#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#endif

#define LANGUAGE_VERSION 9
#define STATE_COUNT 11351
#define SYMBOL_COUNT 269
#define ALIAS_COUNT 7
#define TOKEN_COUNT 144
#define EXTERNAL_TOKEN_COUNT 22
#define MAX_ALIAS_SEQUENCE_LENGTH 6

enum {
  sym__line_break = 1,
  sym__simple_symbol = 2,
  sym__string_start = 3,
  sym__symbol_start = 4,
  sym__subshell_start = 5,
  sym__regex_start = 6,
  sym__string_array_start = 7,
  sym__symbol_array_start = 8,
  sym__heredoc_body_start = 9,
  sym__string_content = 10,
  sym__heredoc_content = 11,
  sym__string_end = 12,
  sym_heredoc_end = 13,
  sym_heredoc_beginning = 14,
  sym__block_ampersand = 15,
  sym__splat_star = 16,
  sym__unary_minus = 17,
  sym__binary_minus = 18,
  sym__binary_star = 19,
  sym__singleton_class_left_angle_left_langle = 20,
  sym__identifier_hash_key = 21,
  anon_sym___END__ = 22,
  sym_uninterpreted = 23,
  anon_sym_BEGIN = 24,
  anon_sym_LBRACE = 25,
  anon_sym_RBRACE = 26,
  anon_sym_END = 27,
  anon_sym_def = 28,
  anon_sym_LPAREN = 29,
  anon_sym_RPAREN = 30,
  anon_sym_DOT = 31,
  anon_sym_COLON_COLON = 32,
  anon_sym_COMMA = 33,
  anon_sym_PIPE = 34,
  anon_sym_SEMI = 35,
  anon_sym_STAR = 36,
  anon_sym_STAR_STAR = 37,
  anon_sym_AMP = 38,
  anon_sym_COLON = 39,
  anon_sym_EQ = 40,
  anon_sym_class = 41,
  anon_sym_LT = 42,
  anon_sym_module = 43,
  anon_sym_end = 44,
  anon_sym_return = 45,
  anon_sym_yield = 46,
  anon_sym_break = 47,
  anon_sym_next = 48,
  sym_redo = 49,
  sym_retry = 50,
  anon_sym_if = 51,
  anon_sym_unless = 52,
  anon_sym_while = 53,
  anon_sym_until = 54,
  anon_sym_rescue = 55,
  anon_sym_for = 56,
  anon_sym_in = 57,
  anon_sym_do = 58,
  anon_sym_case = 59,
  anon_sym_when = 60,
  anon_sym_elsif = 61,
  anon_sym_else = 62,
  anon_sym_then = 63,
  anon_sym_begin = 64,
  anon_sym_ensure = 65,
  anon_sym_EQ_GT = 66,
  anon_sym_LBRACK = 67,
  anon_sym_RBRACK = 68,
  anon_sym_COLON_COLON2 = 69,
  anon_sym_AMP_DOT = 70,
  anon_sym_LPAREN2 = 71,
  anon_sym_PLUS_EQ = 72,
  anon_sym_DASH_EQ = 73,
  anon_sym_STAR_EQ = 74,
  anon_sym_STAR_STAR_EQ = 75,
  anon_sym_SLASH_EQ = 76,
  anon_sym_PIPE_PIPE_EQ = 77,
  anon_sym_PIPE_EQ = 78,
  anon_sym_AMP_AMP_EQ = 79,
  anon_sym_AMP_EQ = 80,
  anon_sym_PERCENT_EQ = 81,
  anon_sym_GT_GT_EQ = 82,
  anon_sym_LT_LT_EQ = 83,
  anon_sym_CARET_EQ = 84,
  anon_sym_QMARK = 85,
  anon_sym_COLON2 = 86,
  anon_sym_DOT_DOT = 87,
  anon_sym_DOT_DOT_DOT = 88,
  anon_sym_and = 89,
  anon_sym_or = 90,
  anon_sym_PIPE_PIPE = 91,
  anon_sym_AMP_AMP = 92,
  anon_sym_LT_LT = 93,
  anon_sym_GT_GT = 94,
  anon_sym_EQ_EQ = 95,
  anon_sym_BANG_EQ = 96,
  anon_sym_EQ_EQ_EQ = 97,
  anon_sym_LT_EQ_GT = 98,
  anon_sym_EQ_TILDE = 99,
  anon_sym_BANG_TILDE = 100,
  anon_sym_LT_EQ = 101,
  anon_sym_GT = 102,
  anon_sym_GT_EQ = 103,
  anon_sym_CARET = 104,
  anon_sym_PLUS = 105,
  anon_sym_SLASH = 106,
  anon_sym_PERCENT = 107,
  anon_sym_defined_QMARK = 108,
  anon_sym_not = 109,
  anon_sym_BANG = 110,
  anon_sym_TILDE = 111,
  sym_constant = 112,
  sym_identifier = 113,
  sym_instance_variable = 114,
  sym_class_variable = 115,
  sym_global_variable = 116,
  anon_sym_DASH = 117,
  anon_sym_PLUS_AT = 118,
  anon_sym_DASH_AT = 119,
  anon_sym_LBRACK_RBRACK = 120,
  anon_sym_LBRACK_RBRACK_EQ = 121,
  anon_sym_BQUOTE = 122,
  anon_sym_undef = 123,
  anon_sym_alias = 124,
  sym_comment = 125,
  sym_integer = 126,
  sym_float = 127,
  sym_complex = 128,
  anon_sym_r = 129,
  sym_super = 130,
  anon_sym_true = 131,
  anon_sym_TRUE = 132,
  anon_sym_false = 133,
  anon_sym_FALSE = 134,
  sym_self = 135,
  anon_sym_nil = 136,
  anon_sym_NIL = 137,
  sym_character = 138,
  anon_sym_POUND_LBRACE = 139,
  aux_sym_SLASH_BSLASHs_PLUS_SLASH = 140,
  sym_escape_sequence = 141,
  anon_sym_LBRACK2 = 142,
  anon_sym_DASH_GT = 143,
  sym_program = 144,
  sym__statements = 145,
  sym_begin_block = 146,
  sym_end_block = 147,
  sym__statement = 148,
  sym_method = 149,
  sym_singleton_method = 150,
  sym__method_rest = 151,
  sym_method_parameters = 152,
  sym_lambda_parameters = 153,
  sym_block_parameters = 154,
  sym__formal_parameter = 155,
  sym__simple_formal_parameter = 156,
  sym_destructured_parameter = 157,
  sym_splat_parameter = 158,
  sym_hash_splat_parameter = 159,
  sym_block_parameter = 160,
  sym_keyword_parameter = 161,
  sym_optional_parameter = 162,
  sym_class = 163,
  sym_superclass = 164,
  sym_singleton_class = 165,
  sym_module = 166,
  sym_return = 167,
  sym_yield = 168,
  sym_break = 169,
  sym_next = 170,
  sym_if_modifier = 171,
  sym_unless_modifier = 172,
  sym_while_modifier = 173,
  sym_until_modifier = 174,
  sym_rescue_modifier = 175,
  sym_while = 176,
  sym_until = 177,
  sym_for = 178,
  sym_in = 179,
  sym__do = 180,
  sym_case = 181,
  sym_when = 182,
  sym_pattern = 183,
  sym_if = 184,
  sym_unless = 185,
  sym_elsif = 186,
  sym_else = 187,
  sym_then = 188,
  sym_begin = 189,
  sym_ensure = 190,
  sym_rescue = 191,
  sym_exceptions = 192,
  sym_exception_variable = 193,
  sym__body_statement = 194,
  sym__arg = 195,
  sym__primary = 196,
  sym_parenthesized_statements = 197,
  sym_element_reference = 198,
  sym_scope_resolution = 199,
  sym_call = 200,
  sym_method_call = 201,
  sym_argument_list = 202,
  sym_argument_list_with_parens = 203,
  sym__argument_list_with_parens = 204,
  sym__argument_list_with_trailing_comma = 205,
  sym__argument = 206,
  sym_splat_argument = 207,
  sym_hash_splat_argument = 208,
  sym_block_argument = 209,
  sym_do_block = 210,
  sym_block = 211,
  sym_assignment = 212,
  sym_operator_assignment = 213,
  sym_conditional = 214,
  sym_range = 215,
  sym_binary = 216,
  sym_unary = 217,
  sym_right_assignment_list = 218,
  sym__arg_or_splat_arg = 219,
  sym_left_assignment_list = 220,
  sym__mlhs = 221,
  sym_destructured_left_assignment = 222,
  sym_rest_assignment = 223,
  sym__lhs = 224,
  sym__variable = 225,
  sym_operator = 226,
  sym__method_name = 227,
  sym_setter = 228,
  sym_undef = 229,
  sym_alias = 230,
  sym_rational = 231,
  sym_true = 232,
  sym_false = 233,
  sym_nil = 234,
  sym_chained_string = 235,
  sym_interpolation = 236,
  sym_string = 237,
  sym_subshell = 238,
  sym_string_array = 239,
  sym_symbol_array = 240,
  sym_symbol = 241,
  sym_regex = 242,
  sym_heredoc_body = 243,
  sym__literal_contents = 244,
  sym_array = 245,
  sym_hash = 246,
  sym__hash_items = 247,
  sym_pair = 248,
  sym_lambda = 249,
  sym_empty_statement = 250,
  sym__terminator = 251,
  aux_sym__statements_repeat1 = 252,
  aux_sym_method_parameters_repeat1 = 253,
  aux_sym_lambda_parameters_repeat1 = 254,
  aux_sym_block_parameters_repeat1 = 255,
  aux_sym_case_repeat1 = 256,
  aux_sym_case_repeat2 = 257,
  aux_sym_when_repeat1 = 258,
  aux_sym_exceptions_repeat1 = 259,
  aux_sym_call_repeat1 = 260,
  aux_sym_argument_list_repeat1 = 261,
  aux_sym__mlhs_repeat1 = 262,
  aux_sym_undef_repeat1 = 263,
  aux_sym_chained_string_repeat1 = 264,
  aux_sym_string_array_repeat1 = 265,
  aux_sym_symbol_array_repeat1 = 266,
  aux_sym_heredoc_body_repeat1 = 267,
  aux_sym__literal_contents_repeat1 = 268,
  anon_alias_sym_DQUOTE = 269,
  anon_alias_sym_RPAREN = 270,
  anon_alias_sym_SLASH = 271,
  anon_alias_sym_BQUOTE = 272,
  alias_sym_bare_string = 273,
  alias_sym_bare_symbol = 274,
  alias_sym_symbol = 275,
};

static const char *ts_symbol_names[] = {
  [sym__line_break] = "_line_break",
  [sym__simple_symbol] = "_simple_symbol",
  [sym__string_start] = "\"",
  [sym__symbol_start] = ":\"",
  [sym__subshell_start] = "`",
  [sym__regex_start] = "/",
  [sym__string_array_start] = "%w(",
  [sym__symbol_array_start] = "%i(",
  [sym__heredoc_body_start] = "_heredoc_body_start",
  [sym__string_content] = "_string_content",
  [sym__heredoc_content] = "_heredoc_content",
  [sym__string_end] = "_string_end",
  [sym_heredoc_end] = "heredoc_end",
  [sym_heredoc_beginning] = "heredoc_beginning",
  [sym__block_ampersand] = "_block_ampersand",
  [sym__splat_star] = "_splat_star",
  [sym__unary_minus] = "-",
  [sym__binary_minus] = "-",
  [sym__binary_star] = "*",
  [sym__singleton_class_left_angle_left_langle] = "<<",
  [sym__identifier_hash_key] = "symbol",
  [ts_builtin_sym_end] = "END",
  [anon_sym___END__] = "__END__",
  [sym_uninterpreted] = "uninterpreted",
  [anon_sym_BEGIN] = "BEGIN",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_END] = "END",
  [anon_sym_def] = "def",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_DOT] = ".",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_COMMA] = ",",
  [anon_sym_PIPE] = "|",
  [anon_sym_SEMI] = ";",
  [anon_sym_STAR] = "*",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_AMP] = "&",
  [anon_sym_COLON] = ":",
  [anon_sym_EQ] = "=",
  [anon_sym_class] = "class",
  [anon_sym_LT] = "<",
  [anon_sym_module] = "module",
  [anon_sym_end] = "end",
  [anon_sym_return] = "return",
  [anon_sym_yield] = "yield",
  [anon_sym_break] = "break",
  [anon_sym_next] = "next",
  [sym_redo] = "redo",
  [sym_retry] = "retry",
  [anon_sym_if] = "if",
  [anon_sym_unless] = "unless",
  [anon_sym_while] = "while",
  [anon_sym_until] = "until",
  [anon_sym_rescue] = "rescue",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_do] = "do",
  [anon_sym_case] = "case",
  [anon_sym_when] = "when",
  [anon_sym_elsif] = "elsif",
  [anon_sym_else] = "else",
  [anon_sym_then] = "then",
  [anon_sym_begin] = "begin",
  [anon_sym_ensure] = "ensure",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_COLON_COLON2] = "::",
  [anon_sym_AMP_DOT] = "&.",
  [anon_sym_LPAREN2] = "(",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PIPE_PIPE_EQ] = "||=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_AMP_AMP_EQ] = "&&=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_QMARK] = "?",
  [anon_sym_COLON2] = ":",
  [anon_sym_DOT_DOT] = "..",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_and] = "and",
  [anon_sym_or] = "or",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_EQ_EQ_EQ] = "===",
  [anon_sym_LT_EQ_GT] = "<=>",
  [anon_sym_EQ_TILDE] = "=~",
  [anon_sym_BANG_TILDE] = "!~",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_GT] = ">",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_CARET] = "^",
  [anon_sym_PLUS] = "+",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_defined_QMARK] = "defined?",
  [anon_sym_not] = "not",
  [anon_sym_BANG] = "!",
  [anon_sym_TILDE] = "~",
  [sym_constant] = "constant",
  [sym_identifier] = "identifier",
  [sym_instance_variable] = "instance_variable",
  [sym_class_variable] = "class_variable",
  [sym_global_variable] = "global_variable",
  [anon_sym_DASH] = "-",
  [anon_sym_PLUS_AT] = "+@",
  [anon_sym_DASH_AT] = "-@",
  [anon_sym_LBRACK_RBRACK] = "[]",
  [anon_sym_LBRACK_RBRACK_EQ] = "[]=",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_undef] = "undef",
  [anon_sym_alias] = "alias",
  [sym_comment] = "comment",
  [sym_integer] = "integer",
  [sym_float] = "float",
  [sym_complex] = "complex",
  [anon_sym_r] = "r",
  [sym_super] = "super",
  [anon_sym_true] = "true",
  [anon_sym_TRUE] = "TRUE",
  [anon_sym_false] = "false",
  [anon_sym_FALSE] = "FALSE",
  [sym_self] = "self",
  [anon_sym_nil] = "nil",
  [anon_sym_NIL] = "NIL",
  [sym_character] = "character",
  [anon_sym_POUND_LBRACE] = "#{",
  [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = "/\\s+/",
  [sym_escape_sequence] = "escape_sequence",
  [anon_sym_LBRACK2] = "[",
  [anon_sym_DASH_GT] = "->",
  [sym_program] = "program",
  [sym__statements] = "_statements",
  [sym_begin_block] = "begin_block",
  [sym_end_block] = "end_block",
  [sym__statement] = "_statement",
  [sym_method] = "method",
  [sym_singleton_method] = "singleton_method",
  [sym__method_rest] = "_method_rest",
  [sym_method_parameters] = "method_parameters",
  [sym_lambda_parameters] = "lambda_parameters",
  [sym_block_parameters] = "block_parameters",
  [sym__formal_parameter] = "_formal_parameter",
  [sym__simple_formal_parameter] = "_simple_formal_parameter",
  [sym_destructured_parameter] = "destructured_parameter",
  [sym_splat_parameter] = "splat_parameter",
  [sym_hash_splat_parameter] = "hash_splat_parameter",
  [sym_block_parameter] = "block_parameter",
  [sym_keyword_parameter] = "keyword_parameter",
  [sym_optional_parameter] = "optional_parameter",
  [sym_class] = "class",
  [sym_superclass] = "superclass",
  [sym_singleton_class] = "singleton_class",
  [sym_module] = "module",
  [sym_return] = "return",
  [sym_yield] = "yield",
  [sym_break] = "break",
  [sym_next] = "next",
  [sym_if_modifier] = "if_modifier",
  [sym_unless_modifier] = "unless_modifier",
  [sym_while_modifier] = "while_modifier",
  [sym_until_modifier] = "until_modifier",
  [sym_rescue_modifier] = "rescue_modifier",
  [sym_while] = "while",
  [sym_until] = "until",
  [sym_for] = "for",
  [sym_in] = "in",
  [sym__do] = "_do",
  [sym_case] = "case",
  [sym_when] = "when",
  [sym_pattern] = "pattern",
  [sym_if] = "if",
  [sym_unless] = "unless",
  [sym_elsif] = "elsif",
  [sym_else] = "else",
  [sym_then] = "then",
  [sym_begin] = "begin",
  [sym_ensure] = "ensure",
  [sym_rescue] = "rescue",
  [sym_exceptions] = "exceptions",
  [sym_exception_variable] = "exception_variable",
  [sym__body_statement] = "_body_statement",
  [sym__arg] = "_arg",
  [sym__primary] = "_primary",
  [sym_parenthesized_statements] = "parenthesized_statements",
  [sym_element_reference] = "element_reference",
  [sym_scope_resolution] = "scope_resolution",
  [sym_call] = "call",
  [sym_method_call] = "method_call",
  [sym_argument_list] = "argument_list",
  [sym_argument_list_with_parens] = "argument_list_with_parens",
  [sym__argument_list_with_parens] = "_argument_list_with_parens",
  [sym__argument_list_with_trailing_comma] = "_argument_list_with_trailing_comma",
  [sym__argument] = "_argument",
  [sym_splat_argument] = "splat_argument",
  [sym_hash_splat_argument] = "hash_splat_argument",
  [sym_block_argument] = "block_argument",
  [sym_do_block] = "do_block",
  [sym_block] = "block",
  [sym_assignment] = "assignment",
  [sym_operator_assignment] = "operator_assignment",
  [sym_conditional] = "conditional",
  [sym_range] = "range",
  [sym_binary] = "binary",
  [sym_unary] = "unary",
  [sym_right_assignment_list] = "right_assignment_list",
  [sym__arg_or_splat_arg] = "_arg_or_splat_arg",
  [sym_left_assignment_list] = "left_assignment_list",
  [sym__mlhs] = "_mlhs",
  [sym_destructured_left_assignment] = "destructured_left_assignment",
  [sym_rest_assignment] = "rest_assignment",
  [sym__lhs] = "_lhs",
  [sym__variable] = "_variable",
  [sym_operator] = "operator",
  [sym__method_name] = "_method_name",
  [sym_setter] = "setter",
  [sym_undef] = "undef",
  [sym_alias] = "alias",
  [sym_rational] = "rational",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_nil] = "nil",
  [sym_chained_string] = "chained_string",
  [sym_interpolation] = "interpolation",
  [sym_string] = "string",
  [sym_subshell] = "subshell",
  [sym_string_array] = "string_array",
  [sym_symbol_array] = "symbol_array",
  [sym_symbol] = "symbol",
  [sym_regex] = "regex",
  [sym_heredoc_body] = "heredoc_body",
  [sym__literal_contents] = "_literal_contents",
  [sym_array] = "array",
  [sym_hash] = "hash",
  [sym__hash_items] = "_hash_items",
  [sym_pair] = "pair",
  [sym_lambda] = "lambda",
  [sym_empty_statement] = "empty_statement",
  [sym__terminator] = "_terminator",
  [aux_sym__statements_repeat1] = "_statements_repeat1",
  [aux_sym_method_parameters_repeat1] = "method_parameters_repeat1",
  [aux_sym_lambda_parameters_repeat1] = "lambda_parameters_repeat1",
  [aux_sym_block_parameters_repeat1] = "block_parameters_repeat1",
  [aux_sym_case_repeat1] = "case_repeat1",
  [aux_sym_case_repeat2] = "case_repeat2",
  [aux_sym_when_repeat1] = "when_repeat1",
  [aux_sym_exceptions_repeat1] = "exceptions_repeat1",
  [aux_sym_call_repeat1] = "call_repeat1",
  [aux_sym_argument_list_repeat1] = "argument_list_repeat1",
  [aux_sym__mlhs_repeat1] = "_mlhs_repeat1",
  [aux_sym_undef_repeat1] = "undef_repeat1",
  [aux_sym_chained_string_repeat1] = "chained_string_repeat1",
  [aux_sym_string_array_repeat1] = "string_array_repeat1",
  [aux_sym_symbol_array_repeat1] = "symbol_array_repeat1",
  [aux_sym_heredoc_body_repeat1] = "heredoc_body_repeat1",
  [aux_sym__literal_contents_repeat1] = "_literal_contents_repeat1",
  [anon_alias_sym_DQUOTE] = "\"",
  [anon_alias_sym_RPAREN] = ")",
  [anon_alias_sym_SLASH] = "/",
  [anon_alias_sym_BQUOTE] = "`",
  [alias_sym_bare_string] = "bare_string",
  [alias_sym_bare_symbol] = "bare_symbol",
  [alias_sym_symbol] = "symbol",
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [sym__line_break] = {
    .visible = false,
    .named = true,
  },
  [sym__simple_symbol] = {
    .visible = false,
    .named = true,
  },
  [sym__string_start] = {
    .visible = true,
    .named = false,
  },
  [sym__symbol_start] = {
    .visible = true,
    .named = false,
  },
  [sym__subshell_start] = {
    .visible = true,
    .named = false,
  },
  [sym__regex_start] = {
    .visible = true,
    .named = false,
  },
  [sym__string_array_start] = {
    .visible = true,
    .named = false,
  },
  [sym__symbol_array_start] = {
    .visible = true,
    .named = false,
  },
  [sym__heredoc_body_start] = {
    .visible = false,
    .named = true,
  },
  [sym__string_content] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_content] = {
    .visible = false,
    .named = true,
  },
  [sym__string_end] = {
    .visible = false,
    .named = true,
  },
  [sym_heredoc_end] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_beginning] = {
    .visible = true,
    .named = true,
  },
  [sym__block_ampersand] = {
    .visible = false,
    .named = true,
  },
  [sym__splat_star] = {
    .visible = false,
    .named = true,
  },
  [sym__unary_minus] = {
    .visible = true,
    .named = false,
  },
  [sym__binary_minus] = {
    .visible = true,
    .named = false,
  },
  [sym__binary_star] = {
    .visible = true,
    .named = false,
  },
  [sym__singleton_class_left_angle_left_langle] = {
    .visible = true,
    .named = false,
  },
  [sym__identifier_hash_key] = {
    .visible = true,
    .named = true,
  },
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [anon_sym___END__] = {
    .visible = true,
    .named = false,
  },
  [sym_uninterpreted] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BEGIN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_END] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_def] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_end] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_next] = {
    .visible = true,
    .named = false,
  },
  [sym_redo] = {
    .visible = true,
    .named = true,
  },
  [sym_retry] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unless] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_until] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_rescue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_when] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elsif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_then] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_begin] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ensure] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defined_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [sym_constant] = {
    .visible = true,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_instance_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_class_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_global_variable] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_RBRACK_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_undef] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_alias] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_integer] = {
    .visible = true,
    .named = true,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [sym_complex] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_r] = {
    .visible = true,
    .named = false,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TRUE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_FALSE] = {
    .visible = true,
    .named = false,
  },
  [sym_self] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_nil] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_NIL] = {
    .visible = true,
    .named = false,
  },
  [sym_character] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_POUND_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LBRACK2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym__statements] = {
    .visible = false,
    .named = true,
  },
  [sym_begin_block] = {
    .visible = true,
    .named = true,
  },
  [sym_end_block] = {
    .visible = true,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
  },
  [sym_method] = {
    .visible = true,
    .named = true,
  },
  [sym_singleton_method] = {
    .visible = true,
    .named = true,
  },
  [sym__method_rest] = {
    .visible = false,
    .named = true,
  },
  [sym_method_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_block_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym__formal_parameter] = {
    .visible = false,
    .named = true,
  },
  [sym__simple_formal_parameter] = {
    .visible = false,
    .named = true,
  },
  [sym_destructured_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_splat_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_splat_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_block_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_class] = {
    .visible = true,
    .named = true,
  },
  [sym_superclass] = {
    .visible = true,
    .named = true,
  },
  [sym_singleton_class] = {
    .visible = true,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym_return] = {
    .visible = true,
    .named = true,
  },
  [sym_yield] = {
    .visible = true,
    .named = true,
  },
  [sym_break] = {
    .visible = true,
    .named = true,
  },
  [sym_next] = {
    .visible = true,
    .named = true,
  },
  [sym_if_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_unless_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_while_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_until_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_rescue_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_while] = {
    .visible = true,
    .named = true,
  },
  [sym_until] = {
    .visible = true,
    .named = true,
  },
  [sym_for] = {
    .visible = true,
    .named = true,
  },
  [sym_in] = {
    .visible = true,
    .named = true,
  },
  [sym__do] = {
    .visible = false,
    .named = true,
  },
  [sym_case] = {
    .visible = true,
    .named = true,
  },
  [sym_when] = {
    .visible = true,
    .named = true,
  },
  [sym_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_if] = {
    .visible = true,
    .named = true,
  },
  [sym_unless] = {
    .visible = true,
    .named = true,
  },
  [sym_elsif] = {
    .visible = true,
    .named = true,
  },
  [sym_else] = {
    .visible = true,
    .named = true,
  },
  [sym_then] = {
    .visible = true,
    .named = true,
  },
  [sym_begin] = {
    .visible = true,
    .named = true,
  },
  [sym_ensure] = {
    .visible = true,
    .named = true,
  },
  [sym_rescue] = {
    .visible = true,
    .named = true,
  },
  [sym_exceptions] = {
    .visible = true,
    .named = true,
  },
  [sym_exception_variable] = {
    .visible = true,
    .named = true,
  },
  [sym__body_statement] = {
    .visible = false,
    .named = true,
  },
  [sym__arg] = {
    .visible = false,
    .named = true,
  },
  [sym__primary] = {
    .visible = false,
    .named = true,
  },
  [sym_parenthesized_statements] = {
    .visible = true,
    .named = true,
  },
  [sym_element_reference] = {
    .visible = true,
    .named = true,
  },
  [sym_scope_resolution] = {
    .visible = true,
    .named = true,
  },
  [sym_call] = {
    .visible = true,
    .named = true,
  },
  [sym_method_call] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list_with_parens] = {
    .visible = true,
    .named = true,
  },
  [sym__argument_list_with_parens] = {
    .visible = false,
    .named = true,
  },
  [sym__argument_list_with_trailing_comma] = {
    .visible = false,
    .named = true,
  },
  [sym__argument] = {
    .visible = false,
    .named = true,
  },
  [sym_splat_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_splat_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_block_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_do_block] = {
    .visible = true,
    .named = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_operator_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional] = {
    .visible = true,
    .named = true,
  },
  [sym_range] = {
    .visible = true,
    .named = true,
  },
  [sym_binary] = {
    .visible = true,
    .named = true,
  },
  [sym_unary] = {
    .visible = true,
    .named = true,
  },
  [sym_right_assignment_list] = {
    .visible = true,
    .named = true,
  },
  [sym__arg_or_splat_arg] = {
    .visible = false,
    .named = true,
  },
  [sym_left_assignment_list] = {
    .visible = true,
    .named = true,
  },
  [sym__mlhs] = {
    .visible = false,
    .named = true,
  },
  [sym_destructured_left_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_rest_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym__lhs] = {
    .visible = false,
    .named = true,
  },
  [sym__variable] = {
    .visible = false,
    .named = true,
  },
  [sym_operator] = {
    .visible = true,
    .named = true,
  },
  [sym__method_name] = {
    .visible = false,
    .named = true,
  },
  [sym_setter] = {
    .visible = true,
    .named = true,
  },
  [sym_undef] = {
    .visible = true,
    .named = true,
  },
  [sym_alias] = {
    .visible = true,
    .named = true,
  },
  [sym_rational] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_nil] = {
    .visible = true,
    .named = true,
  },
  [sym_chained_string] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_subshell] = {
    .visible = true,
    .named = true,
  },
  [sym_string_array] = {
    .visible = true,
    .named = true,
  },
  [sym_symbol_array] = {
    .visible = true,
    .named = true,
  },
  [sym_symbol] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_body] = {
    .visible = true,
    .named = true,
  },
  [sym__literal_contents] = {
    .visible = false,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_hash] = {
    .visible = true,
    .named = true,
  },
  [sym__hash_items] = {
    .visible = false,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__terminator] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__statements_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_method_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_lambda_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_block_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_when_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_exceptions_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_call_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__mlhs_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_undef_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_chained_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_symbol_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_heredoc_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__literal_contents_repeat1] = {
    .visible = false,
    .named = false,
  },
  [anon_alias_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_alias_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_alias_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_alias_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [alias_sym_bare_string] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_bare_symbol] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_symbol] = {
    .visible = true,
    .named = true,
  },
};

static TSSymbol ts_alias_sequences[25][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [1] = {
    [1] = anon_alias_sym_DQUOTE,
  },
  [2] = {
    [1] = anon_alias_sym_BQUOTE,
  },
  [3] = {
    [1] = anon_alias_sym_SLASH,
  },
  [4] = {
    [1] = anon_alias_sym_RPAREN,
  },
  [5] = {
    [2] = anon_alias_sym_DQUOTE,
  },
  [6] = {
    [2] = anon_alias_sym_BQUOTE,
  },
  [7] = {
    [2] = anon_alias_sym_SLASH,
  },
  [8] = {
    [2] = anon_alias_sym_RPAREN,
  },
  [9] = {
    [1] = alias_sym_bare_string,
    [2] = anon_alias_sym_RPAREN,
  },
  [10] = {
    [1] = alias_sym_bare_symbol,
    [2] = anon_alias_sym_RPAREN,
  },
  [11] = {
    [3] = anon_alias_sym_RPAREN,
  },
  [12] = {
    [2] = alias_sym_bare_string,
    [3] = anon_alias_sym_RPAREN,
  },
  [13] = {
    [1] = alias_sym_bare_string,
    [3] = anon_alias_sym_RPAREN,
  },
  [14] = {
    [1] = alias_sym_bare_string,
  },
  [15] = {
    [2] = alias_sym_bare_symbol,
    [3] = anon_alias_sym_RPAREN,
  },
  [16] = {
    [1] = alias_sym_bare_symbol,
    [3] = anon_alias_sym_RPAREN,
  },
  [17] = {
    [1] = alias_sym_bare_symbol,
  },
  [18] = {
    [0] = alias_sym_symbol,
  },
  [19] = {
    [2] = alias_sym_bare_string,
    [4] = anon_alias_sym_RPAREN,
  },
  [20] = {
    [1] = alias_sym_bare_string,
    [4] = anon_alias_sym_RPAREN,
  },
  [21] = {
    [2] = alias_sym_bare_symbol,
    [4] = anon_alias_sym_RPAREN,
  },
  [22] = {
    [1] = alias_sym_bare_symbol,
    [4] = anon_alias_sym_RPAREN,
  },
  [23] = {
    [2] = alias_sym_bare_string,
    [5] = anon_alias_sym_RPAREN,
  },
  [24] = {
    [2] = alias_sym_bare_symbol,
    [5] = anon_alias_sym_RPAREN,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(26);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(30);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(37);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'B')
        ADVANCE(86);
      if (lookahead == 'E')
        ADVANCE(93);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(109);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '`')
        ADVANCE(118);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(110);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(44);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^'))
        ADVANCE(126);
      END_STATE();
    case 1:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 2:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=')
        ADVANCE(3);
      if (lookahead == '~')
        ADVANCE(4);
      END_STATE();
    case 3:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 4:
      ACCEPT_TOKEN(anon_sym_BANG_TILDE);
      END_STATE();
    case 5:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '{')
        ADVANCE(6);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(7);
      END_STATE();
    case 6:
      ACCEPT_TOKEN(anon_sym_POUND_LBRACE);
      END_STATE();
    case 7:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(7);
      END_STATE();
    case 8:
      ACCEPT_TOKEN(sym_global_variable);
      if (lookahead == '-')
        ADVANCE(9);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(10);
      if (lookahead == '!' ||
          lookahead == '\"' ||
          lookahead == '$' ||
          lookahead == '&' ||
          lookahead == '\'' ||
          ('*' <= lookahead && lookahead <= '@') ||
          lookahead == '\\' ||
          lookahead == '`' ||
          lookahead == '~')
        ADVANCE(11);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 9:
      ACCEPT_TOKEN(sym_global_variable);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(10);
      if (lookahead == '!' ||
          lookahead == '\"' ||
          lookahead == '$' ||
          lookahead == '&' ||
          lookahead == '\'' ||
          ('*' <= lookahead && lookahead <= ',') ||
          ('.' <= lookahead && lookahead <= '@') ||
          lookahead == '\\' ||
          lookahead == '`' ||
          lookahead == '~')
        ADVANCE(11);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 10:
      ACCEPT_TOKEN(sym_global_variable);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(10);
      END_STATE();
    case 11:
      ACCEPT_TOKEN(sym_global_variable);
      END_STATE();
    case 12:
      ACCEPT_TOKEN(sym_global_variable);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 13:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=')
        ADVANCE(14);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 15:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(16);
      if (lookahead == '.')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(19);
      END_STATE();
    case 16:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      if (lookahead == '=')
        ADVANCE(17);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(anon_sym_AMP_AMP_EQ);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(anon_sym_AMP_DOT);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(anon_sym_LPAREN2);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*')
        ADVANCE(23);
      if (lookahead == '=')
        ADVANCE(25);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '=')
        ADVANCE(24);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=')
        ADVANCE(27);
      if (lookahead == '@')
        ADVANCE(28);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_PLUS_AT);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '@')
        ADVANCE(31);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_DASH_AT);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.')
        ADVANCE(33);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      if (lookahead == '.')
        ADVANCE(34);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '=')
        ADVANCE(36);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.')
        ADVANCE(38);
      if (lookahead == '_')
        ADVANCE(43);
      if (lookahead == 'b')
        ADVANCE(45);
      if (lookahead == 'd')
        ADVANCE(47);
      if (lookahead == 'x')
        ADVANCE(49);
      if (lookahead == '8' ||
          lookahead == '9')
        ADVANCE(44);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(40);
      if (lookahead == 'O' ||
          lookahead == 'o')
        ADVANCE(51);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(53);
      END_STATE();
    case 38:
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(39);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_')
        ADVANCE(38);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(40);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(39);
      END_STATE();
    case 40:
      if (lookahead == '+' ||
          lookahead == '-')
        ADVANCE(41);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(42);
      END_STATE();
    case 41:
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(42);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_')
        ADVANCE(41);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(42);
      END_STATE();
    case 43:
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(44);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.')
        ADVANCE(38);
      if (lookahead == '_')
        ADVANCE(43);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(40);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(44);
      END_STATE();
    case 45:
      if (lookahead == '0' ||
          lookahead == '1')
        ADVANCE(46);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_')
        ADVANCE(45);
      if (lookahead == '0' ||
          lookahead == '1')
        ADVANCE(46);
      END_STATE();
    case 47:
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(48);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_')
        ADVANCE(47);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(48);
      END_STATE();
    case 49:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(50);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_')
        ADVANCE(49);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(50);
      END_STATE();
    case 51:
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(52);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_')
        ADVANCE(51);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(52);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.')
        ADVANCE(38);
      if (lookahead == '_')
        ADVANCE(54);
      if (lookahead == '8' ||
          lookahead == '9')
        ADVANCE(44);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(40);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(53);
      END_STATE();
    case 54:
      if (lookahead == '8' ||
          lookahead == '9')
        ADVANCE(44);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(53);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':')
        ADVANCE(56);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_COLON_COLON2);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<')
        ADVANCE(59);
      if (lookahead == '=')
        ADVANCE(61);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=')
        ADVANCE(60);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      if (lookahead == '>')
        ADVANCE(62);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_LT_EQ_GT);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=')
        ADVANCE(64);
      if (lookahead == '>')
        ADVANCE(66);
      if (lookahead == '~')
        ADVANCE(67);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '=')
        ADVANCE(65);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_EQ_EQ_EQ);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_EQ_TILDE);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=')
        ADVANCE(69);
      if (lookahead == '>')
        ADVANCE(70);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=')
        ADVANCE(71);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '\\')
        ADVANCE(73);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(79);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(sym_character);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(74);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(sym_character);
      if (lookahead == '-')
        ADVANCE(75);
      if (lookahead == '{')
        ADVANCE(80);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(81);
      END_STATE();
    case 75:
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(76);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(sym_character);
      if (lookahead == 'C' ||
          lookahead == 'M')
        ADVANCE(77);
      END_STATE();
    case 77:
      if (lookahead == '-')
        ADVANCE(78);
      END_STATE();
    case 78:
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(79);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(sym_character);
      END_STATE();
    case 80:
      if (lookahead == '}')
        ADVANCE(79);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(80);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(sym_character);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(81);
      END_STATE();
    case 82:
      if (lookahead == '@')
        ADVANCE(83);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(85);
      END_STATE();
    case 83:
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(84);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(sym_class_variable);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(84);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(sym_instance_variable);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(85);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead == 'E')
        ADVANCE(88);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(sym_constant);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead == 'G')
        ADVANCE(89);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead == 'I')
        ADVANCE(90);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead == 'N')
        ADVANCE(91);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_BEGIN);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead == 'N')
        ADVANCE(94);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead == 'D')
        ADVANCE(95);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_END);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead == 'A')
        ADVANCE(97);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > 'A') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead == 'L')
        ADVANCE(98);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead == 'S')
        ADVANCE(99);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead == 'E')
        ADVANCE(100);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_FALSE);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead == 'I')
        ADVANCE(102);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead == 'L')
        ADVANCE(103);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_NIL);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead == 'R')
        ADVANCE(105);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead == 'U')
        ADVANCE(106);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead == 'E')
        ADVANCE(107);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_TRUE);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 109:
      if (lookahead == '\n')
        SKIP(110);
      END_STATE();
    case 110:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(26);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(30);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(37);
      if (lookahead == ':')
        ADVANCE(112);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'B')
        ADVANCE(86);
      if (lookahead == 'E')
        ADVANCE(93);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(109);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '`')
        ADVANCE(118);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(110);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(44);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^'))
        ADVANCE(126);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_COLON2);
      if (lookahead == ':')
        ADVANCE(113);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_LBRACK2);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=')
        ADVANCE(117);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=')
        ADVANCE(121);
      if (lookahead == '|')
        ADVANCE(122);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      if (lookahead == '=')
        ADVANCE(123);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE_EQ);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '!')
        ADVANCE(127);
      if (lookahead == '?')
        ADVANCE(127);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(sym_identifier);
      END_STATE();
    case 128:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(130);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'B')
        ADVANCE(86);
      if (lookahead == 'E')
        ADVANCE(93);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(155);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(128);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(132);
      END_STATE();
    case 132:
      if (lookahead == 'i')
        ADVANCE(133);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(132);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(sym_complex);
      END_STATE();
    case 134:
      if (lookahead == '>')
        ADVANCE(135);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(132);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '+')
        ADVANCE(137);
      if (lookahead == '-')
        ADVANCE(137);
      if (lookahead == '.')
        ADVANCE(38);
      if (lookahead == '_')
        ADVANCE(43);
      if (lookahead == 'b')
        ADVANCE(45);
      if (lookahead == 'd')
        ADVANCE(47);
      if (lookahead == 'i')
        ADVANCE(133);
      if (lookahead == 'x')
        ADVANCE(49);
      if (lookahead == '8' ||
          lookahead == '9')
        ADVANCE(138);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(40);
      if (lookahead == 'O' ||
          lookahead == 'o')
        ADVANCE(51);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(139);
      END_STATE();
    case 137:
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(132);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '+')
        ADVANCE(137);
      if (lookahead == '-')
        ADVANCE(137);
      if (lookahead == '.')
        ADVANCE(38);
      if (lookahead == '_')
        ADVANCE(43);
      if (lookahead == 'i')
        ADVANCE(133);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(40);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '+')
        ADVANCE(137);
      if (lookahead == '-')
        ADVANCE(137);
      if (lookahead == '.')
        ADVANCE(38);
      if (lookahead == '_')
        ADVANCE(54);
      if (lookahead == 'i')
        ADVANCE(133);
      if (lookahead == '8' ||
          lookahead == '9')
        ADVANCE(138);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(40);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(139);
      END_STATE();
    case 140:
      if (lookahead == ':')
        ADVANCE(113);
      END_STATE();
    case 141:
      if (lookahead == 'b')
        ADVANCE(142);
      END_STATE();
    case 142:
      if (lookahead == 'e')
        ADVANCE(143);
      END_STATE();
    case 143:
      if (lookahead == 'g')
        ADVANCE(144);
      END_STATE();
    case 144:
      if (lookahead == 'i')
        ADVANCE(145);
      END_STATE();
    case 145:
      if (lookahead == 'n')
        ADVANCE(146);
      END_STATE();
    case 146:
      if (lookahead == '\n')
        ADVANCE(147);
      if (lookahead == '\r')
        ADVANCE(146);
      if (lookahead != 0)
        ADVANCE(146);
      END_STATE();
    case 147:
      if (lookahead == '=')
        ADVANCE(148);
      if (lookahead != 0)
        ADVANCE(147);
      END_STATE();
    case 148:
      if (lookahead == 'e')
        ADVANCE(149);
      if (lookahead != 0)
        ADVANCE(147);
      END_STATE();
    case 149:
      if (lookahead == 'n')
        ADVANCE(150);
      if (lookahead != 0)
        ADVANCE(147);
      END_STATE();
    case 150:
      if (lookahead == 'd')
        ADVANCE(151);
      if (lookahead != 0)
        ADVANCE(147);
      END_STATE();
    case 151:
      if (lookahead == '\n')
        ADVANCE(152);
      if (lookahead == '\r')
        ADVANCE(153);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 153:
      if (lookahead == '\n')
        ADVANCE(152);
      END_STATE();
    case 154:
      if (lookahead == '\\')
        ADVANCE(73);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(79);
      END_STATE();
    case 155:
      if (lookahead == '\n')
        SKIP(128);
      END_STATE();
    case 156:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(172);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(173);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 157:
      if (lookahead == '=')
        ADVANCE(3);
      if (lookahead == '~')
        ADVANCE(4);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(160);
      if (lookahead == '.')
        ADVANCE(18);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 161:
      if (lookahead == '*')
        ADVANCE(162);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_SLASH);
      END_STATE();
    case 165:
      if (lookahead == ':')
        ADVANCE(56);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<')
        ADVANCE(167);
      if (lookahead == '=')
        ADVANCE(61);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 168:
      if (lookahead == '=')
        ADVANCE(64);
      if (lookahead == '>')
        ADVANCE(66);
      if (lookahead == 'b')
        ADVANCE(142);
      if (lookahead == '~')
        ADVANCE(67);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=')
        ADVANCE(69);
      if (lookahead == '>')
        ADVANCE(170);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 172:
      if (lookahead == '\n')
        SKIP(173);
      END_STATE();
    case 173:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(172);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(173);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|')
        ADVANCE(176);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 177:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '\\')
        ADVANCE(178);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(177);
      END_STATE();
    case 178:
      if (lookahead == '\n')
        ADVANCE(179);
      if (lookahead == 'u')
        ADVANCE(180);
      if (lookahead == 'x')
        ADVANCE(186);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(188);
      if (lookahead != 0)
        ADVANCE(179);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 180:
      if (lookahead == '{')
        ADVANCE(181);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(183);
      END_STATE();
    case 181:
      if (lookahead == ' ' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(182);
      END_STATE();
    case 182:
      if (lookahead == '}')
        ADVANCE(179);
      if (lookahead == ' ' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(182);
      END_STATE();
    case 183:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(184);
      END_STATE();
    case 184:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(185);
      END_STATE();
    case 185:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(179);
      END_STATE();
    case 186:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(187);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(179);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(189);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(179);
      END_STATE();
    case 190:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '\\')
        ADVANCE(178);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(191);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHs_PLUS_SLASH);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(191);
      END_STATE();
    case 192:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(130);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(193);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(192);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 193:
      if (lookahead == '\n')
        SKIP(192);
      END_STATE();
    case 194:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(196);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(194);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*')
        ADVANCE(162);
      END_STATE();
    case 196:
      if (lookahead == '\n')
        SKIP(194);
      END_STATE();
    case 197:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(200);
      if (lookahead == '-')
        ADVANCE(30);
      if (lookahead == '.')
        ADVANCE(201);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(204);
      if (lookahead == '\\')
        SKIP(207);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '`')
        ADVANCE(118);
      if (lookahead == '|')
        ADVANCE(208);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(197);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '~')
        ADVANCE(4);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '@')
        ADVANCE(28);
      END_STATE();
    case 201:
      if (lookahead == '.')
        ADVANCE(202);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      END_STATE();
    case 203:
      if (lookahead == '=')
        ADVANCE(64);
      if (lookahead == 'b')
        ADVANCE(142);
      if (lookahead == '~')
        ADVANCE(67);
      END_STATE();
    case 204:
      if (lookahead == ']')
        ADVANCE(205);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(anon_sym_LBRACK_RBRACK);
      if (lookahead == '=')
        ADVANCE(206);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_LBRACK_RBRACK_EQ);
      END_STATE();
    case 207:
      if (lookahead == '\n')
        SKIP(197);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 209:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(130);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'B')
        ADVANCE(86);
      if (lookahead == 'E')
        ADVANCE(93);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(210);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(209);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 210:
      if (lookahead == '\n')
        SKIP(209);
      END_STATE();
    case 211:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(130);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'B')
        ADVANCE(86);
      if (lookahead == 'E')
        ADVANCE(93);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(212);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(211);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 212:
      if (lookahead == '\n')
        SKIP(211);
      END_STATE();
    case 213:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '+')
        ADVANCE(137);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(214);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(215);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(213);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 215:
      if (lookahead == '\n')
        SKIP(213);
      END_STATE();
    case 216:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '+')
        ADVANCE(137);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(217);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(216);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 217:
      if (lookahead == '\n')
        SKIP(216);
      END_STATE();
    case 218:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(219);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(220);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 219:
      if (lookahead == '\n')
        SKIP(220);
      END_STATE();
    case 220:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(219);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(220);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 221:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(130);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'B')
        ADVANCE(86);
      if (lookahead == 'E')
        ADVANCE(93);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(222);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(221);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 222:
      if (lookahead == '\n')
        SKIP(221);
      END_STATE();
    case 223:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(130);
      if (lookahead == '+')
        ADVANCE(137);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(224);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(223);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 224:
      if (lookahead == '\n')
        SKIP(223);
      END_STATE();
    case 225:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(130);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(226);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(225);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 226:
      if (lookahead == '\n')
        SKIP(225);
      END_STATE();
    case 227:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(200);
      if (lookahead == '-')
        ADVANCE(30);
      if (lookahead == '.')
        ADVANCE(201);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(204);
      if (lookahead == '\\')
        SKIP(228);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '`')
        ADVANCE(118);
      if (lookahead == '|')
        ADVANCE(208);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(227);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 228:
      if (lookahead == '\n')
        SKIP(227);
      END_STATE();
    case 229:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(230);
      if (lookahead == '+')
        ADVANCE(231);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(232);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(234);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(235);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(236);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 230:
      if (lookahead == '*')
        ADVANCE(23);
      if (lookahead == '=')
        ADVANCE(25);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=')
        ADVANCE(27);
      END_STATE();
    case 232:
      if (lookahead == '=')
        ADVANCE(233);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=')
        ADVANCE(64);
      if (lookahead == '~')
        ADVANCE(67);
      END_STATE();
    case 235:
      if (lookahead == '\n')
        SKIP(236);
      END_STATE();
    case 236:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(230);
      if (lookahead == '+')
        ADVANCE(231);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(232);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(234);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(235);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(236);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 237:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(238);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(237);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 238:
      if (lookahead == '\n')
        SKIP(237);
      END_STATE();
    case 239:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == ':')
        ADVANCE(240);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(214);
      if (lookahead == '\\')
        SKIP(241);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(208);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(242);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 241:
      if (lookahead == '\n')
        SKIP(242);
      END_STATE();
    case 242:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(214);
      if (lookahead == '\\')
        SKIP(241);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(208);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(242);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 243:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '\\')
        SKIP(244);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(243);
      END_STATE();
    case 244:
      if (lookahead == '\n')
        SKIP(243);
      END_STATE();
    case 245:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '\\')
        SKIP(246);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(245);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 246:
      if (lookahead == '\n')
        SKIP(245);
      END_STATE();
    case 247:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '\\')
        SKIP(248);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(247);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 248:
      if (lookahead == '\n')
        SKIP(247);
      END_STATE();
    case 249:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(250);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == '.')
        ADVANCE(251);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(252);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(249);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(160);
      END_STATE();
    case 251:
      if (lookahead == '.')
        ADVANCE(33);
      END_STATE();
    case 252:
      if (lookahead == '\n')
        SKIP(249);
      END_STATE();
    case 253:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(254);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(255);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 254:
      if (lookahead == '\n')
        SKIP(255);
      END_STATE();
    case 255:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(254);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(255);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 256:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(257);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(258);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(234);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(259);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(260);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=')
        ADVANCE(27);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(132);
      END_STATE();
    case 258:
      if (lookahead == '=')
        ADVANCE(233);
      if (lookahead == '>')
        ADVANCE(135);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(132);
      END_STATE();
    case 259:
      if (lookahead == '\n')
        SKIP(260);
      END_STATE();
    case 260:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(257);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(258);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(234);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(259);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(260);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 261:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(230);
      if (lookahead == '+')
        ADVANCE(231);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(232);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(234);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(262);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(263);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 262:
      if (lookahead == '\n')
        SKIP(263);
      END_STATE();
    case 263:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(230);
      if (lookahead == '+')
        ADVANCE(231);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(232);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(234);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(262);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(263);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 264:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(265);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(266);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 265:
      if (lookahead == '\n')
        SKIP(266);
      END_STATE();
    case 266:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(265);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(266);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 267:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(172);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(173);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 268:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '\\')
        SKIP(269);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(270);
      END_STATE();
    case 269:
      if (lookahead == '\n')
        SKIP(268);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHs_PLUS_SLASH);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(270);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(272);
      if (lookahead == '#')
        ADVANCE(273);
      if (lookahead == '=')
        ADVANCE(275);
      if (lookahead == '\\')
        ADVANCE(287);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(272);
      if (lookahead != 0)
        ADVANCE(274);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(272);
      if (lookahead == '#')
        ADVANCE(273);
      if (lookahead == '=')
        ADVANCE(275);
      if (lookahead == '\\')
        ADVANCE(287);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(272);
      if (lookahead != 0)
        ADVANCE(274);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(274);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(273);
      if (lookahead != 0)
        ADVANCE(273);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(274);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(274);
      if (lookahead != 0)
        ADVANCE(274);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(274);
      if (lookahead == 'b')
        ADVANCE(276);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(274);
      if (lookahead != 0)
        ADVANCE(274);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(274);
      if (lookahead == 'e')
        ADVANCE(277);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(274);
      if (lookahead != 0)
        ADVANCE(274);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(274);
      if (lookahead == 'g')
        ADVANCE(278);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(274);
      if (lookahead != 0)
        ADVANCE(274);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(274);
      if (lookahead == 'i')
        ADVANCE(279);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(274);
      if (lookahead != 0)
        ADVANCE(274);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(274);
      if (lookahead == 'n')
        ADVANCE(280);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(274);
      if (lookahead != 0)
        ADVANCE(274);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(281);
      if (lookahead == '\r')
        ADVANCE(280);
      if (lookahead == '\t' ||
          lookahead == ' ')
        ADVANCE(280);
      if (lookahead != 0)
        ADVANCE(280);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(281);
      if (lookahead == '=')
        ADVANCE(282);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(281);
      if (lookahead != 0)
        ADVANCE(281);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(281);
      if (lookahead == 'e')
        ADVANCE(283);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(281);
      if (lookahead != 0)
        ADVANCE(281);
      END_STATE();
    case 283:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(281);
      if (lookahead == 'n')
        ADVANCE(284);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(281);
      if (lookahead != 0)
        ADVANCE(281);
      END_STATE();
    case 284:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(281);
      if (lookahead == 'd')
        ADVANCE(285);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(281);
      if (lookahead != 0)
        ADVANCE(281);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(274);
      if (lookahead == '\r')
        ADVANCE(286);
      if (lookahead == '\t' ||
          lookahead == ' ')
        ADVANCE(274);
      if (lookahead != 0)
        ADVANCE(274);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(274);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(274);
      if (lookahead != 0)
        ADVANCE(274);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(272);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(274);
      if (lookahead != 0)
        ADVANCE(274);
      END_STATE();
    case 288:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(130);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'B')
        ADVANCE(86);
      if (lookahead == 'E')
        ADVANCE(93);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(289);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(288);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 289:
      if (lookahead == '\n')
        SKIP(288);
      END_STATE();
    case 290:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(291);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(292);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(293);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(anon_sym_COLON2);
      if (lookahead == ':')
        ADVANCE(56);
      END_STATE();
    case 292:
      if (lookahead == '\n')
        SKIP(293);
      END_STATE();
    case 293:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(294);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(292);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(293);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(anon_sym_COLON2);
      END_STATE();
    case 295:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(296);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(297);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 296:
      if (lookahead == '\n')
        SKIP(297);
      END_STATE();
    case 297:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(296);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(297);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 298:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(257);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(258);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(299);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(300);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 299:
      if (lookahead == '\n')
        SKIP(300);
      END_STATE();
    case 300:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(257);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(258);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(299);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(300);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 301:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(230);
      if (lookahead == '+')
        ADVANCE(231);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(232);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(302);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(303);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 302:
      if (lookahead == '\n')
        SKIP(303);
      END_STATE();
    case 303:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(230);
      if (lookahead == '+')
        ADVANCE(231);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(232);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(302);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(303);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 304:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(250);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(251);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(305);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(304);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 305:
      if (lookahead == '\n')
        SKIP(304);
      END_STATE();
    case 306:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(257);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(258);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(299);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(300);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 307:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(308);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(309);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 308:
      if (lookahead == '\n')
        SKIP(309);
      END_STATE();
    case 309:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(308);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(309);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 310:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '\\')
        SKIP(311);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(310);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 311:
      if (lookahead == '\n')
        SKIP(310);
      END_STATE();
    case 312:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '.')
        ADVANCE(313);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(214);
      if (lookahead == '\\')
        SKIP(314);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(312);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 313:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 314:
      if (lookahead == '\n')
        SKIP(312);
      END_STATE();
    case 315:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '+')
        ADVANCE(137);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(214);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(316);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(315);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 316:
      if (lookahead == '\n')
        SKIP(315);
      END_STATE();
    case 317:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(318);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(319);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 318:
      if (lookahead == '\n')
        SKIP(319);
      END_STATE();
    case 319:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(318);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(319);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 320:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(257);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(258);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(234);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(321);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(322);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 321:
      if (lookahead == '\n')
        SKIP(322);
      END_STATE();
    case 322:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(257);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(258);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(234);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(321);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(322);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 323:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(230);
      if (lookahead == '+')
        ADVANCE(231);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(232);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(234);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(324);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(325);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 324:
      if (lookahead == '\n')
        SKIP(325);
      END_STATE();
    case 325:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(230);
      if (lookahead == '+')
        ADVANCE(231);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(232);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(234);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(324);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(325);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 326:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(327);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(328);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 327:
      if (lookahead == '\n')
        SKIP(328);
      END_STATE();
    case 328:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(327);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(328);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 329:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(257);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(258);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(234);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(330);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(331);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 330:
      if (lookahead == '\n')
        SKIP(331);
      END_STATE();
    case 331:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(257);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(258);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(234);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(330);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(331);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 332:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(333);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(313);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(334);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(335);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 333:
      if (lookahead == '.')
        ADVANCE(18);
      END_STATE();
    case 334:
      if (lookahead == '\n')
        SKIP(335);
      END_STATE();
    case 335:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(333);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(313);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '\\')
        SKIP(334);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(335);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 336:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(333);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(313);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(337);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(338);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 337:
      if (lookahead == '\n')
        SKIP(338);
      END_STATE();
    case 338:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(333);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(313);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(337);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(338);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 339:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(333);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(313);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(214);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(340);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(208);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(341);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 340:
      if (lookahead == '\n')
        SKIP(341);
      END_STATE();
    case 341:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(333);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(313);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(214);
      if (lookahead == '\\')
        SKIP(340);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(208);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(341);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 342:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(333);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(313);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '=')
        ADVANCE(214);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(343);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(344);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 343:
      if (lookahead == '\n')
        SKIP(344);
      END_STATE();
    case 344:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(333);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(313);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(214);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(343);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(344);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 345:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(333);
      if (lookahead == '.')
        ADVANCE(313);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(346);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(347);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 346:
      if (lookahead == '\n')
        SKIP(347);
      END_STATE();
    case 347:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(333);
      if (lookahead == '.')
        ADVANCE(313);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '\\')
        SKIP(346);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(347);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 348:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(333);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(313);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(349);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(350);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(351);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 349:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 350:
      if (lookahead == '\n')
        SKIP(351);
      END_STATE();
    case 351:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(333);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(313);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(349);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(350);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(351);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 352:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(333);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(313);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(353);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(354);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 353:
      if (lookahead == '\n')
        SKIP(354);
      END_STATE();
    case 354:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(333);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(313);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(353);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(354);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 355:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(356);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(357);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 356:
      if (lookahead == '\n')
        SKIP(357);
      END_STATE();
    case 357:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(356);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(357);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 358:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(359);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(358);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 359:
      if (lookahead == '\n')
        SKIP(358);
      END_STATE();
    case 360:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(257);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(258);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(361);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(362);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 361:
      if (lookahead == '\n')
        SKIP(362);
      END_STATE();
    case 362:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(257);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(258);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(361);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(362);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 363:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(364);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(365);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 364:
      if (lookahead == '\n')
        SKIP(365);
      END_STATE();
    case 365:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(364);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(365);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 366:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(257);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(258);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(361);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(362);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 367:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(368);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(369);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 368:
      if (lookahead == '\n')
        SKIP(369);
      END_STATE();
    case 369:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(368);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(369);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 370:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(230);
      if (lookahead == '+')
        ADVANCE(231);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(232);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(371);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(372);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 371:
      if (lookahead == '\n')
        SKIP(372);
      END_STATE();
    case 372:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(230);
      if (lookahead == '+')
        ADVANCE(231);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(232);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(371);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(372);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 373:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(364);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(365);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 374:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '+')
        ADVANCE(137);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(375);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(374);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 375:
      if (lookahead == '\n')
        SKIP(374);
      END_STATE();
    case 376:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(333);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(313);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(377);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(378);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 377:
      if (lookahead == '\n')
        SKIP(378);
      END_STATE();
    case 378:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(333);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(313);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(377);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(378);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 379:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(130);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(380);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(381);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(379);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 380:
      if (lookahead == '>')
        ADVANCE(66);
      if (lookahead == 'b')
        ADVANCE(142);
      END_STATE();
    case 381:
      if (lookahead == '\n')
        SKIP(379);
      END_STATE();
    case 382:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(250);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(251);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(383);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(382);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 383:
      if (lookahead == '\n')
        SKIP(382);
      END_STATE();
    case 384:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(214);
      if (lookahead == '\\')
        SKIP(385);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(384);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 385:
      if (lookahead == '\n')
        SKIP(384);
      END_STATE();
    case 386:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '\\')
        SKIP(387);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(386);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 387:
      if (lookahead == '\n')
        SKIP(386);
      END_STATE();
    case 388:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(200);
      if (lookahead == '-')
        ADVANCE(30);
      if (lookahead == '.')
        ADVANCE(201);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(234);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(204);
      if (lookahead == '\\')
        SKIP(389);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '`')
        ADVANCE(118);
      if (lookahead == '|')
        ADVANCE(208);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(388);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 389:
      if (lookahead == '\n')
        SKIP(388);
      END_STATE();
    case 390:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(291);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(391);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(392);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 391:
      if (lookahead == '\n')
        SKIP(392);
      END_STATE();
    case 392:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(294);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(391);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(392);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 393:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(394);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(395);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 394:
      if (lookahead == '\n')
        SKIP(395);
      END_STATE();
    case 395:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(394);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(395);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 396:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(257);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(258);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(397);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(398);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 397:
      if (lookahead == '\n')
        SKIP(398);
      END_STATE();
    case 398:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(257);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(258);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(397);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(398);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 399:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(230);
      if (lookahead == '+')
        ADVANCE(231);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(232);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(291);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(400);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(401);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 400:
      if (lookahead == '\n')
        SKIP(401);
      END_STATE();
    case 401:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(230);
      if (lookahead == '+')
        ADVANCE(231);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(232);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(294);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(400);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(401);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 402:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(250);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(251);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(403);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(402);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 403:
      if (lookahead == '\n')
        SKIP(402);
      END_STATE();
    case 404:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(257);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(258);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(397);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(398);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 405:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(230);
      if (lookahead == '+')
        ADVANCE(231);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(232);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(406);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(407);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 406:
      if (lookahead == '\n')
        SKIP(407);
      END_STATE();
    case 407:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(230);
      if (lookahead == '+')
        ADVANCE(231);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(232);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(406);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(407);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 408:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(409);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(410);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 409:
      if (lookahead == '\n')
        SKIP(410);
      END_STATE();
    case 410:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(409);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(410);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 411:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(130);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'B')
        ADVANCE(86);
      if (lookahead == 'E')
        ADVANCE(93);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(412);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(208);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(411);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 412:
      if (lookahead == '\n')
        SKIP(411);
      END_STATE();
    case 413:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == ':')
        ADVANCE(240);
      if (lookahead == '=')
        ADVANCE(214);
      if (lookahead == '\\')
        SKIP(414);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(415);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 414:
      if (lookahead == '\n')
        SKIP(415);
      END_STATE();
    case 415:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '=')
        ADVANCE(214);
      if (lookahead == '\\')
        SKIP(414);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(415);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 416:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(130);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'B')
        ADVANCE(86);
      if (lookahead == 'E')
        ADVANCE(93);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(417);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(208);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(416);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 417:
      if (lookahead == '\n')
        SKIP(416);
      END_STATE();
    case 418:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(200);
      if (lookahead == '-')
        ADVANCE(30);
      if (lookahead == '.')
        ADVANCE(201);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '[')
        ADVANCE(204);
      if (lookahead == '\\')
        SKIP(419);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '`')
        ADVANCE(118);
      if (lookahead == '|')
        ADVANCE(208);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(420);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 419:
      if (lookahead == '\n')
        SKIP(420);
      END_STATE();
    case 420:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(200);
      if (lookahead == '-')
        ADVANCE(30);
      if (lookahead == '.')
        ADVANCE(201);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '[')
        ADVANCE(204);
      if (lookahead == '\\')
        SKIP(419);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '`')
        ADVANCE(118);
      if (lookahead == '|')
        ADVANCE(208);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(420);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 421:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'B')
        ADVANCE(86);
      if (lookahead == 'E')
        ADVANCE(93);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(422);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(208);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(421);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 422:
      if (lookahead == '\n')
        SKIP(421);
      END_STATE();
    case 423:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(230);
      if (lookahead == '+')
        ADVANCE(231);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(232);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(424);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(425);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 424:
      if (lookahead == '\n')
        SKIP(425);
      END_STATE();
    case 425:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(230);
      if (lookahead == '+')
        ADVANCE(231);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(232);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(424);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(425);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 426:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(230);
      if (lookahead == '+')
        ADVANCE(231);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(232);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(234);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(427);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(428);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 427:
      if (lookahead == '\n')
        SKIP(428);
      END_STATE();
    case 428:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(230);
      if (lookahead == '+')
        ADVANCE(231);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(232);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(234);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(427);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(428);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 429:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(230);
      if (lookahead == '+')
        ADVANCE(231);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(232);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(424);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(425);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 430:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(130);
      if (lookahead == '+')
        ADVANCE(137);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(214);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(431);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(430);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 431:
      if (lookahead == '\n')
        SKIP(430);
      END_STATE();
    case 432:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(433);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(434);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 433:
      if (lookahead == '\n')
        SKIP(434);
      END_STATE();
    case 434:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(433);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(434);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 435:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(230);
      if (lookahead == '+')
        ADVANCE(231);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(232);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(291);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(234);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(436);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(437);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 436:
      if (lookahead == '\n')
        SKIP(437);
      END_STATE();
    case 437:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(230);
      if (lookahead == '+')
        ADVANCE(231);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(232);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(294);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(234);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(436);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(437);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 438:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(250);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(251);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(439);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(438);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 439:
      if (lookahead == '\n')
        SKIP(438);
      END_STATE();
    case 440:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(257);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(258);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(234);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(441);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(442);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 441:
      if (lookahead == '\n')
        SKIP(442);
      END_STATE();
    case 442:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(257);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(258);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(234);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(441);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(442);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 443:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(230);
      if (lookahead == '+')
        ADVANCE(231);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(232);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(234);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(444);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(445);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 444:
      if (lookahead == '\n')
        SKIP(445);
      END_STATE();
    case 445:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(230);
      if (lookahead == '+')
        ADVANCE(231);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(232);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(234);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(444);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(445);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 446:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(447);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(448);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 447:
      if (lookahead == '\n')
        SKIP(448);
      END_STATE();
    case 448:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(447);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(448);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 449:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '\\')
        SKIP(450);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(449);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 450:
      if (lookahead == '\n')
        SKIP(449);
      END_STATE();
    case 451:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(452);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(453);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 452:
      if (lookahead == '\n')
        SKIP(453);
      END_STATE();
    case 453:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(452);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(453);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 454:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(257);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(258);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(234);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(455);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(456);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 455:
      if (lookahead == '\n')
        SKIP(456);
      END_STATE();
    case 456:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(257);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(258);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(234);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(455);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(456);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 457:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '\\')
        SKIP(458);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(457);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 458:
      if (lookahead == '\n')
        SKIP(457);
      END_STATE();
    case 459:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(460);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(461);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 460:
      if (lookahead == '\n')
        SKIP(461);
      END_STATE();
    case 461:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(460);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(461);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 462:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(463);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(464);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 463:
      if (lookahead == '\n')
        SKIP(464);
      END_STATE();
    case 464:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(463);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(464);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 465:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(230);
      if (lookahead == '+')
        ADVANCE(231);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(232);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(291);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(234);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(466);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(467);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 466:
      if (lookahead == '\n')
        SKIP(467);
      END_STATE();
    case 467:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(230);
      if (lookahead == '+')
        ADVANCE(231);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(232);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(294);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(234);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(466);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(467);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 468:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(291);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(234);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(469);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(470);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 469:
      if (lookahead == '\n')
        SKIP(470);
      END_STATE();
    case 470:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(294);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(234);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(469);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(470);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 471:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(472);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(473);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 472:
      if (lookahead == '\n')
        SKIP(473);
      END_STATE();
    case 473:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(472);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(473);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 474:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(475);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(476);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 475:
      if (lookahead == '\n')
        SKIP(476);
      END_STATE();
    case 476:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(475);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(476);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 477:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(250);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(251);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(294);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(478);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(477);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 478:
      if (lookahead == '\n')
        SKIP(477);
      END_STATE();
    case 479:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(480);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(481);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 480:
      if (lookahead == '\n')
        SKIP(481);
      END_STATE();
    case 481:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(480);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(481);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 482:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(257);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(258);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(234);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(483);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(484);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 483:
      if (lookahead == '\n')
        SKIP(484);
      END_STATE();
    case 484:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(257);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(258);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(234);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(483);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(484);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 485:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == ':')
        ADVANCE(240);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(214);
      if (lookahead == '\\')
        SKIP(486);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(487);
      END_STATE();
    case 486:
      if (lookahead == '\n')
        SKIP(487);
      END_STATE();
    case 487:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(214);
      if (lookahead == '\\')
        SKIP(486);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(487);
      END_STATE();
    case 488:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(333);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(313);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '=')
        ADVANCE(214);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(489);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(490);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 489:
      if (lookahead == '\n')
        SKIP(490);
      END_STATE();
    case 490:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(333);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(313);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(214);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(489);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(490);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 491:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(492);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(493);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 492:
      if (lookahead == '\n')
        SKIP(493);
      END_STATE();
    case 493:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(492);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(493);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 494:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(257);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(258);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(495);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(496);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 495:
      if (lookahead == '\n')
        SKIP(496);
      END_STATE();
    case 496:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(257);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(258);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(495);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(496);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 497:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(498);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(499);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 498:
      if (lookahead == '\n')
        SKIP(499);
      END_STATE();
    case 499:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(498);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(499);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 500:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(257);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(258);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(495);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(496);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 501:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(230);
      if (lookahead == '+')
        ADVANCE(231);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(232);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(502);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(503);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 502:
      if (lookahead == '\n')
        SKIP(503);
      END_STATE();
    case 503:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(230);
      if (lookahead == '+')
        ADVANCE(231);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(232);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(502);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(503);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 504:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(130);
      if (lookahead == '+')
        ADVANCE(137);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(214);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(505);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(504);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 505:
      if (lookahead == '\n')
        SKIP(504);
      END_STATE();
    case 506:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(507);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(508);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 507:
      if (lookahead == '\n')
        SKIP(508);
      END_STATE();
    case 508:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(507);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(508);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 509:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(510);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(511);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 510:
      if (lookahead == '\n')
        SKIP(511);
      END_STATE();
    case 511:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(510);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(511);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 512:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(513);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(514);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 513:
      if (lookahead == '\n')
        SKIP(514);
      END_STATE();
    case 514:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(513);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(514);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 515:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(516);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(517);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 516:
      if (lookahead == '\n')
        SKIP(517);
      END_STATE();
    case 517:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(516);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(517);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 518:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(257);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(258);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(519);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(520);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 519:
      if (lookahead == '\n')
        SKIP(520);
      END_STATE();
    case 520:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(257);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(258);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(519);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(520);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 521:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(522);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(523);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 522:
      if (lookahead == '\n')
        SKIP(523);
      END_STATE();
    case 523:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(522);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(523);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 524:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(257);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(258);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(525);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(526);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 525:
      if (lookahead == '\n')
        SKIP(526);
      END_STATE();
    case 526:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(257);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(258);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(525);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(526);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 527:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(257);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(258);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(525);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(526);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 528:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(529);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(528);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 529:
      if (lookahead == '\n')
        SKIP(528);
      END_STATE();
    case 530:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(130);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'B')
        ADVANCE(86);
      if (lookahead == 'E')
        ADVANCE(93);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(531);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(208);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(530);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 531:
      if (lookahead == '\n')
        SKIP(530);
      END_STATE();
    case 532:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(250);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(251);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(533);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(532);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 533:
      if (lookahead == '\n')
        SKIP(532);
      END_STATE();
    case 534:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(391);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(392);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 535:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(536);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(537);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 536:
      if (lookahead == '\n')
        SKIP(537);
      END_STATE();
    case 537:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(536);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(537);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 538:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(257);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(258);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(234);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(539);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(540);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 539:
      if (lookahead == '\n')
        SKIP(540);
      END_STATE();
    case 540:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(257);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(258);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(234);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(539);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(540);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 541:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(230);
      if (lookahead == '+')
        ADVANCE(231);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(232);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(234);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(542);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(543);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 542:
      if (lookahead == '\n')
        SKIP(543);
      END_STATE();
    case 543:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(230);
      if (lookahead == '+')
        ADVANCE(231);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(232);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(234);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(542);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(543);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 544:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(545);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(546);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 545:
      if (lookahead == '\n')
        SKIP(546);
      END_STATE();
    case 546:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(545);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(546);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 547:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(409);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(410);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 548:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(257);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(258);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(291);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(549);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(550);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 549:
      if (lookahead == '\n')
        SKIP(550);
      END_STATE();
    case 550:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(257);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(258);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(112);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(549);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(550);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 551:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(250);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(251);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(552);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(551);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 552:
      if (lookahead == '\n')
        SKIP(551);
      END_STATE();
    case 553:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(333);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(313);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '=')
        ADVANCE(214);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(554);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(555);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 554:
      if (lookahead == '\n')
        SKIP(555);
      END_STATE();
    case 555:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(333);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(313);
      if (lookahead == '=')
        ADVANCE(214);
      if (lookahead == '\\')
        SKIP(554);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(555);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 556:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(130);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(557);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(556);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 557:
      if (lookahead == '\n')
        SKIP(556);
      END_STATE();
    case 558:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(291);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(559);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(560);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 559:
      if (lookahead == '\n')
        SKIP(560);
      END_STATE();
    case 560:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(112);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(559);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(560);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 561:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(250);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(251);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(294);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(562);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(561);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 562:
      if (lookahead == '\n')
        SKIP(561);
      END_STATE();
    case 563:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(257);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(258);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(291);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(234);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(564);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(565);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 564:
      if (lookahead == '\n')
        SKIP(565);
      END_STATE();
    case 565:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(257);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(258);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(112);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(234);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(564);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(565);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 566:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(230);
      if (lookahead == '+')
        ADVANCE(231);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(232);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(291);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(234);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(567);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(568);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 567:
      if (lookahead == '\n')
        SKIP(568);
      END_STATE();
    case 568:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(230);
      if (lookahead == '+')
        ADVANCE(231);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(232);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(294);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(234);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(567);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(568);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 569:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(291);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(570);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(571);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 570:
      if (lookahead == '\n')
        SKIP(571);
      END_STATE();
    case 571:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(294);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(570);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(571);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 572:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(230);
      if (lookahead == '+')
        ADVANCE(231);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(232);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(302);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(303);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 573:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(574);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(575);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 574:
      if (lookahead == '\n')
        SKIP(575);
      END_STATE();
    case 575:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(574);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(575);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 576:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(257);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(258);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(577);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(578);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 577:
      if (lookahead == '\n')
        SKIP(578);
      END_STATE();
    case 578:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(257);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(258);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(577);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(578);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 579:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(257);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(258);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(577);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(578);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 580:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(230);
      if (lookahead == '+')
        ADVANCE(231);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(232);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(581);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(582);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 581:
      if (lookahead == '\n')
        SKIP(582);
      END_STATE();
    case 582:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(230);
      if (lookahead == '+')
        ADVANCE(231);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(232);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(581);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(582);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 583:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(460);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(461);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 584:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(250);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(251);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(585);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(584);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 585:
      if (lookahead == '\n')
        SKIP(584);
      END_STATE();
    case 586:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(257);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(258);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(291);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(234);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(587);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(588);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 587:
      if (lookahead == '\n')
        SKIP(588);
      END_STATE();
    case 588:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(257);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(258);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(112);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(234);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(587);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(588);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 589:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(590);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(591);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 590:
      if (lookahead == '\n')
        SKIP(591);
      END_STATE();
    case 591:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(590);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(591);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 592:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(257);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(258);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(593);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(594);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 593:
      if (lookahead == '\n')
        SKIP(594);
      END_STATE();
    case 594:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(257);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(258);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(593);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(594);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 595:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(596);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(597);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 596:
      if (lookahead == '\n')
        SKIP(597);
      END_STATE();
    case 597:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(596);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(597);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 598:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(257);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(258);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(593);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(594);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 599:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(600);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(601);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 600:
      if (lookahead == '\n')
        SKIP(601);
      END_STATE();
    case 601:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(600);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(601);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 602:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(257);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(258);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(291);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(234);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(603);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(604);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 603:
      if (lookahead == '\n')
        SKIP(604);
      END_STATE();
    case 604:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(257);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(258);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(112);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(234);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(603);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(604);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 605:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(230);
      if (lookahead == '+')
        ADVANCE(231);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(232);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(400);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(401);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 606:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(130);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(607);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(606);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 607:
      if (lookahead == '\n')
        SKIP(606);
      END_STATE();
    case 608:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(609);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(610);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 609:
      if (lookahead == '\n')
        SKIP(610);
      END_STATE();
    case 610:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(609);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(610);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 611:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(612);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(613);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 612:
      if (lookahead == '\n')
        SKIP(613);
      END_STATE();
    case 613:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(612);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(613);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 614:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(615);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(616);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 615:
      if (lookahead == '\n')
        SKIP(616);
      END_STATE();
    case 616:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(615);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(616);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 617:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(618);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(619);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 618:
      if (lookahead == '\n')
        SKIP(619);
      END_STATE();
    case 619:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(618);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(619);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 620:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(498);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(499);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 621:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(230);
      if (lookahead == '+')
        ADVANCE(231);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(232);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(502);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(503);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 622:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(623);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(624);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 623:
      if (lookahead == '\n')
        SKIP(624);
      END_STATE();
    case 624:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(623);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(624);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 625:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(257);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(258);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(234);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(626);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(627);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 626:
      if (lookahead == '\n')
        SKIP(627);
      END_STATE();
    case 627:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(257);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(258);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(234);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(626);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(627);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 628:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(234);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(629);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(630);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 629:
      if (lookahead == '\n')
        SKIP(630);
      END_STATE();
    case 630:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(234);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(629);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(630);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 631:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(234);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(632);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(633);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 632:
      if (lookahead == '\n')
        SKIP(633);
      END_STATE();
    case 633:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(234);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(632);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(633);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 634:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(234);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(635);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(636);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 635:
      if (lookahead == '\n')
        SKIP(636);
      END_STATE();
    case 636:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(234);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(635);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(636);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 637:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(510);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(511);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 638:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(639);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(640);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 639:
      if (lookahead == '\n')
        SKIP(640);
      END_STATE();
    case 640:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(639);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(640);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 641:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(513);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(514);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 642:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(643);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(644);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 643:
      if (lookahead == '\n')
        SKIP(644);
      END_STATE();
    case 644:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(643);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(644);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 645:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '\\')
        SKIP(646);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(645);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 646:
      if (lookahead == '\n')
        SKIP(645);
      END_STATE();
    case 647:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(230);
      if (lookahead == '+')
        ADVANCE(231);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(232);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(406);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(407);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 648:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(130);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(649);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(648);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 649:
      if (lookahead == '\n')
        SKIP(648);
      END_STATE();
    case 650:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(291);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(651);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(652);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 651:
      if (lookahead == '\n')
        SKIP(652);
      END_STATE();
    case 652:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(294);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(651);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(652);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 653:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(291);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(654);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(655);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 654:
      if (lookahead == '\n')
        SKIP(655);
      END_STATE();
    case 655:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(112);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(654);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(655);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 656:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(257);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(258);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(657);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(658);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 657:
      if (lookahead == '\n')
        SKIP(658);
      END_STATE();
    case 658:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(257);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(258);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(112);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(657);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(658);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 659:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(291);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(660);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(661);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 660:
      if (lookahead == '\n')
        SKIP(661);
      END_STATE();
    case 661:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(294);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(660);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(661);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 662:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(257);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(258);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(291);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(657);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(658);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 663:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(230);
      if (lookahead == '+')
        ADVANCE(231);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(232);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(291);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(664);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(665);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 664:
      if (lookahead == '\n')
        SKIP(665);
      END_STATE();
    case 665:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(230);
      if (lookahead == '+')
        ADVANCE(231);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(232);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(294);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(664);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(665);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 666:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(660);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(661);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 667:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(230);
      if (lookahead == '+')
        ADVANCE(231);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(232);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(664);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(665);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 668:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(596);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(597);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 669:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(230);
      if (lookahead == '+')
        ADVANCE(231);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(232);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(581);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(582);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 670:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(230);
      if (lookahead == '+')
        ADVANCE(231);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(232);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(291);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(671);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(672);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 671:
      if (lookahead == '\n')
        SKIP(672);
      END_STATE();
    case 672:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(230);
      if (lookahead == '+')
        ADVANCE(231);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(232);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(294);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(671);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(672);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 673:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(674);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(675);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 674:
      if (lookahead == '\n')
        SKIP(675);
      END_STATE();
    case 675:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(674);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(675);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 676:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(234);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(677);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(678);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 677:
      if (lookahead == '\n')
        SKIP(678);
      END_STATE();
    case 678:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(234);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(677);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(678);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 679:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(612);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(613);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 680:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(291);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(234);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(681);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(682);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 681:
      if (lookahead == '\n')
        SKIP(682);
      END_STATE();
    case 682:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(294);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(234);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(681);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(682);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 683:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(684);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(683);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 684:
      if (lookahead == '\n')
        SKIP(683);
      END_STATE();
    case 685:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(333);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(313);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(686);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(687);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 686:
      if (lookahead == '\n')
        SKIP(687);
      END_STATE();
    case 687:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(333);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(313);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '\\')
        SKIP(686);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(687);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 688:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(130);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(689);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(208);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(688);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 689:
      if (lookahead == '\n')
        SKIP(688);
      END_STATE();
    case 690:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(291);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(691);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(692);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 691:
      if (lookahead == '\n')
        SKIP(692);
      END_STATE();
    case 692:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(112);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(691);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(692);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == '_')
        ADVANCE(1);
      if (lookahead == 'a')
        ADVANCE(8);
      if (lookahead == 'b')
        ADVANCE(15);
      if (lookahead == 'c')
        ADVANCE(24);
      if (lookahead == 'd')
        ADVANCE(32);
      if (lookahead == 'e')
        ADVANCE(41);
      if (lookahead == 'f')
        ADVANCE(53);
      if (lookahead == 'i')
        ADVANCE(60);
      if (lookahead == 'm')
        ADVANCE(63);
      if (lookahead == 'n')
        ADVANCE(69);
      if (lookahead == 'o')
        ADVANCE(77);
      if (lookahead == 'r')
        ADVANCE(79);
      if (lookahead == 's')
        ADVANCE(93);
      if (lookahead == 't')
        ADVANCE(101);
      if (lookahead == 'u')
        ADVANCE(108);
      if (lookahead == 'w')
        ADVANCE(120);
      if (lookahead == 'y')
        ADVANCE(127);
      END_STATE();
    case 1:
      if (lookahead == '_')
        ADVANCE(2);
      END_STATE();
    case 2:
      if (lookahead == 'E')
        ADVANCE(3);
      END_STATE();
    case 3:
      if (lookahead == 'N')
        ADVANCE(4);
      END_STATE();
    case 4:
      if (lookahead == 'D')
        ADVANCE(5);
      END_STATE();
    case 5:
      if (lookahead == '_')
        ADVANCE(6);
      END_STATE();
    case 6:
      if (lookahead == '_')
        ADVANCE(7);
      END_STATE();
    case 7:
      ACCEPT_TOKEN(anon_sym___END__);
      END_STATE();
    case 8:
      if (lookahead == 'l')
        ADVANCE(9);
      if (lookahead == 'n')
        ADVANCE(13);
      END_STATE();
    case 9:
      if (lookahead == 'i')
        ADVANCE(10);
      END_STATE();
    case 10:
      if (lookahead == 'a')
        ADVANCE(11);
      END_STATE();
    case 11:
      if (lookahead == 's')
        ADVANCE(12);
      END_STATE();
    case 12:
      ACCEPT_TOKEN(anon_sym_alias);
      END_STATE();
    case 13:
      if (lookahead == 'd')
        ADVANCE(14);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 15:
      if (lookahead == 'e')
        ADVANCE(16);
      if (lookahead == 'r')
        ADVANCE(20);
      END_STATE();
    case 16:
      if (lookahead == 'g')
        ADVANCE(17);
      END_STATE();
    case 17:
      if (lookahead == 'i')
        ADVANCE(18);
      END_STATE();
    case 18:
      if (lookahead == 'n')
        ADVANCE(19);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(anon_sym_begin);
      END_STATE();
    case 20:
      if (lookahead == 'e')
        ADVANCE(21);
      END_STATE();
    case 21:
      if (lookahead == 'a')
        ADVANCE(22);
      END_STATE();
    case 22:
      if (lookahead == 'k')
        ADVANCE(23);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 24:
      if (lookahead == 'a')
        ADVANCE(25);
      if (lookahead == 'l')
        ADVANCE(28);
      END_STATE();
    case 25:
      if (lookahead == 's')
        ADVANCE(26);
      END_STATE();
    case 26:
      if (lookahead == 'e')
        ADVANCE(27);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 28:
      if (lookahead == 'a')
        ADVANCE(29);
      END_STATE();
    case 29:
      if (lookahead == 's')
        ADVANCE(30);
      END_STATE();
    case 30:
      if (lookahead == 's')
        ADVANCE(31);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 32:
      if (lookahead == 'e')
        ADVANCE(33);
      if (lookahead == 'o')
        ADVANCE(40);
      END_STATE();
    case 33:
      if (lookahead == 'f')
        ADVANCE(34);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_def);
      if (lookahead == 'i')
        ADVANCE(35);
      END_STATE();
    case 35:
      if (lookahead == 'n')
        ADVANCE(36);
      END_STATE();
    case 36:
      if (lookahead == 'e')
        ADVANCE(37);
      END_STATE();
    case 37:
      if (lookahead == 'd')
        ADVANCE(38);
      END_STATE();
    case 38:
      if (lookahead == '?')
        ADVANCE(39);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_defined_QMARK);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 41:
      if (lookahead == 'l')
        ADVANCE(42);
      if (lookahead == 'n')
        ADVANCE(47);
      END_STATE();
    case 42:
      if (lookahead == 's')
        ADVANCE(43);
      END_STATE();
    case 43:
      if (lookahead == 'e')
        ADVANCE(44);
      if (lookahead == 'i')
        ADVANCE(45);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 45:
      if (lookahead == 'f')
        ADVANCE(46);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_elsif);
      END_STATE();
    case 47:
      if (lookahead == 'd')
        ADVANCE(48);
      if (lookahead == 's')
        ADVANCE(49);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_end);
      END_STATE();
    case 49:
      if (lookahead == 'u')
        ADVANCE(50);
      END_STATE();
    case 50:
      if (lookahead == 'r')
        ADVANCE(51);
      END_STATE();
    case 51:
      if (lookahead == 'e')
        ADVANCE(52);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_ensure);
      END_STATE();
    case 53:
      if (lookahead == 'a')
        ADVANCE(54);
      if (lookahead == 'o')
        ADVANCE(58);
      END_STATE();
    case 54:
      if (lookahead == 'l')
        ADVANCE(55);
      END_STATE();
    case 55:
      if (lookahead == 's')
        ADVANCE(56);
      END_STATE();
    case 56:
      if (lookahead == 'e')
        ADVANCE(57);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    case 58:
      if (lookahead == 'r')
        ADVANCE(59);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 60:
      if (lookahead == 'f')
        ADVANCE(61);
      if (lookahead == 'n')
        ADVANCE(62);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 63:
      if (lookahead == 'o')
        ADVANCE(64);
      END_STATE();
    case 64:
      if (lookahead == 'd')
        ADVANCE(65);
      END_STATE();
    case 65:
      if (lookahead == 'u')
        ADVANCE(66);
      END_STATE();
    case 66:
      if (lookahead == 'l')
        ADVANCE(67);
      END_STATE();
    case 67:
      if (lookahead == 'e')
        ADVANCE(68);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 69:
      if (lookahead == 'e')
        ADVANCE(70);
      if (lookahead == 'i')
        ADVANCE(73);
      if (lookahead == 'o')
        ADVANCE(75);
      END_STATE();
    case 70:
      if (lookahead == 'x')
        ADVANCE(71);
      END_STATE();
    case 71:
      if (lookahead == 't')
        ADVANCE(72);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_next);
      END_STATE();
    case 73:
      if (lookahead == 'l')
        ADVANCE(74);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_nil);
      END_STATE();
    case 75:
      if (lookahead == 't')
        ADVANCE(76);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_not);
      END_STATE();
    case 77:
      if (lookahead == 'r')
        ADVANCE(78);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_or);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_r);
      if (lookahead == 'e')
        ADVANCE(80);
      END_STATE();
    case 80:
      if (lookahead == 'd')
        ADVANCE(81);
      if (lookahead == 's')
        ADVANCE(83);
      if (lookahead == 't')
        ADVANCE(87);
      END_STATE();
    case 81:
      if (lookahead == 'o')
        ADVANCE(82);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(sym_redo);
      END_STATE();
    case 83:
      if (lookahead == 'c')
        ADVANCE(84);
      END_STATE();
    case 84:
      if (lookahead == 'u')
        ADVANCE(85);
      END_STATE();
    case 85:
      if (lookahead == 'e')
        ADVANCE(86);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_rescue);
      END_STATE();
    case 87:
      if (lookahead == 'r')
        ADVANCE(88);
      if (lookahead == 'u')
        ADVANCE(90);
      END_STATE();
    case 88:
      if (lookahead == 'y')
        ADVANCE(89);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(sym_retry);
      END_STATE();
    case 90:
      if (lookahead == 'r')
        ADVANCE(91);
      END_STATE();
    case 91:
      if (lookahead == 'n')
        ADVANCE(92);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 93:
      if (lookahead == 'e')
        ADVANCE(94);
      if (lookahead == 'u')
        ADVANCE(97);
      END_STATE();
    case 94:
      if (lookahead == 'l')
        ADVANCE(95);
      END_STATE();
    case 95:
      if (lookahead == 'f')
        ADVANCE(96);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(sym_self);
      END_STATE();
    case 97:
      if (lookahead == 'p')
        ADVANCE(98);
      END_STATE();
    case 98:
      if (lookahead == 'e')
        ADVANCE(99);
      END_STATE();
    case 99:
      if (lookahead == 'r')
        ADVANCE(100);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(sym_super);
      END_STATE();
    case 101:
      if (lookahead == 'h')
        ADVANCE(102);
      if (lookahead == 'r')
        ADVANCE(105);
      END_STATE();
    case 102:
      if (lookahead == 'e')
        ADVANCE(103);
      END_STATE();
    case 103:
      if (lookahead == 'n')
        ADVANCE(104);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_then);
      END_STATE();
    case 105:
      if (lookahead == 'u')
        ADVANCE(106);
      END_STATE();
    case 106:
      if (lookahead == 'e')
        ADVANCE(107);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 108:
      if (lookahead == 'n')
        ADVANCE(109);
      END_STATE();
    case 109:
      if (lookahead == 'd')
        ADVANCE(110);
      if (lookahead == 'l')
        ADVANCE(113);
      if (lookahead == 't')
        ADVANCE(117);
      END_STATE();
    case 110:
      if (lookahead == 'e')
        ADVANCE(111);
      END_STATE();
    case 111:
      if (lookahead == 'f')
        ADVANCE(112);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_undef);
      END_STATE();
    case 113:
      if (lookahead == 'e')
        ADVANCE(114);
      END_STATE();
    case 114:
      if (lookahead == 's')
        ADVANCE(115);
      END_STATE();
    case 115:
      if (lookahead == 's')
        ADVANCE(116);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_unless);
      END_STATE();
    case 117:
      if (lookahead == 'i')
        ADVANCE(118);
      END_STATE();
    case 118:
      if (lookahead == 'l')
        ADVANCE(119);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_until);
      END_STATE();
    case 120:
      if (lookahead == 'h')
        ADVANCE(121);
      END_STATE();
    case 121:
      if (lookahead == 'e')
        ADVANCE(122);
      if (lookahead == 'i')
        ADVANCE(124);
      END_STATE();
    case 122:
      if (lookahead == 'n')
        ADVANCE(123);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_when);
      END_STATE();
    case 124:
      if (lookahead == 'l')
        ADVANCE(125);
      END_STATE();
    case 125:
      if (lookahead == 'e')
        ADVANCE(126);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 127:
      if (lookahead == 'i')
        ADVANCE(128);
      END_STATE();
    case 128:
      if (lookahead == 'e')
        ADVANCE(129);
      END_STATE();
    case 129:
      if (lookahead == 'l')
        ADVANCE(130);
      END_STATE();
    case 130:
      if (lookahead == 'd')
        ADVANCE(131);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 128, .external_lex_state = 2},
  [2] = {.lex_state = 156, .external_lex_state = 3},
  [3] = {.lex_state = 177, .external_lex_state = 4},
  [4] = {.lex_state = 177, .external_lex_state = 4},
  [5] = {.lex_state = 177, .external_lex_state = 4},
  [6] = {.lex_state = 177, .external_lex_state = 4},
  [7] = {.lex_state = 190, .external_lex_state = 4},
  [8] = {.lex_state = 190, .external_lex_state = 4},
  [9] = {.lex_state = 192, .external_lex_state = 2},
  [10] = {.lex_state = 128, .external_lex_state = 5},
  [11] = {.lex_state = 128},
  [12] = {.lex_state = 194, .external_lex_state = 6},
  [13] = {.lex_state = 128},
  [14] = {.lex_state = 197, .external_lex_state = 7},
  [15] = {.lex_state = 209, .external_lex_state = 2},
  [16] = {.lex_state = 197},
  [17] = {.lex_state = 211, .external_lex_state = 2},
  [18] = {.lex_state = 213, .external_lex_state = 8},
  [19] = {.lex_state = 216, .external_lex_state = 9},
  [20] = {.lex_state = 216, .external_lex_state = 8},
  [21] = {.lex_state = 218, .external_lex_state = 10},
  [22] = {.lex_state = 218, .external_lex_state = 10},
  [23] = {.lex_state = 218, .external_lex_state = 10},
  [24] = {.lex_state = 218, .external_lex_state = 10},
  [25] = {.lex_state = 221, .external_lex_state = 2},
  [26] = {.lex_state = 221, .external_lex_state = 2},
  [27] = {.lex_state = 192, .external_lex_state = 2},
  [28] = {.lex_state = 192, .external_lex_state = 2},
  [29] = {.lex_state = 223, .external_lex_state = 8},
  [30] = {.lex_state = 225, .external_lex_state = 11},
  [31] = {.lex_state = 128, .external_lex_state = 11},
  [32] = {.lex_state = 192, .external_lex_state = 2},
  [33] = {.lex_state = 192, .external_lex_state = 2},
  [34] = {.lex_state = 227, .external_lex_state = 7},
  [35] = {.lex_state = 227, .external_lex_state = 7},
  [36] = {.lex_state = 156, .external_lex_state = 3},
  [37] = {.lex_state = 229, .external_lex_state = 3},
  [38] = {.lex_state = 229, .external_lex_state = 3},
  [39] = {.lex_state = 229, .external_lex_state = 3},
  [40] = {.lex_state = 237, .external_lex_state = 12},
  [41] = {.lex_state = 239},
  [42] = {.lex_state = 243},
  [43] = {.lex_state = 245},
  [44] = {.lex_state = 247, .external_lex_state = 13},
  [45] = {.lex_state = 249, .external_lex_state = 3},
  [46] = {.lex_state = 253, .external_lex_state = 3},
  [47] = {.lex_state = 256, .external_lex_state = 10},
  [48] = {.lex_state = 213},
  [49] = {.lex_state = 213},
  [50] = {.lex_state = 213},
  [51] = {.lex_state = 261, .external_lex_state = 3},
  [52] = {.lex_state = 264, .external_lex_state = 14},
  [53] = {.lex_state = 128, .external_lex_state = 2},
  [54] = {.lex_state = 267, .external_lex_state = 14},
  [55] = {.lex_state = 221, .external_lex_state = 2},
  [56] = {.lex_state = 192, .external_lex_state = 15},
  [57] = {.lex_state = 177, .external_lex_state = 4},
  [58] = {.lex_state = 156, .external_lex_state = 3},
  [59] = {.lex_state = 192, .external_lex_state = 15},
  [60] = {.lex_state = 156, .external_lex_state = 3},
  [61] = {.lex_state = 192, .external_lex_state = 15},
  [62] = {.lex_state = 156, .external_lex_state = 3},
  [63] = {.lex_state = 192, .external_lex_state = 15},
  [64] = {.lex_state = 156, .external_lex_state = 3},
  [65] = {.lex_state = 221, .external_lex_state = 2},
  [66] = {.lex_state = 190, .external_lex_state = 4},
  [67] = {.lex_state = 268, .external_lex_state = 15},
  [68] = {.lex_state = 190, .external_lex_state = 4},
  [69] = {.lex_state = 156, .external_lex_state = 3},
  [70] = {.lex_state = 190, .external_lex_state = 4},
  [71] = {.lex_state = 268, .external_lex_state = 15},
  [72] = {.lex_state = 249, .external_lex_state = 3},
  [73] = {.lex_state = 271},
  [74] = {.lex_state = 288, .external_lex_state = 2},
  [75] = {.lex_state = 290, .external_lex_state = 16},
  [76] = {.lex_state = 177, .external_lex_state = 4},
  [77] = {.lex_state = 177, .external_lex_state = 4},
  [78] = {.lex_state = 177, .external_lex_state = 4},
  [79] = {.lex_state = 177, .external_lex_state = 4},
  [80] = {.lex_state = 190, .external_lex_state = 4},
  [81] = {.lex_state = 190, .external_lex_state = 4},
  [82] = {.lex_state = 177, .external_lex_state = 17},
  [83] = {.lex_state = 192, .external_lex_state = 2},
  [84] = {.lex_state = 239},
  [85] = {.lex_state = 194, .external_lex_state = 6},
  [86] = {.lex_state = 156, .external_lex_state = 3},
  [87] = {.lex_state = 197, .external_lex_state = 7},
  [88] = {.lex_state = 209, .external_lex_state = 2},
  [89] = {.lex_state = 197},
  [90] = {.lex_state = 192, .external_lex_state = 2},
  [91] = {.lex_state = 216, .external_lex_state = 9},
  [92] = {.lex_state = 216, .external_lex_state = 8},
  [93] = {.lex_state = 295, .external_lex_state = 18},
  [94] = {.lex_state = 295, .external_lex_state = 18},
  [95] = {.lex_state = 295, .external_lex_state = 18},
  [96] = {.lex_state = 295, .external_lex_state = 18},
  [97] = {.lex_state = 221, .external_lex_state = 2},
  [98] = {.lex_state = 221, .external_lex_state = 2},
  [99] = {.lex_state = 192, .external_lex_state = 2},
  [100] = {.lex_state = 192, .external_lex_state = 2},
  [101] = {.lex_state = 223, .external_lex_state = 8},
  [102] = {.lex_state = 225, .external_lex_state = 11},
  [103] = {.lex_state = 128, .external_lex_state = 11},
  [104] = {.lex_state = 192, .external_lex_state = 2},
  [105] = {.lex_state = 192, .external_lex_state = 2},
  [106] = {.lex_state = 298, .external_lex_state = 18},
  [107] = {.lex_state = 290, .external_lex_state = 16},
  [108] = {.lex_state = 301, .external_lex_state = 16},
  [109] = {.lex_state = 301, .external_lex_state = 16},
  [110] = {.lex_state = 301, .external_lex_state = 16},
  [111] = {.lex_state = 237, .external_lex_state = 12},
  [112] = {.lex_state = 239},
  [113] = {.lex_state = 304, .external_lex_state = 16},
  [114] = {.lex_state = 156, .external_lex_state = 16},
  [115] = {.lex_state = 306, .external_lex_state = 18},
  [116] = {.lex_state = 239, .external_lex_state = 19},
  [117] = {.lex_state = 213},
  [118] = {.lex_state = 301, .external_lex_state = 16},
  [119] = {.lex_state = 307, .external_lex_state = 20},
  [120] = {.lex_state = 194},
  [121] = {.lex_state = 194, .external_lex_state = 19},
  [122] = {.lex_state = 239, .external_lex_state = 19},
  [123] = {.lex_state = 288, .external_lex_state = 2},
  [124] = {.lex_state = 310, .external_lex_state = 13},
  [125] = {.lex_state = 177, .external_lex_state = 4},
  [126] = {.lex_state = 192, .external_lex_state = 2},
  [127] = {.lex_state = 310, .external_lex_state = 13},
  [128] = {.lex_state = 312, .external_lex_state = 13},
  [129] = {.lex_state = 312, .external_lex_state = 13},
  [130] = {.lex_state = 156, .external_lex_state = 3},
  [131] = {.lex_state = 312},
  [132] = {.lex_state = 312, .external_lex_state = 13},
  [133] = {.lex_state = 192, .external_lex_state = 2},
  [134] = {.lex_state = 156, .external_lex_state = 3},
  [135] = {.lex_state = 315, .external_lex_state = 8},
  [136] = {.lex_state = 317, .external_lex_state = 10},
  [137] = {.lex_state = 317, .external_lex_state = 10},
  [138] = {.lex_state = 317, .external_lex_state = 10},
  [139] = {.lex_state = 317, .external_lex_state = 10},
  [140] = {.lex_state = 192, .external_lex_state = 2},
  [141] = {.lex_state = 192, .external_lex_state = 2},
  [142] = {.lex_state = 227, .external_lex_state = 7},
  [143] = {.lex_state = 209},
  [144] = {.lex_state = 209, .external_lex_state = 13},
  [145] = {.lex_state = 304, .external_lex_state = 3},
  [146] = {.lex_state = 320, .external_lex_state = 10},
  [147] = {.lex_state = 213},
  [148] = {.lex_state = 315},
  [149] = {.lex_state = 315},
  [150] = {.lex_state = 323, .external_lex_state = 3},
  [151] = {.lex_state = 326, .external_lex_state = 14},
  [152] = {.lex_state = 209, .external_lex_state = 2},
  [153] = {.lex_state = 329, .external_lex_state = 10},
  [154] = {.lex_state = 332},
  [155] = {.lex_state = 177, .external_lex_state = 4},
  [156] = {.lex_state = 177, .external_lex_state = 4},
  [157] = {.lex_state = 177, .external_lex_state = 4},
  [158] = {.lex_state = 177, .external_lex_state = 4},
  [159] = {.lex_state = 190, .external_lex_state = 4},
  [160] = {.lex_state = 190, .external_lex_state = 4},
  [161] = {.lex_state = 194, .external_lex_state = 6},
  [162] = {.lex_state = 197, .external_lex_state = 7},
  [163] = {.lex_state = 209, .external_lex_state = 2},
  [164] = {.lex_state = 197},
  [165] = {.lex_state = 216, .external_lex_state = 9},
  [166] = {.lex_state = 216, .external_lex_state = 8},
  [167] = {.lex_state = 336, .external_lex_state = 12},
  [168] = {.lex_state = 336, .external_lex_state = 12},
  [169] = {.lex_state = 336, .external_lex_state = 12},
  [170] = {.lex_state = 336, .external_lex_state = 12},
  [171] = {.lex_state = 221, .external_lex_state = 2},
  [172] = {.lex_state = 221, .external_lex_state = 2},
  [173] = {.lex_state = 192, .external_lex_state = 2},
  [174] = {.lex_state = 192, .external_lex_state = 2},
  [175] = {.lex_state = 223, .external_lex_state = 8},
  [176] = {.lex_state = 225, .external_lex_state = 11},
  [177] = {.lex_state = 128, .external_lex_state = 11},
  [178] = {.lex_state = 332},
  [179] = {.lex_state = 339},
  [180] = {.lex_state = 339},
  [181] = {.lex_state = 339},
  [182] = {.lex_state = 237, .external_lex_state = 12},
  [183] = {.lex_state = 239},
  [184] = {.lex_state = 332},
  [185] = {.lex_state = 342, .external_lex_state = 12},
  [186] = {.lex_state = 339},
  [187] = {.lex_state = 345, .external_lex_state = 21},
  [188] = {.lex_state = 192, .external_lex_state = 2},
  [189] = {.lex_state = 197},
  [190] = {.lex_state = 348, .external_lex_state = 22},
  [191] = {.lex_state = 332},
  [192] = {.lex_state = 348, .external_lex_state = 22},
  [193] = {.lex_state = 336, .external_lex_state = 12},
  [194] = {.lex_state = 352, .external_lex_state = 22},
  [195] = {.lex_state = 352, .external_lex_state = 22},
  [196] = {.lex_state = 192, .external_lex_state = 2},
  [197] = {.lex_state = 192, .external_lex_state = 2},
  [198] = {.lex_state = 192, .external_lex_state = 2},
  [199] = {.lex_state = 239},
  [200] = {.lex_state = 197},
  [201] = {.lex_state = 192, .external_lex_state = 2},
  [202] = {.lex_state = 355, .external_lex_state = 10},
  [203] = {.lex_state = 355, .external_lex_state = 10},
  [204] = {.lex_state = 355, .external_lex_state = 10},
  [205] = {.lex_state = 355, .external_lex_state = 10},
  [206] = {.lex_state = 358, .external_lex_state = 12},
  [207] = {.lex_state = 192, .external_lex_state = 2},
  [208] = {.lex_state = 192, .external_lex_state = 2},
  [209] = {.lex_state = 360, .external_lex_state = 10},
  [210] = {.lex_state = 301, .external_lex_state = 3},
  [211] = {.lex_state = 301, .external_lex_state = 3},
  [212] = {.lex_state = 301, .external_lex_state = 3},
  [213] = {.lex_state = 363, .external_lex_state = 3},
  [214] = {.lex_state = 156, .external_lex_state = 3},
  [215] = {.lex_state = 366, .external_lex_state = 10},
  [216] = {.lex_state = 156, .external_lex_state = 3},
  [217] = {.lex_state = 264, .external_lex_state = 3},
  [218] = {.lex_state = 367, .external_lex_state = 3},
  [219] = {.lex_state = 213},
  [220] = {.lex_state = 370, .external_lex_state = 3},
  [221] = {.lex_state = 373, .external_lex_state = 14},
  [222] = {.lex_state = 156, .external_lex_state = 3},
  [223] = {.lex_state = 156, .external_lex_state = 3},
  [224] = {.lex_state = 156, .external_lex_state = 3},
  [225] = {.lex_state = 192, .external_lex_state = 2},
  [226] = {.lex_state = 218, .external_lex_state = 10},
  [227] = {.lex_state = 218, .external_lex_state = 10},
  [228] = {.lex_state = 218, .external_lex_state = 10},
  [229] = {.lex_state = 218, .external_lex_state = 10},
  [230] = {.lex_state = 192, .external_lex_state = 2},
  [231] = {.lex_state = 192, .external_lex_state = 2},
  [232] = {.lex_state = 227, .external_lex_state = 7},
  [233] = {.lex_state = 128, .external_lex_state = 13},
  [234] = {.lex_state = 249, .external_lex_state = 3},
  [235] = {.lex_state = 256, .external_lex_state = 10},
  [236] = {.lex_state = 213},
  [237] = {.lex_state = 261, .external_lex_state = 3},
  [238] = {.lex_state = 264, .external_lex_state = 14},
  [239] = {.lex_state = 128, .external_lex_state = 13},
  [240] = {.lex_state = 192, .external_lex_state = 2},
  [241] = {.lex_state = 218, .external_lex_state = 10},
  [242] = {.lex_state = 218, .external_lex_state = 10},
  [243] = {.lex_state = 218, .external_lex_state = 10},
  [244] = {.lex_state = 218, .external_lex_state = 10},
  [245] = {.lex_state = 192, .external_lex_state = 2},
  [246] = {.lex_state = 192, .external_lex_state = 2},
  [247] = {.lex_state = 249, .external_lex_state = 3},
  [248] = {.lex_state = 256, .external_lex_state = 10},
  [249] = {.lex_state = 213},
  [250] = {.lex_state = 261, .external_lex_state = 3},
  [251] = {.lex_state = 264, .external_lex_state = 14},
  [252] = {.lex_state = 249, .external_lex_state = 3},
  [253] = {.lex_state = 209, .external_lex_state = 2},
  [254] = {.lex_state = 374, .external_lex_state = 8},
  [255] = {.lex_state = 376, .external_lex_state = 12},
  [256] = {.lex_state = 128},
  [257] = {.lex_state = 156},
  [258] = {.lex_state = 332},
  [259] = {.lex_state = 192, .external_lex_state = 2},
  [260] = {.lex_state = 218, .external_lex_state = 10},
  [261] = {.lex_state = 218, .external_lex_state = 10},
  [262] = {.lex_state = 218, .external_lex_state = 10},
  [263] = {.lex_state = 218, .external_lex_state = 10},
  [264] = {.lex_state = 192, .external_lex_state = 2},
  [265] = {.lex_state = 192, .external_lex_state = 2},
  [266] = {.lex_state = 249, .external_lex_state = 3},
  [267] = {.lex_state = 256, .external_lex_state = 10},
  [268] = {.lex_state = 213},
  [269] = {.lex_state = 261, .external_lex_state = 3},
  [270] = {.lex_state = 264, .external_lex_state = 14},
  [271] = {.lex_state = 128},
  [272] = {.lex_state = 177, .external_lex_state = 17},
  [273] = {.lex_state = 192, .external_lex_state = 2},
  [274] = {.lex_state = 218, .external_lex_state = 10},
  [275] = {.lex_state = 218, .external_lex_state = 10},
  [276] = {.lex_state = 218, .external_lex_state = 10},
  [277] = {.lex_state = 218, .external_lex_state = 10},
  [278] = {.lex_state = 379, .external_lex_state = 23},
  [279] = {.lex_state = 128, .external_lex_state = 11},
  [280] = {.lex_state = 128, .external_lex_state = 2},
  [281] = {.lex_state = 192, .external_lex_state = 2},
  [282] = {.lex_state = 192, .external_lex_state = 2},
  [283] = {.lex_state = 227, .external_lex_state = 7},
  [284] = {.lex_state = 128},
  [285] = {.lex_state = 128, .external_lex_state = 13},
  [286] = {.lex_state = 128},
  [287] = {.lex_state = 128},
  [288] = {.lex_state = 128},
  [289] = {.lex_state = 156, .external_lex_state = 3},
  [290] = {.lex_state = 249, .external_lex_state = 3},
  [291] = {.lex_state = 256, .external_lex_state = 10},
  [292] = {.lex_state = 213},
  [293] = {.lex_state = 261, .external_lex_state = 3},
  [294] = {.lex_state = 264, .external_lex_state = 14},
  [295] = {.lex_state = 128, .external_lex_state = 2},
  [296] = {.lex_state = 128, .external_lex_state = 2},
  [297] = {.lex_state = 249, .external_lex_state = 3},
  [298] = {.lex_state = 382, .external_lex_state = 3},
  [299] = {.lex_state = 384, .external_lex_state = 13},
  [300] = {.lex_state = 386, .external_lex_state = 13},
  [301] = {.lex_state = 227, .external_lex_state = 7},
  [302] = {.lex_state = 177, .external_lex_state = 4},
  [303] = {.lex_state = 227, .external_lex_state = 7},
  [304] = {.lex_state = 388, .external_lex_state = 7},
  [305] = {.lex_state = 227, .external_lex_state = 7},
  [306] = {.lex_state = 156, .external_lex_state = 3},
  [307] = {.lex_state = 390, .external_lex_state = 24},
  [308] = {.lex_state = 177, .external_lex_state = 4},
  [309] = {.lex_state = 177, .external_lex_state = 4},
  [310] = {.lex_state = 177, .external_lex_state = 4},
  [311] = {.lex_state = 177, .external_lex_state = 4},
  [312] = {.lex_state = 190, .external_lex_state = 4},
  [313] = {.lex_state = 190, .external_lex_state = 4},
  [314] = {.lex_state = 192, .external_lex_state = 2},
  [315] = {.lex_state = 192, .external_lex_state = 2},
  [316] = {.lex_state = 192, .external_lex_state = 2},
  [317] = {.lex_state = 239},
  [318] = {.lex_state = 194, .external_lex_state = 6},
  [319] = {.lex_state = 197, .external_lex_state = 7},
  [320] = {.lex_state = 209, .external_lex_state = 2},
  [321] = {.lex_state = 197},
  [322] = {.lex_state = 192, .external_lex_state = 2},
  [323] = {.lex_state = 216, .external_lex_state = 9},
  [324] = {.lex_state = 216, .external_lex_state = 8},
  [325] = {.lex_state = 393, .external_lex_state = 25},
  [326] = {.lex_state = 393, .external_lex_state = 25},
  [327] = {.lex_state = 393, .external_lex_state = 25},
  [328] = {.lex_state = 393, .external_lex_state = 25},
  [329] = {.lex_state = 221, .external_lex_state = 2},
  [330] = {.lex_state = 221, .external_lex_state = 2},
  [331] = {.lex_state = 192, .external_lex_state = 2},
  [332] = {.lex_state = 192, .external_lex_state = 2},
  [333] = {.lex_state = 223, .external_lex_state = 8},
  [334] = {.lex_state = 225, .external_lex_state = 11},
  [335] = {.lex_state = 128, .external_lex_state = 11},
  [336] = {.lex_state = 156, .external_lex_state = 3},
  [337] = {.lex_state = 192, .external_lex_state = 2},
  [338] = {.lex_state = 192, .external_lex_state = 2},
  [339] = {.lex_state = 396, .external_lex_state = 25},
  [340] = {.lex_state = 390, .external_lex_state = 24},
  [341] = {.lex_state = 399, .external_lex_state = 24},
  [342] = {.lex_state = 399, .external_lex_state = 24},
  [343] = {.lex_state = 399, .external_lex_state = 24},
  [344] = {.lex_state = 237, .external_lex_state = 12},
  [345] = {.lex_state = 239},
  [346] = {.lex_state = 402, .external_lex_state = 24},
  [347] = {.lex_state = 390, .external_lex_state = 24},
  [348] = {.lex_state = 404, .external_lex_state = 25},
  [349] = {.lex_state = 237},
  [350] = {.lex_state = 393, .external_lex_state = 19},
  [351] = {.lex_state = 213},
  [352] = {.lex_state = 405, .external_lex_state = 24},
  [353] = {.lex_state = 408, .external_lex_state = 26},
  [354] = {.lex_state = 411, .external_lex_state = 2},
  [355] = {.lex_state = 413},
  [356] = {.lex_state = 339},
  [357] = {.lex_state = 339},
  [358] = {.lex_state = 128},
  [359] = {.lex_state = 416, .external_lex_state = 11},
  [360] = {.lex_state = 239},
  [361] = {.lex_state = 128},
  [362] = {.lex_state = 156},
  [363] = {.lex_state = 156, .external_lex_state = 3},
  [364] = {.lex_state = 128, .external_lex_state = 5},
  [365] = {.lex_state = 192, .external_lex_state = 2},
  [366] = {.lex_state = 192, .external_lex_state = 2},
  [367] = {.lex_state = 192, .external_lex_state = 2},
  [368] = {.lex_state = 192, .external_lex_state = 2},
  [369] = {.lex_state = 192, .external_lex_state = 2},
  [370] = {.lex_state = 211, .external_lex_state = 2},
  [371] = {.lex_state = 192, .external_lex_state = 2},
  [372] = {.lex_state = 192, .external_lex_state = 2},
  [373] = {.lex_state = 192, .external_lex_state = 2},
  [374] = {.lex_state = 192, .external_lex_state = 2},
  [375] = {.lex_state = 192, .external_lex_state = 2},
  [376] = {.lex_state = 192, .external_lex_state = 2},
  [377] = {.lex_state = 192, .external_lex_state = 2},
  [378] = {.lex_state = 192, .external_lex_state = 2},
  [379] = {.lex_state = 192, .external_lex_state = 2},
  [380] = {.lex_state = 192, .external_lex_state = 2},
  [381] = {.lex_state = 418, .external_lex_state = 27},
  [382] = {.lex_state = 237, .external_lex_state = 12},
  [383] = {.lex_state = 197},
  [384] = {.lex_state = 301, .external_lex_state = 3},
  [385] = {.lex_state = 177, .external_lex_state = 4},
  [386] = {.lex_state = 177, .external_lex_state = 4},
  [387] = {.lex_state = 177, .external_lex_state = 4},
  [388] = {.lex_state = 177, .external_lex_state = 4},
  [389] = {.lex_state = 190, .external_lex_state = 4},
  [390] = {.lex_state = 190, .external_lex_state = 4},
  [391] = {.lex_state = 192, .external_lex_state = 2},
  [392] = {.lex_state = 192, .external_lex_state = 2},
  [393] = {.lex_state = 192, .external_lex_state = 2},
  [394] = {.lex_state = 239},
  [395] = {.lex_state = 421, .external_lex_state = 6},
  [396] = {.lex_state = 197, .external_lex_state = 7},
  [397] = {.lex_state = 209, .external_lex_state = 2},
  [398] = {.lex_state = 192, .external_lex_state = 2},
  [399] = {.lex_state = 216, .external_lex_state = 9},
  [400] = {.lex_state = 216, .external_lex_state = 8},
  [401] = {.lex_state = 366, .external_lex_state = 10},
  [402] = {.lex_state = 366, .external_lex_state = 10},
  [403] = {.lex_state = 366, .external_lex_state = 10},
  [404] = {.lex_state = 366, .external_lex_state = 10},
  [405] = {.lex_state = 221, .external_lex_state = 2},
  [406] = {.lex_state = 221, .external_lex_state = 2},
  [407] = {.lex_state = 192, .external_lex_state = 2},
  [408] = {.lex_state = 192, .external_lex_state = 2},
  [409] = {.lex_state = 223, .external_lex_state = 8},
  [410] = {.lex_state = 416, .external_lex_state = 11},
  [411] = {.lex_state = 225, .external_lex_state = 11},
  [412] = {.lex_state = 128, .external_lex_state = 11},
  [413] = {.lex_state = 358, .external_lex_state = 12},
  [414] = {.lex_state = 192, .external_lex_state = 2},
  [415] = {.lex_state = 192, .external_lex_state = 2},
  [416] = {.lex_state = 360, .external_lex_state = 10},
  [417] = {.lex_state = 301, .external_lex_state = 3},
  [418] = {.lex_state = 237, .external_lex_state = 12},
  [419] = {.lex_state = 239},
  [420] = {.lex_state = 423, .external_lex_state = 3},
  [421] = {.lex_state = 301, .external_lex_state = 3},
  [422] = {.lex_state = 366, .external_lex_state = 10},
  [423] = {.lex_state = 229, .external_lex_state = 3},
  [424] = {.lex_state = 426, .external_lex_state = 3},
  [425] = {.lex_state = 426, .external_lex_state = 3},
  [426] = {.lex_state = 229, .external_lex_state = 3},
  [427] = {.lex_state = 213},
  [428] = {.lex_state = 423, .external_lex_state = 3},
  [429] = {.lex_state = 429, .external_lex_state = 14},
  [430] = {.lex_state = 192, .external_lex_state = 28},
  [431] = {.lex_state = 430, .external_lex_state = 8},
  [432] = {.lex_state = 213},
  [433] = {.lex_state = 192, .external_lex_state = 2},
  [434] = {.lex_state = 264, .external_lex_state = 14},
  [435] = {.lex_state = 247, .external_lex_state = 13},
  [436] = {.lex_state = 128, .external_lex_state = 2},
  [437] = {.lex_state = 192, .external_lex_state = 2},
  [438] = {.lex_state = 128},
  [439] = {.lex_state = 128},
  [440] = {.lex_state = 197},
  [441] = {.lex_state = 432, .external_lex_state = 18},
  [442] = {.lex_state = 432, .external_lex_state = 18},
  [443] = {.lex_state = 432, .external_lex_state = 18},
  [444] = {.lex_state = 432, .external_lex_state = 18},
  [445] = {.lex_state = 192, .external_lex_state = 2},
  [446] = {.lex_state = 192, .external_lex_state = 2},
  [447] = {.lex_state = 227, .external_lex_state = 7},
  [448] = {.lex_state = 227, .external_lex_state = 7},
  [449] = {.lex_state = 435, .external_lex_state = 16},
  [450] = {.lex_state = 435, .external_lex_state = 16},
  [451] = {.lex_state = 435, .external_lex_state = 16},
  [452] = {.lex_state = 194},
  [453] = {.lex_state = 438, .external_lex_state = 16},
  [454] = {.lex_state = 290, .external_lex_state = 16},
  [455] = {.lex_state = 440, .external_lex_state = 18},
  [456] = {.lex_state = 213},
  [457] = {.lex_state = 443, .external_lex_state = 16},
  [458] = {.lex_state = 446, .external_lex_state = 20},
  [459] = {.lex_state = 267, .external_lex_state = 14},
  [460] = {.lex_state = 177, .external_lex_state = 4},
  [461] = {.lex_state = 156, .external_lex_state = 3},
  [462] = {.lex_state = 156, .external_lex_state = 3},
  [463] = {.lex_state = 156, .external_lex_state = 3},
  [464] = {.lex_state = 194},
  [465] = {.lex_state = 156, .external_lex_state = 3},
  [466] = {.lex_state = 192, .external_lex_state = 15},
  [467] = {.lex_state = 268, .external_lex_state = 15},
  [468] = {.lex_state = 156, .external_lex_state = 3},
  [469] = {.lex_state = 177, .external_lex_state = 4},
  [470] = {.lex_state = 268, .external_lex_state = 15},
  [471] = {.lex_state = 190, .external_lex_state = 4},
  [472] = {.lex_state = 156, .external_lex_state = 3},
  [473] = {.lex_state = 192, .external_lex_state = 15},
  [474] = {.lex_state = 268, .external_lex_state = 15},
  [475] = {.lex_state = 156, .external_lex_state = 3},
  [476] = {.lex_state = 177, .external_lex_state = 4},
  [477] = {.lex_state = 268, .external_lex_state = 15},
  [478] = {.lex_state = 243},
  [479] = {.lex_state = 192, .external_lex_state = 2},
  [480] = {.lex_state = 449, .external_lex_state = 13},
  [481] = {.lex_state = 451, .external_lex_state = 10},
  [482] = {.lex_state = 451, .external_lex_state = 10},
  [483] = {.lex_state = 451, .external_lex_state = 10},
  [484] = {.lex_state = 451, .external_lex_state = 10},
  [485] = {.lex_state = 192, .external_lex_state = 2},
  [486] = {.lex_state = 192, .external_lex_state = 2},
  [487] = {.lex_state = 227, .external_lex_state = 7},
  [488] = {.lex_state = 194},
  [489] = {.lex_state = 239, .external_lex_state = 13},
  [490] = {.lex_state = 438, .external_lex_state = 3},
  [491] = {.lex_state = 454, .external_lex_state = 10},
  [492] = {.lex_state = 213},
  [493] = {.lex_state = 443, .external_lex_state = 3},
  [494] = {.lex_state = 446, .external_lex_state = 14},
  [495] = {.lex_state = 288, .external_lex_state = 2},
  [496] = {.lex_state = 267, .external_lex_state = 20},
  [497] = {.lex_state = 192, .external_lex_state = 15},
  [498] = {.lex_state = 290, .external_lex_state = 16},
  [499] = {.lex_state = 192, .external_lex_state = 15},
  [500] = {.lex_state = 290, .external_lex_state = 16},
  [501] = {.lex_state = 192, .external_lex_state = 15},
  [502] = {.lex_state = 290, .external_lex_state = 16},
  [503] = {.lex_state = 192, .external_lex_state = 15},
  [504] = {.lex_state = 290, .external_lex_state = 16},
  [505] = {.lex_state = 190, .external_lex_state = 4},
  [506] = {.lex_state = 268, .external_lex_state = 15},
  [507] = {.lex_state = 290, .external_lex_state = 16},
  [508] = {.lex_state = 190, .external_lex_state = 4},
  [509] = {.lex_state = 268, .external_lex_state = 15},
  [510] = {.lex_state = 457},
  [511] = {.lex_state = 221, .external_lex_state = 2},
  [512] = {.lex_state = 177, .external_lex_state = 17},
  [513] = {.lex_state = 304, .external_lex_state = 16},
  [514] = {.lex_state = 459, .external_lex_state = 20},
  [515] = {.lex_state = 192, .external_lex_state = 2},
  [516] = {.lex_state = 290, .external_lex_state = 16},
  [517] = {.lex_state = 194},
  [518] = {.lex_state = 194, .external_lex_state = 19},
  [519] = {.lex_state = 192, .external_lex_state = 2},
  [520] = {.lex_state = 290, .external_lex_state = 16},
  [521] = {.lex_state = 312},
  [522] = {.lex_state = 312, .external_lex_state = 13},
  [523] = {.lex_state = 290, .external_lex_state = 16},
  [524] = {.lex_state = 209},
  [525] = {.lex_state = 306, .external_lex_state = 18},
  [526] = {.lex_state = 192, .external_lex_state = 2},
  [527] = {.lex_state = 197},
  [528] = {.lex_state = 462, .external_lex_state = 25},
  [529] = {.lex_state = 462, .external_lex_state = 25},
  [530] = {.lex_state = 462, .external_lex_state = 25},
  [531] = {.lex_state = 462, .external_lex_state = 25},
  [532] = {.lex_state = 192, .external_lex_state = 2},
  [533] = {.lex_state = 192, .external_lex_state = 2},
  [534] = {.lex_state = 465, .external_lex_state = 24},
  [535] = {.lex_state = 465, .external_lex_state = 24},
  [536] = {.lex_state = 465, .external_lex_state = 24},
  [537] = {.lex_state = 438, .external_lex_state = 24},
  [538] = {.lex_state = 468, .external_lex_state = 24},
  [539] = {.lex_state = 440, .external_lex_state = 25},
  [540] = {.lex_state = 213},
  [541] = {.lex_state = 443, .external_lex_state = 24},
  [542] = {.lex_state = 471, .external_lex_state = 26},
  [543] = {.lex_state = 192, .external_lex_state = 2},
  [544] = {.lex_state = 348, .external_lex_state = 22},
  [545] = {.lex_state = 348, .external_lex_state = 22},
  [546] = {.lex_state = 352, .external_lex_state = 22},
  [547] = {.lex_state = 352, .external_lex_state = 22},
  [548] = {.lex_state = 192, .external_lex_state = 2},
  [549] = {.lex_state = 192, .external_lex_state = 2},
  [550] = {.lex_state = 192, .external_lex_state = 2},
  [551] = {.lex_state = 239},
  [552] = {.lex_state = 192, .external_lex_state = 2},
  [553] = {.lex_state = 474, .external_lex_state = 25},
  [554] = {.lex_state = 474, .external_lex_state = 25},
  [555] = {.lex_state = 474, .external_lex_state = 25},
  [556] = {.lex_state = 474, .external_lex_state = 25},
  [557] = {.lex_state = 358, .external_lex_state = 12},
  [558] = {.lex_state = 192, .external_lex_state = 2},
  [559] = {.lex_state = 192, .external_lex_state = 2},
  [560] = {.lex_state = 298, .external_lex_state = 25},
  [561] = {.lex_state = 363, .external_lex_state = 24},
  [562] = {.lex_state = 306, .external_lex_state = 25},
  [563] = {.lex_state = 290, .external_lex_state = 16},
  [564] = {.lex_state = 307, .external_lex_state = 24},
  [565] = {.lex_state = 363, .external_lex_state = 24},
  [566] = {.lex_state = 213},
  [567] = {.lex_state = 370, .external_lex_state = 24},
  [568] = {.lex_state = 373, .external_lex_state = 26},
  [569] = {.lex_state = 290, .external_lex_state = 16},
  [570] = {.lex_state = 290, .external_lex_state = 16},
  [571] = {.lex_state = 290, .external_lex_state = 16},
  [572] = {.lex_state = 128, .external_lex_state = 13},
  [573] = {.lex_state = 128, .external_lex_state = 13},
  [574] = {.lex_state = 249, .external_lex_state = 3},
  [575] = {.lex_state = 249, .external_lex_state = 3},
  [576] = {.lex_state = 128},
  [577] = {.lex_state = 249, .external_lex_state = 3},
  [578] = {.lex_state = 128},
  [579] = {.lex_state = 128},
  [580] = {.lex_state = 128},
  [581] = {.lex_state = 128},
  [582] = {.lex_state = 128},
  [583] = {.lex_state = 290, .external_lex_state = 16},
  [584] = {.lex_state = 128, .external_lex_state = 2},
  [585] = {.lex_state = 304, .external_lex_state = 16},
  [586] = {.lex_state = 477, .external_lex_state = 16},
  [587] = {.lex_state = 192, .external_lex_state = 2},
  [588] = {.lex_state = 290, .external_lex_state = 16},
  [589] = {.lex_state = 290, .external_lex_state = 16},
  [590] = {.lex_state = 237},
  [591] = {.lex_state = 411, .external_lex_state = 2},
  [592] = {.lex_state = 416, .external_lex_state = 11},
  [593] = {.lex_state = 128},
  [594] = {.lex_state = 290, .external_lex_state = 16},
  [595] = {.lex_state = 192, .external_lex_state = 2},
  [596] = {.lex_state = 192, .external_lex_state = 2},
  [597] = {.lex_state = 192, .external_lex_state = 2},
  [598] = {.lex_state = 192, .external_lex_state = 2},
  [599] = {.lex_state = 192, .external_lex_state = 2},
  [600] = {.lex_state = 192, .external_lex_state = 2},
  [601] = {.lex_state = 192, .external_lex_state = 2},
  [602] = {.lex_state = 192, .external_lex_state = 2},
  [603] = {.lex_state = 192, .external_lex_state = 2},
  [604] = {.lex_state = 192, .external_lex_state = 2},
  [605] = {.lex_state = 418, .external_lex_state = 27},
  [606] = {.lex_state = 237, .external_lex_state = 12},
  [607] = {.lex_state = 197},
  [608] = {.lex_state = 399, .external_lex_state = 24},
  [609] = {.lex_state = 177, .external_lex_state = 4},
  [610] = {.lex_state = 177, .external_lex_state = 4},
  [611] = {.lex_state = 177, .external_lex_state = 4},
  [612] = {.lex_state = 177, .external_lex_state = 4},
  [613] = {.lex_state = 190, .external_lex_state = 4},
  [614] = {.lex_state = 190, .external_lex_state = 4},
  [615] = {.lex_state = 192, .external_lex_state = 2},
  [616] = {.lex_state = 192, .external_lex_state = 2},
  [617] = {.lex_state = 192, .external_lex_state = 2},
  [618] = {.lex_state = 239},
  [619] = {.lex_state = 421, .external_lex_state = 6},
  [620] = {.lex_state = 197, .external_lex_state = 7},
  [621] = {.lex_state = 209, .external_lex_state = 2},
  [622] = {.lex_state = 192, .external_lex_state = 2},
  [623] = {.lex_state = 216, .external_lex_state = 9},
  [624] = {.lex_state = 216, .external_lex_state = 8},
  [625] = {.lex_state = 306, .external_lex_state = 25},
  [626] = {.lex_state = 306, .external_lex_state = 25},
  [627] = {.lex_state = 306, .external_lex_state = 25},
  [628] = {.lex_state = 306, .external_lex_state = 25},
  [629] = {.lex_state = 221, .external_lex_state = 2},
  [630] = {.lex_state = 221, .external_lex_state = 2},
  [631] = {.lex_state = 192, .external_lex_state = 2},
  [632] = {.lex_state = 192, .external_lex_state = 2},
  [633] = {.lex_state = 223, .external_lex_state = 8},
  [634] = {.lex_state = 416, .external_lex_state = 11},
  [635] = {.lex_state = 225, .external_lex_state = 11},
  [636] = {.lex_state = 128, .external_lex_state = 11},
  [637] = {.lex_state = 358, .external_lex_state = 12},
  [638] = {.lex_state = 192, .external_lex_state = 2},
  [639] = {.lex_state = 192, .external_lex_state = 2},
  [640] = {.lex_state = 298, .external_lex_state = 25},
  [641] = {.lex_state = 399, .external_lex_state = 24},
  [642] = {.lex_state = 237, .external_lex_state = 12},
  [643] = {.lex_state = 239},
  [644] = {.lex_state = 423, .external_lex_state = 24},
  [645] = {.lex_state = 399, .external_lex_state = 24},
  [646] = {.lex_state = 306, .external_lex_state = 25},
  [647] = {.lex_state = 301, .external_lex_state = 16},
  [648] = {.lex_state = 423, .external_lex_state = 24},
  [649] = {.lex_state = 423, .external_lex_state = 24},
  [650] = {.lex_state = 301, .external_lex_state = 16},
  [651] = {.lex_state = 213},
  [652] = {.lex_state = 423, .external_lex_state = 24},
  [653] = {.lex_state = 429, .external_lex_state = 26},
  [654] = {.lex_state = 192, .external_lex_state = 28},
  [655] = {.lex_state = 192, .external_lex_state = 2},
  [656] = {.lex_state = 459, .external_lex_state = 20},
  [657] = {.lex_state = 156, .external_lex_state = 3},
  [658] = {.lex_state = 194},
  [659] = {.lex_state = 194, .external_lex_state = 6},
  [660] = {.lex_state = 449, .external_lex_state = 13},
  [661] = {.lex_state = 194},
  [662] = {.lex_state = 310, .external_lex_state = 13},
  [663] = {.lex_state = 192, .external_lex_state = 15},
  [664] = {.lex_state = 192, .external_lex_state = 2},
  [665] = {.lex_state = 479, .external_lex_state = 18},
  [666] = {.lex_state = 479, .external_lex_state = 18},
  [667] = {.lex_state = 479, .external_lex_state = 18},
  [668] = {.lex_state = 479, .external_lex_state = 18},
  [669] = {.lex_state = 192, .external_lex_state = 2},
  [670] = {.lex_state = 192, .external_lex_state = 2},
  [671] = {.lex_state = 304, .external_lex_state = 16},
  [672] = {.lex_state = 482, .external_lex_state = 18},
  [673] = {.lex_state = 213},
  [674] = {.lex_state = 323, .external_lex_state = 16},
  [675] = {.lex_state = 326, .external_lex_state = 20},
  [676] = {.lex_state = 310, .external_lex_state = 13},
  [677] = {.lex_state = 227, .external_lex_state = 7},
  [678] = {.lex_state = 413},
  [679] = {.lex_state = 256, .external_lex_state = 13},
  [680] = {.lex_state = 256, .external_lex_state = 13},
  [681] = {.lex_state = 128},
  [682] = {.lex_state = 485, .external_lex_state = 13},
  [683] = {.lex_state = 128, .external_lex_state = 2},
  [684] = {.lex_state = 256, .external_lex_state = 13},
  [685] = {.lex_state = 304, .external_lex_state = 3},
  [686] = {.lex_state = 323, .external_lex_state = 3},
  [687] = {.lex_state = 488, .external_lex_state = 12},
  [688] = {.lex_state = 192, .external_lex_state = 2},
  [689] = {.lex_state = 192, .external_lex_state = 2},
  [690] = {.lex_state = 192, .external_lex_state = 2},
  [691] = {.lex_state = 239},
  [692] = {.lex_state = 192, .external_lex_state = 2},
  [693] = {.lex_state = 491, .external_lex_state = 10},
  [694] = {.lex_state = 491, .external_lex_state = 10},
  [695] = {.lex_state = 491, .external_lex_state = 10},
  [696] = {.lex_state = 491, .external_lex_state = 10},
  [697] = {.lex_state = 192, .external_lex_state = 2},
  [698] = {.lex_state = 192, .external_lex_state = 2},
  [699] = {.lex_state = 494, .external_lex_state = 10},
  [700] = {.lex_state = 497, .external_lex_state = 3},
  [701] = {.lex_state = 500, .external_lex_state = 10},
  [702] = {.lex_state = 326, .external_lex_state = 3},
  [703] = {.lex_state = 497, .external_lex_state = 3},
  [704] = {.lex_state = 213},
  [705] = {.lex_state = 501, .external_lex_state = 3},
  [706] = {.lex_state = 497, .external_lex_state = 14},
  [707] = {.lex_state = 304, .external_lex_state = 3},
  [708] = {.lex_state = 304, .external_lex_state = 13},
  [709] = {.lex_state = 156, .external_lex_state = 3},
  [710] = {.lex_state = 192, .external_lex_state = 2},
  [711] = {.lex_state = 192, .external_lex_state = 2},
  [712] = {.lex_state = 192, .external_lex_state = 2},
  [713] = {.lex_state = 192, .external_lex_state = 2},
  [714] = {.lex_state = 192, .external_lex_state = 2},
  [715] = {.lex_state = 192, .external_lex_state = 2},
  [716] = {.lex_state = 192, .external_lex_state = 2},
  [717] = {.lex_state = 192, .external_lex_state = 2},
  [718] = {.lex_state = 192, .external_lex_state = 2},
  [719] = {.lex_state = 192, .external_lex_state = 2},
  [720] = {.lex_state = 192, .external_lex_state = 2},
  [721] = {.lex_state = 192, .external_lex_state = 2},
  [722] = {.lex_state = 192, .external_lex_state = 2},
  [723] = {.lex_state = 192, .external_lex_state = 2},
  [724] = {.lex_state = 192, .external_lex_state = 2},
  [725] = {.lex_state = 192, .external_lex_state = 2},
  [726] = {.lex_state = 192, .external_lex_state = 2},
  [727] = {.lex_state = 192, .external_lex_state = 2},
  [728] = {.lex_state = 239},
  [729] = {.lex_state = 192, .external_lex_state = 2},
  [730] = {.lex_state = 500, .external_lex_state = 10},
  [731] = {.lex_state = 500, .external_lex_state = 10},
  [732] = {.lex_state = 500, .external_lex_state = 10},
  [733] = {.lex_state = 500, .external_lex_state = 10},
  [734] = {.lex_state = 192, .external_lex_state = 2},
  [735] = {.lex_state = 192, .external_lex_state = 2},
  [736] = {.lex_state = 494, .external_lex_state = 10},
  [737] = {.lex_state = 501, .external_lex_state = 3},
  [738] = {.lex_state = 500, .external_lex_state = 10},
  [739] = {.lex_state = 323, .external_lex_state = 3},
  [740] = {.lex_state = 323, .external_lex_state = 3},
  [741] = {.lex_state = 213},
  [742] = {.lex_state = 501, .external_lex_state = 3},
  [743] = {.lex_state = 501, .external_lex_state = 14},
  [744] = {.lex_state = 192, .external_lex_state = 28},
  [745] = {.lex_state = 315},
  [746] = {.lex_state = 504, .external_lex_state = 8},
  [747] = {.lex_state = 315},
  [748] = {.lex_state = 192, .external_lex_state = 2},
  [749] = {.lex_state = 326, .external_lex_state = 14},
  [750] = {.lex_state = 209, .external_lex_state = 13},
  [751] = {.lex_state = 209, .external_lex_state = 2},
  [752] = {.lex_state = 345, .external_lex_state = 21},
  [753] = {.lex_state = 192, .external_lex_state = 15},
  [754] = {.lex_state = 332},
  [755] = {.lex_state = 192, .external_lex_state = 15},
  [756] = {.lex_state = 332},
  [757] = {.lex_state = 192, .external_lex_state = 15},
  [758] = {.lex_state = 332},
  [759] = {.lex_state = 192, .external_lex_state = 15},
  [760] = {.lex_state = 332},
  [761] = {.lex_state = 190, .external_lex_state = 4},
  [762] = {.lex_state = 268, .external_lex_state = 15},
  [763] = {.lex_state = 332},
  [764] = {.lex_state = 190, .external_lex_state = 4},
  [765] = {.lex_state = 268, .external_lex_state = 15},
  [766] = {.lex_state = 332},
  [767] = {.lex_state = 194},
  [768] = {.lex_state = 194, .external_lex_state = 19},
  [769] = {.lex_state = 192, .external_lex_state = 2},
  [770] = {.lex_state = 332},
  [771] = {.lex_state = 312},
  [772] = {.lex_state = 312, .external_lex_state = 13},
  [773] = {.lex_state = 332},
  [774] = {.lex_state = 209},
  [775] = {.lex_state = 488, .external_lex_state = 12},
  [776] = {.lex_state = 192, .external_lex_state = 2},
  [777] = {.lex_state = 348, .external_lex_state = 22},
  [778] = {.lex_state = 348, .external_lex_state = 22},
  [779] = {.lex_state = 352, .external_lex_state = 22},
  [780] = {.lex_state = 352, .external_lex_state = 22},
  [781] = {.lex_state = 192, .external_lex_state = 2},
  [782] = {.lex_state = 192, .external_lex_state = 2},
  [783] = {.lex_state = 239},
  [784] = {.lex_state = 192, .external_lex_state = 2},
  [785] = {.lex_state = 358, .external_lex_state = 12},
  [786] = {.lex_state = 298, .external_lex_state = 25},
  [787] = {.lex_state = 363, .external_lex_state = 24},
  [788] = {.lex_state = 332},
  [789] = {.lex_state = 336, .external_lex_state = 19},
  [790] = {.lex_state = 342, .external_lex_state = 19},
  [791] = {.lex_state = 373, .external_lex_state = 26},
  [792] = {.lex_state = 332},
  [793] = {.lex_state = 332},
  [794] = {.lex_state = 332},
  [795] = {.lex_state = 128, .external_lex_state = 13},
  [796] = {.lex_state = 128, .external_lex_state = 13},
  [797] = {.lex_state = 249, .external_lex_state = 3},
  [798] = {.lex_state = 249, .external_lex_state = 3},
  [799] = {.lex_state = 128},
  [800] = {.lex_state = 249, .external_lex_state = 3},
  [801] = {.lex_state = 128},
  [802] = {.lex_state = 128},
  [803] = {.lex_state = 128},
  [804] = {.lex_state = 128},
  [805] = {.lex_state = 128},
  [806] = {.lex_state = 332},
  [807] = {.lex_state = 128, .external_lex_state = 2},
  [808] = {.lex_state = 332},
  [809] = {.lex_state = 332},
  [810] = {.lex_state = 237},
  [811] = {.lex_state = 411, .external_lex_state = 2},
  [812] = {.lex_state = 416, .external_lex_state = 11},
  [813] = {.lex_state = 128},
  [814] = {.lex_state = 339},
  [815] = {.lex_state = 418, .external_lex_state = 27},
  [816] = {.lex_state = 237, .external_lex_state = 12},
  [817] = {.lex_state = 197},
  [818] = {.lex_state = 192, .external_lex_state = 2},
  [819] = {.lex_state = 192, .external_lex_state = 2},
  [820] = {.lex_state = 192, .external_lex_state = 2},
  [821] = {.lex_state = 239},
  [822] = {.lex_state = 421, .external_lex_state = 6},
  [823] = {.lex_state = 192, .external_lex_state = 2},
  [824] = {.lex_state = 506, .external_lex_state = 25},
  [825] = {.lex_state = 506, .external_lex_state = 25},
  [826] = {.lex_state = 506, .external_lex_state = 25},
  [827] = {.lex_state = 506, .external_lex_state = 25},
  [828] = {.lex_state = 192, .external_lex_state = 2},
  [829] = {.lex_state = 192, .external_lex_state = 2},
  [830] = {.lex_state = 298, .external_lex_state = 25},
  [831] = {.lex_state = 509, .external_lex_state = 24},
  [832] = {.lex_state = 339},
  [833] = {.lex_state = 342, .external_lex_state = 19},
  [834] = {.lex_state = 342, .external_lex_state = 19},
  [835] = {.lex_state = 339},
  [836] = {.lex_state = 213},
  [837] = {.lex_state = 423, .external_lex_state = 24},
  [838] = {.lex_state = 509, .external_lex_state = 26},
  [839] = {.lex_state = 345, .external_lex_state = 21},
  [840] = {.lex_state = 249, .external_lex_state = 3},
  [841] = {.lex_state = 348, .external_lex_state = 22},
  [842] = {.lex_state = 192, .external_lex_state = 2},
  [843] = {.lex_state = 128, .external_lex_state = 13},
  [844] = {.lex_state = 128, .external_lex_state = 2},
  [845] = {.lex_state = 197},
  [846] = {.lex_state = 192, .external_lex_state = 2},
  [847] = {.lex_state = 192, .external_lex_state = 2},
  [848] = {.lex_state = 192, .external_lex_state = 2},
  [849] = {.lex_state = 239},
  [850] = {.lex_state = 421, .external_lex_state = 6},
  [851] = {.lex_state = 192, .external_lex_state = 2},
  [852] = {.lex_state = 474, .external_lex_state = 25},
  [853] = {.lex_state = 474, .external_lex_state = 25},
  [854] = {.lex_state = 474, .external_lex_state = 25},
  [855] = {.lex_state = 474, .external_lex_state = 25},
  [856] = {.lex_state = 192, .external_lex_state = 2},
  [857] = {.lex_state = 192, .external_lex_state = 2},
  [858] = {.lex_state = 298, .external_lex_state = 25},
  [859] = {.lex_state = 512, .external_lex_state = 24},
  [860] = {.lex_state = 336, .external_lex_state = 19},
  [861] = {.lex_state = 342, .external_lex_state = 19},
  [862] = {.lex_state = 213},
  [863] = {.lex_state = 423, .external_lex_state = 24},
  [864] = {.lex_state = 512, .external_lex_state = 26},
  [865] = {.lex_state = 156, .external_lex_state = 3},
  [866] = {.lex_state = 128, .external_lex_state = 2},
  [867] = {.lex_state = 192, .external_lex_state = 2},
  [868] = {.lex_state = 515, .external_lex_state = 10},
  [869] = {.lex_state = 515, .external_lex_state = 10},
  [870] = {.lex_state = 515, .external_lex_state = 10},
  [871] = {.lex_state = 515, .external_lex_state = 10},
  [872] = {.lex_state = 192, .external_lex_state = 2},
  [873] = {.lex_state = 192, .external_lex_state = 2},
  [874] = {.lex_state = 367, .external_lex_state = 3},
  [875] = {.lex_state = 213},
  [876] = {.lex_state = 261, .external_lex_state = 3},
  [877] = {.lex_state = 367, .external_lex_state = 14},
  [878] = {.lex_state = 367, .external_lex_state = 3},
  [879] = {.lex_state = 363, .external_lex_state = 3},
  [880] = {.lex_state = 363, .external_lex_state = 14},
  [881] = {.lex_state = 192, .external_lex_state = 2},
  [882] = {.lex_state = 518, .external_lex_state = 10},
  [883] = {.lex_state = 367, .external_lex_state = 3},
  [884] = {.lex_state = 192, .external_lex_state = 2},
  [885] = {.lex_state = 192, .external_lex_state = 2},
  [886] = {.lex_state = 239},
  [887] = {.lex_state = 192, .external_lex_state = 2},
  [888] = {.lex_state = 360, .external_lex_state = 10},
  [889] = {.lex_state = 363, .external_lex_state = 3},
  [890] = {.lex_state = 363, .external_lex_state = 3},
  [891] = {.lex_state = 363, .external_lex_state = 3},
  [892] = {.lex_state = 373, .external_lex_state = 14},
  [893] = {.lex_state = 192, .external_lex_state = 2},
  [894] = {.lex_state = 192, .external_lex_state = 2},
  [895] = {.lex_state = 192, .external_lex_state = 2},
  [896] = {.lex_state = 239},
  [897] = {.lex_state = 156, .external_lex_state = 3},
  [898] = {.lex_state = 192, .external_lex_state = 2},
  [899] = {.lex_state = 521, .external_lex_state = 25},
  [900] = {.lex_state = 521, .external_lex_state = 25},
  [901] = {.lex_state = 521, .external_lex_state = 25},
  [902] = {.lex_state = 521, .external_lex_state = 25},
  [903] = {.lex_state = 192, .external_lex_state = 2},
  [904] = {.lex_state = 192, .external_lex_state = 2},
  [905] = {.lex_state = 524, .external_lex_state = 25},
  [906] = {.lex_state = 304, .external_lex_state = 24},
  [907] = {.lex_state = 527, .external_lex_state = 25},
  [908] = {.lex_state = 209},
  [909] = {.lex_state = 304, .external_lex_state = 19},
  [910] = {.lex_state = 213},
  [911] = {.lex_state = 501, .external_lex_state = 24},
  [912] = {.lex_state = 497, .external_lex_state = 26},
  [913] = {.lex_state = 363, .external_lex_state = 3},
  [914] = {.lex_state = 156, .external_lex_state = 3},
  [915] = {.lex_state = 192, .external_lex_state = 2},
  [916] = {.lex_state = 192, .external_lex_state = 2},
  [917] = {.lex_state = 192, .external_lex_state = 2},
  [918] = {.lex_state = 192, .external_lex_state = 2},
  [919] = {.lex_state = 192, .external_lex_state = 2},
  [920] = {.lex_state = 192, .external_lex_state = 2},
  [921] = {.lex_state = 192, .external_lex_state = 2},
  [922] = {.lex_state = 192, .external_lex_state = 2},
  [923] = {.lex_state = 192, .external_lex_state = 2},
  [924] = {.lex_state = 192, .external_lex_state = 2},
  [925] = {.lex_state = 192, .external_lex_state = 2},
  [926] = {.lex_state = 418, .external_lex_state = 27},
  [927] = {.lex_state = 237, .external_lex_state = 12},
  [928] = {.lex_state = 197},
  [929] = {.lex_state = 192, .external_lex_state = 2},
  [930] = {.lex_state = 192, .external_lex_state = 2},
  [931] = {.lex_state = 239},
  [932] = {.lex_state = 421, .external_lex_state = 6},
  [933] = {.lex_state = 192, .external_lex_state = 2},
  [934] = {.lex_state = 416, .external_lex_state = 11},
  [935] = {.lex_state = 358, .external_lex_state = 12},
  [936] = {.lex_state = 360, .external_lex_state = 10},
  [937] = {.lex_state = 423, .external_lex_state = 3},
  [938] = {.lex_state = 301, .external_lex_state = 3},
  [939] = {.lex_state = 423, .external_lex_state = 3},
  [940] = {.lex_state = 423, .external_lex_state = 3},
  [941] = {.lex_state = 301, .external_lex_state = 3},
  [942] = {.lex_state = 429, .external_lex_state = 14},
  [943] = {.lex_state = 177, .external_lex_state = 17},
  [944] = {.lex_state = 264, .external_lex_state = 3},
  [945] = {.lex_state = 528, .external_lex_state = 29},
  [946] = {.lex_state = 367, .external_lex_state = 3},
  [947] = {.lex_state = 192, .external_lex_state = 28},
  [948] = {.lex_state = 192, .external_lex_state = 2},
  [949] = {.lex_state = 363, .external_lex_state = 14},
  [950] = {.lex_state = 249, .external_lex_state = 3},
  [951] = {.lex_state = 192, .external_lex_state = 2},
  [952] = {.lex_state = 192, .external_lex_state = 2},
  [953] = {.lex_state = 192, .external_lex_state = 2},
  [954] = {.lex_state = 239},
  [955] = {.lex_state = 192, .external_lex_state = 2},
  [956] = {.lex_state = 355, .external_lex_state = 10},
  [957] = {.lex_state = 355, .external_lex_state = 10},
  [958] = {.lex_state = 355, .external_lex_state = 10},
  [959] = {.lex_state = 355, .external_lex_state = 10},
  [960] = {.lex_state = 192, .external_lex_state = 2},
  [961] = {.lex_state = 192, .external_lex_state = 2},
  [962] = {.lex_state = 360, .external_lex_state = 10},
  [963] = {.lex_state = 363, .external_lex_state = 3},
  [964] = {.lex_state = 366, .external_lex_state = 10},
  [965] = {.lex_state = 264, .external_lex_state = 3},
  [966] = {.lex_state = 363, .external_lex_state = 3},
  [967] = {.lex_state = 213},
  [968] = {.lex_state = 370, .external_lex_state = 3},
  [969] = {.lex_state = 373, .external_lex_state = 14},
  [970] = {.lex_state = 249, .external_lex_state = 3},
  [971] = {.lex_state = 256, .external_lex_state = 13},
  [972] = {.lex_state = 192, .external_lex_state = 2},
  [973] = {.lex_state = 192, .external_lex_state = 2},
  [974] = {.lex_state = 192, .external_lex_state = 2},
  [975] = {.lex_state = 192, .external_lex_state = 2},
  [976] = {.lex_state = 192, .external_lex_state = 2},
  [977] = {.lex_state = 128, .external_lex_state = 2},
  [978] = {.lex_state = 128},
  [979] = {.lex_state = 128, .external_lex_state = 2},
  [980] = {.lex_state = 192, .external_lex_state = 2},
  [981] = {.lex_state = 192, .external_lex_state = 2},
  [982] = {.lex_state = 192, .external_lex_state = 2},
  [983] = {.lex_state = 192, .external_lex_state = 2},
  [984] = {.lex_state = 192, .external_lex_state = 2},
  [985] = {.lex_state = 192, .external_lex_state = 2},
  [986] = {.lex_state = 192, .external_lex_state = 2},
  [987] = {.lex_state = 192, .external_lex_state = 2},
  [988] = {.lex_state = 192, .external_lex_state = 2},
  [989] = {.lex_state = 192, .external_lex_state = 2},
  [990] = {.lex_state = 192, .external_lex_state = 2},
  [991] = {.lex_state = 192, .external_lex_state = 2},
  [992] = {.lex_state = 192, .external_lex_state = 2},
  [993] = {.lex_state = 239},
  [994] = {.lex_state = 192, .external_lex_state = 2},
  [995] = {.lex_state = 366, .external_lex_state = 10},
  [996] = {.lex_state = 366, .external_lex_state = 10},
  [997] = {.lex_state = 366, .external_lex_state = 10},
  [998] = {.lex_state = 366, .external_lex_state = 10},
  [999] = {.lex_state = 192, .external_lex_state = 2},
  [1000] = {.lex_state = 192, .external_lex_state = 2},
  [1001] = {.lex_state = 360, .external_lex_state = 10},
  [1002] = {.lex_state = 423, .external_lex_state = 3},
  [1003] = {.lex_state = 366, .external_lex_state = 10},
  [1004] = {.lex_state = 426, .external_lex_state = 3},
  [1005] = {.lex_state = 426, .external_lex_state = 3},
  [1006] = {.lex_state = 213},
  [1007] = {.lex_state = 423, .external_lex_state = 3},
  [1008] = {.lex_state = 429, .external_lex_state = 14},
  [1009] = {.lex_state = 192, .external_lex_state = 28},
  [1010] = {.lex_state = 192, .external_lex_state = 2},
  [1011] = {.lex_state = 264, .external_lex_state = 14},
  [1012] = {.lex_state = 128, .external_lex_state = 2},
  [1013] = {.lex_state = 128},
  [1014] = {.lex_state = 128, .external_lex_state = 2},
  [1015] = {.lex_state = 249, .external_lex_state = 3},
  [1016] = {.lex_state = 192, .external_lex_state = 2},
  [1017] = {.lex_state = 192, .external_lex_state = 2},
  [1018] = {.lex_state = 192, .external_lex_state = 2},
  [1019] = {.lex_state = 239},
  [1020] = {.lex_state = 192, .external_lex_state = 2},
  [1021] = {.lex_state = 355, .external_lex_state = 10},
  [1022] = {.lex_state = 355, .external_lex_state = 10},
  [1023] = {.lex_state = 355, .external_lex_state = 10},
  [1024] = {.lex_state = 355, .external_lex_state = 10},
  [1025] = {.lex_state = 192, .external_lex_state = 2},
  [1026] = {.lex_state = 192, .external_lex_state = 2},
  [1027] = {.lex_state = 360, .external_lex_state = 10},
  [1028] = {.lex_state = 363, .external_lex_state = 3},
  [1029] = {.lex_state = 366, .external_lex_state = 10},
  [1030] = {.lex_state = 264, .external_lex_state = 3},
  [1031] = {.lex_state = 363, .external_lex_state = 3},
  [1032] = {.lex_state = 213},
  [1033] = {.lex_state = 370, .external_lex_state = 3},
  [1034] = {.lex_state = 373, .external_lex_state = 14},
  [1035] = {.lex_state = 249, .external_lex_state = 3},
  [1036] = {.lex_state = 192, .external_lex_state = 2},
  [1037] = {.lex_state = 192, .external_lex_state = 2},
  [1038] = {.lex_state = 192, .external_lex_state = 2},
  [1039] = {.lex_state = 192, .external_lex_state = 2},
  [1040] = {.lex_state = 192, .external_lex_state = 2},
  [1041] = {.lex_state = 192, .external_lex_state = 2},
  [1042] = {.lex_state = 192, .external_lex_state = 2},
  [1043] = {.lex_state = 192, .external_lex_state = 2},
  [1044] = {.lex_state = 192, .external_lex_state = 2},
  [1045] = {.lex_state = 192, .external_lex_state = 2},
  [1046] = {.lex_state = 128, .external_lex_state = 2},
  [1047] = {.lex_state = 192, .external_lex_state = 2},
  [1048] = {.lex_state = 192, .external_lex_state = 2},
  [1049] = {.lex_state = 192, .external_lex_state = 2},
  [1050] = {.lex_state = 239},
  [1051] = {.lex_state = 421, .external_lex_state = 6},
  [1052] = {.lex_state = 192, .external_lex_state = 2},
  [1053] = {.lex_state = 366, .external_lex_state = 10},
  [1054] = {.lex_state = 366, .external_lex_state = 10},
  [1055] = {.lex_state = 366, .external_lex_state = 10},
  [1056] = {.lex_state = 366, .external_lex_state = 10},
  [1057] = {.lex_state = 192, .external_lex_state = 2},
  [1058] = {.lex_state = 192, .external_lex_state = 2},
  [1059] = {.lex_state = 360, .external_lex_state = 10},
  [1060] = {.lex_state = 423, .external_lex_state = 3},
  [1061] = {.lex_state = 366, .external_lex_state = 10},
  [1062] = {.lex_state = 229, .external_lex_state = 3},
  [1063] = {.lex_state = 426, .external_lex_state = 3},
  [1064] = {.lex_state = 426, .external_lex_state = 3},
  [1065] = {.lex_state = 213},
  [1066] = {.lex_state = 423, .external_lex_state = 3},
  [1067] = {.lex_state = 429, .external_lex_state = 14},
  [1068] = {.lex_state = 192, .external_lex_state = 28},
  [1069] = {.lex_state = 192, .external_lex_state = 2},
  [1070] = {.lex_state = 264, .external_lex_state = 14},
  [1071] = {.lex_state = 128, .external_lex_state = 2},
  [1072] = {.lex_state = 192, .external_lex_state = 2},
  [1073] = {.lex_state = 192, .external_lex_state = 2},
  [1074] = {.lex_state = 192, .external_lex_state = 2},
  [1075] = {.lex_state = 239},
  [1076] = {.lex_state = 192, .external_lex_state = 2},
  [1077] = {.lex_state = 474, .external_lex_state = 25},
  [1078] = {.lex_state = 474, .external_lex_state = 25},
  [1079] = {.lex_state = 474, .external_lex_state = 25},
  [1080] = {.lex_state = 474, .external_lex_state = 25},
  [1081] = {.lex_state = 192, .external_lex_state = 2},
  [1082] = {.lex_state = 192, .external_lex_state = 2},
  [1083] = {.lex_state = 298, .external_lex_state = 25},
  [1084] = {.lex_state = 512, .external_lex_state = 24},
  [1085] = {.lex_state = 306, .external_lex_state = 25},
  [1086] = {.lex_state = 342, .external_lex_state = 19},
  [1087] = {.lex_state = 342, .external_lex_state = 19},
  [1088] = {.lex_state = 213},
  [1089] = {.lex_state = 423, .external_lex_state = 24},
  [1090] = {.lex_state = 512, .external_lex_state = 26},
  [1091] = {.lex_state = 192, .external_lex_state = 2},
  [1092] = {.lex_state = 128, .external_lex_state = 13},
  [1093] = {.lex_state = 223, .external_lex_state = 8},
  [1094] = {.lex_state = 156},
  [1095] = {.lex_state = 249, .external_lex_state = 3},
  [1096] = {.lex_state = 192, .external_lex_state = 2},
  [1097] = {.lex_state = 192, .external_lex_state = 2},
  [1098] = {.lex_state = 192, .external_lex_state = 2},
  [1099] = {.lex_state = 239},
  [1100] = {.lex_state = 192, .external_lex_state = 2},
  [1101] = {.lex_state = 355, .external_lex_state = 10},
  [1102] = {.lex_state = 355, .external_lex_state = 10},
  [1103] = {.lex_state = 355, .external_lex_state = 10},
  [1104] = {.lex_state = 355, .external_lex_state = 10},
  [1105] = {.lex_state = 192, .external_lex_state = 2},
  [1106] = {.lex_state = 192, .external_lex_state = 2},
  [1107] = {.lex_state = 360, .external_lex_state = 10},
  [1108] = {.lex_state = 363, .external_lex_state = 3},
  [1109] = {.lex_state = 366, .external_lex_state = 10},
  [1110] = {.lex_state = 264, .external_lex_state = 3},
  [1111] = {.lex_state = 363, .external_lex_state = 3},
  [1112] = {.lex_state = 213},
  [1113] = {.lex_state = 370, .external_lex_state = 3},
  [1114] = {.lex_state = 373, .external_lex_state = 14},
  [1115] = {.lex_state = 249, .external_lex_state = 3},
  [1116] = {.lex_state = 192, .external_lex_state = 2},
  [1117] = {.lex_state = 192, .external_lex_state = 2},
  [1118] = {.lex_state = 192, .external_lex_state = 2},
  [1119] = {.lex_state = 192, .external_lex_state = 2},
  [1120] = {.lex_state = 192, .external_lex_state = 2},
  [1121] = {.lex_state = 192, .external_lex_state = 2},
  [1122] = {.lex_state = 192, .external_lex_state = 2},
  [1123] = {.lex_state = 192, .external_lex_state = 2},
  [1124] = {.lex_state = 192, .external_lex_state = 2},
  [1125] = {.lex_state = 192, .external_lex_state = 2},
  [1126] = {.lex_state = 128},
  [1127] = {.lex_state = 192, .external_lex_state = 28},
  [1128] = {.lex_state = 192, .external_lex_state = 2},
  [1129] = {.lex_state = 264, .external_lex_state = 14},
  [1130] = {.lex_state = 156, .external_lex_state = 3},
  [1131] = {.lex_state = 192, .external_lex_state = 28},
  [1132] = {.lex_state = 128, .external_lex_state = 11},
  [1133] = {.lex_state = 128},
  [1134] = {.lex_state = 128},
  [1135] = {.lex_state = 128},
  [1136] = {.lex_state = 530, .external_lex_state = 2},
  [1137] = {.lex_state = 177, .external_lex_state = 17},
  [1138] = {.lex_state = 249, .external_lex_state = 3},
  [1139] = {.lex_state = 192, .external_lex_state = 2},
  [1140] = {.lex_state = 192, .external_lex_state = 2},
  [1141] = {.lex_state = 192, .external_lex_state = 2},
  [1142] = {.lex_state = 239},
  [1143] = {.lex_state = 192, .external_lex_state = 2},
  [1144] = {.lex_state = 355, .external_lex_state = 10},
  [1145] = {.lex_state = 355, .external_lex_state = 10},
  [1146] = {.lex_state = 355, .external_lex_state = 10},
  [1147] = {.lex_state = 355, .external_lex_state = 10},
  [1148] = {.lex_state = 192, .external_lex_state = 2},
  [1149] = {.lex_state = 192, .external_lex_state = 2},
  [1150] = {.lex_state = 360, .external_lex_state = 10},
  [1151] = {.lex_state = 363, .external_lex_state = 3},
  [1152] = {.lex_state = 366, .external_lex_state = 10},
  [1153] = {.lex_state = 264, .external_lex_state = 3},
  [1154] = {.lex_state = 363, .external_lex_state = 3},
  [1155] = {.lex_state = 213},
  [1156] = {.lex_state = 370, .external_lex_state = 3},
  [1157] = {.lex_state = 373, .external_lex_state = 14},
  [1158] = {.lex_state = 192, .external_lex_state = 2},
  [1159] = {.lex_state = 192, .external_lex_state = 2},
  [1160] = {.lex_state = 355, .external_lex_state = 10},
  [1161] = {.lex_state = 355, .external_lex_state = 10},
  [1162] = {.lex_state = 355, .external_lex_state = 10},
  [1163] = {.lex_state = 355, .external_lex_state = 10},
  [1164] = {.lex_state = 128, .external_lex_state = 2},
  [1165] = {.lex_state = 216, .external_lex_state = 8},
  [1166] = {.lex_state = 192, .external_lex_state = 2},
  [1167] = {.lex_state = 192, .external_lex_state = 2},
  [1168] = {.lex_state = 128},
  [1169] = {.lex_state = 307, .external_lex_state = 13},
  [1170] = {.lex_state = 128, .external_lex_state = 13},
  [1171] = {.lex_state = 532, .external_lex_state = 3},
  [1172] = {.lex_state = 366, .external_lex_state = 10},
  [1173] = {.lex_state = 355, .external_lex_state = 13},
  [1174] = {.lex_state = 213},
  [1175] = {.lex_state = 370, .external_lex_state = 3},
  [1176] = {.lex_state = 363, .external_lex_state = 14},
  [1177] = {.lex_state = 128, .external_lex_state = 2},
  [1178] = {.lex_state = 192, .external_lex_state = 2},
  [1179] = {.lex_state = 218, .external_lex_state = 10},
  [1180] = {.lex_state = 218, .external_lex_state = 10},
  [1181] = {.lex_state = 218, .external_lex_state = 10},
  [1182] = {.lex_state = 218, .external_lex_state = 10},
  [1183] = {.lex_state = 192, .external_lex_state = 2},
  [1184] = {.lex_state = 192, .external_lex_state = 2},
  [1185] = {.lex_state = 227, .external_lex_state = 7},
  [1186] = {.lex_state = 128},
  [1187] = {.lex_state = 128, .external_lex_state = 13},
  [1188] = {.lex_state = 249, .external_lex_state = 3},
  [1189] = {.lex_state = 256, .external_lex_state = 10},
  [1190] = {.lex_state = 213},
  [1191] = {.lex_state = 261, .external_lex_state = 3},
  [1192] = {.lex_state = 264, .external_lex_state = 14},
  [1193] = {.lex_state = 128, .external_lex_state = 2},
  [1194] = {.lex_state = 128, .external_lex_state = 2},
  [1195] = {.lex_state = 192, .external_lex_state = 2},
  [1196] = {.lex_state = 218, .external_lex_state = 10},
  [1197] = {.lex_state = 218, .external_lex_state = 10},
  [1198] = {.lex_state = 218, .external_lex_state = 10},
  [1199] = {.lex_state = 218, .external_lex_state = 10},
  [1200] = {.lex_state = 192, .external_lex_state = 2},
  [1201] = {.lex_state = 192, .external_lex_state = 2},
  [1202] = {.lex_state = 227, .external_lex_state = 7},
  [1203] = {.lex_state = 128},
  [1204] = {.lex_state = 128, .external_lex_state = 13},
  [1205] = {.lex_state = 249, .external_lex_state = 3},
  [1206] = {.lex_state = 256, .external_lex_state = 10},
  [1207] = {.lex_state = 213},
  [1208] = {.lex_state = 261, .external_lex_state = 3},
  [1209] = {.lex_state = 264, .external_lex_state = 14},
  [1210] = {.lex_state = 128, .external_lex_state = 2},
  [1211] = {.lex_state = 249, .external_lex_state = 3},
  [1212] = {.lex_state = 256, .external_lex_state = 13},
  [1213] = {.lex_state = 156, .external_lex_state = 3},
  [1214] = {.lex_state = 128},
  [1215] = {.lex_state = 128},
  [1216] = {.lex_state = 128},
  [1217] = {.lex_state = 192, .external_lex_state = 2},
  [1218] = {.lex_state = 192, .external_lex_state = 2},
  [1219] = {.lex_state = 192, .external_lex_state = 2},
  [1220] = {.lex_state = 192, .external_lex_state = 2},
  [1221] = {.lex_state = 192, .external_lex_state = 2},
  [1222] = {.lex_state = 192, .external_lex_state = 2},
  [1223] = {.lex_state = 192, .external_lex_state = 2},
  [1224] = {.lex_state = 192, .external_lex_state = 2},
  [1225] = {.lex_state = 192, .external_lex_state = 2},
  [1226] = {.lex_state = 192, .external_lex_state = 2},
  [1227] = {.lex_state = 192, .external_lex_state = 2},
  [1228] = {.lex_state = 192, .external_lex_state = 2},
  [1229] = {.lex_state = 192, .external_lex_state = 2},
  [1230] = {.lex_state = 192, .external_lex_state = 2},
  [1231] = {.lex_state = 192, .external_lex_state = 2},
  [1232] = {.lex_state = 192, .external_lex_state = 2},
  [1233] = {.lex_state = 192, .external_lex_state = 2},
  [1234] = {.lex_state = 192, .external_lex_state = 2},
  [1235] = {.lex_state = 239},
  [1236] = {.lex_state = 192, .external_lex_state = 2},
  [1237] = {.lex_state = 366, .external_lex_state = 10},
  [1238] = {.lex_state = 366, .external_lex_state = 10},
  [1239] = {.lex_state = 366, .external_lex_state = 10},
  [1240] = {.lex_state = 366, .external_lex_state = 10},
  [1241] = {.lex_state = 192, .external_lex_state = 2},
  [1242] = {.lex_state = 192, .external_lex_state = 2},
  [1243] = {.lex_state = 360, .external_lex_state = 10},
  [1244] = {.lex_state = 423, .external_lex_state = 3},
  [1245] = {.lex_state = 366, .external_lex_state = 10},
  [1246] = {.lex_state = 426, .external_lex_state = 3},
  [1247] = {.lex_state = 426, .external_lex_state = 3},
  [1248] = {.lex_state = 213},
  [1249] = {.lex_state = 423, .external_lex_state = 3},
  [1250] = {.lex_state = 429, .external_lex_state = 14},
  [1251] = {.lex_state = 192, .external_lex_state = 28},
  [1252] = {.lex_state = 192, .external_lex_state = 2},
  [1253] = {.lex_state = 264, .external_lex_state = 14},
  [1254] = {.lex_state = 156, .external_lex_state = 3},
  [1255] = {.lex_state = 128, .external_lex_state = 13},
  [1256] = {.lex_state = 128, .external_lex_state = 2},
  [1257] = {.lex_state = 227, .external_lex_state = 7},
  [1258] = {.lex_state = 386, .external_lex_state = 13},
  [1259] = {.lex_state = 227, .external_lex_state = 7},
  [1260] = {.lex_state = 192, .external_lex_state = 15},
  [1261] = {.lex_state = 227, .external_lex_state = 7},
  [1262] = {.lex_state = 449, .external_lex_state = 13},
  [1263] = {.lex_state = 534, .external_lex_state = 26},
  [1264] = {.lex_state = 192, .external_lex_state = 15},
  [1265] = {.lex_state = 390, .external_lex_state = 24},
  [1266] = {.lex_state = 192, .external_lex_state = 15},
  [1267] = {.lex_state = 390, .external_lex_state = 24},
  [1268] = {.lex_state = 192, .external_lex_state = 15},
  [1269] = {.lex_state = 390, .external_lex_state = 24},
  [1270] = {.lex_state = 192, .external_lex_state = 15},
  [1271] = {.lex_state = 390, .external_lex_state = 24},
  [1272] = {.lex_state = 190, .external_lex_state = 4},
  [1273] = {.lex_state = 268, .external_lex_state = 15},
  [1274] = {.lex_state = 390, .external_lex_state = 24},
  [1275] = {.lex_state = 190, .external_lex_state = 4},
  [1276] = {.lex_state = 268, .external_lex_state = 15},
  [1277] = {.lex_state = 192, .external_lex_state = 2},
  [1278] = {.lex_state = 535, .external_lex_state = 25},
  [1279] = {.lex_state = 535, .external_lex_state = 25},
  [1280] = {.lex_state = 535, .external_lex_state = 25},
  [1281] = {.lex_state = 535, .external_lex_state = 25},
  [1282] = {.lex_state = 192, .external_lex_state = 2},
  [1283] = {.lex_state = 192, .external_lex_state = 2},
  [1284] = {.lex_state = 402, .external_lex_state = 24},
  [1285] = {.lex_state = 538, .external_lex_state = 25},
  [1286] = {.lex_state = 213},
  [1287] = {.lex_state = 541, .external_lex_state = 24},
  [1288] = {.lex_state = 544, .external_lex_state = 26},
  [1289] = {.lex_state = 402, .external_lex_state = 24},
  [1290] = {.lex_state = 402, .external_lex_state = 24},
  [1291] = {.lex_state = 547, .external_lex_state = 26},
  [1292] = {.lex_state = 192, .external_lex_state = 2},
  [1293] = {.lex_state = 390, .external_lex_state = 24},
  [1294] = {.lex_state = 194},
  [1295] = {.lex_state = 194, .external_lex_state = 19},
  [1296] = {.lex_state = 192, .external_lex_state = 2},
  [1297] = {.lex_state = 390, .external_lex_state = 24},
  [1298] = {.lex_state = 312},
  [1299] = {.lex_state = 312, .external_lex_state = 13},
  [1300] = {.lex_state = 390, .external_lex_state = 24},
  [1301] = {.lex_state = 209},
  [1302] = {.lex_state = 548, .external_lex_state = 25},
  [1303] = {.lex_state = 402, .external_lex_state = 24},
  [1304] = {.lex_state = 192, .external_lex_state = 2},
  [1305] = {.lex_state = 348, .external_lex_state = 22},
  [1306] = {.lex_state = 348, .external_lex_state = 22},
  [1307] = {.lex_state = 352, .external_lex_state = 22},
  [1308] = {.lex_state = 352, .external_lex_state = 22},
  [1309] = {.lex_state = 192, .external_lex_state = 2},
  [1310] = {.lex_state = 192, .external_lex_state = 2},
  [1311] = {.lex_state = 192, .external_lex_state = 2},
  [1312] = {.lex_state = 239},
  [1313] = {.lex_state = 192, .external_lex_state = 2},
  [1314] = {.lex_state = 192, .external_lex_state = 2},
  [1315] = {.lex_state = 192, .external_lex_state = 2},
  [1316] = {.lex_state = 396, .external_lex_state = 25},
  [1317] = {.lex_state = 408, .external_lex_state = 24},
  [1318] = {.lex_state = 390, .external_lex_state = 24},
  [1319] = {.lex_state = 408, .external_lex_state = 24},
  [1320] = {.lex_state = 408, .external_lex_state = 24},
  [1321] = {.lex_state = 213},
  [1322] = {.lex_state = 405, .external_lex_state = 24},
  [1323] = {.lex_state = 408, .external_lex_state = 26},
  [1324] = {.lex_state = 390, .external_lex_state = 24},
  [1325] = {.lex_state = 390, .external_lex_state = 24},
  [1326] = {.lex_state = 390, .external_lex_state = 24},
  [1327] = {.lex_state = 128, .external_lex_state = 13},
  [1328] = {.lex_state = 128, .external_lex_state = 13},
  [1329] = {.lex_state = 249, .external_lex_state = 3},
  [1330] = {.lex_state = 249, .external_lex_state = 3},
  [1331] = {.lex_state = 128},
  [1332] = {.lex_state = 249, .external_lex_state = 3},
  [1333] = {.lex_state = 128},
  [1334] = {.lex_state = 128},
  [1335] = {.lex_state = 128},
  [1336] = {.lex_state = 128},
  [1337] = {.lex_state = 128},
  [1338] = {.lex_state = 390, .external_lex_state = 24},
  [1339] = {.lex_state = 128, .external_lex_state = 2},
  [1340] = {.lex_state = 402, .external_lex_state = 24},
  [1341] = {.lex_state = 551, .external_lex_state = 24},
  [1342] = {.lex_state = 192, .external_lex_state = 2},
  [1343] = {.lex_state = 390, .external_lex_state = 24},
  [1344] = {.lex_state = 390, .external_lex_state = 24},
  [1345] = {.lex_state = 237},
  [1346] = {.lex_state = 411, .external_lex_state = 2},
  [1347] = {.lex_state = 416, .external_lex_state = 11},
  [1348] = {.lex_state = 128},
  [1349] = {.lex_state = 390, .external_lex_state = 24},
  [1350] = {.lex_state = 192, .external_lex_state = 2},
  [1351] = {.lex_state = 192, .external_lex_state = 2},
  [1352] = {.lex_state = 192, .external_lex_state = 2},
  [1353] = {.lex_state = 192, .external_lex_state = 2},
  [1354] = {.lex_state = 192, .external_lex_state = 2},
  [1355] = {.lex_state = 192, .external_lex_state = 2},
  [1356] = {.lex_state = 192, .external_lex_state = 2},
  [1357] = {.lex_state = 192, .external_lex_state = 2},
  [1358] = {.lex_state = 192, .external_lex_state = 2},
  [1359] = {.lex_state = 192, .external_lex_state = 2},
  [1360] = {.lex_state = 418, .external_lex_state = 27},
  [1361] = {.lex_state = 237, .external_lex_state = 12},
  [1362] = {.lex_state = 197},
  [1363] = {.lex_state = 192, .external_lex_state = 2},
  [1364] = {.lex_state = 192, .external_lex_state = 2},
  [1365] = {.lex_state = 192, .external_lex_state = 2},
  [1366] = {.lex_state = 239},
  [1367] = {.lex_state = 421, .external_lex_state = 6},
  [1368] = {.lex_state = 192, .external_lex_state = 2},
  [1369] = {.lex_state = 404, .external_lex_state = 25},
  [1370] = {.lex_state = 404, .external_lex_state = 25},
  [1371] = {.lex_state = 404, .external_lex_state = 25},
  [1372] = {.lex_state = 404, .external_lex_state = 25},
  [1373] = {.lex_state = 416, .external_lex_state = 11},
  [1374] = {.lex_state = 192, .external_lex_state = 2},
  [1375] = {.lex_state = 192, .external_lex_state = 2},
  [1376] = {.lex_state = 396, .external_lex_state = 25},
  [1377] = {.lex_state = 405, .external_lex_state = 24},
  [1378] = {.lex_state = 404, .external_lex_state = 25},
  [1379] = {.lex_state = 399, .external_lex_state = 24},
  [1380] = {.lex_state = 405, .external_lex_state = 24},
  [1381] = {.lex_state = 405, .external_lex_state = 24},
  [1382] = {.lex_state = 399, .external_lex_state = 24},
  [1383] = {.lex_state = 213},
  [1384] = {.lex_state = 405, .external_lex_state = 24},
  [1385] = {.lex_state = 405, .external_lex_state = 26},
  [1386] = {.lex_state = 156, .external_lex_state = 3},
  [1387] = {.lex_state = 237, .external_lex_state = 29},
  [1388] = {.lex_state = 553},
  [1389] = {.lex_state = 393, .external_lex_state = 19},
  [1390] = {.lex_state = 192, .external_lex_state = 28},
  [1391] = {.lex_state = 192, .external_lex_state = 2},
  [1392] = {.lex_state = 547, .external_lex_state = 26},
  [1393] = {.lex_state = 156, .external_lex_state = 3},
  [1394] = {.lex_state = 239},
  [1395] = {.lex_state = 194},
  [1396] = {.lex_state = 288, .external_lex_state = 2},
  [1397] = {.lex_state = 197},
  [1398] = {.lex_state = 128},
  [1399] = {.lex_state = 413},
  [1400] = {.lex_state = 304},
  [1401] = {.lex_state = 339},
  [1402] = {.lex_state = 339},
  [1403] = {.lex_state = 339},
  [1404] = {.lex_state = 239},
  [1405] = {.lex_state = 156, .external_lex_state = 3},
  [1406] = {.lex_state = 128},
  [1407] = {.lex_state = 128, .external_lex_state = 11},
  [1408] = {.lex_state = 416, .external_lex_state = 2},
  [1409] = {.lex_state = 556, .external_lex_state = 2},
  [1410] = {.lex_state = 192, .external_lex_state = 2},
  [1411] = {.lex_state = 156, .external_lex_state = 3},
  [1412] = {.lex_state = 197},
  [1413] = {.lex_state = 156},
  [1414] = {.lex_state = 271},
  [1415] = {.lex_state = 249, .external_lex_state = 3},
  [1416] = {.lex_state = 249, .external_lex_state = 3},
  [1417] = {.lex_state = 249, .external_lex_state = 3},
  [1418] = {.lex_state = 249, .external_lex_state = 3},
  [1419] = {.lex_state = 249, .external_lex_state = 3},
  [1420] = {.lex_state = 249, .external_lex_state = 3},
  [1421] = {.lex_state = 249, .external_lex_state = 3},
  [1422] = {.lex_state = 249, .external_lex_state = 3},
  [1423] = {.lex_state = 249, .external_lex_state = 3},
  [1424] = {.lex_state = 249, .external_lex_state = 3},
  [1425] = {.lex_state = 177, .external_lex_state = 4},
  [1426] = {.lex_state = 192, .external_lex_state = 2},
  [1427] = {.lex_state = 558, .external_lex_state = 18},
  [1428] = {.lex_state = 558, .external_lex_state = 18},
  [1429] = {.lex_state = 558, .external_lex_state = 18},
  [1430] = {.lex_state = 558, .external_lex_state = 18},
  [1431] = {.lex_state = 192, .external_lex_state = 2},
  [1432] = {.lex_state = 192, .external_lex_state = 2},
  [1433] = {.lex_state = 561, .external_lex_state = 16},
  [1434] = {.lex_state = 563, .external_lex_state = 18},
  [1435] = {.lex_state = 213},
  [1436] = {.lex_state = 566, .external_lex_state = 16},
  [1437] = {.lex_state = 569, .external_lex_state = 20},
  [1438] = {.lex_state = 249, .external_lex_state = 3},
  [1439] = {.lex_state = 249, .external_lex_state = 3},
  [1440] = {.lex_state = 249, .external_lex_state = 3},
  [1441] = {.lex_state = 249, .external_lex_state = 3},
  [1442] = {.lex_state = 177, .external_lex_state = 17},
  [1443] = {.lex_state = 329, .external_lex_state = 10},
  [1444] = {.lex_state = 358, .external_lex_state = 12},
  [1445] = {.lex_state = 329, .external_lex_state = 10},
  [1446] = {.lex_state = 329, .external_lex_state = 10},
  [1447] = {.lex_state = 418, .external_lex_state = 27},
  [1448] = {.lex_state = 229, .external_lex_state = 3},
  [1449] = {.lex_state = 237},
  [1450] = {.lex_state = 329, .external_lex_state = 10},
  [1451] = {.lex_state = 572, .external_lex_state = 14},
  [1452] = {.lex_state = 192, .external_lex_state = 15},
  [1453] = {.lex_state = 301, .external_lex_state = 3},
  [1454] = {.lex_state = 192, .external_lex_state = 15},
  [1455] = {.lex_state = 301, .external_lex_state = 3},
  [1456] = {.lex_state = 192, .external_lex_state = 15},
  [1457] = {.lex_state = 301, .external_lex_state = 3},
  [1458] = {.lex_state = 192, .external_lex_state = 15},
  [1459] = {.lex_state = 301, .external_lex_state = 3},
  [1460] = {.lex_state = 190, .external_lex_state = 4},
  [1461] = {.lex_state = 268, .external_lex_state = 15},
  [1462] = {.lex_state = 301, .external_lex_state = 3},
  [1463] = {.lex_state = 190, .external_lex_state = 4},
  [1464] = {.lex_state = 268, .external_lex_state = 15},
  [1465] = {.lex_state = 229, .external_lex_state = 3},
  [1466] = {.lex_state = 177, .external_lex_state = 4},
  [1467] = {.lex_state = 177, .external_lex_state = 4},
  [1468] = {.lex_state = 177, .external_lex_state = 4},
  [1469] = {.lex_state = 177, .external_lex_state = 4},
  [1470] = {.lex_state = 190, .external_lex_state = 4},
  [1471] = {.lex_state = 190, .external_lex_state = 4},
  [1472] = {.lex_state = 192, .external_lex_state = 2},
  [1473] = {.lex_state = 194, .external_lex_state = 6},
  [1474] = {.lex_state = 197, .external_lex_state = 7},
  [1475] = {.lex_state = 209, .external_lex_state = 2},
  [1476] = {.lex_state = 216, .external_lex_state = 9},
  [1477] = {.lex_state = 216, .external_lex_state = 8},
  [1478] = {.lex_state = 256, .external_lex_state = 10},
  [1479] = {.lex_state = 256, .external_lex_state = 10},
  [1480] = {.lex_state = 256, .external_lex_state = 10},
  [1481] = {.lex_state = 256, .external_lex_state = 10},
  [1482] = {.lex_state = 221, .external_lex_state = 2},
  [1483] = {.lex_state = 221, .external_lex_state = 2},
  [1484] = {.lex_state = 192, .external_lex_state = 2},
  [1485] = {.lex_state = 192, .external_lex_state = 2},
  [1486] = {.lex_state = 223, .external_lex_state = 8},
  [1487] = {.lex_state = 225, .external_lex_state = 11},
  [1488] = {.lex_state = 128, .external_lex_state = 11},
  [1489] = {.lex_state = 192, .external_lex_state = 2},
  [1490] = {.lex_state = 192, .external_lex_state = 2},
  [1491] = {.lex_state = 229, .external_lex_state = 3},
  [1492] = {.lex_state = 237, .external_lex_state = 12},
  [1493] = {.lex_state = 239},
  [1494] = {.lex_state = 426, .external_lex_state = 3},
  [1495] = {.lex_state = 229, .external_lex_state = 3},
  [1496] = {.lex_state = 256, .external_lex_state = 10},
  [1497] = {.lex_state = 213},
  [1498] = {.lex_state = 426, .external_lex_state = 3},
  [1499] = {.lex_state = 426, .external_lex_state = 14},
  [1500] = {.lex_state = 426, .external_lex_state = 3},
  [1501] = {.lex_state = 194, .external_lex_state = 6},
  [1502] = {.lex_state = 423, .external_lex_state = 3},
  [1503] = {.lex_state = 423, .external_lex_state = 14},
  [1504] = {.lex_state = 192, .external_lex_state = 2},
  [1505] = {.lex_state = 192, .external_lex_state = 2},
  [1506] = {.lex_state = 301, .external_lex_state = 3},
  [1507] = {.lex_state = 573, .external_lex_state = 10},
  [1508] = {.lex_state = 573, .external_lex_state = 10},
  [1509] = {.lex_state = 573, .external_lex_state = 10},
  [1510] = {.lex_state = 573, .external_lex_state = 10},
  [1511] = {.lex_state = 192, .external_lex_state = 2},
  [1512] = {.lex_state = 192, .external_lex_state = 2},
  [1513] = {.lex_state = 576, .external_lex_state = 10},
  [1514] = {.lex_state = 194},
  [1515] = {.lex_state = 288, .external_lex_state = 2},
  [1516] = {.lex_state = 438, .external_lex_state = 3},
  [1517] = {.lex_state = 579, .external_lex_state = 10},
  [1518] = {.lex_state = 213},
  [1519] = {.lex_state = 580, .external_lex_state = 3},
  [1520] = {.lex_state = 583, .external_lex_state = 14},
  [1521] = {.lex_state = 194},
  [1522] = {.lex_state = 194, .external_lex_state = 19},
  [1523] = {.lex_state = 192, .external_lex_state = 2},
  [1524] = {.lex_state = 301, .external_lex_state = 3},
  [1525] = {.lex_state = 312},
  [1526] = {.lex_state = 312, .external_lex_state = 13},
  [1527] = {.lex_state = 301, .external_lex_state = 3},
  [1528] = {.lex_state = 209},
  [1529] = {.lex_state = 426, .external_lex_state = 3},
  [1530] = {.lex_state = 192, .external_lex_state = 2},
  [1531] = {.lex_state = 348, .external_lex_state = 22},
  [1532] = {.lex_state = 348, .external_lex_state = 22},
  [1533] = {.lex_state = 352, .external_lex_state = 22},
  [1534] = {.lex_state = 352, .external_lex_state = 22},
  [1535] = {.lex_state = 301, .external_lex_state = 3},
  [1536] = {.lex_state = 301, .external_lex_state = 3},
  [1537] = {.lex_state = 301, .external_lex_state = 3},
  [1538] = {.lex_state = 301, .external_lex_state = 3},
  [1539] = {.lex_state = 128, .external_lex_state = 13},
  [1540] = {.lex_state = 128, .external_lex_state = 13},
  [1541] = {.lex_state = 249, .external_lex_state = 3},
  [1542] = {.lex_state = 249, .external_lex_state = 3},
  [1543] = {.lex_state = 128},
  [1544] = {.lex_state = 229, .external_lex_state = 3},
  [1545] = {.lex_state = 128},
  [1546] = {.lex_state = 128, .external_lex_state = 11},
  [1547] = {.lex_state = 416, .external_lex_state = 2},
  [1548] = {.lex_state = 249, .external_lex_state = 3},
  [1549] = {.lex_state = 128},
  [1550] = {.lex_state = 128},
  [1551] = {.lex_state = 128},
  [1552] = {.lex_state = 128},
  [1553] = {.lex_state = 128},
  [1554] = {.lex_state = 301, .external_lex_state = 3},
  [1555] = {.lex_state = 128, .external_lex_state = 2},
  [1556] = {.lex_state = 229, .external_lex_state = 3},
  [1557] = {.lex_state = 209},
  [1558] = {.lex_state = 423, .external_lex_state = 3},
  [1559] = {.lex_state = 301, .external_lex_state = 3},
  [1560] = {.lex_state = 192, .external_lex_state = 2},
  [1561] = {.lex_state = 301, .external_lex_state = 3},
  [1562] = {.lex_state = 301, .external_lex_state = 3},
  [1563] = {.lex_state = 237},
  [1564] = {.lex_state = 411, .external_lex_state = 2},
  [1565] = {.lex_state = 128},
  [1566] = {.lex_state = 301, .external_lex_state = 3},
  [1567] = {.lex_state = 192, .external_lex_state = 2},
  [1568] = {.lex_state = 192, .external_lex_state = 2},
  [1569] = {.lex_state = 192, .external_lex_state = 2},
  [1570] = {.lex_state = 192, .external_lex_state = 2},
  [1571] = {.lex_state = 192, .external_lex_state = 2},
  [1572] = {.lex_state = 192, .external_lex_state = 2},
  [1573] = {.lex_state = 192, .external_lex_state = 2},
  [1574] = {.lex_state = 192, .external_lex_state = 2},
  [1575] = {.lex_state = 192, .external_lex_state = 2},
  [1576] = {.lex_state = 192, .external_lex_state = 2},
  [1577] = {.lex_state = 421, .external_lex_state = 6},
  [1578] = {.lex_state = 301, .external_lex_state = 3},
  [1579] = {.lex_state = 411, .external_lex_state = 2},
  [1580] = {.lex_state = 229, .external_lex_state = 3},
  [1581] = {.lex_state = 177, .external_lex_state = 17},
  [1582] = {.lex_state = 426, .external_lex_state = 3},
  [1583] = {.lex_state = 528, .external_lex_state = 29},
  [1584] = {.lex_state = 426, .external_lex_state = 3},
  [1585] = {.lex_state = 192, .external_lex_state = 28},
  [1586] = {.lex_state = 192, .external_lex_state = 2},
  [1587] = {.lex_state = 423, .external_lex_state = 14},
  [1588] = {.lex_state = 192, .external_lex_state = 2},
  [1589] = {.lex_state = 192, .external_lex_state = 2},
  [1590] = {.lex_state = 192, .external_lex_state = 2},
  [1591] = {.lex_state = 192, .external_lex_state = 2},
  [1592] = {.lex_state = 584, .external_lex_state = 3},
  [1593] = {.lex_state = 382, .external_lex_state = 3},
  [1594] = {.lex_state = 584, .external_lex_state = 3},
  [1595] = {.lex_state = 213},
  [1596] = {.lex_state = 261, .external_lex_state = 3},
  [1597] = {.lex_state = 315},
  [1598] = {.lex_state = 339},
  [1599] = {.lex_state = 430, .external_lex_state = 8},
  [1600] = {.lex_state = 213},
  [1601] = {.lex_state = 249, .external_lex_state = 3},
  [1602] = {.lex_state = 264, .external_lex_state = 14},
  [1603] = {.lex_state = 192, .external_lex_state = 2},
  [1604] = {.lex_state = 218, .external_lex_state = 10},
  [1605] = {.lex_state = 218, .external_lex_state = 10},
  [1606] = {.lex_state = 218, .external_lex_state = 10},
  [1607] = {.lex_state = 218, .external_lex_state = 10},
  [1608] = {.lex_state = 192, .external_lex_state = 2},
  [1609] = {.lex_state = 192, .external_lex_state = 2},
  [1610] = {.lex_state = 227, .external_lex_state = 7},
  [1611] = {.lex_state = 128, .external_lex_state = 13},
  [1612] = {.lex_state = 249, .external_lex_state = 3},
  [1613] = {.lex_state = 256, .external_lex_state = 10},
  [1614] = {.lex_state = 213},
  [1615] = {.lex_state = 261, .external_lex_state = 3},
  [1616] = {.lex_state = 264, .external_lex_state = 14},
  [1617] = {.lex_state = 438, .external_lex_state = 16},
  [1618] = {.lex_state = 288, .external_lex_state = 2},
  [1619] = {.lex_state = 288, .external_lex_state = 2},
  [1620] = {.lex_state = 586, .external_lex_state = 18},
  [1621] = {.lex_state = 192, .external_lex_state = 2},
  [1622] = {.lex_state = 192, .external_lex_state = 2},
  [1623] = {.lex_state = 192, .external_lex_state = 2},
  [1624] = {.lex_state = 239},
  [1625] = {.lex_state = 192, .external_lex_state = 2},
  [1626] = {.lex_state = 589, .external_lex_state = 25},
  [1627] = {.lex_state = 589, .external_lex_state = 25},
  [1628] = {.lex_state = 589, .external_lex_state = 25},
  [1629] = {.lex_state = 589, .external_lex_state = 25},
  [1630] = {.lex_state = 192, .external_lex_state = 2},
  [1631] = {.lex_state = 192, .external_lex_state = 2},
  [1632] = {.lex_state = 592, .external_lex_state = 25},
  [1633] = {.lex_state = 595, .external_lex_state = 24},
  [1634] = {.lex_state = 598, .external_lex_state = 25},
  [1635] = {.lex_state = 446, .external_lex_state = 24},
  [1636] = {.lex_state = 471, .external_lex_state = 24},
  [1637] = {.lex_state = 213},
  [1638] = {.lex_state = 580, .external_lex_state = 24},
  [1639] = {.lex_state = 595, .external_lex_state = 26},
  [1640] = {.lex_state = 438, .external_lex_state = 16},
  [1641] = {.lex_state = 239},
  [1642] = {.lex_state = 239},
  [1643] = {.lex_state = 239},
  [1644] = {.lex_state = 227, .external_lex_state = 7},
  [1645] = {.lex_state = 177, .external_lex_state = 4},
  [1646] = {.lex_state = 192, .external_lex_state = 2},
  [1647] = {.lex_state = 192, .external_lex_state = 2},
  [1648] = {.lex_state = 192, .external_lex_state = 2},
  [1649] = {.lex_state = 192, .external_lex_state = 2},
  [1650] = {.lex_state = 192, .external_lex_state = 2},
  [1651] = {.lex_state = 192, .external_lex_state = 2},
  [1652] = {.lex_state = 192, .external_lex_state = 2},
  [1653] = {.lex_state = 192, .external_lex_state = 2},
  [1654] = {.lex_state = 192, .external_lex_state = 2},
  [1655] = {.lex_state = 192, .external_lex_state = 2},
  [1656] = {.lex_state = 192, .external_lex_state = 2},
  [1657] = {.lex_state = 192, .external_lex_state = 2},
  [1658] = {.lex_state = 192, .external_lex_state = 2},
  [1659] = {.lex_state = 192, .external_lex_state = 2},
  [1660] = {.lex_state = 192, .external_lex_state = 2},
  [1661] = {.lex_state = 418, .external_lex_state = 27},
  [1662] = {.lex_state = 237, .external_lex_state = 12},
  [1663] = {.lex_state = 197},
  [1664] = {.lex_state = 192, .external_lex_state = 2},
  [1665] = {.lex_state = 192, .external_lex_state = 2},
  [1666] = {.lex_state = 192, .external_lex_state = 2},
  [1667] = {.lex_state = 239},
  [1668] = {.lex_state = 421, .external_lex_state = 6},
  [1669] = {.lex_state = 192, .external_lex_state = 2},
  [1670] = {.lex_state = 598, .external_lex_state = 25},
  [1671] = {.lex_state = 598, .external_lex_state = 25},
  [1672] = {.lex_state = 598, .external_lex_state = 25},
  [1673] = {.lex_state = 598, .external_lex_state = 25},
  [1674] = {.lex_state = 416, .external_lex_state = 11},
  [1675] = {.lex_state = 358, .external_lex_state = 12},
  [1676] = {.lex_state = 192, .external_lex_state = 2},
  [1677] = {.lex_state = 192, .external_lex_state = 2},
  [1678] = {.lex_state = 592, .external_lex_state = 25},
  [1679] = {.lex_state = 580, .external_lex_state = 24},
  [1680] = {.lex_state = 598, .external_lex_state = 25},
  [1681] = {.lex_state = 435, .external_lex_state = 16},
  [1682] = {.lex_state = 443, .external_lex_state = 24},
  [1683] = {.lex_state = 443, .external_lex_state = 24},
  [1684] = {.lex_state = 435, .external_lex_state = 16},
  [1685] = {.lex_state = 213},
  [1686] = {.lex_state = 580, .external_lex_state = 24},
  [1687] = {.lex_state = 580, .external_lex_state = 26},
  [1688] = {.lex_state = 192, .external_lex_state = 28},
  [1689] = {.lex_state = 192, .external_lex_state = 2},
  [1690] = {.lex_state = 446, .external_lex_state = 20},
  [1691] = {.lex_state = 190, .external_lex_state = 4},
  [1692] = {.lex_state = 156, .external_lex_state = 3},
  [1693] = {.lex_state = 156, .external_lex_state = 3},
  [1694] = {.lex_state = 177, .external_lex_state = 4},
  [1695] = {.lex_state = 268, .external_lex_state = 15},
  [1696] = {.lex_state = 156, .external_lex_state = 3},
  [1697] = {.lex_state = 268, .external_lex_state = 15},
  [1698] = {.lex_state = 177, .external_lex_state = 4},
  [1699] = {.lex_state = 268, .external_lex_state = 15},
  [1700] = {.lex_state = 156, .external_lex_state = 3},
  [1701] = {.lex_state = 156, .external_lex_state = 3},
  [1702] = {.lex_state = 177, .external_lex_state = 4},
  [1703] = {.lex_state = 268, .external_lex_state = 15},
  [1704] = {.lex_state = 156, .external_lex_state = 3},
  [1705] = {.lex_state = 268, .external_lex_state = 15},
  [1706] = {.lex_state = 177, .external_lex_state = 4},
  [1707] = {.lex_state = 268, .external_lex_state = 15},
  [1708] = {.lex_state = 438, .external_lex_state = 3},
  [1709] = {.lex_state = 192, .external_lex_state = 2},
  [1710] = {.lex_state = 192, .external_lex_state = 2},
  [1711] = {.lex_state = 192, .external_lex_state = 2},
  [1712] = {.lex_state = 239},
  [1713] = {.lex_state = 192, .external_lex_state = 2},
  [1714] = {.lex_state = 599, .external_lex_state = 10},
  [1715] = {.lex_state = 599, .external_lex_state = 10},
  [1716] = {.lex_state = 599, .external_lex_state = 10},
  [1717] = {.lex_state = 599, .external_lex_state = 10},
  [1718] = {.lex_state = 192, .external_lex_state = 2},
  [1719] = {.lex_state = 192, .external_lex_state = 2},
  [1720] = {.lex_state = 576, .external_lex_state = 10},
  [1721] = {.lex_state = 595, .external_lex_state = 3},
  [1722] = {.lex_state = 446, .external_lex_state = 3},
  [1723] = {.lex_state = 471, .external_lex_state = 3},
  [1724] = {.lex_state = 213},
  [1725] = {.lex_state = 580, .external_lex_state = 3},
  [1726] = {.lex_state = 595, .external_lex_state = 14},
  [1727] = {.lex_state = 438, .external_lex_state = 3},
  [1728] = {.lex_state = 239, .external_lex_state = 13},
  [1729] = {.lex_state = 449, .external_lex_state = 13},
  [1730] = {.lex_state = 192, .external_lex_state = 2},
  [1731] = {.lex_state = 192, .external_lex_state = 2},
  [1732] = {.lex_state = 192, .external_lex_state = 2},
  [1733] = {.lex_state = 192, .external_lex_state = 2},
  [1734] = {.lex_state = 192, .external_lex_state = 2},
  [1735] = {.lex_state = 192, .external_lex_state = 2},
  [1736] = {.lex_state = 192, .external_lex_state = 2},
  [1737] = {.lex_state = 192, .external_lex_state = 2},
  [1738] = {.lex_state = 192, .external_lex_state = 2},
  [1739] = {.lex_state = 192, .external_lex_state = 2},
  [1740] = {.lex_state = 192, .external_lex_state = 2},
  [1741] = {.lex_state = 192, .external_lex_state = 2},
  [1742] = {.lex_state = 192, .external_lex_state = 2},
  [1743] = {.lex_state = 192, .external_lex_state = 2},
  [1744] = {.lex_state = 192, .external_lex_state = 2},
  [1745] = {.lex_state = 192, .external_lex_state = 2},
  [1746] = {.lex_state = 192, .external_lex_state = 2},
  [1747] = {.lex_state = 192, .external_lex_state = 2},
  [1748] = {.lex_state = 239},
  [1749] = {.lex_state = 192, .external_lex_state = 2},
  [1750] = {.lex_state = 579, .external_lex_state = 10},
  [1751] = {.lex_state = 579, .external_lex_state = 10},
  [1752] = {.lex_state = 579, .external_lex_state = 10},
  [1753] = {.lex_state = 579, .external_lex_state = 10},
  [1754] = {.lex_state = 192, .external_lex_state = 2},
  [1755] = {.lex_state = 192, .external_lex_state = 2},
  [1756] = {.lex_state = 576, .external_lex_state = 10},
  [1757] = {.lex_state = 580, .external_lex_state = 3},
  [1758] = {.lex_state = 579, .external_lex_state = 10},
  [1759] = {.lex_state = 443, .external_lex_state = 3},
  [1760] = {.lex_state = 443, .external_lex_state = 3},
  [1761] = {.lex_state = 213},
  [1762] = {.lex_state = 580, .external_lex_state = 3},
  [1763] = {.lex_state = 580, .external_lex_state = 14},
  [1764] = {.lex_state = 192, .external_lex_state = 28},
  [1765] = {.lex_state = 192, .external_lex_state = 2},
  [1766] = {.lex_state = 446, .external_lex_state = 14},
  [1767] = {.lex_state = 239, .external_lex_state = 13},
  [1768] = {.lex_state = 288, .external_lex_state = 2},
  [1769] = {.lex_state = 267, .external_lex_state = 20},
  [1770] = {.lex_state = 290, .external_lex_state = 16},
  [1771] = {.lex_state = 290, .external_lex_state = 16},
  [1772] = {.lex_state = 290, .external_lex_state = 16},
  [1773] = {.lex_state = 290, .external_lex_state = 16},
  [1774] = {.lex_state = 192, .external_lex_state = 15},
  [1775] = {.lex_state = 268, .external_lex_state = 15},
  [1776] = {.lex_state = 290, .external_lex_state = 16},
  [1777] = {.lex_state = 177, .external_lex_state = 4},
  [1778] = {.lex_state = 268, .external_lex_state = 15},
  [1779] = {.lex_state = 290, .external_lex_state = 16},
  [1780] = {.lex_state = 192, .external_lex_state = 15},
  [1781] = {.lex_state = 268, .external_lex_state = 15},
  [1782] = {.lex_state = 290, .external_lex_state = 16},
  [1783] = {.lex_state = 177, .external_lex_state = 4},
  [1784] = {.lex_state = 268, .external_lex_state = 15},
  [1785] = {.lex_state = 194},
  [1786] = {.lex_state = 457},
  [1787] = {.lex_state = 177, .external_lex_state = 17},
  [1788] = {.lex_state = 438, .external_lex_state = 24},
  [1789] = {.lex_state = 290, .external_lex_state = 16},
  [1790] = {.lex_state = 194},
  [1791] = {.lex_state = 304, .external_lex_state = 16},
  [1792] = {.lex_state = 227, .external_lex_state = 7},
  [1793] = {.lex_state = 128, .external_lex_state = 2},
  [1794] = {.lex_state = 290, .external_lex_state = 16},
  [1795] = {.lex_state = 438, .external_lex_state = 24},
  [1796] = {.lex_state = 602, .external_lex_state = 25},
  [1797] = {.lex_state = 192, .external_lex_state = 2},
  [1798] = {.lex_state = 192, .external_lex_state = 2},
  [1799] = {.lex_state = 192, .external_lex_state = 2},
  [1800] = {.lex_state = 239},
  [1801] = {.lex_state = 192, .external_lex_state = 2},
  [1802] = {.lex_state = 589, .external_lex_state = 25},
  [1803] = {.lex_state = 589, .external_lex_state = 25},
  [1804] = {.lex_state = 589, .external_lex_state = 25},
  [1805] = {.lex_state = 589, .external_lex_state = 25},
  [1806] = {.lex_state = 192, .external_lex_state = 2},
  [1807] = {.lex_state = 192, .external_lex_state = 2},
  [1808] = {.lex_state = 592, .external_lex_state = 25},
  [1809] = {.lex_state = 595, .external_lex_state = 24},
  [1810] = {.lex_state = 598, .external_lex_state = 25},
  [1811] = {.lex_state = 471, .external_lex_state = 24},
  [1812] = {.lex_state = 471, .external_lex_state = 24},
  [1813] = {.lex_state = 213},
  [1814] = {.lex_state = 580, .external_lex_state = 24},
  [1815] = {.lex_state = 595, .external_lex_state = 26},
  [1816] = {.lex_state = 438, .external_lex_state = 24},
  [1817] = {.lex_state = 192, .external_lex_state = 2},
  [1818] = {.lex_state = 192, .external_lex_state = 2},
  [1819] = {.lex_state = 192, .external_lex_state = 2},
  [1820] = {.lex_state = 192, .external_lex_state = 2},
  [1821] = {.lex_state = 192, .external_lex_state = 2},
  [1822] = {.lex_state = 192, .external_lex_state = 2},
  [1823] = {.lex_state = 192, .external_lex_state = 2},
  [1824] = {.lex_state = 192, .external_lex_state = 2},
  [1825] = {.lex_state = 192, .external_lex_state = 2},
  [1826] = {.lex_state = 192, .external_lex_state = 2},
  [1827] = {.lex_state = 418, .external_lex_state = 27},
  [1828] = {.lex_state = 237, .external_lex_state = 12},
  [1829] = {.lex_state = 197},
  [1830] = {.lex_state = 192, .external_lex_state = 2},
  [1831] = {.lex_state = 192, .external_lex_state = 2},
  [1832] = {.lex_state = 192, .external_lex_state = 2},
  [1833] = {.lex_state = 239},
  [1834] = {.lex_state = 421, .external_lex_state = 6},
  [1835] = {.lex_state = 192, .external_lex_state = 2},
  [1836] = {.lex_state = 598, .external_lex_state = 25},
  [1837] = {.lex_state = 598, .external_lex_state = 25},
  [1838] = {.lex_state = 598, .external_lex_state = 25},
  [1839] = {.lex_state = 598, .external_lex_state = 25},
  [1840] = {.lex_state = 416, .external_lex_state = 11},
  [1841] = {.lex_state = 192, .external_lex_state = 2},
  [1842] = {.lex_state = 192, .external_lex_state = 2},
  [1843] = {.lex_state = 592, .external_lex_state = 25},
  [1844] = {.lex_state = 580, .external_lex_state = 24},
  [1845] = {.lex_state = 598, .external_lex_state = 25},
  [1846] = {.lex_state = 465, .external_lex_state = 24},
  [1847] = {.lex_state = 443, .external_lex_state = 24},
  [1848] = {.lex_state = 443, .external_lex_state = 24},
  [1849] = {.lex_state = 465, .external_lex_state = 24},
  [1850] = {.lex_state = 213},
  [1851] = {.lex_state = 580, .external_lex_state = 24},
  [1852] = {.lex_state = 580, .external_lex_state = 26},
  [1853] = {.lex_state = 192, .external_lex_state = 28},
  [1854] = {.lex_state = 192, .external_lex_state = 2},
  [1855] = {.lex_state = 471, .external_lex_state = 26},
  [1856] = {.lex_state = 249, .external_lex_state = 3},
  [1857] = {.lex_state = 128, .external_lex_state = 13},
  [1858] = {.lex_state = 128, .external_lex_state = 2},
  [1859] = {.lex_state = 290, .external_lex_state = 16},
  [1860] = {.lex_state = 128, .external_lex_state = 2},
  [1861] = {.lex_state = 363, .external_lex_state = 24},
  [1862] = {.lex_state = 363, .external_lex_state = 26},
  [1863] = {.lex_state = 363, .external_lex_state = 24},
  [1864] = {.lex_state = 363, .external_lex_state = 24},
  [1865] = {.lex_state = 192, .external_lex_state = 2},
  [1866] = {.lex_state = 363, .external_lex_state = 24},
  [1867] = {.lex_state = 363, .external_lex_state = 24},
  [1868] = {.lex_state = 363, .external_lex_state = 24},
  [1869] = {.lex_state = 390, .external_lex_state = 24},
  [1870] = {.lex_state = 209},
  [1871] = {.lex_state = 363, .external_lex_state = 24},
  [1872] = {.lex_state = 390, .external_lex_state = 24},
  [1873] = {.lex_state = 192, .external_lex_state = 2},
  [1874] = {.lex_state = 192, .external_lex_state = 2},
  [1875] = {.lex_state = 192, .external_lex_state = 2},
  [1876] = {.lex_state = 192, .external_lex_state = 2},
  [1877] = {.lex_state = 192, .external_lex_state = 2},
  [1878] = {.lex_state = 192, .external_lex_state = 2},
  [1879] = {.lex_state = 192, .external_lex_state = 2},
  [1880] = {.lex_state = 192, .external_lex_state = 2},
  [1881] = {.lex_state = 192, .external_lex_state = 2},
  [1882] = {.lex_state = 192, .external_lex_state = 2},
  [1883] = {.lex_state = 192, .external_lex_state = 2},
  [1884] = {.lex_state = 177, .external_lex_state = 17},
  [1885] = {.lex_state = 307, .external_lex_state = 24},
  [1886] = {.lex_state = 528, .external_lex_state = 29},
  [1887] = {.lex_state = 363, .external_lex_state = 24},
  [1888] = {.lex_state = 192, .external_lex_state = 28},
  [1889] = {.lex_state = 192, .external_lex_state = 2},
  [1890] = {.lex_state = 363, .external_lex_state = 26},
  [1891] = {.lex_state = 128},
  [1892] = {.lex_state = 128, .external_lex_state = 2},
  [1893] = {.lex_state = 128},
  [1894] = {.lex_state = 128, .external_lex_state = 2},
  [1895] = {.lex_state = 128, .external_lex_state = 2},
  [1896] = {.lex_state = 128, .external_lex_state = 2},
  [1897] = {.lex_state = 128, .external_lex_state = 13},
  [1898] = {.lex_state = 128},
  [1899] = {.lex_state = 290, .external_lex_state = 16},
  [1900] = {.lex_state = 128},
  [1901] = {.lex_state = 128},
  [1902] = {.lex_state = 128},
  [1903] = {.lex_state = 290, .external_lex_state = 16},
  [1904] = {.lex_state = 128},
  [1905] = {.lex_state = 128},
  [1906] = {.lex_state = 128},
  [1907] = {.lex_state = 290, .external_lex_state = 16},
  [1908] = {.lex_state = 438, .external_lex_state = 24},
  [1909] = {.lex_state = 290, .external_lex_state = 16},
  [1910] = {.lex_state = 290, .external_lex_state = 16},
  [1911] = {.lex_state = 194},
  [1912] = {.lex_state = 288, .external_lex_state = 2},
  [1913] = {.lex_state = 290, .external_lex_state = 16},
  [1914] = {.lex_state = 128},
  [1915] = {.lex_state = 128, .external_lex_state = 11},
  [1916] = {.lex_state = 416, .external_lex_state = 2},
  [1917] = {.lex_state = 290, .external_lex_state = 16},
  [1918] = {.lex_state = 304, .external_lex_state = 16},
  [1919] = {.lex_state = 304, .external_lex_state = 16},
  [1920] = {.lex_state = 304, .external_lex_state = 16},
  [1921] = {.lex_state = 304, .external_lex_state = 16},
  [1922] = {.lex_state = 304, .external_lex_state = 16},
  [1923] = {.lex_state = 561, .external_lex_state = 16},
  [1924] = {.lex_state = 304, .external_lex_state = 16},
  [1925] = {.lex_state = 304, .external_lex_state = 16},
  [1926] = {.lex_state = 304, .external_lex_state = 16},
  [1927] = {.lex_state = 304, .external_lex_state = 16},
  [1928] = {.lex_state = 306, .external_lex_state = 18},
  [1929] = {.lex_state = 358, .external_lex_state = 12},
  [1930] = {.lex_state = 306, .external_lex_state = 18},
  [1931] = {.lex_state = 306, .external_lex_state = 18},
  [1932] = {.lex_state = 418, .external_lex_state = 27},
  [1933] = {.lex_state = 301, .external_lex_state = 16},
  [1934] = {.lex_state = 237},
  [1935] = {.lex_state = 306, .external_lex_state = 18},
  [1936] = {.lex_state = 605, .external_lex_state = 26},
  [1937] = {.lex_state = 192, .external_lex_state = 15},
  [1938] = {.lex_state = 399, .external_lex_state = 24},
  [1939] = {.lex_state = 192, .external_lex_state = 15},
  [1940] = {.lex_state = 399, .external_lex_state = 24},
  [1941] = {.lex_state = 192, .external_lex_state = 15},
  [1942] = {.lex_state = 399, .external_lex_state = 24},
  [1943] = {.lex_state = 192, .external_lex_state = 15},
  [1944] = {.lex_state = 399, .external_lex_state = 24},
  [1945] = {.lex_state = 190, .external_lex_state = 4},
  [1946] = {.lex_state = 268, .external_lex_state = 15},
  [1947] = {.lex_state = 399, .external_lex_state = 24},
  [1948] = {.lex_state = 190, .external_lex_state = 4},
  [1949] = {.lex_state = 268, .external_lex_state = 15},
  [1950] = {.lex_state = 194, .external_lex_state = 6},
  [1951] = {.lex_state = 423, .external_lex_state = 24},
  [1952] = {.lex_state = 423, .external_lex_state = 26},
  [1953] = {.lex_state = 423, .external_lex_state = 24},
  [1954] = {.lex_state = 423, .external_lex_state = 24},
  [1955] = {.lex_state = 192, .external_lex_state = 2},
  [1956] = {.lex_state = 423, .external_lex_state = 24},
  [1957] = {.lex_state = 194},
  [1958] = {.lex_state = 288, .external_lex_state = 2},
  [1959] = {.lex_state = 194},
  [1960] = {.lex_state = 194, .external_lex_state = 19},
  [1961] = {.lex_state = 192, .external_lex_state = 2},
  [1962] = {.lex_state = 399, .external_lex_state = 24},
  [1963] = {.lex_state = 312},
  [1964] = {.lex_state = 312, .external_lex_state = 13},
  [1965] = {.lex_state = 399, .external_lex_state = 24},
  [1966] = {.lex_state = 209},
  [1967] = {.lex_state = 423, .external_lex_state = 24},
  [1968] = {.lex_state = 192, .external_lex_state = 2},
  [1969] = {.lex_state = 348, .external_lex_state = 22},
  [1970] = {.lex_state = 348, .external_lex_state = 22},
  [1971] = {.lex_state = 352, .external_lex_state = 22},
  [1972] = {.lex_state = 352, .external_lex_state = 22},
  [1973] = {.lex_state = 399, .external_lex_state = 24},
  [1974] = {.lex_state = 399, .external_lex_state = 24},
  [1975] = {.lex_state = 399, .external_lex_state = 24},
  [1976] = {.lex_state = 399, .external_lex_state = 24},
  [1977] = {.lex_state = 128, .external_lex_state = 13},
  [1978] = {.lex_state = 128, .external_lex_state = 13},
  [1979] = {.lex_state = 249, .external_lex_state = 3},
  [1980] = {.lex_state = 249, .external_lex_state = 3},
  [1981] = {.lex_state = 128},
  [1982] = {.lex_state = 301, .external_lex_state = 16},
  [1983] = {.lex_state = 128},
  [1984] = {.lex_state = 128, .external_lex_state = 11},
  [1985] = {.lex_state = 416, .external_lex_state = 2},
  [1986] = {.lex_state = 249, .external_lex_state = 3},
  [1987] = {.lex_state = 128},
  [1988] = {.lex_state = 128},
  [1989] = {.lex_state = 128},
  [1990] = {.lex_state = 128},
  [1991] = {.lex_state = 128},
  [1992] = {.lex_state = 399, .external_lex_state = 24},
  [1993] = {.lex_state = 128, .external_lex_state = 2},
  [1994] = {.lex_state = 399, .external_lex_state = 24},
  [1995] = {.lex_state = 209},
  [1996] = {.lex_state = 423, .external_lex_state = 24},
  [1997] = {.lex_state = 399, .external_lex_state = 24},
  [1998] = {.lex_state = 192, .external_lex_state = 2},
  [1999] = {.lex_state = 399, .external_lex_state = 24},
  [2000] = {.lex_state = 399, .external_lex_state = 24},
  [2001] = {.lex_state = 237},
  [2002] = {.lex_state = 411, .external_lex_state = 2},
  [2003] = {.lex_state = 128},
  [2004] = {.lex_state = 399, .external_lex_state = 24},
  [2005] = {.lex_state = 192, .external_lex_state = 2},
  [2006] = {.lex_state = 192, .external_lex_state = 2},
  [2007] = {.lex_state = 192, .external_lex_state = 2},
  [2008] = {.lex_state = 192, .external_lex_state = 2},
  [2009] = {.lex_state = 192, .external_lex_state = 2},
  [2010] = {.lex_state = 192, .external_lex_state = 2},
  [2011] = {.lex_state = 192, .external_lex_state = 2},
  [2012] = {.lex_state = 192, .external_lex_state = 2},
  [2013] = {.lex_state = 192, .external_lex_state = 2},
  [2014] = {.lex_state = 192, .external_lex_state = 2},
  [2015] = {.lex_state = 421, .external_lex_state = 6},
  [2016] = {.lex_state = 399, .external_lex_state = 24},
  [2017] = {.lex_state = 411, .external_lex_state = 2},
  [2018] = {.lex_state = 301, .external_lex_state = 16},
  [2019] = {.lex_state = 177, .external_lex_state = 17},
  [2020] = {.lex_state = 423, .external_lex_state = 24},
  [2021] = {.lex_state = 528, .external_lex_state = 29},
  [2022] = {.lex_state = 423, .external_lex_state = 24},
  [2023] = {.lex_state = 192, .external_lex_state = 28},
  [2024] = {.lex_state = 192, .external_lex_state = 2},
  [2025] = {.lex_state = 423, .external_lex_state = 26},
  [2026] = {.lex_state = 192, .external_lex_state = 2},
  [2027] = {.lex_state = 192, .external_lex_state = 2},
  [2028] = {.lex_state = 474, .external_lex_state = 18},
  [2029] = {.lex_state = 474, .external_lex_state = 18},
  [2030] = {.lex_state = 474, .external_lex_state = 18},
  [2031] = {.lex_state = 474, .external_lex_state = 18},
  [2032] = {.lex_state = 192, .external_lex_state = 2},
  [2033] = {.lex_state = 192, .external_lex_state = 2},
  [2034] = {.lex_state = 304, .external_lex_state = 16},
  [2035] = {.lex_state = 477, .external_lex_state = 16},
  [2036] = {.lex_state = 304, .external_lex_state = 16},
  [2037] = {.lex_state = 213},
  [2038] = {.lex_state = 301, .external_lex_state = 16},
  [2039] = {.lex_state = 156, .external_lex_state = 20},
  [2040] = {.lex_state = 304, .external_lex_state = 16},
  [2041] = {.lex_state = 459, .external_lex_state = 20},
  [2042] = {.lex_state = 156, .external_lex_state = 3},
  [2043] = {.lex_state = 177, .external_lex_state = 17},
  [2044] = {.lex_state = 194, .external_lex_state = 6},
  [2045] = {.lex_state = 194, .external_lex_state = 19},
  [2046] = {.lex_state = 449, .external_lex_state = 13},
  [2047] = {.lex_state = 310, .external_lex_state = 13},
  [2048] = {.lex_state = 304, .external_lex_state = 16},
  [2049] = {.lex_state = 192, .external_lex_state = 2},
  [2050] = {.lex_state = 192, .external_lex_state = 2},
  [2051] = {.lex_state = 192, .external_lex_state = 2},
  [2052] = {.lex_state = 239},
  [2053] = {.lex_state = 192, .external_lex_state = 2},
  [2054] = {.lex_state = 192, .external_lex_state = 2},
  [2055] = {.lex_state = 192, .external_lex_state = 2},
  [2056] = {.lex_state = 524, .external_lex_state = 25},
  [2057] = {.lex_state = 497, .external_lex_state = 24},
  [2058] = {.lex_state = 326, .external_lex_state = 24},
  [2059] = {.lex_state = 497, .external_lex_state = 24},
  [2060] = {.lex_state = 213},
  [2061] = {.lex_state = 501, .external_lex_state = 24},
  [2062] = {.lex_state = 497, .external_lex_state = 26},
  [2063] = {.lex_state = 304, .external_lex_state = 16},
  [2064] = {.lex_state = 192, .external_lex_state = 2},
  [2065] = {.lex_state = 192, .external_lex_state = 2},
  [2066] = {.lex_state = 312},
  [2067] = {.lex_state = 192, .external_lex_state = 2},
  [2068] = {.lex_state = 192, .external_lex_state = 2},
  [2069] = {.lex_state = 192, .external_lex_state = 2},
  [2070] = {.lex_state = 192, .external_lex_state = 2},
  [2071] = {.lex_state = 192, .external_lex_state = 2},
  [2072] = {.lex_state = 192, .external_lex_state = 2},
  [2073] = {.lex_state = 192, .external_lex_state = 2},
  [2074] = {.lex_state = 192, .external_lex_state = 2},
  [2075] = {.lex_state = 192, .external_lex_state = 2},
  [2076] = {.lex_state = 192, .external_lex_state = 2},
  [2077] = {.lex_state = 192, .external_lex_state = 2},
  [2078] = {.lex_state = 239},
  [2079] = {.lex_state = 192, .external_lex_state = 2},
  [2080] = {.lex_state = 527, .external_lex_state = 25},
  [2081] = {.lex_state = 527, .external_lex_state = 25},
  [2082] = {.lex_state = 527, .external_lex_state = 25},
  [2083] = {.lex_state = 527, .external_lex_state = 25},
  [2084] = {.lex_state = 192, .external_lex_state = 2},
  [2085] = {.lex_state = 192, .external_lex_state = 2},
  [2086] = {.lex_state = 524, .external_lex_state = 25},
  [2087] = {.lex_state = 501, .external_lex_state = 24},
  [2088] = {.lex_state = 527, .external_lex_state = 25},
  [2089] = {.lex_state = 323, .external_lex_state = 24},
  [2090] = {.lex_state = 323, .external_lex_state = 24},
  [2091] = {.lex_state = 213},
  [2092] = {.lex_state = 501, .external_lex_state = 24},
  [2093] = {.lex_state = 501, .external_lex_state = 26},
  [2094] = {.lex_state = 192, .external_lex_state = 28},
  [2095] = {.lex_state = 192, .external_lex_state = 2},
  [2096] = {.lex_state = 326, .external_lex_state = 20},
  [2097] = {.lex_state = 156, .external_lex_state = 3},
  [2098] = {.lex_state = 128, .external_lex_state = 11},
  [2099] = {.lex_state = 304},
  [2100] = {.lex_state = 256, .external_lex_state = 13},
  [2101] = {.lex_state = 256, .external_lex_state = 13},
  [2102] = {.lex_state = 256, .external_lex_state = 13},
  [2103] = {.lex_state = 239},
  [2104] = {.lex_state = 606, .external_lex_state = 11},
  [2105] = {.lex_state = 192, .external_lex_state = 2},
  [2106] = {.lex_state = 156, .external_lex_state = 3},
  [2107] = {.lex_state = 197},
  [2108] = {.lex_state = 128, .external_lex_state = 2},
  [2109] = {.lex_state = 192, .external_lex_state = 2},
  [2110] = {.lex_state = 192, .external_lex_state = 2},
  [2111] = {.lex_state = 192, .external_lex_state = 2},
  [2112] = {.lex_state = 239},
  [2113] = {.lex_state = 192, .external_lex_state = 2},
  [2114] = {.lex_state = 608, .external_lex_state = 25},
  [2115] = {.lex_state = 608, .external_lex_state = 25},
  [2116] = {.lex_state = 608, .external_lex_state = 25},
  [2117] = {.lex_state = 608, .external_lex_state = 25},
  [2118] = {.lex_state = 192, .external_lex_state = 2},
  [2119] = {.lex_state = 192, .external_lex_state = 2},
  [2120] = {.lex_state = 524, .external_lex_state = 25},
  [2121] = {.lex_state = 611, .external_lex_state = 24},
  [2122] = {.lex_state = 339, .external_lex_state = 19},
  [2123] = {.lex_state = 339, .external_lex_state = 19},
  [2124] = {.lex_state = 213},
  [2125] = {.lex_state = 501, .external_lex_state = 24},
  [2126] = {.lex_state = 611, .external_lex_state = 26},
  [2127] = {.lex_state = 192, .external_lex_state = 2},
  [2128] = {.lex_state = 614, .external_lex_state = 10},
  [2129] = {.lex_state = 614, .external_lex_state = 10},
  [2130] = {.lex_state = 614, .external_lex_state = 10},
  [2131] = {.lex_state = 614, .external_lex_state = 10},
  [2132] = {.lex_state = 192, .external_lex_state = 2},
  [2133] = {.lex_state = 192, .external_lex_state = 2},
  [2134] = {.lex_state = 497, .external_lex_state = 3},
  [2135] = {.lex_state = 213},
  [2136] = {.lex_state = 323, .external_lex_state = 3},
  [2137] = {.lex_state = 617, .external_lex_state = 14},
  [2138] = {.lex_state = 497, .external_lex_state = 3},
  [2139] = {.lex_state = 497, .external_lex_state = 3},
  [2140] = {.lex_state = 620, .external_lex_state = 14},
  [2141] = {.lex_state = 192, .external_lex_state = 2},
  [2142] = {.lex_state = 497, .external_lex_state = 3},
  [2143] = {.lex_state = 192, .external_lex_state = 2},
  [2144] = {.lex_state = 192, .external_lex_state = 2},
  [2145] = {.lex_state = 239},
  [2146] = {.lex_state = 192, .external_lex_state = 2},
  [2147] = {.lex_state = 494, .external_lex_state = 10},
  [2148] = {.lex_state = 497, .external_lex_state = 3},
  [2149] = {.lex_state = 497, .external_lex_state = 3},
  [2150] = {.lex_state = 497, .external_lex_state = 3},
  [2151] = {.lex_state = 497, .external_lex_state = 14},
  [2152] = {.lex_state = 497, .external_lex_state = 3},
  [2153] = {.lex_state = 192, .external_lex_state = 2},
  [2154] = {.lex_state = 192, .external_lex_state = 2},
  [2155] = {.lex_state = 192, .external_lex_state = 2},
  [2156] = {.lex_state = 192, .external_lex_state = 2},
  [2157] = {.lex_state = 192, .external_lex_state = 2},
  [2158] = {.lex_state = 192, .external_lex_state = 2},
  [2159] = {.lex_state = 192, .external_lex_state = 2},
  [2160] = {.lex_state = 192, .external_lex_state = 2},
  [2161] = {.lex_state = 192, .external_lex_state = 2},
  [2162] = {.lex_state = 192, .external_lex_state = 2},
  [2163] = {.lex_state = 192, .external_lex_state = 2},
  [2164] = {.lex_state = 192, .external_lex_state = 2},
  [2165] = {.lex_state = 192, .external_lex_state = 2},
  [2166] = {.lex_state = 239},
  [2167] = {.lex_state = 192, .external_lex_state = 2},
  [2168] = {.lex_state = 494, .external_lex_state = 10},
  [2169] = {.lex_state = 501, .external_lex_state = 3},
  [2170] = {.lex_state = 501, .external_lex_state = 3},
  [2171] = {.lex_state = 501, .external_lex_state = 3},
  [2172] = {.lex_state = 501, .external_lex_state = 14},
  [2173] = {.lex_state = 326, .external_lex_state = 3},
  [2174] = {.lex_state = 528, .external_lex_state = 29},
  [2175] = {.lex_state = 497, .external_lex_state = 3},
  [2176] = {.lex_state = 192, .external_lex_state = 28},
  [2177] = {.lex_state = 192, .external_lex_state = 2},
  [2178] = {.lex_state = 620, .external_lex_state = 14},
  [2179] = {.lex_state = 304, .external_lex_state = 13},
  [2180] = {.lex_state = 304, .external_lex_state = 3},
  [2181] = {.lex_state = 304, .external_lex_state = 3},
  [2182] = {.lex_state = 304, .external_lex_state = 3},
  [2183] = {.lex_state = 304, .external_lex_state = 3},
  [2184] = {.lex_state = 304, .external_lex_state = 3},
  [2185] = {.lex_state = 304, .external_lex_state = 3},
  [2186] = {.lex_state = 304, .external_lex_state = 3},
  [2187] = {.lex_state = 304, .external_lex_state = 3},
  [2188] = {.lex_state = 304, .external_lex_state = 3},
  [2189] = {.lex_state = 304, .external_lex_state = 3},
  [2190] = {.lex_state = 561, .external_lex_state = 16},
  [2191] = {.lex_state = 304, .external_lex_state = 3},
  [2192] = {.lex_state = 304, .external_lex_state = 3},
  [2193] = {.lex_state = 304, .external_lex_state = 3},
  [2194] = {.lex_state = 304, .external_lex_state = 3},
  [2195] = {.lex_state = 192, .external_lex_state = 2},
  [2196] = {.lex_state = 320, .external_lex_state = 10},
  [2197] = {.lex_state = 320, .external_lex_state = 10},
  [2198] = {.lex_state = 320, .external_lex_state = 10},
  [2199] = {.lex_state = 320, .external_lex_state = 10},
  [2200] = {.lex_state = 192, .external_lex_state = 2},
  [2201] = {.lex_state = 192, .external_lex_state = 2},
  [2202] = {.lex_state = 323, .external_lex_state = 3},
  [2203] = {.lex_state = 320, .external_lex_state = 10},
  [2204] = {.lex_state = 213},
  [2205] = {.lex_state = 323, .external_lex_state = 3},
  [2206] = {.lex_state = 323, .external_lex_state = 14},
  [2207] = {.lex_state = 323, .external_lex_state = 3},
  [2208] = {.lex_state = 501, .external_lex_state = 3},
  [2209] = {.lex_state = 621, .external_lex_state = 14},
  [2210] = {.lex_state = 192, .external_lex_state = 2},
  [2211] = {.lex_state = 323, .external_lex_state = 3},
  [2212] = {.lex_state = 501, .external_lex_state = 3},
  [2213] = {.lex_state = 192, .external_lex_state = 2},
  [2214] = {.lex_state = 192, .external_lex_state = 2},
  [2215] = {.lex_state = 192, .external_lex_state = 2},
  [2216] = {.lex_state = 192, .external_lex_state = 2},
  [2217] = {.lex_state = 192, .external_lex_state = 2},
  [2218] = {.lex_state = 192, .external_lex_state = 2},
  [2219] = {.lex_state = 192, .external_lex_state = 2},
  [2220] = {.lex_state = 192, .external_lex_state = 2},
  [2221] = {.lex_state = 192, .external_lex_state = 2},
  [2222] = {.lex_state = 192, .external_lex_state = 2},
  [2223] = {.lex_state = 192, .external_lex_state = 2},
  [2224] = {.lex_state = 323, .external_lex_state = 3},
  [2225] = {.lex_state = 528, .external_lex_state = 29},
  [2226] = {.lex_state = 323, .external_lex_state = 3},
  [2227] = {.lex_state = 192, .external_lex_state = 28},
  [2228] = {.lex_state = 192, .external_lex_state = 2},
  [2229] = {.lex_state = 621, .external_lex_state = 14},
  [2230] = {.lex_state = 192, .external_lex_state = 2},
  [2231] = {.lex_state = 192, .external_lex_state = 2},
  [2232] = {.lex_state = 192, .external_lex_state = 2},
  [2233] = {.lex_state = 192, .external_lex_state = 2},
  [2234] = {.lex_state = 304, .external_lex_state = 3},
  [2235] = {.lex_state = 304, .external_lex_state = 3},
  [2236] = {.lex_state = 213},
  [2237] = {.lex_state = 323, .external_lex_state = 3},
  [2238] = {.lex_state = 504, .external_lex_state = 8},
  [2239] = {.lex_state = 315},
  [2240] = {.lex_state = 304, .external_lex_state = 3},
  [2241] = {.lex_state = 326, .external_lex_state = 14},
  [2242] = {.lex_state = 345, .external_lex_state = 21},
  [2243] = {.lex_state = 332},
  [2244] = {.lex_state = 332},
  [2245] = {.lex_state = 332},
  [2246] = {.lex_state = 332},
  [2247] = {.lex_state = 192, .external_lex_state = 15},
  [2248] = {.lex_state = 268, .external_lex_state = 15},
  [2249] = {.lex_state = 332},
  [2250] = {.lex_state = 177, .external_lex_state = 4},
  [2251] = {.lex_state = 268, .external_lex_state = 15},
  [2252] = {.lex_state = 332},
  [2253] = {.lex_state = 192, .external_lex_state = 15},
  [2254] = {.lex_state = 268, .external_lex_state = 15},
  [2255] = {.lex_state = 332},
  [2256] = {.lex_state = 177, .external_lex_state = 4},
  [2257] = {.lex_state = 268, .external_lex_state = 15},
  [2258] = {.lex_state = 332},
  [2259] = {.lex_state = 194},
  [2260] = {.lex_state = 304, .external_lex_state = 16},
  [2261] = {.lex_state = 227, .external_lex_state = 7},
  [2262] = {.lex_state = 128, .external_lex_state = 2},
  [2263] = {.lex_state = 332},
  [2264] = {.lex_state = 249, .external_lex_state = 3},
  [2265] = {.lex_state = 128, .external_lex_state = 13},
  [2266] = {.lex_state = 128, .external_lex_state = 2},
  [2267] = {.lex_state = 332},
  [2268] = {.lex_state = 128, .external_lex_state = 2},
  [2269] = {.lex_state = 192, .external_lex_state = 2},
  [2270] = {.lex_state = 622, .external_lex_state = 25},
  [2271] = {.lex_state = 622, .external_lex_state = 25},
  [2272] = {.lex_state = 622, .external_lex_state = 25},
  [2273] = {.lex_state = 622, .external_lex_state = 25},
  [2274] = {.lex_state = 192, .external_lex_state = 2},
  [2275] = {.lex_state = 192, .external_lex_state = 2},
  [2276] = {.lex_state = 363, .external_lex_state = 24},
  [2277] = {.lex_state = 625, .external_lex_state = 25},
  [2278] = {.lex_state = 213},
  [2279] = {.lex_state = 261, .external_lex_state = 24},
  [2280] = {.lex_state = 367, .external_lex_state = 26},
  [2281] = {.lex_state = 363, .external_lex_state = 24},
  [2282] = {.lex_state = 192, .external_lex_state = 2},
  [2283] = {.lex_state = 363, .external_lex_state = 24},
  [2284] = {.lex_state = 339, .external_lex_state = 19},
  [2285] = {.lex_state = 209},
  [2286] = {.lex_state = 192, .external_lex_state = 2},
  [2287] = {.lex_state = 177, .external_lex_state = 17},
  [2288] = {.lex_state = 336, .external_lex_state = 19},
  [2289] = {.lex_state = 528, .external_lex_state = 29},
  [2290] = {.lex_state = 342, .external_lex_state = 19},
  [2291] = {.lex_state = 128},
  [2292] = {.lex_state = 128, .external_lex_state = 2},
  [2293] = {.lex_state = 128},
  [2294] = {.lex_state = 128, .external_lex_state = 2},
  [2295] = {.lex_state = 128, .external_lex_state = 2},
  [2296] = {.lex_state = 128, .external_lex_state = 2},
  [2297] = {.lex_state = 128, .external_lex_state = 13},
  [2298] = {.lex_state = 128},
  [2299] = {.lex_state = 332},
  [2300] = {.lex_state = 128},
  [2301] = {.lex_state = 128},
  [2302] = {.lex_state = 128},
  [2303] = {.lex_state = 332},
  [2304] = {.lex_state = 128},
  [2305] = {.lex_state = 128},
  [2306] = {.lex_state = 128},
  [2307] = {.lex_state = 332},
  [2308] = {.lex_state = 332},
  [2309] = {.lex_state = 339},
  [2310] = {.lex_state = 194},
  [2311] = {.lex_state = 288, .external_lex_state = 2},
  [2312] = {.lex_state = 339},
  [2313] = {.lex_state = 128},
  [2314] = {.lex_state = 128, .external_lex_state = 11},
  [2315] = {.lex_state = 416, .external_lex_state = 2},
  [2316] = {.lex_state = 339},
  [2317] = {.lex_state = 488, .external_lex_state = 12},
  [2318] = {.lex_state = 358, .external_lex_state = 12},
  [2319] = {.lex_state = 488, .external_lex_state = 12},
  [2320] = {.lex_state = 488, .external_lex_state = 12},
  [2321] = {.lex_state = 418, .external_lex_state = 27},
  [2322] = {.lex_state = 339},
  [2323] = {.lex_state = 237},
  [2324] = {.lex_state = 488, .external_lex_state = 12},
  [2325] = {.lex_state = 628, .external_lex_state = 24},
  [2326] = {.lex_state = 177, .external_lex_state = 4},
  [2327] = {.lex_state = 177, .external_lex_state = 4},
  [2328] = {.lex_state = 177, .external_lex_state = 4},
  [2329] = {.lex_state = 177, .external_lex_state = 4},
  [2330] = {.lex_state = 190, .external_lex_state = 4},
  [2331] = {.lex_state = 190, .external_lex_state = 4},
  [2332] = {.lex_state = 192, .external_lex_state = 2},
  [2333] = {.lex_state = 194, .external_lex_state = 6},
  [2334] = {.lex_state = 197, .external_lex_state = 7},
  [2335] = {.lex_state = 209, .external_lex_state = 2},
  [2336] = {.lex_state = 216, .external_lex_state = 9},
  [2337] = {.lex_state = 216, .external_lex_state = 8},
  [2338] = {.lex_state = 631, .external_lex_state = 25},
  [2339] = {.lex_state = 631, .external_lex_state = 25},
  [2340] = {.lex_state = 631, .external_lex_state = 25},
  [2341] = {.lex_state = 631, .external_lex_state = 25},
  [2342] = {.lex_state = 221, .external_lex_state = 2},
  [2343] = {.lex_state = 221, .external_lex_state = 2},
  [2344] = {.lex_state = 192, .external_lex_state = 2},
  [2345] = {.lex_state = 192, .external_lex_state = 2},
  [2346] = {.lex_state = 223, .external_lex_state = 8},
  [2347] = {.lex_state = 225, .external_lex_state = 11},
  [2348] = {.lex_state = 128, .external_lex_state = 11},
  [2349] = {.lex_state = 192, .external_lex_state = 2},
  [2350] = {.lex_state = 192, .external_lex_state = 2},
  [2351] = {.lex_state = 628, .external_lex_state = 24},
  [2352] = {.lex_state = 237, .external_lex_state = 12},
  [2353] = {.lex_state = 239},
  [2354] = {.lex_state = 634, .external_lex_state = 24},
  [2355] = {.lex_state = 625, .external_lex_state = 25},
  [2356] = {.lex_state = 213},
  [2357] = {.lex_state = 426, .external_lex_state = 24},
  [2358] = {.lex_state = 634, .external_lex_state = 26},
  [2359] = {.lex_state = 634, .external_lex_state = 24},
  [2360] = {.lex_state = 509, .external_lex_state = 24},
  [2361] = {.lex_state = 637, .external_lex_state = 26},
  [2362] = {.lex_state = 192, .external_lex_state = 2},
  [2363] = {.lex_state = 611, .external_lex_state = 24},
  [2364] = {.lex_state = 634, .external_lex_state = 24},
  [2365] = {.lex_state = 192, .external_lex_state = 2},
  [2366] = {.lex_state = 192, .external_lex_state = 2},
  [2367] = {.lex_state = 239},
  [2368] = {.lex_state = 192, .external_lex_state = 2},
  [2369] = {.lex_state = 298, .external_lex_state = 25},
  [2370] = {.lex_state = 509, .external_lex_state = 24},
  [2371] = {.lex_state = 509, .external_lex_state = 24},
  [2372] = {.lex_state = 509, .external_lex_state = 24},
  [2373] = {.lex_state = 509, .external_lex_state = 26},
  [2374] = {.lex_state = 509, .external_lex_state = 24},
  [2375] = {.lex_state = 192, .external_lex_state = 2},
  [2376] = {.lex_state = 192, .external_lex_state = 2},
  [2377] = {.lex_state = 192, .external_lex_state = 2},
  [2378] = {.lex_state = 192, .external_lex_state = 2},
  [2379] = {.lex_state = 192, .external_lex_state = 2},
  [2380] = {.lex_state = 192, .external_lex_state = 2},
  [2381] = {.lex_state = 192, .external_lex_state = 2},
  [2382] = {.lex_state = 192, .external_lex_state = 2},
  [2383] = {.lex_state = 192, .external_lex_state = 2},
  [2384] = {.lex_state = 192, .external_lex_state = 2},
  [2385] = {.lex_state = 192, .external_lex_state = 2},
  [2386] = {.lex_state = 339},
  [2387] = {.lex_state = 342, .external_lex_state = 19},
  [2388] = {.lex_state = 528, .external_lex_state = 29},
  [2389] = {.lex_state = 342, .external_lex_state = 19},
  [2390] = {.lex_state = 192, .external_lex_state = 28},
  [2391] = {.lex_state = 192, .external_lex_state = 2},
  [2392] = {.lex_state = 637, .external_lex_state = 26},
  [2393] = {.lex_state = 345, .external_lex_state = 21},
  [2394] = {.lex_state = 128, .external_lex_state = 2},
  [2395] = {.lex_state = 249, .external_lex_state = 3},
  [2396] = {.lex_state = 128, .external_lex_state = 2},
  [2397] = {.lex_state = 156, .external_lex_state = 3},
  [2398] = {.lex_state = 348, .external_lex_state = 22},
  [2399] = {.lex_state = 192, .external_lex_state = 2},
  [2400] = {.lex_state = 622, .external_lex_state = 25},
  [2401] = {.lex_state = 622, .external_lex_state = 25},
  [2402] = {.lex_state = 622, .external_lex_state = 25},
  [2403] = {.lex_state = 622, .external_lex_state = 25},
  [2404] = {.lex_state = 192, .external_lex_state = 2},
  [2405] = {.lex_state = 192, .external_lex_state = 2},
  [2406] = {.lex_state = 512, .external_lex_state = 24},
  [2407] = {.lex_state = 213},
  [2408] = {.lex_state = 426, .external_lex_state = 24},
  [2409] = {.lex_state = 638, .external_lex_state = 26},
  [2410] = {.lex_state = 512, .external_lex_state = 24},
  [2411] = {.lex_state = 512, .external_lex_state = 24},
  [2412] = {.lex_state = 641, .external_lex_state = 26},
  [2413] = {.lex_state = 192, .external_lex_state = 2},
  [2414] = {.lex_state = 512, .external_lex_state = 24},
  [2415] = {.lex_state = 512, .external_lex_state = 24},
  [2416] = {.lex_state = 192, .external_lex_state = 2},
  [2417] = {.lex_state = 192, .external_lex_state = 2},
  [2418] = {.lex_state = 239},
  [2419] = {.lex_state = 192, .external_lex_state = 2},
  [2420] = {.lex_state = 298, .external_lex_state = 25},
  [2421] = {.lex_state = 512, .external_lex_state = 24},
  [2422] = {.lex_state = 512, .external_lex_state = 24},
  [2423] = {.lex_state = 512, .external_lex_state = 24},
  [2424] = {.lex_state = 512, .external_lex_state = 26},
  [2425] = {.lex_state = 512, .external_lex_state = 24},
  [2426] = {.lex_state = 192, .external_lex_state = 2},
  [2427] = {.lex_state = 192, .external_lex_state = 2},
  [2428] = {.lex_state = 192, .external_lex_state = 2},
  [2429] = {.lex_state = 192, .external_lex_state = 2},
  [2430] = {.lex_state = 192, .external_lex_state = 2},
  [2431] = {.lex_state = 192, .external_lex_state = 2},
  [2432] = {.lex_state = 192, .external_lex_state = 2},
  [2433] = {.lex_state = 192, .external_lex_state = 2},
  [2434] = {.lex_state = 192, .external_lex_state = 2},
  [2435] = {.lex_state = 192, .external_lex_state = 2},
  [2436] = {.lex_state = 192, .external_lex_state = 2},
  [2437] = {.lex_state = 336, .external_lex_state = 19},
  [2438] = {.lex_state = 528, .external_lex_state = 29},
  [2439] = {.lex_state = 342, .external_lex_state = 19},
  [2440] = {.lex_state = 192, .external_lex_state = 28},
  [2441] = {.lex_state = 192, .external_lex_state = 2},
  [2442] = {.lex_state = 641, .external_lex_state = 26},
  [2443] = {.lex_state = 156, .external_lex_state = 3},
  [2444] = {.lex_state = 367, .external_lex_state = 3},
  [2445] = {.lex_state = 367, .external_lex_state = 3},
  [2446] = {.lex_state = 367, .external_lex_state = 3},
  [2447] = {.lex_state = 367, .external_lex_state = 3},
  [2448] = {.lex_state = 192, .external_lex_state = 2},
  [2449] = {.lex_state = 192, .external_lex_state = 2},
  [2450] = {.lex_state = 192, .external_lex_state = 2},
  [2451] = {.lex_state = 192, .external_lex_state = 2},
  [2452] = {.lex_state = 192, .external_lex_state = 2},
  [2453] = {.lex_state = 192, .external_lex_state = 2},
  [2454] = {.lex_state = 192, .external_lex_state = 2},
  [2455] = {.lex_state = 192, .external_lex_state = 2},
  [2456] = {.lex_state = 192, .external_lex_state = 2},
  [2457] = {.lex_state = 192, .external_lex_state = 2},
  [2458] = {.lex_state = 192, .external_lex_state = 28},
  [2459] = {.lex_state = 192, .external_lex_state = 2},
  [2460] = {.lex_state = 367, .external_lex_state = 14},
  [2461] = {.lex_state = 367, .external_lex_state = 3},
  [2462] = {.lex_state = 363, .external_lex_state = 3},
  [2463] = {.lex_state = 363, .external_lex_state = 3},
  [2464] = {.lex_state = 192, .external_lex_state = 2},
  [2465] = {.lex_state = 363, .external_lex_state = 3},
  [2466] = {.lex_state = 192, .external_lex_state = 2},
  [2467] = {.lex_state = 363, .external_lex_state = 3},
  [2468] = {.lex_state = 528, .external_lex_state = 29},
  [2469] = {.lex_state = 363, .external_lex_state = 3},
  [2470] = {.lex_state = 192, .external_lex_state = 2},
  [2471] = {.lex_state = 642, .external_lex_state = 25},
  [2472] = {.lex_state = 642, .external_lex_state = 25},
  [2473] = {.lex_state = 642, .external_lex_state = 25},
  [2474] = {.lex_state = 642, .external_lex_state = 25},
  [2475] = {.lex_state = 192, .external_lex_state = 2},
  [2476] = {.lex_state = 192, .external_lex_state = 2},
  [2477] = {.lex_state = 304, .external_lex_state = 24},
  [2478] = {.lex_state = 482, .external_lex_state = 25},
  [2479] = {.lex_state = 213},
  [2480] = {.lex_state = 323, .external_lex_state = 24},
  [2481] = {.lex_state = 617, .external_lex_state = 26},
  [2482] = {.lex_state = 304, .external_lex_state = 24},
  [2483] = {.lex_state = 304, .external_lex_state = 24},
  [2484] = {.lex_state = 620, .external_lex_state = 26},
  [2485] = {.lex_state = 192, .external_lex_state = 2},
  [2486] = {.lex_state = 304, .external_lex_state = 24},
  [2487] = {.lex_state = 192, .external_lex_state = 2},
  [2488] = {.lex_state = 192, .external_lex_state = 2},
  [2489] = {.lex_state = 239},
  [2490] = {.lex_state = 192, .external_lex_state = 2},
  [2491] = {.lex_state = 524, .external_lex_state = 25},
  [2492] = {.lex_state = 497, .external_lex_state = 24},
  [2493] = {.lex_state = 497, .external_lex_state = 24},
  [2494] = {.lex_state = 497, .external_lex_state = 24},
  [2495] = {.lex_state = 497, .external_lex_state = 26},
  [2496] = {.lex_state = 304, .external_lex_state = 24},
  [2497] = {.lex_state = 192, .external_lex_state = 2},
  [2498] = {.lex_state = 192, .external_lex_state = 2},
  [2499] = {.lex_state = 192, .external_lex_state = 2},
  [2500] = {.lex_state = 192, .external_lex_state = 2},
  [2501] = {.lex_state = 192, .external_lex_state = 2},
  [2502] = {.lex_state = 192, .external_lex_state = 2},
  [2503] = {.lex_state = 192, .external_lex_state = 2},
  [2504] = {.lex_state = 192, .external_lex_state = 2},
  [2505] = {.lex_state = 192, .external_lex_state = 2},
  [2506] = {.lex_state = 192, .external_lex_state = 2},
  [2507] = {.lex_state = 192, .external_lex_state = 2},
  [2508] = {.lex_state = 192, .external_lex_state = 2},
  [2509] = {.lex_state = 192, .external_lex_state = 2},
  [2510] = {.lex_state = 239},
  [2511] = {.lex_state = 192, .external_lex_state = 2},
  [2512] = {.lex_state = 524, .external_lex_state = 25},
  [2513] = {.lex_state = 501, .external_lex_state = 24},
  [2514] = {.lex_state = 501, .external_lex_state = 24},
  [2515] = {.lex_state = 501, .external_lex_state = 24},
  [2516] = {.lex_state = 501, .external_lex_state = 26},
  [2517] = {.lex_state = 156, .external_lex_state = 3},
  [2518] = {.lex_state = 358, .external_lex_state = 29},
  [2519] = {.lex_state = 304, .external_lex_state = 19},
  [2520] = {.lex_state = 192, .external_lex_state = 28},
  [2521] = {.lex_state = 192, .external_lex_state = 2},
  [2522] = {.lex_state = 620, .external_lex_state = 26},
  [2523] = {.lex_state = 367, .external_lex_state = 3},
  [2524] = {.lex_state = 363, .external_lex_state = 3},
  [2525] = {.lex_state = 363, .external_lex_state = 3},
  [2526] = {.lex_state = 363, .external_lex_state = 3},
  [2527] = {.lex_state = 363, .external_lex_state = 3},
  [2528] = {.lex_state = 363, .external_lex_state = 3},
  [2529] = {.lex_state = 561, .external_lex_state = 16},
  [2530] = {.lex_state = 363, .external_lex_state = 3},
  [2531] = {.lex_state = 363, .external_lex_state = 3},
  [2532] = {.lex_state = 363, .external_lex_state = 3},
  [2533] = {.lex_state = 363, .external_lex_state = 3},
  [2534] = {.lex_state = 518, .external_lex_state = 10},
  [2535] = {.lex_state = 358, .external_lex_state = 12},
  [2536] = {.lex_state = 518, .external_lex_state = 10},
  [2537] = {.lex_state = 518, .external_lex_state = 10},
  [2538] = {.lex_state = 418, .external_lex_state = 27},
  [2539] = {.lex_state = 301, .external_lex_state = 3},
  [2540] = {.lex_state = 237},
  [2541] = {.lex_state = 518, .external_lex_state = 10},
  [2542] = {.lex_state = 423, .external_lex_state = 3},
  [2543] = {.lex_state = 423, .external_lex_state = 3},
  [2544] = {.lex_state = 192, .external_lex_state = 2},
  [2545] = {.lex_state = 301, .external_lex_state = 3},
  [2546] = {.lex_state = 194},
  [2547] = {.lex_state = 288, .external_lex_state = 2},
  [2548] = {.lex_state = 423, .external_lex_state = 3},
  [2549] = {.lex_state = 301, .external_lex_state = 3},
  [2550] = {.lex_state = 128},
  [2551] = {.lex_state = 128, .external_lex_state = 11},
  [2552] = {.lex_state = 416, .external_lex_state = 2},
  [2553] = {.lex_state = 301, .external_lex_state = 3},
  [2554] = {.lex_state = 209},
  [2555] = {.lex_state = 192, .external_lex_state = 2},
  [2556] = {.lex_state = 301, .external_lex_state = 3},
  [2557] = {.lex_state = 177, .external_lex_state = 17},
  [2558] = {.lex_state = 423, .external_lex_state = 3},
  [2559] = {.lex_state = 528, .external_lex_state = 29},
  [2560] = {.lex_state = 423, .external_lex_state = 3},
  [2561] = {.lex_state = 156, .external_lex_state = 3},
  [2562] = {.lex_state = 177, .external_lex_state = 17},
  [2563] = {.lex_state = 264, .external_lex_state = 3},
  [2564] = {.lex_state = 177, .external_lex_state = 17},
  [2565] = {.lex_state = 156, .external_lex_state = 3},
  [2566] = {.lex_state = 528, .external_lex_state = 12},
  [2567] = {.lex_state = 264, .external_lex_state = 3},
  [2568] = {.lex_state = 367, .external_lex_state = 3},
  [2569] = {.lex_state = 363, .external_lex_state = 3},
  [2570] = {.lex_state = 156, .external_lex_state = 3},
  [2571] = {.lex_state = 363, .external_lex_state = 3},
  [2572] = {.lex_state = 363, .external_lex_state = 3},
  [2573] = {.lex_state = 363, .external_lex_state = 14},
  [2574] = {.lex_state = 192, .external_lex_state = 2},
  [2575] = {.lex_state = 515, .external_lex_state = 10},
  [2576] = {.lex_state = 515, .external_lex_state = 10},
  [2577] = {.lex_state = 515, .external_lex_state = 10},
  [2578] = {.lex_state = 515, .external_lex_state = 10},
  [2579] = {.lex_state = 192, .external_lex_state = 2},
  [2580] = {.lex_state = 192, .external_lex_state = 2},
  [2581] = {.lex_state = 363, .external_lex_state = 3},
  [2582] = {.lex_state = 213},
  [2583] = {.lex_state = 261, .external_lex_state = 3},
  [2584] = {.lex_state = 367, .external_lex_state = 14},
  [2585] = {.lex_state = 363, .external_lex_state = 3},
  [2586] = {.lex_state = 363, .external_lex_state = 3},
  [2587] = {.lex_state = 363, .external_lex_state = 14},
  [2588] = {.lex_state = 192, .external_lex_state = 2},
  [2589] = {.lex_state = 363, .external_lex_state = 3},
  [2590] = {.lex_state = 192, .external_lex_state = 2},
  [2591] = {.lex_state = 192, .external_lex_state = 2},
  [2592] = {.lex_state = 239},
  [2593] = {.lex_state = 192, .external_lex_state = 2},
  [2594] = {.lex_state = 360, .external_lex_state = 10},
  [2595] = {.lex_state = 363, .external_lex_state = 3},
  [2596] = {.lex_state = 363, .external_lex_state = 3},
  [2597] = {.lex_state = 363, .external_lex_state = 3},
  [2598] = {.lex_state = 373, .external_lex_state = 14},
  [2599] = {.lex_state = 363, .external_lex_state = 3},
  [2600] = {.lex_state = 192, .external_lex_state = 2},
  [2601] = {.lex_state = 192, .external_lex_state = 2},
  [2602] = {.lex_state = 192, .external_lex_state = 2},
  [2603] = {.lex_state = 192, .external_lex_state = 2},
  [2604] = {.lex_state = 192, .external_lex_state = 2},
  [2605] = {.lex_state = 192, .external_lex_state = 2},
  [2606] = {.lex_state = 192, .external_lex_state = 2},
  [2607] = {.lex_state = 192, .external_lex_state = 2},
  [2608] = {.lex_state = 192, .external_lex_state = 2},
  [2609] = {.lex_state = 192, .external_lex_state = 2},
  [2610] = {.lex_state = 192, .external_lex_state = 2},
  [2611] = {.lex_state = 192, .external_lex_state = 2},
  [2612] = {.lex_state = 192, .external_lex_state = 2},
  [2613] = {.lex_state = 239},
  [2614] = {.lex_state = 192, .external_lex_state = 2},
  [2615] = {.lex_state = 360, .external_lex_state = 10},
  [2616] = {.lex_state = 423, .external_lex_state = 3},
  [2617] = {.lex_state = 423, .external_lex_state = 3},
  [2618] = {.lex_state = 423, .external_lex_state = 3},
  [2619] = {.lex_state = 429, .external_lex_state = 14},
  [2620] = {.lex_state = 264, .external_lex_state = 3},
  [2621] = {.lex_state = 528, .external_lex_state = 29},
  [2622] = {.lex_state = 363, .external_lex_state = 3},
  [2623] = {.lex_state = 192, .external_lex_state = 28},
  [2624] = {.lex_state = 192, .external_lex_state = 2},
  [2625] = {.lex_state = 363, .external_lex_state = 14},
  [2626] = {.lex_state = 256, .external_lex_state = 13},
  [2627] = {.lex_state = 249, .external_lex_state = 3},
  [2628] = {.lex_state = 249, .external_lex_state = 3},
  [2629] = {.lex_state = 249, .external_lex_state = 3},
  [2630] = {.lex_state = 249, .external_lex_state = 3},
  [2631] = {.lex_state = 249, .external_lex_state = 3},
  [2632] = {.lex_state = 192, .external_lex_state = 2},
  [2633] = {.lex_state = 218, .external_lex_state = 10},
  [2634] = {.lex_state = 218, .external_lex_state = 10},
  [2635] = {.lex_state = 218, .external_lex_state = 10},
  [2636] = {.lex_state = 218, .external_lex_state = 10},
  [2637] = {.lex_state = 192, .external_lex_state = 2},
  [2638] = {.lex_state = 192, .external_lex_state = 2},
  [2639] = {.lex_state = 227, .external_lex_state = 7},
  [2640] = {.lex_state = 128},
  [2641] = {.lex_state = 128, .external_lex_state = 13},
  [2642] = {.lex_state = 249, .external_lex_state = 3},
  [2643] = {.lex_state = 256, .external_lex_state = 10},
  [2644] = {.lex_state = 213},
  [2645] = {.lex_state = 261, .external_lex_state = 3},
  [2646] = {.lex_state = 264, .external_lex_state = 14},
  [2647] = {.lex_state = 128, .external_lex_state = 2},
  [2648] = {.lex_state = 156, .external_lex_state = 3},
  [2649] = {.lex_state = 221, .external_lex_state = 2},
  [2650] = {.lex_state = 128},
  [2651] = {.lex_state = 128, .external_lex_state = 2},
  [2652] = {.lex_state = 249, .external_lex_state = 3},
  [2653] = {.lex_state = 249, .external_lex_state = 3},
  [2654] = {.lex_state = 249, .external_lex_state = 3},
  [2655] = {.lex_state = 249, .external_lex_state = 3},
  [2656] = {.lex_state = 249, .external_lex_state = 3},
  [2657] = {.lex_state = 561, .external_lex_state = 16},
  [2658] = {.lex_state = 249, .external_lex_state = 3},
  [2659] = {.lex_state = 249, .external_lex_state = 3},
  [2660] = {.lex_state = 249, .external_lex_state = 3},
  [2661] = {.lex_state = 249, .external_lex_state = 3},
  [2662] = {.lex_state = 192, .external_lex_state = 2},
  [2663] = {.lex_state = 256, .external_lex_state = 10},
  [2664] = {.lex_state = 256, .external_lex_state = 10},
  [2665] = {.lex_state = 256, .external_lex_state = 10},
  [2666] = {.lex_state = 256, .external_lex_state = 10},
  [2667] = {.lex_state = 192, .external_lex_state = 2},
  [2668] = {.lex_state = 192, .external_lex_state = 2},
  [2669] = {.lex_state = 426, .external_lex_state = 3},
  [2670] = {.lex_state = 256, .external_lex_state = 10},
  [2671] = {.lex_state = 213},
  [2672] = {.lex_state = 426, .external_lex_state = 3},
  [2673] = {.lex_state = 426, .external_lex_state = 14},
  [2674] = {.lex_state = 426, .external_lex_state = 3},
  [2675] = {.lex_state = 423, .external_lex_state = 3},
  [2676] = {.lex_state = 423, .external_lex_state = 14},
  [2677] = {.lex_state = 192, .external_lex_state = 2},
  [2678] = {.lex_state = 426, .external_lex_state = 3},
  [2679] = {.lex_state = 423, .external_lex_state = 3},
  [2680] = {.lex_state = 192, .external_lex_state = 2},
  [2681] = {.lex_state = 192, .external_lex_state = 2},
  [2682] = {.lex_state = 192, .external_lex_state = 2},
  [2683] = {.lex_state = 192, .external_lex_state = 2},
  [2684] = {.lex_state = 192, .external_lex_state = 2},
  [2685] = {.lex_state = 192, .external_lex_state = 2},
  [2686] = {.lex_state = 192, .external_lex_state = 2},
  [2687] = {.lex_state = 192, .external_lex_state = 2},
  [2688] = {.lex_state = 192, .external_lex_state = 2},
  [2689] = {.lex_state = 192, .external_lex_state = 2},
  [2690] = {.lex_state = 192, .external_lex_state = 2},
  [2691] = {.lex_state = 426, .external_lex_state = 3},
  [2692] = {.lex_state = 528, .external_lex_state = 29},
  [2693] = {.lex_state = 426, .external_lex_state = 3},
  [2694] = {.lex_state = 192, .external_lex_state = 28},
  [2695] = {.lex_state = 192, .external_lex_state = 2},
  [2696] = {.lex_state = 423, .external_lex_state = 14},
  [2697] = {.lex_state = 192, .external_lex_state = 2},
  [2698] = {.lex_state = 192, .external_lex_state = 2},
  [2699] = {.lex_state = 192, .external_lex_state = 2},
  [2700] = {.lex_state = 192, .external_lex_state = 2},
  [2701] = {.lex_state = 532, .external_lex_state = 3},
  [2702] = {.lex_state = 532, .external_lex_state = 3},
  [2703] = {.lex_state = 213},
  [2704] = {.lex_state = 261, .external_lex_state = 3},
  [2705] = {.lex_state = 249, .external_lex_state = 3},
  [2706] = {.lex_state = 264, .external_lex_state = 14},
  [2707] = {.lex_state = 192, .external_lex_state = 2},
  [2708] = {.lex_state = 218, .external_lex_state = 10},
  [2709] = {.lex_state = 218, .external_lex_state = 10},
  [2710] = {.lex_state = 218, .external_lex_state = 10},
  [2711] = {.lex_state = 218, .external_lex_state = 10},
  [2712] = {.lex_state = 192, .external_lex_state = 2},
  [2713] = {.lex_state = 192, .external_lex_state = 2},
  [2714] = {.lex_state = 227, .external_lex_state = 7},
  [2715] = {.lex_state = 128, .external_lex_state = 13},
  [2716] = {.lex_state = 249, .external_lex_state = 3},
  [2717] = {.lex_state = 256, .external_lex_state = 10},
  [2718] = {.lex_state = 213},
  [2719] = {.lex_state = 261, .external_lex_state = 3},
  [2720] = {.lex_state = 264, .external_lex_state = 14},
  [2721] = {.lex_state = 128, .external_lex_state = 2},
  [2722] = {.lex_state = 156, .external_lex_state = 3},
  [2723] = {.lex_state = 128},
  [2724] = {.lex_state = 128, .external_lex_state = 2},
  [2725] = {.lex_state = 192, .external_lex_state = 2},
  [2726] = {.lex_state = 515, .external_lex_state = 10},
  [2727] = {.lex_state = 515, .external_lex_state = 10},
  [2728] = {.lex_state = 515, .external_lex_state = 10},
  [2729] = {.lex_state = 515, .external_lex_state = 10},
  [2730] = {.lex_state = 192, .external_lex_state = 2},
  [2731] = {.lex_state = 192, .external_lex_state = 2},
  [2732] = {.lex_state = 363, .external_lex_state = 3},
  [2733] = {.lex_state = 213},
  [2734] = {.lex_state = 261, .external_lex_state = 3},
  [2735] = {.lex_state = 367, .external_lex_state = 14},
  [2736] = {.lex_state = 363, .external_lex_state = 3},
  [2737] = {.lex_state = 363, .external_lex_state = 3},
  [2738] = {.lex_state = 363, .external_lex_state = 14},
  [2739] = {.lex_state = 192, .external_lex_state = 2},
  [2740] = {.lex_state = 363, .external_lex_state = 3},
  [2741] = {.lex_state = 192, .external_lex_state = 2},
  [2742] = {.lex_state = 192, .external_lex_state = 2},
  [2743] = {.lex_state = 239},
  [2744] = {.lex_state = 192, .external_lex_state = 2},
  [2745] = {.lex_state = 360, .external_lex_state = 10},
  [2746] = {.lex_state = 363, .external_lex_state = 3},
  [2747] = {.lex_state = 363, .external_lex_state = 3},
  [2748] = {.lex_state = 363, .external_lex_state = 3},
  [2749] = {.lex_state = 373, .external_lex_state = 14},
  [2750] = {.lex_state = 363, .external_lex_state = 3},
  [2751] = {.lex_state = 192, .external_lex_state = 2},
  [2752] = {.lex_state = 192, .external_lex_state = 2},
  [2753] = {.lex_state = 192, .external_lex_state = 2},
  [2754] = {.lex_state = 192, .external_lex_state = 2},
  [2755] = {.lex_state = 192, .external_lex_state = 2},
  [2756] = {.lex_state = 192, .external_lex_state = 2},
  [2757] = {.lex_state = 192, .external_lex_state = 2},
  [2758] = {.lex_state = 192, .external_lex_state = 2},
  [2759] = {.lex_state = 192, .external_lex_state = 2},
  [2760] = {.lex_state = 192, .external_lex_state = 2},
  [2761] = {.lex_state = 192, .external_lex_state = 2},
  [2762] = {.lex_state = 192, .external_lex_state = 2},
  [2763] = {.lex_state = 192, .external_lex_state = 2},
  [2764] = {.lex_state = 239},
  [2765] = {.lex_state = 421, .external_lex_state = 6},
  [2766] = {.lex_state = 192, .external_lex_state = 2},
  [2767] = {.lex_state = 360, .external_lex_state = 10},
  [2768] = {.lex_state = 423, .external_lex_state = 3},
  [2769] = {.lex_state = 423, .external_lex_state = 3},
  [2770] = {.lex_state = 423, .external_lex_state = 3},
  [2771] = {.lex_state = 429, .external_lex_state = 14},
  [2772] = {.lex_state = 264, .external_lex_state = 3},
  [2773] = {.lex_state = 528, .external_lex_state = 29},
  [2774] = {.lex_state = 363, .external_lex_state = 3},
  [2775] = {.lex_state = 192, .external_lex_state = 28},
  [2776] = {.lex_state = 192, .external_lex_state = 2},
  [2777] = {.lex_state = 363, .external_lex_state = 14},
  [2778] = {.lex_state = 249, .external_lex_state = 3},
  [2779] = {.lex_state = 249, .external_lex_state = 3},
  [2780] = {.lex_state = 249, .external_lex_state = 3},
  [2781] = {.lex_state = 249, .external_lex_state = 3},
  [2782] = {.lex_state = 249, .external_lex_state = 3},
  [2783] = {.lex_state = 561, .external_lex_state = 16},
  [2784] = {.lex_state = 249, .external_lex_state = 3},
  [2785] = {.lex_state = 249, .external_lex_state = 3},
  [2786] = {.lex_state = 249, .external_lex_state = 3},
  [2787] = {.lex_state = 249, .external_lex_state = 3},
  [2788] = {.lex_state = 156, .external_lex_state = 3},
  [2789] = {.lex_state = 128},
  [2790] = {.lex_state = 192, .external_lex_state = 2},
  [2791] = {.lex_state = 256, .external_lex_state = 10},
  [2792] = {.lex_state = 256, .external_lex_state = 10},
  [2793] = {.lex_state = 256, .external_lex_state = 10},
  [2794] = {.lex_state = 256, .external_lex_state = 10},
  [2795] = {.lex_state = 192, .external_lex_state = 2},
  [2796] = {.lex_state = 192, .external_lex_state = 2},
  [2797] = {.lex_state = 426, .external_lex_state = 3},
  [2798] = {.lex_state = 256, .external_lex_state = 10},
  [2799] = {.lex_state = 213},
  [2800] = {.lex_state = 426, .external_lex_state = 3},
  [2801] = {.lex_state = 426, .external_lex_state = 14},
  [2802] = {.lex_state = 426, .external_lex_state = 3},
  [2803] = {.lex_state = 423, .external_lex_state = 3},
  [2804] = {.lex_state = 423, .external_lex_state = 14},
  [2805] = {.lex_state = 192, .external_lex_state = 2},
  [2806] = {.lex_state = 423, .external_lex_state = 3},
  [2807] = {.lex_state = 426, .external_lex_state = 3},
  [2808] = {.lex_state = 423, .external_lex_state = 3},
  [2809] = {.lex_state = 192, .external_lex_state = 2},
  [2810] = {.lex_state = 192, .external_lex_state = 2},
  [2811] = {.lex_state = 192, .external_lex_state = 2},
  [2812] = {.lex_state = 192, .external_lex_state = 2},
  [2813] = {.lex_state = 192, .external_lex_state = 2},
  [2814] = {.lex_state = 192, .external_lex_state = 2},
  [2815] = {.lex_state = 192, .external_lex_state = 2},
  [2816] = {.lex_state = 192, .external_lex_state = 2},
  [2817] = {.lex_state = 192, .external_lex_state = 2},
  [2818] = {.lex_state = 192, .external_lex_state = 2},
  [2819] = {.lex_state = 192, .external_lex_state = 2},
  [2820] = {.lex_state = 426, .external_lex_state = 3},
  [2821] = {.lex_state = 528, .external_lex_state = 29},
  [2822] = {.lex_state = 426, .external_lex_state = 3},
  [2823] = {.lex_state = 192, .external_lex_state = 28},
  [2824] = {.lex_state = 192, .external_lex_state = 2},
  [2825] = {.lex_state = 423, .external_lex_state = 14},
  [2826] = {.lex_state = 192, .external_lex_state = 2},
  [2827] = {.lex_state = 192, .external_lex_state = 2},
  [2828] = {.lex_state = 192, .external_lex_state = 2},
  [2829] = {.lex_state = 192, .external_lex_state = 2},
  [2830] = {.lex_state = 532, .external_lex_state = 3},
  [2831] = {.lex_state = 532, .external_lex_state = 3},
  [2832] = {.lex_state = 213},
  [2833] = {.lex_state = 261, .external_lex_state = 3},
  [2834] = {.lex_state = 249, .external_lex_state = 3},
  [2835] = {.lex_state = 264, .external_lex_state = 14},
  [2836] = {.lex_state = 156, .external_lex_state = 3},
  [2837] = {.lex_state = 128},
  [2838] = {.lex_state = 192, .external_lex_state = 2},
  [2839] = {.lex_state = 622, .external_lex_state = 25},
  [2840] = {.lex_state = 622, .external_lex_state = 25},
  [2841] = {.lex_state = 622, .external_lex_state = 25},
  [2842] = {.lex_state = 622, .external_lex_state = 25},
  [2843] = {.lex_state = 192, .external_lex_state = 2},
  [2844] = {.lex_state = 192, .external_lex_state = 2},
  [2845] = {.lex_state = 512, .external_lex_state = 24},
  [2846] = {.lex_state = 625, .external_lex_state = 25},
  [2847] = {.lex_state = 213},
  [2848] = {.lex_state = 426, .external_lex_state = 24},
  [2849] = {.lex_state = 638, .external_lex_state = 26},
  [2850] = {.lex_state = 512, .external_lex_state = 24},
  [2851] = {.lex_state = 512, .external_lex_state = 24},
  [2852] = {.lex_state = 641, .external_lex_state = 26},
  [2853] = {.lex_state = 192, .external_lex_state = 2},
  [2854] = {.lex_state = 512, .external_lex_state = 24},
  [2855] = {.lex_state = 192, .external_lex_state = 2},
  [2856] = {.lex_state = 192, .external_lex_state = 2},
  [2857] = {.lex_state = 239},
  [2858] = {.lex_state = 192, .external_lex_state = 2},
  [2859] = {.lex_state = 298, .external_lex_state = 25},
  [2860] = {.lex_state = 512, .external_lex_state = 24},
  [2861] = {.lex_state = 512, .external_lex_state = 24},
  [2862] = {.lex_state = 512, .external_lex_state = 24},
  [2863] = {.lex_state = 512, .external_lex_state = 26},
  [2864] = {.lex_state = 512, .external_lex_state = 24},
  [2865] = {.lex_state = 192, .external_lex_state = 2},
  [2866] = {.lex_state = 192, .external_lex_state = 2},
  [2867] = {.lex_state = 192, .external_lex_state = 2},
  [2868] = {.lex_state = 192, .external_lex_state = 2},
  [2869] = {.lex_state = 192, .external_lex_state = 2},
  [2870] = {.lex_state = 192, .external_lex_state = 2},
  [2871] = {.lex_state = 192, .external_lex_state = 2},
  [2872] = {.lex_state = 192, .external_lex_state = 2},
  [2873] = {.lex_state = 192, .external_lex_state = 2},
  [2874] = {.lex_state = 192, .external_lex_state = 2},
  [2875] = {.lex_state = 192, .external_lex_state = 2},
  [2876] = {.lex_state = 192, .external_lex_state = 2},
  [2877] = {.lex_state = 192, .external_lex_state = 2},
  [2878] = {.lex_state = 192, .external_lex_state = 2},
  [2879] = {.lex_state = 239},
  [2880] = {.lex_state = 192, .external_lex_state = 2},
  [2881] = {.lex_state = 306, .external_lex_state = 25},
  [2882] = {.lex_state = 306, .external_lex_state = 25},
  [2883] = {.lex_state = 306, .external_lex_state = 25},
  [2884] = {.lex_state = 306, .external_lex_state = 25},
  [2885] = {.lex_state = 192, .external_lex_state = 2},
  [2886] = {.lex_state = 192, .external_lex_state = 2},
  [2887] = {.lex_state = 298, .external_lex_state = 25},
  [2888] = {.lex_state = 423, .external_lex_state = 24},
  [2889] = {.lex_state = 423, .external_lex_state = 24},
  [2890] = {.lex_state = 423, .external_lex_state = 24},
  [2891] = {.lex_state = 213},
  [2892] = {.lex_state = 423, .external_lex_state = 24},
  [2893] = {.lex_state = 429, .external_lex_state = 26},
  [2894] = {.lex_state = 342, .external_lex_state = 19},
  [2895] = {.lex_state = 528, .external_lex_state = 29},
  [2896] = {.lex_state = 342, .external_lex_state = 19},
  [2897] = {.lex_state = 192, .external_lex_state = 28},
  [2898] = {.lex_state = 192, .external_lex_state = 2},
  [2899] = {.lex_state = 641, .external_lex_state = 26},
  [2900] = {.lex_state = 249, .external_lex_state = 3},
  [2901] = {.lex_state = 128, .external_lex_state = 2},
  [2902] = {.lex_state = 223, .external_lex_state = 8},
  [2903] = {.lex_state = 156},
  [2904] = {.lex_state = 192, .external_lex_state = 2},
  [2905] = {.lex_state = 515, .external_lex_state = 10},
  [2906] = {.lex_state = 515, .external_lex_state = 10},
  [2907] = {.lex_state = 515, .external_lex_state = 10},
  [2908] = {.lex_state = 515, .external_lex_state = 10},
  [2909] = {.lex_state = 192, .external_lex_state = 2},
  [2910] = {.lex_state = 192, .external_lex_state = 2},
  [2911] = {.lex_state = 363, .external_lex_state = 3},
  [2912] = {.lex_state = 213},
  [2913] = {.lex_state = 261, .external_lex_state = 3},
  [2914] = {.lex_state = 367, .external_lex_state = 14},
  [2915] = {.lex_state = 363, .external_lex_state = 3},
  [2916] = {.lex_state = 363, .external_lex_state = 3},
  [2917] = {.lex_state = 363, .external_lex_state = 14},
  [2918] = {.lex_state = 192, .external_lex_state = 2},
  [2919] = {.lex_state = 363, .external_lex_state = 3},
  [2920] = {.lex_state = 192, .external_lex_state = 2},
  [2921] = {.lex_state = 192, .external_lex_state = 2},
  [2922] = {.lex_state = 239},
  [2923] = {.lex_state = 192, .external_lex_state = 2},
  [2924] = {.lex_state = 360, .external_lex_state = 10},
  [2925] = {.lex_state = 363, .external_lex_state = 3},
  [2926] = {.lex_state = 363, .external_lex_state = 3},
  [2927] = {.lex_state = 363, .external_lex_state = 3},
  [2928] = {.lex_state = 373, .external_lex_state = 14},
  [2929] = {.lex_state = 363, .external_lex_state = 3},
  [2930] = {.lex_state = 192, .external_lex_state = 2},
  [2931] = {.lex_state = 192, .external_lex_state = 2},
  [2932] = {.lex_state = 192, .external_lex_state = 2},
  [2933] = {.lex_state = 192, .external_lex_state = 2},
  [2934] = {.lex_state = 192, .external_lex_state = 2},
  [2935] = {.lex_state = 192, .external_lex_state = 2},
  [2936] = {.lex_state = 192, .external_lex_state = 2},
  [2937] = {.lex_state = 192, .external_lex_state = 2},
  [2938] = {.lex_state = 192, .external_lex_state = 2},
  [2939] = {.lex_state = 192, .external_lex_state = 2},
  [2940] = {.lex_state = 192, .external_lex_state = 2},
  [2941] = {.lex_state = 264, .external_lex_state = 3},
  [2942] = {.lex_state = 528, .external_lex_state = 29},
  [2943] = {.lex_state = 363, .external_lex_state = 3},
  [2944] = {.lex_state = 192, .external_lex_state = 28},
  [2945] = {.lex_state = 192, .external_lex_state = 2},
  [2946] = {.lex_state = 363, .external_lex_state = 14},
  [2947] = {.lex_state = 249, .external_lex_state = 3},
  [2948] = {.lex_state = 249, .external_lex_state = 3},
  [2949] = {.lex_state = 249, .external_lex_state = 3},
  [2950] = {.lex_state = 249, .external_lex_state = 3},
  [2951] = {.lex_state = 249, .external_lex_state = 3},
  [2952] = {.lex_state = 561, .external_lex_state = 16},
  [2953] = {.lex_state = 249, .external_lex_state = 3},
  [2954] = {.lex_state = 249, .external_lex_state = 3},
  [2955] = {.lex_state = 249, .external_lex_state = 3},
  [2956] = {.lex_state = 249, .external_lex_state = 3},
  [2957] = {.lex_state = 156, .external_lex_state = 3},
  [2958] = {.lex_state = 128},
  [2959] = {.lex_state = 128},
  [2960] = {.lex_state = 128},
  [2961] = {.lex_state = 192, .external_lex_state = 2},
  [2962] = {.lex_state = 192, .external_lex_state = 2},
  [2963] = {.lex_state = 192, .external_lex_state = 2},
  [2964] = {.lex_state = 192, .external_lex_state = 2},
  [2965] = {.lex_state = 532, .external_lex_state = 3},
  [2966] = {.lex_state = 532, .external_lex_state = 3},
  [2967] = {.lex_state = 213},
  [2968] = {.lex_state = 261, .external_lex_state = 3},
  [2969] = {.lex_state = 249, .external_lex_state = 3},
  [2970] = {.lex_state = 264, .external_lex_state = 14},
  [2971] = {.lex_state = 192, .external_lex_state = 2},
  [2972] = {.lex_state = 192, .external_lex_state = 2},
  [2973] = {.lex_state = 515, .external_lex_state = 10},
  [2974] = {.lex_state = 515, .external_lex_state = 10},
  [2975] = {.lex_state = 515, .external_lex_state = 10},
  [2976] = {.lex_state = 515, .external_lex_state = 10},
  [2977] = {.lex_state = 192, .external_lex_state = 2},
  [2978] = {.lex_state = 192, .external_lex_state = 2},
  [2979] = {.lex_state = 256, .external_lex_state = 13},
  [2980] = {.lex_state = 532, .external_lex_state = 3},
  [2981] = {.lex_state = 256, .external_lex_state = 10},
  [2982] = {.lex_state = 256, .external_lex_state = 13},
  [2983] = {.lex_state = 213},
  [2984] = {.lex_state = 261, .external_lex_state = 3},
  [2985] = {.lex_state = 367, .external_lex_state = 14},
  [2986] = {.lex_state = 128, .external_lex_state = 2},
  [2987] = {.lex_state = 128},
  [2988] = {.lex_state = 128},
  [2989] = {.lex_state = 530, .external_lex_state = 2},
  [2990] = {.lex_state = 192, .external_lex_state = 2},
  [2991] = {.lex_state = 515, .external_lex_state = 10},
  [2992] = {.lex_state = 515, .external_lex_state = 10},
  [2993] = {.lex_state = 515, .external_lex_state = 10},
  [2994] = {.lex_state = 515, .external_lex_state = 10},
  [2995] = {.lex_state = 192, .external_lex_state = 2},
  [2996] = {.lex_state = 192, .external_lex_state = 2},
  [2997] = {.lex_state = 363, .external_lex_state = 3},
  [2998] = {.lex_state = 213},
  [2999] = {.lex_state = 261, .external_lex_state = 3},
  [3000] = {.lex_state = 367, .external_lex_state = 14},
  [3001] = {.lex_state = 363, .external_lex_state = 3},
  [3002] = {.lex_state = 363, .external_lex_state = 3},
  [3003] = {.lex_state = 363, .external_lex_state = 14},
  [3004] = {.lex_state = 192, .external_lex_state = 2},
  [3005] = {.lex_state = 363, .external_lex_state = 3},
  [3006] = {.lex_state = 192, .external_lex_state = 2},
  [3007] = {.lex_state = 192, .external_lex_state = 2},
  [3008] = {.lex_state = 239},
  [3009] = {.lex_state = 192, .external_lex_state = 2},
  [3010] = {.lex_state = 360, .external_lex_state = 10},
  [3011] = {.lex_state = 363, .external_lex_state = 3},
  [3012] = {.lex_state = 363, .external_lex_state = 3},
  [3013] = {.lex_state = 363, .external_lex_state = 3},
  [3014] = {.lex_state = 373, .external_lex_state = 14},
  [3015] = {.lex_state = 363, .external_lex_state = 3},
  [3016] = {.lex_state = 192, .external_lex_state = 2},
  [3017] = {.lex_state = 192, .external_lex_state = 2},
  [3018] = {.lex_state = 192, .external_lex_state = 2},
  [3019] = {.lex_state = 192, .external_lex_state = 2},
  [3020] = {.lex_state = 192, .external_lex_state = 2},
  [3021] = {.lex_state = 192, .external_lex_state = 2},
  [3022] = {.lex_state = 192, .external_lex_state = 2},
  [3023] = {.lex_state = 192, .external_lex_state = 2},
  [3024] = {.lex_state = 192, .external_lex_state = 2},
  [3025] = {.lex_state = 192, .external_lex_state = 2},
  [3026] = {.lex_state = 192, .external_lex_state = 2},
  [3027] = {.lex_state = 192, .external_lex_state = 2},
  [3028] = {.lex_state = 192, .external_lex_state = 2},
  [3029] = {.lex_state = 239},
  [3030] = {.lex_state = 192, .external_lex_state = 2},
  [3031] = {.lex_state = 360, .external_lex_state = 10},
  [3032] = {.lex_state = 423, .external_lex_state = 3},
  [3033] = {.lex_state = 423, .external_lex_state = 3},
  [3034] = {.lex_state = 423, .external_lex_state = 3},
  [3035] = {.lex_state = 429, .external_lex_state = 14},
  [3036] = {.lex_state = 264, .external_lex_state = 3},
  [3037] = {.lex_state = 528, .external_lex_state = 29},
  [3038] = {.lex_state = 363, .external_lex_state = 3},
  [3039] = {.lex_state = 192, .external_lex_state = 28},
  [3040] = {.lex_state = 192, .external_lex_state = 2},
  [3041] = {.lex_state = 363, .external_lex_state = 14},
  [3042] = {.lex_state = 532, .external_lex_state = 3},
  [3043] = {.lex_state = 532, .external_lex_state = 3},
  [3044] = {.lex_state = 192, .external_lex_state = 2},
  [3045] = {.lex_state = 192, .external_lex_state = 2},
  [3046] = {.lex_state = 192, .external_lex_state = 2},
  [3047] = {.lex_state = 239},
  [3048] = {.lex_state = 192, .external_lex_state = 2},
  [3049] = {.lex_state = 192, .external_lex_state = 2},
  [3050] = {.lex_state = 192, .external_lex_state = 2},
  [3051] = {.lex_state = 360, .external_lex_state = 10},
  [3052] = {.lex_state = 363, .external_lex_state = 3},
  [3053] = {.lex_state = 363, .external_lex_state = 3},
  [3054] = {.lex_state = 363, .external_lex_state = 3},
  [3055] = {.lex_state = 213},
  [3056] = {.lex_state = 370, .external_lex_state = 3},
  [3057] = {.lex_state = 373, .external_lex_state = 14},
  [3058] = {.lex_state = 345, .external_lex_state = 13},
  [3059] = {.lex_state = 345, .external_lex_state = 13},
  [3060] = {.lex_state = 345, .external_lex_state = 13},
  [3061] = {.lex_state = 332},
  [3062] = {.lex_state = 352, .external_lex_state = 22},
  [3063] = {.lex_state = 345, .external_lex_state = 13},
  [3064] = {.lex_state = 532, .external_lex_state = 3},
  [3065] = {.lex_state = 128},
  [3066] = {.lex_state = 128},
  [3067] = {.lex_state = 128, .external_lex_state = 13},
  [3068] = {.lex_state = 128, .external_lex_state = 2},
  [3069] = {.lex_state = 192, .external_lex_state = 2},
  [3070] = {.lex_state = 192, .external_lex_state = 2},
  [3071] = {.lex_state = 192, .external_lex_state = 2},
  [3072] = {.lex_state = 192, .external_lex_state = 2},
  [3073] = {.lex_state = 192, .external_lex_state = 2},
  [3074] = {.lex_state = 192, .external_lex_state = 2},
  [3075] = {.lex_state = 192, .external_lex_state = 2},
  [3076] = {.lex_state = 192, .external_lex_state = 2},
  [3077] = {.lex_state = 192, .external_lex_state = 2},
  [3078] = {.lex_state = 192, .external_lex_state = 2},
  [3079] = {.lex_state = 192, .external_lex_state = 2},
  [3080] = {.lex_state = 192, .external_lex_state = 2},
  [3081] = {.lex_state = 192, .external_lex_state = 2},
  [3082] = {.lex_state = 239},
  [3083] = {.lex_state = 192, .external_lex_state = 2},
  [3084] = {.lex_state = 366, .external_lex_state = 10},
  [3085] = {.lex_state = 366, .external_lex_state = 10},
  [3086] = {.lex_state = 366, .external_lex_state = 10},
  [3087] = {.lex_state = 366, .external_lex_state = 10},
  [3088] = {.lex_state = 192, .external_lex_state = 2},
  [3089] = {.lex_state = 192, .external_lex_state = 2},
  [3090] = {.lex_state = 360, .external_lex_state = 10},
  [3091] = {.lex_state = 423, .external_lex_state = 3},
  [3092] = {.lex_state = 366, .external_lex_state = 10},
  [3093] = {.lex_state = 423, .external_lex_state = 3},
  [3094] = {.lex_state = 423, .external_lex_state = 3},
  [3095] = {.lex_state = 213},
  [3096] = {.lex_state = 423, .external_lex_state = 3},
  [3097] = {.lex_state = 429, .external_lex_state = 14},
  [3098] = {.lex_state = 192, .external_lex_state = 28},
  [3099] = {.lex_state = 355, .external_lex_state = 13},
  [3100] = {.lex_state = 192, .external_lex_state = 28},
  [3101] = {.lex_state = 192, .external_lex_state = 2},
  [3102] = {.lex_state = 363, .external_lex_state = 14},
  [3103] = {.lex_state = 128, .external_lex_state = 2},
  [3104] = {.lex_state = 249, .external_lex_state = 3},
  [3105] = {.lex_state = 192, .external_lex_state = 2},
  [3106] = {.lex_state = 192, .external_lex_state = 2},
  [3107] = {.lex_state = 192, .external_lex_state = 2},
  [3108] = {.lex_state = 239},
  [3109] = {.lex_state = 192, .external_lex_state = 2},
  [3110] = {.lex_state = 355, .external_lex_state = 10},
  [3111] = {.lex_state = 355, .external_lex_state = 10},
  [3112] = {.lex_state = 355, .external_lex_state = 10},
  [3113] = {.lex_state = 355, .external_lex_state = 10},
  [3114] = {.lex_state = 192, .external_lex_state = 2},
  [3115] = {.lex_state = 192, .external_lex_state = 2},
  [3116] = {.lex_state = 360, .external_lex_state = 10},
  [3117] = {.lex_state = 363, .external_lex_state = 3},
  [3118] = {.lex_state = 366, .external_lex_state = 10},
  [3119] = {.lex_state = 264, .external_lex_state = 3},
  [3120] = {.lex_state = 363, .external_lex_state = 3},
  [3121] = {.lex_state = 213},
  [3122] = {.lex_state = 370, .external_lex_state = 3},
  [3123] = {.lex_state = 373, .external_lex_state = 14},
  [3124] = {.lex_state = 249, .external_lex_state = 3},
  [3125] = {.lex_state = 256, .external_lex_state = 13},
  [3126] = {.lex_state = 192, .external_lex_state = 2},
  [3127] = {.lex_state = 192, .external_lex_state = 2},
  [3128] = {.lex_state = 192, .external_lex_state = 2},
  [3129] = {.lex_state = 192, .external_lex_state = 2},
  [3130] = {.lex_state = 192, .external_lex_state = 2},
  [3131] = {.lex_state = 192, .external_lex_state = 2},
  [3132] = {.lex_state = 192, .external_lex_state = 2},
  [3133] = {.lex_state = 192, .external_lex_state = 2},
  [3134] = {.lex_state = 192, .external_lex_state = 2},
  [3135] = {.lex_state = 192, .external_lex_state = 2},
  [3136] = {.lex_state = 192, .external_lex_state = 2},
  [3137] = {.lex_state = 192, .external_lex_state = 2},
  [3138] = {.lex_state = 192, .external_lex_state = 2},
  [3139] = {.lex_state = 192, .external_lex_state = 2},
  [3140] = {.lex_state = 192, .external_lex_state = 2},
  [3141] = {.lex_state = 192, .external_lex_state = 2},
  [3142] = {.lex_state = 192, .external_lex_state = 2},
  [3143] = {.lex_state = 192, .external_lex_state = 2},
  [3144] = {.lex_state = 239},
  [3145] = {.lex_state = 192, .external_lex_state = 2},
  [3146] = {.lex_state = 366, .external_lex_state = 10},
  [3147] = {.lex_state = 366, .external_lex_state = 10},
  [3148] = {.lex_state = 366, .external_lex_state = 10},
  [3149] = {.lex_state = 366, .external_lex_state = 10},
  [3150] = {.lex_state = 192, .external_lex_state = 2},
  [3151] = {.lex_state = 192, .external_lex_state = 2},
  [3152] = {.lex_state = 360, .external_lex_state = 10},
  [3153] = {.lex_state = 423, .external_lex_state = 3},
  [3154] = {.lex_state = 366, .external_lex_state = 10},
  [3155] = {.lex_state = 426, .external_lex_state = 3},
  [3156] = {.lex_state = 426, .external_lex_state = 3},
  [3157] = {.lex_state = 213},
  [3158] = {.lex_state = 423, .external_lex_state = 3},
  [3159] = {.lex_state = 429, .external_lex_state = 14},
  [3160] = {.lex_state = 192, .external_lex_state = 28},
  [3161] = {.lex_state = 192, .external_lex_state = 2},
  [3162] = {.lex_state = 264, .external_lex_state = 14},
  [3163] = {.lex_state = 128},
  [3164] = {.lex_state = 128, .external_lex_state = 13},
  [3165] = {.lex_state = 128, .external_lex_state = 2},
  [3166] = {.lex_state = 249, .external_lex_state = 3},
  [3167] = {.lex_state = 192, .external_lex_state = 2},
  [3168] = {.lex_state = 192, .external_lex_state = 2},
  [3169] = {.lex_state = 192, .external_lex_state = 2},
  [3170] = {.lex_state = 239},
  [3171] = {.lex_state = 192, .external_lex_state = 2},
  [3172] = {.lex_state = 355, .external_lex_state = 10},
  [3173] = {.lex_state = 355, .external_lex_state = 10},
  [3174] = {.lex_state = 355, .external_lex_state = 10},
  [3175] = {.lex_state = 355, .external_lex_state = 10},
  [3176] = {.lex_state = 192, .external_lex_state = 2},
  [3177] = {.lex_state = 192, .external_lex_state = 2},
  [3178] = {.lex_state = 360, .external_lex_state = 10},
  [3179] = {.lex_state = 363, .external_lex_state = 3},
  [3180] = {.lex_state = 366, .external_lex_state = 10},
  [3181] = {.lex_state = 264, .external_lex_state = 3},
  [3182] = {.lex_state = 363, .external_lex_state = 3},
  [3183] = {.lex_state = 213},
  [3184] = {.lex_state = 370, .external_lex_state = 3},
  [3185] = {.lex_state = 373, .external_lex_state = 14},
  [3186] = {.lex_state = 249, .external_lex_state = 3},
  [3187] = {.lex_state = 256, .external_lex_state = 13},
  [3188] = {.lex_state = 192, .external_lex_state = 2},
  [3189] = {.lex_state = 192, .external_lex_state = 2},
  [3190] = {.lex_state = 192, .external_lex_state = 2},
  [3191] = {.lex_state = 192, .external_lex_state = 2},
  [3192] = {.lex_state = 192, .external_lex_state = 2},
  [3193] = {.lex_state = 192, .external_lex_state = 2},
  [3194] = {.lex_state = 192, .external_lex_state = 2},
  [3195] = {.lex_state = 192, .external_lex_state = 2},
  [3196] = {.lex_state = 192, .external_lex_state = 2},
  [3197] = {.lex_state = 192, .external_lex_state = 2},
  [3198] = {.lex_state = 192, .external_lex_state = 2},
  [3199] = {.lex_state = 192, .external_lex_state = 2},
  [3200] = {.lex_state = 192, .external_lex_state = 2},
  [3201] = {.lex_state = 192, .external_lex_state = 2},
  [3202] = {.lex_state = 192, .external_lex_state = 2},
  [3203] = {.lex_state = 192, .external_lex_state = 2},
  [3204] = {.lex_state = 192, .external_lex_state = 2},
  [3205] = {.lex_state = 192, .external_lex_state = 2},
  [3206] = {.lex_state = 239},
  [3207] = {.lex_state = 192, .external_lex_state = 2},
  [3208] = {.lex_state = 366, .external_lex_state = 10},
  [3209] = {.lex_state = 366, .external_lex_state = 10},
  [3210] = {.lex_state = 366, .external_lex_state = 10},
  [3211] = {.lex_state = 366, .external_lex_state = 10},
  [3212] = {.lex_state = 192, .external_lex_state = 2},
  [3213] = {.lex_state = 192, .external_lex_state = 2},
  [3214] = {.lex_state = 360, .external_lex_state = 10},
  [3215] = {.lex_state = 423, .external_lex_state = 3},
  [3216] = {.lex_state = 366, .external_lex_state = 10},
  [3217] = {.lex_state = 426, .external_lex_state = 3},
  [3218] = {.lex_state = 426, .external_lex_state = 3},
  [3219] = {.lex_state = 213},
  [3220] = {.lex_state = 423, .external_lex_state = 3},
  [3221] = {.lex_state = 429, .external_lex_state = 14},
  [3222] = {.lex_state = 192, .external_lex_state = 28},
  [3223] = {.lex_state = 192, .external_lex_state = 2},
  [3224] = {.lex_state = 264, .external_lex_state = 14},
  [3225] = {.lex_state = 128, .external_lex_state = 13},
  [3226] = {.lex_state = 128, .external_lex_state = 2},
  [3227] = {.lex_state = 256, .external_lex_state = 13},
  [3228] = {.lex_state = 156, .external_lex_state = 3},
  [3229] = {.lex_state = 128},
  [3230] = {.lex_state = 128},
  [3231] = {.lex_state = 249, .external_lex_state = 3},
  [3232] = {.lex_state = 249, .external_lex_state = 3},
  [3233] = {.lex_state = 249, .external_lex_state = 3},
  [3234] = {.lex_state = 249, .external_lex_state = 3},
  [3235] = {.lex_state = 249, .external_lex_state = 3},
  [3236] = {.lex_state = 249, .external_lex_state = 3},
  [3237] = {.lex_state = 249, .external_lex_state = 3},
  [3238] = {.lex_state = 249, .external_lex_state = 3},
  [3239] = {.lex_state = 249, .external_lex_state = 3},
  [3240] = {.lex_state = 249, .external_lex_state = 3},
  [3241] = {.lex_state = 561, .external_lex_state = 16},
  [3242] = {.lex_state = 249, .external_lex_state = 3},
  [3243] = {.lex_state = 249, .external_lex_state = 3},
  [3244] = {.lex_state = 249, .external_lex_state = 3},
  [3245] = {.lex_state = 249, .external_lex_state = 3},
  [3246] = {.lex_state = 192, .external_lex_state = 2},
  [3247] = {.lex_state = 256, .external_lex_state = 10},
  [3248] = {.lex_state = 256, .external_lex_state = 10},
  [3249] = {.lex_state = 256, .external_lex_state = 10},
  [3250] = {.lex_state = 256, .external_lex_state = 10},
  [3251] = {.lex_state = 192, .external_lex_state = 2},
  [3252] = {.lex_state = 192, .external_lex_state = 2},
  [3253] = {.lex_state = 426, .external_lex_state = 3},
  [3254] = {.lex_state = 256, .external_lex_state = 10},
  [3255] = {.lex_state = 213},
  [3256] = {.lex_state = 426, .external_lex_state = 3},
  [3257] = {.lex_state = 426, .external_lex_state = 14},
  [3258] = {.lex_state = 426, .external_lex_state = 3},
  [3259] = {.lex_state = 423, .external_lex_state = 3},
  [3260] = {.lex_state = 423, .external_lex_state = 14},
  [3261] = {.lex_state = 192, .external_lex_state = 2},
  [3262] = {.lex_state = 426, .external_lex_state = 3},
  [3263] = {.lex_state = 423, .external_lex_state = 3},
  [3264] = {.lex_state = 192, .external_lex_state = 2},
  [3265] = {.lex_state = 192, .external_lex_state = 2},
  [3266] = {.lex_state = 192, .external_lex_state = 2},
  [3267] = {.lex_state = 192, .external_lex_state = 2},
  [3268] = {.lex_state = 192, .external_lex_state = 2},
  [3269] = {.lex_state = 192, .external_lex_state = 2},
  [3270] = {.lex_state = 192, .external_lex_state = 2},
  [3271] = {.lex_state = 192, .external_lex_state = 2},
  [3272] = {.lex_state = 192, .external_lex_state = 2},
  [3273] = {.lex_state = 192, .external_lex_state = 2},
  [3274] = {.lex_state = 192, .external_lex_state = 2},
  [3275] = {.lex_state = 426, .external_lex_state = 3},
  [3276] = {.lex_state = 528, .external_lex_state = 29},
  [3277] = {.lex_state = 426, .external_lex_state = 3},
  [3278] = {.lex_state = 192, .external_lex_state = 28},
  [3279] = {.lex_state = 192, .external_lex_state = 2},
  [3280] = {.lex_state = 423, .external_lex_state = 14},
  [3281] = {.lex_state = 192, .external_lex_state = 2},
  [3282] = {.lex_state = 192, .external_lex_state = 2},
  [3283] = {.lex_state = 192, .external_lex_state = 2},
  [3284] = {.lex_state = 192, .external_lex_state = 2},
  [3285] = {.lex_state = 532, .external_lex_state = 3},
  [3286] = {.lex_state = 532, .external_lex_state = 3},
  [3287] = {.lex_state = 213},
  [3288] = {.lex_state = 261, .external_lex_state = 3},
  [3289] = {.lex_state = 249, .external_lex_state = 3},
  [3290] = {.lex_state = 264, .external_lex_state = 14},
  [3291] = {.lex_state = 645, .external_lex_state = 13},
  [3292] = {.lex_state = 386, .external_lex_state = 13},
  [3293] = {.lex_state = 227, .external_lex_state = 7},
  [3294] = {.lex_state = 534, .external_lex_state = 26},
  [3295] = {.lex_state = 390, .external_lex_state = 24},
  [3296] = {.lex_state = 390, .external_lex_state = 24},
  [3297] = {.lex_state = 390, .external_lex_state = 24},
  [3298] = {.lex_state = 390, .external_lex_state = 24},
  [3299] = {.lex_state = 192, .external_lex_state = 15},
  [3300] = {.lex_state = 268, .external_lex_state = 15},
  [3301] = {.lex_state = 390, .external_lex_state = 24},
  [3302] = {.lex_state = 177, .external_lex_state = 4},
  [3303] = {.lex_state = 268, .external_lex_state = 15},
  [3304] = {.lex_state = 390, .external_lex_state = 24},
  [3305] = {.lex_state = 192, .external_lex_state = 15},
  [3306] = {.lex_state = 268, .external_lex_state = 15},
  [3307] = {.lex_state = 390, .external_lex_state = 24},
  [3308] = {.lex_state = 177, .external_lex_state = 4},
  [3309] = {.lex_state = 268, .external_lex_state = 15},
  [3310] = {.lex_state = 402, .external_lex_state = 24},
  [3311] = {.lex_state = 192, .external_lex_state = 2},
  [3312] = {.lex_state = 192, .external_lex_state = 2},
  [3313] = {.lex_state = 239},
  [3314] = {.lex_state = 192, .external_lex_state = 2},
  [3315] = {.lex_state = 396, .external_lex_state = 25},
  [3316] = {.lex_state = 408, .external_lex_state = 24},
  [3317] = {.lex_state = 408, .external_lex_state = 24},
  [3318] = {.lex_state = 408, .external_lex_state = 24},
  [3319] = {.lex_state = 408, .external_lex_state = 26},
  [3320] = {.lex_state = 402, .external_lex_state = 24},
  [3321] = {.lex_state = 192, .external_lex_state = 2},
  [3322] = {.lex_state = 192, .external_lex_state = 2},
  [3323] = {.lex_state = 192, .external_lex_state = 2},
  [3324] = {.lex_state = 192, .external_lex_state = 2},
  [3325] = {.lex_state = 192, .external_lex_state = 2},
  [3326] = {.lex_state = 192, .external_lex_state = 2},
  [3327] = {.lex_state = 192, .external_lex_state = 2},
  [3328] = {.lex_state = 192, .external_lex_state = 2},
  [3329] = {.lex_state = 192, .external_lex_state = 2},
  [3330] = {.lex_state = 192, .external_lex_state = 2},
  [3331] = {.lex_state = 192, .external_lex_state = 2},
  [3332] = {.lex_state = 192, .external_lex_state = 2},
  [3333] = {.lex_state = 239},
  [3334] = {.lex_state = 192, .external_lex_state = 2},
  [3335] = {.lex_state = 396, .external_lex_state = 25},
  [3336] = {.lex_state = 405, .external_lex_state = 24},
  [3337] = {.lex_state = 541, .external_lex_state = 24},
  [3338] = {.lex_state = 541, .external_lex_state = 24},
  [3339] = {.lex_state = 405, .external_lex_state = 26},
  [3340] = {.lex_state = 192, .external_lex_state = 28},
  [3341] = {.lex_state = 192, .external_lex_state = 2},
  [3342] = {.lex_state = 544, .external_lex_state = 26},
  [3343] = {.lex_state = 402, .external_lex_state = 24},
  [3344] = {.lex_state = 390, .external_lex_state = 24},
  [3345] = {.lex_state = 194},
  [3346] = {.lex_state = 304, .external_lex_state = 16},
  [3347] = {.lex_state = 227, .external_lex_state = 7},
  [3348] = {.lex_state = 128, .external_lex_state = 2},
  [3349] = {.lex_state = 390, .external_lex_state = 24},
  [3350] = {.lex_state = 249, .external_lex_state = 3},
  [3351] = {.lex_state = 128, .external_lex_state = 13},
  [3352] = {.lex_state = 128, .external_lex_state = 2},
  [3353] = {.lex_state = 390, .external_lex_state = 24},
  [3354] = {.lex_state = 128, .external_lex_state = 2},
  [3355] = {.lex_state = 408, .external_lex_state = 24},
  [3356] = {.lex_state = 408, .external_lex_state = 24},
  [3357] = {.lex_state = 408, .external_lex_state = 24},
  [3358] = {.lex_state = 192, .external_lex_state = 2},
  [3359] = {.lex_state = 408, .external_lex_state = 24},
  [3360] = {.lex_state = 408, .external_lex_state = 24},
  [3361] = {.lex_state = 192, .external_lex_state = 2},
  [3362] = {.lex_state = 192, .external_lex_state = 2},
  [3363] = {.lex_state = 192, .external_lex_state = 2},
  [3364] = {.lex_state = 192, .external_lex_state = 2},
  [3365] = {.lex_state = 192, .external_lex_state = 2},
  [3366] = {.lex_state = 192, .external_lex_state = 2},
  [3367] = {.lex_state = 192, .external_lex_state = 2},
  [3368] = {.lex_state = 192, .external_lex_state = 2},
  [3369] = {.lex_state = 192, .external_lex_state = 2},
  [3370] = {.lex_state = 192, .external_lex_state = 2},
  [3371] = {.lex_state = 192, .external_lex_state = 2},
  [3372] = {.lex_state = 408, .external_lex_state = 24},
  [3373] = {.lex_state = 528, .external_lex_state = 29},
  [3374] = {.lex_state = 408, .external_lex_state = 24},
  [3375] = {.lex_state = 192, .external_lex_state = 28},
  [3376] = {.lex_state = 192, .external_lex_state = 2},
  [3377] = {.lex_state = 128},
  [3378] = {.lex_state = 128, .external_lex_state = 2},
  [3379] = {.lex_state = 128},
  [3380] = {.lex_state = 128, .external_lex_state = 2},
  [3381] = {.lex_state = 128, .external_lex_state = 2},
  [3382] = {.lex_state = 128, .external_lex_state = 2},
  [3383] = {.lex_state = 128, .external_lex_state = 13},
  [3384] = {.lex_state = 128},
  [3385] = {.lex_state = 390, .external_lex_state = 24},
  [3386] = {.lex_state = 128},
  [3387] = {.lex_state = 128},
  [3388] = {.lex_state = 128},
  [3389] = {.lex_state = 390, .external_lex_state = 24},
  [3390] = {.lex_state = 128},
  [3391] = {.lex_state = 128},
  [3392] = {.lex_state = 128},
  [3393] = {.lex_state = 390, .external_lex_state = 24},
  [3394] = {.lex_state = 402, .external_lex_state = 24},
  [3395] = {.lex_state = 390, .external_lex_state = 24},
  [3396] = {.lex_state = 390, .external_lex_state = 24},
  [3397] = {.lex_state = 194},
  [3398] = {.lex_state = 288, .external_lex_state = 2},
  [3399] = {.lex_state = 390, .external_lex_state = 24},
  [3400] = {.lex_state = 128},
  [3401] = {.lex_state = 128, .external_lex_state = 11},
  [3402] = {.lex_state = 416, .external_lex_state = 2},
  [3403] = {.lex_state = 390, .external_lex_state = 24},
  [3404] = {.lex_state = 402, .external_lex_state = 24},
  [3405] = {.lex_state = 402, .external_lex_state = 24},
  [3406] = {.lex_state = 402, .external_lex_state = 24},
  [3407] = {.lex_state = 402, .external_lex_state = 24},
  [3408] = {.lex_state = 402, .external_lex_state = 24},
  [3409] = {.lex_state = 561, .external_lex_state = 16},
  [3410] = {.lex_state = 402, .external_lex_state = 24},
  [3411] = {.lex_state = 402, .external_lex_state = 24},
  [3412] = {.lex_state = 402, .external_lex_state = 24},
  [3413] = {.lex_state = 402, .external_lex_state = 24},
  [3414] = {.lex_state = 548, .external_lex_state = 25},
  [3415] = {.lex_state = 358, .external_lex_state = 12},
  [3416] = {.lex_state = 548, .external_lex_state = 25},
  [3417] = {.lex_state = 548, .external_lex_state = 25},
  [3418] = {.lex_state = 418, .external_lex_state = 27},
  [3419] = {.lex_state = 399, .external_lex_state = 24},
  [3420] = {.lex_state = 237},
  [3421] = {.lex_state = 548, .external_lex_state = 25},
  [3422] = {.lex_state = 405, .external_lex_state = 24},
  [3423] = {.lex_state = 647, .external_lex_state = 26},
  [3424] = {.lex_state = 405, .external_lex_state = 24},
  [3425] = {.lex_state = 405, .external_lex_state = 24},
  [3426] = {.lex_state = 192, .external_lex_state = 2},
  [3427] = {.lex_state = 399, .external_lex_state = 24},
  [3428] = {.lex_state = 194},
  [3429] = {.lex_state = 288, .external_lex_state = 2},
  [3430] = {.lex_state = 405, .external_lex_state = 24},
  [3431] = {.lex_state = 399, .external_lex_state = 24},
  [3432] = {.lex_state = 128},
  [3433] = {.lex_state = 128, .external_lex_state = 11},
  [3434] = {.lex_state = 416, .external_lex_state = 2},
  [3435] = {.lex_state = 405, .external_lex_state = 24},
  [3436] = {.lex_state = 192, .external_lex_state = 2},
  [3437] = {.lex_state = 192, .external_lex_state = 2},
  [3438] = {.lex_state = 192, .external_lex_state = 2},
  [3439] = {.lex_state = 192, .external_lex_state = 2},
  [3440] = {.lex_state = 192, .external_lex_state = 2},
  [3441] = {.lex_state = 192, .external_lex_state = 2},
  [3442] = {.lex_state = 192, .external_lex_state = 2},
  [3443] = {.lex_state = 192, .external_lex_state = 2},
  [3444] = {.lex_state = 192, .external_lex_state = 2},
  [3445] = {.lex_state = 192, .external_lex_state = 2},
  [3446] = {.lex_state = 192, .external_lex_state = 2},
  [3447] = {.lex_state = 399, .external_lex_state = 24},
  [3448] = {.lex_state = 405, .external_lex_state = 24},
  [3449] = {.lex_state = 528, .external_lex_state = 29},
  [3450] = {.lex_state = 405, .external_lex_state = 24},
  [3451] = {.lex_state = 192, .external_lex_state = 28},
  [3452] = {.lex_state = 192, .external_lex_state = 2},
  [3453] = {.lex_state = 647, .external_lex_state = 26},
  [3454] = {.lex_state = 553, .external_lex_state = 19},
  [3455] = {.lex_state = 237, .external_lex_state = 12},
  [3456] = {.lex_state = 237, .external_lex_state = 29},
  [3457] = {.lex_state = 553},
  [3458] = {.lex_state = 393, .external_lex_state = 19},
  [3459] = {.lex_state = 192, .external_lex_state = 2},
  [3460] = {.lex_state = 402, .external_lex_state = 24},
  [3461] = {.lex_state = 551, .external_lex_state = 24},
  [3462] = {.lex_state = 402, .external_lex_state = 24},
  [3463] = {.lex_state = 402, .external_lex_state = 24},
  [3464] = {.lex_state = 547, .external_lex_state = 26},
  [3465] = {.lex_state = 239},
  [3466] = {.lex_state = 288, .external_lex_state = 2},
  [3467] = {.lex_state = 128},
  [3468] = {.lex_state = 239},
  [3469] = {.lex_state = 239},
  [3470] = {.lex_state = 156, .external_lex_state = 3},
  [3471] = {.lex_state = 194},
  [3472] = {.lex_state = 304},
  [3473] = {.lex_state = 648, .external_lex_state = 2},
  [3474] = {.lex_state = 192, .external_lex_state = 2},
  [3475] = {.lex_state = 128},
  [3476] = {.lex_state = 197},
  [3477] = {.lex_state = 304},
  [3478] = {.lex_state = 239},
  [3479] = {.lex_state = 128, .external_lex_state = 11},
  [3480] = {.lex_state = 128},
  [3481] = {.lex_state = 239},
  [3482] = {.lex_state = 156, .external_lex_state = 3},
  [3483] = {.lex_state = 128},
  [3484] = {.lex_state = 128, .external_lex_state = 2},
  [3485] = {.lex_state = 128, .external_lex_state = 11},
  [3486] = {.lex_state = 192, .external_lex_state = 2},
  [3487] = {.lex_state = 622, .external_lex_state = 18},
  [3488] = {.lex_state = 622, .external_lex_state = 18},
  [3489] = {.lex_state = 622, .external_lex_state = 18},
  [3490] = {.lex_state = 622, .external_lex_state = 18},
  [3491] = {.lex_state = 192, .external_lex_state = 2},
  [3492] = {.lex_state = 192, .external_lex_state = 2},
  [3493] = {.lex_state = 304, .external_lex_state = 16},
  [3494] = {.lex_state = 625, .external_lex_state = 18},
  [3495] = {.lex_state = 213},
  [3496] = {.lex_state = 229, .external_lex_state = 16},
  [3497] = {.lex_state = 253, .external_lex_state = 20},
  [3498] = {.lex_state = 304, .external_lex_state = 16},
  [3499] = {.lex_state = 156},
  [3500] = {.lex_state = 156},
  [3501] = {.lex_state = 243},
  [3502] = {.lex_state = 650, .external_lex_state = 20},
  [3503] = {.lex_state = 192, .external_lex_state = 15},
  [3504] = {.lex_state = 561, .external_lex_state = 16},
  [3505] = {.lex_state = 192, .external_lex_state = 2},
  [3506] = {.lex_state = 192, .external_lex_state = 2},
  [3507] = {.lex_state = 192, .external_lex_state = 2},
  [3508] = {.lex_state = 239},
  [3509] = {.lex_state = 192, .external_lex_state = 2},
  [3510] = {.lex_state = 653, .external_lex_state = 25},
  [3511] = {.lex_state = 653, .external_lex_state = 25},
  [3512] = {.lex_state = 653, .external_lex_state = 25},
  [3513] = {.lex_state = 653, .external_lex_state = 25},
  [3514] = {.lex_state = 192, .external_lex_state = 2},
  [3515] = {.lex_state = 192, .external_lex_state = 2},
  [3516] = {.lex_state = 656, .external_lex_state = 25},
  [3517] = {.lex_state = 659, .external_lex_state = 24},
  [3518] = {.lex_state = 662, .external_lex_state = 25},
  [3519] = {.lex_state = 569, .external_lex_state = 24},
  [3520] = {.lex_state = 650, .external_lex_state = 24},
  [3521] = {.lex_state = 213},
  [3522] = {.lex_state = 663, .external_lex_state = 24},
  [3523] = {.lex_state = 666, .external_lex_state = 26},
  [3524] = {.lex_state = 561, .external_lex_state = 16},
  [3525] = {.lex_state = 192, .external_lex_state = 2},
  [3526] = {.lex_state = 192, .external_lex_state = 2},
  [3527] = {.lex_state = 192, .external_lex_state = 2},
  [3528] = {.lex_state = 192, .external_lex_state = 2},
  [3529] = {.lex_state = 192, .external_lex_state = 2},
  [3530] = {.lex_state = 192, .external_lex_state = 2},
  [3531] = {.lex_state = 192, .external_lex_state = 2},
  [3532] = {.lex_state = 192, .external_lex_state = 2},
  [3533] = {.lex_state = 192, .external_lex_state = 2},
  [3534] = {.lex_state = 192, .external_lex_state = 2},
  [3535] = {.lex_state = 192, .external_lex_state = 2},
  [3536] = {.lex_state = 192, .external_lex_state = 2},
  [3537] = {.lex_state = 192, .external_lex_state = 2},
  [3538] = {.lex_state = 192, .external_lex_state = 2},
  [3539] = {.lex_state = 239},
  [3540] = {.lex_state = 192, .external_lex_state = 2},
  [3541] = {.lex_state = 662, .external_lex_state = 25},
  [3542] = {.lex_state = 662, .external_lex_state = 25},
  [3543] = {.lex_state = 662, .external_lex_state = 25},
  [3544] = {.lex_state = 662, .external_lex_state = 25},
  [3545] = {.lex_state = 192, .external_lex_state = 2},
  [3546] = {.lex_state = 192, .external_lex_state = 2},
  [3547] = {.lex_state = 656, .external_lex_state = 25},
  [3548] = {.lex_state = 663, .external_lex_state = 24},
  [3549] = {.lex_state = 662, .external_lex_state = 25},
  [3550] = {.lex_state = 566, .external_lex_state = 24},
  [3551] = {.lex_state = 566, .external_lex_state = 24},
  [3552] = {.lex_state = 213},
  [3553] = {.lex_state = 663, .external_lex_state = 24},
  [3554] = {.lex_state = 667, .external_lex_state = 26},
  [3555] = {.lex_state = 192, .external_lex_state = 28},
  [3556] = {.lex_state = 192, .external_lex_state = 2},
  [3557] = {.lex_state = 569, .external_lex_state = 20},
  [3558] = {.lex_state = 418, .external_lex_state = 27},
  [3559] = {.lex_state = 177, .external_lex_state = 17},
  [3560] = {.lex_state = 329, .external_lex_state = 10},
  [3561] = {.lex_state = 209},
  [3562] = {.lex_state = 329, .external_lex_state = 10},
  [3563] = {.lex_state = 418, .external_lex_state = 27},
  [3564] = {.lex_state = 229, .external_lex_state = 3},
  [3565] = {.lex_state = 572, .external_lex_state = 14},
  [3566] = {.lex_state = 301, .external_lex_state = 3},
  [3567] = {.lex_state = 301, .external_lex_state = 3},
  [3568] = {.lex_state = 301, .external_lex_state = 3},
  [3569] = {.lex_state = 301, .external_lex_state = 3},
  [3570] = {.lex_state = 192, .external_lex_state = 15},
  [3571] = {.lex_state = 268, .external_lex_state = 15},
  [3572] = {.lex_state = 301, .external_lex_state = 3},
  [3573] = {.lex_state = 177, .external_lex_state = 4},
  [3574] = {.lex_state = 268, .external_lex_state = 15},
  [3575] = {.lex_state = 301, .external_lex_state = 3},
  [3576] = {.lex_state = 192, .external_lex_state = 15},
  [3577] = {.lex_state = 268, .external_lex_state = 15},
  [3578] = {.lex_state = 301, .external_lex_state = 3},
  [3579] = {.lex_state = 177, .external_lex_state = 4},
  [3580] = {.lex_state = 268, .external_lex_state = 15},
  [3581] = {.lex_state = 229, .external_lex_state = 14},
  [3582] = {.lex_state = 192, .external_lex_state = 15},
  [3583] = {.lex_state = 229, .external_lex_state = 3},
  [3584] = {.lex_state = 192, .external_lex_state = 15},
  [3585] = {.lex_state = 229, .external_lex_state = 3},
  [3586] = {.lex_state = 192, .external_lex_state = 15},
  [3587] = {.lex_state = 229, .external_lex_state = 3},
  [3588] = {.lex_state = 192, .external_lex_state = 15},
  [3589] = {.lex_state = 229, .external_lex_state = 3},
  [3590] = {.lex_state = 190, .external_lex_state = 4},
  [3591] = {.lex_state = 268, .external_lex_state = 15},
  [3592] = {.lex_state = 229, .external_lex_state = 3},
  [3593] = {.lex_state = 190, .external_lex_state = 4},
  [3594] = {.lex_state = 268, .external_lex_state = 15},
  [3595] = {.lex_state = 426, .external_lex_state = 3},
  [3596] = {.lex_state = 229, .external_lex_state = 3},
  [3597] = {.lex_state = 194},
  [3598] = {.lex_state = 194, .external_lex_state = 19},
  [3599] = {.lex_state = 192, .external_lex_state = 2},
  [3600] = {.lex_state = 229, .external_lex_state = 3},
  [3601] = {.lex_state = 312},
  [3602] = {.lex_state = 312, .external_lex_state = 13},
  [3603] = {.lex_state = 229, .external_lex_state = 3},
  [3604] = {.lex_state = 209},
  [3605] = {.lex_state = 192, .external_lex_state = 2},
  [3606] = {.lex_state = 348, .external_lex_state = 22},
  [3607] = {.lex_state = 348, .external_lex_state = 22},
  [3608] = {.lex_state = 352, .external_lex_state = 22},
  [3609] = {.lex_state = 352, .external_lex_state = 22},
  [3610] = {.lex_state = 229, .external_lex_state = 3},
  [3611] = {.lex_state = 229, .external_lex_state = 3},
  [3612] = {.lex_state = 229, .external_lex_state = 3},
  [3613] = {.lex_state = 229, .external_lex_state = 3},
  [3614] = {.lex_state = 128, .external_lex_state = 13},
  [3615] = {.lex_state = 128, .external_lex_state = 13},
  [3616] = {.lex_state = 249, .external_lex_state = 3},
  [3617] = {.lex_state = 249, .external_lex_state = 3},
  [3618] = {.lex_state = 128},
  [3619] = {.lex_state = 249, .external_lex_state = 3},
  [3620] = {.lex_state = 128},
  [3621] = {.lex_state = 128},
  [3622] = {.lex_state = 128},
  [3623] = {.lex_state = 128},
  [3624] = {.lex_state = 128},
  [3625] = {.lex_state = 229, .external_lex_state = 3},
  [3626] = {.lex_state = 128, .external_lex_state = 2},
  [3627] = {.lex_state = 426, .external_lex_state = 3},
  [3628] = {.lex_state = 229, .external_lex_state = 3},
  [3629] = {.lex_state = 229, .external_lex_state = 3},
  [3630] = {.lex_state = 229, .external_lex_state = 3},
  [3631] = {.lex_state = 237},
  [3632] = {.lex_state = 128},
  [3633] = {.lex_state = 229, .external_lex_state = 3},
  [3634] = {.lex_state = 192, .external_lex_state = 2},
  [3635] = {.lex_state = 192, .external_lex_state = 2},
  [3636] = {.lex_state = 192, .external_lex_state = 2},
  [3637] = {.lex_state = 192, .external_lex_state = 2},
  [3638] = {.lex_state = 192, .external_lex_state = 2},
  [3639] = {.lex_state = 192, .external_lex_state = 2},
  [3640] = {.lex_state = 192, .external_lex_state = 2},
  [3641] = {.lex_state = 192, .external_lex_state = 2},
  [3642] = {.lex_state = 192, .external_lex_state = 2},
  [3643] = {.lex_state = 192, .external_lex_state = 2},
  [3644] = {.lex_state = 421, .external_lex_state = 6},
  [3645] = {.lex_state = 192, .external_lex_state = 28},
  [3646] = {.lex_state = 192, .external_lex_state = 2},
  [3647] = {.lex_state = 426, .external_lex_state = 14},
  [3648] = {.lex_state = 301, .external_lex_state = 3},
  [3649] = {.lex_state = 426, .external_lex_state = 3},
  [3650] = {.lex_state = 438, .external_lex_state = 3},
  [3651] = {.lex_state = 459, .external_lex_state = 14},
  [3652] = {.lex_state = 192, .external_lex_state = 2},
  [3653] = {.lex_state = 192, .external_lex_state = 2},
  [3654] = {.lex_state = 239},
  [3655] = {.lex_state = 192, .external_lex_state = 2},
  [3656] = {.lex_state = 576, .external_lex_state = 10},
  [3657] = {.lex_state = 595, .external_lex_state = 3},
  [3658] = {.lex_state = 459, .external_lex_state = 3},
  [3659] = {.lex_state = 595, .external_lex_state = 3},
  [3660] = {.lex_state = 595, .external_lex_state = 14},
  [3661] = {.lex_state = 438, .external_lex_state = 3},
  [3662] = {.lex_state = 229, .external_lex_state = 3},
  [3663] = {.lex_state = 194},
  [3664] = {.lex_state = 192, .external_lex_state = 2},
  [3665] = {.lex_state = 192, .external_lex_state = 2},
  [3666] = {.lex_state = 192, .external_lex_state = 2},
  [3667] = {.lex_state = 192, .external_lex_state = 2},
  [3668] = {.lex_state = 192, .external_lex_state = 2},
  [3669] = {.lex_state = 192, .external_lex_state = 2},
  [3670] = {.lex_state = 192, .external_lex_state = 2},
  [3671] = {.lex_state = 192, .external_lex_state = 2},
  [3672] = {.lex_state = 192, .external_lex_state = 2},
  [3673] = {.lex_state = 192, .external_lex_state = 2},
  [3674] = {.lex_state = 192, .external_lex_state = 2},
  [3675] = {.lex_state = 192, .external_lex_state = 2},
  [3676] = {.lex_state = 239},
  [3677] = {.lex_state = 192, .external_lex_state = 2},
  [3678] = {.lex_state = 576, .external_lex_state = 10},
  [3679] = {.lex_state = 580, .external_lex_state = 3},
  [3680] = {.lex_state = 580, .external_lex_state = 3},
  [3681] = {.lex_state = 580, .external_lex_state = 3},
  [3682] = {.lex_state = 580, .external_lex_state = 14},
  [3683] = {.lex_state = 192, .external_lex_state = 28},
  [3684] = {.lex_state = 192, .external_lex_state = 2},
  [3685] = {.lex_state = 459, .external_lex_state = 14},
  [3686] = {.lex_state = 301, .external_lex_state = 3},
  [3687] = {.lex_state = 194},
  [3688] = {.lex_state = 304, .external_lex_state = 16},
  [3689] = {.lex_state = 227, .external_lex_state = 7},
  [3690] = {.lex_state = 128, .external_lex_state = 2},
  [3691] = {.lex_state = 301, .external_lex_state = 3},
  [3692] = {.lex_state = 249, .external_lex_state = 3},
  [3693] = {.lex_state = 128, .external_lex_state = 13},
  [3694] = {.lex_state = 128, .external_lex_state = 2},
  [3695] = {.lex_state = 301, .external_lex_state = 3},
  [3696] = {.lex_state = 128, .external_lex_state = 2},
  [3697] = {.lex_state = 128},
  [3698] = {.lex_state = 128, .external_lex_state = 2},
  [3699] = {.lex_state = 128},
  [3700] = {.lex_state = 128, .external_lex_state = 2},
  [3701] = {.lex_state = 128, .external_lex_state = 2},
  [3702] = {.lex_state = 128, .external_lex_state = 2},
  [3703] = {.lex_state = 128, .external_lex_state = 13},
  [3704] = {.lex_state = 229, .external_lex_state = 3},
  [3705] = {.lex_state = 128},
  [3706] = {.lex_state = 128, .external_lex_state = 2},
  [3707] = {.lex_state = 128, .external_lex_state = 11},
  [3708] = {.lex_state = 128},
  [3709] = {.lex_state = 301, .external_lex_state = 3},
  [3710] = {.lex_state = 128},
  [3711] = {.lex_state = 128},
  [3712] = {.lex_state = 128},
  [3713] = {.lex_state = 301, .external_lex_state = 3},
  [3714] = {.lex_state = 128},
  [3715] = {.lex_state = 128},
  [3716] = {.lex_state = 128},
  [3717] = {.lex_state = 301, .external_lex_state = 3},
  [3718] = {.lex_state = 229, .external_lex_state = 3},
  [3719] = {.lex_state = 426, .external_lex_state = 3},
  [3720] = {.lex_state = 301, .external_lex_state = 3},
  [3721] = {.lex_state = 301, .external_lex_state = 3},
  [3722] = {.lex_state = 301, .external_lex_state = 3},
  [3723] = {.lex_state = 423, .external_lex_state = 3},
  [3724] = {.lex_state = 423, .external_lex_state = 3},
  [3725] = {.lex_state = 423, .external_lex_state = 3},
  [3726] = {.lex_state = 423, .external_lex_state = 3},
  [3727] = {.lex_state = 423, .external_lex_state = 3},
  [3728] = {.lex_state = 561, .external_lex_state = 16},
  [3729] = {.lex_state = 423, .external_lex_state = 3},
  [3730] = {.lex_state = 423, .external_lex_state = 3},
  [3731] = {.lex_state = 423, .external_lex_state = 3},
  [3732] = {.lex_state = 423, .external_lex_state = 3},
  [3733] = {.lex_state = 229, .external_lex_state = 3},
  [3734] = {.lex_state = 229, .external_lex_state = 3},
  [3735] = {.lex_state = 177, .external_lex_state = 17},
  [3736] = {.lex_state = 426, .external_lex_state = 3},
  [3737] = {.lex_state = 229, .external_lex_state = 3},
  [3738] = {.lex_state = 528, .external_lex_state = 12},
  [3739] = {.lex_state = 426, .external_lex_state = 3},
  [3740] = {.lex_state = 426, .external_lex_state = 3},
  [3741] = {.lex_state = 423, .external_lex_state = 3},
  [3742] = {.lex_state = 301, .external_lex_state = 3},
  [3743] = {.lex_state = 423, .external_lex_state = 3},
  [3744] = {.lex_state = 423, .external_lex_state = 3},
  [3745] = {.lex_state = 423, .external_lex_state = 14},
  [3746] = {.lex_state = 584, .external_lex_state = 3},
  [3747] = {.lex_state = 584, .external_lex_state = 3},
  [3748] = {.lex_state = 584, .external_lex_state = 3},
  [3749] = {.lex_state = 192, .external_lex_state = 2},
  [3750] = {.lex_state = 192, .external_lex_state = 2},
  [3751] = {.lex_state = 192, .external_lex_state = 2},
  [3752] = {.lex_state = 192, .external_lex_state = 2},
  [3753] = {.lex_state = 192, .external_lex_state = 2},
  [3754] = {.lex_state = 192, .external_lex_state = 2},
  [3755] = {.lex_state = 192, .external_lex_state = 2},
  [3756] = {.lex_state = 192, .external_lex_state = 2},
  [3757] = {.lex_state = 192, .external_lex_state = 2},
  [3758] = {.lex_state = 192, .external_lex_state = 2},
  [3759] = {.lex_state = 192, .external_lex_state = 28},
  [3760] = {.lex_state = 584, .external_lex_state = 3},
  [3761] = {.lex_state = 192, .external_lex_state = 28},
  [3762] = {.lex_state = 192, .external_lex_state = 2},
  [3763] = {.lex_state = 223, .external_lex_state = 8},
  [3764] = {.lex_state = 249, .external_lex_state = 3},
  [3765] = {.lex_state = 192, .external_lex_state = 2},
  [3766] = {.lex_state = 192, .external_lex_state = 2},
  [3767] = {.lex_state = 192, .external_lex_state = 2},
  [3768] = {.lex_state = 239},
  [3769] = {.lex_state = 192, .external_lex_state = 2},
  [3770] = {.lex_state = 355, .external_lex_state = 10},
  [3771] = {.lex_state = 355, .external_lex_state = 10},
  [3772] = {.lex_state = 355, .external_lex_state = 10},
  [3773] = {.lex_state = 355, .external_lex_state = 10},
  [3774] = {.lex_state = 192, .external_lex_state = 2},
  [3775] = {.lex_state = 192, .external_lex_state = 2},
  [3776] = {.lex_state = 360, .external_lex_state = 10},
  [3777] = {.lex_state = 363, .external_lex_state = 3},
  [3778] = {.lex_state = 366, .external_lex_state = 10},
  [3779] = {.lex_state = 264, .external_lex_state = 3},
  [3780] = {.lex_state = 363, .external_lex_state = 3},
  [3781] = {.lex_state = 213},
  [3782] = {.lex_state = 370, .external_lex_state = 3},
  [3783] = {.lex_state = 373, .external_lex_state = 14},
  [3784] = {.lex_state = 249, .external_lex_state = 3},
  [3785] = {.lex_state = 256, .external_lex_state = 13},
  [3786] = {.lex_state = 192, .external_lex_state = 2},
  [3787] = {.lex_state = 192, .external_lex_state = 2},
  [3788] = {.lex_state = 192, .external_lex_state = 2},
  [3789] = {.lex_state = 192, .external_lex_state = 2},
  [3790] = {.lex_state = 192, .external_lex_state = 2},
  [3791] = {.lex_state = 192, .external_lex_state = 2},
  [3792] = {.lex_state = 192, .external_lex_state = 2},
  [3793] = {.lex_state = 192, .external_lex_state = 2},
  [3794] = {.lex_state = 192, .external_lex_state = 2},
  [3795] = {.lex_state = 192, .external_lex_state = 2},
  [3796] = {.lex_state = 192, .external_lex_state = 2},
  [3797] = {.lex_state = 192, .external_lex_state = 2},
  [3798] = {.lex_state = 192, .external_lex_state = 2},
  [3799] = {.lex_state = 192, .external_lex_state = 2},
  [3800] = {.lex_state = 192, .external_lex_state = 2},
  [3801] = {.lex_state = 192, .external_lex_state = 2},
  [3802] = {.lex_state = 192, .external_lex_state = 2},
  [3803] = {.lex_state = 192, .external_lex_state = 2},
  [3804] = {.lex_state = 239},
  [3805] = {.lex_state = 192, .external_lex_state = 2},
  [3806] = {.lex_state = 366, .external_lex_state = 10},
  [3807] = {.lex_state = 366, .external_lex_state = 10},
  [3808] = {.lex_state = 366, .external_lex_state = 10},
  [3809] = {.lex_state = 366, .external_lex_state = 10},
  [3810] = {.lex_state = 192, .external_lex_state = 2},
  [3811] = {.lex_state = 192, .external_lex_state = 2},
  [3812] = {.lex_state = 360, .external_lex_state = 10},
  [3813] = {.lex_state = 423, .external_lex_state = 3},
  [3814] = {.lex_state = 366, .external_lex_state = 10},
  [3815] = {.lex_state = 426, .external_lex_state = 3},
  [3816] = {.lex_state = 426, .external_lex_state = 3},
  [3817] = {.lex_state = 213},
  [3818] = {.lex_state = 423, .external_lex_state = 3},
  [3819] = {.lex_state = 429, .external_lex_state = 14},
  [3820] = {.lex_state = 192, .external_lex_state = 28},
  [3821] = {.lex_state = 192, .external_lex_state = 2},
  [3822] = {.lex_state = 264, .external_lex_state = 14},
  [3823] = {.lex_state = 194},
  [3824] = {.lex_state = 194},
  [3825] = {.lex_state = 194},
  [3826] = {.lex_state = 194},
  [3827] = {.lex_state = 192, .external_lex_state = 2},
  [3828] = {.lex_state = 462, .external_lex_state = 25},
  [3829] = {.lex_state = 462, .external_lex_state = 25},
  [3830] = {.lex_state = 462, .external_lex_state = 25},
  [3831] = {.lex_state = 462, .external_lex_state = 25},
  [3832] = {.lex_state = 192, .external_lex_state = 2},
  [3833] = {.lex_state = 192, .external_lex_state = 2},
  [3834] = {.lex_state = 471, .external_lex_state = 24},
  [3835] = {.lex_state = 440, .external_lex_state = 25},
  [3836] = {.lex_state = 213},
  [3837] = {.lex_state = 443, .external_lex_state = 24},
  [3838] = {.lex_state = 471, .external_lex_state = 26},
  [3839] = {.lex_state = 471, .external_lex_state = 24},
  [3840] = {.lex_state = 595, .external_lex_state = 24},
  [3841] = {.lex_state = 668, .external_lex_state = 26},
  [3842] = {.lex_state = 192, .external_lex_state = 2},
  [3843] = {.lex_state = 471, .external_lex_state = 24},
  [3844] = {.lex_state = 192, .external_lex_state = 2},
  [3845] = {.lex_state = 192, .external_lex_state = 2},
  [3846] = {.lex_state = 239},
  [3847] = {.lex_state = 192, .external_lex_state = 2},
  [3848] = {.lex_state = 592, .external_lex_state = 25},
  [3849] = {.lex_state = 595, .external_lex_state = 24},
  [3850] = {.lex_state = 595, .external_lex_state = 24},
  [3851] = {.lex_state = 595, .external_lex_state = 24},
  [3852] = {.lex_state = 595, .external_lex_state = 26},
  [3853] = {.lex_state = 595, .external_lex_state = 24},
  [3854] = {.lex_state = 192, .external_lex_state = 2},
  [3855] = {.lex_state = 192, .external_lex_state = 2},
  [3856] = {.lex_state = 192, .external_lex_state = 2},
  [3857] = {.lex_state = 192, .external_lex_state = 2},
  [3858] = {.lex_state = 192, .external_lex_state = 2},
  [3859] = {.lex_state = 192, .external_lex_state = 2},
  [3860] = {.lex_state = 192, .external_lex_state = 2},
  [3861] = {.lex_state = 192, .external_lex_state = 2},
  [3862] = {.lex_state = 192, .external_lex_state = 2},
  [3863] = {.lex_state = 192, .external_lex_state = 2},
  [3864] = {.lex_state = 192, .external_lex_state = 2},
  [3865] = {.lex_state = 192, .external_lex_state = 2},
  [3866] = {.lex_state = 192, .external_lex_state = 2},
  [3867] = {.lex_state = 239},
  [3868] = {.lex_state = 192, .external_lex_state = 2},
  [3869] = {.lex_state = 592, .external_lex_state = 25},
  [3870] = {.lex_state = 580, .external_lex_state = 24},
  [3871] = {.lex_state = 580, .external_lex_state = 24},
  [3872] = {.lex_state = 580, .external_lex_state = 24},
  [3873] = {.lex_state = 580, .external_lex_state = 26},
  [3874] = {.lex_state = 446, .external_lex_state = 24},
  [3875] = {.lex_state = 528, .external_lex_state = 29},
  [3876] = {.lex_state = 471, .external_lex_state = 24},
  [3877] = {.lex_state = 192, .external_lex_state = 28},
  [3878] = {.lex_state = 192, .external_lex_state = 2},
  [3879] = {.lex_state = 668, .external_lex_state = 26},
  [3880] = {.lex_state = 239},
  [3881] = {.lex_state = 227, .external_lex_state = 7},
  [3882] = {.lex_state = 239},
  [3883] = {.lex_state = 194},
  [3884] = {.lex_state = 438, .external_lex_state = 16},
  [3885] = {.lex_state = 438, .external_lex_state = 16},
  [3886] = {.lex_state = 438, .external_lex_state = 16},
  [3887] = {.lex_state = 438, .external_lex_state = 16},
  [3888] = {.lex_state = 438, .external_lex_state = 16},
  [3889] = {.lex_state = 438, .external_lex_state = 16},
  [3890] = {.lex_state = 438, .external_lex_state = 16},
  [3891] = {.lex_state = 438, .external_lex_state = 16},
  [3892] = {.lex_state = 438, .external_lex_state = 16},
  [3893] = {.lex_state = 438, .external_lex_state = 16},
  [3894] = {.lex_state = 561, .external_lex_state = 16},
  [3895] = {.lex_state = 438, .external_lex_state = 16},
  [3896] = {.lex_state = 438, .external_lex_state = 16},
  [3897] = {.lex_state = 438, .external_lex_state = 16},
  [3898] = {.lex_state = 438, .external_lex_state = 16},
  [3899] = {.lex_state = 586, .external_lex_state = 18},
  [3900] = {.lex_state = 358, .external_lex_state = 12},
  [3901] = {.lex_state = 586, .external_lex_state = 18},
  [3902] = {.lex_state = 586, .external_lex_state = 18},
  [3903] = {.lex_state = 418, .external_lex_state = 27},
  [3904] = {.lex_state = 435, .external_lex_state = 16},
  [3905] = {.lex_state = 237},
  [3906] = {.lex_state = 586, .external_lex_state = 18},
  [3907] = {.lex_state = 465, .external_lex_state = 24},
  [3908] = {.lex_state = 177, .external_lex_state = 4},
  [3909] = {.lex_state = 177, .external_lex_state = 4},
  [3910] = {.lex_state = 177, .external_lex_state = 4},
  [3911] = {.lex_state = 177, .external_lex_state = 4},
  [3912] = {.lex_state = 190, .external_lex_state = 4},
  [3913] = {.lex_state = 190, .external_lex_state = 4},
  [3914] = {.lex_state = 192, .external_lex_state = 2},
  [3915] = {.lex_state = 194, .external_lex_state = 6},
  [3916] = {.lex_state = 197, .external_lex_state = 7},
  [3917] = {.lex_state = 209, .external_lex_state = 2},
  [3918] = {.lex_state = 216, .external_lex_state = 9},
  [3919] = {.lex_state = 216, .external_lex_state = 8},
  [3920] = {.lex_state = 440, .external_lex_state = 25},
  [3921] = {.lex_state = 440, .external_lex_state = 25},
  [3922] = {.lex_state = 440, .external_lex_state = 25},
  [3923] = {.lex_state = 440, .external_lex_state = 25},
  [3924] = {.lex_state = 221, .external_lex_state = 2},
  [3925] = {.lex_state = 221, .external_lex_state = 2},
  [3926] = {.lex_state = 192, .external_lex_state = 2},
  [3927] = {.lex_state = 192, .external_lex_state = 2},
  [3928] = {.lex_state = 223, .external_lex_state = 8},
  [3929] = {.lex_state = 225, .external_lex_state = 11},
  [3930] = {.lex_state = 128, .external_lex_state = 11},
  [3931] = {.lex_state = 192, .external_lex_state = 2},
  [3932] = {.lex_state = 192, .external_lex_state = 2},
  [3933] = {.lex_state = 465, .external_lex_state = 24},
  [3934] = {.lex_state = 237, .external_lex_state = 12},
  [3935] = {.lex_state = 239},
  [3936] = {.lex_state = 443, .external_lex_state = 24},
  [3937] = {.lex_state = 465, .external_lex_state = 24},
  [3938] = {.lex_state = 440, .external_lex_state = 25},
  [3939] = {.lex_state = 213},
  [3940] = {.lex_state = 443, .external_lex_state = 24},
  [3941] = {.lex_state = 443, .external_lex_state = 26},
  [3942] = {.lex_state = 443, .external_lex_state = 24},
  [3943] = {.lex_state = 580, .external_lex_state = 24},
  [3944] = {.lex_state = 669, .external_lex_state = 26},
  [3945] = {.lex_state = 192, .external_lex_state = 2},
  [3946] = {.lex_state = 670, .external_lex_state = 24},
  [3947] = {.lex_state = 194},
  [3948] = {.lex_state = 288, .external_lex_state = 2},
  [3949] = {.lex_state = 443, .external_lex_state = 24},
  [3950] = {.lex_state = 435, .external_lex_state = 16},
  [3951] = {.lex_state = 128},
  [3952] = {.lex_state = 128, .external_lex_state = 11},
  [3953] = {.lex_state = 416, .external_lex_state = 2},
  [3954] = {.lex_state = 465, .external_lex_state = 24},
  [3955] = {.lex_state = 209},
  [3956] = {.lex_state = 580, .external_lex_state = 24},
  [3957] = {.lex_state = 192, .external_lex_state = 2},
  [3958] = {.lex_state = 192, .external_lex_state = 2},
  [3959] = {.lex_state = 192, .external_lex_state = 2},
  [3960] = {.lex_state = 192, .external_lex_state = 2},
  [3961] = {.lex_state = 192, .external_lex_state = 2},
  [3962] = {.lex_state = 192, .external_lex_state = 2},
  [3963] = {.lex_state = 192, .external_lex_state = 2},
  [3964] = {.lex_state = 192, .external_lex_state = 2},
  [3965] = {.lex_state = 192, .external_lex_state = 2},
  [3966] = {.lex_state = 192, .external_lex_state = 2},
  [3967] = {.lex_state = 192, .external_lex_state = 2},
  [3968] = {.lex_state = 411, .external_lex_state = 2},
  [3969] = {.lex_state = 435, .external_lex_state = 16},
  [3970] = {.lex_state = 177, .external_lex_state = 17},
  [3971] = {.lex_state = 443, .external_lex_state = 24},
  [3972] = {.lex_state = 528, .external_lex_state = 29},
  [3973] = {.lex_state = 443, .external_lex_state = 24},
  [3974] = {.lex_state = 192, .external_lex_state = 28},
  [3975] = {.lex_state = 192, .external_lex_state = 2},
  [3976] = {.lex_state = 669, .external_lex_state = 26},
  [3977] = {.lex_state = 192, .external_lex_state = 2},
  [3978] = {.lex_state = 192, .external_lex_state = 2},
  [3979] = {.lex_state = 462, .external_lex_state = 18},
  [3980] = {.lex_state = 462, .external_lex_state = 18},
  [3981] = {.lex_state = 462, .external_lex_state = 18},
  [3982] = {.lex_state = 462, .external_lex_state = 18},
  [3983] = {.lex_state = 192, .external_lex_state = 2},
  [3984] = {.lex_state = 192, .external_lex_state = 2},
  [3985] = {.lex_state = 438, .external_lex_state = 16},
  [3986] = {.lex_state = 438, .external_lex_state = 16},
  [3987] = {.lex_state = 213},
  [3988] = {.lex_state = 443, .external_lex_state = 16},
  [3989] = {.lex_state = 471, .external_lex_state = 20},
  [3990] = {.lex_state = 438, .external_lex_state = 16},
  [3991] = {.lex_state = 446, .external_lex_state = 20},
  [3992] = {.lex_state = 156, .external_lex_state = 3},
  [3993] = {.lex_state = 177, .external_lex_state = 4},
  [3994] = {.lex_state = 156, .external_lex_state = 3},
  [3995] = {.lex_state = 177, .external_lex_state = 30},
  [3996] = {.lex_state = 156, .external_lex_state = 3},
  [3997] = {.lex_state = 177, .external_lex_state = 4},
  [3998] = {.lex_state = 156, .external_lex_state = 3},
  [3999] = {.lex_state = 177, .external_lex_state = 30},
  [4000] = {.lex_state = 192, .external_lex_state = 2},
  [4001] = {.lex_state = 673, .external_lex_state = 10},
  [4002] = {.lex_state = 673, .external_lex_state = 10},
  [4003] = {.lex_state = 673, .external_lex_state = 10},
  [4004] = {.lex_state = 673, .external_lex_state = 10},
  [4005] = {.lex_state = 192, .external_lex_state = 2},
  [4006] = {.lex_state = 192, .external_lex_state = 2},
  [4007] = {.lex_state = 471, .external_lex_state = 3},
  [4008] = {.lex_state = 213},
  [4009] = {.lex_state = 443, .external_lex_state = 3},
  [4010] = {.lex_state = 471, .external_lex_state = 14},
  [4011] = {.lex_state = 471, .external_lex_state = 3},
  [4012] = {.lex_state = 595, .external_lex_state = 3},
  [4013] = {.lex_state = 668, .external_lex_state = 14},
  [4014] = {.lex_state = 192, .external_lex_state = 2},
  [4015] = {.lex_state = 471, .external_lex_state = 3},
  [4016] = {.lex_state = 595, .external_lex_state = 3},
  [4017] = {.lex_state = 595, .external_lex_state = 3},
  [4018] = {.lex_state = 595, .external_lex_state = 3},
  [4019] = {.lex_state = 192, .external_lex_state = 2},
  [4020] = {.lex_state = 192, .external_lex_state = 2},
  [4021] = {.lex_state = 192, .external_lex_state = 2},
  [4022] = {.lex_state = 192, .external_lex_state = 2},
  [4023] = {.lex_state = 192, .external_lex_state = 2},
  [4024] = {.lex_state = 192, .external_lex_state = 2},
  [4025] = {.lex_state = 192, .external_lex_state = 2},
  [4026] = {.lex_state = 192, .external_lex_state = 2},
  [4027] = {.lex_state = 192, .external_lex_state = 2},
  [4028] = {.lex_state = 192, .external_lex_state = 2},
  [4029] = {.lex_state = 192, .external_lex_state = 2},
  [4030] = {.lex_state = 446, .external_lex_state = 3},
  [4031] = {.lex_state = 528, .external_lex_state = 29},
  [4032] = {.lex_state = 471, .external_lex_state = 3},
  [4033] = {.lex_state = 192, .external_lex_state = 28},
  [4034] = {.lex_state = 192, .external_lex_state = 2},
  [4035] = {.lex_state = 668, .external_lex_state = 14},
  [4036] = {.lex_state = 239, .external_lex_state = 13},
  [4037] = {.lex_state = 438, .external_lex_state = 3},
  [4038] = {.lex_state = 438, .external_lex_state = 3},
  [4039] = {.lex_state = 438, .external_lex_state = 3},
  [4040] = {.lex_state = 438, .external_lex_state = 3},
  [4041] = {.lex_state = 438, .external_lex_state = 3},
  [4042] = {.lex_state = 438, .external_lex_state = 3},
  [4043] = {.lex_state = 438, .external_lex_state = 3},
  [4044] = {.lex_state = 438, .external_lex_state = 3},
  [4045] = {.lex_state = 438, .external_lex_state = 3},
  [4046] = {.lex_state = 438, .external_lex_state = 3},
  [4047] = {.lex_state = 561, .external_lex_state = 16},
  [4048] = {.lex_state = 438, .external_lex_state = 3},
  [4049] = {.lex_state = 438, .external_lex_state = 3},
  [4050] = {.lex_state = 438, .external_lex_state = 3},
  [4051] = {.lex_state = 438, .external_lex_state = 3},
  [4052] = {.lex_state = 192, .external_lex_state = 2},
  [4053] = {.lex_state = 454, .external_lex_state = 10},
  [4054] = {.lex_state = 454, .external_lex_state = 10},
  [4055] = {.lex_state = 454, .external_lex_state = 10},
  [4056] = {.lex_state = 454, .external_lex_state = 10},
  [4057] = {.lex_state = 192, .external_lex_state = 2},
  [4058] = {.lex_state = 192, .external_lex_state = 2},
  [4059] = {.lex_state = 443, .external_lex_state = 3},
  [4060] = {.lex_state = 454, .external_lex_state = 10},
  [4061] = {.lex_state = 213},
  [4062] = {.lex_state = 443, .external_lex_state = 3},
  [4063] = {.lex_state = 443, .external_lex_state = 14},
  [4064] = {.lex_state = 443, .external_lex_state = 3},
  [4065] = {.lex_state = 580, .external_lex_state = 3},
  [4066] = {.lex_state = 669, .external_lex_state = 14},
  [4067] = {.lex_state = 192, .external_lex_state = 2},
  [4068] = {.lex_state = 443, .external_lex_state = 3},
  [4069] = {.lex_state = 580, .external_lex_state = 3},
  [4070] = {.lex_state = 192, .external_lex_state = 2},
  [4071] = {.lex_state = 192, .external_lex_state = 2},
  [4072] = {.lex_state = 192, .external_lex_state = 2},
  [4073] = {.lex_state = 192, .external_lex_state = 2},
  [4074] = {.lex_state = 192, .external_lex_state = 2},
  [4075] = {.lex_state = 192, .external_lex_state = 2},
  [4076] = {.lex_state = 192, .external_lex_state = 2},
  [4077] = {.lex_state = 192, .external_lex_state = 2},
  [4078] = {.lex_state = 192, .external_lex_state = 2},
  [4079] = {.lex_state = 192, .external_lex_state = 2},
  [4080] = {.lex_state = 192, .external_lex_state = 2},
  [4081] = {.lex_state = 443, .external_lex_state = 3},
  [4082] = {.lex_state = 528, .external_lex_state = 29},
  [4083] = {.lex_state = 443, .external_lex_state = 3},
  [4084] = {.lex_state = 192, .external_lex_state = 28},
  [4085] = {.lex_state = 192, .external_lex_state = 2},
  [4086] = {.lex_state = 669, .external_lex_state = 14},
  [4087] = {.lex_state = 192, .external_lex_state = 2},
  [4088] = {.lex_state = 192, .external_lex_state = 2},
  [4089] = {.lex_state = 192, .external_lex_state = 2},
  [4090] = {.lex_state = 192, .external_lex_state = 2},
  [4091] = {.lex_state = 438, .external_lex_state = 3},
  [4092] = {.lex_state = 438, .external_lex_state = 3},
  [4093] = {.lex_state = 213},
  [4094] = {.lex_state = 443, .external_lex_state = 3},
  [4095] = {.lex_state = 438, .external_lex_state = 3},
  [4096] = {.lex_state = 446, .external_lex_state = 14},
  [4097] = {.lex_state = 290, .external_lex_state = 16},
  [4098] = {.lex_state = 290, .external_lex_state = 16},
  [4099] = {.lex_state = 177, .external_lex_state = 4},
  [4100] = {.lex_state = 268, .external_lex_state = 15},
  [4101] = {.lex_state = 290, .external_lex_state = 16},
  [4102] = {.lex_state = 177, .external_lex_state = 4},
  [4103] = {.lex_state = 290, .external_lex_state = 16},
  [4104] = {.lex_state = 290, .external_lex_state = 16},
  [4105] = {.lex_state = 177, .external_lex_state = 4},
  [4106] = {.lex_state = 268, .external_lex_state = 15},
  [4107] = {.lex_state = 290, .external_lex_state = 16},
  [4108] = {.lex_state = 177, .external_lex_state = 4},
  [4109] = {.lex_state = 177, .external_lex_state = 17},
  [4110] = {.lex_state = 290, .external_lex_state = 16},
  [4111] = {.lex_state = 312},
  [4112] = {.lex_state = 290, .external_lex_state = 16},
  [4113] = {.lex_state = 290, .external_lex_state = 16},
  [4114] = {.lex_state = 192, .external_lex_state = 2},
  [4115] = {.lex_state = 192, .external_lex_state = 2},
  [4116] = {.lex_state = 192, .external_lex_state = 2},
  [4117] = {.lex_state = 471, .external_lex_state = 24},
  [4118] = {.lex_state = 213},
  [4119] = {.lex_state = 443, .external_lex_state = 24},
  [4120] = {.lex_state = 471, .external_lex_state = 24},
  [4121] = {.lex_state = 595, .external_lex_state = 24},
  [4122] = {.lex_state = 668, .external_lex_state = 26},
  [4123] = {.lex_state = 192, .external_lex_state = 2},
  [4124] = {.lex_state = 471, .external_lex_state = 24},
  [4125] = {.lex_state = 192, .external_lex_state = 2},
  [4126] = {.lex_state = 192, .external_lex_state = 2},
  [4127] = {.lex_state = 239},
  [4128] = {.lex_state = 192, .external_lex_state = 2},
  [4129] = {.lex_state = 592, .external_lex_state = 25},
  [4130] = {.lex_state = 595, .external_lex_state = 24},
  [4131] = {.lex_state = 595, .external_lex_state = 24},
  [4132] = {.lex_state = 595, .external_lex_state = 24},
  [4133] = {.lex_state = 595, .external_lex_state = 26},
  [4134] = {.lex_state = 595, .external_lex_state = 24},
  [4135] = {.lex_state = 192, .external_lex_state = 2},
  [4136] = {.lex_state = 192, .external_lex_state = 2},
  [4137] = {.lex_state = 192, .external_lex_state = 2},
  [4138] = {.lex_state = 192, .external_lex_state = 2},
  [4139] = {.lex_state = 192, .external_lex_state = 2},
  [4140] = {.lex_state = 192, .external_lex_state = 2},
  [4141] = {.lex_state = 192, .external_lex_state = 2},
  [4142] = {.lex_state = 192, .external_lex_state = 2},
  [4143] = {.lex_state = 192, .external_lex_state = 2},
  [4144] = {.lex_state = 192, .external_lex_state = 2},
  [4145] = {.lex_state = 192, .external_lex_state = 2},
  [4146] = {.lex_state = 192, .external_lex_state = 2},
  [4147] = {.lex_state = 192, .external_lex_state = 2},
  [4148] = {.lex_state = 239},
  [4149] = {.lex_state = 192, .external_lex_state = 2},
  [4150] = {.lex_state = 592, .external_lex_state = 25},
  [4151] = {.lex_state = 580, .external_lex_state = 24},
  [4152] = {.lex_state = 580, .external_lex_state = 24},
  [4153] = {.lex_state = 580, .external_lex_state = 24},
  [4154] = {.lex_state = 580, .external_lex_state = 26},
  [4155] = {.lex_state = 471, .external_lex_state = 24},
  [4156] = {.lex_state = 528, .external_lex_state = 29},
  [4157] = {.lex_state = 471, .external_lex_state = 24},
  [4158] = {.lex_state = 192, .external_lex_state = 28},
  [4159] = {.lex_state = 192, .external_lex_state = 2},
  [4160] = {.lex_state = 668, .external_lex_state = 26},
  [4161] = {.lex_state = 438, .external_lex_state = 24},
  [4162] = {.lex_state = 438, .external_lex_state = 24},
  [4163] = {.lex_state = 438, .external_lex_state = 24},
  [4164] = {.lex_state = 438, .external_lex_state = 24},
  [4165] = {.lex_state = 438, .external_lex_state = 24},
  [4166] = {.lex_state = 561, .external_lex_state = 16},
  [4167] = {.lex_state = 438, .external_lex_state = 24},
  [4168] = {.lex_state = 438, .external_lex_state = 24},
  [4169] = {.lex_state = 438, .external_lex_state = 24},
  [4170] = {.lex_state = 438, .external_lex_state = 24},
  [4171] = {.lex_state = 602, .external_lex_state = 25},
  [4172] = {.lex_state = 358, .external_lex_state = 12},
  [4173] = {.lex_state = 602, .external_lex_state = 25},
  [4174] = {.lex_state = 602, .external_lex_state = 25},
  [4175] = {.lex_state = 418, .external_lex_state = 27},
  [4176] = {.lex_state = 465, .external_lex_state = 24},
  [4177] = {.lex_state = 237},
  [4178] = {.lex_state = 602, .external_lex_state = 25},
  [4179] = {.lex_state = 192, .external_lex_state = 2},
  [4180] = {.lex_state = 440, .external_lex_state = 25},
  [4181] = {.lex_state = 440, .external_lex_state = 25},
  [4182] = {.lex_state = 440, .external_lex_state = 25},
  [4183] = {.lex_state = 440, .external_lex_state = 25},
  [4184] = {.lex_state = 192, .external_lex_state = 2},
  [4185] = {.lex_state = 192, .external_lex_state = 2},
  [4186] = {.lex_state = 443, .external_lex_state = 24},
  [4187] = {.lex_state = 440, .external_lex_state = 25},
  [4188] = {.lex_state = 213},
  [4189] = {.lex_state = 443, .external_lex_state = 24},
  [4190] = {.lex_state = 443, .external_lex_state = 26},
  [4191] = {.lex_state = 443, .external_lex_state = 24},
  [4192] = {.lex_state = 580, .external_lex_state = 24},
  [4193] = {.lex_state = 669, .external_lex_state = 26},
  [4194] = {.lex_state = 192, .external_lex_state = 2},
  [4195] = {.lex_state = 399, .external_lex_state = 24},
  [4196] = {.lex_state = 194},
  [4197] = {.lex_state = 288, .external_lex_state = 2},
  [4198] = {.lex_state = 443, .external_lex_state = 24},
  [4199] = {.lex_state = 465, .external_lex_state = 24},
  [4200] = {.lex_state = 128},
  [4201] = {.lex_state = 128, .external_lex_state = 11},
  [4202] = {.lex_state = 416, .external_lex_state = 2},
  [4203] = {.lex_state = 580, .external_lex_state = 24},
  [4204] = {.lex_state = 192, .external_lex_state = 2},
  [4205] = {.lex_state = 192, .external_lex_state = 2},
  [4206] = {.lex_state = 192, .external_lex_state = 2},
  [4207] = {.lex_state = 192, .external_lex_state = 2},
  [4208] = {.lex_state = 192, .external_lex_state = 2},
  [4209] = {.lex_state = 192, .external_lex_state = 2},
  [4210] = {.lex_state = 192, .external_lex_state = 2},
  [4211] = {.lex_state = 192, .external_lex_state = 2},
  [4212] = {.lex_state = 192, .external_lex_state = 2},
  [4213] = {.lex_state = 192, .external_lex_state = 2},
  [4214] = {.lex_state = 192, .external_lex_state = 2},
  [4215] = {.lex_state = 411, .external_lex_state = 2},
  [4216] = {.lex_state = 465, .external_lex_state = 24},
  [4217] = {.lex_state = 443, .external_lex_state = 24},
  [4218] = {.lex_state = 528, .external_lex_state = 29},
  [4219] = {.lex_state = 443, .external_lex_state = 24},
  [4220] = {.lex_state = 192, .external_lex_state = 28},
  [4221] = {.lex_state = 192, .external_lex_state = 2},
  [4222] = {.lex_state = 669, .external_lex_state = 26},
  [4223] = {.lex_state = 192, .external_lex_state = 2},
  [4224] = {.lex_state = 438, .external_lex_state = 24},
  [4225] = {.lex_state = 438, .external_lex_state = 24},
  [4226] = {.lex_state = 438, .external_lex_state = 24},
  [4227] = {.lex_state = 471, .external_lex_state = 26},
  [4228] = {.lex_state = 128, .external_lex_state = 2},
  [4229] = {.lex_state = 128, .external_lex_state = 2},
  [4230] = {.lex_state = 290, .external_lex_state = 16},
  [4231] = {.lex_state = 290, .external_lex_state = 16},
  [4232] = {.lex_state = 363, .external_lex_state = 24},
  [4233] = {.lex_state = 363, .external_lex_state = 24},
  [4234] = {.lex_state = 363, .external_lex_state = 24},
  [4235] = {.lex_state = 390, .external_lex_state = 24},
  [4236] = {.lex_state = 363, .external_lex_state = 24},
  [4237] = {.lex_state = 363, .external_lex_state = 24},
  [4238] = {.lex_state = 363, .external_lex_state = 24},
  [4239] = {.lex_state = 363, .external_lex_state = 24},
  [4240] = {.lex_state = 363, .external_lex_state = 24},
  [4241] = {.lex_state = 363, .external_lex_state = 24},
  [4242] = {.lex_state = 561, .external_lex_state = 16},
  [4243] = {.lex_state = 363, .external_lex_state = 24},
  [4244] = {.lex_state = 363, .external_lex_state = 24},
  [4245] = {.lex_state = 363, .external_lex_state = 24},
  [4246] = {.lex_state = 363, .external_lex_state = 24},
  [4247] = {.lex_state = 390, .external_lex_state = 24},
  [4248] = {.lex_state = 177, .external_lex_state = 17},
  [4249] = {.lex_state = 307, .external_lex_state = 24},
  [4250] = {.lex_state = 390, .external_lex_state = 24},
  [4251] = {.lex_state = 528, .external_lex_state = 12},
  [4252] = {.lex_state = 307, .external_lex_state = 24},
  [4253] = {.lex_state = 363, .external_lex_state = 24},
  [4254] = {.lex_state = 363, .external_lex_state = 24},
  [4255] = {.lex_state = 390, .external_lex_state = 24},
  [4256] = {.lex_state = 363, .external_lex_state = 24},
  [4257] = {.lex_state = 363, .external_lex_state = 24},
  [4258] = {.lex_state = 363, .external_lex_state = 26},
  [4259] = {.lex_state = 290, .external_lex_state = 16},
  [4260] = {.lex_state = 128},
  [4261] = {.lex_state = 290, .external_lex_state = 16},
  [4262] = {.lex_state = 128},
  [4263] = {.lex_state = 290, .external_lex_state = 16},
  [4264] = {.lex_state = 128},
  [4265] = {.lex_state = 290, .external_lex_state = 16},
  [4266] = {.lex_state = 128},
  [4267] = {.lex_state = 128, .external_lex_state = 2},
  [4268] = {.lex_state = 290, .external_lex_state = 16},
  [4269] = {.lex_state = 128},
  [4270] = {.lex_state = 128},
  [4271] = {.lex_state = 128},
  [4272] = {.lex_state = 290, .external_lex_state = 16},
  [4273] = {.lex_state = 128},
  [4274] = {.lex_state = 128},
  [4275] = {.lex_state = 290, .external_lex_state = 16},
  [4276] = {.lex_state = 194},
  [4277] = {.lex_state = 290, .external_lex_state = 16},
  [4278] = {.lex_state = 128},
  [4279] = {.lex_state = 128, .external_lex_state = 2},
  [4280] = {.lex_state = 128, .external_lex_state = 11},
  [4281] = {.lex_state = 192, .external_lex_state = 2},
  [4282] = {.lex_state = 306, .external_lex_state = 18},
  [4283] = {.lex_state = 209},
  [4284] = {.lex_state = 306, .external_lex_state = 18},
  [4285] = {.lex_state = 301, .external_lex_state = 16},
  [4286] = {.lex_state = 605, .external_lex_state = 26},
  [4287] = {.lex_state = 399, .external_lex_state = 24},
  [4288] = {.lex_state = 399, .external_lex_state = 24},
  [4289] = {.lex_state = 399, .external_lex_state = 24},
  [4290] = {.lex_state = 399, .external_lex_state = 24},
  [4291] = {.lex_state = 192, .external_lex_state = 15},
  [4292] = {.lex_state = 268, .external_lex_state = 15},
  [4293] = {.lex_state = 399, .external_lex_state = 24},
  [4294] = {.lex_state = 177, .external_lex_state = 4},
  [4295] = {.lex_state = 268, .external_lex_state = 15},
  [4296] = {.lex_state = 399, .external_lex_state = 24},
  [4297] = {.lex_state = 192, .external_lex_state = 15},
  [4298] = {.lex_state = 268, .external_lex_state = 15},
  [4299] = {.lex_state = 399, .external_lex_state = 24},
  [4300] = {.lex_state = 177, .external_lex_state = 4},
  [4301] = {.lex_state = 268, .external_lex_state = 15},
  [4302] = {.lex_state = 399, .external_lex_state = 24},
  [4303] = {.lex_state = 423, .external_lex_state = 24},
  [4304] = {.lex_state = 301, .external_lex_state = 16},
  [4305] = {.lex_state = 194},
  [4306] = {.lex_state = 399, .external_lex_state = 24},
  [4307] = {.lex_state = 194},
  [4308] = {.lex_state = 304, .external_lex_state = 16},
  [4309] = {.lex_state = 227, .external_lex_state = 7},
  [4310] = {.lex_state = 128, .external_lex_state = 2},
  [4311] = {.lex_state = 399, .external_lex_state = 24},
  [4312] = {.lex_state = 249, .external_lex_state = 3},
  [4313] = {.lex_state = 128, .external_lex_state = 13},
  [4314] = {.lex_state = 128, .external_lex_state = 2},
  [4315] = {.lex_state = 399, .external_lex_state = 24},
  [4316] = {.lex_state = 128, .external_lex_state = 2},
  [4317] = {.lex_state = 128},
  [4318] = {.lex_state = 128, .external_lex_state = 2},
  [4319] = {.lex_state = 128},
  [4320] = {.lex_state = 128, .external_lex_state = 2},
  [4321] = {.lex_state = 128, .external_lex_state = 2},
  [4322] = {.lex_state = 128, .external_lex_state = 2},
  [4323] = {.lex_state = 128, .external_lex_state = 13},
  [4324] = {.lex_state = 301, .external_lex_state = 16},
  [4325] = {.lex_state = 128},
  [4326] = {.lex_state = 128, .external_lex_state = 2},
  [4327] = {.lex_state = 128, .external_lex_state = 11},
  [4328] = {.lex_state = 128},
  [4329] = {.lex_state = 399, .external_lex_state = 24},
  [4330] = {.lex_state = 128},
  [4331] = {.lex_state = 128},
  [4332] = {.lex_state = 128},
  [4333] = {.lex_state = 399, .external_lex_state = 24},
  [4334] = {.lex_state = 128},
  [4335] = {.lex_state = 128},
  [4336] = {.lex_state = 128},
  [4337] = {.lex_state = 399, .external_lex_state = 24},
  [4338] = {.lex_state = 399, .external_lex_state = 24},
  [4339] = {.lex_state = 423, .external_lex_state = 24},
  [4340] = {.lex_state = 399, .external_lex_state = 24},
  [4341] = {.lex_state = 399, .external_lex_state = 24},
  [4342] = {.lex_state = 399, .external_lex_state = 24},
  [4343] = {.lex_state = 423, .external_lex_state = 24},
  [4344] = {.lex_state = 423, .external_lex_state = 24},
  [4345] = {.lex_state = 423, .external_lex_state = 24},
  [4346] = {.lex_state = 423, .external_lex_state = 24},
  [4347] = {.lex_state = 423, .external_lex_state = 24},
  [4348] = {.lex_state = 561, .external_lex_state = 16},
  [4349] = {.lex_state = 423, .external_lex_state = 24},
  [4350] = {.lex_state = 423, .external_lex_state = 24},
  [4351] = {.lex_state = 423, .external_lex_state = 24},
  [4352] = {.lex_state = 423, .external_lex_state = 24},
  [4353] = {.lex_state = 301, .external_lex_state = 16},
  [4354] = {.lex_state = 399, .external_lex_state = 24},
  [4355] = {.lex_state = 177, .external_lex_state = 17},
  [4356] = {.lex_state = 423, .external_lex_state = 24},
  [4357] = {.lex_state = 399, .external_lex_state = 24},
  [4358] = {.lex_state = 528, .external_lex_state = 12},
  [4359] = {.lex_state = 423, .external_lex_state = 24},
  [4360] = {.lex_state = 423, .external_lex_state = 24},
  [4361] = {.lex_state = 423, .external_lex_state = 24},
  [4362] = {.lex_state = 399, .external_lex_state = 24},
  [4363] = {.lex_state = 423, .external_lex_state = 24},
  [4364] = {.lex_state = 423, .external_lex_state = 24},
  [4365] = {.lex_state = 423, .external_lex_state = 26},
  [4366] = {.lex_state = 304, .external_lex_state = 16},
  [4367] = {.lex_state = 304, .external_lex_state = 16},
  [4368] = {.lex_state = 304, .external_lex_state = 16},
  [4369] = {.lex_state = 192, .external_lex_state = 2},
  [4370] = {.lex_state = 192, .external_lex_state = 2},
  [4371] = {.lex_state = 192, .external_lex_state = 2},
  [4372] = {.lex_state = 192, .external_lex_state = 2},
  [4373] = {.lex_state = 192, .external_lex_state = 2},
  [4374] = {.lex_state = 192, .external_lex_state = 2},
  [4375] = {.lex_state = 192, .external_lex_state = 2},
  [4376] = {.lex_state = 192, .external_lex_state = 2},
  [4377] = {.lex_state = 192, .external_lex_state = 2},
  [4378] = {.lex_state = 192, .external_lex_state = 2},
  [4379] = {.lex_state = 192, .external_lex_state = 28},
  [4380] = {.lex_state = 304, .external_lex_state = 16},
  [4381] = {.lex_state = 192, .external_lex_state = 28},
  [4382] = {.lex_state = 192, .external_lex_state = 2},
  [4383] = {.lex_state = 156, .external_lex_state = 20},
  [4384] = {.lex_state = 194, .external_lex_state = 6},
  [4385] = {.lex_state = 177, .external_lex_state = 17},
  [4386] = {.lex_state = 194, .external_lex_state = 19},
  [4387] = {.lex_state = 192, .external_lex_state = 2},
  [4388] = {.lex_state = 192, .external_lex_state = 2},
  [4389] = {.lex_state = 192, .external_lex_state = 2},
  [4390] = {.lex_state = 497, .external_lex_state = 24},
  [4391] = {.lex_state = 213},
  [4392] = {.lex_state = 323, .external_lex_state = 24},
  [4393] = {.lex_state = 497, .external_lex_state = 24},
  [4394] = {.lex_state = 497, .external_lex_state = 24},
  [4395] = {.lex_state = 192, .external_lex_state = 2},
  [4396] = {.lex_state = 497, .external_lex_state = 24},
  [4397] = {.lex_state = 497, .external_lex_state = 24},
  [4398] = {.lex_state = 192, .external_lex_state = 2},
  [4399] = {.lex_state = 192, .external_lex_state = 2},
  [4400] = {.lex_state = 192, .external_lex_state = 2},
  [4401] = {.lex_state = 192, .external_lex_state = 2},
  [4402] = {.lex_state = 192, .external_lex_state = 2},
  [4403] = {.lex_state = 192, .external_lex_state = 2},
  [4404] = {.lex_state = 192, .external_lex_state = 2},
  [4405] = {.lex_state = 192, .external_lex_state = 2},
  [4406] = {.lex_state = 192, .external_lex_state = 2},
  [4407] = {.lex_state = 192, .external_lex_state = 2},
  [4408] = {.lex_state = 192, .external_lex_state = 2},
  [4409] = {.lex_state = 326, .external_lex_state = 24},
  [4410] = {.lex_state = 528, .external_lex_state = 29},
  [4411] = {.lex_state = 497, .external_lex_state = 24},
  [4412] = {.lex_state = 192, .external_lex_state = 28},
  [4413] = {.lex_state = 192, .external_lex_state = 2},
  [4414] = {.lex_state = 304, .external_lex_state = 16},
  [4415] = {.lex_state = 304, .external_lex_state = 16},
  [4416] = {.lex_state = 227, .external_lex_state = 7},
  [4417] = {.lex_state = 304, .external_lex_state = 16},
  [4418] = {.lex_state = 304, .external_lex_state = 16},
  [4419] = {.lex_state = 304, .external_lex_state = 16},
  [4420] = {.lex_state = 561, .external_lex_state = 16},
  [4421] = {.lex_state = 304, .external_lex_state = 16},
  [4422] = {.lex_state = 304, .external_lex_state = 16},
  [4423] = {.lex_state = 304, .external_lex_state = 16},
  [4424] = {.lex_state = 304, .external_lex_state = 16},
  [4425] = {.lex_state = 192, .external_lex_state = 2},
  [4426] = {.lex_state = 482, .external_lex_state = 25},
  [4427] = {.lex_state = 482, .external_lex_state = 25},
  [4428] = {.lex_state = 482, .external_lex_state = 25},
  [4429] = {.lex_state = 482, .external_lex_state = 25},
  [4430] = {.lex_state = 192, .external_lex_state = 2},
  [4431] = {.lex_state = 192, .external_lex_state = 2},
  [4432] = {.lex_state = 323, .external_lex_state = 24},
  [4433] = {.lex_state = 482, .external_lex_state = 25},
  [4434] = {.lex_state = 213},
  [4435] = {.lex_state = 323, .external_lex_state = 24},
  [4436] = {.lex_state = 323, .external_lex_state = 26},
  [4437] = {.lex_state = 323, .external_lex_state = 24},
  [4438] = {.lex_state = 501, .external_lex_state = 24},
  [4439] = {.lex_state = 621, .external_lex_state = 26},
  [4440] = {.lex_state = 192, .external_lex_state = 2},
  [4441] = {.lex_state = 323, .external_lex_state = 24},
  [4442] = {.lex_state = 501, .external_lex_state = 24},
  [4443] = {.lex_state = 192, .external_lex_state = 2},
  [4444] = {.lex_state = 192, .external_lex_state = 2},
  [4445] = {.lex_state = 192, .external_lex_state = 2},
  [4446] = {.lex_state = 192, .external_lex_state = 2},
  [4447] = {.lex_state = 192, .external_lex_state = 2},
  [4448] = {.lex_state = 192, .external_lex_state = 2},
  [4449] = {.lex_state = 192, .external_lex_state = 2},
  [4450] = {.lex_state = 192, .external_lex_state = 2},
  [4451] = {.lex_state = 192, .external_lex_state = 2},
  [4452] = {.lex_state = 192, .external_lex_state = 2},
  [4453] = {.lex_state = 192, .external_lex_state = 2},
  [4454] = {.lex_state = 323, .external_lex_state = 24},
  [4455] = {.lex_state = 528, .external_lex_state = 29},
  [4456] = {.lex_state = 323, .external_lex_state = 24},
  [4457] = {.lex_state = 192, .external_lex_state = 28},
  [4458] = {.lex_state = 192, .external_lex_state = 2},
  [4459] = {.lex_state = 621, .external_lex_state = 26},
  [4460] = {.lex_state = 192, .external_lex_state = 2},
  [4461] = {.lex_state = 192, .external_lex_state = 2},
  [4462] = {.lex_state = 642, .external_lex_state = 18},
  [4463] = {.lex_state = 642, .external_lex_state = 18},
  [4464] = {.lex_state = 642, .external_lex_state = 18},
  [4465] = {.lex_state = 642, .external_lex_state = 18},
  [4466] = {.lex_state = 192, .external_lex_state = 2},
  [4467] = {.lex_state = 192, .external_lex_state = 2},
  [4468] = {.lex_state = 304, .external_lex_state = 16},
  [4469] = {.lex_state = 304, .external_lex_state = 16},
  [4470] = {.lex_state = 213},
  [4471] = {.lex_state = 323, .external_lex_state = 16},
  [4472] = {.lex_state = 617, .external_lex_state = 20},
  [4473] = {.lex_state = 304, .external_lex_state = 16},
  [4474] = {.lex_state = 326, .external_lex_state = 20},
  [4475] = {.lex_state = 128, .external_lex_state = 2},
  [4476] = {.lex_state = 128, .external_lex_state = 11},
  [4477] = {.lex_state = 304},
  [4478] = {.lex_state = 411, .external_lex_state = 2},
  [4479] = {.lex_state = 416, .external_lex_state = 11},
  [4480] = {.lex_state = 128},
  [4481] = {.lex_state = 256, .external_lex_state = 13},
  [4482] = {.lex_state = 532, .external_lex_state = 3},
  [4483] = {.lex_state = 532, .external_lex_state = 3},
  [4484] = {.lex_state = 197},
  [4485] = {.lex_state = 256, .external_lex_state = 13},
  [4486] = {.lex_state = 192, .external_lex_state = 2},
  [4487] = {.lex_state = 676, .external_lex_state = 25},
  [4488] = {.lex_state = 676, .external_lex_state = 25},
  [4489] = {.lex_state = 676, .external_lex_state = 25},
  [4490] = {.lex_state = 676, .external_lex_state = 25},
  [4491] = {.lex_state = 192, .external_lex_state = 2},
  [4492] = {.lex_state = 192, .external_lex_state = 2},
  [4493] = {.lex_state = 628, .external_lex_state = 24},
  [4494] = {.lex_state = 213},
  [4495] = {.lex_state = 323, .external_lex_state = 24},
  [4496] = {.lex_state = 628, .external_lex_state = 26},
  [4497] = {.lex_state = 628, .external_lex_state = 24},
  [4498] = {.lex_state = 611, .external_lex_state = 24},
  [4499] = {.lex_state = 679, .external_lex_state = 26},
  [4500] = {.lex_state = 192, .external_lex_state = 2},
  [4501] = {.lex_state = 628, .external_lex_state = 24},
  [4502] = {.lex_state = 192, .external_lex_state = 2},
  [4503] = {.lex_state = 192, .external_lex_state = 2},
  [4504] = {.lex_state = 239},
  [4505] = {.lex_state = 192, .external_lex_state = 2},
  [4506] = {.lex_state = 524, .external_lex_state = 25},
  [4507] = {.lex_state = 611, .external_lex_state = 24},
  [4508] = {.lex_state = 611, .external_lex_state = 24},
  [4509] = {.lex_state = 611, .external_lex_state = 24},
  [4510] = {.lex_state = 611, .external_lex_state = 26},
  [4511] = {.lex_state = 611, .external_lex_state = 24},
  [4512] = {.lex_state = 192, .external_lex_state = 2},
  [4513] = {.lex_state = 192, .external_lex_state = 2},
  [4514] = {.lex_state = 192, .external_lex_state = 2},
  [4515] = {.lex_state = 192, .external_lex_state = 2},
  [4516] = {.lex_state = 192, .external_lex_state = 2},
  [4517] = {.lex_state = 192, .external_lex_state = 2},
  [4518] = {.lex_state = 192, .external_lex_state = 2},
  [4519] = {.lex_state = 192, .external_lex_state = 2},
  [4520] = {.lex_state = 192, .external_lex_state = 2},
  [4521] = {.lex_state = 192, .external_lex_state = 2},
  [4522] = {.lex_state = 192, .external_lex_state = 2},
  [4523] = {.lex_state = 339, .external_lex_state = 19},
  [4524] = {.lex_state = 528, .external_lex_state = 29},
  [4525] = {.lex_state = 339, .external_lex_state = 19},
  [4526] = {.lex_state = 192, .external_lex_state = 28},
  [4527] = {.lex_state = 192, .external_lex_state = 2},
  [4528] = {.lex_state = 679, .external_lex_state = 26},
  [4529] = {.lex_state = 497, .external_lex_state = 3},
  [4530] = {.lex_state = 497, .external_lex_state = 3},
  [4531] = {.lex_state = 497, .external_lex_state = 3},
  [4532] = {.lex_state = 497, .external_lex_state = 3},
  [4533] = {.lex_state = 192, .external_lex_state = 2},
  [4534] = {.lex_state = 192, .external_lex_state = 2},
  [4535] = {.lex_state = 192, .external_lex_state = 2},
  [4536] = {.lex_state = 192, .external_lex_state = 2},
  [4537] = {.lex_state = 192, .external_lex_state = 2},
  [4538] = {.lex_state = 192, .external_lex_state = 2},
  [4539] = {.lex_state = 192, .external_lex_state = 2},
  [4540] = {.lex_state = 192, .external_lex_state = 2},
  [4541] = {.lex_state = 192, .external_lex_state = 2},
  [4542] = {.lex_state = 192, .external_lex_state = 2},
  [4543] = {.lex_state = 192, .external_lex_state = 28},
  [4544] = {.lex_state = 192, .external_lex_state = 2},
  [4545] = {.lex_state = 617, .external_lex_state = 14},
  [4546] = {.lex_state = 497, .external_lex_state = 3},
  [4547] = {.lex_state = 497, .external_lex_state = 3},
  [4548] = {.lex_state = 497, .external_lex_state = 3},
  [4549] = {.lex_state = 192, .external_lex_state = 2},
  [4550] = {.lex_state = 497, .external_lex_state = 3},
  [4551] = {.lex_state = 192, .external_lex_state = 2},
  [4552] = {.lex_state = 497, .external_lex_state = 3},
  [4553] = {.lex_state = 528, .external_lex_state = 29},
  [4554] = {.lex_state = 497, .external_lex_state = 3},
  [4555] = {.lex_state = 497, .external_lex_state = 3},
  [4556] = {.lex_state = 497, .external_lex_state = 3},
  [4557] = {.lex_state = 497, .external_lex_state = 3},
  [4558] = {.lex_state = 497, .external_lex_state = 3},
  [4559] = {.lex_state = 497, .external_lex_state = 3},
  [4560] = {.lex_state = 497, .external_lex_state = 3},
  [4561] = {.lex_state = 561, .external_lex_state = 16},
  [4562] = {.lex_state = 497, .external_lex_state = 3},
  [4563] = {.lex_state = 497, .external_lex_state = 3},
  [4564] = {.lex_state = 497, .external_lex_state = 3},
  [4565] = {.lex_state = 497, .external_lex_state = 3},
  [4566] = {.lex_state = 501, .external_lex_state = 3},
  [4567] = {.lex_state = 501, .external_lex_state = 3},
  [4568] = {.lex_state = 192, .external_lex_state = 2},
  [4569] = {.lex_state = 501, .external_lex_state = 3},
  [4570] = {.lex_state = 192, .external_lex_state = 2},
  [4571] = {.lex_state = 501, .external_lex_state = 3},
  [4572] = {.lex_state = 528, .external_lex_state = 29},
  [4573] = {.lex_state = 501, .external_lex_state = 3},
  [4574] = {.lex_state = 326, .external_lex_state = 3},
  [4575] = {.lex_state = 528, .external_lex_state = 12},
  [4576] = {.lex_state = 326, .external_lex_state = 3},
  [4577] = {.lex_state = 497, .external_lex_state = 3},
  [4578] = {.lex_state = 497, .external_lex_state = 3},
  [4579] = {.lex_state = 497, .external_lex_state = 3},
  [4580] = {.lex_state = 497, .external_lex_state = 3},
  [4581] = {.lex_state = 620, .external_lex_state = 14},
  [4582] = {.lex_state = 304, .external_lex_state = 13},
  [4583] = {.lex_state = 192, .external_lex_state = 2},
  [4584] = {.lex_state = 323, .external_lex_state = 3},
  [4585] = {.lex_state = 323, .external_lex_state = 3},
  [4586] = {.lex_state = 192, .external_lex_state = 2},
  [4587] = {.lex_state = 192, .external_lex_state = 2},
  [4588] = {.lex_state = 192, .external_lex_state = 2},
  [4589] = {.lex_state = 192, .external_lex_state = 2},
  [4590] = {.lex_state = 192, .external_lex_state = 2},
  [4591] = {.lex_state = 192, .external_lex_state = 2},
  [4592] = {.lex_state = 192, .external_lex_state = 2},
  [4593] = {.lex_state = 192, .external_lex_state = 2},
  [4594] = {.lex_state = 192, .external_lex_state = 2},
  [4595] = {.lex_state = 192, .external_lex_state = 2},
  [4596] = {.lex_state = 192, .external_lex_state = 28},
  [4597] = {.lex_state = 192, .external_lex_state = 2},
  [4598] = {.lex_state = 323, .external_lex_state = 14},
  [4599] = {.lex_state = 323, .external_lex_state = 3},
  [4600] = {.lex_state = 323, .external_lex_state = 3},
  [4601] = {.lex_state = 501, .external_lex_state = 3},
  [4602] = {.lex_state = 501, .external_lex_state = 3},
  [4603] = {.lex_state = 501, .external_lex_state = 3},
  [4604] = {.lex_state = 501, .external_lex_state = 3},
  [4605] = {.lex_state = 501, .external_lex_state = 3},
  [4606] = {.lex_state = 561, .external_lex_state = 16},
  [4607] = {.lex_state = 501, .external_lex_state = 3},
  [4608] = {.lex_state = 501, .external_lex_state = 3},
  [4609] = {.lex_state = 501, .external_lex_state = 3},
  [4610] = {.lex_state = 501, .external_lex_state = 3},
  [4611] = {.lex_state = 323, .external_lex_state = 3},
  [4612] = {.lex_state = 528, .external_lex_state = 12},
  [4613] = {.lex_state = 323, .external_lex_state = 3},
  [4614] = {.lex_state = 323, .external_lex_state = 3},
  [4615] = {.lex_state = 501, .external_lex_state = 3},
  [4616] = {.lex_state = 501, .external_lex_state = 3},
  [4617] = {.lex_state = 501, .external_lex_state = 3},
  [4618] = {.lex_state = 621, .external_lex_state = 14},
  [4619] = {.lex_state = 304, .external_lex_state = 3},
  [4620] = {.lex_state = 304, .external_lex_state = 3},
  [4621] = {.lex_state = 304, .external_lex_state = 3},
  [4622] = {.lex_state = 192, .external_lex_state = 2},
  [4623] = {.lex_state = 192, .external_lex_state = 2},
  [4624] = {.lex_state = 192, .external_lex_state = 2},
  [4625] = {.lex_state = 192, .external_lex_state = 2},
  [4626] = {.lex_state = 192, .external_lex_state = 2},
  [4627] = {.lex_state = 192, .external_lex_state = 2},
  [4628] = {.lex_state = 192, .external_lex_state = 2},
  [4629] = {.lex_state = 192, .external_lex_state = 2},
  [4630] = {.lex_state = 192, .external_lex_state = 2},
  [4631] = {.lex_state = 192, .external_lex_state = 2},
  [4632] = {.lex_state = 192, .external_lex_state = 28},
  [4633] = {.lex_state = 304, .external_lex_state = 3},
  [4634] = {.lex_state = 192, .external_lex_state = 28},
  [4635] = {.lex_state = 192, .external_lex_state = 2},
  [4636] = {.lex_state = 223, .external_lex_state = 8},
  [4637] = {.lex_state = 332},
  [4638] = {.lex_state = 332},
  [4639] = {.lex_state = 177, .external_lex_state = 4},
  [4640] = {.lex_state = 268, .external_lex_state = 15},
  [4641] = {.lex_state = 332},
  [4642] = {.lex_state = 177, .external_lex_state = 4},
  [4643] = {.lex_state = 332},
  [4644] = {.lex_state = 332},
  [4645] = {.lex_state = 177, .external_lex_state = 4},
  [4646] = {.lex_state = 268, .external_lex_state = 15},
  [4647] = {.lex_state = 332},
  [4648] = {.lex_state = 177, .external_lex_state = 4},
  [4649] = {.lex_state = 332},
  [4650] = {.lex_state = 312},
  [4651] = {.lex_state = 332},
  [4652] = {.lex_state = 332},
  [4653] = {.lex_state = 128, .external_lex_state = 2},
  [4654] = {.lex_state = 128, .external_lex_state = 2},
  [4655] = {.lex_state = 332},
  [4656] = {.lex_state = 332},
  [4657] = {.lex_state = 363, .external_lex_state = 24},
  [4658] = {.lex_state = 192, .external_lex_state = 2},
  [4659] = {.lex_state = 192, .external_lex_state = 2},
  [4660] = {.lex_state = 239},
  [4661] = {.lex_state = 192, .external_lex_state = 2},
  [4662] = {.lex_state = 298, .external_lex_state = 25},
  [4663] = {.lex_state = 363, .external_lex_state = 24},
  [4664] = {.lex_state = 363, .external_lex_state = 24},
  [4665] = {.lex_state = 363, .external_lex_state = 24},
  [4666] = {.lex_state = 373, .external_lex_state = 26},
  [4667] = {.lex_state = 363, .external_lex_state = 24},
  [4668] = {.lex_state = 192, .external_lex_state = 2},
  [4669] = {.lex_state = 192, .external_lex_state = 2},
  [4670] = {.lex_state = 192, .external_lex_state = 2},
  [4671] = {.lex_state = 192, .external_lex_state = 2},
  [4672] = {.lex_state = 192, .external_lex_state = 2},
  [4673] = {.lex_state = 192, .external_lex_state = 2},
  [4674] = {.lex_state = 192, .external_lex_state = 2},
  [4675] = {.lex_state = 192, .external_lex_state = 2},
  [4676] = {.lex_state = 192, .external_lex_state = 2},
  [4677] = {.lex_state = 192, .external_lex_state = 2},
  [4678] = {.lex_state = 192, .external_lex_state = 2},
  [4679] = {.lex_state = 192, .external_lex_state = 2},
  [4680] = {.lex_state = 239},
  [4681] = {.lex_state = 192, .external_lex_state = 2},
  [4682] = {.lex_state = 298, .external_lex_state = 25},
  [4683] = {.lex_state = 423, .external_lex_state = 24},
  [4684] = {.lex_state = 426, .external_lex_state = 24},
  [4685] = {.lex_state = 426, .external_lex_state = 24},
  [4686] = {.lex_state = 429, .external_lex_state = 26},
  [4687] = {.lex_state = 192, .external_lex_state = 28},
  [4688] = {.lex_state = 192, .external_lex_state = 2},
  [4689] = {.lex_state = 367, .external_lex_state = 26},
  [4690] = {.lex_state = 363, .external_lex_state = 24},
  [4691] = {.lex_state = 339, .external_lex_state = 19},
  [4692] = {.lex_state = 363, .external_lex_state = 24},
  [4693] = {.lex_state = 339, .external_lex_state = 19},
  [4694] = {.lex_state = 177, .external_lex_state = 17},
  [4695] = {.lex_state = 336, .external_lex_state = 19},
  [4696] = {.lex_state = 528, .external_lex_state = 12},
  [4697] = {.lex_state = 336, .external_lex_state = 19},
  [4698] = {.lex_state = 342, .external_lex_state = 19},
  [4699] = {.lex_state = 332},
  [4700] = {.lex_state = 128},
  [4701] = {.lex_state = 332},
  [4702] = {.lex_state = 128},
  [4703] = {.lex_state = 332},
  [4704] = {.lex_state = 128},
  [4705] = {.lex_state = 332},
  [4706] = {.lex_state = 128},
  [4707] = {.lex_state = 128, .external_lex_state = 2},
  [4708] = {.lex_state = 332},
  [4709] = {.lex_state = 128},
  [4710] = {.lex_state = 128},
  [4711] = {.lex_state = 128},
  [4712] = {.lex_state = 332},
  [4713] = {.lex_state = 128},
  [4714] = {.lex_state = 128},
  [4715] = {.lex_state = 339},
  [4716] = {.lex_state = 194},
  [4717] = {.lex_state = 339},
  [4718] = {.lex_state = 128},
  [4719] = {.lex_state = 128, .external_lex_state = 2},
  [4720] = {.lex_state = 128, .external_lex_state = 11},
  [4721] = {.lex_state = 488, .external_lex_state = 12},
  [4722] = {.lex_state = 209},
  [4723] = {.lex_state = 488, .external_lex_state = 12},
  [4724] = {.lex_state = 339},
  [4725] = {.lex_state = 680, .external_lex_state = 26},
  [4726] = {.lex_state = 192, .external_lex_state = 15},
  [4727] = {.lex_state = 628, .external_lex_state = 24},
  [4728] = {.lex_state = 192, .external_lex_state = 15},
  [4729] = {.lex_state = 628, .external_lex_state = 24},
  [4730] = {.lex_state = 192, .external_lex_state = 15},
  [4731] = {.lex_state = 628, .external_lex_state = 24},
  [4732] = {.lex_state = 192, .external_lex_state = 15},
  [4733] = {.lex_state = 628, .external_lex_state = 24},
  [4734] = {.lex_state = 190, .external_lex_state = 4},
  [4735] = {.lex_state = 268, .external_lex_state = 15},
  [4736] = {.lex_state = 628, .external_lex_state = 24},
  [4737] = {.lex_state = 190, .external_lex_state = 4},
  [4738] = {.lex_state = 268, .external_lex_state = 15},
  [4739] = {.lex_state = 634, .external_lex_state = 24},
  [4740] = {.lex_state = 628, .external_lex_state = 24},
  [4741] = {.lex_state = 194},
  [4742] = {.lex_state = 194, .external_lex_state = 19},
  [4743] = {.lex_state = 192, .external_lex_state = 2},
  [4744] = {.lex_state = 628, .external_lex_state = 24},
  [4745] = {.lex_state = 312},
  [4746] = {.lex_state = 312, .external_lex_state = 13},
  [4747] = {.lex_state = 628, .external_lex_state = 24},
  [4748] = {.lex_state = 209},
  [4749] = {.lex_state = 192, .external_lex_state = 2},
  [4750] = {.lex_state = 348, .external_lex_state = 22},
  [4751] = {.lex_state = 348, .external_lex_state = 22},
  [4752] = {.lex_state = 352, .external_lex_state = 22},
  [4753] = {.lex_state = 352, .external_lex_state = 22},
  [4754] = {.lex_state = 192, .external_lex_state = 2},
  [4755] = {.lex_state = 192, .external_lex_state = 2},
  [4756] = {.lex_state = 239},
  [4757] = {.lex_state = 192, .external_lex_state = 2},
  [4758] = {.lex_state = 358, .external_lex_state = 12},
  [4759] = {.lex_state = 298, .external_lex_state = 25},
  [4760] = {.lex_state = 509, .external_lex_state = 24},
  [4761] = {.lex_state = 628, .external_lex_state = 24},
  [4762] = {.lex_state = 634, .external_lex_state = 24},
  [4763] = {.lex_state = 634, .external_lex_state = 24},
  [4764] = {.lex_state = 509, .external_lex_state = 26},
  [4765] = {.lex_state = 628, .external_lex_state = 24},
  [4766] = {.lex_state = 628, .external_lex_state = 24},
  [4767] = {.lex_state = 628, .external_lex_state = 24},
  [4768] = {.lex_state = 128, .external_lex_state = 13},
  [4769] = {.lex_state = 128, .external_lex_state = 13},
  [4770] = {.lex_state = 249, .external_lex_state = 3},
  [4771] = {.lex_state = 249, .external_lex_state = 3},
  [4772] = {.lex_state = 128},
  [4773] = {.lex_state = 249, .external_lex_state = 3},
  [4774] = {.lex_state = 128},
  [4775] = {.lex_state = 128},
  [4776] = {.lex_state = 128},
  [4777] = {.lex_state = 128},
  [4778] = {.lex_state = 128},
  [4779] = {.lex_state = 628, .external_lex_state = 24},
  [4780] = {.lex_state = 128, .external_lex_state = 2},
  [4781] = {.lex_state = 634, .external_lex_state = 24},
  [4782] = {.lex_state = 628, .external_lex_state = 24},
  [4783] = {.lex_state = 628, .external_lex_state = 24},
  [4784] = {.lex_state = 628, .external_lex_state = 24},
  [4785] = {.lex_state = 237},
  [4786] = {.lex_state = 411, .external_lex_state = 2},
  [4787] = {.lex_state = 416, .external_lex_state = 11},
  [4788] = {.lex_state = 128},
  [4789] = {.lex_state = 628, .external_lex_state = 24},
  [4790] = {.lex_state = 192, .external_lex_state = 2},
  [4791] = {.lex_state = 192, .external_lex_state = 2},
  [4792] = {.lex_state = 192, .external_lex_state = 2},
  [4793] = {.lex_state = 192, .external_lex_state = 2},
  [4794] = {.lex_state = 192, .external_lex_state = 2},
  [4795] = {.lex_state = 192, .external_lex_state = 2},
  [4796] = {.lex_state = 192, .external_lex_state = 2},
  [4797] = {.lex_state = 192, .external_lex_state = 2},
  [4798] = {.lex_state = 192, .external_lex_state = 2},
  [4799] = {.lex_state = 192, .external_lex_state = 2},
  [4800] = {.lex_state = 421, .external_lex_state = 6},
  [4801] = {.lex_state = 465, .external_lex_state = 24},
  [4802] = {.lex_state = 192, .external_lex_state = 28},
  [4803] = {.lex_state = 192, .external_lex_state = 2},
  [4804] = {.lex_state = 634, .external_lex_state = 26},
  [4805] = {.lex_state = 634, .external_lex_state = 24},
  [4806] = {.lex_state = 509, .external_lex_state = 24},
  [4807] = {.lex_state = 509, .external_lex_state = 24},
  [4808] = {.lex_state = 192, .external_lex_state = 2},
  [4809] = {.lex_state = 509, .external_lex_state = 24},
  [4810] = {.lex_state = 192, .external_lex_state = 2},
  [4811] = {.lex_state = 509, .external_lex_state = 24},
  [4812] = {.lex_state = 528, .external_lex_state = 29},
  [4813] = {.lex_state = 509, .external_lex_state = 24},
  [4814] = {.lex_state = 634, .external_lex_state = 24},
  [4815] = {.lex_state = 509, .external_lex_state = 24},
  [4816] = {.lex_state = 509, .external_lex_state = 24},
  [4817] = {.lex_state = 509, .external_lex_state = 24},
  [4818] = {.lex_state = 509, .external_lex_state = 24},
  [4819] = {.lex_state = 509, .external_lex_state = 24},
  [4820] = {.lex_state = 561, .external_lex_state = 16},
  [4821] = {.lex_state = 509, .external_lex_state = 24},
  [4822] = {.lex_state = 509, .external_lex_state = 24},
  [4823] = {.lex_state = 509, .external_lex_state = 24},
  [4824] = {.lex_state = 509, .external_lex_state = 24},
  [4825] = {.lex_state = 342, .external_lex_state = 19},
  [4826] = {.lex_state = 528, .external_lex_state = 12},
  [4827] = {.lex_state = 342, .external_lex_state = 19},
  [4828] = {.lex_state = 342, .external_lex_state = 19},
  [4829] = {.lex_state = 509, .external_lex_state = 24},
  [4830] = {.lex_state = 509, .external_lex_state = 24},
  [4831] = {.lex_state = 509, .external_lex_state = 24},
  [4832] = {.lex_state = 637, .external_lex_state = 26},
  [4833] = {.lex_state = 156, .external_lex_state = 3},
  [4834] = {.lex_state = 156, .external_lex_state = 3},
  [4835] = {.lex_state = 512, .external_lex_state = 24},
  [4836] = {.lex_state = 192, .external_lex_state = 2},
  [4837] = {.lex_state = 192, .external_lex_state = 2},
  [4838] = {.lex_state = 239},
  [4839] = {.lex_state = 192, .external_lex_state = 2},
  [4840] = {.lex_state = 298, .external_lex_state = 25},
  [4841] = {.lex_state = 512, .external_lex_state = 24},
  [4842] = {.lex_state = 512, .external_lex_state = 24},
  [4843] = {.lex_state = 512, .external_lex_state = 24},
  [4844] = {.lex_state = 512, .external_lex_state = 26},
  [4845] = {.lex_state = 512, .external_lex_state = 24},
  [4846] = {.lex_state = 192, .external_lex_state = 2},
  [4847] = {.lex_state = 192, .external_lex_state = 2},
  [4848] = {.lex_state = 192, .external_lex_state = 2},
  [4849] = {.lex_state = 192, .external_lex_state = 2},
  [4850] = {.lex_state = 192, .external_lex_state = 2},
  [4851] = {.lex_state = 192, .external_lex_state = 2},
  [4852] = {.lex_state = 192, .external_lex_state = 2},
  [4853] = {.lex_state = 192, .external_lex_state = 2},
  [4854] = {.lex_state = 192, .external_lex_state = 2},
  [4855] = {.lex_state = 192, .external_lex_state = 2},
  [4856] = {.lex_state = 192, .external_lex_state = 28},
  [4857] = {.lex_state = 192, .external_lex_state = 2},
  [4858] = {.lex_state = 638, .external_lex_state = 26},
  [4859] = {.lex_state = 512, .external_lex_state = 24},
  [4860] = {.lex_state = 512, .external_lex_state = 24},
  [4861] = {.lex_state = 512, .external_lex_state = 24},
  [4862] = {.lex_state = 192, .external_lex_state = 2},
  [4863] = {.lex_state = 512, .external_lex_state = 24},
  [4864] = {.lex_state = 192, .external_lex_state = 2},
  [4865] = {.lex_state = 512, .external_lex_state = 24},
  [4866] = {.lex_state = 528, .external_lex_state = 29},
  [4867] = {.lex_state = 512, .external_lex_state = 24},
  [4868] = {.lex_state = 512, .external_lex_state = 24},
  [4869] = {.lex_state = 512, .external_lex_state = 24},
  [4870] = {.lex_state = 512, .external_lex_state = 24},
  [4871] = {.lex_state = 512, .external_lex_state = 24},
  [4872] = {.lex_state = 512, .external_lex_state = 24},
  [4873] = {.lex_state = 512, .external_lex_state = 24},
  [4874] = {.lex_state = 561, .external_lex_state = 16},
  [4875] = {.lex_state = 512, .external_lex_state = 24},
  [4876] = {.lex_state = 512, .external_lex_state = 24},
  [4877] = {.lex_state = 512, .external_lex_state = 24},
  [4878] = {.lex_state = 512, .external_lex_state = 24},
  [4879] = {.lex_state = 336, .external_lex_state = 19},
  [4880] = {.lex_state = 528, .external_lex_state = 12},
  [4881] = {.lex_state = 336, .external_lex_state = 19},
  [4882] = {.lex_state = 342, .external_lex_state = 19},
  [4883] = {.lex_state = 512, .external_lex_state = 24},
  [4884] = {.lex_state = 512, .external_lex_state = 24},
  [4885] = {.lex_state = 512, .external_lex_state = 24},
  [4886] = {.lex_state = 641, .external_lex_state = 26},
  [4887] = {.lex_state = 367, .external_lex_state = 3},
  [4888] = {.lex_state = 367, .external_lex_state = 3},
  [4889] = {.lex_state = 367, .external_lex_state = 3},
  [4890] = {.lex_state = 367, .external_lex_state = 3},
  [4891] = {.lex_state = 367, .external_lex_state = 3},
  [4892] = {.lex_state = 367, .external_lex_state = 3},
  [4893] = {.lex_state = 367, .external_lex_state = 3},
  [4894] = {.lex_state = 561, .external_lex_state = 16},
  [4895] = {.lex_state = 367, .external_lex_state = 3},
  [4896] = {.lex_state = 367, .external_lex_state = 3},
  [4897] = {.lex_state = 367, .external_lex_state = 3},
  [4898] = {.lex_state = 367, .external_lex_state = 3},
  [4899] = {.lex_state = 367, .external_lex_state = 3},
  [4900] = {.lex_state = 367, .external_lex_state = 3},
  [4901] = {.lex_state = 367, .external_lex_state = 3},
  [4902] = {.lex_state = 367, .external_lex_state = 14},
  [4903] = {.lex_state = 363, .external_lex_state = 3},
  [4904] = {.lex_state = 363, .external_lex_state = 3},
  [4905] = {.lex_state = 363, .external_lex_state = 3},
  [4906] = {.lex_state = 528, .external_lex_state = 12},
  [4907] = {.lex_state = 363, .external_lex_state = 3},
  [4908] = {.lex_state = 363, .external_lex_state = 3},
  [4909] = {.lex_state = 304, .external_lex_state = 24},
  [4910] = {.lex_state = 497, .external_lex_state = 24},
  [4911] = {.lex_state = 497, .external_lex_state = 24},
  [4912] = {.lex_state = 304, .external_lex_state = 24},
  [4913] = {.lex_state = 192, .external_lex_state = 2},
  [4914] = {.lex_state = 192, .external_lex_state = 2},
  [4915] = {.lex_state = 192, .external_lex_state = 2},
  [4916] = {.lex_state = 192, .external_lex_state = 2},
  [4917] = {.lex_state = 192, .external_lex_state = 2},
  [4918] = {.lex_state = 192, .external_lex_state = 2},
  [4919] = {.lex_state = 192, .external_lex_state = 2},
  [4920] = {.lex_state = 192, .external_lex_state = 2},
  [4921] = {.lex_state = 192, .external_lex_state = 2},
  [4922] = {.lex_state = 192, .external_lex_state = 2},
  [4923] = {.lex_state = 192, .external_lex_state = 28},
  [4924] = {.lex_state = 192, .external_lex_state = 2},
  [4925] = {.lex_state = 617, .external_lex_state = 26},
  [4926] = {.lex_state = 304, .external_lex_state = 24},
  [4927] = {.lex_state = 497, .external_lex_state = 24},
  [4928] = {.lex_state = 497, .external_lex_state = 24},
  [4929] = {.lex_state = 192, .external_lex_state = 2},
  [4930] = {.lex_state = 497, .external_lex_state = 24},
  [4931] = {.lex_state = 192, .external_lex_state = 2},
  [4932] = {.lex_state = 497, .external_lex_state = 24},
  [4933] = {.lex_state = 528, .external_lex_state = 29},
  [4934] = {.lex_state = 497, .external_lex_state = 24},
  [4935] = {.lex_state = 304, .external_lex_state = 24},
  [4936] = {.lex_state = 304, .external_lex_state = 24},
  [4937] = {.lex_state = 304, .external_lex_state = 24},
  [4938] = {.lex_state = 304, .external_lex_state = 24},
  [4939] = {.lex_state = 304, .external_lex_state = 24},
  [4940] = {.lex_state = 304, .external_lex_state = 24},
  [4941] = {.lex_state = 561, .external_lex_state = 16},
  [4942] = {.lex_state = 304, .external_lex_state = 24},
  [4943] = {.lex_state = 304, .external_lex_state = 24},
  [4944] = {.lex_state = 304, .external_lex_state = 24},
  [4945] = {.lex_state = 304, .external_lex_state = 24},
  [4946] = {.lex_state = 501, .external_lex_state = 24},
  [4947] = {.lex_state = 501, .external_lex_state = 24},
  [4948] = {.lex_state = 192, .external_lex_state = 2},
  [4949] = {.lex_state = 501, .external_lex_state = 24},
  [4950] = {.lex_state = 192, .external_lex_state = 2},
  [4951] = {.lex_state = 501, .external_lex_state = 24},
  [4952] = {.lex_state = 528, .external_lex_state = 29},
  [4953] = {.lex_state = 501, .external_lex_state = 24},
  [4954] = {.lex_state = 358, .external_lex_state = 12},
  [4955] = {.lex_state = 358, .external_lex_state = 29},
  [4956] = {.lex_state = 304, .external_lex_state = 19},
  [4957] = {.lex_state = 192, .external_lex_state = 2},
  [4958] = {.lex_state = 304, .external_lex_state = 24},
  [4959] = {.lex_state = 304, .external_lex_state = 24},
  [4960] = {.lex_state = 304, .external_lex_state = 24},
  [4961] = {.lex_state = 620, .external_lex_state = 26},
  [4962] = {.lex_state = 192, .external_lex_state = 2},
  [4963] = {.lex_state = 518, .external_lex_state = 10},
  [4964] = {.lex_state = 209},
  [4965] = {.lex_state = 518, .external_lex_state = 10},
  [4966] = {.lex_state = 301, .external_lex_state = 3},
  [4967] = {.lex_state = 423, .external_lex_state = 3},
  [4968] = {.lex_state = 301, .external_lex_state = 3},
  [4969] = {.lex_state = 194},
  [4970] = {.lex_state = 301, .external_lex_state = 3},
  [4971] = {.lex_state = 128},
  [4972] = {.lex_state = 128, .external_lex_state = 2},
  [4973] = {.lex_state = 128, .external_lex_state = 11},
  [4974] = {.lex_state = 301, .external_lex_state = 3},
  [4975] = {.lex_state = 423, .external_lex_state = 3},
  [4976] = {.lex_state = 301, .external_lex_state = 3},
  [4977] = {.lex_state = 177, .external_lex_state = 17},
  [4978] = {.lex_state = 423, .external_lex_state = 3},
  [4979] = {.lex_state = 301, .external_lex_state = 3},
  [4980] = {.lex_state = 528, .external_lex_state = 12},
  [4981] = {.lex_state = 423, .external_lex_state = 3},
  [4982] = {.lex_state = 423, .external_lex_state = 3},
  [4983] = {.lex_state = 156, .external_lex_state = 3},
  [4984] = {.lex_state = 683, .external_lex_state = 12},
  [4985] = {.lex_state = 177, .external_lex_state = 17},
  [4986] = {.lex_state = 156, .external_lex_state = 3},
  [4987] = {.lex_state = 192, .external_lex_state = 28},
  [4988] = {.lex_state = 363, .external_lex_state = 3},
  [4989] = {.lex_state = 363, .external_lex_state = 3},
  [4990] = {.lex_state = 363, .external_lex_state = 3},
  [4991] = {.lex_state = 363, .external_lex_state = 3},
  [4992] = {.lex_state = 363, .external_lex_state = 3},
  [4993] = {.lex_state = 192, .external_lex_state = 2},
  [4994] = {.lex_state = 192, .external_lex_state = 2},
  [4995] = {.lex_state = 192, .external_lex_state = 2},
  [4996] = {.lex_state = 192, .external_lex_state = 2},
  [4997] = {.lex_state = 192, .external_lex_state = 2},
  [4998] = {.lex_state = 192, .external_lex_state = 2},
  [4999] = {.lex_state = 192, .external_lex_state = 2},
  [5000] = {.lex_state = 192, .external_lex_state = 2},
  [5001] = {.lex_state = 192, .external_lex_state = 2},
  [5002] = {.lex_state = 192, .external_lex_state = 2},
  [5003] = {.lex_state = 192, .external_lex_state = 28},
  [5004] = {.lex_state = 192, .external_lex_state = 2},
  [5005] = {.lex_state = 367, .external_lex_state = 14},
  [5006] = {.lex_state = 363, .external_lex_state = 3},
  [5007] = {.lex_state = 363, .external_lex_state = 3},
  [5008] = {.lex_state = 363, .external_lex_state = 3},
  [5009] = {.lex_state = 192, .external_lex_state = 2},
  [5010] = {.lex_state = 363, .external_lex_state = 3},
  [5011] = {.lex_state = 192, .external_lex_state = 2},
  [5012] = {.lex_state = 363, .external_lex_state = 3},
  [5013] = {.lex_state = 528, .external_lex_state = 29},
  [5014] = {.lex_state = 363, .external_lex_state = 3},
  [5015] = {.lex_state = 363, .external_lex_state = 3},
  [5016] = {.lex_state = 363, .external_lex_state = 3},
  [5017] = {.lex_state = 363, .external_lex_state = 3},
  [5018] = {.lex_state = 363, .external_lex_state = 3},
  [5019] = {.lex_state = 363, .external_lex_state = 3},
  [5020] = {.lex_state = 363, .external_lex_state = 3},
  [5021] = {.lex_state = 561, .external_lex_state = 16},
  [5022] = {.lex_state = 363, .external_lex_state = 3},
  [5023] = {.lex_state = 363, .external_lex_state = 3},
  [5024] = {.lex_state = 363, .external_lex_state = 3},
  [5025] = {.lex_state = 363, .external_lex_state = 3},
  [5026] = {.lex_state = 423, .external_lex_state = 3},
  [5027] = {.lex_state = 423, .external_lex_state = 3},
  [5028] = {.lex_state = 192, .external_lex_state = 2},
  [5029] = {.lex_state = 423, .external_lex_state = 3},
  [5030] = {.lex_state = 192, .external_lex_state = 2},
  [5031] = {.lex_state = 423, .external_lex_state = 3},
  [5032] = {.lex_state = 528, .external_lex_state = 29},
  [5033] = {.lex_state = 423, .external_lex_state = 3},
  [5034] = {.lex_state = 264, .external_lex_state = 3},
  [5035] = {.lex_state = 528, .external_lex_state = 12},
  [5036] = {.lex_state = 264, .external_lex_state = 3},
  [5037] = {.lex_state = 363, .external_lex_state = 3},
  [5038] = {.lex_state = 363, .external_lex_state = 3},
  [5039] = {.lex_state = 363, .external_lex_state = 3},
  [5040] = {.lex_state = 363, .external_lex_state = 3},
  [5041] = {.lex_state = 363, .external_lex_state = 14},
  [5042] = {.lex_state = 256, .external_lex_state = 13},
  [5043] = {.lex_state = 249, .external_lex_state = 3},
  [5044] = {.lex_state = 192, .external_lex_state = 2},
  [5045] = {.lex_state = 192, .external_lex_state = 2},
  [5046] = {.lex_state = 192, .external_lex_state = 2},
  [5047] = {.lex_state = 239},
  [5048] = {.lex_state = 192, .external_lex_state = 2},
  [5049] = {.lex_state = 355, .external_lex_state = 10},
  [5050] = {.lex_state = 355, .external_lex_state = 10},
  [5051] = {.lex_state = 355, .external_lex_state = 10},
  [5052] = {.lex_state = 355, .external_lex_state = 10},
  [5053] = {.lex_state = 192, .external_lex_state = 2},
  [5054] = {.lex_state = 192, .external_lex_state = 2},
  [5055] = {.lex_state = 360, .external_lex_state = 10},
  [5056] = {.lex_state = 363, .external_lex_state = 3},
  [5057] = {.lex_state = 366, .external_lex_state = 10},
  [5058] = {.lex_state = 264, .external_lex_state = 3},
  [5059] = {.lex_state = 363, .external_lex_state = 3},
  [5060] = {.lex_state = 213},
  [5061] = {.lex_state = 370, .external_lex_state = 3},
  [5062] = {.lex_state = 373, .external_lex_state = 14},
  [5063] = {.lex_state = 249, .external_lex_state = 3},
  [5064] = {.lex_state = 256, .external_lex_state = 13},
  [5065] = {.lex_state = 192, .external_lex_state = 2},
  [5066] = {.lex_state = 192, .external_lex_state = 2},
  [5067] = {.lex_state = 192, .external_lex_state = 2},
  [5068] = {.lex_state = 192, .external_lex_state = 2},
  [5069] = {.lex_state = 192, .external_lex_state = 2},
  [5070] = {.lex_state = 192, .external_lex_state = 2},
  [5071] = {.lex_state = 192, .external_lex_state = 2},
  [5072] = {.lex_state = 192, .external_lex_state = 2},
  [5073] = {.lex_state = 192, .external_lex_state = 2},
  [5074] = {.lex_state = 192, .external_lex_state = 2},
  [5075] = {.lex_state = 192, .external_lex_state = 2},
  [5076] = {.lex_state = 192, .external_lex_state = 2},
  [5077] = {.lex_state = 192, .external_lex_state = 2},
  [5078] = {.lex_state = 192, .external_lex_state = 2},
  [5079] = {.lex_state = 192, .external_lex_state = 2},
  [5080] = {.lex_state = 192, .external_lex_state = 2},
  [5081] = {.lex_state = 192, .external_lex_state = 2},
  [5082] = {.lex_state = 192, .external_lex_state = 2},
  [5083] = {.lex_state = 239},
  [5084] = {.lex_state = 192, .external_lex_state = 2},
  [5085] = {.lex_state = 366, .external_lex_state = 10},
  [5086] = {.lex_state = 366, .external_lex_state = 10},
  [5087] = {.lex_state = 366, .external_lex_state = 10},
  [5088] = {.lex_state = 366, .external_lex_state = 10},
  [5089] = {.lex_state = 192, .external_lex_state = 2},
  [5090] = {.lex_state = 192, .external_lex_state = 2},
  [5091] = {.lex_state = 360, .external_lex_state = 10},
  [5092] = {.lex_state = 423, .external_lex_state = 3},
  [5093] = {.lex_state = 366, .external_lex_state = 10},
  [5094] = {.lex_state = 426, .external_lex_state = 3},
  [5095] = {.lex_state = 426, .external_lex_state = 3},
  [5096] = {.lex_state = 213},
  [5097] = {.lex_state = 423, .external_lex_state = 3},
  [5098] = {.lex_state = 429, .external_lex_state = 14},
  [5099] = {.lex_state = 192, .external_lex_state = 28},
  [5100] = {.lex_state = 192, .external_lex_state = 2},
  [5101] = {.lex_state = 264, .external_lex_state = 14},
  [5102] = {.lex_state = 128, .external_lex_state = 13},
  [5103] = {.lex_state = 128, .external_lex_state = 2},
  [5104] = {.lex_state = 128, .external_lex_state = 13},
  [5105] = {.lex_state = 156, .external_lex_state = 3},
  [5106] = {.lex_state = 128},
  [5107] = {.lex_state = 192, .external_lex_state = 2},
  [5108] = {.lex_state = 426, .external_lex_state = 3},
  [5109] = {.lex_state = 426, .external_lex_state = 3},
  [5110] = {.lex_state = 192, .external_lex_state = 2},
  [5111] = {.lex_state = 192, .external_lex_state = 2},
  [5112] = {.lex_state = 192, .external_lex_state = 2},
  [5113] = {.lex_state = 192, .external_lex_state = 2},
  [5114] = {.lex_state = 192, .external_lex_state = 2},
  [5115] = {.lex_state = 192, .external_lex_state = 2},
  [5116] = {.lex_state = 192, .external_lex_state = 2},
  [5117] = {.lex_state = 192, .external_lex_state = 2},
  [5118] = {.lex_state = 192, .external_lex_state = 2},
  [5119] = {.lex_state = 192, .external_lex_state = 2},
  [5120] = {.lex_state = 192, .external_lex_state = 28},
  [5121] = {.lex_state = 192, .external_lex_state = 2},
  [5122] = {.lex_state = 426, .external_lex_state = 14},
  [5123] = {.lex_state = 426, .external_lex_state = 3},
  [5124] = {.lex_state = 426, .external_lex_state = 3},
  [5125] = {.lex_state = 423, .external_lex_state = 3},
  [5126] = {.lex_state = 423, .external_lex_state = 3},
  [5127] = {.lex_state = 423, .external_lex_state = 3},
  [5128] = {.lex_state = 423, .external_lex_state = 3},
  [5129] = {.lex_state = 423, .external_lex_state = 3},
  [5130] = {.lex_state = 561, .external_lex_state = 16},
  [5131] = {.lex_state = 423, .external_lex_state = 3},
  [5132] = {.lex_state = 423, .external_lex_state = 3},
  [5133] = {.lex_state = 423, .external_lex_state = 3},
  [5134] = {.lex_state = 423, .external_lex_state = 3},
  [5135] = {.lex_state = 426, .external_lex_state = 3},
  [5136] = {.lex_state = 528, .external_lex_state = 12},
  [5137] = {.lex_state = 426, .external_lex_state = 3},
  [5138] = {.lex_state = 426, .external_lex_state = 3},
  [5139] = {.lex_state = 423, .external_lex_state = 3},
  [5140] = {.lex_state = 423, .external_lex_state = 3},
  [5141] = {.lex_state = 423, .external_lex_state = 3},
  [5142] = {.lex_state = 423, .external_lex_state = 14},
  [5143] = {.lex_state = 532, .external_lex_state = 3},
  [5144] = {.lex_state = 532, .external_lex_state = 3},
  [5145] = {.lex_state = 532, .external_lex_state = 3},
  [5146] = {.lex_state = 192, .external_lex_state = 2},
  [5147] = {.lex_state = 192, .external_lex_state = 2},
  [5148] = {.lex_state = 192, .external_lex_state = 2},
  [5149] = {.lex_state = 192, .external_lex_state = 2},
  [5150] = {.lex_state = 192, .external_lex_state = 2},
  [5151] = {.lex_state = 192, .external_lex_state = 2},
  [5152] = {.lex_state = 192, .external_lex_state = 2},
  [5153] = {.lex_state = 192, .external_lex_state = 2},
  [5154] = {.lex_state = 192, .external_lex_state = 2},
  [5155] = {.lex_state = 192, .external_lex_state = 2},
  [5156] = {.lex_state = 192, .external_lex_state = 28},
  [5157] = {.lex_state = 532, .external_lex_state = 3},
  [5158] = {.lex_state = 192, .external_lex_state = 28},
  [5159] = {.lex_state = 192, .external_lex_state = 2},
  [5160] = {.lex_state = 249, .external_lex_state = 3},
  [5161] = {.lex_state = 192, .external_lex_state = 2},
  [5162] = {.lex_state = 192, .external_lex_state = 2},
  [5163] = {.lex_state = 192, .external_lex_state = 2},
  [5164] = {.lex_state = 239},
  [5165] = {.lex_state = 192, .external_lex_state = 2},
  [5166] = {.lex_state = 355, .external_lex_state = 10},
  [5167] = {.lex_state = 355, .external_lex_state = 10},
  [5168] = {.lex_state = 355, .external_lex_state = 10},
  [5169] = {.lex_state = 355, .external_lex_state = 10},
  [5170] = {.lex_state = 192, .external_lex_state = 2},
  [5171] = {.lex_state = 192, .external_lex_state = 2},
  [5172] = {.lex_state = 360, .external_lex_state = 10},
  [5173] = {.lex_state = 363, .external_lex_state = 3},
  [5174] = {.lex_state = 366, .external_lex_state = 10},
  [5175] = {.lex_state = 264, .external_lex_state = 3},
  [5176] = {.lex_state = 363, .external_lex_state = 3},
  [5177] = {.lex_state = 213},
  [5178] = {.lex_state = 370, .external_lex_state = 3},
  [5179] = {.lex_state = 373, .external_lex_state = 14},
  [5180] = {.lex_state = 249, .external_lex_state = 3},
  [5181] = {.lex_state = 256, .external_lex_state = 13},
  [5182] = {.lex_state = 192, .external_lex_state = 2},
  [5183] = {.lex_state = 192, .external_lex_state = 2},
  [5184] = {.lex_state = 192, .external_lex_state = 2},
  [5185] = {.lex_state = 192, .external_lex_state = 2},
  [5186] = {.lex_state = 192, .external_lex_state = 2},
  [5187] = {.lex_state = 192, .external_lex_state = 2},
  [5188] = {.lex_state = 192, .external_lex_state = 2},
  [5189] = {.lex_state = 192, .external_lex_state = 2},
  [5190] = {.lex_state = 192, .external_lex_state = 2},
  [5191] = {.lex_state = 192, .external_lex_state = 2},
  [5192] = {.lex_state = 192, .external_lex_state = 2},
  [5193] = {.lex_state = 192, .external_lex_state = 2},
  [5194] = {.lex_state = 192, .external_lex_state = 2},
  [5195] = {.lex_state = 192, .external_lex_state = 2},
  [5196] = {.lex_state = 192, .external_lex_state = 2},
  [5197] = {.lex_state = 192, .external_lex_state = 2},
  [5198] = {.lex_state = 192, .external_lex_state = 2},
  [5199] = {.lex_state = 192, .external_lex_state = 2},
  [5200] = {.lex_state = 239},
  [5201] = {.lex_state = 192, .external_lex_state = 2},
  [5202] = {.lex_state = 366, .external_lex_state = 10},
  [5203] = {.lex_state = 366, .external_lex_state = 10},
  [5204] = {.lex_state = 366, .external_lex_state = 10},
  [5205] = {.lex_state = 366, .external_lex_state = 10},
  [5206] = {.lex_state = 192, .external_lex_state = 2},
  [5207] = {.lex_state = 192, .external_lex_state = 2},
  [5208] = {.lex_state = 360, .external_lex_state = 10},
  [5209] = {.lex_state = 423, .external_lex_state = 3},
  [5210] = {.lex_state = 366, .external_lex_state = 10},
  [5211] = {.lex_state = 426, .external_lex_state = 3},
  [5212] = {.lex_state = 426, .external_lex_state = 3},
  [5213] = {.lex_state = 213},
  [5214] = {.lex_state = 423, .external_lex_state = 3},
  [5215] = {.lex_state = 429, .external_lex_state = 14},
  [5216] = {.lex_state = 192, .external_lex_state = 28},
  [5217] = {.lex_state = 192, .external_lex_state = 2},
  [5218] = {.lex_state = 264, .external_lex_state = 14},
  [5219] = {.lex_state = 128, .external_lex_state = 13},
  [5220] = {.lex_state = 128, .external_lex_state = 2},
  [5221] = {.lex_state = 156, .external_lex_state = 3},
  [5222] = {.lex_state = 363, .external_lex_state = 3},
  [5223] = {.lex_state = 363, .external_lex_state = 3},
  [5224] = {.lex_state = 363, .external_lex_state = 3},
  [5225] = {.lex_state = 363, .external_lex_state = 3},
  [5226] = {.lex_state = 192, .external_lex_state = 2},
  [5227] = {.lex_state = 192, .external_lex_state = 2},
  [5228] = {.lex_state = 192, .external_lex_state = 2},
  [5229] = {.lex_state = 192, .external_lex_state = 2},
  [5230] = {.lex_state = 192, .external_lex_state = 2},
  [5231] = {.lex_state = 192, .external_lex_state = 2},
  [5232] = {.lex_state = 192, .external_lex_state = 2},
  [5233] = {.lex_state = 192, .external_lex_state = 2},
  [5234] = {.lex_state = 192, .external_lex_state = 2},
  [5235] = {.lex_state = 192, .external_lex_state = 2},
  [5236] = {.lex_state = 192, .external_lex_state = 28},
  [5237] = {.lex_state = 192, .external_lex_state = 2},
  [5238] = {.lex_state = 367, .external_lex_state = 14},
  [5239] = {.lex_state = 363, .external_lex_state = 3},
  [5240] = {.lex_state = 363, .external_lex_state = 3},
  [5241] = {.lex_state = 363, .external_lex_state = 3},
  [5242] = {.lex_state = 192, .external_lex_state = 2},
  [5243] = {.lex_state = 363, .external_lex_state = 3},
  [5244] = {.lex_state = 192, .external_lex_state = 2},
  [5245] = {.lex_state = 363, .external_lex_state = 3},
  [5246] = {.lex_state = 528, .external_lex_state = 29},
  [5247] = {.lex_state = 363, .external_lex_state = 3},
  [5248] = {.lex_state = 363, .external_lex_state = 3},
  [5249] = {.lex_state = 363, .external_lex_state = 3},
  [5250] = {.lex_state = 363, .external_lex_state = 3},
  [5251] = {.lex_state = 363, .external_lex_state = 3},
  [5252] = {.lex_state = 363, .external_lex_state = 3},
  [5253] = {.lex_state = 363, .external_lex_state = 3},
  [5254] = {.lex_state = 561, .external_lex_state = 16},
  [5255] = {.lex_state = 363, .external_lex_state = 3},
  [5256] = {.lex_state = 363, .external_lex_state = 3},
  [5257] = {.lex_state = 363, .external_lex_state = 3},
  [5258] = {.lex_state = 363, .external_lex_state = 3},
  [5259] = {.lex_state = 423, .external_lex_state = 3},
  [5260] = {.lex_state = 423, .external_lex_state = 3},
  [5261] = {.lex_state = 192, .external_lex_state = 2},
  [5262] = {.lex_state = 423, .external_lex_state = 3},
  [5263] = {.lex_state = 423, .external_lex_state = 3},
  [5264] = {.lex_state = 192, .external_lex_state = 2},
  [5265] = {.lex_state = 423, .external_lex_state = 3},
  [5266] = {.lex_state = 528, .external_lex_state = 29},
  [5267] = {.lex_state = 423, .external_lex_state = 3},
  [5268] = {.lex_state = 264, .external_lex_state = 3},
  [5269] = {.lex_state = 528, .external_lex_state = 12},
  [5270] = {.lex_state = 264, .external_lex_state = 3},
  [5271] = {.lex_state = 363, .external_lex_state = 3},
  [5272] = {.lex_state = 363, .external_lex_state = 3},
  [5273] = {.lex_state = 363, .external_lex_state = 3},
  [5274] = {.lex_state = 363, .external_lex_state = 3},
  [5275] = {.lex_state = 363, .external_lex_state = 14},
  [5276] = {.lex_state = 192, .external_lex_state = 2},
  [5277] = {.lex_state = 156, .external_lex_state = 3},
  [5278] = {.lex_state = 426, .external_lex_state = 3},
  [5279] = {.lex_state = 426, .external_lex_state = 3},
  [5280] = {.lex_state = 192, .external_lex_state = 2},
  [5281] = {.lex_state = 192, .external_lex_state = 2},
  [5282] = {.lex_state = 192, .external_lex_state = 2},
  [5283] = {.lex_state = 192, .external_lex_state = 2},
  [5284] = {.lex_state = 192, .external_lex_state = 2},
  [5285] = {.lex_state = 192, .external_lex_state = 2},
  [5286] = {.lex_state = 192, .external_lex_state = 2},
  [5287] = {.lex_state = 192, .external_lex_state = 2},
  [5288] = {.lex_state = 192, .external_lex_state = 2},
  [5289] = {.lex_state = 192, .external_lex_state = 2},
  [5290] = {.lex_state = 192, .external_lex_state = 28},
  [5291] = {.lex_state = 192, .external_lex_state = 2},
  [5292] = {.lex_state = 426, .external_lex_state = 14},
  [5293] = {.lex_state = 426, .external_lex_state = 3},
  [5294] = {.lex_state = 426, .external_lex_state = 3},
  [5295] = {.lex_state = 423, .external_lex_state = 3},
  [5296] = {.lex_state = 423, .external_lex_state = 3},
  [5297] = {.lex_state = 423, .external_lex_state = 3},
  [5298] = {.lex_state = 423, .external_lex_state = 3},
  [5299] = {.lex_state = 423, .external_lex_state = 3},
  [5300] = {.lex_state = 561, .external_lex_state = 16},
  [5301] = {.lex_state = 423, .external_lex_state = 3},
  [5302] = {.lex_state = 423, .external_lex_state = 3},
  [5303] = {.lex_state = 423, .external_lex_state = 3},
  [5304] = {.lex_state = 423, .external_lex_state = 3},
  [5305] = {.lex_state = 426, .external_lex_state = 3},
  [5306] = {.lex_state = 528, .external_lex_state = 12},
  [5307] = {.lex_state = 426, .external_lex_state = 3},
  [5308] = {.lex_state = 426, .external_lex_state = 3},
  [5309] = {.lex_state = 423, .external_lex_state = 3},
  [5310] = {.lex_state = 423, .external_lex_state = 3},
  [5311] = {.lex_state = 423, .external_lex_state = 3},
  [5312] = {.lex_state = 423, .external_lex_state = 14},
  [5313] = {.lex_state = 532, .external_lex_state = 3},
  [5314] = {.lex_state = 532, .external_lex_state = 3},
  [5315] = {.lex_state = 532, .external_lex_state = 3},
  [5316] = {.lex_state = 192, .external_lex_state = 2},
  [5317] = {.lex_state = 192, .external_lex_state = 2},
  [5318] = {.lex_state = 192, .external_lex_state = 2},
  [5319] = {.lex_state = 192, .external_lex_state = 2},
  [5320] = {.lex_state = 192, .external_lex_state = 2},
  [5321] = {.lex_state = 192, .external_lex_state = 2},
  [5322] = {.lex_state = 192, .external_lex_state = 2},
  [5323] = {.lex_state = 192, .external_lex_state = 2},
  [5324] = {.lex_state = 192, .external_lex_state = 2},
  [5325] = {.lex_state = 192, .external_lex_state = 2},
  [5326] = {.lex_state = 192, .external_lex_state = 28},
  [5327] = {.lex_state = 532, .external_lex_state = 3},
  [5328] = {.lex_state = 192, .external_lex_state = 28},
  [5329] = {.lex_state = 192, .external_lex_state = 2},
  [5330] = {.lex_state = 156, .external_lex_state = 3},
  [5331] = {.lex_state = 512, .external_lex_state = 24},
  [5332] = {.lex_state = 192, .external_lex_state = 2},
  [5333] = {.lex_state = 192, .external_lex_state = 2},
  [5334] = {.lex_state = 239},
  [5335] = {.lex_state = 192, .external_lex_state = 2},
  [5336] = {.lex_state = 298, .external_lex_state = 25},
  [5337] = {.lex_state = 512, .external_lex_state = 24},
  [5338] = {.lex_state = 512, .external_lex_state = 24},
  [5339] = {.lex_state = 512, .external_lex_state = 24},
  [5340] = {.lex_state = 512, .external_lex_state = 26},
  [5341] = {.lex_state = 512, .external_lex_state = 24},
  [5342] = {.lex_state = 192, .external_lex_state = 2},
  [5343] = {.lex_state = 192, .external_lex_state = 2},
  [5344] = {.lex_state = 192, .external_lex_state = 2},
  [5345] = {.lex_state = 192, .external_lex_state = 2},
  [5346] = {.lex_state = 192, .external_lex_state = 2},
  [5347] = {.lex_state = 192, .external_lex_state = 2},
  [5348] = {.lex_state = 192, .external_lex_state = 2},
  [5349] = {.lex_state = 192, .external_lex_state = 2},
  [5350] = {.lex_state = 192, .external_lex_state = 2},
  [5351] = {.lex_state = 192, .external_lex_state = 2},
  [5352] = {.lex_state = 192, .external_lex_state = 2},
  [5353] = {.lex_state = 192, .external_lex_state = 2},
  [5354] = {.lex_state = 239},
  [5355] = {.lex_state = 192, .external_lex_state = 2},
  [5356] = {.lex_state = 298, .external_lex_state = 25},
  [5357] = {.lex_state = 423, .external_lex_state = 24},
  [5358] = {.lex_state = 426, .external_lex_state = 24},
  [5359] = {.lex_state = 426, .external_lex_state = 24},
  [5360] = {.lex_state = 429, .external_lex_state = 26},
  [5361] = {.lex_state = 192, .external_lex_state = 28},
  [5362] = {.lex_state = 192, .external_lex_state = 2},
  [5363] = {.lex_state = 638, .external_lex_state = 26},
  [5364] = {.lex_state = 512, .external_lex_state = 24},
  [5365] = {.lex_state = 512, .external_lex_state = 24},
  [5366] = {.lex_state = 512, .external_lex_state = 24},
  [5367] = {.lex_state = 192, .external_lex_state = 2},
  [5368] = {.lex_state = 512, .external_lex_state = 24},
  [5369] = {.lex_state = 192, .external_lex_state = 2},
  [5370] = {.lex_state = 512, .external_lex_state = 24},
  [5371] = {.lex_state = 528, .external_lex_state = 29},
  [5372] = {.lex_state = 512, .external_lex_state = 24},
  [5373] = {.lex_state = 512, .external_lex_state = 24},
  [5374] = {.lex_state = 512, .external_lex_state = 24},
  [5375] = {.lex_state = 512, .external_lex_state = 24},
  [5376] = {.lex_state = 512, .external_lex_state = 24},
  [5377] = {.lex_state = 512, .external_lex_state = 24},
  [5378] = {.lex_state = 512, .external_lex_state = 24},
  [5379] = {.lex_state = 561, .external_lex_state = 16},
  [5380] = {.lex_state = 512, .external_lex_state = 24},
  [5381] = {.lex_state = 512, .external_lex_state = 24},
  [5382] = {.lex_state = 512, .external_lex_state = 24},
  [5383] = {.lex_state = 512, .external_lex_state = 24},
  [5384] = {.lex_state = 423, .external_lex_state = 24},
  [5385] = {.lex_state = 423, .external_lex_state = 26},
  [5386] = {.lex_state = 423, .external_lex_state = 24},
  [5387] = {.lex_state = 423, .external_lex_state = 24},
  [5388] = {.lex_state = 192, .external_lex_state = 2},
  [5389] = {.lex_state = 423, .external_lex_state = 24},
  [5390] = {.lex_state = 423, .external_lex_state = 24},
  [5391] = {.lex_state = 192, .external_lex_state = 2},
  [5392] = {.lex_state = 192, .external_lex_state = 2},
  [5393] = {.lex_state = 192, .external_lex_state = 2},
  [5394] = {.lex_state = 192, .external_lex_state = 2},
  [5395] = {.lex_state = 192, .external_lex_state = 2},
  [5396] = {.lex_state = 192, .external_lex_state = 2},
  [5397] = {.lex_state = 192, .external_lex_state = 2},
  [5398] = {.lex_state = 192, .external_lex_state = 2},
  [5399] = {.lex_state = 192, .external_lex_state = 2},
  [5400] = {.lex_state = 192, .external_lex_state = 2},
  [5401] = {.lex_state = 192, .external_lex_state = 2},
  [5402] = {.lex_state = 423, .external_lex_state = 24},
  [5403] = {.lex_state = 528, .external_lex_state = 29},
  [5404] = {.lex_state = 423, .external_lex_state = 24},
  [5405] = {.lex_state = 192, .external_lex_state = 28},
  [5406] = {.lex_state = 192, .external_lex_state = 2},
  [5407] = {.lex_state = 423, .external_lex_state = 26},
  [5408] = {.lex_state = 342, .external_lex_state = 19},
  [5409] = {.lex_state = 528, .external_lex_state = 12},
  [5410] = {.lex_state = 342, .external_lex_state = 19},
  [5411] = {.lex_state = 342, .external_lex_state = 19},
  [5412] = {.lex_state = 512, .external_lex_state = 24},
  [5413] = {.lex_state = 512, .external_lex_state = 24},
  [5414] = {.lex_state = 512, .external_lex_state = 24},
  [5415] = {.lex_state = 641, .external_lex_state = 26},
  [5416] = {.lex_state = 156, .external_lex_state = 3},
  [5417] = {.lex_state = 128},
  [5418] = {.lex_state = 223, .external_lex_state = 8},
  [5419] = {.lex_state = 363, .external_lex_state = 3},
  [5420] = {.lex_state = 363, .external_lex_state = 3},
  [5421] = {.lex_state = 363, .external_lex_state = 3},
  [5422] = {.lex_state = 363, .external_lex_state = 3},
  [5423] = {.lex_state = 192, .external_lex_state = 2},
  [5424] = {.lex_state = 192, .external_lex_state = 2},
  [5425] = {.lex_state = 192, .external_lex_state = 2},
  [5426] = {.lex_state = 192, .external_lex_state = 2},
  [5427] = {.lex_state = 192, .external_lex_state = 2},
  [5428] = {.lex_state = 192, .external_lex_state = 2},
  [5429] = {.lex_state = 192, .external_lex_state = 2},
  [5430] = {.lex_state = 192, .external_lex_state = 2},
  [5431] = {.lex_state = 192, .external_lex_state = 2},
  [5432] = {.lex_state = 192, .external_lex_state = 2},
  [5433] = {.lex_state = 192, .external_lex_state = 28},
  [5434] = {.lex_state = 192, .external_lex_state = 2},
  [5435] = {.lex_state = 367, .external_lex_state = 14},
  [5436] = {.lex_state = 363, .external_lex_state = 3},
  [5437] = {.lex_state = 363, .external_lex_state = 3},
  [5438] = {.lex_state = 363, .external_lex_state = 3},
  [5439] = {.lex_state = 192, .external_lex_state = 2},
  [5440] = {.lex_state = 363, .external_lex_state = 3},
  [5441] = {.lex_state = 192, .external_lex_state = 2},
  [5442] = {.lex_state = 363, .external_lex_state = 3},
  [5443] = {.lex_state = 528, .external_lex_state = 29},
  [5444] = {.lex_state = 363, .external_lex_state = 3},
  [5445] = {.lex_state = 363, .external_lex_state = 3},
  [5446] = {.lex_state = 363, .external_lex_state = 3},
  [5447] = {.lex_state = 363, .external_lex_state = 3},
  [5448] = {.lex_state = 363, .external_lex_state = 3},
  [5449] = {.lex_state = 363, .external_lex_state = 3},
  [5450] = {.lex_state = 363, .external_lex_state = 3},
  [5451] = {.lex_state = 561, .external_lex_state = 16},
  [5452] = {.lex_state = 363, .external_lex_state = 3},
  [5453] = {.lex_state = 363, .external_lex_state = 3},
  [5454] = {.lex_state = 363, .external_lex_state = 3},
  [5455] = {.lex_state = 363, .external_lex_state = 3},
  [5456] = {.lex_state = 264, .external_lex_state = 3},
  [5457] = {.lex_state = 528, .external_lex_state = 12},
  [5458] = {.lex_state = 264, .external_lex_state = 3},
  [5459] = {.lex_state = 363, .external_lex_state = 3},
  [5460] = {.lex_state = 363, .external_lex_state = 3},
  [5461] = {.lex_state = 363, .external_lex_state = 3},
  [5462] = {.lex_state = 363, .external_lex_state = 3},
  [5463] = {.lex_state = 363, .external_lex_state = 14},
  [5464] = {.lex_state = 192, .external_lex_state = 2},
  [5465] = {.lex_state = 156, .external_lex_state = 3},
  [5466] = {.lex_state = 128},
  [5467] = {.lex_state = 128},
  [5468] = {.lex_state = 532, .external_lex_state = 3},
  [5469] = {.lex_state = 532, .external_lex_state = 3},
  [5470] = {.lex_state = 532, .external_lex_state = 3},
  [5471] = {.lex_state = 192, .external_lex_state = 2},
  [5472] = {.lex_state = 192, .external_lex_state = 2},
  [5473] = {.lex_state = 192, .external_lex_state = 2},
  [5474] = {.lex_state = 192, .external_lex_state = 2},
  [5475] = {.lex_state = 192, .external_lex_state = 2},
  [5476] = {.lex_state = 192, .external_lex_state = 2},
  [5477] = {.lex_state = 192, .external_lex_state = 2},
  [5478] = {.lex_state = 192, .external_lex_state = 2},
  [5479] = {.lex_state = 192, .external_lex_state = 2},
  [5480] = {.lex_state = 192, .external_lex_state = 2},
  [5481] = {.lex_state = 192, .external_lex_state = 28},
  [5482] = {.lex_state = 532, .external_lex_state = 3},
  [5483] = {.lex_state = 192, .external_lex_state = 28},
  [5484] = {.lex_state = 192, .external_lex_state = 2},
  [5485] = {.lex_state = 532, .external_lex_state = 3},
  [5486] = {.lex_state = 532, .external_lex_state = 3},
  [5487] = {.lex_state = 192, .external_lex_state = 2},
  [5488] = {.lex_state = 192, .external_lex_state = 2},
  [5489] = {.lex_state = 239},
  [5490] = {.lex_state = 192, .external_lex_state = 2},
  [5491] = {.lex_state = 360, .external_lex_state = 10},
  [5492] = {.lex_state = 363, .external_lex_state = 3},
  [5493] = {.lex_state = 363, .external_lex_state = 3},
  [5494] = {.lex_state = 363, .external_lex_state = 3},
  [5495] = {.lex_state = 373, .external_lex_state = 14},
  [5496] = {.lex_state = 532, .external_lex_state = 3},
  [5497] = {.lex_state = 192, .external_lex_state = 28},
  [5498] = {.lex_state = 128, .external_lex_state = 2},
  [5499] = {.lex_state = 128},
  [5500] = {.lex_state = 128, .external_lex_state = 2},
  [5501] = {.lex_state = 256, .external_lex_state = 13},
  [5502] = {.lex_state = 192, .external_lex_state = 2},
  [5503] = {.lex_state = 192, .external_lex_state = 2},
  [5504] = {.lex_state = 192, .external_lex_state = 2},
  [5505] = {.lex_state = 192, .external_lex_state = 2},
  [5506] = {.lex_state = 192, .external_lex_state = 2},
  [5507] = {.lex_state = 192, .external_lex_state = 2},
  [5508] = {.lex_state = 192, .external_lex_state = 2},
  [5509] = {.lex_state = 192, .external_lex_state = 2},
  [5510] = {.lex_state = 192, .external_lex_state = 2},
  [5511] = {.lex_state = 192, .external_lex_state = 2},
  [5512] = {.lex_state = 192, .external_lex_state = 2},
  [5513] = {.lex_state = 192, .external_lex_state = 2},
  [5514] = {.lex_state = 239},
  [5515] = {.lex_state = 192, .external_lex_state = 2},
  [5516] = {.lex_state = 360, .external_lex_state = 10},
  [5517] = {.lex_state = 423, .external_lex_state = 3},
  [5518] = {.lex_state = 426, .external_lex_state = 3},
  [5519] = {.lex_state = 426, .external_lex_state = 3},
  [5520] = {.lex_state = 429, .external_lex_state = 14},
  [5521] = {.lex_state = 192, .external_lex_state = 28},
  [5522] = {.lex_state = 192, .external_lex_state = 2},
  [5523] = {.lex_state = 367, .external_lex_state = 14},
  [5524] = {.lex_state = 363, .external_lex_state = 3},
  [5525] = {.lex_state = 363, .external_lex_state = 3},
  [5526] = {.lex_state = 363, .external_lex_state = 3},
  [5527] = {.lex_state = 363, .external_lex_state = 3},
  [5528] = {.lex_state = 192, .external_lex_state = 2},
  [5529] = {.lex_state = 192, .external_lex_state = 2},
  [5530] = {.lex_state = 192, .external_lex_state = 2},
  [5531] = {.lex_state = 192, .external_lex_state = 2},
  [5532] = {.lex_state = 192, .external_lex_state = 2},
  [5533] = {.lex_state = 192, .external_lex_state = 2},
  [5534] = {.lex_state = 192, .external_lex_state = 2},
  [5535] = {.lex_state = 192, .external_lex_state = 2},
  [5536] = {.lex_state = 192, .external_lex_state = 2},
  [5537] = {.lex_state = 192, .external_lex_state = 2},
  [5538] = {.lex_state = 192, .external_lex_state = 28},
  [5539] = {.lex_state = 192, .external_lex_state = 2},
  [5540] = {.lex_state = 367, .external_lex_state = 14},
  [5541] = {.lex_state = 363, .external_lex_state = 3},
  [5542] = {.lex_state = 363, .external_lex_state = 3},
  [5543] = {.lex_state = 363, .external_lex_state = 3},
  [5544] = {.lex_state = 192, .external_lex_state = 2},
  [5545] = {.lex_state = 363, .external_lex_state = 3},
  [5546] = {.lex_state = 192, .external_lex_state = 2},
  [5547] = {.lex_state = 363, .external_lex_state = 3},
  [5548] = {.lex_state = 528, .external_lex_state = 29},
  [5549] = {.lex_state = 363, .external_lex_state = 3},
  [5550] = {.lex_state = 363, .external_lex_state = 3},
  [5551] = {.lex_state = 363, .external_lex_state = 3},
  [5552] = {.lex_state = 363, .external_lex_state = 3},
  [5553] = {.lex_state = 363, .external_lex_state = 3},
  [5554] = {.lex_state = 363, .external_lex_state = 3},
  [5555] = {.lex_state = 363, .external_lex_state = 3},
  [5556] = {.lex_state = 561, .external_lex_state = 16},
  [5557] = {.lex_state = 363, .external_lex_state = 3},
  [5558] = {.lex_state = 363, .external_lex_state = 3},
  [5559] = {.lex_state = 363, .external_lex_state = 3},
  [5560] = {.lex_state = 363, .external_lex_state = 3},
  [5561] = {.lex_state = 423, .external_lex_state = 3},
  [5562] = {.lex_state = 423, .external_lex_state = 3},
  [5563] = {.lex_state = 192, .external_lex_state = 2},
  [5564] = {.lex_state = 423, .external_lex_state = 3},
  [5565] = {.lex_state = 192, .external_lex_state = 2},
  [5566] = {.lex_state = 423, .external_lex_state = 3},
  [5567] = {.lex_state = 528, .external_lex_state = 29},
  [5568] = {.lex_state = 423, .external_lex_state = 3},
  [5569] = {.lex_state = 264, .external_lex_state = 3},
  [5570] = {.lex_state = 528, .external_lex_state = 12},
  [5571] = {.lex_state = 264, .external_lex_state = 3},
  [5572] = {.lex_state = 363, .external_lex_state = 3},
  [5573] = {.lex_state = 363, .external_lex_state = 3},
  [5574] = {.lex_state = 363, .external_lex_state = 3},
  [5575] = {.lex_state = 363, .external_lex_state = 3},
  [5576] = {.lex_state = 363, .external_lex_state = 14},
  [5577] = {.lex_state = 363, .external_lex_state = 3},
  [5578] = {.lex_state = 363, .external_lex_state = 3},
  [5579] = {.lex_state = 363, .external_lex_state = 3},
  [5580] = {.lex_state = 192, .external_lex_state = 2},
  [5581] = {.lex_state = 363, .external_lex_state = 3},
  [5582] = {.lex_state = 363, .external_lex_state = 3},
  [5583] = {.lex_state = 192, .external_lex_state = 2},
  [5584] = {.lex_state = 192, .external_lex_state = 2},
  [5585] = {.lex_state = 192, .external_lex_state = 2},
  [5586] = {.lex_state = 192, .external_lex_state = 2},
  [5587] = {.lex_state = 192, .external_lex_state = 2},
  [5588] = {.lex_state = 192, .external_lex_state = 2},
  [5589] = {.lex_state = 192, .external_lex_state = 2},
  [5590] = {.lex_state = 192, .external_lex_state = 2},
  [5591] = {.lex_state = 192, .external_lex_state = 2},
  [5592] = {.lex_state = 192, .external_lex_state = 2},
  [5593] = {.lex_state = 192, .external_lex_state = 2},
  [5594] = {.lex_state = 363, .external_lex_state = 3},
  [5595] = {.lex_state = 528, .external_lex_state = 29},
  [5596] = {.lex_state = 363, .external_lex_state = 3},
  [5597] = {.lex_state = 192, .external_lex_state = 28},
  [5598] = {.lex_state = 192, .external_lex_state = 2},
  [5599] = {.lex_state = 418, .external_lex_state = 27},
  [5600] = {.lex_state = 237, .external_lex_state = 12},
  [5601] = {.lex_state = 192, .external_lex_state = 2},
  [5602] = {.lex_state = 192, .external_lex_state = 2},
  [5603] = {.lex_state = 192, .external_lex_state = 2},
  [5604] = {.lex_state = 239},
  [5605] = {.lex_state = 421, .external_lex_state = 6},
  [5606] = {.lex_state = 192, .external_lex_state = 2},
  [5607] = {.lex_state = 355, .external_lex_state = 10},
  [5608] = {.lex_state = 355, .external_lex_state = 10},
  [5609] = {.lex_state = 355, .external_lex_state = 10},
  [5610] = {.lex_state = 355, .external_lex_state = 10},
  [5611] = {.lex_state = 358, .external_lex_state = 12},
  [5612] = {.lex_state = 192, .external_lex_state = 2},
  [5613] = {.lex_state = 192, .external_lex_state = 2},
  [5614] = {.lex_state = 360, .external_lex_state = 10},
  [5615] = {.lex_state = 512, .external_lex_state = 3},
  [5616] = {.lex_state = 345, .external_lex_state = 13},
  [5617] = {.lex_state = 345, .external_lex_state = 13},
  [5618] = {.lex_state = 685, .external_lex_state = 13},
  [5619] = {.lex_state = 345, .external_lex_state = 13},
  [5620] = {.lex_state = 213},
  [5621] = {.lex_state = 423, .external_lex_state = 3},
  [5622] = {.lex_state = 512, .external_lex_state = 14},
  [5623] = {.lex_state = 128},
  [5624] = {.lex_state = 128},
  [5625] = {.lex_state = 128, .external_lex_state = 2},
  [5626] = {.lex_state = 532, .external_lex_state = 3},
  [5627] = {.lex_state = 532, .external_lex_state = 3},
  [5628] = {.lex_state = 532, .external_lex_state = 3},
  [5629] = {.lex_state = 532, .external_lex_state = 3},
  [5630] = {.lex_state = 532, .external_lex_state = 3},
  [5631] = {.lex_state = 561, .external_lex_state = 16},
  [5632] = {.lex_state = 532, .external_lex_state = 3},
  [5633] = {.lex_state = 532, .external_lex_state = 3},
  [5634] = {.lex_state = 532, .external_lex_state = 3},
  [5635] = {.lex_state = 532, .external_lex_state = 3},
  [5636] = {.lex_state = 423, .external_lex_state = 3},
  [5637] = {.lex_state = 423, .external_lex_state = 14},
  [5638] = {.lex_state = 423, .external_lex_state = 3},
  [5639] = {.lex_state = 423, .external_lex_state = 3},
  [5640] = {.lex_state = 192, .external_lex_state = 2},
  [5641] = {.lex_state = 423, .external_lex_state = 3},
  [5642] = {.lex_state = 423, .external_lex_state = 3},
  [5643] = {.lex_state = 192, .external_lex_state = 2},
  [5644] = {.lex_state = 192, .external_lex_state = 2},
  [5645] = {.lex_state = 192, .external_lex_state = 2},
  [5646] = {.lex_state = 192, .external_lex_state = 2},
  [5647] = {.lex_state = 192, .external_lex_state = 2},
  [5648] = {.lex_state = 192, .external_lex_state = 2},
  [5649] = {.lex_state = 192, .external_lex_state = 2},
  [5650] = {.lex_state = 192, .external_lex_state = 2},
  [5651] = {.lex_state = 192, .external_lex_state = 2},
  [5652] = {.lex_state = 192, .external_lex_state = 2},
  [5653] = {.lex_state = 192, .external_lex_state = 2},
  [5654] = {.lex_state = 423, .external_lex_state = 3},
  [5655] = {.lex_state = 528, .external_lex_state = 29},
  [5656] = {.lex_state = 423, .external_lex_state = 3},
  [5657] = {.lex_state = 192, .external_lex_state = 28},
  [5658] = {.lex_state = 192, .external_lex_state = 2},
  [5659] = {.lex_state = 423, .external_lex_state = 14},
  [5660] = {.lex_state = 355, .external_lex_state = 13},
  [5661] = {.lex_state = 355, .external_lex_state = 13},
  [5662] = {.lex_state = 192, .external_lex_state = 2},
  [5663] = {.lex_state = 532, .external_lex_state = 3},
  [5664] = {.lex_state = 532, .external_lex_state = 3},
  [5665] = {.lex_state = 532, .external_lex_state = 3},
  [5666] = {.lex_state = 363, .external_lex_state = 14},
  [5667] = {.lex_state = 192, .external_lex_state = 2},
  [5668] = {.lex_state = 515, .external_lex_state = 10},
  [5669] = {.lex_state = 515, .external_lex_state = 10},
  [5670] = {.lex_state = 515, .external_lex_state = 10},
  [5671] = {.lex_state = 515, .external_lex_state = 10},
  [5672] = {.lex_state = 192, .external_lex_state = 2},
  [5673] = {.lex_state = 192, .external_lex_state = 2},
  [5674] = {.lex_state = 363, .external_lex_state = 3},
  [5675] = {.lex_state = 213},
  [5676] = {.lex_state = 261, .external_lex_state = 3},
  [5677] = {.lex_state = 367, .external_lex_state = 14},
  [5678] = {.lex_state = 363, .external_lex_state = 3},
  [5679] = {.lex_state = 363, .external_lex_state = 3},
  [5680] = {.lex_state = 363, .external_lex_state = 14},
  [5681] = {.lex_state = 192, .external_lex_state = 2},
  [5682] = {.lex_state = 363, .external_lex_state = 3},
  [5683] = {.lex_state = 192, .external_lex_state = 2},
  [5684] = {.lex_state = 192, .external_lex_state = 2},
  [5685] = {.lex_state = 239},
  [5686] = {.lex_state = 192, .external_lex_state = 2},
  [5687] = {.lex_state = 360, .external_lex_state = 10},
  [5688] = {.lex_state = 363, .external_lex_state = 3},
  [5689] = {.lex_state = 363, .external_lex_state = 3},
  [5690] = {.lex_state = 363, .external_lex_state = 3},
  [5691] = {.lex_state = 373, .external_lex_state = 14},
  [5692] = {.lex_state = 363, .external_lex_state = 3},
  [5693] = {.lex_state = 192, .external_lex_state = 2},
  [5694] = {.lex_state = 192, .external_lex_state = 2},
  [5695] = {.lex_state = 192, .external_lex_state = 2},
  [5696] = {.lex_state = 192, .external_lex_state = 2},
  [5697] = {.lex_state = 192, .external_lex_state = 2},
  [5698] = {.lex_state = 192, .external_lex_state = 2},
  [5699] = {.lex_state = 192, .external_lex_state = 2},
  [5700] = {.lex_state = 192, .external_lex_state = 2},
  [5701] = {.lex_state = 192, .external_lex_state = 2},
  [5702] = {.lex_state = 192, .external_lex_state = 2},
  [5703] = {.lex_state = 192, .external_lex_state = 2},
  [5704] = {.lex_state = 192, .external_lex_state = 2},
  [5705] = {.lex_state = 192, .external_lex_state = 2},
  [5706] = {.lex_state = 239},
  [5707] = {.lex_state = 192, .external_lex_state = 2},
  [5708] = {.lex_state = 360, .external_lex_state = 10},
  [5709] = {.lex_state = 423, .external_lex_state = 3},
  [5710] = {.lex_state = 423, .external_lex_state = 3},
  [5711] = {.lex_state = 423, .external_lex_state = 3},
  [5712] = {.lex_state = 429, .external_lex_state = 14},
  [5713] = {.lex_state = 264, .external_lex_state = 3},
  [5714] = {.lex_state = 528, .external_lex_state = 29},
  [5715] = {.lex_state = 363, .external_lex_state = 3},
  [5716] = {.lex_state = 192, .external_lex_state = 28},
  [5717] = {.lex_state = 192, .external_lex_state = 2},
  [5718] = {.lex_state = 363, .external_lex_state = 14},
  [5719] = {.lex_state = 256, .external_lex_state = 13},
  [5720] = {.lex_state = 249, .external_lex_state = 3},
  [5721] = {.lex_state = 249, .external_lex_state = 3},
  [5722] = {.lex_state = 249, .external_lex_state = 3},
  [5723] = {.lex_state = 249, .external_lex_state = 3},
  [5724] = {.lex_state = 249, .external_lex_state = 3},
  [5725] = {.lex_state = 249, .external_lex_state = 3},
  [5726] = {.lex_state = 249, .external_lex_state = 3},
  [5727] = {.lex_state = 249, .external_lex_state = 3},
  [5728] = {.lex_state = 249, .external_lex_state = 3},
  [5729] = {.lex_state = 249, .external_lex_state = 3},
  [5730] = {.lex_state = 561, .external_lex_state = 16},
  [5731] = {.lex_state = 249, .external_lex_state = 3},
  [5732] = {.lex_state = 249, .external_lex_state = 3},
  [5733] = {.lex_state = 249, .external_lex_state = 3},
  [5734] = {.lex_state = 249, .external_lex_state = 3},
  [5735] = {.lex_state = 192, .external_lex_state = 2},
  [5736] = {.lex_state = 256, .external_lex_state = 10},
  [5737] = {.lex_state = 256, .external_lex_state = 10},
  [5738] = {.lex_state = 256, .external_lex_state = 10},
  [5739] = {.lex_state = 256, .external_lex_state = 10},
  [5740] = {.lex_state = 192, .external_lex_state = 2},
  [5741] = {.lex_state = 192, .external_lex_state = 2},
  [5742] = {.lex_state = 426, .external_lex_state = 3},
  [5743] = {.lex_state = 256, .external_lex_state = 10},
  [5744] = {.lex_state = 213},
  [5745] = {.lex_state = 426, .external_lex_state = 3},
  [5746] = {.lex_state = 426, .external_lex_state = 14},
  [5747] = {.lex_state = 426, .external_lex_state = 3},
  [5748] = {.lex_state = 423, .external_lex_state = 3},
  [5749] = {.lex_state = 423, .external_lex_state = 14},
  [5750] = {.lex_state = 192, .external_lex_state = 2},
  [5751] = {.lex_state = 426, .external_lex_state = 3},
  [5752] = {.lex_state = 423, .external_lex_state = 3},
  [5753] = {.lex_state = 192, .external_lex_state = 2},
  [5754] = {.lex_state = 192, .external_lex_state = 2},
  [5755] = {.lex_state = 192, .external_lex_state = 2},
  [5756] = {.lex_state = 192, .external_lex_state = 2},
  [5757] = {.lex_state = 192, .external_lex_state = 2},
  [5758] = {.lex_state = 192, .external_lex_state = 2},
  [5759] = {.lex_state = 192, .external_lex_state = 2},
  [5760] = {.lex_state = 192, .external_lex_state = 2},
  [5761] = {.lex_state = 192, .external_lex_state = 2},
  [5762] = {.lex_state = 192, .external_lex_state = 2},
  [5763] = {.lex_state = 192, .external_lex_state = 2},
  [5764] = {.lex_state = 426, .external_lex_state = 3},
  [5765] = {.lex_state = 528, .external_lex_state = 29},
  [5766] = {.lex_state = 426, .external_lex_state = 3},
  [5767] = {.lex_state = 192, .external_lex_state = 28},
  [5768] = {.lex_state = 192, .external_lex_state = 2},
  [5769] = {.lex_state = 423, .external_lex_state = 14},
  [5770] = {.lex_state = 192, .external_lex_state = 2},
  [5771] = {.lex_state = 192, .external_lex_state = 2},
  [5772] = {.lex_state = 192, .external_lex_state = 2},
  [5773] = {.lex_state = 192, .external_lex_state = 2},
  [5774] = {.lex_state = 532, .external_lex_state = 3},
  [5775] = {.lex_state = 532, .external_lex_state = 3},
  [5776] = {.lex_state = 213},
  [5777] = {.lex_state = 261, .external_lex_state = 3},
  [5778] = {.lex_state = 249, .external_lex_state = 3},
  [5779] = {.lex_state = 264, .external_lex_state = 14},
  [5780] = {.lex_state = 192, .external_lex_state = 2},
  [5781] = {.lex_state = 515, .external_lex_state = 10},
  [5782] = {.lex_state = 515, .external_lex_state = 10},
  [5783] = {.lex_state = 515, .external_lex_state = 10},
  [5784] = {.lex_state = 515, .external_lex_state = 10},
  [5785] = {.lex_state = 192, .external_lex_state = 2},
  [5786] = {.lex_state = 192, .external_lex_state = 2},
  [5787] = {.lex_state = 363, .external_lex_state = 3},
  [5788] = {.lex_state = 213},
  [5789] = {.lex_state = 261, .external_lex_state = 3},
  [5790] = {.lex_state = 367, .external_lex_state = 14},
  [5791] = {.lex_state = 363, .external_lex_state = 3},
  [5792] = {.lex_state = 363, .external_lex_state = 3},
  [5793] = {.lex_state = 363, .external_lex_state = 14},
  [5794] = {.lex_state = 192, .external_lex_state = 2},
  [5795] = {.lex_state = 363, .external_lex_state = 3},
  [5796] = {.lex_state = 192, .external_lex_state = 2},
  [5797] = {.lex_state = 192, .external_lex_state = 2},
  [5798] = {.lex_state = 239},
  [5799] = {.lex_state = 192, .external_lex_state = 2},
  [5800] = {.lex_state = 360, .external_lex_state = 10},
  [5801] = {.lex_state = 363, .external_lex_state = 3},
  [5802] = {.lex_state = 363, .external_lex_state = 3},
  [5803] = {.lex_state = 363, .external_lex_state = 3},
  [5804] = {.lex_state = 373, .external_lex_state = 14},
  [5805] = {.lex_state = 363, .external_lex_state = 3},
  [5806] = {.lex_state = 192, .external_lex_state = 2},
  [5807] = {.lex_state = 192, .external_lex_state = 2},
  [5808] = {.lex_state = 192, .external_lex_state = 2},
  [5809] = {.lex_state = 192, .external_lex_state = 2},
  [5810] = {.lex_state = 192, .external_lex_state = 2},
  [5811] = {.lex_state = 192, .external_lex_state = 2},
  [5812] = {.lex_state = 192, .external_lex_state = 2},
  [5813] = {.lex_state = 192, .external_lex_state = 2},
  [5814] = {.lex_state = 192, .external_lex_state = 2},
  [5815] = {.lex_state = 192, .external_lex_state = 2},
  [5816] = {.lex_state = 192, .external_lex_state = 2},
  [5817] = {.lex_state = 192, .external_lex_state = 2},
  [5818] = {.lex_state = 192, .external_lex_state = 2},
  [5819] = {.lex_state = 239},
  [5820] = {.lex_state = 192, .external_lex_state = 2},
  [5821] = {.lex_state = 360, .external_lex_state = 10},
  [5822] = {.lex_state = 423, .external_lex_state = 3},
  [5823] = {.lex_state = 423, .external_lex_state = 3},
  [5824] = {.lex_state = 423, .external_lex_state = 3},
  [5825] = {.lex_state = 429, .external_lex_state = 14},
  [5826] = {.lex_state = 264, .external_lex_state = 3},
  [5827] = {.lex_state = 528, .external_lex_state = 29},
  [5828] = {.lex_state = 363, .external_lex_state = 3},
  [5829] = {.lex_state = 192, .external_lex_state = 28},
  [5830] = {.lex_state = 192, .external_lex_state = 2},
  [5831] = {.lex_state = 363, .external_lex_state = 14},
  [5832] = {.lex_state = 256, .external_lex_state = 13},
  [5833] = {.lex_state = 249, .external_lex_state = 3},
  [5834] = {.lex_state = 249, .external_lex_state = 3},
  [5835] = {.lex_state = 249, .external_lex_state = 3},
  [5836] = {.lex_state = 249, .external_lex_state = 3},
  [5837] = {.lex_state = 249, .external_lex_state = 3},
  [5838] = {.lex_state = 249, .external_lex_state = 3},
  [5839] = {.lex_state = 249, .external_lex_state = 3},
  [5840] = {.lex_state = 249, .external_lex_state = 3},
  [5841] = {.lex_state = 249, .external_lex_state = 3},
  [5842] = {.lex_state = 249, .external_lex_state = 3},
  [5843] = {.lex_state = 561, .external_lex_state = 16},
  [5844] = {.lex_state = 249, .external_lex_state = 3},
  [5845] = {.lex_state = 249, .external_lex_state = 3},
  [5846] = {.lex_state = 249, .external_lex_state = 3},
  [5847] = {.lex_state = 249, .external_lex_state = 3},
  [5848] = {.lex_state = 192, .external_lex_state = 2},
  [5849] = {.lex_state = 256, .external_lex_state = 10},
  [5850] = {.lex_state = 256, .external_lex_state = 10},
  [5851] = {.lex_state = 256, .external_lex_state = 10},
  [5852] = {.lex_state = 256, .external_lex_state = 10},
  [5853] = {.lex_state = 192, .external_lex_state = 2},
  [5854] = {.lex_state = 192, .external_lex_state = 2},
  [5855] = {.lex_state = 426, .external_lex_state = 3},
  [5856] = {.lex_state = 256, .external_lex_state = 10},
  [5857] = {.lex_state = 213},
  [5858] = {.lex_state = 426, .external_lex_state = 3},
  [5859] = {.lex_state = 426, .external_lex_state = 14},
  [5860] = {.lex_state = 426, .external_lex_state = 3},
  [5861] = {.lex_state = 423, .external_lex_state = 3},
  [5862] = {.lex_state = 423, .external_lex_state = 14},
  [5863] = {.lex_state = 192, .external_lex_state = 2},
  [5864] = {.lex_state = 426, .external_lex_state = 3},
  [5865] = {.lex_state = 423, .external_lex_state = 3},
  [5866] = {.lex_state = 192, .external_lex_state = 2},
  [5867] = {.lex_state = 192, .external_lex_state = 2},
  [5868] = {.lex_state = 192, .external_lex_state = 2},
  [5869] = {.lex_state = 192, .external_lex_state = 2},
  [5870] = {.lex_state = 192, .external_lex_state = 2},
  [5871] = {.lex_state = 192, .external_lex_state = 2},
  [5872] = {.lex_state = 192, .external_lex_state = 2},
  [5873] = {.lex_state = 192, .external_lex_state = 2},
  [5874] = {.lex_state = 192, .external_lex_state = 2},
  [5875] = {.lex_state = 192, .external_lex_state = 2},
  [5876] = {.lex_state = 192, .external_lex_state = 2},
  [5877] = {.lex_state = 426, .external_lex_state = 3},
  [5878] = {.lex_state = 528, .external_lex_state = 29},
  [5879] = {.lex_state = 426, .external_lex_state = 3},
  [5880] = {.lex_state = 192, .external_lex_state = 28},
  [5881] = {.lex_state = 192, .external_lex_state = 2},
  [5882] = {.lex_state = 423, .external_lex_state = 14},
  [5883] = {.lex_state = 192, .external_lex_state = 2},
  [5884] = {.lex_state = 192, .external_lex_state = 2},
  [5885] = {.lex_state = 192, .external_lex_state = 2},
  [5886] = {.lex_state = 192, .external_lex_state = 2},
  [5887] = {.lex_state = 532, .external_lex_state = 3},
  [5888] = {.lex_state = 532, .external_lex_state = 3},
  [5889] = {.lex_state = 213},
  [5890] = {.lex_state = 261, .external_lex_state = 3},
  [5891] = {.lex_state = 249, .external_lex_state = 3},
  [5892] = {.lex_state = 264, .external_lex_state = 14},
  [5893] = {.lex_state = 256, .external_lex_state = 13},
  [5894] = {.lex_state = 156, .external_lex_state = 3},
  [5895] = {.lex_state = 128},
  [5896] = {.lex_state = 192, .external_lex_state = 2},
  [5897] = {.lex_state = 426, .external_lex_state = 3},
  [5898] = {.lex_state = 426, .external_lex_state = 3},
  [5899] = {.lex_state = 192, .external_lex_state = 2},
  [5900] = {.lex_state = 192, .external_lex_state = 2},
  [5901] = {.lex_state = 192, .external_lex_state = 2},
  [5902] = {.lex_state = 192, .external_lex_state = 2},
  [5903] = {.lex_state = 192, .external_lex_state = 2},
  [5904] = {.lex_state = 192, .external_lex_state = 2},
  [5905] = {.lex_state = 192, .external_lex_state = 2},
  [5906] = {.lex_state = 192, .external_lex_state = 2},
  [5907] = {.lex_state = 192, .external_lex_state = 2},
  [5908] = {.lex_state = 192, .external_lex_state = 2},
  [5909] = {.lex_state = 192, .external_lex_state = 28},
  [5910] = {.lex_state = 192, .external_lex_state = 2},
  [5911] = {.lex_state = 426, .external_lex_state = 14},
  [5912] = {.lex_state = 426, .external_lex_state = 3},
  [5913] = {.lex_state = 426, .external_lex_state = 3},
  [5914] = {.lex_state = 423, .external_lex_state = 3},
  [5915] = {.lex_state = 423, .external_lex_state = 3},
  [5916] = {.lex_state = 423, .external_lex_state = 3},
  [5917] = {.lex_state = 423, .external_lex_state = 3},
  [5918] = {.lex_state = 423, .external_lex_state = 3},
  [5919] = {.lex_state = 561, .external_lex_state = 16},
  [5920] = {.lex_state = 423, .external_lex_state = 3},
  [5921] = {.lex_state = 423, .external_lex_state = 3},
  [5922] = {.lex_state = 423, .external_lex_state = 3},
  [5923] = {.lex_state = 423, .external_lex_state = 3},
  [5924] = {.lex_state = 426, .external_lex_state = 3},
  [5925] = {.lex_state = 528, .external_lex_state = 12},
  [5926] = {.lex_state = 426, .external_lex_state = 3},
  [5927] = {.lex_state = 426, .external_lex_state = 3},
  [5928] = {.lex_state = 423, .external_lex_state = 3},
  [5929] = {.lex_state = 423, .external_lex_state = 3},
  [5930] = {.lex_state = 423, .external_lex_state = 3},
  [5931] = {.lex_state = 423, .external_lex_state = 14},
  [5932] = {.lex_state = 532, .external_lex_state = 3},
  [5933] = {.lex_state = 532, .external_lex_state = 3},
  [5934] = {.lex_state = 532, .external_lex_state = 3},
  [5935] = {.lex_state = 192, .external_lex_state = 2},
  [5936] = {.lex_state = 192, .external_lex_state = 2},
  [5937] = {.lex_state = 192, .external_lex_state = 2},
  [5938] = {.lex_state = 192, .external_lex_state = 2},
  [5939] = {.lex_state = 192, .external_lex_state = 2},
  [5940] = {.lex_state = 192, .external_lex_state = 2},
  [5941] = {.lex_state = 192, .external_lex_state = 2},
  [5942] = {.lex_state = 192, .external_lex_state = 2},
  [5943] = {.lex_state = 192, .external_lex_state = 2},
  [5944] = {.lex_state = 192, .external_lex_state = 2},
  [5945] = {.lex_state = 192, .external_lex_state = 28},
  [5946] = {.lex_state = 532, .external_lex_state = 3},
  [5947] = {.lex_state = 192, .external_lex_state = 28},
  [5948] = {.lex_state = 192, .external_lex_state = 2},
  [5949] = {.lex_state = 390, .external_lex_state = 24},
  [5950] = {.lex_state = 390, .external_lex_state = 24},
  [5951] = {.lex_state = 177, .external_lex_state = 4},
  [5952] = {.lex_state = 268, .external_lex_state = 15},
  [5953] = {.lex_state = 390, .external_lex_state = 24},
  [5954] = {.lex_state = 177, .external_lex_state = 4},
  [5955] = {.lex_state = 390, .external_lex_state = 24},
  [5956] = {.lex_state = 390, .external_lex_state = 24},
  [5957] = {.lex_state = 177, .external_lex_state = 4},
  [5958] = {.lex_state = 268, .external_lex_state = 15},
  [5959] = {.lex_state = 390, .external_lex_state = 24},
  [5960] = {.lex_state = 177, .external_lex_state = 4},
  [5961] = {.lex_state = 192, .external_lex_state = 2},
  [5962] = {.lex_state = 192, .external_lex_state = 2},
  [5963] = {.lex_state = 192, .external_lex_state = 2},
  [5964] = {.lex_state = 408, .external_lex_state = 24},
  [5965] = {.lex_state = 213},
  [5966] = {.lex_state = 541, .external_lex_state = 24},
  [5967] = {.lex_state = 408, .external_lex_state = 24},
  [5968] = {.lex_state = 192, .external_lex_state = 2},
  [5969] = {.lex_state = 408, .external_lex_state = 24},
  [5970] = {.lex_state = 192, .external_lex_state = 2},
  [5971] = {.lex_state = 408, .external_lex_state = 24},
  [5972] = {.lex_state = 528, .external_lex_state = 29},
  [5973] = {.lex_state = 408, .external_lex_state = 24},
  [5974] = {.lex_state = 402, .external_lex_state = 24},
  [5975] = {.lex_state = 402, .external_lex_state = 24},
  [5976] = {.lex_state = 402, .external_lex_state = 24},
  [5977] = {.lex_state = 402, .external_lex_state = 24},
  [5978] = {.lex_state = 402, .external_lex_state = 24},
  [5979] = {.lex_state = 561, .external_lex_state = 16},
  [5980] = {.lex_state = 402, .external_lex_state = 24},
  [5981] = {.lex_state = 402, .external_lex_state = 24},
  [5982] = {.lex_state = 402, .external_lex_state = 24},
  [5983] = {.lex_state = 402, .external_lex_state = 24},
  [5984] = {.lex_state = 192, .external_lex_state = 2},
  [5985] = {.lex_state = 538, .external_lex_state = 25},
  [5986] = {.lex_state = 538, .external_lex_state = 25},
  [5987] = {.lex_state = 538, .external_lex_state = 25},
  [5988] = {.lex_state = 538, .external_lex_state = 25},
  [5989] = {.lex_state = 192, .external_lex_state = 2},
  [5990] = {.lex_state = 192, .external_lex_state = 2},
  [5991] = {.lex_state = 541, .external_lex_state = 24},
  [5992] = {.lex_state = 538, .external_lex_state = 25},
  [5993] = {.lex_state = 213},
  [5994] = {.lex_state = 541, .external_lex_state = 24},
  [5995] = {.lex_state = 541, .external_lex_state = 26},
  [5996] = {.lex_state = 541, .external_lex_state = 24},
  [5997] = {.lex_state = 192, .external_lex_state = 2},
  [5998] = {.lex_state = 541, .external_lex_state = 24},
  [5999] = {.lex_state = 192, .external_lex_state = 2},
  [6000] = {.lex_state = 541, .external_lex_state = 24},
  [6001] = {.lex_state = 528, .external_lex_state = 29},
  [6002] = {.lex_state = 541, .external_lex_state = 24},
  [6003] = {.lex_state = 192, .external_lex_state = 2},
  [6004] = {.lex_state = 402, .external_lex_state = 24},
  [6005] = {.lex_state = 402, .external_lex_state = 24},
  [6006] = {.lex_state = 402, .external_lex_state = 24},
  [6007] = {.lex_state = 544, .external_lex_state = 26},
  [6008] = {.lex_state = 390, .external_lex_state = 24},
  [6009] = {.lex_state = 312},
  [6010] = {.lex_state = 390, .external_lex_state = 24},
  [6011] = {.lex_state = 390, .external_lex_state = 24},
  [6012] = {.lex_state = 128, .external_lex_state = 2},
  [6013] = {.lex_state = 128, .external_lex_state = 2},
  [6014] = {.lex_state = 390, .external_lex_state = 24},
  [6015] = {.lex_state = 390, .external_lex_state = 24},
  [6016] = {.lex_state = 408, .external_lex_state = 24},
  [6017] = {.lex_state = 408, .external_lex_state = 24},
  [6018] = {.lex_state = 408, .external_lex_state = 24},
  [6019] = {.lex_state = 408, .external_lex_state = 24},
  [6020] = {.lex_state = 408, .external_lex_state = 24},
  [6021] = {.lex_state = 408, .external_lex_state = 24},
  [6022] = {.lex_state = 408, .external_lex_state = 24},
  [6023] = {.lex_state = 561, .external_lex_state = 16},
  [6024] = {.lex_state = 408, .external_lex_state = 24},
  [6025] = {.lex_state = 408, .external_lex_state = 24},
  [6026] = {.lex_state = 408, .external_lex_state = 24},
  [6027] = {.lex_state = 408, .external_lex_state = 24},
  [6028] = {.lex_state = 408, .external_lex_state = 24},
  [6029] = {.lex_state = 528, .external_lex_state = 12},
  [6030] = {.lex_state = 408, .external_lex_state = 24},
  [6031] = {.lex_state = 408, .external_lex_state = 24},
  [6032] = {.lex_state = 408, .external_lex_state = 24},
  [6033] = {.lex_state = 408, .external_lex_state = 24},
  [6034] = {.lex_state = 408, .external_lex_state = 24},
  [6035] = {.lex_state = 390, .external_lex_state = 24},
  [6036] = {.lex_state = 128},
  [6037] = {.lex_state = 390, .external_lex_state = 24},
  [6038] = {.lex_state = 128},
  [6039] = {.lex_state = 390, .external_lex_state = 24},
  [6040] = {.lex_state = 128},
  [6041] = {.lex_state = 390, .external_lex_state = 24},
  [6042] = {.lex_state = 128},
  [6043] = {.lex_state = 128, .external_lex_state = 2},
  [6044] = {.lex_state = 390, .external_lex_state = 24},
  [6045] = {.lex_state = 128},
  [6046] = {.lex_state = 128},
  [6047] = {.lex_state = 128},
  [6048] = {.lex_state = 390, .external_lex_state = 24},
  [6049] = {.lex_state = 128},
  [6050] = {.lex_state = 128},
  [6051] = {.lex_state = 390, .external_lex_state = 24},
  [6052] = {.lex_state = 194},
  [6053] = {.lex_state = 390, .external_lex_state = 24},
  [6054] = {.lex_state = 128},
  [6055] = {.lex_state = 128, .external_lex_state = 2},
  [6056] = {.lex_state = 128, .external_lex_state = 11},
  [6057] = {.lex_state = 192, .external_lex_state = 2},
  [6058] = {.lex_state = 548, .external_lex_state = 25},
  [6059] = {.lex_state = 209},
  [6060] = {.lex_state = 548, .external_lex_state = 25},
  [6061] = {.lex_state = 399, .external_lex_state = 24},
  [6062] = {.lex_state = 405, .external_lex_state = 24},
  [6063] = {.lex_state = 399, .external_lex_state = 24},
  [6064] = {.lex_state = 194},
  [6065] = {.lex_state = 399, .external_lex_state = 24},
  [6066] = {.lex_state = 128},
  [6067] = {.lex_state = 128, .external_lex_state = 2},
  [6068] = {.lex_state = 128, .external_lex_state = 11},
  [6069] = {.lex_state = 405, .external_lex_state = 24},
  [6070] = {.lex_state = 405, .external_lex_state = 24},
  [6071] = {.lex_state = 405, .external_lex_state = 24},
  [6072] = {.lex_state = 405, .external_lex_state = 24},
  [6073] = {.lex_state = 405, .external_lex_state = 24},
  [6074] = {.lex_state = 405, .external_lex_state = 24},
  [6075] = {.lex_state = 561, .external_lex_state = 16},
  [6076] = {.lex_state = 405, .external_lex_state = 24},
  [6077] = {.lex_state = 405, .external_lex_state = 24},
  [6078] = {.lex_state = 405, .external_lex_state = 24},
  [6079] = {.lex_state = 405, .external_lex_state = 24},
  [6080] = {.lex_state = 405, .external_lex_state = 24},
  [6081] = {.lex_state = 528, .external_lex_state = 12},
  [6082] = {.lex_state = 405, .external_lex_state = 24},
  [6083] = {.lex_state = 405, .external_lex_state = 24},
  [6084] = {.lex_state = 405, .external_lex_state = 24},
  [6085] = {.lex_state = 405, .external_lex_state = 24},
  [6086] = {.lex_state = 405, .external_lex_state = 24},
  [6087] = {.lex_state = 647, .external_lex_state = 26},
  [6088] = {.lex_state = 553, .external_lex_state = 19},
  [6089] = {.lex_state = 237, .external_lex_state = 12},
  [6090] = {.lex_state = 528, .external_lex_state = 29},
  [6091] = {.lex_state = 402, .external_lex_state = 24},
  [6092] = {.lex_state = 192, .external_lex_state = 28},
  [6093] = {.lex_state = 402, .external_lex_state = 24},
  [6094] = {.lex_state = 288, .external_lex_state = 2},
  [6095] = {.lex_state = 128},
  [6096] = {.lex_state = 239},
  [6097] = {.lex_state = 688, .external_lex_state = 2},
  [6098] = {.lex_state = 192, .external_lex_state = 2},
  [6099] = {.lex_state = 239},
  [6100] = {.lex_state = 239},
  [6101] = {.lex_state = 156, .external_lex_state = 3},
  [6102] = {.lex_state = 339},
  [6103] = {.lex_state = 304},
  [6104] = {.lex_state = 304, .external_lex_state = 16},
  [6105] = {.lex_state = 304, .external_lex_state = 16},
  [6106] = {.lex_state = 339},
  [6107] = {.lex_state = 128},
  [6108] = {.lex_state = 304},
  [6109] = {.lex_state = 128, .external_lex_state = 11},
  [6110] = {.lex_state = 128},
  [6111] = {.lex_state = 239},
  [6112] = {.lex_state = 239},
  [6113] = {.lex_state = 239},
  [6114] = {.lex_state = 156, .external_lex_state = 3},
  [6115] = {.lex_state = 128},
  [6116] = {.lex_state = 128, .external_lex_state = 2},
  [6117] = {.lex_state = 304, .external_lex_state = 16},
  [6118] = {.lex_state = 304, .external_lex_state = 16},
  [6119] = {.lex_state = 192, .external_lex_state = 2},
  [6120] = {.lex_state = 192, .external_lex_state = 2},
  [6121] = {.lex_state = 192, .external_lex_state = 2},
  [6122] = {.lex_state = 192, .external_lex_state = 2},
  [6123] = {.lex_state = 192, .external_lex_state = 2},
  [6124] = {.lex_state = 192, .external_lex_state = 2},
  [6125] = {.lex_state = 192, .external_lex_state = 2},
  [6126] = {.lex_state = 192, .external_lex_state = 2},
  [6127] = {.lex_state = 192, .external_lex_state = 2},
  [6128] = {.lex_state = 192, .external_lex_state = 2},
  [6129] = {.lex_state = 421, .external_lex_state = 6},
  [6130] = {.lex_state = 229, .external_lex_state = 16},
  [6131] = {.lex_state = 192, .external_lex_state = 28},
  [6132] = {.lex_state = 192, .external_lex_state = 2},
  [6133] = {.lex_state = 253, .external_lex_state = 20},
  [6134] = {.lex_state = 650, .external_lex_state = 20},
  [6135] = {.lex_state = 192, .external_lex_state = 2},
  [6136] = {.lex_state = 690, .external_lex_state = 25},
  [6137] = {.lex_state = 690, .external_lex_state = 25},
  [6138] = {.lex_state = 690, .external_lex_state = 25},
  [6139] = {.lex_state = 690, .external_lex_state = 25},
  [6140] = {.lex_state = 192, .external_lex_state = 2},
  [6141] = {.lex_state = 192, .external_lex_state = 2},
  [6142] = {.lex_state = 650, .external_lex_state = 24},
  [6143] = {.lex_state = 563, .external_lex_state = 25},
  [6144] = {.lex_state = 213},
  [6145] = {.lex_state = 566, .external_lex_state = 24},
  [6146] = {.lex_state = 650, .external_lex_state = 26},
  [6147] = {.lex_state = 650, .external_lex_state = 24},
  [6148] = {.lex_state = 177, .external_lex_state = 4},
  [6149] = {.lex_state = 659, .external_lex_state = 24},
  [6150] = {.lex_state = 659, .external_lex_state = 26},
  [6151] = {.lex_state = 192, .external_lex_state = 2},
  [6152] = {.lex_state = 650, .external_lex_state = 24},
  [6153] = {.lex_state = 192, .external_lex_state = 2},
  [6154] = {.lex_state = 192, .external_lex_state = 2},
  [6155] = {.lex_state = 239},
  [6156] = {.lex_state = 192, .external_lex_state = 2},
  [6157] = {.lex_state = 656, .external_lex_state = 25},
  [6158] = {.lex_state = 659, .external_lex_state = 24},
  [6159] = {.lex_state = 659, .external_lex_state = 24},
  [6160] = {.lex_state = 659, .external_lex_state = 24},
  [6161] = {.lex_state = 666, .external_lex_state = 26},
  [6162] = {.lex_state = 659, .external_lex_state = 24},
  [6163] = {.lex_state = 192, .external_lex_state = 2},
  [6164] = {.lex_state = 192, .external_lex_state = 2},
  [6165] = {.lex_state = 192, .external_lex_state = 2},
  [6166] = {.lex_state = 192, .external_lex_state = 2},
  [6167] = {.lex_state = 192, .external_lex_state = 2},
  [6168] = {.lex_state = 192, .external_lex_state = 2},
  [6169] = {.lex_state = 192, .external_lex_state = 2},
  [6170] = {.lex_state = 192, .external_lex_state = 2},
  [6171] = {.lex_state = 192, .external_lex_state = 2},
  [6172] = {.lex_state = 192, .external_lex_state = 2},
  [6173] = {.lex_state = 192, .external_lex_state = 2},
  [6174] = {.lex_state = 192, .external_lex_state = 2},
  [6175] = {.lex_state = 192, .external_lex_state = 2},
  [6176] = {.lex_state = 239},
  [6177] = {.lex_state = 192, .external_lex_state = 2},
  [6178] = {.lex_state = 656, .external_lex_state = 25},
  [6179] = {.lex_state = 663, .external_lex_state = 24},
  [6180] = {.lex_state = 663, .external_lex_state = 24},
  [6181] = {.lex_state = 663, .external_lex_state = 24},
  [6182] = {.lex_state = 667, .external_lex_state = 26},
  [6183] = {.lex_state = 569, .external_lex_state = 24},
  [6184] = {.lex_state = 528, .external_lex_state = 29},
  [6185] = {.lex_state = 650, .external_lex_state = 24},
  [6186] = {.lex_state = 192, .external_lex_state = 28},
  [6187] = {.lex_state = 192, .external_lex_state = 2},
  [6188] = {.lex_state = 659, .external_lex_state = 26},
  [6189] = {.lex_state = 561, .external_lex_state = 16},
  [6190] = {.lex_state = 561, .external_lex_state = 16},
  [6191] = {.lex_state = 561, .external_lex_state = 16},
  [6192] = {.lex_state = 561, .external_lex_state = 16},
  [6193] = {.lex_state = 561, .external_lex_state = 16},
  [6194] = {.lex_state = 561, .external_lex_state = 16},
  [6195] = {.lex_state = 249, .external_lex_state = 3},
  [6196] = {.lex_state = 561, .external_lex_state = 16},
  [6197] = {.lex_state = 561, .external_lex_state = 16},
  [6198] = {.lex_state = 561, .external_lex_state = 16},
  [6199] = {.lex_state = 561, .external_lex_state = 16},
  [6200] = {.lex_state = 192, .external_lex_state = 2},
  [6201] = {.lex_state = 563, .external_lex_state = 25},
  [6202] = {.lex_state = 563, .external_lex_state = 25},
  [6203] = {.lex_state = 563, .external_lex_state = 25},
  [6204] = {.lex_state = 563, .external_lex_state = 25},
  [6205] = {.lex_state = 192, .external_lex_state = 2},
  [6206] = {.lex_state = 192, .external_lex_state = 2},
  [6207] = {.lex_state = 566, .external_lex_state = 24},
  [6208] = {.lex_state = 563, .external_lex_state = 25},
  [6209] = {.lex_state = 213},
  [6210] = {.lex_state = 566, .external_lex_state = 24},
  [6211] = {.lex_state = 566, .external_lex_state = 26},
  [6212] = {.lex_state = 566, .external_lex_state = 24},
  [6213] = {.lex_state = 177, .external_lex_state = 4},
  [6214] = {.lex_state = 663, .external_lex_state = 24},
  [6215] = {.lex_state = 663, .external_lex_state = 26},
  [6216] = {.lex_state = 192, .external_lex_state = 2},
  [6217] = {.lex_state = 566, .external_lex_state = 24},
  [6218] = {.lex_state = 663, .external_lex_state = 24},
  [6219] = {.lex_state = 192, .external_lex_state = 2},
  [6220] = {.lex_state = 192, .external_lex_state = 2},
  [6221] = {.lex_state = 192, .external_lex_state = 2},
  [6222] = {.lex_state = 192, .external_lex_state = 2},
  [6223] = {.lex_state = 192, .external_lex_state = 2},
  [6224] = {.lex_state = 192, .external_lex_state = 2},
  [6225] = {.lex_state = 192, .external_lex_state = 2},
  [6226] = {.lex_state = 192, .external_lex_state = 2},
  [6227] = {.lex_state = 192, .external_lex_state = 2},
  [6228] = {.lex_state = 192, .external_lex_state = 2},
  [6229] = {.lex_state = 192, .external_lex_state = 2},
  [6230] = {.lex_state = 566, .external_lex_state = 24},
  [6231] = {.lex_state = 528, .external_lex_state = 29},
  [6232] = {.lex_state = 566, .external_lex_state = 24},
  [6233] = {.lex_state = 192, .external_lex_state = 28},
  [6234] = {.lex_state = 192, .external_lex_state = 2},
  [6235] = {.lex_state = 663, .external_lex_state = 26},
  [6236] = {.lex_state = 192, .external_lex_state = 2},
  [6237] = {.lex_state = 192, .external_lex_state = 2},
  [6238] = {.lex_state = 690, .external_lex_state = 18},
  [6239] = {.lex_state = 690, .external_lex_state = 18},
  [6240] = {.lex_state = 690, .external_lex_state = 18},
  [6241] = {.lex_state = 690, .external_lex_state = 18},
  [6242] = {.lex_state = 192, .external_lex_state = 2},
  [6243] = {.lex_state = 192, .external_lex_state = 2},
  [6244] = {.lex_state = 561, .external_lex_state = 16},
  [6245] = {.lex_state = 561, .external_lex_state = 16},
  [6246] = {.lex_state = 213},
  [6247] = {.lex_state = 566, .external_lex_state = 16},
  [6248] = {.lex_state = 650, .external_lex_state = 20},
  [6249] = {.lex_state = 561, .external_lex_state = 16},
  [6250] = {.lex_state = 569, .external_lex_state = 20},
  [6251] = {.lex_state = 418, .external_lex_state = 27},
  [6252] = {.lex_state = 329, .external_lex_state = 10},
  [6253] = {.lex_state = 301, .external_lex_state = 3},
  [6254] = {.lex_state = 301, .external_lex_state = 3},
  [6255] = {.lex_state = 177, .external_lex_state = 4},
  [6256] = {.lex_state = 268, .external_lex_state = 15},
  [6257] = {.lex_state = 301, .external_lex_state = 3},
  [6258] = {.lex_state = 177, .external_lex_state = 4},
  [6259] = {.lex_state = 301, .external_lex_state = 3},
  [6260] = {.lex_state = 301, .external_lex_state = 3},
  [6261] = {.lex_state = 177, .external_lex_state = 4},
  [6262] = {.lex_state = 268, .external_lex_state = 15},
  [6263] = {.lex_state = 301, .external_lex_state = 3},
  [6264] = {.lex_state = 177, .external_lex_state = 4},
  [6265] = {.lex_state = 229, .external_lex_state = 14},
  [6266] = {.lex_state = 229, .external_lex_state = 3},
  [6267] = {.lex_state = 229, .external_lex_state = 3},
  [6268] = {.lex_state = 229, .external_lex_state = 3},
  [6269] = {.lex_state = 229, .external_lex_state = 3},
  [6270] = {.lex_state = 192, .external_lex_state = 15},
  [6271] = {.lex_state = 268, .external_lex_state = 15},
  [6272] = {.lex_state = 229, .external_lex_state = 3},
  [6273] = {.lex_state = 177, .external_lex_state = 4},
  [6274] = {.lex_state = 268, .external_lex_state = 15},
  [6275] = {.lex_state = 229, .external_lex_state = 3},
  [6276] = {.lex_state = 192, .external_lex_state = 15},
  [6277] = {.lex_state = 268, .external_lex_state = 15},
  [6278] = {.lex_state = 229, .external_lex_state = 3},
  [6279] = {.lex_state = 177, .external_lex_state = 4},
  [6280] = {.lex_state = 268, .external_lex_state = 15},
  [6281] = {.lex_state = 229, .external_lex_state = 3},
  [6282] = {.lex_state = 194},
  [6283] = {.lex_state = 304, .external_lex_state = 16},
  [6284] = {.lex_state = 227, .external_lex_state = 7},
  [6285] = {.lex_state = 128, .external_lex_state = 2},
  [6286] = {.lex_state = 229, .external_lex_state = 3},
  [6287] = {.lex_state = 249, .external_lex_state = 3},
  [6288] = {.lex_state = 128, .external_lex_state = 13},
  [6289] = {.lex_state = 128, .external_lex_state = 2},
  [6290] = {.lex_state = 229, .external_lex_state = 3},
  [6291] = {.lex_state = 128, .external_lex_state = 2},
  [6292] = {.lex_state = 128},
  [6293] = {.lex_state = 128, .external_lex_state = 2},
  [6294] = {.lex_state = 128},
  [6295] = {.lex_state = 128, .external_lex_state = 2},
  [6296] = {.lex_state = 128, .external_lex_state = 2},
  [6297] = {.lex_state = 128, .external_lex_state = 2},
  [6298] = {.lex_state = 128, .external_lex_state = 13},
  [6299] = {.lex_state = 128},
  [6300] = {.lex_state = 229, .external_lex_state = 3},
  [6301] = {.lex_state = 128},
  [6302] = {.lex_state = 128},
  [6303] = {.lex_state = 128},
  [6304] = {.lex_state = 229, .external_lex_state = 3},
  [6305] = {.lex_state = 128},
  [6306] = {.lex_state = 128},
  [6307] = {.lex_state = 128},
  [6308] = {.lex_state = 229, .external_lex_state = 3},
  [6309] = {.lex_state = 229, .external_lex_state = 3},
  [6310] = {.lex_state = 229, .external_lex_state = 3},
  [6311] = {.lex_state = 426, .external_lex_state = 3},
  [6312] = {.lex_state = 426, .external_lex_state = 3},
  [6313] = {.lex_state = 426, .external_lex_state = 3},
  [6314] = {.lex_state = 426, .external_lex_state = 3},
  [6315] = {.lex_state = 426, .external_lex_state = 3},
  [6316] = {.lex_state = 561, .external_lex_state = 16},
  [6317] = {.lex_state = 426, .external_lex_state = 3},
  [6318] = {.lex_state = 426, .external_lex_state = 3},
  [6319] = {.lex_state = 426, .external_lex_state = 3},
  [6320] = {.lex_state = 426, .external_lex_state = 3},
  [6321] = {.lex_state = 301, .external_lex_state = 3},
  [6322] = {.lex_state = 426, .external_lex_state = 3},
  [6323] = {.lex_state = 229, .external_lex_state = 3},
  [6324] = {.lex_state = 426, .external_lex_state = 3},
  [6325] = {.lex_state = 426, .external_lex_state = 3},
  [6326] = {.lex_state = 426, .external_lex_state = 14},
  [6327] = {.lex_state = 595, .external_lex_state = 3},
  [6328] = {.lex_state = 595, .external_lex_state = 3},
  [6329] = {.lex_state = 192, .external_lex_state = 2},
  [6330] = {.lex_state = 595, .external_lex_state = 3},
  [6331] = {.lex_state = 192, .external_lex_state = 2},
  [6332] = {.lex_state = 459, .external_lex_state = 3},
  [6333] = {.lex_state = 528, .external_lex_state = 29},
  [6334] = {.lex_state = 595, .external_lex_state = 3},
  [6335] = {.lex_state = 229, .external_lex_state = 3},
  [6336] = {.lex_state = 438, .external_lex_state = 3},
  [6337] = {.lex_state = 438, .external_lex_state = 3},
  [6338] = {.lex_state = 438, .external_lex_state = 3},
  [6339] = {.lex_state = 438, .external_lex_state = 3},
  [6340] = {.lex_state = 438, .external_lex_state = 3},
  [6341] = {.lex_state = 561, .external_lex_state = 16},
  [6342] = {.lex_state = 438, .external_lex_state = 3},
  [6343] = {.lex_state = 438, .external_lex_state = 3},
  [6344] = {.lex_state = 438, .external_lex_state = 3},
  [6345] = {.lex_state = 438, .external_lex_state = 3},
  [6346] = {.lex_state = 580, .external_lex_state = 3},
  [6347] = {.lex_state = 580, .external_lex_state = 3},
  [6348] = {.lex_state = 192, .external_lex_state = 2},
  [6349] = {.lex_state = 580, .external_lex_state = 3},
  [6350] = {.lex_state = 192, .external_lex_state = 2},
  [6351] = {.lex_state = 580, .external_lex_state = 3},
  [6352] = {.lex_state = 528, .external_lex_state = 29},
  [6353] = {.lex_state = 580, .external_lex_state = 3},
  [6354] = {.lex_state = 192, .external_lex_state = 2},
  [6355] = {.lex_state = 192, .external_lex_state = 2},
  [6356] = {.lex_state = 192, .external_lex_state = 2},
  [6357] = {.lex_state = 192, .external_lex_state = 2},
  [6358] = {.lex_state = 438, .external_lex_state = 3},
  [6359] = {.lex_state = 438, .external_lex_state = 3},
  [6360] = {.lex_state = 213},
  [6361] = {.lex_state = 580, .external_lex_state = 3},
  [6362] = {.lex_state = 438, .external_lex_state = 3},
  [6363] = {.lex_state = 459, .external_lex_state = 14},
  [6364] = {.lex_state = 301, .external_lex_state = 3},
  [6365] = {.lex_state = 312},
  [6366] = {.lex_state = 301, .external_lex_state = 3},
  [6367] = {.lex_state = 301, .external_lex_state = 3},
  [6368] = {.lex_state = 128, .external_lex_state = 2},
  [6369] = {.lex_state = 128, .external_lex_state = 2},
  [6370] = {.lex_state = 301, .external_lex_state = 3},
  [6371] = {.lex_state = 301, .external_lex_state = 3},
  [6372] = {.lex_state = 301, .external_lex_state = 3},
  [6373] = {.lex_state = 128},
  [6374] = {.lex_state = 301, .external_lex_state = 3},
  [6375] = {.lex_state = 128},
  [6376] = {.lex_state = 301, .external_lex_state = 3},
  [6377] = {.lex_state = 128},
  [6378] = {.lex_state = 301, .external_lex_state = 3},
  [6379] = {.lex_state = 128},
  [6380] = {.lex_state = 128, .external_lex_state = 2},
  [6381] = {.lex_state = 229, .external_lex_state = 3},
  [6382] = {.lex_state = 128},
  [6383] = {.lex_state = 128, .external_lex_state = 2},
  [6384] = {.lex_state = 301, .external_lex_state = 3},
  [6385] = {.lex_state = 128},
  [6386] = {.lex_state = 128},
  [6387] = {.lex_state = 128},
  [6388] = {.lex_state = 301, .external_lex_state = 3},
  [6389] = {.lex_state = 128},
  [6390] = {.lex_state = 128},
  [6391] = {.lex_state = 192, .external_lex_state = 2},
  [6392] = {.lex_state = 229, .external_lex_state = 3},
  [6393] = {.lex_state = 229, .external_lex_state = 3},
  [6394] = {.lex_state = 192, .external_lex_state = 28},
  [6395] = {.lex_state = 423, .external_lex_state = 3},
  [6396] = {.lex_state = 584, .external_lex_state = 3},
  [6397] = {.lex_state = 584, .external_lex_state = 3},
  [6398] = {.lex_state = 584, .external_lex_state = 3},
  [6399] = {.lex_state = 584, .external_lex_state = 3},
  [6400] = {.lex_state = 584, .external_lex_state = 3},
  [6401] = {.lex_state = 561, .external_lex_state = 16},
  [6402] = {.lex_state = 584, .external_lex_state = 3},
  [6403] = {.lex_state = 584, .external_lex_state = 3},
  [6404] = {.lex_state = 584, .external_lex_state = 3},
  [6405] = {.lex_state = 584, .external_lex_state = 3},
  [6406] = {.lex_state = 382, .external_lex_state = 3},
  [6407] = {.lex_state = 584, .external_lex_state = 3},
  [6408] = {.lex_state = 584, .external_lex_state = 3},
  [6409] = {.lex_state = 584, .external_lex_state = 3},
  [6410] = {.lex_state = 192, .external_lex_state = 2},
  [6411] = {.lex_state = 515, .external_lex_state = 10},
  [6412] = {.lex_state = 515, .external_lex_state = 10},
  [6413] = {.lex_state = 515, .external_lex_state = 10},
  [6414] = {.lex_state = 515, .external_lex_state = 10},
  [6415] = {.lex_state = 192, .external_lex_state = 2},
  [6416] = {.lex_state = 192, .external_lex_state = 2},
  [6417] = {.lex_state = 363, .external_lex_state = 3},
  [6418] = {.lex_state = 213},
  [6419] = {.lex_state = 261, .external_lex_state = 3},
  [6420] = {.lex_state = 367, .external_lex_state = 14},
  [6421] = {.lex_state = 363, .external_lex_state = 3},
  [6422] = {.lex_state = 363, .external_lex_state = 3},
  [6423] = {.lex_state = 363, .external_lex_state = 14},
  [6424] = {.lex_state = 192, .external_lex_state = 2},
  [6425] = {.lex_state = 363, .external_lex_state = 3},
  [6426] = {.lex_state = 192, .external_lex_state = 2},
  [6427] = {.lex_state = 192, .external_lex_state = 2},
  [6428] = {.lex_state = 239},
  [6429] = {.lex_state = 192, .external_lex_state = 2},
  [6430] = {.lex_state = 360, .external_lex_state = 10},
  [6431] = {.lex_state = 363, .external_lex_state = 3},
  [6432] = {.lex_state = 363, .external_lex_state = 3},
  [6433] = {.lex_state = 363, .external_lex_state = 3},
  [6434] = {.lex_state = 373, .external_lex_state = 14},
  [6435] = {.lex_state = 363, .external_lex_state = 3},
  [6436] = {.lex_state = 192, .external_lex_state = 2},
  [6437] = {.lex_state = 192, .external_lex_state = 2},
  [6438] = {.lex_state = 192, .external_lex_state = 2},
  [6439] = {.lex_state = 192, .external_lex_state = 2},
  [6440] = {.lex_state = 192, .external_lex_state = 2},
  [6441] = {.lex_state = 192, .external_lex_state = 2},
  [6442] = {.lex_state = 192, .external_lex_state = 2},
  [6443] = {.lex_state = 192, .external_lex_state = 2},
  [6444] = {.lex_state = 192, .external_lex_state = 2},
  [6445] = {.lex_state = 192, .external_lex_state = 2},
  [6446] = {.lex_state = 192, .external_lex_state = 2},
  [6447] = {.lex_state = 192, .external_lex_state = 2},
  [6448] = {.lex_state = 192, .external_lex_state = 2},
  [6449] = {.lex_state = 239},
  [6450] = {.lex_state = 192, .external_lex_state = 2},
  [6451] = {.lex_state = 360, .external_lex_state = 10},
  [6452] = {.lex_state = 423, .external_lex_state = 3},
  [6453] = {.lex_state = 423, .external_lex_state = 3},
  [6454] = {.lex_state = 423, .external_lex_state = 3},
  [6455] = {.lex_state = 429, .external_lex_state = 14},
  [6456] = {.lex_state = 264, .external_lex_state = 3},
  [6457] = {.lex_state = 528, .external_lex_state = 29},
  [6458] = {.lex_state = 363, .external_lex_state = 3},
  [6459] = {.lex_state = 192, .external_lex_state = 28},
  [6460] = {.lex_state = 192, .external_lex_state = 2},
  [6461] = {.lex_state = 363, .external_lex_state = 14},
  [6462] = {.lex_state = 256, .external_lex_state = 13},
  [6463] = {.lex_state = 249, .external_lex_state = 3},
  [6464] = {.lex_state = 249, .external_lex_state = 3},
  [6465] = {.lex_state = 249, .external_lex_state = 3},
  [6466] = {.lex_state = 249, .external_lex_state = 3},
  [6467] = {.lex_state = 249, .external_lex_state = 3},
  [6468] = {.lex_state = 249, .external_lex_state = 3},
  [6469] = {.lex_state = 249, .external_lex_state = 3},
  [6470] = {.lex_state = 249, .external_lex_state = 3},
  [6471] = {.lex_state = 249, .external_lex_state = 3},
  [6472] = {.lex_state = 249, .external_lex_state = 3},
  [6473] = {.lex_state = 561, .external_lex_state = 16},
  [6474] = {.lex_state = 249, .external_lex_state = 3},
  [6475] = {.lex_state = 249, .external_lex_state = 3},
  [6476] = {.lex_state = 249, .external_lex_state = 3},
  [6477] = {.lex_state = 249, .external_lex_state = 3},
  [6478] = {.lex_state = 192, .external_lex_state = 2},
  [6479] = {.lex_state = 256, .external_lex_state = 10},
  [6480] = {.lex_state = 256, .external_lex_state = 10},
  [6481] = {.lex_state = 256, .external_lex_state = 10},
  [6482] = {.lex_state = 256, .external_lex_state = 10},
  [6483] = {.lex_state = 192, .external_lex_state = 2},
  [6484] = {.lex_state = 192, .external_lex_state = 2},
  [6485] = {.lex_state = 426, .external_lex_state = 3},
  [6486] = {.lex_state = 256, .external_lex_state = 10},
  [6487] = {.lex_state = 213},
  [6488] = {.lex_state = 426, .external_lex_state = 3},
  [6489] = {.lex_state = 426, .external_lex_state = 14},
  [6490] = {.lex_state = 426, .external_lex_state = 3},
  [6491] = {.lex_state = 423, .external_lex_state = 3},
  [6492] = {.lex_state = 423, .external_lex_state = 14},
  [6493] = {.lex_state = 192, .external_lex_state = 2},
  [6494] = {.lex_state = 426, .external_lex_state = 3},
  [6495] = {.lex_state = 423, .external_lex_state = 3},
  [6496] = {.lex_state = 192, .external_lex_state = 2},
  [6497] = {.lex_state = 192, .external_lex_state = 2},
  [6498] = {.lex_state = 192, .external_lex_state = 2},
  [6499] = {.lex_state = 192, .external_lex_state = 2},
  [6500] = {.lex_state = 192, .external_lex_state = 2},
  [6501] = {.lex_state = 192, .external_lex_state = 2},
  [6502] = {.lex_state = 192, .external_lex_state = 2},
  [6503] = {.lex_state = 192, .external_lex_state = 2},
  [6504] = {.lex_state = 192, .external_lex_state = 2},
  [6505] = {.lex_state = 192, .external_lex_state = 2},
  [6506] = {.lex_state = 192, .external_lex_state = 2},
  [6507] = {.lex_state = 426, .external_lex_state = 3},
  [6508] = {.lex_state = 528, .external_lex_state = 29},
  [6509] = {.lex_state = 426, .external_lex_state = 3},
  [6510] = {.lex_state = 192, .external_lex_state = 28},
  [6511] = {.lex_state = 192, .external_lex_state = 2},
  [6512] = {.lex_state = 423, .external_lex_state = 14},
  [6513] = {.lex_state = 192, .external_lex_state = 2},
  [6514] = {.lex_state = 192, .external_lex_state = 2},
  [6515] = {.lex_state = 192, .external_lex_state = 2},
  [6516] = {.lex_state = 192, .external_lex_state = 2},
  [6517] = {.lex_state = 532, .external_lex_state = 3},
  [6518] = {.lex_state = 532, .external_lex_state = 3},
  [6519] = {.lex_state = 213},
  [6520] = {.lex_state = 261, .external_lex_state = 3},
  [6521] = {.lex_state = 249, .external_lex_state = 3},
  [6522] = {.lex_state = 264, .external_lex_state = 14},
  [6523] = {.lex_state = 194},
  [6524] = {.lex_state = 194},
  [6525] = {.lex_state = 471, .external_lex_state = 24},
  [6526] = {.lex_state = 471, .external_lex_state = 24},
  [6527] = {.lex_state = 471, .external_lex_state = 24},
  [6528] = {.lex_state = 471, .external_lex_state = 24},
  [6529] = {.lex_state = 192, .external_lex_state = 2},
  [6530] = {.lex_state = 192, .external_lex_state = 2},
  [6531] = {.lex_state = 192, .external_lex_state = 2},
  [6532] = {.lex_state = 192, .external_lex_state = 2},
  [6533] = {.lex_state = 192, .external_lex_state = 2},
  [6534] = {.lex_state = 192, .external_lex_state = 2},
  [6535] = {.lex_state = 192, .external_lex_state = 2},
  [6536] = {.lex_state = 192, .external_lex_state = 2},
  [6537] = {.lex_state = 192, .external_lex_state = 2},
  [6538] = {.lex_state = 192, .external_lex_state = 2},
  [6539] = {.lex_state = 192, .external_lex_state = 28},
  [6540] = {.lex_state = 192, .external_lex_state = 2},
  [6541] = {.lex_state = 471, .external_lex_state = 26},
  [6542] = {.lex_state = 471, .external_lex_state = 24},
  [6543] = {.lex_state = 595, .external_lex_state = 24},
  [6544] = {.lex_state = 595, .external_lex_state = 24},
  [6545] = {.lex_state = 192, .external_lex_state = 2},
  [6546] = {.lex_state = 595, .external_lex_state = 24},
  [6547] = {.lex_state = 192, .external_lex_state = 2},
  [6548] = {.lex_state = 595, .external_lex_state = 24},
  [6549] = {.lex_state = 528, .external_lex_state = 29},
  [6550] = {.lex_state = 595, .external_lex_state = 24},
  [6551] = {.lex_state = 471, .external_lex_state = 24},
  [6552] = {.lex_state = 595, .external_lex_state = 24},
  [6553] = {.lex_state = 595, .external_lex_state = 24},
  [6554] = {.lex_state = 595, .external_lex_state = 24},
  [6555] = {.lex_state = 595, .external_lex_state = 24},
  [6556] = {.lex_state = 595, .external_lex_state = 24},
  [6557] = {.lex_state = 561, .external_lex_state = 16},
  [6558] = {.lex_state = 595, .external_lex_state = 24},
  [6559] = {.lex_state = 595, .external_lex_state = 24},
  [6560] = {.lex_state = 595, .external_lex_state = 24},
  [6561] = {.lex_state = 595, .external_lex_state = 24},
  [6562] = {.lex_state = 580, .external_lex_state = 24},
  [6563] = {.lex_state = 580, .external_lex_state = 24},
  [6564] = {.lex_state = 192, .external_lex_state = 2},
  [6565] = {.lex_state = 580, .external_lex_state = 24},
  [6566] = {.lex_state = 192, .external_lex_state = 2},
  [6567] = {.lex_state = 580, .external_lex_state = 24},
  [6568] = {.lex_state = 528, .external_lex_state = 29},
  [6569] = {.lex_state = 580, .external_lex_state = 24},
  [6570] = {.lex_state = 446, .external_lex_state = 24},
  [6571] = {.lex_state = 528, .external_lex_state = 12},
  [6572] = {.lex_state = 446, .external_lex_state = 24},
  [6573] = {.lex_state = 471, .external_lex_state = 24},
  [6574] = {.lex_state = 595, .external_lex_state = 24},
  [6575] = {.lex_state = 595, .external_lex_state = 24},
  [6576] = {.lex_state = 595, .external_lex_state = 24},
  [6577] = {.lex_state = 668, .external_lex_state = 26},
  [6578] = {.lex_state = 239},
  [6579] = {.lex_state = 239},
  [6580] = {.lex_state = 192, .external_lex_state = 2},
  [6581] = {.lex_state = 586, .external_lex_state = 18},
  [6582] = {.lex_state = 209},
  [6583] = {.lex_state = 586, .external_lex_state = 18},
  [6584] = {.lex_state = 435, .external_lex_state = 16},
  [6585] = {.lex_state = 465, .external_lex_state = 26},
  [6586] = {.lex_state = 192, .external_lex_state = 15},
  [6587] = {.lex_state = 465, .external_lex_state = 24},
  [6588] = {.lex_state = 192, .external_lex_state = 15},
  [6589] = {.lex_state = 465, .external_lex_state = 24},
  [6590] = {.lex_state = 192, .external_lex_state = 15},
  [6591] = {.lex_state = 465, .external_lex_state = 24},
  [6592] = {.lex_state = 192, .external_lex_state = 15},
  [6593] = {.lex_state = 465, .external_lex_state = 24},
  [6594] = {.lex_state = 190, .external_lex_state = 4},
  [6595] = {.lex_state = 268, .external_lex_state = 15},
  [6596] = {.lex_state = 465, .external_lex_state = 24},
  [6597] = {.lex_state = 190, .external_lex_state = 4},
  [6598] = {.lex_state = 268, .external_lex_state = 15},
  [6599] = {.lex_state = 443, .external_lex_state = 24},
  [6600] = {.lex_state = 465, .external_lex_state = 24},
  [6601] = {.lex_state = 194},
  [6602] = {.lex_state = 194, .external_lex_state = 19},
  [6603] = {.lex_state = 192, .external_lex_state = 2},
  [6604] = {.lex_state = 465, .external_lex_state = 24},
  [6605] = {.lex_state = 312},
  [6606] = {.lex_state = 312, .external_lex_state = 13},
  [6607] = {.lex_state = 465, .external_lex_state = 24},
  [6608] = {.lex_state = 209},
  [6609] = {.lex_state = 192, .external_lex_state = 2},
  [6610] = {.lex_state = 348, .external_lex_state = 22},
  [6611] = {.lex_state = 348, .external_lex_state = 22},
  [6612] = {.lex_state = 352, .external_lex_state = 22},
  [6613] = {.lex_state = 352, .external_lex_state = 22},
  [6614] = {.lex_state = 465, .external_lex_state = 24},
  [6615] = {.lex_state = 465, .external_lex_state = 24},
  [6616] = {.lex_state = 465, .external_lex_state = 24},
  [6617] = {.lex_state = 465, .external_lex_state = 24},
  [6618] = {.lex_state = 128, .external_lex_state = 13},
  [6619] = {.lex_state = 128, .external_lex_state = 13},
  [6620] = {.lex_state = 249, .external_lex_state = 3},
  [6621] = {.lex_state = 249, .external_lex_state = 3},
  [6622] = {.lex_state = 128},
  [6623] = {.lex_state = 249, .external_lex_state = 3},
  [6624] = {.lex_state = 128},
  [6625] = {.lex_state = 128},
  [6626] = {.lex_state = 128},
  [6627] = {.lex_state = 128},
  [6628] = {.lex_state = 128},
  [6629] = {.lex_state = 465, .external_lex_state = 24},
  [6630] = {.lex_state = 128, .external_lex_state = 2},
  [6631] = {.lex_state = 443, .external_lex_state = 24},
  [6632] = {.lex_state = 465, .external_lex_state = 24},
  [6633] = {.lex_state = 465, .external_lex_state = 24},
  [6634] = {.lex_state = 465, .external_lex_state = 24},
  [6635] = {.lex_state = 237},
  [6636] = {.lex_state = 128},
  [6637] = {.lex_state = 465, .external_lex_state = 24},
  [6638] = {.lex_state = 192, .external_lex_state = 2},
  [6639] = {.lex_state = 192, .external_lex_state = 2},
  [6640] = {.lex_state = 192, .external_lex_state = 2},
  [6641] = {.lex_state = 192, .external_lex_state = 2},
  [6642] = {.lex_state = 192, .external_lex_state = 2},
  [6643] = {.lex_state = 192, .external_lex_state = 2},
  [6644] = {.lex_state = 192, .external_lex_state = 2},
  [6645] = {.lex_state = 192, .external_lex_state = 2},
  [6646] = {.lex_state = 192, .external_lex_state = 2},
  [6647] = {.lex_state = 192, .external_lex_state = 2},
  [6648] = {.lex_state = 192, .external_lex_state = 28},
  [6649] = {.lex_state = 192, .external_lex_state = 2},
  [6650] = {.lex_state = 443, .external_lex_state = 26},
  [6651] = {.lex_state = 443, .external_lex_state = 24},
  [6652] = {.lex_state = 435, .external_lex_state = 16},
  [6653] = {.lex_state = 194},
  [6654] = {.lex_state = 435, .external_lex_state = 16},
  [6655] = {.lex_state = 128},
  [6656] = {.lex_state = 128, .external_lex_state = 2},
  [6657] = {.lex_state = 128, .external_lex_state = 11},
  [6658] = {.lex_state = 465, .external_lex_state = 24},
  [6659] = {.lex_state = 443, .external_lex_state = 24},
  [6660] = {.lex_state = 580, .external_lex_state = 24},
  [6661] = {.lex_state = 580, .external_lex_state = 24},
  [6662] = {.lex_state = 580, .external_lex_state = 24},
  [6663] = {.lex_state = 580, .external_lex_state = 24},
  [6664] = {.lex_state = 580, .external_lex_state = 24},
  [6665] = {.lex_state = 561, .external_lex_state = 16},
  [6666] = {.lex_state = 580, .external_lex_state = 24},
  [6667] = {.lex_state = 580, .external_lex_state = 24},
  [6668] = {.lex_state = 580, .external_lex_state = 24},
  [6669] = {.lex_state = 580, .external_lex_state = 24},
  [6670] = {.lex_state = 435, .external_lex_state = 16},
  [6671] = {.lex_state = 465, .external_lex_state = 24},
  [6672] = {.lex_state = 177, .external_lex_state = 17},
  [6673] = {.lex_state = 443, .external_lex_state = 24},
  [6674] = {.lex_state = 465, .external_lex_state = 24},
  [6675] = {.lex_state = 528, .external_lex_state = 12},
  [6676] = {.lex_state = 443, .external_lex_state = 24},
  [6677] = {.lex_state = 443, .external_lex_state = 24},
  [6678] = {.lex_state = 580, .external_lex_state = 24},
  [6679] = {.lex_state = 580, .external_lex_state = 24},
  [6680] = {.lex_state = 580, .external_lex_state = 24},
  [6681] = {.lex_state = 669, .external_lex_state = 26},
  [6682] = {.lex_state = 438, .external_lex_state = 16},
  [6683] = {.lex_state = 438, .external_lex_state = 16},
  [6684] = {.lex_state = 438, .external_lex_state = 16},
  [6685] = {.lex_state = 192, .external_lex_state = 2},
  [6686] = {.lex_state = 192, .external_lex_state = 2},
  [6687] = {.lex_state = 192, .external_lex_state = 2},
  [6688] = {.lex_state = 192, .external_lex_state = 2},
  [6689] = {.lex_state = 192, .external_lex_state = 2},
  [6690] = {.lex_state = 192, .external_lex_state = 2},
  [6691] = {.lex_state = 192, .external_lex_state = 2},
  [6692] = {.lex_state = 192, .external_lex_state = 2},
  [6693] = {.lex_state = 192, .external_lex_state = 2},
  [6694] = {.lex_state = 192, .external_lex_state = 2},
  [6695] = {.lex_state = 192, .external_lex_state = 28},
  [6696] = {.lex_state = 438, .external_lex_state = 16},
  [6697] = {.lex_state = 192, .external_lex_state = 28},
  [6698] = {.lex_state = 192, .external_lex_state = 2},
  [6699] = {.lex_state = 471, .external_lex_state = 20},
  [6700] = {.lex_state = 156, .external_lex_state = 3},
  [6701] = {.lex_state = 156, .external_lex_state = 3},
  [6702] = {.lex_state = 471, .external_lex_state = 3},
  [6703] = {.lex_state = 471, .external_lex_state = 3},
  [6704] = {.lex_state = 471, .external_lex_state = 3},
  [6705] = {.lex_state = 471, .external_lex_state = 3},
  [6706] = {.lex_state = 192, .external_lex_state = 2},
  [6707] = {.lex_state = 192, .external_lex_state = 2},
  [6708] = {.lex_state = 192, .external_lex_state = 2},
  [6709] = {.lex_state = 192, .external_lex_state = 2},
  [6710] = {.lex_state = 192, .external_lex_state = 2},
  [6711] = {.lex_state = 192, .external_lex_state = 2},
  [6712] = {.lex_state = 192, .external_lex_state = 2},
  [6713] = {.lex_state = 192, .external_lex_state = 2},
  [6714] = {.lex_state = 192, .external_lex_state = 2},
  [6715] = {.lex_state = 192, .external_lex_state = 2},
  [6716] = {.lex_state = 192, .external_lex_state = 28},
  [6717] = {.lex_state = 192, .external_lex_state = 2},
  [6718] = {.lex_state = 471, .external_lex_state = 14},
  [6719] = {.lex_state = 471, .external_lex_state = 3},
  [6720] = {.lex_state = 595, .external_lex_state = 3},
  [6721] = {.lex_state = 595, .external_lex_state = 3},
  [6722] = {.lex_state = 471, .external_lex_state = 3},
  [6723] = {.lex_state = 595, .external_lex_state = 3},
  [6724] = {.lex_state = 595, .external_lex_state = 3},
  [6725] = {.lex_state = 595, .external_lex_state = 3},
  [6726] = {.lex_state = 595, .external_lex_state = 3},
  [6727] = {.lex_state = 595, .external_lex_state = 3},
  [6728] = {.lex_state = 561, .external_lex_state = 16},
  [6729] = {.lex_state = 595, .external_lex_state = 3},
  [6730] = {.lex_state = 595, .external_lex_state = 3},
  [6731] = {.lex_state = 595, .external_lex_state = 3},
  [6732] = {.lex_state = 595, .external_lex_state = 3},
  [6733] = {.lex_state = 446, .external_lex_state = 3},
  [6734] = {.lex_state = 528, .external_lex_state = 12},
  [6735] = {.lex_state = 446, .external_lex_state = 3},
  [6736] = {.lex_state = 471, .external_lex_state = 3},
  [6737] = {.lex_state = 595, .external_lex_state = 3},
  [6738] = {.lex_state = 595, .external_lex_state = 3},
  [6739] = {.lex_state = 595, .external_lex_state = 3},
  [6740] = {.lex_state = 668, .external_lex_state = 14},
  [6741] = {.lex_state = 239, .external_lex_state = 13},
  [6742] = {.lex_state = 192, .external_lex_state = 2},
  [6743] = {.lex_state = 443, .external_lex_state = 3},
  [6744] = {.lex_state = 443, .external_lex_state = 3},
  [6745] = {.lex_state = 192, .external_lex_state = 2},
  [6746] = {.lex_state = 192, .external_lex_state = 2},
  [6747] = {.lex_state = 192, .external_lex_state = 2},
  [6748] = {.lex_state = 192, .external_lex_state = 2},
  [6749] = {.lex_state = 192, .external_lex_state = 2},
  [6750] = {.lex_state = 192, .external_lex_state = 2},
  [6751] = {.lex_state = 192, .external_lex_state = 2},
  [6752] = {.lex_state = 192, .external_lex_state = 2},
  [6753] = {.lex_state = 192, .external_lex_state = 2},
  [6754] = {.lex_state = 192, .external_lex_state = 2},
  [6755] = {.lex_state = 192, .external_lex_state = 28},
  [6756] = {.lex_state = 192, .external_lex_state = 2},
  [6757] = {.lex_state = 443, .external_lex_state = 14},
  [6758] = {.lex_state = 443, .external_lex_state = 3},
  [6759] = {.lex_state = 443, .external_lex_state = 3},
  [6760] = {.lex_state = 580, .external_lex_state = 3},
  [6761] = {.lex_state = 580, .external_lex_state = 3},
  [6762] = {.lex_state = 580, .external_lex_state = 3},
  [6763] = {.lex_state = 580, .external_lex_state = 3},
  [6764] = {.lex_state = 580, .external_lex_state = 3},
  [6765] = {.lex_state = 561, .external_lex_state = 16},
  [6766] = {.lex_state = 580, .external_lex_state = 3},
  [6767] = {.lex_state = 580, .external_lex_state = 3},
  [6768] = {.lex_state = 580, .external_lex_state = 3},
  [6769] = {.lex_state = 580, .external_lex_state = 3},
  [6770] = {.lex_state = 443, .external_lex_state = 3},
  [6771] = {.lex_state = 528, .external_lex_state = 12},
  [6772] = {.lex_state = 443, .external_lex_state = 3},
  [6773] = {.lex_state = 443, .external_lex_state = 3},
  [6774] = {.lex_state = 580, .external_lex_state = 3},
  [6775] = {.lex_state = 580, .external_lex_state = 3},
  [6776] = {.lex_state = 580, .external_lex_state = 3},
  [6777] = {.lex_state = 669, .external_lex_state = 14},
  [6778] = {.lex_state = 438, .external_lex_state = 3},
  [6779] = {.lex_state = 438, .external_lex_state = 3},
  [6780] = {.lex_state = 438, .external_lex_state = 3},
  [6781] = {.lex_state = 192, .external_lex_state = 2},
  [6782] = {.lex_state = 192, .external_lex_state = 2},
  [6783] = {.lex_state = 192, .external_lex_state = 2},
  [6784] = {.lex_state = 192, .external_lex_state = 2},
  [6785] = {.lex_state = 192, .external_lex_state = 2},
  [6786] = {.lex_state = 192, .external_lex_state = 2},
  [6787] = {.lex_state = 192, .external_lex_state = 2},
  [6788] = {.lex_state = 192, .external_lex_state = 2},
  [6789] = {.lex_state = 192, .external_lex_state = 2},
  [6790] = {.lex_state = 192, .external_lex_state = 2},
  [6791] = {.lex_state = 192, .external_lex_state = 28},
  [6792] = {.lex_state = 438, .external_lex_state = 3},
  [6793] = {.lex_state = 192, .external_lex_state = 28},
  [6794] = {.lex_state = 192, .external_lex_state = 2},
  [6795] = {.lex_state = 290, .external_lex_state = 16},
  [6796] = {.lex_state = 177, .external_lex_state = 4},
  [6797] = {.lex_state = 290, .external_lex_state = 16},
  [6798] = {.lex_state = 290, .external_lex_state = 16},
  [6799] = {.lex_state = 177, .external_lex_state = 4},
  [6800] = {.lex_state = 290, .external_lex_state = 16},
  [6801] = {.lex_state = 227, .external_lex_state = 7},
  [6802] = {.lex_state = 471, .external_lex_state = 24},
  [6803] = {.lex_state = 471, .external_lex_state = 24},
  [6804] = {.lex_state = 192, .external_lex_state = 2},
  [6805] = {.lex_state = 192, .external_lex_state = 2},
  [6806] = {.lex_state = 192, .external_lex_state = 2},
  [6807] = {.lex_state = 192, .external_lex_state = 2},
  [6808] = {.lex_state = 192, .external_lex_state = 2},
  [6809] = {.lex_state = 192, .external_lex_state = 2},
  [6810] = {.lex_state = 192, .external_lex_state = 2},
  [6811] = {.lex_state = 192, .external_lex_state = 2},
  [6812] = {.lex_state = 192, .external_lex_state = 2},
  [6813] = {.lex_state = 192, .external_lex_state = 2},
  [6814] = {.lex_state = 192, .external_lex_state = 28},
  [6815] = {.lex_state = 192, .external_lex_state = 2},
  [6816] = {.lex_state = 471, .external_lex_state = 24},
  [6817] = {.lex_state = 595, .external_lex_state = 24},
  [6818] = {.lex_state = 595, .external_lex_state = 24},
  [6819] = {.lex_state = 192, .external_lex_state = 2},
  [6820] = {.lex_state = 595, .external_lex_state = 24},
  [6821] = {.lex_state = 192, .external_lex_state = 2},
  [6822] = {.lex_state = 595, .external_lex_state = 24},
  [6823] = {.lex_state = 528, .external_lex_state = 29},
  [6824] = {.lex_state = 595, .external_lex_state = 24},
  [6825] = {.lex_state = 471, .external_lex_state = 24},
  [6826] = {.lex_state = 595, .external_lex_state = 24},
  [6827] = {.lex_state = 595, .external_lex_state = 24},
  [6828] = {.lex_state = 595, .external_lex_state = 24},
  [6829] = {.lex_state = 595, .external_lex_state = 24},
  [6830] = {.lex_state = 595, .external_lex_state = 24},
  [6831] = {.lex_state = 561, .external_lex_state = 16},
  [6832] = {.lex_state = 595, .external_lex_state = 24},
  [6833] = {.lex_state = 595, .external_lex_state = 24},
  [6834] = {.lex_state = 595, .external_lex_state = 24},
  [6835] = {.lex_state = 595, .external_lex_state = 24},
  [6836] = {.lex_state = 580, .external_lex_state = 24},
  [6837] = {.lex_state = 580, .external_lex_state = 24},
  [6838] = {.lex_state = 192, .external_lex_state = 2},
  [6839] = {.lex_state = 580, .external_lex_state = 24},
  [6840] = {.lex_state = 192, .external_lex_state = 2},
  [6841] = {.lex_state = 580, .external_lex_state = 24},
  [6842] = {.lex_state = 528, .external_lex_state = 29},
  [6843] = {.lex_state = 580, .external_lex_state = 24},
  [6844] = {.lex_state = 471, .external_lex_state = 24},
  [6845] = {.lex_state = 528, .external_lex_state = 12},
  [6846] = {.lex_state = 471, .external_lex_state = 24},
  [6847] = {.lex_state = 471, .external_lex_state = 24},
  [6848] = {.lex_state = 595, .external_lex_state = 24},
  [6849] = {.lex_state = 595, .external_lex_state = 24},
  [6850] = {.lex_state = 595, .external_lex_state = 24},
  [6851] = {.lex_state = 668, .external_lex_state = 26},
  [6852] = {.lex_state = 192, .external_lex_state = 2},
  [6853] = {.lex_state = 602, .external_lex_state = 25},
  [6854] = {.lex_state = 209},
  [6855] = {.lex_state = 602, .external_lex_state = 25},
  [6856] = {.lex_state = 465, .external_lex_state = 24},
  [6857] = {.lex_state = 443, .external_lex_state = 24},
  [6858] = {.lex_state = 443, .external_lex_state = 24},
  [6859] = {.lex_state = 192, .external_lex_state = 2},
  [6860] = {.lex_state = 192, .external_lex_state = 2},
  [6861] = {.lex_state = 192, .external_lex_state = 2},
  [6862] = {.lex_state = 192, .external_lex_state = 2},
  [6863] = {.lex_state = 192, .external_lex_state = 2},
  [6864] = {.lex_state = 192, .external_lex_state = 2},
  [6865] = {.lex_state = 192, .external_lex_state = 2},
  [6866] = {.lex_state = 192, .external_lex_state = 2},
  [6867] = {.lex_state = 192, .external_lex_state = 2},
  [6868] = {.lex_state = 192, .external_lex_state = 2},
  [6869] = {.lex_state = 192, .external_lex_state = 28},
  [6870] = {.lex_state = 192, .external_lex_state = 2},
  [6871] = {.lex_state = 443, .external_lex_state = 26},
  [6872] = {.lex_state = 443, .external_lex_state = 24},
  [6873] = {.lex_state = 465, .external_lex_state = 24},
  [6874] = {.lex_state = 194},
  [6875] = {.lex_state = 465, .external_lex_state = 24},
  [6876] = {.lex_state = 128},
  [6877] = {.lex_state = 128, .external_lex_state = 2},
  [6878] = {.lex_state = 128, .external_lex_state = 11},
  [6879] = {.lex_state = 443, .external_lex_state = 24},
  [6880] = {.lex_state = 580, .external_lex_state = 24},
  [6881] = {.lex_state = 580, .external_lex_state = 24},
  [6882] = {.lex_state = 580, .external_lex_state = 24},
  [6883] = {.lex_state = 580, .external_lex_state = 24},
  [6884] = {.lex_state = 580, .external_lex_state = 24},
  [6885] = {.lex_state = 561, .external_lex_state = 16},
  [6886] = {.lex_state = 580, .external_lex_state = 24},
  [6887] = {.lex_state = 580, .external_lex_state = 24},
  [6888] = {.lex_state = 580, .external_lex_state = 24},
  [6889] = {.lex_state = 580, .external_lex_state = 24},
  [6890] = {.lex_state = 465, .external_lex_state = 24},
  [6891] = {.lex_state = 443, .external_lex_state = 24},
  [6892] = {.lex_state = 528, .external_lex_state = 12},
  [6893] = {.lex_state = 443, .external_lex_state = 24},
  [6894] = {.lex_state = 443, .external_lex_state = 24},
  [6895] = {.lex_state = 580, .external_lex_state = 24},
  [6896] = {.lex_state = 580, .external_lex_state = 24},
  [6897] = {.lex_state = 580, .external_lex_state = 24},
  [6898] = {.lex_state = 669, .external_lex_state = 26},
  [6899] = {.lex_state = 438, .external_lex_state = 24},
  [6900] = {.lex_state = 192, .external_lex_state = 28},
  [6901] = {.lex_state = 438, .external_lex_state = 24},
  [6902] = {.lex_state = 290, .external_lex_state = 16},
  [6903] = {.lex_state = 290, .external_lex_state = 16},
  [6904] = {.lex_state = 363, .external_lex_state = 24},
  [6905] = {.lex_state = 363, .external_lex_state = 24},
  [6906] = {.lex_state = 192, .external_lex_state = 2},
  [6907] = {.lex_state = 390, .external_lex_state = 24},
  [6908] = {.lex_state = 390, .external_lex_state = 24},
  [6909] = {.lex_state = 192, .external_lex_state = 28},
  [6910] = {.lex_state = 363, .external_lex_state = 24},
  [6911] = {.lex_state = 290, .external_lex_state = 16},
  [6912] = {.lex_state = 290, .external_lex_state = 16},
  [6913] = {.lex_state = 290, .external_lex_state = 16},
  [6914] = {.lex_state = 290, .external_lex_state = 16},
  [6915] = {.lex_state = 290, .external_lex_state = 16},
  [6916] = {.lex_state = 128},
  [6917] = {.lex_state = 290, .external_lex_state = 16},
  [6918] = {.lex_state = 128},
  [6919] = {.lex_state = 128},
  [6920] = {.lex_state = 290, .external_lex_state = 16},
  [6921] = {.lex_state = 128},
  [6922] = {.lex_state = 290, .external_lex_state = 16},
  [6923] = {.lex_state = 290, .external_lex_state = 16},
  [6924] = {.lex_state = 128},
  [6925] = {.lex_state = 128, .external_lex_state = 2},
  [6926] = {.lex_state = 304, .external_lex_state = 16},
  [6927] = {.lex_state = 306, .external_lex_state = 18},
  [6928] = {.lex_state = 399, .external_lex_state = 24},
  [6929] = {.lex_state = 399, .external_lex_state = 24},
  [6930] = {.lex_state = 177, .external_lex_state = 4},
  [6931] = {.lex_state = 268, .external_lex_state = 15},
  [6932] = {.lex_state = 399, .external_lex_state = 24},
  [6933] = {.lex_state = 177, .external_lex_state = 4},
  [6934] = {.lex_state = 399, .external_lex_state = 24},
  [6935] = {.lex_state = 399, .external_lex_state = 24},
  [6936] = {.lex_state = 177, .external_lex_state = 4},
  [6937] = {.lex_state = 268, .external_lex_state = 15},
  [6938] = {.lex_state = 399, .external_lex_state = 24},
  [6939] = {.lex_state = 177, .external_lex_state = 4},
  [6940] = {.lex_state = 301, .external_lex_state = 16},
  [6941] = {.lex_state = 399, .external_lex_state = 24},
  [6942] = {.lex_state = 312},
  [6943] = {.lex_state = 399, .external_lex_state = 24},
  [6944] = {.lex_state = 399, .external_lex_state = 24},
  [6945] = {.lex_state = 128, .external_lex_state = 2},
  [6946] = {.lex_state = 128, .external_lex_state = 2},
  [6947] = {.lex_state = 399, .external_lex_state = 24},
  [6948] = {.lex_state = 399, .external_lex_state = 24},
  [6949] = {.lex_state = 399, .external_lex_state = 24},
  [6950] = {.lex_state = 128},
  [6951] = {.lex_state = 399, .external_lex_state = 24},
  [6952] = {.lex_state = 128},
  [6953] = {.lex_state = 399, .external_lex_state = 24},
  [6954] = {.lex_state = 128},
  [6955] = {.lex_state = 399, .external_lex_state = 24},
  [6956] = {.lex_state = 128},
  [6957] = {.lex_state = 128, .external_lex_state = 2},
  [6958] = {.lex_state = 301, .external_lex_state = 16},
  [6959] = {.lex_state = 128},
  [6960] = {.lex_state = 128, .external_lex_state = 2},
  [6961] = {.lex_state = 399, .external_lex_state = 24},
  [6962] = {.lex_state = 128},
  [6963] = {.lex_state = 128},
  [6964] = {.lex_state = 128},
  [6965] = {.lex_state = 399, .external_lex_state = 24},
  [6966] = {.lex_state = 128},
  [6967] = {.lex_state = 128},
  [6968] = {.lex_state = 192, .external_lex_state = 2},
  [6969] = {.lex_state = 399, .external_lex_state = 24},
  [6970] = {.lex_state = 399, .external_lex_state = 24},
  [6971] = {.lex_state = 192, .external_lex_state = 28},
  [6972] = {.lex_state = 423, .external_lex_state = 24},
  [6973] = {.lex_state = 304, .external_lex_state = 16},
  [6974] = {.lex_state = 304, .external_lex_state = 16},
  [6975] = {.lex_state = 304, .external_lex_state = 16},
  [6976] = {.lex_state = 304, .external_lex_state = 16},
  [6977] = {.lex_state = 304, .external_lex_state = 16},
  [6978] = {.lex_state = 561, .external_lex_state = 16},
  [6979] = {.lex_state = 304, .external_lex_state = 16},
  [6980] = {.lex_state = 304, .external_lex_state = 16},
  [6981] = {.lex_state = 304, .external_lex_state = 16},
  [6982] = {.lex_state = 304, .external_lex_state = 16},
  [6983] = {.lex_state = 477, .external_lex_state = 16},
  [6984] = {.lex_state = 304, .external_lex_state = 16},
  [6985] = {.lex_state = 304, .external_lex_state = 16},
  [6986] = {.lex_state = 304, .external_lex_state = 16},
  [6987] = {.lex_state = 156, .external_lex_state = 20},
  [6988] = {.lex_state = 194, .external_lex_state = 6},
  [6989] = {.lex_state = 497, .external_lex_state = 24},
  [6990] = {.lex_state = 497, .external_lex_state = 24},
  [6991] = {.lex_state = 192, .external_lex_state = 2},
  [6992] = {.lex_state = 192, .external_lex_state = 2},
  [6993] = {.lex_state = 192, .external_lex_state = 2},
  [6994] = {.lex_state = 192, .external_lex_state = 2},
  [6995] = {.lex_state = 192, .external_lex_state = 2},
  [6996] = {.lex_state = 192, .external_lex_state = 2},
  [6997] = {.lex_state = 192, .external_lex_state = 2},
  [6998] = {.lex_state = 192, .external_lex_state = 2},
  [6999] = {.lex_state = 192, .external_lex_state = 2},
  [7000] = {.lex_state = 192, .external_lex_state = 2},
  [7001] = {.lex_state = 192, .external_lex_state = 28},
  [7002] = {.lex_state = 192, .external_lex_state = 2},
  [7003] = {.lex_state = 497, .external_lex_state = 24},
  [7004] = {.lex_state = 497, .external_lex_state = 24},
  [7005] = {.lex_state = 497, .external_lex_state = 24},
  [7006] = {.lex_state = 497, .external_lex_state = 24},
  [7007] = {.lex_state = 497, .external_lex_state = 24},
  [7008] = {.lex_state = 497, .external_lex_state = 24},
  [7009] = {.lex_state = 497, .external_lex_state = 24},
  [7010] = {.lex_state = 561, .external_lex_state = 16},
  [7011] = {.lex_state = 497, .external_lex_state = 24},
  [7012] = {.lex_state = 497, .external_lex_state = 24},
  [7013] = {.lex_state = 497, .external_lex_state = 24},
  [7014] = {.lex_state = 497, .external_lex_state = 24},
  [7015] = {.lex_state = 326, .external_lex_state = 24},
  [7016] = {.lex_state = 528, .external_lex_state = 12},
  [7017] = {.lex_state = 326, .external_lex_state = 24},
  [7018] = {.lex_state = 497, .external_lex_state = 24},
  [7019] = {.lex_state = 497, .external_lex_state = 24},
  [7020] = {.lex_state = 497, .external_lex_state = 24},
  [7021] = {.lex_state = 497, .external_lex_state = 24},
  [7022] = {.lex_state = 156, .external_lex_state = 3},
  [7023] = {.lex_state = 192, .external_lex_state = 2},
  [7024] = {.lex_state = 323, .external_lex_state = 24},
  [7025] = {.lex_state = 323, .external_lex_state = 24},
  [7026] = {.lex_state = 192, .external_lex_state = 2},
  [7027] = {.lex_state = 192, .external_lex_state = 2},
  [7028] = {.lex_state = 192, .external_lex_state = 2},
  [7029] = {.lex_state = 192, .external_lex_state = 2},
  [7030] = {.lex_state = 192, .external_lex_state = 2},
  [7031] = {.lex_state = 192, .external_lex_state = 2},
  [7032] = {.lex_state = 192, .external_lex_state = 2},
  [7033] = {.lex_state = 192, .external_lex_state = 2},
  [7034] = {.lex_state = 192, .external_lex_state = 2},
  [7035] = {.lex_state = 192, .external_lex_state = 2},
  [7036] = {.lex_state = 192, .external_lex_state = 28},
  [7037] = {.lex_state = 192, .external_lex_state = 2},
  [7038] = {.lex_state = 323, .external_lex_state = 26},
  [7039] = {.lex_state = 323, .external_lex_state = 24},
  [7040] = {.lex_state = 323, .external_lex_state = 24},
  [7041] = {.lex_state = 501, .external_lex_state = 24},
  [7042] = {.lex_state = 501, .external_lex_state = 24},
  [7043] = {.lex_state = 501, .external_lex_state = 24},
  [7044] = {.lex_state = 501, .external_lex_state = 24},
  [7045] = {.lex_state = 501, .external_lex_state = 24},
  [7046] = {.lex_state = 561, .external_lex_state = 16},
  [7047] = {.lex_state = 501, .external_lex_state = 24},
  [7048] = {.lex_state = 501, .external_lex_state = 24},
  [7049] = {.lex_state = 501, .external_lex_state = 24},
  [7050] = {.lex_state = 501, .external_lex_state = 24},
  [7051] = {.lex_state = 323, .external_lex_state = 24},
  [7052] = {.lex_state = 528, .external_lex_state = 12},
  [7053] = {.lex_state = 323, .external_lex_state = 24},
  [7054] = {.lex_state = 323, .external_lex_state = 24},
  [7055] = {.lex_state = 501, .external_lex_state = 24},
  [7056] = {.lex_state = 501, .external_lex_state = 24},
  [7057] = {.lex_state = 501, .external_lex_state = 24},
  [7058] = {.lex_state = 621, .external_lex_state = 26},
  [7059] = {.lex_state = 304, .external_lex_state = 16},
  [7060] = {.lex_state = 304, .external_lex_state = 16},
  [7061] = {.lex_state = 304, .external_lex_state = 16},
  [7062] = {.lex_state = 192, .external_lex_state = 2},
  [7063] = {.lex_state = 192, .external_lex_state = 2},
  [7064] = {.lex_state = 192, .external_lex_state = 2},
  [7065] = {.lex_state = 192, .external_lex_state = 2},
  [7066] = {.lex_state = 192, .external_lex_state = 2},
  [7067] = {.lex_state = 192, .external_lex_state = 2},
  [7068] = {.lex_state = 192, .external_lex_state = 2},
  [7069] = {.lex_state = 192, .external_lex_state = 2},
  [7070] = {.lex_state = 192, .external_lex_state = 2},
  [7071] = {.lex_state = 192, .external_lex_state = 2},
  [7072] = {.lex_state = 192, .external_lex_state = 28},
  [7073] = {.lex_state = 304, .external_lex_state = 16},
  [7074] = {.lex_state = 192, .external_lex_state = 28},
  [7075] = {.lex_state = 192, .external_lex_state = 2},
  [7076] = {.lex_state = 617, .external_lex_state = 20},
  [7077] = {.lex_state = 128, .external_lex_state = 2},
  [7078] = {.lex_state = 128, .external_lex_state = 11},
  [7079] = {.lex_state = 685, .external_lex_state = 13},
  [7080] = {.lex_state = 194},
  [7081] = {.lex_state = 288, .external_lex_state = 2},
  [7082] = {.lex_state = 685, .external_lex_state = 13},
  [7083] = {.lex_state = 128},
  [7084] = {.lex_state = 128, .external_lex_state = 11},
  [7085] = {.lex_state = 416, .external_lex_state = 2},
  [7086] = {.lex_state = 256, .external_lex_state = 13},
  [7087] = {.lex_state = 304},
  [7088] = {.lex_state = 197},
  [7089] = {.lex_state = 256, .external_lex_state = 13},
  [7090] = {.lex_state = 628, .external_lex_state = 24},
  [7091] = {.lex_state = 192, .external_lex_state = 2},
  [7092] = {.lex_state = 192, .external_lex_state = 2},
  [7093] = {.lex_state = 239},
  [7094] = {.lex_state = 192, .external_lex_state = 2},
  [7095] = {.lex_state = 524, .external_lex_state = 25},
  [7096] = {.lex_state = 611, .external_lex_state = 24},
  [7097] = {.lex_state = 628, .external_lex_state = 24},
  [7098] = {.lex_state = 628, .external_lex_state = 24},
  [7099] = {.lex_state = 611, .external_lex_state = 26},
  [7100] = {.lex_state = 628, .external_lex_state = 24},
  [7101] = {.lex_state = 192, .external_lex_state = 2},
  [7102] = {.lex_state = 192, .external_lex_state = 2},
  [7103] = {.lex_state = 192, .external_lex_state = 2},
  [7104] = {.lex_state = 192, .external_lex_state = 2},
  [7105] = {.lex_state = 192, .external_lex_state = 2},
  [7106] = {.lex_state = 192, .external_lex_state = 2},
  [7107] = {.lex_state = 192, .external_lex_state = 2},
  [7108] = {.lex_state = 192, .external_lex_state = 2},
  [7109] = {.lex_state = 192, .external_lex_state = 2},
  [7110] = {.lex_state = 192, .external_lex_state = 2},
  [7111] = {.lex_state = 192, .external_lex_state = 28},
  [7112] = {.lex_state = 192, .external_lex_state = 2},
  [7113] = {.lex_state = 628, .external_lex_state = 26},
  [7114] = {.lex_state = 628, .external_lex_state = 24},
  [7115] = {.lex_state = 611, .external_lex_state = 24},
  [7116] = {.lex_state = 611, .external_lex_state = 24},
  [7117] = {.lex_state = 192, .external_lex_state = 2},
  [7118] = {.lex_state = 611, .external_lex_state = 24},
  [7119] = {.lex_state = 192, .external_lex_state = 2},
  [7120] = {.lex_state = 611, .external_lex_state = 24},
  [7121] = {.lex_state = 528, .external_lex_state = 29},
  [7122] = {.lex_state = 611, .external_lex_state = 24},
  [7123] = {.lex_state = 628, .external_lex_state = 24},
  [7124] = {.lex_state = 611, .external_lex_state = 24},
  [7125] = {.lex_state = 611, .external_lex_state = 24},
  [7126] = {.lex_state = 611, .external_lex_state = 24},
  [7127] = {.lex_state = 611, .external_lex_state = 24},
  [7128] = {.lex_state = 611, .external_lex_state = 24},
  [7129] = {.lex_state = 561, .external_lex_state = 16},
  [7130] = {.lex_state = 611, .external_lex_state = 24},
  [7131] = {.lex_state = 611, .external_lex_state = 24},
  [7132] = {.lex_state = 611, .external_lex_state = 24},
  [7133] = {.lex_state = 611, .external_lex_state = 24},
  [7134] = {.lex_state = 339, .external_lex_state = 19},
  [7135] = {.lex_state = 528, .external_lex_state = 12},
  [7136] = {.lex_state = 339, .external_lex_state = 19},
  [7137] = {.lex_state = 339, .external_lex_state = 19},
  [7138] = {.lex_state = 611, .external_lex_state = 24},
  [7139] = {.lex_state = 611, .external_lex_state = 24},
  [7140] = {.lex_state = 611, .external_lex_state = 24},
  [7141] = {.lex_state = 679, .external_lex_state = 26},
  [7142] = {.lex_state = 497, .external_lex_state = 3},
  [7143] = {.lex_state = 497, .external_lex_state = 3},
  [7144] = {.lex_state = 497, .external_lex_state = 3},
  [7145] = {.lex_state = 497, .external_lex_state = 3},
  [7146] = {.lex_state = 497, .external_lex_state = 3},
  [7147] = {.lex_state = 497, .external_lex_state = 3},
  [7148] = {.lex_state = 497, .external_lex_state = 3},
  [7149] = {.lex_state = 561, .external_lex_state = 16},
  [7150] = {.lex_state = 497, .external_lex_state = 3},
  [7151] = {.lex_state = 497, .external_lex_state = 3},
  [7152] = {.lex_state = 497, .external_lex_state = 3},
  [7153] = {.lex_state = 497, .external_lex_state = 3},
  [7154] = {.lex_state = 497, .external_lex_state = 3},
  [7155] = {.lex_state = 497, .external_lex_state = 3},
  [7156] = {.lex_state = 497, .external_lex_state = 3},
  [7157] = {.lex_state = 617, .external_lex_state = 14},
  [7158] = {.lex_state = 497, .external_lex_state = 3},
  [7159] = {.lex_state = 497, .external_lex_state = 3},
  [7160] = {.lex_state = 497, .external_lex_state = 3},
  [7161] = {.lex_state = 528, .external_lex_state = 12},
  [7162] = {.lex_state = 497, .external_lex_state = 3},
  [7163] = {.lex_state = 497, .external_lex_state = 3},
  [7164] = {.lex_state = 192, .external_lex_state = 2},
  [7165] = {.lex_state = 501, .external_lex_state = 3},
  [7166] = {.lex_state = 501, .external_lex_state = 3},
  [7167] = {.lex_state = 501, .external_lex_state = 3},
  [7168] = {.lex_state = 528, .external_lex_state = 12},
  [7169] = {.lex_state = 501, .external_lex_state = 3},
  [7170] = {.lex_state = 501, .external_lex_state = 3},
  [7171] = {.lex_state = 192, .external_lex_state = 28},
  [7172] = {.lex_state = 497, .external_lex_state = 3},
  [7173] = {.lex_state = 304, .external_lex_state = 3},
  [7174] = {.lex_state = 323, .external_lex_state = 3},
  [7175] = {.lex_state = 323, .external_lex_state = 3},
  [7176] = {.lex_state = 323, .external_lex_state = 3},
  [7177] = {.lex_state = 323, .external_lex_state = 3},
  [7178] = {.lex_state = 323, .external_lex_state = 3},
  [7179] = {.lex_state = 561, .external_lex_state = 16},
  [7180] = {.lex_state = 323, .external_lex_state = 3},
  [7181] = {.lex_state = 323, .external_lex_state = 3},
  [7182] = {.lex_state = 323, .external_lex_state = 3},
  [7183] = {.lex_state = 323, .external_lex_state = 3},
  [7184] = {.lex_state = 323, .external_lex_state = 3},
  [7185] = {.lex_state = 323, .external_lex_state = 3},
  [7186] = {.lex_state = 323, .external_lex_state = 3},
  [7187] = {.lex_state = 323, .external_lex_state = 14},
  [7188] = {.lex_state = 192, .external_lex_state = 2},
  [7189] = {.lex_state = 192, .external_lex_state = 28},
  [7190] = {.lex_state = 501, .external_lex_state = 3},
  [7191] = {.lex_state = 304, .external_lex_state = 3},
  [7192] = {.lex_state = 304, .external_lex_state = 3},
  [7193] = {.lex_state = 304, .external_lex_state = 3},
  [7194] = {.lex_state = 304, .external_lex_state = 3},
  [7195] = {.lex_state = 304, .external_lex_state = 3},
  [7196] = {.lex_state = 561, .external_lex_state = 16},
  [7197] = {.lex_state = 304, .external_lex_state = 3},
  [7198] = {.lex_state = 304, .external_lex_state = 3},
  [7199] = {.lex_state = 304, .external_lex_state = 3},
  [7200] = {.lex_state = 304, .external_lex_state = 3},
  [7201] = {.lex_state = 304, .external_lex_state = 3},
  [7202] = {.lex_state = 304, .external_lex_state = 3},
  [7203] = {.lex_state = 304, .external_lex_state = 3},
  [7204] = {.lex_state = 332},
  [7205] = {.lex_state = 177, .external_lex_state = 4},
  [7206] = {.lex_state = 332},
  [7207] = {.lex_state = 332},
  [7208] = {.lex_state = 177, .external_lex_state = 4},
  [7209] = {.lex_state = 332},
  [7210] = {.lex_state = 227, .external_lex_state = 7},
  [7211] = {.lex_state = 332},
  [7212] = {.lex_state = 332},
  [7213] = {.lex_state = 363, .external_lex_state = 24},
  [7214] = {.lex_state = 363, .external_lex_state = 24},
  [7215] = {.lex_state = 192, .external_lex_state = 2},
  [7216] = {.lex_state = 363, .external_lex_state = 24},
  [7217] = {.lex_state = 192, .external_lex_state = 2},
  [7218] = {.lex_state = 363, .external_lex_state = 24},
  [7219] = {.lex_state = 528, .external_lex_state = 29},
  [7220] = {.lex_state = 363, .external_lex_state = 24},
  [7221] = {.lex_state = 363, .external_lex_state = 24},
  [7222] = {.lex_state = 363, .external_lex_state = 24},
  [7223] = {.lex_state = 363, .external_lex_state = 24},
  [7224] = {.lex_state = 363, .external_lex_state = 24},
  [7225] = {.lex_state = 363, .external_lex_state = 24},
  [7226] = {.lex_state = 561, .external_lex_state = 16},
  [7227] = {.lex_state = 363, .external_lex_state = 24},
  [7228] = {.lex_state = 363, .external_lex_state = 24},
  [7229] = {.lex_state = 363, .external_lex_state = 24},
  [7230] = {.lex_state = 363, .external_lex_state = 24},
  [7231] = {.lex_state = 192, .external_lex_state = 2},
  [7232] = {.lex_state = 625, .external_lex_state = 25},
  [7233] = {.lex_state = 625, .external_lex_state = 25},
  [7234] = {.lex_state = 625, .external_lex_state = 25},
  [7235] = {.lex_state = 625, .external_lex_state = 25},
  [7236] = {.lex_state = 192, .external_lex_state = 2},
  [7237] = {.lex_state = 192, .external_lex_state = 2},
  [7238] = {.lex_state = 426, .external_lex_state = 24},
  [7239] = {.lex_state = 213},
  [7240] = {.lex_state = 426, .external_lex_state = 24},
  [7241] = {.lex_state = 426, .external_lex_state = 26},
  [7242] = {.lex_state = 426, .external_lex_state = 24},
  [7243] = {.lex_state = 192, .external_lex_state = 2},
  [7244] = {.lex_state = 426, .external_lex_state = 24},
  [7245] = {.lex_state = 192, .external_lex_state = 2},
  [7246] = {.lex_state = 426, .external_lex_state = 24},
  [7247] = {.lex_state = 528, .external_lex_state = 29},
  [7248] = {.lex_state = 426, .external_lex_state = 24},
  [7249] = {.lex_state = 363, .external_lex_state = 24},
  [7250] = {.lex_state = 363, .external_lex_state = 24},
  [7251] = {.lex_state = 363, .external_lex_state = 24},
  [7252] = {.lex_state = 367, .external_lex_state = 26},
  [7253] = {.lex_state = 339, .external_lex_state = 19},
  [7254] = {.lex_state = 332},
  [7255] = {.lex_state = 332},
  [7256] = {.lex_state = 332},
  [7257] = {.lex_state = 332},
  [7258] = {.lex_state = 332},
  [7259] = {.lex_state = 128},
  [7260] = {.lex_state = 332},
  [7261] = {.lex_state = 128},
  [7262] = {.lex_state = 128},
  [7263] = {.lex_state = 332},
  [7264] = {.lex_state = 128},
  [7265] = {.lex_state = 339},
  [7266] = {.lex_state = 339},
  [7267] = {.lex_state = 128},
  [7268] = {.lex_state = 128, .external_lex_state = 2},
  [7269] = {.lex_state = 488, .external_lex_state = 12},
  [7270] = {.lex_state = 680, .external_lex_state = 26},
  [7271] = {.lex_state = 628, .external_lex_state = 24},
  [7272] = {.lex_state = 628, .external_lex_state = 24},
  [7273] = {.lex_state = 628, .external_lex_state = 24},
  [7274] = {.lex_state = 628, .external_lex_state = 24},
  [7275] = {.lex_state = 192, .external_lex_state = 15},
  [7276] = {.lex_state = 268, .external_lex_state = 15},
  [7277] = {.lex_state = 628, .external_lex_state = 24},
  [7278] = {.lex_state = 177, .external_lex_state = 4},
  [7279] = {.lex_state = 268, .external_lex_state = 15},
  [7280] = {.lex_state = 628, .external_lex_state = 24},
  [7281] = {.lex_state = 192, .external_lex_state = 15},
  [7282] = {.lex_state = 268, .external_lex_state = 15},
  [7283] = {.lex_state = 628, .external_lex_state = 24},
  [7284] = {.lex_state = 177, .external_lex_state = 4},
  [7285] = {.lex_state = 268, .external_lex_state = 15},
  [7286] = {.lex_state = 628, .external_lex_state = 24},
  [7287] = {.lex_state = 194},
  [7288] = {.lex_state = 304, .external_lex_state = 16},
  [7289] = {.lex_state = 227, .external_lex_state = 7},
  [7290] = {.lex_state = 128, .external_lex_state = 2},
  [7291] = {.lex_state = 628, .external_lex_state = 24},
  [7292] = {.lex_state = 249, .external_lex_state = 3},
  [7293] = {.lex_state = 128, .external_lex_state = 13},
  [7294] = {.lex_state = 128, .external_lex_state = 2},
  [7295] = {.lex_state = 628, .external_lex_state = 24},
  [7296] = {.lex_state = 128, .external_lex_state = 2},
  [7297] = {.lex_state = 634, .external_lex_state = 24},
  [7298] = {.lex_state = 634, .external_lex_state = 24},
  [7299] = {.lex_state = 192, .external_lex_state = 2},
  [7300] = {.lex_state = 634, .external_lex_state = 24},
  [7301] = {.lex_state = 628, .external_lex_state = 24},
  [7302] = {.lex_state = 209},
  [7303] = {.lex_state = 192, .external_lex_state = 2},
  [7304] = {.lex_state = 177, .external_lex_state = 17},
  [7305] = {.lex_state = 634, .external_lex_state = 24},
  [7306] = {.lex_state = 528, .external_lex_state = 29},
  [7307] = {.lex_state = 634, .external_lex_state = 24},
  [7308] = {.lex_state = 128},
  [7309] = {.lex_state = 128, .external_lex_state = 2},
  [7310] = {.lex_state = 128},
  [7311] = {.lex_state = 128, .external_lex_state = 2},
  [7312] = {.lex_state = 128, .external_lex_state = 2},
  [7313] = {.lex_state = 128, .external_lex_state = 2},
  [7314] = {.lex_state = 128, .external_lex_state = 13},
  [7315] = {.lex_state = 128},
  [7316] = {.lex_state = 628, .external_lex_state = 24},
  [7317] = {.lex_state = 128},
  [7318] = {.lex_state = 128},
  [7319] = {.lex_state = 128},
  [7320] = {.lex_state = 628, .external_lex_state = 24},
  [7321] = {.lex_state = 128},
  [7322] = {.lex_state = 128},
  [7323] = {.lex_state = 128},
  [7324] = {.lex_state = 628, .external_lex_state = 24},
  [7325] = {.lex_state = 628, .external_lex_state = 24},
  [7326] = {.lex_state = 628, .external_lex_state = 24},
  [7327] = {.lex_state = 194},
  [7328] = {.lex_state = 288, .external_lex_state = 2},
  [7329] = {.lex_state = 628, .external_lex_state = 24},
  [7330] = {.lex_state = 128},
  [7331] = {.lex_state = 128, .external_lex_state = 11},
  [7332] = {.lex_state = 416, .external_lex_state = 2},
  [7333] = {.lex_state = 628, .external_lex_state = 24},
  [7334] = {.lex_state = 634, .external_lex_state = 24},
  [7335] = {.lex_state = 634, .external_lex_state = 24},
  [7336] = {.lex_state = 634, .external_lex_state = 24},
  [7337] = {.lex_state = 634, .external_lex_state = 24},
  [7338] = {.lex_state = 634, .external_lex_state = 24},
  [7339] = {.lex_state = 561, .external_lex_state = 16},
  [7340] = {.lex_state = 634, .external_lex_state = 24},
  [7341] = {.lex_state = 634, .external_lex_state = 24},
  [7342] = {.lex_state = 634, .external_lex_state = 24},
  [7343] = {.lex_state = 634, .external_lex_state = 24},
  [7344] = {.lex_state = 399, .external_lex_state = 24},
  [7345] = {.lex_state = 634, .external_lex_state = 24},
  [7346] = {.lex_state = 628, .external_lex_state = 24},
  [7347] = {.lex_state = 634, .external_lex_state = 24},
  [7348] = {.lex_state = 634, .external_lex_state = 24},
  [7349] = {.lex_state = 634, .external_lex_state = 26},
  [7350] = {.lex_state = 509, .external_lex_state = 24},
  [7351] = {.lex_state = 509, .external_lex_state = 24},
  [7352] = {.lex_state = 509, .external_lex_state = 24},
  [7353] = {.lex_state = 528, .external_lex_state = 12},
  [7354] = {.lex_state = 509, .external_lex_state = 24},
  [7355] = {.lex_state = 509, .external_lex_state = 24},
  [7356] = {.lex_state = 192, .external_lex_state = 2},
  [7357] = {.lex_state = 192, .external_lex_state = 28},
  [7358] = {.lex_state = 509, .external_lex_state = 24},
  [7359] = {.lex_state = 512, .external_lex_state = 24},
  [7360] = {.lex_state = 512, .external_lex_state = 24},
  [7361] = {.lex_state = 192, .external_lex_state = 2},
  [7362] = {.lex_state = 512, .external_lex_state = 24},
  [7363] = {.lex_state = 192, .external_lex_state = 2},
  [7364] = {.lex_state = 512, .external_lex_state = 24},
  [7365] = {.lex_state = 528, .external_lex_state = 29},
  [7366] = {.lex_state = 512, .external_lex_state = 24},
  [7367] = {.lex_state = 512, .external_lex_state = 24},
  [7368] = {.lex_state = 512, .external_lex_state = 24},
  [7369] = {.lex_state = 512, .external_lex_state = 24},
  [7370] = {.lex_state = 512, .external_lex_state = 24},
  [7371] = {.lex_state = 512, .external_lex_state = 24},
  [7372] = {.lex_state = 561, .external_lex_state = 16},
  [7373] = {.lex_state = 512, .external_lex_state = 24},
  [7374] = {.lex_state = 512, .external_lex_state = 24},
  [7375] = {.lex_state = 512, .external_lex_state = 24},
  [7376] = {.lex_state = 512, .external_lex_state = 24},
  [7377] = {.lex_state = 512, .external_lex_state = 24},
  [7378] = {.lex_state = 512, .external_lex_state = 24},
  [7379] = {.lex_state = 512, .external_lex_state = 24},
  [7380] = {.lex_state = 638, .external_lex_state = 26},
  [7381] = {.lex_state = 512, .external_lex_state = 24},
  [7382] = {.lex_state = 512, .external_lex_state = 24},
  [7383] = {.lex_state = 512, .external_lex_state = 24},
  [7384] = {.lex_state = 528, .external_lex_state = 12},
  [7385] = {.lex_state = 512, .external_lex_state = 24},
  [7386] = {.lex_state = 512, .external_lex_state = 24},
  [7387] = {.lex_state = 192, .external_lex_state = 2},
  [7388] = {.lex_state = 192, .external_lex_state = 28},
  [7389] = {.lex_state = 512, .external_lex_state = 24},
  [7390] = {.lex_state = 367, .external_lex_state = 3},
  [7391] = {.lex_state = 367, .external_lex_state = 3},
  [7392] = {.lex_state = 192, .external_lex_state = 2},
  [7393] = {.lex_state = 192, .external_lex_state = 28},
  [7394] = {.lex_state = 367, .external_lex_state = 3},
  [7395] = {.lex_state = 497, .external_lex_state = 24},
  [7396] = {.lex_state = 497, .external_lex_state = 24},
  [7397] = {.lex_state = 304, .external_lex_state = 24},
  [7398] = {.lex_state = 304, .external_lex_state = 24},
  [7399] = {.lex_state = 304, .external_lex_state = 24},
  [7400] = {.lex_state = 304, .external_lex_state = 24},
  [7401] = {.lex_state = 304, .external_lex_state = 24},
  [7402] = {.lex_state = 561, .external_lex_state = 16},
  [7403] = {.lex_state = 304, .external_lex_state = 24},
  [7404] = {.lex_state = 304, .external_lex_state = 24},
  [7405] = {.lex_state = 304, .external_lex_state = 24},
  [7406] = {.lex_state = 304, .external_lex_state = 24},
  [7407] = {.lex_state = 192, .external_lex_state = 2},
  [7408] = {.lex_state = 304, .external_lex_state = 24},
  [7409] = {.lex_state = 304, .external_lex_state = 24},
  [7410] = {.lex_state = 304, .external_lex_state = 24},
  [7411] = {.lex_state = 617, .external_lex_state = 26},
  [7412] = {.lex_state = 497, .external_lex_state = 24},
  [7413] = {.lex_state = 497, .external_lex_state = 24},
  [7414] = {.lex_state = 497, .external_lex_state = 24},
  [7415] = {.lex_state = 528, .external_lex_state = 12},
  [7416] = {.lex_state = 497, .external_lex_state = 24},
  [7417] = {.lex_state = 497, .external_lex_state = 24},
  [7418] = {.lex_state = 192, .external_lex_state = 2},
  [7419] = {.lex_state = 501, .external_lex_state = 24},
  [7420] = {.lex_state = 501, .external_lex_state = 24},
  [7421] = {.lex_state = 501, .external_lex_state = 24},
  [7422] = {.lex_state = 528, .external_lex_state = 12},
  [7423] = {.lex_state = 501, .external_lex_state = 24},
  [7424] = {.lex_state = 501, .external_lex_state = 24},
  [7425] = {.lex_state = 358, .external_lex_state = 12},
  [7426] = {.lex_state = 528, .external_lex_state = 29},
  [7427] = {.lex_state = 304, .external_lex_state = 24},
  [7428] = {.lex_state = 192, .external_lex_state = 28},
  [7429] = {.lex_state = 304, .external_lex_state = 24},
  [7430] = {.lex_state = 363, .external_lex_state = 3},
  [7431] = {.lex_state = 518, .external_lex_state = 10},
  [7432] = {.lex_state = 301, .external_lex_state = 3},
  [7433] = {.lex_state = 301, .external_lex_state = 3},
  [7434] = {.lex_state = 128},
  [7435] = {.lex_state = 128, .external_lex_state = 2},
  [7436] = {.lex_state = 301, .external_lex_state = 3},
  [7437] = {.lex_state = 301, .external_lex_state = 3},
  [7438] = {.lex_state = 683, .external_lex_state = 12},
  [7439] = {.lex_state = 156, .external_lex_state = 3},
  [7440] = {.lex_state = 363, .external_lex_state = 3},
  [7441] = {.lex_state = 363, .external_lex_state = 3},
  [7442] = {.lex_state = 363, .external_lex_state = 3},
  [7443] = {.lex_state = 363, .external_lex_state = 3},
  [7444] = {.lex_state = 363, .external_lex_state = 3},
  [7445] = {.lex_state = 363, .external_lex_state = 3},
  [7446] = {.lex_state = 363, .external_lex_state = 3},
  [7447] = {.lex_state = 363, .external_lex_state = 3},
  [7448] = {.lex_state = 561, .external_lex_state = 16},
  [7449] = {.lex_state = 363, .external_lex_state = 3},
  [7450] = {.lex_state = 363, .external_lex_state = 3},
  [7451] = {.lex_state = 363, .external_lex_state = 3},
  [7452] = {.lex_state = 363, .external_lex_state = 3},
  [7453] = {.lex_state = 363, .external_lex_state = 3},
  [7454] = {.lex_state = 363, .external_lex_state = 3},
  [7455] = {.lex_state = 363, .external_lex_state = 3},
  [7456] = {.lex_state = 367, .external_lex_state = 14},
  [7457] = {.lex_state = 363, .external_lex_state = 3},
  [7458] = {.lex_state = 363, .external_lex_state = 3},
  [7459] = {.lex_state = 363, .external_lex_state = 3},
  [7460] = {.lex_state = 528, .external_lex_state = 12},
  [7461] = {.lex_state = 363, .external_lex_state = 3},
  [7462] = {.lex_state = 363, .external_lex_state = 3},
  [7463] = {.lex_state = 192, .external_lex_state = 2},
  [7464] = {.lex_state = 423, .external_lex_state = 3},
  [7465] = {.lex_state = 423, .external_lex_state = 3},
  [7466] = {.lex_state = 423, .external_lex_state = 3},
  [7467] = {.lex_state = 528, .external_lex_state = 12},
  [7468] = {.lex_state = 423, .external_lex_state = 3},
  [7469] = {.lex_state = 423, .external_lex_state = 3},
  [7470] = {.lex_state = 192, .external_lex_state = 28},
  [7471] = {.lex_state = 363, .external_lex_state = 3},
  [7472] = {.lex_state = 192, .external_lex_state = 2},
  [7473] = {.lex_state = 515, .external_lex_state = 10},
  [7474] = {.lex_state = 515, .external_lex_state = 10},
  [7475] = {.lex_state = 515, .external_lex_state = 10},
  [7476] = {.lex_state = 515, .external_lex_state = 10},
  [7477] = {.lex_state = 192, .external_lex_state = 2},
  [7478] = {.lex_state = 192, .external_lex_state = 2},
  [7479] = {.lex_state = 363, .external_lex_state = 3},
  [7480] = {.lex_state = 213},
  [7481] = {.lex_state = 261, .external_lex_state = 3},
  [7482] = {.lex_state = 367, .external_lex_state = 14},
  [7483] = {.lex_state = 363, .external_lex_state = 3},
  [7484] = {.lex_state = 363, .external_lex_state = 3},
  [7485] = {.lex_state = 363, .external_lex_state = 14},
  [7486] = {.lex_state = 192, .external_lex_state = 2},
  [7487] = {.lex_state = 363, .external_lex_state = 3},
  [7488] = {.lex_state = 192, .external_lex_state = 2},
  [7489] = {.lex_state = 192, .external_lex_state = 2},
  [7490] = {.lex_state = 239},
  [7491] = {.lex_state = 192, .external_lex_state = 2},
  [7492] = {.lex_state = 360, .external_lex_state = 10},
  [7493] = {.lex_state = 363, .external_lex_state = 3},
  [7494] = {.lex_state = 363, .external_lex_state = 3},
  [7495] = {.lex_state = 363, .external_lex_state = 3},
  [7496] = {.lex_state = 373, .external_lex_state = 14},
  [7497] = {.lex_state = 363, .external_lex_state = 3},
  [7498] = {.lex_state = 192, .external_lex_state = 2},
  [7499] = {.lex_state = 192, .external_lex_state = 2},
  [7500] = {.lex_state = 192, .external_lex_state = 2},
  [7501] = {.lex_state = 192, .external_lex_state = 2},
  [7502] = {.lex_state = 192, .external_lex_state = 2},
  [7503] = {.lex_state = 192, .external_lex_state = 2},
  [7504] = {.lex_state = 192, .external_lex_state = 2},
  [7505] = {.lex_state = 192, .external_lex_state = 2},
  [7506] = {.lex_state = 192, .external_lex_state = 2},
  [7507] = {.lex_state = 192, .external_lex_state = 2},
  [7508] = {.lex_state = 192, .external_lex_state = 2},
  [7509] = {.lex_state = 192, .external_lex_state = 2},
  [7510] = {.lex_state = 192, .external_lex_state = 2},
  [7511] = {.lex_state = 239},
  [7512] = {.lex_state = 192, .external_lex_state = 2},
  [7513] = {.lex_state = 360, .external_lex_state = 10},
  [7514] = {.lex_state = 423, .external_lex_state = 3},
  [7515] = {.lex_state = 423, .external_lex_state = 3},
  [7516] = {.lex_state = 423, .external_lex_state = 3},
  [7517] = {.lex_state = 429, .external_lex_state = 14},
  [7518] = {.lex_state = 264, .external_lex_state = 3},
  [7519] = {.lex_state = 528, .external_lex_state = 29},
  [7520] = {.lex_state = 363, .external_lex_state = 3},
  [7521] = {.lex_state = 192, .external_lex_state = 28},
  [7522] = {.lex_state = 192, .external_lex_state = 2},
  [7523] = {.lex_state = 363, .external_lex_state = 14},
  [7524] = {.lex_state = 256, .external_lex_state = 13},
  [7525] = {.lex_state = 249, .external_lex_state = 3},
  [7526] = {.lex_state = 249, .external_lex_state = 3},
  [7527] = {.lex_state = 249, .external_lex_state = 3},
  [7528] = {.lex_state = 249, .external_lex_state = 3},
  [7529] = {.lex_state = 249, .external_lex_state = 3},
  [7530] = {.lex_state = 249, .external_lex_state = 3},
  [7531] = {.lex_state = 249, .external_lex_state = 3},
  [7532] = {.lex_state = 249, .external_lex_state = 3},
  [7533] = {.lex_state = 249, .external_lex_state = 3},
  [7534] = {.lex_state = 249, .external_lex_state = 3},
  [7535] = {.lex_state = 561, .external_lex_state = 16},
  [7536] = {.lex_state = 249, .external_lex_state = 3},
  [7537] = {.lex_state = 249, .external_lex_state = 3},
  [7538] = {.lex_state = 249, .external_lex_state = 3},
  [7539] = {.lex_state = 249, .external_lex_state = 3},
  [7540] = {.lex_state = 192, .external_lex_state = 2},
  [7541] = {.lex_state = 256, .external_lex_state = 10},
  [7542] = {.lex_state = 256, .external_lex_state = 10},
  [7543] = {.lex_state = 256, .external_lex_state = 10},
  [7544] = {.lex_state = 256, .external_lex_state = 10},
  [7545] = {.lex_state = 192, .external_lex_state = 2},
  [7546] = {.lex_state = 192, .external_lex_state = 2},
  [7547] = {.lex_state = 426, .external_lex_state = 3},
  [7548] = {.lex_state = 256, .external_lex_state = 10},
  [7549] = {.lex_state = 213},
  [7550] = {.lex_state = 426, .external_lex_state = 3},
  [7551] = {.lex_state = 426, .external_lex_state = 14},
  [7552] = {.lex_state = 426, .external_lex_state = 3},
  [7553] = {.lex_state = 423, .external_lex_state = 3},
  [7554] = {.lex_state = 423, .external_lex_state = 14},
  [7555] = {.lex_state = 192, .external_lex_state = 2},
  [7556] = {.lex_state = 426, .external_lex_state = 3},
  [7557] = {.lex_state = 423, .external_lex_state = 3},
  [7558] = {.lex_state = 192, .external_lex_state = 2},
  [7559] = {.lex_state = 192, .external_lex_state = 2},
  [7560] = {.lex_state = 192, .external_lex_state = 2},
  [7561] = {.lex_state = 192, .external_lex_state = 2},
  [7562] = {.lex_state = 192, .external_lex_state = 2},
  [7563] = {.lex_state = 192, .external_lex_state = 2},
  [7564] = {.lex_state = 192, .external_lex_state = 2},
  [7565] = {.lex_state = 192, .external_lex_state = 2},
  [7566] = {.lex_state = 192, .external_lex_state = 2},
  [7567] = {.lex_state = 192, .external_lex_state = 2},
  [7568] = {.lex_state = 192, .external_lex_state = 2},
  [7569] = {.lex_state = 426, .external_lex_state = 3},
  [7570] = {.lex_state = 528, .external_lex_state = 29},
  [7571] = {.lex_state = 426, .external_lex_state = 3},
  [7572] = {.lex_state = 192, .external_lex_state = 28},
  [7573] = {.lex_state = 192, .external_lex_state = 2},
  [7574] = {.lex_state = 423, .external_lex_state = 14},
  [7575] = {.lex_state = 192, .external_lex_state = 2},
  [7576] = {.lex_state = 192, .external_lex_state = 2},
  [7577] = {.lex_state = 192, .external_lex_state = 2},
  [7578] = {.lex_state = 192, .external_lex_state = 2},
  [7579] = {.lex_state = 532, .external_lex_state = 3},
  [7580] = {.lex_state = 532, .external_lex_state = 3},
  [7581] = {.lex_state = 213},
  [7582] = {.lex_state = 261, .external_lex_state = 3},
  [7583] = {.lex_state = 249, .external_lex_state = 3},
  [7584] = {.lex_state = 264, .external_lex_state = 14},
  [7585] = {.lex_state = 128},
  [7586] = {.lex_state = 128, .external_lex_state = 2},
  [7587] = {.lex_state = 249, .external_lex_state = 3},
  [7588] = {.lex_state = 426, .external_lex_state = 3},
  [7589] = {.lex_state = 426, .external_lex_state = 3},
  [7590] = {.lex_state = 426, .external_lex_state = 3},
  [7591] = {.lex_state = 426, .external_lex_state = 3},
  [7592] = {.lex_state = 426, .external_lex_state = 3},
  [7593] = {.lex_state = 561, .external_lex_state = 16},
  [7594] = {.lex_state = 426, .external_lex_state = 3},
  [7595] = {.lex_state = 426, .external_lex_state = 3},
  [7596] = {.lex_state = 426, .external_lex_state = 3},
  [7597] = {.lex_state = 426, .external_lex_state = 3},
  [7598] = {.lex_state = 426, .external_lex_state = 3},
  [7599] = {.lex_state = 426, .external_lex_state = 3},
  [7600] = {.lex_state = 426, .external_lex_state = 3},
  [7601] = {.lex_state = 426, .external_lex_state = 14},
  [7602] = {.lex_state = 192, .external_lex_state = 2},
  [7603] = {.lex_state = 192, .external_lex_state = 28},
  [7604] = {.lex_state = 423, .external_lex_state = 3},
  [7605] = {.lex_state = 532, .external_lex_state = 3},
  [7606] = {.lex_state = 532, .external_lex_state = 3},
  [7607] = {.lex_state = 532, .external_lex_state = 3},
  [7608] = {.lex_state = 532, .external_lex_state = 3},
  [7609] = {.lex_state = 532, .external_lex_state = 3},
  [7610] = {.lex_state = 561, .external_lex_state = 16},
  [7611] = {.lex_state = 532, .external_lex_state = 3},
  [7612] = {.lex_state = 532, .external_lex_state = 3},
  [7613] = {.lex_state = 532, .external_lex_state = 3},
  [7614] = {.lex_state = 532, .external_lex_state = 3},
  [7615] = {.lex_state = 532, .external_lex_state = 3},
  [7616] = {.lex_state = 532, .external_lex_state = 3},
  [7617] = {.lex_state = 532, .external_lex_state = 3},
  [7618] = {.lex_state = 192, .external_lex_state = 2},
  [7619] = {.lex_state = 515, .external_lex_state = 10},
  [7620] = {.lex_state = 515, .external_lex_state = 10},
  [7621] = {.lex_state = 515, .external_lex_state = 10},
  [7622] = {.lex_state = 515, .external_lex_state = 10},
  [7623] = {.lex_state = 192, .external_lex_state = 2},
  [7624] = {.lex_state = 192, .external_lex_state = 2},
  [7625] = {.lex_state = 363, .external_lex_state = 3},
  [7626] = {.lex_state = 213},
  [7627] = {.lex_state = 261, .external_lex_state = 3},
  [7628] = {.lex_state = 367, .external_lex_state = 14},
  [7629] = {.lex_state = 363, .external_lex_state = 3},
  [7630] = {.lex_state = 363, .external_lex_state = 3},
  [7631] = {.lex_state = 363, .external_lex_state = 14},
  [7632] = {.lex_state = 192, .external_lex_state = 2},
  [7633] = {.lex_state = 363, .external_lex_state = 3},
  [7634] = {.lex_state = 192, .external_lex_state = 2},
  [7635] = {.lex_state = 192, .external_lex_state = 2},
  [7636] = {.lex_state = 239},
  [7637] = {.lex_state = 192, .external_lex_state = 2},
  [7638] = {.lex_state = 360, .external_lex_state = 10},
  [7639] = {.lex_state = 363, .external_lex_state = 3},
  [7640] = {.lex_state = 363, .external_lex_state = 3},
  [7641] = {.lex_state = 363, .external_lex_state = 3},
  [7642] = {.lex_state = 373, .external_lex_state = 14},
  [7643] = {.lex_state = 363, .external_lex_state = 3},
  [7644] = {.lex_state = 192, .external_lex_state = 2},
  [7645] = {.lex_state = 192, .external_lex_state = 2},
  [7646] = {.lex_state = 192, .external_lex_state = 2},
  [7647] = {.lex_state = 192, .external_lex_state = 2},
  [7648] = {.lex_state = 192, .external_lex_state = 2},
  [7649] = {.lex_state = 192, .external_lex_state = 2},
  [7650] = {.lex_state = 192, .external_lex_state = 2},
  [7651] = {.lex_state = 192, .external_lex_state = 2},
  [7652] = {.lex_state = 192, .external_lex_state = 2},
  [7653] = {.lex_state = 192, .external_lex_state = 2},
  [7654] = {.lex_state = 192, .external_lex_state = 2},
  [7655] = {.lex_state = 192, .external_lex_state = 2},
  [7656] = {.lex_state = 192, .external_lex_state = 2},
  [7657] = {.lex_state = 239},
  [7658] = {.lex_state = 192, .external_lex_state = 2},
  [7659] = {.lex_state = 360, .external_lex_state = 10},
  [7660] = {.lex_state = 423, .external_lex_state = 3},
  [7661] = {.lex_state = 423, .external_lex_state = 3},
  [7662] = {.lex_state = 423, .external_lex_state = 3},
  [7663] = {.lex_state = 429, .external_lex_state = 14},
  [7664] = {.lex_state = 264, .external_lex_state = 3},
  [7665] = {.lex_state = 528, .external_lex_state = 29},
  [7666] = {.lex_state = 363, .external_lex_state = 3},
  [7667] = {.lex_state = 192, .external_lex_state = 28},
  [7668] = {.lex_state = 192, .external_lex_state = 2},
  [7669] = {.lex_state = 363, .external_lex_state = 14},
  [7670] = {.lex_state = 256, .external_lex_state = 13},
  [7671] = {.lex_state = 249, .external_lex_state = 3},
  [7672] = {.lex_state = 249, .external_lex_state = 3},
  [7673] = {.lex_state = 249, .external_lex_state = 3},
  [7674] = {.lex_state = 249, .external_lex_state = 3},
  [7675] = {.lex_state = 249, .external_lex_state = 3},
  [7676] = {.lex_state = 249, .external_lex_state = 3},
  [7677] = {.lex_state = 249, .external_lex_state = 3},
  [7678] = {.lex_state = 249, .external_lex_state = 3},
  [7679] = {.lex_state = 249, .external_lex_state = 3},
  [7680] = {.lex_state = 249, .external_lex_state = 3},
  [7681] = {.lex_state = 561, .external_lex_state = 16},
  [7682] = {.lex_state = 249, .external_lex_state = 3},
  [7683] = {.lex_state = 249, .external_lex_state = 3},
  [7684] = {.lex_state = 249, .external_lex_state = 3},
  [7685] = {.lex_state = 249, .external_lex_state = 3},
  [7686] = {.lex_state = 192, .external_lex_state = 2},
  [7687] = {.lex_state = 256, .external_lex_state = 10},
  [7688] = {.lex_state = 256, .external_lex_state = 10},
  [7689] = {.lex_state = 256, .external_lex_state = 10},
  [7690] = {.lex_state = 256, .external_lex_state = 10},
  [7691] = {.lex_state = 192, .external_lex_state = 2},
  [7692] = {.lex_state = 192, .external_lex_state = 2},
  [7693] = {.lex_state = 426, .external_lex_state = 3},
  [7694] = {.lex_state = 256, .external_lex_state = 10},
  [7695] = {.lex_state = 213},
  [7696] = {.lex_state = 426, .external_lex_state = 3},
  [7697] = {.lex_state = 426, .external_lex_state = 14},
  [7698] = {.lex_state = 426, .external_lex_state = 3},
  [7699] = {.lex_state = 423, .external_lex_state = 3},
  [7700] = {.lex_state = 423, .external_lex_state = 14},
  [7701] = {.lex_state = 192, .external_lex_state = 2},
  [7702] = {.lex_state = 426, .external_lex_state = 3},
  [7703] = {.lex_state = 423, .external_lex_state = 3},
  [7704] = {.lex_state = 192, .external_lex_state = 2},
  [7705] = {.lex_state = 192, .external_lex_state = 2},
  [7706] = {.lex_state = 192, .external_lex_state = 2},
  [7707] = {.lex_state = 192, .external_lex_state = 2},
  [7708] = {.lex_state = 192, .external_lex_state = 2},
  [7709] = {.lex_state = 192, .external_lex_state = 2},
  [7710] = {.lex_state = 192, .external_lex_state = 2},
  [7711] = {.lex_state = 192, .external_lex_state = 2},
  [7712] = {.lex_state = 192, .external_lex_state = 2},
  [7713] = {.lex_state = 192, .external_lex_state = 2},
  [7714] = {.lex_state = 192, .external_lex_state = 2},
  [7715] = {.lex_state = 426, .external_lex_state = 3},
  [7716] = {.lex_state = 528, .external_lex_state = 29},
  [7717] = {.lex_state = 426, .external_lex_state = 3},
  [7718] = {.lex_state = 192, .external_lex_state = 28},
  [7719] = {.lex_state = 192, .external_lex_state = 2},
  [7720] = {.lex_state = 423, .external_lex_state = 14},
  [7721] = {.lex_state = 192, .external_lex_state = 2},
  [7722] = {.lex_state = 192, .external_lex_state = 2},
  [7723] = {.lex_state = 192, .external_lex_state = 2},
  [7724] = {.lex_state = 192, .external_lex_state = 2},
  [7725] = {.lex_state = 532, .external_lex_state = 3},
  [7726] = {.lex_state = 532, .external_lex_state = 3},
  [7727] = {.lex_state = 213},
  [7728] = {.lex_state = 261, .external_lex_state = 3},
  [7729] = {.lex_state = 249, .external_lex_state = 3},
  [7730] = {.lex_state = 264, .external_lex_state = 14},
  [7731] = {.lex_state = 363, .external_lex_state = 3},
  [7732] = {.lex_state = 363, .external_lex_state = 3},
  [7733] = {.lex_state = 363, .external_lex_state = 3},
  [7734] = {.lex_state = 363, .external_lex_state = 3},
  [7735] = {.lex_state = 363, .external_lex_state = 3},
  [7736] = {.lex_state = 363, .external_lex_state = 3},
  [7737] = {.lex_state = 363, .external_lex_state = 3},
  [7738] = {.lex_state = 561, .external_lex_state = 16},
  [7739] = {.lex_state = 363, .external_lex_state = 3},
  [7740] = {.lex_state = 363, .external_lex_state = 3},
  [7741] = {.lex_state = 363, .external_lex_state = 3},
  [7742] = {.lex_state = 363, .external_lex_state = 3},
  [7743] = {.lex_state = 363, .external_lex_state = 3},
  [7744] = {.lex_state = 363, .external_lex_state = 3},
  [7745] = {.lex_state = 363, .external_lex_state = 3},
  [7746] = {.lex_state = 367, .external_lex_state = 14},
  [7747] = {.lex_state = 363, .external_lex_state = 3},
  [7748] = {.lex_state = 363, .external_lex_state = 3},
  [7749] = {.lex_state = 363, .external_lex_state = 3},
  [7750] = {.lex_state = 528, .external_lex_state = 12},
  [7751] = {.lex_state = 363, .external_lex_state = 3},
  [7752] = {.lex_state = 363, .external_lex_state = 3},
  [7753] = {.lex_state = 192, .external_lex_state = 2},
  [7754] = {.lex_state = 423, .external_lex_state = 3},
  [7755] = {.lex_state = 423, .external_lex_state = 3},
  [7756] = {.lex_state = 423, .external_lex_state = 3},
  [7757] = {.lex_state = 528, .external_lex_state = 12},
  [7758] = {.lex_state = 423, .external_lex_state = 3},
  [7759] = {.lex_state = 423, .external_lex_state = 3},
  [7760] = {.lex_state = 192, .external_lex_state = 28},
  [7761] = {.lex_state = 363, .external_lex_state = 3},
  [7762] = {.lex_state = 249, .external_lex_state = 3},
  [7763] = {.lex_state = 426, .external_lex_state = 3},
  [7764] = {.lex_state = 426, .external_lex_state = 3},
  [7765] = {.lex_state = 426, .external_lex_state = 3},
  [7766] = {.lex_state = 426, .external_lex_state = 3},
  [7767] = {.lex_state = 426, .external_lex_state = 3},
  [7768] = {.lex_state = 561, .external_lex_state = 16},
  [7769] = {.lex_state = 426, .external_lex_state = 3},
  [7770] = {.lex_state = 426, .external_lex_state = 3},
  [7771] = {.lex_state = 426, .external_lex_state = 3},
  [7772] = {.lex_state = 426, .external_lex_state = 3},
  [7773] = {.lex_state = 426, .external_lex_state = 3},
  [7774] = {.lex_state = 426, .external_lex_state = 3},
  [7775] = {.lex_state = 426, .external_lex_state = 3},
  [7776] = {.lex_state = 426, .external_lex_state = 14},
  [7777] = {.lex_state = 192, .external_lex_state = 2},
  [7778] = {.lex_state = 192, .external_lex_state = 28},
  [7779] = {.lex_state = 423, .external_lex_state = 3},
  [7780] = {.lex_state = 532, .external_lex_state = 3},
  [7781] = {.lex_state = 532, .external_lex_state = 3},
  [7782] = {.lex_state = 532, .external_lex_state = 3},
  [7783] = {.lex_state = 532, .external_lex_state = 3},
  [7784] = {.lex_state = 532, .external_lex_state = 3},
  [7785] = {.lex_state = 561, .external_lex_state = 16},
  [7786] = {.lex_state = 532, .external_lex_state = 3},
  [7787] = {.lex_state = 532, .external_lex_state = 3},
  [7788] = {.lex_state = 532, .external_lex_state = 3},
  [7789] = {.lex_state = 532, .external_lex_state = 3},
  [7790] = {.lex_state = 532, .external_lex_state = 3},
  [7791] = {.lex_state = 532, .external_lex_state = 3},
  [7792] = {.lex_state = 532, .external_lex_state = 3},
  [7793] = {.lex_state = 512, .external_lex_state = 24},
  [7794] = {.lex_state = 512, .external_lex_state = 24},
  [7795] = {.lex_state = 192, .external_lex_state = 2},
  [7796] = {.lex_state = 512, .external_lex_state = 24},
  [7797] = {.lex_state = 192, .external_lex_state = 2},
  [7798] = {.lex_state = 512, .external_lex_state = 24},
  [7799] = {.lex_state = 528, .external_lex_state = 29},
  [7800] = {.lex_state = 512, .external_lex_state = 24},
  [7801] = {.lex_state = 512, .external_lex_state = 24},
  [7802] = {.lex_state = 512, .external_lex_state = 24},
  [7803] = {.lex_state = 512, .external_lex_state = 24},
  [7804] = {.lex_state = 512, .external_lex_state = 24},
  [7805] = {.lex_state = 512, .external_lex_state = 24},
  [7806] = {.lex_state = 561, .external_lex_state = 16},
  [7807] = {.lex_state = 512, .external_lex_state = 24},
  [7808] = {.lex_state = 512, .external_lex_state = 24},
  [7809] = {.lex_state = 512, .external_lex_state = 24},
  [7810] = {.lex_state = 512, .external_lex_state = 24},
  [7811] = {.lex_state = 192, .external_lex_state = 2},
  [7812] = {.lex_state = 625, .external_lex_state = 25},
  [7813] = {.lex_state = 625, .external_lex_state = 25},
  [7814] = {.lex_state = 625, .external_lex_state = 25},
  [7815] = {.lex_state = 625, .external_lex_state = 25},
  [7816] = {.lex_state = 192, .external_lex_state = 2},
  [7817] = {.lex_state = 192, .external_lex_state = 2},
  [7818] = {.lex_state = 426, .external_lex_state = 24},
  [7819] = {.lex_state = 213},
  [7820] = {.lex_state = 426, .external_lex_state = 24},
  [7821] = {.lex_state = 426, .external_lex_state = 26},
  [7822] = {.lex_state = 426, .external_lex_state = 24},
  [7823] = {.lex_state = 192, .external_lex_state = 2},
  [7824] = {.lex_state = 426, .external_lex_state = 24},
  [7825] = {.lex_state = 192, .external_lex_state = 2},
  [7826] = {.lex_state = 426, .external_lex_state = 24},
  [7827] = {.lex_state = 528, .external_lex_state = 29},
  [7828] = {.lex_state = 426, .external_lex_state = 24},
  [7829] = {.lex_state = 512, .external_lex_state = 24},
  [7830] = {.lex_state = 512, .external_lex_state = 24},
  [7831] = {.lex_state = 512, .external_lex_state = 24},
  [7832] = {.lex_state = 638, .external_lex_state = 26},
  [7833] = {.lex_state = 512, .external_lex_state = 24},
  [7834] = {.lex_state = 512, .external_lex_state = 24},
  [7835] = {.lex_state = 512, .external_lex_state = 24},
  [7836] = {.lex_state = 528, .external_lex_state = 12},
  [7837] = {.lex_state = 512, .external_lex_state = 24},
  [7838] = {.lex_state = 512, .external_lex_state = 24},
  [7839] = {.lex_state = 192, .external_lex_state = 2},
  [7840] = {.lex_state = 423, .external_lex_state = 24},
  [7841] = {.lex_state = 423, .external_lex_state = 24},
  [7842] = {.lex_state = 423, .external_lex_state = 24},
  [7843] = {.lex_state = 423, .external_lex_state = 24},
  [7844] = {.lex_state = 423, .external_lex_state = 24},
  [7845] = {.lex_state = 423, .external_lex_state = 24},
  [7846] = {.lex_state = 423, .external_lex_state = 24},
  [7847] = {.lex_state = 561, .external_lex_state = 16},
  [7848] = {.lex_state = 423, .external_lex_state = 24},
  [7849] = {.lex_state = 423, .external_lex_state = 24},
  [7850] = {.lex_state = 423, .external_lex_state = 24},
  [7851] = {.lex_state = 423, .external_lex_state = 24},
  [7852] = {.lex_state = 423, .external_lex_state = 24},
  [7853] = {.lex_state = 528, .external_lex_state = 12},
  [7854] = {.lex_state = 423, .external_lex_state = 24},
  [7855] = {.lex_state = 423, .external_lex_state = 24},
  [7856] = {.lex_state = 423, .external_lex_state = 24},
  [7857] = {.lex_state = 423, .external_lex_state = 24},
  [7858] = {.lex_state = 423, .external_lex_state = 24},
  [7859] = {.lex_state = 423, .external_lex_state = 26},
  [7860] = {.lex_state = 192, .external_lex_state = 28},
  [7861] = {.lex_state = 512, .external_lex_state = 24},
  [7862] = {.lex_state = 156, .external_lex_state = 3},
  [7863] = {.lex_state = 363, .external_lex_state = 3},
  [7864] = {.lex_state = 363, .external_lex_state = 3},
  [7865] = {.lex_state = 363, .external_lex_state = 3},
  [7866] = {.lex_state = 363, .external_lex_state = 3},
  [7867] = {.lex_state = 363, .external_lex_state = 3},
  [7868] = {.lex_state = 363, .external_lex_state = 3},
  [7869] = {.lex_state = 363, .external_lex_state = 3},
  [7870] = {.lex_state = 561, .external_lex_state = 16},
  [7871] = {.lex_state = 363, .external_lex_state = 3},
  [7872] = {.lex_state = 363, .external_lex_state = 3},
  [7873] = {.lex_state = 363, .external_lex_state = 3},
  [7874] = {.lex_state = 363, .external_lex_state = 3},
  [7875] = {.lex_state = 363, .external_lex_state = 3},
  [7876] = {.lex_state = 363, .external_lex_state = 3},
  [7877] = {.lex_state = 363, .external_lex_state = 3},
  [7878] = {.lex_state = 367, .external_lex_state = 14},
  [7879] = {.lex_state = 363, .external_lex_state = 3},
  [7880] = {.lex_state = 363, .external_lex_state = 3},
  [7881] = {.lex_state = 363, .external_lex_state = 3},
  [7882] = {.lex_state = 528, .external_lex_state = 12},
  [7883] = {.lex_state = 363, .external_lex_state = 3},
  [7884] = {.lex_state = 363, .external_lex_state = 3},
  [7885] = {.lex_state = 192, .external_lex_state = 2},
  [7886] = {.lex_state = 192, .external_lex_state = 28},
  [7887] = {.lex_state = 363, .external_lex_state = 3},
  [7888] = {.lex_state = 249, .external_lex_state = 3},
  [7889] = {.lex_state = 156, .external_lex_state = 3},
  [7890] = {.lex_state = 128},
  [7891] = {.lex_state = 532, .external_lex_state = 3},
  [7892] = {.lex_state = 532, .external_lex_state = 3},
  [7893] = {.lex_state = 532, .external_lex_state = 3},
  [7894] = {.lex_state = 532, .external_lex_state = 3},
  [7895] = {.lex_state = 532, .external_lex_state = 3},
  [7896] = {.lex_state = 561, .external_lex_state = 16},
  [7897] = {.lex_state = 532, .external_lex_state = 3},
  [7898] = {.lex_state = 532, .external_lex_state = 3},
  [7899] = {.lex_state = 532, .external_lex_state = 3},
  [7900] = {.lex_state = 532, .external_lex_state = 3},
  [7901] = {.lex_state = 532, .external_lex_state = 3},
  [7902] = {.lex_state = 532, .external_lex_state = 3},
  [7903] = {.lex_state = 532, .external_lex_state = 3},
  [7904] = {.lex_state = 192, .external_lex_state = 2},
  [7905] = {.lex_state = 192, .external_lex_state = 2},
  [7906] = {.lex_state = 192, .external_lex_state = 2},
  [7907] = {.lex_state = 363, .external_lex_state = 3},
  [7908] = {.lex_state = 213},
  [7909] = {.lex_state = 261, .external_lex_state = 3},
  [7910] = {.lex_state = 363, .external_lex_state = 3},
  [7911] = {.lex_state = 192, .external_lex_state = 2},
  [7912] = {.lex_state = 363, .external_lex_state = 3},
  [7913] = {.lex_state = 192, .external_lex_state = 2},
  [7914] = {.lex_state = 363, .external_lex_state = 3},
  [7915] = {.lex_state = 528, .external_lex_state = 29},
  [7916] = {.lex_state = 363, .external_lex_state = 3},
  [7917] = {.lex_state = 256, .external_lex_state = 13},
  [7918] = {.lex_state = 192, .external_lex_state = 2},
  [7919] = {.lex_state = 218, .external_lex_state = 10},
  [7920] = {.lex_state = 218, .external_lex_state = 10},
  [7921] = {.lex_state = 218, .external_lex_state = 10},
  [7922] = {.lex_state = 218, .external_lex_state = 10},
  [7923] = {.lex_state = 192, .external_lex_state = 2},
  [7924] = {.lex_state = 192, .external_lex_state = 2},
  [7925] = {.lex_state = 227, .external_lex_state = 7},
  [7926] = {.lex_state = 128, .external_lex_state = 13},
  [7927] = {.lex_state = 249, .external_lex_state = 3},
  [7928] = {.lex_state = 256, .external_lex_state = 10},
  [7929] = {.lex_state = 213},
  [7930] = {.lex_state = 261, .external_lex_state = 3},
  [7931] = {.lex_state = 264, .external_lex_state = 14},
  [7932] = {.lex_state = 128, .external_lex_state = 2},
  [7933] = {.lex_state = 128, .external_lex_state = 2},
  [7934] = {.lex_state = 128},
  [7935] = {.lex_state = 128, .external_lex_state = 2},
  [7936] = {.lex_state = 256, .external_lex_state = 13},
  [7937] = {.lex_state = 532, .external_lex_state = 3},
  [7938] = {.lex_state = 532, .external_lex_state = 3},
  [7939] = {.lex_state = 532, .external_lex_state = 3},
  [7940] = {.lex_state = 532, .external_lex_state = 3},
  [7941] = {.lex_state = 532, .external_lex_state = 3},
  [7942] = {.lex_state = 561, .external_lex_state = 16},
  [7943] = {.lex_state = 532, .external_lex_state = 3},
  [7944] = {.lex_state = 532, .external_lex_state = 3},
  [7945] = {.lex_state = 532, .external_lex_state = 3},
  [7946] = {.lex_state = 532, .external_lex_state = 3},
  [7947] = {.lex_state = 192, .external_lex_state = 2},
  [7948] = {.lex_state = 256, .external_lex_state = 10},
  [7949] = {.lex_state = 256, .external_lex_state = 10},
  [7950] = {.lex_state = 256, .external_lex_state = 10},
  [7951] = {.lex_state = 256, .external_lex_state = 10},
  [7952] = {.lex_state = 192, .external_lex_state = 2},
  [7953] = {.lex_state = 192, .external_lex_state = 2},
  [7954] = {.lex_state = 426, .external_lex_state = 3},
  [7955] = {.lex_state = 256, .external_lex_state = 10},
  [7956] = {.lex_state = 213},
  [7957] = {.lex_state = 426, .external_lex_state = 3},
  [7958] = {.lex_state = 426, .external_lex_state = 14},
  [7959] = {.lex_state = 426, .external_lex_state = 3},
  [7960] = {.lex_state = 192, .external_lex_state = 2},
  [7961] = {.lex_state = 426, .external_lex_state = 3},
  [7962] = {.lex_state = 192, .external_lex_state = 2},
  [7963] = {.lex_state = 426, .external_lex_state = 3},
  [7964] = {.lex_state = 528, .external_lex_state = 29},
  [7965] = {.lex_state = 426, .external_lex_state = 3},
  [7966] = {.lex_state = 192, .external_lex_state = 2},
  [7967] = {.lex_state = 532, .external_lex_state = 3},
  [7968] = {.lex_state = 532, .external_lex_state = 3},
  [7969] = {.lex_state = 532, .external_lex_state = 3},
  [7970] = {.lex_state = 367, .external_lex_state = 14},
  [7971] = {.lex_state = 363, .external_lex_state = 3},
  [7972] = {.lex_state = 363, .external_lex_state = 3},
  [7973] = {.lex_state = 363, .external_lex_state = 3},
  [7974] = {.lex_state = 363, .external_lex_state = 3},
  [7975] = {.lex_state = 363, .external_lex_state = 3},
  [7976] = {.lex_state = 363, .external_lex_state = 3},
  [7977] = {.lex_state = 363, .external_lex_state = 3},
  [7978] = {.lex_state = 561, .external_lex_state = 16},
  [7979] = {.lex_state = 363, .external_lex_state = 3},
  [7980] = {.lex_state = 363, .external_lex_state = 3},
  [7981] = {.lex_state = 363, .external_lex_state = 3},
  [7982] = {.lex_state = 363, .external_lex_state = 3},
  [7983] = {.lex_state = 363, .external_lex_state = 3},
  [7984] = {.lex_state = 363, .external_lex_state = 3},
  [7985] = {.lex_state = 363, .external_lex_state = 3},
  [7986] = {.lex_state = 367, .external_lex_state = 14},
  [7987] = {.lex_state = 363, .external_lex_state = 3},
  [7988] = {.lex_state = 363, .external_lex_state = 3},
  [7989] = {.lex_state = 363, .external_lex_state = 3},
  [7990] = {.lex_state = 528, .external_lex_state = 12},
  [7991] = {.lex_state = 363, .external_lex_state = 3},
  [7992] = {.lex_state = 363, .external_lex_state = 3},
  [7993] = {.lex_state = 192, .external_lex_state = 2},
  [7994] = {.lex_state = 423, .external_lex_state = 3},
  [7995] = {.lex_state = 423, .external_lex_state = 3},
  [7996] = {.lex_state = 423, .external_lex_state = 3},
  [7997] = {.lex_state = 528, .external_lex_state = 12},
  [7998] = {.lex_state = 423, .external_lex_state = 3},
  [7999] = {.lex_state = 423, .external_lex_state = 3},
  [8000] = {.lex_state = 192, .external_lex_state = 28},
  [8001] = {.lex_state = 363, .external_lex_state = 3},
  [8002] = {.lex_state = 363, .external_lex_state = 3},
  [8003] = {.lex_state = 363, .external_lex_state = 3},
  [8004] = {.lex_state = 363, .external_lex_state = 3},
  [8005] = {.lex_state = 363, .external_lex_state = 3},
  [8006] = {.lex_state = 363, .external_lex_state = 3},
  [8007] = {.lex_state = 363, .external_lex_state = 3},
  [8008] = {.lex_state = 363, .external_lex_state = 3},
  [8009] = {.lex_state = 561, .external_lex_state = 16},
  [8010] = {.lex_state = 363, .external_lex_state = 3},
  [8011] = {.lex_state = 363, .external_lex_state = 3},
  [8012] = {.lex_state = 363, .external_lex_state = 3},
  [8013] = {.lex_state = 363, .external_lex_state = 3},
  [8014] = {.lex_state = 363, .external_lex_state = 3},
  [8015] = {.lex_state = 528, .external_lex_state = 12},
  [8016] = {.lex_state = 363, .external_lex_state = 3},
  [8017] = {.lex_state = 363, .external_lex_state = 3},
  [8018] = {.lex_state = 363, .external_lex_state = 3},
  [8019] = {.lex_state = 363, .external_lex_state = 3},
  [8020] = {.lex_state = 363, .external_lex_state = 3},
  [8021] = {.lex_state = 352, .external_lex_state = 22},
  [8022] = {.lex_state = 358, .external_lex_state = 12},
  [8023] = {.lex_state = 352, .external_lex_state = 22},
  [8024] = {.lex_state = 352, .external_lex_state = 22},
  [8025] = {.lex_state = 418, .external_lex_state = 27},
  [8026] = {.lex_state = 345, .external_lex_state = 13},
  [8027] = {.lex_state = 237},
  [8028] = {.lex_state = 192, .external_lex_state = 2},
  [8029] = {.lex_state = 515, .external_lex_state = 10},
  [8030] = {.lex_state = 515, .external_lex_state = 10},
  [8031] = {.lex_state = 515, .external_lex_state = 10},
  [8032] = {.lex_state = 515, .external_lex_state = 10},
  [8033] = {.lex_state = 192, .external_lex_state = 2},
  [8034] = {.lex_state = 192, .external_lex_state = 2},
  [8035] = {.lex_state = 512, .external_lex_state = 3},
  [8036] = {.lex_state = 213},
  [8037] = {.lex_state = 426, .external_lex_state = 3},
  [8038] = {.lex_state = 638, .external_lex_state = 14},
  [8039] = {.lex_state = 512, .external_lex_state = 3},
  [8040] = {.lex_state = 512, .external_lex_state = 3},
  [8041] = {.lex_state = 641, .external_lex_state = 14},
  [8042] = {.lex_state = 192, .external_lex_state = 2},
  [8043] = {.lex_state = 512, .external_lex_state = 3},
  [8044] = {.lex_state = 512, .external_lex_state = 3},
  [8045] = {.lex_state = 192, .external_lex_state = 2},
  [8046] = {.lex_state = 192, .external_lex_state = 2},
  [8047] = {.lex_state = 239},
  [8048] = {.lex_state = 192, .external_lex_state = 2},
  [8049] = {.lex_state = 360, .external_lex_state = 10},
  [8050] = {.lex_state = 512, .external_lex_state = 3},
  [8051] = {.lex_state = 512, .external_lex_state = 3},
  [8052] = {.lex_state = 512, .external_lex_state = 3},
  [8053] = {.lex_state = 512, .external_lex_state = 14},
  [8054] = {.lex_state = 345, .external_lex_state = 13},
  [8055] = {.lex_state = 209},
  [8056] = {.lex_state = 512, .external_lex_state = 3},
  [8057] = {.lex_state = 192, .external_lex_state = 2},
  [8058] = {.lex_state = 192, .external_lex_state = 2},
  [8059] = {.lex_state = 192, .external_lex_state = 2},
  [8060] = {.lex_state = 192, .external_lex_state = 2},
  [8061] = {.lex_state = 192, .external_lex_state = 2},
  [8062] = {.lex_state = 192, .external_lex_state = 2},
  [8063] = {.lex_state = 192, .external_lex_state = 2},
  [8064] = {.lex_state = 192, .external_lex_state = 2},
  [8065] = {.lex_state = 192, .external_lex_state = 2},
  [8066] = {.lex_state = 192, .external_lex_state = 2},
  [8067] = {.lex_state = 192, .external_lex_state = 2},
  [8068] = {.lex_state = 345, .external_lex_state = 13},
  [8069] = {.lex_state = 177, .external_lex_state = 17},
  [8070] = {.lex_state = 345, .external_lex_state = 13},
  [8071] = {.lex_state = 528, .external_lex_state = 29},
  [8072] = {.lex_state = 685, .external_lex_state = 13},
  [8073] = {.lex_state = 192, .external_lex_state = 28},
  [8074] = {.lex_state = 192, .external_lex_state = 2},
  [8075] = {.lex_state = 641, .external_lex_state = 14},
  [8076] = {.lex_state = 128},
  [8077] = {.lex_state = 192, .external_lex_state = 2},
  [8078] = {.lex_state = 423, .external_lex_state = 3},
  [8079] = {.lex_state = 423, .external_lex_state = 3},
  [8080] = {.lex_state = 423, .external_lex_state = 3},
  [8081] = {.lex_state = 423, .external_lex_state = 3},
  [8082] = {.lex_state = 423, .external_lex_state = 3},
  [8083] = {.lex_state = 423, .external_lex_state = 3},
  [8084] = {.lex_state = 423, .external_lex_state = 3},
  [8085] = {.lex_state = 561, .external_lex_state = 16},
  [8086] = {.lex_state = 423, .external_lex_state = 3},
  [8087] = {.lex_state = 423, .external_lex_state = 3},
  [8088] = {.lex_state = 423, .external_lex_state = 3},
  [8089] = {.lex_state = 423, .external_lex_state = 3},
  [8090] = {.lex_state = 423, .external_lex_state = 3},
  [8091] = {.lex_state = 528, .external_lex_state = 12},
  [8092] = {.lex_state = 423, .external_lex_state = 3},
  [8093] = {.lex_state = 423, .external_lex_state = 3},
  [8094] = {.lex_state = 423, .external_lex_state = 3},
  [8095] = {.lex_state = 423, .external_lex_state = 3},
  [8096] = {.lex_state = 423, .external_lex_state = 3},
  [8097] = {.lex_state = 423, .external_lex_state = 14},
  [8098] = {.lex_state = 532, .external_lex_state = 3},
  [8099] = {.lex_state = 192, .external_lex_state = 28},
  [8100] = {.lex_state = 532, .external_lex_state = 3},
  [8101] = {.lex_state = 363, .external_lex_state = 3},
  [8102] = {.lex_state = 363, .external_lex_state = 3},
  [8103] = {.lex_state = 363, .external_lex_state = 3},
  [8104] = {.lex_state = 363, .external_lex_state = 3},
  [8105] = {.lex_state = 192, .external_lex_state = 2},
  [8106] = {.lex_state = 192, .external_lex_state = 2},
  [8107] = {.lex_state = 192, .external_lex_state = 2},
  [8108] = {.lex_state = 192, .external_lex_state = 2},
  [8109] = {.lex_state = 192, .external_lex_state = 2},
  [8110] = {.lex_state = 192, .external_lex_state = 2},
  [8111] = {.lex_state = 192, .external_lex_state = 2},
  [8112] = {.lex_state = 192, .external_lex_state = 2},
  [8113] = {.lex_state = 192, .external_lex_state = 2},
  [8114] = {.lex_state = 192, .external_lex_state = 2},
  [8115] = {.lex_state = 192, .external_lex_state = 28},
  [8116] = {.lex_state = 192, .external_lex_state = 2},
  [8117] = {.lex_state = 367, .external_lex_state = 14},
  [8118] = {.lex_state = 363, .external_lex_state = 3},
  [8119] = {.lex_state = 363, .external_lex_state = 3},
  [8120] = {.lex_state = 363, .external_lex_state = 3},
  [8121] = {.lex_state = 192, .external_lex_state = 2},
  [8122] = {.lex_state = 363, .external_lex_state = 3},
  [8123] = {.lex_state = 192, .external_lex_state = 2},
  [8124] = {.lex_state = 363, .external_lex_state = 3},
  [8125] = {.lex_state = 528, .external_lex_state = 29},
  [8126] = {.lex_state = 363, .external_lex_state = 3},
  [8127] = {.lex_state = 363, .external_lex_state = 3},
  [8128] = {.lex_state = 363, .external_lex_state = 3},
  [8129] = {.lex_state = 363, .external_lex_state = 3},
  [8130] = {.lex_state = 363, .external_lex_state = 3},
  [8131] = {.lex_state = 363, .external_lex_state = 3},
  [8132] = {.lex_state = 363, .external_lex_state = 3},
  [8133] = {.lex_state = 561, .external_lex_state = 16},
  [8134] = {.lex_state = 363, .external_lex_state = 3},
  [8135] = {.lex_state = 363, .external_lex_state = 3},
  [8136] = {.lex_state = 363, .external_lex_state = 3},
  [8137] = {.lex_state = 363, .external_lex_state = 3},
  [8138] = {.lex_state = 423, .external_lex_state = 3},
  [8139] = {.lex_state = 423, .external_lex_state = 3},
  [8140] = {.lex_state = 192, .external_lex_state = 2},
  [8141] = {.lex_state = 423, .external_lex_state = 3},
  [8142] = {.lex_state = 192, .external_lex_state = 2},
  [8143] = {.lex_state = 423, .external_lex_state = 3},
  [8144] = {.lex_state = 528, .external_lex_state = 29},
  [8145] = {.lex_state = 423, .external_lex_state = 3},
  [8146] = {.lex_state = 264, .external_lex_state = 3},
  [8147] = {.lex_state = 528, .external_lex_state = 12},
  [8148] = {.lex_state = 264, .external_lex_state = 3},
  [8149] = {.lex_state = 363, .external_lex_state = 3},
  [8150] = {.lex_state = 363, .external_lex_state = 3},
  [8151] = {.lex_state = 363, .external_lex_state = 3},
  [8152] = {.lex_state = 363, .external_lex_state = 3},
  [8153] = {.lex_state = 363, .external_lex_state = 14},
  [8154] = {.lex_state = 256, .external_lex_state = 13},
  [8155] = {.lex_state = 192, .external_lex_state = 2},
  [8156] = {.lex_state = 426, .external_lex_state = 3},
  [8157] = {.lex_state = 426, .external_lex_state = 3},
  [8158] = {.lex_state = 192, .external_lex_state = 2},
  [8159] = {.lex_state = 192, .external_lex_state = 2},
  [8160] = {.lex_state = 192, .external_lex_state = 2},
  [8161] = {.lex_state = 192, .external_lex_state = 2},
  [8162] = {.lex_state = 192, .external_lex_state = 2},
  [8163] = {.lex_state = 192, .external_lex_state = 2},
  [8164] = {.lex_state = 192, .external_lex_state = 2},
  [8165] = {.lex_state = 192, .external_lex_state = 2},
  [8166] = {.lex_state = 192, .external_lex_state = 2},
  [8167] = {.lex_state = 192, .external_lex_state = 2},
  [8168] = {.lex_state = 192, .external_lex_state = 28},
  [8169] = {.lex_state = 192, .external_lex_state = 2},
  [8170] = {.lex_state = 426, .external_lex_state = 14},
  [8171] = {.lex_state = 426, .external_lex_state = 3},
  [8172] = {.lex_state = 426, .external_lex_state = 3},
  [8173] = {.lex_state = 423, .external_lex_state = 3},
  [8174] = {.lex_state = 423, .external_lex_state = 3},
  [8175] = {.lex_state = 423, .external_lex_state = 3},
  [8176] = {.lex_state = 423, .external_lex_state = 3},
  [8177] = {.lex_state = 423, .external_lex_state = 3},
  [8178] = {.lex_state = 561, .external_lex_state = 16},
  [8179] = {.lex_state = 423, .external_lex_state = 3},
  [8180] = {.lex_state = 423, .external_lex_state = 3},
  [8181] = {.lex_state = 423, .external_lex_state = 3},
  [8182] = {.lex_state = 423, .external_lex_state = 3},
  [8183] = {.lex_state = 426, .external_lex_state = 3},
  [8184] = {.lex_state = 528, .external_lex_state = 12},
  [8185] = {.lex_state = 426, .external_lex_state = 3},
  [8186] = {.lex_state = 426, .external_lex_state = 3},
  [8187] = {.lex_state = 423, .external_lex_state = 3},
  [8188] = {.lex_state = 423, .external_lex_state = 3},
  [8189] = {.lex_state = 423, .external_lex_state = 3},
  [8190] = {.lex_state = 423, .external_lex_state = 14},
  [8191] = {.lex_state = 532, .external_lex_state = 3},
  [8192] = {.lex_state = 532, .external_lex_state = 3},
  [8193] = {.lex_state = 532, .external_lex_state = 3},
  [8194] = {.lex_state = 192, .external_lex_state = 2},
  [8195] = {.lex_state = 192, .external_lex_state = 2},
  [8196] = {.lex_state = 192, .external_lex_state = 2},
  [8197] = {.lex_state = 192, .external_lex_state = 2},
  [8198] = {.lex_state = 192, .external_lex_state = 2},
  [8199] = {.lex_state = 192, .external_lex_state = 2},
  [8200] = {.lex_state = 192, .external_lex_state = 2},
  [8201] = {.lex_state = 192, .external_lex_state = 2},
  [8202] = {.lex_state = 192, .external_lex_state = 2},
  [8203] = {.lex_state = 192, .external_lex_state = 2},
  [8204] = {.lex_state = 192, .external_lex_state = 28},
  [8205] = {.lex_state = 532, .external_lex_state = 3},
  [8206] = {.lex_state = 192, .external_lex_state = 28},
  [8207] = {.lex_state = 192, .external_lex_state = 2},
  [8208] = {.lex_state = 363, .external_lex_state = 3},
  [8209] = {.lex_state = 363, .external_lex_state = 3},
  [8210] = {.lex_state = 363, .external_lex_state = 3},
  [8211] = {.lex_state = 363, .external_lex_state = 3},
  [8212] = {.lex_state = 192, .external_lex_state = 2},
  [8213] = {.lex_state = 192, .external_lex_state = 2},
  [8214] = {.lex_state = 192, .external_lex_state = 2},
  [8215] = {.lex_state = 192, .external_lex_state = 2},
  [8216] = {.lex_state = 192, .external_lex_state = 2},
  [8217] = {.lex_state = 192, .external_lex_state = 2},
  [8218] = {.lex_state = 192, .external_lex_state = 2},
  [8219] = {.lex_state = 192, .external_lex_state = 2},
  [8220] = {.lex_state = 192, .external_lex_state = 2},
  [8221] = {.lex_state = 192, .external_lex_state = 2},
  [8222] = {.lex_state = 192, .external_lex_state = 28},
  [8223] = {.lex_state = 192, .external_lex_state = 2},
  [8224] = {.lex_state = 367, .external_lex_state = 14},
  [8225] = {.lex_state = 363, .external_lex_state = 3},
  [8226] = {.lex_state = 363, .external_lex_state = 3},
  [8227] = {.lex_state = 363, .external_lex_state = 3},
  [8228] = {.lex_state = 192, .external_lex_state = 2},
  [8229] = {.lex_state = 363, .external_lex_state = 3},
  [8230] = {.lex_state = 192, .external_lex_state = 2},
  [8231] = {.lex_state = 363, .external_lex_state = 3},
  [8232] = {.lex_state = 528, .external_lex_state = 29},
  [8233] = {.lex_state = 363, .external_lex_state = 3},
  [8234] = {.lex_state = 363, .external_lex_state = 3},
  [8235] = {.lex_state = 363, .external_lex_state = 3},
  [8236] = {.lex_state = 363, .external_lex_state = 3},
  [8237] = {.lex_state = 363, .external_lex_state = 3},
  [8238] = {.lex_state = 363, .external_lex_state = 3},
  [8239] = {.lex_state = 363, .external_lex_state = 3},
  [8240] = {.lex_state = 561, .external_lex_state = 16},
  [8241] = {.lex_state = 363, .external_lex_state = 3},
  [8242] = {.lex_state = 363, .external_lex_state = 3},
  [8243] = {.lex_state = 363, .external_lex_state = 3},
  [8244] = {.lex_state = 363, .external_lex_state = 3},
  [8245] = {.lex_state = 423, .external_lex_state = 3},
  [8246] = {.lex_state = 423, .external_lex_state = 3},
  [8247] = {.lex_state = 192, .external_lex_state = 2},
  [8248] = {.lex_state = 423, .external_lex_state = 3},
  [8249] = {.lex_state = 192, .external_lex_state = 2},
  [8250] = {.lex_state = 423, .external_lex_state = 3},
  [8251] = {.lex_state = 528, .external_lex_state = 29},
  [8252] = {.lex_state = 423, .external_lex_state = 3},
  [8253] = {.lex_state = 264, .external_lex_state = 3},
  [8254] = {.lex_state = 528, .external_lex_state = 12},
  [8255] = {.lex_state = 264, .external_lex_state = 3},
  [8256] = {.lex_state = 363, .external_lex_state = 3},
  [8257] = {.lex_state = 363, .external_lex_state = 3},
  [8258] = {.lex_state = 363, .external_lex_state = 3},
  [8259] = {.lex_state = 363, .external_lex_state = 3},
  [8260] = {.lex_state = 363, .external_lex_state = 14},
  [8261] = {.lex_state = 256, .external_lex_state = 13},
  [8262] = {.lex_state = 192, .external_lex_state = 2},
  [8263] = {.lex_state = 426, .external_lex_state = 3},
  [8264] = {.lex_state = 426, .external_lex_state = 3},
  [8265] = {.lex_state = 192, .external_lex_state = 2},
  [8266] = {.lex_state = 192, .external_lex_state = 2},
  [8267] = {.lex_state = 192, .external_lex_state = 2},
  [8268] = {.lex_state = 192, .external_lex_state = 2},
  [8269] = {.lex_state = 192, .external_lex_state = 2},
  [8270] = {.lex_state = 192, .external_lex_state = 2},
  [8271] = {.lex_state = 192, .external_lex_state = 2},
  [8272] = {.lex_state = 192, .external_lex_state = 2},
  [8273] = {.lex_state = 192, .external_lex_state = 2},
  [8274] = {.lex_state = 192, .external_lex_state = 2},
  [8275] = {.lex_state = 192, .external_lex_state = 28},
  [8276] = {.lex_state = 192, .external_lex_state = 2},
  [8277] = {.lex_state = 426, .external_lex_state = 14},
  [8278] = {.lex_state = 426, .external_lex_state = 3},
  [8279] = {.lex_state = 426, .external_lex_state = 3},
  [8280] = {.lex_state = 423, .external_lex_state = 3},
  [8281] = {.lex_state = 423, .external_lex_state = 3},
  [8282] = {.lex_state = 423, .external_lex_state = 3},
  [8283] = {.lex_state = 423, .external_lex_state = 3},
  [8284] = {.lex_state = 423, .external_lex_state = 3},
  [8285] = {.lex_state = 561, .external_lex_state = 16},
  [8286] = {.lex_state = 423, .external_lex_state = 3},
  [8287] = {.lex_state = 423, .external_lex_state = 3},
  [8288] = {.lex_state = 423, .external_lex_state = 3},
  [8289] = {.lex_state = 423, .external_lex_state = 3},
  [8290] = {.lex_state = 426, .external_lex_state = 3},
  [8291] = {.lex_state = 528, .external_lex_state = 12},
  [8292] = {.lex_state = 426, .external_lex_state = 3},
  [8293] = {.lex_state = 426, .external_lex_state = 3},
  [8294] = {.lex_state = 423, .external_lex_state = 3},
  [8295] = {.lex_state = 423, .external_lex_state = 3},
  [8296] = {.lex_state = 423, .external_lex_state = 3},
  [8297] = {.lex_state = 423, .external_lex_state = 14},
  [8298] = {.lex_state = 532, .external_lex_state = 3},
  [8299] = {.lex_state = 532, .external_lex_state = 3},
  [8300] = {.lex_state = 532, .external_lex_state = 3},
  [8301] = {.lex_state = 192, .external_lex_state = 2},
  [8302] = {.lex_state = 192, .external_lex_state = 2},
  [8303] = {.lex_state = 192, .external_lex_state = 2},
  [8304] = {.lex_state = 192, .external_lex_state = 2},
  [8305] = {.lex_state = 192, .external_lex_state = 2},
  [8306] = {.lex_state = 192, .external_lex_state = 2},
  [8307] = {.lex_state = 192, .external_lex_state = 2},
  [8308] = {.lex_state = 192, .external_lex_state = 2},
  [8309] = {.lex_state = 192, .external_lex_state = 2},
  [8310] = {.lex_state = 192, .external_lex_state = 2},
  [8311] = {.lex_state = 192, .external_lex_state = 28},
  [8312] = {.lex_state = 532, .external_lex_state = 3},
  [8313] = {.lex_state = 192, .external_lex_state = 28},
  [8314] = {.lex_state = 192, .external_lex_state = 2},
  [8315] = {.lex_state = 156, .external_lex_state = 3},
  [8316] = {.lex_state = 249, .external_lex_state = 3},
  [8317] = {.lex_state = 426, .external_lex_state = 3},
  [8318] = {.lex_state = 426, .external_lex_state = 3},
  [8319] = {.lex_state = 426, .external_lex_state = 3},
  [8320] = {.lex_state = 426, .external_lex_state = 3},
  [8321] = {.lex_state = 426, .external_lex_state = 3},
  [8322] = {.lex_state = 561, .external_lex_state = 16},
  [8323] = {.lex_state = 426, .external_lex_state = 3},
  [8324] = {.lex_state = 426, .external_lex_state = 3},
  [8325] = {.lex_state = 426, .external_lex_state = 3},
  [8326] = {.lex_state = 426, .external_lex_state = 3},
  [8327] = {.lex_state = 426, .external_lex_state = 3},
  [8328] = {.lex_state = 426, .external_lex_state = 3},
  [8329] = {.lex_state = 426, .external_lex_state = 3},
  [8330] = {.lex_state = 426, .external_lex_state = 14},
  [8331] = {.lex_state = 192, .external_lex_state = 2},
  [8332] = {.lex_state = 192, .external_lex_state = 28},
  [8333] = {.lex_state = 423, .external_lex_state = 3},
  [8334] = {.lex_state = 532, .external_lex_state = 3},
  [8335] = {.lex_state = 532, .external_lex_state = 3},
  [8336] = {.lex_state = 532, .external_lex_state = 3},
  [8337] = {.lex_state = 532, .external_lex_state = 3},
  [8338] = {.lex_state = 532, .external_lex_state = 3},
  [8339] = {.lex_state = 561, .external_lex_state = 16},
  [8340] = {.lex_state = 532, .external_lex_state = 3},
  [8341] = {.lex_state = 532, .external_lex_state = 3},
  [8342] = {.lex_state = 532, .external_lex_state = 3},
  [8343] = {.lex_state = 532, .external_lex_state = 3},
  [8344] = {.lex_state = 532, .external_lex_state = 3},
  [8345] = {.lex_state = 532, .external_lex_state = 3},
  [8346] = {.lex_state = 532, .external_lex_state = 3},
  [8347] = {.lex_state = 390, .external_lex_state = 24},
  [8348] = {.lex_state = 177, .external_lex_state = 4},
  [8349] = {.lex_state = 390, .external_lex_state = 24},
  [8350] = {.lex_state = 390, .external_lex_state = 24},
  [8351] = {.lex_state = 177, .external_lex_state = 4},
  [8352] = {.lex_state = 390, .external_lex_state = 24},
  [8353] = {.lex_state = 408, .external_lex_state = 24},
  [8354] = {.lex_state = 408, .external_lex_state = 24},
  [8355] = {.lex_state = 192, .external_lex_state = 2},
  [8356] = {.lex_state = 192, .external_lex_state = 2},
  [8357] = {.lex_state = 192, .external_lex_state = 2},
  [8358] = {.lex_state = 192, .external_lex_state = 2},
  [8359] = {.lex_state = 192, .external_lex_state = 2},
  [8360] = {.lex_state = 192, .external_lex_state = 2},
  [8361] = {.lex_state = 192, .external_lex_state = 2},
  [8362] = {.lex_state = 192, .external_lex_state = 2},
  [8363] = {.lex_state = 192, .external_lex_state = 2},
  [8364] = {.lex_state = 192, .external_lex_state = 2},
  [8365] = {.lex_state = 192, .external_lex_state = 28},
  [8366] = {.lex_state = 192, .external_lex_state = 2},
  [8367] = {.lex_state = 408, .external_lex_state = 24},
  [8368] = {.lex_state = 408, .external_lex_state = 24},
  [8369] = {.lex_state = 408, .external_lex_state = 24},
  [8370] = {.lex_state = 528, .external_lex_state = 12},
  [8371] = {.lex_state = 408, .external_lex_state = 24},
  [8372] = {.lex_state = 408, .external_lex_state = 24},
  [8373] = {.lex_state = 192, .external_lex_state = 2},
  [8374] = {.lex_state = 541, .external_lex_state = 24},
  [8375] = {.lex_state = 541, .external_lex_state = 24},
  [8376] = {.lex_state = 192, .external_lex_state = 2},
  [8377] = {.lex_state = 192, .external_lex_state = 2},
  [8378] = {.lex_state = 192, .external_lex_state = 2},
  [8379] = {.lex_state = 192, .external_lex_state = 2},
  [8380] = {.lex_state = 192, .external_lex_state = 2},
  [8381] = {.lex_state = 192, .external_lex_state = 2},
  [8382] = {.lex_state = 192, .external_lex_state = 2},
  [8383] = {.lex_state = 192, .external_lex_state = 2},
  [8384] = {.lex_state = 192, .external_lex_state = 2},
  [8385] = {.lex_state = 192, .external_lex_state = 2},
  [8386] = {.lex_state = 192, .external_lex_state = 28},
  [8387] = {.lex_state = 192, .external_lex_state = 2},
  [8388] = {.lex_state = 541, .external_lex_state = 26},
  [8389] = {.lex_state = 541, .external_lex_state = 24},
  [8390] = {.lex_state = 541, .external_lex_state = 24},
  [8391] = {.lex_state = 541, .external_lex_state = 24},
  [8392] = {.lex_state = 528, .external_lex_state = 12},
  [8393] = {.lex_state = 541, .external_lex_state = 24},
  [8394] = {.lex_state = 541, .external_lex_state = 24},
  [8395] = {.lex_state = 402, .external_lex_state = 24},
  [8396] = {.lex_state = 192, .external_lex_state = 28},
  [8397] = {.lex_state = 402, .external_lex_state = 24},
  [8398] = {.lex_state = 227, .external_lex_state = 7},
  [8399] = {.lex_state = 390, .external_lex_state = 24},
  [8400] = {.lex_state = 390, .external_lex_state = 24},
  [8401] = {.lex_state = 192, .external_lex_state = 2},
  [8402] = {.lex_state = 192, .external_lex_state = 28},
  [8403] = {.lex_state = 408, .external_lex_state = 24},
  [8404] = {.lex_state = 390, .external_lex_state = 24},
  [8405] = {.lex_state = 390, .external_lex_state = 24},
  [8406] = {.lex_state = 390, .external_lex_state = 24},
  [8407] = {.lex_state = 390, .external_lex_state = 24},
  [8408] = {.lex_state = 390, .external_lex_state = 24},
  [8409] = {.lex_state = 128},
  [8410] = {.lex_state = 390, .external_lex_state = 24},
  [8411] = {.lex_state = 128},
  [8412] = {.lex_state = 128},
  [8413] = {.lex_state = 390, .external_lex_state = 24},
  [8414] = {.lex_state = 128},
  [8415] = {.lex_state = 390, .external_lex_state = 24},
  [8416] = {.lex_state = 390, .external_lex_state = 24},
  [8417] = {.lex_state = 128},
  [8418] = {.lex_state = 128, .external_lex_state = 2},
  [8419] = {.lex_state = 402, .external_lex_state = 24},
  [8420] = {.lex_state = 548, .external_lex_state = 25},
  [8421] = {.lex_state = 399, .external_lex_state = 24},
  [8422] = {.lex_state = 399, .external_lex_state = 24},
  [8423] = {.lex_state = 128},
  [8424] = {.lex_state = 128, .external_lex_state = 2},
  [8425] = {.lex_state = 192, .external_lex_state = 2},
  [8426] = {.lex_state = 192, .external_lex_state = 28},
  [8427] = {.lex_state = 405, .external_lex_state = 24},
  [8428] = {.lex_state = 528, .external_lex_state = 12},
  [8429] = {.lex_state = 551, .external_lex_state = 24},
  [8430] = {.lex_state = 402, .external_lex_state = 24},
  [8431] = {.lex_state = 239},
  [8432] = {.lex_state = 128},
  [8433] = {.lex_state = 288, .external_lex_state = 2},
  [8434] = {.lex_state = 239},
  [8435] = {.lex_state = 192, .external_lex_state = 2},
  [8436] = {.lex_state = 515, .external_lex_state = 18},
  [8437] = {.lex_state = 515, .external_lex_state = 18},
  [8438] = {.lex_state = 515, .external_lex_state = 18},
  [8439] = {.lex_state = 515, .external_lex_state = 18},
  [8440] = {.lex_state = 192, .external_lex_state = 2},
  [8441] = {.lex_state = 192, .external_lex_state = 2},
  [8442] = {.lex_state = 304, .external_lex_state = 16},
  [8443] = {.lex_state = 256, .external_lex_state = 18},
  [8444] = {.lex_state = 213},
  [8445] = {.lex_state = 229, .external_lex_state = 16},
  [8446] = {.lex_state = 253, .external_lex_state = 20},
  [8447] = {.lex_state = 304, .external_lex_state = 16},
  [8448] = {.lex_state = 128},
  [8449] = {.lex_state = 239},
  [8450] = {.lex_state = 239},
  [8451] = {.lex_state = 339},
  [8452] = {.lex_state = 239},
  [8453] = {.lex_state = 128, .external_lex_state = 11},
  [8454] = {.lex_state = 239},
  [8455] = {.lex_state = 128},
  [8456] = {.lex_state = 239},
  [8457] = {.lex_state = 156, .external_lex_state = 3},
  [8458] = {.lex_state = 128},
  [8459] = {.lex_state = 304, .external_lex_state = 16},
  [8460] = {.lex_state = 304, .external_lex_state = 16},
  [8461] = {.lex_state = 304, .external_lex_state = 16},
  [8462] = {.lex_state = 304, .external_lex_state = 16},
  [8463] = {.lex_state = 304, .external_lex_state = 16},
  [8464] = {.lex_state = 561, .external_lex_state = 16},
  [8465] = {.lex_state = 304, .external_lex_state = 16},
  [8466] = {.lex_state = 304, .external_lex_state = 16},
  [8467] = {.lex_state = 304, .external_lex_state = 16},
  [8468] = {.lex_state = 304, .external_lex_state = 16},
  [8469] = {.lex_state = 423, .external_lex_state = 24},
  [8470] = {.lex_state = 192, .external_lex_state = 2},
  [8471] = {.lex_state = 304, .external_lex_state = 16},
  [8472] = {.lex_state = 304, .external_lex_state = 16},
  [8473] = {.lex_state = 304, .external_lex_state = 16},
  [8474] = {.lex_state = 253, .external_lex_state = 20},
  [8475] = {.lex_state = 650, .external_lex_state = 24},
  [8476] = {.lex_state = 650, .external_lex_state = 24},
  [8477] = {.lex_state = 650, .external_lex_state = 24},
  [8478] = {.lex_state = 650, .external_lex_state = 24},
  [8479] = {.lex_state = 192, .external_lex_state = 2},
  [8480] = {.lex_state = 192, .external_lex_state = 2},
  [8481] = {.lex_state = 192, .external_lex_state = 2},
  [8482] = {.lex_state = 192, .external_lex_state = 2},
  [8483] = {.lex_state = 192, .external_lex_state = 2},
  [8484] = {.lex_state = 192, .external_lex_state = 2},
  [8485] = {.lex_state = 192, .external_lex_state = 2},
  [8486] = {.lex_state = 192, .external_lex_state = 2},
  [8487] = {.lex_state = 192, .external_lex_state = 2},
  [8488] = {.lex_state = 192, .external_lex_state = 2},
  [8489] = {.lex_state = 192, .external_lex_state = 28},
  [8490] = {.lex_state = 192, .external_lex_state = 2},
  [8491] = {.lex_state = 650, .external_lex_state = 26},
  [8492] = {.lex_state = 659, .external_lex_state = 26},
  [8493] = {.lex_state = 192, .external_lex_state = 15},
  [8494] = {.lex_state = 650, .external_lex_state = 24},
  [8495] = {.lex_state = 659, .external_lex_state = 24},
  [8496] = {.lex_state = 659, .external_lex_state = 24},
  [8497] = {.lex_state = 192, .external_lex_state = 2},
  [8498] = {.lex_state = 659, .external_lex_state = 24},
  [8499] = {.lex_state = 192, .external_lex_state = 2},
  [8500] = {.lex_state = 659, .external_lex_state = 24},
  [8501] = {.lex_state = 528, .external_lex_state = 29},
  [8502] = {.lex_state = 659, .external_lex_state = 24},
  [8503] = {.lex_state = 650, .external_lex_state = 24},
  [8504] = {.lex_state = 659, .external_lex_state = 24},
  [8505] = {.lex_state = 659, .external_lex_state = 24},
  [8506] = {.lex_state = 659, .external_lex_state = 24},
  [8507] = {.lex_state = 659, .external_lex_state = 24},
  [8508] = {.lex_state = 659, .external_lex_state = 24},
  [8509] = {.lex_state = 561, .external_lex_state = 16},
  [8510] = {.lex_state = 659, .external_lex_state = 24},
  [8511] = {.lex_state = 659, .external_lex_state = 24},
  [8512] = {.lex_state = 659, .external_lex_state = 24},
  [8513] = {.lex_state = 659, .external_lex_state = 24},
  [8514] = {.lex_state = 663, .external_lex_state = 24},
  [8515] = {.lex_state = 663, .external_lex_state = 24},
  [8516] = {.lex_state = 192, .external_lex_state = 2},
  [8517] = {.lex_state = 663, .external_lex_state = 24},
  [8518] = {.lex_state = 192, .external_lex_state = 2},
  [8519] = {.lex_state = 663, .external_lex_state = 24},
  [8520] = {.lex_state = 528, .external_lex_state = 29},
  [8521] = {.lex_state = 663, .external_lex_state = 24},
  [8522] = {.lex_state = 569, .external_lex_state = 24},
  [8523] = {.lex_state = 528, .external_lex_state = 12},
  [8524] = {.lex_state = 569, .external_lex_state = 24},
  [8525] = {.lex_state = 650, .external_lex_state = 24},
  [8526] = {.lex_state = 659, .external_lex_state = 24},
  [8527] = {.lex_state = 659, .external_lex_state = 24},
  [8528] = {.lex_state = 659, .external_lex_state = 24},
  [8529] = {.lex_state = 659, .external_lex_state = 26},
  [8530] = {.lex_state = 192, .external_lex_state = 2},
  [8531] = {.lex_state = 566, .external_lex_state = 24},
  [8532] = {.lex_state = 566, .external_lex_state = 24},
  [8533] = {.lex_state = 192, .external_lex_state = 2},
  [8534] = {.lex_state = 192, .external_lex_state = 2},
  [8535] = {.lex_state = 192, .external_lex_state = 2},
  [8536] = {.lex_state = 192, .external_lex_state = 2},
  [8537] = {.lex_state = 192, .external_lex_state = 2},
  [8538] = {.lex_state = 192, .external_lex_state = 2},
  [8539] = {.lex_state = 192, .external_lex_state = 2},
  [8540] = {.lex_state = 192, .external_lex_state = 2},
  [8541] = {.lex_state = 192, .external_lex_state = 2},
  [8542] = {.lex_state = 192, .external_lex_state = 2},
  [8543] = {.lex_state = 192, .external_lex_state = 28},
  [8544] = {.lex_state = 192, .external_lex_state = 2},
  [8545] = {.lex_state = 566, .external_lex_state = 26},
  [8546] = {.lex_state = 663, .external_lex_state = 26},
  [8547] = {.lex_state = 192, .external_lex_state = 15},
  [8548] = {.lex_state = 566, .external_lex_state = 24},
  [8549] = {.lex_state = 566, .external_lex_state = 24},
  [8550] = {.lex_state = 663, .external_lex_state = 24},
  [8551] = {.lex_state = 663, .external_lex_state = 24},
  [8552] = {.lex_state = 663, .external_lex_state = 24},
  [8553] = {.lex_state = 663, .external_lex_state = 24},
  [8554] = {.lex_state = 663, .external_lex_state = 24},
  [8555] = {.lex_state = 561, .external_lex_state = 16},
  [8556] = {.lex_state = 663, .external_lex_state = 24},
  [8557] = {.lex_state = 663, .external_lex_state = 24},
  [8558] = {.lex_state = 663, .external_lex_state = 24},
  [8559] = {.lex_state = 663, .external_lex_state = 24},
  [8560] = {.lex_state = 566, .external_lex_state = 24},
  [8561] = {.lex_state = 528, .external_lex_state = 12},
  [8562] = {.lex_state = 566, .external_lex_state = 24},
  [8563] = {.lex_state = 566, .external_lex_state = 24},
  [8564] = {.lex_state = 663, .external_lex_state = 24},
  [8565] = {.lex_state = 663, .external_lex_state = 24},
  [8566] = {.lex_state = 663, .external_lex_state = 24},
  [8567] = {.lex_state = 663, .external_lex_state = 26},
  [8568] = {.lex_state = 561, .external_lex_state = 16},
  [8569] = {.lex_state = 561, .external_lex_state = 16},
  [8570] = {.lex_state = 561, .external_lex_state = 16},
  [8571] = {.lex_state = 192, .external_lex_state = 2},
  [8572] = {.lex_state = 192, .external_lex_state = 2},
  [8573] = {.lex_state = 192, .external_lex_state = 2},
  [8574] = {.lex_state = 192, .external_lex_state = 2},
  [8575] = {.lex_state = 192, .external_lex_state = 2},
  [8576] = {.lex_state = 192, .external_lex_state = 2},
  [8577] = {.lex_state = 192, .external_lex_state = 2},
  [8578] = {.lex_state = 192, .external_lex_state = 2},
  [8579] = {.lex_state = 192, .external_lex_state = 2},
  [8580] = {.lex_state = 192, .external_lex_state = 2},
  [8581] = {.lex_state = 192, .external_lex_state = 28},
  [8582] = {.lex_state = 561, .external_lex_state = 16},
  [8583] = {.lex_state = 192, .external_lex_state = 28},
  [8584] = {.lex_state = 192, .external_lex_state = 2},
  [8585] = {.lex_state = 650, .external_lex_state = 20},
  [8586] = {.lex_state = 301, .external_lex_state = 3},
  [8587] = {.lex_state = 177, .external_lex_state = 4},
  [8588] = {.lex_state = 301, .external_lex_state = 3},
  [8589] = {.lex_state = 301, .external_lex_state = 3},
  [8590] = {.lex_state = 177, .external_lex_state = 4},
  [8591] = {.lex_state = 301, .external_lex_state = 3},
  [8592] = {.lex_state = 229, .external_lex_state = 3},
  [8593] = {.lex_state = 229, .external_lex_state = 3},
  [8594] = {.lex_state = 177, .external_lex_state = 4},
  [8595] = {.lex_state = 268, .external_lex_state = 15},
  [8596] = {.lex_state = 229, .external_lex_state = 3},
  [8597] = {.lex_state = 177, .external_lex_state = 4},
  [8598] = {.lex_state = 229, .external_lex_state = 3},
  [8599] = {.lex_state = 229, .external_lex_state = 3},
  [8600] = {.lex_state = 177, .external_lex_state = 4},
  [8601] = {.lex_state = 268, .external_lex_state = 15},
  [8602] = {.lex_state = 229, .external_lex_state = 3},
  [8603] = {.lex_state = 177, .external_lex_state = 4},
  [8604] = {.lex_state = 229, .external_lex_state = 3},
  [8605] = {.lex_state = 312},
  [8606] = {.lex_state = 229, .external_lex_state = 3},
  [8607] = {.lex_state = 229, .external_lex_state = 3},
  [8608] = {.lex_state = 128, .external_lex_state = 2},
  [8609] = {.lex_state = 128, .external_lex_state = 2},
  [8610] = {.lex_state = 229, .external_lex_state = 3},
  [8611] = {.lex_state = 229, .external_lex_state = 3},
  [8612] = {.lex_state = 229, .external_lex_state = 3},
  [8613] = {.lex_state = 128},
  [8614] = {.lex_state = 229, .external_lex_state = 3},
  [8615] = {.lex_state = 128},
  [8616] = {.lex_state = 229, .external_lex_state = 3},
  [8617] = {.lex_state = 128},
  [8618] = {.lex_state = 229, .external_lex_state = 3},
  [8619] = {.lex_state = 128},
  [8620] = {.lex_state = 128, .external_lex_state = 2},
  [8621] = {.lex_state = 229, .external_lex_state = 3},
  [8622] = {.lex_state = 128},
  [8623] = {.lex_state = 128},
  [8624] = {.lex_state = 128},
  [8625] = {.lex_state = 229, .external_lex_state = 3},
  [8626] = {.lex_state = 128},
  [8627] = {.lex_state = 128},
  [8628] = {.lex_state = 192, .external_lex_state = 2},
  [8629] = {.lex_state = 192, .external_lex_state = 28},
  [8630] = {.lex_state = 426, .external_lex_state = 3},
  [8631] = {.lex_state = 595, .external_lex_state = 3},
  [8632] = {.lex_state = 595, .external_lex_state = 3},
  [8633] = {.lex_state = 459, .external_lex_state = 3},
  [8634] = {.lex_state = 528, .external_lex_state = 12},
  [8635] = {.lex_state = 459, .external_lex_state = 3},
  [8636] = {.lex_state = 595, .external_lex_state = 3},
  [8637] = {.lex_state = 192, .external_lex_state = 2},
  [8638] = {.lex_state = 580, .external_lex_state = 3},
  [8639] = {.lex_state = 580, .external_lex_state = 3},
  [8640] = {.lex_state = 580, .external_lex_state = 3},
  [8641] = {.lex_state = 528, .external_lex_state = 12},
  [8642] = {.lex_state = 580, .external_lex_state = 3},
  [8643] = {.lex_state = 580, .external_lex_state = 3},
  [8644] = {.lex_state = 438, .external_lex_state = 3},
  [8645] = {.lex_state = 438, .external_lex_state = 3},
  [8646] = {.lex_state = 438, .external_lex_state = 3},
  [8647] = {.lex_state = 192, .external_lex_state = 2},
  [8648] = {.lex_state = 192, .external_lex_state = 2},
  [8649] = {.lex_state = 192, .external_lex_state = 2},
  [8650] = {.lex_state = 192, .external_lex_state = 2},
  [8651] = {.lex_state = 192, .external_lex_state = 2},
  [8652] = {.lex_state = 192, .external_lex_state = 2},
  [8653] = {.lex_state = 192, .external_lex_state = 2},
  [8654] = {.lex_state = 192, .external_lex_state = 2},
  [8655] = {.lex_state = 192, .external_lex_state = 2},
  [8656] = {.lex_state = 192, .external_lex_state = 2},
  [8657] = {.lex_state = 192, .external_lex_state = 28},
  [8658] = {.lex_state = 438, .external_lex_state = 3},
  [8659] = {.lex_state = 192, .external_lex_state = 28},
  [8660] = {.lex_state = 192, .external_lex_state = 2},
  [8661] = {.lex_state = 227, .external_lex_state = 7},
  [8662] = {.lex_state = 301, .external_lex_state = 3},
  [8663] = {.lex_state = 301, .external_lex_state = 3},
  [8664] = {.lex_state = 301, .external_lex_state = 3},
  [8665] = {.lex_state = 301, .external_lex_state = 3},
  [8666] = {.lex_state = 301, .external_lex_state = 3},
  [8667] = {.lex_state = 301, .external_lex_state = 3},
  [8668] = {.lex_state = 301, .external_lex_state = 3},
  [8669] = {.lex_state = 128},
  [8670] = {.lex_state = 229, .external_lex_state = 3},
  [8671] = {.lex_state = 128},
  [8672] = {.lex_state = 301, .external_lex_state = 3},
  [8673] = {.lex_state = 128},
  [8674] = {.lex_state = 128},
  [8675] = {.lex_state = 301, .external_lex_state = 3},
  [8676] = {.lex_state = 128},
  [8677] = {.lex_state = 423, .external_lex_state = 3},
  [8678] = {.lex_state = 301, .external_lex_state = 3},
  [8679] = {.lex_state = 423, .external_lex_state = 3},
  [8680] = {.lex_state = 192, .external_lex_state = 2},
  [8681] = {.lex_state = 363, .external_lex_state = 3},
  [8682] = {.lex_state = 363, .external_lex_state = 3},
  [8683] = {.lex_state = 363, .external_lex_state = 3},
  [8684] = {.lex_state = 363, .external_lex_state = 3},
  [8685] = {.lex_state = 192, .external_lex_state = 2},
  [8686] = {.lex_state = 192, .external_lex_state = 2},
  [8687] = {.lex_state = 192, .external_lex_state = 2},
  [8688] = {.lex_state = 192, .external_lex_state = 2},
  [8689] = {.lex_state = 192, .external_lex_state = 2},
  [8690] = {.lex_state = 192, .external_lex_state = 2},
  [8691] = {.lex_state = 192, .external_lex_state = 2},
  [8692] = {.lex_state = 192, .external_lex_state = 2},
  [8693] = {.lex_state = 192, .external_lex_state = 2},
  [8694] = {.lex_state = 192, .external_lex_state = 2},
  [8695] = {.lex_state = 192, .external_lex_state = 28},
  [8696] = {.lex_state = 192, .external_lex_state = 2},
  [8697] = {.lex_state = 367, .external_lex_state = 14},
  [8698] = {.lex_state = 363, .external_lex_state = 3},
  [8699] = {.lex_state = 363, .external_lex_state = 3},
  [8700] = {.lex_state = 363, .external_lex_state = 3},
  [8701] = {.lex_state = 192, .external_lex_state = 2},
  [8702] = {.lex_state = 363, .external_lex_state = 3},
  [8703] = {.lex_state = 192, .external_lex_state = 2},
  [8704] = {.lex_state = 363, .external_lex_state = 3},
  [8705] = {.lex_state = 528, .external_lex_state = 29},
  [8706] = {.lex_state = 363, .external_lex_state = 3},
  [8707] = {.lex_state = 363, .external_lex_state = 3},
  [8708] = {.lex_state = 363, .external_lex_state = 3},
  [8709] = {.lex_state = 363, .external_lex_state = 3},
  [8710] = {.lex_state = 363, .external_lex_state = 3},
  [8711] = {.lex_state = 363, .external_lex_state = 3},
  [8712] = {.lex_state = 363, .external_lex_state = 3},
  [8713] = {.lex_state = 561, .external_lex_state = 16},
  [8714] = {.lex_state = 363, .external_lex_state = 3},
  [8715] = {.lex_state = 363, .external_lex_state = 3},
  [8716] = {.lex_state = 363, .external_lex_state = 3},
  [8717] = {.lex_state = 363, .external_lex_state = 3},
  [8718] = {.lex_state = 423, .external_lex_state = 3},
  [8719] = {.lex_state = 423, .external_lex_state = 3},
  [8720] = {.lex_state = 192, .external_lex_state = 2},
  [8721] = {.lex_state = 423, .external_lex_state = 3},
  [8722] = {.lex_state = 192, .external_lex_state = 2},
  [8723] = {.lex_state = 423, .external_lex_state = 3},
  [8724] = {.lex_state = 528, .external_lex_state = 29},
  [8725] = {.lex_state = 423, .external_lex_state = 3},
  [8726] = {.lex_state = 264, .external_lex_state = 3},
  [8727] = {.lex_state = 528, .external_lex_state = 12},
  [8728] = {.lex_state = 264, .external_lex_state = 3},
  [8729] = {.lex_state = 363, .external_lex_state = 3},
  [8730] = {.lex_state = 363, .external_lex_state = 3},
  [8731] = {.lex_state = 363, .external_lex_state = 3},
  [8732] = {.lex_state = 363, .external_lex_state = 3},
  [8733] = {.lex_state = 363, .external_lex_state = 14},
  [8734] = {.lex_state = 256, .external_lex_state = 13},
  [8735] = {.lex_state = 192, .external_lex_state = 2},
  [8736] = {.lex_state = 426, .external_lex_state = 3},
  [8737] = {.lex_state = 426, .external_lex_state = 3},
  [8738] = {.lex_state = 192, .external_lex_state = 2},
  [8739] = {.lex_state = 192, .external_lex_state = 2},
  [8740] = {.lex_state = 192, .external_lex_state = 2},
  [8741] = {.lex_state = 192, .external_lex_state = 2},
  [8742] = {.lex_state = 192, .external_lex_state = 2},
  [8743] = {.lex_state = 192, .external_lex_state = 2},
  [8744] = {.lex_state = 192, .external_lex_state = 2},
  [8745] = {.lex_state = 192, .external_lex_state = 2},
  [8746] = {.lex_state = 192, .external_lex_state = 2},
  [8747] = {.lex_state = 192, .external_lex_state = 2},
  [8748] = {.lex_state = 192, .external_lex_state = 28},
  [8749] = {.lex_state = 192, .external_lex_state = 2},
  [8750] = {.lex_state = 426, .external_lex_state = 14},
  [8751] = {.lex_state = 426, .external_lex_state = 3},
  [8752] = {.lex_state = 426, .external_lex_state = 3},
  [8753] = {.lex_state = 423, .external_lex_state = 3},
  [8754] = {.lex_state = 423, .external_lex_state = 3},
  [8755] = {.lex_state = 423, .external_lex_state = 3},
  [8756] = {.lex_state = 423, .external_lex_state = 3},
  [8757] = {.lex_state = 423, .external_lex_state = 3},
  [8758] = {.lex_state = 561, .external_lex_state = 16},
  [8759] = {.lex_state = 423, .external_lex_state = 3},
  [8760] = {.lex_state = 423, .external_lex_state = 3},
  [8761] = {.lex_state = 423, .external_lex_state = 3},
  [8762] = {.lex_state = 423, .external_lex_state = 3},
  [8763] = {.lex_state = 426, .external_lex_state = 3},
  [8764] = {.lex_state = 528, .external_lex_state = 12},
  [8765] = {.lex_state = 426, .external_lex_state = 3},
  [8766] = {.lex_state = 426, .external_lex_state = 3},
  [8767] = {.lex_state = 423, .external_lex_state = 3},
  [8768] = {.lex_state = 423, .external_lex_state = 3},
  [8769] = {.lex_state = 423, .external_lex_state = 3},
  [8770] = {.lex_state = 423, .external_lex_state = 14},
  [8771] = {.lex_state = 532, .external_lex_state = 3},
  [8772] = {.lex_state = 532, .external_lex_state = 3},
  [8773] = {.lex_state = 532, .external_lex_state = 3},
  [8774] = {.lex_state = 192, .external_lex_state = 2},
  [8775] = {.lex_state = 192, .external_lex_state = 2},
  [8776] = {.lex_state = 192, .external_lex_state = 2},
  [8777] = {.lex_state = 192, .external_lex_state = 2},
  [8778] = {.lex_state = 192, .external_lex_state = 2},
  [8779] = {.lex_state = 192, .external_lex_state = 2},
  [8780] = {.lex_state = 192, .external_lex_state = 2},
  [8781] = {.lex_state = 192, .external_lex_state = 2},
  [8782] = {.lex_state = 192, .external_lex_state = 2},
  [8783] = {.lex_state = 192, .external_lex_state = 2},
  [8784] = {.lex_state = 192, .external_lex_state = 28},
  [8785] = {.lex_state = 532, .external_lex_state = 3},
  [8786] = {.lex_state = 192, .external_lex_state = 28},
  [8787] = {.lex_state = 192, .external_lex_state = 2},
  [8788] = {.lex_state = 471, .external_lex_state = 24},
  [8789] = {.lex_state = 471, .external_lex_state = 24},
  [8790] = {.lex_state = 471, .external_lex_state = 24},
  [8791] = {.lex_state = 471, .external_lex_state = 24},
  [8792] = {.lex_state = 471, .external_lex_state = 24},
  [8793] = {.lex_state = 471, .external_lex_state = 24},
  [8794] = {.lex_state = 471, .external_lex_state = 24},
  [8795] = {.lex_state = 561, .external_lex_state = 16},
  [8796] = {.lex_state = 471, .external_lex_state = 24},
  [8797] = {.lex_state = 471, .external_lex_state = 24},
  [8798] = {.lex_state = 471, .external_lex_state = 24},
  [8799] = {.lex_state = 471, .external_lex_state = 24},
  [8800] = {.lex_state = 471, .external_lex_state = 24},
  [8801] = {.lex_state = 471, .external_lex_state = 24},
  [8802] = {.lex_state = 471, .external_lex_state = 24},
  [8803] = {.lex_state = 471, .external_lex_state = 26},
  [8804] = {.lex_state = 595, .external_lex_state = 24},
  [8805] = {.lex_state = 595, .external_lex_state = 24},
  [8806] = {.lex_state = 595, .external_lex_state = 24},
  [8807] = {.lex_state = 528, .external_lex_state = 12},
  [8808] = {.lex_state = 595, .external_lex_state = 24},
  [8809] = {.lex_state = 595, .external_lex_state = 24},
  [8810] = {.lex_state = 192, .external_lex_state = 2},
  [8811] = {.lex_state = 580, .external_lex_state = 24},
  [8812] = {.lex_state = 580, .external_lex_state = 24},
  [8813] = {.lex_state = 580, .external_lex_state = 24},
  [8814] = {.lex_state = 528, .external_lex_state = 12},
  [8815] = {.lex_state = 580, .external_lex_state = 24},
  [8816] = {.lex_state = 580, .external_lex_state = 24},
  [8817] = {.lex_state = 192, .external_lex_state = 28},
  [8818] = {.lex_state = 595, .external_lex_state = 24},
  [8819] = {.lex_state = 438, .external_lex_state = 16},
  [8820] = {.lex_state = 586, .external_lex_state = 18},
  [8821] = {.lex_state = 465, .external_lex_state = 26},
  [8822] = {.lex_state = 465, .external_lex_state = 24},
  [8823] = {.lex_state = 465, .external_lex_state = 24},
  [8824] = {.lex_state = 465, .external_lex_state = 24},
  [8825] = {.lex_state = 465, .external_lex_state = 24},
  [8826] = {.lex_state = 192, .external_lex_state = 15},
  [8827] = {.lex_state = 268, .external_lex_state = 15},
  [8828] = {.lex_state = 465, .external_lex_state = 24},
  [8829] = {.lex_state = 177, .external_lex_state = 4},
  [8830] = {.lex_state = 268, .external_lex_state = 15},
  [8831] = {.lex_state = 465, .external_lex_state = 24},
  [8832] = {.lex_state = 192, .external_lex_state = 15},
  [8833] = {.lex_state = 268, .external_lex_state = 15},
  [8834] = {.lex_state = 465, .external_lex_state = 24},
  [8835] = {.lex_state = 177, .external_lex_state = 4},
  [8836] = {.lex_state = 268, .external_lex_state = 15},
  [8837] = {.lex_state = 465, .external_lex_state = 24},
  [8838] = {.lex_state = 194},
  [8839] = {.lex_state = 304, .external_lex_state = 16},
  [8840] = {.lex_state = 227, .external_lex_state = 7},
  [8841] = {.lex_state = 128, .external_lex_state = 2},
  [8842] = {.lex_state = 465, .external_lex_state = 24},
  [8843] = {.lex_state = 249, .external_lex_state = 3},
  [8844] = {.lex_state = 128, .external_lex_state = 13},
  [8845] = {.lex_state = 128, .external_lex_state = 2},
  [8846] = {.lex_state = 465, .external_lex_state = 24},
  [8847] = {.lex_state = 128, .external_lex_state = 2},
  [8848] = {.lex_state = 128},
  [8849] = {.lex_state = 128, .external_lex_state = 2},
  [8850] = {.lex_state = 128},
  [8851] = {.lex_state = 128, .external_lex_state = 2},
  [8852] = {.lex_state = 128, .external_lex_state = 2},
  [8853] = {.lex_state = 128, .external_lex_state = 2},
  [8854] = {.lex_state = 128, .external_lex_state = 13},
  [8855] = {.lex_state = 128},
  [8856] = {.lex_state = 465, .external_lex_state = 24},
  [8857] = {.lex_state = 128},
  [8858] = {.lex_state = 128},
  [8859] = {.lex_state = 128},
  [8860] = {.lex_state = 465, .external_lex_state = 24},
  [8861] = {.lex_state = 128},
  [8862] = {.lex_state = 128},
  [8863] = {.lex_state = 128},
  [8864] = {.lex_state = 465, .external_lex_state = 24},
  [8865] = {.lex_state = 465, .external_lex_state = 24},
  [8866] = {.lex_state = 465, .external_lex_state = 24},
  [8867] = {.lex_state = 443, .external_lex_state = 24},
  [8868] = {.lex_state = 443, .external_lex_state = 24},
  [8869] = {.lex_state = 443, .external_lex_state = 24},
  [8870] = {.lex_state = 443, .external_lex_state = 24},
  [8871] = {.lex_state = 443, .external_lex_state = 24},
  [8872] = {.lex_state = 561, .external_lex_state = 16},
  [8873] = {.lex_state = 443, .external_lex_state = 24},
  [8874] = {.lex_state = 443, .external_lex_state = 24},
  [8875] = {.lex_state = 443, .external_lex_state = 24},
  [8876] = {.lex_state = 443, .external_lex_state = 24},
  [8877] = {.lex_state = 443, .external_lex_state = 24},
  [8878] = {.lex_state = 465, .external_lex_state = 24},
  [8879] = {.lex_state = 443, .external_lex_state = 24},
  [8880] = {.lex_state = 443, .external_lex_state = 24},
  [8881] = {.lex_state = 443, .external_lex_state = 26},
  [8882] = {.lex_state = 435, .external_lex_state = 16},
  [8883] = {.lex_state = 435, .external_lex_state = 16},
  [8884] = {.lex_state = 128},
  [8885] = {.lex_state = 128, .external_lex_state = 2},
  [8886] = {.lex_state = 192, .external_lex_state = 2},
  [8887] = {.lex_state = 465, .external_lex_state = 24},
  [8888] = {.lex_state = 465, .external_lex_state = 24},
  [8889] = {.lex_state = 192, .external_lex_state = 28},
  [8890] = {.lex_state = 580, .external_lex_state = 24},
  [8891] = {.lex_state = 438, .external_lex_state = 16},
  [8892] = {.lex_state = 438, .external_lex_state = 16},
  [8893] = {.lex_state = 438, .external_lex_state = 16},
  [8894] = {.lex_state = 438, .external_lex_state = 16},
  [8895] = {.lex_state = 438, .external_lex_state = 16},
  [8896] = {.lex_state = 561, .external_lex_state = 16},
  [8897] = {.lex_state = 438, .external_lex_state = 16},
  [8898] = {.lex_state = 438, .external_lex_state = 16},
  [8899] = {.lex_state = 438, .external_lex_state = 16},
  [8900] = {.lex_state = 438, .external_lex_state = 16},
  [8901] = {.lex_state = 438, .external_lex_state = 16},
  [8902] = {.lex_state = 438, .external_lex_state = 16},
  [8903] = {.lex_state = 438, .external_lex_state = 16},
  [8904] = {.lex_state = 471, .external_lex_state = 20},
  [8905] = {.lex_state = 471, .external_lex_state = 3},
  [8906] = {.lex_state = 471, .external_lex_state = 3},
  [8907] = {.lex_state = 471, .external_lex_state = 3},
  [8908] = {.lex_state = 471, .external_lex_state = 3},
  [8909] = {.lex_state = 471, .external_lex_state = 3},
  [8910] = {.lex_state = 471, .external_lex_state = 3},
  [8911] = {.lex_state = 471, .external_lex_state = 3},
  [8912] = {.lex_state = 561, .external_lex_state = 16},
  [8913] = {.lex_state = 471, .external_lex_state = 3},
  [8914] = {.lex_state = 471, .external_lex_state = 3},
  [8915] = {.lex_state = 471, .external_lex_state = 3},
  [8916] = {.lex_state = 471, .external_lex_state = 3},
  [8917] = {.lex_state = 471, .external_lex_state = 3},
  [8918] = {.lex_state = 471, .external_lex_state = 3},
  [8919] = {.lex_state = 471, .external_lex_state = 3},
  [8920] = {.lex_state = 471, .external_lex_state = 14},
  [8921] = {.lex_state = 595, .external_lex_state = 3},
  [8922] = {.lex_state = 595, .external_lex_state = 3},
  [8923] = {.lex_state = 192, .external_lex_state = 2},
  [8924] = {.lex_state = 192, .external_lex_state = 28},
  [8925] = {.lex_state = 595, .external_lex_state = 3},
  [8926] = {.lex_state = 438, .external_lex_state = 3},
  [8927] = {.lex_state = 443, .external_lex_state = 3},
  [8928] = {.lex_state = 443, .external_lex_state = 3},
  [8929] = {.lex_state = 443, .external_lex_state = 3},
  [8930] = {.lex_state = 443, .external_lex_state = 3},
  [8931] = {.lex_state = 443, .external_lex_state = 3},
  [8932] = {.lex_state = 561, .external_lex_state = 16},
  [8933] = {.lex_state = 443, .external_lex_state = 3},
  [8934] = {.lex_state = 443, .external_lex_state = 3},
  [8935] = {.lex_state = 443, .external_lex_state = 3},
  [8936] = {.lex_state = 443, .external_lex_state = 3},
  [8937] = {.lex_state = 443, .external_lex_state = 3},
  [8938] = {.lex_state = 443, .external_lex_state = 3},
  [8939] = {.lex_state = 443, .external_lex_state = 3},
  [8940] = {.lex_state = 443, .external_lex_state = 14},
  [8941] = {.lex_state = 192, .external_lex_state = 2},
  [8942] = {.lex_state = 192, .external_lex_state = 28},
  [8943] = {.lex_state = 580, .external_lex_state = 3},
  [8944] = {.lex_state = 438, .external_lex_state = 3},
  [8945] = {.lex_state = 438, .external_lex_state = 3},
  [8946] = {.lex_state = 438, .external_lex_state = 3},
  [8947] = {.lex_state = 438, .external_lex_state = 3},
  [8948] = {.lex_state = 438, .external_lex_state = 3},
  [8949] = {.lex_state = 561, .external_lex_state = 16},
  [8950] = {.lex_state = 438, .external_lex_state = 3},
  [8951] = {.lex_state = 438, .external_lex_state = 3},
  [8952] = {.lex_state = 438, .external_lex_state = 3},
  [8953] = {.lex_state = 438, .external_lex_state = 3},
  [8954] = {.lex_state = 438, .external_lex_state = 3},
  [8955] = {.lex_state = 438, .external_lex_state = 3},
  [8956] = {.lex_state = 438, .external_lex_state = 3},
  [8957] = {.lex_state = 290, .external_lex_state = 16},
  [8958] = {.lex_state = 290, .external_lex_state = 16},
  [8959] = {.lex_state = 290, .external_lex_state = 16},
  [8960] = {.lex_state = 471, .external_lex_state = 24},
  [8961] = {.lex_state = 471, .external_lex_state = 24},
  [8962] = {.lex_state = 471, .external_lex_state = 24},
  [8963] = {.lex_state = 471, .external_lex_state = 24},
  [8964] = {.lex_state = 471, .external_lex_state = 24},
  [8965] = {.lex_state = 561, .external_lex_state = 16},
  [8966] = {.lex_state = 471, .external_lex_state = 24},
  [8967] = {.lex_state = 471, .external_lex_state = 24},
  [8968] = {.lex_state = 471, .external_lex_state = 24},
  [8969] = {.lex_state = 471, .external_lex_state = 24},
  [8970] = {.lex_state = 471, .external_lex_state = 24},
  [8971] = {.lex_state = 471, .external_lex_state = 24},
  [8972] = {.lex_state = 471, .external_lex_state = 24},
  [8973] = {.lex_state = 595, .external_lex_state = 24},
  [8974] = {.lex_state = 595, .external_lex_state = 24},
  [8975] = {.lex_state = 595, .external_lex_state = 24},
  [8976] = {.lex_state = 528, .external_lex_state = 12},
  [8977] = {.lex_state = 595, .external_lex_state = 24},
  [8978] = {.lex_state = 595, .external_lex_state = 24},
  [8979] = {.lex_state = 192, .external_lex_state = 2},
  [8980] = {.lex_state = 580, .external_lex_state = 24},
  [8981] = {.lex_state = 580, .external_lex_state = 24},
  [8982] = {.lex_state = 580, .external_lex_state = 24},
  [8983] = {.lex_state = 528, .external_lex_state = 12},
  [8984] = {.lex_state = 580, .external_lex_state = 24},
  [8985] = {.lex_state = 580, .external_lex_state = 24},
  [8986] = {.lex_state = 192, .external_lex_state = 28},
  [8987] = {.lex_state = 595, .external_lex_state = 24},
  [8988] = {.lex_state = 438, .external_lex_state = 24},
  [8989] = {.lex_state = 602, .external_lex_state = 25},
  [8990] = {.lex_state = 443, .external_lex_state = 24},
  [8991] = {.lex_state = 443, .external_lex_state = 24},
  [8992] = {.lex_state = 443, .external_lex_state = 24},
  [8993] = {.lex_state = 443, .external_lex_state = 24},
  [8994] = {.lex_state = 443, .external_lex_state = 24},
  [8995] = {.lex_state = 561, .external_lex_state = 16},
  [8996] = {.lex_state = 443, .external_lex_state = 24},
  [8997] = {.lex_state = 443, .external_lex_state = 24},
  [8998] = {.lex_state = 443, .external_lex_state = 24},
  [8999] = {.lex_state = 443, .external_lex_state = 24},
  [9000] = {.lex_state = 443, .external_lex_state = 24},
  [9001] = {.lex_state = 443, .external_lex_state = 24},
  [9002] = {.lex_state = 443, .external_lex_state = 24},
  [9003] = {.lex_state = 443, .external_lex_state = 26},
  [9004] = {.lex_state = 465, .external_lex_state = 24},
  [9005] = {.lex_state = 465, .external_lex_state = 24},
  [9006] = {.lex_state = 128},
  [9007] = {.lex_state = 128, .external_lex_state = 2},
  [9008] = {.lex_state = 192, .external_lex_state = 2},
  [9009] = {.lex_state = 192, .external_lex_state = 28},
  [9010] = {.lex_state = 580, .external_lex_state = 24},
  [9011] = {.lex_state = 438, .external_lex_state = 24},
  [9012] = {.lex_state = 363, .external_lex_state = 24},
  [9013] = {.lex_state = 390, .external_lex_state = 24},
  [9014] = {.lex_state = 363, .external_lex_state = 24},
  [9015] = {.lex_state = 290, .external_lex_state = 16},
  [9016] = {.lex_state = 290, .external_lex_state = 16},
  [9017] = {.lex_state = 128},
  [9018] = {.lex_state = 290, .external_lex_state = 16},
  [9019] = {.lex_state = 290, .external_lex_state = 16},
  [9020] = {.lex_state = 128},
  [9021] = {.lex_state = 399, .external_lex_state = 24},
  [9022] = {.lex_state = 177, .external_lex_state = 4},
  [9023] = {.lex_state = 399, .external_lex_state = 24},
  [9024] = {.lex_state = 399, .external_lex_state = 24},
  [9025] = {.lex_state = 177, .external_lex_state = 4},
  [9026] = {.lex_state = 399, .external_lex_state = 24},
  [9027] = {.lex_state = 227, .external_lex_state = 7},
  [9028] = {.lex_state = 399, .external_lex_state = 24},
  [9029] = {.lex_state = 399, .external_lex_state = 24},
  [9030] = {.lex_state = 399, .external_lex_state = 24},
  [9031] = {.lex_state = 399, .external_lex_state = 24},
  [9032] = {.lex_state = 399, .external_lex_state = 24},
  [9033] = {.lex_state = 399, .external_lex_state = 24},
  [9034] = {.lex_state = 399, .external_lex_state = 24},
  [9035] = {.lex_state = 128},
  [9036] = {.lex_state = 301, .external_lex_state = 16},
  [9037] = {.lex_state = 128},
  [9038] = {.lex_state = 399, .external_lex_state = 24},
  [9039] = {.lex_state = 128},
  [9040] = {.lex_state = 128},
  [9041] = {.lex_state = 399, .external_lex_state = 24},
  [9042] = {.lex_state = 128},
  [9043] = {.lex_state = 423, .external_lex_state = 24},
  [9044] = {.lex_state = 399, .external_lex_state = 24},
  [9045] = {.lex_state = 423, .external_lex_state = 24},
  [9046] = {.lex_state = 192, .external_lex_state = 2},
  [9047] = {.lex_state = 497, .external_lex_state = 24},
  [9048] = {.lex_state = 497, .external_lex_state = 24},
  [9049] = {.lex_state = 497, .external_lex_state = 24},
  [9050] = {.lex_state = 497, .external_lex_state = 24},
  [9051] = {.lex_state = 497, .external_lex_state = 24},
  [9052] = {.lex_state = 561, .external_lex_state = 16},
  [9053] = {.lex_state = 497, .external_lex_state = 24},
  [9054] = {.lex_state = 497, .external_lex_state = 24},
  [9055] = {.lex_state = 497, .external_lex_state = 24},
  [9056] = {.lex_state = 497, .external_lex_state = 24},
  [9057] = {.lex_state = 497, .external_lex_state = 24},
  [9058] = {.lex_state = 497, .external_lex_state = 24},
  [9059] = {.lex_state = 497, .external_lex_state = 24},
  [9060] = {.lex_state = 192, .external_lex_state = 2},
  [9061] = {.lex_state = 192, .external_lex_state = 28},
  [9062] = {.lex_state = 497, .external_lex_state = 24},
  [9063] = {.lex_state = 304, .external_lex_state = 16},
  [9064] = {.lex_state = 323, .external_lex_state = 24},
  [9065] = {.lex_state = 323, .external_lex_state = 24},
  [9066] = {.lex_state = 323, .external_lex_state = 24},
  [9067] = {.lex_state = 323, .external_lex_state = 24},
  [9068] = {.lex_state = 323, .external_lex_state = 24},
  [9069] = {.lex_state = 561, .external_lex_state = 16},
  [9070] = {.lex_state = 323, .external_lex_state = 24},
  [9071] = {.lex_state = 323, .external_lex_state = 24},
  [9072] = {.lex_state = 323, .external_lex_state = 24},
  [9073] = {.lex_state = 323, .external_lex_state = 24},
  [9074] = {.lex_state = 323, .external_lex_state = 24},
  [9075] = {.lex_state = 323, .external_lex_state = 24},
  [9076] = {.lex_state = 323, .external_lex_state = 24},
  [9077] = {.lex_state = 323, .external_lex_state = 26},
  [9078] = {.lex_state = 192, .external_lex_state = 2},
  [9079] = {.lex_state = 192, .external_lex_state = 28},
  [9080] = {.lex_state = 501, .external_lex_state = 24},
  [9081] = {.lex_state = 304, .external_lex_state = 16},
  [9082] = {.lex_state = 304, .external_lex_state = 16},
  [9083] = {.lex_state = 304, .external_lex_state = 16},
  [9084] = {.lex_state = 304, .external_lex_state = 16},
  [9085] = {.lex_state = 304, .external_lex_state = 16},
  [9086] = {.lex_state = 561, .external_lex_state = 16},
  [9087] = {.lex_state = 304, .external_lex_state = 16},
  [9088] = {.lex_state = 304, .external_lex_state = 16},
  [9089] = {.lex_state = 304, .external_lex_state = 16},
  [9090] = {.lex_state = 304, .external_lex_state = 16},
  [9091] = {.lex_state = 304, .external_lex_state = 16},
  [9092] = {.lex_state = 304, .external_lex_state = 16},
  [9093] = {.lex_state = 304, .external_lex_state = 16},
  [9094] = {.lex_state = 617, .external_lex_state = 20},
  [9095] = {.lex_state = 128, .external_lex_state = 2},
  [9096] = {.lex_state = 685, .external_lex_state = 13},
  [9097] = {.lex_state = 194},
  [9098] = {.lex_state = 685, .external_lex_state = 13},
  [9099] = {.lex_state = 128},
  [9100] = {.lex_state = 128, .external_lex_state = 2},
  [9101] = {.lex_state = 128, .external_lex_state = 11},
  [9102] = {.lex_state = 256, .external_lex_state = 13},
  [9103] = {.lex_state = 304},
  [9104] = {.lex_state = 256, .external_lex_state = 13},
  [9105] = {.lex_state = 256, .external_lex_state = 13},
  [9106] = {.lex_state = 628, .external_lex_state = 24},
  [9107] = {.lex_state = 628, .external_lex_state = 24},
  [9108] = {.lex_state = 192, .external_lex_state = 2},
  [9109] = {.lex_state = 628, .external_lex_state = 24},
  [9110] = {.lex_state = 192, .external_lex_state = 2},
  [9111] = {.lex_state = 628, .external_lex_state = 24},
  [9112] = {.lex_state = 528, .external_lex_state = 29},
  [9113] = {.lex_state = 628, .external_lex_state = 24},
  [9114] = {.lex_state = 628, .external_lex_state = 24},
  [9115] = {.lex_state = 628, .external_lex_state = 24},
  [9116] = {.lex_state = 628, .external_lex_state = 24},
  [9117] = {.lex_state = 628, .external_lex_state = 24},
  [9118] = {.lex_state = 628, .external_lex_state = 24},
  [9119] = {.lex_state = 561, .external_lex_state = 16},
  [9120] = {.lex_state = 628, .external_lex_state = 24},
  [9121] = {.lex_state = 628, .external_lex_state = 24},
  [9122] = {.lex_state = 628, .external_lex_state = 24},
  [9123] = {.lex_state = 628, .external_lex_state = 24},
  [9124] = {.lex_state = 628, .external_lex_state = 24},
  [9125] = {.lex_state = 628, .external_lex_state = 24},
  [9126] = {.lex_state = 628, .external_lex_state = 24},
  [9127] = {.lex_state = 628, .external_lex_state = 26},
  [9128] = {.lex_state = 611, .external_lex_state = 24},
  [9129] = {.lex_state = 611, .external_lex_state = 24},
  [9130] = {.lex_state = 611, .external_lex_state = 24},
  [9131] = {.lex_state = 528, .external_lex_state = 12},
  [9132] = {.lex_state = 611, .external_lex_state = 24},
  [9133] = {.lex_state = 611, .external_lex_state = 24},
  [9134] = {.lex_state = 192, .external_lex_state = 2},
  [9135] = {.lex_state = 192, .external_lex_state = 28},
  [9136] = {.lex_state = 611, .external_lex_state = 24},
  [9137] = {.lex_state = 497, .external_lex_state = 3},
  [9138] = {.lex_state = 497, .external_lex_state = 3},
  [9139] = {.lex_state = 192, .external_lex_state = 2},
  [9140] = {.lex_state = 192, .external_lex_state = 28},
  [9141] = {.lex_state = 497, .external_lex_state = 3},
  [9142] = {.lex_state = 497, .external_lex_state = 3},
  [9143] = {.lex_state = 497, .external_lex_state = 3},
  [9144] = {.lex_state = 192, .external_lex_state = 2},
  [9145] = {.lex_state = 192, .external_lex_state = 28},
  [9146] = {.lex_state = 323, .external_lex_state = 3},
  [9147] = {.lex_state = 501, .external_lex_state = 3},
  [9148] = {.lex_state = 501, .external_lex_state = 3},
  [9149] = {.lex_state = 192, .external_lex_state = 2},
  [9150] = {.lex_state = 332},
  [9151] = {.lex_state = 332},
  [9152] = {.lex_state = 332},
  [9153] = {.lex_state = 363, .external_lex_state = 24},
  [9154] = {.lex_state = 363, .external_lex_state = 24},
  [9155] = {.lex_state = 363, .external_lex_state = 24},
  [9156] = {.lex_state = 528, .external_lex_state = 12},
  [9157] = {.lex_state = 363, .external_lex_state = 24},
  [9158] = {.lex_state = 363, .external_lex_state = 24},
  [9159] = {.lex_state = 192, .external_lex_state = 2},
  [9160] = {.lex_state = 426, .external_lex_state = 24},
  [9161] = {.lex_state = 426, .external_lex_state = 24},
  [9162] = {.lex_state = 192, .external_lex_state = 2},
  [9163] = {.lex_state = 192, .external_lex_state = 2},
  [9164] = {.lex_state = 192, .external_lex_state = 2},
  [9165] = {.lex_state = 192, .external_lex_state = 2},
  [9166] = {.lex_state = 192, .external_lex_state = 2},
  [9167] = {.lex_state = 192, .external_lex_state = 2},
  [9168] = {.lex_state = 192, .external_lex_state = 2},
  [9169] = {.lex_state = 192, .external_lex_state = 2},
  [9170] = {.lex_state = 192, .external_lex_state = 2},
  [9171] = {.lex_state = 192, .external_lex_state = 2},
  [9172] = {.lex_state = 192, .external_lex_state = 28},
  [9173] = {.lex_state = 192, .external_lex_state = 2},
  [9174] = {.lex_state = 426, .external_lex_state = 26},
  [9175] = {.lex_state = 426, .external_lex_state = 24},
  [9176] = {.lex_state = 426, .external_lex_state = 24},
  [9177] = {.lex_state = 426, .external_lex_state = 24},
  [9178] = {.lex_state = 528, .external_lex_state = 12},
  [9179] = {.lex_state = 426, .external_lex_state = 24},
  [9180] = {.lex_state = 426, .external_lex_state = 24},
  [9181] = {.lex_state = 192, .external_lex_state = 28},
  [9182] = {.lex_state = 363, .external_lex_state = 24},
  [9183] = {.lex_state = 332},
  [9184] = {.lex_state = 332},
  [9185] = {.lex_state = 128},
  [9186] = {.lex_state = 332},
  [9187] = {.lex_state = 339},
  [9188] = {.lex_state = 128},
  [9189] = {.lex_state = 628, .external_lex_state = 24},
  [9190] = {.lex_state = 628, .external_lex_state = 24},
  [9191] = {.lex_state = 177, .external_lex_state = 4},
  [9192] = {.lex_state = 268, .external_lex_state = 15},
  [9193] = {.lex_state = 628, .external_lex_state = 24},
  [9194] = {.lex_state = 177, .external_lex_state = 4},
  [9195] = {.lex_state = 628, .external_lex_state = 24},
  [9196] = {.lex_state = 628, .external_lex_state = 24},
  [9197] = {.lex_state = 177, .external_lex_state = 4},
  [9198] = {.lex_state = 268, .external_lex_state = 15},
  [9199] = {.lex_state = 628, .external_lex_state = 24},
  [9200] = {.lex_state = 177, .external_lex_state = 4},
  [9201] = {.lex_state = 628, .external_lex_state = 24},
  [9202] = {.lex_state = 312},
  [9203] = {.lex_state = 628, .external_lex_state = 24},
  [9204] = {.lex_state = 628, .external_lex_state = 24},
  [9205] = {.lex_state = 128, .external_lex_state = 2},
  [9206] = {.lex_state = 128, .external_lex_state = 2},
  [9207] = {.lex_state = 628, .external_lex_state = 24},
  [9208] = {.lex_state = 628, .external_lex_state = 24},
  [9209] = {.lex_state = 634, .external_lex_state = 24},
  [9210] = {.lex_state = 628, .external_lex_state = 24},
  [9211] = {.lex_state = 634, .external_lex_state = 24},
  [9212] = {.lex_state = 628, .external_lex_state = 24},
  [9213] = {.lex_state = 177, .external_lex_state = 17},
  [9214] = {.lex_state = 634, .external_lex_state = 24},
  [9215] = {.lex_state = 628, .external_lex_state = 24},
  [9216] = {.lex_state = 528, .external_lex_state = 12},
  [9217] = {.lex_state = 634, .external_lex_state = 24},
  [9218] = {.lex_state = 634, .external_lex_state = 24},
  [9219] = {.lex_state = 628, .external_lex_state = 24},
  [9220] = {.lex_state = 128},
  [9221] = {.lex_state = 628, .external_lex_state = 24},
  [9222] = {.lex_state = 128},
  [9223] = {.lex_state = 628, .external_lex_state = 24},
  [9224] = {.lex_state = 128},
  [9225] = {.lex_state = 628, .external_lex_state = 24},
  [9226] = {.lex_state = 128},
  [9227] = {.lex_state = 128, .external_lex_state = 2},
  [9228] = {.lex_state = 628, .external_lex_state = 24},
  [9229] = {.lex_state = 128},
  [9230] = {.lex_state = 128},
  [9231] = {.lex_state = 128},
  [9232] = {.lex_state = 628, .external_lex_state = 24},
  [9233] = {.lex_state = 128},
  [9234] = {.lex_state = 128},
  [9235] = {.lex_state = 628, .external_lex_state = 24},
  [9236] = {.lex_state = 194},
  [9237] = {.lex_state = 628, .external_lex_state = 24},
  [9238] = {.lex_state = 128},
  [9239] = {.lex_state = 128, .external_lex_state = 2},
  [9240] = {.lex_state = 128, .external_lex_state = 11},
  [9241] = {.lex_state = 192, .external_lex_state = 2},
  [9242] = {.lex_state = 192, .external_lex_state = 28},
  [9243] = {.lex_state = 634, .external_lex_state = 24},
  [9244] = {.lex_state = 509, .external_lex_state = 24},
  [9245] = {.lex_state = 509, .external_lex_state = 24},
  [9246] = {.lex_state = 512, .external_lex_state = 24},
  [9247] = {.lex_state = 512, .external_lex_state = 24},
  [9248] = {.lex_state = 512, .external_lex_state = 24},
  [9249] = {.lex_state = 528, .external_lex_state = 12},
  [9250] = {.lex_state = 512, .external_lex_state = 24},
  [9251] = {.lex_state = 512, .external_lex_state = 24},
  [9252] = {.lex_state = 192, .external_lex_state = 2},
  [9253] = {.lex_state = 192, .external_lex_state = 28},
  [9254] = {.lex_state = 512, .external_lex_state = 24},
  [9255] = {.lex_state = 512, .external_lex_state = 24},
  [9256] = {.lex_state = 512, .external_lex_state = 24},
  [9257] = {.lex_state = 367, .external_lex_state = 3},
  [9258] = {.lex_state = 367, .external_lex_state = 3},
  [9259] = {.lex_state = 497, .external_lex_state = 24},
  [9260] = {.lex_state = 497, .external_lex_state = 24},
  [9261] = {.lex_state = 192, .external_lex_state = 2},
  [9262] = {.lex_state = 304, .external_lex_state = 24},
  [9263] = {.lex_state = 192, .external_lex_state = 28},
  [9264] = {.lex_state = 304, .external_lex_state = 24},
  [9265] = {.lex_state = 304, .external_lex_state = 24},
  [9266] = {.lex_state = 528, .external_lex_state = 12},
  [9267] = {.lex_state = 304, .external_lex_state = 24},
  [9268] = {.lex_state = 301, .external_lex_state = 3},
  [9269] = {.lex_state = 128},
  [9270] = {.lex_state = 363, .external_lex_state = 3},
  [9271] = {.lex_state = 363, .external_lex_state = 3},
  [9272] = {.lex_state = 192, .external_lex_state = 2},
  [9273] = {.lex_state = 192, .external_lex_state = 28},
  [9274] = {.lex_state = 363, .external_lex_state = 3},
  [9275] = {.lex_state = 363, .external_lex_state = 3},
  [9276] = {.lex_state = 363, .external_lex_state = 3},
  [9277] = {.lex_state = 363, .external_lex_state = 3},
  [9278] = {.lex_state = 363, .external_lex_state = 3},
  [9279] = {.lex_state = 363, .external_lex_state = 3},
  [9280] = {.lex_state = 363, .external_lex_state = 3},
  [9281] = {.lex_state = 192, .external_lex_state = 2},
  [9282] = {.lex_state = 192, .external_lex_state = 2},
  [9283] = {.lex_state = 192, .external_lex_state = 2},
  [9284] = {.lex_state = 192, .external_lex_state = 2},
  [9285] = {.lex_state = 192, .external_lex_state = 2},
  [9286] = {.lex_state = 192, .external_lex_state = 2},
  [9287] = {.lex_state = 192, .external_lex_state = 2},
  [9288] = {.lex_state = 192, .external_lex_state = 2},
  [9289] = {.lex_state = 192, .external_lex_state = 2},
  [9290] = {.lex_state = 192, .external_lex_state = 2},
  [9291] = {.lex_state = 192, .external_lex_state = 28},
  [9292] = {.lex_state = 192, .external_lex_state = 2},
  [9293] = {.lex_state = 367, .external_lex_state = 14},
  [9294] = {.lex_state = 363, .external_lex_state = 3},
  [9295] = {.lex_state = 363, .external_lex_state = 3},
  [9296] = {.lex_state = 363, .external_lex_state = 3},
  [9297] = {.lex_state = 192, .external_lex_state = 2},
  [9298] = {.lex_state = 363, .external_lex_state = 3},
  [9299] = {.lex_state = 192, .external_lex_state = 2},
  [9300] = {.lex_state = 363, .external_lex_state = 3},
  [9301] = {.lex_state = 528, .external_lex_state = 29},
  [9302] = {.lex_state = 363, .external_lex_state = 3},
  [9303] = {.lex_state = 363, .external_lex_state = 3},
  [9304] = {.lex_state = 363, .external_lex_state = 3},
  [9305] = {.lex_state = 363, .external_lex_state = 3},
  [9306] = {.lex_state = 363, .external_lex_state = 3},
  [9307] = {.lex_state = 363, .external_lex_state = 3},
  [9308] = {.lex_state = 363, .external_lex_state = 3},
  [9309] = {.lex_state = 561, .external_lex_state = 16},
  [9310] = {.lex_state = 363, .external_lex_state = 3},
  [9311] = {.lex_state = 363, .external_lex_state = 3},
  [9312] = {.lex_state = 363, .external_lex_state = 3},
  [9313] = {.lex_state = 363, .external_lex_state = 3},
  [9314] = {.lex_state = 423, .external_lex_state = 3},
  [9315] = {.lex_state = 423, .external_lex_state = 3},
  [9316] = {.lex_state = 192, .external_lex_state = 2},
  [9317] = {.lex_state = 423, .external_lex_state = 3},
  [9318] = {.lex_state = 192, .external_lex_state = 2},
  [9319] = {.lex_state = 423, .external_lex_state = 3},
  [9320] = {.lex_state = 528, .external_lex_state = 29},
  [9321] = {.lex_state = 423, .external_lex_state = 3},
  [9322] = {.lex_state = 264, .external_lex_state = 3},
  [9323] = {.lex_state = 528, .external_lex_state = 12},
  [9324] = {.lex_state = 264, .external_lex_state = 3},
  [9325] = {.lex_state = 363, .external_lex_state = 3},
  [9326] = {.lex_state = 363, .external_lex_state = 3},
  [9327] = {.lex_state = 363, .external_lex_state = 3},
  [9328] = {.lex_state = 363, .external_lex_state = 3},
  [9329] = {.lex_state = 363, .external_lex_state = 14},
  [9330] = {.lex_state = 256, .external_lex_state = 13},
  [9331] = {.lex_state = 192, .external_lex_state = 2},
  [9332] = {.lex_state = 426, .external_lex_state = 3},
  [9333] = {.lex_state = 426, .external_lex_state = 3},
  [9334] = {.lex_state = 192, .external_lex_state = 2},
  [9335] = {.lex_state = 192, .external_lex_state = 2},
  [9336] = {.lex_state = 192, .external_lex_state = 2},
  [9337] = {.lex_state = 192, .external_lex_state = 2},
  [9338] = {.lex_state = 192, .external_lex_state = 2},
  [9339] = {.lex_state = 192, .external_lex_state = 2},
  [9340] = {.lex_state = 192, .external_lex_state = 2},
  [9341] = {.lex_state = 192, .external_lex_state = 2},
  [9342] = {.lex_state = 192, .external_lex_state = 2},
  [9343] = {.lex_state = 192, .external_lex_state = 2},
  [9344] = {.lex_state = 192, .external_lex_state = 28},
  [9345] = {.lex_state = 192, .external_lex_state = 2},
  [9346] = {.lex_state = 426, .external_lex_state = 14},
  [9347] = {.lex_state = 426, .external_lex_state = 3},
  [9348] = {.lex_state = 426, .external_lex_state = 3},
  [9349] = {.lex_state = 423, .external_lex_state = 3},
  [9350] = {.lex_state = 423, .external_lex_state = 3},
  [9351] = {.lex_state = 423, .external_lex_state = 3},
  [9352] = {.lex_state = 423, .external_lex_state = 3},
  [9353] = {.lex_state = 423, .external_lex_state = 3},
  [9354] = {.lex_state = 561, .external_lex_state = 16},
  [9355] = {.lex_state = 423, .external_lex_state = 3},
  [9356] = {.lex_state = 423, .external_lex_state = 3},
  [9357] = {.lex_state = 423, .external_lex_state = 3},
  [9358] = {.lex_state = 423, .external_lex_state = 3},
  [9359] = {.lex_state = 426, .external_lex_state = 3},
  [9360] = {.lex_state = 528, .external_lex_state = 12},
  [9361] = {.lex_state = 426, .external_lex_state = 3},
  [9362] = {.lex_state = 426, .external_lex_state = 3},
  [9363] = {.lex_state = 423, .external_lex_state = 3},
  [9364] = {.lex_state = 423, .external_lex_state = 3},
  [9365] = {.lex_state = 423, .external_lex_state = 3},
  [9366] = {.lex_state = 423, .external_lex_state = 14},
  [9367] = {.lex_state = 532, .external_lex_state = 3},
  [9368] = {.lex_state = 532, .external_lex_state = 3},
  [9369] = {.lex_state = 532, .external_lex_state = 3},
  [9370] = {.lex_state = 192, .external_lex_state = 2},
  [9371] = {.lex_state = 192, .external_lex_state = 2},
  [9372] = {.lex_state = 192, .external_lex_state = 2},
  [9373] = {.lex_state = 192, .external_lex_state = 2},
  [9374] = {.lex_state = 192, .external_lex_state = 2},
  [9375] = {.lex_state = 192, .external_lex_state = 2},
  [9376] = {.lex_state = 192, .external_lex_state = 2},
  [9377] = {.lex_state = 192, .external_lex_state = 2},
  [9378] = {.lex_state = 192, .external_lex_state = 2},
  [9379] = {.lex_state = 192, .external_lex_state = 2},
  [9380] = {.lex_state = 192, .external_lex_state = 28},
  [9381] = {.lex_state = 532, .external_lex_state = 3},
  [9382] = {.lex_state = 192, .external_lex_state = 28},
  [9383] = {.lex_state = 192, .external_lex_state = 2},
  [9384] = {.lex_state = 128},
  [9385] = {.lex_state = 192, .external_lex_state = 2},
  [9386] = {.lex_state = 192, .external_lex_state = 28},
  [9387] = {.lex_state = 426, .external_lex_state = 3},
  [9388] = {.lex_state = 423, .external_lex_state = 3},
  [9389] = {.lex_state = 423, .external_lex_state = 3},
  [9390] = {.lex_state = 192, .external_lex_state = 2},
  [9391] = {.lex_state = 363, .external_lex_state = 3},
  [9392] = {.lex_state = 363, .external_lex_state = 3},
  [9393] = {.lex_state = 363, .external_lex_state = 3},
  [9394] = {.lex_state = 363, .external_lex_state = 3},
  [9395] = {.lex_state = 192, .external_lex_state = 2},
  [9396] = {.lex_state = 192, .external_lex_state = 2},
  [9397] = {.lex_state = 192, .external_lex_state = 2},
  [9398] = {.lex_state = 192, .external_lex_state = 2},
  [9399] = {.lex_state = 192, .external_lex_state = 2},
  [9400] = {.lex_state = 192, .external_lex_state = 2},
  [9401] = {.lex_state = 192, .external_lex_state = 2},
  [9402] = {.lex_state = 192, .external_lex_state = 2},
  [9403] = {.lex_state = 192, .external_lex_state = 2},
  [9404] = {.lex_state = 192, .external_lex_state = 2},
  [9405] = {.lex_state = 192, .external_lex_state = 28},
  [9406] = {.lex_state = 192, .external_lex_state = 2},
  [9407] = {.lex_state = 367, .external_lex_state = 14},
  [9408] = {.lex_state = 363, .external_lex_state = 3},
  [9409] = {.lex_state = 363, .external_lex_state = 3},
  [9410] = {.lex_state = 363, .external_lex_state = 3},
  [9411] = {.lex_state = 192, .external_lex_state = 2},
  [9412] = {.lex_state = 363, .external_lex_state = 3},
  [9413] = {.lex_state = 192, .external_lex_state = 2},
  [9414] = {.lex_state = 363, .external_lex_state = 3},
  [9415] = {.lex_state = 528, .external_lex_state = 29},
  [9416] = {.lex_state = 363, .external_lex_state = 3},
  [9417] = {.lex_state = 363, .external_lex_state = 3},
  [9418] = {.lex_state = 363, .external_lex_state = 3},
  [9419] = {.lex_state = 363, .external_lex_state = 3},
  [9420] = {.lex_state = 363, .external_lex_state = 3},
  [9421] = {.lex_state = 363, .external_lex_state = 3},
  [9422] = {.lex_state = 363, .external_lex_state = 3},
  [9423] = {.lex_state = 561, .external_lex_state = 16},
  [9424] = {.lex_state = 363, .external_lex_state = 3},
  [9425] = {.lex_state = 363, .external_lex_state = 3},
  [9426] = {.lex_state = 363, .external_lex_state = 3},
  [9427] = {.lex_state = 363, .external_lex_state = 3},
  [9428] = {.lex_state = 423, .external_lex_state = 3},
  [9429] = {.lex_state = 423, .external_lex_state = 3},
  [9430] = {.lex_state = 192, .external_lex_state = 2},
  [9431] = {.lex_state = 423, .external_lex_state = 3},
  [9432] = {.lex_state = 192, .external_lex_state = 2},
  [9433] = {.lex_state = 423, .external_lex_state = 3},
  [9434] = {.lex_state = 528, .external_lex_state = 29},
  [9435] = {.lex_state = 423, .external_lex_state = 3},
  [9436] = {.lex_state = 264, .external_lex_state = 3},
  [9437] = {.lex_state = 528, .external_lex_state = 12},
  [9438] = {.lex_state = 264, .external_lex_state = 3},
  [9439] = {.lex_state = 363, .external_lex_state = 3},
  [9440] = {.lex_state = 363, .external_lex_state = 3},
  [9441] = {.lex_state = 363, .external_lex_state = 3},
  [9442] = {.lex_state = 363, .external_lex_state = 3},
  [9443] = {.lex_state = 363, .external_lex_state = 14},
  [9444] = {.lex_state = 256, .external_lex_state = 13},
  [9445] = {.lex_state = 192, .external_lex_state = 2},
  [9446] = {.lex_state = 426, .external_lex_state = 3},
  [9447] = {.lex_state = 426, .external_lex_state = 3},
  [9448] = {.lex_state = 192, .external_lex_state = 2},
  [9449] = {.lex_state = 192, .external_lex_state = 2},
  [9450] = {.lex_state = 192, .external_lex_state = 2},
  [9451] = {.lex_state = 192, .external_lex_state = 2},
  [9452] = {.lex_state = 192, .external_lex_state = 2},
  [9453] = {.lex_state = 192, .external_lex_state = 2},
  [9454] = {.lex_state = 192, .external_lex_state = 2},
  [9455] = {.lex_state = 192, .external_lex_state = 2},
  [9456] = {.lex_state = 192, .external_lex_state = 2},
  [9457] = {.lex_state = 192, .external_lex_state = 2},
  [9458] = {.lex_state = 192, .external_lex_state = 28},
  [9459] = {.lex_state = 192, .external_lex_state = 2},
  [9460] = {.lex_state = 426, .external_lex_state = 14},
  [9461] = {.lex_state = 426, .external_lex_state = 3},
  [9462] = {.lex_state = 426, .external_lex_state = 3},
  [9463] = {.lex_state = 423, .external_lex_state = 3},
  [9464] = {.lex_state = 423, .external_lex_state = 3},
  [9465] = {.lex_state = 423, .external_lex_state = 3},
  [9466] = {.lex_state = 423, .external_lex_state = 3},
  [9467] = {.lex_state = 423, .external_lex_state = 3},
  [9468] = {.lex_state = 561, .external_lex_state = 16},
  [9469] = {.lex_state = 423, .external_lex_state = 3},
  [9470] = {.lex_state = 423, .external_lex_state = 3},
  [9471] = {.lex_state = 423, .external_lex_state = 3},
  [9472] = {.lex_state = 423, .external_lex_state = 3},
  [9473] = {.lex_state = 426, .external_lex_state = 3},
  [9474] = {.lex_state = 528, .external_lex_state = 12},
  [9475] = {.lex_state = 426, .external_lex_state = 3},
  [9476] = {.lex_state = 426, .external_lex_state = 3},
  [9477] = {.lex_state = 423, .external_lex_state = 3},
  [9478] = {.lex_state = 423, .external_lex_state = 3},
  [9479] = {.lex_state = 423, .external_lex_state = 3},
  [9480] = {.lex_state = 423, .external_lex_state = 14},
  [9481] = {.lex_state = 532, .external_lex_state = 3},
  [9482] = {.lex_state = 532, .external_lex_state = 3},
  [9483] = {.lex_state = 532, .external_lex_state = 3},
  [9484] = {.lex_state = 192, .external_lex_state = 2},
  [9485] = {.lex_state = 192, .external_lex_state = 2},
  [9486] = {.lex_state = 192, .external_lex_state = 2},
  [9487] = {.lex_state = 192, .external_lex_state = 2},
  [9488] = {.lex_state = 192, .external_lex_state = 2},
  [9489] = {.lex_state = 192, .external_lex_state = 2},
  [9490] = {.lex_state = 192, .external_lex_state = 2},
  [9491] = {.lex_state = 192, .external_lex_state = 2},
  [9492] = {.lex_state = 192, .external_lex_state = 2},
  [9493] = {.lex_state = 192, .external_lex_state = 2},
  [9494] = {.lex_state = 192, .external_lex_state = 28},
  [9495] = {.lex_state = 532, .external_lex_state = 3},
  [9496] = {.lex_state = 192, .external_lex_state = 28},
  [9497] = {.lex_state = 192, .external_lex_state = 2},
  [9498] = {.lex_state = 363, .external_lex_state = 3},
  [9499] = {.lex_state = 363, .external_lex_state = 3},
  [9500] = {.lex_state = 192, .external_lex_state = 2},
  [9501] = {.lex_state = 192, .external_lex_state = 28},
  [9502] = {.lex_state = 363, .external_lex_state = 3},
  [9503] = {.lex_state = 363, .external_lex_state = 3},
  [9504] = {.lex_state = 363, .external_lex_state = 3},
  [9505] = {.lex_state = 192, .external_lex_state = 2},
  [9506] = {.lex_state = 192, .external_lex_state = 28},
  [9507] = {.lex_state = 426, .external_lex_state = 3},
  [9508] = {.lex_state = 423, .external_lex_state = 3},
  [9509] = {.lex_state = 423, .external_lex_state = 3},
  [9510] = {.lex_state = 192, .external_lex_state = 2},
  [9511] = {.lex_state = 512, .external_lex_state = 24},
  [9512] = {.lex_state = 512, .external_lex_state = 24},
  [9513] = {.lex_state = 512, .external_lex_state = 24},
  [9514] = {.lex_state = 528, .external_lex_state = 12},
  [9515] = {.lex_state = 512, .external_lex_state = 24},
  [9516] = {.lex_state = 512, .external_lex_state = 24},
  [9517] = {.lex_state = 192, .external_lex_state = 2},
  [9518] = {.lex_state = 426, .external_lex_state = 24},
  [9519] = {.lex_state = 426, .external_lex_state = 24},
  [9520] = {.lex_state = 192, .external_lex_state = 2},
  [9521] = {.lex_state = 192, .external_lex_state = 2},
  [9522] = {.lex_state = 192, .external_lex_state = 2},
  [9523] = {.lex_state = 192, .external_lex_state = 2},
  [9524] = {.lex_state = 192, .external_lex_state = 2},
  [9525] = {.lex_state = 192, .external_lex_state = 2},
  [9526] = {.lex_state = 192, .external_lex_state = 2},
  [9527] = {.lex_state = 192, .external_lex_state = 2},
  [9528] = {.lex_state = 192, .external_lex_state = 2},
  [9529] = {.lex_state = 192, .external_lex_state = 2},
  [9530] = {.lex_state = 192, .external_lex_state = 28},
  [9531] = {.lex_state = 192, .external_lex_state = 2},
  [9532] = {.lex_state = 426, .external_lex_state = 26},
  [9533] = {.lex_state = 426, .external_lex_state = 24},
  [9534] = {.lex_state = 426, .external_lex_state = 24},
  [9535] = {.lex_state = 426, .external_lex_state = 24},
  [9536] = {.lex_state = 528, .external_lex_state = 12},
  [9537] = {.lex_state = 426, .external_lex_state = 24},
  [9538] = {.lex_state = 426, .external_lex_state = 24},
  [9539] = {.lex_state = 192, .external_lex_state = 28},
  [9540] = {.lex_state = 512, .external_lex_state = 24},
  [9541] = {.lex_state = 512, .external_lex_state = 24},
  [9542] = {.lex_state = 192, .external_lex_state = 2},
  [9543] = {.lex_state = 192, .external_lex_state = 28},
  [9544] = {.lex_state = 423, .external_lex_state = 24},
  [9545] = {.lex_state = 512, .external_lex_state = 24},
  [9546] = {.lex_state = 363, .external_lex_state = 3},
  [9547] = {.lex_state = 363, .external_lex_state = 3},
  [9548] = {.lex_state = 192, .external_lex_state = 2},
  [9549] = {.lex_state = 192, .external_lex_state = 28},
  [9550] = {.lex_state = 363, .external_lex_state = 3},
  [9551] = {.lex_state = 363, .external_lex_state = 3},
  [9552] = {.lex_state = 363, .external_lex_state = 3},
  [9553] = {.lex_state = 156, .external_lex_state = 3},
  [9554] = {.lex_state = 192, .external_lex_state = 2},
  [9555] = {.lex_state = 363, .external_lex_state = 3},
  [9556] = {.lex_state = 363, .external_lex_state = 3},
  [9557] = {.lex_state = 192, .external_lex_state = 2},
  [9558] = {.lex_state = 192, .external_lex_state = 2},
  [9559] = {.lex_state = 192, .external_lex_state = 2},
  [9560] = {.lex_state = 192, .external_lex_state = 2},
  [9561] = {.lex_state = 192, .external_lex_state = 2},
  [9562] = {.lex_state = 192, .external_lex_state = 2},
  [9563] = {.lex_state = 192, .external_lex_state = 2},
  [9564] = {.lex_state = 192, .external_lex_state = 2},
  [9565] = {.lex_state = 192, .external_lex_state = 2},
  [9566] = {.lex_state = 192, .external_lex_state = 2},
  [9567] = {.lex_state = 192, .external_lex_state = 28},
  [9568] = {.lex_state = 192, .external_lex_state = 2},
  [9569] = {.lex_state = 363, .external_lex_state = 3},
  [9570] = {.lex_state = 363, .external_lex_state = 3},
  [9571] = {.lex_state = 363, .external_lex_state = 3},
  [9572] = {.lex_state = 528, .external_lex_state = 12},
  [9573] = {.lex_state = 363, .external_lex_state = 3},
  [9574] = {.lex_state = 363, .external_lex_state = 3},
  [9575] = {.lex_state = 249, .external_lex_state = 3},
  [9576] = {.lex_state = 192, .external_lex_state = 2},
  [9577] = {.lex_state = 192, .external_lex_state = 2},
  [9578] = {.lex_state = 192, .external_lex_state = 2},
  [9579] = {.lex_state = 239},
  [9580] = {.lex_state = 192, .external_lex_state = 2},
  [9581] = {.lex_state = 355, .external_lex_state = 10},
  [9582] = {.lex_state = 355, .external_lex_state = 10},
  [9583] = {.lex_state = 355, .external_lex_state = 10},
  [9584] = {.lex_state = 355, .external_lex_state = 10},
  [9585] = {.lex_state = 192, .external_lex_state = 2},
  [9586] = {.lex_state = 192, .external_lex_state = 2},
  [9587] = {.lex_state = 360, .external_lex_state = 10},
  [9588] = {.lex_state = 363, .external_lex_state = 3},
  [9589] = {.lex_state = 366, .external_lex_state = 10},
  [9590] = {.lex_state = 264, .external_lex_state = 3},
  [9591] = {.lex_state = 363, .external_lex_state = 3},
  [9592] = {.lex_state = 213},
  [9593] = {.lex_state = 370, .external_lex_state = 3},
  [9594] = {.lex_state = 373, .external_lex_state = 14},
  [9595] = {.lex_state = 249, .external_lex_state = 3},
  [9596] = {.lex_state = 256, .external_lex_state = 13},
  [9597] = {.lex_state = 192, .external_lex_state = 2},
  [9598] = {.lex_state = 192, .external_lex_state = 2},
  [9599] = {.lex_state = 192, .external_lex_state = 2},
  [9600] = {.lex_state = 192, .external_lex_state = 2},
  [9601] = {.lex_state = 192, .external_lex_state = 2},
  [9602] = {.lex_state = 192, .external_lex_state = 2},
  [9603] = {.lex_state = 192, .external_lex_state = 2},
  [9604] = {.lex_state = 192, .external_lex_state = 2},
  [9605] = {.lex_state = 192, .external_lex_state = 2},
  [9606] = {.lex_state = 192, .external_lex_state = 2},
  [9607] = {.lex_state = 192, .external_lex_state = 2},
  [9608] = {.lex_state = 192, .external_lex_state = 2},
  [9609] = {.lex_state = 192, .external_lex_state = 2},
  [9610] = {.lex_state = 192, .external_lex_state = 2},
  [9611] = {.lex_state = 192, .external_lex_state = 2},
  [9612] = {.lex_state = 192, .external_lex_state = 2},
  [9613] = {.lex_state = 192, .external_lex_state = 2},
  [9614] = {.lex_state = 192, .external_lex_state = 2},
  [9615] = {.lex_state = 239},
  [9616] = {.lex_state = 192, .external_lex_state = 2},
  [9617] = {.lex_state = 366, .external_lex_state = 10},
  [9618] = {.lex_state = 366, .external_lex_state = 10},
  [9619] = {.lex_state = 366, .external_lex_state = 10},
  [9620] = {.lex_state = 366, .external_lex_state = 10},
  [9621] = {.lex_state = 192, .external_lex_state = 2},
  [9622] = {.lex_state = 192, .external_lex_state = 2},
  [9623] = {.lex_state = 360, .external_lex_state = 10},
  [9624] = {.lex_state = 423, .external_lex_state = 3},
  [9625] = {.lex_state = 366, .external_lex_state = 10},
  [9626] = {.lex_state = 426, .external_lex_state = 3},
  [9627] = {.lex_state = 426, .external_lex_state = 3},
  [9628] = {.lex_state = 213},
  [9629] = {.lex_state = 423, .external_lex_state = 3},
  [9630] = {.lex_state = 429, .external_lex_state = 14},
  [9631] = {.lex_state = 192, .external_lex_state = 28},
  [9632] = {.lex_state = 192, .external_lex_state = 2},
  [9633] = {.lex_state = 264, .external_lex_state = 14},
  [9634] = {.lex_state = 128, .external_lex_state = 13},
  [9635] = {.lex_state = 128, .external_lex_state = 2},
  [9636] = {.lex_state = 192, .external_lex_state = 2},
  [9637] = {.lex_state = 426, .external_lex_state = 3},
  [9638] = {.lex_state = 426, .external_lex_state = 3},
  [9639] = {.lex_state = 192, .external_lex_state = 2},
  [9640] = {.lex_state = 192, .external_lex_state = 2},
  [9641] = {.lex_state = 192, .external_lex_state = 2},
  [9642] = {.lex_state = 192, .external_lex_state = 2},
  [9643] = {.lex_state = 192, .external_lex_state = 2},
  [9644] = {.lex_state = 192, .external_lex_state = 2},
  [9645] = {.lex_state = 192, .external_lex_state = 2},
  [9646] = {.lex_state = 192, .external_lex_state = 2},
  [9647] = {.lex_state = 192, .external_lex_state = 2},
  [9648] = {.lex_state = 192, .external_lex_state = 2},
  [9649] = {.lex_state = 192, .external_lex_state = 28},
  [9650] = {.lex_state = 192, .external_lex_state = 2},
  [9651] = {.lex_state = 426, .external_lex_state = 14},
  [9652] = {.lex_state = 426, .external_lex_state = 3},
  [9653] = {.lex_state = 426, .external_lex_state = 3},
  [9654] = {.lex_state = 426, .external_lex_state = 3},
  [9655] = {.lex_state = 528, .external_lex_state = 12},
  [9656] = {.lex_state = 426, .external_lex_state = 3},
  [9657] = {.lex_state = 426, .external_lex_state = 3},
  [9658] = {.lex_state = 532, .external_lex_state = 3},
  [9659] = {.lex_state = 192, .external_lex_state = 28},
  [9660] = {.lex_state = 532, .external_lex_state = 3},
  [9661] = {.lex_state = 363, .external_lex_state = 3},
  [9662] = {.lex_state = 363, .external_lex_state = 3},
  [9663] = {.lex_state = 192, .external_lex_state = 2},
  [9664] = {.lex_state = 192, .external_lex_state = 28},
  [9665] = {.lex_state = 363, .external_lex_state = 3},
  [9666] = {.lex_state = 363, .external_lex_state = 3},
  [9667] = {.lex_state = 363, .external_lex_state = 3},
  [9668] = {.lex_state = 192, .external_lex_state = 2},
  [9669] = {.lex_state = 192, .external_lex_state = 28},
  [9670] = {.lex_state = 363, .external_lex_state = 3},
  [9671] = {.lex_state = 352, .external_lex_state = 22},
  [9672] = {.lex_state = 209},
  [9673] = {.lex_state = 352, .external_lex_state = 22},
  [9674] = {.lex_state = 345, .external_lex_state = 13},
  [9675] = {.lex_state = 512, .external_lex_state = 3},
  [9676] = {.lex_state = 192, .external_lex_state = 2},
  [9677] = {.lex_state = 192, .external_lex_state = 2},
  [9678] = {.lex_state = 239},
  [9679] = {.lex_state = 192, .external_lex_state = 2},
  [9680] = {.lex_state = 360, .external_lex_state = 10},
  [9681] = {.lex_state = 512, .external_lex_state = 3},
  [9682] = {.lex_state = 512, .external_lex_state = 3},
  [9683] = {.lex_state = 512, .external_lex_state = 3},
  [9684] = {.lex_state = 512, .external_lex_state = 14},
  [9685] = {.lex_state = 512, .external_lex_state = 3},
  [9686] = {.lex_state = 192, .external_lex_state = 2},
  [9687] = {.lex_state = 192, .external_lex_state = 2},
  [9688] = {.lex_state = 192, .external_lex_state = 2},
  [9689] = {.lex_state = 192, .external_lex_state = 2},
  [9690] = {.lex_state = 192, .external_lex_state = 2},
  [9691] = {.lex_state = 192, .external_lex_state = 2},
  [9692] = {.lex_state = 192, .external_lex_state = 2},
  [9693] = {.lex_state = 192, .external_lex_state = 2},
  [9694] = {.lex_state = 192, .external_lex_state = 2},
  [9695] = {.lex_state = 192, .external_lex_state = 2},
  [9696] = {.lex_state = 192, .external_lex_state = 28},
  [9697] = {.lex_state = 192, .external_lex_state = 2},
  [9698] = {.lex_state = 638, .external_lex_state = 14},
  [9699] = {.lex_state = 512, .external_lex_state = 3},
  [9700] = {.lex_state = 512, .external_lex_state = 3},
  [9701] = {.lex_state = 512, .external_lex_state = 3},
  [9702] = {.lex_state = 192, .external_lex_state = 2},
  [9703] = {.lex_state = 512, .external_lex_state = 3},
  [9704] = {.lex_state = 192, .external_lex_state = 2},
  [9705] = {.lex_state = 512, .external_lex_state = 3},
  [9706] = {.lex_state = 528, .external_lex_state = 29},
  [9707] = {.lex_state = 512, .external_lex_state = 3},
  [9708] = {.lex_state = 345, .external_lex_state = 13},
  [9709] = {.lex_state = 512, .external_lex_state = 3},
  [9710] = {.lex_state = 512, .external_lex_state = 3},
  [9711] = {.lex_state = 512, .external_lex_state = 3},
  [9712] = {.lex_state = 512, .external_lex_state = 3},
  [9713] = {.lex_state = 512, .external_lex_state = 3},
  [9714] = {.lex_state = 512, .external_lex_state = 3},
  [9715] = {.lex_state = 561, .external_lex_state = 16},
  [9716] = {.lex_state = 512, .external_lex_state = 3},
  [9717] = {.lex_state = 512, .external_lex_state = 3},
  [9718] = {.lex_state = 512, .external_lex_state = 3},
  [9719] = {.lex_state = 512, .external_lex_state = 3},
  [9720] = {.lex_state = 345, .external_lex_state = 13},
  [9721] = {.lex_state = 177, .external_lex_state = 17},
  [9722] = {.lex_state = 345, .external_lex_state = 13},
  [9723] = {.lex_state = 685, .external_lex_state = 13},
  [9724] = {.lex_state = 528, .external_lex_state = 12},
  [9725] = {.lex_state = 345, .external_lex_state = 13},
  [9726] = {.lex_state = 685, .external_lex_state = 13},
  [9727] = {.lex_state = 512, .external_lex_state = 3},
  [9728] = {.lex_state = 512, .external_lex_state = 3},
  [9729] = {.lex_state = 512, .external_lex_state = 3},
  [9730] = {.lex_state = 641, .external_lex_state = 14},
  [9731] = {.lex_state = 532, .external_lex_state = 3},
  [9732] = {.lex_state = 192, .external_lex_state = 2},
  [9733] = {.lex_state = 192, .external_lex_state = 28},
  [9734] = {.lex_state = 423, .external_lex_state = 3},
  [9735] = {.lex_state = 532, .external_lex_state = 3},
  [9736] = {.lex_state = 363, .external_lex_state = 3},
  [9737] = {.lex_state = 363, .external_lex_state = 3},
  [9738] = {.lex_state = 363, .external_lex_state = 3},
  [9739] = {.lex_state = 363, .external_lex_state = 3},
  [9740] = {.lex_state = 363, .external_lex_state = 3},
  [9741] = {.lex_state = 363, .external_lex_state = 3},
  [9742] = {.lex_state = 363, .external_lex_state = 3},
  [9743] = {.lex_state = 561, .external_lex_state = 16},
  [9744] = {.lex_state = 363, .external_lex_state = 3},
  [9745] = {.lex_state = 363, .external_lex_state = 3},
  [9746] = {.lex_state = 363, .external_lex_state = 3},
  [9747] = {.lex_state = 363, .external_lex_state = 3},
  [9748] = {.lex_state = 363, .external_lex_state = 3},
  [9749] = {.lex_state = 363, .external_lex_state = 3},
  [9750] = {.lex_state = 363, .external_lex_state = 3},
  [9751] = {.lex_state = 367, .external_lex_state = 14},
  [9752] = {.lex_state = 363, .external_lex_state = 3},
  [9753] = {.lex_state = 363, .external_lex_state = 3},
  [9754] = {.lex_state = 363, .external_lex_state = 3},
  [9755] = {.lex_state = 528, .external_lex_state = 12},
  [9756] = {.lex_state = 363, .external_lex_state = 3},
  [9757] = {.lex_state = 363, .external_lex_state = 3},
  [9758] = {.lex_state = 192, .external_lex_state = 2},
  [9759] = {.lex_state = 423, .external_lex_state = 3},
  [9760] = {.lex_state = 423, .external_lex_state = 3},
  [9761] = {.lex_state = 423, .external_lex_state = 3},
  [9762] = {.lex_state = 528, .external_lex_state = 12},
  [9763] = {.lex_state = 423, .external_lex_state = 3},
  [9764] = {.lex_state = 423, .external_lex_state = 3},
  [9765] = {.lex_state = 192, .external_lex_state = 28},
  [9766] = {.lex_state = 363, .external_lex_state = 3},
  [9767] = {.lex_state = 249, .external_lex_state = 3},
  [9768] = {.lex_state = 426, .external_lex_state = 3},
  [9769] = {.lex_state = 426, .external_lex_state = 3},
  [9770] = {.lex_state = 426, .external_lex_state = 3},
  [9771] = {.lex_state = 426, .external_lex_state = 3},
  [9772] = {.lex_state = 426, .external_lex_state = 3},
  [9773] = {.lex_state = 561, .external_lex_state = 16},
  [9774] = {.lex_state = 426, .external_lex_state = 3},
  [9775] = {.lex_state = 426, .external_lex_state = 3},
  [9776] = {.lex_state = 426, .external_lex_state = 3},
  [9777] = {.lex_state = 426, .external_lex_state = 3},
  [9778] = {.lex_state = 426, .external_lex_state = 3},
  [9779] = {.lex_state = 426, .external_lex_state = 3},
  [9780] = {.lex_state = 426, .external_lex_state = 3},
  [9781] = {.lex_state = 426, .external_lex_state = 14},
  [9782] = {.lex_state = 192, .external_lex_state = 2},
  [9783] = {.lex_state = 192, .external_lex_state = 28},
  [9784] = {.lex_state = 423, .external_lex_state = 3},
  [9785] = {.lex_state = 532, .external_lex_state = 3},
  [9786] = {.lex_state = 532, .external_lex_state = 3},
  [9787] = {.lex_state = 532, .external_lex_state = 3},
  [9788] = {.lex_state = 532, .external_lex_state = 3},
  [9789] = {.lex_state = 532, .external_lex_state = 3},
  [9790] = {.lex_state = 561, .external_lex_state = 16},
  [9791] = {.lex_state = 532, .external_lex_state = 3},
  [9792] = {.lex_state = 532, .external_lex_state = 3},
  [9793] = {.lex_state = 532, .external_lex_state = 3},
  [9794] = {.lex_state = 532, .external_lex_state = 3},
  [9795] = {.lex_state = 532, .external_lex_state = 3},
  [9796] = {.lex_state = 532, .external_lex_state = 3},
  [9797] = {.lex_state = 532, .external_lex_state = 3},
  [9798] = {.lex_state = 363, .external_lex_state = 3},
  [9799] = {.lex_state = 363, .external_lex_state = 3},
  [9800] = {.lex_state = 363, .external_lex_state = 3},
  [9801] = {.lex_state = 363, .external_lex_state = 3},
  [9802] = {.lex_state = 363, .external_lex_state = 3},
  [9803] = {.lex_state = 363, .external_lex_state = 3},
  [9804] = {.lex_state = 363, .external_lex_state = 3},
  [9805] = {.lex_state = 561, .external_lex_state = 16},
  [9806] = {.lex_state = 363, .external_lex_state = 3},
  [9807] = {.lex_state = 363, .external_lex_state = 3},
  [9808] = {.lex_state = 363, .external_lex_state = 3},
  [9809] = {.lex_state = 363, .external_lex_state = 3},
  [9810] = {.lex_state = 363, .external_lex_state = 3},
  [9811] = {.lex_state = 363, .external_lex_state = 3},
  [9812] = {.lex_state = 363, .external_lex_state = 3},
  [9813] = {.lex_state = 367, .external_lex_state = 14},
  [9814] = {.lex_state = 363, .external_lex_state = 3},
  [9815] = {.lex_state = 363, .external_lex_state = 3},
  [9816] = {.lex_state = 363, .external_lex_state = 3},
  [9817] = {.lex_state = 528, .external_lex_state = 12},
  [9818] = {.lex_state = 363, .external_lex_state = 3},
  [9819] = {.lex_state = 363, .external_lex_state = 3},
  [9820] = {.lex_state = 192, .external_lex_state = 2},
  [9821] = {.lex_state = 423, .external_lex_state = 3},
  [9822] = {.lex_state = 423, .external_lex_state = 3},
  [9823] = {.lex_state = 423, .external_lex_state = 3},
  [9824] = {.lex_state = 528, .external_lex_state = 12},
  [9825] = {.lex_state = 423, .external_lex_state = 3},
  [9826] = {.lex_state = 423, .external_lex_state = 3},
  [9827] = {.lex_state = 192, .external_lex_state = 28},
  [9828] = {.lex_state = 363, .external_lex_state = 3},
  [9829] = {.lex_state = 249, .external_lex_state = 3},
  [9830] = {.lex_state = 426, .external_lex_state = 3},
  [9831] = {.lex_state = 426, .external_lex_state = 3},
  [9832] = {.lex_state = 426, .external_lex_state = 3},
  [9833] = {.lex_state = 426, .external_lex_state = 3},
  [9834] = {.lex_state = 426, .external_lex_state = 3},
  [9835] = {.lex_state = 561, .external_lex_state = 16},
  [9836] = {.lex_state = 426, .external_lex_state = 3},
  [9837] = {.lex_state = 426, .external_lex_state = 3},
  [9838] = {.lex_state = 426, .external_lex_state = 3},
  [9839] = {.lex_state = 426, .external_lex_state = 3},
  [9840] = {.lex_state = 426, .external_lex_state = 3},
  [9841] = {.lex_state = 426, .external_lex_state = 3},
  [9842] = {.lex_state = 426, .external_lex_state = 3},
  [9843] = {.lex_state = 426, .external_lex_state = 14},
  [9844] = {.lex_state = 192, .external_lex_state = 2},
  [9845] = {.lex_state = 192, .external_lex_state = 28},
  [9846] = {.lex_state = 423, .external_lex_state = 3},
  [9847] = {.lex_state = 532, .external_lex_state = 3},
  [9848] = {.lex_state = 532, .external_lex_state = 3},
  [9849] = {.lex_state = 532, .external_lex_state = 3},
  [9850] = {.lex_state = 532, .external_lex_state = 3},
  [9851] = {.lex_state = 532, .external_lex_state = 3},
  [9852] = {.lex_state = 561, .external_lex_state = 16},
  [9853] = {.lex_state = 532, .external_lex_state = 3},
  [9854] = {.lex_state = 532, .external_lex_state = 3},
  [9855] = {.lex_state = 532, .external_lex_state = 3},
  [9856] = {.lex_state = 532, .external_lex_state = 3},
  [9857] = {.lex_state = 532, .external_lex_state = 3},
  [9858] = {.lex_state = 532, .external_lex_state = 3},
  [9859] = {.lex_state = 532, .external_lex_state = 3},
  [9860] = {.lex_state = 192, .external_lex_state = 2},
  [9861] = {.lex_state = 192, .external_lex_state = 28},
  [9862] = {.lex_state = 426, .external_lex_state = 3},
  [9863] = {.lex_state = 423, .external_lex_state = 3},
  [9864] = {.lex_state = 423, .external_lex_state = 3},
  [9865] = {.lex_state = 192, .external_lex_state = 2},
  [9866] = {.lex_state = 390, .external_lex_state = 24},
  [9867] = {.lex_state = 390, .external_lex_state = 24},
  [9868] = {.lex_state = 408, .external_lex_state = 24},
  [9869] = {.lex_state = 408, .external_lex_state = 24},
  [9870] = {.lex_state = 408, .external_lex_state = 24},
  [9871] = {.lex_state = 408, .external_lex_state = 24},
  [9872] = {.lex_state = 408, .external_lex_state = 24},
  [9873] = {.lex_state = 561, .external_lex_state = 16},
  [9874] = {.lex_state = 408, .external_lex_state = 24},
  [9875] = {.lex_state = 408, .external_lex_state = 24},
  [9876] = {.lex_state = 408, .external_lex_state = 24},
  [9877] = {.lex_state = 408, .external_lex_state = 24},
  [9878] = {.lex_state = 408, .external_lex_state = 24},
  [9879] = {.lex_state = 408, .external_lex_state = 24},
  [9880] = {.lex_state = 408, .external_lex_state = 24},
  [9881] = {.lex_state = 402, .external_lex_state = 24},
  [9882] = {.lex_state = 541, .external_lex_state = 24},
  [9883] = {.lex_state = 541, .external_lex_state = 24},
  [9884] = {.lex_state = 541, .external_lex_state = 24},
  [9885] = {.lex_state = 541, .external_lex_state = 24},
  [9886] = {.lex_state = 541, .external_lex_state = 24},
  [9887] = {.lex_state = 561, .external_lex_state = 16},
  [9888] = {.lex_state = 541, .external_lex_state = 24},
  [9889] = {.lex_state = 541, .external_lex_state = 24},
  [9890] = {.lex_state = 541, .external_lex_state = 24},
  [9891] = {.lex_state = 541, .external_lex_state = 24},
  [9892] = {.lex_state = 541, .external_lex_state = 24},
  [9893] = {.lex_state = 541, .external_lex_state = 24},
  [9894] = {.lex_state = 541, .external_lex_state = 24},
  [9895] = {.lex_state = 541, .external_lex_state = 26},
  [9896] = {.lex_state = 402, .external_lex_state = 24},
  [9897] = {.lex_state = 390, .external_lex_state = 24},
  [9898] = {.lex_state = 408, .external_lex_state = 24},
  [9899] = {.lex_state = 408, .external_lex_state = 24},
  [9900] = {.lex_state = 390, .external_lex_state = 24},
  [9901] = {.lex_state = 390, .external_lex_state = 24},
  [9902] = {.lex_state = 128},
  [9903] = {.lex_state = 390, .external_lex_state = 24},
  [9904] = {.lex_state = 390, .external_lex_state = 24},
  [9905] = {.lex_state = 128},
  [9906] = {.lex_state = 399, .external_lex_state = 24},
  [9907] = {.lex_state = 128},
  [9908] = {.lex_state = 405, .external_lex_state = 24},
  [9909] = {.lex_state = 405, .external_lex_state = 24},
  [9910] = {.lex_state = 288, .external_lex_state = 2},
  [9911] = {.lex_state = 239},
  [9912] = {.lex_state = 239},
  [9913] = {.lex_state = 239},
  [9914] = {.lex_state = 304, .external_lex_state = 16},
  [9915] = {.lex_state = 192, .external_lex_state = 2},
  [9916] = {.lex_state = 192, .external_lex_state = 2},
  [9917] = {.lex_state = 192, .external_lex_state = 2},
  [9918] = {.lex_state = 239},
  [9919] = {.lex_state = 192, .external_lex_state = 2},
  [9920] = {.lex_state = 355, .external_lex_state = 25},
  [9921] = {.lex_state = 355, .external_lex_state = 25},
  [9922] = {.lex_state = 355, .external_lex_state = 25},
  [9923] = {.lex_state = 355, .external_lex_state = 25},
  [9924] = {.lex_state = 192, .external_lex_state = 2},
  [9925] = {.lex_state = 192, .external_lex_state = 2},
  [9926] = {.lex_state = 360, .external_lex_state = 25},
  [9927] = {.lex_state = 363, .external_lex_state = 24},
  [9928] = {.lex_state = 366, .external_lex_state = 25},
  [9929] = {.lex_state = 363, .external_lex_state = 24},
  [9930] = {.lex_state = 363, .external_lex_state = 24},
  [9931] = {.lex_state = 213},
  [9932] = {.lex_state = 370, .external_lex_state = 24},
  [9933] = {.lex_state = 373, .external_lex_state = 26},
  [9934] = {.lex_state = 304, .external_lex_state = 16},
  [9935] = {.lex_state = 192, .external_lex_state = 2},
  [9936] = {.lex_state = 192, .external_lex_state = 2},
  [9937] = {.lex_state = 192, .external_lex_state = 2},
  [9938] = {.lex_state = 192, .external_lex_state = 2},
  [9939] = {.lex_state = 192, .external_lex_state = 2},
  [9940] = {.lex_state = 192, .external_lex_state = 2},
  [9941] = {.lex_state = 192, .external_lex_state = 2},
  [9942] = {.lex_state = 192, .external_lex_state = 2},
  [9943] = {.lex_state = 192, .external_lex_state = 2},
  [9944] = {.lex_state = 192, .external_lex_state = 2},
  [9945] = {.lex_state = 192, .external_lex_state = 2},
  [9946] = {.lex_state = 192, .external_lex_state = 2},
  [9947] = {.lex_state = 192, .external_lex_state = 2},
  [9948] = {.lex_state = 239},
  [9949] = {.lex_state = 192, .external_lex_state = 2},
  [9950] = {.lex_state = 366, .external_lex_state = 25},
  [9951] = {.lex_state = 366, .external_lex_state = 25},
  [9952] = {.lex_state = 366, .external_lex_state = 25},
  [9953] = {.lex_state = 366, .external_lex_state = 25},
  [9954] = {.lex_state = 192, .external_lex_state = 2},
  [9955] = {.lex_state = 192, .external_lex_state = 2},
  [9956] = {.lex_state = 360, .external_lex_state = 25},
  [9957] = {.lex_state = 423, .external_lex_state = 24},
  [9958] = {.lex_state = 366, .external_lex_state = 25},
  [9959] = {.lex_state = 426, .external_lex_state = 24},
  [9960] = {.lex_state = 426, .external_lex_state = 24},
  [9961] = {.lex_state = 213},
  [9962] = {.lex_state = 423, .external_lex_state = 24},
  [9963] = {.lex_state = 429, .external_lex_state = 26},
  [9964] = {.lex_state = 192, .external_lex_state = 28},
  [9965] = {.lex_state = 192, .external_lex_state = 2},
  [9966] = {.lex_state = 253, .external_lex_state = 20},
  [9967] = {.lex_state = 239},
  [9968] = {.lex_state = 128},
  [9969] = {.lex_state = 197},
  [9970] = {.lex_state = 128, .external_lex_state = 11},
  [9971] = {.lex_state = 239},
  [9972] = {.lex_state = 239},
  [9973] = {.lex_state = 128},
  [9974] = {.lex_state = 156, .external_lex_state = 3},
  [9975] = {.lex_state = 192, .external_lex_state = 2},
  [9976] = {.lex_state = 304, .external_lex_state = 16},
  [9977] = {.lex_state = 192, .external_lex_state = 28},
  [9978] = {.lex_state = 304, .external_lex_state = 16},
  [9979] = {.lex_state = 650, .external_lex_state = 24},
  [9980] = {.lex_state = 650, .external_lex_state = 24},
  [9981] = {.lex_state = 650, .external_lex_state = 24},
  [9982] = {.lex_state = 650, .external_lex_state = 24},
  [9983] = {.lex_state = 650, .external_lex_state = 24},
  [9984] = {.lex_state = 650, .external_lex_state = 24},
  [9985] = {.lex_state = 650, .external_lex_state = 24},
  [9986] = {.lex_state = 561, .external_lex_state = 16},
  [9987] = {.lex_state = 650, .external_lex_state = 24},
  [9988] = {.lex_state = 650, .external_lex_state = 24},
  [9989] = {.lex_state = 650, .external_lex_state = 24},
  [9990] = {.lex_state = 650, .external_lex_state = 24},
  [9991] = {.lex_state = 650, .external_lex_state = 24},
  [9992] = {.lex_state = 650, .external_lex_state = 24},
  [9993] = {.lex_state = 650, .external_lex_state = 24},
  [9994] = {.lex_state = 650, .external_lex_state = 26},
  [9995] = {.lex_state = 659, .external_lex_state = 26},
  [9996] = {.lex_state = 659, .external_lex_state = 24},
  [9997] = {.lex_state = 659, .external_lex_state = 24},
  [9998] = {.lex_state = 659, .external_lex_state = 24},
  [9999] = {.lex_state = 528, .external_lex_state = 12},
  [10000] = {.lex_state = 659, .external_lex_state = 24},
  [10001] = {.lex_state = 659, .external_lex_state = 24},
  [10002] = {.lex_state = 192, .external_lex_state = 2},
  [10003] = {.lex_state = 663, .external_lex_state = 24},
  [10004] = {.lex_state = 663, .external_lex_state = 24},
  [10005] = {.lex_state = 663, .external_lex_state = 24},
  [10006] = {.lex_state = 528, .external_lex_state = 12},
  [10007] = {.lex_state = 663, .external_lex_state = 24},
  [10008] = {.lex_state = 663, .external_lex_state = 24},
  [10009] = {.lex_state = 192, .external_lex_state = 28},
  [10010] = {.lex_state = 659, .external_lex_state = 24},
  [10011] = {.lex_state = 561, .external_lex_state = 16},
  [10012] = {.lex_state = 566, .external_lex_state = 24},
  [10013] = {.lex_state = 566, .external_lex_state = 24},
  [10014] = {.lex_state = 566, .external_lex_state = 24},
  [10015] = {.lex_state = 566, .external_lex_state = 24},
  [10016] = {.lex_state = 566, .external_lex_state = 24},
  [10017] = {.lex_state = 561, .external_lex_state = 16},
  [10018] = {.lex_state = 566, .external_lex_state = 24},
  [10019] = {.lex_state = 566, .external_lex_state = 24},
  [10020] = {.lex_state = 566, .external_lex_state = 24},
  [10021] = {.lex_state = 566, .external_lex_state = 24},
  [10022] = {.lex_state = 566, .external_lex_state = 24},
  [10023] = {.lex_state = 566, .external_lex_state = 24},
  [10024] = {.lex_state = 566, .external_lex_state = 24},
  [10025] = {.lex_state = 566, .external_lex_state = 26},
  [10026] = {.lex_state = 663, .external_lex_state = 26},
  [10027] = {.lex_state = 192, .external_lex_state = 2},
  [10028] = {.lex_state = 192, .external_lex_state = 28},
  [10029] = {.lex_state = 663, .external_lex_state = 24},
  [10030] = {.lex_state = 561, .external_lex_state = 16},
  [10031] = {.lex_state = 561, .external_lex_state = 16},
  [10032] = {.lex_state = 561, .external_lex_state = 16},
  [10033] = {.lex_state = 561, .external_lex_state = 16},
  [10034] = {.lex_state = 561, .external_lex_state = 16},
  [10035] = {.lex_state = 561, .external_lex_state = 16},
  [10036] = {.lex_state = 561, .external_lex_state = 16},
  [10037] = {.lex_state = 561, .external_lex_state = 16},
  [10038] = {.lex_state = 561, .external_lex_state = 16},
  [10039] = {.lex_state = 561, .external_lex_state = 16},
  [10040] = {.lex_state = 561, .external_lex_state = 16},
  [10041] = {.lex_state = 561, .external_lex_state = 16},
  [10042] = {.lex_state = 561, .external_lex_state = 16},
  [10043] = {.lex_state = 650, .external_lex_state = 20},
  [10044] = {.lex_state = 301, .external_lex_state = 3},
  [10045] = {.lex_state = 301, .external_lex_state = 3},
  [10046] = {.lex_state = 229, .external_lex_state = 3},
  [10047] = {.lex_state = 177, .external_lex_state = 4},
  [10048] = {.lex_state = 229, .external_lex_state = 3},
  [10049] = {.lex_state = 229, .external_lex_state = 3},
  [10050] = {.lex_state = 177, .external_lex_state = 4},
  [10051] = {.lex_state = 229, .external_lex_state = 3},
  [10052] = {.lex_state = 227, .external_lex_state = 7},
  [10053] = {.lex_state = 229, .external_lex_state = 3},
  [10054] = {.lex_state = 229, .external_lex_state = 3},
  [10055] = {.lex_state = 229, .external_lex_state = 3},
  [10056] = {.lex_state = 229, .external_lex_state = 3},
  [10057] = {.lex_state = 229, .external_lex_state = 3},
  [10058] = {.lex_state = 229, .external_lex_state = 3},
  [10059] = {.lex_state = 229, .external_lex_state = 3},
  [10060] = {.lex_state = 128},
  [10061] = {.lex_state = 229, .external_lex_state = 3},
  [10062] = {.lex_state = 128},
  [10063] = {.lex_state = 128},
  [10064] = {.lex_state = 229, .external_lex_state = 3},
  [10065] = {.lex_state = 128},
  [10066] = {.lex_state = 426, .external_lex_state = 3},
  [10067] = {.lex_state = 229, .external_lex_state = 3},
  [10068] = {.lex_state = 426, .external_lex_state = 3},
  [10069] = {.lex_state = 438, .external_lex_state = 3},
  [10070] = {.lex_state = 438, .external_lex_state = 3},
  [10071] = {.lex_state = 438, .external_lex_state = 3},
  [10072] = {.lex_state = 438, .external_lex_state = 3},
  [10073] = {.lex_state = 438, .external_lex_state = 3},
  [10074] = {.lex_state = 438, .external_lex_state = 3},
  [10075] = {.lex_state = 561, .external_lex_state = 16},
  [10076] = {.lex_state = 438, .external_lex_state = 3},
  [10077] = {.lex_state = 438, .external_lex_state = 3},
  [10078] = {.lex_state = 438, .external_lex_state = 3},
  [10079] = {.lex_state = 438, .external_lex_state = 3},
  [10080] = {.lex_state = 438, .external_lex_state = 3},
  [10081] = {.lex_state = 438, .external_lex_state = 3},
  [10082] = {.lex_state = 438, .external_lex_state = 3},
  [10083] = {.lex_state = 301, .external_lex_state = 3},
  [10084] = {.lex_state = 301, .external_lex_state = 3},
  [10085] = {.lex_state = 229, .external_lex_state = 3},
  [10086] = {.lex_state = 301, .external_lex_state = 3},
  [10087] = {.lex_state = 128},
  [10088] = {.lex_state = 301, .external_lex_state = 3},
  [10089] = {.lex_state = 584, .external_lex_state = 3},
  [10090] = {.lex_state = 363, .external_lex_state = 3},
  [10091] = {.lex_state = 363, .external_lex_state = 3},
  [10092] = {.lex_state = 363, .external_lex_state = 3},
  [10093] = {.lex_state = 363, .external_lex_state = 3},
  [10094] = {.lex_state = 363, .external_lex_state = 3},
  [10095] = {.lex_state = 363, .external_lex_state = 3},
  [10096] = {.lex_state = 363, .external_lex_state = 3},
  [10097] = {.lex_state = 561, .external_lex_state = 16},
  [10098] = {.lex_state = 363, .external_lex_state = 3},
  [10099] = {.lex_state = 363, .external_lex_state = 3},
  [10100] = {.lex_state = 363, .external_lex_state = 3},
  [10101] = {.lex_state = 363, .external_lex_state = 3},
  [10102] = {.lex_state = 363, .external_lex_state = 3},
  [10103] = {.lex_state = 363, .external_lex_state = 3},
  [10104] = {.lex_state = 363, .external_lex_state = 3},
  [10105] = {.lex_state = 367, .external_lex_state = 14},
  [10106] = {.lex_state = 363, .external_lex_state = 3},
  [10107] = {.lex_state = 363, .external_lex_state = 3},
  [10108] = {.lex_state = 363, .external_lex_state = 3},
  [10109] = {.lex_state = 528, .external_lex_state = 12},
  [10110] = {.lex_state = 363, .external_lex_state = 3},
  [10111] = {.lex_state = 363, .external_lex_state = 3},
  [10112] = {.lex_state = 192, .external_lex_state = 2},
  [10113] = {.lex_state = 423, .external_lex_state = 3},
  [10114] = {.lex_state = 423, .external_lex_state = 3},
  [10115] = {.lex_state = 423, .external_lex_state = 3},
  [10116] = {.lex_state = 528, .external_lex_state = 12},
  [10117] = {.lex_state = 423, .external_lex_state = 3},
  [10118] = {.lex_state = 423, .external_lex_state = 3},
  [10119] = {.lex_state = 192, .external_lex_state = 28},
  [10120] = {.lex_state = 363, .external_lex_state = 3},
  [10121] = {.lex_state = 249, .external_lex_state = 3},
  [10122] = {.lex_state = 426, .external_lex_state = 3},
  [10123] = {.lex_state = 426, .external_lex_state = 3},
  [10124] = {.lex_state = 426, .external_lex_state = 3},
  [10125] = {.lex_state = 426, .external_lex_state = 3},
  [10126] = {.lex_state = 426, .external_lex_state = 3},
  [10127] = {.lex_state = 561, .external_lex_state = 16},
  [10128] = {.lex_state = 426, .external_lex_state = 3},
  [10129] = {.lex_state = 426, .external_lex_state = 3},
  [10130] = {.lex_state = 426, .external_lex_state = 3},
  [10131] = {.lex_state = 426, .external_lex_state = 3},
  [10132] = {.lex_state = 426, .external_lex_state = 3},
  [10133] = {.lex_state = 426, .external_lex_state = 3},
  [10134] = {.lex_state = 426, .external_lex_state = 3},
  [10135] = {.lex_state = 426, .external_lex_state = 14},
  [10136] = {.lex_state = 192, .external_lex_state = 2},
  [10137] = {.lex_state = 192, .external_lex_state = 28},
  [10138] = {.lex_state = 423, .external_lex_state = 3},
  [10139] = {.lex_state = 532, .external_lex_state = 3},
  [10140] = {.lex_state = 532, .external_lex_state = 3},
  [10141] = {.lex_state = 532, .external_lex_state = 3},
  [10142] = {.lex_state = 532, .external_lex_state = 3},
  [10143] = {.lex_state = 532, .external_lex_state = 3},
  [10144] = {.lex_state = 561, .external_lex_state = 16},
  [10145] = {.lex_state = 532, .external_lex_state = 3},
  [10146] = {.lex_state = 532, .external_lex_state = 3},
  [10147] = {.lex_state = 532, .external_lex_state = 3},
  [10148] = {.lex_state = 532, .external_lex_state = 3},
  [10149] = {.lex_state = 532, .external_lex_state = 3},
  [10150] = {.lex_state = 532, .external_lex_state = 3},
  [10151] = {.lex_state = 532, .external_lex_state = 3},
  [10152] = {.lex_state = 471, .external_lex_state = 24},
  [10153] = {.lex_state = 471, .external_lex_state = 24},
  [10154] = {.lex_state = 192, .external_lex_state = 2},
  [10155] = {.lex_state = 192, .external_lex_state = 28},
  [10156] = {.lex_state = 471, .external_lex_state = 24},
  [10157] = {.lex_state = 595, .external_lex_state = 24},
  [10158] = {.lex_state = 595, .external_lex_state = 24},
  [10159] = {.lex_state = 465, .external_lex_state = 24},
  [10160] = {.lex_state = 465, .external_lex_state = 24},
  [10161] = {.lex_state = 177, .external_lex_state = 4},
  [10162] = {.lex_state = 268, .external_lex_state = 15},
  [10163] = {.lex_state = 465, .external_lex_state = 24},
  [10164] = {.lex_state = 177, .external_lex_state = 4},
  [10165] = {.lex_state = 465, .external_lex_state = 24},
  [10166] = {.lex_state = 465, .external_lex_state = 24},
  [10167] = {.lex_state = 177, .external_lex_state = 4},
  [10168] = {.lex_state = 268, .external_lex_state = 15},
  [10169] = {.lex_state = 465, .external_lex_state = 24},
  [10170] = {.lex_state = 177, .external_lex_state = 4},
  [10171] = {.lex_state = 465, .external_lex_state = 24},
  [10172] = {.lex_state = 312},
  [10173] = {.lex_state = 465, .external_lex_state = 24},
  [10174] = {.lex_state = 465, .external_lex_state = 24},
  [10175] = {.lex_state = 128, .external_lex_state = 2},
  [10176] = {.lex_state = 128, .external_lex_state = 2},
  [10177] = {.lex_state = 465, .external_lex_state = 24},
  [10178] = {.lex_state = 465, .external_lex_state = 24},
  [10179] = {.lex_state = 465, .external_lex_state = 24},
  [10180] = {.lex_state = 128},
  [10181] = {.lex_state = 465, .external_lex_state = 24},
  [10182] = {.lex_state = 128},
  [10183] = {.lex_state = 465, .external_lex_state = 24},
  [10184] = {.lex_state = 128},
  [10185] = {.lex_state = 465, .external_lex_state = 24},
  [10186] = {.lex_state = 128},
  [10187] = {.lex_state = 128, .external_lex_state = 2},
  [10188] = {.lex_state = 465, .external_lex_state = 24},
  [10189] = {.lex_state = 128},
  [10190] = {.lex_state = 128},
  [10191] = {.lex_state = 128},
  [10192] = {.lex_state = 465, .external_lex_state = 24},
  [10193] = {.lex_state = 128},
  [10194] = {.lex_state = 128},
  [10195] = {.lex_state = 192, .external_lex_state = 2},
  [10196] = {.lex_state = 192, .external_lex_state = 28},
  [10197] = {.lex_state = 443, .external_lex_state = 24},
  [10198] = {.lex_state = 435, .external_lex_state = 16},
  [10199] = {.lex_state = 128},
  [10200] = {.lex_state = 580, .external_lex_state = 24},
  [10201] = {.lex_state = 580, .external_lex_state = 24},
  [10202] = {.lex_state = 192, .external_lex_state = 2},
  [10203] = {.lex_state = 471, .external_lex_state = 3},
  [10204] = {.lex_state = 471, .external_lex_state = 3},
  [10205] = {.lex_state = 192, .external_lex_state = 2},
  [10206] = {.lex_state = 192, .external_lex_state = 28},
  [10207] = {.lex_state = 471, .external_lex_state = 3},
  [10208] = {.lex_state = 595, .external_lex_state = 3},
  [10209] = {.lex_state = 595, .external_lex_state = 3},
  [10210] = {.lex_state = 192, .external_lex_state = 2},
  [10211] = {.lex_state = 192, .external_lex_state = 28},
  [10212] = {.lex_state = 443, .external_lex_state = 3},
  [10213] = {.lex_state = 580, .external_lex_state = 3},
  [10214] = {.lex_state = 580, .external_lex_state = 3},
  [10215] = {.lex_state = 192, .external_lex_state = 2},
  [10216] = {.lex_state = 192, .external_lex_state = 2},
  [10217] = {.lex_state = 192, .external_lex_state = 28},
  [10218] = {.lex_state = 471, .external_lex_state = 24},
  [10219] = {.lex_state = 595, .external_lex_state = 24},
  [10220] = {.lex_state = 595, .external_lex_state = 24},
  [10221] = {.lex_state = 192, .external_lex_state = 2},
  [10222] = {.lex_state = 192, .external_lex_state = 28},
  [10223] = {.lex_state = 443, .external_lex_state = 24},
  [10224] = {.lex_state = 465, .external_lex_state = 24},
  [10225] = {.lex_state = 128},
  [10226] = {.lex_state = 580, .external_lex_state = 24},
  [10227] = {.lex_state = 580, .external_lex_state = 24},
  [10228] = {.lex_state = 290, .external_lex_state = 16},
  [10229] = {.lex_state = 290, .external_lex_state = 16},
  [10230] = {.lex_state = 399, .external_lex_state = 24},
  [10231] = {.lex_state = 399, .external_lex_state = 24},
  [10232] = {.lex_state = 399, .external_lex_state = 24},
  [10233] = {.lex_state = 399, .external_lex_state = 24},
  [10234] = {.lex_state = 301, .external_lex_state = 16},
  [10235] = {.lex_state = 399, .external_lex_state = 24},
  [10236] = {.lex_state = 128},
  [10237] = {.lex_state = 399, .external_lex_state = 24},
  [10238] = {.lex_state = 304, .external_lex_state = 16},
  [10239] = {.lex_state = 192, .external_lex_state = 2},
  [10240] = {.lex_state = 192, .external_lex_state = 28},
  [10241] = {.lex_state = 497, .external_lex_state = 24},
  [10242] = {.lex_state = 497, .external_lex_state = 24},
  [10243] = {.lex_state = 497, .external_lex_state = 24},
  [10244] = {.lex_state = 192, .external_lex_state = 2},
  [10245] = {.lex_state = 192, .external_lex_state = 28},
  [10246] = {.lex_state = 323, .external_lex_state = 24},
  [10247] = {.lex_state = 501, .external_lex_state = 24},
  [10248] = {.lex_state = 501, .external_lex_state = 24},
  [10249] = {.lex_state = 192, .external_lex_state = 2},
  [10250] = {.lex_state = 685, .external_lex_state = 13},
  [10251] = {.lex_state = 685, .external_lex_state = 13},
  [10252] = {.lex_state = 128},
  [10253] = {.lex_state = 128, .external_lex_state = 2},
  [10254] = {.lex_state = 256, .external_lex_state = 13},
  [10255] = {.lex_state = 628, .external_lex_state = 24},
  [10256] = {.lex_state = 628, .external_lex_state = 24},
  [10257] = {.lex_state = 628, .external_lex_state = 24},
  [10258] = {.lex_state = 528, .external_lex_state = 12},
  [10259] = {.lex_state = 628, .external_lex_state = 24},
  [10260] = {.lex_state = 628, .external_lex_state = 24},
  [10261] = {.lex_state = 192, .external_lex_state = 2},
  [10262] = {.lex_state = 192, .external_lex_state = 28},
  [10263] = {.lex_state = 628, .external_lex_state = 24},
  [10264] = {.lex_state = 611, .external_lex_state = 24},
  [10265] = {.lex_state = 611, .external_lex_state = 24},
  [10266] = {.lex_state = 497, .external_lex_state = 3},
  [10267] = {.lex_state = 497, .external_lex_state = 3},
  [10268] = {.lex_state = 323, .external_lex_state = 3},
  [10269] = {.lex_state = 323, .external_lex_state = 3},
  [10270] = {.lex_state = 304, .external_lex_state = 3},
  [10271] = {.lex_state = 363, .external_lex_state = 24},
  [10272] = {.lex_state = 426, .external_lex_state = 24},
  [10273] = {.lex_state = 426, .external_lex_state = 24},
  [10274] = {.lex_state = 426, .external_lex_state = 24},
  [10275] = {.lex_state = 426, .external_lex_state = 24},
  [10276] = {.lex_state = 426, .external_lex_state = 24},
  [10277] = {.lex_state = 561, .external_lex_state = 16},
  [10278] = {.lex_state = 426, .external_lex_state = 24},
  [10279] = {.lex_state = 426, .external_lex_state = 24},
  [10280] = {.lex_state = 426, .external_lex_state = 24},
  [10281] = {.lex_state = 426, .external_lex_state = 24},
  [10282] = {.lex_state = 426, .external_lex_state = 24},
  [10283] = {.lex_state = 426, .external_lex_state = 24},
  [10284] = {.lex_state = 426, .external_lex_state = 24},
  [10285] = {.lex_state = 426, .external_lex_state = 26},
  [10286] = {.lex_state = 363, .external_lex_state = 24},
  [10287] = {.lex_state = 332},
  [10288] = {.lex_state = 339},
  [10289] = {.lex_state = 628, .external_lex_state = 24},
  [10290] = {.lex_state = 177, .external_lex_state = 4},
  [10291] = {.lex_state = 628, .external_lex_state = 24},
  [10292] = {.lex_state = 628, .external_lex_state = 24},
  [10293] = {.lex_state = 177, .external_lex_state = 4},
  [10294] = {.lex_state = 628, .external_lex_state = 24},
  [10295] = {.lex_state = 227, .external_lex_state = 7},
  [10296] = {.lex_state = 628, .external_lex_state = 24},
  [10297] = {.lex_state = 628, .external_lex_state = 24},
  [10298] = {.lex_state = 628, .external_lex_state = 24},
  [10299] = {.lex_state = 628, .external_lex_state = 24},
  [10300] = {.lex_state = 628, .external_lex_state = 24},
  [10301] = {.lex_state = 628, .external_lex_state = 24},
  [10302] = {.lex_state = 628, .external_lex_state = 24},
  [10303] = {.lex_state = 628, .external_lex_state = 24},
  [10304] = {.lex_state = 628, .external_lex_state = 24},
  [10305] = {.lex_state = 128},
  [10306] = {.lex_state = 628, .external_lex_state = 24},
  [10307] = {.lex_state = 128},
  [10308] = {.lex_state = 128},
  [10309] = {.lex_state = 628, .external_lex_state = 24},
  [10310] = {.lex_state = 128},
  [10311] = {.lex_state = 628, .external_lex_state = 24},
  [10312] = {.lex_state = 628, .external_lex_state = 24},
  [10313] = {.lex_state = 128},
  [10314] = {.lex_state = 128, .external_lex_state = 2},
  [10315] = {.lex_state = 634, .external_lex_state = 24},
  [10316] = {.lex_state = 628, .external_lex_state = 24},
  [10317] = {.lex_state = 634, .external_lex_state = 24},
  [10318] = {.lex_state = 512, .external_lex_state = 24},
  [10319] = {.lex_state = 512, .external_lex_state = 24},
  [10320] = {.lex_state = 304, .external_lex_state = 24},
  [10321] = {.lex_state = 304, .external_lex_state = 24},
  [10322] = {.lex_state = 301, .external_lex_state = 3},
  [10323] = {.lex_state = 363, .external_lex_state = 3},
  [10324] = {.lex_state = 363, .external_lex_state = 3},
  [10325] = {.lex_state = 363, .external_lex_state = 3},
  [10326] = {.lex_state = 363, .external_lex_state = 3},
  [10327] = {.lex_state = 363, .external_lex_state = 3},
  [10328] = {.lex_state = 363, .external_lex_state = 3},
  [10329] = {.lex_state = 363, .external_lex_state = 3},
  [10330] = {.lex_state = 363, .external_lex_state = 3},
  [10331] = {.lex_state = 363, .external_lex_state = 3},
  [10332] = {.lex_state = 561, .external_lex_state = 16},
  [10333] = {.lex_state = 363, .external_lex_state = 3},
  [10334] = {.lex_state = 363, .external_lex_state = 3},
  [10335] = {.lex_state = 363, .external_lex_state = 3},
  [10336] = {.lex_state = 363, .external_lex_state = 3},
  [10337] = {.lex_state = 363, .external_lex_state = 3},
  [10338] = {.lex_state = 363, .external_lex_state = 3},
  [10339] = {.lex_state = 363, .external_lex_state = 3},
  [10340] = {.lex_state = 367, .external_lex_state = 14},
  [10341] = {.lex_state = 363, .external_lex_state = 3},
  [10342] = {.lex_state = 363, .external_lex_state = 3},
  [10343] = {.lex_state = 363, .external_lex_state = 3},
  [10344] = {.lex_state = 528, .external_lex_state = 12},
  [10345] = {.lex_state = 363, .external_lex_state = 3},
  [10346] = {.lex_state = 363, .external_lex_state = 3},
  [10347] = {.lex_state = 192, .external_lex_state = 2},
  [10348] = {.lex_state = 423, .external_lex_state = 3},
  [10349] = {.lex_state = 423, .external_lex_state = 3},
  [10350] = {.lex_state = 423, .external_lex_state = 3},
  [10351] = {.lex_state = 528, .external_lex_state = 12},
  [10352] = {.lex_state = 423, .external_lex_state = 3},
  [10353] = {.lex_state = 423, .external_lex_state = 3},
  [10354] = {.lex_state = 192, .external_lex_state = 28},
  [10355] = {.lex_state = 363, .external_lex_state = 3},
  [10356] = {.lex_state = 249, .external_lex_state = 3},
  [10357] = {.lex_state = 426, .external_lex_state = 3},
  [10358] = {.lex_state = 426, .external_lex_state = 3},
  [10359] = {.lex_state = 426, .external_lex_state = 3},
  [10360] = {.lex_state = 426, .external_lex_state = 3},
  [10361] = {.lex_state = 426, .external_lex_state = 3},
  [10362] = {.lex_state = 561, .external_lex_state = 16},
  [10363] = {.lex_state = 426, .external_lex_state = 3},
  [10364] = {.lex_state = 426, .external_lex_state = 3},
  [10365] = {.lex_state = 426, .external_lex_state = 3},
  [10366] = {.lex_state = 426, .external_lex_state = 3},
  [10367] = {.lex_state = 426, .external_lex_state = 3},
  [10368] = {.lex_state = 426, .external_lex_state = 3},
  [10369] = {.lex_state = 426, .external_lex_state = 3},
  [10370] = {.lex_state = 426, .external_lex_state = 14},
  [10371] = {.lex_state = 192, .external_lex_state = 2},
  [10372] = {.lex_state = 192, .external_lex_state = 28},
  [10373] = {.lex_state = 423, .external_lex_state = 3},
  [10374] = {.lex_state = 532, .external_lex_state = 3},
  [10375] = {.lex_state = 532, .external_lex_state = 3},
  [10376] = {.lex_state = 532, .external_lex_state = 3},
  [10377] = {.lex_state = 532, .external_lex_state = 3},
  [10378] = {.lex_state = 532, .external_lex_state = 3},
  [10379] = {.lex_state = 561, .external_lex_state = 16},
  [10380] = {.lex_state = 532, .external_lex_state = 3},
  [10381] = {.lex_state = 532, .external_lex_state = 3},
  [10382] = {.lex_state = 532, .external_lex_state = 3},
  [10383] = {.lex_state = 532, .external_lex_state = 3},
  [10384] = {.lex_state = 532, .external_lex_state = 3},
  [10385] = {.lex_state = 532, .external_lex_state = 3},
  [10386] = {.lex_state = 532, .external_lex_state = 3},
  [10387] = {.lex_state = 426, .external_lex_state = 3},
  [10388] = {.lex_state = 426, .external_lex_state = 3},
  [10389] = {.lex_state = 532, .external_lex_state = 3},
  [10390] = {.lex_state = 363, .external_lex_state = 3},
  [10391] = {.lex_state = 363, .external_lex_state = 3},
  [10392] = {.lex_state = 363, .external_lex_state = 3},
  [10393] = {.lex_state = 363, .external_lex_state = 3},
  [10394] = {.lex_state = 363, .external_lex_state = 3},
  [10395] = {.lex_state = 363, .external_lex_state = 3},
  [10396] = {.lex_state = 363, .external_lex_state = 3},
  [10397] = {.lex_state = 561, .external_lex_state = 16},
  [10398] = {.lex_state = 363, .external_lex_state = 3},
  [10399] = {.lex_state = 363, .external_lex_state = 3},
  [10400] = {.lex_state = 363, .external_lex_state = 3},
  [10401] = {.lex_state = 363, .external_lex_state = 3},
  [10402] = {.lex_state = 363, .external_lex_state = 3},
  [10403] = {.lex_state = 363, .external_lex_state = 3},
  [10404] = {.lex_state = 363, .external_lex_state = 3},
  [10405] = {.lex_state = 367, .external_lex_state = 14},
  [10406] = {.lex_state = 363, .external_lex_state = 3},
  [10407] = {.lex_state = 363, .external_lex_state = 3},
  [10408] = {.lex_state = 363, .external_lex_state = 3},
  [10409] = {.lex_state = 528, .external_lex_state = 12},
  [10410] = {.lex_state = 363, .external_lex_state = 3},
  [10411] = {.lex_state = 363, .external_lex_state = 3},
  [10412] = {.lex_state = 192, .external_lex_state = 2},
  [10413] = {.lex_state = 423, .external_lex_state = 3},
  [10414] = {.lex_state = 423, .external_lex_state = 3},
  [10415] = {.lex_state = 423, .external_lex_state = 3},
  [10416] = {.lex_state = 528, .external_lex_state = 12},
  [10417] = {.lex_state = 423, .external_lex_state = 3},
  [10418] = {.lex_state = 423, .external_lex_state = 3},
  [10419] = {.lex_state = 192, .external_lex_state = 28},
  [10420] = {.lex_state = 363, .external_lex_state = 3},
  [10421] = {.lex_state = 249, .external_lex_state = 3},
  [10422] = {.lex_state = 426, .external_lex_state = 3},
  [10423] = {.lex_state = 426, .external_lex_state = 3},
  [10424] = {.lex_state = 426, .external_lex_state = 3},
  [10425] = {.lex_state = 426, .external_lex_state = 3},
  [10426] = {.lex_state = 426, .external_lex_state = 3},
  [10427] = {.lex_state = 561, .external_lex_state = 16},
  [10428] = {.lex_state = 426, .external_lex_state = 3},
  [10429] = {.lex_state = 426, .external_lex_state = 3},
  [10430] = {.lex_state = 426, .external_lex_state = 3},
  [10431] = {.lex_state = 426, .external_lex_state = 3},
  [10432] = {.lex_state = 426, .external_lex_state = 3},
  [10433] = {.lex_state = 426, .external_lex_state = 3},
  [10434] = {.lex_state = 426, .external_lex_state = 3},
  [10435] = {.lex_state = 426, .external_lex_state = 14},
  [10436] = {.lex_state = 192, .external_lex_state = 2},
  [10437] = {.lex_state = 192, .external_lex_state = 28},
  [10438] = {.lex_state = 423, .external_lex_state = 3},
  [10439] = {.lex_state = 532, .external_lex_state = 3},
  [10440] = {.lex_state = 532, .external_lex_state = 3},
  [10441] = {.lex_state = 532, .external_lex_state = 3},
  [10442] = {.lex_state = 532, .external_lex_state = 3},
  [10443] = {.lex_state = 532, .external_lex_state = 3},
  [10444] = {.lex_state = 561, .external_lex_state = 16},
  [10445] = {.lex_state = 532, .external_lex_state = 3},
  [10446] = {.lex_state = 532, .external_lex_state = 3},
  [10447] = {.lex_state = 532, .external_lex_state = 3},
  [10448] = {.lex_state = 532, .external_lex_state = 3},
  [10449] = {.lex_state = 532, .external_lex_state = 3},
  [10450] = {.lex_state = 532, .external_lex_state = 3},
  [10451] = {.lex_state = 532, .external_lex_state = 3},
  [10452] = {.lex_state = 363, .external_lex_state = 3},
  [10453] = {.lex_state = 363, .external_lex_state = 3},
  [10454] = {.lex_state = 426, .external_lex_state = 3},
  [10455] = {.lex_state = 426, .external_lex_state = 3},
  [10456] = {.lex_state = 532, .external_lex_state = 3},
  [10457] = {.lex_state = 512, .external_lex_state = 24},
  [10458] = {.lex_state = 426, .external_lex_state = 24},
  [10459] = {.lex_state = 426, .external_lex_state = 24},
  [10460] = {.lex_state = 426, .external_lex_state = 24},
  [10461] = {.lex_state = 426, .external_lex_state = 24},
  [10462] = {.lex_state = 426, .external_lex_state = 24},
  [10463] = {.lex_state = 561, .external_lex_state = 16},
  [10464] = {.lex_state = 426, .external_lex_state = 24},
  [10465] = {.lex_state = 426, .external_lex_state = 24},
  [10466] = {.lex_state = 426, .external_lex_state = 24},
  [10467] = {.lex_state = 426, .external_lex_state = 24},
  [10468] = {.lex_state = 426, .external_lex_state = 24},
  [10469] = {.lex_state = 426, .external_lex_state = 24},
  [10470] = {.lex_state = 426, .external_lex_state = 24},
  [10471] = {.lex_state = 426, .external_lex_state = 26},
  [10472] = {.lex_state = 512, .external_lex_state = 24},
  [10473] = {.lex_state = 423, .external_lex_state = 24},
  [10474] = {.lex_state = 423, .external_lex_state = 24},
  [10475] = {.lex_state = 363, .external_lex_state = 3},
  [10476] = {.lex_state = 363, .external_lex_state = 3},
  [10477] = {.lex_state = 532, .external_lex_state = 3},
  [10478] = {.lex_state = 363, .external_lex_state = 3},
  [10479] = {.lex_state = 363, .external_lex_state = 3},
  [10480] = {.lex_state = 363, .external_lex_state = 3},
  [10481] = {.lex_state = 363, .external_lex_state = 3},
  [10482] = {.lex_state = 363, .external_lex_state = 3},
  [10483] = {.lex_state = 561, .external_lex_state = 16},
  [10484] = {.lex_state = 363, .external_lex_state = 3},
  [10485] = {.lex_state = 363, .external_lex_state = 3},
  [10486] = {.lex_state = 363, .external_lex_state = 3},
  [10487] = {.lex_state = 363, .external_lex_state = 3},
  [10488] = {.lex_state = 363, .external_lex_state = 3},
  [10489] = {.lex_state = 363, .external_lex_state = 3},
  [10490] = {.lex_state = 363, .external_lex_state = 3},
  [10491] = {.lex_state = 192, .external_lex_state = 2},
  [10492] = {.lex_state = 515, .external_lex_state = 10},
  [10493] = {.lex_state = 515, .external_lex_state = 10},
  [10494] = {.lex_state = 515, .external_lex_state = 10},
  [10495] = {.lex_state = 515, .external_lex_state = 10},
  [10496] = {.lex_state = 192, .external_lex_state = 2},
  [10497] = {.lex_state = 192, .external_lex_state = 2},
  [10498] = {.lex_state = 363, .external_lex_state = 3},
  [10499] = {.lex_state = 213},
  [10500] = {.lex_state = 261, .external_lex_state = 3},
  [10501] = {.lex_state = 367, .external_lex_state = 14},
  [10502] = {.lex_state = 363, .external_lex_state = 3},
  [10503] = {.lex_state = 363, .external_lex_state = 3},
  [10504] = {.lex_state = 363, .external_lex_state = 14},
  [10505] = {.lex_state = 192, .external_lex_state = 2},
  [10506] = {.lex_state = 363, .external_lex_state = 3},
  [10507] = {.lex_state = 192, .external_lex_state = 2},
  [10508] = {.lex_state = 192, .external_lex_state = 2},
  [10509] = {.lex_state = 239},
  [10510] = {.lex_state = 192, .external_lex_state = 2},
  [10511] = {.lex_state = 360, .external_lex_state = 10},
  [10512] = {.lex_state = 363, .external_lex_state = 3},
  [10513] = {.lex_state = 363, .external_lex_state = 3},
  [10514] = {.lex_state = 363, .external_lex_state = 3},
  [10515] = {.lex_state = 373, .external_lex_state = 14},
  [10516] = {.lex_state = 363, .external_lex_state = 3},
  [10517] = {.lex_state = 192, .external_lex_state = 2},
  [10518] = {.lex_state = 192, .external_lex_state = 2},
  [10519] = {.lex_state = 192, .external_lex_state = 2},
  [10520] = {.lex_state = 192, .external_lex_state = 2},
  [10521] = {.lex_state = 192, .external_lex_state = 2},
  [10522] = {.lex_state = 192, .external_lex_state = 2},
  [10523] = {.lex_state = 192, .external_lex_state = 2},
  [10524] = {.lex_state = 192, .external_lex_state = 2},
  [10525] = {.lex_state = 192, .external_lex_state = 2},
  [10526] = {.lex_state = 192, .external_lex_state = 2},
  [10527] = {.lex_state = 192, .external_lex_state = 2},
  [10528] = {.lex_state = 192, .external_lex_state = 2},
  [10529] = {.lex_state = 192, .external_lex_state = 2},
  [10530] = {.lex_state = 239},
  [10531] = {.lex_state = 192, .external_lex_state = 2},
  [10532] = {.lex_state = 360, .external_lex_state = 10},
  [10533] = {.lex_state = 423, .external_lex_state = 3},
  [10534] = {.lex_state = 423, .external_lex_state = 3},
  [10535] = {.lex_state = 423, .external_lex_state = 3},
  [10536] = {.lex_state = 429, .external_lex_state = 14},
  [10537] = {.lex_state = 264, .external_lex_state = 3},
  [10538] = {.lex_state = 528, .external_lex_state = 29},
  [10539] = {.lex_state = 363, .external_lex_state = 3},
  [10540] = {.lex_state = 192, .external_lex_state = 28},
  [10541] = {.lex_state = 192, .external_lex_state = 2},
  [10542] = {.lex_state = 363, .external_lex_state = 14},
  [10543] = {.lex_state = 256, .external_lex_state = 13},
  [10544] = {.lex_state = 249, .external_lex_state = 3},
  [10545] = {.lex_state = 249, .external_lex_state = 3},
  [10546] = {.lex_state = 249, .external_lex_state = 3},
  [10547] = {.lex_state = 249, .external_lex_state = 3},
  [10548] = {.lex_state = 249, .external_lex_state = 3},
  [10549] = {.lex_state = 249, .external_lex_state = 3},
  [10550] = {.lex_state = 249, .external_lex_state = 3},
  [10551] = {.lex_state = 249, .external_lex_state = 3},
  [10552] = {.lex_state = 249, .external_lex_state = 3},
  [10553] = {.lex_state = 249, .external_lex_state = 3},
  [10554] = {.lex_state = 561, .external_lex_state = 16},
  [10555] = {.lex_state = 249, .external_lex_state = 3},
  [10556] = {.lex_state = 249, .external_lex_state = 3},
  [10557] = {.lex_state = 249, .external_lex_state = 3},
  [10558] = {.lex_state = 249, .external_lex_state = 3},
  [10559] = {.lex_state = 192, .external_lex_state = 2},
  [10560] = {.lex_state = 256, .external_lex_state = 10},
  [10561] = {.lex_state = 256, .external_lex_state = 10},
  [10562] = {.lex_state = 256, .external_lex_state = 10},
  [10563] = {.lex_state = 256, .external_lex_state = 10},
  [10564] = {.lex_state = 192, .external_lex_state = 2},
  [10565] = {.lex_state = 192, .external_lex_state = 2},
  [10566] = {.lex_state = 426, .external_lex_state = 3},
  [10567] = {.lex_state = 256, .external_lex_state = 10},
  [10568] = {.lex_state = 213},
  [10569] = {.lex_state = 426, .external_lex_state = 3},
  [10570] = {.lex_state = 426, .external_lex_state = 14},
  [10571] = {.lex_state = 426, .external_lex_state = 3},
  [10572] = {.lex_state = 423, .external_lex_state = 3},
  [10573] = {.lex_state = 423, .external_lex_state = 14},
  [10574] = {.lex_state = 192, .external_lex_state = 2},
  [10575] = {.lex_state = 426, .external_lex_state = 3},
  [10576] = {.lex_state = 423, .external_lex_state = 3},
  [10577] = {.lex_state = 192, .external_lex_state = 2},
  [10578] = {.lex_state = 192, .external_lex_state = 2},
  [10579] = {.lex_state = 192, .external_lex_state = 2},
  [10580] = {.lex_state = 192, .external_lex_state = 2},
  [10581] = {.lex_state = 192, .external_lex_state = 2},
  [10582] = {.lex_state = 192, .external_lex_state = 2},
  [10583] = {.lex_state = 192, .external_lex_state = 2},
  [10584] = {.lex_state = 192, .external_lex_state = 2},
  [10585] = {.lex_state = 192, .external_lex_state = 2},
  [10586] = {.lex_state = 192, .external_lex_state = 2},
  [10587] = {.lex_state = 192, .external_lex_state = 2},
  [10588] = {.lex_state = 426, .external_lex_state = 3},
  [10589] = {.lex_state = 528, .external_lex_state = 29},
  [10590] = {.lex_state = 426, .external_lex_state = 3},
  [10591] = {.lex_state = 192, .external_lex_state = 28},
  [10592] = {.lex_state = 192, .external_lex_state = 2},
  [10593] = {.lex_state = 423, .external_lex_state = 14},
  [10594] = {.lex_state = 192, .external_lex_state = 2},
  [10595] = {.lex_state = 192, .external_lex_state = 2},
  [10596] = {.lex_state = 192, .external_lex_state = 2},
  [10597] = {.lex_state = 192, .external_lex_state = 2},
  [10598] = {.lex_state = 532, .external_lex_state = 3},
  [10599] = {.lex_state = 532, .external_lex_state = 3},
  [10600] = {.lex_state = 213},
  [10601] = {.lex_state = 261, .external_lex_state = 3},
  [10602] = {.lex_state = 249, .external_lex_state = 3},
  [10603] = {.lex_state = 264, .external_lex_state = 14},
  [10604] = {.lex_state = 532, .external_lex_state = 3},
  [10605] = {.lex_state = 426, .external_lex_state = 3},
  [10606] = {.lex_state = 426, .external_lex_state = 3},
  [10607] = {.lex_state = 426, .external_lex_state = 3},
  [10608] = {.lex_state = 426, .external_lex_state = 3},
  [10609] = {.lex_state = 426, .external_lex_state = 3},
  [10610] = {.lex_state = 561, .external_lex_state = 16},
  [10611] = {.lex_state = 426, .external_lex_state = 3},
  [10612] = {.lex_state = 426, .external_lex_state = 3},
  [10613] = {.lex_state = 426, .external_lex_state = 3},
  [10614] = {.lex_state = 426, .external_lex_state = 3},
  [10615] = {.lex_state = 426, .external_lex_state = 3},
  [10616] = {.lex_state = 426, .external_lex_state = 3},
  [10617] = {.lex_state = 426, .external_lex_state = 3},
  [10618] = {.lex_state = 426, .external_lex_state = 14},
  [10619] = {.lex_state = 532, .external_lex_state = 3},
  [10620] = {.lex_state = 363, .external_lex_state = 3},
  [10621] = {.lex_state = 363, .external_lex_state = 3},
  [10622] = {.lex_state = 363, .external_lex_state = 3},
  [10623] = {.lex_state = 363, .external_lex_state = 3},
  [10624] = {.lex_state = 352, .external_lex_state = 22},
  [10625] = {.lex_state = 512, .external_lex_state = 3},
  [10626] = {.lex_state = 512, .external_lex_state = 3},
  [10627] = {.lex_state = 192, .external_lex_state = 2},
  [10628] = {.lex_state = 512, .external_lex_state = 3},
  [10629] = {.lex_state = 192, .external_lex_state = 2},
  [10630] = {.lex_state = 512, .external_lex_state = 3},
  [10631] = {.lex_state = 528, .external_lex_state = 29},
  [10632] = {.lex_state = 512, .external_lex_state = 3},
  [10633] = {.lex_state = 512, .external_lex_state = 3},
  [10634] = {.lex_state = 512, .external_lex_state = 3},
  [10635] = {.lex_state = 512, .external_lex_state = 3},
  [10636] = {.lex_state = 512, .external_lex_state = 3},
  [10637] = {.lex_state = 512, .external_lex_state = 3},
  [10638] = {.lex_state = 561, .external_lex_state = 16},
  [10639] = {.lex_state = 512, .external_lex_state = 3},
  [10640] = {.lex_state = 512, .external_lex_state = 3},
  [10641] = {.lex_state = 512, .external_lex_state = 3},
  [10642] = {.lex_state = 512, .external_lex_state = 3},
  [10643] = {.lex_state = 512, .external_lex_state = 3},
  [10644] = {.lex_state = 512, .external_lex_state = 3},
  [10645] = {.lex_state = 512, .external_lex_state = 3},
  [10646] = {.lex_state = 638, .external_lex_state = 14},
  [10647] = {.lex_state = 512, .external_lex_state = 3},
  [10648] = {.lex_state = 512, .external_lex_state = 3},
  [10649] = {.lex_state = 512, .external_lex_state = 3},
  [10650] = {.lex_state = 528, .external_lex_state = 12},
  [10651] = {.lex_state = 512, .external_lex_state = 3},
  [10652] = {.lex_state = 512, .external_lex_state = 3},
  [10653] = {.lex_state = 192, .external_lex_state = 2},
  [10654] = {.lex_state = 345, .external_lex_state = 13},
  [10655] = {.lex_state = 685, .external_lex_state = 13},
  [10656] = {.lex_state = 192, .external_lex_state = 28},
  [10657] = {.lex_state = 512, .external_lex_state = 3},
  [10658] = {.lex_state = 423, .external_lex_state = 3},
  [10659] = {.lex_state = 423, .external_lex_state = 3},
  [10660] = {.lex_state = 363, .external_lex_state = 3},
  [10661] = {.lex_state = 363, .external_lex_state = 3},
  [10662] = {.lex_state = 192, .external_lex_state = 2},
  [10663] = {.lex_state = 192, .external_lex_state = 28},
  [10664] = {.lex_state = 363, .external_lex_state = 3},
  [10665] = {.lex_state = 363, .external_lex_state = 3},
  [10666] = {.lex_state = 363, .external_lex_state = 3},
  [10667] = {.lex_state = 192, .external_lex_state = 2},
  [10668] = {.lex_state = 192, .external_lex_state = 28},
  [10669] = {.lex_state = 426, .external_lex_state = 3},
  [10670] = {.lex_state = 423, .external_lex_state = 3},
  [10671] = {.lex_state = 423, .external_lex_state = 3},
  [10672] = {.lex_state = 192, .external_lex_state = 2},
  [10673] = {.lex_state = 363, .external_lex_state = 3},
  [10674] = {.lex_state = 363, .external_lex_state = 3},
  [10675] = {.lex_state = 192, .external_lex_state = 2},
  [10676] = {.lex_state = 192, .external_lex_state = 28},
  [10677] = {.lex_state = 363, .external_lex_state = 3},
  [10678] = {.lex_state = 363, .external_lex_state = 3},
  [10679] = {.lex_state = 363, .external_lex_state = 3},
  [10680] = {.lex_state = 192, .external_lex_state = 2},
  [10681] = {.lex_state = 192, .external_lex_state = 28},
  [10682] = {.lex_state = 426, .external_lex_state = 3},
  [10683] = {.lex_state = 423, .external_lex_state = 3},
  [10684] = {.lex_state = 423, .external_lex_state = 3},
  [10685] = {.lex_state = 192, .external_lex_state = 2},
  [10686] = {.lex_state = 426, .external_lex_state = 3},
  [10687] = {.lex_state = 426, .external_lex_state = 3},
  [10688] = {.lex_state = 532, .external_lex_state = 3},
  [10689] = {.lex_state = 192, .external_lex_state = 2},
  [10690] = {.lex_state = 192, .external_lex_state = 28},
  [10691] = {.lex_state = 408, .external_lex_state = 24},
  [10692] = {.lex_state = 192, .external_lex_state = 2},
  [10693] = {.lex_state = 192, .external_lex_state = 28},
  [10694] = {.lex_state = 541, .external_lex_state = 24},
  [10695] = {.lex_state = 390, .external_lex_state = 24},
  [10696] = {.lex_state = 390, .external_lex_state = 24},
  [10697] = {.lex_state = 399, .external_lex_state = 24},
  [10698] = {.lex_state = 288, .external_lex_state = 2},
  [10699] = {.lex_state = 192, .external_lex_state = 2},
  [10700] = {.lex_state = 515, .external_lex_state = 25},
  [10701] = {.lex_state = 515, .external_lex_state = 25},
  [10702] = {.lex_state = 515, .external_lex_state = 25},
  [10703] = {.lex_state = 515, .external_lex_state = 25},
  [10704] = {.lex_state = 192, .external_lex_state = 2},
  [10705] = {.lex_state = 192, .external_lex_state = 2},
  [10706] = {.lex_state = 363, .external_lex_state = 24},
  [10707] = {.lex_state = 256, .external_lex_state = 25},
  [10708] = {.lex_state = 213},
  [10709] = {.lex_state = 261, .external_lex_state = 24},
  [10710] = {.lex_state = 367, .external_lex_state = 26},
  [10711] = {.lex_state = 363, .external_lex_state = 24},
  [10712] = {.lex_state = 363, .external_lex_state = 24},
  [10713] = {.lex_state = 363, .external_lex_state = 26},
  [10714] = {.lex_state = 192, .external_lex_state = 2},
  [10715] = {.lex_state = 363, .external_lex_state = 24},
  [10716] = {.lex_state = 192, .external_lex_state = 2},
  [10717] = {.lex_state = 192, .external_lex_state = 2},
  [10718] = {.lex_state = 239},
  [10719] = {.lex_state = 192, .external_lex_state = 2},
  [10720] = {.lex_state = 360, .external_lex_state = 25},
  [10721] = {.lex_state = 363, .external_lex_state = 24},
  [10722] = {.lex_state = 363, .external_lex_state = 24},
  [10723] = {.lex_state = 363, .external_lex_state = 24},
  [10724] = {.lex_state = 373, .external_lex_state = 26},
  [10725] = {.lex_state = 363, .external_lex_state = 24},
  [10726] = {.lex_state = 192, .external_lex_state = 2},
  [10727] = {.lex_state = 192, .external_lex_state = 2},
  [10728] = {.lex_state = 192, .external_lex_state = 2},
  [10729] = {.lex_state = 192, .external_lex_state = 2},
  [10730] = {.lex_state = 192, .external_lex_state = 2},
  [10731] = {.lex_state = 192, .external_lex_state = 2},
  [10732] = {.lex_state = 192, .external_lex_state = 2},
  [10733] = {.lex_state = 192, .external_lex_state = 2},
  [10734] = {.lex_state = 192, .external_lex_state = 2},
  [10735] = {.lex_state = 192, .external_lex_state = 2},
  [10736] = {.lex_state = 192, .external_lex_state = 2},
  [10737] = {.lex_state = 192, .external_lex_state = 2},
  [10738] = {.lex_state = 192, .external_lex_state = 2},
  [10739] = {.lex_state = 239},
  [10740] = {.lex_state = 192, .external_lex_state = 2},
  [10741] = {.lex_state = 360, .external_lex_state = 25},
  [10742] = {.lex_state = 423, .external_lex_state = 24},
  [10743] = {.lex_state = 423, .external_lex_state = 24},
  [10744] = {.lex_state = 423, .external_lex_state = 24},
  [10745] = {.lex_state = 429, .external_lex_state = 26},
  [10746] = {.lex_state = 363, .external_lex_state = 24},
  [10747] = {.lex_state = 528, .external_lex_state = 29},
  [10748] = {.lex_state = 363, .external_lex_state = 24},
  [10749] = {.lex_state = 192, .external_lex_state = 28},
  [10750] = {.lex_state = 192, .external_lex_state = 2},
  [10751] = {.lex_state = 363, .external_lex_state = 26},
  [10752] = {.lex_state = 304, .external_lex_state = 16},
  [10753] = {.lex_state = 304, .external_lex_state = 16},
  [10754] = {.lex_state = 304, .external_lex_state = 16},
  [10755] = {.lex_state = 304, .external_lex_state = 16},
  [10756] = {.lex_state = 304, .external_lex_state = 16},
  [10757] = {.lex_state = 561, .external_lex_state = 16},
  [10758] = {.lex_state = 304, .external_lex_state = 16},
  [10759] = {.lex_state = 304, .external_lex_state = 16},
  [10760] = {.lex_state = 304, .external_lex_state = 16},
  [10761] = {.lex_state = 304, .external_lex_state = 16},
  [10762] = {.lex_state = 192, .external_lex_state = 2},
  [10763] = {.lex_state = 256, .external_lex_state = 25},
  [10764] = {.lex_state = 256, .external_lex_state = 25},
  [10765] = {.lex_state = 256, .external_lex_state = 25},
  [10766] = {.lex_state = 256, .external_lex_state = 25},
  [10767] = {.lex_state = 192, .external_lex_state = 2},
  [10768] = {.lex_state = 192, .external_lex_state = 2},
  [10769] = {.lex_state = 426, .external_lex_state = 24},
  [10770] = {.lex_state = 256, .external_lex_state = 25},
  [10771] = {.lex_state = 213},
  [10772] = {.lex_state = 426, .external_lex_state = 24},
  [10773] = {.lex_state = 426, .external_lex_state = 26},
  [10774] = {.lex_state = 426, .external_lex_state = 24},
  [10775] = {.lex_state = 423, .external_lex_state = 24},
  [10776] = {.lex_state = 423, .external_lex_state = 26},
  [10777] = {.lex_state = 192, .external_lex_state = 2},
  [10778] = {.lex_state = 426, .external_lex_state = 24},
  [10779] = {.lex_state = 423, .external_lex_state = 24},
  [10780] = {.lex_state = 192, .external_lex_state = 2},
  [10781] = {.lex_state = 192, .external_lex_state = 2},
  [10782] = {.lex_state = 192, .external_lex_state = 2},
  [10783] = {.lex_state = 192, .external_lex_state = 2},
  [10784] = {.lex_state = 192, .external_lex_state = 2},
  [10785] = {.lex_state = 192, .external_lex_state = 2},
  [10786] = {.lex_state = 192, .external_lex_state = 2},
  [10787] = {.lex_state = 192, .external_lex_state = 2},
  [10788] = {.lex_state = 192, .external_lex_state = 2},
  [10789] = {.lex_state = 192, .external_lex_state = 2},
  [10790] = {.lex_state = 192, .external_lex_state = 2},
  [10791] = {.lex_state = 426, .external_lex_state = 24},
  [10792] = {.lex_state = 528, .external_lex_state = 29},
  [10793] = {.lex_state = 426, .external_lex_state = 24},
  [10794] = {.lex_state = 192, .external_lex_state = 28},
  [10795] = {.lex_state = 192, .external_lex_state = 2},
  [10796] = {.lex_state = 423, .external_lex_state = 26},
  [10797] = {.lex_state = 192, .external_lex_state = 2},
  [10798] = {.lex_state = 304, .external_lex_state = 16},
  [10799] = {.lex_state = 304, .external_lex_state = 16},
  [10800] = {.lex_state = 304, .external_lex_state = 16},
  [10801] = {.lex_state = 253, .external_lex_state = 20},
  [10802] = {.lex_state = 239},
  [10803] = {.lex_state = 239},
  [10804] = {.lex_state = 128, .external_lex_state = 11},
  [10805] = {.lex_state = 239},
  [10806] = {.lex_state = 239},
  [10807] = {.lex_state = 304, .external_lex_state = 16},
  [10808] = {.lex_state = 304, .external_lex_state = 16},
  [10809] = {.lex_state = 650, .external_lex_state = 24},
  [10810] = {.lex_state = 650, .external_lex_state = 24},
  [10811] = {.lex_state = 192, .external_lex_state = 2},
  [10812] = {.lex_state = 192, .external_lex_state = 28},
  [10813] = {.lex_state = 650, .external_lex_state = 24},
  [10814] = {.lex_state = 659, .external_lex_state = 24},
  [10815] = {.lex_state = 659, .external_lex_state = 24},
  [10816] = {.lex_state = 192, .external_lex_state = 2},
  [10817] = {.lex_state = 192, .external_lex_state = 28},
  [10818] = {.lex_state = 566, .external_lex_state = 24},
  [10819] = {.lex_state = 663, .external_lex_state = 24},
  [10820] = {.lex_state = 663, .external_lex_state = 24},
  [10821] = {.lex_state = 192, .external_lex_state = 2},
  [10822] = {.lex_state = 229, .external_lex_state = 3},
  [10823] = {.lex_state = 229, .external_lex_state = 3},
  [10824] = {.lex_state = 229, .external_lex_state = 3},
  [10825] = {.lex_state = 229, .external_lex_state = 3},
  [10826] = {.lex_state = 229, .external_lex_state = 3},
  [10827] = {.lex_state = 128},
  [10828] = {.lex_state = 229, .external_lex_state = 3},
  [10829] = {.lex_state = 192, .external_lex_state = 2},
  [10830] = {.lex_state = 301, .external_lex_state = 3},
  [10831] = {.lex_state = 363, .external_lex_state = 3},
  [10832] = {.lex_state = 363, .external_lex_state = 3},
  [10833] = {.lex_state = 192, .external_lex_state = 2},
  [10834] = {.lex_state = 192, .external_lex_state = 28},
  [10835] = {.lex_state = 363, .external_lex_state = 3},
  [10836] = {.lex_state = 363, .external_lex_state = 3},
  [10837] = {.lex_state = 363, .external_lex_state = 3},
  [10838] = {.lex_state = 192, .external_lex_state = 2},
  [10839] = {.lex_state = 192, .external_lex_state = 28},
  [10840] = {.lex_state = 426, .external_lex_state = 3},
  [10841] = {.lex_state = 423, .external_lex_state = 3},
  [10842] = {.lex_state = 423, .external_lex_state = 3},
  [10843] = {.lex_state = 192, .external_lex_state = 2},
  [10844] = {.lex_state = 471, .external_lex_state = 24},
  [10845] = {.lex_state = 471, .external_lex_state = 24},
  [10846] = {.lex_state = 465, .external_lex_state = 24},
  [10847] = {.lex_state = 177, .external_lex_state = 4},
  [10848] = {.lex_state = 465, .external_lex_state = 24},
  [10849] = {.lex_state = 465, .external_lex_state = 24},
  [10850] = {.lex_state = 177, .external_lex_state = 4},
  [10851] = {.lex_state = 465, .external_lex_state = 24},
  [10852] = {.lex_state = 227, .external_lex_state = 7},
  [10853] = {.lex_state = 465, .external_lex_state = 24},
  [10854] = {.lex_state = 465, .external_lex_state = 24},
  [10855] = {.lex_state = 465, .external_lex_state = 24},
  [10856] = {.lex_state = 465, .external_lex_state = 24},
  [10857] = {.lex_state = 465, .external_lex_state = 24},
  [10858] = {.lex_state = 465, .external_lex_state = 24},
  [10859] = {.lex_state = 465, .external_lex_state = 24},
  [10860] = {.lex_state = 128},
  [10861] = {.lex_state = 465, .external_lex_state = 24},
  [10862] = {.lex_state = 128},
  [10863] = {.lex_state = 128},
  [10864] = {.lex_state = 465, .external_lex_state = 24},
  [10865] = {.lex_state = 128},
  [10866] = {.lex_state = 443, .external_lex_state = 24},
  [10867] = {.lex_state = 465, .external_lex_state = 24},
  [10868] = {.lex_state = 443, .external_lex_state = 24},
  [10869] = {.lex_state = 435, .external_lex_state = 16},
  [10870] = {.lex_state = 438, .external_lex_state = 16},
  [10871] = {.lex_state = 471, .external_lex_state = 3},
  [10872] = {.lex_state = 471, .external_lex_state = 3},
  [10873] = {.lex_state = 443, .external_lex_state = 3},
  [10874] = {.lex_state = 443, .external_lex_state = 3},
  [10875] = {.lex_state = 438, .external_lex_state = 3},
  [10876] = {.lex_state = 471, .external_lex_state = 24},
  [10877] = {.lex_state = 471, .external_lex_state = 24},
  [10878] = {.lex_state = 443, .external_lex_state = 24},
  [10879] = {.lex_state = 443, .external_lex_state = 24},
  [10880] = {.lex_state = 465, .external_lex_state = 24},
  [10881] = {.lex_state = 399, .external_lex_state = 24},
  [10882] = {.lex_state = 497, .external_lex_state = 24},
  [10883] = {.lex_state = 497, .external_lex_state = 24},
  [10884] = {.lex_state = 323, .external_lex_state = 24},
  [10885] = {.lex_state = 323, .external_lex_state = 24},
  [10886] = {.lex_state = 304, .external_lex_state = 16},
  [10887] = {.lex_state = 685, .external_lex_state = 13},
  [10888] = {.lex_state = 128},
  [10889] = {.lex_state = 628, .external_lex_state = 24},
  [10890] = {.lex_state = 628, .external_lex_state = 24},
  [10891] = {.lex_state = 192, .external_lex_state = 2},
  [10892] = {.lex_state = 192, .external_lex_state = 28},
  [10893] = {.lex_state = 426, .external_lex_state = 24},
  [10894] = {.lex_state = 628, .external_lex_state = 24},
  [10895] = {.lex_state = 628, .external_lex_state = 24},
  [10896] = {.lex_state = 628, .external_lex_state = 24},
  [10897] = {.lex_state = 628, .external_lex_state = 24},
  [10898] = {.lex_state = 628, .external_lex_state = 24},
  [10899] = {.lex_state = 128},
  [10900] = {.lex_state = 628, .external_lex_state = 24},
  [10901] = {.lex_state = 628, .external_lex_state = 24},
  [10902] = {.lex_state = 128},
  [10903] = {.lex_state = 363, .external_lex_state = 3},
  [10904] = {.lex_state = 363, .external_lex_state = 3},
  [10905] = {.lex_state = 192, .external_lex_state = 2},
  [10906] = {.lex_state = 192, .external_lex_state = 28},
  [10907] = {.lex_state = 363, .external_lex_state = 3},
  [10908] = {.lex_state = 363, .external_lex_state = 3},
  [10909] = {.lex_state = 363, .external_lex_state = 3},
  [10910] = {.lex_state = 192, .external_lex_state = 2},
  [10911] = {.lex_state = 192, .external_lex_state = 28},
  [10912] = {.lex_state = 426, .external_lex_state = 3},
  [10913] = {.lex_state = 423, .external_lex_state = 3},
  [10914] = {.lex_state = 423, .external_lex_state = 3},
  [10915] = {.lex_state = 192, .external_lex_state = 2},
  [10916] = {.lex_state = 363, .external_lex_state = 3},
  [10917] = {.lex_state = 363, .external_lex_state = 3},
  [10918] = {.lex_state = 192, .external_lex_state = 2},
  [10919] = {.lex_state = 192, .external_lex_state = 28},
  [10920] = {.lex_state = 363, .external_lex_state = 3},
  [10921] = {.lex_state = 363, .external_lex_state = 3},
  [10922] = {.lex_state = 363, .external_lex_state = 3},
  [10923] = {.lex_state = 192, .external_lex_state = 2},
  [10924] = {.lex_state = 192, .external_lex_state = 28},
  [10925] = {.lex_state = 426, .external_lex_state = 3},
  [10926] = {.lex_state = 423, .external_lex_state = 3},
  [10927] = {.lex_state = 423, .external_lex_state = 3},
  [10928] = {.lex_state = 192, .external_lex_state = 2},
  [10929] = {.lex_state = 192, .external_lex_state = 2},
  [10930] = {.lex_state = 192, .external_lex_state = 28},
  [10931] = {.lex_state = 426, .external_lex_state = 24},
  [10932] = {.lex_state = 192, .external_lex_state = 2},
  [10933] = {.lex_state = 192, .external_lex_state = 28},
  [10934] = {.lex_state = 363, .external_lex_state = 3},
  [10935] = {.lex_state = 363, .external_lex_state = 3},
  [10936] = {.lex_state = 363, .external_lex_state = 3},
  [10937] = {.lex_state = 363, .external_lex_state = 3},
  [10938] = {.lex_state = 363, .external_lex_state = 3},
  [10939] = {.lex_state = 192, .external_lex_state = 2},
  [10940] = {.lex_state = 192, .external_lex_state = 2},
  [10941] = {.lex_state = 192, .external_lex_state = 2},
  [10942] = {.lex_state = 192, .external_lex_state = 2},
  [10943] = {.lex_state = 192, .external_lex_state = 2},
  [10944] = {.lex_state = 192, .external_lex_state = 2},
  [10945] = {.lex_state = 192, .external_lex_state = 2},
  [10946] = {.lex_state = 192, .external_lex_state = 2},
  [10947] = {.lex_state = 192, .external_lex_state = 2},
  [10948] = {.lex_state = 192, .external_lex_state = 2},
  [10949] = {.lex_state = 192, .external_lex_state = 28},
  [10950] = {.lex_state = 192, .external_lex_state = 2},
  [10951] = {.lex_state = 367, .external_lex_state = 14},
  [10952] = {.lex_state = 363, .external_lex_state = 3},
  [10953] = {.lex_state = 363, .external_lex_state = 3},
  [10954] = {.lex_state = 363, .external_lex_state = 3},
  [10955] = {.lex_state = 192, .external_lex_state = 2},
  [10956] = {.lex_state = 363, .external_lex_state = 3},
  [10957] = {.lex_state = 192, .external_lex_state = 2},
  [10958] = {.lex_state = 363, .external_lex_state = 3},
  [10959] = {.lex_state = 528, .external_lex_state = 29},
  [10960] = {.lex_state = 363, .external_lex_state = 3},
  [10961] = {.lex_state = 363, .external_lex_state = 3},
  [10962] = {.lex_state = 363, .external_lex_state = 3},
  [10963] = {.lex_state = 363, .external_lex_state = 3},
  [10964] = {.lex_state = 363, .external_lex_state = 3},
  [10965] = {.lex_state = 363, .external_lex_state = 3},
  [10966] = {.lex_state = 363, .external_lex_state = 3},
  [10967] = {.lex_state = 561, .external_lex_state = 16},
  [10968] = {.lex_state = 363, .external_lex_state = 3},
  [10969] = {.lex_state = 363, .external_lex_state = 3},
  [10970] = {.lex_state = 363, .external_lex_state = 3},
  [10971] = {.lex_state = 363, .external_lex_state = 3},
  [10972] = {.lex_state = 423, .external_lex_state = 3},
  [10973] = {.lex_state = 423, .external_lex_state = 3},
  [10974] = {.lex_state = 192, .external_lex_state = 2},
  [10975] = {.lex_state = 423, .external_lex_state = 3},
  [10976] = {.lex_state = 192, .external_lex_state = 2},
  [10977] = {.lex_state = 423, .external_lex_state = 3},
  [10978] = {.lex_state = 528, .external_lex_state = 29},
  [10979] = {.lex_state = 423, .external_lex_state = 3},
  [10980] = {.lex_state = 264, .external_lex_state = 3},
  [10981] = {.lex_state = 528, .external_lex_state = 12},
  [10982] = {.lex_state = 264, .external_lex_state = 3},
  [10983] = {.lex_state = 363, .external_lex_state = 3},
  [10984] = {.lex_state = 363, .external_lex_state = 3},
  [10985] = {.lex_state = 363, .external_lex_state = 3},
  [10986] = {.lex_state = 363, .external_lex_state = 3},
  [10987] = {.lex_state = 363, .external_lex_state = 14},
  [10988] = {.lex_state = 256, .external_lex_state = 13},
  [10989] = {.lex_state = 192, .external_lex_state = 2},
  [10990] = {.lex_state = 426, .external_lex_state = 3},
  [10991] = {.lex_state = 426, .external_lex_state = 3},
  [10992] = {.lex_state = 192, .external_lex_state = 2},
  [10993] = {.lex_state = 192, .external_lex_state = 2},
  [10994] = {.lex_state = 192, .external_lex_state = 2},
  [10995] = {.lex_state = 192, .external_lex_state = 2},
  [10996] = {.lex_state = 192, .external_lex_state = 2},
  [10997] = {.lex_state = 192, .external_lex_state = 2},
  [10998] = {.lex_state = 192, .external_lex_state = 2},
  [10999] = {.lex_state = 192, .external_lex_state = 2},
  [11000] = {.lex_state = 192, .external_lex_state = 2},
  [11001] = {.lex_state = 192, .external_lex_state = 2},
  [11002] = {.lex_state = 192, .external_lex_state = 28},
  [11003] = {.lex_state = 192, .external_lex_state = 2},
  [11004] = {.lex_state = 426, .external_lex_state = 14},
  [11005] = {.lex_state = 426, .external_lex_state = 3},
  [11006] = {.lex_state = 426, .external_lex_state = 3},
  [11007] = {.lex_state = 423, .external_lex_state = 3},
  [11008] = {.lex_state = 423, .external_lex_state = 3},
  [11009] = {.lex_state = 423, .external_lex_state = 3},
  [11010] = {.lex_state = 423, .external_lex_state = 3},
  [11011] = {.lex_state = 423, .external_lex_state = 3},
  [11012] = {.lex_state = 561, .external_lex_state = 16},
  [11013] = {.lex_state = 423, .external_lex_state = 3},
  [11014] = {.lex_state = 423, .external_lex_state = 3},
  [11015] = {.lex_state = 423, .external_lex_state = 3},
  [11016] = {.lex_state = 423, .external_lex_state = 3},
  [11017] = {.lex_state = 426, .external_lex_state = 3},
  [11018] = {.lex_state = 528, .external_lex_state = 12},
  [11019] = {.lex_state = 426, .external_lex_state = 3},
  [11020] = {.lex_state = 426, .external_lex_state = 3},
  [11021] = {.lex_state = 423, .external_lex_state = 3},
  [11022] = {.lex_state = 423, .external_lex_state = 3},
  [11023] = {.lex_state = 423, .external_lex_state = 3},
  [11024] = {.lex_state = 423, .external_lex_state = 14},
  [11025] = {.lex_state = 532, .external_lex_state = 3},
  [11026] = {.lex_state = 532, .external_lex_state = 3},
  [11027] = {.lex_state = 532, .external_lex_state = 3},
  [11028] = {.lex_state = 192, .external_lex_state = 2},
  [11029] = {.lex_state = 192, .external_lex_state = 2},
  [11030] = {.lex_state = 192, .external_lex_state = 2},
  [11031] = {.lex_state = 192, .external_lex_state = 2},
  [11032] = {.lex_state = 192, .external_lex_state = 2},
  [11033] = {.lex_state = 192, .external_lex_state = 2},
  [11034] = {.lex_state = 192, .external_lex_state = 2},
  [11035] = {.lex_state = 192, .external_lex_state = 2},
  [11036] = {.lex_state = 192, .external_lex_state = 2},
  [11037] = {.lex_state = 192, .external_lex_state = 2},
  [11038] = {.lex_state = 192, .external_lex_state = 28},
  [11039] = {.lex_state = 532, .external_lex_state = 3},
  [11040] = {.lex_state = 192, .external_lex_state = 28},
  [11041] = {.lex_state = 192, .external_lex_state = 2},
  [11042] = {.lex_state = 192, .external_lex_state = 2},
  [11043] = {.lex_state = 192, .external_lex_state = 28},
  [11044] = {.lex_state = 426, .external_lex_state = 3},
  [11045] = {.lex_state = 512, .external_lex_state = 3},
  [11046] = {.lex_state = 512, .external_lex_state = 3},
  [11047] = {.lex_state = 512, .external_lex_state = 3},
  [11048] = {.lex_state = 528, .external_lex_state = 12},
  [11049] = {.lex_state = 512, .external_lex_state = 3},
  [11050] = {.lex_state = 512, .external_lex_state = 3},
  [11051] = {.lex_state = 192, .external_lex_state = 2},
  [11052] = {.lex_state = 192, .external_lex_state = 28},
  [11053] = {.lex_state = 512, .external_lex_state = 3},
  [11054] = {.lex_state = 512, .external_lex_state = 3},
  [11055] = {.lex_state = 512, .external_lex_state = 3},
  [11056] = {.lex_state = 363, .external_lex_state = 3},
  [11057] = {.lex_state = 363, .external_lex_state = 3},
  [11058] = {.lex_state = 426, .external_lex_state = 3},
  [11059] = {.lex_state = 426, .external_lex_state = 3},
  [11060] = {.lex_state = 532, .external_lex_state = 3},
  [11061] = {.lex_state = 363, .external_lex_state = 3},
  [11062] = {.lex_state = 363, .external_lex_state = 3},
  [11063] = {.lex_state = 426, .external_lex_state = 3},
  [11064] = {.lex_state = 426, .external_lex_state = 3},
  [11065] = {.lex_state = 532, .external_lex_state = 3},
  [11066] = {.lex_state = 408, .external_lex_state = 24},
  [11067] = {.lex_state = 408, .external_lex_state = 24},
  [11068] = {.lex_state = 541, .external_lex_state = 24},
  [11069] = {.lex_state = 541, .external_lex_state = 24},
  [11070] = {.lex_state = 363, .external_lex_state = 24},
  [11071] = {.lex_state = 363, .external_lex_state = 24},
  [11072] = {.lex_state = 192, .external_lex_state = 2},
  [11073] = {.lex_state = 192, .external_lex_state = 2},
  [11074] = {.lex_state = 192, .external_lex_state = 2},
  [11075] = {.lex_state = 192, .external_lex_state = 2},
  [11076] = {.lex_state = 192, .external_lex_state = 2},
  [11077] = {.lex_state = 192, .external_lex_state = 2},
  [11078] = {.lex_state = 192, .external_lex_state = 2},
  [11079] = {.lex_state = 192, .external_lex_state = 2},
  [11080] = {.lex_state = 192, .external_lex_state = 2},
  [11081] = {.lex_state = 192, .external_lex_state = 2},
  [11082] = {.lex_state = 192, .external_lex_state = 28},
  [11083] = {.lex_state = 192, .external_lex_state = 2},
  [11084] = {.lex_state = 367, .external_lex_state = 26},
  [11085] = {.lex_state = 363, .external_lex_state = 24},
  [11086] = {.lex_state = 363, .external_lex_state = 24},
  [11087] = {.lex_state = 363, .external_lex_state = 24},
  [11088] = {.lex_state = 192, .external_lex_state = 2},
  [11089] = {.lex_state = 363, .external_lex_state = 24},
  [11090] = {.lex_state = 192, .external_lex_state = 2},
  [11091] = {.lex_state = 363, .external_lex_state = 24},
  [11092] = {.lex_state = 528, .external_lex_state = 29},
  [11093] = {.lex_state = 363, .external_lex_state = 24},
  [11094] = {.lex_state = 363, .external_lex_state = 24},
  [11095] = {.lex_state = 363, .external_lex_state = 24},
  [11096] = {.lex_state = 363, .external_lex_state = 24},
  [11097] = {.lex_state = 363, .external_lex_state = 24},
  [11098] = {.lex_state = 363, .external_lex_state = 24},
  [11099] = {.lex_state = 363, .external_lex_state = 24},
  [11100] = {.lex_state = 561, .external_lex_state = 16},
  [11101] = {.lex_state = 363, .external_lex_state = 24},
  [11102] = {.lex_state = 363, .external_lex_state = 24},
  [11103] = {.lex_state = 363, .external_lex_state = 24},
  [11104] = {.lex_state = 363, .external_lex_state = 24},
  [11105] = {.lex_state = 423, .external_lex_state = 24},
  [11106] = {.lex_state = 423, .external_lex_state = 24},
  [11107] = {.lex_state = 192, .external_lex_state = 2},
  [11108] = {.lex_state = 423, .external_lex_state = 24},
  [11109] = {.lex_state = 192, .external_lex_state = 2},
  [11110] = {.lex_state = 423, .external_lex_state = 24},
  [11111] = {.lex_state = 528, .external_lex_state = 29},
  [11112] = {.lex_state = 423, .external_lex_state = 24},
  [11113] = {.lex_state = 363, .external_lex_state = 24},
  [11114] = {.lex_state = 528, .external_lex_state = 12},
  [11115] = {.lex_state = 363, .external_lex_state = 24},
  [11116] = {.lex_state = 363, .external_lex_state = 24},
  [11117] = {.lex_state = 363, .external_lex_state = 24},
  [11118] = {.lex_state = 363, .external_lex_state = 24},
  [11119] = {.lex_state = 363, .external_lex_state = 24},
  [11120] = {.lex_state = 363, .external_lex_state = 26},
  [11121] = {.lex_state = 192, .external_lex_state = 2},
  [11122] = {.lex_state = 426, .external_lex_state = 24},
  [11123] = {.lex_state = 426, .external_lex_state = 24},
  [11124] = {.lex_state = 192, .external_lex_state = 2},
  [11125] = {.lex_state = 192, .external_lex_state = 2},
  [11126] = {.lex_state = 192, .external_lex_state = 2},
  [11127] = {.lex_state = 192, .external_lex_state = 2},
  [11128] = {.lex_state = 192, .external_lex_state = 2},
  [11129] = {.lex_state = 192, .external_lex_state = 2},
  [11130] = {.lex_state = 192, .external_lex_state = 2},
  [11131] = {.lex_state = 192, .external_lex_state = 2},
  [11132] = {.lex_state = 192, .external_lex_state = 2},
  [11133] = {.lex_state = 192, .external_lex_state = 2},
  [11134] = {.lex_state = 192, .external_lex_state = 28},
  [11135] = {.lex_state = 192, .external_lex_state = 2},
  [11136] = {.lex_state = 426, .external_lex_state = 26},
  [11137] = {.lex_state = 426, .external_lex_state = 24},
  [11138] = {.lex_state = 426, .external_lex_state = 24},
  [11139] = {.lex_state = 423, .external_lex_state = 24},
  [11140] = {.lex_state = 423, .external_lex_state = 24},
  [11141] = {.lex_state = 423, .external_lex_state = 24},
  [11142] = {.lex_state = 423, .external_lex_state = 24},
  [11143] = {.lex_state = 423, .external_lex_state = 24},
  [11144] = {.lex_state = 561, .external_lex_state = 16},
  [11145] = {.lex_state = 423, .external_lex_state = 24},
  [11146] = {.lex_state = 423, .external_lex_state = 24},
  [11147] = {.lex_state = 423, .external_lex_state = 24},
  [11148] = {.lex_state = 423, .external_lex_state = 24},
  [11149] = {.lex_state = 426, .external_lex_state = 24},
  [11150] = {.lex_state = 528, .external_lex_state = 12},
  [11151] = {.lex_state = 426, .external_lex_state = 24},
  [11152] = {.lex_state = 426, .external_lex_state = 24},
  [11153] = {.lex_state = 423, .external_lex_state = 24},
  [11154] = {.lex_state = 423, .external_lex_state = 24},
  [11155] = {.lex_state = 423, .external_lex_state = 24},
  [11156] = {.lex_state = 423, .external_lex_state = 26},
  [11157] = {.lex_state = 304, .external_lex_state = 16},
  [11158] = {.lex_state = 192, .external_lex_state = 28},
  [11159] = {.lex_state = 304, .external_lex_state = 16},
  [11160] = {.lex_state = 288, .external_lex_state = 2},
  [11161] = {.lex_state = 239},
  [11162] = {.lex_state = 128, .external_lex_state = 11},
  [11163] = {.lex_state = 239},
  [11164] = {.lex_state = 650, .external_lex_state = 24},
  [11165] = {.lex_state = 650, .external_lex_state = 24},
  [11166] = {.lex_state = 566, .external_lex_state = 24},
  [11167] = {.lex_state = 566, .external_lex_state = 24},
  [11168] = {.lex_state = 561, .external_lex_state = 16},
  [11169] = {.lex_state = 229, .external_lex_state = 3},
  [11170] = {.lex_state = 438, .external_lex_state = 3},
  [11171] = {.lex_state = 363, .external_lex_state = 3},
  [11172] = {.lex_state = 363, .external_lex_state = 3},
  [11173] = {.lex_state = 426, .external_lex_state = 3},
  [11174] = {.lex_state = 426, .external_lex_state = 3},
  [11175] = {.lex_state = 532, .external_lex_state = 3},
  [11176] = {.lex_state = 465, .external_lex_state = 24},
  [11177] = {.lex_state = 465, .external_lex_state = 24},
  [11178] = {.lex_state = 465, .external_lex_state = 24},
  [11179] = {.lex_state = 465, .external_lex_state = 24},
  [11180] = {.lex_state = 465, .external_lex_state = 24},
  [11181] = {.lex_state = 128},
  [11182] = {.lex_state = 465, .external_lex_state = 24},
  [11183] = {.lex_state = 685, .external_lex_state = 13},
  [11184] = {.lex_state = 426, .external_lex_state = 24},
  [11185] = {.lex_state = 426, .external_lex_state = 24},
  [11186] = {.lex_state = 628, .external_lex_state = 24},
  [11187] = {.lex_state = 628, .external_lex_state = 24},
  [11188] = {.lex_state = 363, .external_lex_state = 3},
  [11189] = {.lex_state = 363, .external_lex_state = 3},
  [11190] = {.lex_state = 426, .external_lex_state = 3},
  [11191] = {.lex_state = 426, .external_lex_state = 3},
  [11192] = {.lex_state = 532, .external_lex_state = 3},
  [11193] = {.lex_state = 363, .external_lex_state = 3},
  [11194] = {.lex_state = 363, .external_lex_state = 3},
  [11195] = {.lex_state = 426, .external_lex_state = 3},
  [11196] = {.lex_state = 426, .external_lex_state = 3},
  [11197] = {.lex_state = 532, .external_lex_state = 3},
  [11198] = {.lex_state = 426, .external_lex_state = 24},
  [11199] = {.lex_state = 426, .external_lex_state = 24},
  [11200] = {.lex_state = 363, .external_lex_state = 3},
  [11201] = {.lex_state = 363, .external_lex_state = 3},
  [11202] = {.lex_state = 363, .external_lex_state = 3},
  [11203] = {.lex_state = 363, .external_lex_state = 3},
  [11204] = {.lex_state = 363, .external_lex_state = 3},
  [11205] = {.lex_state = 363, .external_lex_state = 3},
  [11206] = {.lex_state = 363, .external_lex_state = 3},
  [11207] = {.lex_state = 363, .external_lex_state = 3},
  [11208] = {.lex_state = 363, .external_lex_state = 3},
  [11209] = {.lex_state = 561, .external_lex_state = 16},
  [11210] = {.lex_state = 363, .external_lex_state = 3},
  [11211] = {.lex_state = 363, .external_lex_state = 3},
  [11212] = {.lex_state = 363, .external_lex_state = 3},
  [11213] = {.lex_state = 363, .external_lex_state = 3},
  [11214] = {.lex_state = 363, .external_lex_state = 3},
  [11215] = {.lex_state = 363, .external_lex_state = 3},
  [11216] = {.lex_state = 363, .external_lex_state = 3},
  [11217] = {.lex_state = 367, .external_lex_state = 14},
  [11218] = {.lex_state = 363, .external_lex_state = 3},
  [11219] = {.lex_state = 363, .external_lex_state = 3},
  [11220] = {.lex_state = 363, .external_lex_state = 3},
  [11221] = {.lex_state = 528, .external_lex_state = 12},
  [11222] = {.lex_state = 363, .external_lex_state = 3},
  [11223] = {.lex_state = 363, .external_lex_state = 3},
  [11224] = {.lex_state = 192, .external_lex_state = 2},
  [11225] = {.lex_state = 423, .external_lex_state = 3},
  [11226] = {.lex_state = 423, .external_lex_state = 3},
  [11227] = {.lex_state = 423, .external_lex_state = 3},
  [11228] = {.lex_state = 528, .external_lex_state = 12},
  [11229] = {.lex_state = 423, .external_lex_state = 3},
  [11230] = {.lex_state = 423, .external_lex_state = 3},
  [11231] = {.lex_state = 192, .external_lex_state = 28},
  [11232] = {.lex_state = 363, .external_lex_state = 3},
  [11233] = {.lex_state = 249, .external_lex_state = 3},
  [11234] = {.lex_state = 426, .external_lex_state = 3},
  [11235] = {.lex_state = 426, .external_lex_state = 3},
  [11236] = {.lex_state = 426, .external_lex_state = 3},
  [11237] = {.lex_state = 426, .external_lex_state = 3},
  [11238] = {.lex_state = 426, .external_lex_state = 3},
  [11239] = {.lex_state = 561, .external_lex_state = 16},
  [11240] = {.lex_state = 426, .external_lex_state = 3},
  [11241] = {.lex_state = 426, .external_lex_state = 3},
  [11242] = {.lex_state = 426, .external_lex_state = 3},
  [11243] = {.lex_state = 426, .external_lex_state = 3},
  [11244] = {.lex_state = 426, .external_lex_state = 3},
  [11245] = {.lex_state = 426, .external_lex_state = 3},
  [11246] = {.lex_state = 426, .external_lex_state = 3},
  [11247] = {.lex_state = 426, .external_lex_state = 14},
  [11248] = {.lex_state = 192, .external_lex_state = 2},
  [11249] = {.lex_state = 192, .external_lex_state = 28},
  [11250] = {.lex_state = 423, .external_lex_state = 3},
  [11251] = {.lex_state = 532, .external_lex_state = 3},
  [11252] = {.lex_state = 532, .external_lex_state = 3},
  [11253] = {.lex_state = 532, .external_lex_state = 3},
  [11254] = {.lex_state = 532, .external_lex_state = 3},
  [11255] = {.lex_state = 532, .external_lex_state = 3},
  [11256] = {.lex_state = 561, .external_lex_state = 16},
  [11257] = {.lex_state = 532, .external_lex_state = 3},
  [11258] = {.lex_state = 532, .external_lex_state = 3},
  [11259] = {.lex_state = 532, .external_lex_state = 3},
  [11260] = {.lex_state = 532, .external_lex_state = 3},
  [11261] = {.lex_state = 532, .external_lex_state = 3},
  [11262] = {.lex_state = 532, .external_lex_state = 3},
  [11263] = {.lex_state = 532, .external_lex_state = 3},
  [11264] = {.lex_state = 426, .external_lex_state = 3},
  [11265] = {.lex_state = 426, .external_lex_state = 3},
  [11266] = {.lex_state = 512, .external_lex_state = 3},
  [11267] = {.lex_state = 512, .external_lex_state = 3},
  [11268] = {.lex_state = 363, .external_lex_state = 24},
  [11269] = {.lex_state = 363, .external_lex_state = 24},
  [11270] = {.lex_state = 363, .external_lex_state = 24},
  [11271] = {.lex_state = 363, .external_lex_state = 24},
  [11272] = {.lex_state = 363, .external_lex_state = 24},
  [11273] = {.lex_state = 561, .external_lex_state = 16},
  [11274] = {.lex_state = 363, .external_lex_state = 24},
  [11275] = {.lex_state = 363, .external_lex_state = 24},
  [11276] = {.lex_state = 363, .external_lex_state = 24},
  [11277] = {.lex_state = 363, .external_lex_state = 24},
  [11278] = {.lex_state = 363, .external_lex_state = 24},
  [11279] = {.lex_state = 363, .external_lex_state = 24},
  [11280] = {.lex_state = 363, .external_lex_state = 24},
  [11281] = {.lex_state = 367, .external_lex_state = 26},
  [11282] = {.lex_state = 363, .external_lex_state = 24},
  [11283] = {.lex_state = 363, .external_lex_state = 24},
  [11284] = {.lex_state = 363, .external_lex_state = 24},
  [11285] = {.lex_state = 528, .external_lex_state = 12},
  [11286] = {.lex_state = 363, .external_lex_state = 24},
  [11287] = {.lex_state = 363, .external_lex_state = 24},
  [11288] = {.lex_state = 192, .external_lex_state = 2},
  [11289] = {.lex_state = 423, .external_lex_state = 24},
  [11290] = {.lex_state = 423, .external_lex_state = 24},
  [11291] = {.lex_state = 423, .external_lex_state = 24},
  [11292] = {.lex_state = 528, .external_lex_state = 12},
  [11293] = {.lex_state = 423, .external_lex_state = 24},
  [11294] = {.lex_state = 423, .external_lex_state = 24},
  [11295] = {.lex_state = 192, .external_lex_state = 28},
  [11296] = {.lex_state = 363, .external_lex_state = 24},
  [11297] = {.lex_state = 304, .external_lex_state = 16},
  [11298] = {.lex_state = 426, .external_lex_state = 24},
  [11299] = {.lex_state = 426, .external_lex_state = 24},
  [11300] = {.lex_state = 426, .external_lex_state = 24},
  [11301] = {.lex_state = 426, .external_lex_state = 24},
  [11302] = {.lex_state = 426, .external_lex_state = 24},
  [11303] = {.lex_state = 561, .external_lex_state = 16},
  [11304] = {.lex_state = 426, .external_lex_state = 24},
  [11305] = {.lex_state = 426, .external_lex_state = 24},
  [11306] = {.lex_state = 426, .external_lex_state = 24},
  [11307] = {.lex_state = 426, .external_lex_state = 24},
  [11308] = {.lex_state = 426, .external_lex_state = 24},
  [11309] = {.lex_state = 426, .external_lex_state = 24},
  [11310] = {.lex_state = 426, .external_lex_state = 24},
  [11311] = {.lex_state = 426, .external_lex_state = 26},
  [11312] = {.lex_state = 192, .external_lex_state = 2},
  [11313] = {.lex_state = 192, .external_lex_state = 28},
  [11314] = {.lex_state = 423, .external_lex_state = 24},
  [11315] = {.lex_state = 304, .external_lex_state = 16},
  [11316] = {.lex_state = 288, .external_lex_state = 2},
  [11317] = {.lex_state = 128, .external_lex_state = 11},
  [11318] = {.lex_state = 465, .external_lex_state = 24},
  [11319] = {.lex_state = 363, .external_lex_state = 3},
  [11320] = {.lex_state = 363, .external_lex_state = 3},
  [11321] = {.lex_state = 192, .external_lex_state = 2},
  [11322] = {.lex_state = 192, .external_lex_state = 28},
  [11323] = {.lex_state = 363, .external_lex_state = 3},
  [11324] = {.lex_state = 363, .external_lex_state = 3},
  [11325] = {.lex_state = 363, .external_lex_state = 3},
  [11326] = {.lex_state = 192, .external_lex_state = 2},
  [11327] = {.lex_state = 192, .external_lex_state = 28},
  [11328] = {.lex_state = 426, .external_lex_state = 3},
  [11329] = {.lex_state = 423, .external_lex_state = 3},
  [11330] = {.lex_state = 423, .external_lex_state = 3},
  [11331] = {.lex_state = 192, .external_lex_state = 2},
  [11332] = {.lex_state = 192, .external_lex_state = 2},
  [11333] = {.lex_state = 192, .external_lex_state = 28},
  [11334] = {.lex_state = 363, .external_lex_state = 24},
  [11335] = {.lex_state = 363, .external_lex_state = 24},
  [11336] = {.lex_state = 363, .external_lex_state = 24},
  [11337] = {.lex_state = 192, .external_lex_state = 2},
  [11338] = {.lex_state = 192, .external_lex_state = 28},
  [11339] = {.lex_state = 426, .external_lex_state = 24},
  [11340] = {.lex_state = 423, .external_lex_state = 24},
  [11341] = {.lex_state = 423, .external_lex_state = 24},
  [11342] = {.lex_state = 363, .external_lex_state = 3},
  [11343] = {.lex_state = 363, .external_lex_state = 3},
  [11344] = {.lex_state = 426, .external_lex_state = 3},
  [11345] = {.lex_state = 426, .external_lex_state = 3},
  [11346] = {.lex_state = 532, .external_lex_state = 3},
  [11347] = {.lex_state = 363, .external_lex_state = 24},
  [11348] = {.lex_state = 363, .external_lex_state = 24},
  [11349] = {.lex_state = 426, .external_lex_state = 24},
  [11350] = {.lex_state = 426, .external_lex_state = 24},
};

enum {
  ts_external_token__line_break,
  ts_external_token__simple_symbol,
  ts_external_token__string_start,
  ts_external_token__symbol_start,
  ts_external_token__subshell_start,
  ts_external_token__regex_start,
  ts_external_token__string_array_start,
  ts_external_token__symbol_array_start,
  ts_external_token__heredoc_body_start,
  ts_external_token__string_content,
  ts_external_token__heredoc_content,
  ts_external_token__string_end,
  ts_external_token_heredoc_end,
  ts_external_token_heredoc_beginning,
  ts_external_token_SLASH,
  ts_external_token__block_ampersand,
  ts_external_token__splat_star,
  ts_external_token__unary_minus,
  ts_external_token__binary_minus,
  ts_external_token__binary_star,
  ts_external_token__singleton_class_left_angle_left_langle,
  ts_external_token__identifier_hash_key,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__line_break] = sym__line_break,
  [ts_external_token__simple_symbol] = sym__simple_symbol,
  [ts_external_token__string_start] = sym__string_start,
  [ts_external_token__symbol_start] = sym__symbol_start,
  [ts_external_token__subshell_start] = sym__subshell_start,
  [ts_external_token__regex_start] = sym__regex_start,
  [ts_external_token__string_array_start] = sym__string_array_start,
  [ts_external_token__symbol_array_start] = sym__symbol_array_start,
  [ts_external_token__heredoc_body_start] = sym__heredoc_body_start,
  [ts_external_token__string_content] = sym__string_content,
  [ts_external_token__heredoc_content] = sym__heredoc_content,
  [ts_external_token__string_end] = sym__string_end,
  [ts_external_token_heredoc_end] = sym_heredoc_end,
  [ts_external_token_heredoc_beginning] = sym_heredoc_beginning,
  [ts_external_token_SLASH] = anon_sym_SLASH,
  [ts_external_token__block_ampersand] = sym__block_ampersand,
  [ts_external_token__splat_star] = sym__splat_star,
  [ts_external_token__unary_minus] = sym__unary_minus,
  [ts_external_token__binary_minus] = sym__binary_minus,
  [ts_external_token__binary_star] = sym__binary_star,
  [ts_external_token__singleton_class_left_angle_left_langle] = sym__singleton_class_left_angle_left_langle,
  [ts_external_token__identifier_hash_key] = sym__identifier_hash_key,
};

static bool ts_external_scanner_states[31][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token__string_content] = true,
    [ts_external_token__heredoc_content] = true,
    [ts_external_token__string_end] = true,
    [ts_external_token_heredoc_end] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__block_ampersand] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token__singleton_class_left_angle_left_langle] = true,
    [ts_external_token__identifier_hash_key] = true,
  },
  [2] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus] = true,
  },
  [3] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
  },
  [4] = {
    [ts_external_token__string_content] = true,
    [ts_external_token__string_end] = true,
  },
  [5] = {
    [ts_external_token__line_break] = true,
  },
  [6] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__identifier_hash_key] = true,
  },
  [7] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token_SLASH] = true,
  },
  [8] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token_heredoc_beginning] = true,
  },
  [9] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__singleton_class_left_angle_left_langle] = true,
  },
  [10] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__block_ampersand] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token__identifier_hash_key] = true,
  },
  [11] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus] = true,
  },
  [12] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__block_ampersand] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__identifier_hash_key] = true,
  },
  [13] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__heredoc_body_start] = true,
  },
  [14] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
  },
  [15] = {
    [ts_external_token__string_end] = true,
  },
  [16] = {
    [ts_external_token_SLASH] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
  },
  [17] = {
    [ts_external_token__heredoc_content] = true,
    [ts_external_token_heredoc_end] = true,
  },
  [18] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__block_ampersand] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token__identifier_hash_key] = true,
  },
  [19] = {
    [ts_external_token__heredoc_body_start] = true,
  },
  [20] = {
    [ts_external_token__string_start] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
  },
  [21] = {
    [ts_external_token__string_start] = true,
  },
  [22] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__block_ampersand] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__identifier_hash_key] = true,
  },
  [23] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
  },
  [24] = {
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
  },
  [25] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__block_ampersand] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token__identifier_hash_key] = true,
  },
  [26] = {
    [ts_external_token__string_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
  },
  [27] = {
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_SLASH] = true,
  },
  [28] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
  },
  [29] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__block_ampersand] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__identifier_hash_key] = true,
  },
  [30] = {
    [ts_external_token__string_content] = true,
  },
};

static uint16_t ts_parse_table[STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym__line_break] = ACTIONS(1),
    [sym__simple_symbol] = ACTIONS(1),
    [sym__string_start] = ACTIONS(1),
    [sym__symbol_start] = ACTIONS(1),
    [sym__subshell_start] = ACTIONS(1),
    [sym__regex_start] = ACTIONS(1),
    [sym__string_array_start] = ACTIONS(1),
    [sym__symbol_array_start] = ACTIONS(1),
    [sym__heredoc_body_start] = ACTIONS(1),
    [sym__string_content] = ACTIONS(1),
    [sym__heredoc_content] = ACTIONS(1),
    [sym__string_end] = ACTIONS(1),
    [sym_heredoc_end] = ACTIONS(1),
    [sym_heredoc_beginning] = ACTIONS(1),
    [sym__block_ampersand] = ACTIONS(1),
    [sym__splat_star] = ACTIONS(1),
    [sym__unary_minus] = ACTIONS(1),
    [sym__binary_minus] = ACTIONS(1),
    [sym__binary_star] = ACTIONS(1),
    [sym__singleton_class_left_angle_left_langle] = ACTIONS(1),
    [sym__identifier_hash_key] = ACTIONS(1),
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym___END__] = ACTIONS(3),
    [anon_sym_BEGIN] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_END] = ACTIONS(3),
    [anon_sym_def] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(3),
    [anon_sym_COLON_COLON] = ACTIONS(3),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(3),
    [anon_sym_STAR_STAR] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(3),
    [anon_sym_class] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(3),
    [anon_sym_end] = ACTIONS(3),
    [anon_sym_return] = ACTIONS(3),
    [anon_sym_yield] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(3),
    [anon_sym_next] = ACTIONS(3),
    [sym_redo] = ACTIONS(3),
    [sym_retry] = ACTIONS(3),
    [anon_sym_if] = ACTIONS(3),
    [anon_sym_unless] = ACTIONS(3),
    [anon_sym_while] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(3),
    [anon_sym_rescue] = ACTIONS(3),
    [anon_sym_for] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3),
    [anon_sym_case] = ACTIONS(3),
    [anon_sym_when] = ACTIONS(3),
    [anon_sym_elsif] = ACTIONS(3),
    [anon_sym_else] = ACTIONS(3),
    [anon_sym_then] = ACTIONS(3),
    [anon_sym_begin] = ACTIONS(3),
    [anon_sym_ensure] = ACTIONS(3),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_COLON_COLON2] = ACTIONS(1),
    [anon_sym_AMP_DOT] = ACTIONS(1),
    [anon_sym_LPAREN2] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(3),
    [anon_sym_COLON2] = ACTIONS(3),
    [anon_sym_DOT_DOT] = ACTIONS(3),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(3),
    [anon_sym_or] = ACTIONS(3),
    [anon_sym_PIPE_PIPE] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3),
    [anon_sym_LT_LT] = ACTIONS(3),
    [anon_sym_GT_GT] = ACTIONS(3),
    [anon_sym_EQ_EQ] = ACTIONS(3),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1),
    [anon_sym_LT_EQ_GT] = ACTIONS(1),
    [anon_sym_EQ_TILDE] = ACTIONS(1),
    [anon_sym_BANG_TILDE] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(3),
    [anon_sym_GT] = ACTIONS(3),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(3),
    [anon_sym_SLASH] = ACTIONS(3),
    [anon_sym_PERCENT] = ACTIONS(3),
    [anon_sym_defined_QMARK] = ACTIONS(1),
    [anon_sym_not] = ACTIONS(3),
    [anon_sym_BANG] = ACTIONS(3),
    [anon_sym_TILDE] = ACTIONS(1),
    [sym_constant] = ACTIONS(3),
    [sym_identifier] = ACTIONS(3),
    [sym_instance_variable] = ACTIONS(1),
    [sym_class_variable] = ACTIONS(1),
    [sym_global_variable] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(3),
    [anon_sym_PLUS_AT] = ACTIONS(1),
    [anon_sym_DASH_AT] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_undef] = ACTIONS(3),
    [anon_sym_alias] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(3),
    [sym_float] = ACTIONS(3),
    [anon_sym_r] = ACTIONS(3),
    [sym_super] = ACTIONS(3),
    [anon_sym_true] = ACTIONS(3),
    [anon_sym_TRUE] = ACTIONS(3),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_FALSE] = ACTIONS(3),
    [sym_self] = ACTIONS(3),
    [anon_sym_nil] = ACTIONS(3),
    [anon_sym_NIL] = ACTIONS(3),
    [sym_character] = ACTIONS(1),
    [anon_sym_POUND_LBRACE] = ACTIONS(1),
    [anon_sym_LBRACK2] = ACTIONS(3),
  },
  [1] = {
    [sym_program] = STATE(42),
    [sym__statements] = STATE(43),
    [sym_begin_block] = STATE(44),
    [sym_end_block] = STATE(44),
    [sym__statement] = STATE(44),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(44),
    [sym_unless_modifier] = STATE(44),
    [sym_while_modifier] = STATE(44),
    [sym_until_modifier] = STATE(44),
    [sym_rescue_modifier] = STATE(44),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(45),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(51),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(51),
    [sym_assignment] = STATE(45),
    [sym_operator_assignment] = STATE(45),
    [sym_conditional] = STATE(45),
    [sym_range] = STATE(45),
    [sym_binary] = STATE(45),
    [sym_unary] = STATE(45),
    [sym_left_assignment_list] = STATE(48),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(51),
    [sym__variable] = STATE(47),
    [sym_undef] = STATE(44),
    [sym_alias] = STATE(44),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(51),
    [sym_false] = STATE(51),
    [sym_nil] = STATE(51),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(52),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(53),
    [aux_sym__statements_repeat1] = STATE(53),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(21),
    [ts_builtin_sym_end] = ACTIONS(23),
    [anon_sym___END__] = ACTIONS(25),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [anon_sym_undef] = ACTIONS(83),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2] = {
    [sym__line_break] = ACTIONS(101),
    [sym__heredoc_body_start] = ACTIONS(101),
    [sym__binary_minus] = ACTIONS(101),
    [sym__binary_star] = ACTIONS(101),
    [ts_builtin_sym_end] = ACTIONS(101),
    [anon_sym___END__] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_RBRACE] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(103),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_PIPE] = ACTIONS(103),
    [anon_sym_SEMI] = ACTIONS(101),
    [anon_sym_STAR_STAR] = ACTIONS(101),
    [anon_sym_AMP] = ACTIONS(103),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_unless] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_until] = ACTIONS(101),
    [anon_sym_rescue] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(101),
    [anon_sym_when] = ACTIONS(101),
    [anon_sym_elsif] = ACTIONS(101),
    [anon_sym_else] = ACTIONS(101),
    [anon_sym_then] = ACTIONS(101),
    [anon_sym_ensure] = ACTIONS(101),
    [anon_sym_EQ_GT] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_COLON_COLON2] = ACTIONS(101),
    [anon_sym_AMP_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_DOT_DOT] = ACTIONS(103),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_and] = ACTIONS(101),
    [anon_sym_or] = ACTIONS(101),
    [anon_sym_PIPE_PIPE] = ACTIONS(101),
    [anon_sym_AMP_AMP] = ACTIONS(101),
    [anon_sym_LT_LT] = ACTIONS(101),
    [anon_sym_GT_GT] = ACTIONS(101),
    [anon_sym_EQ_EQ] = ACTIONS(103),
    [anon_sym_BANG_EQ] = ACTIONS(101),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(101),
    [anon_sym_LT_EQ_GT] = ACTIONS(101),
    [anon_sym_EQ_TILDE] = ACTIONS(101),
    [anon_sym_BANG_TILDE] = ACTIONS(101),
    [anon_sym_LT_EQ] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_EQ] = ACTIONS(101),
    [anon_sym_CARET] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(101),
    [anon_sym_PERCENT] = ACTIONS(101),
    [sym_comment] = ACTIONS(87),
  },
  [3] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(56),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(107),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [4] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(59),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(113),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [5] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(61),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(115),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [6] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(63),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(117),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [7] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(67),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(121),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(125),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [8] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(71),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(129),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(131),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [9] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(72),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(51),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(51),
    [sym_assignment] = STATE(72),
    [sym_operator_assignment] = STATE(72),
    [sym_conditional] = STATE(72),
    [sym_range] = STATE(72),
    [sym_binary] = STATE(72),
    [sym_unary] = STATE(72),
    [sym_left_assignment_list] = STATE(48),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(51),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(51),
    [sym_false] = STATE(51),
    [sym_nil] = STATE(51),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(52),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10] = {
    [sym__line_break] = ACTIONS(133),
    [sym_comment] = ACTIONS(87),
  },
  [11] = {
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_comment] = ACTIONS(87),
  },
  [12] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(113),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(118),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(118),
    [sym_hash_splat_argument] = STATE(116),
    [sym_assignment] = STATE(113),
    [sym_operator_assignment] = STATE(113),
    [sym_conditional] = STATE(113),
    [sym_range] = STATE(113),
    [sym_binary] = STATE(113),
    [sym_unary] = STATE(113),
    [sym_left_assignment_list] = STATE(117),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(118),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(118),
    [sym_false] = STATE(118),
    [sym_nil] = STATE(118),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(119),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_heredoc_body] = STATE(120),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym__hash_items] = STATE(121),
    [sym_pair] = STATE(122),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [sym__identifier_hash_key] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_RBRACE] = ACTIONS(161),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(209),
    [sym_identifier] = ACTIONS(209),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [13] = {
    [anon_sym_LBRACE] = ACTIONS(227),
    [sym_comment] = ACTIONS(87),
  },
  [14] = {
    [sym__method_rest] = STATE(130),
    [sym__variable] = STATE(131),
    [sym_operator] = STATE(132),
    [sym__method_name] = STATE(132),
    [sym_setter] = STATE(132),
    [sym_symbol] = STATE(132),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_LPAREN] = ACTIONS(233),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(239),
    [sym_identifier] = ACTIONS(241),
    [sym_instance_variable] = ACTIONS(239),
    [sym_class_variable] = ACTIONS(239),
    [sym_global_variable] = ACTIONS(239),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
    [sym_super] = ACTIONS(243),
    [sym_self] = ACTIONS(243),
  },
  [15] = {
    [sym__statements] = STATE(143),
    [sym_begin_block] = STATE(144),
    [sym_end_block] = STATE(144),
    [sym__statement] = STATE(144),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(144),
    [sym_unless_modifier] = STATE(144),
    [sym_while_modifier] = STATE(144),
    [sym_until_modifier] = STATE(144),
    [sym_rescue_modifier] = STATE(144),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(145),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(150),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(150),
    [sym_assignment] = STATE(145),
    [sym_operator_assignment] = STATE(145),
    [sym_conditional] = STATE(145),
    [sym_range] = STATE(145),
    [sym_binary] = STATE(145),
    [sym_unary] = STATE(145),
    [sym_left_assignment_list] = STATE(147),
    [sym__mlhs] = STATE(148),
    [sym_destructured_left_assignment] = STATE(149),
    [sym_rest_assignment] = STATE(149),
    [sym__lhs] = STATE(150),
    [sym__variable] = STATE(146),
    [sym_undef] = STATE(144),
    [sym_alias] = STATE(144),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(150),
    [sym_false] = STATE(150),
    [sym_nil] = STATE(150),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(151),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(152),
    [aux_sym__statements_repeat1] = STATE(152),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_RPAREN] = ACTIONS(247),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(249),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [anon_sym_undef] = ACTIONS(271),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [16] = {
    [sym_constant] = ACTIONS(273),
    [sym_identifier] = ACTIONS(273),
    [sym_comment] = ACTIONS(87),
  },
  [17] = {
    [sym__simple_symbol] = ACTIONS(275),
    [sym__string_start] = ACTIONS(275),
    [sym__symbol_start] = ACTIONS(275),
    [sym__subshell_start] = ACTIONS(275),
    [sym__regex_start] = ACTIONS(275),
    [sym__string_array_start] = ACTIONS(275),
    [sym__symbol_array_start] = ACTIONS(275),
    [sym_heredoc_beginning] = ACTIONS(275),
    [sym__unary_minus] = ACTIONS(275),
    [ts_builtin_sym_end] = ACTIONS(275),
    [anon_sym___END__] = ACTIONS(277),
    [anon_sym_BEGIN] = ACTIONS(277),
    [anon_sym_LBRACE] = ACTIONS(275),
    [anon_sym_RBRACE] = ACTIONS(275),
    [anon_sym_END] = ACTIONS(277),
    [anon_sym_def] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(275),
    [anon_sym_RPAREN] = ACTIONS(275),
    [anon_sym_COLON_COLON] = ACTIONS(275),
    [anon_sym_SEMI] = ACTIONS(275),
    [anon_sym_STAR] = ACTIONS(275),
    [anon_sym_class] = ACTIONS(277),
    [anon_sym_module] = ACTIONS(277),
    [anon_sym_end] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(277),
    [anon_sym_yield] = ACTIONS(277),
    [anon_sym_break] = ACTIONS(277),
    [anon_sym_next] = ACTIONS(277),
    [sym_redo] = ACTIONS(277),
    [sym_retry] = ACTIONS(277),
    [anon_sym_if] = ACTIONS(277),
    [anon_sym_unless] = ACTIONS(277),
    [anon_sym_while] = ACTIONS(277),
    [anon_sym_until] = ACTIONS(277),
    [anon_sym_rescue] = ACTIONS(277),
    [anon_sym_for] = ACTIONS(277),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_when] = ACTIONS(277),
    [anon_sym_elsif] = ACTIONS(277),
    [anon_sym_else] = ACTIONS(277),
    [anon_sym_begin] = ACTIONS(277),
    [anon_sym_ensure] = ACTIONS(277),
    [anon_sym_PLUS] = ACTIONS(277),
    [anon_sym_defined_QMARK] = ACTIONS(275),
    [anon_sym_not] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_TILDE] = ACTIONS(275),
    [sym_constant] = ACTIONS(277),
    [sym_identifier] = ACTIONS(277),
    [sym_instance_variable] = ACTIONS(275),
    [sym_class_variable] = ACTIONS(275),
    [sym_global_variable] = ACTIONS(275),
    [anon_sym_undef] = ACTIONS(277),
    [anon_sym_alias] = ACTIONS(277),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(277),
    [sym_float] = ACTIONS(277),
    [sym_complex] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_true] = ACTIONS(277),
    [anon_sym_TRUE] = ACTIONS(277),
    [anon_sym_false] = ACTIONS(277),
    [anon_sym_FALSE] = ACTIONS(277),
    [sym_self] = ACTIONS(277),
    [anon_sym_nil] = ACTIONS(277),
    [anon_sym_NIL] = ACTIONS(277),
    [sym_character] = ACTIONS(275),
    [anon_sym_LBRACK2] = ACTIONS(275),
    [anon_sym_DASH_GT] = ACTIONS(275),
  },
  [18] = {
    [sym_method] = STATE(184),
    [sym_singleton_method] = STATE(184),
    [sym_class] = STATE(184),
    [sym_singleton_class] = STATE(184),
    [sym_module] = STATE(184),
    [sym_return] = STATE(184),
    [sym_yield] = STATE(184),
    [sym_break] = STATE(184),
    [sym_next] = STATE(184),
    [sym_while] = STATE(184),
    [sym_until] = STATE(184),
    [sym_for] = STATE(184),
    [sym_case] = STATE(184),
    [sym_if] = STATE(184),
    [sym_unless] = STATE(184),
    [sym_begin] = STATE(184),
    [sym__primary] = STATE(184),
    [sym_parenthesized_statements] = STATE(184),
    [sym_element_reference] = STATE(186),
    [sym_scope_resolution] = STATE(185),
    [sym_call] = STATE(185),
    [sym_method_call] = STATE(186),
    [sym__lhs] = STATE(186),
    [sym__variable] = STATE(185),
    [sym_rational] = STATE(184),
    [sym_true] = STATE(186),
    [sym_false] = STATE(186),
    [sym_nil] = STATE(186),
    [sym_chained_string] = STATE(184),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(184),
    [sym_string_array] = STATE(184),
    [sym_symbol_array] = STATE(184),
    [sym_symbol] = STATE(184),
    [sym_regex] = STATE(184),
    [sym_array] = STATE(184),
    [sym_hash] = STATE(184),
    [sym_lambda] = STATE(184),
    [sym__simple_symbol] = ACTIONS(279),
    [sym__string_start] = ACTIONS(281),
    [sym__symbol_start] = ACTIONS(283),
    [sym__subshell_start] = ACTIONS(285),
    [sym__regex_start] = ACTIONS(287),
    [sym__string_array_start] = ACTIONS(289),
    [sym__symbol_array_start] = ACTIONS(291),
    [sym_heredoc_beginning] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_def] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(299),
    [anon_sym_COLON_COLON] = ACTIONS(301),
    [anon_sym_COMMA] = ACTIONS(303),
    [anon_sym_EQ] = ACTIONS(303),
    [anon_sym_class] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(307),
    [anon_sym_return] = ACTIONS(309),
    [anon_sym_yield] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_next] = ACTIONS(315),
    [sym_redo] = ACTIONS(317),
    [sym_retry] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(319),
    [anon_sym_unless] = ACTIONS(321),
    [anon_sym_while] = ACTIONS(323),
    [anon_sym_until] = ACTIONS(325),
    [anon_sym_for] = ACTIONS(327),
    [anon_sym_case] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(331),
    [sym_constant] = ACTIONS(333),
    [sym_identifier] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(317),
    [sym_complex] = ACTIONS(293),
    [sym_super] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(339),
    [anon_sym_TRUE] = ACTIONS(339),
    [anon_sym_false] = ACTIONS(341),
    [anon_sym_FALSE] = ACTIONS(341),
    [sym_self] = ACTIONS(333),
    [anon_sym_nil] = ACTIONS(343),
    [anon_sym_NIL] = ACTIONS(343),
    [sym_character] = ACTIONS(293),
    [anon_sym_LBRACK2] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(347),
  },
  [19] = {
    [sym_method] = STATE(191),
    [sym_singleton_method] = STATE(191),
    [sym_class] = STATE(191),
    [sym_singleton_class] = STATE(191),
    [sym_module] = STATE(191),
    [sym_return] = STATE(191),
    [sym_yield] = STATE(191),
    [sym_break] = STATE(191),
    [sym_next] = STATE(191),
    [sym_while] = STATE(191),
    [sym_until] = STATE(191),
    [sym_for] = STATE(191),
    [sym_case] = STATE(191),
    [sym_if] = STATE(191),
    [sym_unless] = STATE(191),
    [sym_begin] = STATE(191),
    [sym__primary] = STATE(191),
    [sym_parenthesized_statements] = STATE(191),
    [sym_element_reference] = STATE(191),
    [sym_scope_resolution] = STATE(192),
    [sym_call] = STATE(193),
    [sym_method_call] = STATE(191),
    [sym__lhs] = STATE(191),
    [sym__variable] = STATE(193),
    [sym_rational] = STATE(191),
    [sym_true] = STATE(191),
    [sym_false] = STATE(191),
    [sym_nil] = STATE(191),
    [sym_chained_string] = STATE(191),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(191),
    [sym_string_array] = STATE(191),
    [sym_symbol_array] = STATE(191),
    [sym_symbol] = STATE(191),
    [sym_regex] = STATE(191),
    [sym_array] = STATE(191),
    [sym_hash] = STATE(191),
    [sym_lambda] = STATE(191),
    [sym__simple_symbol] = ACTIONS(279),
    [sym__string_start] = ACTIONS(281),
    [sym__symbol_start] = ACTIONS(283),
    [sym__subshell_start] = ACTIONS(285),
    [sym__regex_start] = ACTIONS(287),
    [sym__string_array_start] = ACTIONS(289),
    [sym__symbol_array_start] = ACTIONS(291),
    [sym_heredoc_beginning] = ACTIONS(349),
    [sym__singleton_class_left_angle_left_langle] = ACTIONS(351),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_def] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(299),
    [anon_sym_COLON_COLON] = ACTIONS(353),
    [anon_sym_class] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(307),
    [anon_sym_return] = ACTIONS(309),
    [anon_sym_yield] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_next] = ACTIONS(315),
    [sym_redo] = ACTIONS(355),
    [sym_retry] = ACTIONS(355),
    [anon_sym_if] = ACTIONS(319),
    [anon_sym_unless] = ACTIONS(321),
    [anon_sym_while] = ACTIONS(323),
    [anon_sym_until] = ACTIONS(325),
    [anon_sym_for] = ACTIONS(327),
    [anon_sym_case] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(331),
    [sym_constant] = ACTIONS(357),
    [sym_identifier] = ACTIONS(359),
    [sym_instance_variable] = ACTIONS(361),
    [sym_class_variable] = ACTIONS(361),
    [sym_global_variable] = ACTIONS(361),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(355),
    [sym_complex] = ACTIONS(349),
    [sym_super] = ACTIONS(359),
    [anon_sym_true] = ACTIONS(339),
    [anon_sym_TRUE] = ACTIONS(339),
    [anon_sym_false] = ACTIONS(341),
    [anon_sym_FALSE] = ACTIONS(341),
    [sym_self] = ACTIONS(359),
    [anon_sym_nil] = ACTIONS(343),
    [anon_sym_NIL] = ACTIONS(343),
    [sym_character] = ACTIONS(349),
    [anon_sym_LBRACK2] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(347),
  },
  [20] = {
    [sym_method] = STATE(191),
    [sym_singleton_method] = STATE(191),
    [sym_class] = STATE(191),
    [sym_singleton_class] = STATE(191),
    [sym_module] = STATE(191),
    [sym_return] = STATE(191),
    [sym_yield] = STATE(191),
    [sym_break] = STATE(191),
    [sym_next] = STATE(191),
    [sym_while] = STATE(191),
    [sym_until] = STATE(191),
    [sym_for] = STATE(191),
    [sym_case] = STATE(191),
    [sym_if] = STATE(191),
    [sym_unless] = STATE(191),
    [sym_begin] = STATE(191),
    [sym__primary] = STATE(191),
    [sym_parenthesized_statements] = STATE(191),
    [sym_element_reference] = STATE(191),
    [sym_scope_resolution] = STATE(195),
    [sym_call] = STATE(193),
    [sym_method_call] = STATE(191),
    [sym__lhs] = STATE(191),
    [sym__variable] = STATE(193),
    [sym_rational] = STATE(191),
    [sym_true] = STATE(191),
    [sym_false] = STATE(191),
    [sym_nil] = STATE(191),
    [sym_chained_string] = STATE(191),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(191),
    [sym_string_array] = STATE(191),
    [sym_symbol_array] = STATE(191),
    [sym_symbol] = STATE(191),
    [sym_regex] = STATE(191),
    [sym_array] = STATE(191),
    [sym_hash] = STATE(191),
    [sym_lambda] = STATE(191),
    [sym__simple_symbol] = ACTIONS(279),
    [sym__string_start] = ACTIONS(281),
    [sym__symbol_start] = ACTIONS(283),
    [sym__subshell_start] = ACTIONS(285),
    [sym__regex_start] = ACTIONS(287),
    [sym__string_array_start] = ACTIONS(289),
    [sym__symbol_array_start] = ACTIONS(291),
    [sym_heredoc_beginning] = ACTIONS(349),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_def] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(299),
    [anon_sym_COLON_COLON] = ACTIONS(353),
    [anon_sym_class] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(307),
    [anon_sym_return] = ACTIONS(309),
    [anon_sym_yield] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_next] = ACTIONS(315),
    [sym_redo] = ACTIONS(355),
    [sym_retry] = ACTIONS(355),
    [anon_sym_if] = ACTIONS(319),
    [anon_sym_unless] = ACTIONS(321),
    [anon_sym_while] = ACTIONS(323),
    [anon_sym_until] = ACTIONS(325),
    [anon_sym_for] = ACTIONS(327),
    [anon_sym_case] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(331),
    [sym_constant] = ACTIONS(363),
    [sym_identifier] = ACTIONS(359),
    [sym_instance_variable] = ACTIONS(361),
    [sym_class_variable] = ACTIONS(361),
    [sym_global_variable] = ACTIONS(361),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(355),
    [sym_complex] = ACTIONS(349),
    [sym_super] = ACTIONS(359),
    [anon_sym_true] = ACTIONS(339),
    [anon_sym_TRUE] = ACTIONS(339),
    [anon_sym_false] = ACTIONS(341),
    [anon_sym_FALSE] = ACTIONS(341),
    [sym_self] = ACTIONS(359),
    [anon_sym_nil] = ACTIONS(343),
    [anon_sym_NIL] = ACTIONS(343),
    [sym_character] = ACTIONS(349),
    [anon_sym_LBRACK2] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(347),
  },
  [21] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(213),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(217),
    [sym__argument] = STATE(218),
    [sym_splat_argument] = STATE(218),
    [sym_hash_splat_argument] = STATE(218),
    [sym_block_argument] = STATE(218),
    [sym_assignment] = STATE(213),
    [sym_operator_assignment] = STATE(213),
    [sym_conditional] = STATE(213),
    [sym_range] = STATE(213),
    [sym_binary] = STATE(213),
    [sym_unary] = STATE(213),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(221),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(218),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(369),
    [sym__splat_star] = ACTIONS(371),
    [sym__unary_minus] = ACTIONS(373),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(375),
    [ts_builtin_sym_end] = ACTIONS(365),
    [anon_sym___END__] = ACTIONS(377),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(383),
    [anon_sym_yield] = ACTIONS(385),
    [anon_sym_break] = ACTIONS(387),
    [anon_sym_next] = ACTIONS(389),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(395),
    [anon_sym_not] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [sym_constant] = ACTIONS(403),
    [sym_identifier] = ACTIONS(403),
    [sym_instance_variable] = ACTIONS(405),
    [sym_class_variable] = ACTIONS(405),
    [sym_global_variable] = ACTIONS(405),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(407),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(407),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [22] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(213),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(217),
    [sym__argument] = STATE(218),
    [sym_splat_argument] = STATE(218),
    [sym_hash_splat_argument] = STATE(218),
    [sym_block_argument] = STATE(218),
    [sym_assignment] = STATE(213),
    [sym_operator_assignment] = STATE(213),
    [sym_conditional] = STATE(213),
    [sym_range] = STATE(213),
    [sym_binary] = STATE(213),
    [sym_unary] = STATE(213),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(221),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(218),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(369),
    [sym__splat_star] = ACTIONS(371),
    [sym__unary_minus] = ACTIONS(373),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(375),
    [ts_builtin_sym_end] = ACTIONS(417),
    [anon_sym___END__] = ACTIONS(419),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(383),
    [anon_sym_yield] = ACTIONS(385),
    [anon_sym_break] = ACTIONS(387),
    [anon_sym_next] = ACTIONS(389),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(395),
    [anon_sym_not] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [sym_constant] = ACTIONS(403),
    [sym_identifier] = ACTIONS(403),
    [sym_instance_variable] = ACTIONS(405),
    [sym_class_variable] = ACTIONS(405),
    [sym_global_variable] = ACTIONS(405),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(407),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(407),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [23] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(213),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(217),
    [sym__argument] = STATE(218),
    [sym_splat_argument] = STATE(218),
    [sym_hash_splat_argument] = STATE(218),
    [sym_block_argument] = STATE(218),
    [sym_assignment] = STATE(213),
    [sym_operator_assignment] = STATE(213),
    [sym_conditional] = STATE(213),
    [sym_range] = STATE(213),
    [sym_binary] = STATE(213),
    [sym_unary] = STATE(213),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(221),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(218),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(369),
    [sym__splat_star] = ACTIONS(371),
    [sym__unary_minus] = ACTIONS(373),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(375),
    [ts_builtin_sym_end] = ACTIONS(421),
    [anon_sym___END__] = ACTIONS(423),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(383),
    [anon_sym_yield] = ACTIONS(385),
    [anon_sym_break] = ACTIONS(387),
    [anon_sym_next] = ACTIONS(389),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(395),
    [anon_sym_not] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [sym_constant] = ACTIONS(403),
    [sym_identifier] = ACTIONS(403),
    [sym_instance_variable] = ACTIONS(405),
    [sym_class_variable] = ACTIONS(405),
    [sym_global_variable] = ACTIONS(405),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(407),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(407),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [24] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(213),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(217),
    [sym__argument] = STATE(218),
    [sym_splat_argument] = STATE(218),
    [sym_hash_splat_argument] = STATE(218),
    [sym_block_argument] = STATE(218),
    [sym_assignment] = STATE(213),
    [sym_operator_assignment] = STATE(213),
    [sym_conditional] = STATE(213),
    [sym_range] = STATE(213),
    [sym_binary] = STATE(213),
    [sym_unary] = STATE(213),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(221),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(218),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(369),
    [sym__splat_star] = ACTIONS(371),
    [sym__unary_minus] = ACTIONS(373),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(375),
    [ts_builtin_sym_end] = ACTIONS(425),
    [anon_sym___END__] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(383),
    [anon_sym_yield] = ACTIONS(385),
    [anon_sym_break] = ACTIONS(387),
    [anon_sym_next] = ACTIONS(389),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(395),
    [anon_sym_not] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [sym_constant] = ACTIONS(403),
    [sym_identifier] = ACTIONS(403),
    [sym_instance_variable] = ACTIONS(405),
    [sym_class_variable] = ACTIONS(405),
    [sym_global_variable] = ACTIONS(405),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(407),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(407),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [25] = {
    [sym_begin_block] = STATE(233),
    [sym_end_block] = STATE(233),
    [sym__statement] = STATE(233),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(233),
    [sym_unless_modifier] = STATE(233),
    [sym_while_modifier] = STATE(233),
    [sym_until_modifier] = STATE(233),
    [sym_rescue_modifier] = STATE(233),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(234),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(234),
    [sym_operator_assignment] = STATE(234),
    [sym_conditional] = STATE(234),
    [sym_range] = STATE(234),
    [sym_binary] = STATE(234),
    [sym_unary] = STATE(234),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_undef] = STATE(233),
    [sym_alias] = STATE(233),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(429),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_yield] = ACTIONS(433),
    [anon_sym_break] = ACTIONS(435),
    [anon_sym_next] = ACTIONS(437),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(439),
    [anon_sym_defined_QMARK] = ACTIONS(441),
    [anon_sym_not] = ACTIONS(443),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [anon_sym_undef] = ACTIONS(451),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [26] = {
    [sym_begin_block] = STATE(239),
    [sym_end_block] = STATE(239),
    [sym__statement] = STATE(239),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(239),
    [sym_unless_modifier] = STATE(239),
    [sym_while_modifier] = STATE(239),
    [sym_until_modifier] = STATE(239),
    [sym_rescue_modifier] = STATE(239),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(234),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(234),
    [sym_operator_assignment] = STATE(234),
    [sym_conditional] = STATE(234),
    [sym_range] = STATE(234),
    [sym_binary] = STATE(234),
    [sym_unary] = STATE(234),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_undef] = STATE(239),
    [sym_alias] = STATE(239),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(429),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_yield] = ACTIONS(433),
    [anon_sym_break] = ACTIONS(435),
    [anon_sym_next] = ACTIONS(437),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(439),
    [anon_sym_defined_QMARK] = ACTIONS(441),
    [anon_sym_not] = ACTIONS(443),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [anon_sym_undef] = ACTIONS(451),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [27] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(247),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(247),
    [sym_operator_assignment] = STATE(247),
    [sym_conditional] = STATE(247),
    [sym_range] = STATE(247),
    [sym_binary] = STATE(247),
    [sym_unary] = STATE(247),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(455),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_break] = ACTIONS(459),
    [anon_sym_next] = ACTIONS(461),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_defined_QMARK] = ACTIONS(465),
    [anon_sym_not] = ACTIONS(467),
    [anon_sym_BANG] = ACTIONS(469),
    [anon_sym_TILDE] = ACTIONS(469),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [28] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(252),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(252),
    [sym_operator_assignment] = STATE(252),
    [sym_conditional] = STATE(252),
    [sym_range] = STATE(252),
    [sym_binary] = STATE(252),
    [sym_unary] = STATE(252),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(455),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_break] = ACTIONS(459),
    [anon_sym_next] = ACTIONS(461),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_defined_QMARK] = ACTIONS(465),
    [anon_sym_not] = ACTIONS(467),
    [anon_sym_BANG] = ACTIONS(469),
    [anon_sym_TILDE] = ACTIONS(469),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [29] = {
    [sym_method] = STATE(184),
    [sym_singleton_method] = STATE(184),
    [sym_class] = STATE(184),
    [sym_singleton_class] = STATE(184),
    [sym_module] = STATE(184),
    [sym_return] = STATE(184),
    [sym_yield] = STATE(184),
    [sym_break] = STATE(184),
    [sym_next] = STATE(184),
    [sym_while] = STATE(184),
    [sym_until] = STATE(184),
    [sym_for] = STATE(184),
    [sym_case] = STATE(184),
    [sym_if] = STATE(184),
    [sym_unless] = STATE(184),
    [sym_begin] = STATE(184),
    [sym__primary] = STATE(184),
    [sym_parenthesized_statements] = STATE(184),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(255),
    [sym_call] = STATE(255),
    [sym_method_call] = STATE(258),
    [sym__mlhs] = STATE(256),
    [sym_destructured_left_assignment] = STATE(257),
    [sym_rest_assignment] = STATE(257),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(255),
    [sym_rational] = STATE(184),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(184),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(184),
    [sym_string_array] = STATE(184),
    [sym_symbol_array] = STATE(184),
    [sym_symbol] = STATE(184),
    [sym_regex] = STATE(184),
    [sym_array] = STATE(184),
    [sym_hash] = STATE(184),
    [sym_lambda] = STATE(184),
    [sym__simple_symbol] = ACTIONS(279),
    [sym__string_start] = ACTIONS(281),
    [sym__symbol_start] = ACTIONS(283),
    [sym__subshell_start] = ACTIONS(285),
    [sym__regex_start] = ACTIONS(287),
    [sym__string_array_start] = ACTIONS(289),
    [sym__symbol_array_start] = ACTIONS(291),
    [sym_heredoc_beginning] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_def] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(475),
    [anon_sym_COLON_COLON] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(477),
    [anon_sym_class] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(307),
    [anon_sym_return] = ACTIONS(309),
    [anon_sym_yield] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_next] = ACTIONS(315),
    [sym_redo] = ACTIONS(317),
    [sym_retry] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(319),
    [anon_sym_unless] = ACTIONS(321),
    [anon_sym_while] = ACTIONS(323),
    [anon_sym_until] = ACTIONS(325),
    [anon_sym_for] = ACTIONS(327),
    [anon_sym_case] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(331),
    [sym_constant] = ACTIONS(479),
    [sym_identifier] = ACTIONS(479),
    [sym_instance_variable] = ACTIONS(481),
    [sym_class_variable] = ACTIONS(481),
    [sym_global_variable] = ACTIONS(481),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(317),
    [sym_complex] = ACTIONS(293),
    [sym_super] = ACTIONS(479),
    [anon_sym_true] = ACTIONS(339),
    [anon_sym_TRUE] = ACTIONS(339),
    [anon_sym_false] = ACTIONS(341),
    [anon_sym_FALSE] = ACTIONS(341),
    [sym_self] = ACTIONS(479),
    [anon_sym_nil] = ACTIONS(343),
    [anon_sym_NIL] = ACTIONS(343),
    [sym_character] = ACTIONS(293),
    [anon_sym_LBRACK2] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(347),
  },
  [30] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(266),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(266),
    [sym_operator_assignment] = STATE(266),
    [sym_conditional] = STATE(266),
    [sym_range] = STATE(266),
    [sym_binary] = STATE(266),
    [sym_unary] = STATE(266),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_heredoc_body] = STATE(271),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__terminator] = STATE(271),
    [sym__line_break] = ACTIONS(483),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(485),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(483),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(495),
    [anon_sym_defined_QMARK] = ACTIONS(497),
    [anon_sym_not] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(501),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [31] = {
    [sym__statements] = STATE(284),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(286),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(287),
    [sym_rescue] = STATE(288),
    [sym__body_statement] = STATE(289),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_heredoc_body] = STATE(295),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [sym__terminator] = STATE(295),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__line_break] = ACTIONS(507),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(507),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(513),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [32] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(297),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(51),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(51),
    [sym_assignment] = STATE(297),
    [sym_operator_assignment] = STATE(297),
    [sym_conditional] = STATE(297),
    [sym_range] = STATE(297),
    [sym_binary] = STATE(297),
    [sym_unary] = STATE(297),
    [sym_left_assignment_list] = STATE(48),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(51),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(51),
    [sym_false] = STATE(51),
    [sym_nil] = STATE(51),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(52),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [33] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(298),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(51),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(51),
    [sym_assignment] = STATE(298),
    [sym_operator_assignment] = STATE(298),
    [sym_conditional] = STATE(298),
    [sym_range] = STATE(298),
    [sym_binary] = STATE(298),
    [sym_unary] = STATE(298),
    [sym_left_assignment_list] = STATE(48),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(51),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(51),
    [sym_false] = STATE(51),
    [sym_nil] = STATE(51),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(52),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [34] = {
    [sym_operator] = STATE(300),
    [sym__method_name] = STATE(300),
    [sym_setter] = STATE(300),
    [sym_symbol] = STATE(300),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(543),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(543),
    [sym_class_variable] = ACTIONS(543),
    [sym_global_variable] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [35] = {
    [sym_operator] = STATE(305),
    [sym__method_name] = STATE(305),
    [sym_setter] = STATE(305),
    [sym_symbol] = STATE(305),
    [sym__simple_symbol] = ACTIONS(547),
    [sym__symbol_start] = ACTIONS(549),
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_STAR] = ACTIONS(553),
    [anon_sym_STAR_STAR] = ACTIONS(551),
    [anon_sym_AMP] = ACTIONS(551),
    [anon_sym_LT] = ACTIONS(553),
    [anon_sym_DOT_DOT] = ACTIONS(551),
    [anon_sym_LT_LT] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(551),
    [anon_sym_EQ_EQ] = ACTIONS(553),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(551),
    [anon_sym_LT_EQ_GT] = ACTIONS(551),
    [anon_sym_EQ_TILDE] = ACTIONS(551),
    [anon_sym_BANG_TILDE] = ACTIONS(551),
    [anon_sym_LT_EQ] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(553),
    [anon_sym_GT_EQ] = ACTIONS(551),
    [anon_sym_CARET] = ACTIONS(551),
    [anon_sym_PLUS] = ACTIONS(553),
    [anon_sym_SLASH] = ACTIONS(551),
    [anon_sym_PERCENT] = ACTIONS(551),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(551),
    [sym_constant] = ACTIONS(555),
    [sym_identifier] = ACTIONS(557),
    [sym_instance_variable] = ACTIONS(555),
    [sym_class_variable] = ACTIONS(555),
    [sym_global_variable] = ACTIONS(555),
    [anon_sym_DASH] = ACTIONS(553),
    [anon_sym_PLUS_AT] = ACTIONS(551),
    [anon_sym_DASH_AT] = ACTIONS(551),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(553),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(551),
    [anon_sym_BQUOTE] = ACTIONS(551),
    [sym_comment] = ACTIONS(87),
  },
  [36] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(559),
    [anon_sym___END__] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_when] = ACTIONS(559),
    [anon_sym_elsif] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
    [anon_sym_r] = ACTIONS(563),
  },
  [37] = {
    [sym__line_break] = ACTIONS(565),
    [sym__heredoc_body_start] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(565),
    [sym__binary_star] = ACTIONS(565),
    [ts_builtin_sym_end] = ACTIONS(565),
    [anon_sym___END__] = ACTIONS(565),
    [anon_sym_LBRACE] = ACTIONS(565),
    [anon_sym_RBRACE] = ACTIONS(565),
    [anon_sym_RPAREN] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(567),
    [anon_sym_COMMA] = ACTIONS(565),
    [anon_sym_PIPE] = ACTIONS(567),
    [anon_sym_SEMI] = ACTIONS(565),
    [anon_sym_STAR_STAR] = ACTIONS(567),
    [anon_sym_AMP] = ACTIONS(567),
    [anon_sym_EQ] = ACTIONS(567),
    [anon_sym_LT] = ACTIONS(567),
    [anon_sym_end] = ACTIONS(565),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_unless] = ACTIONS(565),
    [anon_sym_while] = ACTIONS(565),
    [anon_sym_until] = ACTIONS(565),
    [anon_sym_rescue] = ACTIONS(565),
    [anon_sym_do] = ACTIONS(565),
    [anon_sym_when] = ACTIONS(565),
    [anon_sym_elsif] = ACTIONS(565),
    [anon_sym_else] = ACTIONS(565),
    [anon_sym_then] = ACTIONS(565),
    [anon_sym_ensure] = ACTIONS(565),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_COLON_COLON2] = ACTIONS(565),
    [anon_sym_AMP_DOT] = ACTIONS(565),
    [anon_sym_PLUS_EQ] = ACTIONS(565),
    [anon_sym_DASH_EQ] = ACTIONS(565),
    [anon_sym_STAR_EQ] = ACTIONS(565),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(565),
    [anon_sym_SLASH_EQ] = ACTIONS(565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(565),
    [anon_sym_PIPE_EQ] = ACTIONS(565),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(565),
    [anon_sym_AMP_EQ] = ACTIONS(565),
    [anon_sym_PERCENT_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_LT_LT_EQ] = ACTIONS(565),
    [anon_sym_CARET_EQ] = ACTIONS(565),
    [anon_sym_QMARK] = ACTIONS(565),
    [anon_sym_DOT_DOT] = ACTIONS(567),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(565),
    [anon_sym_and] = ACTIONS(565),
    [anon_sym_or] = ACTIONS(565),
    [anon_sym_PIPE_PIPE] = ACTIONS(567),
    [anon_sym_AMP_AMP] = ACTIONS(567),
    [anon_sym_LT_LT] = ACTIONS(567),
    [anon_sym_GT_GT] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(565),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(565),
    [anon_sym_LT_EQ_GT] = ACTIONS(565),
    [anon_sym_EQ_TILDE] = ACTIONS(565),
    [anon_sym_BANG_TILDE] = ACTIONS(565),
    [anon_sym_LT_EQ] = ACTIONS(567),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_GT_EQ] = ACTIONS(565),
    [anon_sym_CARET] = ACTIONS(567),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_SLASH] = ACTIONS(567),
    [anon_sym_PERCENT] = ACTIONS(567),
    [sym_comment] = ACTIONS(87),
  },
  [38] = {
    [sym__line_break] = ACTIONS(569),
    [sym__heredoc_body_start] = ACTIONS(569),
    [sym__binary_minus] = ACTIONS(569),
    [sym__binary_star] = ACTIONS(569),
    [ts_builtin_sym_end] = ACTIONS(569),
    [anon_sym___END__] = ACTIONS(569),
    [anon_sym_LBRACE] = ACTIONS(569),
    [anon_sym_RBRACE] = ACTIONS(569),
    [anon_sym_RPAREN] = ACTIONS(569),
    [anon_sym_DOT] = ACTIONS(571),
    [anon_sym_COMMA] = ACTIONS(569),
    [anon_sym_PIPE] = ACTIONS(571),
    [anon_sym_SEMI] = ACTIONS(569),
    [anon_sym_STAR_STAR] = ACTIONS(571),
    [anon_sym_AMP] = ACTIONS(571),
    [anon_sym_EQ] = ACTIONS(571),
    [anon_sym_LT] = ACTIONS(571),
    [anon_sym_end] = ACTIONS(569),
    [anon_sym_if] = ACTIONS(569),
    [anon_sym_unless] = ACTIONS(569),
    [anon_sym_while] = ACTIONS(569),
    [anon_sym_until] = ACTIONS(569),
    [anon_sym_rescue] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_when] = ACTIONS(569),
    [anon_sym_elsif] = ACTIONS(569),
    [anon_sym_else] = ACTIONS(569),
    [anon_sym_then] = ACTIONS(569),
    [anon_sym_ensure] = ACTIONS(569),
    [anon_sym_LBRACK] = ACTIONS(569),
    [anon_sym_COLON_COLON2] = ACTIONS(569),
    [anon_sym_AMP_DOT] = ACTIONS(569),
    [anon_sym_PLUS_EQ] = ACTIONS(569),
    [anon_sym_DASH_EQ] = ACTIONS(569),
    [anon_sym_STAR_EQ] = ACTIONS(569),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(569),
    [anon_sym_SLASH_EQ] = ACTIONS(569),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(569),
    [anon_sym_PIPE_EQ] = ACTIONS(569),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(569),
    [anon_sym_AMP_EQ] = ACTIONS(569),
    [anon_sym_PERCENT_EQ] = ACTIONS(569),
    [anon_sym_GT_GT_EQ] = ACTIONS(569),
    [anon_sym_LT_LT_EQ] = ACTIONS(569),
    [anon_sym_CARET_EQ] = ACTIONS(569),
    [anon_sym_QMARK] = ACTIONS(569),
    [anon_sym_DOT_DOT] = ACTIONS(571),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(569),
    [anon_sym_and] = ACTIONS(569),
    [anon_sym_or] = ACTIONS(569),
    [anon_sym_PIPE_PIPE] = ACTIONS(571),
    [anon_sym_AMP_AMP] = ACTIONS(571),
    [anon_sym_LT_LT] = ACTIONS(571),
    [anon_sym_GT_GT] = ACTIONS(571),
    [anon_sym_EQ_EQ] = ACTIONS(571),
    [anon_sym_BANG_EQ] = ACTIONS(569),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(569),
    [anon_sym_LT_EQ_GT] = ACTIONS(569),
    [anon_sym_EQ_TILDE] = ACTIONS(569),
    [anon_sym_BANG_TILDE] = ACTIONS(569),
    [anon_sym_LT_EQ] = ACTIONS(571),
    [anon_sym_GT] = ACTIONS(571),
    [anon_sym_GT_EQ] = ACTIONS(569),
    [anon_sym_CARET] = ACTIONS(571),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_SLASH] = ACTIONS(571),
    [anon_sym_PERCENT] = ACTIONS(571),
    [sym_comment] = ACTIONS(87),
  },
  [39] = {
    [sym__line_break] = ACTIONS(573),
    [sym__heredoc_body_start] = ACTIONS(573),
    [sym__binary_minus] = ACTIONS(573),
    [sym__binary_star] = ACTIONS(573),
    [ts_builtin_sym_end] = ACTIONS(573),
    [anon_sym___END__] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(573),
    [anon_sym_RBRACE] = ACTIONS(573),
    [anon_sym_RPAREN] = ACTIONS(573),
    [anon_sym_DOT] = ACTIONS(575),
    [anon_sym_COMMA] = ACTIONS(573),
    [anon_sym_PIPE] = ACTIONS(575),
    [anon_sym_SEMI] = ACTIONS(573),
    [anon_sym_STAR_STAR] = ACTIONS(575),
    [anon_sym_AMP] = ACTIONS(575),
    [anon_sym_EQ] = ACTIONS(575),
    [anon_sym_LT] = ACTIONS(575),
    [anon_sym_end] = ACTIONS(573),
    [anon_sym_if] = ACTIONS(573),
    [anon_sym_unless] = ACTIONS(573),
    [anon_sym_while] = ACTIONS(573),
    [anon_sym_until] = ACTIONS(573),
    [anon_sym_rescue] = ACTIONS(573),
    [anon_sym_do] = ACTIONS(573),
    [anon_sym_when] = ACTIONS(573),
    [anon_sym_elsif] = ACTIONS(573),
    [anon_sym_else] = ACTIONS(573),
    [anon_sym_then] = ACTIONS(573),
    [anon_sym_ensure] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(573),
    [anon_sym_COLON_COLON2] = ACTIONS(573),
    [anon_sym_AMP_DOT] = ACTIONS(573),
    [anon_sym_PLUS_EQ] = ACTIONS(573),
    [anon_sym_DASH_EQ] = ACTIONS(573),
    [anon_sym_STAR_EQ] = ACTIONS(573),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(573),
    [anon_sym_SLASH_EQ] = ACTIONS(573),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(573),
    [anon_sym_PIPE_EQ] = ACTIONS(573),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(573),
    [anon_sym_AMP_EQ] = ACTIONS(573),
    [anon_sym_PERCENT_EQ] = ACTIONS(573),
    [anon_sym_GT_GT_EQ] = ACTIONS(573),
    [anon_sym_LT_LT_EQ] = ACTIONS(573),
    [anon_sym_CARET_EQ] = ACTIONS(573),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_DOT_DOT] = ACTIONS(575),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(573),
    [anon_sym_and] = ACTIONS(573),
    [anon_sym_or] = ACTIONS(573),
    [anon_sym_PIPE_PIPE] = ACTIONS(575),
    [anon_sym_AMP_AMP] = ACTIONS(575),
    [anon_sym_LT_LT] = ACTIONS(575),
    [anon_sym_GT_GT] = ACTIONS(575),
    [anon_sym_EQ_EQ] = ACTIONS(575),
    [anon_sym_BANG_EQ] = ACTIONS(573),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(573),
    [anon_sym_LT_EQ_GT] = ACTIONS(573),
    [anon_sym_EQ_TILDE] = ACTIONS(573),
    [anon_sym_BANG_TILDE] = ACTIONS(573),
    [anon_sym_LT_EQ] = ACTIONS(575),
    [anon_sym_GT] = ACTIONS(575),
    [anon_sym_GT_EQ] = ACTIONS(573),
    [anon_sym_CARET] = ACTIONS(575),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(575),
    [anon_sym_PERCENT] = ACTIONS(575),
    [sym_comment] = ACTIONS(87),
  },
  [40] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(346),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(352),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(352),
    [sym__argument_list_with_trailing_comma] = STATE(349),
    [sym__argument] = STATE(350),
    [sym_splat_argument] = STATE(350),
    [sym_hash_splat_argument] = STATE(350),
    [sym_block_argument] = STATE(350),
    [sym_assignment] = STATE(346),
    [sym_operator_assignment] = STATE(346),
    [sym_conditional] = STATE(346),
    [sym_range] = STATE(346),
    [sym_binary] = STATE(346),
    [sym_unary] = STATE(346),
    [sym_left_assignment_list] = STATE(351),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(352),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(352),
    [sym_false] = STATE(352),
    [sym_nil] = STATE(352),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(353),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(350),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(593),
    [sym__splat_star] = ACTIONS(595),
    [sym__unary_minus] = ACTIONS(597),
    [sym__identifier_hash_key] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(639),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [41] = {
    [sym_lambda_parameters] = STATE(361),
    [sym__simple_formal_parameter] = STATE(362),
    [sym_splat_parameter] = STATE(362),
    [sym_hash_splat_parameter] = STATE(362),
    [sym_block_parameter] = STATE(362),
    [sym_keyword_parameter] = STATE(362),
    [sym_optional_parameter] = STATE(362),
    [sym_do_block] = STATE(363),
    [sym_block] = STATE(363),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [sym_identifier] = ACTIONS(679),
    [sym_comment] = ACTIONS(87),
  },
  [42] = {
    [ts_builtin_sym_end] = ACTIONS(681),
    [sym_comment] = ACTIONS(87),
  },
  [43] = {
    [ts_builtin_sym_end] = ACTIONS(683),
    [anon_sym___END__] = ACTIONS(685),
    [sym_comment] = ACTIONS(87),
  },
  [44] = {
    [sym_heredoc_body] = STATE(370),
    [sym__terminator] = STATE(370),
    [sym__line_break] = ACTIONS(687),
    [sym__heredoc_body_start] = ACTIONS(509),
    [ts_builtin_sym_end] = ACTIONS(689),
    [anon_sym___END__] = ACTIONS(689),
    [anon_sym_SEMI] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(691),
    [anon_sym_unless] = ACTIONS(693),
    [anon_sym_while] = ACTIONS(695),
    [anon_sym_until] = ACTIONS(697),
    [anon_sym_rescue] = ACTIONS(699),
    [sym_comment] = ACTIONS(87),
  },
  [45] = {
    [sym__line_break] = ACTIONS(701),
    [sym__heredoc_body_start] = ACTIONS(701),
    [sym__binary_minus] = ACTIONS(703),
    [sym__binary_star] = ACTIONS(705),
    [ts_builtin_sym_end] = ACTIONS(701),
    [anon_sym___END__] = ACTIONS(701),
    [anon_sym_PIPE] = ACTIONS(707),
    [anon_sym_SEMI] = ACTIONS(701),
    [anon_sym_STAR_STAR] = ACTIONS(705),
    [anon_sym_AMP] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_unless] = ACTIONS(701),
    [anon_sym_while] = ACTIONS(701),
    [anon_sym_until] = ACTIONS(701),
    [anon_sym_rescue] = ACTIONS(701),
    [anon_sym_QMARK] = ACTIONS(713),
    [anon_sym_DOT_DOT] = ACTIONS(715),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(717),
    [anon_sym_and] = ACTIONS(719),
    [anon_sym_or] = ACTIONS(719),
    [anon_sym_PIPE_PIPE] = ACTIONS(721),
    [anon_sym_AMP_AMP] = ACTIONS(721),
    [anon_sym_LT_LT] = ACTIONS(723),
    [anon_sym_GT_GT] = ACTIONS(723),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(721),
    [anon_sym_LT_EQ_GT] = ACTIONS(721),
    [anon_sym_EQ_TILDE] = ACTIONS(721),
    [anon_sym_BANG_TILDE] = ACTIONS(721),
    [anon_sym_LT_EQ] = ACTIONS(711),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_EQ] = ACTIONS(727),
    [anon_sym_CARET] = ACTIONS(729),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_SLASH] = ACTIONS(705),
    [anon_sym_PERCENT] = ACTIONS(705),
    [sym_comment] = ACTIONS(87),
  },
  [46] = {
    [sym__line_break] = ACTIONS(731),
    [sym__heredoc_body_start] = ACTIONS(731),
    [sym__binary_minus] = ACTIONS(731),
    [sym__binary_star] = ACTIONS(731),
    [ts_builtin_sym_end] = ACTIONS(731),
    [anon_sym___END__] = ACTIONS(731),
    [anon_sym_LBRACE] = ACTIONS(731),
    [anon_sym_RBRACE] = ACTIONS(731),
    [anon_sym_RPAREN] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(731),
    [anon_sym_PIPE] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(731),
    [anon_sym_STAR_STAR] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(735),
    [anon_sym_end] = ACTIONS(731),
    [anon_sym_if] = ACTIONS(731),
    [anon_sym_unless] = ACTIONS(731),
    [anon_sym_while] = ACTIONS(731),
    [anon_sym_until] = ACTIONS(731),
    [anon_sym_rescue] = ACTIONS(731),
    [anon_sym_do] = ACTIONS(731),
    [anon_sym_when] = ACTIONS(731),
    [anon_sym_elsif] = ACTIONS(731),
    [anon_sym_else] = ACTIONS(731),
    [anon_sym_then] = ACTIONS(731),
    [anon_sym_ensure] = ACTIONS(731),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_COLON_COLON2] = ACTIONS(739),
    [anon_sym_AMP_DOT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(731),
    [anon_sym_DOT_DOT] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(731),
    [anon_sym_or] = ACTIONS(731),
    [anon_sym_PIPE_PIPE] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(731),
    [anon_sym_LT_LT] = ACTIONS(731),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_EQ_EQ] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(731),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(731),
    [anon_sym_LT_EQ_GT] = ACTIONS(731),
    [anon_sym_EQ_TILDE] = ACTIONS(731),
    [anon_sym_BANG_TILDE] = ACTIONS(731),
    [anon_sym_LT_EQ] = ACTIONS(735),
    [anon_sym_GT] = ACTIONS(735),
    [anon_sym_GT_EQ] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(731),
    [anon_sym_SLASH] = ACTIONS(731),
    [anon_sym_PERCENT] = ACTIONS(731),
    [sym_comment] = ACTIONS(87),
  },
  [47] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(420),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(428),
    [sym_scope_resolution] = STATE(422),
    [sym_call] = STATE(422),
    [sym_method_call] = STATE(428),
    [sym_argument_list] = STATE(423),
    [sym__argument_list_with_parens] = STATE(424),
    [sym__argument] = STATE(425),
    [sym_splat_argument] = STATE(425),
    [sym_hash_splat_argument] = STATE(425),
    [sym_block_argument] = STATE(425),
    [sym_do_block] = STATE(426),
    [sym_block] = STATE(426),
    [sym_assignment] = STATE(420),
    [sym_operator_assignment] = STATE(420),
    [sym_conditional] = STATE(420),
    [sym_range] = STATE(420),
    [sym_binary] = STATE(420),
    [sym_unary] = STATE(420),
    [sym_left_assignment_list] = STATE(427),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(428),
    [sym__variable] = STATE(422),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(428),
    [sym_false] = STATE(428),
    [sym_nil] = STATE(428),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(429),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(425),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(743),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(761),
    [sym__splat_star] = ACTIONS(763),
    [sym__unary_minus] = ACTIONS(765),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(767),
    [ts_builtin_sym_end] = ACTIONS(743),
    [anon_sym___END__] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(771),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(781),
    [anon_sym_yield] = ACTIONS(783),
    [anon_sym_break] = ACTIONS(785),
    [anon_sym_next] = ACTIONS(787),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(769),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(769),
    [anon_sym_until] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(769),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(801),
    [anon_sym_not] = ACTIONS(803),
    [anon_sym_BANG] = ACTIONS(805),
    [anon_sym_TILDE] = ACTIONS(807),
    [sym_constant] = ACTIONS(809),
    [sym_identifier] = ACTIONS(809),
    [sym_instance_variable] = ACTIONS(811),
    [sym_class_variable] = ACTIONS(811),
    [sym_global_variable] = ACTIONS(811),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(815),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(815),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [48] = {
    [anon_sym_EQ] = ACTIONS(821),
    [sym_comment] = ACTIONS(87),
  },
  [49] = {
    [anon_sym_EQ] = ACTIONS(823),
    [sym_comment] = ACTIONS(87),
  },
  [50] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_EQ] = ACTIONS(827),
    [sym_comment] = ACTIONS(87),
  },
  [51] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(559),
    [anon_sym___END__] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(829),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(831),
    [anon_sym_DASH_EQ] = ACTIONS(831),
    [anon_sym_STAR_EQ] = ACTIONS(831),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(831),
    [anon_sym_SLASH_EQ] = ACTIONS(831),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(831),
    [anon_sym_PIPE_EQ] = ACTIONS(831),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(831),
    [anon_sym_AMP_EQ] = ACTIONS(831),
    [anon_sym_PERCENT_EQ] = ACTIONS(831),
    [anon_sym_GT_GT_EQ] = ACTIONS(831),
    [anon_sym_LT_LT_EQ] = ACTIONS(831),
    [anon_sym_CARET_EQ] = ACTIONS(831),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [52] = {
    [sym_string] = STATE(434),
    [aux_sym_chained_string_repeat1] = STATE(434),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(559),
    [anon_sym___END__] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [53] = {
    [sym_begin_block] = STATE(435),
    [sym_end_block] = STATE(435),
    [sym__statement] = STATE(435),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(435),
    [sym_unless_modifier] = STATE(435),
    [sym_while_modifier] = STATE(435),
    [sym_until_modifier] = STATE(435),
    [sym_rescue_modifier] = STATE(435),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(45),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(51),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(51),
    [sym_assignment] = STATE(45),
    [sym_operator_assignment] = STATE(45),
    [sym_conditional] = STATE(45),
    [sym_range] = STATE(45),
    [sym_binary] = STATE(45),
    [sym_unary] = STATE(45),
    [sym_left_assignment_list] = STATE(48),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(51),
    [sym__variable] = STATE(47),
    [sym_undef] = STATE(435),
    [sym_alias] = STATE(435),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(51),
    [sym_false] = STATE(51),
    [sym_nil] = STATE(51),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(52),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(436),
    [aux_sym__statements_repeat1] = STATE(436),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(21),
    [ts_builtin_sym_end] = ACTIONS(689),
    [anon_sym___END__] = ACTIONS(833),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [anon_sym_undef] = ACTIONS(83),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [54] = {
    [sym__line_break] = ACTIONS(835),
    [sym__string_start] = ACTIONS(835),
    [sym__heredoc_body_start] = ACTIONS(835),
    [sym__binary_minus] = ACTIONS(835),
    [sym__binary_star] = ACTIONS(835),
    [ts_builtin_sym_end] = ACTIONS(835),
    [anon_sym___END__] = ACTIONS(835),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_RBRACE] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(835),
    [anon_sym_DOT] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(835),
    [anon_sym_PIPE] = ACTIONS(837),
    [anon_sym_SEMI] = ACTIONS(835),
    [anon_sym_STAR_STAR] = ACTIONS(835),
    [anon_sym_AMP] = ACTIONS(837),
    [anon_sym_COLON] = ACTIONS(837),
    [anon_sym_LT] = ACTIONS(837),
    [anon_sym_end] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_unless] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_until] = ACTIONS(835),
    [anon_sym_rescue] = ACTIONS(835),
    [anon_sym_do] = ACTIONS(835),
    [anon_sym_when] = ACTIONS(835),
    [anon_sym_elsif] = ACTIONS(835),
    [anon_sym_else] = ACTIONS(835),
    [anon_sym_then] = ACTIONS(835),
    [anon_sym_ensure] = ACTIONS(835),
    [anon_sym_EQ_GT] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_COLON_COLON2] = ACTIONS(835),
    [anon_sym_AMP_DOT] = ACTIONS(835),
    [anon_sym_QMARK] = ACTIONS(835),
    [anon_sym_DOT_DOT] = ACTIONS(837),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(835),
    [anon_sym_and] = ACTIONS(835),
    [anon_sym_or] = ACTIONS(835),
    [anon_sym_PIPE_PIPE] = ACTIONS(835),
    [anon_sym_AMP_AMP] = ACTIONS(835),
    [anon_sym_LT_LT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(835),
    [anon_sym_EQ_EQ] = ACTIONS(837),
    [anon_sym_BANG_EQ] = ACTIONS(835),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(835),
    [anon_sym_LT_EQ_GT] = ACTIONS(835),
    [anon_sym_EQ_TILDE] = ACTIONS(835),
    [anon_sym_BANG_TILDE] = ACTIONS(835),
    [anon_sym_LT_EQ] = ACTIONS(837),
    [anon_sym_GT] = ACTIONS(837),
    [anon_sym_GT_EQ] = ACTIONS(835),
    [anon_sym_CARET] = ACTIONS(835),
    [anon_sym_PLUS] = ACTIONS(835),
    [anon_sym_SLASH] = ACTIONS(835),
    [anon_sym_PERCENT] = ACTIONS(835),
    [sym_comment] = ACTIONS(87),
  },
  [55] = {
    [sym_begin_block] = STATE(452),
    [sym_end_block] = STATE(452),
    [sym__statement] = STATE(452),
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_if_modifier] = STATE(452),
    [sym_unless_modifier] = STATE(452),
    [sym_while_modifier] = STATE(452),
    [sym_until_modifier] = STATE(452),
    [sym_rescue_modifier] = STATE(452),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(453),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(457),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym_method_call] = STATE(457),
    [sym_assignment] = STATE(453),
    [sym_operator_assignment] = STATE(453),
    [sym_conditional] = STATE(453),
    [sym_range] = STATE(453),
    [sym_binary] = STATE(453),
    [sym_unary] = STATE(453),
    [sym_left_assignment_list] = STATE(456),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(457),
    [sym__variable] = STATE(455),
    [sym_undef] = STATE(452),
    [sym_alias] = STATE(452),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(457),
    [sym_false] = STATE(457),
    [sym_nil] = STATE(457),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(458),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(841),
    [anon_sym_BEGIN] = ACTIONS(843),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_END] = ACTIONS(845),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_yield] = ACTIONS(851),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_next] = ACTIONS(855),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [anon_sym_undef] = ACTIONS(871),
    [anon_sym_alias] = ACTIONS(873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [56] = {
    [sym__string_end] = ACTIONS(881),
    [sym_comment] = ACTIONS(87),
  },
  [57] = {
    [sym_interpolation] = STATE(460),
    [aux_sym__literal_contents_repeat1] = STATE(460),
    [sym__string_content] = ACTIONS(883),
    [sym__string_end] = ACTIONS(885),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(883),
  },
  [58] = {
    [sym__line_break] = ACTIONS(887),
    [sym__heredoc_body_start] = ACTIONS(887),
    [sym__binary_minus] = ACTIONS(887),
    [sym__binary_star] = ACTIONS(887),
    [ts_builtin_sym_end] = ACTIONS(887),
    [anon_sym___END__] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(887),
    [anon_sym_RBRACE] = ACTIONS(887),
    [anon_sym_RPAREN] = ACTIONS(887),
    [anon_sym_DOT] = ACTIONS(889),
    [anon_sym_COMMA] = ACTIONS(887),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI] = ACTIONS(887),
    [anon_sym_STAR_STAR] = ACTIONS(887),
    [anon_sym_AMP] = ACTIONS(889),
    [anon_sym_LT] = ACTIONS(889),
    [anon_sym_end] = ACTIONS(887),
    [anon_sym_if] = ACTIONS(887),
    [anon_sym_unless] = ACTIONS(887),
    [anon_sym_while] = ACTIONS(887),
    [anon_sym_until] = ACTIONS(887),
    [anon_sym_rescue] = ACTIONS(887),
    [anon_sym_do] = ACTIONS(887),
    [anon_sym_when] = ACTIONS(887),
    [anon_sym_elsif] = ACTIONS(887),
    [anon_sym_else] = ACTIONS(887),
    [anon_sym_then] = ACTIONS(887),
    [anon_sym_ensure] = ACTIONS(887),
    [anon_sym_EQ_GT] = ACTIONS(887),
    [anon_sym_LBRACK] = ACTIONS(887),
    [anon_sym_COLON_COLON2] = ACTIONS(887),
    [anon_sym_AMP_DOT] = ACTIONS(887),
    [anon_sym_QMARK] = ACTIONS(887),
    [anon_sym_DOT_DOT] = ACTIONS(889),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(887),
    [anon_sym_and] = ACTIONS(887),
    [anon_sym_or] = ACTIONS(887),
    [anon_sym_PIPE_PIPE] = ACTIONS(887),
    [anon_sym_AMP_AMP] = ACTIONS(887),
    [anon_sym_LT_LT] = ACTIONS(887),
    [anon_sym_GT_GT] = ACTIONS(887),
    [anon_sym_EQ_EQ] = ACTIONS(889),
    [anon_sym_BANG_EQ] = ACTIONS(887),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(887),
    [anon_sym_LT_EQ_GT] = ACTIONS(887),
    [anon_sym_EQ_TILDE] = ACTIONS(887),
    [anon_sym_BANG_TILDE] = ACTIONS(887),
    [anon_sym_LT_EQ] = ACTIONS(889),
    [anon_sym_GT] = ACTIONS(889),
    [anon_sym_GT_EQ] = ACTIONS(887),
    [anon_sym_CARET] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_SLASH] = ACTIONS(887),
    [anon_sym_PERCENT] = ACTIONS(887),
    [sym_comment] = ACTIONS(87),
  },
  [59] = {
    [sym__string_end] = ACTIONS(891),
    [sym_comment] = ACTIONS(87),
  },
  [60] = {
    [sym__line_break] = ACTIONS(893),
    [sym__heredoc_body_start] = ACTIONS(893),
    [sym__binary_minus] = ACTIONS(893),
    [sym__binary_star] = ACTIONS(893),
    [ts_builtin_sym_end] = ACTIONS(893),
    [anon_sym___END__] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(893),
    [anon_sym_RBRACE] = ACTIONS(893),
    [anon_sym_RPAREN] = ACTIONS(893),
    [anon_sym_DOT] = ACTIONS(895),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_PIPE] = ACTIONS(895),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_STAR_STAR] = ACTIONS(893),
    [anon_sym_AMP] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(895),
    [anon_sym_end] = ACTIONS(893),
    [anon_sym_if] = ACTIONS(893),
    [anon_sym_unless] = ACTIONS(893),
    [anon_sym_while] = ACTIONS(893),
    [anon_sym_until] = ACTIONS(893),
    [anon_sym_rescue] = ACTIONS(893),
    [anon_sym_do] = ACTIONS(893),
    [anon_sym_when] = ACTIONS(893),
    [anon_sym_elsif] = ACTIONS(893),
    [anon_sym_else] = ACTIONS(893),
    [anon_sym_then] = ACTIONS(893),
    [anon_sym_ensure] = ACTIONS(893),
    [anon_sym_EQ_GT] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(893),
    [anon_sym_COLON_COLON2] = ACTIONS(893),
    [anon_sym_AMP_DOT] = ACTIONS(893),
    [anon_sym_QMARK] = ACTIONS(893),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(893),
    [anon_sym_and] = ACTIONS(893),
    [anon_sym_or] = ACTIONS(893),
    [anon_sym_PIPE_PIPE] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(893),
    [anon_sym_LT_LT] = ACTIONS(893),
    [anon_sym_GT_GT] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(895),
    [anon_sym_BANG_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_LT_EQ_GT] = ACTIONS(893),
    [anon_sym_EQ_TILDE] = ACTIONS(893),
    [anon_sym_BANG_TILDE] = ACTIONS(893),
    [anon_sym_LT_EQ] = ACTIONS(895),
    [anon_sym_GT] = ACTIONS(895),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_CARET] = ACTIONS(893),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_SLASH] = ACTIONS(893),
    [anon_sym_PERCENT] = ACTIONS(893),
    [sym_comment] = ACTIONS(87),
  },
  [61] = {
    [sym__string_end] = ACTIONS(897),
    [sym_comment] = ACTIONS(87),
  },
  [62] = {
    [sym__line_break] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(899),
    [sym__binary_minus] = ACTIONS(899),
    [sym__binary_star] = ACTIONS(899),
    [ts_builtin_sym_end] = ACTIONS(899),
    [anon_sym___END__] = ACTIONS(899),
    [anon_sym_LBRACE] = ACTIONS(899),
    [anon_sym_RBRACE] = ACTIONS(899),
    [anon_sym_RPAREN] = ACTIONS(899),
    [anon_sym_DOT] = ACTIONS(901),
    [anon_sym_COMMA] = ACTIONS(899),
    [anon_sym_PIPE] = ACTIONS(901),
    [anon_sym_SEMI] = ACTIONS(899),
    [anon_sym_STAR_STAR] = ACTIONS(899),
    [anon_sym_AMP] = ACTIONS(901),
    [anon_sym_LT] = ACTIONS(901),
    [anon_sym_end] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(899),
    [anon_sym_unless] = ACTIONS(899),
    [anon_sym_while] = ACTIONS(899),
    [anon_sym_until] = ACTIONS(899),
    [anon_sym_rescue] = ACTIONS(899),
    [anon_sym_do] = ACTIONS(899),
    [anon_sym_when] = ACTIONS(899),
    [anon_sym_elsif] = ACTIONS(899),
    [anon_sym_else] = ACTIONS(899),
    [anon_sym_then] = ACTIONS(899),
    [anon_sym_ensure] = ACTIONS(899),
    [anon_sym_EQ_GT] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(899),
    [anon_sym_COLON_COLON2] = ACTIONS(899),
    [anon_sym_AMP_DOT] = ACTIONS(899),
    [anon_sym_QMARK] = ACTIONS(899),
    [anon_sym_DOT_DOT] = ACTIONS(901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(899),
    [anon_sym_and] = ACTIONS(899),
    [anon_sym_or] = ACTIONS(899),
    [anon_sym_PIPE_PIPE] = ACTIONS(899),
    [anon_sym_AMP_AMP] = ACTIONS(899),
    [anon_sym_LT_LT] = ACTIONS(899),
    [anon_sym_GT_GT] = ACTIONS(899),
    [anon_sym_EQ_EQ] = ACTIONS(901),
    [anon_sym_BANG_EQ] = ACTIONS(899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(899),
    [anon_sym_LT_EQ_GT] = ACTIONS(899),
    [anon_sym_EQ_TILDE] = ACTIONS(899),
    [anon_sym_BANG_TILDE] = ACTIONS(899),
    [anon_sym_LT_EQ] = ACTIONS(901),
    [anon_sym_GT] = ACTIONS(901),
    [anon_sym_GT_EQ] = ACTIONS(899),
    [anon_sym_CARET] = ACTIONS(899),
    [anon_sym_PLUS] = ACTIONS(899),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [sym_comment] = ACTIONS(87),
  },
  [63] = {
    [sym__string_end] = ACTIONS(903),
    [sym_comment] = ACTIONS(87),
  },
  [64] = {
    [sym__line_break] = ACTIONS(905),
    [sym__heredoc_body_start] = ACTIONS(905),
    [sym__binary_minus] = ACTIONS(905),
    [sym__binary_star] = ACTIONS(905),
    [ts_builtin_sym_end] = ACTIONS(905),
    [anon_sym___END__] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(905),
    [anon_sym_RBRACE] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(905),
    [anon_sym_DOT] = ACTIONS(907),
    [anon_sym_COMMA] = ACTIONS(905),
    [anon_sym_PIPE] = ACTIONS(907),
    [anon_sym_SEMI] = ACTIONS(905),
    [anon_sym_STAR_STAR] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_LT] = ACTIONS(907),
    [anon_sym_end] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_unless] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_until] = ACTIONS(905),
    [anon_sym_rescue] = ACTIONS(905),
    [anon_sym_do] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(905),
    [anon_sym_elsif] = ACTIONS(905),
    [anon_sym_else] = ACTIONS(905),
    [anon_sym_then] = ACTIONS(905),
    [anon_sym_ensure] = ACTIONS(905),
    [anon_sym_EQ_GT] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_COLON_COLON2] = ACTIONS(905),
    [anon_sym_AMP_DOT] = ACTIONS(905),
    [anon_sym_QMARK] = ACTIONS(905),
    [anon_sym_DOT_DOT] = ACTIONS(907),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(905),
    [anon_sym_and] = ACTIONS(905),
    [anon_sym_or] = ACTIONS(905),
    [anon_sym_PIPE_PIPE] = ACTIONS(905),
    [anon_sym_AMP_AMP] = ACTIONS(905),
    [anon_sym_LT_LT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(905),
    [anon_sym_EQ_EQ] = ACTIONS(907),
    [anon_sym_BANG_EQ] = ACTIONS(905),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(905),
    [anon_sym_LT_EQ_GT] = ACTIONS(905),
    [anon_sym_EQ_TILDE] = ACTIONS(905),
    [anon_sym_BANG_TILDE] = ACTIONS(905),
    [anon_sym_LT_EQ] = ACTIONS(907),
    [anon_sym_GT] = ACTIONS(907),
    [anon_sym_GT_EQ] = ACTIONS(905),
    [anon_sym_CARET] = ACTIONS(905),
    [anon_sym_PLUS] = ACTIONS(905),
    [anon_sym_SLASH] = ACTIONS(905),
    [anon_sym_PERCENT] = ACTIONS(905),
    [sym_comment] = ACTIONS(87),
  },
  [65] = {
    [sym_begin_block] = STATE(464),
    [sym_end_block] = STATE(464),
    [sym__statement] = STATE(464),
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_if_modifier] = STATE(464),
    [sym_unless_modifier] = STATE(464),
    [sym_while_modifier] = STATE(464),
    [sym_until_modifier] = STATE(464),
    [sym_rescue_modifier] = STATE(464),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(453),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(457),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym_method_call] = STATE(457),
    [sym_assignment] = STATE(453),
    [sym_operator_assignment] = STATE(453),
    [sym_conditional] = STATE(453),
    [sym_range] = STATE(453),
    [sym_binary] = STATE(453),
    [sym_unary] = STATE(453),
    [sym_left_assignment_list] = STATE(456),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(457),
    [sym__variable] = STATE(455),
    [sym_undef] = STATE(464),
    [sym_alias] = STATE(464),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(457),
    [sym_false] = STATE(457),
    [sym_nil] = STATE(457),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(458),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(841),
    [anon_sym_BEGIN] = ACTIONS(843),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_END] = ACTIONS(845),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_yield] = ACTIONS(851),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_next] = ACTIONS(855),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [anon_sym_undef] = ACTIONS(871),
    [anon_sym_alias] = ACTIONS(873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [66] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(467),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(909),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(911),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [67] = {
    [aux_sym_string_array_repeat1] = STATE(470),
    [sym__string_end] = ACTIONS(913),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(915),
  },
  [68] = {
    [sym_interpolation] = STATE(471),
    [aux_sym__literal_contents_repeat1] = STATE(471),
    [sym__string_content] = ACTIONS(917),
    [sym__string_end] = ACTIONS(885),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(919),
    [sym_escape_sequence] = ACTIONS(921),
  },
  [69] = {
    [sym__line_break] = ACTIONS(923),
    [sym__heredoc_body_start] = ACTIONS(923),
    [sym__binary_minus] = ACTIONS(923),
    [sym__binary_star] = ACTIONS(923),
    [ts_builtin_sym_end] = ACTIONS(923),
    [anon_sym___END__] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(923),
    [anon_sym_RBRACE] = ACTIONS(923),
    [anon_sym_RPAREN] = ACTIONS(923),
    [anon_sym_DOT] = ACTIONS(925),
    [anon_sym_COMMA] = ACTIONS(923),
    [anon_sym_PIPE] = ACTIONS(925),
    [anon_sym_SEMI] = ACTIONS(923),
    [anon_sym_STAR_STAR] = ACTIONS(923),
    [anon_sym_AMP] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(925),
    [anon_sym_end] = ACTIONS(923),
    [anon_sym_if] = ACTIONS(923),
    [anon_sym_unless] = ACTIONS(923),
    [anon_sym_while] = ACTIONS(923),
    [anon_sym_until] = ACTIONS(923),
    [anon_sym_rescue] = ACTIONS(923),
    [anon_sym_do] = ACTIONS(923),
    [anon_sym_when] = ACTIONS(923),
    [anon_sym_elsif] = ACTIONS(923),
    [anon_sym_else] = ACTIONS(923),
    [anon_sym_then] = ACTIONS(923),
    [anon_sym_ensure] = ACTIONS(923),
    [anon_sym_EQ_GT] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(923),
    [anon_sym_COLON_COLON2] = ACTIONS(923),
    [anon_sym_AMP_DOT] = ACTIONS(923),
    [anon_sym_QMARK] = ACTIONS(923),
    [anon_sym_DOT_DOT] = ACTIONS(925),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(923),
    [anon_sym_and] = ACTIONS(923),
    [anon_sym_or] = ACTIONS(923),
    [anon_sym_PIPE_PIPE] = ACTIONS(923),
    [anon_sym_AMP_AMP] = ACTIONS(923),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_EQ_EQ] = ACTIONS(925),
    [anon_sym_BANG_EQ] = ACTIONS(923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(923),
    [anon_sym_LT_EQ_GT] = ACTIONS(923),
    [anon_sym_EQ_TILDE] = ACTIONS(923),
    [anon_sym_BANG_TILDE] = ACTIONS(923),
    [anon_sym_LT_EQ] = ACTIONS(925),
    [anon_sym_GT] = ACTIONS(925),
    [anon_sym_GT_EQ] = ACTIONS(923),
    [anon_sym_CARET] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(923),
    [anon_sym_SLASH] = ACTIONS(923),
    [anon_sym_PERCENT] = ACTIONS(923),
    [sym_comment] = ACTIONS(87),
  },
  [70] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(474),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(927),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(929),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [71] = {
    [aux_sym_symbol_array_repeat1] = STATE(477),
    [sym__string_end] = ACTIONS(931),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(933),
  },
  [72] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [ts_builtin_sym_end] = ACTIONS(935),
    [anon_sym___END__] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(705),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [73] = {
    [sym_uninterpreted] = ACTIONS(939),
    [sym_comment] = ACTIONS(109),
  },
  [74] = {
    [sym__statements] = STATE(488),
    [sym_begin_block] = STATE(489),
    [sym_end_block] = STATE(489),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(495),
    [aux_sym__statements_repeat1] = STATE(495),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(943),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [75] = {
    [sym__binary_minus] = ACTIONS(101),
    [sym__binary_star] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_RBRACE] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(103),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_PIPE] = ACTIONS(103),
    [anon_sym_SEMI] = ACTIONS(101),
    [anon_sym_STAR_STAR] = ACTIONS(101),
    [anon_sym_AMP] = ACTIONS(103),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_unless] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_until] = ACTIONS(101),
    [anon_sym_rescue] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(101),
    [anon_sym_EQ_GT] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_COLON_COLON2] = ACTIONS(101),
    [anon_sym_AMP_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(103),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_and] = ACTIONS(101),
    [anon_sym_or] = ACTIONS(101),
    [anon_sym_PIPE_PIPE] = ACTIONS(101),
    [anon_sym_AMP_AMP] = ACTIONS(101),
    [anon_sym_LT_LT] = ACTIONS(101),
    [anon_sym_GT_GT] = ACTIONS(101),
    [anon_sym_EQ_EQ] = ACTIONS(103),
    [anon_sym_BANG_EQ] = ACTIONS(101),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(101),
    [anon_sym_LT_EQ_GT] = ACTIONS(101),
    [anon_sym_EQ_TILDE] = ACTIONS(101),
    [anon_sym_BANG_TILDE] = ACTIONS(101),
    [anon_sym_LT_EQ] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_EQ] = ACTIONS(101),
    [anon_sym_CARET] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(101),
    [anon_sym_PERCENT] = ACTIONS(101),
    [sym_comment] = ACTIONS(87),
  },
  [76] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(497),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(967),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [77] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(499),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(969),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [78] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(501),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(971),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [79] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(503),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(973),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [80] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(506),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(975),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(977),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [81] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(509),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(979),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(981),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [82] = {
    [sym_interpolation] = STATE(512),
    [aux_sym_heredoc_body_repeat1] = STATE(512),
    [sym__heredoc_content] = ACTIONS(983),
    [sym_heredoc_end] = ACTIONS(985),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(983),
  },
  [83] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(513),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(118),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(118),
    [sym_assignment] = STATE(513),
    [sym_operator_assignment] = STATE(513),
    [sym_conditional] = STATE(513),
    [sym_range] = STATE(513),
    [sym_binary] = STATE(513),
    [sym_unary] = STATE(513),
    [sym_left_assignment_list] = STATE(117),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(118),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(118),
    [sym_false] = STATE(118),
    [sym_nil] = STATE(118),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(514),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [84] = {
    [anon_sym_COLON] = ACTIONS(989),
    [sym_comment] = ACTIONS(87),
  },
  [85] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(113),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(118),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(118),
    [sym_hash_splat_argument] = STATE(116),
    [sym_assignment] = STATE(113),
    [sym_operator_assignment] = STATE(113),
    [sym_conditional] = STATE(113),
    [sym_range] = STATE(113),
    [sym_binary] = STATE(113),
    [sym_unary] = STATE(113),
    [sym_left_assignment_list] = STATE(117),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(118),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(118),
    [sym_false] = STATE(118),
    [sym_nil] = STATE(118),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(119),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_heredoc_body] = STATE(517),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym__hash_items] = STATE(518),
    [sym_pair] = STATE(122),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [sym__identifier_hash_key] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_RBRACE] = ACTIONS(991),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(209),
    [sym_identifier] = ACTIONS(209),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [86] = {
    [sym__line_break] = ACTIONS(993),
    [sym__heredoc_body_start] = ACTIONS(993),
    [sym__binary_minus] = ACTIONS(993),
    [sym__binary_star] = ACTIONS(993),
    [ts_builtin_sym_end] = ACTIONS(993),
    [anon_sym___END__] = ACTIONS(993),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_RBRACE] = ACTIONS(993),
    [anon_sym_RPAREN] = ACTIONS(993),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(993),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_SEMI] = ACTIONS(993),
    [anon_sym_STAR_STAR] = ACTIONS(993),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(995),
    [anon_sym_end] = ACTIONS(993),
    [anon_sym_if] = ACTIONS(993),
    [anon_sym_unless] = ACTIONS(993),
    [anon_sym_while] = ACTIONS(993),
    [anon_sym_until] = ACTIONS(993),
    [anon_sym_rescue] = ACTIONS(993),
    [anon_sym_do] = ACTIONS(993),
    [anon_sym_when] = ACTIONS(993),
    [anon_sym_elsif] = ACTIONS(993),
    [anon_sym_else] = ACTIONS(993),
    [anon_sym_then] = ACTIONS(993),
    [anon_sym_ensure] = ACTIONS(993),
    [anon_sym_EQ_GT] = ACTIONS(993),
    [anon_sym_LBRACK] = ACTIONS(993),
    [anon_sym_COLON_COLON2] = ACTIONS(993),
    [anon_sym_AMP_DOT] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(993),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(993),
    [anon_sym_and] = ACTIONS(993),
    [anon_sym_or] = ACTIONS(993),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_AMP_AMP] = ACTIONS(993),
    [anon_sym_LT_LT] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(993),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(993),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(993),
    [anon_sym_LT_EQ_GT] = ACTIONS(993),
    [anon_sym_EQ_TILDE] = ACTIONS(993),
    [anon_sym_BANG_TILDE] = ACTIONS(993),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(993),
    [anon_sym_CARET] = ACTIONS(993),
    [anon_sym_PLUS] = ACTIONS(993),
    [anon_sym_SLASH] = ACTIONS(993),
    [anon_sym_PERCENT] = ACTIONS(993),
    [sym_comment] = ACTIONS(87),
  },
  [87] = {
    [sym__method_rest] = STATE(520),
    [sym__variable] = STATE(521),
    [sym_operator] = STATE(522),
    [sym__method_name] = STATE(522),
    [sym_setter] = STATE(522),
    [sym_symbol] = STATE(522),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(239),
    [sym_identifier] = ACTIONS(241),
    [sym_instance_variable] = ACTIONS(239),
    [sym_class_variable] = ACTIONS(239),
    [sym_global_variable] = ACTIONS(239),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
    [sym_super] = ACTIONS(999),
    [sym_self] = ACTIONS(999),
  },
  [88] = {
    [sym__statements] = STATE(524),
    [sym_begin_block] = STATE(144),
    [sym_end_block] = STATE(144),
    [sym__statement] = STATE(144),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(144),
    [sym_unless_modifier] = STATE(144),
    [sym_while_modifier] = STATE(144),
    [sym_until_modifier] = STATE(144),
    [sym_rescue_modifier] = STATE(144),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(145),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(150),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(150),
    [sym_assignment] = STATE(145),
    [sym_operator_assignment] = STATE(145),
    [sym_conditional] = STATE(145),
    [sym_range] = STATE(145),
    [sym_binary] = STATE(145),
    [sym_unary] = STATE(145),
    [sym_left_assignment_list] = STATE(147),
    [sym__mlhs] = STATE(148),
    [sym_destructured_left_assignment] = STATE(149),
    [sym_rest_assignment] = STATE(149),
    [sym__lhs] = STATE(150),
    [sym__variable] = STATE(146),
    [sym_undef] = STATE(144),
    [sym_alias] = STATE(144),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(150),
    [sym_false] = STATE(150),
    [sym_nil] = STATE(150),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(151),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(152),
    [aux_sym__statements_repeat1] = STATE(152),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_RPAREN] = ACTIONS(1001),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(249),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [anon_sym_undef] = ACTIONS(271),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [89] = {
    [sym_constant] = ACTIONS(1003),
    [sym_identifier] = ACTIONS(1003),
    [sym_comment] = ACTIONS(87),
  },
  [90] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(537),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(541),
    [sym_scope_resolution] = STATE(539),
    [sym_call] = STATE(539),
    [sym_method_call] = STATE(541),
    [sym_assignment] = STATE(537),
    [sym_operator_assignment] = STATE(537),
    [sym_conditional] = STATE(537),
    [sym_range] = STATE(537),
    [sym_binary] = STATE(537),
    [sym_unary] = STATE(537),
    [sym_left_assignment_list] = STATE(540),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(541),
    [sym__variable] = STATE(539),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(541),
    [sym_false] = STATE(541),
    [sym_nil] = STATE(541),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(542),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1021),
    [anon_sym_defined_QMARK] = ACTIONS(1023),
    [anon_sym_not] = ACTIONS(1025),
    [anon_sym_BANG] = ACTIONS(1027),
    [anon_sym_TILDE] = ACTIONS(1027),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [91] = {
    [sym_method] = STATE(191),
    [sym_singleton_method] = STATE(191),
    [sym_class] = STATE(191),
    [sym_singleton_class] = STATE(191),
    [sym_module] = STATE(191),
    [sym_return] = STATE(191),
    [sym_yield] = STATE(191),
    [sym_break] = STATE(191),
    [sym_next] = STATE(191),
    [sym_while] = STATE(191),
    [sym_until] = STATE(191),
    [sym_for] = STATE(191),
    [sym_case] = STATE(191),
    [sym_if] = STATE(191),
    [sym_unless] = STATE(191),
    [sym_begin] = STATE(191),
    [sym__primary] = STATE(191),
    [sym_parenthesized_statements] = STATE(191),
    [sym_element_reference] = STATE(191),
    [sym_scope_resolution] = STATE(545),
    [sym_call] = STATE(193),
    [sym_method_call] = STATE(191),
    [sym__lhs] = STATE(191),
    [sym__variable] = STATE(193),
    [sym_rational] = STATE(191),
    [sym_true] = STATE(191),
    [sym_false] = STATE(191),
    [sym_nil] = STATE(191),
    [sym_chained_string] = STATE(191),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(191),
    [sym_string_array] = STATE(191),
    [sym_symbol_array] = STATE(191),
    [sym_symbol] = STATE(191),
    [sym_regex] = STATE(191),
    [sym_array] = STATE(191),
    [sym_hash] = STATE(191),
    [sym_lambda] = STATE(191),
    [sym__simple_symbol] = ACTIONS(279),
    [sym__string_start] = ACTIONS(281),
    [sym__symbol_start] = ACTIONS(283),
    [sym__subshell_start] = ACTIONS(285),
    [sym__regex_start] = ACTIONS(287),
    [sym__string_array_start] = ACTIONS(289),
    [sym__symbol_array_start] = ACTIONS(291),
    [sym_heredoc_beginning] = ACTIONS(349),
    [sym__singleton_class_left_angle_left_langle] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_def] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(299),
    [anon_sym_COLON_COLON] = ACTIONS(353),
    [anon_sym_class] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(307),
    [anon_sym_return] = ACTIONS(309),
    [anon_sym_yield] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_next] = ACTIONS(315),
    [sym_redo] = ACTIONS(355),
    [sym_retry] = ACTIONS(355),
    [anon_sym_if] = ACTIONS(319),
    [anon_sym_unless] = ACTIONS(321),
    [anon_sym_while] = ACTIONS(323),
    [anon_sym_until] = ACTIONS(325),
    [anon_sym_for] = ACTIONS(327),
    [anon_sym_case] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(331),
    [sym_constant] = ACTIONS(1041),
    [sym_identifier] = ACTIONS(359),
    [sym_instance_variable] = ACTIONS(361),
    [sym_class_variable] = ACTIONS(361),
    [sym_global_variable] = ACTIONS(361),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(355),
    [sym_complex] = ACTIONS(349),
    [sym_super] = ACTIONS(359),
    [anon_sym_true] = ACTIONS(339),
    [anon_sym_TRUE] = ACTIONS(339),
    [anon_sym_false] = ACTIONS(341),
    [anon_sym_FALSE] = ACTIONS(341),
    [sym_self] = ACTIONS(359),
    [anon_sym_nil] = ACTIONS(343),
    [anon_sym_NIL] = ACTIONS(343),
    [sym_character] = ACTIONS(349),
    [anon_sym_LBRACK2] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(347),
  },
  [92] = {
    [sym_method] = STATE(191),
    [sym_singleton_method] = STATE(191),
    [sym_class] = STATE(191),
    [sym_singleton_class] = STATE(191),
    [sym_module] = STATE(191),
    [sym_return] = STATE(191),
    [sym_yield] = STATE(191),
    [sym_break] = STATE(191),
    [sym_next] = STATE(191),
    [sym_while] = STATE(191),
    [sym_until] = STATE(191),
    [sym_for] = STATE(191),
    [sym_case] = STATE(191),
    [sym_if] = STATE(191),
    [sym_unless] = STATE(191),
    [sym_begin] = STATE(191),
    [sym__primary] = STATE(191),
    [sym_parenthesized_statements] = STATE(191),
    [sym_element_reference] = STATE(191),
    [sym_scope_resolution] = STATE(547),
    [sym_call] = STATE(193),
    [sym_method_call] = STATE(191),
    [sym__lhs] = STATE(191),
    [sym__variable] = STATE(193),
    [sym_rational] = STATE(191),
    [sym_true] = STATE(191),
    [sym_false] = STATE(191),
    [sym_nil] = STATE(191),
    [sym_chained_string] = STATE(191),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(191),
    [sym_string_array] = STATE(191),
    [sym_symbol_array] = STATE(191),
    [sym_symbol] = STATE(191),
    [sym_regex] = STATE(191),
    [sym_array] = STATE(191),
    [sym_hash] = STATE(191),
    [sym_lambda] = STATE(191),
    [sym__simple_symbol] = ACTIONS(279),
    [sym__string_start] = ACTIONS(281),
    [sym__symbol_start] = ACTIONS(283),
    [sym__subshell_start] = ACTIONS(285),
    [sym__regex_start] = ACTIONS(287),
    [sym__string_array_start] = ACTIONS(289),
    [sym__symbol_array_start] = ACTIONS(291),
    [sym_heredoc_beginning] = ACTIONS(349),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_def] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(299),
    [anon_sym_COLON_COLON] = ACTIONS(353),
    [anon_sym_class] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(307),
    [anon_sym_return] = ACTIONS(309),
    [anon_sym_yield] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_next] = ACTIONS(315),
    [sym_redo] = ACTIONS(355),
    [sym_retry] = ACTIONS(355),
    [anon_sym_if] = ACTIONS(319),
    [anon_sym_unless] = ACTIONS(321),
    [anon_sym_while] = ACTIONS(323),
    [anon_sym_until] = ACTIONS(325),
    [anon_sym_for] = ACTIONS(327),
    [anon_sym_case] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(331),
    [sym_constant] = ACTIONS(1043),
    [sym_identifier] = ACTIONS(359),
    [sym_instance_variable] = ACTIONS(361),
    [sym_class_variable] = ACTIONS(361),
    [sym_global_variable] = ACTIONS(361),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(355),
    [sym_complex] = ACTIONS(349),
    [sym_super] = ACTIONS(359),
    [anon_sym_true] = ACTIONS(339),
    [anon_sym_TRUE] = ACTIONS(339),
    [anon_sym_false] = ACTIONS(341),
    [anon_sym_FALSE] = ACTIONS(341),
    [sym_self] = ACTIONS(359),
    [anon_sym_nil] = ACTIONS(343),
    [anon_sym_NIL] = ACTIONS(343),
    [sym_character] = ACTIONS(349),
    [anon_sym_LBRACK2] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(347),
  },
  [93] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(561),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(567),
    [sym_scope_resolution] = STATE(562),
    [sym_call] = STATE(562),
    [sym_method_call] = STATE(567),
    [sym_argument_list] = STATE(563),
    [sym__argument_list_with_parens] = STATE(564),
    [sym__argument] = STATE(565),
    [sym_splat_argument] = STATE(565),
    [sym_hash_splat_argument] = STATE(565),
    [sym_block_argument] = STATE(565),
    [sym_assignment] = STATE(561),
    [sym_operator_assignment] = STATE(561),
    [sym_conditional] = STATE(561),
    [sym_range] = STATE(561),
    [sym_binary] = STATE(561),
    [sym_unary] = STATE(561),
    [sym_left_assignment_list] = STATE(566),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(567),
    [sym__variable] = STATE(562),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(567),
    [sym_false] = STATE(567),
    [sym_nil] = STATE(567),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(568),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(565),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1047),
    [sym__unary_minus] = ACTIONS(1049),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(1075),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [94] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(561),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(567),
    [sym_scope_resolution] = STATE(562),
    [sym_call] = STATE(562),
    [sym_method_call] = STATE(567),
    [sym_argument_list] = STATE(569),
    [sym__argument_list_with_parens] = STATE(564),
    [sym__argument] = STATE(565),
    [sym_splat_argument] = STATE(565),
    [sym_hash_splat_argument] = STATE(565),
    [sym_block_argument] = STATE(565),
    [sym_assignment] = STATE(561),
    [sym_operator_assignment] = STATE(561),
    [sym_conditional] = STATE(561),
    [sym_range] = STATE(561),
    [sym_binary] = STATE(561),
    [sym_unary] = STATE(561),
    [sym_left_assignment_list] = STATE(566),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(567),
    [sym__variable] = STATE(562),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(567),
    [sym_false] = STATE(567),
    [sym_nil] = STATE(567),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(568),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(565),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1047),
    [sym__unary_minus] = ACTIONS(1049),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(1075),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [95] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(561),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(567),
    [sym_scope_resolution] = STATE(562),
    [sym_call] = STATE(562),
    [sym_method_call] = STATE(567),
    [sym_argument_list] = STATE(570),
    [sym__argument_list_with_parens] = STATE(564),
    [sym__argument] = STATE(565),
    [sym_splat_argument] = STATE(565),
    [sym_hash_splat_argument] = STATE(565),
    [sym_block_argument] = STATE(565),
    [sym_assignment] = STATE(561),
    [sym_operator_assignment] = STATE(561),
    [sym_conditional] = STATE(561),
    [sym_range] = STATE(561),
    [sym_binary] = STATE(561),
    [sym_unary] = STATE(561),
    [sym_left_assignment_list] = STATE(566),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(567),
    [sym__variable] = STATE(562),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(567),
    [sym_false] = STATE(567),
    [sym_nil] = STATE(567),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(568),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(565),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1047),
    [sym__unary_minus] = ACTIONS(1049),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(1075),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [96] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(561),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(567),
    [sym_scope_resolution] = STATE(562),
    [sym_call] = STATE(562),
    [sym_method_call] = STATE(567),
    [sym_argument_list] = STATE(571),
    [sym__argument_list_with_parens] = STATE(564),
    [sym__argument] = STATE(565),
    [sym_splat_argument] = STATE(565),
    [sym_hash_splat_argument] = STATE(565),
    [sym_block_argument] = STATE(565),
    [sym_assignment] = STATE(561),
    [sym_operator_assignment] = STATE(561),
    [sym_conditional] = STATE(561),
    [sym_range] = STATE(561),
    [sym_binary] = STATE(561),
    [sym_unary] = STATE(561),
    [sym_left_assignment_list] = STATE(566),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(567),
    [sym__variable] = STATE(562),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(567),
    [sym_false] = STATE(567),
    [sym_nil] = STATE(567),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(568),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(565),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1047),
    [sym__unary_minus] = ACTIONS(1049),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(1075),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [97] = {
    [sym_begin_block] = STATE(572),
    [sym_end_block] = STATE(572),
    [sym__statement] = STATE(572),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(572),
    [sym_unless_modifier] = STATE(572),
    [sym_while_modifier] = STATE(572),
    [sym_until_modifier] = STATE(572),
    [sym_rescue_modifier] = STATE(572),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(234),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(234),
    [sym_operator_assignment] = STATE(234),
    [sym_conditional] = STATE(234),
    [sym_range] = STATE(234),
    [sym_binary] = STATE(234),
    [sym_unary] = STATE(234),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_undef] = STATE(572),
    [sym_alias] = STATE(572),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(429),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_yield] = ACTIONS(433),
    [anon_sym_break] = ACTIONS(435),
    [anon_sym_next] = ACTIONS(437),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(439),
    [anon_sym_defined_QMARK] = ACTIONS(441),
    [anon_sym_not] = ACTIONS(443),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [anon_sym_undef] = ACTIONS(451),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [98] = {
    [sym_begin_block] = STATE(573),
    [sym_end_block] = STATE(573),
    [sym__statement] = STATE(573),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(573),
    [sym_unless_modifier] = STATE(573),
    [sym_while_modifier] = STATE(573),
    [sym_until_modifier] = STATE(573),
    [sym_rescue_modifier] = STATE(573),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(234),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(234),
    [sym_operator_assignment] = STATE(234),
    [sym_conditional] = STATE(234),
    [sym_range] = STATE(234),
    [sym_binary] = STATE(234),
    [sym_unary] = STATE(234),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_undef] = STATE(573),
    [sym_alias] = STATE(573),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(429),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_yield] = ACTIONS(433),
    [anon_sym_break] = ACTIONS(435),
    [anon_sym_next] = ACTIONS(437),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(439),
    [anon_sym_defined_QMARK] = ACTIONS(441),
    [anon_sym_not] = ACTIONS(443),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [anon_sym_undef] = ACTIONS(451),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [99] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(574),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(574),
    [sym_operator_assignment] = STATE(574),
    [sym_conditional] = STATE(574),
    [sym_range] = STATE(574),
    [sym_binary] = STATE(574),
    [sym_unary] = STATE(574),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(455),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_break] = ACTIONS(459),
    [anon_sym_next] = ACTIONS(461),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_defined_QMARK] = ACTIONS(465),
    [anon_sym_not] = ACTIONS(467),
    [anon_sym_BANG] = ACTIONS(469),
    [anon_sym_TILDE] = ACTIONS(469),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [100] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(575),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(575),
    [sym_operator_assignment] = STATE(575),
    [sym_conditional] = STATE(575),
    [sym_range] = STATE(575),
    [sym_binary] = STATE(575),
    [sym_unary] = STATE(575),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(455),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_break] = ACTIONS(459),
    [anon_sym_next] = ACTIONS(461),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_defined_QMARK] = ACTIONS(465),
    [anon_sym_not] = ACTIONS(467),
    [anon_sym_BANG] = ACTIONS(469),
    [anon_sym_TILDE] = ACTIONS(469),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [101] = {
    [sym_method] = STATE(184),
    [sym_singleton_method] = STATE(184),
    [sym_class] = STATE(184),
    [sym_singleton_class] = STATE(184),
    [sym_module] = STATE(184),
    [sym_return] = STATE(184),
    [sym_yield] = STATE(184),
    [sym_break] = STATE(184),
    [sym_next] = STATE(184),
    [sym_while] = STATE(184),
    [sym_until] = STATE(184),
    [sym_for] = STATE(184),
    [sym_case] = STATE(184),
    [sym_if] = STATE(184),
    [sym_unless] = STATE(184),
    [sym_begin] = STATE(184),
    [sym__primary] = STATE(184),
    [sym_parenthesized_statements] = STATE(184),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(255),
    [sym_call] = STATE(255),
    [sym_method_call] = STATE(258),
    [sym__mlhs] = STATE(576),
    [sym_destructured_left_assignment] = STATE(257),
    [sym_rest_assignment] = STATE(257),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(255),
    [sym_rational] = STATE(184),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(184),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(184),
    [sym_string_array] = STATE(184),
    [sym_symbol_array] = STATE(184),
    [sym_symbol] = STATE(184),
    [sym_regex] = STATE(184),
    [sym_array] = STATE(184),
    [sym_hash] = STATE(184),
    [sym_lambda] = STATE(184),
    [sym__simple_symbol] = ACTIONS(279),
    [sym__string_start] = ACTIONS(281),
    [sym__symbol_start] = ACTIONS(283),
    [sym__subshell_start] = ACTIONS(285),
    [sym__regex_start] = ACTIONS(287),
    [sym__string_array_start] = ACTIONS(289),
    [sym__symbol_array_start] = ACTIONS(291),
    [sym_heredoc_beginning] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_def] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(475),
    [anon_sym_COLON_COLON] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(477),
    [anon_sym_class] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(307),
    [anon_sym_return] = ACTIONS(309),
    [anon_sym_yield] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_next] = ACTIONS(315),
    [sym_redo] = ACTIONS(317),
    [sym_retry] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(319),
    [anon_sym_unless] = ACTIONS(321),
    [anon_sym_while] = ACTIONS(323),
    [anon_sym_until] = ACTIONS(325),
    [anon_sym_for] = ACTIONS(327),
    [anon_sym_case] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(331),
    [sym_constant] = ACTIONS(479),
    [sym_identifier] = ACTIONS(479),
    [sym_instance_variable] = ACTIONS(481),
    [sym_class_variable] = ACTIONS(481),
    [sym_global_variable] = ACTIONS(481),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(317),
    [sym_complex] = ACTIONS(293),
    [sym_super] = ACTIONS(479),
    [anon_sym_true] = ACTIONS(339),
    [anon_sym_TRUE] = ACTIONS(339),
    [anon_sym_false] = ACTIONS(341),
    [anon_sym_FALSE] = ACTIONS(341),
    [sym_self] = ACTIONS(479),
    [anon_sym_nil] = ACTIONS(343),
    [anon_sym_NIL] = ACTIONS(343),
    [sym_character] = ACTIONS(293),
    [anon_sym_LBRACK2] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(347),
  },
  [102] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(577),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(577),
    [sym_operator_assignment] = STATE(577),
    [sym_conditional] = STATE(577),
    [sym_range] = STATE(577),
    [sym_binary] = STATE(577),
    [sym_unary] = STATE(577),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_heredoc_body] = STATE(578),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__terminator] = STATE(578),
    [sym__line_break] = ACTIONS(1083),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(485),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(495),
    [anon_sym_defined_QMARK] = ACTIONS(497),
    [anon_sym_not] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(501),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [103] = {
    [sym__statements] = STATE(579),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(580),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(581),
    [sym_rescue] = STATE(582),
    [sym__body_statement] = STATE(583),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_heredoc_body] = STATE(584),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [sym__terminator] = STATE(584),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__line_break] = ACTIONS(1085),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(1087),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [104] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(585),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(118),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(118),
    [sym_assignment] = STATE(585),
    [sym_operator_assignment] = STATE(585),
    [sym_conditional] = STATE(585),
    [sym_range] = STATE(585),
    [sym_binary] = STATE(585),
    [sym_unary] = STATE(585),
    [sym_left_assignment_list] = STATE(117),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(118),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(118),
    [sym_false] = STATE(118),
    [sym_nil] = STATE(118),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(514),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [105] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(586),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(118),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(118),
    [sym_assignment] = STATE(586),
    [sym_operator_assignment] = STATE(586),
    [sym_conditional] = STATE(586),
    [sym_range] = STATE(586),
    [sym_binary] = STATE(586),
    [sym_unary] = STATE(586),
    [sym_left_assignment_list] = STATE(117),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(118),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(118),
    [sym_false] = STATE(118),
    [sym_nil] = STATE(118),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(514),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [106] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(1093),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [107] = {
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
    [anon_sym_r] = ACTIONS(1095),
  },
  [108] = {
    [sym__binary_minus] = ACTIONS(565),
    [sym__binary_star] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(567),
    [anon_sym_COMMA] = ACTIONS(565),
    [anon_sym_PIPE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(567),
    [anon_sym_AMP] = ACTIONS(567),
    [anon_sym_EQ] = ACTIONS(567),
    [anon_sym_LT] = ACTIONS(567),
    [anon_sym_EQ_GT] = ACTIONS(565),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_COLON_COLON2] = ACTIONS(565),
    [anon_sym_AMP_DOT] = ACTIONS(565),
    [anon_sym_PLUS_EQ] = ACTIONS(565),
    [anon_sym_DASH_EQ] = ACTIONS(565),
    [anon_sym_STAR_EQ] = ACTIONS(565),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(565),
    [anon_sym_SLASH_EQ] = ACTIONS(565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(565),
    [anon_sym_PIPE_EQ] = ACTIONS(565),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(565),
    [anon_sym_AMP_EQ] = ACTIONS(565),
    [anon_sym_PERCENT_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_LT_LT_EQ] = ACTIONS(565),
    [anon_sym_CARET_EQ] = ACTIONS(565),
    [anon_sym_QMARK] = ACTIONS(565),
    [anon_sym_DOT_DOT] = ACTIONS(567),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(565),
    [anon_sym_and] = ACTIONS(565),
    [anon_sym_or] = ACTIONS(565),
    [anon_sym_PIPE_PIPE] = ACTIONS(567),
    [anon_sym_AMP_AMP] = ACTIONS(567),
    [anon_sym_LT_LT] = ACTIONS(567),
    [anon_sym_GT_GT] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(565),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(565),
    [anon_sym_LT_EQ_GT] = ACTIONS(565),
    [anon_sym_EQ_TILDE] = ACTIONS(565),
    [anon_sym_BANG_TILDE] = ACTIONS(565),
    [anon_sym_LT_EQ] = ACTIONS(567),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_GT_EQ] = ACTIONS(565),
    [anon_sym_CARET] = ACTIONS(567),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_SLASH] = ACTIONS(567),
    [anon_sym_PERCENT] = ACTIONS(567),
    [sym_comment] = ACTIONS(87),
  },
  [109] = {
    [sym__binary_minus] = ACTIONS(569),
    [sym__binary_star] = ACTIONS(569),
    [anon_sym_DOT] = ACTIONS(571),
    [anon_sym_COMMA] = ACTIONS(569),
    [anon_sym_PIPE] = ACTIONS(571),
    [anon_sym_STAR_STAR] = ACTIONS(571),
    [anon_sym_AMP] = ACTIONS(571),
    [anon_sym_EQ] = ACTIONS(571),
    [anon_sym_LT] = ACTIONS(571),
    [anon_sym_EQ_GT] = ACTIONS(569),
    [anon_sym_LBRACK] = ACTIONS(569),
    [anon_sym_COLON_COLON2] = ACTIONS(569),
    [anon_sym_AMP_DOT] = ACTIONS(569),
    [anon_sym_PLUS_EQ] = ACTIONS(569),
    [anon_sym_DASH_EQ] = ACTIONS(569),
    [anon_sym_STAR_EQ] = ACTIONS(569),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(569),
    [anon_sym_SLASH_EQ] = ACTIONS(569),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(569),
    [anon_sym_PIPE_EQ] = ACTIONS(569),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(569),
    [anon_sym_AMP_EQ] = ACTIONS(569),
    [anon_sym_PERCENT_EQ] = ACTIONS(569),
    [anon_sym_GT_GT_EQ] = ACTIONS(569),
    [anon_sym_LT_LT_EQ] = ACTIONS(569),
    [anon_sym_CARET_EQ] = ACTIONS(569),
    [anon_sym_QMARK] = ACTIONS(569),
    [anon_sym_DOT_DOT] = ACTIONS(571),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(569),
    [anon_sym_and] = ACTIONS(569),
    [anon_sym_or] = ACTIONS(569),
    [anon_sym_PIPE_PIPE] = ACTIONS(571),
    [anon_sym_AMP_AMP] = ACTIONS(571),
    [anon_sym_LT_LT] = ACTIONS(571),
    [anon_sym_GT_GT] = ACTIONS(571),
    [anon_sym_EQ_EQ] = ACTIONS(571),
    [anon_sym_BANG_EQ] = ACTIONS(569),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(569),
    [anon_sym_LT_EQ_GT] = ACTIONS(569),
    [anon_sym_EQ_TILDE] = ACTIONS(569),
    [anon_sym_BANG_TILDE] = ACTIONS(569),
    [anon_sym_LT_EQ] = ACTIONS(571),
    [anon_sym_GT] = ACTIONS(571),
    [anon_sym_GT_EQ] = ACTIONS(569),
    [anon_sym_CARET] = ACTIONS(571),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_SLASH] = ACTIONS(571),
    [anon_sym_PERCENT] = ACTIONS(571),
    [sym_comment] = ACTIONS(87),
  },
  [110] = {
    [sym__binary_minus] = ACTIONS(573),
    [sym__binary_star] = ACTIONS(573),
    [anon_sym_DOT] = ACTIONS(575),
    [anon_sym_COMMA] = ACTIONS(573),
    [anon_sym_PIPE] = ACTIONS(575),
    [anon_sym_STAR_STAR] = ACTIONS(575),
    [anon_sym_AMP] = ACTIONS(575),
    [anon_sym_EQ] = ACTIONS(575),
    [anon_sym_LT] = ACTIONS(575),
    [anon_sym_EQ_GT] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(573),
    [anon_sym_COLON_COLON2] = ACTIONS(573),
    [anon_sym_AMP_DOT] = ACTIONS(573),
    [anon_sym_PLUS_EQ] = ACTIONS(573),
    [anon_sym_DASH_EQ] = ACTIONS(573),
    [anon_sym_STAR_EQ] = ACTIONS(573),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(573),
    [anon_sym_SLASH_EQ] = ACTIONS(573),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(573),
    [anon_sym_PIPE_EQ] = ACTIONS(573),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(573),
    [anon_sym_AMP_EQ] = ACTIONS(573),
    [anon_sym_PERCENT_EQ] = ACTIONS(573),
    [anon_sym_GT_GT_EQ] = ACTIONS(573),
    [anon_sym_LT_LT_EQ] = ACTIONS(573),
    [anon_sym_CARET_EQ] = ACTIONS(573),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_DOT_DOT] = ACTIONS(575),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(573),
    [anon_sym_and] = ACTIONS(573),
    [anon_sym_or] = ACTIONS(573),
    [anon_sym_PIPE_PIPE] = ACTIONS(575),
    [anon_sym_AMP_AMP] = ACTIONS(575),
    [anon_sym_LT_LT] = ACTIONS(575),
    [anon_sym_GT_GT] = ACTIONS(575),
    [anon_sym_EQ_EQ] = ACTIONS(575),
    [anon_sym_BANG_EQ] = ACTIONS(573),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(573),
    [anon_sym_LT_EQ_GT] = ACTIONS(573),
    [anon_sym_EQ_TILDE] = ACTIONS(573),
    [anon_sym_BANG_TILDE] = ACTIONS(573),
    [anon_sym_LT_EQ] = ACTIONS(575),
    [anon_sym_GT] = ACTIONS(575),
    [anon_sym_GT_EQ] = ACTIONS(573),
    [anon_sym_CARET] = ACTIONS(575),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(575),
    [anon_sym_PERCENT] = ACTIONS(575),
    [sym_comment] = ACTIONS(87),
  },
  [111] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(346),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(352),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(352),
    [sym__argument_list_with_trailing_comma] = STATE(590),
    [sym__argument] = STATE(350),
    [sym_splat_argument] = STATE(350),
    [sym_hash_splat_argument] = STATE(350),
    [sym_block_argument] = STATE(350),
    [sym_assignment] = STATE(346),
    [sym_operator_assignment] = STATE(346),
    [sym_conditional] = STATE(346),
    [sym_range] = STATE(346),
    [sym_binary] = STATE(346),
    [sym_unary] = STATE(346),
    [sym_left_assignment_list] = STATE(351),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(352),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(352),
    [sym_false] = STATE(352),
    [sym_nil] = STATE(352),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(353),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(350),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(593),
    [sym__splat_star] = ACTIONS(595),
    [sym__unary_minus] = ACTIONS(597),
    [sym__identifier_hash_key] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(1097),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [112] = {
    [sym_lambda_parameters] = STATE(593),
    [sym__simple_formal_parameter] = STATE(362),
    [sym_splat_parameter] = STATE(362),
    [sym_hash_splat_parameter] = STATE(362),
    [sym_block_parameter] = STATE(362),
    [sym_keyword_parameter] = STATE(362),
    [sym_optional_parameter] = STATE(362),
    [sym_do_block] = STATE(594),
    [sym_block] = STATE(594),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(1101),
    [sym_identifier] = ACTIONS(679),
    [sym_comment] = ACTIONS(87),
  },
  [113] = {
    [sym__binary_minus] = ACTIONS(1103),
    [sym__binary_star] = ACTIONS(1105),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_STAR_STAR] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(1111),
    [anon_sym_EQ_GT] = ACTIONS(989),
    [anon_sym_QMARK] = ACTIONS(1113),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1117),
    [anon_sym_and] = ACTIONS(1119),
    [anon_sym_or] = ACTIONS(1119),
    [anon_sym_PIPE_PIPE] = ACTIONS(1121),
    [anon_sym_AMP_AMP] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1125),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1121),
    [anon_sym_LT_EQ_GT] = ACTIONS(1121),
    [anon_sym_EQ_TILDE] = ACTIONS(1121),
    [anon_sym_BANG_TILDE] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1111),
    [anon_sym_GT] = ACTIONS(1111),
    [anon_sym_GT_EQ] = ACTIONS(1127),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1103),
    [anon_sym_SLASH] = ACTIONS(1105),
    [anon_sym_PERCENT] = ACTIONS(1105),
    [sym_comment] = ACTIONS(87),
  },
  [114] = {
    [sym__binary_minus] = ACTIONS(731),
    [sym__binary_star] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(1131),
    [anon_sym_COMMA] = ACTIONS(731),
    [anon_sym_PIPE] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(735),
    [anon_sym_EQ_GT] = ACTIONS(731),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_COLON_COLON2] = ACTIONS(1135),
    [anon_sym_AMP_DOT] = ACTIONS(1137),
    [anon_sym_QMARK] = ACTIONS(731),
    [anon_sym_DOT_DOT] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(731),
    [anon_sym_or] = ACTIONS(731),
    [anon_sym_PIPE_PIPE] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(731),
    [anon_sym_LT_LT] = ACTIONS(731),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_EQ_EQ] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(731),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(731),
    [anon_sym_LT_EQ_GT] = ACTIONS(731),
    [anon_sym_EQ_TILDE] = ACTIONS(731),
    [anon_sym_BANG_TILDE] = ACTIONS(731),
    [anon_sym_LT_EQ] = ACTIONS(735),
    [anon_sym_GT] = ACTIONS(735),
    [anon_sym_GT_EQ] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(731),
    [anon_sym_SLASH] = ACTIONS(731),
    [anon_sym_PERCENT] = ACTIONS(731),
    [sym_comment] = ACTIONS(87),
  },
  [115] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(644),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_argument_list] = STATE(647),
    [sym__argument_list_with_parens] = STATE(648),
    [sym__argument] = STATE(649),
    [sym_splat_argument] = STATE(649),
    [sym_hash_splat_argument] = STATE(649),
    [sym_block_argument] = STATE(649),
    [sym_do_block] = STATE(650),
    [sym_block] = STATE(650),
    [sym_assignment] = STATE(644),
    [sym_operator_assignment] = STATE(644),
    [sym_conditional] = STATE(644),
    [sym_range] = STATE(644),
    [sym_binary] = STATE(644),
    [sym_unary] = STATE(644),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(653),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(649),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(1155),
    [sym__splat_star] = ACTIONS(1157),
    [sym__unary_minus] = ACTIONS(1159),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(1193),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1205),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1209),
    [sym_identifier] = ACTIONS(1209),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [116] = {
    [sym__heredoc_body_start] = ACTIONS(1221),
    [anon_sym_RBRACE] = ACTIONS(1221),
    [anon_sym_COMMA] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
  },
  [117] = {
    [anon_sym_EQ] = ACTIONS(1223),
    [sym_comment] = ACTIONS(87),
  },
  [118] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(1225),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(1227),
    [anon_sym_DASH_EQ] = ACTIONS(1227),
    [anon_sym_STAR_EQ] = ACTIONS(1227),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1227),
    [anon_sym_SLASH_EQ] = ACTIONS(1227),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1227),
    [anon_sym_PIPE_EQ] = ACTIONS(1227),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1227),
    [anon_sym_AMP_EQ] = ACTIONS(1227),
    [anon_sym_PERCENT_EQ] = ACTIONS(1227),
    [anon_sym_GT_GT_EQ] = ACTIONS(1227),
    [anon_sym_LT_LT_EQ] = ACTIONS(1227),
    [anon_sym_CARET_EQ] = ACTIONS(1227),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [119] = {
    [sym_string] = STATE(656),
    [aux_sym_chained_string_repeat1] = STATE(656),
    [sym__string_start] = ACTIONS(139),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(1229),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [120] = {
    [anon_sym_RBRACE] = ACTIONS(1231),
    [sym_comment] = ACTIONS(87),
  },
  [121] = {
    [sym_heredoc_body] = STATE(658),
    [sym__heredoc_body_start] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(1231),
    [sym_comment] = ACTIONS(87),
  },
  [122] = {
    [sym__heredoc_body_start] = ACTIONS(1233),
    [anon_sym_RBRACE] = ACTIONS(1233),
    [anon_sym_COMMA] = ACTIONS(1235),
    [sym_comment] = ACTIONS(87),
  },
  [123] = {
    [sym__statements] = STATE(661),
    [sym_begin_block] = STATE(489),
    [sym_end_block] = STATE(489),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(495),
    [aux_sym__statements_repeat1] = STATE(495),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(1237),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [124] = {
    [sym__line_break] = ACTIONS(101),
    [sym__heredoc_body_start] = ACTIONS(101),
    [ts_builtin_sym_end] = ACTIONS(101),
    [anon_sym___END__] = ACTIONS(103),
    [anon_sym_RBRACE] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_SEMI] = ACTIONS(101),
    [anon_sym_STAR] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(101),
    [anon_sym_AMP] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(103),
    [anon_sym_unless] = ACTIONS(103),
    [anon_sym_while] = ACTIONS(103),
    [anon_sym_until] = ACTIONS(103),
    [anon_sym_rescue] = ACTIONS(103),
    [anon_sym_when] = ACTIONS(103),
    [anon_sym_elsif] = ACTIONS(103),
    [anon_sym_else] = ACTIONS(103),
    [anon_sym_then] = ACTIONS(103),
    [anon_sym_ensure] = ACTIONS(103),
    [sym_identifier] = ACTIONS(103),
    [sym_comment] = ACTIONS(87),
  },
  [125] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(663),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(1239),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [126] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(671),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(674),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(674),
    [sym_assignment] = STATE(671),
    [sym_operator_assignment] = STATE(671),
    [sym_conditional] = STATE(671),
    [sym_range] = STATE(671),
    [sym_binary] = STATE(671),
    [sym_unary] = STATE(671),
    [sym_left_assignment_list] = STATE(673),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(674),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(674),
    [sym_false] = STATE(674),
    [sym_nil] = STATE(674),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(675),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1243),
    [anon_sym_yield] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1247),
    [anon_sym_next] = ACTIONS(1249),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [127] = {
    [sym__line_break] = ACTIONS(1263),
    [sym__heredoc_body_start] = ACTIONS(1263),
    [ts_builtin_sym_end] = ACTIONS(1263),
    [anon_sym___END__] = ACTIONS(1265),
    [anon_sym_RBRACE] = ACTIONS(1263),
    [anon_sym_LPAREN] = ACTIONS(1263),
    [anon_sym_RPAREN] = ACTIONS(1263),
    [anon_sym_COMMA] = ACTIONS(1263),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_STAR_STAR] = ACTIONS(1263),
    [anon_sym_AMP] = ACTIONS(1263),
    [anon_sym_end] = ACTIONS(1265),
    [anon_sym_if] = ACTIONS(1265),
    [anon_sym_unless] = ACTIONS(1265),
    [anon_sym_while] = ACTIONS(1265),
    [anon_sym_until] = ACTIONS(1265),
    [anon_sym_rescue] = ACTIONS(1265),
    [anon_sym_when] = ACTIONS(1265),
    [anon_sym_elsif] = ACTIONS(1265),
    [anon_sym_else] = ACTIONS(1265),
    [anon_sym_then] = ACTIONS(1265),
    [anon_sym_ensure] = ACTIONS(1265),
    [sym_identifier] = ACTIONS(1265),
    [sym_comment] = ACTIONS(87),
  },
  [128] = {
    [sym__line_break] = ACTIONS(1267),
    [sym__heredoc_body_start] = ACTIONS(1267),
    [anon_sym_LPAREN] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(1089),
    [anon_sym_COLON_COLON] = ACTIONS(1089),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym_STAR] = ACTIONS(1269),
    [anon_sym_STAR_STAR] = ACTIONS(1267),
    [anon_sym_AMP] = ACTIONS(1267),
    [sym_identifier] = ACTIONS(1267),
    [sym_comment] = ACTIONS(87),
  },
  [129] = {
    [sym__line_break] = ACTIONS(1267),
    [sym__heredoc_body_start] = ACTIONS(1267),
    [anon_sym_LPAREN] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(1089),
    [anon_sym_COLON_COLON] = ACTIONS(1089),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym_STAR] = ACTIONS(1269),
    [anon_sym_STAR_STAR] = ACTIONS(1267),
    [anon_sym_AMP] = ACTIONS(1267),
    [anon_sym_EQ] = ACTIONS(1271),
    [sym_identifier] = ACTIONS(1267),
    [sym_comment] = ACTIONS(87),
  },
  [130] = {
    [sym__line_break] = ACTIONS(1273),
    [sym__heredoc_body_start] = ACTIONS(1273),
    [sym__binary_minus] = ACTIONS(1273),
    [sym__binary_star] = ACTIONS(1273),
    [ts_builtin_sym_end] = ACTIONS(1273),
    [anon_sym___END__] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_RBRACE] = ACTIONS(1273),
    [anon_sym_RPAREN] = ACTIONS(1273),
    [anon_sym_DOT] = ACTIONS(1275),
    [anon_sym_COMMA] = ACTIONS(1273),
    [anon_sym_PIPE] = ACTIONS(1275),
    [anon_sym_SEMI] = ACTIONS(1273),
    [anon_sym_STAR_STAR] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_LT] = ACTIONS(1275),
    [anon_sym_end] = ACTIONS(1273),
    [anon_sym_if] = ACTIONS(1273),
    [anon_sym_unless] = ACTIONS(1273),
    [anon_sym_while] = ACTIONS(1273),
    [anon_sym_until] = ACTIONS(1273),
    [anon_sym_rescue] = ACTIONS(1273),
    [anon_sym_do] = ACTIONS(1273),
    [anon_sym_when] = ACTIONS(1273),
    [anon_sym_elsif] = ACTIONS(1273),
    [anon_sym_else] = ACTIONS(1273),
    [anon_sym_then] = ACTIONS(1273),
    [anon_sym_ensure] = ACTIONS(1273),
    [anon_sym_EQ_GT] = ACTIONS(1273),
    [anon_sym_LBRACK] = ACTIONS(1273),
    [anon_sym_COLON_COLON2] = ACTIONS(1273),
    [anon_sym_AMP_DOT] = ACTIONS(1273),
    [anon_sym_QMARK] = ACTIONS(1273),
    [anon_sym_DOT_DOT] = ACTIONS(1275),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_and] = ACTIONS(1273),
    [anon_sym_or] = ACTIONS(1273),
    [anon_sym_PIPE_PIPE] = ACTIONS(1273),
    [anon_sym_AMP_AMP] = ACTIONS(1273),
    [anon_sym_LT_LT] = ACTIONS(1273),
    [anon_sym_GT_GT] = ACTIONS(1273),
    [anon_sym_EQ_EQ] = ACTIONS(1275),
    [anon_sym_BANG_EQ] = ACTIONS(1273),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1273),
    [anon_sym_LT_EQ_GT] = ACTIONS(1273),
    [anon_sym_EQ_TILDE] = ACTIONS(1273),
    [anon_sym_BANG_TILDE] = ACTIONS(1273),
    [anon_sym_LT_EQ] = ACTIONS(1275),
    [anon_sym_GT] = ACTIONS(1275),
    [anon_sym_GT_EQ] = ACTIONS(1273),
    [anon_sym_CARET] = ACTIONS(1273),
    [anon_sym_PLUS] = ACTIONS(1273),
    [anon_sym_SLASH] = ACTIONS(1273),
    [anon_sym_PERCENT] = ACTIONS(1273),
    [sym_comment] = ACTIONS(87),
  },
  [131] = {
    [anon_sym_DOT] = ACTIONS(1277),
    [anon_sym_COLON_COLON] = ACTIONS(1277),
    [sym_comment] = ACTIONS(87),
  },
  [132] = {
    [sym_method_parameters] = STATE(683),
    [sym__simple_formal_parameter] = STATE(684),
    [sym_splat_parameter] = STATE(684),
    [sym_hash_splat_parameter] = STATE(684),
    [sym_block_parameter] = STATE(684),
    [sym_keyword_parameter] = STATE(684),
    [sym_optional_parameter] = STATE(684),
    [sym_heredoc_body] = STATE(683),
    [sym__terminator] = STATE(683),
    [sym__line_break] = ACTIONS(1279),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_SEMI] = ACTIONS(1279),
    [anon_sym_STAR] = ACTIONS(1283),
    [anon_sym_STAR_STAR] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1287),
    [sym_identifier] = ACTIONS(1289),
    [sym_comment] = ACTIONS(87),
  },
  [133] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(685),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(686),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(686),
    [sym_assignment] = STATE(685),
    [sym_operator_assignment] = STATE(685),
    [sym_conditional] = STATE(685),
    [sym_range] = STATE(685),
    [sym_binary] = STATE(685),
    [sym_unary] = STATE(685),
    [sym_left_assignment_list] = STATE(147),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(686),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(686),
    [sym_false] = STATE(686),
    [sym_nil] = STATE(686),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(151),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [134] = {
    [sym__line_break] = ACTIONS(1291),
    [sym__heredoc_body_start] = ACTIONS(1291),
    [sym__binary_minus] = ACTIONS(1291),
    [sym__binary_star] = ACTIONS(1291),
    [ts_builtin_sym_end] = ACTIONS(1291),
    [anon_sym___END__] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1291),
    [anon_sym_RBRACE] = ACTIONS(1291),
    [anon_sym_RPAREN] = ACTIONS(1291),
    [anon_sym_DOT] = ACTIONS(1293),
    [anon_sym_COMMA] = ACTIONS(1291),
    [anon_sym_PIPE] = ACTIONS(1293),
    [anon_sym_SEMI] = ACTIONS(1291),
    [anon_sym_STAR_STAR] = ACTIONS(1291),
    [anon_sym_AMP] = ACTIONS(1293),
    [anon_sym_LT] = ACTIONS(1293),
    [anon_sym_end] = ACTIONS(1291),
    [anon_sym_if] = ACTIONS(1291),
    [anon_sym_unless] = ACTIONS(1291),
    [anon_sym_while] = ACTIONS(1291),
    [anon_sym_until] = ACTIONS(1291),
    [anon_sym_rescue] = ACTIONS(1291),
    [anon_sym_do] = ACTIONS(1291),
    [anon_sym_when] = ACTIONS(1291),
    [anon_sym_elsif] = ACTIONS(1291),
    [anon_sym_else] = ACTIONS(1291),
    [anon_sym_then] = ACTIONS(1291),
    [anon_sym_ensure] = ACTIONS(1291),
    [anon_sym_EQ_GT] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_COLON_COLON2] = ACTIONS(1291),
    [anon_sym_AMP_DOT] = ACTIONS(1291),
    [anon_sym_QMARK] = ACTIONS(1291),
    [anon_sym_DOT_DOT] = ACTIONS(1293),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1291),
    [anon_sym_and] = ACTIONS(1291),
    [anon_sym_or] = ACTIONS(1291),
    [anon_sym_PIPE_PIPE] = ACTIONS(1291),
    [anon_sym_AMP_AMP] = ACTIONS(1291),
    [anon_sym_LT_LT] = ACTIONS(1291),
    [anon_sym_GT_GT] = ACTIONS(1291),
    [anon_sym_EQ_EQ] = ACTIONS(1293),
    [anon_sym_BANG_EQ] = ACTIONS(1291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1291),
    [anon_sym_LT_EQ_GT] = ACTIONS(1291),
    [anon_sym_EQ_TILDE] = ACTIONS(1291),
    [anon_sym_BANG_TILDE] = ACTIONS(1291),
    [anon_sym_LT_EQ] = ACTIONS(1293),
    [anon_sym_GT] = ACTIONS(1293),
    [anon_sym_GT_EQ] = ACTIONS(1291),
    [anon_sym_CARET] = ACTIONS(1291),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_SLASH] = ACTIONS(1291),
    [anon_sym_PERCENT] = ACTIONS(1291),
    [sym_comment] = ACTIONS(87),
  },
  [135] = {
    [sym_method] = STATE(184),
    [sym_singleton_method] = STATE(184),
    [sym_class] = STATE(184),
    [sym_singleton_class] = STATE(184),
    [sym_module] = STATE(184),
    [sym_return] = STATE(184),
    [sym_yield] = STATE(184),
    [sym_break] = STATE(184),
    [sym_next] = STATE(184),
    [sym_while] = STATE(184),
    [sym_until] = STATE(184),
    [sym_for] = STATE(184),
    [sym_case] = STATE(184),
    [sym_if] = STATE(184),
    [sym_unless] = STATE(184),
    [sym_begin] = STATE(184),
    [sym__primary] = STATE(184),
    [sym_parenthesized_statements] = STATE(184),
    [sym_element_reference] = STATE(186),
    [sym_scope_resolution] = STATE(687),
    [sym_call] = STATE(687),
    [sym_method_call] = STATE(186),
    [sym__lhs] = STATE(186),
    [sym__variable] = STATE(687),
    [sym_rational] = STATE(184),
    [sym_true] = STATE(186),
    [sym_false] = STATE(186),
    [sym_nil] = STATE(186),
    [sym_chained_string] = STATE(184),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(184),
    [sym_string_array] = STATE(184),
    [sym_symbol_array] = STATE(184),
    [sym_symbol] = STATE(184),
    [sym_regex] = STATE(184),
    [sym_array] = STATE(184),
    [sym_hash] = STATE(184),
    [sym_lambda] = STATE(184),
    [sym__simple_symbol] = ACTIONS(279),
    [sym__string_start] = ACTIONS(281),
    [sym__symbol_start] = ACTIONS(283),
    [sym__subshell_start] = ACTIONS(285),
    [sym__regex_start] = ACTIONS(287),
    [sym__string_array_start] = ACTIONS(289),
    [sym__symbol_array_start] = ACTIONS(291),
    [sym_heredoc_beginning] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_def] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(299),
    [anon_sym_RPAREN] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(301),
    [anon_sym_COMMA] = ACTIONS(303),
    [anon_sym_EQ] = ACTIONS(303),
    [anon_sym_class] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(307),
    [anon_sym_return] = ACTIONS(309),
    [anon_sym_yield] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_next] = ACTIONS(315),
    [sym_redo] = ACTIONS(317),
    [sym_retry] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(319),
    [anon_sym_unless] = ACTIONS(321),
    [anon_sym_while] = ACTIONS(323),
    [anon_sym_until] = ACTIONS(325),
    [anon_sym_for] = ACTIONS(327),
    [anon_sym_case] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(331),
    [sym_constant] = ACTIONS(1295),
    [sym_identifier] = ACTIONS(1295),
    [sym_instance_variable] = ACTIONS(1297),
    [sym_class_variable] = ACTIONS(1297),
    [sym_global_variable] = ACTIONS(1297),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(317),
    [sym_complex] = ACTIONS(293),
    [sym_super] = ACTIONS(1295),
    [anon_sym_true] = ACTIONS(339),
    [anon_sym_TRUE] = ACTIONS(339),
    [anon_sym_false] = ACTIONS(341),
    [anon_sym_FALSE] = ACTIONS(341),
    [sym_self] = ACTIONS(1295),
    [anon_sym_nil] = ACTIONS(343),
    [anon_sym_NIL] = ACTIONS(343),
    [sym_character] = ACTIONS(293),
    [anon_sym_LBRACK2] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(347),
  },
  [136] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(700),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(705),
    [sym_scope_resolution] = STATE(701),
    [sym_call] = STATE(701),
    [sym_method_call] = STATE(705),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(702),
    [sym__argument] = STATE(703),
    [sym_splat_argument] = STATE(703),
    [sym_hash_splat_argument] = STATE(703),
    [sym_block_argument] = STATE(703),
    [sym_assignment] = STATE(700),
    [sym_operator_assignment] = STATE(700),
    [sym_conditional] = STATE(700),
    [sym_range] = STATE(700),
    [sym_binary] = STATE(700),
    [sym_unary] = STATE(700),
    [sym_left_assignment_list] = STATE(704),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(705),
    [sym__variable] = STATE(701),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(705),
    [sym_false] = STATE(705),
    [sym_nil] = STATE(705),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(706),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(703),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(1299),
    [sym__splat_star] = ACTIONS(1301),
    [sym__unary_minus] = ACTIONS(1303),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_RPAREN] = ACTIONS(365),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1323),
    [sym_identifier] = ACTIONS(1323),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [137] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(700),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(705),
    [sym_scope_resolution] = STATE(701),
    [sym_call] = STATE(701),
    [sym_method_call] = STATE(705),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(702),
    [sym__argument] = STATE(703),
    [sym_splat_argument] = STATE(703),
    [sym_hash_splat_argument] = STATE(703),
    [sym_block_argument] = STATE(703),
    [sym_assignment] = STATE(700),
    [sym_operator_assignment] = STATE(700),
    [sym_conditional] = STATE(700),
    [sym_range] = STATE(700),
    [sym_binary] = STATE(700),
    [sym_unary] = STATE(700),
    [sym_left_assignment_list] = STATE(704),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(705),
    [sym__variable] = STATE(701),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(705),
    [sym_false] = STATE(705),
    [sym_nil] = STATE(705),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(706),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(703),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(1299),
    [sym__splat_star] = ACTIONS(1301),
    [sym__unary_minus] = ACTIONS(1303),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_RPAREN] = ACTIONS(417),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1323),
    [sym_identifier] = ACTIONS(1323),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [138] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(700),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(705),
    [sym_scope_resolution] = STATE(701),
    [sym_call] = STATE(701),
    [sym_method_call] = STATE(705),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(702),
    [sym__argument] = STATE(703),
    [sym_splat_argument] = STATE(703),
    [sym_hash_splat_argument] = STATE(703),
    [sym_block_argument] = STATE(703),
    [sym_assignment] = STATE(700),
    [sym_operator_assignment] = STATE(700),
    [sym_conditional] = STATE(700),
    [sym_range] = STATE(700),
    [sym_binary] = STATE(700),
    [sym_unary] = STATE(700),
    [sym_left_assignment_list] = STATE(704),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(705),
    [sym__variable] = STATE(701),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(705),
    [sym_false] = STATE(705),
    [sym_nil] = STATE(705),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(706),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(703),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(1299),
    [sym__splat_star] = ACTIONS(1301),
    [sym__unary_minus] = ACTIONS(1303),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_RPAREN] = ACTIONS(421),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1323),
    [sym_identifier] = ACTIONS(1323),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [139] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(700),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(705),
    [sym_scope_resolution] = STATE(701),
    [sym_call] = STATE(701),
    [sym_method_call] = STATE(705),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(702),
    [sym__argument] = STATE(703),
    [sym_splat_argument] = STATE(703),
    [sym_hash_splat_argument] = STATE(703),
    [sym_block_argument] = STATE(703),
    [sym_assignment] = STATE(700),
    [sym_operator_assignment] = STATE(700),
    [sym_conditional] = STATE(700),
    [sym_range] = STATE(700),
    [sym_binary] = STATE(700),
    [sym_unary] = STATE(700),
    [sym_left_assignment_list] = STATE(704),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(705),
    [sym__variable] = STATE(701),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(705),
    [sym_false] = STATE(705),
    [sym_nil] = STATE(705),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(706),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(703),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(1299),
    [sym__splat_star] = ACTIONS(1301),
    [sym__unary_minus] = ACTIONS(1303),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_RPAREN] = ACTIONS(425),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1323),
    [sym_identifier] = ACTIONS(1323),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [140] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(707),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(686),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(686),
    [sym_assignment] = STATE(707),
    [sym_operator_assignment] = STATE(707),
    [sym_conditional] = STATE(707),
    [sym_range] = STATE(707),
    [sym_binary] = STATE(707),
    [sym_unary] = STATE(707),
    [sym_left_assignment_list] = STATE(147),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(686),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(686),
    [sym_false] = STATE(686),
    [sym_nil] = STATE(686),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(151),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [141] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(298),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(686),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(686),
    [sym_assignment] = STATE(298),
    [sym_operator_assignment] = STATE(298),
    [sym_conditional] = STATE(298),
    [sym_range] = STATE(298),
    [sym_binary] = STATE(298),
    [sym_unary] = STATE(298),
    [sym_left_assignment_list] = STATE(147),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(686),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(686),
    [sym_false] = STATE(686),
    [sym_nil] = STATE(686),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(151),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [142] = {
    [sym_operator] = STATE(708),
    [sym__method_name] = STATE(708),
    [sym_setter] = STATE(708),
    [sym_symbol] = STATE(708),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(1329),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(1329),
    [sym_class_variable] = ACTIONS(1329),
    [sym_global_variable] = ACTIONS(1329),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [143] = {
    [anon_sym_RPAREN] = ACTIONS(1331),
    [sym_comment] = ACTIONS(87),
  },
  [144] = {
    [sym_heredoc_body] = STATE(370),
    [sym__terminator] = STATE(370),
    [sym__line_break] = ACTIONS(687),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_RPAREN] = ACTIONS(689),
    [anon_sym_SEMI] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(1333),
    [anon_sym_unless] = ACTIONS(1335),
    [anon_sym_while] = ACTIONS(1337),
    [anon_sym_until] = ACTIONS(1339),
    [anon_sym_rescue] = ACTIONS(1341),
    [sym_comment] = ACTIONS(87),
  },
  [145] = {
    [sym__line_break] = ACTIONS(701),
    [sym__heredoc_body_start] = ACTIONS(701),
    [sym__binary_minus] = ACTIONS(1343),
    [sym__binary_star] = ACTIONS(1345),
    [anon_sym_RPAREN] = ACTIONS(701),
    [anon_sym_PIPE] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(701),
    [anon_sym_STAR_STAR] = ACTIONS(1345),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_unless] = ACTIONS(701),
    [anon_sym_while] = ACTIONS(701),
    [anon_sym_until] = ACTIONS(701),
    [anon_sym_rescue] = ACTIONS(701),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_DOT_DOT] = ACTIONS(1355),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1357),
    [anon_sym_and] = ACTIONS(1359),
    [anon_sym_or] = ACTIONS(1359),
    [anon_sym_PIPE_PIPE] = ACTIONS(1361),
    [anon_sym_AMP_AMP] = ACTIONS(1361),
    [anon_sym_LT_LT] = ACTIONS(1363),
    [anon_sym_GT_GT] = ACTIONS(1363),
    [anon_sym_EQ_EQ] = ACTIONS(1365),
    [anon_sym_BANG_EQ] = ACTIONS(1361),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1361),
    [anon_sym_LT_EQ_GT] = ACTIONS(1361),
    [anon_sym_EQ_TILDE] = ACTIONS(1361),
    [anon_sym_BANG_TILDE] = ACTIONS(1361),
    [anon_sym_LT_EQ] = ACTIONS(1351),
    [anon_sym_GT] = ACTIONS(1351),
    [anon_sym_GT_EQ] = ACTIONS(1367),
    [anon_sym_CARET] = ACTIONS(1369),
    [anon_sym_PLUS] = ACTIONS(1343),
    [anon_sym_SLASH] = ACTIONS(1345),
    [anon_sym_PERCENT] = ACTIONS(1345),
    [sym_comment] = ACTIONS(87),
  },
  [146] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(737),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(742),
    [sym_scope_resolution] = STATE(738),
    [sym_call] = STATE(738),
    [sym_method_call] = STATE(742),
    [sym_argument_list] = STATE(423),
    [sym__argument_list_with_parens] = STATE(739),
    [sym__argument] = STATE(740),
    [sym_splat_argument] = STATE(740),
    [sym_hash_splat_argument] = STATE(740),
    [sym_block_argument] = STATE(740),
    [sym_do_block] = STATE(426),
    [sym_block] = STATE(426),
    [sym_assignment] = STATE(737),
    [sym_operator_assignment] = STATE(737),
    [sym_conditional] = STATE(737),
    [sym_range] = STATE(737),
    [sym_binary] = STATE(737),
    [sym_unary] = STATE(737),
    [sym_left_assignment_list] = STATE(741),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(742),
    [sym__variable] = STATE(738),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(742),
    [sym_false] = STATE(742),
    [sym_nil] = STATE(742),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(743),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(740),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(743),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(1371),
    [sym__splat_star] = ACTIONS(1373),
    [sym__unary_minus] = ACTIONS(1375),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(771),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1381),
    [anon_sym_break] = ACTIONS(1383),
    [anon_sym_next] = ACTIONS(1385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(769),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(769),
    [anon_sym_until] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(769),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(1387),
    [anon_sym_not] = ACTIONS(1389),
    [anon_sym_BANG] = ACTIONS(1391),
    [anon_sym_TILDE] = ACTIONS(1393),
    [sym_constant] = ACTIONS(1395),
    [sym_identifier] = ACTIONS(1395),
    [sym_instance_variable] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1397),
    [sym_global_variable] = ACTIONS(1397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [147] = {
    [anon_sym_EQ] = ACTIONS(1401),
    [sym_comment] = ACTIONS(87),
  },
  [148] = {
    [anon_sym_RPAREN] = ACTIONS(1403),
    [anon_sym_EQ] = ACTIONS(823),
    [sym_comment] = ACTIONS(87),
  },
  [149] = {
    [aux_sym__mlhs_repeat1] = STATE(747),
    [anon_sym_RPAREN] = ACTIONS(827),
    [anon_sym_COMMA] = ACTIONS(1405),
    [anon_sym_EQ] = ACTIONS(827),
    [sym_comment] = ACTIONS(87),
  },
  [150] = {
    [aux_sym__mlhs_repeat1] = STATE(747),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(1405),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(1407),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(1409),
    [anon_sym_DASH_EQ] = ACTIONS(1409),
    [anon_sym_STAR_EQ] = ACTIONS(1409),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1409),
    [anon_sym_SLASH_EQ] = ACTIONS(1409),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1409),
    [anon_sym_PIPE_EQ] = ACTIONS(1409),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1409),
    [anon_sym_AMP_EQ] = ACTIONS(1409),
    [anon_sym_PERCENT_EQ] = ACTIONS(1409),
    [anon_sym_GT_GT_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT_EQ] = ACTIONS(1409),
    [anon_sym_CARET_EQ] = ACTIONS(1409),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [151] = {
    [sym_string] = STATE(749),
    [aux_sym_chained_string_repeat1] = STATE(749),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [152] = {
    [sym_begin_block] = STATE(750),
    [sym_end_block] = STATE(750),
    [sym__statement] = STATE(750),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(750),
    [sym_unless_modifier] = STATE(750),
    [sym_while_modifier] = STATE(750),
    [sym_until_modifier] = STATE(750),
    [sym_rescue_modifier] = STATE(750),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(145),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(686),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(686),
    [sym_assignment] = STATE(145),
    [sym_operator_assignment] = STATE(145),
    [sym_conditional] = STATE(145),
    [sym_range] = STATE(145),
    [sym_binary] = STATE(145),
    [sym_unary] = STATE(145),
    [sym_left_assignment_list] = STATE(147),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(686),
    [sym__variable] = STATE(146),
    [sym_undef] = STATE(750),
    [sym_alias] = STATE(750),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(686),
    [sym_false] = STATE(686),
    [sym_nil] = STATE(686),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(151),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(751),
    [aux_sym__statements_repeat1] = STATE(751),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_RPAREN] = ACTIONS(689),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [anon_sym_undef] = ACTIONS(271),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [153] = {
    [sym__line_break] = ACTIONS(1411),
    [sym__simple_symbol] = ACTIONS(1411),
    [sym__string_start] = ACTIONS(1411),
    [sym__symbol_start] = ACTIONS(1411),
    [sym__subshell_start] = ACTIONS(1411),
    [sym__regex_start] = ACTIONS(1411),
    [sym__string_array_start] = ACTIONS(1411),
    [sym__symbol_array_start] = ACTIONS(1411),
    [sym__heredoc_body_start] = ACTIONS(1411),
    [sym_heredoc_beginning] = ACTIONS(1411),
    [sym__block_ampersand] = ACTIONS(1411),
    [sym__splat_star] = ACTIONS(1411),
    [sym__unary_minus] = ACTIONS(1411),
    [sym__binary_minus] = ACTIONS(1411),
    [sym__binary_star] = ACTIONS(1411),
    [sym__identifier_hash_key] = ACTIONS(1411),
    [ts_builtin_sym_end] = ACTIONS(1411),
    [anon_sym___END__] = ACTIONS(1413),
    [anon_sym_LBRACE] = ACTIONS(1411),
    [anon_sym_RBRACE] = ACTIONS(1411),
    [anon_sym_def] = ACTIONS(1413),
    [anon_sym_LPAREN] = ACTIONS(1413),
    [anon_sym_RPAREN] = ACTIONS(1411),
    [anon_sym_DOT] = ACTIONS(1413),
    [anon_sym_COLON_COLON] = ACTIONS(1413),
    [anon_sym_COMMA] = ACTIONS(1411),
    [anon_sym_PIPE] = ACTIONS(1413),
    [anon_sym_SEMI] = ACTIONS(1411),
    [anon_sym_STAR] = ACTIONS(1413),
    [anon_sym_STAR_STAR] = ACTIONS(1413),
    [anon_sym_AMP] = ACTIONS(1413),
    [anon_sym_EQ] = ACTIONS(1413),
    [anon_sym_class] = ACTIONS(1413),
    [anon_sym_LT] = ACTIONS(1413),
    [anon_sym_module] = ACTIONS(1413),
    [anon_sym_end] = ACTIONS(1413),
    [anon_sym_return] = ACTIONS(1413),
    [anon_sym_yield] = ACTIONS(1413),
    [anon_sym_break] = ACTIONS(1413),
    [anon_sym_next] = ACTIONS(1413),
    [sym_redo] = ACTIONS(1413),
    [sym_retry] = ACTIONS(1413),
    [anon_sym_if] = ACTIONS(1413),
    [anon_sym_unless] = ACTIONS(1413),
    [anon_sym_while] = ACTIONS(1413),
    [anon_sym_until] = ACTIONS(1413),
    [anon_sym_rescue] = ACTIONS(1413),
    [anon_sym_for] = ACTIONS(1413),
    [anon_sym_do] = ACTIONS(1413),
    [anon_sym_case] = ACTIONS(1413),
    [anon_sym_when] = ACTIONS(1413),
    [anon_sym_elsif] = ACTIONS(1413),
    [anon_sym_else] = ACTIONS(1413),
    [anon_sym_then] = ACTIONS(1413),
    [anon_sym_begin] = ACTIONS(1413),
    [anon_sym_ensure] = ACTIONS(1413),
    [anon_sym_LBRACK] = ACTIONS(1411),
    [anon_sym_COLON_COLON2] = ACTIONS(1411),
    [anon_sym_AMP_DOT] = ACTIONS(1411),
    [anon_sym_LPAREN2] = ACTIONS(1411),
    [anon_sym_PLUS_EQ] = ACTIONS(1411),
    [anon_sym_DASH_EQ] = ACTIONS(1411),
    [anon_sym_STAR_EQ] = ACTIONS(1411),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1411),
    [anon_sym_SLASH_EQ] = ACTIONS(1411),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1411),
    [anon_sym_PIPE_EQ] = ACTIONS(1411),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1411),
    [anon_sym_AMP_EQ] = ACTIONS(1411),
    [anon_sym_PERCENT_EQ] = ACTIONS(1411),
    [anon_sym_GT_GT_EQ] = ACTIONS(1411),
    [anon_sym_LT_LT_EQ] = ACTIONS(1411),
    [anon_sym_CARET_EQ] = ACTIONS(1411),
    [anon_sym_QMARK] = ACTIONS(1413),
    [anon_sym_DOT_DOT] = ACTIONS(1413),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1411),
    [anon_sym_and] = ACTIONS(1413),
    [anon_sym_or] = ACTIONS(1413),
    [anon_sym_PIPE_PIPE] = ACTIONS(1413),
    [anon_sym_AMP_AMP] = ACTIONS(1413),
    [anon_sym_LT_LT] = ACTIONS(1413),
    [anon_sym_GT_GT] = ACTIONS(1413),
    [anon_sym_EQ_EQ] = ACTIONS(1413),
    [anon_sym_BANG_EQ] = ACTIONS(1411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1411),
    [anon_sym_LT_EQ_GT] = ACTIONS(1411),
    [anon_sym_EQ_TILDE] = ACTIONS(1411),
    [anon_sym_BANG_TILDE] = ACTIONS(1411),
    [anon_sym_LT_EQ] = ACTIONS(1413),
    [anon_sym_GT] = ACTIONS(1413),
    [anon_sym_GT_EQ] = ACTIONS(1411),
    [anon_sym_CARET] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_SLASH] = ACTIONS(1413),
    [anon_sym_PERCENT] = ACTIONS(1413),
    [anon_sym_defined_QMARK] = ACTIONS(1411),
    [anon_sym_not] = ACTIONS(1413),
    [anon_sym_BANG] = ACTIONS(1413),
    [anon_sym_TILDE] = ACTIONS(1411),
    [sym_constant] = ACTIONS(1413),
    [sym_identifier] = ACTIONS(1413),
    [sym_instance_variable] = ACTIONS(1411),
    [sym_class_variable] = ACTIONS(1411),
    [sym_global_variable] = ACTIONS(1411),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1413),
    [sym_float] = ACTIONS(1413),
    [sym_complex] = ACTIONS(1411),
    [sym_super] = ACTIONS(1413),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_TRUE] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_FALSE] = ACTIONS(1413),
    [sym_self] = ACTIONS(1413),
    [anon_sym_nil] = ACTIONS(1413),
    [anon_sym_NIL] = ACTIONS(1413),
    [sym_character] = ACTIONS(1411),
    [anon_sym_LBRACK2] = ACTIONS(1413),
    [anon_sym_DASH_GT] = ACTIONS(1411),
  },
  [154] = {
    [anon_sym_RBRACE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_unless] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_until] = ACTIONS(101),
    [anon_sym_rescue] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_COLON_COLON2] = ACTIONS(101),
    [anon_sym_AMP_DOT] = ACTIONS(101),
    [sym_comment] = ACTIONS(87),
  },
  [155] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(753),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(1415),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [156] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(755),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(1417),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [157] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(757),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(1419),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [158] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(759),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(1421),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [159] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(762),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(1423),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(1425),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [160] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(765),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(1427),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(1429),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [161] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(113),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(118),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(118),
    [sym_hash_splat_argument] = STATE(116),
    [sym_assignment] = STATE(113),
    [sym_operator_assignment] = STATE(113),
    [sym_conditional] = STATE(113),
    [sym_range] = STATE(113),
    [sym_binary] = STATE(113),
    [sym_unary] = STATE(113),
    [sym_left_assignment_list] = STATE(117),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(118),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(118),
    [sym_false] = STATE(118),
    [sym_nil] = STATE(118),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(119),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_heredoc_body] = STATE(767),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym__hash_items] = STATE(768),
    [sym_pair] = STATE(122),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [sym__identifier_hash_key] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_RBRACE] = ACTIONS(1431),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(209),
    [sym_identifier] = ACTIONS(209),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [162] = {
    [sym__method_rest] = STATE(770),
    [sym__variable] = STATE(771),
    [sym_operator] = STATE(772),
    [sym__method_name] = STATE(772),
    [sym_setter] = STATE(772),
    [sym_symbol] = STATE(772),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_LPAREN] = ACTIONS(1433),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(239),
    [sym_identifier] = ACTIONS(241),
    [sym_instance_variable] = ACTIONS(239),
    [sym_class_variable] = ACTIONS(239),
    [sym_global_variable] = ACTIONS(239),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
    [sym_super] = ACTIONS(1435),
    [sym_self] = ACTIONS(1435),
  },
  [163] = {
    [sym__statements] = STATE(774),
    [sym_begin_block] = STATE(144),
    [sym_end_block] = STATE(144),
    [sym__statement] = STATE(144),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(144),
    [sym_unless_modifier] = STATE(144),
    [sym_while_modifier] = STATE(144),
    [sym_until_modifier] = STATE(144),
    [sym_rescue_modifier] = STATE(144),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(145),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(686),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(686),
    [sym_assignment] = STATE(145),
    [sym_operator_assignment] = STATE(145),
    [sym_conditional] = STATE(145),
    [sym_range] = STATE(145),
    [sym_binary] = STATE(145),
    [sym_unary] = STATE(145),
    [sym_left_assignment_list] = STATE(147),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(686),
    [sym__variable] = STATE(146),
    [sym_undef] = STATE(144),
    [sym_alias] = STATE(144),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(686),
    [sym_false] = STATE(686),
    [sym_nil] = STATE(686),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(151),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(152),
    [aux_sym__statements_repeat1] = STATE(152),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_RPAREN] = ACTIONS(1437),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [anon_sym_undef] = ACTIONS(271),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [164] = {
    [sym_constant] = ACTIONS(1439),
    [sym_identifier] = ACTIONS(1439),
    [sym_comment] = ACTIONS(87),
  },
  [165] = {
    [sym_method] = STATE(191),
    [sym_singleton_method] = STATE(191),
    [sym_class] = STATE(191),
    [sym_singleton_class] = STATE(191),
    [sym_module] = STATE(191),
    [sym_return] = STATE(191),
    [sym_yield] = STATE(191),
    [sym_break] = STATE(191),
    [sym_next] = STATE(191),
    [sym_while] = STATE(191),
    [sym_until] = STATE(191),
    [sym_for] = STATE(191),
    [sym_case] = STATE(191),
    [sym_if] = STATE(191),
    [sym_unless] = STATE(191),
    [sym_begin] = STATE(191),
    [sym__primary] = STATE(191),
    [sym_parenthesized_statements] = STATE(191),
    [sym_element_reference] = STATE(191),
    [sym_scope_resolution] = STATE(778),
    [sym_call] = STATE(193),
    [sym_method_call] = STATE(191),
    [sym__lhs] = STATE(191),
    [sym__variable] = STATE(193),
    [sym_rational] = STATE(191),
    [sym_true] = STATE(191),
    [sym_false] = STATE(191),
    [sym_nil] = STATE(191),
    [sym_chained_string] = STATE(191),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(191),
    [sym_string_array] = STATE(191),
    [sym_symbol_array] = STATE(191),
    [sym_symbol] = STATE(191),
    [sym_regex] = STATE(191),
    [sym_array] = STATE(191),
    [sym_hash] = STATE(191),
    [sym_lambda] = STATE(191),
    [sym__simple_symbol] = ACTIONS(279),
    [sym__string_start] = ACTIONS(281),
    [sym__symbol_start] = ACTIONS(283),
    [sym__subshell_start] = ACTIONS(285),
    [sym__regex_start] = ACTIONS(287),
    [sym__string_array_start] = ACTIONS(289),
    [sym__symbol_array_start] = ACTIONS(291),
    [sym_heredoc_beginning] = ACTIONS(349),
    [sym__singleton_class_left_angle_left_langle] = ACTIONS(1441),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_def] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(299),
    [anon_sym_COLON_COLON] = ACTIONS(353),
    [anon_sym_class] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(307),
    [anon_sym_return] = ACTIONS(309),
    [anon_sym_yield] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_next] = ACTIONS(315),
    [sym_redo] = ACTIONS(355),
    [sym_retry] = ACTIONS(355),
    [anon_sym_if] = ACTIONS(319),
    [anon_sym_unless] = ACTIONS(321),
    [anon_sym_while] = ACTIONS(323),
    [anon_sym_until] = ACTIONS(325),
    [anon_sym_for] = ACTIONS(327),
    [anon_sym_case] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(331),
    [sym_constant] = ACTIONS(1443),
    [sym_identifier] = ACTIONS(359),
    [sym_instance_variable] = ACTIONS(361),
    [sym_class_variable] = ACTIONS(361),
    [sym_global_variable] = ACTIONS(361),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(355),
    [sym_complex] = ACTIONS(349),
    [sym_super] = ACTIONS(359),
    [anon_sym_true] = ACTIONS(339),
    [anon_sym_TRUE] = ACTIONS(339),
    [anon_sym_false] = ACTIONS(341),
    [anon_sym_FALSE] = ACTIONS(341),
    [sym_self] = ACTIONS(359),
    [anon_sym_nil] = ACTIONS(343),
    [anon_sym_NIL] = ACTIONS(343),
    [sym_character] = ACTIONS(349),
    [anon_sym_LBRACK2] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(347),
  },
  [166] = {
    [sym_method] = STATE(191),
    [sym_singleton_method] = STATE(191),
    [sym_class] = STATE(191),
    [sym_singleton_class] = STATE(191),
    [sym_module] = STATE(191),
    [sym_return] = STATE(191),
    [sym_yield] = STATE(191),
    [sym_break] = STATE(191),
    [sym_next] = STATE(191),
    [sym_while] = STATE(191),
    [sym_until] = STATE(191),
    [sym_for] = STATE(191),
    [sym_case] = STATE(191),
    [sym_if] = STATE(191),
    [sym_unless] = STATE(191),
    [sym_begin] = STATE(191),
    [sym__primary] = STATE(191),
    [sym_parenthesized_statements] = STATE(191),
    [sym_element_reference] = STATE(191),
    [sym_scope_resolution] = STATE(780),
    [sym_call] = STATE(193),
    [sym_method_call] = STATE(191),
    [sym__lhs] = STATE(191),
    [sym__variable] = STATE(193),
    [sym_rational] = STATE(191),
    [sym_true] = STATE(191),
    [sym_false] = STATE(191),
    [sym_nil] = STATE(191),
    [sym_chained_string] = STATE(191),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(191),
    [sym_string_array] = STATE(191),
    [sym_symbol_array] = STATE(191),
    [sym_symbol] = STATE(191),
    [sym_regex] = STATE(191),
    [sym_array] = STATE(191),
    [sym_hash] = STATE(191),
    [sym_lambda] = STATE(191),
    [sym__simple_symbol] = ACTIONS(279),
    [sym__string_start] = ACTIONS(281),
    [sym__symbol_start] = ACTIONS(283),
    [sym__subshell_start] = ACTIONS(285),
    [sym__regex_start] = ACTIONS(287),
    [sym__string_array_start] = ACTIONS(289),
    [sym__symbol_array_start] = ACTIONS(291),
    [sym_heredoc_beginning] = ACTIONS(349),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_def] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(299),
    [anon_sym_COLON_COLON] = ACTIONS(353),
    [anon_sym_class] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(307),
    [anon_sym_return] = ACTIONS(309),
    [anon_sym_yield] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_next] = ACTIONS(315),
    [sym_redo] = ACTIONS(355),
    [sym_retry] = ACTIONS(355),
    [anon_sym_if] = ACTIONS(319),
    [anon_sym_unless] = ACTIONS(321),
    [anon_sym_while] = ACTIONS(323),
    [anon_sym_until] = ACTIONS(325),
    [anon_sym_for] = ACTIONS(327),
    [anon_sym_case] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(331),
    [sym_constant] = ACTIONS(1445),
    [sym_identifier] = ACTIONS(359),
    [sym_instance_variable] = ACTIONS(361),
    [sym_class_variable] = ACTIONS(361),
    [sym_global_variable] = ACTIONS(361),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(355),
    [sym_complex] = ACTIONS(349),
    [sym_super] = ACTIONS(359),
    [anon_sym_true] = ACTIONS(339),
    [anon_sym_TRUE] = ACTIONS(339),
    [anon_sym_false] = ACTIONS(341),
    [anon_sym_FALSE] = ACTIONS(341),
    [sym_self] = ACTIONS(359),
    [anon_sym_nil] = ACTIONS(343),
    [anon_sym_NIL] = ACTIONS(343),
    [sym_character] = ACTIONS(349),
    [anon_sym_LBRACK2] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(347),
  },
  [167] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(787),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(567),
    [sym_scope_resolution] = STATE(562),
    [sym_call] = STATE(562),
    [sym_method_call] = STATE(567),
    [sym_argument_list] = STATE(788),
    [sym__argument_list_with_parens] = STATE(789),
    [sym__argument] = STATE(790),
    [sym_splat_argument] = STATE(790),
    [sym_hash_splat_argument] = STATE(790),
    [sym_block_argument] = STATE(790),
    [sym_assignment] = STATE(787),
    [sym_operator_assignment] = STATE(787),
    [sym_conditional] = STATE(787),
    [sym_range] = STATE(787),
    [sym_binary] = STATE(787),
    [sym_unary] = STATE(787),
    [sym_left_assignment_list] = STATE(566),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(567),
    [sym__variable] = STATE(562),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(567),
    [sym_false] = STATE(567),
    [sym_nil] = STATE(567),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(791),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(790),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1447),
    [sym__splat_star] = ACTIONS(1449),
    [sym__unary_minus] = ACTIONS(1049),
    [sym__identifier_hash_key] = ACTIONS(1451),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(365),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1453),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1459),
    [sym_identifier] = ACTIONS(1459),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [168] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(787),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(567),
    [sym_scope_resolution] = STATE(562),
    [sym_call] = STATE(562),
    [sym_method_call] = STATE(567),
    [sym_argument_list] = STATE(792),
    [sym__argument_list_with_parens] = STATE(789),
    [sym__argument] = STATE(790),
    [sym_splat_argument] = STATE(790),
    [sym_hash_splat_argument] = STATE(790),
    [sym_block_argument] = STATE(790),
    [sym_assignment] = STATE(787),
    [sym_operator_assignment] = STATE(787),
    [sym_conditional] = STATE(787),
    [sym_range] = STATE(787),
    [sym_binary] = STATE(787),
    [sym_unary] = STATE(787),
    [sym_left_assignment_list] = STATE(566),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(567),
    [sym__variable] = STATE(562),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(567),
    [sym_false] = STATE(567),
    [sym_nil] = STATE(567),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(791),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(790),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1447),
    [sym__splat_star] = ACTIONS(1449),
    [sym__unary_minus] = ACTIONS(1049),
    [sym__identifier_hash_key] = ACTIONS(1451),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1453),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1459),
    [sym_identifier] = ACTIONS(1459),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [169] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(787),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(567),
    [sym_scope_resolution] = STATE(562),
    [sym_call] = STATE(562),
    [sym_method_call] = STATE(567),
    [sym_argument_list] = STATE(793),
    [sym__argument_list_with_parens] = STATE(789),
    [sym__argument] = STATE(790),
    [sym_splat_argument] = STATE(790),
    [sym_hash_splat_argument] = STATE(790),
    [sym_block_argument] = STATE(790),
    [sym_assignment] = STATE(787),
    [sym_operator_assignment] = STATE(787),
    [sym_conditional] = STATE(787),
    [sym_range] = STATE(787),
    [sym_binary] = STATE(787),
    [sym_unary] = STATE(787),
    [sym_left_assignment_list] = STATE(566),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(567),
    [sym__variable] = STATE(562),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(567),
    [sym_false] = STATE(567),
    [sym_nil] = STATE(567),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(791),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(790),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1447),
    [sym__splat_star] = ACTIONS(1449),
    [sym__unary_minus] = ACTIONS(1049),
    [sym__identifier_hash_key] = ACTIONS(1451),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1453),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1459),
    [sym_identifier] = ACTIONS(1459),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [170] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(787),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(567),
    [sym_scope_resolution] = STATE(562),
    [sym_call] = STATE(562),
    [sym_method_call] = STATE(567),
    [sym_argument_list] = STATE(794),
    [sym__argument_list_with_parens] = STATE(789),
    [sym__argument] = STATE(790),
    [sym_splat_argument] = STATE(790),
    [sym_hash_splat_argument] = STATE(790),
    [sym_block_argument] = STATE(790),
    [sym_assignment] = STATE(787),
    [sym_operator_assignment] = STATE(787),
    [sym_conditional] = STATE(787),
    [sym_range] = STATE(787),
    [sym_binary] = STATE(787),
    [sym_unary] = STATE(787),
    [sym_left_assignment_list] = STATE(566),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(567),
    [sym__variable] = STATE(562),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(567),
    [sym_false] = STATE(567),
    [sym_nil] = STATE(567),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(791),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(790),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1447),
    [sym__splat_star] = ACTIONS(1449),
    [sym__unary_minus] = ACTIONS(1049),
    [sym__identifier_hash_key] = ACTIONS(1451),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1453),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1459),
    [sym_identifier] = ACTIONS(1459),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [171] = {
    [sym_begin_block] = STATE(795),
    [sym_end_block] = STATE(795),
    [sym__statement] = STATE(795),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(795),
    [sym_unless_modifier] = STATE(795),
    [sym_while_modifier] = STATE(795),
    [sym_until_modifier] = STATE(795),
    [sym_rescue_modifier] = STATE(795),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(234),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(234),
    [sym_operator_assignment] = STATE(234),
    [sym_conditional] = STATE(234),
    [sym_range] = STATE(234),
    [sym_binary] = STATE(234),
    [sym_unary] = STATE(234),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_undef] = STATE(795),
    [sym_alias] = STATE(795),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(429),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_yield] = ACTIONS(433),
    [anon_sym_break] = ACTIONS(435),
    [anon_sym_next] = ACTIONS(437),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(439),
    [anon_sym_defined_QMARK] = ACTIONS(441),
    [anon_sym_not] = ACTIONS(443),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [anon_sym_undef] = ACTIONS(451),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [172] = {
    [sym_begin_block] = STATE(796),
    [sym_end_block] = STATE(796),
    [sym__statement] = STATE(796),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(796),
    [sym_unless_modifier] = STATE(796),
    [sym_while_modifier] = STATE(796),
    [sym_until_modifier] = STATE(796),
    [sym_rescue_modifier] = STATE(796),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(234),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(234),
    [sym_operator_assignment] = STATE(234),
    [sym_conditional] = STATE(234),
    [sym_range] = STATE(234),
    [sym_binary] = STATE(234),
    [sym_unary] = STATE(234),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_undef] = STATE(796),
    [sym_alias] = STATE(796),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(429),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_yield] = ACTIONS(433),
    [anon_sym_break] = ACTIONS(435),
    [anon_sym_next] = ACTIONS(437),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(439),
    [anon_sym_defined_QMARK] = ACTIONS(441),
    [anon_sym_not] = ACTIONS(443),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [anon_sym_undef] = ACTIONS(451),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [173] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(797),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(797),
    [sym_operator_assignment] = STATE(797),
    [sym_conditional] = STATE(797),
    [sym_range] = STATE(797),
    [sym_binary] = STATE(797),
    [sym_unary] = STATE(797),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(455),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_break] = ACTIONS(459),
    [anon_sym_next] = ACTIONS(461),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_defined_QMARK] = ACTIONS(465),
    [anon_sym_not] = ACTIONS(467),
    [anon_sym_BANG] = ACTIONS(469),
    [anon_sym_TILDE] = ACTIONS(469),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [174] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(798),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(798),
    [sym_operator_assignment] = STATE(798),
    [sym_conditional] = STATE(798),
    [sym_range] = STATE(798),
    [sym_binary] = STATE(798),
    [sym_unary] = STATE(798),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(455),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_break] = ACTIONS(459),
    [anon_sym_next] = ACTIONS(461),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_defined_QMARK] = ACTIONS(465),
    [anon_sym_not] = ACTIONS(467),
    [anon_sym_BANG] = ACTIONS(469),
    [anon_sym_TILDE] = ACTIONS(469),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [175] = {
    [sym_method] = STATE(184),
    [sym_singleton_method] = STATE(184),
    [sym_class] = STATE(184),
    [sym_singleton_class] = STATE(184),
    [sym_module] = STATE(184),
    [sym_return] = STATE(184),
    [sym_yield] = STATE(184),
    [sym_break] = STATE(184),
    [sym_next] = STATE(184),
    [sym_while] = STATE(184),
    [sym_until] = STATE(184),
    [sym_for] = STATE(184),
    [sym_case] = STATE(184),
    [sym_if] = STATE(184),
    [sym_unless] = STATE(184),
    [sym_begin] = STATE(184),
    [sym__primary] = STATE(184),
    [sym_parenthesized_statements] = STATE(184),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(255),
    [sym_call] = STATE(255),
    [sym_method_call] = STATE(258),
    [sym__mlhs] = STATE(799),
    [sym_destructured_left_assignment] = STATE(257),
    [sym_rest_assignment] = STATE(257),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(255),
    [sym_rational] = STATE(184),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(184),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(184),
    [sym_string_array] = STATE(184),
    [sym_symbol_array] = STATE(184),
    [sym_symbol] = STATE(184),
    [sym_regex] = STATE(184),
    [sym_array] = STATE(184),
    [sym_hash] = STATE(184),
    [sym_lambda] = STATE(184),
    [sym__simple_symbol] = ACTIONS(279),
    [sym__string_start] = ACTIONS(281),
    [sym__symbol_start] = ACTIONS(283),
    [sym__subshell_start] = ACTIONS(285),
    [sym__regex_start] = ACTIONS(287),
    [sym__string_array_start] = ACTIONS(289),
    [sym__symbol_array_start] = ACTIONS(291),
    [sym_heredoc_beginning] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_def] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(475),
    [anon_sym_COLON_COLON] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(477),
    [anon_sym_class] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(307),
    [anon_sym_return] = ACTIONS(309),
    [anon_sym_yield] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_next] = ACTIONS(315),
    [sym_redo] = ACTIONS(317),
    [sym_retry] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(319),
    [anon_sym_unless] = ACTIONS(321),
    [anon_sym_while] = ACTIONS(323),
    [anon_sym_until] = ACTIONS(325),
    [anon_sym_for] = ACTIONS(327),
    [anon_sym_case] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(331),
    [sym_constant] = ACTIONS(479),
    [sym_identifier] = ACTIONS(479),
    [sym_instance_variable] = ACTIONS(481),
    [sym_class_variable] = ACTIONS(481),
    [sym_global_variable] = ACTIONS(481),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(317),
    [sym_complex] = ACTIONS(293),
    [sym_super] = ACTIONS(479),
    [anon_sym_true] = ACTIONS(339),
    [anon_sym_TRUE] = ACTIONS(339),
    [anon_sym_false] = ACTIONS(341),
    [anon_sym_FALSE] = ACTIONS(341),
    [sym_self] = ACTIONS(479),
    [anon_sym_nil] = ACTIONS(343),
    [anon_sym_NIL] = ACTIONS(343),
    [sym_character] = ACTIONS(293),
    [anon_sym_LBRACK2] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(347),
  },
  [176] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(800),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(800),
    [sym_operator_assignment] = STATE(800),
    [sym_conditional] = STATE(800),
    [sym_range] = STATE(800),
    [sym_binary] = STATE(800),
    [sym_unary] = STATE(800),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_heredoc_body] = STATE(801),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__terminator] = STATE(801),
    [sym__line_break] = ACTIONS(1461),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(485),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(1461),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(495),
    [anon_sym_defined_QMARK] = ACTIONS(497),
    [anon_sym_not] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(501),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [177] = {
    [sym__statements] = STATE(802),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(803),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(804),
    [sym_rescue] = STATE(805),
    [sym__body_statement] = STATE(806),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_heredoc_body] = STATE(807),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [sym__terminator] = STATE(807),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__line_break] = ACTIONS(1463),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(1463),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(1465),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [178] = {
    [anon_sym_DOT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
    [anon_sym_r] = ACTIONS(1467),
  },
  [179] = {
    [anon_sym_RPAREN] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(565),
    [anon_sym_COMMA] = ACTIONS(565),
    [anon_sym_EQ] = ACTIONS(565),
    [anon_sym_in] = ACTIONS(565),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_COLON_COLON2] = ACTIONS(565),
    [anon_sym_AMP_DOT] = ACTIONS(565),
    [sym_comment] = ACTIONS(87),
  },
  [180] = {
    [anon_sym_RPAREN] = ACTIONS(569),
    [anon_sym_DOT] = ACTIONS(569),
    [anon_sym_COMMA] = ACTIONS(569),
    [anon_sym_EQ] = ACTIONS(569),
    [anon_sym_in] = ACTIONS(569),
    [anon_sym_LBRACK] = ACTIONS(569),
    [anon_sym_COLON_COLON2] = ACTIONS(569),
    [anon_sym_AMP_DOT] = ACTIONS(569),
    [sym_comment] = ACTIONS(87),
  },
  [181] = {
    [anon_sym_RPAREN] = ACTIONS(573),
    [anon_sym_DOT] = ACTIONS(573),
    [anon_sym_COMMA] = ACTIONS(573),
    [anon_sym_EQ] = ACTIONS(573),
    [anon_sym_in] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(573),
    [anon_sym_COLON_COLON2] = ACTIONS(573),
    [anon_sym_AMP_DOT] = ACTIONS(573),
    [sym_comment] = ACTIONS(87),
  },
  [182] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(346),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(352),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(352),
    [sym__argument_list_with_trailing_comma] = STATE(810),
    [sym__argument] = STATE(350),
    [sym_splat_argument] = STATE(350),
    [sym_hash_splat_argument] = STATE(350),
    [sym_block_argument] = STATE(350),
    [sym_assignment] = STATE(346),
    [sym_operator_assignment] = STATE(346),
    [sym_conditional] = STATE(346),
    [sym_range] = STATE(346),
    [sym_binary] = STATE(346),
    [sym_unary] = STATE(346),
    [sym_left_assignment_list] = STATE(351),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(352),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(352),
    [sym_false] = STATE(352),
    [sym_nil] = STATE(352),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(353),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(350),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(593),
    [sym__splat_star] = ACTIONS(595),
    [sym__unary_minus] = ACTIONS(597),
    [sym__identifier_hash_key] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(1469),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [183] = {
    [sym_lambda_parameters] = STATE(813),
    [sym__simple_formal_parameter] = STATE(362),
    [sym_splat_parameter] = STATE(362),
    [sym_hash_splat_parameter] = STATE(362),
    [sym_block_parameter] = STATE(362),
    [sym_keyword_parameter] = STATE(362),
    [sym_optional_parameter] = STATE(362),
    [sym_do_block] = STATE(814),
    [sym_block] = STATE(814),
    [anon_sym_LBRACE] = ACTIONS(1471),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(1473),
    [sym_identifier] = ACTIONS(679),
    [sym_comment] = ACTIONS(87),
  },
  [184] = {
    [anon_sym_DOT] = ACTIONS(1475),
    [anon_sym_LBRACK] = ACTIONS(1477),
    [anon_sym_COLON_COLON2] = ACTIONS(1479),
    [anon_sym_AMP_DOT] = ACTIONS(1475),
    [sym_comment] = ACTIONS(87),
  },
  [185] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(831),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(837),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(837),
    [sym_argument_list] = STATE(832),
    [sym__argument_list_with_parens] = STATE(833),
    [sym__argument] = STATE(834),
    [sym_splat_argument] = STATE(834),
    [sym_hash_splat_argument] = STATE(834),
    [sym_block_argument] = STATE(834),
    [sym_do_block] = STATE(835),
    [sym_block] = STATE(835),
    [sym_assignment] = STATE(831),
    [sym_operator_assignment] = STATE(831),
    [sym_conditional] = STATE(831),
    [sym_range] = STATE(831),
    [sym_binary] = STATE(831),
    [sym_unary] = STATE(831),
    [sym_left_assignment_list] = STATE(836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(837),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(837),
    [sym_false] = STATE(837),
    [sym_nil] = STATE(837),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(838),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(834),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1481),
    [sym__splat_star] = ACTIONS(1483),
    [sym__unary_minus] = ACTIONS(1485),
    [sym__identifier_hash_key] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1489),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(743),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1491),
    [anon_sym_EQ] = ACTIONS(743),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1493),
    [anon_sym_yield] = ACTIONS(1495),
    [anon_sym_break] = ACTIONS(1497),
    [anon_sym_next] = ACTIONS(1499),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1473),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1507),
    [anon_sym_TILDE] = ACTIONS(1507),
    [sym_constant] = ACTIONS(1509),
    [sym_identifier] = ACTIONS(1509),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [186] = {
    [anon_sym_RPAREN] = ACTIONS(1511),
    [anon_sym_DOT] = ACTIONS(559),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_EQ] = ACTIONS(1511),
    [anon_sym_in] = ACTIONS(1511),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [187] = {
    [sym_string] = STATE(839),
    [aux_sym_chained_string_repeat1] = STATE(839),
    [sym__string_start] = ACTIONS(281),
    [anon_sym_DOT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [188] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(840),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(840),
    [sym_operator_assignment] = STATE(840),
    [sym_conditional] = STATE(840),
    [sym_range] = STATE(840),
    [sym_binary] = STATE(840),
    [sym_unary] = STATE(840),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(485),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(495),
    [anon_sym_defined_QMARK] = ACTIONS(497),
    [anon_sym_not] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(501),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [189] = {
    [sym_constant] = ACTIONS(1513),
    [sym_identifier] = ACTIONS(1513),
    [sym_comment] = ACTIONS(87),
  },
  [190] = {
    [sym_superclass] = STATE(843),
    [sym_heredoc_body] = STATE(844),
    [sym__terminator] = STATE(844),
    [sym__line_break] = ACTIONS(1515),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1089),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1515),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1089),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1517),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1089),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [191] = {
    [anon_sym_DOT] = ACTIONS(1475),
    [anon_sym_LBRACK] = ACTIONS(1477),
    [anon_sym_COLON_COLON2] = ACTIONS(1519),
    [anon_sym_AMP_DOT] = ACTIONS(1475),
    [sym_comment] = ACTIONS(87),
  },
  [192] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_superclass] = STATE(843),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(859),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym_argument_list] = STATE(832),
    [sym__argument_list_with_parens] = STATE(860),
    [sym__argument] = STATE(861),
    [sym_splat_argument] = STATE(861),
    [sym_hash_splat_argument] = STATE(861),
    [sym_block_argument] = STATE(861),
    [sym_do_block] = STATE(835),
    [sym_block] = STATE(835),
    [sym_assignment] = STATE(859),
    [sym_operator_assignment] = STATE(859),
    [sym_conditional] = STATE(859),
    [sym_range] = STATE(859),
    [sym_binary] = STATE(859),
    [sym_unary] = STATE(859),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(864),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_heredoc_body] = STATE(844),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(861),
    [sym_lambda] = STATE(347),
    [sym__terminator] = STATE(844),
    [sym__line_break] = ACTIONS(1515),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1521),
    [sym__splat_star] = ACTIONS(1523),
    [sym__unary_minus] = ACTIONS(1525),
    [sym__identifier_hash_key] = ACTIONS(1527),
    [anon_sym_LBRACE] = ACTIONS(1529),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(743),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(1515),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1531),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(1517),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1473),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(1549),
    [sym_identifier] = ACTIONS(1549),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [193] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(859),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym_argument_list] = STATE(832),
    [sym__argument_list_with_parens] = STATE(860),
    [sym__argument] = STATE(861),
    [sym_splat_argument] = STATE(861),
    [sym_hash_splat_argument] = STATE(861),
    [sym_block_argument] = STATE(861),
    [sym_do_block] = STATE(835),
    [sym_block] = STATE(835),
    [sym_assignment] = STATE(859),
    [sym_operator_assignment] = STATE(859),
    [sym_conditional] = STATE(859),
    [sym_range] = STATE(859),
    [sym_binary] = STATE(859),
    [sym_unary] = STATE(859),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(864),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(861),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1521),
    [sym__splat_star] = ACTIONS(1523),
    [sym__unary_minus] = ACTIONS(1525),
    [sym__identifier_hash_key] = ACTIONS(1527),
    [anon_sym_LBRACE] = ACTIONS(1529),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(743),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1531),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1473),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(1549),
    [sym_identifier] = ACTIONS(1549),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [194] = {
    [sym_heredoc_body] = STATE(866),
    [sym__terminator] = STATE(866),
    [sym__line_break] = ACTIONS(1551),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1089),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1551),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1089),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(1553),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1089),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [195] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(859),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym_argument_list] = STATE(832),
    [sym__argument_list_with_parens] = STATE(860),
    [sym__argument] = STATE(861),
    [sym_splat_argument] = STATE(861),
    [sym_hash_splat_argument] = STATE(861),
    [sym_block_argument] = STATE(861),
    [sym_do_block] = STATE(835),
    [sym_block] = STATE(835),
    [sym_assignment] = STATE(859),
    [sym_operator_assignment] = STATE(859),
    [sym_conditional] = STATE(859),
    [sym_range] = STATE(859),
    [sym_binary] = STATE(859),
    [sym_unary] = STATE(859),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(864),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_heredoc_body] = STATE(866),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(861),
    [sym_lambda] = STATE(347),
    [sym__terminator] = STATE(866),
    [sym__line_break] = ACTIONS(1551),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1521),
    [sym__splat_star] = ACTIONS(1523),
    [sym__unary_minus] = ACTIONS(1525),
    [sym__identifier_hash_key] = ACTIONS(1527),
    [anon_sym_LBRACE] = ACTIONS(1529),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(743),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(1551),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1531),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_end] = ACTIONS(1553),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1473),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(1549),
    [sym_identifier] = ACTIONS(1549),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [196] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(874),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(876),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(876),
    [sym_assignment] = STATE(874),
    [sym_operator_assignment] = STATE(874),
    [sym_conditional] = STATE(874),
    [sym_range] = STATE(874),
    [sym_binary] = STATE(874),
    [sym_unary] = STATE(874),
    [sym_left_assignment_list] = STATE(875),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(876),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(876),
    [sym_false] = STATE(876),
    [sym_nil] = STATE(876),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(877),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(1555),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1557),
    [anon_sym_yield] = ACTIONS(1559),
    [anon_sym_break] = ACTIONS(1561),
    [anon_sym_next] = ACTIONS(1563),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_defined_QMARK] = ACTIONS(1567),
    [anon_sym_not] = ACTIONS(1569),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_TILDE] = ACTIONS(1571),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [197] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(878),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(876),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(876),
    [sym_assignment] = STATE(878),
    [sym_operator_assignment] = STATE(878),
    [sym_conditional] = STATE(878),
    [sym_range] = STATE(878),
    [sym_binary] = STATE(878),
    [sym_unary] = STATE(878),
    [sym_left_assignment_list] = STATE(875),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(876),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(876),
    [sym_false] = STATE(876),
    [sym_nil] = STATE(876),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(877),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(1555),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1557),
    [anon_sym_yield] = ACTIONS(1559),
    [anon_sym_break] = ACTIONS(1561),
    [anon_sym_next] = ACTIONS(1563),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_defined_QMARK] = ACTIONS(1567),
    [anon_sym_not] = ACTIONS(1569),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_TILDE] = ACTIONS(1571),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [198] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(879),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_assignment] = STATE(879),
    [sym_operator_assignment] = STATE(879),
    [sym_conditional] = STATE(879),
    [sym_range] = STATE(879),
    [sym_binary] = STATE(879),
    [sym_unary] = STATE(879),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(880),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(373),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(383),
    [anon_sym_yield] = ACTIONS(385),
    [anon_sym_break] = ACTIONS(387),
    [anon_sym_next] = ACTIONS(389),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1575),
    [anon_sym_defined_QMARK] = ACTIONS(395),
    [anon_sym_not] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_TILDE] = ACTIONS(401),
    [sym_constant] = ACTIONS(407),
    [sym_identifier] = ACTIONS(407),
    [sym_instance_variable] = ACTIONS(405),
    [sym_class_variable] = ACTIONS(405),
    [sym_global_variable] = ACTIONS(405),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(407),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(407),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [199] = {
    [anon_sym_COLON] = ACTIONS(1577),
    [sym_comment] = ACTIONS(87),
  },
  [200] = {
    [sym_constant] = ACTIONS(1579),
    [sym_identifier] = ACTIONS(1579),
    [sym_comment] = ACTIONS(87),
  },
  [201] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(883),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(876),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(876),
    [sym_assignment] = STATE(883),
    [sym_operator_assignment] = STATE(883),
    [sym_conditional] = STATE(883),
    [sym_range] = STATE(883),
    [sym_binary] = STATE(883),
    [sym_unary] = STATE(883),
    [sym_left_assignment_list] = STATE(875),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(876),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(876),
    [sym_false] = STATE(876),
    [sym_nil] = STATE(876),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(877),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(1555),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1557),
    [anon_sym_yield] = ACTIONS(1559),
    [anon_sym_break] = ACTIONS(1561),
    [anon_sym_next] = ACTIONS(1563),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_defined_QMARK] = ACTIONS(1567),
    [anon_sym_not] = ACTIONS(1569),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_TILDE] = ACTIONS(1571),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [202] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(889),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(890),
    [sym__argument] = STATE(891),
    [sym_splat_argument] = STATE(891),
    [sym_hash_splat_argument] = STATE(891),
    [sym_block_argument] = STATE(891),
    [sym_assignment] = STATE(889),
    [sym_operator_assignment] = STATE(889),
    [sym_conditional] = STATE(889),
    [sym_range] = STATE(889),
    [sym_binary] = STATE(889),
    [sym_unary] = STATE(889),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(892),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(891),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(1581),
    [sym__splat_star] = ACTIONS(1583),
    [sym__unary_minus] = ACTIONS(373),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(1585),
    [ts_builtin_sym_end] = ACTIONS(365),
    [anon_sym___END__] = ACTIONS(377),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(383),
    [anon_sym_yield] = ACTIONS(385),
    [anon_sym_break] = ACTIONS(387),
    [anon_sym_next] = ACTIONS(389),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(395),
    [anon_sym_not] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [sym_constant] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1587),
    [sym_instance_variable] = ACTIONS(405),
    [sym_class_variable] = ACTIONS(405),
    [sym_global_variable] = ACTIONS(405),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(407),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(407),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [203] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(889),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(890),
    [sym__argument] = STATE(891),
    [sym_splat_argument] = STATE(891),
    [sym_hash_splat_argument] = STATE(891),
    [sym_block_argument] = STATE(891),
    [sym_assignment] = STATE(889),
    [sym_operator_assignment] = STATE(889),
    [sym_conditional] = STATE(889),
    [sym_range] = STATE(889),
    [sym_binary] = STATE(889),
    [sym_unary] = STATE(889),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(892),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(891),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(1581),
    [sym__splat_star] = ACTIONS(1583),
    [sym__unary_minus] = ACTIONS(373),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(1585),
    [ts_builtin_sym_end] = ACTIONS(417),
    [anon_sym___END__] = ACTIONS(419),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(383),
    [anon_sym_yield] = ACTIONS(385),
    [anon_sym_break] = ACTIONS(387),
    [anon_sym_next] = ACTIONS(389),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(395),
    [anon_sym_not] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [sym_constant] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1587),
    [sym_instance_variable] = ACTIONS(405),
    [sym_class_variable] = ACTIONS(405),
    [sym_global_variable] = ACTIONS(405),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(407),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(407),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [204] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(889),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(890),
    [sym__argument] = STATE(891),
    [sym_splat_argument] = STATE(891),
    [sym_hash_splat_argument] = STATE(891),
    [sym_block_argument] = STATE(891),
    [sym_assignment] = STATE(889),
    [sym_operator_assignment] = STATE(889),
    [sym_conditional] = STATE(889),
    [sym_range] = STATE(889),
    [sym_binary] = STATE(889),
    [sym_unary] = STATE(889),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(892),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(891),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(1581),
    [sym__splat_star] = ACTIONS(1583),
    [sym__unary_minus] = ACTIONS(373),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(1585),
    [ts_builtin_sym_end] = ACTIONS(421),
    [anon_sym___END__] = ACTIONS(423),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(383),
    [anon_sym_yield] = ACTIONS(385),
    [anon_sym_break] = ACTIONS(387),
    [anon_sym_next] = ACTIONS(389),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(395),
    [anon_sym_not] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [sym_constant] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1587),
    [sym_instance_variable] = ACTIONS(405),
    [sym_class_variable] = ACTIONS(405),
    [sym_global_variable] = ACTIONS(405),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(407),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(407),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [205] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(889),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(890),
    [sym__argument] = STATE(891),
    [sym_splat_argument] = STATE(891),
    [sym_hash_splat_argument] = STATE(891),
    [sym_block_argument] = STATE(891),
    [sym_assignment] = STATE(889),
    [sym_operator_assignment] = STATE(889),
    [sym_conditional] = STATE(889),
    [sym_range] = STATE(889),
    [sym_binary] = STATE(889),
    [sym_unary] = STATE(889),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(892),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(891),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(1581),
    [sym__splat_star] = ACTIONS(1583),
    [sym__unary_minus] = ACTIONS(373),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(1585),
    [ts_builtin_sym_end] = ACTIONS(425),
    [anon_sym___END__] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(383),
    [anon_sym_yield] = ACTIONS(385),
    [anon_sym_break] = ACTIONS(387),
    [anon_sym_next] = ACTIONS(389),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(395),
    [anon_sym_not] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [sym_constant] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1587),
    [sym_instance_variable] = ACTIONS(405),
    [sym_class_variable] = ACTIONS(405),
    [sym_global_variable] = ACTIONS(405),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(407),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(407),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [206] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(906),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(911),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(911),
    [sym__argument_list_with_trailing_comma] = STATE(908),
    [sym__argument] = STATE(909),
    [sym_splat_argument] = STATE(909),
    [sym_hash_splat_argument] = STATE(909),
    [sym_block_argument] = STATE(909),
    [sym_assignment] = STATE(906),
    [sym_operator_assignment] = STATE(906),
    [sym_conditional] = STATE(906),
    [sym_range] = STATE(906),
    [sym_binary] = STATE(906),
    [sym_unary] = STATE(906),
    [sym_left_assignment_list] = STATE(910),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(911),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(911),
    [sym_false] = STATE(911),
    [sym_nil] = STATE(911),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(912),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(909),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1589),
    [sym__splat_star] = ACTIONS(1591),
    [sym__unary_minus] = ACTIONS(1593),
    [sym__identifier_hash_key] = ACTIONS(1595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(1597),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1599),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_defined_QMARK] = ACTIONS(1611),
    [anon_sym_not] = ACTIONS(1613),
    [anon_sym_BANG] = ACTIONS(1615),
    [anon_sym_TILDE] = ACTIONS(1615),
    [sym_constant] = ACTIONS(1617),
    [sym_identifier] = ACTIONS(1617),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [207] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(913),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_assignment] = STATE(913),
    [sym_operator_assignment] = STATE(913),
    [sym_conditional] = STATE(913),
    [sym_range] = STATE(913),
    [sym_binary] = STATE(913),
    [sym_unary] = STATE(913),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(880),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(373),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(383),
    [anon_sym_yield] = ACTIONS(385),
    [anon_sym_break] = ACTIONS(387),
    [anon_sym_next] = ACTIONS(389),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1575),
    [anon_sym_defined_QMARK] = ACTIONS(395),
    [anon_sym_not] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_TILDE] = ACTIONS(401),
    [sym_constant] = ACTIONS(407),
    [sym_identifier] = ACTIONS(407),
    [sym_instance_variable] = ACTIONS(405),
    [sym_class_variable] = ACTIONS(405),
    [sym_global_variable] = ACTIONS(405),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(407),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(407),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [208] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(880),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(373),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(383),
    [anon_sym_yield] = ACTIONS(385),
    [anon_sym_break] = ACTIONS(387),
    [anon_sym_next] = ACTIONS(389),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1575),
    [anon_sym_defined_QMARK] = ACTIONS(395),
    [anon_sym_not] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_TILDE] = ACTIONS(401),
    [sym_constant] = ACTIONS(407),
    [sym_identifier] = ACTIONS(407),
    [sym_instance_variable] = ACTIONS(405),
    [sym_class_variable] = ACTIONS(405),
    [sym_global_variable] = ACTIONS(405),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(407),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(407),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [209] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [ts_builtin_sym_end] = ACTIONS(1089),
    [anon_sym___END__] = ACTIONS(1091),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(1623),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [210] = {
    [sym__line_break] = ACTIONS(565),
    [sym__heredoc_body_start] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(565),
    [sym__binary_star] = ACTIONS(565),
    [ts_builtin_sym_end] = ACTIONS(565),
    [anon_sym___END__] = ACTIONS(565),
    [anon_sym_LBRACE] = ACTIONS(565),
    [anon_sym_RBRACE] = ACTIONS(565),
    [anon_sym_RPAREN] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(567),
    [anon_sym_COMMA] = ACTIONS(565),
    [anon_sym_PIPE] = ACTIONS(567),
    [anon_sym_SEMI] = ACTIONS(565),
    [anon_sym_STAR_STAR] = ACTIONS(567),
    [anon_sym_AMP] = ACTIONS(567),
    [anon_sym_EQ] = ACTIONS(567),
    [anon_sym_LT] = ACTIONS(567),
    [anon_sym_end] = ACTIONS(565),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_unless] = ACTIONS(565),
    [anon_sym_while] = ACTIONS(565),
    [anon_sym_until] = ACTIONS(565),
    [anon_sym_rescue] = ACTIONS(565),
    [anon_sym_do] = ACTIONS(565),
    [anon_sym_when] = ACTIONS(565),
    [anon_sym_elsif] = ACTIONS(565),
    [anon_sym_else] = ACTIONS(565),
    [anon_sym_then] = ACTIONS(565),
    [anon_sym_ensure] = ACTIONS(565),
    [anon_sym_EQ_GT] = ACTIONS(565),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_COLON_COLON2] = ACTIONS(565),
    [anon_sym_AMP_DOT] = ACTIONS(565),
    [anon_sym_PLUS_EQ] = ACTIONS(565),
    [anon_sym_DASH_EQ] = ACTIONS(565),
    [anon_sym_STAR_EQ] = ACTIONS(565),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(565),
    [anon_sym_SLASH_EQ] = ACTIONS(565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(565),
    [anon_sym_PIPE_EQ] = ACTIONS(565),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(565),
    [anon_sym_AMP_EQ] = ACTIONS(565),
    [anon_sym_PERCENT_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_LT_LT_EQ] = ACTIONS(565),
    [anon_sym_CARET_EQ] = ACTIONS(565),
    [anon_sym_QMARK] = ACTIONS(565),
    [anon_sym_DOT_DOT] = ACTIONS(567),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(565),
    [anon_sym_and] = ACTIONS(565),
    [anon_sym_or] = ACTIONS(565),
    [anon_sym_PIPE_PIPE] = ACTIONS(567),
    [anon_sym_AMP_AMP] = ACTIONS(567),
    [anon_sym_LT_LT] = ACTIONS(567),
    [anon_sym_GT_GT] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(565),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(565),
    [anon_sym_LT_EQ_GT] = ACTIONS(565),
    [anon_sym_EQ_TILDE] = ACTIONS(565),
    [anon_sym_BANG_TILDE] = ACTIONS(565),
    [anon_sym_LT_EQ] = ACTIONS(567),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_GT_EQ] = ACTIONS(565),
    [anon_sym_CARET] = ACTIONS(567),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_SLASH] = ACTIONS(567),
    [anon_sym_PERCENT] = ACTIONS(567),
    [sym_comment] = ACTIONS(87),
  },
  [211] = {
    [sym__line_break] = ACTIONS(569),
    [sym__heredoc_body_start] = ACTIONS(569),
    [sym__binary_minus] = ACTIONS(569),
    [sym__binary_star] = ACTIONS(569),
    [ts_builtin_sym_end] = ACTIONS(569),
    [anon_sym___END__] = ACTIONS(569),
    [anon_sym_LBRACE] = ACTIONS(569),
    [anon_sym_RBRACE] = ACTIONS(569),
    [anon_sym_RPAREN] = ACTIONS(569),
    [anon_sym_DOT] = ACTIONS(571),
    [anon_sym_COMMA] = ACTIONS(569),
    [anon_sym_PIPE] = ACTIONS(571),
    [anon_sym_SEMI] = ACTIONS(569),
    [anon_sym_STAR_STAR] = ACTIONS(571),
    [anon_sym_AMP] = ACTIONS(571),
    [anon_sym_EQ] = ACTIONS(571),
    [anon_sym_LT] = ACTIONS(571),
    [anon_sym_end] = ACTIONS(569),
    [anon_sym_if] = ACTIONS(569),
    [anon_sym_unless] = ACTIONS(569),
    [anon_sym_while] = ACTIONS(569),
    [anon_sym_until] = ACTIONS(569),
    [anon_sym_rescue] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_when] = ACTIONS(569),
    [anon_sym_elsif] = ACTIONS(569),
    [anon_sym_else] = ACTIONS(569),
    [anon_sym_then] = ACTIONS(569),
    [anon_sym_ensure] = ACTIONS(569),
    [anon_sym_EQ_GT] = ACTIONS(569),
    [anon_sym_LBRACK] = ACTIONS(569),
    [anon_sym_COLON_COLON2] = ACTIONS(569),
    [anon_sym_AMP_DOT] = ACTIONS(569),
    [anon_sym_PLUS_EQ] = ACTIONS(569),
    [anon_sym_DASH_EQ] = ACTIONS(569),
    [anon_sym_STAR_EQ] = ACTIONS(569),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(569),
    [anon_sym_SLASH_EQ] = ACTIONS(569),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(569),
    [anon_sym_PIPE_EQ] = ACTIONS(569),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(569),
    [anon_sym_AMP_EQ] = ACTIONS(569),
    [anon_sym_PERCENT_EQ] = ACTIONS(569),
    [anon_sym_GT_GT_EQ] = ACTIONS(569),
    [anon_sym_LT_LT_EQ] = ACTIONS(569),
    [anon_sym_CARET_EQ] = ACTIONS(569),
    [anon_sym_QMARK] = ACTIONS(569),
    [anon_sym_DOT_DOT] = ACTIONS(571),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(569),
    [anon_sym_and] = ACTIONS(569),
    [anon_sym_or] = ACTIONS(569),
    [anon_sym_PIPE_PIPE] = ACTIONS(571),
    [anon_sym_AMP_AMP] = ACTIONS(571),
    [anon_sym_LT_LT] = ACTIONS(571),
    [anon_sym_GT_GT] = ACTIONS(571),
    [anon_sym_EQ_EQ] = ACTIONS(571),
    [anon_sym_BANG_EQ] = ACTIONS(569),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(569),
    [anon_sym_LT_EQ_GT] = ACTIONS(569),
    [anon_sym_EQ_TILDE] = ACTIONS(569),
    [anon_sym_BANG_TILDE] = ACTIONS(569),
    [anon_sym_LT_EQ] = ACTIONS(571),
    [anon_sym_GT] = ACTIONS(571),
    [anon_sym_GT_EQ] = ACTIONS(569),
    [anon_sym_CARET] = ACTIONS(571),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_SLASH] = ACTIONS(571),
    [anon_sym_PERCENT] = ACTIONS(571),
    [sym_comment] = ACTIONS(87),
  },
  [212] = {
    [sym__line_break] = ACTIONS(573),
    [sym__heredoc_body_start] = ACTIONS(573),
    [sym__binary_minus] = ACTIONS(573),
    [sym__binary_star] = ACTIONS(573),
    [ts_builtin_sym_end] = ACTIONS(573),
    [anon_sym___END__] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(573),
    [anon_sym_RBRACE] = ACTIONS(573),
    [anon_sym_RPAREN] = ACTIONS(573),
    [anon_sym_DOT] = ACTIONS(575),
    [anon_sym_COMMA] = ACTIONS(573),
    [anon_sym_PIPE] = ACTIONS(575),
    [anon_sym_SEMI] = ACTIONS(573),
    [anon_sym_STAR_STAR] = ACTIONS(575),
    [anon_sym_AMP] = ACTIONS(575),
    [anon_sym_EQ] = ACTIONS(575),
    [anon_sym_LT] = ACTIONS(575),
    [anon_sym_end] = ACTIONS(573),
    [anon_sym_if] = ACTIONS(573),
    [anon_sym_unless] = ACTIONS(573),
    [anon_sym_while] = ACTIONS(573),
    [anon_sym_until] = ACTIONS(573),
    [anon_sym_rescue] = ACTIONS(573),
    [anon_sym_do] = ACTIONS(573),
    [anon_sym_when] = ACTIONS(573),
    [anon_sym_elsif] = ACTIONS(573),
    [anon_sym_else] = ACTIONS(573),
    [anon_sym_then] = ACTIONS(573),
    [anon_sym_ensure] = ACTIONS(573),
    [anon_sym_EQ_GT] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(573),
    [anon_sym_COLON_COLON2] = ACTIONS(573),
    [anon_sym_AMP_DOT] = ACTIONS(573),
    [anon_sym_PLUS_EQ] = ACTIONS(573),
    [anon_sym_DASH_EQ] = ACTIONS(573),
    [anon_sym_STAR_EQ] = ACTIONS(573),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(573),
    [anon_sym_SLASH_EQ] = ACTIONS(573),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(573),
    [anon_sym_PIPE_EQ] = ACTIONS(573),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(573),
    [anon_sym_AMP_EQ] = ACTIONS(573),
    [anon_sym_PERCENT_EQ] = ACTIONS(573),
    [anon_sym_GT_GT_EQ] = ACTIONS(573),
    [anon_sym_LT_LT_EQ] = ACTIONS(573),
    [anon_sym_CARET_EQ] = ACTIONS(573),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_DOT_DOT] = ACTIONS(575),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(573),
    [anon_sym_and] = ACTIONS(573),
    [anon_sym_or] = ACTIONS(573),
    [anon_sym_PIPE_PIPE] = ACTIONS(575),
    [anon_sym_AMP_AMP] = ACTIONS(575),
    [anon_sym_LT_LT] = ACTIONS(575),
    [anon_sym_GT_GT] = ACTIONS(575),
    [anon_sym_EQ_EQ] = ACTIONS(575),
    [anon_sym_BANG_EQ] = ACTIONS(573),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(573),
    [anon_sym_LT_EQ_GT] = ACTIONS(573),
    [anon_sym_EQ_TILDE] = ACTIONS(573),
    [anon_sym_BANG_TILDE] = ACTIONS(573),
    [anon_sym_LT_EQ] = ACTIONS(575),
    [anon_sym_GT] = ACTIONS(575),
    [anon_sym_GT_EQ] = ACTIONS(573),
    [anon_sym_CARET] = ACTIONS(575),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(575),
    [anon_sym_PERCENT] = ACTIONS(575),
    [sym_comment] = ACTIONS(87),
  },
  [213] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(1627),
    [sym__binary_star] = ACTIONS(1629),
    [ts_builtin_sym_end] = ACTIONS(1625),
    [anon_sym___END__] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(1633),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(1629),
    [anon_sym_AMP] = ACTIONS(1635),
    [anon_sym_LT] = ACTIONS(1637),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_unless] = ACTIONS(1625),
    [anon_sym_while] = ACTIONS(1625),
    [anon_sym_until] = ACTIONS(1625),
    [anon_sym_rescue] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(1577),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(1639),
    [anon_sym_DOT_DOT] = ACTIONS(1641),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1643),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(1645),
    [anon_sym_AMP_AMP] = ACTIONS(1645),
    [anon_sym_LT_LT] = ACTIONS(1647),
    [anon_sym_GT_GT] = ACTIONS(1647),
    [anon_sym_EQ_EQ] = ACTIONS(1649),
    [anon_sym_BANG_EQ] = ACTIONS(1645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1645),
    [anon_sym_LT_EQ_GT] = ACTIONS(1645),
    [anon_sym_EQ_TILDE] = ACTIONS(1645),
    [anon_sym_BANG_TILDE] = ACTIONS(1645),
    [anon_sym_LT_EQ] = ACTIONS(1637),
    [anon_sym_GT] = ACTIONS(1637),
    [anon_sym_GT_EQ] = ACTIONS(1651),
    [anon_sym_CARET] = ACTIONS(1653),
    [anon_sym_PLUS] = ACTIONS(1627),
    [anon_sym_SLASH] = ACTIONS(1629),
    [anon_sym_PERCENT] = ACTIONS(1629),
    [sym_comment] = ACTIONS(87),
  },
  [214] = {
    [sym__line_break] = ACTIONS(731),
    [sym__heredoc_body_start] = ACTIONS(731),
    [sym__binary_minus] = ACTIONS(731),
    [sym__binary_star] = ACTIONS(731),
    [ts_builtin_sym_end] = ACTIONS(731),
    [anon_sym___END__] = ACTIONS(731),
    [anon_sym_LBRACE] = ACTIONS(731),
    [anon_sym_RBRACE] = ACTIONS(731),
    [anon_sym_RPAREN] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(1655),
    [anon_sym_COMMA] = ACTIONS(731),
    [anon_sym_PIPE] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(731),
    [anon_sym_STAR_STAR] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(735),
    [anon_sym_end] = ACTIONS(731),
    [anon_sym_if] = ACTIONS(731),
    [anon_sym_unless] = ACTIONS(731),
    [anon_sym_while] = ACTIONS(731),
    [anon_sym_until] = ACTIONS(731),
    [anon_sym_rescue] = ACTIONS(731),
    [anon_sym_do] = ACTIONS(731),
    [anon_sym_when] = ACTIONS(731),
    [anon_sym_elsif] = ACTIONS(731),
    [anon_sym_else] = ACTIONS(731),
    [anon_sym_then] = ACTIONS(731),
    [anon_sym_ensure] = ACTIONS(731),
    [anon_sym_EQ_GT] = ACTIONS(731),
    [anon_sym_LBRACK] = ACTIONS(1657),
    [anon_sym_COLON_COLON2] = ACTIONS(1659),
    [anon_sym_AMP_DOT] = ACTIONS(1661),
    [anon_sym_QMARK] = ACTIONS(731),
    [anon_sym_DOT_DOT] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(731),
    [anon_sym_or] = ACTIONS(731),
    [anon_sym_PIPE_PIPE] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(731),
    [anon_sym_LT_LT] = ACTIONS(731),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_EQ_EQ] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(731),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(731),
    [anon_sym_LT_EQ_GT] = ACTIONS(731),
    [anon_sym_EQ_TILDE] = ACTIONS(731),
    [anon_sym_BANG_TILDE] = ACTIONS(731),
    [anon_sym_LT_EQ] = ACTIONS(735),
    [anon_sym_GT] = ACTIONS(735),
    [anon_sym_GT_EQ] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(731),
    [anon_sym_SLASH] = ACTIONS(731),
    [anon_sym_PERCENT] = ACTIONS(731),
    [sym_comment] = ACTIONS(87),
  },
  [215] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(937),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(428),
    [sym_scope_resolution] = STATE(422),
    [sym_call] = STATE(422),
    [sym_method_call] = STATE(428),
    [sym_argument_list] = STATE(938),
    [sym__argument_list_with_parens] = STATE(939),
    [sym__argument] = STATE(940),
    [sym_splat_argument] = STATE(940),
    [sym_hash_splat_argument] = STATE(940),
    [sym_block_argument] = STATE(940),
    [sym_do_block] = STATE(941),
    [sym_block] = STATE(941),
    [sym_assignment] = STATE(937),
    [sym_operator_assignment] = STATE(937),
    [sym_conditional] = STATE(937),
    [sym_range] = STATE(937),
    [sym_binary] = STATE(937),
    [sym_unary] = STATE(937),
    [sym_left_assignment_list] = STATE(427),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(428),
    [sym__variable] = STATE(422),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(428),
    [sym_false] = STATE(428),
    [sym_nil] = STATE(428),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(942),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(940),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(743),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(1663),
    [sym__splat_star] = ACTIONS(1665),
    [sym__unary_minus] = ACTIONS(765),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(1667),
    [ts_builtin_sym_end] = ACTIONS(743),
    [anon_sym___END__] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(1669),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(781),
    [anon_sym_yield] = ACTIONS(783),
    [anon_sym_break] = ACTIONS(785),
    [anon_sym_next] = ACTIONS(787),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(769),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(769),
    [anon_sym_until] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(769),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(1671),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(801),
    [anon_sym_not] = ACTIONS(803),
    [anon_sym_BANG] = ACTIONS(805),
    [anon_sym_TILDE] = ACTIONS(807),
    [sym_constant] = ACTIONS(1675),
    [sym_identifier] = ACTIONS(1675),
    [sym_instance_variable] = ACTIONS(811),
    [sym_class_variable] = ACTIONS(811),
    [sym_global_variable] = ACTIONS(811),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(815),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(815),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [216] = {
    [sym__line_break] = ACTIONS(1677),
    [sym__heredoc_body_start] = ACTIONS(1677),
    [sym__binary_minus] = ACTIONS(1677),
    [sym__binary_star] = ACTIONS(1677),
    [ts_builtin_sym_end] = ACTIONS(1677),
    [anon_sym___END__] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1677),
    [anon_sym_RBRACE] = ACTIONS(1677),
    [anon_sym_RPAREN] = ACTIONS(1677),
    [anon_sym_DOT] = ACTIONS(1679),
    [anon_sym_COMMA] = ACTIONS(1677),
    [anon_sym_PIPE] = ACTIONS(1679),
    [anon_sym_SEMI] = ACTIONS(1677),
    [anon_sym_STAR_STAR] = ACTIONS(1677),
    [anon_sym_AMP] = ACTIONS(1679),
    [anon_sym_LT] = ACTIONS(1679),
    [anon_sym_end] = ACTIONS(1677),
    [anon_sym_if] = ACTIONS(1677),
    [anon_sym_unless] = ACTIONS(1677),
    [anon_sym_while] = ACTIONS(1677),
    [anon_sym_until] = ACTIONS(1677),
    [anon_sym_rescue] = ACTIONS(1677),
    [anon_sym_do] = ACTIONS(1677),
    [anon_sym_when] = ACTIONS(1677),
    [anon_sym_elsif] = ACTIONS(1677),
    [anon_sym_else] = ACTIONS(1677),
    [anon_sym_then] = ACTIONS(1677),
    [anon_sym_ensure] = ACTIONS(1677),
    [anon_sym_EQ_GT] = ACTIONS(1677),
    [anon_sym_LBRACK] = ACTIONS(1677),
    [anon_sym_COLON_COLON2] = ACTIONS(1677),
    [anon_sym_AMP_DOT] = ACTIONS(1677),
    [anon_sym_QMARK] = ACTIONS(1677),
    [anon_sym_DOT_DOT] = ACTIONS(1679),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1677),
    [anon_sym_and] = ACTIONS(1677),
    [anon_sym_or] = ACTIONS(1677),
    [anon_sym_PIPE_PIPE] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_LT_LT] = ACTIONS(1677),
    [anon_sym_GT_GT] = ACTIONS(1677),
    [anon_sym_EQ_EQ] = ACTIONS(1679),
    [anon_sym_BANG_EQ] = ACTIONS(1677),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1677),
    [anon_sym_LT_EQ_GT] = ACTIONS(1677),
    [anon_sym_EQ_TILDE] = ACTIONS(1677),
    [anon_sym_BANG_TILDE] = ACTIONS(1677),
    [anon_sym_LT_EQ] = ACTIONS(1679),
    [anon_sym_GT] = ACTIONS(1679),
    [anon_sym_GT_EQ] = ACTIONS(1677),
    [anon_sym_CARET] = ACTIONS(1677),
    [anon_sym_PLUS] = ACTIONS(1677),
    [anon_sym_SLASH] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [sym_comment] = ACTIONS(87),
  },
  [217] = {
    [sym_heredoc_body] = STATE(944),
    [aux_sym_call_repeat1] = STATE(944),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [ts_builtin_sym_end] = ACTIONS(1681),
    [anon_sym___END__] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [218] = {
    [sym_heredoc_body] = STATE(944),
    [aux_sym_call_repeat1] = STATE(944),
    [aux_sym_argument_list_repeat1] = STATE(946),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [ts_builtin_sym_end] = ACTIONS(1681),
    [anon_sym___END__] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1687),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [219] = {
    [anon_sym_EQ] = ACTIONS(1689),
    [sym_comment] = ACTIONS(87),
  },
  [220] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(559),
    [anon_sym___END__] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(1691),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(1693),
    [anon_sym_DASH_EQ] = ACTIONS(1693),
    [anon_sym_STAR_EQ] = ACTIONS(1693),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1693),
    [anon_sym_SLASH_EQ] = ACTIONS(1693),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1693),
    [anon_sym_PIPE_EQ] = ACTIONS(1693),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1693),
    [anon_sym_AMP_EQ] = ACTIONS(1693),
    [anon_sym_PERCENT_EQ] = ACTIONS(1693),
    [anon_sym_GT_GT_EQ] = ACTIONS(1693),
    [anon_sym_LT_LT_EQ] = ACTIONS(1693),
    [anon_sym_CARET_EQ] = ACTIONS(1693),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [221] = {
    [sym_string] = STATE(949),
    [aux_sym_chained_string_repeat1] = STATE(949),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(559),
    [anon_sym___END__] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(1695),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [222] = {
    [sym__line_break] = ACTIONS(1697),
    [sym__heredoc_body_start] = ACTIONS(1697),
    [sym__binary_minus] = ACTIONS(1697),
    [sym__binary_star] = ACTIONS(1697),
    [ts_builtin_sym_end] = ACTIONS(1697),
    [anon_sym___END__] = ACTIONS(1697),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_RBRACE] = ACTIONS(1697),
    [anon_sym_RPAREN] = ACTIONS(1697),
    [anon_sym_DOT] = ACTIONS(1699),
    [anon_sym_COMMA] = ACTIONS(1697),
    [anon_sym_PIPE] = ACTIONS(1699),
    [anon_sym_SEMI] = ACTIONS(1697),
    [anon_sym_STAR_STAR] = ACTIONS(1697),
    [anon_sym_AMP] = ACTIONS(1699),
    [anon_sym_LT] = ACTIONS(1699),
    [anon_sym_end] = ACTIONS(1697),
    [anon_sym_if] = ACTIONS(1697),
    [anon_sym_unless] = ACTIONS(1697),
    [anon_sym_while] = ACTIONS(1697),
    [anon_sym_until] = ACTIONS(1697),
    [anon_sym_rescue] = ACTIONS(1697),
    [anon_sym_do] = ACTIONS(1697),
    [anon_sym_when] = ACTIONS(1697),
    [anon_sym_elsif] = ACTIONS(1697),
    [anon_sym_else] = ACTIONS(1697),
    [anon_sym_then] = ACTIONS(1697),
    [anon_sym_ensure] = ACTIONS(1697),
    [anon_sym_EQ_GT] = ACTIONS(1697),
    [anon_sym_LBRACK] = ACTIONS(1697),
    [anon_sym_COLON_COLON2] = ACTIONS(1697),
    [anon_sym_AMP_DOT] = ACTIONS(1697),
    [anon_sym_QMARK] = ACTIONS(1697),
    [anon_sym_DOT_DOT] = ACTIONS(1699),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1697),
    [anon_sym_and] = ACTIONS(1697),
    [anon_sym_or] = ACTIONS(1697),
    [anon_sym_PIPE_PIPE] = ACTIONS(1697),
    [anon_sym_AMP_AMP] = ACTIONS(1697),
    [anon_sym_LT_LT] = ACTIONS(1697),
    [anon_sym_GT_GT] = ACTIONS(1697),
    [anon_sym_EQ_EQ] = ACTIONS(1699),
    [anon_sym_BANG_EQ] = ACTIONS(1697),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1697),
    [anon_sym_LT_EQ_GT] = ACTIONS(1697),
    [anon_sym_EQ_TILDE] = ACTIONS(1697),
    [anon_sym_BANG_TILDE] = ACTIONS(1697),
    [anon_sym_LT_EQ] = ACTIONS(1699),
    [anon_sym_GT] = ACTIONS(1699),
    [anon_sym_GT_EQ] = ACTIONS(1697),
    [anon_sym_CARET] = ACTIONS(1697),
    [anon_sym_PLUS] = ACTIONS(1697),
    [anon_sym_SLASH] = ACTIONS(1697),
    [anon_sym_PERCENT] = ACTIONS(1697),
    [sym_comment] = ACTIONS(87),
  },
  [223] = {
    [sym__line_break] = ACTIONS(1701),
    [sym__heredoc_body_start] = ACTIONS(1701),
    [sym__binary_minus] = ACTIONS(1701),
    [sym__binary_star] = ACTIONS(1701),
    [ts_builtin_sym_end] = ACTIONS(1701),
    [anon_sym___END__] = ACTIONS(1701),
    [anon_sym_LBRACE] = ACTIONS(1701),
    [anon_sym_RBRACE] = ACTIONS(1701),
    [anon_sym_RPAREN] = ACTIONS(1701),
    [anon_sym_DOT] = ACTIONS(1703),
    [anon_sym_COMMA] = ACTIONS(1701),
    [anon_sym_PIPE] = ACTIONS(1703),
    [anon_sym_SEMI] = ACTIONS(1701),
    [anon_sym_STAR_STAR] = ACTIONS(1701),
    [anon_sym_AMP] = ACTIONS(1703),
    [anon_sym_LT] = ACTIONS(1703),
    [anon_sym_end] = ACTIONS(1701),
    [anon_sym_if] = ACTIONS(1701),
    [anon_sym_unless] = ACTIONS(1701),
    [anon_sym_while] = ACTIONS(1701),
    [anon_sym_until] = ACTIONS(1701),
    [anon_sym_rescue] = ACTIONS(1701),
    [anon_sym_do] = ACTIONS(1701),
    [anon_sym_when] = ACTIONS(1701),
    [anon_sym_elsif] = ACTIONS(1701),
    [anon_sym_else] = ACTIONS(1701),
    [anon_sym_then] = ACTIONS(1701),
    [anon_sym_ensure] = ACTIONS(1701),
    [anon_sym_EQ_GT] = ACTIONS(1701),
    [anon_sym_LBRACK] = ACTIONS(1701),
    [anon_sym_COLON_COLON2] = ACTIONS(1701),
    [anon_sym_AMP_DOT] = ACTIONS(1701),
    [anon_sym_QMARK] = ACTIONS(1701),
    [anon_sym_DOT_DOT] = ACTIONS(1703),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1701),
    [anon_sym_and] = ACTIONS(1701),
    [anon_sym_or] = ACTIONS(1701),
    [anon_sym_PIPE_PIPE] = ACTIONS(1701),
    [anon_sym_AMP_AMP] = ACTIONS(1701),
    [anon_sym_LT_LT] = ACTIONS(1701),
    [anon_sym_GT_GT] = ACTIONS(1701),
    [anon_sym_EQ_EQ] = ACTIONS(1703),
    [anon_sym_BANG_EQ] = ACTIONS(1701),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1701),
    [anon_sym_LT_EQ_GT] = ACTIONS(1701),
    [anon_sym_EQ_TILDE] = ACTIONS(1701),
    [anon_sym_BANG_TILDE] = ACTIONS(1701),
    [anon_sym_LT_EQ] = ACTIONS(1703),
    [anon_sym_GT] = ACTIONS(1703),
    [anon_sym_GT_EQ] = ACTIONS(1701),
    [anon_sym_CARET] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(1701),
    [anon_sym_SLASH] = ACTIONS(1701),
    [anon_sym_PERCENT] = ACTIONS(1701),
    [sym_comment] = ACTIONS(87),
  },
  [224] = {
    [sym__line_break] = ACTIONS(1705),
    [sym__heredoc_body_start] = ACTIONS(1705),
    [sym__binary_minus] = ACTIONS(1705),
    [sym__binary_star] = ACTIONS(1705),
    [ts_builtin_sym_end] = ACTIONS(1705),
    [anon_sym___END__] = ACTIONS(1705),
    [anon_sym_LBRACE] = ACTIONS(1705),
    [anon_sym_RBRACE] = ACTIONS(1705),
    [anon_sym_RPAREN] = ACTIONS(1705),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1705),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1705),
    [anon_sym_STAR_STAR] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1705),
    [anon_sym_if] = ACTIONS(1705),
    [anon_sym_unless] = ACTIONS(1705),
    [anon_sym_while] = ACTIONS(1705),
    [anon_sym_until] = ACTIONS(1705),
    [anon_sym_rescue] = ACTIONS(1705),
    [anon_sym_do] = ACTIONS(1705),
    [anon_sym_when] = ACTIONS(1705),
    [anon_sym_elsif] = ACTIONS(1705),
    [anon_sym_else] = ACTIONS(1705),
    [anon_sym_then] = ACTIONS(1705),
    [anon_sym_ensure] = ACTIONS(1705),
    [anon_sym_EQ_GT] = ACTIONS(1705),
    [anon_sym_LBRACK] = ACTIONS(1705),
    [anon_sym_COLON_COLON2] = ACTIONS(1705),
    [anon_sym_AMP_DOT] = ACTIONS(1705),
    [anon_sym_QMARK] = ACTIONS(1705),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1705),
    [anon_sym_and] = ACTIONS(1705),
    [anon_sym_or] = ACTIONS(1705),
    [anon_sym_PIPE_PIPE] = ACTIONS(1705),
    [anon_sym_AMP_AMP] = ACTIONS(1705),
    [anon_sym_LT_LT] = ACTIONS(1705),
    [anon_sym_GT_GT] = ACTIONS(1705),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1705),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1705),
    [anon_sym_LT_EQ_GT] = ACTIONS(1705),
    [anon_sym_EQ_TILDE] = ACTIONS(1705),
    [anon_sym_BANG_TILDE] = ACTIONS(1705),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1705),
    [anon_sym_CARET] = ACTIONS(1705),
    [anon_sym_PLUS] = ACTIONS(1705),
    [anon_sym_SLASH] = ACTIONS(1705),
    [anon_sym_PERCENT] = ACTIONS(1705),
    [sym_comment] = ACTIONS(87),
  },
  [225] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(950),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(950),
    [sym_operator_assignment] = STATE(950),
    [sym_conditional] = STATE(950),
    [sym_range] = STATE(950),
    [sym_binary] = STATE(950),
    [sym_unary] = STATE(950),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(429),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_yield] = ACTIONS(433),
    [anon_sym_break] = ACTIONS(435),
    [anon_sym_next] = ACTIONS(437),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(439),
    [anon_sym_defined_QMARK] = ACTIONS(441),
    [anon_sym_not] = ACTIONS(443),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [226] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(963),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(965),
    [sym__argument] = STATE(966),
    [sym_splat_argument] = STATE(966),
    [sym_hash_splat_argument] = STATE(966),
    [sym_block_argument] = STATE(966),
    [sym_assignment] = STATE(963),
    [sym_operator_assignment] = STATE(963),
    [sym_conditional] = STATE(963),
    [sym_range] = STATE(963),
    [sym_binary] = STATE(963),
    [sym_unary] = STATE(963),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(969),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(966),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(1709),
    [sym__splat_star] = ACTIONS(1711),
    [sym__unary_minus] = ACTIONS(1713),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(1715),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1717),
    [anon_sym_yield] = ACTIONS(1719),
    [anon_sym_break] = ACTIONS(1721),
    [anon_sym_next] = ACTIONS(1723),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(377),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(1725),
    [anon_sym_not] = ACTIONS(1727),
    [anon_sym_BANG] = ACTIONS(1729),
    [anon_sym_TILDE] = ACTIONS(1731),
    [sym_constant] = ACTIONS(1733),
    [sym_identifier] = ACTIONS(1733),
    [sym_instance_variable] = ACTIONS(1735),
    [sym_class_variable] = ACTIONS(1735),
    [sym_global_variable] = ACTIONS(1735),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1737),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1737),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [227] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(963),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(965),
    [sym__argument] = STATE(966),
    [sym_splat_argument] = STATE(966),
    [sym_hash_splat_argument] = STATE(966),
    [sym_block_argument] = STATE(966),
    [sym_assignment] = STATE(963),
    [sym_operator_assignment] = STATE(963),
    [sym_conditional] = STATE(963),
    [sym_range] = STATE(963),
    [sym_binary] = STATE(963),
    [sym_unary] = STATE(963),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(969),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(966),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(1709),
    [sym__splat_star] = ACTIONS(1711),
    [sym__unary_minus] = ACTIONS(1713),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(1715),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1717),
    [anon_sym_yield] = ACTIONS(1719),
    [anon_sym_break] = ACTIONS(1721),
    [anon_sym_next] = ACTIONS(1723),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(419),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(1725),
    [anon_sym_not] = ACTIONS(1727),
    [anon_sym_BANG] = ACTIONS(1729),
    [anon_sym_TILDE] = ACTIONS(1731),
    [sym_constant] = ACTIONS(1733),
    [sym_identifier] = ACTIONS(1733),
    [sym_instance_variable] = ACTIONS(1735),
    [sym_class_variable] = ACTIONS(1735),
    [sym_global_variable] = ACTIONS(1735),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1737),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1737),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [228] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(963),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(965),
    [sym__argument] = STATE(966),
    [sym_splat_argument] = STATE(966),
    [sym_hash_splat_argument] = STATE(966),
    [sym_block_argument] = STATE(966),
    [sym_assignment] = STATE(963),
    [sym_operator_assignment] = STATE(963),
    [sym_conditional] = STATE(963),
    [sym_range] = STATE(963),
    [sym_binary] = STATE(963),
    [sym_unary] = STATE(963),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(969),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(966),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(1709),
    [sym__splat_star] = ACTIONS(1711),
    [sym__unary_minus] = ACTIONS(1713),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(1715),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1717),
    [anon_sym_yield] = ACTIONS(1719),
    [anon_sym_break] = ACTIONS(1721),
    [anon_sym_next] = ACTIONS(1723),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(423),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(1725),
    [anon_sym_not] = ACTIONS(1727),
    [anon_sym_BANG] = ACTIONS(1729),
    [anon_sym_TILDE] = ACTIONS(1731),
    [sym_constant] = ACTIONS(1733),
    [sym_identifier] = ACTIONS(1733),
    [sym_instance_variable] = ACTIONS(1735),
    [sym_class_variable] = ACTIONS(1735),
    [sym_global_variable] = ACTIONS(1735),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1737),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1737),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [229] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(963),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(965),
    [sym__argument] = STATE(966),
    [sym_splat_argument] = STATE(966),
    [sym_hash_splat_argument] = STATE(966),
    [sym_block_argument] = STATE(966),
    [sym_assignment] = STATE(963),
    [sym_operator_assignment] = STATE(963),
    [sym_conditional] = STATE(963),
    [sym_range] = STATE(963),
    [sym_binary] = STATE(963),
    [sym_unary] = STATE(963),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(969),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(966),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(1709),
    [sym__splat_star] = ACTIONS(1711),
    [sym__unary_minus] = ACTIONS(1713),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(1715),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1717),
    [anon_sym_yield] = ACTIONS(1719),
    [anon_sym_break] = ACTIONS(1721),
    [anon_sym_next] = ACTIONS(1723),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(427),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(1725),
    [anon_sym_not] = ACTIONS(1727),
    [anon_sym_BANG] = ACTIONS(1729),
    [anon_sym_TILDE] = ACTIONS(1731),
    [sym_constant] = ACTIONS(1733),
    [sym_identifier] = ACTIONS(1733),
    [sym_instance_variable] = ACTIONS(1735),
    [sym_class_variable] = ACTIONS(1735),
    [sym_global_variable] = ACTIONS(1735),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1737),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1737),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [230] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(970),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(970),
    [sym_operator_assignment] = STATE(970),
    [sym_conditional] = STATE(970),
    [sym_range] = STATE(970),
    [sym_binary] = STATE(970),
    [sym_unary] = STATE(970),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(429),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_yield] = ACTIONS(433),
    [anon_sym_break] = ACTIONS(435),
    [anon_sym_next] = ACTIONS(437),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(439),
    [anon_sym_defined_QMARK] = ACTIONS(441),
    [anon_sym_not] = ACTIONS(443),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [231] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(298),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(298),
    [sym_operator_assignment] = STATE(298),
    [sym_conditional] = STATE(298),
    [sym_range] = STATE(298),
    [sym_binary] = STATE(298),
    [sym_unary] = STATE(298),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(429),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_yield] = ACTIONS(433),
    [anon_sym_break] = ACTIONS(435),
    [anon_sym_next] = ACTIONS(437),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(439),
    [anon_sym_defined_QMARK] = ACTIONS(441),
    [anon_sym_not] = ACTIONS(443),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [232] = {
    [sym_operator] = STATE(971),
    [sym__method_name] = STATE(971),
    [sym_setter] = STATE(971),
    [sym_symbol] = STATE(971),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(1739),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(1739),
    [sym_class_variable] = ACTIONS(1739),
    [sym_global_variable] = ACTIONS(1739),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [233] = {
    [sym_then] = STATE(978),
    [sym_heredoc_body] = STATE(979),
    [sym__terminator] = STATE(979),
    [sym__line_break] = ACTIONS(1741),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(1741),
    [anon_sym_if] = ACTIONS(1743),
    [anon_sym_unless] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1747),
    [anon_sym_until] = ACTIONS(1749),
    [anon_sym_rescue] = ACTIONS(1751),
    [anon_sym_then] = ACTIONS(1753),
    [sym_comment] = ACTIONS(87),
  },
  [234] = {
    [sym__line_break] = ACTIONS(701),
    [sym__heredoc_body_start] = ACTIONS(701),
    [sym__binary_minus] = ACTIONS(1755),
    [sym__binary_star] = ACTIONS(1757),
    [anon_sym_PIPE] = ACTIONS(1759),
    [anon_sym_SEMI] = ACTIONS(701),
    [anon_sym_STAR_STAR] = ACTIONS(1757),
    [anon_sym_AMP] = ACTIONS(1761),
    [anon_sym_LT] = ACTIONS(1763),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_unless] = ACTIONS(701),
    [anon_sym_while] = ACTIONS(701),
    [anon_sym_until] = ACTIONS(701),
    [anon_sym_rescue] = ACTIONS(701),
    [anon_sym_then] = ACTIONS(701),
    [anon_sym_QMARK] = ACTIONS(1765),
    [anon_sym_DOT_DOT] = ACTIONS(1767),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1769),
    [anon_sym_and] = ACTIONS(1771),
    [anon_sym_or] = ACTIONS(1771),
    [anon_sym_PIPE_PIPE] = ACTIONS(1773),
    [anon_sym_AMP_AMP] = ACTIONS(1773),
    [anon_sym_LT_LT] = ACTIONS(1775),
    [anon_sym_GT_GT] = ACTIONS(1775),
    [anon_sym_EQ_EQ] = ACTIONS(1777),
    [anon_sym_BANG_EQ] = ACTIONS(1773),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1773),
    [anon_sym_LT_EQ_GT] = ACTIONS(1773),
    [anon_sym_EQ_TILDE] = ACTIONS(1773),
    [anon_sym_BANG_TILDE] = ACTIONS(1773),
    [anon_sym_LT_EQ] = ACTIONS(1763),
    [anon_sym_GT] = ACTIONS(1763),
    [anon_sym_GT_EQ] = ACTIONS(1779),
    [anon_sym_CARET] = ACTIONS(1781),
    [anon_sym_PLUS] = ACTIONS(1755),
    [anon_sym_SLASH] = ACTIONS(1757),
    [anon_sym_PERCENT] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
  },
  [235] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(1002),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_argument_list] = STATE(423),
    [sym__argument_list_with_parens] = STATE(1004),
    [sym__argument] = STATE(1005),
    [sym_splat_argument] = STATE(1005),
    [sym_hash_splat_argument] = STATE(1005),
    [sym_block_argument] = STATE(1005),
    [sym_do_block] = STATE(426),
    [sym_block] = STATE(426),
    [sym_assignment] = STATE(1002),
    [sym_operator_assignment] = STATE(1002),
    [sym_conditional] = STATE(1002),
    [sym_range] = STATE(1002),
    [sym_binary] = STATE(1002),
    [sym_unary] = STATE(1002),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(1008),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(1005),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(743),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(1783),
    [sym__splat_star] = ACTIONS(1785),
    [sym__unary_minus] = ACTIONS(1787),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(1789),
    [anon_sym_LBRACE] = ACTIONS(771),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1791),
    [anon_sym_yield] = ACTIONS(1793),
    [anon_sym_break] = ACTIONS(1795),
    [anon_sym_next] = ACTIONS(1797),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(769),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(769),
    [anon_sym_until] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(769),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_then] = ACTIONS(769),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(1799),
    [anon_sym_not] = ACTIONS(1801),
    [anon_sym_BANG] = ACTIONS(1803),
    [anon_sym_TILDE] = ACTIONS(1805),
    [sym_constant] = ACTIONS(1807),
    [sym_identifier] = ACTIONS(1807),
    [sym_instance_variable] = ACTIONS(1809),
    [sym_class_variable] = ACTIONS(1809),
    [sym_global_variable] = ACTIONS(1809),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1811),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1811),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [236] = {
    [anon_sym_EQ] = ACTIONS(1813),
    [sym_comment] = ACTIONS(87),
  },
  [237] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(1815),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(1817),
    [anon_sym_DASH_EQ] = ACTIONS(1817),
    [anon_sym_STAR_EQ] = ACTIONS(1817),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1817),
    [anon_sym_SLASH_EQ] = ACTIONS(1817),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1817),
    [anon_sym_PIPE_EQ] = ACTIONS(1817),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1817),
    [anon_sym_AMP_EQ] = ACTIONS(1817),
    [anon_sym_PERCENT_EQ] = ACTIONS(1817),
    [anon_sym_GT_GT_EQ] = ACTIONS(1817),
    [anon_sym_LT_LT_EQ] = ACTIONS(1817),
    [anon_sym_CARET_EQ] = ACTIONS(1817),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [238] = {
    [sym_string] = STATE(1011),
    [aux_sym_chained_string_repeat1] = STATE(1011),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [239] = {
    [sym_then] = STATE(1013),
    [sym_heredoc_body] = STATE(1014),
    [sym__terminator] = STATE(1014),
    [sym__line_break] = ACTIONS(1819),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(1819),
    [anon_sym_if] = ACTIONS(1743),
    [anon_sym_unless] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1747),
    [anon_sym_until] = ACTIONS(1749),
    [anon_sym_rescue] = ACTIONS(1751),
    [anon_sym_then] = ACTIONS(1821),
    [sym_comment] = ACTIONS(87),
  },
  [240] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1015),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(1015),
    [sym_operator_assignment] = STATE(1015),
    [sym_conditional] = STATE(1015),
    [sym_range] = STATE(1015),
    [sym_binary] = STATE(1015),
    [sym_unary] = STATE(1015),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(455),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_break] = ACTIONS(459),
    [anon_sym_next] = ACTIONS(461),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_defined_QMARK] = ACTIONS(465),
    [anon_sym_not] = ACTIONS(467),
    [anon_sym_BANG] = ACTIONS(469),
    [anon_sym_TILDE] = ACTIONS(469),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [241] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1028),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1033),
    [sym_scope_resolution] = STATE(1029),
    [sym_call] = STATE(1029),
    [sym_method_call] = STATE(1033),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(1030),
    [sym__argument] = STATE(1031),
    [sym_splat_argument] = STATE(1031),
    [sym_hash_splat_argument] = STATE(1031),
    [sym_block_argument] = STATE(1031),
    [sym_assignment] = STATE(1028),
    [sym_operator_assignment] = STATE(1028),
    [sym_conditional] = STATE(1028),
    [sym_range] = STATE(1028),
    [sym_binary] = STATE(1028),
    [sym_unary] = STATE(1028),
    [sym_left_assignment_list] = STATE(1032),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1033),
    [sym__variable] = STATE(1029),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1033),
    [sym_false] = STATE(1033),
    [sym_nil] = STATE(1033),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1034),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(1031),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(1823),
    [sym__splat_star] = ACTIONS(1825),
    [sym__unary_minus] = ACTIONS(1827),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(1829),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1831),
    [anon_sym_yield] = ACTIONS(1833),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_next] = ACTIONS(1837),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1845),
    [sym_constant] = ACTIONS(1847),
    [sym_identifier] = ACTIONS(1847),
    [sym_instance_variable] = ACTIONS(1849),
    [sym_class_variable] = ACTIONS(1849),
    [sym_global_variable] = ACTIONS(1849),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1851),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1851),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [242] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1028),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1033),
    [sym_scope_resolution] = STATE(1029),
    [sym_call] = STATE(1029),
    [sym_method_call] = STATE(1033),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(1030),
    [sym__argument] = STATE(1031),
    [sym_splat_argument] = STATE(1031),
    [sym_hash_splat_argument] = STATE(1031),
    [sym_block_argument] = STATE(1031),
    [sym_assignment] = STATE(1028),
    [sym_operator_assignment] = STATE(1028),
    [sym_conditional] = STATE(1028),
    [sym_range] = STATE(1028),
    [sym_binary] = STATE(1028),
    [sym_unary] = STATE(1028),
    [sym_left_assignment_list] = STATE(1032),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1033),
    [sym__variable] = STATE(1029),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1033),
    [sym_false] = STATE(1033),
    [sym_nil] = STATE(1033),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1034),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(1031),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(1823),
    [sym__splat_star] = ACTIONS(1825),
    [sym__unary_minus] = ACTIONS(1827),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(1829),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1831),
    [anon_sym_yield] = ACTIONS(1833),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_next] = ACTIONS(1837),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1845),
    [sym_constant] = ACTIONS(1847),
    [sym_identifier] = ACTIONS(1847),
    [sym_instance_variable] = ACTIONS(1849),
    [sym_class_variable] = ACTIONS(1849),
    [sym_global_variable] = ACTIONS(1849),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1851),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1851),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [243] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1028),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1033),
    [sym_scope_resolution] = STATE(1029),
    [sym_call] = STATE(1029),
    [sym_method_call] = STATE(1033),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(1030),
    [sym__argument] = STATE(1031),
    [sym_splat_argument] = STATE(1031),
    [sym_hash_splat_argument] = STATE(1031),
    [sym_block_argument] = STATE(1031),
    [sym_assignment] = STATE(1028),
    [sym_operator_assignment] = STATE(1028),
    [sym_conditional] = STATE(1028),
    [sym_range] = STATE(1028),
    [sym_binary] = STATE(1028),
    [sym_unary] = STATE(1028),
    [sym_left_assignment_list] = STATE(1032),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1033),
    [sym__variable] = STATE(1029),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1033),
    [sym_false] = STATE(1033),
    [sym_nil] = STATE(1033),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1034),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(1031),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(1823),
    [sym__splat_star] = ACTIONS(1825),
    [sym__unary_minus] = ACTIONS(1827),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(1829),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1831),
    [anon_sym_yield] = ACTIONS(1833),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_next] = ACTIONS(1837),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1845),
    [sym_constant] = ACTIONS(1847),
    [sym_identifier] = ACTIONS(1847),
    [sym_instance_variable] = ACTIONS(1849),
    [sym_class_variable] = ACTIONS(1849),
    [sym_global_variable] = ACTIONS(1849),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1851),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1851),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [244] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1028),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1033),
    [sym_scope_resolution] = STATE(1029),
    [sym_call] = STATE(1029),
    [sym_method_call] = STATE(1033),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(1030),
    [sym__argument] = STATE(1031),
    [sym_splat_argument] = STATE(1031),
    [sym_hash_splat_argument] = STATE(1031),
    [sym_block_argument] = STATE(1031),
    [sym_assignment] = STATE(1028),
    [sym_operator_assignment] = STATE(1028),
    [sym_conditional] = STATE(1028),
    [sym_range] = STATE(1028),
    [sym_binary] = STATE(1028),
    [sym_unary] = STATE(1028),
    [sym_left_assignment_list] = STATE(1032),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1033),
    [sym__variable] = STATE(1029),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1033),
    [sym_false] = STATE(1033),
    [sym_nil] = STATE(1033),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1034),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(1031),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(1823),
    [sym__splat_star] = ACTIONS(1825),
    [sym__unary_minus] = ACTIONS(1827),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(1829),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1831),
    [anon_sym_yield] = ACTIONS(1833),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_next] = ACTIONS(1837),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1845),
    [sym_constant] = ACTIONS(1847),
    [sym_identifier] = ACTIONS(1847),
    [sym_instance_variable] = ACTIONS(1849),
    [sym_class_variable] = ACTIONS(1849),
    [sym_global_variable] = ACTIONS(1849),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1851),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1851),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [245] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1035),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(1035),
    [sym_operator_assignment] = STATE(1035),
    [sym_conditional] = STATE(1035),
    [sym_range] = STATE(1035),
    [sym_binary] = STATE(1035),
    [sym_unary] = STATE(1035),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(455),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_break] = ACTIONS(459),
    [anon_sym_next] = ACTIONS(461),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_defined_QMARK] = ACTIONS(465),
    [anon_sym_not] = ACTIONS(467),
    [anon_sym_BANG] = ACTIONS(469),
    [anon_sym_TILDE] = ACTIONS(469),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [246] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(298),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(298),
    [sym_operator_assignment] = STATE(298),
    [sym_conditional] = STATE(298),
    [sym_range] = STATE(298),
    [sym_binary] = STATE(298),
    [sym_unary] = STATE(298),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(455),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_break] = ACTIONS(459),
    [anon_sym_next] = ACTIONS(461),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_defined_QMARK] = ACTIONS(465),
    [anon_sym_not] = ACTIONS(467),
    [anon_sym_BANG] = ACTIONS(469),
    [anon_sym_TILDE] = ACTIONS(469),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [247] = {
    [sym__do] = STATE(1046),
    [sym_heredoc_body] = STATE(1046),
    [sym__terminator] = STATE(1046),
    [sym__line_break] = ACTIONS(1853),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym__binary_minus] = ACTIONS(1855),
    [sym__binary_star] = ACTIONS(1857),
    [anon_sym_PIPE] = ACTIONS(1859),
    [anon_sym_SEMI] = ACTIONS(1853),
    [anon_sym_STAR_STAR] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_LT] = ACTIONS(1863),
    [anon_sym_do] = ACTIONS(1853),
    [anon_sym_QMARK] = ACTIONS(1865),
    [anon_sym_DOT_DOT] = ACTIONS(1867),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1869),
    [anon_sym_and] = ACTIONS(1871),
    [anon_sym_or] = ACTIONS(1871),
    [anon_sym_PIPE_PIPE] = ACTIONS(1873),
    [anon_sym_AMP_AMP] = ACTIONS(1873),
    [anon_sym_LT_LT] = ACTIONS(1875),
    [anon_sym_GT_GT] = ACTIONS(1875),
    [anon_sym_EQ_EQ] = ACTIONS(1877),
    [anon_sym_BANG_EQ] = ACTIONS(1873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1873),
    [anon_sym_LT_EQ_GT] = ACTIONS(1873),
    [anon_sym_EQ_TILDE] = ACTIONS(1873),
    [anon_sym_BANG_TILDE] = ACTIONS(1873),
    [anon_sym_LT_EQ] = ACTIONS(1863),
    [anon_sym_GT] = ACTIONS(1863),
    [anon_sym_GT_EQ] = ACTIONS(1879),
    [anon_sym_CARET] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_SLASH] = ACTIONS(1857),
    [anon_sym_PERCENT] = ACTIONS(1857),
    [sym_comment] = ACTIONS(87),
  },
  [248] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(1060),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1066),
    [sym_scope_resolution] = STATE(1061),
    [sym_call] = STATE(1061),
    [sym_method_call] = STATE(1066),
    [sym_argument_list] = STATE(1062),
    [sym__argument_list_with_parens] = STATE(1063),
    [sym__argument] = STATE(1064),
    [sym_splat_argument] = STATE(1064),
    [sym_hash_splat_argument] = STATE(1064),
    [sym_block_argument] = STATE(1064),
    [sym_do_block] = STATE(426),
    [sym_block] = STATE(426),
    [sym_assignment] = STATE(1060),
    [sym_operator_assignment] = STATE(1060),
    [sym_conditional] = STATE(1060),
    [sym_range] = STATE(1060),
    [sym_binary] = STATE(1060),
    [sym_unary] = STATE(1060),
    [sym_left_assignment_list] = STATE(1065),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1066),
    [sym__variable] = STATE(1061),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1066),
    [sym_false] = STATE(1066),
    [sym_nil] = STATE(1066),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(1067),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(1064),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(743),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(1883),
    [sym__splat_star] = ACTIONS(1885),
    [sym__unary_minus] = ACTIONS(1887),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(1889),
    [anon_sym_LBRACE] = ACTIONS(1891),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1895),
    [anon_sym_break] = ACTIONS(1897),
    [anon_sym_next] = ACTIONS(1899),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(769),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(1909),
    [anon_sym_not] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1913),
    [anon_sym_TILDE] = ACTIONS(1915),
    [sym_constant] = ACTIONS(1917),
    [sym_identifier] = ACTIONS(1917),
    [sym_instance_variable] = ACTIONS(1919),
    [sym_class_variable] = ACTIONS(1919),
    [sym_global_variable] = ACTIONS(1919),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1921),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1921),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [249] = {
    [anon_sym_EQ] = ACTIONS(1923),
    [sym_comment] = ACTIONS(87),
  },
  [250] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(1925),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(1927),
    [anon_sym_DASH_EQ] = ACTIONS(1927),
    [anon_sym_STAR_EQ] = ACTIONS(1927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1927),
    [anon_sym_SLASH_EQ] = ACTIONS(1927),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1927),
    [anon_sym_PIPE_EQ] = ACTIONS(1927),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1927),
    [anon_sym_AMP_EQ] = ACTIONS(1927),
    [anon_sym_PERCENT_EQ] = ACTIONS(1927),
    [anon_sym_GT_GT_EQ] = ACTIONS(1927),
    [anon_sym_LT_LT_EQ] = ACTIONS(1927),
    [anon_sym_CARET_EQ] = ACTIONS(1927),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [251] = {
    [sym_string] = STATE(1070),
    [aux_sym_chained_string_repeat1] = STATE(1070),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [252] = {
    [sym__do] = STATE(1071),
    [sym_heredoc_body] = STATE(1071),
    [sym__terminator] = STATE(1071),
    [sym__line_break] = ACTIONS(1929),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym__binary_minus] = ACTIONS(1855),
    [sym__binary_star] = ACTIONS(1857),
    [anon_sym_PIPE] = ACTIONS(1859),
    [anon_sym_SEMI] = ACTIONS(1929),
    [anon_sym_STAR_STAR] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_LT] = ACTIONS(1863),
    [anon_sym_do] = ACTIONS(1929),
    [anon_sym_QMARK] = ACTIONS(1865),
    [anon_sym_DOT_DOT] = ACTIONS(1867),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1869),
    [anon_sym_and] = ACTIONS(1871),
    [anon_sym_or] = ACTIONS(1871),
    [anon_sym_PIPE_PIPE] = ACTIONS(1873),
    [anon_sym_AMP_AMP] = ACTIONS(1873),
    [anon_sym_LT_LT] = ACTIONS(1875),
    [anon_sym_GT_GT] = ACTIONS(1875),
    [anon_sym_EQ_EQ] = ACTIONS(1877),
    [anon_sym_BANG_EQ] = ACTIONS(1873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1873),
    [anon_sym_LT_EQ_GT] = ACTIONS(1873),
    [anon_sym_EQ_TILDE] = ACTIONS(1873),
    [anon_sym_BANG_TILDE] = ACTIONS(1873),
    [anon_sym_LT_EQ] = ACTIONS(1863),
    [anon_sym_GT] = ACTIONS(1863),
    [anon_sym_GT_EQ] = ACTIONS(1879),
    [anon_sym_CARET] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_SLASH] = ACTIONS(1857),
    [anon_sym_PERCENT] = ACTIONS(1857),
    [sym_comment] = ACTIONS(87),
  },
  [253] = {
    [sym__statements] = STATE(774),
    [sym_begin_block] = STATE(144),
    [sym_end_block] = STATE(144),
    [sym__statement] = STATE(144),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(144),
    [sym_unless_modifier] = STATE(144),
    [sym_while_modifier] = STATE(144),
    [sym_until_modifier] = STATE(144),
    [sym_rescue_modifier] = STATE(144),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(145),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(150),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(150),
    [sym_assignment] = STATE(145),
    [sym_operator_assignment] = STATE(145),
    [sym_conditional] = STATE(145),
    [sym_range] = STATE(145),
    [sym_binary] = STATE(145),
    [sym_unary] = STATE(145),
    [sym_left_assignment_list] = STATE(147),
    [sym__mlhs] = STATE(148),
    [sym_destructured_left_assignment] = STATE(149),
    [sym_rest_assignment] = STATE(149),
    [sym__lhs] = STATE(150),
    [sym__variable] = STATE(146),
    [sym_undef] = STATE(144),
    [sym_alias] = STATE(144),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(150),
    [sym_false] = STATE(150),
    [sym_nil] = STATE(150),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(151),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(152),
    [aux_sym__statements_repeat1] = STATE(152),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_RPAREN] = ACTIONS(1437),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(249),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [anon_sym_undef] = ACTIONS(271),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [254] = {
    [sym_method] = STATE(184),
    [sym_singleton_method] = STATE(184),
    [sym_class] = STATE(184),
    [sym_singleton_class] = STATE(184),
    [sym_module] = STATE(184),
    [sym_return] = STATE(184),
    [sym_yield] = STATE(184),
    [sym_break] = STATE(184),
    [sym_next] = STATE(184),
    [sym_while] = STATE(184),
    [sym_until] = STATE(184),
    [sym_for] = STATE(184),
    [sym_case] = STATE(184),
    [sym_if] = STATE(184),
    [sym_unless] = STATE(184),
    [sym_begin] = STATE(184),
    [sym__primary] = STATE(184),
    [sym_parenthesized_statements] = STATE(184),
    [sym_element_reference] = STATE(186),
    [sym_scope_resolution] = STATE(255),
    [sym_call] = STATE(255),
    [sym_method_call] = STATE(186),
    [sym__lhs] = STATE(186),
    [sym__variable] = STATE(255),
    [sym_rational] = STATE(184),
    [sym_true] = STATE(186),
    [sym_false] = STATE(186),
    [sym_nil] = STATE(186),
    [sym_chained_string] = STATE(184),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(184),
    [sym_string_array] = STATE(184),
    [sym_symbol_array] = STATE(184),
    [sym_symbol] = STATE(184),
    [sym_regex] = STATE(184),
    [sym_array] = STATE(184),
    [sym_hash] = STATE(184),
    [sym_lambda] = STATE(184),
    [sym__simple_symbol] = ACTIONS(279),
    [sym__string_start] = ACTIONS(281),
    [sym__symbol_start] = ACTIONS(283),
    [sym__subshell_start] = ACTIONS(285),
    [sym__regex_start] = ACTIONS(287),
    [sym__string_array_start] = ACTIONS(289),
    [sym__symbol_array_start] = ACTIONS(291),
    [sym_heredoc_beginning] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_def] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(299),
    [anon_sym_COLON_COLON] = ACTIONS(301),
    [anon_sym_COMMA] = ACTIONS(303),
    [anon_sym_class] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(307),
    [anon_sym_return] = ACTIONS(309),
    [anon_sym_yield] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_next] = ACTIONS(315),
    [sym_redo] = ACTIONS(317),
    [sym_retry] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(319),
    [anon_sym_unless] = ACTIONS(321),
    [anon_sym_while] = ACTIONS(323),
    [anon_sym_until] = ACTIONS(325),
    [anon_sym_for] = ACTIONS(327),
    [anon_sym_in] = ACTIONS(1931),
    [anon_sym_case] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(331),
    [sym_constant] = ACTIONS(479),
    [sym_identifier] = ACTIONS(479),
    [sym_instance_variable] = ACTIONS(481),
    [sym_class_variable] = ACTIONS(481),
    [sym_global_variable] = ACTIONS(481),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(317),
    [sym_complex] = ACTIONS(293),
    [sym_super] = ACTIONS(479),
    [anon_sym_true] = ACTIONS(339),
    [anon_sym_TRUE] = ACTIONS(339),
    [anon_sym_false] = ACTIONS(341),
    [anon_sym_FALSE] = ACTIONS(341),
    [sym_self] = ACTIONS(479),
    [anon_sym_nil] = ACTIONS(343),
    [anon_sym_NIL] = ACTIONS(343),
    [sym_character] = ACTIONS(293),
    [anon_sym_LBRACK2] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(347),
  },
  [255] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(1084),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1089),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(1089),
    [sym_argument_list] = STATE(832),
    [sym__argument_list_with_parens] = STATE(1086),
    [sym__argument] = STATE(1087),
    [sym_splat_argument] = STATE(1087),
    [sym_hash_splat_argument] = STATE(1087),
    [sym_block_argument] = STATE(1087),
    [sym_do_block] = STATE(835),
    [sym_block] = STATE(835),
    [sym_assignment] = STATE(1084),
    [sym_operator_assignment] = STATE(1084),
    [sym_conditional] = STATE(1084),
    [sym_range] = STATE(1084),
    [sym_binary] = STATE(1084),
    [sym_unary] = STATE(1084),
    [sym_left_assignment_list] = STATE(1088),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1089),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1089),
    [sym_false] = STATE(1089),
    [sym_nil] = STATE(1089),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1090),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(1087),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1933),
    [sym__splat_star] = ACTIONS(1935),
    [sym__unary_minus] = ACTIONS(1937),
    [sym__identifier_hash_key] = ACTIONS(1939),
    [anon_sym_LBRACE] = ACTIONS(1489),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(743),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1941),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1943),
    [anon_sym_yield] = ACTIONS(1945),
    [anon_sym_break] = ACTIONS(1947),
    [anon_sym_next] = ACTIONS(1949),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_in] = ACTIONS(769),
    [anon_sym_do] = ACTIONS(1473),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1951),
    [anon_sym_defined_QMARK] = ACTIONS(1953),
    [anon_sym_not] = ACTIONS(1955),
    [anon_sym_BANG] = ACTIONS(1957),
    [anon_sym_TILDE] = ACTIONS(1957),
    [sym_constant] = ACTIONS(1959),
    [sym_identifier] = ACTIONS(1959),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [256] = {
    [sym_in] = STATE(1092),
    [anon_sym_in] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
  },
  [257] = {
    [aux_sym__mlhs_repeat1] = STATE(1094),
    [anon_sym_COMMA] = ACTIONS(1967),
    [anon_sym_in] = ACTIONS(827),
    [sym_comment] = ACTIONS(87),
  },
  [258] = {
    [aux_sym__mlhs_repeat1] = STATE(1094),
    [anon_sym_DOT] = ACTIONS(559),
    [anon_sym_COMMA] = ACTIONS(1967),
    [anon_sym_in] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [259] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1095),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(1095),
    [sym_operator_assignment] = STATE(1095),
    [sym_conditional] = STATE(1095),
    [sym_range] = STATE(1095),
    [sym_binary] = STATE(1095),
    [sym_unary] = STATE(1095),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(485),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(495),
    [anon_sym_defined_QMARK] = ACTIONS(497),
    [anon_sym_not] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(501),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [260] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1108),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1113),
    [sym_scope_resolution] = STATE(1109),
    [sym_call] = STATE(1109),
    [sym_method_call] = STATE(1113),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(1110),
    [sym__argument] = STATE(1111),
    [sym_splat_argument] = STATE(1111),
    [sym_hash_splat_argument] = STATE(1111),
    [sym_block_argument] = STATE(1111),
    [sym_assignment] = STATE(1108),
    [sym_operator_assignment] = STATE(1108),
    [sym_conditional] = STATE(1108),
    [sym_range] = STATE(1108),
    [sym_binary] = STATE(1108),
    [sym_unary] = STATE(1108),
    [sym_left_assignment_list] = STATE(1112),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1113),
    [sym__variable] = STATE(1109),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1113),
    [sym_false] = STATE(1113),
    [sym_nil] = STATE(1113),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1114),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(1111),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(1969),
    [sym__splat_star] = ACTIONS(1971),
    [sym__unary_minus] = ACTIONS(1973),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(1975),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1977),
    [anon_sym_yield] = ACTIONS(1979),
    [anon_sym_break] = ACTIONS(1981),
    [anon_sym_next] = ACTIONS(1983),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1991),
    [sym_constant] = ACTIONS(1993),
    [sym_identifier] = ACTIONS(1993),
    [sym_instance_variable] = ACTIONS(1995),
    [sym_class_variable] = ACTIONS(1995),
    [sym_global_variable] = ACTIONS(1995),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1997),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1997),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [261] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1108),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1113),
    [sym_scope_resolution] = STATE(1109),
    [sym_call] = STATE(1109),
    [sym_method_call] = STATE(1113),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(1110),
    [sym__argument] = STATE(1111),
    [sym_splat_argument] = STATE(1111),
    [sym_hash_splat_argument] = STATE(1111),
    [sym_block_argument] = STATE(1111),
    [sym_assignment] = STATE(1108),
    [sym_operator_assignment] = STATE(1108),
    [sym_conditional] = STATE(1108),
    [sym_range] = STATE(1108),
    [sym_binary] = STATE(1108),
    [sym_unary] = STATE(1108),
    [sym_left_assignment_list] = STATE(1112),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1113),
    [sym__variable] = STATE(1109),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1113),
    [sym_false] = STATE(1113),
    [sym_nil] = STATE(1113),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1114),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(1111),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(1969),
    [sym__splat_star] = ACTIONS(1971),
    [sym__unary_minus] = ACTIONS(1973),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(1975),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1977),
    [anon_sym_yield] = ACTIONS(1979),
    [anon_sym_break] = ACTIONS(1981),
    [anon_sym_next] = ACTIONS(1983),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1991),
    [sym_constant] = ACTIONS(1993),
    [sym_identifier] = ACTIONS(1993),
    [sym_instance_variable] = ACTIONS(1995),
    [sym_class_variable] = ACTIONS(1995),
    [sym_global_variable] = ACTIONS(1995),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1997),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1997),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [262] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1108),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1113),
    [sym_scope_resolution] = STATE(1109),
    [sym_call] = STATE(1109),
    [sym_method_call] = STATE(1113),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(1110),
    [sym__argument] = STATE(1111),
    [sym_splat_argument] = STATE(1111),
    [sym_hash_splat_argument] = STATE(1111),
    [sym_block_argument] = STATE(1111),
    [sym_assignment] = STATE(1108),
    [sym_operator_assignment] = STATE(1108),
    [sym_conditional] = STATE(1108),
    [sym_range] = STATE(1108),
    [sym_binary] = STATE(1108),
    [sym_unary] = STATE(1108),
    [sym_left_assignment_list] = STATE(1112),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1113),
    [sym__variable] = STATE(1109),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1113),
    [sym_false] = STATE(1113),
    [sym_nil] = STATE(1113),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1114),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(1111),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(1969),
    [sym__splat_star] = ACTIONS(1971),
    [sym__unary_minus] = ACTIONS(1973),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(1975),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1977),
    [anon_sym_yield] = ACTIONS(1979),
    [anon_sym_break] = ACTIONS(1981),
    [anon_sym_next] = ACTIONS(1983),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1991),
    [sym_constant] = ACTIONS(1993),
    [sym_identifier] = ACTIONS(1993),
    [sym_instance_variable] = ACTIONS(1995),
    [sym_class_variable] = ACTIONS(1995),
    [sym_global_variable] = ACTIONS(1995),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1997),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1997),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [263] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1108),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1113),
    [sym_scope_resolution] = STATE(1109),
    [sym_call] = STATE(1109),
    [sym_method_call] = STATE(1113),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(1110),
    [sym__argument] = STATE(1111),
    [sym_splat_argument] = STATE(1111),
    [sym_hash_splat_argument] = STATE(1111),
    [sym_block_argument] = STATE(1111),
    [sym_assignment] = STATE(1108),
    [sym_operator_assignment] = STATE(1108),
    [sym_conditional] = STATE(1108),
    [sym_range] = STATE(1108),
    [sym_binary] = STATE(1108),
    [sym_unary] = STATE(1108),
    [sym_left_assignment_list] = STATE(1112),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1113),
    [sym__variable] = STATE(1109),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1113),
    [sym_false] = STATE(1113),
    [sym_nil] = STATE(1113),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1114),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(1111),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(1969),
    [sym__splat_star] = ACTIONS(1971),
    [sym__unary_minus] = ACTIONS(1973),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(1975),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1977),
    [anon_sym_yield] = ACTIONS(1979),
    [anon_sym_break] = ACTIONS(1981),
    [anon_sym_next] = ACTIONS(1983),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1991),
    [sym_constant] = ACTIONS(1993),
    [sym_identifier] = ACTIONS(1993),
    [sym_instance_variable] = ACTIONS(1995),
    [sym_class_variable] = ACTIONS(1995),
    [sym_global_variable] = ACTIONS(1995),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1997),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1997),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [264] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1115),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(1115),
    [sym_operator_assignment] = STATE(1115),
    [sym_conditional] = STATE(1115),
    [sym_range] = STATE(1115),
    [sym_binary] = STATE(1115),
    [sym_unary] = STATE(1115),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(485),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(495),
    [anon_sym_defined_QMARK] = ACTIONS(497),
    [anon_sym_not] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(501),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [265] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(298),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(298),
    [sym_operator_assignment] = STATE(298),
    [sym_conditional] = STATE(298),
    [sym_range] = STATE(298),
    [sym_binary] = STATE(298),
    [sym_unary] = STATE(298),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(485),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(495),
    [anon_sym_defined_QMARK] = ACTIONS(497),
    [anon_sym_not] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(501),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [266] = {
    [sym_heredoc_body] = STATE(1126),
    [sym__terminator] = STATE(1126),
    [sym__line_break] = ACTIONS(1999),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym__binary_minus] = ACTIONS(2001),
    [sym__binary_star] = ACTIONS(2003),
    [anon_sym_PIPE] = ACTIONS(2005),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(2003),
    [anon_sym_AMP] = ACTIONS(2007),
    [anon_sym_LT] = ACTIONS(2009),
    [anon_sym_QMARK] = ACTIONS(2011),
    [anon_sym_DOT_DOT] = ACTIONS(2013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2015),
    [anon_sym_and] = ACTIONS(2017),
    [anon_sym_or] = ACTIONS(2017),
    [anon_sym_PIPE_PIPE] = ACTIONS(2019),
    [anon_sym_AMP_AMP] = ACTIONS(2019),
    [anon_sym_LT_LT] = ACTIONS(2021),
    [anon_sym_GT_GT] = ACTIONS(2021),
    [anon_sym_EQ_EQ] = ACTIONS(2023),
    [anon_sym_BANG_EQ] = ACTIONS(2019),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2019),
    [anon_sym_LT_EQ_GT] = ACTIONS(2019),
    [anon_sym_EQ_TILDE] = ACTIONS(2019),
    [anon_sym_BANG_TILDE] = ACTIONS(2019),
    [anon_sym_LT_EQ] = ACTIONS(2009),
    [anon_sym_GT] = ACTIONS(2009),
    [anon_sym_GT_EQ] = ACTIONS(2025),
    [anon_sym_CARET] = ACTIONS(2027),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_SLASH] = ACTIONS(2003),
    [anon_sym_PERCENT] = ACTIONS(2003),
    [sym_comment] = ACTIONS(87),
  },
  [267] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(1060),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1066),
    [sym_scope_resolution] = STATE(1061),
    [sym_call] = STATE(1061),
    [sym_method_call] = STATE(1066),
    [sym_argument_list] = STATE(423),
    [sym__argument_list_with_parens] = STATE(1063),
    [sym__argument] = STATE(1064),
    [sym_splat_argument] = STATE(1064),
    [sym_hash_splat_argument] = STATE(1064),
    [sym_block_argument] = STATE(1064),
    [sym_do_block] = STATE(426),
    [sym_block] = STATE(426),
    [sym_assignment] = STATE(1060),
    [sym_operator_assignment] = STATE(1060),
    [sym_conditional] = STATE(1060),
    [sym_range] = STATE(1060),
    [sym_binary] = STATE(1060),
    [sym_unary] = STATE(1060),
    [sym_left_assignment_list] = STATE(1065),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1066),
    [sym__variable] = STATE(1061),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1066),
    [sym_false] = STATE(1066),
    [sym_nil] = STATE(1066),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(1067),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(1064),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(743),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(1883),
    [sym__splat_star] = ACTIONS(1885),
    [sym__unary_minus] = ACTIONS(1887),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(1889),
    [anon_sym_LBRACE] = ACTIONS(771),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1895),
    [anon_sym_break] = ACTIONS(1897),
    [anon_sym_next] = ACTIONS(1899),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(1909),
    [anon_sym_not] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1913),
    [anon_sym_TILDE] = ACTIONS(1915),
    [sym_constant] = ACTIONS(1917),
    [sym_identifier] = ACTIONS(1917),
    [sym_instance_variable] = ACTIONS(1919),
    [sym_class_variable] = ACTIONS(1919),
    [sym_global_variable] = ACTIONS(1919),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1921),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1921),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [268] = {
    [anon_sym_EQ] = ACTIONS(2029),
    [sym_comment] = ACTIONS(87),
  },
  [269] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(2031),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(2033),
    [anon_sym_DASH_EQ] = ACTIONS(2033),
    [anon_sym_STAR_EQ] = ACTIONS(2033),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2033),
    [anon_sym_SLASH_EQ] = ACTIONS(2033),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2033),
    [anon_sym_PIPE_EQ] = ACTIONS(2033),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2033),
    [anon_sym_AMP_EQ] = ACTIONS(2033),
    [anon_sym_PERCENT_EQ] = ACTIONS(2033),
    [anon_sym_GT_GT_EQ] = ACTIONS(2033),
    [anon_sym_LT_LT_EQ] = ACTIONS(2033),
    [anon_sym_CARET_EQ] = ACTIONS(2033),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [270] = {
    [sym_string] = STATE(1129),
    [aux_sym_chained_string_repeat1] = STATE(1129),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [271] = {
    [sym_when] = STATE(1135),
    [sym_else] = STATE(1133),
    [aux_sym_case_repeat1] = STATE(1134),
    [aux_sym_case_repeat2] = STATE(1135),
    [anon_sym_SEMI] = ACTIONS(2035),
    [anon_sym_end] = ACTIONS(2037),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [272] = {
    [sym_interpolation] = STATE(1137),
    [aux_sym_heredoc_body_repeat1] = STATE(1137),
    [sym__heredoc_content] = ACTIONS(2043),
    [sym_heredoc_end] = ACTIONS(2045),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(2043),
  },
  [273] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1138),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(1138),
    [sym_operator_assignment] = STATE(1138),
    [sym_conditional] = STATE(1138),
    [sym_range] = STATE(1138),
    [sym_binary] = STATE(1138),
    [sym_unary] = STATE(1138),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [274] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1151),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1156),
    [sym_scope_resolution] = STATE(1152),
    [sym_call] = STATE(1152),
    [sym_method_call] = STATE(1156),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(1153),
    [sym__argument] = STATE(1154),
    [sym_splat_argument] = STATE(1154),
    [sym_hash_splat_argument] = STATE(1154),
    [sym_block_argument] = STATE(1154),
    [sym_assignment] = STATE(1151),
    [sym_operator_assignment] = STATE(1151),
    [sym_conditional] = STATE(1151),
    [sym_range] = STATE(1151),
    [sym_binary] = STATE(1151),
    [sym_unary] = STATE(1151),
    [sym_left_assignment_list] = STATE(1155),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1156),
    [sym__variable] = STATE(1152),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1156),
    [sym_false] = STATE(1156),
    [sym_nil] = STATE(1156),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1157),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(1154),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(2047),
    [sym__splat_star] = ACTIONS(2049),
    [sym__unary_minus] = ACTIONS(2051),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(2053),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(2055),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2059),
    [anon_sym_next] = ACTIONS(2061),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(377),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(377),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [anon_sym_BANG] = ACTIONS(2067),
    [anon_sym_TILDE] = ACTIONS(2069),
    [sym_constant] = ACTIONS(2071),
    [sym_identifier] = ACTIONS(2071),
    [sym_instance_variable] = ACTIONS(2073),
    [sym_class_variable] = ACTIONS(2073),
    [sym_global_variable] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2075),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [275] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1151),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1156),
    [sym_scope_resolution] = STATE(1152),
    [sym_call] = STATE(1152),
    [sym_method_call] = STATE(1156),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(1153),
    [sym__argument] = STATE(1154),
    [sym_splat_argument] = STATE(1154),
    [sym_hash_splat_argument] = STATE(1154),
    [sym_block_argument] = STATE(1154),
    [sym_assignment] = STATE(1151),
    [sym_operator_assignment] = STATE(1151),
    [sym_conditional] = STATE(1151),
    [sym_range] = STATE(1151),
    [sym_binary] = STATE(1151),
    [sym_unary] = STATE(1151),
    [sym_left_assignment_list] = STATE(1155),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1156),
    [sym__variable] = STATE(1152),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1156),
    [sym_false] = STATE(1156),
    [sym_nil] = STATE(1156),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1157),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(1154),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(2047),
    [sym__splat_star] = ACTIONS(2049),
    [sym__unary_minus] = ACTIONS(2051),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(2053),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(2055),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2059),
    [anon_sym_next] = ACTIONS(2061),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(419),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [anon_sym_BANG] = ACTIONS(2067),
    [anon_sym_TILDE] = ACTIONS(2069),
    [sym_constant] = ACTIONS(2071),
    [sym_identifier] = ACTIONS(2071),
    [sym_instance_variable] = ACTIONS(2073),
    [sym_class_variable] = ACTIONS(2073),
    [sym_global_variable] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2075),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [276] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1151),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1156),
    [sym_scope_resolution] = STATE(1152),
    [sym_call] = STATE(1152),
    [sym_method_call] = STATE(1156),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(1153),
    [sym__argument] = STATE(1154),
    [sym_splat_argument] = STATE(1154),
    [sym_hash_splat_argument] = STATE(1154),
    [sym_block_argument] = STATE(1154),
    [sym_assignment] = STATE(1151),
    [sym_operator_assignment] = STATE(1151),
    [sym_conditional] = STATE(1151),
    [sym_range] = STATE(1151),
    [sym_binary] = STATE(1151),
    [sym_unary] = STATE(1151),
    [sym_left_assignment_list] = STATE(1155),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1156),
    [sym__variable] = STATE(1152),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1156),
    [sym_false] = STATE(1156),
    [sym_nil] = STATE(1156),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1157),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(1154),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(2047),
    [sym__splat_star] = ACTIONS(2049),
    [sym__unary_minus] = ACTIONS(2051),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(2053),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(423),
    [anon_sym_return] = ACTIONS(2055),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2059),
    [anon_sym_next] = ACTIONS(2061),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(423),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [anon_sym_BANG] = ACTIONS(2067),
    [anon_sym_TILDE] = ACTIONS(2069),
    [sym_constant] = ACTIONS(2071),
    [sym_identifier] = ACTIONS(2071),
    [sym_instance_variable] = ACTIONS(2073),
    [sym_class_variable] = ACTIONS(2073),
    [sym_global_variable] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2075),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [277] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1151),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1156),
    [sym_scope_resolution] = STATE(1152),
    [sym_call] = STATE(1152),
    [sym_method_call] = STATE(1156),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(1153),
    [sym__argument] = STATE(1154),
    [sym_splat_argument] = STATE(1154),
    [sym_hash_splat_argument] = STATE(1154),
    [sym_block_argument] = STATE(1154),
    [sym_assignment] = STATE(1151),
    [sym_operator_assignment] = STATE(1151),
    [sym_conditional] = STATE(1151),
    [sym_range] = STATE(1151),
    [sym_binary] = STATE(1151),
    [sym_unary] = STATE(1151),
    [sym_left_assignment_list] = STATE(1155),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1156),
    [sym__variable] = STATE(1152),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1156),
    [sym_false] = STATE(1156),
    [sym_nil] = STATE(1156),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1157),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(1154),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(2047),
    [sym__splat_star] = ACTIONS(2049),
    [sym__unary_minus] = ACTIONS(2051),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(2053),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(427),
    [anon_sym_return] = ACTIONS(2055),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2059),
    [anon_sym_next] = ACTIONS(2061),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(427),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [anon_sym_BANG] = ACTIONS(2067),
    [anon_sym_TILDE] = ACTIONS(2069),
    [sym_constant] = ACTIONS(2071),
    [sym_identifier] = ACTIONS(2071),
    [sym_instance_variable] = ACTIONS(2073),
    [sym_class_variable] = ACTIONS(2073),
    [sym_global_variable] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2075),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [278] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_then] = STATE(1168),
    [sym_begin] = STATE(214),
    [sym_exceptions] = STATE(1169),
    [sym_exception_variable] = STATE(1170),
    [sym__arg] = STATE(1171),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1175),
    [sym_scope_resolution] = STATE(1172),
    [sym_call] = STATE(1172),
    [sym_method_call] = STATE(1175),
    [sym_splat_argument] = STATE(1173),
    [sym_assignment] = STATE(1171),
    [sym_operator_assignment] = STATE(1171),
    [sym_conditional] = STATE(1171),
    [sym_range] = STATE(1171),
    [sym_binary] = STATE(1171),
    [sym_unary] = STATE(1171),
    [sym__arg_or_splat_arg] = STATE(1173),
    [sym_left_assignment_list] = STATE(1174),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1175),
    [sym__variable] = STATE(1172),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1175),
    [sym_false] = STATE(1175),
    [sym_nil] = STATE(1175),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1176),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(1177),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__terminator] = STATE(1177),
    [sym__line_break] = ACTIONS(2077),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__splat_star] = ACTIONS(2079),
    [sym__unary_minus] = ACTIONS(2081),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_SEMI] = ACTIONS(2077),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2085),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_next] = ACTIONS(2089),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(2091),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(2093),
    [anon_sym_PLUS] = ACTIONS(2095),
    [anon_sym_defined_QMARK] = ACTIONS(2097),
    [anon_sym_not] = ACTIONS(2099),
    [anon_sym_BANG] = ACTIONS(2101),
    [anon_sym_TILDE] = ACTIONS(2101),
    [sym_constant] = ACTIONS(2103),
    [sym_identifier] = ACTIONS(2103),
    [sym_instance_variable] = ACTIONS(2105),
    [sym_class_variable] = ACTIONS(2105),
    [sym_global_variable] = ACTIONS(2105),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2103),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2103),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [279] = {
    [sym__statements] = STATE(1186),
    [sym_begin_block] = STATE(1187),
    [sym_end_block] = STATE(1187),
    [sym__statement] = STATE(1187),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1187),
    [sym_unless_modifier] = STATE(1187),
    [sym_while_modifier] = STATE(1187),
    [sym_until_modifier] = STATE(1187),
    [sym_rescue_modifier] = STATE(1187),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1188),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1191),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(1191),
    [sym_assignment] = STATE(1188),
    [sym_operator_assignment] = STATE(1188),
    [sym_conditional] = STATE(1188),
    [sym_range] = STATE(1188),
    [sym_binary] = STATE(1188),
    [sym_unary] = STATE(1188),
    [sym_left_assignment_list] = STATE(1190),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1191),
    [sym__variable] = STATE(1189),
    [sym_undef] = STATE(1187),
    [sym_alias] = STATE(1187),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1191),
    [sym_false] = STATE(1191),
    [sym_nil] = STATE(1191),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1192),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_heredoc_body] = STATE(1193),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1194),
    [sym__terminator] = STATE(1193),
    [aux_sym__statements_repeat1] = STATE(1194),
    [sym__line_break] = ACTIONS(2107),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2109),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2107),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(2111),
    [anon_sym_return] = ACTIONS(2113),
    [anon_sym_yield] = ACTIONS(2115),
    [anon_sym_break] = ACTIONS(2117),
    [anon_sym_next] = ACTIONS(2119),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(2111),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_defined_QMARK] = ACTIONS(2123),
    [anon_sym_not] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2127),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [anon_sym_undef] = ACTIONS(2133),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [280] = {
    [sym__statements] = STATE(1203),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(2137),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [281] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1211),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(1211),
    [sym_operator_assignment] = STATE(1211),
    [sym_conditional] = STATE(1211),
    [sym_range] = STATE(1211),
    [sym_binary] = STATE(1211),
    [sym_unary] = STATE(1211),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [282] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(298),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(298),
    [sym_operator_assignment] = STATE(298),
    [sym_conditional] = STATE(298),
    [sym_range] = STATE(298),
    [sym_binary] = STATE(298),
    [sym_unary] = STATE(298),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [283] = {
    [sym_operator] = STATE(1212),
    [sym__method_name] = STATE(1212),
    [sym_setter] = STATE(1212),
    [sym_symbol] = STATE(1212),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(2161),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [284] = {
    [sym_else] = STATE(1214),
    [sym_ensure] = STATE(1215),
    [sym_rescue] = STATE(1216),
    [anon_sym_end] = ACTIONS(2163),
    [anon_sym_rescue] = ACTIONS(2165),
    [anon_sym_else] = ACTIONS(2167),
    [anon_sym_ensure] = ACTIONS(2169),
    [sym_comment] = ACTIONS(87),
  },
  [285] = {
    [sym_heredoc_body] = STATE(370),
    [sym__terminator] = STATE(370),
    [sym__line_break] = ACTIONS(687),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(687),
    [anon_sym_end] = ACTIONS(689),
    [anon_sym_if] = ACTIONS(2171),
    [anon_sym_unless] = ACTIONS(2173),
    [anon_sym_while] = ACTIONS(2175),
    [anon_sym_until] = ACTIONS(2177),
    [anon_sym_rescue] = ACTIONS(2179),
    [anon_sym_else] = ACTIONS(689),
    [anon_sym_ensure] = ACTIONS(689),
    [sym_comment] = ACTIONS(87),
  },
  [286] = {
    [sym_ensure] = STATE(1215),
    [anon_sym_end] = ACTIONS(2163),
    [anon_sym_ensure] = ACTIONS(2169),
    [sym_comment] = ACTIONS(87),
  },
  [287] = {
    [anon_sym_end] = ACTIONS(2163),
    [sym_comment] = ACTIONS(87),
  },
  [288] = {
    [sym_else] = STATE(1214),
    [sym_ensure] = STATE(1215),
    [anon_sym_end] = ACTIONS(2163),
    [anon_sym_else] = ACTIONS(2167),
    [anon_sym_ensure] = ACTIONS(2169),
    [sym_comment] = ACTIONS(87),
  },
  [289] = {
    [sym__line_break] = ACTIONS(2181),
    [sym__heredoc_body_start] = ACTIONS(2181),
    [sym__binary_minus] = ACTIONS(2181),
    [sym__binary_star] = ACTIONS(2181),
    [ts_builtin_sym_end] = ACTIONS(2181),
    [anon_sym___END__] = ACTIONS(2181),
    [anon_sym_LBRACE] = ACTIONS(2181),
    [anon_sym_RBRACE] = ACTIONS(2181),
    [anon_sym_RPAREN] = ACTIONS(2181),
    [anon_sym_DOT] = ACTIONS(2183),
    [anon_sym_COMMA] = ACTIONS(2181),
    [anon_sym_PIPE] = ACTIONS(2183),
    [anon_sym_SEMI] = ACTIONS(2181),
    [anon_sym_STAR_STAR] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2183),
    [anon_sym_LT] = ACTIONS(2183),
    [anon_sym_end] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(2181),
    [anon_sym_unless] = ACTIONS(2181),
    [anon_sym_while] = ACTIONS(2181),
    [anon_sym_until] = ACTIONS(2181),
    [anon_sym_rescue] = ACTIONS(2181),
    [anon_sym_do] = ACTIONS(2181),
    [anon_sym_when] = ACTIONS(2181),
    [anon_sym_elsif] = ACTIONS(2181),
    [anon_sym_else] = ACTIONS(2181),
    [anon_sym_then] = ACTIONS(2181),
    [anon_sym_ensure] = ACTIONS(2181),
    [anon_sym_EQ_GT] = ACTIONS(2181),
    [anon_sym_LBRACK] = ACTIONS(2181),
    [anon_sym_COLON_COLON2] = ACTIONS(2181),
    [anon_sym_AMP_DOT] = ACTIONS(2181),
    [anon_sym_QMARK] = ACTIONS(2181),
    [anon_sym_DOT_DOT] = ACTIONS(2183),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2181),
    [anon_sym_AMP_AMP] = ACTIONS(2181),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym_EQ_EQ] = ACTIONS(2183),
    [anon_sym_BANG_EQ] = ACTIONS(2181),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2181),
    [anon_sym_LT_EQ_GT] = ACTIONS(2181),
    [anon_sym_EQ_TILDE] = ACTIONS(2181),
    [anon_sym_BANG_TILDE] = ACTIONS(2181),
    [anon_sym_LT_EQ] = ACTIONS(2183),
    [anon_sym_GT] = ACTIONS(2183),
    [anon_sym_GT_EQ] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [sym_comment] = ACTIONS(87),
  },
  [290] = {
    [sym__line_break] = ACTIONS(701),
    [sym__heredoc_body_start] = ACTIONS(701),
    [sym__binary_minus] = ACTIONS(2185),
    [sym__binary_star] = ACTIONS(2187),
    [anon_sym_PIPE] = ACTIONS(2189),
    [anon_sym_SEMI] = ACTIONS(701),
    [anon_sym_STAR_STAR] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2191),
    [anon_sym_LT] = ACTIONS(2193),
    [anon_sym_end] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_unless] = ACTIONS(701),
    [anon_sym_while] = ACTIONS(701),
    [anon_sym_until] = ACTIONS(701),
    [anon_sym_rescue] = ACTIONS(701),
    [anon_sym_else] = ACTIONS(701),
    [anon_sym_ensure] = ACTIONS(701),
    [anon_sym_QMARK] = ACTIONS(2195),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2199),
    [anon_sym_and] = ACTIONS(2201),
    [anon_sym_or] = ACTIONS(2201),
    [anon_sym_PIPE_PIPE] = ACTIONS(2203),
    [anon_sym_AMP_AMP] = ACTIONS(2203),
    [anon_sym_LT_LT] = ACTIONS(2205),
    [anon_sym_GT_GT] = ACTIONS(2205),
    [anon_sym_EQ_EQ] = ACTIONS(2207),
    [anon_sym_BANG_EQ] = ACTIONS(2203),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2203),
    [anon_sym_LT_EQ_GT] = ACTIONS(2203),
    [anon_sym_EQ_TILDE] = ACTIONS(2203),
    [anon_sym_BANG_TILDE] = ACTIONS(2203),
    [anon_sym_LT_EQ] = ACTIONS(2193),
    [anon_sym_GT] = ACTIONS(2193),
    [anon_sym_GT_EQ] = ACTIONS(2209),
    [anon_sym_CARET] = ACTIONS(2211),
    [anon_sym_PLUS] = ACTIONS(2185),
    [anon_sym_SLASH] = ACTIONS(2187),
    [anon_sym_PERCENT] = ACTIONS(2187),
    [sym_comment] = ACTIONS(87),
  },
  [291] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(1244),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1249),
    [sym_scope_resolution] = STATE(1245),
    [sym_call] = STATE(1245),
    [sym_method_call] = STATE(1249),
    [sym_argument_list] = STATE(423),
    [sym__argument_list_with_parens] = STATE(1246),
    [sym__argument] = STATE(1247),
    [sym_splat_argument] = STATE(1247),
    [sym_hash_splat_argument] = STATE(1247),
    [sym_block_argument] = STATE(1247),
    [sym_do_block] = STATE(426),
    [sym_block] = STATE(426),
    [sym_assignment] = STATE(1244),
    [sym_operator_assignment] = STATE(1244),
    [sym_conditional] = STATE(1244),
    [sym_range] = STATE(1244),
    [sym_binary] = STATE(1244),
    [sym_unary] = STATE(1244),
    [sym_left_assignment_list] = STATE(1248),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(1245),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1249),
    [sym_false] = STATE(1249),
    [sym_nil] = STATE(1249),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(1250),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(1247),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(743),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(2213),
    [sym__splat_star] = ACTIONS(2215),
    [sym__unary_minus] = ACTIONS(2217),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(2219),
    [anon_sym_LBRACE] = ACTIONS(771),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(769),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2223),
    [anon_sym_break] = ACTIONS(2225),
    [anon_sym_next] = ACTIONS(2227),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(769),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(769),
    [anon_sym_until] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(769),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_else] = ACTIONS(769),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_ensure] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(2229),
    [anon_sym_not] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(2233),
    [anon_sym_TILDE] = ACTIONS(2235),
    [sym_constant] = ACTIONS(2237),
    [sym_identifier] = ACTIONS(2237),
    [sym_instance_variable] = ACTIONS(2239),
    [sym_class_variable] = ACTIONS(2239),
    [sym_global_variable] = ACTIONS(2239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(2241),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2241),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [292] = {
    [anon_sym_EQ] = ACTIONS(2243),
    [sym_comment] = ACTIONS(87),
  },
  [293] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(2245),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(2247),
    [anon_sym_DASH_EQ] = ACTIONS(2247),
    [anon_sym_STAR_EQ] = ACTIONS(2247),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2247),
    [anon_sym_SLASH_EQ] = ACTIONS(2247),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2247),
    [anon_sym_PIPE_EQ] = ACTIONS(2247),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2247),
    [anon_sym_AMP_EQ] = ACTIONS(2247),
    [anon_sym_PERCENT_EQ] = ACTIONS(2247),
    [anon_sym_GT_GT_EQ] = ACTIONS(2247),
    [anon_sym_LT_LT_EQ] = ACTIONS(2247),
    [anon_sym_CARET_EQ] = ACTIONS(2247),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [294] = {
    [sym_string] = STATE(1253),
    [aux_sym_chained_string_repeat1] = STATE(1253),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [295] = {
    [sym__statements] = STATE(284),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(286),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(287),
    [sym_rescue] = STATE(288),
    [sym__body_statement] = STATE(1254),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(2249),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [296] = {
    [sym_begin_block] = STATE(1255),
    [sym_end_block] = STATE(1255),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1255),
    [sym_unless_modifier] = STATE(1255),
    [sym_while_modifier] = STATE(1255),
    [sym_until_modifier] = STATE(1255),
    [sym_rescue_modifier] = STATE(1255),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(1255),
    [sym_alias] = STATE(1255),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1256),
    [aux_sym__statements_repeat1] = STATE(1256),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(833),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(833),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(833),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [297] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(703),
    [sym__binary_star] = ACTIONS(705),
    [ts_builtin_sym_end] = ACTIONS(935),
    [anon_sym___END__] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(707),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(705),
    [anon_sym_AMP] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(713),
    [anon_sym_DOT_DOT] = ACTIONS(715),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(717),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(721),
    [anon_sym_AMP_AMP] = ACTIONS(721),
    [anon_sym_LT_LT] = ACTIONS(723),
    [anon_sym_GT_GT] = ACTIONS(723),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(721),
    [anon_sym_LT_EQ_GT] = ACTIONS(721),
    [anon_sym_EQ_TILDE] = ACTIONS(721),
    [anon_sym_BANG_TILDE] = ACTIONS(721),
    [anon_sym_LT_EQ] = ACTIONS(711),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_EQ] = ACTIONS(727),
    [anon_sym_CARET] = ACTIONS(729),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_SLASH] = ACTIONS(705),
    [anon_sym_PERCENT] = ACTIONS(705),
    [sym_comment] = ACTIONS(87),
  },
  [298] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [ts_builtin_sym_end] = ACTIONS(935),
    [anon_sym___END__] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(935),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_when] = ACTIONS(935),
    [anon_sym_elsif] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_ensure] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [299] = {
    [sym__line_break] = ACTIONS(1267),
    [sym__heredoc_body_start] = ACTIONS(1267),
    [ts_builtin_sym_end] = ACTIONS(1267),
    [anon_sym___END__] = ACTIONS(1269),
    [anon_sym_RBRACE] = ACTIONS(1267),
    [anon_sym_LPAREN] = ACTIONS(1267),
    [anon_sym_RPAREN] = ACTIONS(1267),
    [anon_sym_COMMA] = ACTIONS(1267),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym_STAR] = ACTIONS(1269),
    [anon_sym_STAR_STAR] = ACTIONS(1267),
    [anon_sym_AMP] = ACTIONS(1267),
    [anon_sym_EQ] = ACTIONS(1271),
    [anon_sym_end] = ACTIONS(1269),
    [anon_sym_if] = ACTIONS(1269),
    [anon_sym_unless] = ACTIONS(1269),
    [anon_sym_while] = ACTIONS(1269),
    [anon_sym_until] = ACTIONS(1269),
    [anon_sym_rescue] = ACTIONS(1269),
    [anon_sym_when] = ACTIONS(1269),
    [anon_sym_elsif] = ACTIONS(1269),
    [anon_sym_else] = ACTIONS(1269),
    [anon_sym_then] = ACTIONS(1269),
    [anon_sym_ensure] = ACTIONS(1269),
    [sym_identifier] = ACTIONS(1269),
    [sym_comment] = ACTIONS(87),
  },
  [300] = {
    [aux_sym_undef_repeat1] = STATE(1258),
    [sym__line_break] = ACTIONS(2251),
    [sym__heredoc_body_start] = ACTIONS(2251),
    [ts_builtin_sym_end] = ACTIONS(2251),
    [anon_sym___END__] = ACTIONS(2251),
    [anon_sym_COMMA] = ACTIONS(2253),
    [anon_sym_SEMI] = ACTIONS(2251),
    [anon_sym_if] = ACTIONS(2251),
    [anon_sym_unless] = ACTIONS(2251),
    [anon_sym_while] = ACTIONS(2251),
    [anon_sym_until] = ACTIONS(2251),
    [anon_sym_rescue] = ACTIONS(2251),
    [sym_comment] = ACTIONS(87),
  },
  [301] = {
    [sym__simple_symbol] = ACTIONS(101),
    [sym__symbol_start] = ACTIONS(101),
    [anon_sym_PIPE] = ACTIONS(101),
    [anon_sym_STAR] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(101),
    [anon_sym_AMP] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(101),
    [anon_sym_LT_LT] = ACTIONS(101),
    [anon_sym_GT_GT] = ACTIONS(101),
    [anon_sym_EQ_EQ] = ACTIONS(103),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(101),
    [anon_sym_LT_EQ_GT] = ACTIONS(101),
    [anon_sym_EQ_TILDE] = ACTIONS(101),
    [anon_sym_BANG_TILDE] = ACTIONS(101),
    [anon_sym_LT_EQ] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_EQ] = ACTIONS(101),
    [anon_sym_CARET] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_SLASH] = ACTIONS(101),
    [anon_sym_PERCENT] = ACTIONS(101),
    [anon_sym_BANG] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_constant] = ACTIONS(101),
    [sym_identifier] = ACTIONS(101),
    [sym_instance_variable] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(101),
    [sym_global_variable] = ACTIONS(101),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_PLUS_AT] = ACTIONS(101),
    [anon_sym_DASH_AT] = ACTIONS(101),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [sym_comment] = ACTIONS(87),
  },
  [302] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(1260),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(2255),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [303] = {
    [sym__simple_symbol] = ACTIONS(1263),
    [sym__symbol_start] = ACTIONS(1263),
    [anon_sym_PIPE] = ACTIONS(1263),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_STAR_STAR] = ACTIONS(1263),
    [anon_sym_AMP] = ACTIONS(1263),
    [anon_sym_LT] = ACTIONS(1265),
    [anon_sym_DOT_DOT] = ACTIONS(1263),
    [anon_sym_LT_LT] = ACTIONS(1263),
    [anon_sym_GT_GT] = ACTIONS(1263),
    [anon_sym_EQ_EQ] = ACTIONS(1265),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1263),
    [anon_sym_LT_EQ_GT] = ACTIONS(1263),
    [anon_sym_EQ_TILDE] = ACTIONS(1263),
    [anon_sym_BANG_TILDE] = ACTIONS(1263),
    [anon_sym_LT_EQ] = ACTIONS(1265),
    [anon_sym_GT] = ACTIONS(1265),
    [anon_sym_GT_EQ] = ACTIONS(1263),
    [anon_sym_CARET] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1265),
    [anon_sym_SLASH] = ACTIONS(1263),
    [anon_sym_PERCENT] = ACTIONS(1263),
    [anon_sym_BANG] = ACTIONS(1265),
    [anon_sym_TILDE] = ACTIONS(1263),
    [sym_constant] = ACTIONS(1263),
    [sym_identifier] = ACTIONS(1263),
    [sym_instance_variable] = ACTIONS(1263),
    [sym_class_variable] = ACTIONS(1263),
    [sym_global_variable] = ACTIONS(1263),
    [anon_sym_DASH] = ACTIONS(1265),
    [anon_sym_PLUS_AT] = ACTIONS(1263),
    [anon_sym_DASH_AT] = ACTIONS(1263),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(1265),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(1263),
    [anon_sym_BQUOTE] = ACTIONS(1263),
    [sym_comment] = ACTIONS(87),
  },
  [304] = {
    [sym__simple_symbol] = ACTIONS(1267),
    [sym__symbol_start] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1267),
    [anon_sym_STAR] = ACTIONS(1269),
    [anon_sym_STAR_STAR] = ACTIONS(1267),
    [anon_sym_AMP] = ACTIONS(1267),
    [anon_sym_EQ] = ACTIONS(2257),
    [anon_sym_LT] = ACTIONS(1269),
    [anon_sym_DOT_DOT] = ACTIONS(1267),
    [anon_sym_LT_LT] = ACTIONS(1267),
    [anon_sym_GT_GT] = ACTIONS(1267),
    [anon_sym_EQ_EQ] = ACTIONS(1269),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1267),
    [anon_sym_LT_EQ_GT] = ACTIONS(1267),
    [anon_sym_EQ_TILDE] = ACTIONS(1267),
    [anon_sym_BANG_TILDE] = ACTIONS(1267),
    [anon_sym_LT_EQ] = ACTIONS(1269),
    [anon_sym_GT] = ACTIONS(1269),
    [anon_sym_GT_EQ] = ACTIONS(1267),
    [anon_sym_CARET] = ACTIONS(1267),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_SLASH] = ACTIONS(1267),
    [anon_sym_PERCENT] = ACTIONS(1267),
    [anon_sym_BANG] = ACTIONS(1269),
    [anon_sym_TILDE] = ACTIONS(1267),
    [sym_constant] = ACTIONS(1267),
    [sym_identifier] = ACTIONS(1267),
    [sym_instance_variable] = ACTIONS(1267),
    [sym_class_variable] = ACTIONS(1267),
    [sym_global_variable] = ACTIONS(1267),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_PLUS_AT] = ACTIONS(1267),
    [anon_sym_DASH_AT] = ACTIONS(1267),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(1269),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(1267),
    [anon_sym_BQUOTE] = ACTIONS(1267),
    [sym_comment] = ACTIONS(87),
  },
  [305] = {
    [sym_operator] = STATE(1262),
    [sym__method_name] = STATE(1262),
    [sym_setter] = STATE(1262),
    [sym_symbol] = STATE(1262),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(2259),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(2259),
    [sym_class_variable] = ACTIONS(2259),
    [sym_global_variable] = ACTIONS(2259),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [306] = {
    [sym__line_break] = ACTIONS(2261),
    [sym__heredoc_body_start] = ACTIONS(2261),
    [sym__binary_minus] = ACTIONS(2261),
    [sym__binary_star] = ACTIONS(2261),
    [ts_builtin_sym_end] = ACTIONS(2261),
    [anon_sym___END__] = ACTIONS(2261),
    [anon_sym_LBRACE] = ACTIONS(2261),
    [anon_sym_RBRACE] = ACTIONS(2261),
    [anon_sym_RPAREN] = ACTIONS(2261),
    [anon_sym_DOT] = ACTIONS(2263),
    [anon_sym_COMMA] = ACTIONS(2261),
    [anon_sym_PIPE] = ACTIONS(2263),
    [anon_sym_SEMI] = ACTIONS(2261),
    [anon_sym_STAR_STAR] = ACTIONS(2261),
    [anon_sym_AMP] = ACTIONS(2263),
    [anon_sym_LT] = ACTIONS(2263),
    [anon_sym_end] = ACTIONS(2261),
    [anon_sym_if] = ACTIONS(2261),
    [anon_sym_unless] = ACTIONS(2261),
    [anon_sym_while] = ACTIONS(2261),
    [anon_sym_until] = ACTIONS(2261),
    [anon_sym_rescue] = ACTIONS(2261),
    [anon_sym_do] = ACTIONS(2261),
    [anon_sym_when] = ACTIONS(2261),
    [anon_sym_elsif] = ACTIONS(2261),
    [anon_sym_else] = ACTIONS(2261),
    [anon_sym_then] = ACTIONS(2261),
    [anon_sym_ensure] = ACTIONS(2261),
    [anon_sym_EQ_GT] = ACTIONS(2261),
    [anon_sym_LBRACK] = ACTIONS(2261),
    [anon_sym_COLON_COLON2] = ACTIONS(2261),
    [anon_sym_AMP_DOT] = ACTIONS(2261),
    [anon_sym_QMARK] = ACTIONS(2261),
    [anon_sym_DOT_DOT] = ACTIONS(2263),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2261),
    [anon_sym_and] = ACTIONS(2261),
    [anon_sym_or] = ACTIONS(2261),
    [anon_sym_PIPE_PIPE] = ACTIONS(2261),
    [anon_sym_AMP_AMP] = ACTIONS(2261),
    [anon_sym_LT_LT] = ACTIONS(2261),
    [anon_sym_GT_GT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(2263),
    [anon_sym_BANG_EQ] = ACTIONS(2261),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2261),
    [anon_sym_LT_EQ_GT] = ACTIONS(2261),
    [anon_sym_EQ_TILDE] = ACTIONS(2261),
    [anon_sym_BANG_TILDE] = ACTIONS(2261),
    [anon_sym_LT_EQ] = ACTIONS(2263),
    [anon_sym_GT] = ACTIONS(2263),
    [anon_sym_GT_EQ] = ACTIONS(2261),
    [anon_sym_CARET] = ACTIONS(2261),
    [anon_sym_PLUS] = ACTIONS(2261),
    [anon_sym_SLASH] = ACTIONS(2261),
    [anon_sym_PERCENT] = ACTIONS(2261),
    [sym_comment] = ACTIONS(87),
  },
  [307] = {
    [sym__heredoc_body_start] = ACTIONS(101),
    [sym__binary_minus] = ACTIONS(101),
    [sym__binary_star] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_RBRACE] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(103),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_PIPE] = ACTIONS(103),
    [anon_sym_SEMI] = ACTIONS(101),
    [anon_sym_STAR_STAR] = ACTIONS(101),
    [anon_sym_AMP] = ACTIONS(103),
    [anon_sym_EQ] = ACTIONS(103),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_unless] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_until] = ACTIONS(101),
    [anon_sym_rescue] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(101),
    [anon_sym_EQ_GT] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_RBRACK] = ACTIONS(101),
    [anon_sym_COLON_COLON2] = ACTIONS(101),
    [anon_sym_AMP_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(103),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_and] = ACTIONS(101),
    [anon_sym_or] = ACTIONS(101),
    [anon_sym_PIPE_PIPE] = ACTIONS(101),
    [anon_sym_AMP_AMP] = ACTIONS(101),
    [anon_sym_LT_LT] = ACTIONS(101),
    [anon_sym_GT_GT] = ACTIONS(101),
    [anon_sym_EQ_EQ] = ACTIONS(103),
    [anon_sym_BANG_EQ] = ACTIONS(101),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(101),
    [anon_sym_LT_EQ_GT] = ACTIONS(101),
    [anon_sym_EQ_TILDE] = ACTIONS(101),
    [anon_sym_BANG_TILDE] = ACTIONS(101),
    [anon_sym_LT_EQ] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_EQ] = ACTIONS(101),
    [anon_sym_CARET] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(101),
    [anon_sym_PERCENT] = ACTIONS(101),
    [sym_comment] = ACTIONS(87),
  },
  [308] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(1264),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(2265),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [309] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(1266),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(2267),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [310] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(1268),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(2269),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [311] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(1270),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(2271),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [312] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1273),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(2273),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(2275),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [313] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1276),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(2277),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(2279),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [314] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(1284),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(1287),
    [sym_scope_resolution] = STATE(1285),
    [sym_call] = STATE(1285),
    [sym_method_call] = STATE(1287),
    [sym_assignment] = STATE(1284),
    [sym_operator_assignment] = STATE(1284),
    [sym_conditional] = STATE(1284),
    [sym_range] = STATE(1284),
    [sym_binary] = STATE(1284),
    [sym_unary] = STATE(1284),
    [sym_left_assignment_list] = STATE(1286),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1287),
    [sym__variable] = STATE(1285),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(1287),
    [sym_false] = STATE(1287),
    [sym_nil] = STATE(1287),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(1288),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(2281),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2283),
    [anon_sym_yield] = ACTIONS(2285),
    [anon_sym_break] = ACTIONS(2287),
    [anon_sym_next] = ACTIONS(2289),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2291),
    [anon_sym_defined_QMARK] = ACTIONS(2293),
    [anon_sym_not] = ACTIONS(2295),
    [anon_sym_BANG] = ACTIONS(2297),
    [anon_sym_TILDE] = ACTIONS(2297),
    [sym_constant] = ACTIONS(2299),
    [sym_identifier] = ACTIONS(2299),
    [sym_instance_variable] = ACTIONS(2301),
    [sym_class_variable] = ACTIONS(2301),
    [sym_global_variable] = ACTIONS(2301),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2299),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2299),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [315] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(1289),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(1287),
    [sym_scope_resolution] = STATE(1285),
    [sym_call] = STATE(1285),
    [sym_method_call] = STATE(1287),
    [sym_assignment] = STATE(1289),
    [sym_operator_assignment] = STATE(1289),
    [sym_conditional] = STATE(1289),
    [sym_range] = STATE(1289),
    [sym_binary] = STATE(1289),
    [sym_unary] = STATE(1289),
    [sym_left_assignment_list] = STATE(1286),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1287),
    [sym__variable] = STATE(1285),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(1287),
    [sym_false] = STATE(1287),
    [sym_nil] = STATE(1287),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(1288),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(2281),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2283),
    [anon_sym_yield] = ACTIONS(2285),
    [anon_sym_break] = ACTIONS(2287),
    [anon_sym_next] = ACTIONS(2289),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2291),
    [anon_sym_defined_QMARK] = ACTIONS(2293),
    [anon_sym_not] = ACTIONS(2295),
    [anon_sym_BANG] = ACTIONS(2297),
    [anon_sym_TILDE] = ACTIONS(2297),
    [sym_constant] = ACTIONS(2299),
    [sym_identifier] = ACTIONS(2299),
    [sym_instance_variable] = ACTIONS(2301),
    [sym_class_variable] = ACTIONS(2301),
    [sym_global_variable] = ACTIONS(2301),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2299),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2299),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [316] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(1290),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(352),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(352),
    [sym_assignment] = STATE(1290),
    [sym_operator_assignment] = STATE(1290),
    [sym_conditional] = STATE(1290),
    [sym_range] = STATE(1290),
    [sym_binary] = STATE(1290),
    [sym_unary] = STATE(1290),
    [sym_left_assignment_list] = STATE(351),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(352),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(352),
    [sym_false] = STATE(352),
    [sym_nil] = STATE(352),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1291),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [317] = {
    [anon_sym_COLON] = ACTIONS(2303),
    [sym_comment] = ACTIONS(87),
  },
  [318] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(113),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(118),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(118),
    [sym_hash_splat_argument] = STATE(116),
    [sym_assignment] = STATE(113),
    [sym_operator_assignment] = STATE(113),
    [sym_conditional] = STATE(113),
    [sym_range] = STATE(113),
    [sym_binary] = STATE(113),
    [sym_unary] = STATE(113),
    [sym_left_assignment_list] = STATE(117),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(118),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(118),
    [sym_false] = STATE(118),
    [sym_nil] = STATE(118),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(119),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_heredoc_body] = STATE(1294),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym__hash_items] = STATE(1295),
    [sym_pair] = STATE(122),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [sym__identifier_hash_key] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_RBRACE] = ACTIONS(2305),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(209),
    [sym_identifier] = ACTIONS(209),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [319] = {
    [sym__method_rest] = STATE(1297),
    [sym__variable] = STATE(1298),
    [sym_operator] = STATE(1299),
    [sym__method_name] = STATE(1299),
    [sym_setter] = STATE(1299),
    [sym_symbol] = STATE(1299),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_LPAREN] = ACTIONS(2307),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(239),
    [sym_identifier] = ACTIONS(241),
    [sym_instance_variable] = ACTIONS(239),
    [sym_class_variable] = ACTIONS(239),
    [sym_global_variable] = ACTIONS(239),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
    [sym_super] = ACTIONS(2309),
    [sym_self] = ACTIONS(2309),
  },
  [320] = {
    [sym__statements] = STATE(1301),
    [sym_begin_block] = STATE(144),
    [sym_end_block] = STATE(144),
    [sym__statement] = STATE(144),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(144),
    [sym_unless_modifier] = STATE(144),
    [sym_while_modifier] = STATE(144),
    [sym_until_modifier] = STATE(144),
    [sym_rescue_modifier] = STATE(144),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(145),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(150),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(150),
    [sym_assignment] = STATE(145),
    [sym_operator_assignment] = STATE(145),
    [sym_conditional] = STATE(145),
    [sym_range] = STATE(145),
    [sym_binary] = STATE(145),
    [sym_unary] = STATE(145),
    [sym_left_assignment_list] = STATE(147),
    [sym__mlhs] = STATE(148),
    [sym_destructured_left_assignment] = STATE(149),
    [sym_rest_assignment] = STATE(149),
    [sym__lhs] = STATE(150),
    [sym__variable] = STATE(146),
    [sym_undef] = STATE(144),
    [sym_alias] = STATE(144),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(150),
    [sym_false] = STATE(150),
    [sym_nil] = STATE(150),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(151),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(152),
    [aux_sym__statements_repeat1] = STATE(152),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_RPAREN] = ACTIONS(2311),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(249),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [anon_sym_undef] = ACTIONS(271),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [321] = {
    [sym_constant] = ACTIONS(2313),
    [sym_identifier] = ACTIONS(2313),
    [sym_comment] = ACTIONS(87),
  },
  [322] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(1303),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(1287),
    [sym_scope_resolution] = STATE(1285),
    [sym_call] = STATE(1285),
    [sym_method_call] = STATE(1287),
    [sym_assignment] = STATE(1303),
    [sym_operator_assignment] = STATE(1303),
    [sym_conditional] = STATE(1303),
    [sym_range] = STATE(1303),
    [sym_binary] = STATE(1303),
    [sym_unary] = STATE(1303),
    [sym_left_assignment_list] = STATE(1286),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1287),
    [sym__variable] = STATE(1285),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(1287),
    [sym_false] = STATE(1287),
    [sym_nil] = STATE(1287),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(1288),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(2281),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2283),
    [anon_sym_yield] = ACTIONS(2285),
    [anon_sym_break] = ACTIONS(2287),
    [anon_sym_next] = ACTIONS(2289),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2291),
    [anon_sym_defined_QMARK] = ACTIONS(2293),
    [anon_sym_not] = ACTIONS(2295),
    [anon_sym_BANG] = ACTIONS(2297),
    [anon_sym_TILDE] = ACTIONS(2297),
    [sym_constant] = ACTIONS(2299),
    [sym_identifier] = ACTIONS(2299),
    [sym_instance_variable] = ACTIONS(2301),
    [sym_class_variable] = ACTIONS(2301),
    [sym_global_variable] = ACTIONS(2301),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2299),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2299),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [323] = {
    [sym_method] = STATE(191),
    [sym_singleton_method] = STATE(191),
    [sym_class] = STATE(191),
    [sym_singleton_class] = STATE(191),
    [sym_module] = STATE(191),
    [sym_return] = STATE(191),
    [sym_yield] = STATE(191),
    [sym_break] = STATE(191),
    [sym_next] = STATE(191),
    [sym_while] = STATE(191),
    [sym_until] = STATE(191),
    [sym_for] = STATE(191),
    [sym_case] = STATE(191),
    [sym_if] = STATE(191),
    [sym_unless] = STATE(191),
    [sym_begin] = STATE(191),
    [sym__primary] = STATE(191),
    [sym_parenthesized_statements] = STATE(191),
    [sym_element_reference] = STATE(191),
    [sym_scope_resolution] = STATE(1306),
    [sym_call] = STATE(193),
    [sym_method_call] = STATE(191),
    [sym__lhs] = STATE(191),
    [sym__variable] = STATE(193),
    [sym_rational] = STATE(191),
    [sym_true] = STATE(191),
    [sym_false] = STATE(191),
    [sym_nil] = STATE(191),
    [sym_chained_string] = STATE(191),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(191),
    [sym_string_array] = STATE(191),
    [sym_symbol_array] = STATE(191),
    [sym_symbol] = STATE(191),
    [sym_regex] = STATE(191),
    [sym_array] = STATE(191),
    [sym_hash] = STATE(191),
    [sym_lambda] = STATE(191),
    [sym__simple_symbol] = ACTIONS(279),
    [sym__string_start] = ACTIONS(281),
    [sym__symbol_start] = ACTIONS(283),
    [sym__subshell_start] = ACTIONS(285),
    [sym__regex_start] = ACTIONS(287),
    [sym__string_array_start] = ACTIONS(289),
    [sym__symbol_array_start] = ACTIONS(291),
    [sym_heredoc_beginning] = ACTIONS(349),
    [sym__singleton_class_left_angle_left_langle] = ACTIONS(2315),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_def] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(299),
    [anon_sym_COLON_COLON] = ACTIONS(353),
    [anon_sym_class] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(307),
    [anon_sym_return] = ACTIONS(309),
    [anon_sym_yield] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_next] = ACTIONS(315),
    [sym_redo] = ACTIONS(355),
    [sym_retry] = ACTIONS(355),
    [anon_sym_if] = ACTIONS(319),
    [anon_sym_unless] = ACTIONS(321),
    [anon_sym_while] = ACTIONS(323),
    [anon_sym_until] = ACTIONS(325),
    [anon_sym_for] = ACTIONS(327),
    [anon_sym_case] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(331),
    [sym_constant] = ACTIONS(2317),
    [sym_identifier] = ACTIONS(359),
    [sym_instance_variable] = ACTIONS(361),
    [sym_class_variable] = ACTIONS(361),
    [sym_global_variable] = ACTIONS(361),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(355),
    [sym_complex] = ACTIONS(349),
    [sym_super] = ACTIONS(359),
    [anon_sym_true] = ACTIONS(339),
    [anon_sym_TRUE] = ACTIONS(339),
    [anon_sym_false] = ACTIONS(341),
    [anon_sym_FALSE] = ACTIONS(341),
    [sym_self] = ACTIONS(359),
    [anon_sym_nil] = ACTIONS(343),
    [anon_sym_NIL] = ACTIONS(343),
    [sym_character] = ACTIONS(349),
    [anon_sym_LBRACK2] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(347),
  },
  [324] = {
    [sym_method] = STATE(191),
    [sym_singleton_method] = STATE(191),
    [sym_class] = STATE(191),
    [sym_singleton_class] = STATE(191),
    [sym_module] = STATE(191),
    [sym_return] = STATE(191),
    [sym_yield] = STATE(191),
    [sym_break] = STATE(191),
    [sym_next] = STATE(191),
    [sym_while] = STATE(191),
    [sym_until] = STATE(191),
    [sym_for] = STATE(191),
    [sym_case] = STATE(191),
    [sym_if] = STATE(191),
    [sym_unless] = STATE(191),
    [sym_begin] = STATE(191),
    [sym__primary] = STATE(191),
    [sym_parenthesized_statements] = STATE(191),
    [sym_element_reference] = STATE(191),
    [sym_scope_resolution] = STATE(1308),
    [sym_call] = STATE(193),
    [sym_method_call] = STATE(191),
    [sym__lhs] = STATE(191),
    [sym__variable] = STATE(193),
    [sym_rational] = STATE(191),
    [sym_true] = STATE(191),
    [sym_false] = STATE(191),
    [sym_nil] = STATE(191),
    [sym_chained_string] = STATE(191),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(191),
    [sym_string_array] = STATE(191),
    [sym_symbol_array] = STATE(191),
    [sym_symbol] = STATE(191),
    [sym_regex] = STATE(191),
    [sym_array] = STATE(191),
    [sym_hash] = STATE(191),
    [sym_lambda] = STATE(191),
    [sym__simple_symbol] = ACTIONS(279),
    [sym__string_start] = ACTIONS(281),
    [sym__symbol_start] = ACTIONS(283),
    [sym__subshell_start] = ACTIONS(285),
    [sym__regex_start] = ACTIONS(287),
    [sym__string_array_start] = ACTIONS(289),
    [sym__symbol_array_start] = ACTIONS(291),
    [sym_heredoc_beginning] = ACTIONS(349),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_def] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(299),
    [anon_sym_COLON_COLON] = ACTIONS(353),
    [anon_sym_class] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(307),
    [anon_sym_return] = ACTIONS(309),
    [anon_sym_yield] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_next] = ACTIONS(315),
    [sym_redo] = ACTIONS(355),
    [sym_retry] = ACTIONS(355),
    [anon_sym_if] = ACTIONS(319),
    [anon_sym_unless] = ACTIONS(321),
    [anon_sym_while] = ACTIONS(323),
    [anon_sym_until] = ACTIONS(325),
    [anon_sym_for] = ACTIONS(327),
    [anon_sym_case] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(331),
    [sym_constant] = ACTIONS(2319),
    [sym_identifier] = ACTIONS(359),
    [sym_instance_variable] = ACTIONS(361),
    [sym_class_variable] = ACTIONS(361),
    [sym_global_variable] = ACTIONS(361),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(355),
    [sym_complex] = ACTIONS(349),
    [sym_super] = ACTIONS(359),
    [anon_sym_true] = ACTIONS(339),
    [anon_sym_TRUE] = ACTIONS(339),
    [anon_sym_false] = ACTIONS(341),
    [anon_sym_FALSE] = ACTIONS(341),
    [sym_self] = ACTIONS(359),
    [anon_sym_nil] = ACTIONS(343),
    [anon_sym_NIL] = ACTIONS(343),
    [sym_character] = ACTIONS(349),
    [anon_sym_LBRACK2] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(347),
  },
  [325] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(1317),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1322),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(1322),
    [sym_argument_list] = STATE(1318),
    [sym__argument_list_with_parens] = STATE(1319),
    [sym__argument] = STATE(1320),
    [sym_splat_argument] = STATE(1320),
    [sym_hash_splat_argument] = STATE(1320),
    [sym_block_argument] = STATE(1320),
    [sym_assignment] = STATE(1317),
    [sym_operator_assignment] = STATE(1317),
    [sym_conditional] = STATE(1317),
    [sym_range] = STATE(1317),
    [sym_binary] = STATE(1317),
    [sym_unary] = STATE(1317),
    [sym_left_assignment_list] = STATE(1321),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1322),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1322),
    [sym_false] = STATE(1322),
    [sym_nil] = STATE(1322),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1323),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(1320),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(2321),
    [sym__splat_star] = ACTIONS(2323),
    [sym__unary_minus] = ACTIONS(2325),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_RBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(2329),
    [anon_sym_not] = ACTIONS(2331),
    [anon_sym_BANG] = ACTIONS(2333),
    [anon_sym_TILDE] = ACTIONS(2335),
    [sym_constant] = ACTIONS(2337),
    [sym_identifier] = ACTIONS(2337),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [326] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(1317),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1322),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(1322),
    [sym_argument_list] = STATE(1324),
    [sym__argument_list_with_parens] = STATE(1319),
    [sym__argument] = STATE(1320),
    [sym_splat_argument] = STATE(1320),
    [sym_hash_splat_argument] = STATE(1320),
    [sym_block_argument] = STATE(1320),
    [sym_assignment] = STATE(1317),
    [sym_operator_assignment] = STATE(1317),
    [sym_conditional] = STATE(1317),
    [sym_range] = STATE(1317),
    [sym_binary] = STATE(1317),
    [sym_unary] = STATE(1317),
    [sym_left_assignment_list] = STATE(1321),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1322),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1322),
    [sym_false] = STATE(1322),
    [sym_nil] = STATE(1322),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1323),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(1320),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(2321),
    [sym__splat_star] = ACTIONS(2323),
    [sym__unary_minus] = ACTIONS(2325),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_RBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(2329),
    [anon_sym_not] = ACTIONS(2331),
    [anon_sym_BANG] = ACTIONS(2333),
    [anon_sym_TILDE] = ACTIONS(2335),
    [sym_constant] = ACTIONS(2337),
    [sym_identifier] = ACTIONS(2337),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [327] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(1317),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1322),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(1322),
    [sym_argument_list] = STATE(1325),
    [sym__argument_list_with_parens] = STATE(1319),
    [sym__argument] = STATE(1320),
    [sym_splat_argument] = STATE(1320),
    [sym_hash_splat_argument] = STATE(1320),
    [sym_block_argument] = STATE(1320),
    [sym_assignment] = STATE(1317),
    [sym_operator_assignment] = STATE(1317),
    [sym_conditional] = STATE(1317),
    [sym_range] = STATE(1317),
    [sym_binary] = STATE(1317),
    [sym_unary] = STATE(1317),
    [sym_left_assignment_list] = STATE(1321),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1322),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1322),
    [sym_false] = STATE(1322),
    [sym_nil] = STATE(1322),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1323),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(1320),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(2321),
    [sym__splat_star] = ACTIONS(2323),
    [sym__unary_minus] = ACTIONS(2325),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_RBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(2329),
    [anon_sym_not] = ACTIONS(2331),
    [anon_sym_BANG] = ACTIONS(2333),
    [anon_sym_TILDE] = ACTIONS(2335),
    [sym_constant] = ACTIONS(2337),
    [sym_identifier] = ACTIONS(2337),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [328] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(1317),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1322),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(1322),
    [sym_argument_list] = STATE(1326),
    [sym__argument_list_with_parens] = STATE(1319),
    [sym__argument] = STATE(1320),
    [sym_splat_argument] = STATE(1320),
    [sym_hash_splat_argument] = STATE(1320),
    [sym_block_argument] = STATE(1320),
    [sym_assignment] = STATE(1317),
    [sym_operator_assignment] = STATE(1317),
    [sym_conditional] = STATE(1317),
    [sym_range] = STATE(1317),
    [sym_binary] = STATE(1317),
    [sym_unary] = STATE(1317),
    [sym_left_assignment_list] = STATE(1321),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1322),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1322),
    [sym_false] = STATE(1322),
    [sym_nil] = STATE(1322),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1323),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(1320),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(2321),
    [sym__splat_star] = ACTIONS(2323),
    [sym__unary_minus] = ACTIONS(2325),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_RBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(2329),
    [anon_sym_not] = ACTIONS(2331),
    [anon_sym_BANG] = ACTIONS(2333),
    [anon_sym_TILDE] = ACTIONS(2335),
    [sym_constant] = ACTIONS(2337),
    [sym_identifier] = ACTIONS(2337),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [329] = {
    [sym_begin_block] = STATE(1327),
    [sym_end_block] = STATE(1327),
    [sym__statement] = STATE(1327),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1327),
    [sym_unless_modifier] = STATE(1327),
    [sym_while_modifier] = STATE(1327),
    [sym_until_modifier] = STATE(1327),
    [sym_rescue_modifier] = STATE(1327),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(234),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(234),
    [sym_operator_assignment] = STATE(234),
    [sym_conditional] = STATE(234),
    [sym_range] = STATE(234),
    [sym_binary] = STATE(234),
    [sym_unary] = STATE(234),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_undef] = STATE(1327),
    [sym_alias] = STATE(1327),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(429),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_yield] = ACTIONS(433),
    [anon_sym_break] = ACTIONS(435),
    [anon_sym_next] = ACTIONS(437),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(439),
    [anon_sym_defined_QMARK] = ACTIONS(441),
    [anon_sym_not] = ACTIONS(443),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [anon_sym_undef] = ACTIONS(451),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [330] = {
    [sym_begin_block] = STATE(1328),
    [sym_end_block] = STATE(1328),
    [sym__statement] = STATE(1328),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1328),
    [sym_unless_modifier] = STATE(1328),
    [sym_while_modifier] = STATE(1328),
    [sym_until_modifier] = STATE(1328),
    [sym_rescue_modifier] = STATE(1328),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(234),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(234),
    [sym_operator_assignment] = STATE(234),
    [sym_conditional] = STATE(234),
    [sym_range] = STATE(234),
    [sym_binary] = STATE(234),
    [sym_unary] = STATE(234),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_undef] = STATE(1328),
    [sym_alias] = STATE(1328),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(429),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_yield] = ACTIONS(433),
    [anon_sym_break] = ACTIONS(435),
    [anon_sym_next] = ACTIONS(437),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(439),
    [anon_sym_defined_QMARK] = ACTIONS(441),
    [anon_sym_not] = ACTIONS(443),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [anon_sym_undef] = ACTIONS(451),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [331] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1329),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(1329),
    [sym_operator_assignment] = STATE(1329),
    [sym_conditional] = STATE(1329),
    [sym_range] = STATE(1329),
    [sym_binary] = STATE(1329),
    [sym_unary] = STATE(1329),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(455),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_break] = ACTIONS(459),
    [anon_sym_next] = ACTIONS(461),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_defined_QMARK] = ACTIONS(465),
    [anon_sym_not] = ACTIONS(467),
    [anon_sym_BANG] = ACTIONS(469),
    [anon_sym_TILDE] = ACTIONS(469),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [332] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1330),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(1330),
    [sym_operator_assignment] = STATE(1330),
    [sym_conditional] = STATE(1330),
    [sym_range] = STATE(1330),
    [sym_binary] = STATE(1330),
    [sym_unary] = STATE(1330),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(455),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_break] = ACTIONS(459),
    [anon_sym_next] = ACTIONS(461),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_defined_QMARK] = ACTIONS(465),
    [anon_sym_not] = ACTIONS(467),
    [anon_sym_BANG] = ACTIONS(469),
    [anon_sym_TILDE] = ACTIONS(469),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [333] = {
    [sym_method] = STATE(184),
    [sym_singleton_method] = STATE(184),
    [sym_class] = STATE(184),
    [sym_singleton_class] = STATE(184),
    [sym_module] = STATE(184),
    [sym_return] = STATE(184),
    [sym_yield] = STATE(184),
    [sym_break] = STATE(184),
    [sym_next] = STATE(184),
    [sym_while] = STATE(184),
    [sym_until] = STATE(184),
    [sym_for] = STATE(184),
    [sym_case] = STATE(184),
    [sym_if] = STATE(184),
    [sym_unless] = STATE(184),
    [sym_begin] = STATE(184),
    [sym__primary] = STATE(184),
    [sym_parenthesized_statements] = STATE(184),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(255),
    [sym_call] = STATE(255),
    [sym_method_call] = STATE(258),
    [sym__mlhs] = STATE(1331),
    [sym_destructured_left_assignment] = STATE(257),
    [sym_rest_assignment] = STATE(257),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(255),
    [sym_rational] = STATE(184),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(184),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(184),
    [sym_string_array] = STATE(184),
    [sym_symbol_array] = STATE(184),
    [sym_symbol] = STATE(184),
    [sym_regex] = STATE(184),
    [sym_array] = STATE(184),
    [sym_hash] = STATE(184),
    [sym_lambda] = STATE(184),
    [sym__simple_symbol] = ACTIONS(279),
    [sym__string_start] = ACTIONS(281),
    [sym__symbol_start] = ACTIONS(283),
    [sym__subshell_start] = ACTIONS(285),
    [sym__regex_start] = ACTIONS(287),
    [sym__string_array_start] = ACTIONS(289),
    [sym__symbol_array_start] = ACTIONS(291),
    [sym_heredoc_beginning] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_def] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(475),
    [anon_sym_COLON_COLON] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(477),
    [anon_sym_class] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(307),
    [anon_sym_return] = ACTIONS(309),
    [anon_sym_yield] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_next] = ACTIONS(315),
    [sym_redo] = ACTIONS(317),
    [sym_retry] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(319),
    [anon_sym_unless] = ACTIONS(321),
    [anon_sym_while] = ACTIONS(323),
    [anon_sym_until] = ACTIONS(325),
    [anon_sym_for] = ACTIONS(327),
    [anon_sym_case] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(331),
    [sym_constant] = ACTIONS(479),
    [sym_identifier] = ACTIONS(479),
    [sym_instance_variable] = ACTIONS(481),
    [sym_class_variable] = ACTIONS(481),
    [sym_global_variable] = ACTIONS(481),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(317),
    [sym_complex] = ACTIONS(293),
    [sym_super] = ACTIONS(479),
    [anon_sym_true] = ACTIONS(339),
    [anon_sym_TRUE] = ACTIONS(339),
    [anon_sym_false] = ACTIONS(341),
    [anon_sym_FALSE] = ACTIONS(341),
    [sym_self] = ACTIONS(479),
    [anon_sym_nil] = ACTIONS(343),
    [anon_sym_NIL] = ACTIONS(343),
    [sym_character] = ACTIONS(293),
    [anon_sym_LBRACK2] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(347),
  },
  [334] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1332),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(1332),
    [sym_operator_assignment] = STATE(1332),
    [sym_conditional] = STATE(1332),
    [sym_range] = STATE(1332),
    [sym_binary] = STATE(1332),
    [sym_unary] = STATE(1332),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_heredoc_body] = STATE(1333),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__terminator] = STATE(1333),
    [sym__line_break] = ACTIONS(2339),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(485),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2339),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(495),
    [anon_sym_defined_QMARK] = ACTIONS(497),
    [anon_sym_not] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(501),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [335] = {
    [sym__statements] = STATE(1334),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(1335),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(1336),
    [sym_rescue] = STATE(1337),
    [sym__body_statement] = STATE(1338),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_heredoc_body] = STATE(1339),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [sym__terminator] = STATE(1339),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__line_break] = ACTIONS(2341),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2341),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(2343),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [336] = {
    [sym__line_break] = ACTIONS(2345),
    [sym__heredoc_body_start] = ACTIONS(2345),
    [sym__binary_minus] = ACTIONS(2345),
    [sym__binary_star] = ACTIONS(2345),
    [ts_builtin_sym_end] = ACTIONS(2345),
    [anon_sym___END__] = ACTIONS(2345),
    [anon_sym_LBRACE] = ACTIONS(2345),
    [anon_sym_RBRACE] = ACTIONS(2345),
    [anon_sym_RPAREN] = ACTIONS(2345),
    [anon_sym_DOT] = ACTIONS(2347),
    [anon_sym_COMMA] = ACTIONS(2345),
    [anon_sym_PIPE] = ACTIONS(2347),
    [anon_sym_SEMI] = ACTIONS(2345),
    [anon_sym_STAR_STAR] = ACTIONS(2345),
    [anon_sym_AMP] = ACTIONS(2347),
    [anon_sym_LT] = ACTIONS(2347),
    [anon_sym_end] = ACTIONS(2345),
    [anon_sym_if] = ACTIONS(2345),
    [anon_sym_unless] = ACTIONS(2345),
    [anon_sym_while] = ACTIONS(2345),
    [anon_sym_until] = ACTIONS(2345),
    [anon_sym_rescue] = ACTIONS(2345),
    [anon_sym_do] = ACTIONS(2345),
    [anon_sym_when] = ACTIONS(2345),
    [anon_sym_elsif] = ACTIONS(2345),
    [anon_sym_else] = ACTIONS(2345),
    [anon_sym_then] = ACTIONS(2345),
    [anon_sym_ensure] = ACTIONS(2345),
    [anon_sym_EQ_GT] = ACTIONS(2345),
    [anon_sym_LBRACK] = ACTIONS(2345),
    [anon_sym_COLON_COLON2] = ACTIONS(2345),
    [anon_sym_AMP_DOT] = ACTIONS(2345),
    [anon_sym_QMARK] = ACTIONS(2345),
    [anon_sym_DOT_DOT] = ACTIONS(2347),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2345),
    [anon_sym_and] = ACTIONS(2345),
    [anon_sym_or] = ACTIONS(2345),
    [anon_sym_PIPE_PIPE] = ACTIONS(2345),
    [anon_sym_AMP_AMP] = ACTIONS(2345),
    [anon_sym_LT_LT] = ACTIONS(2345),
    [anon_sym_GT_GT] = ACTIONS(2345),
    [anon_sym_EQ_EQ] = ACTIONS(2347),
    [anon_sym_BANG_EQ] = ACTIONS(2345),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2345),
    [anon_sym_LT_EQ_GT] = ACTIONS(2345),
    [anon_sym_EQ_TILDE] = ACTIONS(2345),
    [anon_sym_BANG_TILDE] = ACTIONS(2345),
    [anon_sym_LT_EQ] = ACTIONS(2347),
    [anon_sym_GT] = ACTIONS(2347),
    [anon_sym_GT_EQ] = ACTIONS(2345),
    [anon_sym_CARET] = ACTIONS(2345),
    [anon_sym_PLUS] = ACTIONS(2345),
    [anon_sym_SLASH] = ACTIONS(2345),
    [anon_sym_PERCENT] = ACTIONS(2345),
    [sym_comment] = ACTIONS(87),
  },
  [337] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(1340),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(352),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(352),
    [sym_assignment] = STATE(1340),
    [sym_operator_assignment] = STATE(1340),
    [sym_conditional] = STATE(1340),
    [sym_range] = STATE(1340),
    [sym_binary] = STATE(1340),
    [sym_unary] = STATE(1340),
    [sym_left_assignment_list] = STATE(351),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(352),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(352),
    [sym_false] = STATE(352),
    [sym_nil] = STATE(352),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1291),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [338] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(1341),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(352),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(352),
    [sym_assignment] = STATE(1341),
    [sym_operator_assignment] = STATE(1341),
    [sym_conditional] = STATE(1341),
    [sym_range] = STATE(1341),
    [sym_binary] = STATE(1341),
    [sym_unary] = STATE(1341),
    [sym_left_assignment_list] = STATE(351),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(352),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(352),
    [sym_false] = STATE(352),
    [sym_nil] = STATE(352),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1291),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [339] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(2349),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_RBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [340] = {
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_in] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
    [anon_sym_r] = ACTIONS(2351),
  },
  [341] = {
    [sym__heredoc_body_start] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(565),
    [sym__binary_star] = ACTIONS(565),
    [anon_sym_LBRACE] = ACTIONS(565),
    [anon_sym_RBRACE] = ACTIONS(565),
    [anon_sym_RPAREN] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(567),
    [anon_sym_COMMA] = ACTIONS(565),
    [anon_sym_PIPE] = ACTIONS(567),
    [anon_sym_SEMI] = ACTIONS(565),
    [anon_sym_STAR_STAR] = ACTIONS(567),
    [anon_sym_AMP] = ACTIONS(567),
    [anon_sym_EQ] = ACTIONS(567),
    [anon_sym_LT] = ACTIONS(567),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_unless] = ACTIONS(565),
    [anon_sym_while] = ACTIONS(565),
    [anon_sym_until] = ACTIONS(565),
    [anon_sym_rescue] = ACTIONS(565),
    [anon_sym_in] = ACTIONS(565),
    [anon_sym_do] = ACTIONS(565),
    [anon_sym_EQ_GT] = ACTIONS(565),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_RBRACK] = ACTIONS(565),
    [anon_sym_COLON_COLON2] = ACTIONS(565),
    [anon_sym_AMP_DOT] = ACTIONS(565),
    [anon_sym_PLUS_EQ] = ACTIONS(565),
    [anon_sym_DASH_EQ] = ACTIONS(565),
    [anon_sym_STAR_EQ] = ACTIONS(565),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(565),
    [anon_sym_SLASH_EQ] = ACTIONS(565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(565),
    [anon_sym_PIPE_EQ] = ACTIONS(565),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(565),
    [anon_sym_AMP_EQ] = ACTIONS(565),
    [anon_sym_PERCENT_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_LT_LT_EQ] = ACTIONS(565),
    [anon_sym_CARET_EQ] = ACTIONS(565),
    [anon_sym_QMARK] = ACTIONS(565),
    [anon_sym_COLON2] = ACTIONS(567),
    [anon_sym_DOT_DOT] = ACTIONS(567),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(565),
    [anon_sym_and] = ACTIONS(565),
    [anon_sym_or] = ACTIONS(565),
    [anon_sym_PIPE_PIPE] = ACTIONS(567),
    [anon_sym_AMP_AMP] = ACTIONS(567),
    [anon_sym_LT_LT] = ACTIONS(567),
    [anon_sym_GT_GT] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(565),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(565),
    [anon_sym_LT_EQ_GT] = ACTIONS(565),
    [anon_sym_EQ_TILDE] = ACTIONS(565),
    [anon_sym_BANG_TILDE] = ACTIONS(565),
    [anon_sym_LT_EQ] = ACTIONS(567),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_GT_EQ] = ACTIONS(565),
    [anon_sym_CARET] = ACTIONS(567),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_SLASH] = ACTIONS(567),
    [anon_sym_PERCENT] = ACTIONS(567),
    [sym_comment] = ACTIONS(87),
  },
  [342] = {
    [sym__heredoc_body_start] = ACTIONS(569),
    [sym__binary_minus] = ACTIONS(569),
    [sym__binary_star] = ACTIONS(569),
    [anon_sym_LBRACE] = ACTIONS(569),
    [anon_sym_RBRACE] = ACTIONS(569),
    [anon_sym_RPAREN] = ACTIONS(569),
    [anon_sym_DOT] = ACTIONS(571),
    [anon_sym_COMMA] = ACTIONS(569),
    [anon_sym_PIPE] = ACTIONS(571),
    [anon_sym_SEMI] = ACTIONS(569),
    [anon_sym_STAR_STAR] = ACTIONS(571),
    [anon_sym_AMP] = ACTIONS(571),
    [anon_sym_EQ] = ACTIONS(571),
    [anon_sym_LT] = ACTIONS(571),
    [anon_sym_if] = ACTIONS(569),
    [anon_sym_unless] = ACTIONS(569),
    [anon_sym_while] = ACTIONS(569),
    [anon_sym_until] = ACTIONS(569),
    [anon_sym_rescue] = ACTIONS(569),
    [anon_sym_in] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_EQ_GT] = ACTIONS(569),
    [anon_sym_LBRACK] = ACTIONS(569),
    [anon_sym_RBRACK] = ACTIONS(569),
    [anon_sym_COLON_COLON2] = ACTIONS(569),
    [anon_sym_AMP_DOT] = ACTIONS(569),
    [anon_sym_PLUS_EQ] = ACTIONS(569),
    [anon_sym_DASH_EQ] = ACTIONS(569),
    [anon_sym_STAR_EQ] = ACTIONS(569),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(569),
    [anon_sym_SLASH_EQ] = ACTIONS(569),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(569),
    [anon_sym_PIPE_EQ] = ACTIONS(569),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(569),
    [anon_sym_AMP_EQ] = ACTIONS(569),
    [anon_sym_PERCENT_EQ] = ACTIONS(569),
    [anon_sym_GT_GT_EQ] = ACTIONS(569),
    [anon_sym_LT_LT_EQ] = ACTIONS(569),
    [anon_sym_CARET_EQ] = ACTIONS(569),
    [anon_sym_QMARK] = ACTIONS(569),
    [anon_sym_COLON2] = ACTIONS(571),
    [anon_sym_DOT_DOT] = ACTIONS(571),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(569),
    [anon_sym_and] = ACTIONS(569),
    [anon_sym_or] = ACTIONS(569),
    [anon_sym_PIPE_PIPE] = ACTIONS(571),
    [anon_sym_AMP_AMP] = ACTIONS(571),
    [anon_sym_LT_LT] = ACTIONS(571),
    [anon_sym_GT_GT] = ACTIONS(571),
    [anon_sym_EQ_EQ] = ACTIONS(571),
    [anon_sym_BANG_EQ] = ACTIONS(569),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(569),
    [anon_sym_LT_EQ_GT] = ACTIONS(569),
    [anon_sym_EQ_TILDE] = ACTIONS(569),
    [anon_sym_BANG_TILDE] = ACTIONS(569),
    [anon_sym_LT_EQ] = ACTIONS(571),
    [anon_sym_GT] = ACTIONS(571),
    [anon_sym_GT_EQ] = ACTIONS(569),
    [anon_sym_CARET] = ACTIONS(571),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_SLASH] = ACTIONS(571),
    [anon_sym_PERCENT] = ACTIONS(571),
    [sym_comment] = ACTIONS(87),
  },
  [343] = {
    [sym__heredoc_body_start] = ACTIONS(573),
    [sym__binary_minus] = ACTIONS(573),
    [sym__binary_star] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(573),
    [anon_sym_RBRACE] = ACTIONS(573),
    [anon_sym_RPAREN] = ACTIONS(573),
    [anon_sym_DOT] = ACTIONS(575),
    [anon_sym_COMMA] = ACTIONS(573),
    [anon_sym_PIPE] = ACTIONS(575),
    [anon_sym_SEMI] = ACTIONS(573),
    [anon_sym_STAR_STAR] = ACTIONS(575),
    [anon_sym_AMP] = ACTIONS(575),
    [anon_sym_EQ] = ACTIONS(575),
    [anon_sym_LT] = ACTIONS(575),
    [anon_sym_if] = ACTIONS(573),
    [anon_sym_unless] = ACTIONS(573),
    [anon_sym_while] = ACTIONS(573),
    [anon_sym_until] = ACTIONS(573),
    [anon_sym_rescue] = ACTIONS(573),
    [anon_sym_in] = ACTIONS(573),
    [anon_sym_do] = ACTIONS(573),
    [anon_sym_EQ_GT] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(573),
    [anon_sym_RBRACK] = ACTIONS(573),
    [anon_sym_COLON_COLON2] = ACTIONS(573),
    [anon_sym_AMP_DOT] = ACTIONS(573),
    [anon_sym_PLUS_EQ] = ACTIONS(573),
    [anon_sym_DASH_EQ] = ACTIONS(573),
    [anon_sym_STAR_EQ] = ACTIONS(573),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(573),
    [anon_sym_SLASH_EQ] = ACTIONS(573),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(573),
    [anon_sym_PIPE_EQ] = ACTIONS(573),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(573),
    [anon_sym_AMP_EQ] = ACTIONS(573),
    [anon_sym_PERCENT_EQ] = ACTIONS(573),
    [anon_sym_GT_GT_EQ] = ACTIONS(573),
    [anon_sym_LT_LT_EQ] = ACTIONS(573),
    [anon_sym_CARET_EQ] = ACTIONS(573),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_COLON2] = ACTIONS(575),
    [anon_sym_DOT_DOT] = ACTIONS(575),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(573),
    [anon_sym_and] = ACTIONS(573),
    [anon_sym_or] = ACTIONS(573),
    [anon_sym_PIPE_PIPE] = ACTIONS(575),
    [anon_sym_AMP_AMP] = ACTIONS(575),
    [anon_sym_LT_LT] = ACTIONS(575),
    [anon_sym_GT_GT] = ACTIONS(575),
    [anon_sym_EQ_EQ] = ACTIONS(575),
    [anon_sym_BANG_EQ] = ACTIONS(573),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(573),
    [anon_sym_LT_EQ_GT] = ACTIONS(573),
    [anon_sym_EQ_TILDE] = ACTIONS(573),
    [anon_sym_BANG_TILDE] = ACTIONS(573),
    [anon_sym_LT_EQ] = ACTIONS(575),
    [anon_sym_GT] = ACTIONS(575),
    [anon_sym_GT_EQ] = ACTIONS(573),
    [anon_sym_CARET] = ACTIONS(575),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(575),
    [anon_sym_PERCENT] = ACTIONS(575),
    [sym_comment] = ACTIONS(87),
  },
  [344] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(346),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(352),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(352),
    [sym__argument_list_with_trailing_comma] = STATE(1345),
    [sym__argument] = STATE(350),
    [sym_splat_argument] = STATE(350),
    [sym_hash_splat_argument] = STATE(350),
    [sym_block_argument] = STATE(350),
    [sym_assignment] = STATE(346),
    [sym_operator_assignment] = STATE(346),
    [sym_conditional] = STATE(346),
    [sym_range] = STATE(346),
    [sym_binary] = STATE(346),
    [sym_unary] = STATE(346),
    [sym_left_assignment_list] = STATE(351),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(352),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(352),
    [sym_false] = STATE(352),
    [sym_nil] = STATE(352),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(353),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(350),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(593),
    [sym__splat_star] = ACTIONS(595),
    [sym__unary_minus] = ACTIONS(597),
    [sym__identifier_hash_key] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(2353),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [345] = {
    [sym_lambda_parameters] = STATE(1348),
    [sym__simple_formal_parameter] = STATE(362),
    [sym_splat_parameter] = STATE(362),
    [sym_hash_splat_parameter] = STATE(362),
    [sym_block_parameter] = STATE(362),
    [sym_keyword_parameter] = STATE(362),
    [sym_optional_parameter] = STATE(362),
    [sym_do_block] = STATE(1349),
    [sym_block] = STATE(1349),
    [anon_sym_LBRACE] = ACTIONS(2355),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(2357),
    [sym_identifier] = ACTIONS(679),
    [sym_comment] = ACTIONS(87),
  },
  [346] = {
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(2359),
    [sym__binary_star] = ACTIONS(2361),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(2363),
    [anon_sym_STAR_STAR] = ACTIONS(2361),
    [anon_sym_AMP] = ACTIONS(2365),
    [anon_sym_LT] = ACTIONS(2367),
    [anon_sym_EQ_GT] = ACTIONS(2303),
    [anon_sym_RBRACK] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(2369),
    [anon_sym_DOT_DOT] = ACTIONS(2371),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2373),
    [anon_sym_and] = ACTIONS(2375),
    [anon_sym_or] = ACTIONS(2375),
    [anon_sym_PIPE_PIPE] = ACTIONS(2377),
    [anon_sym_AMP_AMP] = ACTIONS(2377),
    [anon_sym_LT_LT] = ACTIONS(2379),
    [anon_sym_GT_GT] = ACTIONS(2379),
    [anon_sym_EQ_EQ] = ACTIONS(2381),
    [anon_sym_BANG_EQ] = ACTIONS(2377),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2377),
    [anon_sym_LT_EQ_GT] = ACTIONS(2377),
    [anon_sym_EQ_TILDE] = ACTIONS(2377),
    [anon_sym_BANG_TILDE] = ACTIONS(2377),
    [anon_sym_LT_EQ] = ACTIONS(2367),
    [anon_sym_GT] = ACTIONS(2367),
    [anon_sym_GT_EQ] = ACTIONS(2383),
    [anon_sym_CARET] = ACTIONS(2385),
    [anon_sym_PLUS] = ACTIONS(2359),
    [anon_sym_SLASH] = ACTIONS(2361),
    [anon_sym_PERCENT] = ACTIONS(2361),
    [sym_comment] = ACTIONS(87),
  },
  [347] = {
    [sym__heredoc_body_start] = ACTIONS(731),
    [sym__binary_minus] = ACTIONS(731),
    [sym__binary_star] = ACTIONS(731),
    [anon_sym_LBRACE] = ACTIONS(731),
    [anon_sym_RBRACE] = ACTIONS(731),
    [anon_sym_RPAREN] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(2387),
    [anon_sym_COMMA] = ACTIONS(731),
    [anon_sym_PIPE] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(731),
    [anon_sym_STAR_STAR] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(735),
    [anon_sym_EQ] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(735),
    [anon_sym_if] = ACTIONS(731),
    [anon_sym_unless] = ACTIONS(731),
    [anon_sym_while] = ACTIONS(731),
    [anon_sym_until] = ACTIONS(731),
    [anon_sym_rescue] = ACTIONS(731),
    [anon_sym_in] = ACTIONS(731),
    [anon_sym_do] = ACTIONS(731),
    [anon_sym_EQ_GT] = ACTIONS(731),
    [anon_sym_LBRACK] = ACTIONS(2389),
    [anon_sym_RBRACK] = ACTIONS(731),
    [anon_sym_COLON_COLON2] = ACTIONS(2391),
    [anon_sym_AMP_DOT] = ACTIONS(2393),
    [anon_sym_QMARK] = ACTIONS(731),
    [anon_sym_COLON2] = ACTIONS(735),
    [anon_sym_DOT_DOT] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(731),
    [anon_sym_or] = ACTIONS(731),
    [anon_sym_PIPE_PIPE] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(731),
    [anon_sym_LT_LT] = ACTIONS(731),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_EQ_EQ] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(731),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(731),
    [anon_sym_LT_EQ_GT] = ACTIONS(731),
    [anon_sym_EQ_TILDE] = ACTIONS(731),
    [anon_sym_BANG_TILDE] = ACTIONS(731),
    [anon_sym_LT_EQ] = ACTIONS(735),
    [anon_sym_GT] = ACTIONS(735),
    [anon_sym_GT_EQ] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(731),
    [anon_sym_SLASH] = ACTIONS(731),
    [anon_sym_PERCENT] = ACTIONS(731),
    [sym_comment] = ACTIONS(87),
  },
  [348] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1377),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1384),
    [sym_scope_resolution] = STATE(1378),
    [sym_call] = STATE(1378),
    [sym_method_call] = STATE(1384),
    [sym_argument_list] = STATE(1379),
    [sym__argument_list_with_parens] = STATE(1380),
    [sym__argument] = STATE(1381),
    [sym_splat_argument] = STATE(1381),
    [sym_hash_splat_argument] = STATE(1381),
    [sym_block_argument] = STATE(1381),
    [sym_do_block] = STATE(1382),
    [sym_block] = STATE(1382),
    [sym_assignment] = STATE(1377),
    [sym_operator_assignment] = STATE(1377),
    [sym_conditional] = STATE(1377),
    [sym_range] = STATE(1377),
    [sym_binary] = STATE(1377),
    [sym_unary] = STATE(1377),
    [sym_left_assignment_list] = STATE(1383),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1384),
    [sym__variable] = STATE(1378),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1384),
    [sym_false] = STATE(1384),
    [sym_nil] = STATE(1384),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1385),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(1381),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(2395),
    [sym__splat_star] = ACTIONS(2397),
    [sym__unary_minus] = ACTIONS(2399),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(2401),
    [anon_sym_LBRACE] = ACTIONS(2403),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2405),
    [anon_sym_yield] = ACTIONS(2407),
    [anon_sym_break] = ACTIONS(2409),
    [anon_sym_next] = ACTIONS(2411),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(2413),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_RBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(2415),
    [anon_sym_not] = ACTIONS(2417),
    [anon_sym_BANG] = ACTIONS(2419),
    [anon_sym_TILDE] = ACTIONS(2421),
    [sym_constant] = ACTIONS(2423),
    [sym_identifier] = ACTIONS(2423),
    [sym_instance_variable] = ACTIONS(2425),
    [sym_class_variable] = ACTIONS(2425),
    [sym_global_variable] = ACTIONS(2425),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2427),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2427),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [349] = {
    [anon_sym_RBRACK] = ACTIONS(2429),
    [sym_comment] = ACTIONS(87),
  },
  [350] = {
    [sym_heredoc_body] = STATE(1388),
    [aux_sym_argument_list_repeat1] = STATE(1389),
    [sym__heredoc_body_start] = ACTIONS(151),
    [anon_sym_COMMA] = ACTIONS(2431),
    [anon_sym_RBRACK] = ACTIONS(2433),
    [sym_comment] = ACTIONS(87),
  },
  [351] = {
    [anon_sym_EQ] = ACTIONS(2435),
    [sym_comment] = ACTIONS(87),
  },
  [352] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(2437),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(2439),
    [anon_sym_DASH_EQ] = ACTIONS(2439),
    [anon_sym_STAR_EQ] = ACTIONS(2439),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2439),
    [anon_sym_SLASH_EQ] = ACTIONS(2439),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2439),
    [anon_sym_PIPE_EQ] = ACTIONS(2439),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2439),
    [anon_sym_AMP_EQ] = ACTIONS(2439),
    [anon_sym_PERCENT_EQ] = ACTIONS(2439),
    [anon_sym_GT_GT_EQ] = ACTIONS(2439),
    [anon_sym_LT_LT_EQ] = ACTIONS(2439),
    [anon_sym_CARET_EQ] = ACTIONS(2439),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [353] = {
    [sym_string] = STATE(1392),
    [aux_sym_chained_string_repeat1] = STATE(1392),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(2441),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [354] = {
    [sym__statements] = STATE(1395),
    [sym_begin_block] = STATE(489),
    [sym_end_block] = STATE(489),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_block_parameters] = STATE(1396),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(495),
    [aux_sym__statements_repeat1] = STATE(495),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(2443),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2445),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [355] = {
    [sym__formal_parameter] = STATE(1400),
    [sym__simple_formal_parameter] = STATE(1400),
    [sym_destructured_parameter] = STATE(1400),
    [sym_splat_parameter] = STATE(1400),
    [sym_hash_splat_parameter] = STATE(1400),
    [sym_block_parameter] = STATE(1400),
    [sym_keyword_parameter] = STATE(1400),
    [sym_optional_parameter] = STATE(1400),
    [anon_sym_LPAREN] = ACTIONS(2447),
    [anon_sym_RPAREN] = ACTIONS(2449),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [sym_identifier] = ACTIONS(2451),
    [sym_comment] = ACTIONS(87),
  },
  [356] = {
    [anon_sym_LBRACE] = ACTIONS(2453),
    [anon_sym_RPAREN] = ACTIONS(2453),
    [anon_sym_COMMA] = ACTIONS(2453),
    [anon_sym_PIPE] = ACTIONS(2453),
    [anon_sym_SEMI] = ACTIONS(2453),
    [anon_sym_do] = ACTIONS(2455),
    [sym_identifier] = ACTIONS(2457),
    [sym_comment] = ACTIONS(87),
  },
  [357] = {
    [anon_sym_LBRACE] = ACTIONS(2459),
    [anon_sym_RPAREN] = ACTIONS(2459),
    [anon_sym_COMMA] = ACTIONS(2459),
    [anon_sym_PIPE] = ACTIONS(2459),
    [anon_sym_SEMI] = ACTIONS(2459),
    [anon_sym_do] = ACTIONS(2461),
    [sym_identifier] = ACTIONS(2463),
    [sym_comment] = ACTIONS(87),
  },
  [358] = {
    [sym_lambda] = STATE(1403),
    [sym_identifier] = ACTIONS(2465),
    [sym_comment] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(347),
  },
  [359] = {
    [sym__statements] = STATE(1406),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_block_parameters] = STATE(1407),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_heredoc_body] = STATE(1408),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [sym__terminator] = STATE(1408),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__line_break] = ACTIONS(2467),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(2467),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(2471),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [360] = {
    [anon_sym_LBRACE] = ACTIONS(2473),
    [anon_sym_COMMA] = ACTIONS(2473),
    [anon_sym_COLON] = ACTIONS(2475),
    [anon_sym_EQ] = ACTIONS(2477),
    [anon_sym_do] = ACTIONS(2473),
    [sym_comment] = ACTIONS(87),
  },
  [361] = {
    [sym_do_block] = STATE(1411),
    [sym_block] = STATE(1411),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_do] = ACTIONS(2479),
    [sym_comment] = ACTIONS(87),
  },
  [362] = {
    [aux_sym_lambda_parameters_repeat1] = STATE(1413),
    [anon_sym_LBRACE] = ACTIONS(2481),
    [anon_sym_COMMA] = ACTIONS(2483),
    [anon_sym_do] = ACTIONS(2481),
    [sym_comment] = ACTIONS(87),
  },
  [363] = {
    [sym__line_break] = ACTIONS(2485),
    [sym__heredoc_body_start] = ACTIONS(2485),
    [sym__binary_minus] = ACTIONS(2485),
    [sym__binary_star] = ACTIONS(2485),
    [ts_builtin_sym_end] = ACTIONS(2485),
    [anon_sym___END__] = ACTIONS(2485),
    [anon_sym_LBRACE] = ACTIONS(2485),
    [anon_sym_RBRACE] = ACTIONS(2485),
    [anon_sym_RPAREN] = ACTIONS(2485),
    [anon_sym_DOT] = ACTIONS(2487),
    [anon_sym_COMMA] = ACTIONS(2485),
    [anon_sym_PIPE] = ACTIONS(2487),
    [anon_sym_SEMI] = ACTIONS(2485),
    [anon_sym_STAR_STAR] = ACTIONS(2485),
    [anon_sym_AMP] = ACTIONS(2487),
    [anon_sym_LT] = ACTIONS(2487),
    [anon_sym_end] = ACTIONS(2485),
    [anon_sym_if] = ACTIONS(2485),
    [anon_sym_unless] = ACTIONS(2485),
    [anon_sym_while] = ACTIONS(2485),
    [anon_sym_until] = ACTIONS(2485),
    [anon_sym_rescue] = ACTIONS(2485),
    [anon_sym_do] = ACTIONS(2485),
    [anon_sym_when] = ACTIONS(2485),
    [anon_sym_elsif] = ACTIONS(2485),
    [anon_sym_else] = ACTIONS(2485),
    [anon_sym_then] = ACTIONS(2485),
    [anon_sym_ensure] = ACTIONS(2485),
    [anon_sym_EQ_GT] = ACTIONS(2485),
    [anon_sym_LBRACK] = ACTIONS(2485),
    [anon_sym_COLON_COLON2] = ACTIONS(2485),
    [anon_sym_AMP_DOT] = ACTIONS(2485),
    [anon_sym_QMARK] = ACTIONS(2485),
    [anon_sym_DOT_DOT] = ACTIONS(2487),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2485),
    [anon_sym_and] = ACTIONS(2485),
    [anon_sym_or] = ACTIONS(2485),
    [anon_sym_PIPE_PIPE] = ACTIONS(2485),
    [anon_sym_AMP_AMP] = ACTIONS(2485),
    [anon_sym_LT_LT] = ACTIONS(2485),
    [anon_sym_GT_GT] = ACTIONS(2485),
    [anon_sym_EQ_EQ] = ACTIONS(2487),
    [anon_sym_BANG_EQ] = ACTIONS(2485),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2485),
    [anon_sym_LT_EQ_GT] = ACTIONS(2485),
    [anon_sym_EQ_TILDE] = ACTIONS(2485),
    [anon_sym_BANG_TILDE] = ACTIONS(2485),
    [anon_sym_LT_EQ] = ACTIONS(2487),
    [anon_sym_GT] = ACTIONS(2487),
    [anon_sym_GT_EQ] = ACTIONS(2485),
    [anon_sym_CARET] = ACTIONS(2485),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_SLASH] = ACTIONS(2485),
    [anon_sym_PERCENT] = ACTIONS(2485),
    [sym_comment] = ACTIONS(87),
  },
  [364] = {
    [sym__line_break] = ACTIONS(2489),
    [sym_comment] = ACTIONS(87),
  },
  [365] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1415),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(51),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(51),
    [sym_assignment] = STATE(1415),
    [sym_operator_assignment] = STATE(1415),
    [sym_conditional] = STATE(1415),
    [sym_range] = STATE(1415),
    [sym_binary] = STATE(1415),
    [sym_unary] = STATE(1415),
    [sym_left_assignment_list] = STATE(48),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(51),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(51),
    [sym_false] = STATE(51),
    [sym_nil] = STATE(51),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(52),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [366] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1416),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(51),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(51),
    [sym_assignment] = STATE(1416),
    [sym_operator_assignment] = STATE(1416),
    [sym_conditional] = STATE(1416),
    [sym_range] = STATE(1416),
    [sym_binary] = STATE(1416),
    [sym_unary] = STATE(1416),
    [sym_left_assignment_list] = STATE(48),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(51),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(51),
    [sym_false] = STATE(51),
    [sym_nil] = STATE(51),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(52),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [367] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1417),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(51),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(51),
    [sym_assignment] = STATE(1417),
    [sym_operator_assignment] = STATE(1417),
    [sym_conditional] = STATE(1417),
    [sym_range] = STATE(1417),
    [sym_binary] = STATE(1417),
    [sym_unary] = STATE(1417),
    [sym_left_assignment_list] = STATE(48),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(51),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(51),
    [sym_false] = STATE(51),
    [sym_nil] = STATE(51),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(52),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [368] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1418),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(51),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(51),
    [sym_assignment] = STATE(1418),
    [sym_operator_assignment] = STATE(1418),
    [sym_conditional] = STATE(1418),
    [sym_range] = STATE(1418),
    [sym_binary] = STATE(1418),
    [sym_unary] = STATE(1418),
    [sym_left_assignment_list] = STATE(48),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(51),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(51),
    [sym_false] = STATE(51),
    [sym_nil] = STATE(51),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(52),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [369] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1419),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(51),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(51),
    [sym_assignment] = STATE(1419),
    [sym_operator_assignment] = STATE(1419),
    [sym_conditional] = STATE(1419),
    [sym_range] = STATE(1419),
    [sym_binary] = STATE(1419),
    [sym_unary] = STATE(1419),
    [sym_left_assignment_list] = STATE(48),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(51),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(51),
    [sym_false] = STATE(51),
    [sym_nil] = STATE(51),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(52),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [370] = {
    [sym__simple_symbol] = ACTIONS(2491),
    [sym__string_start] = ACTIONS(2491),
    [sym__symbol_start] = ACTIONS(2491),
    [sym__subshell_start] = ACTIONS(2491),
    [sym__regex_start] = ACTIONS(2491),
    [sym__string_array_start] = ACTIONS(2491),
    [sym__symbol_array_start] = ACTIONS(2491),
    [sym_heredoc_beginning] = ACTIONS(2491),
    [sym__unary_minus] = ACTIONS(2491),
    [ts_builtin_sym_end] = ACTIONS(2491),
    [anon_sym___END__] = ACTIONS(2493),
    [anon_sym_BEGIN] = ACTIONS(2493),
    [anon_sym_LBRACE] = ACTIONS(2491),
    [anon_sym_RBRACE] = ACTIONS(2491),
    [anon_sym_END] = ACTIONS(2493),
    [anon_sym_def] = ACTIONS(2493),
    [anon_sym_LPAREN] = ACTIONS(2491),
    [anon_sym_RPAREN] = ACTIONS(2491),
    [anon_sym_COLON_COLON] = ACTIONS(2491),
    [anon_sym_SEMI] = ACTIONS(2491),
    [anon_sym_STAR] = ACTIONS(2491),
    [anon_sym_class] = ACTIONS(2493),
    [anon_sym_module] = ACTIONS(2493),
    [anon_sym_end] = ACTIONS(2493),
    [anon_sym_return] = ACTIONS(2493),
    [anon_sym_yield] = ACTIONS(2493),
    [anon_sym_break] = ACTIONS(2493),
    [anon_sym_next] = ACTIONS(2493),
    [sym_redo] = ACTIONS(2493),
    [sym_retry] = ACTIONS(2493),
    [anon_sym_if] = ACTIONS(2493),
    [anon_sym_unless] = ACTIONS(2493),
    [anon_sym_while] = ACTIONS(2493),
    [anon_sym_until] = ACTIONS(2493),
    [anon_sym_rescue] = ACTIONS(2493),
    [anon_sym_for] = ACTIONS(2493),
    [anon_sym_case] = ACTIONS(2493),
    [anon_sym_when] = ACTIONS(2493),
    [anon_sym_elsif] = ACTIONS(2493),
    [anon_sym_else] = ACTIONS(2493),
    [anon_sym_begin] = ACTIONS(2493),
    [anon_sym_ensure] = ACTIONS(2493),
    [anon_sym_PLUS] = ACTIONS(2493),
    [anon_sym_defined_QMARK] = ACTIONS(2491),
    [anon_sym_not] = ACTIONS(2493),
    [anon_sym_BANG] = ACTIONS(2491),
    [anon_sym_TILDE] = ACTIONS(2491),
    [sym_constant] = ACTIONS(2493),
    [sym_identifier] = ACTIONS(2493),
    [sym_instance_variable] = ACTIONS(2491),
    [sym_class_variable] = ACTIONS(2491),
    [sym_global_variable] = ACTIONS(2491),
    [anon_sym_undef] = ACTIONS(2493),
    [anon_sym_alias] = ACTIONS(2493),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2493),
    [sym_float] = ACTIONS(2493),
    [sym_complex] = ACTIONS(2491),
    [sym_super] = ACTIONS(2493),
    [anon_sym_true] = ACTIONS(2493),
    [anon_sym_TRUE] = ACTIONS(2493),
    [anon_sym_false] = ACTIONS(2493),
    [anon_sym_FALSE] = ACTIONS(2493),
    [sym_self] = ACTIONS(2493),
    [anon_sym_nil] = ACTIONS(2493),
    [anon_sym_NIL] = ACTIONS(2493),
    [sym_character] = ACTIONS(2491),
    [anon_sym_LBRACK2] = ACTIONS(2491),
    [anon_sym_DASH_GT] = ACTIONS(2491),
  },
  [371] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1420),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(51),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(51),
    [sym_assignment] = STATE(1420),
    [sym_operator_assignment] = STATE(1420),
    [sym_conditional] = STATE(1420),
    [sym_range] = STATE(1420),
    [sym_binary] = STATE(1420),
    [sym_unary] = STATE(1420),
    [sym_left_assignment_list] = STATE(48),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(51),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(51),
    [sym_false] = STATE(51),
    [sym_nil] = STATE(51),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(52),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [372] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1421),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(51),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(51),
    [sym_assignment] = STATE(1421),
    [sym_operator_assignment] = STATE(1421),
    [sym_conditional] = STATE(1421),
    [sym_range] = STATE(1421),
    [sym_binary] = STATE(1421),
    [sym_unary] = STATE(1421),
    [sym_left_assignment_list] = STATE(48),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(51),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(51),
    [sym_false] = STATE(51),
    [sym_nil] = STATE(51),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(52),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [373] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1422),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(51),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(51),
    [sym_assignment] = STATE(1422),
    [sym_operator_assignment] = STATE(1422),
    [sym_conditional] = STATE(1422),
    [sym_range] = STATE(1422),
    [sym_binary] = STATE(1422),
    [sym_unary] = STATE(1422),
    [sym_left_assignment_list] = STATE(48),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(51),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(51),
    [sym_false] = STATE(51),
    [sym_nil] = STATE(51),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(52),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [374] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1423),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(51),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(51),
    [sym_assignment] = STATE(1423),
    [sym_operator_assignment] = STATE(1423),
    [sym_conditional] = STATE(1423),
    [sym_range] = STATE(1423),
    [sym_binary] = STATE(1423),
    [sym_unary] = STATE(1423),
    [sym_left_assignment_list] = STATE(48),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(51),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(51),
    [sym_false] = STATE(51),
    [sym_nil] = STATE(51),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(52),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [375] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1424),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(51),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(51),
    [sym_assignment] = STATE(1424),
    [sym_operator_assignment] = STATE(1424),
    [sym_conditional] = STATE(1424),
    [sym_range] = STATE(1424),
    [sym_binary] = STATE(1424),
    [sym_unary] = STATE(1424),
    [sym_left_assignment_list] = STATE(48),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(51),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(51),
    [sym_false] = STATE(51),
    [sym_nil] = STATE(51),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(52),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [376] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(1433),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(1433),
    [sym_operator_assignment] = STATE(1433),
    [sym_conditional] = STATE(1433),
    [sym_range] = STATE(1433),
    [sym_binary] = STATE(1433),
    [sym_unary] = STATE(1433),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [377] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1438),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(51),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(51),
    [sym_assignment] = STATE(1438),
    [sym_operator_assignment] = STATE(1438),
    [sym_conditional] = STATE(1438),
    [sym_range] = STATE(1438),
    [sym_binary] = STATE(1438),
    [sym_unary] = STATE(1438),
    [sym_left_assignment_list] = STATE(48),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(51),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(51),
    [sym_false] = STATE(51),
    [sym_nil] = STATE(51),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(52),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [378] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1439),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(51),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(51),
    [sym_assignment] = STATE(1439),
    [sym_operator_assignment] = STATE(1439),
    [sym_conditional] = STATE(1439),
    [sym_range] = STATE(1439),
    [sym_binary] = STATE(1439),
    [sym_unary] = STATE(1439),
    [sym_left_assignment_list] = STATE(48),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(51),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(51),
    [sym_false] = STATE(51),
    [sym_nil] = STATE(51),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(52),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [379] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1440),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(51),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(51),
    [sym_assignment] = STATE(1440),
    [sym_operator_assignment] = STATE(1440),
    [sym_conditional] = STATE(1440),
    [sym_range] = STATE(1440),
    [sym_binary] = STATE(1440),
    [sym_unary] = STATE(1440),
    [sym_left_assignment_list] = STATE(48),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(51),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(51),
    [sym_false] = STATE(51),
    [sym_nil] = STATE(51),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(52),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [380] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1441),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(51),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(51),
    [sym_assignment] = STATE(1441),
    [sym_operator_assignment] = STATE(1441),
    [sym_conditional] = STATE(1441),
    [sym_range] = STATE(1441),
    [sym_binary] = STATE(1441),
    [sym_unary] = STATE(1441),
    [sym_left_assignment_list] = STATE(48),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(51),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(51),
    [sym_false] = STATE(51),
    [sym_nil] = STATE(51),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(52),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [381] = {
    [sym_argument_list_with_parens] = STATE(1445),
    [sym__argument_list_with_parens] = STATE(1446),
    [sym_operator] = STATE(1445),
    [sym_heredoc_body] = STATE(1447),
    [aux_sym_call_repeat1] = STATE(1447),
    [sym__heredoc_body_start] = ACTIONS(2519),
    [anon_sym_PIPE] = ACTIONS(2521),
    [anon_sym_STAR] = ACTIONS(2523),
    [anon_sym_STAR_STAR] = ACTIONS(2521),
    [anon_sym_AMP] = ACTIONS(2521),
    [anon_sym_LT] = ACTIONS(2523),
    [anon_sym_LPAREN2] = ACTIONS(2525),
    [anon_sym_DOT_DOT] = ACTIONS(2521),
    [anon_sym_LT_LT] = ACTIONS(2521),
    [anon_sym_GT_GT] = ACTIONS(2521),
    [anon_sym_EQ_EQ] = ACTIONS(2523),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2521),
    [anon_sym_LT_EQ_GT] = ACTIONS(2521),
    [anon_sym_EQ_TILDE] = ACTIONS(2521),
    [anon_sym_BANG_TILDE] = ACTIONS(2521),
    [anon_sym_LT_EQ] = ACTIONS(2523),
    [anon_sym_GT] = ACTIONS(2523),
    [anon_sym_GT_EQ] = ACTIONS(2521),
    [anon_sym_CARET] = ACTIONS(2521),
    [anon_sym_PLUS] = ACTIONS(2523),
    [anon_sym_SLASH] = ACTIONS(2521),
    [anon_sym_PERCENT] = ACTIONS(2521),
    [anon_sym_BANG] = ACTIONS(2523),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2527),
    [sym_identifier] = ACTIONS(2527),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_PLUS_AT] = ACTIONS(2521),
    [anon_sym_DASH_AT] = ACTIONS(2521),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2523),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(2521),
    [anon_sym_BQUOTE] = ACTIONS(2521),
    [sym_comment] = ACTIONS(87),
  },
  [382] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(346),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(352),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(352),
    [sym__argument_list_with_trailing_comma] = STATE(1449),
    [sym__argument] = STATE(350),
    [sym_splat_argument] = STATE(350),
    [sym_hash_splat_argument] = STATE(350),
    [sym_block_argument] = STATE(350),
    [sym_assignment] = STATE(346),
    [sym_operator_assignment] = STATE(346),
    [sym_conditional] = STATE(346),
    [sym_range] = STATE(346),
    [sym_binary] = STATE(346),
    [sym_unary] = STATE(346),
    [sym_left_assignment_list] = STATE(351),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(352),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(352),
    [sym_false] = STATE(352),
    [sym_nil] = STATE(352),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(353),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(350),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(593),
    [sym__splat_star] = ACTIONS(595),
    [sym__unary_minus] = ACTIONS(597),
    [sym__identifier_hash_key] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(2529),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [383] = {
    [sym_constant] = ACTIONS(2531),
    [sym_identifier] = ACTIONS(2531),
    [sym_comment] = ACTIONS(87),
  },
  [384] = {
    [sym__line_break] = ACTIONS(101),
    [sym__heredoc_body_start] = ACTIONS(101),
    [sym__binary_minus] = ACTIONS(101),
    [sym__binary_star] = ACTIONS(101),
    [ts_builtin_sym_end] = ACTIONS(101),
    [anon_sym___END__] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_RBRACE] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(103),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_PIPE] = ACTIONS(103),
    [anon_sym_SEMI] = ACTIONS(101),
    [anon_sym_STAR_STAR] = ACTIONS(103),
    [anon_sym_AMP] = ACTIONS(103),
    [anon_sym_EQ] = ACTIONS(103),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_unless] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_until] = ACTIONS(101),
    [anon_sym_rescue] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(101),
    [anon_sym_when] = ACTIONS(101),
    [anon_sym_elsif] = ACTIONS(101),
    [anon_sym_else] = ACTIONS(101),
    [anon_sym_then] = ACTIONS(101),
    [anon_sym_ensure] = ACTIONS(101),
    [anon_sym_EQ_GT] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_COLON_COLON2] = ACTIONS(101),
    [anon_sym_AMP_DOT] = ACTIONS(101),
    [anon_sym_PLUS_EQ] = ACTIONS(101),
    [anon_sym_DASH_EQ] = ACTIONS(101),
    [anon_sym_STAR_EQ] = ACTIONS(101),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(101),
    [anon_sym_SLASH_EQ] = ACTIONS(101),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(101),
    [anon_sym_PIPE_EQ] = ACTIONS(101),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(101),
    [anon_sym_AMP_EQ] = ACTIONS(101),
    [anon_sym_PERCENT_EQ] = ACTIONS(101),
    [anon_sym_GT_GT_EQ] = ACTIONS(101),
    [anon_sym_LT_LT_EQ] = ACTIONS(101),
    [anon_sym_CARET_EQ] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_DOT_DOT] = ACTIONS(103),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_and] = ACTIONS(101),
    [anon_sym_or] = ACTIONS(101),
    [anon_sym_PIPE_PIPE] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_LT_LT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_EQ_EQ] = ACTIONS(103),
    [anon_sym_BANG_EQ] = ACTIONS(101),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(101),
    [anon_sym_LT_EQ_GT] = ACTIONS(101),
    [anon_sym_EQ_TILDE] = ACTIONS(101),
    [anon_sym_BANG_TILDE] = ACTIONS(101),
    [anon_sym_LT_EQ] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_EQ] = ACTIONS(101),
    [anon_sym_CARET] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [sym_comment] = ACTIONS(87),
  },
  [385] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(1452),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(2533),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [386] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(1454),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(2535),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [387] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(1456),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(2537),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [388] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(1458),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(2539),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [389] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1461),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(2541),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(2543),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [390] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1464),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(2545),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(2547),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [391] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(1494),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(1498),
    [sym_scope_resolution] = STATE(1496),
    [sym_call] = STATE(1496),
    [sym_method_call] = STATE(1498),
    [sym_assignment] = STATE(1494),
    [sym_operator_assignment] = STATE(1494),
    [sym_conditional] = STATE(1494),
    [sym_range] = STATE(1494),
    [sym_binary] = STATE(1494),
    [sym_unary] = STATE(1494),
    [sym_left_assignment_list] = STATE(1497),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1498),
    [sym__variable] = STATE(1496),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(1498),
    [sym_false] = STATE(1498),
    [sym_nil] = STATE(1498),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(1499),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(2565),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(2577),
    [anon_sym_yield] = ACTIONS(2579),
    [anon_sym_break] = ACTIONS(2581),
    [anon_sym_next] = ACTIONS(2583),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(2601),
    [anon_sym_defined_QMARK] = ACTIONS(2603),
    [anon_sym_not] = ACTIONS(2605),
    [anon_sym_BANG] = ACTIONS(2607),
    [anon_sym_TILDE] = ACTIONS(2607),
    [sym_constant] = ACTIONS(2609),
    [sym_identifier] = ACTIONS(2609),
    [sym_instance_variable] = ACTIONS(2611),
    [sym_class_variable] = ACTIONS(2611),
    [sym_global_variable] = ACTIONS(2611),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(2609),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2609),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [392] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(1500),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(1498),
    [sym_scope_resolution] = STATE(1496),
    [sym_call] = STATE(1496),
    [sym_method_call] = STATE(1498),
    [sym_assignment] = STATE(1500),
    [sym_operator_assignment] = STATE(1500),
    [sym_conditional] = STATE(1500),
    [sym_range] = STATE(1500),
    [sym_binary] = STATE(1500),
    [sym_unary] = STATE(1500),
    [sym_left_assignment_list] = STATE(1497),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1498),
    [sym__variable] = STATE(1496),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(1498),
    [sym_false] = STATE(1498),
    [sym_nil] = STATE(1498),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(1499),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(2565),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(2577),
    [anon_sym_yield] = ACTIONS(2579),
    [anon_sym_break] = ACTIONS(2581),
    [anon_sym_next] = ACTIONS(2583),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(2601),
    [anon_sym_defined_QMARK] = ACTIONS(2603),
    [anon_sym_not] = ACTIONS(2605),
    [anon_sym_BANG] = ACTIONS(2607),
    [anon_sym_TILDE] = ACTIONS(2607),
    [sym_constant] = ACTIONS(2609),
    [sym_identifier] = ACTIONS(2609),
    [sym_instance_variable] = ACTIONS(2611),
    [sym_class_variable] = ACTIONS(2611),
    [sym_global_variable] = ACTIONS(2611),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(2609),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2609),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [393] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(1502),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(428),
    [sym_scope_resolution] = STATE(422),
    [sym_call] = STATE(422),
    [sym_method_call] = STATE(428),
    [sym_assignment] = STATE(1502),
    [sym_operator_assignment] = STATE(1502),
    [sym_conditional] = STATE(1502),
    [sym_range] = STATE(1502),
    [sym_binary] = STATE(1502),
    [sym_unary] = STATE(1502),
    [sym_left_assignment_list] = STATE(427),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(428),
    [sym__variable] = STATE(422),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(428),
    [sym_false] = STATE(428),
    [sym_nil] = STATE(428),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(1503),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(781),
    [anon_sym_yield] = ACTIONS(783),
    [anon_sym_break] = ACTIONS(785),
    [anon_sym_next] = ACTIONS(787),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(2623),
    [anon_sym_defined_QMARK] = ACTIONS(801),
    [anon_sym_not] = ACTIONS(803),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_TILDE] = ACTIONS(807),
    [sym_constant] = ACTIONS(815),
    [sym_identifier] = ACTIONS(815),
    [sym_instance_variable] = ACTIONS(811),
    [sym_class_variable] = ACTIONS(811),
    [sym_global_variable] = ACTIONS(811),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(815),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(815),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [394] = {
    [anon_sym_COLON] = ACTIONS(2627),
    [sym_comment] = ACTIONS(87),
  },
  [395] = {
    [sym__statements] = STATE(1514),
    [sym_begin_block] = STATE(489),
    [sym_end_block] = STATE(489),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_block_parameters] = STATE(1515),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1516),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1519),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1519),
    [sym_hash_splat_argument] = STATE(116),
    [sym_assignment] = STATE(1516),
    [sym_operator_assignment] = STATE(1516),
    [sym_conditional] = STATE(1516),
    [sym_range] = STATE(1516),
    [sym_binary] = STATE(1516),
    [sym_unary] = STATE(1516),
    [sym_left_assignment_list] = STATE(1518),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1519),
    [sym__variable] = STATE(1517),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1519),
    [sym_false] = STATE(1519),
    [sym_nil] = STATE(1519),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1520),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(1521),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym__hash_items] = STATE(1522),
    [sym_pair] = STATE(122),
    [sym_lambda] = STATE(214),
    [sym_empty_statement] = STATE(495),
    [aux_sym__statements_repeat1] = STATE(495),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2629),
    [sym__identifier_hash_key] = ACTIONS(157),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(2631),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_PIPE] = ACTIONS(2445),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2633),
    [anon_sym_yield] = ACTIONS(2635),
    [anon_sym_break] = ACTIONS(2637),
    [anon_sym_next] = ACTIONS(2639),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2641),
    [anon_sym_defined_QMARK] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2647),
    [anon_sym_TILDE] = ACTIONS(2647),
    [sym_constant] = ACTIONS(2649),
    [sym_identifier] = ACTIONS(2649),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [396] = {
    [sym__method_rest] = STATE(1524),
    [sym__variable] = STATE(1525),
    [sym_operator] = STATE(1526),
    [sym__method_name] = STATE(1526),
    [sym_setter] = STATE(1526),
    [sym_symbol] = STATE(1526),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_LPAREN] = ACTIONS(2655),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(239),
    [sym_identifier] = ACTIONS(241),
    [sym_instance_variable] = ACTIONS(239),
    [sym_class_variable] = ACTIONS(239),
    [sym_global_variable] = ACTIONS(239),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
    [sym_super] = ACTIONS(2657),
    [sym_self] = ACTIONS(2657),
  },
  [397] = {
    [sym__statements] = STATE(1528),
    [sym_begin_block] = STATE(144),
    [sym_end_block] = STATE(144),
    [sym__statement] = STATE(144),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(144),
    [sym_unless_modifier] = STATE(144),
    [sym_while_modifier] = STATE(144),
    [sym_until_modifier] = STATE(144),
    [sym_rescue_modifier] = STATE(144),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(145),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(150),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(150),
    [sym_assignment] = STATE(145),
    [sym_operator_assignment] = STATE(145),
    [sym_conditional] = STATE(145),
    [sym_range] = STATE(145),
    [sym_binary] = STATE(145),
    [sym_unary] = STATE(145),
    [sym_left_assignment_list] = STATE(147),
    [sym__mlhs] = STATE(148),
    [sym_destructured_left_assignment] = STATE(149),
    [sym_rest_assignment] = STATE(149),
    [sym__lhs] = STATE(150),
    [sym__variable] = STATE(146),
    [sym_undef] = STATE(144),
    [sym_alias] = STATE(144),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(150),
    [sym_false] = STATE(150),
    [sym_nil] = STATE(150),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(151),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(152),
    [aux_sym__statements_repeat1] = STATE(152),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_RPAREN] = ACTIONS(2659),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(249),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [anon_sym_undef] = ACTIONS(271),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [398] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(1529),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(1498),
    [sym_scope_resolution] = STATE(1496),
    [sym_call] = STATE(1496),
    [sym_method_call] = STATE(1498),
    [sym_assignment] = STATE(1529),
    [sym_operator_assignment] = STATE(1529),
    [sym_conditional] = STATE(1529),
    [sym_range] = STATE(1529),
    [sym_binary] = STATE(1529),
    [sym_unary] = STATE(1529),
    [sym_left_assignment_list] = STATE(1497),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1498),
    [sym__variable] = STATE(1496),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(1498),
    [sym_false] = STATE(1498),
    [sym_nil] = STATE(1498),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(1499),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(2565),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(2577),
    [anon_sym_yield] = ACTIONS(2579),
    [anon_sym_break] = ACTIONS(2581),
    [anon_sym_next] = ACTIONS(2583),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(2601),
    [anon_sym_defined_QMARK] = ACTIONS(2603),
    [anon_sym_not] = ACTIONS(2605),
    [anon_sym_BANG] = ACTIONS(2607),
    [anon_sym_TILDE] = ACTIONS(2607),
    [sym_constant] = ACTIONS(2609),
    [sym_identifier] = ACTIONS(2609),
    [sym_instance_variable] = ACTIONS(2611),
    [sym_class_variable] = ACTIONS(2611),
    [sym_global_variable] = ACTIONS(2611),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(2609),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2609),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [399] = {
    [sym_method] = STATE(191),
    [sym_singleton_method] = STATE(191),
    [sym_class] = STATE(191),
    [sym_singleton_class] = STATE(191),
    [sym_module] = STATE(191),
    [sym_return] = STATE(191),
    [sym_yield] = STATE(191),
    [sym_break] = STATE(191),
    [sym_next] = STATE(191),
    [sym_while] = STATE(191),
    [sym_until] = STATE(191),
    [sym_for] = STATE(191),
    [sym_case] = STATE(191),
    [sym_if] = STATE(191),
    [sym_unless] = STATE(191),
    [sym_begin] = STATE(191),
    [sym__primary] = STATE(191),
    [sym_parenthesized_statements] = STATE(191),
    [sym_element_reference] = STATE(191),
    [sym_scope_resolution] = STATE(1532),
    [sym_call] = STATE(193),
    [sym_method_call] = STATE(191),
    [sym__lhs] = STATE(191),
    [sym__variable] = STATE(193),
    [sym_rational] = STATE(191),
    [sym_true] = STATE(191),
    [sym_false] = STATE(191),
    [sym_nil] = STATE(191),
    [sym_chained_string] = STATE(191),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(191),
    [sym_string_array] = STATE(191),
    [sym_symbol_array] = STATE(191),
    [sym_symbol] = STATE(191),
    [sym_regex] = STATE(191),
    [sym_array] = STATE(191),
    [sym_hash] = STATE(191),
    [sym_lambda] = STATE(191),
    [sym__simple_symbol] = ACTIONS(279),
    [sym__string_start] = ACTIONS(281),
    [sym__symbol_start] = ACTIONS(283),
    [sym__subshell_start] = ACTIONS(285),
    [sym__regex_start] = ACTIONS(287),
    [sym__string_array_start] = ACTIONS(289),
    [sym__symbol_array_start] = ACTIONS(291),
    [sym_heredoc_beginning] = ACTIONS(349),
    [sym__singleton_class_left_angle_left_langle] = ACTIONS(2661),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_def] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(299),
    [anon_sym_COLON_COLON] = ACTIONS(353),
    [anon_sym_class] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(307),
    [anon_sym_return] = ACTIONS(309),
    [anon_sym_yield] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_next] = ACTIONS(315),
    [sym_redo] = ACTIONS(355),
    [sym_retry] = ACTIONS(355),
    [anon_sym_if] = ACTIONS(319),
    [anon_sym_unless] = ACTIONS(321),
    [anon_sym_while] = ACTIONS(323),
    [anon_sym_until] = ACTIONS(325),
    [anon_sym_for] = ACTIONS(327),
    [anon_sym_case] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(331),
    [sym_constant] = ACTIONS(2663),
    [sym_identifier] = ACTIONS(359),
    [sym_instance_variable] = ACTIONS(361),
    [sym_class_variable] = ACTIONS(361),
    [sym_global_variable] = ACTIONS(361),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(355),
    [sym_complex] = ACTIONS(349),
    [sym_super] = ACTIONS(359),
    [anon_sym_true] = ACTIONS(339),
    [anon_sym_TRUE] = ACTIONS(339),
    [anon_sym_false] = ACTIONS(341),
    [anon_sym_FALSE] = ACTIONS(341),
    [sym_self] = ACTIONS(359),
    [anon_sym_nil] = ACTIONS(343),
    [anon_sym_NIL] = ACTIONS(343),
    [sym_character] = ACTIONS(349),
    [anon_sym_LBRACK2] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(347),
  },
  [400] = {
    [sym_method] = STATE(191),
    [sym_singleton_method] = STATE(191),
    [sym_class] = STATE(191),
    [sym_singleton_class] = STATE(191),
    [sym_module] = STATE(191),
    [sym_return] = STATE(191),
    [sym_yield] = STATE(191),
    [sym_break] = STATE(191),
    [sym_next] = STATE(191),
    [sym_while] = STATE(191),
    [sym_until] = STATE(191),
    [sym_for] = STATE(191),
    [sym_case] = STATE(191),
    [sym_if] = STATE(191),
    [sym_unless] = STATE(191),
    [sym_begin] = STATE(191),
    [sym__primary] = STATE(191),
    [sym_parenthesized_statements] = STATE(191),
    [sym_element_reference] = STATE(191),
    [sym_scope_resolution] = STATE(1534),
    [sym_call] = STATE(193),
    [sym_method_call] = STATE(191),
    [sym__lhs] = STATE(191),
    [sym__variable] = STATE(193),
    [sym_rational] = STATE(191),
    [sym_true] = STATE(191),
    [sym_false] = STATE(191),
    [sym_nil] = STATE(191),
    [sym_chained_string] = STATE(191),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(191),
    [sym_string_array] = STATE(191),
    [sym_symbol_array] = STATE(191),
    [sym_symbol] = STATE(191),
    [sym_regex] = STATE(191),
    [sym_array] = STATE(191),
    [sym_hash] = STATE(191),
    [sym_lambda] = STATE(191),
    [sym__simple_symbol] = ACTIONS(279),
    [sym__string_start] = ACTIONS(281),
    [sym__symbol_start] = ACTIONS(283),
    [sym__subshell_start] = ACTIONS(285),
    [sym__regex_start] = ACTIONS(287),
    [sym__string_array_start] = ACTIONS(289),
    [sym__symbol_array_start] = ACTIONS(291),
    [sym_heredoc_beginning] = ACTIONS(349),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_def] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(299),
    [anon_sym_COLON_COLON] = ACTIONS(353),
    [anon_sym_class] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(307),
    [anon_sym_return] = ACTIONS(309),
    [anon_sym_yield] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_next] = ACTIONS(315),
    [sym_redo] = ACTIONS(355),
    [sym_retry] = ACTIONS(355),
    [anon_sym_if] = ACTIONS(319),
    [anon_sym_unless] = ACTIONS(321),
    [anon_sym_while] = ACTIONS(323),
    [anon_sym_until] = ACTIONS(325),
    [anon_sym_for] = ACTIONS(327),
    [anon_sym_case] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(331),
    [sym_constant] = ACTIONS(2665),
    [sym_identifier] = ACTIONS(359),
    [sym_instance_variable] = ACTIONS(361),
    [sym_class_variable] = ACTIONS(361),
    [sym_global_variable] = ACTIONS(361),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(355),
    [sym_complex] = ACTIONS(349),
    [sym_super] = ACTIONS(359),
    [anon_sym_true] = ACTIONS(339),
    [anon_sym_TRUE] = ACTIONS(339),
    [anon_sym_false] = ACTIONS(341),
    [anon_sym_FALSE] = ACTIONS(341),
    [sym_self] = ACTIONS(359),
    [anon_sym_nil] = ACTIONS(343),
    [anon_sym_NIL] = ACTIONS(343),
    [sym_character] = ACTIONS(349),
    [anon_sym_LBRACK2] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(347),
  },
  [401] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(937),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(428),
    [sym_scope_resolution] = STATE(422),
    [sym_call] = STATE(422),
    [sym_method_call] = STATE(428),
    [sym_argument_list] = STATE(1535),
    [sym__argument_list_with_parens] = STATE(939),
    [sym__argument] = STATE(940),
    [sym_splat_argument] = STATE(940),
    [sym_hash_splat_argument] = STATE(940),
    [sym_block_argument] = STATE(940),
    [sym_assignment] = STATE(937),
    [sym_operator_assignment] = STATE(937),
    [sym_conditional] = STATE(937),
    [sym_range] = STATE(937),
    [sym_binary] = STATE(937),
    [sym_unary] = STATE(937),
    [sym_left_assignment_list] = STATE(427),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(428),
    [sym__variable] = STATE(422),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(428),
    [sym_false] = STATE(428),
    [sym_nil] = STATE(428),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(942),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(940),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(1663),
    [sym__splat_star] = ACTIONS(1665),
    [sym__unary_minus] = ACTIONS(765),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(1667),
    [ts_builtin_sym_end] = ACTIONS(365),
    [anon_sym___END__] = ACTIONS(377),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(781),
    [anon_sym_yield] = ACTIONS(783),
    [anon_sym_break] = ACTIONS(785),
    [anon_sym_next] = ACTIONS(787),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(365),
    [anon_sym_DASH_EQ] = ACTIONS(365),
    [anon_sym_STAR_EQ] = ACTIONS(365),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(365),
    [anon_sym_SLASH_EQ] = ACTIONS(365),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(365),
    [anon_sym_PIPE_EQ] = ACTIONS(365),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(365),
    [anon_sym_AMP_EQ] = ACTIONS(365),
    [anon_sym_PERCENT_EQ] = ACTIONS(365),
    [anon_sym_GT_GT_EQ] = ACTIONS(365),
    [anon_sym_LT_LT_EQ] = ACTIONS(365),
    [anon_sym_CARET_EQ] = ACTIONS(365),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_PERCENT] = ACTIONS(377),
    [anon_sym_defined_QMARK] = ACTIONS(801),
    [anon_sym_not] = ACTIONS(803),
    [anon_sym_BANG] = ACTIONS(805),
    [anon_sym_TILDE] = ACTIONS(807),
    [sym_constant] = ACTIONS(1675),
    [sym_identifier] = ACTIONS(1675),
    [sym_instance_variable] = ACTIONS(811),
    [sym_class_variable] = ACTIONS(811),
    [sym_global_variable] = ACTIONS(811),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(815),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(815),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [402] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(937),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(428),
    [sym_scope_resolution] = STATE(422),
    [sym_call] = STATE(422),
    [sym_method_call] = STATE(428),
    [sym_argument_list] = STATE(1536),
    [sym__argument_list_with_parens] = STATE(939),
    [sym__argument] = STATE(940),
    [sym_splat_argument] = STATE(940),
    [sym_hash_splat_argument] = STATE(940),
    [sym_block_argument] = STATE(940),
    [sym_assignment] = STATE(937),
    [sym_operator_assignment] = STATE(937),
    [sym_conditional] = STATE(937),
    [sym_range] = STATE(937),
    [sym_binary] = STATE(937),
    [sym_unary] = STATE(937),
    [sym_left_assignment_list] = STATE(427),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(428),
    [sym__variable] = STATE(422),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(428),
    [sym_false] = STATE(428),
    [sym_nil] = STATE(428),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(942),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(940),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(1663),
    [sym__splat_star] = ACTIONS(1665),
    [sym__unary_minus] = ACTIONS(765),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(1667),
    [ts_builtin_sym_end] = ACTIONS(417),
    [anon_sym___END__] = ACTIONS(419),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_EQ] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(781),
    [anon_sym_yield] = ACTIONS(783),
    [anon_sym_break] = ACTIONS(785),
    [anon_sym_next] = ACTIONS(787),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(417),
    [anon_sym_DASH_EQ] = ACTIONS(417),
    [anon_sym_STAR_EQ] = ACTIONS(417),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(417),
    [anon_sym_SLASH_EQ] = ACTIONS(417),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(417),
    [anon_sym_PIPE_EQ] = ACTIONS(417),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(417),
    [anon_sym_AMP_EQ] = ACTIONS(417),
    [anon_sym_PERCENT_EQ] = ACTIONS(417),
    [anon_sym_GT_GT_EQ] = ACTIONS(417),
    [anon_sym_LT_LT_EQ] = ACTIONS(417),
    [anon_sym_CARET_EQ] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(801),
    [anon_sym_not] = ACTIONS(803),
    [anon_sym_BANG] = ACTIONS(805),
    [anon_sym_TILDE] = ACTIONS(807),
    [sym_constant] = ACTIONS(1675),
    [sym_identifier] = ACTIONS(1675),
    [sym_instance_variable] = ACTIONS(811),
    [sym_class_variable] = ACTIONS(811),
    [sym_global_variable] = ACTIONS(811),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(815),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(815),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [403] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(937),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(428),
    [sym_scope_resolution] = STATE(422),
    [sym_call] = STATE(422),
    [sym_method_call] = STATE(428),
    [sym_argument_list] = STATE(1537),
    [sym__argument_list_with_parens] = STATE(939),
    [sym__argument] = STATE(940),
    [sym_splat_argument] = STATE(940),
    [sym_hash_splat_argument] = STATE(940),
    [sym_block_argument] = STATE(940),
    [sym_assignment] = STATE(937),
    [sym_operator_assignment] = STATE(937),
    [sym_conditional] = STATE(937),
    [sym_range] = STATE(937),
    [sym_binary] = STATE(937),
    [sym_unary] = STATE(937),
    [sym_left_assignment_list] = STATE(427),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(428),
    [sym__variable] = STATE(422),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(428),
    [sym_false] = STATE(428),
    [sym_nil] = STATE(428),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(942),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(940),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(1663),
    [sym__splat_star] = ACTIONS(1665),
    [sym__unary_minus] = ACTIONS(765),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(1667),
    [ts_builtin_sym_end] = ACTIONS(421),
    [anon_sym___END__] = ACTIONS(423),
    [anon_sym_LBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_EQ] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(781),
    [anon_sym_yield] = ACTIONS(783),
    [anon_sym_break] = ACTIONS(785),
    [anon_sym_next] = ACTIONS(787),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(421),
    [anon_sym_DASH_EQ] = ACTIONS(421),
    [anon_sym_STAR_EQ] = ACTIONS(421),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(421),
    [anon_sym_SLASH_EQ] = ACTIONS(421),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(421),
    [anon_sym_PIPE_EQ] = ACTIONS(421),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(421),
    [anon_sym_AMP_EQ] = ACTIONS(421),
    [anon_sym_PERCENT_EQ] = ACTIONS(421),
    [anon_sym_GT_GT_EQ] = ACTIONS(421),
    [anon_sym_LT_LT_EQ] = ACTIONS(421),
    [anon_sym_CARET_EQ] = ACTIONS(421),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(801),
    [anon_sym_not] = ACTIONS(803),
    [anon_sym_BANG] = ACTIONS(805),
    [anon_sym_TILDE] = ACTIONS(807),
    [sym_constant] = ACTIONS(1675),
    [sym_identifier] = ACTIONS(1675),
    [sym_instance_variable] = ACTIONS(811),
    [sym_class_variable] = ACTIONS(811),
    [sym_global_variable] = ACTIONS(811),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(815),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(815),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [404] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(937),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(428),
    [sym_scope_resolution] = STATE(422),
    [sym_call] = STATE(422),
    [sym_method_call] = STATE(428),
    [sym_argument_list] = STATE(1538),
    [sym__argument_list_with_parens] = STATE(939),
    [sym__argument] = STATE(940),
    [sym_splat_argument] = STATE(940),
    [sym_hash_splat_argument] = STATE(940),
    [sym_block_argument] = STATE(940),
    [sym_assignment] = STATE(937),
    [sym_operator_assignment] = STATE(937),
    [sym_conditional] = STATE(937),
    [sym_range] = STATE(937),
    [sym_binary] = STATE(937),
    [sym_unary] = STATE(937),
    [sym_left_assignment_list] = STATE(427),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(428),
    [sym__variable] = STATE(422),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(428),
    [sym_false] = STATE(428),
    [sym_nil] = STATE(428),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(942),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(940),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(1663),
    [sym__splat_star] = ACTIONS(1665),
    [sym__unary_minus] = ACTIONS(765),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(1667),
    [ts_builtin_sym_end] = ACTIONS(425),
    [anon_sym___END__] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(427),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(781),
    [anon_sym_yield] = ACTIONS(783),
    [anon_sym_break] = ACTIONS(785),
    [anon_sym_next] = ACTIONS(787),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(425),
    [anon_sym_DASH_EQ] = ACTIONS(425),
    [anon_sym_STAR_EQ] = ACTIONS(425),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(425),
    [anon_sym_SLASH_EQ] = ACTIONS(425),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(425),
    [anon_sym_PIPE_EQ] = ACTIONS(425),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(425),
    [anon_sym_AMP_EQ] = ACTIONS(425),
    [anon_sym_PERCENT_EQ] = ACTIONS(425),
    [anon_sym_GT_GT_EQ] = ACTIONS(425),
    [anon_sym_LT_LT_EQ] = ACTIONS(425),
    [anon_sym_CARET_EQ] = ACTIONS(425),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(801),
    [anon_sym_not] = ACTIONS(803),
    [anon_sym_BANG] = ACTIONS(805),
    [anon_sym_TILDE] = ACTIONS(807),
    [sym_constant] = ACTIONS(1675),
    [sym_identifier] = ACTIONS(1675),
    [sym_instance_variable] = ACTIONS(811),
    [sym_class_variable] = ACTIONS(811),
    [sym_global_variable] = ACTIONS(811),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(815),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(815),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [405] = {
    [sym_begin_block] = STATE(1539),
    [sym_end_block] = STATE(1539),
    [sym__statement] = STATE(1539),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1539),
    [sym_unless_modifier] = STATE(1539),
    [sym_while_modifier] = STATE(1539),
    [sym_until_modifier] = STATE(1539),
    [sym_rescue_modifier] = STATE(1539),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(234),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(234),
    [sym_operator_assignment] = STATE(234),
    [sym_conditional] = STATE(234),
    [sym_range] = STATE(234),
    [sym_binary] = STATE(234),
    [sym_unary] = STATE(234),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_undef] = STATE(1539),
    [sym_alias] = STATE(1539),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(429),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_yield] = ACTIONS(433),
    [anon_sym_break] = ACTIONS(435),
    [anon_sym_next] = ACTIONS(437),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(439),
    [anon_sym_defined_QMARK] = ACTIONS(441),
    [anon_sym_not] = ACTIONS(443),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [anon_sym_undef] = ACTIONS(451),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [406] = {
    [sym_begin_block] = STATE(1540),
    [sym_end_block] = STATE(1540),
    [sym__statement] = STATE(1540),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1540),
    [sym_unless_modifier] = STATE(1540),
    [sym_while_modifier] = STATE(1540),
    [sym_until_modifier] = STATE(1540),
    [sym_rescue_modifier] = STATE(1540),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(234),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(234),
    [sym_operator_assignment] = STATE(234),
    [sym_conditional] = STATE(234),
    [sym_range] = STATE(234),
    [sym_binary] = STATE(234),
    [sym_unary] = STATE(234),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_undef] = STATE(1540),
    [sym_alias] = STATE(1540),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(429),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_yield] = ACTIONS(433),
    [anon_sym_break] = ACTIONS(435),
    [anon_sym_next] = ACTIONS(437),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(439),
    [anon_sym_defined_QMARK] = ACTIONS(441),
    [anon_sym_not] = ACTIONS(443),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [anon_sym_undef] = ACTIONS(451),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [407] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1541),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(1541),
    [sym_operator_assignment] = STATE(1541),
    [sym_conditional] = STATE(1541),
    [sym_range] = STATE(1541),
    [sym_binary] = STATE(1541),
    [sym_unary] = STATE(1541),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(455),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_break] = ACTIONS(459),
    [anon_sym_next] = ACTIONS(461),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_defined_QMARK] = ACTIONS(465),
    [anon_sym_not] = ACTIONS(467),
    [anon_sym_BANG] = ACTIONS(469),
    [anon_sym_TILDE] = ACTIONS(469),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [408] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1542),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(1542),
    [sym_operator_assignment] = STATE(1542),
    [sym_conditional] = STATE(1542),
    [sym_range] = STATE(1542),
    [sym_binary] = STATE(1542),
    [sym_unary] = STATE(1542),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(455),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_break] = ACTIONS(459),
    [anon_sym_next] = ACTIONS(461),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_defined_QMARK] = ACTIONS(465),
    [anon_sym_not] = ACTIONS(467),
    [anon_sym_BANG] = ACTIONS(469),
    [anon_sym_TILDE] = ACTIONS(469),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [409] = {
    [sym_method] = STATE(184),
    [sym_singleton_method] = STATE(184),
    [sym_class] = STATE(184),
    [sym_singleton_class] = STATE(184),
    [sym_module] = STATE(184),
    [sym_return] = STATE(184),
    [sym_yield] = STATE(184),
    [sym_break] = STATE(184),
    [sym_next] = STATE(184),
    [sym_while] = STATE(184),
    [sym_until] = STATE(184),
    [sym_for] = STATE(184),
    [sym_case] = STATE(184),
    [sym_if] = STATE(184),
    [sym_unless] = STATE(184),
    [sym_begin] = STATE(184),
    [sym__primary] = STATE(184),
    [sym_parenthesized_statements] = STATE(184),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(255),
    [sym_call] = STATE(255),
    [sym_method_call] = STATE(258),
    [sym__mlhs] = STATE(1543),
    [sym_destructured_left_assignment] = STATE(257),
    [sym_rest_assignment] = STATE(257),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(255),
    [sym_rational] = STATE(184),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(184),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(184),
    [sym_string_array] = STATE(184),
    [sym_symbol_array] = STATE(184),
    [sym_symbol] = STATE(184),
    [sym_regex] = STATE(184),
    [sym_array] = STATE(184),
    [sym_hash] = STATE(184),
    [sym_lambda] = STATE(184),
    [sym__simple_symbol] = ACTIONS(279),
    [sym__string_start] = ACTIONS(281),
    [sym__symbol_start] = ACTIONS(283),
    [sym__subshell_start] = ACTIONS(285),
    [sym__regex_start] = ACTIONS(287),
    [sym__string_array_start] = ACTIONS(289),
    [sym__symbol_array_start] = ACTIONS(291),
    [sym_heredoc_beginning] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_def] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(475),
    [anon_sym_COLON_COLON] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(477),
    [anon_sym_class] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(307),
    [anon_sym_return] = ACTIONS(309),
    [anon_sym_yield] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_next] = ACTIONS(315),
    [sym_redo] = ACTIONS(317),
    [sym_retry] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(319),
    [anon_sym_unless] = ACTIONS(321),
    [anon_sym_while] = ACTIONS(323),
    [anon_sym_until] = ACTIONS(325),
    [anon_sym_for] = ACTIONS(327),
    [anon_sym_case] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(331),
    [sym_constant] = ACTIONS(479),
    [sym_identifier] = ACTIONS(479),
    [sym_instance_variable] = ACTIONS(481),
    [sym_class_variable] = ACTIONS(481),
    [sym_global_variable] = ACTIONS(481),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(317),
    [sym_complex] = ACTIONS(293),
    [sym_super] = ACTIONS(479),
    [anon_sym_true] = ACTIONS(339),
    [anon_sym_TRUE] = ACTIONS(339),
    [anon_sym_false] = ACTIONS(341),
    [anon_sym_FALSE] = ACTIONS(341),
    [sym_self] = ACTIONS(479),
    [anon_sym_nil] = ACTIONS(343),
    [anon_sym_NIL] = ACTIONS(343),
    [sym_character] = ACTIONS(293),
    [anon_sym_LBRACK2] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(347),
  },
  [410] = {
    [sym__statements] = STATE(1545),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_block_parameters] = STATE(1546),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_heredoc_body] = STATE(1547),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [sym__terminator] = STATE(1547),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__line_break] = ACTIONS(2667),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(2667),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(2669),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [411] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1548),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(1548),
    [sym_operator_assignment] = STATE(1548),
    [sym_conditional] = STATE(1548),
    [sym_range] = STATE(1548),
    [sym_binary] = STATE(1548),
    [sym_unary] = STATE(1548),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_heredoc_body] = STATE(1549),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__terminator] = STATE(1549),
    [sym__line_break] = ACTIONS(2671),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(485),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2671),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(495),
    [anon_sym_defined_QMARK] = ACTIONS(497),
    [anon_sym_not] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(501),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [412] = {
    [sym__statements] = STATE(1550),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(1551),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(1552),
    [sym_rescue] = STATE(1553),
    [sym__body_statement] = STATE(1554),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_heredoc_body] = STATE(1555),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [sym__terminator] = STATE(1555),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__line_break] = ACTIONS(2673),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2673),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(2675),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [413] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(906),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(911),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(911),
    [sym__argument_list_with_trailing_comma] = STATE(1557),
    [sym__argument] = STATE(909),
    [sym_splat_argument] = STATE(909),
    [sym_hash_splat_argument] = STATE(909),
    [sym_block_argument] = STATE(909),
    [sym_assignment] = STATE(906),
    [sym_operator_assignment] = STATE(906),
    [sym_conditional] = STATE(906),
    [sym_range] = STATE(906),
    [sym_binary] = STATE(906),
    [sym_unary] = STATE(906),
    [sym_left_assignment_list] = STATE(910),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(911),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(911),
    [sym_false] = STATE(911),
    [sym_nil] = STATE(911),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(912),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(909),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1589),
    [sym__splat_star] = ACTIONS(1591),
    [sym__unary_minus] = ACTIONS(1593),
    [sym__identifier_hash_key] = ACTIONS(1595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(2677),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1599),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_defined_QMARK] = ACTIONS(1611),
    [anon_sym_not] = ACTIONS(1613),
    [anon_sym_BANG] = ACTIONS(1615),
    [anon_sym_TILDE] = ACTIONS(1615),
    [sym_constant] = ACTIONS(1617),
    [sym_identifier] = ACTIONS(1617),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [414] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(1558),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(428),
    [sym_scope_resolution] = STATE(422),
    [sym_call] = STATE(422),
    [sym_method_call] = STATE(428),
    [sym_assignment] = STATE(1558),
    [sym_operator_assignment] = STATE(1558),
    [sym_conditional] = STATE(1558),
    [sym_range] = STATE(1558),
    [sym_binary] = STATE(1558),
    [sym_unary] = STATE(1558),
    [sym_left_assignment_list] = STATE(427),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(428),
    [sym__variable] = STATE(422),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(428),
    [sym_false] = STATE(428),
    [sym_nil] = STATE(428),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(1503),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(781),
    [anon_sym_yield] = ACTIONS(783),
    [anon_sym_break] = ACTIONS(785),
    [anon_sym_next] = ACTIONS(787),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(2623),
    [anon_sym_defined_QMARK] = ACTIONS(801),
    [anon_sym_not] = ACTIONS(803),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_TILDE] = ACTIONS(807),
    [sym_constant] = ACTIONS(815),
    [sym_identifier] = ACTIONS(815),
    [sym_instance_variable] = ACTIONS(811),
    [sym_class_variable] = ACTIONS(811),
    [sym_global_variable] = ACTIONS(811),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(815),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(815),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [415] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(1559),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(428),
    [sym_scope_resolution] = STATE(422),
    [sym_call] = STATE(422),
    [sym_method_call] = STATE(428),
    [sym_assignment] = STATE(1559),
    [sym_operator_assignment] = STATE(1559),
    [sym_conditional] = STATE(1559),
    [sym_range] = STATE(1559),
    [sym_binary] = STATE(1559),
    [sym_unary] = STATE(1559),
    [sym_left_assignment_list] = STATE(427),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(428),
    [sym__variable] = STATE(422),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(428),
    [sym_false] = STATE(428),
    [sym_nil] = STATE(428),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(1503),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(781),
    [anon_sym_yield] = ACTIONS(783),
    [anon_sym_break] = ACTIONS(785),
    [anon_sym_next] = ACTIONS(787),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(2623),
    [anon_sym_defined_QMARK] = ACTIONS(801),
    [anon_sym_not] = ACTIONS(803),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_TILDE] = ACTIONS(807),
    [sym_constant] = ACTIONS(815),
    [sym_identifier] = ACTIONS(815),
    [sym_instance_variable] = ACTIONS(811),
    [sym_class_variable] = ACTIONS(811),
    [sym_global_variable] = ACTIONS(811),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(815),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(815),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [416] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [ts_builtin_sym_end] = ACTIONS(1089),
    [anon_sym___END__] = ACTIONS(1091),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(2679),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [417] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(559),
    [anon_sym___END__] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_when] = ACTIONS(559),
    [anon_sym_elsif] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
    [anon_sym_r] = ACTIONS(2681),
  },
  [418] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(346),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(352),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(352),
    [sym__argument_list_with_trailing_comma] = STATE(1563),
    [sym__argument] = STATE(350),
    [sym_splat_argument] = STATE(350),
    [sym_hash_splat_argument] = STATE(350),
    [sym_block_argument] = STATE(350),
    [sym_assignment] = STATE(346),
    [sym_operator_assignment] = STATE(346),
    [sym_conditional] = STATE(346),
    [sym_range] = STATE(346),
    [sym_binary] = STATE(346),
    [sym_unary] = STATE(346),
    [sym_left_assignment_list] = STATE(351),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(352),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(352),
    [sym_false] = STATE(352),
    [sym_nil] = STATE(352),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(353),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(350),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(593),
    [sym__splat_star] = ACTIONS(595),
    [sym__unary_minus] = ACTIONS(597),
    [sym__identifier_hash_key] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(2683),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [419] = {
    [sym_lambda_parameters] = STATE(1565),
    [sym__simple_formal_parameter] = STATE(362),
    [sym_splat_parameter] = STATE(362),
    [sym_hash_splat_parameter] = STATE(362),
    [sym_block_parameter] = STATE(362),
    [sym_keyword_parameter] = STATE(362),
    [sym_optional_parameter] = STATE(362),
    [sym_do_block] = STATE(1566),
    [sym_block] = STATE(1566),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(1671),
    [sym_identifier] = ACTIONS(679),
    [sym_comment] = ACTIONS(87),
  },
  [420] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(2687),
    [sym__binary_star] = ACTIONS(2689),
    [ts_builtin_sym_end] = ACTIONS(1625),
    [anon_sym___END__] = ACTIONS(1625),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(2691),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(2693),
    [anon_sym_AMP] = ACTIONS(2695),
    [anon_sym_EQ] = ACTIONS(1631),
    [anon_sym_LT] = ACTIONS(2697),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_unless] = ACTIONS(1625),
    [anon_sym_while] = ACTIONS(1625),
    [anon_sym_until] = ACTIONS(1625),
    [anon_sym_rescue] = ACTIONS(1625),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(2627),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_PLUS_EQ] = ACTIONS(1625),
    [anon_sym_DASH_EQ] = ACTIONS(1625),
    [anon_sym_STAR_EQ] = ACTIONS(1625),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1625),
    [anon_sym_SLASH_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1625),
    [anon_sym_AMP_EQ] = ACTIONS(1625),
    [anon_sym_PERCENT_EQ] = ACTIONS(1625),
    [anon_sym_GT_GT_EQ] = ACTIONS(1625),
    [anon_sym_LT_LT_EQ] = ACTIONS(1625),
    [anon_sym_CARET_EQ] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(2699),
    [anon_sym_DOT_DOT] = ACTIONS(2701),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2703),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(2705),
    [anon_sym_AMP_AMP] = ACTIONS(2705),
    [anon_sym_LT_LT] = ACTIONS(2707),
    [anon_sym_GT_GT] = ACTIONS(2707),
    [anon_sym_EQ_EQ] = ACTIONS(2705),
    [anon_sym_BANG_EQ] = ACTIONS(2709),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2709),
    [anon_sym_LT_EQ_GT] = ACTIONS(2709),
    [anon_sym_EQ_TILDE] = ACTIONS(2709),
    [anon_sym_BANG_TILDE] = ACTIONS(2709),
    [anon_sym_LT_EQ] = ACTIONS(2697),
    [anon_sym_GT] = ACTIONS(2697),
    [anon_sym_GT_EQ] = ACTIONS(2711),
    [anon_sym_CARET] = ACTIONS(2691),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_SLASH] = ACTIONS(2693),
    [anon_sym_PERCENT] = ACTIONS(2693),
    [sym_comment] = ACTIONS(87),
  },
  [421] = {
    [sym__line_break] = ACTIONS(731),
    [sym__heredoc_body_start] = ACTIONS(731),
    [sym__binary_minus] = ACTIONS(731),
    [sym__binary_star] = ACTIONS(731),
    [ts_builtin_sym_end] = ACTIONS(731),
    [anon_sym___END__] = ACTIONS(731),
    [anon_sym_LBRACE] = ACTIONS(731),
    [anon_sym_RBRACE] = ACTIONS(731),
    [anon_sym_RPAREN] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(1655),
    [anon_sym_COMMA] = ACTIONS(731),
    [anon_sym_PIPE] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(731),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_AMP] = ACTIONS(735),
    [anon_sym_EQ] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(735),
    [anon_sym_end] = ACTIONS(731),
    [anon_sym_if] = ACTIONS(731),
    [anon_sym_unless] = ACTIONS(731),
    [anon_sym_while] = ACTIONS(731),
    [anon_sym_until] = ACTIONS(731),
    [anon_sym_rescue] = ACTIONS(731),
    [anon_sym_do] = ACTIONS(731),
    [anon_sym_when] = ACTIONS(731),
    [anon_sym_elsif] = ACTIONS(731),
    [anon_sym_else] = ACTIONS(731),
    [anon_sym_then] = ACTIONS(731),
    [anon_sym_ensure] = ACTIONS(731),
    [anon_sym_EQ_GT] = ACTIONS(731),
    [anon_sym_LBRACK] = ACTIONS(1657),
    [anon_sym_COLON_COLON2] = ACTIONS(1659),
    [anon_sym_AMP_DOT] = ACTIONS(1661),
    [anon_sym_PLUS_EQ] = ACTIONS(731),
    [anon_sym_DASH_EQ] = ACTIONS(731),
    [anon_sym_STAR_EQ] = ACTIONS(731),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(731),
    [anon_sym_SLASH_EQ] = ACTIONS(731),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(731),
    [anon_sym_PIPE_EQ] = ACTIONS(731),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(731),
    [anon_sym_AMP_EQ] = ACTIONS(731),
    [anon_sym_PERCENT_EQ] = ACTIONS(731),
    [anon_sym_GT_GT_EQ] = ACTIONS(731),
    [anon_sym_LT_LT_EQ] = ACTIONS(731),
    [anon_sym_CARET_EQ] = ACTIONS(731),
    [anon_sym_QMARK] = ACTIONS(731),
    [anon_sym_DOT_DOT] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(731),
    [anon_sym_or] = ACTIONS(731),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_EQ_EQ] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(731),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(731),
    [anon_sym_LT_EQ_GT] = ACTIONS(731),
    [anon_sym_EQ_TILDE] = ACTIONS(731),
    [anon_sym_BANG_TILDE] = ACTIONS(731),
    [anon_sym_LT_EQ] = ACTIONS(735),
    [anon_sym_GT] = ACTIONS(735),
    [anon_sym_GT_EQ] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_SLASH] = ACTIONS(735),
    [anon_sym_PERCENT] = ACTIONS(735),
    [sym_comment] = ACTIONS(87),
  },
  [422] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(937),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(428),
    [sym_scope_resolution] = STATE(422),
    [sym_call] = STATE(422),
    [sym_method_call] = STATE(428),
    [sym_argument_list] = STATE(1578),
    [sym__argument_list_with_parens] = STATE(939),
    [sym__argument] = STATE(940),
    [sym_splat_argument] = STATE(940),
    [sym_hash_splat_argument] = STATE(940),
    [sym_block_argument] = STATE(940),
    [sym_do_block] = STATE(941),
    [sym_block] = STATE(941),
    [sym_assignment] = STATE(937),
    [sym_operator_assignment] = STATE(937),
    [sym_conditional] = STATE(937),
    [sym_range] = STATE(937),
    [sym_binary] = STATE(937),
    [sym_unary] = STATE(937),
    [sym_left_assignment_list] = STATE(427),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(428),
    [sym__variable] = STATE(422),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(428),
    [sym_false] = STATE(428),
    [sym_nil] = STATE(428),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(942),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(940),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(743),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(1663),
    [sym__splat_star] = ACTIONS(1665),
    [sym__unary_minus] = ACTIONS(765),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(1667),
    [ts_builtin_sym_end] = ACTIONS(743),
    [anon_sym___END__] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(2715),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(781),
    [anon_sym_yield] = ACTIONS(783),
    [anon_sym_break] = ACTIONS(785),
    [anon_sym_next] = ACTIONS(787),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(769),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(769),
    [anon_sym_until] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(769),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(769),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(801),
    [anon_sym_not] = ACTIONS(803),
    [anon_sym_BANG] = ACTIONS(805),
    [anon_sym_TILDE] = ACTIONS(807),
    [sym_constant] = ACTIONS(1675),
    [sym_identifier] = ACTIONS(1675),
    [sym_instance_variable] = ACTIONS(811),
    [sym_class_variable] = ACTIONS(811),
    [sym_global_variable] = ACTIONS(811),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(815),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(815),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [423] = {
    [sym_do_block] = STATE(1580),
    [sym_block] = STATE(1580),
    [sym__line_break] = ACTIONS(2717),
    [sym__heredoc_body_start] = ACTIONS(2717),
    [sym__binary_minus] = ACTIONS(2717),
    [sym__binary_star] = ACTIONS(2717),
    [ts_builtin_sym_end] = ACTIONS(2717),
    [anon_sym___END__] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(2719),
    [anon_sym_RBRACE] = ACTIONS(2717),
    [anon_sym_RPAREN] = ACTIONS(2717),
    [anon_sym_DOT] = ACTIONS(2721),
    [anon_sym_COMMA] = ACTIONS(2717),
    [anon_sym_PIPE] = ACTIONS(2721),
    [anon_sym_SEMI] = ACTIONS(2717),
    [anon_sym_STAR_STAR] = ACTIONS(2721),
    [anon_sym_AMP] = ACTIONS(2721),
    [anon_sym_EQ] = ACTIONS(2721),
    [anon_sym_LT] = ACTIONS(2721),
    [anon_sym_end] = ACTIONS(2717),
    [anon_sym_if] = ACTIONS(2717),
    [anon_sym_unless] = ACTIONS(2717),
    [anon_sym_while] = ACTIONS(2717),
    [anon_sym_until] = ACTIONS(2717),
    [anon_sym_rescue] = ACTIONS(2717),
    [anon_sym_do] = ACTIONS(2723),
    [anon_sym_when] = ACTIONS(2717),
    [anon_sym_elsif] = ACTIONS(2717),
    [anon_sym_else] = ACTIONS(2717),
    [anon_sym_then] = ACTIONS(2717),
    [anon_sym_ensure] = ACTIONS(2717),
    [anon_sym_LBRACK] = ACTIONS(2717),
    [anon_sym_COLON_COLON2] = ACTIONS(2717),
    [anon_sym_AMP_DOT] = ACTIONS(2717),
    [anon_sym_PLUS_EQ] = ACTIONS(2717),
    [anon_sym_DASH_EQ] = ACTIONS(2717),
    [anon_sym_STAR_EQ] = ACTIONS(2717),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2717),
    [anon_sym_SLASH_EQ] = ACTIONS(2717),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2717),
    [anon_sym_PIPE_EQ] = ACTIONS(2717),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2717),
    [anon_sym_AMP_EQ] = ACTIONS(2717),
    [anon_sym_PERCENT_EQ] = ACTIONS(2717),
    [anon_sym_GT_GT_EQ] = ACTIONS(2717),
    [anon_sym_LT_LT_EQ] = ACTIONS(2717),
    [anon_sym_CARET_EQ] = ACTIONS(2717),
    [anon_sym_QMARK] = ACTIONS(2717),
    [anon_sym_DOT_DOT] = ACTIONS(2721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2717),
    [anon_sym_and] = ACTIONS(2717),
    [anon_sym_or] = ACTIONS(2717),
    [anon_sym_PIPE_PIPE] = ACTIONS(2721),
    [anon_sym_AMP_AMP] = ACTIONS(2721),
    [anon_sym_LT_LT] = ACTIONS(2721),
    [anon_sym_GT_GT] = ACTIONS(2721),
    [anon_sym_EQ_EQ] = ACTIONS(2721),
    [anon_sym_BANG_EQ] = ACTIONS(2717),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2717),
    [anon_sym_LT_EQ_GT] = ACTIONS(2717),
    [anon_sym_EQ_TILDE] = ACTIONS(2717),
    [anon_sym_BANG_TILDE] = ACTIONS(2717),
    [anon_sym_LT_EQ] = ACTIONS(2721),
    [anon_sym_GT] = ACTIONS(2721),
    [anon_sym_GT_EQ] = ACTIONS(2717),
    [anon_sym_CARET] = ACTIONS(2721),
    [anon_sym_PLUS] = ACTIONS(2721),
    [anon_sym_SLASH] = ACTIONS(2721),
    [anon_sym_PERCENT] = ACTIONS(2721),
    [sym_comment] = ACTIONS(87),
  },
  [424] = {
    [sym_heredoc_body] = STATE(1582),
    [aux_sym_call_repeat1] = STATE(1582),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [ts_builtin_sym_end] = ACTIONS(1681),
    [anon_sym___END__] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [425] = {
    [sym_heredoc_body] = STATE(1582),
    [aux_sym_call_repeat1] = STATE(1582),
    [aux_sym_argument_list_repeat1] = STATE(1584),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [ts_builtin_sym_end] = ACTIONS(1681),
    [anon_sym___END__] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(2727),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [426] = {
    [sym__line_break] = ACTIONS(2717),
    [sym__heredoc_body_start] = ACTIONS(2717),
    [sym__binary_minus] = ACTIONS(2717),
    [sym__binary_star] = ACTIONS(2717),
    [ts_builtin_sym_end] = ACTIONS(2717),
    [anon_sym___END__] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(2717),
    [anon_sym_RBRACE] = ACTIONS(2717),
    [anon_sym_RPAREN] = ACTIONS(2717),
    [anon_sym_DOT] = ACTIONS(2721),
    [anon_sym_COMMA] = ACTIONS(2717),
    [anon_sym_PIPE] = ACTIONS(2721),
    [anon_sym_SEMI] = ACTIONS(2717),
    [anon_sym_STAR_STAR] = ACTIONS(2721),
    [anon_sym_AMP] = ACTIONS(2721),
    [anon_sym_EQ] = ACTIONS(2721),
    [anon_sym_LT] = ACTIONS(2721),
    [anon_sym_end] = ACTIONS(2717),
    [anon_sym_if] = ACTIONS(2717),
    [anon_sym_unless] = ACTIONS(2717),
    [anon_sym_while] = ACTIONS(2717),
    [anon_sym_until] = ACTIONS(2717),
    [anon_sym_rescue] = ACTIONS(2717),
    [anon_sym_do] = ACTIONS(2717),
    [anon_sym_when] = ACTIONS(2717),
    [anon_sym_elsif] = ACTIONS(2717),
    [anon_sym_else] = ACTIONS(2717),
    [anon_sym_then] = ACTIONS(2717),
    [anon_sym_ensure] = ACTIONS(2717),
    [anon_sym_LBRACK] = ACTIONS(2717),
    [anon_sym_COLON_COLON2] = ACTIONS(2717),
    [anon_sym_AMP_DOT] = ACTIONS(2717),
    [anon_sym_PLUS_EQ] = ACTIONS(2717),
    [anon_sym_DASH_EQ] = ACTIONS(2717),
    [anon_sym_STAR_EQ] = ACTIONS(2717),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2717),
    [anon_sym_SLASH_EQ] = ACTIONS(2717),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2717),
    [anon_sym_PIPE_EQ] = ACTIONS(2717),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2717),
    [anon_sym_AMP_EQ] = ACTIONS(2717),
    [anon_sym_PERCENT_EQ] = ACTIONS(2717),
    [anon_sym_GT_GT_EQ] = ACTIONS(2717),
    [anon_sym_LT_LT_EQ] = ACTIONS(2717),
    [anon_sym_CARET_EQ] = ACTIONS(2717),
    [anon_sym_QMARK] = ACTIONS(2717),
    [anon_sym_DOT_DOT] = ACTIONS(2721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2717),
    [anon_sym_and] = ACTIONS(2717),
    [anon_sym_or] = ACTIONS(2717),
    [anon_sym_PIPE_PIPE] = ACTIONS(2721),
    [anon_sym_AMP_AMP] = ACTIONS(2721),
    [anon_sym_LT_LT] = ACTIONS(2721),
    [anon_sym_GT_GT] = ACTIONS(2721),
    [anon_sym_EQ_EQ] = ACTIONS(2721),
    [anon_sym_BANG_EQ] = ACTIONS(2717),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2717),
    [anon_sym_LT_EQ_GT] = ACTIONS(2717),
    [anon_sym_EQ_TILDE] = ACTIONS(2717),
    [anon_sym_BANG_TILDE] = ACTIONS(2717),
    [anon_sym_LT_EQ] = ACTIONS(2721),
    [anon_sym_GT] = ACTIONS(2721),
    [anon_sym_GT_EQ] = ACTIONS(2717),
    [anon_sym_CARET] = ACTIONS(2721),
    [anon_sym_PLUS] = ACTIONS(2721),
    [anon_sym_SLASH] = ACTIONS(2721),
    [anon_sym_PERCENT] = ACTIONS(2721),
    [sym_comment] = ACTIONS(87),
  },
  [427] = {
    [anon_sym_EQ] = ACTIONS(2729),
    [sym_comment] = ACTIONS(87),
  },
  [428] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(559),
    [anon_sym___END__] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(2731),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(2733),
    [anon_sym_DASH_EQ] = ACTIONS(2733),
    [anon_sym_STAR_EQ] = ACTIONS(2733),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2733),
    [anon_sym_SLASH_EQ] = ACTIONS(2733),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2733),
    [anon_sym_PIPE_EQ] = ACTIONS(2733),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2733),
    [anon_sym_AMP_EQ] = ACTIONS(2733),
    [anon_sym_PERCENT_EQ] = ACTIONS(2733),
    [anon_sym_GT_GT_EQ] = ACTIONS(2733),
    [anon_sym_LT_LT_EQ] = ACTIONS(2733),
    [anon_sym_CARET_EQ] = ACTIONS(2733),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [429] = {
    [sym_string] = STATE(1587),
    [aux_sym_chained_string_repeat1] = STATE(1587),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(747),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(559),
    [anon_sym___END__] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(2735),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [430] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1592),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1596),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(1596),
    [sym_splat_argument] = STATE(1594),
    [sym_assignment] = STATE(1592),
    [sym_operator_assignment] = STATE(1592),
    [sym_conditional] = STATE(1592),
    [sym_range] = STATE(1592),
    [sym_binary] = STATE(1592),
    [sym_unary] = STATE(1592),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(1594),
    [sym_left_assignment_list] = STATE(1595),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1596),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1596),
    [sym_false] = STATE(1596),
    [sym_nil] = STATE(1596),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(877),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(2737),
    [sym__unary_minus] = ACTIONS(2739),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1557),
    [anon_sym_yield] = ACTIONS(1559),
    [anon_sym_break] = ACTIONS(1561),
    [anon_sym_next] = ACTIONS(1563),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2741),
    [anon_sym_defined_QMARK] = ACTIONS(2743),
    [anon_sym_not] = ACTIONS(2745),
    [anon_sym_BANG] = ACTIONS(2747),
    [anon_sym_TILDE] = ACTIONS(2747),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [431] = {
    [sym_method] = STATE(184),
    [sym_singleton_method] = STATE(184),
    [sym_class] = STATE(184),
    [sym_singleton_class] = STATE(184),
    [sym_module] = STATE(184),
    [sym_return] = STATE(184),
    [sym_yield] = STATE(184),
    [sym_break] = STATE(184),
    [sym_next] = STATE(184),
    [sym_while] = STATE(184),
    [sym_until] = STATE(184),
    [sym_for] = STATE(184),
    [sym_case] = STATE(184),
    [sym_if] = STATE(184),
    [sym_unless] = STATE(184),
    [sym_begin] = STATE(184),
    [sym__primary] = STATE(184),
    [sym_parenthesized_statements] = STATE(184),
    [sym_element_reference] = STATE(1598),
    [sym_scope_resolution] = STATE(185),
    [sym_call] = STATE(185),
    [sym_method_call] = STATE(1598),
    [sym_destructured_left_assignment] = STATE(1597),
    [sym_rest_assignment] = STATE(1597),
    [sym__lhs] = STATE(1598),
    [sym__variable] = STATE(185),
    [sym_rational] = STATE(184),
    [sym_true] = STATE(1598),
    [sym_false] = STATE(1598),
    [sym_nil] = STATE(1598),
    [sym_chained_string] = STATE(184),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(184),
    [sym_string_array] = STATE(184),
    [sym_symbol_array] = STATE(184),
    [sym_symbol] = STATE(184),
    [sym_regex] = STATE(184),
    [sym_array] = STATE(184),
    [sym_hash] = STATE(184),
    [sym_lambda] = STATE(184),
    [sym__simple_symbol] = ACTIONS(279),
    [sym__string_start] = ACTIONS(281),
    [sym__symbol_start] = ACTIONS(283),
    [sym__subshell_start] = ACTIONS(285),
    [sym__regex_start] = ACTIONS(287),
    [sym__string_array_start] = ACTIONS(289),
    [sym__symbol_array_start] = ACTIONS(291),
    [sym_heredoc_beginning] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_def] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(475),
    [anon_sym_COLON_COLON] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_EQ] = ACTIONS(2749),
    [anon_sym_class] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(307),
    [anon_sym_return] = ACTIONS(309),
    [anon_sym_yield] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_next] = ACTIONS(315),
    [sym_redo] = ACTIONS(317),
    [sym_retry] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(319),
    [anon_sym_unless] = ACTIONS(321),
    [anon_sym_while] = ACTIONS(323),
    [anon_sym_until] = ACTIONS(325),
    [anon_sym_for] = ACTIONS(327),
    [anon_sym_case] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(331),
    [sym_constant] = ACTIONS(333),
    [sym_identifier] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(317),
    [sym_complex] = ACTIONS(293),
    [sym_super] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(339),
    [anon_sym_TRUE] = ACTIONS(339),
    [anon_sym_false] = ACTIONS(341),
    [anon_sym_FALSE] = ACTIONS(341),
    [sym_self] = ACTIONS(333),
    [anon_sym_nil] = ACTIONS(343),
    [anon_sym_NIL] = ACTIONS(343),
    [sym_character] = ACTIONS(293),
    [anon_sym_LBRACK2] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(347),
  },
  [432] = {
    [aux_sym__mlhs_repeat1] = STATE(1600),
    [anon_sym_COMMA] = ACTIONS(2751),
    [anon_sym_EQ] = ACTIONS(2749),
    [sym_comment] = ACTIONS(87),
  },
  [433] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1601),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(51),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(51),
    [sym_assignment] = STATE(1601),
    [sym_operator_assignment] = STATE(1601),
    [sym_conditional] = STATE(1601),
    [sym_range] = STATE(1601),
    [sym_binary] = STATE(1601),
    [sym_unary] = STATE(1601),
    [sym_left_assignment_list] = STATE(48),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(51),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(51),
    [sym_false] = STATE(51),
    [sym_nil] = STATE(51),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(52),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [434] = {
    [sym_string] = STATE(1602),
    [aux_sym_chained_string_repeat1] = STATE(1602),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [ts_builtin_sym_end] = ACTIONS(2753),
    [anon_sym___END__] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [435] = {
    [sym_heredoc_body] = STATE(370),
    [sym__terminator] = STATE(370),
    [sym__line_break] = ACTIONS(687),
    [sym__heredoc_body_start] = ACTIONS(509),
    [ts_builtin_sym_end] = ACTIONS(2757),
    [anon_sym___END__] = ACTIONS(2757),
    [anon_sym_SEMI] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(691),
    [anon_sym_unless] = ACTIONS(693),
    [anon_sym_while] = ACTIONS(695),
    [anon_sym_until] = ACTIONS(697),
    [anon_sym_rescue] = ACTIONS(699),
    [sym_comment] = ACTIONS(87),
  },
  [436] = {
    [sym_begin_block] = STATE(1611),
    [sym_end_block] = STATE(1611),
    [sym__statement] = STATE(1611),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1611),
    [sym_unless_modifier] = STATE(1611),
    [sym_while_modifier] = STATE(1611),
    [sym_until_modifier] = STATE(1611),
    [sym_rescue_modifier] = STATE(1611),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1612),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1615),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(1615),
    [sym_assignment] = STATE(1612),
    [sym_operator_assignment] = STATE(1612),
    [sym_conditional] = STATE(1612),
    [sym_range] = STATE(1612),
    [sym_binary] = STATE(1612),
    [sym_unary] = STATE(1612),
    [sym_left_assignment_list] = STATE(1614),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1615),
    [sym__variable] = STATE(1613),
    [sym_undef] = STATE(1611),
    [sym_alias] = STATE(1611),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1615),
    [sym_false] = STATE(1615),
    [sym_nil] = STATE(1615),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1616),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(436),
    [aux_sym__statements_repeat1] = STATE(436),
    [sym__simple_symbol] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(2762),
    [sym__symbol_start] = ACTIONS(2765),
    [sym__subshell_start] = ACTIONS(2768),
    [sym__regex_start] = ACTIONS(2771),
    [sym__string_array_start] = ACTIONS(2774),
    [sym__symbol_array_start] = ACTIONS(2777),
    [sym_heredoc_beginning] = ACTIONS(2780),
    [sym__unary_minus] = ACTIONS(2783),
    [ts_builtin_sym_end] = ACTIONS(2491),
    [anon_sym___END__] = ACTIONS(2493),
    [anon_sym_BEGIN] = ACTIONS(2786),
    [anon_sym_LBRACE] = ACTIONS(2789),
    [anon_sym_END] = ACTIONS(2792),
    [anon_sym_def] = ACTIONS(2795),
    [anon_sym_LPAREN] = ACTIONS(2798),
    [anon_sym_COLON_COLON] = ACTIONS(2801),
    [anon_sym_SEMI] = ACTIONS(2804),
    [anon_sym_STAR] = ACTIONS(2807),
    [anon_sym_class] = ACTIONS(2810),
    [anon_sym_module] = ACTIONS(2813),
    [anon_sym_return] = ACTIONS(2816),
    [anon_sym_yield] = ACTIONS(2819),
    [anon_sym_break] = ACTIONS(2822),
    [anon_sym_next] = ACTIONS(2825),
    [sym_redo] = ACTIONS(2828),
    [sym_retry] = ACTIONS(2828),
    [anon_sym_if] = ACTIONS(2831),
    [anon_sym_unless] = ACTIONS(2834),
    [anon_sym_while] = ACTIONS(2837),
    [anon_sym_until] = ACTIONS(2840),
    [anon_sym_for] = ACTIONS(2843),
    [anon_sym_case] = ACTIONS(2846),
    [anon_sym_begin] = ACTIONS(2849),
    [anon_sym_PLUS] = ACTIONS(2852),
    [anon_sym_defined_QMARK] = ACTIONS(2855),
    [anon_sym_not] = ACTIONS(2858),
    [anon_sym_BANG] = ACTIONS(2861),
    [anon_sym_TILDE] = ACTIONS(2861),
    [sym_constant] = ACTIONS(2864),
    [sym_identifier] = ACTIONS(2864),
    [sym_instance_variable] = ACTIONS(2867),
    [sym_class_variable] = ACTIONS(2867),
    [sym_global_variable] = ACTIONS(2867),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_alias] = ACTIONS(2873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2876),
    [sym_float] = ACTIONS(2828),
    [sym_complex] = ACTIONS(2780),
    [sym_super] = ACTIONS(2864),
    [anon_sym_true] = ACTIONS(2879),
    [anon_sym_TRUE] = ACTIONS(2879),
    [anon_sym_false] = ACTIONS(2882),
    [anon_sym_FALSE] = ACTIONS(2882),
    [sym_self] = ACTIONS(2864),
    [anon_sym_nil] = ACTIONS(2885),
    [anon_sym_NIL] = ACTIONS(2885),
    [sym_character] = ACTIONS(2780),
    [anon_sym_LBRACK2] = ACTIONS(2888),
    [anon_sym_DASH_GT] = ACTIONS(2891),
  },
  [437] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(1617),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(457),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym_method_call] = STATE(457),
    [sym_assignment] = STATE(1617),
    [sym_operator_assignment] = STATE(1617),
    [sym_conditional] = STATE(1617),
    [sym_range] = STATE(1617),
    [sym_binary] = STATE(1617),
    [sym_unary] = STATE(1617),
    [sym_left_assignment_list] = STATE(456),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(457),
    [sym__variable] = STATE(455),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(457),
    [sym_false] = STATE(457),
    [sym_nil] = STATE(457),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(458),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(841),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_yield] = ACTIONS(851),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_next] = ACTIONS(855),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [438] = {
    [anon_sym_LBRACE] = ACTIONS(2894),
    [sym_comment] = ACTIONS(87),
  },
  [439] = {
    [anon_sym_LBRACE] = ACTIONS(2896),
    [sym_comment] = ACTIONS(87),
  },
  [440] = {
    [sym_constant] = ACTIONS(2898),
    [sym_identifier] = ACTIONS(2898),
    [sym_comment] = ACTIONS(87),
  },
  [441] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(1633),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1638),
    [sym_scope_resolution] = STATE(1634),
    [sym_call] = STATE(1634),
    [sym_method_call] = STATE(1638),
    [sym_argument_list] = STATE(563),
    [sym__argument_list_with_parens] = STATE(1635),
    [sym__argument] = STATE(1636),
    [sym_splat_argument] = STATE(1636),
    [sym_hash_splat_argument] = STATE(1636),
    [sym_block_argument] = STATE(1636),
    [sym_assignment] = STATE(1633),
    [sym_operator_assignment] = STATE(1633),
    [sym_conditional] = STATE(1633),
    [sym_range] = STATE(1633),
    [sym_binary] = STATE(1633),
    [sym_unary] = STATE(1633),
    [sym_left_assignment_list] = STATE(1637),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1638),
    [sym__variable] = STATE(1634),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1638),
    [sym_false] = STATE(1638),
    [sym_nil] = STATE(1638),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1639),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(1636),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(2900),
    [sym__splat_star] = ACTIONS(2902),
    [sym__unary_minus] = ACTIONS(2904),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(2906),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(2910),
    [anon_sym_break] = ACTIONS(2912),
    [anon_sym_next] = ACTIONS(2914),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(2916),
    [anon_sym_not] = ACTIONS(2918),
    [anon_sym_BANG] = ACTIONS(2920),
    [anon_sym_TILDE] = ACTIONS(2922),
    [sym_constant] = ACTIONS(2924),
    [sym_identifier] = ACTIONS(2924),
    [sym_instance_variable] = ACTIONS(2926),
    [sym_class_variable] = ACTIONS(2926),
    [sym_global_variable] = ACTIONS(2926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2928),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2928),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [442] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(1633),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1638),
    [sym_scope_resolution] = STATE(1634),
    [sym_call] = STATE(1634),
    [sym_method_call] = STATE(1638),
    [sym_argument_list] = STATE(569),
    [sym__argument_list_with_parens] = STATE(1635),
    [sym__argument] = STATE(1636),
    [sym_splat_argument] = STATE(1636),
    [sym_hash_splat_argument] = STATE(1636),
    [sym_block_argument] = STATE(1636),
    [sym_assignment] = STATE(1633),
    [sym_operator_assignment] = STATE(1633),
    [sym_conditional] = STATE(1633),
    [sym_range] = STATE(1633),
    [sym_binary] = STATE(1633),
    [sym_unary] = STATE(1633),
    [sym_left_assignment_list] = STATE(1637),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1638),
    [sym__variable] = STATE(1634),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1638),
    [sym_false] = STATE(1638),
    [sym_nil] = STATE(1638),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1639),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(1636),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(2900),
    [sym__splat_star] = ACTIONS(2902),
    [sym__unary_minus] = ACTIONS(2904),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(2906),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(2910),
    [anon_sym_break] = ACTIONS(2912),
    [anon_sym_next] = ACTIONS(2914),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(2916),
    [anon_sym_not] = ACTIONS(2918),
    [anon_sym_BANG] = ACTIONS(2920),
    [anon_sym_TILDE] = ACTIONS(2922),
    [sym_constant] = ACTIONS(2924),
    [sym_identifier] = ACTIONS(2924),
    [sym_instance_variable] = ACTIONS(2926),
    [sym_class_variable] = ACTIONS(2926),
    [sym_global_variable] = ACTIONS(2926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2928),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2928),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [443] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(1633),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1638),
    [sym_scope_resolution] = STATE(1634),
    [sym_call] = STATE(1634),
    [sym_method_call] = STATE(1638),
    [sym_argument_list] = STATE(570),
    [sym__argument_list_with_parens] = STATE(1635),
    [sym__argument] = STATE(1636),
    [sym_splat_argument] = STATE(1636),
    [sym_hash_splat_argument] = STATE(1636),
    [sym_block_argument] = STATE(1636),
    [sym_assignment] = STATE(1633),
    [sym_operator_assignment] = STATE(1633),
    [sym_conditional] = STATE(1633),
    [sym_range] = STATE(1633),
    [sym_binary] = STATE(1633),
    [sym_unary] = STATE(1633),
    [sym_left_assignment_list] = STATE(1637),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1638),
    [sym__variable] = STATE(1634),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1638),
    [sym_false] = STATE(1638),
    [sym_nil] = STATE(1638),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1639),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(1636),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(2900),
    [sym__splat_star] = ACTIONS(2902),
    [sym__unary_minus] = ACTIONS(2904),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(2906),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(2910),
    [anon_sym_break] = ACTIONS(2912),
    [anon_sym_next] = ACTIONS(2914),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(2916),
    [anon_sym_not] = ACTIONS(2918),
    [anon_sym_BANG] = ACTIONS(2920),
    [anon_sym_TILDE] = ACTIONS(2922),
    [sym_constant] = ACTIONS(2924),
    [sym_identifier] = ACTIONS(2924),
    [sym_instance_variable] = ACTIONS(2926),
    [sym_class_variable] = ACTIONS(2926),
    [sym_global_variable] = ACTIONS(2926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2928),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2928),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [444] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(1633),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1638),
    [sym_scope_resolution] = STATE(1634),
    [sym_call] = STATE(1634),
    [sym_method_call] = STATE(1638),
    [sym_argument_list] = STATE(571),
    [sym__argument_list_with_parens] = STATE(1635),
    [sym__argument] = STATE(1636),
    [sym_splat_argument] = STATE(1636),
    [sym_hash_splat_argument] = STATE(1636),
    [sym_block_argument] = STATE(1636),
    [sym_assignment] = STATE(1633),
    [sym_operator_assignment] = STATE(1633),
    [sym_conditional] = STATE(1633),
    [sym_range] = STATE(1633),
    [sym_binary] = STATE(1633),
    [sym_unary] = STATE(1633),
    [sym_left_assignment_list] = STATE(1637),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1638),
    [sym__variable] = STATE(1634),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1638),
    [sym_false] = STATE(1638),
    [sym_nil] = STATE(1638),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1639),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(1636),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(2900),
    [sym__splat_star] = ACTIONS(2902),
    [sym__unary_minus] = ACTIONS(2904),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(2906),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(2910),
    [anon_sym_break] = ACTIONS(2912),
    [anon_sym_next] = ACTIONS(2914),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(2916),
    [anon_sym_not] = ACTIONS(2918),
    [anon_sym_BANG] = ACTIONS(2920),
    [anon_sym_TILDE] = ACTIONS(2922),
    [sym_constant] = ACTIONS(2924),
    [sym_identifier] = ACTIONS(2924),
    [sym_instance_variable] = ACTIONS(2926),
    [sym_class_variable] = ACTIONS(2926),
    [sym_global_variable] = ACTIONS(2926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2928),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2928),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [445] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(1640),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(457),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym_method_call] = STATE(457),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_left_assignment_list] = STATE(456),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(457),
    [sym__variable] = STATE(455),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(457),
    [sym_false] = STATE(457),
    [sym_nil] = STATE(457),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(458),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(841),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_yield] = ACTIONS(851),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_next] = ACTIONS(855),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [446] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(586),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(457),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym_method_call] = STATE(457),
    [sym_assignment] = STATE(586),
    [sym_operator_assignment] = STATE(586),
    [sym_conditional] = STATE(586),
    [sym_range] = STATE(586),
    [sym_binary] = STATE(586),
    [sym_unary] = STATE(586),
    [sym_left_assignment_list] = STATE(456),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(457),
    [sym__variable] = STATE(455),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(457),
    [sym_false] = STATE(457),
    [sym_nil] = STATE(457),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(458),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(841),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_yield] = ACTIONS(851),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_next] = ACTIONS(855),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [447] = {
    [sym_operator] = STATE(1643),
    [sym__method_name] = STATE(1643),
    [sym_setter] = STATE(1643),
    [sym_symbol] = STATE(1643),
    [sym__simple_symbol] = ACTIONS(279),
    [sym__symbol_start] = ACTIONS(283),
    [anon_sym_PIPE] = ACTIONS(2930),
    [anon_sym_STAR] = ACTIONS(2932),
    [anon_sym_STAR_STAR] = ACTIONS(2930),
    [anon_sym_AMP] = ACTIONS(2930),
    [anon_sym_LT] = ACTIONS(2932),
    [anon_sym_DOT_DOT] = ACTIONS(2930),
    [anon_sym_LT_LT] = ACTIONS(2930),
    [anon_sym_GT_GT] = ACTIONS(2930),
    [anon_sym_EQ_EQ] = ACTIONS(2932),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2930),
    [anon_sym_LT_EQ_GT] = ACTIONS(2930),
    [anon_sym_EQ_TILDE] = ACTIONS(2930),
    [anon_sym_BANG_TILDE] = ACTIONS(2930),
    [anon_sym_LT_EQ] = ACTIONS(2932),
    [anon_sym_GT] = ACTIONS(2932),
    [anon_sym_GT_EQ] = ACTIONS(2930),
    [anon_sym_CARET] = ACTIONS(2930),
    [anon_sym_PLUS] = ACTIONS(2932),
    [anon_sym_SLASH] = ACTIONS(2930),
    [anon_sym_PERCENT] = ACTIONS(2930),
    [anon_sym_BANG] = ACTIONS(2932),
    [anon_sym_TILDE] = ACTIONS(2930),
    [sym_constant] = ACTIONS(2934),
    [sym_identifier] = ACTIONS(2936),
    [sym_instance_variable] = ACTIONS(2934),
    [sym_class_variable] = ACTIONS(2934),
    [sym_global_variable] = ACTIONS(2934),
    [anon_sym_DASH] = ACTIONS(2932),
    [anon_sym_PLUS_AT] = ACTIONS(2930),
    [anon_sym_DASH_AT] = ACTIONS(2930),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2932),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(2930),
    [anon_sym_BQUOTE] = ACTIONS(2930),
    [sym_comment] = ACTIONS(87),
  },
  [448] = {
    [sym_operator] = STATE(1644),
    [sym__method_name] = STATE(1644),
    [sym_setter] = STATE(1644),
    [sym_symbol] = STATE(1644),
    [sym__simple_symbol] = ACTIONS(547),
    [sym__symbol_start] = ACTIONS(549),
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_STAR] = ACTIONS(553),
    [anon_sym_STAR_STAR] = ACTIONS(551),
    [anon_sym_AMP] = ACTIONS(551),
    [anon_sym_LT] = ACTIONS(553),
    [anon_sym_DOT_DOT] = ACTIONS(551),
    [anon_sym_LT_LT] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(551),
    [anon_sym_EQ_EQ] = ACTIONS(553),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(551),
    [anon_sym_LT_EQ_GT] = ACTIONS(551),
    [anon_sym_EQ_TILDE] = ACTIONS(551),
    [anon_sym_BANG_TILDE] = ACTIONS(551),
    [anon_sym_LT_EQ] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(553),
    [anon_sym_GT_EQ] = ACTIONS(551),
    [anon_sym_CARET] = ACTIONS(551),
    [anon_sym_PLUS] = ACTIONS(553),
    [anon_sym_SLASH] = ACTIONS(551),
    [anon_sym_PERCENT] = ACTIONS(551),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(551),
    [sym_constant] = ACTIONS(2938),
    [sym_identifier] = ACTIONS(557),
    [sym_instance_variable] = ACTIONS(2938),
    [sym_class_variable] = ACTIONS(2938),
    [sym_global_variable] = ACTIONS(2938),
    [anon_sym_DASH] = ACTIONS(553),
    [anon_sym_PLUS_AT] = ACTIONS(551),
    [anon_sym_DASH_AT] = ACTIONS(551),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(553),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(551),
    [anon_sym_BQUOTE] = ACTIONS(551),
    [sym_comment] = ACTIONS(87),
  },
  [449] = {
    [sym__binary_minus] = ACTIONS(565),
    [sym__binary_star] = ACTIONS(565),
    [anon_sym_LBRACE] = ACTIONS(565),
    [anon_sym_RBRACE] = ACTIONS(565),
    [anon_sym_RPAREN] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(567),
    [anon_sym_COMMA] = ACTIONS(565),
    [anon_sym_PIPE] = ACTIONS(567),
    [anon_sym_SEMI] = ACTIONS(565),
    [anon_sym_STAR_STAR] = ACTIONS(567),
    [anon_sym_AMP] = ACTIONS(567),
    [anon_sym_EQ] = ACTIONS(567),
    [anon_sym_LT] = ACTIONS(567),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_unless] = ACTIONS(565),
    [anon_sym_while] = ACTIONS(565),
    [anon_sym_until] = ACTIONS(565),
    [anon_sym_rescue] = ACTIONS(565),
    [anon_sym_do] = ACTIONS(565),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_COLON_COLON2] = ACTIONS(565),
    [anon_sym_AMP_DOT] = ACTIONS(565),
    [anon_sym_PLUS_EQ] = ACTIONS(565),
    [anon_sym_DASH_EQ] = ACTIONS(565),
    [anon_sym_STAR_EQ] = ACTIONS(565),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(565),
    [anon_sym_SLASH_EQ] = ACTIONS(565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(565),
    [anon_sym_PIPE_EQ] = ACTIONS(565),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(565),
    [anon_sym_AMP_EQ] = ACTIONS(565),
    [anon_sym_PERCENT_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_LT_LT_EQ] = ACTIONS(565),
    [anon_sym_CARET_EQ] = ACTIONS(565),
    [anon_sym_QMARK] = ACTIONS(565),
    [anon_sym_COLON2] = ACTIONS(567),
    [anon_sym_DOT_DOT] = ACTIONS(567),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(565),
    [anon_sym_and] = ACTIONS(565),
    [anon_sym_or] = ACTIONS(565),
    [anon_sym_PIPE_PIPE] = ACTIONS(567),
    [anon_sym_AMP_AMP] = ACTIONS(567),
    [anon_sym_LT_LT] = ACTIONS(567),
    [anon_sym_GT_GT] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(565),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(565),
    [anon_sym_LT_EQ_GT] = ACTIONS(565),
    [anon_sym_EQ_TILDE] = ACTIONS(565),
    [anon_sym_BANG_TILDE] = ACTIONS(565),
    [anon_sym_LT_EQ] = ACTIONS(567),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_GT_EQ] = ACTIONS(565),
    [anon_sym_CARET] = ACTIONS(567),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_SLASH] = ACTIONS(567),
    [anon_sym_PERCENT] = ACTIONS(567),
    [sym_comment] = ACTIONS(87),
  },
  [450] = {
    [sym__binary_minus] = ACTIONS(569),
    [sym__binary_star] = ACTIONS(569),
    [anon_sym_LBRACE] = ACTIONS(569),
    [anon_sym_RBRACE] = ACTIONS(569),
    [anon_sym_RPAREN] = ACTIONS(569),
    [anon_sym_DOT] = ACTIONS(571),
    [anon_sym_COMMA] = ACTIONS(569),
    [anon_sym_PIPE] = ACTIONS(571),
    [anon_sym_SEMI] = ACTIONS(569),
    [anon_sym_STAR_STAR] = ACTIONS(571),
    [anon_sym_AMP] = ACTIONS(571),
    [anon_sym_EQ] = ACTIONS(571),
    [anon_sym_LT] = ACTIONS(571),
    [anon_sym_if] = ACTIONS(569),
    [anon_sym_unless] = ACTIONS(569),
    [anon_sym_while] = ACTIONS(569),
    [anon_sym_until] = ACTIONS(569),
    [anon_sym_rescue] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_LBRACK] = ACTIONS(569),
    [anon_sym_COLON_COLON2] = ACTIONS(569),
    [anon_sym_AMP_DOT] = ACTIONS(569),
    [anon_sym_PLUS_EQ] = ACTIONS(569),
    [anon_sym_DASH_EQ] = ACTIONS(569),
    [anon_sym_STAR_EQ] = ACTIONS(569),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(569),
    [anon_sym_SLASH_EQ] = ACTIONS(569),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(569),
    [anon_sym_PIPE_EQ] = ACTIONS(569),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(569),
    [anon_sym_AMP_EQ] = ACTIONS(569),
    [anon_sym_PERCENT_EQ] = ACTIONS(569),
    [anon_sym_GT_GT_EQ] = ACTIONS(569),
    [anon_sym_LT_LT_EQ] = ACTIONS(569),
    [anon_sym_CARET_EQ] = ACTIONS(569),
    [anon_sym_QMARK] = ACTIONS(569),
    [anon_sym_COLON2] = ACTIONS(571),
    [anon_sym_DOT_DOT] = ACTIONS(571),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(569),
    [anon_sym_and] = ACTIONS(569),
    [anon_sym_or] = ACTIONS(569),
    [anon_sym_PIPE_PIPE] = ACTIONS(571),
    [anon_sym_AMP_AMP] = ACTIONS(571),
    [anon_sym_LT_LT] = ACTIONS(571),
    [anon_sym_GT_GT] = ACTIONS(571),
    [anon_sym_EQ_EQ] = ACTIONS(571),
    [anon_sym_BANG_EQ] = ACTIONS(569),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(569),
    [anon_sym_LT_EQ_GT] = ACTIONS(569),
    [anon_sym_EQ_TILDE] = ACTIONS(569),
    [anon_sym_BANG_TILDE] = ACTIONS(569),
    [anon_sym_LT_EQ] = ACTIONS(571),
    [anon_sym_GT] = ACTIONS(571),
    [anon_sym_GT_EQ] = ACTIONS(569),
    [anon_sym_CARET] = ACTIONS(571),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_SLASH] = ACTIONS(571),
    [anon_sym_PERCENT] = ACTIONS(571),
    [sym_comment] = ACTIONS(87),
  },
  [451] = {
    [sym__binary_minus] = ACTIONS(573),
    [sym__binary_star] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(573),
    [anon_sym_RBRACE] = ACTIONS(573),
    [anon_sym_RPAREN] = ACTIONS(573),
    [anon_sym_DOT] = ACTIONS(575),
    [anon_sym_COMMA] = ACTIONS(573),
    [anon_sym_PIPE] = ACTIONS(575),
    [anon_sym_SEMI] = ACTIONS(573),
    [anon_sym_STAR_STAR] = ACTIONS(575),
    [anon_sym_AMP] = ACTIONS(575),
    [anon_sym_EQ] = ACTIONS(575),
    [anon_sym_LT] = ACTIONS(575),
    [anon_sym_if] = ACTIONS(573),
    [anon_sym_unless] = ACTIONS(573),
    [anon_sym_while] = ACTIONS(573),
    [anon_sym_until] = ACTIONS(573),
    [anon_sym_rescue] = ACTIONS(573),
    [anon_sym_do] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(573),
    [anon_sym_COLON_COLON2] = ACTIONS(573),
    [anon_sym_AMP_DOT] = ACTIONS(573),
    [anon_sym_PLUS_EQ] = ACTIONS(573),
    [anon_sym_DASH_EQ] = ACTIONS(573),
    [anon_sym_STAR_EQ] = ACTIONS(573),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(573),
    [anon_sym_SLASH_EQ] = ACTIONS(573),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(573),
    [anon_sym_PIPE_EQ] = ACTIONS(573),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(573),
    [anon_sym_AMP_EQ] = ACTIONS(573),
    [anon_sym_PERCENT_EQ] = ACTIONS(573),
    [anon_sym_GT_GT_EQ] = ACTIONS(573),
    [anon_sym_LT_LT_EQ] = ACTIONS(573),
    [anon_sym_CARET_EQ] = ACTIONS(573),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_COLON2] = ACTIONS(575),
    [anon_sym_DOT_DOT] = ACTIONS(575),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(573),
    [anon_sym_and] = ACTIONS(573),
    [anon_sym_or] = ACTIONS(573),
    [anon_sym_PIPE_PIPE] = ACTIONS(575),
    [anon_sym_AMP_AMP] = ACTIONS(575),
    [anon_sym_LT_LT] = ACTIONS(575),
    [anon_sym_GT_GT] = ACTIONS(575),
    [anon_sym_EQ_EQ] = ACTIONS(575),
    [anon_sym_BANG_EQ] = ACTIONS(573),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(573),
    [anon_sym_LT_EQ_GT] = ACTIONS(573),
    [anon_sym_EQ_TILDE] = ACTIONS(573),
    [anon_sym_BANG_TILDE] = ACTIONS(573),
    [anon_sym_LT_EQ] = ACTIONS(575),
    [anon_sym_GT] = ACTIONS(575),
    [anon_sym_GT_EQ] = ACTIONS(573),
    [anon_sym_CARET] = ACTIONS(575),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(575),
    [anon_sym_PERCENT] = ACTIONS(575),
    [sym_comment] = ACTIONS(87),
  },
  [452] = {
    [anon_sym_RBRACE] = ACTIONS(2940),
    [anon_sym_if] = ACTIONS(2942),
    [anon_sym_unless] = ACTIONS(2944),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_until] = ACTIONS(2948),
    [anon_sym_rescue] = ACTIONS(2950),
    [sym_comment] = ACTIONS(87),
  },
  [453] = {
    [sym__binary_minus] = ACTIONS(2952),
    [sym__binary_star] = ACTIONS(2954),
    [anon_sym_RBRACE] = ACTIONS(701),
    [anon_sym_PIPE] = ACTIONS(2956),
    [anon_sym_STAR_STAR] = ACTIONS(2954),
    [anon_sym_AMP] = ACTIONS(2958),
    [anon_sym_LT] = ACTIONS(2960),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_unless] = ACTIONS(701),
    [anon_sym_while] = ACTIONS(701),
    [anon_sym_until] = ACTIONS(701),
    [anon_sym_rescue] = ACTIONS(701),
    [anon_sym_QMARK] = ACTIONS(2962),
    [anon_sym_DOT_DOT] = ACTIONS(2964),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2966),
    [anon_sym_and] = ACTIONS(2968),
    [anon_sym_or] = ACTIONS(2968),
    [anon_sym_PIPE_PIPE] = ACTIONS(2970),
    [anon_sym_AMP_AMP] = ACTIONS(2970),
    [anon_sym_LT_LT] = ACTIONS(2972),
    [anon_sym_GT_GT] = ACTIONS(2972),
    [anon_sym_EQ_EQ] = ACTIONS(2974),
    [anon_sym_BANG_EQ] = ACTIONS(2970),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2970),
    [anon_sym_LT_EQ_GT] = ACTIONS(2970),
    [anon_sym_EQ_TILDE] = ACTIONS(2970),
    [anon_sym_BANG_TILDE] = ACTIONS(2970),
    [anon_sym_LT_EQ] = ACTIONS(2960),
    [anon_sym_GT] = ACTIONS(2960),
    [anon_sym_GT_EQ] = ACTIONS(2976),
    [anon_sym_CARET] = ACTIONS(2978),
    [anon_sym_PLUS] = ACTIONS(2952),
    [anon_sym_SLASH] = ACTIONS(2954),
    [anon_sym_PERCENT] = ACTIONS(2954),
    [sym_comment] = ACTIONS(87),
  },
  [454] = {
    [sym__binary_minus] = ACTIONS(731),
    [sym__binary_star] = ACTIONS(731),
    [anon_sym_LBRACE] = ACTIONS(731),
    [anon_sym_RBRACE] = ACTIONS(731),
    [anon_sym_RPAREN] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(2980),
    [anon_sym_COMMA] = ACTIONS(731),
    [anon_sym_PIPE] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(731),
    [anon_sym_STAR_STAR] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(735),
    [anon_sym_if] = ACTIONS(731),
    [anon_sym_unless] = ACTIONS(731),
    [anon_sym_while] = ACTIONS(731),
    [anon_sym_until] = ACTIONS(731),
    [anon_sym_rescue] = ACTIONS(731),
    [anon_sym_do] = ACTIONS(731),
    [anon_sym_LBRACK] = ACTIONS(2982),
    [anon_sym_COLON_COLON2] = ACTIONS(2984),
    [anon_sym_AMP_DOT] = ACTIONS(2986),
    [anon_sym_QMARK] = ACTIONS(731),
    [anon_sym_COLON2] = ACTIONS(735),
    [anon_sym_DOT_DOT] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(731),
    [anon_sym_or] = ACTIONS(731),
    [anon_sym_PIPE_PIPE] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(731),
    [anon_sym_LT_LT] = ACTIONS(731),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_EQ_EQ] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(731),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(731),
    [anon_sym_LT_EQ_GT] = ACTIONS(731),
    [anon_sym_EQ_TILDE] = ACTIONS(731),
    [anon_sym_BANG_TILDE] = ACTIONS(731),
    [anon_sym_LT_EQ] = ACTIONS(735),
    [anon_sym_GT] = ACTIONS(735),
    [anon_sym_GT_EQ] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(731),
    [anon_sym_SLASH] = ACTIONS(731),
    [anon_sym_PERCENT] = ACTIONS(731),
    [sym_comment] = ACTIONS(87),
  },
  [455] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1679),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1686),
    [sym_scope_resolution] = STATE(1680),
    [sym_call] = STATE(1680),
    [sym_method_call] = STATE(1686),
    [sym_argument_list] = STATE(1681),
    [sym__argument_list_with_parens] = STATE(1682),
    [sym__argument] = STATE(1683),
    [sym_splat_argument] = STATE(1683),
    [sym_hash_splat_argument] = STATE(1683),
    [sym_block_argument] = STATE(1683),
    [sym_do_block] = STATE(1684),
    [sym_block] = STATE(1684),
    [sym_assignment] = STATE(1679),
    [sym_operator_assignment] = STATE(1679),
    [sym_conditional] = STATE(1679),
    [sym_range] = STATE(1679),
    [sym_binary] = STATE(1679),
    [sym_unary] = STATE(1679),
    [sym_left_assignment_list] = STATE(1685),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1686),
    [sym__variable] = STATE(1680),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1686),
    [sym_false] = STATE(1686),
    [sym_nil] = STATE(1686),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1687),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(1683),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(2988),
    [sym__splat_star] = ACTIONS(2990),
    [sym__unary_minus] = ACTIONS(2992),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(2994),
    [anon_sym_LBRACE] = ACTIONS(2996),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2998),
    [anon_sym_yield] = ACTIONS(3000),
    [anon_sym_break] = ACTIONS(3002),
    [anon_sym_next] = ACTIONS(3004),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(769),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(769),
    [anon_sym_until] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(769),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(3006),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(3010),
    [anon_sym_not] = ACTIONS(3012),
    [anon_sym_BANG] = ACTIONS(3014),
    [anon_sym_TILDE] = ACTIONS(3016),
    [sym_constant] = ACTIONS(3018),
    [sym_identifier] = ACTIONS(3018),
    [sym_instance_variable] = ACTIONS(3020),
    [sym_class_variable] = ACTIONS(3020),
    [sym_global_variable] = ACTIONS(3020),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3022),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3022),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [456] = {
    [anon_sym_EQ] = ACTIONS(3024),
    [sym_comment] = ACTIONS(87),
  },
  [457] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(3026),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(3028),
    [anon_sym_DASH_EQ] = ACTIONS(3028),
    [anon_sym_STAR_EQ] = ACTIONS(3028),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3028),
    [anon_sym_SLASH_EQ] = ACTIONS(3028),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3028),
    [anon_sym_PIPE_EQ] = ACTIONS(3028),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3028),
    [anon_sym_AMP_EQ] = ACTIONS(3028),
    [anon_sym_PERCENT_EQ] = ACTIONS(3028),
    [anon_sym_GT_GT_EQ] = ACTIONS(3028),
    [anon_sym_LT_LT_EQ] = ACTIONS(3028),
    [anon_sym_CARET_EQ] = ACTIONS(3028),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [458] = {
    [sym_string] = STATE(1690),
    [aux_sym_chained_string_repeat1] = STATE(1690),
    [sym__string_start] = ACTIONS(139),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [459] = {
    [sym__line_break] = ACTIONS(3030),
    [sym__string_start] = ACTIONS(3030),
    [sym__heredoc_body_start] = ACTIONS(3030),
    [sym__binary_minus] = ACTIONS(3030),
    [sym__binary_star] = ACTIONS(3030),
    [ts_builtin_sym_end] = ACTIONS(3030),
    [anon_sym___END__] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3030),
    [anon_sym_RBRACE] = ACTIONS(3030),
    [anon_sym_RPAREN] = ACTIONS(3030),
    [anon_sym_DOT] = ACTIONS(3032),
    [anon_sym_COMMA] = ACTIONS(3030),
    [anon_sym_PIPE] = ACTIONS(3032),
    [anon_sym_SEMI] = ACTIONS(3030),
    [anon_sym_STAR_STAR] = ACTIONS(3030),
    [anon_sym_AMP] = ACTIONS(3032),
    [anon_sym_COLON] = ACTIONS(3032),
    [anon_sym_LT] = ACTIONS(3032),
    [anon_sym_end] = ACTIONS(3030),
    [anon_sym_if] = ACTIONS(3030),
    [anon_sym_unless] = ACTIONS(3030),
    [anon_sym_while] = ACTIONS(3030),
    [anon_sym_until] = ACTIONS(3030),
    [anon_sym_rescue] = ACTIONS(3030),
    [anon_sym_do] = ACTIONS(3030),
    [anon_sym_when] = ACTIONS(3030),
    [anon_sym_elsif] = ACTIONS(3030),
    [anon_sym_else] = ACTIONS(3030),
    [anon_sym_then] = ACTIONS(3030),
    [anon_sym_ensure] = ACTIONS(3030),
    [anon_sym_EQ_GT] = ACTIONS(3030),
    [anon_sym_LBRACK] = ACTIONS(3030),
    [anon_sym_COLON_COLON2] = ACTIONS(3030),
    [anon_sym_AMP_DOT] = ACTIONS(3030),
    [anon_sym_QMARK] = ACTIONS(3030),
    [anon_sym_DOT_DOT] = ACTIONS(3032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3030),
    [anon_sym_and] = ACTIONS(3030),
    [anon_sym_or] = ACTIONS(3030),
    [anon_sym_PIPE_PIPE] = ACTIONS(3030),
    [anon_sym_AMP_AMP] = ACTIONS(3030),
    [anon_sym_LT_LT] = ACTIONS(3030),
    [anon_sym_GT_GT] = ACTIONS(3030),
    [anon_sym_EQ_EQ] = ACTIONS(3032),
    [anon_sym_BANG_EQ] = ACTIONS(3030),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3030),
    [anon_sym_LT_EQ_GT] = ACTIONS(3030),
    [anon_sym_EQ_TILDE] = ACTIONS(3030),
    [anon_sym_BANG_TILDE] = ACTIONS(3030),
    [anon_sym_LT_EQ] = ACTIONS(3032),
    [anon_sym_GT] = ACTIONS(3032),
    [anon_sym_GT_EQ] = ACTIONS(3030),
    [anon_sym_CARET] = ACTIONS(3030),
    [anon_sym_PLUS] = ACTIONS(3030),
    [anon_sym_SLASH] = ACTIONS(3030),
    [anon_sym_PERCENT] = ACTIONS(3030),
    [sym_comment] = ACTIONS(87),
  },
  [460] = {
    [sym_interpolation] = STATE(460),
    [aux_sym__literal_contents_repeat1] = STATE(460),
    [sym__string_content] = ACTIONS(3034),
    [sym__string_end] = ACTIONS(3037),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(3039),
    [sym_escape_sequence] = ACTIONS(3034),
  },
  [461] = {
    [sym__line_break] = ACTIONS(3042),
    [sym__heredoc_body_start] = ACTIONS(3042),
    [sym__binary_minus] = ACTIONS(3042),
    [sym__binary_star] = ACTIONS(3042),
    [ts_builtin_sym_end] = ACTIONS(3042),
    [anon_sym___END__] = ACTIONS(3042),
    [anon_sym_LBRACE] = ACTIONS(3042),
    [anon_sym_RBRACE] = ACTIONS(3042),
    [anon_sym_RPAREN] = ACTIONS(3042),
    [anon_sym_DOT] = ACTIONS(3044),
    [anon_sym_COMMA] = ACTIONS(3042),
    [anon_sym_PIPE] = ACTIONS(3044),
    [anon_sym_SEMI] = ACTIONS(3042),
    [anon_sym_STAR_STAR] = ACTIONS(3042),
    [anon_sym_AMP] = ACTIONS(3044),
    [anon_sym_LT] = ACTIONS(3044),
    [anon_sym_end] = ACTIONS(3042),
    [anon_sym_if] = ACTIONS(3042),
    [anon_sym_unless] = ACTIONS(3042),
    [anon_sym_while] = ACTIONS(3042),
    [anon_sym_until] = ACTIONS(3042),
    [anon_sym_rescue] = ACTIONS(3042),
    [anon_sym_do] = ACTIONS(3042),
    [anon_sym_when] = ACTIONS(3042),
    [anon_sym_elsif] = ACTIONS(3042),
    [anon_sym_else] = ACTIONS(3042),
    [anon_sym_then] = ACTIONS(3042),
    [anon_sym_ensure] = ACTIONS(3042),
    [anon_sym_EQ_GT] = ACTIONS(3042),
    [anon_sym_LBRACK] = ACTIONS(3042),
    [anon_sym_COLON_COLON2] = ACTIONS(3042),
    [anon_sym_AMP_DOT] = ACTIONS(3042),
    [anon_sym_QMARK] = ACTIONS(3042),
    [anon_sym_DOT_DOT] = ACTIONS(3044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3042),
    [anon_sym_and] = ACTIONS(3042),
    [anon_sym_or] = ACTIONS(3042),
    [anon_sym_PIPE_PIPE] = ACTIONS(3042),
    [anon_sym_AMP_AMP] = ACTIONS(3042),
    [anon_sym_LT_LT] = ACTIONS(3042),
    [anon_sym_GT_GT] = ACTIONS(3042),
    [anon_sym_EQ_EQ] = ACTIONS(3044),
    [anon_sym_BANG_EQ] = ACTIONS(3042),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3042),
    [anon_sym_LT_EQ_GT] = ACTIONS(3042),
    [anon_sym_EQ_TILDE] = ACTIONS(3042),
    [anon_sym_BANG_TILDE] = ACTIONS(3042),
    [anon_sym_LT_EQ] = ACTIONS(3044),
    [anon_sym_GT] = ACTIONS(3044),
    [anon_sym_GT_EQ] = ACTIONS(3042),
    [anon_sym_CARET] = ACTIONS(3042),
    [anon_sym_PLUS] = ACTIONS(3042),
    [anon_sym_SLASH] = ACTIONS(3042),
    [anon_sym_PERCENT] = ACTIONS(3042),
    [sym_comment] = ACTIONS(87),
  },
  [462] = {
    [sym__line_break] = ACTIONS(3046),
    [sym__heredoc_body_start] = ACTIONS(3046),
    [sym__binary_minus] = ACTIONS(3046),
    [sym__binary_star] = ACTIONS(3046),
    [ts_builtin_sym_end] = ACTIONS(3046),
    [anon_sym___END__] = ACTIONS(3046),
    [anon_sym_LBRACE] = ACTIONS(3046),
    [anon_sym_RBRACE] = ACTIONS(3046),
    [anon_sym_RPAREN] = ACTIONS(3046),
    [anon_sym_DOT] = ACTIONS(3048),
    [anon_sym_COMMA] = ACTIONS(3046),
    [anon_sym_PIPE] = ACTIONS(3048),
    [anon_sym_SEMI] = ACTIONS(3046),
    [anon_sym_STAR_STAR] = ACTIONS(3046),
    [anon_sym_AMP] = ACTIONS(3048),
    [anon_sym_LT] = ACTIONS(3048),
    [anon_sym_end] = ACTIONS(3046),
    [anon_sym_if] = ACTIONS(3046),
    [anon_sym_unless] = ACTIONS(3046),
    [anon_sym_while] = ACTIONS(3046),
    [anon_sym_until] = ACTIONS(3046),
    [anon_sym_rescue] = ACTIONS(3046),
    [anon_sym_do] = ACTIONS(3046),
    [anon_sym_when] = ACTIONS(3046),
    [anon_sym_elsif] = ACTIONS(3046),
    [anon_sym_else] = ACTIONS(3046),
    [anon_sym_then] = ACTIONS(3046),
    [anon_sym_ensure] = ACTIONS(3046),
    [anon_sym_EQ_GT] = ACTIONS(3046),
    [anon_sym_LBRACK] = ACTIONS(3046),
    [anon_sym_COLON_COLON2] = ACTIONS(3046),
    [anon_sym_AMP_DOT] = ACTIONS(3046),
    [anon_sym_QMARK] = ACTIONS(3046),
    [anon_sym_DOT_DOT] = ACTIONS(3048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3046),
    [anon_sym_and] = ACTIONS(3046),
    [anon_sym_or] = ACTIONS(3046),
    [anon_sym_PIPE_PIPE] = ACTIONS(3046),
    [anon_sym_AMP_AMP] = ACTIONS(3046),
    [anon_sym_LT_LT] = ACTIONS(3046),
    [anon_sym_GT_GT] = ACTIONS(3046),
    [anon_sym_EQ_EQ] = ACTIONS(3048),
    [anon_sym_BANG_EQ] = ACTIONS(3046),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3046),
    [anon_sym_LT_EQ_GT] = ACTIONS(3046),
    [anon_sym_EQ_TILDE] = ACTIONS(3046),
    [anon_sym_BANG_TILDE] = ACTIONS(3046),
    [anon_sym_LT_EQ] = ACTIONS(3048),
    [anon_sym_GT] = ACTIONS(3048),
    [anon_sym_GT_EQ] = ACTIONS(3046),
    [anon_sym_CARET] = ACTIONS(3046),
    [anon_sym_PLUS] = ACTIONS(3046),
    [anon_sym_SLASH] = ACTIONS(3046),
    [anon_sym_PERCENT] = ACTIONS(3046),
    [sym_comment] = ACTIONS(87),
  },
  [463] = {
    [sym__line_break] = ACTIONS(3050),
    [sym__heredoc_body_start] = ACTIONS(3050),
    [sym__binary_minus] = ACTIONS(3050),
    [sym__binary_star] = ACTIONS(3050),
    [ts_builtin_sym_end] = ACTIONS(3050),
    [anon_sym___END__] = ACTIONS(3050),
    [anon_sym_LBRACE] = ACTIONS(3050),
    [anon_sym_RBRACE] = ACTIONS(3050),
    [anon_sym_RPAREN] = ACTIONS(3050),
    [anon_sym_DOT] = ACTIONS(3052),
    [anon_sym_COMMA] = ACTIONS(3050),
    [anon_sym_PIPE] = ACTIONS(3052),
    [anon_sym_SEMI] = ACTIONS(3050),
    [anon_sym_STAR_STAR] = ACTIONS(3050),
    [anon_sym_AMP] = ACTIONS(3052),
    [anon_sym_LT] = ACTIONS(3052),
    [anon_sym_end] = ACTIONS(3050),
    [anon_sym_if] = ACTIONS(3050),
    [anon_sym_unless] = ACTIONS(3050),
    [anon_sym_while] = ACTIONS(3050),
    [anon_sym_until] = ACTIONS(3050),
    [anon_sym_rescue] = ACTIONS(3050),
    [anon_sym_do] = ACTIONS(3050),
    [anon_sym_when] = ACTIONS(3050),
    [anon_sym_elsif] = ACTIONS(3050),
    [anon_sym_else] = ACTIONS(3050),
    [anon_sym_then] = ACTIONS(3050),
    [anon_sym_ensure] = ACTIONS(3050),
    [anon_sym_EQ_GT] = ACTIONS(3050),
    [anon_sym_LBRACK] = ACTIONS(3050),
    [anon_sym_COLON_COLON2] = ACTIONS(3050),
    [anon_sym_AMP_DOT] = ACTIONS(3050),
    [anon_sym_QMARK] = ACTIONS(3050),
    [anon_sym_DOT_DOT] = ACTIONS(3052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3050),
    [anon_sym_and] = ACTIONS(3050),
    [anon_sym_or] = ACTIONS(3050),
    [anon_sym_PIPE_PIPE] = ACTIONS(3050),
    [anon_sym_AMP_AMP] = ACTIONS(3050),
    [anon_sym_LT_LT] = ACTIONS(3050),
    [anon_sym_GT_GT] = ACTIONS(3050),
    [anon_sym_EQ_EQ] = ACTIONS(3052),
    [anon_sym_BANG_EQ] = ACTIONS(3050),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3050),
    [anon_sym_LT_EQ_GT] = ACTIONS(3050),
    [anon_sym_EQ_TILDE] = ACTIONS(3050),
    [anon_sym_BANG_TILDE] = ACTIONS(3050),
    [anon_sym_LT_EQ] = ACTIONS(3052),
    [anon_sym_GT] = ACTIONS(3052),
    [anon_sym_GT_EQ] = ACTIONS(3050),
    [anon_sym_CARET] = ACTIONS(3050),
    [anon_sym_PLUS] = ACTIONS(3050),
    [anon_sym_SLASH] = ACTIONS(3050),
    [anon_sym_PERCENT] = ACTIONS(3050),
    [sym_comment] = ACTIONS(87),
  },
  [464] = {
    [anon_sym_RBRACE] = ACTIONS(3054),
    [anon_sym_if] = ACTIONS(2942),
    [anon_sym_unless] = ACTIONS(2944),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_until] = ACTIONS(2948),
    [anon_sym_rescue] = ACTIONS(2950),
    [sym_comment] = ACTIONS(87),
  },
  [465] = {
    [sym__line_break] = ACTIONS(3056),
    [sym__heredoc_body_start] = ACTIONS(3056),
    [sym__binary_minus] = ACTIONS(3056),
    [sym__binary_star] = ACTIONS(3056),
    [ts_builtin_sym_end] = ACTIONS(3056),
    [anon_sym___END__] = ACTIONS(3056),
    [anon_sym_LBRACE] = ACTIONS(3056),
    [anon_sym_RBRACE] = ACTIONS(3056),
    [anon_sym_RPAREN] = ACTIONS(3056),
    [anon_sym_DOT] = ACTIONS(3058),
    [anon_sym_COMMA] = ACTIONS(3056),
    [anon_sym_PIPE] = ACTIONS(3058),
    [anon_sym_SEMI] = ACTIONS(3056),
    [anon_sym_STAR_STAR] = ACTIONS(3056),
    [anon_sym_AMP] = ACTIONS(3058),
    [anon_sym_LT] = ACTIONS(3058),
    [anon_sym_end] = ACTIONS(3056),
    [anon_sym_if] = ACTIONS(3056),
    [anon_sym_unless] = ACTIONS(3056),
    [anon_sym_while] = ACTIONS(3056),
    [anon_sym_until] = ACTIONS(3056),
    [anon_sym_rescue] = ACTIONS(3056),
    [anon_sym_do] = ACTIONS(3056),
    [anon_sym_when] = ACTIONS(3056),
    [anon_sym_elsif] = ACTIONS(3056),
    [anon_sym_else] = ACTIONS(3056),
    [anon_sym_then] = ACTIONS(3056),
    [anon_sym_ensure] = ACTIONS(3056),
    [anon_sym_EQ_GT] = ACTIONS(3056),
    [anon_sym_LBRACK] = ACTIONS(3056),
    [anon_sym_COLON_COLON2] = ACTIONS(3056),
    [anon_sym_AMP_DOT] = ACTIONS(3056),
    [anon_sym_QMARK] = ACTIONS(3056),
    [anon_sym_DOT_DOT] = ACTIONS(3058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3056),
    [anon_sym_and] = ACTIONS(3056),
    [anon_sym_or] = ACTIONS(3056),
    [anon_sym_PIPE_PIPE] = ACTIONS(3056),
    [anon_sym_AMP_AMP] = ACTIONS(3056),
    [anon_sym_LT_LT] = ACTIONS(3056),
    [anon_sym_GT_GT] = ACTIONS(3056),
    [anon_sym_EQ_EQ] = ACTIONS(3058),
    [anon_sym_BANG_EQ] = ACTIONS(3056),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3056),
    [anon_sym_LT_EQ_GT] = ACTIONS(3056),
    [anon_sym_EQ_TILDE] = ACTIONS(3056),
    [anon_sym_BANG_TILDE] = ACTIONS(3056),
    [anon_sym_LT_EQ] = ACTIONS(3058),
    [anon_sym_GT] = ACTIONS(3058),
    [anon_sym_GT_EQ] = ACTIONS(3056),
    [anon_sym_CARET] = ACTIONS(3056),
    [anon_sym_PLUS] = ACTIONS(3056),
    [anon_sym_SLASH] = ACTIONS(3056),
    [anon_sym_PERCENT] = ACTIONS(3056),
    [sym_comment] = ACTIONS(87),
  },
  [466] = {
    [sym__string_end] = ACTIONS(3060),
    [sym_comment] = ACTIONS(87),
  },
  [467] = {
    [aux_sym_string_array_repeat1] = STATE(1695),
    [sym__string_end] = ACTIONS(3062),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(3064),
  },
  [468] = {
    [sym__line_break] = ACTIONS(3066),
    [sym__heredoc_body_start] = ACTIONS(3066),
    [sym__binary_minus] = ACTIONS(3066),
    [sym__binary_star] = ACTIONS(3066),
    [ts_builtin_sym_end] = ACTIONS(3066),
    [anon_sym___END__] = ACTIONS(3066),
    [anon_sym_LBRACE] = ACTIONS(3066),
    [anon_sym_RBRACE] = ACTIONS(3066),
    [anon_sym_RPAREN] = ACTIONS(3066),
    [anon_sym_DOT] = ACTIONS(3068),
    [anon_sym_COMMA] = ACTIONS(3066),
    [anon_sym_PIPE] = ACTIONS(3068),
    [anon_sym_SEMI] = ACTIONS(3066),
    [anon_sym_STAR_STAR] = ACTIONS(3066),
    [anon_sym_AMP] = ACTIONS(3068),
    [anon_sym_LT] = ACTIONS(3068),
    [anon_sym_end] = ACTIONS(3066),
    [anon_sym_if] = ACTIONS(3066),
    [anon_sym_unless] = ACTIONS(3066),
    [anon_sym_while] = ACTIONS(3066),
    [anon_sym_until] = ACTIONS(3066),
    [anon_sym_rescue] = ACTIONS(3066),
    [anon_sym_do] = ACTIONS(3066),
    [anon_sym_when] = ACTIONS(3066),
    [anon_sym_elsif] = ACTIONS(3066),
    [anon_sym_else] = ACTIONS(3066),
    [anon_sym_then] = ACTIONS(3066),
    [anon_sym_ensure] = ACTIONS(3066),
    [anon_sym_EQ_GT] = ACTIONS(3066),
    [anon_sym_LBRACK] = ACTIONS(3066),
    [anon_sym_COLON_COLON2] = ACTIONS(3066),
    [anon_sym_AMP_DOT] = ACTIONS(3066),
    [anon_sym_QMARK] = ACTIONS(3066),
    [anon_sym_DOT_DOT] = ACTIONS(3068),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3066),
    [anon_sym_and] = ACTIONS(3066),
    [anon_sym_or] = ACTIONS(3066),
    [anon_sym_PIPE_PIPE] = ACTIONS(3066),
    [anon_sym_AMP_AMP] = ACTIONS(3066),
    [anon_sym_LT_LT] = ACTIONS(3066),
    [anon_sym_GT_GT] = ACTIONS(3066),
    [anon_sym_EQ_EQ] = ACTIONS(3068),
    [anon_sym_BANG_EQ] = ACTIONS(3066),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3066),
    [anon_sym_LT_EQ_GT] = ACTIONS(3066),
    [anon_sym_EQ_TILDE] = ACTIONS(3066),
    [anon_sym_BANG_TILDE] = ACTIONS(3066),
    [anon_sym_LT_EQ] = ACTIONS(3068),
    [anon_sym_GT] = ACTIONS(3068),
    [anon_sym_GT_EQ] = ACTIONS(3066),
    [anon_sym_CARET] = ACTIONS(3066),
    [anon_sym_PLUS] = ACTIONS(3066),
    [anon_sym_SLASH] = ACTIONS(3066),
    [anon_sym_PERCENT] = ACTIONS(3066),
    [sym_comment] = ACTIONS(87),
  },
  [469] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1697),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(3070),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [470] = {
    [aux_sym_string_array_repeat1] = STATE(1699),
    [sym__string_end] = ACTIONS(3070),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(3072),
  },
  [471] = {
    [sym_interpolation] = STATE(471),
    [aux_sym__literal_contents_repeat1] = STATE(471),
    [sym__string_content] = ACTIONS(3074),
    [sym__string_end] = ACTIONS(3037),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(3077),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(3080),
    [sym_escape_sequence] = ACTIONS(3082),
  },
  [472] = {
    [sym__line_break] = ACTIONS(3085),
    [sym__heredoc_body_start] = ACTIONS(3085),
    [sym__binary_minus] = ACTIONS(3085),
    [sym__binary_star] = ACTIONS(3085),
    [ts_builtin_sym_end] = ACTIONS(3085),
    [anon_sym___END__] = ACTIONS(3085),
    [anon_sym_LBRACE] = ACTIONS(3085),
    [anon_sym_RBRACE] = ACTIONS(3085),
    [anon_sym_RPAREN] = ACTIONS(3085),
    [anon_sym_DOT] = ACTIONS(3087),
    [anon_sym_COMMA] = ACTIONS(3085),
    [anon_sym_PIPE] = ACTIONS(3087),
    [anon_sym_SEMI] = ACTIONS(3085),
    [anon_sym_STAR_STAR] = ACTIONS(3085),
    [anon_sym_AMP] = ACTIONS(3087),
    [anon_sym_LT] = ACTIONS(3087),
    [anon_sym_end] = ACTIONS(3085),
    [anon_sym_if] = ACTIONS(3085),
    [anon_sym_unless] = ACTIONS(3085),
    [anon_sym_while] = ACTIONS(3085),
    [anon_sym_until] = ACTIONS(3085),
    [anon_sym_rescue] = ACTIONS(3085),
    [anon_sym_do] = ACTIONS(3085),
    [anon_sym_when] = ACTIONS(3085),
    [anon_sym_elsif] = ACTIONS(3085),
    [anon_sym_else] = ACTIONS(3085),
    [anon_sym_then] = ACTIONS(3085),
    [anon_sym_ensure] = ACTIONS(3085),
    [anon_sym_EQ_GT] = ACTIONS(3085),
    [anon_sym_LBRACK] = ACTIONS(3085),
    [anon_sym_COLON_COLON2] = ACTIONS(3085),
    [anon_sym_AMP_DOT] = ACTIONS(3085),
    [anon_sym_QMARK] = ACTIONS(3085),
    [anon_sym_DOT_DOT] = ACTIONS(3087),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3085),
    [anon_sym_and] = ACTIONS(3085),
    [anon_sym_or] = ACTIONS(3085),
    [anon_sym_PIPE_PIPE] = ACTIONS(3085),
    [anon_sym_AMP_AMP] = ACTIONS(3085),
    [anon_sym_LT_LT] = ACTIONS(3085),
    [anon_sym_GT_GT] = ACTIONS(3085),
    [anon_sym_EQ_EQ] = ACTIONS(3087),
    [anon_sym_BANG_EQ] = ACTIONS(3085),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3085),
    [anon_sym_LT_EQ_GT] = ACTIONS(3085),
    [anon_sym_EQ_TILDE] = ACTIONS(3085),
    [anon_sym_BANG_TILDE] = ACTIONS(3085),
    [anon_sym_LT_EQ] = ACTIONS(3087),
    [anon_sym_GT] = ACTIONS(3087),
    [anon_sym_GT_EQ] = ACTIONS(3085),
    [anon_sym_CARET] = ACTIONS(3085),
    [anon_sym_PLUS] = ACTIONS(3085),
    [anon_sym_SLASH] = ACTIONS(3085),
    [anon_sym_PERCENT] = ACTIONS(3085),
    [sym_comment] = ACTIONS(87),
  },
  [473] = {
    [sym__string_end] = ACTIONS(3089),
    [sym_comment] = ACTIONS(87),
  },
  [474] = {
    [aux_sym_symbol_array_repeat1] = STATE(1703),
    [sym__string_end] = ACTIONS(3091),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(3093),
  },
  [475] = {
    [sym__line_break] = ACTIONS(3095),
    [sym__heredoc_body_start] = ACTIONS(3095),
    [sym__binary_minus] = ACTIONS(3095),
    [sym__binary_star] = ACTIONS(3095),
    [ts_builtin_sym_end] = ACTIONS(3095),
    [anon_sym___END__] = ACTIONS(3095),
    [anon_sym_LBRACE] = ACTIONS(3095),
    [anon_sym_RBRACE] = ACTIONS(3095),
    [anon_sym_RPAREN] = ACTIONS(3095),
    [anon_sym_DOT] = ACTIONS(3097),
    [anon_sym_COMMA] = ACTIONS(3095),
    [anon_sym_PIPE] = ACTIONS(3097),
    [anon_sym_SEMI] = ACTIONS(3095),
    [anon_sym_STAR_STAR] = ACTIONS(3095),
    [anon_sym_AMP] = ACTIONS(3097),
    [anon_sym_LT] = ACTIONS(3097),
    [anon_sym_end] = ACTIONS(3095),
    [anon_sym_if] = ACTIONS(3095),
    [anon_sym_unless] = ACTIONS(3095),
    [anon_sym_while] = ACTIONS(3095),
    [anon_sym_until] = ACTIONS(3095),
    [anon_sym_rescue] = ACTIONS(3095),
    [anon_sym_do] = ACTIONS(3095),
    [anon_sym_when] = ACTIONS(3095),
    [anon_sym_elsif] = ACTIONS(3095),
    [anon_sym_else] = ACTIONS(3095),
    [anon_sym_then] = ACTIONS(3095),
    [anon_sym_ensure] = ACTIONS(3095),
    [anon_sym_EQ_GT] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3095),
    [anon_sym_COLON_COLON2] = ACTIONS(3095),
    [anon_sym_AMP_DOT] = ACTIONS(3095),
    [anon_sym_QMARK] = ACTIONS(3095),
    [anon_sym_DOT_DOT] = ACTIONS(3097),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3095),
    [anon_sym_and] = ACTIONS(3095),
    [anon_sym_or] = ACTIONS(3095),
    [anon_sym_PIPE_PIPE] = ACTIONS(3095),
    [anon_sym_AMP_AMP] = ACTIONS(3095),
    [anon_sym_LT_LT] = ACTIONS(3095),
    [anon_sym_GT_GT] = ACTIONS(3095),
    [anon_sym_EQ_EQ] = ACTIONS(3097),
    [anon_sym_BANG_EQ] = ACTIONS(3095),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3095),
    [anon_sym_LT_EQ_GT] = ACTIONS(3095),
    [anon_sym_EQ_TILDE] = ACTIONS(3095),
    [anon_sym_BANG_TILDE] = ACTIONS(3095),
    [anon_sym_LT_EQ] = ACTIONS(3097),
    [anon_sym_GT] = ACTIONS(3097),
    [anon_sym_GT_EQ] = ACTIONS(3095),
    [anon_sym_CARET] = ACTIONS(3095),
    [anon_sym_PLUS] = ACTIONS(3095),
    [anon_sym_SLASH] = ACTIONS(3095),
    [anon_sym_PERCENT] = ACTIONS(3095),
    [sym_comment] = ACTIONS(87),
  },
  [476] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1705),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(3099),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [477] = {
    [aux_sym_symbol_array_repeat1] = STATE(1707),
    [sym__string_end] = ACTIONS(3099),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(3101),
  },
  [478] = {
    [ts_builtin_sym_end] = ACTIONS(3103),
    [sym_comment] = ACTIONS(87),
  },
  [479] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1708),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(1708),
    [sym_operator_assignment] = STATE(1708),
    [sym_conditional] = STATE(1708),
    [sym_range] = STATE(1708),
    [sym_binary] = STATE(1708),
    [sym_unary] = STATE(1708),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [480] = {
    [sym__line_break] = ACTIONS(3105),
    [sym__heredoc_body_start] = ACTIONS(3105),
    [ts_builtin_sym_end] = ACTIONS(3105),
    [anon_sym___END__] = ACTIONS(3105),
    [anon_sym_RBRACE] = ACTIONS(3105),
    [anon_sym_RPAREN] = ACTIONS(3105),
    [anon_sym_SEMI] = ACTIONS(3105),
    [anon_sym_end] = ACTIONS(3105),
    [anon_sym_if] = ACTIONS(3105),
    [anon_sym_unless] = ACTIONS(3105),
    [anon_sym_while] = ACTIONS(3105),
    [anon_sym_until] = ACTIONS(3105),
    [anon_sym_rescue] = ACTIONS(3105),
    [anon_sym_when] = ACTIONS(3105),
    [anon_sym_elsif] = ACTIONS(3105),
    [anon_sym_else] = ACTIONS(3105),
    [anon_sym_then] = ACTIONS(3105),
    [anon_sym_ensure] = ACTIONS(3105),
    [sym_comment] = ACTIONS(87),
  },
  [481] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1721),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1725),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1725),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(1722),
    [sym__argument] = STATE(1723),
    [sym_splat_argument] = STATE(1723),
    [sym_hash_splat_argument] = STATE(1723),
    [sym_block_argument] = STATE(1723),
    [sym_assignment] = STATE(1721),
    [sym_operator_assignment] = STATE(1721),
    [sym_conditional] = STATE(1721),
    [sym_range] = STATE(1721),
    [sym_binary] = STATE(1721),
    [sym_unary] = STATE(1721),
    [sym_left_assignment_list] = STATE(1724),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1725),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1725),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1726),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(1723),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(3107),
    [sym__splat_star] = ACTIONS(3109),
    [sym__unary_minus] = ACTIONS(3111),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(3113),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(3123),
    [anon_sym_not] = ACTIONS(3125),
    [anon_sym_BANG] = ACTIONS(3127),
    [anon_sym_TILDE] = ACTIONS(3129),
    [sym_constant] = ACTIONS(3131),
    [sym_identifier] = ACTIONS(3131),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [482] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1721),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1725),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1725),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(1722),
    [sym__argument] = STATE(1723),
    [sym_splat_argument] = STATE(1723),
    [sym_hash_splat_argument] = STATE(1723),
    [sym_block_argument] = STATE(1723),
    [sym_assignment] = STATE(1721),
    [sym_operator_assignment] = STATE(1721),
    [sym_conditional] = STATE(1721),
    [sym_range] = STATE(1721),
    [sym_binary] = STATE(1721),
    [sym_unary] = STATE(1721),
    [sym_left_assignment_list] = STATE(1724),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1725),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1725),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1726),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(1723),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(3107),
    [sym__splat_star] = ACTIONS(3109),
    [sym__unary_minus] = ACTIONS(3111),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(3113),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(3123),
    [anon_sym_not] = ACTIONS(3125),
    [anon_sym_BANG] = ACTIONS(3127),
    [anon_sym_TILDE] = ACTIONS(3129),
    [sym_constant] = ACTIONS(3131),
    [sym_identifier] = ACTIONS(3131),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [483] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1721),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1725),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1725),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(1722),
    [sym__argument] = STATE(1723),
    [sym_splat_argument] = STATE(1723),
    [sym_hash_splat_argument] = STATE(1723),
    [sym_block_argument] = STATE(1723),
    [sym_assignment] = STATE(1721),
    [sym_operator_assignment] = STATE(1721),
    [sym_conditional] = STATE(1721),
    [sym_range] = STATE(1721),
    [sym_binary] = STATE(1721),
    [sym_unary] = STATE(1721),
    [sym_left_assignment_list] = STATE(1724),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1725),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1725),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1726),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(1723),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(3107),
    [sym__splat_star] = ACTIONS(3109),
    [sym__unary_minus] = ACTIONS(3111),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(3113),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(3123),
    [anon_sym_not] = ACTIONS(3125),
    [anon_sym_BANG] = ACTIONS(3127),
    [anon_sym_TILDE] = ACTIONS(3129),
    [sym_constant] = ACTIONS(3131),
    [sym_identifier] = ACTIONS(3131),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [484] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1721),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1725),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1725),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(1722),
    [sym__argument] = STATE(1723),
    [sym_splat_argument] = STATE(1723),
    [sym_hash_splat_argument] = STATE(1723),
    [sym_block_argument] = STATE(1723),
    [sym_assignment] = STATE(1721),
    [sym_operator_assignment] = STATE(1721),
    [sym_conditional] = STATE(1721),
    [sym_range] = STATE(1721),
    [sym_binary] = STATE(1721),
    [sym_unary] = STATE(1721),
    [sym_left_assignment_list] = STATE(1724),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1725),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1725),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1726),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(1723),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(3107),
    [sym__splat_star] = ACTIONS(3109),
    [sym__unary_minus] = ACTIONS(3111),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(3113),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(3123),
    [anon_sym_not] = ACTIONS(3125),
    [anon_sym_BANG] = ACTIONS(3127),
    [anon_sym_TILDE] = ACTIONS(3129),
    [sym_constant] = ACTIONS(3131),
    [sym_identifier] = ACTIONS(3131),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [485] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1727),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(1727),
    [sym_operator_assignment] = STATE(1727),
    [sym_conditional] = STATE(1727),
    [sym_range] = STATE(1727),
    [sym_binary] = STATE(1727),
    [sym_unary] = STATE(1727),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [486] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(298),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(298),
    [sym_operator_assignment] = STATE(298),
    [sym_conditional] = STATE(298),
    [sym_range] = STATE(298),
    [sym_binary] = STATE(298),
    [sym_unary] = STATE(298),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [487] = {
    [sym_operator] = STATE(1728),
    [sym__method_name] = STATE(1728),
    [sym_setter] = STATE(1728),
    [sym_symbol] = STATE(1728),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(3133),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(3133),
    [sym_class_variable] = ACTIONS(3133),
    [sym_global_variable] = ACTIONS(3133),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [488] = {
    [anon_sym_RBRACE] = ACTIONS(3135),
    [sym_comment] = ACTIONS(87),
  },
  [489] = {
    [sym_heredoc_body] = STATE(370),
    [sym__terminator] = STATE(370),
    [sym__line_break] = ACTIONS(687),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_RBRACE] = ACTIONS(689),
    [anon_sym_SEMI] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(3137),
    [anon_sym_unless] = ACTIONS(3139),
    [anon_sym_while] = ACTIONS(3141),
    [anon_sym_until] = ACTIONS(3143),
    [anon_sym_rescue] = ACTIONS(3145),
    [sym_comment] = ACTIONS(87),
  },
  [490] = {
    [sym__line_break] = ACTIONS(701),
    [sym__heredoc_body_start] = ACTIONS(701),
    [sym__binary_minus] = ACTIONS(3147),
    [sym__binary_star] = ACTIONS(3149),
    [anon_sym_RBRACE] = ACTIONS(701),
    [anon_sym_PIPE] = ACTIONS(3151),
    [anon_sym_SEMI] = ACTIONS(701),
    [anon_sym_STAR_STAR] = ACTIONS(3149),
    [anon_sym_AMP] = ACTIONS(3153),
    [anon_sym_LT] = ACTIONS(3155),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_unless] = ACTIONS(701),
    [anon_sym_while] = ACTIONS(701),
    [anon_sym_until] = ACTIONS(701),
    [anon_sym_rescue] = ACTIONS(701),
    [anon_sym_QMARK] = ACTIONS(3157),
    [anon_sym_DOT_DOT] = ACTIONS(3159),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3161),
    [anon_sym_and] = ACTIONS(3163),
    [anon_sym_or] = ACTIONS(3163),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3167),
    [anon_sym_GT_GT] = ACTIONS(3167),
    [anon_sym_EQ_EQ] = ACTIONS(3169),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3155),
    [anon_sym_GT] = ACTIONS(3155),
    [anon_sym_GT_EQ] = ACTIONS(3171),
    [anon_sym_CARET] = ACTIONS(3173),
    [anon_sym_PLUS] = ACTIONS(3147),
    [anon_sym_SLASH] = ACTIONS(3149),
    [anon_sym_PERCENT] = ACTIONS(3149),
    [sym_comment] = ACTIONS(87),
  },
  [491] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(1757),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1762),
    [sym_scope_resolution] = STATE(1758),
    [sym_call] = STATE(1758),
    [sym_method_call] = STATE(1762),
    [sym_argument_list] = STATE(423),
    [sym__argument_list_with_parens] = STATE(1759),
    [sym__argument] = STATE(1760),
    [sym_splat_argument] = STATE(1760),
    [sym_hash_splat_argument] = STATE(1760),
    [sym_block_argument] = STATE(1760),
    [sym_do_block] = STATE(426),
    [sym_block] = STATE(426),
    [sym_assignment] = STATE(1757),
    [sym_operator_assignment] = STATE(1757),
    [sym_conditional] = STATE(1757),
    [sym_range] = STATE(1757),
    [sym_binary] = STATE(1757),
    [sym_unary] = STATE(1757),
    [sym_left_assignment_list] = STATE(1761),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1762),
    [sym__variable] = STATE(1758),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1762),
    [sym_false] = STATE(1762),
    [sym_nil] = STATE(1762),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(1763),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(1760),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(743),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(3175),
    [sym__splat_star] = ACTIONS(3177),
    [sym__unary_minus] = ACTIONS(3179),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(3181),
    [anon_sym_LBRACE] = ACTIONS(771),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(3183),
    [anon_sym_yield] = ACTIONS(3185),
    [anon_sym_break] = ACTIONS(3187),
    [anon_sym_next] = ACTIONS(3189),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(769),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(769),
    [anon_sym_until] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(769),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(3191),
    [anon_sym_not] = ACTIONS(3193),
    [anon_sym_BANG] = ACTIONS(3195),
    [anon_sym_TILDE] = ACTIONS(3197),
    [sym_constant] = ACTIONS(3199),
    [sym_identifier] = ACTIONS(3199),
    [sym_instance_variable] = ACTIONS(3201),
    [sym_class_variable] = ACTIONS(3201),
    [sym_global_variable] = ACTIONS(3201),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(3203),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(3203),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [492] = {
    [anon_sym_EQ] = ACTIONS(3205),
    [sym_comment] = ACTIONS(87),
  },
  [493] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(3207),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(3209),
    [anon_sym_DASH_EQ] = ACTIONS(3209),
    [anon_sym_STAR_EQ] = ACTIONS(3209),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3209),
    [anon_sym_SLASH_EQ] = ACTIONS(3209),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3209),
    [anon_sym_PIPE_EQ] = ACTIONS(3209),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3209),
    [anon_sym_AMP_EQ] = ACTIONS(3209),
    [anon_sym_PERCENT_EQ] = ACTIONS(3209),
    [anon_sym_GT_GT_EQ] = ACTIONS(3209),
    [anon_sym_LT_LT_EQ] = ACTIONS(3209),
    [anon_sym_CARET_EQ] = ACTIONS(3209),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [494] = {
    [sym_string] = STATE(1766),
    [aux_sym_chained_string_repeat1] = STATE(1766),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [495] = {
    [sym_begin_block] = STATE(1767),
    [sym_end_block] = STATE(1767),
    [sym__statement] = STATE(1767),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1767),
    [sym_unless_modifier] = STATE(1767),
    [sym_while_modifier] = STATE(1767),
    [sym_until_modifier] = STATE(1767),
    [sym_rescue_modifier] = STATE(1767),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(1767),
    [sym_alias] = STATE(1767),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1768),
    [aux_sym__statements_repeat1] = STATE(1768),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(689),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [496] = {
    [sym__string_start] = ACTIONS(835),
    [sym__binary_minus] = ACTIONS(835),
    [sym__binary_star] = ACTIONS(835),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_RBRACE] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(835),
    [anon_sym_DOT] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(835),
    [anon_sym_PIPE] = ACTIONS(837),
    [anon_sym_SEMI] = ACTIONS(835),
    [anon_sym_STAR_STAR] = ACTIONS(835),
    [anon_sym_AMP] = ACTIONS(837),
    [anon_sym_COLON] = ACTIONS(837),
    [anon_sym_LT] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_unless] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_until] = ACTIONS(835),
    [anon_sym_rescue] = ACTIONS(835),
    [anon_sym_do] = ACTIONS(835),
    [anon_sym_EQ_GT] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_COLON_COLON2] = ACTIONS(835),
    [anon_sym_AMP_DOT] = ACTIONS(835),
    [anon_sym_QMARK] = ACTIONS(835),
    [anon_sym_DOT_DOT] = ACTIONS(837),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(835),
    [anon_sym_and] = ACTIONS(835),
    [anon_sym_or] = ACTIONS(835),
    [anon_sym_PIPE_PIPE] = ACTIONS(835),
    [anon_sym_AMP_AMP] = ACTIONS(835),
    [anon_sym_LT_LT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(835),
    [anon_sym_EQ_EQ] = ACTIONS(837),
    [anon_sym_BANG_EQ] = ACTIONS(835),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(835),
    [anon_sym_LT_EQ_GT] = ACTIONS(835),
    [anon_sym_EQ_TILDE] = ACTIONS(835),
    [anon_sym_BANG_TILDE] = ACTIONS(835),
    [anon_sym_LT_EQ] = ACTIONS(837),
    [anon_sym_GT] = ACTIONS(837),
    [anon_sym_GT_EQ] = ACTIONS(835),
    [anon_sym_CARET] = ACTIONS(835),
    [anon_sym_PLUS] = ACTIONS(835),
    [anon_sym_SLASH] = ACTIONS(835),
    [anon_sym_PERCENT] = ACTIONS(835),
    [sym_comment] = ACTIONS(87),
  },
  [497] = {
    [sym__string_end] = ACTIONS(3211),
    [sym_comment] = ACTIONS(87),
  },
  [498] = {
    [sym__binary_minus] = ACTIONS(887),
    [sym__binary_star] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(887),
    [anon_sym_RBRACE] = ACTIONS(887),
    [anon_sym_RPAREN] = ACTIONS(887),
    [anon_sym_DOT] = ACTIONS(889),
    [anon_sym_COMMA] = ACTIONS(887),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI] = ACTIONS(887),
    [anon_sym_STAR_STAR] = ACTIONS(887),
    [anon_sym_AMP] = ACTIONS(889),
    [anon_sym_LT] = ACTIONS(889),
    [anon_sym_if] = ACTIONS(887),
    [anon_sym_unless] = ACTIONS(887),
    [anon_sym_while] = ACTIONS(887),
    [anon_sym_until] = ACTIONS(887),
    [anon_sym_rescue] = ACTIONS(887),
    [anon_sym_do] = ACTIONS(887),
    [anon_sym_EQ_GT] = ACTIONS(887),
    [anon_sym_LBRACK] = ACTIONS(887),
    [anon_sym_COLON_COLON2] = ACTIONS(887),
    [anon_sym_AMP_DOT] = ACTIONS(887),
    [anon_sym_QMARK] = ACTIONS(887),
    [anon_sym_COLON2] = ACTIONS(889),
    [anon_sym_DOT_DOT] = ACTIONS(889),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(887),
    [anon_sym_and] = ACTIONS(887),
    [anon_sym_or] = ACTIONS(887),
    [anon_sym_PIPE_PIPE] = ACTIONS(887),
    [anon_sym_AMP_AMP] = ACTIONS(887),
    [anon_sym_LT_LT] = ACTIONS(887),
    [anon_sym_GT_GT] = ACTIONS(887),
    [anon_sym_EQ_EQ] = ACTIONS(889),
    [anon_sym_BANG_EQ] = ACTIONS(887),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(887),
    [anon_sym_LT_EQ_GT] = ACTIONS(887),
    [anon_sym_EQ_TILDE] = ACTIONS(887),
    [anon_sym_BANG_TILDE] = ACTIONS(887),
    [anon_sym_LT_EQ] = ACTIONS(889),
    [anon_sym_GT] = ACTIONS(889),
    [anon_sym_GT_EQ] = ACTIONS(887),
    [anon_sym_CARET] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_SLASH] = ACTIONS(887),
    [anon_sym_PERCENT] = ACTIONS(887),
    [sym_comment] = ACTIONS(87),
  },
  [499] = {
    [sym__string_end] = ACTIONS(3213),
    [sym_comment] = ACTIONS(87),
  },
  [500] = {
    [sym__binary_minus] = ACTIONS(893),
    [sym__binary_star] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(893),
    [anon_sym_RBRACE] = ACTIONS(893),
    [anon_sym_RPAREN] = ACTIONS(893),
    [anon_sym_DOT] = ACTIONS(895),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_PIPE] = ACTIONS(895),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_STAR_STAR] = ACTIONS(893),
    [anon_sym_AMP] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(895),
    [anon_sym_if] = ACTIONS(893),
    [anon_sym_unless] = ACTIONS(893),
    [anon_sym_while] = ACTIONS(893),
    [anon_sym_until] = ACTIONS(893),
    [anon_sym_rescue] = ACTIONS(893),
    [anon_sym_do] = ACTIONS(893),
    [anon_sym_EQ_GT] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(893),
    [anon_sym_COLON_COLON2] = ACTIONS(893),
    [anon_sym_AMP_DOT] = ACTIONS(893),
    [anon_sym_QMARK] = ACTIONS(893),
    [anon_sym_COLON2] = ACTIONS(895),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(893),
    [anon_sym_and] = ACTIONS(893),
    [anon_sym_or] = ACTIONS(893),
    [anon_sym_PIPE_PIPE] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(893),
    [anon_sym_LT_LT] = ACTIONS(893),
    [anon_sym_GT_GT] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(895),
    [anon_sym_BANG_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_LT_EQ_GT] = ACTIONS(893),
    [anon_sym_EQ_TILDE] = ACTIONS(893),
    [anon_sym_BANG_TILDE] = ACTIONS(893),
    [anon_sym_LT_EQ] = ACTIONS(895),
    [anon_sym_GT] = ACTIONS(895),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_CARET] = ACTIONS(893),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_SLASH] = ACTIONS(893),
    [anon_sym_PERCENT] = ACTIONS(893),
    [sym_comment] = ACTIONS(87),
  },
  [501] = {
    [sym__string_end] = ACTIONS(3215),
    [sym_comment] = ACTIONS(87),
  },
  [502] = {
    [sym__binary_minus] = ACTIONS(899),
    [sym__binary_star] = ACTIONS(899),
    [anon_sym_LBRACE] = ACTIONS(899),
    [anon_sym_RBRACE] = ACTIONS(899),
    [anon_sym_RPAREN] = ACTIONS(899),
    [anon_sym_DOT] = ACTIONS(901),
    [anon_sym_COMMA] = ACTIONS(899),
    [anon_sym_PIPE] = ACTIONS(901),
    [anon_sym_SEMI] = ACTIONS(899),
    [anon_sym_STAR_STAR] = ACTIONS(899),
    [anon_sym_AMP] = ACTIONS(901),
    [anon_sym_LT] = ACTIONS(901),
    [anon_sym_if] = ACTIONS(899),
    [anon_sym_unless] = ACTIONS(899),
    [anon_sym_while] = ACTIONS(899),
    [anon_sym_until] = ACTIONS(899),
    [anon_sym_rescue] = ACTIONS(899),
    [anon_sym_do] = ACTIONS(899),
    [anon_sym_EQ_GT] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(899),
    [anon_sym_COLON_COLON2] = ACTIONS(899),
    [anon_sym_AMP_DOT] = ACTIONS(899),
    [anon_sym_QMARK] = ACTIONS(899),
    [anon_sym_COLON2] = ACTIONS(901),
    [anon_sym_DOT_DOT] = ACTIONS(901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(899),
    [anon_sym_and] = ACTIONS(899),
    [anon_sym_or] = ACTIONS(899),
    [anon_sym_PIPE_PIPE] = ACTIONS(899),
    [anon_sym_AMP_AMP] = ACTIONS(899),
    [anon_sym_LT_LT] = ACTIONS(899),
    [anon_sym_GT_GT] = ACTIONS(899),
    [anon_sym_EQ_EQ] = ACTIONS(901),
    [anon_sym_BANG_EQ] = ACTIONS(899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(899),
    [anon_sym_LT_EQ_GT] = ACTIONS(899),
    [anon_sym_EQ_TILDE] = ACTIONS(899),
    [anon_sym_BANG_TILDE] = ACTIONS(899),
    [anon_sym_LT_EQ] = ACTIONS(901),
    [anon_sym_GT] = ACTIONS(901),
    [anon_sym_GT_EQ] = ACTIONS(899),
    [anon_sym_CARET] = ACTIONS(899),
    [anon_sym_PLUS] = ACTIONS(899),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [sym_comment] = ACTIONS(87),
  },
  [503] = {
    [sym__string_end] = ACTIONS(3217),
    [sym_comment] = ACTIONS(87),
  },
  [504] = {
    [sym__binary_minus] = ACTIONS(905),
    [sym__binary_star] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(905),
    [anon_sym_RBRACE] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(905),
    [anon_sym_DOT] = ACTIONS(907),
    [anon_sym_COMMA] = ACTIONS(905),
    [anon_sym_PIPE] = ACTIONS(907),
    [anon_sym_SEMI] = ACTIONS(905),
    [anon_sym_STAR_STAR] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_LT] = ACTIONS(907),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_unless] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_until] = ACTIONS(905),
    [anon_sym_rescue] = ACTIONS(905),
    [anon_sym_do] = ACTIONS(905),
    [anon_sym_EQ_GT] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_COLON_COLON2] = ACTIONS(905),
    [anon_sym_AMP_DOT] = ACTIONS(905),
    [anon_sym_QMARK] = ACTIONS(905),
    [anon_sym_COLON2] = ACTIONS(907),
    [anon_sym_DOT_DOT] = ACTIONS(907),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(905),
    [anon_sym_and] = ACTIONS(905),
    [anon_sym_or] = ACTIONS(905),
    [anon_sym_PIPE_PIPE] = ACTIONS(905),
    [anon_sym_AMP_AMP] = ACTIONS(905),
    [anon_sym_LT_LT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(905),
    [anon_sym_EQ_EQ] = ACTIONS(907),
    [anon_sym_BANG_EQ] = ACTIONS(905),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(905),
    [anon_sym_LT_EQ_GT] = ACTIONS(905),
    [anon_sym_EQ_TILDE] = ACTIONS(905),
    [anon_sym_BANG_TILDE] = ACTIONS(905),
    [anon_sym_LT_EQ] = ACTIONS(907),
    [anon_sym_GT] = ACTIONS(907),
    [anon_sym_GT_EQ] = ACTIONS(905),
    [anon_sym_CARET] = ACTIONS(905),
    [anon_sym_PLUS] = ACTIONS(905),
    [anon_sym_SLASH] = ACTIONS(905),
    [anon_sym_PERCENT] = ACTIONS(905),
    [sym_comment] = ACTIONS(87),
  },
  [505] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1775),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(3219),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(3221),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [506] = {
    [aux_sym_string_array_repeat1] = STATE(1778),
    [sym__string_end] = ACTIONS(3223),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(3225),
  },
  [507] = {
    [sym__binary_minus] = ACTIONS(923),
    [sym__binary_star] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(923),
    [anon_sym_RBRACE] = ACTIONS(923),
    [anon_sym_RPAREN] = ACTIONS(923),
    [anon_sym_DOT] = ACTIONS(925),
    [anon_sym_COMMA] = ACTIONS(923),
    [anon_sym_PIPE] = ACTIONS(925),
    [anon_sym_SEMI] = ACTIONS(923),
    [anon_sym_STAR_STAR] = ACTIONS(923),
    [anon_sym_AMP] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(925),
    [anon_sym_if] = ACTIONS(923),
    [anon_sym_unless] = ACTIONS(923),
    [anon_sym_while] = ACTIONS(923),
    [anon_sym_until] = ACTIONS(923),
    [anon_sym_rescue] = ACTIONS(923),
    [anon_sym_do] = ACTIONS(923),
    [anon_sym_EQ_GT] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(923),
    [anon_sym_COLON_COLON2] = ACTIONS(923),
    [anon_sym_AMP_DOT] = ACTIONS(923),
    [anon_sym_QMARK] = ACTIONS(923),
    [anon_sym_COLON2] = ACTIONS(925),
    [anon_sym_DOT_DOT] = ACTIONS(925),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(923),
    [anon_sym_and] = ACTIONS(923),
    [anon_sym_or] = ACTIONS(923),
    [anon_sym_PIPE_PIPE] = ACTIONS(923),
    [anon_sym_AMP_AMP] = ACTIONS(923),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_EQ_EQ] = ACTIONS(925),
    [anon_sym_BANG_EQ] = ACTIONS(923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(923),
    [anon_sym_LT_EQ_GT] = ACTIONS(923),
    [anon_sym_EQ_TILDE] = ACTIONS(923),
    [anon_sym_BANG_TILDE] = ACTIONS(923),
    [anon_sym_LT_EQ] = ACTIONS(925),
    [anon_sym_GT] = ACTIONS(925),
    [anon_sym_GT_EQ] = ACTIONS(923),
    [anon_sym_CARET] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(923),
    [anon_sym_SLASH] = ACTIONS(923),
    [anon_sym_PERCENT] = ACTIONS(923),
    [sym_comment] = ACTIONS(87),
  },
  [508] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1781),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(3227),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(3229),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [509] = {
    [aux_sym_symbol_array_repeat1] = STATE(1784),
    [sym__string_end] = ACTIONS(3231),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(3233),
  },
  [510] = {
    [anon_sym_RBRACE] = ACTIONS(3235),
    [anon_sym_RPAREN] = ACTIONS(3235),
    [anon_sym_SEMI] = ACTIONS(3235),
    [anon_sym_end] = ACTIONS(3235),
    [anon_sym_when] = ACTIONS(3235),
    [anon_sym_else] = ACTIONS(3235),
    [anon_sym_RBRACK] = ACTIONS(3235),
    [sym_comment] = ACTIONS(87),
  },
  [511] = {
    [sym_begin_block] = STATE(1785),
    [sym_end_block] = STATE(1785),
    [sym__statement] = STATE(1785),
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_if_modifier] = STATE(1785),
    [sym_unless_modifier] = STATE(1785),
    [sym_while_modifier] = STATE(1785),
    [sym_until_modifier] = STATE(1785),
    [sym_rescue_modifier] = STATE(1785),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(453),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(457),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym_method_call] = STATE(457),
    [sym_assignment] = STATE(453),
    [sym_operator_assignment] = STATE(453),
    [sym_conditional] = STATE(453),
    [sym_range] = STATE(453),
    [sym_binary] = STATE(453),
    [sym_unary] = STATE(453),
    [sym_left_assignment_list] = STATE(456),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(457),
    [sym__variable] = STATE(455),
    [sym_undef] = STATE(1785),
    [sym_alias] = STATE(1785),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(457),
    [sym_false] = STATE(457),
    [sym_nil] = STATE(457),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(458),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(841),
    [anon_sym_BEGIN] = ACTIONS(843),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_END] = ACTIONS(845),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_yield] = ACTIONS(851),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_next] = ACTIONS(855),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [anon_sym_undef] = ACTIONS(871),
    [anon_sym_alias] = ACTIONS(873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [512] = {
    [sym_interpolation] = STATE(1787),
    [aux_sym_heredoc_body_repeat1] = STATE(1787),
    [sym__heredoc_content] = ACTIONS(3237),
    [sym_heredoc_end] = ACTIONS(3239),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(3237),
  },
  [513] = {
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [514] = {
    [sym_string] = STATE(656),
    [aux_sym_chained_string_repeat1] = STATE(656),
    [sym__string_start] = ACTIONS(139),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [515] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(1788),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(541),
    [sym_scope_resolution] = STATE(539),
    [sym_call] = STATE(539),
    [sym_method_call] = STATE(541),
    [sym_assignment] = STATE(1788),
    [sym_operator_assignment] = STATE(1788),
    [sym_conditional] = STATE(1788),
    [sym_range] = STATE(1788),
    [sym_binary] = STATE(1788),
    [sym_unary] = STATE(1788),
    [sym_left_assignment_list] = STATE(540),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(541),
    [sym__variable] = STATE(539),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(541),
    [sym_false] = STATE(541),
    [sym_nil] = STATE(541),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(542),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1021),
    [anon_sym_defined_QMARK] = ACTIONS(1023),
    [anon_sym_not] = ACTIONS(1025),
    [anon_sym_BANG] = ACTIONS(1027),
    [anon_sym_TILDE] = ACTIONS(1027),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [516] = {
    [sym__binary_minus] = ACTIONS(993),
    [sym__binary_star] = ACTIONS(993),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_RBRACE] = ACTIONS(993),
    [anon_sym_RPAREN] = ACTIONS(993),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(993),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_SEMI] = ACTIONS(993),
    [anon_sym_STAR_STAR] = ACTIONS(993),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(995),
    [anon_sym_if] = ACTIONS(993),
    [anon_sym_unless] = ACTIONS(993),
    [anon_sym_while] = ACTIONS(993),
    [anon_sym_until] = ACTIONS(993),
    [anon_sym_rescue] = ACTIONS(993),
    [anon_sym_do] = ACTIONS(993),
    [anon_sym_EQ_GT] = ACTIONS(993),
    [anon_sym_LBRACK] = ACTIONS(993),
    [anon_sym_COLON_COLON2] = ACTIONS(993),
    [anon_sym_AMP_DOT] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(993),
    [anon_sym_COLON2] = ACTIONS(995),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(993),
    [anon_sym_and] = ACTIONS(993),
    [anon_sym_or] = ACTIONS(993),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_AMP_AMP] = ACTIONS(993),
    [anon_sym_LT_LT] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(993),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(993),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(993),
    [anon_sym_LT_EQ_GT] = ACTIONS(993),
    [anon_sym_EQ_TILDE] = ACTIONS(993),
    [anon_sym_BANG_TILDE] = ACTIONS(993),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(993),
    [anon_sym_CARET] = ACTIONS(993),
    [anon_sym_PLUS] = ACTIONS(993),
    [anon_sym_SLASH] = ACTIONS(993),
    [anon_sym_PERCENT] = ACTIONS(993),
    [sym_comment] = ACTIONS(87),
  },
  [517] = {
    [anon_sym_RBRACE] = ACTIONS(3241),
    [sym_comment] = ACTIONS(87),
  },
  [518] = {
    [sym_heredoc_body] = STATE(1790),
    [sym__heredoc_body_start] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(3241),
    [sym_comment] = ACTIONS(87),
  },
  [519] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(1791),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(674),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(674),
    [sym_assignment] = STATE(1791),
    [sym_operator_assignment] = STATE(1791),
    [sym_conditional] = STATE(1791),
    [sym_range] = STATE(1791),
    [sym_binary] = STATE(1791),
    [sym_unary] = STATE(1791),
    [sym_left_assignment_list] = STATE(673),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(674),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(674),
    [sym_false] = STATE(674),
    [sym_nil] = STATE(674),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(675),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1243),
    [anon_sym_yield] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1247),
    [anon_sym_next] = ACTIONS(1249),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [520] = {
    [sym__binary_minus] = ACTIONS(1273),
    [sym__binary_star] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_RBRACE] = ACTIONS(1273),
    [anon_sym_RPAREN] = ACTIONS(1273),
    [anon_sym_DOT] = ACTIONS(1275),
    [anon_sym_COMMA] = ACTIONS(1273),
    [anon_sym_PIPE] = ACTIONS(1275),
    [anon_sym_SEMI] = ACTIONS(1273),
    [anon_sym_STAR_STAR] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_LT] = ACTIONS(1275),
    [anon_sym_if] = ACTIONS(1273),
    [anon_sym_unless] = ACTIONS(1273),
    [anon_sym_while] = ACTIONS(1273),
    [anon_sym_until] = ACTIONS(1273),
    [anon_sym_rescue] = ACTIONS(1273),
    [anon_sym_do] = ACTIONS(1273),
    [anon_sym_EQ_GT] = ACTIONS(1273),
    [anon_sym_LBRACK] = ACTIONS(1273),
    [anon_sym_COLON_COLON2] = ACTIONS(1273),
    [anon_sym_AMP_DOT] = ACTIONS(1273),
    [anon_sym_QMARK] = ACTIONS(1273),
    [anon_sym_COLON2] = ACTIONS(1275),
    [anon_sym_DOT_DOT] = ACTIONS(1275),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_and] = ACTIONS(1273),
    [anon_sym_or] = ACTIONS(1273),
    [anon_sym_PIPE_PIPE] = ACTIONS(1273),
    [anon_sym_AMP_AMP] = ACTIONS(1273),
    [anon_sym_LT_LT] = ACTIONS(1273),
    [anon_sym_GT_GT] = ACTIONS(1273),
    [anon_sym_EQ_EQ] = ACTIONS(1275),
    [anon_sym_BANG_EQ] = ACTIONS(1273),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1273),
    [anon_sym_LT_EQ_GT] = ACTIONS(1273),
    [anon_sym_EQ_TILDE] = ACTIONS(1273),
    [anon_sym_BANG_TILDE] = ACTIONS(1273),
    [anon_sym_LT_EQ] = ACTIONS(1275),
    [anon_sym_GT] = ACTIONS(1275),
    [anon_sym_GT_EQ] = ACTIONS(1273),
    [anon_sym_CARET] = ACTIONS(1273),
    [anon_sym_PLUS] = ACTIONS(1273),
    [anon_sym_SLASH] = ACTIONS(1273),
    [anon_sym_PERCENT] = ACTIONS(1273),
    [sym_comment] = ACTIONS(87),
  },
  [521] = {
    [anon_sym_DOT] = ACTIONS(3243),
    [anon_sym_COLON_COLON] = ACTIONS(3243),
    [sym_comment] = ACTIONS(87),
  },
  [522] = {
    [sym_method_parameters] = STATE(1793),
    [sym__simple_formal_parameter] = STATE(684),
    [sym_splat_parameter] = STATE(684),
    [sym_hash_splat_parameter] = STATE(684),
    [sym_block_parameter] = STATE(684),
    [sym_keyword_parameter] = STATE(684),
    [sym_optional_parameter] = STATE(684),
    [sym_heredoc_body] = STATE(1793),
    [sym__terminator] = STATE(1793),
    [sym__line_break] = ACTIONS(3245),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_SEMI] = ACTIONS(3245),
    [anon_sym_STAR] = ACTIONS(1283),
    [anon_sym_STAR_STAR] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1287),
    [sym_identifier] = ACTIONS(1289),
    [sym_comment] = ACTIONS(87),
  },
  [523] = {
    [sym__binary_minus] = ACTIONS(1291),
    [sym__binary_star] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1291),
    [anon_sym_RBRACE] = ACTIONS(1291),
    [anon_sym_RPAREN] = ACTIONS(1291),
    [anon_sym_DOT] = ACTIONS(1293),
    [anon_sym_COMMA] = ACTIONS(1291),
    [anon_sym_PIPE] = ACTIONS(1293),
    [anon_sym_SEMI] = ACTIONS(1291),
    [anon_sym_STAR_STAR] = ACTIONS(1291),
    [anon_sym_AMP] = ACTIONS(1293),
    [anon_sym_LT] = ACTIONS(1293),
    [anon_sym_if] = ACTIONS(1291),
    [anon_sym_unless] = ACTIONS(1291),
    [anon_sym_while] = ACTIONS(1291),
    [anon_sym_until] = ACTIONS(1291),
    [anon_sym_rescue] = ACTIONS(1291),
    [anon_sym_do] = ACTIONS(1291),
    [anon_sym_EQ_GT] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_COLON_COLON2] = ACTIONS(1291),
    [anon_sym_AMP_DOT] = ACTIONS(1291),
    [anon_sym_QMARK] = ACTIONS(1291),
    [anon_sym_COLON2] = ACTIONS(1293),
    [anon_sym_DOT_DOT] = ACTIONS(1293),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1291),
    [anon_sym_and] = ACTIONS(1291),
    [anon_sym_or] = ACTIONS(1291),
    [anon_sym_PIPE_PIPE] = ACTIONS(1291),
    [anon_sym_AMP_AMP] = ACTIONS(1291),
    [anon_sym_LT_LT] = ACTIONS(1291),
    [anon_sym_GT_GT] = ACTIONS(1291),
    [anon_sym_EQ_EQ] = ACTIONS(1293),
    [anon_sym_BANG_EQ] = ACTIONS(1291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1291),
    [anon_sym_LT_EQ_GT] = ACTIONS(1291),
    [anon_sym_EQ_TILDE] = ACTIONS(1291),
    [anon_sym_BANG_TILDE] = ACTIONS(1291),
    [anon_sym_LT_EQ] = ACTIONS(1293),
    [anon_sym_GT] = ACTIONS(1293),
    [anon_sym_GT_EQ] = ACTIONS(1291),
    [anon_sym_CARET] = ACTIONS(1291),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_SLASH] = ACTIONS(1291),
    [anon_sym_PERCENT] = ACTIONS(1291),
    [sym_comment] = ACTIONS(87),
  },
  [524] = {
    [anon_sym_RPAREN] = ACTIONS(3247),
    [sym_comment] = ACTIONS(87),
  },
  [525] = {
    [sym__simple_symbol] = ACTIONS(1411),
    [sym__string_start] = ACTIONS(1411),
    [sym__symbol_start] = ACTIONS(1411),
    [sym__subshell_start] = ACTIONS(1411),
    [sym__regex_start] = ACTIONS(1411),
    [sym__string_array_start] = ACTIONS(1411),
    [sym__symbol_array_start] = ACTIONS(1411),
    [sym_heredoc_beginning] = ACTIONS(1411),
    [sym__block_ampersand] = ACTIONS(1411),
    [sym__splat_star] = ACTIONS(1411),
    [sym__unary_minus] = ACTIONS(1411),
    [sym__binary_minus] = ACTIONS(1411),
    [sym__binary_star] = ACTIONS(1411),
    [sym__identifier_hash_key] = ACTIONS(1411),
    [anon_sym_LBRACE] = ACTIONS(1411),
    [anon_sym_def] = ACTIONS(1413),
    [anon_sym_LPAREN] = ACTIONS(1413),
    [anon_sym_DOT] = ACTIONS(1413),
    [anon_sym_COLON_COLON] = ACTIONS(1413),
    [anon_sym_COMMA] = ACTIONS(1411),
    [anon_sym_PIPE] = ACTIONS(1413),
    [anon_sym_STAR] = ACTIONS(1413),
    [anon_sym_STAR_STAR] = ACTIONS(1413),
    [anon_sym_AMP] = ACTIONS(1413),
    [anon_sym_EQ] = ACTIONS(1413),
    [anon_sym_class] = ACTIONS(1413),
    [anon_sym_LT] = ACTIONS(1413),
    [anon_sym_module] = ACTIONS(1413),
    [anon_sym_return] = ACTIONS(1413),
    [anon_sym_yield] = ACTIONS(1413),
    [anon_sym_break] = ACTIONS(1413),
    [anon_sym_next] = ACTIONS(1413),
    [sym_redo] = ACTIONS(1413),
    [sym_retry] = ACTIONS(1413),
    [anon_sym_if] = ACTIONS(1413),
    [anon_sym_unless] = ACTIONS(1413),
    [anon_sym_while] = ACTIONS(1413),
    [anon_sym_until] = ACTIONS(1413),
    [anon_sym_for] = ACTIONS(1413),
    [anon_sym_do] = ACTIONS(1413),
    [anon_sym_case] = ACTIONS(1413),
    [anon_sym_begin] = ACTIONS(1413),
    [anon_sym_EQ_GT] = ACTIONS(1411),
    [anon_sym_LBRACK] = ACTIONS(1411),
    [anon_sym_COLON_COLON2] = ACTIONS(1411),
    [anon_sym_AMP_DOT] = ACTIONS(1411),
    [anon_sym_LPAREN2] = ACTIONS(1411),
    [anon_sym_PLUS_EQ] = ACTIONS(1411),
    [anon_sym_DASH_EQ] = ACTIONS(1411),
    [anon_sym_STAR_EQ] = ACTIONS(1411),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1411),
    [anon_sym_SLASH_EQ] = ACTIONS(1411),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1411),
    [anon_sym_PIPE_EQ] = ACTIONS(1411),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1411),
    [anon_sym_AMP_EQ] = ACTIONS(1411),
    [anon_sym_PERCENT_EQ] = ACTIONS(1411),
    [anon_sym_GT_GT_EQ] = ACTIONS(1411),
    [anon_sym_LT_LT_EQ] = ACTIONS(1411),
    [anon_sym_CARET_EQ] = ACTIONS(1411),
    [anon_sym_QMARK] = ACTIONS(1413),
    [anon_sym_DOT_DOT] = ACTIONS(1413),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1411),
    [anon_sym_and] = ACTIONS(1413),
    [anon_sym_or] = ACTIONS(1413),
    [anon_sym_PIPE_PIPE] = ACTIONS(1413),
    [anon_sym_AMP_AMP] = ACTIONS(1413),
    [anon_sym_LT_LT] = ACTIONS(1413),
    [anon_sym_GT_GT] = ACTIONS(1413),
    [anon_sym_EQ_EQ] = ACTIONS(1413),
    [anon_sym_BANG_EQ] = ACTIONS(1411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1411),
    [anon_sym_LT_EQ_GT] = ACTIONS(1411),
    [anon_sym_EQ_TILDE] = ACTIONS(1411),
    [anon_sym_BANG_TILDE] = ACTIONS(1411),
    [anon_sym_LT_EQ] = ACTIONS(1413),
    [anon_sym_GT] = ACTIONS(1413),
    [anon_sym_GT_EQ] = ACTIONS(1411),
    [anon_sym_CARET] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_SLASH] = ACTIONS(1413),
    [anon_sym_PERCENT] = ACTIONS(1413),
    [anon_sym_defined_QMARK] = ACTIONS(1411),
    [anon_sym_not] = ACTIONS(1413),
    [anon_sym_BANG] = ACTIONS(1413),
    [anon_sym_TILDE] = ACTIONS(1411),
    [sym_constant] = ACTIONS(1413),
    [sym_identifier] = ACTIONS(1413),
    [sym_instance_variable] = ACTIONS(1411),
    [sym_class_variable] = ACTIONS(1411),
    [sym_global_variable] = ACTIONS(1411),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1413),
    [sym_float] = ACTIONS(1413),
    [sym_complex] = ACTIONS(1411),
    [sym_super] = ACTIONS(1413),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_TRUE] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_FALSE] = ACTIONS(1413),
    [sym_self] = ACTIONS(1413),
    [anon_sym_nil] = ACTIONS(1413),
    [anon_sym_NIL] = ACTIONS(1413),
    [sym_character] = ACTIONS(1411),
    [anon_sym_LBRACK2] = ACTIONS(1413),
    [anon_sym_DASH_GT] = ACTIONS(1411),
  },
  [526] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(1795),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(541),
    [sym_scope_resolution] = STATE(539),
    [sym_call] = STATE(539),
    [sym_method_call] = STATE(541),
    [sym_assignment] = STATE(1795),
    [sym_operator_assignment] = STATE(1795),
    [sym_conditional] = STATE(1795),
    [sym_range] = STATE(1795),
    [sym_binary] = STATE(1795),
    [sym_unary] = STATE(1795),
    [sym_left_assignment_list] = STATE(540),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(541),
    [sym__variable] = STATE(539),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(541),
    [sym_false] = STATE(541),
    [sym_nil] = STATE(541),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(542),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1021),
    [anon_sym_defined_QMARK] = ACTIONS(1023),
    [anon_sym_not] = ACTIONS(1025),
    [anon_sym_BANG] = ACTIONS(1027),
    [anon_sym_TILDE] = ACTIONS(1027),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [527] = {
    [sym_constant] = ACTIONS(3249),
    [sym_identifier] = ACTIONS(3249),
    [sym_comment] = ACTIONS(87),
  },
  [528] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(1809),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1814),
    [sym_scope_resolution] = STATE(1810),
    [sym_call] = STATE(1810),
    [sym_method_call] = STATE(1814),
    [sym_argument_list] = STATE(1318),
    [sym__argument_list_with_parens] = STATE(1811),
    [sym__argument] = STATE(1812),
    [sym_splat_argument] = STATE(1812),
    [sym_hash_splat_argument] = STATE(1812),
    [sym_block_argument] = STATE(1812),
    [sym_assignment] = STATE(1809),
    [sym_operator_assignment] = STATE(1809),
    [sym_conditional] = STATE(1809),
    [sym_range] = STATE(1809),
    [sym_binary] = STATE(1809),
    [sym_unary] = STATE(1809),
    [sym_left_assignment_list] = STATE(1813),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1814),
    [sym__variable] = STATE(1810),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1814),
    [sym_false] = STATE(1814),
    [sym_nil] = STATE(1814),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1815),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(1812),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(3251),
    [sym__splat_star] = ACTIONS(3253),
    [sym__unary_minus] = ACTIONS(3255),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(3257),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_break] = ACTIONS(3263),
    [anon_sym_next] = ACTIONS(3265),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(3267),
    [anon_sym_not] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3271),
    [anon_sym_TILDE] = ACTIONS(3273),
    [sym_constant] = ACTIONS(3275),
    [sym_identifier] = ACTIONS(3275),
    [sym_instance_variable] = ACTIONS(3277),
    [sym_class_variable] = ACTIONS(3277),
    [sym_global_variable] = ACTIONS(3277),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3279),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3279),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [529] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(1809),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1814),
    [sym_scope_resolution] = STATE(1810),
    [sym_call] = STATE(1810),
    [sym_method_call] = STATE(1814),
    [sym_argument_list] = STATE(1324),
    [sym__argument_list_with_parens] = STATE(1811),
    [sym__argument] = STATE(1812),
    [sym_splat_argument] = STATE(1812),
    [sym_hash_splat_argument] = STATE(1812),
    [sym_block_argument] = STATE(1812),
    [sym_assignment] = STATE(1809),
    [sym_operator_assignment] = STATE(1809),
    [sym_conditional] = STATE(1809),
    [sym_range] = STATE(1809),
    [sym_binary] = STATE(1809),
    [sym_unary] = STATE(1809),
    [sym_left_assignment_list] = STATE(1813),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1814),
    [sym__variable] = STATE(1810),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1814),
    [sym_false] = STATE(1814),
    [sym_nil] = STATE(1814),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1815),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(1812),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(3251),
    [sym__splat_star] = ACTIONS(3253),
    [sym__unary_minus] = ACTIONS(3255),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(3257),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_break] = ACTIONS(3263),
    [anon_sym_next] = ACTIONS(3265),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(3267),
    [anon_sym_not] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3271),
    [anon_sym_TILDE] = ACTIONS(3273),
    [sym_constant] = ACTIONS(3275),
    [sym_identifier] = ACTIONS(3275),
    [sym_instance_variable] = ACTIONS(3277),
    [sym_class_variable] = ACTIONS(3277),
    [sym_global_variable] = ACTIONS(3277),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3279),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3279),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [530] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(1809),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1814),
    [sym_scope_resolution] = STATE(1810),
    [sym_call] = STATE(1810),
    [sym_method_call] = STATE(1814),
    [sym_argument_list] = STATE(1325),
    [sym__argument_list_with_parens] = STATE(1811),
    [sym__argument] = STATE(1812),
    [sym_splat_argument] = STATE(1812),
    [sym_hash_splat_argument] = STATE(1812),
    [sym_block_argument] = STATE(1812),
    [sym_assignment] = STATE(1809),
    [sym_operator_assignment] = STATE(1809),
    [sym_conditional] = STATE(1809),
    [sym_range] = STATE(1809),
    [sym_binary] = STATE(1809),
    [sym_unary] = STATE(1809),
    [sym_left_assignment_list] = STATE(1813),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1814),
    [sym__variable] = STATE(1810),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1814),
    [sym_false] = STATE(1814),
    [sym_nil] = STATE(1814),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1815),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(1812),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(3251),
    [sym__splat_star] = ACTIONS(3253),
    [sym__unary_minus] = ACTIONS(3255),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(3257),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_break] = ACTIONS(3263),
    [anon_sym_next] = ACTIONS(3265),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(3267),
    [anon_sym_not] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3271),
    [anon_sym_TILDE] = ACTIONS(3273),
    [sym_constant] = ACTIONS(3275),
    [sym_identifier] = ACTIONS(3275),
    [sym_instance_variable] = ACTIONS(3277),
    [sym_class_variable] = ACTIONS(3277),
    [sym_global_variable] = ACTIONS(3277),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3279),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3279),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [531] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(1809),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1814),
    [sym_scope_resolution] = STATE(1810),
    [sym_call] = STATE(1810),
    [sym_method_call] = STATE(1814),
    [sym_argument_list] = STATE(1326),
    [sym__argument_list_with_parens] = STATE(1811),
    [sym__argument] = STATE(1812),
    [sym_splat_argument] = STATE(1812),
    [sym_hash_splat_argument] = STATE(1812),
    [sym_block_argument] = STATE(1812),
    [sym_assignment] = STATE(1809),
    [sym_operator_assignment] = STATE(1809),
    [sym_conditional] = STATE(1809),
    [sym_range] = STATE(1809),
    [sym_binary] = STATE(1809),
    [sym_unary] = STATE(1809),
    [sym_left_assignment_list] = STATE(1813),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1814),
    [sym__variable] = STATE(1810),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1814),
    [sym_false] = STATE(1814),
    [sym_nil] = STATE(1814),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1815),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(1812),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(3251),
    [sym__splat_star] = ACTIONS(3253),
    [sym__unary_minus] = ACTIONS(3255),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(3257),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_break] = ACTIONS(3263),
    [anon_sym_next] = ACTIONS(3265),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(3267),
    [anon_sym_not] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3271),
    [anon_sym_TILDE] = ACTIONS(3273),
    [sym_constant] = ACTIONS(3275),
    [sym_identifier] = ACTIONS(3275),
    [sym_instance_variable] = ACTIONS(3277),
    [sym_class_variable] = ACTIONS(3277),
    [sym_global_variable] = ACTIONS(3277),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3279),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3279),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [532] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(1816),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(541),
    [sym_scope_resolution] = STATE(539),
    [sym_call] = STATE(539),
    [sym_method_call] = STATE(541),
    [sym_assignment] = STATE(1816),
    [sym_operator_assignment] = STATE(1816),
    [sym_conditional] = STATE(1816),
    [sym_range] = STATE(1816),
    [sym_binary] = STATE(1816),
    [sym_unary] = STATE(1816),
    [sym_left_assignment_list] = STATE(540),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(541),
    [sym__variable] = STATE(539),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(541),
    [sym_false] = STATE(541),
    [sym_nil] = STATE(541),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(542),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1021),
    [anon_sym_defined_QMARK] = ACTIONS(1023),
    [anon_sym_not] = ACTIONS(1025),
    [anon_sym_BANG] = ACTIONS(1027),
    [anon_sym_TILDE] = ACTIONS(1027),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [533] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(1341),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(541),
    [sym_scope_resolution] = STATE(539),
    [sym_call] = STATE(539),
    [sym_method_call] = STATE(541),
    [sym_assignment] = STATE(1341),
    [sym_operator_assignment] = STATE(1341),
    [sym_conditional] = STATE(1341),
    [sym_range] = STATE(1341),
    [sym_binary] = STATE(1341),
    [sym_unary] = STATE(1341),
    [sym_left_assignment_list] = STATE(540),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(541),
    [sym__variable] = STATE(539),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(541),
    [sym_false] = STATE(541),
    [sym_nil] = STATE(541),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(542),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1021),
    [anon_sym_defined_QMARK] = ACTIONS(1023),
    [anon_sym_not] = ACTIONS(1025),
    [anon_sym_BANG] = ACTIONS(1027),
    [anon_sym_TILDE] = ACTIONS(1027),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [534] = {
    [sym__heredoc_body_start] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(565),
    [sym__binary_star] = ACTIONS(565),
    [anon_sym_LBRACE] = ACTIONS(565),
    [anon_sym_RBRACE] = ACTIONS(565),
    [anon_sym_RPAREN] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(567),
    [anon_sym_COMMA] = ACTIONS(565),
    [anon_sym_PIPE] = ACTIONS(567),
    [anon_sym_SEMI] = ACTIONS(565),
    [anon_sym_STAR_STAR] = ACTIONS(567),
    [anon_sym_AMP] = ACTIONS(567),
    [anon_sym_EQ] = ACTIONS(567),
    [anon_sym_LT] = ACTIONS(567),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_unless] = ACTIONS(565),
    [anon_sym_while] = ACTIONS(565),
    [anon_sym_until] = ACTIONS(565),
    [anon_sym_rescue] = ACTIONS(565),
    [anon_sym_in] = ACTIONS(565),
    [anon_sym_do] = ACTIONS(565),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_RBRACK] = ACTIONS(565),
    [anon_sym_COLON_COLON2] = ACTIONS(565),
    [anon_sym_AMP_DOT] = ACTIONS(565),
    [anon_sym_PLUS_EQ] = ACTIONS(565),
    [anon_sym_DASH_EQ] = ACTIONS(565),
    [anon_sym_STAR_EQ] = ACTIONS(565),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(565),
    [anon_sym_SLASH_EQ] = ACTIONS(565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(565),
    [anon_sym_PIPE_EQ] = ACTIONS(565),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(565),
    [anon_sym_AMP_EQ] = ACTIONS(565),
    [anon_sym_PERCENT_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_LT_LT_EQ] = ACTIONS(565),
    [anon_sym_CARET_EQ] = ACTIONS(565),
    [anon_sym_QMARK] = ACTIONS(565),
    [anon_sym_COLON2] = ACTIONS(567),
    [anon_sym_DOT_DOT] = ACTIONS(567),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(565),
    [anon_sym_and] = ACTIONS(565),
    [anon_sym_or] = ACTIONS(565),
    [anon_sym_PIPE_PIPE] = ACTIONS(567),
    [anon_sym_AMP_AMP] = ACTIONS(567),
    [anon_sym_LT_LT] = ACTIONS(567),
    [anon_sym_GT_GT] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(565),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(565),
    [anon_sym_LT_EQ_GT] = ACTIONS(565),
    [anon_sym_EQ_TILDE] = ACTIONS(565),
    [anon_sym_BANG_TILDE] = ACTIONS(565),
    [anon_sym_LT_EQ] = ACTIONS(567),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_GT_EQ] = ACTIONS(565),
    [anon_sym_CARET] = ACTIONS(567),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_SLASH] = ACTIONS(567),
    [anon_sym_PERCENT] = ACTIONS(567),
    [sym_comment] = ACTIONS(87),
  },
  [535] = {
    [sym__heredoc_body_start] = ACTIONS(569),
    [sym__binary_minus] = ACTIONS(569),
    [sym__binary_star] = ACTIONS(569),
    [anon_sym_LBRACE] = ACTIONS(569),
    [anon_sym_RBRACE] = ACTIONS(569),
    [anon_sym_RPAREN] = ACTIONS(569),
    [anon_sym_DOT] = ACTIONS(571),
    [anon_sym_COMMA] = ACTIONS(569),
    [anon_sym_PIPE] = ACTIONS(571),
    [anon_sym_SEMI] = ACTIONS(569),
    [anon_sym_STAR_STAR] = ACTIONS(571),
    [anon_sym_AMP] = ACTIONS(571),
    [anon_sym_EQ] = ACTIONS(571),
    [anon_sym_LT] = ACTIONS(571),
    [anon_sym_if] = ACTIONS(569),
    [anon_sym_unless] = ACTIONS(569),
    [anon_sym_while] = ACTIONS(569),
    [anon_sym_until] = ACTIONS(569),
    [anon_sym_rescue] = ACTIONS(569),
    [anon_sym_in] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_LBRACK] = ACTIONS(569),
    [anon_sym_RBRACK] = ACTIONS(569),
    [anon_sym_COLON_COLON2] = ACTIONS(569),
    [anon_sym_AMP_DOT] = ACTIONS(569),
    [anon_sym_PLUS_EQ] = ACTIONS(569),
    [anon_sym_DASH_EQ] = ACTIONS(569),
    [anon_sym_STAR_EQ] = ACTIONS(569),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(569),
    [anon_sym_SLASH_EQ] = ACTIONS(569),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(569),
    [anon_sym_PIPE_EQ] = ACTIONS(569),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(569),
    [anon_sym_AMP_EQ] = ACTIONS(569),
    [anon_sym_PERCENT_EQ] = ACTIONS(569),
    [anon_sym_GT_GT_EQ] = ACTIONS(569),
    [anon_sym_LT_LT_EQ] = ACTIONS(569),
    [anon_sym_CARET_EQ] = ACTIONS(569),
    [anon_sym_QMARK] = ACTIONS(569),
    [anon_sym_COLON2] = ACTIONS(571),
    [anon_sym_DOT_DOT] = ACTIONS(571),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(569),
    [anon_sym_and] = ACTIONS(569),
    [anon_sym_or] = ACTIONS(569),
    [anon_sym_PIPE_PIPE] = ACTIONS(571),
    [anon_sym_AMP_AMP] = ACTIONS(571),
    [anon_sym_LT_LT] = ACTIONS(571),
    [anon_sym_GT_GT] = ACTIONS(571),
    [anon_sym_EQ_EQ] = ACTIONS(571),
    [anon_sym_BANG_EQ] = ACTIONS(569),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(569),
    [anon_sym_LT_EQ_GT] = ACTIONS(569),
    [anon_sym_EQ_TILDE] = ACTIONS(569),
    [anon_sym_BANG_TILDE] = ACTIONS(569),
    [anon_sym_LT_EQ] = ACTIONS(571),
    [anon_sym_GT] = ACTIONS(571),
    [anon_sym_GT_EQ] = ACTIONS(569),
    [anon_sym_CARET] = ACTIONS(571),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_SLASH] = ACTIONS(571),
    [anon_sym_PERCENT] = ACTIONS(571),
    [sym_comment] = ACTIONS(87),
  },
  [536] = {
    [sym__heredoc_body_start] = ACTIONS(573),
    [sym__binary_minus] = ACTIONS(573),
    [sym__binary_star] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(573),
    [anon_sym_RBRACE] = ACTIONS(573),
    [anon_sym_RPAREN] = ACTIONS(573),
    [anon_sym_DOT] = ACTIONS(575),
    [anon_sym_COMMA] = ACTIONS(573),
    [anon_sym_PIPE] = ACTIONS(575),
    [anon_sym_SEMI] = ACTIONS(573),
    [anon_sym_STAR_STAR] = ACTIONS(575),
    [anon_sym_AMP] = ACTIONS(575),
    [anon_sym_EQ] = ACTIONS(575),
    [anon_sym_LT] = ACTIONS(575),
    [anon_sym_if] = ACTIONS(573),
    [anon_sym_unless] = ACTIONS(573),
    [anon_sym_while] = ACTIONS(573),
    [anon_sym_until] = ACTIONS(573),
    [anon_sym_rescue] = ACTIONS(573),
    [anon_sym_in] = ACTIONS(573),
    [anon_sym_do] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(573),
    [anon_sym_RBRACK] = ACTIONS(573),
    [anon_sym_COLON_COLON2] = ACTIONS(573),
    [anon_sym_AMP_DOT] = ACTIONS(573),
    [anon_sym_PLUS_EQ] = ACTIONS(573),
    [anon_sym_DASH_EQ] = ACTIONS(573),
    [anon_sym_STAR_EQ] = ACTIONS(573),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(573),
    [anon_sym_SLASH_EQ] = ACTIONS(573),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(573),
    [anon_sym_PIPE_EQ] = ACTIONS(573),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(573),
    [anon_sym_AMP_EQ] = ACTIONS(573),
    [anon_sym_PERCENT_EQ] = ACTIONS(573),
    [anon_sym_GT_GT_EQ] = ACTIONS(573),
    [anon_sym_LT_LT_EQ] = ACTIONS(573),
    [anon_sym_CARET_EQ] = ACTIONS(573),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_COLON2] = ACTIONS(575),
    [anon_sym_DOT_DOT] = ACTIONS(575),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(573),
    [anon_sym_and] = ACTIONS(573),
    [anon_sym_or] = ACTIONS(573),
    [anon_sym_PIPE_PIPE] = ACTIONS(575),
    [anon_sym_AMP_AMP] = ACTIONS(575),
    [anon_sym_LT_LT] = ACTIONS(575),
    [anon_sym_GT_GT] = ACTIONS(575),
    [anon_sym_EQ_EQ] = ACTIONS(575),
    [anon_sym_BANG_EQ] = ACTIONS(573),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(573),
    [anon_sym_LT_EQ_GT] = ACTIONS(573),
    [anon_sym_EQ_TILDE] = ACTIONS(573),
    [anon_sym_BANG_TILDE] = ACTIONS(573),
    [anon_sym_LT_EQ] = ACTIONS(575),
    [anon_sym_GT] = ACTIONS(575),
    [anon_sym_GT_EQ] = ACTIONS(573),
    [anon_sym_CARET] = ACTIONS(575),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(575),
    [anon_sym_PERCENT] = ACTIONS(575),
    [sym_comment] = ACTIONS(87),
  },
  [537] = {
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(3283),
    [sym__binary_star] = ACTIONS(3285),
    [anon_sym_RBRACE] = ACTIONS(3281),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(3287),
    [anon_sym_STAR_STAR] = ACTIONS(3285),
    [anon_sym_AMP] = ACTIONS(3289),
    [anon_sym_LT] = ACTIONS(3291),
    [anon_sym_QMARK] = ACTIONS(3293),
    [anon_sym_DOT_DOT] = ACTIONS(3295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3297),
    [anon_sym_and] = ACTIONS(3299),
    [anon_sym_or] = ACTIONS(3299),
    [anon_sym_PIPE_PIPE] = ACTIONS(3301),
    [anon_sym_AMP_AMP] = ACTIONS(3301),
    [anon_sym_LT_LT] = ACTIONS(3303),
    [anon_sym_GT_GT] = ACTIONS(3303),
    [anon_sym_EQ_EQ] = ACTIONS(3305),
    [anon_sym_BANG_EQ] = ACTIONS(3301),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3301),
    [anon_sym_LT_EQ_GT] = ACTIONS(3301),
    [anon_sym_EQ_TILDE] = ACTIONS(3301),
    [anon_sym_BANG_TILDE] = ACTIONS(3301),
    [anon_sym_LT_EQ] = ACTIONS(3291),
    [anon_sym_GT] = ACTIONS(3291),
    [anon_sym_GT_EQ] = ACTIONS(3307),
    [anon_sym_CARET] = ACTIONS(3309),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_SLASH] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [sym_comment] = ACTIONS(87),
  },
  [538] = {
    [sym__heredoc_body_start] = ACTIONS(731),
    [sym__binary_minus] = ACTIONS(731),
    [sym__binary_star] = ACTIONS(731),
    [anon_sym_LBRACE] = ACTIONS(731),
    [anon_sym_RBRACE] = ACTIONS(731),
    [anon_sym_RPAREN] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(3311),
    [anon_sym_COMMA] = ACTIONS(731),
    [anon_sym_PIPE] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(731),
    [anon_sym_STAR_STAR] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(735),
    [anon_sym_EQ] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(735),
    [anon_sym_if] = ACTIONS(731),
    [anon_sym_unless] = ACTIONS(731),
    [anon_sym_while] = ACTIONS(731),
    [anon_sym_until] = ACTIONS(731),
    [anon_sym_rescue] = ACTIONS(731),
    [anon_sym_in] = ACTIONS(731),
    [anon_sym_do] = ACTIONS(731),
    [anon_sym_LBRACK] = ACTIONS(3313),
    [anon_sym_RBRACK] = ACTIONS(731),
    [anon_sym_COLON_COLON2] = ACTIONS(3315),
    [anon_sym_AMP_DOT] = ACTIONS(3317),
    [anon_sym_QMARK] = ACTIONS(731),
    [anon_sym_COLON2] = ACTIONS(735),
    [anon_sym_DOT_DOT] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(731),
    [anon_sym_or] = ACTIONS(731),
    [anon_sym_PIPE_PIPE] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(731),
    [anon_sym_LT_LT] = ACTIONS(731),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_EQ_EQ] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(731),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(731),
    [anon_sym_LT_EQ_GT] = ACTIONS(731),
    [anon_sym_EQ_TILDE] = ACTIONS(731),
    [anon_sym_BANG_TILDE] = ACTIONS(731),
    [anon_sym_LT_EQ] = ACTIONS(735),
    [anon_sym_GT] = ACTIONS(735),
    [anon_sym_GT_EQ] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(731),
    [anon_sym_SLASH] = ACTIONS(731),
    [anon_sym_PERCENT] = ACTIONS(731),
    [sym_comment] = ACTIONS(87),
  },
  [539] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1844),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1851),
    [sym_scope_resolution] = STATE(1845),
    [sym_call] = STATE(1845),
    [sym_method_call] = STATE(1851),
    [sym_argument_list] = STATE(1846),
    [sym__argument_list_with_parens] = STATE(1847),
    [sym__argument] = STATE(1848),
    [sym_splat_argument] = STATE(1848),
    [sym_hash_splat_argument] = STATE(1848),
    [sym_block_argument] = STATE(1848),
    [sym_do_block] = STATE(1849),
    [sym_block] = STATE(1849),
    [sym_assignment] = STATE(1844),
    [sym_operator_assignment] = STATE(1844),
    [sym_conditional] = STATE(1844),
    [sym_range] = STATE(1844),
    [sym_binary] = STATE(1844),
    [sym_unary] = STATE(1844),
    [sym_left_assignment_list] = STATE(1850),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1851),
    [sym__variable] = STATE(1845),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1851),
    [sym_false] = STATE(1851),
    [sym_nil] = STATE(1851),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1852),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(1848),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(3319),
    [sym__splat_star] = ACTIONS(3321),
    [sym__unary_minus] = ACTIONS(3323),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(3325),
    [anon_sym_LBRACE] = ACTIONS(3327),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3329),
    [anon_sym_yield] = ACTIONS(3331),
    [anon_sym_break] = ACTIONS(3333),
    [anon_sym_next] = ACTIONS(3335),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(3337),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(3339),
    [anon_sym_not] = ACTIONS(3341),
    [anon_sym_BANG] = ACTIONS(3343),
    [anon_sym_TILDE] = ACTIONS(3345),
    [sym_constant] = ACTIONS(3347),
    [sym_identifier] = ACTIONS(3347),
    [sym_instance_variable] = ACTIONS(3349),
    [sym_class_variable] = ACTIONS(3349),
    [sym_global_variable] = ACTIONS(3349),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3351),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3351),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [540] = {
    [anon_sym_EQ] = ACTIONS(3353),
    [sym_comment] = ACTIONS(87),
  },
  [541] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(3355),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(3357),
    [anon_sym_DASH_EQ] = ACTIONS(3357),
    [anon_sym_STAR_EQ] = ACTIONS(3357),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3357),
    [anon_sym_SLASH_EQ] = ACTIONS(3357),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3357),
    [anon_sym_PIPE_EQ] = ACTIONS(3357),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3357),
    [anon_sym_AMP_EQ] = ACTIONS(3357),
    [anon_sym_PERCENT_EQ] = ACTIONS(3357),
    [anon_sym_GT_GT_EQ] = ACTIONS(3357),
    [anon_sym_LT_LT_EQ] = ACTIONS(3357),
    [anon_sym_CARET_EQ] = ACTIONS(3357),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [542] = {
    [sym_string] = STATE(1855),
    [aux_sym_chained_string_repeat1] = STATE(1855),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [543] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1856),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(1856),
    [sym_operator_assignment] = STATE(1856),
    [sym_conditional] = STATE(1856),
    [sym_range] = STATE(1856),
    [sym_binary] = STATE(1856),
    [sym_unary] = STATE(1856),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(485),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(495),
    [anon_sym_defined_QMARK] = ACTIONS(497),
    [anon_sym_not] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(501),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [544] = {
    [sym_superclass] = STATE(1857),
    [sym_heredoc_body] = STATE(1858),
    [sym__terminator] = STATE(1858),
    [sym__line_break] = ACTIONS(3359),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1089),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(3359),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1089),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1517),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1089),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [545] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_superclass] = STATE(1857),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(859),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym_argument_list] = STATE(832),
    [sym__argument_list_with_parens] = STATE(860),
    [sym__argument] = STATE(861),
    [sym_splat_argument] = STATE(861),
    [sym_hash_splat_argument] = STATE(861),
    [sym_block_argument] = STATE(861),
    [sym_do_block] = STATE(835),
    [sym_block] = STATE(835),
    [sym_assignment] = STATE(859),
    [sym_operator_assignment] = STATE(859),
    [sym_conditional] = STATE(859),
    [sym_range] = STATE(859),
    [sym_binary] = STATE(859),
    [sym_unary] = STATE(859),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(864),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_heredoc_body] = STATE(1858),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(861),
    [sym_lambda] = STATE(347),
    [sym__terminator] = STATE(1858),
    [sym__line_break] = ACTIONS(3359),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1521),
    [sym__splat_star] = ACTIONS(1523),
    [sym__unary_minus] = ACTIONS(1525),
    [sym__identifier_hash_key] = ACTIONS(1527),
    [anon_sym_LBRACE] = ACTIONS(1529),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(743),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(3359),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1531),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(1517),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1473),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(1549),
    [sym_identifier] = ACTIONS(1549),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [546] = {
    [sym_heredoc_body] = STATE(1860),
    [sym__terminator] = STATE(1860),
    [sym__line_break] = ACTIONS(3361),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1089),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(3361),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1089),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(3363),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1089),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [547] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(859),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym_argument_list] = STATE(832),
    [sym__argument_list_with_parens] = STATE(860),
    [sym__argument] = STATE(861),
    [sym_splat_argument] = STATE(861),
    [sym_hash_splat_argument] = STATE(861),
    [sym_block_argument] = STATE(861),
    [sym_do_block] = STATE(835),
    [sym_block] = STATE(835),
    [sym_assignment] = STATE(859),
    [sym_operator_assignment] = STATE(859),
    [sym_conditional] = STATE(859),
    [sym_range] = STATE(859),
    [sym_binary] = STATE(859),
    [sym_unary] = STATE(859),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(864),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_heredoc_body] = STATE(1860),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(861),
    [sym_lambda] = STATE(347),
    [sym__terminator] = STATE(1860),
    [sym__line_break] = ACTIONS(3361),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1521),
    [sym__splat_star] = ACTIONS(1523),
    [sym__unary_minus] = ACTIONS(1525),
    [sym__identifier_hash_key] = ACTIONS(1527),
    [anon_sym_LBRACE] = ACTIONS(1529),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(743),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(3361),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1531),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_end] = ACTIONS(3363),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1473),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(1549),
    [sym_identifier] = ACTIONS(1549),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [548] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(1861),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(567),
    [sym_scope_resolution] = STATE(562),
    [sym_call] = STATE(562),
    [sym_method_call] = STATE(567),
    [sym_assignment] = STATE(1861),
    [sym_operator_assignment] = STATE(1861),
    [sym_conditional] = STATE(1861),
    [sym_range] = STATE(1861),
    [sym_binary] = STATE(1861),
    [sym_unary] = STATE(1861),
    [sym_left_assignment_list] = STATE(566),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(567),
    [sym__variable] = STATE(562),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(567),
    [sym_false] = STATE(567),
    [sym_nil] = STATE(567),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1862),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1049),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1079),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [549] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(1863),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(567),
    [sym_scope_resolution] = STATE(562),
    [sym_call] = STATE(562),
    [sym_method_call] = STATE(567),
    [sym_assignment] = STATE(1863),
    [sym_operator_assignment] = STATE(1863),
    [sym_conditional] = STATE(1863),
    [sym_range] = STATE(1863),
    [sym_binary] = STATE(1863),
    [sym_unary] = STATE(1863),
    [sym_left_assignment_list] = STATE(566),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(567),
    [sym__variable] = STATE(562),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(567),
    [sym_false] = STATE(567),
    [sym_nil] = STATE(567),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1862),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1049),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1079),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [550] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(1864),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(567),
    [sym_scope_resolution] = STATE(562),
    [sym_call] = STATE(562),
    [sym_method_call] = STATE(567),
    [sym_assignment] = STATE(1864),
    [sym_operator_assignment] = STATE(1864),
    [sym_conditional] = STATE(1864),
    [sym_range] = STATE(1864),
    [sym_binary] = STATE(1864),
    [sym_unary] = STATE(1864),
    [sym_left_assignment_list] = STATE(566),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(567),
    [sym__variable] = STATE(562),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(567),
    [sym_false] = STATE(567),
    [sym_nil] = STATE(567),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1862),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1049),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1079),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [551] = {
    [anon_sym_COLON] = ACTIONS(3365),
    [sym_comment] = ACTIONS(87),
  },
  [552] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(1866),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(567),
    [sym_scope_resolution] = STATE(562),
    [sym_call] = STATE(562),
    [sym_method_call] = STATE(567),
    [sym_assignment] = STATE(1866),
    [sym_operator_assignment] = STATE(1866),
    [sym_conditional] = STATE(1866),
    [sym_range] = STATE(1866),
    [sym_binary] = STATE(1866),
    [sym_unary] = STATE(1866),
    [sym_left_assignment_list] = STATE(566),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(567),
    [sym__variable] = STATE(562),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(567),
    [sym_false] = STATE(567),
    [sym_nil] = STATE(567),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1862),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1049),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1079),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [553] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(561),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(567),
    [sym_scope_resolution] = STATE(562),
    [sym_call] = STATE(562),
    [sym_method_call] = STATE(567),
    [sym_argument_list] = STATE(1318),
    [sym__argument_list_with_parens] = STATE(1867),
    [sym__argument] = STATE(1868),
    [sym_splat_argument] = STATE(1868),
    [sym_hash_splat_argument] = STATE(1868),
    [sym_block_argument] = STATE(1868),
    [sym_assignment] = STATE(561),
    [sym_operator_assignment] = STATE(561),
    [sym_conditional] = STATE(561),
    [sym_range] = STATE(561),
    [sym_binary] = STATE(561),
    [sym_unary] = STATE(561),
    [sym_left_assignment_list] = STATE(566),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(567),
    [sym__variable] = STATE(562),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(567),
    [sym_false] = STATE(567),
    [sym_nil] = STATE(567),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(568),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(1868),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1047),
    [sym__unary_minus] = ACTIONS(1049),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(1075),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [554] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(561),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(567),
    [sym_scope_resolution] = STATE(562),
    [sym_call] = STATE(562),
    [sym_method_call] = STATE(567),
    [sym_argument_list] = STATE(1324),
    [sym__argument_list_with_parens] = STATE(1867),
    [sym__argument] = STATE(1868),
    [sym_splat_argument] = STATE(1868),
    [sym_hash_splat_argument] = STATE(1868),
    [sym_block_argument] = STATE(1868),
    [sym_assignment] = STATE(561),
    [sym_operator_assignment] = STATE(561),
    [sym_conditional] = STATE(561),
    [sym_range] = STATE(561),
    [sym_binary] = STATE(561),
    [sym_unary] = STATE(561),
    [sym_left_assignment_list] = STATE(566),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(567),
    [sym__variable] = STATE(562),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(567),
    [sym_false] = STATE(567),
    [sym_nil] = STATE(567),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(568),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(1868),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1047),
    [sym__unary_minus] = ACTIONS(1049),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(1075),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [555] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(561),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(567),
    [sym_scope_resolution] = STATE(562),
    [sym_call] = STATE(562),
    [sym_method_call] = STATE(567),
    [sym_argument_list] = STATE(1325),
    [sym__argument_list_with_parens] = STATE(1867),
    [sym__argument] = STATE(1868),
    [sym_splat_argument] = STATE(1868),
    [sym_hash_splat_argument] = STATE(1868),
    [sym_block_argument] = STATE(1868),
    [sym_assignment] = STATE(561),
    [sym_operator_assignment] = STATE(561),
    [sym_conditional] = STATE(561),
    [sym_range] = STATE(561),
    [sym_binary] = STATE(561),
    [sym_unary] = STATE(561),
    [sym_left_assignment_list] = STATE(566),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(567),
    [sym__variable] = STATE(562),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(567),
    [sym_false] = STATE(567),
    [sym_nil] = STATE(567),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(568),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(1868),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1047),
    [sym__unary_minus] = ACTIONS(1049),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(1075),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [556] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(561),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(567),
    [sym_scope_resolution] = STATE(562),
    [sym_call] = STATE(562),
    [sym_method_call] = STATE(567),
    [sym_argument_list] = STATE(1326),
    [sym__argument_list_with_parens] = STATE(1867),
    [sym__argument] = STATE(1868),
    [sym_splat_argument] = STATE(1868),
    [sym_hash_splat_argument] = STATE(1868),
    [sym_block_argument] = STATE(1868),
    [sym_assignment] = STATE(561),
    [sym_operator_assignment] = STATE(561),
    [sym_conditional] = STATE(561),
    [sym_range] = STATE(561),
    [sym_binary] = STATE(561),
    [sym_unary] = STATE(561),
    [sym_left_assignment_list] = STATE(566),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(567),
    [sym__variable] = STATE(562),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(567),
    [sym_false] = STATE(567),
    [sym_nil] = STATE(567),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(568),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(1868),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1047),
    [sym__unary_minus] = ACTIONS(1049),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(1075),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [557] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(906),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(911),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(911),
    [sym__argument_list_with_trailing_comma] = STATE(1870),
    [sym__argument] = STATE(909),
    [sym_splat_argument] = STATE(909),
    [sym_hash_splat_argument] = STATE(909),
    [sym_block_argument] = STATE(909),
    [sym_assignment] = STATE(906),
    [sym_operator_assignment] = STATE(906),
    [sym_conditional] = STATE(906),
    [sym_range] = STATE(906),
    [sym_binary] = STATE(906),
    [sym_unary] = STATE(906),
    [sym_left_assignment_list] = STATE(910),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(911),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(911),
    [sym_false] = STATE(911),
    [sym_nil] = STATE(911),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(912),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(909),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1589),
    [sym__splat_star] = ACTIONS(1591),
    [sym__unary_minus] = ACTIONS(1593),
    [sym__identifier_hash_key] = ACTIONS(1595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(3367),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1599),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_defined_QMARK] = ACTIONS(1611),
    [anon_sym_not] = ACTIONS(1613),
    [anon_sym_BANG] = ACTIONS(1615),
    [anon_sym_TILDE] = ACTIONS(1615),
    [sym_constant] = ACTIONS(1617),
    [sym_identifier] = ACTIONS(1617),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [558] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(1871),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(567),
    [sym_scope_resolution] = STATE(562),
    [sym_call] = STATE(562),
    [sym_method_call] = STATE(567),
    [sym_assignment] = STATE(1871),
    [sym_operator_assignment] = STATE(1871),
    [sym_conditional] = STATE(1871),
    [sym_range] = STATE(1871),
    [sym_binary] = STATE(1871),
    [sym_unary] = STATE(1871),
    [sym_left_assignment_list] = STATE(566),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(567),
    [sym__variable] = STATE(562),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(567),
    [sym_false] = STATE(567),
    [sym_nil] = STATE(567),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1862),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1049),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1079),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [559] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(1872),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(567),
    [sym_scope_resolution] = STATE(562),
    [sym_call] = STATE(562),
    [sym_method_call] = STATE(567),
    [sym_assignment] = STATE(1872),
    [sym_operator_assignment] = STATE(1872),
    [sym_conditional] = STATE(1872),
    [sym_range] = STATE(1872),
    [sym_binary] = STATE(1872),
    [sym_unary] = STATE(1872),
    [sym_left_assignment_list] = STATE(566),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(567),
    [sym__variable] = STATE(562),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(567),
    [sym_false] = STATE(567),
    [sym_nil] = STATE(567),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1862),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1049),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1079),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [560] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(3369),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [561] = {
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(3371),
    [sym__binary_star] = ACTIONS(3373),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(3375),
    [anon_sym_STAR_STAR] = ACTIONS(3373),
    [anon_sym_AMP] = ACTIONS(3377),
    [anon_sym_LT] = ACTIONS(3379),
    [anon_sym_EQ_GT] = ACTIONS(1625),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(3381),
    [anon_sym_DOT_DOT] = ACTIONS(3383),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3385),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(3387),
    [anon_sym_AMP_AMP] = ACTIONS(3387),
    [anon_sym_LT_LT] = ACTIONS(3389),
    [anon_sym_GT_GT] = ACTIONS(3389),
    [anon_sym_EQ_EQ] = ACTIONS(3391),
    [anon_sym_BANG_EQ] = ACTIONS(3387),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3387),
    [anon_sym_LT_EQ_GT] = ACTIONS(3387),
    [anon_sym_EQ_TILDE] = ACTIONS(3387),
    [anon_sym_BANG_TILDE] = ACTIONS(3387),
    [anon_sym_LT_EQ] = ACTIONS(3379),
    [anon_sym_GT] = ACTIONS(3379),
    [anon_sym_GT_EQ] = ACTIONS(3393),
    [anon_sym_CARET] = ACTIONS(3395),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_SLASH] = ACTIONS(3373),
    [anon_sym_PERCENT] = ACTIONS(3373),
    [sym_comment] = ACTIONS(87),
  },
  [562] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(644),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_argument_list] = STATE(1379),
    [sym__argument_list_with_parens] = STATE(648),
    [sym__argument] = STATE(649),
    [sym_splat_argument] = STATE(649),
    [sym_hash_splat_argument] = STATE(649),
    [sym_block_argument] = STATE(649),
    [sym_do_block] = STATE(1382),
    [sym_block] = STATE(1382),
    [sym_assignment] = STATE(644),
    [sym_operator_assignment] = STATE(644),
    [sym_conditional] = STATE(644),
    [sym_range] = STATE(644),
    [sym_binary] = STATE(644),
    [sym_unary] = STATE(644),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(653),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(649),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(1155),
    [sym__splat_star] = ACTIONS(1157),
    [sym__unary_minus] = ACTIONS(1159),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(2403),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(2413),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1205),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1209),
    [sym_identifier] = ACTIONS(1209),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [563] = {
    [sym__binary_minus] = ACTIONS(1677),
    [sym__binary_star] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1677),
    [anon_sym_RBRACE] = ACTIONS(1677),
    [anon_sym_RPAREN] = ACTIONS(1677),
    [anon_sym_DOT] = ACTIONS(1679),
    [anon_sym_COMMA] = ACTIONS(1677),
    [anon_sym_PIPE] = ACTIONS(1679),
    [anon_sym_SEMI] = ACTIONS(1677),
    [anon_sym_STAR_STAR] = ACTIONS(1677),
    [anon_sym_AMP] = ACTIONS(1679),
    [anon_sym_LT] = ACTIONS(1679),
    [anon_sym_if] = ACTIONS(1677),
    [anon_sym_unless] = ACTIONS(1677),
    [anon_sym_while] = ACTIONS(1677),
    [anon_sym_until] = ACTIONS(1677),
    [anon_sym_rescue] = ACTIONS(1677),
    [anon_sym_do] = ACTIONS(1677),
    [anon_sym_EQ_GT] = ACTIONS(1677),
    [anon_sym_LBRACK] = ACTIONS(1677),
    [anon_sym_COLON_COLON2] = ACTIONS(1677),
    [anon_sym_AMP_DOT] = ACTIONS(1677),
    [anon_sym_QMARK] = ACTIONS(1677),
    [anon_sym_COLON2] = ACTIONS(1679),
    [anon_sym_DOT_DOT] = ACTIONS(1679),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1677),
    [anon_sym_and] = ACTIONS(1677),
    [anon_sym_or] = ACTIONS(1677),
    [anon_sym_PIPE_PIPE] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_LT_LT] = ACTIONS(1677),
    [anon_sym_GT_GT] = ACTIONS(1677),
    [anon_sym_EQ_EQ] = ACTIONS(1679),
    [anon_sym_BANG_EQ] = ACTIONS(1677),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1677),
    [anon_sym_LT_EQ_GT] = ACTIONS(1677),
    [anon_sym_EQ_TILDE] = ACTIONS(1677),
    [anon_sym_BANG_TILDE] = ACTIONS(1677),
    [anon_sym_LT_EQ] = ACTIONS(1679),
    [anon_sym_GT] = ACTIONS(1679),
    [anon_sym_GT_EQ] = ACTIONS(1677),
    [anon_sym_CARET] = ACTIONS(1677),
    [anon_sym_PLUS] = ACTIONS(1677),
    [anon_sym_SLASH] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [sym_comment] = ACTIONS(87),
  },
  [564] = {
    [sym_heredoc_body] = STATE(1885),
    [aux_sym_call_repeat1] = STATE(1885),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [565] = {
    [sym_heredoc_body] = STATE(1885),
    [aux_sym_call_repeat1] = STATE(1885),
    [aux_sym_argument_list_repeat1] = STATE(1887),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(3399),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [566] = {
    [anon_sym_EQ] = ACTIONS(3401),
    [sym_comment] = ACTIONS(87),
  },
  [567] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(3403),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(3405),
    [anon_sym_DASH_EQ] = ACTIONS(3405),
    [anon_sym_STAR_EQ] = ACTIONS(3405),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3405),
    [anon_sym_SLASH_EQ] = ACTIONS(3405),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3405),
    [anon_sym_PIPE_EQ] = ACTIONS(3405),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3405),
    [anon_sym_AMP_EQ] = ACTIONS(3405),
    [anon_sym_PERCENT_EQ] = ACTIONS(3405),
    [anon_sym_GT_GT_EQ] = ACTIONS(3405),
    [anon_sym_LT_LT_EQ] = ACTIONS(3405),
    [anon_sym_CARET_EQ] = ACTIONS(3405),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [568] = {
    [sym_string] = STATE(1890),
    [aux_sym_chained_string_repeat1] = STATE(1890),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(3407),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [569] = {
    [sym__binary_minus] = ACTIONS(1697),
    [sym__binary_star] = ACTIONS(1697),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_RBRACE] = ACTIONS(1697),
    [anon_sym_RPAREN] = ACTIONS(1697),
    [anon_sym_DOT] = ACTIONS(1699),
    [anon_sym_COMMA] = ACTIONS(1697),
    [anon_sym_PIPE] = ACTIONS(1699),
    [anon_sym_SEMI] = ACTIONS(1697),
    [anon_sym_STAR_STAR] = ACTIONS(1697),
    [anon_sym_AMP] = ACTIONS(1699),
    [anon_sym_LT] = ACTIONS(1699),
    [anon_sym_if] = ACTIONS(1697),
    [anon_sym_unless] = ACTIONS(1697),
    [anon_sym_while] = ACTIONS(1697),
    [anon_sym_until] = ACTIONS(1697),
    [anon_sym_rescue] = ACTIONS(1697),
    [anon_sym_do] = ACTIONS(1697),
    [anon_sym_EQ_GT] = ACTIONS(1697),
    [anon_sym_LBRACK] = ACTIONS(1697),
    [anon_sym_COLON_COLON2] = ACTIONS(1697),
    [anon_sym_AMP_DOT] = ACTIONS(1697),
    [anon_sym_QMARK] = ACTIONS(1697),
    [anon_sym_COLON2] = ACTIONS(1699),
    [anon_sym_DOT_DOT] = ACTIONS(1699),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1697),
    [anon_sym_and] = ACTIONS(1697),
    [anon_sym_or] = ACTIONS(1697),
    [anon_sym_PIPE_PIPE] = ACTIONS(1697),
    [anon_sym_AMP_AMP] = ACTIONS(1697),
    [anon_sym_LT_LT] = ACTIONS(1697),
    [anon_sym_GT_GT] = ACTIONS(1697),
    [anon_sym_EQ_EQ] = ACTIONS(1699),
    [anon_sym_BANG_EQ] = ACTIONS(1697),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1697),
    [anon_sym_LT_EQ_GT] = ACTIONS(1697),
    [anon_sym_EQ_TILDE] = ACTIONS(1697),
    [anon_sym_BANG_TILDE] = ACTIONS(1697),
    [anon_sym_LT_EQ] = ACTIONS(1699),
    [anon_sym_GT] = ACTIONS(1699),
    [anon_sym_GT_EQ] = ACTIONS(1697),
    [anon_sym_CARET] = ACTIONS(1697),
    [anon_sym_PLUS] = ACTIONS(1697),
    [anon_sym_SLASH] = ACTIONS(1697),
    [anon_sym_PERCENT] = ACTIONS(1697),
    [sym_comment] = ACTIONS(87),
  },
  [570] = {
    [sym__binary_minus] = ACTIONS(1701),
    [sym__binary_star] = ACTIONS(1701),
    [anon_sym_LBRACE] = ACTIONS(1701),
    [anon_sym_RBRACE] = ACTIONS(1701),
    [anon_sym_RPAREN] = ACTIONS(1701),
    [anon_sym_DOT] = ACTIONS(1703),
    [anon_sym_COMMA] = ACTIONS(1701),
    [anon_sym_PIPE] = ACTIONS(1703),
    [anon_sym_SEMI] = ACTIONS(1701),
    [anon_sym_STAR_STAR] = ACTIONS(1701),
    [anon_sym_AMP] = ACTIONS(1703),
    [anon_sym_LT] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1701),
    [anon_sym_unless] = ACTIONS(1701),
    [anon_sym_while] = ACTIONS(1701),
    [anon_sym_until] = ACTIONS(1701),
    [anon_sym_rescue] = ACTIONS(1701),
    [anon_sym_do] = ACTIONS(1701),
    [anon_sym_EQ_GT] = ACTIONS(1701),
    [anon_sym_LBRACK] = ACTIONS(1701),
    [anon_sym_COLON_COLON2] = ACTIONS(1701),
    [anon_sym_AMP_DOT] = ACTIONS(1701),
    [anon_sym_QMARK] = ACTIONS(1701),
    [anon_sym_COLON2] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1703),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1701),
    [anon_sym_and] = ACTIONS(1701),
    [anon_sym_or] = ACTIONS(1701),
    [anon_sym_PIPE_PIPE] = ACTIONS(1701),
    [anon_sym_AMP_AMP] = ACTIONS(1701),
    [anon_sym_LT_LT] = ACTIONS(1701),
    [anon_sym_GT_GT] = ACTIONS(1701),
    [anon_sym_EQ_EQ] = ACTIONS(1703),
    [anon_sym_BANG_EQ] = ACTIONS(1701),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1701),
    [anon_sym_LT_EQ_GT] = ACTIONS(1701),
    [anon_sym_EQ_TILDE] = ACTIONS(1701),
    [anon_sym_BANG_TILDE] = ACTIONS(1701),
    [anon_sym_LT_EQ] = ACTIONS(1703),
    [anon_sym_GT] = ACTIONS(1703),
    [anon_sym_GT_EQ] = ACTIONS(1701),
    [anon_sym_CARET] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(1701),
    [anon_sym_SLASH] = ACTIONS(1701),
    [anon_sym_PERCENT] = ACTIONS(1701),
    [sym_comment] = ACTIONS(87),
  },
  [571] = {
    [sym__binary_minus] = ACTIONS(1705),
    [sym__binary_star] = ACTIONS(1705),
    [anon_sym_LBRACE] = ACTIONS(1705),
    [anon_sym_RBRACE] = ACTIONS(1705),
    [anon_sym_RPAREN] = ACTIONS(1705),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1705),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1705),
    [anon_sym_STAR_STAR] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1705),
    [anon_sym_unless] = ACTIONS(1705),
    [anon_sym_while] = ACTIONS(1705),
    [anon_sym_until] = ACTIONS(1705),
    [anon_sym_rescue] = ACTIONS(1705),
    [anon_sym_do] = ACTIONS(1705),
    [anon_sym_EQ_GT] = ACTIONS(1705),
    [anon_sym_LBRACK] = ACTIONS(1705),
    [anon_sym_COLON_COLON2] = ACTIONS(1705),
    [anon_sym_AMP_DOT] = ACTIONS(1705),
    [anon_sym_QMARK] = ACTIONS(1705),
    [anon_sym_COLON2] = ACTIONS(1707),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1705),
    [anon_sym_and] = ACTIONS(1705),
    [anon_sym_or] = ACTIONS(1705),
    [anon_sym_PIPE_PIPE] = ACTIONS(1705),
    [anon_sym_AMP_AMP] = ACTIONS(1705),
    [anon_sym_LT_LT] = ACTIONS(1705),
    [anon_sym_GT_GT] = ACTIONS(1705),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1705),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1705),
    [anon_sym_LT_EQ_GT] = ACTIONS(1705),
    [anon_sym_EQ_TILDE] = ACTIONS(1705),
    [anon_sym_BANG_TILDE] = ACTIONS(1705),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1705),
    [anon_sym_CARET] = ACTIONS(1705),
    [anon_sym_PLUS] = ACTIONS(1705),
    [anon_sym_SLASH] = ACTIONS(1705),
    [anon_sym_PERCENT] = ACTIONS(1705),
    [sym_comment] = ACTIONS(87),
  },
  [572] = {
    [sym_then] = STATE(1891),
    [sym_heredoc_body] = STATE(1892),
    [sym__terminator] = STATE(1892),
    [sym__line_break] = ACTIONS(3409),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(3409),
    [anon_sym_if] = ACTIONS(1743),
    [anon_sym_unless] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1747),
    [anon_sym_until] = ACTIONS(1749),
    [anon_sym_rescue] = ACTIONS(1751),
    [anon_sym_then] = ACTIONS(1753),
    [sym_comment] = ACTIONS(87),
  },
  [573] = {
    [sym_then] = STATE(1893),
    [sym_heredoc_body] = STATE(1894),
    [sym__terminator] = STATE(1894),
    [sym__line_break] = ACTIONS(3411),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(3411),
    [anon_sym_if] = ACTIONS(1743),
    [anon_sym_unless] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1747),
    [anon_sym_until] = ACTIONS(1749),
    [anon_sym_rescue] = ACTIONS(1751),
    [anon_sym_then] = ACTIONS(1821),
    [sym_comment] = ACTIONS(87),
  },
  [574] = {
    [sym__do] = STATE(1895),
    [sym_heredoc_body] = STATE(1895),
    [sym__terminator] = STATE(1895),
    [sym__line_break] = ACTIONS(3413),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym__binary_minus] = ACTIONS(1855),
    [sym__binary_star] = ACTIONS(1857),
    [anon_sym_PIPE] = ACTIONS(1859),
    [anon_sym_SEMI] = ACTIONS(3413),
    [anon_sym_STAR_STAR] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_LT] = ACTIONS(1863),
    [anon_sym_do] = ACTIONS(3413),
    [anon_sym_QMARK] = ACTIONS(1865),
    [anon_sym_DOT_DOT] = ACTIONS(1867),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1869),
    [anon_sym_and] = ACTIONS(1871),
    [anon_sym_or] = ACTIONS(1871),
    [anon_sym_PIPE_PIPE] = ACTIONS(1873),
    [anon_sym_AMP_AMP] = ACTIONS(1873),
    [anon_sym_LT_LT] = ACTIONS(1875),
    [anon_sym_GT_GT] = ACTIONS(1875),
    [anon_sym_EQ_EQ] = ACTIONS(1877),
    [anon_sym_BANG_EQ] = ACTIONS(1873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1873),
    [anon_sym_LT_EQ_GT] = ACTIONS(1873),
    [anon_sym_EQ_TILDE] = ACTIONS(1873),
    [anon_sym_BANG_TILDE] = ACTIONS(1873),
    [anon_sym_LT_EQ] = ACTIONS(1863),
    [anon_sym_GT] = ACTIONS(1863),
    [anon_sym_GT_EQ] = ACTIONS(1879),
    [anon_sym_CARET] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_SLASH] = ACTIONS(1857),
    [anon_sym_PERCENT] = ACTIONS(1857),
    [sym_comment] = ACTIONS(87),
  },
  [575] = {
    [sym__do] = STATE(1896),
    [sym_heredoc_body] = STATE(1896),
    [sym__terminator] = STATE(1896),
    [sym__line_break] = ACTIONS(3415),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym__binary_minus] = ACTIONS(1855),
    [sym__binary_star] = ACTIONS(1857),
    [anon_sym_PIPE] = ACTIONS(1859),
    [anon_sym_SEMI] = ACTIONS(3415),
    [anon_sym_STAR_STAR] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_LT] = ACTIONS(1863),
    [anon_sym_do] = ACTIONS(3415),
    [anon_sym_QMARK] = ACTIONS(1865),
    [anon_sym_DOT_DOT] = ACTIONS(1867),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1869),
    [anon_sym_and] = ACTIONS(1871),
    [anon_sym_or] = ACTIONS(1871),
    [anon_sym_PIPE_PIPE] = ACTIONS(1873),
    [anon_sym_AMP_AMP] = ACTIONS(1873),
    [anon_sym_LT_LT] = ACTIONS(1875),
    [anon_sym_GT_GT] = ACTIONS(1875),
    [anon_sym_EQ_EQ] = ACTIONS(1877),
    [anon_sym_BANG_EQ] = ACTIONS(1873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1873),
    [anon_sym_LT_EQ_GT] = ACTIONS(1873),
    [anon_sym_EQ_TILDE] = ACTIONS(1873),
    [anon_sym_BANG_TILDE] = ACTIONS(1873),
    [anon_sym_LT_EQ] = ACTIONS(1863),
    [anon_sym_GT] = ACTIONS(1863),
    [anon_sym_GT_EQ] = ACTIONS(1879),
    [anon_sym_CARET] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_SLASH] = ACTIONS(1857),
    [anon_sym_PERCENT] = ACTIONS(1857),
    [sym_comment] = ACTIONS(87),
  },
  [576] = {
    [sym_in] = STATE(1897),
    [anon_sym_in] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
  },
  [577] = {
    [sym_heredoc_body] = STATE(1898),
    [sym__terminator] = STATE(1898),
    [sym__line_break] = ACTIONS(3417),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym__binary_minus] = ACTIONS(2001),
    [sym__binary_star] = ACTIONS(2003),
    [anon_sym_PIPE] = ACTIONS(2005),
    [anon_sym_SEMI] = ACTIONS(3417),
    [anon_sym_STAR_STAR] = ACTIONS(2003),
    [anon_sym_AMP] = ACTIONS(2007),
    [anon_sym_LT] = ACTIONS(2009),
    [anon_sym_QMARK] = ACTIONS(2011),
    [anon_sym_DOT_DOT] = ACTIONS(2013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2015),
    [anon_sym_and] = ACTIONS(2017),
    [anon_sym_or] = ACTIONS(2017),
    [anon_sym_PIPE_PIPE] = ACTIONS(2019),
    [anon_sym_AMP_AMP] = ACTIONS(2019),
    [anon_sym_LT_LT] = ACTIONS(2021),
    [anon_sym_GT_GT] = ACTIONS(2021),
    [anon_sym_EQ_EQ] = ACTIONS(2023),
    [anon_sym_BANG_EQ] = ACTIONS(2019),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2019),
    [anon_sym_LT_EQ_GT] = ACTIONS(2019),
    [anon_sym_EQ_TILDE] = ACTIONS(2019),
    [anon_sym_BANG_TILDE] = ACTIONS(2019),
    [anon_sym_LT_EQ] = ACTIONS(2009),
    [anon_sym_GT] = ACTIONS(2009),
    [anon_sym_GT_EQ] = ACTIONS(2025),
    [anon_sym_CARET] = ACTIONS(2027),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_SLASH] = ACTIONS(2003),
    [anon_sym_PERCENT] = ACTIONS(2003),
    [sym_comment] = ACTIONS(87),
  },
  [578] = {
    [sym_when] = STATE(1902),
    [sym_else] = STATE(1900),
    [aux_sym_case_repeat1] = STATE(1901),
    [aux_sym_case_repeat2] = STATE(1902),
    [anon_sym_SEMI] = ACTIONS(3419),
    [anon_sym_end] = ACTIONS(3421),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [579] = {
    [sym_else] = STATE(1904),
    [sym_ensure] = STATE(1905),
    [sym_rescue] = STATE(1906),
    [anon_sym_end] = ACTIONS(3423),
    [anon_sym_rescue] = ACTIONS(2165),
    [anon_sym_else] = ACTIONS(2167),
    [anon_sym_ensure] = ACTIONS(2169),
    [sym_comment] = ACTIONS(87),
  },
  [580] = {
    [sym_ensure] = STATE(1905),
    [anon_sym_end] = ACTIONS(3423),
    [anon_sym_ensure] = ACTIONS(2169),
    [sym_comment] = ACTIONS(87),
  },
  [581] = {
    [anon_sym_end] = ACTIONS(3423),
    [sym_comment] = ACTIONS(87),
  },
  [582] = {
    [sym_else] = STATE(1904),
    [sym_ensure] = STATE(1905),
    [anon_sym_end] = ACTIONS(3423),
    [anon_sym_else] = ACTIONS(2167),
    [anon_sym_ensure] = ACTIONS(2169),
    [sym_comment] = ACTIONS(87),
  },
  [583] = {
    [sym__binary_minus] = ACTIONS(2181),
    [sym__binary_star] = ACTIONS(2181),
    [anon_sym_LBRACE] = ACTIONS(2181),
    [anon_sym_RBRACE] = ACTIONS(2181),
    [anon_sym_RPAREN] = ACTIONS(2181),
    [anon_sym_DOT] = ACTIONS(2183),
    [anon_sym_COMMA] = ACTIONS(2181),
    [anon_sym_PIPE] = ACTIONS(2183),
    [anon_sym_SEMI] = ACTIONS(2181),
    [anon_sym_STAR_STAR] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2183),
    [anon_sym_LT] = ACTIONS(2183),
    [anon_sym_if] = ACTIONS(2181),
    [anon_sym_unless] = ACTIONS(2181),
    [anon_sym_while] = ACTIONS(2181),
    [anon_sym_until] = ACTIONS(2181),
    [anon_sym_rescue] = ACTIONS(2181),
    [anon_sym_do] = ACTIONS(2181),
    [anon_sym_EQ_GT] = ACTIONS(2181),
    [anon_sym_LBRACK] = ACTIONS(2181),
    [anon_sym_COLON_COLON2] = ACTIONS(2181),
    [anon_sym_AMP_DOT] = ACTIONS(2181),
    [anon_sym_QMARK] = ACTIONS(2181),
    [anon_sym_COLON2] = ACTIONS(2183),
    [anon_sym_DOT_DOT] = ACTIONS(2183),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2181),
    [anon_sym_AMP_AMP] = ACTIONS(2181),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym_EQ_EQ] = ACTIONS(2183),
    [anon_sym_BANG_EQ] = ACTIONS(2181),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2181),
    [anon_sym_LT_EQ_GT] = ACTIONS(2181),
    [anon_sym_EQ_TILDE] = ACTIONS(2181),
    [anon_sym_BANG_TILDE] = ACTIONS(2181),
    [anon_sym_LT_EQ] = ACTIONS(2183),
    [anon_sym_GT] = ACTIONS(2183),
    [anon_sym_GT_EQ] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [sym_comment] = ACTIONS(87),
  },
  [584] = {
    [sym__statements] = STATE(579),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(580),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(581),
    [sym_rescue] = STATE(582),
    [sym__body_statement] = STATE(1907),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(3425),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [585] = {
    [sym__binary_minus] = ACTIONS(1103),
    [sym__binary_star] = ACTIONS(1105),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_STAR_STAR] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(1111),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(1113),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1117),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(1121),
    [anon_sym_AMP_AMP] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1125),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1121),
    [anon_sym_LT_EQ_GT] = ACTIONS(1121),
    [anon_sym_EQ_TILDE] = ACTIONS(1121),
    [anon_sym_BANG_TILDE] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1111),
    [anon_sym_GT] = ACTIONS(1111),
    [anon_sym_GT_EQ] = ACTIONS(1127),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1103),
    [anon_sym_SLASH] = ACTIONS(1105),
    [anon_sym_PERCENT] = ACTIONS(1105),
    [sym_comment] = ACTIONS(87),
  },
  [586] = {
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(935),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_COLON2] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [587] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(1908),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(541),
    [sym_scope_resolution] = STATE(539),
    [sym_call] = STATE(539),
    [sym_method_call] = STATE(541),
    [sym_assignment] = STATE(1908),
    [sym_operator_assignment] = STATE(1908),
    [sym_conditional] = STATE(1908),
    [sym_range] = STATE(1908),
    [sym_binary] = STATE(1908),
    [sym_unary] = STATE(1908),
    [sym_left_assignment_list] = STATE(540),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(541),
    [sym__variable] = STATE(539),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(541),
    [sym_false] = STATE(541),
    [sym_nil] = STATE(541),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(542),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1021),
    [anon_sym_defined_QMARK] = ACTIONS(1023),
    [anon_sym_not] = ACTIONS(1025),
    [anon_sym_BANG] = ACTIONS(1027),
    [anon_sym_TILDE] = ACTIONS(1027),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [588] = {
    [sym__binary_minus] = ACTIONS(2261),
    [sym__binary_star] = ACTIONS(2261),
    [anon_sym_LBRACE] = ACTIONS(2261),
    [anon_sym_RBRACE] = ACTIONS(2261),
    [anon_sym_RPAREN] = ACTIONS(2261),
    [anon_sym_DOT] = ACTIONS(2263),
    [anon_sym_COMMA] = ACTIONS(2261),
    [anon_sym_PIPE] = ACTIONS(2263),
    [anon_sym_SEMI] = ACTIONS(2261),
    [anon_sym_STAR_STAR] = ACTIONS(2261),
    [anon_sym_AMP] = ACTIONS(2263),
    [anon_sym_LT] = ACTIONS(2263),
    [anon_sym_if] = ACTIONS(2261),
    [anon_sym_unless] = ACTIONS(2261),
    [anon_sym_while] = ACTIONS(2261),
    [anon_sym_until] = ACTIONS(2261),
    [anon_sym_rescue] = ACTIONS(2261),
    [anon_sym_do] = ACTIONS(2261),
    [anon_sym_EQ_GT] = ACTIONS(2261),
    [anon_sym_LBRACK] = ACTIONS(2261),
    [anon_sym_COLON_COLON2] = ACTIONS(2261),
    [anon_sym_AMP_DOT] = ACTIONS(2261),
    [anon_sym_QMARK] = ACTIONS(2261),
    [anon_sym_COLON2] = ACTIONS(2263),
    [anon_sym_DOT_DOT] = ACTIONS(2263),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2261),
    [anon_sym_and] = ACTIONS(2261),
    [anon_sym_or] = ACTIONS(2261),
    [anon_sym_PIPE_PIPE] = ACTIONS(2261),
    [anon_sym_AMP_AMP] = ACTIONS(2261),
    [anon_sym_LT_LT] = ACTIONS(2261),
    [anon_sym_GT_GT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(2263),
    [anon_sym_BANG_EQ] = ACTIONS(2261),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2261),
    [anon_sym_LT_EQ_GT] = ACTIONS(2261),
    [anon_sym_EQ_TILDE] = ACTIONS(2261),
    [anon_sym_BANG_TILDE] = ACTIONS(2261),
    [anon_sym_LT_EQ] = ACTIONS(2263),
    [anon_sym_GT] = ACTIONS(2263),
    [anon_sym_GT_EQ] = ACTIONS(2261),
    [anon_sym_CARET] = ACTIONS(2261),
    [anon_sym_PLUS] = ACTIONS(2261),
    [anon_sym_SLASH] = ACTIONS(2261),
    [anon_sym_PERCENT] = ACTIONS(2261),
    [sym_comment] = ACTIONS(87),
  },
  [589] = {
    [sym__binary_minus] = ACTIONS(2345),
    [sym__binary_star] = ACTIONS(2345),
    [anon_sym_LBRACE] = ACTIONS(2345),
    [anon_sym_RBRACE] = ACTIONS(2345),
    [anon_sym_RPAREN] = ACTIONS(2345),
    [anon_sym_DOT] = ACTIONS(2347),
    [anon_sym_COMMA] = ACTIONS(2345),
    [anon_sym_PIPE] = ACTIONS(2347),
    [anon_sym_SEMI] = ACTIONS(2345),
    [anon_sym_STAR_STAR] = ACTIONS(2345),
    [anon_sym_AMP] = ACTIONS(2347),
    [anon_sym_LT] = ACTIONS(2347),
    [anon_sym_if] = ACTIONS(2345),
    [anon_sym_unless] = ACTIONS(2345),
    [anon_sym_while] = ACTIONS(2345),
    [anon_sym_until] = ACTIONS(2345),
    [anon_sym_rescue] = ACTIONS(2345),
    [anon_sym_do] = ACTIONS(2345),
    [anon_sym_EQ_GT] = ACTIONS(2345),
    [anon_sym_LBRACK] = ACTIONS(2345),
    [anon_sym_COLON_COLON2] = ACTIONS(2345),
    [anon_sym_AMP_DOT] = ACTIONS(2345),
    [anon_sym_QMARK] = ACTIONS(2345),
    [anon_sym_COLON2] = ACTIONS(2347),
    [anon_sym_DOT_DOT] = ACTIONS(2347),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2345),
    [anon_sym_and] = ACTIONS(2345),
    [anon_sym_or] = ACTIONS(2345),
    [anon_sym_PIPE_PIPE] = ACTIONS(2345),
    [anon_sym_AMP_AMP] = ACTIONS(2345),
    [anon_sym_LT_LT] = ACTIONS(2345),
    [anon_sym_GT_GT] = ACTIONS(2345),
    [anon_sym_EQ_EQ] = ACTIONS(2347),
    [anon_sym_BANG_EQ] = ACTIONS(2345),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2345),
    [anon_sym_LT_EQ_GT] = ACTIONS(2345),
    [anon_sym_EQ_TILDE] = ACTIONS(2345),
    [anon_sym_BANG_TILDE] = ACTIONS(2345),
    [anon_sym_LT_EQ] = ACTIONS(2347),
    [anon_sym_GT] = ACTIONS(2347),
    [anon_sym_GT_EQ] = ACTIONS(2345),
    [anon_sym_CARET] = ACTIONS(2345),
    [anon_sym_PLUS] = ACTIONS(2345),
    [anon_sym_SLASH] = ACTIONS(2345),
    [anon_sym_PERCENT] = ACTIONS(2345),
    [sym_comment] = ACTIONS(87),
  },
  [590] = {
    [anon_sym_RBRACK] = ACTIONS(3427),
    [sym_comment] = ACTIONS(87),
  },
  [591] = {
    [sym__statements] = STATE(1911),
    [sym_begin_block] = STATE(489),
    [sym_end_block] = STATE(489),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_block_parameters] = STATE(1912),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(495),
    [aux_sym__statements_repeat1] = STATE(495),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(3429),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2445),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [592] = {
    [sym__statements] = STATE(1914),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_block_parameters] = STATE(1915),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_heredoc_body] = STATE(1916),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [sym__terminator] = STATE(1916),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__line_break] = ACTIONS(3431),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(3431),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(3433),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [593] = {
    [sym_do_block] = STATE(1917),
    [sym_block] = STATE(1917),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_do] = ACTIONS(3435),
    [sym_comment] = ACTIONS(87),
  },
  [594] = {
    [sym__binary_minus] = ACTIONS(2485),
    [sym__binary_star] = ACTIONS(2485),
    [anon_sym_LBRACE] = ACTIONS(2485),
    [anon_sym_RBRACE] = ACTIONS(2485),
    [anon_sym_RPAREN] = ACTIONS(2485),
    [anon_sym_DOT] = ACTIONS(2487),
    [anon_sym_COMMA] = ACTIONS(2485),
    [anon_sym_PIPE] = ACTIONS(2487),
    [anon_sym_SEMI] = ACTIONS(2485),
    [anon_sym_STAR_STAR] = ACTIONS(2485),
    [anon_sym_AMP] = ACTIONS(2487),
    [anon_sym_LT] = ACTIONS(2487),
    [anon_sym_if] = ACTIONS(2485),
    [anon_sym_unless] = ACTIONS(2485),
    [anon_sym_while] = ACTIONS(2485),
    [anon_sym_until] = ACTIONS(2485),
    [anon_sym_rescue] = ACTIONS(2485),
    [anon_sym_do] = ACTIONS(2485),
    [anon_sym_EQ_GT] = ACTIONS(2485),
    [anon_sym_LBRACK] = ACTIONS(2485),
    [anon_sym_COLON_COLON2] = ACTIONS(2485),
    [anon_sym_AMP_DOT] = ACTIONS(2485),
    [anon_sym_QMARK] = ACTIONS(2485),
    [anon_sym_COLON2] = ACTIONS(2487),
    [anon_sym_DOT_DOT] = ACTIONS(2487),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2485),
    [anon_sym_and] = ACTIONS(2485),
    [anon_sym_or] = ACTIONS(2485),
    [anon_sym_PIPE_PIPE] = ACTIONS(2485),
    [anon_sym_AMP_AMP] = ACTIONS(2485),
    [anon_sym_LT_LT] = ACTIONS(2485),
    [anon_sym_GT_GT] = ACTIONS(2485),
    [anon_sym_EQ_EQ] = ACTIONS(2487),
    [anon_sym_BANG_EQ] = ACTIONS(2485),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2485),
    [anon_sym_LT_EQ_GT] = ACTIONS(2485),
    [anon_sym_EQ_TILDE] = ACTIONS(2485),
    [anon_sym_BANG_TILDE] = ACTIONS(2485),
    [anon_sym_LT_EQ] = ACTIONS(2487),
    [anon_sym_GT] = ACTIONS(2487),
    [anon_sym_GT_EQ] = ACTIONS(2485),
    [anon_sym_CARET] = ACTIONS(2485),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_SLASH] = ACTIONS(2485),
    [anon_sym_PERCENT] = ACTIONS(2485),
    [sym_comment] = ACTIONS(87),
  },
  [595] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(1918),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(118),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(118),
    [sym_assignment] = STATE(1918),
    [sym_operator_assignment] = STATE(1918),
    [sym_conditional] = STATE(1918),
    [sym_range] = STATE(1918),
    [sym_binary] = STATE(1918),
    [sym_unary] = STATE(1918),
    [sym_left_assignment_list] = STATE(117),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(118),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(118),
    [sym_false] = STATE(118),
    [sym_nil] = STATE(118),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(514),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [596] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(1919),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(118),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(118),
    [sym_assignment] = STATE(1919),
    [sym_operator_assignment] = STATE(1919),
    [sym_conditional] = STATE(1919),
    [sym_range] = STATE(1919),
    [sym_binary] = STATE(1919),
    [sym_unary] = STATE(1919),
    [sym_left_assignment_list] = STATE(117),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(118),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(118),
    [sym_false] = STATE(118),
    [sym_nil] = STATE(118),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(514),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [597] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(1920),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(118),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(118),
    [sym_assignment] = STATE(1920),
    [sym_operator_assignment] = STATE(1920),
    [sym_conditional] = STATE(1920),
    [sym_range] = STATE(1920),
    [sym_binary] = STATE(1920),
    [sym_unary] = STATE(1920),
    [sym_left_assignment_list] = STATE(117),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(118),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(118),
    [sym_false] = STATE(118),
    [sym_nil] = STATE(118),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(514),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [598] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(1921),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(118),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(118),
    [sym_assignment] = STATE(1921),
    [sym_operator_assignment] = STATE(1921),
    [sym_conditional] = STATE(1921),
    [sym_range] = STATE(1921),
    [sym_binary] = STATE(1921),
    [sym_unary] = STATE(1921),
    [sym_left_assignment_list] = STATE(117),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(118),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(118),
    [sym_false] = STATE(118),
    [sym_nil] = STATE(118),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(514),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [599] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(1922),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(118),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(118),
    [sym_assignment] = STATE(1922),
    [sym_operator_assignment] = STATE(1922),
    [sym_conditional] = STATE(1922),
    [sym_range] = STATE(1922),
    [sym_binary] = STATE(1922),
    [sym_unary] = STATE(1922),
    [sym_left_assignment_list] = STATE(117),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(118),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(118),
    [sym_false] = STATE(118),
    [sym_nil] = STATE(118),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(514),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [600] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(1923),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(1923),
    [sym_operator_assignment] = STATE(1923),
    [sym_conditional] = STATE(1923),
    [sym_range] = STATE(1923),
    [sym_binary] = STATE(1923),
    [sym_unary] = STATE(1923),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [601] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(1924),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(118),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(118),
    [sym_assignment] = STATE(1924),
    [sym_operator_assignment] = STATE(1924),
    [sym_conditional] = STATE(1924),
    [sym_range] = STATE(1924),
    [sym_binary] = STATE(1924),
    [sym_unary] = STATE(1924),
    [sym_left_assignment_list] = STATE(117),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(118),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(118),
    [sym_false] = STATE(118),
    [sym_nil] = STATE(118),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(514),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [602] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(1925),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(118),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(118),
    [sym_assignment] = STATE(1925),
    [sym_operator_assignment] = STATE(1925),
    [sym_conditional] = STATE(1925),
    [sym_range] = STATE(1925),
    [sym_binary] = STATE(1925),
    [sym_unary] = STATE(1925),
    [sym_left_assignment_list] = STATE(117),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(118),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(118),
    [sym_false] = STATE(118),
    [sym_nil] = STATE(118),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(514),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [603] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(1926),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(118),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(118),
    [sym_assignment] = STATE(1926),
    [sym_operator_assignment] = STATE(1926),
    [sym_conditional] = STATE(1926),
    [sym_range] = STATE(1926),
    [sym_binary] = STATE(1926),
    [sym_unary] = STATE(1926),
    [sym_left_assignment_list] = STATE(117),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(118),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(118),
    [sym_false] = STATE(118),
    [sym_nil] = STATE(118),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(514),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [604] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(1927),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(118),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(118),
    [sym_assignment] = STATE(1927),
    [sym_operator_assignment] = STATE(1927),
    [sym_conditional] = STATE(1927),
    [sym_range] = STATE(1927),
    [sym_binary] = STATE(1927),
    [sym_unary] = STATE(1927),
    [sym_left_assignment_list] = STATE(117),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(118),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(118),
    [sym_false] = STATE(118),
    [sym_nil] = STATE(118),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(514),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [605] = {
    [sym_argument_list_with_parens] = STATE(1930),
    [sym__argument_list_with_parens] = STATE(1931),
    [sym_operator] = STATE(1930),
    [sym_heredoc_body] = STATE(1932),
    [aux_sym_call_repeat1] = STATE(1932),
    [sym__heredoc_body_start] = ACTIONS(2519),
    [anon_sym_PIPE] = ACTIONS(3437),
    [anon_sym_STAR] = ACTIONS(3439),
    [anon_sym_STAR_STAR] = ACTIONS(3437),
    [anon_sym_AMP] = ACTIONS(3437),
    [anon_sym_LT] = ACTIONS(3439),
    [anon_sym_LPAREN2] = ACTIONS(3441),
    [anon_sym_DOT_DOT] = ACTIONS(3437),
    [anon_sym_LT_LT] = ACTIONS(3437),
    [anon_sym_GT_GT] = ACTIONS(3437),
    [anon_sym_EQ_EQ] = ACTIONS(3439),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3437),
    [anon_sym_LT_EQ_GT] = ACTIONS(3437),
    [anon_sym_EQ_TILDE] = ACTIONS(3437),
    [anon_sym_BANG_TILDE] = ACTIONS(3437),
    [anon_sym_LT_EQ] = ACTIONS(3439),
    [anon_sym_GT] = ACTIONS(3439),
    [anon_sym_GT_EQ] = ACTIONS(3437),
    [anon_sym_CARET] = ACTIONS(3437),
    [anon_sym_PLUS] = ACTIONS(3439),
    [anon_sym_SLASH] = ACTIONS(3437),
    [anon_sym_PERCENT] = ACTIONS(3437),
    [anon_sym_BANG] = ACTIONS(3439),
    [anon_sym_TILDE] = ACTIONS(3437),
    [sym_constant] = ACTIONS(3443),
    [sym_identifier] = ACTIONS(3443),
    [anon_sym_DASH] = ACTIONS(3439),
    [anon_sym_PLUS_AT] = ACTIONS(3437),
    [anon_sym_DASH_AT] = ACTIONS(3437),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3439),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(3437),
    [anon_sym_BQUOTE] = ACTIONS(3437),
    [sym_comment] = ACTIONS(87),
  },
  [606] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(346),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(352),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(352),
    [sym__argument_list_with_trailing_comma] = STATE(1934),
    [sym__argument] = STATE(350),
    [sym_splat_argument] = STATE(350),
    [sym_hash_splat_argument] = STATE(350),
    [sym_block_argument] = STATE(350),
    [sym_assignment] = STATE(346),
    [sym_operator_assignment] = STATE(346),
    [sym_conditional] = STATE(346),
    [sym_range] = STATE(346),
    [sym_binary] = STATE(346),
    [sym_unary] = STATE(346),
    [sym_left_assignment_list] = STATE(351),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(352),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(352),
    [sym_false] = STATE(352),
    [sym_nil] = STATE(352),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(353),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(350),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(593),
    [sym__splat_star] = ACTIONS(595),
    [sym__unary_minus] = ACTIONS(597),
    [sym__identifier_hash_key] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(3445),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [607] = {
    [sym_constant] = ACTIONS(3447),
    [sym_identifier] = ACTIONS(3447),
    [sym_comment] = ACTIONS(87),
  },
  [608] = {
    [sym__heredoc_body_start] = ACTIONS(101),
    [sym__binary_minus] = ACTIONS(101),
    [sym__binary_star] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_RBRACE] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(103),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_PIPE] = ACTIONS(103),
    [anon_sym_SEMI] = ACTIONS(101),
    [anon_sym_STAR_STAR] = ACTIONS(103),
    [anon_sym_AMP] = ACTIONS(103),
    [anon_sym_EQ] = ACTIONS(103),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_unless] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_until] = ACTIONS(101),
    [anon_sym_rescue] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(101),
    [anon_sym_EQ_GT] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_RBRACK] = ACTIONS(101),
    [anon_sym_COLON_COLON2] = ACTIONS(101),
    [anon_sym_AMP_DOT] = ACTIONS(101),
    [anon_sym_PLUS_EQ] = ACTIONS(101),
    [anon_sym_DASH_EQ] = ACTIONS(101),
    [anon_sym_STAR_EQ] = ACTIONS(101),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(101),
    [anon_sym_SLASH_EQ] = ACTIONS(101),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(101),
    [anon_sym_PIPE_EQ] = ACTIONS(101),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(101),
    [anon_sym_AMP_EQ] = ACTIONS(101),
    [anon_sym_PERCENT_EQ] = ACTIONS(101),
    [anon_sym_GT_GT_EQ] = ACTIONS(101),
    [anon_sym_LT_LT_EQ] = ACTIONS(101),
    [anon_sym_CARET_EQ] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(103),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_and] = ACTIONS(101),
    [anon_sym_or] = ACTIONS(101),
    [anon_sym_PIPE_PIPE] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_LT_LT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_EQ_EQ] = ACTIONS(103),
    [anon_sym_BANG_EQ] = ACTIONS(101),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(101),
    [anon_sym_LT_EQ_GT] = ACTIONS(101),
    [anon_sym_EQ_TILDE] = ACTIONS(101),
    [anon_sym_BANG_TILDE] = ACTIONS(101),
    [anon_sym_LT_EQ] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_EQ] = ACTIONS(101),
    [anon_sym_CARET] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [sym_comment] = ACTIONS(87),
  },
  [609] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(1937),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(3449),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [610] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(1939),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(3451),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [611] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(1941),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(3453),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [612] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(1943),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(3455),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [613] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1946),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(3457),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(3459),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [614] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1949),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(3461),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(3463),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [615] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1951),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_assignment] = STATE(1951),
    [sym_operator_assignment] = STATE(1951),
    [sym_conditional] = STATE(1951),
    [sym_range] = STATE(1951),
    [sym_binary] = STATE(1951),
    [sym_unary] = STATE(1951),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1952),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(3469),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [616] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1953),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_assignment] = STATE(1953),
    [sym_operator_assignment] = STATE(1953),
    [sym_conditional] = STATE(1953),
    [sym_range] = STATE(1953),
    [sym_binary] = STATE(1953),
    [sym_unary] = STATE(1953),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1952),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(3469),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [617] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1954),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_assignment] = STATE(1954),
    [sym_operator_assignment] = STATE(1954),
    [sym_conditional] = STATE(1954),
    [sym_range] = STATE(1954),
    [sym_binary] = STATE(1954),
    [sym_unary] = STATE(1954),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1952),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(3469),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [618] = {
    [anon_sym_COLON] = ACTIONS(3473),
    [sym_comment] = ACTIONS(87),
  },
  [619] = {
    [sym__statements] = STATE(1957),
    [sym_begin_block] = STATE(489),
    [sym_end_block] = STATE(489),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_block_parameters] = STATE(1958),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1516),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1519),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1519),
    [sym_hash_splat_argument] = STATE(116),
    [sym_assignment] = STATE(1516),
    [sym_operator_assignment] = STATE(1516),
    [sym_conditional] = STATE(1516),
    [sym_range] = STATE(1516),
    [sym_binary] = STATE(1516),
    [sym_unary] = STATE(1516),
    [sym_left_assignment_list] = STATE(1518),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1519),
    [sym__variable] = STATE(1517),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1519),
    [sym_false] = STATE(1519),
    [sym_nil] = STATE(1519),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1520),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(1959),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym__hash_items] = STATE(1960),
    [sym_pair] = STATE(122),
    [sym_lambda] = STATE(214),
    [sym_empty_statement] = STATE(495),
    [aux_sym__statements_repeat1] = STATE(495),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2629),
    [sym__identifier_hash_key] = ACTIONS(157),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(3475),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_PIPE] = ACTIONS(2445),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2633),
    [anon_sym_yield] = ACTIONS(2635),
    [anon_sym_break] = ACTIONS(2637),
    [anon_sym_next] = ACTIONS(2639),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2641),
    [anon_sym_defined_QMARK] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2647),
    [anon_sym_TILDE] = ACTIONS(2647),
    [sym_constant] = ACTIONS(2649),
    [sym_identifier] = ACTIONS(2649),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [620] = {
    [sym__method_rest] = STATE(1962),
    [sym__variable] = STATE(1963),
    [sym_operator] = STATE(1964),
    [sym__method_name] = STATE(1964),
    [sym_setter] = STATE(1964),
    [sym_symbol] = STATE(1964),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_LPAREN] = ACTIONS(3477),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(239),
    [sym_identifier] = ACTIONS(241),
    [sym_instance_variable] = ACTIONS(239),
    [sym_class_variable] = ACTIONS(239),
    [sym_global_variable] = ACTIONS(239),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
    [sym_super] = ACTIONS(3479),
    [sym_self] = ACTIONS(3479),
  },
  [621] = {
    [sym__statements] = STATE(1966),
    [sym_begin_block] = STATE(144),
    [sym_end_block] = STATE(144),
    [sym__statement] = STATE(144),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(144),
    [sym_unless_modifier] = STATE(144),
    [sym_while_modifier] = STATE(144),
    [sym_until_modifier] = STATE(144),
    [sym_rescue_modifier] = STATE(144),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(145),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(150),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(150),
    [sym_assignment] = STATE(145),
    [sym_operator_assignment] = STATE(145),
    [sym_conditional] = STATE(145),
    [sym_range] = STATE(145),
    [sym_binary] = STATE(145),
    [sym_unary] = STATE(145),
    [sym_left_assignment_list] = STATE(147),
    [sym__mlhs] = STATE(148),
    [sym_destructured_left_assignment] = STATE(149),
    [sym_rest_assignment] = STATE(149),
    [sym__lhs] = STATE(150),
    [sym__variable] = STATE(146),
    [sym_undef] = STATE(144),
    [sym_alias] = STATE(144),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(150),
    [sym_false] = STATE(150),
    [sym_nil] = STATE(150),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(151),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(152),
    [aux_sym__statements_repeat1] = STATE(152),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_RPAREN] = ACTIONS(3481),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(249),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [anon_sym_undef] = ACTIONS(271),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [622] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1967),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_assignment] = STATE(1967),
    [sym_operator_assignment] = STATE(1967),
    [sym_conditional] = STATE(1967),
    [sym_range] = STATE(1967),
    [sym_binary] = STATE(1967),
    [sym_unary] = STATE(1967),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1952),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(3469),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [623] = {
    [sym_method] = STATE(191),
    [sym_singleton_method] = STATE(191),
    [sym_class] = STATE(191),
    [sym_singleton_class] = STATE(191),
    [sym_module] = STATE(191),
    [sym_return] = STATE(191),
    [sym_yield] = STATE(191),
    [sym_break] = STATE(191),
    [sym_next] = STATE(191),
    [sym_while] = STATE(191),
    [sym_until] = STATE(191),
    [sym_for] = STATE(191),
    [sym_case] = STATE(191),
    [sym_if] = STATE(191),
    [sym_unless] = STATE(191),
    [sym_begin] = STATE(191),
    [sym__primary] = STATE(191),
    [sym_parenthesized_statements] = STATE(191),
    [sym_element_reference] = STATE(191),
    [sym_scope_resolution] = STATE(1970),
    [sym_call] = STATE(193),
    [sym_method_call] = STATE(191),
    [sym__lhs] = STATE(191),
    [sym__variable] = STATE(193),
    [sym_rational] = STATE(191),
    [sym_true] = STATE(191),
    [sym_false] = STATE(191),
    [sym_nil] = STATE(191),
    [sym_chained_string] = STATE(191),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(191),
    [sym_string_array] = STATE(191),
    [sym_symbol_array] = STATE(191),
    [sym_symbol] = STATE(191),
    [sym_regex] = STATE(191),
    [sym_array] = STATE(191),
    [sym_hash] = STATE(191),
    [sym_lambda] = STATE(191),
    [sym__simple_symbol] = ACTIONS(279),
    [sym__string_start] = ACTIONS(281),
    [sym__symbol_start] = ACTIONS(283),
    [sym__subshell_start] = ACTIONS(285),
    [sym__regex_start] = ACTIONS(287),
    [sym__string_array_start] = ACTIONS(289),
    [sym__symbol_array_start] = ACTIONS(291),
    [sym_heredoc_beginning] = ACTIONS(349),
    [sym__singleton_class_left_angle_left_langle] = ACTIONS(3483),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_def] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(299),
    [anon_sym_COLON_COLON] = ACTIONS(353),
    [anon_sym_class] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(307),
    [anon_sym_return] = ACTIONS(309),
    [anon_sym_yield] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_next] = ACTIONS(315),
    [sym_redo] = ACTIONS(355),
    [sym_retry] = ACTIONS(355),
    [anon_sym_if] = ACTIONS(319),
    [anon_sym_unless] = ACTIONS(321),
    [anon_sym_while] = ACTIONS(323),
    [anon_sym_until] = ACTIONS(325),
    [anon_sym_for] = ACTIONS(327),
    [anon_sym_case] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(331),
    [sym_constant] = ACTIONS(3485),
    [sym_identifier] = ACTIONS(359),
    [sym_instance_variable] = ACTIONS(361),
    [sym_class_variable] = ACTIONS(361),
    [sym_global_variable] = ACTIONS(361),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(355),
    [sym_complex] = ACTIONS(349),
    [sym_super] = ACTIONS(359),
    [anon_sym_true] = ACTIONS(339),
    [anon_sym_TRUE] = ACTIONS(339),
    [anon_sym_false] = ACTIONS(341),
    [anon_sym_FALSE] = ACTIONS(341),
    [sym_self] = ACTIONS(359),
    [anon_sym_nil] = ACTIONS(343),
    [anon_sym_NIL] = ACTIONS(343),
    [sym_character] = ACTIONS(349),
    [anon_sym_LBRACK2] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(347),
  },
  [624] = {
    [sym_method] = STATE(191),
    [sym_singleton_method] = STATE(191),
    [sym_class] = STATE(191),
    [sym_singleton_class] = STATE(191),
    [sym_module] = STATE(191),
    [sym_return] = STATE(191),
    [sym_yield] = STATE(191),
    [sym_break] = STATE(191),
    [sym_next] = STATE(191),
    [sym_while] = STATE(191),
    [sym_until] = STATE(191),
    [sym_for] = STATE(191),
    [sym_case] = STATE(191),
    [sym_if] = STATE(191),
    [sym_unless] = STATE(191),
    [sym_begin] = STATE(191),
    [sym__primary] = STATE(191),
    [sym_parenthesized_statements] = STATE(191),
    [sym_element_reference] = STATE(191),
    [sym_scope_resolution] = STATE(1972),
    [sym_call] = STATE(193),
    [sym_method_call] = STATE(191),
    [sym__lhs] = STATE(191),
    [sym__variable] = STATE(193),
    [sym_rational] = STATE(191),
    [sym_true] = STATE(191),
    [sym_false] = STATE(191),
    [sym_nil] = STATE(191),
    [sym_chained_string] = STATE(191),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(191),
    [sym_string_array] = STATE(191),
    [sym_symbol_array] = STATE(191),
    [sym_symbol] = STATE(191),
    [sym_regex] = STATE(191),
    [sym_array] = STATE(191),
    [sym_hash] = STATE(191),
    [sym_lambda] = STATE(191),
    [sym__simple_symbol] = ACTIONS(279),
    [sym__string_start] = ACTIONS(281),
    [sym__symbol_start] = ACTIONS(283),
    [sym__subshell_start] = ACTIONS(285),
    [sym__regex_start] = ACTIONS(287),
    [sym__string_array_start] = ACTIONS(289),
    [sym__symbol_array_start] = ACTIONS(291),
    [sym_heredoc_beginning] = ACTIONS(349),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_def] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(299),
    [anon_sym_COLON_COLON] = ACTIONS(353),
    [anon_sym_class] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(307),
    [anon_sym_return] = ACTIONS(309),
    [anon_sym_yield] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_next] = ACTIONS(315),
    [sym_redo] = ACTIONS(355),
    [sym_retry] = ACTIONS(355),
    [anon_sym_if] = ACTIONS(319),
    [anon_sym_unless] = ACTIONS(321),
    [anon_sym_while] = ACTIONS(323),
    [anon_sym_until] = ACTIONS(325),
    [anon_sym_for] = ACTIONS(327),
    [anon_sym_case] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(331),
    [sym_constant] = ACTIONS(3487),
    [sym_identifier] = ACTIONS(359),
    [sym_instance_variable] = ACTIONS(361),
    [sym_class_variable] = ACTIONS(361),
    [sym_global_variable] = ACTIONS(361),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(355),
    [sym_complex] = ACTIONS(349),
    [sym_super] = ACTIONS(359),
    [anon_sym_true] = ACTIONS(339),
    [anon_sym_TRUE] = ACTIONS(339),
    [anon_sym_false] = ACTIONS(341),
    [anon_sym_FALSE] = ACTIONS(341),
    [sym_self] = ACTIONS(359),
    [anon_sym_nil] = ACTIONS(343),
    [anon_sym_NIL] = ACTIONS(343),
    [sym_character] = ACTIONS(349),
    [anon_sym_LBRACK2] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(347),
  },
  [625] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(644),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_argument_list] = STATE(1973),
    [sym__argument_list_with_parens] = STATE(648),
    [sym__argument] = STATE(649),
    [sym_splat_argument] = STATE(649),
    [sym_hash_splat_argument] = STATE(649),
    [sym_block_argument] = STATE(649),
    [sym_assignment] = STATE(644),
    [sym_operator_assignment] = STATE(644),
    [sym_conditional] = STATE(644),
    [sym_range] = STATE(644),
    [sym_binary] = STATE(644),
    [sym_unary] = STATE(644),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(653),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(649),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(1155),
    [sym__splat_star] = ACTIONS(1157),
    [sym__unary_minus] = ACTIONS(1159),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(365),
    [anon_sym_DASH_EQ] = ACTIONS(365),
    [anon_sym_STAR_EQ] = ACTIONS(365),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(365),
    [anon_sym_SLASH_EQ] = ACTIONS(365),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(365),
    [anon_sym_PIPE_EQ] = ACTIONS(365),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(365),
    [anon_sym_AMP_EQ] = ACTIONS(365),
    [anon_sym_PERCENT_EQ] = ACTIONS(365),
    [anon_sym_GT_GT_EQ] = ACTIONS(365),
    [anon_sym_LT_LT_EQ] = ACTIONS(365),
    [anon_sym_CARET_EQ] = ACTIONS(365),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_PERCENT] = ACTIONS(377),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1205),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1209),
    [sym_identifier] = ACTIONS(1209),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [626] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(644),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_argument_list] = STATE(1974),
    [sym__argument_list_with_parens] = STATE(648),
    [sym__argument] = STATE(649),
    [sym_splat_argument] = STATE(649),
    [sym_hash_splat_argument] = STATE(649),
    [sym_block_argument] = STATE(649),
    [sym_assignment] = STATE(644),
    [sym_operator_assignment] = STATE(644),
    [sym_conditional] = STATE(644),
    [sym_range] = STATE(644),
    [sym_binary] = STATE(644),
    [sym_unary] = STATE(644),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(653),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(649),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(1155),
    [sym__splat_star] = ACTIONS(1157),
    [sym__unary_minus] = ACTIONS(1159),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_EQ] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(417),
    [anon_sym_DASH_EQ] = ACTIONS(417),
    [anon_sym_STAR_EQ] = ACTIONS(417),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(417),
    [anon_sym_SLASH_EQ] = ACTIONS(417),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(417),
    [anon_sym_PIPE_EQ] = ACTIONS(417),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(417),
    [anon_sym_AMP_EQ] = ACTIONS(417),
    [anon_sym_PERCENT_EQ] = ACTIONS(417),
    [anon_sym_GT_GT_EQ] = ACTIONS(417),
    [anon_sym_LT_LT_EQ] = ACTIONS(417),
    [anon_sym_CARET_EQ] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1205),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1209),
    [sym_identifier] = ACTIONS(1209),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [627] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(644),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_argument_list] = STATE(1975),
    [sym__argument_list_with_parens] = STATE(648),
    [sym__argument] = STATE(649),
    [sym_splat_argument] = STATE(649),
    [sym_hash_splat_argument] = STATE(649),
    [sym_block_argument] = STATE(649),
    [sym_assignment] = STATE(644),
    [sym_operator_assignment] = STATE(644),
    [sym_conditional] = STATE(644),
    [sym_range] = STATE(644),
    [sym_binary] = STATE(644),
    [sym_unary] = STATE(644),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(653),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(649),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(1155),
    [sym__splat_star] = ACTIONS(1157),
    [sym__unary_minus] = ACTIONS(1159),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_EQ] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(421),
    [anon_sym_DASH_EQ] = ACTIONS(421),
    [anon_sym_STAR_EQ] = ACTIONS(421),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(421),
    [anon_sym_SLASH_EQ] = ACTIONS(421),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(421),
    [anon_sym_PIPE_EQ] = ACTIONS(421),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(421),
    [anon_sym_AMP_EQ] = ACTIONS(421),
    [anon_sym_PERCENT_EQ] = ACTIONS(421),
    [anon_sym_GT_GT_EQ] = ACTIONS(421),
    [anon_sym_LT_LT_EQ] = ACTIONS(421),
    [anon_sym_CARET_EQ] = ACTIONS(421),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1205),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1209),
    [sym_identifier] = ACTIONS(1209),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [628] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(644),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_argument_list] = STATE(1976),
    [sym__argument_list_with_parens] = STATE(648),
    [sym__argument] = STATE(649),
    [sym_splat_argument] = STATE(649),
    [sym_hash_splat_argument] = STATE(649),
    [sym_block_argument] = STATE(649),
    [sym_assignment] = STATE(644),
    [sym_operator_assignment] = STATE(644),
    [sym_conditional] = STATE(644),
    [sym_range] = STATE(644),
    [sym_binary] = STATE(644),
    [sym_unary] = STATE(644),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(653),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(649),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(1155),
    [sym__splat_star] = ACTIONS(1157),
    [sym__unary_minus] = ACTIONS(1159),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(427),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(425),
    [anon_sym_DASH_EQ] = ACTIONS(425),
    [anon_sym_STAR_EQ] = ACTIONS(425),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(425),
    [anon_sym_SLASH_EQ] = ACTIONS(425),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(425),
    [anon_sym_PIPE_EQ] = ACTIONS(425),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(425),
    [anon_sym_AMP_EQ] = ACTIONS(425),
    [anon_sym_PERCENT_EQ] = ACTIONS(425),
    [anon_sym_GT_GT_EQ] = ACTIONS(425),
    [anon_sym_LT_LT_EQ] = ACTIONS(425),
    [anon_sym_CARET_EQ] = ACTIONS(425),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1205),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1209),
    [sym_identifier] = ACTIONS(1209),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [629] = {
    [sym_begin_block] = STATE(1977),
    [sym_end_block] = STATE(1977),
    [sym__statement] = STATE(1977),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1977),
    [sym_unless_modifier] = STATE(1977),
    [sym_while_modifier] = STATE(1977),
    [sym_until_modifier] = STATE(1977),
    [sym_rescue_modifier] = STATE(1977),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(234),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(234),
    [sym_operator_assignment] = STATE(234),
    [sym_conditional] = STATE(234),
    [sym_range] = STATE(234),
    [sym_binary] = STATE(234),
    [sym_unary] = STATE(234),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_undef] = STATE(1977),
    [sym_alias] = STATE(1977),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(429),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_yield] = ACTIONS(433),
    [anon_sym_break] = ACTIONS(435),
    [anon_sym_next] = ACTIONS(437),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(439),
    [anon_sym_defined_QMARK] = ACTIONS(441),
    [anon_sym_not] = ACTIONS(443),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [anon_sym_undef] = ACTIONS(451),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [630] = {
    [sym_begin_block] = STATE(1978),
    [sym_end_block] = STATE(1978),
    [sym__statement] = STATE(1978),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1978),
    [sym_unless_modifier] = STATE(1978),
    [sym_while_modifier] = STATE(1978),
    [sym_until_modifier] = STATE(1978),
    [sym_rescue_modifier] = STATE(1978),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(234),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(234),
    [sym_operator_assignment] = STATE(234),
    [sym_conditional] = STATE(234),
    [sym_range] = STATE(234),
    [sym_binary] = STATE(234),
    [sym_unary] = STATE(234),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_undef] = STATE(1978),
    [sym_alias] = STATE(1978),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(429),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_yield] = ACTIONS(433),
    [anon_sym_break] = ACTIONS(435),
    [anon_sym_next] = ACTIONS(437),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(439),
    [anon_sym_defined_QMARK] = ACTIONS(441),
    [anon_sym_not] = ACTIONS(443),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [anon_sym_undef] = ACTIONS(451),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [631] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1979),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(1979),
    [sym_operator_assignment] = STATE(1979),
    [sym_conditional] = STATE(1979),
    [sym_range] = STATE(1979),
    [sym_binary] = STATE(1979),
    [sym_unary] = STATE(1979),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(455),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_break] = ACTIONS(459),
    [anon_sym_next] = ACTIONS(461),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_defined_QMARK] = ACTIONS(465),
    [anon_sym_not] = ACTIONS(467),
    [anon_sym_BANG] = ACTIONS(469),
    [anon_sym_TILDE] = ACTIONS(469),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [632] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1980),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(1980),
    [sym_operator_assignment] = STATE(1980),
    [sym_conditional] = STATE(1980),
    [sym_range] = STATE(1980),
    [sym_binary] = STATE(1980),
    [sym_unary] = STATE(1980),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(455),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_break] = ACTIONS(459),
    [anon_sym_next] = ACTIONS(461),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_defined_QMARK] = ACTIONS(465),
    [anon_sym_not] = ACTIONS(467),
    [anon_sym_BANG] = ACTIONS(469),
    [anon_sym_TILDE] = ACTIONS(469),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [633] = {
    [sym_method] = STATE(184),
    [sym_singleton_method] = STATE(184),
    [sym_class] = STATE(184),
    [sym_singleton_class] = STATE(184),
    [sym_module] = STATE(184),
    [sym_return] = STATE(184),
    [sym_yield] = STATE(184),
    [sym_break] = STATE(184),
    [sym_next] = STATE(184),
    [sym_while] = STATE(184),
    [sym_until] = STATE(184),
    [sym_for] = STATE(184),
    [sym_case] = STATE(184),
    [sym_if] = STATE(184),
    [sym_unless] = STATE(184),
    [sym_begin] = STATE(184),
    [sym__primary] = STATE(184),
    [sym_parenthesized_statements] = STATE(184),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(255),
    [sym_call] = STATE(255),
    [sym_method_call] = STATE(258),
    [sym__mlhs] = STATE(1981),
    [sym_destructured_left_assignment] = STATE(257),
    [sym_rest_assignment] = STATE(257),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(255),
    [sym_rational] = STATE(184),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(184),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(184),
    [sym_string_array] = STATE(184),
    [sym_symbol_array] = STATE(184),
    [sym_symbol] = STATE(184),
    [sym_regex] = STATE(184),
    [sym_array] = STATE(184),
    [sym_hash] = STATE(184),
    [sym_lambda] = STATE(184),
    [sym__simple_symbol] = ACTIONS(279),
    [sym__string_start] = ACTIONS(281),
    [sym__symbol_start] = ACTIONS(283),
    [sym__subshell_start] = ACTIONS(285),
    [sym__regex_start] = ACTIONS(287),
    [sym__string_array_start] = ACTIONS(289),
    [sym__symbol_array_start] = ACTIONS(291),
    [sym_heredoc_beginning] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_def] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(475),
    [anon_sym_COLON_COLON] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(477),
    [anon_sym_class] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(307),
    [anon_sym_return] = ACTIONS(309),
    [anon_sym_yield] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_next] = ACTIONS(315),
    [sym_redo] = ACTIONS(317),
    [sym_retry] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(319),
    [anon_sym_unless] = ACTIONS(321),
    [anon_sym_while] = ACTIONS(323),
    [anon_sym_until] = ACTIONS(325),
    [anon_sym_for] = ACTIONS(327),
    [anon_sym_case] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(331),
    [sym_constant] = ACTIONS(479),
    [sym_identifier] = ACTIONS(479),
    [sym_instance_variable] = ACTIONS(481),
    [sym_class_variable] = ACTIONS(481),
    [sym_global_variable] = ACTIONS(481),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(317),
    [sym_complex] = ACTIONS(293),
    [sym_super] = ACTIONS(479),
    [anon_sym_true] = ACTIONS(339),
    [anon_sym_TRUE] = ACTIONS(339),
    [anon_sym_false] = ACTIONS(341),
    [anon_sym_FALSE] = ACTIONS(341),
    [sym_self] = ACTIONS(479),
    [anon_sym_nil] = ACTIONS(343),
    [anon_sym_NIL] = ACTIONS(343),
    [sym_character] = ACTIONS(293),
    [anon_sym_LBRACK2] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(347),
  },
  [634] = {
    [sym__statements] = STATE(1983),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_block_parameters] = STATE(1984),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_heredoc_body] = STATE(1985),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [sym__terminator] = STATE(1985),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__line_break] = ACTIONS(3489),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(3489),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(3491),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [635] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1986),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(1986),
    [sym_operator_assignment] = STATE(1986),
    [sym_conditional] = STATE(1986),
    [sym_range] = STATE(1986),
    [sym_binary] = STATE(1986),
    [sym_unary] = STATE(1986),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_heredoc_body] = STATE(1987),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__terminator] = STATE(1987),
    [sym__line_break] = ACTIONS(3493),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(485),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(3493),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(495),
    [anon_sym_defined_QMARK] = ACTIONS(497),
    [anon_sym_not] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(501),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [636] = {
    [sym__statements] = STATE(1988),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(1989),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(1990),
    [sym_rescue] = STATE(1991),
    [sym__body_statement] = STATE(1992),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_heredoc_body] = STATE(1993),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [sym__terminator] = STATE(1993),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__line_break] = ACTIONS(3495),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(3495),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(3497),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [637] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(906),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(911),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(911),
    [sym__argument_list_with_trailing_comma] = STATE(1995),
    [sym__argument] = STATE(909),
    [sym_splat_argument] = STATE(909),
    [sym_hash_splat_argument] = STATE(909),
    [sym_block_argument] = STATE(909),
    [sym_assignment] = STATE(906),
    [sym_operator_assignment] = STATE(906),
    [sym_conditional] = STATE(906),
    [sym_range] = STATE(906),
    [sym_binary] = STATE(906),
    [sym_unary] = STATE(906),
    [sym_left_assignment_list] = STATE(910),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(911),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(911),
    [sym_false] = STATE(911),
    [sym_nil] = STATE(911),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(912),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(909),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1589),
    [sym__splat_star] = ACTIONS(1591),
    [sym__unary_minus] = ACTIONS(1593),
    [sym__identifier_hash_key] = ACTIONS(1595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(3499),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1599),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_defined_QMARK] = ACTIONS(1611),
    [anon_sym_not] = ACTIONS(1613),
    [anon_sym_BANG] = ACTIONS(1615),
    [anon_sym_TILDE] = ACTIONS(1615),
    [sym_constant] = ACTIONS(1617),
    [sym_identifier] = ACTIONS(1617),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [638] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1996),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_assignment] = STATE(1996),
    [sym_operator_assignment] = STATE(1996),
    [sym_conditional] = STATE(1996),
    [sym_range] = STATE(1996),
    [sym_binary] = STATE(1996),
    [sym_unary] = STATE(1996),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1952),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(3469),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [639] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1997),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_assignment] = STATE(1997),
    [sym_operator_assignment] = STATE(1997),
    [sym_conditional] = STATE(1997),
    [sym_range] = STATE(1997),
    [sym_binary] = STATE(1997),
    [sym_unary] = STATE(1997),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1952),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(3469),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [640] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(3501),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [641] = {
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_in] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
    [anon_sym_r] = ACTIONS(3503),
  },
  [642] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(346),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(352),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(352),
    [sym__argument_list_with_trailing_comma] = STATE(2001),
    [sym__argument] = STATE(350),
    [sym_splat_argument] = STATE(350),
    [sym_hash_splat_argument] = STATE(350),
    [sym_block_argument] = STATE(350),
    [sym_assignment] = STATE(346),
    [sym_operator_assignment] = STATE(346),
    [sym_conditional] = STATE(346),
    [sym_range] = STATE(346),
    [sym_binary] = STATE(346),
    [sym_unary] = STATE(346),
    [sym_left_assignment_list] = STATE(351),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(352),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(352),
    [sym_false] = STATE(352),
    [sym_nil] = STATE(352),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(353),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(350),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(593),
    [sym__splat_star] = ACTIONS(595),
    [sym__unary_minus] = ACTIONS(597),
    [sym__identifier_hash_key] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(3505),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [643] = {
    [sym_lambda_parameters] = STATE(2003),
    [sym__simple_formal_parameter] = STATE(362),
    [sym_splat_parameter] = STATE(362),
    [sym_hash_splat_parameter] = STATE(362),
    [sym_block_parameter] = STATE(362),
    [sym_keyword_parameter] = STATE(362),
    [sym_optional_parameter] = STATE(362),
    [sym_do_block] = STATE(2004),
    [sym_block] = STATE(2004),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(2413),
    [sym_identifier] = ACTIONS(679),
    [sym_comment] = ACTIONS(87),
  },
  [644] = {
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(3509),
    [sym__binary_star] = ACTIONS(3511),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(3513),
    [anon_sym_STAR_STAR] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(3517),
    [anon_sym_EQ] = ACTIONS(1631),
    [anon_sym_LT] = ACTIONS(3519),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(1625),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_PLUS_EQ] = ACTIONS(1625),
    [anon_sym_DASH_EQ] = ACTIONS(1625),
    [anon_sym_STAR_EQ] = ACTIONS(1625),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1625),
    [anon_sym_SLASH_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1625),
    [anon_sym_AMP_EQ] = ACTIONS(1625),
    [anon_sym_PERCENT_EQ] = ACTIONS(1625),
    [anon_sym_GT_GT_EQ] = ACTIONS(1625),
    [anon_sym_LT_LT_EQ] = ACTIONS(1625),
    [anon_sym_CARET_EQ] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(3521),
    [anon_sym_DOT_DOT] = ACTIONS(3523),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3525),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(3527),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_LT_LT] = ACTIONS(3529),
    [anon_sym_GT_GT] = ACTIONS(3529),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ] = ACTIONS(3531),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3531),
    [anon_sym_LT_EQ_GT] = ACTIONS(3531),
    [anon_sym_EQ_TILDE] = ACTIONS(3531),
    [anon_sym_BANG_TILDE] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3519),
    [anon_sym_GT] = ACTIONS(3519),
    [anon_sym_GT_EQ] = ACTIONS(3533),
    [anon_sym_CARET] = ACTIONS(3513),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_SLASH] = ACTIONS(3515),
    [anon_sym_PERCENT] = ACTIONS(3515),
    [sym_comment] = ACTIONS(87),
  },
  [645] = {
    [sym__heredoc_body_start] = ACTIONS(731),
    [sym__binary_minus] = ACTIONS(731),
    [sym__binary_star] = ACTIONS(731),
    [anon_sym_LBRACE] = ACTIONS(731),
    [anon_sym_RBRACE] = ACTIONS(731),
    [anon_sym_RPAREN] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(2387),
    [anon_sym_COMMA] = ACTIONS(731),
    [anon_sym_PIPE] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(731),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_AMP] = ACTIONS(735),
    [anon_sym_EQ] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(735),
    [anon_sym_if] = ACTIONS(731),
    [anon_sym_unless] = ACTIONS(731),
    [anon_sym_while] = ACTIONS(731),
    [anon_sym_until] = ACTIONS(731),
    [anon_sym_rescue] = ACTIONS(731),
    [anon_sym_in] = ACTIONS(731),
    [anon_sym_do] = ACTIONS(731),
    [anon_sym_EQ_GT] = ACTIONS(731),
    [anon_sym_LBRACK] = ACTIONS(2389),
    [anon_sym_RBRACK] = ACTIONS(731),
    [anon_sym_COLON_COLON2] = ACTIONS(2391),
    [anon_sym_AMP_DOT] = ACTIONS(2393),
    [anon_sym_PLUS_EQ] = ACTIONS(731),
    [anon_sym_DASH_EQ] = ACTIONS(731),
    [anon_sym_STAR_EQ] = ACTIONS(731),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(731),
    [anon_sym_SLASH_EQ] = ACTIONS(731),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(731),
    [anon_sym_PIPE_EQ] = ACTIONS(731),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(731),
    [anon_sym_AMP_EQ] = ACTIONS(731),
    [anon_sym_PERCENT_EQ] = ACTIONS(731),
    [anon_sym_GT_GT_EQ] = ACTIONS(731),
    [anon_sym_LT_LT_EQ] = ACTIONS(731),
    [anon_sym_CARET_EQ] = ACTIONS(731),
    [anon_sym_QMARK] = ACTIONS(731),
    [anon_sym_COLON2] = ACTIONS(735),
    [anon_sym_DOT_DOT] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(731),
    [anon_sym_or] = ACTIONS(731),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_EQ_EQ] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(731),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(731),
    [anon_sym_LT_EQ_GT] = ACTIONS(731),
    [anon_sym_EQ_TILDE] = ACTIONS(731),
    [anon_sym_BANG_TILDE] = ACTIONS(731),
    [anon_sym_LT_EQ] = ACTIONS(735),
    [anon_sym_GT] = ACTIONS(735),
    [anon_sym_GT_EQ] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_SLASH] = ACTIONS(735),
    [anon_sym_PERCENT] = ACTIONS(735),
    [sym_comment] = ACTIONS(87),
  },
  [646] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(644),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_argument_list] = STATE(2016),
    [sym__argument_list_with_parens] = STATE(648),
    [sym__argument] = STATE(649),
    [sym_splat_argument] = STATE(649),
    [sym_hash_splat_argument] = STATE(649),
    [sym_block_argument] = STATE(649),
    [sym_do_block] = STATE(1382),
    [sym_block] = STATE(1382),
    [sym_assignment] = STATE(644),
    [sym_operator_assignment] = STATE(644),
    [sym_conditional] = STATE(644),
    [sym_range] = STATE(644),
    [sym_binary] = STATE(644),
    [sym_unary] = STATE(644),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(653),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(649),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(1155),
    [sym__splat_star] = ACTIONS(1157),
    [sym__unary_minus] = ACTIONS(1159),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(3537),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(769),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1205),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1209),
    [sym_identifier] = ACTIONS(1209),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [647] = {
    [sym_do_block] = STATE(2018),
    [sym_block] = STATE(2018),
    [sym__binary_minus] = ACTIONS(2717),
    [sym__binary_star] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(3539),
    [anon_sym_DOT] = ACTIONS(2721),
    [anon_sym_COMMA] = ACTIONS(2717),
    [anon_sym_PIPE] = ACTIONS(2721),
    [anon_sym_STAR_STAR] = ACTIONS(2721),
    [anon_sym_AMP] = ACTIONS(2721),
    [anon_sym_EQ] = ACTIONS(2721),
    [anon_sym_LT] = ACTIONS(2721),
    [anon_sym_do] = ACTIONS(3541),
    [anon_sym_EQ_GT] = ACTIONS(2717),
    [anon_sym_LBRACK] = ACTIONS(2717),
    [anon_sym_COLON_COLON2] = ACTIONS(2717),
    [anon_sym_AMP_DOT] = ACTIONS(2717),
    [anon_sym_PLUS_EQ] = ACTIONS(2717),
    [anon_sym_DASH_EQ] = ACTIONS(2717),
    [anon_sym_STAR_EQ] = ACTIONS(2717),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2717),
    [anon_sym_SLASH_EQ] = ACTIONS(2717),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2717),
    [anon_sym_PIPE_EQ] = ACTIONS(2717),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2717),
    [anon_sym_AMP_EQ] = ACTIONS(2717),
    [anon_sym_PERCENT_EQ] = ACTIONS(2717),
    [anon_sym_GT_GT_EQ] = ACTIONS(2717),
    [anon_sym_LT_LT_EQ] = ACTIONS(2717),
    [anon_sym_CARET_EQ] = ACTIONS(2717),
    [anon_sym_QMARK] = ACTIONS(2717),
    [anon_sym_DOT_DOT] = ACTIONS(2721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2717),
    [anon_sym_and] = ACTIONS(2717),
    [anon_sym_or] = ACTIONS(2717),
    [anon_sym_PIPE_PIPE] = ACTIONS(2721),
    [anon_sym_AMP_AMP] = ACTIONS(2721),
    [anon_sym_LT_LT] = ACTIONS(2721),
    [anon_sym_GT_GT] = ACTIONS(2721),
    [anon_sym_EQ_EQ] = ACTIONS(2721),
    [anon_sym_BANG_EQ] = ACTIONS(2717),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2717),
    [anon_sym_LT_EQ_GT] = ACTIONS(2717),
    [anon_sym_EQ_TILDE] = ACTIONS(2717),
    [anon_sym_BANG_TILDE] = ACTIONS(2717),
    [anon_sym_LT_EQ] = ACTIONS(2721),
    [anon_sym_GT] = ACTIONS(2721),
    [anon_sym_GT_EQ] = ACTIONS(2717),
    [anon_sym_CARET] = ACTIONS(2721),
    [anon_sym_PLUS] = ACTIONS(2721),
    [anon_sym_SLASH] = ACTIONS(2721),
    [anon_sym_PERCENT] = ACTIONS(2721),
    [sym_comment] = ACTIONS(87),
  },
  [648] = {
    [sym_heredoc_body] = STATE(2020),
    [aux_sym_call_repeat1] = STATE(2020),
    [sym__heredoc_body_start] = ACTIONS(3543),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [649] = {
    [sym_heredoc_body] = STATE(2020),
    [aux_sym_call_repeat1] = STATE(2020),
    [aux_sym_argument_list_repeat1] = STATE(2022),
    [sym__heredoc_body_start] = ACTIONS(3543),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(3545),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [650] = {
    [sym__binary_minus] = ACTIONS(2717),
    [sym__binary_star] = ACTIONS(2717),
    [anon_sym_DOT] = ACTIONS(2721),
    [anon_sym_COMMA] = ACTIONS(2717),
    [anon_sym_PIPE] = ACTIONS(2721),
    [anon_sym_STAR_STAR] = ACTIONS(2721),
    [anon_sym_AMP] = ACTIONS(2721),
    [anon_sym_EQ] = ACTIONS(2721),
    [anon_sym_LT] = ACTIONS(2721),
    [anon_sym_EQ_GT] = ACTIONS(2717),
    [anon_sym_LBRACK] = ACTIONS(2717),
    [anon_sym_COLON_COLON2] = ACTIONS(2717),
    [anon_sym_AMP_DOT] = ACTIONS(2717),
    [anon_sym_PLUS_EQ] = ACTIONS(2717),
    [anon_sym_DASH_EQ] = ACTIONS(2717),
    [anon_sym_STAR_EQ] = ACTIONS(2717),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2717),
    [anon_sym_SLASH_EQ] = ACTIONS(2717),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2717),
    [anon_sym_PIPE_EQ] = ACTIONS(2717),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2717),
    [anon_sym_AMP_EQ] = ACTIONS(2717),
    [anon_sym_PERCENT_EQ] = ACTIONS(2717),
    [anon_sym_GT_GT_EQ] = ACTIONS(2717),
    [anon_sym_LT_LT_EQ] = ACTIONS(2717),
    [anon_sym_CARET_EQ] = ACTIONS(2717),
    [anon_sym_QMARK] = ACTIONS(2717),
    [anon_sym_DOT_DOT] = ACTIONS(2721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2717),
    [anon_sym_and] = ACTIONS(2717),
    [anon_sym_or] = ACTIONS(2717),
    [anon_sym_PIPE_PIPE] = ACTIONS(2721),
    [anon_sym_AMP_AMP] = ACTIONS(2721),
    [anon_sym_LT_LT] = ACTIONS(2721),
    [anon_sym_GT_GT] = ACTIONS(2721),
    [anon_sym_EQ_EQ] = ACTIONS(2721),
    [anon_sym_BANG_EQ] = ACTIONS(2717),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2717),
    [anon_sym_LT_EQ_GT] = ACTIONS(2717),
    [anon_sym_EQ_TILDE] = ACTIONS(2717),
    [anon_sym_BANG_TILDE] = ACTIONS(2717),
    [anon_sym_LT_EQ] = ACTIONS(2721),
    [anon_sym_GT] = ACTIONS(2721),
    [anon_sym_GT_EQ] = ACTIONS(2717),
    [anon_sym_CARET] = ACTIONS(2721),
    [anon_sym_PLUS] = ACTIONS(2721),
    [anon_sym_SLASH] = ACTIONS(2721),
    [anon_sym_PERCENT] = ACTIONS(2721),
    [sym_comment] = ACTIONS(87),
  },
  [651] = {
    [anon_sym_EQ] = ACTIONS(3547),
    [sym_comment] = ACTIONS(87),
  },
  [652] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(3549),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(3551),
    [anon_sym_DASH_EQ] = ACTIONS(3551),
    [anon_sym_STAR_EQ] = ACTIONS(3551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3551),
    [anon_sym_SLASH_EQ] = ACTIONS(3551),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3551),
    [anon_sym_PIPE_EQ] = ACTIONS(3551),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3551),
    [anon_sym_AMP_EQ] = ACTIONS(3551),
    [anon_sym_PERCENT_EQ] = ACTIONS(3551),
    [anon_sym_GT_GT_EQ] = ACTIONS(3551),
    [anon_sym_LT_LT_EQ] = ACTIONS(3551),
    [anon_sym_CARET_EQ] = ACTIONS(3551),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [653] = {
    [sym_string] = STATE(2025),
    [aux_sym_chained_string_repeat1] = STATE(2025),
    [sym__string_start] = ACTIONS(1141),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(3553),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [654] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(2034),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(2038),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(2038),
    [sym_splat_argument] = STATE(2036),
    [sym_assignment] = STATE(2034),
    [sym_operator_assignment] = STATE(2034),
    [sym_conditional] = STATE(2034),
    [sym_range] = STATE(2034),
    [sym_binary] = STATE(2034),
    [sym_unary] = STATE(2034),
    [sym_right_assignment_list] = STATE(2035),
    [sym__arg_or_splat_arg] = STATE(2036),
    [sym_left_assignment_list] = STATE(2037),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2038),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(2038),
    [sym_false] = STATE(2038),
    [sym_nil] = STATE(2038),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(2039),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__splat_star] = ACTIONS(3555),
    [sym__unary_minus] = ACTIONS(3557),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3559),
    [anon_sym_yield] = ACTIONS(3561),
    [anon_sym_break] = ACTIONS(3563),
    [anon_sym_next] = ACTIONS(3565),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3567),
    [anon_sym_defined_QMARK] = ACTIONS(3569),
    [anon_sym_not] = ACTIONS(3571),
    [anon_sym_BANG] = ACTIONS(3573),
    [anon_sym_TILDE] = ACTIONS(3573),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [655] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(2040),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(118),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(118),
    [sym_assignment] = STATE(2040),
    [sym_operator_assignment] = STATE(2040),
    [sym_conditional] = STATE(2040),
    [sym_range] = STATE(2040),
    [sym_binary] = STATE(2040),
    [sym_unary] = STATE(2040),
    [sym_left_assignment_list] = STATE(117),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(118),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(118),
    [sym_false] = STATE(118),
    [sym_nil] = STATE(118),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(514),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [656] = {
    [sym_string] = STATE(2041),
    [aux_sym_chained_string_repeat1] = STATE(2041),
    [sym__string_start] = ACTIONS(139),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_EQ_GT] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [657] = {
    [sym__line_break] = ACTIONS(3575),
    [sym__heredoc_body_start] = ACTIONS(3575),
    [sym__binary_minus] = ACTIONS(3575),
    [sym__binary_star] = ACTIONS(3575),
    [ts_builtin_sym_end] = ACTIONS(3575),
    [anon_sym___END__] = ACTIONS(3575),
    [anon_sym_LBRACE] = ACTIONS(3575),
    [anon_sym_RBRACE] = ACTIONS(3575),
    [anon_sym_RPAREN] = ACTIONS(3575),
    [anon_sym_DOT] = ACTIONS(3577),
    [anon_sym_COMMA] = ACTIONS(3575),
    [anon_sym_PIPE] = ACTIONS(3577),
    [anon_sym_SEMI] = ACTIONS(3575),
    [anon_sym_STAR_STAR] = ACTIONS(3575),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_LT] = ACTIONS(3577),
    [anon_sym_end] = ACTIONS(3575),
    [anon_sym_if] = ACTIONS(3575),
    [anon_sym_unless] = ACTIONS(3575),
    [anon_sym_while] = ACTIONS(3575),
    [anon_sym_until] = ACTIONS(3575),
    [anon_sym_rescue] = ACTIONS(3575),
    [anon_sym_do] = ACTIONS(3575),
    [anon_sym_when] = ACTIONS(3575),
    [anon_sym_elsif] = ACTIONS(3575),
    [anon_sym_else] = ACTIONS(3575),
    [anon_sym_then] = ACTIONS(3575),
    [anon_sym_ensure] = ACTIONS(3575),
    [anon_sym_EQ_GT] = ACTIONS(3575),
    [anon_sym_LBRACK] = ACTIONS(3575),
    [anon_sym_COLON_COLON2] = ACTIONS(3575),
    [anon_sym_AMP_DOT] = ACTIONS(3575),
    [anon_sym_QMARK] = ACTIONS(3575),
    [anon_sym_DOT_DOT] = ACTIONS(3577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3575),
    [anon_sym_and] = ACTIONS(3575),
    [anon_sym_or] = ACTIONS(3575),
    [anon_sym_PIPE_PIPE] = ACTIONS(3575),
    [anon_sym_AMP_AMP] = ACTIONS(3575),
    [anon_sym_LT_LT] = ACTIONS(3575),
    [anon_sym_GT_GT] = ACTIONS(3575),
    [anon_sym_EQ_EQ] = ACTIONS(3577),
    [anon_sym_BANG_EQ] = ACTIONS(3575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3575),
    [anon_sym_LT_EQ_GT] = ACTIONS(3575),
    [anon_sym_EQ_TILDE] = ACTIONS(3575),
    [anon_sym_BANG_TILDE] = ACTIONS(3575),
    [anon_sym_LT_EQ] = ACTIONS(3577),
    [anon_sym_GT] = ACTIONS(3577),
    [anon_sym_GT_EQ] = ACTIONS(3575),
    [anon_sym_CARET] = ACTIONS(3575),
    [anon_sym_PLUS] = ACTIONS(3575),
    [anon_sym_SLASH] = ACTIONS(3575),
    [anon_sym_PERCENT] = ACTIONS(3575),
    [sym_comment] = ACTIONS(87),
  },
  [658] = {
    [anon_sym_RBRACE] = ACTIONS(3579),
    [sym_comment] = ACTIONS(87),
  },
  [659] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(113),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(118),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(118),
    [sym_hash_splat_argument] = STATE(116),
    [sym_assignment] = STATE(113),
    [sym_operator_assignment] = STATE(113),
    [sym_conditional] = STATE(113),
    [sym_range] = STATE(113),
    [sym_binary] = STATE(113),
    [sym_unary] = STATE(113),
    [sym_left_assignment_list] = STATE(117),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(118),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(118),
    [sym_false] = STATE(118),
    [sym_nil] = STATE(118),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(119),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_heredoc_body] = STATE(2044),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym__hash_items] = STATE(2045),
    [sym_pair] = STATE(122),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym__heredoc_body_start] = ACTIONS(3581),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [sym__identifier_hash_key] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_RBRACE] = ACTIONS(3583),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(209),
    [sym_identifier] = ACTIONS(209),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [660] = {
    [sym__line_break] = ACTIONS(3585),
    [sym__heredoc_body_start] = ACTIONS(3585),
    [ts_builtin_sym_end] = ACTIONS(3585),
    [anon_sym___END__] = ACTIONS(3585),
    [anon_sym_RBRACE] = ACTIONS(3585),
    [anon_sym_RPAREN] = ACTIONS(3585),
    [anon_sym_SEMI] = ACTIONS(3585),
    [anon_sym_end] = ACTIONS(3585),
    [anon_sym_if] = ACTIONS(3585),
    [anon_sym_unless] = ACTIONS(3585),
    [anon_sym_while] = ACTIONS(3585),
    [anon_sym_until] = ACTIONS(3585),
    [anon_sym_rescue] = ACTIONS(3585),
    [anon_sym_when] = ACTIONS(3585),
    [anon_sym_elsif] = ACTIONS(3585),
    [anon_sym_else] = ACTIONS(3585),
    [anon_sym_then] = ACTIONS(3585),
    [anon_sym_ensure] = ACTIONS(3585),
    [sym_comment] = ACTIONS(87),
  },
  [661] = {
    [anon_sym_RBRACE] = ACTIONS(3587),
    [sym_comment] = ACTIONS(87),
  },
  [662] = {
    [sym__line_break] = ACTIONS(887),
    [sym__heredoc_body_start] = ACTIONS(887),
    [ts_builtin_sym_end] = ACTIONS(887),
    [anon_sym___END__] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(887),
    [anon_sym_LPAREN] = ACTIONS(887),
    [anon_sym_RPAREN] = ACTIONS(887),
    [anon_sym_COMMA] = ACTIONS(887),
    [anon_sym_SEMI] = ACTIONS(887),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_STAR_STAR] = ACTIONS(887),
    [anon_sym_AMP] = ACTIONS(887),
    [anon_sym_end] = ACTIONS(889),
    [anon_sym_if] = ACTIONS(889),
    [anon_sym_unless] = ACTIONS(889),
    [anon_sym_while] = ACTIONS(889),
    [anon_sym_until] = ACTIONS(889),
    [anon_sym_rescue] = ACTIONS(889),
    [anon_sym_when] = ACTIONS(889),
    [anon_sym_elsif] = ACTIONS(889),
    [anon_sym_else] = ACTIONS(889),
    [anon_sym_then] = ACTIONS(889),
    [anon_sym_ensure] = ACTIONS(889),
    [sym_identifier] = ACTIONS(889),
    [sym_comment] = ACTIONS(87),
  },
  [663] = {
    [sym__string_end] = ACTIONS(3589),
    [sym_comment] = ACTIONS(87),
  },
  [664] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(2048),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(674),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(674),
    [sym_assignment] = STATE(2048),
    [sym_operator_assignment] = STATE(2048),
    [sym_conditional] = STATE(2048),
    [sym_range] = STATE(2048),
    [sym_binary] = STATE(2048),
    [sym_unary] = STATE(2048),
    [sym_left_assignment_list] = STATE(673),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(674),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(674),
    [sym_false] = STATE(674),
    [sym_nil] = STATE(674),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(675),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1243),
    [anon_sym_yield] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1247),
    [anon_sym_next] = ACTIONS(1249),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [665] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(2057),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2061),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(2061),
    [sym_argument_list] = STATE(563),
    [sym__argument_list_with_parens] = STATE(2058),
    [sym__argument] = STATE(2059),
    [sym_splat_argument] = STATE(2059),
    [sym_hash_splat_argument] = STATE(2059),
    [sym_block_argument] = STATE(2059),
    [sym_assignment] = STATE(2057),
    [sym_operator_assignment] = STATE(2057),
    [sym_conditional] = STATE(2057),
    [sym_range] = STATE(2057),
    [sym_binary] = STATE(2057),
    [sym_unary] = STATE(2057),
    [sym_left_assignment_list] = STATE(2060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2061),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2061),
    [sym_false] = STATE(2061),
    [sym_nil] = STATE(2061),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2062),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(2059),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(3591),
    [sym__splat_star] = ACTIONS(3593),
    [sym__unary_minus] = ACTIONS(3595),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(3597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(365),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(3599),
    [anon_sym_not] = ACTIONS(3601),
    [anon_sym_BANG] = ACTIONS(3603),
    [anon_sym_TILDE] = ACTIONS(3605),
    [sym_constant] = ACTIONS(3607),
    [sym_identifier] = ACTIONS(3607),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [666] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(2057),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2061),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(2061),
    [sym_argument_list] = STATE(569),
    [sym__argument_list_with_parens] = STATE(2058),
    [sym__argument] = STATE(2059),
    [sym_splat_argument] = STATE(2059),
    [sym_hash_splat_argument] = STATE(2059),
    [sym_block_argument] = STATE(2059),
    [sym_assignment] = STATE(2057),
    [sym_operator_assignment] = STATE(2057),
    [sym_conditional] = STATE(2057),
    [sym_range] = STATE(2057),
    [sym_binary] = STATE(2057),
    [sym_unary] = STATE(2057),
    [sym_left_assignment_list] = STATE(2060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2061),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2061),
    [sym_false] = STATE(2061),
    [sym_nil] = STATE(2061),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2062),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(2059),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(3591),
    [sym__splat_star] = ACTIONS(3593),
    [sym__unary_minus] = ACTIONS(3595),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(3597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(417),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(3599),
    [anon_sym_not] = ACTIONS(3601),
    [anon_sym_BANG] = ACTIONS(3603),
    [anon_sym_TILDE] = ACTIONS(3605),
    [sym_constant] = ACTIONS(3607),
    [sym_identifier] = ACTIONS(3607),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [667] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(2057),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2061),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(2061),
    [sym_argument_list] = STATE(570),
    [sym__argument_list_with_parens] = STATE(2058),
    [sym__argument] = STATE(2059),
    [sym_splat_argument] = STATE(2059),
    [sym_hash_splat_argument] = STATE(2059),
    [sym_block_argument] = STATE(2059),
    [sym_assignment] = STATE(2057),
    [sym_operator_assignment] = STATE(2057),
    [sym_conditional] = STATE(2057),
    [sym_range] = STATE(2057),
    [sym_binary] = STATE(2057),
    [sym_unary] = STATE(2057),
    [sym_left_assignment_list] = STATE(2060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2061),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2061),
    [sym_false] = STATE(2061),
    [sym_nil] = STATE(2061),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2062),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(2059),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(3591),
    [sym__splat_star] = ACTIONS(3593),
    [sym__unary_minus] = ACTIONS(3595),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(3597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(421),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(3599),
    [anon_sym_not] = ACTIONS(3601),
    [anon_sym_BANG] = ACTIONS(3603),
    [anon_sym_TILDE] = ACTIONS(3605),
    [sym_constant] = ACTIONS(3607),
    [sym_identifier] = ACTIONS(3607),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [668] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(2057),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2061),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(2061),
    [sym_argument_list] = STATE(571),
    [sym__argument_list_with_parens] = STATE(2058),
    [sym__argument] = STATE(2059),
    [sym_splat_argument] = STATE(2059),
    [sym_hash_splat_argument] = STATE(2059),
    [sym_block_argument] = STATE(2059),
    [sym_assignment] = STATE(2057),
    [sym_operator_assignment] = STATE(2057),
    [sym_conditional] = STATE(2057),
    [sym_range] = STATE(2057),
    [sym_binary] = STATE(2057),
    [sym_unary] = STATE(2057),
    [sym_left_assignment_list] = STATE(2060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2061),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2061),
    [sym_false] = STATE(2061),
    [sym_nil] = STATE(2061),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2062),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(2059),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(3591),
    [sym__splat_star] = ACTIONS(3593),
    [sym__unary_minus] = ACTIONS(3595),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(3597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(425),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(3599),
    [anon_sym_not] = ACTIONS(3601),
    [anon_sym_BANG] = ACTIONS(3603),
    [anon_sym_TILDE] = ACTIONS(3605),
    [sym_constant] = ACTIONS(3607),
    [sym_identifier] = ACTIONS(3607),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [669] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(2063),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(674),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(674),
    [sym_assignment] = STATE(2063),
    [sym_operator_assignment] = STATE(2063),
    [sym_conditional] = STATE(2063),
    [sym_range] = STATE(2063),
    [sym_binary] = STATE(2063),
    [sym_unary] = STATE(2063),
    [sym_left_assignment_list] = STATE(673),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(674),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(674),
    [sym_false] = STATE(674),
    [sym_nil] = STATE(674),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(675),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1243),
    [anon_sym_yield] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1247),
    [anon_sym_next] = ACTIONS(1249),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [670] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(586),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(674),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(674),
    [sym_assignment] = STATE(586),
    [sym_operator_assignment] = STATE(586),
    [sym_conditional] = STATE(586),
    [sym_range] = STATE(586),
    [sym_binary] = STATE(586),
    [sym_unary] = STATE(586),
    [sym_left_assignment_list] = STATE(673),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(674),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(674),
    [sym_false] = STATE(674),
    [sym_nil] = STATE(674),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(675),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1243),
    [anon_sym_yield] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1247),
    [anon_sym_next] = ACTIONS(1249),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [671] = {
    [sym__binary_minus] = ACTIONS(3609),
    [sym__binary_star] = ACTIONS(3611),
    [anon_sym_RPAREN] = ACTIONS(3613),
    [anon_sym_PIPE] = ACTIONS(3615),
    [anon_sym_STAR_STAR] = ACTIONS(3611),
    [anon_sym_AMP] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3619),
    [anon_sym_QMARK] = ACTIONS(3621),
    [anon_sym_DOT_DOT] = ACTIONS(3623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3625),
    [anon_sym_and] = ACTIONS(3627),
    [anon_sym_or] = ACTIONS(3627),
    [anon_sym_PIPE_PIPE] = ACTIONS(3629),
    [anon_sym_AMP_AMP] = ACTIONS(3629),
    [anon_sym_LT_LT] = ACTIONS(3631),
    [anon_sym_GT_GT] = ACTIONS(3631),
    [anon_sym_EQ_EQ] = ACTIONS(3633),
    [anon_sym_BANG_EQ] = ACTIONS(3629),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3629),
    [anon_sym_LT_EQ_GT] = ACTIONS(3629),
    [anon_sym_EQ_TILDE] = ACTIONS(3629),
    [anon_sym_BANG_TILDE] = ACTIONS(3629),
    [anon_sym_LT_EQ] = ACTIONS(3619),
    [anon_sym_GT] = ACTIONS(3619),
    [anon_sym_GT_EQ] = ACTIONS(3635),
    [anon_sym_CARET] = ACTIONS(3637),
    [anon_sym_PLUS] = ACTIONS(3609),
    [anon_sym_SLASH] = ACTIONS(3611),
    [anon_sym_PERCENT] = ACTIONS(3611),
    [sym_comment] = ACTIONS(87),
  },
  [672] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(2087),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2092),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2092),
    [sym_argument_list] = STATE(1681),
    [sym__argument_list_with_parens] = STATE(2089),
    [sym__argument] = STATE(2090),
    [sym_splat_argument] = STATE(2090),
    [sym_hash_splat_argument] = STATE(2090),
    [sym_block_argument] = STATE(2090),
    [sym_do_block] = STATE(1684),
    [sym_block] = STATE(1684),
    [sym_assignment] = STATE(2087),
    [sym_operator_assignment] = STATE(2087),
    [sym_conditional] = STATE(2087),
    [sym_range] = STATE(2087),
    [sym_binary] = STATE(2087),
    [sym_unary] = STATE(2087),
    [sym_left_assignment_list] = STATE(2091),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2092),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2092),
    [sym_false] = STATE(2092),
    [sym_nil] = STATE(2092),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(2093),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(2090),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(3639),
    [sym__splat_star] = ACTIONS(3641),
    [sym__unary_minus] = ACTIONS(3643),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(3645),
    [anon_sym_LBRACE] = ACTIONS(2996),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3647),
    [anon_sym_yield] = ACTIONS(3649),
    [anon_sym_break] = ACTIONS(3651),
    [anon_sym_next] = ACTIONS(3653),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(3006),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(3655),
    [anon_sym_not] = ACTIONS(3657),
    [anon_sym_BANG] = ACTIONS(3659),
    [anon_sym_TILDE] = ACTIONS(3661),
    [sym_constant] = ACTIONS(3663),
    [sym_identifier] = ACTIONS(3663),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [673] = {
    [anon_sym_EQ] = ACTIONS(3669),
    [sym_comment] = ACTIONS(87),
  },
  [674] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(3671),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(3673),
    [anon_sym_DASH_EQ] = ACTIONS(3673),
    [anon_sym_STAR_EQ] = ACTIONS(3673),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3673),
    [anon_sym_SLASH_EQ] = ACTIONS(3673),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3673),
    [anon_sym_PIPE_EQ] = ACTIONS(3673),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3673),
    [anon_sym_AMP_EQ] = ACTIONS(3673),
    [anon_sym_PERCENT_EQ] = ACTIONS(3673),
    [anon_sym_GT_GT_EQ] = ACTIONS(3673),
    [anon_sym_LT_LT_EQ] = ACTIONS(3673),
    [anon_sym_CARET_EQ] = ACTIONS(3673),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [675] = {
    [sym_string] = STATE(2096),
    [aux_sym_chained_string_repeat1] = STATE(2096),
    [sym__string_start] = ACTIONS(139),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [676] = {
    [sym__line_break] = ACTIONS(3675),
    [sym__heredoc_body_start] = ACTIONS(3675),
    [ts_builtin_sym_end] = ACTIONS(3675),
    [anon_sym___END__] = ACTIONS(3677),
    [anon_sym_RBRACE] = ACTIONS(3675),
    [anon_sym_LPAREN] = ACTIONS(3675),
    [anon_sym_RPAREN] = ACTIONS(3675),
    [anon_sym_COMMA] = ACTIONS(3675),
    [anon_sym_SEMI] = ACTIONS(3675),
    [anon_sym_STAR] = ACTIONS(3677),
    [anon_sym_STAR_STAR] = ACTIONS(3675),
    [anon_sym_AMP] = ACTIONS(3675),
    [anon_sym_end] = ACTIONS(3677),
    [anon_sym_if] = ACTIONS(3677),
    [anon_sym_unless] = ACTIONS(3677),
    [anon_sym_while] = ACTIONS(3677),
    [anon_sym_until] = ACTIONS(3677),
    [anon_sym_rescue] = ACTIONS(3677),
    [anon_sym_when] = ACTIONS(3677),
    [anon_sym_elsif] = ACTIONS(3677),
    [anon_sym_else] = ACTIONS(3677),
    [anon_sym_then] = ACTIONS(3677),
    [anon_sym_ensure] = ACTIONS(3677),
    [sym_identifier] = ACTIONS(3677),
    [sym_comment] = ACTIONS(87),
  },
  [677] = {
    [sym__method_rest] = STATE(2097),
    [sym_operator] = STATE(132),
    [sym__method_name] = STATE(132),
    [sym_setter] = STATE(132),
    [sym_symbol] = STATE(132),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(3679),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(3679),
    [sym_class_variable] = ACTIONS(3679),
    [sym_global_variable] = ACTIONS(3679),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [678] = {
    [sym__formal_parameter] = STATE(2099),
    [sym__simple_formal_parameter] = STATE(2099),
    [sym_destructured_parameter] = STATE(2099),
    [sym_splat_parameter] = STATE(2099),
    [sym_hash_splat_parameter] = STATE(2099),
    [sym_block_parameter] = STATE(2099),
    [sym_keyword_parameter] = STATE(2099),
    [sym_optional_parameter] = STATE(2099),
    [anon_sym_LPAREN] = ACTIONS(2447),
    [anon_sym_RPAREN] = ACTIONS(3681),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [sym_identifier] = ACTIONS(2451),
    [sym_comment] = ACTIONS(87),
  },
  [679] = {
    [sym__line_break] = ACTIONS(2453),
    [sym__heredoc_body_start] = ACTIONS(2453),
    [anon_sym_COMMA] = ACTIONS(2453),
    [anon_sym_SEMI] = ACTIONS(2453),
    [sym_identifier] = ACTIONS(3683),
    [sym_comment] = ACTIONS(87),
  },
  [680] = {
    [sym__line_break] = ACTIONS(2459),
    [sym__heredoc_body_start] = ACTIONS(2459),
    [anon_sym_COMMA] = ACTIONS(2459),
    [anon_sym_SEMI] = ACTIONS(2459),
    [sym_identifier] = ACTIONS(3685),
    [sym_comment] = ACTIONS(87),
  },
  [681] = {
    [sym_lambda] = STATE(2102),
    [sym_identifier] = ACTIONS(3687),
    [sym_comment] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(3689),
  },
  [682] = {
    [sym__line_break] = ACTIONS(2473),
    [sym__heredoc_body_start] = ACTIONS(2473),
    [anon_sym_COMMA] = ACTIONS(2473),
    [anon_sym_SEMI] = ACTIONS(2473),
    [anon_sym_COLON] = ACTIONS(3691),
    [anon_sym_EQ] = ACTIONS(3693),
    [sym_comment] = ACTIONS(87),
  },
  [683] = {
    [sym__statements] = STATE(284),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(286),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(287),
    [sym_rescue] = STATE(288),
    [sym__body_statement] = STATE(2106),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(3695),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [684] = {
    [sym_heredoc_body] = STATE(2108),
    [sym__terminator] = STATE(2108),
    [sym__line_break] = ACTIONS(3697),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_COMMA] = ACTIONS(3699),
    [anon_sym_SEMI] = ACTIONS(3697),
    [sym_comment] = ACTIONS(87),
  },
  [685] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(1345),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [686] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(1407),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(1409),
    [anon_sym_DASH_EQ] = ACTIONS(1409),
    [anon_sym_STAR_EQ] = ACTIONS(1409),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1409),
    [anon_sym_SLASH_EQ] = ACTIONS(1409),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1409),
    [anon_sym_PIPE_EQ] = ACTIONS(1409),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1409),
    [anon_sym_AMP_EQ] = ACTIONS(1409),
    [anon_sym_PERCENT_EQ] = ACTIONS(1409),
    [anon_sym_GT_GT_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT_EQ] = ACTIONS(1409),
    [anon_sym_CARET_EQ] = ACTIONS(1409),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [687] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(2121),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2125),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2125),
    [sym_argument_list] = STATE(832),
    [sym__argument_list_with_parens] = STATE(2122),
    [sym__argument] = STATE(2123),
    [sym_splat_argument] = STATE(2123),
    [sym_hash_splat_argument] = STATE(2123),
    [sym_block_argument] = STATE(2123),
    [sym_do_block] = STATE(835),
    [sym_block] = STATE(835),
    [sym_assignment] = STATE(2121),
    [sym_operator_assignment] = STATE(2121),
    [sym_conditional] = STATE(2121),
    [sym_range] = STATE(2121),
    [sym_binary] = STATE(2121),
    [sym_unary] = STATE(2121),
    [sym_left_assignment_list] = STATE(2124),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2125),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2125),
    [sym_false] = STATE(2125),
    [sym_nil] = STATE(2125),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2126),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(2123),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(3701),
    [sym__splat_star] = ACTIONS(3703),
    [sym__unary_minus] = ACTIONS(3705),
    [sym__identifier_hash_key] = ACTIONS(3707),
    [anon_sym_LBRACE] = ACTIONS(1489),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(743),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(3709),
    [anon_sym_EQ] = ACTIONS(743),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3713),
    [anon_sym_break] = ACTIONS(3715),
    [anon_sym_next] = ACTIONS(3717),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1473),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(3719),
    [anon_sym_defined_QMARK] = ACTIONS(3721),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [sym_constant] = ACTIONS(3727),
    [sym_identifier] = ACTIONS(3727),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [688] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2134),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2136),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(2136),
    [sym_assignment] = STATE(2134),
    [sym_operator_assignment] = STATE(2134),
    [sym_conditional] = STATE(2134),
    [sym_range] = STATE(2134),
    [sym_binary] = STATE(2134),
    [sym_unary] = STATE(2134),
    [sym_left_assignment_list] = STATE(2135),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2136),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2136),
    [sym_false] = STATE(2136),
    [sym_nil] = STATE(2136),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2137),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3729),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3731),
    [anon_sym_yield] = ACTIONS(3733),
    [anon_sym_break] = ACTIONS(3735),
    [anon_sym_next] = ACTIONS(3737),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3739),
    [anon_sym_defined_QMARK] = ACTIONS(3741),
    [anon_sym_not] = ACTIONS(3743),
    [anon_sym_BANG] = ACTIONS(3745),
    [anon_sym_TILDE] = ACTIONS(3745),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [689] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2138),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2136),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(2136),
    [sym_assignment] = STATE(2138),
    [sym_operator_assignment] = STATE(2138),
    [sym_conditional] = STATE(2138),
    [sym_range] = STATE(2138),
    [sym_binary] = STATE(2138),
    [sym_unary] = STATE(2138),
    [sym_left_assignment_list] = STATE(2135),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2136),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2136),
    [sym_false] = STATE(2136),
    [sym_nil] = STATE(2136),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2137),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3729),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3731),
    [anon_sym_yield] = ACTIONS(3733),
    [anon_sym_break] = ACTIONS(3735),
    [anon_sym_next] = ACTIONS(3737),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3739),
    [anon_sym_defined_QMARK] = ACTIONS(3741),
    [anon_sym_not] = ACTIONS(3743),
    [anon_sym_BANG] = ACTIONS(3745),
    [anon_sym_TILDE] = ACTIONS(3745),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [690] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2139),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(705),
    [sym_scope_resolution] = STATE(701),
    [sym_call] = STATE(701),
    [sym_method_call] = STATE(705),
    [sym_assignment] = STATE(2139),
    [sym_operator_assignment] = STATE(2139),
    [sym_conditional] = STATE(2139),
    [sym_range] = STATE(2139),
    [sym_binary] = STATE(2139),
    [sym_unary] = STATE(2139),
    [sym_left_assignment_list] = STATE(704),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(705),
    [sym__variable] = STATE(701),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(705),
    [sym_false] = STATE(705),
    [sym_nil] = STATE(705),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2140),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3747),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [691] = {
    [anon_sym_COLON] = ACTIONS(3749),
    [sym_comment] = ACTIONS(87),
  },
  [692] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2142),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2136),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(2136),
    [sym_assignment] = STATE(2142),
    [sym_operator_assignment] = STATE(2142),
    [sym_conditional] = STATE(2142),
    [sym_range] = STATE(2142),
    [sym_binary] = STATE(2142),
    [sym_unary] = STATE(2142),
    [sym_left_assignment_list] = STATE(2135),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2136),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2136),
    [sym_false] = STATE(2136),
    [sym_nil] = STATE(2136),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2137),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3729),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3731),
    [anon_sym_yield] = ACTIONS(3733),
    [anon_sym_break] = ACTIONS(3735),
    [anon_sym_next] = ACTIONS(3737),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3739),
    [anon_sym_defined_QMARK] = ACTIONS(3741),
    [anon_sym_not] = ACTIONS(3743),
    [anon_sym_BANG] = ACTIONS(3745),
    [anon_sym_TILDE] = ACTIONS(3745),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [693] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2148),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(705),
    [sym_scope_resolution] = STATE(701),
    [sym_call] = STATE(701),
    [sym_method_call] = STATE(705),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(2149),
    [sym__argument] = STATE(2150),
    [sym_splat_argument] = STATE(2150),
    [sym_hash_splat_argument] = STATE(2150),
    [sym_block_argument] = STATE(2150),
    [sym_assignment] = STATE(2148),
    [sym_operator_assignment] = STATE(2148),
    [sym_conditional] = STATE(2148),
    [sym_range] = STATE(2148),
    [sym_binary] = STATE(2148),
    [sym_unary] = STATE(2148),
    [sym_left_assignment_list] = STATE(704),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(705),
    [sym__variable] = STATE(701),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(705),
    [sym_false] = STATE(705),
    [sym_nil] = STATE(705),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2151),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2150),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(3751),
    [sym__splat_star] = ACTIONS(3753),
    [sym__unary_minus] = ACTIONS(1303),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(3755),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_RPAREN] = ACTIONS(365),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(3757),
    [sym_identifier] = ACTIONS(3757),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [694] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2148),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(705),
    [sym_scope_resolution] = STATE(701),
    [sym_call] = STATE(701),
    [sym_method_call] = STATE(705),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(2149),
    [sym__argument] = STATE(2150),
    [sym_splat_argument] = STATE(2150),
    [sym_hash_splat_argument] = STATE(2150),
    [sym_block_argument] = STATE(2150),
    [sym_assignment] = STATE(2148),
    [sym_operator_assignment] = STATE(2148),
    [sym_conditional] = STATE(2148),
    [sym_range] = STATE(2148),
    [sym_binary] = STATE(2148),
    [sym_unary] = STATE(2148),
    [sym_left_assignment_list] = STATE(704),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(705),
    [sym__variable] = STATE(701),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(705),
    [sym_false] = STATE(705),
    [sym_nil] = STATE(705),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2151),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2150),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(3751),
    [sym__splat_star] = ACTIONS(3753),
    [sym__unary_minus] = ACTIONS(1303),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(3755),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_RPAREN] = ACTIONS(417),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(3757),
    [sym_identifier] = ACTIONS(3757),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [695] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2148),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(705),
    [sym_scope_resolution] = STATE(701),
    [sym_call] = STATE(701),
    [sym_method_call] = STATE(705),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(2149),
    [sym__argument] = STATE(2150),
    [sym_splat_argument] = STATE(2150),
    [sym_hash_splat_argument] = STATE(2150),
    [sym_block_argument] = STATE(2150),
    [sym_assignment] = STATE(2148),
    [sym_operator_assignment] = STATE(2148),
    [sym_conditional] = STATE(2148),
    [sym_range] = STATE(2148),
    [sym_binary] = STATE(2148),
    [sym_unary] = STATE(2148),
    [sym_left_assignment_list] = STATE(704),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(705),
    [sym__variable] = STATE(701),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(705),
    [sym_false] = STATE(705),
    [sym_nil] = STATE(705),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2151),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2150),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(3751),
    [sym__splat_star] = ACTIONS(3753),
    [sym__unary_minus] = ACTIONS(1303),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(3755),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_RPAREN] = ACTIONS(421),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(3757),
    [sym_identifier] = ACTIONS(3757),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [696] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2148),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(705),
    [sym_scope_resolution] = STATE(701),
    [sym_call] = STATE(701),
    [sym_method_call] = STATE(705),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(2149),
    [sym__argument] = STATE(2150),
    [sym_splat_argument] = STATE(2150),
    [sym_hash_splat_argument] = STATE(2150),
    [sym_block_argument] = STATE(2150),
    [sym_assignment] = STATE(2148),
    [sym_operator_assignment] = STATE(2148),
    [sym_conditional] = STATE(2148),
    [sym_range] = STATE(2148),
    [sym_binary] = STATE(2148),
    [sym_unary] = STATE(2148),
    [sym_left_assignment_list] = STATE(704),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(705),
    [sym__variable] = STATE(701),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(705),
    [sym_false] = STATE(705),
    [sym_nil] = STATE(705),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2151),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2150),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(3751),
    [sym__splat_star] = ACTIONS(3753),
    [sym__unary_minus] = ACTIONS(1303),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(3755),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_RPAREN] = ACTIONS(425),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(3757),
    [sym_identifier] = ACTIONS(3757),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [697] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2152),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(705),
    [sym_scope_resolution] = STATE(701),
    [sym_call] = STATE(701),
    [sym_method_call] = STATE(705),
    [sym_assignment] = STATE(2152),
    [sym_operator_assignment] = STATE(2152),
    [sym_conditional] = STATE(2152),
    [sym_range] = STATE(2152),
    [sym_binary] = STATE(2152),
    [sym_unary] = STATE(2152),
    [sym_left_assignment_list] = STATE(704),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(705),
    [sym__variable] = STATE(701),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(705),
    [sym_false] = STATE(705),
    [sym_nil] = STATE(705),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2140),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3747),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [698] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(705),
    [sym_scope_resolution] = STATE(701),
    [sym_call] = STATE(701),
    [sym_method_call] = STATE(705),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(704),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(705),
    [sym__variable] = STATE(701),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(705),
    [sym_false] = STATE(705),
    [sym_nil] = STATE(705),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2140),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3747),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [699] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(3759),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [700] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(3761),
    [sym__binary_star] = ACTIONS(3763),
    [anon_sym_RPAREN] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(3765),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(3763),
    [anon_sym_AMP] = ACTIONS(3767),
    [anon_sym_LT] = ACTIONS(3769),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_unless] = ACTIONS(1625),
    [anon_sym_while] = ACTIONS(1625),
    [anon_sym_until] = ACTIONS(1625),
    [anon_sym_rescue] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(3749),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(3771),
    [anon_sym_DOT_DOT] = ACTIONS(3773),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3775),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(3777),
    [anon_sym_AMP_AMP] = ACTIONS(3777),
    [anon_sym_LT_LT] = ACTIONS(3779),
    [anon_sym_GT_GT] = ACTIONS(3779),
    [anon_sym_EQ_EQ] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3777),
    [anon_sym_LT_EQ_GT] = ACTIONS(3777),
    [anon_sym_EQ_TILDE] = ACTIONS(3777),
    [anon_sym_BANG_TILDE] = ACTIONS(3777),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3783),
    [anon_sym_CARET] = ACTIONS(3785),
    [anon_sym_PLUS] = ACTIONS(3761),
    [anon_sym_SLASH] = ACTIONS(3763),
    [anon_sym_PERCENT] = ACTIONS(3763),
    [sym_comment] = ACTIONS(87),
  },
  [701] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(2169),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(742),
    [sym_scope_resolution] = STATE(738),
    [sym_call] = STATE(738),
    [sym_method_call] = STATE(742),
    [sym_argument_list] = STATE(938),
    [sym__argument_list_with_parens] = STATE(2170),
    [sym__argument] = STATE(2171),
    [sym_splat_argument] = STATE(2171),
    [sym_hash_splat_argument] = STATE(2171),
    [sym_block_argument] = STATE(2171),
    [sym_do_block] = STATE(941),
    [sym_block] = STATE(941),
    [sym_assignment] = STATE(2169),
    [sym_operator_assignment] = STATE(2169),
    [sym_conditional] = STATE(2169),
    [sym_range] = STATE(2169),
    [sym_binary] = STATE(2169),
    [sym_unary] = STATE(2169),
    [sym_left_assignment_list] = STATE(741),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(742),
    [sym__variable] = STATE(738),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(742),
    [sym_false] = STATE(742),
    [sym_nil] = STATE(742),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2172),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(2171),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(743),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(3787),
    [sym__splat_star] = ACTIONS(3789),
    [sym__unary_minus] = ACTIONS(1375),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(3791),
    [anon_sym_LBRACE] = ACTIONS(1669),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1381),
    [anon_sym_break] = ACTIONS(1383),
    [anon_sym_next] = ACTIONS(1385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(769),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(769),
    [anon_sym_until] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(769),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(1671),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(1387),
    [anon_sym_not] = ACTIONS(1389),
    [anon_sym_BANG] = ACTIONS(1391),
    [anon_sym_TILDE] = ACTIONS(1393),
    [sym_constant] = ACTIONS(3793),
    [sym_identifier] = ACTIONS(3793),
    [sym_instance_variable] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1397),
    [sym_global_variable] = ACTIONS(1397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [702] = {
    [sym_heredoc_body] = STATE(2173),
    [aux_sym_call_repeat1] = STATE(2173),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [703] = {
    [sym_heredoc_body] = STATE(2173),
    [aux_sym_call_repeat1] = STATE(2173),
    [aux_sym_argument_list_repeat1] = STATE(2175),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(3795),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [704] = {
    [anon_sym_EQ] = ACTIONS(3797),
    [sym_comment] = ACTIONS(87),
  },
  [705] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(3799),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(3801),
    [anon_sym_DASH_EQ] = ACTIONS(3801),
    [anon_sym_STAR_EQ] = ACTIONS(3801),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3801),
    [anon_sym_SLASH_EQ] = ACTIONS(3801),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3801),
    [anon_sym_PIPE_EQ] = ACTIONS(3801),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3801),
    [anon_sym_AMP_EQ] = ACTIONS(3801),
    [anon_sym_PERCENT_EQ] = ACTIONS(3801),
    [anon_sym_GT_GT_EQ] = ACTIONS(3801),
    [anon_sym_LT_LT_EQ] = ACTIONS(3801),
    [anon_sym_CARET_EQ] = ACTIONS(3801),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [706] = {
    [sym_string] = STATE(2178),
    [aux_sym_chained_string_repeat1] = STATE(2178),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(3803),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [707] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(1343),
    [sym__binary_star] = ACTIONS(1345),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(1345),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_DOT_DOT] = ACTIONS(1355),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1357),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(1361),
    [anon_sym_AMP_AMP] = ACTIONS(1361),
    [anon_sym_LT_LT] = ACTIONS(1363),
    [anon_sym_GT_GT] = ACTIONS(1363),
    [anon_sym_EQ_EQ] = ACTIONS(1365),
    [anon_sym_BANG_EQ] = ACTIONS(1361),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1361),
    [anon_sym_LT_EQ_GT] = ACTIONS(1361),
    [anon_sym_EQ_TILDE] = ACTIONS(1361),
    [anon_sym_BANG_TILDE] = ACTIONS(1361),
    [anon_sym_LT_EQ] = ACTIONS(1351),
    [anon_sym_GT] = ACTIONS(1351),
    [anon_sym_GT_EQ] = ACTIONS(1367),
    [anon_sym_CARET] = ACTIONS(1369),
    [anon_sym_PLUS] = ACTIONS(1343),
    [anon_sym_SLASH] = ACTIONS(1345),
    [anon_sym_PERCENT] = ACTIONS(1345),
    [sym_comment] = ACTIONS(87),
  },
  [708] = {
    [aux_sym_undef_repeat1] = STATE(2179),
    [sym__line_break] = ACTIONS(2251),
    [sym__heredoc_body_start] = ACTIONS(2251),
    [anon_sym_RPAREN] = ACTIONS(2251),
    [anon_sym_COMMA] = ACTIONS(2253),
    [anon_sym_SEMI] = ACTIONS(2251),
    [anon_sym_if] = ACTIONS(2251),
    [anon_sym_unless] = ACTIONS(2251),
    [anon_sym_while] = ACTIONS(2251),
    [anon_sym_until] = ACTIONS(2251),
    [anon_sym_rescue] = ACTIONS(2251),
    [sym_comment] = ACTIONS(87),
  },
  [709] = {
    [sym__line_break] = ACTIONS(3805),
    [sym__heredoc_body_start] = ACTIONS(3805),
    [sym__binary_minus] = ACTIONS(3805),
    [sym__binary_star] = ACTIONS(3805),
    [ts_builtin_sym_end] = ACTIONS(3805),
    [anon_sym___END__] = ACTIONS(3805),
    [anon_sym_LBRACE] = ACTIONS(3805),
    [anon_sym_RBRACE] = ACTIONS(3805),
    [anon_sym_RPAREN] = ACTIONS(3805),
    [anon_sym_DOT] = ACTIONS(3807),
    [anon_sym_COMMA] = ACTIONS(3805),
    [anon_sym_PIPE] = ACTIONS(3807),
    [anon_sym_SEMI] = ACTIONS(3805),
    [anon_sym_STAR_STAR] = ACTIONS(3805),
    [anon_sym_AMP] = ACTIONS(3807),
    [anon_sym_LT] = ACTIONS(3807),
    [anon_sym_end] = ACTIONS(3805),
    [anon_sym_if] = ACTIONS(3805),
    [anon_sym_unless] = ACTIONS(3805),
    [anon_sym_while] = ACTIONS(3805),
    [anon_sym_until] = ACTIONS(3805),
    [anon_sym_rescue] = ACTIONS(3805),
    [anon_sym_do] = ACTIONS(3805),
    [anon_sym_when] = ACTIONS(3805),
    [anon_sym_elsif] = ACTIONS(3805),
    [anon_sym_else] = ACTIONS(3805),
    [anon_sym_then] = ACTIONS(3805),
    [anon_sym_ensure] = ACTIONS(3805),
    [anon_sym_EQ_GT] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(3805),
    [anon_sym_COLON_COLON2] = ACTIONS(3805),
    [anon_sym_AMP_DOT] = ACTIONS(3805),
    [anon_sym_QMARK] = ACTIONS(3805),
    [anon_sym_DOT_DOT] = ACTIONS(3807),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3805),
    [anon_sym_and] = ACTIONS(3805),
    [anon_sym_or] = ACTIONS(3805),
    [anon_sym_PIPE_PIPE] = ACTIONS(3805),
    [anon_sym_AMP_AMP] = ACTIONS(3805),
    [anon_sym_LT_LT] = ACTIONS(3805),
    [anon_sym_GT_GT] = ACTIONS(3805),
    [anon_sym_EQ_EQ] = ACTIONS(3807),
    [anon_sym_BANG_EQ] = ACTIONS(3805),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3805),
    [anon_sym_LT_EQ_GT] = ACTIONS(3805),
    [anon_sym_EQ_TILDE] = ACTIONS(3805),
    [anon_sym_BANG_TILDE] = ACTIONS(3805),
    [anon_sym_LT_EQ] = ACTIONS(3807),
    [anon_sym_GT] = ACTIONS(3807),
    [anon_sym_GT_EQ] = ACTIONS(3805),
    [anon_sym_CARET] = ACTIONS(3805),
    [anon_sym_PLUS] = ACTIONS(3805),
    [anon_sym_SLASH] = ACTIONS(3805),
    [anon_sym_PERCENT] = ACTIONS(3805),
    [sym_comment] = ACTIONS(87),
  },
  [710] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2180),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(686),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(686),
    [sym_assignment] = STATE(2180),
    [sym_operator_assignment] = STATE(2180),
    [sym_conditional] = STATE(2180),
    [sym_range] = STATE(2180),
    [sym_binary] = STATE(2180),
    [sym_unary] = STATE(2180),
    [sym_left_assignment_list] = STATE(147),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(686),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(686),
    [sym_false] = STATE(686),
    [sym_nil] = STATE(686),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(151),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [711] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2181),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(686),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(686),
    [sym_assignment] = STATE(2181),
    [sym_operator_assignment] = STATE(2181),
    [sym_conditional] = STATE(2181),
    [sym_range] = STATE(2181),
    [sym_binary] = STATE(2181),
    [sym_unary] = STATE(2181),
    [sym_left_assignment_list] = STATE(147),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(686),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(686),
    [sym_false] = STATE(686),
    [sym_nil] = STATE(686),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(151),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [712] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2182),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(686),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(686),
    [sym_assignment] = STATE(2182),
    [sym_operator_assignment] = STATE(2182),
    [sym_conditional] = STATE(2182),
    [sym_range] = STATE(2182),
    [sym_binary] = STATE(2182),
    [sym_unary] = STATE(2182),
    [sym_left_assignment_list] = STATE(147),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(686),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(686),
    [sym_false] = STATE(686),
    [sym_nil] = STATE(686),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(151),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [713] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2183),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(686),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(686),
    [sym_assignment] = STATE(2183),
    [sym_operator_assignment] = STATE(2183),
    [sym_conditional] = STATE(2183),
    [sym_range] = STATE(2183),
    [sym_binary] = STATE(2183),
    [sym_unary] = STATE(2183),
    [sym_left_assignment_list] = STATE(147),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(686),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(686),
    [sym_false] = STATE(686),
    [sym_nil] = STATE(686),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(151),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [714] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2184),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(686),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(686),
    [sym_assignment] = STATE(2184),
    [sym_operator_assignment] = STATE(2184),
    [sym_conditional] = STATE(2184),
    [sym_range] = STATE(2184),
    [sym_binary] = STATE(2184),
    [sym_unary] = STATE(2184),
    [sym_left_assignment_list] = STATE(147),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(686),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(686),
    [sym_false] = STATE(686),
    [sym_nil] = STATE(686),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(151),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [715] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2185),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(686),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(686),
    [sym_assignment] = STATE(2185),
    [sym_operator_assignment] = STATE(2185),
    [sym_conditional] = STATE(2185),
    [sym_range] = STATE(2185),
    [sym_binary] = STATE(2185),
    [sym_unary] = STATE(2185),
    [sym_left_assignment_list] = STATE(147),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(686),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(686),
    [sym_false] = STATE(686),
    [sym_nil] = STATE(686),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(151),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [716] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2186),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(686),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(686),
    [sym_assignment] = STATE(2186),
    [sym_operator_assignment] = STATE(2186),
    [sym_conditional] = STATE(2186),
    [sym_range] = STATE(2186),
    [sym_binary] = STATE(2186),
    [sym_unary] = STATE(2186),
    [sym_left_assignment_list] = STATE(147),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(686),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(686),
    [sym_false] = STATE(686),
    [sym_nil] = STATE(686),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(151),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [717] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2187),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(686),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(686),
    [sym_assignment] = STATE(2187),
    [sym_operator_assignment] = STATE(2187),
    [sym_conditional] = STATE(2187),
    [sym_range] = STATE(2187),
    [sym_binary] = STATE(2187),
    [sym_unary] = STATE(2187),
    [sym_left_assignment_list] = STATE(147),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(686),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(686),
    [sym_false] = STATE(686),
    [sym_nil] = STATE(686),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(151),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [718] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2188),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(686),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(686),
    [sym_assignment] = STATE(2188),
    [sym_operator_assignment] = STATE(2188),
    [sym_conditional] = STATE(2188),
    [sym_range] = STATE(2188),
    [sym_binary] = STATE(2188),
    [sym_unary] = STATE(2188),
    [sym_left_assignment_list] = STATE(147),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(686),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(686),
    [sym_false] = STATE(686),
    [sym_nil] = STATE(686),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(151),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [719] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2189),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(686),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(686),
    [sym_assignment] = STATE(2189),
    [sym_operator_assignment] = STATE(2189),
    [sym_conditional] = STATE(2189),
    [sym_range] = STATE(2189),
    [sym_binary] = STATE(2189),
    [sym_unary] = STATE(2189),
    [sym_left_assignment_list] = STATE(147),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(686),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(686),
    [sym_false] = STATE(686),
    [sym_nil] = STATE(686),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(151),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [720] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(2190),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(2190),
    [sym_operator_assignment] = STATE(2190),
    [sym_conditional] = STATE(2190),
    [sym_range] = STATE(2190),
    [sym_binary] = STATE(2190),
    [sym_unary] = STATE(2190),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [721] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2191),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(686),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(686),
    [sym_assignment] = STATE(2191),
    [sym_operator_assignment] = STATE(2191),
    [sym_conditional] = STATE(2191),
    [sym_range] = STATE(2191),
    [sym_binary] = STATE(2191),
    [sym_unary] = STATE(2191),
    [sym_left_assignment_list] = STATE(147),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(686),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(686),
    [sym_false] = STATE(686),
    [sym_nil] = STATE(686),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(151),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [722] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2192),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(686),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(686),
    [sym_assignment] = STATE(2192),
    [sym_operator_assignment] = STATE(2192),
    [sym_conditional] = STATE(2192),
    [sym_range] = STATE(2192),
    [sym_binary] = STATE(2192),
    [sym_unary] = STATE(2192),
    [sym_left_assignment_list] = STATE(147),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(686),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(686),
    [sym_false] = STATE(686),
    [sym_nil] = STATE(686),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(151),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [723] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2193),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(686),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(686),
    [sym_assignment] = STATE(2193),
    [sym_operator_assignment] = STATE(2193),
    [sym_conditional] = STATE(2193),
    [sym_range] = STATE(2193),
    [sym_binary] = STATE(2193),
    [sym_unary] = STATE(2193),
    [sym_left_assignment_list] = STATE(147),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(686),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(686),
    [sym_false] = STATE(686),
    [sym_nil] = STATE(686),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(151),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [724] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2194),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(686),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(686),
    [sym_assignment] = STATE(2194),
    [sym_operator_assignment] = STATE(2194),
    [sym_conditional] = STATE(2194),
    [sym_range] = STATE(2194),
    [sym_binary] = STATE(2194),
    [sym_unary] = STATE(2194),
    [sym_left_assignment_list] = STATE(147),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(686),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(686),
    [sym_false] = STATE(686),
    [sym_nil] = STATE(686),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(151),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [725] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(2202),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2205),
    [sym_scope_resolution] = STATE(2203),
    [sym_call] = STATE(2203),
    [sym_method_call] = STATE(2205),
    [sym_assignment] = STATE(2202),
    [sym_operator_assignment] = STATE(2202),
    [sym_conditional] = STATE(2202),
    [sym_range] = STATE(2202),
    [sym_binary] = STATE(2202),
    [sym_unary] = STATE(2202),
    [sym_left_assignment_list] = STATE(2204),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2205),
    [sym__variable] = STATE(2203),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2205),
    [sym_false] = STATE(2205),
    [sym_nil] = STATE(2205),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2206),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(3809),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(3811),
    [anon_sym_yield] = ACTIONS(3813),
    [anon_sym_break] = ACTIONS(3815),
    [anon_sym_next] = ACTIONS(3817),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(3819),
    [anon_sym_defined_QMARK] = ACTIONS(3821),
    [anon_sym_not] = ACTIONS(3823),
    [anon_sym_BANG] = ACTIONS(3825),
    [anon_sym_TILDE] = ACTIONS(3825),
    [sym_constant] = ACTIONS(3827),
    [sym_identifier] = ACTIONS(3827),
    [sym_instance_variable] = ACTIONS(3829),
    [sym_class_variable] = ACTIONS(3829),
    [sym_global_variable] = ACTIONS(3829),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(3827),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3827),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [726] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(2207),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2205),
    [sym_scope_resolution] = STATE(2203),
    [sym_call] = STATE(2203),
    [sym_method_call] = STATE(2205),
    [sym_assignment] = STATE(2207),
    [sym_operator_assignment] = STATE(2207),
    [sym_conditional] = STATE(2207),
    [sym_range] = STATE(2207),
    [sym_binary] = STATE(2207),
    [sym_unary] = STATE(2207),
    [sym_left_assignment_list] = STATE(2204),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2205),
    [sym__variable] = STATE(2203),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2205),
    [sym_false] = STATE(2205),
    [sym_nil] = STATE(2205),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2206),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(3809),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(3811),
    [anon_sym_yield] = ACTIONS(3813),
    [anon_sym_break] = ACTIONS(3815),
    [anon_sym_next] = ACTIONS(3817),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(3819),
    [anon_sym_defined_QMARK] = ACTIONS(3821),
    [anon_sym_not] = ACTIONS(3823),
    [anon_sym_BANG] = ACTIONS(3825),
    [anon_sym_TILDE] = ACTIONS(3825),
    [sym_constant] = ACTIONS(3827),
    [sym_identifier] = ACTIONS(3827),
    [sym_instance_variable] = ACTIONS(3829),
    [sym_class_variable] = ACTIONS(3829),
    [sym_global_variable] = ACTIONS(3829),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(3827),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3827),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [727] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(2208),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(742),
    [sym_scope_resolution] = STATE(738),
    [sym_call] = STATE(738),
    [sym_method_call] = STATE(742),
    [sym_assignment] = STATE(2208),
    [sym_operator_assignment] = STATE(2208),
    [sym_conditional] = STATE(2208),
    [sym_range] = STATE(2208),
    [sym_binary] = STATE(2208),
    [sym_unary] = STATE(2208),
    [sym_left_assignment_list] = STATE(741),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(742),
    [sym__variable] = STATE(738),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(742),
    [sym_false] = STATE(742),
    [sym_nil] = STATE(742),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2209),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1381),
    [anon_sym_break] = ACTIONS(1383),
    [anon_sym_next] = ACTIONS(1385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(3831),
    [anon_sym_defined_QMARK] = ACTIONS(1387),
    [anon_sym_not] = ACTIONS(1389),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_TILDE] = ACTIONS(1393),
    [sym_constant] = ACTIONS(1399),
    [sym_identifier] = ACTIONS(1399),
    [sym_instance_variable] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1397),
    [sym_global_variable] = ACTIONS(1397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [728] = {
    [anon_sym_COLON] = ACTIONS(3833),
    [sym_comment] = ACTIONS(87),
  },
  [729] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(2211),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2205),
    [sym_scope_resolution] = STATE(2203),
    [sym_call] = STATE(2203),
    [sym_method_call] = STATE(2205),
    [sym_assignment] = STATE(2211),
    [sym_operator_assignment] = STATE(2211),
    [sym_conditional] = STATE(2211),
    [sym_range] = STATE(2211),
    [sym_binary] = STATE(2211),
    [sym_unary] = STATE(2211),
    [sym_left_assignment_list] = STATE(2204),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2205),
    [sym__variable] = STATE(2203),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2205),
    [sym_false] = STATE(2205),
    [sym_nil] = STATE(2205),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2206),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(3809),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(3811),
    [anon_sym_yield] = ACTIONS(3813),
    [anon_sym_break] = ACTIONS(3815),
    [anon_sym_next] = ACTIONS(3817),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(3819),
    [anon_sym_defined_QMARK] = ACTIONS(3821),
    [anon_sym_not] = ACTIONS(3823),
    [anon_sym_BANG] = ACTIONS(3825),
    [anon_sym_TILDE] = ACTIONS(3825),
    [sym_constant] = ACTIONS(3827),
    [sym_identifier] = ACTIONS(3827),
    [sym_instance_variable] = ACTIONS(3829),
    [sym_class_variable] = ACTIONS(3829),
    [sym_global_variable] = ACTIONS(3829),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(3827),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3827),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [730] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(2169),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(742),
    [sym_scope_resolution] = STATE(738),
    [sym_call] = STATE(738),
    [sym_method_call] = STATE(742),
    [sym_argument_list] = STATE(1535),
    [sym__argument_list_with_parens] = STATE(2170),
    [sym__argument] = STATE(2171),
    [sym_splat_argument] = STATE(2171),
    [sym_hash_splat_argument] = STATE(2171),
    [sym_block_argument] = STATE(2171),
    [sym_assignment] = STATE(2169),
    [sym_operator_assignment] = STATE(2169),
    [sym_conditional] = STATE(2169),
    [sym_range] = STATE(2169),
    [sym_binary] = STATE(2169),
    [sym_unary] = STATE(2169),
    [sym_left_assignment_list] = STATE(741),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(742),
    [sym__variable] = STATE(738),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(742),
    [sym_false] = STATE(742),
    [sym_nil] = STATE(742),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2172),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(2171),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(3787),
    [sym__splat_star] = ACTIONS(3789),
    [sym__unary_minus] = ACTIONS(1375),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(3791),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_RPAREN] = ACTIONS(365),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1381),
    [anon_sym_break] = ACTIONS(1383),
    [anon_sym_next] = ACTIONS(1385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(365),
    [anon_sym_DASH_EQ] = ACTIONS(365),
    [anon_sym_STAR_EQ] = ACTIONS(365),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(365),
    [anon_sym_SLASH_EQ] = ACTIONS(365),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(365),
    [anon_sym_PIPE_EQ] = ACTIONS(365),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(365),
    [anon_sym_AMP_EQ] = ACTIONS(365),
    [anon_sym_PERCENT_EQ] = ACTIONS(365),
    [anon_sym_GT_GT_EQ] = ACTIONS(365),
    [anon_sym_LT_LT_EQ] = ACTIONS(365),
    [anon_sym_CARET_EQ] = ACTIONS(365),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_PERCENT] = ACTIONS(377),
    [anon_sym_defined_QMARK] = ACTIONS(1387),
    [anon_sym_not] = ACTIONS(1389),
    [anon_sym_BANG] = ACTIONS(1391),
    [anon_sym_TILDE] = ACTIONS(1393),
    [sym_constant] = ACTIONS(3793),
    [sym_identifier] = ACTIONS(3793),
    [sym_instance_variable] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1397),
    [sym_global_variable] = ACTIONS(1397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [731] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(2169),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(742),
    [sym_scope_resolution] = STATE(738),
    [sym_call] = STATE(738),
    [sym_method_call] = STATE(742),
    [sym_argument_list] = STATE(1536),
    [sym__argument_list_with_parens] = STATE(2170),
    [sym__argument] = STATE(2171),
    [sym_splat_argument] = STATE(2171),
    [sym_hash_splat_argument] = STATE(2171),
    [sym_block_argument] = STATE(2171),
    [sym_assignment] = STATE(2169),
    [sym_operator_assignment] = STATE(2169),
    [sym_conditional] = STATE(2169),
    [sym_range] = STATE(2169),
    [sym_binary] = STATE(2169),
    [sym_unary] = STATE(2169),
    [sym_left_assignment_list] = STATE(741),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(742),
    [sym__variable] = STATE(738),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(742),
    [sym_false] = STATE(742),
    [sym_nil] = STATE(742),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2172),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(2171),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(3787),
    [sym__splat_star] = ACTIONS(3789),
    [sym__unary_minus] = ACTIONS(1375),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(3791),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_RPAREN] = ACTIONS(417),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_EQ] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1381),
    [anon_sym_break] = ACTIONS(1383),
    [anon_sym_next] = ACTIONS(1385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(417),
    [anon_sym_DASH_EQ] = ACTIONS(417),
    [anon_sym_STAR_EQ] = ACTIONS(417),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(417),
    [anon_sym_SLASH_EQ] = ACTIONS(417),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(417),
    [anon_sym_PIPE_EQ] = ACTIONS(417),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(417),
    [anon_sym_AMP_EQ] = ACTIONS(417),
    [anon_sym_PERCENT_EQ] = ACTIONS(417),
    [anon_sym_GT_GT_EQ] = ACTIONS(417),
    [anon_sym_LT_LT_EQ] = ACTIONS(417),
    [anon_sym_CARET_EQ] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(1387),
    [anon_sym_not] = ACTIONS(1389),
    [anon_sym_BANG] = ACTIONS(1391),
    [anon_sym_TILDE] = ACTIONS(1393),
    [sym_constant] = ACTIONS(3793),
    [sym_identifier] = ACTIONS(3793),
    [sym_instance_variable] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1397),
    [sym_global_variable] = ACTIONS(1397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [732] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(2169),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(742),
    [sym_scope_resolution] = STATE(738),
    [sym_call] = STATE(738),
    [sym_method_call] = STATE(742),
    [sym_argument_list] = STATE(1537),
    [sym__argument_list_with_parens] = STATE(2170),
    [sym__argument] = STATE(2171),
    [sym_splat_argument] = STATE(2171),
    [sym_hash_splat_argument] = STATE(2171),
    [sym_block_argument] = STATE(2171),
    [sym_assignment] = STATE(2169),
    [sym_operator_assignment] = STATE(2169),
    [sym_conditional] = STATE(2169),
    [sym_range] = STATE(2169),
    [sym_binary] = STATE(2169),
    [sym_unary] = STATE(2169),
    [sym_left_assignment_list] = STATE(741),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(742),
    [sym__variable] = STATE(738),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(742),
    [sym_false] = STATE(742),
    [sym_nil] = STATE(742),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2172),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(2171),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(3787),
    [sym__splat_star] = ACTIONS(3789),
    [sym__unary_minus] = ACTIONS(1375),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(3791),
    [anon_sym_LBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_RPAREN] = ACTIONS(421),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_EQ] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1381),
    [anon_sym_break] = ACTIONS(1383),
    [anon_sym_next] = ACTIONS(1385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(421),
    [anon_sym_DASH_EQ] = ACTIONS(421),
    [anon_sym_STAR_EQ] = ACTIONS(421),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(421),
    [anon_sym_SLASH_EQ] = ACTIONS(421),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(421),
    [anon_sym_PIPE_EQ] = ACTIONS(421),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(421),
    [anon_sym_AMP_EQ] = ACTIONS(421),
    [anon_sym_PERCENT_EQ] = ACTIONS(421),
    [anon_sym_GT_GT_EQ] = ACTIONS(421),
    [anon_sym_LT_LT_EQ] = ACTIONS(421),
    [anon_sym_CARET_EQ] = ACTIONS(421),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(1387),
    [anon_sym_not] = ACTIONS(1389),
    [anon_sym_BANG] = ACTIONS(1391),
    [anon_sym_TILDE] = ACTIONS(1393),
    [sym_constant] = ACTIONS(3793),
    [sym_identifier] = ACTIONS(3793),
    [sym_instance_variable] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1397),
    [sym_global_variable] = ACTIONS(1397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [733] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(2169),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(742),
    [sym_scope_resolution] = STATE(738),
    [sym_call] = STATE(738),
    [sym_method_call] = STATE(742),
    [sym_argument_list] = STATE(1538),
    [sym__argument_list_with_parens] = STATE(2170),
    [sym__argument] = STATE(2171),
    [sym_splat_argument] = STATE(2171),
    [sym_hash_splat_argument] = STATE(2171),
    [sym_block_argument] = STATE(2171),
    [sym_assignment] = STATE(2169),
    [sym_operator_assignment] = STATE(2169),
    [sym_conditional] = STATE(2169),
    [sym_range] = STATE(2169),
    [sym_binary] = STATE(2169),
    [sym_unary] = STATE(2169),
    [sym_left_assignment_list] = STATE(741),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(742),
    [sym__variable] = STATE(738),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(742),
    [sym_false] = STATE(742),
    [sym_nil] = STATE(742),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2172),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(2171),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(3787),
    [sym__splat_star] = ACTIONS(3789),
    [sym__unary_minus] = ACTIONS(1375),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(3791),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_RPAREN] = ACTIONS(425),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(427),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1381),
    [anon_sym_break] = ACTIONS(1383),
    [anon_sym_next] = ACTIONS(1385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(425),
    [anon_sym_DASH_EQ] = ACTIONS(425),
    [anon_sym_STAR_EQ] = ACTIONS(425),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(425),
    [anon_sym_SLASH_EQ] = ACTIONS(425),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(425),
    [anon_sym_PIPE_EQ] = ACTIONS(425),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(425),
    [anon_sym_AMP_EQ] = ACTIONS(425),
    [anon_sym_PERCENT_EQ] = ACTIONS(425),
    [anon_sym_GT_GT_EQ] = ACTIONS(425),
    [anon_sym_LT_LT_EQ] = ACTIONS(425),
    [anon_sym_CARET_EQ] = ACTIONS(425),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(1387),
    [anon_sym_not] = ACTIONS(1389),
    [anon_sym_BANG] = ACTIONS(1391),
    [anon_sym_TILDE] = ACTIONS(1393),
    [sym_constant] = ACTIONS(3793),
    [sym_identifier] = ACTIONS(3793),
    [sym_instance_variable] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1397),
    [sym_global_variable] = ACTIONS(1397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [734] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(2212),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(742),
    [sym_scope_resolution] = STATE(738),
    [sym_call] = STATE(738),
    [sym_method_call] = STATE(742),
    [sym_assignment] = STATE(2212),
    [sym_operator_assignment] = STATE(2212),
    [sym_conditional] = STATE(2212),
    [sym_range] = STATE(2212),
    [sym_binary] = STATE(2212),
    [sym_unary] = STATE(2212),
    [sym_left_assignment_list] = STATE(741),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(742),
    [sym__variable] = STATE(738),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(742),
    [sym_false] = STATE(742),
    [sym_nil] = STATE(742),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2209),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1381),
    [anon_sym_break] = ACTIONS(1383),
    [anon_sym_next] = ACTIONS(1385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(3831),
    [anon_sym_defined_QMARK] = ACTIONS(1387),
    [anon_sym_not] = ACTIONS(1389),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_TILDE] = ACTIONS(1393),
    [sym_constant] = ACTIONS(1399),
    [sym_identifier] = ACTIONS(1399),
    [sym_instance_variable] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1397),
    [sym_global_variable] = ACTIONS(1397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [735] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(1559),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(742),
    [sym_scope_resolution] = STATE(738),
    [sym_call] = STATE(738),
    [sym_method_call] = STATE(742),
    [sym_assignment] = STATE(1559),
    [sym_operator_assignment] = STATE(1559),
    [sym_conditional] = STATE(1559),
    [sym_range] = STATE(1559),
    [sym_binary] = STATE(1559),
    [sym_unary] = STATE(1559),
    [sym_left_assignment_list] = STATE(741),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(742),
    [sym__variable] = STATE(738),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(742),
    [sym_false] = STATE(742),
    [sym_nil] = STATE(742),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2209),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1381),
    [anon_sym_break] = ACTIONS(1383),
    [anon_sym_next] = ACTIONS(1385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(3831),
    [anon_sym_defined_QMARK] = ACTIONS(1387),
    [anon_sym_not] = ACTIONS(1389),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_TILDE] = ACTIONS(1393),
    [sym_constant] = ACTIONS(1399),
    [sym_identifier] = ACTIONS(1399),
    [sym_instance_variable] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1397),
    [sym_global_variable] = ACTIONS(1397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [736] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(3835),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [737] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(3837),
    [sym__binary_star] = ACTIONS(3839),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_RPAREN] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(3841),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(3843),
    [anon_sym_AMP] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(1631),
    [anon_sym_LT] = ACTIONS(3847),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_unless] = ACTIONS(1625),
    [anon_sym_while] = ACTIONS(1625),
    [anon_sym_until] = ACTIONS(1625),
    [anon_sym_rescue] = ACTIONS(1625),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(3833),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_PLUS_EQ] = ACTIONS(1625),
    [anon_sym_DASH_EQ] = ACTIONS(1625),
    [anon_sym_STAR_EQ] = ACTIONS(1625),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1625),
    [anon_sym_SLASH_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1625),
    [anon_sym_AMP_EQ] = ACTIONS(1625),
    [anon_sym_PERCENT_EQ] = ACTIONS(1625),
    [anon_sym_GT_GT_EQ] = ACTIONS(1625),
    [anon_sym_LT_LT_EQ] = ACTIONS(1625),
    [anon_sym_CARET_EQ] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(3849),
    [anon_sym_DOT_DOT] = ACTIONS(3851),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3853),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(3855),
    [anon_sym_AMP_AMP] = ACTIONS(3855),
    [anon_sym_LT_LT] = ACTIONS(3857),
    [anon_sym_GT_GT] = ACTIONS(3857),
    [anon_sym_EQ_EQ] = ACTIONS(3855),
    [anon_sym_BANG_EQ] = ACTIONS(3859),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3859),
    [anon_sym_LT_EQ_GT] = ACTIONS(3859),
    [anon_sym_EQ_TILDE] = ACTIONS(3859),
    [anon_sym_BANG_TILDE] = ACTIONS(3859),
    [anon_sym_LT_EQ] = ACTIONS(3847),
    [anon_sym_GT] = ACTIONS(3847),
    [anon_sym_GT_EQ] = ACTIONS(3861),
    [anon_sym_CARET] = ACTIONS(3841),
    [anon_sym_PLUS] = ACTIONS(3863),
    [anon_sym_SLASH] = ACTIONS(3843),
    [anon_sym_PERCENT] = ACTIONS(3843),
    [sym_comment] = ACTIONS(87),
  },
  [738] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(2169),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(742),
    [sym_scope_resolution] = STATE(738),
    [sym_call] = STATE(738),
    [sym_method_call] = STATE(742),
    [sym_argument_list] = STATE(1578),
    [sym__argument_list_with_parens] = STATE(2170),
    [sym__argument] = STATE(2171),
    [sym_splat_argument] = STATE(2171),
    [sym_hash_splat_argument] = STATE(2171),
    [sym_block_argument] = STATE(2171),
    [sym_do_block] = STATE(941),
    [sym_block] = STATE(941),
    [sym_assignment] = STATE(2169),
    [sym_operator_assignment] = STATE(2169),
    [sym_conditional] = STATE(2169),
    [sym_range] = STATE(2169),
    [sym_binary] = STATE(2169),
    [sym_unary] = STATE(2169),
    [sym_left_assignment_list] = STATE(741),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(742),
    [sym__variable] = STATE(738),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(742),
    [sym_false] = STATE(742),
    [sym_nil] = STATE(742),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2172),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(2171),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(743),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(3787),
    [sym__splat_star] = ACTIONS(3789),
    [sym__unary_minus] = ACTIONS(1375),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(3791),
    [anon_sym_LBRACE] = ACTIONS(2715),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1381),
    [anon_sym_break] = ACTIONS(1383),
    [anon_sym_next] = ACTIONS(1385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(769),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(769),
    [anon_sym_until] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(769),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(769),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(1387),
    [anon_sym_not] = ACTIONS(1389),
    [anon_sym_BANG] = ACTIONS(1391),
    [anon_sym_TILDE] = ACTIONS(1393),
    [sym_constant] = ACTIONS(3793),
    [sym_identifier] = ACTIONS(3793),
    [sym_instance_variable] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1397),
    [sym_global_variable] = ACTIONS(1397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [739] = {
    [sym_heredoc_body] = STATE(2224),
    [aux_sym_call_repeat1] = STATE(2224),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [740] = {
    [sym_heredoc_body] = STATE(2224),
    [aux_sym_call_repeat1] = STATE(2224),
    [aux_sym_argument_list_repeat1] = STATE(2226),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(3865),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [741] = {
    [anon_sym_EQ] = ACTIONS(3867),
    [sym_comment] = ACTIONS(87),
  },
  [742] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(3869),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(3871),
    [anon_sym_DASH_EQ] = ACTIONS(3871),
    [anon_sym_STAR_EQ] = ACTIONS(3871),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3871),
    [anon_sym_SLASH_EQ] = ACTIONS(3871),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3871),
    [anon_sym_PIPE_EQ] = ACTIONS(3871),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3871),
    [anon_sym_AMP_EQ] = ACTIONS(3871),
    [anon_sym_PERCENT_EQ] = ACTIONS(3871),
    [anon_sym_GT_GT_EQ] = ACTIONS(3871),
    [anon_sym_LT_LT_EQ] = ACTIONS(3871),
    [anon_sym_CARET_EQ] = ACTIONS(3871),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [743] = {
    [sym_string] = STATE(2229),
    [aux_sym_chained_string_repeat1] = STATE(2229),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(747),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(3873),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [744] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2234),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2237),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(2237),
    [sym_splat_argument] = STATE(2235),
    [sym_assignment] = STATE(2234),
    [sym_operator_assignment] = STATE(2234),
    [sym_conditional] = STATE(2234),
    [sym_range] = STATE(2234),
    [sym_binary] = STATE(2234),
    [sym_unary] = STATE(2234),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(2235),
    [sym_left_assignment_list] = STATE(2236),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2237),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2237),
    [sym_false] = STATE(2237),
    [sym_nil] = STATE(2237),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2137),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(3875),
    [sym__unary_minus] = ACTIONS(3877),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3731),
    [anon_sym_yield] = ACTIONS(3733),
    [anon_sym_break] = ACTIONS(3735),
    [anon_sym_next] = ACTIONS(3737),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3879),
    [anon_sym_defined_QMARK] = ACTIONS(3881),
    [anon_sym_not] = ACTIONS(3883),
    [anon_sym_BANG] = ACTIONS(3885),
    [anon_sym_TILDE] = ACTIONS(3885),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [745] = {
    [anon_sym_RPAREN] = ACTIONS(3887),
    [anon_sym_COMMA] = ACTIONS(3887),
    [anon_sym_EQ] = ACTIONS(3887),
    [anon_sym_in] = ACTIONS(3887),
    [sym_comment] = ACTIONS(87),
  },
  [746] = {
    [sym_method] = STATE(184),
    [sym_singleton_method] = STATE(184),
    [sym_class] = STATE(184),
    [sym_singleton_class] = STATE(184),
    [sym_module] = STATE(184),
    [sym_return] = STATE(184),
    [sym_yield] = STATE(184),
    [sym_break] = STATE(184),
    [sym_next] = STATE(184),
    [sym_while] = STATE(184),
    [sym_until] = STATE(184),
    [sym_for] = STATE(184),
    [sym_case] = STATE(184),
    [sym_if] = STATE(184),
    [sym_unless] = STATE(184),
    [sym_begin] = STATE(184),
    [sym__primary] = STATE(184),
    [sym_parenthesized_statements] = STATE(184),
    [sym_element_reference] = STATE(1598),
    [sym_scope_resolution] = STATE(687),
    [sym_call] = STATE(687),
    [sym_method_call] = STATE(1598),
    [sym_destructured_left_assignment] = STATE(1597),
    [sym_rest_assignment] = STATE(1597),
    [sym__lhs] = STATE(1598),
    [sym__variable] = STATE(687),
    [sym_rational] = STATE(184),
    [sym_true] = STATE(1598),
    [sym_false] = STATE(1598),
    [sym_nil] = STATE(1598),
    [sym_chained_string] = STATE(184),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(184),
    [sym_string_array] = STATE(184),
    [sym_symbol_array] = STATE(184),
    [sym_symbol] = STATE(184),
    [sym_regex] = STATE(184),
    [sym_array] = STATE(184),
    [sym_hash] = STATE(184),
    [sym_lambda] = STATE(184),
    [sym__simple_symbol] = ACTIONS(279),
    [sym__string_start] = ACTIONS(281),
    [sym__symbol_start] = ACTIONS(283),
    [sym__subshell_start] = ACTIONS(285),
    [sym__regex_start] = ACTIONS(287),
    [sym__string_array_start] = ACTIONS(289),
    [sym__symbol_array_start] = ACTIONS(291),
    [sym_heredoc_beginning] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_def] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(475),
    [anon_sym_RPAREN] = ACTIONS(2749),
    [anon_sym_COLON_COLON] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(249),
    [anon_sym_EQ] = ACTIONS(2749),
    [anon_sym_class] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(307),
    [anon_sym_return] = ACTIONS(309),
    [anon_sym_yield] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_next] = ACTIONS(315),
    [sym_redo] = ACTIONS(317),
    [sym_retry] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(319),
    [anon_sym_unless] = ACTIONS(321),
    [anon_sym_while] = ACTIONS(323),
    [anon_sym_until] = ACTIONS(325),
    [anon_sym_for] = ACTIONS(327),
    [anon_sym_case] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(331),
    [sym_constant] = ACTIONS(1295),
    [sym_identifier] = ACTIONS(1295),
    [sym_instance_variable] = ACTIONS(1297),
    [sym_class_variable] = ACTIONS(1297),
    [sym_global_variable] = ACTIONS(1297),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(317),
    [sym_complex] = ACTIONS(293),
    [sym_super] = ACTIONS(1295),
    [anon_sym_true] = ACTIONS(339),
    [anon_sym_TRUE] = ACTIONS(339),
    [anon_sym_false] = ACTIONS(341),
    [anon_sym_FALSE] = ACTIONS(341),
    [sym_self] = ACTIONS(1295),
    [anon_sym_nil] = ACTIONS(343),
    [anon_sym_NIL] = ACTIONS(343),
    [sym_character] = ACTIONS(293),
    [anon_sym_LBRACK2] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(347),
  },
  [747] = {
    [aux_sym__mlhs_repeat1] = STATE(2239),
    [anon_sym_RPAREN] = ACTIONS(2749),
    [anon_sym_COMMA] = ACTIONS(3889),
    [anon_sym_EQ] = ACTIONS(2749),
    [sym_comment] = ACTIONS(87),
  },
  [748] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2240),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(686),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(686),
    [sym_assignment] = STATE(2240),
    [sym_operator_assignment] = STATE(2240),
    [sym_conditional] = STATE(2240),
    [sym_range] = STATE(2240),
    [sym_binary] = STATE(2240),
    [sym_unary] = STATE(2240),
    [sym_left_assignment_list] = STATE(147),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(686),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(686),
    [sym_false] = STATE(686),
    [sym_nil] = STATE(686),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(151),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [749] = {
    [sym_string] = STATE(2241),
    [aux_sym_chained_string_repeat1] = STATE(2241),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_RPAREN] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [750] = {
    [sym_heredoc_body] = STATE(370),
    [sym__terminator] = STATE(370),
    [sym__line_break] = ACTIONS(687),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_RPAREN] = ACTIONS(2757),
    [anon_sym_SEMI] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(1333),
    [anon_sym_unless] = ACTIONS(1335),
    [anon_sym_while] = ACTIONS(1337),
    [anon_sym_until] = ACTIONS(1339),
    [anon_sym_rescue] = ACTIONS(1341),
    [sym_comment] = ACTIONS(87),
  },
  [751] = {
    [sym_begin_block] = STATE(1611),
    [sym_end_block] = STATE(1611),
    [sym__statement] = STATE(1611),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1611),
    [sym_unless_modifier] = STATE(1611),
    [sym_while_modifier] = STATE(1611),
    [sym_until_modifier] = STATE(1611),
    [sym_rescue_modifier] = STATE(1611),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1612),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1615),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(1615),
    [sym_assignment] = STATE(1612),
    [sym_operator_assignment] = STATE(1612),
    [sym_conditional] = STATE(1612),
    [sym_range] = STATE(1612),
    [sym_binary] = STATE(1612),
    [sym_unary] = STATE(1612),
    [sym_left_assignment_list] = STATE(1614),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1615),
    [sym__variable] = STATE(1613),
    [sym_undef] = STATE(1611),
    [sym_alias] = STATE(1611),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1615),
    [sym_false] = STATE(1615),
    [sym_nil] = STATE(1615),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1616),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(751),
    [aux_sym__statements_repeat1] = STATE(751),
    [sym__simple_symbol] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(2762),
    [sym__symbol_start] = ACTIONS(2765),
    [sym__subshell_start] = ACTIONS(2768),
    [sym__regex_start] = ACTIONS(2771),
    [sym__string_array_start] = ACTIONS(2774),
    [sym__symbol_array_start] = ACTIONS(2777),
    [sym_heredoc_beginning] = ACTIONS(2780),
    [sym__unary_minus] = ACTIONS(2783),
    [anon_sym_BEGIN] = ACTIONS(2786),
    [anon_sym_LBRACE] = ACTIONS(2789),
    [anon_sym_END] = ACTIONS(2792),
    [anon_sym_def] = ACTIONS(2795),
    [anon_sym_LPAREN] = ACTIONS(2798),
    [anon_sym_RPAREN] = ACTIONS(2491),
    [anon_sym_COLON_COLON] = ACTIONS(2801),
    [anon_sym_SEMI] = ACTIONS(2804),
    [anon_sym_STAR] = ACTIONS(2807),
    [anon_sym_class] = ACTIONS(2810),
    [anon_sym_module] = ACTIONS(2813),
    [anon_sym_return] = ACTIONS(2816),
    [anon_sym_yield] = ACTIONS(2819),
    [anon_sym_break] = ACTIONS(2822),
    [anon_sym_next] = ACTIONS(2825),
    [sym_redo] = ACTIONS(2828),
    [sym_retry] = ACTIONS(2828),
    [anon_sym_if] = ACTIONS(2831),
    [anon_sym_unless] = ACTIONS(2834),
    [anon_sym_while] = ACTIONS(2837),
    [anon_sym_until] = ACTIONS(2840),
    [anon_sym_for] = ACTIONS(2843),
    [anon_sym_case] = ACTIONS(2846),
    [anon_sym_begin] = ACTIONS(2849),
    [anon_sym_PLUS] = ACTIONS(2852),
    [anon_sym_defined_QMARK] = ACTIONS(2855),
    [anon_sym_not] = ACTIONS(2858),
    [anon_sym_BANG] = ACTIONS(2861),
    [anon_sym_TILDE] = ACTIONS(2861),
    [sym_constant] = ACTIONS(2864),
    [sym_identifier] = ACTIONS(2864),
    [sym_instance_variable] = ACTIONS(2867),
    [sym_class_variable] = ACTIONS(2867),
    [sym_global_variable] = ACTIONS(2867),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_alias] = ACTIONS(2873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2876),
    [sym_float] = ACTIONS(2828),
    [sym_complex] = ACTIONS(2780),
    [sym_super] = ACTIONS(2864),
    [anon_sym_true] = ACTIONS(2879),
    [anon_sym_TRUE] = ACTIONS(2879),
    [anon_sym_false] = ACTIONS(2882),
    [anon_sym_FALSE] = ACTIONS(2882),
    [sym_self] = ACTIONS(2864),
    [anon_sym_nil] = ACTIONS(2885),
    [anon_sym_NIL] = ACTIONS(2885),
    [sym_character] = ACTIONS(2780),
    [anon_sym_LBRACK2] = ACTIONS(2888),
    [anon_sym_DASH_GT] = ACTIONS(2891),
  },
  [752] = {
    [sym__string_start] = ACTIONS(835),
    [anon_sym_DOT] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_COLON_COLON2] = ACTIONS(835),
    [anon_sym_AMP_DOT] = ACTIONS(835),
    [sym_comment] = ACTIONS(87),
  },
  [753] = {
    [sym__string_end] = ACTIONS(3891),
    [sym_comment] = ACTIONS(87),
  },
  [754] = {
    [anon_sym_RBRACE] = ACTIONS(887),
    [anon_sym_DOT] = ACTIONS(887),
    [anon_sym_COMMA] = ACTIONS(887),
    [anon_sym_if] = ACTIONS(887),
    [anon_sym_unless] = ACTIONS(887),
    [anon_sym_while] = ACTIONS(887),
    [anon_sym_until] = ACTIONS(887),
    [anon_sym_rescue] = ACTIONS(887),
    [anon_sym_LBRACK] = ACTIONS(887),
    [anon_sym_COLON_COLON2] = ACTIONS(887),
    [anon_sym_AMP_DOT] = ACTIONS(887),
    [sym_comment] = ACTIONS(87),
  },
  [755] = {
    [sym__string_end] = ACTIONS(3893),
    [sym_comment] = ACTIONS(87),
  },
  [756] = {
    [anon_sym_DOT] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(893),
    [anon_sym_COLON_COLON2] = ACTIONS(893),
    [anon_sym_AMP_DOT] = ACTIONS(893),
    [sym_comment] = ACTIONS(87),
  },
  [757] = {
    [sym__string_end] = ACTIONS(3895),
    [sym_comment] = ACTIONS(87),
  },
  [758] = {
    [anon_sym_DOT] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(899),
    [anon_sym_COLON_COLON2] = ACTIONS(899),
    [anon_sym_AMP_DOT] = ACTIONS(899),
    [sym_comment] = ACTIONS(87),
  },
  [759] = {
    [sym__string_end] = ACTIONS(3897),
    [sym_comment] = ACTIONS(87),
  },
  [760] = {
    [anon_sym_DOT] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_COLON_COLON2] = ACTIONS(905),
    [anon_sym_AMP_DOT] = ACTIONS(905),
    [sym_comment] = ACTIONS(87),
  },
  [761] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(2248),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(3899),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(3901),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [762] = {
    [aux_sym_string_array_repeat1] = STATE(2251),
    [sym__string_end] = ACTIONS(3903),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(3905),
  },
  [763] = {
    [anon_sym_DOT] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(923),
    [anon_sym_COLON_COLON2] = ACTIONS(923),
    [anon_sym_AMP_DOT] = ACTIONS(923),
    [sym_comment] = ACTIONS(87),
  },
  [764] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(2254),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(3907),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(3909),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [765] = {
    [aux_sym_symbol_array_repeat1] = STATE(2257),
    [sym__string_end] = ACTIONS(3911),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(3913),
  },
  [766] = {
    [anon_sym_DOT] = ACTIONS(993),
    [anon_sym_LBRACK] = ACTIONS(993),
    [anon_sym_COLON_COLON2] = ACTIONS(993),
    [anon_sym_AMP_DOT] = ACTIONS(993),
    [sym_comment] = ACTIONS(87),
  },
  [767] = {
    [anon_sym_RBRACE] = ACTIONS(3915),
    [sym_comment] = ACTIONS(87),
  },
  [768] = {
    [sym_heredoc_body] = STATE(2259),
    [sym__heredoc_body_start] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(3915),
    [sym_comment] = ACTIONS(87),
  },
  [769] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(2260),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(674),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(674),
    [sym_assignment] = STATE(2260),
    [sym_operator_assignment] = STATE(2260),
    [sym_conditional] = STATE(2260),
    [sym_range] = STATE(2260),
    [sym_binary] = STATE(2260),
    [sym_unary] = STATE(2260),
    [sym_left_assignment_list] = STATE(673),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(674),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(674),
    [sym_false] = STATE(674),
    [sym_nil] = STATE(674),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(675),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1243),
    [anon_sym_yield] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1247),
    [anon_sym_next] = ACTIONS(1249),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [770] = {
    [anon_sym_DOT] = ACTIONS(1273),
    [anon_sym_LBRACK] = ACTIONS(1273),
    [anon_sym_COLON_COLON2] = ACTIONS(1273),
    [anon_sym_AMP_DOT] = ACTIONS(1273),
    [sym_comment] = ACTIONS(87),
  },
  [771] = {
    [anon_sym_DOT] = ACTIONS(3917),
    [anon_sym_COLON_COLON] = ACTIONS(3917),
    [sym_comment] = ACTIONS(87),
  },
  [772] = {
    [sym_method_parameters] = STATE(2262),
    [sym__simple_formal_parameter] = STATE(684),
    [sym_splat_parameter] = STATE(684),
    [sym_hash_splat_parameter] = STATE(684),
    [sym_block_parameter] = STATE(684),
    [sym_keyword_parameter] = STATE(684),
    [sym_optional_parameter] = STATE(684),
    [sym_heredoc_body] = STATE(2262),
    [sym__terminator] = STATE(2262),
    [sym__line_break] = ACTIONS(3919),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_SEMI] = ACTIONS(3919),
    [anon_sym_STAR] = ACTIONS(1283),
    [anon_sym_STAR_STAR] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1287),
    [sym_identifier] = ACTIONS(1289),
    [sym_comment] = ACTIONS(87),
  },
  [773] = {
    [anon_sym_DOT] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_COLON_COLON2] = ACTIONS(1291),
    [anon_sym_AMP_DOT] = ACTIONS(1291),
    [sym_comment] = ACTIONS(87),
  },
  [774] = {
    [anon_sym_RPAREN] = ACTIONS(3921),
    [sym_comment] = ACTIONS(87),
  },
  [775] = {
    [sym__simple_symbol] = ACTIONS(1411),
    [sym__string_start] = ACTIONS(1411),
    [sym__symbol_start] = ACTIONS(1411),
    [sym__subshell_start] = ACTIONS(1411),
    [sym__regex_start] = ACTIONS(1411),
    [sym__string_array_start] = ACTIONS(1411),
    [sym__symbol_array_start] = ACTIONS(1411),
    [sym_heredoc_beginning] = ACTIONS(1411),
    [sym__block_ampersand] = ACTIONS(1411),
    [sym__splat_star] = ACTIONS(1411),
    [sym__unary_minus] = ACTIONS(1411),
    [sym__identifier_hash_key] = ACTIONS(1411),
    [anon_sym_LBRACE] = ACTIONS(1411),
    [anon_sym_def] = ACTIONS(1413),
    [anon_sym_LPAREN] = ACTIONS(1413),
    [anon_sym_RPAREN] = ACTIONS(1411),
    [anon_sym_DOT] = ACTIONS(1411),
    [anon_sym_COLON_COLON] = ACTIONS(1413),
    [anon_sym_COMMA] = ACTIONS(1411),
    [anon_sym_STAR] = ACTIONS(1413),
    [anon_sym_STAR_STAR] = ACTIONS(1411),
    [anon_sym_EQ] = ACTIONS(1411),
    [anon_sym_class] = ACTIONS(1413),
    [anon_sym_module] = ACTIONS(1413),
    [anon_sym_return] = ACTIONS(1413),
    [anon_sym_yield] = ACTIONS(1413),
    [anon_sym_break] = ACTIONS(1413),
    [anon_sym_next] = ACTIONS(1413),
    [sym_redo] = ACTIONS(1413),
    [sym_retry] = ACTIONS(1413),
    [anon_sym_if] = ACTIONS(1413),
    [anon_sym_unless] = ACTIONS(1413),
    [anon_sym_while] = ACTIONS(1413),
    [anon_sym_until] = ACTIONS(1413),
    [anon_sym_for] = ACTIONS(1413),
    [anon_sym_in] = ACTIONS(1413),
    [anon_sym_do] = ACTIONS(1413),
    [anon_sym_case] = ACTIONS(1413),
    [anon_sym_begin] = ACTIONS(1413),
    [anon_sym_LBRACK] = ACTIONS(1411),
    [anon_sym_COLON_COLON2] = ACTIONS(1411),
    [anon_sym_AMP_DOT] = ACTIONS(1411),
    [anon_sym_LPAREN2] = ACTIONS(1411),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_defined_QMARK] = ACTIONS(1411),
    [anon_sym_not] = ACTIONS(1413),
    [anon_sym_BANG] = ACTIONS(1411),
    [anon_sym_TILDE] = ACTIONS(1411),
    [sym_constant] = ACTIONS(1413),
    [sym_identifier] = ACTIONS(1413),
    [sym_instance_variable] = ACTIONS(1411),
    [sym_class_variable] = ACTIONS(1411),
    [sym_global_variable] = ACTIONS(1411),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1413),
    [sym_float] = ACTIONS(1413),
    [sym_complex] = ACTIONS(1411),
    [sym_super] = ACTIONS(1413),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_TRUE] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_FALSE] = ACTIONS(1413),
    [sym_self] = ACTIONS(1413),
    [anon_sym_nil] = ACTIONS(1413),
    [anon_sym_NIL] = ACTIONS(1413),
    [sym_character] = ACTIONS(1411),
    [anon_sym_LBRACK2] = ACTIONS(1413),
    [anon_sym_DASH_GT] = ACTIONS(1411),
  },
  [776] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2264),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(2264),
    [sym_operator_assignment] = STATE(2264),
    [sym_conditional] = STATE(2264),
    [sym_range] = STATE(2264),
    [sym_binary] = STATE(2264),
    [sym_unary] = STATE(2264),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(485),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(495),
    [anon_sym_defined_QMARK] = ACTIONS(497),
    [anon_sym_not] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(501),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [777] = {
    [sym_superclass] = STATE(2265),
    [sym_heredoc_body] = STATE(2266),
    [sym__terminator] = STATE(2266),
    [sym__line_break] = ACTIONS(3923),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1089),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(3923),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1089),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1517),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1089),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [778] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_superclass] = STATE(2265),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(859),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym_argument_list] = STATE(832),
    [sym__argument_list_with_parens] = STATE(860),
    [sym__argument] = STATE(861),
    [sym_splat_argument] = STATE(861),
    [sym_hash_splat_argument] = STATE(861),
    [sym_block_argument] = STATE(861),
    [sym_do_block] = STATE(835),
    [sym_block] = STATE(835),
    [sym_assignment] = STATE(859),
    [sym_operator_assignment] = STATE(859),
    [sym_conditional] = STATE(859),
    [sym_range] = STATE(859),
    [sym_binary] = STATE(859),
    [sym_unary] = STATE(859),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(864),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_heredoc_body] = STATE(2266),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(861),
    [sym_lambda] = STATE(347),
    [sym__terminator] = STATE(2266),
    [sym__line_break] = ACTIONS(3923),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1521),
    [sym__splat_star] = ACTIONS(1523),
    [sym__unary_minus] = ACTIONS(1525),
    [sym__identifier_hash_key] = ACTIONS(1527),
    [anon_sym_LBRACE] = ACTIONS(1529),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(743),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(3923),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1531),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(1517),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1473),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(1549),
    [sym_identifier] = ACTIONS(1549),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [779] = {
    [sym_heredoc_body] = STATE(2268),
    [sym__terminator] = STATE(2268),
    [sym__line_break] = ACTIONS(3925),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1089),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(3925),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1089),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(3927),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1089),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [780] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(859),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym_argument_list] = STATE(832),
    [sym__argument_list_with_parens] = STATE(860),
    [sym__argument] = STATE(861),
    [sym_splat_argument] = STATE(861),
    [sym_hash_splat_argument] = STATE(861),
    [sym_block_argument] = STATE(861),
    [sym_do_block] = STATE(835),
    [sym_block] = STATE(835),
    [sym_assignment] = STATE(859),
    [sym_operator_assignment] = STATE(859),
    [sym_conditional] = STATE(859),
    [sym_range] = STATE(859),
    [sym_binary] = STATE(859),
    [sym_unary] = STATE(859),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(864),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_heredoc_body] = STATE(2268),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(861),
    [sym_lambda] = STATE(347),
    [sym__terminator] = STATE(2268),
    [sym__line_break] = ACTIONS(3925),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1521),
    [sym__splat_star] = ACTIONS(1523),
    [sym__unary_minus] = ACTIONS(1525),
    [sym__identifier_hash_key] = ACTIONS(1527),
    [anon_sym_LBRACE] = ACTIONS(1529),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(743),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(3925),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1531),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_end] = ACTIONS(3927),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1473),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(1549),
    [sym_identifier] = ACTIONS(1549),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [781] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(2276),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2279),
    [sym_scope_resolution] = STATE(2277),
    [sym_call] = STATE(2277),
    [sym_method_call] = STATE(2279),
    [sym_assignment] = STATE(2276),
    [sym_operator_assignment] = STATE(2276),
    [sym_conditional] = STATE(2276),
    [sym_range] = STATE(2276),
    [sym_binary] = STATE(2276),
    [sym_unary] = STATE(2276),
    [sym_left_assignment_list] = STATE(2278),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2277),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2279),
    [sym_false] = STATE(2279),
    [sym_nil] = STATE(2279),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2280),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3931),
    [anon_sym_yield] = ACTIONS(3933),
    [anon_sym_break] = ACTIONS(3935),
    [anon_sym_next] = ACTIONS(3937),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3939),
    [anon_sym_defined_QMARK] = ACTIONS(3941),
    [anon_sym_not] = ACTIONS(3943),
    [anon_sym_BANG] = ACTIONS(3945),
    [anon_sym_TILDE] = ACTIONS(3945),
    [sym_constant] = ACTIONS(3947),
    [sym_identifier] = ACTIONS(3947),
    [sym_instance_variable] = ACTIONS(3949),
    [sym_class_variable] = ACTIONS(3949),
    [sym_global_variable] = ACTIONS(3949),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3947),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3947),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [782] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(2281),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2279),
    [sym_scope_resolution] = STATE(2277),
    [sym_call] = STATE(2277),
    [sym_method_call] = STATE(2279),
    [sym_assignment] = STATE(2281),
    [sym_operator_assignment] = STATE(2281),
    [sym_conditional] = STATE(2281),
    [sym_range] = STATE(2281),
    [sym_binary] = STATE(2281),
    [sym_unary] = STATE(2281),
    [sym_left_assignment_list] = STATE(2278),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2277),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2279),
    [sym_false] = STATE(2279),
    [sym_nil] = STATE(2279),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2280),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3931),
    [anon_sym_yield] = ACTIONS(3933),
    [anon_sym_break] = ACTIONS(3935),
    [anon_sym_next] = ACTIONS(3937),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3939),
    [anon_sym_defined_QMARK] = ACTIONS(3941),
    [anon_sym_not] = ACTIONS(3943),
    [anon_sym_BANG] = ACTIONS(3945),
    [anon_sym_TILDE] = ACTIONS(3945),
    [sym_constant] = ACTIONS(3947),
    [sym_identifier] = ACTIONS(3947),
    [sym_instance_variable] = ACTIONS(3949),
    [sym_class_variable] = ACTIONS(3949),
    [sym_global_variable] = ACTIONS(3949),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3947),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3947),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [783] = {
    [anon_sym_COLON] = ACTIONS(3951),
    [sym_comment] = ACTIONS(87),
  },
  [784] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(2283),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2279),
    [sym_scope_resolution] = STATE(2277),
    [sym_call] = STATE(2277),
    [sym_method_call] = STATE(2279),
    [sym_assignment] = STATE(2283),
    [sym_operator_assignment] = STATE(2283),
    [sym_conditional] = STATE(2283),
    [sym_range] = STATE(2283),
    [sym_binary] = STATE(2283),
    [sym_unary] = STATE(2283),
    [sym_left_assignment_list] = STATE(2278),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2277),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2279),
    [sym_false] = STATE(2279),
    [sym_nil] = STATE(2279),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2280),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3931),
    [anon_sym_yield] = ACTIONS(3933),
    [anon_sym_break] = ACTIONS(3935),
    [anon_sym_next] = ACTIONS(3937),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3939),
    [anon_sym_defined_QMARK] = ACTIONS(3941),
    [anon_sym_not] = ACTIONS(3943),
    [anon_sym_BANG] = ACTIONS(3945),
    [anon_sym_TILDE] = ACTIONS(3945),
    [sym_constant] = ACTIONS(3947),
    [sym_identifier] = ACTIONS(3947),
    [sym_instance_variable] = ACTIONS(3949),
    [sym_class_variable] = ACTIONS(3949),
    [sym_global_variable] = ACTIONS(3949),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3947),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3947),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [785] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(906),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(911),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(911),
    [sym__argument_list_with_trailing_comma] = STATE(2285),
    [sym__argument] = STATE(909),
    [sym_splat_argument] = STATE(909),
    [sym_hash_splat_argument] = STATE(909),
    [sym_block_argument] = STATE(909),
    [sym_assignment] = STATE(906),
    [sym_operator_assignment] = STATE(906),
    [sym_conditional] = STATE(906),
    [sym_range] = STATE(906),
    [sym_binary] = STATE(906),
    [sym_unary] = STATE(906),
    [sym_left_assignment_list] = STATE(910),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(911),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(911),
    [sym_false] = STATE(911),
    [sym_nil] = STATE(911),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(912),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(909),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1589),
    [sym__splat_star] = ACTIONS(1591),
    [sym__unary_minus] = ACTIONS(1593),
    [sym__identifier_hash_key] = ACTIONS(1595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(3953),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1599),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_defined_QMARK] = ACTIONS(1611),
    [anon_sym_not] = ACTIONS(1613),
    [anon_sym_BANG] = ACTIONS(1615),
    [anon_sym_TILDE] = ACTIONS(1615),
    [sym_constant] = ACTIONS(1617),
    [sym_identifier] = ACTIONS(1617),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [786] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(3955),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [787] = {
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(3371),
    [sym__binary_star] = ACTIONS(3373),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(3375),
    [anon_sym_STAR_STAR] = ACTIONS(3373),
    [anon_sym_AMP] = ACTIONS(3377),
    [anon_sym_LT] = ACTIONS(3379),
    [anon_sym_EQ_GT] = ACTIONS(3951),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(3381),
    [anon_sym_DOT_DOT] = ACTIONS(3383),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3385),
    [anon_sym_and] = ACTIONS(3957),
    [anon_sym_or] = ACTIONS(3957),
    [anon_sym_PIPE_PIPE] = ACTIONS(3387),
    [anon_sym_AMP_AMP] = ACTIONS(3387),
    [anon_sym_LT_LT] = ACTIONS(3389),
    [anon_sym_GT_GT] = ACTIONS(3389),
    [anon_sym_EQ_EQ] = ACTIONS(3391),
    [anon_sym_BANG_EQ] = ACTIONS(3387),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3387),
    [anon_sym_LT_EQ_GT] = ACTIONS(3387),
    [anon_sym_EQ_TILDE] = ACTIONS(3387),
    [anon_sym_BANG_TILDE] = ACTIONS(3387),
    [anon_sym_LT_EQ] = ACTIONS(3379),
    [anon_sym_GT] = ACTIONS(3379),
    [anon_sym_GT_EQ] = ACTIONS(3393),
    [anon_sym_CARET] = ACTIONS(3395),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_SLASH] = ACTIONS(3373),
    [anon_sym_PERCENT] = ACTIONS(3373),
    [sym_comment] = ACTIONS(87),
  },
  [788] = {
    [anon_sym_DOT] = ACTIONS(1677),
    [anon_sym_LBRACK] = ACTIONS(1677),
    [anon_sym_COLON_COLON2] = ACTIONS(1677),
    [anon_sym_AMP_DOT] = ACTIONS(1677),
    [sym_comment] = ACTIONS(87),
  },
  [789] = {
    [sym_heredoc_body] = STATE(2288),
    [aux_sym_call_repeat1] = STATE(2288),
    [sym__heredoc_body_start] = ACTIONS(3959),
    [anon_sym_DOT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [790] = {
    [sym_heredoc_body] = STATE(2288),
    [aux_sym_call_repeat1] = STATE(2288),
    [aux_sym_argument_list_repeat1] = STATE(2290),
    [sym__heredoc_body_start] = ACTIONS(3959),
    [anon_sym_DOT] = ACTIONS(1681),
    [anon_sym_COMMA] = ACTIONS(3961),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [791] = {
    [sym_string] = STATE(1890),
    [aux_sym_chained_string_repeat1] = STATE(1890),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(3963),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [792] = {
    [anon_sym_DOT] = ACTIONS(1697),
    [anon_sym_LBRACK] = ACTIONS(1697),
    [anon_sym_COLON_COLON2] = ACTIONS(1697),
    [anon_sym_AMP_DOT] = ACTIONS(1697),
    [sym_comment] = ACTIONS(87),
  },
  [793] = {
    [anon_sym_DOT] = ACTIONS(1701),
    [anon_sym_LBRACK] = ACTIONS(1701),
    [anon_sym_COLON_COLON2] = ACTIONS(1701),
    [anon_sym_AMP_DOT] = ACTIONS(1701),
    [sym_comment] = ACTIONS(87),
  },
  [794] = {
    [anon_sym_DOT] = ACTIONS(1705),
    [anon_sym_LBRACK] = ACTIONS(1705),
    [anon_sym_COLON_COLON2] = ACTIONS(1705),
    [anon_sym_AMP_DOT] = ACTIONS(1705),
    [sym_comment] = ACTIONS(87),
  },
  [795] = {
    [sym_then] = STATE(2291),
    [sym_heredoc_body] = STATE(2292),
    [sym__terminator] = STATE(2292),
    [sym__line_break] = ACTIONS(3965),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(3965),
    [anon_sym_if] = ACTIONS(1743),
    [anon_sym_unless] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1747),
    [anon_sym_until] = ACTIONS(1749),
    [anon_sym_rescue] = ACTIONS(1751),
    [anon_sym_then] = ACTIONS(1753),
    [sym_comment] = ACTIONS(87),
  },
  [796] = {
    [sym_then] = STATE(2293),
    [sym_heredoc_body] = STATE(2294),
    [sym__terminator] = STATE(2294),
    [sym__line_break] = ACTIONS(3967),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(3967),
    [anon_sym_if] = ACTIONS(1743),
    [anon_sym_unless] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1747),
    [anon_sym_until] = ACTIONS(1749),
    [anon_sym_rescue] = ACTIONS(1751),
    [anon_sym_then] = ACTIONS(1821),
    [sym_comment] = ACTIONS(87),
  },
  [797] = {
    [sym__do] = STATE(2295),
    [sym_heredoc_body] = STATE(2295),
    [sym__terminator] = STATE(2295),
    [sym__line_break] = ACTIONS(3969),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym__binary_minus] = ACTIONS(1855),
    [sym__binary_star] = ACTIONS(1857),
    [anon_sym_PIPE] = ACTIONS(1859),
    [anon_sym_SEMI] = ACTIONS(3969),
    [anon_sym_STAR_STAR] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_LT] = ACTIONS(1863),
    [anon_sym_do] = ACTIONS(3969),
    [anon_sym_QMARK] = ACTIONS(1865),
    [anon_sym_DOT_DOT] = ACTIONS(1867),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1869),
    [anon_sym_and] = ACTIONS(1871),
    [anon_sym_or] = ACTIONS(1871),
    [anon_sym_PIPE_PIPE] = ACTIONS(1873),
    [anon_sym_AMP_AMP] = ACTIONS(1873),
    [anon_sym_LT_LT] = ACTIONS(1875),
    [anon_sym_GT_GT] = ACTIONS(1875),
    [anon_sym_EQ_EQ] = ACTIONS(1877),
    [anon_sym_BANG_EQ] = ACTIONS(1873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1873),
    [anon_sym_LT_EQ_GT] = ACTIONS(1873),
    [anon_sym_EQ_TILDE] = ACTIONS(1873),
    [anon_sym_BANG_TILDE] = ACTIONS(1873),
    [anon_sym_LT_EQ] = ACTIONS(1863),
    [anon_sym_GT] = ACTIONS(1863),
    [anon_sym_GT_EQ] = ACTIONS(1879),
    [anon_sym_CARET] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_SLASH] = ACTIONS(1857),
    [anon_sym_PERCENT] = ACTIONS(1857),
    [sym_comment] = ACTIONS(87),
  },
  [798] = {
    [sym__do] = STATE(2296),
    [sym_heredoc_body] = STATE(2296),
    [sym__terminator] = STATE(2296),
    [sym__line_break] = ACTIONS(3971),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym__binary_minus] = ACTIONS(1855),
    [sym__binary_star] = ACTIONS(1857),
    [anon_sym_PIPE] = ACTIONS(1859),
    [anon_sym_SEMI] = ACTIONS(3971),
    [anon_sym_STAR_STAR] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_LT] = ACTIONS(1863),
    [anon_sym_do] = ACTIONS(3971),
    [anon_sym_QMARK] = ACTIONS(1865),
    [anon_sym_DOT_DOT] = ACTIONS(1867),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1869),
    [anon_sym_and] = ACTIONS(1871),
    [anon_sym_or] = ACTIONS(1871),
    [anon_sym_PIPE_PIPE] = ACTIONS(1873),
    [anon_sym_AMP_AMP] = ACTIONS(1873),
    [anon_sym_LT_LT] = ACTIONS(1875),
    [anon_sym_GT_GT] = ACTIONS(1875),
    [anon_sym_EQ_EQ] = ACTIONS(1877),
    [anon_sym_BANG_EQ] = ACTIONS(1873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1873),
    [anon_sym_LT_EQ_GT] = ACTIONS(1873),
    [anon_sym_EQ_TILDE] = ACTIONS(1873),
    [anon_sym_BANG_TILDE] = ACTIONS(1873),
    [anon_sym_LT_EQ] = ACTIONS(1863),
    [anon_sym_GT] = ACTIONS(1863),
    [anon_sym_GT_EQ] = ACTIONS(1879),
    [anon_sym_CARET] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_SLASH] = ACTIONS(1857),
    [anon_sym_PERCENT] = ACTIONS(1857),
    [sym_comment] = ACTIONS(87),
  },
  [799] = {
    [sym_in] = STATE(2297),
    [anon_sym_in] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
  },
  [800] = {
    [sym_heredoc_body] = STATE(2298),
    [sym__terminator] = STATE(2298),
    [sym__line_break] = ACTIONS(3973),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym__binary_minus] = ACTIONS(2001),
    [sym__binary_star] = ACTIONS(2003),
    [anon_sym_PIPE] = ACTIONS(2005),
    [anon_sym_SEMI] = ACTIONS(3973),
    [anon_sym_STAR_STAR] = ACTIONS(2003),
    [anon_sym_AMP] = ACTIONS(2007),
    [anon_sym_LT] = ACTIONS(2009),
    [anon_sym_QMARK] = ACTIONS(2011),
    [anon_sym_DOT_DOT] = ACTIONS(2013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2015),
    [anon_sym_and] = ACTIONS(2017),
    [anon_sym_or] = ACTIONS(2017),
    [anon_sym_PIPE_PIPE] = ACTIONS(2019),
    [anon_sym_AMP_AMP] = ACTIONS(2019),
    [anon_sym_LT_LT] = ACTIONS(2021),
    [anon_sym_GT_GT] = ACTIONS(2021),
    [anon_sym_EQ_EQ] = ACTIONS(2023),
    [anon_sym_BANG_EQ] = ACTIONS(2019),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2019),
    [anon_sym_LT_EQ_GT] = ACTIONS(2019),
    [anon_sym_EQ_TILDE] = ACTIONS(2019),
    [anon_sym_BANG_TILDE] = ACTIONS(2019),
    [anon_sym_LT_EQ] = ACTIONS(2009),
    [anon_sym_GT] = ACTIONS(2009),
    [anon_sym_GT_EQ] = ACTIONS(2025),
    [anon_sym_CARET] = ACTIONS(2027),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_SLASH] = ACTIONS(2003),
    [anon_sym_PERCENT] = ACTIONS(2003),
    [sym_comment] = ACTIONS(87),
  },
  [801] = {
    [sym_when] = STATE(2302),
    [sym_else] = STATE(2300),
    [aux_sym_case_repeat1] = STATE(2301),
    [aux_sym_case_repeat2] = STATE(2302),
    [anon_sym_SEMI] = ACTIONS(3975),
    [anon_sym_end] = ACTIONS(3977),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [802] = {
    [sym_else] = STATE(2304),
    [sym_ensure] = STATE(2305),
    [sym_rescue] = STATE(2306),
    [anon_sym_end] = ACTIONS(3979),
    [anon_sym_rescue] = ACTIONS(2165),
    [anon_sym_else] = ACTIONS(2167),
    [anon_sym_ensure] = ACTIONS(2169),
    [sym_comment] = ACTIONS(87),
  },
  [803] = {
    [sym_ensure] = STATE(2305),
    [anon_sym_end] = ACTIONS(3979),
    [anon_sym_ensure] = ACTIONS(2169),
    [sym_comment] = ACTIONS(87),
  },
  [804] = {
    [anon_sym_end] = ACTIONS(3979),
    [sym_comment] = ACTIONS(87),
  },
  [805] = {
    [sym_else] = STATE(2304),
    [sym_ensure] = STATE(2305),
    [anon_sym_end] = ACTIONS(3979),
    [anon_sym_else] = ACTIONS(2167),
    [anon_sym_ensure] = ACTIONS(2169),
    [sym_comment] = ACTIONS(87),
  },
  [806] = {
    [anon_sym_DOT] = ACTIONS(2181),
    [anon_sym_LBRACK] = ACTIONS(2181),
    [anon_sym_COLON_COLON2] = ACTIONS(2181),
    [anon_sym_AMP_DOT] = ACTIONS(2181),
    [sym_comment] = ACTIONS(87),
  },
  [807] = {
    [sym__statements] = STATE(802),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(803),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(804),
    [sym_rescue] = STATE(805),
    [sym__body_statement] = STATE(2307),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(3981),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [808] = {
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_LBRACK] = ACTIONS(2261),
    [anon_sym_COLON_COLON2] = ACTIONS(2261),
    [anon_sym_AMP_DOT] = ACTIONS(2261),
    [sym_comment] = ACTIONS(87),
  },
  [809] = {
    [anon_sym_DOT] = ACTIONS(2345),
    [anon_sym_LBRACK] = ACTIONS(2345),
    [anon_sym_COLON_COLON2] = ACTIONS(2345),
    [anon_sym_AMP_DOT] = ACTIONS(2345),
    [sym_comment] = ACTIONS(87),
  },
  [810] = {
    [anon_sym_RBRACK] = ACTIONS(3983),
    [sym_comment] = ACTIONS(87),
  },
  [811] = {
    [sym__statements] = STATE(2310),
    [sym_begin_block] = STATE(489),
    [sym_end_block] = STATE(489),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_block_parameters] = STATE(2311),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(495),
    [aux_sym__statements_repeat1] = STATE(495),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(3985),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2445),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [812] = {
    [sym__statements] = STATE(2313),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_block_parameters] = STATE(2314),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_heredoc_body] = STATE(2315),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [sym__terminator] = STATE(2315),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__line_break] = ACTIONS(3987),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(3987),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(3989),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [813] = {
    [sym_do_block] = STATE(2316),
    [sym_block] = STATE(2316),
    [anon_sym_LBRACE] = ACTIONS(1471),
    [anon_sym_do] = ACTIONS(3991),
    [sym_comment] = ACTIONS(87),
  },
  [814] = {
    [anon_sym_LBRACE] = ACTIONS(2485),
    [anon_sym_RPAREN] = ACTIONS(2485),
    [anon_sym_DOT] = ACTIONS(2485),
    [anon_sym_COMMA] = ACTIONS(2485),
    [anon_sym_PIPE] = ACTIONS(2485),
    [anon_sym_SEMI] = ACTIONS(2485),
    [anon_sym_do] = ACTIONS(2485),
    [anon_sym_LBRACK] = ACTIONS(2485),
    [anon_sym_COLON_COLON2] = ACTIONS(2485),
    [anon_sym_AMP_DOT] = ACTIONS(2485),
    [sym_comment] = ACTIONS(87),
  },
  [815] = {
    [sym_argument_list_with_parens] = STATE(2319),
    [sym__argument_list_with_parens] = STATE(2320),
    [sym_operator] = STATE(2319),
    [sym_heredoc_body] = STATE(2321),
    [aux_sym_call_repeat1] = STATE(2321),
    [sym__heredoc_body_start] = ACTIONS(2519),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3995),
    [anon_sym_STAR_STAR] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT] = ACTIONS(3995),
    [anon_sym_LPAREN2] = ACTIONS(3997),
    [anon_sym_DOT_DOT] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3993),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_EQ_EQ] = ACTIONS(3995),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3993),
    [anon_sym_LT_EQ_GT] = ACTIONS(3993),
    [anon_sym_EQ_TILDE] = ACTIONS(3993),
    [anon_sym_BANG_TILDE] = ACTIONS(3993),
    [anon_sym_LT_EQ] = ACTIONS(3995),
    [anon_sym_GT] = ACTIONS(3995),
    [anon_sym_GT_EQ] = ACTIONS(3993),
    [anon_sym_CARET] = ACTIONS(3993),
    [anon_sym_PLUS] = ACTIONS(3995),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3993),
    [anon_sym_BANG] = ACTIONS(3995),
    [anon_sym_TILDE] = ACTIONS(3993),
    [sym_constant] = ACTIONS(3999),
    [sym_identifier] = ACTIONS(3999),
    [anon_sym_DASH] = ACTIONS(3995),
    [anon_sym_PLUS_AT] = ACTIONS(3993),
    [anon_sym_DASH_AT] = ACTIONS(3993),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3995),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(3993),
    [anon_sym_BQUOTE] = ACTIONS(3993),
    [sym_comment] = ACTIONS(87),
  },
  [816] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(346),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(352),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(352),
    [sym__argument_list_with_trailing_comma] = STATE(2323),
    [sym__argument] = STATE(350),
    [sym_splat_argument] = STATE(350),
    [sym_hash_splat_argument] = STATE(350),
    [sym_block_argument] = STATE(350),
    [sym_assignment] = STATE(346),
    [sym_operator_assignment] = STATE(346),
    [sym_conditional] = STATE(346),
    [sym_range] = STATE(346),
    [sym_binary] = STATE(346),
    [sym_unary] = STATE(346),
    [sym_left_assignment_list] = STATE(351),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(352),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(352),
    [sym_false] = STATE(352),
    [sym_nil] = STATE(352),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(353),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(350),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(593),
    [sym__splat_star] = ACTIONS(595),
    [sym__unary_minus] = ACTIONS(597),
    [sym__identifier_hash_key] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(4001),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [817] = {
    [sym_constant] = ACTIONS(4003),
    [sym_identifier] = ACTIONS(4003),
    [sym_comment] = ACTIONS(87),
  },
  [818] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(2354),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2357),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(2357),
    [sym_assignment] = STATE(2354),
    [sym_operator_assignment] = STATE(2354),
    [sym_conditional] = STATE(2354),
    [sym_range] = STATE(2354),
    [sym_binary] = STATE(2354),
    [sym_unary] = STATE(2354),
    [sym_left_assignment_list] = STATE(2356),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2357),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2357),
    [sym_false] = STATE(2357),
    [sym_nil] = STATE(2357),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2358),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(4005),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(4009),
    [sym__subshell_start] = ACTIONS(4011),
    [sym__regex_start] = ACTIONS(4013),
    [sym__string_array_start] = ACTIONS(4015),
    [sym__symbol_array_start] = ACTIONS(4017),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4019),
    [anon_sym_LBRACE] = ACTIONS(4021),
    [anon_sym_def] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4025),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(4027),
    [anon_sym_module] = ACTIONS(4029),
    [anon_sym_return] = ACTIONS(4031),
    [anon_sym_yield] = ACTIONS(4033),
    [anon_sym_break] = ACTIONS(4035),
    [anon_sym_next] = ACTIONS(4037),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(4039),
    [anon_sym_unless] = ACTIONS(4041),
    [anon_sym_while] = ACTIONS(4043),
    [anon_sym_until] = ACTIONS(4045),
    [anon_sym_for] = ACTIONS(4047),
    [anon_sym_case] = ACTIONS(4049),
    [anon_sym_begin] = ACTIONS(4051),
    [anon_sym_PLUS] = ACTIONS(4053),
    [anon_sym_defined_QMARK] = ACTIONS(4055),
    [anon_sym_not] = ACTIONS(4057),
    [anon_sym_BANG] = ACTIONS(4059),
    [anon_sym_TILDE] = ACTIONS(4059),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4065),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(4067),
    [anon_sym_DASH_GT] = ACTIONS(4069),
  },
  [819] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(2359),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2357),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(2357),
    [sym_assignment] = STATE(2359),
    [sym_operator_assignment] = STATE(2359),
    [sym_conditional] = STATE(2359),
    [sym_range] = STATE(2359),
    [sym_binary] = STATE(2359),
    [sym_unary] = STATE(2359),
    [sym_left_assignment_list] = STATE(2356),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2357),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2357),
    [sym_false] = STATE(2357),
    [sym_nil] = STATE(2357),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2358),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(4005),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(4009),
    [sym__subshell_start] = ACTIONS(4011),
    [sym__regex_start] = ACTIONS(4013),
    [sym__string_array_start] = ACTIONS(4015),
    [sym__symbol_array_start] = ACTIONS(4017),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4019),
    [anon_sym_LBRACE] = ACTIONS(4021),
    [anon_sym_def] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4025),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(4027),
    [anon_sym_module] = ACTIONS(4029),
    [anon_sym_return] = ACTIONS(4031),
    [anon_sym_yield] = ACTIONS(4033),
    [anon_sym_break] = ACTIONS(4035),
    [anon_sym_next] = ACTIONS(4037),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(4039),
    [anon_sym_unless] = ACTIONS(4041),
    [anon_sym_while] = ACTIONS(4043),
    [anon_sym_until] = ACTIONS(4045),
    [anon_sym_for] = ACTIONS(4047),
    [anon_sym_case] = ACTIONS(4049),
    [anon_sym_begin] = ACTIONS(4051),
    [anon_sym_PLUS] = ACTIONS(4053),
    [anon_sym_defined_QMARK] = ACTIONS(4055),
    [anon_sym_not] = ACTIONS(4057),
    [anon_sym_BANG] = ACTIONS(4059),
    [anon_sym_TILDE] = ACTIONS(4059),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4065),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(4067),
    [anon_sym_DASH_GT] = ACTIONS(4069),
  },
  [820] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(2360),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(837),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(837),
    [sym_assignment] = STATE(2360),
    [sym_operator_assignment] = STATE(2360),
    [sym_conditional] = STATE(2360),
    [sym_range] = STATE(2360),
    [sym_binary] = STATE(2360),
    [sym_unary] = STATE(2360),
    [sym_left_assignment_list] = STATE(836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(837),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(837),
    [sym_false] = STATE(837),
    [sym_nil] = STATE(837),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2361),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1485),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1493),
    [anon_sym_yield] = ACTIONS(1495),
    [anon_sym_break] = ACTIONS(1497),
    [anon_sym_next] = ACTIONS(1499),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1507),
    [anon_sym_TILDE] = ACTIONS(1507),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [821] = {
    [anon_sym_COLON] = ACTIONS(4071),
    [sym_comment] = ACTIONS(87),
  },
  [822] = {
    [sym__statements] = STATE(2310),
    [sym_begin_block] = STATE(489),
    [sym_end_block] = STATE(489),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_block_parameters] = STATE(2311),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1516),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1519),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1519),
    [sym_hash_splat_argument] = STATE(116),
    [sym_assignment] = STATE(1516),
    [sym_operator_assignment] = STATE(1516),
    [sym_conditional] = STATE(1516),
    [sym_range] = STATE(1516),
    [sym_binary] = STATE(1516),
    [sym_unary] = STATE(1516),
    [sym_left_assignment_list] = STATE(1518),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1519),
    [sym__variable] = STATE(1517),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1519),
    [sym_false] = STATE(1519),
    [sym_nil] = STATE(1519),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1520),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(1294),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym__hash_items] = STATE(1295),
    [sym_pair] = STATE(122),
    [sym_lambda] = STATE(214),
    [sym_empty_statement] = STATE(495),
    [aux_sym__statements_repeat1] = STATE(495),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2629),
    [sym__identifier_hash_key] = ACTIONS(157),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(4073),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_PIPE] = ACTIONS(2445),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2633),
    [anon_sym_yield] = ACTIONS(2635),
    [anon_sym_break] = ACTIONS(2637),
    [anon_sym_next] = ACTIONS(2639),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2641),
    [anon_sym_defined_QMARK] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2647),
    [anon_sym_TILDE] = ACTIONS(2647),
    [sym_constant] = ACTIONS(2649),
    [sym_identifier] = ACTIONS(2649),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [823] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(2364),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2357),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(2357),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_left_assignment_list] = STATE(2356),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2357),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2357),
    [sym_false] = STATE(2357),
    [sym_nil] = STATE(2357),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2358),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(4005),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(4009),
    [sym__subshell_start] = ACTIONS(4011),
    [sym__regex_start] = ACTIONS(4013),
    [sym__string_array_start] = ACTIONS(4015),
    [sym__symbol_array_start] = ACTIONS(4017),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4019),
    [anon_sym_LBRACE] = ACTIONS(4021),
    [anon_sym_def] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4025),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(4027),
    [anon_sym_module] = ACTIONS(4029),
    [anon_sym_return] = ACTIONS(4031),
    [anon_sym_yield] = ACTIONS(4033),
    [anon_sym_break] = ACTIONS(4035),
    [anon_sym_next] = ACTIONS(4037),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(4039),
    [anon_sym_unless] = ACTIONS(4041),
    [anon_sym_while] = ACTIONS(4043),
    [anon_sym_until] = ACTIONS(4045),
    [anon_sym_for] = ACTIONS(4047),
    [anon_sym_case] = ACTIONS(4049),
    [anon_sym_begin] = ACTIONS(4051),
    [anon_sym_PLUS] = ACTIONS(4053),
    [anon_sym_defined_QMARK] = ACTIONS(4055),
    [anon_sym_not] = ACTIONS(4057),
    [anon_sym_BANG] = ACTIONS(4059),
    [anon_sym_TILDE] = ACTIONS(4059),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4065),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(4067),
    [anon_sym_DASH_GT] = ACTIONS(4069),
  },
  [824] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(2370),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(837),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(837),
    [sym_argument_list] = STATE(1318),
    [sym__argument_list_with_parens] = STATE(2371),
    [sym__argument] = STATE(2372),
    [sym_splat_argument] = STATE(2372),
    [sym_hash_splat_argument] = STATE(2372),
    [sym_block_argument] = STATE(2372),
    [sym_assignment] = STATE(2370),
    [sym_operator_assignment] = STATE(2370),
    [sym_conditional] = STATE(2370),
    [sym_range] = STATE(2370),
    [sym_binary] = STATE(2370),
    [sym_unary] = STATE(2370),
    [sym_left_assignment_list] = STATE(836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(837),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(837),
    [sym_false] = STATE(837),
    [sym_nil] = STATE(837),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2373),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(2372),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(4075),
    [sym__splat_star] = ACTIONS(4077),
    [sym__unary_minus] = ACTIONS(1485),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(4079),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1493),
    [anon_sym_yield] = ACTIONS(1495),
    [anon_sym_break] = ACTIONS(1497),
    [anon_sym_next] = ACTIONS(1499),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(4081),
    [anon_sym_TILDE] = ACTIONS(1507),
    [sym_constant] = ACTIONS(4083),
    [sym_identifier] = ACTIONS(4083),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [825] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(2370),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(837),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(837),
    [sym_argument_list] = STATE(1324),
    [sym__argument_list_with_parens] = STATE(2371),
    [sym__argument] = STATE(2372),
    [sym_splat_argument] = STATE(2372),
    [sym_hash_splat_argument] = STATE(2372),
    [sym_block_argument] = STATE(2372),
    [sym_assignment] = STATE(2370),
    [sym_operator_assignment] = STATE(2370),
    [sym_conditional] = STATE(2370),
    [sym_range] = STATE(2370),
    [sym_binary] = STATE(2370),
    [sym_unary] = STATE(2370),
    [sym_left_assignment_list] = STATE(836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(837),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(837),
    [sym_false] = STATE(837),
    [sym_nil] = STATE(837),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2373),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(2372),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(4075),
    [sym__splat_star] = ACTIONS(4077),
    [sym__unary_minus] = ACTIONS(1485),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(4079),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_EQ] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1493),
    [anon_sym_yield] = ACTIONS(1495),
    [anon_sym_break] = ACTIONS(1497),
    [anon_sym_next] = ACTIONS(1499),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(4081),
    [anon_sym_TILDE] = ACTIONS(1507),
    [sym_constant] = ACTIONS(4083),
    [sym_identifier] = ACTIONS(4083),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [826] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(2370),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(837),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(837),
    [sym_argument_list] = STATE(1325),
    [sym__argument_list_with_parens] = STATE(2371),
    [sym__argument] = STATE(2372),
    [sym_splat_argument] = STATE(2372),
    [sym_hash_splat_argument] = STATE(2372),
    [sym_block_argument] = STATE(2372),
    [sym_assignment] = STATE(2370),
    [sym_operator_assignment] = STATE(2370),
    [sym_conditional] = STATE(2370),
    [sym_range] = STATE(2370),
    [sym_binary] = STATE(2370),
    [sym_unary] = STATE(2370),
    [sym_left_assignment_list] = STATE(836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(837),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(837),
    [sym_false] = STATE(837),
    [sym_nil] = STATE(837),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2373),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(2372),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(4075),
    [sym__splat_star] = ACTIONS(4077),
    [sym__unary_minus] = ACTIONS(1485),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(4079),
    [anon_sym_LBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_EQ] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1493),
    [anon_sym_yield] = ACTIONS(1495),
    [anon_sym_break] = ACTIONS(1497),
    [anon_sym_next] = ACTIONS(1499),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(4081),
    [anon_sym_TILDE] = ACTIONS(1507),
    [sym_constant] = ACTIONS(4083),
    [sym_identifier] = ACTIONS(4083),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [827] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(2370),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(837),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(837),
    [sym_argument_list] = STATE(1326),
    [sym__argument_list_with_parens] = STATE(2371),
    [sym__argument] = STATE(2372),
    [sym_splat_argument] = STATE(2372),
    [sym_hash_splat_argument] = STATE(2372),
    [sym_block_argument] = STATE(2372),
    [sym_assignment] = STATE(2370),
    [sym_operator_assignment] = STATE(2370),
    [sym_conditional] = STATE(2370),
    [sym_range] = STATE(2370),
    [sym_binary] = STATE(2370),
    [sym_unary] = STATE(2370),
    [sym_left_assignment_list] = STATE(836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(837),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(837),
    [sym_false] = STATE(837),
    [sym_nil] = STATE(837),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2373),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(2372),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(4075),
    [sym__splat_star] = ACTIONS(4077),
    [sym__unary_minus] = ACTIONS(1485),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(4079),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1493),
    [anon_sym_yield] = ACTIONS(1495),
    [anon_sym_break] = ACTIONS(1497),
    [anon_sym_next] = ACTIONS(1499),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(4081),
    [anon_sym_TILDE] = ACTIONS(1507),
    [sym_constant] = ACTIONS(4083),
    [sym_identifier] = ACTIONS(4083),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [828] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(2374),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(837),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(837),
    [sym_assignment] = STATE(2374),
    [sym_operator_assignment] = STATE(2374),
    [sym_conditional] = STATE(2374),
    [sym_range] = STATE(2374),
    [sym_binary] = STATE(2374),
    [sym_unary] = STATE(2374),
    [sym_left_assignment_list] = STATE(836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(837),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(837),
    [sym_false] = STATE(837),
    [sym_nil] = STATE(837),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2361),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1485),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1493),
    [anon_sym_yield] = ACTIONS(1495),
    [anon_sym_break] = ACTIONS(1497),
    [anon_sym_next] = ACTIONS(1499),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1507),
    [anon_sym_TILDE] = ACTIONS(1507),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [829] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(1872),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(837),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(837),
    [sym_assignment] = STATE(1872),
    [sym_operator_assignment] = STATE(1872),
    [sym_conditional] = STATE(1872),
    [sym_range] = STATE(1872),
    [sym_binary] = STATE(1872),
    [sym_unary] = STATE(1872),
    [sym_left_assignment_list] = STATE(836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(837),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(837),
    [sym_false] = STATE(837),
    [sym_nil] = STATE(837),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2361),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1485),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1493),
    [anon_sym_yield] = ACTIONS(1495),
    [anon_sym_break] = ACTIONS(1497),
    [anon_sym_next] = ACTIONS(1499),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1507),
    [anon_sym_TILDE] = ACTIONS(1507),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [830] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(4085),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [831] = {
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(4087),
    [sym__binary_star] = ACTIONS(4089),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(4091),
    [anon_sym_STAR_STAR] = ACTIONS(4089),
    [anon_sym_AMP] = ACTIONS(4093),
    [anon_sym_EQ] = ACTIONS(1631),
    [anon_sym_LT] = ACTIONS(4095),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(4071),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(4097),
    [anon_sym_DOT_DOT] = ACTIONS(4099),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4101),
    [anon_sym_and] = ACTIONS(4103),
    [anon_sym_or] = ACTIONS(4103),
    [anon_sym_PIPE_PIPE] = ACTIONS(4105),
    [anon_sym_AMP_AMP] = ACTIONS(4105),
    [anon_sym_LT_LT] = ACTIONS(4107),
    [anon_sym_GT_GT] = ACTIONS(4107),
    [anon_sym_EQ_EQ] = ACTIONS(4109),
    [anon_sym_BANG_EQ] = ACTIONS(4105),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4105),
    [anon_sym_LT_EQ_GT] = ACTIONS(4105),
    [anon_sym_EQ_TILDE] = ACTIONS(4105),
    [anon_sym_BANG_TILDE] = ACTIONS(4105),
    [anon_sym_LT_EQ] = ACTIONS(4095),
    [anon_sym_GT] = ACTIONS(4095),
    [anon_sym_GT_EQ] = ACTIONS(4111),
    [anon_sym_CARET] = ACTIONS(4113),
    [anon_sym_PLUS] = ACTIONS(4087),
    [anon_sym_SLASH] = ACTIONS(4089),
    [anon_sym_PERCENT] = ACTIONS(4089),
    [sym_comment] = ACTIONS(87),
  },
  [832] = {
    [sym_do_block] = STATE(2386),
    [sym_block] = STATE(2386),
    [anon_sym_LBRACE] = ACTIONS(1471),
    [anon_sym_RPAREN] = ACTIONS(2717),
    [anon_sym_DOT] = ACTIONS(2717),
    [anon_sym_COMMA] = ACTIONS(2717),
    [anon_sym_EQ] = ACTIONS(2717),
    [anon_sym_in] = ACTIONS(2717),
    [anon_sym_do] = ACTIONS(3991),
    [anon_sym_LBRACK] = ACTIONS(2717),
    [anon_sym_COLON_COLON2] = ACTIONS(2717),
    [anon_sym_AMP_DOT] = ACTIONS(2717),
    [sym_comment] = ACTIONS(87),
  },
  [833] = {
    [sym_heredoc_body] = STATE(2387),
    [aux_sym_call_repeat1] = STATE(2387),
    [sym__heredoc_body_start] = ACTIONS(3959),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1681),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_EQ] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [834] = {
    [sym_heredoc_body] = STATE(2387),
    [aux_sym_call_repeat1] = STATE(2387),
    [aux_sym_argument_list_repeat1] = STATE(2389),
    [sym__heredoc_body_start] = ACTIONS(3959),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1681),
    [anon_sym_COMMA] = ACTIONS(4115),
    [anon_sym_EQ] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [835] = {
    [anon_sym_RPAREN] = ACTIONS(2717),
    [anon_sym_DOT] = ACTIONS(2717),
    [anon_sym_COMMA] = ACTIONS(2717),
    [anon_sym_EQ] = ACTIONS(2717),
    [anon_sym_in] = ACTIONS(2717),
    [anon_sym_LBRACK] = ACTIONS(2717),
    [anon_sym_COLON_COLON2] = ACTIONS(2717),
    [anon_sym_AMP_DOT] = ACTIONS(2717),
    [sym_comment] = ACTIONS(87),
  },
  [836] = {
    [anon_sym_EQ] = ACTIONS(4117),
    [sym_comment] = ACTIONS(87),
  },
  [837] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(4119),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(4121),
    [anon_sym_DASH_EQ] = ACTIONS(4121),
    [anon_sym_STAR_EQ] = ACTIONS(4121),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4121),
    [anon_sym_SLASH_EQ] = ACTIONS(4121),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4121),
    [anon_sym_PIPE_EQ] = ACTIONS(4121),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4121),
    [anon_sym_AMP_EQ] = ACTIONS(4121),
    [anon_sym_PERCENT_EQ] = ACTIONS(4121),
    [anon_sym_GT_GT_EQ] = ACTIONS(4121),
    [anon_sym_LT_LT_EQ] = ACTIONS(4121),
    [anon_sym_CARET_EQ] = ACTIONS(4121),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [838] = {
    [sym_string] = STATE(2392),
    [aux_sym_chained_string_repeat1] = STATE(2392),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(4123),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [839] = {
    [sym_string] = STATE(2393),
    [aux_sym_chained_string_repeat1] = STATE(2393),
    [sym__string_start] = ACTIONS(281),
    [anon_sym_DOT] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [840] = {
    [sym_heredoc_body] = STATE(2394),
    [sym__terminator] = STATE(2394),
    [sym__line_break] = ACTIONS(4125),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym__binary_minus] = ACTIONS(2001),
    [sym__binary_star] = ACTIONS(2003),
    [anon_sym_PIPE] = ACTIONS(2005),
    [anon_sym_SEMI] = ACTIONS(4125),
    [anon_sym_STAR_STAR] = ACTIONS(2003),
    [anon_sym_AMP] = ACTIONS(2007),
    [anon_sym_LT] = ACTIONS(2009),
    [anon_sym_QMARK] = ACTIONS(2011),
    [anon_sym_DOT_DOT] = ACTIONS(2013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2015),
    [anon_sym_and] = ACTIONS(2017),
    [anon_sym_or] = ACTIONS(2017),
    [anon_sym_PIPE_PIPE] = ACTIONS(2019),
    [anon_sym_AMP_AMP] = ACTIONS(2019),
    [anon_sym_LT_LT] = ACTIONS(2021),
    [anon_sym_GT_GT] = ACTIONS(2021),
    [anon_sym_EQ_EQ] = ACTIONS(2023),
    [anon_sym_BANG_EQ] = ACTIONS(2019),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2019),
    [anon_sym_LT_EQ_GT] = ACTIONS(2019),
    [anon_sym_EQ_TILDE] = ACTIONS(2019),
    [anon_sym_BANG_TILDE] = ACTIONS(2019),
    [anon_sym_LT_EQ] = ACTIONS(2009),
    [anon_sym_GT] = ACTIONS(2009),
    [anon_sym_GT_EQ] = ACTIONS(2025),
    [anon_sym_CARET] = ACTIONS(2027),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_SLASH] = ACTIONS(2003),
    [anon_sym_PERCENT] = ACTIONS(2003),
    [sym_comment] = ACTIONS(87),
  },
  [841] = {
    [sym__line_break] = ACTIONS(1411),
    [sym__simple_symbol] = ACTIONS(1411),
    [sym__string_start] = ACTIONS(1411),
    [sym__symbol_start] = ACTIONS(1411),
    [sym__subshell_start] = ACTIONS(1411),
    [sym__regex_start] = ACTIONS(1411),
    [sym__string_array_start] = ACTIONS(1411),
    [sym__symbol_array_start] = ACTIONS(1411),
    [sym__heredoc_body_start] = ACTIONS(1411),
    [sym_heredoc_beginning] = ACTIONS(1411),
    [sym__block_ampersand] = ACTIONS(1411),
    [sym__splat_star] = ACTIONS(1411),
    [sym__unary_minus] = ACTIONS(1411),
    [sym__identifier_hash_key] = ACTIONS(1411),
    [anon_sym_LBRACE] = ACTIONS(1411),
    [anon_sym_def] = ACTIONS(1413),
    [anon_sym_LPAREN] = ACTIONS(1413),
    [anon_sym_DOT] = ACTIONS(1411),
    [anon_sym_COLON_COLON] = ACTIONS(1413),
    [anon_sym_SEMI] = ACTIONS(1411),
    [anon_sym_STAR] = ACTIONS(1413),
    [anon_sym_STAR_STAR] = ACTIONS(1411),
    [anon_sym_class] = ACTIONS(1413),
    [anon_sym_LT] = ACTIONS(1411),
    [anon_sym_module] = ACTIONS(1413),
    [anon_sym_end] = ACTIONS(1413),
    [anon_sym_return] = ACTIONS(1413),
    [anon_sym_yield] = ACTIONS(1413),
    [anon_sym_break] = ACTIONS(1413),
    [anon_sym_next] = ACTIONS(1413),
    [sym_redo] = ACTIONS(1413),
    [sym_retry] = ACTIONS(1413),
    [anon_sym_if] = ACTIONS(1413),
    [anon_sym_unless] = ACTIONS(1413),
    [anon_sym_while] = ACTIONS(1413),
    [anon_sym_until] = ACTIONS(1413),
    [anon_sym_for] = ACTIONS(1413),
    [anon_sym_do] = ACTIONS(1413),
    [anon_sym_case] = ACTIONS(1413),
    [anon_sym_then] = ACTIONS(1413),
    [anon_sym_begin] = ACTIONS(1413),
    [anon_sym_LBRACK] = ACTIONS(1411),
    [anon_sym_COLON_COLON2] = ACTIONS(1411),
    [anon_sym_AMP_DOT] = ACTIONS(1411),
    [anon_sym_LPAREN2] = ACTIONS(1411),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_defined_QMARK] = ACTIONS(1411),
    [anon_sym_not] = ACTIONS(1413),
    [anon_sym_BANG] = ACTIONS(1411),
    [anon_sym_TILDE] = ACTIONS(1411),
    [sym_constant] = ACTIONS(1413),
    [sym_identifier] = ACTIONS(1413),
    [sym_instance_variable] = ACTIONS(1411),
    [sym_class_variable] = ACTIONS(1411),
    [sym_global_variable] = ACTIONS(1411),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1413),
    [sym_float] = ACTIONS(1413),
    [sym_complex] = ACTIONS(1411),
    [sym_super] = ACTIONS(1413),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_TRUE] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_FALSE] = ACTIONS(1413),
    [sym_self] = ACTIONS(1413),
    [anon_sym_nil] = ACTIONS(1413),
    [anon_sym_NIL] = ACTIONS(1413),
    [sym_character] = ACTIONS(1411),
    [anon_sym_LBRACK2] = ACTIONS(1413),
    [anon_sym_DASH_GT] = ACTIONS(1411),
  },
  [842] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2395),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(2395),
    [sym_operator_assignment] = STATE(2395),
    [sym_conditional] = STATE(2395),
    [sym_range] = STATE(2395),
    [sym_binary] = STATE(2395),
    [sym_unary] = STATE(2395),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(485),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(495),
    [anon_sym_defined_QMARK] = ACTIONS(497),
    [anon_sym_not] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(501),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [843] = {
    [sym_heredoc_body] = STATE(2396),
    [sym__terminator] = STATE(2396),
    [sym__line_break] = ACTIONS(4127),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(4127),
    [sym_comment] = ACTIONS(87),
  },
  [844] = {
    [sym__statements] = STATE(284),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(286),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(287),
    [sym_rescue] = STATE(288),
    [sym__body_statement] = STATE(2397),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(4129),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [845] = {
    [sym_constant] = ACTIONS(4131),
    [sym_identifier] = ACTIONS(4131),
    [sym_comment] = ACTIONS(87),
  },
  [846] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(2406),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2408),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(2408),
    [sym_assignment] = STATE(2406),
    [sym_operator_assignment] = STATE(2406),
    [sym_conditional] = STATE(2406),
    [sym_range] = STATE(2406),
    [sym_binary] = STATE(2406),
    [sym_unary] = STATE(2406),
    [sym_left_assignment_list] = STATE(2407),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2408),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2408),
    [sym_false] = STATE(2408),
    [sym_nil] = STATE(2408),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2409),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4133),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4135),
    [anon_sym_yield] = ACTIONS(4137),
    [anon_sym_break] = ACTIONS(4139),
    [anon_sym_next] = ACTIONS(4141),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4143),
    [anon_sym_defined_QMARK] = ACTIONS(4145),
    [anon_sym_not] = ACTIONS(4147),
    [anon_sym_BANG] = ACTIONS(4149),
    [anon_sym_TILDE] = ACTIONS(4149),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [847] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(2410),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2408),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(2408),
    [sym_assignment] = STATE(2410),
    [sym_operator_assignment] = STATE(2410),
    [sym_conditional] = STATE(2410),
    [sym_range] = STATE(2410),
    [sym_binary] = STATE(2410),
    [sym_unary] = STATE(2410),
    [sym_left_assignment_list] = STATE(2407),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2408),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2408),
    [sym_false] = STATE(2408),
    [sym_nil] = STATE(2408),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2409),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4133),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4135),
    [anon_sym_yield] = ACTIONS(4137),
    [anon_sym_break] = ACTIONS(4139),
    [anon_sym_next] = ACTIONS(4141),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4143),
    [anon_sym_defined_QMARK] = ACTIONS(4145),
    [anon_sym_not] = ACTIONS(4147),
    [anon_sym_BANG] = ACTIONS(4149),
    [anon_sym_TILDE] = ACTIONS(4149),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [848] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(2411),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym_assignment] = STATE(2411),
    [sym_operator_assignment] = STATE(2411),
    [sym_conditional] = STATE(2411),
    [sym_range] = STATE(2411),
    [sym_binary] = STATE(2411),
    [sym_unary] = STATE(2411),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2412),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [849] = {
    [anon_sym_COLON] = ACTIONS(4151),
    [sym_comment] = ACTIONS(87),
  },
  [850] = {
    [sym__statements] = STATE(2310),
    [sym_begin_block] = STATE(489),
    [sym_end_block] = STATE(489),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_block_parameters] = STATE(2311),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1516),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1519),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1519),
    [sym_hash_splat_argument] = STATE(116),
    [sym_assignment] = STATE(1516),
    [sym_operator_assignment] = STATE(1516),
    [sym_conditional] = STATE(1516),
    [sym_range] = STATE(1516),
    [sym_binary] = STATE(1516),
    [sym_unary] = STATE(1516),
    [sym_left_assignment_list] = STATE(1518),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1519),
    [sym__variable] = STATE(1517),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1519),
    [sym_false] = STATE(1519),
    [sym_nil] = STATE(1519),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1520),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(1294),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym__hash_items] = STATE(1295),
    [sym_pair] = STATE(122),
    [sym_lambda] = STATE(214),
    [sym_empty_statement] = STATE(495),
    [aux_sym__statements_repeat1] = STATE(495),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2629),
    [sym__identifier_hash_key] = ACTIONS(157),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(4153),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_PIPE] = ACTIONS(2445),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2633),
    [anon_sym_yield] = ACTIONS(2635),
    [anon_sym_break] = ACTIONS(2637),
    [anon_sym_next] = ACTIONS(2639),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2641),
    [anon_sym_defined_QMARK] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2647),
    [anon_sym_TILDE] = ACTIONS(2647),
    [sym_constant] = ACTIONS(2649),
    [sym_identifier] = ACTIONS(2649),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [851] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(2415),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2408),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(2408),
    [sym_assignment] = STATE(2415),
    [sym_operator_assignment] = STATE(2415),
    [sym_conditional] = STATE(2415),
    [sym_range] = STATE(2415),
    [sym_binary] = STATE(2415),
    [sym_unary] = STATE(2415),
    [sym_left_assignment_list] = STATE(2407),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2408),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2408),
    [sym_false] = STATE(2408),
    [sym_nil] = STATE(2408),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2409),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4133),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4135),
    [anon_sym_yield] = ACTIONS(4137),
    [anon_sym_break] = ACTIONS(4139),
    [anon_sym_next] = ACTIONS(4141),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4143),
    [anon_sym_defined_QMARK] = ACTIONS(4145),
    [anon_sym_not] = ACTIONS(4147),
    [anon_sym_BANG] = ACTIONS(4149),
    [anon_sym_TILDE] = ACTIONS(4149),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [852] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(2421),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym_argument_list] = STATE(1318),
    [sym__argument_list_with_parens] = STATE(2422),
    [sym__argument] = STATE(2423),
    [sym_splat_argument] = STATE(2423),
    [sym_hash_splat_argument] = STATE(2423),
    [sym_block_argument] = STATE(2423),
    [sym_assignment] = STATE(2421),
    [sym_operator_assignment] = STATE(2421),
    [sym_conditional] = STATE(2421),
    [sym_range] = STATE(2421),
    [sym_binary] = STATE(2421),
    [sym_unary] = STATE(2421),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2424),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(2423),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(4155),
    [sym__splat_star] = ACTIONS(4157),
    [sym__unary_minus] = ACTIONS(1525),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(4159),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(4161),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(4163),
    [sym_identifier] = ACTIONS(4163),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [853] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(2421),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym_argument_list] = STATE(1324),
    [sym__argument_list_with_parens] = STATE(2422),
    [sym__argument] = STATE(2423),
    [sym_splat_argument] = STATE(2423),
    [sym_hash_splat_argument] = STATE(2423),
    [sym_block_argument] = STATE(2423),
    [sym_assignment] = STATE(2421),
    [sym_operator_assignment] = STATE(2421),
    [sym_conditional] = STATE(2421),
    [sym_range] = STATE(2421),
    [sym_binary] = STATE(2421),
    [sym_unary] = STATE(2421),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2424),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(2423),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(4155),
    [sym__splat_star] = ACTIONS(4157),
    [sym__unary_minus] = ACTIONS(1525),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(4159),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(4161),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(4163),
    [sym_identifier] = ACTIONS(4163),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [854] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(2421),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym_argument_list] = STATE(1325),
    [sym__argument_list_with_parens] = STATE(2422),
    [sym__argument] = STATE(2423),
    [sym_splat_argument] = STATE(2423),
    [sym_hash_splat_argument] = STATE(2423),
    [sym_block_argument] = STATE(2423),
    [sym_assignment] = STATE(2421),
    [sym_operator_assignment] = STATE(2421),
    [sym_conditional] = STATE(2421),
    [sym_range] = STATE(2421),
    [sym_binary] = STATE(2421),
    [sym_unary] = STATE(2421),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2424),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(2423),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(4155),
    [sym__splat_star] = ACTIONS(4157),
    [sym__unary_minus] = ACTIONS(1525),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(4159),
    [anon_sym_LBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(4161),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(4163),
    [sym_identifier] = ACTIONS(4163),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [855] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(2421),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym_argument_list] = STATE(1326),
    [sym__argument_list_with_parens] = STATE(2422),
    [sym__argument] = STATE(2423),
    [sym_splat_argument] = STATE(2423),
    [sym_hash_splat_argument] = STATE(2423),
    [sym_block_argument] = STATE(2423),
    [sym_assignment] = STATE(2421),
    [sym_operator_assignment] = STATE(2421),
    [sym_conditional] = STATE(2421),
    [sym_range] = STATE(2421),
    [sym_binary] = STATE(2421),
    [sym_unary] = STATE(2421),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2424),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(2423),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(4155),
    [sym__splat_star] = ACTIONS(4157),
    [sym__unary_minus] = ACTIONS(1525),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(4159),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(4161),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(4163),
    [sym_identifier] = ACTIONS(4163),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [856] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(2425),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym_assignment] = STATE(2425),
    [sym_operator_assignment] = STATE(2425),
    [sym_conditional] = STATE(2425),
    [sym_range] = STATE(2425),
    [sym_binary] = STATE(2425),
    [sym_unary] = STATE(2425),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2412),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [857] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(1872),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym_assignment] = STATE(1872),
    [sym_operator_assignment] = STATE(1872),
    [sym_conditional] = STATE(1872),
    [sym_range] = STATE(1872),
    [sym_binary] = STATE(1872),
    [sym_unary] = STATE(1872),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2412),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [858] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(4165),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [859] = {
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(4167),
    [sym__binary_star] = ACTIONS(4169),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(4171),
    [anon_sym_STAR_STAR] = ACTIONS(4169),
    [anon_sym_AMP] = ACTIONS(4173),
    [anon_sym_LT] = ACTIONS(4175),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(4151),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_DOT_DOT] = ACTIONS(4179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4181),
    [anon_sym_and] = ACTIONS(4183),
    [anon_sym_or] = ACTIONS(4183),
    [anon_sym_PIPE_PIPE] = ACTIONS(4185),
    [anon_sym_AMP_AMP] = ACTIONS(4185),
    [anon_sym_LT_LT] = ACTIONS(4187),
    [anon_sym_GT_GT] = ACTIONS(4187),
    [anon_sym_EQ_EQ] = ACTIONS(4189),
    [anon_sym_BANG_EQ] = ACTIONS(4185),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4185),
    [anon_sym_LT_EQ_GT] = ACTIONS(4185),
    [anon_sym_EQ_TILDE] = ACTIONS(4185),
    [anon_sym_BANG_TILDE] = ACTIONS(4185),
    [anon_sym_LT_EQ] = ACTIONS(4175),
    [anon_sym_GT] = ACTIONS(4175),
    [anon_sym_GT_EQ] = ACTIONS(4191),
    [anon_sym_CARET] = ACTIONS(4193),
    [anon_sym_PLUS] = ACTIONS(4167),
    [anon_sym_SLASH] = ACTIONS(4169),
    [anon_sym_PERCENT] = ACTIONS(4169),
    [sym_comment] = ACTIONS(87),
  },
  [860] = {
    [sym_heredoc_body] = STATE(2437),
    [aux_sym_call_repeat1] = STATE(2437),
    [sym__heredoc_body_start] = ACTIONS(3959),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [861] = {
    [sym_heredoc_body] = STATE(2437),
    [aux_sym_call_repeat1] = STATE(2437),
    [aux_sym_argument_list_repeat1] = STATE(2439),
    [sym__heredoc_body_start] = ACTIONS(3959),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1681),
    [anon_sym_COMMA] = ACTIONS(4195),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [862] = {
    [anon_sym_EQ] = ACTIONS(4197),
    [sym_comment] = ACTIONS(87),
  },
  [863] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(4199),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(4201),
    [anon_sym_DASH_EQ] = ACTIONS(4201),
    [anon_sym_STAR_EQ] = ACTIONS(4201),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4201),
    [anon_sym_SLASH_EQ] = ACTIONS(4201),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4201),
    [anon_sym_PIPE_EQ] = ACTIONS(4201),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4201),
    [anon_sym_AMP_EQ] = ACTIONS(4201),
    [anon_sym_PERCENT_EQ] = ACTIONS(4201),
    [anon_sym_GT_GT_EQ] = ACTIONS(4201),
    [anon_sym_LT_LT_EQ] = ACTIONS(4201),
    [anon_sym_CARET_EQ] = ACTIONS(4201),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [864] = {
    [sym_string] = STATE(2442),
    [aux_sym_chained_string_repeat1] = STATE(2442),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(4203),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [865] = {
    [sym__line_break] = ACTIONS(4205),
    [sym__heredoc_body_start] = ACTIONS(4205),
    [sym__binary_minus] = ACTIONS(4205),
    [sym__binary_star] = ACTIONS(4205),
    [ts_builtin_sym_end] = ACTIONS(4205),
    [anon_sym___END__] = ACTIONS(4205),
    [anon_sym_LBRACE] = ACTIONS(4205),
    [anon_sym_RBRACE] = ACTIONS(4205),
    [anon_sym_RPAREN] = ACTIONS(4205),
    [anon_sym_DOT] = ACTIONS(4207),
    [anon_sym_COMMA] = ACTIONS(4205),
    [anon_sym_PIPE] = ACTIONS(4207),
    [anon_sym_SEMI] = ACTIONS(4205),
    [anon_sym_STAR_STAR] = ACTIONS(4205),
    [anon_sym_AMP] = ACTIONS(4207),
    [anon_sym_LT] = ACTIONS(4207),
    [anon_sym_end] = ACTIONS(4205),
    [anon_sym_if] = ACTIONS(4205),
    [anon_sym_unless] = ACTIONS(4205),
    [anon_sym_while] = ACTIONS(4205),
    [anon_sym_until] = ACTIONS(4205),
    [anon_sym_rescue] = ACTIONS(4205),
    [anon_sym_do] = ACTIONS(4205),
    [anon_sym_when] = ACTIONS(4205),
    [anon_sym_elsif] = ACTIONS(4205),
    [anon_sym_else] = ACTIONS(4205),
    [anon_sym_then] = ACTIONS(4205),
    [anon_sym_ensure] = ACTIONS(4205),
    [anon_sym_EQ_GT] = ACTIONS(4205),
    [anon_sym_LBRACK] = ACTIONS(4205),
    [anon_sym_COLON_COLON2] = ACTIONS(4205),
    [anon_sym_AMP_DOT] = ACTIONS(4205),
    [anon_sym_QMARK] = ACTIONS(4205),
    [anon_sym_DOT_DOT] = ACTIONS(4207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4205),
    [anon_sym_and] = ACTIONS(4205),
    [anon_sym_or] = ACTIONS(4205),
    [anon_sym_PIPE_PIPE] = ACTIONS(4205),
    [anon_sym_AMP_AMP] = ACTIONS(4205),
    [anon_sym_LT_LT] = ACTIONS(4205),
    [anon_sym_GT_GT] = ACTIONS(4205),
    [anon_sym_EQ_EQ] = ACTIONS(4207),
    [anon_sym_BANG_EQ] = ACTIONS(4205),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4205),
    [anon_sym_LT_EQ_GT] = ACTIONS(4205),
    [anon_sym_EQ_TILDE] = ACTIONS(4205),
    [anon_sym_BANG_TILDE] = ACTIONS(4205),
    [anon_sym_LT_EQ] = ACTIONS(4207),
    [anon_sym_GT] = ACTIONS(4207),
    [anon_sym_GT_EQ] = ACTIONS(4205),
    [anon_sym_CARET] = ACTIONS(4205),
    [anon_sym_PLUS] = ACTIONS(4205),
    [anon_sym_SLASH] = ACTIONS(4205),
    [anon_sym_PERCENT] = ACTIONS(4205),
    [sym_comment] = ACTIONS(87),
  },
  [866] = {
    [sym__statements] = STATE(284),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(286),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(287),
    [sym_rescue] = STATE(288),
    [sym__body_statement] = STATE(2443),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(4209),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [867] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2444),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(876),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(876),
    [sym_assignment] = STATE(2444),
    [sym_operator_assignment] = STATE(2444),
    [sym_conditional] = STATE(2444),
    [sym_range] = STATE(2444),
    [sym_binary] = STATE(2444),
    [sym_unary] = STATE(2444),
    [sym_left_assignment_list] = STATE(875),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(876),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(876),
    [sym_false] = STATE(876),
    [sym_nil] = STATE(876),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(877),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(1555),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1557),
    [anon_sym_yield] = ACTIONS(1559),
    [anon_sym_break] = ACTIONS(1561),
    [anon_sym_next] = ACTIONS(1563),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_defined_QMARK] = ACTIONS(1567),
    [anon_sym_not] = ACTIONS(1569),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_TILDE] = ACTIONS(1571),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [868] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(213),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(2445),
    [sym__argument] = STATE(2446),
    [sym_splat_argument] = STATE(2446),
    [sym_hash_splat_argument] = STATE(2446),
    [sym_block_argument] = STATE(2446),
    [sym_assignment] = STATE(213),
    [sym_operator_assignment] = STATE(213),
    [sym_conditional] = STATE(213),
    [sym_range] = STATE(213),
    [sym_binary] = STATE(213),
    [sym_unary] = STATE(213),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(221),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2446),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(369),
    [sym__splat_star] = ACTIONS(371),
    [sym__unary_minus] = ACTIONS(373),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(375),
    [ts_builtin_sym_end] = ACTIONS(365),
    [anon_sym___END__] = ACTIONS(377),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(383),
    [anon_sym_yield] = ACTIONS(385),
    [anon_sym_break] = ACTIONS(387),
    [anon_sym_next] = ACTIONS(389),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(395),
    [anon_sym_not] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [sym_constant] = ACTIONS(403),
    [sym_identifier] = ACTIONS(403),
    [sym_instance_variable] = ACTIONS(405),
    [sym_class_variable] = ACTIONS(405),
    [sym_global_variable] = ACTIONS(405),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(407),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(407),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [869] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(213),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(2445),
    [sym__argument] = STATE(2446),
    [sym_splat_argument] = STATE(2446),
    [sym_hash_splat_argument] = STATE(2446),
    [sym_block_argument] = STATE(2446),
    [sym_assignment] = STATE(213),
    [sym_operator_assignment] = STATE(213),
    [sym_conditional] = STATE(213),
    [sym_range] = STATE(213),
    [sym_binary] = STATE(213),
    [sym_unary] = STATE(213),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(221),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2446),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(369),
    [sym__splat_star] = ACTIONS(371),
    [sym__unary_minus] = ACTIONS(373),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(375),
    [ts_builtin_sym_end] = ACTIONS(417),
    [anon_sym___END__] = ACTIONS(419),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(383),
    [anon_sym_yield] = ACTIONS(385),
    [anon_sym_break] = ACTIONS(387),
    [anon_sym_next] = ACTIONS(389),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(395),
    [anon_sym_not] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [sym_constant] = ACTIONS(403),
    [sym_identifier] = ACTIONS(403),
    [sym_instance_variable] = ACTIONS(405),
    [sym_class_variable] = ACTIONS(405),
    [sym_global_variable] = ACTIONS(405),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(407),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(407),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [870] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(213),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(2445),
    [sym__argument] = STATE(2446),
    [sym_splat_argument] = STATE(2446),
    [sym_hash_splat_argument] = STATE(2446),
    [sym_block_argument] = STATE(2446),
    [sym_assignment] = STATE(213),
    [sym_operator_assignment] = STATE(213),
    [sym_conditional] = STATE(213),
    [sym_range] = STATE(213),
    [sym_binary] = STATE(213),
    [sym_unary] = STATE(213),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(221),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2446),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(369),
    [sym__splat_star] = ACTIONS(371),
    [sym__unary_minus] = ACTIONS(373),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(375),
    [ts_builtin_sym_end] = ACTIONS(421),
    [anon_sym___END__] = ACTIONS(423),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(383),
    [anon_sym_yield] = ACTIONS(385),
    [anon_sym_break] = ACTIONS(387),
    [anon_sym_next] = ACTIONS(389),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(395),
    [anon_sym_not] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [sym_constant] = ACTIONS(403),
    [sym_identifier] = ACTIONS(403),
    [sym_instance_variable] = ACTIONS(405),
    [sym_class_variable] = ACTIONS(405),
    [sym_global_variable] = ACTIONS(405),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(407),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(407),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [871] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(213),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(2445),
    [sym__argument] = STATE(2446),
    [sym_splat_argument] = STATE(2446),
    [sym_hash_splat_argument] = STATE(2446),
    [sym_block_argument] = STATE(2446),
    [sym_assignment] = STATE(213),
    [sym_operator_assignment] = STATE(213),
    [sym_conditional] = STATE(213),
    [sym_range] = STATE(213),
    [sym_binary] = STATE(213),
    [sym_unary] = STATE(213),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(221),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2446),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(369),
    [sym__splat_star] = ACTIONS(371),
    [sym__unary_minus] = ACTIONS(373),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(375),
    [ts_builtin_sym_end] = ACTIONS(425),
    [anon_sym___END__] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(383),
    [anon_sym_yield] = ACTIONS(385),
    [anon_sym_break] = ACTIONS(387),
    [anon_sym_next] = ACTIONS(389),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(395),
    [anon_sym_not] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [sym_constant] = ACTIONS(403),
    [sym_identifier] = ACTIONS(403),
    [sym_instance_variable] = ACTIONS(405),
    [sym_class_variable] = ACTIONS(405),
    [sym_global_variable] = ACTIONS(405),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(407),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(407),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [872] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2447),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(876),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(876),
    [sym_assignment] = STATE(2447),
    [sym_operator_assignment] = STATE(2447),
    [sym_conditional] = STATE(2447),
    [sym_range] = STATE(2447),
    [sym_binary] = STATE(2447),
    [sym_unary] = STATE(2447),
    [sym_left_assignment_list] = STATE(875),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(876),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(876),
    [sym_false] = STATE(876),
    [sym_nil] = STATE(876),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(877),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(1555),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1557),
    [anon_sym_yield] = ACTIONS(1559),
    [anon_sym_break] = ACTIONS(1561),
    [anon_sym_next] = ACTIONS(1563),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_defined_QMARK] = ACTIONS(1567),
    [anon_sym_not] = ACTIONS(1569),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_TILDE] = ACTIONS(1571),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [873] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(876),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(876),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(875),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(876),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(876),
    [sym_false] = STATE(876),
    [sym_nil] = STATE(876),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(877),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(1555),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1557),
    [anon_sym_yield] = ACTIONS(1559),
    [anon_sym_break] = ACTIONS(1561),
    [anon_sym_next] = ACTIONS(1563),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_defined_QMARK] = ACTIONS(1567),
    [anon_sym_not] = ACTIONS(1569),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_TILDE] = ACTIONS(1571),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [874] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(4213),
    [sym__binary_star] = ACTIONS(4215),
    [ts_builtin_sym_end] = ACTIONS(4211),
    [anon_sym___END__] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(4219),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(4215),
    [anon_sym_AMP] = ACTIONS(4221),
    [anon_sym_LT] = ACTIONS(4223),
    [anon_sym_if] = ACTIONS(4211),
    [anon_sym_unless] = ACTIONS(4211),
    [anon_sym_while] = ACTIONS(4211),
    [anon_sym_until] = ACTIONS(4211),
    [anon_sym_rescue] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(4225),
    [anon_sym_DOT_DOT] = ACTIONS(4227),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4229),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(4231),
    [anon_sym_AMP_AMP] = ACTIONS(4231),
    [anon_sym_LT_LT] = ACTIONS(4233),
    [anon_sym_GT_GT] = ACTIONS(4233),
    [anon_sym_EQ_EQ] = ACTIONS(4235),
    [anon_sym_BANG_EQ] = ACTIONS(4231),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4231),
    [anon_sym_LT_EQ_GT] = ACTIONS(4231),
    [anon_sym_EQ_TILDE] = ACTIONS(4231),
    [anon_sym_BANG_TILDE] = ACTIONS(4231),
    [anon_sym_LT_EQ] = ACTIONS(4223),
    [anon_sym_GT] = ACTIONS(4223),
    [anon_sym_GT_EQ] = ACTIONS(4237),
    [anon_sym_CARET] = ACTIONS(4239),
    [anon_sym_PLUS] = ACTIONS(4213),
    [anon_sym_SLASH] = ACTIONS(4215),
    [anon_sym_PERCENT] = ACTIONS(4215),
    [sym_comment] = ACTIONS(87),
  },
  [875] = {
    [anon_sym_EQ] = ACTIONS(4241),
    [sym_comment] = ACTIONS(87),
  },
  [876] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(559),
    [anon_sym___END__] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(4243),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(4245),
    [anon_sym_DASH_EQ] = ACTIONS(4245),
    [anon_sym_STAR_EQ] = ACTIONS(4245),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4245),
    [anon_sym_SLASH_EQ] = ACTIONS(4245),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4245),
    [anon_sym_PIPE_EQ] = ACTIONS(4245),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4245),
    [anon_sym_AMP_EQ] = ACTIONS(4245),
    [anon_sym_PERCENT_EQ] = ACTIONS(4245),
    [anon_sym_GT_GT_EQ] = ACTIONS(4245),
    [anon_sym_LT_LT_EQ] = ACTIONS(4245),
    [anon_sym_CARET_EQ] = ACTIONS(4245),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [877] = {
    [sym_string] = STATE(2460),
    [aux_sym_chained_string_repeat1] = STATE(2460),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(559),
    [anon_sym___END__] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [878] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(4213),
    [sym__binary_star] = ACTIONS(4215),
    [ts_builtin_sym_end] = ACTIONS(4247),
    [anon_sym___END__] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(4219),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(4215),
    [anon_sym_AMP] = ACTIONS(4221),
    [anon_sym_LT] = ACTIONS(4223),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(4225),
    [anon_sym_DOT_DOT] = ACTIONS(4227),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4229),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(4231),
    [anon_sym_AMP_AMP] = ACTIONS(4231),
    [anon_sym_LT_LT] = ACTIONS(4233),
    [anon_sym_GT_GT] = ACTIONS(4233),
    [anon_sym_EQ_EQ] = ACTIONS(4235),
    [anon_sym_BANG_EQ] = ACTIONS(4231),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4231),
    [anon_sym_LT_EQ_GT] = ACTIONS(4231),
    [anon_sym_EQ_TILDE] = ACTIONS(4231),
    [anon_sym_BANG_TILDE] = ACTIONS(4231),
    [anon_sym_LT_EQ] = ACTIONS(4223),
    [anon_sym_GT] = ACTIONS(4223),
    [anon_sym_GT_EQ] = ACTIONS(4237),
    [anon_sym_CARET] = ACTIONS(4239),
    [anon_sym_PLUS] = ACTIONS(4213),
    [anon_sym_SLASH] = ACTIONS(4215),
    [anon_sym_PERCENT] = ACTIONS(4215),
    [sym_comment] = ACTIONS(87),
  },
  [879] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [ts_builtin_sym_end] = ACTIONS(935),
    [anon_sym___END__] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(1629),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [880] = {
    [sym_string] = STATE(949),
    [aux_sym_chained_string_repeat1] = STATE(949),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(559),
    [anon_sym___END__] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [881] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2461),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(876),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(876),
    [sym_assignment] = STATE(2461),
    [sym_operator_assignment] = STATE(2461),
    [sym_conditional] = STATE(2461),
    [sym_range] = STATE(2461),
    [sym_binary] = STATE(2461),
    [sym_unary] = STATE(2461),
    [sym_left_assignment_list] = STATE(875),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(876),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(876),
    [sym_false] = STATE(876),
    [sym_nil] = STATE(876),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(877),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(1555),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1557),
    [anon_sym_yield] = ACTIONS(1559),
    [anon_sym_break] = ACTIONS(1561),
    [anon_sym_next] = ACTIONS(1563),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_defined_QMARK] = ACTIONS(1567),
    [anon_sym_not] = ACTIONS(1569),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_TILDE] = ACTIONS(1571),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [882] = {
    [sym__line_break] = ACTIONS(1411),
    [sym__simple_symbol] = ACTIONS(1411),
    [sym__string_start] = ACTIONS(1411),
    [sym__symbol_start] = ACTIONS(1411),
    [sym__subshell_start] = ACTIONS(1411),
    [sym__regex_start] = ACTIONS(1411),
    [sym__string_array_start] = ACTIONS(1411),
    [sym__symbol_array_start] = ACTIONS(1411),
    [sym__heredoc_body_start] = ACTIONS(1411),
    [sym_heredoc_beginning] = ACTIONS(1411),
    [sym__block_ampersand] = ACTIONS(1411),
    [sym__splat_star] = ACTIONS(1411),
    [sym__unary_minus] = ACTIONS(1411),
    [sym__binary_minus] = ACTIONS(1411),
    [sym__binary_star] = ACTIONS(1411),
    [sym__identifier_hash_key] = ACTIONS(1411),
    [ts_builtin_sym_end] = ACTIONS(1411),
    [anon_sym___END__] = ACTIONS(1413),
    [anon_sym_LBRACE] = ACTIONS(1411),
    [anon_sym_RBRACE] = ACTIONS(1411),
    [anon_sym_def] = ACTIONS(1413),
    [anon_sym_LPAREN] = ACTIONS(1413),
    [anon_sym_RPAREN] = ACTIONS(1411),
    [anon_sym_DOT] = ACTIONS(1413),
    [anon_sym_COLON_COLON] = ACTIONS(1413),
    [anon_sym_COMMA] = ACTIONS(1411),
    [anon_sym_PIPE] = ACTIONS(1413),
    [anon_sym_SEMI] = ACTIONS(1411),
    [anon_sym_STAR] = ACTIONS(1413),
    [anon_sym_STAR_STAR] = ACTIONS(1413),
    [anon_sym_AMP] = ACTIONS(1413),
    [anon_sym_EQ] = ACTIONS(1413),
    [anon_sym_class] = ACTIONS(1413),
    [anon_sym_LT] = ACTIONS(1413),
    [anon_sym_module] = ACTIONS(1413),
    [anon_sym_end] = ACTIONS(1413),
    [anon_sym_return] = ACTIONS(1413),
    [anon_sym_yield] = ACTIONS(1413),
    [anon_sym_break] = ACTIONS(1413),
    [anon_sym_next] = ACTIONS(1413),
    [sym_redo] = ACTIONS(1413),
    [sym_retry] = ACTIONS(1413),
    [anon_sym_if] = ACTIONS(1413),
    [anon_sym_unless] = ACTIONS(1413),
    [anon_sym_while] = ACTIONS(1413),
    [anon_sym_until] = ACTIONS(1413),
    [anon_sym_rescue] = ACTIONS(1413),
    [anon_sym_for] = ACTIONS(1413),
    [anon_sym_do] = ACTIONS(1413),
    [anon_sym_case] = ACTIONS(1413),
    [anon_sym_when] = ACTIONS(1413),
    [anon_sym_elsif] = ACTIONS(1413),
    [anon_sym_else] = ACTIONS(1413),
    [anon_sym_then] = ACTIONS(1413),
    [anon_sym_begin] = ACTIONS(1413),
    [anon_sym_ensure] = ACTIONS(1413),
    [anon_sym_EQ_GT] = ACTIONS(1411),
    [anon_sym_LBRACK] = ACTIONS(1411),
    [anon_sym_COLON_COLON2] = ACTIONS(1411),
    [anon_sym_AMP_DOT] = ACTIONS(1411),
    [anon_sym_LPAREN2] = ACTIONS(1411),
    [anon_sym_PLUS_EQ] = ACTIONS(1411),
    [anon_sym_DASH_EQ] = ACTIONS(1411),
    [anon_sym_STAR_EQ] = ACTIONS(1411),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1411),
    [anon_sym_SLASH_EQ] = ACTIONS(1411),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1411),
    [anon_sym_PIPE_EQ] = ACTIONS(1411),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1411),
    [anon_sym_AMP_EQ] = ACTIONS(1411),
    [anon_sym_PERCENT_EQ] = ACTIONS(1411),
    [anon_sym_GT_GT_EQ] = ACTIONS(1411),
    [anon_sym_LT_LT_EQ] = ACTIONS(1411),
    [anon_sym_CARET_EQ] = ACTIONS(1411),
    [anon_sym_QMARK] = ACTIONS(1413),
    [anon_sym_DOT_DOT] = ACTIONS(1413),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1411),
    [anon_sym_and] = ACTIONS(1413),
    [anon_sym_or] = ACTIONS(1413),
    [anon_sym_PIPE_PIPE] = ACTIONS(1413),
    [anon_sym_AMP_AMP] = ACTIONS(1413),
    [anon_sym_LT_LT] = ACTIONS(1413),
    [anon_sym_GT_GT] = ACTIONS(1413),
    [anon_sym_EQ_EQ] = ACTIONS(1413),
    [anon_sym_BANG_EQ] = ACTIONS(1411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1411),
    [anon_sym_LT_EQ_GT] = ACTIONS(1411),
    [anon_sym_EQ_TILDE] = ACTIONS(1411),
    [anon_sym_BANG_TILDE] = ACTIONS(1411),
    [anon_sym_LT_EQ] = ACTIONS(1413),
    [anon_sym_GT] = ACTIONS(1413),
    [anon_sym_GT_EQ] = ACTIONS(1411),
    [anon_sym_CARET] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_SLASH] = ACTIONS(1413),
    [anon_sym_PERCENT] = ACTIONS(1413),
    [anon_sym_defined_QMARK] = ACTIONS(1411),
    [anon_sym_not] = ACTIONS(1413),
    [anon_sym_BANG] = ACTIONS(1413),
    [anon_sym_TILDE] = ACTIONS(1411),
    [sym_constant] = ACTIONS(1413),
    [sym_identifier] = ACTIONS(1413),
    [sym_instance_variable] = ACTIONS(1411),
    [sym_class_variable] = ACTIONS(1411),
    [sym_global_variable] = ACTIONS(1411),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1413),
    [sym_float] = ACTIONS(1413),
    [sym_complex] = ACTIONS(1411),
    [sym_super] = ACTIONS(1413),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_TRUE] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_FALSE] = ACTIONS(1413),
    [sym_self] = ACTIONS(1413),
    [anon_sym_nil] = ACTIONS(1413),
    [anon_sym_NIL] = ACTIONS(1413),
    [sym_character] = ACTIONS(1411),
    [anon_sym_LBRACK2] = ACTIONS(1413),
    [anon_sym_DASH_GT] = ACTIONS(1411),
  },
  [883] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(4213),
    [sym__binary_star] = ACTIONS(4215),
    [ts_builtin_sym_end] = ACTIONS(3281),
    [anon_sym___END__] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(4219),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(4215),
    [anon_sym_AMP] = ACTIONS(4221),
    [anon_sym_LT] = ACTIONS(4223),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_unless] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_until] = ACTIONS(3281),
    [anon_sym_rescue] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(4225),
    [anon_sym_DOT_DOT] = ACTIONS(4227),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4229),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(4231),
    [anon_sym_AMP_AMP] = ACTIONS(4231),
    [anon_sym_LT_LT] = ACTIONS(4233),
    [anon_sym_GT_GT] = ACTIONS(4233),
    [anon_sym_EQ_EQ] = ACTIONS(4235),
    [anon_sym_BANG_EQ] = ACTIONS(4231),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4231),
    [anon_sym_LT_EQ_GT] = ACTIONS(4231),
    [anon_sym_EQ_TILDE] = ACTIONS(4231),
    [anon_sym_BANG_TILDE] = ACTIONS(4231),
    [anon_sym_LT_EQ] = ACTIONS(4223),
    [anon_sym_GT] = ACTIONS(4223),
    [anon_sym_GT_EQ] = ACTIONS(4237),
    [anon_sym_CARET] = ACTIONS(4239),
    [anon_sym_PLUS] = ACTIONS(4213),
    [anon_sym_SLASH] = ACTIONS(4215),
    [anon_sym_PERCENT] = ACTIONS(4215),
    [sym_comment] = ACTIONS(87),
  },
  [884] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2462),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_assignment] = STATE(2462),
    [sym_operator_assignment] = STATE(2462),
    [sym_conditional] = STATE(2462),
    [sym_range] = STATE(2462),
    [sym_binary] = STATE(2462),
    [sym_unary] = STATE(2462),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(880),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(373),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(383),
    [anon_sym_yield] = ACTIONS(385),
    [anon_sym_break] = ACTIONS(387),
    [anon_sym_next] = ACTIONS(389),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1575),
    [anon_sym_defined_QMARK] = ACTIONS(395),
    [anon_sym_not] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_TILDE] = ACTIONS(401),
    [sym_constant] = ACTIONS(407),
    [sym_identifier] = ACTIONS(407),
    [sym_instance_variable] = ACTIONS(405),
    [sym_class_variable] = ACTIONS(405),
    [sym_global_variable] = ACTIONS(405),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(407),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(407),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [885] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2463),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_assignment] = STATE(2463),
    [sym_operator_assignment] = STATE(2463),
    [sym_conditional] = STATE(2463),
    [sym_range] = STATE(2463),
    [sym_binary] = STATE(2463),
    [sym_unary] = STATE(2463),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(880),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(373),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(383),
    [anon_sym_yield] = ACTIONS(385),
    [anon_sym_break] = ACTIONS(387),
    [anon_sym_next] = ACTIONS(389),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1575),
    [anon_sym_defined_QMARK] = ACTIONS(395),
    [anon_sym_not] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_TILDE] = ACTIONS(401),
    [sym_constant] = ACTIONS(407),
    [sym_identifier] = ACTIONS(407),
    [sym_instance_variable] = ACTIONS(405),
    [sym_class_variable] = ACTIONS(405),
    [sym_global_variable] = ACTIONS(405),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(407),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(407),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [886] = {
    [anon_sym_COLON] = ACTIONS(4253),
    [sym_comment] = ACTIONS(87),
  },
  [887] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2465),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_assignment] = STATE(2465),
    [sym_operator_assignment] = STATE(2465),
    [sym_conditional] = STATE(2465),
    [sym_range] = STATE(2465),
    [sym_binary] = STATE(2465),
    [sym_unary] = STATE(2465),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(880),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(373),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(383),
    [anon_sym_yield] = ACTIONS(385),
    [anon_sym_break] = ACTIONS(387),
    [anon_sym_next] = ACTIONS(389),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1575),
    [anon_sym_defined_QMARK] = ACTIONS(395),
    [anon_sym_not] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_TILDE] = ACTIONS(401),
    [sym_constant] = ACTIONS(407),
    [sym_identifier] = ACTIONS(407),
    [sym_instance_variable] = ACTIONS(405),
    [sym_class_variable] = ACTIONS(405),
    [sym_global_variable] = ACTIONS(405),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(407),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(407),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [888] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [ts_builtin_sym_end] = ACTIONS(1089),
    [anon_sym___END__] = ACTIONS(1091),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(4255),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [889] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(1627),
    [sym__binary_star] = ACTIONS(1629),
    [ts_builtin_sym_end] = ACTIONS(1625),
    [anon_sym___END__] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(1633),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(1629),
    [anon_sym_AMP] = ACTIONS(1635),
    [anon_sym_LT] = ACTIONS(1637),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_unless] = ACTIONS(1625),
    [anon_sym_while] = ACTIONS(1625),
    [anon_sym_until] = ACTIONS(1625),
    [anon_sym_rescue] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(1625),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(1639),
    [anon_sym_DOT_DOT] = ACTIONS(1641),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1643),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(1645),
    [anon_sym_AMP_AMP] = ACTIONS(1645),
    [anon_sym_LT_LT] = ACTIONS(1647),
    [anon_sym_GT_GT] = ACTIONS(1647),
    [anon_sym_EQ_EQ] = ACTIONS(1649),
    [anon_sym_BANG_EQ] = ACTIONS(1645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1645),
    [anon_sym_LT_EQ_GT] = ACTIONS(1645),
    [anon_sym_EQ_TILDE] = ACTIONS(1645),
    [anon_sym_BANG_TILDE] = ACTIONS(1645),
    [anon_sym_LT_EQ] = ACTIONS(1637),
    [anon_sym_GT] = ACTIONS(1637),
    [anon_sym_GT_EQ] = ACTIONS(1651),
    [anon_sym_CARET] = ACTIONS(1653),
    [anon_sym_PLUS] = ACTIONS(1627),
    [anon_sym_SLASH] = ACTIONS(1629),
    [anon_sym_PERCENT] = ACTIONS(1629),
    [sym_comment] = ACTIONS(87),
  },
  [890] = {
    [sym_heredoc_body] = STATE(2467),
    [aux_sym_call_repeat1] = STATE(2467),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [ts_builtin_sym_end] = ACTIONS(1681),
    [anon_sym___END__] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [891] = {
    [sym_heredoc_body] = STATE(2467),
    [aux_sym_call_repeat1] = STATE(2467),
    [aux_sym_argument_list_repeat1] = STATE(2469),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [ts_builtin_sym_end] = ACTIONS(1681),
    [anon_sym___END__] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(4257),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [892] = {
    [sym_string] = STATE(949),
    [aux_sym_chained_string_repeat1] = STATE(949),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(559),
    [anon_sym___END__] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(4259),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [893] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(2477),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2480),
    [sym_scope_resolution] = STATE(2478),
    [sym_call] = STATE(2478),
    [sym_method_call] = STATE(2480),
    [sym_assignment] = STATE(2477),
    [sym_operator_assignment] = STATE(2477),
    [sym_conditional] = STATE(2477),
    [sym_range] = STATE(2477),
    [sym_binary] = STATE(2477),
    [sym_unary] = STATE(2477),
    [sym_left_assignment_list] = STATE(2479),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2480),
    [sym__variable] = STATE(2478),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2480),
    [sym_false] = STATE(2480),
    [sym_nil] = STATE(2480),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2481),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4261),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4263),
    [anon_sym_yield] = ACTIONS(4265),
    [anon_sym_break] = ACTIONS(4267),
    [anon_sym_next] = ACTIONS(4269),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4271),
    [anon_sym_defined_QMARK] = ACTIONS(4273),
    [anon_sym_not] = ACTIONS(4275),
    [anon_sym_BANG] = ACTIONS(4277),
    [anon_sym_TILDE] = ACTIONS(4277),
    [sym_constant] = ACTIONS(4279),
    [sym_identifier] = ACTIONS(4279),
    [sym_instance_variable] = ACTIONS(4281),
    [sym_class_variable] = ACTIONS(4281),
    [sym_global_variable] = ACTIONS(4281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4279),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4279),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [894] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(2482),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2480),
    [sym_scope_resolution] = STATE(2478),
    [sym_call] = STATE(2478),
    [sym_method_call] = STATE(2480),
    [sym_assignment] = STATE(2482),
    [sym_operator_assignment] = STATE(2482),
    [sym_conditional] = STATE(2482),
    [sym_range] = STATE(2482),
    [sym_binary] = STATE(2482),
    [sym_unary] = STATE(2482),
    [sym_left_assignment_list] = STATE(2479),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2480),
    [sym__variable] = STATE(2478),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2480),
    [sym_false] = STATE(2480),
    [sym_nil] = STATE(2480),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2481),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4261),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4263),
    [anon_sym_yield] = ACTIONS(4265),
    [anon_sym_break] = ACTIONS(4267),
    [anon_sym_next] = ACTIONS(4269),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4271),
    [anon_sym_defined_QMARK] = ACTIONS(4273),
    [anon_sym_not] = ACTIONS(4275),
    [anon_sym_BANG] = ACTIONS(4277),
    [anon_sym_TILDE] = ACTIONS(4277),
    [sym_constant] = ACTIONS(4279),
    [sym_identifier] = ACTIONS(4279),
    [sym_instance_variable] = ACTIONS(4281),
    [sym_class_variable] = ACTIONS(4281),
    [sym_global_variable] = ACTIONS(4281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4279),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4279),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [895] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(2483),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(911),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(911),
    [sym_assignment] = STATE(2483),
    [sym_operator_assignment] = STATE(2483),
    [sym_conditional] = STATE(2483),
    [sym_range] = STATE(2483),
    [sym_binary] = STATE(2483),
    [sym_unary] = STATE(2483),
    [sym_left_assignment_list] = STATE(910),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(911),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(911),
    [sym_false] = STATE(911),
    [sym_nil] = STATE(911),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2484),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1593),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_defined_QMARK] = ACTIONS(1611),
    [anon_sym_not] = ACTIONS(1613),
    [anon_sym_BANG] = ACTIONS(1615),
    [anon_sym_TILDE] = ACTIONS(1615),
    [sym_constant] = ACTIONS(1621),
    [sym_identifier] = ACTIONS(1621),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [896] = {
    [anon_sym_COLON] = ACTIONS(4283),
    [sym_comment] = ACTIONS(87),
  },
  [897] = {
    [sym__line_break] = ACTIONS(4285),
    [sym__heredoc_body_start] = ACTIONS(4285),
    [sym__binary_minus] = ACTIONS(4285),
    [sym__binary_star] = ACTIONS(4285),
    [ts_builtin_sym_end] = ACTIONS(4285),
    [anon_sym___END__] = ACTIONS(4285),
    [anon_sym_LBRACE] = ACTIONS(4285),
    [anon_sym_RBRACE] = ACTIONS(4285),
    [anon_sym_RPAREN] = ACTIONS(4285),
    [anon_sym_DOT] = ACTIONS(4287),
    [anon_sym_COMMA] = ACTIONS(4285),
    [anon_sym_PIPE] = ACTIONS(4287),
    [anon_sym_SEMI] = ACTIONS(4285),
    [anon_sym_STAR_STAR] = ACTIONS(4285),
    [anon_sym_AMP] = ACTIONS(4287),
    [anon_sym_LT] = ACTIONS(4287),
    [anon_sym_end] = ACTIONS(4285),
    [anon_sym_if] = ACTIONS(4285),
    [anon_sym_unless] = ACTIONS(4285),
    [anon_sym_while] = ACTIONS(4285),
    [anon_sym_until] = ACTIONS(4285),
    [anon_sym_rescue] = ACTIONS(4285),
    [anon_sym_do] = ACTIONS(4285),
    [anon_sym_when] = ACTIONS(4285),
    [anon_sym_elsif] = ACTIONS(4285),
    [anon_sym_else] = ACTIONS(4285),
    [anon_sym_then] = ACTIONS(4285),
    [anon_sym_ensure] = ACTIONS(4285),
    [anon_sym_EQ_GT] = ACTIONS(4285),
    [anon_sym_LBRACK] = ACTIONS(4285),
    [anon_sym_COLON_COLON2] = ACTIONS(4285),
    [anon_sym_AMP_DOT] = ACTIONS(4285),
    [anon_sym_QMARK] = ACTIONS(4285),
    [anon_sym_DOT_DOT] = ACTIONS(4287),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4285),
    [anon_sym_and] = ACTIONS(4285),
    [anon_sym_or] = ACTIONS(4285),
    [anon_sym_PIPE_PIPE] = ACTIONS(4285),
    [anon_sym_AMP_AMP] = ACTIONS(4285),
    [anon_sym_LT_LT] = ACTIONS(4285),
    [anon_sym_GT_GT] = ACTIONS(4285),
    [anon_sym_EQ_EQ] = ACTIONS(4287),
    [anon_sym_BANG_EQ] = ACTIONS(4285),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4285),
    [anon_sym_LT_EQ_GT] = ACTIONS(4285),
    [anon_sym_EQ_TILDE] = ACTIONS(4285),
    [anon_sym_BANG_TILDE] = ACTIONS(4285),
    [anon_sym_LT_EQ] = ACTIONS(4287),
    [anon_sym_GT] = ACTIONS(4287),
    [anon_sym_GT_EQ] = ACTIONS(4285),
    [anon_sym_CARET] = ACTIONS(4285),
    [anon_sym_PLUS] = ACTIONS(4285),
    [anon_sym_SLASH] = ACTIONS(4285),
    [anon_sym_PERCENT] = ACTIONS(4285),
    [sym_comment] = ACTIONS(87),
  },
  [898] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(2486),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2480),
    [sym_scope_resolution] = STATE(2478),
    [sym_call] = STATE(2478),
    [sym_method_call] = STATE(2480),
    [sym_assignment] = STATE(2486),
    [sym_operator_assignment] = STATE(2486),
    [sym_conditional] = STATE(2486),
    [sym_range] = STATE(2486),
    [sym_binary] = STATE(2486),
    [sym_unary] = STATE(2486),
    [sym_left_assignment_list] = STATE(2479),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2480),
    [sym__variable] = STATE(2478),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2480),
    [sym_false] = STATE(2480),
    [sym_nil] = STATE(2480),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2481),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4261),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4263),
    [anon_sym_yield] = ACTIONS(4265),
    [anon_sym_break] = ACTIONS(4267),
    [anon_sym_next] = ACTIONS(4269),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4271),
    [anon_sym_defined_QMARK] = ACTIONS(4273),
    [anon_sym_not] = ACTIONS(4275),
    [anon_sym_BANG] = ACTIONS(4277),
    [anon_sym_TILDE] = ACTIONS(4277),
    [sym_constant] = ACTIONS(4279),
    [sym_identifier] = ACTIONS(4279),
    [sym_instance_variable] = ACTIONS(4281),
    [sym_class_variable] = ACTIONS(4281),
    [sym_global_variable] = ACTIONS(4281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4279),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4279),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [899] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(2492),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2061),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(2061),
    [sym_argument_list] = STATE(1318),
    [sym__argument_list_with_parens] = STATE(2493),
    [sym__argument] = STATE(2494),
    [sym_splat_argument] = STATE(2494),
    [sym_hash_splat_argument] = STATE(2494),
    [sym_block_argument] = STATE(2494),
    [sym_assignment] = STATE(2492),
    [sym_operator_assignment] = STATE(2492),
    [sym_conditional] = STATE(2492),
    [sym_range] = STATE(2492),
    [sym_binary] = STATE(2492),
    [sym_unary] = STATE(2492),
    [sym_left_assignment_list] = STATE(2060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2061),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2061),
    [sym_false] = STATE(2061),
    [sym_nil] = STATE(2061),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2495),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(2494),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(4289),
    [sym__splat_star] = ACTIONS(4291),
    [sym__unary_minus] = ACTIONS(3595),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(4293),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(365),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(3599),
    [anon_sym_not] = ACTIONS(3601),
    [anon_sym_BANG] = ACTIONS(3603),
    [anon_sym_TILDE] = ACTIONS(3605),
    [sym_constant] = ACTIONS(4295),
    [sym_identifier] = ACTIONS(4295),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [900] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(2492),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2061),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(2061),
    [sym_argument_list] = STATE(1324),
    [sym__argument_list_with_parens] = STATE(2493),
    [sym__argument] = STATE(2494),
    [sym_splat_argument] = STATE(2494),
    [sym_hash_splat_argument] = STATE(2494),
    [sym_block_argument] = STATE(2494),
    [sym_assignment] = STATE(2492),
    [sym_operator_assignment] = STATE(2492),
    [sym_conditional] = STATE(2492),
    [sym_range] = STATE(2492),
    [sym_binary] = STATE(2492),
    [sym_unary] = STATE(2492),
    [sym_left_assignment_list] = STATE(2060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2061),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2061),
    [sym_false] = STATE(2061),
    [sym_nil] = STATE(2061),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2495),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(2494),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(4289),
    [sym__splat_star] = ACTIONS(4291),
    [sym__unary_minus] = ACTIONS(3595),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(4293),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(417),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(3599),
    [anon_sym_not] = ACTIONS(3601),
    [anon_sym_BANG] = ACTIONS(3603),
    [anon_sym_TILDE] = ACTIONS(3605),
    [sym_constant] = ACTIONS(4295),
    [sym_identifier] = ACTIONS(4295),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [901] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(2492),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2061),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(2061),
    [sym_argument_list] = STATE(1325),
    [sym__argument_list_with_parens] = STATE(2493),
    [sym__argument] = STATE(2494),
    [sym_splat_argument] = STATE(2494),
    [sym_hash_splat_argument] = STATE(2494),
    [sym_block_argument] = STATE(2494),
    [sym_assignment] = STATE(2492),
    [sym_operator_assignment] = STATE(2492),
    [sym_conditional] = STATE(2492),
    [sym_range] = STATE(2492),
    [sym_binary] = STATE(2492),
    [sym_unary] = STATE(2492),
    [sym_left_assignment_list] = STATE(2060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2061),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2061),
    [sym_false] = STATE(2061),
    [sym_nil] = STATE(2061),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2495),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(2494),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(4289),
    [sym__splat_star] = ACTIONS(4291),
    [sym__unary_minus] = ACTIONS(3595),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(4293),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(421),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(3599),
    [anon_sym_not] = ACTIONS(3601),
    [anon_sym_BANG] = ACTIONS(3603),
    [anon_sym_TILDE] = ACTIONS(3605),
    [sym_constant] = ACTIONS(4295),
    [sym_identifier] = ACTIONS(4295),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [902] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(2492),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2061),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(2061),
    [sym_argument_list] = STATE(1326),
    [sym__argument_list_with_parens] = STATE(2493),
    [sym__argument] = STATE(2494),
    [sym_splat_argument] = STATE(2494),
    [sym_hash_splat_argument] = STATE(2494),
    [sym_block_argument] = STATE(2494),
    [sym_assignment] = STATE(2492),
    [sym_operator_assignment] = STATE(2492),
    [sym_conditional] = STATE(2492),
    [sym_range] = STATE(2492),
    [sym_binary] = STATE(2492),
    [sym_unary] = STATE(2492),
    [sym_left_assignment_list] = STATE(2060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2061),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2061),
    [sym_false] = STATE(2061),
    [sym_nil] = STATE(2061),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2495),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(2494),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(4289),
    [sym__splat_star] = ACTIONS(4291),
    [sym__unary_minus] = ACTIONS(3595),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(4293),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(425),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(3599),
    [anon_sym_not] = ACTIONS(3601),
    [anon_sym_BANG] = ACTIONS(3603),
    [anon_sym_TILDE] = ACTIONS(3605),
    [sym_constant] = ACTIONS(4295),
    [sym_identifier] = ACTIONS(4295),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [903] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(2496),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(911),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(911),
    [sym_assignment] = STATE(2496),
    [sym_operator_assignment] = STATE(2496),
    [sym_conditional] = STATE(2496),
    [sym_range] = STATE(2496),
    [sym_binary] = STATE(2496),
    [sym_unary] = STATE(2496),
    [sym_left_assignment_list] = STATE(910),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(911),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(911),
    [sym_false] = STATE(911),
    [sym_nil] = STATE(911),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2484),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1593),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_defined_QMARK] = ACTIONS(1611),
    [anon_sym_not] = ACTIONS(1613),
    [anon_sym_BANG] = ACTIONS(1615),
    [anon_sym_TILDE] = ACTIONS(1615),
    [sym_constant] = ACTIONS(1621),
    [sym_identifier] = ACTIONS(1621),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [904] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(1341),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(911),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(911),
    [sym_assignment] = STATE(1341),
    [sym_operator_assignment] = STATE(1341),
    [sym_conditional] = STATE(1341),
    [sym_range] = STATE(1341),
    [sym_binary] = STATE(1341),
    [sym_unary] = STATE(1341),
    [sym_left_assignment_list] = STATE(910),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(911),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(911),
    [sym_false] = STATE(911),
    [sym_nil] = STATE(911),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2484),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1593),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_defined_QMARK] = ACTIONS(1611),
    [anon_sym_not] = ACTIONS(1613),
    [anon_sym_BANG] = ACTIONS(1615),
    [anon_sym_TILDE] = ACTIONS(1615),
    [sym_constant] = ACTIONS(1621),
    [sym_identifier] = ACTIONS(1621),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [905] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(4297),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [906] = {
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(4299),
    [sym__binary_star] = ACTIONS(4301),
    [anon_sym_RPAREN] = ACTIONS(1625),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(4303),
    [anon_sym_STAR_STAR] = ACTIONS(4301),
    [anon_sym_AMP] = ACTIONS(4305),
    [anon_sym_LT] = ACTIONS(4307),
    [anon_sym_EQ_GT] = ACTIONS(4283),
    [anon_sym_QMARK] = ACTIONS(4309),
    [anon_sym_DOT_DOT] = ACTIONS(4311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4313),
    [anon_sym_and] = ACTIONS(4315),
    [anon_sym_or] = ACTIONS(4315),
    [anon_sym_PIPE_PIPE] = ACTIONS(4317),
    [anon_sym_AMP_AMP] = ACTIONS(4317),
    [anon_sym_LT_LT] = ACTIONS(4319),
    [anon_sym_GT_GT] = ACTIONS(4319),
    [anon_sym_EQ_EQ] = ACTIONS(4321),
    [anon_sym_BANG_EQ] = ACTIONS(4317),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4317),
    [anon_sym_LT_EQ_GT] = ACTIONS(4317),
    [anon_sym_EQ_TILDE] = ACTIONS(4317),
    [anon_sym_BANG_TILDE] = ACTIONS(4317),
    [anon_sym_LT_EQ] = ACTIONS(4307),
    [anon_sym_GT] = ACTIONS(4307),
    [anon_sym_GT_EQ] = ACTIONS(4323),
    [anon_sym_CARET] = ACTIONS(4325),
    [anon_sym_PLUS] = ACTIONS(4299),
    [anon_sym_SLASH] = ACTIONS(4301),
    [anon_sym_PERCENT] = ACTIONS(4301),
    [sym_comment] = ACTIONS(87),
  },
  [907] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(2513),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2092),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2092),
    [sym_argument_list] = STATE(1379),
    [sym__argument_list_with_parens] = STATE(2514),
    [sym__argument] = STATE(2515),
    [sym_splat_argument] = STATE(2515),
    [sym_hash_splat_argument] = STATE(2515),
    [sym_block_argument] = STATE(2515),
    [sym_do_block] = STATE(1382),
    [sym_block] = STATE(1382),
    [sym_assignment] = STATE(2513),
    [sym_operator_assignment] = STATE(2513),
    [sym_conditional] = STATE(2513),
    [sym_range] = STATE(2513),
    [sym_binary] = STATE(2513),
    [sym_unary] = STATE(2513),
    [sym_left_assignment_list] = STATE(2091),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2092),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2092),
    [sym_false] = STATE(2092),
    [sym_nil] = STATE(2092),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(2516),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(2515),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(4327),
    [sym__splat_star] = ACTIONS(4329),
    [sym__unary_minus] = ACTIONS(3643),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(4331),
    [anon_sym_LBRACE] = ACTIONS(2403),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3647),
    [anon_sym_yield] = ACTIONS(3649),
    [anon_sym_break] = ACTIONS(3651),
    [anon_sym_next] = ACTIONS(3653),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(2413),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(3655),
    [anon_sym_not] = ACTIONS(3657),
    [anon_sym_BANG] = ACTIONS(3659),
    [anon_sym_TILDE] = ACTIONS(3661),
    [sym_constant] = ACTIONS(4333),
    [sym_identifier] = ACTIONS(4333),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [908] = {
    [anon_sym_RPAREN] = ACTIONS(4335),
    [sym_comment] = ACTIONS(87),
  },
  [909] = {
    [sym_heredoc_body] = STATE(1388),
    [aux_sym_argument_list_repeat1] = STATE(2519),
    [sym__heredoc_body_start] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(2433),
    [anon_sym_COMMA] = ACTIONS(4337),
    [sym_comment] = ACTIONS(87),
  },
  [910] = {
    [anon_sym_EQ] = ACTIONS(4339),
    [sym_comment] = ACTIONS(87),
  },
  [911] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(4341),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(4343),
    [anon_sym_DASH_EQ] = ACTIONS(4343),
    [anon_sym_STAR_EQ] = ACTIONS(4343),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4343),
    [anon_sym_SLASH_EQ] = ACTIONS(4343),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4343),
    [anon_sym_PIPE_EQ] = ACTIONS(4343),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4343),
    [anon_sym_AMP_EQ] = ACTIONS(4343),
    [anon_sym_PERCENT_EQ] = ACTIONS(4343),
    [anon_sym_GT_GT_EQ] = ACTIONS(4343),
    [anon_sym_LT_LT_EQ] = ACTIONS(4343),
    [anon_sym_CARET_EQ] = ACTIONS(4343),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [912] = {
    [sym_string] = STATE(2522),
    [aux_sym_chained_string_repeat1] = STATE(2522),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(4345),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [913] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(1627),
    [sym__binary_star] = ACTIONS(1629),
    [ts_builtin_sym_end] = ACTIONS(935),
    [anon_sym___END__] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(1633),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(1629),
    [anon_sym_AMP] = ACTIONS(1635),
    [anon_sym_LT] = ACTIONS(1637),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(1639),
    [anon_sym_DOT_DOT] = ACTIONS(1641),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1643),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(1645),
    [anon_sym_AMP_AMP] = ACTIONS(1645),
    [anon_sym_LT_LT] = ACTIONS(1647),
    [anon_sym_GT_GT] = ACTIONS(1647),
    [anon_sym_EQ_EQ] = ACTIONS(1649),
    [anon_sym_BANG_EQ] = ACTIONS(1645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1645),
    [anon_sym_LT_EQ_GT] = ACTIONS(1645),
    [anon_sym_EQ_TILDE] = ACTIONS(1645),
    [anon_sym_BANG_TILDE] = ACTIONS(1645),
    [anon_sym_LT_EQ] = ACTIONS(1637),
    [anon_sym_GT] = ACTIONS(1637),
    [anon_sym_GT_EQ] = ACTIONS(1651),
    [anon_sym_CARET] = ACTIONS(1653),
    [anon_sym_PLUS] = ACTIONS(1627),
    [anon_sym_SLASH] = ACTIONS(1629),
    [anon_sym_PERCENT] = ACTIONS(1629),
    [sym_comment] = ACTIONS(87),
  },
  [914] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [ts_builtin_sym_end] = ACTIONS(935),
    [anon_sym___END__] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(935),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_when] = ACTIONS(935),
    [anon_sym_elsif] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_ensure] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [915] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2523),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(876),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(876),
    [sym_assignment] = STATE(2523),
    [sym_operator_assignment] = STATE(2523),
    [sym_conditional] = STATE(2523),
    [sym_range] = STATE(2523),
    [sym_binary] = STATE(2523),
    [sym_unary] = STATE(2523),
    [sym_left_assignment_list] = STATE(875),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(876),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(876),
    [sym_false] = STATE(876),
    [sym_nil] = STATE(876),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(877),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(1555),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1557),
    [anon_sym_yield] = ACTIONS(1559),
    [anon_sym_break] = ACTIONS(1561),
    [anon_sym_next] = ACTIONS(1563),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_defined_QMARK] = ACTIONS(1567),
    [anon_sym_not] = ACTIONS(1569),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_TILDE] = ACTIONS(1571),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [916] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2524),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_assignment] = STATE(2524),
    [sym_operator_assignment] = STATE(2524),
    [sym_conditional] = STATE(2524),
    [sym_range] = STATE(2524),
    [sym_binary] = STATE(2524),
    [sym_unary] = STATE(2524),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(880),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(373),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(383),
    [anon_sym_yield] = ACTIONS(385),
    [anon_sym_break] = ACTIONS(387),
    [anon_sym_next] = ACTIONS(389),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1575),
    [anon_sym_defined_QMARK] = ACTIONS(395),
    [anon_sym_not] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_TILDE] = ACTIONS(401),
    [sym_constant] = ACTIONS(407),
    [sym_identifier] = ACTIONS(407),
    [sym_instance_variable] = ACTIONS(405),
    [sym_class_variable] = ACTIONS(405),
    [sym_global_variable] = ACTIONS(405),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(407),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(407),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [917] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2525),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_assignment] = STATE(2525),
    [sym_operator_assignment] = STATE(2525),
    [sym_conditional] = STATE(2525),
    [sym_range] = STATE(2525),
    [sym_binary] = STATE(2525),
    [sym_unary] = STATE(2525),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(880),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(373),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(383),
    [anon_sym_yield] = ACTIONS(385),
    [anon_sym_break] = ACTIONS(387),
    [anon_sym_next] = ACTIONS(389),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1575),
    [anon_sym_defined_QMARK] = ACTIONS(395),
    [anon_sym_not] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_TILDE] = ACTIONS(401),
    [sym_constant] = ACTIONS(407),
    [sym_identifier] = ACTIONS(407),
    [sym_instance_variable] = ACTIONS(405),
    [sym_class_variable] = ACTIONS(405),
    [sym_global_variable] = ACTIONS(405),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(407),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(407),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [918] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2526),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_assignment] = STATE(2526),
    [sym_operator_assignment] = STATE(2526),
    [sym_conditional] = STATE(2526),
    [sym_range] = STATE(2526),
    [sym_binary] = STATE(2526),
    [sym_unary] = STATE(2526),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(880),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(373),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(383),
    [anon_sym_yield] = ACTIONS(385),
    [anon_sym_break] = ACTIONS(387),
    [anon_sym_next] = ACTIONS(389),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1575),
    [anon_sym_defined_QMARK] = ACTIONS(395),
    [anon_sym_not] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_TILDE] = ACTIONS(401),
    [sym_constant] = ACTIONS(407),
    [sym_identifier] = ACTIONS(407),
    [sym_instance_variable] = ACTIONS(405),
    [sym_class_variable] = ACTIONS(405),
    [sym_global_variable] = ACTIONS(405),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(407),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(407),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [919] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2527),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_assignment] = STATE(2527),
    [sym_operator_assignment] = STATE(2527),
    [sym_conditional] = STATE(2527),
    [sym_range] = STATE(2527),
    [sym_binary] = STATE(2527),
    [sym_unary] = STATE(2527),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(880),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(373),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(383),
    [anon_sym_yield] = ACTIONS(385),
    [anon_sym_break] = ACTIONS(387),
    [anon_sym_next] = ACTIONS(389),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1575),
    [anon_sym_defined_QMARK] = ACTIONS(395),
    [anon_sym_not] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_TILDE] = ACTIONS(401),
    [sym_constant] = ACTIONS(407),
    [sym_identifier] = ACTIONS(407),
    [sym_instance_variable] = ACTIONS(405),
    [sym_class_variable] = ACTIONS(405),
    [sym_global_variable] = ACTIONS(405),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(407),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(407),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [920] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2528),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_assignment] = STATE(2528),
    [sym_operator_assignment] = STATE(2528),
    [sym_conditional] = STATE(2528),
    [sym_range] = STATE(2528),
    [sym_binary] = STATE(2528),
    [sym_unary] = STATE(2528),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(880),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(373),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(383),
    [anon_sym_yield] = ACTIONS(385),
    [anon_sym_break] = ACTIONS(387),
    [anon_sym_next] = ACTIONS(389),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1575),
    [anon_sym_defined_QMARK] = ACTIONS(395),
    [anon_sym_not] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_TILDE] = ACTIONS(401),
    [sym_constant] = ACTIONS(407),
    [sym_identifier] = ACTIONS(407),
    [sym_instance_variable] = ACTIONS(405),
    [sym_class_variable] = ACTIONS(405),
    [sym_global_variable] = ACTIONS(405),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(407),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(407),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [921] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(2529),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [922] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2530),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_assignment] = STATE(2530),
    [sym_operator_assignment] = STATE(2530),
    [sym_conditional] = STATE(2530),
    [sym_range] = STATE(2530),
    [sym_binary] = STATE(2530),
    [sym_unary] = STATE(2530),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(880),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(373),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(383),
    [anon_sym_yield] = ACTIONS(385),
    [anon_sym_break] = ACTIONS(387),
    [anon_sym_next] = ACTIONS(389),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1575),
    [anon_sym_defined_QMARK] = ACTIONS(395),
    [anon_sym_not] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_TILDE] = ACTIONS(401),
    [sym_constant] = ACTIONS(407),
    [sym_identifier] = ACTIONS(407),
    [sym_instance_variable] = ACTIONS(405),
    [sym_class_variable] = ACTIONS(405),
    [sym_global_variable] = ACTIONS(405),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(407),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(407),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [923] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2531),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_assignment] = STATE(2531),
    [sym_operator_assignment] = STATE(2531),
    [sym_conditional] = STATE(2531),
    [sym_range] = STATE(2531),
    [sym_binary] = STATE(2531),
    [sym_unary] = STATE(2531),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(880),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(373),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(383),
    [anon_sym_yield] = ACTIONS(385),
    [anon_sym_break] = ACTIONS(387),
    [anon_sym_next] = ACTIONS(389),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1575),
    [anon_sym_defined_QMARK] = ACTIONS(395),
    [anon_sym_not] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_TILDE] = ACTIONS(401),
    [sym_constant] = ACTIONS(407),
    [sym_identifier] = ACTIONS(407),
    [sym_instance_variable] = ACTIONS(405),
    [sym_class_variable] = ACTIONS(405),
    [sym_global_variable] = ACTIONS(405),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(407),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(407),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [924] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2532),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_assignment] = STATE(2532),
    [sym_operator_assignment] = STATE(2532),
    [sym_conditional] = STATE(2532),
    [sym_range] = STATE(2532),
    [sym_binary] = STATE(2532),
    [sym_unary] = STATE(2532),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(880),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(373),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(383),
    [anon_sym_yield] = ACTIONS(385),
    [anon_sym_break] = ACTIONS(387),
    [anon_sym_next] = ACTIONS(389),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1575),
    [anon_sym_defined_QMARK] = ACTIONS(395),
    [anon_sym_not] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_TILDE] = ACTIONS(401),
    [sym_constant] = ACTIONS(407),
    [sym_identifier] = ACTIONS(407),
    [sym_instance_variable] = ACTIONS(405),
    [sym_class_variable] = ACTIONS(405),
    [sym_global_variable] = ACTIONS(405),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(407),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(407),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [925] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2533),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_assignment] = STATE(2533),
    [sym_operator_assignment] = STATE(2533),
    [sym_conditional] = STATE(2533),
    [sym_range] = STATE(2533),
    [sym_binary] = STATE(2533),
    [sym_unary] = STATE(2533),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(880),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(373),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(383),
    [anon_sym_yield] = ACTIONS(385),
    [anon_sym_break] = ACTIONS(387),
    [anon_sym_next] = ACTIONS(389),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1575),
    [anon_sym_defined_QMARK] = ACTIONS(395),
    [anon_sym_not] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_TILDE] = ACTIONS(401),
    [sym_constant] = ACTIONS(407),
    [sym_identifier] = ACTIONS(407),
    [sym_instance_variable] = ACTIONS(405),
    [sym_class_variable] = ACTIONS(405),
    [sym_global_variable] = ACTIONS(405),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(407),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(407),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [926] = {
    [sym_argument_list_with_parens] = STATE(2536),
    [sym__argument_list_with_parens] = STATE(2537),
    [sym_operator] = STATE(2536),
    [sym_heredoc_body] = STATE(2538),
    [aux_sym_call_repeat1] = STATE(2538),
    [sym__heredoc_body_start] = ACTIONS(2519),
    [anon_sym_PIPE] = ACTIONS(4347),
    [anon_sym_STAR] = ACTIONS(4349),
    [anon_sym_STAR_STAR] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4347),
    [anon_sym_LT] = ACTIONS(4349),
    [anon_sym_LPAREN2] = ACTIONS(4351),
    [anon_sym_DOT_DOT] = ACTIONS(4347),
    [anon_sym_LT_LT] = ACTIONS(4347),
    [anon_sym_GT_GT] = ACTIONS(4347),
    [anon_sym_EQ_EQ] = ACTIONS(4349),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4347),
    [anon_sym_LT_EQ_GT] = ACTIONS(4347),
    [anon_sym_EQ_TILDE] = ACTIONS(4347),
    [anon_sym_BANG_TILDE] = ACTIONS(4347),
    [anon_sym_LT_EQ] = ACTIONS(4349),
    [anon_sym_GT] = ACTIONS(4349),
    [anon_sym_GT_EQ] = ACTIONS(4347),
    [anon_sym_CARET] = ACTIONS(4347),
    [anon_sym_PLUS] = ACTIONS(4349),
    [anon_sym_SLASH] = ACTIONS(4347),
    [anon_sym_PERCENT] = ACTIONS(4347),
    [anon_sym_BANG] = ACTIONS(4349),
    [anon_sym_TILDE] = ACTIONS(4347),
    [sym_constant] = ACTIONS(4353),
    [sym_identifier] = ACTIONS(4353),
    [anon_sym_DASH] = ACTIONS(4349),
    [anon_sym_PLUS_AT] = ACTIONS(4347),
    [anon_sym_DASH_AT] = ACTIONS(4347),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4349),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(4347),
    [anon_sym_BQUOTE] = ACTIONS(4347),
    [sym_comment] = ACTIONS(87),
  },
  [927] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(346),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(352),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(352),
    [sym__argument_list_with_trailing_comma] = STATE(2540),
    [sym__argument] = STATE(350),
    [sym_splat_argument] = STATE(350),
    [sym_hash_splat_argument] = STATE(350),
    [sym_block_argument] = STATE(350),
    [sym_assignment] = STATE(346),
    [sym_operator_assignment] = STATE(346),
    [sym_conditional] = STATE(346),
    [sym_range] = STATE(346),
    [sym_binary] = STATE(346),
    [sym_unary] = STATE(346),
    [sym_left_assignment_list] = STATE(351),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(352),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(352),
    [sym_false] = STATE(352),
    [sym_nil] = STATE(352),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(353),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(350),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(593),
    [sym__splat_star] = ACTIONS(595),
    [sym__unary_minus] = ACTIONS(597),
    [sym__identifier_hash_key] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(4355),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [928] = {
    [sym_constant] = ACTIONS(4357),
    [sym_identifier] = ACTIONS(4357),
    [sym_comment] = ACTIONS(87),
  },
  [929] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(2542),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(428),
    [sym_scope_resolution] = STATE(422),
    [sym_call] = STATE(422),
    [sym_method_call] = STATE(428),
    [sym_assignment] = STATE(2542),
    [sym_operator_assignment] = STATE(2542),
    [sym_conditional] = STATE(2542),
    [sym_range] = STATE(2542),
    [sym_binary] = STATE(2542),
    [sym_unary] = STATE(2542),
    [sym_left_assignment_list] = STATE(427),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(428),
    [sym__variable] = STATE(422),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(428),
    [sym_false] = STATE(428),
    [sym_nil] = STATE(428),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(1503),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(781),
    [anon_sym_yield] = ACTIONS(783),
    [anon_sym_break] = ACTIONS(785),
    [anon_sym_next] = ACTIONS(787),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(2623),
    [anon_sym_defined_QMARK] = ACTIONS(801),
    [anon_sym_not] = ACTIONS(803),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_TILDE] = ACTIONS(807),
    [sym_constant] = ACTIONS(815),
    [sym_identifier] = ACTIONS(815),
    [sym_instance_variable] = ACTIONS(811),
    [sym_class_variable] = ACTIONS(811),
    [sym_global_variable] = ACTIONS(811),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(815),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(815),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [930] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(2543),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(428),
    [sym_scope_resolution] = STATE(422),
    [sym_call] = STATE(422),
    [sym_method_call] = STATE(428),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_left_assignment_list] = STATE(427),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(428),
    [sym__variable] = STATE(422),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(428),
    [sym_false] = STATE(428),
    [sym_nil] = STATE(428),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(1503),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(781),
    [anon_sym_yield] = ACTIONS(783),
    [anon_sym_break] = ACTIONS(785),
    [anon_sym_next] = ACTIONS(787),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(2623),
    [anon_sym_defined_QMARK] = ACTIONS(801),
    [anon_sym_not] = ACTIONS(803),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_TILDE] = ACTIONS(807),
    [sym_constant] = ACTIONS(815),
    [sym_identifier] = ACTIONS(815),
    [sym_instance_variable] = ACTIONS(811),
    [sym_class_variable] = ACTIONS(811),
    [sym_global_variable] = ACTIONS(811),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(815),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(815),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [931] = {
    [anon_sym_COLON] = ACTIONS(4359),
    [sym_comment] = ACTIONS(87),
  },
  [932] = {
    [sym__statements] = STATE(2546),
    [sym_begin_block] = STATE(489),
    [sym_end_block] = STATE(489),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_block_parameters] = STATE(2547),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1516),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1519),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1519),
    [sym_hash_splat_argument] = STATE(116),
    [sym_assignment] = STATE(1516),
    [sym_operator_assignment] = STATE(1516),
    [sym_conditional] = STATE(1516),
    [sym_range] = STATE(1516),
    [sym_binary] = STATE(1516),
    [sym_unary] = STATE(1516),
    [sym_left_assignment_list] = STATE(1518),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1519),
    [sym__variable] = STATE(1517),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1519),
    [sym_false] = STATE(1519),
    [sym_nil] = STATE(1519),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1520),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(1521),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym__hash_items] = STATE(1522),
    [sym_pair] = STATE(122),
    [sym_lambda] = STATE(214),
    [sym_empty_statement] = STATE(495),
    [aux_sym__statements_repeat1] = STATE(495),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2629),
    [sym__identifier_hash_key] = ACTIONS(157),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(4361),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_PIPE] = ACTIONS(2445),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2633),
    [anon_sym_yield] = ACTIONS(2635),
    [anon_sym_break] = ACTIONS(2637),
    [anon_sym_next] = ACTIONS(2639),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2641),
    [anon_sym_defined_QMARK] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2647),
    [anon_sym_TILDE] = ACTIONS(2647),
    [sym_constant] = ACTIONS(2649),
    [sym_identifier] = ACTIONS(2649),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [933] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(2548),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(428),
    [sym_scope_resolution] = STATE(422),
    [sym_call] = STATE(422),
    [sym_method_call] = STATE(428),
    [sym_assignment] = STATE(2548),
    [sym_operator_assignment] = STATE(2548),
    [sym_conditional] = STATE(2548),
    [sym_range] = STATE(2548),
    [sym_binary] = STATE(2548),
    [sym_unary] = STATE(2548),
    [sym_left_assignment_list] = STATE(427),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(428),
    [sym__variable] = STATE(422),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(428),
    [sym_false] = STATE(428),
    [sym_nil] = STATE(428),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(1503),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(781),
    [anon_sym_yield] = ACTIONS(783),
    [anon_sym_break] = ACTIONS(785),
    [anon_sym_next] = ACTIONS(787),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(2623),
    [anon_sym_defined_QMARK] = ACTIONS(801),
    [anon_sym_not] = ACTIONS(803),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_TILDE] = ACTIONS(807),
    [sym_constant] = ACTIONS(815),
    [sym_identifier] = ACTIONS(815),
    [sym_instance_variable] = ACTIONS(811),
    [sym_class_variable] = ACTIONS(811),
    [sym_global_variable] = ACTIONS(811),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(815),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(815),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [934] = {
    [sym__statements] = STATE(2550),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_block_parameters] = STATE(2551),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_heredoc_body] = STATE(2552),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [sym__terminator] = STATE(2552),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__line_break] = ACTIONS(4363),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(4363),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(4365),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [935] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(906),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(911),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(911),
    [sym__argument_list_with_trailing_comma] = STATE(2554),
    [sym__argument] = STATE(909),
    [sym_splat_argument] = STATE(909),
    [sym_hash_splat_argument] = STATE(909),
    [sym_block_argument] = STATE(909),
    [sym_assignment] = STATE(906),
    [sym_operator_assignment] = STATE(906),
    [sym_conditional] = STATE(906),
    [sym_range] = STATE(906),
    [sym_binary] = STATE(906),
    [sym_unary] = STATE(906),
    [sym_left_assignment_list] = STATE(910),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(911),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(911),
    [sym_false] = STATE(911),
    [sym_nil] = STATE(911),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(912),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(909),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1589),
    [sym__splat_star] = ACTIONS(1591),
    [sym__unary_minus] = ACTIONS(1593),
    [sym__identifier_hash_key] = ACTIONS(1595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(4367),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1599),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_defined_QMARK] = ACTIONS(1611),
    [anon_sym_not] = ACTIONS(1613),
    [anon_sym_BANG] = ACTIONS(1615),
    [anon_sym_TILDE] = ACTIONS(1615),
    [sym_constant] = ACTIONS(1617),
    [sym_identifier] = ACTIONS(1617),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [936] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [ts_builtin_sym_end] = ACTIONS(1089),
    [anon_sym___END__] = ACTIONS(1091),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(4369),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [937] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(2687),
    [sym__binary_star] = ACTIONS(2689),
    [ts_builtin_sym_end] = ACTIONS(1625),
    [anon_sym___END__] = ACTIONS(1625),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(2691),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(2693),
    [anon_sym_AMP] = ACTIONS(2695),
    [anon_sym_EQ] = ACTIONS(1631),
    [anon_sym_LT] = ACTIONS(2697),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_unless] = ACTIONS(1625),
    [anon_sym_while] = ACTIONS(1625),
    [anon_sym_until] = ACTIONS(1625),
    [anon_sym_rescue] = ACTIONS(1625),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(1625),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_PLUS_EQ] = ACTIONS(1625),
    [anon_sym_DASH_EQ] = ACTIONS(1625),
    [anon_sym_STAR_EQ] = ACTIONS(1625),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1625),
    [anon_sym_SLASH_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1625),
    [anon_sym_AMP_EQ] = ACTIONS(1625),
    [anon_sym_PERCENT_EQ] = ACTIONS(1625),
    [anon_sym_GT_GT_EQ] = ACTIONS(1625),
    [anon_sym_LT_LT_EQ] = ACTIONS(1625),
    [anon_sym_CARET_EQ] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(2699),
    [anon_sym_DOT_DOT] = ACTIONS(2701),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2703),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(2705),
    [anon_sym_AMP_AMP] = ACTIONS(2705),
    [anon_sym_LT_LT] = ACTIONS(2707),
    [anon_sym_GT_GT] = ACTIONS(2707),
    [anon_sym_EQ_EQ] = ACTIONS(2705),
    [anon_sym_BANG_EQ] = ACTIONS(2709),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2709),
    [anon_sym_LT_EQ_GT] = ACTIONS(2709),
    [anon_sym_EQ_TILDE] = ACTIONS(2709),
    [anon_sym_BANG_TILDE] = ACTIONS(2709),
    [anon_sym_LT_EQ] = ACTIONS(2697),
    [anon_sym_GT] = ACTIONS(2697),
    [anon_sym_GT_EQ] = ACTIONS(2711),
    [anon_sym_CARET] = ACTIONS(2691),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_SLASH] = ACTIONS(2693),
    [anon_sym_PERCENT] = ACTIONS(2693),
    [sym_comment] = ACTIONS(87),
  },
  [938] = {
    [sym_do_block] = STATE(2556),
    [sym_block] = STATE(2556),
    [sym__line_break] = ACTIONS(2717),
    [sym__heredoc_body_start] = ACTIONS(2717),
    [sym__binary_minus] = ACTIONS(2717),
    [sym__binary_star] = ACTIONS(2717),
    [ts_builtin_sym_end] = ACTIONS(2717),
    [anon_sym___END__] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_RBRACE] = ACTIONS(2717),
    [anon_sym_RPAREN] = ACTIONS(2717),
    [anon_sym_DOT] = ACTIONS(2721),
    [anon_sym_COMMA] = ACTIONS(2717),
    [anon_sym_PIPE] = ACTIONS(2721),
    [anon_sym_SEMI] = ACTIONS(2717),
    [anon_sym_STAR_STAR] = ACTIONS(2721),
    [anon_sym_AMP] = ACTIONS(2721),
    [anon_sym_EQ] = ACTIONS(2721),
    [anon_sym_LT] = ACTIONS(2721),
    [anon_sym_end] = ACTIONS(2717),
    [anon_sym_if] = ACTIONS(2717),
    [anon_sym_unless] = ACTIONS(2717),
    [anon_sym_while] = ACTIONS(2717),
    [anon_sym_until] = ACTIONS(2717),
    [anon_sym_rescue] = ACTIONS(2717),
    [anon_sym_do] = ACTIONS(4371),
    [anon_sym_when] = ACTIONS(2717),
    [anon_sym_elsif] = ACTIONS(2717),
    [anon_sym_else] = ACTIONS(2717),
    [anon_sym_then] = ACTIONS(2717),
    [anon_sym_ensure] = ACTIONS(2717),
    [anon_sym_EQ_GT] = ACTIONS(2717),
    [anon_sym_LBRACK] = ACTIONS(2717),
    [anon_sym_COLON_COLON2] = ACTIONS(2717),
    [anon_sym_AMP_DOT] = ACTIONS(2717),
    [anon_sym_PLUS_EQ] = ACTIONS(2717),
    [anon_sym_DASH_EQ] = ACTIONS(2717),
    [anon_sym_STAR_EQ] = ACTIONS(2717),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2717),
    [anon_sym_SLASH_EQ] = ACTIONS(2717),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2717),
    [anon_sym_PIPE_EQ] = ACTIONS(2717),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2717),
    [anon_sym_AMP_EQ] = ACTIONS(2717),
    [anon_sym_PERCENT_EQ] = ACTIONS(2717),
    [anon_sym_GT_GT_EQ] = ACTIONS(2717),
    [anon_sym_LT_LT_EQ] = ACTIONS(2717),
    [anon_sym_CARET_EQ] = ACTIONS(2717),
    [anon_sym_QMARK] = ACTIONS(2717),
    [anon_sym_DOT_DOT] = ACTIONS(2721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2717),
    [anon_sym_and] = ACTIONS(2717),
    [anon_sym_or] = ACTIONS(2717),
    [anon_sym_PIPE_PIPE] = ACTIONS(2721),
    [anon_sym_AMP_AMP] = ACTIONS(2721),
    [anon_sym_LT_LT] = ACTIONS(2721),
    [anon_sym_GT_GT] = ACTIONS(2721),
    [anon_sym_EQ_EQ] = ACTIONS(2721),
    [anon_sym_BANG_EQ] = ACTIONS(2717),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2717),
    [anon_sym_LT_EQ_GT] = ACTIONS(2717),
    [anon_sym_EQ_TILDE] = ACTIONS(2717),
    [anon_sym_BANG_TILDE] = ACTIONS(2717),
    [anon_sym_LT_EQ] = ACTIONS(2721),
    [anon_sym_GT] = ACTIONS(2721),
    [anon_sym_GT_EQ] = ACTIONS(2717),
    [anon_sym_CARET] = ACTIONS(2721),
    [anon_sym_PLUS] = ACTIONS(2721),
    [anon_sym_SLASH] = ACTIONS(2721),
    [anon_sym_PERCENT] = ACTIONS(2721),
    [sym_comment] = ACTIONS(87),
  },
  [939] = {
    [sym_heredoc_body] = STATE(2558),
    [aux_sym_call_repeat1] = STATE(2558),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [ts_builtin_sym_end] = ACTIONS(1681),
    [anon_sym___END__] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [940] = {
    [sym_heredoc_body] = STATE(2558),
    [aux_sym_call_repeat1] = STATE(2558),
    [aux_sym_argument_list_repeat1] = STATE(2560),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [ts_builtin_sym_end] = ACTIONS(1681),
    [anon_sym___END__] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(4375),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [941] = {
    [sym__line_break] = ACTIONS(2717),
    [sym__heredoc_body_start] = ACTIONS(2717),
    [sym__binary_minus] = ACTIONS(2717),
    [sym__binary_star] = ACTIONS(2717),
    [ts_builtin_sym_end] = ACTIONS(2717),
    [anon_sym___END__] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(2717),
    [anon_sym_RBRACE] = ACTIONS(2717),
    [anon_sym_RPAREN] = ACTIONS(2717),
    [anon_sym_DOT] = ACTIONS(2721),
    [anon_sym_COMMA] = ACTIONS(2717),
    [anon_sym_PIPE] = ACTIONS(2721),
    [anon_sym_SEMI] = ACTIONS(2717),
    [anon_sym_STAR_STAR] = ACTIONS(2721),
    [anon_sym_AMP] = ACTIONS(2721),
    [anon_sym_EQ] = ACTIONS(2721),
    [anon_sym_LT] = ACTIONS(2721),
    [anon_sym_end] = ACTIONS(2717),
    [anon_sym_if] = ACTIONS(2717),
    [anon_sym_unless] = ACTIONS(2717),
    [anon_sym_while] = ACTIONS(2717),
    [anon_sym_until] = ACTIONS(2717),
    [anon_sym_rescue] = ACTIONS(2717),
    [anon_sym_do] = ACTIONS(2717),
    [anon_sym_when] = ACTIONS(2717),
    [anon_sym_elsif] = ACTIONS(2717),
    [anon_sym_else] = ACTIONS(2717),
    [anon_sym_then] = ACTIONS(2717),
    [anon_sym_ensure] = ACTIONS(2717),
    [anon_sym_EQ_GT] = ACTIONS(2717),
    [anon_sym_LBRACK] = ACTIONS(2717),
    [anon_sym_COLON_COLON2] = ACTIONS(2717),
    [anon_sym_AMP_DOT] = ACTIONS(2717),
    [anon_sym_PLUS_EQ] = ACTIONS(2717),
    [anon_sym_DASH_EQ] = ACTIONS(2717),
    [anon_sym_STAR_EQ] = ACTIONS(2717),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2717),
    [anon_sym_SLASH_EQ] = ACTIONS(2717),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2717),
    [anon_sym_PIPE_EQ] = ACTIONS(2717),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2717),
    [anon_sym_AMP_EQ] = ACTIONS(2717),
    [anon_sym_PERCENT_EQ] = ACTIONS(2717),
    [anon_sym_GT_GT_EQ] = ACTIONS(2717),
    [anon_sym_LT_LT_EQ] = ACTIONS(2717),
    [anon_sym_CARET_EQ] = ACTIONS(2717),
    [anon_sym_QMARK] = ACTIONS(2717),
    [anon_sym_DOT_DOT] = ACTIONS(2721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2717),
    [anon_sym_and] = ACTIONS(2717),
    [anon_sym_or] = ACTIONS(2717),
    [anon_sym_PIPE_PIPE] = ACTIONS(2721),
    [anon_sym_AMP_AMP] = ACTIONS(2721),
    [anon_sym_LT_LT] = ACTIONS(2721),
    [anon_sym_GT_GT] = ACTIONS(2721),
    [anon_sym_EQ_EQ] = ACTIONS(2721),
    [anon_sym_BANG_EQ] = ACTIONS(2717),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2717),
    [anon_sym_LT_EQ_GT] = ACTIONS(2717),
    [anon_sym_EQ_TILDE] = ACTIONS(2717),
    [anon_sym_BANG_TILDE] = ACTIONS(2717),
    [anon_sym_LT_EQ] = ACTIONS(2721),
    [anon_sym_GT] = ACTIONS(2721),
    [anon_sym_GT_EQ] = ACTIONS(2717),
    [anon_sym_CARET] = ACTIONS(2721),
    [anon_sym_PLUS] = ACTIONS(2721),
    [anon_sym_SLASH] = ACTIONS(2721),
    [anon_sym_PERCENT] = ACTIONS(2721),
    [sym_comment] = ACTIONS(87),
  },
  [942] = {
    [sym_string] = STATE(1587),
    [aux_sym_chained_string_repeat1] = STATE(1587),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(747),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(559),
    [anon_sym___END__] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(4377),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [943] = {
    [sym_interpolation] = STATE(2562),
    [aux_sym_heredoc_body_repeat1] = STATE(2562),
    [sym__heredoc_content] = ACTIONS(4379),
    [sym_heredoc_end] = ACTIONS(4381),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(4379),
  },
  [944] = {
    [sym_heredoc_body] = STATE(2563),
    [aux_sym_call_repeat1] = STATE(2563),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [ts_builtin_sym_end] = ACTIONS(4383),
    [anon_sym___END__] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [945] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(213),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym__argument] = STATE(2565),
    [sym_splat_argument] = STATE(2565),
    [sym_hash_splat_argument] = STATE(2565),
    [sym_block_argument] = STATE(2565),
    [sym_assignment] = STATE(213),
    [sym_operator_assignment] = STATE(213),
    [sym_conditional] = STATE(213),
    [sym_range] = STATE(213),
    [sym_binary] = STATE(213),
    [sym_unary] = STATE(213),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(221),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(2566),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2565),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(369),
    [sym__splat_star] = ACTIONS(371),
    [sym__unary_minus] = ACTIONS(373),
    [sym__identifier_hash_key] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(4389),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(383),
    [anon_sym_yield] = ACTIONS(385),
    [anon_sym_break] = ACTIONS(387),
    [anon_sym_next] = ACTIONS(389),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1575),
    [anon_sym_defined_QMARK] = ACTIONS(395),
    [anon_sym_not] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_TILDE] = ACTIONS(401),
    [sym_constant] = ACTIONS(403),
    [sym_identifier] = ACTIONS(403),
    [sym_instance_variable] = ACTIONS(405),
    [sym_class_variable] = ACTIONS(405),
    [sym_global_variable] = ACTIONS(405),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(407),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(407),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [946] = {
    [sym_heredoc_body] = STATE(2567),
    [aux_sym_call_repeat1] = STATE(2567),
    [aux_sym_argument_list_repeat1] = STATE(2568),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [ts_builtin_sym_end] = ACTIONS(4383),
    [anon_sym___END__] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(1687),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [947] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2569),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_splat_argument] = STATE(2571),
    [sym_assignment] = STATE(2569),
    [sym_operator_assignment] = STATE(2569),
    [sym_conditional] = STATE(2569),
    [sym_range] = STATE(2569),
    [sym_binary] = STATE(2569),
    [sym_unary] = STATE(2569),
    [sym_right_assignment_list] = STATE(2570),
    [sym__arg_or_splat_arg] = STATE(2571),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(880),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__splat_star] = ACTIONS(1583),
    [sym__unary_minus] = ACTIONS(373),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(383),
    [anon_sym_yield] = ACTIONS(385),
    [anon_sym_break] = ACTIONS(387),
    [anon_sym_next] = ACTIONS(389),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1575),
    [anon_sym_defined_QMARK] = ACTIONS(395),
    [anon_sym_not] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_TILDE] = ACTIONS(401),
    [sym_constant] = ACTIONS(407),
    [sym_identifier] = ACTIONS(407),
    [sym_instance_variable] = ACTIONS(405),
    [sym_class_variable] = ACTIONS(405),
    [sym_global_variable] = ACTIONS(405),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(407),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(407),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [948] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2572),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_assignment] = STATE(2572),
    [sym_operator_assignment] = STATE(2572),
    [sym_conditional] = STATE(2572),
    [sym_range] = STATE(2572),
    [sym_binary] = STATE(2572),
    [sym_unary] = STATE(2572),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(880),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(373),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(383),
    [anon_sym_yield] = ACTIONS(385),
    [anon_sym_break] = ACTIONS(387),
    [anon_sym_next] = ACTIONS(389),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1575),
    [anon_sym_defined_QMARK] = ACTIONS(395),
    [anon_sym_not] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_TILDE] = ACTIONS(401),
    [sym_constant] = ACTIONS(407),
    [sym_identifier] = ACTIONS(407),
    [sym_instance_variable] = ACTIONS(405),
    [sym_class_variable] = ACTIONS(405),
    [sym_global_variable] = ACTIONS(405),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(407),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(407),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [949] = {
    [sym_string] = STATE(2573),
    [aux_sym_chained_string_repeat1] = STATE(2573),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [ts_builtin_sym_end] = ACTIONS(2753),
    [anon_sym___END__] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_EQ_GT] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [950] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(1757),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [951] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2581),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2583),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2583),
    [sym_assignment] = STATE(2581),
    [sym_operator_assignment] = STATE(2581),
    [sym_conditional] = STATE(2581),
    [sym_range] = STATE(2581),
    [sym_binary] = STATE(2581),
    [sym_unary] = STATE(2581),
    [sym_left_assignment_list] = STATE(2582),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2583),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2583),
    [sym_false] = STATE(2583),
    [sym_nil] = STATE(2583),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2584),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4391),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4393),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_break] = ACTIONS(4397),
    [anon_sym_next] = ACTIONS(4399),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4401),
    [anon_sym_defined_QMARK] = ACTIONS(4403),
    [anon_sym_not] = ACTIONS(4405),
    [anon_sym_BANG] = ACTIONS(4407),
    [anon_sym_TILDE] = ACTIONS(4407),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [952] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2585),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2583),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2583),
    [sym_assignment] = STATE(2585),
    [sym_operator_assignment] = STATE(2585),
    [sym_conditional] = STATE(2585),
    [sym_range] = STATE(2585),
    [sym_binary] = STATE(2585),
    [sym_unary] = STATE(2585),
    [sym_left_assignment_list] = STATE(2582),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2583),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2583),
    [sym_false] = STATE(2583),
    [sym_nil] = STATE(2583),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2584),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4391),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4393),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_break] = ACTIONS(4397),
    [anon_sym_next] = ACTIONS(4399),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4401),
    [anon_sym_defined_QMARK] = ACTIONS(4403),
    [anon_sym_not] = ACTIONS(4405),
    [anon_sym_BANG] = ACTIONS(4407),
    [anon_sym_TILDE] = ACTIONS(4407),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [953] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2586),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_assignment] = STATE(2586),
    [sym_operator_assignment] = STATE(2586),
    [sym_conditional] = STATE(2586),
    [sym_range] = STATE(2586),
    [sym_binary] = STATE(2586),
    [sym_unary] = STATE(2586),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2587),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1713),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1717),
    [anon_sym_yield] = ACTIONS(1719),
    [anon_sym_break] = ACTIONS(1721),
    [anon_sym_next] = ACTIONS(1723),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4409),
    [anon_sym_defined_QMARK] = ACTIONS(1725),
    [anon_sym_not] = ACTIONS(1727),
    [anon_sym_BANG] = ACTIONS(1731),
    [anon_sym_TILDE] = ACTIONS(1731),
    [sym_constant] = ACTIONS(1737),
    [sym_identifier] = ACTIONS(1737),
    [sym_instance_variable] = ACTIONS(1735),
    [sym_class_variable] = ACTIONS(1735),
    [sym_global_variable] = ACTIONS(1735),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1737),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1737),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [954] = {
    [anon_sym_COLON] = ACTIONS(4411),
    [sym_comment] = ACTIONS(87),
  },
  [955] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2589),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2583),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2583),
    [sym_assignment] = STATE(2589),
    [sym_operator_assignment] = STATE(2589),
    [sym_conditional] = STATE(2589),
    [sym_range] = STATE(2589),
    [sym_binary] = STATE(2589),
    [sym_unary] = STATE(2589),
    [sym_left_assignment_list] = STATE(2582),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2583),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2583),
    [sym_false] = STATE(2583),
    [sym_nil] = STATE(2583),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2584),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4391),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4393),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_break] = ACTIONS(4397),
    [anon_sym_next] = ACTIONS(4399),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4401),
    [anon_sym_defined_QMARK] = ACTIONS(4403),
    [anon_sym_not] = ACTIONS(4405),
    [anon_sym_BANG] = ACTIONS(4407),
    [anon_sym_TILDE] = ACTIONS(4407),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [956] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2595),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(2596),
    [sym__argument] = STATE(2597),
    [sym_splat_argument] = STATE(2597),
    [sym_hash_splat_argument] = STATE(2597),
    [sym_block_argument] = STATE(2597),
    [sym_assignment] = STATE(2595),
    [sym_operator_assignment] = STATE(2595),
    [sym_conditional] = STATE(2595),
    [sym_range] = STATE(2595),
    [sym_binary] = STATE(2595),
    [sym_unary] = STATE(2595),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2598),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2597),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(4413),
    [sym__splat_star] = ACTIONS(4415),
    [sym__unary_minus] = ACTIONS(1713),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(4417),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1717),
    [anon_sym_yield] = ACTIONS(1719),
    [anon_sym_break] = ACTIONS(1721),
    [anon_sym_next] = ACTIONS(1723),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(377),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(1725),
    [anon_sym_not] = ACTIONS(1727),
    [anon_sym_BANG] = ACTIONS(1729),
    [anon_sym_TILDE] = ACTIONS(1731),
    [sym_constant] = ACTIONS(4419),
    [sym_identifier] = ACTIONS(4419),
    [sym_instance_variable] = ACTIONS(1735),
    [sym_class_variable] = ACTIONS(1735),
    [sym_global_variable] = ACTIONS(1735),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1737),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1737),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [957] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2595),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(2596),
    [sym__argument] = STATE(2597),
    [sym_splat_argument] = STATE(2597),
    [sym_hash_splat_argument] = STATE(2597),
    [sym_block_argument] = STATE(2597),
    [sym_assignment] = STATE(2595),
    [sym_operator_assignment] = STATE(2595),
    [sym_conditional] = STATE(2595),
    [sym_range] = STATE(2595),
    [sym_binary] = STATE(2595),
    [sym_unary] = STATE(2595),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2598),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2597),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(4413),
    [sym__splat_star] = ACTIONS(4415),
    [sym__unary_minus] = ACTIONS(1713),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(4417),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1717),
    [anon_sym_yield] = ACTIONS(1719),
    [anon_sym_break] = ACTIONS(1721),
    [anon_sym_next] = ACTIONS(1723),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(419),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(1725),
    [anon_sym_not] = ACTIONS(1727),
    [anon_sym_BANG] = ACTIONS(1729),
    [anon_sym_TILDE] = ACTIONS(1731),
    [sym_constant] = ACTIONS(4419),
    [sym_identifier] = ACTIONS(4419),
    [sym_instance_variable] = ACTIONS(1735),
    [sym_class_variable] = ACTIONS(1735),
    [sym_global_variable] = ACTIONS(1735),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1737),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1737),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [958] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2595),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(2596),
    [sym__argument] = STATE(2597),
    [sym_splat_argument] = STATE(2597),
    [sym_hash_splat_argument] = STATE(2597),
    [sym_block_argument] = STATE(2597),
    [sym_assignment] = STATE(2595),
    [sym_operator_assignment] = STATE(2595),
    [sym_conditional] = STATE(2595),
    [sym_range] = STATE(2595),
    [sym_binary] = STATE(2595),
    [sym_unary] = STATE(2595),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2598),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2597),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(4413),
    [sym__splat_star] = ACTIONS(4415),
    [sym__unary_minus] = ACTIONS(1713),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(4417),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1717),
    [anon_sym_yield] = ACTIONS(1719),
    [anon_sym_break] = ACTIONS(1721),
    [anon_sym_next] = ACTIONS(1723),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(423),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(1725),
    [anon_sym_not] = ACTIONS(1727),
    [anon_sym_BANG] = ACTIONS(1729),
    [anon_sym_TILDE] = ACTIONS(1731),
    [sym_constant] = ACTIONS(4419),
    [sym_identifier] = ACTIONS(4419),
    [sym_instance_variable] = ACTIONS(1735),
    [sym_class_variable] = ACTIONS(1735),
    [sym_global_variable] = ACTIONS(1735),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1737),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1737),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [959] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2595),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(2596),
    [sym__argument] = STATE(2597),
    [sym_splat_argument] = STATE(2597),
    [sym_hash_splat_argument] = STATE(2597),
    [sym_block_argument] = STATE(2597),
    [sym_assignment] = STATE(2595),
    [sym_operator_assignment] = STATE(2595),
    [sym_conditional] = STATE(2595),
    [sym_range] = STATE(2595),
    [sym_binary] = STATE(2595),
    [sym_unary] = STATE(2595),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2598),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2597),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(4413),
    [sym__splat_star] = ACTIONS(4415),
    [sym__unary_minus] = ACTIONS(1713),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(4417),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1717),
    [anon_sym_yield] = ACTIONS(1719),
    [anon_sym_break] = ACTIONS(1721),
    [anon_sym_next] = ACTIONS(1723),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(427),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(1725),
    [anon_sym_not] = ACTIONS(1727),
    [anon_sym_BANG] = ACTIONS(1729),
    [anon_sym_TILDE] = ACTIONS(1731),
    [sym_constant] = ACTIONS(4419),
    [sym_identifier] = ACTIONS(4419),
    [sym_instance_variable] = ACTIONS(1735),
    [sym_class_variable] = ACTIONS(1735),
    [sym_global_variable] = ACTIONS(1735),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1737),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1737),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [960] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2599),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_assignment] = STATE(2599),
    [sym_operator_assignment] = STATE(2599),
    [sym_conditional] = STATE(2599),
    [sym_range] = STATE(2599),
    [sym_binary] = STATE(2599),
    [sym_unary] = STATE(2599),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2587),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1713),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1717),
    [anon_sym_yield] = ACTIONS(1719),
    [anon_sym_break] = ACTIONS(1721),
    [anon_sym_next] = ACTIONS(1723),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4409),
    [anon_sym_defined_QMARK] = ACTIONS(1725),
    [anon_sym_not] = ACTIONS(1727),
    [anon_sym_BANG] = ACTIONS(1731),
    [anon_sym_TILDE] = ACTIONS(1731),
    [sym_constant] = ACTIONS(1737),
    [sym_identifier] = ACTIONS(1737),
    [sym_instance_variable] = ACTIONS(1735),
    [sym_class_variable] = ACTIONS(1735),
    [sym_global_variable] = ACTIONS(1735),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1737),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1737),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [961] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2587),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1713),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1717),
    [anon_sym_yield] = ACTIONS(1719),
    [anon_sym_break] = ACTIONS(1721),
    [anon_sym_next] = ACTIONS(1723),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4409),
    [anon_sym_defined_QMARK] = ACTIONS(1725),
    [anon_sym_not] = ACTIONS(1727),
    [anon_sym_BANG] = ACTIONS(1731),
    [anon_sym_TILDE] = ACTIONS(1731),
    [sym_constant] = ACTIONS(1737),
    [sym_identifier] = ACTIONS(1737),
    [sym_instance_variable] = ACTIONS(1735),
    [sym_class_variable] = ACTIONS(1735),
    [sym_global_variable] = ACTIONS(1735),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1737),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1737),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [962] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(4421),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_then] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [963] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(4423),
    [sym__binary_star] = ACTIONS(4425),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(4427),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(4425),
    [anon_sym_AMP] = ACTIONS(4429),
    [anon_sym_LT] = ACTIONS(4431),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_unless] = ACTIONS(1625),
    [anon_sym_while] = ACTIONS(1625),
    [anon_sym_until] = ACTIONS(1625),
    [anon_sym_rescue] = ACTIONS(1625),
    [anon_sym_then] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(4411),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(4433),
    [anon_sym_DOT_DOT] = ACTIONS(4435),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4437),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(4439),
    [anon_sym_AMP_AMP] = ACTIONS(4439),
    [anon_sym_LT_LT] = ACTIONS(4441),
    [anon_sym_GT_GT] = ACTIONS(4441),
    [anon_sym_EQ_EQ] = ACTIONS(4443),
    [anon_sym_BANG_EQ] = ACTIONS(4439),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4439),
    [anon_sym_LT_EQ_GT] = ACTIONS(4439),
    [anon_sym_EQ_TILDE] = ACTIONS(4439),
    [anon_sym_BANG_TILDE] = ACTIONS(4439),
    [anon_sym_LT_EQ] = ACTIONS(4431),
    [anon_sym_GT] = ACTIONS(4431),
    [anon_sym_GT_EQ] = ACTIONS(4445),
    [anon_sym_CARET] = ACTIONS(4447),
    [anon_sym_PLUS] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(4425),
    [anon_sym_PERCENT] = ACTIONS(4425),
    [sym_comment] = ACTIONS(87),
  },
  [964] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(2616),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_argument_list] = STATE(938),
    [sym__argument_list_with_parens] = STATE(2617),
    [sym__argument] = STATE(2618),
    [sym_splat_argument] = STATE(2618),
    [sym_hash_splat_argument] = STATE(2618),
    [sym_block_argument] = STATE(2618),
    [sym_do_block] = STATE(941),
    [sym_block] = STATE(941),
    [sym_assignment] = STATE(2616),
    [sym_operator_assignment] = STATE(2616),
    [sym_conditional] = STATE(2616),
    [sym_range] = STATE(2616),
    [sym_binary] = STATE(2616),
    [sym_unary] = STATE(2616),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2619),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(2618),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(743),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(4449),
    [sym__splat_star] = ACTIONS(4451),
    [sym__unary_minus] = ACTIONS(1787),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(1669),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1791),
    [anon_sym_yield] = ACTIONS(1793),
    [anon_sym_break] = ACTIONS(1795),
    [anon_sym_next] = ACTIONS(1797),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(769),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(769),
    [anon_sym_until] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(769),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(1671),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_then] = ACTIONS(769),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(1799),
    [anon_sym_not] = ACTIONS(1801),
    [anon_sym_BANG] = ACTIONS(1803),
    [anon_sym_TILDE] = ACTIONS(1805),
    [sym_constant] = ACTIONS(4455),
    [sym_identifier] = ACTIONS(4455),
    [sym_instance_variable] = ACTIONS(1809),
    [sym_class_variable] = ACTIONS(1809),
    [sym_global_variable] = ACTIONS(1809),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1811),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1811),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [965] = {
    [sym_heredoc_body] = STATE(2620),
    [aux_sym_call_repeat1] = STATE(2620),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_then] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [966] = {
    [sym_heredoc_body] = STATE(2620),
    [aux_sym_call_repeat1] = STATE(2620),
    [aux_sym_argument_list_repeat1] = STATE(2622),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(4457),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_then] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [967] = {
    [anon_sym_EQ] = ACTIONS(4459),
    [sym_comment] = ACTIONS(87),
  },
  [968] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(4461),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(4463),
    [anon_sym_DASH_EQ] = ACTIONS(4463),
    [anon_sym_STAR_EQ] = ACTIONS(4463),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4463),
    [anon_sym_SLASH_EQ] = ACTIONS(4463),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4463),
    [anon_sym_PIPE_EQ] = ACTIONS(4463),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4463),
    [anon_sym_AMP_EQ] = ACTIONS(4463),
    [anon_sym_PERCENT_EQ] = ACTIONS(4463),
    [anon_sym_GT_GT_EQ] = ACTIONS(4463),
    [anon_sym_LT_LT_EQ] = ACTIONS(4463),
    [anon_sym_CARET_EQ] = ACTIONS(4463),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [969] = {
    [sym_string] = STATE(2625),
    [aux_sym_chained_string_repeat1] = STATE(2625),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(4465),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [970] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(1755),
    [sym__binary_star] = ACTIONS(1757),
    [anon_sym_PIPE] = ACTIONS(1759),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(1757),
    [anon_sym_AMP] = ACTIONS(1761),
    [anon_sym_LT] = ACTIONS(1763),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(1765),
    [anon_sym_DOT_DOT] = ACTIONS(1767),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1769),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(1773),
    [anon_sym_AMP_AMP] = ACTIONS(1773),
    [anon_sym_LT_LT] = ACTIONS(1775),
    [anon_sym_GT_GT] = ACTIONS(1775),
    [anon_sym_EQ_EQ] = ACTIONS(1777),
    [anon_sym_BANG_EQ] = ACTIONS(1773),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1773),
    [anon_sym_LT_EQ_GT] = ACTIONS(1773),
    [anon_sym_EQ_TILDE] = ACTIONS(1773),
    [anon_sym_BANG_TILDE] = ACTIONS(1773),
    [anon_sym_LT_EQ] = ACTIONS(1763),
    [anon_sym_GT] = ACTIONS(1763),
    [anon_sym_GT_EQ] = ACTIONS(1779),
    [anon_sym_CARET] = ACTIONS(1781),
    [anon_sym_PLUS] = ACTIONS(1755),
    [anon_sym_SLASH] = ACTIONS(1757),
    [anon_sym_PERCENT] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
  },
  [971] = {
    [aux_sym_undef_repeat1] = STATE(2626),
    [sym__line_break] = ACTIONS(2251),
    [sym__heredoc_body_start] = ACTIONS(2251),
    [anon_sym_COMMA] = ACTIONS(2253),
    [anon_sym_SEMI] = ACTIONS(2251),
    [anon_sym_if] = ACTIONS(2251),
    [anon_sym_unless] = ACTIONS(2251),
    [anon_sym_while] = ACTIONS(2251),
    [anon_sym_until] = ACTIONS(2251),
    [anon_sym_rescue] = ACTIONS(2251),
    [anon_sym_then] = ACTIONS(2251),
    [sym_comment] = ACTIONS(87),
  },
  [972] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2627),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(2627),
    [sym_operator_assignment] = STATE(2627),
    [sym_conditional] = STATE(2627),
    [sym_range] = STATE(2627),
    [sym_binary] = STATE(2627),
    [sym_unary] = STATE(2627),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(429),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_yield] = ACTIONS(433),
    [anon_sym_break] = ACTIONS(435),
    [anon_sym_next] = ACTIONS(437),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(439),
    [anon_sym_defined_QMARK] = ACTIONS(441),
    [anon_sym_not] = ACTIONS(443),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [973] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2628),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(2628),
    [sym_operator_assignment] = STATE(2628),
    [sym_conditional] = STATE(2628),
    [sym_range] = STATE(2628),
    [sym_binary] = STATE(2628),
    [sym_unary] = STATE(2628),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(429),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_yield] = ACTIONS(433),
    [anon_sym_break] = ACTIONS(435),
    [anon_sym_next] = ACTIONS(437),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(439),
    [anon_sym_defined_QMARK] = ACTIONS(441),
    [anon_sym_not] = ACTIONS(443),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [974] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2629),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(2629),
    [sym_operator_assignment] = STATE(2629),
    [sym_conditional] = STATE(2629),
    [sym_range] = STATE(2629),
    [sym_binary] = STATE(2629),
    [sym_unary] = STATE(2629),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(429),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_yield] = ACTIONS(433),
    [anon_sym_break] = ACTIONS(435),
    [anon_sym_next] = ACTIONS(437),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(439),
    [anon_sym_defined_QMARK] = ACTIONS(441),
    [anon_sym_not] = ACTIONS(443),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [975] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2630),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(2630),
    [sym_operator_assignment] = STATE(2630),
    [sym_conditional] = STATE(2630),
    [sym_range] = STATE(2630),
    [sym_binary] = STATE(2630),
    [sym_unary] = STATE(2630),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(429),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_yield] = ACTIONS(433),
    [anon_sym_break] = ACTIONS(435),
    [anon_sym_next] = ACTIONS(437),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(439),
    [anon_sym_defined_QMARK] = ACTIONS(441),
    [anon_sym_not] = ACTIONS(443),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [976] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2631),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(2631),
    [sym_operator_assignment] = STATE(2631),
    [sym_conditional] = STATE(2631),
    [sym_range] = STATE(2631),
    [sym_binary] = STATE(2631),
    [sym_unary] = STATE(2631),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(429),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_yield] = ACTIONS(433),
    [anon_sym_break] = ACTIONS(435),
    [anon_sym_next] = ACTIONS(437),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(439),
    [anon_sym_defined_QMARK] = ACTIONS(441),
    [anon_sym_not] = ACTIONS(443),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [977] = {
    [sym__statements] = STATE(2640),
    [sym_begin_block] = STATE(2641),
    [sym_end_block] = STATE(2641),
    [sym__statement] = STATE(2641),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(2641),
    [sym_unless_modifier] = STATE(2641),
    [sym_while_modifier] = STATE(2641),
    [sym_until_modifier] = STATE(2641),
    [sym_rescue_modifier] = STATE(2641),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2642),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2645),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(2645),
    [sym_assignment] = STATE(2642),
    [sym_operator_assignment] = STATE(2642),
    [sym_conditional] = STATE(2642),
    [sym_range] = STATE(2642),
    [sym_binary] = STATE(2642),
    [sym_unary] = STATE(2642),
    [sym_left_assignment_list] = STATE(2644),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2645),
    [sym__variable] = STATE(2643),
    [sym_undef] = STATE(2641),
    [sym_alias] = STATE(2641),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2645),
    [sym_false] = STATE(2645),
    [sym_nil] = STATE(2645),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2646),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(2647),
    [aux_sym__statements_repeat1] = STATE(2647),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4467),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(4469),
    [anon_sym_return] = ACTIONS(4471),
    [anon_sym_yield] = ACTIONS(4473),
    [anon_sym_break] = ACTIONS(4475),
    [anon_sym_next] = ACTIONS(4477),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(4469),
    [anon_sym_else] = ACTIONS(4469),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4479),
    [anon_sym_defined_QMARK] = ACTIONS(4481),
    [anon_sym_not] = ACTIONS(4483),
    [anon_sym_BANG] = ACTIONS(4485),
    [anon_sym_TILDE] = ACTIONS(4485),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [anon_sym_undef] = ACTIONS(4491),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [978] = {
    [sym_elsif] = STATE(2650),
    [sym_else] = STATE(2650),
    [anon_sym_end] = ACTIONS(4493),
    [anon_sym_elsif] = ACTIONS(4495),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [979] = {
    [sym__statements] = STATE(2640),
    [sym_begin_block] = STATE(2641),
    [sym_end_block] = STATE(2641),
    [sym__statement] = STATE(2641),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(2641),
    [sym_unless_modifier] = STATE(2641),
    [sym_while_modifier] = STATE(2641),
    [sym_until_modifier] = STATE(2641),
    [sym_rescue_modifier] = STATE(2641),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_elsif] = STATE(2650),
    [sym_else] = STATE(2650),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2642),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2645),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(2645),
    [sym_assignment] = STATE(2642),
    [sym_operator_assignment] = STATE(2642),
    [sym_conditional] = STATE(2642),
    [sym_range] = STATE(2642),
    [sym_binary] = STATE(2642),
    [sym_unary] = STATE(2642),
    [sym_left_assignment_list] = STATE(2644),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2645),
    [sym__variable] = STATE(2643),
    [sym_undef] = STATE(2641),
    [sym_alias] = STATE(2641),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2645),
    [sym_false] = STATE(2645),
    [sym_nil] = STATE(2645),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2646),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(2647),
    [aux_sym__statements_repeat1] = STATE(2647),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4467),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(4497),
    [anon_sym_return] = ACTIONS(4471),
    [anon_sym_yield] = ACTIONS(4473),
    [anon_sym_break] = ACTIONS(4475),
    [anon_sym_next] = ACTIONS(4477),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(4499),
    [anon_sym_else] = ACTIONS(4501),
    [anon_sym_then] = ACTIONS(4503),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4479),
    [anon_sym_defined_QMARK] = ACTIONS(4481),
    [anon_sym_not] = ACTIONS(4483),
    [anon_sym_BANG] = ACTIONS(4485),
    [anon_sym_TILDE] = ACTIONS(4485),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [anon_sym_undef] = ACTIONS(4491),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [980] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2652),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(2652),
    [sym_operator_assignment] = STATE(2652),
    [sym_conditional] = STATE(2652),
    [sym_range] = STATE(2652),
    [sym_binary] = STATE(2652),
    [sym_unary] = STATE(2652),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(429),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_yield] = ACTIONS(433),
    [anon_sym_break] = ACTIONS(435),
    [anon_sym_next] = ACTIONS(437),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(439),
    [anon_sym_defined_QMARK] = ACTIONS(441),
    [anon_sym_not] = ACTIONS(443),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [981] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2653),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(2653),
    [sym_operator_assignment] = STATE(2653),
    [sym_conditional] = STATE(2653),
    [sym_range] = STATE(2653),
    [sym_binary] = STATE(2653),
    [sym_unary] = STATE(2653),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(429),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_yield] = ACTIONS(433),
    [anon_sym_break] = ACTIONS(435),
    [anon_sym_next] = ACTIONS(437),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(439),
    [anon_sym_defined_QMARK] = ACTIONS(441),
    [anon_sym_not] = ACTIONS(443),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [982] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2654),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(2654),
    [sym_operator_assignment] = STATE(2654),
    [sym_conditional] = STATE(2654),
    [sym_range] = STATE(2654),
    [sym_binary] = STATE(2654),
    [sym_unary] = STATE(2654),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(429),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_yield] = ACTIONS(433),
    [anon_sym_break] = ACTIONS(435),
    [anon_sym_next] = ACTIONS(437),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(439),
    [anon_sym_defined_QMARK] = ACTIONS(441),
    [anon_sym_not] = ACTIONS(443),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [983] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2655),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(2655),
    [sym_operator_assignment] = STATE(2655),
    [sym_conditional] = STATE(2655),
    [sym_range] = STATE(2655),
    [sym_binary] = STATE(2655),
    [sym_unary] = STATE(2655),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(429),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_yield] = ACTIONS(433),
    [anon_sym_break] = ACTIONS(435),
    [anon_sym_next] = ACTIONS(437),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(439),
    [anon_sym_defined_QMARK] = ACTIONS(441),
    [anon_sym_not] = ACTIONS(443),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [984] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2656),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(2656),
    [sym_operator_assignment] = STATE(2656),
    [sym_conditional] = STATE(2656),
    [sym_range] = STATE(2656),
    [sym_binary] = STATE(2656),
    [sym_unary] = STATE(2656),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(429),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_yield] = ACTIONS(433),
    [anon_sym_break] = ACTIONS(435),
    [anon_sym_next] = ACTIONS(437),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(439),
    [anon_sym_defined_QMARK] = ACTIONS(441),
    [anon_sym_not] = ACTIONS(443),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [985] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(2657),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(2657),
    [sym_operator_assignment] = STATE(2657),
    [sym_conditional] = STATE(2657),
    [sym_range] = STATE(2657),
    [sym_binary] = STATE(2657),
    [sym_unary] = STATE(2657),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [986] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2658),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(2658),
    [sym_operator_assignment] = STATE(2658),
    [sym_conditional] = STATE(2658),
    [sym_range] = STATE(2658),
    [sym_binary] = STATE(2658),
    [sym_unary] = STATE(2658),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(429),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_yield] = ACTIONS(433),
    [anon_sym_break] = ACTIONS(435),
    [anon_sym_next] = ACTIONS(437),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(439),
    [anon_sym_defined_QMARK] = ACTIONS(441),
    [anon_sym_not] = ACTIONS(443),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [987] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2659),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(2659),
    [sym_operator_assignment] = STATE(2659),
    [sym_conditional] = STATE(2659),
    [sym_range] = STATE(2659),
    [sym_binary] = STATE(2659),
    [sym_unary] = STATE(2659),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(429),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_yield] = ACTIONS(433),
    [anon_sym_break] = ACTIONS(435),
    [anon_sym_next] = ACTIONS(437),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(439),
    [anon_sym_defined_QMARK] = ACTIONS(441),
    [anon_sym_not] = ACTIONS(443),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [988] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2660),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(2660),
    [sym_operator_assignment] = STATE(2660),
    [sym_conditional] = STATE(2660),
    [sym_range] = STATE(2660),
    [sym_binary] = STATE(2660),
    [sym_unary] = STATE(2660),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(429),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_yield] = ACTIONS(433),
    [anon_sym_break] = ACTIONS(435),
    [anon_sym_next] = ACTIONS(437),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(439),
    [anon_sym_defined_QMARK] = ACTIONS(441),
    [anon_sym_not] = ACTIONS(443),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [989] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2661),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(2661),
    [sym_operator_assignment] = STATE(2661),
    [sym_conditional] = STATE(2661),
    [sym_range] = STATE(2661),
    [sym_binary] = STATE(2661),
    [sym_unary] = STATE(2661),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(429),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_yield] = ACTIONS(433),
    [anon_sym_break] = ACTIONS(435),
    [anon_sym_next] = ACTIONS(437),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(439),
    [anon_sym_defined_QMARK] = ACTIONS(441),
    [anon_sym_not] = ACTIONS(443),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [990] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(2669),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2672),
    [sym_scope_resolution] = STATE(2670),
    [sym_call] = STATE(2670),
    [sym_method_call] = STATE(2672),
    [sym_assignment] = STATE(2669),
    [sym_operator_assignment] = STATE(2669),
    [sym_conditional] = STATE(2669),
    [sym_range] = STATE(2669),
    [sym_binary] = STATE(2669),
    [sym_unary] = STATE(2669),
    [sym_left_assignment_list] = STATE(2671),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2672),
    [sym__variable] = STATE(2670),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2672),
    [sym_false] = STATE(2672),
    [sym_nil] = STATE(2672),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2673),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(4505),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(4507),
    [anon_sym_yield] = ACTIONS(4509),
    [anon_sym_break] = ACTIONS(4511),
    [anon_sym_next] = ACTIONS(4513),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(4515),
    [anon_sym_defined_QMARK] = ACTIONS(4517),
    [anon_sym_not] = ACTIONS(4519),
    [anon_sym_BANG] = ACTIONS(4521),
    [anon_sym_TILDE] = ACTIONS(4521),
    [sym_constant] = ACTIONS(4523),
    [sym_identifier] = ACTIONS(4523),
    [sym_instance_variable] = ACTIONS(4525),
    [sym_class_variable] = ACTIONS(4525),
    [sym_global_variable] = ACTIONS(4525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(4523),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4523),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [991] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(2674),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2672),
    [sym_scope_resolution] = STATE(2670),
    [sym_call] = STATE(2670),
    [sym_method_call] = STATE(2672),
    [sym_assignment] = STATE(2674),
    [sym_operator_assignment] = STATE(2674),
    [sym_conditional] = STATE(2674),
    [sym_range] = STATE(2674),
    [sym_binary] = STATE(2674),
    [sym_unary] = STATE(2674),
    [sym_left_assignment_list] = STATE(2671),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2672),
    [sym__variable] = STATE(2670),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2672),
    [sym_false] = STATE(2672),
    [sym_nil] = STATE(2672),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2673),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(4505),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(4507),
    [anon_sym_yield] = ACTIONS(4509),
    [anon_sym_break] = ACTIONS(4511),
    [anon_sym_next] = ACTIONS(4513),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(4515),
    [anon_sym_defined_QMARK] = ACTIONS(4517),
    [anon_sym_not] = ACTIONS(4519),
    [anon_sym_BANG] = ACTIONS(4521),
    [anon_sym_TILDE] = ACTIONS(4521),
    [sym_constant] = ACTIONS(4523),
    [sym_identifier] = ACTIONS(4523),
    [sym_instance_variable] = ACTIONS(4525),
    [sym_class_variable] = ACTIONS(4525),
    [sym_global_variable] = ACTIONS(4525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(4523),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4523),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [992] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(2675),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_assignment] = STATE(2675),
    [sym_operator_assignment] = STATE(2675),
    [sym_conditional] = STATE(2675),
    [sym_range] = STATE(2675),
    [sym_binary] = STATE(2675),
    [sym_unary] = STATE(2675),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2676),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1787),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1791),
    [anon_sym_yield] = ACTIONS(1793),
    [anon_sym_break] = ACTIONS(1795),
    [anon_sym_next] = ACTIONS(1797),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(4527),
    [anon_sym_defined_QMARK] = ACTIONS(1799),
    [anon_sym_not] = ACTIONS(1801),
    [anon_sym_BANG] = ACTIONS(1805),
    [anon_sym_TILDE] = ACTIONS(1805),
    [sym_constant] = ACTIONS(1811),
    [sym_identifier] = ACTIONS(1811),
    [sym_instance_variable] = ACTIONS(1809),
    [sym_class_variable] = ACTIONS(1809),
    [sym_global_variable] = ACTIONS(1809),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1811),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1811),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [993] = {
    [anon_sym_COLON] = ACTIONS(4529),
    [sym_comment] = ACTIONS(87),
  },
  [994] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(2678),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2672),
    [sym_scope_resolution] = STATE(2670),
    [sym_call] = STATE(2670),
    [sym_method_call] = STATE(2672),
    [sym_assignment] = STATE(2678),
    [sym_operator_assignment] = STATE(2678),
    [sym_conditional] = STATE(2678),
    [sym_range] = STATE(2678),
    [sym_binary] = STATE(2678),
    [sym_unary] = STATE(2678),
    [sym_left_assignment_list] = STATE(2671),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2672),
    [sym__variable] = STATE(2670),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2672),
    [sym_false] = STATE(2672),
    [sym_nil] = STATE(2672),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2673),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(4505),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(4507),
    [anon_sym_yield] = ACTIONS(4509),
    [anon_sym_break] = ACTIONS(4511),
    [anon_sym_next] = ACTIONS(4513),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(4515),
    [anon_sym_defined_QMARK] = ACTIONS(4517),
    [anon_sym_not] = ACTIONS(4519),
    [anon_sym_BANG] = ACTIONS(4521),
    [anon_sym_TILDE] = ACTIONS(4521),
    [sym_constant] = ACTIONS(4523),
    [sym_identifier] = ACTIONS(4523),
    [sym_instance_variable] = ACTIONS(4525),
    [sym_class_variable] = ACTIONS(4525),
    [sym_global_variable] = ACTIONS(4525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(4523),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4523),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [995] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(2616),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_argument_list] = STATE(1535),
    [sym__argument_list_with_parens] = STATE(2617),
    [sym__argument] = STATE(2618),
    [sym_splat_argument] = STATE(2618),
    [sym_hash_splat_argument] = STATE(2618),
    [sym_block_argument] = STATE(2618),
    [sym_assignment] = STATE(2616),
    [sym_operator_assignment] = STATE(2616),
    [sym_conditional] = STATE(2616),
    [sym_range] = STATE(2616),
    [sym_binary] = STATE(2616),
    [sym_unary] = STATE(2616),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2619),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(2618),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(4449),
    [sym__splat_star] = ACTIONS(4451),
    [sym__unary_minus] = ACTIONS(1787),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1791),
    [anon_sym_yield] = ACTIONS(1793),
    [anon_sym_break] = ACTIONS(1795),
    [anon_sym_next] = ACTIONS(1797),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_then] = ACTIONS(377),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(365),
    [anon_sym_DASH_EQ] = ACTIONS(365),
    [anon_sym_STAR_EQ] = ACTIONS(365),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(365),
    [anon_sym_SLASH_EQ] = ACTIONS(365),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(365),
    [anon_sym_PIPE_EQ] = ACTIONS(365),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(365),
    [anon_sym_AMP_EQ] = ACTIONS(365),
    [anon_sym_PERCENT_EQ] = ACTIONS(365),
    [anon_sym_GT_GT_EQ] = ACTIONS(365),
    [anon_sym_LT_LT_EQ] = ACTIONS(365),
    [anon_sym_CARET_EQ] = ACTIONS(365),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_PERCENT] = ACTIONS(377),
    [anon_sym_defined_QMARK] = ACTIONS(1799),
    [anon_sym_not] = ACTIONS(1801),
    [anon_sym_BANG] = ACTIONS(1803),
    [anon_sym_TILDE] = ACTIONS(1805),
    [sym_constant] = ACTIONS(4455),
    [sym_identifier] = ACTIONS(4455),
    [sym_instance_variable] = ACTIONS(1809),
    [sym_class_variable] = ACTIONS(1809),
    [sym_global_variable] = ACTIONS(1809),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1811),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1811),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [996] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(2616),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_argument_list] = STATE(1536),
    [sym__argument_list_with_parens] = STATE(2617),
    [sym__argument] = STATE(2618),
    [sym_splat_argument] = STATE(2618),
    [sym_hash_splat_argument] = STATE(2618),
    [sym_block_argument] = STATE(2618),
    [sym_assignment] = STATE(2616),
    [sym_operator_assignment] = STATE(2616),
    [sym_conditional] = STATE(2616),
    [sym_range] = STATE(2616),
    [sym_binary] = STATE(2616),
    [sym_unary] = STATE(2616),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2619),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(2618),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(4449),
    [sym__splat_star] = ACTIONS(4451),
    [sym__unary_minus] = ACTIONS(1787),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_EQ] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1791),
    [anon_sym_yield] = ACTIONS(1793),
    [anon_sym_break] = ACTIONS(1795),
    [anon_sym_next] = ACTIONS(1797),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_then] = ACTIONS(419),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(417),
    [anon_sym_DASH_EQ] = ACTIONS(417),
    [anon_sym_STAR_EQ] = ACTIONS(417),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(417),
    [anon_sym_SLASH_EQ] = ACTIONS(417),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(417),
    [anon_sym_PIPE_EQ] = ACTIONS(417),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(417),
    [anon_sym_AMP_EQ] = ACTIONS(417),
    [anon_sym_PERCENT_EQ] = ACTIONS(417),
    [anon_sym_GT_GT_EQ] = ACTIONS(417),
    [anon_sym_LT_LT_EQ] = ACTIONS(417),
    [anon_sym_CARET_EQ] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(1799),
    [anon_sym_not] = ACTIONS(1801),
    [anon_sym_BANG] = ACTIONS(1803),
    [anon_sym_TILDE] = ACTIONS(1805),
    [sym_constant] = ACTIONS(4455),
    [sym_identifier] = ACTIONS(4455),
    [sym_instance_variable] = ACTIONS(1809),
    [sym_class_variable] = ACTIONS(1809),
    [sym_global_variable] = ACTIONS(1809),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1811),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1811),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [997] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(2616),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_argument_list] = STATE(1537),
    [sym__argument_list_with_parens] = STATE(2617),
    [sym__argument] = STATE(2618),
    [sym_splat_argument] = STATE(2618),
    [sym_hash_splat_argument] = STATE(2618),
    [sym_block_argument] = STATE(2618),
    [sym_assignment] = STATE(2616),
    [sym_operator_assignment] = STATE(2616),
    [sym_conditional] = STATE(2616),
    [sym_range] = STATE(2616),
    [sym_binary] = STATE(2616),
    [sym_unary] = STATE(2616),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2619),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(2618),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(4449),
    [sym__splat_star] = ACTIONS(4451),
    [sym__unary_minus] = ACTIONS(1787),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_EQ] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1791),
    [anon_sym_yield] = ACTIONS(1793),
    [anon_sym_break] = ACTIONS(1795),
    [anon_sym_next] = ACTIONS(1797),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_then] = ACTIONS(423),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(421),
    [anon_sym_DASH_EQ] = ACTIONS(421),
    [anon_sym_STAR_EQ] = ACTIONS(421),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(421),
    [anon_sym_SLASH_EQ] = ACTIONS(421),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(421),
    [anon_sym_PIPE_EQ] = ACTIONS(421),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(421),
    [anon_sym_AMP_EQ] = ACTIONS(421),
    [anon_sym_PERCENT_EQ] = ACTIONS(421),
    [anon_sym_GT_GT_EQ] = ACTIONS(421),
    [anon_sym_LT_LT_EQ] = ACTIONS(421),
    [anon_sym_CARET_EQ] = ACTIONS(421),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(1799),
    [anon_sym_not] = ACTIONS(1801),
    [anon_sym_BANG] = ACTIONS(1803),
    [anon_sym_TILDE] = ACTIONS(1805),
    [sym_constant] = ACTIONS(4455),
    [sym_identifier] = ACTIONS(4455),
    [sym_instance_variable] = ACTIONS(1809),
    [sym_class_variable] = ACTIONS(1809),
    [sym_global_variable] = ACTIONS(1809),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1811),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1811),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [998] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(2616),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_argument_list] = STATE(1538),
    [sym__argument_list_with_parens] = STATE(2617),
    [sym__argument] = STATE(2618),
    [sym_splat_argument] = STATE(2618),
    [sym_hash_splat_argument] = STATE(2618),
    [sym_block_argument] = STATE(2618),
    [sym_assignment] = STATE(2616),
    [sym_operator_assignment] = STATE(2616),
    [sym_conditional] = STATE(2616),
    [sym_range] = STATE(2616),
    [sym_binary] = STATE(2616),
    [sym_unary] = STATE(2616),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2619),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(2618),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(4449),
    [sym__splat_star] = ACTIONS(4451),
    [sym__unary_minus] = ACTIONS(1787),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(427),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1791),
    [anon_sym_yield] = ACTIONS(1793),
    [anon_sym_break] = ACTIONS(1795),
    [anon_sym_next] = ACTIONS(1797),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_then] = ACTIONS(427),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(425),
    [anon_sym_DASH_EQ] = ACTIONS(425),
    [anon_sym_STAR_EQ] = ACTIONS(425),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(425),
    [anon_sym_SLASH_EQ] = ACTIONS(425),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(425),
    [anon_sym_PIPE_EQ] = ACTIONS(425),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(425),
    [anon_sym_AMP_EQ] = ACTIONS(425),
    [anon_sym_PERCENT_EQ] = ACTIONS(425),
    [anon_sym_GT_GT_EQ] = ACTIONS(425),
    [anon_sym_LT_LT_EQ] = ACTIONS(425),
    [anon_sym_CARET_EQ] = ACTIONS(425),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(1799),
    [anon_sym_not] = ACTIONS(1801),
    [anon_sym_BANG] = ACTIONS(1803),
    [anon_sym_TILDE] = ACTIONS(1805),
    [sym_constant] = ACTIONS(4455),
    [sym_identifier] = ACTIONS(4455),
    [sym_instance_variable] = ACTIONS(1809),
    [sym_class_variable] = ACTIONS(1809),
    [sym_global_variable] = ACTIONS(1809),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1811),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1811),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [999] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(2679),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_assignment] = STATE(2679),
    [sym_operator_assignment] = STATE(2679),
    [sym_conditional] = STATE(2679),
    [sym_range] = STATE(2679),
    [sym_binary] = STATE(2679),
    [sym_unary] = STATE(2679),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2676),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1787),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1791),
    [anon_sym_yield] = ACTIONS(1793),
    [anon_sym_break] = ACTIONS(1795),
    [anon_sym_next] = ACTIONS(1797),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(4527),
    [anon_sym_defined_QMARK] = ACTIONS(1799),
    [anon_sym_not] = ACTIONS(1801),
    [anon_sym_BANG] = ACTIONS(1805),
    [anon_sym_TILDE] = ACTIONS(1805),
    [sym_constant] = ACTIONS(1811),
    [sym_identifier] = ACTIONS(1811),
    [sym_instance_variable] = ACTIONS(1809),
    [sym_class_variable] = ACTIONS(1809),
    [sym_global_variable] = ACTIONS(1809),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1811),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1811),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [1000] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(1559),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_assignment] = STATE(1559),
    [sym_operator_assignment] = STATE(1559),
    [sym_conditional] = STATE(1559),
    [sym_range] = STATE(1559),
    [sym_binary] = STATE(1559),
    [sym_unary] = STATE(1559),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2676),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1787),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1791),
    [anon_sym_yield] = ACTIONS(1793),
    [anon_sym_break] = ACTIONS(1795),
    [anon_sym_next] = ACTIONS(1797),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(4527),
    [anon_sym_defined_QMARK] = ACTIONS(1799),
    [anon_sym_not] = ACTIONS(1801),
    [anon_sym_BANG] = ACTIONS(1805),
    [anon_sym_TILDE] = ACTIONS(1805),
    [sym_constant] = ACTIONS(1811),
    [sym_identifier] = ACTIONS(1811),
    [sym_instance_variable] = ACTIONS(1809),
    [sym_class_variable] = ACTIONS(1809),
    [sym_global_variable] = ACTIONS(1809),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1811),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1811),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [1001] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(4531),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_then] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [1002] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(4533),
    [sym__binary_star] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(4537),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(4539),
    [anon_sym_AMP] = ACTIONS(4541),
    [anon_sym_EQ] = ACTIONS(1631),
    [anon_sym_LT] = ACTIONS(4543),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_unless] = ACTIONS(1625),
    [anon_sym_while] = ACTIONS(1625),
    [anon_sym_until] = ACTIONS(1625),
    [anon_sym_rescue] = ACTIONS(1625),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_then] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(4529),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_PLUS_EQ] = ACTIONS(1625),
    [anon_sym_DASH_EQ] = ACTIONS(1625),
    [anon_sym_STAR_EQ] = ACTIONS(1625),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1625),
    [anon_sym_SLASH_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1625),
    [anon_sym_AMP_EQ] = ACTIONS(1625),
    [anon_sym_PERCENT_EQ] = ACTIONS(1625),
    [anon_sym_GT_GT_EQ] = ACTIONS(1625),
    [anon_sym_LT_LT_EQ] = ACTIONS(1625),
    [anon_sym_CARET_EQ] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(4545),
    [anon_sym_DOT_DOT] = ACTIONS(4547),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4549),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(4551),
    [anon_sym_AMP_AMP] = ACTIONS(4551),
    [anon_sym_LT_LT] = ACTIONS(4553),
    [anon_sym_GT_GT] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4551),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4555),
    [anon_sym_LT_EQ_GT] = ACTIONS(4555),
    [anon_sym_EQ_TILDE] = ACTIONS(4555),
    [anon_sym_BANG_TILDE] = ACTIONS(4555),
    [anon_sym_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT] = ACTIONS(4543),
    [anon_sym_GT_EQ] = ACTIONS(4557),
    [anon_sym_CARET] = ACTIONS(4537),
    [anon_sym_PLUS] = ACTIONS(4559),
    [anon_sym_SLASH] = ACTIONS(4539),
    [anon_sym_PERCENT] = ACTIONS(4539),
    [sym_comment] = ACTIONS(87),
  },
  [1003] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(2616),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_argument_list] = STATE(1578),
    [sym__argument_list_with_parens] = STATE(2617),
    [sym__argument] = STATE(2618),
    [sym_splat_argument] = STATE(2618),
    [sym_hash_splat_argument] = STATE(2618),
    [sym_block_argument] = STATE(2618),
    [sym_do_block] = STATE(941),
    [sym_block] = STATE(941),
    [sym_assignment] = STATE(2616),
    [sym_operator_assignment] = STATE(2616),
    [sym_conditional] = STATE(2616),
    [sym_range] = STATE(2616),
    [sym_binary] = STATE(2616),
    [sym_unary] = STATE(2616),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2619),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(2618),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(743),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(4449),
    [sym__splat_star] = ACTIONS(4451),
    [sym__unary_minus] = ACTIONS(1787),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(2715),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1791),
    [anon_sym_yield] = ACTIONS(1793),
    [anon_sym_break] = ACTIONS(1795),
    [anon_sym_next] = ACTIONS(1797),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(769),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(769),
    [anon_sym_until] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(769),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(769),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_then] = ACTIONS(769),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(1799),
    [anon_sym_not] = ACTIONS(1801),
    [anon_sym_BANG] = ACTIONS(1803),
    [anon_sym_TILDE] = ACTIONS(1805),
    [sym_constant] = ACTIONS(4455),
    [sym_identifier] = ACTIONS(4455),
    [sym_instance_variable] = ACTIONS(1809),
    [sym_class_variable] = ACTIONS(1809),
    [sym_global_variable] = ACTIONS(1809),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1811),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1811),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [1004] = {
    [sym_heredoc_body] = STATE(2691),
    [aux_sym_call_repeat1] = STATE(2691),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_then] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [1005] = {
    [sym_heredoc_body] = STATE(2691),
    [aux_sym_call_repeat1] = STATE(2691),
    [aux_sym_argument_list_repeat1] = STATE(2693),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(4561),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_then] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [1006] = {
    [anon_sym_EQ] = ACTIONS(4563),
    [sym_comment] = ACTIONS(87),
  },
  [1007] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(4565),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(4567),
    [anon_sym_DASH_EQ] = ACTIONS(4567),
    [anon_sym_STAR_EQ] = ACTIONS(4567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4567),
    [anon_sym_SLASH_EQ] = ACTIONS(4567),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4567),
    [anon_sym_PIPE_EQ] = ACTIONS(4567),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4567),
    [anon_sym_AMP_EQ] = ACTIONS(4567),
    [anon_sym_PERCENT_EQ] = ACTIONS(4567),
    [anon_sym_GT_GT_EQ] = ACTIONS(4567),
    [anon_sym_LT_LT_EQ] = ACTIONS(4567),
    [anon_sym_CARET_EQ] = ACTIONS(4567),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1008] = {
    [sym_string] = STATE(2696),
    [aux_sym_chained_string_repeat1] = STATE(2696),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(747),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(4569),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1009] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2701),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2704),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2704),
    [sym_splat_argument] = STATE(2702),
    [sym_assignment] = STATE(2701),
    [sym_operator_assignment] = STATE(2701),
    [sym_conditional] = STATE(2701),
    [sym_range] = STATE(2701),
    [sym_binary] = STATE(2701),
    [sym_unary] = STATE(2701),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(2702),
    [sym_left_assignment_list] = STATE(2703),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2704),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2704),
    [sym_false] = STATE(2704),
    [sym_nil] = STATE(2704),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2584),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(4571),
    [sym__unary_minus] = ACTIONS(4573),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4393),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_break] = ACTIONS(4397),
    [anon_sym_next] = ACTIONS(4399),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4575),
    [anon_sym_defined_QMARK] = ACTIONS(4577),
    [anon_sym_not] = ACTIONS(4579),
    [anon_sym_BANG] = ACTIONS(4581),
    [anon_sym_TILDE] = ACTIONS(4581),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1010] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2705),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(2705),
    [sym_operator_assignment] = STATE(2705),
    [sym_conditional] = STATE(2705),
    [sym_range] = STATE(2705),
    [sym_binary] = STATE(2705),
    [sym_unary] = STATE(2705),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(429),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_yield] = ACTIONS(433),
    [anon_sym_break] = ACTIONS(435),
    [anon_sym_next] = ACTIONS(437),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(439),
    [anon_sym_defined_QMARK] = ACTIONS(441),
    [anon_sym_not] = ACTIONS(443),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1011] = {
    [sym_string] = STATE(2706),
    [aux_sym_chained_string_repeat1] = STATE(2706),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_then] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [1012] = {
    [sym__statements] = STATE(2640),
    [sym_begin_block] = STATE(2715),
    [sym_end_block] = STATE(2715),
    [sym__statement] = STATE(2715),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(2715),
    [sym_unless_modifier] = STATE(2715),
    [sym_while_modifier] = STATE(2715),
    [sym_until_modifier] = STATE(2715),
    [sym_rescue_modifier] = STATE(2715),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2716),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2719),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(2719),
    [sym_assignment] = STATE(2716),
    [sym_operator_assignment] = STATE(2716),
    [sym_conditional] = STATE(2716),
    [sym_range] = STATE(2716),
    [sym_binary] = STATE(2716),
    [sym_unary] = STATE(2716),
    [sym_left_assignment_list] = STATE(2718),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2719),
    [sym__variable] = STATE(2717),
    [sym_undef] = STATE(2715),
    [sym_alias] = STATE(2715),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2719),
    [sym_false] = STATE(2719),
    [sym_nil] = STATE(2719),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2720),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(2721),
    [aux_sym__statements_repeat1] = STATE(2721),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4583),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(4469),
    [anon_sym_return] = ACTIONS(4585),
    [anon_sym_yield] = ACTIONS(4587),
    [anon_sym_break] = ACTIONS(4589),
    [anon_sym_next] = ACTIONS(4591),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(4469),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4593),
    [anon_sym_defined_QMARK] = ACTIONS(4595),
    [anon_sym_not] = ACTIONS(4597),
    [anon_sym_BANG] = ACTIONS(4599),
    [anon_sym_TILDE] = ACTIONS(4599),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [anon_sym_undef] = ACTIONS(4605),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1013] = {
    [sym_else] = STATE(2723),
    [anon_sym_end] = ACTIONS(4607),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [1014] = {
    [sym__statements] = STATE(2640),
    [sym_begin_block] = STATE(2715),
    [sym_end_block] = STATE(2715),
    [sym__statement] = STATE(2715),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(2715),
    [sym_unless_modifier] = STATE(2715),
    [sym_while_modifier] = STATE(2715),
    [sym_until_modifier] = STATE(2715),
    [sym_rescue_modifier] = STATE(2715),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(2723),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2716),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2719),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(2719),
    [sym_assignment] = STATE(2716),
    [sym_operator_assignment] = STATE(2716),
    [sym_conditional] = STATE(2716),
    [sym_range] = STATE(2716),
    [sym_binary] = STATE(2716),
    [sym_unary] = STATE(2716),
    [sym_left_assignment_list] = STATE(2718),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2719),
    [sym__variable] = STATE(2717),
    [sym_undef] = STATE(2715),
    [sym_alias] = STATE(2715),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2719),
    [sym_false] = STATE(2719),
    [sym_nil] = STATE(2719),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2720),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(2721),
    [aux_sym__statements_repeat1] = STATE(2721),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4583),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(4609),
    [anon_sym_return] = ACTIONS(4585),
    [anon_sym_yield] = ACTIONS(4587),
    [anon_sym_break] = ACTIONS(4589),
    [anon_sym_next] = ACTIONS(4591),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(4501),
    [anon_sym_then] = ACTIONS(4611),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4593),
    [anon_sym_defined_QMARK] = ACTIONS(4595),
    [anon_sym_not] = ACTIONS(4597),
    [anon_sym_BANG] = ACTIONS(4599),
    [anon_sym_TILDE] = ACTIONS(4599),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [anon_sym_undef] = ACTIONS(4605),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1015] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [1016] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2732),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2734),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2734),
    [sym_assignment] = STATE(2732),
    [sym_operator_assignment] = STATE(2732),
    [sym_conditional] = STATE(2732),
    [sym_range] = STATE(2732),
    [sym_binary] = STATE(2732),
    [sym_unary] = STATE(2732),
    [sym_left_assignment_list] = STATE(2733),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2734),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2734),
    [sym_false] = STATE(2734),
    [sym_nil] = STATE(2734),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2735),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4613),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4615),
    [anon_sym_yield] = ACTIONS(4617),
    [anon_sym_break] = ACTIONS(4619),
    [anon_sym_next] = ACTIONS(4621),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4623),
    [anon_sym_defined_QMARK] = ACTIONS(4625),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_BANG] = ACTIONS(4629),
    [anon_sym_TILDE] = ACTIONS(4629),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1017] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2736),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2734),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2734),
    [sym_assignment] = STATE(2736),
    [sym_operator_assignment] = STATE(2736),
    [sym_conditional] = STATE(2736),
    [sym_range] = STATE(2736),
    [sym_binary] = STATE(2736),
    [sym_unary] = STATE(2736),
    [sym_left_assignment_list] = STATE(2733),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2734),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2734),
    [sym_false] = STATE(2734),
    [sym_nil] = STATE(2734),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2735),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4613),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4615),
    [anon_sym_yield] = ACTIONS(4617),
    [anon_sym_break] = ACTIONS(4619),
    [anon_sym_next] = ACTIONS(4621),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4623),
    [anon_sym_defined_QMARK] = ACTIONS(4625),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_BANG] = ACTIONS(4629),
    [anon_sym_TILDE] = ACTIONS(4629),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1018] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2737),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1033),
    [sym_scope_resolution] = STATE(1029),
    [sym_call] = STATE(1029),
    [sym_method_call] = STATE(1033),
    [sym_assignment] = STATE(2737),
    [sym_operator_assignment] = STATE(2737),
    [sym_conditional] = STATE(2737),
    [sym_range] = STATE(2737),
    [sym_binary] = STATE(2737),
    [sym_unary] = STATE(2737),
    [sym_left_assignment_list] = STATE(1032),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1033),
    [sym__variable] = STATE(1029),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1033),
    [sym_false] = STATE(1033),
    [sym_nil] = STATE(1033),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2738),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1827),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1831),
    [anon_sym_yield] = ACTIONS(1833),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_next] = ACTIONS(1837),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4631),
    [anon_sym_defined_QMARK] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1845),
    [anon_sym_TILDE] = ACTIONS(1845),
    [sym_constant] = ACTIONS(1851),
    [sym_identifier] = ACTIONS(1851),
    [sym_instance_variable] = ACTIONS(1849),
    [sym_class_variable] = ACTIONS(1849),
    [sym_global_variable] = ACTIONS(1849),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1851),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1851),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1019] = {
    [anon_sym_COLON] = ACTIONS(4633),
    [sym_comment] = ACTIONS(87),
  },
  [1020] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2740),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2734),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2734),
    [sym_assignment] = STATE(2740),
    [sym_operator_assignment] = STATE(2740),
    [sym_conditional] = STATE(2740),
    [sym_range] = STATE(2740),
    [sym_binary] = STATE(2740),
    [sym_unary] = STATE(2740),
    [sym_left_assignment_list] = STATE(2733),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2734),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2734),
    [sym_false] = STATE(2734),
    [sym_nil] = STATE(2734),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2735),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4613),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4615),
    [anon_sym_yield] = ACTIONS(4617),
    [anon_sym_break] = ACTIONS(4619),
    [anon_sym_next] = ACTIONS(4621),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4623),
    [anon_sym_defined_QMARK] = ACTIONS(4625),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_BANG] = ACTIONS(4629),
    [anon_sym_TILDE] = ACTIONS(4629),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1021] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2746),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1033),
    [sym_scope_resolution] = STATE(1029),
    [sym_call] = STATE(1029),
    [sym_method_call] = STATE(1033),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(2747),
    [sym__argument] = STATE(2748),
    [sym_splat_argument] = STATE(2748),
    [sym_hash_splat_argument] = STATE(2748),
    [sym_block_argument] = STATE(2748),
    [sym_assignment] = STATE(2746),
    [sym_operator_assignment] = STATE(2746),
    [sym_conditional] = STATE(2746),
    [sym_range] = STATE(2746),
    [sym_binary] = STATE(2746),
    [sym_unary] = STATE(2746),
    [sym_left_assignment_list] = STATE(1032),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1033),
    [sym__variable] = STATE(1029),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1033),
    [sym_false] = STATE(1033),
    [sym_nil] = STATE(1033),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2749),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2748),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(4635),
    [sym__splat_star] = ACTIONS(4637),
    [sym__unary_minus] = ACTIONS(1827),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(4639),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1831),
    [anon_sym_yield] = ACTIONS(1833),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_next] = ACTIONS(1837),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1845),
    [sym_constant] = ACTIONS(4641),
    [sym_identifier] = ACTIONS(4641),
    [sym_instance_variable] = ACTIONS(1849),
    [sym_class_variable] = ACTIONS(1849),
    [sym_global_variable] = ACTIONS(1849),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1851),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1851),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1022] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2746),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1033),
    [sym_scope_resolution] = STATE(1029),
    [sym_call] = STATE(1029),
    [sym_method_call] = STATE(1033),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(2747),
    [sym__argument] = STATE(2748),
    [sym_splat_argument] = STATE(2748),
    [sym_hash_splat_argument] = STATE(2748),
    [sym_block_argument] = STATE(2748),
    [sym_assignment] = STATE(2746),
    [sym_operator_assignment] = STATE(2746),
    [sym_conditional] = STATE(2746),
    [sym_range] = STATE(2746),
    [sym_binary] = STATE(2746),
    [sym_unary] = STATE(2746),
    [sym_left_assignment_list] = STATE(1032),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1033),
    [sym__variable] = STATE(1029),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1033),
    [sym_false] = STATE(1033),
    [sym_nil] = STATE(1033),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2749),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2748),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(4635),
    [sym__splat_star] = ACTIONS(4637),
    [sym__unary_minus] = ACTIONS(1827),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(4639),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1831),
    [anon_sym_yield] = ACTIONS(1833),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_next] = ACTIONS(1837),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1845),
    [sym_constant] = ACTIONS(4641),
    [sym_identifier] = ACTIONS(4641),
    [sym_instance_variable] = ACTIONS(1849),
    [sym_class_variable] = ACTIONS(1849),
    [sym_global_variable] = ACTIONS(1849),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1851),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1851),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1023] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2746),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1033),
    [sym_scope_resolution] = STATE(1029),
    [sym_call] = STATE(1029),
    [sym_method_call] = STATE(1033),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(2747),
    [sym__argument] = STATE(2748),
    [sym_splat_argument] = STATE(2748),
    [sym_hash_splat_argument] = STATE(2748),
    [sym_block_argument] = STATE(2748),
    [sym_assignment] = STATE(2746),
    [sym_operator_assignment] = STATE(2746),
    [sym_conditional] = STATE(2746),
    [sym_range] = STATE(2746),
    [sym_binary] = STATE(2746),
    [sym_unary] = STATE(2746),
    [sym_left_assignment_list] = STATE(1032),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1033),
    [sym__variable] = STATE(1029),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1033),
    [sym_false] = STATE(1033),
    [sym_nil] = STATE(1033),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2749),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2748),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(4635),
    [sym__splat_star] = ACTIONS(4637),
    [sym__unary_minus] = ACTIONS(1827),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(4639),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1831),
    [anon_sym_yield] = ACTIONS(1833),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_next] = ACTIONS(1837),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1845),
    [sym_constant] = ACTIONS(4641),
    [sym_identifier] = ACTIONS(4641),
    [sym_instance_variable] = ACTIONS(1849),
    [sym_class_variable] = ACTIONS(1849),
    [sym_global_variable] = ACTIONS(1849),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1851),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1851),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1024] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2746),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1033),
    [sym_scope_resolution] = STATE(1029),
    [sym_call] = STATE(1029),
    [sym_method_call] = STATE(1033),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(2747),
    [sym__argument] = STATE(2748),
    [sym_splat_argument] = STATE(2748),
    [sym_hash_splat_argument] = STATE(2748),
    [sym_block_argument] = STATE(2748),
    [sym_assignment] = STATE(2746),
    [sym_operator_assignment] = STATE(2746),
    [sym_conditional] = STATE(2746),
    [sym_range] = STATE(2746),
    [sym_binary] = STATE(2746),
    [sym_unary] = STATE(2746),
    [sym_left_assignment_list] = STATE(1032),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1033),
    [sym__variable] = STATE(1029),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1033),
    [sym_false] = STATE(1033),
    [sym_nil] = STATE(1033),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2749),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2748),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(4635),
    [sym__splat_star] = ACTIONS(4637),
    [sym__unary_minus] = ACTIONS(1827),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(4639),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1831),
    [anon_sym_yield] = ACTIONS(1833),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_next] = ACTIONS(1837),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1845),
    [sym_constant] = ACTIONS(4641),
    [sym_identifier] = ACTIONS(4641),
    [sym_instance_variable] = ACTIONS(1849),
    [sym_class_variable] = ACTIONS(1849),
    [sym_global_variable] = ACTIONS(1849),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1851),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1851),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1025] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2750),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1033),
    [sym_scope_resolution] = STATE(1029),
    [sym_call] = STATE(1029),
    [sym_method_call] = STATE(1033),
    [sym_assignment] = STATE(2750),
    [sym_operator_assignment] = STATE(2750),
    [sym_conditional] = STATE(2750),
    [sym_range] = STATE(2750),
    [sym_binary] = STATE(2750),
    [sym_unary] = STATE(2750),
    [sym_left_assignment_list] = STATE(1032),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1033),
    [sym__variable] = STATE(1029),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1033),
    [sym_false] = STATE(1033),
    [sym_nil] = STATE(1033),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2738),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1827),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1831),
    [anon_sym_yield] = ACTIONS(1833),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_next] = ACTIONS(1837),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4631),
    [anon_sym_defined_QMARK] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1845),
    [anon_sym_TILDE] = ACTIONS(1845),
    [sym_constant] = ACTIONS(1851),
    [sym_identifier] = ACTIONS(1851),
    [sym_instance_variable] = ACTIONS(1849),
    [sym_class_variable] = ACTIONS(1849),
    [sym_global_variable] = ACTIONS(1849),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1851),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1851),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1026] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1033),
    [sym_scope_resolution] = STATE(1029),
    [sym_call] = STATE(1029),
    [sym_method_call] = STATE(1033),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(1032),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1033),
    [sym__variable] = STATE(1029),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1033),
    [sym_false] = STATE(1033),
    [sym_nil] = STATE(1033),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2738),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1827),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1831),
    [anon_sym_yield] = ACTIONS(1833),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_next] = ACTIONS(1837),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4631),
    [anon_sym_defined_QMARK] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1845),
    [anon_sym_TILDE] = ACTIONS(1845),
    [sym_constant] = ACTIONS(1851),
    [sym_identifier] = ACTIONS(1851),
    [sym_instance_variable] = ACTIONS(1849),
    [sym_class_variable] = ACTIONS(1849),
    [sym_global_variable] = ACTIONS(1849),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1851),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1851),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1027] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(4643),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [1028] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(4645),
    [sym__binary_star] = ACTIONS(4647),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(4649),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(4647),
    [anon_sym_AMP] = ACTIONS(4651),
    [anon_sym_LT] = ACTIONS(4653),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(4633),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(4655),
    [anon_sym_DOT_DOT] = ACTIONS(4657),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4659),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(4661),
    [anon_sym_AMP_AMP] = ACTIONS(4661),
    [anon_sym_LT_LT] = ACTIONS(4663),
    [anon_sym_GT_GT] = ACTIONS(4663),
    [anon_sym_EQ_EQ] = ACTIONS(4665),
    [anon_sym_BANG_EQ] = ACTIONS(4661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4661),
    [anon_sym_LT_EQ_GT] = ACTIONS(4661),
    [anon_sym_EQ_TILDE] = ACTIONS(4661),
    [anon_sym_BANG_TILDE] = ACTIONS(4661),
    [anon_sym_LT_EQ] = ACTIONS(4653),
    [anon_sym_GT] = ACTIONS(4653),
    [anon_sym_GT_EQ] = ACTIONS(4667),
    [anon_sym_CARET] = ACTIONS(4669),
    [anon_sym_PLUS] = ACTIONS(4645),
    [anon_sym_SLASH] = ACTIONS(4647),
    [anon_sym_PERCENT] = ACTIONS(4647),
    [sym_comment] = ACTIONS(87),
  },
  [1029] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(2768),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1066),
    [sym_scope_resolution] = STATE(1061),
    [sym_call] = STATE(1061),
    [sym_method_call] = STATE(1066),
    [sym_argument_list] = STATE(1578),
    [sym__argument_list_with_parens] = STATE(2769),
    [sym__argument] = STATE(2770),
    [sym_splat_argument] = STATE(2770),
    [sym_hash_splat_argument] = STATE(2770),
    [sym_block_argument] = STATE(2770),
    [sym_do_block] = STATE(941),
    [sym_block] = STATE(941),
    [sym_assignment] = STATE(2768),
    [sym_operator_assignment] = STATE(2768),
    [sym_conditional] = STATE(2768),
    [sym_range] = STATE(2768),
    [sym_binary] = STATE(2768),
    [sym_unary] = STATE(2768),
    [sym_left_assignment_list] = STATE(1065),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1066),
    [sym__variable] = STATE(1061),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1066),
    [sym_false] = STATE(1066),
    [sym_nil] = STATE(1066),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2771),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(2770),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(743),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(4671),
    [sym__splat_star] = ACTIONS(4673),
    [sym__unary_minus] = ACTIONS(1887),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(4675),
    [anon_sym_LBRACE] = ACTIONS(4677),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1895),
    [anon_sym_break] = ACTIONS(1897),
    [anon_sym_next] = ACTIONS(1899),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(769),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(1909),
    [anon_sym_not] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1913),
    [anon_sym_TILDE] = ACTIONS(1915),
    [sym_constant] = ACTIONS(4679),
    [sym_identifier] = ACTIONS(4679),
    [sym_instance_variable] = ACTIONS(1919),
    [sym_class_variable] = ACTIONS(1919),
    [sym_global_variable] = ACTIONS(1919),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1921),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1921),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [1030] = {
    [sym_heredoc_body] = STATE(2772),
    [aux_sym_call_repeat1] = STATE(2772),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [1031] = {
    [sym_heredoc_body] = STATE(2772),
    [aux_sym_call_repeat1] = STATE(2772),
    [aux_sym_argument_list_repeat1] = STATE(2774),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(4681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [1032] = {
    [anon_sym_EQ] = ACTIONS(4683),
    [sym_comment] = ACTIONS(87),
  },
  [1033] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(4685),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(4687),
    [anon_sym_DASH_EQ] = ACTIONS(4687),
    [anon_sym_STAR_EQ] = ACTIONS(4687),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4687),
    [anon_sym_SLASH_EQ] = ACTIONS(4687),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4687),
    [anon_sym_PIPE_EQ] = ACTIONS(4687),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4687),
    [anon_sym_AMP_EQ] = ACTIONS(4687),
    [anon_sym_PERCENT_EQ] = ACTIONS(4687),
    [anon_sym_GT_GT_EQ] = ACTIONS(4687),
    [anon_sym_LT_LT_EQ] = ACTIONS(4687),
    [anon_sym_CARET_EQ] = ACTIONS(4687),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1034] = {
    [sym_string] = STATE(2777),
    [aux_sym_chained_string_repeat1] = STATE(2777),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(4689),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [1035] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(1855),
    [sym__binary_star] = ACTIONS(1857),
    [anon_sym_PIPE] = ACTIONS(1859),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_LT] = ACTIONS(1863),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(1865),
    [anon_sym_DOT_DOT] = ACTIONS(1867),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1869),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(1873),
    [anon_sym_AMP_AMP] = ACTIONS(1873),
    [anon_sym_LT_LT] = ACTIONS(1875),
    [anon_sym_GT_GT] = ACTIONS(1875),
    [anon_sym_EQ_EQ] = ACTIONS(1877),
    [anon_sym_BANG_EQ] = ACTIONS(1873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1873),
    [anon_sym_LT_EQ_GT] = ACTIONS(1873),
    [anon_sym_EQ_TILDE] = ACTIONS(1873),
    [anon_sym_BANG_TILDE] = ACTIONS(1873),
    [anon_sym_LT_EQ] = ACTIONS(1863),
    [anon_sym_GT] = ACTIONS(1863),
    [anon_sym_GT_EQ] = ACTIONS(1879),
    [anon_sym_CARET] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_SLASH] = ACTIONS(1857),
    [anon_sym_PERCENT] = ACTIONS(1857),
    [sym_comment] = ACTIONS(87),
  },
  [1036] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2778),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(2778),
    [sym_operator_assignment] = STATE(2778),
    [sym_conditional] = STATE(2778),
    [sym_range] = STATE(2778),
    [sym_binary] = STATE(2778),
    [sym_unary] = STATE(2778),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(455),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_break] = ACTIONS(459),
    [anon_sym_next] = ACTIONS(461),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_defined_QMARK] = ACTIONS(465),
    [anon_sym_not] = ACTIONS(467),
    [anon_sym_BANG] = ACTIONS(469),
    [anon_sym_TILDE] = ACTIONS(469),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1037] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2779),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(2779),
    [sym_operator_assignment] = STATE(2779),
    [sym_conditional] = STATE(2779),
    [sym_range] = STATE(2779),
    [sym_binary] = STATE(2779),
    [sym_unary] = STATE(2779),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(455),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_break] = ACTIONS(459),
    [anon_sym_next] = ACTIONS(461),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_defined_QMARK] = ACTIONS(465),
    [anon_sym_not] = ACTIONS(467),
    [anon_sym_BANG] = ACTIONS(469),
    [anon_sym_TILDE] = ACTIONS(469),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1038] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2780),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(2780),
    [sym_operator_assignment] = STATE(2780),
    [sym_conditional] = STATE(2780),
    [sym_range] = STATE(2780),
    [sym_binary] = STATE(2780),
    [sym_unary] = STATE(2780),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(455),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_break] = ACTIONS(459),
    [anon_sym_next] = ACTIONS(461),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_defined_QMARK] = ACTIONS(465),
    [anon_sym_not] = ACTIONS(467),
    [anon_sym_BANG] = ACTIONS(469),
    [anon_sym_TILDE] = ACTIONS(469),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1039] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2781),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(2781),
    [sym_operator_assignment] = STATE(2781),
    [sym_conditional] = STATE(2781),
    [sym_range] = STATE(2781),
    [sym_binary] = STATE(2781),
    [sym_unary] = STATE(2781),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(455),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_break] = ACTIONS(459),
    [anon_sym_next] = ACTIONS(461),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_defined_QMARK] = ACTIONS(465),
    [anon_sym_not] = ACTIONS(467),
    [anon_sym_BANG] = ACTIONS(469),
    [anon_sym_TILDE] = ACTIONS(469),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1040] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2782),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(2782),
    [sym_operator_assignment] = STATE(2782),
    [sym_conditional] = STATE(2782),
    [sym_range] = STATE(2782),
    [sym_binary] = STATE(2782),
    [sym_unary] = STATE(2782),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(455),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_break] = ACTIONS(459),
    [anon_sym_next] = ACTIONS(461),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_defined_QMARK] = ACTIONS(465),
    [anon_sym_not] = ACTIONS(467),
    [anon_sym_BANG] = ACTIONS(469),
    [anon_sym_TILDE] = ACTIONS(469),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1041] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(2783),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(2783),
    [sym_operator_assignment] = STATE(2783),
    [sym_conditional] = STATE(2783),
    [sym_range] = STATE(2783),
    [sym_binary] = STATE(2783),
    [sym_unary] = STATE(2783),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1042] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2784),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(2784),
    [sym_operator_assignment] = STATE(2784),
    [sym_conditional] = STATE(2784),
    [sym_range] = STATE(2784),
    [sym_binary] = STATE(2784),
    [sym_unary] = STATE(2784),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(455),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_break] = ACTIONS(459),
    [anon_sym_next] = ACTIONS(461),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_defined_QMARK] = ACTIONS(465),
    [anon_sym_not] = ACTIONS(467),
    [anon_sym_BANG] = ACTIONS(469),
    [anon_sym_TILDE] = ACTIONS(469),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1043] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2785),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(2785),
    [sym_operator_assignment] = STATE(2785),
    [sym_conditional] = STATE(2785),
    [sym_range] = STATE(2785),
    [sym_binary] = STATE(2785),
    [sym_unary] = STATE(2785),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(455),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_break] = ACTIONS(459),
    [anon_sym_next] = ACTIONS(461),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_defined_QMARK] = ACTIONS(465),
    [anon_sym_not] = ACTIONS(467),
    [anon_sym_BANG] = ACTIONS(469),
    [anon_sym_TILDE] = ACTIONS(469),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1044] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2786),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(2786),
    [sym_operator_assignment] = STATE(2786),
    [sym_conditional] = STATE(2786),
    [sym_range] = STATE(2786),
    [sym_binary] = STATE(2786),
    [sym_unary] = STATE(2786),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(455),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_break] = ACTIONS(459),
    [anon_sym_next] = ACTIONS(461),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_defined_QMARK] = ACTIONS(465),
    [anon_sym_not] = ACTIONS(467),
    [anon_sym_BANG] = ACTIONS(469),
    [anon_sym_TILDE] = ACTIONS(469),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1045] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2787),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(2787),
    [sym_operator_assignment] = STATE(2787),
    [sym_conditional] = STATE(2787),
    [sym_range] = STATE(2787),
    [sym_binary] = STATE(2787),
    [sym_unary] = STATE(2787),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(455),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_break] = ACTIONS(459),
    [anon_sym_next] = ACTIONS(461),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_defined_QMARK] = ACTIONS(465),
    [anon_sym_not] = ACTIONS(467),
    [anon_sym_BANG] = ACTIONS(469),
    [anon_sym_TILDE] = ACTIONS(469),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1046] = {
    [sym__statements] = STATE(2789),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(4691),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1047] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(2797),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2800),
    [sym_scope_resolution] = STATE(2798),
    [sym_call] = STATE(2798),
    [sym_method_call] = STATE(2800),
    [sym_assignment] = STATE(2797),
    [sym_operator_assignment] = STATE(2797),
    [sym_conditional] = STATE(2797),
    [sym_range] = STATE(2797),
    [sym_binary] = STATE(2797),
    [sym_unary] = STATE(2797),
    [sym_left_assignment_list] = STATE(2799),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2800),
    [sym__variable] = STATE(2798),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2800),
    [sym_false] = STATE(2800),
    [sym_nil] = STATE(2800),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2801),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(4693),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(4695),
    [anon_sym_yield] = ACTIONS(4697),
    [anon_sym_break] = ACTIONS(4699),
    [anon_sym_next] = ACTIONS(4701),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(4703),
    [anon_sym_defined_QMARK] = ACTIONS(4705),
    [anon_sym_not] = ACTIONS(4707),
    [anon_sym_BANG] = ACTIONS(4709),
    [anon_sym_TILDE] = ACTIONS(4709),
    [sym_constant] = ACTIONS(4711),
    [sym_identifier] = ACTIONS(4711),
    [sym_instance_variable] = ACTIONS(4713),
    [sym_class_variable] = ACTIONS(4713),
    [sym_global_variable] = ACTIONS(4713),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(4711),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4711),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [1048] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(2802),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2800),
    [sym_scope_resolution] = STATE(2798),
    [sym_call] = STATE(2798),
    [sym_method_call] = STATE(2800),
    [sym_assignment] = STATE(2802),
    [sym_operator_assignment] = STATE(2802),
    [sym_conditional] = STATE(2802),
    [sym_range] = STATE(2802),
    [sym_binary] = STATE(2802),
    [sym_unary] = STATE(2802),
    [sym_left_assignment_list] = STATE(2799),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2800),
    [sym__variable] = STATE(2798),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2800),
    [sym_false] = STATE(2800),
    [sym_nil] = STATE(2800),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2801),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(4693),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(4695),
    [anon_sym_yield] = ACTIONS(4697),
    [anon_sym_break] = ACTIONS(4699),
    [anon_sym_next] = ACTIONS(4701),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(4703),
    [anon_sym_defined_QMARK] = ACTIONS(4705),
    [anon_sym_not] = ACTIONS(4707),
    [anon_sym_BANG] = ACTIONS(4709),
    [anon_sym_TILDE] = ACTIONS(4709),
    [sym_constant] = ACTIONS(4711),
    [sym_identifier] = ACTIONS(4711),
    [sym_instance_variable] = ACTIONS(4713),
    [sym_class_variable] = ACTIONS(4713),
    [sym_global_variable] = ACTIONS(4713),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(4711),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4711),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [1049] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(2803),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1066),
    [sym_scope_resolution] = STATE(1061),
    [sym_call] = STATE(1061),
    [sym_method_call] = STATE(1066),
    [sym_assignment] = STATE(2803),
    [sym_operator_assignment] = STATE(2803),
    [sym_conditional] = STATE(2803),
    [sym_range] = STATE(2803),
    [sym_binary] = STATE(2803),
    [sym_unary] = STATE(2803),
    [sym_left_assignment_list] = STATE(1065),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1066),
    [sym__variable] = STATE(1061),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1066),
    [sym_false] = STATE(1066),
    [sym_nil] = STATE(1066),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2804),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1895),
    [anon_sym_break] = ACTIONS(1897),
    [anon_sym_next] = ACTIONS(1899),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(4715),
    [anon_sym_defined_QMARK] = ACTIONS(1909),
    [anon_sym_not] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1915),
    [anon_sym_TILDE] = ACTIONS(1915),
    [sym_constant] = ACTIONS(1921),
    [sym_identifier] = ACTIONS(1921),
    [sym_instance_variable] = ACTIONS(1919),
    [sym_class_variable] = ACTIONS(1919),
    [sym_global_variable] = ACTIONS(1919),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1921),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1921),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [1050] = {
    [anon_sym_COLON] = ACTIONS(4717),
    [sym_comment] = ACTIONS(87),
  },
  [1051] = {
    [sym__statements] = STATE(1514),
    [sym_begin_block] = STATE(489),
    [sym_end_block] = STATE(489),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_block_parameters] = STATE(1515),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1516),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1519),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1519),
    [sym_hash_splat_argument] = STATE(116),
    [sym_assignment] = STATE(1516),
    [sym_operator_assignment] = STATE(1516),
    [sym_conditional] = STATE(1516),
    [sym_range] = STATE(1516),
    [sym_binary] = STATE(1516),
    [sym_unary] = STATE(1516),
    [sym_left_assignment_list] = STATE(1518),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1519),
    [sym__variable] = STATE(1517),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1519),
    [sym_false] = STATE(1519),
    [sym_nil] = STATE(1519),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1520),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(1521),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym__hash_items] = STATE(1522),
    [sym_pair] = STATE(122),
    [sym_lambda] = STATE(214),
    [sym_empty_statement] = STATE(495),
    [aux_sym__statements_repeat1] = STATE(495),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2629),
    [sym__identifier_hash_key] = ACTIONS(157),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(4719),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_PIPE] = ACTIONS(2445),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2633),
    [anon_sym_yield] = ACTIONS(2635),
    [anon_sym_break] = ACTIONS(2637),
    [anon_sym_next] = ACTIONS(2639),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2641),
    [anon_sym_defined_QMARK] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2647),
    [anon_sym_TILDE] = ACTIONS(2647),
    [sym_constant] = ACTIONS(2649),
    [sym_identifier] = ACTIONS(2649),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1052] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(2807),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2800),
    [sym_scope_resolution] = STATE(2798),
    [sym_call] = STATE(2798),
    [sym_method_call] = STATE(2800),
    [sym_assignment] = STATE(2807),
    [sym_operator_assignment] = STATE(2807),
    [sym_conditional] = STATE(2807),
    [sym_range] = STATE(2807),
    [sym_binary] = STATE(2807),
    [sym_unary] = STATE(2807),
    [sym_left_assignment_list] = STATE(2799),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2800),
    [sym__variable] = STATE(2798),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2800),
    [sym_false] = STATE(2800),
    [sym_nil] = STATE(2800),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2801),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(4693),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(4695),
    [anon_sym_yield] = ACTIONS(4697),
    [anon_sym_break] = ACTIONS(4699),
    [anon_sym_next] = ACTIONS(4701),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(4703),
    [anon_sym_defined_QMARK] = ACTIONS(4705),
    [anon_sym_not] = ACTIONS(4707),
    [anon_sym_BANG] = ACTIONS(4709),
    [anon_sym_TILDE] = ACTIONS(4709),
    [sym_constant] = ACTIONS(4711),
    [sym_identifier] = ACTIONS(4711),
    [sym_instance_variable] = ACTIONS(4713),
    [sym_class_variable] = ACTIONS(4713),
    [sym_global_variable] = ACTIONS(4713),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(4711),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4711),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [1053] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(2768),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1066),
    [sym_scope_resolution] = STATE(1061),
    [sym_call] = STATE(1061),
    [sym_method_call] = STATE(1066),
    [sym_argument_list] = STATE(1535),
    [sym__argument_list_with_parens] = STATE(2769),
    [sym__argument] = STATE(2770),
    [sym_splat_argument] = STATE(2770),
    [sym_hash_splat_argument] = STATE(2770),
    [sym_block_argument] = STATE(2770),
    [sym_assignment] = STATE(2768),
    [sym_operator_assignment] = STATE(2768),
    [sym_conditional] = STATE(2768),
    [sym_range] = STATE(2768),
    [sym_binary] = STATE(2768),
    [sym_unary] = STATE(2768),
    [sym_left_assignment_list] = STATE(1065),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1066),
    [sym__variable] = STATE(1061),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1066),
    [sym_false] = STATE(1066),
    [sym_nil] = STATE(1066),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2771),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(2770),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(4671),
    [sym__splat_star] = ACTIONS(4673),
    [sym__unary_minus] = ACTIONS(1887),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(4675),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1895),
    [anon_sym_break] = ACTIONS(1897),
    [anon_sym_next] = ACTIONS(1899),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(365),
    [anon_sym_DASH_EQ] = ACTIONS(365),
    [anon_sym_STAR_EQ] = ACTIONS(365),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(365),
    [anon_sym_SLASH_EQ] = ACTIONS(365),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(365),
    [anon_sym_PIPE_EQ] = ACTIONS(365),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(365),
    [anon_sym_AMP_EQ] = ACTIONS(365),
    [anon_sym_PERCENT_EQ] = ACTIONS(365),
    [anon_sym_GT_GT_EQ] = ACTIONS(365),
    [anon_sym_LT_LT_EQ] = ACTIONS(365),
    [anon_sym_CARET_EQ] = ACTIONS(365),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_PERCENT] = ACTIONS(377),
    [anon_sym_defined_QMARK] = ACTIONS(1909),
    [anon_sym_not] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1913),
    [anon_sym_TILDE] = ACTIONS(1915),
    [sym_constant] = ACTIONS(4679),
    [sym_identifier] = ACTIONS(4679),
    [sym_instance_variable] = ACTIONS(1919),
    [sym_class_variable] = ACTIONS(1919),
    [sym_global_variable] = ACTIONS(1919),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1921),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1921),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [1054] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(2768),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1066),
    [sym_scope_resolution] = STATE(1061),
    [sym_call] = STATE(1061),
    [sym_method_call] = STATE(1066),
    [sym_argument_list] = STATE(1536),
    [sym__argument_list_with_parens] = STATE(2769),
    [sym__argument] = STATE(2770),
    [sym_splat_argument] = STATE(2770),
    [sym_hash_splat_argument] = STATE(2770),
    [sym_block_argument] = STATE(2770),
    [sym_assignment] = STATE(2768),
    [sym_operator_assignment] = STATE(2768),
    [sym_conditional] = STATE(2768),
    [sym_range] = STATE(2768),
    [sym_binary] = STATE(2768),
    [sym_unary] = STATE(2768),
    [sym_left_assignment_list] = STATE(1065),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1066),
    [sym__variable] = STATE(1061),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1066),
    [sym_false] = STATE(1066),
    [sym_nil] = STATE(1066),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2771),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(2770),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(4671),
    [sym__splat_star] = ACTIONS(4673),
    [sym__unary_minus] = ACTIONS(1887),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(4675),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_EQ] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1895),
    [anon_sym_break] = ACTIONS(1897),
    [anon_sym_next] = ACTIONS(1899),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(417),
    [anon_sym_DASH_EQ] = ACTIONS(417),
    [anon_sym_STAR_EQ] = ACTIONS(417),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(417),
    [anon_sym_SLASH_EQ] = ACTIONS(417),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(417),
    [anon_sym_PIPE_EQ] = ACTIONS(417),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(417),
    [anon_sym_AMP_EQ] = ACTIONS(417),
    [anon_sym_PERCENT_EQ] = ACTIONS(417),
    [anon_sym_GT_GT_EQ] = ACTIONS(417),
    [anon_sym_LT_LT_EQ] = ACTIONS(417),
    [anon_sym_CARET_EQ] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(1909),
    [anon_sym_not] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1913),
    [anon_sym_TILDE] = ACTIONS(1915),
    [sym_constant] = ACTIONS(4679),
    [sym_identifier] = ACTIONS(4679),
    [sym_instance_variable] = ACTIONS(1919),
    [sym_class_variable] = ACTIONS(1919),
    [sym_global_variable] = ACTIONS(1919),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1921),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1921),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [1055] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(2768),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1066),
    [sym_scope_resolution] = STATE(1061),
    [sym_call] = STATE(1061),
    [sym_method_call] = STATE(1066),
    [sym_argument_list] = STATE(1537),
    [sym__argument_list_with_parens] = STATE(2769),
    [sym__argument] = STATE(2770),
    [sym_splat_argument] = STATE(2770),
    [sym_hash_splat_argument] = STATE(2770),
    [sym_block_argument] = STATE(2770),
    [sym_assignment] = STATE(2768),
    [sym_operator_assignment] = STATE(2768),
    [sym_conditional] = STATE(2768),
    [sym_range] = STATE(2768),
    [sym_binary] = STATE(2768),
    [sym_unary] = STATE(2768),
    [sym_left_assignment_list] = STATE(1065),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1066),
    [sym__variable] = STATE(1061),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1066),
    [sym_false] = STATE(1066),
    [sym_nil] = STATE(1066),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2771),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(2770),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(4671),
    [sym__splat_star] = ACTIONS(4673),
    [sym__unary_minus] = ACTIONS(1887),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(4675),
    [anon_sym_LBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_EQ] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1895),
    [anon_sym_break] = ACTIONS(1897),
    [anon_sym_next] = ACTIONS(1899),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(421),
    [anon_sym_DASH_EQ] = ACTIONS(421),
    [anon_sym_STAR_EQ] = ACTIONS(421),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(421),
    [anon_sym_SLASH_EQ] = ACTIONS(421),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(421),
    [anon_sym_PIPE_EQ] = ACTIONS(421),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(421),
    [anon_sym_AMP_EQ] = ACTIONS(421),
    [anon_sym_PERCENT_EQ] = ACTIONS(421),
    [anon_sym_GT_GT_EQ] = ACTIONS(421),
    [anon_sym_LT_LT_EQ] = ACTIONS(421),
    [anon_sym_CARET_EQ] = ACTIONS(421),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(1909),
    [anon_sym_not] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1913),
    [anon_sym_TILDE] = ACTIONS(1915),
    [sym_constant] = ACTIONS(4679),
    [sym_identifier] = ACTIONS(4679),
    [sym_instance_variable] = ACTIONS(1919),
    [sym_class_variable] = ACTIONS(1919),
    [sym_global_variable] = ACTIONS(1919),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1921),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1921),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [1056] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(2768),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1066),
    [sym_scope_resolution] = STATE(1061),
    [sym_call] = STATE(1061),
    [sym_method_call] = STATE(1066),
    [sym_argument_list] = STATE(1538),
    [sym__argument_list_with_parens] = STATE(2769),
    [sym__argument] = STATE(2770),
    [sym_splat_argument] = STATE(2770),
    [sym_hash_splat_argument] = STATE(2770),
    [sym_block_argument] = STATE(2770),
    [sym_assignment] = STATE(2768),
    [sym_operator_assignment] = STATE(2768),
    [sym_conditional] = STATE(2768),
    [sym_range] = STATE(2768),
    [sym_binary] = STATE(2768),
    [sym_unary] = STATE(2768),
    [sym_left_assignment_list] = STATE(1065),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1066),
    [sym__variable] = STATE(1061),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1066),
    [sym_false] = STATE(1066),
    [sym_nil] = STATE(1066),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2771),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(2770),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(4671),
    [sym__splat_star] = ACTIONS(4673),
    [sym__unary_minus] = ACTIONS(1887),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(4675),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(427),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1895),
    [anon_sym_break] = ACTIONS(1897),
    [anon_sym_next] = ACTIONS(1899),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(425),
    [anon_sym_DASH_EQ] = ACTIONS(425),
    [anon_sym_STAR_EQ] = ACTIONS(425),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(425),
    [anon_sym_SLASH_EQ] = ACTIONS(425),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(425),
    [anon_sym_PIPE_EQ] = ACTIONS(425),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(425),
    [anon_sym_AMP_EQ] = ACTIONS(425),
    [anon_sym_PERCENT_EQ] = ACTIONS(425),
    [anon_sym_GT_GT_EQ] = ACTIONS(425),
    [anon_sym_LT_LT_EQ] = ACTIONS(425),
    [anon_sym_CARET_EQ] = ACTIONS(425),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(1909),
    [anon_sym_not] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1913),
    [anon_sym_TILDE] = ACTIONS(1915),
    [sym_constant] = ACTIONS(4679),
    [sym_identifier] = ACTIONS(4679),
    [sym_instance_variable] = ACTIONS(1919),
    [sym_class_variable] = ACTIONS(1919),
    [sym_global_variable] = ACTIONS(1919),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1921),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1921),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [1057] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(2808),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1066),
    [sym_scope_resolution] = STATE(1061),
    [sym_call] = STATE(1061),
    [sym_method_call] = STATE(1066),
    [sym_assignment] = STATE(2808),
    [sym_operator_assignment] = STATE(2808),
    [sym_conditional] = STATE(2808),
    [sym_range] = STATE(2808),
    [sym_binary] = STATE(2808),
    [sym_unary] = STATE(2808),
    [sym_left_assignment_list] = STATE(1065),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1066),
    [sym__variable] = STATE(1061),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1066),
    [sym_false] = STATE(1066),
    [sym_nil] = STATE(1066),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2804),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1895),
    [anon_sym_break] = ACTIONS(1897),
    [anon_sym_next] = ACTIONS(1899),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(4715),
    [anon_sym_defined_QMARK] = ACTIONS(1909),
    [anon_sym_not] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1915),
    [anon_sym_TILDE] = ACTIONS(1915),
    [sym_constant] = ACTIONS(1921),
    [sym_identifier] = ACTIONS(1921),
    [sym_instance_variable] = ACTIONS(1919),
    [sym_class_variable] = ACTIONS(1919),
    [sym_global_variable] = ACTIONS(1919),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1921),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1921),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [1058] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(1559),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1066),
    [sym_scope_resolution] = STATE(1061),
    [sym_call] = STATE(1061),
    [sym_method_call] = STATE(1066),
    [sym_assignment] = STATE(1559),
    [sym_operator_assignment] = STATE(1559),
    [sym_conditional] = STATE(1559),
    [sym_range] = STATE(1559),
    [sym_binary] = STATE(1559),
    [sym_unary] = STATE(1559),
    [sym_left_assignment_list] = STATE(1065),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1066),
    [sym__variable] = STATE(1061),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1066),
    [sym_false] = STATE(1066),
    [sym_nil] = STATE(1066),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2804),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1895),
    [anon_sym_break] = ACTIONS(1897),
    [anon_sym_next] = ACTIONS(1899),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(4715),
    [anon_sym_defined_QMARK] = ACTIONS(1909),
    [anon_sym_not] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1915),
    [anon_sym_TILDE] = ACTIONS(1915),
    [sym_constant] = ACTIONS(1921),
    [sym_identifier] = ACTIONS(1921),
    [sym_instance_variable] = ACTIONS(1919),
    [sym_class_variable] = ACTIONS(1919),
    [sym_global_variable] = ACTIONS(1919),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1921),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1921),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [1059] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(4721),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [1060] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(4723),
    [sym__binary_star] = ACTIONS(4725),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(4727),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(4729),
    [anon_sym_AMP] = ACTIONS(4731),
    [anon_sym_EQ] = ACTIONS(1631),
    [anon_sym_LT] = ACTIONS(4733),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(4717),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_PLUS_EQ] = ACTIONS(1625),
    [anon_sym_DASH_EQ] = ACTIONS(1625),
    [anon_sym_STAR_EQ] = ACTIONS(1625),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1625),
    [anon_sym_SLASH_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1625),
    [anon_sym_AMP_EQ] = ACTIONS(1625),
    [anon_sym_PERCENT_EQ] = ACTIONS(1625),
    [anon_sym_GT_GT_EQ] = ACTIONS(1625),
    [anon_sym_LT_LT_EQ] = ACTIONS(1625),
    [anon_sym_CARET_EQ] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(4735),
    [anon_sym_DOT_DOT] = ACTIONS(4737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4739),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(4741),
    [anon_sym_AMP_AMP] = ACTIONS(4741),
    [anon_sym_LT_LT] = ACTIONS(4743),
    [anon_sym_GT_GT] = ACTIONS(4743),
    [anon_sym_EQ_EQ] = ACTIONS(4741),
    [anon_sym_BANG_EQ] = ACTIONS(4745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4745),
    [anon_sym_LT_EQ_GT] = ACTIONS(4745),
    [anon_sym_EQ_TILDE] = ACTIONS(4745),
    [anon_sym_BANG_TILDE] = ACTIONS(4745),
    [anon_sym_LT_EQ] = ACTIONS(4733),
    [anon_sym_GT] = ACTIONS(4733),
    [anon_sym_GT_EQ] = ACTIONS(4747),
    [anon_sym_CARET] = ACTIONS(4727),
    [anon_sym_PLUS] = ACTIONS(4749),
    [anon_sym_SLASH] = ACTIONS(4729),
    [anon_sym_PERCENT] = ACTIONS(4729),
    [sym_comment] = ACTIONS(87),
  },
  [1061] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(2768),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1066),
    [sym_scope_resolution] = STATE(1061),
    [sym_call] = STATE(1061),
    [sym_method_call] = STATE(1066),
    [sym_argument_list] = STATE(1578),
    [sym__argument_list_with_parens] = STATE(2769),
    [sym__argument] = STATE(2770),
    [sym_splat_argument] = STATE(2770),
    [sym_hash_splat_argument] = STATE(2770),
    [sym_block_argument] = STATE(2770),
    [sym_do_block] = STATE(941),
    [sym_block] = STATE(941),
    [sym_assignment] = STATE(2768),
    [sym_operator_assignment] = STATE(2768),
    [sym_conditional] = STATE(2768),
    [sym_range] = STATE(2768),
    [sym_binary] = STATE(2768),
    [sym_unary] = STATE(2768),
    [sym_left_assignment_list] = STATE(1065),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1066),
    [sym__variable] = STATE(1061),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1066),
    [sym_false] = STATE(1066),
    [sym_nil] = STATE(1066),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2771),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(2770),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(743),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(4671),
    [sym__splat_star] = ACTIONS(4673),
    [sym__unary_minus] = ACTIONS(1887),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(4675),
    [anon_sym_LBRACE] = ACTIONS(2715),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1895),
    [anon_sym_break] = ACTIONS(1897),
    [anon_sym_next] = ACTIONS(1899),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(769),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(1909),
    [anon_sym_not] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1913),
    [anon_sym_TILDE] = ACTIONS(1915),
    [sym_constant] = ACTIONS(4679),
    [sym_identifier] = ACTIONS(4679),
    [sym_instance_variable] = ACTIONS(1919),
    [sym_class_variable] = ACTIONS(1919),
    [sym_global_variable] = ACTIONS(1919),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1921),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1921),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [1062] = {
    [sym_do_block] = STATE(1580),
    [sym_block] = STATE(1580),
    [sym__line_break] = ACTIONS(2717),
    [sym__heredoc_body_start] = ACTIONS(2717),
    [sym__binary_minus] = ACTIONS(2717),
    [sym__binary_star] = ACTIONS(2717),
    [ts_builtin_sym_end] = ACTIONS(2717),
    [anon_sym___END__] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(2719),
    [anon_sym_RBRACE] = ACTIONS(2717),
    [anon_sym_RPAREN] = ACTIONS(2717),
    [anon_sym_DOT] = ACTIONS(2721),
    [anon_sym_COMMA] = ACTIONS(2717),
    [anon_sym_PIPE] = ACTIONS(2721),
    [anon_sym_SEMI] = ACTIONS(2717),
    [anon_sym_STAR_STAR] = ACTIONS(2721),
    [anon_sym_AMP] = ACTIONS(2721),
    [anon_sym_EQ] = ACTIONS(2721),
    [anon_sym_LT] = ACTIONS(2721),
    [anon_sym_end] = ACTIONS(2717),
    [anon_sym_if] = ACTIONS(2717),
    [anon_sym_unless] = ACTIONS(2717),
    [anon_sym_while] = ACTIONS(2717),
    [anon_sym_until] = ACTIONS(2717),
    [anon_sym_rescue] = ACTIONS(2717),
    [anon_sym_do] = ACTIONS(2717),
    [anon_sym_when] = ACTIONS(2717),
    [anon_sym_elsif] = ACTIONS(2717),
    [anon_sym_else] = ACTIONS(2717),
    [anon_sym_then] = ACTIONS(2717),
    [anon_sym_ensure] = ACTIONS(2717),
    [anon_sym_LBRACK] = ACTIONS(2717),
    [anon_sym_COLON_COLON2] = ACTIONS(2717),
    [anon_sym_AMP_DOT] = ACTIONS(2717),
    [anon_sym_PLUS_EQ] = ACTIONS(2717),
    [anon_sym_DASH_EQ] = ACTIONS(2717),
    [anon_sym_STAR_EQ] = ACTIONS(2717),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2717),
    [anon_sym_SLASH_EQ] = ACTIONS(2717),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2717),
    [anon_sym_PIPE_EQ] = ACTIONS(2717),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2717),
    [anon_sym_AMP_EQ] = ACTIONS(2717),
    [anon_sym_PERCENT_EQ] = ACTIONS(2717),
    [anon_sym_GT_GT_EQ] = ACTIONS(2717),
    [anon_sym_LT_LT_EQ] = ACTIONS(2717),
    [anon_sym_CARET_EQ] = ACTIONS(2717),
    [anon_sym_QMARK] = ACTIONS(2717),
    [anon_sym_DOT_DOT] = ACTIONS(2721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2717),
    [anon_sym_and] = ACTIONS(2717),
    [anon_sym_or] = ACTIONS(2717),
    [anon_sym_PIPE_PIPE] = ACTIONS(2721),
    [anon_sym_AMP_AMP] = ACTIONS(2721),
    [anon_sym_LT_LT] = ACTIONS(2721),
    [anon_sym_GT_GT] = ACTIONS(2721),
    [anon_sym_EQ_EQ] = ACTIONS(2721),
    [anon_sym_BANG_EQ] = ACTIONS(2717),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2717),
    [anon_sym_LT_EQ_GT] = ACTIONS(2717),
    [anon_sym_EQ_TILDE] = ACTIONS(2717),
    [anon_sym_BANG_TILDE] = ACTIONS(2717),
    [anon_sym_LT_EQ] = ACTIONS(2721),
    [anon_sym_GT] = ACTIONS(2721),
    [anon_sym_GT_EQ] = ACTIONS(2717),
    [anon_sym_CARET] = ACTIONS(2721),
    [anon_sym_PLUS] = ACTIONS(2721),
    [anon_sym_SLASH] = ACTIONS(2721),
    [anon_sym_PERCENT] = ACTIONS(2721),
    [sym_comment] = ACTIONS(87),
  },
  [1063] = {
    [sym_heredoc_body] = STATE(2820),
    [aux_sym_call_repeat1] = STATE(2820),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [1064] = {
    [sym_heredoc_body] = STATE(2820),
    [aux_sym_call_repeat1] = STATE(2820),
    [aux_sym_argument_list_repeat1] = STATE(2822),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(4751),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [1065] = {
    [anon_sym_EQ] = ACTIONS(4753),
    [sym_comment] = ACTIONS(87),
  },
  [1066] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(4755),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(4757),
    [anon_sym_DASH_EQ] = ACTIONS(4757),
    [anon_sym_STAR_EQ] = ACTIONS(4757),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4757),
    [anon_sym_SLASH_EQ] = ACTIONS(4757),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4757),
    [anon_sym_PIPE_EQ] = ACTIONS(4757),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4757),
    [anon_sym_AMP_EQ] = ACTIONS(4757),
    [anon_sym_PERCENT_EQ] = ACTIONS(4757),
    [anon_sym_GT_GT_EQ] = ACTIONS(4757),
    [anon_sym_LT_LT_EQ] = ACTIONS(4757),
    [anon_sym_CARET_EQ] = ACTIONS(4757),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1067] = {
    [sym_string] = STATE(2825),
    [aux_sym_chained_string_repeat1] = STATE(2825),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(747),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(4759),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1068] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2830),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2833),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2833),
    [sym_splat_argument] = STATE(2831),
    [sym_assignment] = STATE(2830),
    [sym_operator_assignment] = STATE(2830),
    [sym_conditional] = STATE(2830),
    [sym_range] = STATE(2830),
    [sym_binary] = STATE(2830),
    [sym_unary] = STATE(2830),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(2831),
    [sym_left_assignment_list] = STATE(2832),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2833),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2833),
    [sym_false] = STATE(2833),
    [sym_nil] = STATE(2833),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2735),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(4761),
    [sym__unary_minus] = ACTIONS(4763),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4615),
    [anon_sym_yield] = ACTIONS(4617),
    [anon_sym_break] = ACTIONS(4619),
    [anon_sym_next] = ACTIONS(4621),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4765),
    [anon_sym_defined_QMARK] = ACTIONS(4767),
    [anon_sym_not] = ACTIONS(4769),
    [anon_sym_BANG] = ACTIONS(4771),
    [anon_sym_TILDE] = ACTIONS(4771),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1069] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2834),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(2834),
    [sym_operator_assignment] = STATE(2834),
    [sym_conditional] = STATE(2834),
    [sym_range] = STATE(2834),
    [sym_binary] = STATE(2834),
    [sym_unary] = STATE(2834),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(455),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_break] = ACTIONS(459),
    [anon_sym_next] = ACTIONS(461),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_defined_QMARK] = ACTIONS(465),
    [anon_sym_not] = ACTIONS(467),
    [anon_sym_BANG] = ACTIONS(469),
    [anon_sym_TILDE] = ACTIONS(469),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1070] = {
    [sym_string] = STATE(2835),
    [aux_sym_chained_string_repeat1] = STATE(2835),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [1071] = {
    [sym__statements] = STATE(2837),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(4773),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1072] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(2845),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2848),
    [sym_scope_resolution] = STATE(2846),
    [sym_call] = STATE(2846),
    [sym_method_call] = STATE(2848),
    [sym_assignment] = STATE(2845),
    [sym_operator_assignment] = STATE(2845),
    [sym_conditional] = STATE(2845),
    [sym_range] = STATE(2845),
    [sym_binary] = STATE(2845),
    [sym_unary] = STATE(2845),
    [sym_left_assignment_list] = STATE(2847),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2848),
    [sym__variable] = STATE(2846),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2848),
    [sym_false] = STATE(2848),
    [sym_nil] = STATE(2848),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2849),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4775),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4777),
    [anon_sym_yield] = ACTIONS(4779),
    [anon_sym_break] = ACTIONS(4781),
    [anon_sym_next] = ACTIONS(4783),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4785),
    [anon_sym_defined_QMARK] = ACTIONS(4787),
    [anon_sym_not] = ACTIONS(4789),
    [anon_sym_BANG] = ACTIONS(4791),
    [anon_sym_TILDE] = ACTIONS(4791),
    [sym_constant] = ACTIONS(4793),
    [sym_identifier] = ACTIONS(4793),
    [sym_instance_variable] = ACTIONS(4795),
    [sym_class_variable] = ACTIONS(4795),
    [sym_global_variable] = ACTIONS(4795),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4793),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4793),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1073] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(2850),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2848),
    [sym_scope_resolution] = STATE(2846),
    [sym_call] = STATE(2846),
    [sym_method_call] = STATE(2848),
    [sym_assignment] = STATE(2850),
    [sym_operator_assignment] = STATE(2850),
    [sym_conditional] = STATE(2850),
    [sym_range] = STATE(2850),
    [sym_binary] = STATE(2850),
    [sym_unary] = STATE(2850),
    [sym_left_assignment_list] = STATE(2847),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2848),
    [sym__variable] = STATE(2846),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2848),
    [sym_false] = STATE(2848),
    [sym_nil] = STATE(2848),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2849),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4775),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4777),
    [anon_sym_yield] = ACTIONS(4779),
    [anon_sym_break] = ACTIONS(4781),
    [anon_sym_next] = ACTIONS(4783),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4785),
    [anon_sym_defined_QMARK] = ACTIONS(4787),
    [anon_sym_not] = ACTIONS(4789),
    [anon_sym_BANG] = ACTIONS(4791),
    [anon_sym_TILDE] = ACTIONS(4791),
    [sym_constant] = ACTIONS(4793),
    [sym_identifier] = ACTIONS(4793),
    [sym_instance_variable] = ACTIONS(4795),
    [sym_class_variable] = ACTIONS(4795),
    [sym_global_variable] = ACTIONS(4795),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4793),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4793),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1074] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(2851),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1089),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(1089),
    [sym_assignment] = STATE(2851),
    [sym_operator_assignment] = STATE(2851),
    [sym_conditional] = STATE(2851),
    [sym_range] = STATE(2851),
    [sym_binary] = STATE(2851),
    [sym_unary] = STATE(2851),
    [sym_left_assignment_list] = STATE(1088),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1089),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1089),
    [sym_false] = STATE(1089),
    [sym_nil] = STATE(1089),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1937),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1943),
    [anon_sym_yield] = ACTIONS(1945),
    [anon_sym_break] = ACTIONS(1947),
    [anon_sym_next] = ACTIONS(1949),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1951),
    [anon_sym_defined_QMARK] = ACTIONS(1953),
    [anon_sym_not] = ACTIONS(1955),
    [anon_sym_BANG] = ACTIONS(1957),
    [anon_sym_TILDE] = ACTIONS(1957),
    [sym_constant] = ACTIONS(1963),
    [sym_identifier] = ACTIONS(1963),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1075] = {
    [anon_sym_COLON] = ACTIONS(4797),
    [sym_comment] = ACTIONS(87),
  },
  [1076] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(2854),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2848),
    [sym_scope_resolution] = STATE(2846),
    [sym_call] = STATE(2846),
    [sym_method_call] = STATE(2848),
    [sym_assignment] = STATE(2854),
    [sym_operator_assignment] = STATE(2854),
    [sym_conditional] = STATE(2854),
    [sym_range] = STATE(2854),
    [sym_binary] = STATE(2854),
    [sym_unary] = STATE(2854),
    [sym_left_assignment_list] = STATE(2847),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2848),
    [sym__variable] = STATE(2846),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2848),
    [sym_false] = STATE(2848),
    [sym_nil] = STATE(2848),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2849),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4775),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4777),
    [anon_sym_yield] = ACTIONS(4779),
    [anon_sym_break] = ACTIONS(4781),
    [anon_sym_next] = ACTIONS(4783),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4785),
    [anon_sym_defined_QMARK] = ACTIONS(4787),
    [anon_sym_not] = ACTIONS(4789),
    [anon_sym_BANG] = ACTIONS(4791),
    [anon_sym_TILDE] = ACTIONS(4791),
    [sym_constant] = ACTIONS(4793),
    [sym_identifier] = ACTIONS(4793),
    [sym_instance_variable] = ACTIONS(4795),
    [sym_class_variable] = ACTIONS(4795),
    [sym_global_variable] = ACTIONS(4795),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4793),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4793),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1077] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(2860),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1089),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(1089),
    [sym_argument_list] = STATE(1318),
    [sym__argument_list_with_parens] = STATE(2861),
    [sym__argument] = STATE(2862),
    [sym_splat_argument] = STATE(2862),
    [sym_hash_splat_argument] = STATE(2862),
    [sym_block_argument] = STATE(2862),
    [sym_assignment] = STATE(2860),
    [sym_operator_assignment] = STATE(2860),
    [sym_conditional] = STATE(2860),
    [sym_range] = STATE(2860),
    [sym_binary] = STATE(2860),
    [sym_unary] = STATE(2860),
    [sym_left_assignment_list] = STATE(1088),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1089),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1089),
    [sym_false] = STATE(1089),
    [sym_nil] = STATE(1089),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2863),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(2862),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(4799),
    [sym__splat_star] = ACTIONS(4801),
    [sym__unary_minus] = ACTIONS(1937),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(4803),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1943),
    [anon_sym_yield] = ACTIONS(1945),
    [anon_sym_break] = ACTIONS(1947),
    [anon_sym_next] = ACTIONS(1949),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_in] = ACTIONS(377),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(1953),
    [anon_sym_not] = ACTIONS(1955),
    [anon_sym_BANG] = ACTIONS(4805),
    [anon_sym_TILDE] = ACTIONS(1957),
    [sym_constant] = ACTIONS(4807),
    [sym_identifier] = ACTIONS(4807),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1078] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(2860),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1089),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(1089),
    [sym_argument_list] = STATE(1324),
    [sym__argument_list_with_parens] = STATE(2861),
    [sym__argument] = STATE(2862),
    [sym_splat_argument] = STATE(2862),
    [sym_hash_splat_argument] = STATE(2862),
    [sym_block_argument] = STATE(2862),
    [sym_assignment] = STATE(2860),
    [sym_operator_assignment] = STATE(2860),
    [sym_conditional] = STATE(2860),
    [sym_range] = STATE(2860),
    [sym_binary] = STATE(2860),
    [sym_unary] = STATE(2860),
    [sym_left_assignment_list] = STATE(1088),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1089),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1089),
    [sym_false] = STATE(1089),
    [sym_nil] = STATE(1089),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2863),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(2862),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(4799),
    [sym__splat_star] = ACTIONS(4801),
    [sym__unary_minus] = ACTIONS(1937),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(4803),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1943),
    [anon_sym_yield] = ACTIONS(1945),
    [anon_sym_break] = ACTIONS(1947),
    [anon_sym_next] = ACTIONS(1949),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_in] = ACTIONS(419),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(1953),
    [anon_sym_not] = ACTIONS(1955),
    [anon_sym_BANG] = ACTIONS(4805),
    [anon_sym_TILDE] = ACTIONS(1957),
    [sym_constant] = ACTIONS(4807),
    [sym_identifier] = ACTIONS(4807),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1079] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(2860),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1089),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(1089),
    [sym_argument_list] = STATE(1325),
    [sym__argument_list_with_parens] = STATE(2861),
    [sym__argument] = STATE(2862),
    [sym_splat_argument] = STATE(2862),
    [sym_hash_splat_argument] = STATE(2862),
    [sym_block_argument] = STATE(2862),
    [sym_assignment] = STATE(2860),
    [sym_operator_assignment] = STATE(2860),
    [sym_conditional] = STATE(2860),
    [sym_range] = STATE(2860),
    [sym_binary] = STATE(2860),
    [sym_unary] = STATE(2860),
    [sym_left_assignment_list] = STATE(1088),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1089),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1089),
    [sym_false] = STATE(1089),
    [sym_nil] = STATE(1089),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2863),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(2862),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(4799),
    [sym__splat_star] = ACTIONS(4801),
    [sym__unary_minus] = ACTIONS(1937),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(4803),
    [anon_sym_LBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1943),
    [anon_sym_yield] = ACTIONS(1945),
    [anon_sym_break] = ACTIONS(1947),
    [anon_sym_next] = ACTIONS(1949),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_in] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(1953),
    [anon_sym_not] = ACTIONS(1955),
    [anon_sym_BANG] = ACTIONS(4805),
    [anon_sym_TILDE] = ACTIONS(1957),
    [sym_constant] = ACTIONS(4807),
    [sym_identifier] = ACTIONS(4807),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1080] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(2860),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1089),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(1089),
    [sym_argument_list] = STATE(1326),
    [sym__argument_list_with_parens] = STATE(2861),
    [sym__argument] = STATE(2862),
    [sym_splat_argument] = STATE(2862),
    [sym_hash_splat_argument] = STATE(2862),
    [sym_block_argument] = STATE(2862),
    [sym_assignment] = STATE(2860),
    [sym_operator_assignment] = STATE(2860),
    [sym_conditional] = STATE(2860),
    [sym_range] = STATE(2860),
    [sym_binary] = STATE(2860),
    [sym_unary] = STATE(2860),
    [sym_left_assignment_list] = STATE(1088),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1089),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1089),
    [sym_false] = STATE(1089),
    [sym_nil] = STATE(1089),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2863),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(2862),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(4799),
    [sym__splat_star] = ACTIONS(4801),
    [sym__unary_minus] = ACTIONS(1937),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(4803),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1943),
    [anon_sym_yield] = ACTIONS(1945),
    [anon_sym_break] = ACTIONS(1947),
    [anon_sym_next] = ACTIONS(1949),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_in] = ACTIONS(427),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(1953),
    [anon_sym_not] = ACTIONS(1955),
    [anon_sym_BANG] = ACTIONS(4805),
    [anon_sym_TILDE] = ACTIONS(1957),
    [sym_constant] = ACTIONS(4807),
    [sym_identifier] = ACTIONS(4807),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1081] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(2864),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1089),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(1089),
    [sym_assignment] = STATE(2864),
    [sym_operator_assignment] = STATE(2864),
    [sym_conditional] = STATE(2864),
    [sym_range] = STATE(2864),
    [sym_binary] = STATE(2864),
    [sym_unary] = STATE(2864),
    [sym_left_assignment_list] = STATE(1088),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1089),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1089),
    [sym_false] = STATE(1089),
    [sym_nil] = STATE(1089),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1937),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1943),
    [anon_sym_yield] = ACTIONS(1945),
    [anon_sym_break] = ACTIONS(1947),
    [anon_sym_next] = ACTIONS(1949),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1951),
    [anon_sym_defined_QMARK] = ACTIONS(1953),
    [anon_sym_not] = ACTIONS(1955),
    [anon_sym_BANG] = ACTIONS(1957),
    [anon_sym_TILDE] = ACTIONS(1957),
    [sym_constant] = ACTIONS(1963),
    [sym_identifier] = ACTIONS(1963),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1082] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(1872),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1089),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(1089),
    [sym_assignment] = STATE(1872),
    [sym_operator_assignment] = STATE(1872),
    [sym_conditional] = STATE(1872),
    [sym_range] = STATE(1872),
    [sym_binary] = STATE(1872),
    [sym_unary] = STATE(1872),
    [sym_left_assignment_list] = STATE(1088),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1089),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1089),
    [sym_false] = STATE(1089),
    [sym_nil] = STATE(1089),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1937),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1943),
    [anon_sym_yield] = ACTIONS(1945),
    [anon_sym_break] = ACTIONS(1947),
    [anon_sym_next] = ACTIONS(1949),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1951),
    [anon_sym_defined_QMARK] = ACTIONS(1953),
    [anon_sym_not] = ACTIONS(1955),
    [anon_sym_BANG] = ACTIONS(1957),
    [anon_sym_TILDE] = ACTIONS(1957),
    [sym_constant] = ACTIONS(1963),
    [sym_identifier] = ACTIONS(1963),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1083] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(4809),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [1084] = {
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(4811),
    [sym__binary_star] = ACTIONS(4813),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(4815),
    [anon_sym_STAR_STAR] = ACTIONS(4813),
    [anon_sym_AMP] = ACTIONS(4817),
    [anon_sym_LT] = ACTIONS(4819),
    [anon_sym_in] = ACTIONS(1625),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(4797),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(4821),
    [anon_sym_DOT_DOT] = ACTIONS(4823),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4825),
    [anon_sym_and] = ACTIONS(4827),
    [anon_sym_or] = ACTIONS(4827),
    [anon_sym_PIPE_PIPE] = ACTIONS(4829),
    [anon_sym_AMP_AMP] = ACTIONS(4829),
    [anon_sym_LT_LT] = ACTIONS(4831),
    [anon_sym_GT_GT] = ACTIONS(4831),
    [anon_sym_EQ_EQ] = ACTIONS(4833),
    [anon_sym_BANG_EQ] = ACTIONS(4829),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4829),
    [anon_sym_LT_EQ_GT] = ACTIONS(4829),
    [anon_sym_EQ_TILDE] = ACTIONS(4829),
    [anon_sym_BANG_TILDE] = ACTIONS(4829),
    [anon_sym_LT_EQ] = ACTIONS(4819),
    [anon_sym_GT] = ACTIONS(4819),
    [anon_sym_GT_EQ] = ACTIONS(4835),
    [anon_sym_CARET] = ACTIONS(4837),
    [anon_sym_PLUS] = ACTIONS(4811),
    [anon_sym_SLASH] = ACTIONS(4813),
    [anon_sym_PERCENT] = ACTIONS(4813),
    [sym_comment] = ACTIONS(87),
  },
  [1085] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(2888),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2892),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(2892),
    [sym_argument_list] = STATE(2016),
    [sym__argument_list_with_parens] = STATE(2889),
    [sym__argument] = STATE(2890),
    [sym_splat_argument] = STATE(2890),
    [sym_hash_splat_argument] = STATE(2890),
    [sym_block_argument] = STATE(2890),
    [sym_do_block] = STATE(1382),
    [sym_block] = STATE(1382),
    [sym_assignment] = STATE(2888),
    [sym_operator_assignment] = STATE(2888),
    [sym_conditional] = STATE(2888),
    [sym_range] = STATE(2888),
    [sym_binary] = STATE(2888),
    [sym_unary] = STATE(2888),
    [sym_left_assignment_list] = STATE(2891),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2892),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2892),
    [sym_false] = STATE(2892),
    [sym_nil] = STATE(2892),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(2893),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(2890),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(4839),
    [sym__splat_star] = ACTIONS(4841),
    [sym__unary_minus] = ACTIONS(4843),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(4845),
    [anon_sym_LBRACE] = ACTIONS(3537),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4847),
    [anon_sym_yield] = ACTIONS(4849),
    [anon_sym_break] = ACTIONS(4851),
    [anon_sym_next] = ACTIONS(4853),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_in] = ACTIONS(769),
    [anon_sym_do] = ACTIONS(769),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(4855),
    [anon_sym_not] = ACTIONS(4857),
    [anon_sym_BANG] = ACTIONS(4859),
    [anon_sym_TILDE] = ACTIONS(4861),
    [sym_constant] = ACTIONS(4863),
    [sym_identifier] = ACTIONS(4863),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1086] = {
    [sym_heredoc_body] = STATE(2894),
    [aux_sym_call_repeat1] = STATE(2894),
    [sym__heredoc_body_start] = ACTIONS(3959),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1681),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_in] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [1087] = {
    [sym_heredoc_body] = STATE(2894),
    [aux_sym_call_repeat1] = STATE(2894),
    [aux_sym_argument_list_repeat1] = STATE(2896),
    [sym__heredoc_body_start] = ACTIONS(3959),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1681),
    [anon_sym_COMMA] = ACTIONS(4865),
    [anon_sym_in] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [1088] = {
    [anon_sym_EQ] = ACTIONS(4867),
    [sym_comment] = ACTIONS(87),
  },
  [1089] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(4869),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_in] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(4871),
    [anon_sym_DASH_EQ] = ACTIONS(4871),
    [anon_sym_STAR_EQ] = ACTIONS(4871),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4871),
    [anon_sym_SLASH_EQ] = ACTIONS(4871),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4871),
    [anon_sym_PIPE_EQ] = ACTIONS(4871),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4871),
    [anon_sym_AMP_EQ] = ACTIONS(4871),
    [anon_sym_PERCENT_EQ] = ACTIONS(4871),
    [anon_sym_GT_GT_EQ] = ACTIONS(4871),
    [anon_sym_LT_LT_EQ] = ACTIONS(4871),
    [anon_sym_CARET_EQ] = ACTIONS(4871),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1090] = {
    [sym_string] = STATE(2899),
    [aux_sym_chained_string_repeat1] = STATE(2899),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(4873),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_in] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [1091] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2900),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(2900),
    [sym_operator_assignment] = STATE(2900),
    [sym_conditional] = STATE(2900),
    [sym_range] = STATE(2900),
    [sym_binary] = STATE(2900),
    [sym_unary] = STATE(2900),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(455),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_break] = ACTIONS(459),
    [anon_sym_next] = ACTIONS(461),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_defined_QMARK] = ACTIONS(465),
    [anon_sym_not] = ACTIONS(467),
    [anon_sym_BANG] = ACTIONS(469),
    [anon_sym_TILDE] = ACTIONS(469),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1092] = {
    [sym__do] = STATE(2901),
    [sym_heredoc_body] = STATE(2901),
    [sym__terminator] = STATE(2901),
    [sym__line_break] = ACTIONS(4875),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(4875),
    [anon_sym_do] = ACTIONS(4875),
    [sym_comment] = ACTIONS(87),
  },
  [1093] = {
    [sym_method] = STATE(184),
    [sym_singleton_method] = STATE(184),
    [sym_class] = STATE(184),
    [sym_singleton_class] = STATE(184),
    [sym_module] = STATE(184),
    [sym_return] = STATE(184),
    [sym_yield] = STATE(184),
    [sym_break] = STATE(184),
    [sym_next] = STATE(184),
    [sym_while] = STATE(184),
    [sym_until] = STATE(184),
    [sym_for] = STATE(184),
    [sym_case] = STATE(184),
    [sym_if] = STATE(184),
    [sym_unless] = STATE(184),
    [sym_begin] = STATE(184),
    [sym__primary] = STATE(184),
    [sym_parenthesized_statements] = STATE(184),
    [sym_element_reference] = STATE(1598),
    [sym_scope_resolution] = STATE(255),
    [sym_call] = STATE(255),
    [sym_method_call] = STATE(1598),
    [sym_destructured_left_assignment] = STATE(1597),
    [sym_rest_assignment] = STATE(1597),
    [sym__lhs] = STATE(1598),
    [sym__variable] = STATE(255),
    [sym_rational] = STATE(184),
    [sym_true] = STATE(1598),
    [sym_false] = STATE(1598),
    [sym_nil] = STATE(1598),
    [sym_chained_string] = STATE(184),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(184),
    [sym_string_array] = STATE(184),
    [sym_symbol_array] = STATE(184),
    [sym_symbol] = STATE(184),
    [sym_regex] = STATE(184),
    [sym_array] = STATE(184),
    [sym_hash] = STATE(184),
    [sym_lambda] = STATE(184),
    [sym__simple_symbol] = ACTIONS(279),
    [sym__string_start] = ACTIONS(281),
    [sym__symbol_start] = ACTIONS(283),
    [sym__subshell_start] = ACTIONS(285),
    [sym__regex_start] = ACTIONS(287),
    [sym__string_array_start] = ACTIONS(289),
    [sym__symbol_array_start] = ACTIONS(291),
    [sym_heredoc_beginning] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_def] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(475),
    [anon_sym_COLON_COLON] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(477),
    [anon_sym_class] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(307),
    [anon_sym_return] = ACTIONS(309),
    [anon_sym_yield] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_next] = ACTIONS(315),
    [sym_redo] = ACTIONS(317),
    [sym_retry] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(319),
    [anon_sym_unless] = ACTIONS(321),
    [anon_sym_while] = ACTIONS(323),
    [anon_sym_until] = ACTIONS(325),
    [anon_sym_for] = ACTIONS(327),
    [anon_sym_in] = ACTIONS(4877),
    [anon_sym_case] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(331),
    [sym_constant] = ACTIONS(479),
    [sym_identifier] = ACTIONS(479),
    [sym_instance_variable] = ACTIONS(481),
    [sym_class_variable] = ACTIONS(481),
    [sym_global_variable] = ACTIONS(481),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(317),
    [sym_complex] = ACTIONS(293),
    [sym_super] = ACTIONS(479),
    [anon_sym_true] = ACTIONS(339),
    [anon_sym_TRUE] = ACTIONS(339),
    [anon_sym_false] = ACTIONS(341),
    [anon_sym_FALSE] = ACTIONS(341),
    [sym_self] = ACTIONS(479),
    [anon_sym_nil] = ACTIONS(343),
    [anon_sym_NIL] = ACTIONS(343),
    [sym_character] = ACTIONS(293),
    [anon_sym_LBRACK2] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(347),
  },
  [1094] = {
    [aux_sym__mlhs_repeat1] = STATE(2903),
    [anon_sym_COMMA] = ACTIONS(4879),
    [anon_sym_in] = ACTIONS(2749),
    [sym_comment] = ACTIONS(87),
  },
  [1095] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(2003),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [1096] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2911),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2913),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2913),
    [sym_assignment] = STATE(2911),
    [sym_operator_assignment] = STATE(2911),
    [sym_conditional] = STATE(2911),
    [sym_range] = STATE(2911),
    [sym_binary] = STATE(2911),
    [sym_unary] = STATE(2911),
    [sym_left_assignment_list] = STATE(2912),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2913),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2913),
    [sym_false] = STATE(2913),
    [sym_nil] = STATE(2913),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2914),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4881),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4883),
    [anon_sym_yield] = ACTIONS(4885),
    [anon_sym_break] = ACTIONS(4887),
    [anon_sym_next] = ACTIONS(4889),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4891),
    [anon_sym_defined_QMARK] = ACTIONS(4893),
    [anon_sym_not] = ACTIONS(4895),
    [anon_sym_BANG] = ACTIONS(4897),
    [anon_sym_TILDE] = ACTIONS(4897),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1097] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2915),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2913),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2913),
    [sym_assignment] = STATE(2915),
    [sym_operator_assignment] = STATE(2915),
    [sym_conditional] = STATE(2915),
    [sym_range] = STATE(2915),
    [sym_binary] = STATE(2915),
    [sym_unary] = STATE(2915),
    [sym_left_assignment_list] = STATE(2912),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2913),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2913),
    [sym_false] = STATE(2913),
    [sym_nil] = STATE(2913),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2914),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4881),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4883),
    [anon_sym_yield] = ACTIONS(4885),
    [anon_sym_break] = ACTIONS(4887),
    [anon_sym_next] = ACTIONS(4889),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4891),
    [anon_sym_defined_QMARK] = ACTIONS(4893),
    [anon_sym_not] = ACTIONS(4895),
    [anon_sym_BANG] = ACTIONS(4897),
    [anon_sym_TILDE] = ACTIONS(4897),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1098] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2916),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1113),
    [sym_scope_resolution] = STATE(1109),
    [sym_call] = STATE(1109),
    [sym_method_call] = STATE(1113),
    [sym_assignment] = STATE(2916),
    [sym_operator_assignment] = STATE(2916),
    [sym_conditional] = STATE(2916),
    [sym_range] = STATE(2916),
    [sym_binary] = STATE(2916),
    [sym_unary] = STATE(2916),
    [sym_left_assignment_list] = STATE(1112),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1113),
    [sym__variable] = STATE(1109),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1113),
    [sym_false] = STATE(1113),
    [sym_nil] = STATE(1113),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2917),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1973),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1977),
    [anon_sym_yield] = ACTIONS(1979),
    [anon_sym_break] = ACTIONS(1981),
    [anon_sym_next] = ACTIONS(1983),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4899),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1991),
    [anon_sym_TILDE] = ACTIONS(1991),
    [sym_constant] = ACTIONS(1997),
    [sym_identifier] = ACTIONS(1997),
    [sym_instance_variable] = ACTIONS(1995),
    [sym_class_variable] = ACTIONS(1995),
    [sym_global_variable] = ACTIONS(1995),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1997),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1997),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1099] = {
    [anon_sym_COLON] = ACTIONS(4901),
    [sym_comment] = ACTIONS(87),
  },
  [1100] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2919),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2913),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2913),
    [sym_assignment] = STATE(2919),
    [sym_operator_assignment] = STATE(2919),
    [sym_conditional] = STATE(2919),
    [sym_range] = STATE(2919),
    [sym_binary] = STATE(2919),
    [sym_unary] = STATE(2919),
    [sym_left_assignment_list] = STATE(2912),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2913),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2913),
    [sym_false] = STATE(2913),
    [sym_nil] = STATE(2913),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2914),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4881),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4883),
    [anon_sym_yield] = ACTIONS(4885),
    [anon_sym_break] = ACTIONS(4887),
    [anon_sym_next] = ACTIONS(4889),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4891),
    [anon_sym_defined_QMARK] = ACTIONS(4893),
    [anon_sym_not] = ACTIONS(4895),
    [anon_sym_BANG] = ACTIONS(4897),
    [anon_sym_TILDE] = ACTIONS(4897),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1101] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2925),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1113),
    [sym_scope_resolution] = STATE(1109),
    [sym_call] = STATE(1109),
    [sym_method_call] = STATE(1113),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(2926),
    [sym__argument] = STATE(2927),
    [sym_splat_argument] = STATE(2927),
    [sym_hash_splat_argument] = STATE(2927),
    [sym_block_argument] = STATE(2927),
    [sym_assignment] = STATE(2925),
    [sym_operator_assignment] = STATE(2925),
    [sym_conditional] = STATE(2925),
    [sym_range] = STATE(2925),
    [sym_binary] = STATE(2925),
    [sym_unary] = STATE(2925),
    [sym_left_assignment_list] = STATE(1112),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1113),
    [sym__variable] = STATE(1109),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1113),
    [sym_false] = STATE(1113),
    [sym_nil] = STATE(1113),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2928),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2927),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(4903),
    [sym__splat_star] = ACTIONS(4905),
    [sym__unary_minus] = ACTIONS(1973),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(4907),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1977),
    [anon_sym_yield] = ACTIONS(1979),
    [anon_sym_break] = ACTIONS(1981),
    [anon_sym_next] = ACTIONS(1983),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1991),
    [sym_constant] = ACTIONS(4909),
    [sym_identifier] = ACTIONS(4909),
    [sym_instance_variable] = ACTIONS(1995),
    [sym_class_variable] = ACTIONS(1995),
    [sym_global_variable] = ACTIONS(1995),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1997),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1997),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1102] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2925),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1113),
    [sym_scope_resolution] = STATE(1109),
    [sym_call] = STATE(1109),
    [sym_method_call] = STATE(1113),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(2926),
    [sym__argument] = STATE(2927),
    [sym_splat_argument] = STATE(2927),
    [sym_hash_splat_argument] = STATE(2927),
    [sym_block_argument] = STATE(2927),
    [sym_assignment] = STATE(2925),
    [sym_operator_assignment] = STATE(2925),
    [sym_conditional] = STATE(2925),
    [sym_range] = STATE(2925),
    [sym_binary] = STATE(2925),
    [sym_unary] = STATE(2925),
    [sym_left_assignment_list] = STATE(1112),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1113),
    [sym__variable] = STATE(1109),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1113),
    [sym_false] = STATE(1113),
    [sym_nil] = STATE(1113),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2928),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2927),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(4903),
    [sym__splat_star] = ACTIONS(4905),
    [sym__unary_minus] = ACTIONS(1973),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(4907),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1977),
    [anon_sym_yield] = ACTIONS(1979),
    [anon_sym_break] = ACTIONS(1981),
    [anon_sym_next] = ACTIONS(1983),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1991),
    [sym_constant] = ACTIONS(4909),
    [sym_identifier] = ACTIONS(4909),
    [sym_instance_variable] = ACTIONS(1995),
    [sym_class_variable] = ACTIONS(1995),
    [sym_global_variable] = ACTIONS(1995),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1997),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1997),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1103] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2925),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1113),
    [sym_scope_resolution] = STATE(1109),
    [sym_call] = STATE(1109),
    [sym_method_call] = STATE(1113),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(2926),
    [sym__argument] = STATE(2927),
    [sym_splat_argument] = STATE(2927),
    [sym_hash_splat_argument] = STATE(2927),
    [sym_block_argument] = STATE(2927),
    [sym_assignment] = STATE(2925),
    [sym_operator_assignment] = STATE(2925),
    [sym_conditional] = STATE(2925),
    [sym_range] = STATE(2925),
    [sym_binary] = STATE(2925),
    [sym_unary] = STATE(2925),
    [sym_left_assignment_list] = STATE(1112),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1113),
    [sym__variable] = STATE(1109),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1113),
    [sym_false] = STATE(1113),
    [sym_nil] = STATE(1113),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2928),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2927),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(4903),
    [sym__splat_star] = ACTIONS(4905),
    [sym__unary_minus] = ACTIONS(1973),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(4907),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1977),
    [anon_sym_yield] = ACTIONS(1979),
    [anon_sym_break] = ACTIONS(1981),
    [anon_sym_next] = ACTIONS(1983),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1991),
    [sym_constant] = ACTIONS(4909),
    [sym_identifier] = ACTIONS(4909),
    [sym_instance_variable] = ACTIONS(1995),
    [sym_class_variable] = ACTIONS(1995),
    [sym_global_variable] = ACTIONS(1995),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1997),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1997),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1104] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2925),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1113),
    [sym_scope_resolution] = STATE(1109),
    [sym_call] = STATE(1109),
    [sym_method_call] = STATE(1113),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(2926),
    [sym__argument] = STATE(2927),
    [sym_splat_argument] = STATE(2927),
    [sym_hash_splat_argument] = STATE(2927),
    [sym_block_argument] = STATE(2927),
    [sym_assignment] = STATE(2925),
    [sym_operator_assignment] = STATE(2925),
    [sym_conditional] = STATE(2925),
    [sym_range] = STATE(2925),
    [sym_binary] = STATE(2925),
    [sym_unary] = STATE(2925),
    [sym_left_assignment_list] = STATE(1112),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1113),
    [sym__variable] = STATE(1109),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1113),
    [sym_false] = STATE(1113),
    [sym_nil] = STATE(1113),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2928),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2927),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(4903),
    [sym__splat_star] = ACTIONS(4905),
    [sym__unary_minus] = ACTIONS(1973),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(4907),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1977),
    [anon_sym_yield] = ACTIONS(1979),
    [anon_sym_break] = ACTIONS(1981),
    [anon_sym_next] = ACTIONS(1983),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1991),
    [sym_constant] = ACTIONS(4909),
    [sym_identifier] = ACTIONS(4909),
    [sym_instance_variable] = ACTIONS(1995),
    [sym_class_variable] = ACTIONS(1995),
    [sym_global_variable] = ACTIONS(1995),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1997),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1997),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1105] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2929),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1113),
    [sym_scope_resolution] = STATE(1109),
    [sym_call] = STATE(1109),
    [sym_method_call] = STATE(1113),
    [sym_assignment] = STATE(2929),
    [sym_operator_assignment] = STATE(2929),
    [sym_conditional] = STATE(2929),
    [sym_range] = STATE(2929),
    [sym_binary] = STATE(2929),
    [sym_unary] = STATE(2929),
    [sym_left_assignment_list] = STATE(1112),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1113),
    [sym__variable] = STATE(1109),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1113),
    [sym_false] = STATE(1113),
    [sym_nil] = STATE(1113),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2917),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1973),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1977),
    [anon_sym_yield] = ACTIONS(1979),
    [anon_sym_break] = ACTIONS(1981),
    [anon_sym_next] = ACTIONS(1983),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4899),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1991),
    [anon_sym_TILDE] = ACTIONS(1991),
    [sym_constant] = ACTIONS(1997),
    [sym_identifier] = ACTIONS(1997),
    [sym_instance_variable] = ACTIONS(1995),
    [sym_class_variable] = ACTIONS(1995),
    [sym_global_variable] = ACTIONS(1995),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1997),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1997),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1106] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1113),
    [sym_scope_resolution] = STATE(1109),
    [sym_call] = STATE(1109),
    [sym_method_call] = STATE(1113),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(1112),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1113),
    [sym__variable] = STATE(1109),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1113),
    [sym_false] = STATE(1113),
    [sym_nil] = STATE(1113),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2917),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1973),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1977),
    [anon_sym_yield] = ACTIONS(1979),
    [anon_sym_break] = ACTIONS(1981),
    [anon_sym_next] = ACTIONS(1983),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4899),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1991),
    [anon_sym_TILDE] = ACTIONS(1991),
    [sym_constant] = ACTIONS(1997),
    [sym_identifier] = ACTIONS(1997),
    [sym_instance_variable] = ACTIONS(1995),
    [sym_class_variable] = ACTIONS(1995),
    [sym_global_variable] = ACTIONS(1995),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1997),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1997),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1107] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(4911),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [1108] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(4913),
    [sym__binary_star] = ACTIONS(4915),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(4917),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(4915),
    [anon_sym_AMP] = ACTIONS(4919),
    [anon_sym_LT] = ACTIONS(4921),
    [anon_sym_EQ_GT] = ACTIONS(4901),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_DOT_DOT] = ACTIONS(4925),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4927),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(4929),
    [anon_sym_AMP_AMP] = ACTIONS(4929),
    [anon_sym_LT_LT] = ACTIONS(4931),
    [anon_sym_GT_GT] = ACTIONS(4931),
    [anon_sym_EQ_EQ] = ACTIONS(4933),
    [anon_sym_BANG_EQ] = ACTIONS(4929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4929),
    [anon_sym_LT_EQ_GT] = ACTIONS(4929),
    [anon_sym_EQ_TILDE] = ACTIONS(4929),
    [anon_sym_BANG_TILDE] = ACTIONS(4929),
    [anon_sym_LT_EQ] = ACTIONS(4921),
    [anon_sym_GT] = ACTIONS(4921),
    [anon_sym_GT_EQ] = ACTIONS(4935),
    [anon_sym_CARET] = ACTIONS(4937),
    [anon_sym_PLUS] = ACTIONS(4913),
    [anon_sym_SLASH] = ACTIONS(4915),
    [anon_sym_PERCENT] = ACTIONS(4915),
    [sym_comment] = ACTIONS(87),
  },
  [1109] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(2768),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1066),
    [sym_scope_resolution] = STATE(1061),
    [sym_call] = STATE(1061),
    [sym_method_call] = STATE(1066),
    [sym_argument_list] = STATE(938),
    [sym__argument_list_with_parens] = STATE(2769),
    [sym__argument] = STATE(2770),
    [sym_splat_argument] = STATE(2770),
    [sym_hash_splat_argument] = STATE(2770),
    [sym_block_argument] = STATE(2770),
    [sym_do_block] = STATE(941),
    [sym_block] = STATE(941),
    [sym_assignment] = STATE(2768),
    [sym_operator_assignment] = STATE(2768),
    [sym_conditional] = STATE(2768),
    [sym_range] = STATE(2768),
    [sym_binary] = STATE(2768),
    [sym_unary] = STATE(2768),
    [sym_left_assignment_list] = STATE(1065),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1066),
    [sym__variable] = STATE(1061),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1066),
    [sym_false] = STATE(1066),
    [sym_nil] = STATE(1066),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2771),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(2770),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(743),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(4671),
    [sym__splat_star] = ACTIONS(4673),
    [sym__unary_minus] = ACTIONS(1887),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(4675),
    [anon_sym_LBRACE] = ACTIONS(1669),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1895),
    [anon_sym_break] = ACTIONS(1897),
    [anon_sym_next] = ACTIONS(1899),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(1671),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(1909),
    [anon_sym_not] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1913),
    [anon_sym_TILDE] = ACTIONS(1915),
    [sym_constant] = ACTIONS(4679),
    [sym_identifier] = ACTIONS(4679),
    [sym_instance_variable] = ACTIONS(1919),
    [sym_class_variable] = ACTIONS(1919),
    [sym_global_variable] = ACTIONS(1919),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1921),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1921),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [1110] = {
    [sym_heredoc_body] = STATE(2941),
    [aux_sym_call_repeat1] = STATE(2941),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [1111] = {
    [sym_heredoc_body] = STATE(2941),
    [aux_sym_call_repeat1] = STATE(2941),
    [aux_sym_argument_list_repeat1] = STATE(2943),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(4939),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [1112] = {
    [anon_sym_EQ] = ACTIONS(4941),
    [sym_comment] = ACTIONS(87),
  },
  [1113] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(4943),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(4945),
    [anon_sym_DASH_EQ] = ACTIONS(4945),
    [anon_sym_STAR_EQ] = ACTIONS(4945),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4945),
    [anon_sym_SLASH_EQ] = ACTIONS(4945),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4945),
    [anon_sym_PIPE_EQ] = ACTIONS(4945),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4945),
    [anon_sym_AMP_EQ] = ACTIONS(4945),
    [anon_sym_PERCENT_EQ] = ACTIONS(4945),
    [anon_sym_GT_GT_EQ] = ACTIONS(4945),
    [anon_sym_LT_LT_EQ] = ACTIONS(4945),
    [anon_sym_CARET_EQ] = ACTIONS(4945),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1114] = {
    [sym_string] = STATE(2946),
    [aux_sym_chained_string_repeat1] = STATE(2946),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(4947),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [1115] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(2001),
    [sym__binary_star] = ACTIONS(2003),
    [anon_sym_PIPE] = ACTIONS(2005),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(2003),
    [anon_sym_AMP] = ACTIONS(2007),
    [anon_sym_LT] = ACTIONS(2009),
    [anon_sym_QMARK] = ACTIONS(2011),
    [anon_sym_DOT_DOT] = ACTIONS(2013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2015),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(2019),
    [anon_sym_AMP_AMP] = ACTIONS(2019),
    [anon_sym_LT_LT] = ACTIONS(2021),
    [anon_sym_GT_GT] = ACTIONS(2021),
    [anon_sym_EQ_EQ] = ACTIONS(2023),
    [anon_sym_BANG_EQ] = ACTIONS(2019),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2019),
    [anon_sym_LT_EQ_GT] = ACTIONS(2019),
    [anon_sym_EQ_TILDE] = ACTIONS(2019),
    [anon_sym_BANG_TILDE] = ACTIONS(2019),
    [anon_sym_LT_EQ] = ACTIONS(2009),
    [anon_sym_GT] = ACTIONS(2009),
    [anon_sym_GT_EQ] = ACTIONS(2025),
    [anon_sym_CARET] = ACTIONS(2027),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_SLASH] = ACTIONS(2003),
    [anon_sym_PERCENT] = ACTIONS(2003),
    [sym_comment] = ACTIONS(87),
  },
  [1116] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2947),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(2947),
    [sym_operator_assignment] = STATE(2947),
    [sym_conditional] = STATE(2947),
    [sym_range] = STATE(2947),
    [sym_binary] = STATE(2947),
    [sym_unary] = STATE(2947),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(485),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(495),
    [anon_sym_defined_QMARK] = ACTIONS(497),
    [anon_sym_not] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(501),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1117] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2948),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(2948),
    [sym_operator_assignment] = STATE(2948),
    [sym_conditional] = STATE(2948),
    [sym_range] = STATE(2948),
    [sym_binary] = STATE(2948),
    [sym_unary] = STATE(2948),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(485),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(495),
    [anon_sym_defined_QMARK] = ACTIONS(497),
    [anon_sym_not] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(501),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1118] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2949),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(2949),
    [sym_operator_assignment] = STATE(2949),
    [sym_conditional] = STATE(2949),
    [sym_range] = STATE(2949),
    [sym_binary] = STATE(2949),
    [sym_unary] = STATE(2949),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(485),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(495),
    [anon_sym_defined_QMARK] = ACTIONS(497),
    [anon_sym_not] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(501),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1119] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2950),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(2950),
    [sym_operator_assignment] = STATE(2950),
    [sym_conditional] = STATE(2950),
    [sym_range] = STATE(2950),
    [sym_binary] = STATE(2950),
    [sym_unary] = STATE(2950),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(485),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(495),
    [anon_sym_defined_QMARK] = ACTIONS(497),
    [anon_sym_not] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(501),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1120] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2951),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(2951),
    [sym_operator_assignment] = STATE(2951),
    [sym_conditional] = STATE(2951),
    [sym_range] = STATE(2951),
    [sym_binary] = STATE(2951),
    [sym_unary] = STATE(2951),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(485),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(495),
    [anon_sym_defined_QMARK] = ACTIONS(497),
    [anon_sym_not] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(501),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1121] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(2952),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(2952),
    [sym_operator_assignment] = STATE(2952),
    [sym_conditional] = STATE(2952),
    [sym_range] = STATE(2952),
    [sym_binary] = STATE(2952),
    [sym_unary] = STATE(2952),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1122] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2953),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(2953),
    [sym_operator_assignment] = STATE(2953),
    [sym_conditional] = STATE(2953),
    [sym_range] = STATE(2953),
    [sym_binary] = STATE(2953),
    [sym_unary] = STATE(2953),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(485),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(495),
    [anon_sym_defined_QMARK] = ACTIONS(497),
    [anon_sym_not] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(501),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1123] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2954),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(2954),
    [sym_operator_assignment] = STATE(2954),
    [sym_conditional] = STATE(2954),
    [sym_range] = STATE(2954),
    [sym_binary] = STATE(2954),
    [sym_unary] = STATE(2954),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(485),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(495),
    [anon_sym_defined_QMARK] = ACTIONS(497),
    [anon_sym_not] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(501),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1124] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2955),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(2955),
    [sym_operator_assignment] = STATE(2955),
    [sym_conditional] = STATE(2955),
    [sym_range] = STATE(2955),
    [sym_binary] = STATE(2955),
    [sym_unary] = STATE(2955),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(485),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(495),
    [anon_sym_defined_QMARK] = ACTIONS(497),
    [anon_sym_not] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(501),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1125] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2956),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(2956),
    [sym_operator_assignment] = STATE(2956),
    [sym_conditional] = STATE(2956),
    [sym_range] = STATE(2956),
    [sym_binary] = STATE(2956),
    [sym_unary] = STATE(2956),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(485),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(495),
    [anon_sym_defined_QMARK] = ACTIONS(497),
    [anon_sym_not] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(501),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1126] = {
    [sym_when] = STATE(2960),
    [sym_else] = STATE(2958),
    [aux_sym_case_repeat1] = STATE(2959),
    [aux_sym_case_repeat2] = STATE(2960),
    [anon_sym_SEMI] = ACTIONS(4949),
    [anon_sym_end] = ACTIONS(4951),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [1127] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2965),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2968),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2968),
    [sym_splat_argument] = STATE(2966),
    [sym_assignment] = STATE(2965),
    [sym_operator_assignment] = STATE(2965),
    [sym_conditional] = STATE(2965),
    [sym_range] = STATE(2965),
    [sym_binary] = STATE(2965),
    [sym_unary] = STATE(2965),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(2966),
    [sym_left_assignment_list] = STATE(2967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2968),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2968),
    [sym_false] = STATE(2968),
    [sym_nil] = STATE(2968),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2914),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(4953),
    [sym__unary_minus] = ACTIONS(4955),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4883),
    [anon_sym_yield] = ACTIONS(4885),
    [anon_sym_break] = ACTIONS(4887),
    [anon_sym_next] = ACTIONS(4889),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4957),
    [anon_sym_defined_QMARK] = ACTIONS(4959),
    [anon_sym_not] = ACTIONS(4961),
    [anon_sym_BANG] = ACTIONS(4963),
    [anon_sym_TILDE] = ACTIONS(4963),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1128] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2969),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(2969),
    [sym_operator_assignment] = STATE(2969),
    [sym_conditional] = STATE(2969),
    [sym_range] = STATE(2969),
    [sym_binary] = STATE(2969),
    [sym_unary] = STATE(2969),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(485),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(495),
    [anon_sym_defined_QMARK] = ACTIONS(497),
    [anon_sym_not] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(501),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1129] = {
    [sym_string] = STATE(2970),
    [aux_sym_chained_string_repeat1] = STATE(2970),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [1130] = {
    [sym__line_break] = ACTIONS(4965),
    [sym__heredoc_body_start] = ACTIONS(4965),
    [sym__binary_minus] = ACTIONS(4965),
    [sym__binary_star] = ACTIONS(4965),
    [ts_builtin_sym_end] = ACTIONS(4965),
    [anon_sym___END__] = ACTIONS(4965),
    [anon_sym_LBRACE] = ACTIONS(4965),
    [anon_sym_RBRACE] = ACTIONS(4965),
    [anon_sym_RPAREN] = ACTIONS(4965),
    [anon_sym_DOT] = ACTIONS(4967),
    [anon_sym_COMMA] = ACTIONS(4965),
    [anon_sym_PIPE] = ACTIONS(4967),
    [anon_sym_SEMI] = ACTIONS(4965),
    [anon_sym_STAR_STAR] = ACTIONS(4965),
    [anon_sym_AMP] = ACTIONS(4967),
    [anon_sym_LT] = ACTIONS(4967),
    [anon_sym_end] = ACTIONS(4965),
    [anon_sym_if] = ACTIONS(4965),
    [anon_sym_unless] = ACTIONS(4965),
    [anon_sym_while] = ACTIONS(4965),
    [anon_sym_until] = ACTIONS(4965),
    [anon_sym_rescue] = ACTIONS(4965),
    [anon_sym_do] = ACTIONS(4965),
    [anon_sym_when] = ACTIONS(4965),
    [anon_sym_elsif] = ACTIONS(4965),
    [anon_sym_else] = ACTIONS(4965),
    [anon_sym_then] = ACTIONS(4965),
    [anon_sym_ensure] = ACTIONS(4965),
    [anon_sym_EQ_GT] = ACTIONS(4965),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym_COLON_COLON2] = ACTIONS(4965),
    [anon_sym_AMP_DOT] = ACTIONS(4965),
    [anon_sym_QMARK] = ACTIONS(4965),
    [anon_sym_DOT_DOT] = ACTIONS(4967),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4965),
    [anon_sym_and] = ACTIONS(4965),
    [anon_sym_or] = ACTIONS(4965),
    [anon_sym_PIPE_PIPE] = ACTIONS(4965),
    [anon_sym_AMP_AMP] = ACTIONS(4965),
    [anon_sym_LT_LT] = ACTIONS(4965),
    [anon_sym_GT_GT] = ACTIONS(4965),
    [anon_sym_EQ_EQ] = ACTIONS(4967),
    [anon_sym_BANG_EQ] = ACTIONS(4965),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4965),
    [anon_sym_LT_EQ_GT] = ACTIONS(4965),
    [anon_sym_EQ_TILDE] = ACTIONS(4965),
    [anon_sym_BANG_TILDE] = ACTIONS(4965),
    [anon_sym_LT_EQ] = ACTIONS(4967),
    [anon_sym_GT] = ACTIONS(4967),
    [anon_sym_GT_EQ] = ACTIONS(4965),
    [anon_sym_CARET] = ACTIONS(4965),
    [anon_sym_PLUS] = ACTIONS(4965),
    [anon_sym_SLASH] = ACTIONS(4965),
    [anon_sym_PERCENT] = ACTIONS(4965),
    [sym_comment] = ACTIONS(87),
  },
  [1131] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_pattern] = STATE(2979),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2980),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2984),
    [sym_scope_resolution] = STATE(2981),
    [sym_call] = STATE(2981),
    [sym_method_call] = STATE(2984),
    [sym_splat_argument] = STATE(2982),
    [sym_assignment] = STATE(2980),
    [sym_operator_assignment] = STATE(2980),
    [sym_conditional] = STATE(2980),
    [sym_range] = STATE(2980),
    [sym_binary] = STATE(2980),
    [sym_unary] = STATE(2980),
    [sym_left_assignment_list] = STATE(2983),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2984),
    [sym__variable] = STATE(2981),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2984),
    [sym_false] = STATE(2984),
    [sym_nil] = STATE(2984),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2985),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(4969),
    [sym__unary_minus] = ACTIONS(4971),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4973),
    [anon_sym_yield] = ACTIONS(4975),
    [anon_sym_break] = ACTIONS(4977),
    [anon_sym_next] = ACTIONS(4979),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4981),
    [anon_sym_defined_QMARK] = ACTIONS(4983),
    [anon_sym_not] = ACTIONS(4985),
    [anon_sym_BANG] = ACTIONS(4987),
    [anon_sym_TILDE] = ACTIONS(4987),
    [sym_constant] = ACTIONS(4989),
    [sym_identifier] = ACTIONS(4989),
    [sym_instance_variable] = ACTIONS(4991),
    [sym_class_variable] = ACTIONS(4991),
    [sym_global_variable] = ACTIONS(4991),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4989),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4989),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1132] = {
    [sym__statements] = STATE(1186),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_heredoc_body] = STATE(2986),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [sym__terminator] = STATE(2986),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__line_break] = ACTIONS(4993),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(4993),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(2111),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1133] = {
    [anon_sym_end] = ACTIONS(4951),
    [sym_comment] = ACTIONS(87),
  },
  [1134] = {
    [sym_when] = STATE(2960),
    [sym_else] = STATE(2958),
    [aux_sym_case_repeat1] = STATE(2987),
    [aux_sym_case_repeat2] = STATE(2960),
    [anon_sym_SEMI] = ACTIONS(4995),
    [anon_sym_end] = ACTIONS(4951),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [1135] = {
    [sym_when] = STATE(2988),
    [sym_else] = STATE(2958),
    [aux_sym_case_repeat2] = STATE(2988),
    [anon_sym_end] = ACTIONS(4951),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [1136] = {
    [sym__simple_symbol] = ACTIONS(3235),
    [sym__string_start] = ACTIONS(3235),
    [sym__symbol_start] = ACTIONS(3235),
    [sym__subshell_start] = ACTIONS(3235),
    [sym__regex_start] = ACTIONS(3235),
    [sym__string_array_start] = ACTIONS(3235),
    [sym__symbol_array_start] = ACTIONS(3235),
    [sym_heredoc_beginning] = ACTIONS(3235),
    [sym__unary_minus] = ACTIONS(3235),
    [ts_builtin_sym_end] = ACTIONS(3235),
    [anon_sym___END__] = ACTIONS(4997),
    [anon_sym_BEGIN] = ACTIONS(4997),
    [anon_sym_LBRACE] = ACTIONS(3235),
    [anon_sym_RBRACE] = ACTIONS(3235),
    [anon_sym_END] = ACTIONS(4997),
    [anon_sym_def] = ACTIONS(4997),
    [anon_sym_LPAREN] = ACTIONS(3235),
    [anon_sym_RPAREN] = ACTIONS(3235),
    [anon_sym_COLON_COLON] = ACTIONS(3235),
    [anon_sym_PIPE] = ACTIONS(3235),
    [anon_sym_SEMI] = ACTIONS(3235),
    [anon_sym_STAR] = ACTIONS(3235),
    [anon_sym_class] = ACTIONS(4997),
    [anon_sym_module] = ACTIONS(4997),
    [anon_sym_end] = ACTIONS(4997),
    [anon_sym_return] = ACTIONS(4997),
    [anon_sym_yield] = ACTIONS(4997),
    [anon_sym_break] = ACTIONS(4997),
    [anon_sym_next] = ACTIONS(4997),
    [sym_redo] = ACTIONS(4997),
    [sym_retry] = ACTIONS(4997),
    [anon_sym_if] = ACTIONS(4997),
    [anon_sym_unless] = ACTIONS(4997),
    [anon_sym_while] = ACTIONS(4997),
    [anon_sym_until] = ACTIONS(4997),
    [anon_sym_rescue] = ACTIONS(4997),
    [anon_sym_for] = ACTIONS(4997),
    [anon_sym_case] = ACTIONS(4997),
    [anon_sym_when] = ACTIONS(4997),
    [anon_sym_elsif] = ACTIONS(4997),
    [anon_sym_else] = ACTIONS(4997),
    [anon_sym_then] = ACTIONS(4997),
    [anon_sym_begin] = ACTIONS(4997),
    [anon_sym_ensure] = ACTIONS(4997),
    [anon_sym_PLUS] = ACTIONS(4997),
    [anon_sym_defined_QMARK] = ACTIONS(3235),
    [anon_sym_not] = ACTIONS(4997),
    [anon_sym_BANG] = ACTIONS(3235),
    [anon_sym_TILDE] = ACTIONS(3235),
    [sym_constant] = ACTIONS(4997),
    [sym_identifier] = ACTIONS(4997),
    [sym_instance_variable] = ACTIONS(3235),
    [sym_class_variable] = ACTIONS(3235),
    [sym_global_variable] = ACTIONS(3235),
    [anon_sym_undef] = ACTIONS(4997),
    [anon_sym_alias] = ACTIONS(4997),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4997),
    [sym_float] = ACTIONS(4997),
    [sym_complex] = ACTIONS(3235),
    [sym_super] = ACTIONS(4997),
    [anon_sym_true] = ACTIONS(4997),
    [anon_sym_TRUE] = ACTIONS(4997),
    [anon_sym_false] = ACTIONS(4997),
    [anon_sym_FALSE] = ACTIONS(4997),
    [sym_self] = ACTIONS(4997),
    [anon_sym_nil] = ACTIONS(4997),
    [anon_sym_NIL] = ACTIONS(4997),
    [sym_character] = ACTIONS(3235),
    [anon_sym_LBRACK2] = ACTIONS(3235),
    [anon_sym_DASH_GT] = ACTIONS(3235),
  },
  [1137] = {
    [sym_interpolation] = STATE(1787),
    [aux_sym_heredoc_body_repeat1] = STATE(1787),
    [sym__heredoc_content] = ACTIONS(3237),
    [sym_heredoc_end] = ACTIONS(4999),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(3237),
  },
  [1138] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_ensure] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [1139] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2997),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2999),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(2999),
    [sym_assignment] = STATE(2997),
    [sym_operator_assignment] = STATE(2997),
    [sym_conditional] = STATE(2997),
    [sym_range] = STATE(2997),
    [sym_binary] = STATE(2997),
    [sym_unary] = STATE(2997),
    [sym_left_assignment_list] = STATE(2998),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2999),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2999),
    [sym_false] = STATE(2999),
    [sym_nil] = STATE(2999),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(3000),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(5001),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5003),
    [anon_sym_yield] = ACTIONS(5005),
    [anon_sym_break] = ACTIONS(5007),
    [anon_sym_next] = ACTIONS(5009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5011),
    [anon_sym_defined_QMARK] = ACTIONS(5013),
    [anon_sym_not] = ACTIONS(5015),
    [anon_sym_BANG] = ACTIONS(5017),
    [anon_sym_TILDE] = ACTIONS(5017),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1140] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(3001),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2999),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(2999),
    [sym_assignment] = STATE(3001),
    [sym_operator_assignment] = STATE(3001),
    [sym_conditional] = STATE(3001),
    [sym_range] = STATE(3001),
    [sym_binary] = STATE(3001),
    [sym_unary] = STATE(3001),
    [sym_left_assignment_list] = STATE(2998),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2999),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2999),
    [sym_false] = STATE(2999),
    [sym_nil] = STATE(2999),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(3000),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(5001),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5003),
    [anon_sym_yield] = ACTIONS(5005),
    [anon_sym_break] = ACTIONS(5007),
    [anon_sym_next] = ACTIONS(5009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5011),
    [anon_sym_defined_QMARK] = ACTIONS(5013),
    [anon_sym_not] = ACTIONS(5015),
    [anon_sym_BANG] = ACTIONS(5017),
    [anon_sym_TILDE] = ACTIONS(5017),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1141] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3002),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1156),
    [sym_scope_resolution] = STATE(1152),
    [sym_call] = STATE(1152),
    [sym_method_call] = STATE(1156),
    [sym_assignment] = STATE(3002),
    [sym_operator_assignment] = STATE(3002),
    [sym_conditional] = STATE(3002),
    [sym_range] = STATE(3002),
    [sym_binary] = STATE(3002),
    [sym_unary] = STATE(3002),
    [sym_left_assignment_list] = STATE(1155),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1156),
    [sym__variable] = STATE(1152),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1156),
    [sym_false] = STATE(1156),
    [sym_nil] = STATE(1156),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3003),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2051),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2055),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2059),
    [anon_sym_next] = ACTIONS(2061),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5019),
    [anon_sym_defined_QMARK] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [anon_sym_BANG] = ACTIONS(2069),
    [anon_sym_TILDE] = ACTIONS(2069),
    [sym_constant] = ACTIONS(2075),
    [sym_identifier] = ACTIONS(2075),
    [sym_instance_variable] = ACTIONS(2073),
    [sym_class_variable] = ACTIONS(2073),
    [sym_global_variable] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2075),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1142] = {
    [anon_sym_COLON] = ACTIONS(5021),
    [sym_comment] = ACTIONS(87),
  },
  [1143] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(3005),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2999),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(2999),
    [sym_assignment] = STATE(3005),
    [sym_operator_assignment] = STATE(3005),
    [sym_conditional] = STATE(3005),
    [sym_range] = STATE(3005),
    [sym_binary] = STATE(3005),
    [sym_unary] = STATE(3005),
    [sym_left_assignment_list] = STATE(2998),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2999),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2999),
    [sym_false] = STATE(2999),
    [sym_nil] = STATE(2999),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(3000),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(5001),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5003),
    [anon_sym_yield] = ACTIONS(5005),
    [anon_sym_break] = ACTIONS(5007),
    [anon_sym_next] = ACTIONS(5009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5011),
    [anon_sym_defined_QMARK] = ACTIONS(5013),
    [anon_sym_not] = ACTIONS(5015),
    [anon_sym_BANG] = ACTIONS(5017),
    [anon_sym_TILDE] = ACTIONS(5017),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1144] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3011),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1156),
    [sym_scope_resolution] = STATE(1152),
    [sym_call] = STATE(1152),
    [sym_method_call] = STATE(1156),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(3012),
    [sym__argument] = STATE(3013),
    [sym_splat_argument] = STATE(3013),
    [sym_hash_splat_argument] = STATE(3013),
    [sym_block_argument] = STATE(3013),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_left_assignment_list] = STATE(1155),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1156),
    [sym__variable] = STATE(1152),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1156),
    [sym_false] = STATE(1156),
    [sym_nil] = STATE(1156),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3014),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(3013),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(5023),
    [sym__splat_star] = ACTIONS(5025),
    [sym__unary_minus] = ACTIONS(2051),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(5027),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(2055),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2059),
    [anon_sym_next] = ACTIONS(2061),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(377),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(377),
    [anon_sym_EQ_GT] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [anon_sym_BANG] = ACTIONS(2067),
    [anon_sym_TILDE] = ACTIONS(2069),
    [sym_constant] = ACTIONS(5029),
    [sym_identifier] = ACTIONS(5029),
    [sym_instance_variable] = ACTIONS(2073),
    [sym_class_variable] = ACTIONS(2073),
    [sym_global_variable] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2075),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1145] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3011),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1156),
    [sym_scope_resolution] = STATE(1152),
    [sym_call] = STATE(1152),
    [sym_method_call] = STATE(1156),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(3012),
    [sym__argument] = STATE(3013),
    [sym_splat_argument] = STATE(3013),
    [sym_hash_splat_argument] = STATE(3013),
    [sym_block_argument] = STATE(3013),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_left_assignment_list] = STATE(1155),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1156),
    [sym__variable] = STATE(1152),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1156),
    [sym_false] = STATE(1156),
    [sym_nil] = STATE(1156),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3014),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(3013),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(5023),
    [sym__splat_star] = ACTIONS(5025),
    [sym__unary_minus] = ACTIONS(2051),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(5027),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(2055),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2059),
    [anon_sym_next] = ACTIONS(2061),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(419),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(419),
    [anon_sym_EQ_GT] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [anon_sym_BANG] = ACTIONS(2067),
    [anon_sym_TILDE] = ACTIONS(2069),
    [sym_constant] = ACTIONS(5029),
    [sym_identifier] = ACTIONS(5029),
    [sym_instance_variable] = ACTIONS(2073),
    [sym_class_variable] = ACTIONS(2073),
    [sym_global_variable] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2075),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1146] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3011),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1156),
    [sym_scope_resolution] = STATE(1152),
    [sym_call] = STATE(1152),
    [sym_method_call] = STATE(1156),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(3012),
    [sym__argument] = STATE(3013),
    [sym_splat_argument] = STATE(3013),
    [sym_hash_splat_argument] = STATE(3013),
    [sym_block_argument] = STATE(3013),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_left_assignment_list] = STATE(1155),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1156),
    [sym__variable] = STATE(1152),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1156),
    [sym_false] = STATE(1156),
    [sym_nil] = STATE(1156),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3014),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(3013),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(5023),
    [sym__splat_star] = ACTIONS(5025),
    [sym__unary_minus] = ACTIONS(2051),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(5027),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(423),
    [anon_sym_return] = ACTIONS(2055),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2059),
    [anon_sym_next] = ACTIONS(2061),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(423),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(423),
    [anon_sym_EQ_GT] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [anon_sym_BANG] = ACTIONS(2067),
    [anon_sym_TILDE] = ACTIONS(2069),
    [sym_constant] = ACTIONS(5029),
    [sym_identifier] = ACTIONS(5029),
    [sym_instance_variable] = ACTIONS(2073),
    [sym_class_variable] = ACTIONS(2073),
    [sym_global_variable] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2075),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1147] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3011),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1156),
    [sym_scope_resolution] = STATE(1152),
    [sym_call] = STATE(1152),
    [sym_method_call] = STATE(1156),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(3012),
    [sym__argument] = STATE(3013),
    [sym_splat_argument] = STATE(3013),
    [sym_hash_splat_argument] = STATE(3013),
    [sym_block_argument] = STATE(3013),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_left_assignment_list] = STATE(1155),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1156),
    [sym__variable] = STATE(1152),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1156),
    [sym_false] = STATE(1156),
    [sym_nil] = STATE(1156),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3014),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(3013),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(5023),
    [sym__splat_star] = ACTIONS(5025),
    [sym__unary_minus] = ACTIONS(2051),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(5027),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(427),
    [anon_sym_return] = ACTIONS(2055),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2059),
    [anon_sym_next] = ACTIONS(2061),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(427),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(427),
    [anon_sym_EQ_GT] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [anon_sym_BANG] = ACTIONS(2067),
    [anon_sym_TILDE] = ACTIONS(2069),
    [sym_constant] = ACTIONS(5029),
    [sym_identifier] = ACTIONS(5029),
    [sym_instance_variable] = ACTIONS(2073),
    [sym_class_variable] = ACTIONS(2073),
    [sym_global_variable] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2075),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1148] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3015),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1156),
    [sym_scope_resolution] = STATE(1152),
    [sym_call] = STATE(1152),
    [sym_method_call] = STATE(1156),
    [sym_assignment] = STATE(3015),
    [sym_operator_assignment] = STATE(3015),
    [sym_conditional] = STATE(3015),
    [sym_range] = STATE(3015),
    [sym_binary] = STATE(3015),
    [sym_unary] = STATE(3015),
    [sym_left_assignment_list] = STATE(1155),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1156),
    [sym__variable] = STATE(1152),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1156),
    [sym_false] = STATE(1156),
    [sym_nil] = STATE(1156),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3003),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2051),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2055),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2059),
    [anon_sym_next] = ACTIONS(2061),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5019),
    [anon_sym_defined_QMARK] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [anon_sym_BANG] = ACTIONS(2069),
    [anon_sym_TILDE] = ACTIONS(2069),
    [sym_constant] = ACTIONS(2075),
    [sym_identifier] = ACTIONS(2075),
    [sym_instance_variable] = ACTIONS(2073),
    [sym_class_variable] = ACTIONS(2073),
    [sym_global_variable] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2075),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1149] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1156),
    [sym_scope_resolution] = STATE(1152),
    [sym_call] = STATE(1152),
    [sym_method_call] = STATE(1156),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(1155),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1156),
    [sym__variable] = STATE(1152),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1156),
    [sym_false] = STATE(1156),
    [sym_nil] = STATE(1156),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3003),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2051),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2055),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2059),
    [anon_sym_next] = ACTIONS(2061),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5019),
    [anon_sym_defined_QMARK] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [anon_sym_BANG] = ACTIONS(2069),
    [anon_sym_TILDE] = ACTIONS(2069),
    [sym_constant] = ACTIONS(2075),
    [sym_identifier] = ACTIONS(2075),
    [sym_instance_variable] = ACTIONS(2073),
    [sym_class_variable] = ACTIONS(2073),
    [sym_global_variable] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2075),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1150] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(5031),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_else] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_ensure] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [1151] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(5033),
    [sym__binary_star] = ACTIONS(5035),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(5037),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(5035),
    [anon_sym_AMP] = ACTIONS(5039),
    [anon_sym_LT] = ACTIONS(5041),
    [anon_sym_end] = ACTIONS(1625),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_unless] = ACTIONS(1625),
    [anon_sym_while] = ACTIONS(1625),
    [anon_sym_until] = ACTIONS(1625),
    [anon_sym_rescue] = ACTIONS(1625),
    [anon_sym_else] = ACTIONS(1625),
    [anon_sym_ensure] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(5021),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(5043),
    [anon_sym_DOT_DOT] = ACTIONS(5045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5047),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(5049),
    [anon_sym_AMP_AMP] = ACTIONS(5049),
    [anon_sym_LT_LT] = ACTIONS(5051),
    [anon_sym_GT_GT] = ACTIONS(5051),
    [anon_sym_EQ_EQ] = ACTIONS(5053),
    [anon_sym_BANG_EQ] = ACTIONS(5049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5049),
    [anon_sym_LT_EQ_GT] = ACTIONS(5049),
    [anon_sym_EQ_TILDE] = ACTIONS(5049),
    [anon_sym_BANG_TILDE] = ACTIONS(5049),
    [anon_sym_LT_EQ] = ACTIONS(5041),
    [anon_sym_GT] = ACTIONS(5041),
    [anon_sym_GT_EQ] = ACTIONS(5055),
    [anon_sym_CARET] = ACTIONS(5057),
    [anon_sym_PLUS] = ACTIONS(5033),
    [anon_sym_SLASH] = ACTIONS(5035),
    [anon_sym_PERCENT] = ACTIONS(5035),
    [sym_comment] = ACTIONS(87),
  },
  [1152] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3032),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1249),
    [sym_scope_resolution] = STATE(1245),
    [sym_call] = STATE(1245),
    [sym_method_call] = STATE(1249),
    [sym_argument_list] = STATE(938),
    [sym__argument_list_with_parens] = STATE(3033),
    [sym__argument] = STATE(3034),
    [sym_splat_argument] = STATE(3034),
    [sym_hash_splat_argument] = STATE(3034),
    [sym_block_argument] = STATE(3034),
    [sym_do_block] = STATE(941),
    [sym_block] = STATE(941),
    [sym_assignment] = STATE(3032),
    [sym_operator_assignment] = STATE(3032),
    [sym_conditional] = STATE(3032),
    [sym_range] = STATE(3032),
    [sym_binary] = STATE(3032),
    [sym_unary] = STATE(3032),
    [sym_left_assignment_list] = STATE(1248),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(1245),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1249),
    [sym_false] = STATE(1249),
    [sym_nil] = STATE(1249),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3035),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(3034),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(743),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(5059),
    [sym__splat_star] = ACTIONS(5061),
    [sym__unary_minus] = ACTIONS(2217),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(5063),
    [anon_sym_LBRACE] = ACTIONS(1669),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(769),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2223),
    [anon_sym_break] = ACTIONS(2225),
    [anon_sym_next] = ACTIONS(2227),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(769),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(769),
    [anon_sym_until] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(769),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(1671),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_else] = ACTIONS(769),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_ensure] = ACTIONS(769),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(2229),
    [anon_sym_not] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(2233),
    [anon_sym_TILDE] = ACTIONS(2235),
    [sym_constant] = ACTIONS(5065),
    [sym_identifier] = ACTIONS(5065),
    [sym_instance_variable] = ACTIONS(2239),
    [sym_class_variable] = ACTIONS(2239),
    [sym_global_variable] = ACTIONS(2239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(2241),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2241),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [1153] = {
    [sym_heredoc_body] = STATE(3036),
    [aux_sym_call_repeat1] = STATE(3036),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_else] = ACTIONS(1681),
    [anon_sym_ensure] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [1154] = {
    [sym_heredoc_body] = STATE(3036),
    [aux_sym_call_repeat1] = STATE(3036),
    [aux_sym_argument_list_repeat1] = STATE(3038),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(5067),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_else] = ACTIONS(1681),
    [anon_sym_ensure] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [1155] = {
    [anon_sym_EQ] = ACTIONS(5069),
    [sym_comment] = ACTIONS(87),
  },
  [1156] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(5071),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(5073),
    [anon_sym_DASH_EQ] = ACTIONS(5073),
    [anon_sym_STAR_EQ] = ACTIONS(5073),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5073),
    [anon_sym_SLASH_EQ] = ACTIONS(5073),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5073),
    [anon_sym_PIPE_EQ] = ACTIONS(5073),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5073),
    [anon_sym_AMP_EQ] = ACTIONS(5073),
    [anon_sym_PERCENT_EQ] = ACTIONS(5073),
    [anon_sym_GT_GT_EQ] = ACTIONS(5073),
    [anon_sym_LT_LT_EQ] = ACTIONS(5073),
    [anon_sym_CARET_EQ] = ACTIONS(5073),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1157] = {
    [sym_string] = STATE(3041),
    [aux_sym_chained_string_repeat1] = STATE(3041),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(5075),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [1158] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3042),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1175),
    [sym_scope_resolution] = STATE(1172),
    [sym_call] = STATE(1172),
    [sym_method_call] = STATE(1175),
    [sym_assignment] = STATE(3042),
    [sym_operator_assignment] = STATE(3042),
    [sym_conditional] = STATE(3042),
    [sym_range] = STATE(3042),
    [sym_binary] = STATE(3042),
    [sym_unary] = STATE(3042),
    [sym_left_assignment_list] = STATE(1174),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1175),
    [sym__variable] = STATE(1172),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1175),
    [sym_false] = STATE(1175),
    [sym_nil] = STATE(1175),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1176),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2081),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2085),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_next] = ACTIONS(2089),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2095),
    [anon_sym_defined_QMARK] = ACTIONS(2097),
    [anon_sym_not] = ACTIONS(2099),
    [anon_sym_BANG] = ACTIONS(2101),
    [anon_sym_TILDE] = ACTIONS(2101),
    [sym_constant] = ACTIONS(2103),
    [sym_identifier] = ACTIONS(2103),
    [sym_instance_variable] = ACTIONS(2105),
    [sym_class_variable] = ACTIONS(2105),
    [sym_global_variable] = ACTIONS(2105),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2103),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2103),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1159] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3043),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1175),
    [sym_scope_resolution] = STATE(1172),
    [sym_call] = STATE(1172),
    [sym_method_call] = STATE(1175),
    [sym_assignment] = STATE(3043),
    [sym_operator_assignment] = STATE(3043),
    [sym_conditional] = STATE(3043),
    [sym_range] = STATE(3043),
    [sym_binary] = STATE(3043),
    [sym_unary] = STATE(3043),
    [sym_left_assignment_list] = STATE(1174),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1175),
    [sym__variable] = STATE(1172),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1175),
    [sym_false] = STATE(1175),
    [sym_nil] = STATE(1175),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1176),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2081),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2085),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_next] = ACTIONS(2089),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2095),
    [anon_sym_defined_QMARK] = ACTIONS(2097),
    [anon_sym_not] = ACTIONS(2099),
    [anon_sym_BANG] = ACTIONS(2101),
    [anon_sym_TILDE] = ACTIONS(2101),
    [sym_constant] = ACTIONS(2103),
    [sym_identifier] = ACTIONS(2103),
    [sym_instance_variable] = ACTIONS(2105),
    [sym_class_variable] = ACTIONS(2105),
    [sym_global_variable] = ACTIONS(2105),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2103),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2103),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1160] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3052),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3056),
    [sym_scope_resolution] = STATE(1172),
    [sym_call] = STATE(1172),
    [sym_method_call] = STATE(3056),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(3053),
    [sym__argument] = STATE(3054),
    [sym_splat_argument] = STATE(3054),
    [sym_hash_splat_argument] = STATE(3054),
    [sym_block_argument] = STATE(3054),
    [sym_assignment] = STATE(3052),
    [sym_operator_assignment] = STATE(3052),
    [sym_conditional] = STATE(3052),
    [sym_range] = STATE(3052),
    [sym_binary] = STATE(3052),
    [sym_unary] = STATE(3052),
    [sym_left_assignment_list] = STATE(3055),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3056),
    [sym__variable] = STATE(1172),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3056),
    [sym_false] = STATE(3056),
    [sym_nil] = STATE(3056),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3057),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(3054),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(5077),
    [sym__splat_star] = ACTIONS(5079),
    [sym__unary_minus] = ACTIONS(5081),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(5083),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2085),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_next] = ACTIONS(2089),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(377),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(5085),
    [anon_sym_not] = ACTIONS(5087),
    [anon_sym_BANG] = ACTIONS(5089),
    [anon_sym_TILDE] = ACTIONS(5091),
    [sym_constant] = ACTIONS(5093),
    [sym_identifier] = ACTIONS(5093),
    [sym_instance_variable] = ACTIONS(2105),
    [sym_class_variable] = ACTIONS(2105),
    [sym_global_variable] = ACTIONS(2105),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2103),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2103),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1161] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3052),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3056),
    [sym_scope_resolution] = STATE(1172),
    [sym_call] = STATE(1172),
    [sym_method_call] = STATE(3056),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(3053),
    [sym__argument] = STATE(3054),
    [sym_splat_argument] = STATE(3054),
    [sym_hash_splat_argument] = STATE(3054),
    [sym_block_argument] = STATE(3054),
    [sym_assignment] = STATE(3052),
    [sym_operator_assignment] = STATE(3052),
    [sym_conditional] = STATE(3052),
    [sym_range] = STATE(3052),
    [sym_binary] = STATE(3052),
    [sym_unary] = STATE(3052),
    [sym_left_assignment_list] = STATE(3055),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3056),
    [sym__variable] = STATE(1172),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3056),
    [sym_false] = STATE(3056),
    [sym_nil] = STATE(3056),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3057),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(3054),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(5077),
    [sym__splat_star] = ACTIONS(5079),
    [sym__unary_minus] = ACTIONS(5081),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(5083),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2085),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_next] = ACTIONS(2089),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(419),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(5085),
    [anon_sym_not] = ACTIONS(5087),
    [anon_sym_BANG] = ACTIONS(5089),
    [anon_sym_TILDE] = ACTIONS(5091),
    [sym_constant] = ACTIONS(5093),
    [sym_identifier] = ACTIONS(5093),
    [sym_instance_variable] = ACTIONS(2105),
    [sym_class_variable] = ACTIONS(2105),
    [sym_global_variable] = ACTIONS(2105),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2103),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2103),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1162] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3052),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3056),
    [sym_scope_resolution] = STATE(1172),
    [sym_call] = STATE(1172),
    [sym_method_call] = STATE(3056),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(3053),
    [sym__argument] = STATE(3054),
    [sym_splat_argument] = STATE(3054),
    [sym_hash_splat_argument] = STATE(3054),
    [sym_block_argument] = STATE(3054),
    [sym_assignment] = STATE(3052),
    [sym_operator_assignment] = STATE(3052),
    [sym_conditional] = STATE(3052),
    [sym_range] = STATE(3052),
    [sym_binary] = STATE(3052),
    [sym_unary] = STATE(3052),
    [sym_left_assignment_list] = STATE(3055),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3056),
    [sym__variable] = STATE(1172),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3056),
    [sym_false] = STATE(3056),
    [sym_nil] = STATE(3056),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3057),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(3054),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(5077),
    [sym__splat_star] = ACTIONS(5079),
    [sym__unary_minus] = ACTIONS(5081),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(5083),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2085),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_next] = ACTIONS(2089),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(423),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(5085),
    [anon_sym_not] = ACTIONS(5087),
    [anon_sym_BANG] = ACTIONS(5089),
    [anon_sym_TILDE] = ACTIONS(5091),
    [sym_constant] = ACTIONS(5093),
    [sym_identifier] = ACTIONS(5093),
    [sym_instance_variable] = ACTIONS(2105),
    [sym_class_variable] = ACTIONS(2105),
    [sym_global_variable] = ACTIONS(2105),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2103),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2103),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1163] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3052),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3056),
    [sym_scope_resolution] = STATE(1172),
    [sym_call] = STATE(1172),
    [sym_method_call] = STATE(3056),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(3053),
    [sym__argument] = STATE(3054),
    [sym_splat_argument] = STATE(3054),
    [sym_hash_splat_argument] = STATE(3054),
    [sym_block_argument] = STATE(3054),
    [sym_assignment] = STATE(3052),
    [sym_operator_assignment] = STATE(3052),
    [sym_conditional] = STATE(3052),
    [sym_range] = STATE(3052),
    [sym_binary] = STATE(3052),
    [sym_unary] = STATE(3052),
    [sym_left_assignment_list] = STATE(3055),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3056),
    [sym__variable] = STATE(1172),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3056),
    [sym_false] = STATE(3056),
    [sym_nil] = STATE(3056),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3057),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(3054),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(5077),
    [sym__splat_star] = ACTIONS(5079),
    [sym__unary_minus] = ACTIONS(5081),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(5083),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2085),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_next] = ACTIONS(2089),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(427),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(5085),
    [anon_sym_not] = ACTIONS(5087),
    [anon_sym_BANG] = ACTIONS(5089),
    [anon_sym_TILDE] = ACTIONS(5091),
    [sym_constant] = ACTIONS(5093),
    [sym_identifier] = ACTIONS(5093),
    [sym_instance_variable] = ACTIONS(2105),
    [sym_class_variable] = ACTIONS(2105),
    [sym_global_variable] = ACTIONS(2105),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2103),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2103),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1164] = {
    [sym__statements] = STATE(2640),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(4469),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(4469),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(4469),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(4469),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1165] = {
    [sym_method] = STATE(3061),
    [sym_singleton_method] = STATE(3061),
    [sym_class] = STATE(3061),
    [sym_singleton_class] = STATE(3061),
    [sym_module] = STATE(3061),
    [sym_return] = STATE(3061),
    [sym_yield] = STATE(3061),
    [sym_break] = STATE(3061),
    [sym_next] = STATE(3061),
    [sym_while] = STATE(3061),
    [sym_until] = STATE(3061),
    [sym_for] = STATE(3061),
    [sym_case] = STATE(3061),
    [sym_if] = STATE(3061),
    [sym_unless] = STATE(3061),
    [sym_begin] = STATE(3061),
    [sym__primary] = STATE(3061),
    [sym_parenthesized_statements] = STATE(3061),
    [sym_element_reference] = STATE(3063),
    [sym_scope_resolution] = STATE(3062),
    [sym_call] = STATE(3062),
    [sym_method_call] = STATE(3063),
    [sym__lhs] = STATE(3063),
    [sym__variable] = STATE(3062),
    [sym_rational] = STATE(3061),
    [sym_true] = STATE(3063),
    [sym_false] = STATE(3063),
    [sym_nil] = STATE(3063),
    [sym_chained_string] = STATE(3061),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(3061),
    [sym_string_array] = STATE(3061),
    [sym_symbol_array] = STATE(3061),
    [sym_symbol] = STATE(3061),
    [sym_regex] = STATE(3061),
    [sym_array] = STATE(3061),
    [sym_hash] = STATE(3061),
    [sym_lambda] = STATE(3061),
    [sym__simple_symbol] = ACTIONS(279),
    [sym__string_start] = ACTIONS(281),
    [sym__symbol_start] = ACTIONS(283),
    [sym__subshell_start] = ACTIONS(285),
    [sym__regex_start] = ACTIONS(287),
    [sym__string_array_start] = ACTIONS(289),
    [sym__symbol_array_start] = ACTIONS(291),
    [sym_heredoc_beginning] = ACTIONS(5095),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_def] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(299),
    [anon_sym_COLON_COLON] = ACTIONS(353),
    [anon_sym_class] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(307),
    [anon_sym_return] = ACTIONS(309),
    [anon_sym_yield] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_next] = ACTIONS(315),
    [sym_redo] = ACTIONS(5097),
    [sym_retry] = ACTIONS(5097),
    [anon_sym_if] = ACTIONS(319),
    [anon_sym_unless] = ACTIONS(321),
    [anon_sym_while] = ACTIONS(323),
    [anon_sym_until] = ACTIONS(325),
    [anon_sym_for] = ACTIONS(327),
    [anon_sym_case] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(331),
    [sym_constant] = ACTIONS(5099),
    [sym_identifier] = ACTIONS(5099),
    [sym_instance_variable] = ACTIONS(5101),
    [sym_class_variable] = ACTIONS(5101),
    [sym_global_variable] = ACTIONS(5101),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(5097),
    [sym_complex] = ACTIONS(5095),
    [sym_super] = ACTIONS(5099),
    [anon_sym_true] = ACTIONS(5103),
    [anon_sym_TRUE] = ACTIONS(5103),
    [anon_sym_false] = ACTIONS(5105),
    [anon_sym_FALSE] = ACTIONS(5105),
    [sym_self] = ACTIONS(5099),
    [anon_sym_nil] = ACTIONS(5107),
    [anon_sym_NIL] = ACTIONS(5107),
    [sym_character] = ACTIONS(5095),
    [anon_sym_LBRACK2] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(347),
  },
  [1166] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3064),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1175),
    [sym_scope_resolution] = STATE(1172),
    [sym_call] = STATE(1172),
    [sym_method_call] = STATE(1175),
    [sym_assignment] = STATE(3064),
    [sym_operator_assignment] = STATE(3064),
    [sym_conditional] = STATE(3064),
    [sym_range] = STATE(3064),
    [sym_binary] = STATE(3064),
    [sym_unary] = STATE(3064),
    [sym_left_assignment_list] = STATE(1174),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1175),
    [sym__variable] = STATE(1172),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1175),
    [sym_false] = STATE(1175),
    [sym_nil] = STATE(1175),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1176),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2081),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2085),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_next] = ACTIONS(2089),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2095),
    [anon_sym_defined_QMARK] = ACTIONS(2097),
    [anon_sym_not] = ACTIONS(2099),
    [anon_sym_BANG] = ACTIONS(2101),
    [anon_sym_TILDE] = ACTIONS(2101),
    [sym_constant] = ACTIONS(2103),
    [sym_identifier] = ACTIONS(2103),
    [sym_instance_variable] = ACTIONS(2105),
    [sym_class_variable] = ACTIONS(2105),
    [sym_global_variable] = ACTIONS(2105),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2103),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2103),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1167] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(298),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1175),
    [sym_scope_resolution] = STATE(1172),
    [sym_call] = STATE(1172),
    [sym_method_call] = STATE(1175),
    [sym_assignment] = STATE(298),
    [sym_operator_assignment] = STATE(298),
    [sym_conditional] = STATE(298),
    [sym_range] = STATE(298),
    [sym_binary] = STATE(298),
    [sym_unary] = STATE(298),
    [sym_left_assignment_list] = STATE(1174),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1175),
    [sym__variable] = STATE(1172),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1175),
    [sym_false] = STATE(1175),
    [sym_nil] = STATE(1175),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1176),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2081),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2085),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_next] = ACTIONS(2089),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2095),
    [anon_sym_defined_QMARK] = ACTIONS(2097),
    [anon_sym_not] = ACTIONS(2099),
    [anon_sym_BANG] = ACTIONS(2101),
    [anon_sym_TILDE] = ACTIONS(2101),
    [sym_constant] = ACTIONS(2103),
    [sym_identifier] = ACTIONS(2103),
    [sym_instance_variable] = ACTIONS(2105),
    [sym_class_variable] = ACTIONS(2105),
    [sym_global_variable] = ACTIONS(2105),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2103),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2103),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1168] = {
    [sym_rescue] = STATE(3065),
    [anon_sym_end] = ACTIONS(5109),
    [anon_sym_rescue] = ACTIONS(2165),
    [anon_sym_else] = ACTIONS(5109),
    [anon_sym_ensure] = ACTIONS(5109),
    [sym_comment] = ACTIONS(87),
  },
  [1169] = {
    [sym_then] = STATE(3066),
    [sym_exception_variable] = STATE(3067),
    [sym_heredoc_body] = STATE(3068),
    [sym__terminator] = STATE(3068),
    [sym__line_break] = ACTIONS(5111),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(5111),
    [anon_sym_then] = ACTIONS(5113),
    [anon_sym_EQ_GT] = ACTIONS(2093),
    [sym_comment] = ACTIONS(87),
  },
  [1170] = {
    [sym_then] = STATE(3066),
    [sym_heredoc_body] = STATE(3068),
    [sym__terminator] = STATE(3068),
    [sym__line_break] = ACTIONS(5111),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(5111),
    [anon_sym_then] = ACTIONS(5113),
    [sym_comment] = ACTIONS(87),
  },
  [1171] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(5117),
    [sym__binary_star] = ACTIONS(5119),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(5121),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(5119),
    [anon_sym_AMP] = ACTIONS(5123),
    [anon_sym_LT] = ACTIONS(5125),
    [anon_sym_then] = ACTIONS(5115),
    [anon_sym_EQ_GT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(5127),
    [anon_sym_DOT_DOT] = ACTIONS(5129),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5131),
    [anon_sym_and] = ACTIONS(5133),
    [anon_sym_or] = ACTIONS(5133),
    [anon_sym_PIPE_PIPE] = ACTIONS(5135),
    [anon_sym_AMP_AMP] = ACTIONS(5135),
    [anon_sym_LT_LT] = ACTIONS(5137),
    [anon_sym_GT_GT] = ACTIONS(5137),
    [anon_sym_EQ_EQ] = ACTIONS(5139),
    [anon_sym_BANG_EQ] = ACTIONS(5135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5135),
    [anon_sym_LT_EQ_GT] = ACTIONS(5135),
    [anon_sym_EQ_TILDE] = ACTIONS(5135),
    [anon_sym_BANG_TILDE] = ACTIONS(5135),
    [anon_sym_LT_EQ] = ACTIONS(5125),
    [anon_sym_GT] = ACTIONS(5125),
    [anon_sym_GT_EQ] = ACTIONS(5141),
    [anon_sym_CARET] = ACTIONS(5143),
    [anon_sym_PLUS] = ACTIONS(5117),
    [anon_sym_SLASH] = ACTIONS(5119),
    [anon_sym_PERCENT] = ACTIONS(5119),
    [sym_comment] = ACTIONS(87),
  },
  [1172] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3091),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3096),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(3096),
    [sym_argument_list] = STATE(938),
    [sym__argument_list_with_parens] = STATE(3093),
    [sym__argument] = STATE(3094),
    [sym_splat_argument] = STATE(3094),
    [sym_hash_splat_argument] = STATE(3094),
    [sym_block_argument] = STATE(3094),
    [sym_do_block] = STATE(941),
    [sym_block] = STATE(941),
    [sym_assignment] = STATE(3091),
    [sym_operator_assignment] = STATE(3091),
    [sym_conditional] = STATE(3091),
    [sym_range] = STATE(3091),
    [sym_binary] = STATE(3091),
    [sym_unary] = STATE(3091),
    [sym_left_assignment_list] = STATE(3095),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3096),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3096),
    [sym_false] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3097),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(3094),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(743),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(5145),
    [sym__splat_star] = ACTIONS(5147),
    [sym__unary_minus] = ACTIONS(5149),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(5151),
    [anon_sym_LBRACE] = ACTIONS(1669),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5153),
    [anon_sym_yield] = ACTIONS(5155),
    [anon_sym_break] = ACTIONS(5157),
    [anon_sym_next] = ACTIONS(5159),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(1671),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_then] = ACTIONS(769),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(5161),
    [anon_sym_not] = ACTIONS(5163),
    [anon_sym_BANG] = ACTIONS(5165),
    [anon_sym_TILDE] = ACTIONS(5167),
    [sym_constant] = ACTIONS(5169),
    [sym_identifier] = ACTIONS(5169),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [1173] = {
    [aux_sym_exceptions_repeat1] = STATE(3099),
    [sym__line_break] = ACTIONS(5175),
    [sym__heredoc_body_start] = ACTIONS(5175),
    [anon_sym_COMMA] = ACTIONS(5177),
    [anon_sym_SEMI] = ACTIONS(5175),
    [anon_sym_then] = ACTIONS(5175),
    [anon_sym_EQ_GT] = ACTIONS(5175),
    [sym_comment] = ACTIONS(87),
  },
  [1174] = {
    [anon_sym_EQ] = ACTIONS(5179),
    [sym_comment] = ACTIONS(87),
  },
  [1175] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(5181),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(5183),
    [anon_sym_DASH_EQ] = ACTIONS(5183),
    [anon_sym_STAR_EQ] = ACTIONS(5183),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5183),
    [anon_sym_SLASH_EQ] = ACTIONS(5183),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5183),
    [anon_sym_PIPE_EQ] = ACTIONS(5183),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5183),
    [anon_sym_AMP_EQ] = ACTIONS(5183),
    [anon_sym_PERCENT_EQ] = ACTIONS(5183),
    [anon_sym_GT_GT_EQ] = ACTIONS(5183),
    [anon_sym_LT_LT_EQ] = ACTIONS(5183),
    [anon_sym_CARET_EQ] = ACTIONS(5183),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1176] = {
    [sym_string] = STATE(3102),
    [aux_sym_chained_string_repeat1] = STATE(3102),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [1177] = {
    [sym__statements] = STATE(2640),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym_rescue] = STATE(3065),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(5185),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(5185),
    [anon_sym_then] = ACTIONS(5187),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(5185),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1178] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(3104),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1191),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(1191),
    [sym_assignment] = STATE(3104),
    [sym_operator_assignment] = STATE(3104),
    [sym_conditional] = STATE(3104),
    [sym_range] = STATE(3104),
    [sym_binary] = STATE(3104),
    [sym_unary] = STATE(3104),
    [sym_left_assignment_list] = STATE(1190),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1191),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1191),
    [sym_false] = STATE(1191),
    [sym_nil] = STATE(1191),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1192),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2113),
    [anon_sym_yield] = ACTIONS(2115),
    [anon_sym_break] = ACTIONS(2117),
    [anon_sym_next] = ACTIONS(2119),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_defined_QMARK] = ACTIONS(2123),
    [anon_sym_not] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2127),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1179] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3117),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(3118),
    [sym_call] = STATE(3118),
    [sym_method_call] = STATE(3122),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(3119),
    [sym__argument] = STATE(3120),
    [sym_splat_argument] = STATE(3120),
    [sym_hash_splat_argument] = STATE(3120),
    [sym_block_argument] = STATE(3120),
    [sym_assignment] = STATE(3117),
    [sym_operator_assignment] = STATE(3117),
    [sym_conditional] = STATE(3117),
    [sym_range] = STATE(3117),
    [sym_binary] = STATE(3117),
    [sym_unary] = STATE(3117),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(3118),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3123),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(3120),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(5189),
    [sym__splat_star] = ACTIONS(5191),
    [sym__unary_minus] = ACTIONS(5193),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(5195),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(5197),
    [anon_sym_yield] = ACTIONS(5199),
    [anon_sym_break] = ACTIONS(5201),
    [anon_sym_next] = ACTIONS(5203),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(377),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(5205),
    [anon_sym_not] = ACTIONS(5207),
    [anon_sym_BANG] = ACTIONS(5209),
    [anon_sym_TILDE] = ACTIONS(5211),
    [sym_constant] = ACTIONS(5213),
    [sym_identifier] = ACTIONS(5213),
    [sym_instance_variable] = ACTIONS(5215),
    [sym_class_variable] = ACTIONS(5215),
    [sym_global_variable] = ACTIONS(5215),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5217),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5217),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1180] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3117),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(3118),
    [sym_call] = STATE(3118),
    [sym_method_call] = STATE(3122),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(3119),
    [sym__argument] = STATE(3120),
    [sym_splat_argument] = STATE(3120),
    [sym_hash_splat_argument] = STATE(3120),
    [sym_block_argument] = STATE(3120),
    [sym_assignment] = STATE(3117),
    [sym_operator_assignment] = STATE(3117),
    [sym_conditional] = STATE(3117),
    [sym_range] = STATE(3117),
    [sym_binary] = STATE(3117),
    [sym_unary] = STATE(3117),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(3118),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3123),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(3120),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(5189),
    [sym__splat_star] = ACTIONS(5191),
    [sym__unary_minus] = ACTIONS(5193),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(5195),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(5197),
    [anon_sym_yield] = ACTIONS(5199),
    [anon_sym_break] = ACTIONS(5201),
    [anon_sym_next] = ACTIONS(5203),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(5205),
    [anon_sym_not] = ACTIONS(5207),
    [anon_sym_BANG] = ACTIONS(5209),
    [anon_sym_TILDE] = ACTIONS(5211),
    [sym_constant] = ACTIONS(5213),
    [sym_identifier] = ACTIONS(5213),
    [sym_instance_variable] = ACTIONS(5215),
    [sym_class_variable] = ACTIONS(5215),
    [sym_global_variable] = ACTIONS(5215),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5217),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5217),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1181] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3117),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(3118),
    [sym_call] = STATE(3118),
    [sym_method_call] = STATE(3122),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(3119),
    [sym__argument] = STATE(3120),
    [sym_splat_argument] = STATE(3120),
    [sym_hash_splat_argument] = STATE(3120),
    [sym_block_argument] = STATE(3120),
    [sym_assignment] = STATE(3117),
    [sym_operator_assignment] = STATE(3117),
    [sym_conditional] = STATE(3117),
    [sym_range] = STATE(3117),
    [sym_binary] = STATE(3117),
    [sym_unary] = STATE(3117),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(3118),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3123),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(3120),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(5189),
    [sym__splat_star] = ACTIONS(5191),
    [sym__unary_minus] = ACTIONS(5193),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(5195),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(423),
    [anon_sym_return] = ACTIONS(5197),
    [anon_sym_yield] = ACTIONS(5199),
    [anon_sym_break] = ACTIONS(5201),
    [anon_sym_next] = ACTIONS(5203),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(5205),
    [anon_sym_not] = ACTIONS(5207),
    [anon_sym_BANG] = ACTIONS(5209),
    [anon_sym_TILDE] = ACTIONS(5211),
    [sym_constant] = ACTIONS(5213),
    [sym_identifier] = ACTIONS(5213),
    [sym_instance_variable] = ACTIONS(5215),
    [sym_class_variable] = ACTIONS(5215),
    [sym_global_variable] = ACTIONS(5215),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5217),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5217),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1182] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3117),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(3118),
    [sym_call] = STATE(3118),
    [sym_method_call] = STATE(3122),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(3119),
    [sym__argument] = STATE(3120),
    [sym_splat_argument] = STATE(3120),
    [sym_hash_splat_argument] = STATE(3120),
    [sym_block_argument] = STATE(3120),
    [sym_assignment] = STATE(3117),
    [sym_operator_assignment] = STATE(3117),
    [sym_conditional] = STATE(3117),
    [sym_range] = STATE(3117),
    [sym_binary] = STATE(3117),
    [sym_unary] = STATE(3117),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(3118),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3123),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(3120),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(5189),
    [sym__splat_star] = ACTIONS(5191),
    [sym__unary_minus] = ACTIONS(5193),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(5195),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(427),
    [anon_sym_return] = ACTIONS(5197),
    [anon_sym_yield] = ACTIONS(5199),
    [anon_sym_break] = ACTIONS(5201),
    [anon_sym_next] = ACTIONS(5203),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(5205),
    [anon_sym_not] = ACTIONS(5207),
    [anon_sym_BANG] = ACTIONS(5209),
    [anon_sym_TILDE] = ACTIONS(5211),
    [sym_constant] = ACTIONS(5213),
    [sym_identifier] = ACTIONS(5213),
    [sym_instance_variable] = ACTIONS(5215),
    [sym_class_variable] = ACTIONS(5215),
    [sym_global_variable] = ACTIONS(5215),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5217),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5217),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1183] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(3124),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1191),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(1191),
    [sym_assignment] = STATE(3124),
    [sym_operator_assignment] = STATE(3124),
    [sym_conditional] = STATE(3124),
    [sym_range] = STATE(3124),
    [sym_binary] = STATE(3124),
    [sym_unary] = STATE(3124),
    [sym_left_assignment_list] = STATE(1190),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1191),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1191),
    [sym_false] = STATE(1191),
    [sym_nil] = STATE(1191),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1192),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2113),
    [anon_sym_yield] = ACTIONS(2115),
    [anon_sym_break] = ACTIONS(2117),
    [anon_sym_next] = ACTIONS(2119),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_defined_QMARK] = ACTIONS(2123),
    [anon_sym_not] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2127),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1184] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(298),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1191),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(1191),
    [sym_assignment] = STATE(298),
    [sym_operator_assignment] = STATE(298),
    [sym_conditional] = STATE(298),
    [sym_range] = STATE(298),
    [sym_binary] = STATE(298),
    [sym_unary] = STATE(298),
    [sym_left_assignment_list] = STATE(1190),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1191),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1191),
    [sym_false] = STATE(1191),
    [sym_nil] = STATE(1191),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1192),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2113),
    [anon_sym_yield] = ACTIONS(2115),
    [anon_sym_break] = ACTIONS(2117),
    [anon_sym_next] = ACTIONS(2119),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_defined_QMARK] = ACTIONS(2123),
    [anon_sym_not] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2127),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1185] = {
    [sym_operator] = STATE(3125),
    [sym__method_name] = STATE(3125),
    [sym_setter] = STATE(3125),
    [sym_symbol] = STATE(3125),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(5219),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(5219),
    [sym_class_variable] = ACTIONS(5219),
    [sym_global_variable] = ACTIONS(5219),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [1186] = {
    [anon_sym_end] = ACTIONS(5221),
    [anon_sym_ensure] = ACTIONS(5221),
    [sym_comment] = ACTIONS(87),
  },
  [1187] = {
    [sym_heredoc_body] = STATE(370),
    [sym__terminator] = STATE(370),
    [sym__line_break] = ACTIONS(687),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(687),
    [anon_sym_end] = ACTIONS(689),
    [anon_sym_if] = ACTIONS(5223),
    [anon_sym_unless] = ACTIONS(5225),
    [anon_sym_while] = ACTIONS(5227),
    [anon_sym_until] = ACTIONS(5229),
    [anon_sym_rescue] = ACTIONS(5231),
    [anon_sym_ensure] = ACTIONS(689),
    [sym_comment] = ACTIONS(87),
  },
  [1188] = {
    [sym__line_break] = ACTIONS(701),
    [sym__heredoc_body_start] = ACTIONS(701),
    [sym__binary_minus] = ACTIONS(5233),
    [sym__binary_star] = ACTIONS(5235),
    [anon_sym_PIPE] = ACTIONS(5237),
    [anon_sym_SEMI] = ACTIONS(701),
    [anon_sym_STAR_STAR] = ACTIONS(5235),
    [anon_sym_AMP] = ACTIONS(5239),
    [anon_sym_LT] = ACTIONS(5241),
    [anon_sym_end] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_unless] = ACTIONS(701),
    [anon_sym_while] = ACTIONS(701),
    [anon_sym_until] = ACTIONS(701),
    [anon_sym_rescue] = ACTIONS(701),
    [anon_sym_ensure] = ACTIONS(701),
    [anon_sym_QMARK] = ACTIONS(5243),
    [anon_sym_DOT_DOT] = ACTIONS(5245),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5247),
    [anon_sym_and] = ACTIONS(5249),
    [anon_sym_or] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5251),
    [anon_sym_AMP_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5253),
    [anon_sym_GT_GT] = ACTIONS(5253),
    [anon_sym_EQ_EQ] = ACTIONS(5255),
    [anon_sym_BANG_EQ] = ACTIONS(5251),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5251),
    [anon_sym_LT_EQ_GT] = ACTIONS(5251),
    [anon_sym_EQ_TILDE] = ACTIONS(5251),
    [anon_sym_BANG_TILDE] = ACTIONS(5251),
    [anon_sym_LT_EQ] = ACTIONS(5241),
    [anon_sym_GT] = ACTIONS(5241),
    [anon_sym_GT_EQ] = ACTIONS(5257),
    [anon_sym_CARET] = ACTIONS(5259),
    [anon_sym_PLUS] = ACTIONS(5233),
    [anon_sym_SLASH] = ACTIONS(5235),
    [anon_sym_PERCENT] = ACTIONS(5235),
    [sym_comment] = ACTIONS(87),
  },
  [1189] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3153),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3158),
    [sym_scope_resolution] = STATE(3154),
    [sym_call] = STATE(3154),
    [sym_method_call] = STATE(3158),
    [sym_argument_list] = STATE(423),
    [sym__argument_list_with_parens] = STATE(3155),
    [sym__argument] = STATE(3156),
    [sym_splat_argument] = STATE(3156),
    [sym_hash_splat_argument] = STATE(3156),
    [sym_block_argument] = STATE(3156),
    [sym_do_block] = STATE(426),
    [sym_block] = STATE(426),
    [sym_assignment] = STATE(3153),
    [sym_operator_assignment] = STATE(3153),
    [sym_conditional] = STATE(3153),
    [sym_range] = STATE(3153),
    [sym_binary] = STATE(3153),
    [sym_unary] = STATE(3153),
    [sym_left_assignment_list] = STATE(3157),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3158),
    [sym__variable] = STATE(3154),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3158),
    [sym_false] = STATE(3158),
    [sym_nil] = STATE(3158),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3159),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(3156),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(743),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(5261),
    [sym__splat_star] = ACTIONS(5263),
    [sym__unary_minus] = ACTIONS(5265),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(5267),
    [anon_sym_LBRACE] = ACTIONS(771),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(769),
    [anon_sym_return] = ACTIONS(5269),
    [anon_sym_yield] = ACTIONS(5271),
    [anon_sym_break] = ACTIONS(5273),
    [anon_sym_next] = ACTIONS(5275),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(769),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(769),
    [anon_sym_until] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(769),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_ensure] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(5277),
    [anon_sym_not] = ACTIONS(5279),
    [anon_sym_BANG] = ACTIONS(5281),
    [anon_sym_TILDE] = ACTIONS(5283),
    [sym_constant] = ACTIONS(5285),
    [sym_identifier] = ACTIONS(5285),
    [sym_instance_variable] = ACTIONS(5287),
    [sym_class_variable] = ACTIONS(5287),
    [sym_global_variable] = ACTIONS(5287),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5289),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5289),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [1190] = {
    [anon_sym_EQ] = ACTIONS(5291),
    [sym_comment] = ACTIONS(87),
  },
  [1191] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(5293),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(5295),
    [anon_sym_DASH_EQ] = ACTIONS(5295),
    [anon_sym_STAR_EQ] = ACTIONS(5295),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5295),
    [anon_sym_SLASH_EQ] = ACTIONS(5295),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5295),
    [anon_sym_PIPE_EQ] = ACTIONS(5295),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5295),
    [anon_sym_AMP_EQ] = ACTIONS(5295),
    [anon_sym_PERCENT_EQ] = ACTIONS(5295),
    [anon_sym_GT_GT_EQ] = ACTIONS(5295),
    [anon_sym_LT_LT_EQ] = ACTIONS(5295),
    [anon_sym_CARET_EQ] = ACTIONS(5295),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1192] = {
    [sym_string] = STATE(3162),
    [aux_sym_chained_string_repeat1] = STATE(3162),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [1193] = {
    [sym__statements] = STATE(3163),
    [sym_begin_block] = STATE(1187),
    [sym_end_block] = STATE(1187),
    [sym__statement] = STATE(1187),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1187),
    [sym_unless_modifier] = STATE(1187),
    [sym_while_modifier] = STATE(1187),
    [sym_until_modifier] = STATE(1187),
    [sym_rescue_modifier] = STATE(1187),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1188),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1191),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(1191),
    [sym_assignment] = STATE(1188),
    [sym_operator_assignment] = STATE(1188),
    [sym_conditional] = STATE(1188),
    [sym_range] = STATE(1188),
    [sym_binary] = STATE(1188),
    [sym_unary] = STATE(1188),
    [sym_left_assignment_list] = STATE(1190),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1191),
    [sym__variable] = STATE(1189),
    [sym_undef] = STATE(1187),
    [sym_alias] = STATE(1187),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1191),
    [sym_false] = STATE(1191),
    [sym_nil] = STATE(1191),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1192),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1194),
    [aux_sym__statements_repeat1] = STATE(1194),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2109),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(5297),
    [anon_sym_return] = ACTIONS(2113),
    [anon_sym_yield] = ACTIONS(2115),
    [anon_sym_break] = ACTIONS(2117),
    [anon_sym_next] = ACTIONS(2119),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(5297),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_defined_QMARK] = ACTIONS(2123),
    [anon_sym_not] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2127),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [anon_sym_undef] = ACTIONS(2133),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1194] = {
    [sym_begin_block] = STATE(3164),
    [sym_end_block] = STATE(3164),
    [sym__statement] = STATE(3164),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(3164),
    [sym_unless_modifier] = STATE(3164),
    [sym_while_modifier] = STATE(3164),
    [sym_until_modifier] = STATE(3164),
    [sym_rescue_modifier] = STATE(3164),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1188),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1191),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(1191),
    [sym_assignment] = STATE(1188),
    [sym_operator_assignment] = STATE(1188),
    [sym_conditional] = STATE(1188),
    [sym_range] = STATE(1188),
    [sym_binary] = STATE(1188),
    [sym_unary] = STATE(1188),
    [sym_left_assignment_list] = STATE(1190),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1191),
    [sym__variable] = STATE(1189),
    [sym_undef] = STATE(3164),
    [sym_alias] = STATE(3164),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1191),
    [sym_false] = STATE(1191),
    [sym_nil] = STATE(1191),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1192),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(3165),
    [aux_sym__statements_repeat1] = STATE(3165),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2109),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(833),
    [anon_sym_return] = ACTIONS(2113),
    [anon_sym_yield] = ACTIONS(2115),
    [anon_sym_break] = ACTIONS(2117),
    [anon_sym_next] = ACTIONS(2119),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(833),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_defined_QMARK] = ACTIONS(2123),
    [anon_sym_not] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2127),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [anon_sym_undef] = ACTIONS(2133),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1195] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(3166),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(3166),
    [sym_operator_assignment] = STATE(3166),
    [sym_conditional] = STATE(3166),
    [sym_range] = STATE(3166),
    [sym_binary] = STATE(3166),
    [sym_unary] = STATE(3166),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1196] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3179),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3184),
    [sym_scope_resolution] = STATE(3180),
    [sym_call] = STATE(3180),
    [sym_method_call] = STATE(3184),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(3181),
    [sym__argument] = STATE(3182),
    [sym_splat_argument] = STATE(3182),
    [sym_hash_splat_argument] = STATE(3182),
    [sym_block_argument] = STATE(3182),
    [sym_assignment] = STATE(3179),
    [sym_operator_assignment] = STATE(3179),
    [sym_conditional] = STATE(3179),
    [sym_range] = STATE(3179),
    [sym_binary] = STATE(3179),
    [sym_unary] = STATE(3179),
    [sym_left_assignment_list] = STATE(3183),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3184),
    [sym__variable] = STATE(3180),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3184),
    [sym_false] = STATE(3184),
    [sym_nil] = STATE(3184),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3185),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(3182),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(5299),
    [sym__splat_star] = ACTIONS(5301),
    [sym__unary_minus] = ACTIONS(5303),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(5305),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(5307),
    [anon_sym_yield] = ACTIONS(5309),
    [anon_sym_break] = ACTIONS(5311),
    [anon_sym_next] = ACTIONS(5313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(5315),
    [anon_sym_not] = ACTIONS(5317),
    [anon_sym_BANG] = ACTIONS(5319),
    [anon_sym_TILDE] = ACTIONS(5321),
    [sym_constant] = ACTIONS(5323),
    [sym_identifier] = ACTIONS(5323),
    [sym_instance_variable] = ACTIONS(5325),
    [sym_class_variable] = ACTIONS(5325),
    [sym_global_variable] = ACTIONS(5325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1197] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3179),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3184),
    [sym_scope_resolution] = STATE(3180),
    [sym_call] = STATE(3180),
    [sym_method_call] = STATE(3184),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(3181),
    [sym__argument] = STATE(3182),
    [sym_splat_argument] = STATE(3182),
    [sym_hash_splat_argument] = STATE(3182),
    [sym_block_argument] = STATE(3182),
    [sym_assignment] = STATE(3179),
    [sym_operator_assignment] = STATE(3179),
    [sym_conditional] = STATE(3179),
    [sym_range] = STATE(3179),
    [sym_binary] = STATE(3179),
    [sym_unary] = STATE(3179),
    [sym_left_assignment_list] = STATE(3183),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3184),
    [sym__variable] = STATE(3180),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3184),
    [sym_false] = STATE(3184),
    [sym_nil] = STATE(3184),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3185),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(3182),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(5299),
    [sym__splat_star] = ACTIONS(5301),
    [sym__unary_minus] = ACTIONS(5303),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(5305),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(5307),
    [anon_sym_yield] = ACTIONS(5309),
    [anon_sym_break] = ACTIONS(5311),
    [anon_sym_next] = ACTIONS(5313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(5315),
    [anon_sym_not] = ACTIONS(5317),
    [anon_sym_BANG] = ACTIONS(5319),
    [anon_sym_TILDE] = ACTIONS(5321),
    [sym_constant] = ACTIONS(5323),
    [sym_identifier] = ACTIONS(5323),
    [sym_instance_variable] = ACTIONS(5325),
    [sym_class_variable] = ACTIONS(5325),
    [sym_global_variable] = ACTIONS(5325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1198] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3179),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3184),
    [sym_scope_resolution] = STATE(3180),
    [sym_call] = STATE(3180),
    [sym_method_call] = STATE(3184),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(3181),
    [sym__argument] = STATE(3182),
    [sym_splat_argument] = STATE(3182),
    [sym_hash_splat_argument] = STATE(3182),
    [sym_block_argument] = STATE(3182),
    [sym_assignment] = STATE(3179),
    [sym_operator_assignment] = STATE(3179),
    [sym_conditional] = STATE(3179),
    [sym_range] = STATE(3179),
    [sym_binary] = STATE(3179),
    [sym_unary] = STATE(3179),
    [sym_left_assignment_list] = STATE(3183),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3184),
    [sym__variable] = STATE(3180),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3184),
    [sym_false] = STATE(3184),
    [sym_nil] = STATE(3184),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3185),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(3182),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(5299),
    [sym__splat_star] = ACTIONS(5301),
    [sym__unary_minus] = ACTIONS(5303),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(5305),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(423),
    [anon_sym_return] = ACTIONS(5307),
    [anon_sym_yield] = ACTIONS(5309),
    [anon_sym_break] = ACTIONS(5311),
    [anon_sym_next] = ACTIONS(5313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(5315),
    [anon_sym_not] = ACTIONS(5317),
    [anon_sym_BANG] = ACTIONS(5319),
    [anon_sym_TILDE] = ACTIONS(5321),
    [sym_constant] = ACTIONS(5323),
    [sym_identifier] = ACTIONS(5323),
    [sym_instance_variable] = ACTIONS(5325),
    [sym_class_variable] = ACTIONS(5325),
    [sym_global_variable] = ACTIONS(5325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1199] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3179),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3184),
    [sym_scope_resolution] = STATE(3180),
    [sym_call] = STATE(3180),
    [sym_method_call] = STATE(3184),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(3181),
    [sym__argument] = STATE(3182),
    [sym_splat_argument] = STATE(3182),
    [sym_hash_splat_argument] = STATE(3182),
    [sym_block_argument] = STATE(3182),
    [sym_assignment] = STATE(3179),
    [sym_operator_assignment] = STATE(3179),
    [sym_conditional] = STATE(3179),
    [sym_range] = STATE(3179),
    [sym_binary] = STATE(3179),
    [sym_unary] = STATE(3179),
    [sym_left_assignment_list] = STATE(3183),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3184),
    [sym__variable] = STATE(3180),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3184),
    [sym_false] = STATE(3184),
    [sym_nil] = STATE(3184),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3185),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(3182),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(5299),
    [sym__splat_star] = ACTIONS(5301),
    [sym__unary_minus] = ACTIONS(5303),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(5305),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(427),
    [anon_sym_return] = ACTIONS(5307),
    [anon_sym_yield] = ACTIONS(5309),
    [anon_sym_break] = ACTIONS(5311),
    [anon_sym_next] = ACTIONS(5313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(5315),
    [anon_sym_not] = ACTIONS(5317),
    [anon_sym_BANG] = ACTIONS(5319),
    [anon_sym_TILDE] = ACTIONS(5321),
    [sym_constant] = ACTIONS(5323),
    [sym_identifier] = ACTIONS(5323),
    [sym_instance_variable] = ACTIONS(5325),
    [sym_class_variable] = ACTIONS(5325),
    [sym_global_variable] = ACTIONS(5325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1200] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(3186),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(3186),
    [sym_operator_assignment] = STATE(3186),
    [sym_conditional] = STATE(3186),
    [sym_range] = STATE(3186),
    [sym_binary] = STATE(3186),
    [sym_unary] = STATE(3186),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1201] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(298),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(298),
    [sym_operator_assignment] = STATE(298),
    [sym_conditional] = STATE(298),
    [sym_range] = STATE(298),
    [sym_binary] = STATE(298),
    [sym_unary] = STATE(298),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1202] = {
    [sym_operator] = STATE(3187),
    [sym__method_name] = STATE(3187),
    [sym_setter] = STATE(3187),
    [sym_symbol] = STATE(3187),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(5329),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(5329),
    [sym_class_variable] = ACTIONS(5329),
    [sym_global_variable] = ACTIONS(5329),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [1203] = {
    [anon_sym_end] = ACTIONS(5331),
    [sym_comment] = ACTIONS(87),
  },
  [1204] = {
    [sym_heredoc_body] = STATE(370),
    [sym__terminator] = STATE(370),
    [sym__line_break] = ACTIONS(687),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(687),
    [anon_sym_end] = ACTIONS(689),
    [anon_sym_if] = ACTIONS(5333),
    [anon_sym_unless] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5337),
    [anon_sym_until] = ACTIONS(5339),
    [anon_sym_rescue] = ACTIONS(5341),
    [sym_comment] = ACTIONS(87),
  },
  [1205] = {
    [sym__line_break] = ACTIONS(701),
    [sym__heredoc_body_start] = ACTIONS(701),
    [sym__binary_minus] = ACTIONS(5343),
    [sym__binary_star] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_SEMI] = ACTIONS(701),
    [anon_sym_STAR_STAR] = ACTIONS(5345),
    [anon_sym_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_end] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_unless] = ACTIONS(701),
    [anon_sym_while] = ACTIONS(701),
    [anon_sym_until] = ACTIONS(701),
    [anon_sym_rescue] = ACTIONS(701),
    [anon_sym_QMARK] = ACTIONS(5353),
    [anon_sym_DOT_DOT] = ACTIONS(5355),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5357),
    [anon_sym_and] = ACTIONS(5359),
    [anon_sym_or] = ACTIONS(5359),
    [anon_sym_PIPE_PIPE] = ACTIONS(5361),
    [anon_sym_AMP_AMP] = ACTIONS(5361),
    [anon_sym_LT_LT] = ACTIONS(5363),
    [anon_sym_GT_GT] = ACTIONS(5363),
    [anon_sym_EQ_EQ] = ACTIONS(5365),
    [anon_sym_BANG_EQ] = ACTIONS(5361),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5361),
    [anon_sym_LT_EQ_GT] = ACTIONS(5361),
    [anon_sym_EQ_TILDE] = ACTIONS(5361),
    [anon_sym_BANG_TILDE] = ACTIONS(5361),
    [anon_sym_LT_EQ] = ACTIONS(5351),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5367),
    [anon_sym_CARET] = ACTIONS(5369),
    [anon_sym_PLUS] = ACTIONS(5343),
    [anon_sym_SLASH] = ACTIONS(5345),
    [anon_sym_PERCENT] = ACTIONS(5345),
    [sym_comment] = ACTIONS(87),
  },
  [1206] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3215),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3220),
    [sym_scope_resolution] = STATE(3216),
    [sym_call] = STATE(3216),
    [sym_method_call] = STATE(3220),
    [sym_argument_list] = STATE(423),
    [sym__argument_list_with_parens] = STATE(3217),
    [sym__argument] = STATE(3218),
    [sym_splat_argument] = STATE(3218),
    [sym_hash_splat_argument] = STATE(3218),
    [sym_block_argument] = STATE(3218),
    [sym_do_block] = STATE(426),
    [sym_block] = STATE(426),
    [sym_assignment] = STATE(3215),
    [sym_operator_assignment] = STATE(3215),
    [sym_conditional] = STATE(3215),
    [sym_range] = STATE(3215),
    [sym_binary] = STATE(3215),
    [sym_unary] = STATE(3215),
    [sym_left_assignment_list] = STATE(3219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3220),
    [sym__variable] = STATE(3216),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3220),
    [sym_false] = STATE(3220),
    [sym_nil] = STATE(3220),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3221),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(3218),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(743),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(5371),
    [sym__splat_star] = ACTIONS(5373),
    [sym__unary_minus] = ACTIONS(5375),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(5377),
    [anon_sym_LBRACE] = ACTIONS(771),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(769),
    [anon_sym_return] = ACTIONS(5379),
    [anon_sym_yield] = ACTIONS(5381),
    [anon_sym_break] = ACTIONS(5383),
    [anon_sym_next] = ACTIONS(5385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(769),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(769),
    [anon_sym_until] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(769),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(5387),
    [anon_sym_not] = ACTIONS(5389),
    [anon_sym_BANG] = ACTIONS(5391),
    [anon_sym_TILDE] = ACTIONS(5393),
    [sym_constant] = ACTIONS(5395),
    [sym_identifier] = ACTIONS(5395),
    [sym_instance_variable] = ACTIONS(5397),
    [sym_class_variable] = ACTIONS(5397),
    [sym_global_variable] = ACTIONS(5397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [1207] = {
    [anon_sym_EQ] = ACTIONS(5401),
    [sym_comment] = ACTIONS(87),
  },
  [1208] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(5403),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(5405),
    [anon_sym_DASH_EQ] = ACTIONS(5405),
    [anon_sym_STAR_EQ] = ACTIONS(5405),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5405),
    [anon_sym_SLASH_EQ] = ACTIONS(5405),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5405),
    [anon_sym_PIPE_EQ] = ACTIONS(5405),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5405),
    [anon_sym_AMP_EQ] = ACTIONS(5405),
    [anon_sym_PERCENT_EQ] = ACTIONS(5405),
    [anon_sym_GT_GT_EQ] = ACTIONS(5405),
    [anon_sym_LT_LT_EQ] = ACTIONS(5405),
    [anon_sym_CARET_EQ] = ACTIONS(5405),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1209] = {
    [sym_string] = STATE(3224),
    [aux_sym_chained_string_repeat1] = STATE(3224),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [1210] = {
    [sym_begin_block] = STATE(3225),
    [sym_end_block] = STATE(3225),
    [sym__statement] = STATE(3225),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(3225),
    [sym_unless_modifier] = STATE(3225),
    [sym_while_modifier] = STATE(3225),
    [sym_until_modifier] = STATE(3225),
    [sym_rescue_modifier] = STATE(3225),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(3225),
    [sym_alias] = STATE(3225),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(3226),
    [aux_sym__statements_repeat1] = STATE(3226),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(833),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1211] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(2185),
    [sym__binary_star] = ACTIONS(2187),
    [anon_sym_PIPE] = ACTIONS(2189),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2191),
    [anon_sym_LT] = ACTIONS(2193),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_ensure] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(2195),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2199),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(2203),
    [anon_sym_AMP_AMP] = ACTIONS(2203),
    [anon_sym_LT_LT] = ACTIONS(2205),
    [anon_sym_GT_GT] = ACTIONS(2205),
    [anon_sym_EQ_EQ] = ACTIONS(2207),
    [anon_sym_BANG_EQ] = ACTIONS(2203),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2203),
    [anon_sym_LT_EQ_GT] = ACTIONS(2203),
    [anon_sym_EQ_TILDE] = ACTIONS(2203),
    [anon_sym_BANG_TILDE] = ACTIONS(2203),
    [anon_sym_LT_EQ] = ACTIONS(2193),
    [anon_sym_GT] = ACTIONS(2193),
    [anon_sym_GT_EQ] = ACTIONS(2209),
    [anon_sym_CARET] = ACTIONS(2211),
    [anon_sym_PLUS] = ACTIONS(2185),
    [anon_sym_SLASH] = ACTIONS(2187),
    [anon_sym_PERCENT] = ACTIONS(2187),
    [sym_comment] = ACTIONS(87),
  },
  [1212] = {
    [aux_sym_undef_repeat1] = STATE(3227),
    [sym__line_break] = ACTIONS(2251),
    [sym__heredoc_body_start] = ACTIONS(2251),
    [anon_sym_COMMA] = ACTIONS(2253),
    [anon_sym_SEMI] = ACTIONS(2251),
    [anon_sym_end] = ACTIONS(2251),
    [anon_sym_if] = ACTIONS(2251),
    [anon_sym_unless] = ACTIONS(2251),
    [anon_sym_while] = ACTIONS(2251),
    [anon_sym_until] = ACTIONS(2251),
    [anon_sym_rescue] = ACTIONS(2251),
    [anon_sym_else] = ACTIONS(2251),
    [anon_sym_ensure] = ACTIONS(2251),
    [sym_comment] = ACTIONS(87),
  },
  [1213] = {
    [sym__line_break] = ACTIONS(5407),
    [sym__heredoc_body_start] = ACTIONS(5407),
    [sym__binary_minus] = ACTIONS(5407),
    [sym__binary_star] = ACTIONS(5407),
    [ts_builtin_sym_end] = ACTIONS(5407),
    [anon_sym___END__] = ACTIONS(5407),
    [anon_sym_LBRACE] = ACTIONS(5407),
    [anon_sym_RBRACE] = ACTIONS(5407),
    [anon_sym_RPAREN] = ACTIONS(5407),
    [anon_sym_DOT] = ACTIONS(5409),
    [anon_sym_COMMA] = ACTIONS(5407),
    [anon_sym_PIPE] = ACTIONS(5409),
    [anon_sym_SEMI] = ACTIONS(5407),
    [anon_sym_STAR_STAR] = ACTIONS(5407),
    [anon_sym_AMP] = ACTIONS(5409),
    [anon_sym_LT] = ACTIONS(5409),
    [anon_sym_end] = ACTIONS(5407),
    [anon_sym_if] = ACTIONS(5407),
    [anon_sym_unless] = ACTIONS(5407),
    [anon_sym_while] = ACTIONS(5407),
    [anon_sym_until] = ACTIONS(5407),
    [anon_sym_rescue] = ACTIONS(5407),
    [anon_sym_do] = ACTIONS(5407),
    [anon_sym_when] = ACTIONS(5407),
    [anon_sym_elsif] = ACTIONS(5407),
    [anon_sym_else] = ACTIONS(5407),
    [anon_sym_then] = ACTIONS(5407),
    [anon_sym_ensure] = ACTIONS(5407),
    [anon_sym_EQ_GT] = ACTIONS(5407),
    [anon_sym_LBRACK] = ACTIONS(5407),
    [anon_sym_COLON_COLON2] = ACTIONS(5407),
    [anon_sym_AMP_DOT] = ACTIONS(5407),
    [anon_sym_QMARK] = ACTIONS(5407),
    [anon_sym_DOT_DOT] = ACTIONS(5409),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5407),
    [anon_sym_and] = ACTIONS(5407),
    [anon_sym_or] = ACTIONS(5407),
    [anon_sym_PIPE_PIPE] = ACTIONS(5407),
    [anon_sym_AMP_AMP] = ACTIONS(5407),
    [anon_sym_LT_LT] = ACTIONS(5407),
    [anon_sym_GT_GT] = ACTIONS(5407),
    [anon_sym_EQ_EQ] = ACTIONS(5409),
    [anon_sym_BANG_EQ] = ACTIONS(5407),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5407),
    [anon_sym_LT_EQ_GT] = ACTIONS(5407),
    [anon_sym_EQ_TILDE] = ACTIONS(5407),
    [anon_sym_BANG_TILDE] = ACTIONS(5407),
    [anon_sym_LT_EQ] = ACTIONS(5409),
    [anon_sym_GT] = ACTIONS(5409),
    [anon_sym_GT_EQ] = ACTIONS(5407),
    [anon_sym_CARET] = ACTIONS(5407),
    [anon_sym_PLUS] = ACTIONS(5407),
    [anon_sym_SLASH] = ACTIONS(5407),
    [anon_sym_PERCENT] = ACTIONS(5407),
    [sym_comment] = ACTIONS(87),
  },
  [1214] = {
    [sym_ensure] = STATE(3229),
    [anon_sym_end] = ACTIONS(5411),
    [anon_sym_ensure] = ACTIONS(2169),
    [sym_comment] = ACTIONS(87),
  },
  [1215] = {
    [anon_sym_end] = ACTIONS(5411),
    [sym_comment] = ACTIONS(87),
  },
  [1216] = {
    [sym_else] = STATE(3230),
    [sym_ensure] = STATE(3229),
    [anon_sym_end] = ACTIONS(5411),
    [anon_sym_else] = ACTIONS(2167),
    [anon_sym_ensure] = ACTIONS(2169),
    [sym_comment] = ACTIONS(87),
  },
  [1217] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(3231),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(3231),
    [sym_operator_assignment] = STATE(3231),
    [sym_conditional] = STATE(3231),
    [sym_range] = STATE(3231),
    [sym_binary] = STATE(3231),
    [sym_unary] = STATE(3231),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1218] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(3232),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(3232),
    [sym_operator_assignment] = STATE(3232),
    [sym_conditional] = STATE(3232),
    [sym_range] = STATE(3232),
    [sym_binary] = STATE(3232),
    [sym_unary] = STATE(3232),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1219] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(3233),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(3233),
    [sym_operator_assignment] = STATE(3233),
    [sym_conditional] = STATE(3233),
    [sym_range] = STATE(3233),
    [sym_binary] = STATE(3233),
    [sym_unary] = STATE(3233),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1220] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(3234),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(3234),
    [sym_operator_assignment] = STATE(3234),
    [sym_conditional] = STATE(3234),
    [sym_range] = STATE(3234),
    [sym_binary] = STATE(3234),
    [sym_unary] = STATE(3234),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1221] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(3235),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(3235),
    [sym_operator_assignment] = STATE(3235),
    [sym_conditional] = STATE(3235),
    [sym_range] = STATE(3235),
    [sym_binary] = STATE(3235),
    [sym_unary] = STATE(3235),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1222] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(3236),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(3236),
    [sym_operator_assignment] = STATE(3236),
    [sym_conditional] = STATE(3236),
    [sym_range] = STATE(3236),
    [sym_binary] = STATE(3236),
    [sym_unary] = STATE(3236),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1223] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(3237),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(3237),
    [sym_operator_assignment] = STATE(3237),
    [sym_conditional] = STATE(3237),
    [sym_range] = STATE(3237),
    [sym_binary] = STATE(3237),
    [sym_unary] = STATE(3237),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1224] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(3238),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(3238),
    [sym_operator_assignment] = STATE(3238),
    [sym_conditional] = STATE(3238),
    [sym_range] = STATE(3238),
    [sym_binary] = STATE(3238),
    [sym_unary] = STATE(3238),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1225] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(3239),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(3239),
    [sym_operator_assignment] = STATE(3239),
    [sym_conditional] = STATE(3239),
    [sym_range] = STATE(3239),
    [sym_binary] = STATE(3239),
    [sym_unary] = STATE(3239),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1226] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(3240),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(3240),
    [sym_operator_assignment] = STATE(3240),
    [sym_conditional] = STATE(3240),
    [sym_range] = STATE(3240),
    [sym_binary] = STATE(3240),
    [sym_unary] = STATE(3240),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1227] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(3241),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(3241),
    [sym_operator_assignment] = STATE(3241),
    [sym_conditional] = STATE(3241),
    [sym_range] = STATE(3241),
    [sym_binary] = STATE(3241),
    [sym_unary] = STATE(3241),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1228] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(3242),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(3242),
    [sym_operator_assignment] = STATE(3242),
    [sym_conditional] = STATE(3242),
    [sym_range] = STATE(3242),
    [sym_binary] = STATE(3242),
    [sym_unary] = STATE(3242),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1229] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(3243),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(3243),
    [sym_operator_assignment] = STATE(3243),
    [sym_conditional] = STATE(3243),
    [sym_range] = STATE(3243),
    [sym_binary] = STATE(3243),
    [sym_unary] = STATE(3243),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1230] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(3244),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(3244),
    [sym_operator_assignment] = STATE(3244),
    [sym_conditional] = STATE(3244),
    [sym_range] = STATE(3244),
    [sym_binary] = STATE(3244),
    [sym_unary] = STATE(3244),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1231] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(3245),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(3245),
    [sym_operator_assignment] = STATE(3245),
    [sym_conditional] = STATE(3245),
    [sym_range] = STATE(3245),
    [sym_binary] = STATE(3245),
    [sym_unary] = STATE(3245),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1232] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(3253),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(3256),
    [sym_scope_resolution] = STATE(3254),
    [sym_call] = STATE(3254),
    [sym_method_call] = STATE(3256),
    [sym_assignment] = STATE(3253),
    [sym_operator_assignment] = STATE(3253),
    [sym_conditional] = STATE(3253),
    [sym_range] = STATE(3253),
    [sym_binary] = STATE(3253),
    [sym_unary] = STATE(3253),
    [sym_left_assignment_list] = STATE(3255),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3256),
    [sym__variable] = STATE(3254),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(3256),
    [sym_false] = STATE(3256),
    [sym_nil] = STATE(3256),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(3257),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(5413),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(5415),
    [anon_sym_yield] = ACTIONS(5417),
    [anon_sym_break] = ACTIONS(5419),
    [anon_sym_next] = ACTIONS(5421),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(5423),
    [anon_sym_defined_QMARK] = ACTIONS(5425),
    [anon_sym_not] = ACTIONS(5427),
    [anon_sym_BANG] = ACTIONS(5429),
    [anon_sym_TILDE] = ACTIONS(5429),
    [sym_constant] = ACTIONS(5431),
    [sym_identifier] = ACTIONS(5431),
    [sym_instance_variable] = ACTIONS(5433),
    [sym_class_variable] = ACTIONS(5433),
    [sym_global_variable] = ACTIONS(5433),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(5431),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5431),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [1233] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(3258),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(3256),
    [sym_scope_resolution] = STATE(3254),
    [sym_call] = STATE(3254),
    [sym_method_call] = STATE(3256),
    [sym_assignment] = STATE(3258),
    [sym_operator_assignment] = STATE(3258),
    [sym_conditional] = STATE(3258),
    [sym_range] = STATE(3258),
    [sym_binary] = STATE(3258),
    [sym_unary] = STATE(3258),
    [sym_left_assignment_list] = STATE(3255),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3256),
    [sym__variable] = STATE(3254),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(3256),
    [sym_false] = STATE(3256),
    [sym_nil] = STATE(3256),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(3257),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(5413),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(5415),
    [anon_sym_yield] = ACTIONS(5417),
    [anon_sym_break] = ACTIONS(5419),
    [anon_sym_next] = ACTIONS(5421),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(5423),
    [anon_sym_defined_QMARK] = ACTIONS(5425),
    [anon_sym_not] = ACTIONS(5427),
    [anon_sym_BANG] = ACTIONS(5429),
    [anon_sym_TILDE] = ACTIONS(5429),
    [sym_constant] = ACTIONS(5431),
    [sym_identifier] = ACTIONS(5431),
    [sym_instance_variable] = ACTIONS(5433),
    [sym_class_variable] = ACTIONS(5433),
    [sym_global_variable] = ACTIONS(5433),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(5431),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5431),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [1234] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3259),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1249),
    [sym_scope_resolution] = STATE(1245),
    [sym_call] = STATE(1245),
    [sym_method_call] = STATE(1249),
    [sym_assignment] = STATE(3259),
    [sym_operator_assignment] = STATE(3259),
    [sym_conditional] = STATE(3259),
    [sym_range] = STATE(3259),
    [sym_binary] = STATE(3259),
    [sym_unary] = STATE(3259),
    [sym_left_assignment_list] = STATE(1248),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(1245),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1249),
    [sym_false] = STATE(1249),
    [sym_nil] = STATE(1249),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3260),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2223),
    [anon_sym_break] = ACTIONS(2225),
    [anon_sym_next] = ACTIONS(2227),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(5435),
    [anon_sym_defined_QMARK] = ACTIONS(2229),
    [anon_sym_not] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(2235),
    [anon_sym_TILDE] = ACTIONS(2235),
    [sym_constant] = ACTIONS(2241),
    [sym_identifier] = ACTIONS(2241),
    [sym_instance_variable] = ACTIONS(2239),
    [sym_class_variable] = ACTIONS(2239),
    [sym_global_variable] = ACTIONS(2239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(2241),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2241),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [1235] = {
    [anon_sym_COLON] = ACTIONS(5437),
    [sym_comment] = ACTIONS(87),
  },
  [1236] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(3262),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(3256),
    [sym_scope_resolution] = STATE(3254),
    [sym_call] = STATE(3254),
    [sym_method_call] = STATE(3256),
    [sym_assignment] = STATE(3262),
    [sym_operator_assignment] = STATE(3262),
    [sym_conditional] = STATE(3262),
    [sym_range] = STATE(3262),
    [sym_binary] = STATE(3262),
    [sym_unary] = STATE(3262),
    [sym_left_assignment_list] = STATE(3255),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3256),
    [sym__variable] = STATE(3254),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(3256),
    [sym_false] = STATE(3256),
    [sym_nil] = STATE(3256),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(3257),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(5413),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(5415),
    [anon_sym_yield] = ACTIONS(5417),
    [anon_sym_break] = ACTIONS(5419),
    [anon_sym_next] = ACTIONS(5421),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(5423),
    [anon_sym_defined_QMARK] = ACTIONS(5425),
    [anon_sym_not] = ACTIONS(5427),
    [anon_sym_BANG] = ACTIONS(5429),
    [anon_sym_TILDE] = ACTIONS(5429),
    [sym_constant] = ACTIONS(5431),
    [sym_identifier] = ACTIONS(5431),
    [sym_instance_variable] = ACTIONS(5433),
    [sym_class_variable] = ACTIONS(5433),
    [sym_global_variable] = ACTIONS(5433),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(5431),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5431),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [1237] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3032),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1249),
    [sym_scope_resolution] = STATE(1245),
    [sym_call] = STATE(1245),
    [sym_method_call] = STATE(1249),
    [sym_argument_list] = STATE(1535),
    [sym__argument_list_with_parens] = STATE(3033),
    [sym__argument] = STATE(3034),
    [sym_splat_argument] = STATE(3034),
    [sym_hash_splat_argument] = STATE(3034),
    [sym_block_argument] = STATE(3034),
    [sym_assignment] = STATE(3032),
    [sym_operator_assignment] = STATE(3032),
    [sym_conditional] = STATE(3032),
    [sym_range] = STATE(3032),
    [sym_binary] = STATE(3032),
    [sym_unary] = STATE(3032),
    [sym_left_assignment_list] = STATE(1248),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(1245),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1249),
    [sym_false] = STATE(1249),
    [sym_nil] = STATE(1249),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3035),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(3034),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(5059),
    [sym__splat_star] = ACTIONS(5061),
    [sym__unary_minus] = ACTIONS(2217),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(5063),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2223),
    [anon_sym_break] = ACTIONS(2225),
    [anon_sym_next] = ACTIONS(2227),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_else] = ACTIONS(377),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_ensure] = ACTIONS(377),
    [anon_sym_EQ_GT] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(365),
    [anon_sym_DASH_EQ] = ACTIONS(365),
    [anon_sym_STAR_EQ] = ACTIONS(365),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(365),
    [anon_sym_SLASH_EQ] = ACTIONS(365),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(365),
    [anon_sym_PIPE_EQ] = ACTIONS(365),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(365),
    [anon_sym_AMP_EQ] = ACTIONS(365),
    [anon_sym_PERCENT_EQ] = ACTIONS(365),
    [anon_sym_GT_GT_EQ] = ACTIONS(365),
    [anon_sym_LT_LT_EQ] = ACTIONS(365),
    [anon_sym_CARET_EQ] = ACTIONS(365),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_PERCENT] = ACTIONS(377),
    [anon_sym_defined_QMARK] = ACTIONS(2229),
    [anon_sym_not] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(2233),
    [anon_sym_TILDE] = ACTIONS(2235),
    [sym_constant] = ACTIONS(5065),
    [sym_identifier] = ACTIONS(5065),
    [sym_instance_variable] = ACTIONS(2239),
    [sym_class_variable] = ACTIONS(2239),
    [sym_global_variable] = ACTIONS(2239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(2241),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2241),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [1238] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3032),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1249),
    [sym_scope_resolution] = STATE(1245),
    [sym_call] = STATE(1245),
    [sym_method_call] = STATE(1249),
    [sym_argument_list] = STATE(1536),
    [sym__argument_list_with_parens] = STATE(3033),
    [sym__argument] = STATE(3034),
    [sym_splat_argument] = STATE(3034),
    [sym_hash_splat_argument] = STATE(3034),
    [sym_block_argument] = STATE(3034),
    [sym_assignment] = STATE(3032),
    [sym_operator_assignment] = STATE(3032),
    [sym_conditional] = STATE(3032),
    [sym_range] = STATE(3032),
    [sym_binary] = STATE(3032),
    [sym_unary] = STATE(3032),
    [sym_left_assignment_list] = STATE(1248),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(1245),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1249),
    [sym_false] = STATE(1249),
    [sym_nil] = STATE(1249),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3035),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(3034),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(5059),
    [sym__splat_star] = ACTIONS(5061),
    [sym__unary_minus] = ACTIONS(2217),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(5063),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_EQ] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2223),
    [anon_sym_break] = ACTIONS(2225),
    [anon_sym_next] = ACTIONS(2227),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_else] = ACTIONS(419),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_ensure] = ACTIONS(419),
    [anon_sym_EQ_GT] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(417),
    [anon_sym_DASH_EQ] = ACTIONS(417),
    [anon_sym_STAR_EQ] = ACTIONS(417),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(417),
    [anon_sym_SLASH_EQ] = ACTIONS(417),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(417),
    [anon_sym_PIPE_EQ] = ACTIONS(417),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(417),
    [anon_sym_AMP_EQ] = ACTIONS(417),
    [anon_sym_PERCENT_EQ] = ACTIONS(417),
    [anon_sym_GT_GT_EQ] = ACTIONS(417),
    [anon_sym_LT_LT_EQ] = ACTIONS(417),
    [anon_sym_CARET_EQ] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(2229),
    [anon_sym_not] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(2233),
    [anon_sym_TILDE] = ACTIONS(2235),
    [sym_constant] = ACTIONS(5065),
    [sym_identifier] = ACTIONS(5065),
    [sym_instance_variable] = ACTIONS(2239),
    [sym_class_variable] = ACTIONS(2239),
    [sym_global_variable] = ACTIONS(2239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(2241),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2241),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [1239] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3032),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1249),
    [sym_scope_resolution] = STATE(1245),
    [sym_call] = STATE(1245),
    [sym_method_call] = STATE(1249),
    [sym_argument_list] = STATE(1537),
    [sym__argument_list_with_parens] = STATE(3033),
    [sym__argument] = STATE(3034),
    [sym_splat_argument] = STATE(3034),
    [sym_hash_splat_argument] = STATE(3034),
    [sym_block_argument] = STATE(3034),
    [sym_assignment] = STATE(3032),
    [sym_operator_assignment] = STATE(3032),
    [sym_conditional] = STATE(3032),
    [sym_range] = STATE(3032),
    [sym_binary] = STATE(3032),
    [sym_unary] = STATE(3032),
    [sym_left_assignment_list] = STATE(1248),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(1245),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1249),
    [sym_false] = STATE(1249),
    [sym_nil] = STATE(1249),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3035),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(3034),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(5059),
    [sym__splat_star] = ACTIONS(5061),
    [sym__unary_minus] = ACTIONS(2217),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(5063),
    [anon_sym_LBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_EQ] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(423),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2223),
    [anon_sym_break] = ACTIONS(2225),
    [anon_sym_next] = ACTIONS(2227),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_else] = ACTIONS(423),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_ensure] = ACTIONS(423),
    [anon_sym_EQ_GT] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(421),
    [anon_sym_DASH_EQ] = ACTIONS(421),
    [anon_sym_STAR_EQ] = ACTIONS(421),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(421),
    [anon_sym_SLASH_EQ] = ACTIONS(421),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(421),
    [anon_sym_PIPE_EQ] = ACTIONS(421),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(421),
    [anon_sym_AMP_EQ] = ACTIONS(421),
    [anon_sym_PERCENT_EQ] = ACTIONS(421),
    [anon_sym_GT_GT_EQ] = ACTIONS(421),
    [anon_sym_LT_LT_EQ] = ACTIONS(421),
    [anon_sym_CARET_EQ] = ACTIONS(421),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(2229),
    [anon_sym_not] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(2233),
    [anon_sym_TILDE] = ACTIONS(2235),
    [sym_constant] = ACTIONS(5065),
    [sym_identifier] = ACTIONS(5065),
    [sym_instance_variable] = ACTIONS(2239),
    [sym_class_variable] = ACTIONS(2239),
    [sym_global_variable] = ACTIONS(2239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(2241),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2241),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [1240] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3032),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1249),
    [sym_scope_resolution] = STATE(1245),
    [sym_call] = STATE(1245),
    [sym_method_call] = STATE(1249),
    [sym_argument_list] = STATE(1538),
    [sym__argument_list_with_parens] = STATE(3033),
    [sym__argument] = STATE(3034),
    [sym_splat_argument] = STATE(3034),
    [sym_hash_splat_argument] = STATE(3034),
    [sym_block_argument] = STATE(3034),
    [sym_assignment] = STATE(3032),
    [sym_operator_assignment] = STATE(3032),
    [sym_conditional] = STATE(3032),
    [sym_range] = STATE(3032),
    [sym_binary] = STATE(3032),
    [sym_unary] = STATE(3032),
    [sym_left_assignment_list] = STATE(1248),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(1245),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1249),
    [sym_false] = STATE(1249),
    [sym_nil] = STATE(1249),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3035),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(3034),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(5059),
    [sym__splat_star] = ACTIONS(5061),
    [sym__unary_minus] = ACTIONS(2217),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(5063),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(427),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(427),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2223),
    [anon_sym_break] = ACTIONS(2225),
    [anon_sym_next] = ACTIONS(2227),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_else] = ACTIONS(427),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_ensure] = ACTIONS(427),
    [anon_sym_EQ_GT] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(425),
    [anon_sym_DASH_EQ] = ACTIONS(425),
    [anon_sym_STAR_EQ] = ACTIONS(425),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(425),
    [anon_sym_SLASH_EQ] = ACTIONS(425),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(425),
    [anon_sym_PIPE_EQ] = ACTIONS(425),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(425),
    [anon_sym_AMP_EQ] = ACTIONS(425),
    [anon_sym_PERCENT_EQ] = ACTIONS(425),
    [anon_sym_GT_GT_EQ] = ACTIONS(425),
    [anon_sym_LT_LT_EQ] = ACTIONS(425),
    [anon_sym_CARET_EQ] = ACTIONS(425),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(2229),
    [anon_sym_not] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(2233),
    [anon_sym_TILDE] = ACTIONS(2235),
    [sym_constant] = ACTIONS(5065),
    [sym_identifier] = ACTIONS(5065),
    [sym_instance_variable] = ACTIONS(2239),
    [sym_class_variable] = ACTIONS(2239),
    [sym_global_variable] = ACTIONS(2239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(2241),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2241),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [1241] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3263),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1249),
    [sym_scope_resolution] = STATE(1245),
    [sym_call] = STATE(1245),
    [sym_method_call] = STATE(1249),
    [sym_assignment] = STATE(3263),
    [sym_operator_assignment] = STATE(3263),
    [sym_conditional] = STATE(3263),
    [sym_range] = STATE(3263),
    [sym_binary] = STATE(3263),
    [sym_unary] = STATE(3263),
    [sym_left_assignment_list] = STATE(1248),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(1245),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1249),
    [sym_false] = STATE(1249),
    [sym_nil] = STATE(1249),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3260),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2223),
    [anon_sym_break] = ACTIONS(2225),
    [anon_sym_next] = ACTIONS(2227),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(5435),
    [anon_sym_defined_QMARK] = ACTIONS(2229),
    [anon_sym_not] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(2235),
    [anon_sym_TILDE] = ACTIONS(2235),
    [sym_constant] = ACTIONS(2241),
    [sym_identifier] = ACTIONS(2241),
    [sym_instance_variable] = ACTIONS(2239),
    [sym_class_variable] = ACTIONS(2239),
    [sym_global_variable] = ACTIONS(2239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(2241),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2241),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [1242] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(1559),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1249),
    [sym_scope_resolution] = STATE(1245),
    [sym_call] = STATE(1245),
    [sym_method_call] = STATE(1249),
    [sym_assignment] = STATE(1559),
    [sym_operator_assignment] = STATE(1559),
    [sym_conditional] = STATE(1559),
    [sym_range] = STATE(1559),
    [sym_binary] = STATE(1559),
    [sym_unary] = STATE(1559),
    [sym_left_assignment_list] = STATE(1248),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(1245),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1249),
    [sym_false] = STATE(1249),
    [sym_nil] = STATE(1249),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3260),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2223),
    [anon_sym_break] = ACTIONS(2225),
    [anon_sym_next] = ACTIONS(2227),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(5435),
    [anon_sym_defined_QMARK] = ACTIONS(2229),
    [anon_sym_not] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(2235),
    [anon_sym_TILDE] = ACTIONS(2235),
    [sym_constant] = ACTIONS(2241),
    [sym_identifier] = ACTIONS(2241),
    [sym_instance_variable] = ACTIONS(2239),
    [sym_class_variable] = ACTIONS(2239),
    [sym_global_variable] = ACTIONS(2239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(2241),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2241),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [1243] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(5439),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_else] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_ensure] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [1244] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(5441),
    [sym__binary_star] = ACTIONS(5443),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(5445),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(5447),
    [anon_sym_AMP] = ACTIONS(5449),
    [anon_sym_EQ] = ACTIONS(1631),
    [anon_sym_LT] = ACTIONS(5451),
    [anon_sym_end] = ACTIONS(1625),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_unless] = ACTIONS(1625),
    [anon_sym_while] = ACTIONS(1625),
    [anon_sym_until] = ACTIONS(1625),
    [anon_sym_rescue] = ACTIONS(1625),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_else] = ACTIONS(1625),
    [anon_sym_ensure] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(5437),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_PLUS_EQ] = ACTIONS(1625),
    [anon_sym_DASH_EQ] = ACTIONS(1625),
    [anon_sym_STAR_EQ] = ACTIONS(1625),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1625),
    [anon_sym_SLASH_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1625),
    [anon_sym_AMP_EQ] = ACTIONS(1625),
    [anon_sym_PERCENT_EQ] = ACTIONS(1625),
    [anon_sym_GT_GT_EQ] = ACTIONS(1625),
    [anon_sym_LT_LT_EQ] = ACTIONS(1625),
    [anon_sym_CARET_EQ] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(5453),
    [anon_sym_DOT_DOT] = ACTIONS(5455),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5457),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(5459),
    [anon_sym_AMP_AMP] = ACTIONS(5459),
    [anon_sym_LT_LT] = ACTIONS(5461),
    [anon_sym_GT_GT] = ACTIONS(5461),
    [anon_sym_EQ_EQ] = ACTIONS(5459),
    [anon_sym_BANG_EQ] = ACTIONS(5463),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5463),
    [anon_sym_LT_EQ_GT] = ACTIONS(5463),
    [anon_sym_EQ_TILDE] = ACTIONS(5463),
    [anon_sym_BANG_TILDE] = ACTIONS(5463),
    [anon_sym_LT_EQ] = ACTIONS(5451),
    [anon_sym_GT] = ACTIONS(5451),
    [anon_sym_GT_EQ] = ACTIONS(5465),
    [anon_sym_CARET] = ACTIONS(5445),
    [anon_sym_PLUS] = ACTIONS(5467),
    [anon_sym_SLASH] = ACTIONS(5447),
    [anon_sym_PERCENT] = ACTIONS(5447),
    [sym_comment] = ACTIONS(87),
  },
  [1245] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3032),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1249),
    [sym_scope_resolution] = STATE(1245),
    [sym_call] = STATE(1245),
    [sym_method_call] = STATE(1249),
    [sym_argument_list] = STATE(1578),
    [sym__argument_list_with_parens] = STATE(3033),
    [sym__argument] = STATE(3034),
    [sym_splat_argument] = STATE(3034),
    [sym_hash_splat_argument] = STATE(3034),
    [sym_block_argument] = STATE(3034),
    [sym_do_block] = STATE(941),
    [sym_block] = STATE(941),
    [sym_assignment] = STATE(3032),
    [sym_operator_assignment] = STATE(3032),
    [sym_conditional] = STATE(3032),
    [sym_range] = STATE(3032),
    [sym_binary] = STATE(3032),
    [sym_unary] = STATE(3032),
    [sym_left_assignment_list] = STATE(1248),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(1245),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1249),
    [sym_false] = STATE(1249),
    [sym_nil] = STATE(1249),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3035),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(3034),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(743),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(5059),
    [sym__splat_star] = ACTIONS(5061),
    [sym__unary_minus] = ACTIONS(2217),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(5063),
    [anon_sym_LBRACE] = ACTIONS(2715),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(769),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2223),
    [anon_sym_break] = ACTIONS(2225),
    [anon_sym_next] = ACTIONS(2227),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(769),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(769),
    [anon_sym_until] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(769),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(769),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_else] = ACTIONS(769),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_ensure] = ACTIONS(769),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(2229),
    [anon_sym_not] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(2233),
    [anon_sym_TILDE] = ACTIONS(2235),
    [sym_constant] = ACTIONS(5065),
    [sym_identifier] = ACTIONS(5065),
    [sym_instance_variable] = ACTIONS(2239),
    [sym_class_variable] = ACTIONS(2239),
    [sym_global_variable] = ACTIONS(2239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(2241),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2241),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [1246] = {
    [sym_heredoc_body] = STATE(3275),
    [aux_sym_call_repeat1] = STATE(3275),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_else] = ACTIONS(1681),
    [anon_sym_ensure] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [1247] = {
    [sym_heredoc_body] = STATE(3275),
    [aux_sym_call_repeat1] = STATE(3275),
    [aux_sym_argument_list_repeat1] = STATE(3277),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(5469),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_else] = ACTIONS(1681),
    [anon_sym_ensure] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [1248] = {
    [anon_sym_EQ] = ACTIONS(5471),
    [sym_comment] = ACTIONS(87),
  },
  [1249] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(5473),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(5475),
    [anon_sym_DASH_EQ] = ACTIONS(5475),
    [anon_sym_STAR_EQ] = ACTIONS(5475),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5475),
    [anon_sym_SLASH_EQ] = ACTIONS(5475),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5475),
    [anon_sym_PIPE_EQ] = ACTIONS(5475),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5475),
    [anon_sym_AMP_EQ] = ACTIONS(5475),
    [anon_sym_PERCENT_EQ] = ACTIONS(5475),
    [anon_sym_GT_GT_EQ] = ACTIONS(5475),
    [anon_sym_LT_LT_EQ] = ACTIONS(5475),
    [anon_sym_CARET_EQ] = ACTIONS(5475),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1250] = {
    [sym_string] = STATE(3280),
    [aux_sym_chained_string_repeat1] = STATE(3280),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(747),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(5477),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1251] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(3285),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(3288),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(3288),
    [sym_splat_argument] = STATE(3286),
    [sym_assignment] = STATE(3285),
    [sym_operator_assignment] = STATE(3285),
    [sym_conditional] = STATE(3285),
    [sym_range] = STATE(3285),
    [sym_binary] = STATE(3285),
    [sym_unary] = STATE(3285),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(3286),
    [sym_left_assignment_list] = STATE(3287),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3288),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(3288),
    [sym_false] = STATE(3288),
    [sym_nil] = STATE(3288),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(3000),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(5479),
    [sym__unary_minus] = ACTIONS(5481),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5003),
    [anon_sym_yield] = ACTIONS(5005),
    [anon_sym_break] = ACTIONS(5007),
    [anon_sym_next] = ACTIONS(5009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5483),
    [anon_sym_defined_QMARK] = ACTIONS(5485),
    [anon_sym_not] = ACTIONS(5487),
    [anon_sym_BANG] = ACTIONS(5489),
    [anon_sym_TILDE] = ACTIONS(5489),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1252] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(3289),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(3289),
    [sym_operator_assignment] = STATE(3289),
    [sym_conditional] = STATE(3289),
    [sym_range] = STATE(3289),
    [sym_binary] = STATE(3289),
    [sym_unary] = STATE(3289),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1253] = {
    [sym_string] = STATE(3290),
    [aux_sym_chained_string_repeat1] = STATE(3290),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_end] = ACTIONS(2753),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_else] = ACTIONS(2753),
    [anon_sym_ensure] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [1254] = {
    [sym__line_break] = ACTIONS(5491),
    [sym__heredoc_body_start] = ACTIONS(5491),
    [sym__binary_minus] = ACTIONS(5491),
    [sym__binary_star] = ACTIONS(5491),
    [ts_builtin_sym_end] = ACTIONS(5491),
    [anon_sym___END__] = ACTIONS(5491),
    [anon_sym_LBRACE] = ACTIONS(5491),
    [anon_sym_RBRACE] = ACTIONS(5491),
    [anon_sym_RPAREN] = ACTIONS(5491),
    [anon_sym_DOT] = ACTIONS(5493),
    [anon_sym_COMMA] = ACTIONS(5491),
    [anon_sym_PIPE] = ACTIONS(5493),
    [anon_sym_SEMI] = ACTIONS(5491),
    [anon_sym_STAR_STAR] = ACTIONS(5491),
    [anon_sym_AMP] = ACTIONS(5493),
    [anon_sym_LT] = ACTIONS(5493),
    [anon_sym_end] = ACTIONS(5491),
    [anon_sym_if] = ACTIONS(5491),
    [anon_sym_unless] = ACTIONS(5491),
    [anon_sym_while] = ACTIONS(5491),
    [anon_sym_until] = ACTIONS(5491),
    [anon_sym_rescue] = ACTIONS(5491),
    [anon_sym_do] = ACTIONS(5491),
    [anon_sym_when] = ACTIONS(5491),
    [anon_sym_elsif] = ACTIONS(5491),
    [anon_sym_else] = ACTIONS(5491),
    [anon_sym_then] = ACTIONS(5491),
    [anon_sym_ensure] = ACTIONS(5491),
    [anon_sym_EQ_GT] = ACTIONS(5491),
    [anon_sym_LBRACK] = ACTIONS(5491),
    [anon_sym_COLON_COLON2] = ACTIONS(5491),
    [anon_sym_AMP_DOT] = ACTIONS(5491),
    [anon_sym_QMARK] = ACTIONS(5491),
    [anon_sym_DOT_DOT] = ACTIONS(5493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5491),
    [anon_sym_and] = ACTIONS(5491),
    [anon_sym_or] = ACTIONS(5491),
    [anon_sym_PIPE_PIPE] = ACTIONS(5491),
    [anon_sym_AMP_AMP] = ACTIONS(5491),
    [anon_sym_LT_LT] = ACTIONS(5491),
    [anon_sym_GT_GT] = ACTIONS(5491),
    [anon_sym_EQ_EQ] = ACTIONS(5493),
    [anon_sym_BANG_EQ] = ACTIONS(5491),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5491),
    [anon_sym_LT_EQ_GT] = ACTIONS(5491),
    [anon_sym_EQ_TILDE] = ACTIONS(5491),
    [anon_sym_BANG_TILDE] = ACTIONS(5491),
    [anon_sym_LT_EQ] = ACTIONS(5493),
    [anon_sym_GT] = ACTIONS(5493),
    [anon_sym_GT_EQ] = ACTIONS(5491),
    [anon_sym_CARET] = ACTIONS(5491),
    [anon_sym_PLUS] = ACTIONS(5491),
    [anon_sym_SLASH] = ACTIONS(5491),
    [anon_sym_PERCENT] = ACTIONS(5491),
    [sym_comment] = ACTIONS(87),
  },
  [1255] = {
    [sym_heredoc_body] = STATE(370),
    [sym__terminator] = STATE(370),
    [sym__line_break] = ACTIONS(687),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(687),
    [anon_sym_end] = ACTIONS(2757),
    [anon_sym_if] = ACTIONS(2171),
    [anon_sym_unless] = ACTIONS(2173),
    [anon_sym_while] = ACTIONS(2175),
    [anon_sym_until] = ACTIONS(2177),
    [anon_sym_rescue] = ACTIONS(2179),
    [anon_sym_else] = ACTIONS(2757),
    [anon_sym_ensure] = ACTIONS(2757),
    [sym_comment] = ACTIONS(87),
  },
  [1256] = {
    [sym_begin_block] = STATE(1611),
    [sym_end_block] = STATE(1611),
    [sym__statement] = STATE(1611),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1611),
    [sym_unless_modifier] = STATE(1611),
    [sym_while_modifier] = STATE(1611),
    [sym_until_modifier] = STATE(1611),
    [sym_rescue_modifier] = STATE(1611),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1612),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1615),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(1615),
    [sym_assignment] = STATE(1612),
    [sym_operator_assignment] = STATE(1612),
    [sym_conditional] = STATE(1612),
    [sym_range] = STATE(1612),
    [sym_binary] = STATE(1612),
    [sym_unary] = STATE(1612),
    [sym_left_assignment_list] = STATE(1614),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1615),
    [sym__variable] = STATE(1613),
    [sym_undef] = STATE(1611),
    [sym_alias] = STATE(1611),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1615),
    [sym_false] = STATE(1615),
    [sym_nil] = STATE(1615),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1616),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1256),
    [aux_sym__statements_repeat1] = STATE(1256),
    [sym__simple_symbol] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(2762),
    [sym__symbol_start] = ACTIONS(2765),
    [sym__subshell_start] = ACTIONS(2768),
    [sym__regex_start] = ACTIONS(2771),
    [sym__string_array_start] = ACTIONS(2774),
    [sym__symbol_array_start] = ACTIONS(2777),
    [sym_heredoc_beginning] = ACTIONS(2780),
    [sym__unary_minus] = ACTIONS(2783),
    [anon_sym_BEGIN] = ACTIONS(2786),
    [anon_sym_LBRACE] = ACTIONS(2789),
    [anon_sym_END] = ACTIONS(2792),
    [anon_sym_def] = ACTIONS(2795),
    [anon_sym_LPAREN] = ACTIONS(2798),
    [anon_sym_COLON_COLON] = ACTIONS(2801),
    [anon_sym_SEMI] = ACTIONS(2804),
    [anon_sym_STAR] = ACTIONS(2807),
    [anon_sym_class] = ACTIONS(2810),
    [anon_sym_module] = ACTIONS(2813),
    [anon_sym_end] = ACTIONS(2493),
    [anon_sym_return] = ACTIONS(2816),
    [anon_sym_yield] = ACTIONS(2819),
    [anon_sym_break] = ACTIONS(2822),
    [anon_sym_next] = ACTIONS(2825),
    [sym_redo] = ACTIONS(2828),
    [sym_retry] = ACTIONS(2828),
    [anon_sym_if] = ACTIONS(2831),
    [anon_sym_unless] = ACTIONS(2834),
    [anon_sym_while] = ACTIONS(2837),
    [anon_sym_until] = ACTIONS(2840),
    [anon_sym_rescue] = ACTIONS(2493),
    [anon_sym_for] = ACTIONS(2843),
    [anon_sym_case] = ACTIONS(2846),
    [anon_sym_else] = ACTIONS(2493),
    [anon_sym_begin] = ACTIONS(2849),
    [anon_sym_ensure] = ACTIONS(2493),
    [anon_sym_PLUS] = ACTIONS(2852),
    [anon_sym_defined_QMARK] = ACTIONS(2855),
    [anon_sym_not] = ACTIONS(2858),
    [anon_sym_BANG] = ACTIONS(2861),
    [anon_sym_TILDE] = ACTIONS(2861),
    [sym_constant] = ACTIONS(2864),
    [sym_identifier] = ACTIONS(2864),
    [sym_instance_variable] = ACTIONS(2867),
    [sym_class_variable] = ACTIONS(2867),
    [sym_global_variable] = ACTIONS(2867),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_alias] = ACTIONS(2873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2876),
    [sym_float] = ACTIONS(2828),
    [sym_complex] = ACTIONS(2780),
    [sym_super] = ACTIONS(2864),
    [anon_sym_true] = ACTIONS(2879),
    [anon_sym_TRUE] = ACTIONS(2879),
    [anon_sym_false] = ACTIONS(2882),
    [anon_sym_FALSE] = ACTIONS(2882),
    [sym_self] = ACTIONS(2864),
    [anon_sym_nil] = ACTIONS(2885),
    [anon_sym_NIL] = ACTIONS(2885),
    [sym_character] = ACTIONS(2780),
    [anon_sym_LBRACK2] = ACTIONS(2888),
    [anon_sym_DASH_GT] = ACTIONS(2891),
  },
  [1257] = {
    [sym_operator] = STATE(3291),
    [sym__method_name] = STATE(3291),
    [sym_setter] = STATE(3291),
    [sym_symbol] = STATE(3291),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(5495),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(5495),
    [sym_class_variable] = ACTIONS(5495),
    [sym_global_variable] = ACTIONS(5495),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [1258] = {
    [aux_sym_undef_repeat1] = STATE(3292),
    [sym__line_break] = ACTIONS(5497),
    [sym__heredoc_body_start] = ACTIONS(5497),
    [ts_builtin_sym_end] = ACTIONS(5497),
    [anon_sym___END__] = ACTIONS(5497),
    [anon_sym_COMMA] = ACTIONS(2253),
    [anon_sym_SEMI] = ACTIONS(5497),
    [anon_sym_if] = ACTIONS(5497),
    [anon_sym_unless] = ACTIONS(5497),
    [anon_sym_while] = ACTIONS(5497),
    [anon_sym_until] = ACTIONS(5497),
    [anon_sym_rescue] = ACTIONS(5497),
    [sym_comment] = ACTIONS(87),
  },
  [1259] = {
    [sym__simple_symbol] = ACTIONS(887),
    [sym__symbol_start] = ACTIONS(887),
    [anon_sym_PIPE] = ACTIONS(887),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_STAR_STAR] = ACTIONS(887),
    [anon_sym_AMP] = ACTIONS(887),
    [anon_sym_LT] = ACTIONS(889),
    [anon_sym_DOT_DOT] = ACTIONS(887),
    [anon_sym_LT_LT] = ACTIONS(887),
    [anon_sym_GT_GT] = ACTIONS(887),
    [anon_sym_EQ_EQ] = ACTIONS(889),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(887),
    [anon_sym_LT_EQ_GT] = ACTIONS(887),
    [anon_sym_EQ_TILDE] = ACTIONS(887),
    [anon_sym_BANG_TILDE] = ACTIONS(887),
    [anon_sym_LT_EQ] = ACTIONS(889),
    [anon_sym_GT] = ACTIONS(889),
    [anon_sym_GT_EQ] = ACTIONS(887),
    [anon_sym_CARET] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_SLASH] = ACTIONS(887),
    [anon_sym_PERCENT] = ACTIONS(887),
    [anon_sym_BANG] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(887),
    [sym_constant] = ACTIONS(887),
    [sym_identifier] = ACTIONS(887),
    [sym_instance_variable] = ACTIONS(887),
    [sym_class_variable] = ACTIONS(887),
    [sym_global_variable] = ACTIONS(887),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_PLUS_AT] = ACTIONS(887),
    [anon_sym_DASH_AT] = ACTIONS(887),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(889),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(887),
    [anon_sym_BQUOTE] = ACTIONS(887),
    [sym_comment] = ACTIONS(87),
  },
  [1260] = {
    [sym__string_end] = ACTIONS(5499),
    [sym_comment] = ACTIONS(87),
  },
  [1261] = {
    [sym__simple_symbol] = ACTIONS(3675),
    [sym__symbol_start] = ACTIONS(3675),
    [anon_sym_PIPE] = ACTIONS(3675),
    [anon_sym_STAR] = ACTIONS(3677),
    [anon_sym_STAR_STAR] = ACTIONS(3675),
    [anon_sym_AMP] = ACTIONS(3675),
    [anon_sym_LT] = ACTIONS(3677),
    [anon_sym_DOT_DOT] = ACTIONS(3675),
    [anon_sym_LT_LT] = ACTIONS(3675),
    [anon_sym_GT_GT] = ACTIONS(3675),
    [anon_sym_EQ_EQ] = ACTIONS(3677),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3675),
    [anon_sym_LT_EQ_GT] = ACTIONS(3675),
    [anon_sym_EQ_TILDE] = ACTIONS(3675),
    [anon_sym_BANG_TILDE] = ACTIONS(3675),
    [anon_sym_LT_EQ] = ACTIONS(3677),
    [anon_sym_GT] = ACTIONS(3677),
    [anon_sym_GT_EQ] = ACTIONS(3675),
    [anon_sym_CARET] = ACTIONS(3675),
    [anon_sym_PLUS] = ACTIONS(3677),
    [anon_sym_SLASH] = ACTIONS(3675),
    [anon_sym_PERCENT] = ACTIONS(3675),
    [anon_sym_BANG] = ACTIONS(3677),
    [anon_sym_TILDE] = ACTIONS(3675),
    [sym_constant] = ACTIONS(3675),
    [sym_identifier] = ACTIONS(3675),
    [sym_instance_variable] = ACTIONS(3675),
    [sym_class_variable] = ACTIONS(3675),
    [sym_global_variable] = ACTIONS(3675),
    [anon_sym_DASH] = ACTIONS(3677),
    [anon_sym_PLUS_AT] = ACTIONS(3675),
    [anon_sym_DASH_AT] = ACTIONS(3675),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3677),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(3675),
    [anon_sym_BQUOTE] = ACTIONS(3675),
    [sym_comment] = ACTIONS(87),
  },
  [1262] = {
    [sym__line_break] = ACTIONS(5501),
    [sym__heredoc_body_start] = ACTIONS(5501),
    [ts_builtin_sym_end] = ACTIONS(5501),
    [anon_sym___END__] = ACTIONS(5501),
    [anon_sym_RBRACE] = ACTIONS(5501),
    [anon_sym_RPAREN] = ACTIONS(5501),
    [anon_sym_SEMI] = ACTIONS(5501),
    [anon_sym_end] = ACTIONS(5501),
    [anon_sym_if] = ACTIONS(5501),
    [anon_sym_unless] = ACTIONS(5501),
    [anon_sym_while] = ACTIONS(5501),
    [anon_sym_until] = ACTIONS(5501),
    [anon_sym_rescue] = ACTIONS(5501),
    [anon_sym_when] = ACTIONS(5501),
    [anon_sym_elsif] = ACTIONS(5501),
    [anon_sym_else] = ACTIONS(5501),
    [anon_sym_then] = ACTIONS(5501),
    [anon_sym_ensure] = ACTIONS(5501),
    [sym_comment] = ACTIONS(87),
  },
  [1263] = {
    [sym__string_start] = ACTIONS(835),
    [sym__heredoc_body_start] = ACTIONS(835),
    [sym__binary_minus] = ACTIONS(835),
    [sym__binary_star] = ACTIONS(835),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_RBRACE] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(835),
    [anon_sym_DOT] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(835),
    [anon_sym_PIPE] = ACTIONS(837),
    [anon_sym_SEMI] = ACTIONS(835),
    [anon_sym_STAR_STAR] = ACTIONS(835),
    [anon_sym_AMP] = ACTIONS(837),
    [anon_sym_COLON] = ACTIONS(837),
    [anon_sym_EQ] = ACTIONS(837),
    [anon_sym_LT] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_unless] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_until] = ACTIONS(835),
    [anon_sym_rescue] = ACTIONS(835),
    [anon_sym_in] = ACTIONS(835),
    [anon_sym_do] = ACTIONS(835),
    [anon_sym_EQ_GT] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_RBRACK] = ACTIONS(835),
    [anon_sym_COLON_COLON2] = ACTIONS(835),
    [anon_sym_AMP_DOT] = ACTIONS(835),
    [anon_sym_QMARK] = ACTIONS(835),
    [anon_sym_COLON2] = ACTIONS(837),
    [anon_sym_DOT_DOT] = ACTIONS(837),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(835),
    [anon_sym_and] = ACTIONS(835),
    [anon_sym_or] = ACTIONS(835),
    [anon_sym_PIPE_PIPE] = ACTIONS(835),
    [anon_sym_AMP_AMP] = ACTIONS(835),
    [anon_sym_LT_LT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(835),
    [anon_sym_EQ_EQ] = ACTIONS(837),
    [anon_sym_BANG_EQ] = ACTIONS(835),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(835),
    [anon_sym_LT_EQ_GT] = ACTIONS(835),
    [anon_sym_EQ_TILDE] = ACTIONS(835),
    [anon_sym_BANG_TILDE] = ACTIONS(835),
    [anon_sym_LT_EQ] = ACTIONS(837),
    [anon_sym_GT] = ACTIONS(837),
    [anon_sym_GT_EQ] = ACTIONS(835),
    [anon_sym_CARET] = ACTIONS(835),
    [anon_sym_PLUS] = ACTIONS(835),
    [anon_sym_SLASH] = ACTIONS(835),
    [anon_sym_PERCENT] = ACTIONS(835),
    [sym_comment] = ACTIONS(87),
  },
  [1264] = {
    [sym__string_end] = ACTIONS(5503),
    [sym_comment] = ACTIONS(87),
  },
  [1265] = {
    [sym__heredoc_body_start] = ACTIONS(887),
    [sym__binary_minus] = ACTIONS(887),
    [sym__binary_star] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(887),
    [anon_sym_RBRACE] = ACTIONS(887),
    [anon_sym_RPAREN] = ACTIONS(887),
    [anon_sym_DOT] = ACTIONS(889),
    [anon_sym_COMMA] = ACTIONS(887),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI] = ACTIONS(887),
    [anon_sym_STAR_STAR] = ACTIONS(887),
    [anon_sym_AMP] = ACTIONS(889),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_LT] = ACTIONS(889),
    [anon_sym_if] = ACTIONS(887),
    [anon_sym_unless] = ACTIONS(887),
    [anon_sym_while] = ACTIONS(887),
    [anon_sym_until] = ACTIONS(887),
    [anon_sym_rescue] = ACTIONS(887),
    [anon_sym_in] = ACTIONS(887),
    [anon_sym_do] = ACTIONS(887),
    [anon_sym_EQ_GT] = ACTIONS(887),
    [anon_sym_LBRACK] = ACTIONS(887),
    [anon_sym_RBRACK] = ACTIONS(887),
    [anon_sym_COLON_COLON2] = ACTIONS(887),
    [anon_sym_AMP_DOT] = ACTIONS(887),
    [anon_sym_QMARK] = ACTIONS(887),
    [anon_sym_COLON2] = ACTIONS(889),
    [anon_sym_DOT_DOT] = ACTIONS(889),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(887),
    [anon_sym_and] = ACTIONS(887),
    [anon_sym_or] = ACTIONS(887),
    [anon_sym_PIPE_PIPE] = ACTIONS(887),
    [anon_sym_AMP_AMP] = ACTIONS(887),
    [anon_sym_LT_LT] = ACTIONS(887),
    [anon_sym_GT_GT] = ACTIONS(887),
    [anon_sym_EQ_EQ] = ACTIONS(889),
    [anon_sym_BANG_EQ] = ACTIONS(887),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(887),
    [anon_sym_LT_EQ_GT] = ACTIONS(887),
    [anon_sym_EQ_TILDE] = ACTIONS(887),
    [anon_sym_BANG_TILDE] = ACTIONS(887),
    [anon_sym_LT_EQ] = ACTIONS(889),
    [anon_sym_GT] = ACTIONS(889),
    [anon_sym_GT_EQ] = ACTIONS(887),
    [anon_sym_CARET] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_SLASH] = ACTIONS(887),
    [anon_sym_PERCENT] = ACTIONS(887),
    [sym_comment] = ACTIONS(87),
  },
  [1266] = {
    [sym__string_end] = ACTIONS(5505),
    [sym_comment] = ACTIONS(87),
  },
  [1267] = {
    [sym__heredoc_body_start] = ACTIONS(893),
    [sym__binary_minus] = ACTIONS(893),
    [sym__binary_star] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(893),
    [anon_sym_RBRACE] = ACTIONS(893),
    [anon_sym_RPAREN] = ACTIONS(893),
    [anon_sym_DOT] = ACTIONS(895),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_PIPE] = ACTIONS(895),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_STAR_STAR] = ACTIONS(893),
    [anon_sym_AMP] = ACTIONS(895),
    [anon_sym_EQ] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(895),
    [anon_sym_if] = ACTIONS(893),
    [anon_sym_unless] = ACTIONS(893),
    [anon_sym_while] = ACTIONS(893),
    [anon_sym_until] = ACTIONS(893),
    [anon_sym_rescue] = ACTIONS(893),
    [anon_sym_in] = ACTIONS(893),
    [anon_sym_do] = ACTIONS(893),
    [anon_sym_EQ_GT] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(893),
    [anon_sym_RBRACK] = ACTIONS(893),
    [anon_sym_COLON_COLON2] = ACTIONS(893),
    [anon_sym_AMP_DOT] = ACTIONS(893),
    [anon_sym_QMARK] = ACTIONS(893),
    [anon_sym_COLON2] = ACTIONS(895),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(893),
    [anon_sym_and] = ACTIONS(893),
    [anon_sym_or] = ACTIONS(893),
    [anon_sym_PIPE_PIPE] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(893),
    [anon_sym_LT_LT] = ACTIONS(893),
    [anon_sym_GT_GT] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(895),
    [anon_sym_BANG_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_LT_EQ_GT] = ACTIONS(893),
    [anon_sym_EQ_TILDE] = ACTIONS(893),
    [anon_sym_BANG_TILDE] = ACTIONS(893),
    [anon_sym_LT_EQ] = ACTIONS(895),
    [anon_sym_GT] = ACTIONS(895),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_CARET] = ACTIONS(893),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_SLASH] = ACTIONS(893),
    [anon_sym_PERCENT] = ACTIONS(893),
    [sym_comment] = ACTIONS(87),
  },
  [1268] = {
    [sym__string_end] = ACTIONS(5507),
    [sym_comment] = ACTIONS(87),
  },
  [1269] = {
    [sym__heredoc_body_start] = ACTIONS(899),
    [sym__binary_minus] = ACTIONS(899),
    [sym__binary_star] = ACTIONS(899),
    [anon_sym_LBRACE] = ACTIONS(899),
    [anon_sym_RBRACE] = ACTIONS(899),
    [anon_sym_RPAREN] = ACTIONS(899),
    [anon_sym_DOT] = ACTIONS(901),
    [anon_sym_COMMA] = ACTIONS(899),
    [anon_sym_PIPE] = ACTIONS(901),
    [anon_sym_SEMI] = ACTIONS(899),
    [anon_sym_STAR_STAR] = ACTIONS(899),
    [anon_sym_AMP] = ACTIONS(901),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_LT] = ACTIONS(901),
    [anon_sym_if] = ACTIONS(899),
    [anon_sym_unless] = ACTIONS(899),
    [anon_sym_while] = ACTIONS(899),
    [anon_sym_until] = ACTIONS(899),
    [anon_sym_rescue] = ACTIONS(899),
    [anon_sym_in] = ACTIONS(899),
    [anon_sym_do] = ACTIONS(899),
    [anon_sym_EQ_GT] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(899),
    [anon_sym_RBRACK] = ACTIONS(899),
    [anon_sym_COLON_COLON2] = ACTIONS(899),
    [anon_sym_AMP_DOT] = ACTIONS(899),
    [anon_sym_QMARK] = ACTIONS(899),
    [anon_sym_COLON2] = ACTIONS(901),
    [anon_sym_DOT_DOT] = ACTIONS(901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(899),
    [anon_sym_and] = ACTIONS(899),
    [anon_sym_or] = ACTIONS(899),
    [anon_sym_PIPE_PIPE] = ACTIONS(899),
    [anon_sym_AMP_AMP] = ACTIONS(899),
    [anon_sym_LT_LT] = ACTIONS(899),
    [anon_sym_GT_GT] = ACTIONS(899),
    [anon_sym_EQ_EQ] = ACTIONS(901),
    [anon_sym_BANG_EQ] = ACTIONS(899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(899),
    [anon_sym_LT_EQ_GT] = ACTIONS(899),
    [anon_sym_EQ_TILDE] = ACTIONS(899),
    [anon_sym_BANG_TILDE] = ACTIONS(899),
    [anon_sym_LT_EQ] = ACTIONS(901),
    [anon_sym_GT] = ACTIONS(901),
    [anon_sym_GT_EQ] = ACTIONS(899),
    [anon_sym_CARET] = ACTIONS(899),
    [anon_sym_PLUS] = ACTIONS(899),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [sym_comment] = ACTIONS(87),
  },
  [1270] = {
    [sym__string_end] = ACTIONS(5509),
    [sym_comment] = ACTIONS(87),
  },
  [1271] = {
    [sym__heredoc_body_start] = ACTIONS(905),
    [sym__binary_minus] = ACTIONS(905),
    [sym__binary_star] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(905),
    [anon_sym_RBRACE] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(905),
    [anon_sym_DOT] = ACTIONS(907),
    [anon_sym_COMMA] = ACTIONS(905),
    [anon_sym_PIPE] = ACTIONS(907),
    [anon_sym_SEMI] = ACTIONS(905),
    [anon_sym_STAR_STAR] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(907),
    [anon_sym_LT] = ACTIONS(907),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_unless] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_until] = ACTIONS(905),
    [anon_sym_rescue] = ACTIONS(905),
    [anon_sym_in] = ACTIONS(905),
    [anon_sym_do] = ACTIONS(905),
    [anon_sym_EQ_GT] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_RBRACK] = ACTIONS(905),
    [anon_sym_COLON_COLON2] = ACTIONS(905),
    [anon_sym_AMP_DOT] = ACTIONS(905),
    [anon_sym_QMARK] = ACTIONS(905),
    [anon_sym_COLON2] = ACTIONS(907),
    [anon_sym_DOT_DOT] = ACTIONS(907),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(905),
    [anon_sym_and] = ACTIONS(905),
    [anon_sym_or] = ACTIONS(905),
    [anon_sym_PIPE_PIPE] = ACTIONS(905),
    [anon_sym_AMP_AMP] = ACTIONS(905),
    [anon_sym_LT_LT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(905),
    [anon_sym_EQ_EQ] = ACTIONS(907),
    [anon_sym_BANG_EQ] = ACTIONS(905),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(905),
    [anon_sym_LT_EQ_GT] = ACTIONS(905),
    [anon_sym_EQ_TILDE] = ACTIONS(905),
    [anon_sym_BANG_TILDE] = ACTIONS(905),
    [anon_sym_LT_EQ] = ACTIONS(907),
    [anon_sym_GT] = ACTIONS(907),
    [anon_sym_GT_EQ] = ACTIONS(905),
    [anon_sym_CARET] = ACTIONS(905),
    [anon_sym_PLUS] = ACTIONS(905),
    [anon_sym_SLASH] = ACTIONS(905),
    [anon_sym_PERCENT] = ACTIONS(905),
    [sym_comment] = ACTIONS(87),
  },
  [1272] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(3300),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(5511),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(5513),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [1273] = {
    [aux_sym_string_array_repeat1] = STATE(3303),
    [sym__string_end] = ACTIONS(5515),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(5517),
  },
  [1274] = {
    [sym__heredoc_body_start] = ACTIONS(923),
    [sym__binary_minus] = ACTIONS(923),
    [sym__binary_star] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(923),
    [anon_sym_RBRACE] = ACTIONS(923),
    [anon_sym_RPAREN] = ACTIONS(923),
    [anon_sym_DOT] = ACTIONS(925),
    [anon_sym_COMMA] = ACTIONS(923),
    [anon_sym_PIPE] = ACTIONS(925),
    [anon_sym_SEMI] = ACTIONS(923),
    [anon_sym_STAR_STAR] = ACTIONS(923),
    [anon_sym_AMP] = ACTIONS(925),
    [anon_sym_EQ] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(925),
    [anon_sym_if] = ACTIONS(923),
    [anon_sym_unless] = ACTIONS(923),
    [anon_sym_while] = ACTIONS(923),
    [anon_sym_until] = ACTIONS(923),
    [anon_sym_rescue] = ACTIONS(923),
    [anon_sym_in] = ACTIONS(923),
    [anon_sym_do] = ACTIONS(923),
    [anon_sym_EQ_GT] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(923),
    [anon_sym_RBRACK] = ACTIONS(923),
    [anon_sym_COLON_COLON2] = ACTIONS(923),
    [anon_sym_AMP_DOT] = ACTIONS(923),
    [anon_sym_QMARK] = ACTIONS(923),
    [anon_sym_COLON2] = ACTIONS(925),
    [anon_sym_DOT_DOT] = ACTIONS(925),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(923),
    [anon_sym_and] = ACTIONS(923),
    [anon_sym_or] = ACTIONS(923),
    [anon_sym_PIPE_PIPE] = ACTIONS(923),
    [anon_sym_AMP_AMP] = ACTIONS(923),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_EQ_EQ] = ACTIONS(925),
    [anon_sym_BANG_EQ] = ACTIONS(923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(923),
    [anon_sym_LT_EQ_GT] = ACTIONS(923),
    [anon_sym_EQ_TILDE] = ACTIONS(923),
    [anon_sym_BANG_TILDE] = ACTIONS(923),
    [anon_sym_LT_EQ] = ACTIONS(925),
    [anon_sym_GT] = ACTIONS(925),
    [anon_sym_GT_EQ] = ACTIONS(923),
    [anon_sym_CARET] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(923),
    [anon_sym_SLASH] = ACTIONS(923),
    [anon_sym_PERCENT] = ACTIONS(923),
    [sym_comment] = ACTIONS(87),
  },
  [1275] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(3306),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(5519),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(5521),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [1276] = {
    [aux_sym_symbol_array_repeat1] = STATE(3309),
    [sym__string_end] = ACTIONS(5523),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(5525),
  },
  [1277] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(3310),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(1287),
    [sym_scope_resolution] = STATE(1285),
    [sym_call] = STATE(1285),
    [sym_method_call] = STATE(1287),
    [sym_assignment] = STATE(3310),
    [sym_operator_assignment] = STATE(3310),
    [sym_conditional] = STATE(3310),
    [sym_range] = STATE(3310),
    [sym_binary] = STATE(3310),
    [sym_unary] = STATE(3310),
    [sym_left_assignment_list] = STATE(1286),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1287),
    [sym__variable] = STATE(1285),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(1287),
    [sym_false] = STATE(1287),
    [sym_nil] = STATE(1287),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(1288),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(2281),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2283),
    [anon_sym_yield] = ACTIONS(2285),
    [anon_sym_break] = ACTIONS(2287),
    [anon_sym_next] = ACTIONS(2289),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2291),
    [anon_sym_defined_QMARK] = ACTIONS(2293),
    [anon_sym_not] = ACTIONS(2295),
    [anon_sym_BANG] = ACTIONS(2297),
    [anon_sym_TILDE] = ACTIONS(2297),
    [sym_constant] = ACTIONS(2299),
    [sym_identifier] = ACTIONS(2299),
    [sym_instance_variable] = ACTIONS(2301),
    [sym_class_variable] = ACTIONS(2301),
    [sym_global_variable] = ACTIONS(2301),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2299),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2299),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1278] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(3316),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1322),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(1322),
    [sym_argument_list] = STATE(1318),
    [sym__argument_list_with_parens] = STATE(3317),
    [sym__argument] = STATE(3318),
    [sym_splat_argument] = STATE(3318),
    [sym_hash_splat_argument] = STATE(3318),
    [sym_block_argument] = STATE(3318),
    [sym_assignment] = STATE(3316),
    [sym_operator_assignment] = STATE(3316),
    [sym_conditional] = STATE(3316),
    [sym_range] = STATE(3316),
    [sym_binary] = STATE(3316),
    [sym_unary] = STATE(3316),
    [sym_left_assignment_list] = STATE(1321),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1322),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1322),
    [sym_false] = STATE(1322),
    [sym_nil] = STATE(1322),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(3319),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(3318),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(5527),
    [sym__splat_star] = ACTIONS(5529),
    [sym__unary_minus] = ACTIONS(2325),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(5531),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_RBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(2329),
    [anon_sym_not] = ACTIONS(2331),
    [anon_sym_BANG] = ACTIONS(2333),
    [anon_sym_TILDE] = ACTIONS(2335),
    [sym_constant] = ACTIONS(5533),
    [sym_identifier] = ACTIONS(5533),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1279] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(3316),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1322),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(1322),
    [sym_argument_list] = STATE(1324),
    [sym__argument_list_with_parens] = STATE(3317),
    [sym__argument] = STATE(3318),
    [sym_splat_argument] = STATE(3318),
    [sym_hash_splat_argument] = STATE(3318),
    [sym_block_argument] = STATE(3318),
    [sym_assignment] = STATE(3316),
    [sym_operator_assignment] = STATE(3316),
    [sym_conditional] = STATE(3316),
    [sym_range] = STATE(3316),
    [sym_binary] = STATE(3316),
    [sym_unary] = STATE(3316),
    [sym_left_assignment_list] = STATE(1321),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1322),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1322),
    [sym_false] = STATE(1322),
    [sym_nil] = STATE(1322),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(3319),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(3318),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(5527),
    [sym__splat_star] = ACTIONS(5529),
    [sym__unary_minus] = ACTIONS(2325),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(5531),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_RBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(2329),
    [anon_sym_not] = ACTIONS(2331),
    [anon_sym_BANG] = ACTIONS(2333),
    [anon_sym_TILDE] = ACTIONS(2335),
    [sym_constant] = ACTIONS(5533),
    [sym_identifier] = ACTIONS(5533),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1280] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(3316),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1322),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(1322),
    [sym_argument_list] = STATE(1325),
    [sym__argument_list_with_parens] = STATE(3317),
    [sym__argument] = STATE(3318),
    [sym_splat_argument] = STATE(3318),
    [sym_hash_splat_argument] = STATE(3318),
    [sym_block_argument] = STATE(3318),
    [sym_assignment] = STATE(3316),
    [sym_operator_assignment] = STATE(3316),
    [sym_conditional] = STATE(3316),
    [sym_range] = STATE(3316),
    [sym_binary] = STATE(3316),
    [sym_unary] = STATE(3316),
    [sym_left_assignment_list] = STATE(1321),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1322),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1322),
    [sym_false] = STATE(1322),
    [sym_nil] = STATE(1322),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(3319),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(3318),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(5527),
    [sym__splat_star] = ACTIONS(5529),
    [sym__unary_minus] = ACTIONS(2325),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(5531),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_RBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(2329),
    [anon_sym_not] = ACTIONS(2331),
    [anon_sym_BANG] = ACTIONS(2333),
    [anon_sym_TILDE] = ACTIONS(2335),
    [sym_constant] = ACTIONS(5533),
    [sym_identifier] = ACTIONS(5533),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1281] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(3316),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1322),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(1322),
    [sym_argument_list] = STATE(1326),
    [sym__argument_list_with_parens] = STATE(3317),
    [sym__argument] = STATE(3318),
    [sym_splat_argument] = STATE(3318),
    [sym_hash_splat_argument] = STATE(3318),
    [sym_block_argument] = STATE(3318),
    [sym_assignment] = STATE(3316),
    [sym_operator_assignment] = STATE(3316),
    [sym_conditional] = STATE(3316),
    [sym_range] = STATE(3316),
    [sym_binary] = STATE(3316),
    [sym_unary] = STATE(3316),
    [sym_left_assignment_list] = STATE(1321),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1322),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1322),
    [sym_false] = STATE(1322),
    [sym_nil] = STATE(1322),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(3319),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(3318),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(5527),
    [sym__splat_star] = ACTIONS(5529),
    [sym__unary_minus] = ACTIONS(2325),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(5531),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_RBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(2329),
    [anon_sym_not] = ACTIONS(2331),
    [anon_sym_BANG] = ACTIONS(2333),
    [anon_sym_TILDE] = ACTIONS(2335),
    [sym_constant] = ACTIONS(5533),
    [sym_identifier] = ACTIONS(5533),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1282] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(3320),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(1287),
    [sym_scope_resolution] = STATE(1285),
    [sym_call] = STATE(1285),
    [sym_method_call] = STATE(1287),
    [sym_assignment] = STATE(3320),
    [sym_operator_assignment] = STATE(3320),
    [sym_conditional] = STATE(3320),
    [sym_range] = STATE(3320),
    [sym_binary] = STATE(3320),
    [sym_unary] = STATE(3320),
    [sym_left_assignment_list] = STATE(1286),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1287),
    [sym__variable] = STATE(1285),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(1287),
    [sym_false] = STATE(1287),
    [sym_nil] = STATE(1287),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(1288),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(2281),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2283),
    [anon_sym_yield] = ACTIONS(2285),
    [anon_sym_break] = ACTIONS(2287),
    [anon_sym_next] = ACTIONS(2289),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2291),
    [anon_sym_defined_QMARK] = ACTIONS(2293),
    [anon_sym_not] = ACTIONS(2295),
    [anon_sym_BANG] = ACTIONS(2297),
    [anon_sym_TILDE] = ACTIONS(2297),
    [sym_constant] = ACTIONS(2299),
    [sym_identifier] = ACTIONS(2299),
    [sym_instance_variable] = ACTIONS(2301),
    [sym_class_variable] = ACTIONS(2301),
    [sym_global_variable] = ACTIONS(2301),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2299),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2299),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1283] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(1341),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(1287),
    [sym_scope_resolution] = STATE(1285),
    [sym_call] = STATE(1285),
    [sym_method_call] = STATE(1287),
    [sym_assignment] = STATE(1341),
    [sym_operator_assignment] = STATE(1341),
    [sym_conditional] = STATE(1341),
    [sym_range] = STATE(1341),
    [sym_binary] = STATE(1341),
    [sym_unary] = STATE(1341),
    [sym_left_assignment_list] = STATE(1286),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1287),
    [sym__variable] = STATE(1285),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(1287),
    [sym_false] = STATE(1287),
    [sym_nil] = STATE(1287),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(1288),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(2281),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2283),
    [anon_sym_yield] = ACTIONS(2285),
    [anon_sym_break] = ACTIONS(2287),
    [anon_sym_next] = ACTIONS(2289),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2291),
    [anon_sym_defined_QMARK] = ACTIONS(2293),
    [anon_sym_not] = ACTIONS(2295),
    [anon_sym_BANG] = ACTIONS(2297),
    [anon_sym_TILDE] = ACTIONS(2297),
    [sym_constant] = ACTIONS(2299),
    [sym_identifier] = ACTIONS(2299),
    [sym_instance_variable] = ACTIONS(2301),
    [sym_class_variable] = ACTIONS(2301),
    [sym_global_variable] = ACTIONS(2301),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2299),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2299),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1284] = {
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(5535),
    [sym__binary_star] = ACTIONS(5537),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5537),
    [anon_sym_AMP] = ACTIONS(5541),
    [anon_sym_LT] = ACTIONS(5543),
    [anon_sym_RBRACK] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(5545),
    [anon_sym_DOT_DOT] = ACTIONS(5547),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5549),
    [anon_sym_and] = ACTIONS(5551),
    [anon_sym_or] = ACTIONS(5551),
    [anon_sym_PIPE_PIPE] = ACTIONS(5553),
    [anon_sym_AMP_AMP] = ACTIONS(5553),
    [anon_sym_LT_LT] = ACTIONS(5555),
    [anon_sym_GT_GT] = ACTIONS(5555),
    [anon_sym_EQ_EQ] = ACTIONS(5557),
    [anon_sym_BANG_EQ] = ACTIONS(5553),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5553),
    [anon_sym_LT_EQ_GT] = ACTIONS(5553),
    [anon_sym_EQ_TILDE] = ACTIONS(5553),
    [anon_sym_BANG_TILDE] = ACTIONS(5553),
    [anon_sym_LT_EQ] = ACTIONS(5543),
    [anon_sym_GT] = ACTIONS(5543),
    [anon_sym_GT_EQ] = ACTIONS(5559),
    [anon_sym_CARET] = ACTIONS(5561),
    [anon_sym_PLUS] = ACTIONS(5535),
    [anon_sym_SLASH] = ACTIONS(5537),
    [anon_sym_PERCENT] = ACTIONS(5537),
    [sym_comment] = ACTIONS(87),
  },
  [1285] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3336),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1384),
    [sym_scope_resolution] = STATE(1378),
    [sym_call] = STATE(1378),
    [sym_method_call] = STATE(1384),
    [sym_argument_list] = STATE(1846),
    [sym__argument_list_with_parens] = STATE(3337),
    [sym__argument] = STATE(3338),
    [sym_splat_argument] = STATE(3338),
    [sym_hash_splat_argument] = STATE(3338),
    [sym_block_argument] = STATE(3338),
    [sym_do_block] = STATE(1849),
    [sym_block] = STATE(1849),
    [sym_assignment] = STATE(3336),
    [sym_operator_assignment] = STATE(3336),
    [sym_conditional] = STATE(3336),
    [sym_range] = STATE(3336),
    [sym_binary] = STATE(3336),
    [sym_unary] = STATE(3336),
    [sym_left_assignment_list] = STATE(1383),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1384),
    [sym__variable] = STATE(1378),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1384),
    [sym_false] = STATE(1384),
    [sym_nil] = STATE(1384),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3339),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(3338),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(5563),
    [sym__splat_star] = ACTIONS(5565),
    [sym__unary_minus] = ACTIONS(2399),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(5567),
    [anon_sym_LBRACE] = ACTIONS(3327),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2405),
    [anon_sym_yield] = ACTIONS(2407),
    [anon_sym_break] = ACTIONS(2409),
    [anon_sym_next] = ACTIONS(2411),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(3337),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_RBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(2415),
    [anon_sym_not] = ACTIONS(2417),
    [anon_sym_BANG] = ACTIONS(2419),
    [anon_sym_TILDE] = ACTIONS(2421),
    [sym_constant] = ACTIONS(5569),
    [sym_identifier] = ACTIONS(5569),
    [sym_instance_variable] = ACTIONS(2425),
    [sym_class_variable] = ACTIONS(2425),
    [sym_global_variable] = ACTIONS(2425),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2427),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2427),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1286] = {
    [anon_sym_EQ] = ACTIONS(5571),
    [sym_comment] = ACTIONS(87),
  },
  [1287] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(5573),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(5575),
    [anon_sym_DASH_EQ] = ACTIONS(5575),
    [anon_sym_STAR_EQ] = ACTIONS(5575),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5575),
    [anon_sym_SLASH_EQ] = ACTIONS(5575),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5575),
    [anon_sym_PIPE_EQ] = ACTIONS(5575),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5575),
    [anon_sym_AMP_EQ] = ACTIONS(5575),
    [anon_sym_PERCENT_EQ] = ACTIONS(5575),
    [anon_sym_GT_GT_EQ] = ACTIONS(5575),
    [anon_sym_LT_LT_EQ] = ACTIONS(5575),
    [anon_sym_CARET_EQ] = ACTIONS(5575),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1288] = {
    [sym_string] = STATE(3342),
    [aux_sym_chained_string_repeat1] = STATE(3342),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [1289] = {
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(5535),
    [sym__binary_star] = ACTIONS(5537),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5537),
    [anon_sym_AMP] = ACTIONS(5541),
    [anon_sym_LT] = ACTIONS(5543),
    [anon_sym_RBRACK] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(5545),
    [anon_sym_DOT_DOT] = ACTIONS(5547),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5549),
    [anon_sym_and] = ACTIONS(5551),
    [anon_sym_or] = ACTIONS(5551),
    [anon_sym_PIPE_PIPE] = ACTIONS(5553),
    [anon_sym_AMP_AMP] = ACTIONS(5553),
    [anon_sym_LT_LT] = ACTIONS(5555),
    [anon_sym_GT_GT] = ACTIONS(5555),
    [anon_sym_EQ_EQ] = ACTIONS(5557),
    [anon_sym_BANG_EQ] = ACTIONS(5553),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5553),
    [anon_sym_LT_EQ_GT] = ACTIONS(5553),
    [anon_sym_EQ_TILDE] = ACTIONS(5553),
    [anon_sym_BANG_TILDE] = ACTIONS(5553),
    [anon_sym_LT_EQ] = ACTIONS(5543),
    [anon_sym_GT] = ACTIONS(5543),
    [anon_sym_GT_EQ] = ACTIONS(5559),
    [anon_sym_CARET] = ACTIONS(5561),
    [anon_sym_PLUS] = ACTIONS(5535),
    [anon_sym_SLASH] = ACTIONS(5537),
    [anon_sym_PERCENT] = ACTIONS(5537),
    [sym_comment] = ACTIONS(87),
  },
  [1290] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(2361),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_RBRACK] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [1291] = {
    [sym_string] = STATE(1392),
    [aux_sym_chained_string_repeat1] = STATE(1392),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [1292] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(3343),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(1287),
    [sym_scope_resolution] = STATE(1285),
    [sym_call] = STATE(1285),
    [sym_method_call] = STATE(1287),
    [sym_assignment] = STATE(3343),
    [sym_operator_assignment] = STATE(3343),
    [sym_conditional] = STATE(3343),
    [sym_range] = STATE(3343),
    [sym_binary] = STATE(3343),
    [sym_unary] = STATE(3343),
    [sym_left_assignment_list] = STATE(1286),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1287),
    [sym__variable] = STATE(1285),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(1287),
    [sym_false] = STATE(1287),
    [sym_nil] = STATE(1287),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(1288),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(2281),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2283),
    [anon_sym_yield] = ACTIONS(2285),
    [anon_sym_break] = ACTIONS(2287),
    [anon_sym_next] = ACTIONS(2289),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2291),
    [anon_sym_defined_QMARK] = ACTIONS(2293),
    [anon_sym_not] = ACTIONS(2295),
    [anon_sym_BANG] = ACTIONS(2297),
    [anon_sym_TILDE] = ACTIONS(2297),
    [sym_constant] = ACTIONS(2299),
    [sym_identifier] = ACTIONS(2299),
    [sym_instance_variable] = ACTIONS(2301),
    [sym_class_variable] = ACTIONS(2301),
    [sym_global_variable] = ACTIONS(2301),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2299),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2299),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1293] = {
    [sym__heredoc_body_start] = ACTIONS(993),
    [sym__binary_minus] = ACTIONS(993),
    [sym__binary_star] = ACTIONS(993),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_RBRACE] = ACTIONS(993),
    [anon_sym_RPAREN] = ACTIONS(993),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(993),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_SEMI] = ACTIONS(993),
    [anon_sym_STAR_STAR] = ACTIONS(993),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_EQ] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(995),
    [anon_sym_if] = ACTIONS(993),
    [anon_sym_unless] = ACTIONS(993),
    [anon_sym_while] = ACTIONS(993),
    [anon_sym_until] = ACTIONS(993),
    [anon_sym_rescue] = ACTIONS(993),
    [anon_sym_in] = ACTIONS(993),
    [anon_sym_do] = ACTIONS(993),
    [anon_sym_EQ_GT] = ACTIONS(993),
    [anon_sym_LBRACK] = ACTIONS(993),
    [anon_sym_RBRACK] = ACTIONS(993),
    [anon_sym_COLON_COLON2] = ACTIONS(993),
    [anon_sym_AMP_DOT] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(993),
    [anon_sym_COLON2] = ACTIONS(995),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(993),
    [anon_sym_and] = ACTIONS(993),
    [anon_sym_or] = ACTIONS(993),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_AMP_AMP] = ACTIONS(993),
    [anon_sym_LT_LT] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(993),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(993),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(993),
    [anon_sym_LT_EQ_GT] = ACTIONS(993),
    [anon_sym_EQ_TILDE] = ACTIONS(993),
    [anon_sym_BANG_TILDE] = ACTIONS(993),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(993),
    [anon_sym_CARET] = ACTIONS(993),
    [anon_sym_PLUS] = ACTIONS(993),
    [anon_sym_SLASH] = ACTIONS(993),
    [anon_sym_PERCENT] = ACTIONS(993),
    [sym_comment] = ACTIONS(87),
  },
  [1294] = {
    [anon_sym_RBRACE] = ACTIONS(5577),
    [sym_comment] = ACTIONS(87),
  },
  [1295] = {
    [sym_heredoc_body] = STATE(3345),
    [sym__heredoc_body_start] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(5577),
    [sym_comment] = ACTIONS(87),
  },
  [1296] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(3346),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(674),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(674),
    [sym_assignment] = STATE(3346),
    [sym_operator_assignment] = STATE(3346),
    [sym_conditional] = STATE(3346),
    [sym_range] = STATE(3346),
    [sym_binary] = STATE(3346),
    [sym_unary] = STATE(3346),
    [sym_left_assignment_list] = STATE(673),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(674),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(674),
    [sym_false] = STATE(674),
    [sym_nil] = STATE(674),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(675),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1243),
    [anon_sym_yield] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1247),
    [anon_sym_next] = ACTIONS(1249),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1297] = {
    [sym__heredoc_body_start] = ACTIONS(1273),
    [sym__binary_minus] = ACTIONS(1273),
    [sym__binary_star] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_RBRACE] = ACTIONS(1273),
    [anon_sym_RPAREN] = ACTIONS(1273),
    [anon_sym_DOT] = ACTIONS(1275),
    [anon_sym_COMMA] = ACTIONS(1273),
    [anon_sym_PIPE] = ACTIONS(1275),
    [anon_sym_SEMI] = ACTIONS(1273),
    [anon_sym_STAR_STAR] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_EQ] = ACTIONS(1275),
    [anon_sym_LT] = ACTIONS(1275),
    [anon_sym_if] = ACTIONS(1273),
    [anon_sym_unless] = ACTIONS(1273),
    [anon_sym_while] = ACTIONS(1273),
    [anon_sym_until] = ACTIONS(1273),
    [anon_sym_rescue] = ACTIONS(1273),
    [anon_sym_in] = ACTIONS(1273),
    [anon_sym_do] = ACTIONS(1273),
    [anon_sym_EQ_GT] = ACTIONS(1273),
    [anon_sym_LBRACK] = ACTIONS(1273),
    [anon_sym_RBRACK] = ACTIONS(1273),
    [anon_sym_COLON_COLON2] = ACTIONS(1273),
    [anon_sym_AMP_DOT] = ACTIONS(1273),
    [anon_sym_QMARK] = ACTIONS(1273),
    [anon_sym_COLON2] = ACTIONS(1275),
    [anon_sym_DOT_DOT] = ACTIONS(1275),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_and] = ACTIONS(1273),
    [anon_sym_or] = ACTIONS(1273),
    [anon_sym_PIPE_PIPE] = ACTIONS(1273),
    [anon_sym_AMP_AMP] = ACTIONS(1273),
    [anon_sym_LT_LT] = ACTIONS(1273),
    [anon_sym_GT_GT] = ACTIONS(1273),
    [anon_sym_EQ_EQ] = ACTIONS(1275),
    [anon_sym_BANG_EQ] = ACTIONS(1273),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1273),
    [anon_sym_LT_EQ_GT] = ACTIONS(1273),
    [anon_sym_EQ_TILDE] = ACTIONS(1273),
    [anon_sym_BANG_TILDE] = ACTIONS(1273),
    [anon_sym_LT_EQ] = ACTIONS(1275),
    [anon_sym_GT] = ACTIONS(1275),
    [anon_sym_GT_EQ] = ACTIONS(1273),
    [anon_sym_CARET] = ACTIONS(1273),
    [anon_sym_PLUS] = ACTIONS(1273),
    [anon_sym_SLASH] = ACTIONS(1273),
    [anon_sym_PERCENT] = ACTIONS(1273),
    [sym_comment] = ACTIONS(87),
  },
  [1298] = {
    [anon_sym_DOT] = ACTIONS(5579),
    [anon_sym_COLON_COLON] = ACTIONS(5579),
    [sym_comment] = ACTIONS(87),
  },
  [1299] = {
    [sym_method_parameters] = STATE(3348),
    [sym__simple_formal_parameter] = STATE(684),
    [sym_splat_parameter] = STATE(684),
    [sym_hash_splat_parameter] = STATE(684),
    [sym_block_parameter] = STATE(684),
    [sym_keyword_parameter] = STATE(684),
    [sym_optional_parameter] = STATE(684),
    [sym_heredoc_body] = STATE(3348),
    [sym__terminator] = STATE(3348),
    [sym__line_break] = ACTIONS(5581),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_SEMI] = ACTIONS(5581),
    [anon_sym_STAR] = ACTIONS(1283),
    [anon_sym_STAR_STAR] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1287),
    [sym_identifier] = ACTIONS(1289),
    [sym_comment] = ACTIONS(87),
  },
  [1300] = {
    [sym__heredoc_body_start] = ACTIONS(1291),
    [sym__binary_minus] = ACTIONS(1291),
    [sym__binary_star] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1291),
    [anon_sym_RBRACE] = ACTIONS(1291),
    [anon_sym_RPAREN] = ACTIONS(1291),
    [anon_sym_DOT] = ACTIONS(1293),
    [anon_sym_COMMA] = ACTIONS(1291),
    [anon_sym_PIPE] = ACTIONS(1293),
    [anon_sym_SEMI] = ACTIONS(1291),
    [anon_sym_STAR_STAR] = ACTIONS(1291),
    [anon_sym_AMP] = ACTIONS(1293),
    [anon_sym_EQ] = ACTIONS(1293),
    [anon_sym_LT] = ACTIONS(1293),
    [anon_sym_if] = ACTIONS(1291),
    [anon_sym_unless] = ACTIONS(1291),
    [anon_sym_while] = ACTIONS(1291),
    [anon_sym_until] = ACTIONS(1291),
    [anon_sym_rescue] = ACTIONS(1291),
    [anon_sym_in] = ACTIONS(1291),
    [anon_sym_do] = ACTIONS(1291),
    [anon_sym_EQ_GT] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_RBRACK] = ACTIONS(1291),
    [anon_sym_COLON_COLON2] = ACTIONS(1291),
    [anon_sym_AMP_DOT] = ACTIONS(1291),
    [anon_sym_QMARK] = ACTIONS(1291),
    [anon_sym_COLON2] = ACTIONS(1293),
    [anon_sym_DOT_DOT] = ACTIONS(1293),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1291),
    [anon_sym_and] = ACTIONS(1291),
    [anon_sym_or] = ACTIONS(1291),
    [anon_sym_PIPE_PIPE] = ACTIONS(1291),
    [anon_sym_AMP_AMP] = ACTIONS(1291),
    [anon_sym_LT_LT] = ACTIONS(1291),
    [anon_sym_GT_GT] = ACTIONS(1291),
    [anon_sym_EQ_EQ] = ACTIONS(1293),
    [anon_sym_BANG_EQ] = ACTIONS(1291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1291),
    [anon_sym_LT_EQ_GT] = ACTIONS(1291),
    [anon_sym_EQ_TILDE] = ACTIONS(1291),
    [anon_sym_BANG_TILDE] = ACTIONS(1291),
    [anon_sym_LT_EQ] = ACTIONS(1293),
    [anon_sym_GT] = ACTIONS(1293),
    [anon_sym_GT_EQ] = ACTIONS(1291),
    [anon_sym_CARET] = ACTIONS(1291),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_SLASH] = ACTIONS(1291),
    [anon_sym_PERCENT] = ACTIONS(1291),
    [sym_comment] = ACTIONS(87),
  },
  [1301] = {
    [anon_sym_RPAREN] = ACTIONS(5583),
    [sym_comment] = ACTIONS(87),
  },
  [1302] = {
    [sym__simple_symbol] = ACTIONS(1411),
    [sym__string_start] = ACTIONS(1411),
    [sym__symbol_start] = ACTIONS(1411),
    [sym__subshell_start] = ACTIONS(1411),
    [sym__regex_start] = ACTIONS(1411),
    [sym__string_array_start] = ACTIONS(1411),
    [sym__symbol_array_start] = ACTIONS(1411),
    [sym__heredoc_body_start] = ACTIONS(1411),
    [sym_heredoc_beginning] = ACTIONS(1411),
    [sym__block_ampersand] = ACTIONS(1411),
    [sym__splat_star] = ACTIONS(1411),
    [sym__unary_minus] = ACTIONS(1411),
    [sym__binary_minus] = ACTIONS(1411),
    [sym__binary_star] = ACTIONS(1411),
    [sym__identifier_hash_key] = ACTIONS(1411),
    [anon_sym_LBRACE] = ACTIONS(1411),
    [anon_sym_RBRACE] = ACTIONS(1411),
    [anon_sym_def] = ACTIONS(1413),
    [anon_sym_LPAREN] = ACTIONS(1413),
    [anon_sym_RPAREN] = ACTIONS(1411),
    [anon_sym_DOT] = ACTIONS(1413),
    [anon_sym_COLON_COLON] = ACTIONS(1413),
    [anon_sym_COMMA] = ACTIONS(1411),
    [anon_sym_PIPE] = ACTIONS(1413),
    [anon_sym_SEMI] = ACTIONS(1411),
    [anon_sym_STAR] = ACTIONS(1413),
    [anon_sym_STAR_STAR] = ACTIONS(1413),
    [anon_sym_AMP] = ACTIONS(1413),
    [anon_sym_EQ] = ACTIONS(1413),
    [anon_sym_class] = ACTIONS(1413),
    [anon_sym_LT] = ACTIONS(1413),
    [anon_sym_module] = ACTIONS(1413),
    [anon_sym_return] = ACTIONS(1413),
    [anon_sym_yield] = ACTIONS(1413),
    [anon_sym_break] = ACTIONS(1413),
    [anon_sym_next] = ACTIONS(1413),
    [sym_redo] = ACTIONS(1413),
    [sym_retry] = ACTIONS(1413),
    [anon_sym_if] = ACTIONS(1413),
    [anon_sym_unless] = ACTIONS(1413),
    [anon_sym_while] = ACTIONS(1413),
    [anon_sym_until] = ACTIONS(1413),
    [anon_sym_rescue] = ACTIONS(1413),
    [anon_sym_for] = ACTIONS(1413),
    [anon_sym_in] = ACTIONS(1413),
    [anon_sym_do] = ACTIONS(1413),
    [anon_sym_case] = ACTIONS(1413),
    [anon_sym_begin] = ACTIONS(1413),
    [anon_sym_EQ_GT] = ACTIONS(1411),
    [anon_sym_LBRACK] = ACTIONS(1411),
    [anon_sym_RBRACK] = ACTIONS(1411),
    [anon_sym_COLON_COLON2] = ACTIONS(1411),
    [anon_sym_AMP_DOT] = ACTIONS(1411),
    [anon_sym_LPAREN2] = ACTIONS(1411),
    [anon_sym_PLUS_EQ] = ACTIONS(1411),
    [anon_sym_DASH_EQ] = ACTIONS(1411),
    [anon_sym_STAR_EQ] = ACTIONS(1411),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1411),
    [anon_sym_SLASH_EQ] = ACTIONS(1411),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1411),
    [anon_sym_PIPE_EQ] = ACTIONS(1411),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1411),
    [anon_sym_AMP_EQ] = ACTIONS(1411),
    [anon_sym_PERCENT_EQ] = ACTIONS(1411),
    [anon_sym_GT_GT_EQ] = ACTIONS(1411),
    [anon_sym_LT_LT_EQ] = ACTIONS(1411),
    [anon_sym_CARET_EQ] = ACTIONS(1411),
    [anon_sym_QMARK] = ACTIONS(1413),
    [anon_sym_COLON2] = ACTIONS(1413),
    [anon_sym_DOT_DOT] = ACTIONS(1413),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1411),
    [anon_sym_and] = ACTIONS(1413),
    [anon_sym_or] = ACTIONS(1413),
    [anon_sym_PIPE_PIPE] = ACTIONS(1413),
    [anon_sym_AMP_AMP] = ACTIONS(1413),
    [anon_sym_LT_LT] = ACTIONS(1413),
    [anon_sym_GT_GT] = ACTIONS(1413),
    [anon_sym_EQ_EQ] = ACTIONS(1413),
    [anon_sym_BANG_EQ] = ACTIONS(1411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1411),
    [anon_sym_LT_EQ_GT] = ACTIONS(1411),
    [anon_sym_EQ_TILDE] = ACTIONS(1411),
    [anon_sym_BANG_TILDE] = ACTIONS(1411),
    [anon_sym_LT_EQ] = ACTIONS(1413),
    [anon_sym_GT] = ACTIONS(1413),
    [anon_sym_GT_EQ] = ACTIONS(1411),
    [anon_sym_CARET] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_SLASH] = ACTIONS(1413),
    [anon_sym_PERCENT] = ACTIONS(1413),
    [anon_sym_defined_QMARK] = ACTIONS(1411),
    [anon_sym_not] = ACTIONS(1413),
    [anon_sym_BANG] = ACTIONS(1413),
    [anon_sym_TILDE] = ACTIONS(1411),
    [sym_constant] = ACTIONS(1413),
    [sym_identifier] = ACTIONS(1413),
    [sym_instance_variable] = ACTIONS(1411),
    [sym_class_variable] = ACTIONS(1411),
    [sym_global_variable] = ACTIONS(1411),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1413),
    [sym_float] = ACTIONS(1413),
    [sym_complex] = ACTIONS(1411),
    [sym_super] = ACTIONS(1413),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_TRUE] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_FALSE] = ACTIONS(1413),
    [sym_self] = ACTIONS(1413),
    [anon_sym_nil] = ACTIONS(1413),
    [anon_sym_NIL] = ACTIONS(1413),
    [sym_character] = ACTIONS(1411),
    [anon_sym_LBRACK2] = ACTIONS(1413),
    [anon_sym_DASH_GT] = ACTIONS(1411),
  },
  [1303] = {
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(5535),
    [sym__binary_star] = ACTIONS(5537),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5537),
    [anon_sym_AMP] = ACTIONS(5541),
    [anon_sym_LT] = ACTIONS(5543),
    [anon_sym_RBRACK] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(5545),
    [anon_sym_DOT_DOT] = ACTIONS(5547),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5549),
    [anon_sym_and] = ACTIONS(5551),
    [anon_sym_or] = ACTIONS(5551),
    [anon_sym_PIPE_PIPE] = ACTIONS(5553),
    [anon_sym_AMP_AMP] = ACTIONS(5553),
    [anon_sym_LT_LT] = ACTIONS(5555),
    [anon_sym_GT_GT] = ACTIONS(5555),
    [anon_sym_EQ_EQ] = ACTIONS(5557),
    [anon_sym_BANG_EQ] = ACTIONS(5553),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5553),
    [anon_sym_LT_EQ_GT] = ACTIONS(5553),
    [anon_sym_EQ_TILDE] = ACTIONS(5553),
    [anon_sym_BANG_TILDE] = ACTIONS(5553),
    [anon_sym_LT_EQ] = ACTIONS(5543),
    [anon_sym_GT] = ACTIONS(5543),
    [anon_sym_GT_EQ] = ACTIONS(5559),
    [anon_sym_CARET] = ACTIONS(5561),
    [anon_sym_PLUS] = ACTIONS(5535),
    [anon_sym_SLASH] = ACTIONS(5537),
    [anon_sym_PERCENT] = ACTIONS(5537),
    [sym_comment] = ACTIONS(87),
  },
  [1304] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(3350),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(3350),
    [sym_operator_assignment] = STATE(3350),
    [sym_conditional] = STATE(3350),
    [sym_range] = STATE(3350),
    [sym_binary] = STATE(3350),
    [sym_unary] = STATE(3350),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(485),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(495),
    [anon_sym_defined_QMARK] = ACTIONS(497),
    [anon_sym_not] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(501),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1305] = {
    [sym_superclass] = STATE(3351),
    [sym_heredoc_body] = STATE(3352),
    [sym__terminator] = STATE(3352),
    [sym__line_break] = ACTIONS(5585),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1089),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(5585),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1089),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1517),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1089),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [1306] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_superclass] = STATE(3351),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(859),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym_argument_list] = STATE(832),
    [sym__argument_list_with_parens] = STATE(860),
    [sym__argument] = STATE(861),
    [sym_splat_argument] = STATE(861),
    [sym_hash_splat_argument] = STATE(861),
    [sym_block_argument] = STATE(861),
    [sym_do_block] = STATE(835),
    [sym_block] = STATE(835),
    [sym_assignment] = STATE(859),
    [sym_operator_assignment] = STATE(859),
    [sym_conditional] = STATE(859),
    [sym_range] = STATE(859),
    [sym_binary] = STATE(859),
    [sym_unary] = STATE(859),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(864),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_heredoc_body] = STATE(3352),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(861),
    [sym_lambda] = STATE(347),
    [sym__terminator] = STATE(3352),
    [sym__line_break] = ACTIONS(5585),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1521),
    [sym__splat_star] = ACTIONS(1523),
    [sym__unary_minus] = ACTIONS(1525),
    [sym__identifier_hash_key] = ACTIONS(1527),
    [anon_sym_LBRACE] = ACTIONS(1529),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(743),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(5585),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1531),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(1517),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1473),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(1549),
    [sym_identifier] = ACTIONS(1549),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1307] = {
    [sym_heredoc_body] = STATE(3354),
    [sym__terminator] = STATE(3354),
    [sym__line_break] = ACTIONS(5587),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1089),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(5587),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1089),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(5589),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1089),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [1308] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(859),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym_argument_list] = STATE(832),
    [sym__argument_list_with_parens] = STATE(860),
    [sym__argument] = STATE(861),
    [sym_splat_argument] = STATE(861),
    [sym_hash_splat_argument] = STATE(861),
    [sym_block_argument] = STATE(861),
    [sym_do_block] = STATE(835),
    [sym_block] = STATE(835),
    [sym_assignment] = STATE(859),
    [sym_operator_assignment] = STATE(859),
    [sym_conditional] = STATE(859),
    [sym_range] = STATE(859),
    [sym_binary] = STATE(859),
    [sym_unary] = STATE(859),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(864),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_heredoc_body] = STATE(3354),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(861),
    [sym_lambda] = STATE(347),
    [sym__terminator] = STATE(3354),
    [sym__line_break] = ACTIONS(5587),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1521),
    [sym__splat_star] = ACTIONS(1523),
    [sym__unary_minus] = ACTIONS(1525),
    [sym__identifier_hash_key] = ACTIONS(1527),
    [anon_sym_LBRACE] = ACTIONS(1529),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(743),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(5587),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1531),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_end] = ACTIONS(5589),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1473),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(1549),
    [sym_identifier] = ACTIONS(1549),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1309] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(3355),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1322),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(1322),
    [sym_assignment] = STATE(3355),
    [sym_operator_assignment] = STATE(3355),
    [sym_conditional] = STATE(3355),
    [sym_range] = STATE(3355),
    [sym_binary] = STATE(3355),
    [sym_unary] = STATE(3355),
    [sym_left_assignment_list] = STATE(1321),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1322),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1322),
    [sym_false] = STATE(1322),
    [sym_nil] = STATE(1322),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1291),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2325),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5591),
    [anon_sym_defined_QMARK] = ACTIONS(2329),
    [anon_sym_not] = ACTIONS(2331),
    [anon_sym_BANG] = ACTIONS(2335),
    [anon_sym_TILDE] = ACTIONS(2335),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1310] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(3356),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1322),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(1322),
    [sym_assignment] = STATE(3356),
    [sym_operator_assignment] = STATE(3356),
    [sym_conditional] = STATE(3356),
    [sym_range] = STATE(3356),
    [sym_binary] = STATE(3356),
    [sym_unary] = STATE(3356),
    [sym_left_assignment_list] = STATE(1321),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1322),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1322),
    [sym_false] = STATE(1322),
    [sym_nil] = STATE(1322),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1291),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2325),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5591),
    [anon_sym_defined_QMARK] = ACTIONS(2329),
    [anon_sym_not] = ACTIONS(2331),
    [anon_sym_BANG] = ACTIONS(2335),
    [anon_sym_TILDE] = ACTIONS(2335),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1311] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(3357),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1322),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(1322),
    [sym_assignment] = STATE(3357),
    [sym_operator_assignment] = STATE(3357),
    [sym_conditional] = STATE(3357),
    [sym_range] = STATE(3357),
    [sym_binary] = STATE(3357),
    [sym_unary] = STATE(3357),
    [sym_left_assignment_list] = STATE(1321),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1322),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1322),
    [sym_false] = STATE(1322),
    [sym_nil] = STATE(1322),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1291),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2325),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5591),
    [anon_sym_defined_QMARK] = ACTIONS(2329),
    [anon_sym_not] = ACTIONS(2331),
    [anon_sym_BANG] = ACTIONS(2335),
    [anon_sym_TILDE] = ACTIONS(2335),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1312] = {
    [anon_sym_COLON] = ACTIONS(5593),
    [sym_comment] = ACTIONS(87),
  },
  [1313] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(3359),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1322),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(1322),
    [sym_assignment] = STATE(3359),
    [sym_operator_assignment] = STATE(3359),
    [sym_conditional] = STATE(3359),
    [sym_range] = STATE(3359),
    [sym_binary] = STATE(3359),
    [sym_unary] = STATE(3359),
    [sym_left_assignment_list] = STATE(1321),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1322),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1322),
    [sym_false] = STATE(1322),
    [sym_nil] = STATE(1322),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1291),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2325),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5591),
    [anon_sym_defined_QMARK] = ACTIONS(2329),
    [anon_sym_not] = ACTIONS(2331),
    [anon_sym_BANG] = ACTIONS(2335),
    [anon_sym_TILDE] = ACTIONS(2335),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1314] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(3360),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1322),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(1322),
    [sym_assignment] = STATE(3360),
    [sym_operator_assignment] = STATE(3360),
    [sym_conditional] = STATE(3360),
    [sym_range] = STATE(3360),
    [sym_binary] = STATE(3360),
    [sym_unary] = STATE(3360),
    [sym_left_assignment_list] = STATE(1321),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1322),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1322),
    [sym_false] = STATE(1322),
    [sym_nil] = STATE(1322),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1291),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2325),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5591),
    [anon_sym_defined_QMARK] = ACTIONS(2329),
    [anon_sym_not] = ACTIONS(2331),
    [anon_sym_BANG] = ACTIONS(2335),
    [anon_sym_TILDE] = ACTIONS(2335),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1315] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(1872),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1322),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(1322),
    [sym_assignment] = STATE(1872),
    [sym_operator_assignment] = STATE(1872),
    [sym_conditional] = STATE(1872),
    [sym_range] = STATE(1872),
    [sym_binary] = STATE(1872),
    [sym_unary] = STATE(1872),
    [sym_left_assignment_list] = STATE(1321),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1322),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1322),
    [sym_false] = STATE(1322),
    [sym_nil] = STATE(1322),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1291),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2325),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5591),
    [anon_sym_defined_QMARK] = ACTIONS(2329),
    [anon_sym_not] = ACTIONS(2331),
    [anon_sym_BANG] = ACTIONS(2335),
    [anon_sym_TILDE] = ACTIONS(2335),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1316] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(5595),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_RBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [1317] = {
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(5597),
    [sym__binary_star] = ACTIONS(5599),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(5601),
    [anon_sym_STAR_STAR] = ACTIONS(5599),
    [anon_sym_AMP] = ACTIONS(5603),
    [anon_sym_LT] = ACTIONS(5605),
    [anon_sym_EQ_GT] = ACTIONS(1625),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_RBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(5607),
    [anon_sym_DOT_DOT] = ACTIONS(5609),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5611),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(5613),
    [anon_sym_AMP_AMP] = ACTIONS(5613),
    [anon_sym_LT_LT] = ACTIONS(5615),
    [anon_sym_GT_GT] = ACTIONS(5615),
    [anon_sym_EQ_EQ] = ACTIONS(5617),
    [anon_sym_BANG_EQ] = ACTIONS(5613),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5613),
    [anon_sym_LT_EQ_GT] = ACTIONS(5613),
    [anon_sym_EQ_TILDE] = ACTIONS(5613),
    [anon_sym_BANG_TILDE] = ACTIONS(5613),
    [anon_sym_LT_EQ] = ACTIONS(5605),
    [anon_sym_GT] = ACTIONS(5605),
    [anon_sym_GT_EQ] = ACTIONS(5619),
    [anon_sym_CARET] = ACTIONS(5621),
    [anon_sym_PLUS] = ACTIONS(5597),
    [anon_sym_SLASH] = ACTIONS(5599),
    [anon_sym_PERCENT] = ACTIONS(5599),
    [sym_comment] = ACTIONS(87),
  },
  [1318] = {
    [sym__heredoc_body_start] = ACTIONS(1677),
    [sym__binary_minus] = ACTIONS(1677),
    [sym__binary_star] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1677),
    [anon_sym_RBRACE] = ACTIONS(1677),
    [anon_sym_RPAREN] = ACTIONS(1677),
    [anon_sym_DOT] = ACTIONS(1679),
    [anon_sym_COMMA] = ACTIONS(1677),
    [anon_sym_PIPE] = ACTIONS(1679),
    [anon_sym_SEMI] = ACTIONS(1677),
    [anon_sym_STAR_STAR] = ACTIONS(1677),
    [anon_sym_AMP] = ACTIONS(1679),
    [anon_sym_EQ] = ACTIONS(1679),
    [anon_sym_LT] = ACTIONS(1679),
    [anon_sym_if] = ACTIONS(1677),
    [anon_sym_unless] = ACTIONS(1677),
    [anon_sym_while] = ACTIONS(1677),
    [anon_sym_until] = ACTIONS(1677),
    [anon_sym_rescue] = ACTIONS(1677),
    [anon_sym_in] = ACTIONS(1677),
    [anon_sym_do] = ACTIONS(1677),
    [anon_sym_EQ_GT] = ACTIONS(1677),
    [anon_sym_LBRACK] = ACTIONS(1677),
    [anon_sym_RBRACK] = ACTIONS(1677),
    [anon_sym_COLON_COLON2] = ACTIONS(1677),
    [anon_sym_AMP_DOT] = ACTIONS(1677),
    [anon_sym_QMARK] = ACTIONS(1677),
    [anon_sym_COLON2] = ACTIONS(1679),
    [anon_sym_DOT_DOT] = ACTIONS(1679),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1677),
    [anon_sym_and] = ACTIONS(1677),
    [anon_sym_or] = ACTIONS(1677),
    [anon_sym_PIPE_PIPE] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_LT_LT] = ACTIONS(1677),
    [anon_sym_GT_GT] = ACTIONS(1677),
    [anon_sym_EQ_EQ] = ACTIONS(1679),
    [anon_sym_BANG_EQ] = ACTIONS(1677),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1677),
    [anon_sym_LT_EQ_GT] = ACTIONS(1677),
    [anon_sym_EQ_TILDE] = ACTIONS(1677),
    [anon_sym_BANG_TILDE] = ACTIONS(1677),
    [anon_sym_LT_EQ] = ACTIONS(1679),
    [anon_sym_GT] = ACTIONS(1679),
    [anon_sym_GT_EQ] = ACTIONS(1677),
    [anon_sym_CARET] = ACTIONS(1677),
    [anon_sym_PLUS] = ACTIONS(1677),
    [anon_sym_SLASH] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [sym_comment] = ACTIONS(87),
  },
  [1319] = {
    [sym_heredoc_body] = STATE(3372),
    [aux_sym_call_repeat1] = STATE(3372),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_RBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [1320] = {
    [sym_heredoc_body] = STATE(3372),
    [aux_sym_call_repeat1] = STATE(3372),
    [aux_sym_argument_list_repeat1] = STATE(3374),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(5623),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_RBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [1321] = {
    [anon_sym_EQ] = ACTIONS(5625),
    [sym_comment] = ACTIONS(87),
  },
  [1322] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(5627),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(5629),
    [anon_sym_DASH_EQ] = ACTIONS(5629),
    [anon_sym_STAR_EQ] = ACTIONS(5629),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5629),
    [anon_sym_SLASH_EQ] = ACTIONS(5629),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5629),
    [anon_sym_PIPE_EQ] = ACTIONS(5629),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5629),
    [anon_sym_AMP_EQ] = ACTIONS(5629),
    [anon_sym_PERCENT_EQ] = ACTIONS(5629),
    [anon_sym_GT_GT_EQ] = ACTIONS(5629),
    [anon_sym_LT_LT_EQ] = ACTIONS(5629),
    [anon_sym_CARET_EQ] = ACTIONS(5629),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1323] = {
    [sym_string] = STATE(1392),
    [aux_sym_chained_string_repeat1] = STATE(1392),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(5631),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [1324] = {
    [sym__heredoc_body_start] = ACTIONS(1697),
    [sym__binary_minus] = ACTIONS(1697),
    [sym__binary_star] = ACTIONS(1697),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_RBRACE] = ACTIONS(1697),
    [anon_sym_RPAREN] = ACTIONS(1697),
    [anon_sym_DOT] = ACTIONS(1699),
    [anon_sym_COMMA] = ACTIONS(1697),
    [anon_sym_PIPE] = ACTIONS(1699),
    [anon_sym_SEMI] = ACTIONS(1697),
    [anon_sym_STAR_STAR] = ACTIONS(1697),
    [anon_sym_AMP] = ACTIONS(1699),
    [anon_sym_EQ] = ACTIONS(1699),
    [anon_sym_LT] = ACTIONS(1699),
    [anon_sym_if] = ACTIONS(1697),
    [anon_sym_unless] = ACTIONS(1697),
    [anon_sym_while] = ACTIONS(1697),
    [anon_sym_until] = ACTIONS(1697),
    [anon_sym_rescue] = ACTIONS(1697),
    [anon_sym_in] = ACTIONS(1697),
    [anon_sym_do] = ACTIONS(1697),
    [anon_sym_EQ_GT] = ACTIONS(1697),
    [anon_sym_LBRACK] = ACTIONS(1697),
    [anon_sym_RBRACK] = ACTIONS(1697),
    [anon_sym_COLON_COLON2] = ACTIONS(1697),
    [anon_sym_AMP_DOT] = ACTIONS(1697),
    [anon_sym_QMARK] = ACTIONS(1697),
    [anon_sym_COLON2] = ACTIONS(1699),
    [anon_sym_DOT_DOT] = ACTIONS(1699),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1697),
    [anon_sym_and] = ACTIONS(1697),
    [anon_sym_or] = ACTIONS(1697),
    [anon_sym_PIPE_PIPE] = ACTIONS(1697),
    [anon_sym_AMP_AMP] = ACTIONS(1697),
    [anon_sym_LT_LT] = ACTIONS(1697),
    [anon_sym_GT_GT] = ACTIONS(1697),
    [anon_sym_EQ_EQ] = ACTIONS(1699),
    [anon_sym_BANG_EQ] = ACTIONS(1697),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1697),
    [anon_sym_LT_EQ_GT] = ACTIONS(1697),
    [anon_sym_EQ_TILDE] = ACTIONS(1697),
    [anon_sym_BANG_TILDE] = ACTIONS(1697),
    [anon_sym_LT_EQ] = ACTIONS(1699),
    [anon_sym_GT] = ACTIONS(1699),
    [anon_sym_GT_EQ] = ACTIONS(1697),
    [anon_sym_CARET] = ACTIONS(1697),
    [anon_sym_PLUS] = ACTIONS(1697),
    [anon_sym_SLASH] = ACTIONS(1697),
    [anon_sym_PERCENT] = ACTIONS(1697),
    [sym_comment] = ACTIONS(87),
  },
  [1325] = {
    [sym__heredoc_body_start] = ACTIONS(1701),
    [sym__binary_minus] = ACTIONS(1701),
    [sym__binary_star] = ACTIONS(1701),
    [anon_sym_LBRACE] = ACTIONS(1701),
    [anon_sym_RBRACE] = ACTIONS(1701),
    [anon_sym_RPAREN] = ACTIONS(1701),
    [anon_sym_DOT] = ACTIONS(1703),
    [anon_sym_COMMA] = ACTIONS(1701),
    [anon_sym_PIPE] = ACTIONS(1703),
    [anon_sym_SEMI] = ACTIONS(1701),
    [anon_sym_STAR_STAR] = ACTIONS(1701),
    [anon_sym_AMP] = ACTIONS(1703),
    [anon_sym_EQ] = ACTIONS(1703),
    [anon_sym_LT] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1701),
    [anon_sym_unless] = ACTIONS(1701),
    [anon_sym_while] = ACTIONS(1701),
    [anon_sym_until] = ACTIONS(1701),
    [anon_sym_rescue] = ACTIONS(1701),
    [anon_sym_in] = ACTIONS(1701),
    [anon_sym_do] = ACTIONS(1701),
    [anon_sym_EQ_GT] = ACTIONS(1701),
    [anon_sym_LBRACK] = ACTIONS(1701),
    [anon_sym_RBRACK] = ACTIONS(1701),
    [anon_sym_COLON_COLON2] = ACTIONS(1701),
    [anon_sym_AMP_DOT] = ACTIONS(1701),
    [anon_sym_QMARK] = ACTIONS(1701),
    [anon_sym_COLON2] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1703),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1701),
    [anon_sym_and] = ACTIONS(1701),
    [anon_sym_or] = ACTIONS(1701),
    [anon_sym_PIPE_PIPE] = ACTIONS(1701),
    [anon_sym_AMP_AMP] = ACTIONS(1701),
    [anon_sym_LT_LT] = ACTIONS(1701),
    [anon_sym_GT_GT] = ACTIONS(1701),
    [anon_sym_EQ_EQ] = ACTIONS(1703),
    [anon_sym_BANG_EQ] = ACTIONS(1701),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1701),
    [anon_sym_LT_EQ_GT] = ACTIONS(1701),
    [anon_sym_EQ_TILDE] = ACTIONS(1701),
    [anon_sym_BANG_TILDE] = ACTIONS(1701),
    [anon_sym_LT_EQ] = ACTIONS(1703),
    [anon_sym_GT] = ACTIONS(1703),
    [anon_sym_GT_EQ] = ACTIONS(1701),
    [anon_sym_CARET] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(1701),
    [anon_sym_SLASH] = ACTIONS(1701),
    [anon_sym_PERCENT] = ACTIONS(1701),
    [sym_comment] = ACTIONS(87),
  },
  [1326] = {
    [sym__heredoc_body_start] = ACTIONS(1705),
    [sym__binary_minus] = ACTIONS(1705),
    [sym__binary_star] = ACTIONS(1705),
    [anon_sym_LBRACE] = ACTIONS(1705),
    [anon_sym_RBRACE] = ACTIONS(1705),
    [anon_sym_RPAREN] = ACTIONS(1705),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1705),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1705),
    [anon_sym_STAR_STAR] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1705),
    [anon_sym_unless] = ACTIONS(1705),
    [anon_sym_while] = ACTIONS(1705),
    [anon_sym_until] = ACTIONS(1705),
    [anon_sym_rescue] = ACTIONS(1705),
    [anon_sym_in] = ACTIONS(1705),
    [anon_sym_do] = ACTIONS(1705),
    [anon_sym_EQ_GT] = ACTIONS(1705),
    [anon_sym_LBRACK] = ACTIONS(1705),
    [anon_sym_RBRACK] = ACTIONS(1705),
    [anon_sym_COLON_COLON2] = ACTIONS(1705),
    [anon_sym_AMP_DOT] = ACTIONS(1705),
    [anon_sym_QMARK] = ACTIONS(1705),
    [anon_sym_COLON2] = ACTIONS(1707),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1705),
    [anon_sym_and] = ACTIONS(1705),
    [anon_sym_or] = ACTIONS(1705),
    [anon_sym_PIPE_PIPE] = ACTIONS(1705),
    [anon_sym_AMP_AMP] = ACTIONS(1705),
    [anon_sym_LT_LT] = ACTIONS(1705),
    [anon_sym_GT_GT] = ACTIONS(1705),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1705),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1705),
    [anon_sym_LT_EQ_GT] = ACTIONS(1705),
    [anon_sym_EQ_TILDE] = ACTIONS(1705),
    [anon_sym_BANG_TILDE] = ACTIONS(1705),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1705),
    [anon_sym_CARET] = ACTIONS(1705),
    [anon_sym_PLUS] = ACTIONS(1705),
    [anon_sym_SLASH] = ACTIONS(1705),
    [anon_sym_PERCENT] = ACTIONS(1705),
    [sym_comment] = ACTIONS(87),
  },
  [1327] = {
    [sym_then] = STATE(3377),
    [sym_heredoc_body] = STATE(3378),
    [sym__terminator] = STATE(3378),
    [sym__line_break] = ACTIONS(5633),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(5633),
    [anon_sym_if] = ACTIONS(1743),
    [anon_sym_unless] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1747),
    [anon_sym_until] = ACTIONS(1749),
    [anon_sym_rescue] = ACTIONS(1751),
    [anon_sym_then] = ACTIONS(1753),
    [sym_comment] = ACTIONS(87),
  },
  [1328] = {
    [sym_then] = STATE(3379),
    [sym_heredoc_body] = STATE(3380),
    [sym__terminator] = STATE(3380),
    [sym__line_break] = ACTIONS(5635),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(5635),
    [anon_sym_if] = ACTIONS(1743),
    [anon_sym_unless] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1747),
    [anon_sym_until] = ACTIONS(1749),
    [anon_sym_rescue] = ACTIONS(1751),
    [anon_sym_then] = ACTIONS(1821),
    [sym_comment] = ACTIONS(87),
  },
  [1329] = {
    [sym__do] = STATE(3381),
    [sym_heredoc_body] = STATE(3381),
    [sym__terminator] = STATE(3381),
    [sym__line_break] = ACTIONS(5637),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym__binary_minus] = ACTIONS(1855),
    [sym__binary_star] = ACTIONS(1857),
    [anon_sym_PIPE] = ACTIONS(1859),
    [anon_sym_SEMI] = ACTIONS(5637),
    [anon_sym_STAR_STAR] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_LT] = ACTIONS(1863),
    [anon_sym_do] = ACTIONS(5637),
    [anon_sym_QMARK] = ACTIONS(1865),
    [anon_sym_DOT_DOT] = ACTIONS(1867),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1869),
    [anon_sym_and] = ACTIONS(1871),
    [anon_sym_or] = ACTIONS(1871),
    [anon_sym_PIPE_PIPE] = ACTIONS(1873),
    [anon_sym_AMP_AMP] = ACTIONS(1873),
    [anon_sym_LT_LT] = ACTIONS(1875),
    [anon_sym_GT_GT] = ACTIONS(1875),
    [anon_sym_EQ_EQ] = ACTIONS(1877),
    [anon_sym_BANG_EQ] = ACTIONS(1873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1873),
    [anon_sym_LT_EQ_GT] = ACTIONS(1873),
    [anon_sym_EQ_TILDE] = ACTIONS(1873),
    [anon_sym_BANG_TILDE] = ACTIONS(1873),
    [anon_sym_LT_EQ] = ACTIONS(1863),
    [anon_sym_GT] = ACTIONS(1863),
    [anon_sym_GT_EQ] = ACTIONS(1879),
    [anon_sym_CARET] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_SLASH] = ACTIONS(1857),
    [anon_sym_PERCENT] = ACTIONS(1857),
    [sym_comment] = ACTIONS(87),
  },
  [1330] = {
    [sym__do] = STATE(3382),
    [sym_heredoc_body] = STATE(3382),
    [sym__terminator] = STATE(3382),
    [sym__line_break] = ACTIONS(5639),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym__binary_minus] = ACTIONS(1855),
    [sym__binary_star] = ACTIONS(1857),
    [anon_sym_PIPE] = ACTIONS(1859),
    [anon_sym_SEMI] = ACTIONS(5639),
    [anon_sym_STAR_STAR] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_LT] = ACTIONS(1863),
    [anon_sym_do] = ACTIONS(5639),
    [anon_sym_QMARK] = ACTIONS(1865),
    [anon_sym_DOT_DOT] = ACTIONS(1867),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1869),
    [anon_sym_and] = ACTIONS(1871),
    [anon_sym_or] = ACTIONS(1871),
    [anon_sym_PIPE_PIPE] = ACTIONS(1873),
    [anon_sym_AMP_AMP] = ACTIONS(1873),
    [anon_sym_LT_LT] = ACTIONS(1875),
    [anon_sym_GT_GT] = ACTIONS(1875),
    [anon_sym_EQ_EQ] = ACTIONS(1877),
    [anon_sym_BANG_EQ] = ACTIONS(1873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1873),
    [anon_sym_LT_EQ_GT] = ACTIONS(1873),
    [anon_sym_EQ_TILDE] = ACTIONS(1873),
    [anon_sym_BANG_TILDE] = ACTIONS(1873),
    [anon_sym_LT_EQ] = ACTIONS(1863),
    [anon_sym_GT] = ACTIONS(1863),
    [anon_sym_GT_EQ] = ACTIONS(1879),
    [anon_sym_CARET] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_SLASH] = ACTIONS(1857),
    [anon_sym_PERCENT] = ACTIONS(1857),
    [sym_comment] = ACTIONS(87),
  },
  [1331] = {
    [sym_in] = STATE(3383),
    [anon_sym_in] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
  },
  [1332] = {
    [sym_heredoc_body] = STATE(3384),
    [sym__terminator] = STATE(3384),
    [sym__line_break] = ACTIONS(5641),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym__binary_minus] = ACTIONS(2001),
    [sym__binary_star] = ACTIONS(2003),
    [anon_sym_PIPE] = ACTIONS(2005),
    [anon_sym_SEMI] = ACTIONS(5641),
    [anon_sym_STAR_STAR] = ACTIONS(2003),
    [anon_sym_AMP] = ACTIONS(2007),
    [anon_sym_LT] = ACTIONS(2009),
    [anon_sym_QMARK] = ACTIONS(2011),
    [anon_sym_DOT_DOT] = ACTIONS(2013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2015),
    [anon_sym_and] = ACTIONS(2017),
    [anon_sym_or] = ACTIONS(2017),
    [anon_sym_PIPE_PIPE] = ACTIONS(2019),
    [anon_sym_AMP_AMP] = ACTIONS(2019),
    [anon_sym_LT_LT] = ACTIONS(2021),
    [anon_sym_GT_GT] = ACTIONS(2021),
    [anon_sym_EQ_EQ] = ACTIONS(2023),
    [anon_sym_BANG_EQ] = ACTIONS(2019),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2019),
    [anon_sym_LT_EQ_GT] = ACTIONS(2019),
    [anon_sym_EQ_TILDE] = ACTIONS(2019),
    [anon_sym_BANG_TILDE] = ACTIONS(2019),
    [anon_sym_LT_EQ] = ACTIONS(2009),
    [anon_sym_GT] = ACTIONS(2009),
    [anon_sym_GT_EQ] = ACTIONS(2025),
    [anon_sym_CARET] = ACTIONS(2027),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_SLASH] = ACTIONS(2003),
    [anon_sym_PERCENT] = ACTIONS(2003),
    [sym_comment] = ACTIONS(87),
  },
  [1333] = {
    [sym_when] = STATE(3388),
    [sym_else] = STATE(3386),
    [aux_sym_case_repeat1] = STATE(3387),
    [aux_sym_case_repeat2] = STATE(3388),
    [anon_sym_SEMI] = ACTIONS(5643),
    [anon_sym_end] = ACTIONS(5645),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [1334] = {
    [sym_else] = STATE(3390),
    [sym_ensure] = STATE(3391),
    [sym_rescue] = STATE(3392),
    [anon_sym_end] = ACTIONS(5647),
    [anon_sym_rescue] = ACTIONS(2165),
    [anon_sym_else] = ACTIONS(2167),
    [anon_sym_ensure] = ACTIONS(2169),
    [sym_comment] = ACTIONS(87),
  },
  [1335] = {
    [sym_ensure] = STATE(3391),
    [anon_sym_end] = ACTIONS(5647),
    [anon_sym_ensure] = ACTIONS(2169),
    [sym_comment] = ACTIONS(87),
  },
  [1336] = {
    [anon_sym_end] = ACTIONS(5647),
    [sym_comment] = ACTIONS(87),
  },
  [1337] = {
    [sym_else] = STATE(3390),
    [sym_ensure] = STATE(3391),
    [anon_sym_end] = ACTIONS(5647),
    [anon_sym_else] = ACTIONS(2167),
    [anon_sym_ensure] = ACTIONS(2169),
    [sym_comment] = ACTIONS(87),
  },
  [1338] = {
    [sym__heredoc_body_start] = ACTIONS(2181),
    [sym__binary_minus] = ACTIONS(2181),
    [sym__binary_star] = ACTIONS(2181),
    [anon_sym_LBRACE] = ACTIONS(2181),
    [anon_sym_RBRACE] = ACTIONS(2181),
    [anon_sym_RPAREN] = ACTIONS(2181),
    [anon_sym_DOT] = ACTIONS(2183),
    [anon_sym_COMMA] = ACTIONS(2181),
    [anon_sym_PIPE] = ACTIONS(2183),
    [anon_sym_SEMI] = ACTIONS(2181),
    [anon_sym_STAR_STAR] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2183),
    [anon_sym_EQ] = ACTIONS(2183),
    [anon_sym_LT] = ACTIONS(2183),
    [anon_sym_if] = ACTIONS(2181),
    [anon_sym_unless] = ACTIONS(2181),
    [anon_sym_while] = ACTIONS(2181),
    [anon_sym_until] = ACTIONS(2181),
    [anon_sym_rescue] = ACTIONS(2181),
    [anon_sym_in] = ACTIONS(2181),
    [anon_sym_do] = ACTIONS(2181),
    [anon_sym_EQ_GT] = ACTIONS(2181),
    [anon_sym_LBRACK] = ACTIONS(2181),
    [anon_sym_RBRACK] = ACTIONS(2181),
    [anon_sym_COLON_COLON2] = ACTIONS(2181),
    [anon_sym_AMP_DOT] = ACTIONS(2181),
    [anon_sym_QMARK] = ACTIONS(2181),
    [anon_sym_COLON2] = ACTIONS(2183),
    [anon_sym_DOT_DOT] = ACTIONS(2183),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2181),
    [anon_sym_AMP_AMP] = ACTIONS(2181),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym_EQ_EQ] = ACTIONS(2183),
    [anon_sym_BANG_EQ] = ACTIONS(2181),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2181),
    [anon_sym_LT_EQ_GT] = ACTIONS(2181),
    [anon_sym_EQ_TILDE] = ACTIONS(2181),
    [anon_sym_BANG_TILDE] = ACTIONS(2181),
    [anon_sym_LT_EQ] = ACTIONS(2183),
    [anon_sym_GT] = ACTIONS(2183),
    [anon_sym_GT_EQ] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [sym_comment] = ACTIONS(87),
  },
  [1339] = {
    [sym__statements] = STATE(1334),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(1335),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(1336),
    [sym_rescue] = STATE(1337),
    [sym__body_statement] = STATE(3393),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(5649),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1340] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(2359),
    [sym__binary_star] = ACTIONS(2361),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(2363),
    [anon_sym_STAR_STAR] = ACTIONS(2361),
    [anon_sym_AMP] = ACTIONS(2365),
    [anon_sym_LT] = ACTIONS(2367),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_RBRACK] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(2369),
    [anon_sym_DOT_DOT] = ACTIONS(2371),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2373),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(2377),
    [anon_sym_AMP_AMP] = ACTIONS(2377),
    [anon_sym_LT_LT] = ACTIONS(2379),
    [anon_sym_GT_GT] = ACTIONS(2379),
    [anon_sym_EQ_EQ] = ACTIONS(2381),
    [anon_sym_BANG_EQ] = ACTIONS(2377),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2377),
    [anon_sym_LT_EQ_GT] = ACTIONS(2377),
    [anon_sym_EQ_TILDE] = ACTIONS(2377),
    [anon_sym_BANG_TILDE] = ACTIONS(2377),
    [anon_sym_LT_EQ] = ACTIONS(2367),
    [anon_sym_GT] = ACTIONS(2367),
    [anon_sym_GT_EQ] = ACTIONS(2383),
    [anon_sym_CARET] = ACTIONS(2385),
    [anon_sym_PLUS] = ACTIONS(2359),
    [anon_sym_SLASH] = ACTIONS(2361),
    [anon_sym_PERCENT] = ACTIONS(2361),
    [sym_comment] = ACTIONS(87),
  },
  [1341] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(935),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_RBRACK] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [1342] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(3394),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(1287),
    [sym_scope_resolution] = STATE(1285),
    [sym_call] = STATE(1285),
    [sym_method_call] = STATE(1287),
    [sym_assignment] = STATE(3394),
    [sym_operator_assignment] = STATE(3394),
    [sym_conditional] = STATE(3394),
    [sym_range] = STATE(3394),
    [sym_binary] = STATE(3394),
    [sym_unary] = STATE(3394),
    [sym_left_assignment_list] = STATE(1286),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1287),
    [sym__variable] = STATE(1285),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(1287),
    [sym_false] = STATE(1287),
    [sym_nil] = STATE(1287),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(1288),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(2281),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2283),
    [anon_sym_yield] = ACTIONS(2285),
    [anon_sym_break] = ACTIONS(2287),
    [anon_sym_next] = ACTIONS(2289),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2291),
    [anon_sym_defined_QMARK] = ACTIONS(2293),
    [anon_sym_not] = ACTIONS(2295),
    [anon_sym_BANG] = ACTIONS(2297),
    [anon_sym_TILDE] = ACTIONS(2297),
    [sym_constant] = ACTIONS(2299),
    [sym_identifier] = ACTIONS(2299),
    [sym_instance_variable] = ACTIONS(2301),
    [sym_class_variable] = ACTIONS(2301),
    [sym_global_variable] = ACTIONS(2301),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2299),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2299),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1343] = {
    [sym__heredoc_body_start] = ACTIONS(2261),
    [sym__binary_minus] = ACTIONS(2261),
    [sym__binary_star] = ACTIONS(2261),
    [anon_sym_LBRACE] = ACTIONS(2261),
    [anon_sym_RBRACE] = ACTIONS(2261),
    [anon_sym_RPAREN] = ACTIONS(2261),
    [anon_sym_DOT] = ACTIONS(2263),
    [anon_sym_COMMA] = ACTIONS(2261),
    [anon_sym_PIPE] = ACTIONS(2263),
    [anon_sym_SEMI] = ACTIONS(2261),
    [anon_sym_STAR_STAR] = ACTIONS(2261),
    [anon_sym_AMP] = ACTIONS(2263),
    [anon_sym_EQ] = ACTIONS(2263),
    [anon_sym_LT] = ACTIONS(2263),
    [anon_sym_if] = ACTIONS(2261),
    [anon_sym_unless] = ACTIONS(2261),
    [anon_sym_while] = ACTIONS(2261),
    [anon_sym_until] = ACTIONS(2261),
    [anon_sym_rescue] = ACTIONS(2261),
    [anon_sym_in] = ACTIONS(2261),
    [anon_sym_do] = ACTIONS(2261),
    [anon_sym_EQ_GT] = ACTIONS(2261),
    [anon_sym_LBRACK] = ACTIONS(2261),
    [anon_sym_RBRACK] = ACTIONS(2261),
    [anon_sym_COLON_COLON2] = ACTIONS(2261),
    [anon_sym_AMP_DOT] = ACTIONS(2261),
    [anon_sym_QMARK] = ACTIONS(2261),
    [anon_sym_COLON2] = ACTIONS(2263),
    [anon_sym_DOT_DOT] = ACTIONS(2263),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2261),
    [anon_sym_and] = ACTIONS(2261),
    [anon_sym_or] = ACTIONS(2261),
    [anon_sym_PIPE_PIPE] = ACTIONS(2261),
    [anon_sym_AMP_AMP] = ACTIONS(2261),
    [anon_sym_LT_LT] = ACTIONS(2261),
    [anon_sym_GT_GT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(2263),
    [anon_sym_BANG_EQ] = ACTIONS(2261),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2261),
    [anon_sym_LT_EQ_GT] = ACTIONS(2261),
    [anon_sym_EQ_TILDE] = ACTIONS(2261),
    [anon_sym_BANG_TILDE] = ACTIONS(2261),
    [anon_sym_LT_EQ] = ACTIONS(2263),
    [anon_sym_GT] = ACTIONS(2263),
    [anon_sym_GT_EQ] = ACTIONS(2261),
    [anon_sym_CARET] = ACTIONS(2261),
    [anon_sym_PLUS] = ACTIONS(2261),
    [anon_sym_SLASH] = ACTIONS(2261),
    [anon_sym_PERCENT] = ACTIONS(2261),
    [sym_comment] = ACTIONS(87),
  },
  [1344] = {
    [sym__heredoc_body_start] = ACTIONS(2345),
    [sym__binary_minus] = ACTIONS(2345),
    [sym__binary_star] = ACTIONS(2345),
    [anon_sym_LBRACE] = ACTIONS(2345),
    [anon_sym_RBRACE] = ACTIONS(2345),
    [anon_sym_RPAREN] = ACTIONS(2345),
    [anon_sym_DOT] = ACTIONS(2347),
    [anon_sym_COMMA] = ACTIONS(2345),
    [anon_sym_PIPE] = ACTIONS(2347),
    [anon_sym_SEMI] = ACTIONS(2345),
    [anon_sym_STAR_STAR] = ACTIONS(2345),
    [anon_sym_AMP] = ACTIONS(2347),
    [anon_sym_EQ] = ACTIONS(2347),
    [anon_sym_LT] = ACTIONS(2347),
    [anon_sym_if] = ACTIONS(2345),
    [anon_sym_unless] = ACTIONS(2345),
    [anon_sym_while] = ACTIONS(2345),
    [anon_sym_until] = ACTIONS(2345),
    [anon_sym_rescue] = ACTIONS(2345),
    [anon_sym_in] = ACTIONS(2345),
    [anon_sym_do] = ACTIONS(2345),
    [anon_sym_EQ_GT] = ACTIONS(2345),
    [anon_sym_LBRACK] = ACTIONS(2345),
    [anon_sym_RBRACK] = ACTIONS(2345),
    [anon_sym_COLON_COLON2] = ACTIONS(2345),
    [anon_sym_AMP_DOT] = ACTIONS(2345),
    [anon_sym_QMARK] = ACTIONS(2345),
    [anon_sym_COLON2] = ACTIONS(2347),
    [anon_sym_DOT_DOT] = ACTIONS(2347),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2345),
    [anon_sym_and] = ACTIONS(2345),
    [anon_sym_or] = ACTIONS(2345),
    [anon_sym_PIPE_PIPE] = ACTIONS(2345),
    [anon_sym_AMP_AMP] = ACTIONS(2345),
    [anon_sym_LT_LT] = ACTIONS(2345),
    [anon_sym_GT_GT] = ACTIONS(2345),
    [anon_sym_EQ_EQ] = ACTIONS(2347),
    [anon_sym_BANG_EQ] = ACTIONS(2345),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2345),
    [anon_sym_LT_EQ_GT] = ACTIONS(2345),
    [anon_sym_EQ_TILDE] = ACTIONS(2345),
    [anon_sym_BANG_TILDE] = ACTIONS(2345),
    [anon_sym_LT_EQ] = ACTIONS(2347),
    [anon_sym_GT] = ACTIONS(2347),
    [anon_sym_GT_EQ] = ACTIONS(2345),
    [anon_sym_CARET] = ACTIONS(2345),
    [anon_sym_PLUS] = ACTIONS(2345),
    [anon_sym_SLASH] = ACTIONS(2345),
    [anon_sym_PERCENT] = ACTIONS(2345),
    [sym_comment] = ACTIONS(87),
  },
  [1345] = {
    [anon_sym_RBRACK] = ACTIONS(5651),
    [sym_comment] = ACTIONS(87),
  },
  [1346] = {
    [sym__statements] = STATE(3397),
    [sym_begin_block] = STATE(489),
    [sym_end_block] = STATE(489),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_block_parameters] = STATE(3398),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(495),
    [aux_sym__statements_repeat1] = STATE(495),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(5653),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2445),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1347] = {
    [sym__statements] = STATE(3400),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_block_parameters] = STATE(3401),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_heredoc_body] = STATE(3402),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [sym__terminator] = STATE(3402),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__line_break] = ACTIONS(5655),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(5655),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(5657),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1348] = {
    [sym_do_block] = STATE(3403),
    [sym_block] = STATE(3403),
    [anon_sym_LBRACE] = ACTIONS(2355),
    [anon_sym_do] = ACTIONS(5659),
    [sym_comment] = ACTIONS(87),
  },
  [1349] = {
    [sym__heredoc_body_start] = ACTIONS(2485),
    [sym__binary_minus] = ACTIONS(2485),
    [sym__binary_star] = ACTIONS(2485),
    [anon_sym_LBRACE] = ACTIONS(2485),
    [anon_sym_RBRACE] = ACTIONS(2485),
    [anon_sym_RPAREN] = ACTIONS(2485),
    [anon_sym_DOT] = ACTIONS(2487),
    [anon_sym_COMMA] = ACTIONS(2485),
    [anon_sym_PIPE] = ACTIONS(2487),
    [anon_sym_SEMI] = ACTIONS(2485),
    [anon_sym_STAR_STAR] = ACTIONS(2485),
    [anon_sym_AMP] = ACTIONS(2487),
    [anon_sym_EQ] = ACTIONS(2487),
    [anon_sym_LT] = ACTIONS(2487),
    [anon_sym_if] = ACTIONS(2485),
    [anon_sym_unless] = ACTIONS(2485),
    [anon_sym_while] = ACTIONS(2485),
    [anon_sym_until] = ACTIONS(2485),
    [anon_sym_rescue] = ACTIONS(2485),
    [anon_sym_in] = ACTIONS(2485),
    [anon_sym_do] = ACTIONS(2485),
    [anon_sym_EQ_GT] = ACTIONS(2485),
    [anon_sym_LBRACK] = ACTIONS(2485),
    [anon_sym_RBRACK] = ACTIONS(2485),
    [anon_sym_COLON_COLON2] = ACTIONS(2485),
    [anon_sym_AMP_DOT] = ACTIONS(2485),
    [anon_sym_QMARK] = ACTIONS(2485),
    [anon_sym_COLON2] = ACTIONS(2487),
    [anon_sym_DOT_DOT] = ACTIONS(2487),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2485),
    [anon_sym_and] = ACTIONS(2485),
    [anon_sym_or] = ACTIONS(2485),
    [anon_sym_PIPE_PIPE] = ACTIONS(2485),
    [anon_sym_AMP_AMP] = ACTIONS(2485),
    [anon_sym_LT_LT] = ACTIONS(2485),
    [anon_sym_GT_GT] = ACTIONS(2485),
    [anon_sym_EQ_EQ] = ACTIONS(2487),
    [anon_sym_BANG_EQ] = ACTIONS(2485),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2485),
    [anon_sym_LT_EQ_GT] = ACTIONS(2485),
    [anon_sym_EQ_TILDE] = ACTIONS(2485),
    [anon_sym_BANG_TILDE] = ACTIONS(2485),
    [anon_sym_LT_EQ] = ACTIONS(2487),
    [anon_sym_GT] = ACTIONS(2487),
    [anon_sym_GT_EQ] = ACTIONS(2485),
    [anon_sym_CARET] = ACTIONS(2485),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_SLASH] = ACTIONS(2485),
    [anon_sym_PERCENT] = ACTIONS(2485),
    [sym_comment] = ACTIONS(87),
  },
  [1350] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(3404),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(352),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(352),
    [sym_assignment] = STATE(3404),
    [sym_operator_assignment] = STATE(3404),
    [sym_conditional] = STATE(3404),
    [sym_range] = STATE(3404),
    [sym_binary] = STATE(3404),
    [sym_unary] = STATE(3404),
    [sym_left_assignment_list] = STATE(351),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(352),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(352),
    [sym_false] = STATE(352),
    [sym_nil] = STATE(352),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1291),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1351] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(3405),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(352),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(352),
    [sym_assignment] = STATE(3405),
    [sym_operator_assignment] = STATE(3405),
    [sym_conditional] = STATE(3405),
    [sym_range] = STATE(3405),
    [sym_binary] = STATE(3405),
    [sym_unary] = STATE(3405),
    [sym_left_assignment_list] = STATE(351),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(352),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(352),
    [sym_false] = STATE(352),
    [sym_nil] = STATE(352),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1291),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1352] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(3406),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(352),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(352),
    [sym_assignment] = STATE(3406),
    [sym_operator_assignment] = STATE(3406),
    [sym_conditional] = STATE(3406),
    [sym_range] = STATE(3406),
    [sym_binary] = STATE(3406),
    [sym_unary] = STATE(3406),
    [sym_left_assignment_list] = STATE(351),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(352),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(352),
    [sym_false] = STATE(352),
    [sym_nil] = STATE(352),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1291),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1353] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(3407),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(352),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(352),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_left_assignment_list] = STATE(351),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(352),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(352),
    [sym_false] = STATE(352),
    [sym_nil] = STATE(352),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1291),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1354] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(3408),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(352),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(352),
    [sym_assignment] = STATE(3408),
    [sym_operator_assignment] = STATE(3408),
    [sym_conditional] = STATE(3408),
    [sym_range] = STATE(3408),
    [sym_binary] = STATE(3408),
    [sym_unary] = STATE(3408),
    [sym_left_assignment_list] = STATE(351),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(352),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(352),
    [sym_false] = STATE(352),
    [sym_nil] = STATE(352),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1291),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1355] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(3409),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(3409),
    [sym_operator_assignment] = STATE(3409),
    [sym_conditional] = STATE(3409),
    [sym_range] = STATE(3409),
    [sym_binary] = STATE(3409),
    [sym_unary] = STATE(3409),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1356] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(3410),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(352),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(352),
    [sym_assignment] = STATE(3410),
    [sym_operator_assignment] = STATE(3410),
    [sym_conditional] = STATE(3410),
    [sym_range] = STATE(3410),
    [sym_binary] = STATE(3410),
    [sym_unary] = STATE(3410),
    [sym_left_assignment_list] = STATE(351),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(352),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(352),
    [sym_false] = STATE(352),
    [sym_nil] = STATE(352),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1291),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1357] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(3411),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(352),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(352),
    [sym_assignment] = STATE(3411),
    [sym_operator_assignment] = STATE(3411),
    [sym_conditional] = STATE(3411),
    [sym_range] = STATE(3411),
    [sym_binary] = STATE(3411),
    [sym_unary] = STATE(3411),
    [sym_left_assignment_list] = STATE(351),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(352),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(352),
    [sym_false] = STATE(352),
    [sym_nil] = STATE(352),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1291),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1358] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(3412),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(352),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(352),
    [sym_assignment] = STATE(3412),
    [sym_operator_assignment] = STATE(3412),
    [sym_conditional] = STATE(3412),
    [sym_range] = STATE(3412),
    [sym_binary] = STATE(3412),
    [sym_unary] = STATE(3412),
    [sym_left_assignment_list] = STATE(351),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(352),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(352),
    [sym_false] = STATE(352),
    [sym_nil] = STATE(352),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1291),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1359] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(3413),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(352),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(352),
    [sym_assignment] = STATE(3413),
    [sym_operator_assignment] = STATE(3413),
    [sym_conditional] = STATE(3413),
    [sym_range] = STATE(3413),
    [sym_binary] = STATE(3413),
    [sym_unary] = STATE(3413),
    [sym_left_assignment_list] = STATE(351),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(352),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(352),
    [sym_false] = STATE(352),
    [sym_nil] = STATE(352),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1291),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1360] = {
    [sym_argument_list_with_parens] = STATE(3416),
    [sym__argument_list_with_parens] = STATE(3417),
    [sym_operator] = STATE(3416),
    [sym_heredoc_body] = STATE(3418),
    [aux_sym_call_repeat1] = STATE(3418),
    [sym__heredoc_body_start] = ACTIONS(2519),
    [anon_sym_PIPE] = ACTIONS(5661),
    [anon_sym_STAR] = ACTIONS(5663),
    [anon_sym_STAR_STAR] = ACTIONS(5661),
    [anon_sym_AMP] = ACTIONS(5661),
    [anon_sym_LT] = ACTIONS(5663),
    [anon_sym_LPAREN2] = ACTIONS(5665),
    [anon_sym_DOT_DOT] = ACTIONS(5661),
    [anon_sym_LT_LT] = ACTIONS(5661),
    [anon_sym_GT_GT] = ACTIONS(5661),
    [anon_sym_EQ_EQ] = ACTIONS(5663),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5661),
    [anon_sym_LT_EQ_GT] = ACTIONS(5661),
    [anon_sym_EQ_TILDE] = ACTIONS(5661),
    [anon_sym_BANG_TILDE] = ACTIONS(5661),
    [anon_sym_LT_EQ] = ACTIONS(5663),
    [anon_sym_GT] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5661),
    [anon_sym_CARET] = ACTIONS(5661),
    [anon_sym_PLUS] = ACTIONS(5663),
    [anon_sym_SLASH] = ACTIONS(5661),
    [anon_sym_PERCENT] = ACTIONS(5661),
    [anon_sym_BANG] = ACTIONS(5663),
    [anon_sym_TILDE] = ACTIONS(5661),
    [sym_constant] = ACTIONS(5667),
    [sym_identifier] = ACTIONS(5667),
    [anon_sym_DASH] = ACTIONS(5663),
    [anon_sym_PLUS_AT] = ACTIONS(5661),
    [anon_sym_DASH_AT] = ACTIONS(5661),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5663),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(5661),
    [anon_sym_BQUOTE] = ACTIONS(5661),
    [sym_comment] = ACTIONS(87),
  },
  [1361] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(346),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(352),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(352),
    [sym__argument_list_with_trailing_comma] = STATE(3420),
    [sym__argument] = STATE(350),
    [sym_splat_argument] = STATE(350),
    [sym_hash_splat_argument] = STATE(350),
    [sym_block_argument] = STATE(350),
    [sym_assignment] = STATE(346),
    [sym_operator_assignment] = STATE(346),
    [sym_conditional] = STATE(346),
    [sym_range] = STATE(346),
    [sym_binary] = STATE(346),
    [sym_unary] = STATE(346),
    [sym_left_assignment_list] = STATE(351),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(352),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(352),
    [sym_false] = STATE(352),
    [sym_nil] = STATE(352),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(353),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(350),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(593),
    [sym__splat_star] = ACTIONS(595),
    [sym__unary_minus] = ACTIONS(597),
    [sym__identifier_hash_key] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(5669),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1362] = {
    [sym_constant] = ACTIONS(5671),
    [sym_identifier] = ACTIONS(5671),
    [sym_comment] = ACTIONS(87),
  },
  [1363] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3422),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1384),
    [sym_scope_resolution] = STATE(1378),
    [sym_call] = STATE(1378),
    [sym_method_call] = STATE(1384),
    [sym_assignment] = STATE(3422),
    [sym_operator_assignment] = STATE(3422),
    [sym_conditional] = STATE(3422),
    [sym_range] = STATE(3422),
    [sym_binary] = STATE(3422),
    [sym_unary] = STATE(3422),
    [sym_left_assignment_list] = STATE(1383),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1384),
    [sym__variable] = STATE(1378),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1384),
    [sym_false] = STATE(1384),
    [sym_nil] = STATE(1384),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3423),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2399),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2405),
    [anon_sym_yield] = ACTIONS(2407),
    [anon_sym_break] = ACTIONS(2409),
    [anon_sym_next] = ACTIONS(2411),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(5673),
    [anon_sym_defined_QMARK] = ACTIONS(2415),
    [anon_sym_not] = ACTIONS(2417),
    [anon_sym_BANG] = ACTIONS(2421),
    [anon_sym_TILDE] = ACTIONS(2421),
    [sym_constant] = ACTIONS(2427),
    [sym_identifier] = ACTIONS(2427),
    [sym_instance_variable] = ACTIONS(2425),
    [sym_class_variable] = ACTIONS(2425),
    [sym_global_variable] = ACTIONS(2425),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2427),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2427),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1364] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3424),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1384),
    [sym_scope_resolution] = STATE(1378),
    [sym_call] = STATE(1378),
    [sym_method_call] = STATE(1384),
    [sym_assignment] = STATE(3424),
    [sym_operator_assignment] = STATE(3424),
    [sym_conditional] = STATE(3424),
    [sym_range] = STATE(3424),
    [sym_binary] = STATE(3424),
    [sym_unary] = STATE(3424),
    [sym_left_assignment_list] = STATE(1383),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1384),
    [sym__variable] = STATE(1378),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1384),
    [sym_false] = STATE(1384),
    [sym_nil] = STATE(1384),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3423),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2399),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2405),
    [anon_sym_yield] = ACTIONS(2407),
    [anon_sym_break] = ACTIONS(2409),
    [anon_sym_next] = ACTIONS(2411),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(5673),
    [anon_sym_defined_QMARK] = ACTIONS(2415),
    [anon_sym_not] = ACTIONS(2417),
    [anon_sym_BANG] = ACTIONS(2421),
    [anon_sym_TILDE] = ACTIONS(2421),
    [sym_constant] = ACTIONS(2427),
    [sym_identifier] = ACTIONS(2427),
    [sym_instance_variable] = ACTIONS(2425),
    [sym_class_variable] = ACTIONS(2425),
    [sym_global_variable] = ACTIONS(2425),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2427),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2427),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1365] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3425),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1384),
    [sym_scope_resolution] = STATE(1378),
    [sym_call] = STATE(1378),
    [sym_method_call] = STATE(1384),
    [sym_assignment] = STATE(3425),
    [sym_operator_assignment] = STATE(3425),
    [sym_conditional] = STATE(3425),
    [sym_range] = STATE(3425),
    [sym_binary] = STATE(3425),
    [sym_unary] = STATE(3425),
    [sym_left_assignment_list] = STATE(1383),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1384),
    [sym__variable] = STATE(1378),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1384),
    [sym_false] = STATE(1384),
    [sym_nil] = STATE(1384),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3423),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2399),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2405),
    [anon_sym_yield] = ACTIONS(2407),
    [anon_sym_break] = ACTIONS(2409),
    [anon_sym_next] = ACTIONS(2411),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(5673),
    [anon_sym_defined_QMARK] = ACTIONS(2415),
    [anon_sym_not] = ACTIONS(2417),
    [anon_sym_BANG] = ACTIONS(2421),
    [anon_sym_TILDE] = ACTIONS(2421),
    [sym_constant] = ACTIONS(2427),
    [sym_identifier] = ACTIONS(2427),
    [sym_instance_variable] = ACTIONS(2425),
    [sym_class_variable] = ACTIONS(2425),
    [sym_global_variable] = ACTIONS(2425),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2427),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2427),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1366] = {
    [anon_sym_COLON] = ACTIONS(5675),
    [sym_comment] = ACTIONS(87),
  },
  [1367] = {
    [sym__statements] = STATE(3428),
    [sym_begin_block] = STATE(489),
    [sym_end_block] = STATE(489),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_block_parameters] = STATE(3429),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1516),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1519),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1519),
    [sym_hash_splat_argument] = STATE(116),
    [sym_assignment] = STATE(1516),
    [sym_operator_assignment] = STATE(1516),
    [sym_conditional] = STATE(1516),
    [sym_range] = STATE(1516),
    [sym_binary] = STATE(1516),
    [sym_unary] = STATE(1516),
    [sym_left_assignment_list] = STATE(1518),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1519),
    [sym__variable] = STATE(1517),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1519),
    [sym_false] = STATE(1519),
    [sym_nil] = STATE(1519),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1520),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(1959),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym__hash_items] = STATE(1960),
    [sym_pair] = STATE(122),
    [sym_lambda] = STATE(214),
    [sym_empty_statement] = STATE(495),
    [aux_sym__statements_repeat1] = STATE(495),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2629),
    [sym__identifier_hash_key] = ACTIONS(157),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(5677),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_PIPE] = ACTIONS(2445),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2633),
    [anon_sym_yield] = ACTIONS(2635),
    [anon_sym_break] = ACTIONS(2637),
    [anon_sym_next] = ACTIONS(2639),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2641),
    [anon_sym_defined_QMARK] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2647),
    [anon_sym_TILDE] = ACTIONS(2647),
    [sym_constant] = ACTIONS(2649),
    [sym_identifier] = ACTIONS(2649),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1368] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3430),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1384),
    [sym_scope_resolution] = STATE(1378),
    [sym_call] = STATE(1378),
    [sym_method_call] = STATE(1384),
    [sym_assignment] = STATE(3430),
    [sym_operator_assignment] = STATE(3430),
    [sym_conditional] = STATE(3430),
    [sym_range] = STATE(3430),
    [sym_binary] = STATE(3430),
    [sym_unary] = STATE(3430),
    [sym_left_assignment_list] = STATE(1383),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1384),
    [sym__variable] = STATE(1378),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1384),
    [sym_false] = STATE(1384),
    [sym_nil] = STATE(1384),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3423),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2399),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2405),
    [anon_sym_yield] = ACTIONS(2407),
    [anon_sym_break] = ACTIONS(2409),
    [anon_sym_next] = ACTIONS(2411),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(5673),
    [anon_sym_defined_QMARK] = ACTIONS(2415),
    [anon_sym_not] = ACTIONS(2417),
    [anon_sym_BANG] = ACTIONS(2421),
    [anon_sym_TILDE] = ACTIONS(2421),
    [sym_constant] = ACTIONS(2427),
    [sym_identifier] = ACTIONS(2427),
    [sym_instance_variable] = ACTIONS(2425),
    [sym_class_variable] = ACTIONS(2425),
    [sym_global_variable] = ACTIONS(2425),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2427),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2427),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1369] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1377),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1384),
    [sym_scope_resolution] = STATE(1378),
    [sym_call] = STATE(1378),
    [sym_method_call] = STATE(1384),
    [sym_argument_list] = STATE(1973),
    [sym__argument_list_with_parens] = STATE(1380),
    [sym__argument] = STATE(1381),
    [sym_splat_argument] = STATE(1381),
    [sym_hash_splat_argument] = STATE(1381),
    [sym_block_argument] = STATE(1381),
    [sym_assignment] = STATE(1377),
    [sym_operator_assignment] = STATE(1377),
    [sym_conditional] = STATE(1377),
    [sym_range] = STATE(1377),
    [sym_binary] = STATE(1377),
    [sym_unary] = STATE(1377),
    [sym_left_assignment_list] = STATE(1383),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1384),
    [sym__variable] = STATE(1378),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1384),
    [sym_false] = STATE(1384),
    [sym_nil] = STATE(1384),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1385),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(1381),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(2395),
    [sym__splat_star] = ACTIONS(2397),
    [sym__unary_minus] = ACTIONS(2399),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(2401),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2405),
    [anon_sym_yield] = ACTIONS(2407),
    [anon_sym_break] = ACTIONS(2409),
    [anon_sym_next] = ACTIONS(2411),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_RBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(365),
    [anon_sym_DASH_EQ] = ACTIONS(365),
    [anon_sym_STAR_EQ] = ACTIONS(365),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(365),
    [anon_sym_SLASH_EQ] = ACTIONS(365),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(365),
    [anon_sym_PIPE_EQ] = ACTIONS(365),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(365),
    [anon_sym_AMP_EQ] = ACTIONS(365),
    [anon_sym_PERCENT_EQ] = ACTIONS(365),
    [anon_sym_GT_GT_EQ] = ACTIONS(365),
    [anon_sym_LT_LT_EQ] = ACTIONS(365),
    [anon_sym_CARET_EQ] = ACTIONS(365),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_PERCENT] = ACTIONS(377),
    [anon_sym_defined_QMARK] = ACTIONS(2415),
    [anon_sym_not] = ACTIONS(2417),
    [anon_sym_BANG] = ACTIONS(2419),
    [anon_sym_TILDE] = ACTIONS(2421),
    [sym_constant] = ACTIONS(2423),
    [sym_identifier] = ACTIONS(2423),
    [sym_instance_variable] = ACTIONS(2425),
    [sym_class_variable] = ACTIONS(2425),
    [sym_global_variable] = ACTIONS(2425),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2427),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2427),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1370] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1377),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1384),
    [sym_scope_resolution] = STATE(1378),
    [sym_call] = STATE(1378),
    [sym_method_call] = STATE(1384),
    [sym_argument_list] = STATE(1974),
    [sym__argument_list_with_parens] = STATE(1380),
    [sym__argument] = STATE(1381),
    [sym_splat_argument] = STATE(1381),
    [sym_hash_splat_argument] = STATE(1381),
    [sym_block_argument] = STATE(1381),
    [sym_assignment] = STATE(1377),
    [sym_operator_assignment] = STATE(1377),
    [sym_conditional] = STATE(1377),
    [sym_range] = STATE(1377),
    [sym_binary] = STATE(1377),
    [sym_unary] = STATE(1377),
    [sym_left_assignment_list] = STATE(1383),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1384),
    [sym__variable] = STATE(1378),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1384),
    [sym_false] = STATE(1384),
    [sym_nil] = STATE(1384),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1385),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(1381),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(2395),
    [sym__splat_star] = ACTIONS(2397),
    [sym__unary_minus] = ACTIONS(2399),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(2401),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_EQ] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2405),
    [anon_sym_yield] = ACTIONS(2407),
    [anon_sym_break] = ACTIONS(2409),
    [anon_sym_next] = ACTIONS(2411),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_RBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(417),
    [anon_sym_DASH_EQ] = ACTIONS(417),
    [anon_sym_STAR_EQ] = ACTIONS(417),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(417),
    [anon_sym_SLASH_EQ] = ACTIONS(417),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(417),
    [anon_sym_PIPE_EQ] = ACTIONS(417),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(417),
    [anon_sym_AMP_EQ] = ACTIONS(417),
    [anon_sym_PERCENT_EQ] = ACTIONS(417),
    [anon_sym_GT_GT_EQ] = ACTIONS(417),
    [anon_sym_LT_LT_EQ] = ACTIONS(417),
    [anon_sym_CARET_EQ] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(2415),
    [anon_sym_not] = ACTIONS(2417),
    [anon_sym_BANG] = ACTIONS(2419),
    [anon_sym_TILDE] = ACTIONS(2421),
    [sym_constant] = ACTIONS(2423),
    [sym_identifier] = ACTIONS(2423),
    [sym_instance_variable] = ACTIONS(2425),
    [sym_class_variable] = ACTIONS(2425),
    [sym_global_variable] = ACTIONS(2425),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2427),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2427),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1371] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1377),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1384),
    [sym_scope_resolution] = STATE(1378),
    [sym_call] = STATE(1378),
    [sym_method_call] = STATE(1384),
    [sym_argument_list] = STATE(1975),
    [sym__argument_list_with_parens] = STATE(1380),
    [sym__argument] = STATE(1381),
    [sym_splat_argument] = STATE(1381),
    [sym_hash_splat_argument] = STATE(1381),
    [sym_block_argument] = STATE(1381),
    [sym_assignment] = STATE(1377),
    [sym_operator_assignment] = STATE(1377),
    [sym_conditional] = STATE(1377),
    [sym_range] = STATE(1377),
    [sym_binary] = STATE(1377),
    [sym_unary] = STATE(1377),
    [sym_left_assignment_list] = STATE(1383),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1384),
    [sym__variable] = STATE(1378),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1384),
    [sym_false] = STATE(1384),
    [sym_nil] = STATE(1384),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1385),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(1381),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(2395),
    [sym__splat_star] = ACTIONS(2397),
    [sym__unary_minus] = ACTIONS(2399),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(2401),
    [anon_sym_LBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_EQ] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2405),
    [anon_sym_yield] = ACTIONS(2407),
    [anon_sym_break] = ACTIONS(2409),
    [anon_sym_next] = ACTIONS(2411),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_RBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(421),
    [anon_sym_DASH_EQ] = ACTIONS(421),
    [anon_sym_STAR_EQ] = ACTIONS(421),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(421),
    [anon_sym_SLASH_EQ] = ACTIONS(421),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(421),
    [anon_sym_PIPE_EQ] = ACTIONS(421),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(421),
    [anon_sym_AMP_EQ] = ACTIONS(421),
    [anon_sym_PERCENT_EQ] = ACTIONS(421),
    [anon_sym_GT_GT_EQ] = ACTIONS(421),
    [anon_sym_LT_LT_EQ] = ACTIONS(421),
    [anon_sym_CARET_EQ] = ACTIONS(421),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(2415),
    [anon_sym_not] = ACTIONS(2417),
    [anon_sym_BANG] = ACTIONS(2419),
    [anon_sym_TILDE] = ACTIONS(2421),
    [sym_constant] = ACTIONS(2423),
    [sym_identifier] = ACTIONS(2423),
    [sym_instance_variable] = ACTIONS(2425),
    [sym_class_variable] = ACTIONS(2425),
    [sym_global_variable] = ACTIONS(2425),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2427),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2427),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1372] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1377),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1384),
    [sym_scope_resolution] = STATE(1378),
    [sym_call] = STATE(1378),
    [sym_method_call] = STATE(1384),
    [sym_argument_list] = STATE(1976),
    [sym__argument_list_with_parens] = STATE(1380),
    [sym__argument] = STATE(1381),
    [sym_splat_argument] = STATE(1381),
    [sym_hash_splat_argument] = STATE(1381),
    [sym_block_argument] = STATE(1381),
    [sym_assignment] = STATE(1377),
    [sym_operator_assignment] = STATE(1377),
    [sym_conditional] = STATE(1377),
    [sym_range] = STATE(1377),
    [sym_binary] = STATE(1377),
    [sym_unary] = STATE(1377),
    [sym_left_assignment_list] = STATE(1383),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1384),
    [sym__variable] = STATE(1378),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1384),
    [sym_false] = STATE(1384),
    [sym_nil] = STATE(1384),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1385),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(1381),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(2395),
    [sym__splat_star] = ACTIONS(2397),
    [sym__unary_minus] = ACTIONS(2399),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(2401),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(427),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2405),
    [anon_sym_yield] = ACTIONS(2407),
    [anon_sym_break] = ACTIONS(2409),
    [anon_sym_next] = ACTIONS(2411),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_RBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(425),
    [anon_sym_DASH_EQ] = ACTIONS(425),
    [anon_sym_STAR_EQ] = ACTIONS(425),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(425),
    [anon_sym_SLASH_EQ] = ACTIONS(425),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(425),
    [anon_sym_PIPE_EQ] = ACTIONS(425),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(425),
    [anon_sym_AMP_EQ] = ACTIONS(425),
    [anon_sym_PERCENT_EQ] = ACTIONS(425),
    [anon_sym_GT_GT_EQ] = ACTIONS(425),
    [anon_sym_LT_LT_EQ] = ACTIONS(425),
    [anon_sym_CARET_EQ] = ACTIONS(425),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(2415),
    [anon_sym_not] = ACTIONS(2417),
    [anon_sym_BANG] = ACTIONS(2419),
    [anon_sym_TILDE] = ACTIONS(2421),
    [sym_constant] = ACTIONS(2423),
    [sym_identifier] = ACTIONS(2423),
    [sym_instance_variable] = ACTIONS(2425),
    [sym_class_variable] = ACTIONS(2425),
    [sym_global_variable] = ACTIONS(2425),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2427),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2427),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1373] = {
    [sym__statements] = STATE(3432),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_block_parameters] = STATE(3433),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_heredoc_body] = STATE(3434),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [sym__terminator] = STATE(3434),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__line_break] = ACTIONS(5679),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(5679),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(5681),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1374] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3435),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1384),
    [sym_scope_resolution] = STATE(1378),
    [sym_call] = STATE(1378),
    [sym_method_call] = STATE(1384),
    [sym_assignment] = STATE(3435),
    [sym_operator_assignment] = STATE(3435),
    [sym_conditional] = STATE(3435),
    [sym_range] = STATE(3435),
    [sym_binary] = STATE(3435),
    [sym_unary] = STATE(3435),
    [sym_left_assignment_list] = STATE(1383),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1384),
    [sym__variable] = STATE(1378),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1384),
    [sym_false] = STATE(1384),
    [sym_nil] = STATE(1384),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3423),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2399),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2405),
    [anon_sym_yield] = ACTIONS(2407),
    [anon_sym_break] = ACTIONS(2409),
    [anon_sym_next] = ACTIONS(2411),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(5673),
    [anon_sym_defined_QMARK] = ACTIONS(2415),
    [anon_sym_not] = ACTIONS(2417),
    [anon_sym_BANG] = ACTIONS(2421),
    [anon_sym_TILDE] = ACTIONS(2421),
    [sym_constant] = ACTIONS(2427),
    [sym_identifier] = ACTIONS(2427),
    [sym_instance_variable] = ACTIONS(2425),
    [sym_class_variable] = ACTIONS(2425),
    [sym_global_variable] = ACTIONS(2425),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2427),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2427),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1375] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1997),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1384),
    [sym_scope_resolution] = STATE(1378),
    [sym_call] = STATE(1378),
    [sym_method_call] = STATE(1384),
    [sym_assignment] = STATE(1997),
    [sym_operator_assignment] = STATE(1997),
    [sym_conditional] = STATE(1997),
    [sym_range] = STATE(1997),
    [sym_binary] = STATE(1997),
    [sym_unary] = STATE(1997),
    [sym_left_assignment_list] = STATE(1383),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1384),
    [sym__variable] = STATE(1378),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1384),
    [sym_false] = STATE(1384),
    [sym_nil] = STATE(1384),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3423),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2399),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2405),
    [anon_sym_yield] = ACTIONS(2407),
    [anon_sym_break] = ACTIONS(2409),
    [anon_sym_next] = ACTIONS(2411),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(5673),
    [anon_sym_defined_QMARK] = ACTIONS(2415),
    [anon_sym_not] = ACTIONS(2417),
    [anon_sym_BANG] = ACTIONS(2421),
    [anon_sym_TILDE] = ACTIONS(2421),
    [sym_constant] = ACTIONS(2427),
    [sym_identifier] = ACTIONS(2427),
    [sym_instance_variable] = ACTIONS(2425),
    [sym_class_variable] = ACTIONS(2425),
    [sym_global_variable] = ACTIONS(2425),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2427),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2427),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1376] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(5683),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_RBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [1377] = {
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(5685),
    [sym__binary_star] = ACTIONS(5687),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(5689),
    [anon_sym_STAR_STAR] = ACTIONS(5691),
    [anon_sym_AMP] = ACTIONS(5693),
    [anon_sym_EQ] = ACTIONS(1631),
    [anon_sym_LT] = ACTIONS(5695),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(1625),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_RBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_PLUS_EQ] = ACTIONS(1625),
    [anon_sym_DASH_EQ] = ACTIONS(1625),
    [anon_sym_STAR_EQ] = ACTIONS(1625),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1625),
    [anon_sym_SLASH_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1625),
    [anon_sym_AMP_EQ] = ACTIONS(1625),
    [anon_sym_PERCENT_EQ] = ACTIONS(1625),
    [anon_sym_GT_GT_EQ] = ACTIONS(1625),
    [anon_sym_LT_LT_EQ] = ACTIONS(1625),
    [anon_sym_CARET_EQ] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(5697),
    [anon_sym_DOT_DOT] = ACTIONS(5699),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5701),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(5703),
    [anon_sym_AMP_AMP] = ACTIONS(5703),
    [anon_sym_LT_LT] = ACTIONS(5705),
    [anon_sym_GT_GT] = ACTIONS(5705),
    [anon_sym_EQ_EQ] = ACTIONS(5703),
    [anon_sym_BANG_EQ] = ACTIONS(5707),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5707),
    [anon_sym_LT_EQ_GT] = ACTIONS(5707),
    [anon_sym_EQ_TILDE] = ACTIONS(5707),
    [anon_sym_BANG_TILDE] = ACTIONS(5707),
    [anon_sym_LT_EQ] = ACTIONS(5695),
    [anon_sym_GT] = ACTIONS(5695),
    [anon_sym_GT_EQ] = ACTIONS(5709),
    [anon_sym_CARET] = ACTIONS(5689),
    [anon_sym_PLUS] = ACTIONS(5711),
    [anon_sym_SLASH] = ACTIONS(5691),
    [anon_sym_PERCENT] = ACTIONS(5691),
    [sym_comment] = ACTIONS(87),
  },
  [1378] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1377),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1384),
    [sym_scope_resolution] = STATE(1378),
    [sym_call] = STATE(1378),
    [sym_method_call] = STATE(1384),
    [sym_argument_list] = STATE(2016),
    [sym__argument_list_with_parens] = STATE(1380),
    [sym__argument] = STATE(1381),
    [sym_splat_argument] = STATE(1381),
    [sym_hash_splat_argument] = STATE(1381),
    [sym_block_argument] = STATE(1381),
    [sym_do_block] = STATE(1382),
    [sym_block] = STATE(1382),
    [sym_assignment] = STATE(1377),
    [sym_operator_assignment] = STATE(1377),
    [sym_conditional] = STATE(1377),
    [sym_range] = STATE(1377),
    [sym_binary] = STATE(1377),
    [sym_unary] = STATE(1377),
    [sym_left_assignment_list] = STATE(1383),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1384),
    [sym__variable] = STATE(1378),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1384),
    [sym_false] = STATE(1384),
    [sym_nil] = STATE(1384),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1385),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(1381),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(2395),
    [sym__splat_star] = ACTIONS(2397),
    [sym__unary_minus] = ACTIONS(2399),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(2401),
    [anon_sym_LBRACE] = ACTIONS(3537),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2405),
    [anon_sym_yield] = ACTIONS(2407),
    [anon_sym_break] = ACTIONS(2409),
    [anon_sym_next] = ACTIONS(2411),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(769),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_RBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(2415),
    [anon_sym_not] = ACTIONS(2417),
    [anon_sym_BANG] = ACTIONS(2419),
    [anon_sym_TILDE] = ACTIONS(2421),
    [sym_constant] = ACTIONS(2423),
    [sym_identifier] = ACTIONS(2423),
    [sym_instance_variable] = ACTIONS(2425),
    [sym_class_variable] = ACTIONS(2425),
    [sym_global_variable] = ACTIONS(2425),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2427),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2427),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1379] = {
    [sym_do_block] = STATE(3447),
    [sym_block] = STATE(3447),
    [sym__heredoc_body_start] = ACTIONS(2717),
    [sym__binary_minus] = ACTIONS(2717),
    [sym__binary_star] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym_RBRACE] = ACTIONS(2717),
    [anon_sym_RPAREN] = ACTIONS(2717),
    [anon_sym_DOT] = ACTIONS(2721),
    [anon_sym_COMMA] = ACTIONS(2717),
    [anon_sym_PIPE] = ACTIONS(2721),
    [anon_sym_SEMI] = ACTIONS(2717),
    [anon_sym_STAR_STAR] = ACTIONS(2721),
    [anon_sym_AMP] = ACTIONS(2721),
    [anon_sym_EQ] = ACTIONS(2721),
    [anon_sym_LT] = ACTIONS(2721),
    [anon_sym_if] = ACTIONS(2717),
    [anon_sym_unless] = ACTIONS(2717),
    [anon_sym_while] = ACTIONS(2717),
    [anon_sym_until] = ACTIONS(2717),
    [anon_sym_rescue] = ACTIONS(2717),
    [anon_sym_do] = ACTIONS(5713),
    [anon_sym_EQ_GT] = ACTIONS(2717),
    [anon_sym_LBRACK] = ACTIONS(2717),
    [anon_sym_RBRACK] = ACTIONS(2717),
    [anon_sym_COLON_COLON2] = ACTIONS(2717),
    [anon_sym_AMP_DOT] = ACTIONS(2717),
    [anon_sym_PLUS_EQ] = ACTIONS(2717),
    [anon_sym_DASH_EQ] = ACTIONS(2717),
    [anon_sym_STAR_EQ] = ACTIONS(2717),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2717),
    [anon_sym_SLASH_EQ] = ACTIONS(2717),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2717),
    [anon_sym_PIPE_EQ] = ACTIONS(2717),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2717),
    [anon_sym_AMP_EQ] = ACTIONS(2717),
    [anon_sym_PERCENT_EQ] = ACTIONS(2717),
    [anon_sym_GT_GT_EQ] = ACTIONS(2717),
    [anon_sym_LT_LT_EQ] = ACTIONS(2717),
    [anon_sym_CARET_EQ] = ACTIONS(2717),
    [anon_sym_QMARK] = ACTIONS(2717),
    [anon_sym_COLON2] = ACTIONS(2721),
    [anon_sym_DOT_DOT] = ACTIONS(2721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2717),
    [anon_sym_and] = ACTIONS(2717),
    [anon_sym_or] = ACTIONS(2717),
    [anon_sym_PIPE_PIPE] = ACTIONS(2721),
    [anon_sym_AMP_AMP] = ACTIONS(2721),
    [anon_sym_LT_LT] = ACTIONS(2721),
    [anon_sym_GT_GT] = ACTIONS(2721),
    [anon_sym_EQ_EQ] = ACTIONS(2721),
    [anon_sym_BANG_EQ] = ACTIONS(2717),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2717),
    [anon_sym_LT_EQ_GT] = ACTIONS(2717),
    [anon_sym_EQ_TILDE] = ACTIONS(2717),
    [anon_sym_BANG_TILDE] = ACTIONS(2717),
    [anon_sym_LT_EQ] = ACTIONS(2721),
    [anon_sym_GT] = ACTIONS(2721),
    [anon_sym_GT_EQ] = ACTIONS(2717),
    [anon_sym_CARET] = ACTIONS(2721),
    [anon_sym_PLUS] = ACTIONS(2721),
    [anon_sym_SLASH] = ACTIONS(2721),
    [anon_sym_PERCENT] = ACTIONS(2721),
    [sym_comment] = ACTIONS(87),
  },
  [1380] = {
    [sym_heredoc_body] = STATE(3448),
    [aux_sym_call_repeat1] = STATE(3448),
    [sym__heredoc_body_start] = ACTIONS(3543),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_RBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [1381] = {
    [sym_heredoc_body] = STATE(3448),
    [aux_sym_call_repeat1] = STATE(3448),
    [aux_sym_argument_list_repeat1] = STATE(3450),
    [sym__heredoc_body_start] = ACTIONS(3543),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(5715),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_RBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [1382] = {
    [sym__heredoc_body_start] = ACTIONS(2717),
    [sym__binary_minus] = ACTIONS(2717),
    [sym__binary_star] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(2717),
    [anon_sym_RBRACE] = ACTIONS(2717),
    [anon_sym_RPAREN] = ACTIONS(2717),
    [anon_sym_DOT] = ACTIONS(2721),
    [anon_sym_COMMA] = ACTIONS(2717),
    [anon_sym_PIPE] = ACTIONS(2721),
    [anon_sym_SEMI] = ACTIONS(2717),
    [anon_sym_STAR_STAR] = ACTIONS(2721),
    [anon_sym_AMP] = ACTIONS(2721),
    [anon_sym_EQ] = ACTIONS(2721),
    [anon_sym_LT] = ACTIONS(2721),
    [anon_sym_if] = ACTIONS(2717),
    [anon_sym_unless] = ACTIONS(2717),
    [anon_sym_while] = ACTIONS(2717),
    [anon_sym_until] = ACTIONS(2717),
    [anon_sym_rescue] = ACTIONS(2717),
    [anon_sym_in] = ACTIONS(2717),
    [anon_sym_do] = ACTIONS(2717),
    [anon_sym_EQ_GT] = ACTIONS(2717),
    [anon_sym_LBRACK] = ACTIONS(2717),
    [anon_sym_RBRACK] = ACTIONS(2717),
    [anon_sym_COLON_COLON2] = ACTIONS(2717),
    [anon_sym_AMP_DOT] = ACTIONS(2717),
    [anon_sym_PLUS_EQ] = ACTIONS(2717),
    [anon_sym_DASH_EQ] = ACTIONS(2717),
    [anon_sym_STAR_EQ] = ACTIONS(2717),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2717),
    [anon_sym_SLASH_EQ] = ACTIONS(2717),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2717),
    [anon_sym_PIPE_EQ] = ACTIONS(2717),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2717),
    [anon_sym_AMP_EQ] = ACTIONS(2717),
    [anon_sym_PERCENT_EQ] = ACTIONS(2717),
    [anon_sym_GT_GT_EQ] = ACTIONS(2717),
    [anon_sym_LT_LT_EQ] = ACTIONS(2717),
    [anon_sym_CARET_EQ] = ACTIONS(2717),
    [anon_sym_QMARK] = ACTIONS(2717),
    [anon_sym_COLON2] = ACTIONS(2721),
    [anon_sym_DOT_DOT] = ACTIONS(2721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2717),
    [anon_sym_and] = ACTIONS(2717),
    [anon_sym_or] = ACTIONS(2717),
    [anon_sym_PIPE_PIPE] = ACTIONS(2721),
    [anon_sym_AMP_AMP] = ACTIONS(2721),
    [anon_sym_LT_LT] = ACTIONS(2721),
    [anon_sym_GT_GT] = ACTIONS(2721),
    [anon_sym_EQ_EQ] = ACTIONS(2721),
    [anon_sym_BANG_EQ] = ACTIONS(2717),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2717),
    [anon_sym_LT_EQ_GT] = ACTIONS(2717),
    [anon_sym_EQ_TILDE] = ACTIONS(2717),
    [anon_sym_BANG_TILDE] = ACTIONS(2717),
    [anon_sym_LT_EQ] = ACTIONS(2721),
    [anon_sym_GT] = ACTIONS(2721),
    [anon_sym_GT_EQ] = ACTIONS(2717),
    [anon_sym_CARET] = ACTIONS(2721),
    [anon_sym_PLUS] = ACTIONS(2721),
    [anon_sym_SLASH] = ACTIONS(2721),
    [anon_sym_PERCENT] = ACTIONS(2721),
    [sym_comment] = ACTIONS(87),
  },
  [1383] = {
    [anon_sym_EQ] = ACTIONS(5717),
    [sym_comment] = ACTIONS(87),
  },
  [1384] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(5719),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(5721),
    [anon_sym_DASH_EQ] = ACTIONS(5721),
    [anon_sym_STAR_EQ] = ACTIONS(5721),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5721),
    [anon_sym_SLASH_EQ] = ACTIONS(5721),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5721),
    [anon_sym_PIPE_EQ] = ACTIONS(5721),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5721),
    [anon_sym_AMP_EQ] = ACTIONS(5721),
    [anon_sym_PERCENT_EQ] = ACTIONS(5721),
    [anon_sym_GT_GT_EQ] = ACTIONS(5721),
    [anon_sym_LT_LT_EQ] = ACTIONS(5721),
    [anon_sym_CARET_EQ] = ACTIONS(5721),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1385] = {
    [sym_string] = STATE(3453),
    [aux_sym_chained_string_repeat1] = STATE(3453),
    [sym__string_start] = ACTIONS(1141),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(5723),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1386] = {
    [sym__line_break] = ACTIONS(5725),
    [sym__heredoc_body_start] = ACTIONS(5725),
    [sym__binary_minus] = ACTIONS(5725),
    [sym__binary_star] = ACTIONS(5725),
    [ts_builtin_sym_end] = ACTIONS(5725),
    [anon_sym___END__] = ACTIONS(5725),
    [anon_sym_LBRACE] = ACTIONS(5725),
    [anon_sym_RBRACE] = ACTIONS(5725),
    [anon_sym_RPAREN] = ACTIONS(5725),
    [anon_sym_DOT] = ACTIONS(5727),
    [anon_sym_COMMA] = ACTIONS(5725),
    [anon_sym_PIPE] = ACTIONS(5727),
    [anon_sym_SEMI] = ACTIONS(5725),
    [anon_sym_STAR_STAR] = ACTIONS(5725),
    [anon_sym_AMP] = ACTIONS(5727),
    [anon_sym_LT] = ACTIONS(5727),
    [anon_sym_end] = ACTIONS(5725),
    [anon_sym_if] = ACTIONS(5725),
    [anon_sym_unless] = ACTIONS(5725),
    [anon_sym_while] = ACTIONS(5725),
    [anon_sym_until] = ACTIONS(5725),
    [anon_sym_rescue] = ACTIONS(5725),
    [anon_sym_do] = ACTIONS(5725),
    [anon_sym_when] = ACTIONS(5725),
    [anon_sym_elsif] = ACTIONS(5725),
    [anon_sym_else] = ACTIONS(5725),
    [anon_sym_then] = ACTIONS(5725),
    [anon_sym_ensure] = ACTIONS(5725),
    [anon_sym_EQ_GT] = ACTIONS(5725),
    [anon_sym_LBRACK] = ACTIONS(5725),
    [anon_sym_COLON_COLON2] = ACTIONS(5725),
    [anon_sym_AMP_DOT] = ACTIONS(5725),
    [anon_sym_QMARK] = ACTIONS(5725),
    [anon_sym_DOT_DOT] = ACTIONS(5727),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5725),
    [anon_sym_and] = ACTIONS(5725),
    [anon_sym_or] = ACTIONS(5725),
    [anon_sym_PIPE_PIPE] = ACTIONS(5725),
    [anon_sym_AMP_AMP] = ACTIONS(5725),
    [anon_sym_LT_LT] = ACTIONS(5725),
    [anon_sym_GT_GT] = ACTIONS(5725),
    [anon_sym_EQ_EQ] = ACTIONS(5727),
    [anon_sym_BANG_EQ] = ACTIONS(5725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5725),
    [anon_sym_LT_EQ_GT] = ACTIONS(5725),
    [anon_sym_EQ_TILDE] = ACTIONS(5725),
    [anon_sym_BANG_TILDE] = ACTIONS(5725),
    [anon_sym_LT_EQ] = ACTIONS(5727),
    [anon_sym_GT] = ACTIONS(5727),
    [anon_sym_GT_EQ] = ACTIONS(5725),
    [anon_sym_CARET] = ACTIONS(5725),
    [anon_sym_PLUS] = ACTIONS(5725),
    [anon_sym_SLASH] = ACTIONS(5725),
    [anon_sym_PERCENT] = ACTIONS(5725),
    [sym_comment] = ACTIONS(87),
  },
  [1387] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(346),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(352),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(352),
    [sym__argument] = STATE(3454),
    [sym_splat_argument] = STATE(3454),
    [sym_hash_splat_argument] = STATE(3454),
    [sym_block_argument] = STATE(3454),
    [sym_assignment] = STATE(346),
    [sym_operator_assignment] = STATE(346),
    [sym_conditional] = STATE(346),
    [sym_range] = STATE(346),
    [sym_binary] = STATE(346),
    [sym_unary] = STATE(346),
    [sym_left_assignment_list] = STATE(351),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(352),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(352),
    [sym_false] = STATE(352),
    [sym_nil] = STATE(352),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(353),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_heredoc_body] = STATE(3455),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(3454),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(593),
    [sym__splat_star] = ACTIONS(595),
    [sym__unary_minus] = ACTIONS(597),
    [sym__identifier_hash_key] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(5729),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1388] = {
    [anon_sym_RPAREN] = ACTIONS(5729),
    [anon_sym_RBRACK] = ACTIONS(5729),
    [sym_comment] = ACTIONS(87),
  },
  [1389] = {
    [sym_heredoc_body] = STATE(3457),
    [aux_sym_argument_list_repeat1] = STATE(3458),
    [sym__heredoc_body_start] = ACTIONS(151),
    [anon_sym_COMMA] = ACTIONS(5731),
    [anon_sym_RBRACK] = ACTIONS(5729),
    [sym_comment] = ACTIONS(87),
  },
  [1390] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(3460),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(352),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(352),
    [sym_splat_argument] = STATE(3462),
    [sym_assignment] = STATE(3460),
    [sym_operator_assignment] = STATE(3460),
    [sym_conditional] = STATE(3460),
    [sym_range] = STATE(3460),
    [sym_binary] = STATE(3460),
    [sym_unary] = STATE(3460),
    [sym_right_assignment_list] = STATE(3461),
    [sym__arg_or_splat_arg] = STATE(3462),
    [sym_left_assignment_list] = STATE(351),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(352),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(352),
    [sym_false] = STATE(352),
    [sym_nil] = STATE(352),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1291),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(5733),
    [sym__unary_minus] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1391] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(3463),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(352),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(352),
    [sym_assignment] = STATE(3463),
    [sym_operator_assignment] = STATE(3463),
    [sym_conditional] = STATE(3463),
    [sym_range] = STATE(3463),
    [sym_binary] = STATE(3463),
    [sym_unary] = STATE(3463),
    [sym_left_assignment_list] = STATE(351),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(352),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(352),
    [sym_false] = STATE(352),
    [sym_nil] = STATE(352),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1291),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1392] = {
    [sym_string] = STATE(3464),
    [aux_sym_chained_string_repeat1] = STATE(3464),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_EQ_GT] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_RBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [1393] = {
    [sym__line_break] = ACTIONS(5735),
    [sym__heredoc_body_start] = ACTIONS(5735),
    [sym__binary_minus] = ACTIONS(5735),
    [sym__binary_star] = ACTIONS(5735),
    [ts_builtin_sym_end] = ACTIONS(5735),
    [anon_sym___END__] = ACTIONS(5735),
    [anon_sym_LBRACE] = ACTIONS(5735),
    [anon_sym_RBRACE] = ACTIONS(5735),
    [anon_sym_RPAREN] = ACTIONS(5735),
    [anon_sym_DOT] = ACTIONS(5737),
    [anon_sym_COMMA] = ACTIONS(5735),
    [anon_sym_PIPE] = ACTIONS(5737),
    [anon_sym_SEMI] = ACTIONS(5735),
    [anon_sym_STAR_STAR] = ACTIONS(5735),
    [anon_sym_AMP] = ACTIONS(5737),
    [anon_sym_LT] = ACTIONS(5737),
    [anon_sym_end] = ACTIONS(5735),
    [anon_sym_if] = ACTIONS(5735),
    [anon_sym_unless] = ACTIONS(5735),
    [anon_sym_while] = ACTIONS(5735),
    [anon_sym_until] = ACTIONS(5735),
    [anon_sym_rescue] = ACTIONS(5735),
    [anon_sym_do] = ACTIONS(5735),
    [anon_sym_when] = ACTIONS(5735),
    [anon_sym_elsif] = ACTIONS(5735),
    [anon_sym_else] = ACTIONS(5735),
    [anon_sym_then] = ACTIONS(5735),
    [anon_sym_ensure] = ACTIONS(5735),
    [anon_sym_EQ_GT] = ACTIONS(5735),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_COLON_COLON2] = ACTIONS(5735),
    [anon_sym_AMP_DOT] = ACTIONS(5735),
    [anon_sym_QMARK] = ACTIONS(5735),
    [anon_sym_DOT_DOT] = ACTIONS(5737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5735),
    [anon_sym_and] = ACTIONS(5735),
    [anon_sym_or] = ACTIONS(5735),
    [anon_sym_PIPE_PIPE] = ACTIONS(5735),
    [anon_sym_AMP_AMP] = ACTIONS(5735),
    [anon_sym_LT_LT] = ACTIONS(5735),
    [anon_sym_GT_GT] = ACTIONS(5735),
    [anon_sym_EQ_EQ] = ACTIONS(5737),
    [anon_sym_BANG_EQ] = ACTIONS(5735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5735),
    [anon_sym_LT_EQ_GT] = ACTIONS(5735),
    [anon_sym_EQ_TILDE] = ACTIONS(5735),
    [anon_sym_BANG_TILDE] = ACTIONS(5735),
    [anon_sym_LT_EQ] = ACTIONS(5737),
    [anon_sym_GT] = ACTIONS(5737),
    [anon_sym_GT_EQ] = ACTIONS(5735),
    [anon_sym_CARET] = ACTIONS(5735),
    [anon_sym_PLUS] = ACTIONS(5735),
    [anon_sym_SLASH] = ACTIONS(5735),
    [anon_sym_PERCENT] = ACTIONS(5735),
    [sym_comment] = ACTIONS(87),
  },
  [1394] = {
    [sym__formal_parameter] = STATE(3469),
    [sym__simple_formal_parameter] = STATE(3469),
    [sym_destructured_parameter] = STATE(3469),
    [sym_splat_parameter] = STATE(3469),
    [sym_hash_splat_parameter] = STATE(3469),
    [sym_block_parameter] = STATE(3469),
    [sym_keyword_parameter] = STATE(3469),
    [sym_optional_parameter] = STATE(3469),
    [anon_sym_LPAREN] = ACTIONS(2447),
    [anon_sym_COMMA] = ACTIONS(5739),
    [anon_sym_PIPE] = ACTIONS(5741),
    [anon_sym_SEMI] = ACTIONS(5743),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [sym_identifier] = ACTIONS(5745),
    [sym_comment] = ACTIONS(87),
  },
  [1395] = {
    [anon_sym_RBRACE] = ACTIONS(5747),
    [sym_comment] = ACTIONS(87),
  },
  [1396] = {
    [sym__statements] = STATE(3471),
    [sym_begin_block] = STATE(489),
    [sym_end_block] = STATE(489),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(495),
    [aux_sym__statements_repeat1] = STATE(495),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(5747),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1397] = {
    [sym__formal_parameter] = STATE(3472),
    [sym__simple_formal_parameter] = STATE(3472),
    [sym_destructured_parameter] = STATE(3472),
    [sym_splat_parameter] = STATE(3472),
    [sym_hash_splat_parameter] = STATE(3472),
    [sym_block_parameter] = STATE(3472),
    [sym_keyword_parameter] = STATE(3472),
    [sym_optional_parameter] = STATE(3472),
    [anon_sym_LPAREN] = ACTIONS(2447),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [sym_identifier] = ACTIONS(2451),
    [sym_comment] = ACTIONS(87),
  },
  [1398] = {
    [anon_sym_LBRACE] = ACTIONS(5749),
    [anon_sym_do] = ACTIONS(5749),
    [sym_comment] = ACTIONS(87),
  },
  [1399] = {
    [anon_sym_RPAREN] = ACTIONS(2473),
    [anon_sym_COMMA] = ACTIONS(2473),
    [anon_sym_COLON] = ACTIONS(5751),
    [anon_sym_EQ] = ACTIONS(5753),
    [sym_comment] = ACTIONS(87),
  },
  [1400] = {
    [aux_sym_method_parameters_repeat1] = STATE(3477),
    [anon_sym_RPAREN] = ACTIONS(5755),
    [anon_sym_COMMA] = ACTIONS(5757),
    [sym_comment] = ACTIONS(87),
  },
  [1401] = {
    [anon_sym_LBRACE] = ACTIONS(5759),
    [anon_sym_RPAREN] = ACTIONS(5759),
    [anon_sym_COMMA] = ACTIONS(5759),
    [anon_sym_PIPE] = ACTIONS(5759),
    [anon_sym_SEMI] = ACTIONS(5759),
    [anon_sym_do] = ACTIONS(5759),
    [sym_comment] = ACTIONS(87),
  },
  [1402] = {
    [anon_sym_LBRACE] = ACTIONS(5761),
    [anon_sym_RPAREN] = ACTIONS(5761),
    [anon_sym_COMMA] = ACTIONS(5761),
    [anon_sym_PIPE] = ACTIONS(5761),
    [anon_sym_SEMI] = ACTIONS(5761),
    [anon_sym_do] = ACTIONS(5761),
    [sym_comment] = ACTIONS(87),
  },
  [1403] = {
    [anon_sym_LBRACE] = ACTIONS(5763),
    [anon_sym_RPAREN] = ACTIONS(5763),
    [anon_sym_COMMA] = ACTIONS(5763),
    [anon_sym_PIPE] = ACTIONS(5763),
    [anon_sym_SEMI] = ACTIONS(5763),
    [anon_sym_do] = ACTIONS(5763),
    [sym_comment] = ACTIONS(87),
  },
  [1404] = {
    [sym__formal_parameter] = STATE(3481),
    [sym__simple_formal_parameter] = STATE(3481),
    [sym_destructured_parameter] = STATE(3481),
    [sym_splat_parameter] = STATE(3481),
    [sym_hash_splat_parameter] = STATE(3481),
    [sym_block_parameter] = STATE(3481),
    [sym_keyword_parameter] = STATE(3481),
    [sym_optional_parameter] = STATE(3481),
    [anon_sym_LPAREN] = ACTIONS(2447),
    [anon_sym_COMMA] = ACTIONS(5765),
    [anon_sym_PIPE] = ACTIONS(5767),
    [anon_sym_SEMI] = ACTIONS(5769),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [sym_identifier] = ACTIONS(5745),
    [sym_comment] = ACTIONS(87),
  },
  [1405] = {
    [sym__line_break] = ACTIONS(5771),
    [sym__heredoc_body_start] = ACTIONS(5771),
    [sym__binary_minus] = ACTIONS(5771),
    [sym__binary_star] = ACTIONS(5771),
    [ts_builtin_sym_end] = ACTIONS(5771),
    [anon_sym___END__] = ACTIONS(5771),
    [anon_sym_LBRACE] = ACTIONS(5771),
    [anon_sym_RBRACE] = ACTIONS(5771),
    [anon_sym_RPAREN] = ACTIONS(5771),
    [anon_sym_DOT] = ACTIONS(5773),
    [anon_sym_COMMA] = ACTIONS(5771),
    [anon_sym_PIPE] = ACTIONS(5773),
    [anon_sym_SEMI] = ACTIONS(5771),
    [anon_sym_STAR_STAR] = ACTIONS(5771),
    [anon_sym_AMP] = ACTIONS(5773),
    [anon_sym_LT] = ACTIONS(5773),
    [anon_sym_end] = ACTIONS(5771),
    [anon_sym_if] = ACTIONS(5771),
    [anon_sym_unless] = ACTIONS(5771),
    [anon_sym_while] = ACTIONS(5771),
    [anon_sym_until] = ACTIONS(5771),
    [anon_sym_rescue] = ACTIONS(5771),
    [anon_sym_do] = ACTIONS(5771),
    [anon_sym_when] = ACTIONS(5771),
    [anon_sym_elsif] = ACTIONS(5771),
    [anon_sym_else] = ACTIONS(5771),
    [anon_sym_then] = ACTIONS(5771),
    [anon_sym_ensure] = ACTIONS(5771),
    [anon_sym_EQ_GT] = ACTIONS(5771),
    [anon_sym_LBRACK] = ACTIONS(5771),
    [anon_sym_COLON_COLON2] = ACTIONS(5771),
    [anon_sym_AMP_DOT] = ACTIONS(5771),
    [anon_sym_QMARK] = ACTIONS(5771),
    [anon_sym_DOT_DOT] = ACTIONS(5773),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5771),
    [anon_sym_and] = ACTIONS(5771),
    [anon_sym_or] = ACTIONS(5771),
    [anon_sym_PIPE_PIPE] = ACTIONS(5771),
    [anon_sym_AMP_AMP] = ACTIONS(5771),
    [anon_sym_LT_LT] = ACTIONS(5771),
    [anon_sym_GT_GT] = ACTIONS(5771),
    [anon_sym_EQ_EQ] = ACTIONS(5773),
    [anon_sym_BANG_EQ] = ACTIONS(5771),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5771),
    [anon_sym_LT_EQ_GT] = ACTIONS(5771),
    [anon_sym_EQ_TILDE] = ACTIONS(5771),
    [anon_sym_BANG_TILDE] = ACTIONS(5771),
    [anon_sym_LT_EQ] = ACTIONS(5773),
    [anon_sym_GT] = ACTIONS(5773),
    [anon_sym_GT_EQ] = ACTIONS(5771),
    [anon_sym_CARET] = ACTIONS(5771),
    [anon_sym_PLUS] = ACTIONS(5771),
    [anon_sym_SLASH] = ACTIONS(5771),
    [anon_sym_PERCENT] = ACTIONS(5771),
    [sym_comment] = ACTIONS(87),
  },
  [1406] = {
    [anon_sym_end] = ACTIONS(5775),
    [sym_comment] = ACTIONS(87),
  },
  [1407] = {
    [sym__statements] = STATE(3483),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_heredoc_body] = STATE(3484),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [sym__terminator] = STATE(3484),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__line_break] = ACTIONS(5777),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(5777),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(5779),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1408] = {
    [sym__statements] = STATE(3483),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_block_parameters] = STATE(3485),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(5779),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1409] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(3493),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(3496),
    [sym_scope_resolution] = STATE(3494),
    [sym_call] = STATE(3494),
    [sym_method_call] = STATE(3496),
    [sym_assignment] = STATE(3493),
    [sym_operator_assignment] = STATE(3493),
    [sym_conditional] = STATE(3493),
    [sym_range] = STATE(3493),
    [sym_binary] = STATE(3493),
    [sym_unary] = STATE(3493),
    [sym_left_assignment_list] = STATE(3495),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3496),
    [sym__variable] = STATE(3494),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(3496),
    [sym_false] = STATE(3496),
    [sym_nil] = STATE(3496),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(5781),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_COMMA] = ACTIONS(5783),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5785),
    [anon_sym_yield] = ACTIONS(5787),
    [anon_sym_break] = ACTIONS(5789),
    [anon_sym_next] = ACTIONS(5791),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_do] = ACTIONS(5793),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5795),
    [anon_sym_defined_QMARK] = ACTIONS(5797),
    [anon_sym_not] = ACTIONS(5799),
    [anon_sym_BANG] = ACTIONS(5801),
    [anon_sym_TILDE] = ACTIONS(5801),
    [sym_constant] = ACTIONS(5803),
    [sym_identifier] = ACTIONS(5803),
    [sym_instance_variable] = ACTIONS(5805),
    [sym_class_variable] = ACTIONS(5805),
    [sym_global_variable] = ACTIONS(5805),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(5803),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(5803),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1410] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(3498),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(3496),
    [sym_scope_resolution] = STATE(3494),
    [sym_call] = STATE(3494),
    [sym_method_call] = STATE(3496),
    [sym_assignment] = STATE(3498),
    [sym_operator_assignment] = STATE(3498),
    [sym_conditional] = STATE(3498),
    [sym_range] = STATE(3498),
    [sym_binary] = STATE(3498),
    [sym_unary] = STATE(3498),
    [sym_left_assignment_list] = STATE(3495),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3496),
    [sym__variable] = STATE(3494),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(3496),
    [sym_false] = STATE(3496),
    [sym_nil] = STATE(3496),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(5781),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5785),
    [anon_sym_yield] = ACTIONS(5787),
    [anon_sym_break] = ACTIONS(5789),
    [anon_sym_next] = ACTIONS(5791),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5795),
    [anon_sym_defined_QMARK] = ACTIONS(5797),
    [anon_sym_not] = ACTIONS(5799),
    [anon_sym_BANG] = ACTIONS(5801),
    [anon_sym_TILDE] = ACTIONS(5801),
    [sym_constant] = ACTIONS(5803),
    [sym_identifier] = ACTIONS(5803),
    [sym_instance_variable] = ACTIONS(5805),
    [sym_class_variable] = ACTIONS(5805),
    [sym_global_variable] = ACTIONS(5805),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(5803),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(5803),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1411] = {
    [sym__line_break] = ACTIONS(5807),
    [sym__heredoc_body_start] = ACTIONS(5807),
    [sym__binary_minus] = ACTIONS(5807),
    [sym__binary_star] = ACTIONS(5807),
    [ts_builtin_sym_end] = ACTIONS(5807),
    [anon_sym___END__] = ACTIONS(5807),
    [anon_sym_LBRACE] = ACTIONS(5807),
    [anon_sym_RBRACE] = ACTIONS(5807),
    [anon_sym_RPAREN] = ACTIONS(5807),
    [anon_sym_DOT] = ACTIONS(5809),
    [anon_sym_COMMA] = ACTIONS(5807),
    [anon_sym_PIPE] = ACTIONS(5809),
    [anon_sym_SEMI] = ACTIONS(5807),
    [anon_sym_STAR_STAR] = ACTIONS(5807),
    [anon_sym_AMP] = ACTIONS(5809),
    [anon_sym_LT] = ACTIONS(5809),
    [anon_sym_end] = ACTIONS(5807),
    [anon_sym_if] = ACTIONS(5807),
    [anon_sym_unless] = ACTIONS(5807),
    [anon_sym_while] = ACTIONS(5807),
    [anon_sym_until] = ACTIONS(5807),
    [anon_sym_rescue] = ACTIONS(5807),
    [anon_sym_do] = ACTIONS(5807),
    [anon_sym_when] = ACTIONS(5807),
    [anon_sym_elsif] = ACTIONS(5807),
    [anon_sym_else] = ACTIONS(5807),
    [anon_sym_then] = ACTIONS(5807),
    [anon_sym_ensure] = ACTIONS(5807),
    [anon_sym_EQ_GT] = ACTIONS(5807),
    [anon_sym_LBRACK] = ACTIONS(5807),
    [anon_sym_COLON_COLON2] = ACTIONS(5807),
    [anon_sym_AMP_DOT] = ACTIONS(5807),
    [anon_sym_QMARK] = ACTIONS(5807),
    [anon_sym_DOT_DOT] = ACTIONS(5809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5807),
    [anon_sym_and] = ACTIONS(5807),
    [anon_sym_or] = ACTIONS(5807),
    [anon_sym_PIPE_PIPE] = ACTIONS(5807),
    [anon_sym_AMP_AMP] = ACTIONS(5807),
    [anon_sym_LT_LT] = ACTIONS(5807),
    [anon_sym_GT_GT] = ACTIONS(5807),
    [anon_sym_EQ_EQ] = ACTIONS(5809),
    [anon_sym_BANG_EQ] = ACTIONS(5807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5807),
    [anon_sym_LT_EQ_GT] = ACTIONS(5807),
    [anon_sym_EQ_TILDE] = ACTIONS(5807),
    [anon_sym_BANG_TILDE] = ACTIONS(5807),
    [anon_sym_LT_EQ] = ACTIONS(5809),
    [anon_sym_GT] = ACTIONS(5809),
    [anon_sym_GT_EQ] = ACTIONS(5807),
    [anon_sym_CARET] = ACTIONS(5807),
    [anon_sym_PLUS] = ACTIONS(5807),
    [anon_sym_SLASH] = ACTIONS(5807),
    [anon_sym_PERCENT] = ACTIONS(5807),
    [sym_comment] = ACTIONS(87),
  },
  [1412] = {
    [sym__simple_formal_parameter] = STATE(3499),
    [sym_splat_parameter] = STATE(3499),
    [sym_hash_splat_parameter] = STATE(3499),
    [sym_block_parameter] = STATE(3499),
    [sym_keyword_parameter] = STATE(3499),
    [sym_optional_parameter] = STATE(3499),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [sym_identifier] = ACTIONS(5811),
    [sym_comment] = ACTIONS(87),
  },
  [1413] = {
    [aux_sym_lambda_parameters_repeat1] = STATE(3500),
    [anon_sym_LBRACE] = ACTIONS(5749),
    [anon_sym_COMMA] = ACTIONS(2483),
    [anon_sym_do] = ACTIONS(5749),
    [sym_comment] = ACTIONS(87),
  },
  [1414] = {
    [sym_uninterpreted] = ACTIONS(5813),
    [sym_comment] = ACTIONS(109),
  },
  [1415] = {
    [sym__line_break] = ACTIONS(5815),
    [sym__heredoc_body_start] = ACTIONS(5815),
    [sym__binary_minus] = ACTIONS(703),
    [sym__binary_star] = ACTIONS(705),
    [ts_builtin_sym_end] = ACTIONS(5815),
    [anon_sym___END__] = ACTIONS(5815),
    [anon_sym_PIPE] = ACTIONS(707),
    [anon_sym_SEMI] = ACTIONS(5815),
    [anon_sym_STAR_STAR] = ACTIONS(705),
    [anon_sym_AMP] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(5815),
    [anon_sym_unless] = ACTIONS(5815),
    [anon_sym_while] = ACTIONS(5815),
    [anon_sym_until] = ACTIONS(5815),
    [anon_sym_rescue] = ACTIONS(5815),
    [anon_sym_QMARK] = ACTIONS(713),
    [anon_sym_DOT_DOT] = ACTIONS(715),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(717),
    [anon_sym_and] = ACTIONS(719),
    [anon_sym_or] = ACTIONS(719),
    [anon_sym_PIPE_PIPE] = ACTIONS(721),
    [anon_sym_AMP_AMP] = ACTIONS(721),
    [anon_sym_LT_LT] = ACTIONS(723),
    [anon_sym_GT_GT] = ACTIONS(723),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(721),
    [anon_sym_LT_EQ_GT] = ACTIONS(721),
    [anon_sym_EQ_TILDE] = ACTIONS(721),
    [anon_sym_BANG_TILDE] = ACTIONS(721),
    [anon_sym_LT_EQ] = ACTIONS(711),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_EQ] = ACTIONS(727),
    [anon_sym_CARET] = ACTIONS(729),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_SLASH] = ACTIONS(705),
    [anon_sym_PERCENT] = ACTIONS(705),
    [sym_comment] = ACTIONS(87),
  },
  [1416] = {
    [sym__line_break] = ACTIONS(5817),
    [sym__heredoc_body_start] = ACTIONS(5817),
    [sym__binary_minus] = ACTIONS(703),
    [sym__binary_star] = ACTIONS(705),
    [ts_builtin_sym_end] = ACTIONS(5817),
    [anon_sym___END__] = ACTIONS(5817),
    [anon_sym_PIPE] = ACTIONS(707),
    [anon_sym_SEMI] = ACTIONS(5817),
    [anon_sym_STAR_STAR] = ACTIONS(705),
    [anon_sym_AMP] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(5817),
    [anon_sym_unless] = ACTIONS(5817),
    [anon_sym_while] = ACTIONS(5817),
    [anon_sym_until] = ACTIONS(5817),
    [anon_sym_rescue] = ACTIONS(5817),
    [anon_sym_QMARK] = ACTIONS(713),
    [anon_sym_DOT_DOT] = ACTIONS(715),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(717),
    [anon_sym_and] = ACTIONS(719),
    [anon_sym_or] = ACTIONS(719),
    [anon_sym_PIPE_PIPE] = ACTIONS(721),
    [anon_sym_AMP_AMP] = ACTIONS(721),
    [anon_sym_LT_LT] = ACTIONS(723),
    [anon_sym_GT_GT] = ACTIONS(723),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(721),
    [anon_sym_LT_EQ_GT] = ACTIONS(721),
    [anon_sym_EQ_TILDE] = ACTIONS(721),
    [anon_sym_BANG_TILDE] = ACTIONS(721),
    [anon_sym_LT_EQ] = ACTIONS(711),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_EQ] = ACTIONS(727),
    [anon_sym_CARET] = ACTIONS(729),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_SLASH] = ACTIONS(705),
    [anon_sym_PERCENT] = ACTIONS(705),
    [sym_comment] = ACTIONS(87),
  },
  [1417] = {
    [sym__line_break] = ACTIONS(5819),
    [sym__heredoc_body_start] = ACTIONS(5819),
    [sym__binary_minus] = ACTIONS(703),
    [sym__binary_star] = ACTIONS(705),
    [ts_builtin_sym_end] = ACTIONS(5819),
    [anon_sym___END__] = ACTIONS(5819),
    [anon_sym_PIPE] = ACTIONS(707),
    [anon_sym_SEMI] = ACTIONS(5819),
    [anon_sym_STAR_STAR] = ACTIONS(705),
    [anon_sym_AMP] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(5819),
    [anon_sym_unless] = ACTIONS(5819),
    [anon_sym_while] = ACTIONS(5819),
    [anon_sym_until] = ACTIONS(5819),
    [anon_sym_rescue] = ACTIONS(5819),
    [anon_sym_QMARK] = ACTIONS(713),
    [anon_sym_DOT_DOT] = ACTIONS(715),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(717),
    [anon_sym_and] = ACTIONS(719),
    [anon_sym_or] = ACTIONS(719),
    [anon_sym_PIPE_PIPE] = ACTIONS(721),
    [anon_sym_AMP_AMP] = ACTIONS(721),
    [anon_sym_LT_LT] = ACTIONS(723),
    [anon_sym_GT_GT] = ACTIONS(723),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(721),
    [anon_sym_LT_EQ_GT] = ACTIONS(721),
    [anon_sym_EQ_TILDE] = ACTIONS(721),
    [anon_sym_BANG_TILDE] = ACTIONS(721),
    [anon_sym_LT_EQ] = ACTIONS(711),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_EQ] = ACTIONS(727),
    [anon_sym_CARET] = ACTIONS(729),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_SLASH] = ACTIONS(705),
    [anon_sym_PERCENT] = ACTIONS(705),
    [sym_comment] = ACTIONS(87),
  },
  [1418] = {
    [sym__line_break] = ACTIONS(5821),
    [sym__heredoc_body_start] = ACTIONS(5821),
    [sym__binary_minus] = ACTIONS(703),
    [sym__binary_star] = ACTIONS(705),
    [ts_builtin_sym_end] = ACTIONS(5821),
    [anon_sym___END__] = ACTIONS(5821),
    [anon_sym_PIPE] = ACTIONS(707),
    [anon_sym_SEMI] = ACTIONS(5821),
    [anon_sym_STAR_STAR] = ACTIONS(705),
    [anon_sym_AMP] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(5821),
    [anon_sym_unless] = ACTIONS(5821),
    [anon_sym_while] = ACTIONS(5821),
    [anon_sym_until] = ACTIONS(5821),
    [anon_sym_rescue] = ACTIONS(5821),
    [anon_sym_QMARK] = ACTIONS(713),
    [anon_sym_DOT_DOT] = ACTIONS(715),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(717),
    [anon_sym_and] = ACTIONS(719),
    [anon_sym_or] = ACTIONS(719),
    [anon_sym_PIPE_PIPE] = ACTIONS(721),
    [anon_sym_AMP_AMP] = ACTIONS(721),
    [anon_sym_LT_LT] = ACTIONS(723),
    [anon_sym_GT_GT] = ACTIONS(723),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(721),
    [anon_sym_LT_EQ_GT] = ACTIONS(721),
    [anon_sym_EQ_TILDE] = ACTIONS(721),
    [anon_sym_BANG_TILDE] = ACTIONS(721),
    [anon_sym_LT_EQ] = ACTIONS(711),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_EQ] = ACTIONS(727),
    [anon_sym_CARET] = ACTIONS(729),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_SLASH] = ACTIONS(705),
    [anon_sym_PERCENT] = ACTIONS(705),
    [sym_comment] = ACTIONS(87),
  },
  [1419] = {
    [sym__line_break] = ACTIONS(5823),
    [sym__heredoc_body_start] = ACTIONS(5823),
    [sym__binary_minus] = ACTIONS(703),
    [sym__binary_star] = ACTIONS(705),
    [ts_builtin_sym_end] = ACTIONS(5823),
    [anon_sym___END__] = ACTIONS(5823),
    [anon_sym_PIPE] = ACTIONS(707),
    [anon_sym_SEMI] = ACTIONS(5823),
    [anon_sym_STAR_STAR] = ACTIONS(705),
    [anon_sym_AMP] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(5823),
    [anon_sym_unless] = ACTIONS(5823),
    [anon_sym_while] = ACTIONS(5823),
    [anon_sym_until] = ACTIONS(5823),
    [anon_sym_rescue] = ACTIONS(5823),
    [anon_sym_QMARK] = ACTIONS(713),
    [anon_sym_DOT_DOT] = ACTIONS(715),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(717),
    [anon_sym_and] = ACTIONS(719),
    [anon_sym_or] = ACTIONS(719),
    [anon_sym_PIPE_PIPE] = ACTIONS(721),
    [anon_sym_AMP_AMP] = ACTIONS(721),
    [anon_sym_LT_LT] = ACTIONS(723),
    [anon_sym_GT_GT] = ACTIONS(723),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(721),
    [anon_sym_LT_EQ_GT] = ACTIONS(721),
    [anon_sym_EQ_TILDE] = ACTIONS(721),
    [anon_sym_BANG_TILDE] = ACTIONS(721),
    [anon_sym_LT_EQ] = ACTIONS(711),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_EQ] = ACTIONS(727),
    [anon_sym_CARET] = ACTIONS(729),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_SLASH] = ACTIONS(705),
    [anon_sym_PERCENT] = ACTIONS(705),
    [sym_comment] = ACTIONS(87),
  },
  [1420] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(705),
    [ts_builtin_sym_end] = ACTIONS(5825),
    [anon_sym___END__] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(705),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(705),
    [anon_sym_PERCENT] = ACTIONS(705),
    [sym_comment] = ACTIONS(87),
  },
  [1421] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [ts_builtin_sym_end] = ACTIONS(5825),
    [anon_sym___END__] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(705),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [1422] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(703),
    [sym__binary_star] = ACTIONS(705),
    [ts_builtin_sym_end] = ACTIONS(5825),
    [anon_sym___END__] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(705),
    [anon_sym_AMP] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(723),
    [anon_sym_GT_GT] = ACTIONS(723),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_SLASH] = ACTIONS(705),
    [anon_sym_PERCENT] = ACTIONS(705),
    [sym_comment] = ACTIONS(87),
  },
  [1423] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(703),
    [sym__binary_star] = ACTIONS(705),
    [ts_builtin_sym_end] = ACTIONS(5825),
    [anon_sym___END__] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(705),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(723),
    [anon_sym_GT_GT] = ACTIONS(723),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_SLASH] = ACTIONS(705),
    [anon_sym_PERCENT] = ACTIONS(705),
    [sym_comment] = ACTIONS(87),
  },
  [1424] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(703),
    [sym__binary_star] = ACTIONS(705),
    [ts_builtin_sym_end] = ACTIONS(5825),
    [anon_sym___END__] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(707),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(705),
    [anon_sym_AMP] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(723),
    [anon_sym_GT_GT] = ACTIONS(723),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(729),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_SLASH] = ACTIONS(705),
    [anon_sym_PERCENT] = ACTIONS(705),
    [sym_comment] = ACTIONS(87),
  },
  [1425] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(3503),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(5829),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [1426] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(3504),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(3504),
    [sym_operator_assignment] = STATE(3504),
    [sym_conditional] = STATE(3504),
    [sym_range] = STATE(3504),
    [sym_binary] = STATE(3504),
    [sym_unary] = STATE(3504),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1427] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(3517),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(3522),
    [sym_scope_resolution] = STATE(3518),
    [sym_call] = STATE(3518),
    [sym_method_call] = STATE(3522),
    [sym_argument_list] = STATE(563),
    [sym__argument_list_with_parens] = STATE(3519),
    [sym__argument] = STATE(3520),
    [sym_splat_argument] = STATE(3520),
    [sym_hash_splat_argument] = STATE(3520),
    [sym_block_argument] = STATE(3520),
    [sym_assignment] = STATE(3517),
    [sym_operator_assignment] = STATE(3517),
    [sym_conditional] = STATE(3517),
    [sym_range] = STATE(3517),
    [sym_binary] = STATE(3517),
    [sym_unary] = STATE(3517),
    [sym_left_assignment_list] = STATE(3521),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3522),
    [sym__variable] = STATE(3518),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(3522),
    [sym_false] = STATE(3522),
    [sym_nil] = STATE(3522),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(3523),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(3520),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(5831),
    [sym__splat_star] = ACTIONS(5833),
    [sym__unary_minus] = ACTIONS(5835),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(5837),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5839),
    [anon_sym_yield] = ACTIONS(5841),
    [anon_sym_break] = ACTIONS(5843),
    [anon_sym_next] = ACTIONS(5845),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_COLON2] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(5847),
    [anon_sym_not] = ACTIONS(5849),
    [anon_sym_BANG] = ACTIONS(5851),
    [anon_sym_TILDE] = ACTIONS(5853),
    [sym_constant] = ACTIONS(5855),
    [sym_identifier] = ACTIONS(5855),
    [sym_instance_variable] = ACTIONS(5857),
    [sym_class_variable] = ACTIONS(5857),
    [sym_global_variable] = ACTIONS(5857),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5859),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5859),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1428] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(3517),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(3522),
    [sym_scope_resolution] = STATE(3518),
    [sym_call] = STATE(3518),
    [sym_method_call] = STATE(3522),
    [sym_argument_list] = STATE(569),
    [sym__argument_list_with_parens] = STATE(3519),
    [sym__argument] = STATE(3520),
    [sym_splat_argument] = STATE(3520),
    [sym_hash_splat_argument] = STATE(3520),
    [sym_block_argument] = STATE(3520),
    [sym_assignment] = STATE(3517),
    [sym_operator_assignment] = STATE(3517),
    [sym_conditional] = STATE(3517),
    [sym_range] = STATE(3517),
    [sym_binary] = STATE(3517),
    [sym_unary] = STATE(3517),
    [sym_left_assignment_list] = STATE(3521),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3522),
    [sym__variable] = STATE(3518),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(3522),
    [sym_false] = STATE(3522),
    [sym_nil] = STATE(3522),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(3523),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(3520),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(5831),
    [sym__splat_star] = ACTIONS(5833),
    [sym__unary_minus] = ACTIONS(5835),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(5837),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5839),
    [anon_sym_yield] = ACTIONS(5841),
    [anon_sym_break] = ACTIONS(5843),
    [anon_sym_next] = ACTIONS(5845),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_COLON2] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(5847),
    [anon_sym_not] = ACTIONS(5849),
    [anon_sym_BANG] = ACTIONS(5851),
    [anon_sym_TILDE] = ACTIONS(5853),
    [sym_constant] = ACTIONS(5855),
    [sym_identifier] = ACTIONS(5855),
    [sym_instance_variable] = ACTIONS(5857),
    [sym_class_variable] = ACTIONS(5857),
    [sym_global_variable] = ACTIONS(5857),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5859),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5859),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1429] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(3517),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(3522),
    [sym_scope_resolution] = STATE(3518),
    [sym_call] = STATE(3518),
    [sym_method_call] = STATE(3522),
    [sym_argument_list] = STATE(570),
    [sym__argument_list_with_parens] = STATE(3519),
    [sym__argument] = STATE(3520),
    [sym_splat_argument] = STATE(3520),
    [sym_hash_splat_argument] = STATE(3520),
    [sym_block_argument] = STATE(3520),
    [sym_assignment] = STATE(3517),
    [sym_operator_assignment] = STATE(3517),
    [sym_conditional] = STATE(3517),
    [sym_range] = STATE(3517),
    [sym_binary] = STATE(3517),
    [sym_unary] = STATE(3517),
    [sym_left_assignment_list] = STATE(3521),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3522),
    [sym__variable] = STATE(3518),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(3522),
    [sym_false] = STATE(3522),
    [sym_nil] = STATE(3522),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(3523),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(3520),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(5831),
    [sym__splat_star] = ACTIONS(5833),
    [sym__unary_minus] = ACTIONS(5835),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(5837),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5839),
    [anon_sym_yield] = ACTIONS(5841),
    [anon_sym_break] = ACTIONS(5843),
    [anon_sym_next] = ACTIONS(5845),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_COLON2] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(5847),
    [anon_sym_not] = ACTIONS(5849),
    [anon_sym_BANG] = ACTIONS(5851),
    [anon_sym_TILDE] = ACTIONS(5853),
    [sym_constant] = ACTIONS(5855),
    [sym_identifier] = ACTIONS(5855),
    [sym_instance_variable] = ACTIONS(5857),
    [sym_class_variable] = ACTIONS(5857),
    [sym_global_variable] = ACTIONS(5857),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5859),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5859),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1430] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(3517),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(3522),
    [sym_scope_resolution] = STATE(3518),
    [sym_call] = STATE(3518),
    [sym_method_call] = STATE(3522),
    [sym_argument_list] = STATE(571),
    [sym__argument_list_with_parens] = STATE(3519),
    [sym__argument] = STATE(3520),
    [sym_splat_argument] = STATE(3520),
    [sym_hash_splat_argument] = STATE(3520),
    [sym_block_argument] = STATE(3520),
    [sym_assignment] = STATE(3517),
    [sym_operator_assignment] = STATE(3517),
    [sym_conditional] = STATE(3517),
    [sym_range] = STATE(3517),
    [sym_binary] = STATE(3517),
    [sym_unary] = STATE(3517),
    [sym_left_assignment_list] = STATE(3521),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3522),
    [sym__variable] = STATE(3518),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(3522),
    [sym_false] = STATE(3522),
    [sym_nil] = STATE(3522),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(3523),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(3520),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(5831),
    [sym__splat_star] = ACTIONS(5833),
    [sym__unary_minus] = ACTIONS(5835),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(5837),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5839),
    [anon_sym_yield] = ACTIONS(5841),
    [anon_sym_break] = ACTIONS(5843),
    [anon_sym_next] = ACTIONS(5845),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_COLON2] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(5847),
    [anon_sym_not] = ACTIONS(5849),
    [anon_sym_BANG] = ACTIONS(5851),
    [anon_sym_TILDE] = ACTIONS(5853),
    [sym_constant] = ACTIONS(5855),
    [sym_identifier] = ACTIONS(5855),
    [sym_instance_variable] = ACTIONS(5857),
    [sym_class_variable] = ACTIONS(5857),
    [sym_global_variable] = ACTIONS(5857),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5859),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5859),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1431] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(3524),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(3524),
    [sym_operator_assignment] = STATE(3524),
    [sym_conditional] = STATE(3524),
    [sym_range] = STATE(3524),
    [sym_binary] = STATE(3524),
    [sym_unary] = STATE(3524),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1432] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(586),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(586),
    [sym_operator_assignment] = STATE(586),
    [sym_conditional] = STATE(586),
    [sym_range] = STATE(586),
    [sym_binary] = STATE(586),
    [sym_unary] = STATE(586),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1433] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(5873),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [1434] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3548),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3553),
    [sym_scope_resolution] = STATE(3549),
    [sym_call] = STATE(3549),
    [sym_method_call] = STATE(3553),
    [sym_argument_list] = STATE(1681),
    [sym__argument_list_with_parens] = STATE(3550),
    [sym__argument] = STATE(3551),
    [sym_splat_argument] = STATE(3551),
    [sym_hash_splat_argument] = STATE(3551),
    [sym_block_argument] = STATE(3551),
    [sym_do_block] = STATE(1684),
    [sym_block] = STATE(1684),
    [sym_assignment] = STATE(3548),
    [sym_operator_assignment] = STATE(3548),
    [sym_conditional] = STATE(3548),
    [sym_range] = STATE(3548),
    [sym_binary] = STATE(3548),
    [sym_unary] = STATE(3548),
    [sym_left_assignment_list] = STATE(3552),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3553),
    [sym__variable] = STATE(3549),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3553),
    [sym_false] = STATE(3553),
    [sym_nil] = STATE(3553),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3554),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(3551),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(5891),
    [sym__splat_star] = ACTIONS(5893),
    [sym__unary_minus] = ACTIONS(5895),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(5897),
    [anon_sym_LBRACE] = ACTIONS(2996),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5899),
    [anon_sym_yield] = ACTIONS(5901),
    [anon_sym_break] = ACTIONS(5903),
    [anon_sym_next] = ACTIONS(5905),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(3006),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(5907),
    [anon_sym_not] = ACTIONS(5909),
    [anon_sym_BANG] = ACTIONS(5911),
    [anon_sym_TILDE] = ACTIONS(5913),
    [sym_constant] = ACTIONS(5915),
    [sym_identifier] = ACTIONS(5915),
    [sym_instance_variable] = ACTIONS(5917),
    [sym_class_variable] = ACTIONS(5917),
    [sym_global_variable] = ACTIONS(5917),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5919),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5919),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1435] = {
    [anon_sym_EQ] = ACTIONS(5921),
    [sym_comment] = ACTIONS(87),
  },
  [1436] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(5923),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(5925),
    [anon_sym_DASH_EQ] = ACTIONS(5925),
    [anon_sym_STAR_EQ] = ACTIONS(5925),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5925),
    [anon_sym_SLASH_EQ] = ACTIONS(5925),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5925),
    [anon_sym_PIPE_EQ] = ACTIONS(5925),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5925),
    [anon_sym_AMP_EQ] = ACTIONS(5925),
    [anon_sym_PERCENT_EQ] = ACTIONS(5925),
    [anon_sym_GT_GT_EQ] = ACTIONS(5925),
    [anon_sym_LT_LT_EQ] = ACTIONS(5925),
    [anon_sym_CARET_EQ] = ACTIONS(5925),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1437] = {
    [sym_string] = STATE(3557),
    [aux_sym_chained_string_repeat1] = STATE(3557),
    [sym__string_start] = ACTIONS(2495),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [1438] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(703),
    [sym__binary_star] = ACTIONS(705),
    [ts_builtin_sym_end] = ACTIONS(5927),
    [anon_sym___END__] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(707),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(705),
    [anon_sym_AMP] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(715),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(717),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(721),
    [anon_sym_AMP_AMP] = ACTIONS(721),
    [anon_sym_LT_LT] = ACTIONS(723),
    [anon_sym_GT_GT] = ACTIONS(723),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(721),
    [anon_sym_LT_EQ_GT] = ACTIONS(721),
    [anon_sym_EQ_TILDE] = ACTIONS(721),
    [anon_sym_BANG_TILDE] = ACTIONS(721),
    [anon_sym_LT_EQ] = ACTIONS(711),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_EQ] = ACTIONS(727),
    [anon_sym_CARET] = ACTIONS(729),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_SLASH] = ACTIONS(705),
    [anon_sym_PERCENT] = ACTIONS(705),
    [sym_comment] = ACTIONS(87),
  },
  [1439] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(703),
    [sym__binary_star] = ACTIONS(705),
    [ts_builtin_sym_end] = ACTIONS(5825),
    [anon_sym___END__] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(707),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(705),
    [anon_sym_AMP] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(713),
    [anon_sym_DOT_DOT] = ACTIONS(715),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(717),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(721),
    [anon_sym_AMP_AMP] = ACTIONS(721),
    [anon_sym_LT_LT] = ACTIONS(723),
    [anon_sym_GT_GT] = ACTIONS(723),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(721),
    [anon_sym_LT_EQ_GT] = ACTIONS(721),
    [anon_sym_EQ_TILDE] = ACTIONS(721),
    [anon_sym_BANG_TILDE] = ACTIONS(721),
    [anon_sym_LT_EQ] = ACTIONS(711),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_EQ] = ACTIONS(727),
    [anon_sym_CARET] = ACTIONS(729),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_SLASH] = ACTIONS(705),
    [anon_sym_PERCENT] = ACTIONS(705),
    [sym_comment] = ACTIONS(87),
  },
  [1440] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(703),
    [sym__binary_star] = ACTIONS(705),
    [ts_builtin_sym_end] = ACTIONS(5825),
    [anon_sym___END__] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(707),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(705),
    [anon_sym_AMP] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(723),
    [anon_sym_GT_GT] = ACTIONS(723),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(721),
    [anon_sym_LT_EQ_GT] = ACTIONS(721),
    [anon_sym_EQ_TILDE] = ACTIONS(721),
    [anon_sym_BANG_TILDE] = ACTIONS(721),
    [anon_sym_LT_EQ] = ACTIONS(711),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_EQ] = ACTIONS(727),
    [anon_sym_CARET] = ACTIONS(729),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_SLASH] = ACTIONS(705),
    [anon_sym_PERCENT] = ACTIONS(705),
    [sym_comment] = ACTIONS(87),
  },
  [1441] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(703),
    [sym__binary_star] = ACTIONS(705),
    [ts_builtin_sym_end] = ACTIONS(5825),
    [anon_sym___END__] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(705),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_SLASH] = ACTIONS(705),
    [anon_sym_PERCENT] = ACTIONS(705),
    [sym_comment] = ACTIONS(87),
  },
  [1442] = {
    [sym_interpolation] = STATE(3559),
    [aux_sym_heredoc_body_repeat1] = STATE(3559),
    [sym__heredoc_content] = ACTIONS(5929),
    [sym_heredoc_end] = ACTIONS(5931),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(5929),
  },
  [1443] = {
    [sym__line_break] = ACTIONS(1263),
    [sym__simple_symbol] = ACTIONS(1263),
    [sym__string_start] = ACTIONS(1263),
    [sym__symbol_start] = ACTIONS(1263),
    [sym__subshell_start] = ACTIONS(1263),
    [sym__regex_start] = ACTIONS(1263),
    [sym__string_array_start] = ACTIONS(1263),
    [sym__symbol_array_start] = ACTIONS(1263),
    [sym__heredoc_body_start] = ACTIONS(1263),
    [sym_heredoc_beginning] = ACTIONS(1263),
    [sym__block_ampersand] = ACTIONS(1263),
    [sym__splat_star] = ACTIONS(1263),
    [sym__unary_minus] = ACTIONS(1263),
    [sym__binary_minus] = ACTIONS(1263),
    [sym__binary_star] = ACTIONS(1263),
    [sym__identifier_hash_key] = ACTIONS(1263),
    [ts_builtin_sym_end] = ACTIONS(1263),
    [anon_sym___END__] = ACTIONS(1265),
    [anon_sym_LBRACE] = ACTIONS(1263),
    [anon_sym_RBRACE] = ACTIONS(1263),
    [anon_sym_def] = ACTIONS(1265),
    [anon_sym_LPAREN] = ACTIONS(1265),
    [anon_sym_RPAREN] = ACTIONS(1263),
    [anon_sym_DOT] = ACTIONS(1265),
    [anon_sym_COLON_COLON] = ACTIONS(1265),
    [anon_sym_COMMA] = ACTIONS(1263),
    [anon_sym_PIPE] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_STAR_STAR] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1265),
    [anon_sym_EQ] = ACTIONS(1265),
    [anon_sym_class] = ACTIONS(1265),
    [anon_sym_LT] = ACTIONS(1265),
    [anon_sym_module] = ACTIONS(1265),
    [anon_sym_end] = ACTIONS(1265),
    [anon_sym_return] = ACTIONS(1265),
    [anon_sym_yield] = ACTIONS(1265),
    [anon_sym_break] = ACTIONS(1265),
    [anon_sym_next] = ACTIONS(1265),
    [sym_redo] = ACTIONS(1265),
    [sym_retry] = ACTIONS(1265),
    [anon_sym_if] = ACTIONS(1265),
    [anon_sym_unless] = ACTIONS(1265),
    [anon_sym_while] = ACTIONS(1265),
    [anon_sym_until] = ACTIONS(1265),
    [anon_sym_rescue] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1265),
    [anon_sym_do] = ACTIONS(1265),
    [anon_sym_case] = ACTIONS(1265),
    [anon_sym_when] = ACTIONS(1265),
    [anon_sym_elsif] = ACTIONS(1265),
    [anon_sym_else] = ACTIONS(1265),
    [anon_sym_then] = ACTIONS(1265),
    [anon_sym_begin] = ACTIONS(1265),
    [anon_sym_ensure] = ACTIONS(1265),
    [anon_sym_LBRACK] = ACTIONS(1263),
    [anon_sym_COLON_COLON2] = ACTIONS(1263),
    [anon_sym_AMP_DOT] = ACTIONS(1263),
    [anon_sym_LPAREN2] = ACTIONS(1263),
    [anon_sym_PLUS_EQ] = ACTIONS(1263),
    [anon_sym_DASH_EQ] = ACTIONS(1263),
    [anon_sym_STAR_EQ] = ACTIONS(1263),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1263),
    [anon_sym_SLASH_EQ] = ACTIONS(1263),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1263),
    [anon_sym_PIPE_EQ] = ACTIONS(1263),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1263),
    [anon_sym_AMP_EQ] = ACTIONS(1263),
    [anon_sym_PERCENT_EQ] = ACTIONS(1263),
    [anon_sym_GT_GT_EQ] = ACTIONS(1263),
    [anon_sym_LT_LT_EQ] = ACTIONS(1263),
    [anon_sym_CARET_EQ] = ACTIONS(1263),
    [anon_sym_QMARK] = ACTIONS(1265),
    [anon_sym_DOT_DOT] = ACTIONS(1265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1263),
    [anon_sym_and] = ACTIONS(1265),
    [anon_sym_or] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_LT_LT] = ACTIONS(1265),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_EQ_EQ] = ACTIONS(1265),
    [anon_sym_BANG_EQ] = ACTIONS(1263),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1263),
    [anon_sym_LT_EQ_GT] = ACTIONS(1263),
    [anon_sym_EQ_TILDE] = ACTIONS(1263),
    [anon_sym_BANG_TILDE] = ACTIONS(1263),
    [anon_sym_LT_EQ] = ACTIONS(1265),
    [anon_sym_GT] = ACTIONS(1265),
    [anon_sym_GT_EQ] = ACTIONS(1263),
    [anon_sym_CARET] = ACTIONS(1265),
    [anon_sym_PLUS] = ACTIONS(1265),
    [anon_sym_SLASH] = ACTIONS(1265),
    [anon_sym_PERCENT] = ACTIONS(1265),
    [anon_sym_defined_QMARK] = ACTIONS(1263),
    [anon_sym_not] = ACTIONS(1265),
    [anon_sym_BANG] = ACTIONS(1265),
    [anon_sym_TILDE] = ACTIONS(1263),
    [sym_constant] = ACTIONS(1265),
    [sym_identifier] = ACTIONS(1265),
    [sym_instance_variable] = ACTIONS(1263),
    [sym_class_variable] = ACTIONS(1263),
    [sym_global_variable] = ACTIONS(1263),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1265),
    [sym_float] = ACTIONS(1265),
    [sym_complex] = ACTIONS(1263),
    [sym_super] = ACTIONS(1265),
    [anon_sym_true] = ACTIONS(1265),
    [anon_sym_TRUE] = ACTIONS(1265),
    [anon_sym_false] = ACTIONS(1265),
    [anon_sym_FALSE] = ACTIONS(1265),
    [sym_self] = ACTIONS(1265),
    [anon_sym_nil] = ACTIONS(1265),
    [anon_sym_NIL] = ACTIONS(1265),
    [sym_character] = ACTIONS(1263),
    [anon_sym_LBRACK2] = ACTIONS(1265),
    [anon_sym_DASH_GT] = ACTIONS(1263),
  },
  [1444] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(906),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(911),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(911),
    [sym__argument_list_with_trailing_comma] = STATE(3561),
    [sym__argument] = STATE(909),
    [sym_splat_argument] = STATE(909),
    [sym_hash_splat_argument] = STATE(909),
    [sym_block_argument] = STATE(909),
    [sym_assignment] = STATE(906),
    [sym_operator_assignment] = STATE(906),
    [sym_conditional] = STATE(906),
    [sym_range] = STATE(906),
    [sym_binary] = STATE(906),
    [sym_unary] = STATE(906),
    [sym_left_assignment_list] = STATE(910),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(911),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(911),
    [sym_false] = STATE(911),
    [sym_nil] = STATE(911),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(912),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(909),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1589),
    [sym__splat_star] = ACTIONS(1591),
    [sym__unary_minus] = ACTIONS(1593),
    [sym__identifier_hash_key] = ACTIONS(1595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(5933),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1599),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_defined_QMARK] = ACTIONS(1611),
    [anon_sym_not] = ACTIONS(1613),
    [anon_sym_BANG] = ACTIONS(1615),
    [anon_sym_TILDE] = ACTIONS(1615),
    [sym_constant] = ACTIONS(1617),
    [sym_identifier] = ACTIONS(1617),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1445] = {
    [sym__line_break] = ACTIONS(5935),
    [sym__simple_symbol] = ACTIONS(5935),
    [sym__string_start] = ACTIONS(5935),
    [sym__symbol_start] = ACTIONS(5935),
    [sym__subshell_start] = ACTIONS(5935),
    [sym__regex_start] = ACTIONS(5935),
    [sym__string_array_start] = ACTIONS(5935),
    [sym__symbol_array_start] = ACTIONS(5935),
    [sym__heredoc_body_start] = ACTIONS(5935),
    [sym_heredoc_beginning] = ACTIONS(5935),
    [sym__block_ampersand] = ACTIONS(5935),
    [sym__splat_star] = ACTIONS(5935),
    [sym__unary_minus] = ACTIONS(5935),
    [sym__binary_minus] = ACTIONS(5935),
    [sym__binary_star] = ACTIONS(5935),
    [sym__identifier_hash_key] = ACTIONS(5935),
    [ts_builtin_sym_end] = ACTIONS(5935),
    [anon_sym___END__] = ACTIONS(5937),
    [anon_sym_LBRACE] = ACTIONS(5935),
    [anon_sym_RBRACE] = ACTIONS(5935),
    [anon_sym_def] = ACTIONS(5937),
    [anon_sym_LPAREN] = ACTIONS(5937),
    [anon_sym_RPAREN] = ACTIONS(5935),
    [anon_sym_DOT] = ACTIONS(5937),
    [anon_sym_COLON_COLON] = ACTIONS(5937),
    [anon_sym_COMMA] = ACTIONS(5935),
    [anon_sym_PIPE] = ACTIONS(5937),
    [anon_sym_SEMI] = ACTIONS(5935),
    [anon_sym_STAR] = ACTIONS(5937),
    [anon_sym_STAR_STAR] = ACTIONS(5937),
    [anon_sym_AMP] = ACTIONS(5937),
    [anon_sym_EQ] = ACTIONS(5937),
    [anon_sym_class] = ACTIONS(5937),
    [anon_sym_LT] = ACTIONS(5937),
    [anon_sym_module] = ACTIONS(5937),
    [anon_sym_end] = ACTIONS(5937),
    [anon_sym_return] = ACTIONS(5937),
    [anon_sym_yield] = ACTIONS(5937),
    [anon_sym_break] = ACTIONS(5937),
    [anon_sym_next] = ACTIONS(5937),
    [sym_redo] = ACTIONS(5937),
    [sym_retry] = ACTIONS(5937),
    [anon_sym_if] = ACTIONS(5937),
    [anon_sym_unless] = ACTIONS(5937),
    [anon_sym_while] = ACTIONS(5937),
    [anon_sym_until] = ACTIONS(5937),
    [anon_sym_rescue] = ACTIONS(5937),
    [anon_sym_for] = ACTIONS(5937),
    [anon_sym_do] = ACTIONS(5937),
    [anon_sym_case] = ACTIONS(5937),
    [anon_sym_when] = ACTIONS(5937),
    [anon_sym_elsif] = ACTIONS(5937),
    [anon_sym_else] = ACTIONS(5937),
    [anon_sym_then] = ACTIONS(5937),
    [anon_sym_begin] = ACTIONS(5937),
    [anon_sym_ensure] = ACTIONS(5937),
    [anon_sym_LBRACK] = ACTIONS(5935),
    [anon_sym_COLON_COLON2] = ACTIONS(5935),
    [anon_sym_AMP_DOT] = ACTIONS(5935),
    [anon_sym_LPAREN2] = ACTIONS(5935),
    [anon_sym_PLUS_EQ] = ACTIONS(5935),
    [anon_sym_DASH_EQ] = ACTIONS(5935),
    [anon_sym_STAR_EQ] = ACTIONS(5935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5935),
    [anon_sym_SLASH_EQ] = ACTIONS(5935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5935),
    [anon_sym_PIPE_EQ] = ACTIONS(5935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5935),
    [anon_sym_AMP_EQ] = ACTIONS(5935),
    [anon_sym_PERCENT_EQ] = ACTIONS(5935),
    [anon_sym_GT_GT_EQ] = ACTIONS(5935),
    [anon_sym_LT_LT_EQ] = ACTIONS(5935),
    [anon_sym_CARET_EQ] = ACTIONS(5935),
    [anon_sym_QMARK] = ACTIONS(5937),
    [anon_sym_DOT_DOT] = ACTIONS(5937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5935),
    [anon_sym_and] = ACTIONS(5937),
    [anon_sym_or] = ACTIONS(5937),
    [anon_sym_PIPE_PIPE] = ACTIONS(5937),
    [anon_sym_AMP_AMP] = ACTIONS(5937),
    [anon_sym_LT_LT] = ACTIONS(5937),
    [anon_sym_GT_GT] = ACTIONS(5937),
    [anon_sym_EQ_EQ] = ACTIONS(5937),
    [anon_sym_BANG_EQ] = ACTIONS(5935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5935),
    [anon_sym_LT_EQ_GT] = ACTIONS(5935),
    [anon_sym_EQ_TILDE] = ACTIONS(5935),
    [anon_sym_BANG_TILDE] = ACTIONS(5935),
    [anon_sym_LT_EQ] = ACTIONS(5937),
    [anon_sym_GT] = ACTIONS(5937),
    [anon_sym_GT_EQ] = ACTIONS(5935),
    [anon_sym_CARET] = ACTIONS(5937),
    [anon_sym_PLUS] = ACTIONS(5937),
    [anon_sym_SLASH] = ACTIONS(5937),
    [anon_sym_PERCENT] = ACTIONS(5937),
    [anon_sym_defined_QMARK] = ACTIONS(5935),
    [anon_sym_not] = ACTIONS(5937),
    [anon_sym_BANG] = ACTIONS(5937),
    [anon_sym_TILDE] = ACTIONS(5935),
    [sym_constant] = ACTIONS(5937),
    [sym_identifier] = ACTIONS(5937),
    [sym_instance_variable] = ACTIONS(5935),
    [sym_class_variable] = ACTIONS(5935),
    [sym_global_variable] = ACTIONS(5935),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5937),
    [sym_float] = ACTIONS(5937),
    [sym_complex] = ACTIONS(5935),
    [sym_super] = ACTIONS(5937),
    [anon_sym_true] = ACTIONS(5937),
    [anon_sym_TRUE] = ACTIONS(5937),
    [anon_sym_false] = ACTIONS(5937),
    [anon_sym_FALSE] = ACTIONS(5937),
    [sym_self] = ACTIONS(5937),
    [anon_sym_nil] = ACTIONS(5937),
    [anon_sym_NIL] = ACTIONS(5937),
    [sym_character] = ACTIONS(5935),
    [anon_sym_LBRACK2] = ACTIONS(5937),
    [anon_sym_DASH_GT] = ACTIONS(5935),
  },
  [1446] = {
    [sym__line_break] = ACTIONS(5939),
    [sym__simple_symbol] = ACTIONS(5939),
    [sym__string_start] = ACTIONS(5939),
    [sym__symbol_start] = ACTIONS(5939),
    [sym__subshell_start] = ACTIONS(5939),
    [sym__regex_start] = ACTIONS(5939),
    [sym__string_array_start] = ACTIONS(5939),
    [sym__symbol_array_start] = ACTIONS(5939),
    [sym__heredoc_body_start] = ACTIONS(5939),
    [sym_heredoc_beginning] = ACTIONS(5939),
    [sym__block_ampersand] = ACTIONS(5939),
    [sym__splat_star] = ACTIONS(5939),
    [sym__unary_minus] = ACTIONS(5939),
    [sym__binary_minus] = ACTIONS(5939),
    [sym__binary_star] = ACTIONS(5939),
    [sym__identifier_hash_key] = ACTIONS(5939),
    [ts_builtin_sym_end] = ACTIONS(5939),
    [anon_sym___END__] = ACTIONS(5941),
    [anon_sym_LBRACE] = ACTIONS(5939),
    [anon_sym_RBRACE] = ACTIONS(5939),
    [anon_sym_def] = ACTIONS(5941),
    [anon_sym_LPAREN] = ACTIONS(5941),
    [anon_sym_RPAREN] = ACTIONS(5939),
    [anon_sym_DOT] = ACTIONS(5941),
    [anon_sym_COLON_COLON] = ACTIONS(5941),
    [anon_sym_COMMA] = ACTIONS(5939),
    [anon_sym_PIPE] = ACTIONS(5941),
    [anon_sym_SEMI] = ACTIONS(5939),
    [anon_sym_STAR] = ACTIONS(5941),
    [anon_sym_STAR_STAR] = ACTIONS(5941),
    [anon_sym_AMP] = ACTIONS(5941),
    [anon_sym_EQ] = ACTIONS(5941),
    [anon_sym_class] = ACTIONS(5941),
    [anon_sym_LT] = ACTIONS(5941),
    [anon_sym_module] = ACTIONS(5941),
    [anon_sym_end] = ACTIONS(5941),
    [anon_sym_return] = ACTIONS(5941),
    [anon_sym_yield] = ACTIONS(5941),
    [anon_sym_break] = ACTIONS(5941),
    [anon_sym_next] = ACTIONS(5941),
    [sym_redo] = ACTIONS(5941),
    [sym_retry] = ACTIONS(5941),
    [anon_sym_if] = ACTIONS(5941),
    [anon_sym_unless] = ACTIONS(5941),
    [anon_sym_while] = ACTIONS(5941),
    [anon_sym_until] = ACTIONS(5941),
    [anon_sym_rescue] = ACTIONS(5941),
    [anon_sym_for] = ACTIONS(5941),
    [anon_sym_do] = ACTIONS(5941),
    [anon_sym_case] = ACTIONS(5941),
    [anon_sym_when] = ACTIONS(5941),
    [anon_sym_elsif] = ACTIONS(5941),
    [anon_sym_else] = ACTIONS(5941),
    [anon_sym_then] = ACTIONS(5941),
    [anon_sym_begin] = ACTIONS(5941),
    [anon_sym_ensure] = ACTIONS(5941),
    [anon_sym_LBRACK] = ACTIONS(5939),
    [anon_sym_COLON_COLON2] = ACTIONS(5939),
    [anon_sym_AMP_DOT] = ACTIONS(5939),
    [anon_sym_LPAREN2] = ACTIONS(5939),
    [anon_sym_PLUS_EQ] = ACTIONS(5939),
    [anon_sym_DASH_EQ] = ACTIONS(5939),
    [anon_sym_STAR_EQ] = ACTIONS(5939),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5939),
    [anon_sym_SLASH_EQ] = ACTIONS(5939),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5939),
    [anon_sym_PIPE_EQ] = ACTIONS(5939),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5939),
    [anon_sym_AMP_EQ] = ACTIONS(5939),
    [anon_sym_PERCENT_EQ] = ACTIONS(5939),
    [anon_sym_GT_GT_EQ] = ACTIONS(5939),
    [anon_sym_LT_LT_EQ] = ACTIONS(5939),
    [anon_sym_CARET_EQ] = ACTIONS(5939),
    [anon_sym_QMARK] = ACTIONS(5941),
    [anon_sym_DOT_DOT] = ACTIONS(5941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5939),
    [anon_sym_and] = ACTIONS(5941),
    [anon_sym_or] = ACTIONS(5941),
    [anon_sym_PIPE_PIPE] = ACTIONS(5941),
    [anon_sym_AMP_AMP] = ACTIONS(5941),
    [anon_sym_LT_LT] = ACTIONS(5941),
    [anon_sym_GT_GT] = ACTIONS(5941),
    [anon_sym_EQ_EQ] = ACTIONS(5941),
    [anon_sym_BANG_EQ] = ACTIONS(5939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5939),
    [anon_sym_LT_EQ_GT] = ACTIONS(5939),
    [anon_sym_EQ_TILDE] = ACTIONS(5939),
    [anon_sym_BANG_TILDE] = ACTIONS(5939),
    [anon_sym_LT_EQ] = ACTIONS(5941),
    [anon_sym_GT] = ACTIONS(5941),
    [anon_sym_GT_EQ] = ACTIONS(5939),
    [anon_sym_CARET] = ACTIONS(5941),
    [anon_sym_PLUS] = ACTIONS(5941),
    [anon_sym_SLASH] = ACTIONS(5941),
    [anon_sym_PERCENT] = ACTIONS(5941),
    [anon_sym_defined_QMARK] = ACTIONS(5939),
    [anon_sym_not] = ACTIONS(5941),
    [anon_sym_BANG] = ACTIONS(5941),
    [anon_sym_TILDE] = ACTIONS(5939),
    [sym_constant] = ACTIONS(5941),
    [sym_identifier] = ACTIONS(5941),
    [sym_instance_variable] = ACTIONS(5939),
    [sym_class_variable] = ACTIONS(5939),
    [sym_global_variable] = ACTIONS(5939),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5941),
    [sym_float] = ACTIONS(5941),
    [sym_complex] = ACTIONS(5939),
    [sym_super] = ACTIONS(5941),
    [anon_sym_true] = ACTIONS(5941),
    [anon_sym_TRUE] = ACTIONS(5941),
    [anon_sym_false] = ACTIONS(5941),
    [anon_sym_FALSE] = ACTIONS(5941),
    [sym_self] = ACTIONS(5941),
    [anon_sym_nil] = ACTIONS(5941),
    [anon_sym_NIL] = ACTIONS(5941),
    [sym_character] = ACTIONS(5939),
    [anon_sym_LBRACK2] = ACTIONS(5941),
    [anon_sym_DASH_GT] = ACTIONS(5939),
  },
  [1447] = {
    [sym_argument_list_with_parens] = STATE(3562),
    [sym__argument_list_with_parens] = STATE(1446),
    [sym_operator] = STATE(3562),
    [sym_heredoc_body] = STATE(3563),
    [aux_sym_call_repeat1] = STATE(3563),
    [sym__heredoc_body_start] = ACTIONS(2519),
    [anon_sym_PIPE] = ACTIONS(2521),
    [anon_sym_STAR] = ACTIONS(2523),
    [anon_sym_STAR_STAR] = ACTIONS(2521),
    [anon_sym_AMP] = ACTIONS(2521),
    [anon_sym_LT] = ACTIONS(2523),
    [anon_sym_LPAREN2] = ACTIONS(2525),
    [anon_sym_DOT_DOT] = ACTIONS(2521),
    [anon_sym_LT_LT] = ACTIONS(2521),
    [anon_sym_GT_GT] = ACTIONS(2521),
    [anon_sym_EQ_EQ] = ACTIONS(2523),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2521),
    [anon_sym_LT_EQ_GT] = ACTIONS(2521),
    [anon_sym_EQ_TILDE] = ACTIONS(2521),
    [anon_sym_BANG_TILDE] = ACTIONS(2521),
    [anon_sym_LT_EQ] = ACTIONS(2523),
    [anon_sym_GT] = ACTIONS(2523),
    [anon_sym_GT_EQ] = ACTIONS(2521),
    [anon_sym_CARET] = ACTIONS(2521),
    [anon_sym_PLUS] = ACTIONS(2523),
    [anon_sym_SLASH] = ACTIONS(2521),
    [anon_sym_PERCENT] = ACTIONS(2521),
    [anon_sym_BANG] = ACTIONS(2523),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(5943),
    [sym_identifier] = ACTIONS(5943),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_PLUS_AT] = ACTIONS(2521),
    [anon_sym_DASH_AT] = ACTIONS(2521),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2523),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(2521),
    [anon_sym_BQUOTE] = ACTIONS(2521),
    [sym_comment] = ACTIONS(87),
  },
  [1448] = {
    [sym__line_break] = ACTIONS(5945),
    [sym__heredoc_body_start] = ACTIONS(5945),
    [sym__binary_minus] = ACTIONS(5945),
    [sym__binary_star] = ACTIONS(5945),
    [ts_builtin_sym_end] = ACTIONS(5945),
    [anon_sym___END__] = ACTIONS(5945),
    [anon_sym_LBRACE] = ACTIONS(5945),
    [anon_sym_RBRACE] = ACTIONS(5945),
    [anon_sym_RPAREN] = ACTIONS(5945),
    [anon_sym_DOT] = ACTIONS(5947),
    [anon_sym_COMMA] = ACTIONS(5945),
    [anon_sym_PIPE] = ACTIONS(5947),
    [anon_sym_SEMI] = ACTIONS(5945),
    [anon_sym_STAR_STAR] = ACTIONS(5947),
    [anon_sym_AMP] = ACTIONS(5947),
    [anon_sym_EQ] = ACTIONS(5947),
    [anon_sym_LT] = ACTIONS(5947),
    [anon_sym_end] = ACTIONS(5945),
    [anon_sym_if] = ACTIONS(5945),
    [anon_sym_unless] = ACTIONS(5945),
    [anon_sym_while] = ACTIONS(5945),
    [anon_sym_until] = ACTIONS(5945),
    [anon_sym_rescue] = ACTIONS(5945),
    [anon_sym_do] = ACTIONS(5945),
    [anon_sym_when] = ACTIONS(5945),
    [anon_sym_elsif] = ACTIONS(5945),
    [anon_sym_else] = ACTIONS(5945),
    [anon_sym_then] = ACTIONS(5945),
    [anon_sym_ensure] = ACTIONS(5945),
    [anon_sym_LBRACK] = ACTIONS(5945),
    [anon_sym_COLON_COLON2] = ACTIONS(5945),
    [anon_sym_AMP_DOT] = ACTIONS(5945),
    [anon_sym_PLUS_EQ] = ACTIONS(5945),
    [anon_sym_DASH_EQ] = ACTIONS(5945),
    [anon_sym_STAR_EQ] = ACTIONS(5945),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5945),
    [anon_sym_SLASH_EQ] = ACTIONS(5945),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5945),
    [anon_sym_PIPE_EQ] = ACTIONS(5945),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5945),
    [anon_sym_AMP_EQ] = ACTIONS(5945),
    [anon_sym_PERCENT_EQ] = ACTIONS(5945),
    [anon_sym_GT_GT_EQ] = ACTIONS(5945),
    [anon_sym_LT_LT_EQ] = ACTIONS(5945),
    [anon_sym_CARET_EQ] = ACTIONS(5945),
    [anon_sym_QMARK] = ACTIONS(5945),
    [anon_sym_DOT_DOT] = ACTIONS(5947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5945),
    [anon_sym_and] = ACTIONS(5945),
    [anon_sym_or] = ACTIONS(5945),
    [anon_sym_PIPE_PIPE] = ACTIONS(5947),
    [anon_sym_AMP_AMP] = ACTIONS(5947),
    [anon_sym_LT_LT] = ACTIONS(5947),
    [anon_sym_GT_GT] = ACTIONS(5947),
    [anon_sym_EQ_EQ] = ACTIONS(5947),
    [anon_sym_BANG_EQ] = ACTIONS(5945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5945),
    [anon_sym_LT_EQ_GT] = ACTIONS(5945),
    [anon_sym_EQ_TILDE] = ACTIONS(5945),
    [anon_sym_BANG_TILDE] = ACTIONS(5945),
    [anon_sym_LT_EQ] = ACTIONS(5947),
    [anon_sym_GT] = ACTIONS(5947),
    [anon_sym_GT_EQ] = ACTIONS(5945),
    [anon_sym_CARET] = ACTIONS(5947),
    [anon_sym_PLUS] = ACTIONS(5947),
    [anon_sym_SLASH] = ACTIONS(5947),
    [anon_sym_PERCENT] = ACTIONS(5947),
    [sym_comment] = ACTIONS(87),
  },
  [1449] = {
    [anon_sym_RBRACK] = ACTIONS(5949),
    [sym_comment] = ACTIONS(87),
  },
  [1450] = {
    [sym__line_break] = ACTIONS(5951),
    [sym__simple_symbol] = ACTIONS(5951),
    [sym__string_start] = ACTIONS(5951),
    [sym__symbol_start] = ACTIONS(5951),
    [sym__subshell_start] = ACTIONS(5951),
    [sym__regex_start] = ACTIONS(5951),
    [sym__string_array_start] = ACTIONS(5951),
    [sym__symbol_array_start] = ACTIONS(5951),
    [sym__heredoc_body_start] = ACTIONS(5951),
    [sym_heredoc_beginning] = ACTIONS(5951),
    [sym__block_ampersand] = ACTIONS(5951),
    [sym__splat_star] = ACTIONS(5951),
    [sym__unary_minus] = ACTIONS(5951),
    [sym__binary_minus] = ACTIONS(5951),
    [sym__binary_star] = ACTIONS(5951),
    [sym__identifier_hash_key] = ACTIONS(5951),
    [ts_builtin_sym_end] = ACTIONS(5951),
    [anon_sym___END__] = ACTIONS(5953),
    [anon_sym_LBRACE] = ACTIONS(5951),
    [anon_sym_RBRACE] = ACTIONS(5951),
    [anon_sym_def] = ACTIONS(5953),
    [anon_sym_LPAREN] = ACTIONS(5953),
    [anon_sym_RPAREN] = ACTIONS(5951),
    [anon_sym_DOT] = ACTIONS(5953),
    [anon_sym_COLON_COLON] = ACTIONS(5953),
    [anon_sym_COMMA] = ACTIONS(5951),
    [anon_sym_PIPE] = ACTIONS(5953),
    [anon_sym_SEMI] = ACTIONS(5951),
    [anon_sym_STAR] = ACTIONS(5953),
    [anon_sym_STAR_STAR] = ACTIONS(5953),
    [anon_sym_AMP] = ACTIONS(5953),
    [anon_sym_EQ] = ACTIONS(5953),
    [anon_sym_class] = ACTIONS(5953),
    [anon_sym_LT] = ACTIONS(5953),
    [anon_sym_module] = ACTIONS(5953),
    [anon_sym_end] = ACTIONS(5953),
    [anon_sym_return] = ACTIONS(5953),
    [anon_sym_yield] = ACTIONS(5953),
    [anon_sym_break] = ACTIONS(5953),
    [anon_sym_next] = ACTIONS(5953),
    [sym_redo] = ACTIONS(5953),
    [sym_retry] = ACTIONS(5953),
    [anon_sym_if] = ACTIONS(5953),
    [anon_sym_unless] = ACTIONS(5953),
    [anon_sym_while] = ACTIONS(5953),
    [anon_sym_until] = ACTIONS(5953),
    [anon_sym_rescue] = ACTIONS(5953),
    [anon_sym_for] = ACTIONS(5953),
    [anon_sym_do] = ACTIONS(5953),
    [anon_sym_case] = ACTIONS(5953),
    [anon_sym_when] = ACTIONS(5953),
    [anon_sym_elsif] = ACTIONS(5953),
    [anon_sym_else] = ACTIONS(5953),
    [anon_sym_then] = ACTIONS(5953),
    [anon_sym_begin] = ACTIONS(5953),
    [anon_sym_ensure] = ACTIONS(5953),
    [anon_sym_LBRACK] = ACTIONS(5951),
    [anon_sym_COLON_COLON2] = ACTIONS(5951),
    [anon_sym_AMP_DOT] = ACTIONS(5951),
    [anon_sym_LPAREN2] = ACTIONS(5951),
    [anon_sym_PLUS_EQ] = ACTIONS(5951),
    [anon_sym_DASH_EQ] = ACTIONS(5951),
    [anon_sym_STAR_EQ] = ACTIONS(5951),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5951),
    [anon_sym_SLASH_EQ] = ACTIONS(5951),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5951),
    [anon_sym_PIPE_EQ] = ACTIONS(5951),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5951),
    [anon_sym_AMP_EQ] = ACTIONS(5951),
    [anon_sym_PERCENT_EQ] = ACTIONS(5951),
    [anon_sym_GT_GT_EQ] = ACTIONS(5951),
    [anon_sym_LT_LT_EQ] = ACTIONS(5951),
    [anon_sym_CARET_EQ] = ACTIONS(5951),
    [anon_sym_QMARK] = ACTIONS(5953),
    [anon_sym_DOT_DOT] = ACTIONS(5953),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5951),
    [anon_sym_and] = ACTIONS(5953),
    [anon_sym_or] = ACTIONS(5953),
    [anon_sym_PIPE_PIPE] = ACTIONS(5953),
    [anon_sym_AMP_AMP] = ACTIONS(5953),
    [anon_sym_LT_LT] = ACTIONS(5953),
    [anon_sym_GT_GT] = ACTIONS(5953),
    [anon_sym_EQ_EQ] = ACTIONS(5953),
    [anon_sym_BANG_EQ] = ACTIONS(5951),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5951),
    [anon_sym_LT_EQ_GT] = ACTIONS(5951),
    [anon_sym_EQ_TILDE] = ACTIONS(5951),
    [anon_sym_BANG_TILDE] = ACTIONS(5951),
    [anon_sym_LT_EQ] = ACTIONS(5953),
    [anon_sym_GT] = ACTIONS(5953),
    [anon_sym_GT_EQ] = ACTIONS(5951),
    [anon_sym_CARET] = ACTIONS(5953),
    [anon_sym_PLUS] = ACTIONS(5953),
    [anon_sym_SLASH] = ACTIONS(5953),
    [anon_sym_PERCENT] = ACTIONS(5953),
    [anon_sym_defined_QMARK] = ACTIONS(5951),
    [anon_sym_not] = ACTIONS(5953),
    [anon_sym_BANG] = ACTIONS(5953),
    [anon_sym_TILDE] = ACTIONS(5951),
    [sym_constant] = ACTIONS(5953),
    [sym_identifier] = ACTIONS(5953),
    [sym_instance_variable] = ACTIONS(5951),
    [sym_class_variable] = ACTIONS(5951),
    [sym_global_variable] = ACTIONS(5951),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5953),
    [sym_float] = ACTIONS(5953),
    [sym_complex] = ACTIONS(5951),
    [sym_super] = ACTIONS(5953),
    [anon_sym_true] = ACTIONS(5953),
    [anon_sym_TRUE] = ACTIONS(5953),
    [anon_sym_false] = ACTIONS(5953),
    [anon_sym_FALSE] = ACTIONS(5953),
    [sym_self] = ACTIONS(5953),
    [anon_sym_nil] = ACTIONS(5953),
    [anon_sym_NIL] = ACTIONS(5953),
    [sym_character] = ACTIONS(5951),
    [anon_sym_LBRACK2] = ACTIONS(5953),
    [anon_sym_DASH_GT] = ACTIONS(5951),
  },
  [1451] = {
    [sym__line_break] = ACTIONS(835),
    [sym__string_start] = ACTIONS(835),
    [sym__heredoc_body_start] = ACTIONS(835),
    [sym__binary_minus] = ACTIONS(835),
    [sym__binary_star] = ACTIONS(835),
    [ts_builtin_sym_end] = ACTIONS(835),
    [anon_sym___END__] = ACTIONS(835),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_RBRACE] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(835),
    [anon_sym_DOT] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(835),
    [anon_sym_PIPE] = ACTIONS(837),
    [anon_sym_SEMI] = ACTIONS(835),
    [anon_sym_STAR_STAR] = ACTIONS(837),
    [anon_sym_AMP] = ACTIONS(837),
    [anon_sym_COLON] = ACTIONS(837),
    [anon_sym_EQ] = ACTIONS(837),
    [anon_sym_LT] = ACTIONS(837),
    [anon_sym_end] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_unless] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_until] = ACTIONS(835),
    [anon_sym_rescue] = ACTIONS(835),
    [anon_sym_do] = ACTIONS(835),
    [anon_sym_when] = ACTIONS(835),
    [anon_sym_elsif] = ACTIONS(835),
    [anon_sym_else] = ACTIONS(835),
    [anon_sym_then] = ACTIONS(835),
    [anon_sym_ensure] = ACTIONS(835),
    [anon_sym_EQ_GT] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_COLON_COLON2] = ACTIONS(835),
    [anon_sym_AMP_DOT] = ACTIONS(835),
    [anon_sym_PLUS_EQ] = ACTIONS(835),
    [anon_sym_DASH_EQ] = ACTIONS(835),
    [anon_sym_STAR_EQ] = ACTIONS(835),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(835),
    [anon_sym_SLASH_EQ] = ACTIONS(835),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(835),
    [anon_sym_PIPE_EQ] = ACTIONS(835),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(835),
    [anon_sym_AMP_EQ] = ACTIONS(835),
    [anon_sym_PERCENT_EQ] = ACTIONS(835),
    [anon_sym_GT_GT_EQ] = ACTIONS(835),
    [anon_sym_LT_LT_EQ] = ACTIONS(835),
    [anon_sym_CARET_EQ] = ACTIONS(835),
    [anon_sym_QMARK] = ACTIONS(835),
    [anon_sym_DOT_DOT] = ACTIONS(837),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(835),
    [anon_sym_and] = ACTIONS(835),
    [anon_sym_or] = ACTIONS(835),
    [anon_sym_PIPE_PIPE] = ACTIONS(837),
    [anon_sym_AMP_AMP] = ACTIONS(837),
    [anon_sym_LT_LT] = ACTIONS(837),
    [anon_sym_GT_GT] = ACTIONS(837),
    [anon_sym_EQ_EQ] = ACTIONS(837),
    [anon_sym_BANG_EQ] = ACTIONS(835),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(835),
    [anon_sym_LT_EQ_GT] = ACTIONS(835),
    [anon_sym_EQ_TILDE] = ACTIONS(835),
    [anon_sym_BANG_TILDE] = ACTIONS(835),
    [anon_sym_LT_EQ] = ACTIONS(837),
    [anon_sym_GT] = ACTIONS(837),
    [anon_sym_GT_EQ] = ACTIONS(835),
    [anon_sym_CARET] = ACTIONS(837),
    [anon_sym_PLUS] = ACTIONS(837),
    [anon_sym_SLASH] = ACTIONS(837),
    [anon_sym_PERCENT] = ACTIONS(837),
    [sym_comment] = ACTIONS(87),
  },
  [1452] = {
    [sym__string_end] = ACTIONS(5955),
    [sym_comment] = ACTIONS(87),
  },
  [1453] = {
    [sym__line_break] = ACTIONS(887),
    [sym__heredoc_body_start] = ACTIONS(887),
    [sym__binary_minus] = ACTIONS(887),
    [sym__binary_star] = ACTIONS(887),
    [ts_builtin_sym_end] = ACTIONS(887),
    [anon_sym___END__] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(887),
    [anon_sym_RBRACE] = ACTIONS(887),
    [anon_sym_RPAREN] = ACTIONS(887),
    [anon_sym_DOT] = ACTIONS(889),
    [anon_sym_COMMA] = ACTIONS(887),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI] = ACTIONS(887),
    [anon_sym_STAR_STAR] = ACTIONS(889),
    [anon_sym_AMP] = ACTIONS(889),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_LT] = ACTIONS(889),
    [anon_sym_end] = ACTIONS(887),
    [anon_sym_if] = ACTIONS(887),
    [anon_sym_unless] = ACTIONS(887),
    [anon_sym_while] = ACTIONS(887),
    [anon_sym_until] = ACTIONS(887),
    [anon_sym_rescue] = ACTIONS(887),
    [anon_sym_do] = ACTIONS(887),
    [anon_sym_when] = ACTIONS(887),
    [anon_sym_elsif] = ACTIONS(887),
    [anon_sym_else] = ACTIONS(887),
    [anon_sym_then] = ACTIONS(887),
    [anon_sym_ensure] = ACTIONS(887),
    [anon_sym_EQ_GT] = ACTIONS(887),
    [anon_sym_LBRACK] = ACTIONS(887),
    [anon_sym_COLON_COLON2] = ACTIONS(887),
    [anon_sym_AMP_DOT] = ACTIONS(887),
    [anon_sym_PLUS_EQ] = ACTIONS(887),
    [anon_sym_DASH_EQ] = ACTIONS(887),
    [anon_sym_STAR_EQ] = ACTIONS(887),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(887),
    [anon_sym_SLASH_EQ] = ACTIONS(887),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(887),
    [anon_sym_PIPE_EQ] = ACTIONS(887),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(887),
    [anon_sym_AMP_EQ] = ACTIONS(887),
    [anon_sym_PERCENT_EQ] = ACTIONS(887),
    [anon_sym_GT_GT_EQ] = ACTIONS(887),
    [anon_sym_LT_LT_EQ] = ACTIONS(887),
    [anon_sym_CARET_EQ] = ACTIONS(887),
    [anon_sym_QMARK] = ACTIONS(887),
    [anon_sym_DOT_DOT] = ACTIONS(889),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(887),
    [anon_sym_and] = ACTIONS(887),
    [anon_sym_or] = ACTIONS(887),
    [anon_sym_PIPE_PIPE] = ACTIONS(889),
    [anon_sym_AMP_AMP] = ACTIONS(889),
    [anon_sym_LT_LT] = ACTIONS(889),
    [anon_sym_GT_GT] = ACTIONS(889),
    [anon_sym_EQ_EQ] = ACTIONS(889),
    [anon_sym_BANG_EQ] = ACTIONS(887),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(887),
    [anon_sym_LT_EQ_GT] = ACTIONS(887),
    [anon_sym_EQ_TILDE] = ACTIONS(887),
    [anon_sym_BANG_TILDE] = ACTIONS(887),
    [anon_sym_LT_EQ] = ACTIONS(889),
    [anon_sym_GT] = ACTIONS(889),
    [anon_sym_GT_EQ] = ACTIONS(887),
    [anon_sym_CARET] = ACTIONS(889),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_SLASH] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [sym_comment] = ACTIONS(87),
  },
  [1454] = {
    [sym__string_end] = ACTIONS(5957),
    [sym_comment] = ACTIONS(87),
  },
  [1455] = {
    [sym__line_break] = ACTIONS(893),
    [sym__heredoc_body_start] = ACTIONS(893),
    [sym__binary_minus] = ACTIONS(893),
    [sym__binary_star] = ACTIONS(893),
    [ts_builtin_sym_end] = ACTIONS(893),
    [anon_sym___END__] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(893),
    [anon_sym_RBRACE] = ACTIONS(893),
    [anon_sym_RPAREN] = ACTIONS(893),
    [anon_sym_DOT] = ACTIONS(895),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_PIPE] = ACTIONS(895),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_STAR_STAR] = ACTIONS(895),
    [anon_sym_AMP] = ACTIONS(895),
    [anon_sym_EQ] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(895),
    [anon_sym_end] = ACTIONS(893),
    [anon_sym_if] = ACTIONS(893),
    [anon_sym_unless] = ACTIONS(893),
    [anon_sym_while] = ACTIONS(893),
    [anon_sym_until] = ACTIONS(893),
    [anon_sym_rescue] = ACTIONS(893),
    [anon_sym_do] = ACTIONS(893),
    [anon_sym_when] = ACTIONS(893),
    [anon_sym_elsif] = ACTIONS(893),
    [anon_sym_else] = ACTIONS(893),
    [anon_sym_then] = ACTIONS(893),
    [anon_sym_ensure] = ACTIONS(893),
    [anon_sym_EQ_GT] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(893),
    [anon_sym_COLON_COLON2] = ACTIONS(893),
    [anon_sym_AMP_DOT] = ACTIONS(893),
    [anon_sym_PLUS_EQ] = ACTIONS(893),
    [anon_sym_DASH_EQ] = ACTIONS(893),
    [anon_sym_STAR_EQ] = ACTIONS(893),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(893),
    [anon_sym_SLASH_EQ] = ACTIONS(893),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(893),
    [anon_sym_PIPE_EQ] = ACTIONS(893),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(893),
    [anon_sym_AMP_EQ] = ACTIONS(893),
    [anon_sym_PERCENT_EQ] = ACTIONS(893),
    [anon_sym_GT_GT_EQ] = ACTIONS(893),
    [anon_sym_LT_LT_EQ] = ACTIONS(893),
    [anon_sym_CARET_EQ] = ACTIONS(893),
    [anon_sym_QMARK] = ACTIONS(893),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(893),
    [anon_sym_and] = ACTIONS(893),
    [anon_sym_or] = ACTIONS(893),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_LT_LT] = ACTIONS(895),
    [anon_sym_GT_GT] = ACTIONS(895),
    [anon_sym_EQ_EQ] = ACTIONS(895),
    [anon_sym_BANG_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_LT_EQ_GT] = ACTIONS(893),
    [anon_sym_EQ_TILDE] = ACTIONS(893),
    [anon_sym_BANG_TILDE] = ACTIONS(893),
    [anon_sym_LT_EQ] = ACTIONS(895),
    [anon_sym_GT] = ACTIONS(895),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_CARET] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(895),
    [anon_sym_SLASH] = ACTIONS(895),
    [anon_sym_PERCENT] = ACTIONS(895),
    [sym_comment] = ACTIONS(87),
  },
  [1456] = {
    [sym__string_end] = ACTIONS(5959),
    [sym_comment] = ACTIONS(87),
  },
  [1457] = {
    [sym__line_break] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(899),
    [sym__binary_minus] = ACTIONS(899),
    [sym__binary_star] = ACTIONS(899),
    [ts_builtin_sym_end] = ACTIONS(899),
    [anon_sym___END__] = ACTIONS(899),
    [anon_sym_LBRACE] = ACTIONS(899),
    [anon_sym_RBRACE] = ACTIONS(899),
    [anon_sym_RPAREN] = ACTIONS(899),
    [anon_sym_DOT] = ACTIONS(901),
    [anon_sym_COMMA] = ACTIONS(899),
    [anon_sym_PIPE] = ACTIONS(901),
    [anon_sym_SEMI] = ACTIONS(899),
    [anon_sym_STAR_STAR] = ACTIONS(901),
    [anon_sym_AMP] = ACTIONS(901),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_LT] = ACTIONS(901),
    [anon_sym_end] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(899),
    [anon_sym_unless] = ACTIONS(899),
    [anon_sym_while] = ACTIONS(899),
    [anon_sym_until] = ACTIONS(899),
    [anon_sym_rescue] = ACTIONS(899),
    [anon_sym_do] = ACTIONS(899),
    [anon_sym_when] = ACTIONS(899),
    [anon_sym_elsif] = ACTIONS(899),
    [anon_sym_else] = ACTIONS(899),
    [anon_sym_then] = ACTIONS(899),
    [anon_sym_ensure] = ACTIONS(899),
    [anon_sym_EQ_GT] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(899),
    [anon_sym_COLON_COLON2] = ACTIONS(899),
    [anon_sym_AMP_DOT] = ACTIONS(899),
    [anon_sym_PLUS_EQ] = ACTIONS(899),
    [anon_sym_DASH_EQ] = ACTIONS(899),
    [anon_sym_STAR_EQ] = ACTIONS(899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(899),
    [anon_sym_SLASH_EQ] = ACTIONS(899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(899),
    [anon_sym_PIPE_EQ] = ACTIONS(899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(899),
    [anon_sym_AMP_EQ] = ACTIONS(899),
    [anon_sym_PERCENT_EQ] = ACTIONS(899),
    [anon_sym_GT_GT_EQ] = ACTIONS(899),
    [anon_sym_LT_LT_EQ] = ACTIONS(899),
    [anon_sym_CARET_EQ] = ACTIONS(899),
    [anon_sym_QMARK] = ACTIONS(899),
    [anon_sym_DOT_DOT] = ACTIONS(901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(899),
    [anon_sym_and] = ACTIONS(899),
    [anon_sym_or] = ACTIONS(899),
    [anon_sym_PIPE_PIPE] = ACTIONS(901),
    [anon_sym_AMP_AMP] = ACTIONS(901),
    [anon_sym_LT_LT] = ACTIONS(901),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_EQ_EQ] = ACTIONS(901),
    [anon_sym_BANG_EQ] = ACTIONS(899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(899),
    [anon_sym_LT_EQ_GT] = ACTIONS(899),
    [anon_sym_EQ_TILDE] = ACTIONS(899),
    [anon_sym_BANG_TILDE] = ACTIONS(899),
    [anon_sym_LT_EQ] = ACTIONS(901),
    [anon_sym_GT] = ACTIONS(901),
    [anon_sym_GT_EQ] = ACTIONS(899),
    [anon_sym_CARET] = ACTIONS(901),
    [anon_sym_PLUS] = ACTIONS(901),
    [anon_sym_SLASH] = ACTIONS(901),
    [anon_sym_PERCENT] = ACTIONS(901),
    [sym_comment] = ACTIONS(87),
  },
  [1458] = {
    [sym__string_end] = ACTIONS(5961),
    [sym_comment] = ACTIONS(87),
  },
  [1459] = {
    [sym__line_break] = ACTIONS(905),
    [sym__heredoc_body_start] = ACTIONS(905),
    [sym__binary_minus] = ACTIONS(905),
    [sym__binary_star] = ACTIONS(905),
    [ts_builtin_sym_end] = ACTIONS(905),
    [anon_sym___END__] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(905),
    [anon_sym_RBRACE] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(905),
    [anon_sym_DOT] = ACTIONS(907),
    [anon_sym_COMMA] = ACTIONS(905),
    [anon_sym_PIPE] = ACTIONS(907),
    [anon_sym_SEMI] = ACTIONS(905),
    [anon_sym_STAR_STAR] = ACTIONS(907),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(907),
    [anon_sym_LT] = ACTIONS(907),
    [anon_sym_end] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_unless] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_until] = ACTIONS(905),
    [anon_sym_rescue] = ACTIONS(905),
    [anon_sym_do] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(905),
    [anon_sym_elsif] = ACTIONS(905),
    [anon_sym_else] = ACTIONS(905),
    [anon_sym_then] = ACTIONS(905),
    [anon_sym_ensure] = ACTIONS(905),
    [anon_sym_EQ_GT] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_COLON_COLON2] = ACTIONS(905),
    [anon_sym_AMP_DOT] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_QMARK] = ACTIONS(905),
    [anon_sym_DOT_DOT] = ACTIONS(907),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(905),
    [anon_sym_and] = ACTIONS(905),
    [anon_sym_or] = ACTIONS(905),
    [anon_sym_PIPE_PIPE] = ACTIONS(907),
    [anon_sym_AMP_AMP] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(907),
    [anon_sym_GT_GT] = ACTIONS(907),
    [anon_sym_EQ_EQ] = ACTIONS(907),
    [anon_sym_BANG_EQ] = ACTIONS(905),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(905),
    [anon_sym_LT_EQ_GT] = ACTIONS(905),
    [anon_sym_EQ_TILDE] = ACTIONS(905),
    [anon_sym_BANG_TILDE] = ACTIONS(905),
    [anon_sym_LT_EQ] = ACTIONS(907),
    [anon_sym_GT] = ACTIONS(907),
    [anon_sym_GT_EQ] = ACTIONS(905),
    [anon_sym_CARET] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(907),
    [anon_sym_SLASH] = ACTIONS(907),
    [anon_sym_PERCENT] = ACTIONS(907),
    [sym_comment] = ACTIONS(87),
  },
  [1460] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(3571),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(5963),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(5965),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [1461] = {
    [aux_sym_string_array_repeat1] = STATE(3574),
    [sym__string_end] = ACTIONS(5967),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(5969),
  },
  [1462] = {
    [sym__line_break] = ACTIONS(923),
    [sym__heredoc_body_start] = ACTIONS(923),
    [sym__binary_minus] = ACTIONS(923),
    [sym__binary_star] = ACTIONS(923),
    [ts_builtin_sym_end] = ACTIONS(923),
    [anon_sym___END__] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(923),
    [anon_sym_RBRACE] = ACTIONS(923),
    [anon_sym_RPAREN] = ACTIONS(923),
    [anon_sym_DOT] = ACTIONS(925),
    [anon_sym_COMMA] = ACTIONS(923),
    [anon_sym_PIPE] = ACTIONS(925),
    [anon_sym_SEMI] = ACTIONS(923),
    [anon_sym_STAR_STAR] = ACTIONS(925),
    [anon_sym_AMP] = ACTIONS(925),
    [anon_sym_EQ] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(925),
    [anon_sym_end] = ACTIONS(923),
    [anon_sym_if] = ACTIONS(923),
    [anon_sym_unless] = ACTIONS(923),
    [anon_sym_while] = ACTIONS(923),
    [anon_sym_until] = ACTIONS(923),
    [anon_sym_rescue] = ACTIONS(923),
    [anon_sym_do] = ACTIONS(923),
    [anon_sym_when] = ACTIONS(923),
    [anon_sym_elsif] = ACTIONS(923),
    [anon_sym_else] = ACTIONS(923),
    [anon_sym_then] = ACTIONS(923),
    [anon_sym_ensure] = ACTIONS(923),
    [anon_sym_EQ_GT] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(923),
    [anon_sym_COLON_COLON2] = ACTIONS(923),
    [anon_sym_AMP_DOT] = ACTIONS(923),
    [anon_sym_PLUS_EQ] = ACTIONS(923),
    [anon_sym_DASH_EQ] = ACTIONS(923),
    [anon_sym_STAR_EQ] = ACTIONS(923),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(923),
    [anon_sym_SLASH_EQ] = ACTIONS(923),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(923),
    [anon_sym_PIPE_EQ] = ACTIONS(923),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(923),
    [anon_sym_AMP_EQ] = ACTIONS(923),
    [anon_sym_PERCENT_EQ] = ACTIONS(923),
    [anon_sym_GT_GT_EQ] = ACTIONS(923),
    [anon_sym_LT_LT_EQ] = ACTIONS(923),
    [anon_sym_CARET_EQ] = ACTIONS(923),
    [anon_sym_QMARK] = ACTIONS(923),
    [anon_sym_DOT_DOT] = ACTIONS(925),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(923),
    [anon_sym_and] = ACTIONS(923),
    [anon_sym_or] = ACTIONS(923),
    [anon_sym_PIPE_PIPE] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(925),
    [anon_sym_LT_LT] = ACTIONS(925),
    [anon_sym_GT_GT] = ACTIONS(925),
    [anon_sym_EQ_EQ] = ACTIONS(925),
    [anon_sym_BANG_EQ] = ACTIONS(923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(923),
    [anon_sym_LT_EQ_GT] = ACTIONS(923),
    [anon_sym_EQ_TILDE] = ACTIONS(923),
    [anon_sym_BANG_TILDE] = ACTIONS(923),
    [anon_sym_LT_EQ] = ACTIONS(925),
    [anon_sym_GT] = ACTIONS(925),
    [anon_sym_GT_EQ] = ACTIONS(923),
    [anon_sym_CARET] = ACTIONS(925),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(925),
    [anon_sym_PERCENT] = ACTIONS(925),
    [sym_comment] = ACTIONS(87),
  },
  [1463] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(3577),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(5971),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(5973),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [1464] = {
    [aux_sym_symbol_array_repeat1] = STATE(3580),
    [sym__string_end] = ACTIONS(5975),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(5977),
  },
  [1465] = {
    [sym__line_break] = ACTIONS(101),
    [sym__heredoc_body_start] = ACTIONS(101),
    [sym__binary_minus] = ACTIONS(101),
    [sym__binary_star] = ACTIONS(101),
    [ts_builtin_sym_end] = ACTIONS(101),
    [anon_sym___END__] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_RBRACE] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(103),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_PIPE] = ACTIONS(103),
    [anon_sym_SEMI] = ACTIONS(101),
    [anon_sym_STAR_STAR] = ACTIONS(103),
    [anon_sym_AMP] = ACTIONS(103),
    [anon_sym_EQ] = ACTIONS(103),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_unless] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_until] = ACTIONS(101),
    [anon_sym_rescue] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(101),
    [anon_sym_when] = ACTIONS(101),
    [anon_sym_elsif] = ACTIONS(101),
    [anon_sym_else] = ACTIONS(101),
    [anon_sym_then] = ACTIONS(101),
    [anon_sym_ensure] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_COLON_COLON2] = ACTIONS(101),
    [anon_sym_AMP_DOT] = ACTIONS(101),
    [anon_sym_PLUS_EQ] = ACTIONS(101),
    [anon_sym_DASH_EQ] = ACTIONS(101),
    [anon_sym_STAR_EQ] = ACTIONS(101),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(101),
    [anon_sym_SLASH_EQ] = ACTIONS(101),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(101),
    [anon_sym_PIPE_EQ] = ACTIONS(101),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(101),
    [anon_sym_AMP_EQ] = ACTIONS(101),
    [anon_sym_PERCENT_EQ] = ACTIONS(101),
    [anon_sym_GT_GT_EQ] = ACTIONS(101),
    [anon_sym_LT_LT_EQ] = ACTIONS(101),
    [anon_sym_CARET_EQ] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_DOT_DOT] = ACTIONS(103),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_and] = ACTIONS(101),
    [anon_sym_or] = ACTIONS(101),
    [anon_sym_PIPE_PIPE] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_LT_LT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_EQ_EQ] = ACTIONS(103),
    [anon_sym_BANG_EQ] = ACTIONS(101),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(101),
    [anon_sym_LT_EQ_GT] = ACTIONS(101),
    [anon_sym_EQ_TILDE] = ACTIONS(101),
    [anon_sym_BANG_TILDE] = ACTIONS(101),
    [anon_sym_LT_EQ] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_EQ] = ACTIONS(101),
    [anon_sym_CARET] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [sym_comment] = ACTIONS(87),
  },
  [1466] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(3582),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(5979),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [1467] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(3584),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(5981),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [1468] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(3586),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(5983),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [1469] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(3588),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(5985),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [1470] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(3591),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(5987),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(5989),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [1471] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(3594),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(5991),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(5993),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [1472] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(3595),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(1498),
    [sym_scope_resolution] = STATE(1496),
    [sym_call] = STATE(1496),
    [sym_method_call] = STATE(1498),
    [sym_assignment] = STATE(3595),
    [sym_operator_assignment] = STATE(3595),
    [sym_conditional] = STATE(3595),
    [sym_range] = STATE(3595),
    [sym_binary] = STATE(3595),
    [sym_unary] = STATE(3595),
    [sym_left_assignment_list] = STATE(1497),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1498),
    [sym__variable] = STATE(1496),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(1498),
    [sym_false] = STATE(1498),
    [sym_nil] = STATE(1498),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(1499),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(2565),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(2577),
    [anon_sym_yield] = ACTIONS(2579),
    [anon_sym_break] = ACTIONS(2581),
    [anon_sym_next] = ACTIONS(2583),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(2601),
    [anon_sym_defined_QMARK] = ACTIONS(2603),
    [anon_sym_not] = ACTIONS(2605),
    [anon_sym_BANG] = ACTIONS(2607),
    [anon_sym_TILDE] = ACTIONS(2607),
    [sym_constant] = ACTIONS(2609),
    [sym_identifier] = ACTIONS(2609),
    [sym_instance_variable] = ACTIONS(2611),
    [sym_class_variable] = ACTIONS(2611),
    [sym_global_variable] = ACTIONS(2611),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(2609),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2609),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [1473] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(113),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(118),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(118),
    [sym_hash_splat_argument] = STATE(116),
    [sym_assignment] = STATE(113),
    [sym_operator_assignment] = STATE(113),
    [sym_conditional] = STATE(113),
    [sym_range] = STATE(113),
    [sym_binary] = STATE(113),
    [sym_unary] = STATE(113),
    [sym_left_assignment_list] = STATE(117),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(118),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(118),
    [sym_false] = STATE(118),
    [sym_nil] = STATE(118),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(119),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_heredoc_body] = STATE(3597),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym__hash_items] = STATE(3598),
    [sym_pair] = STATE(122),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [sym__identifier_hash_key] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_RBRACE] = ACTIONS(5995),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(209),
    [sym_identifier] = ACTIONS(209),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1474] = {
    [sym__method_rest] = STATE(3600),
    [sym__variable] = STATE(3601),
    [sym_operator] = STATE(3602),
    [sym__method_name] = STATE(3602),
    [sym_setter] = STATE(3602),
    [sym_symbol] = STATE(3602),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_LPAREN] = ACTIONS(5997),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(239),
    [sym_identifier] = ACTIONS(241),
    [sym_instance_variable] = ACTIONS(239),
    [sym_class_variable] = ACTIONS(239),
    [sym_global_variable] = ACTIONS(239),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
    [sym_super] = ACTIONS(5999),
    [sym_self] = ACTIONS(5999),
  },
  [1475] = {
    [sym__statements] = STATE(3604),
    [sym_begin_block] = STATE(144),
    [sym_end_block] = STATE(144),
    [sym__statement] = STATE(144),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(144),
    [sym_unless_modifier] = STATE(144),
    [sym_while_modifier] = STATE(144),
    [sym_until_modifier] = STATE(144),
    [sym_rescue_modifier] = STATE(144),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(145),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(150),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(150),
    [sym_assignment] = STATE(145),
    [sym_operator_assignment] = STATE(145),
    [sym_conditional] = STATE(145),
    [sym_range] = STATE(145),
    [sym_binary] = STATE(145),
    [sym_unary] = STATE(145),
    [sym_left_assignment_list] = STATE(147),
    [sym__mlhs] = STATE(148),
    [sym_destructured_left_assignment] = STATE(149),
    [sym_rest_assignment] = STATE(149),
    [sym__lhs] = STATE(150),
    [sym__variable] = STATE(146),
    [sym_undef] = STATE(144),
    [sym_alias] = STATE(144),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(150),
    [sym_false] = STATE(150),
    [sym_nil] = STATE(150),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(151),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(152),
    [aux_sym__statements_repeat1] = STATE(152),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_RPAREN] = ACTIONS(6001),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(249),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [anon_sym_undef] = ACTIONS(271),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1476] = {
    [sym_method] = STATE(191),
    [sym_singleton_method] = STATE(191),
    [sym_class] = STATE(191),
    [sym_singleton_class] = STATE(191),
    [sym_module] = STATE(191),
    [sym_return] = STATE(191),
    [sym_yield] = STATE(191),
    [sym_break] = STATE(191),
    [sym_next] = STATE(191),
    [sym_while] = STATE(191),
    [sym_until] = STATE(191),
    [sym_for] = STATE(191),
    [sym_case] = STATE(191),
    [sym_if] = STATE(191),
    [sym_unless] = STATE(191),
    [sym_begin] = STATE(191),
    [sym__primary] = STATE(191),
    [sym_parenthesized_statements] = STATE(191),
    [sym_element_reference] = STATE(191),
    [sym_scope_resolution] = STATE(3607),
    [sym_call] = STATE(193),
    [sym_method_call] = STATE(191),
    [sym__lhs] = STATE(191),
    [sym__variable] = STATE(193),
    [sym_rational] = STATE(191),
    [sym_true] = STATE(191),
    [sym_false] = STATE(191),
    [sym_nil] = STATE(191),
    [sym_chained_string] = STATE(191),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(191),
    [sym_string_array] = STATE(191),
    [sym_symbol_array] = STATE(191),
    [sym_symbol] = STATE(191),
    [sym_regex] = STATE(191),
    [sym_array] = STATE(191),
    [sym_hash] = STATE(191),
    [sym_lambda] = STATE(191),
    [sym__simple_symbol] = ACTIONS(279),
    [sym__string_start] = ACTIONS(281),
    [sym__symbol_start] = ACTIONS(283),
    [sym__subshell_start] = ACTIONS(285),
    [sym__regex_start] = ACTIONS(287),
    [sym__string_array_start] = ACTIONS(289),
    [sym__symbol_array_start] = ACTIONS(291),
    [sym_heredoc_beginning] = ACTIONS(349),
    [sym__singleton_class_left_angle_left_langle] = ACTIONS(6003),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_def] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(299),
    [anon_sym_COLON_COLON] = ACTIONS(353),
    [anon_sym_class] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(307),
    [anon_sym_return] = ACTIONS(309),
    [anon_sym_yield] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_next] = ACTIONS(315),
    [sym_redo] = ACTIONS(355),
    [sym_retry] = ACTIONS(355),
    [anon_sym_if] = ACTIONS(319),
    [anon_sym_unless] = ACTIONS(321),
    [anon_sym_while] = ACTIONS(323),
    [anon_sym_until] = ACTIONS(325),
    [anon_sym_for] = ACTIONS(327),
    [anon_sym_case] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(331),
    [sym_constant] = ACTIONS(6005),
    [sym_identifier] = ACTIONS(359),
    [sym_instance_variable] = ACTIONS(361),
    [sym_class_variable] = ACTIONS(361),
    [sym_global_variable] = ACTIONS(361),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(355),
    [sym_complex] = ACTIONS(349),
    [sym_super] = ACTIONS(359),
    [anon_sym_true] = ACTIONS(339),
    [anon_sym_TRUE] = ACTIONS(339),
    [anon_sym_false] = ACTIONS(341),
    [anon_sym_FALSE] = ACTIONS(341),
    [sym_self] = ACTIONS(359),
    [anon_sym_nil] = ACTIONS(343),
    [anon_sym_NIL] = ACTIONS(343),
    [sym_character] = ACTIONS(349),
    [anon_sym_LBRACK2] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(347),
  },
  [1477] = {
    [sym_method] = STATE(191),
    [sym_singleton_method] = STATE(191),
    [sym_class] = STATE(191),
    [sym_singleton_class] = STATE(191),
    [sym_module] = STATE(191),
    [sym_return] = STATE(191),
    [sym_yield] = STATE(191),
    [sym_break] = STATE(191),
    [sym_next] = STATE(191),
    [sym_while] = STATE(191),
    [sym_until] = STATE(191),
    [sym_for] = STATE(191),
    [sym_case] = STATE(191),
    [sym_if] = STATE(191),
    [sym_unless] = STATE(191),
    [sym_begin] = STATE(191),
    [sym__primary] = STATE(191),
    [sym_parenthesized_statements] = STATE(191),
    [sym_element_reference] = STATE(191),
    [sym_scope_resolution] = STATE(3609),
    [sym_call] = STATE(193),
    [sym_method_call] = STATE(191),
    [sym__lhs] = STATE(191),
    [sym__variable] = STATE(193),
    [sym_rational] = STATE(191),
    [sym_true] = STATE(191),
    [sym_false] = STATE(191),
    [sym_nil] = STATE(191),
    [sym_chained_string] = STATE(191),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(191),
    [sym_string_array] = STATE(191),
    [sym_symbol_array] = STATE(191),
    [sym_symbol] = STATE(191),
    [sym_regex] = STATE(191),
    [sym_array] = STATE(191),
    [sym_hash] = STATE(191),
    [sym_lambda] = STATE(191),
    [sym__simple_symbol] = ACTIONS(279),
    [sym__string_start] = ACTIONS(281),
    [sym__symbol_start] = ACTIONS(283),
    [sym__subshell_start] = ACTIONS(285),
    [sym__regex_start] = ACTIONS(287),
    [sym__string_array_start] = ACTIONS(289),
    [sym__symbol_array_start] = ACTIONS(291),
    [sym_heredoc_beginning] = ACTIONS(349),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_def] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(299),
    [anon_sym_COLON_COLON] = ACTIONS(353),
    [anon_sym_class] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(307),
    [anon_sym_return] = ACTIONS(309),
    [anon_sym_yield] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_next] = ACTIONS(315),
    [sym_redo] = ACTIONS(355),
    [sym_retry] = ACTIONS(355),
    [anon_sym_if] = ACTIONS(319),
    [anon_sym_unless] = ACTIONS(321),
    [anon_sym_while] = ACTIONS(323),
    [anon_sym_until] = ACTIONS(325),
    [anon_sym_for] = ACTIONS(327),
    [anon_sym_case] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(331),
    [sym_constant] = ACTIONS(6007),
    [sym_identifier] = ACTIONS(359),
    [sym_instance_variable] = ACTIONS(361),
    [sym_class_variable] = ACTIONS(361),
    [sym_global_variable] = ACTIONS(361),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(355),
    [sym_complex] = ACTIONS(349),
    [sym_super] = ACTIONS(359),
    [anon_sym_true] = ACTIONS(339),
    [anon_sym_TRUE] = ACTIONS(339),
    [anon_sym_false] = ACTIONS(341),
    [anon_sym_FALSE] = ACTIONS(341),
    [sym_self] = ACTIONS(359),
    [anon_sym_nil] = ACTIONS(343),
    [anon_sym_NIL] = ACTIONS(343),
    [sym_character] = ACTIONS(349),
    [anon_sym_LBRACK2] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(347),
  },
  [1478] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(420),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(428),
    [sym_scope_resolution] = STATE(422),
    [sym_call] = STATE(422),
    [sym_method_call] = STATE(428),
    [sym_argument_list] = STATE(3610),
    [sym__argument_list_with_parens] = STATE(424),
    [sym__argument] = STATE(425),
    [sym_splat_argument] = STATE(425),
    [sym_hash_splat_argument] = STATE(425),
    [sym_block_argument] = STATE(425),
    [sym_assignment] = STATE(420),
    [sym_operator_assignment] = STATE(420),
    [sym_conditional] = STATE(420),
    [sym_range] = STATE(420),
    [sym_binary] = STATE(420),
    [sym_unary] = STATE(420),
    [sym_left_assignment_list] = STATE(427),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(428),
    [sym__variable] = STATE(422),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(428),
    [sym_false] = STATE(428),
    [sym_nil] = STATE(428),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(429),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(425),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(761),
    [sym__splat_star] = ACTIONS(763),
    [sym__unary_minus] = ACTIONS(765),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(767),
    [ts_builtin_sym_end] = ACTIONS(365),
    [anon_sym___END__] = ACTIONS(377),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(781),
    [anon_sym_yield] = ACTIONS(783),
    [anon_sym_break] = ACTIONS(785),
    [anon_sym_next] = ACTIONS(787),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(365),
    [anon_sym_DASH_EQ] = ACTIONS(365),
    [anon_sym_STAR_EQ] = ACTIONS(365),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(365),
    [anon_sym_SLASH_EQ] = ACTIONS(365),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(365),
    [anon_sym_PIPE_EQ] = ACTIONS(365),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(365),
    [anon_sym_AMP_EQ] = ACTIONS(365),
    [anon_sym_PERCENT_EQ] = ACTIONS(365),
    [anon_sym_GT_GT_EQ] = ACTIONS(365),
    [anon_sym_LT_LT_EQ] = ACTIONS(365),
    [anon_sym_CARET_EQ] = ACTIONS(365),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_PERCENT] = ACTIONS(377),
    [anon_sym_defined_QMARK] = ACTIONS(801),
    [anon_sym_not] = ACTIONS(803),
    [anon_sym_BANG] = ACTIONS(805),
    [anon_sym_TILDE] = ACTIONS(807),
    [sym_constant] = ACTIONS(809),
    [sym_identifier] = ACTIONS(809),
    [sym_instance_variable] = ACTIONS(811),
    [sym_class_variable] = ACTIONS(811),
    [sym_global_variable] = ACTIONS(811),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(815),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(815),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [1479] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(420),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(428),
    [sym_scope_resolution] = STATE(422),
    [sym_call] = STATE(422),
    [sym_method_call] = STATE(428),
    [sym_argument_list] = STATE(3611),
    [sym__argument_list_with_parens] = STATE(424),
    [sym__argument] = STATE(425),
    [sym_splat_argument] = STATE(425),
    [sym_hash_splat_argument] = STATE(425),
    [sym_block_argument] = STATE(425),
    [sym_assignment] = STATE(420),
    [sym_operator_assignment] = STATE(420),
    [sym_conditional] = STATE(420),
    [sym_range] = STATE(420),
    [sym_binary] = STATE(420),
    [sym_unary] = STATE(420),
    [sym_left_assignment_list] = STATE(427),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(428),
    [sym__variable] = STATE(422),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(428),
    [sym_false] = STATE(428),
    [sym_nil] = STATE(428),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(429),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(425),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(761),
    [sym__splat_star] = ACTIONS(763),
    [sym__unary_minus] = ACTIONS(765),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(767),
    [ts_builtin_sym_end] = ACTIONS(417),
    [anon_sym___END__] = ACTIONS(419),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_EQ] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(781),
    [anon_sym_yield] = ACTIONS(783),
    [anon_sym_break] = ACTIONS(785),
    [anon_sym_next] = ACTIONS(787),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(417),
    [anon_sym_DASH_EQ] = ACTIONS(417),
    [anon_sym_STAR_EQ] = ACTIONS(417),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(417),
    [anon_sym_SLASH_EQ] = ACTIONS(417),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(417),
    [anon_sym_PIPE_EQ] = ACTIONS(417),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(417),
    [anon_sym_AMP_EQ] = ACTIONS(417),
    [anon_sym_PERCENT_EQ] = ACTIONS(417),
    [anon_sym_GT_GT_EQ] = ACTIONS(417),
    [anon_sym_LT_LT_EQ] = ACTIONS(417),
    [anon_sym_CARET_EQ] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(801),
    [anon_sym_not] = ACTIONS(803),
    [anon_sym_BANG] = ACTIONS(805),
    [anon_sym_TILDE] = ACTIONS(807),
    [sym_constant] = ACTIONS(809),
    [sym_identifier] = ACTIONS(809),
    [sym_instance_variable] = ACTIONS(811),
    [sym_class_variable] = ACTIONS(811),
    [sym_global_variable] = ACTIONS(811),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(815),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(815),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [1480] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(420),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(428),
    [sym_scope_resolution] = STATE(422),
    [sym_call] = STATE(422),
    [sym_method_call] = STATE(428),
    [sym_argument_list] = STATE(3612),
    [sym__argument_list_with_parens] = STATE(424),
    [sym__argument] = STATE(425),
    [sym_splat_argument] = STATE(425),
    [sym_hash_splat_argument] = STATE(425),
    [sym_block_argument] = STATE(425),
    [sym_assignment] = STATE(420),
    [sym_operator_assignment] = STATE(420),
    [sym_conditional] = STATE(420),
    [sym_range] = STATE(420),
    [sym_binary] = STATE(420),
    [sym_unary] = STATE(420),
    [sym_left_assignment_list] = STATE(427),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(428),
    [sym__variable] = STATE(422),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(428),
    [sym_false] = STATE(428),
    [sym_nil] = STATE(428),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(429),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(425),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(761),
    [sym__splat_star] = ACTIONS(763),
    [sym__unary_minus] = ACTIONS(765),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(767),
    [ts_builtin_sym_end] = ACTIONS(421),
    [anon_sym___END__] = ACTIONS(423),
    [anon_sym_LBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_EQ] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(781),
    [anon_sym_yield] = ACTIONS(783),
    [anon_sym_break] = ACTIONS(785),
    [anon_sym_next] = ACTIONS(787),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(421),
    [anon_sym_DASH_EQ] = ACTIONS(421),
    [anon_sym_STAR_EQ] = ACTIONS(421),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(421),
    [anon_sym_SLASH_EQ] = ACTIONS(421),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(421),
    [anon_sym_PIPE_EQ] = ACTIONS(421),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(421),
    [anon_sym_AMP_EQ] = ACTIONS(421),
    [anon_sym_PERCENT_EQ] = ACTIONS(421),
    [anon_sym_GT_GT_EQ] = ACTIONS(421),
    [anon_sym_LT_LT_EQ] = ACTIONS(421),
    [anon_sym_CARET_EQ] = ACTIONS(421),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(801),
    [anon_sym_not] = ACTIONS(803),
    [anon_sym_BANG] = ACTIONS(805),
    [anon_sym_TILDE] = ACTIONS(807),
    [sym_constant] = ACTIONS(809),
    [sym_identifier] = ACTIONS(809),
    [sym_instance_variable] = ACTIONS(811),
    [sym_class_variable] = ACTIONS(811),
    [sym_global_variable] = ACTIONS(811),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(815),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(815),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [1481] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(420),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(428),
    [sym_scope_resolution] = STATE(422),
    [sym_call] = STATE(422),
    [sym_method_call] = STATE(428),
    [sym_argument_list] = STATE(3613),
    [sym__argument_list_with_parens] = STATE(424),
    [sym__argument] = STATE(425),
    [sym_splat_argument] = STATE(425),
    [sym_hash_splat_argument] = STATE(425),
    [sym_block_argument] = STATE(425),
    [sym_assignment] = STATE(420),
    [sym_operator_assignment] = STATE(420),
    [sym_conditional] = STATE(420),
    [sym_range] = STATE(420),
    [sym_binary] = STATE(420),
    [sym_unary] = STATE(420),
    [sym_left_assignment_list] = STATE(427),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(428),
    [sym__variable] = STATE(422),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(428),
    [sym_false] = STATE(428),
    [sym_nil] = STATE(428),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(429),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(425),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(761),
    [sym__splat_star] = ACTIONS(763),
    [sym__unary_minus] = ACTIONS(765),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(767),
    [ts_builtin_sym_end] = ACTIONS(425),
    [anon_sym___END__] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(427),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(781),
    [anon_sym_yield] = ACTIONS(783),
    [anon_sym_break] = ACTIONS(785),
    [anon_sym_next] = ACTIONS(787),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(425),
    [anon_sym_DASH_EQ] = ACTIONS(425),
    [anon_sym_STAR_EQ] = ACTIONS(425),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(425),
    [anon_sym_SLASH_EQ] = ACTIONS(425),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(425),
    [anon_sym_PIPE_EQ] = ACTIONS(425),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(425),
    [anon_sym_AMP_EQ] = ACTIONS(425),
    [anon_sym_PERCENT_EQ] = ACTIONS(425),
    [anon_sym_GT_GT_EQ] = ACTIONS(425),
    [anon_sym_LT_LT_EQ] = ACTIONS(425),
    [anon_sym_CARET_EQ] = ACTIONS(425),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(801),
    [anon_sym_not] = ACTIONS(803),
    [anon_sym_BANG] = ACTIONS(805),
    [anon_sym_TILDE] = ACTIONS(807),
    [sym_constant] = ACTIONS(809),
    [sym_identifier] = ACTIONS(809),
    [sym_instance_variable] = ACTIONS(811),
    [sym_class_variable] = ACTIONS(811),
    [sym_global_variable] = ACTIONS(811),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(815),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(815),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [1482] = {
    [sym_begin_block] = STATE(3614),
    [sym_end_block] = STATE(3614),
    [sym__statement] = STATE(3614),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(3614),
    [sym_unless_modifier] = STATE(3614),
    [sym_while_modifier] = STATE(3614),
    [sym_until_modifier] = STATE(3614),
    [sym_rescue_modifier] = STATE(3614),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(234),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(234),
    [sym_operator_assignment] = STATE(234),
    [sym_conditional] = STATE(234),
    [sym_range] = STATE(234),
    [sym_binary] = STATE(234),
    [sym_unary] = STATE(234),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_undef] = STATE(3614),
    [sym_alias] = STATE(3614),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(429),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_yield] = ACTIONS(433),
    [anon_sym_break] = ACTIONS(435),
    [anon_sym_next] = ACTIONS(437),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(439),
    [anon_sym_defined_QMARK] = ACTIONS(441),
    [anon_sym_not] = ACTIONS(443),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [anon_sym_undef] = ACTIONS(451),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1483] = {
    [sym_begin_block] = STATE(3615),
    [sym_end_block] = STATE(3615),
    [sym__statement] = STATE(3615),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(3615),
    [sym_unless_modifier] = STATE(3615),
    [sym_while_modifier] = STATE(3615),
    [sym_until_modifier] = STATE(3615),
    [sym_rescue_modifier] = STATE(3615),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(234),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(234),
    [sym_operator_assignment] = STATE(234),
    [sym_conditional] = STATE(234),
    [sym_range] = STATE(234),
    [sym_binary] = STATE(234),
    [sym_unary] = STATE(234),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_undef] = STATE(3615),
    [sym_alias] = STATE(3615),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(429),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_yield] = ACTIONS(433),
    [anon_sym_break] = ACTIONS(435),
    [anon_sym_next] = ACTIONS(437),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(439),
    [anon_sym_defined_QMARK] = ACTIONS(441),
    [anon_sym_not] = ACTIONS(443),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [anon_sym_undef] = ACTIONS(451),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1484] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(3616),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(3616),
    [sym_operator_assignment] = STATE(3616),
    [sym_conditional] = STATE(3616),
    [sym_range] = STATE(3616),
    [sym_binary] = STATE(3616),
    [sym_unary] = STATE(3616),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(455),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_break] = ACTIONS(459),
    [anon_sym_next] = ACTIONS(461),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_defined_QMARK] = ACTIONS(465),
    [anon_sym_not] = ACTIONS(467),
    [anon_sym_BANG] = ACTIONS(469),
    [anon_sym_TILDE] = ACTIONS(469),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1485] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(3617),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(3617),
    [sym_operator_assignment] = STATE(3617),
    [sym_conditional] = STATE(3617),
    [sym_range] = STATE(3617),
    [sym_binary] = STATE(3617),
    [sym_unary] = STATE(3617),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(455),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_break] = ACTIONS(459),
    [anon_sym_next] = ACTIONS(461),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_defined_QMARK] = ACTIONS(465),
    [anon_sym_not] = ACTIONS(467),
    [anon_sym_BANG] = ACTIONS(469),
    [anon_sym_TILDE] = ACTIONS(469),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1486] = {
    [sym_method] = STATE(184),
    [sym_singleton_method] = STATE(184),
    [sym_class] = STATE(184),
    [sym_singleton_class] = STATE(184),
    [sym_module] = STATE(184),
    [sym_return] = STATE(184),
    [sym_yield] = STATE(184),
    [sym_break] = STATE(184),
    [sym_next] = STATE(184),
    [sym_while] = STATE(184),
    [sym_until] = STATE(184),
    [sym_for] = STATE(184),
    [sym_case] = STATE(184),
    [sym_if] = STATE(184),
    [sym_unless] = STATE(184),
    [sym_begin] = STATE(184),
    [sym__primary] = STATE(184),
    [sym_parenthesized_statements] = STATE(184),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(255),
    [sym_call] = STATE(255),
    [sym_method_call] = STATE(258),
    [sym__mlhs] = STATE(3618),
    [sym_destructured_left_assignment] = STATE(257),
    [sym_rest_assignment] = STATE(257),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(255),
    [sym_rational] = STATE(184),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(184),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(184),
    [sym_string_array] = STATE(184),
    [sym_symbol_array] = STATE(184),
    [sym_symbol] = STATE(184),
    [sym_regex] = STATE(184),
    [sym_array] = STATE(184),
    [sym_hash] = STATE(184),
    [sym_lambda] = STATE(184),
    [sym__simple_symbol] = ACTIONS(279),
    [sym__string_start] = ACTIONS(281),
    [sym__symbol_start] = ACTIONS(283),
    [sym__subshell_start] = ACTIONS(285),
    [sym__regex_start] = ACTIONS(287),
    [sym__string_array_start] = ACTIONS(289),
    [sym__symbol_array_start] = ACTIONS(291),
    [sym_heredoc_beginning] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_def] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(475),
    [anon_sym_COLON_COLON] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(477),
    [anon_sym_class] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(307),
    [anon_sym_return] = ACTIONS(309),
    [anon_sym_yield] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_next] = ACTIONS(315),
    [sym_redo] = ACTIONS(317),
    [sym_retry] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(319),
    [anon_sym_unless] = ACTIONS(321),
    [anon_sym_while] = ACTIONS(323),
    [anon_sym_until] = ACTIONS(325),
    [anon_sym_for] = ACTIONS(327),
    [anon_sym_case] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(331),
    [sym_constant] = ACTIONS(479),
    [sym_identifier] = ACTIONS(479),
    [sym_instance_variable] = ACTIONS(481),
    [sym_class_variable] = ACTIONS(481),
    [sym_global_variable] = ACTIONS(481),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(317),
    [sym_complex] = ACTIONS(293),
    [sym_super] = ACTIONS(479),
    [anon_sym_true] = ACTIONS(339),
    [anon_sym_TRUE] = ACTIONS(339),
    [anon_sym_false] = ACTIONS(341),
    [anon_sym_FALSE] = ACTIONS(341),
    [sym_self] = ACTIONS(479),
    [anon_sym_nil] = ACTIONS(343),
    [anon_sym_NIL] = ACTIONS(343),
    [sym_character] = ACTIONS(293),
    [anon_sym_LBRACK2] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(347),
  },
  [1487] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(3619),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(3619),
    [sym_operator_assignment] = STATE(3619),
    [sym_conditional] = STATE(3619),
    [sym_range] = STATE(3619),
    [sym_binary] = STATE(3619),
    [sym_unary] = STATE(3619),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_heredoc_body] = STATE(3620),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__terminator] = STATE(3620),
    [sym__line_break] = ACTIONS(6009),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(485),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(6009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(495),
    [anon_sym_defined_QMARK] = ACTIONS(497),
    [anon_sym_not] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(501),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1488] = {
    [sym__statements] = STATE(3621),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(3622),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(3623),
    [sym_rescue] = STATE(3624),
    [sym__body_statement] = STATE(3625),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_heredoc_body] = STATE(3626),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [sym__terminator] = STATE(3626),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__line_break] = ACTIONS(6011),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(6011),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(6013),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1489] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(3627),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(1498),
    [sym_scope_resolution] = STATE(1496),
    [sym_call] = STATE(1496),
    [sym_method_call] = STATE(1498),
    [sym_assignment] = STATE(3627),
    [sym_operator_assignment] = STATE(3627),
    [sym_conditional] = STATE(3627),
    [sym_range] = STATE(3627),
    [sym_binary] = STATE(3627),
    [sym_unary] = STATE(3627),
    [sym_left_assignment_list] = STATE(1497),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1498),
    [sym__variable] = STATE(1496),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(1498),
    [sym_false] = STATE(1498),
    [sym_nil] = STATE(1498),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(1499),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(2565),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(2577),
    [anon_sym_yield] = ACTIONS(2579),
    [anon_sym_break] = ACTIONS(2581),
    [anon_sym_next] = ACTIONS(2583),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(2601),
    [anon_sym_defined_QMARK] = ACTIONS(2603),
    [anon_sym_not] = ACTIONS(2605),
    [anon_sym_BANG] = ACTIONS(2607),
    [anon_sym_TILDE] = ACTIONS(2607),
    [sym_constant] = ACTIONS(2609),
    [sym_identifier] = ACTIONS(2609),
    [sym_instance_variable] = ACTIONS(2611),
    [sym_class_variable] = ACTIONS(2611),
    [sym_global_variable] = ACTIONS(2611),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(2609),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2609),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [1490] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(3628),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(1498),
    [sym_scope_resolution] = STATE(1496),
    [sym_call] = STATE(1496),
    [sym_method_call] = STATE(1498),
    [sym_assignment] = STATE(3628),
    [sym_operator_assignment] = STATE(3628),
    [sym_conditional] = STATE(3628),
    [sym_range] = STATE(3628),
    [sym_binary] = STATE(3628),
    [sym_unary] = STATE(3628),
    [sym_left_assignment_list] = STATE(1497),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1498),
    [sym__variable] = STATE(1496),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(1498),
    [sym_false] = STATE(1498),
    [sym_nil] = STATE(1498),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(1499),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(2565),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(2577),
    [anon_sym_yield] = ACTIONS(2579),
    [anon_sym_break] = ACTIONS(2581),
    [anon_sym_next] = ACTIONS(2583),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(2601),
    [anon_sym_defined_QMARK] = ACTIONS(2603),
    [anon_sym_not] = ACTIONS(2605),
    [anon_sym_BANG] = ACTIONS(2607),
    [anon_sym_TILDE] = ACTIONS(2607),
    [sym_constant] = ACTIONS(2609),
    [sym_identifier] = ACTIONS(2609),
    [sym_instance_variable] = ACTIONS(2611),
    [sym_class_variable] = ACTIONS(2611),
    [sym_global_variable] = ACTIONS(2611),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(2609),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2609),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [1491] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(559),
    [anon_sym___END__] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_when] = ACTIONS(559),
    [anon_sym_elsif] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
    [anon_sym_r] = ACTIONS(6015),
  },
  [1492] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(346),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(352),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(352),
    [sym__argument_list_with_trailing_comma] = STATE(3631),
    [sym__argument] = STATE(350),
    [sym_splat_argument] = STATE(350),
    [sym_hash_splat_argument] = STATE(350),
    [sym_block_argument] = STATE(350),
    [sym_assignment] = STATE(346),
    [sym_operator_assignment] = STATE(346),
    [sym_conditional] = STATE(346),
    [sym_range] = STATE(346),
    [sym_binary] = STATE(346),
    [sym_unary] = STATE(346),
    [sym_left_assignment_list] = STATE(351),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(352),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(352),
    [sym_false] = STATE(352),
    [sym_nil] = STATE(352),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(353),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(350),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(593),
    [sym__splat_star] = ACTIONS(595),
    [sym__unary_minus] = ACTIONS(597),
    [sym__identifier_hash_key] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(6017),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1493] = {
    [sym_lambda_parameters] = STATE(3632),
    [sym__simple_formal_parameter] = STATE(362),
    [sym_splat_parameter] = STATE(362),
    [sym_hash_splat_parameter] = STATE(362),
    [sym_block_parameter] = STATE(362),
    [sym_keyword_parameter] = STATE(362),
    [sym_optional_parameter] = STATE(362),
    [sym_do_block] = STATE(3633),
    [sym_block] = STATE(3633),
    [anon_sym_LBRACE] = ACTIONS(2719),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(793),
    [sym_identifier] = ACTIONS(679),
    [sym_comment] = ACTIONS(87),
  },
  [1494] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(6019),
    [sym__binary_star] = ACTIONS(6021),
    [ts_builtin_sym_end] = ACTIONS(4211),
    [anon_sym___END__] = ACTIONS(4211),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(6023),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_AMP] = ACTIONS(6027),
    [anon_sym_EQ] = ACTIONS(4217),
    [anon_sym_LT] = ACTIONS(6029),
    [anon_sym_if] = ACTIONS(4211),
    [anon_sym_unless] = ACTIONS(4211),
    [anon_sym_while] = ACTIONS(4211),
    [anon_sym_until] = ACTIONS(4211),
    [anon_sym_rescue] = ACTIONS(4211),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_PLUS_EQ] = ACTIONS(4211),
    [anon_sym_DASH_EQ] = ACTIONS(4211),
    [anon_sym_STAR_EQ] = ACTIONS(4211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4211),
    [anon_sym_SLASH_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4211),
    [anon_sym_AMP_EQ] = ACTIONS(4211),
    [anon_sym_PERCENT_EQ] = ACTIONS(4211),
    [anon_sym_GT_GT_EQ] = ACTIONS(4211),
    [anon_sym_LT_LT_EQ] = ACTIONS(4211),
    [anon_sym_CARET_EQ] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(6031),
    [anon_sym_DOT_DOT] = ACTIONS(6033),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6035),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(6037),
    [anon_sym_AMP_AMP] = ACTIONS(6037),
    [anon_sym_LT_LT] = ACTIONS(6039),
    [anon_sym_GT_GT] = ACTIONS(6039),
    [anon_sym_EQ_EQ] = ACTIONS(6037),
    [anon_sym_BANG_EQ] = ACTIONS(6041),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6041),
    [anon_sym_LT_EQ_GT] = ACTIONS(6041),
    [anon_sym_EQ_TILDE] = ACTIONS(6041),
    [anon_sym_BANG_TILDE] = ACTIONS(6041),
    [anon_sym_LT_EQ] = ACTIONS(6029),
    [anon_sym_GT] = ACTIONS(6029),
    [anon_sym_GT_EQ] = ACTIONS(6043),
    [anon_sym_CARET] = ACTIONS(6023),
    [anon_sym_PLUS] = ACTIONS(6045),
    [anon_sym_SLASH] = ACTIONS(6025),
    [anon_sym_PERCENT] = ACTIONS(6025),
    [sym_comment] = ACTIONS(87),
  },
  [1495] = {
    [sym__line_break] = ACTIONS(731),
    [sym__heredoc_body_start] = ACTIONS(731),
    [sym__binary_minus] = ACTIONS(731),
    [sym__binary_star] = ACTIONS(731),
    [ts_builtin_sym_end] = ACTIONS(731),
    [anon_sym___END__] = ACTIONS(731),
    [anon_sym_LBRACE] = ACTIONS(731),
    [anon_sym_RBRACE] = ACTIONS(731),
    [anon_sym_RPAREN] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(731),
    [anon_sym_PIPE] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(731),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_AMP] = ACTIONS(735),
    [anon_sym_EQ] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(735),
    [anon_sym_end] = ACTIONS(731),
    [anon_sym_if] = ACTIONS(731),
    [anon_sym_unless] = ACTIONS(731),
    [anon_sym_while] = ACTIONS(731),
    [anon_sym_until] = ACTIONS(731),
    [anon_sym_rescue] = ACTIONS(731),
    [anon_sym_do] = ACTIONS(731),
    [anon_sym_when] = ACTIONS(731),
    [anon_sym_elsif] = ACTIONS(731),
    [anon_sym_else] = ACTIONS(731),
    [anon_sym_then] = ACTIONS(731),
    [anon_sym_ensure] = ACTIONS(731),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_COLON_COLON2] = ACTIONS(739),
    [anon_sym_AMP_DOT] = ACTIONS(741),
    [anon_sym_PLUS_EQ] = ACTIONS(731),
    [anon_sym_DASH_EQ] = ACTIONS(731),
    [anon_sym_STAR_EQ] = ACTIONS(731),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(731),
    [anon_sym_SLASH_EQ] = ACTIONS(731),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(731),
    [anon_sym_PIPE_EQ] = ACTIONS(731),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(731),
    [anon_sym_AMP_EQ] = ACTIONS(731),
    [anon_sym_PERCENT_EQ] = ACTIONS(731),
    [anon_sym_GT_GT_EQ] = ACTIONS(731),
    [anon_sym_LT_LT_EQ] = ACTIONS(731),
    [anon_sym_CARET_EQ] = ACTIONS(731),
    [anon_sym_QMARK] = ACTIONS(731),
    [anon_sym_DOT_DOT] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(731),
    [anon_sym_or] = ACTIONS(731),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_EQ_EQ] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(731),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(731),
    [anon_sym_LT_EQ_GT] = ACTIONS(731),
    [anon_sym_EQ_TILDE] = ACTIONS(731),
    [anon_sym_BANG_TILDE] = ACTIONS(731),
    [anon_sym_LT_EQ] = ACTIONS(735),
    [anon_sym_GT] = ACTIONS(735),
    [anon_sym_GT_EQ] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_SLASH] = ACTIONS(735),
    [anon_sym_PERCENT] = ACTIONS(735),
    [sym_comment] = ACTIONS(87),
  },
  [1496] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(420),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(428),
    [sym_scope_resolution] = STATE(422),
    [sym_call] = STATE(422),
    [sym_method_call] = STATE(428),
    [sym_argument_list] = STATE(1062),
    [sym__argument_list_with_parens] = STATE(424),
    [sym__argument] = STATE(425),
    [sym_splat_argument] = STATE(425),
    [sym_hash_splat_argument] = STATE(425),
    [sym_block_argument] = STATE(425),
    [sym_do_block] = STATE(426),
    [sym_block] = STATE(426),
    [sym_assignment] = STATE(420),
    [sym_operator_assignment] = STATE(420),
    [sym_conditional] = STATE(420),
    [sym_range] = STATE(420),
    [sym_binary] = STATE(420),
    [sym_unary] = STATE(420),
    [sym_left_assignment_list] = STATE(427),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(428),
    [sym__variable] = STATE(422),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(428),
    [sym_false] = STATE(428),
    [sym_nil] = STATE(428),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(429),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(425),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(743),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(761),
    [sym__splat_star] = ACTIONS(763),
    [sym__unary_minus] = ACTIONS(765),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(767),
    [ts_builtin_sym_end] = ACTIONS(743),
    [anon_sym___END__] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(6047),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(781),
    [anon_sym_yield] = ACTIONS(783),
    [anon_sym_break] = ACTIONS(785),
    [anon_sym_next] = ACTIONS(787),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(769),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(769),
    [anon_sym_until] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(769),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(769),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(801),
    [anon_sym_not] = ACTIONS(803),
    [anon_sym_BANG] = ACTIONS(805),
    [anon_sym_TILDE] = ACTIONS(807),
    [sym_constant] = ACTIONS(809),
    [sym_identifier] = ACTIONS(809),
    [sym_instance_variable] = ACTIONS(811),
    [sym_class_variable] = ACTIONS(811),
    [sym_global_variable] = ACTIONS(811),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(815),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(815),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [1497] = {
    [anon_sym_EQ] = ACTIONS(6049),
    [sym_comment] = ACTIONS(87),
  },
  [1498] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(559),
    [anon_sym___END__] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(6051),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(6053),
    [anon_sym_DASH_EQ] = ACTIONS(6053),
    [anon_sym_STAR_EQ] = ACTIONS(6053),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6053),
    [anon_sym_SLASH_EQ] = ACTIONS(6053),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6053),
    [anon_sym_PIPE_EQ] = ACTIONS(6053),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6053),
    [anon_sym_AMP_EQ] = ACTIONS(6053),
    [anon_sym_PERCENT_EQ] = ACTIONS(6053),
    [anon_sym_GT_GT_EQ] = ACTIONS(6053),
    [anon_sym_LT_LT_EQ] = ACTIONS(6053),
    [anon_sym_CARET_EQ] = ACTIONS(6053),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1499] = {
    [sym_string] = STATE(3647),
    [aux_sym_chained_string_repeat1] = STATE(3647),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(2551),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(559),
    [anon_sym___END__] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1500] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(6019),
    [sym__binary_star] = ACTIONS(6021),
    [ts_builtin_sym_end] = ACTIONS(4247),
    [anon_sym___END__] = ACTIONS(4247),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(6023),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_AMP] = ACTIONS(6027),
    [anon_sym_EQ] = ACTIONS(4249),
    [anon_sym_LT] = ACTIONS(6029),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_PLUS_EQ] = ACTIONS(4247),
    [anon_sym_DASH_EQ] = ACTIONS(4247),
    [anon_sym_STAR_EQ] = ACTIONS(4247),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4247),
    [anon_sym_SLASH_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4247),
    [anon_sym_AMP_EQ] = ACTIONS(4247),
    [anon_sym_PERCENT_EQ] = ACTIONS(4247),
    [anon_sym_GT_GT_EQ] = ACTIONS(4247),
    [anon_sym_LT_LT_EQ] = ACTIONS(4247),
    [anon_sym_CARET_EQ] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(6031),
    [anon_sym_DOT_DOT] = ACTIONS(6033),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6035),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(6037),
    [anon_sym_AMP_AMP] = ACTIONS(6037),
    [anon_sym_LT_LT] = ACTIONS(6039),
    [anon_sym_GT_GT] = ACTIONS(6039),
    [anon_sym_EQ_EQ] = ACTIONS(6037),
    [anon_sym_BANG_EQ] = ACTIONS(6041),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6041),
    [anon_sym_LT_EQ_GT] = ACTIONS(6041),
    [anon_sym_EQ_TILDE] = ACTIONS(6041),
    [anon_sym_BANG_TILDE] = ACTIONS(6041),
    [anon_sym_LT_EQ] = ACTIONS(6029),
    [anon_sym_GT] = ACTIONS(6029),
    [anon_sym_GT_EQ] = ACTIONS(6043),
    [anon_sym_CARET] = ACTIONS(6023),
    [anon_sym_PLUS] = ACTIONS(6045),
    [anon_sym_SLASH] = ACTIONS(6025),
    [anon_sym_PERCENT] = ACTIONS(6025),
    [sym_comment] = ACTIONS(87),
  },
  [1501] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(113),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(118),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(118),
    [sym_hash_splat_argument] = STATE(116),
    [sym_assignment] = STATE(113),
    [sym_operator_assignment] = STATE(113),
    [sym_conditional] = STATE(113),
    [sym_range] = STATE(113),
    [sym_binary] = STATE(113),
    [sym_unary] = STATE(113),
    [sym_left_assignment_list] = STATE(117),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(118),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(118),
    [sym_false] = STATE(118),
    [sym_nil] = STATE(118),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(119),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_heredoc_body] = STATE(1521),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym__hash_items] = STATE(1522),
    [sym_pair] = STATE(122),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [sym__identifier_hash_key] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_RBRACE] = ACTIONS(6055),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(209),
    [sym_identifier] = ACTIONS(209),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1502] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [ts_builtin_sym_end] = ACTIONS(935),
    [anon_sym___END__] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(2693),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [1503] = {
    [sym_string] = STATE(1587),
    [aux_sym_chained_string_repeat1] = STATE(1587),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(747),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(559),
    [anon_sym___END__] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1504] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(3649),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(1498),
    [sym_scope_resolution] = STATE(1496),
    [sym_call] = STATE(1496),
    [sym_method_call] = STATE(1498),
    [sym_assignment] = STATE(3649),
    [sym_operator_assignment] = STATE(3649),
    [sym_conditional] = STATE(3649),
    [sym_range] = STATE(3649),
    [sym_binary] = STATE(3649),
    [sym_unary] = STATE(3649),
    [sym_left_assignment_list] = STATE(1497),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1498),
    [sym__variable] = STATE(1496),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(1498),
    [sym_false] = STATE(1498),
    [sym_nil] = STATE(1498),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(1499),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(2565),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(2577),
    [anon_sym_yield] = ACTIONS(2579),
    [anon_sym_break] = ACTIONS(2581),
    [anon_sym_next] = ACTIONS(2583),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(2601),
    [anon_sym_defined_QMARK] = ACTIONS(2603),
    [anon_sym_not] = ACTIONS(2605),
    [anon_sym_BANG] = ACTIONS(2607),
    [anon_sym_TILDE] = ACTIONS(2607),
    [sym_constant] = ACTIONS(2609),
    [sym_identifier] = ACTIONS(2609),
    [sym_instance_variable] = ACTIONS(2611),
    [sym_class_variable] = ACTIONS(2611),
    [sym_global_variable] = ACTIONS(2611),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(2609),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2609),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [1505] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3650),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1519),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1519),
    [sym_assignment] = STATE(3650),
    [sym_operator_assignment] = STATE(3650),
    [sym_conditional] = STATE(3650),
    [sym_range] = STATE(3650),
    [sym_binary] = STATE(3650),
    [sym_unary] = STATE(3650),
    [sym_left_assignment_list] = STATE(1518),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1519),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1519),
    [sym_false] = STATE(1519),
    [sym_nil] = STATE(1519),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3651),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2629),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2633),
    [anon_sym_yield] = ACTIONS(2635),
    [anon_sym_break] = ACTIONS(2637),
    [anon_sym_next] = ACTIONS(2639),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2641),
    [anon_sym_defined_QMARK] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2647),
    [anon_sym_TILDE] = ACTIONS(2647),
    [sym_constant] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1506] = {
    [sym__line_break] = ACTIONS(5735),
    [sym__heredoc_body_start] = ACTIONS(5735),
    [sym__binary_minus] = ACTIONS(5735),
    [sym__binary_star] = ACTIONS(5735),
    [ts_builtin_sym_end] = ACTIONS(5735),
    [anon_sym___END__] = ACTIONS(5735),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_RBRACE] = ACTIONS(5735),
    [anon_sym_RPAREN] = ACTIONS(5735),
    [anon_sym_DOT] = ACTIONS(5737),
    [anon_sym_COMMA] = ACTIONS(5735),
    [anon_sym_PIPE] = ACTIONS(5737),
    [anon_sym_SEMI] = ACTIONS(5735),
    [anon_sym_STAR_STAR] = ACTIONS(5737),
    [anon_sym_AMP] = ACTIONS(5737),
    [anon_sym_EQ] = ACTIONS(5737),
    [anon_sym_LT] = ACTIONS(5737),
    [anon_sym_end] = ACTIONS(5735),
    [anon_sym_if] = ACTIONS(5735),
    [anon_sym_unless] = ACTIONS(5735),
    [anon_sym_while] = ACTIONS(5735),
    [anon_sym_until] = ACTIONS(5735),
    [anon_sym_rescue] = ACTIONS(5735),
    [anon_sym_do] = ACTIONS(993),
    [anon_sym_when] = ACTIONS(5735),
    [anon_sym_elsif] = ACTIONS(5735),
    [anon_sym_else] = ACTIONS(5735),
    [anon_sym_then] = ACTIONS(5735),
    [anon_sym_ensure] = ACTIONS(5735),
    [anon_sym_EQ_GT] = ACTIONS(993),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_COLON_COLON2] = ACTIONS(5735),
    [anon_sym_AMP_DOT] = ACTIONS(5735),
    [anon_sym_PLUS_EQ] = ACTIONS(5735),
    [anon_sym_DASH_EQ] = ACTIONS(5735),
    [anon_sym_STAR_EQ] = ACTIONS(5735),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5735),
    [anon_sym_SLASH_EQ] = ACTIONS(5735),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5735),
    [anon_sym_PIPE_EQ] = ACTIONS(5735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5735),
    [anon_sym_AMP_EQ] = ACTIONS(5735),
    [anon_sym_PERCENT_EQ] = ACTIONS(5735),
    [anon_sym_GT_GT_EQ] = ACTIONS(5735),
    [anon_sym_LT_LT_EQ] = ACTIONS(5735),
    [anon_sym_CARET_EQ] = ACTIONS(5735),
    [anon_sym_QMARK] = ACTIONS(5735),
    [anon_sym_DOT_DOT] = ACTIONS(5737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5735),
    [anon_sym_and] = ACTIONS(5735),
    [anon_sym_or] = ACTIONS(5735),
    [anon_sym_PIPE_PIPE] = ACTIONS(5737),
    [anon_sym_AMP_AMP] = ACTIONS(5737),
    [anon_sym_LT_LT] = ACTIONS(5737),
    [anon_sym_GT_GT] = ACTIONS(5737),
    [anon_sym_EQ_EQ] = ACTIONS(5737),
    [anon_sym_BANG_EQ] = ACTIONS(5735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5735),
    [anon_sym_LT_EQ_GT] = ACTIONS(5735),
    [anon_sym_EQ_TILDE] = ACTIONS(5735),
    [anon_sym_BANG_TILDE] = ACTIONS(5735),
    [anon_sym_LT_EQ] = ACTIONS(5737),
    [anon_sym_GT] = ACTIONS(5737),
    [anon_sym_GT_EQ] = ACTIONS(5735),
    [anon_sym_CARET] = ACTIONS(5737),
    [anon_sym_PLUS] = ACTIONS(5737),
    [anon_sym_SLASH] = ACTIONS(5737),
    [anon_sym_PERCENT] = ACTIONS(5737),
    [sym_comment] = ACTIONS(87),
  },
  [1507] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3657),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1725),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1725),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(3658),
    [sym__argument] = STATE(3659),
    [sym_splat_argument] = STATE(3659),
    [sym_hash_splat_argument] = STATE(3659),
    [sym_block_argument] = STATE(3659),
    [sym_assignment] = STATE(3657),
    [sym_operator_assignment] = STATE(3657),
    [sym_conditional] = STATE(3657),
    [sym_range] = STATE(3657),
    [sym_binary] = STATE(3657),
    [sym_unary] = STATE(3657),
    [sym_left_assignment_list] = STATE(1724),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1725),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1725),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3660),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(3659),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(6057),
    [sym__splat_star] = ACTIONS(6059),
    [sym__unary_minus] = ACTIONS(3111),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(6061),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(3123),
    [anon_sym_not] = ACTIONS(3125),
    [anon_sym_BANG] = ACTIONS(3127),
    [anon_sym_TILDE] = ACTIONS(3129),
    [sym_constant] = ACTIONS(6063),
    [sym_identifier] = ACTIONS(6063),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1508] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3657),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1725),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1725),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(3658),
    [sym__argument] = STATE(3659),
    [sym_splat_argument] = STATE(3659),
    [sym_hash_splat_argument] = STATE(3659),
    [sym_block_argument] = STATE(3659),
    [sym_assignment] = STATE(3657),
    [sym_operator_assignment] = STATE(3657),
    [sym_conditional] = STATE(3657),
    [sym_range] = STATE(3657),
    [sym_binary] = STATE(3657),
    [sym_unary] = STATE(3657),
    [sym_left_assignment_list] = STATE(1724),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1725),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1725),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3660),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(3659),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(6057),
    [sym__splat_star] = ACTIONS(6059),
    [sym__unary_minus] = ACTIONS(3111),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(6061),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(3123),
    [anon_sym_not] = ACTIONS(3125),
    [anon_sym_BANG] = ACTIONS(3127),
    [anon_sym_TILDE] = ACTIONS(3129),
    [sym_constant] = ACTIONS(6063),
    [sym_identifier] = ACTIONS(6063),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1509] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3657),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1725),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1725),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(3658),
    [sym__argument] = STATE(3659),
    [sym_splat_argument] = STATE(3659),
    [sym_hash_splat_argument] = STATE(3659),
    [sym_block_argument] = STATE(3659),
    [sym_assignment] = STATE(3657),
    [sym_operator_assignment] = STATE(3657),
    [sym_conditional] = STATE(3657),
    [sym_range] = STATE(3657),
    [sym_binary] = STATE(3657),
    [sym_unary] = STATE(3657),
    [sym_left_assignment_list] = STATE(1724),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1725),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1725),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3660),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(3659),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(6057),
    [sym__splat_star] = ACTIONS(6059),
    [sym__unary_minus] = ACTIONS(3111),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(6061),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(3123),
    [anon_sym_not] = ACTIONS(3125),
    [anon_sym_BANG] = ACTIONS(3127),
    [anon_sym_TILDE] = ACTIONS(3129),
    [sym_constant] = ACTIONS(6063),
    [sym_identifier] = ACTIONS(6063),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1510] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3657),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1725),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1725),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(3658),
    [sym__argument] = STATE(3659),
    [sym_splat_argument] = STATE(3659),
    [sym_hash_splat_argument] = STATE(3659),
    [sym_block_argument] = STATE(3659),
    [sym_assignment] = STATE(3657),
    [sym_operator_assignment] = STATE(3657),
    [sym_conditional] = STATE(3657),
    [sym_range] = STATE(3657),
    [sym_binary] = STATE(3657),
    [sym_unary] = STATE(3657),
    [sym_left_assignment_list] = STATE(1724),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1725),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1725),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3660),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(3659),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(6057),
    [sym__splat_star] = ACTIONS(6059),
    [sym__unary_minus] = ACTIONS(3111),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(6061),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(3123),
    [anon_sym_not] = ACTIONS(3125),
    [anon_sym_BANG] = ACTIONS(3127),
    [anon_sym_TILDE] = ACTIONS(3129),
    [sym_constant] = ACTIONS(6063),
    [sym_identifier] = ACTIONS(6063),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1511] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3661),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1519),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1519),
    [sym_assignment] = STATE(3661),
    [sym_operator_assignment] = STATE(3661),
    [sym_conditional] = STATE(3661),
    [sym_range] = STATE(3661),
    [sym_binary] = STATE(3661),
    [sym_unary] = STATE(3661),
    [sym_left_assignment_list] = STATE(1518),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1519),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1519),
    [sym_false] = STATE(1519),
    [sym_nil] = STATE(1519),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3651),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2629),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2633),
    [anon_sym_yield] = ACTIONS(2635),
    [anon_sym_break] = ACTIONS(2637),
    [anon_sym_next] = ACTIONS(2639),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2641),
    [anon_sym_defined_QMARK] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2647),
    [anon_sym_TILDE] = ACTIONS(2647),
    [sym_constant] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1512] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(298),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1519),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1519),
    [sym_assignment] = STATE(298),
    [sym_operator_assignment] = STATE(298),
    [sym_conditional] = STATE(298),
    [sym_range] = STATE(298),
    [sym_binary] = STATE(298),
    [sym_unary] = STATE(298),
    [sym_left_assignment_list] = STATE(1518),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1519),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1519),
    [sym_false] = STATE(1519),
    [sym_nil] = STATE(1519),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3651),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2629),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2633),
    [anon_sym_yield] = ACTIONS(2635),
    [anon_sym_break] = ACTIONS(2637),
    [anon_sym_next] = ACTIONS(2639),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2641),
    [anon_sym_defined_QMARK] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2647),
    [anon_sym_TILDE] = ACTIONS(2647),
    [sym_constant] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1513] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(1093),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [1514] = {
    [anon_sym_RBRACE] = ACTIONS(6065),
    [sym_comment] = ACTIONS(87),
  },
  [1515] = {
    [sym__statements] = STATE(3663),
    [sym_begin_block] = STATE(489),
    [sym_end_block] = STATE(489),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(495),
    [aux_sym__statements_repeat1] = STATE(495),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(6065),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1516] = {
    [sym__line_break] = ACTIONS(701),
    [sym__heredoc_body_start] = ACTIONS(701),
    [sym__binary_minus] = ACTIONS(6067),
    [sym__binary_star] = ACTIONS(6069),
    [anon_sym_RBRACE] = ACTIONS(701),
    [anon_sym_PIPE] = ACTIONS(6071),
    [anon_sym_SEMI] = ACTIONS(701),
    [anon_sym_STAR_STAR] = ACTIONS(6069),
    [anon_sym_AMP] = ACTIONS(6073),
    [anon_sym_LT] = ACTIONS(6075),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_unless] = ACTIONS(701),
    [anon_sym_while] = ACTIONS(701),
    [anon_sym_until] = ACTIONS(701),
    [anon_sym_rescue] = ACTIONS(701),
    [anon_sym_EQ_GT] = ACTIONS(989),
    [anon_sym_QMARK] = ACTIONS(6077),
    [anon_sym_DOT_DOT] = ACTIONS(6079),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6081),
    [anon_sym_and] = ACTIONS(6083),
    [anon_sym_or] = ACTIONS(6083),
    [anon_sym_PIPE_PIPE] = ACTIONS(6085),
    [anon_sym_AMP_AMP] = ACTIONS(6085),
    [anon_sym_LT_LT] = ACTIONS(6087),
    [anon_sym_GT_GT] = ACTIONS(6087),
    [anon_sym_EQ_EQ] = ACTIONS(6089),
    [anon_sym_BANG_EQ] = ACTIONS(6085),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6085),
    [anon_sym_LT_EQ_GT] = ACTIONS(6085),
    [anon_sym_EQ_TILDE] = ACTIONS(6085),
    [anon_sym_BANG_TILDE] = ACTIONS(6085),
    [anon_sym_LT_EQ] = ACTIONS(6075),
    [anon_sym_GT] = ACTIONS(6075),
    [anon_sym_GT_EQ] = ACTIONS(6091),
    [anon_sym_CARET] = ACTIONS(6093),
    [anon_sym_PLUS] = ACTIONS(6067),
    [anon_sym_SLASH] = ACTIONS(6069),
    [anon_sym_PERCENT] = ACTIONS(6069),
    [sym_comment] = ACTIONS(87),
  },
  [1517] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3679),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1762),
    [sym_scope_resolution] = STATE(1758),
    [sym_call] = STATE(1758),
    [sym_method_call] = STATE(1762),
    [sym_argument_list] = STATE(938),
    [sym__argument_list_with_parens] = STATE(3680),
    [sym__argument] = STATE(3681),
    [sym_splat_argument] = STATE(3681),
    [sym_hash_splat_argument] = STATE(3681),
    [sym_block_argument] = STATE(3681),
    [sym_do_block] = STATE(941),
    [sym_block] = STATE(941),
    [sym_assignment] = STATE(3679),
    [sym_operator_assignment] = STATE(3679),
    [sym_conditional] = STATE(3679),
    [sym_range] = STATE(3679),
    [sym_binary] = STATE(3679),
    [sym_unary] = STATE(3679),
    [sym_left_assignment_list] = STATE(1761),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1762),
    [sym__variable] = STATE(1758),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1762),
    [sym_false] = STATE(1762),
    [sym_nil] = STATE(1762),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3682),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(3681),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(743),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(6095),
    [sym__splat_star] = ACTIONS(6097),
    [sym__unary_minus] = ACTIONS(3179),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(6099),
    [anon_sym_LBRACE] = ACTIONS(1669),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(3183),
    [anon_sym_yield] = ACTIONS(3185),
    [anon_sym_break] = ACTIONS(3187),
    [anon_sym_next] = ACTIONS(3189),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(769),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(769),
    [anon_sym_until] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(769),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(1671),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(3191),
    [anon_sym_not] = ACTIONS(3193),
    [anon_sym_BANG] = ACTIONS(3195),
    [anon_sym_TILDE] = ACTIONS(3197),
    [sym_constant] = ACTIONS(6101),
    [sym_identifier] = ACTIONS(6101),
    [sym_instance_variable] = ACTIONS(3201),
    [sym_class_variable] = ACTIONS(3201),
    [sym_global_variable] = ACTIONS(3201),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(3203),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(3203),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [1518] = {
    [anon_sym_EQ] = ACTIONS(6103),
    [sym_comment] = ACTIONS(87),
  },
  [1519] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(6105),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(6107),
    [anon_sym_DASH_EQ] = ACTIONS(6107),
    [anon_sym_STAR_EQ] = ACTIONS(6107),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6107),
    [anon_sym_SLASH_EQ] = ACTIONS(6107),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6107),
    [anon_sym_PIPE_EQ] = ACTIONS(6107),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6107),
    [anon_sym_AMP_EQ] = ACTIONS(6107),
    [anon_sym_PERCENT_EQ] = ACTIONS(6107),
    [anon_sym_GT_GT_EQ] = ACTIONS(6107),
    [anon_sym_LT_LT_EQ] = ACTIONS(6107),
    [anon_sym_CARET_EQ] = ACTIONS(6107),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1520] = {
    [sym_string] = STATE(3685),
    [aux_sym_chained_string_repeat1] = STATE(3685),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(1229),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [1521] = {
    [anon_sym_RBRACE] = ACTIONS(6109),
    [sym_comment] = ACTIONS(87),
  },
  [1522] = {
    [sym_heredoc_body] = STATE(3687),
    [sym__heredoc_body_start] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(6109),
    [sym_comment] = ACTIONS(87),
  },
  [1523] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(3688),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(674),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(674),
    [sym_assignment] = STATE(3688),
    [sym_operator_assignment] = STATE(3688),
    [sym_conditional] = STATE(3688),
    [sym_range] = STATE(3688),
    [sym_binary] = STATE(3688),
    [sym_unary] = STATE(3688),
    [sym_left_assignment_list] = STATE(673),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(674),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(674),
    [sym_false] = STATE(674),
    [sym_nil] = STATE(674),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(675),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1243),
    [anon_sym_yield] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1247),
    [anon_sym_next] = ACTIONS(1249),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1524] = {
    [sym__line_break] = ACTIONS(1273),
    [sym__heredoc_body_start] = ACTIONS(1273),
    [sym__binary_minus] = ACTIONS(1273),
    [sym__binary_star] = ACTIONS(1273),
    [ts_builtin_sym_end] = ACTIONS(1273),
    [anon_sym___END__] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_RBRACE] = ACTIONS(1273),
    [anon_sym_RPAREN] = ACTIONS(1273),
    [anon_sym_DOT] = ACTIONS(1275),
    [anon_sym_COMMA] = ACTIONS(1273),
    [anon_sym_PIPE] = ACTIONS(1275),
    [anon_sym_SEMI] = ACTIONS(1273),
    [anon_sym_STAR_STAR] = ACTIONS(1275),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_EQ] = ACTIONS(1275),
    [anon_sym_LT] = ACTIONS(1275),
    [anon_sym_end] = ACTIONS(1273),
    [anon_sym_if] = ACTIONS(1273),
    [anon_sym_unless] = ACTIONS(1273),
    [anon_sym_while] = ACTIONS(1273),
    [anon_sym_until] = ACTIONS(1273),
    [anon_sym_rescue] = ACTIONS(1273),
    [anon_sym_do] = ACTIONS(1273),
    [anon_sym_when] = ACTIONS(1273),
    [anon_sym_elsif] = ACTIONS(1273),
    [anon_sym_else] = ACTIONS(1273),
    [anon_sym_then] = ACTIONS(1273),
    [anon_sym_ensure] = ACTIONS(1273),
    [anon_sym_EQ_GT] = ACTIONS(1273),
    [anon_sym_LBRACK] = ACTIONS(1273),
    [anon_sym_COLON_COLON2] = ACTIONS(1273),
    [anon_sym_AMP_DOT] = ACTIONS(1273),
    [anon_sym_PLUS_EQ] = ACTIONS(1273),
    [anon_sym_DASH_EQ] = ACTIONS(1273),
    [anon_sym_STAR_EQ] = ACTIONS(1273),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1273),
    [anon_sym_SLASH_EQ] = ACTIONS(1273),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1273),
    [anon_sym_PIPE_EQ] = ACTIONS(1273),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1273),
    [anon_sym_AMP_EQ] = ACTIONS(1273),
    [anon_sym_PERCENT_EQ] = ACTIONS(1273),
    [anon_sym_GT_GT_EQ] = ACTIONS(1273),
    [anon_sym_LT_LT_EQ] = ACTIONS(1273),
    [anon_sym_CARET_EQ] = ACTIONS(1273),
    [anon_sym_QMARK] = ACTIONS(1273),
    [anon_sym_DOT_DOT] = ACTIONS(1275),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_and] = ACTIONS(1273),
    [anon_sym_or] = ACTIONS(1273),
    [anon_sym_PIPE_PIPE] = ACTIONS(1275),
    [anon_sym_AMP_AMP] = ACTIONS(1275),
    [anon_sym_LT_LT] = ACTIONS(1275),
    [anon_sym_GT_GT] = ACTIONS(1275),
    [anon_sym_EQ_EQ] = ACTIONS(1275),
    [anon_sym_BANG_EQ] = ACTIONS(1273),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1273),
    [anon_sym_LT_EQ_GT] = ACTIONS(1273),
    [anon_sym_EQ_TILDE] = ACTIONS(1273),
    [anon_sym_BANG_TILDE] = ACTIONS(1273),
    [anon_sym_LT_EQ] = ACTIONS(1275),
    [anon_sym_GT] = ACTIONS(1275),
    [anon_sym_GT_EQ] = ACTIONS(1273),
    [anon_sym_CARET] = ACTIONS(1275),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_SLASH] = ACTIONS(1275),
    [anon_sym_PERCENT] = ACTIONS(1275),
    [sym_comment] = ACTIONS(87),
  },
  [1525] = {
    [anon_sym_DOT] = ACTIONS(6111),
    [anon_sym_COLON_COLON] = ACTIONS(6111),
    [sym_comment] = ACTIONS(87),
  },
  [1526] = {
    [sym_method_parameters] = STATE(3690),
    [sym__simple_formal_parameter] = STATE(684),
    [sym_splat_parameter] = STATE(684),
    [sym_hash_splat_parameter] = STATE(684),
    [sym_block_parameter] = STATE(684),
    [sym_keyword_parameter] = STATE(684),
    [sym_optional_parameter] = STATE(684),
    [sym_heredoc_body] = STATE(3690),
    [sym__terminator] = STATE(3690),
    [sym__line_break] = ACTIONS(6113),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_SEMI] = ACTIONS(6113),
    [anon_sym_STAR] = ACTIONS(1283),
    [anon_sym_STAR_STAR] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1287),
    [sym_identifier] = ACTIONS(1289),
    [sym_comment] = ACTIONS(87),
  },
  [1527] = {
    [sym__line_break] = ACTIONS(1291),
    [sym__heredoc_body_start] = ACTIONS(1291),
    [sym__binary_minus] = ACTIONS(1291),
    [sym__binary_star] = ACTIONS(1291),
    [ts_builtin_sym_end] = ACTIONS(1291),
    [anon_sym___END__] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1291),
    [anon_sym_RBRACE] = ACTIONS(1291),
    [anon_sym_RPAREN] = ACTIONS(1291),
    [anon_sym_DOT] = ACTIONS(1293),
    [anon_sym_COMMA] = ACTIONS(1291),
    [anon_sym_PIPE] = ACTIONS(1293),
    [anon_sym_SEMI] = ACTIONS(1291),
    [anon_sym_STAR_STAR] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1293),
    [anon_sym_EQ] = ACTIONS(1293),
    [anon_sym_LT] = ACTIONS(1293),
    [anon_sym_end] = ACTIONS(1291),
    [anon_sym_if] = ACTIONS(1291),
    [anon_sym_unless] = ACTIONS(1291),
    [anon_sym_while] = ACTIONS(1291),
    [anon_sym_until] = ACTIONS(1291),
    [anon_sym_rescue] = ACTIONS(1291),
    [anon_sym_do] = ACTIONS(1291),
    [anon_sym_when] = ACTIONS(1291),
    [anon_sym_elsif] = ACTIONS(1291),
    [anon_sym_else] = ACTIONS(1291),
    [anon_sym_then] = ACTIONS(1291),
    [anon_sym_ensure] = ACTIONS(1291),
    [anon_sym_EQ_GT] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_COLON_COLON2] = ACTIONS(1291),
    [anon_sym_AMP_DOT] = ACTIONS(1291),
    [anon_sym_PLUS_EQ] = ACTIONS(1291),
    [anon_sym_DASH_EQ] = ACTIONS(1291),
    [anon_sym_STAR_EQ] = ACTIONS(1291),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1291),
    [anon_sym_SLASH_EQ] = ACTIONS(1291),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1291),
    [anon_sym_PIPE_EQ] = ACTIONS(1291),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1291),
    [anon_sym_AMP_EQ] = ACTIONS(1291),
    [anon_sym_PERCENT_EQ] = ACTIONS(1291),
    [anon_sym_GT_GT_EQ] = ACTIONS(1291),
    [anon_sym_LT_LT_EQ] = ACTIONS(1291),
    [anon_sym_CARET_EQ] = ACTIONS(1291),
    [anon_sym_QMARK] = ACTIONS(1291),
    [anon_sym_DOT_DOT] = ACTIONS(1293),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1291),
    [anon_sym_and] = ACTIONS(1291),
    [anon_sym_or] = ACTIONS(1291),
    [anon_sym_PIPE_PIPE] = ACTIONS(1293),
    [anon_sym_AMP_AMP] = ACTIONS(1293),
    [anon_sym_LT_LT] = ACTIONS(1293),
    [anon_sym_GT_GT] = ACTIONS(1293),
    [anon_sym_EQ_EQ] = ACTIONS(1293),
    [anon_sym_BANG_EQ] = ACTIONS(1291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1291),
    [anon_sym_LT_EQ_GT] = ACTIONS(1291),
    [anon_sym_EQ_TILDE] = ACTIONS(1291),
    [anon_sym_BANG_TILDE] = ACTIONS(1291),
    [anon_sym_LT_EQ] = ACTIONS(1293),
    [anon_sym_GT] = ACTIONS(1293),
    [anon_sym_GT_EQ] = ACTIONS(1291),
    [anon_sym_CARET] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1293),
    [anon_sym_SLASH] = ACTIONS(1293),
    [anon_sym_PERCENT] = ACTIONS(1293),
    [sym_comment] = ACTIONS(87),
  },
  [1528] = {
    [anon_sym_RPAREN] = ACTIONS(6115),
    [sym_comment] = ACTIONS(87),
  },
  [1529] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(6019),
    [sym__binary_star] = ACTIONS(6021),
    [ts_builtin_sym_end] = ACTIONS(3281),
    [anon_sym___END__] = ACTIONS(3281),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(6023),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_AMP] = ACTIONS(6027),
    [anon_sym_EQ] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(6029),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_unless] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_until] = ACTIONS(3281),
    [anon_sym_rescue] = ACTIONS(3281),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_PLUS_EQ] = ACTIONS(3281),
    [anon_sym_DASH_EQ] = ACTIONS(3281),
    [anon_sym_STAR_EQ] = ACTIONS(3281),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3281),
    [anon_sym_SLASH_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3281),
    [anon_sym_AMP_EQ] = ACTIONS(3281),
    [anon_sym_PERCENT_EQ] = ACTIONS(3281),
    [anon_sym_GT_GT_EQ] = ACTIONS(3281),
    [anon_sym_LT_LT_EQ] = ACTIONS(3281),
    [anon_sym_CARET_EQ] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(6031),
    [anon_sym_DOT_DOT] = ACTIONS(6033),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6035),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(6037),
    [anon_sym_AMP_AMP] = ACTIONS(6037),
    [anon_sym_LT_LT] = ACTIONS(6039),
    [anon_sym_GT_GT] = ACTIONS(6039),
    [anon_sym_EQ_EQ] = ACTIONS(6037),
    [anon_sym_BANG_EQ] = ACTIONS(6041),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6041),
    [anon_sym_LT_EQ_GT] = ACTIONS(6041),
    [anon_sym_EQ_TILDE] = ACTIONS(6041),
    [anon_sym_BANG_TILDE] = ACTIONS(6041),
    [anon_sym_LT_EQ] = ACTIONS(6029),
    [anon_sym_GT] = ACTIONS(6029),
    [anon_sym_GT_EQ] = ACTIONS(6043),
    [anon_sym_CARET] = ACTIONS(6023),
    [anon_sym_PLUS] = ACTIONS(6045),
    [anon_sym_SLASH] = ACTIONS(6025),
    [anon_sym_PERCENT] = ACTIONS(6025),
    [sym_comment] = ACTIONS(87),
  },
  [1530] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(3692),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(3692),
    [sym_operator_assignment] = STATE(3692),
    [sym_conditional] = STATE(3692),
    [sym_range] = STATE(3692),
    [sym_binary] = STATE(3692),
    [sym_unary] = STATE(3692),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(485),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(495),
    [anon_sym_defined_QMARK] = ACTIONS(497),
    [anon_sym_not] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(501),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1531] = {
    [sym_superclass] = STATE(3693),
    [sym_heredoc_body] = STATE(3694),
    [sym__terminator] = STATE(3694),
    [sym__line_break] = ACTIONS(6117),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1089),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(6117),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1089),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1517),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1089),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [1532] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_superclass] = STATE(3693),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(859),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym_argument_list] = STATE(832),
    [sym__argument_list_with_parens] = STATE(860),
    [sym__argument] = STATE(861),
    [sym_splat_argument] = STATE(861),
    [sym_hash_splat_argument] = STATE(861),
    [sym_block_argument] = STATE(861),
    [sym_do_block] = STATE(835),
    [sym_block] = STATE(835),
    [sym_assignment] = STATE(859),
    [sym_operator_assignment] = STATE(859),
    [sym_conditional] = STATE(859),
    [sym_range] = STATE(859),
    [sym_binary] = STATE(859),
    [sym_unary] = STATE(859),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(864),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_heredoc_body] = STATE(3694),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(861),
    [sym_lambda] = STATE(347),
    [sym__terminator] = STATE(3694),
    [sym__line_break] = ACTIONS(6117),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1521),
    [sym__splat_star] = ACTIONS(1523),
    [sym__unary_minus] = ACTIONS(1525),
    [sym__identifier_hash_key] = ACTIONS(1527),
    [anon_sym_LBRACE] = ACTIONS(1529),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(743),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(6117),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1531),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(1517),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1473),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(1549),
    [sym_identifier] = ACTIONS(1549),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1533] = {
    [sym_heredoc_body] = STATE(3696),
    [sym__terminator] = STATE(3696),
    [sym__line_break] = ACTIONS(6119),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1089),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(6119),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1089),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(6121),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1089),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [1534] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(859),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym_argument_list] = STATE(832),
    [sym__argument_list_with_parens] = STATE(860),
    [sym__argument] = STATE(861),
    [sym_splat_argument] = STATE(861),
    [sym_hash_splat_argument] = STATE(861),
    [sym_block_argument] = STATE(861),
    [sym_do_block] = STATE(835),
    [sym_block] = STATE(835),
    [sym_assignment] = STATE(859),
    [sym_operator_assignment] = STATE(859),
    [sym_conditional] = STATE(859),
    [sym_range] = STATE(859),
    [sym_binary] = STATE(859),
    [sym_unary] = STATE(859),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(864),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_heredoc_body] = STATE(3696),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(861),
    [sym_lambda] = STATE(347),
    [sym__terminator] = STATE(3696),
    [sym__line_break] = ACTIONS(6119),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1521),
    [sym__splat_star] = ACTIONS(1523),
    [sym__unary_minus] = ACTIONS(1525),
    [sym__identifier_hash_key] = ACTIONS(1527),
    [anon_sym_LBRACE] = ACTIONS(1529),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(743),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(6119),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1531),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_end] = ACTIONS(6121),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1473),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(1549),
    [sym_identifier] = ACTIONS(1549),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1535] = {
    [sym__line_break] = ACTIONS(1677),
    [sym__heredoc_body_start] = ACTIONS(1677),
    [sym__binary_minus] = ACTIONS(1677),
    [sym__binary_star] = ACTIONS(1677),
    [ts_builtin_sym_end] = ACTIONS(1677),
    [anon_sym___END__] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1677),
    [anon_sym_RBRACE] = ACTIONS(1677),
    [anon_sym_RPAREN] = ACTIONS(1677),
    [anon_sym_DOT] = ACTIONS(1679),
    [anon_sym_COMMA] = ACTIONS(1677),
    [anon_sym_PIPE] = ACTIONS(1679),
    [anon_sym_SEMI] = ACTIONS(1677),
    [anon_sym_STAR_STAR] = ACTIONS(1679),
    [anon_sym_AMP] = ACTIONS(1679),
    [anon_sym_EQ] = ACTIONS(1679),
    [anon_sym_LT] = ACTIONS(1679),
    [anon_sym_end] = ACTIONS(1677),
    [anon_sym_if] = ACTIONS(1677),
    [anon_sym_unless] = ACTIONS(1677),
    [anon_sym_while] = ACTIONS(1677),
    [anon_sym_until] = ACTIONS(1677),
    [anon_sym_rescue] = ACTIONS(1677),
    [anon_sym_do] = ACTIONS(1677),
    [anon_sym_when] = ACTIONS(1677),
    [anon_sym_elsif] = ACTIONS(1677),
    [anon_sym_else] = ACTIONS(1677),
    [anon_sym_then] = ACTIONS(1677),
    [anon_sym_ensure] = ACTIONS(1677),
    [anon_sym_EQ_GT] = ACTIONS(1677),
    [anon_sym_LBRACK] = ACTIONS(1677),
    [anon_sym_COLON_COLON2] = ACTIONS(1677),
    [anon_sym_AMP_DOT] = ACTIONS(1677),
    [anon_sym_PLUS_EQ] = ACTIONS(1677),
    [anon_sym_DASH_EQ] = ACTIONS(1677),
    [anon_sym_STAR_EQ] = ACTIONS(1677),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1677),
    [anon_sym_SLASH_EQ] = ACTIONS(1677),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1677),
    [anon_sym_PIPE_EQ] = ACTIONS(1677),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1677),
    [anon_sym_AMP_EQ] = ACTIONS(1677),
    [anon_sym_PERCENT_EQ] = ACTIONS(1677),
    [anon_sym_GT_GT_EQ] = ACTIONS(1677),
    [anon_sym_LT_LT_EQ] = ACTIONS(1677),
    [anon_sym_CARET_EQ] = ACTIONS(1677),
    [anon_sym_QMARK] = ACTIONS(1677),
    [anon_sym_DOT_DOT] = ACTIONS(1679),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1677),
    [anon_sym_and] = ACTIONS(1677),
    [anon_sym_or] = ACTIONS(1677),
    [anon_sym_PIPE_PIPE] = ACTIONS(1679),
    [anon_sym_AMP_AMP] = ACTIONS(1679),
    [anon_sym_LT_LT] = ACTIONS(1679),
    [anon_sym_GT_GT] = ACTIONS(1679),
    [anon_sym_EQ_EQ] = ACTIONS(1679),
    [anon_sym_BANG_EQ] = ACTIONS(1677),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1677),
    [anon_sym_LT_EQ_GT] = ACTIONS(1677),
    [anon_sym_EQ_TILDE] = ACTIONS(1677),
    [anon_sym_BANG_TILDE] = ACTIONS(1677),
    [anon_sym_LT_EQ] = ACTIONS(1679),
    [anon_sym_GT] = ACTIONS(1679),
    [anon_sym_GT_EQ] = ACTIONS(1677),
    [anon_sym_CARET] = ACTIONS(1679),
    [anon_sym_PLUS] = ACTIONS(1679),
    [anon_sym_SLASH] = ACTIONS(1679),
    [anon_sym_PERCENT] = ACTIONS(1679),
    [sym_comment] = ACTIONS(87),
  },
  [1536] = {
    [sym__line_break] = ACTIONS(1697),
    [sym__heredoc_body_start] = ACTIONS(1697),
    [sym__binary_minus] = ACTIONS(1697),
    [sym__binary_star] = ACTIONS(1697),
    [ts_builtin_sym_end] = ACTIONS(1697),
    [anon_sym___END__] = ACTIONS(1697),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_RBRACE] = ACTIONS(1697),
    [anon_sym_RPAREN] = ACTIONS(1697),
    [anon_sym_DOT] = ACTIONS(1699),
    [anon_sym_COMMA] = ACTIONS(1697),
    [anon_sym_PIPE] = ACTIONS(1699),
    [anon_sym_SEMI] = ACTIONS(1697),
    [anon_sym_STAR_STAR] = ACTIONS(1699),
    [anon_sym_AMP] = ACTIONS(1699),
    [anon_sym_EQ] = ACTIONS(1699),
    [anon_sym_LT] = ACTIONS(1699),
    [anon_sym_end] = ACTIONS(1697),
    [anon_sym_if] = ACTIONS(1697),
    [anon_sym_unless] = ACTIONS(1697),
    [anon_sym_while] = ACTIONS(1697),
    [anon_sym_until] = ACTIONS(1697),
    [anon_sym_rescue] = ACTIONS(1697),
    [anon_sym_do] = ACTIONS(1697),
    [anon_sym_when] = ACTIONS(1697),
    [anon_sym_elsif] = ACTIONS(1697),
    [anon_sym_else] = ACTIONS(1697),
    [anon_sym_then] = ACTIONS(1697),
    [anon_sym_ensure] = ACTIONS(1697),
    [anon_sym_EQ_GT] = ACTIONS(1697),
    [anon_sym_LBRACK] = ACTIONS(1697),
    [anon_sym_COLON_COLON2] = ACTIONS(1697),
    [anon_sym_AMP_DOT] = ACTIONS(1697),
    [anon_sym_PLUS_EQ] = ACTIONS(1697),
    [anon_sym_DASH_EQ] = ACTIONS(1697),
    [anon_sym_STAR_EQ] = ACTIONS(1697),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1697),
    [anon_sym_SLASH_EQ] = ACTIONS(1697),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1697),
    [anon_sym_PIPE_EQ] = ACTIONS(1697),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1697),
    [anon_sym_AMP_EQ] = ACTIONS(1697),
    [anon_sym_PERCENT_EQ] = ACTIONS(1697),
    [anon_sym_GT_GT_EQ] = ACTIONS(1697),
    [anon_sym_LT_LT_EQ] = ACTIONS(1697),
    [anon_sym_CARET_EQ] = ACTIONS(1697),
    [anon_sym_QMARK] = ACTIONS(1697),
    [anon_sym_DOT_DOT] = ACTIONS(1699),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1697),
    [anon_sym_and] = ACTIONS(1697),
    [anon_sym_or] = ACTIONS(1697),
    [anon_sym_PIPE_PIPE] = ACTIONS(1699),
    [anon_sym_AMP_AMP] = ACTIONS(1699),
    [anon_sym_LT_LT] = ACTIONS(1699),
    [anon_sym_GT_GT] = ACTIONS(1699),
    [anon_sym_EQ_EQ] = ACTIONS(1699),
    [anon_sym_BANG_EQ] = ACTIONS(1697),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1697),
    [anon_sym_LT_EQ_GT] = ACTIONS(1697),
    [anon_sym_EQ_TILDE] = ACTIONS(1697),
    [anon_sym_BANG_TILDE] = ACTIONS(1697),
    [anon_sym_LT_EQ] = ACTIONS(1699),
    [anon_sym_GT] = ACTIONS(1699),
    [anon_sym_GT_EQ] = ACTIONS(1697),
    [anon_sym_CARET] = ACTIONS(1699),
    [anon_sym_PLUS] = ACTIONS(1699),
    [anon_sym_SLASH] = ACTIONS(1699),
    [anon_sym_PERCENT] = ACTIONS(1699),
    [sym_comment] = ACTIONS(87),
  },
  [1537] = {
    [sym__line_break] = ACTIONS(1701),
    [sym__heredoc_body_start] = ACTIONS(1701),
    [sym__binary_minus] = ACTIONS(1701),
    [sym__binary_star] = ACTIONS(1701),
    [ts_builtin_sym_end] = ACTIONS(1701),
    [anon_sym___END__] = ACTIONS(1701),
    [anon_sym_LBRACE] = ACTIONS(1701),
    [anon_sym_RBRACE] = ACTIONS(1701),
    [anon_sym_RPAREN] = ACTIONS(1701),
    [anon_sym_DOT] = ACTIONS(1703),
    [anon_sym_COMMA] = ACTIONS(1701),
    [anon_sym_PIPE] = ACTIONS(1703),
    [anon_sym_SEMI] = ACTIONS(1701),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1703),
    [anon_sym_EQ] = ACTIONS(1703),
    [anon_sym_LT] = ACTIONS(1703),
    [anon_sym_end] = ACTIONS(1701),
    [anon_sym_if] = ACTIONS(1701),
    [anon_sym_unless] = ACTIONS(1701),
    [anon_sym_while] = ACTIONS(1701),
    [anon_sym_until] = ACTIONS(1701),
    [anon_sym_rescue] = ACTIONS(1701),
    [anon_sym_do] = ACTIONS(1701),
    [anon_sym_when] = ACTIONS(1701),
    [anon_sym_elsif] = ACTIONS(1701),
    [anon_sym_else] = ACTIONS(1701),
    [anon_sym_then] = ACTIONS(1701),
    [anon_sym_ensure] = ACTIONS(1701),
    [anon_sym_EQ_GT] = ACTIONS(1701),
    [anon_sym_LBRACK] = ACTIONS(1701),
    [anon_sym_COLON_COLON2] = ACTIONS(1701),
    [anon_sym_AMP_DOT] = ACTIONS(1701),
    [anon_sym_PLUS_EQ] = ACTIONS(1701),
    [anon_sym_DASH_EQ] = ACTIONS(1701),
    [anon_sym_STAR_EQ] = ACTIONS(1701),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1701),
    [anon_sym_SLASH_EQ] = ACTIONS(1701),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1701),
    [anon_sym_PIPE_EQ] = ACTIONS(1701),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1701),
    [anon_sym_AMP_EQ] = ACTIONS(1701),
    [anon_sym_PERCENT_EQ] = ACTIONS(1701),
    [anon_sym_GT_GT_EQ] = ACTIONS(1701),
    [anon_sym_LT_LT_EQ] = ACTIONS(1701),
    [anon_sym_CARET_EQ] = ACTIONS(1701),
    [anon_sym_QMARK] = ACTIONS(1701),
    [anon_sym_DOT_DOT] = ACTIONS(1703),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1701),
    [anon_sym_and] = ACTIONS(1701),
    [anon_sym_or] = ACTIONS(1701),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1703),
    [anon_sym_BANG_EQ] = ACTIONS(1701),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1701),
    [anon_sym_LT_EQ_GT] = ACTIONS(1701),
    [anon_sym_EQ_TILDE] = ACTIONS(1701),
    [anon_sym_BANG_TILDE] = ACTIONS(1701),
    [anon_sym_LT_EQ] = ACTIONS(1703),
    [anon_sym_GT] = ACTIONS(1703),
    [anon_sym_GT_EQ] = ACTIONS(1701),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [1538] = {
    [sym__line_break] = ACTIONS(1705),
    [sym__heredoc_body_start] = ACTIONS(1705),
    [sym__binary_minus] = ACTIONS(1705),
    [sym__binary_star] = ACTIONS(1705),
    [ts_builtin_sym_end] = ACTIONS(1705),
    [anon_sym___END__] = ACTIONS(1705),
    [anon_sym_LBRACE] = ACTIONS(1705),
    [anon_sym_RBRACE] = ACTIONS(1705),
    [anon_sym_RPAREN] = ACTIONS(1705),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1705),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1705),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1705),
    [anon_sym_if] = ACTIONS(1705),
    [anon_sym_unless] = ACTIONS(1705),
    [anon_sym_while] = ACTIONS(1705),
    [anon_sym_until] = ACTIONS(1705),
    [anon_sym_rescue] = ACTIONS(1705),
    [anon_sym_do] = ACTIONS(1705),
    [anon_sym_when] = ACTIONS(1705),
    [anon_sym_elsif] = ACTIONS(1705),
    [anon_sym_else] = ACTIONS(1705),
    [anon_sym_then] = ACTIONS(1705),
    [anon_sym_ensure] = ACTIONS(1705),
    [anon_sym_EQ_GT] = ACTIONS(1705),
    [anon_sym_LBRACK] = ACTIONS(1705),
    [anon_sym_COLON_COLON2] = ACTIONS(1705),
    [anon_sym_AMP_DOT] = ACTIONS(1705),
    [anon_sym_PLUS_EQ] = ACTIONS(1705),
    [anon_sym_DASH_EQ] = ACTIONS(1705),
    [anon_sym_STAR_EQ] = ACTIONS(1705),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1705),
    [anon_sym_SLASH_EQ] = ACTIONS(1705),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1705),
    [anon_sym_PIPE_EQ] = ACTIONS(1705),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1705),
    [anon_sym_AMP_EQ] = ACTIONS(1705),
    [anon_sym_PERCENT_EQ] = ACTIONS(1705),
    [anon_sym_GT_GT_EQ] = ACTIONS(1705),
    [anon_sym_LT_LT_EQ] = ACTIONS(1705),
    [anon_sym_CARET_EQ] = ACTIONS(1705),
    [anon_sym_QMARK] = ACTIONS(1705),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1705),
    [anon_sym_and] = ACTIONS(1705),
    [anon_sym_or] = ACTIONS(1705),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1705),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1705),
    [anon_sym_LT_EQ_GT] = ACTIONS(1705),
    [anon_sym_EQ_TILDE] = ACTIONS(1705),
    [anon_sym_BANG_TILDE] = ACTIONS(1705),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1705),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [1539] = {
    [sym_then] = STATE(3697),
    [sym_heredoc_body] = STATE(3698),
    [sym__terminator] = STATE(3698),
    [sym__line_break] = ACTIONS(6123),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(6123),
    [anon_sym_if] = ACTIONS(1743),
    [anon_sym_unless] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1747),
    [anon_sym_until] = ACTIONS(1749),
    [anon_sym_rescue] = ACTIONS(1751),
    [anon_sym_then] = ACTIONS(1753),
    [sym_comment] = ACTIONS(87),
  },
  [1540] = {
    [sym_then] = STATE(3699),
    [sym_heredoc_body] = STATE(3700),
    [sym__terminator] = STATE(3700),
    [sym__line_break] = ACTIONS(6125),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(6125),
    [anon_sym_if] = ACTIONS(1743),
    [anon_sym_unless] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1747),
    [anon_sym_until] = ACTIONS(1749),
    [anon_sym_rescue] = ACTIONS(1751),
    [anon_sym_then] = ACTIONS(1821),
    [sym_comment] = ACTIONS(87),
  },
  [1541] = {
    [sym__do] = STATE(3701),
    [sym_heredoc_body] = STATE(3701),
    [sym__terminator] = STATE(3701),
    [sym__line_break] = ACTIONS(6127),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym__binary_minus] = ACTIONS(1855),
    [sym__binary_star] = ACTIONS(1857),
    [anon_sym_PIPE] = ACTIONS(1859),
    [anon_sym_SEMI] = ACTIONS(6127),
    [anon_sym_STAR_STAR] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_LT] = ACTIONS(1863),
    [anon_sym_do] = ACTIONS(6127),
    [anon_sym_QMARK] = ACTIONS(1865),
    [anon_sym_DOT_DOT] = ACTIONS(1867),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1869),
    [anon_sym_and] = ACTIONS(1871),
    [anon_sym_or] = ACTIONS(1871),
    [anon_sym_PIPE_PIPE] = ACTIONS(1873),
    [anon_sym_AMP_AMP] = ACTIONS(1873),
    [anon_sym_LT_LT] = ACTIONS(1875),
    [anon_sym_GT_GT] = ACTIONS(1875),
    [anon_sym_EQ_EQ] = ACTIONS(1877),
    [anon_sym_BANG_EQ] = ACTIONS(1873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1873),
    [anon_sym_LT_EQ_GT] = ACTIONS(1873),
    [anon_sym_EQ_TILDE] = ACTIONS(1873),
    [anon_sym_BANG_TILDE] = ACTIONS(1873),
    [anon_sym_LT_EQ] = ACTIONS(1863),
    [anon_sym_GT] = ACTIONS(1863),
    [anon_sym_GT_EQ] = ACTIONS(1879),
    [anon_sym_CARET] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_SLASH] = ACTIONS(1857),
    [anon_sym_PERCENT] = ACTIONS(1857),
    [sym_comment] = ACTIONS(87),
  },
  [1542] = {
    [sym__do] = STATE(3702),
    [sym_heredoc_body] = STATE(3702),
    [sym__terminator] = STATE(3702),
    [sym__line_break] = ACTIONS(6129),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym__binary_minus] = ACTIONS(1855),
    [sym__binary_star] = ACTIONS(1857),
    [anon_sym_PIPE] = ACTIONS(1859),
    [anon_sym_SEMI] = ACTIONS(6129),
    [anon_sym_STAR_STAR] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_LT] = ACTIONS(1863),
    [anon_sym_do] = ACTIONS(6129),
    [anon_sym_QMARK] = ACTIONS(1865),
    [anon_sym_DOT_DOT] = ACTIONS(1867),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1869),
    [anon_sym_and] = ACTIONS(1871),
    [anon_sym_or] = ACTIONS(1871),
    [anon_sym_PIPE_PIPE] = ACTIONS(1873),
    [anon_sym_AMP_AMP] = ACTIONS(1873),
    [anon_sym_LT_LT] = ACTIONS(1875),
    [anon_sym_GT_GT] = ACTIONS(1875),
    [anon_sym_EQ_EQ] = ACTIONS(1877),
    [anon_sym_BANG_EQ] = ACTIONS(1873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1873),
    [anon_sym_LT_EQ_GT] = ACTIONS(1873),
    [anon_sym_EQ_TILDE] = ACTIONS(1873),
    [anon_sym_BANG_TILDE] = ACTIONS(1873),
    [anon_sym_LT_EQ] = ACTIONS(1863),
    [anon_sym_GT] = ACTIONS(1863),
    [anon_sym_GT_EQ] = ACTIONS(1879),
    [anon_sym_CARET] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_SLASH] = ACTIONS(1857),
    [anon_sym_PERCENT] = ACTIONS(1857),
    [sym_comment] = ACTIONS(87),
  },
  [1543] = {
    [sym_in] = STATE(3703),
    [anon_sym_in] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
  },
  [1544] = {
    [sym__line_break] = ACTIONS(5771),
    [sym__heredoc_body_start] = ACTIONS(5771),
    [sym__binary_minus] = ACTIONS(5771),
    [sym__binary_star] = ACTIONS(5771),
    [ts_builtin_sym_end] = ACTIONS(5771),
    [anon_sym___END__] = ACTIONS(5771),
    [anon_sym_LBRACE] = ACTIONS(5771),
    [anon_sym_RBRACE] = ACTIONS(5771),
    [anon_sym_RPAREN] = ACTIONS(5771),
    [anon_sym_DOT] = ACTIONS(5773),
    [anon_sym_COMMA] = ACTIONS(5771),
    [anon_sym_PIPE] = ACTIONS(5773),
    [anon_sym_SEMI] = ACTIONS(5771),
    [anon_sym_STAR_STAR] = ACTIONS(5773),
    [anon_sym_AMP] = ACTIONS(5773),
    [anon_sym_EQ] = ACTIONS(5773),
    [anon_sym_LT] = ACTIONS(5773),
    [anon_sym_end] = ACTIONS(5771),
    [anon_sym_if] = ACTIONS(5771),
    [anon_sym_unless] = ACTIONS(5771),
    [anon_sym_while] = ACTIONS(5771),
    [anon_sym_until] = ACTIONS(5771),
    [anon_sym_rescue] = ACTIONS(5771),
    [anon_sym_do] = ACTIONS(5771),
    [anon_sym_when] = ACTIONS(5771),
    [anon_sym_elsif] = ACTIONS(5771),
    [anon_sym_else] = ACTIONS(5771),
    [anon_sym_then] = ACTIONS(5771),
    [anon_sym_ensure] = ACTIONS(5771),
    [anon_sym_LBRACK] = ACTIONS(5771),
    [anon_sym_COLON_COLON2] = ACTIONS(5771),
    [anon_sym_AMP_DOT] = ACTIONS(5771),
    [anon_sym_PLUS_EQ] = ACTIONS(5771),
    [anon_sym_DASH_EQ] = ACTIONS(5771),
    [anon_sym_STAR_EQ] = ACTIONS(5771),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5771),
    [anon_sym_SLASH_EQ] = ACTIONS(5771),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5771),
    [anon_sym_PIPE_EQ] = ACTIONS(5771),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5771),
    [anon_sym_AMP_EQ] = ACTIONS(5771),
    [anon_sym_PERCENT_EQ] = ACTIONS(5771),
    [anon_sym_GT_GT_EQ] = ACTIONS(5771),
    [anon_sym_LT_LT_EQ] = ACTIONS(5771),
    [anon_sym_CARET_EQ] = ACTIONS(5771),
    [anon_sym_QMARK] = ACTIONS(5771),
    [anon_sym_DOT_DOT] = ACTIONS(5773),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5771),
    [anon_sym_and] = ACTIONS(5771),
    [anon_sym_or] = ACTIONS(5771),
    [anon_sym_PIPE_PIPE] = ACTIONS(5773),
    [anon_sym_AMP_AMP] = ACTIONS(5773),
    [anon_sym_LT_LT] = ACTIONS(5773),
    [anon_sym_GT_GT] = ACTIONS(5773),
    [anon_sym_EQ_EQ] = ACTIONS(5773),
    [anon_sym_BANG_EQ] = ACTIONS(5771),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5771),
    [anon_sym_LT_EQ_GT] = ACTIONS(5771),
    [anon_sym_EQ_TILDE] = ACTIONS(5771),
    [anon_sym_BANG_TILDE] = ACTIONS(5771),
    [anon_sym_LT_EQ] = ACTIONS(5773),
    [anon_sym_GT] = ACTIONS(5773),
    [anon_sym_GT_EQ] = ACTIONS(5771),
    [anon_sym_CARET] = ACTIONS(5773),
    [anon_sym_PLUS] = ACTIONS(5773),
    [anon_sym_SLASH] = ACTIONS(5773),
    [anon_sym_PERCENT] = ACTIONS(5773),
    [sym_comment] = ACTIONS(87),
  },
  [1545] = {
    [anon_sym_end] = ACTIONS(6131),
    [sym_comment] = ACTIONS(87),
  },
  [1546] = {
    [sym__statements] = STATE(3705),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_heredoc_body] = STATE(3706),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [sym__terminator] = STATE(3706),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__line_break] = ACTIONS(6133),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(6133),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(6135),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1547] = {
    [sym__statements] = STATE(3705),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_block_parameters] = STATE(3707),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(6135),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1548] = {
    [sym_heredoc_body] = STATE(3708),
    [sym__terminator] = STATE(3708),
    [sym__line_break] = ACTIONS(6137),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym__binary_minus] = ACTIONS(2001),
    [sym__binary_star] = ACTIONS(2003),
    [anon_sym_PIPE] = ACTIONS(2005),
    [anon_sym_SEMI] = ACTIONS(6137),
    [anon_sym_STAR_STAR] = ACTIONS(2003),
    [anon_sym_AMP] = ACTIONS(2007),
    [anon_sym_LT] = ACTIONS(2009),
    [anon_sym_QMARK] = ACTIONS(2011),
    [anon_sym_DOT_DOT] = ACTIONS(2013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2015),
    [anon_sym_and] = ACTIONS(2017),
    [anon_sym_or] = ACTIONS(2017),
    [anon_sym_PIPE_PIPE] = ACTIONS(2019),
    [anon_sym_AMP_AMP] = ACTIONS(2019),
    [anon_sym_LT_LT] = ACTIONS(2021),
    [anon_sym_GT_GT] = ACTIONS(2021),
    [anon_sym_EQ_EQ] = ACTIONS(2023),
    [anon_sym_BANG_EQ] = ACTIONS(2019),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2019),
    [anon_sym_LT_EQ_GT] = ACTIONS(2019),
    [anon_sym_EQ_TILDE] = ACTIONS(2019),
    [anon_sym_BANG_TILDE] = ACTIONS(2019),
    [anon_sym_LT_EQ] = ACTIONS(2009),
    [anon_sym_GT] = ACTIONS(2009),
    [anon_sym_GT_EQ] = ACTIONS(2025),
    [anon_sym_CARET] = ACTIONS(2027),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_SLASH] = ACTIONS(2003),
    [anon_sym_PERCENT] = ACTIONS(2003),
    [sym_comment] = ACTIONS(87),
  },
  [1549] = {
    [sym_when] = STATE(3712),
    [sym_else] = STATE(3710),
    [aux_sym_case_repeat1] = STATE(3711),
    [aux_sym_case_repeat2] = STATE(3712),
    [anon_sym_SEMI] = ACTIONS(6139),
    [anon_sym_end] = ACTIONS(6141),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [1550] = {
    [sym_else] = STATE(3714),
    [sym_ensure] = STATE(3715),
    [sym_rescue] = STATE(3716),
    [anon_sym_end] = ACTIONS(6143),
    [anon_sym_rescue] = ACTIONS(2165),
    [anon_sym_else] = ACTIONS(2167),
    [anon_sym_ensure] = ACTIONS(2169),
    [sym_comment] = ACTIONS(87),
  },
  [1551] = {
    [sym_ensure] = STATE(3715),
    [anon_sym_end] = ACTIONS(6143),
    [anon_sym_ensure] = ACTIONS(2169),
    [sym_comment] = ACTIONS(87),
  },
  [1552] = {
    [anon_sym_end] = ACTIONS(6143),
    [sym_comment] = ACTIONS(87),
  },
  [1553] = {
    [sym_else] = STATE(3714),
    [sym_ensure] = STATE(3715),
    [anon_sym_end] = ACTIONS(6143),
    [anon_sym_else] = ACTIONS(2167),
    [anon_sym_ensure] = ACTIONS(2169),
    [sym_comment] = ACTIONS(87),
  },
  [1554] = {
    [sym__line_break] = ACTIONS(2181),
    [sym__heredoc_body_start] = ACTIONS(2181),
    [sym__binary_minus] = ACTIONS(2181),
    [sym__binary_star] = ACTIONS(2181),
    [ts_builtin_sym_end] = ACTIONS(2181),
    [anon_sym___END__] = ACTIONS(2181),
    [anon_sym_LBRACE] = ACTIONS(2181),
    [anon_sym_RBRACE] = ACTIONS(2181),
    [anon_sym_RPAREN] = ACTIONS(2181),
    [anon_sym_DOT] = ACTIONS(2183),
    [anon_sym_COMMA] = ACTIONS(2181),
    [anon_sym_PIPE] = ACTIONS(2183),
    [anon_sym_SEMI] = ACTIONS(2181),
    [anon_sym_STAR_STAR] = ACTIONS(2183),
    [anon_sym_AMP] = ACTIONS(2183),
    [anon_sym_EQ] = ACTIONS(2183),
    [anon_sym_LT] = ACTIONS(2183),
    [anon_sym_end] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(2181),
    [anon_sym_unless] = ACTIONS(2181),
    [anon_sym_while] = ACTIONS(2181),
    [anon_sym_until] = ACTIONS(2181),
    [anon_sym_rescue] = ACTIONS(2181),
    [anon_sym_do] = ACTIONS(2181),
    [anon_sym_when] = ACTIONS(2181),
    [anon_sym_elsif] = ACTIONS(2181),
    [anon_sym_else] = ACTIONS(2181),
    [anon_sym_then] = ACTIONS(2181),
    [anon_sym_ensure] = ACTIONS(2181),
    [anon_sym_EQ_GT] = ACTIONS(2181),
    [anon_sym_LBRACK] = ACTIONS(2181),
    [anon_sym_COLON_COLON2] = ACTIONS(2181),
    [anon_sym_AMP_DOT] = ACTIONS(2181),
    [anon_sym_PLUS_EQ] = ACTIONS(2181),
    [anon_sym_DASH_EQ] = ACTIONS(2181),
    [anon_sym_STAR_EQ] = ACTIONS(2181),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2181),
    [anon_sym_SLASH_EQ] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2181),
    [anon_sym_PIPE_EQ] = ACTIONS(2181),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2181),
    [anon_sym_AMP_EQ] = ACTIONS(2181),
    [anon_sym_PERCENT_EQ] = ACTIONS(2181),
    [anon_sym_GT_GT_EQ] = ACTIONS(2181),
    [anon_sym_LT_LT_EQ] = ACTIONS(2181),
    [anon_sym_CARET_EQ] = ACTIONS(2181),
    [anon_sym_QMARK] = ACTIONS(2181),
    [anon_sym_DOT_DOT] = ACTIONS(2183),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2183),
    [anon_sym_AMP_AMP] = ACTIONS(2183),
    [anon_sym_LT_LT] = ACTIONS(2183),
    [anon_sym_GT_GT] = ACTIONS(2183),
    [anon_sym_EQ_EQ] = ACTIONS(2183),
    [anon_sym_BANG_EQ] = ACTIONS(2181),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2181),
    [anon_sym_LT_EQ_GT] = ACTIONS(2181),
    [anon_sym_EQ_TILDE] = ACTIONS(2181),
    [anon_sym_BANG_TILDE] = ACTIONS(2181),
    [anon_sym_LT_EQ] = ACTIONS(2183),
    [anon_sym_GT] = ACTIONS(2183),
    [anon_sym_GT_EQ] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2183),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_SLASH] = ACTIONS(2183),
    [anon_sym_PERCENT] = ACTIONS(2183),
    [sym_comment] = ACTIONS(87),
  },
  [1555] = {
    [sym__statements] = STATE(1550),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(1551),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(1552),
    [sym_rescue] = STATE(1553),
    [sym__body_statement] = STATE(3717),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(6145),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1556] = {
    [sym__line_break] = ACTIONS(4285),
    [sym__heredoc_body_start] = ACTIONS(4285),
    [sym__binary_minus] = ACTIONS(4285),
    [sym__binary_star] = ACTIONS(4285),
    [ts_builtin_sym_end] = ACTIONS(4285),
    [anon_sym___END__] = ACTIONS(4285),
    [anon_sym_LBRACE] = ACTIONS(4285),
    [anon_sym_RBRACE] = ACTIONS(4285),
    [anon_sym_RPAREN] = ACTIONS(4285),
    [anon_sym_DOT] = ACTIONS(4287),
    [anon_sym_COMMA] = ACTIONS(4285),
    [anon_sym_PIPE] = ACTIONS(4287),
    [anon_sym_SEMI] = ACTIONS(4285),
    [anon_sym_STAR_STAR] = ACTIONS(4287),
    [anon_sym_AMP] = ACTIONS(4287),
    [anon_sym_EQ] = ACTIONS(4287),
    [anon_sym_LT] = ACTIONS(4287),
    [anon_sym_end] = ACTIONS(4285),
    [anon_sym_if] = ACTIONS(4285),
    [anon_sym_unless] = ACTIONS(4285),
    [anon_sym_while] = ACTIONS(4285),
    [anon_sym_until] = ACTIONS(4285),
    [anon_sym_rescue] = ACTIONS(4285),
    [anon_sym_do] = ACTIONS(4285),
    [anon_sym_when] = ACTIONS(4285),
    [anon_sym_elsif] = ACTIONS(4285),
    [anon_sym_else] = ACTIONS(4285),
    [anon_sym_then] = ACTIONS(4285),
    [anon_sym_ensure] = ACTIONS(4285),
    [anon_sym_LBRACK] = ACTIONS(4285),
    [anon_sym_COLON_COLON2] = ACTIONS(4285),
    [anon_sym_AMP_DOT] = ACTIONS(4285),
    [anon_sym_PLUS_EQ] = ACTIONS(4285),
    [anon_sym_DASH_EQ] = ACTIONS(4285),
    [anon_sym_STAR_EQ] = ACTIONS(4285),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4285),
    [anon_sym_SLASH_EQ] = ACTIONS(4285),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4285),
    [anon_sym_PIPE_EQ] = ACTIONS(4285),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4285),
    [anon_sym_AMP_EQ] = ACTIONS(4285),
    [anon_sym_PERCENT_EQ] = ACTIONS(4285),
    [anon_sym_GT_GT_EQ] = ACTIONS(4285),
    [anon_sym_LT_LT_EQ] = ACTIONS(4285),
    [anon_sym_CARET_EQ] = ACTIONS(4285),
    [anon_sym_QMARK] = ACTIONS(4285),
    [anon_sym_DOT_DOT] = ACTIONS(4287),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4285),
    [anon_sym_and] = ACTIONS(4285),
    [anon_sym_or] = ACTIONS(4285),
    [anon_sym_PIPE_PIPE] = ACTIONS(4287),
    [anon_sym_AMP_AMP] = ACTIONS(4287),
    [anon_sym_LT_LT] = ACTIONS(4287),
    [anon_sym_GT_GT] = ACTIONS(4287),
    [anon_sym_EQ_EQ] = ACTIONS(4287),
    [anon_sym_BANG_EQ] = ACTIONS(4285),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4285),
    [anon_sym_LT_EQ_GT] = ACTIONS(4285),
    [anon_sym_EQ_TILDE] = ACTIONS(4285),
    [anon_sym_BANG_TILDE] = ACTIONS(4285),
    [anon_sym_LT_EQ] = ACTIONS(4287),
    [anon_sym_GT] = ACTIONS(4287),
    [anon_sym_GT_EQ] = ACTIONS(4285),
    [anon_sym_CARET] = ACTIONS(4287),
    [anon_sym_PLUS] = ACTIONS(4287),
    [anon_sym_SLASH] = ACTIONS(4287),
    [anon_sym_PERCENT] = ACTIONS(4287),
    [sym_comment] = ACTIONS(87),
  },
  [1557] = {
    [anon_sym_RPAREN] = ACTIONS(6147),
    [sym_comment] = ACTIONS(87),
  },
  [1558] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(2687),
    [sym__binary_star] = ACTIONS(2689),
    [ts_builtin_sym_end] = ACTIONS(935),
    [anon_sym___END__] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(2691),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(2693),
    [anon_sym_AMP] = ACTIONS(2695),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(2697),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(2699),
    [anon_sym_DOT_DOT] = ACTIONS(2701),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2703),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(2705),
    [anon_sym_AMP_AMP] = ACTIONS(2705),
    [anon_sym_LT_LT] = ACTIONS(2707),
    [anon_sym_GT_GT] = ACTIONS(2707),
    [anon_sym_EQ_EQ] = ACTIONS(2705),
    [anon_sym_BANG_EQ] = ACTIONS(2709),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2709),
    [anon_sym_LT_EQ_GT] = ACTIONS(2709),
    [anon_sym_EQ_TILDE] = ACTIONS(2709),
    [anon_sym_BANG_TILDE] = ACTIONS(2709),
    [anon_sym_LT_EQ] = ACTIONS(2697),
    [anon_sym_GT] = ACTIONS(2697),
    [anon_sym_GT_EQ] = ACTIONS(2711),
    [anon_sym_CARET] = ACTIONS(2691),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_SLASH] = ACTIONS(2693),
    [anon_sym_PERCENT] = ACTIONS(2693),
    [sym_comment] = ACTIONS(87),
  },
  [1559] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [ts_builtin_sym_end] = ACTIONS(935),
    [anon_sym___END__] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(937),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_when] = ACTIONS(935),
    [anon_sym_elsif] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_ensure] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [1560] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(3719),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(1498),
    [sym_scope_resolution] = STATE(1496),
    [sym_call] = STATE(1496),
    [sym_method_call] = STATE(1498),
    [sym_assignment] = STATE(3719),
    [sym_operator_assignment] = STATE(3719),
    [sym_conditional] = STATE(3719),
    [sym_range] = STATE(3719),
    [sym_binary] = STATE(3719),
    [sym_unary] = STATE(3719),
    [sym_left_assignment_list] = STATE(1497),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1498),
    [sym__variable] = STATE(1496),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(1498),
    [sym_false] = STATE(1498),
    [sym_nil] = STATE(1498),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(1499),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(2565),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(2577),
    [anon_sym_yield] = ACTIONS(2579),
    [anon_sym_break] = ACTIONS(2581),
    [anon_sym_next] = ACTIONS(2583),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(2601),
    [anon_sym_defined_QMARK] = ACTIONS(2603),
    [anon_sym_not] = ACTIONS(2605),
    [anon_sym_BANG] = ACTIONS(2607),
    [anon_sym_TILDE] = ACTIONS(2607),
    [sym_constant] = ACTIONS(2609),
    [sym_identifier] = ACTIONS(2609),
    [sym_instance_variable] = ACTIONS(2611),
    [sym_class_variable] = ACTIONS(2611),
    [sym_global_variable] = ACTIONS(2611),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(2609),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2609),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [1561] = {
    [sym__line_break] = ACTIONS(2261),
    [sym__heredoc_body_start] = ACTIONS(2261),
    [sym__binary_minus] = ACTIONS(2261),
    [sym__binary_star] = ACTIONS(2261),
    [ts_builtin_sym_end] = ACTIONS(2261),
    [anon_sym___END__] = ACTIONS(2261),
    [anon_sym_LBRACE] = ACTIONS(2261),
    [anon_sym_RBRACE] = ACTIONS(2261),
    [anon_sym_RPAREN] = ACTIONS(2261),
    [anon_sym_DOT] = ACTIONS(2263),
    [anon_sym_COMMA] = ACTIONS(2261),
    [anon_sym_PIPE] = ACTIONS(2263),
    [anon_sym_SEMI] = ACTIONS(2261),
    [anon_sym_STAR_STAR] = ACTIONS(2263),
    [anon_sym_AMP] = ACTIONS(2263),
    [anon_sym_EQ] = ACTIONS(2263),
    [anon_sym_LT] = ACTIONS(2263),
    [anon_sym_end] = ACTIONS(2261),
    [anon_sym_if] = ACTIONS(2261),
    [anon_sym_unless] = ACTIONS(2261),
    [anon_sym_while] = ACTIONS(2261),
    [anon_sym_until] = ACTIONS(2261),
    [anon_sym_rescue] = ACTIONS(2261),
    [anon_sym_do] = ACTIONS(2261),
    [anon_sym_when] = ACTIONS(2261),
    [anon_sym_elsif] = ACTIONS(2261),
    [anon_sym_else] = ACTIONS(2261),
    [anon_sym_then] = ACTIONS(2261),
    [anon_sym_ensure] = ACTIONS(2261),
    [anon_sym_EQ_GT] = ACTIONS(2261),
    [anon_sym_LBRACK] = ACTIONS(2261),
    [anon_sym_COLON_COLON2] = ACTIONS(2261),
    [anon_sym_AMP_DOT] = ACTIONS(2261),
    [anon_sym_PLUS_EQ] = ACTIONS(2261),
    [anon_sym_DASH_EQ] = ACTIONS(2261),
    [anon_sym_STAR_EQ] = ACTIONS(2261),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2261),
    [anon_sym_SLASH_EQ] = ACTIONS(2261),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2261),
    [anon_sym_PIPE_EQ] = ACTIONS(2261),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2261),
    [anon_sym_AMP_EQ] = ACTIONS(2261),
    [anon_sym_PERCENT_EQ] = ACTIONS(2261),
    [anon_sym_GT_GT_EQ] = ACTIONS(2261),
    [anon_sym_LT_LT_EQ] = ACTIONS(2261),
    [anon_sym_CARET_EQ] = ACTIONS(2261),
    [anon_sym_QMARK] = ACTIONS(2261),
    [anon_sym_DOT_DOT] = ACTIONS(2263),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2261),
    [anon_sym_and] = ACTIONS(2261),
    [anon_sym_or] = ACTIONS(2261),
    [anon_sym_PIPE_PIPE] = ACTIONS(2263),
    [anon_sym_AMP_AMP] = ACTIONS(2263),
    [anon_sym_LT_LT] = ACTIONS(2263),
    [anon_sym_GT_GT] = ACTIONS(2263),
    [anon_sym_EQ_EQ] = ACTIONS(2263),
    [anon_sym_BANG_EQ] = ACTIONS(2261),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2261),
    [anon_sym_LT_EQ_GT] = ACTIONS(2261),
    [anon_sym_EQ_TILDE] = ACTIONS(2261),
    [anon_sym_BANG_TILDE] = ACTIONS(2261),
    [anon_sym_LT_EQ] = ACTIONS(2263),
    [anon_sym_GT] = ACTIONS(2263),
    [anon_sym_GT_EQ] = ACTIONS(2261),
    [anon_sym_CARET] = ACTIONS(2263),
    [anon_sym_PLUS] = ACTIONS(2263),
    [anon_sym_SLASH] = ACTIONS(2263),
    [anon_sym_PERCENT] = ACTIONS(2263),
    [sym_comment] = ACTIONS(87),
  },
  [1562] = {
    [sym__line_break] = ACTIONS(2345),
    [sym__heredoc_body_start] = ACTIONS(2345),
    [sym__binary_minus] = ACTIONS(2345),
    [sym__binary_star] = ACTIONS(2345),
    [ts_builtin_sym_end] = ACTIONS(2345),
    [anon_sym___END__] = ACTIONS(2345),
    [anon_sym_LBRACE] = ACTIONS(2345),
    [anon_sym_RBRACE] = ACTIONS(2345),
    [anon_sym_RPAREN] = ACTIONS(2345),
    [anon_sym_DOT] = ACTIONS(2347),
    [anon_sym_COMMA] = ACTIONS(2345),
    [anon_sym_PIPE] = ACTIONS(2347),
    [anon_sym_SEMI] = ACTIONS(2345),
    [anon_sym_STAR_STAR] = ACTIONS(2347),
    [anon_sym_AMP] = ACTIONS(2347),
    [anon_sym_EQ] = ACTIONS(2347),
    [anon_sym_LT] = ACTIONS(2347),
    [anon_sym_end] = ACTIONS(2345),
    [anon_sym_if] = ACTIONS(2345),
    [anon_sym_unless] = ACTIONS(2345),
    [anon_sym_while] = ACTIONS(2345),
    [anon_sym_until] = ACTIONS(2345),
    [anon_sym_rescue] = ACTIONS(2345),
    [anon_sym_do] = ACTIONS(2345),
    [anon_sym_when] = ACTIONS(2345),
    [anon_sym_elsif] = ACTIONS(2345),
    [anon_sym_else] = ACTIONS(2345),
    [anon_sym_then] = ACTIONS(2345),
    [anon_sym_ensure] = ACTIONS(2345),
    [anon_sym_EQ_GT] = ACTIONS(2345),
    [anon_sym_LBRACK] = ACTIONS(2345),
    [anon_sym_COLON_COLON2] = ACTIONS(2345),
    [anon_sym_AMP_DOT] = ACTIONS(2345),
    [anon_sym_PLUS_EQ] = ACTIONS(2345),
    [anon_sym_DASH_EQ] = ACTIONS(2345),
    [anon_sym_STAR_EQ] = ACTIONS(2345),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2345),
    [anon_sym_SLASH_EQ] = ACTIONS(2345),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2345),
    [anon_sym_PIPE_EQ] = ACTIONS(2345),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2345),
    [anon_sym_AMP_EQ] = ACTIONS(2345),
    [anon_sym_PERCENT_EQ] = ACTIONS(2345),
    [anon_sym_GT_GT_EQ] = ACTIONS(2345),
    [anon_sym_LT_LT_EQ] = ACTIONS(2345),
    [anon_sym_CARET_EQ] = ACTIONS(2345),
    [anon_sym_QMARK] = ACTIONS(2345),
    [anon_sym_DOT_DOT] = ACTIONS(2347),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2345),
    [anon_sym_and] = ACTIONS(2345),
    [anon_sym_or] = ACTIONS(2345),
    [anon_sym_PIPE_PIPE] = ACTIONS(2347),
    [anon_sym_AMP_AMP] = ACTIONS(2347),
    [anon_sym_LT_LT] = ACTIONS(2347),
    [anon_sym_GT_GT] = ACTIONS(2347),
    [anon_sym_EQ_EQ] = ACTIONS(2347),
    [anon_sym_BANG_EQ] = ACTIONS(2345),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2345),
    [anon_sym_LT_EQ_GT] = ACTIONS(2345),
    [anon_sym_EQ_TILDE] = ACTIONS(2345),
    [anon_sym_BANG_TILDE] = ACTIONS(2345),
    [anon_sym_LT_EQ] = ACTIONS(2347),
    [anon_sym_GT] = ACTIONS(2347),
    [anon_sym_GT_EQ] = ACTIONS(2345),
    [anon_sym_CARET] = ACTIONS(2347),
    [anon_sym_PLUS] = ACTIONS(2347),
    [anon_sym_SLASH] = ACTIONS(2347),
    [anon_sym_PERCENT] = ACTIONS(2347),
    [sym_comment] = ACTIONS(87),
  },
  [1563] = {
    [anon_sym_RBRACK] = ACTIONS(6149),
    [sym_comment] = ACTIONS(87),
  },
  [1564] = {
    [sym__statements] = STATE(2546),
    [sym_begin_block] = STATE(489),
    [sym_end_block] = STATE(489),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_block_parameters] = STATE(2547),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(495),
    [aux_sym__statements_repeat1] = STATE(495),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(6151),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2445),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1565] = {
    [sym_do_block] = STATE(3722),
    [sym_block] = STATE(3722),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_do] = ACTIONS(4371),
    [sym_comment] = ACTIONS(87),
  },
  [1566] = {
    [sym__line_break] = ACTIONS(2485),
    [sym__heredoc_body_start] = ACTIONS(2485),
    [sym__binary_minus] = ACTIONS(2485),
    [sym__binary_star] = ACTIONS(2485),
    [ts_builtin_sym_end] = ACTIONS(2485),
    [anon_sym___END__] = ACTIONS(2485),
    [anon_sym_LBRACE] = ACTIONS(2485),
    [anon_sym_RBRACE] = ACTIONS(2485),
    [anon_sym_RPAREN] = ACTIONS(2485),
    [anon_sym_DOT] = ACTIONS(2487),
    [anon_sym_COMMA] = ACTIONS(2485),
    [anon_sym_PIPE] = ACTIONS(2487),
    [anon_sym_SEMI] = ACTIONS(2485),
    [anon_sym_STAR_STAR] = ACTIONS(2487),
    [anon_sym_AMP] = ACTIONS(2487),
    [anon_sym_EQ] = ACTIONS(2487),
    [anon_sym_LT] = ACTIONS(2487),
    [anon_sym_end] = ACTIONS(2485),
    [anon_sym_if] = ACTIONS(2485),
    [anon_sym_unless] = ACTIONS(2485),
    [anon_sym_while] = ACTIONS(2485),
    [anon_sym_until] = ACTIONS(2485),
    [anon_sym_rescue] = ACTIONS(2485),
    [anon_sym_do] = ACTIONS(2485),
    [anon_sym_when] = ACTIONS(2485),
    [anon_sym_elsif] = ACTIONS(2485),
    [anon_sym_else] = ACTIONS(2485),
    [anon_sym_then] = ACTIONS(2485),
    [anon_sym_ensure] = ACTIONS(2485),
    [anon_sym_EQ_GT] = ACTIONS(2485),
    [anon_sym_LBRACK] = ACTIONS(2485),
    [anon_sym_COLON_COLON2] = ACTIONS(2485),
    [anon_sym_AMP_DOT] = ACTIONS(2485),
    [anon_sym_PLUS_EQ] = ACTIONS(2485),
    [anon_sym_DASH_EQ] = ACTIONS(2485),
    [anon_sym_STAR_EQ] = ACTIONS(2485),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2485),
    [anon_sym_SLASH_EQ] = ACTIONS(2485),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2485),
    [anon_sym_PIPE_EQ] = ACTIONS(2485),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2485),
    [anon_sym_AMP_EQ] = ACTIONS(2485),
    [anon_sym_PERCENT_EQ] = ACTIONS(2485),
    [anon_sym_GT_GT_EQ] = ACTIONS(2485),
    [anon_sym_LT_LT_EQ] = ACTIONS(2485),
    [anon_sym_CARET_EQ] = ACTIONS(2485),
    [anon_sym_QMARK] = ACTIONS(2485),
    [anon_sym_DOT_DOT] = ACTIONS(2487),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2485),
    [anon_sym_and] = ACTIONS(2485),
    [anon_sym_or] = ACTIONS(2485),
    [anon_sym_PIPE_PIPE] = ACTIONS(2487),
    [anon_sym_AMP_AMP] = ACTIONS(2487),
    [anon_sym_LT_LT] = ACTIONS(2487),
    [anon_sym_GT_GT] = ACTIONS(2487),
    [anon_sym_EQ_EQ] = ACTIONS(2487),
    [anon_sym_BANG_EQ] = ACTIONS(2485),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2485),
    [anon_sym_LT_EQ_GT] = ACTIONS(2485),
    [anon_sym_EQ_TILDE] = ACTIONS(2485),
    [anon_sym_BANG_TILDE] = ACTIONS(2485),
    [anon_sym_LT_EQ] = ACTIONS(2487),
    [anon_sym_GT] = ACTIONS(2487),
    [anon_sym_GT_EQ] = ACTIONS(2485),
    [anon_sym_CARET] = ACTIONS(2487),
    [anon_sym_PLUS] = ACTIONS(2487),
    [anon_sym_SLASH] = ACTIONS(2487),
    [anon_sym_PERCENT] = ACTIONS(2487),
    [sym_comment] = ACTIONS(87),
  },
  [1567] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3723),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(428),
    [sym_scope_resolution] = STATE(422),
    [sym_call] = STATE(422),
    [sym_method_call] = STATE(428),
    [sym_assignment] = STATE(3723),
    [sym_operator_assignment] = STATE(3723),
    [sym_conditional] = STATE(3723),
    [sym_range] = STATE(3723),
    [sym_binary] = STATE(3723),
    [sym_unary] = STATE(3723),
    [sym_left_assignment_list] = STATE(427),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(428),
    [sym__variable] = STATE(422),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(428),
    [sym_false] = STATE(428),
    [sym_nil] = STATE(428),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(1503),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(781),
    [anon_sym_yield] = ACTIONS(783),
    [anon_sym_break] = ACTIONS(785),
    [anon_sym_next] = ACTIONS(787),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(2623),
    [anon_sym_defined_QMARK] = ACTIONS(801),
    [anon_sym_not] = ACTIONS(803),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_TILDE] = ACTIONS(807),
    [sym_constant] = ACTIONS(815),
    [sym_identifier] = ACTIONS(815),
    [sym_instance_variable] = ACTIONS(811),
    [sym_class_variable] = ACTIONS(811),
    [sym_global_variable] = ACTIONS(811),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(815),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(815),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [1568] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3724),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(428),
    [sym_scope_resolution] = STATE(422),
    [sym_call] = STATE(422),
    [sym_method_call] = STATE(428),
    [sym_assignment] = STATE(3724),
    [sym_operator_assignment] = STATE(3724),
    [sym_conditional] = STATE(3724),
    [sym_range] = STATE(3724),
    [sym_binary] = STATE(3724),
    [sym_unary] = STATE(3724),
    [sym_left_assignment_list] = STATE(427),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(428),
    [sym__variable] = STATE(422),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(428),
    [sym_false] = STATE(428),
    [sym_nil] = STATE(428),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(1503),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(781),
    [anon_sym_yield] = ACTIONS(783),
    [anon_sym_break] = ACTIONS(785),
    [anon_sym_next] = ACTIONS(787),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(2623),
    [anon_sym_defined_QMARK] = ACTIONS(801),
    [anon_sym_not] = ACTIONS(803),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_TILDE] = ACTIONS(807),
    [sym_constant] = ACTIONS(815),
    [sym_identifier] = ACTIONS(815),
    [sym_instance_variable] = ACTIONS(811),
    [sym_class_variable] = ACTIONS(811),
    [sym_global_variable] = ACTIONS(811),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(815),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(815),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [1569] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3725),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(428),
    [sym_scope_resolution] = STATE(422),
    [sym_call] = STATE(422),
    [sym_method_call] = STATE(428),
    [sym_assignment] = STATE(3725),
    [sym_operator_assignment] = STATE(3725),
    [sym_conditional] = STATE(3725),
    [sym_range] = STATE(3725),
    [sym_binary] = STATE(3725),
    [sym_unary] = STATE(3725),
    [sym_left_assignment_list] = STATE(427),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(428),
    [sym__variable] = STATE(422),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(428),
    [sym_false] = STATE(428),
    [sym_nil] = STATE(428),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(1503),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(781),
    [anon_sym_yield] = ACTIONS(783),
    [anon_sym_break] = ACTIONS(785),
    [anon_sym_next] = ACTIONS(787),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(2623),
    [anon_sym_defined_QMARK] = ACTIONS(801),
    [anon_sym_not] = ACTIONS(803),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_TILDE] = ACTIONS(807),
    [sym_constant] = ACTIONS(815),
    [sym_identifier] = ACTIONS(815),
    [sym_instance_variable] = ACTIONS(811),
    [sym_class_variable] = ACTIONS(811),
    [sym_global_variable] = ACTIONS(811),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(815),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(815),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [1570] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3726),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(428),
    [sym_scope_resolution] = STATE(422),
    [sym_call] = STATE(422),
    [sym_method_call] = STATE(428),
    [sym_assignment] = STATE(3726),
    [sym_operator_assignment] = STATE(3726),
    [sym_conditional] = STATE(3726),
    [sym_range] = STATE(3726),
    [sym_binary] = STATE(3726),
    [sym_unary] = STATE(3726),
    [sym_left_assignment_list] = STATE(427),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(428),
    [sym__variable] = STATE(422),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(428),
    [sym_false] = STATE(428),
    [sym_nil] = STATE(428),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(1503),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(781),
    [anon_sym_yield] = ACTIONS(783),
    [anon_sym_break] = ACTIONS(785),
    [anon_sym_next] = ACTIONS(787),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(2623),
    [anon_sym_defined_QMARK] = ACTIONS(801),
    [anon_sym_not] = ACTIONS(803),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_TILDE] = ACTIONS(807),
    [sym_constant] = ACTIONS(815),
    [sym_identifier] = ACTIONS(815),
    [sym_instance_variable] = ACTIONS(811),
    [sym_class_variable] = ACTIONS(811),
    [sym_global_variable] = ACTIONS(811),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(815),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(815),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [1571] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3727),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(428),
    [sym_scope_resolution] = STATE(422),
    [sym_call] = STATE(422),
    [sym_method_call] = STATE(428),
    [sym_assignment] = STATE(3727),
    [sym_operator_assignment] = STATE(3727),
    [sym_conditional] = STATE(3727),
    [sym_range] = STATE(3727),
    [sym_binary] = STATE(3727),
    [sym_unary] = STATE(3727),
    [sym_left_assignment_list] = STATE(427),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(428),
    [sym__variable] = STATE(422),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(428),
    [sym_false] = STATE(428),
    [sym_nil] = STATE(428),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(1503),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(781),
    [anon_sym_yield] = ACTIONS(783),
    [anon_sym_break] = ACTIONS(785),
    [anon_sym_next] = ACTIONS(787),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(2623),
    [anon_sym_defined_QMARK] = ACTIONS(801),
    [anon_sym_not] = ACTIONS(803),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_TILDE] = ACTIONS(807),
    [sym_constant] = ACTIONS(815),
    [sym_identifier] = ACTIONS(815),
    [sym_instance_variable] = ACTIONS(811),
    [sym_class_variable] = ACTIONS(811),
    [sym_global_variable] = ACTIONS(811),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(815),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(815),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [1572] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(3728),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(3728),
    [sym_operator_assignment] = STATE(3728),
    [sym_conditional] = STATE(3728),
    [sym_range] = STATE(3728),
    [sym_binary] = STATE(3728),
    [sym_unary] = STATE(3728),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1573] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3729),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(428),
    [sym_scope_resolution] = STATE(422),
    [sym_call] = STATE(422),
    [sym_method_call] = STATE(428),
    [sym_assignment] = STATE(3729),
    [sym_operator_assignment] = STATE(3729),
    [sym_conditional] = STATE(3729),
    [sym_range] = STATE(3729),
    [sym_binary] = STATE(3729),
    [sym_unary] = STATE(3729),
    [sym_left_assignment_list] = STATE(427),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(428),
    [sym__variable] = STATE(422),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(428),
    [sym_false] = STATE(428),
    [sym_nil] = STATE(428),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(1503),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(781),
    [anon_sym_yield] = ACTIONS(783),
    [anon_sym_break] = ACTIONS(785),
    [anon_sym_next] = ACTIONS(787),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(2623),
    [anon_sym_defined_QMARK] = ACTIONS(801),
    [anon_sym_not] = ACTIONS(803),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_TILDE] = ACTIONS(807),
    [sym_constant] = ACTIONS(815),
    [sym_identifier] = ACTIONS(815),
    [sym_instance_variable] = ACTIONS(811),
    [sym_class_variable] = ACTIONS(811),
    [sym_global_variable] = ACTIONS(811),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(815),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(815),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [1574] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3730),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(428),
    [sym_scope_resolution] = STATE(422),
    [sym_call] = STATE(422),
    [sym_method_call] = STATE(428),
    [sym_assignment] = STATE(3730),
    [sym_operator_assignment] = STATE(3730),
    [sym_conditional] = STATE(3730),
    [sym_range] = STATE(3730),
    [sym_binary] = STATE(3730),
    [sym_unary] = STATE(3730),
    [sym_left_assignment_list] = STATE(427),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(428),
    [sym__variable] = STATE(422),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(428),
    [sym_false] = STATE(428),
    [sym_nil] = STATE(428),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(1503),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(781),
    [anon_sym_yield] = ACTIONS(783),
    [anon_sym_break] = ACTIONS(785),
    [anon_sym_next] = ACTIONS(787),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(2623),
    [anon_sym_defined_QMARK] = ACTIONS(801),
    [anon_sym_not] = ACTIONS(803),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_TILDE] = ACTIONS(807),
    [sym_constant] = ACTIONS(815),
    [sym_identifier] = ACTIONS(815),
    [sym_instance_variable] = ACTIONS(811),
    [sym_class_variable] = ACTIONS(811),
    [sym_global_variable] = ACTIONS(811),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(815),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(815),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [1575] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3731),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(428),
    [sym_scope_resolution] = STATE(422),
    [sym_call] = STATE(422),
    [sym_method_call] = STATE(428),
    [sym_assignment] = STATE(3731),
    [sym_operator_assignment] = STATE(3731),
    [sym_conditional] = STATE(3731),
    [sym_range] = STATE(3731),
    [sym_binary] = STATE(3731),
    [sym_unary] = STATE(3731),
    [sym_left_assignment_list] = STATE(427),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(428),
    [sym__variable] = STATE(422),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(428),
    [sym_false] = STATE(428),
    [sym_nil] = STATE(428),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(1503),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(781),
    [anon_sym_yield] = ACTIONS(783),
    [anon_sym_break] = ACTIONS(785),
    [anon_sym_next] = ACTIONS(787),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(2623),
    [anon_sym_defined_QMARK] = ACTIONS(801),
    [anon_sym_not] = ACTIONS(803),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_TILDE] = ACTIONS(807),
    [sym_constant] = ACTIONS(815),
    [sym_identifier] = ACTIONS(815),
    [sym_instance_variable] = ACTIONS(811),
    [sym_class_variable] = ACTIONS(811),
    [sym_global_variable] = ACTIONS(811),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(815),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(815),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [1576] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3732),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(428),
    [sym_scope_resolution] = STATE(422),
    [sym_call] = STATE(422),
    [sym_method_call] = STATE(428),
    [sym_assignment] = STATE(3732),
    [sym_operator_assignment] = STATE(3732),
    [sym_conditional] = STATE(3732),
    [sym_range] = STATE(3732),
    [sym_binary] = STATE(3732),
    [sym_unary] = STATE(3732),
    [sym_left_assignment_list] = STATE(427),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(428),
    [sym__variable] = STATE(422),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(428),
    [sym_false] = STATE(428),
    [sym_nil] = STATE(428),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(1503),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(781),
    [anon_sym_yield] = ACTIONS(783),
    [anon_sym_break] = ACTIONS(785),
    [anon_sym_next] = ACTIONS(787),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(2623),
    [anon_sym_defined_QMARK] = ACTIONS(801),
    [anon_sym_not] = ACTIONS(803),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_TILDE] = ACTIONS(807),
    [sym_constant] = ACTIONS(815),
    [sym_identifier] = ACTIONS(815),
    [sym_instance_variable] = ACTIONS(811),
    [sym_class_variable] = ACTIONS(811),
    [sym_global_variable] = ACTIONS(811),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(815),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(815),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [1577] = {
    [sym__statements] = STATE(2546),
    [sym_begin_block] = STATE(489),
    [sym_end_block] = STATE(489),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_block_parameters] = STATE(2547),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1516),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1519),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1519),
    [sym_hash_splat_argument] = STATE(116),
    [sym_assignment] = STATE(1516),
    [sym_operator_assignment] = STATE(1516),
    [sym_conditional] = STATE(1516),
    [sym_range] = STATE(1516),
    [sym_binary] = STATE(1516),
    [sym_unary] = STATE(1516),
    [sym_left_assignment_list] = STATE(1518),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1519),
    [sym__variable] = STATE(1517),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1519),
    [sym_false] = STATE(1519),
    [sym_nil] = STATE(1519),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1520),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(1521),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym__hash_items] = STATE(1522),
    [sym_pair] = STATE(122),
    [sym_lambda] = STATE(214),
    [sym_empty_statement] = STATE(495),
    [aux_sym__statements_repeat1] = STATE(495),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2629),
    [sym__identifier_hash_key] = ACTIONS(157),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(6151),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_PIPE] = ACTIONS(2445),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2633),
    [anon_sym_yield] = ACTIONS(2635),
    [anon_sym_break] = ACTIONS(2637),
    [anon_sym_next] = ACTIONS(2639),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2641),
    [anon_sym_defined_QMARK] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2647),
    [anon_sym_TILDE] = ACTIONS(2647),
    [sym_constant] = ACTIONS(2649),
    [sym_identifier] = ACTIONS(2649),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1578] = {
    [sym_do_block] = STATE(2556),
    [sym_block] = STATE(2556),
    [sym__line_break] = ACTIONS(2717),
    [sym__heredoc_body_start] = ACTIONS(2717),
    [sym__binary_minus] = ACTIONS(2717),
    [sym__binary_star] = ACTIONS(2717),
    [ts_builtin_sym_end] = ACTIONS(2717),
    [anon_sym___END__] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_RBRACE] = ACTIONS(2717),
    [anon_sym_RPAREN] = ACTIONS(2717),
    [anon_sym_DOT] = ACTIONS(2721),
    [anon_sym_COMMA] = ACTIONS(2717),
    [anon_sym_PIPE] = ACTIONS(2721),
    [anon_sym_SEMI] = ACTIONS(2717),
    [anon_sym_STAR_STAR] = ACTIONS(2721),
    [anon_sym_AMP] = ACTIONS(2721),
    [anon_sym_EQ] = ACTIONS(2721),
    [anon_sym_LT] = ACTIONS(2721),
    [anon_sym_end] = ACTIONS(2717),
    [anon_sym_if] = ACTIONS(2717),
    [anon_sym_unless] = ACTIONS(2717),
    [anon_sym_while] = ACTIONS(2717),
    [anon_sym_until] = ACTIONS(2717),
    [anon_sym_rescue] = ACTIONS(2717),
    [anon_sym_do] = ACTIONS(2717),
    [anon_sym_when] = ACTIONS(2717),
    [anon_sym_elsif] = ACTIONS(2717),
    [anon_sym_else] = ACTIONS(2717),
    [anon_sym_then] = ACTIONS(2717),
    [anon_sym_ensure] = ACTIONS(2717),
    [anon_sym_EQ_GT] = ACTIONS(2717),
    [anon_sym_LBRACK] = ACTIONS(2717),
    [anon_sym_COLON_COLON2] = ACTIONS(2717),
    [anon_sym_AMP_DOT] = ACTIONS(2717),
    [anon_sym_PLUS_EQ] = ACTIONS(2717),
    [anon_sym_DASH_EQ] = ACTIONS(2717),
    [anon_sym_STAR_EQ] = ACTIONS(2717),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2717),
    [anon_sym_SLASH_EQ] = ACTIONS(2717),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2717),
    [anon_sym_PIPE_EQ] = ACTIONS(2717),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2717),
    [anon_sym_AMP_EQ] = ACTIONS(2717),
    [anon_sym_PERCENT_EQ] = ACTIONS(2717),
    [anon_sym_GT_GT_EQ] = ACTIONS(2717),
    [anon_sym_LT_LT_EQ] = ACTIONS(2717),
    [anon_sym_CARET_EQ] = ACTIONS(2717),
    [anon_sym_QMARK] = ACTIONS(2717),
    [anon_sym_DOT_DOT] = ACTIONS(2721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2717),
    [anon_sym_and] = ACTIONS(2717),
    [anon_sym_or] = ACTIONS(2717),
    [anon_sym_PIPE_PIPE] = ACTIONS(2721),
    [anon_sym_AMP_AMP] = ACTIONS(2721),
    [anon_sym_LT_LT] = ACTIONS(2721),
    [anon_sym_GT_GT] = ACTIONS(2721),
    [anon_sym_EQ_EQ] = ACTIONS(2721),
    [anon_sym_BANG_EQ] = ACTIONS(2717),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2717),
    [anon_sym_LT_EQ_GT] = ACTIONS(2717),
    [anon_sym_EQ_TILDE] = ACTIONS(2717),
    [anon_sym_BANG_TILDE] = ACTIONS(2717),
    [anon_sym_LT_EQ] = ACTIONS(2721),
    [anon_sym_GT] = ACTIONS(2721),
    [anon_sym_GT_EQ] = ACTIONS(2717),
    [anon_sym_CARET] = ACTIONS(2721),
    [anon_sym_PLUS] = ACTIONS(2721),
    [anon_sym_SLASH] = ACTIONS(2721),
    [anon_sym_PERCENT] = ACTIONS(2721),
    [sym_comment] = ACTIONS(87),
  },
  [1579] = {
    [sym__statements] = STATE(1514),
    [sym_begin_block] = STATE(489),
    [sym_end_block] = STATE(489),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_block_parameters] = STATE(1515),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(495),
    [aux_sym__statements_repeat1] = STATE(495),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(6153),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2445),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1580] = {
    [sym__line_break] = ACTIONS(6155),
    [sym__heredoc_body_start] = ACTIONS(6155),
    [sym__binary_minus] = ACTIONS(6155),
    [sym__binary_star] = ACTIONS(6155),
    [ts_builtin_sym_end] = ACTIONS(6155),
    [anon_sym___END__] = ACTIONS(6155),
    [anon_sym_LBRACE] = ACTIONS(6155),
    [anon_sym_RBRACE] = ACTIONS(6155),
    [anon_sym_RPAREN] = ACTIONS(6155),
    [anon_sym_DOT] = ACTIONS(6157),
    [anon_sym_COMMA] = ACTIONS(6155),
    [anon_sym_PIPE] = ACTIONS(6157),
    [anon_sym_SEMI] = ACTIONS(6155),
    [anon_sym_STAR_STAR] = ACTIONS(6157),
    [anon_sym_AMP] = ACTIONS(6157),
    [anon_sym_EQ] = ACTIONS(6157),
    [anon_sym_LT] = ACTIONS(6157),
    [anon_sym_end] = ACTIONS(6155),
    [anon_sym_if] = ACTIONS(6155),
    [anon_sym_unless] = ACTIONS(6155),
    [anon_sym_while] = ACTIONS(6155),
    [anon_sym_until] = ACTIONS(6155),
    [anon_sym_rescue] = ACTIONS(6155),
    [anon_sym_do] = ACTIONS(6155),
    [anon_sym_when] = ACTIONS(6155),
    [anon_sym_elsif] = ACTIONS(6155),
    [anon_sym_else] = ACTIONS(6155),
    [anon_sym_then] = ACTIONS(6155),
    [anon_sym_ensure] = ACTIONS(6155),
    [anon_sym_LBRACK] = ACTIONS(6155),
    [anon_sym_COLON_COLON2] = ACTIONS(6155),
    [anon_sym_AMP_DOT] = ACTIONS(6155),
    [anon_sym_PLUS_EQ] = ACTIONS(6155),
    [anon_sym_DASH_EQ] = ACTIONS(6155),
    [anon_sym_STAR_EQ] = ACTIONS(6155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6155),
    [anon_sym_SLASH_EQ] = ACTIONS(6155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6155),
    [anon_sym_PIPE_EQ] = ACTIONS(6155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6155),
    [anon_sym_AMP_EQ] = ACTIONS(6155),
    [anon_sym_PERCENT_EQ] = ACTIONS(6155),
    [anon_sym_GT_GT_EQ] = ACTIONS(6155),
    [anon_sym_LT_LT_EQ] = ACTIONS(6155),
    [anon_sym_CARET_EQ] = ACTIONS(6155),
    [anon_sym_QMARK] = ACTIONS(6155),
    [anon_sym_DOT_DOT] = ACTIONS(6157),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6155),
    [anon_sym_and] = ACTIONS(6155),
    [anon_sym_or] = ACTIONS(6155),
    [anon_sym_PIPE_PIPE] = ACTIONS(6157),
    [anon_sym_AMP_AMP] = ACTIONS(6157),
    [anon_sym_LT_LT] = ACTIONS(6157),
    [anon_sym_GT_GT] = ACTIONS(6157),
    [anon_sym_EQ_EQ] = ACTIONS(6157),
    [anon_sym_BANG_EQ] = ACTIONS(6155),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6155),
    [anon_sym_LT_EQ_GT] = ACTIONS(6155),
    [anon_sym_EQ_TILDE] = ACTIONS(6155),
    [anon_sym_BANG_TILDE] = ACTIONS(6155),
    [anon_sym_LT_EQ] = ACTIONS(6157),
    [anon_sym_GT] = ACTIONS(6157),
    [anon_sym_GT_EQ] = ACTIONS(6155),
    [anon_sym_CARET] = ACTIONS(6157),
    [anon_sym_PLUS] = ACTIONS(6157),
    [anon_sym_SLASH] = ACTIONS(6157),
    [anon_sym_PERCENT] = ACTIONS(6157),
    [sym_comment] = ACTIONS(87),
  },
  [1581] = {
    [sym_interpolation] = STATE(3735),
    [aux_sym_heredoc_body_repeat1] = STATE(3735),
    [sym__heredoc_content] = ACTIONS(6159),
    [sym_heredoc_end] = ACTIONS(6161),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(6159),
  },
  [1582] = {
    [sym_heredoc_body] = STATE(3736),
    [aux_sym_call_repeat1] = STATE(3736),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [ts_builtin_sym_end] = ACTIONS(4383),
    [anon_sym___END__] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [1583] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(420),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(428),
    [sym_scope_resolution] = STATE(422),
    [sym_call] = STATE(422),
    [sym_method_call] = STATE(428),
    [sym__argument] = STATE(3737),
    [sym_splat_argument] = STATE(3737),
    [sym_hash_splat_argument] = STATE(3737),
    [sym_block_argument] = STATE(3737),
    [sym_assignment] = STATE(420),
    [sym_operator_assignment] = STATE(420),
    [sym_conditional] = STATE(420),
    [sym_range] = STATE(420),
    [sym_binary] = STATE(420),
    [sym_unary] = STATE(420),
    [sym_left_assignment_list] = STATE(427),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(428),
    [sym__variable] = STATE(422),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(428),
    [sym_false] = STATE(428),
    [sym_nil] = STATE(428),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(429),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_heredoc_body] = STATE(3738),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(3737),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(761),
    [sym__splat_star] = ACTIONS(763),
    [sym__unary_minus] = ACTIONS(765),
    [sym__identifier_hash_key] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(6163),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(781),
    [anon_sym_yield] = ACTIONS(783),
    [anon_sym_break] = ACTIONS(785),
    [anon_sym_next] = ACTIONS(787),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(2623),
    [anon_sym_defined_QMARK] = ACTIONS(801),
    [anon_sym_not] = ACTIONS(803),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_TILDE] = ACTIONS(807),
    [sym_constant] = ACTIONS(809),
    [sym_identifier] = ACTIONS(809),
    [sym_instance_variable] = ACTIONS(811),
    [sym_class_variable] = ACTIONS(811),
    [sym_global_variable] = ACTIONS(811),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(815),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(815),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [1584] = {
    [sym_heredoc_body] = STATE(3739),
    [aux_sym_call_repeat1] = STATE(3739),
    [aux_sym_argument_list_repeat1] = STATE(3740),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [ts_builtin_sym_end] = ACTIONS(4383),
    [anon_sym___END__] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(2727),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [1585] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3741),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(428),
    [sym_scope_resolution] = STATE(422),
    [sym_call] = STATE(422),
    [sym_method_call] = STATE(428),
    [sym_splat_argument] = STATE(3743),
    [sym_assignment] = STATE(3741),
    [sym_operator_assignment] = STATE(3741),
    [sym_conditional] = STATE(3741),
    [sym_range] = STATE(3741),
    [sym_binary] = STATE(3741),
    [sym_unary] = STATE(3741),
    [sym_right_assignment_list] = STATE(3742),
    [sym__arg_or_splat_arg] = STATE(3743),
    [sym_left_assignment_list] = STATE(427),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(428),
    [sym__variable] = STATE(422),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(428),
    [sym_false] = STATE(428),
    [sym_nil] = STATE(428),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(1503),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__splat_star] = ACTIONS(1665),
    [sym__unary_minus] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(781),
    [anon_sym_yield] = ACTIONS(783),
    [anon_sym_break] = ACTIONS(785),
    [anon_sym_next] = ACTIONS(787),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(2623),
    [anon_sym_defined_QMARK] = ACTIONS(801),
    [anon_sym_not] = ACTIONS(803),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_TILDE] = ACTIONS(807),
    [sym_constant] = ACTIONS(815),
    [sym_identifier] = ACTIONS(815),
    [sym_instance_variable] = ACTIONS(811),
    [sym_class_variable] = ACTIONS(811),
    [sym_global_variable] = ACTIONS(811),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(815),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(815),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [1586] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3744),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(428),
    [sym_scope_resolution] = STATE(422),
    [sym_call] = STATE(422),
    [sym_method_call] = STATE(428),
    [sym_assignment] = STATE(3744),
    [sym_operator_assignment] = STATE(3744),
    [sym_conditional] = STATE(3744),
    [sym_range] = STATE(3744),
    [sym_binary] = STATE(3744),
    [sym_unary] = STATE(3744),
    [sym_left_assignment_list] = STATE(427),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(428),
    [sym__variable] = STATE(422),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(428),
    [sym_false] = STATE(428),
    [sym_nil] = STATE(428),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(1503),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(781),
    [anon_sym_yield] = ACTIONS(783),
    [anon_sym_break] = ACTIONS(785),
    [anon_sym_next] = ACTIONS(787),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(2623),
    [anon_sym_defined_QMARK] = ACTIONS(801),
    [anon_sym_not] = ACTIONS(803),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_TILDE] = ACTIONS(807),
    [sym_constant] = ACTIONS(815),
    [sym_identifier] = ACTIONS(815),
    [sym_instance_variable] = ACTIONS(811),
    [sym_class_variable] = ACTIONS(811),
    [sym_global_variable] = ACTIONS(811),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(815),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(815),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [1587] = {
    [sym_string] = STATE(3745),
    [aux_sym_chained_string_repeat1] = STATE(3745),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(747),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [ts_builtin_sym_end] = ACTIONS(2753),
    [anon_sym___END__] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2755),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_EQ] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_EQ_GT] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_PLUS_EQ] = ACTIONS(2753),
    [anon_sym_DASH_EQ] = ACTIONS(2753),
    [anon_sym_STAR_EQ] = ACTIONS(2753),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2753),
    [anon_sym_SLASH_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2753),
    [anon_sym_AMP_EQ] = ACTIONS(2753),
    [anon_sym_PERCENT_EQ] = ACTIONS(2753),
    [anon_sym_GT_GT_EQ] = ACTIONS(2753),
    [anon_sym_LT_LT_EQ] = ACTIONS(2753),
    [anon_sym_CARET_EQ] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2755),
    [anon_sym_AMP_AMP] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2755),
    [anon_sym_GT_GT] = ACTIONS(2755),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_SLASH] = ACTIONS(2755),
    [anon_sym_PERCENT] = ACTIONS(2755),
    [sym_comment] = ACTIONS(87),
  },
  [1588] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(3746),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1596),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(1596),
    [sym_assignment] = STATE(3746),
    [sym_operator_assignment] = STATE(3746),
    [sym_conditional] = STATE(3746),
    [sym_range] = STATE(3746),
    [sym_binary] = STATE(3746),
    [sym_unary] = STATE(3746),
    [sym_left_assignment_list] = STATE(1595),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1596),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1596),
    [sym_false] = STATE(1596),
    [sym_nil] = STATE(1596),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(877),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2739),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1557),
    [anon_sym_yield] = ACTIONS(1559),
    [anon_sym_break] = ACTIONS(1561),
    [anon_sym_next] = ACTIONS(1563),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2741),
    [anon_sym_defined_QMARK] = ACTIONS(2743),
    [anon_sym_not] = ACTIONS(2745),
    [anon_sym_BANG] = ACTIONS(2747),
    [anon_sym_TILDE] = ACTIONS(2747),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1589] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(3747),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1596),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(1596),
    [sym_assignment] = STATE(3747),
    [sym_operator_assignment] = STATE(3747),
    [sym_conditional] = STATE(3747),
    [sym_range] = STATE(3747),
    [sym_binary] = STATE(3747),
    [sym_unary] = STATE(3747),
    [sym_left_assignment_list] = STATE(1595),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1596),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1596),
    [sym_false] = STATE(1596),
    [sym_nil] = STATE(1596),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(877),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2739),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1557),
    [anon_sym_yield] = ACTIONS(1559),
    [anon_sym_break] = ACTIONS(1561),
    [anon_sym_next] = ACTIONS(1563),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2741),
    [anon_sym_defined_QMARK] = ACTIONS(2743),
    [anon_sym_not] = ACTIONS(2745),
    [anon_sym_BANG] = ACTIONS(2747),
    [anon_sym_TILDE] = ACTIONS(2747),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1590] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(3748),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1596),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(1596),
    [sym_assignment] = STATE(3748),
    [sym_operator_assignment] = STATE(3748),
    [sym_conditional] = STATE(3748),
    [sym_range] = STATE(3748),
    [sym_binary] = STATE(3748),
    [sym_unary] = STATE(3748),
    [sym_left_assignment_list] = STATE(1595),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1596),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1596),
    [sym_false] = STATE(1596),
    [sym_nil] = STATE(1596),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(877),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2739),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1557),
    [anon_sym_yield] = ACTIONS(1559),
    [anon_sym_break] = ACTIONS(1561),
    [anon_sym_next] = ACTIONS(1563),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2741),
    [anon_sym_defined_QMARK] = ACTIONS(2743),
    [anon_sym_not] = ACTIONS(2745),
    [anon_sym_BANG] = ACTIONS(2747),
    [anon_sym_TILDE] = ACTIONS(2747),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1591] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(298),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1596),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(1596),
    [sym_assignment] = STATE(298),
    [sym_operator_assignment] = STATE(298),
    [sym_conditional] = STATE(298),
    [sym_range] = STATE(298),
    [sym_binary] = STATE(298),
    [sym_unary] = STATE(298),
    [sym_left_assignment_list] = STATE(1595),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1596),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1596),
    [sym_false] = STATE(1596),
    [sym_nil] = STATE(1596),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(877),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2739),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1557),
    [anon_sym_yield] = ACTIONS(1559),
    [anon_sym_break] = ACTIONS(1561),
    [anon_sym_next] = ACTIONS(1563),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2741),
    [anon_sym_defined_QMARK] = ACTIONS(2743),
    [anon_sym_not] = ACTIONS(2745),
    [anon_sym_BANG] = ACTIONS(2747),
    [anon_sym_TILDE] = ACTIONS(2747),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1592] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(6165),
    [sym__binary_star] = ACTIONS(6167),
    [ts_builtin_sym_end] = ACTIONS(5115),
    [anon_sym___END__] = ACTIONS(5115),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(6169),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(6167),
    [anon_sym_AMP] = ACTIONS(6171),
    [anon_sym_LT] = ACTIONS(6173),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(6175),
    [anon_sym_DOT_DOT] = ACTIONS(6177),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6179),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(6181),
    [anon_sym_AMP_AMP] = ACTIONS(6181),
    [anon_sym_LT_LT] = ACTIONS(6183),
    [anon_sym_GT_GT] = ACTIONS(6183),
    [anon_sym_EQ_EQ] = ACTIONS(6185),
    [anon_sym_BANG_EQ] = ACTIONS(6181),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6181),
    [anon_sym_LT_EQ_GT] = ACTIONS(6181),
    [anon_sym_EQ_TILDE] = ACTIONS(6181),
    [anon_sym_BANG_TILDE] = ACTIONS(6181),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6173),
    [anon_sym_GT_EQ] = ACTIONS(6187),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_PLUS] = ACTIONS(6165),
    [anon_sym_SLASH] = ACTIONS(6167),
    [anon_sym_PERCENT] = ACTIONS(6167),
    [sym_comment] = ACTIONS(87),
  },
  [1593] = {
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [ts_builtin_sym_end] = ACTIONS(6191),
    [anon_sym___END__] = ACTIONS(6191),
    [anon_sym_RBRACE] = ACTIONS(6191),
    [anon_sym_RPAREN] = ACTIONS(6191),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_end] = ACTIONS(6191),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_when] = ACTIONS(6191),
    [anon_sym_elsif] = ACTIONS(6191),
    [anon_sym_else] = ACTIONS(6191),
    [anon_sym_then] = ACTIONS(6191),
    [anon_sym_ensure] = ACTIONS(6191),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [1594] = {
    [aux_sym_exceptions_repeat1] = STATE(3760),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [ts_builtin_sym_end] = ACTIONS(6191),
    [anon_sym___END__] = ACTIONS(6191),
    [anon_sym_COMMA] = ACTIONS(6195),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [1595] = {
    [anon_sym_EQ] = ACTIONS(6197),
    [sym_comment] = ACTIONS(87),
  },
  [1596] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(559),
    [anon_sym___END__] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(6199),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(6201),
    [anon_sym_DASH_EQ] = ACTIONS(6201),
    [anon_sym_STAR_EQ] = ACTIONS(6201),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6201),
    [anon_sym_SLASH_EQ] = ACTIONS(6201),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6201),
    [anon_sym_PIPE_EQ] = ACTIONS(6201),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6201),
    [anon_sym_AMP_EQ] = ACTIONS(6201),
    [anon_sym_PERCENT_EQ] = ACTIONS(6201),
    [anon_sym_GT_GT_EQ] = ACTIONS(6201),
    [anon_sym_LT_LT_EQ] = ACTIONS(6201),
    [anon_sym_CARET_EQ] = ACTIONS(6201),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1597] = {
    [anon_sym_RPAREN] = ACTIONS(6203),
    [anon_sym_COMMA] = ACTIONS(6203),
    [anon_sym_EQ] = ACTIONS(6203),
    [anon_sym_in] = ACTIONS(6203),
    [sym_comment] = ACTIONS(87),
  },
  [1598] = {
    [anon_sym_RPAREN] = ACTIONS(6203),
    [anon_sym_DOT] = ACTIONS(559),
    [anon_sym_COMMA] = ACTIONS(6203),
    [anon_sym_EQ] = ACTIONS(6203),
    [anon_sym_in] = ACTIONS(6203),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [1599] = {
    [sym_method] = STATE(184),
    [sym_singleton_method] = STATE(184),
    [sym_class] = STATE(184),
    [sym_singleton_class] = STATE(184),
    [sym_module] = STATE(184),
    [sym_return] = STATE(184),
    [sym_yield] = STATE(184),
    [sym_break] = STATE(184),
    [sym_next] = STATE(184),
    [sym_while] = STATE(184),
    [sym_until] = STATE(184),
    [sym_for] = STATE(184),
    [sym_case] = STATE(184),
    [sym_if] = STATE(184),
    [sym_unless] = STATE(184),
    [sym_begin] = STATE(184),
    [sym__primary] = STATE(184),
    [sym_parenthesized_statements] = STATE(184),
    [sym_element_reference] = STATE(1598),
    [sym_scope_resolution] = STATE(185),
    [sym_call] = STATE(185),
    [sym_method_call] = STATE(1598),
    [sym_destructured_left_assignment] = STATE(1597),
    [sym_rest_assignment] = STATE(1597),
    [sym__lhs] = STATE(1598),
    [sym__variable] = STATE(185),
    [sym_rational] = STATE(184),
    [sym_true] = STATE(1598),
    [sym_false] = STATE(1598),
    [sym_nil] = STATE(1598),
    [sym_chained_string] = STATE(184),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(184),
    [sym_string_array] = STATE(184),
    [sym_symbol_array] = STATE(184),
    [sym_symbol] = STATE(184),
    [sym_regex] = STATE(184),
    [sym_array] = STATE(184),
    [sym_hash] = STATE(184),
    [sym_lambda] = STATE(184),
    [sym__simple_symbol] = ACTIONS(279),
    [sym__string_start] = ACTIONS(281),
    [sym__symbol_start] = ACTIONS(283),
    [sym__subshell_start] = ACTIONS(285),
    [sym__regex_start] = ACTIONS(287),
    [sym__string_array_start] = ACTIONS(289),
    [sym__symbol_array_start] = ACTIONS(291),
    [sym_heredoc_beginning] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_def] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(475),
    [anon_sym_COLON_COLON] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_EQ] = ACTIONS(6205),
    [anon_sym_class] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(307),
    [anon_sym_return] = ACTIONS(309),
    [anon_sym_yield] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_next] = ACTIONS(315),
    [sym_redo] = ACTIONS(317),
    [sym_retry] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(319),
    [anon_sym_unless] = ACTIONS(321),
    [anon_sym_while] = ACTIONS(323),
    [anon_sym_until] = ACTIONS(325),
    [anon_sym_for] = ACTIONS(327),
    [anon_sym_case] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(331),
    [sym_constant] = ACTIONS(333),
    [sym_identifier] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(317),
    [sym_complex] = ACTIONS(293),
    [sym_super] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(339),
    [anon_sym_TRUE] = ACTIONS(339),
    [anon_sym_false] = ACTIONS(341),
    [anon_sym_FALSE] = ACTIONS(341),
    [sym_self] = ACTIONS(333),
    [anon_sym_nil] = ACTIONS(343),
    [anon_sym_NIL] = ACTIONS(343),
    [sym_character] = ACTIONS(293),
    [anon_sym_LBRACK2] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(347),
  },
  [1600] = {
    [aux_sym__mlhs_repeat1] = STATE(1600),
    [anon_sym_COMMA] = ACTIONS(6207),
    [anon_sym_EQ] = ACTIONS(6203),
    [sym_comment] = ACTIONS(87),
  },
  [1601] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(703),
    [sym__binary_star] = ACTIONS(705),
    [ts_builtin_sym_end] = ACTIONS(6210),
    [anon_sym___END__] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(707),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(705),
    [anon_sym_AMP] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(713),
    [anon_sym_DOT_DOT] = ACTIONS(715),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(717),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(721),
    [anon_sym_AMP_AMP] = ACTIONS(721),
    [anon_sym_LT_LT] = ACTIONS(723),
    [anon_sym_GT_GT] = ACTIONS(723),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(721),
    [anon_sym_LT_EQ_GT] = ACTIONS(721),
    [anon_sym_EQ_TILDE] = ACTIONS(721),
    [anon_sym_BANG_TILDE] = ACTIONS(721),
    [anon_sym_LT_EQ] = ACTIONS(711),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_EQ] = ACTIONS(727),
    [anon_sym_CARET] = ACTIONS(729),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_SLASH] = ACTIONS(705),
    [anon_sym_PERCENT] = ACTIONS(705),
    [sym_comment] = ACTIONS(87),
  },
  [1602] = {
    [sym_string] = STATE(1602),
    [aux_sym_chained_string_repeat1] = STATE(1602),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(6214),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [ts_builtin_sym_end] = ACTIONS(6212),
    [anon_sym___END__] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [1603] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(3764),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1615),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(1615),
    [sym_assignment] = STATE(3764),
    [sym_operator_assignment] = STATE(3764),
    [sym_conditional] = STATE(3764),
    [sym_range] = STATE(3764),
    [sym_binary] = STATE(3764),
    [sym_unary] = STATE(3764),
    [sym_left_assignment_list] = STATE(1614),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1615),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1615),
    [sym_false] = STATE(1615),
    [sym_nil] = STATE(1615),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1616),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6219),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6221),
    [anon_sym_yield] = ACTIONS(6223),
    [anon_sym_break] = ACTIONS(6225),
    [anon_sym_next] = ACTIONS(6227),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6229),
    [anon_sym_defined_QMARK] = ACTIONS(6231),
    [anon_sym_not] = ACTIONS(6233),
    [anon_sym_BANG] = ACTIONS(6235),
    [anon_sym_TILDE] = ACTIONS(6235),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1604] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3777),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3782),
    [sym_scope_resolution] = STATE(3778),
    [sym_call] = STATE(3778),
    [sym_method_call] = STATE(3782),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(3779),
    [sym__argument] = STATE(3780),
    [sym_splat_argument] = STATE(3780),
    [sym_hash_splat_argument] = STATE(3780),
    [sym_block_argument] = STATE(3780),
    [sym_assignment] = STATE(3777),
    [sym_operator_assignment] = STATE(3777),
    [sym_conditional] = STATE(3777),
    [sym_range] = STATE(3777),
    [sym_binary] = STATE(3777),
    [sym_unary] = STATE(3777),
    [sym_left_assignment_list] = STATE(3781),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3782),
    [sym__variable] = STATE(3778),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3782),
    [sym_false] = STATE(3782),
    [sym_nil] = STATE(3782),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3783),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(3780),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(6241),
    [sym__splat_star] = ACTIONS(6243),
    [sym__unary_minus] = ACTIONS(6245),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(6247),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6249),
    [anon_sym_yield] = ACTIONS(6251),
    [anon_sym_break] = ACTIONS(6253),
    [anon_sym_next] = ACTIONS(6255),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(6257),
    [anon_sym_not] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(6261),
    [anon_sym_TILDE] = ACTIONS(6263),
    [sym_constant] = ACTIONS(6265),
    [sym_identifier] = ACTIONS(6265),
    [sym_instance_variable] = ACTIONS(6267),
    [sym_class_variable] = ACTIONS(6267),
    [sym_global_variable] = ACTIONS(6267),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(6269),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6269),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1605] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3777),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3782),
    [sym_scope_resolution] = STATE(3778),
    [sym_call] = STATE(3778),
    [sym_method_call] = STATE(3782),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(3779),
    [sym__argument] = STATE(3780),
    [sym_splat_argument] = STATE(3780),
    [sym_hash_splat_argument] = STATE(3780),
    [sym_block_argument] = STATE(3780),
    [sym_assignment] = STATE(3777),
    [sym_operator_assignment] = STATE(3777),
    [sym_conditional] = STATE(3777),
    [sym_range] = STATE(3777),
    [sym_binary] = STATE(3777),
    [sym_unary] = STATE(3777),
    [sym_left_assignment_list] = STATE(3781),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3782),
    [sym__variable] = STATE(3778),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3782),
    [sym_false] = STATE(3782),
    [sym_nil] = STATE(3782),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3783),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(3780),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(6241),
    [sym__splat_star] = ACTIONS(6243),
    [sym__unary_minus] = ACTIONS(6245),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(6247),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6249),
    [anon_sym_yield] = ACTIONS(6251),
    [anon_sym_break] = ACTIONS(6253),
    [anon_sym_next] = ACTIONS(6255),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(6257),
    [anon_sym_not] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(6261),
    [anon_sym_TILDE] = ACTIONS(6263),
    [sym_constant] = ACTIONS(6265),
    [sym_identifier] = ACTIONS(6265),
    [sym_instance_variable] = ACTIONS(6267),
    [sym_class_variable] = ACTIONS(6267),
    [sym_global_variable] = ACTIONS(6267),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(6269),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6269),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1606] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3777),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3782),
    [sym_scope_resolution] = STATE(3778),
    [sym_call] = STATE(3778),
    [sym_method_call] = STATE(3782),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(3779),
    [sym__argument] = STATE(3780),
    [sym_splat_argument] = STATE(3780),
    [sym_hash_splat_argument] = STATE(3780),
    [sym_block_argument] = STATE(3780),
    [sym_assignment] = STATE(3777),
    [sym_operator_assignment] = STATE(3777),
    [sym_conditional] = STATE(3777),
    [sym_range] = STATE(3777),
    [sym_binary] = STATE(3777),
    [sym_unary] = STATE(3777),
    [sym_left_assignment_list] = STATE(3781),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3782),
    [sym__variable] = STATE(3778),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3782),
    [sym_false] = STATE(3782),
    [sym_nil] = STATE(3782),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3783),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(3780),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(6241),
    [sym__splat_star] = ACTIONS(6243),
    [sym__unary_minus] = ACTIONS(6245),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(6247),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6249),
    [anon_sym_yield] = ACTIONS(6251),
    [anon_sym_break] = ACTIONS(6253),
    [anon_sym_next] = ACTIONS(6255),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(6257),
    [anon_sym_not] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(6261),
    [anon_sym_TILDE] = ACTIONS(6263),
    [sym_constant] = ACTIONS(6265),
    [sym_identifier] = ACTIONS(6265),
    [sym_instance_variable] = ACTIONS(6267),
    [sym_class_variable] = ACTIONS(6267),
    [sym_global_variable] = ACTIONS(6267),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(6269),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6269),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1607] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3777),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3782),
    [sym_scope_resolution] = STATE(3778),
    [sym_call] = STATE(3778),
    [sym_method_call] = STATE(3782),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(3779),
    [sym__argument] = STATE(3780),
    [sym_splat_argument] = STATE(3780),
    [sym_hash_splat_argument] = STATE(3780),
    [sym_block_argument] = STATE(3780),
    [sym_assignment] = STATE(3777),
    [sym_operator_assignment] = STATE(3777),
    [sym_conditional] = STATE(3777),
    [sym_range] = STATE(3777),
    [sym_binary] = STATE(3777),
    [sym_unary] = STATE(3777),
    [sym_left_assignment_list] = STATE(3781),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3782),
    [sym__variable] = STATE(3778),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3782),
    [sym_false] = STATE(3782),
    [sym_nil] = STATE(3782),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3783),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(3780),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(6241),
    [sym__splat_star] = ACTIONS(6243),
    [sym__unary_minus] = ACTIONS(6245),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(6247),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6249),
    [anon_sym_yield] = ACTIONS(6251),
    [anon_sym_break] = ACTIONS(6253),
    [anon_sym_next] = ACTIONS(6255),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(6257),
    [anon_sym_not] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(6261),
    [anon_sym_TILDE] = ACTIONS(6263),
    [sym_constant] = ACTIONS(6265),
    [sym_identifier] = ACTIONS(6265),
    [sym_instance_variable] = ACTIONS(6267),
    [sym_class_variable] = ACTIONS(6267),
    [sym_global_variable] = ACTIONS(6267),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(6269),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6269),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1608] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(3784),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1615),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(1615),
    [sym_assignment] = STATE(3784),
    [sym_operator_assignment] = STATE(3784),
    [sym_conditional] = STATE(3784),
    [sym_range] = STATE(3784),
    [sym_binary] = STATE(3784),
    [sym_unary] = STATE(3784),
    [sym_left_assignment_list] = STATE(1614),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1615),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1615),
    [sym_false] = STATE(1615),
    [sym_nil] = STATE(1615),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1616),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6219),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6221),
    [anon_sym_yield] = ACTIONS(6223),
    [anon_sym_break] = ACTIONS(6225),
    [anon_sym_next] = ACTIONS(6227),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6229),
    [anon_sym_defined_QMARK] = ACTIONS(6231),
    [anon_sym_not] = ACTIONS(6233),
    [anon_sym_BANG] = ACTIONS(6235),
    [anon_sym_TILDE] = ACTIONS(6235),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1609] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(298),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1615),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(1615),
    [sym_assignment] = STATE(298),
    [sym_operator_assignment] = STATE(298),
    [sym_conditional] = STATE(298),
    [sym_range] = STATE(298),
    [sym_binary] = STATE(298),
    [sym_unary] = STATE(298),
    [sym_left_assignment_list] = STATE(1614),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1615),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1615),
    [sym_false] = STATE(1615),
    [sym_nil] = STATE(1615),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1616),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6219),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6221),
    [anon_sym_yield] = ACTIONS(6223),
    [anon_sym_break] = ACTIONS(6225),
    [anon_sym_next] = ACTIONS(6227),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6229),
    [anon_sym_defined_QMARK] = ACTIONS(6231),
    [anon_sym_not] = ACTIONS(6233),
    [anon_sym_BANG] = ACTIONS(6235),
    [anon_sym_TILDE] = ACTIONS(6235),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1610] = {
    [sym_operator] = STATE(3785),
    [sym__method_name] = STATE(3785),
    [sym_setter] = STATE(3785),
    [sym_symbol] = STATE(3785),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(6271),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(6271),
    [sym_class_variable] = ACTIONS(6271),
    [sym_global_variable] = ACTIONS(6271),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [1611] = {
    [sym_heredoc_body] = STATE(370),
    [sym__terminator] = STATE(370),
    [sym__line_break] = ACTIONS(687),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(6273),
    [anon_sym_unless] = ACTIONS(6275),
    [anon_sym_while] = ACTIONS(6277),
    [anon_sym_until] = ACTIONS(6279),
    [anon_sym_rescue] = ACTIONS(6281),
    [sym_comment] = ACTIONS(87),
  },
  [1612] = {
    [sym__line_break] = ACTIONS(701),
    [sym__heredoc_body_start] = ACTIONS(701),
    [sym__binary_minus] = ACTIONS(6283),
    [sym__binary_star] = ACTIONS(6285),
    [anon_sym_PIPE] = ACTIONS(6287),
    [anon_sym_SEMI] = ACTIONS(701),
    [anon_sym_STAR_STAR] = ACTIONS(6285),
    [anon_sym_AMP] = ACTIONS(6289),
    [anon_sym_LT] = ACTIONS(6291),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_unless] = ACTIONS(701),
    [anon_sym_while] = ACTIONS(701),
    [anon_sym_until] = ACTIONS(701),
    [anon_sym_rescue] = ACTIONS(701),
    [anon_sym_QMARK] = ACTIONS(6293),
    [anon_sym_DOT_DOT] = ACTIONS(6295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6297),
    [anon_sym_and] = ACTIONS(6299),
    [anon_sym_or] = ACTIONS(6299),
    [anon_sym_PIPE_PIPE] = ACTIONS(6301),
    [anon_sym_AMP_AMP] = ACTIONS(6301),
    [anon_sym_LT_LT] = ACTIONS(6303),
    [anon_sym_GT_GT] = ACTIONS(6303),
    [anon_sym_EQ_EQ] = ACTIONS(6305),
    [anon_sym_BANG_EQ] = ACTIONS(6301),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6301),
    [anon_sym_LT_EQ_GT] = ACTIONS(6301),
    [anon_sym_EQ_TILDE] = ACTIONS(6301),
    [anon_sym_BANG_TILDE] = ACTIONS(6301),
    [anon_sym_LT_EQ] = ACTIONS(6291),
    [anon_sym_GT] = ACTIONS(6291),
    [anon_sym_GT_EQ] = ACTIONS(6307),
    [anon_sym_CARET] = ACTIONS(6309),
    [anon_sym_PLUS] = ACTIONS(6283),
    [anon_sym_SLASH] = ACTIONS(6285),
    [anon_sym_PERCENT] = ACTIONS(6285),
    [sym_comment] = ACTIONS(87),
  },
  [1613] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3813),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3818),
    [sym_scope_resolution] = STATE(3814),
    [sym_call] = STATE(3814),
    [sym_method_call] = STATE(3818),
    [sym_argument_list] = STATE(423),
    [sym__argument_list_with_parens] = STATE(3815),
    [sym__argument] = STATE(3816),
    [sym_splat_argument] = STATE(3816),
    [sym_hash_splat_argument] = STATE(3816),
    [sym_block_argument] = STATE(3816),
    [sym_do_block] = STATE(426),
    [sym_block] = STATE(426),
    [sym_assignment] = STATE(3813),
    [sym_operator_assignment] = STATE(3813),
    [sym_conditional] = STATE(3813),
    [sym_range] = STATE(3813),
    [sym_binary] = STATE(3813),
    [sym_unary] = STATE(3813),
    [sym_left_assignment_list] = STATE(3817),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3818),
    [sym__variable] = STATE(3814),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3818),
    [sym_false] = STATE(3818),
    [sym_nil] = STATE(3818),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3819),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(3816),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(743),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(6311),
    [sym__splat_star] = ACTIONS(6313),
    [sym__unary_minus] = ACTIONS(6315),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(6317),
    [anon_sym_LBRACE] = ACTIONS(771),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(6319),
    [anon_sym_yield] = ACTIONS(6321),
    [anon_sym_break] = ACTIONS(6323),
    [anon_sym_next] = ACTIONS(6325),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(769),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(769),
    [anon_sym_until] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(769),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(6327),
    [anon_sym_not] = ACTIONS(6329),
    [anon_sym_BANG] = ACTIONS(6331),
    [anon_sym_TILDE] = ACTIONS(6333),
    [sym_constant] = ACTIONS(6335),
    [sym_identifier] = ACTIONS(6335),
    [sym_instance_variable] = ACTIONS(6337),
    [sym_class_variable] = ACTIONS(6337),
    [sym_global_variable] = ACTIONS(6337),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(6339),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6339),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [1614] = {
    [anon_sym_EQ] = ACTIONS(6341),
    [sym_comment] = ACTIONS(87),
  },
  [1615] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(6343),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(6345),
    [anon_sym_DASH_EQ] = ACTIONS(6345),
    [anon_sym_STAR_EQ] = ACTIONS(6345),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6345),
    [anon_sym_SLASH_EQ] = ACTIONS(6345),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6345),
    [anon_sym_PIPE_EQ] = ACTIONS(6345),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6345),
    [anon_sym_AMP_EQ] = ACTIONS(6345),
    [anon_sym_PERCENT_EQ] = ACTIONS(6345),
    [anon_sym_GT_GT_EQ] = ACTIONS(6345),
    [anon_sym_LT_LT_EQ] = ACTIONS(6345),
    [anon_sym_CARET_EQ] = ACTIONS(6345),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1616] = {
    [sym_string] = STATE(3822),
    [aux_sym_chained_string_repeat1] = STATE(3822),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [1617] = {
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(2954),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [1618] = {
    [sym__statements] = STATE(3824),
    [sym_begin_block] = STATE(489),
    [sym_end_block] = STATE(489),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(495),
    [aux_sym__statements_repeat1] = STATE(495),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(6347),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1619] = {
    [sym__statements] = STATE(3826),
    [sym_begin_block] = STATE(489),
    [sym_end_block] = STATE(489),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(495),
    [aux_sym__statements_repeat1] = STATE(495),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(6349),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1620] = {
    [sym__simple_symbol] = ACTIONS(1411),
    [sym__string_start] = ACTIONS(1411),
    [sym__symbol_start] = ACTIONS(1411),
    [sym__subshell_start] = ACTIONS(1411),
    [sym__regex_start] = ACTIONS(1411),
    [sym__string_array_start] = ACTIONS(1411),
    [sym__symbol_array_start] = ACTIONS(1411),
    [sym_heredoc_beginning] = ACTIONS(1411),
    [sym__block_ampersand] = ACTIONS(1411),
    [sym__splat_star] = ACTIONS(1411),
    [sym__unary_minus] = ACTIONS(1411),
    [sym__binary_minus] = ACTIONS(1411),
    [sym__binary_star] = ACTIONS(1411),
    [sym__identifier_hash_key] = ACTIONS(1411),
    [anon_sym_LBRACE] = ACTIONS(1411),
    [anon_sym_RBRACE] = ACTIONS(1411),
    [anon_sym_def] = ACTIONS(1413),
    [anon_sym_LPAREN] = ACTIONS(1413),
    [anon_sym_RPAREN] = ACTIONS(1411),
    [anon_sym_DOT] = ACTIONS(1413),
    [anon_sym_COLON_COLON] = ACTIONS(1413),
    [anon_sym_COMMA] = ACTIONS(1411),
    [anon_sym_PIPE] = ACTIONS(1413),
    [anon_sym_SEMI] = ACTIONS(1411),
    [anon_sym_STAR] = ACTIONS(1413),
    [anon_sym_STAR_STAR] = ACTIONS(1413),
    [anon_sym_AMP] = ACTIONS(1413),
    [anon_sym_EQ] = ACTIONS(1413),
    [anon_sym_class] = ACTIONS(1413),
    [anon_sym_LT] = ACTIONS(1413),
    [anon_sym_module] = ACTIONS(1413),
    [anon_sym_return] = ACTIONS(1413),
    [anon_sym_yield] = ACTIONS(1413),
    [anon_sym_break] = ACTIONS(1413),
    [anon_sym_next] = ACTIONS(1413),
    [sym_redo] = ACTIONS(1413),
    [sym_retry] = ACTIONS(1413),
    [anon_sym_if] = ACTIONS(1413),
    [anon_sym_unless] = ACTIONS(1413),
    [anon_sym_while] = ACTIONS(1413),
    [anon_sym_until] = ACTIONS(1413),
    [anon_sym_rescue] = ACTIONS(1413),
    [anon_sym_for] = ACTIONS(1413),
    [anon_sym_do] = ACTIONS(1413),
    [anon_sym_case] = ACTIONS(1413),
    [anon_sym_begin] = ACTIONS(1413),
    [anon_sym_LBRACK] = ACTIONS(1411),
    [anon_sym_COLON_COLON2] = ACTIONS(1411),
    [anon_sym_AMP_DOT] = ACTIONS(1411),
    [anon_sym_LPAREN2] = ACTIONS(1411),
    [anon_sym_PLUS_EQ] = ACTIONS(1411),
    [anon_sym_DASH_EQ] = ACTIONS(1411),
    [anon_sym_STAR_EQ] = ACTIONS(1411),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1411),
    [anon_sym_SLASH_EQ] = ACTIONS(1411),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1411),
    [anon_sym_PIPE_EQ] = ACTIONS(1411),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1411),
    [anon_sym_AMP_EQ] = ACTIONS(1411),
    [anon_sym_PERCENT_EQ] = ACTIONS(1411),
    [anon_sym_GT_GT_EQ] = ACTIONS(1411),
    [anon_sym_LT_LT_EQ] = ACTIONS(1411),
    [anon_sym_CARET_EQ] = ACTIONS(1411),
    [anon_sym_QMARK] = ACTIONS(1413),
    [anon_sym_COLON2] = ACTIONS(1413),
    [anon_sym_DOT_DOT] = ACTIONS(1413),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1411),
    [anon_sym_and] = ACTIONS(1413),
    [anon_sym_or] = ACTIONS(1413),
    [anon_sym_PIPE_PIPE] = ACTIONS(1413),
    [anon_sym_AMP_AMP] = ACTIONS(1413),
    [anon_sym_LT_LT] = ACTIONS(1413),
    [anon_sym_GT_GT] = ACTIONS(1413),
    [anon_sym_EQ_EQ] = ACTIONS(1413),
    [anon_sym_BANG_EQ] = ACTIONS(1411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1411),
    [anon_sym_LT_EQ_GT] = ACTIONS(1411),
    [anon_sym_EQ_TILDE] = ACTIONS(1411),
    [anon_sym_BANG_TILDE] = ACTIONS(1411),
    [anon_sym_LT_EQ] = ACTIONS(1413),
    [anon_sym_GT] = ACTIONS(1413),
    [anon_sym_GT_EQ] = ACTIONS(1411),
    [anon_sym_CARET] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_SLASH] = ACTIONS(1413),
    [anon_sym_PERCENT] = ACTIONS(1413),
    [anon_sym_defined_QMARK] = ACTIONS(1411),
    [anon_sym_not] = ACTIONS(1413),
    [anon_sym_BANG] = ACTIONS(1413),
    [anon_sym_TILDE] = ACTIONS(1411),
    [sym_constant] = ACTIONS(1413),
    [sym_identifier] = ACTIONS(1413),
    [sym_instance_variable] = ACTIONS(1411),
    [sym_class_variable] = ACTIONS(1411),
    [sym_global_variable] = ACTIONS(1411),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1413),
    [sym_float] = ACTIONS(1413),
    [sym_complex] = ACTIONS(1411),
    [sym_super] = ACTIONS(1413),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_TRUE] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_FALSE] = ACTIONS(1413),
    [sym_self] = ACTIONS(1413),
    [anon_sym_nil] = ACTIONS(1413),
    [anon_sym_NIL] = ACTIONS(1413),
    [sym_character] = ACTIONS(1411),
    [anon_sym_LBRACK2] = ACTIONS(1413),
    [anon_sym_DASH_GT] = ACTIONS(1411),
  },
  [1621] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(3834),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(3837),
    [sym_scope_resolution] = STATE(3835),
    [sym_call] = STATE(3835),
    [sym_method_call] = STATE(3837),
    [sym_assignment] = STATE(3834),
    [sym_operator_assignment] = STATE(3834),
    [sym_conditional] = STATE(3834),
    [sym_range] = STATE(3834),
    [sym_binary] = STATE(3834),
    [sym_unary] = STATE(3834),
    [sym_left_assignment_list] = STATE(3836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3837),
    [sym__variable] = STATE(3835),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(3837),
    [sym_false] = STATE(3837),
    [sym_nil] = STATE(3837),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(3838),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6351),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6353),
    [anon_sym_yield] = ACTIONS(6355),
    [anon_sym_break] = ACTIONS(6357),
    [anon_sym_next] = ACTIONS(6359),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6361),
    [anon_sym_defined_QMARK] = ACTIONS(6363),
    [anon_sym_not] = ACTIONS(6365),
    [anon_sym_BANG] = ACTIONS(6367),
    [anon_sym_TILDE] = ACTIONS(6367),
    [sym_constant] = ACTIONS(6369),
    [sym_identifier] = ACTIONS(6369),
    [sym_instance_variable] = ACTIONS(6371),
    [sym_class_variable] = ACTIONS(6371),
    [sym_global_variable] = ACTIONS(6371),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6369),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6369),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1622] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(3839),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(3837),
    [sym_scope_resolution] = STATE(3835),
    [sym_call] = STATE(3835),
    [sym_method_call] = STATE(3837),
    [sym_assignment] = STATE(3839),
    [sym_operator_assignment] = STATE(3839),
    [sym_conditional] = STATE(3839),
    [sym_range] = STATE(3839),
    [sym_binary] = STATE(3839),
    [sym_unary] = STATE(3839),
    [sym_left_assignment_list] = STATE(3836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3837),
    [sym__variable] = STATE(3835),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(3837),
    [sym_false] = STATE(3837),
    [sym_nil] = STATE(3837),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(3838),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6351),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6353),
    [anon_sym_yield] = ACTIONS(6355),
    [anon_sym_break] = ACTIONS(6357),
    [anon_sym_next] = ACTIONS(6359),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6361),
    [anon_sym_defined_QMARK] = ACTIONS(6363),
    [anon_sym_not] = ACTIONS(6365),
    [anon_sym_BANG] = ACTIONS(6367),
    [anon_sym_TILDE] = ACTIONS(6367),
    [sym_constant] = ACTIONS(6369),
    [sym_identifier] = ACTIONS(6369),
    [sym_instance_variable] = ACTIONS(6371),
    [sym_class_variable] = ACTIONS(6371),
    [sym_global_variable] = ACTIONS(6371),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6369),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6369),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1623] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(3840),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1638),
    [sym_scope_resolution] = STATE(1634),
    [sym_call] = STATE(1634),
    [sym_method_call] = STATE(1638),
    [sym_assignment] = STATE(3840),
    [sym_operator_assignment] = STATE(3840),
    [sym_conditional] = STATE(3840),
    [sym_range] = STATE(3840),
    [sym_binary] = STATE(3840),
    [sym_unary] = STATE(3840),
    [sym_left_assignment_list] = STATE(1637),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1638),
    [sym__variable] = STATE(1634),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1638),
    [sym_false] = STATE(1638),
    [sym_nil] = STATE(1638),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(3841),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(2910),
    [anon_sym_break] = ACTIONS(2912),
    [anon_sym_next] = ACTIONS(2914),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6373),
    [anon_sym_defined_QMARK] = ACTIONS(2916),
    [anon_sym_not] = ACTIONS(2918),
    [anon_sym_BANG] = ACTIONS(2922),
    [anon_sym_TILDE] = ACTIONS(2922),
    [sym_constant] = ACTIONS(2928),
    [sym_identifier] = ACTIONS(2928),
    [sym_instance_variable] = ACTIONS(2926),
    [sym_class_variable] = ACTIONS(2926),
    [sym_global_variable] = ACTIONS(2926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2928),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2928),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1624] = {
    [anon_sym_COLON] = ACTIONS(6375),
    [sym_comment] = ACTIONS(87),
  },
  [1625] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(3843),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(3837),
    [sym_scope_resolution] = STATE(3835),
    [sym_call] = STATE(3835),
    [sym_method_call] = STATE(3837),
    [sym_assignment] = STATE(3843),
    [sym_operator_assignment] = STATE(3843),
    [sym_conditional] = STATE(3843),
    [sym_range] = STATE(3843),
    [sym_binary] = STATE(3843),
    [sym_unary] = STATE(3843),
    [sym_left_assignment_list] = STATE(3836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3837),
    [sym__variable] = STATE(3835),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(3837),
    [sym_false] = STATE(3837),
    [sym_nil] = STATE(3837),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(3838),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6351),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6353),
    [anon_sym_yield] = ACTIONS(6355),
    [anon_sym_break] = ACTIONS(6357),
    [anon_sym_next] = ACTIONS(6359),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6361),
    [anon_sym_defined_QMARK] = ACTIONS(6363),
    [anon_sym_not] = ACTIONS(6365),
    [anon_sym_BANG] = ACTIONS(6367),
    [anon_sym_TILDE] = ACTIONS(6367),
    [sym_constant] = ACTIONS(6369),
    [sym_identifier] = ACTIONS(6369),
    [sym_instance_variable] = ACTIONS(6371),
    [sym_class_variable] = ACTIONS(6371),
    [sym_global_variable] = ACTIONS(6371),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6369),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6369),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1626] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(3849),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1638),
    [sym_scope_resolution] = STATE(1634),
    [sym_call] = STATE(1634),
    [sym_method_call] = STATE(1638),
    [sym_argument_list] = STATE(1318),
    [sym__argument_list_with_parens] = STATE(3850),
    [sym__argument] = STATE(3851),
    [sym_splat_argument] = STATE(3851),
    [sym_hash_splat_argument] = STATE(3851),
    [sym_block_argument] = STATE(3851),
    [sym_assignment] = STATE(3849),
    [sym_operator_assignment] = STATE(3849),
    [sym_conditional] = STATE(3849),
    [sym_range] = STATE(3849),
    [sym_binary] = STATE(3849),
    [sym_unary] = STATE(3849),
    [sym_left_assignment_list] = STATE(1637),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1638),
    [sym__variable] = STATE(1634),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1638),
    [sym_false] = STATE(1638),
    [sym_nil] = STATE(1638),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(3852),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(3851),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(6377),
    [sym__splat_star] = ACTIONS(6379),
    [sym__unary_minus] = ACTIONS(2904),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(6381),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(2910),
    [anon_sym_break] = ACTIONS(2912),
    [anon_sym_next] = ACTIONS(2914),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(2916),
    [anon_sym_not] = ACTIONS(2918),
    [anon_sym_BANG] = ACTIONS(2920),
    [anon_sym_TILDE] = ACTIONS(2922),
    [sym_constant] = ACTIONS(6383),
    [sym_identifier] = ACTIONS(6383),
    [sym_instance_variable] = ACTIONS(2926),
    [sym_class_variable] = ACTIONS(2926),
    [sym_global_variable] = ACTIONS(2926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2928),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2928),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1627] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(3849),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1638),
    [sym_scope_resolution] = STATE(1634),
    [sym_call] = STATE(1634),
    [sym_method_call] = STATE(1638),
    [sym_argument_list] = STATE(1324),
    [sym__argument_list_with_parens] = STATE(3850),
    [sym__argument] = STATE(3851),
    [sym_splat_argument] = STATE(3851),
    [sym_hash_splat_argument] = STATE(3851),
    [sym_block_argument] = STATE(3851),
    [sym_assignment] = STATE(3849),
    [sym_operator_assignment] = STATE(3849),
    [sym_conditional] = STATE(3849),
    [sym_range] = STATE(3849),
    [sym_binary] = STATE(3849),
    [sym_unary] = STATE(3849),
    [sym_left_assignment_list] = STATE(1637),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1638),
    [sym__variable] = STATE(1634),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1638),
    [sym_false] = STATE(1638),
    [sym_nil] = STATE(1638),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(3852),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(3851),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(6377),
    [sym__splat_star] = ACTIONS(6379),
    [sym__unary_minus] = ACTIONS(2904),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(6381),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(2910),
    [anon_sym_break] = ACTIONS(2912),
    [anon_sym_next] = ACTIONS(2914),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(2916),
    [anon_sym_not] = ACTIONS(2918),
    [anon_sym_BANG] = ACTIONS(2920),
    [anon_sym_TILDE] = ACTIONS(2922),
    [sym_constant] = ACTIONS(6383),
    [sym_identifier] = ACTIONS(6383),
    [sym_instance_variable] = ACTIONS(2926),
    [sym_class_variable] = ACTIONS(2926),
    [sym_global_variable] = ACTIONS(2926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2928),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2928),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1628] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(3849),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1638),
    [sym_scope_resolution] = STATE(1634),
    [sym_call] = STATE(1634),
    [sym_method_call] = STATE(1638),
    [sym_argument_list] = STATE(1325),
    [sym__argument_list_with_parens] = STATE(3850),
    [sym__argument] = STATE(3851),
    [sym_splat_argument] = STATE(3851),
    [sym_hash_splat_argument] = STATE(3851),
    [sym_block_argument] = STATE(3851),
    [sym_assignment] = STATE(3849),
    [sym_operator_assignment] = STATE(3849),
    [sym_conditional] = STATE(3849),
    [sym_range] = STATE(3849),
    [sym_binary] = STATE(3849),
    [sym_unary] = STATE(3849),
    [sym_left_assignment_list] = STATE(1637),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1638),
    [sym__variable] = STATE(1634),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1638),
    [sym_false] = STATE(1638),
    [sym_nil] = STATE(1638),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(3852),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(3851),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(6377),
    [sym__splat_star] = ACTIONS(6379),
    [sym__unary_minus] = ACTIONS(2904),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(6381),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(2910),
    [anon_sym_break] = ACTIONS(2912),
    [anon_sym_next] = ACTIONS(2914),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(2916),
    [anon_sym_not] = ACTIONS(2918),
    [anon_sym_BANG] = ACTIONS(2920),
    [anon_sym_TILDE] = ACTIONS(2922),
    [sym_constant] = ACTIONS(6383),
    [sym_identifier] = ACTIONS(6383),
    [sym_instance_variable] = ACTIONS(2926),
    [sym_class_variable] = ACTIONS(2926),
    [sym_global_variable] = ACTIONS(2926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2928),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2928),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1629] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(3849),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1638),
    [sym_scope_resolution] = STATE(1634),
    [sym_call] = STATE(1634),
    [sym_method_call] = STATE(1638),
    [sym_argument_list] = STATE(1326),
    [sym__argument_list_with_parens] = STATE(3850),
    [sym__argument] = STATE(3851),
    [sym_splat_argument] = STATE(3851),
    [sym_hash_splat_argument] = STATE(3851),
    [sym_block_argument] = STATE(3851),
    [sym_assignment] = STATE(3849),
    [sym_operator_assignment] = STATE(3849),
    [sym_conditional] = STATE(3849),
    [sym_range] = STATE(3849),
    [sym_binary] = STATE(3849),
    [sym_unary] = STATE(3849),
    [sym_left_assignment_list] = STATE(1637),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1638),
    [sym__variable] = STATE(1634),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1638),
    [sym_false] = STATE(1638),
    [sym_nil] = STATE(1638),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(3852),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(3851),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(6377),
    [sym__splat_star] = ACTIONS(6379),
    [sym__unary_minus] = ACTIONS(2904),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(6381),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(2910),
    [anon_sym_break] = ACTIONS(2912),
    [anon_sym_next] = ACTIONS(2914),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(2916),
    [anon_sym_not] = ACTIONS(2918),
    [anon_sym_BANG] = ACTIONS(2920),
    [anon_sym_TILDE] = ACTIONS(2922),
    [sym_constant] = ACTIONS(6383),
    [sym_identifier] = ACTIONS(6383),
    [sym_instance_variable] = ACTIONS(2926),
    [sym_class_variable] = ACTIONS(2926),
    [sym_global_variable] = ACTIONS(2926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2928),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2928),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1630] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(3853),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1638),
    [sym_scope_resolution] = STATE(1634),
    [sym_call] = STATE(1634),
    [sym_method_call] = STATE(1638),
    [sym_assignment] = STATE(3853),
    [sym_operator_assignment] = STATE(3853),
    [sym_conditional] = STATE(3853),
    [sym_range] = STATE(3853),
    [sym_binary] = STATE(3853),
    [sym_unary] = STATE(3853),
    [sym_left_assignment_list] = STATE(1637),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1638),
    [sym__variable] = STATE(1634),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1638),
    [sym_false] = STATE(1638),
    [sym_nil] = STATE(1638),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(3841),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(2910),
    [anon_sym_break] = ACTIONS(2912),
    [anon_sym_next] = ACTIONS(2914),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6373),
    [anon_sym_defined_QMARK] = ACTIONS(2916),
    [anon_sym_not] = ACTIONS(2918),
    [anon_sym_BANG] = ACTIONS(2922),
    [anon_sym_TILDE] = ACTIONS(2922),
    [sym_constant] = ACTIONS(2928),
    [sym_identifier] = ACTIONS(2928),
    [sym_instance_variable] = ACTIONS(2926),
    [sym_class_variable] = ACTIONS(2926),
    [sym_global_variable] = ACTIONS(2926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2928),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2928),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1631] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(1872),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1638),
    [sym_scope_resolution] = STATE(1634),
    [sym_call] = STATE(1634),
    [sym_method_call] = STATE(1638),
    [sym_assignment] = STATE(1872),
    [sym_operator_assignment] = STATE(1872),
    [sym_conditional] = STATE(1872),
    [sym_range] = STATE(1872),
    [sym_binary] = STATE(1872),
    [sym_unary] = STATE(1872),
    [sym_left_assignment_list] = STATE(1637),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1638),
    [sym__variable] = STATE(1634),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1638),
    [sym_false] = STATE(1638),
    [sym_nil] = STATE(1638),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(3841),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(2910),
    [anon_sym_break] = ACTIONS(2912),
    [anon_sym_next] = ACTIONS(2914),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6373),
    [anon_sym_defined_QMARK] = ACTIONS(2916),
    [anon_sym_not] = ACTIONS(2918),
    [anon_sym_BANG] = ACTIONS(2922),
    [anon_sym_TILDE] = ACTIONS(2922),
    [sym_constant] = ACTIONS(2928),
    [sym_identifier] = ACTIONS(2928),
    [sym_instance_variable] = ACTIONS(2926),
    [sym_class_variable] = ACTIONS(2926),
    [sym_global_variable] = ACTIONS(2926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2928),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2928),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1632] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(6385),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [1633] = {
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(6387),
    [sym__binary_star] = ACTIONS(6389),
    [anon_sym_RBRACE] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(6391),
    [anon_sym_STAR_STAR] = ACTIONS(6389),
    [anon_sym_AMP] = ACTIONS(6393),
    [anon_sym_LT] = ACTIONS(6395),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_unless] = ACTIONS(1625),
    [anon_sym_while] = ACTIONS(1625),
    [anon_sym_until] = ACTIONS(1625),
    [anon_sym_rescue] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(6375),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(6397),
    [anon_sym_DOT_DOT] = ACTIONS(6399),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6401),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(6403),
    [anon_sym_AMP_AMP] = ACTIONS(6403),
    [anon_sym_LT_LT] = ACTIONS(6405),
    [anon_sym_GT_GT] = ACTIONS(6405),
    [anon_sym_EQ_EQ] = ACTIONS(6407),
    [anon_sym_BANG_EQ] = ACTIONS(6403),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6403),
    [anon_sym_LT_EQ_GT] = ACTIONS(6403),
    [anon_sym_EQ_TILDE] = ACTIONS(6403),
    [anon_sym_BANG_TILDE] = ACTIONS(6403),
    [anon_sym_LT_EQ] = ACTIONS(6395),
    [anon_sym_GT] = ACTIONS(6395),
    [anon_sym_GT_EQ] = ACTIONS(6409),
    [anon_sym_CARET] = ACTIONS(6411),
    [anon_sym_PLUS] = ACTIONS(6387),
    [anon_sym_SLASH] = ACTIONS(6389),
    [anon_sym_PERCENT] = ACTIONS(6389),
    [sym_comment] = ACTIONS(87),
  },
  [1634] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3870),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1686),
    [sym_scope_resolution] = STATE(1680),
    [sym_call] = STATE(1680),
    [sym_method_call] = STATE(1686),
    [sym_argument_list] = STATE(1379),
    [sym__argument_list_with_parens] = STATE(3871),
    [sym__argument] = STATE(3872),
    [sym_splat_argument] = STATE(3872),
    [sym_hash_splat_argument] = STATE(3872),
    [sym_block_argument] = STATE(3872),
    [sym_do_block] = STATE(1382),
    [sym_block] = STATE(1382),
    [sym_assignment] = STATE(3870),
    [sym_operator_assignment] = STATE(3870),
    [sym_conditional] = STATE(3870),
    [sym_range] = STATE(3870),
    [sym_binary] = STATE(3870),
    [sym_unary] = STATE(3870),
    [sym_left_assignment_list] = STATE(1685),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1686),
    [sym__variable] = STATE(1680),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1686),
    [sym_false] = STATE(1686),
    [sym_nil] = STATE(1686),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3873),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(3872),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(6413),
    [sym__splat_star] = ACTIONS(6415),
    [sym__unary_minus] = ACTIONS(2992),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(6417),
    [anon_sym_LBRACE] = ACTIONS(2403),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2998),
    [anon_sym_yield] = ACTIONS(3000),
    [anon_sym_break] = ACTIONS(3002),
    [anon_sym_next] = ACTIONS(3004),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(769),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(769),
    [anon_sym_until] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(769),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(2413),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(3010),
    [anon_sym_not] = ACTIONS(3012),
    [anon_sym_BANG] = ACTIONS(3014),
    [anon_sym_TILDE] = ACTIONS(3016),
    [sym_constant] = ACTIONS(6419),
    [sym_identifier] = ACTIONS(6419),
    [sym_instance_variable] = ACTIONS(3020),
    [sym_class_variable] = ACTIONS(3020),
    [sym_global_variable] = ACTIONS(3020),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3022),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3022),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1635] = {
    [sym_heredoc_body] = STATE(3874),
    [aux_sym_call_repeat1] = STATE(3874),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_RBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [1636] = {
    [sym_heredoc_body] = STATE(3874),
    [aux_sym_call_repeat1] = STATE(3874),
    [aux_sym_argument_list_repeat1] = STATE(3876),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_RBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(6421),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [1637] = {
    [anon_sym_EQ] = ACTIONS(6423),
    [sym_comment] = ACTIONS(87),
  },
  [1638] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(6425),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(6427),
    [anon_sym_DASH_EQ] = ACTIONS(6427),
    [anon_sym_STAR_EQ] = ACTIONS(6427),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6427),
    [anon_sym_SLASH_EQ] = ACTIONS(6427),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6427),
    [anon_sym_PIPE_EQ] = ACTIONS(6427),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6427),
    [anon_sym_AMP_EQ] = ACTIONS(6427),
    [anon_sym_PERCENT_EQ] = ACTIONS(6427),
    [anon_sym_GT_GT_EQ] = ACTIONS(6427),
    [anon_sym_LT_LT_EQ] = ACTIONS(6427),
    [anon_sym_CARET_EQ] = ACTIONS(6427),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1639] = {
    [sym_string] = STATE(3879),
    [aux_sym_chained_string_repeat1] = STATE(3879),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(6429),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [1640] = {
    [sym__binary_minus] = ACTIONS(2952),
    [sym__binary_star] = ACTIONS(2954),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(2956),
    [anon_sym_STAR_STAR] = ACTIONS(2954),
    [anon_sym_AMP] = ACTIONS(2958),
    [anon_sym_LT] = ACTIONS(2960),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(2962),
    [anon_sym_DOT_DOT] = ACTIONS(2964),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2966),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(2970),
    [anon_sym_AMP_AMP] = ACTIONS(2970),
    [anon_sym_LT_LT] = ACTIONS(2972),
    [anon_sym_GT_GT] = ACTIONS(2972),
    [anon_sym_EQ_EQ] = ACTIONS(2974),
    [anon_sym_BANG_EQ] = ACTIONS(2970),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2970),
    [anon_sym_LT_EQ_GT] = ACTIONS(2970),
    [anon_sym_EQ_TILDE] = ACTIONS(2970),
    [anon_sym_BANG_TILDE] = ACTIONS(2970),
    [anon_sym_LT_EQ] = ACTIONS(2960),
    [anon_sym_GT] = ACTIONS(2960),
    [anon_sym_GT_EQ] = ACTIONS(2976),
    [anon_sym_CARET] = ACTIONS(2978),
    [anon_sym_PLUS] = ACTIONS(2952),
    [anon_sym_SLASH] = ACTIONS(2954),
    [anon_sym_PERCENT] = ACTIONS(2954),
    [sym_comment] = ACTIONS(87),
  },
  [1641] = {
    [anon_sym_RBRACE] = ACTIONS(1263),
    [anon_sym_COMMA] = ACTIONS(1263),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_unless] = ACTIONS(1263),
    [anon_sym_while] = ACTIONS(1263),
    [anon_sym_until] = ACTIONS(1263),
    [anon_sym_rescue] = ACTIONS(1263),
    [sym_comment] = ACTIONS(87),
  },
  [1642] = {
    [anon_sym_RBRACE] = ACTIONS(1267),
    [anon_sym_COMMA] = ACTIONS(1267),
    [anon_sym_EQ] = ACTIONS(6431),
    [anon_sym_if] = ACTIONS(1267),
    [anon_sym_unless] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1267),
    [anon_sym_until] = ACTIONS(1267),
    [anon_sym_rescue] = ACTIONS(1267),
    [sym_comment] = ACTIONS(87),
  },
  [1643] = {
    [aux_sym_undef_repeat1] = STATE(3882),
    [anon_sym_RBRACE] = ACTIONS(2251),
    [anon_sym_COMMA] = ACTIONS(6433),
    [anon_sym_if] = ACTIONS(2251),
    [anon_sym_unless] = ACTIONS(2251),
    [anon_sym_while] = ACTIONS(2251),
    [anon_sym_until] = ACTIONS(2251),
    [anon_sym_rescue] = ACTIONS(2251),
    [sym_comment] = ACTIONS(87),
  },
  [1644] = {
    [sym_operator] = STATE(3883),
    [sym__method_name] = STATE(3883),
    [sym_setter] = STATE(3883),
    [sym_symbol] = STATE(3883),
    [sym__simple_symbol] = ACTIONS(279),
    [sym__symbol_start] = ACTIONS(283),
    [anon_sym_PIPE] = ACTIONS(2930),
    [anon_sym_STAR] = ACTIONS(2932),
    [anon_sym_STAR_STAR] = ACTIONS(2930),
    [anon_sym_AMP] = ACTIONS(2930),
    [anon_sym_LT] = ACTIONS(2932),
    [anon_sym_DOT_DOT] = ACTIONS(2930),
    [anon_sym_LT_LT] = ACTIONS(2930),
    [anon_sym_GT_GT] = ACTIONS(2930),
    [anon_sym_EQ_EQ] = ACTIONS(2932),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2930),
    [anon_sym_LT_EQ_GT] = ACTIONS(2930),
    [anon_sym_EQ_TILDE] = ACTIONS(2930),
    [anon_sym_BANG_TILDE] = ACTIONS(2930),
    [anon_sym_LT_EQ] = ACTIONS(2932),
    [anon_sym_GT] = ACTIONS(2932),
    [anon_sym_GT_EQ] = ACTIONS(2930),
    [anon_sym_CARET] = ACTIONS(2930),
    [anon_sym_PLUS] = ACTIONS(2932),
    [anon_sym_SLASH] = ACTIONS(2930),
    [anon_sym_PERCENT] = ACTIONS(2930),
    [anon_sym_BANG] = ACTIONS(2932),
    [anon_sym_TILDE] = ACTIONS(2930),
    [sym_constant] = ACTIONS(6435),
    [sym_identifier] = ACTIONS(2936),
    [sym_instance_variable] = ACTIONS(6435),
    [sym_class_variable] = ACTIONS(6435),
    [sym_global_variable] = ACTIONS(6435),
    [anon_sym_DASH] = ACTIONS(2932),
    [anon_sym_PLUS_AT] = ACTIONS(2930),
    [anon_sym_DASH_AT] = ACTIONS(2930),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2932),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(2930),
    [anon_sym_BQUOTE] = ACTIONS(2930),
    [sym_comment] = ACTIONS(87),
  },
  [1645] = {
    [sym__string_content] = ACTIONS(6437),
    [sym__string_end] = ACTIONS(6437),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(6439),
    [sym_escape_sequence] = ACTIONS(6437),
  },
  [1646] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(3884),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(457),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym_method_call] = STATE(457),
    [sym_assignment] = STATE(3884),
    [sym_operator_assignment] = STATE(3884),
    [sym_conditional] = STATE(3884),
    [sym_range] = STATE(3884),
    [sym_binary] = STATE(3884),
    [sym_unary] = STATE(3884),
    [sym_left_assignment_list] = STATE(456),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(457),
    [sym__variable] = STATE(455),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(457),
    [sym_false] = STATE(457),
    [sym_nil] = STATE(457),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(458),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(841),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_yield] = ACTIONS(851),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_next] = ACTIONS(855),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1647] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(3885),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(457),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym_method_call] = STATE(457),
    [sym_assignment] = STATE(3885),
    [sym_operator_assignment] = STATE(3885),
    [sym_conditional] = STATE(3885),
    [sym_range] = STATE(3885),
    [sym_binary] = STATE(3885),
    [sym_unary] = STATE(3885),
    [sym_left_assignment_list] = STATE(456),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(457),
    [sym__variable] = STATE(455),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(457),
    [sym_false] = STATE(457),
    [sym_nil] = STATE(457),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(458),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(841),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_yield] = ACTIONS(851),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_next] = ACTIONS(855),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1648] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(3886),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(457),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym_method_call] = STATE(457),
    [sym_assignment] = STATE(3886),
    [sym_operator_assignment] = STATE(3886),
    [sym_conditional] = STATE(3886),
    [sym_range] = STATE(3886),
    [sym_binary] = STATE(3886),
    [sym_unary] = STATE(3886),
    [sym_left_assignment_list] = STATE(456),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(457),
    [sym__variable] = STATE(455),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(457),
    [sym_false] = STATE(457),
    [sym_nil] = STATE(457),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(458),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(841),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_yield] = ACTIONS(851),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_next] = ACTIONS(855),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1649] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(3887),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(457),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym_method_call] = STATE(457),
    [sym_assignment] = STATE(3887),
    [sym_operator_assignment] = STATE(3887),
    [sym_conditional] = STATE(3887),
    [sym_range] = STATE(3887),
    [sym_binary] = STATE(3887),
    [sym_unary] = STATE(3887),
    [sym_left_assignment_list] = STATE(456),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(457),
    [sym__variable] = STATE(455),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(457),
    [sym_false] = STATE(457),
    [sym_nil] = STATE(457),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(458),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(841),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_yield] = ACTIONS(851),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_next] = ACTIONS(855),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1650] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(3888),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(457),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym_method_call] = STATE(457),
    [sym_assignment] = STATE(3888),
    [sym_operator_assignment] = STATE(3888),
    [sym_conditional] = STATE(3888),
    [sym_range] = STATE(3888),
    [sym_binary] = STATE(3888),
    [sym_unary] = STATE(3888),
    [sym_left_assignment_list] = STATE(456),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(457),
    [sym__variable] = STATE(455),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(457),
    [sym_false] = STATE(457),
    [sym_nil] = STATE(457),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(458),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(841),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_yield] = ACTIONS(851),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_next] = ACTIONS(855),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1651] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(3889),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(457),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym_method_call] = STATE(457),
    [sym_assignment] = STATE(3889),
    [sym_operator_assignment] = STATE(3889),
    [sym_conditional] = STATE(3889),
    [sym_range] = STATE(3889),
    [sym_binary] = STATE(3889),
    [sym_unary] = STATE(3889),
    [sym_left_assignment_list] = STATE(456),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(457),
    [sym__variable] = STATE(455),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(457),
    [sym_false] = STATE(457),
    [sym_nil] = STATE(457),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(458),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(841),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_yield] = ACTIONS(851),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_next] = ACTIONS(855),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1652] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(3890),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(457),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym_method_call] = STATE(457),
    [sym_assignment] = STATE(3890),
    [sym_operator_assignment] = STATE(3890),
    [sym_conditional] = STATE(3890),
    [sym_range] = STATE(3890),
    [sym_binary] = STATE(3890),
    [sym_unary] = STATE(3890),
    [sym_left_assignment_list] = STATE(456),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(457),
    [sym__variable] = STATE(455),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(457),
    [sym_false] = STATE(457),
    [sym_nil] = STATE(457),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(458),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(841),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_yield] = ACTIONS(851),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_next] = ACTIONS(855),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1653] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(3891),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(457),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym_method_call] = STATE(457),
    [sym_assignment] = STATE(3891),
    [sym_operator_assignment] = STATE(3891),
    [sym_conditional] = STATE(3891),
    [sym_range] = STATE(3891),
    [sym_binary] = STATE(3891),
    [sym_unary] = STATE(3891),
    [sym_left_assignment_list] = STATE(456),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(457),
    [sym__variable] = STATE(455),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(457),
    [sym_false] = STATE(457),
    [sym_nil] = STATE(457),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(458),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(841),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_yield] = ACTIONS(851),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_next] = ACTIONS(855),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1654] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(3892),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(457),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym_method_call] = STATE(457),
    [sym_assignment] = STATE(3892),
    [sym_operator_assignment] = STATE(3892),
    [sym_conditional] = STATE(3892),
    [sym_range] = STATE(3892),
    [sym_binary] = STATE(3892),
    [sym_unary] = STATE(3892),
    [sym_left_assignment_list] = STATE(456),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(457),
    [sym__variable] = STATE(455),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(457),
    [sym_false] = STATE(457),
    [sym_nil] = STATE(457),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(458),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(841),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_yield] = ACTIONS(851),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_next] = ACTIONS(855),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1655] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(3893),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(457),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym_method_call] = STATE(457),
    [sym_assignment] = STATE(3893),
    [sym_operator_assignment] = STATE(3893),
    [sym_conditional] = STATE(3893),
    [sym_range] = STATE(3893),
    [sym_binary] = STATE(3893),
    [sym_unary] = STATE(3893),
    [sym_left_assignment_list] = STATE(456),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(457),
    [sym__variable] = STATE(455),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(457),
    [sym_false] = STATE(457),
    [sym_nil] = STATE(457),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(458),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(841),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_yield] = ACTIONS(851),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_next] = ACTIONS(855),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1656] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(3894),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(3894),
    [sym_operator_assignment] = STATE(3894),
    [sym_conditional] = STATE(3894),
    [sym_range] = STATE(3894),
    [sym_binary] = STATE(3894),
    [sym_unary] = STATE(3894),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1657] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(3895),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(457),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym_method_call] = STATE(457),
    [sym_assignment] = STATE(3895),
    [sym_operator_assignment] = STATE(3895),
    [sym_conditional] = STATE(3895),
    [sym_range] = STATE(3895),
    [sym_binary] = STATE(3895),
    [sym_unary] = STATE(3895),
    [sym_left_assignment_list] = STATE(456),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(457),
    [sym__variable] = STATE(455),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(457),
    [sym_false] = STATE(457),
    [sym_nil] = STATE(457),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(458),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(841),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_yield] = ACTIONS(851),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_next] = ACTIONS(855),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1658] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(3896),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(457),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym_method_call] = STATE(457),
    [sym_assignment] = STATE(3896),
    [sym_operator_assignment] = STATE(3896),
    [sym_conditional] = STATE(3896),
    [sym_range] = STATE(3896),
    [sym_binary] = STATE(3896),
    [sym_unary] = STATE(3896),
    [sym_left_assignment_list] = STATE(456),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(457),
    [sym__variable] = STATE(455),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(457),
    [sym_false] = STATE(457),
    [sym_nil] = STATE(457),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(458),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(841),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_yield] = ACTIONS(851),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_next] = ACTIONS(855),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1659] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(3897),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(457),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym_method_call] = STATE(457),
    [sym_assignment] = STATE(3897),
    [sym_operator_assignment] = STATE(3897),
    [sym_conditional] = STATE(3897),
    [sym_range] = STATE(3897),
    [sym_binary] = STATE(3897),
    [sym_unary] = STATE(3897),
    [sym_left_assignment_list] = STATE(456),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(457),
    [sym__variable] = STATE(455),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(457),
    [sym_false] = STATE(457),
    [sym_nil] = STATE(457),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(458),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(841),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_yield] = ACTIONS(851),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_next] = ACTIONS(855),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1660] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(3898),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(457),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym_method_call] = STATE(457),
    [sym_assignment] = STATE(3898),
    [sym_operator_assignment] = STATE(3898),
    [sym_conditional] = STATE(3898),
    [sym_range] = STATE(3898),
    [sym_binary] = STATE(3898),
    [sym_unary] = STATE(3898),
    [sym_left_assignment_list] = STATE(456),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(457),
    [sym__variable] = STATE(455),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(457),
    [sym_false] = STATE(457),
    [sym_nil] = STATE(457),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(458),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(841),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_yield] = ACTIONS(851),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_next] = ACTIONS(855),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1661] = {
    [sym_argument_list_with_parens] = STATE(3901),
    [sym__argument_list_with_parens] = STATE(3902),
    [sym_operator] = STATE(3901),
    [sym_heredoc_body] = STATE(3903),
    [aux_sym_call_repeat1] = STATE(3903),
    [sym__heredoc_body_start] = ACTIONS(2519),
    [anon_sym_PIPE] = ACTIONS(6441),
    [anon_sym_STAR] = ACTIONS(6443),
    [anon_sym_STAR_STAR] = ACTIONS(6441),
    [anon_sym_AMP] = ACTIONS(6441),
    [anon_sym_LT] = ACTIONS(6443),
    [anon_sym_LPAREN2] = ACTIONS(6445),
    [anon_sym_DOT_DOT] = ACTIONS(6441),
    [anon_sym_LT_LT] = ACTIONS(6441),
    [anon_sym_GT_GT] = ACTIONS(6441),
    [anon_sym_EQ_EQ] = ACTIONS(6443),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6441),
    [anon_sym_LT_EQ_GT] = ACTIONS(6441),
    [anon_sym_EQ_TILDE] = ACTIONS(6441),
    [anon_sym_BANG_TILDE] = ACTIONS(6441),
    [anon_sym_LT_EQ] = ACTIONS(6443),
    [anon_sym_GT] = ACTIONS(6443),
    [anon_sym_GT_EQ] = ACTIONS(6441),
    [anon_sym_CARET] = ACTIONS(6441),
    [anon_sym_PLUS] = ACTIONS(6443),
    [anon_sym_SLASH] = ACTIONS(6441),
    [anon_sym_PERCENT] = ACTIONS(6441),
    [anon_sym_BANG] = ACTIONS(6443),
    [anon_sym_TILDE] = ACTIONS(6441),
    [sym_constant] = ACTIONS(6447),
    [sym_identifier] = ACTIONS(6447),
    [anon_sym_DASH] = ACTIONS(6443),
    [anon_sym_PLUS_AT] = ACTIONS(6441),
    [anon_sym_DASH_AT] = ACTIONS(6441),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(6443),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(6441),
    [anon_sym_BQUOTE] = ACTIONS(6441),
    [sym_comment] = ACTIONS(87),
  },
  [1662] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(346),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(352),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(352),
    [sym__argument_list_with_trailing_comma] = STATE(3905),
    [sym__argument] = STATE(350),
    [sym_splat_argument] = STATE(350),
    [sym_hash_splat_argument] = STATE(350),
    [sym_block_argument] = STATE(350),
    [sym_assignment] = STATE(346),
    [sym_operator_assignment] = STATE(346),
    [sym_conditional] = STATE(346),
    [sym_range] = STATE(346),
    [sym_binary] = STATE(346),
    [sym_unary] = STATE(346),
    [sym_left_assignment_list] = STATE(351),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(352),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(352),
    [sym_false] = STATE(352),
    [sym_nil] = STATE(352),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(353),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(350),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(593),
    [sym__splat_star] = ACTIONS(595),
    [sym__unary_minus] = ACTIONS(597),
    [sym__identifier_hash_key] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(6449),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1663] = {
    [sym_constant] = ACTIONS(6451),
    [sym_identifier] = ACTIONS(6451),
    [sym_comment] = ACTIONS(87),
  },
  [1664] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(3936),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(3940),
    [sym_scope_resolution] = STATE(3938),
    [sym_call] = STATE(3938),
    [sym_method_call] = STATE(3940),
    [sym_assignment] = STATE(3936),
    [sym_operator_assignment] = STATE(3936),
    [sym_conditional] = STATE(3936),
    [sym_range] = STATE(3936),
    [sym_binary] = STATE(3936),
    [sym_unary] = STATE(3936),
    [sym_left_assignment_list] = STATE(3939),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3940),
    [sym__variable] = STATE(3938),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(3940),
    [sym_false] = STATE(3940),
    [sym_nil] = STATE(3940),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(3941),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(6469),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(6481),
    [anon_sym_yield] = ACTIONS(6483),
    [anon_sym_break] = ACTIONS(6485),
    [anon_sym_next] = ACTIONS(6487),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(6505),
    [anon_sym_defined_QMARK] = ACTIONS(6507),
    [anon_sym_not] = ACTIONS(6509),
    [anon_sym_BANG] = ACTIONS(6511),
    [anon_sym_TILDE] = ACTIONS(6511),
    [sym_constant] = ACTIONS(6513),
    [sym_identifier] = ACTIONS(6513),
    [sym_instance_variable] = ACTIONS(6515),
    [sym_class_variable] = ACTIONS(6515),
    [sym_global_variable] = ACTIONS(6515),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(6513),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6513),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [1665] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(3942),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(3940),
    [sym_scope_resolution] = STATE(3938),
    [sym_call] = STATE(3938),
    [sym_method_call] = STATE(3940),
    [sym_assignment] = STATE(3942),
    [sym_operator_assignment] = STATE(3942),
    [sym_conditional] = STATE(3942),
    [sym_range] = STATE(3942),
    [sym_binary] = STATE(3942),
    [sym_unary] = STATE(3942),
    [sym_left_assignment_list] = STATE(3939),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3940),
    [sym__variable] = STATE(3938),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(3940),
    [sym_false] = STATE(3940),
    [sym_nil] = STATE(3940),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(3941),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(6469),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(6481),
    [anon_sym_yield] = ACTIONS(6483),
    [anon_sym_break] = ACTIONS(6485),
    [anon_sym_next] = ACTIONS(6487),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(6505),
    [anon_sym_defined_QMARK] = ACTIONS(6507),
    [anon_sym_not] = ACTIONS(6509),
    [anon_sym_BANG] = ACTIONS(6511),
    [anon_sym_TILDE] = ACTIONS(6511),
    [sym_constant] = ACTIONS(6513),
    [sym_identifier] = ACTIONS(6513),
    [sym_instance_variable] = ACTIONS(6515),
    [sym_class_variable] = ACTIONS(6515),
    [sym_global_variable] = ACTIONS(6515),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(6513),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6513),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [1666] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3943),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1686),
    [sym_scope_resolution] = STATE(1680),
    [sym_call] = STATE(1680),
    [sym_method_call] = STATE(1686),
    [sym_assignment] = STATE(3943),
    [sym_operator_assignment] = STATE(3943),
    [sym_conditional] = STATE(3943),
    [sym_range] = STATE(3943),
    [sym_binary] = STATE(3943),
    [sym_unary] = STATE(3943),
    [sym_left_assignment_list] = STATE(1685),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1686),
    [sym__variable] = STATE(1680),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1686),
    [sym_false] = STATE(1686),
    [sym_nil] = STATE(1686),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3944),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2992),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2998),
    [anon_sym_yield] = ACTIONS(3000),
    [anon_sym_break] = ACTIONS(3002),
    [anon_sym_next] = ACTIONS(3004),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6523),
    [anon_sym_defined_QMARK] = ACTIONS(3010),
    [anon_sym_not] = ACTIONS(3012),
    [anon_sym_BANG] = ACTIONS(3016),
    [anon_sym_TILDE] = ACTIONS(3016),
    [sym_constant] = ACTIONS(3022),
    [sym_identifier] = ACTIONS(3022),
    [sym_instance_variable] = ACTIONS(3020),
    [sym_class_variable] = ACTIONS(3020),
    [sym_global_variable] = ACTIONS(3020),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3022),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3022),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1667] = {
    [anon_sym_COLON] = ACTIONS(6525),
    [sym_comment] = ACTIONS(87),
  },
  [1668] = {
    [sym__statements] = STATE(3947),
    [sym_begin_block] = STATE(489),
    [sym_end_block] = STATE(489),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_block_parameters] = STATE(3948),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1516),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1519),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1519),
    [sym_hash_splat_argument] = STATE(116),
    [sym_assignment] = STATE(1516),
    [sym_operator_assignment] = STATE(1516),
    [sym_conditional] = STATE(1516),
    [sym_range] = STATE(1516),
    [sym_binary] = STATE(1516),
    [sym_unary] = STATE(1516),
    [sym_left_assignment_list] = STATE(1518),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1519),
    [sym__variable] = STATE(1517),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1519),
    [sym_false] = STATE(1519),
    [sym_nil] = STATE(1519),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1520),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(1959),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym__hash_items] = STATE(1960),
    [sym_pair] = STATE(122),
    [sym_lambda] = STATE(214),
    [sym_empty_statement] = STATE(495),
    [aux_sym__statements_repeat1] = STATE(495),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2629),
    [sym__identifier_hash_key] = ACTIONS(157),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(6527),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_PIPE] = ACTIONS(2445),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2633),
    [anon_sym_yield] = ACTIONS(2635),
    [anon_sym_break] = ACTIONS(2637),
    [anon_sym_next] = ACTIONS(2639),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2641),
    [anon_sym_defined_QMARK] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2647),
    [anon_sym_TILDE] = ACTIONS(2647),
    [sym_constant] = ACTIONS(2649),
    [sym_identifier] = ACTIONS(2649),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1669] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(3949),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(3940),
    [sym_scope_resolution] = STATE(3938),
    [sym_call] = STATE(3938),
    [sym_method_call] = STATE(3940),
    [sym_assignment] = STATE(3949),
    [sym_operator_assignment] = STATE(3949),
    [sym_conditional] = STATE(3949),
    [sym_range] = STATE(3949),
    [sym_binary] = STATE(3949),
    [sym_unary] = STATE(3949),
    [sym_left_assignment_list] = STATE(3939),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3940),
    [sym__variable] = STATE(3938),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(3940),
    [sym_false] = STATE(3940),
    [sym_nil] = STATE(3940),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(3941),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(6469),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(6481),
    [anon_sym_yield] = ACTIONS(6483),
    [anon_sym_break] = ACTIONS(6485),
    [anon_sym_next] = ACTIONS(6487),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(6505),
    [anon_sym_defined_QMARK] = ACTIONS(6507),
    [anon_sym_not] = ACTIONS(6509),
    [anon_sym_BANG] = ACTIONS(6511),
    [anon_sym_TILDE] = ACTIONS(6511),
    [sym_constant] = ACTIONS(6513),
    [sym_identifier] = ACTIONS(6513),
    [sym_instance_variable] = ACTIONS(6515),
    [sym_class_variable] = ACTIONS(6515),
    [sym_global_variable] = ACTIONS(6515),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(6513),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6513),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [1670] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3870),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1686),
    [sym_scope_resolution] = STATE(1680),
    [sym_call] = STATE(1680),
    [sym_method_call] = STATE(1686),
    [sym_argument_list] = STATE(1973),
    [sym__argument_list_with_parens] = STATE(3871),
    [sym__argument] = STATE(3872),
    [sym_splat_argument] = STATE(3872),
    [sym_hash_splat_argument] = STATE(3872),
    [sym_block_argument] = STATE(3872),
    [sym_assignment] = STATE(3870),
    [sym_operator_assignment] = STATE(3870),
    [sym_conditional] = STATE(3870),
    [sym_range] = STATE(3870),
    [sym_binary] = STATE(3870),
    [sym_unary] = STATE(3870),
    [sym_left_assignment_list] = STATE(1685),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1686),
    [sym__variable] = STATE(1680),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1686),
    [sym_false] = STATE(1686),
    [sym_nil] = STATE(1686),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3873),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(3872),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(6413),
    [sym__splat_star] = ACTIONS(6415),
    [sym__unary_minus] = ACTIONS(2992),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(6417),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_RBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2998),
    [anon_sym_yield] = ACTIONS(3000),
    [anon_sym_break] = ACTIONS(3002),
    [anon_sym_next] = ACTIONS(3004),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(365),
    [anon_sym_DASH_EQ] = ACTIONS(365),
    [anon_sym_STAR_EQ] = ACTIONS(365),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(365),
    [anon_sym_SLASH_EQ] = ACTIONS(365),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(365),
    [anon_sym_PIPE_EQ] = ACTIONS(365),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(365),
    [anon_sym_AMP_EQ] = ACTIONS(365),
    [anon_sym_PERCENT_EQ] = ACTIONS(365),
    [anon_sym_GT_GT_EQ] = ACTIONS(365),
    [anon_sym_LT_LT_EQ] = ACTIONS(365),
    [anon_sym_CARET_EQ] = ACTIONS(365),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_PERCENT] = ACTIONS(377),
    [anon_sym_defined_QMARK] = ACTIONS(3010),
    [anon_sym_not] = ACTIONS(3012),
    [anon_sym_BANG] = ACTIONS(3014),
    [anon_sym_TILDE] = ACTIONS(3016),
    [sym_constant] = ACTIONS(6419),
    [sym_identifier] = ACTIONS(6419),
    [sym_instance_variable] = ACTIONS(3020),
    [sym_class_variable] = ACTIONS(3020),
    [sym_global_variable] = ACTIONS(3020),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3022),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3022),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1671] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3870),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1686),
    [sym_scope_resolution] = STATE(1680),
    [sym_call] = STATE(1680),
    [sym_method_call] = STATE(1686),
    [sym_argument_list] = STATE(1974),
    [sym__argument_list_with_parens] = STATE(3871),
    [sym__argument] = STATE(3872),
    [sym_splat_argument] = STATE(3872),
    [sym_hash_splat_argument] = STATE(3872),
    [sym_block_argument] = STATE(3872),
    [sym_assignment] = STATE(3870),
    [sym_operator_assignment] = STATE(3870),
    [sym_conditional] = STATE(3870),
    [sym_range] = STATE(3870),
    [sym_binary] = STATE(3870),
    [sym_unary] = STATE(3870),
    [sym_left_assignment_list] = STATE(1685),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1686),
    [sym__variable] = STATE(1680),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1686),
    [sym_false] = STATE(1686),
    [sym_nil] = STATE(1686),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3873),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(3872),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(6413),
    [sym__splat_star] = ACTIONS(6415),
    [sym__unary_minus] = ACTIONS(2992),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(6417),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_RBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_EQ] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2998),
    [anon_sym_yield] = ACTIONS(3000),
    [anon_sym_break] = ACTIONS(3002),
    [anon_sym_next] = ACTIONS(3004),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(417),
    [anon_sym_DASH_EQ] = ACTIONS(417),
    [anon_sym_STAR_EQ] = ACTIONS(417),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(417),
    [anon_sym_SLASH_EQ] = ACTIONS(417),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(417),
    [anon_sym_PIPE_EQ] = ACTIONS(417),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(417),
    [anon_sym_AMP_EQ] = ACTIONS(417),
    [anon_sym_PERCENT_EQ] = ACTIONS(417),
    [anon_sym_GT_GT_EQ] = ACTIONS(417),
    [anon_sym_LT_LT_EQ] = ACTIONS(417),
    [anon_sym_CARET_EQ] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(3010),
    [anon_sym_not] = ACTIONS(3012),
    [anon_sym_BANG] = ACTIONS(3014),
    [anon_sym_TILDE] = ACTIONS(3016),
    [sym_constant] = ACTIONS(6419),
    [sym_identifier] = ACTIONS(6419),
    [sym_instance_variable] = ACTIONS(3020),
    [sym_class_variable] = ACTIONS(3020),
    [sym_global_variable] = ACTIONS(3020),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3022),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3022),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1672] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3870),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1686),
    [sym_scope_resolution] = STATE(1680),
    [sym_call] = STATE(1680),
    [sym_method_call] = STATE(1686),
    [sym_argument_list] = STATE(1975),
    [sym__argument_list_with_parens] = STATE(3871),
    [sym__argument] = STATE(3872),
    [sym_splat_argument] = STATE(3872),
    [sym_hash_splat_argument] = STATE(3872),
    [sym_block_argument] = STATE(3872),
    [sym_assignment] = STATE(3870),
    [sym_operator_assignment] = STATE(3870),
    [sym_conditional] = STATE(3870),
    [sym_range] = STATE(3870),
    [sym_binary] = STATE(3870),
    [sym_unary] = STATE(3870),
    [sym_left_assignment_list] = STATE(1685),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1686),
    [sym__variable] = STATE(1680),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1686),
    [sym_false] = STATE(1686),
    [sym_nil] = STATE(1686),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3873),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(3872),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(6413),
    [sym__splat_star] = ACTIONS(6415),
    [sym__unary_minus] = ACTIONS(2992),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(6417),
    [anon_sym_LBRACE] = ACTIONS(421),
    [anon_sym_RBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_EQ] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2998),
    [anon_sym_yield] = ACTIONS(3000),
    [anon_sym_break] = ACTIONS(3002),
    [anon_sym_next] = ACTIONS(3004),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(421),
    [anon_sym_DASH_EQ] = ACTIONS(421),
    [anon_sym_STAR_EQ] = ACTIONS(421),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(421),
    [anon_sym_SLASH_EQ] = ACTIONS(421),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(421),
    [anon_sym_PIPE_EQ] = ACTIONS(421),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(421),
    [anon_sym_AMP_EQ] = ACTIONS(421),
    [anon_sym_PERCENT_EQ] = ACTIONS(421),
    [anon_sym_GT_GT_EQ] = ACTIONS(421),
    [anon_sym_LT_LT_EQ] = ACTIONS(421),
    [anon_sym_CARET_EQ] = ACTIONS(421),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(3010),
    [anon_sym_not] = ACTIONS(3012),
    [anon_sym_BANG] = ACTIONS(3014),
    [anon_sym_TILDE] = ACTIONS(3016),
    [sym_constant] = ACTIONS(6419),
    [sym_identifier] = ACTIONS(6419),
    [sym_instance_variable] = ACTIONS(3020),
    [sym_class_variable] = ACTIONS(3020),
    [sym_global_variable] = ACTIONS(3020),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3022),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3022),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1673] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3870),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1686),
    [sym_scope_resolution] = STATE(1680),
    [sym_call] = STATE(1680),
    [sym_method_call] = STATE(1686),
    [sym_argument_list] = STATE(1976),
    [sym__argument_list_with_parens] = STATE(3871),
    [sym__argument] = STATE(3872),
    [sym_splat_argument] = STATE(3872),
    [sym_hash_splat_argument] = STATE(3872),
    [sym_block_argument] = STATE(3872),
    [sym_assignment] = STATE(3870),
    [sym_operator_assignment] = STATE(3870),
    [sym_conditional] = STATE(3870),
    [sym_range] = STATE(3870),
    [sym_binary] = STATE(3870),
    [sym_unary] = STATE(3870),
    [sym_left_assignment_list] = STATE(1685),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1686),
    [sym__variable] = STATE(1680),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1686),
    [sym_false] = STATE(1686),
    [sym_nil] = STATE(1686),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3873),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(3872),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(6413),
    [sym__splat_star] = ACTIONS(6415),
    [sym__unary_minus] = ACTIONS(2992),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(6417),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(427),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2998),
    [anon_sym_yield] = ACTIONS(3000),
    [anon_sym_break] = ACTIONS(3002),
    [anon_sym_next] = ACTIONS(3004),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(425),
    [anon_sym_DASH_EQ] = ACTIONS(425),
    [anon_sym_STAR_EQ] = ACTIONS(425),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(425),
    [anon_sym_SLASH_EQ] = ACTIONS(425),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(425),
    [anon_sym_PIPE_EQ] = ACTIONS(425),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(425),
    [anon_sym_AMP_EQ] = ACTIONS(425),
    [anon_sym_PERCENT_EQ] = ACTIONS(425),
    [anon_sym_GT_GT_EQ] = ACTIONS(425),
    [anon_sym_LT_LT_EQ] = ACTIONS(425),
    [anon_sym_CARET_EQ] = ACTIONS(425),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(3010),
    [anon_sym_not] = ACTIONS(3012),
    [anon_sym_BANG] = ACTIONS(3014),
    [anon_sym_TILDE] = ACTIONS(3016),
    [sym_constant] = ACTIONS(6419),
    [sym_identifier] = ACTIONS(6419),
    [sym_instance_variable] = ACTIONS(3020),
    [sym_class_variable] = ACTIONS(3020),
    [sym_global_variable] = ACTIONS(3020),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3022),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3022),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1674] = {
    [sym__statements] = STATE(3951),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_block_parameters] = STATE(3952),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_heredoc_body] = STATE(3953),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [sym__terminator] = STATE(3953),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__line_break] = ACTIONS(6529),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(6529),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(6531),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1675] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(906),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(911),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(911),
    [sym__argument_list_with_trailing_comma] = STATE(3955),
    [sym__argument] = STATE(909),
    [sym_splat_argument] = STATE(909),
    [sym_hash_splat_argument] = STATE(909),
    [sym_block_argument] = STATE(909),
    [sym_assignment] = STATE(906),
    [sym_operator_assignment] = STATE(906),
    [sym_conditional] = STATE(906),
    [sym_range] = STATE(906),
    [sym_binary] = STATE(906),
    [sym_unary] = STATE(906),
    [sym_left_assignment_list] = STATE(910),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(911),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(911),
    [sym_false] = STATE(911),
    [sym_nil] = STATE(911),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(912),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(909),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1589),
    [sym__splat_star] = ACTIONS(1591),
    [sym__unary_minus] = ACTIONS(1593),
    [sym__identifier_hash_key] = ACTIONS(1595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(6533),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1599),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_defined_QMARK] = ACTIONS(1611),
    [anon_sym_not] = ACTIONS(1613),
    [anon_sym_BANG] = ACTIONS(1615),
    [anon_sym_TILDE] = ACTIONS(1615),
    [sym_constant] = ACTIONS(1617),
    [sym_identifier] = ACTIONS(1617),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1676] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3956),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1686),
    [sym_scope_resolution] = STATE(1680),
    [sym_call] = STATE(1680),
    [sym_method_call] = STATE(1686),
    [sym_assignment] = STATE(3956),
    [sym_operator_assignment] = STATE(3956),
    [sym_conditional] = STATE(3956),
    [sym_range] = STATE(3956),
    [sym_binary] = STATE(3956),
    [sym_unary] = STATE(3956),
    [sym_left_assignment_list] = STATE(1685),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1686),
    [sym__variable] = STATE(1680),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1686),
    [sym_false] = STATE(1686),
    [sym_nil] = STATE(1686),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3944),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2992),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2998),
    [anon_sym_yield] = ACTIONS(3000),
    [anon_sym_break] = ACTIONS(3002),
    [anon_sym_next] = ACTIONS(3004),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6523),
    [anon_sym_defined_QMARK] = ACTIONS(3010),
    [anon_sym_not] = ACTIONS(3012),
    [anon_sym_BANG] = ACTIONS(3016),
    [anon_sym_TILDE] = ACTIONS(3016),
    [sym_constant] = ACTIONS(3022),
    [sym_identifier] = ACTIONS(3022),
    [sym_instance_variable] = ACTIONS(3020),
    [sym_class_variable] = ACTIONS(3020),
    [sym_global_variable] = ACTIONS(3020),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3022),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3022),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1677] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1997),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1686),
    [sym_scope_resolution] = STATE(1680),
    [sym_call] = STATE(1680),
    [sym_method_call] = STATE(1686),
    [sym_assignment] = STATE(1997),
    [sym_operator_assignment] = STATE(1997),
    [sym_conditional] = STATE(1997),
    [sym_range] = STATE(1997),
    [sym_binary] = STATE(1997),
    [sym_unary] = STATE(1997),
    [sym_left_assignment_list] = STATE(1685),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1686),
    [sym__variable] = STATE(1680),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1686),
    [sym_false] = STATE(1686),
    [sym_nil] = STATE(1686),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3944),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2992),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2998),
    [anon_sym_yield] = ACTIONS(3000),
    [anon_sym_break] = ACTIONS(3002),
    [anon_sym_next] = ACTIONS(3004),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6523),
    [anon_sym_defined_QMARK] = ACTIONS(3010),
    [anon_sym_not] = ACTIONS(3012),
    [anon_sym_BANG] = ACTIONS(3016),
    [anon_sym_TILDE] = ACTIONS(3016),
    [sym_constant] = ACTIONS(3022),
    [sym_identifier] = ACTIONS(3022),
    [sym_instance_variable] = ACTIONS(3020),
    [sym_class_variable] = ACTIONS(3020),
    [sym_global_variable] = ACTIONS(3020),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3022),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3022),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1678] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(6535),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [1679] = {
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(6537),
    [sym__binary_star] = ACTIONS(6539),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_RBRACE] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(6541),
    [anon_sym_STAR_STAR] = ACTIONS(6543),
    [anon_sym_AMP] = ACTIONS(6545),
    [anon_sym_EQ] = ACTIONS(1631),
    [anon_sym_LT] = ACTIONS(6547),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_unless] = ACTIONS(1625),
    [anon_sym_while] = ACTIONS(1625),
    [anon_sym_until] = ACTIONS(1625),
    [anon_sym_rescue] = ACTIONS(1625),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(6525),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_PLUS_EQ] = ACTIONS(1625),
    [anon_sym_DASH_EQ] = ACTIONS(1625),
    [anon_sym_STAR_EQ] = ACTIONS(1625),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1625),
    [anon_sym_SLASH_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1625),
    [anon_sym_AMP_EQ] = ACTIONS(1625),
    [anon_sym_PERCENT_EQ] = ACTIONS(1625),
    [anon_sym_GT_GT_EQ] = ACTIONS(1625),
    [anon_sym_LT_LT_EQ] = ACTIONS(1625),
    [anon_sym_CARET_EQ] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(6549),
    [anon_sym_DOT_DOT] = ACTIONS(6551),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6553),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(6555),
    [anon_sym_AMP_AMP] = ACTIONS(6555),
    [anon_sym_LT_LT] = ACTIONS(6557),
    [anon_sym_GT_GT] = ACTIONS(6557),
    [anon_sym_EQ_EQ] = ACTIONS(6555),
    [anon_sym_BANG_EQ] = ACTIONS(6559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6559),
    [anon_sym_LT_EQ_GT] = ACTIONS(6559),
    [anon_sym_EQ_TILDE] = ACTIONS(6559),
    [anon_sym_BANG_TILDE] = ACTIONS(6559),
    [anon_sym_LT_EQ] = ACTIONS(6547),
    [anon_sym_GT] = ACTIONS(6547),
    [anon_sym_GT_EQ] = ACTIONS(6561),
    [anon_sym_CARET] = ACTIONS(6541),
    [anon_sym_PLUS] = ACTIONS(6563),
    [anon_sym_SLASH] = ACTIONS(6543),
    [anon_sym_PERCENT] = ACTIONS(6543),
    [sym_comment] = ACTIONS(87),
  },
  [1680] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3870),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1686),
    [sym_scope_resolution] = STATE(1680),
    [sym_call] = STATE(1680),
    [sym_method_call] = STATE(1686),
    [sym_argument_list] = STATE(2016),
    [sym__argument_list_with_parens] = STATE(3871),
    [sym__argument] = STATE(3872),
    [sym_splat_argument] = STATE(3872),
    [sym_hash_splat_argument] = STATE(3872),
    [sym_block_argument] = STATE(3872),
    [sym_do_block] = STATE(1382),
    [sym_block] = STATE(1382),
    [sym_assignment] = STATE(3870),
    [sym_operator_assignment] = STATE(3870),
    [sym_conditional] = STATE(3870),
    [sym_range] = STATE(3870),
    [sym_binary] = STATE(3870),
    [sym_unary] = STATE(3870),
    [sym_left_assignment_list] = STATE(1685),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1686),
    [sym__variable] = STATE(1680),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1686),
    [sym_false] = STATE(1686),
    [sym_nil] = STATE(1686),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3873),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(3872),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(6413),
    [sym__splat_star] = ACTIONS(6415),
    [sym__unary_minus] = ACTIONS(2992),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(6417),
    [anon_sym_LBRACE] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2998),
    [anon_sym_yield] = ACTIONS(3000),
    [anon_sym_break] = ACTIONS(3002),
    [anon_sym_next] = ACTIONS(3004),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(769),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(769),
    [anon_sym_until] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(769),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(769),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(3010),
    [anon_sym_not] = ACTIONS(3012),
    [anon_sym_BANG] = ACTIONS(3014),
    [anon_sym_TILDE] = ACTIONS(3016),
    [sym_constant] = ACTIONS(6419),
    [sym_identifier] = ACTIONS(6419),
    [sym_instance_variable] = ACTIONS(3020),
    [sym_class_variable] = ACTIONS(3020),
    [sym_global_variable] = ACTIONS(3020),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3022),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3022),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1681] = {
    [sym_do_block] = STATE(3969),
    [sym_block] = STATE(3969),
    [sym__binary_minus] = ACTIONS(2717),
    [sym__binary_star] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(6565),
    [anon_sym_RBRACE] = ACTIONS(2717),
    [anon_sym_RPAREN] = ACTIONS(2717),
    [anon_sym_DOT] = ACTIONS(2721),
    [anon_sym_COMMA] = ACTIONS(2717),
    [anon_sym_PIPE] = ACTIONS(2721),
    [anon_sym_SEMI] = ACTIONS(2717),
    [anon_sym_STAR_STAR] = ACTIONS(2721),
    [anon_sym_AMP] = ACTIONS(2721),
    [anon_sym_EQ] = ACTIONS(2721),
    [anon_sym_LT] = ACTIONS(2721),
    [anon_sym_if] = ACTIONS(2717),
    [anon_sym_unless] = ACTIONS(2717),
    [anon_sym_while] = ACTIONS(2717),
    [anon_sym_until] = ACTIONS(2717),
    [anon_sym_rescue] = ACTIONS(2717),
    [anon_sym_do] = ACTIONS(6567),
    [anon_sym_LBRACK] = ACTIONS(2717),
    [anon_sym_COLON_COLON2] = ACTIONS(2717),
    [anon_sym_AMP_DOT] = ACTIONS(2717),
    [anon_sym_PLUS_EQ] = ACTIONS(2717),
    [anon_sym_DASH_EQ] = ACTIONS(2717),
    [anon_sym_STAR_EQ] = ACTIONS(2717),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2717),
    [anon_sym_SLASH_EQ] = ACTIONS(2717),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2717),
    [anon_sym_PIPE_EQ] = ACTIONS(2717),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2717),
    [anon_sym_AMP_EQ] = ACTIONS(2717),
    [anon_sym_PERCENT_EQ] = ACTIONS(2717),
    [anon_sym_GT_GT_EQ] = ACTIONS(2717),
    [anon_sym_LT_LT_EQ] = ACTIONS(2717),
    [anon_sym_CARET_EQ] = ACTIONS(2717),
    [anon_sym_QMARK] = ACTIONS(2717),
    [anon_sym_COLON2] = ACTIONS(2721),
    [anon_sym_DOT_DOT] = ACTIONS(2721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2717),
    [anon_sym_and] = ACTIONS(2717),
    [anon_sym_or] = ACTIONS(2717),
    [anon_sym_PIPE_PIPE] = ACTIONS(2721),
    [anon_sym_AMP_AMP] = ACTIONS(2721),
    [anon_sym_LT_LT] = ACTIONS(2721),
    [anon_sym_GT_GT] = ACTIONS(2721),
    [anon_sym_EQ_EQ] = ACTIONS(2721),
    [anon_sym_BANG_EQ] = ACTIONS(2717),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2717),
    [anon_sym_LT_EQ_GT] = ACTIONS(2717),
    [anon_sym_EQ_TILDE] = ACTIONS(2717),
    [anon_sym_BANG_TILDE] = ACTIONS(2717),
    [anon_sym_LT_EQ] = ACTIONS(2721),
    [anon_sym_GT] = ACTIONS(2721),
    [anon_sym_GT_EQ] = ACTIONS(2717),
    [anon_sym_CARET] = ACTIONS(2721),
    [anon_sym_PLUS] = ACTIONS(2721),
    [anon_sym_SLASH] = ACTIONS(2721),
    [anon_sym_PERCENT] = ACTIONS(2721),
    [sym_comment] = ACTIONS(87),
  },
  [1682] = {
    [sym_heredoc_body] = STATE(3971),
    [aux_sym_call_repeat1] = STATE(3971),
    [sym__heredoc_body_start] = ACTIONS(6569),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_RBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [1683] = {
    [sym_heredoc_body] = STATE(3971),
    [aux_sym_call_repeat1] = STATE(3971),
    [aux_sym_argument_list_repeat1] = STATE(3973),
    [sym__heredoc_body_start] = ACTIONS(6569),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_RBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(6571),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [1684] = {
    [sym__binary_minus] = ACTIONS(2717),
    [sym__binary_star] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(2717),
    [anon_sym_RBRACE] = ACTIONS(2717),
    [anon_sym_RPAREN] = ACTIONS(2717),
    [anon_sym_DOT] = ACTIONS(2721),
    [anon_sym_COMMA] = ACTIONS(2717),
    [anon_sym_PIPE] = ACTIONS(2721),
    [anon_sym_SEMI] = ACTIONS(2717),
    [anon_sym_STAR_STAR] = ACTIONS(2721),
    [anon_sym_AMP] = ACTIONS(2721),
    [anon_sym_EQ] = ACTIONS(2721),
    [anon_sym_LT] = ACTIONS(2721),
    [anon_sym_if] = ACTIONS(2717),
    [anon_sym_unless] = ACTIONS(2717),
    [anon_sym_while] = ACTIONS(2717),
    [anon_sym_until] = ACTIONS(2717),
    [anon_sym_rescue] = ACTIONS(2717),
    [anon_sym_do] = ACTIONS(2717),
    [anon_sym_LBRACK] = ACTIONS(2717),
    [anon_sym_COLON_COLON2] = ACTIONS(2717),
    [anon_sym_AMP_DOT] = ACTIONS(2717),
    [anon_sym_PLUS_EQ] = ACTIONS(2717),
    [anon_sym_DASH_EQ] = ACTIONS(2717),
    [anon_sym_STAR_EQ] = ACTIONS(2717),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2717),
    [anon_sym_SLASH_EQ] = ACTIONS(2717),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2717),
    [anon_sym_PIPE_EQ] = ACTIONS(2717),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2717),
    [anon_sym_AMP_EQ] = ACTIONS(2717),
    [anon_sym_PERCENT_EQ] = ACTIONS(2717),
    [anon_sym_GT_GT_EQ] = ACTIONS(2717),
    [anon_sym_LT_LT_EQ] = ACTIONS(2717),
    [anon_sym_CARET_EQ] = ACTIONS(2717),
    [anon_sym_QMARK] = ACTIONS(2717),
    [anon_sym_COLON2] = ACTIONS(2721),
    [anon_sym_DOT_DOT] = ACTIONS(2721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2717),
    [anon_sym_and] = ACTIONS(2717),
    [anon_sym_or] = ACTIONS(2717),
    [anon_sym_PIPE_PIPE] = ACTIONS(2721),
    [anon_sym_AMP_AMP] = ACTIONS(2721),
    [anon_sym_LT_LT] = ACTIONS(2721),
    [anon_sym_GT_GT] = ACTIONS(2721),
    [anon_sym_EQ_EQ] = ACTIONS(2721),
    [anon_sym_BANG_EQ] = ACTIONS(2717),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2717),
    [anon_sym_LT_EQ_GT] = ACTIONS(2717),
    [anon_sym_EQ_TILDE] = ACTIONS(2717),
    [anon_sym_BANG_TILDE] = ACTIONS(2717),
    [anon_sym_LT_EQ] = ACTIONS(2721),
    [anon_sym_GT] = ACTIONS(2721),
    [anon_sym_GT_EQ] = ACTIONS(2717),
    [anon_sym_CARET] = ACTIONS(2721),
    [anon_sym_PLUS] = ACTIONS(2721),
    [anon_sym_SLASH] = ACTIONS(2721),
    [anon_sym_PERCENT] = ACTIONS(2721),
    [sym_comment] = ACTIONS(87),
  },
  [1685] = {
    [anon_sym_EQ] = ACTIONS(6573),
    [sym_comment] = ACTIONS(87),
  },
  [1686] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(6575),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(6577),
    [anon_sym_DASH_EQ] = ACTIONS(6577),
    [anon_sym_STAR_EQ] = ACTIONS(6577),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6577),
    [anon_sym_SLASH_EQ] = ACTIONS(6577),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6577),
    [anon_sym_PIPE_EQ] = ACTIONS(6577),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6577),
    [anon_sym_AMP_EQ] = ACTIONS(6577),
    [anon_sym_PERCENT_EQ] = ACTIONS(6577),
    [anon_sym_GT_GT_EQ] = ACTIONS(6577),
    [anon_sym_LT_LT_EQ] = ACTIONS(6577),
    [anon_sym_CARET_EQ] = ACTIONS(6577),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1687] = {
    [sym_string] = STATE(3976),
    [aux_sym_chained_string_repeat1] = STATE(3976),
    [sym__string_start] = ACTIONS(1141),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(6579),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1688] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(3985),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(3988),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym_method_call] = STATE(3988),
    [sym_splat_argument] = STATE(3986),
    [sym_assignment] = STATE(3985),
    [sym_operator_assignment] = STATE(3985),
    [sym_conditional] = STATE(3985),
    [sym_range] = STATE(3985),
    [sym_binary] = STATE(3985),
    [sym_unary] = STATE(3985),
    [sym_right_assignment_list] = STATE(2035),
    [sym__arg_or_splat_arg] = STATE(3986),
    [sym_left_assignment_list] = STATE(3987),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3988),
    [sym__variable] = STATE(455),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(3988),
    [sym_false] = STATE(3988),
    [sym_nil] = STATE(3988),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(3989),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__splat_star] = ACTIONS(6581),
    [sym__unary_minus] = ACTIONS(6583),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6585),
    [anon_sym_yield] = ACTIONS(6587),
    [anon_sym_break] = ACTIONS(6589),
    [anon_sym_next] = ACTIONS(6591),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6593),
    [anon_sym_defined_QMARK] = ACTIONS(6595),
    [anon_sym_not] = ACTIONS(6597),
    [anon_sym_BANG] = ACTIONS(6599),
    [anon_sym_TILDE] = ACTIONS(6599),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1689] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(3990),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(457),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym_method_call] = STATE(457),
    [sym_assignment] = STATE(3990),
    [sym_operator_assignment] = STATE(3990),
    [sym_conditional] = STATE(3990),
    [sym_range] = STATE(3990),
    [sym_binary] = STATE(3990),
    [sym_unary] = STATE(3990),
    [sym_left_assignment_list] = STATE(456),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(457),
    [sym__variable] = STATE(455),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(457),
    [sym_false] = STATE(457),
    [sym_nil] = STATE(457),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(458),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(841),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_yield] = ACTIONS(851),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_next] = ACTIONS(855),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1690] = {
    [sym_string] = STATE(3991),
    [aux_sym_chained_string_repeat1] = STATE(3991),
    [sym__string_start] = ACTIONS(139),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_RBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [1691] = {
    [sym__string_content] = ACTIONS(6437),
    [sym__string_end] = ACTIONS(6437),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(6439),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(6439),
    [sym_escape_sequence] = ACTIONS(6439),
  },
  [1692] = {
    [sym__line_break] = ACTIONS(6601),
    [sym__heredoc_body_start] = ACTIONS(6601),
    [sym__binary_minus] = ACTIONS(6601),
    [sym__binary_star] = ACTIONS(6601),
    [ts_builtin_sym_end] = ACTIONS(6601),
    [anon_sym___END__] = ACTIONS(6601),
    [anon_sym_LBRACE] = ACTIONS(6601),
    [anon_sym_RBRACE] = ACTIONS(6601),
    [anon_sym_RPAREN] = ACTIONS(6601),
    [anon_sym_DOT] = ACTIONS(6603),
    [anon_sym_COMMA] = ACTIONS(6601),
    [anon_sym_PIPE] = ACTIONS(6603),
    [anon_sym_SEMI] = ACTIONS(6601),
    [anon_sym_STAR_STAR] = ACTIONS(6601),
    [anon_sym_AMP] = ACTIONS(6603),
    [anon_sym_LT] = ACTIONS(6603),
    [anon_sym_end] = ACTIONS(6601),
    [anon_sym_if] = ACTIONS(6601),
    [anon_sym_unless] = ACTIONS(6601),
    [anon_sym_while] = ACTIONS(6601),
    [anon_sym_until] = ACTIONS(6601),
    [anon_sym_rescue] = ACTIONS(6601),
    [anon_sym_do] = ACTIONS(6601),
    [anon_sym_when] = ACTIONS(6601),
    [anon_sym_elsif] = ACTIONS(6601),
    [anon_sym_else] = ACTIONS(6601),
    [anon_sym_then] = ACTIONS(6601),
    [anon_sym_ensure] = ACTIONS(6601),
    [anon_sym_EQ_GT] = ACTIONS(6601),
    [anon_sym_LBRACK] = ACTIONS(6601),
    [anon_sym_COLON_COLON2] = ACTIONS(6601),
    [anon_sym_AMP_DOT] = ACTIONS(6601),
    [anon_sym_QMARK] = ACTIONS(6601),
    [anon_sym_DOT_DOT] = ACTIONS(6603),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6601),
    [anon_sym_and] = ACTIONS(6601),
    [anon_sym_or] = ACTIONS(6601),
    [anon_sym_PIPE_PIPE] = ACTIONS(6601),
    [anon_sym_AMP_AMP] = ACTIONS(6601),
    [anon_sym_LT_LT] = ACTIONS(6601),
    [anon_sym_GT_GT] = ACTIONS(6601),
    [anon_sym_EQ_EQ] = ACTIONS(6603),
    [anon_sym_BANG_EQ] = ACTIONS(6601),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6601),
    [anon_sym_LT_EQ_GT] = ACTIONS(6601),
    [anon_sym_EQ_TILDE] = ACTIONS(6601),
    [anon_sym_BANG_TILDE] = ACTIONS(6601),
    [anon_sym_LT_EQ] = ACTIONS(6603),
    [anon_sym_GT] = ACTIONS(6603),
    [anon_sym_GT_EQ] = ACTIONS(6601),
    [anon_sym_CARET] = ACTIONS(6601),
    [anon_sym_PLUS] = ACTIONS(6601),
    [anon_sym_SLASH] = ACTIONS(6601),
    [anon_sym_PERCENT] = ACTIONS(6601),
    [sym_comment] = ACTIONS(87),
  },
  [1693] = {
    [sym__line_break] = ACTIONS(6605),
    [sym__heredoc_body_start] = ACTIONS(6605),
    [sym__binary_minus] = ACTIONS(6605),
    [sym__binary_star] = ACTIONS(6605),
    [ts_builtin_sym_end] = ACTIONS(6605),
    [anon_sym___END__] = ACTIONS(6605),
    [anon_sym_LBRACE] = ACTIONS(6605),
    [anon_sym_RBRACE] = ACTIONS(6605),
    [anon_sym_RPAREN] = ACTIONS(6605),
    [anon_sym_DOT] = ACTIONS(6607),
    [anon_sym_COMMA] = ACTIONS(6605),
    [anon_sym_PIPE] = ACTIONS(6607),
    [anon_sym_SEMI] = ACTIONS(6605),
    [anon_sym_STAR_STAR] = ACTIONS(6605),
    [anon_sym_AMP] = ACTIONS(6607),
    [anon_sym_LT] = ACTIONS(6607),
    [anon_sym_end] = ACTIONS(6605),
    [anon_sym_if] = ACTIONS(6605),
    [anon_sym_unless] = ACTIONS(6605),
    [anon_sym_while] = ACTIONS(6605),
    [anon_sym_until] = ACTIONS(6605),
    [anon_sym_rescue] = ACTIONS(6605),
    [anon_sym_do] = ACTIONS(6605),
    [anon_sym_when] = ACTIONS(6605),
    [anon_sym_elsif] = ACTIONS(6605),
    [anon_sym_else] = ACTIONS(6605),
    [anon_sym_then] = ACTIONS(6605),
    [anon_sym_ensure] = ACTIONS(6605),
    [anon_sym_EQ_GT] = ACTIONS(6605),
    [anon_sym_LBRACK] = ACTIONS(6605),
    [anon_sym_COLON_COLON2] = ACTIONS(6605),
    [anon_sym_AMP_DOT] = ACTIONS(6605),
    [anon_sym_QMARK] = ACTIONS(6605),
    [anon_sym_DOT_DOT] = ACTIONS(6607),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6605),
    [anon_sym_and] = ACTIONS(6605),
    [anon_sym_or] = ACTIONS(6605),
    [anon_sym_PIPE_PIPE] = ACTIONS(6605),
    [anon_sym_AMP_AMP] = ACTIONS(6605),
    [anon_sym_LT_LT] = ACTIONS(6605),
    [anon_sym_GT_GT] = ACTIONS(6605),
    [anon_sym_EQ_EQ] = ACTIONS(6607),
    [anon_sym_BANG_EQ] = ACTIONS(6605),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6605),
    [anon_sym_LT_EQ_GT] = ACTIONS(6605),
    [anon_sym_EQ_TILDE] = ACTIONS(6605),
    [anon_sym_BANG_TILDE] = ACTIONS(6605),
    [anon_sym_LT_EQ] = ACTIONS(6607),
    [anon_sym_GT] = ACTIONS(6607),
    [anon_sym_GT_EQ] = ACTIONS(6605),
    [anon_sym_CARET] = ACTIONS(6605),
    [anon_sym_PLUS] = ACTIONS(6605),
    [anon_sym_SLASH] = ACTIONS(6605),
    [anon_sym_PERCENT] = ACTIONS(6605),
    [sym_comment] = ACTIONS(87),
  },
  [1694] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1697),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(6609),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [1695] = {
    [aux_sym_string_array_repeat1] = STATE(1699),
    [sym__string_end] = ACTIONS(6609),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(6611),
  },
  [1696] = {
    [sym__line_break] = ACTIONS(6613),
    [sym__heredoc_body_start] = ACTIONS(6613),
    [sym__binary_minus] = ACTIONS(6613),
    [sym__binary_star] = ACTIONS(6613),
    [ts_builtin_sym_end] = ACTIONS(6613),
    [anon_sym___END__] = ACTIONS(6613),
    [anon_sym_LBRACE] = ACTIONS(6613),
    [anon_sym_RBRACE] = ACTIONS(6613),
    [anon_sym_RPAREN] = ACTIONS(6613),
    [anon_sym_DOT] = ACTIONS(6615),
    [anon_sym_COMMA] = ACTIONS(6613),
    [anon_sym_PIPE] = ACTIONS(6615),
    [anon_sym_SEMI] = ACTIONS(6613),
    [anon_sym_STAR_STAR] = ACTIONS(6613),
    [anon_sym_AMP] = ACTIONS(6615),
    [anon_sym_LT] = ACTIONS(6615),
    [anon_sym_end] = ACTIONS(6613),
    [anon_sym_if] = ACTIONS(6613),
    [anon_sym_unless] = ACTIONS(6613),
    [anon_sym_while] = ACTIONS(6613),
    [anon_sym_until] = ACTIONS(6613),
    [anon_sym_rescue] = ACTIONS(6613),
    [anon_sym_do] = ACTIONS(6613),
    [anon_sym_when] = ACTIONS(6613),
    [anon_sym_elsif] = ACTIONS(6613),
    [anon_sym_else] = ACTIONS(6613),
    [anon_sym_then] = ACTIONS(6613),
    [anon_sym_ensure] = ACTIONS(6613),
    [anon_sym_EQ_GT] = ACTIONS(6613),
    [anon_sym_LBRACK] = ACTIONS(6613),
    [anon_sym_COLON_COLON2] = ACTIONS(6613),
    [anon_sym_AMP_DOT] = ACTIONS(6613),
    [anon_sym_QMARK] = ACTIONS(6613),
    [anon_sym_DOT_DOT] = ACTIONS(6615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6613),
    [anon_sym_and] = ACTIONS(6613),
    [anon_sym_or] = ACTIONS(6613),
    [anon_sym_PIPE_PIPE] = ACTIONS(6613),
    [anon_sym_AMP_AMP] = ACTIONS(6613),
    [anon_sym_LT_LT] = ACTIONS(6613),
    [anon_sym_GT_GT] = ACTIONS(6613),
    [anon_sym_EQ_EQ] = ACTIONS(6615),
    [anon_sym_BANG_EQ] = ACTIONS(6613),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6613),
    [anon_sym_LT_EQ_GT] = ACTIONS(6613),
    [anon_sym_EQ_TILDE] = ACTIONS(6613),
    [anon_sym_BANG_TILDE] = ACTIONS(6613),
    [anon_sym_LT_EQ] = ACTIONS(6615),
    [anon_sym_GT] = ACTIONS(6615),
    [anon_sym_GT_EQ] = ACTIONS(6613),
    [anon_sym_CARET] = ACTIONS(6613),
    [anon_sym_PLUS] = ACTIONS(6613),
    [anon_sym_SLASH] = ACTIONS(6613),
    [anon_sym_PERCENT] = ACTIONS(6613),
    [sym_comment] = ACTIONS(87),
  },
  [1697] = {
    [sym__string_end] = ACTIONS(6617),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(6617),
  },
  [1698] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1697),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(6619),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [1699] = {
    [aux_sym_string_array_repeat1] = STATE(1699),
    [sym__string_end] = ACTIONS(6621),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(6623),
  },
  [1700] = {
    [sym__line_break] = ACTIONS(6626),
    [sym__heredoc_body_start] = ACTIONS(6626),
    [sym__binary_minus] = ACTIONS(6626),
    [sym__binary_star] = ACTIONS(6626),
    [ts_builtin_sym_end] = ACTIONS(6626),
    [anon_sym___END__] = ACTIONS(6626),
    [anon_sym_LBRACE] = ACTIONS(6626),
    [anon_sym_RBRACE] = ACTIONS(6626),
    [anon_sym_RPAREN] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(6628),
    [anon_sym_COMMA] = ACTIONS(6626),
    [anon_sym_PIPE] = ACTIONS(6628),
    [anon_sym_SEMI] = ACTIONS(6626),
    [anon_sym_STAR_STAR] = ACTIONS(6626),
    [anon_sym_AMP] = ACTIONS(6628),
    [anon_sym_LT] = ACTIONS(6628),
    [anon_sym_end] = ACTIONS(6626),
    [anon_sym_if] = ACTIONS(6626),
    [anon_sym_unless] = ACTIONS(6626),
    [anon_sym_while] = ACTIONS(6626),
    [anon_sym_until] = ACTIONS(6626),
    [anon_sym_rescue] = ACTIONS(6626),
    [anon_sym_do] = ACTIONS(6626),
    [anon_sym_when] = ACTIONS(6626),
    [anon_sym_elsif] = ACTIONS(6626),
    [anon_sym_else] = ACTIONS(6626),
    [anon_sym_then] = ACTIONS(6626),
    [anon_sym_ensure] = ACTIONS(6626),
    [anon_sym_EQ_GT] = ACTIONS(6626),
    [anon_sym_LBRACK] = ACTIONS(6626),
    [anon_sym_COLON_COLON2] = ACTIONS(6626),
    [anon_sym_AMP_DOT] = ACTIONS(6626),
    [anon_sym_QMARK] = ACTIONS(6626),
    [anon_sym_DOT_DOT] = ACTIONS(6628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6626),
    [anon_sym_and] = ACTIONS(6626),
    [anon_sym_or] = ACTIONS(6626),
    [anon_sym_PIPE_PIPE] = ACTIONS(6626),
    [anon_sym_AMP_AMP] = ACTIONS(6626),
    [anon_sym_LT_LT] = ACTIONS(6626),
    [anon_sym_GT_GT] = ACTIONS(6626),
    [anon_sym_EQ_EQ] = ACTIONS(6628),
    [anon_sym_BANG_EQ] = ACTIONS(6626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6626),
    [anon_sym_LT_EQ_GT] = ACTIONS(6626),
    [anon_sym_EQ_TILDE] = ACTIONS(6626),
    [anon_sym_BANG_TILDE] = ACTIONS(6626),
    [anon_sym_LT_EQ] = ACTIONS(6628),
    [anon_sym_GT] = ACTIONS(6628),
    [anon_sym_GT_EQ] = ACTIONS(6626),
    [anon_sym_CARET] = ACTIONS(6626),
    [anon_sym_PLUS] = ACTIONS(6626),
    [anon_sym_SLASH] = ACTIONS(6626),
    [anon_sym_PERCENT] = ACTIONS(6626),
    [sym_comment] = ACTIONS(87),
  },
  [1701] = {
    [sym__line_break] = ACTIONS(6630),
    [sym__heredoc_body_start] = ACTIONS(6630),
    [sym__binary_minus] = ACTIONS(6630),
    [sym__binary_star] = ACTIONS(6630),
    [ts_builtin_sym_end] = ACTIONS(6630),
    [anon_sym___END__] = ACTIONS(6630),
    [anon_sym_LBRACE] = ACTIONS(6630),
    [anon_sym_RBRACE] = ACTIONS(6630),
    [anon_sym_RPAREN] = ACTIONS(6630),
    [anon_sym_DOT] = ACTIONS(6632),
    [anon_sym_COMMA] = ACTIONS(6630),
    [anon_sym_PIPE] = ACTIONS(6632),
    [anon_sym_SEMI] = ACTIONS(6630),
    [anon_sym_STAR_STAR] = ACTIONS(6630),
    [anon_sym_AMP] = ACTIONS(6632),
    [anon_sym_LT] = ACTIONS(6632),
    [anon_sym_end] = ACTIONS(6630),
    [anon_sym_if] = ACTIONS(6630),
    [anon_sym_unless] = ACTIONS(6630),
    [anon_sym_while] = ACTIONS(6630),
    [anon_sym_until] = ACTIONS(6630),
    [anon_sym_rescue] = ACTIONS(6630),
    [anon_sym_do] = ACTIONS(6630),
    [anon_sym_when] = ACTIONS(6630),
    [anon_sym_elsif] = ACTIONS(6630),
    [anon_sym_else] = ACTIONS(6630),
    [anon_sym_then] = ACTIONS(6630),
    [anon_sym_ensure] = ACTIONS(6630),
    [anon_sym_EQ_GT] = ACTIONS(6630),
    [anon_sym_LBRACK] = ACTIONS(6630),
    [anon_sym_COLON_COLON2] = ACTIONS(6630),
    [anon_sym_AMP_DOT] = ACTIONS(6630),
    [anon_sym_QMARK] = ACTIONS(6630),
    [anon_sym_DOT_DOT] = ACTIONS(6632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6630),
    [anon_sym_and] = ACTIONS(6630),
    [anon_sym_or] = ACTIONS(6630),
    [anon_sym_PIPE_PIPE] = ACTIONS(6630),
    [anon_sym_AMP_AMP] = ACTIONS(6630),
    [anon_sym_LT_LT] = ACTIONS(6630),
    [anon_sym_GT_GT] = ACTIONS(6630),
    [anon_sym_EQ_EQ] = ACTIONS(6632),
    [anon_sym_BANG_EQ] = ACTIONS(6630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6630),
    [anon_sym_LT_EQ_GT] = ACTIONS(6630),
    [anon_sym_EQ_TILDE] = ACTIONS(6630),
    [anon_sym_BANG_TILDE] = ACTIONS(6630),
    [anon_sym_LT_EQ] = ACTIONS(6632),
    [anon_sym_GT] = ACTIONS(6632),
    [anon_sym_GT_EQ] = ACTIONS(6630),
    [anon_sym_CARET] = ACTIONS(6630),
    [anon_sym_PLUS] = ACTIONS(6630),
    [anon_sym_SLASH] = ACTIONS(6630),
    [anon_sym_PERCENT] = ACTIONS(6630),
    [sym_comment] = ACTIONS(87),
  },
  [1702] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1705),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(6634),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [1703] = {
    [aux_sym_symbol_array_repeat1] = STATE(1707),
    [sym__string_end] = ACTIONS(6634),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(6636),
  },
  [1704] = {
    [sym__line_break] = ACTIONS(6638),
    [sym__heredoc_body_start] = ACTIONS(6638),
    [sym__binary_minus] = ACTIONS(6638),
    [sym__binary_star] = ACTIONS(6638),
    [ts_builtin_sym_end] = ACTIONS(6638),
    [anon_sym___END__] = ACTIONS(6638),
    [anon_sym_LBRACE] = ACTIONS(6638),
    [anon_sym_RBRACE] = ACTIONS(6638),
    [anon_sym_RPAREN] = ACTIONS(6638),
    [anon_sym_DOT] = ACTIONS(6640),
    [anon_sym_COMMA] = ACTIONS(6638),
    [anon_sym_PIPE] = ACTIONS(6640),
    [anon_sym_SEMI] = ACTIONS(6638),
    [anon_sym_STAR_STAR] = ACTIONS(6638),
    [anon_sym_AMP] = ACTIONS(6640),
    [anon_sym_LT] = ACTIONS(6640),
    [anon_sym_end] = ACTIONS(6638),
    [anon_sym_if] = ACTIONS(6638),
    [anon_sym_unless] = ACTIONS(6638),
    [anon_sym_while] = ACTIONS(6638),
    [anon_sym_until] = ACTIONS(6638),
    [anon_sym_rescue] = ACTIONS(6638),
    [anon_sym_do] = ACTIONS(6638),
    [anon_sym_when] = ACTIONS(6638),
    [anon_sym_elsif] = ACTIONS(6638),
    [anon_sym_else] = ACTIONS(6638),
    [anon_sym_then] = ACTIONS(6638),
    [anon_sym_ensure] = ACTIONS(6638),
    [anon_sym_EQ_GT] = ACTIONS(6638),
    [anon_sym_LBRACK] = ACTIONS(6638),
    [anon_sym_COLON_COLON2] = ACTIONS(6638),
    [anon_sym_AMP_DOT] = ACTIONS(6638),
    [anon_sym_QMARK] = ACTIONS(6638),
    [anon_sym_DOT_DOT] = ACTIONS(6640),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6638),
    [anon_sym_and] = ACTIONS(6638),
    [anon_sym_or] = ACTIONS(6638),
    [anon_sym_PIPE_PIPE] = ACTIONS(6638),
    [anon_sym_AMP_AMP] = ACTIONS(6638),
    [anon_sym_LT_LT] = ACTIONS(6638),
    [anon_sym_GT_GT] = ACTIONS(6638),
    [anon_sym_EQ_EQ] = ACTIONS(6640),
    [anon_sym_BANG_EQ] = ACTIONS(6638),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6638),
    [anon_sym_LT_EQ_GT] = ACTIONS(6638),
    [anon_sym_EQ_TILDE] = ACTIONS(6638),
    [anon_sym_BANG_TILDE] = ACTIONS(6638),
    [anon_sym_LT_EQ] = ACTIONS(6640),
    [anon_sym_GT] = ACTIONS(6640),
    [anon_sym_GT_EQ] = ACTIONS(6638),
    [anon_sym_CARET] = ACTIONS(6638),
    [anon_sym_PLUS] = ACTIONS(6638),
    [anon_sym_SLASH] = ACTIONS(6638),
    [anon_sym_PERCENT] = ACTIONS(6638),
    [sym_comment] = ACTIONS(87),
  },
  [1705] = {
    [sym__string_end] = ACTIONS(6642),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(6642),
  },
  [1706] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1705),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(6644),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [1707] = {
    [aux_sym_symbol_array_repeat1] = STATE(1707),
    [sym__string_end] = ACTIONS(6646),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(6648),
  },
  [1708] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(3149),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [1709] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(4007),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(4009),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4009),
    [sym_assignment] = STATE(4007),
    [sym_operator_assignment] = STATE(4007),
    [sym_conditional] = STATE(4007),
    [sym_range] = STATE(4007),
    [sym_binary] = STATE(4007),
    [sym_unary] = STATE(4007),
    [sym_left_assignment_list] = STATE(4008),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4009),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(4009),
    [sym_false] = STATE(4009),
    [sym_nil] = STATE(4009),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(4010),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6651),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6653),
    [anon_sym_yield] = ACTIONS(6655),
    [anon_sym_break] = ACTIONS(6657),
    [anon_sym_next] = ACTIONS(6659),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6661),
    [anon_sym_defined_QMARK] = ACTIONS(6663),
    [anon_sym_not] = ACTIONS(6665),
    [anon_sym_BANG] = ACTIONS(6667),
    [anon_sym_TILDE] = ACTIONS(6667),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1710] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(4011),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(4009),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4009),
    [sym_assignment] = STATE(4011),
    [sym_operator_assignment] = STATE(4011),
    [sym_conditional] = STATE(4011),
    [sym_range] = STATE(4011),
    [sym_binary] = STATE(4011),
    [sym_unary] = STATE(4011),
    [sym_left_assignment_list] = STATE(4008),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4009),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(4009),
    [sym_false] = STATE(4009),
    [sym_nil] = STATE(4009),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(4010),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6651),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6653),
    [anon_sym_yield] = ACTIONS(6655),
    [anon_sym_break] = ACTIONS(6657),
    [anon_sym_next] = ACTIONS(6659),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6661),
    [anon_sym_defined_QMARK] = ACTIONS(6663),
    [anon_sym_not] = ACTIONS(6665),
    [anon_sym_BANG] = ACTIONS(6667),
    [anon_sym_TILDE] = ACTIONS(6667),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1711] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4012),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1725),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1725),
    [sym_assignment] = STATE(4012),
    [sym_operator_assignment] = STATE(4012),
    [sym_conditional] = STATE(4012),
    [sym_range] = STATE(4012),
    [sym_binary] = STATE(4012),
    [sym_unary] = STATE(4012),
    [sym_left_assignment_list] = STATE(1724),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1725),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1725),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(4013),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(3111),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6669),
    [anon_sym_defined_QMARK] = ACTIONS(3123),
    [anon_sym_not] = ACTIONS(3125),
    [anon_sym_BANG] = ACTIONS(3129),
    [anon_sym_TILDE] = ACTIONS(3129),
    [sym_constant] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1712] = {
    [anon_sym_COLON] = ACTIONS(6671),
    [sym_comment] = ACTIONS(87),
  },
  [1713] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(4015),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(4009),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4009),
    [sym_assignment] = STATE(4015),
    [sym_operator_assignment] = STATE(4015),
    [sym_conditional] = STATE(4015),
    [sym_range] = STATE(4015),
    [sym_binary] = STATE(4015),
    [sym_unary] = STATE(4015),
    [sym_left_assignment_list] = STATE(4008),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4009),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(4009),
    [sym_false] = STATE(4009),
    [sym_nil] = STATE(4009),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(4010),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6651),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6653),
    [anon_sym_yield] = ACTIONS(6655),
    [anon_sym_break] = ACTIONS(6657),
    [anon_sym_next] = ACTIONS(6659),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6661),
    [anon_sym_defined_QMARK] = ACTIONS(6663),
    [anon_sym_not] = ACTIONS(6665),
    [anon_sym_BANG] = ACTIONS(6667),
    [anon_sym_TILDE] = ACTIONS(6667),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1714] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3657),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1725),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1725),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(4016),
    [sym__argument] = STATE(4017),
    [sym_splat_argument] = STATE(4017),
    [sym_hash_splat_argument] = STATE(4017),
    [sym_block_argument] = STATE(4017),
    [sym_assignment] = STATE(3657),
    [sym_operator_assignment] = STATE(3657),
    [sym_conditional] = STATE(3657),
    [sym_range] = STATE(3657),
    [sym_binary] = STATE(3657),
    [sym_unary] = STATE(3657),
    [sym_left_assignment_list] = STATE(1724),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1725),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1725),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3660),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4017),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(6057),
    [sym__splat_star] = ACTIONS(6059),
    [sym__unary_minus] = ACTIONS(3111),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(6061),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(3123),
    [anon_sym_not] = ACTIONS(3125),
    [anon_sym_BANG] = ACTIONS(3127),
    [anon_sym_TILDE] = ACTIONS(3129),
    [sym_constant] = ACTIONS(6063),
    [sym_identifier] = ACTIONS(6063),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1715] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3657),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1725),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1725),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(4016),
    [sym__argument] = STATE(4017),
    [sym_splat_argument] = STATE(4017),
    [sym_hash_splat_argument] = STATE(4017),
    [sym_block_argument] = STATE(4017),
    [sym_assignment] = STATE(3657),
    [sym_operator_assignment] = STATE(3657),
    [sym_conditional] = STATE(3657),
    [sym_range] = STATE(3657),
    [sym_binary] = STATE(3657),
    [sym_unary] = STATE(3657),
    [sym_left_assignment_list] = STATE(1724),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1725),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1725),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3660),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4017),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(6057),
    [sym__splat_star] = ACTIONS(6059),
    [sym__unary_minus] = ACTIONS(3111),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(6061),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(3123),
    [anon_sym_not] = ACTIONS(3125),
    [anon_sym_BANG] = ACTIONS(3127),
    [anon_sym_TILDE] = ACTIONS(3129),
    [sym_constant] = ACTIONS(6063),
    [sym_identifier] = ACTIONS(6063),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1716] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3657),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1725),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1725),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(4016),
    [sym__argument] = STATE(4017),
    [sym_splat_argument] = STATE(4017),
    [sym_hash_splat_argument] = STATE(4017),
    [sym_block_argument] = STATE(4017),
    [sym_assignment] = STATE(3657),
    [sym_operator_assignment] = STATE(3657),
    [sym_conditional] = STATE(3657),
    [sym_range] = STATE(3657),
    [sym_binary] = STATE(3657),
    [sym_unary] = STATE(3657),
    [sym_left_assignment_list] = STATE(1724),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1725),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1725),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3660),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4017),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(6057),
    [sym__splat_star] = ACTIONS(6059),
    [sym__unary_minus] = ACTIONS(3111),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(6061),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(3123),
    [anon_sym_not] = ACTIONS(3125),
    [anon_sym_BANG] = ACTIONS(3127),
    [anon_sym_TILDE] = ACTIONS(3129),
    [sym_constant] = ACTIONS(6063),
    [sym_identifier] = ACTIONS(6063),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1717] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3657),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1725),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1725),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(4016),
    [sym__argument] = STATE(4017),
    [sym_splat_argument] = STATE(4017),
    [sym_hash_splat_argument] = STATE(4017),
    [sym_block_argument] = STATE(4017),
    [sym_assignment] = STATE(3657),
    [sym_operator_assignment] = STATE(3657),
    [sym_conditional] = STATE(3657),
    [sym_range] = STATE(3657),
    [sym_binary] = STATE(3657),
    [sym_unary] = STATE(3657),
    [sym_left_assignment_list] = STATE(1724),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1725),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1725),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3660),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4017),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(6057),
    [sym__splat_star] = ACTIONS(6059),
    [sym__unary_minus] = ACTIONS(3111),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(6061),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(3123),
    [anon_sym_not] = ACTIONS(3125),
    [anon_sym_BANG] = ACTIONS(3127),
    [anon_sym_TILDE] = ACTIONS(3129),
    [sym_constant] = ACTIONS(6063),
    [sym_identifier] = ACTIONS(6063),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1718] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4018),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1725),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1725),
    [sym_assignment] = STATE(4018),
    [sym_operator_assignment] = STATE(4018),
    [sym_conditional] = STATE(4018),
    [sym_range] = STATE(4018),
    [sym_binary] = STATE(4018),
    [sym_unary] = STATE(4018),
    [sym_left_assignment_list] = STATE(1724),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1725),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1725),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(4013),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(3111),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6669),
    [anon_sym_defined_QMARK] = ACTIONS(3123),
    [anon_sym_not] = ACTIONS(3125),
    [anon_sym_BANG] = ACTIONS(3129),
    [anon_sym_TILDE] = ACTIONS(3129),
    [sym_constant] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1719] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1725),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1725),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(1724),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1725),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1725),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(4013),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(3111),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6669),
    [anon_sym_defined_QMARK] = ACTIONS(3123),
    [anon_sym_not] = ACTIONS(3125),
    [anon_sym_BANG] = ACTIONS(3129),
    [anon_sym_TILDE] = ACTIONS(3129),
    [sym_constant] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1720] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(6673),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [1721] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(6675),
    [sym__binary_star] = ACTIONS(6677),
    [anon_sym_RBRACE] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(6679),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(6677),
    [anon_sym_AMP] = ACTIONS(6681),
    [anon_sym_LT] = ACTIONS(6683),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_unless] = ACTIONS(1625),
    [anon_sym_while] = ACTIONS(1625),
    [anon_sym_until] = ACTIONS(1625),
    [anon_sym_rescue] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(6671),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(6685),
    [anon_sym_DOT_DOT] = ACTIONS(6687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6689),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(6691),
    [anon_sym_AMP_AMP] = ACTIONS(6691),
    [anon_sym_LT_LT] = ACTIONS(6693),
    [anon_sym_GT_GT] = ACTIONS(6693),
    [anon_sym_EQ_EQ] = ACTIONS(6695),
    [anon_sym_BANG_EQ] = ACTIONS(6691),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6691),
    [anon_sym_LT_EQ_GT] = ACTIONS(6691),
    [anon_sym_EQ_TILDE] = ACTIONS(6691),
    [anon_sym_BANG_TILDE] = ACTIONS(6691),
    [anon_sym_LT_EQ] = ACTIONS(6683),
    [anon_sym_GT] = ACTIONS(6683),
    [anon_sym_GT_EQ] = ACTIONS(6697),
    [anon_sym_CARET] = ACTIONS(6699),
    [anon_sym_PLUS] = ACTIONS(6675),
    [anon_sym_SLASH] = ACTIONS(6677),
    [anon_sym_PERCENT] = ACTIONS(6677),
    [sym_comment] = ACTIONS(87),
  },
  [1722] = {
    [sym_heredoc_body] = STATE(4030),
    [aux_sym_call_repeat1] = STATE(4030),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_RBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [1723] = {
    [sym_heredoc_body] = STATE(4030),
    [aux_sym_call_repeat1] = STATE(4030),
    [aux_sym_argument_list_repeat1] = STATE(4032),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_RBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(6701),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [1724] = {
    [anon_sym_EQ] = ACTIONS(6703),
    [sym_comment] = ACTIONS(87),
  },
  [1725] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(6705),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(6707),
    [anon_sym_DASH_EQ] = ACTIONS(6707),
    [anon_sym_STAR_EQ] = ACTIONS(6707),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6707),
    [anon_sym_SLASH_EQ] = ACTIONS(6707),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6707),
    [anon_sym_PIPE_EQ] = ACTIONS(6707),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6707),
    [anon_sym_AMP_EQ] = ACTIONS(6707),
    [anon_sym_PERCENT_EQ] = ACTIONS(6707),
    [anon_sym_GT_GT_EQ] = ACTIONS(6707),
    [anon_sym_LT_LT_EQ] = ACTIONS(6707),
    [anon_sym_CARET_EQ] = ACTIONS(6707),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1726] = {
    [sym_string] = STATE(4035),
    [aux_sym_chained_string_repeat1] = STATE(4035),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(6709),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [1727] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(3147),
    [sym__binary_star] = ACTIONS(3149),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(3151),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(3149),
    [anon_sym_AMP] = ACTIONS(3153),
    [anon_sym_LT] = ACTIONS(3155),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(3157),
    [anon_sym_DOT_DOT] = ACTIONS(3159),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3161),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3167),
    [anon_sym_GT_GT] = ACTIONS(3167),
    [anon_sym_EQ_EQ] = ACTIONS(3169),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3155),
    [anon_sym_GT] = ACTIONS(3155),
    [anon_sym_GT_EQ] = ACTIONS(3171),
    [anon_sym_CARET] = ACTIONS(3173),
    [anon_sym_PLUS] = ACTIONS(3147),
    [anon_sym_SLASH] = ACTIONS(3149),
    [anon_sym_PERCENT] = ACTIONS(3149),
    [sym_comment] = ACTIONS(87),
  },
  [1728] = {
    [aux_sym_undef_repeat1] = STATE(4036),
    [sym__line_break] = ACTIONS(2251),
    [sym__heredoc_body_start] = ACTIONS(2251),
    [anon_sym_RBRACE] = ACTIONS(2251),
    [anon_sym_COMMA] = ACTIONS(2253),
    [anon_sym_SEMI] = ACTIONS(2251),
    [anon_sym_if] = ACTIONS(2251),
    [anon_sym_unless] = ACTIONS(2251),
    [anon_sym_while] = ACTIONS(2251),
    [anon_sym_until] = ACTIONS(2251),
    [anon_sym_rescue] = ACTIONS(2251),
    [sym_comment] = ACTIONS(87),
  },
  [1729] = {
    [sym__line_break] = ACTIONS(6711),
    [sym__heredoc_body_start] = ACTIONS(6711),
    [ts_builtin_sym_end] = ACTIONS(6711),
    [anon_sym___END__] = ACTIONS(6711),
    [anon_sym_RBRACE] = ACTIONS(6711),
    [anon_sym_RPAREN] = ACTIONS(6711),
    [anon_sym_SEMI] = ACTIONS(6711),
    [anon_sym_end] = ACTIONS(6711),
    [anon_sym_if] = ACTIONS(6711),
    [anon_sym_unless] = ACTIONS(6711),
    [anon_sym_while] = ACTIONS(6711),
    [anon_sym_until] = ACTIONS(6711),
    [anon_sym_rescue] = ACTIONS(6711),
    [anon_sym_when] = ACTIONS(6711),
    [anon_sym_elsif] = ACTIONS(6711),
    [anon_sym_else] = ACTIONS(6711),
    [anon_sym_then] = ACTIONS(6711),
    [anon_sym_ensure] = ACTIONS(6711),
    [sym_comment] = ACTIONS(87),
  },
  [1730] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(4037),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(4037),
    [sym_operator_assignment] = STATE(4037),
    [sym_conditional] = STATE(4037),
    [sym_range] = STATE(4037),
    [sym_binary] = STATE(4037),
    [sym_unary] = STATE(4037),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1731] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(4038),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(4038),
    [sym_operator_assignment] = STATE(4038),
    [sym_conditional] = STATE(4038),
    [sym_range] = STATE(4038),
    [sym_binary] = STATE(4038),
    [sym_unary] = STATE(4038),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1732] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(4039),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(4039),
    [sym_operator_assignment] = STATE(4039),
    [sym_conditional] = STATE(4039),
    [sym_range] = STATE(4039),
    [sym_binary] = STATE(4039),
    [sym_unary] = STATE(4039),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1733] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(4040),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(4040),
    [sym_operator_assignment] = STATE(4040),
    [sym_conditional] = STATE(4040),
    [sym_range] = STATE(4040),
    [sym_binary] = STATE(4040),
    [sym_unary] = STATE(4040),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1734] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(4041),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(4041),
    [sym_operator_assignment] = STATE(4041),
    [sym_conditional] = STATE(4041),
    [sym_range] = STATE(4041),
    [sym_binary] = STATE(4041),
    [sym_unary] = STATE(4041),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1735] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(4042),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(4042),
    [sym_operator_assignment] = STATE(4042),
    [sym_conditional] = STATE(4042),
    [sym_range] = STATE(4042),
    [sym_binary] = STATE(4042),
    [sym_unary] = STATE(4042),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1736] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(4043),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(4043),
    [sym_operator_assignment] = STATE(4043),
    [sym_conditional] = STATE(4043),
    [sym_range] = STATE(4043),
    [sym_binary] = STATE(4043),
    [sym_unary] = STATE(4043),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1737] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(4044),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(4044),
    [sym_operator_assignment] = STATE(4044),
    [sym_conditional] = STATE(4044),
    [sym_range] = STATE(4044),
    [sym_binary] = STATE(4044),
    [sym_unary] = STATE(4044),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1738] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(4045),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(4045),
    [sym_operator_assignment] = STATE(4045),
    [sym_conditional] = STATE(4045),
    [sym_range] = STATE(4045),
    [sym_binary] = STATE(4045),
    [sym_unary] = STATE(4045),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1739] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(4046),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(4046),
    [sym_operator_assignment] = STATE(4046),
    [sym_conditional] = STATE(4046),
    [sym_range] = STATE(4046),
    [sym_binary] = STATE(4046),
    [sym_unary] = STATE(4046),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1740] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(4047),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(4047),
    [sym_operator_assignment] = STATE(4047),
    [sym_conditional] = STATE(4047),
    [sym_range] = STATE(4047),
    [sym_binary] = STATE(4047),
    [sym_unary] = STATE(4047),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1741] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(4048),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(4048),
    [sym_operator_assignment] = STATE(4048),
    [sym_conditional] = STATE(4048),
    [sym_range] = STATE(4048),
    [sym_binary] = STATE(4048),
    [sym_unary] = STATE(4048),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1742] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(4049),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(4049),
    [sym_operator_assignment] = STATE(4049),
    [sym_conditional] = STATE(4049),
    [sym_range] = STATE(4049),
    [sym_binary] = STATE(4049),
    [sym_unary] = STATE(4049),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1743] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(4050),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(4050),
    [sym_operator_assignment] = STATE(4050),
    [sym_conditional] = STATE(4050),
    [sym_range] = STATE(4050),
    [sym_binary] = STATE(4050),
    [sym_unary] = STATE(4050),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1744] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(4051),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(4051),
    [sym_operator_assignment] = STATE(4051),
    [sym_conditional] = STATE(4051),
    [sym_range] = STATE(4051),
    [sym_binary] = STATE(4051),
    [sym_unary] = STATE(4051),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1745] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(4059),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(4062),
    [sym_scope_resolution] = STATE(4060),
    [sym_call] = STATE(4060),
    [sym_method_call] = STATE(4062),
    [sym_assignment] = STATE(4059),
    [sym_operator_assignment] = STATE(4059),
    [sym_conditional] = STATE(4059),
    [sym_range] = STATE(4059),
    [sym_binary] = STATE(4059),
    [sym_unary] = STATE(4059),
    [sym_left_assignment_list] = STATE(4061),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4062),
    [sym__variable] = STATE(4060),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(4062),
    [sym_false] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(4063),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(6713),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(6715),
    [anon_sym_yield] = ACTIONS(6717),
    [anon_sym_break] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6721),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(6723),
    [anon_sym_defined_QMARK] = ACTIONS(6725),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6731),
    [sym_identifier] = ACTIONS(6731),
    [sym_instance_variable] = ACTIONS(6733),
    [sym_class_variable] = ACTIONS(6733),
    [sym_global_variable] = ACTIONS(6733),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(6731),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6731),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [1746] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(4064),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(4062),
    [sym_scope_resolution] = STATE(4060),
    [sym_call] = STATE(4060),
    [sym_method_call] = STATE(4062),
    [sym_assignment] = STATE(4064),
    [sym_operator_assignment] = STATE(4064),
    [sym_conditional] = STATE(4064),
    [sym_range] = STATE(4064),
    [sym_binary] = STATE(4064),
    [sym_unary] = STATE(4064),
    [sym_left_assignment_list] = STATE(4061),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4062),
    [sym__variable] = STATE(4060),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(4062),
    [sym_false] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(4063),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(6713),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(6715),
    [anon_sym_yield] = ACTIONS(6717),
    [anon_sym_break] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6721),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(6723),
    [anon_sym_defined_QMARK] = ACTIONS(6725),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6731),
    [sym_identifier] = ACTIONS(6731),
    [sym_instance_variable] = ACTIONS(6733),
    [sym_class_variable] = ACTIONS(6733),
    [sym_global_variable] = ACTIONS(6733),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(6731),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6731),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [1747] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(4065),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1762),
    [sym_scope_resolution] = STATE(1758),
    [sym_call] = STATE(1758),
    [sym_method_call] = STATE(1762),
    [sym_assignment] = STATE(4065),
    [sym_operator_assignment] = STATE(4065),
    [sym_conditional] = STATE(4065),
    [sym_range] = STATE(4065),
    [sym_binary] = STATE(4065),
    [sym_unary] = STATE(4065),
    [sym_left_assignment_list] = STATE(1761),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1762),
    [sym__variable] = STATE(1758),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1762),
    [sym_false] = STATE(1762),
    [sym_nil] = STATE(1762),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(4066),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(3179),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(3183),
    [anon_sym_yield] = ACTIONS(3185),
    [anon_sym_break] = ACTIONS(3187),
    [anon_sym_next] = ACTIONS(3189),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(6735),
    [anon_sym_defined_QMARK] = ACTIONS(3191),
    [anon_sym_not] = ACTIONS(3193),
    [anon_sym_BANG] = ACTIONS(3197),
    [anon_sym_TILDE] = ACTIONS(3197),
    [sym_constant] = ACTIONS(3203),
    [sym_identifier] = ACTIONS(3203),
    [sym_instance_variable] = ACTIONS(3201),
    [sym_class_variable] = ACTIONS(3201),
    [sym_global_variable] = ACTIONS(3201),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(3203),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(3203),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [1748] = {
    [anon_sym_COLON] = ACTIONS(6737),
    [sym_comment] = ACTIONS(87),
  },
  [1749] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(4068),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(4062),
    [sym_scope_resolution] = STATE(4060),
    [sym_call] = STATE(4060),
    [sym_method_call] = STATE(4062),
    [sym_assignment] = STATE(4068),
    [sym_operator_assignment] = STATE(4068),
    [sym_conditional] = STATE(4068),
    [sym_range] = STATE(4068),
    [sym_binary] = STATE(4068),
    [sym_unary] = STATE(4068),
    [sym_left_assignment_list] = STATE(4061),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4062),
    [sym__variable] = STATE(4060),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(4062),
    [sym_false] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(4063),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(6713),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(6715),
    [anon_sym_yield] = ACTIONS(6717),
    [anon_sym_break] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6721),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(6723),
    [anon_sym_defined_QMARK] = ACTIONS(6725),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6731),
    [sym_identifier] = ACTIONS(6731),
    [sym_instance_variable] = ACTIONS(6733),
    [sym_class_variable] = ACTIONS(6733),
    [sym_global_variable] = ACTIONS(6733),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(6731),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6731),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [1750] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3679),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1762),
    [sym_scope_resolution] = STATE(1758),
    [sym_call] = STATE(1758),
    [sym_method_call] = STATE(1762),
    [sym_argument_list] = STATE(1535),
    [sym__argument_list_with_parens] = STATE(3680),
    [sym__argument] = STATE(3681),
    [sym_splat_argument] = STATE(3681),
    [sym_hash_splat_argument] = STATE(3681),
    [sym_block_argument] = STATE(3681),
    [sym_assignment] = STATE(3679),
    [sym_operator_assignment] = STATE(3679),
    [sym_conditional] = STATE(3679),
    [sym_range] = STATE(3679),
    [sym_binary] = STATE(3679),
    [sym_unary] = STATE(3679),
    [sym_left_assignment_list] = STATE(1761),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1762),
    [sym__variable] = STATE(1758),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1762),
    [sym_false] = STATE(1762),
    [sym_nil] = STATE(1762),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3682),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(3681),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(6095),
    [sym__splat_star] = ACTIONS(6097),
    [sym__unary_minus] = ACTIONS(3179),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(6099),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_RBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(3183),
    [anon_sym_yield] = ACTIONS(3185),
    [anon_sym_break] = ACTIONS(3187),
    [anon_sym_next] = ACTIONS(3189),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(365),
    [anon_sym_DASH_EQ] = ACTIONS(365),
    [anon_sym_STAR_EQ] = ACTIONS(365),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(365),
    [anon_sym_SLASH_EQ] = ACTIONS(365),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(365),
    [anon_sym_PIPE_EQ] = ACTIONS(365),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(365),
    [anon_sym_AMP_EQ] = ACTIONS(365),
    [anon_sym_PERCENT_EQ] = ACTIONS(365),
    [anon_sym_GT_GT_EQ] = ACTIONS(365),
    [anon_sym_LT_LT_EQ] = ACTIONS(365),
    [anon_sym_CARET_EQ] = ACTIONS(365),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_PERCENT] = ACTIONS(377),
    [anon_sym_defined_QMARK] = ACTIONS(3191),
    [anon_sym_not] = ACTIONS(3193),
    [anon_sym_BANG] = ACTIONS(3195),
    [anon_sym_TILDE] = ACTIONS(3197),
    [sym_constant] = ACTIONS(6101),
    [sym_identifier] = ACTIONS(6101),
    [sym_instance_variable] = ACTIONS(3201),
    [sym_class_variable] = ACTIONS(3201),
    [sym_global_variable] = ACTIONS(3201),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(3203),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(3203),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [1751] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3679),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1762),
    [sym_scope_resolution] = STATE(1758),
    [sym_call] = STATE(1758),
    [sym_method_call] = STATE(1762),
    [sym_argument_list] = STATE(1536),
    [sym__argument_list_with_parens] = STATE(3680),
    [sym__argument] = STATE(3681),
    [sym_splat_argument] = STATE(3681),
    [sym_hash_splat_argument] = STATE(3681),
    [sym_block_argument] = STATE(3681),
    [sym_assignment] = STATE(3679),
    [sym_operator_assignment] = STATE(3679),
    [sym_conditional] = STATE(3679),
    [sym_range] = STATE(3679),
    [sym_binary] = STATE(3679),
    [sym_unary] = STATE(3679),
    [sym_left_assignment_list] = STATE(1761),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1762),
    [sym__variable] = STATE(1758),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1762),
    [sym_false] = STATE(1762),
    [sym_nil] = STATE(1762),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3682),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(3681),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(6095),
    [sym__splat_star] = ACTIONS(6097),
    [sym__unary_minus] = ACTIONS(3179),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(6099),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_RBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_EQ] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(3183),
    [anon_sym_yield] = ACTIONS(3185),
    [anon_sym_break] = ACTIONS(3187),
    [anon_sym_next] = ACTIONS(3189),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(417),
    [anon_sym_DASH_EQ] = ACTIONS(417),
    [anon_sym_STAR_EQ] = ACTIONS(417),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(417),
    [anon_sym_SLASH_EQ] = ACTIONS(417),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(417),
    [anon_sym_PIPE_EQ] = ACTIONS(417),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(417),
    [anon_sym_AMP_EQ] = ACTIONS(417),
    [anon_sym_PERCENT_EQ] = ACTIONS(417),
    [anon_sym_GT_GT_EQ] = ACTIONS(417),
    [anon_sym_LT_LT_EQ] = ACTIONS(417),
    [anon_sym_CARET_EQ] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(3191),
    [anon_sym_not] = ACTIONS(3193),
    [anon_sym_BANG] = ACTIONS(3195),
    [anon_sym_TILDE] = ACTIONS(3197),
    [sym_constant] = ACTIONS(6101),
    [sym_identifier] = ACTIONS(6101),
    [sym_instance_variable] = ACTIONS(3201),
    [sym_class_variable] = ACTIONS(3201),
    [sym_global_variable] = ACTIONS(3201),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(3203),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(3203),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [1752] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3679),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1762),
    [sym_scope_resolution] = STATE(1758),
    [sym_call] = STATE(1758),
    [sym_method_call] = STATE(1762),
    [sym_argument_list] = STATE(1537),
    [sym__argument_list_with_parens] = STATE(3680),
    [sym__argument] = STATE(3681),
    [sym_splat_argument] = STATE(3681),
    [sym_hash_splat_argument] = STATE(3681),
    [sym_block_argument] = STATE(3681),
    [sym_assignment] = STATE(3679),
    [sym_operator_assignment] = STATE(3679),
    [sym_conditional] = STATE(3679),
    [sym_range] = STATE(3679),
    [sym_binary] = STATE(3679),
    [sym_unary] = STATE(3679),
    [sym_left_assignment_list] = STATE(1761),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1762),
    [sym__variable] = STATE(1758),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1762),
    [sym_false] = STATE(1762),
    [sym_nil] = STATE(1762),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3682),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(3681),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(6095),
    [sym__splat_star] = ACTIONS(6097),
    [sym__unary_minus] = ACTIONS(3179),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(6099),
    [anon_sym_LBRACE] = ACTIONS(421),
    [anon_sym_RBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_EQ] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(3183),
    [anon_sym_yield] = ACTIONS(3185),
    [anon_sym_break] = ACTIONS(3187),
    [anon_sym_next] = ACTIONS(3189),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(421),
    [anon_sym_DASH_EQ] = ACTIONS(421),
    [anon_sym_STAR_EQ] = ACTIONS(421),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(421),
    [anon_sym_SLASH_EQ] = ACTIONS(421),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(421),
    [anon_sym_PIPE_EQ] = ACTIONS(421),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(421),
    [anon_sym_AMP_EQ] = ACTIONS(421),
    [anon_sym_PERCENT_EQ] = ACTIONS(421),
    [anon_sym_GT_GT_EQ] = ACTIONS(421),
    [anon_sym_LT_LT_EQ] = ACTIONS(421),
    [anon_sym_CARET_EQ] = ACTIONS(421),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(3191),
    [anon_sym_not] = ACTIONS(3193),
    [anon_sym_BANG] = ACTIONS(3195),
    [anon_sym_TILDE] = ACTIONS(3197),
    [sym_constant] = ACTIONS(6101),
    [sym_identifier] = ACTIONS(6101),
    [sym_instance_variable] = ACTIONS(3201),
    [sym_class_variable] = ACTIONS(3201),
    [sym_global_variable] = ACTIONS(3201),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(3203),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(3203),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [1753] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3679),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1762),
    [sym_scope_resolution] = STATE(1758),
    [sym_call] = STATE(1758),
    [sym_method_call] = STATE(1762),
    [sym_argument_list] = STATE(1538),
    [sym__argument_list_with_parens] = STATE(3680),
    [sym__argument] = STATE(3681),
    [sym_splat_argument] = STATE(3681),
    [sym_hash_splat_argument] = STATE(3681),
    [sym_block_argument] = STATE(3681),
    [sym_assignment] = STATE(3679),
    [sym_operator_assignment] = STATE(3679),
    [sym_conditional] = STATE(3679),
    [sym_range] = STATE(3679),
    [sym_binary] = STATE(3679),
    [sym_unary] = STATE(3679),
    [sym_left_assignment_list] = STATE(1761),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1762),
    [sym__variable] = STATE(1758),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1762),
    [sym_false] = STATE(1762),
    [sym_nil] = STATE(1762),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3682),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(3681),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(6095),
    [sym__splat_star] = ACTIONS(6097),
    [sym__unary_minus] = ACTIONS(3179),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(6099),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(427),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(3183),
    [anon_sym_yield] = ACTIONS(3185),
    [anon_sym_break] = ACTIONS(3187),
    [anon_sym_next] = ACTIONS(3189),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(425),
    [anon_sym_DASH_EQ] = ACTIONS(425),
    [anon_sym_STAR_EQ] = ACTIONS(425),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(425),
    [anon_sym_SLASH_EQ] = ACTIONS(425),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(425),
    [anon_sym_PIPE_EQ] = ACTIONS(425),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(425),
    [anon_sym_AMP_EQ] = ACTIONS(425),
    [anon_sym_PERCENT_EQ] = ACTIONS(425),
    [anon_sym_GT_GT_EQ] = ACTIONS(425),
    [anon_sym_LT_LT_EQ] = ACTIONS(425),
    [anon_sym_CARET_EQ] = ACTIONS(425),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(3191),
    [anon_sym_not] = ACTIONS(3193),
    [anon_sym_BANG] = ACTIONS(3195),
    [anon_sym_TILDE] = ACTIONS(3197),
    [sym_constant] = ACTIONS(6101),
    [sym_identifier] = ACTIONS(6101),
    [sym_instance_variable] = ACTIONS(3201),
    [sym_class_variable] = ACTIONS(3201),
    [sym_global_variable] = ACTIONS(3201),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(3203),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(3203),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [1754] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(4069),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1762),
    [sym_scope_resolution] = STATE(1758),
    [sym_call] = STATE(1758),
    [sym_method_call] = STATE(1762),
    [sym_assignment] = STATE(4069),
    [sym_operator_assignment] = STATE(4069),
    [sym_conditional] = STATE(4069),
    [sym_range] = STATE(4069),
    [sym_binary] = STATE(4069),
    [sym_unary] = STATE(4069),
    [sym_left_assignment_list] = STATE(1761),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1762),
    [sym__variable] = STATE(1758),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1762),
    [sym_false] = STATE(1762),
    [sym_nil] = STATE(1762),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(4066),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(3179),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(3183),
    [anon_sym_yield] = ACTIONS(3185),
    [anon_sym_break] = ACTIONS(3187),
    [anon_sym_next] = ACTIONS(3189),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(6735),
    [anon_sym_defined_QMARK] = ACTIONS(3191),
    [anon_sym_not] = ACTIONS(3193),
    [anon_sym_BANG] = ACTIONS(3197),
    [anon_sym_TILDE] = ACTIONS(3197),
    [sym_constant] = ACTIONS(3203),
    [sym_identifier] = ACTIONS(3203),
    [sym_instance_variable] = ACTIONS(3201),
    [sym_class_variable] = ACTIONS(3201),
    [sym_global_variable] = ACTIONS(3201),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(3203),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(3203),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [1755] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(1559),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1762),
    [sym_scope_resolution] = STATE(1758),
    [sym_call] = STATE(1758),
    [sym_method_call] = STATE(1762),
    [sym_assignment] = STATE(1559),
    [sym_operator_assignment] = STATE(1559),
    [sym_conditional] = STATE(1559),
    [sym_range] = STATE(1559),
    [sym_binary] = STATE(1559),
    [sym_unary] = STATE(1559),
    [sym_left_assignment_list] = STATE(1761),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1762),
    [sym__variable] = STATE(1758),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1762),
    [sym_false] = STATE(1762),
    [sym_nil] = STATE(1762),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(4066),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(3179),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(3183),
    [anon_sym_yield] = ACTIONS(3185),
    [anon_sym_break] = ACTIONS(3187),
    [anon_sym_next] = ACTIONS(3189),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(6735),
    [anon_sym_defined_QMARK] = ACTIONS(3191),
    [anon_sym_not] = ACTIONS(3193),
    [anon_sym_BANG] = ACTIONS(3197),
    [anon_sym_TILDE] = ACTIONS(3197),
    [sym_constant] = ACTIONS(3203),
    [sym_identifier] = ACTIONS(3203),
    [sym_instance_variable] = ACTIONS(3201),
    [sym_class_variable] = ACTIONS(3201),
    [sym_global_variable] = ACTIONS(3201),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(3203),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(3203),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [1756] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(6739),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [1757] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(6741),
    [sym__binary_star] = ACTIONS(6743),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_RBRACE] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(6747),
    [anon_sym_AMP] = ACTIONS(6749),
    [anon_sym_EQ] = ACTIONS(1631),
    [anon_sym_LT] = ACTIONS(6751),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_unless] = ACTIONS(1625),
    [anon_sym_while] = ACTIONS(1625),
    [anon_sym_until] = ACTIONS(1625),
    [anon_sym_rescue] = ACTIONS(1625),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(6737),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_PLUS_EQ] = ACTIONS(1625),
    [anon_sym_DASH_EQ] = ACTIONS(1625),
    [anon_sym_STAR_EQ] = ACTIONS(1625),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1625),
    [anon_sym_SLASH_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1625),
    [anon_sym_AMP_EQ] = ACTIONS(1625),
    [anon_sym_PERCENT_EQ] = ACTIONS(1625),
    [anon_sym_GT_GT_EQ] = ACTIONS(1625),
    [anon_sym_LT_LT_EQ] = ACTIONS(1625),
    [anon_sym_CARET_EQ] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(6753),
    [anon_sym_DOT_DOT] = ACTIONS(6755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6757),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(6759),
    [anon_sym_AMP_AMP] = ACTIONS(6759),
    [anon_sym_LT_LT] = ACTIONS(6761),
    [anon_sym_GT_GT] = ACTIONS(6761),
    [anon_sym_EQ_EQ] = ACTIONS(6759),
    [anon_sym_BANG_EQ] = ACTIONS(6763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6763),
    [anon_sym_LT_EQ_GT] = ACTIONS(6763),
    [anon_sym_EQ_TILDE] = ACTIONS(6763),
    [anon_sym_BANG_TILDE] = ACTIONS(6763),
    [anon_sym_LT_EQ] = ACTIONS(6751),
    [anon_sym_GT] = ACTIONS(6751),
    [anon_sym_GT_EQ] = ACTIONS(6765),
    [anon_sym_CARET] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6767),
    [anon_sym_SLASH] = ACTIONS(6747),
    [anon_sym_PERCENT] = ACTIONS(6747),
    [sym_comment] = ACTIONS(87),
  },
  [1758] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3679),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1762),
    [sym_scope_resolution] = STATE(1758),
    [sym_call] = STATE(1758),
    [sym_method_call] = STATE(1762),
    [sym_argument_list] = STATE(1578),
    [sym__argument_list_with_parens] = STATE(3680),
    [sym__argument] = STATE(3681),
    [sym_splat_argument] = STATE(3681),
    [sym_hash_splat_argument] = STATE(3681),
    [sym_block_argument] = STATE(3681),
    [sym_do_block] = STATE(941),
    [sym_block] = STATE(941),
    [sym_assignment] = STATE(3679),
    [sym_operator_assignment] = STATE(3679),
    [sym_conditional] = STATE(3679),
    [sym_range] = STATE(3679),
    [sym_binary] = STATE(3679),
    [sym_unary] = STATE(3679),
    [sym_left_assignment_list] = STATE(1761),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1762),
    [sym__variable] = STATE(1758),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1762),
    [sym_false] = STATE(1762),
    [sym_nil] = STATE(1762),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3682),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(3681),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(743),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(6095),
    [sym__splat_star] = ACTIONS(6097),
    [sym__unary_minus] = ACTIONS(3179),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(6099),
    [anon_sym_LBRACE] = ACTIONS(2715),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(3183),
    [anon_sym_yield] = ACTIONS(3185),
    [anon_sym_break] = ACTIONS(3187),
    [anon_sym_next] = ACTIONS(3189),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(769),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(769),
    [anon_sym_until] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(769),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(769),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(3191),
    [anon_sym_not] = ACTIONS(3193),
    [anon_sym_BANG] = ACTIONS(3195),
    [anon_sym_TILDE] = ACTIONS(3197),
    [sym_constant] = ACTIONS(6101),
    [sym_identifier] = ACTIONS(6101),
    [sym_instance_variable] = ACTIONS(3201),
    [sym_class_variable] = ACTIONS(3201),
    [sym_global_variable] = ACTIONS(3201),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(3203),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(3203),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [1759] = {
    [sym_heredoc_body] = STATE(4081),
    [aux_sym_call_repeat1] = STATE(4081),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_RBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [1760] = {
    [sym_heredoc_body] = STATE(4081),
    [aux_sym_call_repeat1] = STATE(4081),
    [aux_sym_argument_list_repeat1] = STATE(4083),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_RBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(6769),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [1761] = {
    [anon_sym_EQ] = ACTIONS(6771),
    [sym_comment] = ACTIONS(87),
  },
  [1762] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(6773),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(6775),
    [anon_sym_DASH_EQ] = ACTIONS(6775),
    [anon_sym_STAR_EQ] = ACTIONS(6775),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6775),
    [anon_sym_SLASH_EQ] = ACTIONS(6775),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6775),
    [anon_sym_PIPE_EQ] = ACTIONS(6775),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6775),
    [anon_sym_AMP_EQ] = ACTIONS(6775),
    [anon_sym_PERCENT_EQ] = ACTIONS(6775),
    [anon_sym_GT_GT_EQ] = ACTIONS(6775),
    [anon_sym_LT_LT_EQ] = ACTIONS(6775),
    [anon_sym_CARET_EQ] = ACTIONS(6775),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1763] = {
    [sym_string] = STATE(4086),
    [aux_sym_chained_string_repeat1] = STATE(4086),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(747),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(6777),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1764] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(4091),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(4094),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4094),
    [sym_splat_argument] = STATE(4092),
    [sym_assignment] = STATE(4091),
    [sym_operator_assignment] = STATE(4091),
    [sym_conditional] = STATE(4091),
    [sym_range] = STATE(4091),
    [sym_binary] = STATE(4091),
    [sym_unary] = STATE(4091),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(4092),
    [sym_left_assignment_list] = STATE(4093),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4094),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(4094),
    [sym_false] = STATE(4094),
    [sym_nil] = STATE(4094),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(4010),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(6779),
    [sym__unary_minus] = ACTIONS(6781),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6653),
    [anon_sym_yield] = ACTIONS(6655),
    [anon_sym_break] = ACTIONS(6657),
    [anon_sym_next] = ACTIONS(6659),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6783),
    [anon_sym_defined_QMARK] = ACTIONS(6785),
    [anon_sym_not] = ACTIONS(6787),
    [anon_sym_BANG] = ACTIONS(6789),
    [anon_sym_TILDE] = ACTIONS(6789),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1765] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(4095),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(4095),
    [sym_operator_assignment] = STATE(4095),
    [sym_conditional] = STATE(4095),
    [sym_range] = STATE(4095),
    [sym_binary] = STATE(4095),
    [sym_unary] = STATE(4095),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1766] = {
    [sym_string] = STATE(4096),
    [aux_sym_chained_string_repeat1] = STATE(4096),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_RBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [1767] = {
    [sym_heredoc_body] = STATE(370),
    [sym__terminator] = STATE(370),
    [sym__line_break] = ACTIONS(687),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_RBRACE] = ACTIONS(2757),
    [anon_sym_SEMI] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(3137),
    [anon_sym_unless] = ACTIONS(3139),
    [anon_sym_while] = ACTIONS(3141),
    [anon_sym_until] = ACTIONS(3143),
    [anon_sym_rescue] = ACTIONS(3145),
    [sym_comment] = ACTIONS(87),
  },
  [1768] = {
    [sym_begin_block] = STATE(1611),
    [sym_end_block] = STATE(1611),
    [sym__statement] = STATE(1611),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1611),
    [sym_unless_modifier] = STATE(1611),
    [sym_while_modifier] = STATE(1611),
    [sym_until_modifier] = STATE(1611),
    [sym_rescue_modifier] = STATE(1611),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1612),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1615),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(1615),
    [sym_assignment] = STATE(1612),
    [sym_operator_assignment] = STATE(1612),
    [sym_conditional] = STATE(1612),
    [sym_range] = STATE(1612),
    [sym_binary] = STATE(1612),
    [sym_unary] = STATE(1612),
    [sym_left_assignment_list] = STATE(1614),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1615),
    [sym__variable] = STATE(1613),
    [sym_undef] = STATE(1611),
    [sym_alias] = STATE(1611),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1615),
    [sym_false] = STATE(1615),
    [sym_nil] = STATE(1615),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1616),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1768),
    [aux_sym__statements_repeat1] = STATE(1768),
    [sym__simple_symbol] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(2762),
    [sym__symbol_start] = ACTIONS(2765),
    [sym__subshell_start] = ACTIONS(2768),
    [sym__regex_start] = ACTIONS(2771),
    [sym__string_array_start] = ACTIONS(2774),
    [sym__symbol_array_start] = ACTIONS(2777),
    [sym_heredoc_beginning] = ACTIONS(2780),
    [sym__unary_minus] = ACTIONS(2783),
    [anon_sym_BEGIN] = ACTIONS(2786),
    [anon_sym_LBRACE] = ACTIONS(2789),
    [anon_sym_RBRACE] = ACTIONS(2491),
    [anon_sym_END] = ACTIONS(2792),
    [anon_sym_def] = ACTIONS(2795),
    [anon_sym_LPAREN] = ACTIONS(2798),
    [anon_sym_COLON_COLON] = ACTIONS(2801),
    [anon_sym_SEMI] = ACTIONS(2804),
    [anon_sym_STAR] = ACTIONS(2807),
    [anon_sym_class] = ACTIONS(2810),
    [anon_sym_module] = ACTIONS(2813),
    [anon_sym_return] = ACTIONS(2816),
    [anon_sym_yield] = ACTIONS(2819),
    [anon_sym_break] = ACTIONS(2822),
    [anon_sym_next] = ACTIONS(2825),
    [sym_redo] = ACTIONS(2828),
    [sym_retry] = ACTIONS(2828),
    [anon_sym_if] = ACTIONS(2831),
    [anon_sym_unless] = ACTIONS(2834),
    [anon_sym_while] = ACTIONS(2837),
    [anon_sym_until] = ACTIONS(2840),
    [anon_sym_for] = ACTIONS(2843),
    [anon_sym_case] = ACTIONS(2846),
    [anon_sym_begin] = ACTIONS(2849),
    [anon_sym_PLUS] = ACTIONS(2852),
    [anon_sym_defined_QMARK] = ACTIONS(2855),
    [anon_sym_not] = ACTIONS(2858),
    [anon_sym_BANG] = ACTIONS(2861),
    [anon_sym_TILDE] = ACTIONS(2861),
    [sym_constant] = ACTIONS(2864),
    [sym_identifier] = ACTIONS(2864),
    [sym_instance_variable] = ACTIONS(2867),
    [sym_class_variable] = ACTIONS(2867),
    [sym_global_variable] = ACTIONS(2867),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_alias] = ACTIONS(2873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2876),
    [sym_float] = ACTIONS(2828),
    [sym_complex] = ACTIONS(2780),
    [sym_super] = ACTIONS(2864),
    [anon_sym_true] = ACTIONS(2879),
    [anon_sym_TRUE] = ACTIONS(2879),
    [anon_sym_false] = ACTIONS(2882),
    [anon_sym_FALSE] = ACTIONS(2882),
    [sym_self] = ACTIONS(2864),
    [anon_sym_nil] = ACTIONS(2885),
    [anon_sym_NIL] = ACTIONS(2885),
    [sym_character] = ACTIONS(2780),
    [anon_sym_LBRACK2] = ACTIONS(2888),
    [anon_sym_DASH_GT] = ACTIONS(2891),
  },
  [1769] = {
    [sym__string_start] = ACTIONS(3030),
    [sym__binary_minus] = ACTIONS(3030),
    [sym__binary_star] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3030),
    [anon_sym_RBRACE] = ACTIONS(3030),
    [anon_sym_RPAREN] = ACTIONS(3030),
    [anon_sym_DOT] = ACTIONS(3032),
    [anon_sym_COMMA] = ACTIONS(3030),
    [anon_sym_PIPE] = ACTIONS(3032),
    [anon_sym_SEMI] = ACTIONS(3030),
    [anon_sym_STAR_STAR] = ACTIONS(3030),
    [anon_sym_AMP] = ACTIONS(3032),
    [anon_sym_COLON] = ACTIONS(3032),
    [anon_sym_LT] = ACTIONS(3032),
    [anon_sym_if] = ACTIONS(3030),
    [anon_sym_unless] = ACTIONS(3030),
    [anon_sym_while] = ACTIONS(3030),
    [anon_sym_until] = ACTIONS(3030),
    [anon_sym_rescue] = ACTIONS(3030),
    [anon_sym_do] = ACTIONS(3030),
    [anon_sym_EQ_GT] = ACTIONS(3030),
    [anon_sym_LBRACK] = ACTIONS(3030),
    [anon_sym_COLON_COLON2] = ACTIONS(3030),
    [anon_sym_AMP_DOT] = ACTIONS(3030),
    [anon_sym_QMARK] = ACTIONS(3030),
    [anon_sym_DOT_DOT] = ACTIONS(3032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3030),
    [anon_sym_and] = ACTIONS(3030),
    [anon_sym_or] = ACTIONS(3030),
    [anon_sym_PIPE_PIPE] = ACTIONS(3030),
    [anon_sym_AMP_AMP] = ACTIONS(3030),
    [anon_sym_LT_LT] = ACTIONS(3030),
    [anon_sym_GT_GT] = ACTIONS(3030),
    [anon_sym_EQ_EQ] = ACTIONS(3032),
    [anon_sym_BANG_EQ] = ACTIONS(3030),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3030),
    [anon_sym_LT_EQ_GT] = ACTIONS(3030),
    [anon_sym_EQ_TILDE] = ACTIONS(3030),
    [anon_sym_BANG_TILDE] = ACTIONS(3030),
    [anon_sym_LT_EQ] = ACTIONS(3032),
    [anon_sym_GT] = ACTIONS(3032),
    [anon_sym_GT_EQ] = ACTIONS(3030),
    [anon_sym_CARET] = ACTIONS(3030),
    [anon_sym_PLUS] = ACTIONS(3030),
    [anon_sym_SLASH] = ACTIONS(3030),
    [anon_sym_PERCENT] = ACTIONS(3030),
    [sym_comment] = ACTIONS(87),
  },
  [1770] = {
    [sym__binary_minus] = ACTIONS(3042),
    [sym__binary_star] = ACTIONS(3042),
    [anon_sym_LBRACE] = ACTIONS(3042),
    [anon_sym_RBRACE] = ACTIONS(3042),
    [anon_sym_RPAREN] = ACTIONS(3042),
    [anon_sym_DOT] = ACTIONS(3044),
    [anon_sym_COMMA] = ACTIONS(3042),
    [anon_sym_PIPE] = ACTIONS(3044),
    [anon_sym_SEMI] = ACTIONS(3042),
    [anon_sym_STAR_STAR] = ACTIONS(3042),
    [anon_sym_AMP] = ACTIONS(3044),
    [anon_sym_LT] = ACTIONS(3044),
    [anon_sym_if] = ACTIONS(3042),
    [anon_sym_unless] = ACTIONS(3042),
    [anon_sym_while] = ACTIONS(3042),
    [anon_sym_until] = ACTIONS(3042),
    [anon_sym_rescue] = ACTIONS(3042),
    [anon_sym_do] = ACTIONS(3042),
    [anon_sym_EQ_GT] = ACTIONS(3042),
    [anon_sym_LBRACK] = ACTIONS(3042),
    [anon_sym_COLON_COLON2] = ACTIONS(3042),
    [anon_sym_AMP_DOT] = ACTIONS(3042),
    [anon_sym_QMARK] = ACTIONS(3042),
    [anon_sym_COLON2] = ACTIONS(3044),
    [anon_sym_DOT_DOT] = ACTIONS(3044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3042),
    [anon_sym_and] = ACTIONS(3042),
    [anon_sym_or] = ACTIONS(3042),
    [anon_sym_PIPE_PIPE] = ACTIONS(3042),
    [anon_sym_AMP_AMP] = ACTIONS(3042),
    [anon_sym_LT_LT] = ACTIONS(3042),
    [anon_sym_GT_GT] = ACTIONS(3042),
    [anon_sym_EQ_EQ] = ACTIONS(3044),
    [anon_sym_BANG_EQ] = ACTIONS(3042),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3042),
    [anon_sym_LT_EQ_GT] = ACTIONS(3042),
    [anon_sym_EQ_TILDE] = ACTIONS(3042),
    [anon_sym_BANG_TILDE] = ACTIONS(3042),
    [anon_sym_LT_EQ] = ACTIONS(3044),
    [anon_sym_GT] = ACTIONS(3044),
    [anon_sym_GT_EQ] = ACTIONS(3042),
    [anon_sym_CARET] = ACTIONS(3042),
    [anon_sym_PLUS] = ACTIONS(3042),
    [anon_sym_SLASH] = ACTIONS(3042),
    [anon_sym_PERCENT] = ACTIONS(3042),
    [sym_comment] = ACTIONS(87),
  },
  [1771] = {
    [sym__binary_minus] = ACTIONS(3046),
    [sym__binary_star] = ACTIONS(3046),
    [anon_sym_LBRACE] = ACTIONS(3046),
    [anon_sym_RBRACE] = ACTIONS(3046),
    [anon_sym_RPAREN] = ACTIONS(3046),
    [anon_sym_DOT] = ACTIONS(3048),
    [anon_sym_COMMA] = ACTIONS(3046),
    [anon_sym_PIPE] = ACTIONS(3048),
    [anon_sym_SEMI] = ACTIONS(3046),
    [anon_sym_STAR_STAR] = ACTIONS(3046),
    [anon_sym_AMP] = ACTIONS(3048),
    [anon_sym_LT] = ACTIONS(3048),
    [anon_sym_if] = ACTIONS(3046),
    [anon_sym_unless] = ACTIONS(3046),
    [anon_sym_while] = ACTIONS(3046),
    [anon_sym_until] = ACTIONS(3046),
    [anon_sym_rescue] = ACTIONS(3046),
    [anon_sym_do] = ACTIONS(3046),
    [anon_sym_EQ_GT] = ACTIONS(3046),
    [anon_sym_LBRACK] = ACTIONS(3046),
    [anon_sym_COLON_COLON2] = ACTIONS(3046),
    [anon_sym_AMP_DOT] = ACTIONS(3046),
    [anon_sym_QMARK] = ACTIONS(3046),
    [anon_sym_COLON2] = ACTIONS(3048),
    [anon_sym_DOT_DOT] = ACTIONS(3048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3046),
    [anon_sym_and] = ACTIONS(3046),
    [anon_sym_or] = ACTIONS(3046),
    [anon_sym_PIPE_PIPE] = ACTIONS(3046),
    [anon_sym_AMP_AMP] = ACTIONS(3046),
    [anon_sym_LT_LT] = ACTIONS(3046),
    [anon_sym_GT_GT] = ACTIONS(3046),
    [anon_sym_EQ_EQ] = ACTIONS(3048),
    [anon_sym_BANG_EQ] = ACTIONS(3046),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3046),
    [anon_sym_LT_EQ_GT] = ACTIONS(3046),
    [anon_sym_EQ_TILDE] = ACTIONS(3046),
    [anon_sym_BANG_TILDE] = ACTIONS(3046),
    [anon_sym_LT_EQ] = ACTIONS(3048),
    [anon_sym_GT] = ACTIONS(3048),
    [anon_sym_GT_EQ] = ACTIONS(3046),
    [anon_sym_CARET] = ACTIONS(3046),
    [anon_sym_PLUS] = ACTIONS(3046),
    [anon_sym_SLASH] = ACTIONS(3046),
    [anon_sym_PERCENT] = ACTIONS(3046),
    [sym_comment] = ACTIONS(87),
  },
  [1772] = {
    [sym__binary_minus] = ACTIONS(3050),
    [sym__binary_star] = ACTIONS(3050),
    [anon_sym_LBRACE] = ACTIONS(3050),
    [anon_sym_RBRACE] = ACTIONS(3050),
    [anon_sym_RPAREN] = ACTIONS(3050),
    [anon_sym_DOT] = ACTIONS(3052),
    [anon_sym_COMMA] = ACTIONS(3050),
    [anon_sym_PIPE] = ACTIONS(3052),
    [anon_sym_SEMI] = ACTIONS(3050),
    [anon_sym_STAR_STAR] = ACTIONS(3050),
    [anon_sym_AMP] = ACTIONS(3052),
    [anon_sym_LT] = ACTIONS(3052),
    [anon_sym_if] = ACTIONS(3050),
    [anon_sym_unless] = ACTIONS(3050),
    [anon_sym_while] = ACTIONS(3050),
    [anon_sym_until] = ACTIONS(3050),
    [anon_sym_rescue] = ACTIONS(3050),
    [anon_sym_do] = ACTIONS(3050),
    [anon_sym_EQ_GT] = ACTIONS(3050),
    [anon_sym_LBRACK] = ACTIONS(3050),
    [anon_sym_COLON_COLON2] = ACTIONS(3050),
    [anon_sym_AMP_DOT] = ACTIONS(3050),
    [anon_sym_QMARK] = ACTIONS(3050),
    [anon_sym_COLON2] = ACTIONS(3052),
    [anon_sym_DOT_DOT] = ACTIONS(3052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3050),
    [anon_sym_and] = ACTIONS(3050),
    [anon_sym_or] = ACTIONS(3050),
    [anon_sym_PIPE_PIPE] = ACTIONS(3050),
    [anon_sym_AMP_AMP] = ACTIONS(3050),
    [anon_sym_LT_LT] = ACTIONS(3050),
    [anon_sym_GT_GT] = ACTIONS(3050),
    [anon_sym_EQ_EQ] = ACTIONS(3052),
    [anon_sym_BANG_EQ] = ACTIONS(3050),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3050),
    [anon_sym_LT_EQ_GT] = ACTIONS(3050),
    [anon_sym_EQ_TILDE] = ACTIONS(3050),
    [anon_sym_BANG_TILDE] = ACTIONS(3050),
    [anon_sym_LT_EQ] = ACTIONS(3052),
    [anon_sym_GT] = ACTIONS(3052),
    [anon_sym_GT_EQ] = ACTIONS(3050),
    [anon_sym_CARET] = ACTIONS(3050),
    [anon_sym_PLUS] = ACTIONS(3050),
    [anon_sym_SLASH] = ACTIONS(3050),
    [anon_sym_PERCENT] = ACTIONS(3050),
    [sym_comment] = ACTIONS(87),
  },
  [1773] = {
    [sym__binary_minus] = ACTIONS(3056),
    [sym__binary_star] = ACTIONS(3056),
    [anon_sym_LBRACE] = ACTIONS(3056),
    [anon_sym_RBRACE] = ACTIONS(3056),
    [anon_sym_RPAREN] = ACTIONS(3056),
    [anon_sym_DOT] = ACTIONS(3058),
    [anon_sym_COMMA] = ACTIONS(3056),
    [anon_sym_PIPE] = ACTIONS(3058),
    [anon_sym_SEMI] = ACTIONS(3056),
    [anon_sym_STAR_STAR] = ACTIONS(3056),
    [anon_sym_AMP] = ACTIONS(3058),
    [anon_sym_LT] = ACTIONS(3058),
    [anon_sym_if] = ACTIONS(3056),
    [anon_sym_unless] = ACTIONS(3056),
    [anon_sym_while] = ACTIONS(3056),
    [anon_sym_until] = ACTIONS(3056),
    [anon_sym_rescue] = ACTIONS(3056),
    [anon_sym_do] = ACTIONS(3056),
    [anon_sym_EQ_GT] = ACTIONS(3056),
    [anon_sym_LBRACK] = ACTIONS(3056),
    [anon_sym_COLON_COLON2] = ACTIONS(3056),
    [anon_sym_AMP_DOT] = ACTIONS(3056),
    [anon_sym_QMARK] = ACTIONS(3056),
    [anon_sym_COLON2] = ACTIONS(3058),
    [anon_sym_DOT_DOT] = ACTIONS(3058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3056),
    [anon_sym_and] = ACTIONS(3056),
    [anon_sym_or] = ACTIONS(3056),
    [anon_sym_PIPE_PIPE] = ACTIONS(3056),
    [anon_sym_AMP_AMP] = ACTIONS(3056),
    [anon_sym_LT_LT] = ACTIONS(3056),
    [anon_sym_GT_GT] = ACTIONS(3056),
    [anon_sym_EQ_EQ] = ACTIONS(3058),
    [anon_sym_BANG_EQ] = ACTIONS(3056),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3056),
    [anon_sym_LT_EQ_GT] = ACTIONS(3056),
    [anon_sym_EQ_TILDE] = ACTIONS(3056),
    [anon_sym_BANG_TILDE] = ACTIONS(3056),
    [anon_sym_LT_EQ] = ACTIONS(3058),
    [anon_sym_GT] = ACTIONS(3058),
    [anon_sym_GT_EQ] = ACTIONS(3056),
    [anon_sym_CARET] = ACTIONS(3056),
    [anon_sym_PLUS] = ACTIONS(3056),
    [anon_sym_SLASH] = ACTIONS(3056),
    [anon_sym_PERCENT] = ACTIONS(3056),
    [sym_comment] = ACTIONS(87),
  },
  [1774] = {
    [sym__string_end] = ACTIONS(6791),
    [sym_comment] = ACTIONS(87),
  },
  [1775] = {
    [aux_sym_string_array_repeat1] = STATE(4100),
    [sym__string_end] = ACTIONS(6793),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(6795),
  },
  [1776] = {
    [sym__binary_minus] = ACTIONS(3066),
    [sym__binary_star] = ACTIONS(3066),
    [anon_sym_LBRACE] = ACTIONS(3066),
    [anon_sym_RBRACE] = ACTIONS(3066),
    [anon_sym_RPAREN] = ACTIONS(3066),
    [anon_sym_DOT] = ACTIONS(3068),
    [anon_sym_COMMA] = ACTIONS(3066),
    [anon_sym_PIPE] = ACTIONS(3068),
    [anon_sym_SEMI] = ACTIONS(3066),
    [anon_sym_STAR_STAR] = ACTIONS(3066),
    [anon_sym_AMP] = ACTIONS(3068),
    [anon_sym_LT] = ACTIONS(3068),
    [anon_sym_if] = ACTIONS(3066),
    [anon_sym_unless] = ACTIONS(3066),
    [anon_sym_while] = ACTIONS(3066),
    [anon_sym_until] = ACTIONS(3066),
    [anon_sym_rescue] = ACTIONS(3066),
    [anon_sym_do] = ACTIONS(3066),
    [anon_sym_EQ_GT] = ACTIONS(3066),
    [anon_sym_LBRACK] = ACTIONS(3066),
    [anon_sym_COLON_COLON2] = ACTIONS(3066),
    [anon_sym_AMP_DOT] = ACTIONS(3066),
    [anon_sym_QMARK] = ACTIONS(3066),
    [anon_sym_COLON2] = ACTIONS(3068),
    [anon_sym_DOT_DOT] = ACTIONS(3068),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3066),
    [anon_sym_and] = ACTIONS(3066),
    [anon_sym_or] = ACTIONS(3066),
    [anon_sym_PIPE_PIPE] = ACTIONS(3066),
    [anon_sym_AMP_AMP] = ACTIONS(3066),
    [anon_sym_LT_LT] = ACTIONS(3066),
    [anon_sym_GT_GT] = ACTIONS(3066),
    [anon_sym_EQ_EQ] = ACTIONS(3068),
    [anon_sym_BANG_EQ] = ACTIONS(3066),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3066),
    [anon_sym_LT_EQ_GT] = ACTIONS(3066),
    [anon_sym_EQ_TILDE] = ACTIONS(3066),
    [anon_sym_BANG_TILDE] = ACTIONS(3066),
    [anon_sym_LT_EQ] = ACTIONS(3068),
    [anon_sym_GT] = ACTIONS(3068),
    [anon_sym_GT_EQ] = ACTIONS(3066),
    [anon_sym_CARET] = ACTIONS(3066),
    [anon_sym_PLUS] = ACTIONS(3066),
    [anon_sym_SLASH] = ACTIONS(3066),
    [anon_sym_PERCENT] = ACTIONS(3066),
    [sym_comment] = ACTIONS(87),
  },
  [1777] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1697),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(6797),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [1778] = {
    [aux_sym_string_array_repeat1] = STATE(1699),
    [sym__string_end] = ACTIONS(6797),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(6799),
  },
  [1779] = {
    [sym__binary_minus] = ACTIONS(3085),
    [sym__binary_star] = ACTIONS(3085),
    [anon_sym_LBRACE] = ACTIONS(3085),
    [anon_sym_RBRACE] = ACTIONS(3085),
    [anon_sym_RPAREN] = ACTIONS(3085),
    [anon_sym_DOT] = ACTIONS(3087),
    [anon_sym_COMMA] = ACTIONS(3085),
    [anon_sym_PIPE] = ACTIONS(3087),
    [anon_sym_SEMI] = ACTIONS(3085),
    [anon_sym_STAR_STAR] = ACTIONS(3085),
    [anon_sym_AMP] = ACTIONS(3087),
    [anon_sym_LT] = ACTIONS(3087),
    [anon_sym_if] = ACTIONS(3085),
    [anon_sym_unless] = ACTIONS(3085),
    [anon_sym_while] = ACTIONS(3085),
    [anon_sym_until] = ACTIONS(3085),
    [anon_sym_rescue] = ACTIONS(3085),
    [anon_sym_do] = ACTIONS(3085),
    [anon_sym_EQ_GT] = ACTIONS(3085),
    [anon_sym_LBRACK] = ACTIONS(3085),
    [anon_sym_COLON_COLON2] = ACTIONS(3085),
    [anon_sym_AMP_DOT] = ACTIONS(3085),
    [anon_sym_QMARK] = ACTIONS(3085),
    [anon_sym_COLON2] = ACTIONS(3087),
    [anon_sym_DOT_DOT] = ACTIONS(3087),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3085),
    [anon_sym_and] = ACTIONS(3085),
    [anon_sym_or] = ACTIONS(3085),
    [anon_sym_PIPE_PIPE] = ACTIONS(3085),
    [anon_sym_AMP_AMP] = ACTIONS(3085),
    [anon_sym_LT_LT] = ACTIONS(3085),
    [anon_sym_GT_GT] = ACTIONS(3085),
    [anon_sym_EQ_EQ] = ACTIONS(3087),
    [anon_sym_BANG_EQ] = ACTIONS(3085),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3085),
    [anon_sym_LT_EQ_GT] = ACTIONS(3085),
    [anon_sym_EQ_TILDE] = ACTIONS(3085),
    [anon_sym_BANG_TILDE] = ACTIONS(3085),
    [anon_sym_LT_EQ] = ACTIONS(3087),
    [anon_sym_GT] = ACTIONS(3087),
    [anon_sym_GT_EQ] = ACTIONS(3085),
    [anon_sym_CARET] = ACTIONS(3085),
    [anon_sym_PLUS] = ACTIONS(3085),
    [anon_sym_SLASH] = ACTIONS(3085),
    [anon_sym_PERCENT] = ACTIONS(3085),
    [sym_comment] = ACTIONS(87),
  },
  [1780] = {
    [sym__string_end] = ACTIONS(6801),
    [sym_comment] = ACTIONS(87),
  },
  [1781] = {
    [aux_sym_symbol_array_repeat1] = STATE(4106),
    [sym__string_end] = ACTIONS(6803),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(6805),
  },
  [1782] = {
    [sym__binary_minus] = ACTIONS(3095),
    [sym__binary_star] = ACTIONS(3095),
    [anon_sym_LBRACE] = ACTIONS(3095),
    [anon_sym_RBRACE] = ACTIONS(3095),
    [anon_sym_RPAREN] = ACTIONS(3095),
    [anon_sym_DOT] = ACTIONS(3097),
    [anon_sym_COMMA] = ACTIONS(3095),
    [anon_sym_PIPE] = ACTIONS(3097),
    [anon_sym_SEMI] = ACTIONS(3095),
    [anon_sym_STAR_STAR] = ACTIONS(3095),
    [anon_sym_AMP] = ACTIONS(3097),
    [anon_sym_LT] = ACTIONS(3097),
    [anon_sym_if] = ACTIONS(3095),
    [anon_sym_unless] = ACTIONS(3095),
    [anon_sym_while] = ACTIONS(3095),
    [anon_sym_until] = ACTIONS(3095),
    [anon_sym_rescue] = ACTIONS(3095),
    [anon_sym_do] = ACTIONS(3095),
    [anon_sym_EQ_GT] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3095),
    [anon_sym_COLON_COLON2] = ACTIONS(3095),
    [anon_sym_AMP_DOT] = ACTIONS(3095),
    [anon_sym_QMARK] = ACTIONS(3095),
    [anon_sym_COLON2] = ACTIONS(3097),
    [anon_sym_DOT_DOT] = ACTIONS(3097),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3095),
    [anon_sym_and] = ACTIONS(3095),
    [anon_sym_or] = ACTIONS(3095),
    [anon_sym_PIPE_PIPE] = ACTIONS(3095),
    [anon_sym_AMP_AMP] = ACTIONS(3095),
    [anon_sym_LT_LT] = ACTIONS(3095),
    [anon_sym_GT_GT] = ACTIONS(3095),
    [anon_sym_EQ_EQ] = ACTIONS(3097),
    [anon_sym_BANG_EQ] = ACTIONS(3095),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3095),
    [anon_sym_LT_EQ_GT] = ACTIONS(3095),
    [anon_sym_EQ_TILDE] = ACTIONS(3095),
    [anon_sym_BANG_TILDE] = ACTIONS(3095),
    [anon_sym_LT_EQ] = ACTIONS(3097),
    [anon_sym_GT] = ACTIONS(3097),
    [anon_sym_GT_EQ] = ACTIONS(3095),
    [anon_sym_CARET] = ACTIONS(3095),
    [anon_sym_PLUS] = ACTIONS(3095),
    [anon_sym_SLASH] = ACTIONS(3095),
    [anon_sym_PERCENT] = ACTIONS(3095),
    [sym_comment] = ACTIONS(87),
  },
  [1783] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1705),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(6807),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [1784] = {
    [aux_sym_symbol_array_repeat1] = STATE(1707),
    [sym__string_end] = ACTIONS(6807),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(6809),
  },
  [1785] = {
    [anon_sym_RBRACE] = ACTIONS(6811),
    [anon_sym_if] = ACTIONS(2942),
    [anon_sym_unless] = ACTIONS(2944),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_until] = ACTIONS(2948),
    [anon_sym_rescue] = ACTIONS(2950),
    [sym_comment] = ACTIONS(87),
  },
  [1786] = {
    [anon_sym_RBRACE] = ACTIONS(6813),
    [anon_sym_RPAREN] = ACTIONS(6813),
    [anon_sym_SEMI] = ACTIONS(6813),
    [anon_sym_end] = ACTIONS(6813),
    [anon_sym_when] = ACTIONS(6813),
    [anon_sym_else] = ACTIONS(6813),
    [anon_sym_RBRACK] = ACTIONS(6813),
    [sym_comment] = ACTIONS(87),
  },
  [1787] = {
    [sym_interpolation] = STATE(1787),
    [aux_sym_heredoc_body_repeat1] = STATE(1787),
    [sym__heredoc_content] = ACTIONS(6815),
    [sym_heredoc_end] = ACTIONS(6818),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(6820),
    [sym_escape_sequence] = ACTIONS(6815),
  },
  [1788] = {
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(3283),
    [sym__binary_star] = ACTIONS(3285),
    [anon_sym_RBRACE] = ACTIONS(6823),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(3287),
    [anon_sym_STAR_STAR] = ACTIONS(3285),
    [anon_sym_AMP] = ACTIONS(3289),
    [anon_sym_LT] = ACTIONS(3291),
    [anon_sym_QMARK] = ACTIONS(3293),
    [anon_sym_DOT_DOT] = ACTIONS(3295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3297),
    [anon_sym_and] = ACTIONS(3299),
    [anon_sym_or] = ACTIONS(3299),
    [anon_sym_PIPE_PIPE] = ACTIONS(3301),
    [anon_sym_AMP_AMP] = ACTIONS(3301),
    [anon_sym_LT_LT] = ACTIONS(3303),
    [anon_sym_GT_GT] = ACTIONS(3303),
    [anon_sym_EQ_EQ] = ACTIONS(3305),
    [anon_sym_BANG_EQ] = ACTIONS(3301),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3301),
    [anon_sym_LT_EQ_GT] = ACTIONS(3301),
    [anon_sym_EQ_TILDE] = ACTIONS(3301),
    [anon_sym_BANG_TILDE] = ACTIONS(3301),
    [anon_sym_LT_EQ] = ACTIONS(3291),
    [anon_sym_GT] = ACTIONS(3291),
    [anon_sym_GT_EQ] = ACTIONS(3307),
    [anon_sym_CARET] = ACTIONS(3309),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_SLASH] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [sym_comment] = ACTIONS(87),
  },
  [1789] = {
    [sym__binary_minus] = ACTIONS(3575),
    [sym__binary_star] = ACTIONS(3575),
    [anon_sym_LBRACE] = ACTIONS(3575),
    [anon_sym_RBRACE] = ACTIONS(3575),
    [anon_sym_RPAREN] = ACTIONS(3575),
    [anon_sym_DOT] = ACTIONS(3577),
    [anon_sym_COMMA] = ACTIONS(3575),
    [anon_sym_PIPE] = ACTIONS(3577),
    [anon_sym_SEMI] = ACTIONS(3575),
    [anon_sym_STAR_STAR] = ACTIONS(3575),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_LT] = ACTIONS(3577),
    [anon_sym_if] = ACTIONS(3575),
    [anon_sym_unless] = ACTIONS(3575),
    [anon_sym_while] = ACTIONS(3575),
    [anon_sym_until] = ACTIONS(3575),
    [anon_sym_rescue] = ACTIONS(3575),
    [anon_sym_do] = ACTIONS(3575),
    [anon_sym_EQ_GT] = ACTIONS(3575),
    [anon_sym_LBRACK] = ACTIONS(3575),
    [anon_sym_COLON_COLON2] = ACTIONS(3575),
    [anon_sym_AMP_DOT] = ACTIONS(3575),
    [anon_sym_QMARK] = ACTIONS(3575),
    [anon_sym_COLON2] = ACTIONS(3577),
    [anon_sym_DOT_DOT] = ACTIONS(3577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3575),
    [anon_sym_and] = ACTIONS(3575),
    [anon_sym_or] = ACTIONS(3575),
    [anon_sym_PIPE_PIPE] = ACTIONS(3575),
    [anon_sym_AMP_AMP] = ACTIONS(3575),
    [anon_sym_LT_LT] = ACTIONS(3575),
    [anon_sym_GT_GT] = ACTIONS(3575),
    [anon_sym_EQ_EQ] = ACTIONS(3577),
    [anon_sym_BANG_EQ] = ACTIONS(3575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3575),
    [anon_sym_LT_EQ_GT] = ACTIONS(3575),
    [anon_sym_EQ_TILDE] = ACTIONS(3575),
    [anon_sym_BANG_TILDE] = ACTIONS(3575),
    [anon_sym_LT_EQ] = ACTIONS(3577),
    [anon_sym_GT] = ACTIONS(3577),
    [anon_sym_GT_EQ] = ACTIONS(3575),
    [anon_sym_CARET] = ACTIONS(3575),
    [anon_sym_PLUS] = ACTIONS(3575),
    [anon_sym_SLASH] = ACTIONS(3575),
    [anon_sym_PERCENT] = ACTIONS(3575),
    [sym_comment] = ACTIONS(87),
  },
  [1790] = {
    [anon_sym_RBRACE] = ACTIONS(6825),
    [sym_comment] = ACTIONS(87),
  },
  [1791] = {
    [sym__binary_minus] = ACTIONS(3609),
    [sym__binary_star] = ACTIONS(3611),
    [anon_sym_RPAREN] = ACTIONS(6827),
    [anon_sym_PIPE] = ACTIONS(3615),
    [anon_sym_STAR_STAR] = ACTIONS(3611),
    [anon_sym_AMP] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3619),
    [anon_sym_QMARK] = ACTIONS(3621),
    [anon_sym_DOT_DOT] = ACTIONS(3623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3625),
    [anon_sym_and] = ACTIONS(3627),
    [anon_sym_or] = ACTIONS(3627),
    [anon_sym_PIPE_PIPE] = ACTIONS(3629),
    [anon_sym_AMP_AMP] = ACTIONS(3629),
    [anon_sym_LT_LT] = ACTIONS(3631),
    [anon_sym_GT_GT] = ACTIONS(3631),
    [anon_sym_EQ_EQ] = ACTIONS(3633),
    [anon_sym_BANG_EQ] = ACTIONS(3629),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3629),
    [anon_sym_LT_EQ_GT] = ACTIONS(3629),
    [anon_sym_EQ_TILDE] = ACTIONS(3629),
    [anon_sym_BANG_TILDE] = ACTIONS(3629),
    [anon_sym_LT_EQ] = ACTIONS(3619),
    [anon_sym_GT] = ACTIONS(3619),
    [anon_sym_GT_EQ] = ACTIONS(3635),
    [anon_sym_CARET] = ACTIONS(3637),
    [anon_sym_PLUS] = ACTIONS(3609),
    [anon_sym_SLASH] = ACTIONS(3611),
    [anon_sym_PERCENT] = ACTIONS(3611),
    [sym_comment] = ACTIONS(87),
  },
  [1792] = {
    [sym__method_rest] = STATE(4112),
    [sym_operator] = STATE(522),
    [sym__method_name] = STATE(522),
    [sym_setter] = STATE(522),
    [sym_symbol] = STATE(522),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(6829),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(6829),
    [sym_class_variable] = ACTIONS(6829),
    [sym_global_variable] = ACTIONS(6829),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [1793] = {
    [sym__statements] = STATE(579),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(580),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(581),
    [sym_rescue] = STATE(582),
    [sym__body_statement] = STATE(4113),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(6831),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1794] = {
    [sym__binary_minus] = ACTIONS(3805),
    [sym__binary_star] = ACTIONS(3805),
    [anon_sym_LBRACE] = ACTIONS(3805),
    [anon_sym_RBRACE] = ACTIONS(3805),
    [anon_sym_RPAREN] = ACTIONS(3805),
    [anon_sym_DOT] = ACTIONS(3807),
    [anon_sym_COMMA] = ACTIONS(3805),
    [anon_sym_PIPE] = ACTIONS(3807),
    [anon_sym_SEMI] = ACTIONS(3805),
    [anon_sym_STAR_STAR] = ACTIONS(3805),
    [anon_sym_AMP] = ACTIONS(3807),
    [anon_sym_LT] = ACTIONS(3807),
    [anon_sym_if] = ACTIONS(3805),
    [anon_sym_unless] = ACTIONS(3805),
    [anon_sym_while] = ACTIONS(3805),
    [anon_sym_until] = ACTIONS(3805),
    [anon_sym_rescue] = ACTIONS(3805),
    [anon_sym_do] = ACTIONS(3805),
    [anon_sym_EQ_GT] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(3805),
    [anon_sym_COLON_COLON2] = ACTIONS(3805),
    [anon_sym_AMP_DOT] = ACTIONS(3805),
    [anon_sym_QMARK] = ACTIONS(3805),
    [anon_sym_COLON2] = ACTIONS(3807),
    [anon_sym_DOT_DOT] = ACTIONS(3807),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3805),
    [anon_sym_and] = ACTIONS(3805),
    [anon_sym_or] = ACTIONS(3805),
    [anon_sym_PIPE_PIPE] = ACTIONS(3805),
    [anon_sym_AMP_AMP] = ACTIONS(3805),
    [anon_sym_LT_LT] = ACTIONS(3805),
    [anon_sym_GT_GT] = ACTIONS(3805),
    [anon_sym_EQ_EQ] = ACTIONS(3807),
    [anon_sym_BANG_EQ] = ACTIONS(3805),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3805),
    [anon_sym_LT_EQ_GT] = ACTIONS(3805),
    [anon_sym_EQ_TILDE] = ACTIONS(3805),
    [anon_sym_BANG_TILDE] = ACTIONS(3805),
    [anon_sym_LT_EQ] = ACTIONS(3807),
    [anon_sym_GT] = ACTIONS(3807),
    [anon_sym_GT_EQ] = ACTIONS(3805),
    [anon_sym_CARET] = ACTIONS(3805),
    [anon_sym_PLUS] = ACTIONS(3805),
    [anon_sym_SLASH] = ACTIONS(3805),
    [anon_sym_PERCENT] = ACTIONS(3805),
    [sym_comment] = ACTIONS(87),
  },
  [1795] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(3285),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [1796] = {
    [sym__simple_symbol] = ACTIONS(1411),
    [sym__string_start] = ACTIONS(1411),
    [sym__symbol_start] = ACTIONS(1411),
    [sym__subshell_start] = ACTIONS(1411),
    [sym__regex_start] = ACTIONS(1411),
    [sym__string_array_start] = ACTIONS(1411),
    [sym__symbol_array_start] = ACTIONS(1411),
    [sym__heredoc_body_start] = ACTIONS(1411),
    [sym_heredoc_beginning] = ACTIONS(1411),
    [sym__block_ampersand] = ACTIONS(1411),
    [sym__splat_star] = ACTIONS(1411),
    [sym__unary_minus] = ACTIONS(1411),
    [sym__binary_minus] = ACTIONS(1411),
    [sym__binary_star] = ACTIONS(1411),
    [sym__identifier_hash_key] = ACTIONS(1411),
    [anon_sym_LBRACE] = ACTIONS(1411),
    [anon_sym_RBRACE] = ACTIONS(1411),
    [anon_sym_def] = ACTIONS(1413),
    [anon_sym_LPAREN] = ACTIONS(1413),
    [anon_sym_RPAREN] = ACTIONS(1411),
    [anon_sym_DOT] = ACTIONS(1413),
    [anon_sym_COLON_COLON] = ACTIONS(1413),
    [anon_sym_COMMA] = ACTIONS(1411),
    [anon_sym_PIPE] = ACTIONS(1413),
    [anon_sym_SEMI] = ACTIONS(1411),
    [anon_sym_STAR] = ACTIONS(1413),
    [anon_sym_STAR_STAR] = ACTIONS(1413),
    [anon_sym_AMP] = ACTIONS(1413),
    [anon_sym_EQ] = ACTIONS(1413),
    [anon_sym_class] = ACTIONS(1413),
    [anon_sym_LT] = ACTIONS(1413),
    [anon_sym_module] = ACTIONS(1413),
    [anon_sym_return] = ACTIONS(1413),
    [anon_sym_yield] = ACTIONS(1413),
    [anon_sym_break] = ACTIONS(1413),
    [anon_sym_next] = ACTIONS(1413),
    [sym_redo] = ACTIONS(1413),
    [sym_retry] = ACTIONS(1413),
    [anon_sym_if] = ACTIONS(1413),
    [anon_sym_unless] = ACTIONS(1413),
    [anon_sym_while] = ACTIONS(1413),
    [anon_sym_until] = ACTIONS(1413),
    [anon_sym_rescue] = ACTIONS(1413),
    [anon_sym_for] = ACTIONS(1413),
    [anon_sym_in] = ACTIONS(1413),
    [anon_sym_do] = ACTIONS(1413),
    [anon_sym_case] = ACTIONS(1413),
    [anon_sym_begin] = ACTIONS(1413),
    [anon_sym_LBRACK] = ACTIONS(1411),
    [anon_sym_RBRACK] = ACTIONS(1411),
    [anon_sym_COLON_COLON2] = ACTIONS(1411),
    [anon_sym_AMP_DOT] = ACTIONS(1411),
    [anon_sym_LPAREN2] = ACTIONS(1411),
    [anon_sym_PLUS_EQ] = ACTIONS(1411),
    [anon_sym_DASH_EQ] = ACTIONS(1411),
    [anon_sym_STAR_EQ] = ACTIONS(1411),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1411),
    [anon_sym_SLASH_EQ] = ACTIONS(1411),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1411),
    [anon_sym_PIPE_EQ] = ACTIONS(1411),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1411),
    [anon_sym_AMP_EQ] = ACTIONS(1411),
    [anon_sym_PERCENT_EQ] = ACTIONS(1411),
    [anon_sym_GT_GT_EQ] = ACTIONS(1411),
    [anon_sym_LT_LT_EQ] = ACTIONS(1411),
    [anon_sym_CARET_EQ] = ACTIONS(1411),
    [anon_sym_QMARK] = ACTIONS(1413),
    [anon_sym_COLON2] = ACTIONS(1413),
    [anon_sym_DOT_DOT] = ACTIONS(1413),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1411),
    [anon_sym_and] = ACTIONS(1413),
    [anon_sym_or] = ACTIONS(1413),
    [anon_sym_PIPE_PIPE] = ACTIONS(1413),
    [anon_sym_AMP_AMP] = ACTIONS(1413),
    [anon_sym_LT_LT] = ACTIONS(1413),
    [anon_sym_GT_GT] = ACTIONS(1413),
    [anon_sym_EQ_EQ] = ACTIONS(1413),
    [anon_sym_BANG_EQ] = ACTIONS(1411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1411),
    [anon_sym_LT_EQ_GT] = ACTIONS(1411),
    [anon_sym_EQ_TILDE] = ACTIONS(1411),
    [anon_sym_BANG_TILDE] = ACTIONS(1411),
    [anon_sym_LT_EQ] = ACTIONS(1413),
    [anon_sym_GT] = ACTIONS(1413),
    [anon_sym_GT_EQ] = ACTIONS(1411),
    [anon_sym_CARET] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_SLASH] = ACTIONS(1413),
    [anon_sym_PERCENT] = ACTIONS(1413),
    [anon_sym_defined_QMARK] = ACTIONS(1411),
    [anon_sym_not] = ACTIONS(1413),
    [anon_sym_BANG] = ACTIONS(1413),
    [anon_sym_TILDE] = ACTIONS(1411),
    [sym_constant] = ACTIONS(1413),
    [sym_identifier] = ACTIONS(1413),
    [sym_instance_variable] = ACTIONS(1411),
    [sym_class_variable] = ACTIONS(1411),
    [sym_global_variable] = ACTIONS(1411),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1413),
    [sym_float] = ACTIONS(1413),
    [sym_complex] = ACTIONS(1411),
    [sym_super] = ACTIONS(1413),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_TRUE] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_FALSE] = ACTIONS(1413),
    [sym_self] = ACTIONS(1413),
    [anon_sym_nil] = ACTIONS(1413),
    [anon_sym_NIL] = ACTIONS(1413),
    [sym_character] = ACTIONS(1411),
    [anon_sym_LBRACK2] = ACTIONS(1413),
    [anon_sym_DASH_GT] = ACTIONS(1411),
  },
  [1797] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(4117),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4119),
    [sym_scope_resolution] = STATE(539),
    [sym_call] = STATE(539),
    [sym_method_call] = STATE(4119),
    [sym_assignment] = STATE(4117),
    [sym_operator_assignment] = STATE(4117),
    [sym_conditional] = STATE(4117),
    [sym_range] = STATE(4117),
    [sym_binary] = STATE(4117),
    [sym_unary] = STATE(4117),
    [sym_left_assignment_list] = STATE(4118),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4119),
    [sym__variable] = STATE(539),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4119),
    [sym_false] = STATE(4119),
    [sym_nil] = STATE(4119),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(542),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6833),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6835),
    [anon_sym_defined_QMARK] = ACTIONS(6837),
    [anon_sym_not] = ACTIONS(6839),
    [anon_sym_BANG] = ACTIONS(6841),
    [anon_sym_TILDE] = ACTIONS(6841),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1798] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(4120),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4119),
    [sym_scope_resolution] = STATE(539),
    [sym_call] = STATE(539),
    [sym_method_call] = STATE(4119),
    [sym_assignment] = STATE(4120),
    [sym_operator_assignment] = STATE(4120),
    [sym_conditional] = STATE(4120),
    [sym_range] = STATE(4120),
    [sym_binary] = STATE(4120),
    [sym_unary] = STATE(4120),
    [sym_left_assignment_list] = STATE(4118),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4119),
    [sym__variable] = STATE(539),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4119),
    [sym_false] = STATE(4119),
    [sym_nil] = STATE(4119),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(542),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6833),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6835),
    [anon_sym_defined_QMARK] = ACTIONS(6837),
    [anon_sym_not] = ACTIONS(6839),
    [anon_sym_BANG] = ACTIONS(6841),
    [anon_sym_TILDE] = ACTIONS(6841),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1799] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4121),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1814),
    [sym_scope_resolution] = STATE(1810),
    [sym_call] = STATE(1810),
    [sym_method_call] = STATE(1814),
    [sym_assignment] = STATE(4121),
    [sym_operator_assignment] = STATE(4121),
    [sym_conditional] = STATE(4121),
    [sym_range] = STATE(4121),
    [sym_binary] = STATE(4121),
    [sym_unary] = STATE(4121),
    [sym_left_assignment_list] = STATE(1813),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1814),
    [sym__variable] = STATE(1810),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1814),
    [sym_false] = STATE(1814),
    [sym_nil] = STATE(1814),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4122),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_break] = ACTIONS(3263),
    [anon_sym_next] = ACTIONS(3265),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6843),
    [anon_sym_defined_QMARK] = ACTIONS(3267),
    [anon_sym_not] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3273),
    [anon_sym_TILDE] = ACTIONS(3273),
    [sym_constant] = ACTIONS(3279),
    [sym_identifier] = ACTIONS(3279),
    [sym_instance_variable] = ACTIONS(3277),
    [sym_class_variable] = ACTIONS(3277),
    [sym_global_variable] = ACTIONS(3277),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3279),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3279),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1800] = {
    [anon_sym_COLON] = ACTIONS(6845),
    [sym_comment] = ACTIONS(87),
  },
  [1801] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(4124),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4119),
    [sym_scope_resolution] = STATE(539),
    [sym_call] = STATE(539),
    [sym_method_call] = STATE(4119),
    [sym_assignment] = STATE(4124),
    [sym_operator_assignment] = STATE(4124),
    [sym_conditional] = STATE(4124),
    [sym_range] = STATE(4124),
    [sym_binary] = STATE(4124),
    [sym_unary] = STATE(4124),
    [sym_left_assignment_list] = STATE(4118),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4119),
    [sym__variable] = STATE(539),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4119),
    [sym_false] = STATE(4119),
    [sym_nil] = STATE(4119),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(542),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6833),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6835),
    [anon_sym_defined_QMARK] = ACTIONS(6837),
    [anon_sym_not] = ACTIONS(6839),
    [anon_sym_BANG] = ACTIONS(6841),
    [anon_sym_TILDE] = ACTIONS(6841),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1802] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4130),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1814),
    [sym_scope_resolution] = STATE(1810),
    [sym_call] = STATE(1810),
    [sym_method_call] = STATE(1814),
    [sym_argument_list] = STATE(1318),
    [sym__argument_list_with_parens] = STATE(4131),
    [sym__argument] = STATE(4132),
    [sym_splat_argument] = STATE(4132),
    [sym_hash_splat_argument] = STATE(4132),
    [sym_block_argument] = STATE(4132),
    [sym_assignment] = STATE(4130),
    [sym_operator_assignment] = STATE(4130),
    [sym_conditional] = STATE(4130),
    [sym_range] = STATE(4130),
    [sym_binary] = STATE(4130),
    [sym_unary] = STATE(4130),
    [sym_left_assignment_list] = STATE(1813),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1814),
    [sym__variable] = STATE(1810),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1814),
    [sym_false] = STATE(1814),
    [sym_nil] = STATE(1814),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4133),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(4132),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(6847),
    [sym__splat_star] = ACTIONS(6849),
    [sym__unary_minus] = ACTIONS(3255),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(6851),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_break] = ACTIONS(3263),
    [anon_sym_next] = ACTIONS(3265),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(3267),
    [anon_sym_not] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3271),
    [anon_sym_TILDE] = ACTIONS(3273),
    [sym_constant] = ACTIONS(6853),
    [sym_identifier] = ACTIONS(6853),
    [sym_instance_variable] = ACTIONS(3277),
    [sym_class_variable] = ACTIONS(3277),
    [sym_global_variable] = ACTIONS(3277),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3279),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3279),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1803] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4130),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1814),
    [sym_scope_resolution] = STATE(1810),
    [sym_call] = STATE(1810),
    [sym_method_call] = STATE(1814),
    [sym_argument_list] = STATE(1324),
    [sym__argument_list_with_parens] = STATE(4131),
    [sym__argument] = STATE(4132),
    [sym_splat_argument] = STATE(4132),
    [sym_hash_splat_argument] = STATE(4132),
    [sym_block_argument] = STATE(4132),
    [sym_assignment] = STATE(4130),
    [sym_operator_assignment] = STATE(4130),
    [sym_conditional] = STATE(4130),
    [sym_range] = STATE(4130),
    [sym_binary] = STATE(4130),
    [sym_unary] = STATE(4130),
    [sym_left_assignment_list] = STATE(1813),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1814),
    [sym__variable] = STATE(1810),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1814),
    [sym_false] = STATE(1814),
    [sym_nil] = STATE(1814),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4133),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(4132),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(6847),
    [sym__splat_star] = ACTIONS(6849),
    [sym__unary_minus] = ACTIONS(3255),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(6851),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_break] = ACTIONS(3263),
    [anon_sym_next] = ACTIONS(3265),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(3267),
    [anon_sym_not] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3271),
    [anon_sym_TILDE] = ACTIONS(3273),
    [sym_constant] = ACTIONS(6853),
    [sym_identifier] = ACTIONS(6853),
    [sym_instance_variable] = ACTIONS(3277),
    [sym_class_variable] = ACTIONS(3277),
    [sym_global_variable] = ACTIONS(3277),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3279),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3279),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1804] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4130),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1814),
    [sym_scope_resolution] = STATE(1810),
    [sym_call] = STATE(1810),
    [sym_method_call] = STATE(1814),
    [sym_argument_list] = STATE(1325),
    [sym__argument_list_with_parens] = STATE(4131),
    [sym__argument] = STATE(4132),
    [sym_splat_argument] = STATE(4132),
    [sym_hash_splat_argument] = STATE(4132),
    [sym_block_argument] = STATE(4132),
    [sym_assignment] = STATE(4130),
    [sym_operator_assignment] = STATE(4130),
    [sym_conditional] = STATE(4130),
    [sym_range] = STATE(4130),
    [sym_binary] = STATE(4130),
    [sym_unary] = STATE(4130),
    [sym_left_assignment_list] = STATE(1813),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1814),
    [sym__variable] = STATE(1810),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1814),
    [sym_false] = STATE(1814),
    [sym_nil] = STATE(1814),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4133),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(4132),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(6847),
    [sym__splat_star] = ACTIONS(6849),
    [sym__unary_minus] = ACTIONS(3255),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(6851),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_break] = ACTIONS(3263),
    [anon_sym_next] = ACTIONS(3265),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(3267),
    [anon_sym_not] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3271),
    [anon_sym_TILDE] = ACTIONS(3273),
    [sym_constant] = ACTIONS(6853),
    [sym_identifier] = ACTIONS(6853),
    [sym_instance_variable] = ACTIONS(3277),
    [sym_class_variable] = ACTIONS(3277),
    [sym_global_variable] = ACTIONS(3277),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3279),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3279),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1805] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4130),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1814),
    [sym_scope_resolution] = STATE(1810),
    [sym_call] = STATE(1810),
    [sym_method_call] = STATE(1814),
    [sym_argument_list] = STATE(1326),
    [sym__argument_list_with_parens] = STATE(4131),
    [sym__argument] = STATE(4132),
    [sym_splat_argument] = STATE(4132),
    [sym_hash_splat_argument] = STATE(4132),
    [sym_block_argument] = STATE(4132),
    [sym_assignment] = STATE(4130),
    [sym_operator_assignment] = STATE(4130),
    [sym_conditional] = STATE(4130),
    [sym_range] = STATE(4130),
    [sym_binary] = STATE(4130),
    [sym_unary] = STATE(4130),
    [sym_left_assignment_list] = STATE(1813),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1814),
    [sym__variable] = STATE(1810),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1814),
    [sym_false] = STATE(1814),
    [sym_nil] = STATE(1814),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4133),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(4132),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(6847),
    [sym__splat_star] = ACTIONS(6849),
    [sym__unary_minus] = ACTIONS(3255),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(6851),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_break] = ACTIONS(3263),
    [anon_sym_next] = ACTIONS(3265),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(3267),
    [anon_sym_not] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3271),
    [anon_sym_TILDE] = ACTIONS(3273),
    [sym_constant] = ACTIONS(6853),
    [sym_identifier] = ACTIONS(6853),
    [sym_instance_variable] = ACTIONS(3277),
    [sym_class_variable] = ACTIONS(3277),
    [sym_global_variable] = ACTIONS(3277),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3279),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3279),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1806] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4134),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1814),
    [sym_scope_resolution] = STATE(1810),
    [sym_call] = STATE(1810),
    [sym_method_call] = STATE(1814),
    [sym_assignment] = STATE(4134),
    [sym_operator_assignment] = STATE(4134),
    [sym_conditional] = STATE(4134),
    [sym_range] = STATE(4134),
    [sym_binary] = STATE(4134),
    [sym_unary] = STATE(4134),
    [sym_left_assignment_list] = STATE(1813),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1814),
    [sym__variable] = STATE(1810),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1814),
    [sym_false] = STATE(1814),
    [sym_nil] = STATE(1814),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4122),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_break] = ACTIONS(3263),
    [anon_sym_next] = ACTIONS(3265),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6843),
    [anon_sym_defined_QMARK] = ACTIONS(3267),
    [anon_sym_not] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3273),
    [anon_sym_TILDE] = ACTIONS(3273),
    [sym_constant] = ACTIONS(3279),
    [sym_identifier] = ACTIONS(3279),
    [sym_instance_variable] = ACTIONS(3277),
    [sym_class_variable] = ACTIONS(3277),
    [sym_global_variable] = ACTIONS(3277),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3279),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3279),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1807] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(1872),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1814),
    [sym_scope_resolution] = STATE(1810),
    [sym_call] = STATE(1810),
    [sym_method_call] = STATE(1814),
    [sym_assignment] = STATE(1872),
    [sym_operator_assignment] = STATE(1872),
    [sym_conditional] = STATE(1872),
    [sym_range] = STATE(1872),
    [sym_binary] = STATE(1872),
    [sym_unary] = STATE(1872),
    [sym_left_assignment_list] = STATE(1813),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1814),
    [sym__variable] = STATE(1810),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1814),
    [sym_false] = STATE(1814),
    [sym_nil] = STATE(1814),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4122),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_break] = ACTIONS(3263),
    [anon_sym_next] = ACTIONS(3265),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6843),
    [anon_sym_defined_QMARK] = ACTIONS(3267),
    [anon_sym_not] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3273),
    [anon_sym_TILDE] = ACTIONS(3273),
    [sym_constant] = ACTIONS(3279),
    [sym_identifier] = ACTIONS(3279),
    [sym_instance_variable] = ACTIONS(3277),
    [sym_class_variable] = ACTIONS(3277),
    [sym_global_variable] = ACTIONS(3277),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3279),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3279),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1808] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(6855),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [1809] = {
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(6857),
    [sym__binary_star] = ACTIONS(6859),
    [anon_sym_RBRACE] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(6861),
    [anon_sym_STAR_STAR] = ACTIONS(6859),
    [anon_sym_AMP] = ACTIONS(6863),
    [anon_sym_LT] = ACTIONS(6865),
    [anon_sym_EQ_GT] = ACTIONS(6845),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(6867),
    [anon_sym_DOT_DOT] = ACTIONS(6869),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6871),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(6873),
    [anon_sym_AMP_AMP] = ACTIONS(6873),
    [anon_sym_LT_LT] = ACTIONS(6875),
    [anon_sym_GT_GT] = ACTIONS(6875),
    [anon_sym_EQ_EQ] = ACTIONS(6877),
    [anon_sym_BANG_EQ] = ACTIONS(6873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6873),
    [anon_sym_LT_EQ_GT] = ACTIONS(6873),
    [anon_sym_EQ_TILDE] = ACTIONS(6873),
    [anon_sym_BANG_TILDE] = ACTIONS(6873),
    [anon_sym_LT_EQ] = ACTIONS(6865),
    [anon_sym_GT] = ACTIONS(6865),
    [anon_sym_GT_EQ] = ACTIONS(6879),
    [anon_sym_CARET] = ACTIONS(6881),
    [anon_sym_PLUS] = ACTIONS(6857),
    [anon_sym_SLASH] = ACTIONS(6859),
    [anon_sym_PERCENT] = ACTIONS(6859),
    [sym_comment] = ACTIONS(87),
  },
  [1810] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4151),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1851),
    [sym_scope_resolution] = STATE(1845),
    [sym_call] = STATE(1845),
    [sym_method_call] = STATE(1851),
    [sym_argument_list] = STATE(1379),
    [sym__argument_list_with_parens] = STATE(4152),
    [sym__argument] = STATE(4153),
    [sym_splat_argument] = STATE(4153),
    [sym_hash_splat_argument] = STATE(4153),
    [sym_block_argument] = STATE(4153),
    [sym_do_block] = STATE(1382),
    [sym_block] = STATE(1382),
    [sym_assignment] = STATE(4151),
    [sym_operator_assignment] = STATE(4151),
    [sym_conditional] = STATE(4151),
    [sym_range] = STATE(4151),
    [sym_binary] = STATE(4151),
    [sym_unary] = STATE(4151),
    [sym_left_assignment_list] = STATE(1850),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1851),
    [sym__variable] = STATE(1845),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1851),
    [sym_false] = STATE(1851),
    [sym_nil] = STATE(1851),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4154),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(4153),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(6883),
    [sym__splat_star] = ACTIONS(6885),
    [sym__unary_minus] = ACTIONS(3323),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(6887),
    [anon_sym_LBRACE] = ACTIONS(2403),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3329),
    [anon_sym_yield] = ACTIONS(3331),
    [anon_sym_break] = ACTIONS(3333),
    [anon_sym_next] = ACTIONS(3335),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(2413),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(3339),
    [anon_sym_not] = ACTIONS(3341),
    [anon_sym_BANG] = ACTIONS(3343),
    [anon_sym_TILDE] = ACTIONS(3345),
    [sym_constant] = ACTIONS(6889),
    [sym_identifier] = ACTIONS(6889),
    [sym_instance_variable] = ACTIONS(3349),
    [sym_class_variable] = ACTIONS(3349),
    [sym_global_variable] = ACTIONS(3349),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3351),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3351),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1811] = {
    [sym_heredoc_body] = STATE(4155),
    [aux_sym_call_repeat1] = STATE(4155),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_RBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [1812] = {
    [sym_heredoc_body] = STATE(4155),
    [aux_sym_call_repeat1] = STATE(4155),
    [aux_sym_argument_list_repeat1] = STATE(4157),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_RBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(6891),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [1813] = {
    [anon_sym_EQ] = ACTIONS(6893),
    [sym_comment] = ACTIONS(87),
  },
  [1814] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(6895),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(6897),
    [anon_sym_DASH_EQ] = ACTIONS(6897),
    [anon_sym_STAR_EQ] = ACTIONS(6897),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6897),
    [anon_sym_SLASH_EQ] = ACTIONS(6897),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6897),
    [anon_sym_PIPE_EQ] = ACTIONS(6897),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6897),
    [anon_sym_AMP_EQ] = ACTIONS(6897),
    [anon_sym_PERCENT_EQ] = ACTIONS(6897),
    [anon_sym_GT_GT_EQ] = ACTIONS(6897),
    [anon_sym_LT_LT_EQ] = ACTIONS(6897),
    [anon_sym_CARET_EQ] = ACTIONS(6897),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1815] = {
    [sym_string] = STATE(4160),
    [aux_sym_chained_string_repeat1] = STATE(4160),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(6899),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [1816] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(3283),
    [sym__binary_star] = ACTIONS(3285),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(3287),
    [anon_sym_STAR_STAR] = ACTIONS(3285),
    [anon_sym_AMP] = ACTIONS(3289),
    [anon_sym_LT] = ACTIONS(3291),
    [anon_sym_QMARK] = ACTIONS(3293),
    [anon_sym_DOT_DOT] = ACTIONS(3295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3297),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(3301),
    [anon_sym_AMP_AMP] = ACTIONS(3301),
    [anon_sym_LT_LT] = ACTIONS(3303),
    [anon_sym_GT_GT] = ACTIONS(3303),
    [anon_sym_EQ_EQ] = ACTIONS(3305),
    [anon_sym_BANG_EQ] = ACTIONS(3301),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3301),
    [anon_sym_LT_EQ_GT] = ACTIONS(3301),
    [anon_sym_EQ_TILDE] = ACTIONS(3301),
    [anon_sym_BANG_TILDE] = ACTIONS(3301),
    [anon_sym_LT_EQ] = ACTIONS(3291),
    [anon_sym_GT] = ACTIONS(3291),
    [anon_sym_GT_EQ] = ACTIONS(3307),
    [anon_sym_CARET] = ACTIONS(3309),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_SLASH] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [sym_comment] = ACTIONS(87),
  },
  [1817] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(4161),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(541),
    [sym_scope_resolution] = STATE(539),
    [sym_call] = STATE(539),
    [sym_method_call] = STATE(541),
    [sym_assignment] = STATE(4161),
    [sym_operator_assignment] = STATE(4161),
    [sym_conditional] = STATE(4161),
    [sym_range] = STATE(4161),
    [sym_binary] = STATE(4161),
    [sym_unary] = STATE(4161),
    [sym_left_assignment_list] = STATE(540),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(541),
    [sym__variable] = STATE(539),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(541),
    [sym_false] = STATE(541),
    [sym_nil] = STATE(541),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(542),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1021),
    [anon_sym_defined_QMARK] = ACTIONS(1023),
    [anon_sym_not] = ACTIONS(1025),
    [anon_sym_BANG] = ACTIONS(1027),
    [anon_sym_TILDE] = ACTIONS(1027),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1818] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(4162),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(541),
    [sym_scope_resolution] = STATE(539),
    [sym_call] = STATE(539),
    [sym_method_call] = STATE(541),
    [sym_assignment] = STATE(4162),
    [sym_operator_assignment] = STATE(4162),
    [sym_conditional] = STATE(4162),
    [sym_range] = STATE(4162),
    [sym_binary] = STATE(4162),
    [sym_unary] = STATE(4162),
    [sym_left_assignment_list] = STATE(540),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(541),
    [sym__variable] = STATE(539),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(541),
    [sym_false] = STATE(541),
    [sym_nil] = STATE(541),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(542),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1021),
    [anon_sym_defined_QMARK] = ACTIONS(1023),
    [anon_sym_not] = ACTIONS(1025),
    [anon_sym_BANG] = ACTIONS(1027),
    [anon_sym_TILDE] = ACTIONS(1027),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1819] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(4163),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(541),
    [sym_scope_resolution] = STATE(539),
    [sym_call] = STATE(539),
    [sym_method_call] = STATE(541),
    [sym_assignment] = STATE(4163),
    [sym_operator_assignment] = STATE(4163),
    [sym_conditional] = STATE(4163),
    [sym_range] = STATE(4163),
    [sym_binary] = STATE(4163),
    [sym_unary] = STATE(4163),
    [sym_left_assignment_list] = STATE(540),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(541),
    [sym__variable] = STATE(539),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(541),
    [sym_false] = STATE(541),
    [sym_nil] = STATE(541),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(542),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1021),
    [anon_sym_defined_QMARK] = ACTIONS(1023),
    [anon_sym_not] = ACTIONS(1025),
    [anon_sym_BANG] = ACTIONS(1027),
    [anon_sym_TILDE] = ACTIONS(1027),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1820] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(4164),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(541),
    [sym_scope_resolution] = STATE(539),
    [sym_call] = STATE(539),
    [sym_method_call] = STATE(541),
    [sym_assignment] = STATE(4164),
    [sym_operator_assignment] = STATE(4164),
    [sym_conditional] = STATE(4164),
    [sym_range] = STATE(4164),
    [sym_binary] = STATE(4164),
    [sym_unary] = STATE(4164),
    [sym_left_assignment_list] = STATE(540),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(541),
    [sym__variable] = STATE(539),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(541),
    [sym_false] = STATE(541),
    [sym_nil] = STATE(541),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(542),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1021),
    [anon_sym_defined_QMARK] = ACTIONS(1023),
    [anon_sym_not] = ACTIONS(1025),
    [anon_sym_BANG] = ACTIONS(1027),
    [anon_sym_TILDE] = ACTIONS(1027),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1821] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(4165),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(541),
    [sym_scope_resolution] = STATE(539),
    [sym_call] = STATE(539),
    [sym_method_call] = STATE(541),
    [sym_assignment] = STATE(4165),
    [sym_operator_assignment] = STATE(4165),
    [sym_conditional] = STATE(4165),
    [sym_range] = STATE(4165),
    [sym_binary] = STATE(4165),
    [sym_unary] = STATE(4165),
    [sym_left_assignment_list] = STATE(540),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(541),
    [sym__variable] = STATE(539),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(541),
    [sym_false] = STATE(541),
    [sym_nil] = STATE(541),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(542),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1021),
    [anon_sym_defined_QMARK] = ACTIONS(1023),
    [anon_sym_not] = ACTIONS(1025),
    [anon_sym_BANG] = ACTIONS(1027),
    [anon_sym_TILDE] = ACTIONS(1027),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1822] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(4166),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(4166),
    [sym_operator_assignment] = STATE(4166),
    [sym_conditional] = STATE(4166),
    [sym_range] = STATE(4166),
    [sym_binary] = STATE(4166),
    [sym_unary] = STATE(4166),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1823] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(4167),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(541),
    [sym_scope_resolution] = STATE(539),
    [sym_call] = STATE(539),
    [sym_method_call] = STATE(541),
    [sym_assignment] = STATE(4167),
    [sym_operator_assignment] = STATE(4167),
    [sym_conditional] = STATE(4167),
    [sym_range] = STATE(4167),
    [sym_binary] = STATE(4167),
    [sym_unary] = STATE(4167),
    [sym_left_assignment_list] = STATE(540),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(541),
    [sym__variable] = STATE(539),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(541),
    [sym_false] = STATE(541),
    [sym_nil] = STATE(541),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(542),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1021),
    [anon_sym_defined_QMARK] = ACTIONS(1023),
    [anon_sym_not] = ACTIONS(1025),
    [anon_sym_BANG] = ACTIONS(1027),
    [anon_sym_TILDE] = ACTIONS(1027),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1824] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(4168),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(541),
    [sym_scope_resolution] = STATE(539),
    [sym_call] = STATE(539),
    [sym_method_call] = STATE(541),
    [sym_assignment] = STATE(4168),
    [sym_operator_assignment] = STATE(4168),
    [sym_conditional] = STATE(4168),
    [sym_range] = STATE(4168),
    [sym_binary] = STATE(4168),
    [sym_unary] = STATE(4168),
    [sym_left_assignment_list] = STATE(540),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(541),
    [sym__variable] = STATE(539),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(541),
    [sym_false] = STATE(541),
    [sym_nil] = STATE(541),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(542),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1021),
    [anon_sym_defined_QMARK] = ACTIONS(1023),
    [anon_sym_not] = ACTIONS(1025),
    [anon_sym_BANG] = ACTIONS(1027),
    [anon_sym_TILDE] = ACTIONS(1027),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1825] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(4169),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(541),
    [sym_scope_resolution] = STATE(539),
    [sym_call] = STATE(539),
    [sym_method_call] = STATE(541),
    [sym_assignment] = STATE(4169),
    [sym_operator_assignment] = STATE(4169),
    [sym_conditional] = STATE(4169),
    [sym_range] = STATE(4169),
    [sym_binary] = STATE(4169),
    [sym_unary] = STATE(4169),
    [sym_left_assignment_list] = STATE(540),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(541),
    [sym__variable] = STATE(539),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(541),
    [sym_false] = STATE(541),
    [sym_nil] = STATE(541),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(542),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1021),
    [anon_sym_defined_QMARK] = ACTIONS(1023),
    [anon_sym_not] = ACTIONS(1025),
    [anon_sym_BANG] = ACTIONS(1027),
    [anon_sym_TILDE] = ACTIONS(1027),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1826] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(4170),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(541),
    [sym_scope_resolution] = STATE(539),
    [sym_call] = STATE(539),
    [sym_method_call] = STATE(541),
    [sym_assignment] = STATE(4170),
    [sym_operator_assignment] = STATE(4170),
    [sym_conditional] = STATE(4170),
    [sym_range] = STATE(4170),
    [sym_binary] = STATE(4170),
    [sym_unary] = STATE(4170),
    [sym_left_assignment_list] = STATE(540),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(541),
    [sym__variable] = STATE(539),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(541),
    [sym_false] = STATE(541),
    [sym_nil] = STATE(541),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(542),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1021),
    [anon_sym_defined_QMARK] = ACTIONS(1023),
    [anon_sym_not] = ACTIONS(1025),
    [anon_sym_BANG] = ACTIONS(1027),
    [anon_sym_TILDE] = ACTIONS(1027),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1827] = {
    [sym_argument_list_with_parens] = STATE(4173),
    [sym__argument_list_with_parens] = STATE(4174),
    [sym_operator] = STATE(4173),
    [sym_heredoc_body] = STATE(4175),
    [aux_sym_call_repeat1] = STATE(4175),
    [sym__heredoc_body_start] = ACTIONS(2519),
    [anon_sym_PIPE] = ACTIONS(6901),
    [anon_sym_STAR] = ACTIONS(6903),
    [anon_sym_STAR_STAR] = ACTIONS(6901),
    [anon_sym_AMP] = ACTIONS(6901),
    [anon_sym_LT] = ACTIONS(6903),
    [anon_sym_LPAREN2] = ACTIONS(6905),
    [anon_sym_DOT_DOT] = ACTIONS(6901),
    [anon_sym_LT_LT] = ACTIONS(6901),
    [anon_sym_GT_GT] = ACTIONS(6901),
    [anon_sym_EQ_EQ] = ACTIONS(6903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6901),
    [anon_sym_LT_EQ_GT] = ACTIONS(6901),
    [anon_sym_EQ_TILDE] = ACTIONS(6901),
    [anon_sym_BANG_TILDE] = ACTIONS(6901),
    [anon_sym_LT_EQ] = ACTIONS(6903),
    [anon_sym_GT] = ACTIONS(6903),
    [anon_sym_GT_EQ] = ACTIONS(6901),
    [anon_sym_CARET] = ACTIONS(6901),
    [anon_sym_PLUS] = ACTIONS(6903),
    [anon_sym_SLASH] = ACTIONS(6901),
    [anon_sym_PERCENT] = ACTIONS(6901),
    [anon_sym_BANG] = ACTIONS(6903),
    [anon_sym_TILDE] = ACTIONS(6901),
    [sym_constant] = ACTIONS(6907),
    [sym_identifier] = ACTIONS(6907),
    [anon_sym_DASH] = ACTIONS(6903),
    [anon_sym_PLUS_AT] = ACTIONS(6901),
    [anon_sym_DASH_AT] = ACTIONS(6901),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(6903),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(6901),
    [anon_sym_BQUOTE] = ACTIONS(6901),
    [sym_comment] = ACTIONS(87),
  },
  [1828] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(346),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(352),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(352),
    [sym__argument_list_with_trailing_comma] = STATE(4177),
    [sym__argument] = STATE(350),
    [sym_splat_argument] = STATE(350),
    [sym_hash_splat_argument] = STATE(350),
    [sym_block_argument] = STATE(350),
    [sym_assignment] = STATE(346),
    [sym_operator_assignment] = STATE(346),
    [sym_conditional] = STATE(346),
    [sym_range] = STATE(346),
    [sym_binary] = STATE(346),
    [sym_unary] = STATE(346),
    [sym_left_assignment_list] = STATE(351),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(352),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(352),
    [sym_false] = STATE(352),
    [sym_nil] = STATE(352),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(353),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(350),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(593),
    [sym__splat_star] = ACTIONS(595),
    [sym__unary_minus] = ACTIONS(597),
    [sym__identifier_hash_key] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(6909),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1829] = {
    [sym_constant] = ACTIONS(6911),
    [sym_identifier] = ACTIONS(6911),
    [sym_comment] = ACTIONS(87),
  },
  [1830] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(4186),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(4189),
    [sym_scope_resolution] = STATE(4187),
    [sym_call] = STATE(4187),
    [sym_method_call] = STATE(4189),
    [sym_assignment] = STATE(4186),
    [sym_operator_assignment] = STATE(4186),
    [sym_conditional] = STATE(4186),
    [sym_range] = STATE(4186),
    [sym_binary] = STATE(4186),
    [sym_unary] = STATE(4186),
    [sym_left_assignment_list] = STATE(4188),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4189),
    [sym__variable] = STATE(4187),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(4189),
    [sym_false] = STATE(4189),
    [sym_nil] = STATE(4189),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(4190),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(6913),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(6915),
    [anon_sym_yield] = ACTIONS(6917),
    [anon_sym_break] = ACTIONS(6919),
    [anon_sym_next] = ACTIONS(6921),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_defined_QMARK] = ACTIONS(6925),
    [anon_sym_not] = ACTIONS(6927),
    [anon_sym_BANG] = ACTIONS(6929),
    [anon_sym_TILDE] = ACTIONS(6929),
    [sym_constant] = ACTIONS(6931),
    [sym_identifier] = ACTIONS(6931),
    [sym_instance_variable] = ACTIONS(6933),
    [sym_class_variable] = ACTIONS(6933),
    [sym_global_variable] = ACTIONS(6933),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(6931),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6931),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [1831] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(4191),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(4189),
    [sym_scope_resolution] = STATE(4187),
    [sym_call] = STATE(4187),
    [sym_method_call] = STATE(4189),
    [sym_assignment] = STATE(4191),
    [sym_operator_assignment] = STATE(4191),
    [sym_conditional] = STATE(4191),
    [sym_range] = STATE(4191),
    [sym_binary] = STATE(4191),
    [sym_unary] = STATE(4191),
    [sym_left_assignment_list] = STATE(4188),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4189),
    [sym__variable] = STATE(4187),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(4189),
    [sym_false] = STATE(4189),
    [sym_nil] = STATE(4189),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(4190),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(6913),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(6915),
    [anon_sym_yield] = ACTIONS(6917),
    [anon_sym_break] = ACTIONS(6919),
    [anon_sym_next] = ACTIONS(6921),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_defined_QMARK] = ACTIONS(6925),
    [anon_sym_not] = ACTIONS(6927),
    [anon_sym_BANG] = ACTIONS(6929),
    [anon_sym_TILDE] = ACTIONS(6929),
    [sym_constant] = ACTIONS(6931),
    [sym_identifier] = ACTIONS(6931),
    [sym_instance_variable] = ACTIONS(6933),
    [sym_class_variable] = ACTIONS(6933),
    [sym_global_variable] = ACTIONS(6933),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(6931),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6931),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [1832] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4192),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1851),
    [sym_scope_resolution] = STATE(1845),
    [sym_call] = STATE(1845),
    [sym_method_call] = STATE(1851),
    [sym_assignment] = STATE(4192),
    [sym_operator_assignment] = STATE(4192),
    [sym_conditional] = STATE(4192),
    [sym_range] = STATE(4192),
    [sym_binary] = STATE(4192),
    [sym_unary] = STATE(4192),
    [sym_left_assignment_list] = STATE(1850),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1851),
    [sym__variable] = STATE(1845),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1851),
    [sym_false] = STATE(1851),
    [sym_nil] = STATE(1851),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4193),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3323),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3329),
    [anon_sym_yield] = ACTIONS(3331),
    [anon_sym_break] = ACTIONS(3333),
    [anon_sym_next] = ACTIONS(3335),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6935),
    [anon_sym_defined_QMARK] = ACTIONS(3339),
    [anon_sym_not] = ACTIONS(3341),
    [anon_sym_BANG] = ACTIONS(3345),
    [anon_sym_TILDE] = ACTIONS(3345),
    [sym_constant] = ACTIONS(3351),
    [sym_identifier] = ACTIONS(3351),
    [sym_instance_variable] = ACTIONS(3349),
    [sym_class_variable] = ACTIONS(3349),
    [sym_global_variable] = ACTIONS(3349),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3351),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3351),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1833] = {
    [anon_sym_COLON] = ACTIONS(6937),
    [sym_comment] = ACTIONS(87),
  },
  [1834] = {
    [sym__statements] = STATE(4196),
    [sym_begin_block] = STATE(489),
    [sym_end_block] = STATE(489),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_block_parameters] = STATE(4197),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1516),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1519),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1519),
    [sym_hash_splat_argument] = STATE(116),
    [sym_assignment] = STATE(1516),
    [sym_operator_assignment] = STATE(1516),
    [sym_conditional] = STATE(1516),
    [sym_range] = STATE(1516),
    [sym_binary] = STATE(1516),
    [sym_unary] = STATE(1516),
    [sym_left_assignment_list] = STATE(1518),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1519),
    [sym__variable] = STATE(1517),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1519),
    [sym_false] = STATE(1519),
    [sym_nil] = STATE(1519),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1520),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(1959),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym__hash_items] = STATE(1960),
    [sym_pair] = STATE(122),
    [sym_lambda] = STATE(214),
    [sym_empty_statement] = STATE(495),
    [aux_sym__statements_repeat1] = STATE(495),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2629),
    [sym__identifier_hash_key] = ACTIONS(157),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(6939),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_PIPE] = ACTIONS(2445),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2633),
    [anon_sym_yield] = ACTIONS(2635),
    [anon_sym_break] = ACTIONS(2637),
    [anon_sym_next] = ACTIONS(2639),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2641),
    [anon_sym_defined_QMARK] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2647),
    [anon_sym_TILDE] = ACTIONS(2647),
    [sym_constant] = ACTIONS(2649),
    [sym_identifier] = ACTIONS(2649),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1835] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(4198),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(4189),
    [sym_scope_resolution] = STATE(4187),
    [sym_call] = STATE(4187),
    [sym_method_call] = STATE(4189),
    [sym_assignment] = STATE(4198),
    [sym_operator_assignment] = STATE(4198),
    [sym_conditional] = STATE(4198),
    [sym_range] = STATE(4198),
    [sym_binary] = STATE(4198),
    [sym_unary] = STATE(4198),
    [sym_left_assignment_list] = STATE(4188),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4189),
    [sym__variable] = STATE(4187),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(4189),
    [sym_false] = STATE(4189),
    [sym_nil] = STATE(4189),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(4190),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(6913),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(6915),
    [anon_sym_yield] = ACTIONS(6917),
    [anon_sym_break] = ACTIONS(6919),
    [anon_sym_next] = ACTIONS(6921),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_defined_QMARK] = ACTIONS(6925),
    [anon_sym_not] = ACTIONS(6927),
    [anon_sym_BANG] = ACTIONS(6929),
    [anon_sym_TILDE] = ACTIONS(6929),
    [sym_constant] = ACTIONS(6931),
    [sym_identifier] = ACTIONS(6931),
    [sym_instance_variable] = ACTIONS(6933),
    [sym_class_variable] = ACTIONS(6933),
    [sym_global_variable] = ACTIONS(6933),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(6931),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6931),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [1836] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4151),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1851),
    [sym_scope_resolution] = STATE(1845),
    [sym_call] = STATE(1845),
    [sym_method_call] = STATE(1851),
    [sym_argument_list] = STATE(1973),
    [sym__argument_list_with_parens] = STATE(4152),
    [sym__argument] = STATE(4153),
    [sym_splat_argument] = STATE(4153),
    [sym_hash_splat_argument] = STATE(4153),
    [sym_block_argument] = STATE(4153),
    [sym_assignment] = STATE(4151),
    [sym_operator_assignment] = STATE(4151),
    [sym_conditional] = STATE(4151),
    [sym_range] = STATE(4151),
    [sym_binary] = STATE(4151),
    [sym_unary] = STATE(4151),
    [sym_left_assignment_list] = STATE(1850),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1851),
    [sym__variable] = STATE(1845),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1851),
    [sym_false] = STATE(1851),
    [sym_nil] = STATE(1851),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4154),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(4153),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(6883),
    [sym__splat_star] = ACTIONS(6885),
    [sym__unary_minus] = ACTIONS(3323),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(6887),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_RBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3329),
    [anon_sym_yield] = ACTIONS(3331),
    [anon_sym_break] = ACTIONS(3333),
    [anon_sym_next] = ACTIONS(3335),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(365),
    [anon_sym_DASH_EQ] = ACTIONS(365),
    [anon_sym_STAR_EQ] = ACTIONS(365),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(365),
    [anon_sym_SLASH_EQ] = ACTIONS(365),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(365),
    [anon_sym_PIPE_EQ] = ACTIONS(365),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(365),
    [anon_sym_AMP_EQ] = ACTIONS(365),
    [anon_sym_PERCENT_EQ] = ACTIONS(365),
    [anon_sym_GT_GT_EQ] = ACTIONS(365),
    [anon_sym_LT_LT_EQ] = ACTIONS(365),
    [anon_sym_CARET_EQ] = ACTIONS(365),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_PERCENT] = ACTIONS(377),
    [anon_sym_defined_QMARK] = ACTIONS(3339),
    [anon_sym_not] = ACTIONS(3341),
    [anon_sym_BANG] = ACTIONS(3343),
    [anon_sym_TILDE] = ACTIONS(3345),
    [sym_constant] = ACTIONS(6889),
    [sym_identifier] = ACTIONS(6889),
    [sym_instance_variable] = ACTIONS(3349),
    [sym_class_variable] = ACTIONS(3349),
    [sym_global_variable] = ACTIONS(3349),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3351),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3351),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1837] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4151),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1851),
    [sym_scope_resolution] = STATE(1845),
    [sym_call] = STATE(1845),
    [sym_method_call] = STATE(1851),
    [sym_argument_list] = STATE(1974),
    [sym__argument_list_with_parens] = STATE(4152),
    [sym__argument] = STATE(4153),
    [sym_splat_argument] = STATE(4153),
    [sym_hash_splat_argument] = STATE(4153),
    [sym_block_argument] = STATE(4153),
    [sym_assignment] = STATE(4151),
    [sym_operator_assignment] = STATE(4151),
    [sym_conditional] = STATE(4151),
    [sym_range] = STATE(4151),
    [sym_binary] = STATE(4151),
    [sym_unary] = STATE(4151),
    [sym_left_assignment_list] = STATE(1850),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1851),
    [sym__variable] = STATE(1845),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1851),
    [sym_false] = STATE(1851),
    [sym_nil] = STATE(1851),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4154),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(4153),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(6883),
    [sym__splat_star] = ACTIONS(6885),
    [sym__unary_minus] = ACTIONS(3323),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(6887),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_RBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_EQ] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3329),
    [anon_sym_yield] = ACTIONS(3331),
    [anon_sym_break] = ACTIONS(3333),
    [anon_sym_next] = ACTIONS(3335),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(417),
    [anon_sym_DASH_EQ] = ACTIONS(417),
    [anon_sym_STAR_EQ] = ACTIONS(417),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(417),
    [anon_sym_SLASH_EQ] = ACTIONS(417),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(417),
    [anon_sym_PIPE_EQ] = ACTIONS(417),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(417),
    [anon_sym_AMP_EQ] = ACTIONS(417),
    [anon_sym_PERCENT_EQ] = ACTIONS(417),
    [anon_sym_GT_GT_EQ] = ACTIONS(417),
    [anon_sym_LT_LT_EQ] = ACTIONS(417),
    [anon_sym_CARET_EQ] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(3339),
    [anon_sym_not] = ACTIONS(3341),
    [anon_sym_BANG] = ACTIONS(3343),
    [anon_sym_TILDE] = ACTIONS(3345),
    [sym_constant] = ACTIONS(6889),
    [sym_identifier] = ACTIONS(6889),
    [sym_instance_variable] = ACTIONS(3349),
    [sym_class_variable] = ACTIONS(3349),
    [sym_global_variable] = ACTIONS(3349),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3351),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3351),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1838] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4151),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1851),
    [sym_scope_resolution] = STATE(1845),
    [sym_call] = STATE(1845),
    [sym_method_call] = STATE(1851),
    [sym_argument_list] = STATE(1975),
    [sym__argument_list_with_parens] = STATE(4152),
    [sym__argument] = STATE(4153),
    [sym_splat_argument] = STATE(4153),
    [sym_hash_splat_argument] = STATE(4153),
    [sym_block_argument] = STATE(4153),
    [sym_assignment] = STATE(4151),
    [sym_operator_assignment] = STATE(4151),
    [sym_conditional] = STATE(4151),
    [sym_range] = STATE(4151),
    [sym_binary] = STATE(4151),
    [sym_unary] = STATE(4151),
    [sym_left_assignment_list] = STATE(1850),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1851),
    [sym__variable] = STATE(1845),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1851),
    [sym_false] = STATE(1851),
    [sym_nil] = STATE(1851),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4154),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(4153),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(6883),
    [sym__splat_star] = ACTIONS(6885),
    [sym__unary_minus] = ACTIONS(3323),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(6887),
    [anon_sym_LBRACE] = ACTIONS(421),
    [anon_sym_RBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_EQ] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3329),
    [anon_sym_yield] = ACTIONS(3331),
    [anon_sym_break] = ACTIONS(3333),
    [anon_sym_next] = ACTIONS(3335),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(421),
    [anon_sym_DASH_EQ] = ACTIONS(421),
    [anon_sym_STAR_EQ] = ACTIONS(421),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(421),
    [anon_sym_SLASH_EQ] = ACTIONS(421),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(421),
    [anon_sym_PIPE_EQ] = ACTIONS(421),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(421),
    [anon_sym_AMP_EQ] = ACTIONS(421),
    [anon_sym_PERCENT_EQ] = ACTIONS(421),
    [anon_sym_GT_GT_EQ] = ACTIONS(421),
    [anon_sym_LT_LT_EQ] = ACTIONS(421),
    [anon_sym_CARET_EQ] = ACTIONS(421),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(3339),
    [anon_sym_not] = ACTIONS(3341),
    [anon_sym_BANG] = ACTIONS(3343),
    [anon_sym_TILDE] = ACTIONS(3345),
    [sym_constant] = ACTIONS(6889),
    [sym_identifier] = ACTIONS(6889),
    [sym_instance_variable] = ACTIONS(3349),
    [sym_class_variable] = ACTIONS(3349),
    [sym_global_variable] = ACTIONS(3349),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3351),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3351),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1839] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4151),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1851),
    [sym_scope_resolution] = STATE(1845),
    [sym_call] = STATE(1845),
    [sym_method_call] = STATE(1851),
    [sym_argument_list] = STATE(1976),
    [sym__argument_list_with_parens] = STATE(4152),
    [sym__argument] = STATE(4153),
    [sym_splat_argument] = STATE(4153),
    [sym_hash_splat_argument] = STATE(4153),
    [sym_block_argument] = STATE(4153),
    [sym_assignment] = STATE(4151),
    [sym_operator_assignment] = STATE(4151),
    [sym_conditional] = STATE(4151),
    [sym_range] = STATE(4151),
    [sym_binary] = STATE(4151),
    [sym_unary] = STATE(4151),
    [sym_left_assignment_list] = STATE(1850),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1851),
    [sym__variable] = STATE(1845),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1851),
    [sym_false] = STATE(1851),
    [sym_nil] = STATE(1851),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4154),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(4153),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(6883),
    [sym__splat_star] = ACTIONS(6885),
    [sym__unary_minus] = ACTIONS(3323),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(6887),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(427),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3329),
    [anon_sym_yield] = ACTIONS(3331),
    [anon_sym_break] = ACTIONS(3333),
    [anon_sym_next] = ACTIONS(3335),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(425),
    [anon_sym_DASH_EQ] = ACTIONS(425),
    [anon_sym_STAR_EQ] = ACTIONS(425),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(425),
    [anon_sym_SLASH_EQ] = ACTIONS(425),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(425),
    [anon_sym_PIPE_EQ] = ACTIONS(425),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(425),
    [anon_sym_AMP_EQ] = ACTIONS(425),
    [anon_sym_PERCENT_EQ] = ACTIONS(425),
    [anon_sym_GT_GT_EQ] = ACTIONS(425),
    [anon_sym_LT_LT_EQ] = ACTIONS(425),
    [anon_sym_CARET_EQ] = ACTIONS(425),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(3339),
    [anon_sym_not] = ACTIONS(3341),
    [anon_sym_BANG] = ACTIONS(3343),
    [anon_sym_TILDE] = ACTIONS(3345),
    [sym_constant] = ACTIONS(6889),
    [sym_identifier] = ACTIONS(6889),
    [sym_instance_variable] = ACTIONS(3349),
    [sym_class_variable] = ACTIONS(3349),
    [sym_global_variable] = ACTIONS(3349),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3351),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3351),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1840] = {
    [sym__statements] = STATE(4200),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_block_parameters] = STATE(4201),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_heredoc_body] = STATE(4202),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [sym__terminator] = STATE(4202),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__line_break] = ACTIONS(6941),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(6941),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(6943),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1841] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4203),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1851),
    [sym_scope_resolution] = STATE(1845),
    [sym_call] = STATE(1845),
    [sym_method_call] = STATE(1851),
    [sym_assignment] = STATE(4203),
    [sym_operator_assignment] = STATE(4203),
    [sym_conditional] = STATE(4203),
    [sym_range] = STATE(4203),
    [sym_binary] = STATE(4203),
    [sym_unary] = STATE(4203),
    [sym_left_assignment_list] = STATE(1850),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1851),
    [sym__variable] = STATE(1845),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1851),
    [sym_false] = STATE(1851),
    [sym_nil] = STATE(1851),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4193),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3323),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3329),
    [anon_sym_yield] = ACTIONS(3331),
    [anon_sym_break] = ACTIONS(3333),
    [anon_sym_next] = ACTIONS(3335),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6935),
    [anon_sym_defined_QMARK] = ACTIONS(3339),
    [anon_sym_not] = ACTIONS(3341),
    [anon_sym_BANG] = ACTIONS(3345),
    [anon_sym_TILDE] = ACTIONS(3345),
    [sym_constant] = ACTIONS(3351),
    [sym_identifier] = ACTIONS(3351),
    [sym_instance_variable] = ACTIONS(3349),
    [sym_class_variable] = ACTIONS(3349),
    [sym_global_variable] = ACTIONS(3349),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3351),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3351),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1842] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1997),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1851),
    [sym_scope_resolution] = STATE(1845),
    [sym_call] = STATE(1845),
    [sym_method_call] = STATE(1851),
    [sym_assignment] = STATE(1997),
    [sym_operator_assignment] = STATE(1997),
    [sym_conditional] = STATE(1997),
    [sym_range] = STATE(1997),
    [sym_binary] = STATE(1997),
    [sym_unary] = STATE(1997),
    [sym_left_assignment_list] = STATE(1850),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1851),
    [sym__variable] = STATE(1845),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1851),
    [sym_false] = STATE(1851),
    [sym_nil] = STATE(1851),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4193),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3323),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3329),
    [anon_sym_yield] = ACTIONS(3331),
    [anon_sym_break] = ACTIONS(3333),
    [anon_sym_next] = ACTIONS(3335),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6935),
    [anon_sym_defined_QMARK] = ACTIONS(3339),
    [anon_sym_not] = ACTIONS(3341),
    [anon_sym_BANG] = ACTIONS(3345),
    [anon_sym_TILDE] = ACTIONS(3345),
    [sym_constant] = ACTIONS(3351),
    [sym_identifier] = ACTIONS(3351),
    [sym_instance_variable] = ACTIONS(3349),
    [sym_class_variable] = ACTIONS(3349),
    [sym_global_variable] = ACTIONS(3349),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3351),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3351),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1843] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(6945),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [1844] = {
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(6947),
    [sym__binary_star] = ACTIONS(6949),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_RBRACE] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(6951),
    [anon_sym_STAR_STAR] = ACTIONS(6953),
    [anon_sym_AMP] = ACTIONS(6955),
    [anon_sym_EQ] = ACTIONS(1631),
    [anon_sym_LT] = ACTIONS(6957),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(6937),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_PLUS_EQ] = ACTIONS(1625),
    [anon_sym_DASH_EQ] = ACTIONS(1625),
    [anon_sym_STAR_EQ] = ACTIONS(1625),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1625),
    [anon_sym_SLASH_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1625),
    [anon_sym_AMP_EQ] = ACTIONS(1625),
    [anon_sym_PERCENT_EQ] = ACTIONS(1625),
    [anon_sym_GT_GT_EQ] = ACTIONS(1625),
    [anon_sym_LT_LT_EQ] = ACTIONS(1625),
    [anon_sym_CARET_EQ] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(6959),
    [anon_sym_DOT_DOT] = ACTIONS(6961),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6963),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(6965),
    [anon_sym_AMP_AMP] = ACTIONS(6965),
    [anon_sym_LT_LT] = ACTIONS(6967),
    [anon_sym_GT_GT] = ACTIONS(6967),
    [anon_sym_EQ_EQ] = ACTIONS(6965),
    [anon_sym_BANG_EQ] = ACTIONS(6969),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6969),
    [anon_sym_LT_EQ_GT] = ACTIONS(6969),
    [anon_sym_EQ_TILDE] = ACTIONS(6969),
    [anon_sym_BANG_TILDE] = ACTIONS(6969),
    [anon_sym_LT_EQ] = ACTIONS(6957),
    [anon_sym_GT] = ACTIONS(6957),
    [anon_sym_GT_EQ] = ACTIONS(6971),
    [anon_sym_CARET] = ACTIONS(6951),
    [anon_sym_PLUS] = ACTIONS(6973),
    [anon_sym_SLASH] = ACTIONS(6953),
    [anon_sym_PERCENT] = ACTIONS(6953),
    [sym_comment] = ACTIONS(87),
  },
  [1845] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4151),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1851),
    [sym_scope_resolution] = STATE(1845),
    [sym_call] = STATE(1845),
    [sym_method_call] = STATE(1851),
    [sym_argument_list] = STATE(2016),
    [sym__argument_list_with_parens] = STATE(4152),
    [sym__argument] = STATE(4153),
    [sym_splat_argument] = STATE(4153),
    [sym_hash_splat_argument] = STATE(4153),
    [sym_block_argument] = STATE(4153),
    [sym_do_block] = STATE(1382),
    [sym_block] = STATE(1382),
    [sym_assignment] = STATE(4151),
    [sym_operator_assignment] = STATE(4151),
    [sym_conditional] = STATE(4151),
    [sym_range] = STATE(4151),
    [sym_binary] = STATE(4151),
    [sym_unary] = STATE(4151),
    [sym_left_assignment_list] = STATE(1850),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1851),
    [sym__variable] = STATE(1845),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1851),
    [sym_false] = STATE(1851),
    [sym_nil] = STATE(1851),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4154),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(4153),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(6883),
    [sym__splat_star] = ACTIONS(6885),
    [sym__unary_minus] = ACTIONS(3323),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(6887),
    [anon_sym_LBRACE] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3329),
    [anon_sym_yield] = ACTIONS(3331),
    [anon_sym_break] = ACTIONS(3333),
    [anon_sym_next] = ACTIONS(3335),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(769),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(3339),
    [anon_sym_not] = ACTIONS(3341),
    [anon_sym_BANG] = ACTIONS(3343),
    [anon_sym_TILDE] = ACTIONS(3345),
    [sym_constant] = ACTIONS(6889),
    [sym_identifier] = ACTIONS(6889),
    [sym_instance_variable] = ACTIONS(3349),
    [sym_class_variable] = ACTIONS(3349),
    [sym_global_variable] = ACTIONS(3349),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3351),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3351),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1846] = {
    [sym_do_block] = STATE(4216),
    [sym_block] = STATE(4216),
    [sym__heredoc_body_start] = ACTIONS(2717),
    [sym__binary_minus] = ACTIONS(2717),
    [sym__binary_star] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(6975),
    [anon_sym_RBRACE] = ACTIONS(2717),
    [anon_sym_RPAREN] = ACTIONS(2717),
    [anon_sym_DOT] = ACTIONS(2721),
    [anon_sym_COMMA] = ACTIONS(2717),
    [anon_sym_PIPE] = ACTIONS(2721),
    [anon_sym_SEMI] = ACTIONS(2717),
    [anon_sym_STAR_STAR] = ACTIONS(2721),
    [anon_sym_AMP] = ACTIONS(2721),
    [anon_sym_EQ] = ACTIONS(2721),
    [anon_sym_LT] = ACTIONS(2721),
    [anon_sym_if] = ACTIONS(2717),
    [anon_sym_unless] = ACTIONS(2717),
    [anon_sym_while] = ACTIONS(2717),
    [anon_sym_until] = ACTIONS(2717),
    [anon_sym_rescue] = ACTIONS(2717),
    [anon_sym_do] = ACTIONS(6977),
    [anon_sym_LBRACK] = ACTIONS(2717),
    [anon_sym_RBRACK] = ACTIONS(2717),
    [anon_sym_COLON_COLON2] = ACTIONS(2717),
    [anon_sym_AMP_DOT] = ACTIONS(2717),
    [anon_sym_PLUS_EQ] = ACTIONS(2717),
    [anon_sym_DASH_EQ] = ACTIONS(2717),
    [anon_sym_STAR_EQ] = ACTIONS(2717),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2717),
    [anon_sym_SLASH_EQ] = ACTIONS(2717),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2717),
    [anon_sym_PIPE_EQ] = ACTIONS(2717),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2717),
    [anon_sym_AMP_EQ] = ACTIONS(2717),
    [anon_sym_PERCENT_EQ] = ACTIONS(2717),
    [anon_sym_GT_GT_EQ] = ACTIONS(2717),
    [anon_sym_LT_LT_EQ] = ACTIONS(2717),
    [anon_sym_CARET_EQ] = ACTIONS(2717),
    [anon_sym_QMARK] = ACTIONS(2717),
    [anon_sym_COLON2] = ACTIONS(2721),
    [anon_sym_DOT_DOT] = ACTIONS(2721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2717),
    [anon_sym_and] = ACTIONS(2717),
    [anon_sym_or] = ACTIONS(2717),
    [anon_sym_PIPE_PIPE] = ACTIONS(2721),
    [anon_sym_AMP_AMP] = ACTIONS(2721),
    [anon_sym_LT_LT] = ACTIONS(2721),
    [anon_sym_GT_GT] = ACTIONS(2721),
    [anon_sym_EQ_EQ] = ACTIONS(2721),
    [anon_sym_BANG_EQ] = ACTIONS(2717),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2717),
    [anon_sym_LT_EQ_GT] = ACTIONS(2717),
    [anon_sym_EQ_TILDE] = ACTIONS(2717),
    [anon_sym_BANG_TILDE] = ACTIONS(2717),
    [anon_sym_LT_EQ] = ACTIONS(2721),
    [anon_sym_GT] = ACTIONS(2721),
    [anon_sym_GT_EQ] = ACTIONS(2717),
    [anon_sym_CARET] = ACTIONS(2721),
    [anon_sym_PLUS] = ACTIONS(2721),
    [anon_sym_SLASH] = ACTIONS(2721),
    [anon_sym_PERCENT] = ACTIONS(2721),
    [sym_comment] = ACTIONS(87),
  },
  [1847] = {
    [sym_heredoc_body] = STATE(4217),
    [aux_sym_call_repeat1] = STATE(4217),
    [sym__heredoc_body_start] = ACTIONS(6569),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_RBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [1848] = {
    [sym_heredoc_body] = STATE(4217),
    [aux_sym_call_repeat1] = STATE(4217),
    [aux_sym_argument_list_repeat1] = STATE(4219),
    [sym__heredoc_body_start] = ACTIONS(6569),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_RBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(6979),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [1849] = {
    [sym__heredoc_body_start] = ACTIONS(2717),
    [sym__binary_minus] = ACTIONS(2717),
    [sym__binary_star] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(2717),
    [anon_sym_RBRACE] = ACTIONS(2717),
    [anon_sym_RPAREN] = ACTIONS(2717),
    [anon_sym_DOT] = ACTIONS(2721),
    [anon_sym_COMMA] = ACTIONS(2717),
    [anon_sym_PIPE] = ACTIONS(2721),
    [anon_sym_SEMI] = ACTIONS(2717),
    [anon_sym_STAR_STAR] = ACTIONS(2721),
    [anon_sym_AMP] = ACTIONS(2721),
    [anon_sym_EQ] = ACTIONS(2721),
    [anon_sym_LT] = ACTIONS(2721),
    [anon_sym_if] = ACTIONS(2717),
    [anon_sym_unless] = ACTIONS(2717),
    [anon_sym_while] = ACTIONS(2717),
    [anon_sym_until] = ACTIONS(2717),
    [anon_sym_rescue] = ACTIONS(2717),
    [anon_sym_in] = ACTIONS(2717),
    [anon_sym_do] = ACTIONS(2717),
    [anon_sym_LBRACK] = ACTIONS(2717),
    [anon_sym_RBRACK] = ACTIONS(2717),
    [anon_sym_COLON_COLON2] = ACTIONS(2717),
    [anon_sym_AMP_DOT] = ACTIONS(2717),
    [anon_sym_PLUS_EQ] = ACTIONS(2717),
    [anon_sym_DASH_EQ] = ACTIONS(2717),
    [anon_sym_STAR_EQ] = ACTIONS(2717),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2717),
    [anon_sym_SLASH_EQ] = ACTIONS(2717),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2717),
    [anon_sym_PIPE_EQ] = ACTIONS(2717),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2717),
    [anon_sym_AMP_EQ] = ACTIONS(2717),
    [anon_sym_PERCENT_EQ] = ACTIONS(2717),
    [anon_sym_GT_GT_EQ] = ACTIONS(2717),
    [anon_sym_LT_LT_EQ] = ACTIONS(2717),
    [anon_sym_CARET_EQ] = ACTIONS(2717),
    [anon_sym_QMARK] = ACTIONS(2717),
    [anon_sym_COLON2] = ACTIONS(2721),
    [anon_sym_DOT_DOT] = ACTIONS(2721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2717),
    [anon_sym_and] = ACTIONS(2717),
    [anon_sym_or] = ACTIONS(2717),
    [anon_sym_PIPE_PIPE] = ACTIONS(2721),
    [anon_sym_AMP_AMP] = ACTIONS(2721),
    [anon_sym_LT_LT] = ACTIONS(2721),
    [anon_sym_GT_GT] = ACTIONS(2721),
    [anon_sym_EQ_EQ] = ACTIONS(2721),
    [anon_sym_BANG_EQ] = ACTIONS(2717),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2717),
    [anon_sym_LT_EQ_GT] = ACTIONS(2717),
    [anon_sym_EQ_TILDE] = ACTIONS(2717),
    [anon_sym_BANG_TILDE] = ACTIONS(2717),
    [anon_sym_LT_EQ] = ACTIONS(2721),
    [anon_sym_GT] = ACTIONS(2721),
    [anon_sym_GT_EQ] = ACTIONS(2717),
    [anon_sym_CARET] = ACTIONS(2721),
    [anon_sym_PLUS] = ACTIONS(2721),
    [anon_sym_SLASH] = ACTIONS(2721),
    [anon_sym_PERCENT] = ACTIONS(2721),
    [sym_comment] = ACTIONS(87),
  },
  [1850] = {
    [anon_sym_EQ] = ACTIONS(6981),
    [sym_comment] = ACTIONS(87),
  },
  [1851] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(6983),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(6985),
    [anon_sym_DASH_EQ] = ACTIONS(6985),
    [anon_sym_STAR_EQ] = ACTIONS(6985),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6985),
    [anon_sym_SLASH_EQ] = ACTIONS(6985),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6985),
    [anon_sym_PIPE_EQ] = ACTIONS(6985),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6985),
    [anon_sym_AMP_EQ] = ACTIONS(6985),
    [anon_sym_PERCENT_EQ] = ACTIONS(6985),
    [anon_sym_GT_GT_EQ] = ACTIONS(6985),
    [anon_sym_LT_LT_EQ] = ACTIONS(6985),
    [anon_sym_CARET_EQ] = ACTIONS(6985),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1852] = {
    [sym_string] = STATE(4222),
    [aux_sym_chained_string_repeat1] = STATE(4222),
    [sym__string_start] = ACTIONS(1141),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(6987),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1853] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(4224),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(541),
    [sym_scope_resolution] = STATE(539),
    [sym_call] = STATE(539),
    [sym_method_call] = STATE(541),
    [sym_splat_argument] = STATE(4225),
    [sym_assignment] = STATE(4224),
    [sym_operator_assignment] = STATE(4224),
    [sym_conditional] = STATE(4224),
    [sym_range] = STATE(4224),
    [sym_binary] = STATE(4224),
    [sym_unary] = STATE(4224),
    [sym_right_assignment_list] = STATE(3461),
    [sym__arg_or_splat_arg] = STATE(4225),
    [sym_left_assignment_list] = STATE(540),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(541),
    [sym__variable] = STATE(539),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(541),
    [sym_false] = STATE(541),
    [sym_nil] = STATE(541),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(542),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(6989),
    [sym__unary_minus] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1021),
    [anon_sym_defined_QMARK] = ACTIONS(1023),
    [anon_sym_not] = ACTIONS(1025),
    [anon_sym_BANG] = ACTIONS(1027),
    [anon_sym_TILDE] = ACTIONS(1027),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1854] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(4226),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(541),
    [sym_scope_resolution] = STATE(539),
    [sym_call] = STATE(539),
    [sym_method_call] = STATE(541),
    [sym_assignment] = STATE(4226),
    [sym_operator_assignment] = STATE(4226),
    [sym_conditional] = STATE(4226),
    [sym_range] = STATE(4226),
    [sym_binary] = STATE(4226),
    [sym_unary] = STATE(4226),
    [sym_left_assignment_list] = STATE(540),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(541),
    [sym__variable] = STATE(539),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(541),
    [sym_false] = STATE(541),
    [sym_nil] = STATE(541),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(542),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1021),
    [anon_sym_defined_QMARK] = ACTIONS(1023),
    [anon_sym_not] = ACTIONS(1025),
    [anon_sym_BANG] = ACTIONS(1027),
    [anon_sym_TILDE] = ACTIONS(1027),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1855] = {
    [sym_string] = STATE(4227),
    [aux_sym_chained_string_repeat1] = STATE(4227),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_RBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [1856] = {
    [sym_heredoc_body] = STATE(4228),
    [sym__terminator] = STATE(4228),
    [sym__line_break] = ACTIONS(6991),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym__binary_minus] = ACTIONS(2001),
    [sym__binary_star] = ACTIONS(2003),
    [anon_sym_PIPE] = ACTIONS(2005),
    [anon_sym_SEMI] = ACTIONS(6991),
    [anon_sym_STAR_STAR] = ACTIONS(2003),
    [anon_sym_AMP] = ACTIONS(2007),
    [anon_sym_LT] = ACTIONS(2009),
    [anon_sym_QMARK] = ACTIONS(2011),
    [anon_sym_DOT_DOT] = ACTIONS(2013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2015),
    [anon_sym_and] = ACTIONS(2017),
    [anon_sym_or] = ACTIONS(2017),
    [anon_sym_PIPE_PIPE] = ACTIONS(2019),
    [anon_sym_AMP_AMP] = ACTIONS(2019),
    [anon_sym_LT_LT] = ACTIONS(2021),
    [anon_sym_GT_GT] = ACTIONS(2021),
    [anon_sym_EQ_EQ] = ACTIONS(2023),
    [anon_sym_BANG_EQ] = ACTIONS(2019),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2019),
    [anon_sym_LT_EQ_GT] = ACTIONS(2019),
    [anon_sym_EQ_TILDE] = ACTIONS(2019),
    [anon_sym_BANG_TILDE] = ACTIONS(2019),
    [anon_sym_LT_EQ] = ACTIONS(2009),
    [anon_sym_GT] = ACTIONS(2009),
    [anon_sym_GT_EQ] = ACTIONS(2025),
    [anon_sym_CARET] = ACTIONS(2027),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_SLASH] = ACTIONS(2003),
    [anon_sym_PERCENT] = ACTIONS(2003),
    [sym_comment] = ACTIONS(87),
  },
  [1857] = {
    [sym_heredoc_body] = STATE(4229),
    [sym__terminator] = STATE(4229),
    [sym__line_break] = ACTIONS(6993),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(6993),
    [sym_comment] = ACTIONS(87),
  },
  [1858] = {
    [sym__statements] = STATE(579),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(580),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(581),
    [sym_rescue] = STATE(582),
    [sym__body_statement] = STATE(4230),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(6995),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1859] = {
    [sym__binary_minus] = ACTIONS(4205),
    [sym__binary_star] = ACTIONS(4205),
    [anon_sym_LBRACE] = ACTIONS(4205),
    [anon_sym_RBRACE] = ACTIONS(4205),
    [anon_sym_RPAREN] = ACTIONS(4205),
    [anon_sym_DOT] = ACTIONS(4207),
    [anon_sym_COMMA] = ACTIONS(4205),
    [anon_sym_PIPE] = ACTIONS(4207),
    [anon_sym_SEMI] = ACTIONS(4205),
    [anon_sym_STAR_STAR] = ACTIONS(4205),
    [anon_sym_AMP] = ACTIONS(4207),
    [anon_sym_LT] = ACTIONS(4207),
    [anon_sym_if] = ACTIONS(4205),
    [anon_sym_unless] = ACTIONS(4205),
    [anon_sym_while] = ACTIONS(4205),
    [anon_sym_until] = ACTIONS(4205),
    [anon_sym_rescue] = ACTIONS(4205),
    [anon_sym_do] = ACTIONS(4205),
    [anon_sym_EQ_GT] = ACTIONS(4205),
    [anon_sym_LBRACK] = ACTIONS(4205),
    [anon_sym_COLON_COLON2] = ACTIONS(4205),
    [anon_sym_AMP_DOT] = ACTIONS(4205),
    [anon_sym_QMARK] = ACTIONS(4205),
    [anon_sym_COLON2] = ACTIONS(4207),
    [anon_sym_DOT_DOT] = ACTIONS(4207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4205),
    [anon_sym_and] = ACTIONS(4205),
    [anon_sym_or] = ACTIONS(4205),
    [anon_sym_PIPE_PIPE] = ACTIONS(4205),
    [anon_sym_AMP_AMP] = ACTIONS(4205),
    [anon_sym_LT_LT] = ACTIONS(4205),
    [anon_sym_GT_GT] = ACTIONS(4205),
    [anon_sym_EQ_EQ] = ACTIONS(4207),
    [anon_sym_BANG_EQ] = ACTIONS(4205),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4205),
    [anon_sym_LT_EQ_GT] = ACTIONS(4205),
    [anon_sym_EQ_TILDE] = ACTIONS(4205),
    [anon_sym_BANG_TILDE] = ACTIONS(4205),
    [anon_sym_LT_EQ] = ACTIONS(4207),
    [anon_sym_GT] = ACTIONS(4207),
    [anon_sym_GT_EQ] = ACTIONS(4205),
    [anon_sym_CARET] = ACTIONS(4205),
    [anon_sym_PLUS] = ACTIONS(4205),
    [anon_sym_SLASH] = ACTIONS(4205),
    [anon_sym_PERCENT] = ACTIONS(4205),
    [sym_comment] = ACTIONS(87),
  },
  [1860] = {
    [sym__statements] = STATE(579),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(580),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(581),
    [sym_rescue] = STATE(582),
    [sym__body_statement] = STATE(4231),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(6997),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1861] = {
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(3371),
    [sym__binary_star] = ACTIONS(3373),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(3375),
    [anon_sym_STAR_STAR] = ACTIONS(3373),
    [anon_sym_AMP] = ACTIONS(3377),
    [anon_sym_LT] = ACTIONS(3379),
    [anon_sym_EQ_GT] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(3381),
    [anon_sym_DOT_DOT] = ACTIONS(3383),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3385),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(3387),
    [anon_sym_AMP_AMP] = ACTIONS(3387),
    [anon_sym_LT_LT] = ACTIONS(3389),
    [anon_sym_GT_GT] = ACTIONS(3389),
    [anon_sym_EQ_EQ] = ACTIONS(3391),
    [anon_sym_BANG_EQ] = ACTIONS(3387),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3387),
    [anon_sym_LT_EQ_GT] = ACTIONS(3387),
    [anon_sym_EQ_TILDE] = ACTIONS(3387),
    [anon_sym_BANG_TILDE] = ACTIONS(3387),
    [anon_sym_LT_EQ] = ACTIONS(3379),
    [anon_sym_GT] = ACTIONS(3379),
    [anon_sym_GT_EQ] = ACTIONS(3393),
    [anon_sym_CARET] = ACTIONS(3395),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_SLASH] = ACTIONS(3373),
    [anon_sym_PERCENT] = ACTIONS(3373),
    [sym_comment] = ACTIONS(87),
  },
  [1862] = {
    [sym_string] = STATE(1890),
    [aux_sym_chained_string_repeat1] = STATE(1890),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [1863] = {
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(3371),
    [sym__binary_star] = ACTIONS(3373),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(3375),
    [anon_sym_STAR_STAR] = ACTIONS(3373),
    [anon_sym_AMP] = ACTIONS(3377),
    [anon_sym_LT] = ACTIONS(3379),
    [anon_sym_EQ_GT] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(3381),
    [anon_sym_DOT_DOT] = ACTIONS(3383),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3385),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(3387),
    [anon_sym_AMP_AMP] = ACTIONS(3387),
    [anon_sym_LT_LT] = ACTIONS(3389),
    [anon_sym_GT_GT] = ACTIONS(3389),
    [anon_sym_EQ_EQ] = ACTIONS(3391),
    [anon_sym_BANG_EQ] = ACTIONS(3387),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3387),
    [anon_sym_LT_EQ_GT] = ACTIONS(3387),
    [anon_sym_EQ_TILDE] = ACTIONS(3387),
    [anon_sym_BANG_TILDE] = ACTIONS(3387),
    [anon_sym_LT_EQ] = ACTIONS(3379),
    [anon_sym_GT] = ACTIONS(3379),
    [anon_sym_GT_EQ] = ACTIONS(3393),
    [anon_sym_CARET] = ACTIONS(3395),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_SLASH] = ACTIONS(3373),
    [anon_sym_PERCENT] = ACTIONS(3373),
    [sym_comment] = ACTIONS(87),
  },
  [1864] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(3373),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [1865] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4232),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(567),
    [sym_scope_resolution] = STATE(562),
    [sym_call] = STATE(562),
    [sym_method_call] = STATE(567),
    [sym_assignment] = STATE(4232),
    [sym_operator_assignment] = STATE(4232),
    [sym_conditional] = STATE(4232),
    [sym_range] = STATE(4232),
    [sym_binary] = STATE(4232),
    [sym_unary] = STATE(4232),
    [sym_left_assignment_list] = STATE(566),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(567),
    [sym__variable] = STATE(562),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(567),
    [sym_false] = STATE(567),
    [sym_nil] = STATE(567),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1862),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1049),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1079),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1866] = {
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(3371),
    [sym__binary_star] = ACTIONS(3373),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(3375),
    [anon_sym_STAR_STAR] = ACTIONS(3373),
    [anon_sym_AMP] = ACTIONS(3377),
    [anon_sym_LT] = ACTIONS(3379),
    [anon_sym_EQ_GT] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3381),
    [anon_sym_DOT_DOT] = ACTIONS(3383),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3385),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(3387),
    [anon_sym_AMP_AMP] = ACTIONS(3387),
    [anon_sym_LT_LT] = ACTIONS(3389),
    [anon_sym_GT_GT] = ACTIONS(3389),
    [anon_sym_EQ_EQ] = ACTIONS(3391),
    [anon_sym_BANG_EQ] = ACTIONS(3387),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3387),
    [anon_sym_LT_EQ_GT] = ACTIONS(3387),
    [anon_sym_EQ_TILDE] = ACTIONS(3387),
    [anon_sym_BANG_TILDE] = ACTIONS(3387),
    [anon_sym_LT_EQ] = ACTIONS(3379),
    [anon_sym_GT] = ACTIONS(3379),
    [anon_sym_GT_EQ] = ACTIONS(3393),
    [anon_sym_CARET] = ACTIONS(3395),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_SLASH] = ACTIONS(3373),
    [anon_sym_PERCENT] = ACTIONS(3373),
    [sym_comment] = ACTIONS(87),
  },
  [1867] = {
    [sym_heredoc_body] = STATE(4233),
    [aux_sym_call_repeat1] = STATE(4233),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [1868] = {
    [sym_heredoc_body] = STATE(4233),
    [aux_sym_call_repeat1] = STATE(4233),
    [aux_sym_argument_list_repeat1] = STATE(4234),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(3399),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [1869] = {
    [sym__heredoc_body_start] = ACTIONS(4285),
    [sym__binary_minus] = ACTIONS(4285),
    [sym__binary_star] = ACTIONS(4285),
    [anon_sym_LBRACE] = ACTIONS(4285),
    [anon_sym_RBRACE] = ACTIONS(4285),
    [anon_sym_RPAREN] = ACTIONS(4285),
    [anon_sym_DOT] = ACTIONS(4287),
    [anon_sym_COMMA] = ACTIONS(4285),
    [anon_sym_PIPE] = ACTIONS(4287),
    [anon_sym_SEMI] = ACTIONS(4285),
    [anon_sym_STAR_STAR] = ACTIONS(4285),
    [anon_sym_AMP] = ACTIONS(4287),
    [anon_sym_EQ] = ACTIONS(4287),
    [anon_sym_LT] = ACTIONS(4287),
    [anon_sym_if] = ACTIONS(4285),
    [anon_sym_unless] = ACTIONS(4285),
    [anon_sym_while] = ACTIONS(4285),
    [anon_sym_until] = ACTIONS(4285),
    [anon_sym_rescue] = ACTIONS(4285),
    [anon_sym_in] = ACTIONS(4285),
    [anon_sym_do] = ACTIONS(4285),
    [anon_sym_EQ_GT] = ACTIONS(4285),
    [anon_sym_LBRACK] = ACTIONS(4285),
    [anon_sym_RBRACK] = ACTIONS(4285),
    [anon_sym_COLON_COLON2] = ACTIONS(4285),
    [anon_sym_AMP_DOT] = ACTIONS(4285),
    [anon_sym_QMARK] = ACTIONS(4285),
    [anon_sym_COLON2] = ACTIONS(4287),
    [anon_sym_DOT_DOT] = ACTIONS(4287),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4285),
    [anon_sym_and] = ACTIONS(4285),
    [anon_sym_or] = ACTIONS(4285),
    [anon_sym_PIPE_PIPE] = ACTIONS(4285),
    [anon_sym_AMP_AMP] = ACTIONS(4285),
    [anon_sym_LT_LT] = ACTIONS(4285),
    [anon_sym_GT_GT] = ACTIONS(4285),
    [anon_sym_EQ_EQ] = ACTIONS(4287),
    [anon_sym_BANG_EQ] = ACTIONS(4285),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4285),
    [anon_sym_LT_EQ_GT] = ACTIONS(4285),
    [anon_sym_EQ_TILDE] = ACTIONS(4285),
    [anon_sym_BANG_TILDE] = ACTIONS(4285),
    [anon_sym_LT_EQ] = ACTIONS(4287),
    [anon_sym_GT] = ACTIONS(4287),
    [anon_sym_GT_EQ] = ACTIONS(4285),
    [anon_sym_CARET] = ACTIONS(4285),
    [anon_sym_PLUS] = ACTIONS(4285),
    [anon_sym_SLASH] = ACTIONS(4285),
    [anon_sym_PERCENT] = ACTIONS(4285),
    [sym_comment] = ACTIONS(87),
  },
  [1870] = {
    [anon_sym_RPAREN] = ACTIONS(6999),
    [sym_comment] = ACTIONS(87),
  },
  [1871] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(3371),
    [sym__binary_star] = ACTIONS(3373),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(3375),
    [anon_sym_STAR_STAR] = ACTIONS(3373),
    [anon_sym_AMP] = ACTIONS(3377),
    [anon_sym_LT] = ACTIONS(3379),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(3381),
    [anon_sym_DOT_DOT] = ACTIONS(3383),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3385),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(3387),
    [anon_sym_AMP_AMP] = ACTIONS(3387),
    [anon_sym_LT_LT] = ACTIONS(3389),
    [anon_sym_GT_GT] = ACTIONS(3389),
    [anon_sym_EQ_EQ] = ACTIONS(3391),
    [anon_sym_BANG_EQ] = ACTIONS(3387),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3387),
    [anon_sym_LT_EQ_GT] = ACTIONS(3387),
    [anon_sym_EQ_TILDE] = ACTIONS(3387),
    [anon_sym_BANG_TILDE] = ACTIONS(3387),
    [anon_sym_LT_EQ] = ACTIONS(3379),
    [anon_sym_GT] = ACTIONS(3379),
    [anon_sym_GT_EQ] = ACTIONS(3393),
    [anon_sym_CARET] = ACTIONS(3395),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_SLASH] = ACTIONS(3373),
    [anon_sym_PERCENT] = ACTIONS(3373),
    [sym_comment] = ACTIONS(87),
  },
  [1872] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(935),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_in] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_RBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_COLON2] = ACTIONS(937),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [1873] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4236),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(567),
    [sym_scope_resolution] = STATE(562),
    [sym_call] = STATE(562),
    [sym_method_call] = STATE(567),
    [sym_assignment] = STATE(4236),
    [sym_operator_assignment] = STATE(4236),
    [sym_conditional] = STATE(4236),
    [sym_range] = STATE(4236),
    [sym_binary] = STATE(4236),
    [sym_unary] = STATE(4236),
    [sym_left_assignment_list] = STATE(566),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(567),
    [sym__variable] = STATE(562),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(567),
    [sym_false] = STATE(567),
    [sym_nil] = STATE(567),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1862),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1049),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1079),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1874] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4237),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(567),
    [sym_scope_resolution] = STATE(562),
    [sym_call] = STATE(562),
    [sym_method_call] = STATE(567),
    [sym_assignment] = STATE(4237),
    [sym_operator_assignment] = STATE(4237),
    [sym_conditional] = STATE(4237),
    [sym_range] = STATE(4237),
    [sym_binary] = STATE(4237),
    [sym_unary] = STATE(4237),
    [sym_left_assignment_list] = STATE(566),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(567),
    [sym__variable] = STATE(562),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(567),
    [sym_false] = STATE(567),
    [sym_nil] = STATE(567),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1862),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1049),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1079),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1875] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4238),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(567),
    [sym_scope_resolution] = STATE(562),
    [sym_call] = STATE(562),
    [sym_method_call] = STATE(567),
    [sym_assignment] = STATE(4238),
    [sym_operator_assignment] = STATE(4238),
    [sym_conditional] = STATE(4238),
    [sym_range] = STATE(4238),
    [sym_binary] = STATE(4238),
    [sym_unary] = STATE(4238),
    [sym_left_assignment_list] = STATE(566),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(567),
    [sym__variable] = STATE(562),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(567),
    [sym_false] = STATE(567),
    [sym_nil] = STATE(567),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1862),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1049),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1079),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1876] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4239),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(567),
    [sym_scope_resolution] = STATE(562),
    [sym_call] = STATE(562),
    [sym_method_call] = STATE(567),
    [sym_assignment] = STATE(4239),
    [sym_operator_assignment] = STATE(4239),
    [sym_conditional] = STATE(4239),
    [sym_range] = STATE(4239),
    [sym_binary] = STATE(4239),
    [sym_unary] = STATE(4239),
    [sym_left_assignment_list] = STATE(566),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(567),
    [sym__variable] = STATE(562),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(567),
    [sym_false] = STATE(567),
    [sym_nil] = STATE(567),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1862),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1049),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1079),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1877] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4240),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(567),
    [sym_scope_resolution] = STATE(562),
    [sym_call] = STATE(562),
    [sym_method_call] = STATE(567),
    [sym_assignment] = STATE(4240),
    [sym_operator_assignment] = STATE(4240),
    [sym_conditional] = STATE(4240),
    [sym_range] = STATE(4240),
    [sym_binary] = STATE(4240),
    [sym_unary] = STATE(4240),
    [sym_left_assignment_list] = STATE(566),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(567),
    [sym__variable] = STATE(562),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(567),
    [sym_false] = STATE(567),
    [sym_nil] = STATE(567),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1862),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1049),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1079),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1878] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4241),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(567),
    [sym_scope_resolution] = STATE(562),
    [sym_call] = STATE(562),
    [sym_method_call] = STATE(567),
    [sym_assignment] = STATE(4241),
    [sym_operator_assignment] = STATE(4241),
    [sym_conditional] = STATE(4241),
    [sym_range] = STATE(4241),
    [sym_binary] = STATE(4241),
    [sym_unary] = STATE(4241),
    [sym_left_assignment_list] = STATE(566),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(567),
    [sym__variable] = STATE(562),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(567),
    [sym_false] = STATE(567),
    [sym_nil] = STATE(567),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1862),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1049),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1079),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1879] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(4242),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(4242),
    [sym_operator_assignment] = STATE(4242),
    [sym_conditional] = STATE(4242),
    [sym_range] = STATE(4242),
    [sym_binary] = STATE(4242),
    [sym_unary] = STATE(4242),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1880] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4243),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(567),
    [sym_scope_resolution] = STATE(562),
    [sym_call] = STATE(562),
    [sym_method_call] = STATE(567),
    [sym_assignment] = STATE(4243),
    [sym_operator_assignment] = STATE(4243),
    [sym_conditional] = STATE(4243),
    [sym_range] = STATE(4243),
    [sym_binary] = STATE(4243),
    [sym_unary] = STATE(4243),
    [sym_left_assignment_list] = STATE(566),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(567),
    [sym__variable] = STATE(562),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(567),
    [sym_false] = STATE(567),
    [sym_nil] = STATE(567),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1862),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1049),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1079),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1881] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4244),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(567),
    [sym_scope_resolution] = STATE(562),
    [sym_call] = STATE(562),
    [sym_method_call] = STATE(567),
    [sym_assignment] = STATE(4244),
    [sym_operator_assignment] = STATE(4244),
    [sym_conditional] = STATE(4244),
    [sym_range] = STATE(4244),
    [sym_binary] = STATE(4244),
    [sym_unary] = STATE(4244),
    [sym_left_assignment_list] = STATE(566),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(567),
    [sym__variable] = STATE(562),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(567),
    [sym_false] = STATE(567),
    [sym_nil] = STATE(567),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1862),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1049),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1079),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1882] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4245),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(567),
    [sym_scope_resolution] = STATE(562),
    [sym_call] = STATE(562),
    [sym_method_call] = STATE(567),
    [sym_assignment] = STATE(4245),
    [sym_operator_assignment] = STATE(4245),
    [sym_conditional] = STATE(4245),
    [sym_range] = STATE(4245),
    [sym_binary] = STATE(4245),
    [sym_unary] = STATE(4245),
    [sym_left_assignment_list] = STATE(566),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(567),
    [sym__variable] = STATE(562),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(567),
    [sym_false] = STATE(567),
    [sym_nil] = STATE(567),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1862),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1049),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1079),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1883] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4246),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(567),
    [sym_scope_resolution] = STATE(562),
    [sym_call] = STATE(562),
    [sym_method_call] = STATE(567),
    [sym_assignment] = STATE(4246),
    [sym_operator_assignment] = STATE(4246),
    [sym_conditional] = STATE(4246),
    [sym_range] = STATE(4246),
    [sym_binary] = STATE(4246),
    [sym_unary] = STATE(4246),
    [sym_left_assignment_list] = STATE(566),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(567),
    [sym__variable] = STATE(562),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(567),
    [sym_false] = STATE(567),
    [sym_nil] = STATE(567),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1862),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1049),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1079),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1884] = {
    [sym_interpolation] = STATE(4248),
    [aux_sym_heredoc_body_repeat1] = STATE(4248),
    [sym__heredoc_content] = ACTIONS(7001),
    [sym_heredoc_end] = ACTIONS(7003),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(7001),
  },
  [1885] = {
    [sym_heredoc_body] = STATE(4249),
    [aux_sym_call_repeat1] = STATE(4249),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [1886] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(561),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(567),
    [sym_scope_resolution] = STATE(562),
    [sym_call] = STATE(562),
    [sym_method_call] = STATE(567),
    [sym__argument] = STATE(4250),
    [sym_splat_argument] = STATE(4250),
    [sym_hash_splat_argument] = STATE(4250),
    [sym_block_argument] = STATE(4250),
    [sym_assignment] = STATE(561),
    [sym_operator_assignment] = STATE(561),
    [sym_conditional] = STATE(561),
    [sym_range] = STATE(561),
    [sym_binary] = STATE(561),
    [sym_unary] = STATE(561),
    [sym_left_assignment_list] = STATE(566),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(567),
    [sym__variable] = STATE(562),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(567),
    [sym_false] = STATE(567),
    [sym_nil] = STATE(567),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(568),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_heredoc_body] = STATE(4251),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(4250),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1047),
    [sym__unary_minus] = ACTIONS(1049),
    [sym__identifier_hash_key] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(7005),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(1075),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1887] = {
    [sym_heredoc_body] = STATE(4252),
    [aux_sym_call_repeat1] = STATE(4252),
    [aux_sym_argument_list_repeat1] = STATE(4253),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(3399),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [1888] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4254),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(567),
    [sym_scope_resolution] = STATE(562),
    [sym_call] = STATE(562),
    [sym_method_call] = STATE(567),
    [sym_splat_argument] = STATE(4256),
    [sym_assignment] = STATE(4254),
    [sym_operator_assignment] = STATE(4254),
    [sym_conditional] = STATE(4254),
    [sym_range] = STATE(4254),
    [sym_binary] = STATE(4254),
    [sym_unary] = STATE(4254),
    [sym_right_assignment_list] = STATE(4255),
    [sym__arg_or_splat_arg] = STATE(4256),
    [sym_left_assignment_list] = STATE(566),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(567),
    [sym__variable] = STATE(562),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(567),
    [sym_false] = STATE(567),
    [sym_nil] = STATE(567),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1862),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(1047),
    [sym__unary_minus] = ACTIONS(1049),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1079),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1889] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4257),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(567),
    [sym_scope_resolution] = STATE(562),
    [sym_call] = STATE(562),
    [sym_method_call] = STATE(567),
    [sym_assignment] = STATE(4257),
    [sym_operator_assignment] = STATE(4257),
    [sym_conditional] = STATE(4257),
    [sym_range] = STATE(4257),
    [sym_binary] = STATE(4257),
    [sym_unary] = STATE(4257),
    [sym_left_assignment_list] = STATE(566),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(567),
    [sym__variable] = STATE(562),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(567),
    [sym_false] = STATE(567),
    [sym_nil] = STATE(567),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1862),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1049),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1079),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1890] = {
    [sym_string] = STATE(4258),
    [aux_sym_chained_string_repeat1] = STATE(4258),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_EQ_GT] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [1891] = {
    [sym_elsif] = STATE(4260),
    [sym_else] = STATE(4260),
    [anon_sym_end] = ACTIONS(7007),
    [anon_sym_elsif] = ACTIONS(4495),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [1892] = {
    [sym__statements] = STATE(2640),
    [sym_begin_block] = STATE(2641),
    [sym_end_block] = STATE(2641),
    [sym__statement] = STATE(2641),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(2641),
    [sym_unless_modifier] = STATE(2641),
    [sym_while_modifier] = STATE(2641),
    [sym_until_modifier] = STATE(2641),
    [sym_rescue_modifier] = STATE(2641),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_elsif] = STATE(4260),
    [sym_else] = STATE(4260),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2642),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2645),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(2645),
    [sym_assignment] = STATE(2642),
    [sym_operator_assignment] = STATE(2642),
    [sym_conditional] = STATE(2642),
    [sym_range] = STATE(2642),
    [sym_binary] = STATE(2642),
    [sym_unary] = STATE(2642),
    [sym_left_assignment_list] = STATE(2644),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2645),
    [sym__variable] = STATE(2643),
    [sym_undef] = STATE(2641),
    [sym_alias] = STATE(2641),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2645),
    [sym_false] = STATE(2645),
    [sym_nil] = STATE(2645),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2646),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(2647),
    [aux_sym__statements_repeat1] = STATE(2647),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4467),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(7009),
    [anon_sym_return] = ACTIONS(4471),
    [anon_sym_yield] = ACTIONS(4473),
    [anon_sym_break] = ACTIONS(4475),
    [anon_sym_next] = ACTIONS(4477),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(4499),
    [anon_sym_else] = ACTIONS(4501),
    [anon_sym_then] = ACTIONS(4503),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4479),
    [anon_sym_defined_QMARK] = ACTIONS(4481),
    [anon_sym_not] = ACTIONS(4483),
    [anon_sym_BANG] = ACTIONS(4485),
    [anon_sym_TILDE] = ACTIONS(4485),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [anon_sym_undef] = ACTIONS(4491),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1893] = {
    [sym_else] = STATE(4262),
    [anon_sym_end] = ACTIONS(7011),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [1894] = {
    [sym__statements] = STATE(2640),
    [sym_begin_block] = STATE(2715),
    [sym_end_block] = STATE(2715),
    [sym__statement] = STATE(2715),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(2715),
    [sym_unless_modifier] = STATE(2715),
    [sym_while_modifier] = STATE(2715),
    [sym_until_modifier] = STATE(2715),
    [sym_rescue_modifier] = STATE(2715),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(4262),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2716),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2719),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(2719),
    [sym_assignment] = STATE(2716),
    [sym_operator_assignment] = STATE(2716),
    [sym_conditional] = STATE(2716),
    [sym_range] = STATE(2716),
    [sym_binary] = STATE(2716),
    [sym_unary] = STATE(2716),
    [sym_left_assignment_list] = STATE(2718),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2719),
    [sym__variable] = STATE(2717),
    [sym_undef] = STATE(2715),
    [sym_alias] = STATE(2715),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2719),
    [sym_false] = STATE(2719),
    [sym_nil] = STATE(2719),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2720),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(2721),
    [aux_sym__statements_repeat1] = STATE(2721),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4583),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(7013),
    [anon_sym_return] = ACTIONS(4585),
    [anon_sym_yield] = ACTIONS(4587),
    [anon_sym_break] = ACTIONS(4589),
    [anon_sym_next] = ACTIONS(4591),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(4501),
    [anon_sym_then] = ACTIONS(4611),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4593),
    [anon_sym_defined_QMARK] = ACTIONS(4595),
    [anon_sym_not] = ACTIONS(4597),
    [anon_sym_BANG] = ACTIONS(4599),
    [anon_sym_TILDE] = ACTIONS(4599),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [anon_sym_undef] = ACTIONS(4605),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1895] = {
    [sym__statements] = STATE(4264),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(7015),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1896] = {
    [sym__statements] = STATE(4266),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(7017),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1897] = {
    [sym__do] = STATE(4267),
    [sym_heredoc_body] = STATE(4267),
    [sym__terminator] = STATE(4267),
    [sym__line_break] = ACTIONS(7019),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(7019),
    [anon_sym_do] = ACTIONS(7019),
    [sym_comment] = ACTIONS(87),
  },
  [1898] = {
    [sym_when] = STATE(4271),
    [sym_else] = STATE(4269),
    [aux_sym_case_repeat1] = STATE(4270),
    [aux_sym_case_repeat2] = STATE(4271),
    [anon_sym_SEMI] = ACTIONS(7021),
    [anon_sym_end] = ACTIONS(7023),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [1899] = {
    [sym__binary_minus] = ACTIONS(4965),
    [sym__binary_star] = ACTIONS(4965),
    [anon_sym_LBRACE] = ACTIONS(4965),
    [anon_sym_RBRACE] = ACTIONS(4965),
    [anon_sym_RPAREN] = ACTIONS(4965),
    [anon_sym_DOT] = ACTIONS(4967),
    [anon_sym_COMMA] = ACTIONS(4965),
    [anon_sym_PIPE] = ACTIONS(4967),
    [anon_sym_SEMI] = ACTIONS(4965),
    [anon_sym_STAR_STAR] = ACTIONS(4965),
    [anon_sym_AMP] = ACTIONS(4967),
    [anon_sym_LT] = ACTIONS(4967),
    [anon_sym_if] = ACTIONS(4965),
    [anon_sym_unless] = ACTIONS(4965),
    [anon_sym_while] = ACTIONS(4965),
    [anon_sym_until] = ACTIONS(4965),
    [anon_sym_rescue] = ACTIONS(4965),
    [anon_sym_do] = ACTIONS(4965),
    [anon_sym_EQ_GT] = ACTIONS(4965),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym_COLON_COLON2] = ACTIONS(4965),
    [anon_sym_AMP_DOT] = ACTIONS(4965),
    [anon_sym_QMARK] = ACTIONS(4965),
    [anon_sym_COLON2] = ACTIONS(4967),
    [anon_sym_DOT_DOT] = ACTIONS(4967),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4965),
    [anon_sym_and] = ACTIONS(4965),
    [anon_sym_or] = ACTIONS(4965),
    [anon_sym_PIPE_PIPE] = ACTIONS(4965),
    [anon_sym_AMP_AMP] = ACTIONS(4965),
    [anon_sym_LT_LT] = ACTIONS(4965),
    [anon_sym_GT_GT] = ACTIONS(4965),
    [anon_sym_EQ_EQ] = ACTIONS(4967),
    [anon_sym_BANG_EQ] = ACTIONS(4965),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4965),
    [anon_sym_LT_EQ_GT] = ACTIONS(4965),
    [anon_sym_EQ_TILDE] = ACTIONS(4965),
    [anon_sym_BANG_TILDE] = ACTIONS(4965),
    [anon_sym_LT_EQ] = ACTIONS(4967),
    [anon_sym_GT] = ACTIONS(4967),
    [anon_sym_GT_EQ] = ACTIONS(4965),
    [anon_sym_CARET] = ACTIONS(4965),
    [anon_sym_PLUS] = ACTIONS(4965),
    [anon_sym_SLASH] = ACTIONS(4965),
    [anon_sym_PERCENT] = ACTIONS(4965),
    [sym_comment] = ACTIONS(87),
  },
  [1900] = {
    [anon_sym_end] = ACTIONS(7023),
    [sym_comment] = ACTIONS(87),
  },
  [1901] = {
    [sym_when] = STATE(4271),
    [sym_else] = STATE(4269),
    [aux_sym_case_repeat1] = STATE(2987),
    [aux_sym_case_repeat2] = STATE(4271),
    [anon_sym_SEMI] = ACTIONS(4995),
    [anon_sym_end] = ACTIONS(7023),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [1902] = {
    [sym_when] = STATE(2988),
    [sym_else] = STATE(4269),
    [aux_sym_case_repeat2] = STATE(2988),
    [anon_sym_end] = ACTIONS(7023),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [1903] = {
    [sym__binary_minus] = ACTIONS(5407),
    [sym__binary_star] = ACTIONS(5407),
    [anon_sym_LBRACE] = ACTIONS(5407),
    [anon_sym_RBRACE] = ACTIONS(5407),
    [anon_sym_RPAREN] = ACTIONS(5407),
    [anon_sym_DOT] = ACTIONS(5409),
    [anon_sym_COMMA] = ACTIONS(5407),
    [anon_sym_PIPE] = ACTIONS(5409),
    [anon_sym_SEMI] = ACTIONS(5407),
    [anon_sym_STAR_STAR] = ACTIONS(5407),
    [anon_sym_AMP] = ACTIONS(5409),
    [anon_sym_LT] = ACTIONS(5409),
    [anon_sym_if] = ACTIONS(5407),
    [anon_sym_unless] = ACTIONS(5407),
    [anon_sym_while] = ACTIONS(5407),
    [anon_sym_until] = ACTIONS(5407),
    [anon_sym_rescue] = ACTIONS(5407),
    [anon_sym_do] = ACTIONS(5407),
    [anon_sym_EQ_GT] = ACTIONS(5407),
    [anon_sym_LBRACK] = ACTIONS(5407),
    [anon_sym_COLON_COLON2] = ACTIONS(5407),
    [anon_sym_AMP_DOT] = ACTIONS(5407),
    [anon_sym_QMARK] = ACTIONS(5407),
    [anon_sym_COLON2] = ACTIONS(5409),
    [anon_sym_DOT_DOT] = ACTIONS(5409),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5407),
    [anon_sym_and] = ACTIONS(5407),
    [anon_sym_or] = ACTIONS(5407),
    [anon_sym_PIPE_PIPE] = ACTIONS(5407),
    [anon_sym_AMP_AMP] = ACTIONS(5407),
    [anon_sym_LT_LT] = ACTIONS(5407),
    [anon_sym_GT_GT] = ACTIONS(5407),
    [anon_sym_EQ_EQ] = ACTIONS(5409),
    [anon_sym_BANG_EQ] = ACTIONS(5407),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5407),
    [anon_sym_LT_EQ_GT] = ACTIONS(5407),
    [anon_sym_EQ_TILDE] = ACTIONS(5407),
    [anon_sym_BANG_TILDE] = ACTIONS(5407),
    [anon_sym_LT_EQ] = ACTIONS(5409),
    [anon_sym_GT] = ACTIONS(5409),
    [anon_sym_GT_EQ] = ACTIONS(5407),
    [anon_sym_CARET] = ACTIONS(5407),
    [anon_sym_PLUS] = ACTIONS(5407),
    [anon_sym_SLASH] = ACTIONS(5407),
    [anon_sym_PERCENT] = ACTIONS(5407),
    [sym_comment] = ACTIONS(87),
  },
  [1904] = {
    [sym_ensure] = STATE(4273),
    [anon_sym_end] = ACTIONS(7025),
    [anon_sym_ensure] = ACTIONS(2169),
    [sym_comment] = ACTIONS(87),
  },
  [1905] = {
    [anon_sym_end] = ACTIONS(7025),
    [sym_comment] = ACTIONS(87),
  },
  [1906] = {
    [sym_else] = STATE(4274),
    [sym_ensure] = STATE(4273),
    [anon_sym_end] = ACTIONS(7025),
    [anon_sym_else] = ACTIONS(2167),
    [anon_sym_ensure] = ACTIONS(2169),
    [sym_comment] = ACTIONS(87),
  },
  [1907] = {
    [sym__binary_minus] = ACTIONS(5491),
    [sym__binary_star] = ACTIONS(5491),
    [anon_sym_LBRACE] = ACTIONS(5491),
    [anon_sym_RBRACE] = ACTIONS(5491),
    [anon_sym_RPAREN] = ACTIONS(5491),
    [anon_sym_DOT] = ACTIONS(5493),
    [anon_sym_COMMA] = ACTIONS(5491),
    [anon_sym_PIPE] = ACTIONS(5493),
    [anon_sym_SEMI] = ACTIONS(5491),
    [anon_sym_STAR_STAR] = ACTIONS(5491),
    [anon_sym_AMP] = ACTIONS(5493),
    [anon_sym_LT] = ACTIONS(5493),
    [anon_sym_if] = ACTIONS(5491),
    [anon_sym_unless] = ACTIONS(5491),
    [anon_sym_while] = ACTIONS(5491),
    [anon_sym_until] = ACTIONS(5491),
    [anon_sym_rescue] = ACTIONS(5491),
    [anon_sym_do] = ACTIONS(5491),
    [anon_sym_EQ_GT] = ACTIONS(5491),
    [anon_sym_LBRACK] = ACTIONS(5491),
    [anon_sym_COLON_COLON2] = ACTIONS(5491),
    [anon_sym_AMP_DOT] = ACTIONS(5491),
    [anon_sym_QMARK] = ACTIONS(5491),
    [anon_sym_COLON2] = ACTIONS(5493),
    [anon_sym_DOT_DOT] = ACTIONS(5493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5491),
    [anon_sym_and] = ACTIONS(5491),
    [anon_sym_or] = ACTIONS(5491),
    [anon_sym_PIPE_PIPE] = ACTIONS(5491),
    [anon_sym_AMP_AMP] = ACTIONS(5491),
    [anon_sym_LT_LT] = ACTIONS(5491),
    [anon_sym_GT_GT] = ACTIONS(5491),
    [anon_sym_EQ_EQ] = ACTIONS(5493),
    [anon_sym_BANG_EQ] = ACTIONS(5491),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5491),
    [anon_sym_LT_EQ_GT] = ACTIONS(5491),
    [anon_sym_EQ_TILDE] = ACTIONS(5491),
    [anon_sym_BANG_TILDE] = ACTIONS(5491),
    [anon_sym_LT_EQ] = ACTIONS(5493),
    [anon_sym_GT] = ACTIONS(5493),
    [anon_sym_GT_EQ] = ACTIONS(5491),
    [anon_sym_CARET] = ACTIONS(5491),
    [anon_sym_PLUS] = ACTIONS(5491),
    [anon_sym_SLASH] = ACTIONS(5491),
    [anon_sym_PERCENT] = ACTIONS(5491),
    [sym_comment] = ACTIONS(87),
  },
  [1908] = {
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(3283),
    [sym__binary_star] = ACTIONS(3285),
    [anon_sym_RBRACE] = ACTIONS(7027),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(3287),
    [anon_sym_STAR_STAR] = ACTIONS(3285),
    [anon_sym_AMP] = ACTIONS(3289),
    [anon_sym_LT] = ACTIONS(3291),
    [anon_sym_QMARK] = ACTIONS(3293),
    [anon_sym_DOT_DOT] = ACTIONS(3295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3297),
    [anon_sym_and] = ACTIONS(3299),
    [anon_sym_or] = ACTIONS(3299),
    [anon_sym_PIPE_PIPE] = ACTIONS(3301),
    [anon_sym_AMP_AMP] = ACTIONS(3301),
    [anon_sym_LT_LT] = ACTIONS(3303),
    [anon_sym_GT_GT] = ACTIONS(3303),
    [anon_sym_EQ_EQ] = ACTIONS(3305),
    [anon_sym_BANG_EQ] = ACTIONS(3301),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3301),
    [anon_sym_LT_EQ_GT] = ACTIONS(3301),
    [anon_sym_EQ_TILDE] = ACTIONS(3301),
    [anon_sym_BANG_TILDE] = ACTIONS(3301),
    [anon_sym_LT_EQ] = ACTIONS(3291),
    [anon_sym_GT] = ACTIONS(3291),
    [anon_sym_GT_EQ] = ACTIONS(3307),
    [anon_sym_CARET] = ACTIONS(3309),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_SLASH] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [sym_comment] = ACTIONS(87),
  },
  [1909] = {
    [sym__binary_minus] = ACTIONS(5725),
    [sym__binary_star] = ACTIONS(5725),
    [anon_sym_LBRACE] = ACTIONS(5725),
    [anon_sym_RBRACE] = ACTIONS(5725),
    [anon_sym_RPAREN] = ACTIONS(5725),
    [anon_sym_DOT] = ACTIONS(5727),
    [anon_sym_COMMA] = ACTIONS(5725),
    [anon_sym_PIPE] = ACTIONS(5727),
    [anon_sym_SEMI] = ACTIONS(5725),
    [anon_sym_STAR_STAR] = ACTIONS(5725),
    [anon_sym_AMP] = ACTIONS(5727),
    [anon_sym_LT] = ACTIONS(5727),
    [anon_sym_if] = ACTIONS(5725),
    [anon_sym_unless] = ACTIONS(5725),
    [anon_sym_while] = ACTIONS(5725),
    [anon_sym_until] = ACTIONS(5725),
    [anon_sym_rescue] = ACTIONS(5725),
    [anon_sym_do] = ACTIONS(5725),
    [anon_sym_EQ_GT] = ACTIONS(5725),
    [anon_sym_LBRACK] = ACTIONS(5725),
    [anon_sym_COLON_COLON2] = ACTIONS(5725),
    [anon_sym_AMP_DOT] = ACTIONS(5725),
    [anon_sym_QMARK] = ACTIONS(5725),
    [anon_sym_COLON2] = ACTIONS(5727),
    [anon_sym_DOT_DOT] = ACTIONS(5727),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5725),
    [anon_sym_and] = ACTIONS(5725),
    [anon_sym_or] = ACTIONS(5725),
    [anon_sym_PIPE_PIPE] = ACTIONS(5725),
    [anon_sym_AMP_AMP] = ACTIONS(5725),
    [anon_sym_LT_LT] = ACTIONS(5725),
    [anon_sym_GT_GT] = ACTIONS(5725),
    [anon_sym_EQ_EQ] = ACTIONS(5727),
    [anon_sym_BANG_EQ] = ACTIONS(5725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5725),
    [anon_sym_LT_EQ_GT] = ACTIONS(5725),
    [anon_sym_EQ_TILDE] = ACTIONS(5725),
    [anon_sym_BANG_TILDE] = ACTIONS(5725),
    [anon_sym_LT_EQ] = ACTIONS(5727),
    [anon_sym_GT] = ACTIONS(5727),
    [anon_sym_GT_EQ] = ACTIONS(5725),
    [anon_sym_CARET] = ACTIONS(5725),
    [anon_sym_PLUS] = ACTIONS(5725),
    [anon_sym_SLASH] = ACTIONS(5725),
    [anon_sym_PERCENT] = ACTIONS(5725),
    [sym_comment] = ACTIONS(87),
  },
  [1910] = {
    [sym__binary_minus] = ACTIONS(5735),
    [sym__binary_star] = ACTIONS(5735),
    [anon_sym_LBRACE] = ACTIONS(5735),
    [anon_sym_RBRACE] = ACTIONS(5735),
    [anon_sym_RPAREN] = ACTIONS(5735),
    [anon_sym_DOT] = ACTIONS(5737),
    [anon_sym_COMMA] = ACTIONS(5735),
    [anon_sym_PIPE] = ACTIONS(5737),
    [anon_sym_SEMI] = ACTIONS(5735),
    [anon_sym_STAR_STAR] = ACTIONS(5735),
    [anon_sym_AMP] = ACTIONS(5737),
    [anon_sym_LT] = ACTIONS(5737),
    [anon_sym_if] = ACTIONS(5735),
    [anon_sym_unless] = ACTIONS(5735),
    [anon_sym_while] = ACTIONS(5735),
    [anon_sym_until] = ACTIONS(5735),
    [anon_sym_rescue] = ACTIONS(5735),
    [anon_sym_do] = ACTIONS(5735),
    [anon_sym_EQ_GT] = ACTIONS(5735),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_COLON_COLON2] = ACTIONS(5735),
    [anon_sym_AMP_DOT] = ACTIONS(5735),
    [anon_sym_QMARK] = ACTIONS(5735),
    [anon_sym_COLON2] = ACTIONS(5737),
    [anon_sym_DOT_DOT] = ACTIONS(5737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5735),
    [anon_sym_and] = ACTIONS(5735),
    [anon_sym_or] = ACTIONS(5735),
    [anon_sym_PIPE_PIPE] = ACTIONS(5735),
    [anon_sym_AMP_AMP] = ACTIONS(5735),
    [anon_sym_LT_LT] = ACTIONS(5735),
    [anon_sym_GT_GT] = ACTIONS(5735),
    [anon_sym_EQ_EQ] = ACTIONS(5737),
    [anon_sym_BANG_EQ] = ACTIONS(5735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5735),
    [anon_sym_LT_EQ_GT] = ACTIONS(5735),
    [anon_sym_EQ_TILDE] = ACTIONS(5735),
    [anon_sym_BANG_TILDE] = ACTIONS(5735),
    [anon_sym_LT_EQ] = ACTIONS(5737),
    [anon_sym_GT] = ACTIONS(5737),
    [anon_sym_GT_EQ] = ACTIONS(5735),
    [anon_sym_CARET] = ACTIONS(5735),
    [anon_sym_PLUS] = ACTIONS(5735),
    [anon_sym_SLASH] = ACTIONS(5735),
    [anon_sym_PERCENT] = ACTIONS(5735),
    [sym_comment] = ACTIONS(87),
  },
  [1911] = {
    [anon_sym_RBRACE] = ACTIONS(7029),
    [sym_comment] = ACTIONS(87),
  },
  [1912] = {
    [sym__statements] = STATE(4276),
    [sym_begin_block] = STATE(489),
    [sym_end_block] = STATE(489),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(495),
    [aux_sym__statements_repeat1] = STATE(495),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(7029),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1913] = {
    [sym__binary_minus] = ACTIONS(5771),
    [sym__binary_star] = ACTIONS(5771),
    [anon_sym_LBRACE] = ACTIONS(5771),
    [anon_sym_RBRACE] = ACTIONS(5771),
    [anon_sym_RPAREN] = ACTIONS(5771),
    [anon_sym_DOT] = ACTIONS(5773),
    [anon_sym_COMMA] = ACTIONS(5771),
    [anon_sym_PIPE] = ACTIONS(5773),
    [anon_sym_SEMI] = ACTIONS(5771),
    [anon_sym_STAR_STAR] = ACTIONS(5771),
    [anon_sym_AMP] = ACTIONS(5773),
    [anon_sym_LT] = ACTIONS(5773),
    [anon_sym_if] = ACTIONS(5771),
    [anon_sym_unless] = ACTIONS(5771),
    [anon_sym_while] = ACTIONS(5771),
    [anon_sym_until] = ACTIONS(5771),
    [anon_sym_rescue] = ACTIONS(5771),
    [anon_sym_do] = ACTIONS(5771),
    [anon_sym_EQ_GT] = ACTIONS(5771),
    [anon_sym_LBRACK] = ACTIONS(5771),
    [anon_sym_COLON_COLON2] = ACTIONS(5771),
    [anon_sym_AMP_DOT] = ACTIONS(5771),
    [anon_sym_QMARK] = ACTIONS(5771),
    [anon_sym_COLON2] = ACTIONS(5773),
    [anon_sym_DOT_DOT] = ACTIONS(5773),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5771),
    [anon_sym_and] = ACTIONS(5771),
    [anon_sym_or] = ACTIONS(5771),
    [anon_sym_PIPE_PIPE] = ACTIONS(5771),
    [anon_sym_AMP_AMP] = ACTIONS(5771),
    [anon_sym_LT_LT] = ACTIONS(5771),
    [anon_sym_GT_GT] = ACTIONS(5771),
    [anon_sym_EQ_EQ] = ACTIONS(5773),
    [anon_sym_BANG_EQ] = ACTIONS(5771),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5771),
    [anon_sym_LT_EQ_GT] = ACTIONS(5771),
    [anon_sym_EQ_TILDE] = ACTIONS(5771),
    [anon_sym_BANG_TILDE] = ACTIONS(5771),
    [anon_sym_LT_EQ] = ACTIONS(5773),
    [anon_sym_GT] = ACTIONS(5773),
    [anon_sym_GT_EQ] = ACTIONS(5771),
    [anon_sym_CARET] = ACTIONS(5771),
    [anon_sym_PLUS] = ACTIONS(5771),
    [anon_sym_SLASH] = ACTIONS(5771),
    [anon_sym_PERCENT] = ACTIONS(5771),
    [sym_comment] = ACTIONS(87),
  },
  [1914] = {
    [anon_sym_end] = ACTIONS(7031),
    [sym_comment] = ACTIONS(87),
  },
  [1915] = {
    [sym__statements] = STATE(4278),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_heredoc_body] = STATE(4279),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [sym__terminator] = STATE(4279),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__line_break] = ACTIONS(7033),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(7033),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(7035),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1916] = {
    [sym__statements] = STATE(4278),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_block_parameters] = STATE(4280),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(7035),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1917] = {
    [sym__binary_minus] = ACTIONS(5807),
    [sym__binary_star] = ACTIONS(5807),
    [anon_sym_LBRACE] = ACTIONS(5807),
    [anon_sym_RBRACE] = ACTIONS(5807),
    [anon_sym_RPAREN] = ACTIONS(5807),
    [anon_sym_DOT] = ACTIONS(5809),
    [anon_sym_COMMA] = ACTIONS(5807),
    [anon_sym_PIPE] = ACTIONS(5809),
    [anon_sym_SEMI] = ACTIONS(5807),
    [anon_sym_STAR_STAR] = ACTIONS(5807),
    [anon_sym_AMP] = ACTIONS(5809),
    [anon_sym_LT] = ACTIONS(5809),
    [anon_sym_if] = ACTIONS(5807),
    [anon_sym_unless] = ACTIONS(5807),
    [anon_sym_while] = ACTIONS(5807),
    [anon_sym_until] = ACTIONS(5807),
    [anon_sym_rescue] = ACTIONS(5807),
    [anon_sym_do] = ACTIONS(5807),
    [anon_sym_EQ_GT] = ACTIONS(5807),
    [anon_sym_LBRACK] = ACTIONS(5807),
    [anon_sym_COLON_COLON2] = ACTIONS(5807),
    [anon_sym_AMP_DOT] = ACTIONS(5807),
    [anon_sym_QMARK] = ACTIONS(5807),
    [anon_sym_COLON2] = ACTIONS(5809),
    [anon_sym_DOT_DOT] = ACTIONS(5809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5807),
    [anon_sym_and] = ACTIONS(5807),
    [anon_sym_or] = ACTIONS(5807),
    [anon_sym_PIPE_PIPE] = ACTIONS(5807),
    [anon_sym_AMP_AMP] = ACTIONS(5807),
    [anon_sym_LT_LT] = ACTIONS(5807),
    [anon_sym_GT_GT] = ACTIONS(5807),
    [anon_sym_EQ_EQ] = ACTIONS(5809),
    [anon_sym_BANG_EQ] = ACTIONS(5807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5807),
    [anon_sym_LT_EQ_GT] = ACTIONS(5807),
    [anon_sym_EQ_TILDE] = ACTIONS(5807),
    [anon_sym_BANG_TILDE] = ACTIONS(5807),
    [anon_sym_LT_EQ] = ACTIONS(5809),
    [anon_sym_GT] = ACTIONS(5809),
    [anon_sym_GT_EQ] = ACTIONS(5807),
    [anon_sym_CARET] = ACTIONS(5807),
    [anon_sym_PLUS] = ACTIONS(5807),
    [anon_sym_SLASH] = ACTIONS(5807),
    [anon_sym_PERCENT] = ACTIONS(5807),
    [sym_comment] = ACTIONS(87),
  },
  [1918] = {
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(1105),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(1105),
    [anon_sym_PERCENT] = ACTIONS(1105),
    [sym_comment] = ACTIONS(87),
  },
  [1919] = {
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [1920] = {
    [sym__binary_minus] = ACTIONS(1103),
    [sym__binary_star] = ACTIONS(1105),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(1103),
    [anon_sym_SLASH] = ACTIONS(1105),
    [anon_sym_PERCENT] = ACTIONS(1105),
    [sym_comment] = ACTIONS(87),
  },
  [1921] = {
    [sym__binary_minus] = ACTIONS(1103),
    [sym__binary_star] = ACTIONS(1105),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(1103),
    [anon_sym_SLASH] = ACTIONS(1105),
    [anon_sym_PERCENT] = ACTIONS(1105),
    [sym_comment] = ACTIONS(87),
  },
  [1922] = {
    [sym__binary_minus] = ACTIONS(1103),
    [sym__binary_star] = ACTIONS(1105),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_STAR_STAR] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1103),
    [anon_sym_SLASH] = ACTIONS(1105),
    [anon_sym_PERCENT] = ACTIONS(1105),
    [sym_comment] = ACTIONS(87),
  },
  [1923] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(7037),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [1924] = {
    [sym__binary_minus] = ACTIONS(1103),
    [sym__binary_star] = ACTIONS(1105),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_STAR_STAR] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(1111),
    [anon_sym_EQ_GT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1117),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(1121),
    [anon_sym_AMP_AMP] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1125),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1121),
    [anon_sym_LT_EQ_GT] = ACTIONS(1121),
    [anon_sym_EQ_TILDE] = ACTIONS(1121),
    [anon_sym_BANG_TILDE] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1111),
    [anon_sym_GT] = ACTIONS(1111),
    [anon_sym_GT_EQ] = ACTIONS(1127),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1103),
    [anon_sym_SLASH] = ACTIONS(1105),
    [anon_sym_PERCENT] = ACTIONS(1105),
    [sym_comment] = ACTIONS(87),
  },
  [1925] = {
    [sym__binary_minus] = ACTIONS(1103),
    [sym__binary_star] = ACTIONS(1105),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_STAR_STAR] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(1111),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(1113),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1117),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(1121),
    [anon_sym_AMP_AMP] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1125),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1121),
    [anon_sym_LT_EQ_GT] = ACTIONS(1121),
    [anon_sym_EQ_TILDE] = ACTIONS(1121),
    [anon_sym_BANG_TILDE] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1111),
    [anon_sym_GT] = ACTIONS(1111),
    [anon_sym_GT_EQ] = ACTIONS(1127),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1103),
    [anon_sym_SLASH] = ACTIONS(1105),
    [anon_sym_PERCENT] = ACTIONS(1105),
    [sym_comment] = ACTIONS(87),
  },
  [1926] = {
    [sym__binary_minus] = ACTIONS(1103),
    [sym__binary_star] = ACTIONS(1105),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_STAR_STAR] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(1111),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1125),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1121),
    [anon_sym_LT_EQ_GT] = ACTIONS(1121),
    [anon_sym_EQ_TILDE] = ACTIONS(1121),
    [anon_sym_BANG_TILDE] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1111),
    [anon_sym_GT] = ACTIONS(1111),
    [anon_sym_GT_EQ] = ACTIONS(1127),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1103),
    [anon_sym_SLASH] = ACTIONS(1105),
    [anon_sym_PERCENT] = ACTIONS(1105),
    [sym_comment] = ACTIONS(87),
  },
  [1927] = {
    [sym__binary_minus] = ACTIONS(1103),
    [sym__binary_star] = ACTIONS(1105),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(1103),
    [anon_sym_SLASH] = ACTIONS(1105),
    [anon_sym_PERCENT] = ACTIONS(1105),
    [sym_comment] = ACTIONS(87),
  },
  [1928] = {
    [sym__simple_symbol] = ACTIONS(1263),
    [sym__string_start] = ACTIONS(1263),
    [sym__symbol_start] = ACTIONS(1263),
    [sym__subshell_start] = ACTIONS(1263),
    [sym__regex_start] = ACTIONS(1263),
    [sym__string_array_start] = ACTIONS(1263),
    [sym__symbol_array_start] = ACTIONS(1263),
    [sym_heredoc_beginning] = ACTIONS(1263),
    [sym__block_ampersand] = ACTIONS(1263),
    [sym__splat_star] = ACTIONS(1263),
    [sym__unary_minus] = ACTIONS(1263),
    [sym__binary_minus] = ACTIONS(1263),
    [sym__binary_star] = ACTIONS(1263),
    [sym__identifier_hash_key] = ACTIONS(1263),
    [anon_sym_LBRACE] = ACTIONS(1263),
    [anon_sym_def] = ACTIONS(1265),
    [anon_sym_LPAREN] = ACTIONS(1265),
    [anon_sym_DOT] = ACTIONS(1265),
    [anon_sym_COLON_COLON] = ACTIONS(1265),
    [anon_sym_COMMA] = ACTIONS(1263),
    [anon_sym_PIPE] = ACTIONS(1265),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_STAR_STAR] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1265),
    [anon_sym_EQ] = ACTIONS(1265),
    [anon_sym_class] = ACTIONS(1265),
    [anon_sym_LT] = ACTIONS(1265),
    [anon_sym_module] = ACTIONS(1265),
    [anon_sym_return] = ACTIONS(1265),
    [anon_sym_yield] = ACTIONS(1265),
    [anon_sym_break] = ACTIONS(1265),
    [anon_sym_next] = ACTIONS(1265),
    [sym_redo] = ACTIONS(1265),
    [sym_retry] = ACTIONS(1265),
    [anon_sym_if] = ACTIONS(1265),
    [anon_sym_unless] = ACTIONS(1265),
    [anon_sym_while] = ACTIONS(1265),
    [anon_sym_until] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1265),
    [anon_sym_do] = ACTIONS(1265),
    [anon_sym_case] = ACTIONS(1265),
    [anon_sym_begin] = ACTIONS(1265),
    [anon_sym_EQ_GT] = ACTIONS(1263),
    [anon_sym_LBRACK] = ACTIONS(1263),
    [anon_sym_COLON_COLON2] = ACTIONS(1263),
    [anon_sym_AMP_DOT] = ACTIONS(1263),
    [anon_sym_LPAREN2] = ACTIONS(1263),
    [anon_sym_PLUS_EQ] = ACTIONS(1263),
    [anon_sym_DASH_EQ] = ACTIONS(1263),
    [anon_sym_STAR_EQ] = ACTIONS(1263),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1263),
    [anon_sym_SLASH_EQ] = ACTIONS(1263),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1263),
    [anon_sym_PIPE_EQ] = ACTIONS(1263),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1263),
    [anon_sym_AMP_EQ] = ACTIONS(1263),
    [anon_sym_PERCENT_EQ] = ACTIONS(1263),
    [anon_sym_GT_GT_EQ] = ACTIONS(1263),
    [anon_sym_LT_LT_EQ] = ACTIONS(1263),
    [anon_sym_CARET_EQ] = ACTIONS(1263),
    [anon_sym_QMARK] = ACTIONS(1265),
    [anon_sym_DOT_DOT] = ACTIONS(1265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1263),
    [anon_sym_and] = ACTIONS(1265),
    [anon_sym_or] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_LT_LT] = ACTIONS(1265),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_EQ_EQ] = ACTIONS(1265),
    [anon_sym_BANG_EQ] = ACTIONS(1263),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1263),
    [anon_sym_LT_EQ_GT] = ACTIONS(1263),
    [anon_sym_EQ_TILDE] = ACTIONS(1263),
    [anon_sym_BANG_TILDE] = ACTIONS(1263),
    [anon_sym_LT_EQ] = ACTIONS(1265),
    [anon_sym_GT] = ACTIONS(1265),
    [anon_sym_GT_EQ] = ACTIONS(1263),
    [anon_sym_CARET] = ACTIONS(1265),
    [anon_sym_PLUS] = ACTIONS(1265),
    [anon_sym_SLASH] = ACTIONS(1265),
    [anon_sym_PERCENT] = ACTIONS(1265),
    [anon_sym_defined_QMARK] = ACTIONS(1263),
    [anon_sym_not] = ACTIONS(1265),
    [anon_sym_BANG] = ACTIONS(1265),
    [anon_sym_TILDE] = ACTIONS(1263),
    [sym_constant] = ACTIONS(1265),
    [sym_identifier] = ACTIONS(1265),
    [sym_instance_variable] = ACTIONS(1263),
    [sym_class_variable] = ACTIONS(1263),
    [sym_global_variable] = ACTIONS(1263),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1265),
    [sym_float] = ACTIONS(1265),
    [sym_complex] = ACTIONS(1263),
    [sym_super] = ACTIONS(1265),
    [anon_sym_true] = ACTIONS(1265),
    [anon_sym_TRUE] = ACTIONS(1265),
    [anon_sym_false] = ACTIONS(1265),
    [anon_sym_FALSE] = ACTIONS(1265),
    [sym_self] = ACTIONS(1265),
    [anon_sym_nil] = ACTIONS(1265),
    [anon_sym_NIL] = ACTIONS(1265),
    [sym_character] = ACTIONS(1263),
    [anon_sym_LBRACK2] = ACTIONS(1265),
    [anon_sym_DASH_GT] = ACTIONS(1263),
  },
  [1929] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(906),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(911),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(911),
    [sym__argument_list_with_trailing_comma] = STATE(4283),
    [sym__argument] = STATE(909),
    [sym_splat_argument] = STATE(909),
    [sym_hash_splat_argument] = STATE(909),
    [sym_block_argument] = STATE(909),
    [sym_assignment] = STATE(906),
    [sym_operator_assignment] = STATE(906),
    [sym_conditional] = STATE(906),
    [sym_range] = STATE(906),
    [sym_binary] = STATE(906),
    [sym_unary] = STATE(906),
    [sym_left_assignment_list] = STATE(910),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(911),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(911),
    [sym_false] = STATE(911),
    [sym_nil] = STATE(911),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(912),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(909),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1589),
    [sym__splat_star] = ACTIONS(1591),
    [sym__unary_minus] = ACTIONS(1593),
    [sym__identifier_hash_key] = ACTIONS(1595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(7039),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1599),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_defined_QMARK] = ACTIONS(1611),
    [anon_sym_not] = ACTIONS(1613),
    [anon_sym_BANG] = ACTIONS(1615),
    [anon_sym_TILDE] = ACTIONS(1615),
    [sym_constant] = ACTIONS(1617),
    [sym_identifier] = ACTIONS(1617),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1930] = {
    [sym__simple_symbol] = ACTIONS(5935),
    [sym__string_start] = ACTIONS(5935),
    [sym__symbol_start] = ACTIONS(5935),
    [sym__subshell_start] = ACTIONS(5935),
    [sym__regex_start] = ACTIONS(5935),
    [sym__string_array_start] = ACTIONS(5935),
    [sym__symbol_array_start] = ACTIONS(5935),
    [sym_heredoc_beginning] = ACTIONS(5935),
    [sym__block_ampersand] = ACTIONS(5935),
    [sym__splat_star] = ACTIONS(5935),
    [sym__unary_minus] = ACTIONS(5935),
    [sym__binary_minus] = ACTIONS(5935),
    [sym__binary_star] = ACTIONS(5935),
    [sym__identifier_hash_key] = ACTIONS(5935),
    [anon_sym_LBRACE] = ACTIONS(5935),
    [anon_sym_def] = ACTIONS(5937),
    [anon_sym_LPAREN] = ACTIONS(5937),
    [anon_sym_DOT] = ACTIONS(5937),
    [anon_sym_COLON_COLON] = ACTIONS(5937),
    [anon_sym_COMMA] = ACTIONS(5935),
    [anon_sym_PIPE] = ACTIONS(5937),
    [anon_sym_STAR] = ACTIONS(5937),
    [anon_sym_STAR_STAR] = ACTIONS(5937),
    [anon_sym_AMP] = ACTIONS(5937),
    [anon_sym_EQ] = ACTIONS(5937),
    [anon_sym_class] = ACTIONS(5937),
    [anon_sym_LT] = ACTIONS(5937),
    [anon_sym_module] = ACTIONS(5937),
    [anon_sym_return] = ACTIONS(5937),
    [anon_sym_yield] = ACTIONS(5937),
    [anon_sym_break] = ACTIONS(5937),
    [anon_sym_next] = ACTIONS(5937),
    [sym_redo] = ACTIONS(5937),
    [sym_retry] = ACTIONS(5937),
    [anon_sym_if] = ACTIONS(5937),
    [anon_sym_unless] = ACTIONS(5937),
    [anon_sym_while] = ACTIONS(5937),
    [anon_sym_until] = ACTIONS(5937),
    [anon_sym_for] = ACTIONS(5937),
    [anon_sym_do] = ACTIONS(5937),
    [anon_sym_case] = ACTIONS(5937),
    [anon_sym_begin] = ACTIONS(5937),
    [anon_sym_EQ_GT] = ACTIONS(5935),
    [anon_sym_LBRACK] = ACTIONS(5935),
    [anon_sym_COLON_COLON2] = ACTIONS(5935),
    [anon_sym_AMP_DOT] = ACTIONS(5935),
    [anon_sym_LPAREN2] = ACTIONS(5935),
    [anon_sym_PLUS_EQ] = ACTIONS(5935),
    [anon_sym_DASH_EQ] = ACTIONS(5935),
    [anon_sym_STAR_EQ] = ACTIONS(5935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5935),
    [anon_sym_SLASH_EQ] = ACTIONS(5935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5935),
    [anon_sym_PIPE_EQ] = ACTIONS(5935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5935),
    [anon_sym_AMP_EQ] = ACTIONS(5935),
    [anon_sym_PERCENT_EQ] = ACTIONS(5935),
    [anon_sym_GT_GT_EQ] = ACTIONS(5935),
    [anon_sym_LT_LT_EQ] = ACTIONS(5935),
    [anon_sym_CARET_EQ] = ACTIONS(5935),
    [anon_sym_QMARK] = ACTIONS(5937),
    [anon_sym_DOT_DOT] = ACTIONS(5937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5935),
    [anon_sym_and] = ACTIONS(5937),
    [anon_sym_or] = ACTIONS(5937),
    [anon_sym_PIPE_PIPE] = ACTIONS(5937),
    [anon_sym_AMP_AMP] = ACTIONS(5937),
    [anon_sym_LT_LT] = ACTIONS(5937),
    [anon_sym_GT_GT] = ACTIONS(5937),
    [anon_sym_EQ_EQ] = ACTIONS(5937),
    [anon_sym_BANG_EQ] = ACTIONS(5935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5935),
    [anon_sym_LT_EQ_GT] = ACTIONS(5935),
    [anon_sym_EQ_TILDE] = ACTIONS(5935),
    [anon_sym_BANG_TILDE] = ACTIONS(5935),
    [anon_sym_LT_EQ] = ACTIONS(5937),
    [anon_sym_GT] = ACTIONS(5937),
    [anon_sym_GT_EQ] = ACTIONS(5935),
    [anon_sym_CARET] = ACTIONS(5937),
    [anon_sym_PLUS] = ACTIONS(5937),
    [anon_sym_SLASH] = ACTIONS(5937),
    [anon_sym_PERCENT] = ACTIONS(5937),
    [anon_sym_defined_QMARK] = ACTIONS(5935),
    [anon_sym_not] = ACTIONS(5937),
    [anon_sym_BANG] = ACTIONS(5937),
    [anon_sym_TILDE] = ACTIONS(5935),
    [sym_constant] = ACTIONS(5937),
    [sym_identifier] = ACTIONS(5937),
    [sym_instance_variable] = ACTIONS(5935),
    [sym_class_variable] = ACTIONS(5935),
    [sym_global_variable] = ACTIONS(5935),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5937),
    [sym_float] = ACTIONS(5937),
    [sym_complex] = ACTIONS(5935),
    [sym_super] = ACTIONS(5937),
    [anon_sym_true] = ACTIONS(5937),
    [anon_sym_TRUE] = ACTIONS(5937),
    [anon_sym_false] = ACTIONS(5937),
    [anon_sym_FALSE] = ACTIONS(5937),
    [sym_self] = ACTIONS(5937),
    [anon_sym_nil] = ACTIONS(5937),
    [anon_sym_NIL] = ACTIONS(5937),
    [sym_character] = ACTIONS(5935),
    [anon_sym_LBRACK2] = ACTIONS(5937),
    [anon_sym_DASH_GT] = ACTIONS(5935),
  },
  [1931] = {
    [sym__simple_symbol] = ACTIONS(5939),
    [sym__string_start] = ACTIONS(5939),
    [sym__symbol_start] = ACTIONS(5939),
    [sym__subshell_start] = ACTIONS(5939),
    [sym__regex_start] = ACTIONS(5939),
    [sym__string_array_start] = ACTIONS(5939),
    [sym__symbol_array_start] = ACTIONS(5939),
    [sym_heredoc_beginning] = ACTIONS(5939),
    [sym__block_ampersand] = ACTIONS(5939),
    [sym__splat_star] = ACTIONS(5939),
    [sym__unary_minus] = ACTIONS(5939),
    [sym__binary_minus] = ACTIONS(5939),
    [sym__binary_star] = ACTIONS(5939),
    [sym__identifier_hash_key] = ACTIONS(5939),
    [anon_sym_LBRACE] = ACTIONS(5939),
    [anon_sym_def] = ACTIONS(5941),
    [anon_sym_LPAREN] = ACTIONS(5941),
    [anon_sym_DOT] = ACTIONS(5941),
    [anon_sym_COLON_COLON] = ACTIONS(5941),
    [anon_sym_COMMA] = ACTIONS(5939),
    [anon_sym_PIPE] = ACTIONS(5941),
    [anon_sym_STAR] = ACTIONS(5941),
    [anon_sym_STAR_STAR] = ACTIONS(5941),
    [anon_sym_AMP] = ACTIONS(5941),
    [anon_sym_EQ] = ACTIONS(5941),
    [anon_sym_class] = ACTIONS(5941),
    [anon_sym_LT] = ACTIONS(5941),
    [anon_sym_module] = ACTIONS(5941),
    [anon_sym_return] = ACTIONS(5941),
    [anon_sym_yield] = ACTIONS(5941),
    [anon_sym_break] = ACTIONS(5941),
    [anon_sym_next] = ACTIONS(5941),
    [sym_redo] = ACTIONS(5941),
    [sym_retry] = ACTIONS(5941),
    [anon_sym_if] = ACTIONS(5941),
    [anon_sym_unless] = ACTIONS(5941),
    [anon_sym_while] = ACTIONS(5941),
    [anon_sym_until] = ACTIONS(5941),
    [anon_sym_for] = ACTIONS(5941),
    [anon_sym_do] = ACTIONS(5941),
    [anon_sym_case] = ACTIONS(5941),
    [anon_sym_begin] = ACTIONS(5941),
    [anon_sym_EQ_GT] = ACTIONS(5939),
    [anon_sym_LBRACK] = ACTIONS(5939),
    [anon_sym_COLON_COLON2] = ACTIONS(5939),
    [anon_sym_AMP_DOT] = ACTIONS(5939),
    [anon_sym_LPAREN2] = ACTIONS(5939),
    [anon_sym_PLUS_EQ] = ACTIONS(5939),
    [anon_sym_DASH_EQ] = ACTIONS(5939),
    [anon_sym_STAR_EQ] = ACTIONS(5939),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5939),
    [anon_sym_SLASH_EQ] = ACTIONS(5939),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5939),
    [anon_sym_PIPE_EQ] = ACTIONS(5939),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5939),
    [anon_sym_AMP_EQ] = ACTIONS(5939),
    [anon_sym_PERCENT_EQ] = ACTIONS(5939),
    [anon_sym_GT_GT_EQ] = ACTIONS(5939),
    [anon_sym_LT_LT_EQ] = ACTIONS(5939),
    [anon_sym_CARET_EQ] = ACTIONS(5939),
    [anon_sym_QMARK] = ACTIONS(5941),
    [anon_sym_DOT_DOT] = ACTIONS(5941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5939),
    [anon_sym_and] = ACTIONS(5941),
    [anon_sym_or] = ACTIONS(5941),
    [anon_sym_PIPE_PIPE] = ACTIONS(5941),
    [anon_sym_AMP_AMP] = ACTIONS(5941),
    [anon_sym_LT_LT] = ACTIONS(5941),
    [anon_sym_GT_GT] = ACTIONS(5941),
    [anon_sym_EQ_EQ] = ACTIONS(5941),
    [anon_sym_BANG_EQ] = ACTIONS(5939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5939),
    [anon_sym_LT_EQ_GT] = ACTIONS(5939),
    [anon_sym_EQ_TILDE] = ACTIONS(5939),
    [anon_sym_BANG_TILDE] = ACTIONS(5939),
    [anon_sym_LT_EQ] = ACTIONS(5941),
    [anon_sym_GT] = ACTIONS(5941),
    [anon_sym_GT_EQ] = ACTIONS(5939),
    [anon_sym_CARET] = ACTIONS(5941),
    [anon_sym_PLUS] = ACTIONS(5941),
    [anon_sym_SLASH] = ACTIONS(5941),
    [anon_sym_PERCENT] = ACTIONS(5941),
    [anon_sym_defined_QMARK] = ACTIONS(5939),
    [anon_sym_not] = ACTIONS(5941),
    [anon_sym_BANG] = ACTIONS(5941),
    [anon_sym_TILDE] = ACTIONS(5939),
    [sym_constant] = ACTIONS(5941),
    [sym_identifier] = ACTIONS(5941),
    [sym_instance_variable] = ACTIONS(5939),
    [sym_class_variable] = ACTIONS(5939),
    [sym_global_variable] = ACTIONS(5939),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5941),
    [sym_float] = ACTIONS(5941),
    [sym_complex] = ACTIONS(5939),
    [sym_super] = ACTIONS(5941),
    [anon_sym_true] = ACTIONS(5941),
    [anon_sym_TRUE] = ACTIONS(5941),
    [anon_sym_false] = ACTIONS(5941),
    [anon_sym_FALSE] = ACTIONS(5941),
    [sym_self] = ACTIONS(5941),
    [anon_sym_nil] = ACTIONS(5941),
    [anon_sym_NIL] = ACTIONS(5941),
    [sym_character] = ACTIONS(5939),
    [anon_sym_LBRACK2] = ACTIONS(5941),
    [anon_sym_DASH_GT] = ACTIONS(5939),
  },
  [1932] = {
    [sym_argument_list_with_parens] = STATE(4284),
    [sym__argument_list_with_parens] = STATE(1931),
    [sym_operator] = STATE(4284),
    [sym_heredoc_body] = STATE(3563),
    [aux_sym_call_repeat1] = STATE(3563),
    [sym__heredoc_body_start] = ACTIONS(2519),
    [anon_sym_PIPE] = ACTIONS(3437),
    [anon_sym_STAR] = ACTIONS(3439),
    [anon_sym_STAR_STAR] = ACTIONS(3437),
    [anon_sym_AMP] = ACTIONS(3437),
    [anon_sym_LT] = ACTIONS(3439),
    [anon_sym_LPAREN2] = ACTIONS(3441),
    [anon_sym_DOT_DOT] = ACTIONS(3437),
    [anon_sym_LT_LT] = ACTIONS(3437),
    [anon_sym_GT_GT] = ACTIONS(3437),
    [anon_sym_EQ_EQ] = ACTIONS(3439),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3437),
    [anon_sym_LT_EQ_GT] = ACTIONS(3437),
    [anon_sym_EQ_TILDE] = ACTIONS(3437),
    [anon_sym_BANG_TILDE] = ACTIONS(3437),
    [anon_sym_LT_EQ] = ACTIONS(3439),
    [anon_sym_GT] = ACTIONS(3439),
    [anon_sym_GT_EQ] = ACTIONS(3437),
    [anon_sym_CARET] = ACTIONS(3437),
    [anon_sym_PLUS] = ACTIONS(3439),
    [anon_sym_SLASH] = ACTIONS(3437),
    [anon_sym_PERCENT] = ACTIONS(3437),
    [anon_sym_BANG] = ACTIONS(3439),
    [anon_sym_TILDE] = ACTIONS(3437),
    [sym_constant] = ACTIONS(7041),
    [sym_identifier] = ACTIONS(7041),
    [anon_sym_DASH] = ACTIONS(3439),
    [anon_sym_PLUS_AT] = ACTIONS(3437),
    [anon_sym_DASH_AT] = ACTIONS(3437),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3439),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(3437),
    [anon_sym_BQUOTE] = ACTIONS(3437),
    [sym_comment] = ACTIONS(87),
  },
  [1933] = {
    [sym__binary_minus] = ACTIONS(5945),
    [sym__binary_star] = ACTIONS(5945),
    [anon_sym_DOT] = ACTIONS(5947),
    [anon_sym_COMMA] = ACTIONS(5945),
    [anon_sym_PIPE] = ACTIONS(5947),
    [anon_sym_STAR_STAR] = ACTIONS(5947),
    [anon_sym_AMP] = ACTIONS(5947),
    [anon_sym_EQ] = ACTIONS(5947),
    [anon_sym_LT] = ACTIONS(5947),
    [anon_sym_EQ_GT] = ACTIONS(5945),
    [anon_sym_LBRACK] = ACTIONS(5945),
    [anon_sym_COLON_COLON2] = ACTIONS(5945),
    [anon_sym_AMP_DOT] = ACTIONS(5945),
    [anon_sym_PLUS_EQ] = ACTIONS(5945),
    [anon_sym_DASH_EQ] = ACTIONS(5945),
    [anon_sym_STAR_EQ] = ACTIONS(5945),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5945),
    [anon_sym_SLASH_EQ] = ACTIONS(5945),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5945),
    [anon_sym_PIPE_EQ] = ACTIONS(5945),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5945),
    [anon_sym_AMP_EQ] = ACTIONS(5945),
    [anon_sym_PERCENT_EQ] = ACTIONS(5945),
    [anon_sym_GT_GT_EQ] = ACTIONS(5945),
    [anon_sym_LT_LT_EQ] = ACTIONS(5945),
    [anon_sym_CARET_EQ] = ACTIONS(5945),
    [anon_sym_QMARK] = ACTIONS(5945),
    [anon_sym_DOT_DOT] = ACTIONS(5947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5945),
    [anon_sym_and] = ACTIONS(5945),
    [anon_sym_or] = ACTIONS(5945),
    [anon_sym_PIPE_PIPE] = ACTIONS(5947),
    [anon_sym_AMP_AMP] = ACTIONS(5947),
    [anon_sym_LT_LT] = ACTIONS(5947),
    [anon_sym_GT_GT] = ACTIONS(5947),
    [anon_sym_EQ_EQ] = ACTIONS(5947),
    [anon_sym_BANG_EQ] = ACTIONS(5945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5945),
    [anon_sym_LT_EQ_GT] = ACTIONS(5945),
    [anon_sym_EQ_TILDE] = ACTIONS(5945),
    [anon_sym_BANG_TILDE] = ACTIONS(5945),
    [anon_sym_LT_EQ] = ACTIONS(5947),
    [anon_sym_GT] = ACTIONS(5947),
    [anon_sym_GT_EQ] = ACTIONS(5945),
    [anon_sym_CARET] = ACTIONS(5947),
    [anon_sym_PLUS] = ACTIONS(5947),
    [anon_sym_SLASH] = ACTIONS(5947),
    [anon_sym_PERCENT] = ACTIONS(5947),
    [sym_comment] = ACTIONS(87),
  },
  [1934] = {
    [anon_sym_RBRACK] = ACTIONS(7043),
    [sym_comment] = ACTIONS(87),
  },
  [1935] = {
    [sym__simple_symbol] = ACTIONS(5951),
    [sym__string_start] = ACTIONS(5951),
    [sym__symbol_start] = ACTIONS(5951),
    [sym__subshell_start] = ACTIONS(5951),
    [sym__regex_start] = ACTIONS(5951),
    [sym__string_array_start] = ACTIONS(5951),
    [sym__symbol_array_start] = ACTIONS(5951),
    [sym_heredoc_beginning] = ACTIONS(5951),
    [sym__block_ampersand] = ACTIONS(5951),
    [sym__splat_star] = ACTIONS(5951),
    [sym__unary_minus] = ACTIONS(5951),
    [sym__binary_minus] = ACTIONS(5951),
    [sym__binary_star] = ACTIONS(5951),
    [sym__identifier_hash_key] = ACTIONS(5951),
    [anon_sym_LBRACE] = ACTIONS(5951),
    [anon_sym_def] = ACTIONS(5953),
    [anon_sym_LPAREN] = ACTIONS(5953),
    [anon_sym_DOT] = ACTIONS(5953),
    [anon_sym_COLON_COLON] = ACTIONS(5953),
    [anon_sym_COMMA] = ACTIONS(5951),
    [anon_sym_PIPE] = ACTIONS(5953),
    [anon_sym_STAR] = ACTIONS(5953),
    [anon_sym_STAR_STAR] = ACTIONS(5953),
    [anon_sym_AMP] = ACTIONS(5953),
    [anon_sym_EQ] = ACTIONS(5953),
    [anon_sym_class] = ACTIONS(5953),
    [anon_sym_LT] = ACTIONS(5953),
    [anon_sym_module] = ACTIONS(5953),
    [anon_sym_return] = ACTIONS(5953),
    [anon_sym_yield] = ACTIONS(5953),
    [anon_sym_break] = ACTIONS(5953),
    [anon_sym_next] = ACTIONS(5953),
    [sym_redo] = ACTIONS(5953),
    [sym_retry] = ACTIONS(5953),
    [anon_sym_if] = ACTIONS(5953),
    [anon_sym_unless] = ACTIONS(5953),
    [anon_sym_while] = ACTIONS(5953),
    [anon_sym_until] = ACTIONS(5953),
    [anon_sym_for] = ACTIONS(5953),
    [anon_sym_do] = ACTIONS(5953),
    [anon_sym_case] = ACTIONS(5953),
    [anon_sym_begin] = ACTIONS(5953),
    [anon_sym_EQ_GT] = ACTIONS(5951),
    [anon_sym_LBRACK] = ACTIONS(5951),
    [anon_sym_COLON_COLON2] = ACTIONS(5951),
    [anon_sym_AMP_DOT] = ACTIONS(5951),
    [anon_sym_LPAREN2] = ACTIONS(5951),
    [anon_sym_PLUS_EQ] = ACTIONS(5951),
    [anon_sym_DASH_EQ] = ACTIONS(5951),
    [anon_sym_STAR_EQ] = ACTIONS(5951),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5951),
    [anon_sym_SLASH_EQ] = ACTIONS(5951),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5951),
    [anon_sym_PIPE_EQ] = ACTIONS(5951),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5951),
    [anon_sym_AMP_EQ] = ACTIONS(5951),
    [anon_sym_PERCENT_EQ] = ACTIONS(5951),
    [anon_sym_GT_GT_EQ] = ACTIONS(5951),
    [anon_sym_LT_LT_EQ] = ACTIONS(5951),
    [anon_sym_CARET_EQ] = ACTIONS(5951),
    [anon_sym_QMARK] = ACTIONS(5953),
    [anon_sym_DOT_DOT] = ACTIONS(5953),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5951),
    [anon_sym_and] = ACTIONS(5953),
    [anon_sym_or] = ACTIONS(5953),
    [anon_sym_PIPE_PIPE] = ACTIONS(5953),
    [anon_sym_AMP_AMP] = ACTIONS(5953),
    [anon_sym_LT_LT] = ACTIONS(5953),
    [anon_sym_GT_GT] = ACTIONS(5953),
    [anon_sym_EQ_EQ] = ACTIONS(5953),
    [anon_sym_BANG_EQ] = ACTIONS(5951),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5951),
    [anon_sym_LT_EQ_GT] = ACTIONS(5951),
    [anon_sym_EQ_TILDE] = ACTIONS(5951),
    [anon_sym_BANG_TILDE] = ACTIONS(5951),
    [anon_sym_LT_EQ] = ACTIONS(5953),
    [anon_sym_GT] = ACTIONS(5953),
    [anon_sym_GT_EQ] = ACTIONS(5951),
    [anon_sym_CARET] = ACTIONS(5953),
    [anon_sym_PLUS] = ACTIONS(5953),
    [anon_sym_SLASH] = ACTIONS(5953),
    [anon_sym_PERCENT] = ACTIONS(5953),
    [anon_sym_defined_QMARK] = ACTIONS(5951),
    [anon_sym_not] = ACTIONS(5953),
    [anon_sym_BANG] = ACTIONS(5953),
    [anon_sym_TILDE] = ACTIONS(5951),
    [sym_constant] = ACTIONS(5953),
    [sym_identifier] = ACTIONS(5953),
    [sym_instance_variable] = ACTIONS(5951),
    [sym_class_variable] = ACTIONS(5951),
    [sym_global_variable] = ACTIONS(5951),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5953),
    [sym_float] = ACTIONS(5953),
    [sym_complex] = ACTIONS(5951),
    [sym_super] = ACTIONS(5953),
    [anon_sym_true] = ACTIONS(5953),
    [anon_sym_TRUE] = ACTIONS(5953),
    [anon_sym_false] = ACTIONS(5953),
    [anon_sym_FALSE] = ACTIONS(5953),
    [sym_self] = ACTIONS(5953),
    [anon_sym_nil] = ACTIONS(5953),
    [anon_sym_NIL] = ACTIONS(5953),
    [sym_character] = ACTIONS(5951),
    [anon_sym_LBRACK2] = ACTIONS(5953),
    [anon_sym_DASH_GT] = ACTIONS(5951),
  },
  [1936] = {
    [sym__string_start] = ACTIONS(835),
    [sym__heredoc_body_start] = ACTIONS(835),
    [sym__binary_minus] = ACTIONS(835),
    [sym__binary_star] = ACTIONS(835),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_RBRACE] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(835),
    [anon_sym_DOT] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(835),
    [anon_sym_PIPE] = ACTIONS(837),
    [anon_sym_SEMI] = ACTIONS(835),
    [anon_sym_STAR_STAR] = ACTIONS(837),
    [anon_sym_AMP] = ACTIONS(837),
    [anon_sym_COLON] = ACTIONS(837),
    [anon_sym_EQ] = ACTIONS(837),
    [anon_sym_LT] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_unless] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_until] = ACTIONS(835),
    [anon_sym_rescue] = ACTIONS(835),
    [anon_sym_in] = ACTIONS(835),
    [anon_sym_do] = ACTIONS(835),
    [anon_sym_EQ_GT] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_RBRACK] = ACTIONS(835),
    [anon_sym_COLON_COLON2] = ACTIONS(835),
    [anon_sym_AMP_DOT] = ACTIONS(835),
    [anon_sym_PLUS_EQ] = ACTIONS(835),
    [anon_sym_DASH_EQ] = ACTIONS(835),
    [anon_sym_STAR_EQ] = ACTIONS(835),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(835),
    [anon_sym_SLASH_EQ] = ACTIONS(835),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(835),
    [anon_sym_PIPE_EQ] = ACTIONS(835),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(835),
    [anon_sym_AMP_EQ] = ACTIONS(835),
    [anon_sym_PERCENT_EQ] = ACTIONS(835),
    [anon_sym_GT_GT_EQ] = ACTIONS(835),
    [anon_sym_LT_LT_EQ] = ACTIONS(835),
    [anon_sym_CARET_EQ] = ACTIONS(835),
    [anon_sym_QMARK] = ACTIONS(835),
    [anon_sym_COLON2] = ACTIONS(837),
    [anon_sym_DOT_DOT] = ACTIONS(837),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(835),
    [anon_sym_and] = ACTIONS(835),
    [anon_sym_or] = ACTIONS(835),
    [anon_sym_PIPE_PIPE] = ACTIONS(837),
    [anon_sym_AMP_AMP] = ACTIONS(837),
    [anon_sym_LT_LT] = ACTIONS(837),
    [anon_sym_GT_GT] = ACTIONS(837),
    [anon_sym_EQ_EQ] = ACTIONS(837),
    [anon_sym_BANG_EQ] = ACTIONS(835),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(835),
    [anon_sym_LT_EQ_GT] = ACTIONS(835),
    [anon_sym_EQ_TILDE] = ACTIONS(835),
    [anon_sym_BANG_TILDE] = ACTIONS(835),
    [anon_sym_LT_EQ] = ACTIONS(837),
    [anon_sym_GT] = ACTIONS(837),
    [anon_sym_GT_EQ] = ACTIONS(835),
    [anon_sym_CARET] = ACTIONS(837),
    [anon_sym_PLUS] = ACTIONS(837),
    [anon_sym_SLASH] = ACTIONS(837),
    [anon_sym_PERCENT] = ACTIONS(837),
    [sym_comment] = ACTIONS(87),
  },
  [1937] = {
    [sym__string_end] = ACTIONS(7045),
    [sym_comment] = ACTIONS(87),
  },
  [1938] = {
    [sym__heredoc_body_start] = ACTIONS(887),
    [sym__binary_minus] = ACTIONS(887),
    [sym__binary_star] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(887),
    [anon_sym_RBRACE] = ACTIONS(887),
    [anon_sym_RPAREN] = ACTIONS(887),
    [anon_sym_DOT] = ACTIONS(889),
    [anon_sym_COMMA] = ACTIONS(887),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI] = ACTIONS(887),
    [anon_sym_STAR_STAR] = ACTIONS(889),
    [anon_sym_AMP] = ACTIONS(889),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_LT] = ACTIONS(889),
    [anon_sym_if] = ACTIONS(887),
    [anon_sym_unless] = ACTIONS(887),
    [anon_sym_while] = ACTIONS(887),
    [anon_sym_until] = ACTIONS(887),
    [anon_sym_rescue] = ACTIONS(887),
    [anon_sym_in] = ACTIONS(887),
    [anon_sym_do] = ACTIONS(887),
    [anon_sym_EQ_GT] = ACTIONS(887),
    [anon_sym_LBRACK] = ACTIONS(887),
    [anon_sym_RBRACK] = ACTIONS(887),
    [anon_sym_COLON_COLON2] = ACTIONS(887),
    [anon_sym_AMP_DOT] = ACTIONS(887),
    [anon_sym_PLUS_EQ] = ACTIONS(887),
    [anon_sym_DASH_EQ] = ACTIONS(887),
    [anon_sym_STAR_EQ] = ACTIONS(887),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(887),
    [anon_sym_SLASH_EQ] = ACTIONS(887),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(887),
    [anon_sym_PIPE_EQ] = ACTIONS(887),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(887),
    [anon_sym_AMP_EQ] = ACTIONS(887),
    [anon_sym_PERCENT_EQ] = ACTIONS(887),
    [anon_sym_GT_GT_EQ] = ACTIONS(887),
    [anon_sym_LT_LT_EQ] = ACTIONS(887),
    [anon_sym_CARET_EQ] = ACTIONS(887),
    [anon_sym_QMARK] = ACTIONS(887),
    [anon_sym_COLON2] = ACTIONS(889),
    [anon_sym_DOT_DOT] = ACTIONS(889),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(887),
    [anon_sym_and] = ACTIONS(887),
    [anon_sym_or] = ACTIONS(887),
    [anon_sym_PIPE_PIPE] = ACTIONS(889),
    [anon_sym_AMP_AMP] = ACTIONS(889),
    [anon_sym_LT_LT] = ACTIONS(889),
    [anon_sym_GT_GT] = ACTIONS(889),
    [anon_sym_EQ_EQ] = ACTIONS(889),
    [anon_sym_BANG_EQ] = ACTIONS(887),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(887),
    [anon_sym_LT_EQ_GT] = ACTIONS(887),
    [anon_sym_EQ_TILDE] = ACTIONS(887),
    [anon_sym_BANG_TILDE] = ACTIONS(887),
    [anon_sym_LT_EQ] = ACTIONS(889),
    [anon_sym_GT] = ACTIONS(889),
    [anon_sym_GT_EQ] = ACTIONS(887),
    [anon_sym_CARET] = ACTIONS(889),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_SLASH] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [sym_comment] = ACTIONS(87),
  },
  [1939] = {
    [sym__string_end] = ACTIONS(7047),
    [sym_comment] = ACTIONS(87),
  },
  [1940] = {
    [sym__heredoc_body_start] = ACTIONS(893),
    [sym__binary_minus] = ACTIONS(893),
    [sym__binary_star] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(893),
    [anon_sym_RBRACE] = ACTIONS(893),
    [anon_sym_RPAREN] = ACTIONS(893),
    [anon_sym_DOT] = ACTIONS(895),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_PIPE] = ACTIONS(895),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_STAR_STAR] = ACTIONS(895),
    [anon_sym_AMP] = ACTIONS(895),
    [anon_sym_EQ] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(895),
    [anon_sym_if] = ACTIONS(893),
    [anon_sym_unless] = ACTIONS(893),
    [anon_sym_while] = ACTIONS(893),
    [anon_sym_until] = ACTIONS(893),
    [anon_sym_rescue] = ACTIONS(893),
    [anon_sym_in] = ACTIONS(893),
    [anon_sym_do] = ACTIONS(893),
    [anon_sym_EQ_GT] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(893),
    [anon_sym_RBRACK] = ACTIONS(893),
    [anon_sym_COLON_COLON2] = ACTIONS(893),
    [anon_sym_AMP_DOT] = ACTIONS(893),
    [anon_sym_PLUS_EQ] = ACTIONS(893),
    [anon_sym_DASH_EQ] = ACTIONS(893),
    [anon_sym_STAR_EQ] = ACTIONS(893),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(893),
    [anon_sym_SLASH_EQ] = ACTIONS(893),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(893),
    [anon_sym_PIPE_EQ] = ACTIONS(893),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(893),
    [anon_sym_AMP_EQ] = ACTIONS(893),
    [anon_sym_PERCENT_EQ] = ACTIONS(893),
    [anon_sym_GT_GT_EQ] = ACTIONS(893),
    [anon_sym_LT_LT_EQ] = ACTIONS(893),
    [anon_sym_CARET_EQ] = ACTIONS(893),
    [anon_sym_QMARK] = ACTIONS(893),
    [anon_sym_COLON2] = ACTIONS(895),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(893),
    [anon_sym_and] = ACTIONS(893),
    [anon_sym_or] = ACTIONS(893),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_LT_LT] = ACTIONS(895),
    [anon_sym_GT_GT] = ACTIONS(895),
    [anon_sym_EQ_EQ] = ACTIONS(895),
    [anon_sym_BANG_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_LT_EQ_GT] = ACTIONS(893),
    [anon_sym_EQ_TILDE] = ACTIONS(893),
    [anon_sym_BANG_TILDE] = ACTIONS(893),
    [anon_sym_LT_EQ] = ACTIONS(895),
    [anon_sym_GT] = ACTIONS(895),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_CARET] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(895),
    [anon_sym_SLASH] = ACTIONS(895),
    [anon_sym_PERCENT] = ACTIONS(895),
    [sym_comment] = ACTIONS(87),
  },
  [1941] = {
    [sym__string_end] = ACTIONS(7049),
    [sym_comment] = ACTIONS(87),
  },
  [1942] = {
    [sym__heredoc_body_start] = ACTIONS(899),
    [sym__binary_minus] = ACTIONS(899),
    [sym__binary_star] = ACTIONS(899),
    [anon_sym_LBRACE] = ACTIONS(899),
    [anon_sym_RBRACE] = ACTIONS(899),
    [anon_sym_RPAREN] = ACTIONS(899),
    [anon_sym_DOT] = ACTIONS(901),
    [anon_sym_COMMA] = ACTIONS(899),
    [anon_sym_PIPE] = ACTIONS(901),
    [anon_sym_SEMI] = ACTIONS(899),
    [anon_sym_STAR_STAR] = ACTIONS(901),
    [anon_sym_AMP] = ACTIONS(901),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_LT] = ACTIONS(901),
    [anon_sym_if] = ACTIONS(899),
    [anon_sym_unless] = ACTIONS(899),
    [anon_sym_while] = ACTIONS(899),
    [anon_sym_until] = ACTIONS(899),
    [anon_sym_rescue] = ACTIONS(899),
    [anon_sym_in] = ACTIONS(899),
    [anon_sym_do] = ACTIONS(899),
    [anon_sym_EQ_GT] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(899),
    [anon_sym_RBRACK] = ACTIONS(899),
    [anon_sym_COLON_COLON2] = ACTIONS(899),
    [anon_sym_AMP_DOT] = ACTIONS(899),
    [anon_sym_PLUS_EQ] = ACTIONS(899),
    [anon_sym_DASH_EQ] = ACTIONS(899),
    [anon_sym_STAR_EQ] = ACTIONS(899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(899),
    [anon_sym_SLASH_EQ] = ACTIONS(899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(899),
    [anon_sym_PIPE_EQ] = ACTIONS(899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(899),
    [anon_sym_AMP_EQ] = ACTIONS(899),
    [anon_sym_PERCENT_EQ] = ACTIONS(899),
    [anon_sym_GT_GT_EQ] = ACTIONS(899),
    [anon_sym_LT_LT_EQ] = ACTIONS(899),
    [anon_sym_CARET_EQ] = ACTIONS(899),
    [anon_sym_QMARK] = ACTIONS(899),
    [anon_sym_COLON2] = ACTIONS(901),
    [anon_sym_DOT_DOT] = ACTIONS(901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(899),
    [anon_sym_and] = ACTIONS(899),
    [anon_sym_or] = ACTIONS(899),
    [anon_sym_PIPE_PIPE] = ACTIONS(901),
    [anon_sym_AMP_AMP] = ACTIONS(901),
    [anon_sym_LT_LT] = ACTIONS(901),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_EQ_EQ] = ACTIONS(901),
    [anon_sym_BANG_EQ] = ACTIONS(899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(899),
    [anon_sym_LT_EQ_GT] = ACTIONS(899),
    [anon_sym_EQ_TILDE] = ACTIONS(899),
    [anon_sym_BANG_TILDE] = ACTIONS(899),
    [anon_sym_LT_EQ] = ACTIONS(901),
    [anon_sym_GT] = ACTIONS(901),
    [anon_sym_GT_EQ] = ACTIONS(899),
    [anon_sym_CARET] = ACTIONS(901),
    [anon_sym_PLUS] = ACTIONS(901),
    [anon_sym_SLASH] = ACTIONS(901),
    [anon_sym_PERCENT] = ACTIONS(901),
    [sym_comment] = ACTIONS(87),
  },
  [1943] = {
    [sym__string_end] = ACTIONS(7051),
    [sym_comment] = ACTIONS(87),
  },
  [1944] = {
    [sym__heredoc_body_start] = ACTIONS(905),
    [sym__binary_minus] = ACTIONS(905),
    [sym__binary_star] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(905),
    [anon_sym_RBRACE] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(905),
    [anon_sym_DOT] = ACTIONS(907),
    [anon_sym_COMMA] = ACTIONS(905),
    [anon_sym_PIPE] = ACTIONS(907),
    [anon_sym_SEMI] = ACTIONS(905),
    [anon_sym_STAR_STAR] = ACTIONS(907),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(907),
    [anon_sym_LT] = ACTIONS(907),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_unless] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_until] = ACTIONS(905),
    [anon_sym_rescue] = ACTIONS(905),
    [anon_sym_in] = ACTIONS(905),
    [anon_sym_do] = ACTIONS(905),
    [anon_sym_EQ_GT] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_RBRACK] = ACTIONS(905),
    [anon_sym_COLON_COLON2] = ACTIONS(905),
    [anon_sym_AMP_DOT] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_QMARK] = ACTIONS(905),
    [anon_sym_COLON2] = ACTIONS(907),
    [anon_sym_DOT_DOT] = ACTIONS(907),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(905),
    [anon_sym_and] = ACTIONS(905),
    [anon_sym_or] = ACTIONS(905),
    [anon_sym_PIPE_PIPE] = ACTIONS(907),
    [anon_sym_AMP_AMP] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(907),
    [anon_sym_GT_GT] = ACTIONS(907),
    [anon_sym_EQ_EQ] = ACTIONS(907),
    [anon_sym_BANG_EQ] = ACTIONS(905),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(905),
    [anon_sym_LT_EQ_GT] = ACTIONS(905),
    [anon_sym_EQ_TILDE] = ACTIONS(905),
    [anon_sym_BANG_TILDE] = ACTIONS(905),
    [anon_sym_LT_EQ] = ACTIONS(907),
    [anon_sym_GT] = ACTIONS(907),
    [anon_sym_GT_EQ] = ACTIONS(905),
    [anon_sym_CARET] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(907),
    [anon_sym_SLASH] = ACTIONS(907),
    [anon_sym_PERCENT] = ACTIONS(907),
    [sym_comment] = ACTIONS(87),
  },
  [1945] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(4292),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(7053),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(7055),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [1946] = {
    [aux_sym_string_array_repeat1] = STATE(4295),
    [sym__string_end] = ACTIONS(7057),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(7059),
  },
  [1947] = {
    [sym__heredoc_body_start] = ACTIONS(923),
    [sym__binary_minus] = ACTIONS(923),
    [sym__binary_star] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(923),
    [anon_sym_RBRACE] = ACTIONS(923),
    [anon_sym_RPAREN] = ACTIONS(923),
    [anon_sym_DOT] = ACTIONS(925),
    [anon_sym_COMMA] = ACTIONS(923),
    [anon_sym_PIPE] = ACTIONS(925),
    [anon_sym_SEMI] = ACTIONS(923),
    [anon_sym_STAR_STAR] = ACTIONS(925),
    [anon_sym_AMP] = ACTIONS(925),
    [anon_sym_EQ] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(925),
    [anon_sym_if] = ACTIONS(923),
    [anon_sym_unless] = ACTIONS(923),
    [anon_sym_while] = ACTIONS(923),
    [anon_sym_until] = ACTIONS(923),
    [anon_sym_rescue] = ACTIONS(923),
    [anon_sym_in] = ACTIONS(923),
    [anon_sym_do] = ACTIONS(923),
    [anon_sym_EQ_GT] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(923),
    [anon_sym_RBRACK] = ACTIONS(923),
    [anon_sym_COLON_COLON2] = ACTIONS(923),
    [anon_sym_AMP_DOT] = ACTIONS(923),
    [anon_sym_PLUS_EQ] = ACTIONS(923),
    [anon_sym_DASH_EQ] = ACTIONS(923),
    [anon_sym_STAR_EQ] = ACTIONS(923),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(923),
    [anon_sym_SLASH_EQ] = ACTIONS(923),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(923),
    [anon_sym_PIPE_EQ] = ACTIONS(923),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(923),
    [anon_sym_AMP_EQ] = ACTIONS(923),
    [anon_sym_PERCENT_EQ] = ACTIONS(923),
    [anon_sym_GT_GT_EQ] = ACTIONS(923),
    [anon_sym_LT_LT_EQ] = ACTIONS(923),
    [anon_sym_CARET_EQ] = ACTIONS(923),
    [anon_sym_QMARK] = ACTIONS(923),
    [anon_sym_COLON2] = ACTIONS(925),
    [anon_sym_DOT_DOT] = ACTIONS(925),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(923),
    [anon_sym_and] = ACTIONS(923),
    [anon_sym_or] = ACTIONS(923),
    [anon_sym_PIPE_PIPE] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(925),
    [anon_sym_LT_LT] = ACTIONS(925),
    [anon_sym_GT_GT] = ACTIONS(925),
    [anon_sym_EQ_EQ] = ACTIONS(925),
    [anon_sym_BANG_EQ] = ACTIONS(923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(923),
    [anon_sym_LT_EQ_GT] = ACTIONS(923),
    [anon_sym_EQ_TILDE] = ACTIONS(923),
    [anon_sym_BANG_TILDE] = ACTIONS(923),
    [anon_sym_LT_EQ] = ACTIONS(925),
    [anon_sym_GT] = ACTIONS(925),
    [anon_sym_GT_EQ] = ACTIONS(923),
    [anon_sym_CARET] = ACTIONS(925),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(925),
    [anon_sym_PERCENT] = ACTIONS(925),
    [sym_comment] = ACTIONS(87),
  },
  [1948] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(4298),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(7061),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(7063),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [1949] = {
    [aux_sym_symbol_array_repeat1] = STATE(4301),
    [sym__string_end] = ACTIONS(7065),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(7067),
  },
  [1950] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(113),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(118),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(118),
    [sym_hash_splat_argument] = STATE(116),
    [sym_assignment] = STATE(113),
    [sym_operator_assignment] = STATE(113),
    [sym_conditional] = STATE(113),
    [sym_range] = STATE(113),
    [sym_binary] = STATE(113),
    [sym_unary] = STATE(113),
    [sym_left_assignment_list] = STATE(117),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(118),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(118),
    [sym_false] = STATE(118),
    [sym_nil] = STATE(118),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(119),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_heredoc_body] = STATE(1959),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym__hash_items] = STATE(1960),
    [sym_pair] = STATE(122),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [sym__identifier_hash_key] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_RBRACE] = ACTIONS(7069),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(209),
    [sym_identifier] = ACTIONS(209),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1951] = {
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(3509),
    [sym__binary_star] = ACTIONS(3511),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(3513),
    [anon_sym_STAR_STAR] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(3517),
    [anon_sym_EQ] = ACTIONS(4217),
    [anon_sym_LT] = ACTIONS(3519),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_EQ_GT] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_PLUS_EQ] = ACTIONS(4211),
    [anon_sym_DASH_EQ] = ACTIONS(4211),
    [anon_sym_STAR_EQ] = ACTIONS(4211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4211),
    [anon_sym_SLASH_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4211),
    [anon_sym_AMP_EQ] = ACTIONS(4211),
    [anon_sym_PERCENT_EQ] = ACTIONS(4211),
    [anon_sym_GT_GT_EQ] = ACTIONS(4211),
    [anon_sym_LT_LT_EQ] = ACTIONS(4211),
    [anon_sym_CARET_EQ] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(3521),
    [anon_sym_DOT_DOT] = ACTIONS(3523),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3525),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(3527),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_LT_LT] = ACTIONS(3529),
    [anon_sym_GT_GT] = ACTIONS(3529),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ] = ACTIONS(3531),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3531),
    [anon_sym_LT_EQ_GT] = ACTIONS(3531),
    [anon_sym_EQ_TILDE] = ACTIONS(3531),
    [anon_sym_BANG_TILDE] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3519),
    [anon_sym_GT] = ACTIONS(3519),
    [anon_sym_GT_EQ] = ACTIONS(3533),
    [anon_sym_CARET] = ACTIONS(3513),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_SLASH] = ACTIONS(3515),
    [anon_sym_PERCENT] = ACTIONS(3515),
    [sym_comment] = ACTIONS(87),
  },
  [1952] = {
    [sym_string] = STATE(2025),
    [aux_sym_chained_string_repeat1] = STATE(2025),
    [sym__string_start] = ACTIONS(1141),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1953] = {
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(3509),
    [sym__binary_star] = ACTIONS(3511),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(3513),
    [anon_sym_STAR_STAR] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(3517),
    [anon_sym_EQ] = ACTIONS(4249),
    [anon_sym_LT] = ACTIONS(3519),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_EQ_GT] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_PLUS_EQ] = ACTIONS(4247),
    [anon_sym_DASH_EQ] = ACTIONS(4247),
    [anon_sym_STAR_EQ] = ACTIONS(4247),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4247),
    [anon_sym_SLASH_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4247),
    [anon_sym_AMP_EQ] = ACTIONS(4247),
    [anon_sym_PERCENT_EQ] = ACTIONS(4247),
    [anon_sym_GT_GT_EQ] = ACTIONS(4247),
    [anon_sym_LT_LT_EQ] = ACTIONS(4247),
    [anon_sym_CARET_EQ] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(3521),
    [anon_sym_DOT_DOT] = ACTIONS(3523),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3525),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(3527),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_LT_LT] = ACTIONS(3529),
    [anon_sym_GT_GT] = ACTIONS(3529),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ] = ACTIONS(3531),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3531),
    [anon_sym_LT_EQ_GT] = ACTIONS(3531),
    [anon_sym_EQ_TILDE] = ACTIONS(3531),
    [anon_sym_BANG_TILDE] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3519),
    [anon_sym_GT] = ACTIONS(3519),
    [anon_sym_GT_EQ] = ACTIONS(3533),
    [anon_sym_CARET] = ACTIONS(3513),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_SLASH] = ACTIONS(3515),
    [anon_sym_PERCENT] = ACTIONS(3515),
    [sym_comment] = ACTIONS(87),
  },
  [1954] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [1955] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4303),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_assignment] = STATE(4303),
    [sym_operator_assignment] = STATE(4303),
    [sym_conditional] = STATE(4303),
    [sym_range] = STATE(4303),
    [sym_binary] = STATE(4303),
    [sym_unary] = STATE(4303),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1952),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(3469),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1956] = {
    [sym__heredoc_body_start] = ACTIONS(993),
    [sym__binary_minus] = ACTIONS(5735),
    [sym__binary_star] = ACTIONS(5735),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_DOT] = ACTIONS(5737),
    [anon_sym_COMMA] = ACTIONS(5735),
    [anon_sym_PIPE] = ACTIONS(5737),
    [anon_sym_STAR_STAR] = ACTIONS(5737),
    [anon_sym_AMP] = ACTIONS(5737),
    [anon_sym_EQ] = ACTIONS(5737),
    [anon_sym_LT] = ACTIONS(5737),
    [anon_sym_do] = ACTIONS(993),
    [anon_sym_EQ_GT] = ACTIONS(5735),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_COLON_COLON2] = ACTIONS(5735),
    [anon_sym_AMP_DOT] = ACTIONS(5735),
    [anon_sym_PLUS_EQ] = ACTIONS(5735),
    [anon_sym_DASH_EQ] = ACTIONS(5735),
    [anon_sym_STAR_EQ] = ACTIONS(5735),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5735),
    [anon_sym_SLASH_EQ] = ACTIONS(5735),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5735),
    [anon_sym_PIPE_EQ] = ACTIONS(5735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5735),
    [anon_sym_AMP_EQ] = ACTIONS(5735),
    [anon_sym_PERCENT_EQ] = ACTIONS(5735),
    [anon_sym_GT_GT_EQ] = ACTIONS(5735),
    [anon_sym_LT_LT_EQ] = ACTIONS(5735),
    [anon_sym_CARET_EQ] = ACTIONS(5735),
    [anon_sym_QMARK] = ACTIONS(5735),
    [anon_sym_DOT_DOT] = ACTIONS(5737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5735),
    [anon_sym_and] = ACTIONS(5735),
    [anon_sym_or] = ACTIONS(5735),
    [anon_sym_PIPE_PIPE] = ACTIONS(5737),
    [anon_sym_AMP_AMP] = ACTIONS(5737),
    [anon_sym_LT_LT] = ACTIONS(5737),
    [anon_sym_GT_GT] = ACTIONS(5737),
    [anon_sym_EQ_EQ] = ACTIONS(5737),
    [anon_sym_BANG_EQ] = ACTIONS(5735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5735),
    [anon_sym_LT_EQ_GT] = ACTIONS(5735),
    [anon_sym_EQ_TILDE] = ACTIONS(5735),
    [anon_sym_BANG_TILDE] = ACTIONS(5735),
    [anon_sym_LT_EQ] = ACTIONS(5737),
    [anon_sym_GT] = ACTIONS(5737),
    [anon_sym_GT_EQ] = ACTIONS(5735),
    [anon_sym_CARET] = ACTIONS(5737),
    [anon_sym_PLUS] = ACTIONS(5737),
    [anon_sym_SLASH] = ACTIONS(5737),
    [anon_sym_PERCENT] = ACTIONS(5737),
    [sym_comment] = ACTIONS(87),
  },
  [1957] = {
    [anon_sym_RBRACE] = ACTIONS(7071),
    [sym_comment] = ACTIONS(87),
  },
  [1958] = {
    [sym__statements] = STATE(4305),
    [sym_begin_block] = STATE(489),
    [sym_end_block] = STATE(489),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(495),
    [aux_sym__statements_repeat1] = STATE(495),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(7071),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1959] = {
    [anon_sym_RBRACE] = ACTIONS(7073),
    [sym_comment] = ACTIONS(87),
  },
  [1960] = {
    [sym_heredoc_body] = STATE(4307),
    [sym__heredoc_body_start] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(7073),
    [sym_comment] = ACTIONS(87),
  },
  [1961] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(4308),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(674),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(674),
    [sym_assignment] = STATE(4308),
    [sym_operator_assignment] = STATE(4308),
    [sym_conditional] = STATE(4308),
    [sym_range] = STATE(4308),
    [sym_binary] = STATE(4308),
    [sym_unary] = STATE(4308),
    [sym_left_assignment_list] = STATE(673),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(674),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(674),
    [sym_false] = STATE(674),
    [sym_nil] = STATE(674),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(675),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1243),
    [anon_sym_yield] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1247),
    [anon_sym_next] = ACTIONS(1249),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1962] = {
    [sym__heredoc_body_start] = ACTIONS(1273),
    [sym__binary_minus] = ACTIONS(1273),
    [sym__binary_star] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_RBRACE] = ACTIONS(1273),
    [anon_sym_RPAREN] = ACTIONS(1273),
    [anon_sym_DOT] = ACTIONS(1275),
    [anon_sym_COMMA] = ACTIONS(1273),
    [anon_sym_PIPE] = ACTIONS(1275),
    [anon_sym_SEMI] = ACTIONS(1273),
    [anon_sym_STAR_STAR] = ACTIONS(1275),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_EQ] = ACTIONS(1275),
    [anon_sym_LT] = ACTIONS(1275),
    [anon_sym_if] = ACTIONS(1273),
    [anon_sym_unless] = ACTIONS(1273),
    [anon_sym_while] = ACTIONS(1273),
    [anon_sym_until] = ACTIONS(1273),
    [anon_sym_rescue] = ACTIONS(1273),
    [anon_sym_in] = ACTIONS(1273),
    [anon_sym_do] = ACTIONS(1273),
    [anon_sym_EQ_GT] = ACTIONS(1273),
    [anon_sym_LBRACK] = ACTIONS(1273),
    [anon_sym_RBRACK] = ACTIONS(1273),
    [anon_sym_COLON_COLON2] = ACTIONS(1273),
    [anon_sym_AMP_DOT] = ACTIONS(1273),
    [anon_sym_PLUS_EQ] = ACTIONS(1273),
    [anon_sym_DASH_EQ] = ACTIONS(1273),
    [anon_sym_STAR_EQ] = ACTIONS(1273),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1273),
    [anon_sym_SLASH_EQ] = ACTIONS(1273),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1273),
    [anon_sym_PIPE_EQ] = ACTIONS(1273),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1273),
    [anon_sym_AMP_EQ] = ACTIONS(1273),
    [anon_sym_PERCENT_EQ] = ACTIONS(1273),
    [anon_sym_GT_GT_EQ] = ACTIONS(1273),
    [anon_sym_LT_LT_EQ] = ACTIONS(1273),
    [anon_sym_CARET_EQ] = ACTIONS(1273),
    [anon_sym_QMARK] = ACTIONS(1273),
    [anon_sym_COLON2] = ACTIONS(1275),
    [anon_sym_DOT_DOT] = ACTIONS(1275),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_and] = ACTIONS(1273),
    [anon_sym_or] = ACTIONS(1273),
    [anon_sym_PIPE_PIPE] = ACTIONS(1275),
    [anon_sym_AMP_AMP] = ACTIONS(1275),
    [anon_sym_LT_LT] = ACTIONS(1275),
    [anon_sym_GT_GT] = ACTIONS(1275),
    [anon_sym_EQ_EQ] = ACTIONS(1275),
    [anon_sym_BANG_EQ] = ACTIONS(1273),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1273),
    [anon_sym_LT_EQ_GT] = ACTIONS(1273),
    [anon_sym_EQ_TILDE] = ACTIONS(1273),
    [anon_sym_BANG_TILDE] = ACTIONS(1273),
    [anon_sym_LT_EQ] = ACTIONS(1275),
    [anon_sym_GT] = ACTIONS(1275),
    [anon_sym_GT_EQ] = ACTIONS(1273),
    [anon_sym_CARET] = ACTIONS(1275),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_SLASH] = ACTIONS(1275),
    [anon_sym_PERCENT] = ACTIONS(1275),
    [sym_comment] = ACTIONS(87),
  },
  [1963] = {
    [anon_sym_DOT] = ACTIONS(7075),
    [anon_sym_COLON_COLON] = ACTIONS(7075),
    [sym_comment] = ACTIONS(87),
  },
  [1964] = {
    [sym_method_parameters] = STATE(4310),
    [sym__simple_formal_parameter] = STATE(684),
    [sym_splat_parameter] = STATE(684),
    [sym_hash_splat_parameter] = STATE(684),
    [sym_block_parameter] = STATE(684),
    [sym_keyword_parameter] = STATE(684),
    [sym_optional_parameter] = STATE(684),
    [sym_heredoc_body] = STATE(4310),
    [sym__terminator] = STATE(4310),
    [sym__line_break] = ACTIONS(7077),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_SEMI] = ACTIONS(7077),
    [anon_sym_STAR] = ACTIONS(1283),
    [anon_sym_STAR_STAR] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1287),
    [sym_identifier] = ACTIONS(1289),
    [sym_comment] = ACTIONS(87),
  },
  [1965] = {
    [sym__heredoc_body_start] = ACTIONS(1291),
    [sym__binary_minus] = ACTIONS(1291),
    [sym__binary_star] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1291),
    [anon_sym_RBRACE] = ACTIONS(1291),
    [anon_sym_RPAREN] = ACTIONS(1291),
    [anon_sym_DOT] = ACTIONS(1293),
    [anon_sym_COMMA] = ACTIONS(1291),
    [anon_sym_PIPE] = ACTIONS(1293),
    [anon_sym_SEMI] = ACTIONS(1291),
    [anon_sym_STAR_STAR] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1293),
    [anon_sym_EQ] = ACTIONS(1293),
    [anon_sym_LT] = ACTIONS(1293),
    [anon_sym_if] = ACTIONS(1291),
    [anon_sym_unless] = ACTIONS(1291),
    [anon_sym_while] = ACTIONS(1291),
    [anon_sym_until] = ACTIONS(1291),
    [anon_sym_rescue] = ACTIONS(1291),
    [anon_sym_in] = ACTIONS(1291),
    [anon_sym_do] = ACTIONS(1291),
    [anon_sym_EQ_GT] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_RBRACK] = ACTIONS(1291),
    [anon_sym_COLON_COLON2] = ACTIONS(1291),
    [anon_sym_AMP_DOT] = ACTIONS(1291),
    [anon_sym_PLUS_EQ] = ACTIONS(1291),
    [anon_sym_DASH_EQ] = ACTIONS(1291),
    [anon_sym_STAR_EQ] = ACTIONS(1291),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1291),
    [anon_sym_SLASH_EQ] = ACTIONS(1291),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1291),
    [anon_sym_PIPE_EQ] = ACTIONS(1291),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1291),
    [anon_sym_AMP_EQ] = ACTIONS(1291),
    [anon_sym_PERCENT_EQ] = ACTIONS(1291),
    [anon_sym_GT_GT_EQ] = ACTIONS(1291),
    [anon_sym_LT_LT_EQ] = ACTIONS(1291),
    [anon_sym_CARET_EQ] = ACTIONS(1291),
    [anon_sym_QMARK] = ACTIONS(1291),
    [anon_sym_COLON2] = ACTIONS(1293),
    [anon_sym_DOT_DOT] = ACTIONS(1293),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1291),
    [anon_sym_and] = ACTIONS(1291),
    [anon_sym_or] = ACTIONS(1291),
    [anon_sym_PIPE_PIPE] = ACTIONS(1293),
    [anon_sym_AMP_AMP] = ACTIONS(1293),
    [anon_sym_LT_LT] = ACTIONS(1293),
    [anon_sym_GT_GT] = ACTIONS(1293),
    [anon_sym_EQ_EQ] = ACTIONS(1293),
    [anon_sym_BANG_EQ] = ACTIONS(1291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1291),
    [anon_sym_LT_EQ_GT] = ACTIONS(1291),
    [anon_sym_EQ_TILDE] = ACTIONS(1291),
    [anon_sym_BANG_TILDE] = ACTIONS(1291),
    [anon_sym_LT_EQ] = ACTIONS(1293),
    [anon_sym_GT] = ACTIONS(1293),
    [anon_sym_GT_EQ] = ACTIONS(1291),
    [anon_sym_CARET] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1293),
    [anon_sym_SLASH] = ACTIONS(1293),
    [anon_sym_PERCENT] = ACTIONS(1293),
    [sym_comment] = ACTIONS(87),
  },
  [1966] = {
    [anon_sym_RPAREN] = ACTIONS(7079),
    [sym_comment] = ACTIONS(87),
  },
  [1967] = {
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(3509),
    [sym__binary_star] = ACTIONS(3511),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(3513),
    [anon_sym_STAR_STAR] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(3517),
    [anon_sym_EQ] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(3519),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_EQ_GT] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_PLUS_EQ] = ACTIONS(3281),
    [anon_sym_DASH_EQ] = ACTIONS(3281),
    [anon_sym_STAR_EQ] = ACTIONS(3281),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3281),
    [anon_sym_SLASH_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3281),
    [anon_sym_AMP_EQ] = ACTIONS(3281),
    [anon_sym_PERCENT_EQ] = ACTIONS(3281),
    [anon_sym_GT_GT_EQ] = ACTIONS(3281),
    [anon_sym_LT_LT_EQ] = ACTIONS(3281),
    [anon_sym_CARET_EQ] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3521),
    [anon_sym_DOT_DOT] = ACTIONS(3523),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3525),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(3527),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_LT_LT] = ACTIONS(3529),
    [anon_sym_GT_GT] = ACTIONS(3529),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ] = ACTIONS(3531),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3531),
    [anon_sym_LT_EQ_GT] = ACTIONS(3531),
    [anon_sym_EQ_TILDE] = ACTIONS(3531),
    [anon_sym_BANG_TILDE] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3519),
    [anon_sym_GT] = ACTIONS(3519),
    [anon_sym_GT_EQ] = ACTIONS(3533),
    [anon_sym_CARET] = ACTIONS(3513),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_SLASH] = ACTIONS(3515),
    [anon_sym_PERCENT] = ACTIONS(3515),
    [sym_comment] = ACTIONS(87),
  },
  [1968] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(4312),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(4312),
    [sym_operator_assignment] = STATE(4312),
    [sym_conditional] = STATE(4312),
    [sym_range] = STATE(4312),
    [sym_binary] = STATE(4312),
    [sym_unary] = STATE(4312),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(485),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(495),
    [anon_sym_defined_QMARK] = ACTIONS(497),
    [anon_sym_not] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(501),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1969] = {
    [sym_superclass] = STATE(4313),
    [sym_heredoc_body] = STATE(4314),
    [sym__terminator] = STATE(4314),
    [sym__line_break] = ACTIONS(7081),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1089),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(7081),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1089),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1517),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1089),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [1970] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_superclass] = STATE(4313),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(859),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym_argument_list] = STATE(832),
    [sym__argument_list_with_parens] = STATE(860),
    [sym__argument] = STATE(861),
    [sym_splat_argument] = STATE(861),
    [sym_hash_splat_argument] = STATE(861),
    [sym_block_argument] = STATE(861),
    [sym_do_block] = STATE(835),
    [sym_block] = STATE(835),
    [sym_assignment] = STATE(859),
    [sym_operator_assignment] = STATE(859),
    [sym_conditional] = STATE(859),
    [sym_range] = STATE(859),
    [sym_binary] = STATE(859),
    [sym_unary] = STATE(859),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(864),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_heredoc_body] = STATE(4314),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(861),
    [sym_lambda] = STATE(347),
    [sym__terminator] = STATE(4314),
    [sym__line_break] = ACTIONS(7081),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1521),
    [sym__splat_star] = ACTIONS(1523),
    [sym__unary_minus] = ACTIONS(1525),
    [sym__identifier_hash_key] = ACTIONS(1527),
    [anon_sym_LBRACE] = ACTIONS(1529),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(743),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(7081),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1531),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(1517),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1473),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(1549),
    [sym_identifier] = ACTIONS(1549),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1971] = {
    [sym_heredoc_body] = STATE(4316),
    [sym__terminator] = STATE(4316),
    [sym__line_break] = ACTIONS(7083),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1089),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(7083),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1089),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(7085),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1089),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [1972] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(859),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym_argument_list] = STATE(832),
    [sym__argument_list_with_parens] = STATE(860),
    [sym__argument] = STATE(861),
    [sym_splat_argument] = STATE(861),
    [sym_hash_splat_argument] = STATE(861),
    [sym_block_argument] = STATE(861),
    [sym_do_block] = STATE(835),
    [sym_block] = STATE(835),
    [sym_assignment] = STATE(859),
    [sym_operator_assignment] = STATE(859),
    [sym_conditional] = STATE(859),
    [sym_range] = STATE(859),
    [sym_binary] = STATE(859),
    [sym_unary] = STATE(859),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(864),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_heredoc_body] = STATE(4316),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(861),
    [sym_lambda] = STATE(347),
    [sym__terminator] = STATE(4316),
    [sym__line_break] = ACTIONS(7083),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1521),
    [sym__splat_star] = ACTIONS(1523),
    [sym__unary_minus] = ACTIONS(1525),
    [sym__identifier_hash_key] = ACTIONS(1527),
    [anon_sym_LBRACE] = ACTIONS(1529),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(743),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(7083),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1531),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_end] = ACTIONS(7085),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1473),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(1549),
    [sym_identifier] = ACTIONS(1549),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1973] = {
    [sym__heredoc_body_start] = ACTIONS(1677),
    [sym__binary_minus] = ACTIONS(1677),
    [sym__binary_star] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1677),
    [anon_sym_RBRACE] = ACTIONS(1677),
    [anon_sym_RPAREN] = ACTIONS(1677),
    [anon_sym_DOT] = ACTIONS(1679),
    [anon_sym_COMMA] = ACTIONS(1677),
    [anon_sym_PIPE] = ACTIONS(1679),
    [anon_sym_SEMI] = ACTIONS(1677),
    [anon_sym_STAR_STAR] = ACTIONS(1679),
    [anon_sym_AMP] = ACTIONS(1679),
    [anon_sym_EQ] = ACTIONS(1679),
    [anon_sym_LT] = ACTIONS(1679),
    [anon_sym_if] = ACTIONS(1677),
    [anon_sym_unless] = ACTIONS(1677),
    [anon_sym_while] = ACTIONS(1677),
    [anon_sym_until] = ACTIONS(1677),
    [anon_sym_rescue] = ACTIONS(1677),
    [anon_sym_in] = ACTIONS(1677),
    [anon_sym_do] = ACTIONS(1677),
    [anon_sym_EQ_GT] = ACTIONS(1677),
    [anon_sym_LBRACK] = ACTIONS(1677),
    [anon_sym_RBRACK] = ACTIONS(1677),
    [anon_sym_COLON_COLON2] = ACTIONS(1677),
    [anon_sym_AMP_DOT] = ACTIONS(1677),
    [anon_sym_PLUS_EQ] = ACTIONS(1677),
    [anon_sym_DASH_EQ] = ACTIONS(1677),
    [anon_sym_STAR_EQ] = ACTIONS(1677),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1677),
    [anon_sym_SLASH_EQ] = ACTIONS(1677),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1677),
    [anon_sym_PIPE_EQ] = ACTIONS(1677),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1677),
    [anon_sym_AMP_EQ] = ACTIONS(1677),
    [anon_sym_PERCENT_EQ] = ACTIONS(1677),
    [anon_sym_GT_GT_EQ] = ACTIONS(1677),
    [anon_sym_LT_LT_EQ] = ACTIONS(1677),
    [anon_sym_CARET_EQ] = ACTIONS(1677),
    [anon_sym_QMARK] = ACTIONS(1677),
    [anon_sym_COLON2] = ACTIONS(1679),
    [anon_sym_DOT_DOT] = ACTIONS(1679),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1677),
    [anon_sym_and] = ACTIONS(1677),
    [anon_sym_or] = ACTIONS(1677),
    [anon_sym_PIPE_PIPE] = ACTIONS(1679),
    [anon_sym_AMP_AMP] = ACTIONS(1679),
    [anon_sym_LT_LT] = ACTIONS(1679),
    [anon_sym_GT_GT] = ACTIONS(1679),
    [anon_sym_EQ_EQ] = ACTIONS(1679),
    [anon_sym_BANG_EQ] = ACTIONS(1677),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1677),
    [anon_sym_LT_EQ_GT] = ACTIONS(1677),
    [anon_sym_EQ_TILDE] = ACTIONS(1677),
    [anon_sym_BANG_TILDE] = ACTIONS(1677),
    [anon_sym_LT_EQ] = ACTIONS(1679),
    [anon_sym_GT] = ACTIONS(1679),
    [anon_sym_GT_EQ] = ACTIONS(1677),
    [anon_sym_CARET] = ACTIONS(1679),
    [anon_sym_PLUS] = ACTIONS(1679),
    [anon_sym_SLASH] = ACTIONS(1679),
    [anon_sym_PERCENT] = ACTIONS(1679),
    [sym_comment] = ACTIONS(87),
  },
  [1974] = {
    [sym__heredoc_body_start] = ACTIONS(1697),
    [sym__binary_minus] = ACTIONS(1697),
    [sym__binary_star] = ACTIONS(1697),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_RBRACE] = ACTIONS(1697),
    [anon_sym_RPAREN] = ACTIONS(1697),
    [anon_sym_DOT] = ACTIONS(1699),
    [anon_sym_COMMA] = ACTIONS(1697),
    [anon_sym_PIPE] = ACTIONS(1699),
    [anon_sym_SEMI] = ACTIONS(1697),
    [anon_sym_STAR_STAR] = ACTIONS(1699),
    [anon_sym_AMP] = ACTIONS(1699),
    [anon_sym_EQ] = ACTIONS(1699),
    [anon_sym_LT] = ACTIONS(1699),
    [anon_sym_if] = ACTIONS(1697),
    [anon_sym_unless] = ACTIONS(1697),
    [anon_sym_while] = ACTIONS(1697),
    [anon_sym_until] = ACTIONS(1697),
    [anon_sym_rescue] = ACTIONS(1697),
    [anon_sym_in] = ACTIONS(1697),
    [anon_sym_do] = ACTIONS(1697),
    [anon_sym_EQ_GT] = ACTIONS(1697),
    [anon_sym_LBRACK] = ACTIONS(1697),
    [anon_sym_RBRACK] = ACTIONS(1697),
    [anon_sym_COLON_COLON2] = ACTIONS(1697),
    [anon_sym_AMP_DOT] = ACTIONS(1697),
    [anon_sym_PLUS_EQ] = ACTIONS(1697),
    [anon_sym_DASH_EQ] = ACTIONS(1697),
    [anon_sym_STAR_EQ] = ACTIONS(1697),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1697),
    [anon_sym_SLASH_EQ] = ACTIONS(1697),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1697),
    [anon_sym_PIPE_EQ] = ACTIONS(1697),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1697),
    [anon_sym_AMP_EQ] = ACTIONS(1697),
    [anon_sym_PERCENT_EQ] = ACTIONS(1697),
    [anon_sym_GT_GT_EQ] = ACTIONS(1697),
    [anon_sym_LT_LT_EQ] = ACTIONS(1697),
    [anon_sym_CARET_EQ] = ACTIONS(1697),
    [anon_sym_QMARK] = ACTIONS(1697),
    [anon_sym_COLON2] = ACTIONS(1699),
    [anon_sym_DOT_DOT] = ACTIONS(1699),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1697),
    [anon_sym_and] = ACTIONS(1697),
    [anon_sym_or] = ACTIONS(1697),
    [anon_sym_PIPE_PIPE] = ACTIONS(1699),
    [anon_sym_AMP_AMP] = ACTIONS(1699),
    [anon_sym_LT_LT] = ACTIONS(1699),
    [anon_sym_GT_GT] = ACTIONS(1699),
    [anon_sym_EQ_EQ] = ACTIONS(1699),
    [anon_sym_BANG_EQ] = ACTIONS(1697),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1697),
    [anon_sym_LT_EQ_GT] = ACTIONS(1697),
    [anon_sym_EQ_TILDE] = ACTIONS(1697),
    [anon_sym_BANG_TILDE] = ACTIONS(1697),
    [anon_sym_LT_EQ] = ACTIONS(1699),
    [anon_sym_GT] = ACTIONS(1699),
    [anon_sym_GT_EQ] = ACTIONS(1697),
    [anon_sym_CARET] = ACTIONS(1699),
    [anon_sym_PLUS] = ACTIONS(1699),
    [anon_sym_SLASH] = ACTIONS(1699),
    [anon_sym_PERCENT] = ACTIONS(1699),
    [sym_comment] = ACTIONS(87),
  },
  [1975] = {
    [sym__heredoc_body_start] = ACTIONS(1701),
    [sym__binary_minus] = ACTIONS(1701),
    [sym__binary_star] = ACTIONS(1701),
    [anon_sym_LBRACE] = ACTIONS(1701),
    [anon_sym_RBRACE] = ACTIONS(1701),
    [anon_sym_RPAREN] = ACTIONS(1701),
    [anon_sym_DOT] = ACTIONS(1703),
    [anon_sym_COMMA] = ACTIONS(1701),
    [anon_sym_PIPE] = ACTIONS(1703),
    [anon_sym_SEMI] = ACTIONS(1701),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1703),
    [anon_sym_EQ] = ACTIONS(1703),
    [anon_sym_LT] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1701),
    [anon_sym_unless] = ACTIONS(1701),
    [anon_sym_while] = ACTIONS(1701),
    [anon_sym_until] = ACTIONS(1701),
    [anon_sym_rescue] = ACTIONS(1701),
    [anon_sym_in] = ACTIONS(1701),
    [anon_sym_do] = ACTIONS(1701),
    [anon_sym_EQ_GT] = ACTIONS(1701),
    [anon_sym_LBRACK] = ACTIONS(1701),
    [anon_sym_RBRACK] = ACTIONS(1701),
    [anon_sym_COLON_COLON2] = ACTIONS(1701),
    [anon_sym_AMP_DOT] = ACTIONS(1701),
    [anon_sym_PLUS_EQ] = ACTIONS(1701),
    [anon_sym_DASH_EQ] = ACTIONS(1701),
    [anon_sym_STAR_EQ] = ACTIONS(1701),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1701),
    [anon_sym_SLASH_EQ] = ACTIONS(1701),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1701),
    [anon_sym_PIPE_EQ] = ACTIONS(1701),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1701),
    [anon_sym_AMP_EQ] = ACTIONS(1701),
    [anon_sym_PERCENT_EQ] = ACTIONS(1701),
    [anon_sym_GT_GT_EQ] = ACTIONS(1701),
    [anon_sym_LT_LT_EQ] = ACTIONS(1701),
    [anon_sym_CARET_EQ] = ACTIONS(1701),
    [anon_sym_QMARK] = ACTIONS(1701),
    [anon_sym_COLON2] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1703),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1701),
    [anon_sym_and] = ACTIONS(1701),
    [anon_sym_or] = ACTIONS(1701),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1703),
    [anon_sym_BANG_EQ] = ACTIONS(1701),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1701),
    [anon_sym_LT_EQ_GT] = ACTIONS(1701),
    [anon_sym_EQ_TILDE] = ACTIONS(1701),
    [anon_sym_BANG_TILDE] = ACTIONS(1701),
    [anon_sym_LT_EQ] = ACTIONS(1703),
    [anon_sym_GT] = ACTIONS(1703),
    [anon_sym_GT_EQ] = ACTIONS(1701),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [1976] = {
    [sym__heredoc_body_start] = ACTIONS(1705),
    [sym__binary_minus] = ACTIONS(1705),
    [sym__binary_star] = ACTIONS(1705),
    [anon_sym_LBRACE] = ACTIONS(1705),
    [anon_sym_RBRACE] = ACTIONS(1705),
    [anon_sym_RPAREN] = ACTIONS(1705),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1705),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1705),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1705),
    [anon_sym_unless] = ACTIONS(1705),
    [anon_sym_while] = ACTIONS(1705),
    [anon_sym_until] = ACTIONS(1705),
    [anon_sym_rescue] = ACTIONS(1705),
    [anon_sym_in] = ACTIONS(1705),
    [anon_sym_do] = ACTIONS(1705),
    [anon_sym_EQ_GT] = ACTIONS(1705),
    [anon_sym_LBRACK] = ACTIONS(1705),
    [anon_sym_RBRACK] = ACTIONS(1705),
    [anon_sym_COLON_COLON2] = ACTIONS(1705),
    [anon_sym_AMP_DOT] = ACTIONS(1705),
    [anon_sym_PLUS_EQ] = ACTIONS(1705),
    [anon_sym_DASH_EQ] = ACTIONS(1705),
    [anon_sym_STAR_EQ] = ACTIONS(1705),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1705),
    [anon_sym_SLASH_EQ] = ACTIONS(1705),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1705),
    [anon_sym_PIPE_EQ] = ACTIONS(1705),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1705),
    [anon_sym_AMP_EQ] = ACTIONS(1705),
    [anon_sym_PERCENT_EQ] = ACTIONS(1705),
    [anon_sym_GT_GT_EQ] = ACTIONS(1705),
    [anon_sym_LT_LT_EQ] = ACTIONS(1705),
    [anon_sym_CARET_EQ] = ACTIONS(1705),
    [anon_sym_QMARK] = ACTIONS(1705),
    [anon_sym_COLON2] = ACTIONS(1707),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1705),
    [anon_sym_and] = ACTIONS(1705),
    [anon_sym_or] = ACTIONS(1705),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1705),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1705),
    [anon_sym_LT_EQ_GT] = ACTIONS(1705),
    [anon_sym_EQ_TILDE] = ACTIONS(1705),
    [anon_sym_BANG_TILDE] = ACTIONS(1705),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1705),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [1977] = {
    [sym_then] = STATE(4317),
    [sym_heredoc_body] = STATE(4318),
    [sym__terminator] = STATE(4318),
    [sym__line_break] = ACTIONS(7087),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(7087),
    [anon_sym_if] = ACTIONS(1743),
    [anon_sym_unless] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1747),
    [anon_sym_until] = ACTIONS(1749),
    [anon_sym_rescue] = ACTIONS(1751),
    [anon_sym_then] = ACTIONS(1753),
    [sym_comment] = ACTIONS(87),
  },
  [1978] = {
    [sym_then] = STATE(4319),
    [sym_heredoc_body] = STATE(4320),
    [sym__terminator] = STATE(4320),
    [sym__line_break] = ACTIONS(7089),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(7089),
    [anon_sym_if] = ACTIONS(1743),
    [anon_sym_unless] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1747),
    [anon_sym_until] = ACTIONS(1749),
    [anon_sym_rescue] = ACTIONS(1751),
    [anon_sym_then] = ACTIONS(1821),
    [sym_comment] = ACTIONS(87),
  },
  [1979] = {
    [sym__do] = STATE(4321),
    [sym_heredoc_body] = STATE(4321),
    [sym__terminator] = STATE(4321),
    [sym__line_break] = ACTIONS(7091),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym__binary_minus] = ACTIONS(1855),
    [sym__binary_star] = ACTIONS(1857),
    [anon_sym_PIPE] = ACTIONS(1859),
    [anon_sym_SEMI] = ACTIONS(7091),
    [anon_sym_STAR_STAR] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_LT] = ACTIONS(1863),
    [anon_sym_do] = ACTIONS(7091),
    [anon_sym_QMARK] = ACTIONS(1865),
    [anon_sym_DOT_DOT] = ACTIONS(1867),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1869),
    [anon_sym_and] = ACTIONS(1871),
    [anon_sym_or] = ACTIONS(1871),
    [anon_sym_PIPE_PIPE] = ACTIONS(1873),
    [anon_sym_AMP_AMP] = ACTIONS(1873),
    [anon_sym_LT_LT] = ACTIONS(1875),
    [anon_sym_GT_GT] = ACTIONS(1875),
    [anon_sym_EQ_EQ] = ACTIONS(1877),
    [anon_sym_BANG_EQ] = ACTIONS(1873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1873),
    [anon_sym_LT_EQ_GT] = ACTIONS(1873),
    [anon_sym_EQ_TILDE] = ACTIONS(1873),
    [anon_sym_BANG_TILDE] = ACTIONS(1873),
    [anon_sym_LT_EQ] = ACTIONS(1863),
    [anon_sym_GT] = ACTIONS(1863),
    [anon_sym_GT_EQ] = ACTIONS(1879),
    [anon_sym_CARET] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_SLASH] = ACTIONS(1857),
    [anon_sym_PERCENT] = ACTIONS(1857),
    [sym_comment] = ACTIONS(87),
  },
  [1980] = {
    [sym__do] = STATE(4322),
    [sym_heredoc_body] = STATE(4322),
    [sym__terminator] = STATE(4322),
    [sym__line_break] = ACTIONS(7093),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym__binary_minus] = ACTIONS(1855),
    [sym__binary_star] = ACTIONS(1857),
    [anon_sym_PIPE] = ACTIONS(1859),
    [anon_sym_SEMI] = ACTIONS(7093),
    [anon_sym_STAR_STAR] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_LT] = ACTIONS(1863),
    [anon_sym_do] = ACTIONS(7093),
    [anon_sym_QMARK] = ACTIONS(1865),
    [anon_sym_DOT_DOT] = ACTIONS(1867),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1869),
    [anon_sym_and] = ACTIONS(1871),
    [anon_sym_or] = ACTIONS(1871),
    [anon_sym_PIPE_PIPE] = ACTIONS(1873),
    [anon_sym_AMP_AMP] = ACTIONS(1873),
    [anon_sym_LT_LT] = ACTIONS(1875),
    [anon_sym_GT_GT] = ACTIONS(1875),
    [anon_sym_EQ_EQ] = ACTIONS(1877),
    [anon_sym_BANG_EQ] = ACTIONS(1873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1873),
    [anon_sym_LT_EQ_GT] = ACTIONS(1873),
    [anon_sym_EQ_TILDE] = ACTIONS(1873),
    [anon_sym_BANG_TILDE] = ACTIONS(1873),
    [anon_sym_LT_EQ] = ACTIONS(1863),
    [anon_sym_GT] = ACTIONS(1863),
    [anon_sym_GT_EQ] = ACTIONS(1879),
    [anon_sym_CARET] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_SLASH] = ACTIONS(1857),
    [anon_sym_PERCENT] = ACTIONS(1857),
    [sym_comment] = ACTIONS(87),
  },
  [1981] = {
    [sym_in] = STATE(4323),
    [anon_sym_in] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
  },
  [1982] = {
    [sym__binary_minus] = ACTIONS(5771),
    [sym__binary_star] = ACTIONS(5771),
    [anon_sym_DOT] = ACTIONS(5773),
    [anon_sym_COMMA] = ACTIONS(5771),
    [anon_sym_PIPE] = ACTIONS(5773),
    [anon_sym_STAR_STAR] = ACTIONS(5773),
    [anon_sym_AMP] = ACTIONS(5773),
    [anon_sym_EQ] = ACTIONS(5773),
    [anon_sym_LT] = ACTIONS(5773),
    [anon_sym_EQ_GT] = ACTIONS(5771),
    [anon_sym_LBRACK] = ACTIONS(5771),
    [anon_sym_COLON_COLON2] = ACTIONS(5771),
    [anon_sym_AMP_DOT] = ACTIONS(5771),
    [anon_sym_PLUS_EQ] = ACTIONS(5771),
    [anon_sym_DASH_EQ] = ACTIONS(5771),
    [anon_sym_STAR_EQ] = ACTIONS(5771),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5771),
    [anon_sym_SLASH_EQ] = ACTIONS(5771),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5771),
    [anon_sym_PIPE_EQ] = ACTIONS(5771),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5771),
    [anon_sym_AMP_EQ] = ACTIONS(5771),
    [anon_sym_PERCENT_EQ] = ACTIONS(5771),
    [anon_sym_GT_GT_EQ] = ACTIONS(5771),
    [anon_sym_LT_LT_EQ] = ACTIONS(5771),
    [anon_sym_CARET_EQ] = ACTIONS(5771),
    [anon_sym_QMARK] = ACTIONS(5771),
    [anon_sym_DOT_DOT] = ACTIONS(5773),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5771),
    [anon_sym_and] = ACTIONS(5771),
    [anon_sym_or] = ACTIONS(5771),
    [anon_sym_PIPE_PIPE] = ACTIONS(5773),
    [anon_sym_AMP_AMP] = ACTIONS(5773),
    [anon_sym_LT_LT] = ACTIONS(5773),
    [anon_sym_GT_GT] = ACTIONS(5773),
    [anon_sym_EQ_EQ] = ACTIONS(5773),
    [anon_sym_BANG_EQ] = ACTIONS(5771),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5771),
    [anon_sym_LT_EQ_GT] = ACTIONS(5771),
    [anon_sym_EQ_TILDE] = ACTIONS(5771),
    [anon_sym_BANG_TILDE] = ACTIONS(5771),
    [anon_sym_LT_EQ] = ACTIONS(5773),
    [anon_sym_GT] = ACTIONS(5773),
    [anon_sym_GT_EQ] = ACTIONS(5771),
    [anon_sym_CARET] = ACTIONS(5773),
    [anon_sym_PLUS] = ACTIONS(5773),
    [anon_sym_SLASH] = ACTIONS(5773),
    [anon_sym_PERCENT] = ACTIONS(5773),
    [sym_comment] = ACTIONS(87),
  },
  [1983] = {
    [anon_sym_end] = ACTIONS(7095),
    [sym_comment] = ACTIONS(87),
  },
  [1984] = {
    [sym__statements] = STATE(4325),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_heredoc_body] = STATE(4326),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [sym__terminator] = STATE(4326),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__line_break] = ACTIONS(7097),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(7097),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(7099),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1985] = {
    [sym__statements] = STATE(4325),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_block_parameters] = STATE(4327),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(7099),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1986] = {
    [sym_heredoc_body] = STATE(4328),
    [sym__terminator] = STATE(4328),
    [sym__line_break] = ACTIONS(7101),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym__binary_minus] = ACTIONS(2001),
    [sym__binary_star] = ACTIONS(2003),
    [anon_sym_PIPE] = ACTIONS(2005),
    [anon_sym_SEMI] = ACTIONS(7101),
    [anon_sym_STAR_STAR] = ACTIONS(2003),
    [anon_sym_AMP] = ACTIONS(2007),
    [anon_sym_LT] = ACTIONS(2009),
    [anon_sym_QMARK] = ACTIONS(2011),
    [anon_sym_DOT_DOT] = ACTIONS(2013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2015),
    [anon_sym_and] = ACTIONS(2017),
    [anon_sym_or] = ACTIONS(2017),
    [anon_sym_PIPE_PIPE] = ACTIONS(2019),
    [anon_sym_AMP_AMP] = ACTIONS(2019),
    [anon_sym_LT_LT] = ACTIONS(2021),
    [anon_sym_GT_GT] = ACTIONS(2021),
    [anon_sym_EQ_EQ] = ACTIONS(2023),
    [anon_sym_BANG_EQ] = ACTIONS(2019),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2019),
    [anon_sym_LT_EQ_GT] = ACTIONS(2019),
    [anon_sym_EQ_TILDE] = ACTIONS(2019),
    [anon_sym_BANG_TILDE] = ACTIONS(2019),
    [anon_sym_LT_EQ] = ACTIONS(2009),
    [anon_sym_GT] = ACTIONS(2009),
    [anon_sym_GT_EQ] = ACTIONS(2025),
    [anon_sym_CARET] = ACTIONS(2027),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_SLASH] = ACTIONS(2003),
    [anon_sym_PERCENT] = ACTIONS(2003),
    [sym_comment] = ACTIONS(87),
  },
  [1987] = {
    [sym_when] = STATE(4332),
    [sym_else] = STATE(4330),
    [aux_sym_case_repeat1] = STATE(4331),
    [aux_sym_case_repeat2] = STATE(4332),
    [anon_sym_SEMI] = ACTIONS(7103),
    [anon_sym_end] = ACTIONS(7105),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [1988] = {
    [sym_else] = STATE(4334),
    [sym_ensure] = STATE(4335),
    [sym_rescue] = STATE(4336),
    [anon_sym_end] = ACTIONS(7107),
    [anon_sym_rescue] = ACTIONS(2165),
    [anon_sym_else] = ACTIONS(2167),
    [anon_sym_ensure] = ACTIONS(2169),
    [sym_comment] = ACTIONS(87),
  },
  [1989] = {
    [sym_ensure] = STATE(4335),
    [anon_sym_end] = ACTIONS(7107),
    [anon_sym_ensure] = ACTIONS(2169),
    [sym_comment] = ACTIONS(87),
  },
  [1990] = {
    [anon_sym_end] = ACTIONS(7107),
    [sym_comment] = ACTIONS(87),
  },
  [1991] = {
    [sym_else] = STATE(4334),
    [sym_ensure] = STATE(4335),
    [anon_sym_end] = ACTIONS(7107),
    [anon_sym_else] = ACTIONS(2167),
    [anon_sym_ensure] = ACTIONS(2169),
    [sym_comment] = ACTIONS(87),
  },
  [1992] = {
    [sym__heredoc_body_start] = ACTIONS(2181),
    [sym__binary_minus] = ACTIONS(2181),
    [sym__binary_star] = ACTIONS(2181),
    [anon_sym_LBRACE] = ACTIONS(2181),
    [anon_sym_RBRACE] = ACTIONS(2181),
    [anon_sym_RPAREN] = ACTIONS(2181),
    [anon_sym_DOT] = ACTIONS(2183),
    [anon_sym_COMMA] = ACTIONS(2181),
    [anon_sym_PIPE] = ACTIONS(2183),
    [anon_sym_SEMI] = ACTIONS(2181),
    [anon_sym_STAR_STAR] = ACTIONS(2183),
    [anon_sym_AMP] = ACTIONS(2183),
    [anon_sym_EQ] = ACTIONS(2183),
    [anon_sym_LT] = ACTIONS(2183),
    [anon_sym_if] = ACTIONS(2181),
    [anon_sym_unless] = ACTIONS(2181),
    [anon_sym_while] = ACTIONS(2181),
    [anon_sym_until] = ACTIONS(2181),
    [anon_sym_rescue] = ACTIONS(2181),
    [anon_sym_in] = ACTIONS(2181),
    [anon_sym_do] = ACTIONS(2181),
    [anon_sym_EQ_GT] = ACTIONS(2181),
    [anon_sym_LBRACK] = ACTIONS(2181),
    [anon_sym_RBRACK] = ACTIONS(2181),
    [anon_sym_COLON_COLON2] = ACTIONS(2181),
    [anon_sym_AMP_DOT] = ACTIONS(2181),
    [anon_sym_PLUS_EQ] = ACTIONS(2181),
    [anon_sym_DASH_EQ] = ACTIONS(2181),
    [anon_sym_STAR_EQ] = ACTIONS(2181),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2181),
    [anon_sym_SLASH_EQ] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2181),
    [anon_sym_PIPE_EQ] = ACTIONS(2181),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2181),
    [anon_sym_AMP_EQ] = ACTIONS(2181),
    [anon_sym_PERCENT_EQ] = ACTIONS(2181),
    [anon_sym_GT_GT_EQ] = ACTIONS(2181),
    [anon_sym_LT_LT_EQ] = ACTIONS(2181),
    [anon_sym_CARET_EQ] = ACTIONS(2181),
    [anon_sym_QMARK] = ACTIONS(2181),
    [anon_sym_COLON2] = ACTIONS(2183),
    [anon_sym_DOT_DOT] = ACTIONS(2183),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2183),
    [anon_sym_AMP_AMP] = ACTIONS(2183),
    [anon_sym_LT_LT] = ACTIONS(2183),
    [anon_sym_GT_GT] = ACTIONS(2183),
    [anon_sym_EQ_EQ] = ACTIONS(2183),
    [anon_sym_BANG_EQ] = ACTIONS(2181),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2181),
    [anon_sym_LT_EQ_GT] = ACTIONS(2181),
    [anon_sym_EQ_TILDE] = ACTIONS(2181),
    [anon_sym_BANG_TILDE] = ACTIONS(2181),
    [anon_sym_LT_EQ] = ACTIONS(2183),
    [anon_sym_GT] = ACTIONS(2183),
    [anon_sym_GT_EQ] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2183),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_SLASH] = ACTIONS(2183),
    [anon_sym_PERCENT] = ACTIONS(2183),
    [sym_comment] = ACTIONS(87),
  },
  [1993] = {
    [sym__statements] = STATE(1988),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(1989),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(1990),
    [sym_rescue] = STATE(1991),
    [sym__body_statement] = STATE(4337),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(7109),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1994] = {
    [sym__heredoc_body_start] = ACTIONS(4285),
    [sym__binary_minus] = ACTIONS(4285),
    [sym__binary_star] = ACTIONS(4285),
    [anon_sym_LBRACE] = ACTIONS(4285),
    [anon_sym_RBRACE] = ACTIONS(4285),
    [anon_sym_RPAREN] = ACTIONS(4285),
    [anon_sym_DOT] = ACTIONS(4287),
    [anon_sym_COMMA] = ACTIONS(4285),
    [anon_sym_PIPE] = ACTIONS(4287),
    [anon_sym_SEMI] = ACTIONS(4285),
    [anon_sym_STAR_STAR] = ACTIONS(4287),
    [anon_sym_AMP] = ACTIONS(4287),
    [anon_sym_EQ] = ACTIONS(4287),
    [anon_sym_LT] = ACTIONS(4287),
    [anon_sym_if] = ACTIONS(4285),
    [anon_sym_unless] = ACTIONS(4285),
    [anon_sym_while] = ACTIONS(4285),
    [anon_sym_until] = ACTIONS(4285),
    [anon_sym_rescue] = ACTIONS(4285),
    [anon_sym_in] = ACTIONS(4285),
    [anon_sym_do] = ACTIONS(4285),
    [anon_sym_EQ_GT] = ACTIONS(4285),
    [anon_sym_LBRACK] = ACTIONS(4285),
    [anon_sym_RBRACK] = ACTIONS(4285),
    [anon_sym_COLON_COLON2] = ACTIONS(4285),
    [anon_sym_AMP_DOT] = ACTIONS(4285),
    [anon_sym_PLUS_EQ] = ACTIONS(4285),
    [anon_sym_DASH_EQ] = ACTIONS(4285),
    [anon_sym_STAR_EQ] = ACTIONS(4285),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4285),
    [anon_sym_SLASH_EQ] = ACTIONS(4285),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4285),
    [anon_sym_PIPE_EQ] = ACTIONS(4285),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4285),
    [anon_sym_AMP_EQ] = ACTIONS(4285),
    [anon_sym_PERCENT_EQ] = ACTIONS(4285),
    [anon_sym_GT_GT_EQ] = ACTIONS(4285),
    [anon_sym_LT_LT_EQ] = ACTIONS(4285),
    [anon_sym_CARET_EQ] = ACTIONS(4285),
    [anon_sym_QMARK] = ACTIONS(4285),
    [anon_sym_COLON2] = ACTIONS(4287),
    [anon_sym_DOT_DOT] = ACTIONS(4287),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4285),
    [anon_sym_and] = ACTIONS(4285),
    [anon_sym_or] = ACTIONS(4285),
    [anon_sym_PIPE_PIPE] = ACTIONS(4287),
    [anon_sym_AMP_AMP] = ACTIONS(4287),
    [anon_sym_LT_LT] = ACTIONS(4287),
    [anon_sym_GT_GT] = ACTIONS(4287),
    [anon_sym_EQ_EQ] = ACTIONS(4287),
    [anon_sym_BANG_EQ] = ACTIONS(4285),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4285),
    [anon_sym_LT_EQ_GT] = ACTIONS(4285),
    [anon_sym_EQ_TILDE] = ACTIONS(4285),
    [anon_sym_BANG_TILDE] = ACTIONS(4285),
    [anon_sym_LT_EQ] = ACTIONS(4287),
    [anon_sym_GT] = ACTIONS(4287),
    [anon_sym_GT_EQ] = ACTIONS(4285),
    [anon_sym_CARET] = ACTIONS(4287),
    [anon_sym_PLUS] = ACTIONS(4287),
    [anon_sym_SLASH] = ACTIONS(4287),
    [anon_sym_PERCENT] = ACTIONS(4287),
    [sym_comment] = ACTIONS(87),
  },
  [1995] = {
    [anon_sym_RPAREN] = ACTIONS(7111),
    [sym_comment] = ACTIONS(87),
  },
  [1996] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(3509),
    [sym__binary_star] = ACTIONS(3511),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(3513),
    [anon_sym_STAR_STAR] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(3517),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(3519),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(3521),
    [anon_sym_DOT_DOT] = ACTIONS(3523),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3525),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(3527),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_LT_LT] = ACTIONS(3529),
    [anon_sym_GT_GT] = ACTIONS(3529),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ] = ACTIONS(3531),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3531),
    [anon_sym_LT_EQ_GT] = ACTIONS(3531),
    [anon_sym_EQ_TILDE] = ACTIONS(3531),
    [anon_sym_BANG_TILDE] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3519),
    [anon_sym_GT] = ACTIONS(3519),
    [anon_sym_GT_EQ] = ACTIONS(3533),
    [anon_sym_CARET] = ACTIONS(3513),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_SLASH] = ACTIONS(3515),
    [anon_sym_PERCENT] = ACTIONS(3515),
    [sym_comment] = ACTIONS(87),
  },
  [1997] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(937),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_in] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_RBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_COLON2] = ACTIONS(937),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [1998] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4339),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_assignment] = STATE(4339),
    [sym_operator_assignment] = STATE(4339),
    [sym_conditional] = STATE(4339),
    [sym_range] = STATE(4339),
    [sym_binary] = STATE(4339),
    [sym_unary] = STATE(4339),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1952),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(3469),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1999] = {
    [sym__heredoc_body_start] = ACTIONS(2261),
    [sym__binary_minus] = ACTIONS(2261),
    [sym__binary_star] = ACTIONS(2261),
    [anon_sym_LBRACE] = ACTIONS(2261),
    [anon_sym_RBRACE] = ACTIONS(2261),
    [anon_sym_RPAREN] = ACTIONS(2261),
    [anon_sym_DOT] = ACTIONS(2263),
    [anon_sym_COMMA] = ACTIONS(2261),
    [anon_sym_PIPE] = ACTIONS(2263),
    [anon_sym_SEMI] = ACTIONS(2261),
    [anon_sym_STAR_STAR] = ACTIONS(2263),
    [anon_sym_AMP] = ACTIONS(2263),
    [anon_sym_EQ] = ACTIONS(2263),
    [anon_sym_LT] = ACTIONS(2263),
    [anon_sym_if] = ACTIONS(2261),
    [anon_sym_unless] = ACTIONS(2261),
    [anon_sym_while] = ACTIONS(2261),
    [anon_sym_until] = ACTIONS(2261),
    [anon_sym_rescue] = ACTIONS(2261),
    [anon_sym_in] = ACTIONS(2261),
    [anon_sym_do] = ACTIONS(2261),
    [anon_sym_EQ_GT] = ACTIONS(2261),
    [anon_sym_LBRACK] = ACTIONS(2261),
    [anon_sym_RBRACK] = ACTIONS(2261),
    [anon_sym_COLON_COLON2] = ACTIONS(2261),
    [anon_sym_AMP_DOT] = ACTIONS(2261),
    [anon_sym_PLUS_EQ] = ACTIONS(2261),
    [anon_sym_DASH_EQ] = ACTIONS(2261),
    [anon_sym_STAR_EQ] = ACTIONS(2261),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2261),
    [anon_sym_SLASH_EQ] = ACTIONS(2261),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2261),
    [anon_sym_PIPE_EQ] = ACTIONS(2261),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2261),
    [anon_sym_AMP_EQ] = ACTIONS(2261),
    [anon_sym_PERCENT_EQ] = ACTIONS(2261),
    [anon_sym_GT_GT_EQ] = ACTIONS(2261),
    [anon_sym_LT_LT_EQ] = ACTIONS(2261),
    [anon_sym_CARET_EQ] = ACTIONS(2261),
    [anon_sym_QMARK] = ACTIONS(2261),
    [anon_sym_COLON2] = ACTIONS(2263),
    [anon_sym_DOT_DOT] = ACTIONS(2263),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2261),
    [anon_sym_and] = ACTIONS(2261),
    [anon_sym_or] = ACTIONS(2261),
    [anon_sym_PIPE_PIPE] = ACTIONS(2263),
    [anon_sym_AMP_AMP] = ACTIONS(2263),
    [anon_sym_LT_LT] = ACTIONS(2263),
    [anon_sym_GT_GT] = ACTIONS(2263),
    [anon_sym_EQ_EQ] = ACTIONS(2263),
    [anon_sym_BANG_EQ] = ACTIONS(2261),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2261),
    [anon_sym_LT_EQ_GT] = ACTIONS(2261),
    [anon_sym_EQ_TILDE] = ACTIONS(2261),
    [anon_sym_BANG_TILDE] = ACTIONS(2261),
    [anon_sym_LT_EQ] = ACTIONS(2263),
    [anon_sym_GT] = ACTIONS(2263),
    [anon_sym_GT_EQ] = ACTIONS(2261),
    [anon_sym_CARET] = ACTIONS(2263),
    [anon_sym_PLUS] = ACTIONS(2263),
    [anon_sym_SLASH] = ACTIONS(2263),
    [anon_sym_PERCENT] = ACTIONS(2263),
    [sym_comment] = ACTIONS(87),
  },
  [2000] = {
    [sym__heredoc_body_start] = ACTIONS(2345),
    [sym__binary_minus] = ACTIONS(2345),
    [sym__binary_star] = ACTIONS(2345),
    [anon_sym_LBRACE] = ACTIONS(2345),
    [anon_sym_RBRACE] = ACTIONS(2345),
    [anon_sym_RPAREN] = ACTIONS(2345),
    [anon_sym_DOT] = ACTIONS(2347),
    [anon_sym_COMMA] = ACTIONS(2345),
    [anon_sym_PIPE] = ACTIONS(2347),
    [anon_sym_SEMI] = ACTIONS(2345),
    [anon_sym_STAR_STAR] = ACTIONS(2347),
    [anon_sym_AMP] = ACTIONS(2347),
    [anon_sym_EQ] = ACTIONS(2347),
    [anon_sym_LT] = ACTIONS(2347),
    [anon_sym_if] = ACTIONS(2345),
    [anon_sym_unless] = ACTIONS(2345),
    [anon_sym_while] = ACTIONS(2345),
    [anon_sym_until] = ACTIONS(2345),
    [anon_sym_rescue] = ACTIONS(2345),
    [anon_sym_in] = ACTIONS(2345),
    [anon_sym_do] = ACTIONS(2345),
    [anon_sym_EQ_GT] = ACTIONS(2345),
    [anon_sym_LBRACK] = ACTIONS(2345),
    [anon_sym_RBRACK] = ACTIONS(2345),
    [anon_sym_COLON_COLON2] = ACTIONS(2345),
    [anon_sym_AMP_DOT] = ACTIONS(2345),
    [anon_sym_PLUS_EQ] = ACTIONS(2345),
    [anon_sym_DASH_EQ] = ACTIONS(2345),
    [anon_sym_STAR_EQ] = ACTIONS(2345),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2345),
    [anon_sym_SLASH_EQ] = ACTIONS(2345),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2345),
    [anon_sym_PIPE_EQ] = ACTIONS(2345),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2345),
    [anon_sym_AMP_EQ] = ACTIONS(2345),
    [anon_sym_PERCENT_EQ] = ACTIONS(2345),
    [anon_sym_GT_GT_EQ] = ACTIONS(2345),
    [anon_sym_LT_LT_EQ] = ACTIONS(2345),
    [anon_sym_CARET_EQ] = ACTIONS(2345),
    [anon_sym_QMARK] = ACTIONS(2345),
    [anon_sym_COLON2] = ACTIONS(2347),
    [anon_sym_DOT_DOT] = ACTIONS(2347),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2345),
    [anon_sym_and] = ACTIONS(2345),
    [anon_sym_or] = ACTIONS(2345),
    [anon_sym_PIPE_PIPE] = ACTIONS(2347),
    [anon_sym_AMP_AMP] = ACTIONS(2347),
    [anon_sym_LT_LT] = ACTIONS(2347),
    [anon_sym_GT_GT] = ACTIONS(2347),
    [anon_sym_EQ_EQ] = ACTIONS(2347),
    [anon_sym_BANG_EQ] = ACTIONS(2345),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2345),
    [anon_sym_LT_EQ_GT] = ACTIONS(2345),
    [anon_sym_EQ_TILDE] = ACTIONS(2345),
    [anon_sym_BANG_TILDE] = ACTIONS(2345),
    [anon_sym_LT_EQ] = ACTIONS(2347),
    [anon_sym_GT] = ACTIONS(2347),
    [anon_sym_GT_EQ] = ACTIONS(2345),
    [anon_sym_CARET] = ACTIONS(2347),
    [anon_sym_PLUS] = ACTIONS(2347),
    [anon_sym_SLASH] = ACTIONS(2347),
    [anon_sym_PERCENT] = ACTIONS(2347),
    [sym_comment] = ACTIONS(87),
  },
  [2001] = {
    [anon_sym_RBRACK] = ACTIONS(7113),
    [sym_comment] = ACTIONS(87),
  },
  [2002] = {
    [sym__statements] = STATE(3428),
    [sym_begin_block] = STATE(489),
    [sym_end_block] = STATE(489),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_block_parameters] = STATE(3429),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(495),
    [aux_sym__statements_repeat1] = STATE(495),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(7115),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2445),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2003] = {
    [sym_do_block] = STATE(4342),
    [sym_block] = STATE(4342),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym_do] = ACTIONS(5713),
    [sym_comment] = ACTIONS(87),
  },
  [2004] = {
    [sym__heredoc_body_start] = ACTIONS(2485),
    [sym__binary_minus] = ACTIONS(2485),
    [sym__binary_star] = ACTIONS(2485),
    [anon_sym_LBRACE] = ACTIONS(2485),
    [anon_sym_RBRACE] = ACTIONS(2485),
    [anon_sym_RPAREN] = ACTIONS(2485),
    [anon_sym_DOT] = ACTIONS(2487),
    [anon_sym_COMMA] = ACTIONS(2485),
    [anon_sym_PIPE] = ACTIONS(2487),
    [anon_sym_SEMI] = ACTIONS(2485),
    [anon_sym_STAR_STAR] = ACTIONS(2487),
    [anon_sym_AMP] = ACTIONS(2487),
    [anon_sym_EQ] = ACTIONS(2487),
    [anon_sym_LT] = ACTIONS(2487),
    [anon_sym_if] = ACTIONS(2485),
    [anon_sym_unless] = ACTIONS(2485),
    [anon_sym_while] = ACTIONS(2485),
    [anon_sym_until] = ACTIONS(2485),
    [anon_sym_rescue] = ACTIONS(2485),
    [anon_sym_in] = ACTIONS(2485),
    [anon_sym_do] = ACTIONS(2485),
    [anon_sym_EQ_GT] = ACTIONS(2485),
    [anon_sym_LBRACK] = ACTIONS(2485),
    [anon_sym_RBRACK] = ACTIONS(2485),
    [anon_sym_COLON_COLON2] = ACTIONS(2485),
    [anon_sym_AMP_DOT] = ACTIONS(2485),
    [anon_sym_PLUS_EQ] = ACTIONS(2485),
    [anon_sym_DASH_EQ] = ACTIONS(2485),
    [anon_sym_STAR_EQ] = ACTIONS(2485),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2485),
    [anon_sym_SLASH_EQ] = ACTIONS(2485),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2485),
    [anon_sym_PIPE_EQ] = ACTIONS(2485),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2485),
    [anon_sym_AMP_EQ] = ACTIONS(2485),
    [anon_sym_PERCENT_EQ] = ACTIONS(2485),
    [anon_sym_GT_GT_EQ] = ACTIONS(2485),
    [anon_sym_LT_LT_EQ] = ACTIONS(2485),
    [anon_sym_CARET_EQ] = ACTIONS(2485),
    [anon_sym_QMARK] = ACTIONS(2485),
    [anon_sym_COLON2] = ACTIONS(2487),
    [anon_sym_DOT_DOT] = ACTIONS(2487),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2485),
    [anon_sym_and] = ACTIONS(2485),
    [anon_sym_or] = ACTIONS(2485),
    [anon_sym_PIPE_PIPE] = ACTIONS(2487),
    [anon_sym_AMP_AMP] = ACTIONS(2487),
    [anon_sym_LT_LT] = ACTIONS(2487),
    [anon_sym_GT_GT] = ACTIONS(2487),
    [anon_sym_EQ_EQ] = ACTIONS(2487),
    [anon_sym_BANG_EQ] = ACTIONS(2485),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2485),
    [anon_sym_LT_EQ_GT] = ACTIONS(2485),
    [anon_sym_EQ_TILDE] = ACTIONS(2485),
    [anon_sym_BANG_TILDE] = ACTIONS(2485),
    [anon_sym_LT_EQ] = ACTIONS(2487),
    [anon_sym_GT] = ACTIONS(2487),
    [anon_sym_GT_EQ] = ACTIONS(2485),
    [anon_sym_CARET] = ACTIONS(2487),
    [anon_sym_PLUS] = ACTIONS(2487),
    [anon_sym_SLASH] = ACTIONS(2487),
    [anon_sym_PERCENT] = ACTIONS(2487),
    [sym_comment] = ACTIONS(87),
  },
  [2005] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4343),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_assignment] = STATE(4343),
    [sym_operator_assignment] = STATE(4343),
    [sym_conditional] = STATE(4343),
    [sym_range] = STATE(4343),
    [sym_binary] = STATE(4343),
    [sym_unary] = STATE(4343),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1952),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(3469),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2006] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4344),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_assignment] = STATE(4344),
    [sym_operator_assignment] = STATE(4344),
    [sym_conditional] = STATE(4344),
    [sym_range] = STATE(4344),
    [sym_binary] = STATE(4344),
    [sym_unary] = STATE(4344),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1952),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(3469),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2007] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4345),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_assignment] = STATE(4345),
    [sym_operator_assignment] = STATE(4345),
    [sym_conditional] = STATE(4345),
    [sym_range] = STATE(4345),
    [sym_binary] = STATE(4345),
    [sym_unary] = STATE(4345),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1952),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(3469),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2008] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4346),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_assignment] = STATE(4346),
    [sym_operator_assignment] = STATE(4346),
    [sym_conditional] = STATE(4346),
    [sym_range] = STATE(4346),
    [sym_binary] = STATE(4346),
    [sym_unary] = STATE(4346),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1952),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(3469),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2009] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4347),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_assignment] = STATE(4347),
    [sym_operator_assignment] = STATE(4347),
    [sym_conditional] = STATE(4347),
    [sym_range] = STATE(4347),
    [sym_binary] = STATE(4347),
    [sym_unary] = STATE(4347),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1952),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(3469),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2010] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(4348),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(4348),
    [sym_operator_assignment] = STATE(4348),
    [sym_conditional] = STATE(4348),
    [sym_range] = STATE(4348),
    [sym_binary] = STATE(4348),
    [sym_unary] = STATE(4348),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2011] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4349),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_assignment] = STATE(4349),
    [sym_operator_assignment] = STATE(4349),
    [sym_conditional] = STATE(4349),
    [sym_range] = STATE(4349),
    [sym_binary] = STATE(4349),
    [sym_unary] = STATE(4349),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1952),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(3469),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2012] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4350),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_assignment] = STATE(4350),
    [sym_operator_assignment] = STATE(4350),
    [sym_conditional] = STATE(4350),
    [sym_range] = STATE(4350),
    [sym_binary] = STATE(4350),
    [sym_unary] = STATE(4350),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1952),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(3469),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2013] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4351),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_assignment] = STATE(4351),
    [sym_operator_assignment] = STATE(4351),
    [sym_conditional] = STATE(4351),
    [sym_range] = STATE(4351),
    [sym_binary] = STATE(4351),
    [sym_unary] = STATE(4351),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1952),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(3469),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2014] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4352),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_assignment] = STATE(4352),
    [sym_operator_assignment] = STATE(4352),
    [sym_conditional] = STATE(4352),
    [sym_range] = STATE(4352),
    [sym_binary] = STATE(4352),
    [sym_unary] = STATE(4352),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1952),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(3469),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2015] = {
    [sym__statements] = STATE(3428),
    [sym_begin_block] = STATE(489),
    [sym_end_block] = STATE(489),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_block_parameters] = STATE(3429),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1516),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1519),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1519),
    [sym_hash_splat_argument] = STATE(116),
    [sym_assignment] = STATE(1516),
    [sym_operator_assignment] = STATE(1516),
    [sym_conditional] = STATE(1516),
    [sym_range] = STATE(1516),
    [sym_binary] = STATE(1516),
    [sym_unary] = STATE(1516),
    [sym_left_assignment_list] = STATE(1518),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1519),
    [sym__variable] = STATE(1517),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1519),
    [sym_false] = STATE(1519),
    [sym_nil] = STATE(1519),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1520),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(1959),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym__hash_items] = STATE(1960),
    [sym_pair] = STATE(122),
    [sym_lambda] = STATE(214),
    [sym_empty_statement] = STATE(495),
    [aux_sym__statements_repeat1] = STATE(495),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2629),
    [sym__identifier_hash_key] = ACTIONS(157),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(7115),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_PIPE] = ACTIONS(2445),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2633),
    [anon_sym_yield] = ACTIONS(2635),
    [anon_sym_break] = ACTIONS(2637),
    [anon_sym_next] = ACTIONS(2639),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2641),
    [anon_sym_defined_QMARK] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2647),
    [anon_sym_TILDE] = ACTIONS(2647),
    [sym_constant] = ACTIONS(2649),
    [sym_identifier] = ACTIONS(2649),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2016] = {
    [sym_do_block] = STATE(3447),
    [sym_block] = STATE(3447),
    [sym__heredoc_body_start] = ACTIONS(2717),
    [sym__binary_minus] = ACTIONS(2717),
    [sym__binary_star] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym_RBRACE] = ACTIONS(2717),
    [anon_sym_RPAREN] = ACTIONS(2717),
    [anon_sym_DOT] = ACTIONS(2721),
    [anon_sym_COMMA] = ACTIONS(2717),
    [anon_sym_PIPE] = ACTIONS(2721),
    [anon_sym_SEMI] = ACTIONS(2717),
    [anon_sym_STAR_STAR] = ACTIONS(2721),
    [anon_sym_AMP] = ACTIONS(2721),
    [anon_sym_EQ] = ACTIONS(2721),
    [anon_sym_LT] = ACTIONS(2721),
    [anon_sym_if] = ACTIONS(2717),
    [anon_sym_unless] = ACTIONS(2717),
    [anon_sym_while] = ACTIONS(2717),
    [anon_sym_until] = ACTIONS(2717),
    [anon_sym_rescue] = ACTIONS(2717),
    [anon_sym_in] = ACTIONS(2717),
    [anon_sym_do] = ACTIONS(2717),
    [anon_sym_EQ_GT] = ACTIONS(2717),
    [anon_sym_LBRACK] = ACTIONS(2717),
    [anon_sym_RBRACK] = ACTIONS(2717),
    [anon_sym_COLON_COLON2] = ACTIONS(2717),
    [anon_sym_AMP_DOT] = ACTIONS(2717),
    [anon_sym_PLUS_EQ] = ACTIONS(2717),
    [anon_sym_DASH_EQ] = ACTIONS(2717),
    [anon_sym_STAR_EQ] = ACTIONS(2717),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2717),
    [anon_sym_SLASH_EQ] = ACTIONS(2717),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2717),
    [anon_sym_PIPE_EQ] = ACTIONS(2717),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2717),
    [anon_sym_AMP_EQ] = ACTIONS(2717),
    [anon_sym_PERCENT_EQ] = ACTIONS(2717),
    [anon_sym_GT_GT_EQ] = ACTIONS(2717),
    [anon_sym_LT_LT_EQ] = ACTIONS(2717),
    [anon_sym_CARET_EQ] = ACTIONS(2717),
    [anon_sym_QMARK] = ACTIONS(2717),
    [anon_sym_COLON2] = ACTIONS(2721),
    [anon_sym_DOT_DOT] = ACTIONS(2721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2717),
    [anon_sym_and] = ACTIONS(2717),
    [anon_sym_or] = ACTIONS(2717),
    [anon_sym_PIPE_PIPE] = ACTIONS(2721),
    [anon_sym_AMP_AMP] = ACTIONS(2721),
    [anon_sym_LT_LT] = ACTIONS(2721),
    [anon_sym_GT_GT] = ACTIONS(2721),
    [anon_sym_EQ_EQ] = ACTIONS(2721),
    [anon_sym_BANG_EQ] = ACTIONS(2717),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2717),
    [anon_sym_LT_EQ_GT] = ACTIONS(2717),
    [anon_sym_EQ_TILDE] = ACTIONS(2717),
    [anon_sym_BANG_TILDE] = ACTIONS(2717),
    [anon_sym_LT_EQ] = ACTIONS(2721),
    [anon_sym_GT] = ACTIONS(2721),
    [anon_sym_GT_EQ] = ACTIONS(2717),
    [anon_sym_CARET] = ACTIONS(2721),
    [anon_sym_PLUS] = ACTIONS(2721),
    [anon_sym_SLASH] = ACTIONS(2721),
    [anon_sym_PERCENT] = ACTIONS(2721),
    [sym_comment] = ACTIONS(87),
  },
  [2017] = {
    [sym__statements] = STATE(1957),
    [sym_begin_block] = STATE(489),
    [sym_end_block] = STATE(489),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_block_parameters] = STATE(1958),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(495),
    [aux_sym__statements_repeat1] = STATE(495),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(7117),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2445),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2018] = {
    [sym__binary_minus] = ACTIONS(6155),
    [sym__binary_star] = ACTIONS(6155),
    [anon_sym_DOT] = ACTIONS(6157),
    [anon_sym_COMMA] = ACTIONS(6155),
    [anon_sym_PIPE] = ACTIONS(6157),
    [anon_sym_STAR_STAR] = ACTIONS(6157),
    [anon_sym_AMP] = ACTIONS(6157),
    [anon_sym_EQ] = ACTIONS(6157),
    [anon_sym_LT] = ACTIONS(6157),
    [anon_sym_EQ_GT] = ACTIONS(6155),
    [anon_sym_LBRACK] = ACTIONS(6155),
    [anon_sym_COLON_COLON2] = ACTIONS(6155),
    [anon_sym_AMP_DOT] = ACTIONS(6155),
    [anon_sym_PLUS_EQ] = ACTIONS(6155),
    [anon_sym_DASH_EQ] = ACTIONS(6155),
    [anon_sym_STAR_EQ] = ACTIONS(6155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6155),
    [anon_sym_SLASH_EQ] = ACTIONS(6155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6155),
    [anon_sym_PIPE_EQ] = ACTIONS(6155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6155),
    [anon_sym_AMP_EQ] = ACTIONS(6155),
    [anon_sym_PERCENT_EQ] = ACTIONS(6155),
    [anon_sym_GT_GT_EQ] = ACTIONS(6155),
    [anon_sym_LT_LT_EQ] = ACTIONS(6155),
    [anon_sym_CARET_EQ] = ACTIONS(6155),
    [anon_sym_QMARK] = ACTIONS(6155),
    [anon_sym_DOT_DOT] = ACTIONS(6157),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6155),
    [anon_sym_and] = ACTIONS(6155),
    [anon_sym_or] = ACTIONS(6155),
    [anon_sym_PIPE_PIPE] = ACTIONS(6157),
    [anon_sym_AMP_AMP] = ACTIONS(6157),
    [anon_sym_LT_LT] = ACTIONS(6157),
    [anon_sym_GT_GT] = ACTIONS(6157),
    [anon_sym_EQ_EQ] = ACTIONS(6157),
    [anon_sym_BANG_EQ] = ACTIONS(6155),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6155),
    [anon_sym_LT_EQ_GT] = ACTIONS(6155),
    [anon_sym_EQ_TILDE] = ACTIONS(6155),
    [anon_sym_BANG_TILDE] = ACTIONS(6155),
    [anon_sym_LT_EQ] = ACTIONS(6157),
    [anon_sym_GT] = ACTIONS(6157),
    [anon_sym_GT_EQ] = ACTIONS(6155),
    [anon_sym_CARET] = ACTIONS(6157),
    [anon_sym_PLUS] = ACTIONS(6157),
    [anon_sym_SLASH] = ACTIONS(6157),
    [anon_sym_PERCENT] = ACTIONS(6157),
    [sym_comment] = ACTIONS(87),
  },
  [2019] = {
    [sym_interpolation] = STATE(4355),
    [aux_sym_heredoc_body_repeat1] = STATE(4355),
    [sym__heredoc_content] = ACTIONS(7119),
    [sym_heredoc_end] = ACTIONS(7121),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(7119),
  },
  [2020] = {
    [sym_heredoc_body] = STATE(4356),
    [aux_sym_call_repeat1] = STATE(4356),
    [sym__heredoc_body_start] = ACTIONS(3543),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [2021] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(644),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym__argument] = STATE(4357),
    [sym_splat_argument] = STATE(4357),
    [sym_hash_splat_argument] = STATE(4357),
    [sym_block_argument] = STATE(4357),
    [sym_assignment] = STATE(644),
    [sym_operator_assignment] = STATE(644),
    [sym_conditional] = STATE(644),
    [sym_range] = STATE(644),
    [sym_binary] = STATE(644),
    [sym_unary] = STATE(644),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(653),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_heredoc_body] = STATE(4358),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(4357),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(1155),
    [sym__splat_star] = ACTIONS(1157),
    [sym__unary_minus] = ACTIONS(1159),
    [sym__identifier_hash_key] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(3469),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1209),
    [sym_identifier] = ACTIONS(1209),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2022] = {
    [sym_heredoc_body] = STATE(4359),
    [aux_sym_call_repeat1] = STATE(4359),
    [aux_sym_argument_list_repeat1] = STATE(4360),
    [sym__heredoc_body_start] = ACTIONS(3543),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(3545),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [2023] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4361),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_splat_argument] = STATE(4363),
    [sym_assignment] = STATE(4361),
    [sym_operator_assignment] = STATE(4361),
    [sym_conditional] = STATE(4361),
    [sym_range] = STATE(4361),
    [sym_binary] = STATE(4361),
    [sym_unary] = STATE(4361),
    [sym_right_assignment_list] = STATE(4362),
    [sym__arg_or_splat_arg] = STATE(4363),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1952),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__splat_star] = ACTIONS(1157),
    [sym__unary_minus] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(3469),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2024] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4364),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_assignment] = STATE(4364),
    [sym_operator_assignment] = STATE(4364),
    [sym_conditional] = STATE(4364),
    [sym_range] = STATE(4364),
    [sym_binary] = STATE(4364),
    [sym_unary] = STATE(4364),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1952),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(3469),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2025] = {
    [sym_string] = STATE(4365),
    [aux_sym_chained_string_repeat1] = STATE(4365),
    [sym__string_start] = ACTIONS(1141),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_STAR_STAR] = ACTIONS(2755),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_EQ] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_EQ_GT] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_PLUS_EQ] = ACTIONS(2753),
    [anon_sym_DASH_EQ] = ACTIONS(2753),
    [anon_sym_STAR_EQ] = ACTIONS(2753),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2753),
    [anon_sym_SLASH_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2753),
    [anon_sym_AMP_EQ] = ACTIONS(2753),
    [anon_sym_PERCENT_EQ] = ACTIONS(2753),
    [anon_sym_GT_GT_EQ] = ACTIONS(2753),
    [anon_sym_LT_LT_EQ] = ACTIONS(2753),
    [anon_sym_CARET_EQ] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2755),
    [anon_sym_AMP_AMP] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2755),
    [anon_sym_GT_GT] = ACTIONS(2755),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_SLASH] = ACTIONS(2755),
    [anon_sym_PERCENT] = ACTIONS(2755),
    [sym_comment] = ACTIONS(87),
  },
  [2026] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(4366),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(2038),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(2038),
    [sym_assignment] = STATE(4366),
    [sym_operator_assignment] = STATE(4366),
    [sym_conditional] = STATE(4366),
    [sym_range] = STATE(4366),
    [sym_binary] = STATE(4366),
    [sym_unary] = STATE(4366),
    [sym_left_assignment_list] = STATE(2037),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2038),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(2038),
    [sym_false] = STATE(2038),
    [sym_nil] = STATE(2038),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(2039),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(3557),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3559),
    [anon_sym_yield] = ACTIONS(3561),
    [anon_sym_break] = ACTIONS(3563),
    [anon_sym_next] = ACTIONS(3565),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3567),
    [anon_sym_defined_QMARK] = ACTIONS(3569),
    [anon_sym_not] = ACTIONS(3571),
    [anon_sym_BANG] = ACTIONS(3573),
    [anon_sym_TILDE] = ACTIONS(3573),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2027] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(4367),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(2038),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(2038),
    [sym_assignment] = STATE(4367),
    [sym_operator_assignment] = STATE(4367),
    [sym_conditional] = STATE(4367),
    [sym_range] = STATE(4367),
    [sym_binary] = STATE(4367),
    [sym_unary] = STATE(4367),
    [sym_left_assignment_list] = STATE(2037),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2038),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(2038),
    [sym_false] = STATE(2038),
    [sym_nil] = STATE(2038),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(2039),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(3557),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3559),
    [anon_sym_yield] = ACTIONS(3561),
    [anon_sym_break] = ACTIONS(3563),
    [anon_sym_next] = ACTIONS(3565),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3567),
    [anon_sym_defined_QMARK] = ACTIONS(3569),
    [anon_sym_not] = ACTIONS(3571),
    [anon_sym_BANG] = ACTIONS(3573),
    [anon_sym_TILDE] = ACTIONS(3573),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2028] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(561),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(567),
    [sym_scope_resolution] = STATE(562),
    [sym_call] = STATE(562),
    [sym_method_call] = STATE(567),
    [sym_argument_list] = STATE(563),
    [sym__argument_list_with_parens] = STATE(1867),
    [sym__argument] = STATE(1868),
    [sym_splat_argument] = STATE(1868),
    [sym_hash_splat_argument] = STATE(1868),
    [sym_block_argument] = STATE(1868),
    [sym_assignment] = STATE(561),
    [sym_operator_assignment] = STATE(561),
    [sym_conditional] = STATE(561),
    [sym_range] = STATE(561),
    [sym_binary] = STATE(561),
    [sym_unary] = STATE(561),
    [sym_left_assignment_list] = STATE(566),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(567),
    [sym__variable] = STATE(562),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(567),
    [sym_false] = STATE(567),
    [sym_nil] = STATE(567),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(568),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(1868),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1047),
    [sym__unary_minus] = ACTIONS(1049),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(1075),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2029] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(561),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(567),
    [sym_scope_resolution] = STATE(562),
    [sym_call] = STATE(562),
    [sym_method_call] = STATE(567),
    [sym_argument_list] = STATE(569),
    [sym__argument_list_with_parens] = STATE(1867),
    [sym__argument] = STATE(1868),
    [sym_splat_argument] = STATE(1868),
    [sym_hash_splat_argument] = STATE(1868),
    [sym_block_argument] = STATE(1868),
    [sym_assignment] = STATE(561),
    [sym_operator_assignment] = STATE(561),
    [sym_conditional] = STATE(561),
    [sym_range] = STATE(561),
    [sym_binary] = STATE(561),
    [sym_unary] = STATE(561),
    [sym_left_assignment_list] = STATE(566),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(567),
    [sym__variable] = STATE(562),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(567),
    [sym_false] = STATE(567),
    [sym_nil] = STATE(567),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(568),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(1868),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1047),
    [sym__unary_minus] = ACTIONS(1049),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(1075),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2030] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(561),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(567),
    [sym_scope_resolution] = STATE(562),
    [sym_call] = STATE(562),
    [sym_method_call] = STATE(567),
    [sym_argument_list] = STATE(570),
    [sym__argument_list_with_parens] = STATE(1867),
    [sym__argument] = STATE(1868),
    [sym_splat_argument] = STATE(1868),
    [sym_hash_splat_argument] = STATE(1868),
    [sym_block_argument] = STATE(1868),
    [sym_assignment] = STATE(561),
    [sym_operator_assignment] = STATE(561),
    [sym_conditional] = STATE(561),
    [sym_range] = STATE(561),
    [sym_binary] = STATE(561),
    [sym_unary] = STATE(561),
    [sym_left_assignment_list] = STATE(566),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(567),
    [sym__variable] = STATE(562),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(567),
    [sym_false] = STATE(567),
    [sym_nil] = STATE(567),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(568),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(1868),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1047),
    [sym__unary_minus] = ACTIONS(1049),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(1075),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2031] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(561),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(567),
    [sym_scope_resolution] = STATE(562),
    [sym_call] = STATE(562),
    [sym_method_call] = STATE(567),
    [sym_argument_list] = STATE(571),
    [sym__argument_list_with_parens] = STATE(1867),
    [sym__argument] = STATE(1868),
    [sym_splat_argument] = STATE(1868),
    [sym_hash_splat_argument] = STATE(1868),
    [sym_block_argument] = STATE(1868),
    [sym_assignment] = STATE(561),
    [sym_operator_assignment] = STATE(561),
    [sym_conditional] = STATE(561),
    [sym_range] = STATE(561),
    [sym_binary] = STATE(561),
    [sym_unary] = STATE(561),
    [sym_left_assignment_list] = STATE(566),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(567),
    [sym__variable] = STATE(562),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(567),
    [sym_false] = STATE(567),
    [sym_nil] = STATE(567),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(568),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(1868),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1047),
    [sym__unary_minus] = ACTIONS(1049),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(1075),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2032] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(4368),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(2038),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(2038),
    [sym_assignment] = STATE(4368),
    [sym_operator_assignment] = STATE(4368),
    [sym_conditional] = STATE(4368),
    [sym_range] = STATE(4368),
    [sym_binary] = STATE(4368),
    [sym_unary] = STATE(4368),
    [sym_left_assignment_list] = STATE(2037),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2038),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(2038),
    [sym_false] = STATE(2038),
    [sym_nil] = STATE(2038),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(2039),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(3557),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3559),
    [anon_sym_yield] = ACTIONS(3561),
    [anon_sym_break] = ACTIONS(3563),
    [anon_sym_next] = ACTIONS(3565),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3567),
    [anon_sym_defined_QMARK] = ACTIONS(3569),
    [anon_sym_not] = ACTIONS(3571),
    [anon_sym_BANG] = ACTIONS(3573),
    [anon_sym_TILDE] = ACTIONS(3573),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2033] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(586),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(2038),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(2038),
    [sym_assignment] = STATE(586),
    [sym_operator_assignment] = STATE(586),
    [sym_conditional] = STATE(586),
    [sym_range] = STATE(586),
    [sym_binary] = STATE(586),
    [sym_unary] = STATE(586),
    [sym_left_assignment_list] = STATE(2037),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2038),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(2038),
    [sym_false] = STATE(2038),
    [sym_nil] = STATE(2038),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(2039),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(3557),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3559),
    [anon_sym_yield] = ACTIONS(3561),
    [anon_sym_break] = ACTIONS(3563),
    [anon_sym_next] = ACTIONS(3565),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3567),
    [anon_sym_defined_QMARK] = ACTIONS(3569),
    [anon_sym_not] = ACTIONS(3571),
    [anon_sym_BANG] = ACTIONS(3573),
    [anon_sym_TILDE] = ACTIONS(3573),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2034] = {
    [sym__binary_minus] = ACTIONS(7125),
    [sym__binary_star] = ACTIONS(7127),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(7129),
    [anon_sym_STAR_STAR] = ACTIONS(7127),
    [anon_sym_AMP] = ACTIONS(7131),
    [anon_sym_LT] = ACTIONS(7133),
    [anon_sym_EQ_GT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(7135),
    [anon_sym_DOT_DOT] = ACTIONS(7137),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7139),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7141),
    [anon_sym_AMP_AMP] = ACTIONS(7141),
    [anon_sym_LT_LT] = ACTIONS(7143),
    [anon_sym_GT_GT] = ACTIONS(7143),
    [anon_sym_EQ_EQ] = ACTIONS(7145),
    [anon_sym_BANG_EQ] = ACTIONS(7141),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7141),
    [anon_sym_LT_EQ_GT] = ACTIONS(7141),
    [anon_sym_EQ_TILDE] = ACTIONS(7141),
    [anon_sym_BANG_TILDE] = ACTIONS(7141),
    [anon_sym_LT_EQ] = ACTIONS(7133),
    [anon_sym_GT] = ACTIONS(7133),
    [anon_sym_GT_EQ] = ACTIONS(7147),
    [anon_sym_CARET] = ACTIONS(7149),
    [anon_sym_PLUS] = ACTIONS(7125),
    [anon_sym_SLASH] = ACTIONS(7127),
    [anon_sym_PERCENT] = ACTIONS(7127),
    [sym_comment] = ACTIONS(87),
  },
  [2035] = {
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_RBRACE] = ACTIONS(6191),
    [anon_sym_RPAREN] = ACTIONS(6191),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_COLON2] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [2036] = {
    [aux_sym_exceptions_repeat1] = STATE(4380),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_COMMA] = ACTIONS(7151),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [2037] = {
    [anon_sym_EQ] = ACTIONS(7153),
    [sym_comment] = ACTIONS(87),
  },
  [2038] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(7155),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(7157),
    [anon_sym_DASH_EQ] = ACTIONS(7157),
    [anon_sym_STAR_EQ] = ACTIONS(7157),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7157),
    [anon_sym_SLASH_EQ] = ACTIONS(7157),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7157),
    [anon_sym_PIPE_EQ] = ACTIONS(7157),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7157),
    [anon_sym_AMP_EQ] = ACTIONS(7157),
    [anon_sym_PERCENT_EQ] = ACTIONS(7157),
    [anon_sym_GT_GT_EQ] = ACTIONS(7157),
    [anon_sym_LT_LT_EQ] = ACTIONS(7157),
    [anon_sym_CARET_EQ] = ACTIONS(7157),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2039] = {
    [sym_string] = STATE(4383),
    [aux_sym_chained_string_repeat1] = STATE(4383),
    [sym__string_start] = ACTIONS(139),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2040] = {
    [sym__binary_minus] = ACTIONS(1103),
    [sym__binary_star] = ACTIONS(1105),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_STAR_STAR] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(1111),
    [anon_sym_EQ_GT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(1113),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1117),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(1121),
    [anon_sym_AMP_AMP] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1125),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1121),
    [anon_sym_LT_EQ_GT] = ACTIONS(1121),
    [anon_sym_EQ_TILDE] = ACTIONS(1121),
    [anon_sym_BANG_TILDE] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1111),
    [anon_sym_GT] = ACTIONS(1111),
    [anon_sym_GT_EQ] = ACTIONS(1127),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1103),
    [anon_sym_SLASH] = ACTIONS(1105),
    [anon_sym_PERCENT] = ACTIONS(1105),
    [sym_comment] = ACTIONS(87),
  },
  [2041] = {
    [sym_string] = STATE(2041),
    [aux_sym_chained_string_repeat1] = STATE(2041),
    [sym__string_start] = ACTIONS(7159),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_EQ_GT] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [2042] = {
    [sym__line_break] = ACTIONS(7162),
    [sym__heredoc_body_start] = ACTIONS(7162),
    [sym__binary_minus] = ACTIONS(7162),
    [sym__binary_star] = ACTIONS(7162),
    [ts_builtin_sym_end] = ACTIONS(7162),
    [anon_sym___END__] = ACTIONS(7162),
    [anon_sym_LBRACE] = ACTIONS(7162),
    [anon_sym_RBRACE] = ACTIONS(7162),
    [anon_sym_RPAREN] = ACTIONS(7162),
    [anon_sym_DOT] = ACTIONS(7164),
    [anon_sym_COMMA] = ACTIONS(7162),
    [anon_sym_PIPE] = ACTIONS(7164),
    [anon_sym_SEMI] = ACTIONS(7162),
    [anon_sym_STAR_STAR] = ACTIONS(7162),
    [anon_sym_AMP] = ACTIONS(7164),
    [anon_sym_LT] = ACTIONS(7164),
    [anon_sym_end] = ACTIONS(7162),
    [anon_sym_if] = ACTIONS(7162),
    [anon_sym_unless] = ACTIONS(7162),
    [anon_sym_while] = ACTIONS(7162),
    [anon_sym_until] = ACTIONS(7162),
    [anon_sym_rescue] = ACTIONS(7162),
    [anon_sym_do] = ACTIONS(7162),
    [anon_sym_when] = ACTIONS(7162),
    [anon_sym_elsif] = ACTIONS(7162),
    [anon_sym_else] = ACTIONS(7162),
    [anon_sym_then] = ACTIONS(7162),
    [anon_sym_ensure] = ACTIONS(7162),
    [anon_sym_EQ_GT] = ACTIONS(7162),
    [anon_sym_LBRACK] = ACTIONS(7162),
    [anon_sym_COLON_COLON2] = ACTIONS(7162),
    [anon_sym_AMP_DOT] = ACTIONS(7162),
    [anon_sym_QMARK] = ACTIONS(7162),
    [anon_sym_DOT_DOT] = ACTIONS(7164),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7162),
    [anon_sym_and] = ACTIONS(7162),
    [anon_sym_or] = ACTIONS(7162),
    [anon_sym_PIPE_PIPE] = ACTIONS(7162),
    [anon_sym_AMP_AMP] = ACTIONS(7162),
    [anon_sym_LT_LT] = ACTIONS(7162),
    [anon_sym_GT_GT] = ACTIONS(7162),
    [anon_sym_EQ_EQ] = ACTIONS(7164),
    [anon_sym_BANG_EQ] = ACTIONS(7162),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7162),
    [anon_sym_LT_EQ_GT] = ACTIONS(7162),
    [anon_sym_EQ_TILDE] = ACTIONS(7162),
    [anon_sym_BANG_TILDE] = ACTIONS(7162),
    [anon_sym_LT_EQ] = ACTIONS(7164),
    [anon_sym_GT] = ACTIONS(7164),
    [anon_sym_GT_EQ] = ACTIONS(7162),
    [anon_sym_CARET] = ACTIONS(7162),
    [anon_sym_PLUS] = ACTIONS(7162),
    [anon_sym_SLASH] = ACTIONS(7162),
    [anon_sym_PERCENT] = ACTIONS(7162),
    [sym_comment] = ACTIONS(87),
  },
  [2043] = {
    [sym_interpolation] = STATE(4385),
    [aux_sym_heredoc_body_repeat1] = STATE(4385),
    [sym__heredoc_content] = ACTIONS(7166),
    [sym_heredoc_end] = ACTIONS(7168),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(7166),
  },
  [2044] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(113),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(118),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(118),
    [sym_hash_splat_argument] = STATE(116),
    [sym_assignment] = STATE(113),
    [sym_operator_assignment] = STATE(113),
    [sym_conditional] = STATE(113),
    [sym_range] = STATE(113),
    [sym_binary] = STATE(113),
    [sym_unary] = STATE(113),
    [sym_left_assignment_list] = STATE(117),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(118),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(118),
    [sym_false] = STATE(118),
    [sym_nil] = STATE(118),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(119),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym__hash_items] = STATE(4386),
    [sym_pair] = STATE(122),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym__heredoc_body_start] = ACTIONS(7170),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [sym__identifier_hash_key] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_RBRACE] = ACTIONS(7170),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(209),
    [sym_identifier] = ACTIONS(209),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2045] = {
    [sym__heredoc_body_start] = ACTIONS(7170),
    [anon_sym_RBRACE] = ACTIONS(7170),
    [sym_comment] = ACTIONS(87),
  },
  [2046] = {
    [sym__line_break] = ACTIONS(7172),
    [sym__heredoc_body_start] = ACTIONS(7172),
    [ts_builtin_sym_end] = ACTIONS(7172),
    [anon_sym___END__] = ACTIONS(7172),
    [anon_sym_RBRACE] = ACTIONS(7172),
    [anon_sym_RPAREN] = ACTIONS(7172),
    [anon_sym_SEMI] = ACTIONS(7172),
    [anon_sym_end] = ACTIONS(7172),
    [anon_sym_if] = ACTIONS(7172),
    [anon_sym_unless] = ACTIONS(7172),
    [anon_sym_while] = ACTIONS(7172),
    [anon_sym_until] = ACTIONS(7172),
    [anon_sym_rescue] = ACTIONS(7172),
    [anon_sym_when] = ACTIONS(7172),
    [anon_sym_elsif] = ACTIONS(7172),
    [anon_sym_else] = ACTIONS(7172),
    [anon_sym_then] = ACTIONS(7172),
    [anon_sym_ensure] = ACTIONS(7172),
    [sym_comment] = ACTIONS(87),
  },
  [2047] = {
    [sym__line_break] = ACTIONS(3042),
    [sym__heredoc_body_start] = ACTIONS(3042),
    [ts_builtin_sym_end] = ACTIONS(3042),
    [anon_sym___END__] = ACTIONS(3044),
    [anon_sym_RBRACE] = ACTIONS(3042),
    [anon_sym_LPAREN] = ACTIONS(3042),
    [anon_sym_RPAREN] = ACTIONS(3042),
    [anon_sym_COMMA] = ACTIONS(3042),
    [anon_sym_SEMI] = ACTIONS(3042),
    [anon_sym_STAR] = ACTIONS(3044),
    [anon_sym_STAR_STAR] = ACTIONS(3042),
    [anon_sym_AMP] = ACTIONS(3042),
    [anon_sym_end] = ACTIONS(3044),
    [anon_sym_if] = ACTIONS(3044),
    [anon_sym_unless] = ACTIONS(3044),
    [anon_sym_while] = ACTIONS(3044),
    [anon_sym_until] = ACTIONS(3044),
    [anon_sym_rescue] = ACTIONS(3044),
    [anon_sym_when] = ACTIONS(3044),
    [anon_sym_elsif] = ACTIONS(3044),
    [anon_sym_else] = ACTIONS(3044),
    [anon_sym_then] = ACTIONS(3044),
    [anon_sym_ensure] = ACTIONS(3044),
    [sym_identifier] = ACTIONS(3044),
    [sym_comment] = ACTIONS(87),
  },
  [2048] = {
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(3611),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [2049] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(4390),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4392),
    [sym_scope_resolution] = STATE(2478),
    [sym_call] = STATE(2478),
    [sym_method_call] = STATE(4392),
    [sym_assignment] = STATE(4390),
    [sym_operator_assignment] = STATE(4390),
    [sym_conditional] = STATE(4390),
    [sym_range] = STATE(4390),
    [sym_binary] = STATE(4390),
    [sym_unary] = STATE(4390),
    [sym_left_assignment_list] = STATE(4391),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4392),
    [sym__variable] = STATE(2478),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4392),
    [sym_false] = STATE(4392),
    [sym_nil] = STATE(4392),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2481),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7174),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4263),
    [anon_sym_yield] = ACTIONS(4265),
    [anon_sym_break] = ACTIONS(4267),
    [anon_sym_next] = ACTIONS(4269),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7176),
    [anon_sym_defined_QMARK] = ACTIONS(7178),
    [anon_sym_not] = ACTIONS(7180),
    [anon_sym_BANG] = ACTIONS(7182),
    [anon_sym_TILDE] = ACTIONS(7182),
    [sym_constant] = ACTIONS(4279),
    [sym_identifier] = ACTIONS(4279),
    [sym_instance_variable] = ACTIONS(4281),
    [sym_class_variable] = ACTIONS(4281),
    [sym_global_variable] = ACTIONS(4281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4279),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4279),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2050] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(4393),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4392),
    [sym_scope_resolution] = STATE(2478),
    [sym_call] = STATE(2478),
    [sym_method_call] = STATE(4392),
    [sym_assignment] = STATE(4393),
    [sym_operator_assignment] = STATE(4393),
    [sym_conditional] = STATE(4393),
    [sym_range] = STATE(4393),
    [sym_binary] = STATE(4393),
    [sym_unary] = STATE(4393),
    [sym_left_assignment_list] = STATE(4391),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4392),
    [sym__variable] = STATE(2478),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4392),
    [sym_false] = STATE(4392),
    [sym_nil] = STATE(4392),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2481),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7174),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4263),
    [anon_sym_yield] = ACTIONS(4265),
    [anon_sym_break] = ACTIONS(4267),
    [anon_sym_next] = ACTIONS(4269),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7176),
    [anon_sym_defined_QMARK] = ACTIONS(7178),
    [anon_sym_not] = ACTIONS(7180),
    [anon_sym_BANG] = ACTIONS(7182),
    [anon_sym_TILDE] = ACTIONS(7182),
    [sym_constant] = ACTIONS(4279),
    [sym_identifier] = ACTIONS(4279),
    [sym_instance_variable] = ACTIONS(4281),
    [sym_class_variable] = ACTIONS(4281),
    [sym_global_variable] = ACTIONS(4281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4279),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4279),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2051] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4394),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2061),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(2061),
    [sym_assignment] = STATE(4394),
    [sym_operator_assignment] = STATE(4394),
    [sym_conditional] = STATE(4394),
    [sym_range] = STATE(4394),
    [sym_binary] = STATE(4394),
    [sym_unary] = STATE(4394),
    [sym_left_assignment_list] = STATE(2060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2061),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2061),
    [sym_false] = STATE(2061),
    [sym_nil] = STATE(2061),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2484),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7184),
    [anon_sym_defined_QMARK] = ACTIONS(3599),
    [anon_sym_not] = ACTIONS(3601),
    [anon_sym_BANG] = ACTIONS(3605),
    [anon_sym_TILDE] = ACTIONS(3605),
    [sym_constant] = ACTIONS(1621),
    [sym_identifier] = ACTIONS(1621),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2052] = {
    [anon_sym_COLON] = ACTIONS(7186),
    [sym_comment] = ACTIONS(87),
  },
  [2053] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(4396),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4392),
    [sym_scope_resolution] = STATE(2478),
    [sym_call] = STATE(2478),
    [sym_method_call] = STATE(4392),
    [sym_assignment] = STATE(4396),
    [sym_operator_assignment] = STATE(4396),
    [sym_conditional] = STATE(4396),
    [sym_range] = STATE(4396),
    [sym_binary] = STATE(4396),
    [sym_unary] = STATE(4396),
    [sym_left_assignment_list] = STATE(4391),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4392),
    [sym__variable] = STATE(2478),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4392),
    [sym_false] = STATE(4392),
    [sym_nil] = STATE(4392),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2481),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7174),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4263),
    [anon_sym_yield] = ACTIONS(4265),
    [anon_sym_break] = ACTIONS(4267),
    [anon_sym_next] = ACTIONS(4269),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7176),
    [anon_sym_defined_QMARK] = ACTIONS(7178),
    [anon_sym_not] = ACTIONS(7180),
    [anon_sym_BANG] = ACTIONS(7182),
    [anon_sym_TILDE] = ACTIONS(7182),
    [sym_constant] = ACTIONS(4279),
    [sym_identifier] = ACTIONS(4279),
    [sym_instance_variable] = ACTIONS(4281),
    [sym_class_variable] = ACTIONS(4281),
    [sym_global_variable] = ACTIONS(4281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4279),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4279),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2054] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4397),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2061),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(2061),
    [sym_assignment] = STATE(4397),
    [sym_operator_assignment] = STATE(4397),
    [sym_conditional] = STATE(4397),
    [sym_range] = STATE(4397),
    [sym_binary] = STATE(4397),
    [sym_unary] = STATE(4397),
    [sym_left_assignment_list] = STATE(2060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2061),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2061),
    [sym_false] = STATE(2061),
    [sym_nil] = STATE(2061),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2484),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7184),
    [anon_sym_defined_QMARK] = ACTIONS(3599),
    [anon_sym_not] = ACTIONS(3601),
    [anon_sym_BANG] = ACTIONS(3605),
    [anon_sym_TILDE] = ACTIONS(3605),
    [sym_constant] = ACTIONS(1621),
    [sym_identifier] = ACTIONS(1621),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2055] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(1872),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2061),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(2061),
    [sym_assignment] = STATE(1872),
    [sym_operator_assignment] = STATE(1872),
    [sym_conditional] = STATE(1872),
    [sym_range] = STATE(1872),
    [sym_binary] = STATE(1872),
    [sym_unary] = STATE(1872),
    [sym_left_assignment_list] = STATE(2060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2061),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2061),
    [sym_false] = STATE(2061),
    [sym_nil] = STATE(2061),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2484),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7184),
    [anon_sym_defined_QMARK] = ACTIONS(3599),
    [anon_sym_not] = ACTIONS(3601),
    [anon_sym_BANG] = ACTIONS(3605),
    [anon_sym_TILDE] = ACTIONS(3605),
    [sym_constant] = ACTIONS(1621),
    [sym_identifier] = ACTIONS(1621),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2056] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(7188),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [2057] = {
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(7190),
    [sym__binary_star] = ACTIONS(7192),
    [anon_sym_RPAREN] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(7194),
    [anon_sym_STAR_STAR] = ACTIONS(7192),
    [anon_sym_AMP] = ACTIONS(7196),
    [anon_sym_LT] = ACTIONS(7198),
    [anon_sym_EQ_GT] = ACTIONS(7186),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(7200),
    [anon_sym_DOT_DOT] = ACTIONS(7202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7204),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(7206),
    [anon_sym_AMP_AMP] = ACTIONS(7206),
    [anon_sym_LT_LT] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7208),
    [anon_sym_EQ_EQ] = ACTIONS(7210),
    [anon_sym_BANG_EQ] = ACTIONS(7206),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7206),
    [anon_sym_LT_EQ_GT] = ACTIONS(7206),
    [anon_sym_EQ_TILDE] = ACTIONS(7206),
    [anon_sym_BANG_TILDE] = ACTIONS(7206),
    [anon_sym_LT_EQ] = ACTIONS(7198),
    [anon_sym_GT] = ACTIONS(7198),
    [anon_sym_GT_EQ] = ACTIONS(7212),
    [anon_sym_CARET] = ACTIONS(7214),
    [anon_sym_PLUS] = ACTIONS(7190),
    [anon_sym_SLASH] = ACTIONS(7192),
    [anon_sym_PERCENT] = ACTIONS(7192),
    [sym_comment] = ACTIONS(87),
  },
  [2058] = {
    [sym_heredoc_body] = STATE(4409),
    [aux_sym_call_repeat1] = STATE(4409),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [2059] = {
    [sym_heredoc_body] = STATE(4409),
    [aux_sym_call_repeat1] = STATE(4409),
    [aux_sym_argument_list_repeat1] = STATE(4411),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(7216),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [2060] = {
    [anon_sym_EQ] = ACTIONS(7218),
    [sym_comment] = ACTIONS(87),
  },
  [2061] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(7220),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(7222),
    [anon_sym_DASH_EQ] = ACTIONS(7222),
    [anon_sym_STAR_EQ] = ACTIONS(7222),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7222),
    [anon_sym_SLASH_EQ] = ACTIONS(7222),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7222),
    [anon_sym_PIPE_EQ] = ACTIONS(7222),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7222),
    [anon_sym_AMP_EQ] = ACTIONS(7222),
    [anon_sym_PERCENT_EQ] = ACTIONS(7222),
    [anon_sym_GT_GT_EQ] = ACTIONS(7222),
    [anon_sym_LT_LT_EQ] = ACTIONS(7222),
    [anon_sym_CARET_EQ] = ACTIONS(7222),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2062] = {
    [sym_string] = STATE(2522),
    [aux_sym_chained_string_repeat1] = STATE(2522),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(7224),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2063] = {
    [sym__binary_minus] = ACTIONS(3609),
    [sym__binary_star] = ACTIONS(3611),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(3615),
    [anon_sym_STAR_STAR] = ACTIONS(3611),
    [anon_sym_AMP] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3619),
    [anon_sym_QMARK] = ACTIONS(3621),
    [anon_sym_DOT_DOT] = ACTIONS(3623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3625),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(3629),
    [anon_sym_AMP_AMP] = ACTIONS(3629),
    [anon_sym_LT_LT] = ACTIONS(3631),
    [anon_sym_GT_GT] = ACTIONS(3631),
    [anon_sym_EQ_EQ] = ACTIONS(3633),
    [anon_sym_BANG_EQ] = ACTIONS(3629),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3629),
    [anon_sym_LT_EQ_GT] = ACTIONS(3629),
    [anon_sym_EQ_TILDE] = ACTIONS(3629),
    [anon_sym_BANG_TILDE] = ACTIONS(3629),
    [anon_sym_LT_EQ] = ACTIONS(3619),
    [anon_sym_GT] = ACTIONS(3619),
    [anon_sym_GT_EQ] = ACTIONS(3635),
    [anon_sym_CARET] = ACTIONS(3637),
    [anon_sym_PLUS] = ACTIONS(3609),
    [anon_sym_SLASH] = ACTIONS(3611),
    [anon_sym_PERCENT] = ACTIONS(3611),
    [sym_comment] = ACTIONS(87),
  },
  [2064] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(4414),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(674),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(674),
    [sym_assignment] = STATE(4414),
    [sym_operator_assignment] = STATE(4414),
    [sym_conditional] = STATE(4414),
    [sym_range] = STATE(4414),
    [sym_binary] = STATE(4414),
    [sym_unary] = STATE(4414),
    [sym_left_assignment_list] = STATE(673),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(674),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(674),
    [sym_false] = STATE(674),
    [sym_nil] = STATE(674),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(675),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1243),
    [anon_sym_yield] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1247),
    [anon_sym_next] = ACTIONS(1249),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2065] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(4415),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(674),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(674),
    [sym_assignment] = STATE(4415),
    [sym_operator_assignment] = STATE(4415),
    [sym_conditional] = STATE(4415),
    [sym_range] = STATE(4415),
    [sym_binary] = STATE(4415),
    [sym_unary] = STATE(4415),
    [sym_left_assignment_list] = STATE(673),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(674),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(674),
    [sym_false] = STATE(674),
    [sym_nil] = STATE(674),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(675),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1243),
    [anon_sym_yield] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1247),
    [anon_sym_next] = ACTIONS(1249),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2066] = {
    [anon_sym_DOT] = ACTIONS(7226),
    [anon_sym_COLON_COLON] = ACTIONS(7226),
    [sym_comment] = ACTIONS(87),
  },
  [2067] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(4417),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(674),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(674),
    [sym_assignment] = STATE(4417),
    [sym_operator_assignment] = STATE(4417),
    [sym_conditional] = STATE(4417),
    [sym_range] = STATE(4417),
    [sym_binary] = STATE(4417),
    [sym_unary] = STATE(4417),
    [sym_left_assignment_list] = STATE(673),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(674),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(674),
    [sym_false] = STATE(674),
    [sym_nil] = STATE(674),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(675),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1243),
    [anon_sym_yield] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1247),
    [anon_sym_next] = ACTIONS(1249),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2068] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(4418),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(674),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(674),
    [sym_assignment] = STATE(4418),
    [sym_operator_assignment] = STATE(4418),
    [sym_conditional] = STATE(4418),
    [sym_range] = STATE(4418),
    [sym_binary] = STATE(4418),
    [sym_unary] = STATE(4418),
    [sym_left_assignment_list] = STATE(673),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(674),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(674),
    [sym_false] = STATE(674),
    [sym_nil] = STATE(674),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(675),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1243),
    [anon_sym_yield] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1247),
    [anon_sym_next] = ACTIONS(1249),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2069] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(4419),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(674),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(674),
    [sym_assignment] = STATE(4419),
    [sym_operator_assignment] = STATE(4419),
    [sym_conditional] = STATE(4419),
    [sym_range] = STATE(4419),
    [sym_binary] = STATE(4419),
    [sym_unary] = STATE(4419),
    [sym_left_assignment_list] = STATE(673),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(674),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(674),
    [sym_false] = STATE(674),
    [sym_nil] = STATE(674),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(675),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1243),
    [anon_sym_yield] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1247),
    [anon_sym_next] = ACTIONS(1249),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2070] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(4420),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(4420),
    [sym_operator_assignment] = STATE(4420),
    [sym_conditional] = STATE(4420),
    [sym_range] = STATE(4420),
    [sym_binary] = STATE(4420),
    [sym_unary] = STATE(4420),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2071] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(4421),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(674),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(674),
    [sym_assignment] = STATE(4421),
    [sym_operator_assignment] = STATE(4421),
    [sym_conditional] = STATE(4421),
    [sym_range] = STATE(4421),
    [sym_binary] = STATE(4421),
    [sym_unary] = STATE(4421),
    [sym_left_assignment_list] = STATE(673),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(674),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(674),
    [sym_false] = STATE(674),
    [sym_nil] = STATE(674),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(675),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1243),
    [anon_sym_yield] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1247),
    [anon_sym_next] = ACTIONS(1249),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2072] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(4422),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(674),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(674),
    [sym_assignment] = STATE(4422),
    [sym_operator_assignment] = STATE(4422),
    [sym_conditional] = STATE(4422),
    [sym_range] = STATE(4422),
    [sym_binary] = STATE(4422),
    [sym_unary] = STATE(4422),
    [sym_left_assignment_list] = STATE(673),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(674),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(674),
    [sym_false] = STATE(674),
    [sym_nil] = STATE(674),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(675),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1243),
    [anon_sym_yield] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1247),
    [anon_sym_next] = ACTIONS(1249),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2073] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(4423),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(674),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(674),
    [sym_assignment] = STATE(4423),
    [sym_operator_assignment] = STATE(4423),
    [sym_conditional] = STATE(4423),
    [sym_range] = STATE(4423),
    [sym_binary] = STATE(4423),
    [sym_unary] = STATE(4423),
    [sym_left_assignment_list] = STATE(673),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(674),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(674),
    [sym_false] = STATE(674),
    [sym_nil] = STATE(674),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(675),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1243),
    [anon_sym_yield] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1247),
    [anon_sym_next] = ACTIONS(1249),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2074] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(4424),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(674),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(674),
    [sym_assignment] = STATE(4424),
    [sym_operator_assignment] = STATE(4424),
    [sym_conditional] = STATE(4424),
    [sym_range] = STATE(4424),
    [sym_binary] = STATE(4424),
    [sym_unary] = STATE(4424),
    [sym_left_assignment_list] = STATE(673),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(674),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(674),
    [sym_false] = STATE(674),
    [sym_nil] = STATE(674),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(675),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1243),
    [anon_sym_yield] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1247),
    [anon_sym_next] = ACTIONS(1249),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2075] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(4432),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(4435),
    [sym_scope_resolution] = STATE(4433),
    [sym_call] = STATE(4433),
    [sym_method_call] = STATE(4435),
    [sym_assignment] = STATE(4432),
    [sym_operator_assignment] = STATE(4432),
    [sym_conditional] = STATE(4432),
    [sym_range] = STATE(4432),
    [sym_binary] = STATE(4432),
    [sym_unary] = STATE(4432),
    [sym_left_assignment_list] = STATE(4434),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4435),
    [sym__variable] = STATE(4433),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(4435),
    [sym_false] = STATE(4435),
    [sym_nil] = STATE(4435),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(4436),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(7228),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(7230),
    [anon_sym_yield] = ACTIONS(7232),
    [anon_sym_break] = ACTIONS(7234),
    [anon_sym_next] = ACTIONS(7236),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(7238),
    [anon_sym_defined_QMARK] = ACTIONS(7240),
    [anon_sym_not] = ACTIONS(7242),
    [anon_sym_BANG] = ACTIONS(7244),
    [anon_sym_TILDE] = ACTIONS(7244),
    [sym_constant] = ACTIONS(7246),
    [sym_identifier] = ACTIONS(7246),
    [sym_instance_variable] = ACTIONS(7248),
    [sym_class_variable] = ACTIONS(7248),
    [sym_global_variable] = ACTIONS(7248),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(7246),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(7246),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [2076] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(4437),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(4435),
    [sym_scope_resolution] = STATE(4433),
    [sym_call] = STATE(4433),
    [sym_method_call] = STATE(4435),
    [sym_assignment] = STATE(4437),
    [sym_operator_assignment] = STATE(4437),
    [sym_conditional] = STATE(4437),
    [sym_range] = STATE(4437),
    [sym_binary] = STATE(4437),
    [sym_unary] = STATE(4437),
    [sym_left_assignment_list] = STATE(4434),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4435),
    [sym__variable] = STATE(4433),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(4435),
    [sym_false] = STATE(4435),
    [sym_nil] = STATE(4435),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(4436),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(7228),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(7230),
    [anon_sym_yield] = ACTIONS(7232),
    [anon_sym_break] = ACTIONS(7234),
    [anon_sym_next] = ACTIONS(7236),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(7238),
    [anon_sym_defined_QMARK] = ACTIONS(7240),
    [anon_sym_not] = ACTIONS(7242),
    [anon_sym_BANG] = ACTIONS(7244),
    [anon_sym_TILDE] = ACTIONS(7244),
    [sym_constant] = ACTIONS(7246),
    [sym_identifier] = ACTIONS(7246),
    [sym_instance_variable] = ACTIONS(7248),
    [sym_class_variable] = ACTIONS(7248),
    [sym_global_variable] = ACTIONS(7248),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(7246),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(7246),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [2077] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4438),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2092),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2092),
    [sym_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(4438),
    [sym_range] = STATE(4438),
    [sym_binary] = STATE(4438),
    [sym_unary] = STATE(4438),
    [sym_left_assignment_list] = STATE(2091),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2092),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2092),
    [sym_false] = STATE(2092),
    [sym_nil] = STATE(2092),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4439),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3643),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3647),
    [anon_sym_yield] = ACTIONS(3649),
    [anon_sym_break] = ACTIONS(3651),
    [anon_sym_next] = ACTIONS(3653),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(7250),
    [anon_sym_defined_QMARK] = ACTIONS(3655),
    [anon_sym_not] = ACTIONS(3657),
    [anon_sym_BANG] = ACTIONS(3661),
    [anon_sym_TILDE] = ACTIONS(3661),
    [sym_constant] = ACTIONS(3667),
    [sym_identifier] = ACTIONS(3667),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2078] = {
    [anon_sym_COLON] = ACTIONS(7252),
    [sym_comment] = ACTIONS(87),
  },
  [2079] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(4441),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(4435),
    [sym_scope_resolution] = STATE(4433),
    [sym_call] = STATE(4433),
    [sym_method_call] = STATE(4435),
    [sym_assignment] = STATE(4441),
    [sym_operator_assignment] = STATE(4441),
    [sym_conditional] = STATE(4441),
    [sym_range] = STATE(4441),
    [sym_binary] = STATE(4441),
    [sym_unary] = STATE(4441),
    [sym_left_assignment_list] = STATE(4434),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4435),
    [sym__variable] = STATE(4433),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(4435),
    [sym_false] = STATE(4435),
    [sym_nil] = STATE(4435),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(4436),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(7228),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(7230),
    [anon_sym_yield] = ACTIONS(7232),
    [anon_sym_break] = ACTIONS(7234),
    [anon_sym_next] = ACTIONS(7236),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(7238),
    [anon_sym_defined_QMARK] = ACTIONS(7240),
    [anon_sym_not] = ACTIONS(7242),
    [anon_sym_BANG] = ACTIONS(7244),
    [anon_sym_TILDE] = ACTIONS(7244),
    [sym_constant] = ACTIONS(7246),
    [sym_identifier] = ACTIONS(7246),
    [sym_instance_variable] = ACTIONS(7248),
    [sym_class_variable] = ACTIONS(7248),
    [sym_global_variable] = ACTIONS(7248),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(7246),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(7246),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [2080] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(2513),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2092),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2092),
    [sym_argument_list] = STATE(1973),
    [sym__argument_list_with_parens] = STATE(2514),
    [sym__argument] = STATE(2515),
    [sym_splat_argument] = STATE(2515),
    [sym_hash_splat_argument] = STATE(2515),
    [sym_block_argument] = STATE(2515),
    [sym_assignment] = STATE(2513),
    [sym_operator_assignment] = STATE(2513),
    [sym_conditional] = STATE(2513),
    [sym_range] = STATE(2513),
    [sym_binary] = STATE(2513),
    [sym_unary] = STATE(2513),
    [sym_left_assignment_list] = STATE(2091),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2092),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2092),
    [sym_false] = STATE(2092),
    [sym_nil] = STATE(2092),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(2516),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(2515),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(4327),
    [sym__splat_star] = ACTIONS(4329),
    [sym__unary_minus] = ACTIONS(3643),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(4331),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_RPAREN] = ACTIONS(365),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3647),
    [anon_sym_yield] = ACTIONS(3649),
    [anon_sym_break] = ACTIONS(3651),
    [anon_sym_next] = ACTIONS(3653),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(365),
    [anon_sym_DASH_EQ] = ACTIONS(365),
    [anon_sym_STAR_EQ] = ACTIONS(365),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(365),
    [anon_sym_SLASH_EQ] = ACTIONS(365),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(365),
    [anon_sym_PIPE_EQ] = ACTIONS(365),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(365),
    [anon_sym_AMP_EQ] = ACTIONS(365),
    [anon_sym_PERCENT_EQ] = ACTIONS(365),
    [anon_sym_GT_GT_EQ] = ACTIONS(365),
    [anon_sym_LT_LT_EQ] = ACTIONS(365),
    [anon_sym_CARET_EQ] = ACTIONS(365),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_PERCENT] = ACTIONS(377),
    [anon_sym_defined_QMARK] = ACTIONS(3655),
    [anon_sym_not] = ACTIONS(3657),
    [anon_sym_BANG] = ACTIONS(3659),
    [anon_sym_TILDE] = ACTIONS(3661),
    [sym_constant] = ACTIONS(4333),
    [sym_identifier] = ACTIONS(4333),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2081] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(2513),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2092),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2092),
    [sym_argument_list] = STATE(1974),
    [sym__argument_list_with_parens] = STATE(2514),
    [sym__argument] = STATE(2515),
    [sym_splat_argument] = STATE(2515),
    [sym_hash_splat_argument] = STATE(2515),
    [sym_block_argument] = STATE(2515),
    [sym_assignment] = STATE(2513),
    [sym_operator_assignment] = STATE(2513),
    [sym_conditional] = STATE(2513),
    [sym_range] = STATE(2513),
    [sym_binary] = STATE(2513),
    [sym_unary] = STATE(2513),
    [sym_left_assignment_list] = STATE(2091),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2092),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2092),
    [sym_false] = STATE(2092),
    [sym_nil] = STATE(2092),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(2516),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(2515),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(4327),
    [sym__splat_star] = ACTIONS(4329),
    [sym__unary_minus] = ACTIONS(3643),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(4331),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_RPAREN] = ACTIONS(417),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_EQ] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3647),
    [anon_sym_yield] = ACTIONS(3649),
    [anon_sym_break] = ACTIONS(3651),
    [anon_sym_next] = ACTIONS(3653),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(417),
    [anon_sym_DASH_EQ] = ACTIONS(417),
    [anon_sym_STAR_EQ] = ACTIONS(417),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(417),
    [anon_sym_SLASH_EQ] = ACTIONS(417),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(417),
    [anon_sym_PIPE_EQ] = ACTIONS(417),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(417),
    [anon_sym_AMP_EQ] = ACTIONS(417),
    [anon_sym_PERCENT_EQ] = ACTIONS(417),
    [anon_sym_GT_GT_EQ] = ACTIONS(417),
    [anon_sym_LT_LT_EQ] = ACTIONS(417),
    [anon_sym_CARET_EQ] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(3655),
    [anon_sym_not] = ACTIONS(3657),
    [anon_sym_BANG] = ACTIONS(3659),
    [anon_sym_TILDE] = ACTIONS(3661),
    [sym_constant] = ACTIONS(4333),
    [sym_identifier] = ACTIONS(4333),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2082] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(2513),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2092),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2092),
    [sym_argument_list] = STATE(1975),
    [sym__argument_list_with_parens] = STATE(2514),
    [sym__argument] = STATE(2515),
    [sym_splat_argument] = STATE(2515),
    [sym_hash_splat_argument] = STATE(2515),
    [sym_block_argument] = STATE(2515),
    [sym_assignment] = STATE(2513),
    [sym_operator_assignment] = STATE(2513),
    [sym_conditional] = STATE(2513),
    [sym_range] = STATE(2513),
    [sym_binary] = STATE(2513),
    [sym_unary] = STATE(2513),
    [sym_left_assignment_list] = STATE(2091),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2092),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2092),
    [sym_false] = STATE(2092),
    [sym_nil] = STATE(2092),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(2516),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(2515),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(4327),
    [sym__splat_star] = ACTIONS(4329),
    [sym__unary_minus] = ACTIONS(3643),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(4331),
    [anon_sym_LBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_RPAREN] = ACTIONS(421),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_EQ] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3647),
    [anon_sym_yield] = ACTIONS(3649),
    [anon_sym_break] = ACTIONS(3651),
    [anon_sym_next] = ACTIONS(3653),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(421),
    [anon_sym_DASH_EQ] = ACTIONS(421),
    [anon_sym_STAR_EQ] = ACTIONS(421),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(421),
    [anon_sym_SLASH_EQ] = ACTIONS(421),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(421),
    [anon_sym_PIPE_EQ] = ACTIONS(421),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(421),
    [anon_sym_AMP_EQ] = ACTIONS(421),
    [anon_sym_PERCENT_EQ] = ACTIONS(421),
    [anon_sym_GT_GT_EQ] = ACTIONS(421),
    [anon_sym_LT_LT_EQ] = ACTIONS(421),
    [anon_sym_CARET_EQ] = ACTIONS(421),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(3655),
    [anon_sym_not] = ACTIONS(3657),
    [anon_sym_BANG] = ACTIONS(3659),
    [anon_sym_TILDE] = ACTIONS(3661),
    [sym_constant] = ACTIONS(4333),
    [sym_identifier] = ACTIONS(4333),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2083] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(2513),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2092),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2092),
    [sym_argument_list] = STATE(1976),
    [sym__argument_list_with_parens] = STATE(2514),
    [sym__argument] = STATE(2515),
    [sym_splat_argument] = STATE(2515),
    [sym_hash_splat_argument] = STATE(2515),
    [sym_block_argument] = STATE(2515),
    [sym_assignment] = STATE(2513),
    [sym_operator_assignment] = STATE(2513),
    [sym_conditional] = STATE(2513),
    [sym_range] = STATE(2513),
    [sym_binary] = STATE(2513),
    [sym_unary] = STATE(2513),
    [sym_left_assignment_list] = STATE(2091),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2092),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2092),
    [sym_false] = STATE(2092),
    [sym_nil] = STATE(2092),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(2516),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(2515),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(4327),
    [sym__splat_star] = ACTIONS(4329),
    [sym__unary_minus] = ACTIONS(3643),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(4331),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_RPAREN] = ACTIONS(425),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(427),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3647),
    [anon_sym_yield] = ACTIONS(3649),
    [anon_sym_break] = ACTIONS(3651),
    [anon_sym_next] = ACTIONS(3653),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(425),
    [anon_sym_DASH_EQ] = ACTIONS(425),
    [anon_sym_STAR_EQ] = ACTIONS(425),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(425),
    [anon_sym_SLASH_EQ] = ACTIONS(425),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(425),
    [anon_sym_PIPE_EQ] = ACTIONS(425),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(425),
    [anon_sym_AMP_EQ] = ACTIONS(425),
    [anon_sym_PERCENT_EQ] = ACTIONS(425),
    [anon_sym_GT_GT_EQ] = ACTIONS(425),
    [anon_sym_LT_LT_EQ] = ACTIONS(425),
    [anon_sym_CARET_EQ] = ACTIONS(425),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(3655),
    [anon_sym_not] = ACTIONS(3657),
    [anon_sym_BANG] = ACTIONS(3659),
    [anon_sym_TILDE] = ACTIONS(3661),
    [sym_constant] = ACTIONS(4333),
    [sym_identifier] = ACTIONS(4333),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2084] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4442),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2092),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2092),
    [sym_assignment] = STATE(4442),
    [sym_operator_assignment] = STATE(4442),
    [sym_conditional] = STATE(4442),
    [sym_range] = STATE(4442),
    [sym_binary] = STATE(4442),
    [sym_unary] = STATE(4442),
    [sym_left_assignment_list] = STATE(2091),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2092),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2092),
    [sym_false] = STATE(2092),
    [sym_nil] = STATE(2092),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4439),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3643),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3647),
    [anon_sym_yield] = ACTIONS(3649),
    [anon_sym_break] = ACTIONS(3651),
    [anon_sym_next] = ACTIONS(3653),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(7250),
    [anon_sym_defined_QMARK] = ACTIONS(3655),
    [anon_sym_not] = ACTIONS(3657),
    [anon_sym_BANG] = ACTIONS(3661),
    [anon_sym_TILDE] = ACTIONS(3661),
    [sym_constant] = ACTIONS(3667),
    [sym_identifier] = ACTIONS(3667),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2085] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1997),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2092),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2092),
    [sym_assignment] = STATE(1997),
    [sym_operator_assignment] = STATE(1997),
    [sym_conditional] = STATE(1997),
    [sym_range] = STATE(1997),
    [sym_binary] = STATE(1997),
    [sym_unary] = STATE(1997),
    [sym_left_assignment_list] = STATE(2091),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2092),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2092),
    [sym_false] = STATE(2092),
    [sym_nil] = STATE(2092),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4439),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3643),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3647),
    [anon_sym_yield] = ACTIONS(3649),
    [anon_sym_break] = ACTIONS(3651),
    [anon_sym_next] = ACTIONS(3653),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(7250),
    [anon_sym_defined_QMARK] = ACTIONS(3655),
    [anon_sym_not] = ACTIONS(3657),
    [anon_sym_BANG] = ACTIONS(3661),
    [anon_sym_TILDE] = ACTIONS(3661),
    [sym_constant] = ACTIONS(3667),
    [sym_identifier] = ACTIONS(3667),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2086] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(7254),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [2087] = {
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(7256),
    [sym__binary_star] = ACTIONS(7258),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_RPAREN] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(7260),
    [anon_sym_STAR_STAR] = ACTIONS(7262),
    [anon_sym_AMP] = ACTIONS(7264),
    [anon_sym_EQ] = ACTIONS(1631),
    [anon_sym_LT] = ACTIONS(7266),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(7252),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_PLUS_EQ] = ACTIONS(1625),
    [anon_sym_DASH_EQ] = ACTIONS(1625),
    [anon_sym_STAR_EQ] = ACTIONS(1625),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1625),
    [anon_sym_SLASH_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1625),
    [anon_sym_AMP_EQ] = ACTIONS(1625),
    [anon_sym_PERCENT_EQ] = ACTIONS(1625),
    [anon_sym_GT_GT_EQ] = ACTIONS(1625),
    [anon_sym_LT_LT_EQ] = ACTIONS(1625),
    [anon_sym_CARET_EQ] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(7268),
    [anon_sym_DOT_DOT] = ACTIONS(7270),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7272),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(7274),
    [anon_sym_AMP_AMP] = ACTIONS(7274),
    [anon_sym_LT_LT] = ACTIONS(7276),
    [anon_sym_GT_GT] = ACTIONS(7276),
    [anon_sym_EQ_EQ] = ACTIONS(7274),
    [anon_sym_BANG_EQ] = ACTIONS(7278),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7278),
    [anon_sym_LT_EQ_GT] = ACTIONS(7278),
    [anon_sym_EQ_TILDE] = ACTIONS(7278),
    [anon_sym_BANG_TILDE] = ACTIONS(7278),
    [anon_sym_LT_EQ] = ACTIONS(7266),
    [anon_sym_GT] = ACTIONS(7266),
    [anon_sym_GT_EQ] = ACTIONS(7280),
    [anon_sym_CARET] = ACTIONS(7260),
    [anon_sym_PLUS] = ACTIONS(7282),
    [anon_sym_SLASH] = ACTIONS(7262),
    [anon_sym_PERCENT] = ACTIONS(7262),
    [sym_comment] = ACTIONS(87),
  },
  [2088] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(2513),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2092),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2092),
    [sym_argument_list] = STATE(2016),
    [sym__argument_list_with_parens] = STATE(2514),
    [sym__argument] = STATE(2515),
    [sym_splat_argument] = STATE(2515),
    [sym_hash_splat_argument] = STATE(2515),
    [sym_block_argument] = STATE(2515),
    [sym_do_block] = STATE(1382),
    [sym_block] = STATE(1382),
    [sym_assignment] = STATE(2513),
    [sym_operator_assignment] = STATE(2513),
    [sym_conditional] = STATE(2513),
    [sym_range] = STATE(2513),
    [sym_binary] = STATE(2513),
    [sym_unary] = STATE(2513),
    [sym_left_assignment_list] = STATE(2091),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2092),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2092),
    [sym_false] = STATE(2092),
    [sym_nil] = STATE(2092),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(2516),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(2515),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(4327),
    [sym__splat_star] = ACTIONS(4329),
    [sym__unary_minus] = ACTIONS(3643),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(4331),
    [anon_sym_LBRACE] = ACTIONS(3537),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3647),
    [anon_sym_yield] = ACTIONS(3649),
    [anon_sym_break] = ACTIONS(3651),
    [anon_sym_next] = ACTIONS(3653),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(769),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(3655),
    [anon_sym_not] = ACTIONS(3657),
    [anon_sym_BANG] = ACTIONS(3659),
    [anon_sym_TILDE] = ACTIONS(3661),
    [sym_constant] = ACTIONS(4333),
    [sym_identifier] = ACTIONS(4333),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2089] = {
    [sym_heredoc_body] = STATE(4454),
    [aux_sym_call_repeat1] = STATE(4454),
    [sym__heredoc_body_start] = ACTIONS(6569),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [2090] = {
    [sym_heredoc_body] = STATE(4454),
    [aux_sym_call_repeat1] = STATE(4454),
    [aux_sym_argument_list_repeat1] = STATE(4456),
    [sym__heredoc_body_start] = ACTIONS(6569),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(7284),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [2091] = {
    [anon_sym_EQ] = ACTIONS(7286),
    [sym_comment] = ACTIONS(87),
  },
  [2092] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(7288),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(7290),
    [anon_sym_DASH_EQ] = ACTIONS(7290),
    [anon_sym_STAR_EQ] = ACTIONS(7290),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7290),
    [anon_sym_SLASH_EQ] = ACTIONS(7290),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7290),
    [anon_sym_PIPE_EQ] = ACTIONS(7290),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7290),
    [anon_sym_AMP_EQ] = ACTIONS(7290),
    [anon_sym_PERCENT_EQ] = ACTIONS(7290),
    [anon_sym_GT_GT_EQ] = ACTIONS(7290),
    [anon_sym_LT_LT_EQ] = ACTIONS(7290),
    [anon_sym_CARET_EQ] = ACTIONS(7290),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2093] = {
    [sym_string] = STATE(4459),
    [aux_sym_chained_string_repeat1] = STATE(4459),
    [sym__string_start] = ACTIONS(1141),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(7292),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2094] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(4468),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(4471),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(4471),
    [sym_splat_argument] = STATE(4469),
    [sym_assignment] = STATE(4468),
    [sym_operator_assignment] = STATE(4468),
    [sym_conditional] = STATE(4468),
    [sym_range] = STATE(4468),
    [sym_binary] = STATE(4468),
    [sym_unary] = STATE(4468),
    [sym_right_assignment_list] = STATE(2035),
    [sym__arg_or_splat_arg] = STATE(4469),
    [sym_left_assignment_list] = STATE(4470),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4471),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(4471),
    [sym_false] = STATE(4471),
    [sym_nil] = STATE(4471),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(4472),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__splat_star] = ACTIONS(7294),
    [sym__unary_minus] = ACTIONS(7296),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7298),
    [anon_sym_yield] = ACTIONS(7300),
    [anon_sym_break] = ACTIONS(7302),
    [anon_sym_next] = ACTIONS(7304),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7306),
    [anon_sym_defined_QMARK] = ACTIONS(7308),
    [anon_sym_not] = ACTIONS(7310),
    [anon_sym_BANG] = ACTIONS(7312),
    [anon_sym_TILDE] = ACTIONS(7312),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2095] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(4473),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(674),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(674),
    [sym_assignment] = STATE(4473),
    [sym_operator_assignment] = STATE(4473),
    [sym_conditional] = STATE(4473),
    [sym_range] = STATE(4473),
    [sym_binary] = STATE(4473),
    [sym_unary] = STATE(4473),
    [sym_left_assignment_list] = STATE(673),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(674),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(674),
    [sym_false] = STATE(674),
    [sym_nil] = STATE(674),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(675),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1243),
    [anon_sym_yield] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1247),
    [anon_sym_next] = ACTIONS(1249),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2096] = {
    [sym_string] = STATE(4474),
    [aux_sym_chained_string_repeat1] = STATE(4474),
    [sym__string_start] = ACTIONS(139),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_RPAREN] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [2097] = {
    [sym__line_break] = ACTIONS(7314),
    [sym__heredoc_body_start] = ACTIONS(7314),
    [sym__binary_minus] = ACTIONS(7314),
    [sym__binary_star] = ACTIONS(7314),
    [ts_builtin_sym_end] = ACTIONS(7314),
    [anon_sym___END__] = ACTIONS(7314),
    [anon_sym_LBRACE] = ACTIONS(7314),
    [anon_sym_RBRACE] = ACTIONS(7314),
    [anon_sym_RPAREN] = ACTIONS(7314),
    [anon_sym_DOT] = ACTIONS(7316),
    [anon_sym_COMMA] = ACTIONS(7314),
    [anon_sym_PIPE] = ACTIONS(7316),
    [anon_sym_SEMI] = ACTIONS(7314),
    [anon_sym_STAR_STAR] = ACTIONS(7314),
    [anon_sym_AMP] = ACTIONS(7316),
    [anon_sym_LT] = ACTIONS(7316),
    [anon_sym_end] = ACTIONS(7314),
    [anon_sym_if] = ACTIONS(7314),
    [anon_sym_unless] = ACTIONS(7314),
    [anon_sym_while] = ACTIONS(7314),
    [anon_sym_until] = ACTIONS(7314),
    [anon_sym_rescue] = ACTIONS(7314),
    [anon_sym_do] = ACTIONS(7314),
    [anon_sym_when] = ACTIONS(7314),
    [anon_sym_elsif] = ACTIONS(7314),
    [anon_sym_else] = ACTIONS(7314),
    [anon_sym_then] = ACTIONS(7314),
    [anon_sym_ensure] = ACTIONS(7314),
    [anon_sym_EQ_GT] = ACTIONS(7314),
    [anon_sym_LBRACK] = ACTIONS(7314),
    [anon_sym_COLON_COLON2] = ACTIONS(7314),
    [anon_sym_AMP_DOT] = ACTIONS(7314),
    [anon_sym_QMARK] = ACTIONS(7314),
    [anon_sym_DOT_DOT] = ACTIONS(7316),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7314),
    [anon_sym_and] = ACTIONS(7314),
    [anon_sym_or] = ACTIONS(7314),
    [anon_sym_PIPE_PIPE] = ACTIONS(7314),
    [anon_sym_AMP_AMP] = ACTIONS(7314),
    [anon_sym_LT_LT] = ACTIONS(7314),
    [anon_sym_GT_GT] = ACTIONS(7314),
    [anon_sym_EQ_EQ] = ACTIONS(7316),
    [anon_sym_BANG_EQ] = ACTIONS(7314),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7314),
    [anon_sym_LT_EQ_GT] = ACTIONS(7314),
    [anon_sym_EQ_TILDE] = ACTIONS(7314),
    [anon_sym_BANG_TILDE] = ACTIONS(7314),
    [anon_sym_LT_EQ] = ACTIONS(7316),
    [anon_sym_GT] = ACTIONS(7316),
    [anon_sym_GT_EQ] = ACTIONS(7314),
    [anon_sym_CARET] = ACTIONS(7314),
    [anon_sym_PLUS] = ACTIONS(7314),
    [anon_sym_SLASH] = ACTIONS(7314),
    [anon_sym_PERCENT] = ACTIONS(7314),
    [sym_comment] = ACTIONS(87),
  },
  [2098] = {
    [sym_heredoc_body] = STATE(4475),
    [sym__terminator] = STATE(4475),
    [sym__line_break] = ACTIONS(7318),
    [sym__simple_symbol] = ACTIONS(7320),
    [sym__string_start] = ACTIONS(7320),
    [sym__symbol_start] = ACTIONS(7320),
    [sym__subshell_start] = ACTIONS(7320),
    [sym__regex_start] = ACTIONS(7320),
    [sym__string_array_start] = ACTIONS(7320),
    [sym__symbol_array_start] = ACTIONS(7320),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(7320),
    [sym__unary_minus] = ACTIONS(7320),
    [anon_sym_BEGIN] = ACTIONS(7322),
    [anon_sym_LBRACE] = ACTIONS(7320),
    [anon_sym_END] = ACTIONS(7322),
    [anon_sym_def] = ACTIONS(7322),
    [anon_sym_LPAREN] = ACTIONS(7320),
    [anon_sym_COLON_COLON] = ACTIONS(7320),
    [anon_sym_SEMI] = ACTIONS(7318),
    [anon_sym_STAR] = ACTIONS(7320),
    [anon_sym_class] = ACTIONS(7322),
    [anon_sym_module] = ACTIONS(7322),
    [anon_sym_end] = ACTIONS(7322),
    [anon_sym_return] = ACTIONS(7322),
    [anon_sym_yield] = ACTIONS(7322),
    [anon_sym_break] = ACTIONS(7322),
    [anon_sym_next] = ACTIONS(7322),
    [sym_redo] = ACTIONS(7322),
    [sym_retry] = ACTIONS(7322),
    [anon_sym_if] = ACTIONS(7322),
    [anon_sym_unless] = ACTIONS(7322),
    [anon_sym_while] = ACTIONS(7322),
    [anon_sym_until] = ACTIONS(7322),
    [anon_sym_rescue] = ACTIONS(7322),
    [anon_sym_for] = ACTIONS(7322),
    [anon_sym_case] = ACTIONS(7322),
    [anon_sym_else] = ACTIONS(7322),
    [anon_sym_begin] = ACTIONS(7322),
    [anon_sym_ensure] = ACTIONS(7322),
    [anon_sym_PLUS] = ACTIONS(7322),
    [anon_sym_defined_QMARK] = ACTIONS(7320),
    [anon_sym_not] = ACTIONS(7322),
    [anon_sym_BANG] = ACTIONS(7320),
    [anon_sym_TILDE] = ACTIONS(7320),
    [sym_constant] = ACTIONS(7322),
    [sym_identifier] = ACTIONS(7322),
    [sym_instance_variable] = ACTIONS(7320),
    [sym_class_variable] = ACTIONS(7320),
    [sym_global_variable] = ACTIONS(7320),
    [anon_sym_undef] = ACTIONS(7322),
    [anon_sym_alias] = ACTIONS(7322),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(7322),
    [sym_float] = ACTIONS(7322),
    [sym_complex] = ACTIONS(7320),
    [sym_super] = ACTIONS(7322),
    [anon_sym_true] = ACTIONS(7322),
    [anon_sym_TRUE] = ACTIONS(7322),
    [anon_sym_false] = ACTIONS(7322),
    [anon_sym_FALSE] = ACTIONS(7322),
    [sym_self] = ACTIONS(7322),
    [anon_sym_nil] = ACTIONS(7322),
    [anon_sym_NIL] = ACTIONS(7322),
    [sym_character] = ACTIONS(7320),
    [anon_sym_LBRACK2] = ACTIONS(7320),
    [anon_sym_DASH_GT] = ACTIONS(7320),
  },
  [2099] = {
    [aux_sym_method_parameters_repeat1] = STATE(4477),
    [anon_sym_RPAREN] = ACTIONS(7324),
    [anon_sym_COMMA] = ACTIONS(5757),
    [sym_comment] = ACTIONS(87),
  },
  [2100] = {
    [sym__line_break] = ACTIONS(5759),
    [sym__heredoc_body_start] = ACTIONS(5759),
    [anon_sym_COMMA] = ACTIONS(5759),
    [anon_sym_SEMI] = ACTIONS(5759),
    [sym_comment] = ACTIONS(87),
  },
  [2101] = {
    [sym__line_break] = ACTIONS(5761),
    [sym__heredoc_body_start] = ACTIONS(5761),
    [anon_sym_COMMA] = ACTIONS(5761),
    [anon_sym_SEMI] = ACTIONS(5761),
    [sym_comment] = ACTIONS(87),
  },
  [2102] = {
    [sym__line_break] = ACTIONS(5763),
    [sym__heredoc_body_start] = ACTIONS(5763),
    [anon_sym_COMMA] = ACTIONS(5763),
    [anon_sym_SEMI] = ACTIONS(5763),
    [sym_comment] = ACTIONS(87),
  },
  [2103] = {
    [sym_lambda_parameters] = STATE(4480),
    [sym__simple_formal_parameter] = STATE(362),
    [sym_splat_parameter] = STATE(362),
    [sym_hash_splat_parameter] = STATE(362),
    [sym_block_parameter] = STATE(362),
    [sym_keyword_parameter] = STATE(362),
    [sym_optional_parameter] = STATE(362),
    [sym_do_block] = STATE(4481),
    [sym_block] = STATE(4481),
    [anon_sym_LBRACE] = ACTIONS(7326),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(7328),
    [sym_identifier] = ACTIONS(679),
    [sym_comment] = ACTIONS(87),
  },
  [2104] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(4482),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2968),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2968),
    [sym_assignment] = STATE(4482),
    [sym_operator_assignment] = STATE(4482),
    [sym_conditional] = STATE(4482),
    [sym_range] = STATE(4482),
    [sym_binary] = STATE(4482),
    [sym_unary] = STATE(4482),
    [sym_left_assignment_list] = STATE(2967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2968),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2968),
    [sym_false] = STATE(2968),
    [sym_nil] = STATE(2968),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2914),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__line_break] = ACTIONS(5783),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(5783),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4955),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_COMMA] = ACTIONS(5783),
    [anon_sym_SEMI] = ACTIONS(5783),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4883),
    [anon_sym_yield] = ACTIONS(4885),
    [anon_sym_break] = ACTIONS(4887),
    [anon_sym_next] = ACTIONS(4889),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4957),
    [anon_sym_defined_QMARK] = ACTIONS(4959),
    [anon_sym_not] = ACTIONS(4961),
    [anon_sym_BANG] = ACTIONS(4963),
    [anon_sym_TILDE] = ACTIONS(4963),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2105] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(4483),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2968),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2968),
    [sym_assignment] = STATE(4483),
    [sym_operator_assignment] = STATE(4483),
    [sym_conditional] = STATE(4483),
    [sym_range] = STATE(4483),
    [sym_binary] = STATE(4483),
    [sym_unary] = STATE(4483),
    [sym_left_assignment_list] = STATE(2967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2968),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2968),
    [sym_false] = STATE(2968),
    [sym_nil] = STATE(2968),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2914),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4955),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4883),
    [anon_sym_yield] = ACTIONS(4885),
    [anon_sym_break] = ACTIONS(4887),
    [anon_sym_next] = ACTIONS(4889),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4957),
    [anon_sym_defined_QMARK] = ACTIONS(4959),
    [anon_sym_not] = ACTIONS(4961),
    [anon_sym_BANG] = ACTIONS(4963),
    [anon_sym_TILDE] = ACTIONS(4963),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2106] = {
    [sym__line_break] = ACTIONS(7330),
    [sym__heredoc_body_start] = ACTIONS(7330),
    [sym__binary_minus] = ACTIONS(7330),
    [sym__binary_star] = ACTIONS(7330),
    [ts_builtin_sym_end] = ACTIONS(7330),
    [anon_sym___END__] = ACTIONS(7330),
    [anon_sym_LBRACE] = ACTIONS(7330),
    [anon_sym_RBRACE] = ACTIONS(7330),
    [anon_sym_RPAREN] = ACTIONS(7330),
    [anon_sym_DOT] = ACTIONS(7332),
    [anon_sym_COMMA] = ACTIONS(7330),
    [anon_sym_PIPE] = ACTIONS(7332),
    [anon_sym_SEMI] = ACTIONS(7330),
    [anon_sym_STAR_STAR] = ACTIONS(7330),
    [anon_sym_AMP] = ACTIONS(7332),
    [anon_sym_LT] = ACTIONS(7332),
    [anon_sym_end] = ACTIONS(7330),
    [anon_sym_if] = ACTIONS(7330),
    [anon_sym_unless] = ACTIONS(7330),
    [anon_sym_while] = ACTIONS(7330),
    [anon_sym_until] = ACTIONS(7330),
    [anon_sym_rescue] = ACTIONS(7330),
    [anon_sym_do] = ACTIONS(7330),
    [anon_sym_when] = ACTIONS(7330),
    [anon_sym_elsif] = ACTIONS(7330),
    [anon_sym_else] = ACTIONS(7330),
    [anon_sym_then] = ACTIONS(7330),
    [anon_sym_ensure] = ACTIONS(7330),
    [anon_sym_EQ_GT] = ACTIONS(7330),
    [anon_sym_LBRACK] = ACTIONS(7330),
    [anon_sym_COLON_COLON2] = ACTIONS(7330),
    [anon_sym_AMP_DOT] = ACTIONS(7330),
    [anon_sym_QMARK] = ACTIONS(7330),
    [anon_sym_DOT_DOT] = ACTIONS(7332),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7330),
    [anon_sym_and] = ACTIONS(7330),
    [anon_sym_or] = ACTIONS(7330),
    [anon_sym_PIPE_PIPE] = ACTIONS(7330),
    [anon_sym_AMP_AMP] = ACTIONS(7330),
    [anon_sym_LT_LT] = ACTIONS(7330),
    [anon_sym_GT_GT] = ACTIONS(7330),
    [anon_sym_EQ_EQ] = ACTIONS(7332),
    [anon_sym_BANG_EQ] = ACTIONS(7330),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7330),
    [anon_sym_LT_EQ_GT] = ACTIONS(7330),
    [anon_sym_EQ_TILDE] = ACTIONS(7330),
    [anon_sym_BANG_TILDE] = ACTIONS(7330),
    [anon_sym_LT_EQ] = ACTIONS(7332),
    [anon_sym_GT] = ACTIONS(7332),
    [anon_sym_GT_EQ] = ACTIONS(7330),
    [anon_sym_CARET] = ACTIONS(7330),
    [anon_sym_PLUS] = ACTIONS(7330),
    [anon_sym_SLASH] = ACTIONS(7330),
    [anon_sym_PERCENT] = ACTIONS(7330),
    [sym_comment] = ACTIONS(87),
  },
  [2107] = {
    [sym__formal_parameter] = STATE(4485),
    [sym__simple_formal_parameter] = STATE(4485),
    [sym_destructured_parameter] = STATE(4485),
    [sym_splat_parameter] = STATE(4485),
    [sym_hash_splat_parameter] = STATE(4485),
    [sym_block_parameter] = STATE(4485),
    [sym_keyword_parameter] = STATE(4485),
    [sym_optional_parameter] = STATE(4485),
    [anon_sym_LPAREN] = ACTIONS(7334),
    [anon_sym_STAR] = ACTIONS(1283),
    [anon_sym_STAR_STAR] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1287),
    [sym_identifier] = ACTIONS(1289),
    [sym_comment] = ACTIONS(87),
  },
  [2108] = {
    [sym__simple_symbol] = ACTIONS(7320),
    [sym__string_start] = ACTIONS(7320),
    [sym__symbol_start] = ACTIONS(7320),
    [sym__subshell_start] = ACTIONS(7320),
    [sym__regex_start] = ACTIONS(7320),
    [sym__string_array_start] = ACTIONS(7320),
    [sym__symbol_array_start] = ACTIONS(7320),
    [sym_heredoc_beginning] = ACTIONS(7320),
    [sym__unary_minus] = ACTIONS(7320),
    [anon_sym_BEGIN] = ACTIONS(7322),
    [anon_sym_LBRACE] = ACTIONS(7320),
    [anon_sym_END] = ACTIONS(7322),
    [anon_sym_def] = ACTIONS(7322),
    [anon_sym_LPAREN] = ACTIONS(7320),
    [anon_sym_COLON_COLON] = ACTIONS(7320),
    [anon_sym_SEMI] = ACTIONS(7320),
    [anon_sym_STAR] = ACTIONS(7320),
    [anon_sym_class] = ACTIONS(7322),
    [anon_sym_module] = ACTIONS(7322),
    [anon_sym_end] = ACTIONS(7322),
    [anon_sym_return] = ACTIONS(7322),
    [anon_sym_yield] = ACTIONS(7322),
    [anon_sym_break] = ACTIONS(7322),
    [anon_sym_next] = ACTIONS(7322),
    [sym_redo] = ACTIONS(7322),
    [sym_retry] = ACTIONS(7322),
    [anon_sym_if] = ACTIONS(7322),
    [anon_sym_unless] = ACTIONS(7322),
    [anon_sym_while] = ACTIONS(7322),
    [anon_sym_until] = ACTIONS(7322),
    [anon_sym_rescue] = ACTIONS(7322),
    [anon_sym_for] = ACTIONS(7322),
    [anon_sym_case] = ACTIONS(7322),
    [anon_sym_else] = ACTIONS(7322),
    [anon_sym_begin] = ACTIONS(7322),
    [anon_sym_ensure] = ACTIONS(7322),
    [anon_sym_PLUS] = ACTIONS(7322),
    [anon_sym_defined_QMARK] = ACTIONS(7320),
    [anon_sym_not] = ACTIONS(7322),
    [anon_sym_BANG] = ACTIONS(7320),
    [anon_sym_TILDE] = ACTIONS(7320),
    [sym_constant] = ACTIONS(7322),
    [sym_identifier] = ACTIONS(7322),
    [sym_instance_variable] = ACTIONS(7320),
    [sym_class_variable] = ACTIONS(7320),
    [sym_global_variable] = ACTIONS(7320),
    [anon_sym_undef] = ACTIONS(7322),
    [anon_sym_alias] = ACTIONS(7322),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(7322),
    [sym_float] = ACTIONS(7322),
    [sym_complex] = ACTIONS(7320),
    [sym_super] = ACTIONS(7322),
    [anon_sym_true] = ACTIONS(7322),
    [anon_sym_TRUE] = ACTIONS(7322),
    [anon_sym_false] = ACTIONS(7322),
    [anon_sym_FALSE] = ACTIONS(7322),
    [sym_self] = ACTIONS(7322),
    [anon_sym_nil] = ACTIONS(7322),
    [anon_sym_NIL] = ACTIONS(7322),
    [sym_character] = ACTIONS(7320),
    [anon_sym_LBRACK2] = ACTIONS(7320),
    [anon_sym_DASH_GT] = ACTIONS(7320),
  },
  [2109] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(4493),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4495),
    [sym_scope_resolution] = STATE(4433),
    [sym_call] = STATE(4433),
    [sym_method_call] = STATE(4495),
    [sym_assignment] = STATE(4493),
    [sym_operator_assignment] = STATE(4493),
    [sym_conditional] = STATE(4493),
    [sym_range] = STATE(4493),
    [sym_binary] = STATE(4493),
    [sym_unary] = STATE(4493),
    [sym_left_assignment_list] = STATE(4494),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4495),
    [sym__variable] = STATE(4433),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4495),
    [sym_false] = STATE(4495),
    [sym_nil] = STATE(4495),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(4496),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(4005),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(4009),
    [sym__subshell_start] = ACTIONS(4011),
    [sym__regex_start] = ACTIONS(4013),
    [sym__string_array_start] = ACTIONS(4015),
    [sym__symbol_array_start] = ACTIONS(4017),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7336),
    [anon_sym_LBRACE] = ACTIONS(4021),
    [anon_sym_def] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4025),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(4027),
    [anon_sym_module] = ACTIONS(4029),
    [anon_sym_return] = ACTIONS(7338),
    [anon_sym_yield] = ACTIONS(7340),
    [anon_sym_break] = ACTIONS(7342),
    [anon_sym_next] = ACTIONS(7344),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(4039),
    [anon_sym_unless] = ACTIONS(4041),
    [anon_sym_while] = ACTIONS(4043),
    [anon_sym_until] = ACTIONS(4045),
    [anon_sym_for] = ACTIONS(4047),
    [anon_sym_case] = ACTIONS(4049),
    [anon_sym_begin] = ACTIONS(4051),
    [anon_sym_PLUS] = ACTIONS(7346),
    [anon_sym_defined_QMARK] = ACTIONS(7348),
    [anon_sym_not] = ACTIONS(7350),
    [anon_sym_BANG] = ACTIONS(7352),
    [anon_sym_TILDE] = ACTIONS(7352),
    [sym_constant] = ACTIONS(7246),
    [sym_identifier] = ACTIONS(7246),
    [sym_instance_variable] = ACTIONS(7248),
    [sym_class_variable] = ACTIONS(7248),
    [sym_global_variable] = ACTIONS(7248),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4065),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(7246),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(7246),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(4067),
    [anon_sym_DASH_GT] = ACTIONS(4069),
  },
  [2110] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(4497),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4495),
    [sym_scope_resolution] = STATE(4433),
    [sym_call] = STATE(4433),
    [sym_method_call] = STATE(4495),
    [sym_assignment] = STATE(4497),
    [sym_operator_assignment] = STATE(4497),
    [sym_conditional] = STATE(4497),
    [sym_range] = STATE(4497),
    [sym_binary] = STATE(4497),
    [sym_unary] = STATE(4497),
    [sym_left_assignment_list] = STATE(4494),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4495),
    [sym__variable] = STATE(4433),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4495),
    [sym_false] = STATE(4495),
    [sym_nil] = STATE(4495),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(4496),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(4005),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(4009),
    [sym__subshell_start] = ACTIONS(4011),
    [sym__regex_start] = ACTIONS(4013),
    [sym__string_array_start] = ACTIONS(4015),
    [sym__symbol_array_start] = ACTIONS(4017),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7336),
    [anon_sym_LBRACE] = ACTIONS(4021),
    [anon_sym_def] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4025),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(4027),
    [anon_sym_module] = ACTIONS(4029),
    [anon_sym_return] = ACTIONS(7338),
    [anon_sym_yield] = ACTIONS(7340),
    [anon_sym_break] = ACTIONS(7342),
    [anon_sym_next] = ACTIONS(7344),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(4039),
    [anon_sym_unless] = ACTIONS(4041),
    [anon_sym_while] = ACTIONS(4043),
    [anon_sym_until] = ACTIONS(4045),
    [anon_sym_for] = ACTIONS(4047),
    [anon_sym_case] = ACTIONS(4049),
    [anon_sym_begin] = ACTIONS(4051),
    [anon_sym_PLUS] = ACTIONS(7346),
    [anon_sym_defined_QMARK] = ACTIONS(7348),
    [anon_sym_not] = ACTIONS(7350),
    [anon_sym_BANG] = ACTIONS(7352),
    [anon_sym_TILDE] = ACTIONS(7352),
    [sym_constant] = ACTIONS(7246),
    [sym_identifier] = ACTIONS(7246),
    [sym_instance_variable] = ACTIONS(7248),
    [sym_class_variable] = ACTIONS(7248),
    [sym_global_variable] = ACTIONS(7248),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4065),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(7246),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(7246),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(4067),
    [anon_sym_DASH_GT] = ACTIONS(4069),
  },
  [2111] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4498),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2125),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2125),
    [sym_assignment] = STATE(4498),
    [sym_operator_assignment] = STATE(4498),
    [sym_conditional] = STATE(4498),
    [sym_range] = STATE(4498),
    [sym_binary] = STATE(4498),
    [sym_unary] = STATE(4498),
    [sym_left_assignment_list] = STATE(2124),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2125),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2125),
    [sym_false] = STATE(2125),
    [sym_nil] = STATE(2125),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4499),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3705),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3713),
    [anon_sym_break] = ACTIONS(3715),
    [anon_sym_next] = ACTIONS(3717),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3719),
    [anon_sym_defined_QMARK] = ACTIONS(3721),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [sym_constant] = ACTIONS(3667),
    [sym_identifier] = ACTIONS(3667),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2112] = {
    [anon_sym_COLON] = ACTIONS(7354),
    [sym_comment] = ACTIONS(87),
  },
  [2113] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(4501),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4495),
    [sym_scope_resolution] = STATE(4433),
    [sym_call] = STATE(4433),
    [sym_method_call] = STATE(4495),
    [sym_assignment] = STATE(4501),
    [sym_operator_assignment] = STATE(4501),
    [sym_conditional] = STATE(4501),
    [sym_range] = STATE(4501),
    [sym_binary] = STATE(4501),
    [sym_unary] = STATE(4501),
    [sym_left_assignment_list] = STATE(4494),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4495),
    [sym__variable] = STATE(4433),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4495),
    [sym_false] = STATE(4495),
    [sym_nil] = STATE(4495),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(4496),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(4005),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(4009),
    [sym__subshell_start] = ACTIONS(4011),
    [sym__regex_start] = ACTIONS(4013),
    [sym__string_array_start] = ACTIONS(4015),
    [sym__symbol_array_start] = ACTIONS(4017),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7336),
    [anon_sym_LBRACE] = ACTIONS(4021),
    [anon_sym_def] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4025),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(4027),
    [anon_sym_module] = ACTIONS(4029),
    [anon_sym_return] = ACTIONS(7338),
    [anon_sym_yield] = ACTIONS(7340),
    [anon_sym_break] = ACTIONS(7342),
    [anon_sym_next] = ACTIONS(7344),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(4039),
    [anon_sym_unless] = ACTIONS(4041),
    [anon_sym_while] = ACTIONS(4043),
    [anon_sym_until] = ACTIONS(4045),
    [anon_sym_for] = ACTIONS(4047),
    [anon_sym_case] = ACTIONS(4049),
    [anon_sym_begin] = ACTIONS(4051),
    [anon_sym_PLUS] = ACTIONS(7346),
    [anon_sym_defined_QMARK] = ACTIONS(7348),
    [anon_sym_not] = ACTIONS(7350),
    [anon_sym_BANG] = ACTIONS(7352),
    [anon_sym_TILDE] = ACTIONS(7352),
    [sym_constant] = ACTIONS(7246),
    [sym_identifier] = ACTIONS(7246),
    [sym_instance_variable] = ACTIONS(7248),
    [sym_class_variable] = ACTIONS(7248),
    [sym_global_variable] = ACTIONS(7248),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4065),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(7246),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(7246),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(4067),
    [anon_sym_DASH_GT] = ACTIONS(4069),
  },
  [2114] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4507),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2125),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2125),
    [sym_argument_list] = STATE(1318),
    [sym__argument_list_with_parens] = STATE(4508),
    [sym__argument] = STATE(4509),
    [sym_splat_argument] = STATE(4509),
    [sym_hash_splat_argument] = STATE(4509),
    [sym_block_argument] = STATE(4509),
    [sym_assignment] = STATE(4507),
    [sym_operator_assignment] = STATE(4507),
    [sym_conditional] = STATE(4507),
    [sym_range] = STATE(4507),
    [sym_binary] = STATE(4507),
    [sym_unary] = STATE(4507),
    [sym_left_assignment_list] = STATE(2124),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2125),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2125),
    [sym_false] = STATE(2125),
    [sym_nil] = STATE(2125),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4510),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(4509),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(7356),
    [sym__splat_star] = ACTIONS(7358),
    [sym__unary_minus] = ACTIONS(3705),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(7360),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(365),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3713),
    [anon_sym_break] = ACTIONS(3715),
    [anon_sym_next] = ACTIONS(3717),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(3721),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_BANG] = ACTIONS(7362),
    [anon_sym_TILDE] = ACTIONS(3725),
    [sym_constant] = ACTIONS(7364),
    [sym_identifier] = ACTIONS(7364),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2115] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4507),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2125),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2125),
    [sym_argument_list] = STATE(1324),
    [sym__argument_list_with_parens] = STATE(4508),
    [sym__argument] = STATE(4509),
    [sym_splat_argument] = STATE(4509),
    [sym_hash_splat_argument] = STATE(4509),
    [sym_block_argument] = STATE(4509),
    [sym_assignment] = STATE(4507),
    [sym_operator_assignment] = STATE(4507),
    [sym_conditional] = STATE(4507),
    [sym_range] = STATE(4507),
    [sym_binary] = STATE(4507),
    [sym_unary] = STATE(4507),
    [sym_left_assignment_list] = STATE(2124),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2125),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2125),
    [sym_false] = STATE(2125),
    [sym_nil] = STATE(2125),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4510),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(4509),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(7356),
    [sym__splat_star] = ACTIONS(7358),
    [sym__unary_minus] = ACTIONS(3705),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(7360),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(417),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_EQ] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3713),
    [anon_sym_break] = ACTIONS(3715),
    [anon_sym_next] = ACTIONS(3717),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(3721),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_BANG] = ACTIONS(7362),
    [anon_sym_TILDE] = ACTIONS(3725),
    [sym_constant] = ACTIONS(7364),
    [sym_identifier] = ACTIONS(7364),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2116] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4507),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2125),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2125),
    [sym_argument_list] = STATE(1325),
    [sym__argument_list_with_parens] = STATE(4508),
    [sym__argument] = STATE(4509),
    [sym_splat_argument] = STATE(4509),
    [sym_hash_splat_argument] = STATE(4509),
    [sym_block_argument] = STATE(4509),
    [sym_assignment] = STATE(4507),
    [sym_operator_assignment] = STATE(4507),
    [sym_conditional] = STATE(4507),
    [sym_range] = STATE(4507),
    [sym_binary] = STATE(4507),
    [sym_unary] = STATE(4507),
    [sym_left_assignment_list] = STATE(2124),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2125),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2125),
    [sym_false] = STATE(2125),
    [sym_nil] = STATE(2125),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4510),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(4509),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(7356),
    [sym__splat_star] = ACTIONS(7358),
    [sym__unary_minus] = ACTIONS(3705),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(7360),
    [anon_sym_LBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(421),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_EQ] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3713),
    [anon_sym_break] = ACTIONS(3715),
    [anon_sym_next] = ACTIONS(3717),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(3721),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_BANG] = ACTIONS(7362),
    [anon_sym_TILDE] = ACTIONS(3725),
    [sym_constant] = ACTIONS(7364),
    [sym_identifier] = ACTIONS(7364),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2117] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4507),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2125),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2125),
    [sym_argument_list] = STATE(1326),
    [sym__argument_list_with_parens] = STATE(4508),
    [sym__argument] = STATE(4509),
    [sym_splat_argument] = STATE(4509),
    [sym_hash_splat_argument] = STATE(4509),
    [sym_block_argument] = STATE(4509),
    [sym_assignment] = STATE(4507),
    [sym_operator_assignment] = STATE(4507),
    [sym_conditional] = STATE(4507),
    [sym_range] = STATE(4507),
    [sym_binary] = STATE(4507),
    [sym_unary] = STATE(4507),
    [sym_left_assignment_list] = STATE(2124),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2125),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2125),
    [sym_false] = STATE(2125),
    [sym_nil] = STATE(2125),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4510),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(4509),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(7356),
    [sym__splat_star] = ACTIONS(7358),
    [sym__unary_minus] = ACTIONS(3705),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(7360),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(425),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3713),
    [anon_sym_break] = ACTIONS(3715),
    [anon_sym_next] = ACTIONS(3717),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(3721),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_BANG] = ACTIONS(7362),
    [anon_sym_TILDE] = ACTIONS(3725),
    [sym_constant] = ACTIONS(7364),
    [sym_identifier] = ACTIONS(7364),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2118] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4511),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2125),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2125),
    [sym_assignment] = STATE(4511),
    [sym_operator_assignment] = STATE(4511),
    [sym_conditional] = STATE(4511),
    [sym_range] = STATE(4511),
    [sym_binary] = STATE(4511),
    [sym_unary] = STATE(4511),
    [sym_left_assignment_list] = STATE(2124),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2125),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2125),
    [sym_false] = STATE(2125),
    [sym_nil] = STATE(2125),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4499),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3705),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3713),
    [anon_sym_break] = ACTIONS(3715),
    [anon_sym_next] = ACTIONS(3717),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3719),
    [anon_sym_defined_QMARK] = ACTIONS(3721),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [sym_constant] = ACTIONS(3667),
    [sym_identifier] = ACTIONS(3667),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2119] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(1872),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2125),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2125),
    [sym_assignment] = STATE(1872),
    [sym_operator_assignment] = STATE(1872),
    [sym_conditional] = STATE(1872),
    [sym_range] = STATE(1872),
    [sym_binary] = STATE(1872),
    [sym_unary] = STATE(1872),
    [sym_left_assignment_list] = STATE(2124),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2125),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2125),
    [sym_false] = STATE(2125),
    [sym_nil] = STATE(2125),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4499),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3705),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3713),
    [anon_sym_break] = ACTIONS(3715),
    [anon_sym_next] = ACTIONS(3717),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3719),
    [anon_sym_defined_QMARK] = ACTIONS(3721),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [sym_constant] = ACTIONS(3667),
    [sym_identifier] = ACTIONS(3667),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2120] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(7366),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [2121] = {
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(7368),
    [sym__binary_star] = ACTIONS(7370),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_RPAREN] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(7372),
    [anon_sym_STAR_STAR] = ACTIONS(7370),
    [anon_sym_AMP] = ACTIONS(7374),
    [anon_sym_EQ] = ACTIONS(1631),
    [anon_sym_LT] = ACTIONS(7376),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(7354),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(7378),
    [anon_sym_DOT_DOT] = ACTIONS(7380),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7382),
    [anon_sym_and] = ACTIONS(7384),
    [anon_sym_or] = ACTIONS(7384),
    [anon_sym_PIPE_PIPE] = ACTIONS(7386),
    [anon_sym_AMP_AMP] = ACTIONS(7386),
    [anon_sym_LT_LT] = ACTIONS(7388),
    [anon_sym_GT_GT] = ACTIONS(7388),
    [anon_sym_EQ_EQ] = ACTIONS(7390),
    [anon_sym_BANG_EQ] = ACTIONS(7386),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7386),
    [anon_sym_LT_EQ_GT] = ACTIONS(7386),
    [anon_sym_EQ_TILDE] = ACTIONS(7386),
    [anon_sym_BANG_TILDE] = ACTIONS(7386),
    [anon_sym_LT_EQ] = ACTIONS(7376),
    [anon_sym_GT] = ACTIONS(7376),
    [anon_sym_GT_EQ] = ACTIONS(7392),
    [anon_sym_CARET] = ACTIONS(7394),
    [anon_sym_PLUS] = ACTIONS(7368),
    [anon_sym_SLASH] = ACTIONS(7370),
    [anon_sym_PERCENT] = ACTIONS(7370),
    [sym_comment] = ACTIONS(87),
  },
  [2122] = {
    [sym_heredoc_body] = STATE(4523),
    [aux_sym_call_repeat1] = STATE(4523),
    [sym__heredoc_body_start] = ACTIONS(3959),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1681),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_EQ] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [2123] = {
    [sym_heredoc_body] = STATE(4523),
    [aux_sym_call_repeat1] = STATE(4523),
    [aux_sym_argument_list_repeat1] = STATE(4525),
    [sym__heredoc_body_start] = ACTIONS(3959),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1681),
    [anon_sym_COMMA] = ACTIONS(7396),
    [anon_sym_EQ] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [2124] = {
    [anon_sym_EQ] = ACTIONS(7398),
    [sym_comment] = ACTIONS(87),
  },
  [2125] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(7400),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(7402),
    [anon_sym_DASH_EQ] = ACTIONS(7402),
    [anon_sym_STAR_EQ] = ACTIONS(7402),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7402),
    [anon_sym_SLASH_EQ] = ACTIONS(7402),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7402),
    [anon_sym_PIPE_EQ] = ACTIONS(7402),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7402),
    [anon_sym_AMP_EQ] = ACTIONS(7402),
    [anon_sym_PERCENT_EQ] = ACTIONS(7402),
    [anon_sym_GT_GT_EQ] = ACTIONS(7402),
    [anon_sym_LT_LT_EQ] = ACTIONS(7402),
    [anon_sym_CARET_EQ] = ACTIONS(7402),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2126] = {
    [sym_string] = STATE(4528),
    [aux_sym_chained_string_repeat1] = STATE(4528),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(7404),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2127] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(4529),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2136),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(2136),
    [sym_assignment] = STATE(4529),
    [sym_operator_assignment] = STATE(4529),
    [sym_conditional] = STATE(4529),
    [sym_range] = STATE(4529),
    [sym_binary] = STATE(4529),
    [sym_unary] = STATE(4529),
    [sym_left_assignment_list] = STATE(2135),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2136),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2136),
    [sym_false] = STATE(2136),
    [sym_nil] = STATE(2136),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2137),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3729),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3731),
    [anon_sym_yield] = ACTIONS(3733),
    [anon_sym_break] = ACTIONS(3735),
    [anon_sym_next] = ACTIONS(3737),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3739),
    [anon_sym_defined_QMARK] = ACTIONS(3741),
    [anon_sym_not] = ACTIONS(3743),
    [anon_sym_BANG] = ACTIONS(3745),
    [anon_sym_TILDE] = ACTIONS(3745),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2128] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(700),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(705),
    [sym_scope_resolution] = STATE(701),
    [sym_call] = STATE(701),
    [sym_method_call] = STATE(705),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(4530),
    [sym__argument] = STATE(4531),
    [sym_splat_argument] = STATE(4531),
    [sym_hash_splat_argument] = STATE(4531),
    [sym_block_argument] = STATE(4531),
    [sym_assignment] = STATE(700),
    [sym_operator_assignment] = STATE(700),
    [sym_conditional] = STATE(700),
    [sym_range] = STATE(700),
    [sym_binary] = STATE(700),
    [sym_unary] = STATE(700),
    [sym_left_assignment_list] = STATE(704),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(705),
    [sym__variable] = STATE(701),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(705),
    [sym_false] = STATE(705),
    [sym_nil] = STATE(705),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(706),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4531),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(1299),
    [sym__splat_star] = ACTIONS(1301),
    [sym__unary_minus] = ACTIONS(1303),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_RPAREN] = ACTIONS(365),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1323),
    [sym_identifier] = ACTIONS(1323),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2129] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(700),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(705),
    [sym_scope_resolution] = STATE(701),
    [sym_call] = STATE(701),
    [sym_method_call] = STATE(705),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(4530),
    [sym__argument] = STATE(4531),
    [sym_splat_argument] = STATE(4531),
    [sym_hash_splat_argument] = STATE(4531),
    [sym_block_argument] = STATE(4531),
    [sym_assignment] = STATE(700),
    [sym_operator_assignment] = STATE(700),
    [sym_conditional] = STATE(700),
    [sym_range] = STATE(700),
    [sym_binary] = STATE(700),
    [sym_unary] = STATE(700),
    [sym_left_assignment_list] = STATE(704),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(705),
    [sym__variable] = STATE(701),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(705),
    [sym_false] = STATE(705),
    [sym_nil] = STATE(705),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(706),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4531),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(1299),
    [sym__splat_star] = ACTIONS(1301),
    [sym__unary_minus] = ACTIONS(1303),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_RPAREN] = ACTIONS(417),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1323),
    [sym_identifier] = ACTIONS(1323),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2130] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(700),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(705),
    [sym_scope_resolution] = STATE(701),
    [sym_call] = STATE(701),
    [sym_method_call] = STATE(705),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(4530),
    [sym__argument] = STATE(4531),
    [sym_splat_argument] = STATE(4531),
    [sym_hash_splat_argument] = STATE(4531),
    [sym_block_argument] = STATE(4531),
    [sym_assignment] = STATE(700),
    [sym_operator_assignment] = STATE(700),
    [sym_conditional] = STATE(700),
    [sym_range] = STATE(700),
    [sym_binary] = STATE(700),
    [sym_unary] = STATE(700),
    [sym_left_assignment_list] = STATE(704),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(705),
    [sym__variable] = STATE(701),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(705),
    [sym_false] = STATE(705),
    [sym_nil] = STATE(705),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(706),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4531),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(1299),
    [sym__splat_star] = ACTIONS(1301),
    [sym__unary_minus] = ACTIONS(1303),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_RPAREN] = ACTIONS(421),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1323),
    [sym_identifier] = ACTIONS(1323),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2131] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(700),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(705),
    [sym_scope_resolution] = STATE(701),
    [sym_call] = STATE(701),
    [sym_method_call] = STATE(705),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(4530),
    [sym__argument] = STATE(4531),
    [sym_splat_argument] = STATE(4531),
    [sym_hash_splat_argument] = STATE(4531),
    [sym_block_argument] = STATE(4531),
    [sym_assignment] = STATE(700),
    [sym_operator_assignment] = STATE(700),
    [sym_conditional] = STATE(700),
    [sym_range] = STATE(700),
    [sym_binary] = STATE(700),
    [sym_unary] = STATE(700),
    [sym_left_assignment_list] = STATE(704),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(705),
    [sym__variable] = STATE(701),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(705),
    [sym_false] = STATE(705),
    [sym_nil] = STATE(705),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(706),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4531),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(1299),
    [sym__splat_star] = ACTIONS(1301),
    [sym__unary_minus] = ACTIONS(1303),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_RPAREN] = ACTIONS(425),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1323),
    [sym_identifier] = ACTIONS(1323),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2132] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(4532),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2136),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(2136),
    [sym_assignment] = STATE(4532),
    [sym_operator_assignment] = STATE(4532),
    [sym_conditional] = STATE(4532),
    [sym_range] = STATE(4532),
    [sym_binary] = STATE(4532),
    [sym_unary] = STATE(4532),
    [sym_left_assignment_list] = STATE(2135),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2136),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2136),
    [sym_false] = STATE(2136),
    [sym_nil] = STATE(2136),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2137),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3729),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3731),
    [anon_sym_yield] = ACTIONS(3733),
    [anon_sym_break] = ACTIONS(3735),
    [anon_sym_next] = ACTIONS(3737),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3739),
    [anon_sym_defined_QMARK] = ACTIONS(3741),
    [anon_sym_not] = ACTIONS(3743),
    [anon_sym_BANG] = ACTIONS(3745),
    [anon_sym_TILDE] = ACTIONS(3745),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2133] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2136),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(2136),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(2135),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2136),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2136),
    [sym_false] = STATE(2136),
    [sym_nil] = STATE(2136),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2137),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3729),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3731),
    [anon_sym_yield] = ACTIONS(3733),
    [anon_sym_break] = ACTIONS(3735),
    [anon_sym_next] = ACTIONS(3737),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3739),
    [anon_sym_defined_QMARK] = ACTIONS(3741),
    [anon_sym_not] = ACTIONS(3743),
    [anon_sym_BANG] = ACTIONS(3745),
    [anon_sym_TILDE] = ACTIONS(3745),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2134] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(7406),
    [sym__binary_star] = ACTIONS(7408),
    [anon_sym_RPAREN] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(7410),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(7408),
    [anon_sym_AMP] = ACTIONS(7412),
    [anon_sym_LT] = ACTIONS(7414),
    [anon_sym_if] = ACTIONS(4211),
    [anon_sym_unless] = ACTIONS(4211),
    [anon_sym_while] = ACTIONS(4211),
    [anon_sym_until] = ACTIONS(4211),
    [anon_sym_rescue] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(7416),
    [anon_sym_DOT_DOT] = ACTIONS(7418),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7420),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(7422),
    [anon_sym_AMP_AMP] = ACTIONS(7422),
    [anon_sym_LT_LT] = ACTIONS(7424),
    [anon_sym_GT_GT] = ACTIONS(7424),
    [anon_sym_EQ_EQ] = ACTIONS(7426),
    [anon_sym_BANG_EQ] = ACTIONS(7422),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7422),
    [anon_sym_LT_EQ_GT] = ACTIONS(7422),
    [anon_sym_EQ_TILDE] = ACTIONS(7422),
    [anon_sym_BANG_TILDE] = ACTIONS(7422),
    [anon_sym_LT_EQ] = ACTIONS(7414),
    [anon_sym_GT] = ACTIONS(7414),
    [anon_sym_GT_EQ] = ACTIONS(7428),
    [anon_sym_CARET] = ACTIONS(7430),
    [anon_sym_PLUS] = ACTIONS(7406),
    [anon_sym_SLASH] = ACTIONS(7408),
    [anon_sym_PERCENT] = ACTIONS(7408),
    [sym_comment] = ACTIONS(87),
  },
  [2135] = {
    [anon_sym_EQ] = ACTIONS(7432),
    [sym_comment] = ACTIONS(87),
  },
  [2136] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(7434),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(7436),
    [anon_sym_DASH_EQ] = ACTIONS(7436),
    [anon_sym_STAR_EQ] = ACTIONS(7436),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7436),
    [anon_sym_SLASH_EQ] = ACTIONS(7436),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7436),
    [anon_sym_PIPE_EQ] = ACTIONS(7436),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7436),
    [anon_sym_AMP_EQ] = ACTIONS(7436),
    [anon_sym_PERCENT_EQ] = ACTIONS(7436),
    [anon_sym_GT_GT_EQ] = ACTIONS(7436),
    [anon_sym_LT_LT_EQ] = ACTIONS(7436),
    [anon_sym_CARET_EQ] = ACTIONS(7436),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2137] = {
    [sym_string] = STATE(4545),
    [aux_sym_chained_string_repeat1] = STATE(4545),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2138] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(7406),
    [sym__binary_star] = ACTIONS(7408),
    [anon_sym_RPAREN] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(7410),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(7408),
    [anon_sym_AMP] = ACTIONS(7412),
    [anon_sym_LT] = ACTIONS(7414),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(7416),
    [anon_sym_DOT_DOT] = ACTIONS(7418),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7420),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(7422),
    [anon_sym_AMP_AMP] = ACTIONS(7422),
    [anon_sym_LT_LT] = ACTIONS(7424),
    [anon_sym_GT_GT] = ACTIONS(7424),
    [anon_sym_EQ_EQ] = ACTIONS(7426),
    [anon_sym_BANG_EQ] = ACTIONS(7422),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7422),
    [anon_sym_LT_EQ_GT] = ACTIONS(7422),
    [anon_sym_EQ_TILDE] = ACTIONS(7422),
    [anon_sym_BANG_TILDE] = ACTIONS(7422),
    [anon_sym_LT_EQ] = ACTIONS(7414),
    [anon_sym_GT] = ACTIONS(7414),
    [anon_sym_GT_EQ] = ACTIONS(7428),
    [anon_sym_CARET] = ACTIONS(7430),
    [anon_sym_PLUS] = ACTIONS(7406),
    [anon_sym_SLASH] = ACTIONS(7408),
    [anon_sym_PERCENT] = ACTIONS(7408),
    [sym_comment] = ACTIONS(87),
  },
  [2139] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(3763),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [2140] = {
    [sym_string] = STATE(2178),
    [aux_sym_chained_string_repeat1] = STATE(2178),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2141] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(4546),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2136),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(2136),
    [sym_assignment] = STATE(4546),
    [sym_operator_assignment] = STATE(4546),
    [sym_conditional] = STATE(4546),
    [sym_range] = STATE(4546),
    [sym_binary] = STATE(4546),
    [sym_unary] = STATE(4546),
    [sym_left_assignment_list] = STATE(2135),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2136),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2136),
    [sym_false] = STATE(2136),
    [sym_nil] = STATE(2136),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2137),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3729),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3731),
    [anon_sym_yield] = ACTIONS(3733),
    [anon_sym_break] = ACTIONS(3735),
    [anon_sym_next] = ACTIONS(3737),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3739),
    [anon_sym_defined_QMARK] = ACTIONS(3741),
    [anon_sym_not] = ACTIONS(3743),
    [anon_sym_BANG] = ACTIONS(3745),
    [anon_sym_TILDE] = ACTIONS(3745),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2142] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(7406),
    [sym__binary_star] = ACTIONS(7408),
    [anon_sym_RPAREN] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(7410),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(7408),
    [anon_sym_AMP] = ACTIONS(7412),
    [anon_sym_LT] = ACTIONS(7414),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_unless] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_until] = ACTIONS(3281),
    [anon_sym_rescue] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(7416),
    [anon_sym_DOT_DOT] = ACTIONS(7418),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7420),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(7422),
    [anon_sym_AMP_AMP] = ACTIONS(7422),
    [anon_sym_LT_LT] = ACTIONS(7424),
    [anon_sym_GT_GT] = ACTIONS(7424),
    [anon_sym_EQ_EQ] = ACTIONS(7426),
    [anon_sym_BANG_EQ] = ACTIONS(7422),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7422),
    [anon_sym_LT_EQ_GT] = ACTIONS(7422),
    [anon_sym_EQ_TILDE] = ACTIONS(7422),
    [anon_sym_BANG_TILDE] = ACTIONS(7422),
    [anon_sym_LT_EQ] = ACTIONS(7414),
    [anon_sym_GT] = ACTIONS(7414),
    [anon_sym_GT_EQ] = ACTIONS(7428),
    [anon_sym_CARET] = ACTIONS(7430),
    [anon_sym_PLUS] = ACTIONS(7406),
    [anon_sym_SLASH] = ACTIONS(7408),
    [anon_sym_PERCENT] = ACTIONS(7408),
    [sym_comment] = ACTIONS(87),
  },
  [2143] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4547),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(705),
    [sym_scope_resolution] = STATE(701),
    [sym_call] = STATE(701),
    [sym_method_call] = STATE(705),
    [sym_assignment] = STATE(4547),
    [sym_operator_assignment] = STATE(4547),
    [sym_conditional] = STATE(4547),
    [sym_range] = STATE(4547),
    [sym_binary] = STATE(4547),
    [sym_unary] = STATE(4547),
    [sym_left_assignment_list] = STATE(704),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(705),
    [sym__variable] = STATE(701),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(705),
    [sym_false] = STATE(705),
    [sym_nil] = STATE(705),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2140),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3747),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2144] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4548),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(705),
    [sym_scope_resolution] = STATE(701),
    [sym_call] = STATE(701),
    [sym_method_call] = STATE(705),
    [sym_assignment] = STATE(4548),
    [sym_operator_assignment] = STATE(4548),
    [sym_conditional] = STATE(4548),
    [sym_range] = STATE(4548),
    [sym_binary] = STATE(4548),
    [sym_unary] = STATE(4548),
    [sym_left_assignment_list] = STATE(704),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(705),
    [sym__variable] = STATE(701),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(705),
    [sym_false] = STATE(705),
    [sym_nil] = STATE(705),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2140),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3747),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2145] = {
    [anon_sym_COLON] = ACTIONS(7438),
    [sym_comment] = ACTIONS(87),
  },
  [2146] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4550),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(705),
    [sym_scope_resolution] = STATE(701),
    [sym_call] = STATE(701),
    [sym_method_call] = STATE(705),
    [sym_assignment] = STATE(4550),
    [sym_operator_assignment] = STATE(4550),
    [sym_conditional] = STATE(4550),
    [sym_range] = STATE(4550),
    [sym_binary] = STATE(4550),
    [sym_unary] = STATE(4550),
    [sym_left_assignment_list] = STATE(704),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(705),
    [sym__variable] = STATE(701),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(705),
    [sym_false] = STATE(705),
    [sym_nil] = STATE(705),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2140),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3747),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2147] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(7440),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [2148] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(3761),
    [sym__binary_star] = ACTIONS(3763),
    [anon_sym_RPAREN] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(3765),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(3763),
    [anon_sym_AMP] = ACTIONS(3767),
    [anon_sym_LT] = ACTIONS(3769),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_unless] = ACTIONS(1625),
    [anon_sym_while] = ACTIONS(1625),
    [anon_sym_until] = ACTIONS(1625),
    [anon_sym_rescue] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(1625),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(3771),
    [anon_sym_DOT_DOT] = ACTIONS(3773),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3775),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(3777),
    [anon_sym_AMP_AMP] = ACTIONS(3777),
    [anon_sym_LT_LT] = ACTIONS(3779),
    [anon_sym_GT_GT] = ACTIONS(3779),
    [anon_sym_EQ_EQ] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3777),
    [anon_sym_LT_EQ_GT] = ACTIONS(3777),
    [anon_sym_EQ_TILDE] = ACTIONS(3777),
    [anon_sym_BANG_TILDE] = ACTIONS(3777),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3783),
    [anon_sym_CARET] = ACTIONS(3785),
    [anon_sym_PLUS] = ACTIONS(3761),
    [anon_sym_SLASH] = ACTIONS(3763),
    [anon_sym_PERCENT] = ACTIONS(3763),
    [sym_comment] = ACTIONS(87),
  },
  [2149] = {
    [sym_heredoc_body] = STATE(4552),
    [aux_sym_call_repeat1] = STATE(4552),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [2150] = {
    [sym_heredoc_body] = STATE(4552),
    [aux_sym_call_repeat1] = STATE(4552),
    [aux_sym_argument_list_repeat1] = STATE(4554),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(7442),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [2151] = {
    [sym_string] = STATE(2178),
    [aux_sym_chained_string_repeat1] = STATE(2178),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(7444),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2152] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(3761),
    [sym__binary_star] = ACTIONS(3763),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(3765),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(3763),
    [anon_sym_AMP] = ACTIONS(3767),
    [anon_sym_LT] = ACTIONS(3769),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(3771),
    [anon_sym_DOT_DOT] = ACTIONS(3773),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3775),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(3777),
    [anon_sym_AMP_AMP] = ACTIONS(3777),
    [anon_sym_LT_LT] = ACTIONS(3779),
    [anon_sym_GT_GT] = ACTIONS(3779),
    [anon_sym_EQ_EQ] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3777),
    [anon_sym_LT_EQ_GT] = ACTIONS(3777),
    [anon_sym_EQ_TILDE] = ACTIONS(3777),
    [anon_sym_BANG_TILDE] = ACTIONS(3777),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3783),
    [anon_sym_CARET] = ACTIONS(3785),
    [anon_sym_PLUS] = ACTIONS(3761),
    [anon_sym_SLASH] = ACTIONS(3763),
    [anon_sym_PERCENT] = ACTIONS(3763),
    [sym_comment] = ACTIONS(87),
  },
  [2153] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(4555),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2136),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(2136),
    [sym_assignment] = STATE(4555),
    [sym_operator_assignment] = STATE(4555),
    [sym_conditional] = STATE(4555),
    [sym_range] = STATE(4555),
    [sym_binary] = STATE(4555),
    [sym_unary] = STATE(4555),
    [sym_left_assignment_list] = STATE(2135),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2136),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2136),
    [sym_false] = STATE(2136),
    [sym_nil] = STATE(2136),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2137),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3729),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3731),
    [anon_sym_yield] = ACTIONS(3733),
    [anon_sym_break] = ACTIONS(3735),
    [anon_sym_next] = ACTIONS(3737),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3739),
    [anon_sym_defined_QMARK] = ACTIONS(3741),
    [anon_sym_not] = ACTIONS(3743),
    [anon_sym_BANG] = ACTIONS(3745),
    [anon_sym_TILDE] = ACTIONS(3745),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2154] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4556),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(705),
    [sym_scope_resolution] = STATE(701),
    [sym_call] = STATE(701),
    [sym_method_call] = STATE(705),
    [sym_assignment] = STATE(4556),
    [sym_operator_assignment] = STATE(4556),
    [sym_conditional] = STATE(4556),
    [sym_range] = STATE(4556),
    [sym_binary] = STATE(4556),
    [sym_unary] = STATE(4556),
    [sym_left_assignment_list] = STATE(704),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(705),
    [sym__variable] = STATE(701),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(705),
    [sym_false] = STATE(705),
    [sym_nil] = STATE(705),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2140),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3747),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2155] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4557),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(705),
    [sym_scope_resolution] = STATE(701),
    [sym_call] = STATE(701),
    [sym_method_call] = STATE(705),
    [sym_assignment] = STATE(4557),
    [sym_operator_assignment] = STATE(4557),
    [sym_conditional] = STATE(4557),
    [sym_range] = STATE(4557),
    [sym_binary] = STATE(4557),
    [sym_unary] = STATE(4557),
    [sym_left_assignment_list] = STATE(704),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(705),
    [sym__variable] = STATE(701),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(705),
    [sym_false] = STATE(705),
    [sym_nil] = STATE(705),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2140),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3747),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2156] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4558),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(705),
    [sym_scope_resolution] = STATE(701),
    [sym_call] = STATE(701),
    [sym_method_call] = STATE(705),
    [sym_assignment] = STATE(4558),
    [sym_operator_assignment] = STATE(4558),
    [sym_conditional] = STATE(4558),
    [sym_range] = STATE(4558),
    [sym_binary] = STATE(4558),
    [sym_unary] = STATE(4558),
    [sym_left_assignment_list] = STATE(704),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(705),
    [sym__variable] = STATE(701),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(705),
    [sym_false] = STATE(705),
    [sym_nil] = STATE(705),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2140),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3747),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2157] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4559),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(705),
    [sym_scope_resolution] = STATE(701),
    [sym_call] = STATE(701),
    [sym_method_call] = STATE(705),
    [sym_assignment] = STATE(4559),
    [sym_operator_assignment] = STATE(4559),
    [sym_conditional] = STATE(4559),
    [sym_range] = STATE(4559),
    [sym_binary] = STATE(4559),
    [sym_unary] = STATE(4559),
    [sym_left_assignment_list] = STATE(704),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(705),
    [sym__variable] = STATE(701),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(705),
    [sym_false] = STATE(705),
    [sym_nil] = STATE(705),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2140),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3747),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2158] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4560),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(705),
    [sym_scope_resolution] = STATE(701),
    [sym_call] = STATE(701),
    [sym_method_call] = STATE(705),
    [sym_assignment] = STATE(4560),
    [sym_operator_assignment] = STATE(4560),
    [sym_conditional] = STATE(4560),
    [sym_range] = STATE(4560),
    [sym_binary] = STATE(4560),
    [sym_unary] = STATE(4560),
    [sym_left_assignment_list] = STATE(704),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(705),
    [sym__variable] = STATE(701),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(705),
    [sym_false] = STATE(705),
    [sym_nil] = STATE(705),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2140),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3747),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2159] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(4561),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(4561),
    [sym_operator_assignment] = STATE(4561),
    [sym_conditional] = STATE(4561),
    [sym_range] = STATE(4561),
    [sym_binary] = STATE(4561),
    [sym_unary] = STATE(4561),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2160] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4562),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(705),
    [sym_scope_resolution] = STATE(701),
    [sym_call] = STATE(701),
    [sym_method_call] = STATE(705),
    [sym_assignment] = STATE(4562),
    [sym_operator_assignment] = STATE(4562),
    [sym_conditional] = STATE(4562),
    [sym_range] = STATE(4562),
    [sym_binary] = STATE(4562),
    [sym_unary] = STATE(4562),
    [sym_left_assignment_list] = STATE(704),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(705),
    [sym__variable] = STATE(701),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(705),
    [sym_false] = STATE(705),
    [sym_nil] = STATE(705),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2140),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3747),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2161] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4563),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(705),
    [sym_scope_resolution] = STATE(701),
    [sym_call] = STATE(701),
    [sym_method_call] = STATE(705),
    [sym_assignment] = STATE(4563),
    [sym_operator_assignment] = STATE(4563),
    [sym_conditional] = STATE(4563),
    [sym_range] = STATE(4563),
    [sym_binary] = STATE(4563),
    [sym_unary] = STATE(4563),
    [sym_left_assignment_list] = STATE(704),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(705),
    [sym__variable] = STATE(701),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(705),
    [sym_false] = STATE(705),
    [sym_nil] = STATE(705),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2140),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3747),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2162] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4564),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(705),
    [sym_scope_resolution] = STATE(701),
    [sym_call] = STATE(701),
    [sym_method_call] = STATE(705),
    [sym_assignment] = STATE(4564),
    [sym_operator_assignment] = STATE(4564),
    [sym_conditional] = STATE(4564),
    [sym_range] = STATE(4564),
    [sym_binary] = STATE(4564),
    [sym_unary] = STATE(4564),
    [sym_left_assignment_list] = STATE(704),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(705),
    [sym__variable] = STATE(701),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(705),
    [sym_false] = STATE(705),
    [sym_nil] = STATE(705),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2140),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3747),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2163] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4565),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(705),
    [sym_scope_resolution] = STATE(701),
    [sym_call] = STATE(701),
    [sym_method_call] = STATE(705),
    [sym_assignment] = STATE(4565),
    [sym_operator_assignment] = STATE(4565),
    [sym_conditional] = STATE(4565),
    [sym_range] = STATE(4565),
    [sym_binary] = STATE(4565),
    [sym_unary] = STATE(4565),
    [sym_left_assignment_list] = STATE(704),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(705),
    [sym__variable] = STATE(701),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(705),
    [sym_false] = STATE(705),
    [sym_nil] = STATE(705),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2140),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3747),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2164] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(4566),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(742),
    [sym_scope_resolution] = STATE(738),
    [sym_call] = STATE(738),
    [sym_method_call] = STATE(742),
    [sym_assignment] = STATE(4566),
    [sym_operator_assignment] = STATE(4566),
    [sym_conditional] = STATE(4566),
    [sym_range] = STATE(4566),
    [sym_binary] = STATE(4566),
    [sym_unary] = STATE(4566),
    [sym_left_assignment_list] = STATE(741),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(742),
    [sym__variable] = STATE(738),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(742),
    [sym_false] = STATE(742),
    [sym_nil] = STATE(742),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2209),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1381),
    [anon_sym_break] = ACTIONS(1383),
    [anon_sym_next] = ACTIONS(1385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(3831),
    [anon_sym_defined_QMARK] = ACTIONS(1387),
    [anon_sym_not] = ACTIONS(1389),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_TILDE] = ACTIONS(1393),
    [sym_constant] = ACTIONS(1399),
    [sym_identifier] = ACTIONS(1399),
    [sym_instance_variable] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1397),
    [sym_global_variable] = ACTIONS(1397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2165] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(4567),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(742),
    [sym_scope_resolution] = STATE(738),
    [sym_call] = STATE(738),
    [sym_method_call] = STATE(742),
    [sym_assignment] = STATE(4567),
    [sym_operator_assignment] = STATE(4567),
    [sym_conditional] = STATE(4567),
    [sym_range] = STATE(4567),
    [sym_binary] = STATE(4567),
    [sym_unary] = STATE(4567),
    [sym_left_assignment_list] = STATE(741),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(742),
    [sym__variable] = STATE(738),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(742),
    [sym_false] = STATE(742),
    [sym_nil] = STATE(742),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2209),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1381),
    [anon_sym_break] = ACTIONS(1383),
    [anon_sym_next] = ACTIONS(1385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(3831),
    [anon_sym_defined_QMARK] = ACTIONS(1387),
    [anon_sym_not] = ACTIONS(1389),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_TILDE] = ACTIONS(1393),
    [sym_constant] = ACTIONS(1399),
    [sym_identifier] = ACTIONS(1399),
    [sym_instance_variable] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1397),
    [sym_global_variable] = ACTIONS(1397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2166] = {
    [anon_sym_COLON] = ACTIONS(7446),
    [sym_comment] = ACTIONS(87),
  },
  [2167] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(4569),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(742),
    [sym_scope_resolution] = STATE(738),
    [sym_call] = STATE(738),
    [sym_method_call] = STATE(742),
    [sym_assignment] = STATE(4569),
    [sym_operator_assignment] = STATE(4569),
    [sym_conditional] = STATE(4569),
    [sym_range] = STATE(4569),
    [sym_binary] = STATE(4569),
    [sym_unary] = STATE(4569),
    [sym_left_assignment_list] = STATE(741),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(742),
    [sym__variable] = STATE(738),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(742),
    [sym_false] = STATE(742),
    [sym_nil] = STATE(742),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2209),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1381),
    [anon_sym_break] = ACTIONS(1383),
    [anon_sym_next] = ACTIONS(1385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(3831),
    [anon_sym_defined_QMARK] = ACTIONS(1387),
    [anon_sym_not] = ACTIONS(1389),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_TILDE] = ACTIONS(1393),
    [sym_constant] = ACTIONS(1399),
    [sym_identifier] = ACTIONS(1399),
    [sym_instance_variable] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1397),
    [sym_global_variable] = ACTIONS(1397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2168] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(7448),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [2169] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(3837),
    [sym__binary_star] = ACTIONS(3839),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_RPAREN] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(3841),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(3843),
    [anon_sym_AMP] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(1631),
    [anon_sym_LT] = ACTIONS(3847),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_unless] = ACTIONS(1625),
    [anon_sym_while] = ACTIONS(1625),
    [anon_sym_until] = ACTIONS(1625),
    [anon_sym_rescue] = ACTIONS(1625),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(1625),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_PLUS_EQ] = ACTIONS(1625),
    [anon_sym_DASH_EQ] = ACTIONS(1625),
    [anon_sym_STAR_EQ] = ACTIONS(1625),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1625),
    [anon_sym_SLASH_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1625),
    [anon_sym_AMP_EQ] = ACTIONS(1625),
    [anon_sym_PERCENT_EQ] = ACTIONS(1625),
    [anon_sym_GT_GT_EQ] = ACTIONS(1625),
    [anon_sym_LT_LT_EQ] = ACTIONS(1625),
    [anon_sym_CARET_EQ] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(3849),
    [anon_sym_DOT_DOT] = ACTIONS(3851),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3853),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(3855),
    [anon_sym_AMP_AMP] = ACTIONS(3855),
    [anon_sym_LT_LT] = ACTIONS(3857),
    [anon_sym_GT_GT] = ACTIONS(3857),
    [anon_sym_EQ_EQ] = ACTIONS(3855),
    [anon_sym_BANG_EQ] = ACTIONS(3859),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3859),
    [anon_sym_LT_EQ_GT] = ACTIONS(3859),
    [anon_sym_EQ_TILDE] = ACTIONS(3859),
    [anon_sym_BANG_TILDE] = ACTIONS(3859),
    [anon_sym_LT_EQ] = ACTIONS(3847),
    [anon_sym_GT] = ACTIONS(3847),
    [anon_sym_GT_EQ] = ACTIONS(3861),
    [anon_sym_CARET] = ACTIONS(3841),
    [anon_sym_PLUS] = ACTIONS(3863),
    [anon_sym_SLASH] = ACTIONS(3843),
    [anon_sym_PERCENT] = ACTIONS(3843),
    [sym_comment] = ACTIONS(87),
  },
  [2170] = {
    [sym_heredoc_body] = STATE(4571),
    [aux_sym_call_repeat1] = STATE(4571),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [2171] = {
    [sym_heredoc_body] = STATE(4571),
    [aux_sym_call_repeat1] = STATE(4571),
    [aux_sym_argument_list_repeat1] = STATE(4573),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(7450),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [2172] = {
    [sym_string] = STATE(2229),
    [aux_sym_chained_string_repeat1] = STATE(2229),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(747),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(7452),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2173] = {
    [sym_heredoc_body] = STATE(4574),
    [aux_sym_call_repeat1] = STATE(4574),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_RPAREN] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [2174] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(700),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(705),
    [sym_scope_resolution] = STATE(701),
    [sym_call] = STATE(701),
    [sym_method_call] = STATE(705),
    [sym__argument] = STATE(2565),
    [sym_splat_argument] = STATE(2565),
    [sym_hash_splat_argument] = STATE(2565),
    [sym_block_argument] = STATE(2565),
    [sym_assignment] = STATE(700),
    [sym_operator_assignment] = STATE(700),
    [sym_conditional] = STATE(700),
    [sym_range] = STATE(700),
    [sym_binary] = STATE(700),
    [sym_unary] = STATE(700),
    [sym_left_assignment_list] = STATE(704),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(705),
    [sym__variable] = STATE(701),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(705),
    [sym_false] = STATE(705),
    [sym_nil] = STATE(705),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(706),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(4575),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2565),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(1299),
    [sym__splat_star] = ACTIONS(1301),
    [sym__unary_minus] = ACTIONS(1303),
    [sym__identifier_hash_key] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(7454),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3747),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1323),
    [sym_identifier] = ACTIONS(1323),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2175] = {
    [sym_heredoc_body] = STATE(4576),
    [aux_sym_call_repeat1] = STATE(4576),
    [aux_sym_argument_list_repeat1] = STATE(4577),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_RPAREN] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(3795),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [2176] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4578),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(705),
    [sym_scope_resolution] = STATE(701),
    [sym_call] = STATE(701),
    [sym_method_call] = STATE(705),
    [sym_splat_argument] = STATE(4579),
    [sym_assignment] = STATE(4578),
    [sym_operator_assignment] = STATE(4578),
    [sym_conditional] = STATE(4578),
    [sym_range] = STATE(4578),
    [sym_binary] = STATE(4578),
    [sym_unary] = STATE(4578),
    [sym_right_assignment_list] = STATE(2570),
    [sym__arg_or_splat_arg] = STATE(4579),
    [sym_left_assignment_list] = STATE(704),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(705),
    [sym__variable] = STATE(701),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(705),
    [sym_false] = STATE(705),
    [sym_nil] = STATE(705),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2140),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__splat_star] = ACTIONS(3753),
    [sym__unary_minus] = ACTIONS(1303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3747),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2177] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4580),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(705),
    [sym_scope_resolution] = STATE(701),
    [sym_call] = STATE(701),
    [sym_method_call] = STATE(705),
    [sym_assignment] = STATE(4580),
    [sym_operator_assignment] = STATE(4580),
    [sym_conditional] = STATE(4580),
    [sym_range] = STATE(4580),
    [sym_binary] = STATE(4580),
    [sym_unary] = STATE(4580),
    [sym_left_assignment_list] = STATE(704),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(705),
    [sym__variable] = STATE(701),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(705),
    [sym_false] = STATE(705),
    [sym_nil] = STATE(705),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2140),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3747),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2178] = {
    [sym_string] = STATE(4581),
    [aux_sym_chained_string_repeat1] = STATE(4581),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_RPAREN] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_EQ_GT] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [2179] = {
    [aux_sym_undef_repeat1] = STATE(4582),
    [sym__line_break] = ACTIONS(5497),
    [sym__heredoc_body_start] = ACTIONS(5497),
    [anon_sym_RPAREN] = ACTIONS(5497),
    [anon_sym_COMMA] = ACTIONS(2253),
    [anon_sym_SEMI] = ACTIONS(5497),
    [anon_sym_if] = ACTIONS(5497),
    [anon_sym_unless] = ACTIONS(5497),
    [anon_sym_while] = ACTIONS(5497),
    [anon_sym_until] = ACTIONS(5497),
    [anon_sym_rescue] = ACTIONS(5497),
    [sym_comment] = ACTIONS(87),
  },
  [2180] = {
    [sym__line_break] = ACTIONS(5815),
    [sym__heredoc_body_start] = ACTIONS(5815),
    [sym__binary_minus] = ACTIONS(1343),
    [sym__binary_star] = ACTIONS(1345),
    [anon_sym_RPAREN] = ACTIONS(5815),
    [anon_sym_PIPE] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(5815),
    [anon_sym_STAR_STAR] = ACTIONS(1345),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(5815),
    [anon_sym_unless] = ACTIONS(5815),
    [anon_sym_while] = ACTIONS(5815),
    [anon_sym_until] = ACTIONS(5815),
    [anon_sym_rescue] = ACTIONS(5815),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_DOT_DOT] = ACTIONS(1355),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1357),
    [anon_sym_and] = ACTIONS(1359),
    [anon_sym_or] = ACTIONS(1359),
    [anon_sym_PIPE_PIPE] = ACTIONS(1361),
    [anon_sym_AMP_AMP] = ACTIONS(1361),
    [anon_sym_LT_LT] = ACTIONS(1363),
    [anon_sym_GT_GT] = ACTIONS(1363),
    [anon_sym_EQ_EQ] = ACTIONS(1365),
    [anon_sym_BANG_EQ] = ACTIONS(1361),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1361),
    [anon_sym_LT_EQ_GT] = ACTIONS(1361),
    [anon_sym_EQ_TILDE] = ACTIONS(1361),
    [anon_sym_BANG_TILDE] = ACTIONS(1361),
    [anon_sym_LT_EQ] = ACTIONS(1351),
    [anon_sym_GT] = ACTIONS(1351),
    [anon_sym_GT_EQ] = ACTIONS(1367),
    [anon_sym_CARET] = ACTIONS(1369),
    [anon_sym_PLUS] = ACTIONS(1343),
    [anon_sym_SLASH] = ACTIONS(1345),
    [anon_sym_PERCENT] = ACTIONS(1345),
    [sym_comment] = ACTIONS(87),
  },
  [2181] = {
    [sym__line_break] = ACTIONS(5817),
    [sym__heredoc_body_start] = ACTIONS(5817),
    [sym__binary_minus] = ACTIONS(1343),
    [sym__binary_star] = ACTIONS(1345),
    [anon_sym_RPAREN] = ACTIONS(5817),
    [anon_sym_PIPE] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(5817),
    [anon_sym_STAR_STAR] = ACTIONS(1345),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(5817),
    [anon_sym_unless] = ACTIONS(5817),
    [anon_sym_while] = ACTIONS(5817),
    [anon_sym_until] = ACTIONS(5817),
    [anon_sym_rescue] = ACTIONS(5817),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_DOT_DOT] = ACTIONS(1355),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1357),
    [anon_sym_and] = ACTIONS(1359),
    [anon_sym_or] = ACTIONS(1359),
    [anon_sym_PIPE_PIPE] = ACTIONS(1361),
    [anon_sym_AMP_AMP] = ACTIONS(1361),
    [anon_sym_LT_LT] = ACTIONS(1363),
    [anon_sym_GT_GT] = ACTIONS(1363),
    [anon_sym_EQ_EQ] = ACTIONS(1365),
    [anon_sym_BANG_EQ] = ACTIONS(1361),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1361),
    [anon_sym_LT_EQ_GT] = ACTIONS(1361),
    [anon_sym_EQ_TILDE] = ACTIONS(1361),
    [anon_sym_BANG_TILDE] = ACTIONS(1361),
    [anon_sym_LT_EQ] = ACTIONS(1351),
    [anon_sym_GT] = ACTIONS(1351),
    [anon_sym_GT_EQ] = ACTIONS(1367),
    [anon_sym_CARET] = ACTIONS(1369),
    [anon_sym_PLUS] = ACTIONS(1343),
    [anon_sym_SLASH] = ACTIONS(1345),
    [anon_sym_PERCENT] = ACTIONS(1345),
    [sym_comment] = ACTIONS(87),
  },
  [2182] = {
    [sym__line_break] = ACTIONS(5819),
    [sym__heredoc_body_start] = ACTIONS(5819),
    [sym__binary_minus] = ACTIONS(1343),
    [sym__binary_star] = ACTIONS(1345),
    [anon_sym_RPAREN] = ACTIONS(5819),
    [anon_sym_PIPE] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(5819),
    [anon_sym_STAR_STAR] = ACTIONS(1345),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(5819),
    [anon_sym_unless] = ACTIONS(5819),
    [anon_sym_while] = ACTIONS(5819),
    [anon_sym_until] = ACTIONS(5819),
    [anon_sym_rescue] = ACTIONS(5819),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_DOT_DOT] = ACTIONS(1355),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1357),
    [anon_sym_and] = ACTIONS(1359),
    [anon_sym_or] = ACTIONS(1359),
    [anon_sym_PIPE_PIPE] = ACTIONS(1361),
    [anon_sym_AMP_AMP] = ACTIONS(1361),
    [anon_sym_LT_LT] = ACTIONS(1363),
    [anon_sym_GT_GT] = ACTIONS(1363),
    [anon_sym_EQ_EQ] = ACTIONS(1365),
    [anon_sym_BANG_EQ] = ACTIONS(1361),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1361),
    [anon_sym_LT_EQ_GT] = ACTIONS(1361),
    [anon_sym_EQ_TILDE] = ACTIONS(1361),
    [anon_sym_BANG_TILDE] = ACTIONS(1361),
    [anon_sym_LT_EQ] = ACTIONS(1351),
    [anon_sym_GT] = ACTIONS(1351),
    [anon_sym_GT_EQ] = ACTIONS(1367),
    [anon_sym_CARET] = ACTIONS(1369),
    [anon_sym_PLUS] = ACTIONS(1343),
    [anon_sym_SLASH] = ACTIONS(1345),
    [anon_sym_PERCENT] = ACTIONS(1345),
    [sym_comment] = ACTIONS(87),
  },
  [2183] = {
    [sym__line_break] = ACTIONS(5821),
    [sym__heredoc_body_start] = ACTIONS(5821),
    [sym__binary_minus] = ACTIONS(1343),
    [sym__binary_star] = ACTIONS(1345),
    [anon_sym_RPAREN] = ACTIONS(5821),
    [anon_sym_PIPE] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(5821),
    [anon_sym_STAR_STAR] = ACTIONS(1345),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(5821),
    [anon_sym_unless] = ACTIONS(5821),
    [anon_sym_while] = ACTIONS(5821),
    [anon_sym_until] = ACTIONS(5821),
    [anon_sym_rescue] = ACTIONS(5821),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_DOT_DOT] = ACTIONS(1355),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1357),
    [anon_sym_and] = ACTIONS(1359),
    [anon_sym_or] = ACTIONS(1359),
    [anon_sym_PIPE_PIPE] = ACTIONS(1361),
    [anon_sym_AMP_AMP] = ACTIONS(1361),
    [anon_sym_LT_LT] = ACTIONS(1363),
    [anon_sym_GT_GT] = ACTIONS(1363),
    [anon_sym_EQ_EQ] = ACTIONS(1365),
    [anon_sym_BANG_EQ] = ACTIONS(1361),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1361),
    [anon_sym_LT_EQ_GT] = ACTIONS(1361),
    [anon_sym_EQ_TILDE] = ACTIONS(1361),
    [anon_sym_BANG_TILDE] = ACTIONS(1361),
    [anon_sym_LT_EQ] = ACTIONS(1351),
    [anon_sym_GT] = ACTIONS(1351),
    [anon_sym_GT_EQ] = ACTIONS(1367),
    [anon_sym_CARET] = ACTIONS(1369),
    [anon_sym_PLUS] = ACTIONS(1343),
    [anon_sym_SLASH] = ACTIONS(1345),
    [anon_sym_PERCENT] = ACTIONS(1345),
    [sym_comment] = ACTIONS(87),
  },
  [2184] = {
    [sym__line_break] = ACTIONS(5823),
    [sym__heredoc_body_start] = ACTIONS(5823),
    [sym__binary_minus] = ACTIONS(1343),
    [sym__binary_star] = ACTIONS(1345),
    [anon_sym_RPAREN] = ACTIONS(5823),
    [anon_sym_PIPE] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(5823),
    [anon_sym_STAR_STAR] = ACTIONS(1345),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(5823),
    [anon_sym_unless] = ACTIONS(5823),
    [anon_sym_while] = ACTIONS(5823),
    [anon_sym_until] = ACTIONS(5823),
    [anon_sym_rescue] = ACTIONS(5823),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_DOT_DOT] = ACTIONS(1355),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1357),
    [anon_sym_and] = ACTIONS(1359),
    [anon_sym_or] = ACTIONS(1359),
    [anon_sym_PIPE_PIPE] = ACTIONS(1361),
    [anon_sym_AMP_AMP] = ACTIONS(1361),
    [anon_sym_LT_LT] = ACTIONS(1363),
    [anon_sym_GT_GT] = ACTIONS(1363),
    [anon_sym_EQ_EQ] = ACTIONS(1365),
    [anon_sym_BANG_EQ] = ACTIONS(1361),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1361),
    [anon_sym_LT_EQ_GT] = ACTIONS(1361),
    [anon_sym_EQ_TILDE] = ACTIONS(1361),
    [anon_sym_BANG_TILDE] = ACTIONS(1361),
    [anon_sym_LT_EQ] = ACTIONS(1351),
    [anon_sym_GT] = ACTIONS(1351),
    [anon_sym_GT_EQ] = ACTIONS(1367),
    [anon_sym_CARET] = ACTIONS(1369),
    [anon_sym_PLUS] = ACTIONS(1343),
    [anon_sym_SLASH] = ACTIONS(1345),
    [anon_sym_PERCENT] = ACTIONS(1345),
    [sym_comment] = ACTIONS(87),
  },
  [2185] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(1345),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(1345),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(1345),
    [anon_sym_PERCENT] = ACTIONS(1345),
    [sym_comment] = ACTIONS(87),
  },
  [2186] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(1345),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [2187] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(1343),
    [sym__binary_star] = ACTIONS(1345),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(1345),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(1363),
    [anon_sym_GT_GT] = ACTIONS(1363),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(1343),
    [anon_sym_SLASH] = ACTIONS(1345),
    [anon_sym_PERCENT] = ACTIONS(1345),
    [sym_comment] = ACTIONS(87),
  },
  [2188] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(1343),
    [sym__binary_star] = ACTIONS(1345),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(1345),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(1363),
    [anon_sym_GT_GT] = ACTIONS(1363),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(1343),
    [anon_sym_SLASH] = ACTIONS(1345),
    [anon_sym_PERCENT] = ACTIONS(1345),
    [sym_comment] = ACTIONS(87),
  },
  [2189] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(1343),
    [sym__binary_star] = ACTIONS(1345),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(1345),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(1363),
    [anon_sym_GT_GT] = ACTIONS(1363),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(1369),
    [anon_sym_PLUS] = ACTIONS(1343),
    [anon_sym_SLASH] = ACTIONS(1345),
    [anon_sym_PERCENT] = ACTIONS(1345),
    [sym_comment] = ACTIONS(87),
  },
  [2190] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(7456),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [2191] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(1343),
    [sym__binary_star] = ACTIONS(1345),
    [anon_sym_RPAREN] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(1345),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(1355),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1357),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(1361),
    [anon_sym_AMP_AMP] = ACTIONS(1361),
    [anon_sym_LT_LT] = ACTIONS(1363),
    [anon_sym_GT_GT] = ACTIONS(1363),
    [anon_sym_EQ_EQ] = ACTIONS(1365),
    [anon_sym_BANG_EQ] = ACTIONS(1361),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1361),
    [anon_sym_LT_EQ_GT] = ACTIONS(1361),
    [anon_sym_EQ_TILDE] = ACTIONS(1361),
    [anon_sym_BANG_TILDE] = ACTIONS(1361),
    [anon_sym_LT_EQ] = ACTIONS(1351),
    [anon_sym_GT] = ACTIONS(1351),
    [anon_sym_GT_EQ] = ACTIONS(1367),
    [anon_sym_CARET] = ACTIONS(1369),
    [anon_sym_PLUS] = ACTIONS(1343),
    [anon_sym_SLASH] = ACTIONS(1345),
    [anon_sym_PERCENT] = ACTIONS(1345),
    [sym_comment] = ACTIONS(87),
  },
  [2192] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(1343),
    [sym__binary_star] = ACTIONS(1345),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(1345),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_DOT_DOT] = ACTIONS(1355),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1357),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(1361),
    [anon_sym_AMP_AMP] = ACTIONS(1361),
    [anon_sym_LT_LT] = ACTIONS(1363),
    [anon_sym_GT_GT] = ACTIONS(1363),
    [anon_sym_EQ_EQ] = ACTIONS(1365),
    [anon_sym_BANG_EQ] = ACTIONS(1361),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1361),
    [anon_sym_LT_EQ_GT] = ACTIONS(1361),
    [anon_sym_EQ_TILDE] = ACTIONS(1361),
    [anon_sym_BANG_TILDE] = ACTIONS(1361),
    [anon_sym_LT_EQ] = ACTIONS(1351),
    [anon_sym_GT] = ACTIONS(1351),
    [anon_sym_GT_EQ] = ACTIONS(1367),
    [anon_sym_CARET] = ACTIONS(1369),
    [anon_sym_PLUS] = ACTIONS(1343),
    [anon_sym_SLASH] = ACTIONS(1345),
    [anon_sym_PERCENT] = ACTIONS(1345),
    [sym_comment] = ACTIONS(87),
  },
  [2193] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(1343),
    [sym__binary_star] = ACTIONS(1345),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(1345),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(1363),
    [anon_sym_GT_GT] = ACTIONS(1363),
    [anon_sym_EQ_EQ] = ACTIONS(1365),
    [anon_sym_BANG_EQ] = ACTIONS(1361),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1361),
    [anon_sym_LT_EQ_GT] = ACTIONS(1361),
    [anon_sym_EQ_TILDE] = ACTIONS(1361),
    [anon_sym_BANG_TILDE] = ACTIONS(1361),
    [anon_sym_LT_EQ] = ACTIONS(1351),
    [anon_sym_GT] = ACTIONS(1351),
    [anon_sym_GT_EQ] = ACTIONS(1367),
    [anon_sym_CARET] = ACTIONS(1369),
    [anon_sym_PLUS] = ACTIONS(1343),
    [anon_sym_SLASH] = ACTIONS(1345),
    [anon_sym_PERCENT] = ACTIONS(1345),
    [sym_comment] = ACTIONS(87),
  },
  [2194] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(1343),
    [sym__binary_star] = ACTIONS(1345),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(1345),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(1343),
    [anon_sym_SLASH] = ACTIONS(1345),
    [anon_sym_PERCENT] = ACTIONS(1345),
    [sym_comment] = ACTIONS(87),
  },
  [2195] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(4584),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2205),
    [sym_scope_resolution] = STATE(2203),
    [sym_call] = STATE(2203),
    [sym_method_call] = STATE(2205),
    [sym_assignment] = STATE(4584),
    [sym_operator_assignment] = STATE(4584),
    [sym_conditional] = STATE(4584),
    [sym_range] = STATE(4584),
    [sym_binary] = STATE(4584),
    [sym_unary] = STATE(4584),
    [sym_left_assignment_list] = STATE(2204),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2205),
    [sym__variable] = STATE(2203),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2205),
    [sym_false] = STATE(2205),
    [sym_nil] = STATE(2205),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2206),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(3809),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(3811),
    [anon_sym_yield] = ACTIONS(3813),
    [anon_sym_break] = ACTIONS(3815),
    [anon_sym_next] = ACTIONS(3817),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(3819),
    [anon_sym_defined_QMARK] = ACTIONS(3821),
    [anon_sym_not] = ACTIONS(3823),
    [anon_sym_BANG] = ACTIONS(3825),
    [anon_sym_TILDE] = ACTIONS(3825),
    [sym_constant] = ACTIONS(3827),
    [sym_identifier] = ACTIONS(3827),
    [sym_instance_variable] = ACTIONS(3829),
    [sym_class_variable] = ACTIONS(3829),
    [sym_global_variable] = ACTIONS(3829),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(3827),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3827),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [2196] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(737),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(742),
    [sym_scope_resolution] = STATE(738),
    [sym_call] = STATE(738),
    [sym_method_call] = STATE(742),
    [sym_argument_list] = STATE(3610),
    [sym__argument_list_with_parens] = STATE(739),
    [sym__argument] = STATE(740),
    [sym_splat_argument] = STATE(740),
    [sym_hash_splat_argument] = STATE(740),
    [sym_block_argument] = STATE(740),
    [sym_assignment] = STATE(737),
    [sym_operator_assignment] = STATE(737),
    [sym_conditional] = STATE(737),
    [sym_range] = STATE(737),
    [sym_binary] = STATE(737),
    [sym_unary] = STATE(737),
    [sym_left_assignment_list] = STATE(741),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(742),
    [sym__variable] = STATE(738),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(742),
    [sym_false] = STATE(742),
    [sym_nil] = STATE(742),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(743),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(740),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(1371),
    [sym__splat_star] = ACTIONS(1373),
    [sym__unary_minus] = ACTIONS(1375),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_RPAREN] = ACTIONS(365),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1381),
    [anon_sym_break] = ACTIONS(1383),
    [anon_sym_next] = ACTIONS(1385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(365),
    [anon_sym_DASH_EQ] = ACTIONS(365),
    [anon_sym_STAR_EQ] = ACTIONS(365),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(365),
    [anon_sym_SLASH_EQ] = ACTIONS(365),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(365),
    [anon_sym_PIPE_EQ] = ACTIONS(365),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(365),
    [anon_sym_AMP_EQ] = ACTIONS(365),
    [anon_sym_PERCENT_EQ] = ACTIONS(365),
    [anon_sym_GT_GT_EQ] = ACTIONS(365),
    [anon_sym_LT_LT_EQ] = ACTIONS(365),
    [anon_sym_CARET_EQ] = ACTIONS(365),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_PERCENT] = ACTIONS(377),
    [anon_sym_defined_QMARK] = ACTIONS(1387),
    [anon_sym_not] = ACTIONS(1389),
    [anon_sym_BANG] = ACTIONS(1391),
    [anon_sym_TILDE] = ACTIONS(1393),
    [sym_constant] = ACTIONS(1395),
    [sym_identifier] = ACTIONS(1395),
    [sym_instance_variable] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1397),
    [sym_global_variable] = ACTIONS(1397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2197] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(737),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(742),
    [sym_scope_resolution] = STATE(738),
    [sym_call] = STATE(738),
    [sym_method_call] = STATE(742),
    [sym_argument_list] = STATE(3611),
    [sym__argument_list_with_parens] = STATE(739),
    [sym__argument] = STATE(740),
    [sym_splat_argument] = STATE(740),
    [sym_hash_splat_argument] = STATE(740),
    [sym_block_argument] = STATE(740),
    [sym_assignment] = STATE(737),
    [sym_operator_assignment] = STATE(737),
    [sym_conditional] = STATE(737),
    [sym_range] = STATE(737),
    [sym_binary] = STATE(737),
    [sym_unary] = STATE(737),
    [sym_left_assignment_list] = STATE(741),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(742),
    [sym__variable] = STATE(738),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(742),
    [sym_false] = STATE(742),
    [sym_nil] = STATE(742),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(743),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(740),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(1371),
    [sym__splat_star] = ACTIONS(1373),
    [sym__unary_minus] = ACTIONS(1375),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_RPAREN] = ACTIONS(417),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_EQ] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1381),
    [anon_sym_break] = ACTIONS(1383),
    [anon_sym_next] = ACTIONS(1385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(417),
    [anon_sym_DASH_EQ] = ACTIONS(417),
    [anon_sym_STAR_EQ] = ACTIONS(417),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(417),
    [anon_sym_SLASH_EQ] = ACTIONS(417),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(417),
    [anon_sym_PIPE_EQ] = ACTIONS(417),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(417),
    [anon_sym_AMP_EQ] = ACTIONS(417),
    [anon_sym_PERCENT_EQ] = ACTIONS(417),
    [anon_sym_GT_GT_EQ] = ACTIONS(417),
    [anon_sym_LT_LT_EQ] = ACTIONS(417),
    [anon_sym_CARET_EQ] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(1387),
    [anon_sym_not] = ACTIONS(1389),
    [anon_sym_BANG] = ACTIONS(1391),
    [anon_sym_TILDE] = ACTIONS(1393),
    [sym_constant] = ACTIONS(1395),
    [sym_identifier] = ACTIONS(1395),
    [sym_instance_variable] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1397),
    [sym_global_variable] = ACTIONS(1397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2198] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(737),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(742),
    [sym_scope_resolution] = STATE(738),
    [sym_call] = STATE(738),
    [sym_method_call] = STATE(742),
    [sym_argument_list] = STATE(3612),
    [sym__argument_list_with_parens] = STATE(739),
    [sym__argument] = STATE(740),
    [sym_splat_argument] = STATE(740),
    [sym_hash_splat_argument] = STATE(740),
    [sym_block_argument] = STATE(740),
    [sym_assignment] = STATE(737),
    [sym_operator_assignment] = STATE(737),
    [sym_conditional] = STATE(737),
    [sym_range] = STATE(737),
    [sym_binary] = STATE(737),
    [sym_unary] = STATE(737),
    [sym_left_assignment_list] = STATE(741),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(742),
    [sym__variable] = STATE(738),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(742),
    [sym_false] = STATE(742),
    [sym_nil] = STATE(742),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(743),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(740),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(1371),
    [sym__splat_star] = ACTIONS(1373),
    [sym__unary_minus] = ACTIONS(1375),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_RPAREN] = ACTIONS(421),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_EQ] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1381),
    [anon_sym_break] = ACTIONS(1383),
    [anon_sym_next] = ACTIONS(1385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(421),
    [anon_sym_DASH_EQ] = ACTIONS(421),
    [anon_sym_STAR_EQ] = ACTIONS(421),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(421),
    [anon_sym_SLASH_EQ] = ACTIONS(421),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(421),
    [anon_sym_PIPE_EQ] = ACTIONS(421),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(421),
    [anon_sym_AMP_EQ] = ACTIONS(421),
    [anon_sym_PERCENT_EQ] = ACTIONS(421),
    [anon_sym_GT_GT_EQ] = ACTIONS(421),
    [anon_sym_LT_LT_EQ] = ACTIONS(421),
    [anon_sym_CARET_EQ] = ACTIONS(421),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(1387),
    [anon_sym_not] = ACTIONS(1389),
    [anon_sym_BANG] = ACTIONS(1391),
    [anon_sym_TILDE] = ACTIONS(1393),
    [sym_constant] = ACTIONS(1395),
    [sym_identifier] = ACTIONS(1395),
    [sym_instance_variable] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1397),
    [sym_global_variable] = ACTIONS(1397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2199] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(737),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(742),
    [sym_scope_resolution] = STATE(738),
    [sym_call] = STATE(738),
    [sym_method_call] = STATE(742),
    [sym_argument_list] = STATE(3613),
    [sym__argument_list_with_parens] = STATE(739),
    [sym__argument] = STATE(740),
    [sym_splat_argument] = STATE(740),
    [sym_hash_splat_argument] = STATE(740),
    [sym_block_argument] = STATE(740),
    [sym_assignment] = STATE(737),
    [sym_operator_assignment] = STATE(737),
    [sym_conditional] = STATE(737),
    [sym_range] = STATE(737),
    [sym_binary] = STATE(737),
    [sym_unary] = STATE(737),
    [sym_left_assignment_list] = STATE(741),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(742),
    [sym__variable] = STATE(738),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(742),
    [sym_false] = STATE(742),
    [sym_nil] = STATE(742),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(743),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(740),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(1371),
    [sym__splat_star] = ACTIONS(1373),
    [sym__unary_minus] = ACTIONS(1375),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_RPAREN] = ACTIONS(425),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(427),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1381),
    [anon_sym_break] = ACTIONS(1383),
    [anon_sym_next] = ACTIONS(1385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(425),
    [anon_sym_DASH_EQ] = ACTIONS(425),
    [anon_sym_STAR_EQ] = ACTIONS(425),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(425),
    [anon_sym_SLASH_EQ] = ACTIONS(425),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(425),
    [anon_sym_PIPE_EQ] = ACTIONS(425),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(425),
    [anon_sym_AMP_EQ] = ACTIONS(425),
    [anon_sym_PERCENT_EQ] = ACTIONS(425),
    [anon_sym_GT_GT_EQ] = ACTIONS(425),
    [anon_sym_LT_LT_EQ] = ACTIONS(425),
    [anon_sym_CARET_EQ] = ACTIONS(425),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(1387),
    [anon_sym_not] = ACTIONS(1389),
    [anon_sym_BANG] = ACTIONS(1391),
    [anon_sym_TILDE] = ACTIONS(1393),
    [sym_constant] = ACTIONS(1395),
    [sym_identifier] = ACTIONS(1395),
    [sym_instance_variable] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1397),
    [sym_global_variable] = ACTIONS(1397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2200] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(4585),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2205),
    [sym_scope_resolution] = STATE(2203),
    [sym_call] = STATE(2203),
    [sym_method_call] = STATE(2205),
    [sym_assignment] = STATE(4585),
    [sym_operator_assignment] = STATE(4585),
    [sym_conditional] = STATE(4585),
    [sym_range] = STATE(4585),
    [sym_binary] = STATE(4585),
    [sym_unary] = STATE(4585),
    [sym_left_assignment_list] = STATE(2204),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2205),
    [sym__variable] = STATE(2203),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2205),
    [sym_false] = STATE(2205),
    [sym_nil] = STATE(2205),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2206),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(3809),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(3811),
    [anon_sym_yield] = ACTIONS(3813),
    [anon_sym_break] = ACTIONS(3815),
    [anon_sym_next] = ACTIONS(3817),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(3819),
    [anon_sym_defined_QMARK] = ACTIONS(3821),
    [anon_sym_not] = ACTIONS(3823),
    [anon_sym_BANG] = ACTIONS(3825),
    [anon_sym_TILDE] = ACTIONS(3825),
    [sym_constant] = ACTIONS(3827),
    [sym_identifier] = ACTIONS(3827),
    [sym_instance_variable] = ACTIONS(3829),
    [sym_class_variable] = ACTIONS(3829),
    [sym_global_variable] = ACTIONS(3829),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(3827),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3827),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [2201] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(3628),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2205),
    [sym_scope_resolution] = STATE(2203),
    [sym_call] = STATE(2203),
    [sym_method_call] = STATE(2205),
    [sym_assignment] = STATE(3628),
    [sym_operator_assignment] = STATE(3628),
    [sym_conditional] = STATE(3628),
    [sym_range] = STATE(3628),
    [sym_binary] = STATE(3628),
    [sym_unary] = STATE(3628),
    [sym_left_assignment_list] = STATE(2204),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2205),
    [sym__variable] = STATE(2203),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2205),
    [sym_false] = STATE(2205),
    [sym_nil] = STATE(2205),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2206),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(3809),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(3811),
    [anon_sym_yield] = ACTIONS(3813),
    [anon_sym_break] = ACTIONS(3815),
    [anon_sym_next] = ACTIONS(3817),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(3819),
    [anon_sym_defined_QMARK] = ACTIONS(3821),
    [anon_sym_not] = ACTIONS(3823),
    [anon_sym_BANG] = ACTIONS(3825),
    [anon_sym_TILDE] = ACTIONS(3825),
    [sym_constant] = ACTIONS(3827),
    [sym_identifier] = ACTIONS(3827),
    [sym_instance_variable] = ACTIONS(3829),
    [sym_class_variable] = ACTIONS(3829),
    [sym_global_variable] = ACTIONS(3829),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(3827),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3827),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [2202] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(7458),
    [sym__binary_star] = ACTIONS(7460),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_RPAREN] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(7462),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(7464),
    [anon_sym_AMP] = ACTIONS(7466),
    [anon_sym_EQ] = ACTIONS(4217),
    [anon_sym_LT] = ACTIONS(7468),
    [anon_sym_if] = ACTIONS(4211),
    [anon_sym_unless] = ACTIONS(4211),
    [anon_sym_while] = ACTIONS(4211),
    [anon_sym_until] = ACTIONS(4211),
    [anon_sym_rescue] = ACTIONS(4211),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_PLUS_EQ] = ACTIONS(4211),
    [anon_sym_DASH_EQ] = ACTIONS(4211),
    [anon_sym_STAR_EQ] = ACTIONS(4211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4211),
    [anon_sym_SLASH_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4211),
    [anon_sym_AMP_EQ] = ACTIONS(4211),
    [anon_sym_PERCENT_EQ] = ACTIONS(4211),
    [anon_sym_GT_GT_EQ] = ACTIONS(4211),
    [anon_sym_LT_LT_EQ] = ACTIONS(4211),
    [anon_sym_CARET_EQ] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(7470),
    [anon_sym_DOT_DOT] = ACTIONS(7472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7474),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(7476),
    [anon_sym_AMP_AMP] = ACTIONS(7476),
    [anon_sym_LT_LT] = ACTIONS(7478),
    [anon_sym_GT_GT] = ACTIONS(7478),
    [anon_sym_EQ_EQ] = ACTIONS(7476),
    [anon_sym_BANG_EQ] = ACTIONS(7480),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7480),
    [anon_sym_LT_EQ_GT] = ACTIONS(7480),
    [anon_sym_EQ_TILDE] = ACTIONS(7480),
    [anon_sym_BANG_TILDE] = ACTIONS(7480),
    [anon_sym_LT_EQ] = ACTIONS(7468),
    [anon_sym_GT] = ACTIONS(7468),
    [anon_sym_GT_EQ] = ACTIONS(7482),
    [anon_sym_CARET] = ACTIONS(7462),
    [anon_sym_PLUS] = ACTIONS(7484),
    [anon_sym_SLASH] = ACTIONS(7464),
    [anon_sym_PERCENT] = ACTIONS(7464),
    [sym_comment] = ACTIONS(87),
  },
  [2203] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(737),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(742),
    [sym_scope_resolution] = STATE(738),
    [sym_call] = STATE(738),
    [sym_method_call] = STATE(742),
    [sym_argument_list] = STATE(1062),
    [sym__argument_list_with_parens] = STATE(739),
    [sym__argument] = STATE(740),
    [sym_splat_argument] = STATE(740),
    [sym_hash_splat_argument] = STATE(740),
    [sym_block_argument] = STATE(740),
    [sym_do_block] = STATE(426),
    [sym_block] = STATE(426),
    [sym_assignment] = STATE(737),
    [sym_operator_assignment] = STATE(737),
    [sym_conditional] = STATE(737),
    [sym_range] = STATE(737),
    [sym_binary] = STATE(737),
    [sym_unary] = STATE(737),
    [sym_left_assignment_list] = STATE(741),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(742),
    [sym__variable] = STATE(738),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(742),
    [sym_false] = STATE(742),
    [sym_nil] = STATE(742),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(743),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(740),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(743),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(1371),
    [sym__splat_star] = ACTIONS(1373),
    [sym__unary_minus] = ACTIONS(1375),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(6047),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1381),
    [anon_sym_break] = ACTIONS(1383),
    [anon_sym_next] = ACTIONS(1385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(769),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(769),
    [anon_sym_until] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(769),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(769),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(1387),
    [anon_sym_not] = ACTIONS(1389),
    [anon_sym_BANG] = ACTIONS(1391),
    [anon_sym_TILDE] = ACTIONS(1393),
    [sym_constant] = ACTIONS(1395),
    [sym_identifier] = ACTIONS(1395),
    [sym_instance_variable] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1397),
    [sym_global_variable] = ACTIONS(1397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2204] = {
    [anon_sym_EQ] = ACTIONS(7486),
    [sym_comment] = ACTIONS(87),
  },
  [2205] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(7488),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(7490),
    [anon_sym_DASH_EQ] = ACTIONS(7490),
    [anon_sym_STAR_EQ] = ACTIONS(7490),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7490),
    [anon_sym_SLASH_EQ] = ACTIONS(7490),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7490),
    [anon_sym_PIPE_EQ] = ACTIONS(7490),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7490),
    [anon_sym_AMP_EQ] = ACTIONS(7490),
    [anon_sym_PERCENT_EQ] = ACTIONS(7490),
    [anon_sym_GT_GT_EQ] = ACTIONS(7490),
    [anon_sym_LT_LT_EQ] = ACTIONS(7490),
    [anon_sym_CARET_EQ] = ACTIONS(7490),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2206] = {
    [sym_string] = STATE(4598),
    [aux_sym_chained_string_repeat1] = STATE(4598),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(2551),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2207] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(7458),
    [sym__binary_star] = ACTIONS(7460),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_RPAREN] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(7462),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(7464),
    [anon_sym_AMP] = ACTIONS(7466),
    [anon_sym_EQ] = ACTIONS(4249),
    [anon_sym_LT] = ACTIONS(7468),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_PLUS_EQ] = ACTIONS(4247),
    [anon_sym_DASH_EQ] = ACTIONS(4247),
    [anon_sym_STAR_EQ] = ACTIONS(4247),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4247),
    [anon_sym_SLASH_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4247),
    [anon_sym_AMP_EQ] = ACTIONS(4247),
    [anon_sym_PERCENT_EQ] = ACTIONS(4247),
    [anon_sym_GT_GT_EQ] = ACTIONS(4247),
    [anon_sym_LT_LT_EQ] = ACTIONS(4247),
    [anon_sym_CARET_EQ] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(7470),
    [anon_sym_DOT_DOT] = ACTIONS(7472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7474),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(7476),
    [anon_sym_AMP_AMP] = ACTIONS(7476),
    [anon_sym_LT_LT] = ACTIONS(7478),
    [anon_sym_GT_GT] = ACTIONS(7478),
    [anon_sym_EQ_EQ] = ACTIONS(7476),
    [anon_sym_BANG_EQ] = ACTIONS(7480),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7480),
    [anon_sym_LT_EQ_GT] = ACTIONS(7480),
    [anon_sym_EQ_TILDE] = ACTIONS(7480),
    [anon_sym_BANG_TILDE] = ACTIONS(7480),
    [anon_sym_LT_EQ] = ACTIONS(7468),
    [anon_sym_GT] = ACTIONS(7468),
    [anon_sym_GT_EQ] = ACTIONS(7482),
    [anon_sym_CARET] = ACTIONS(7462),
    [anon_sym_PLUS] = ACTIONS(7484),
    [anon_sym_SLASH] = ACTIONS(7464),
    [anon_sym_PERCENT] = ACTIONS(7464),
    [sym_comment] = ACTIONS(87),
  },
  [2208] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(3843),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [2209] = {
    [sym_string] = STATE(2229),
    [aux_sym_chained_string_repeat1] = STATE(2229),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(747),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2210] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(4599),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2205),
    [sym_scope_resolution] = STATE(2203),
    [sym_call] = STATE(2203),
    [sym_method_call] = STATE(2205),
    [sym_assignment] = STATE(4599),
    [sym_operator_assignment] = STATE(4599),
    [sym_conditional] = STATE(4599),
    [sym_range] = STATE(4599),
    [sym_binary] = STATE(4599),
    [sym_unary] = STATE(4599),
    [sym_left_assignment_list] = STATE(2204),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2205),
    [sym__variable] = STATE(2203),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2205),
    [sym_false] = STATE(2205),
    [sym_nil] = STATE(2205),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2206),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(3809),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(3811),
    [anon_sym_yield] = ACTIONS(3813),
    [anon_sym_break] = ACTIONS(3815),
    [anon_sym_next] = ACTIONS(3817),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(3819),
    [anon_sym_defined_QMARK] = ACTIONS(3821),
    [anon_sym_not] = ACTIONS(3823),
    [anon_sym_BANG] = ACTIONS(3825),
    [anon_sym_TILDE] = ACTIONS(3825),
    [sym_constant] = ACTIONS(3827),
    [sym_identifier] = ACTIONS(3827),
    [sym_instance_variable] = ACTIONS(3829),
    [sym_class_variable] = ACTIONS(3829),
    [sym_global_variable] = ACTIONS(3829),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(3827),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3827),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [2211] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(7458),
    [sym__binary_star] = ACTIONS(7460),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_RPAREN] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(7462),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(7464),
    [anon_sym_AMP] = ACTIONS(7466),
    [anon_sym_EQ] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(7468),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_unless] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_until] = ACTIONS(3281),
    [anon_sym_rescue] = ACTIONS(3281),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_PLUS_EQ] = ACTIONS(3281),
    [anon_sym_DASH_EQ] = ACTIONS(3281),
    [anon_sym_STAR_EQ] = ACTIONS(3281),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3281),
    [anon_sym_SLASH_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3281),
    [anon_sym_AMP_EQ] = ACTIONS(3281),
    [anon_sym_PERCENT_EQ] = ACTIONS(3281),
    [anon_sym_GT_GT_EQ] = ACTIONS(3281),
    [anon_sym_LT_LT_EQ] = ACTIONS(3281),
    [anon_sym_CARET_EQ] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(7470),
    [anon_sym_DOT_DOT] = ACTIONS(7472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7474),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(7476),
    [anon_sym_AMP_AMP] = ACTIONS(7476),
    [anon_sym_LT_LT] = ACTIONS(7478),
    [anon_sym_GT_GT] = ACTIONS(7478),
    [anon_sym_EQ_EQ] = ACTIONS(7476),
    [anon_sym_BANG_EQ] = ACTIONS(7480),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7480),
    [anon_sym_LT_EQ_GT] = ACTIONS(7480),
    [anon_sym_EQ_TILDE] = ACTIONS(7480),
    [anon_sym_BANG_TILDE] = ACTIONS(7480),
    [anon_sym_LT_EQ] = ACTIONS(7468),
    [anon_sym_GT] = ACTIONS(7468),
    [anon_sym_GT_EQ] = ACTIONS(7482),
    [anon_sym_CARET] = ACTIONS(7462),
    [anon_sym_PLUS] = ACTIONS(7484),
    [anon_sym_SLASH] = ACTIONS(7464),
    [anon_sym_PERCENT] = ACTIONS(7464),
    [sym_comment] = ACTIONS(87),
  },
  [2212] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(3837),
    [sym__binary_star] = ACTIONS(3839),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(3841),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(3843),
    [anon_sym_AMP] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(3847),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(3849),
    [anon_sym_DOT_DOT] = ACTIONS(3851),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3853),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(3855),
    [anon_sym_AMP_AMP] = ACTIONS(3855),
    [anon_sym_LT_LT] = ACTIONS(3857),
    [anon_sym_GT_GT] = ACTIONS(3857),
    [anon_sym_EQ_EQ] = ACTIONS(3855),
    [anon_sym_BANG_EQ] = ACTIONS(3859),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3859),
    [anon_sym_LT_EQ_GT] = ACTIONS(3859),
    [anon_sym_EQ_TILDE] = ACTIONS(3859),
    [anon_sym_BANG_TILDE] = ACTIONS(3859),
    [anon_sym_LT_EQ] = ACTIONS(3847),
    [anon_sym_GT] = ACTIONS(3847),
    [anon_sym_GT_EQ] = ACTIONS(3861),
    [anon_sym_CARET] = ACTIONS(3841),
    [anon_sym_PLUS] = ACTIONS(3863),
    [anon_sym_SLASH] = ACTIONS(3843),
    [anon_sym_PERCENT] = ACTIONS(3843),
    [sym_comment] = ACTIONS(87),
  },
  [2213] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(4600),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2205),
    [sym_scope_resolution] = STATE(2203),
    [sym_call] = STATE(2203),
    [sym_method_call] = STATE(2205),
    [sym_assignment] = STATE(4600),
    [sym_operator_assignment] = STATE(4600),
    [sym_conditional] = STATE(4600),
    [sym_range] = STATE(4600),
    [sym_binary] = STATE(4600),
    [sym_unary] = STATE(4600),
    [sym_left_assignment_list] = STATE(2204),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2205),
    [sym__variable] = STATE(2203),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2205),
    [sym_false] = STATE(2205),
    [sym_nil] = STATE(2205),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2206),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(3809),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(3811),
    [anon_sym_yield] = ACTIONS(3813),
    [anon_sym_break] = ACTIONS(3815),
    [anon_sym_next] = ACTIONS(3817),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(3819),
    [anon_sym_defined_QMARK] = ACTIONS(3821),
    [anon_sym_not] = ACTIONS(3823),
    [anon_sym_BANG] = ACTIONS(3825),
    [anon_sym_TILDE] = ACTIONS(3825),
    [sym_constant] = ACTIONS(3827),
    [sym_identifier] = ACTIONS(3827),
    [sym_instance_variable] = ACTIONS(3829),
    [sym_class_variable] = ACTIONS(3829),
    [sym_global_variable] = ACTIONS(3829),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(3827),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3827),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [2214] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(4601),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(742),
    [sym_scope_resolution] = STATE(738),
    [sym_call] = STATE(738),
    [sym_method_call] = STATE(742),
    [sym_assignment] = STATE(4601),
    [sym_operator_assignment] = STATE(4601),
    [sym_conditional] = STATE(4601),
    [sym_range] = STATE(4601),
    [sym_binary] = STATE(4601),
    [sym_unary] = STATE(4601),
    [sym_left_assignment_list] = STATE(741),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(742),
    [sym__variable] = STATE(738),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(742),
    [sym_false] = STATE(742),
    [sym_nil] = STATE(742),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2209),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1381),
    [anon_sym_break] = ACTIONS(1383),
    [anon_sym_next] = ACTIONS(1385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(3831),
    [anon_sym_defined_QMARK] = ACTIONS(1387),
    [anon_sym_not] = ACTIONS(1389),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_TILDE] = ACTIONS(1393),
    [sym_constant] = ACTIONS(1399),
    [sym_identifier] = ACTIONS(1399),
    [sym_instance_variable] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1397),
    [sym_global_variable] = ACTIONS(1397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2215] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(4602),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(742),
    [sym_scope_resolution] = STATE(738),
    [sym_call] = STATE(738),
    [sym_method_call] = STATE(742),
    [sym_assignment] = STATE(4602),
    [sym_operator_assignment] = STATE(4602),
    [sym_conditional] = STATE(4602),
    [sym_range] = STATE(4602),
    [sym_binary] = STATE(4602),
    [sym_unary] = STATE(4602),
    [sym_left_assignment_list] = STATE(741),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(742),
    [sym__variable] = STATE(738),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(742),
    [sym_false] = STATE(742),
    [sym_nil] = STATE(742),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2209),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1381),
    [anon_sym_break] = ACTIONS(1383),
    [anon_sym_next] = ACTIONS(1385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(3831),
    [anon_sym_defined_QMARK] = ACTIONS(1387),
    [anon_sym_not] = ACTIONS(1389),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_TILDE] = ACTIONS(1393),
    [sym_constant] = ACTIONS(1399),
    [sym_identifier] = ACTIONS(1399),
    [sym_instance_variable] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1397),
    [sym_global_variable] = ACTIONS(1397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2216] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(4603),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(742),
    [sym_scope_resolution] = STATE(738),
    [sym_call] = STATE(738),
    [sym_method_call] = STATE(742),
    [sym_assignment] = STATE(4603),
    [sym_operator_assignment] = STATE(4603),
    [sym_conditional] = STATE(4603),
    [sym_range] = STATE(4603),
    [sym_binary] = STATE(4603),
    [sym_unary] = STATE(4603),
    [sym_left_assignment_list] = STATE(741),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(742),
    [sym__variable] = STATE(738),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(742),
    [sym_false] = STATE(742),
    [sym_nil] = STATE(742),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2209),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1381),
    [anon_sym_break] = ACTIONS(1383),
    [anon_sym_next] = ACTIONS(1385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(3831),
    [anon_sym_defined_QMARK] = ACTIONS(1387),
    [anon_sym_not] = ACTIONS(1389),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_TILDE] = ACTIONS(1393),
    [sym_constant] = ACTIONS(1399),
    [sym_identifier] = ACTIONS(1399),
    [sym_instance_variable] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1397),
    [sym_global_variable] = ACTIONS(1397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2217] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(4604),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(742),
    [sym_scope_resolution] = STATE(738),
    [sym_call] = STATE(738),
    [sym_method_call] = STATE(742),
    [sym_assignment] = STATE(4604),
    [sym_operator_assignment] = STATE(4604),
    [sym_conditional] = STATE(4604),
    [sym_range] = STATE(4604),
    [sym_binary] = STATE(4604),
    [sym_unary] = STATE(4604),
    [sym_left_assignment_list] = STATE(741),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(742),
    [sym__variable] = STATE(738),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(742),
    [sym_false] = STATE(742),
    [sym_nil] = STATE(742),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2209),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1381),
    [anon_sym_break] = ACTIONS(1383),
    [anon_sym_next] = ACTIONS(1385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(3831),
    [anon_sym_defined_QMARK] = ACTIONS(1387),
    [anon_sym_not] = ACTIONS(1389),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_TILDE] = ACTIONS(1393),
    [sym_constant] = ACTIONS(1399),
    [sym_identifier] = ACTIONS(1399),
    [sym_instance_variable] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1397),
    [sym_global_variable] = ACTIONS(1397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2218] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(4605),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(742),
    [sym_scope_resolution] = STATE(738),
    [sym_call] = STATE(738),
    [sym_method_call] = STATE(742),
    [sym_assignment] = STATE(4605),
    [sym_operator_assignment] = STATE(4605),
    [sym_conditional] = STATE(4605),
    [sym_range] = STATE(4605),
    [sym_binary] = STATE(4605),
    [sym_unary] = STATE(4605),
    [sym_left_assignment_list] = STATE(741),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(742),
    [sym__variable] = STATE(738),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(742),
    [sym_false] = STATE(742),
    [sym_nil] = STATE(742),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2209),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1381),
    [anon_sym_break] = ACTIONS(1383),
    [anon_sym_next] = ACTIONS(1385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(3831),
    [anon_sym_defined_QMARK] = ACTIONS(1387),
    [anon_sym_not] = ACTIONS(1389),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_TILDE] = ACTIONS(1393),
    [sym_constant] = ACTIONS(1399),
    [sym_identifier] = ACTIONS(1399),
    [sym_instance_variable] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1397),
    [sym_global_variable] = ACTIONS(1397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2219] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(4606),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(4606),
    [sym_operator_assignment] = STATE(4606),
    [sym_conditional] = STATE(4606),
    [sym_range] = STATE(4606),
    [sym_binary] = STATE(4606),
    [sym_unary] = STATE(4606),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2220] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(4607),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(742),
    [sym_scope_resolution] = STATE(738),
    [sym_call] = STATE(738),
    [sym_method_call] = STATE(742),
    [sym_assignment] = STATE(4607),
    [sym_operator_assignment] = STATE(4607),
    [sym_conditional] = STATE(4607),
    [sym_range] = STATE(4607),
    [sym_binary] = STATE(4607),
    [sym_unary] = STATE(4607),
    [sym_left_assignment_list] = STATE(741),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(742),
    [sym__variable] = STATE(738),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(742),
    [sym_false] = STATE(742),
    [sym_nil] = STATE(742),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2209),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1381),
    [anon_sym_break] = ACTIONS(1383),
    [anon_sym_next] = ACTIONS(1385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(3831),
    [anon_sym_defined_QMARK] = ACTIONS(1387),
    [anon_sym_not] = ACTIONS(1389),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_TILDE] = ACTIONS(1393),
    [sym_constant] = ACTIONS(1399),
    [sym_identifier] = ACTIONS(1399),
    [sym_instance_variable] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1397),
    [sym_global_variable] = ACTIONS(1397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2221] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(4608),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(742),
    [sym_scope_resolution] = STATE(738),
    [sym_call] = STATE(738),
    [sym_method_call] = STATE(742),
    [sym_assignment] = STATE(4608),
    [sym_operator_assignment] = STATE(4608),
    [sym_conditional] = STATE(4608),
    [sym_range] = STATE(4608),
    [sym_binary] = STATE(4608),
    [sym_unary] = STATE(4608),
    [sym_left_assignment_list] = STATE(741),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(742),
    [sym__variable] = STATE(738),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(742),
    [sym_false] = STATE(742),
    [sym_nil] = STATE(742),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2209),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1381),
    [anon_sym_break] = ACTIONS(1383),
    [anon_sym_next] = ACTIONS(1385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(3831),
    [anon_sym_defined_QMARK] = ACTIONS(1387),
    [anon_sym_not] = ACTIONS(1389),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_TILDE] = ACTIONS(1393),
    [sym_constant] = ACTIONS(1399),
    [sym_identifier] = ACTIONS(1399),
    [sym_instance_variable] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1397),
    [sym_global_variable] = ACTIONS(1397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2222] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(4609),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(742),
    [sym_scope_resolution] = STATE(738),
    [sym_call] = STATE(738),
    [sym_method_call] = STATE(742),
    [sym_assignment] = STATE(4609),
    [sym_operator_assignment] = STATE(4609),
    [sym_conditional] = STATE(4609),
    [sym_range] = STATE(4609),
    [sym_binary] = STATE(4609),
    [sym_unary] = STATE(4609),
    [sym_left_assignment_list] = STATE(741),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(742),
    [sym__variable] = STATE(738),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(742),
    [sym_false] = STATE(742),
    [sym_nil] = STATE(742),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2209),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1381),
    [anon_sym_break] = ACTIONS(1383),
    [anon_sym_next] = ACTIONS(1385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(3831),
    [anon_sym_defined_QMARK] = ACTIONS(1387),
    [anon_sym_not] = ACTIONS(1389),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_TILDE] = ACTIONS(1393),
    [sym_constant] = ACTIONS(1399),
    [sym_identifier] = ACTIONS(1399),
    [sym_instance_variable] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1397),
    [sym_global_variable] = ACTIONS(1397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2223] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(4610),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(742),
    [sym_scope_resolution] = STATE(738),
    [sym_call] = STATE(738),
    [sym_method_call] = STATE(742),
    [sym_assignment] = STATE(4610),
    [sym_operator_assignment] = STATE(4610),
    [sym_conditional] = STATE(4610),
    [sym_range] = STATE(4610),
    [sym_binary] = STATE(4610),
    [sym_unary] = STATE(4610),
    [sym_left_assignment_list] = STATE(741),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(742),
    [sym__variable] = STATE(738),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(742),
    [sym_false] = STATE(742),
    [sym_nil] = STATE(742),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2209),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1381),
    [anon_sym_break] = ACTIONS(1383),
    [anon_sym_next] = ACTIONS(1385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(3831),
    [anon_sym_defined_QMARK] = ACTIONS(1387),
    [anon_sym_not] = ACTIONS(1389),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_TILDE] = ACTIONS(1393),
    [sym_constant] = ACTIONS(1399),
    [sym_identifier] = ACTIONS(1399),
    [sym_instance_variable] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1397),
    [sym_global_variable] = ACTIONS(1397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2224] = {
    [sym_heredoc_body] = STATE(4611),
    [aux_sym_call_repeat1] = STATE(4611),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_RPAREN] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [2225] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(737),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(742),
    [sym_scope_resolution] = STATE(738),
    [sym_call] = STATE(738),
    [sym_method_call] = STATE(742),
    [sym__argument] = STATE(3737),
    [sym_splat_argument] = STATE(3737),
    [sym_hash_splat_argument] = STATE(3737),
    [sym_block_argument] = STATE(3737),
    [sym_assignment] = STATE(737),
    [sym_operator_assignment] = STATE(737),
    [sym_conditional] = STATE(737),
    [sym_range] = STATE(737),
    [sym_binary] = STATE(737),
    [sym_unary] = STATE(737),
    [sym_left_assignment_list] = STATE(741),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(742),
    [sym__variable] = STATE(738),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(742),
    [sym_false] = STATE(742),
    [sym_nil] = STATE(742),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(743),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_heredoc_body] = STATE(4612),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(3737),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(1371),
    [sym__splat_star] = ACTIONS(1373),
    [sym__unary_minus] = ACTIONS(1375),
    [sym__identifier_hash_key] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(7492),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1381),
    [anon_sym_break] = ACTIONS(1383),
    [anon_sym_next] = ACTIONS(1385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(3831),
    [anon_sym_defined_QMARK] = ACTIONS(1387),
    [anon_sym_not] = ACTIONS(1389),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_TILDE] = ACTIONS(1393),
    [sym_constant] = ACTIONS(1395),
    [sym_identifier] = ACTIONS(1395),
    [sym_instance_variable] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1397),
    [sym_global_variable] = ACTIONS(1397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2226] = {
    [sym_heredoc_body] = STATE(4613),
    [aux_sym_call_repeat1] = STATE(4613),
    [aux_sym_argument_list_repeat1] = STATE(4614),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_RPAREN] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(3865),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [2227] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(4615),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(742),
    [sym_scope_resolution] = STATE(738),
    [sym_call] = STATE(738),
    [sym_method_call] = STATE(742),
    [sym_splat_argument] = STATE(4616),
    [sym_assignment] = STATE(4615),
    [sym_operator_assignment] = STATE(4615),
    [sym_conditional] = STATE(4615),
    [sym_range] = STATE(4615),
    [sym_binary] = STATE(4615),
    [sym_unary] = STATE(4615),
    [sym_right_assignment_list] = STATE(3742),
    [sym__arg_or_splat_arg] = STATE(4616),
    [sym_left_assignment_list] = STATE(741),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(742),
    [sym__variable] = STATE(738),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(742),
    [sym_false] = STATE(742),
    [sym_nil] = STATE(742),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2209),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__splat_star] = ACTIONS(3789),
    [sym__unary_minus] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1381),
    [anon_sym_break] = ACTIONS(1383),
    [anon_sym_next] = ACTIONS(1385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(3831),
    [anon_sym_defined_QMARK] = ACTIONS(1387),
    [anon_sym_not] = ACTIONS(1389),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_TILDE] = ACTIONS(1393),
    [sym_constant] = ACTIONS(1399),
    [sym_identifier] = ACTIONS(1399),
    [sym_instance_variable] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1397),
    [sym_global_variable] = ACTIONS(1397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2228] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(4617),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(742),
    [sym_scope_resolution] = STATE(738),
    [sym_call] = STATE(738),
    [sym_method_call] = STATE(742),
    [sym_assignment] = STATE(4617),
    [sym_operator_assignment] = STATE(4617),
    [sym_conditional] = STATE(4617),
    [sym_range] = STATE(4617),
    [sym_binary] = STATE(4617),
    [sym_unary] = STATE(4617),
    [sym_left_assignment_list] = STATE(741),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(742),
    [sym__variable] = STATE(738),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(742),
    [sym_false] = STATE(742),
    [sym_nil] = STATE(742),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2209),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1381),
    [anon_sym_break] = ACTIONS(1383),
    [anon_sym_next] = ACTIONS(1385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(3831),
    [anon_sym_defined_QMARK] = ACTIONS(1387),
    [anon_sym_not] = ACTIONS(1389),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_TILDE] = ACTIONS(1393),
    [sym_constant] = ACTIONS(1399),
    [sym_identifier] = ACTIONS(1399),
    [sym_instance_variable] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1397),
    [sym_global_variable] = ACTIONS(1397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2229] = {
    [sym_string] = STATE(4618),
    [aux_sym_chained_string_repeat1] = STATE(4618),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(747),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_RPAREN] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2755),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_EQ] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_EQ_GT] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_PLUS_EQ] = ACTIONS(2753),
    [anon_sym_DASH_EQ] = ACTIONS(2753),
    [anon_sym_STAR_EQ] = ACTIONS(2753),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2753),
    [anon_sym_SLASH_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2753),
    [anon_sym_AMP_EQ] = ACTIONS(2753),
    [anon_sym_PERCENT_EQ] = ACTIONS(2753),
    [anon_sym_GT_GT_EQ] = ACTIONS(2753),
    [anon_sym_LT_LT_EQ] = ACTIONS(2753),
    [anon_sym_CARET_EQ] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2755),
    [anon_sym_AMP_AMP] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2755),
    [anon_sym_GT_GT] = ACTIONS(2755),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_SLASH] = ACTIONS(2755),
    [anon_sym_PERCENT] = ACTIONS(2755),
    [sym_comment] = ACTIONS(87),
  },
  [2230] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(4619),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2237),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(2237),
    [sym_assignment] = STATE(4619),
    [sym_operator_assignment] = STATE(4619),
    [sym_conditional] = STATE(4619),
    [sym_range] = STATE(4619),
    [sym_binary] = STATE(4619),
    [sym_unary] = STATE(4619),
    [sym_left_assignment_list] = STATE(2236),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2237),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2237),
    [sym_false] = STATE(2237),
    [sym_nil] = STATE(2237),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2137),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3877),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3731),
    [anon_sym_yield] = ACTIONS(3733),
    [anon_sym_break] = ACTIONS(3735),
    [anon_sym_next] = ACTIONS(3737),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3879),
    [anon_sym_defined_QMARK] = ACTIONS(3881),
    [anon_sym_not] = ACTIONS(3883),
    [anon_sym_BANG] = ACTIONS(3885),
    [anon_sym_TILDE] = ACTIONS(3885),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2231] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(4620),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2237),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(2237),
    [sym_assignment] = STATE(4620),
    [sym_operator_assignment] = STATE(4620),
    [sym_conditional] = STATE(4620),
    [sym_range] = STATE(4620),
    [sym_binary] = STATE(4620),
    [sym_unary] = STATE(4620),
    [sym_left_assignment_list] = STATE(2236),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2237),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2237),
    [sym_false] = STATE(2237),
    [sym_nil] = STATE(2237),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2137),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3877),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3731),
    [anon_sym_yield] = ACTIONS(3733),
    [anon_sym_break] = ACTIONS(3735),
    [anon_sym_next] = ACTIONS(3737),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3879),
    [anon_sym_defined_QMARK] = ACTIONS(3881),
    [anon_sym_not] = ACTIONS(3883),
    [anon_sym_BANG] = ACTIONS(3885),
    [anon_sym_TILDE] = ACTIONS(3885),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2232] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(4621),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2237),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(2237),
    [sym_assignment] = STATE(4621),
    [sym_operator_assignment] = STATE(4621),
    [sym_conditional] = STATE(4621),
    [sym_range] = STATE(4621),
    [sym_binary] = STATE(4621),
    [sym_unary] = STATE(4621),
    [sym_left_assignment_list] = STATE(2236),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2237),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2237),
    [sym_false] = STATE(2237),
    [sym_nil] = STATE(2237),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2137),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3877),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3731),
    [anon_sym_yield] = ACTIONS(3733),
    [anon_sym_break] = ACTIONS(3735),
    [anon_sym_next] = ACTIONS(3737),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3879),
    [anon_sym_defined_QMARK] = ACTIONS(3881),
    [anon_sym_not] = ACTIONS(3883),
    [anon_sym_BANG] = ACTIONS(3885),
    [anon_sym_TILDE] = ACTIONS(3885),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2233] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(298),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2237),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(2237),
    [sym_assignment] = STATE(298),
    [sym_operator_assignment] = STATE(298),
    [sym_conditional] = STATE(298),
    [sym_range] = STATE(298),
    [sym_binary] = STATE(298),
    [sym_unary] = STATE(298),
    [sym_left_assignment_list] = STATE(2236),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2237),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2237),
    [sym_false] = STATE(2237),
    [sym_nil] = STATE(2237),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2137),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3877),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3731),
    [anon_sym_yield] = ACTIONS(3733),
    [anon_sym_break] = ACTIONS(3735),
    [anon_sym_next] = ACTIONS(3737),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3879),
    [anon_sym_defined_QMARK] = ACTIONS(3881),
    [anon_sym_not] = ACTIONS(3883),
    [anon_sym_BANG] = ACTIONS(3885),
    [anon_sym_TILDE] = ACTIONS(3885),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2234] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(7494),
    [sym__binary_star] = ACTIONS(7496),
    [anon_sym_RPAREN] = ACTIONS(5115),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(7498),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(7496),
    [anon_sym_AMP] = ACTIONS(7500),
    [anon_sym_LT] = ACTIONS(7502),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(7504),
    [anon_sym_DOT_DOT] = ACTIONS(7506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7508),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7510),
    [anon_sym_AMP_AMP] = ACTIONS(7510),
    [anon_sym_LT_LT] = ACTIONS(7512),
    [anon_sym_GT_GT] = ACTIONS(7512),
    [anon_sym_EQ_EQ] = ACTIONS(7514),
    [anon_sym_BANG_EQ] = ACTIONS(7510),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7510),
    [anon_sym_LT_EQ_GT] = ACTIONS(7510),
    [anon_sym_EQ_TILDE] = ACTIONS(7510),
    [anon_sym_BANG_TILDE] = ACTIONS(7510),
    [anon_sym_LT_EQ] = ACTIONS(7502),
    [anon_sym_GT] = ACTIONS(7502),
    [anon_sym_GT_EQ] = ACTIONS(7516),
    [anon_sym_CARET] = ACTIONS(7518),
    [anon_sym_PLUS] = ACTIONS(7494),
    [anon_sym_SLASH] = ACTIONS(7496),
    [anon_sym_PERCENT] = ACTIONS(7496),
    [sym_comment] = ACTIONS(87),
  },
  [2235] = {
    [aux_sym_exceptions_repeat1] = STATE(4633),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_RPAREN] = ACTIONS(6191),
    [anon_sym_COMMA] = ACTIONS(7520),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [2236] = {
    [anon_sym_EQ] = ACTIONS(7522),
    [sym_comment] = ACTIONS(87),
  },
  [2237] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(7524),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(7526),
    [anon_sym_DASH_EQ] = ACTIONS(7526),
    [anon_sym_STAR_EQ] = ACTIONS(7526),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7526),
    [anon_sym_SLASH_EQ] = ACTIONS(7526),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7526),
    [anon_sym_PIPE_EQ] = ACTIONS(7526),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7526),
    [anon_sym_AMP_EQ] = ACTIONS(7526),
    [anon_sym_PERCENT_EQ] = ACTIONS(7526),
    [anon_sym_GT_GT_EQ] = ACTIONS(7526),
    [anon_sym_LT_LT_EQ] = ACTIONS(7526),
    [anon_sym_CARET_EQ] = ACTIONS(7526),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2238] = {
    [sym_method] = STATE(184),
    [sym_singleton_method] = STATE(184),
    [sym_class] = STATE(184),
    [sym_singleton_class] = STATE(184),
    [sym_module] = STATE(184),
    [sym_return] = STATE(184),
    [sym_yield] = STATE(184),
    [sym_break] = STATE(184),
    [sym_next] = STATE(184),
    [sym_while] = STATE(184),
    [sym_until] = STATE(184),
    [sym_for] = STATE(184),
    [sym_case] = STATE(184),
    [sym_if] = STATE(184),
    [sym_unless] = STATE(184),
    [sym_begin] = STATE(184),
    [sym__primary] = STATE(184),
    [sym_parenthesized_statements] = STATE(184),
    [sym_element_reference] = STATE(1598),
    [sym_scope_resolution] = STATE(687),
    [sym_call] = STATE(687),
    [sym_method_call] = STATE(1598),
    [sym_destructured_left_assignment] = STATE(1597),
    [sym_rest_assignment] = STATE(1597),
    [sym__lhs] = STATE(1598),
    [sym__variable] = STATE(687),
    [sym_rational] = STATE(184),
    [sym_true] = STATE(1598),
    [sym_false] = STATE(1598),
    [sym_nil] = STATE(1598),
    [sym_chained_string] = STATE(184),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(184),
    [sym_string_array] = STATE(184),
    [sym_symbol_array] = STATE(184),
    [sym_symbol] = STATE(184),
    [sym_regex] = STATE(184),
    [sym_array] = STATE(184),
    [sym_hash] = STATE(184),
    [sym_lambda] = STATE(184),
    [sym__simple_symbol] = ACTIONS(279),
    [sym__string_start] = ACTIONS(281),
    [sym__symbol_start] = ACTIONS(283),
    [sym__subshell_start] = ACTIONS(285),
    [sym__regex_start] = ACTIONS(287),
    [sym__string_array_start] = ACTIONS(289),
    [sym__symbol_array_start] = ACTIONS(291),
    [sym_heredoc_beginning] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_def] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(475),
    [anon_sym_RPAREN] = ACTIONS(6205),
    [anon_sym_COLON_COLON] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(249),
    [anon_sym_EQ] = ACTIONS(6205),
    [anon_sym_class] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(307),
    [anon_sym_return] = ACTIONS(309),
    [anon_sym_yield] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_next] = ACTIONS(315),
    [sym_redo] = ACTIONS(317),
    [sym_retry] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(319),
    [anon_sym_unless] = ACTIONS(321),
    [anon_sym_while] = ACTIONS(323),
    [anon_sym_until] = ACTIONS(325),
    [anon_sym_for] = ACTIONS(327),
    [anon_sym_case] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(331),
    [sym_constant] = ACTIONS(1295),
    [sym_identifier] = ACTIONS(1295),
    [sym_instance_variable] = ACTIONS(1297),
    [sym_class_variable] = ACTIONS(1297),
    [sym_global_variable] = ACTIONS(1297),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(317),
    [sym_complex] = ACTIONS(293),
    [sym_super] = ACTIONS(1295),
    [anon_sym_true] = ACTIONS(339),
    [anon_sym_TRUE] = ACTIONS(339),
    [anon_sym_false] = ACTIONS(341),
    [anon_sym_FALSE] = ACTIONS(341),
    [sym_self] = ACTIONS(1295),
    [anon_sym_nil] = ACTIONS(343),
    [anon_sym_NIL] = ACTIONS(343),
    [sym_character] = ACTIONS(293),
    [anon_sym_LBRACK2] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(347),
  },
  [2239] = {
    [aux_sym__mlhs_repeat1] = STATE(2239),
    [anon_sym_RPAREN] = ACTIONS(6203),
    [anon_sym_COMMA] = ACTIONS(7528),
    [anon_sym_EQ] = ACTIONS(6203),
    [sym_comment] = ACTIONS(87),
  },
  [2240] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(1343),
    [sym__binary_star] = ACTIONS(1345),
    [anon_sym_RPAREN] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(1345),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_DOT_DOT] = ACTIONS(1355),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1357),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(1361),
    [anon_sym_AMP_AMP] = ACTIONS(1361),
    [anon_sym_LT_LT] = ACTIONS(1363),
    [anon_sym_GT_GT] = ACTIONS(1363),
    [anon_sym_EQ_EQ] = ACTIONS(1365),
    [anon_sym_BANG_EQ] = ACTIONS(1361),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1361),
    [anon_sym_LT_EQ_GT] = ACTIONS(1361),
    [anon_sym_EQ_TILDE] = ACTIONS(1361),
    [anon_sym_BANG_TILDE] = ACTIONS(1361),
    [anon_sym_LT_EQ] = ACTIONS(1351),
    [anon_sym_GT] = ACTIONS(1351),
    [anon_sym_GT_EQ] = ACTIONS(1367),
    [anon_sym_CARET] = ACTIONS(1369),
    [anon_sym_PLUS] = ACTIONS(1343),
    [anon_sym_SLASH] = ACTIONS(1345),
    [anon_sym_PERCENT] = ACTIONS(1345),
    [sym_comment] = ACTIONS(87),
  },
  [2241] = {
    [sym_string] = STATE(2241),
    [aux_sym_chained_string_repeat1] = STATE(2241),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(6214),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_RPAREN] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [2242] = {
    [sym__string_start] = ACTIONS(3030),
    [anon_sym_DOT] = ACTIONS(3030),
    [anon_sym_LBRACK] = ACTIONS(3030),
    [anon_sym_COLON_COLON2] = ACTIONS(3030),
    [anon_sym_AMP_DOT] = ACTIONS(3030),
    [sym_comment] = ACTIONS(87),
  },
  [2243] = {
    [anon_sym_RBRACE] = ACTIONS(3042),
    [anon_sym_DOT] = ACTIONS(3042),
    [anon_sym_COMMA] = ACTIONS(3042),
    [anon_sym_if] = ACTIONS(3042),
    [anon_sym_unless] = ACTIONS(3042),
    [anon_sym_while] = ACTIONS(3042),
    [anon_sym_until] = ACTIONS(3042),
    [anon_sym_rescue] = ACTIONS(3042),
    [anon_sym_LBRACK] = ACTIONS(3042),
    [anon_sym_COLON_COLON2] = ACTIONS(3042),
    [anon_sym_AMP_DOT] = ACTIONS(3042),
    [sym_comment] = ACTIONS(87),
  },
  [2244] = {
    [anon_sym_DOT] = ACTIONS(3046),
    [anon_sym_LBRACK] = ACTIONS(3046),
    [anon_sym_COLON_COLON2] = ACTIONS(3046),
    [anon_sym_AMP_DOT] = ACTIONS(3046),
    [sym_comment] = ACTIONS(87),
  },
  [2245] = {
    [anon_sym_DOT] = ACTIONS(3050),
    [anon_sym_LBRACK] = ACTIONS(3050),
    [anon_sym_COLON_COLON2] = ACTIONS(3050),
    [anon_sym_AMP_DOT] = ACTIONS(3050),
    [sym_comment] = ACTIONS(87),
  },
  [2246] = {
    [anon_sym_DOT] = ACTIONS(3056),
    [anon_sym_LBRACK] = ACTIONS(3056),
    [anon_sym_COLON_COLON2] = ACTIONS(3056),
    [anon_sym_AMP_DOT] = ACTIONS(3056),
    [sym_comment] = ACTIONS(87),
  },
  [2247] = {
    [sym__string_end] = ACTIONS(7531),
    [sym_comment] = ACTIONS(87),
  },
  [2248] = {
    [aux_sym_string_array_repeat1] = STATE(4640),
    [sym__string_end] = ACTIONS(7533),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(7535),
  },
  [2249] = {
    [anon_sym_DOT] = ACTIONS(3066),
    [anon_sym_LBRACK] = ACTIONS(3066),
    [anon_sym_COLON_COLON2] = ACTIONS(3066),
    [anon_sym_AMP_DOT] = ACTIONS(3066),
    [sym_comment] = ACTIONS(87),
  },
  [2250] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1697),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(7537),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [2251] = {
    [aux_sym_string_array_repeat1] = STATE(1699),
    [sym__string_end] = ACTIONS(7537),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(7539),
  },
  [2252] = {
    [anon_sym_DOT] = ACTIONS(3085),
    [anon_sym_LBRACK] = ACTIONS(3085),
    [anon_sym_COLON_COLON2] = ACTIONS(3085),
    [anon_sym_AMP_DOT] = ACTIONS(3085),
    [sym_comment] = ACTIONS(87),
  },
  [2253] = {
    [sym__string_end] = ACTIONS(7541),
    [sym_comment] = ACTIONS(87),
  },
  [2254] = {
    [aux_sym_symbol_array_repeat1] = STATE(4646),
    [sym__string_end] = ACTIONS(7543),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(7545),
  },
  [2255] = {
    [anon_sym_DOT] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3095),
    [anon_sym_COLON_COLON2] = ACTIONS(3095),
    [anon_sym_AMP_DOT] = ACTIONS(3095),
    [sym_comment] = ACTIONS(87),
  },
  [2256] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1705),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(7547),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [2257] = {
    [aux_sym_symbol_array_repeat1] = STATE(1707),
    [sym__string_end] = ACTIONS(7547),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(7549),
  },
  [2258] = {
    [anon_sym_DOT] = ACTIONS(3575),
    [anon_sym_LBRACK] = ACTIONS(3575),
    [anon_sym_COLON_COLON2] = ACTIONS(3575),
    [anon_sym_AMP_DOT] = ACTIONS(3575),
    [sym_comment] = ACTIONS(87),
  },
  [2259] = {
    [anon_sym_RBRACE] = ACTIONS(7551),
    [sym_comment] = ACTIONS(87),
  },
  [2260] = {
    [sym__binary_minus] = ACTIONS(3609),
    [sym__binary_star] = ACTIONS(3611),
    [anon_sym_RPAREN] = ACTIONS(7553),
    [anon_sym_PIPE] = ACTIONS(3615),
    [anon_sym_STAR_STAR] = ACTIONS(3611),
    [anon_sym_AMP] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3619),
    [anon_sym_QMARK] = ACTIONS(3621),
    [anon_sym_DOT_DOT] = ACTIONS(3623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3625),
    [anon_sym_and] = ACTIONS(3627),
    [anon_sym_or] = ACTIONS(3627),
    [anon_sym_PIPE_PIPE] = ACTIONS(3629),
    [anon_sym_AMP_AMP] = ACTIONS(3629),
    [anon_sym_LT_LT] = ACTIONS(3631),
    [anon_sym_GT_GT] = ACTIONS(3631),
    [anon_sym_EQ_EQ] = ACTIONS(3633),
    [anon_sym_BANG_EQ] = ACTIONS(3629),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3629),
    [anon_sym_LT_EQ_GT] = ACTIONS(3629),
    [anon_sym_EQ_TILDE] = ACTIONS(3629),
    [anon_sym_BANG_TILDE] = ACTIONS(3629),
    [anon_sym_LT_EQ] = ACTIONS(3619),
    [anon_sym_GT] = ACTIONS(3619),
    [anon_sym_GT_EQ] = ACTIONS(3635),
    [anon_sym_CARET] = ACTIONS(3637),
    [anon_sym_PLUS] = ACTIONS(3609),
    [anon_sym_SLASH] = ACTIONS(3611),
    [anon_sym_PERCENT] = ACTIONS(3611),
    [sym_comment] = ACTIONS(87),
  },
  [2261] = {
    [sym__method_rest] = STATE(4651),
    [sym_operator] = STATE(772),
    [sym__method_name] = STATE(772),
    [sym_setter] = STATE(772),
    [sym_symbol] = STATE(772),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(7555),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(7555),
    [sym_class_variable] = ACTIONS(7555),
    [sym_global_variable] = ACTIONS(7555),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [2262] = {
    [sym__statements] = STATE(802),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(803),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(804),
    [sym_rescue] = STATE(805),
    [sym__body_statement] = STATE(4652),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(7557),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2263] = {
    [anon_sym_DOT] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(3805),
    [anon_sym_COLON_COLON2] = ACTIONS(3805),
    [anon_sym_AMP_DOT] = ACTIONS(3805),
    [sym_comment] = ACTIONS(87),
  },
  [2264] = {
    [sym_heredoc_body] = STATE(4653),
    [sym__terminator] = STATE(4653),
    [sym__line_break] = ACTIONS(7559),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym__binary_minus] = ACTIONS(2001),
    [sym__binary_star] = ACTIONS(2003),
    [anon_sym_PIPE] = ACTIONS(2005),
    [anon_sym_SEMI] = ACTIONS(7559),
    [anon_sym_STAR_STAR] = ACTIONS(2003),
    [anon_sym_AMP] = ACTIONS(2007),
    [anon_sym_LT] = ACTIONS(2009),
    [anon_sym_QMARK] = ACTIONS(2011),
    [anon_sym_DOT_DOT] = ACTIONS(2013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2015),
    [anon_sym_and] = ACTIONS(2017),
    [anon_sym_or] = ACTIONS(2017),
    [anon_sym_PIPE_PIPE] = ACTIONS(2019),
    [anon_sym_AMP_AMP] = ACTIONS(2019),
    [anon_sym_LT_LT] = ACTIONS(2021),
    [anon_sym_GT_GT] = ACTIONS(2021),
    [anon_sym_EQ_EQ] = ACTIONS(2023),
    [anon_sym_BANG_EQ] = ACTIONS(2019),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2019),
    [anon_sym_LT_EQ_GT] = ACTIONS(2019),
    [anon_sym_EQ_TILDE] = ACTIONS(2019),
    [anon_sym_BANG_TILDE] = ACTIONS(2019),
    [anon_sym_LT_EQ] = ACTIONS(2009),
    [anon_sym_GT] = ACTIONS(2009),
    [anon_sym_GT_EQ] = ACTIONS(2025),
    [anon_sym_CARET] = ACTIONS(2027),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_SLASH] = ACTIONS(2003),
    [anon_sym_PERCENT] = ACTIONS(2003),
    [sym_comment] = ACTIONS(87),
  },
  [2265] = {
    [sym_heredoc_body] = STATE(4654),
    [sym__terminator] = STATE(4654),
    [sym__line_break] = ACTIONS(7561),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(7561),
    [sym_comment] = ACTIONS(87),
  },
  [2266] = {
    [sym__statements] = STATE(802),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(803),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(804),
    [sym_rescue] = STATE(805),
    [sym__body_statement] = STATE(4655),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(7563),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2267] = {
    [anon_sym_DOT] = ACTIONS(4205),
    [anon_sym_LBRACK] = ACTIONS(4205),
    [anon_sym_COLON_COLON2] = ACTIONS(4205),
    [anon_sym_AMP_DOT] = ACTIONS(4205),
    [sym_comment] = ACTIONS(87),
  },
  [2268] = {
    [sym__statements] = STATE(802),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(803),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(804),
    [sym_rescue] = STATE(805),
    [sym__body_statement] = STATE(4656),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(7565),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2269] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(4657),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2279),
    [sym_scope_resolution] = STATE(2277),
    [sym_call] = STATE(2277),
    [sym_method_call] = STATE(2279),
    [sym_assignment] = STATE(4657),
    [sym_operator_assignment] = STATE(4657),
    [sym_conditional] = STATE(4657),
    [sym_range] = STATE(4657),
    [sym_binary] = STATE(4657),
    [sym_unary] = STATE(4657),
    [sym_left_assignment_list] = STATE(2278),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2277),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2279),
    [sym_false] = STATE(2279),
    [sym_nil] = STATE(2279),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2280),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3931),
    [anon_sym_yield] = ACTIONS(3933),
    [anon_sym_break] = ACTIONS(3935),
    [anon_sym_next] = ACTIONS(3937),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3939),
    [anon_sym_defined_QMARK] = ACTIONS(3941),
    [anon_sym_not] = ACTIONS(3943),
    [anon_sym_BANG] = ACTIONS(3945),
    [anon_sym_TILDE] = ACTIONS(3945),
    [sym_constant] = ACTIONS(3947),
    [sym_identifier] = ACTIONS(3947),
    [sym_instance_variable] = ACTIONS(3949),
    [sym_class_variable] = ACTIONS(3949),
    [sym_global_variable] = ACTIONS(3949),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3947),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3947),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2270] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4663),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(567),
    [sym_scope_resolution] = STATE(562),
    [sym_call] = STATE(562),
    [sym_method_call] = STATE(567),
    [sym_argument_list] = STATE(1318),
    [sym__argument_list_with_parens] = STATE(4664),
    [sym__argument] = STATE(4665),
    [sym_splat_argument] = STATE(4665),
    [sym_hash_splat_argument] = STATE(4665),
    [sym_block_argument] = STATE(4665),
    [sym_assignment] = STATE(4663),
    [sym_operator_assignment] = STATE(4663),
    [sym_conditional] = STATE(4663),
    [sym_range] = STATE(4663),
    [sym_binary] = STATE(4663),
    [sym_unary] = STATE(4663),
    [sym_left_assignment_list] = STATE(566),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(567),
    [sym__variable] = STATE(562),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(567),
    [sym_false] = STATE(567),
    [sym_nil] = STATE(567),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4666),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(4665),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(7567),
    [sym__splat_star] = ACTIONS(7569),
    [sym__unary_minus] = ACTIONS(1049),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(7571),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(7573),
    [sym_identifier] = ACTIONS(7573),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2271] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4663),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(567),
    [sym_scope_resolution] = STATE(562),
    [sym_call] = STATE(562),
    [sym_method_call] = STATE(567),
    [sym_argument_list] = STATE(1324),
    [sym__argument_list_with_parens] = STATE(4664),
    [sym__argument] = STATE(4665),
    [sym_splat_argument] = STATE(4665),
    [sym_hash_splat_argument] = STATE(4665),
    [sym_block_argument] = STATE(4665),
    [sym_assignment] = STATE(4663),
    [sym_operator_assignment] = STATE(4663),
    [sym_conditional] = STATE(4663),
    [sym_range] = STATE(4663),
    [sym_binary] = STATE(4663),
    [sym_unary] = STATE(4663),
    [sym_left_assignment_list] = STATE(566),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(567),
    [sym__variable] = STATE(562),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(567),
    [sym_false] = STATE(567),
    [sym_nil] = STATE(567),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4666),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(4665),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(7567),
    [sym__splat_star] = ACTIONS(7569),
    [sym__unary_minus] = ACTIONS(1049),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(7571),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(7573),
    [sym_identifier] = ACTIONS(7573),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2272] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4663),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(567),
    [sym_scope_resolution] = STATE(562),
    [sym_call] = STATE(562),
    [sym_method_call] = STATE(567),
    [sym_argument_list] = STATE(1325),
    [sym__argument_list_with_parens] = STATE(4664),
    [sym__argument] = STATE(4665),
    [sym_splat_argument] = STATE(4665),
    [sym_hash_splat_argument] = STATE(4665),
    [sym_block_argument] = STATE(4665),
    [sym_assignment] = STATE(4663),
    [sym_operator_assignment] = STATE(4663),
    [sym_conditional] = STATE(4663),
    [sym_range] = STATE(4663),
    [sym_binary] = STATE(4663),
    [sym_unary] = STATE(4663),
    [sym_left_assignment_list] = STATE(566),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(567),
    [sym__variable] = STATE(562),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(567),
    [sym_false] = STATE(567),
    [sym_nil] = STATE(567),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4666),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(4665),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(7567),
    [sym__splat_star] = ACTIONS(7569),
    [sym__unary_minus] = ACTIONS(1049),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(7571),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(7573),
    [sym_identifier] = ACTIONS(7573),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2273] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4663),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(567),
    [sym_scope_resolution] = STATE(562),
    [sym_call] = STATE(562),
    [sym_method_call] = STATE(567),
    [sym_argument_list] = STATE(1326),
    [sym__argument_list_with_parens] = STATE(4664),
    [sym__argument] = STATE(4665),
    [sym_splat_argument] = STATE(4665),
    [sym_hash_splat_argument] = STATE(4665),
    [sym_block_argument] = STATE(4665),
    [sym_assignment] = STATE(4663),
    [sym_operator_assignment] = STATE(4663),
    [sym_conditional] = STATE(4663),
    [sym_range] = STATE(4663),
    [sym_binary] = STATE(4663),
    [sym_unary] = STATE(4663),
    [sym_left_assignment_list] = STATE(566),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(567),
    [sym__variable] = STATE(562),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(567),
    [sym_false] = STATE(567),
    [sym_nil] = STATE(567),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4666),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(4665),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(7567),
    [sym__splat_star] = ACTIONS(7569),
    [sym__unary_minus] = ACTIONS(1049),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(7571),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(7573),
    [sym_identifier] = ACTIONS(7573),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2274] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(4667),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2279),
    [sym_scope_resolution] = STATE(2277),
    [sym_call] = STATE(2277),
    [sym_method_call] = STATE(2279),
    [sym_assignment] = STATE(4667),
    [sym_operator_assignment] = STATE(4667),
    [sym_conditional] = STATE(4667),
    [sym_range] = STATE(4667),
    [sym_binary] = STATE(4667),
    [sym_unary] = STATE(4667),
    [sym_left_assignment_list] = STATE(2278),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2277),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2279),
    [sym_false] = STATE(2279),
    [sym_nil] = STATE(2279),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2280),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3931),
    [anon_sym_yield] = ACTIONS(3933),
    [anon_sym_break] = ACTIONS(3935),
    [anon_sym_next] = ACTIONS(3937),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3939),
    [anon_sym_defined_QMARK] = ACTIONS(3941),
    [anon_sym_not] = ACTIONS(3943),
    [anon_sym_BANG] = ACTIONS(3945),
    [anon_sym_TILDE] = ACTIONS(3945),
    [sym_constant] = ACTIONS(3947),
    [sym_identifier] = ACTIONS(3947),
    [sym_instance_variable] = ACTIONS(3949),
    [sym_class_variable] = ACTIONS(3949),
    [sym_global_variable] = ACTIONS(3949),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3947),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3947),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2275] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(1872),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2279),
    [sym_scope_resolution] = STATE(2277),
    [sym_call] = STATE(2277),
    [sym_method_call] = STATE(2279),
    [sym_assignment] = STATE(1872),
    [sym_operator_assignment] = STATE(1872),
    [sym_conditional] = STATE(1872),
    [sym_range] = STATE(1872),
    [sym_binary] = STATE(1872),
    [sym_unary] = STATE(1872),
    [sym_left_assignment_list] = STATE(2278),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2277),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2279),
    [sym_false] = STATE(2279),
    [sym_nil] = STATE(2279),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2280),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3931),
    [anon_sym_yield] = ACTIONS(3933),
    [anon_sym_break] = ACTIONS(3935),
    [anon_sym_next] = ACTIONS(3937),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3939),
    [anon_sym_defined_QMARK] = ACTIONS(3941),
    [anon_sym_not] = ACTIONS(3943),
    [anon_sym_BANG] = ACTIONS(3945),
    [anon_sym_TILDE] = ACTIONS(3945),
    [sym_constant] = ACTIONS(3947),
    [sym_identifier] = ACTIONS(3947),
    [sym_instance_variable] = ACTIONS(3949),
    [sym_class_variable] = ACTIONS(3949),
    [sym_global_variable] = ACTIONS(3949),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3947),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3947),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2276] = {
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(7575),
    [sym__binary_star] = ACTIONS(7577),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(7579),
    [anon_sym_STAR_STAR] = ACTIONS(7577),
    [anon_sym_AMP] = ACTIONS(7581),
    [anon_sym_LT] = ACTIONS(7583),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(7585),
    [anon_sym_DOT_DOT] = ACTIONS(7587),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7589),
    [anon_sym_and] = ACTIONS(7591),
    [anon_sym_or] = ACTIONS(7591),
    [anon_sym_PIPE_PIPE] = ACTIONS(7593),
    [anon_sym_AMP_AMP] = ACTIONS(7593),
    [anon_sym_LT_LT] = ACTIONS(7595),
    [anon_sym_GT_GT] = ACTIONS(7595),
    [anon_sym_EQ_EQ] = ACTIONS(7597),
    [anon_sym_BANG_EQ] = ACTIONS(7593),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7593),
    [anon_sym_LT_EQ_GT] = ACTIONS(7593),
    [anon_sym_EQ_TILDE] = ACTIONS(7593),
    [anon_sym_BANG_TILDE] = ACTIONS(7593),
    [anon_sym_LT_EQ] = ACTIONS(7583),
    [anon_sym_GT] = ACTIONS(7583),
    [anon_sym_GT_EQ] = ACTIONS(7599),
    [anon_sym_CARET] = ACTIONS(7601),
    [anon_sym_PLUS] = ACTIONS(7575),
    [anon_sym_SLASH] = ACTIONS(7577),
    [anon_sym_PERCENT] = ACTIONS(7577),
    [sym_comment] = ACTIONS(87),
  },
  [2277] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4683),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_argument_list] = STATE(1846),
    [sym__argument_list_with_parens] = STATE(4684),
    [sym__argument] = STATE(4685),
    [sym_splat_argument] = STATE(4685),
    [sym_hash_splat_argument] = STATE(4685),
    [sym_block_argument] = STATE(4685),
    [sym_do_block] = STATE(1849),
    [sym_block] = STATE(1849),
    [sym_assignment] = STATE(4683),
    [sym_operator_assignment] = STATE(4683),
    [sym_conditional] = STATE(4683),
    [sym_range] = STATE(4683),
    [sym_binary] = STATE(4683),
    [sym_unary] = STATE(4683),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4686),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(4685),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(7603),
    [sym__splat_star] = ACTIONS(7605),
    [sym__unary_minus] = ACTIONS(1159),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(7607),
    [anon_sym_LBRACE] = ACTIONS(3327),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(3337),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1205),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(7609),
    [sym_identifier] = ACTIONS(7609),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2278] = {
    [anon_sym_EQ] = ACTIONS(7611),
    [sym_comment] = ACTIONS(87),
  },
  [2279] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(7613),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(7615),
    [anon_sym_DASH_EQ] = ACTIONS(7615),
    [anon_sym_STAR_EQ] = ACTIONS(7615),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7615),
    [anon_sym_SLASH_EQ] = ACTIONS(7615),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7615),
    [anon_sym_PIPE_EQ] = ACTIONS(7615),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7615),
    [anon_sym_AMP_EQ] = ACTIONS(7615),
    [anon_sym_PERCENT_EQ] = ACTIONS(7615),
    [anon_sym_GT_GT_EQ] = ACTIONS(7615),
    [anon_sym_LT_LT_EQ] = ACTIONS(7615),
    [anon_sym_CARET_EQ] = ACTIONS(7615),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2280] = {
    [sym_string] = STATE(4689),
    [aux_sym_chained_string_repeat1] = STATE(4689),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2281] = {
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(7575),
    [sym__binary_star] = ACTIONS(7577),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(7579),
    [anon_sym_STAR_STAR] = ACTIONS(7577),
    [anon_sym_AMP] = ACTIONS(7581),
    [anon_sym_LT] = ACTIONS(7583),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(7585),
    [anon_sym_DOT_DOT] = ACTIONS(7587),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7589),
    [anon_sym_and] = ACTIONS(7591),
    [anon_sym_or] = ACTIONS(7591),
    [anon_sym_PIPE_PIPE] = ACTIONS(7593),
    [anon_sym_AMP_AMP] = ACTIONS(7593),
    [anon_sym_LT_LT] = ACTIONS(7595),
    [anon_sym_GT_GT] = ACTIONS(7595),
    [anon_sym_EQ_EQ] = ACTIONS(7597),
    [anon_sym_BANG_EQ] = ACTIONS(7593),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7593),
    [anon_sym_LT_EQ_GT] = ACTIONS(7593),
    [anon_sym_EQ_TILDE] = ACTIONS(7593),
    [anon_sym_BANG_TILDE] = ACTIONS(7593),
    [anon_sym_LT_EQ] = ACTIONS(7583),
    [anon_sym_GT] = ACTIONS(7583),
    [anon_sym_GT_EQ] = ACTIONS(7599),
    [anon_sym_CARET] = ACTIONS(7601),
    [anon_sym_PLUS] = ACTIONS(7575),
    [anon_sym_SLASH] = ACTIONS(7577),
    [anon_sym_PERCENT] = ACTIONS(7577),
    [sym_comment] = ACTIONS(87),
  },
  [2282] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(4690),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2279),
    [sym_scope_resolution] = STATE(2277),
    [sym_call] = STATE(2277),
    [sym_method_call] = STATE(2279),
    [sym_assignment] = STATE(4690),
    [sym_operator_assignment] = STATE(4690),
    [sym_conditional] = STATE(4690),
    [sym_range] = STATE(4690),
    [sym_binary] = STATE(4690),
    [sym_unary] = STATE(4690),
    [sym_left_assignment_list] = STATE(2278),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2277),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2279),
    [sym_false] = STATE(2279),
    [sym_nil] = STATE(2279),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2280),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3931),
    [anon_sym_yield] = ACTIONS(3933),
    [anon_sym_break] = ACTIONS(3935),
    [anon_sym_next] = ACTIONS(3937),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3939),
    [anon_sym_defined_QMARK] = ACTIONS(3941),
    [anon_sym_not] = ACTIONS(3943),
    [anon_sym_BANG] = ACTIONS(3945),
    [anon_sym_TILDE] = ACTIONS(3945),
    [sym_constant] = ACTIONS(3947),
    [sym_identifier] = ACTIONS(3947),
    [sym_instance_variable] = ACTIONS(3949),
    [sym_class_variable] = ACTIONS(3949),
    [sym_global_variable] = ACTIONS(3949),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3947),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3947),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2283] = {
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(7575),
    [sym__binary_star] = ACTIONS(7577),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(7579),
    [anon_sym_STAR_STAR] = ACTIONS(7577),
    [anon_sym_AMP] = ACTIONS(7581),
    [anon_sym_LT] = ACTIONS(7583),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(7585),
    [anon_sym_DOT_DOT] = ACTIONS(7587),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7589),
    [anon_sym_and] = ACTIONS(7591),
    [anon_sym_or] = ACTIONS(7591),
    [anon_sym_PIPE_PIPE] = ACTIONS(7593),
    [anon_sym_AMP_AMP] = ACTIONS(7593),
    [anon_sym_LT_LT] = ACTIONS(7595),
    [anon_sym_GT_GT] = ACTIONS(7595),
    [anon_sym_EQ_EQ] = ACTIONS(7597),
    [anon_sym_BANG_EQ] = ACTIONS(7593),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7593),
    [anon_sym_LT_EQ_GT] = ACTIONS(7593),
    [anon_sym_EQ_TILDE] = ACTIONS(7593),
    [anon_sym_BANG_TILDE] = ACTIONS(7593),
    [anon_sym_LT_EQ] = ACTIONS(7583),
    [anon_sym_GT] = ACTIONS(7583),
    [anon_sym_GT_EQ] = ACTIONS(7599),
    [anon_sym_CARET] = ACTIONS(7601),
    [anon_sym_PLUS] = ACTIONS(7575),
    [anon_sym_SLASH] = ACTIONS(7577),
    [anon_sym_PERCENT] = ACTIONS(7577),
    [sym_comment] = ACTIONS(87),
  },
  [2284] = {
    [sym__heredoc_body_start] = ACTIONS(4285),
    [anon_sym_LBRACE] = ACTIONS(4285),
    [anon_sym_RPAREN] = ACTIONS(4285),
    [anon_sym_DOT] = ACTIONS(4285),
    [anon_sym_COMMA] = ACTIONS(4285),
    [anon_sym_EQ] = ACTIONS(4285),
    [anon_sym_in] = ACTIONS(4285),
    [anon_sym_do] = ACTIONS(4285),
    [anon_sym_LBRACK] = ACTIONS(4285),
    [anon_sym_COLON_COLON2] = ACTIONS(4285),
    [anon_sym_AMP_DOT] = ACTIONS(4285),
    [sym_comment] = ACTIONS(87),
  },
  [2285] = {
    [anon_sym_RPAREN] = ACTIONS(7617),
    [sym_comment] = ACTIONS(87),
  },
  [2286] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(4692),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2279),
    [sym_scope_resolution] = STATE(2277),
    [sym_call] = STATE(2277),
    [sym_method_call] = STATE(2279),
    [sym_assignment] = STATE(4692),
    [sym_operator_assignment] = STATE(4692),
    [sym_conditional] = STATE(4692),
    [sym_range] = STATE(4692),
    [sym_binary] = STATE(4692),
    [sym_unary] = STATE(4692),
    [sym_left_assignment_list] = STATE(2278),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2277),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2279),
    [sym_false] = STATE(2279),
    [sym_nil] = STATE(2279),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2280),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3931),
    [anon_sym_yield] = ACTIONS(3933),
    [anon_sym_break] = ACTIONS(3935),
    [anon_sym_next] = ACTIONS(3937),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3939),
    [anon_sym_defined_QMARK] = ACTIONS(3941),
    [anon_sym_not] = ACTIONS(3943),
    [anon_sym_BANG] = ACTIONS(3945),
    [anon_sym_TILDE] = ACTIONS(3945),
    [sym_constant] = ACTIONS(3947),
    [sym_identifier] = ACTIONS(3947),
    [sym_instance_variable] = ACTIONS(3949),
    [sym_class_variable] = ACTIONS(3949),
    [sym_global_variable] = ACTIONS(3949),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3947),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3947),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2287] = {
    [sym_interpolation] = STATE(4694),
    [aux_sym_heredoc_body_repeat1] = STATE(4694),
    [sym__heredoc_content] = ACTIONS(7619),
    [sym_heredoc_end] = ACTIONS(7621),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(7619),
  },
  [2288] = {
    [sym_heredoc_body] = STATE(4695),
    [aux_sym_call_repeat1] = STATE(4695),
    [sym__heredoc_body_start] = ACTIONS(3959),
    [anon_sym_DOT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [2289] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(787),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(567),
    [sym_scope_resolution] = STATE(562),
    [sym_call] = STATE(562),
    [sym_method_call] = STATE(567),
    [sym__argument] = STATE(3454),
    [sym_splat_argument] = STATE(3454),
    [sym_hash_splat_argument] = STATE(3454),
    [sym_block_argument] = STATE(3454),
    [sym_assignment] = STATE(787),
    [sym_operator_assignment] = STATE(787),
    [sym_conditional] = STATE(787),
    [sym_range] = STATE(787),
    [sym_binary] = STATE(787),
    [sym_unary] = STATE(787),
    [sym_left_assignment_list] = STATE(566),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(567),
    [sym__variable] = STATE(562),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(567),
    [sym_false] = STATE(567),
    [sym_nil] = STATE(567),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(791),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_heredoc_body] = STATE(4696),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(3454),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1447),
    [sym__splat_star] = ACTIONS(1449),
    [sym__unary_minus] = ACTIONS(1049),
    [sym__identifier_hash_key] = ACTIONS(1451),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1453),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1459),
    [sym_identifier] = ACTIONS(1459),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2290] = {
    [sym_heredoc_body] = STATE(4697),
    [aux_sym_call_repeat1] = STATE(4697),
    [aux_sym_argument_list_repeat1] = STATE(4698),
    [sym__heredoc_body_start] = ACTIONS(3959),
    [anon_sym_DOT] = ACTIONS(4383),
    [anon_sym_COMMA] = ACTIONS(3961),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [2291] = {
    [sym_elsif] = STATE(4700),
    [sym_else] = STATE(4700),
    [anon_sym_end] = ACTIONS(7623),
    [anon_sym_elsif] = ACTIONS(4495),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [2292] = {
    [sym__statements] = STATE(2640),
    [sym_begin_block] = STATE(2641),
    [sym_end_block] = STATE(2641),
    [sym__statement] = STATE(2641),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(2641),
    [sym_unless_modifier] = STATE(2641),
    [sym_while_modifier] = STATE(2641),
    [sym_until_modifier] = STATE(2641),
    [sym_rescue_modifier] = STATE(2641),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_elsif] = STATE(4700),
    [sym_else] = STATE(4700),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2642),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2645),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(2645),
    [sym_assignment] = STATE(2642),
    [sym_operator_assignment] = STATE(2642),
    [sym_conditional] = STATE(2642),
    [sym_range] = STATE(2642),
    [sym_binary] = STATE(2642),
    [sym_unary] = STATE(2642),
    [sym_left_assignment_list] = STATE(2644),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2645),
    [sym__variable] = STATE(2643),
    [sym_undef] = STATE(2641),
    [sym_alias] = STATE(2641),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2645),
    [sym_false] = STATE(2645),
    [sym_nil] = STATE(2645),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2646),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(2647),
    [aux_sym__statements_repeat1] = STATE(2647),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4467),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(7625),
    [anon_sym_return] = ACTIONS(4471),
    [anon_sym_yield] = ACTIONS(4473),
    [anon_sym_break] = ACTIONS(4475),
    [anon_sym_next] = ACTIONS(4477),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(4499),
    [anon_sym_else] = ACTIONS(4501),
    [anon_sym_then] = ACTIONS(4503),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4479),
    [anon_sym_defined_QMARK] = ACTIONS(4481),
    [anon_sym_not] = ACTIONS(4483),
    [anon_sym_BANG] = ACTIONS(4485),
    [anon_sym_TILDE] = ACTIONS(4485),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [anon_sym_undef] = ACTIONS(4491),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2293] = {
    [sym_else] = STATE(4702),
    [anon_sym_end] = ACTIONS(7627),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [2294] = {
    [sym__statements] = STATE(2640),
    [sym_begin_block] = STATE(2715),
    [sym_end_block] = STATE(2715),
    [sym__statement] = STATE(2715),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(2715),
    [sym_unless_modifier] = STATE(2715),
    [sym_while_modifier] = STATE(2715),
    [sym_until_modifier] = STATE(2715),
    [sym_rescue_modifier] = STATE(2715),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(4702),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2716),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2719),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(2719),
    [sym_assignment] = STATE(2716),
    [sym_operator_assignment] = STATE(2716),
    [sym_conditional] = STATE(2716),
    [sym_range] = STATE(2716),
    [sym_binary] = STATE(2716),
    [sym_unary] = STATE(2716),
    [sym_left_assignment_list] = STATE(2718),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2719),
    [sym__variable] = STATE(2717),
    [sym_undef] = STATE(2715),
    [sym_alias] = STATE(2715),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2719),
    [sym_false] = STATE(2719),
    [sym_nil] = STATE(2719),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2720),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(2721),
    [aux_sym__statements_repeat1] = STATE(2721),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4583),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(7629),
    [anon_sym_return] = ACTIONS(4585),
    [anon_sym_yield] = ACTIONS(4587),
    [anon_sym_break] = ACTIONS(4589),
    [anon_sym_next] = ACTIONS(4591),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(4501),
    [anon_sym_then] = ACTIONS(4611),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4593),
    [anon_sym_defined_QMARK] = ACTIONS(4595),
    [anon_sym_not] = ACTIONS(4597),
    [anon_sym_BANG] = ACTIONS(4599),
    [anon_sym_TILDE] = ACTIONS(4599),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [anon_sym_undef] = ACTIONS(4605),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2295] = {
    [sym__statements] = STATE(4704),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(7631),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2296] = {
    [sym__statements] = STATE(4706),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(7633),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2297] = {
    [sym__do] = STATE(4707),
    [sym_heredoc_body] = STATE(4707),
    [sym__terminator] = STATE(4707),
    [sym__line_break] = ACTIONS(7635),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(7635),
    [anon_sym_do] = ACTIONS(7635),
    [sym_comment] = ACTIONS(87),
  },
  [2298] = {
    [sym_when] = STATE(4711),
    [sym_else] = STATE(4709),
    [aux_sym_case_repeat1] = STATE(4710),
    [aux_sym_case_repeat2] = STATE(4711),
    [anon_sym_SEMI] = ACTIONS(7637),
    [anon_sym_end] = ACTIONS(7639),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [2299] = {
    [anon_sym_DOT] = ACTIONS(4965),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym_COLON_COLON2] = ACTIONS(4965),
    [anon_sym_AMP_DOT] = ACTIONS(4965),
    [sym_comment] = ACTIONS(87),
  },
  [2300] = {
    [anon_sym_end] = ACTIONS(7639),
    [sym_comment] = ACTIONS(87),
  },
  [2301] = {
    [sym_when] = STATE(4711),
    [sym_else] = STATE(4709),
    [aux_sym_case_repeat1] = STATE(2987),
    [aux_sym_case_repeat2] = STATE(4711),
    [anon_sym_SEMI] = ACTIONS(4995),
    [anon_sym_end] = ACTIONS(7639),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [2302] = {
    [sym_when] = STATE(2988),
    [sym_else] = STATE(4709),
    [aux_sym_case_repeat2] = STATE(2988),
    [anon_sym_end] = ACTIONS(7639),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [2303] = {
    [anon_sym_DOT] = ACTIONS(5407),
    [anon_sym_LBRACK] = ACTIONS(5407),
    [anon_sym_COLON_COLON2] = ACTIONS(5407),
    [anon_sym_AMP_DOT] = ACTIONS(5407),
    [sym_comment] = ACTIONS(87),
  },
  [2304] = {
    [sym_ensure] = STATE(4713),
    [anon_sym_end] = ACTIONS(7641),
    [anon_sym_ensure] = ACTIONS(2169),
    [sym_comment] = ACTIONS(87),
  },
  [2305] = {
    [anon_sym_end] = ACTIONS(7641),
    [sym_comment] = ACTIONS(87),
  },
  [2306] = {
    [sym_else] = STATE(4714),
    [sym_ensure] = STATE(4713),
    [anon_sym_end] = ACTIONS(7641),
    [anon_sym_else] = ACTIONS(2167),
    [anon_sym_ensure] = ACTIONS(2169),
    [sym_comment] = ACTIONS(87),
  },
  [2307] = {
    [anon_sym_DOT] = ACTIONS(5491),
    [anon_sym_LBRACK] = ACTIONS(5491),
    [anon_sym_COLON_COLON2] = ACTIONS(5491),
    [anon_sym_AMP_DOT] = ACTIONS(5491),
    [sym_comment] = ACTIONS(87),
  },
  [2308] = {
    [anon_sym_DOT] = ACTIONS(5725),
    [anon_sym_LBRACK] = ACTIONS(5725),
    [anon_sym_COLON_COLON2] = ACTIONS(5725),
    [anon_sym_AMP_DOT] = ACTIONS(5725),
    [sym_comment] = ACTIONS(87),
  },
  [2309] = {
    [anon_sym_LBRACE] = ACTIONS(5735),
    [anon_sym_RPAREN] = ACTIONS(5735),
    [anon_sym_DOT] = ACTIONS(5735),
    [anon_sym_COMMA] = ACTIONS(5735),
    [anon_sym_PIPE] = ACTIONS(5735),
    [anon_sym_SEMI] = ACTIONS(5735),
    [anon_sym_EQ] = ACTIONS(5735),
    [anon_sym_in] = ACTIONS(5735),
    [anon_sym_do] = ACTIONS(5735),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_COLON_COLON2] = ACTIONS(5735),
    [anon_sym_AMP_DOT] = ACTIONS(5735),
    [sym_comment] = ACTIONS(87),
  },
  [2310] = {
    [anon_sym_RBRACE] = ACTIONS(7643),
    [sym_comment] = ACTIONS(87),
  },
  [2311] = {
    [sym__statements] = STATE(4716),
    [sym_begin_block] = STATE(489),
    [sym_end_block] = STATE(489),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(495),
    [aux_sym__statements_repeat1] = STATE(495),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(7643),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2312] = {
    [anon_sym_LBRACE] = ACTIONS(5771),
    [anon_sym_RPAREN] = ACTIONS(5771),
    [anon_sym_DOT] = ACTIONS(5771),
    [anon_sym_COMMA] = ACTIONS(5771),
    [anon_sym_PIPE] = ACTIONS(5771),
    [anon_sym_SEMI] = ACTIONS(5771),
    [anon_sym_EQ] = ACTIONS(5771),
    [anon_sym_in] = ACTIONS(5771),
    [anon_sym_do] = ACTIONS(5771),
    [anon_sym_LBRACK] = ACTIONS(5771),
    [anon_sym_COLON_COLON2] = ACTIONS(5771),
    [anon_sym_AMP_DOT] = ACTIONS(5771),
    [sym_comment] = ACTIONS(87),
  },
  [2313] = {
    [anon_sym_end] = ACTIONS(7645),
    [sym_comment] = ACTIONS(87),
  },
  [2314] = {
    [sym__statements] = STATE(4718),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_heredoc_body] = STATE(4719),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [sym__terminator] = STATE(4719),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__line_break] = ACTIONS(7647),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(7647),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(7649),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2315] = {
    [sym__statements] = STATE(4718),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_block_parameters] = STATE(4720),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(7649),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2316] = {
    [anon_sym_LBRACE] = ACTIONS(5807),
    [anon_sym_RPAREN] = ACTIONS(5807),
    [anon_sym_DOT] = ACTIONS(5807),
    [anon_sym_COMMA] = ACTIONS(5807),
    [anon_sym_PIPE] = ACTIONS(5807),
    [anon_sym_SEMI] = ACTIONS(5807),
    [anon_sym_do] = ACTIONS(5807),
    [anon_sym_LBRACK] = ACTIONS(5807),
    [anon_sym_COLON_COLON2] = ACTIONS(5807),
    [anon_sym_AMP_DOT] = ACTIONS(5807),
    [sym_comment] = ACTIONS(87),
  },
  [2317] = {
    [sym__simple_symbol] = ACTIONS(1263),
    [sym__string_start] = ACTIONS(1263),
    [sym__symbol_start] = ACTIONS(1263),
    [sym__subshell_start] = ACTIONS(1263),
    [sym__regex_start] = ACTIONS(1263),
    [sym__string_array_start] = ACTIONS(1263),
    [sym__symbol_array_start] = ACTIONS(1263),
    [sym_heredoc_beginning] = ACTIONS(1263),
    [sym__block_ampersand] = ACTIONS(1263),
    [sym__splat_star] = ACTIONS(1263),
    [sym__unary_minus] = ACTIONS(1263),
    [sym__identifier_hash_key] = ACTIONS(1263),
    [anon_sym_LBRACE] = ACTIONS(1263),
    [anon_sym_def] = ACTIONS(1265),
    [anon_sym_LPAREN] = ACTIONS(1265),
    [anon_sym_RPAREN] = ACTIONS(1263),
    [anon_sym_DOT] = ACTIONS(1263),
    [anon_sym_COLON_COLON] = ACTIONS(1265),
    [anon_sym_COMMA] = ACTIONS(1263),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_STAR_STAR] = ACTIONS(1263),
    [anon_sym_EQ] = ACTIONS(1263),
    [anon_sym_class] = ACTIONS(1265),
    [anon_sym_module] = ACTIONS(1265),
    [anon_sym_return] = ACTIONS(1265),
    [anon_sym_yield] = ACTIONS(1265),
    [anon_sym_break] = ACTIONS(1265),
    [anon_sym_next] = ACTIONS(1265),
    [sym_redo] = ACTIONS(1265),
    [sym_retry] = ACTIONS(1265),
    [anon_sym_if] = ACTIONS(1265),
    [anon_sym_unless] = ACTIONS(1265),
    [anon_sym_while] = ACTIONS(1265),
    [anon_sym_until] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1265),
    [anon_sym_in] = ACTIONS(1265),
    [anon_sym_do] = ACTIONS(1265),
    [anon_sym_case] = ACTIONS(1265),
    [anon_sym_begin] = ACTIONS(1265),
    [anon_sym_LBRACK] = ACTIONS(1263),
    [anon_sym_COLON_COLON2] = ACTIONS(1263),
    [anon_sym_AMP_DOT] = ACTIONS(1263),
    [anon_sym_LPAREN2] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1265),
    [anon_sym_defined_QMARK] = ACTIONS(1263),
    [anon_sym_not] = ACTIONS(1265),
    [anon_sym_BANG] = ACTIONS(1263),
    [anon_sym_TILDE] = ACTIONS(1263),
    [sym_constant] = ACTIONS(1265),
    [sym_identifier] = ACTIONS(1265),
    [sym_instance_variable] = ACTIONS(1263),
    [sym_class_variable] = ACTIONS(1263),
    [sym_global_variable] = ACTIONS(1263),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1265),
    [sym_float] = ACTIONS(1265),
    [sym_complex] = ACTIONS(1263),
    [sym_super] = ACTIONS(1265),
    [anon_sym_true] = ACTIONS(1265),
    [anon_sym_TRUE] = ACTIONS(1265),
    [anon_sym_false] = ACTIONS(1265),
    [anon_sym_FALSE] = ACTIONS(1265),
    [sym_self] = ACTIONS(1265),
    [anon_sym_nil] = ACTIONS(1265),
    [anon_sym_NIL] = ACTIONS(1265),
    [sym_character] = ACTIONS(1263),
    [anon_sym_LBRACK2] = ACTIONS(1265),
    [anon_sym_DASH_GT] = ACTIONS(1263),
  },
  [2318] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(906),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(911),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(911),
    [sym__argument_list_with_trailing_comma] = STATE(4722),
    [sym__argument] = STATE(909),
    [sym_splat_argument] = STATE(909),
    [sym_hash_splat_argument] = STATE(909),
    [sym_block_argument] = STATE(909),
    [sym_assignment] = STATE(906),
    [sym_operator_assignment] = STATE(906),
    [sym_conditional] = STATE(906),
    [sym_range] = STATE(906),
    [sym_binary] = STATE(906),
    [sym_unary] = STATE(906),
    [sym_left_assignment_list] = STATE(910),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(911),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(911),
    [sym_false] = STATE(911),
    [sym_nil] = STATE(911),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(912),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(909),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1589),
    [sym__splat_star] = ACTIONS(1591),
    [sym__unary_minus] = ACTIONS(1593),
    [sym__identifier_hash_key] = ACTIONS(1595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(7651),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1599),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_defined_QMARK] = ACTIONS(1611),
    [anon_sym_not] = ACTIONS(1613),
    [anon_sym_BANG] = ACTIONS(1615),
    [anon_sym_TILDE] = ACTIONS(1615),
    [sym_constant] = ACTIONS(1617),
    [sym_identifier] = ACTIONS(1617),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2319] = {
    [sym__simple_symbol] = ACTIONS(5935),
    [sym__string_start] = ACTIONS(5935),
    [sym__symbol_start] = ACTIONS(5935),
    [sym__subshell_start] = ACTIONS(5935),
    [sym__regex_start] = ACTIONS(5935),
    [sym__string_array_start] = ACTIONS(5935),
    [sym__symbol_array_start] = ACTIONS(5935),
    [sym_heredoc_beginning] = ACTIONS(5935),
    [sym__block_ampersand] = ACTIONS(5935),
    [sym__splat_star] = ACTIONS(5935),
    [sym__unary_minus] = ACTIONS(5935),
    [sym__identifier_hash_key] = ACTIONS(5935),
    [anon_sym_LBRACE] = ACTIONS(5935),
    [anon_sym_def] = ACTIONS(5937),
    [anon_sym_LPAREN] = ACTIONS(5937),
    [anon_sym_RPAREN] = ACTIONS(5935),
    [anon_sym_DOT] = ACTIONS(5935),
    [anon_sym_COLON_COLON] = ACTIONS(5937),
    [anon_sym_COMMA] = ACTIONS(5935),
    [anon_sym_STAR] = ACTIONS(5937),
    [anon_sym_STAR_STAR] = ACTIONS(5935),
    [anon_sym_EQ] = ACTIONS(5935),
    [anon_sym_class] = ACTIONS(5937),
    [anon_sym_module] = ACTIONS(5937),
    [anon_sym_return] = ACTIONS(5937),
    [anon_sym_yield] = ACTIONS(5937),
    [anon_sym_break] = ACTIONS(5937),
    [anon_sym_next] = ACTIONS(5937),
    [sym_redo] = ACTIONS(5937),
    [sym_retry] = ACTIONS(5937),
    [anon_sym_if] = ACTIONS(5937),
    [anon_sym_unless] = ACTIONS(5937),
    [anon_sym_while] = ACTIONS(5937),
    [anon_sym_until] = ACTIONS(5937),
    [anon_sym_for] = ACTIONS(5937),
    [anon_sym_in] = ACTIONS(5937),
    [anon_sym_do] = ACTIONS(5937),
    [anon_sym_case] = ACTIONS(5937),
    [anon_sym_begin] = ACTIONS(5937),
    [anon_sym_LBRACK] = ACTIONS(5935),
    [anon_sym_COLON_COLON2] = ACTIONS(5935),
    [anon_sym_AMP_DOT] = ACTIONS(5935),
    [anon_sym_LPAREN2] = ACTIONS(5935),
    [anon_sym_PLUS] = ACTIONS(5937),
    [anon_sym_defined_QMARK] = ACTIONS(5935),
    [anon_sym_not] = ACTIONS(5937),
    [anon_sym_BANG] = ACTIONS(5935),
    [anon_sym_TILDE] = ACTIONS(5935),
    [sym_constant] = ACTIONS(5937),
    [sym_identifier] = ACTIONS(5937),
    [sym_instance_variable] = ACTIONS(5935),
    [sym_class_variable] = ACTIONS(5935),
    [sym_global_variable] = ACTIONS(5935),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5937),
    [sym_float] = ACTIONS(5937),
    [sym_complex] = ACTIONS(5935),
    [sym_super] = ACTIONS(5937),
    [anon_sym_true] = ACTIONS(5937),
    [anon_sym_TRUE] = ACTIONS(5937),
    [anon_sym_false] = ACTIONS(5937),
    [anon_sym_FALSE] = ACTIONS(5937),
    [sym_self] = ACTIONS(5937),
    [anon_sym_nil] = ACTIONS(5937),
    [anon_sym_NIL] = ACTIONS(5937),
    [sym_character] = ACTIONS(5935),
    [anon_sym_LBRACK2] = ACTIONS(5937),
    [anon_sym_DASH_GT] = ACTIONS(5935),
  },
  [2320] = {
    [sym__simple_symbol] = ACTIONS(5939),
    [sym__string_start] = ACTIONS(5939),
    [sym__symbol_start] = ACTIONS(5939),
    [sym__subshell_start] = ACTIONS(5939),
    [sym__regex_start] = ACTIONS(5939),
    [sym__string_array_start] = ACTIONS(5939),
    [sym__symbol_array_start] = ACTIONS(5939),
    [sym_heredoc_beginning] = ACTIONS(5939),
    [sym__block_ampersand] = ACTIONS(5939),
    [sym__splat_star] = ACTIONS(5939),
    [sym__unary_minus] = ACTIONS(5939),
    [sym__identifier_hash_key] = ACTIONS(5939),
    [anon_sym_LBRACE] = ACTIONS(5939),
    [anon_sym_def] = ACTIONS(5941),
    [anon_sym_LPAREN] = ACTIONS(5941),
    [anon_sym_RPAREN] = ACTIONS(5939),
    [anon_sym_DOT] = ACTIONS(5939),
    [anon_sym_COLON_COLON] = ACTIONS(5941),
    [anon_sym_COMMA] = ACTIONS(5939),
    [anon_sym_STAR] = ACTIONS(5941),
    [anon_sym_STAR_STAR] = ACTIONS(5939),
    [anon_sym_EQ] = ACTIONS(5939),
    [anon_sym_class] = ACTIONS(5941),
    [anon_sym_module] = ACTIONS(5941),
    [anon_sym_return] = ACTIONS(5941),
    [anon_sym_yield] = ACTIONS(5941),
    [anon_sym_break] = ACTIONS(5941),
    [anon_sym_next] = ACTIONS(5941),
    [sym_redo] = ACTIONS(5941),
    [sym_retry] = ACTIONS(5941),
    [anon_sym_if] = ACTIONS(5941),
    [anon_sym_unless] = ACTIONS(5941),
    [anon_sym_while] = ACTIONS(5941),
    [anon_sym_until] = ACTIONS(5941),
    [anon_sym_for] = ACTIONS(5941),
    [anon_sym_in] = ACTIONS(5941),
    [anon_sym_do] = ACTIONS(5941),
    [anon_sym_case] = ACTIONS(5941),
    [anon_sym_begin] = ACTIONS(5941),
    [anon_sym_LBRACK] = ACTIONS(5939),
    [anon_sym_COLON_COLON2] = ACTIONS(5939),
    [anon_sym_AMP_DOT] = ACTIONS(5939),
    [anon_sym_LPAREN2] = ACTIONS(5939),
    [anon_sym_PLUS] = ACTIONS(5941),
    [anon_sym_defined_QMARK] = ACTIONS(5939),
    [anon_sym_not] = ACTIONS(5941),
    [anon_sym_BANG] = ACTIONS(5939),
    [anon_sym_TILDE] = ACTIONS(5939),
    [sym_constant] = ACTIONS(5941),
    [sym_identifier] = ACTIONS(5941),
    [sym_instance_variable] = ACTIONS(5939),
    [sym_class_variable] = ACTIONS(5939),
    [sym_global_variable] = ACTIONS(5939),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5941),
    [sym_float] = ACTIONS(5941),
    [sym_complex] = ACTIONS(5939),
    [sym_super] = ACTIONS(5941),
    [anon_sym_true] = ACTIONS(5941),
    [anon_sym_TRUE] = ACTIONS(5941),
    [anon_sym_false] = ACTIONS(5941),
    [anon_sym_FALSE] = ACTIONS(5941),
    [sym_self] = ACTIONS(5941),
    [anon_sym_nil] = ACTIONS(5941),
    [anon_sym_NIL] = ACTIONS(5941),
    [sym_character] = ACTIONS(5939),
    [anon_sym_LBRACK2] = ACTIONS(5941),
    [anon_sym_DASH_GT] = ACTIONS(5939),
  },
  [2321] = {
    [sym_argument_list_with_parens] = STATE(4723),
    [sym__argument_list_with_parens] = STATE(2320),
    [sym_operator] = STATE(4723),
    [sym_heredoc_body] = STATE(3563),
    [aux_sym_call_repeat1] = STATE(3563),
    [sym__heredoc_body_start] = ACTIONS(2519),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3995),
    [anon_sym_STAR_STAR] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT] = ACTIONS(3995),
    [anon_sym_LPAREN2] = ACTIONS(3997),
    [anon_sym_DOT_DOT] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3993),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_EQ_EQ] = ACTIONS(3995),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3993),
    [anon_sym_LT_EQ_GT] = ACTIONS(3993),
    [anon_sym_EQ_TILDE] = ACTIONS(3993),
    [anon_sym_BANG_TILDE] = ACTIONS(3993),
    [anon_sym_LT_EQ] = ACTIONS(3995),
    [anon_sym_GT] = ACTIONS(3995),
    [anon_sym_GT_EQ] = ACTIONS(3993),
    [anon_sym_CARET] = ACTIONS(3993),
    [anon_sym_PLUS] = ACTIONS(3995),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3993),
    [anon_sym_BANG] = ACTIONS(3995),
    [anon_sym_TILDE] = ACTIONS(3993),
    [sym_constant] = ACTIONS(7653),
    [sym_identifier] = ACTIONS(7653),
    [anon_sym_DASH] = ACTIONS(3995),
    [anon_sym_PLUS_AT] = ACTIONS(3993),
    [anon_sym_DASH_AT] = ACTIONS(3993),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3995),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(3993),
    [anon_sym_BQUOTE] = ACTIONS(3993),
    [sym_comment] = ACTIONS(87),
  },
  [2322] = {
    [anon_sym_RPAREN] = ACTIONS(5945),
    [anon_sym_DOT] = ACTIONS(5945),
    [anon_sym_COMMA] = ACTIONS(5945),
    [anon_sym_EQ] = ACTIONS(5945),
    [anon_sym_in] = ACTIONS(5945),
    [anon_sym_LBRACK] = ACTIONS(5945),
    [anon_sym_COLON_COLON2] = ACTIONS(5945),
    [anon_sym_AMP_DOT] = ACTIONS(5945),
    [sym_comment] = ACTIONS(87),
  },
  [2323] = {
    [anon_sym_RBRACK] = ACTIONS(7655),
    [sym_comment] = ACTIONS(87),
  },
  [2324] = {
    [sym__simple_symbol] = ACTIONS(5951),
    [sym__string_start] = ACTIONS(5951),
    [sym__symbol_start] = ACTIONS(5951),
    [sym__subshell_start] = ACTIONS(5951),
    [sym__regex_start] = ACTIONS(5951),
    [sym__string_array_start] = ACTIONS(5951),
    [sym__symbol_array_start] = ACTIONS(5951),
    [sym_heredoc_beginning] = ACTIONS(5951),
    [sym__block_ampersand] = ACTIONS(5951),
    [sym__splat_star] = ACTIONS(5951),
    [sym__unary_minus] = ACTIONS(5951),
    [sym__identifier_hash_key] = ACTIONS(5951),
    [anon_sym_LBRACE] = ACTIONS(5951),
    [anon_sym_def] = ACTIONS(5953),
    [anon_sym_LPAREN] = ACTIONS(5953),
    [anon_sym_RPAREN] = ACTIONS(5951),
    [anon_sym_DOT] = ACTIONS(5951),
    [anon_sym_COLON_COLON] = ACTIONS(5953),
    [anon_sym_COMMA] = ACTIONS(5951),
    [anon_sym_STAR] = ACTIONS(5953),
    [anon_sym_STAR_STAR] = ACTIONS(5951),
    [anon_sym_EQ] = ACTIONS(5951),
    [anon_sym_class] = ACTIONS(5953),
    [anon_sym_module] = ACTIONS(5953),
    [anon_sym_return] = ACTIONS(5953),
    [anon_sym_yield] = ACTIONS(5953),
    [anon_sym_break] = ACTIONS(5953),
    [anon_sym_next] = ACTIONS(5953),
    [sym_redo] = ACTIONS(5953),
    [sym_retry] = ACTIONS(5953),
    [anon_sym_if] = ACTIONS(5953),
    [anon_sym_unless] = ACTIONS(5953),
    [anon_sym_while] = ACTIONS(5953),
    [anon_sym_until] = ACTIONS(5953),
    [anon_sym_for] = ACTIONS(5953),
    [anon_sym_in] = ACTIONS(5953),
    [anon_sym_do] = ACTIONS(5953),
    [anon_sym_case] = ACTIONS(5953),
    [anon_sym_begin] = ACTIONS(5953),
    [anon_sym_LBRACK] = ACTIONS(5951),
    [anon_sym_COLON_COLON2] = ACTIONS(5951),
    [anon_sym_AMP_DOT] = ACTIONS(5951),
    [anon_sym_LPAREN2] = ACTIONS(5951),
    [anon_sym_PLUS] = ACTIONS(5953),
    [anon_sym_defined_QMARK] = ACTIONS(5951),
    [anon_sym_not] = ACTIONS(5953),
    [anon_sym_BANG] = ACTIONS(5951),
    [anon_sym_TILDE] = ACTIONS(5951),
    [sym_constant] = ACTIONS(5953),
    [sym_identifier] = ACTIONS(5953),
    [sym_instance_variable] = ACTIONS(5951),
    [sym_class_variable] = ACTIONS(5951),
    [sym_global_variable] = ACTIONS(5951),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5953),
    [sym_float] = ACTIONS(5953),
    [sym_complex] = ACTIONS(5951),
    [sym_super] = ACTIONS(5953),
    [anon_sym_true] = ACTIONS(5953),
    [anon_sym_TRUE] = ACTIONS(5953),
    [anon_sym_false] = ACTIONS(5953),
    [anon_sym_FALSE] = ACTIONS(5953),
    [sym_self] = ACTIONS(5953),
    [anon_sym_nil] = ACTIONS(5953),
    [anon_sym_NIL] = ACTIONS(5953),
    [sym_character] = ACTIONS(5951),
    [anon_sym_LBRACK2] = ACTIONS(5953),
    [anon_sym_DASH_GT] = ACTIONS(5951),
  },
  [2325] = {
    [sym__heredoc_body_start] = ACTIONS(101),
    [sym__binary_minus] = ACTIONS(101),
    [sym__binary_star] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(103),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_PIPE] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(101),
    [anon_sym_AMP] = ACTIONS(103),
    [anon_sym_EQ] = ACTIONS(103),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_do] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_COLON_COLON2] = ACTIONS(101),
    [anon_sym_AMP_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_DOT_DOT] = ACTIONS(103),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_and] = ACTIONS(101),
    [anon_sym_or] = ACTIONS(101),
    [anon_sym_PIPE_PIPE] = ACTIONS(101),
    [anon_sym_AMP_AMP] = ACTIONS(101),
    [anon_sym_LT_LT] = ACTIONS(101),
    [anon_sym_GT_GT] = ACTIONS(101),
    [anon_sym_EQ_EQ] = ACTIONS(103),
    [anon_sym_BANG_EQ] = ACTIONS(101),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(101),
    [anon_sym_LT_EQ_GT] = ACTIONS(101),
    [anon_sym_EQ_TILDE] = ACTIONS(101),
    [anon_sym_BANG_TILDE] = ACTIONS(101),
    [anon_sym_LT_EQ] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_EQ] = ACTIONS(101),
    [anon_sym_CARET] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(101),
    [anon_sym_PERCENT] = ACTIONS(101),
    [sym_comment] = ACTIONS(87),
  },
  [2326] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(4726),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(7657),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [2327] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(4728),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(7659),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [2328] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(4730),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(7661),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [2329] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(4732),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(7663),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [2330] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(4735),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(7665),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(7667),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [2331] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(4738),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(7669),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(7671),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [2332] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(4739),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2357),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(2357),
    [sym_assignment] = STATE(4739),
    [sym_operator_assignment] = STATE(4739),
    [sym_conditional] = STATE(4739),
    [sym_range] = STATE(4739),
    [sym_binary] = STATE(4739),
    [sym_unary] = STATE(4739),
    [sym_left_assignment_list] = STATE(2356),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2357),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2357),
    [sym_false] = STATE(2357),
    [sym_nil] = STATE(2357),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2358),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(4005),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(4009),
    [sym__subshell_start] = ACTIONS(4011),
    [sym__regex_start] = ACTIONS(4013),
    [sym__string_array_start] = ACTIONS(4015),
    [sym__symbol_array_start] = ACTIONS(4017),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4019),
    [anon_sym_LBRACE] = ACTIONS(4021),
    [anon_sym_def] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4025),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(4027),
    [anon_sym_module] = ACTIONS(4029),
    [anon_sym_return] = ACTIONS(4031),
    [anon_sym_yield] = ACTIONS(4033),
    [anon_sym_break] = ACTIONS(4035),
    [anon_sym_next] = ACTIONS(4037),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(4039),
    [anon_sym_unless] = ACTIONS(4041),
    [anon_sym_while] = ACTIONS(4043),
    [anon_sym_until] = ACTIONS(4045),
    [anon_sym_for] = ACTIONS(4047),
    [anon_sym_case] = ACTIONS(4049),
    [anon_sym_begin] = ACTIONS(4051),
    [anon_sym_PLUS] = ACTIONS(4053),
    [anon_sym_defined_QMARK] = ACTIONS(4055),
    [anon_sym_not] = ACTIONS(4057),
    [anon_sym_BANG] = ACTIONS(4059),
    [anon_sym_TILDE] = ACTIONS(4059),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4065),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(4067),
    [anon_sym_DASH_GT] = ACTIONS(4069),
  },
  [2333] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(113),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(118),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(118),
    [sym_hash_splat_argument] = STATE(116),
    [sym_assignment] = STATE(113),
    [sym_operator_assignment] = STATE(113),
    [sym_conditional] = STATE(113),
    [sym_range] = STATE(113),
    [sym_binary] = STATE(113),
    [sym_unary] = STATE(113),
    [sym_left_assignment_list] = STATE(117),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(118),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(118),
    [sym_false] = STATE(118),
    [sym_nil] = STATE(118),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(119),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_heredoc_body] = STATE(4741),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym__hash_items] = STATE(4742),
    [sym_pair] = STATE(122),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [sym__identifier_hash_key] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_RBRACE] = ACTIONS(7673),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(209),
    [sym_identifier] = ACTIONS(209),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2334] = {
    [sym__method_rest] = STATE(4744),
    [sym__variable] = STATE(4745),
    [sym_operator] = STATE(4746),
    [sym__method_name] = STATE(4746),
    [sym_setter] = STATE(4746),
    [sym_symbol] = STATE(4746),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_LPAREN] = ACTIONS(7675),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(239),
    [sym_identifier] = ACTIONS(241),
    [sym_instance_variable] = ACTIONS(239),
    [sym_class_variable] = ACTIONS(239),
    [sym_global_variable] = ACTIONS(239),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
    [sym_super] = ACTIONS(7677),
    [sym_self] = ACTIONS(7677),
  },
  [2335] = {
    [sym__statements] = STATE(4748),
    [sym_begin_block] = STATE(144),
    [sym_end_block] = STATE(144),
    [sym__statement] = STATE(144),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(144),
    [sym_unless_modifier] = STATE(144),
    [sym_while_modifier] = STATE(144),
    [sym_until_modifier] = STATE(144),
    [sym_rescue_modifier] = STATE(144),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(145),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(150),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(150),
    [sym_assignment] = STATE(145),
    [sym_operator_assignment] = STATE(145),
    [sym_conditional] = STATE(145),
    [sym_range] = STATE(145),
    [sym_binary] = STATE(145),
    [sym_unary] = STATE(145),
    [sym_left_assignment_list] = STATE(147),
    [sym__mlhs] = STATE(148),
    [sym_destructured_left_assignment] = STATE(149),
    [sym_rest_assignment] = STATE(149),
    [sym__lhs] = STATE(150),
    [sym__variable] = STATE(146),
    [sym_undef] = STATE(144),
    [sym_alias] = STATE(144),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(150),
    [sym_false] = STATE(150),
    [sym_nil] = STATE(150),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(151),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(152),
    [aux_sym__statements_repeat1] = STATE(152),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_RPAREN] = ACTIONS(7679),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(249),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [anon_sym_undef] = ACTIONS(271),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2336] = {
    [sym_method] = STATE(191),
    [sym_singleton_method] = STATE(191),
    [sym_class] = STATE(191),
    [sym_singleton_class] = STATE(191),
    [sym_module] = STATE(191),
    [sym_return] = STATE(191),
    [sym_yield] = STATE(191),
    [sym_break] = STATE(191),
    [sym_next] = STATE(191),
    [sym_while] = STATE(191),
    [sym_until] = STATE(191),
    [sym_for] = STATE(191),
    [sym_case] = STATE(191),
    [sym_if] = STATE(191),
    [sym_unless] = STATE(191),
    [sym_begin] = STATE(191),
    [sym__primary] = STATE(191),
    [sym_parenthesized_statements] = STATE(191),
    [sym_element_reference] = STATE(191),
    [sym_scope_resolution] = STATE(4751),
    [sym_call] = STATE(193),
    [sym_method_call] = STATE(191),
    [sym__lhs] = STATE(191),
    [sym__variable] = STATE(193),
    [sym_rational] = STATE(191),
    [sym_true] = STATE(191),
    [sym_false] = STATE(191),
    [sym_nil] = STATE(191),
    [sym_chained_string] = STATE(191),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(191),
    [sym_string_array] = STATE(191),
    [sym_symbol_array] = STATE(191),
    [sym_symbol] = STATE(191),
    [sym_regex] = STATE(191),
    [sym_array] = STATE(191),
    [sym_hash] = STATE(191),
    [sym_lambda] = STATE(191),
    [sym__simple_symbol] = ACTIONS(279),
    [sym__string_start] = ACTIONS(281),
    [sym__symbol_start] = ACTIONS(283),
    [sym__subshell_start] = ACTIONS(285),
    [sym__regex_start] = ACTIONS(287),
    [sym__string_array_start] = ACTIONS(289),
    [sym__symbol_array_start] = ACTIONS(291),
    [sym_heredoc_beginning] = ACTIONS(349),
    [sym__singleton_class_left_angle_left_langle] = ACTIONS(7681),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_def] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(299),
    [anon_sym_COLON_COLON] = ACTIONS(353),
    [anon_sym_class] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(307),
    [anon_sym_return] = ACTIONS(309),
    [anon_sym_yield] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_next] = ACTIONS(315),
    [sym_redo] = ACTIONS(355),
    [sym_retry] = ACTIONS(355),
    [anon_sym_if] = ACTIONS(319),
    [anon_sym_unless] = ACTIONS(321),
    [anon_sym_while] = ACTIONS(323),
    [anon_sym_until] = ACTIONS(325),
    [anon_sym_for] = ACTIONS(327),
    [anon_sym_case] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(331),
    [sym_constant] = ACTIONS(7683),
    [sym_identifier] = ACTIONS(359),
    [sym_instance_variable] = ACTIONS(361),
    [sym_class_variable] = ACTIONS(361),
    [sym_global_variable] = ACTIONS(361),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(355),
    [sym_complex] = ACTIONS(349),
    [sym_super] = ACTIONS(359),
    [anon_sym_true] = ACTIONS(339),
    [anon_sym_TRUE] = ACTIONS(339),
    [anon_sym_false] = ACTIONS(341),
    [anon_sym_FALSE] = ACTIONS(341),
    [sym_self] = ACTIONS(359),
    [anon_sym_nil] = ACTIONS(343),
    [anon_sym_NIL] = ACTIONS(343),
    [sym_character] = ACTIONS(349),
    [anon_sym_LBRACK2] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(347),
  },
  [2337] = {
    [sym_method] = STATE(191),
    [sym_singleton_method] = STATE(191),
    [sym_class] = STATE(191),
    [sym_singleton_class] = STATE(191),
    [sym_module] = STATE(191),
    [sym_return] = STATE(191),
    [sym_yield] = STATE(191),
    [sym_break] = STATE(191),
    [sym_next] = STATE(191),
    [sym_while] = STATE(191),
    [sym_until] = STATE(191),
    [sym_for] = STATE(191),
    [sym_case] = STATE(191),
    [sym_if] = STATE(191),
    [sym_unless] = STATE(191),
    [sym_begin] = STATE(191),
    [sym__primary] = STATE(191),
    [sym_parenthesized_statements] = STATE(191),
    [sym_element_reference] = STATE(191),
    [sym_scope_resolution] = STATE(4753),
    [sym_call] = STATE(193),
    [sym_method_call] = STATE(191),
    [sym__lhs] = STATE(191),
    [sym__variable] = STATE(193),
    [sym_rational] = STATE(191),
    [sym_true] = STATE(191),
    [sym_false] = STATE(191),
    [sym_nil] = STATE(191),
    [sym_chained_string] = STATE(191),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(191),
    [sym_string_array] = STATE(191),
    [sym_symbol_array] = STATE(191),
    [sym_symbol] = STATE(191),
    [sym_regex] = STATE(191),
    [sym_array] = STATE(191),
    [sym_hash] = STATE(191),
    [sym_lambda] = STATE(191),
    [sym__simple_symbol] = ACTIONS(279),
    [sym__string_start] = ACTIONS(281),
    [sym__symbol_start] = ACTIONS(283),
    [sym__subshell_start] = ACTIONS(285),
    [sym__regex_start] = ACTIONS(287),
    [sym__string_array_start] = ACTIONS(289),
    [sym__symbol_array_start] = ACTIONS(291),
    [sym_heredoc_beginning] = ACTIONS(349),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_def] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(299),
    [anon_sym_COLON_COLON] = ACTIONS(353),
    [anon_sym_class] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(307),
    [anon_sym_return] = ACTIONS(309),
    [anon_sym_yield] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_next] = ACTIONS(315),
    [sym_redo] = ACTIONS(355),
    [sym_retry] = ACTIONS(355),
    [anon_sym_if] = ACTIONS(319),
    [anon_sym_unless] = ACTIONS(321),
    [anon_sym_while] = ACTIONS(323),
    [anon_sym_until] = ACTIONS(325),
    [anon_sym_for] = ACTIONS(327),
    [anon_sym_case] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(331),
    [sym_constant] = ACTIONS(7685),
    [sym_identifier] = ACTIONS(359),
    [sym_instance_variable] = ACTIONS(361),
    [sym_class_variable] = ACTIONS(361),
    [sym_global_variable] = ACTIONS(361),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(355),
    [sym_complex] = ACTIONS(349),
    [sym_super] = ACTIONS(359),
    [anon_sym_true] = ACTIONS(339),
    [anon_sym_TRUE] = ACTIONS(339),
    [anon_sym_false] = ACTIONS(341),
    [anon_sym_FALSE] = ACTIONS(341),
    [sym_self] = ACTIONS(359),
    [anon_sym_nil] = ACTIONS(343),
    [anon_sym_NIL] = ACTIONS(343),
    [sym_character] = ACTIONS(349),
    [anon_sym_LBRACK2] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(347),
  },
  [2338] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4760),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(837),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(837),
    [sym_argument_list] = STATE(4761),
    [sym__argument_list_with_parens] = STATE(4762),
    [sym__argument] = STATE(4763),
    [sym_splat_argument] = STATE(4763),
    [sym_hash_splat_argument] = STATE(4763),
    [sym_block_argument] = STATE(4763),
    [sym_assignment] = STATE(4760),
    [sym_operator_assignment] = STATE(4760),
    [sym_conditional] = STATE(4760),
    [sym_range] = STATE(4760),
    [sym_binary] = STATE(4760),
    [sym_unary] = STATE(4760),
    [sym_left_assignment_list] = STATE(836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(837),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(837),
    [sym_false] = STATE(837),
    [sym_nil] = STATE(837),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4764),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(4763),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(7687),
    [sym__splat_star] = ACTIONS(7689),
    [sym__unary_minus] = ACTIONS(1485),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(7691),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1493),
    [anon_sym_yield] = ACTIONS(1495),
    [anon_sym_break] = ACTIONS(1497),
    [anon_sym_next] = ACTIONS(1499),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(7693),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(4081),
    [anon_sym_TILDE] = ACTIONS(1507),
    [sym_constant] = ACTIONS(7695),
    [sym_identifier] = ACTIONS(7695),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2339] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4760),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(837),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(837),
    [sym_argument_list] = STATE(4765),
    [sym__argument_list_with_parens] = STATE(4762),
    [sym__argument] = STATE(4763),
    [sym_splat_argument] = STATE(4763),
    [sym_hash_splat_argument] = STATE(4763),
    [sym_block_argument] = STATE(4763),
    [sym_assignment] = STATE(4760),
    [sym_operator_assignment] = STATE(4760),
    [sym_conditional] = STATE(4760),
    [sym_range] = STATE(4760),
    [sym_binary] = STATE(4760),
    [sym_unary] = STATE(4760),
    [sym_left_assignment_list] = STATE(836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(837),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(837),
    [sym_false] = STATE(837),
    [sym_nil] = STATE(837),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4764),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(4763),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(7687),
    [sym__splat_star] = ACTIONS(7689),
    [sym__unary_minus] = ACTIONS(1485),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(7691),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_EQ] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1493),
    [anon_sym_yield] = ACTIONS(1495),
    [anon_sym_break] = ACTIONS(1497),
    [anon_sym_next] = ACTIONS(1499),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(7693),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(4081),
    [anon_sym_TILDE] = ACTIONS(1507),
    [sym_constant] = ACTIONS(7695),
    [sym_identifier] = ACTIONS(7695),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2340] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4760),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(837),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(837),
    [sym_argument_list] = STATE(4766),
    [sym__argument_list_with_parens] = STATE(4762),
    [sym__argument] = STATE(4763),
    [sym_splat_argument] = STATE(4763),
    [sym_hash_splat_argument] = STATE(4763),
    [sym_block_argument] = STATE(4763),
    [sym_assignment] = STATE(4760),
    [sym_operator_assignment] = STATE(4760),
    [sym_conditional] = STATE(4760),
    [sym_range] = STATE(4760),
    [sym_binary] = STATE(4760),
    [sym_unary] = STATE(4760),
    [sym_left_assignment_list] = STATE(836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(837),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(837),
    [sym_false] = STATE(837),
    [sym_nil] = STATE(837),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4764),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(4763),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(7687),
    [sym__splat_star] = ACTIONS(7689),
    [sym__unary_minus] = ACTIONS(1485),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(7691),
    [anon_sym_LBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_EQ] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1493),
    [anon_sym_yield] = ACTIONS(1495),
    [anon_sym_break] = ACTIONS(1497),
    [anon_sym_next] = ACTIONS(1499),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(7693),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(4081),
    [anon_sym_TILDE] = ACTIONS(1507),
    [sym_constant] = ACTIONS(7695),
    [sym_identifier] = ACTIONS(7695),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2341] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4760),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(837),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(837),
    [sym_argument_list] = STATE(4767),
    [sym__argument_list_with_parens] = STATE(4762),
    [sym__argument] = STATE(4763),
    [sym_splat_argument] = STATE(4763),
    [sym_hash_splat_argument] = STATE(4763),
    [sym_block_argument] = STATE(4763),
    [sym_assignment] = STATE(4760),
    [sym_operator_assignment] = STATE(4760),
    [sym_conditional] = STATE(4760),
    [sym_range] = STATE(4760),
    [sym_binary] = STATE(4760),
    [sym_unary] = STATE(4760),
    [sym_left_assignment_list] = STATE(836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(837),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(837),
    [sym_false] = STATE(837),
    [sym_nil] = STATE(837),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4764),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(4763),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(7687),
    [sym__splat_star] = ACTIONS(7689),
    [sym__unary_minus] = ACTIONS(1485),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(7691),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1493),
    [anon_sym_yield] = ACTIONS(1495),
    [anon_sym_break] = ACTIONS(1497),
    [anon_sym_next] = ACTIONS(1499),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(7693),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(4081),
    [anon_sym_TILDE] = ACTIONS(1507),
    [sym_constant] = ACTIONS(7695),
    [sym_identifier] = ACTIONS(7695),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2342] = {
    [sym_begin_block] = STATE(4768),
    [sym_end_block] = STATE(4768),
    [sym__statement] = STATE(4768),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(4768),
    [sym_unless_modifier] = STATE(4768),
    [sym_while_modifier] = STATE(4768),
    [sym_until_modifier] = STATE(4768),
    [sym_rescue_modifier] = STATE(4768),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(234),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(234),
    [sym_operator_assignment] = STATE(234),
    [sym_conditional] = STATE(234),
    [sym_range] = STATE(234),
    [sym_binary] = STATE(234),
    [sym_unary] = STATE(234),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_undef] = STATE(4768),
    [sym_alias] = STATE(4768),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(429),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_yield] = ACTIONS(433),
    [anon_sym_break] = ACTIONS(435),
    [anon_sym_next] = ACTIONS(437),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(439),
    [anon_sym_defined_QMARK] = ACTIONS(441),
    [anon_sym_not] = ACTIONS(443),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [anon_sym_undef] = ACTIONS(451),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2343] = {
    [sym_begin_block] = STATE(4769),
    [sym_end_block] = STATE(4769),
    [sym__statement] = STATE(4769),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(4769),
    [sym_unless_modifier] = STATE(4769),
    [sym_while_modifier] = STATE(4769),
    [sym_until_modifier] = STATE(4769),
    [sym_rescue_modifier] = STATE(4769),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(234),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(234),
    [sym_operator_assignment] = STATE(234),
    [sym_conditional] = STATE(234),
    [sym_range] = STATE(234),
    [sym_binary] = STATE(234),
    [sym_unary] = STATE(234),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_undef] = STATE(4769),
    [sym_alias] = STATE(4769),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(429),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_yield] = ACTIONS(433),
    [anon_sym_break] = ACTIONS(435),
    [anon_sym_next] = ACTIONS(437),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(439),
    [anon_sym_defined_QMARK] = ACTIONS(441),
    [anon_sym_not] = ACTIONS(443),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [anon_sym_undef] = ACTIONS(451),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2344] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(4770),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(4770),
    [sym_operator_assignment] = STATE(4770),
    [sym_conditional] = STATE(4770),
    [sym_range] = STATE(4770),
    [sym_binary] = STATE(4770),
    [sym_unary] = STATE(4770),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(455),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_break] = ACTIONS(459),
    [anon_sym_next] = ACTIONS(461),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_defined_QMARK] = ACTIONS(465),
    [anon_sym_not] = ACTIONS(467),
    [anon_sym_BANG] = ACTIONS(469),
    [anon_sym_TILDE] = ACTIONS(469),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2345] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(4771),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(4771),
    [sym_operator_assignment] = STATE(4771),
    [sym_conditional] = STATE(4771),
    [sym_range] = STATE(4771),
    [sym_binary] = STATE(4771),
    [sym_unary] = STATE(4771),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(455),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_break] = ACTIONS(459),
    [anon_sym_next] = ACTIONS(461),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_defined_QMARK] = ACTIONS(465),
    [anon_sym_not] = ACTIONS(467),
    [anon_sym_BANG] = ACTIONS(469),
    [anon_sym_TILDE] = ACTIONS(469),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2346] = {
    [sym_method] = STATE(184),
    [sym_singleton_method] = STATE(184),
    [sym_class] = STATE(184),
    [sym_singleton_class] = STATE(184),
    [sym_module] = STATE(184),
    [sym_return] = STATE(184),
    [sym_yield] = STATE(184),
    [sym_break] = STATE(184),
    [sym_next] = STATE(184),
    [sym_while] = STATE(184),
    [sym_until] = STATE(184),
    [sym_for] = STATE(184),
    [sym_case] = STATE(184),
    [sym_if] = STATE(184),
    [sym_unless] = STATE(184),
    [sym_begin] = STATE(184),
    [sym__primary] = STATE(184),
    [sym_parenthesized_statements] = STATE(184),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(255),
    [sym_call] = STATE(255),
    [sym_method_call] = STATE(258),
    [sym__mlhs] = STATE(4772),
    [sym_destructured_left_assignment] = STATE(257),
    [sym_rest_assignment] = STATE(257),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(255),
    [sym_rational] = STATE(184),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(184),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(184),
    [sym_string_array] = STATE(184),
    [sym_symbol_array] = STATE(184),
    [sym_symbol] = STATE(184),
    [sym_regex] = STATE(184),
    [sym_array] = STATE(184),
    [sym_hash] = STATE(184),
    [sym_lambda] = STATE(184),
    [sym__simple_symbol] = ACTIONS(279),
    [sym__string_start] = ACTIONS(281),
    [sym__symbol_start] = ACTIONS(283),
    [sym__subshell_start] = ACTIONS(285),
    [sym__regex_start] = ACTIONS(287),
    [sym__string_array_start] = ACTIONS(289),
    [sym__symbol_array_start] = ACTIONS(291),
    [sym_heredoc_beginning] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_def] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(475),
    [anon_sym_COLON_COLON] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(477),
    [anon_sym_class] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(307),
    [anon_sym_return] = ACTIONS(309),
    [anon_sym_yield] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_next] = ACTIONS(315),
    [sym_redo] = ACTIONS(317),
    [sym_retry] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(319),
    [anon_sym_unless] = ACTIONS(321),
    [anon_sym_while] = ACTIONS(323),
    [anon_sym_until] = ACTIONS(325),
    [anon_sym_for] = ACTIONS(327),
    [anon_sym_case] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(331),
    [sym_constant] = ACTIONS(479),
    [sym_identifier] = ACTIONS(479),
    [sym_instance_variable] = ACTIONS(481),
    [sym_class_variable] = ACTIONS(481),
    [sym_global_variable] = ACTIONS(481),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(317),
    [sym_complex] = ACTIONS(293),
    [sym_super] = ACTIONS(479),
    [anon_sym_true] = ACTIONS(339),
    [anon_sym_TRUE] = ACTIONS(339),
    [anon_sym_false] = ACTIONS(341),
    [anon_sym_FALSE] = ACTIONS(341),
    [sym_self] = ACTIONS(479),
    [anon_sym_nil] = ACTIONS(343),
    [anon_sym_NIL] = ACTIONS(343),
    [sym_character] = ACTIONS(293),
    [anon_sym_LBRACK2] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(347),
  },
  [2347] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(4773),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(4773),
    [sym_operator_assignment] = STATE(4773),
    [sym_conditional] = STATE(4773),
    [sym_range] = STATE(4773),
    [sym_binary] = STATE(4773),
    [sym_unary] = STATE(4773),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_heredoc_body] = STATE(4774),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__terminator] = STATE(4774),
    [sym__line_break] = ACTIONS(7697),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(485),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(7697),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(495),
    [anon_sym_defined_QMARK] = ACTIONS(497),
    [anon_sym_not] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(501),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2348] = {
    [sym__statements] = STATE(4775),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(4776),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(4777),
    [sym_rescue] = STATE(4778),
    [sym__body_statement] = STATE(4779),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_heredoc_body] = STATE(4780),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [sym__terminator] = STATE(4780),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__line_break] = ACTIONS(7699),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(7699),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(7701),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2349] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(4781),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2357),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(2357),
    [sym_assignment] = STATE(4781),
    [sym_operator_assignment] = STATE(4781),
    [sym_conditional] = STATE(4781),
    [sym_range] = STATE(4781),
    [sym_binary] = STATE(4781),
    [sym_unary] = STATE(4781),
    [sym_left_assignment_list] = STATE(2356),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2357),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2357),
    [sym_false] = STATE(2357),
    [sym_nil] = STATE(2357),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2358),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(4005),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(4009),
    [sym__subshell_start] = ACTIONS(4011),
    [sym__regex_start] = ACTIONS(4013),
    [sym__string_array_start] = ACTIONS(4015),
    [sym__symbol_array_start] = ACTIONS(4017),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4019),
    [anon_sym_LBRACE] = ACTIONS(4021),
    [anon_sym_def] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4025),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(4027),
    [anon_sym_module] = ACTIONS(4029),
    [anon_sym_return] = ACTIONS(4031),
    [anon_sym_yield] = ACTIONS(4033),
    [anon_sym_break] = ACTIONS(4035),
    [anon_sym_next] = ACTIONS(4037),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(4039),
    [anon_sym_unless] = ACTIONS(4041),
    [anon_sym_while] = ACTIONS(4043),
    [anon_sym_until] = ACTIONS(4045),
    [anon_sym_for] = ACTIONS(4047),
    [anon_sym_case] = ACTIONS(4049),
    [anon_sym_begin] = ACTIONS(4051),
    [anon_sym_PLUS] = ACTIONS(4053),
    [anon_sym_defined_QMARK] = ACTIONS(4055),
    [anon_sym_not] = ACTIONS(4057),
    [anon_sym_BANG] = ACTIONS(4059),
    [anon_sym_TILDE] = ACTIONS(4059),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4065),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(4067),
    [anon_sym_DASH_GT] = ACTIONS(4069),
  },
  [2350] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(4782),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2357),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(2357),
    [sym_assignment] = STATE(4782),
    [sym_operator_assignment] = STATE(4782),
    [sym_conditional] = STATE(4782),
    [sym_range] = STATE(4782),
    [sym_binary] = STATE(4782),
    [sym_unary] = STATE(4782),
    [sym_left_assignment_list] = STATE(2356),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2357),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2357),
    [sym_false] = STATE(2357),
    [sym_nil] = STATE(2357),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2358),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(4005),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(4009),
    [sym__subshell_start] = ACTIONS(4011),
    [sym__regex_start] = ACTIONS(4013),
    [sym__string_array_start] = ACTIONS(4015),
    [sym__symbol_array_start] = ACTIONS(4017),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4019),
    [anon_sym_LBRACE] = ACTIONS(4021),
    [anon_sym_def] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4025),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(4027),
    [anon_sym_module] = ACTIONS(4029),
    [anon_sym_return] = ACTIONS(4031),
    [anon_sym_yield] = ACTIONS(4033),
    [anon_sym_break] = ACTIONS(4035),
    [anon_sym_next] = ACTIONS(4037),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(4039),
    [anon_sym_unless] = ACTIONS(4041),
    [anon_sym_while] = ACTIONS(4043),
    [anon_sym_until] = ACTIONS(4045),
    [anon_sym_for] = ACTIONS(4047),
    [anon_sym_case] = ACTIONS(4049),
    [anon_sym_begin] = ACTIONS(4051),
    [anon_sym_PLUS] = ACTIONS(4053),
    [anon_sym_defined_QMARK] = ACTIONS(4055),
    [anon_sym_not] = ACTIONS(4057),
    [anon_sym_BANG] = ACTIONS(4059),
    [anon_sym_TILDE] = ACTIONS(4059),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4065),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(4067),
    [anon_sym_DASH_GT] = ACTIONS(4069),
  },
  [2351] = {
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
    [anon_sym_r] = ACTIONS(7703),
  },
  [2352] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(346),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(352),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(352),
    [sym__argument_list_with_trailing_comma] = STATE(4785),
    [sym__argument] = STATE(350),
    [sym_splat_argument] = STATE(350),
    [sym_hash_splat_argument] = STATE(350),
    [sym_block_argument] = STATE(350),
    [sym_assignment] = STATE(346),
    [sym_operator_assignment] = STATE(346),
    [sym_conditional] = STATE(346),
    [sym_range] = STATE(346),
    [sym_binary] = STATE(346),
    [sym_unary] = STATE(346),
    [sym_left_assignment_list] = STATE(351),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(352),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(352),
    [sym_false] = STATE(352),
    [sym_nil] = STATE(352),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(353),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(350),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(593),
    [sym__splat_star] = ACTIONS(595),
    [sym__unary_minus] = ACTIONS(597),
    [sym__identifier_hash_key] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(7705),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2353] = {
    [sym_lambda_parameters] = STATE(4788),
    [sym__simple_formal_parameter] = STATE(362),
    [sym_splat_parameter] = STATE(362),
    [sym_hash_splat_parameter] = STATE(362),
    [sym_block_parameter] = STATE(362),
    [sym_keyword_parameter] = STATE(362),
    [sym_optional_parameter] = STATE(362),
    [sym_do_block] = STATE(4789),
    [sym_block] = STATE(4789),
    [anon_sym_LBRACE] = ACTIONS(7707),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(7709),
    [sym_identifier] = ACTIONS(679),
    [sym_comment] = ACTIONS(87),
  },
  [2354] = {
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(7711),
    [sym__binary_star] = ACTIONS(7713),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(7715),
    [anon_sym_STAR_STAR] = ACTIONS(7713),
    [anon_sym_AMP] = ACTIONS(7717),
    [anon_sym_EQ] = ACTIONS(4217),
    [anon_sym_LT] = ACTIONS(7719),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(7721),
    [anon_sym_DOT_DOT] = ACTIONS(7723),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7725),
    [anon_sym_and] = ACTIONS(7727),
    [anon_sym_or] = ACTIONS(7727),
    [anon_sym_PIPE_PIPE] = ACTIONS(7729),
    [anon_sym_AMP_AMP] = ACTIONS(7729),
    [anon_sym_LT_LT] = ACTIONS(7731),
    [anon_sym_GT_GT] = ACTIONS(7731),
    [anon_sym_EQ_EQ] = ACTIONS(7733),
    [anon_sym_BANG_EQ] = ACTIONS(7729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7729),
    [anon_sym_LT_EQ_GT] = ACTIONS(7729),
    [anon_sym_EQ_TILDE] = ACTIONS(7729),
    [anon_sym_BANG_TILDE] = ACTIONS(7729),
    [anon_sym_LT_EQ] = ACTIONS(7719),
    [anon_sym_GT] = ACTIONS(7719),
    [anon_sym_GT_EQ] = ACTIONS(7735),
    [anon_sym_CARET] = ACTIONS(7737),
    [anon_sym_PLUS] = ACTIONS(7711),
    [anon_sym_SLASH] = ACTIONS(7713),
    [anon_sym_PERCENT] = ACTIONS(7713),
    [sym_comment] = ACTIONS(87),
  },
  [2355] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4683),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_argument_list] = STATE(4801),
    [sym__argument_list_with_parens] = STATE(4684),
    [sym__argument] = STATE(4685),
    [sym_splat_argument] = STATE(4685),
    [sym_hash_splat_argument] = STATE(4685),
    [sym_block_argument] = STATE(4685),
    [sym_do_block] = STATE(1849),
    [sym_block] = STATE(1849),
    [sym_assignment] = STATE(4683),
    [sym_operator_assignment] = STATE(4683),
    [sym_conditional] = STATE(4683),
    [sym_range] = STATE(4683),
    [sym_binary] = STATE(4683),
    [sym_unary] = STATE(4683),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4686),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(4685),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(7603),
    [sym__splat_star] = ACTIONS(7605),
    [sym__unary_minus] = ACTIONS(1159),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(7607),
    [anon_sym_LBRACE] = ACTIONS(7739),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(769),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1205),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(7609),
    [sym_identifier] = ACTIONS(7609),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2356] = {
    [anon_sym_EQ] = ACTIONS(7741),
    [sym_comment] = ACTIONS(87),
  },
  [2357] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(7743),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(7745),
    [anon_sym_DASH_EQ] = ACTIONS(7745),
    [anon_sym_STAR_EQ] = ACTIONS(7745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7745),
    [anon_sym_SLASH_EQ] = ACTIONS(7745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7745),
    [anon_sym_PIPE_EQ] = ACTIONS(7745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7745),
    [anon_sym_AMP_EQ] = ACTIONS(7745),
    [anon_sym_PERCENT_EQ] = ACTIONS(7745),
    [anon_sym_GT_GT_EQ] = ACTIONS(7745),
    [anon_sym_LT_LT_EQ] = ACTIONS(7745),
    [anon_sym_CARET_EQ] = ACTIONS(7745),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2358] = {
    [sym_string] = STATE(4804),
    [aux_sym_chained_string_repeat1] = STATE(4804),
    [sym__string_start] = ACTIONS(4007),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2359] = {
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(7711),
    [sym__binary_star] = ACTIONS(7713),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(7715),
    [anon_sym_STAR_STAR] = ACTIONS(7713),
    [anon_sym_AMP] = ACTIONS(7717),
    [anon_sym_EQ] = ACTIONS(4249),
    [anon_sym_LT] = ACTIONS(7719),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(7721),
    [anon_sym_DOT_DOT] = ACTIONS(7723),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7725),
    [anon_sym_and] = ACTIONS(7727),
    [anon_sym_or] = ACTIONS(7727),
    [anon_sym_PIPE_PIPE] = ACTIONS(7729),
    [anon_sym_AMP_AMP] = ACTIONS(7729),
    [anon_sym_LT_LT] = ACTIONS(7731),
    [anon_sym_GT_GT] = ACTIONS(7731),
    [anon_sym_EQ_EQ] = ACTIONS(7733),
    [anon_sym_BANG_EQ] = ACTIONS(7729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7729),
    [anon_sym_LT_EQ_GT] = ACTIONS(7729),
    [anon_sym_EQ_TILDE] = ACTIONS(7729),
    [anon_sym_BANG_TILDE] = ACTIONS(7729),
    [anon_sym_LT_EQ] = ACTIONS(7719),
    [anon_sym_GT] = ACTIONS(7719),
    [anon_sym_GT_EQ] = ACTIONS(7735),
    [anon_sym_CARET] = ACTIONS(7737),
    [anon_sym_PLUS] = ACTIONS(7711),
    [anon_sym_SLASH] = ACTIONS(7713),
    [anon_sym_PERCENT] = ACTIONS(7713),
    [sym_comment] = ACTIONS(87),
  },
  [2360] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(4089),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [2361] = {
    [sym_string] = STATE(2392),
    [aux_sym_chained_string_repeat1] = STATE(2392),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2362] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(4805),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2357),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(2357),
    [sym_assignment] = STATE(4805),
    [sym_operator_assignment] = STATE(4805),
    [sym_conditional] = STATE(4805),
    [sym_range] = STATE(4805),
    [sym_binary] = STATE(4805),
    [sym_unary] = STATE(4805),
    [sym_left_assignment_list] = STATE(2356),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2357),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2357),
    [sym_false] = STATE(2357),
    [sym_nil] = STATE(2357),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2358),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(4005),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(4009),
    [sym__subshell_start] = ACTIONS(4011),
    [sym__regex_start] = ACTIONS(4013),
    [sym__string_array_start] = ACTIONS(4015),
    [sym__symbol_array_start] = ACTIONS(4017),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4019),
    [anon_sym_LBRACE] = ACTIONS(4021),
    [anon_sym_def] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4025),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(4027),
    [anon_sym_module] = ACTIONS(4029),
    [anon_sym_return] = ACTIONS(4031),
    [anon_sym_yield] = ACTIONS(4033),
    [anon_sym_break] = ACTIONS(4035),
    [anon_sym_next] = ACTIONS(4037),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(4039),
    [anon_sym_unless] = ACTIONS(4041),
    [anon_sym_while] = ACTIONS(4043),
    [anon_sym_until] = ACTIONS(4045),
    [anon_sym_for] = ACTIONS(4047),
    [anon_sym_case] = ACTIONS(4049),
    [anon_sym_begin] = ACTIONS(4051),
    [anon_sym_PLUS] = ACTIONS(4053),
    [anon_sym_defined_QMARK] = ACTIONS(4055),
    [anon_sym_not] = ACTIONS(4057),
    [anon_sym_BANG] = ACTIONS(4059),
    [anon_sym_TILDE] = ACTIONS(4059),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4065),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(4067),
    [anon_sym_DASH_GT] = ACTIONS(4069),
  },
  [2363] = {
    [sym__heredoc_body_start] = ACTIONS(993),
    [sym__binary_minus] = ACTIONS(993),
    [sym__binary_star] = ACTIONS(993),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_RPAREN] = ACTIONS(5735),
    [anon_sym_DOT] = ACTIONS(5737),
    [anon_sym_COMMA] = ACTIONS(5735),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_STAR_STAR] = ACTIONS(993),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_EQ] = ACTIONS(5737),
    [anon_sym_LT] = ACTIONS(995),
    [anon_sym_in] = ACTIONS(5735),
    [anon_sym_do] = ACTIONS(993),
    [anon_sym_EQ_GT] = ACTIONS(993),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_COLON_COLON2] = ACTIONS(5735),
    [anon_sym_AMP_DOT] = ACTIONS(5735),
    [anon_sym_QMARK] = ACTIONS(993),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(993),
    [anon_sym_and] = ACTIONS(993),
    [anon_sym_or] = ACTIONS(993),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_AMP_AMP] = ACTIONS(993),
    [anon_sym_LT_LT] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(993),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(993),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(993),
    [anon_sym_LT_EQ_GT] = ACTIONS(993),
    [anon_sym_EQ_TILDE] = ACTIONS(993),
    [anon_sym_BANG_TILDE] = ACTIONS(993),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(993),
    [anon_sym_CARET] = ACTIONS(993),
    [anon_sym_PLUS] = ACTIONS(993),
    [anon_sym_SLASH] = ACTIONS(993),
    [anon_sym_PERCENT] = ACTIONS(993),
    [sym_comment] = ACTIONS(87),
  },
  [2364] = {
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(7711),
    [sym__binary_star] = ACTIONS(7713),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(7715),
    [anon_sym_STAR_STAR] = ACTIONS(7713),
    [anon_sym_AMP] = ACTIONS(7717),
    [anon_sym_EQ] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(7719),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(7721),
    [anon_sym_DOT_DOT] = ACTIONS(7723),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7725),
    [anon_sym_and] = ACTIONS(7727),
    [anon_sym_or] = ACTIONS(7727),
    [anon_sym_PIPE_PIPE] = ACTIONS(7729),
    [anon_sym_AMP_AMP] = ACTIONS(7729),
    [anon_sym_LT_LT] = ACTIONS(7731),
    [anon_sym_GT_GT] = ACTIONS(7731),
    [anon_sym_EQ_EQ] = ACTIONS(7733),
    [anon_sym_BANG_EQ] = ACTIONS(7729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7729),
    [anon_sym_LT_EQ_GT] = ACTIONS(7729),
    [anon_sym_EQ_TILDE] = ACTIONS(7729),
    [anon_sym_BANG_TILDE] = ACTIONS(7729),
    [anon_sym_LT_EQ] = ACTIONS(7719),
    [anon_sym_GT] = ACTIONS(7719),
    [anon_sym_GT_EQ] = ACTIONS(7735),
    [anon_sym_CARET] = ACTIONS(7737),
    [anon_sym_PLUS] = ACTIONS(7711),
    [anon_sym_SLASH] = ACTIONS(7713),
    [anon_sym_PERCENT] = ACTIONS(7713),
    [sym_comment] = ACTIONS(87),
  },
  [2365] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4806),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(837),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(837),
    [sym_assignment] = STATE(4806),
    [sym_operator_assignment] = STATE(4806),
    [sym_conditional] = STATE(4806),
    [sym_range] = STATE(4806),
    [sym_binary] = STATE(4806),
    [sym_unary] = STATE(4806),
    [sym_left_assignment_list] = STATE(836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(837),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(837),
    [sym_false] = STATE(837),
    [sym_nil] = STATE(837),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2361),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1485),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1493),
    [anon_sym_yield] = ACTIONS(1495),
    [anon_sym_break] = ACTIONS(1497),
    [anon_sym_next] = ACTIONS(1499),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1507),
    [anon_sym_TILDE] = ACTIONS(1507),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2366] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4807),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(837),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(837),
    [sym_assignment] = STATE(4807),
    [sym_operator_assignment] = STATE(4807),
    [sym_conditional] = STATE(4807),
    [sym_range] = STATE(4807),
    [sym_binary] = STATE(4807),
    [sym_unary] = STATE(4807),
    [sym_left_assignment_list] = STATE(836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(837),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(837),
    [sym_false] = STATE(837),
    [sym_nil] = STATE(837),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2361),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1485),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1493),
    [anon_sym_yield] = ACTIONS(1495),
    [anon_sym_break] = ACTIONS(1497),
    [anon_sym_next] = ACTIONS(1499),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1507),
    [anon_sym_TILDE] = ACTIONS(1507),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2367] = {
    [anon_sym_COLON] = ACTIONS(7747),
    [sym_comment] = ACTIONS(87),
  },
  [2368] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4809),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(837),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(837),
    [sym_assignment] = STATE(4809),
    [sym_operator_assignment] = STATE(4809),
    [sym_conditional] = STATE(4809),
    [sym_range] = STATE(4809),
    [sym_binary] = STATE(4809),
    [sym_unary] = STATE(4809),
    [sym_left_assignment_list] = STATE(836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(837),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(837),
    [sym_false] = STATE(837),
    [sym_nil] = STATE(837),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2361),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1485),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1493),
    [anon_sym_yield] = ACTIONS(1495),
    [anon_sym_break] = ACTIONS(1497),
    [anon_sym_next] = ACTIONS(1499),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1507),
    [anon_sym_TILDE] = ACTIONS(1507),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2369] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(7749),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [2370] = {
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(4087),
    [sym__binary_star] = ACTIONS(4089),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(4091),
    [anon_sym_STAR_STAR] = ACTIONS(4089),
    [anon_sym_AMP] = ACTIONS(4093),
    [anon_sym_EQ] = ACTIONS(1631),
    [anon_sym_LT] = ACTIONS(4095),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(1625),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(4097),
    [anon_sym_DOT_DOT] = ACTIONS(4099),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4101),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(4105),
    [anon_sym_AMP_AMP] = ACTIONS(4105),
    [anon_sym_LT_LT] = ACTIONS(4107),
    [anon_sym_GT_GT] = ACTIONS(4107),
    [anon_sym_EQ_EQ] = ACTIONS(4109),
    [anon_sym_BANG_EQ] = ACTIONS(4105),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4105),
    [anon_sym_LT_EQ_GT] = ACTIONS(4105),
    [anon_sym_EQ_TILDE] = ACTIONS(4105),
    [anon_sym_BANG_TILDE] = ACTIONS(4105),
    [anon_sym_LT_EQ] = ACTIONS(4095),
    [anon_sym_GT] = ACTIONS(4095),
    [anon_sym_GT_EQ] = ACTIONS(4111),
    [anon_sym_CARET] = ACTIONS(4113),
    [anon_sym_PLUS] = ACTIONS(4087),
    [anon_sym_SLASH] = ACTIONS(4089),
    [anon_sym_PERCENT] = ACTIONS(4089),
    [sym_comment] = ACTIONS(87),
  },
  [2371] = {
    [sym_heredoc_body] = STATE(4811),
    [aux_sym_call_repeat1] = STATE(4811),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [2372] = {
    [sym_heredoc_body] = STATE(4811),
    [aux_sym_call_repeat1] = STATE(4811),
    [aux_sym_argument_list_repeat1] = STATE(4813),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(7751),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [2373] = {
    [sym_string] = STATE(2392),
    [aux_sym_chained_string_repeat1] = STATE(2392),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(7753),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2374] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(4087),
    [sym__binary_star] = ACTIONS(4089),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(4091),
    [anon_sym_STAR_STAR] = ACTIONS(4089),
    [anon_sym_AMP] = ACTIONS(4093),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(4095),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(4097),
    [anon_sym_DOT_DOT] = ACTIONS(4099),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4101),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(4105),
    [anon_sym_AMP_AMP] = ACTIONS(4105),
    [anon_sym_LT_LT] = ACTIONS(4107),
    [anon_sym_GT_GT] = ACTIONS(4107),
    [anon_sym_EQ_EQ] = ACTIONS(4109),
    [anon_sym_BANG_EQ] = ACTIONS(4105),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4105),
    [anon_sym_LT_EQ_GT] = ACTIONS(4105),
    [anon_sym_EQ_TILDE] = ACTIONS(4105),
    [anon_sym_BANG_TILDE] = ACTIONS(4105),
    [anon_sym_LT_EQ] = ACTIONS(4095),
    [anon_sym_GT] = ACTIONS(4095),
    [anon_sym_GT_EQ] = ACTIONS(4111),
    [anon_sym_CARET] = ACTIONS(4113),
    [anon_sym_PLUS] = ACTIONS(4087),
    [anon_sym_SLASH] = ACTIONS(4089),
    [anon_sym_PERCENT] = ACTIONS(4089),
    [sym_comment] = ACTIONS(87),
  },
  [2375] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(4814),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2357),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(2357),
    [sym_assignment] = STATE(4814),
    [sym_operator_assignment] = STATE(4814),
    [sym_conditional] = STATE(4814),
    [sym_range] = STATE(4814),
    [sym_binary] = STATE(4814),
    [sym_unary] = STATE(4814),
    [sym_left_assignment_list] = STATE(2356),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2357),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2357),
    [sym_false] = STATE(2357),
    [sym_nil] = STATE(2357),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2358),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(4005),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(4009),
    [sym__subshell_start] = ACTIONS(4011),
    [sym__regex_start] = ACTIONS(4013),
    [sym__string_array_start] = ACTIONS(4015),
    [sym__symbol_array_start] = ACTIONS(4017),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4019),
    [anon_sym_LBRACE] = ACTIONS(4021),
    [anon_sym_def] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4025),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(4027),
    [anon_sym_module] = ACTIONS(4029),
    [anon_sym_return] = ACTIONS(4031),
    [anon_sym_yield] = ACTIONS(4033),
    [anon_sym_break] = ACTIONS(4035),
    [anon_sym_next] = ACTIONS(4037),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(4039),
    [anon_sym_unless] = ACTIONS(4041),
    [anon_sym_while] = ACTIONS(4043),
    [anon_sym_until] = ACTIONS(4045),
    [anon_sym_for] = ACTIONS(4047),
    [anon_sym_case] = ACTIONS(4049),
    [anon_sym_begin] = ACTIONS(4051),
    [anon_sym_PLUS] = ACTIONS(4053),
    [anon_sym_defined_QMARK] = ACTIONS(4055),
    [anon_sym_not] = ACTIONS(4057),
    [anon_sym_BANG] = ACTIONS(4059),
    [anon_sym_TILDE] = ACTIONS(4059),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4065),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(4067),
    [anon_sym_DASH_GT] = ACTIONS(4069),
  },
  [2376] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4815),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(837),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(837),
    [sym_assignment] = STATE(4815),
    [sym_operator_assignment] = STATE(4815),
    [sym_conditional] = STATE(4815),
    [sym_range] = STATE(4815),
    [sym_binary] = STATE(4815),
    [sym_unary] = STATE(4815),
    [sym_left_assignment_list] = STATE(836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(837),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(837),
    [sym_false] = STATE(837),
    [sym_nil] = STATE(837),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2361),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1485),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1493),
    [anon_sym_yield] = ACTIONS(1495),
    [anon_sym_break] = ACTIONS(1497),
    [anon_sym_next] = ACTIONS(1499),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1507),
    [anon_sym_TILDE] = ACTIONS(1507),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2377] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4816),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(837),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(837),
    [sym_assignment] = STATE(4816),
    [sym_operator_assignment] = STATE(4816),
    [sym_conditional] = STATE(4816),
    [sym_range] = STATE(4816),
    [sym_binary] = STATE(4816),
    [sym_unary] = STATE(4816),
    [sym_left_assignment_list] = STATE(836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(837),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(837),
    [sym_false] = STATE(837),
    [sym_nil] = STATE(837),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2361),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1485),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1493),
    [anon_sym_yield] = ACTIONS(1495),
    [anon_sym_break] = ACTIONS(1497),
    [anon_sym_next] = ACTIONS(1499),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1507),
    [anon_sym_TILDE] = ACTIONS(1507),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2378] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4817),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(837),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(837),
    [sym_assignment] = STATE(4817),
    [sym_operator_assignment] = STATE(4817),
    [sym_conditional] = STATE(4817),
    [sym_range] = STATE(4817),
    [sym_binary] = STATE(4817),
    [sym_unary] = STATE(4817),
    [sym_left_assignment_list] = STATE(836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(837),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(837),
    [sym_false] = STATE(837),
    [sym_nil] = STATE(837),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2361),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1485),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1493),
    [anon_sym_yield] = ACTIONS(1495),
    [anon_sym_break] = ACTIONS(1497),
    [anon_sym_next] = ACTIONS(1499),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1507),
    [anon_sym_TILDE] = ACTIONS(1507),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2379] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4818),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(837),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(837),
    [sym_assignment] = STATE(4818),
    [sym_operator_assignment] = STATE(4818),
    [sym_conditional] = STATE(4818),
    [sym_range] = STATE(4818),
    [sym_binary] = STATE(4818),
    [sym_unary] = STATE(4818),
    [sym_left_assignment_list] = STATE(836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(837),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(837),
    [sym_false] = STATE(837),
    [sym_nil] = STATE(837),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2361),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1485),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1493),
    [anon_sym_yield] = ACTIONS(1495),
    [anon_sym_break] = ACTIONS(1497),
    [anon_sym_next] = ACTIONS(1499),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1507),
    [anon_sym_TILDE] = ACTIONS(1507),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2380] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4819),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(837),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(837),
    [sym_assignment] = STATE(4819),
    [sym_operator_assignment] = STATE(4819),
    [sym_conditional] = STATE(4819),
    [sym_range] = STATE(4819),
    [sym_binary] = STATE(4819),
    [sym_unary] = STATE(4819),
    [sym_left_assignment_list] = STATE(836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(837),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(837),
    [sym_false] = STATE(837),
    [sym_nil] = STATE(837),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2361),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1485),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1493),
    [anon_sym_yield] = ACTIONS(1495),
    [anon_sym_break] = ACTIONS(1497),
    [anon_sym_next] = ACTIONS(1499),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1507),
    [anon_sym_TILDE] = ACTIONS(1507),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2381] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(4820),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(4820),
    [sym_operator_assignment] = STATE(4820),
    [sym_conditional] = STATE(4820),
    [sym_range] = STATE(4820),
    [sym_binary] = STATE(4820),
    [sym_unary] = STATE(4820),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2382] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4821),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(837),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(837),
    [sym_assignment] = STATE(4821),
    [sym_operator_assignment] = STATE(4821),
    [sym_conditional] = STATE(4821),
    [sym_range] = STATE(4821),
    [sym_binary] = STATE(4821),
    [sym_unary] = STATE(4821),
    [sym_left_assignment_list] = STATE(836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(837),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(837),
    [sym_false] = STATE(837),
    [sym_nil] = STATE(837),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2361),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1485),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1493),
    [anon_sym_yield] = ACTIONS(1495),
    [anon_sym_break] = ACTIONS(1497),
    [anon_sym_next] = ACTIONS(1499),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1507),
    [anon_sym_TILDE] = ACTIONS(1507),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2383] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4822),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(837),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(837),
    [sym_assignment] = STATE(4822),
    [sym_operator_assignment] = STATE(4822),
    [sym_conditional] = STATE(4822),
    [sym_range] = STATE(4822),
    [sym_binary] = STATE(4822),
    [sym_unary] = STATE(4822),
    [sym_left_assignment_list] = STATE(836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(837),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(837),
    [sym_false] = STATE(837),
    [sym_nil] = STATE(837),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2361),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1485),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1493),
    [anon_sym_yield] = ACTIONS(1495),
    [anon_sym_break] = ACTIONS(1497),
    [anon_sym_next] = ACTIONS(1499),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1507),
    [anon_sym_TILDE] = ACTIONS(1507),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2384] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4823),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(837),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(837),
    [sym_assignment] = STATE(4823),
    [sym_operator_assignment] = STATE(4823),
    [sym_conditional] = STATE(4823),
    [sym_range] = STATE(4823),
    [sym_binary] = STATE(4823),
    [sym_unary] = STATE(4823),
    [sym_left_assignment_list] = STATE(836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(837),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(837),
    [sym_false] = STATE(837),
    [sym_nil] = STATE(837),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2361),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1485),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1493),
    [anon_sym_yield] = ACTIONS(1495),
    [anon_sym_break] = ACTIONS(1497),
    [anon_sym_next] = ACTIONS(1499),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1507),
    [anon_sym_TILDE] = ACTIONS(1507),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2385] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4824),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(837),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(837),
    [sym_assignment] = STATE(4824),
    [sym_operator_assignment] = STATE(4824),
    [sym_conditional] = STATE(4824),
    [sym_range] = STATE(4824),
    [sym_binary] = STATE(4824),
    [sym_unary] = STATE(4824),
    [sym_left_assignment_list] = STATE(836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(837),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(837),
    [sym_false] = STATE(837),
    [sym_nil] = STATE(837),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2361),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1485),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1493),
    [anon_sym_yield] = ACTIONS(1495),
    [anon_sym_break] = ACTIONS(1497),
    [anon_sym_next] = ACTIONS(1499),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1507),
    [anon_sym_TILDE] = ACTIONS(1507),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2386] = {
    [anon_sym_RPAREN] = ACTIONS(6155),
    [anon_sym_DOT] = ACTIONS(6155),
    [anon_sym_COMMA] = ACTIONS(6155),
    [anon_sym_EQ] = ACTIONS(6155),
    [anon_sym_in] = ACTIONS(6155),
    [anon_sym_LBRACK] = ACTIONS(6155),
    [anon_sym_COLON_COLON2] = ACTIONS(6155),
    [anon_sym_AMP_DOT] = ACTIONS(6155),
    [sym_comment] = ACTIONS(87),
  },
  [2387] = {
    [sym_heredoc_body] = STATE(4825),
    [aux_sym_call_repeat1] = STATE(4825),
    [sym__heredoc_body_start] = ACTIONS(3959),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4383),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_EQ] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [2388] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(831),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(837),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(837),
    [sym__argument] = STATE(3454),
    [sym_splat_argument] = STATE(3454),
    [sym_hash_splat_argument] = STATE(3454),
    [sym_block_argument] = STATE(3454),
    [sym_assignment] = STATE(831),
    [sym_operator_assignment] = STATE(831),
    [sym_conditional] = STATE(831),
    [sym_range] = STATE(831),
    [sym_binary] = STATE(831),
    [sym_unary] = STATE(831),
    [sym_left_assignment_list] = STATE(836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(837),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(837),
    [sym_false] = STATE(837),
    [sym_nil] = STATE(837),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(838),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_heredoc_body] = STATE(4826),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(3454),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1481),
    [sym__splat_star] = ACTIONS(1483),
    [sym__unary_minus] = ACTIONS(1485),
    [sym__identifier_hash_key] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1491),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1493),
    [anon_sym_yield] = ACTIONS(1495),
    [anon_sym_break] = ACTIONS(1497),
    [anon_sym_next] = ACTIONS(1499),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1507),
    [anon_sym_TILDE] = ACTIONS(1507),
    [sym_constant] = ACTIONS(1509),
    [sym_identifier] = ACTIONS(1509),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2389] = {
    [sym_heredoc_body] = STATE(4827),
    [aux_sym_call_repeat1] = STATE(4827),
    [aux_sym_argument_list_repeat1] = STATE(4828),
    [sym__heredoc_body_start] = ACTIONS(3959),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4383),
    [anon_sym_COMMA] = ACTIONS(4115),
    [anon_sym_EQ] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [2390] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4829),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(837),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(837),
    [sym_splat_argument] = STATE(4830),
    [sym_assignment] = STATE(4829),
    [sym_operator_assignment] = STATE(4829),
    [sym_conditional] = STATE(4829),
    [sym_range] = STATE(4829),
    [sym_binary] = STATE(4829),
    [sym_unary] = STATE(4829),
    [sym_right_assignment_list] = STATE(4255),
    [sym__arg_or_splat_arg] = STATE(4830),
    [sym_left_assignment_list] = STATE(836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(837),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(837),
    [sym_false] = STATE(837),
    [sym_nil] = STATE(837),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2361),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(4077),
    [sym__unary_minus] = ACTIONS(1485),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1493),
    [anon_sym_yield] = ACTIONS(1495),
    [anon_sym_break] = ACTIONS(1497),
    [anon_sym_next] = ACTIONS(1499),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1507),
    [anon_sym_TILDE] = ACTIONS(1507),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2391] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4831),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(837),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(837),
    [sym_assignment] = STATE(4831),
    [sym_operator_assignment] = STATE(4831),
    [sym_conditional] = STATE(4831),
    [sym_range] = STATE(4831),
    [sym_binary] = STATE(4831),
    [sym_unary] = STATE(4831),
    [sym_left_assignment_list] = STATE(836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(837),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(837),
    [sym_false] = STATE(837),
    [sym_nil] = STATE(837),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2361),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1485),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1493),
    [anon_sym_yield] = ACTIONS(1495),
    [anon_sym_break] = ACTIONS(1497),
    [anon_sym_next] = ACTIONS(1499),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1507),
    [anon_sym_TILDE] = ACTIONS(1507),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2392] = {
    [sym_string] = STATE(4832),
    [aux_sym_chained_string_repeat1] = STATE(4832),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_EQ] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_EQ_GT] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [2393] = {
    [sym_string] = STATE(2393),
    [aux_sym_chained_string_repeat1] = STATE(2393),
    [sym__string_start] = ACTIONS(7755),
    [anon_sym_DOT] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [2394] = {
    [sym__statements] = STATE(284),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(286),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(287),
    [sym_rescue] = STATE(288),
    [sym__body_statement] = STATE(4833),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(7758),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2395] = {
    [sym__line_break] = ACTIONS(7760),
    [sym__heredoc_body_start] = ACTIONS(7760),
    [sym__binary_minus] = ACTIONS(2001),
    [sym__binary_star] = ACTIONS(2003),
    [anon_sym_PIPE] = ACTIONS(2005),
    [anon_sym_SEMI] = ACTIONS(7760),
    [anon_sym_STAR_STAR] = ACTIONS(2003),
    [anon_sym_AMP] = ACTIONS(2007),
    [anon_sym_LT] = ACTIONS(2009),
    [anon_sym_QMARK] = ACTIONS(2011),
    [anon_sym_DOT_DOT] = ACTIONS(2013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2015),
    [anon_sym_and] = ACTIONS(2017),
    [anon_sym_or] = ACTIONS(2017),
    [anon_sym_PIPE_PIPE] = ACTIONS(2019),
    [anon_sym_AMP_AMP] = ACTIONS(2019),
    [anon_sym_LT_LT] = ACTIONS(2021),
    [anon_sym_GT_GT] = ACTIONS(2021),
    [anon_sym_EQ_EQ] = ACTIONS(2023),
    [anon_sym_BANG_EQ] = ACTIONS(2019),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2019),
    [anon_sym_LT_EQ_GT] = ACTIONS(2019),
    [anon_sym_EQ_TILDE] = ACTIONS(2019),
    [anon_sym_BANG_TILDE] = ACTIONS(2019),
    [anon_sym_LT_EQ] = ACTIONS(2009),
    [anon_sym_GT] = ACTIONS(2009),
    [anon_sym_GT_EQ] = ACTIONS(2025),
    [anon_sym_CARET] = ACTIONS(2027),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_SLASH] = ACTIONS(2003),
    [anon_sym_PERCENT] = ACTIONS(2003),
    [sym_comment] = ACTIONS(87),
  },
  [2396] = {
    [sym__statements] = STATE(284),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(286),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(287),
    [sym_rescue] = STATE(288),
    [sym__body_statement] = STATE(4834),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(7762),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2397] = {
    [sym__line_break] = ACTIONS(7764),
    [sym__heredoc_body_start] = ACTIONS(7764),
    [sym__binary_minus] = ACTIONS(7764),
    [sym__binary_star] = ACTIONS(7764),
    [ts_builtin_sym_end] = ACTIONS(7764),
    [anon_sym___END__] = ACTIONS(7764),
    [anon_sym_LBRACE] = ACTIONS(7764),
    [anon_sym_RBRACE] = ACTIONS(7764),
    [anon_sym_RPAREN] = ACTIONS(7764),
    [anon_sym_DOT] = ACTIONS(7766),
    [anon_sym_COMMA] = ACTIONS(7764),
    [anon_sym_PIPE] = ACTIONS(7766),
    [anon_sym_SEMI] = ACTIONS(7764),
    [anon_sym_STAR_STAR] = ACTIONS(7764),
    [anon_sym_AMP] = ACTIONS(7766),
    [anon_sym_LT] = ACTIONS(7766),
    [anon_sym_end] = ACTIONS(7764),
    [anon_sym_if] = ACTIONS(7764),
    [anon_sym_unless] = ACTIONS(7764),
    [anon_sym_while] = ACTIONS(7764),
    [anon_sym_until] = ACTIONS(7764),
    [anon_sym_rescue] = ACTIONS(7764),
    [anon_sym_do] = ACTIONS(7764),
    [anon_sym_when] = ACTIONS(7764),
    [anon_sym_elsif] = ACTIONS(7764),
    [anon_sym_else] = ACTIONS(7764),
    [anon_sym_then] = ACTIONS(7764),
    [anon_sym_ensure] = ACTIONS(7764),
    [anon_sym_EQ_GT] = ACTIONS(7764),
    [anon_sym_LBRACK] = ACTIONS(7764),
    [anon_sym_COLON_COLON2] = ACTIONS(7764),
    [anon_sym_AMP_DOT] = ACTIONS(7764),
    [anon_sym_QMARK] = ACTIONS(7764),
    [anon_sym_DOT_DOT] = ACTIONS(7766),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7764),
    [anon_sym_and] = ACTIONS(7764),
    [anon_sym_or] = ACTIONS(7764),
    [anon_sym_PIPE_PIPE] = ACTIONS(7764),
    [anon_sym_AMP_AMP] = ACTIONS(7764),
    [anon_sym_LT_LT] = ACTIONS(7764),
    [anon_sym_GT_GT] = ACTIONS(7764),
    [anon_sym_EQ_EQ] = ACTIONS(7766),
    [anon_sym_BANG_EQ] = ACTIONS(7764),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7764),
    [anon_sym_LT_EQ_GT] = ACTIONS(7764),
    [anon_sym_EQ_TILDE] = ACTIONS(7764),
    [anon_sym_BANG_TILDE] = ACTIONS(7764),
    [anon_sym_LT_EQ] = ACTIONS(7766),
    [anon_sym_GT] = ACTIONS(7766),
    [anon_sym_GT_EQ] = ACTIONS(7764),
    [anon_sym_CARET] = ACTIONS(7764),
    [anon_sym_PLUS] = ACTIONS(7764),
    [anon_sym_SLASH] = ACTIONS(7764),
    [anon_sym_PERCENT] = ACTIONS(7764),
    [sym_comment] = ACTIONS(87),
  },
  [2398] = {
    [sym__line_break] = ACTIONS(5951),
    [sym__simple_symbol] = ACTIONS(5951),
    [sym__string_start] = ACTIONS(5951),
    [sym__symbol_start] = ACTIONS(5951),
    [sym__subshell_start] = ACTIONS(5951),
    [sym__regex_start] = ACTIONS(5951),
    [sym__string_array_start] = ACTIONS(5951),
    [sym__symbol_array_start] = ACTIONS(5951),
    [sym__heredoc_body_start] = ACTIONS(5951),
    [sym_heredoc_beginning] = ACTIONS(5951),
    [sym__block_ampersand] = ACTIONS(5951),
    [sym__splat_star] = ACTIONS(5951),
    [sym__unary_minus] = ACTIONS(5951),
    [sym__identifier_hash_key] = ACTIONS(5951),
    [anon_sym_LBRACE] = ACTIONS(5951),
    [anon_sym_def] = ACTIONS(5953),
    [anon_sym_LPAREN] = ACTIONS(5953),
    [anon_sym_DOT] = ACTIONS(5951),
    [anon_sym_COLON_COLON] = ACTIONS(5953),
    [anon_sym_SEMI] = ACTIONS(5951),
    [anon_sym_STAR] = ACTIONS(5953),
    [anon_sym_STAR_STAR] = ACTIONS(5951),
    [anon_sym_class] = ACTIONS(5953),
    [anon_sym_LT] = ACTIONS(5951),
    [anon_sym_module] = ACTIONS(5953),
    [anon_sym_end] = ACTIONS(5953),
    [anon_sym_return] = ACTIONS(5953),
    [anon_sym_yield] = ACTIONS(5953),
    [anon_sym_break] = ACTIONS(5953),
    [anon_sym_next] = ACTIONS(5953),
    [sym_redo] = ACTIONS(5953),
    [sym_retry] = ACTIONS(5953),
    [anon_sym_if] = ACTIONS(5953),
    [anon_sym_unless] = ACTIONS(5953),
    [anon_sym_while] = ACTIONS(5953),
    [anon_sym_until] = ACTIONS(5953),
    [anon_sym_for] = ACTIONS(5953),
    [anon_sym_do] = ACTIONS(5953),
    [anon_sym_case] = ACTIONS(5953),
    [anon_sym_then] = ACTIONS(5953),
    [anon_sym_begin] = ACTIONS(5953),
    [anon_sym_LBRACK] = ACTIONS(5951),
    [anon_sym_COLON_COLON2] = ACTIONS(5951),
    [anon_sym_AMP_DOT] = ACTIONS(5951),
    [anon_sym_LPAREN2] = ACTIONS(5951),
    [anon_sym_PLUS] = ACTIONS(5953),
    [anon_sym_defined_QMARK] = ACTIONS(5951),
    [anon_sym_not] = ACTIONS(5953),
    [anon_sym_BANG] = ACTIONS(5951),
    [anon_sym_TILDE] = ACTIONS(5951),
    [sym_constant] = ACTIONS(5953),
    [sym_identifier] = ACTIONS(5953),
    [sym_instance_variable] = ACTIONS(5951),
    [sym_class_variable] = ACTIONS(5951),
    [sym_global_variable] = ACTIONS(5951),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5953),
    [sym_float] = ACTIONS(5953),
    [sym_complex] = ACTIONS(5951),
    [sym_super] = ACTIONS(5953),
    [anon_sym_true] = ACTIONS(5953),
    [anon_sym_TRUE] = ACTIONS(5953),
    [anon_sym_false] = ACTIONS(5953),
    [anon_sym_FALSE] = ACTIONS(5953),
    [sym_self] = ACTIONS(5953),
    [anon_sym_nil] = ACTIONS(5953),
    [anon_sym_NIL] = ACTIONS(5953),
    [sym_character] = ACTIONS(5951),
    [anon_sym_LBRACK2] = ACTIONS(5953),
    [anon_sym_DASH_GT] = ACTIONS(5951),
  },
  [2399] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(4835),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2408),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(2408),
    [sym_assignment] = STATE(4835),
    [sym_operator_assignment] = STATE(4835),
    [sym_conditional] = STATE(4835),
    [sym_range] = STATE(4835),
    [sym_binary] = STATE(4835),
    [sym_unary] = STATE(4835),
    [sym_left_assignment_list] = STATE(2407),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2408),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2408),
    [sym_false] = STATE(2408),
    [sym_nil] = STATE(2408),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2409),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4133),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4135),
    [anon_sym_yield] = ACTIONS(4137),
    [anon_sym_break] = ACTIONS(4139),
    [anon_sym_next] = ACTIONS(4141),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4143),
    [anon_sym_defined_QMARK] = ACTIONS(4145),
    [anon_sym_not] = ACTIONS(4147),
    [anon_sym_BANG] = ACTIONS(4149),
    [anon_sym_TILDE] = ACTIONS(4149),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2400] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4841),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym_argument_list] = STATE(1318),
    [sym__argument_list_with_parens] = STATE(4842),
    [sym__argument] = STATE(4843),
    [sym_splat_argument] = STATE(4843),
    [sym_hash_splat_argument] = STATE(4843),
    [sym_block_argument] = STATE(4843),
    [sym_assignment] = STATE(4841),
    [sym_operator_assignment] = STATE(4841),
    [sym_conditional] = STATE(4841),
    [sym_range] = STATE(4841),
    [sym_binary] = STATE(4841),
    [sym_unary] = STATE(4841),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4844),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(4843),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(7768),
    [sym__splat_star] = ACTIONS(7770),
    [sym__unary_minus] = ACTIONS(1525),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(7772),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(4161),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(7774),
    [sym_identifier] = ACTIONS(7774),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2401] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4841),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym_argument_list] = STATE(1324),
    [sym__argument_list_with_parens] = STATE(4842),
    [sym__argument] = STATE(4843),
    [sym_splat_argument] = STATE(4843),
    [sym_hash_splat_argument] = STATE(4843),
    [sym_block_argument] = STATE(4843),
    [sym_assignment] = STATE(4841),
    [sym_operator_assignment] = STATE(4841),
    [sym_conditional] = STATE(4841),
    [sym_range] = STATE(4841),
    [sym_binary] = STATE(4841),
    [sym_unary] = STATE(4841),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4844),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(4843),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(7768),
    [sym__splat_star] = ACTIONS(7770),
    [sym__unary_minus] = ACTIONS(1525),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(7772),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(4161),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(7774),
    [sym_identifier] = ACTIONS(7774),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2402] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4841),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym_argument_list] = STATE(1325),
    [sym__argument_list_with_parens] = STATE(4842),
    [sym__argument] = STATE(4843),
    [sym_splat_argument] = STATE(4843),
    [sym_hash_splat_argument] = STATE(4843),
    [sym_block_argument] = STATE(4843),
    [sym_assignment] = STATE(4841),
    [sym_operator_assignment] = STATE(4841),
    [sym_conditional] = STATE(4841),
    [sym_range] = STATE(4841),
    [sym_binary] = STATE(4841),
    [sym_unary] = STATE(4841),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4844),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(4843),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(7768),
    [sym__splat_star] = ACTIONS(7770),
    [sym__unary_minus] = ACTIONS(1525),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(7772),
    [anon_sym_LBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(4161),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(7774),
    [sym_identifier] = ACTIONS(7774),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2403] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4841),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym_argument_list] = STATE(1326),
    [sym__argument_list_with_parens] = STATE(4842),
    [sym__argument] = STATE(4843),
    [sym_splat_argument] = STATE(4843),
    [sym_hash_splat_argument] = STATE(4843),
    [sym_block_argument] = STATE(4843),
    [sym_assignment] = STATE(4841),
    [sym_operator_assignment] = STATE(4841),
    [sym_conditional] = STATE(4841),
    [sym_range] = STATE(4841),
    [sym_binary] = STATE(4841),
    [sym_unary] = STATE(4841),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4844),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(4843),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(7768),
    [sym__splat_star] = ACTIONS(7770),
    [sym__unary_minus] = ACTIONS(1525),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(7772),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(4161),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(7774),
    [sym_identifier] = ACTIONS(7774),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2404] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(4845),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2408),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(2408),
    [sym_assignment] = STATE(4845),
    [sym_operator_assignment] = STATE(4845),
    [sym_conditional] = STATE(4845),
    [sym_range] = STATE(4845),
    [sym_binary] = STATE(4845),
    [sym_unary] = STATE(4845),
    [sym_left_assignment_list] = STATE(2407),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2408),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2408),
    [sym_false] = STATE(2408),
    [sym_nil] = STATE(2408),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2409),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4133),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4135),
    [anon_sym_yield] = ACTIONS(4137),
    [anon_sym_break] = ACTIONS(4139),
    [anon_sym_next] = ACTIONS(4141),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4143),
    [anon_sym_defined_QMARK] = ACTIONS(4145),
    [anon_sym_not] = ACTIONS(4147),
    [anon_sym_BANG] = ACTIONS(4149),
    [anon_sym_TILDE] = ACTIONS(4149),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2405] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(1872),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2408),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(2408),
    [sym_assignment] = STATE(1872),
    [sym_operator_assignment] = STATE(1872),
    [sym_conditional] = STATE(1872),
    [sym_range] = STATE(1872),
    [sym_binary] = STATE(1872),
    [sym_unary] = STATE(1872),
    [sym_left_assignment_list] = STATE(2407),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2408),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2408),
    [sym_false] = STATE(2408),
    [sym_nil] = STATE(2408),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2409),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4133),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4135),
    [anon_sym_yield] = ACTIONS(4137),
    [anon_sym_break] = ACTIONS(4139),
    [anon_sym_next] = ACTIONS(4141),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4143),
    [anon_sym_defined_QMARK] = ACTIONS(4145),
    [anon_sym_not] = ACTIONS(4147),
    [anon_sym_BANG] = ACTIONS(4149),
    [anon_sym_TILDE] = ACTIONS(4149),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2406] = {
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(7776),
    [sym__binary_star] = ACTIONS(7778),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(7780),
    [anon_sym_STAR_STAR] = ACTIONS(7778),
    [anon_sym_AMP] = ACTIONS(7782),
    [anon_sym_LT] = ACTIONS(7784),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(7786),
    [anon_sym_DOT_DOT] = ACTIONS(7788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7790),
    [anon_sym_and] = ACTIONS(7792),
    [anon_sym_or] = ACTIONS(7792),
    [anon_sym_PIPE_PIPE] = ACTIONS(7794),
    [anon_sym_AMP_AMP] = ACTIONS(7794),
    [anon_sym_LT_LT] = ACTIONS(7796),
    [anon_sym_GT_GT] = ACTIONS(7796),
    [anon_sym_EQ_EQ] = ACTIONS(7798),
    [anon_sym_BANG_EQ] = ACTIONS(7794),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7794),
    [anon_sym_LT_EQ_GT] = ACTIONS(7794),
    [anon_sym_EQ_TILDE] = ACTIONS(7794),
    [anon_sym_BANG_TILDE] = ACTIONS(7794),
    [anon_sym_LT_EQ] = ACTIONS(7784),
    [anon_sym_GT] = ACTIONS(7784),
    [anon_sym_GT_EQ] = ACTIONS(7800),
    [anon_sym_CARET] = ACTIONS(7802),
    [anon_sym_PLUS] = ACTIONS(7776),
    [anon_sym_SLASH] = ACTIONS(7778),
    [anon_sym_PERCENT] = ACTIONS(7778),
    [sym_comment] = ACTIONS(87),
  },
  [2407] = {
    [anon_sym_EQ] = ACTIONS(7804),
    [sym_comment] = ACTIONS(87),
  },
  [2408] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(7806),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(7808),
    [anon_sym_DASH_EQ] = ACTIONS(7808),
    [anon_sym_STAR_EQ] = ACTIONS(7808),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7808),
    [anon_sym_SLASH_EQ] = ACTIONS(7808),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7808),
    [anon_sym_PIPE_EQ] = ACTIONS(7808),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7808),
    [anon_sym_AMP_EQ] = ACTIONS(7808),
    [anon_sym_PERCENT_EQ] = ACTIONS(7808),
    [anon_sym_GT_GT_EQ] = ACTIONS(7808),
    [anon_sym_LT_LT_EQ] = ACTIONS(7808),
    [anon_sym_CARET_EQ] = ACTIONS(7808),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2409] = {
    [sym_string] = STATE(4858),
    [aux_sym_chained_string_repeat1] = STATE(4858),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2410] = {
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(7776),
    [sym__binary_star] = ACTIONS(7778),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(7780),
    [anon_sym_STAR_STAR] = ACTIONS(7778),
    [anon_sym_AMP] = ACTIONS(7782),
    [anon_sym_LT] = ACTIONS(7784),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(7786),
    [anon_sym_DOT_DOT] = ACTIONS(7788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7790),
    [anon_sym_and] = ACTIONS(7792),
    [anon_sym_or] = ACTIONS(7792),
    [anon_sym_PIPE_PIPE] = ACTIONS(7794),
    [anon_sym_AMP_AMP] = ACTIONS(7794),
    [anon_sym_LT_LT] = ACTIONS(7796),
    [anon_sym_GT_GT] = ACTIONS(7796),
    [anon_sym_EQ_EQ] = ACTIONS(7798),
    [anon_sym_BANG_EQ] = ACTIONS(7794),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7794),
    [anon_sym_LT_EQ_GT] = ACTIONS(7794),
    [anon_sym_EQ_TILDE] = ACTIONS(7794),
    [anon_sym_BANG_TILDE] = ACTIONS(7794),
    [anon_sym_LT_EQ] = ACTIONS(7784),
    [anon_sym_GT] = ACTIONS(7784),
    [anon_sym_GT_EQ] = ACTIONS(7800),
    [anon_sym_CARET] = ACTIONS(7802),
    [anon_sym_PLUS] = ACTIONS(7776),
    [anon_sym_SLASH] = ACTIONS(7778),
    [anon_sym_PERCENT] = ACTIONS(7778),
    [sym_comment] = ACTIONS(87),
  },
  [2411] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(4169),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [2412] = {
    [sym_string] = STATE(2442),
    [aux_sym_chained_string_repeat1] = STATE(2442),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2413] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(4859),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2408),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(2408),
    [sym_assignment] = STATE(4859),
    [sym_operator_assignment] = STATE(4859),
    [sym_conditional] = STATE(4859),
    [sym_range] = STATE(4859),
    [sym_binary] = STATE(4859),
    [sym_unary] = STATE(4859),
    [sym_left_assignment_list] = STATE(2407),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2408),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2408),
    [sym_false] = STATE(2408),
    [sym_nil] = STATE(2408),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2409),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4133),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4135),
    [anon_sym_yield] = ACTIONS(4137),
    [anon_sym_break] = ACTIONS(4139),
    [anon_sym_next] = ACTIONS(4141),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4143),
    [anon_sym_defined_QMARK] = ACTIONS(4145),
    [anon_sym_not] = ACTIONS(4147),
    [anon_sym_BANG] = ACTIONS(4149),
    [anon_sym_TILDE] = ACTIONS(4149),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2414] = {
    [sym__heredoc_body_start] = ACTIONS(993),
    [sym__binary_minus] = ACTIONS(993),
    [sym__binary_star] = ACTIONS(993),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_DOT] = ACTIONS(5737),
    [anon_sym_COMMA] = ACTIONS(993),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_STAR_STAR] = ACTIONS(993),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(995),
    [anon_sym_do] = ACTIONS(993),
    [anon_sym_EQ_GT] = ACTIONS(993),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_COLON_COLON2] = ACTIONS(5735),
    [anon_sym_AMP_DOT] = ACTIONS(5735),
    [anon_sym_QMARK] = ACTIONS(993),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(993),
    [anon_sym_and] = ACTIONS(993),
    [anon_sym_or] = ACTIONS(993),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_AMP_AMP] = ACTIONS(993),
    [anon_sym_LT_LT] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(993),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(993),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(993),
    [anon_sym_LT_EQ_GT] = ACTIONS(993),
    [anon_sym_EQ_TILDE] = ACTIONS(993),
    [anon_sym_BANG_TILDE] = ACTIONS(993),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(993),
    [anon_sym_CARET] = ACTIONS(993),
    [anon_sym_PLUS] = ACTIONS(993),
    [anon_sym_SLASH] = ACTIONS(993),
    [anon_sym_PERCENT] = ACTIONS(993),
    [sym_comment] = ACTIONS(87),
  },
  [2415] = {
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(7776),
    [sym__binary_star] = ACTIONS(7778),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(7780),
    [anon_sym_STAR_STAR] = ACTIONS(7778),
    [anon_sym_AMP] = ACTIONS(7782),
    [anon_sym_LT] = ACTIONS(7784),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(7786),
    [anon_sym_DOT_DOT] = ACTIONS(7788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7790),
    [anon_sym_and] = ACTIONS(7792),
    [anon_sym_or] = ACTIONS(7792),
    [anon_sym_PIPE_PIPE] = ACTIONS(7794),
    [anon_sym_AMP_AMP] = ACTIONS(7794),
    [anon_sym_LT_LT] = ACTIONS(7796),
    [anon_sym_GT_GT] = ACTIONS(7796),
    [anon_sym_EQ_EQ] = ACTIONS(7798),
    [anon_sym_BANG_EQ] = ACTIONS(7794),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7794),
    [anon_sym_LT_EQ_GT] = ACTIONS(7794),
    [anon_sym_EQ_TILDE] = ACTIONS(7794),
    [anon_sym_BANG_TILDE] = ACTIONS(7794),
    [anon_sym_LT_EQ] = ACTIONS(7784),
    [anon_sym_GT] = ACTIONS(7784),
    [anon_sym_GT_EQ] = ACTIONS(7800),
    [anon_sym_CARET] = ACTIONS(7802),
    [anon_sym_PLUS] = ACTIONS(7776),
    [anon_sym_SLASH] = ACTIONS(7778),
    [anon_sym_PERCENT] = ACTIONS(7778),
    [sym_comment] = ACTIONS(87),
  },
  [2416] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4860),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym_assignment] = STATE(4860),
    [sym_operator_assignment] = STATE(4860),
    [sym_conditional] = STATE(4860),
    [sym_range] = STATE(4860),
    [sym_binary] = STATE(4860),
    [sym_unary] = STATE(4860),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2412),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2417] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4861),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym_assignment] = STATE(4861),
    [sym_operator_assignment] = STATE(4861),
    [sym_conditional] = STATE(4861),
    [sym_range] = STATE(4861),
    [sym_binary] = STATE(4861),
    [sym_unary] = STATE(4861),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2412),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2418] = {
    [anon_sym_COLON] = ACTIONS(7810),
    [sym_comment] = ACTIONS(87),
  },
  [2419] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4863),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym_assignment] = STATE(4863),
    [sym_operator_assignment] = STATE(4863),
    [sym_conditional] = STATE(4863),
    [sym_range] = STATE(4863),
    [sym_binary] = STATE(4863),
    [sym_unary] = STATE(4863),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2412),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2420] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(7812),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [2421] = {
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(4167),
    [sym__binary_star] = ACTIONS(4169),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(4171),
    [anon_sym_STAR_STAR] = ACTIONS(4169),
    [anon_sym_AMP] = ACTIONS(4173),
    [anon_sym_LT] = ACTIONS(4175),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(1625),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_DOT_DOT] = ACTIONS(4179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4181),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(4185),
    [anon_sym_AMP_AMP] = ACTIONS(4185),
    [anon_sym_LT_LT] = ACTIONS(4187),
    [anon_sym_GT_GT] = ACTIONS(4187),
    [anon_sym_EQ_EQ] = ACTIONS(4189),
    [anon_sym_BANG_EQ] = ACTIONS(4185),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4185),
    [anon_sym_LT_EQ_GT] = ACTIONS(4185),
    [anon_sym_EQ_TILDE] = ACTIONS(4185),
    [anon_sym_BANG_TILDE] = ACTIONS(4185),
    [anon_sym_LT_EQ] = ACTIONS(4175),
    [anon_sym_GT] = ACTIONS(4175),
    [anon_sym_GT_EQ] = ACTIONS(4191),
    [anon_sym_CARET] = ACTIONS(4193),
    [anon_sym_PLUS] = ACTIONS(4167),
    [anon_sym_SLASH] = ACTIONS(4169),
    [anon_sym_PERCENT] = ACTIONS(4169),
    [sym_comment] = ACTIONS(87),
  },
  [2422] = {
    [sym_heredoc_body] = STATE(4865),
    [aux_sym_call_repeat1] = STATE(4865),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [2423] = {
    [sym_heredoc_body] = STATE(4865),
    [aux_sym_call_repeat1] = STATE(4865),
    [aux_sym_argument_list_repeat1] = STATE(4867),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(7814),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [2424] = {
    [sym_string] = STATE(2442),
    [aux_sym_chained_string_repeat1] = STATE(2442),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(7816),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2425] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(4167),
    [sym__binary_star] = ACTIONS(4169),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(4171),
    [anon_sym_STAR_STAR] = ACTIONS(4169),
    [anon_sym_AMP] = ACTIONS(4173),
    [anon_sym_LT] = ACTIONS(4175),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_DOT_DOT] = ACTIONS(4179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4181),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(4185),
    [anon_sym_AMP_AMP] = ACTIONS(4185),
    [anon_sym_LT_LT] = ACTIONS(4187),
    [anon_sym_GT_GT] = ACTIONS(4187),
    [anon_sym_EQ_EQ] = ACTIONS(4189),
    [anon_sym_BANG_EQ] = ACTIONS(4185),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4185),
    [anon_sym_LT_EQ_GT] = ACTIONS(4185),
    [anon_sym_EQ_TILDE] = ACTIONS(4185),
    [anon_sym_BANG_TILDE] = ACTIONS(4185),
    [anon_sym_LT_EQ] = ACTIONS(4175),
    [anon_sym_GT] = ACTIONS(4175),
    [anon_sym_GT_EQ] = ACTIONS(4191),
    [anon_sym_CARET] = ACTIONS(4193),
    [anon_sym_PLUS] = ACTIONS(4167),
    [anon_sym_SLASH] = ACTIONS(4169),
    [anon_sym_PERCENT] = ACTIONS(4169),
    [sym_comment] = ACTIONS(87),
  },
  [2426] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(4868),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2408),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(2408),
    [sym_assignment] = STATE(4868),
    [sym_operator_assignment] = STATE(4868),
    [sym_conditional] = STATE(4868),
    [sym_range] = STATE(4868),
    [sym_binary] = STATE(4868),
    [sym_unary] = STATE(4868),
    [sym_left_assignment_list] = STATE(2407),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2408),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2408),
    [sym_false] = STATE(2408),
    [sym_nil] = STATE(2408),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2409),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4133),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4135),
    [anon_sym_yield] = ACTIONS(4137),
    [anon_sym_break] = ACTIONS(4139),
    [anon_sym_next] = ACTIONS(4141),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4143),
    [anon_sym_defined_QMARK] = ACTIONS(4145),
    [anon_sym_not] = ACTIONS(4147),
    [anon_sym_BANG] = ACTIONS(4149),
    [anon_sym_TILDE] = ACTIONS(4149),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2427] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4869),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym_assignment] = STATE(4869),
    [sym_operator_assignment] = STATE(4869),
    [sym_conditional] = STATE(4869),
    [sym_range] = STATE(4869),
    [sym_binary] = STATE(4869),
    [sym_unary] = STATE(4869),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2412),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2428] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4870),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym_assignment] = STATE(4870),
    [sym_operator_assignment] = STATE(4870),
    [sym_conditional] = STATE(4870),
    [sym_range] = STATE(4870),
    [sym_binary] = STATE(4870),
    [sym_unary] = STATE(4870),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2412),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2429] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4871),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym_assignment] = STATE(4871),
    [sym_operator_assignment] = STATE(4871),
    [sym_conditional] = STATE(4871),
    [sym_range] = STATE(4871),
    [sym_binary] = STATE(4871),
    [sym_unary] = STATE(4871),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2412),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2430] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4872),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym_assignment] = STATE(4872),
    [sym_operator_assignment] = STATE(4872),
    [sym_conditional] = STATE(4872),
    [sym_range] = STATE(4872),
    [sym_binary] = STATE(4872),
    [sym_unary] = STATE(4872),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2412),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2431] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4873),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym_assignment] = STATE(4873),
    [sym_operator_assignment] = STATE(4873),
    [sym_conditional] = STATE(4873),
    [sym_range] = STATE(4873),
    [sym_binary] = STATE(4873),
    [sym_unary] = STATE(4873),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2412),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2432] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(4874),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(4874),
    [sym_operator_assignment] = STATE(4874),
    [sym_conditional] = STATE(4874),
    [sym_range] = STATE(4874),
    [sym_binary] = STATE(4874),
    [sym_unary] = STATE(4874),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2433] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4875),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym_assignment] = STATE(4875),
    [sym_operator_assignment] = STATE(4875),
    [sym_conditional] = STATE(4875),
    [sym_range] = STATE(4875),
    [sym_binary] = STATE(4875),
    [sym_unary] = STATE(4875),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2412),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2434] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4876),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym_assignment] = STATE(4876),
    [sym_operator_assignment] = STATE(4876),
    [sym_conditional] = STATE(4876),
    [sym_range] = STATE(4876),
    [sym_binary] = STATE(4876),
    [sym_unary] = STATE(4876),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2412),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2435] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4877),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym_assignment] = STATE(4877),
    [sym_operator_assignment] = STATE(4877),
    [sym_conditional] = STATE(4877),
    [sym_range] = STATE(4877),
    [sym_binary] = STATE(4877),
    [sym_unary] = STATE(4877),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2412),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2436] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4878),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym_assignment] = STATE(4878),
    [sym_operator_assignment] = STATE(4878),
    [sym_conditional] = STATE(4878),
    [sym_range] = STATE(4878),
    [sym_binary] = STATE(4878),
    [sym_unary] = STATE(4878),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2412),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2437] = {
    [sym_heredoc_body] = STATE(4879),
    [aux_sym_call_repeat1] = STATE(4879),
    [sym__heredoc_body_start] = ACTIONS(3959),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [2438] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(859),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym__argument] = STATE(3454),
    [sym_splat_argument] = STATE(3454),
    [sym_hash_splat_argument] = STATE(3454),
    [sym_block_argument] = STATE(3454),
    [sym_assignment] = STATE(859),
    [sym_operator_assignment] = STATE(859),
    [sym_conditional] = STATE(859),
    [sym_range] = STATE(859),
    [sym_binary] = STATE(859),
    [sym_unary] = STATE(859),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(864),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_heredoc_body] = STATE(4880),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(3454),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1521),
    [sym__splat_star] = ACTIONS(1523),
    [sym__unary_minus] = ACTIONS(1525),
    [sym__identifier_hash_key] = ACTIONS(1527),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1531),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(1549),
    [sym_identifier] = ACTIONS(1549),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2439] = {
    [sym_heredoc_body] = STATE(4881),
    [aux_sym_call_repeat1] = STATE(4881),
    [aux_sym_argument_list_repeat1] = STATE(4882),
    [sym__heredoc_body_start] = ACTIONS(3959),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4383),
    [anon_sym_COMMA] = ACTIONS(4195),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [2440] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4883),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym_splat_argument] = STATE(4884),
    [sym_assignment] = STATE(4883),
    [sym_operator_assignment] = STATE(4883),
    [sym_conditional] = STATE(4883),
    [sym_range] = STATE(4883),
    [sym_binary] = STATE(4883),
    [sym_unary] = STATE(4883),
    [sym_right_assignment_list] = STATE(4255),
    [sym__arg_or_splat_arg] = STATE(4884),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2412),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(4157),
    [sym__unary_minus] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2441] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4885),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym_assignment] = STATE(4885),
    [sym_operator_assignment] = STATE(4885),
    [sym_conditional] = STATE(4885),
    [sym_range] = STATE(4885),
    [sym_binary] = STATE(4885),
    [sym_unary] = STATE(4885),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2412),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2442] = {
    [sym_string] = STATE(4886),
    [aux_sym_chained_string_repeat1] = STATE(4886),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_EQ_GT] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [2443] = {
    [sym__line_break] = ACTIONS(7818),
    [sym__heredoc_body_start] = ACTIONS(7818),
    [sym__binary_minus] = ACTIONS(7818),
    [sym__binary_star] = ACTIONS(7818),
    [ts_builtin_sym_end] = ACTIONS(7818),
    [anon_sym___END__] = ACTIONS(7818),
    [anon_sym_LBRACE] = ACTIONS(7818),
    [anon_sym_RBRACE] = ACTIONS(7818),
    [anon_sym_RPAREN] = ACTIONS(7818),
    [anon_sym_DOT] = ACTIONS(7820),
    [anon_sym_COMMA] = ACTIONS(7818),
    [anon_sym_PIPE] = ACTIONS(7820),
    [anon_sym_SEMI] = ACTIONS(7818),
    [anon_sym_STAR_STAR] = ACTIONS(7818),
    [anon_sym_AMP] = ACTIONS(7820),
    [anon_sym_LT] = ACTIONS(7820),
    [anon_sym_end] = ACTIONS(7818),
    [anon_sym_if] = ACTIONS(7818),
    [anon_sym_unless] = ACTIONS(7818),
    [anon_sym_while] = ACTIONS(7818),
    [anon_sym_until] = ACTIONS(7818),
    [anon_sym_rescue] = ACTIONS(7818),
    [anon_sym_do] = ACTIONS(7818),
    [anon_sym_when] = ACTIONS(7818),
    [anon_sym_elsif] = ACTIONS(7818),
    [anon_sym_else] = ACTIONS(7818),
    [anon_sym_then] = ACTIONS(7818),
    [anon_sym_ensure] = ACTIONS(7818),
    [anon_sym_EQ_GT] = ACTIONS(7818),
    [anon_sym_LBRACK] = ACTIONS(7818),
    [anon_sym_COLON_COLON2] = ACTIONS(7818),
    [anon_sym_AMP_DOT] = ACTIONS(7818),
    [anon_sym_QMARK] = ACTIONS(7818),
    [anon_sym_DOT_DOT] = ACTIONS(7820),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7818),
    [anon_sym_and] = ACTIONS(7818),
    [anon_sym_or] = ACTIONS(7818),
    [anon_sym_PIPE_PIPE] = ACTIONS(7818),
    [anon_sym_AMP_AMP] = ACTIONS(7818),
    [anon_sym_LT_LT] = ACTIONS(7818),
    [anon_sym_GT_GT] = ACTIONS(7818),
    [anon_sym_EQ_EQ] = ACTIONS(7820),
    [anon_sym_BANG_EQ] = ACTIONS(7818),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7818),
    [anon_sym_LT_EQ_GT] = ACTIONS(7818),
    [anon_sym_EQ_TILDE] = ACTIONS(7818),
    [anon_sym_BANG_TILDE] = ACTIONS(7818),
    [anon_sym_LT_EQ] = ACTIONS(7820),
    [anon_sym_GT] = ACTIONS(7820),
    [anon_sym_GT_EQ] = ACTIONS(7818),
    [anon_sym_CARET] = ACTIONS(7818),
    [anon_sym_PLUS] = ACTIONS(7818),
    [anon_sym_SLASH] = ACTIONS(7818),
    [anon_sym_PERCENT] = ACTIONS(7818),
    [sym_comment] = ACTIONS(87),
  },
  [2444] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [ts_builtin_sym_end] = ACTIONS(935),
    [anon_sym___END__] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(4215),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [2445] = {
    [sym_heredoc_body] = STATE(4887),
    [aux_sym_call_repeat1] = STATE(4887),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [ts_builtin_sym_end] = ACTIONS(1681),
    [anon_sym___END__] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [2446] = {
    [sym_heredoc_body] = STATE(4887),
    [aux_sym_call_repeat1] = STATE(4887),
    [aux_sym_argument_list_repeat1] = STATE(4888),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [ts_builtin_sym_end] = ACTIONS(1681),
    [anon_sym___END__] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1687),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [2447] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(4213),
    [sym__binary_star] = ACTIONS(4215),
    [ts_builtin_sym_end] = ACTIONS(935),
    [anon_sym___END__] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(4219),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(4215),
    [anon_sym_AMP] = ACTIONS(4221),
    [anon_sym_LT] = ACTIONS(4223),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(4225),
    [anon_sym_DOT_DOT] = ACTIONS(4227),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4229),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(4231),
    [anon_sym_AMP_AMP] = ACTIONS(4231),
    [anon_sym_LT_LT] = ACTIONS(4233),
    [anon_sym_GT_GT] = ACTIONS(4233),
    [anon_sym_EQ_EQ] = ACTIONS(4235),
    [anon_sym_BANG_EQ] = ACTIONS(4231),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4231),
    [anon_sym_LT_EQ_GT] = ACTIONS(4231),
    [anon_sym_EQ_TILDE] = ACTIONS(4231),
    [anon_sym_BANG_TILDE] = ACTIONS(4231),
    [anon_sym_LT_EQ] = ACTIONS(4223),
    [anon_sym_GT] = ACTIONS(4223),
    [anon_sym_GT_EQ] = ACTIONS(4237),
    [anon_sym_CARET] = ACTIONS(4239),
    [anon_sym_PLUS] = ACTIONS(4213),
    [anon_sym_SLASH] = ACTIONS(4215),
    [anon_sym_PERCENT] = ACTIONS(4215),
    [sym_comment] = ACTIONS(87),
  },
  [2448] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(4889),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(876),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(876),
    [sym_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(4889),
    [sym_range] = STATE(4889),
    [sym_binary] = STATE(4889),
    [sym_unary] = STATE(4889),
    [sym_left_assignment_list] = STATE(875),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(876),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(876),
    [sym_false] = STATE(876),
    [sym_nil] = STATE(876),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(877),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(1555),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1557),
    [anon_sym_yield] = ACTIONS(1559),
    [anon_sym_break] = ACTIONS(1561),
    [anon_sym_next] = ACTIONS(1563),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_defined_QMARK] = ACTIONS(1567),
    [anon_sym_not] = ACTIONS(1569),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_TILDE] = ACTIONS(1571),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2449] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(4890),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(876),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(876),
    [sym_assignment] = STATE(4890),
    [sym_operator_assignment] = STATE(4890),
    [sym_conditional] = STATE(4890),
    [sym_range] = STATE(4890),
    [sym_binary] = STATE(4890),
    [sym_unary] = STATE(4890),
    [sym_left_assignment_list] = STATE(875),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(876),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(876),
    [sym_false] = STATE(876),
    [sym_nil] = STATE(876),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(877),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(1555),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1557),
    [anon_sym_yield] = ACTIONS(1559),
    [anon_sym_break] = ACTIONS(1561),
    [anon_sym_next] = ACTIONS(1563),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_defined_QMARK] = ACTIONS(1567),
    [anon_sym_not] = ACTIONS(1569),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_TILDE] = ACTIONS(1571),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2450] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(4891),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(876),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(876),
    [sym_assignment] = STATE(4891),
    [sym_operator_assignment] = STATE(4891),
    [sym_conditional] = STATE(4891),
    [sym_range] = STATE(4891),
    [sym_binary] = STATE(4891),
    [sym_unary] = STATE(4891),
    [sym_left_assignment_list] = STATE(875),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(876),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(876),
    [sym_false] = STATE(876),
    [sym_nil] = STATE(876),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(877),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(1555),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1557),
    [anon_sym_yield] = ACTIONS(1559),
    [anon_sym_break] = ACTIONS(1561),
    [anon_sym_next] = ACTIONS(1563),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_defined_QMARK] = ACTIONS(1567),
    [anon_sym_not] = ACTIONS(1569),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_TILDE] = ACTIONS(1571),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2451] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(4892),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(876),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(876),
    [sym_assignment] = STATE(4892),
    [sym_operator_assignment] = STATE(4892),
    [sym_conditional] = STATE(4892),
    [sym_range] = STATE(4892),
    [sym_binary] = STATE(4892),
    [sym_unary] = STATE(4892),
    [sym_left_assignment_list] = STATE(875),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(876),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(876),
    [sym_false] = STATE(876),
    [sym_nil] = STATE(876),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(877),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(1555),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1557),
    [anon_sym_yield] = ACTIONS(1559),
    [anon_sym_break] = ACTIONS(1561),
    [anon_sym_next] = ACTIONS(1563),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_defined_QMARK] = ACTIONS(1567),
    [anon_sym_not] = ACTIONS(1569),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_TILDE] = ACTIONS(1571),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2452] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(4893),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(876),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(876),
    [sym_assignment] = STATE(4893),
    [sym_operator_assignment] = STATE(4893),
    [sym_conditional] = STATE(4893),
    [sym_range] = STATE(4893),
    [sym_binary] = STATE(4893),
    [sym_unary] = STATE(4893),
    [sym_left_assignment_list] = STATE(875),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(876),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(876),
    [sym_false] = STATE(876),
    [sym_nil] = STATE(876),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(877),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(1555),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1557),
    [anon_sym_yield] = ACTIONS(1559),
    [anon_sym_break] = ACTIONS(1561),
    [anon_sym_next] = ACTIONS(1563),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_defined_QMARK] = ACTIONS(1567),
    [anon_sym_not] = ACTIONS(1569),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_TILDE] = ACTIONS(1571),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2453] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(4894),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(4894),
    [sym_operator_assignment] = STATE(4894),
    [sym_conditional] = STATE(4894),
    [sym_range] = STATE(4894),
    [sym_binary] = STATE(4894),
    [sym_unary] = STATE(4894),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2454] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(4895),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(876),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(876),
    [sym_assignment] = STATE(4895),
    [sym_operator_assignment] = STATE(4895),
    [sym_conditional] = STATE(4895),
    [sym_range] = STATE(4895),
    [sym_binary] = STATE(4895),
    [sym_unary] = STATE(4895),
    [sym_left_assignment_list] = STATE(875),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(876),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(876),
    [sym_false] = STATE(876),
    [sym_nil] = STATE(876),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(877),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(1555),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1557),
    [anon_sym_yield] = ACTIONS(1559),
    [anon_sym_break] = ACTIONS(1561),
    [anon_sym_next] = ACTIONS(1563),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_defined_QMARK] = ACTIONS(1567),
    [anon_sym_not] = ACTIONS(1569),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_TILDE] = ACTIONS(1571),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2455] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(4896),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(876),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(876),
    [sym_assignment] = STATE(4896),
    [sym_operator_assignment] = STATE(4896),
    [sym_conditional] = STATE(4896),
    [sym_range] = STATE(4896),
    [sym_binary] = STATE(4896),
    [sym_unary] = STATE(4896),
    [sym_left_assignment_list] = STATE(875),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(876),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(876),
    [sym_false] = STATE(876),
    [sym_nil] = STATE(876),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(877),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(1555),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1557),
    [anon_sym_yield] = ACTIONS(1559),
    [anon_sym_break] = ACTIONS(1561),
    [anon_sym_next] = ACTIONS(1563),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_defined_QMARK] = ACTIONS(1567),
    [anon_sym_not] = ACTIONS(1569),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_TILDE] = ACTIONS(1571),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2456] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(4897),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(876),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(876),
    [sym_assignment] = STATE(4897),
    [sym_operator_assignment] = STATE(4897),
    [sym_conditional] = STATE(4897),
    [sym_range] = STATE(4897),
    [sym_binary] = STATE(4897),
    [sym_unary] = STATE(4897),
    [sym_left_assignment_list] = STATE(875),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(876),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(876),
    [sym_false] = STATE(876),
    [sym_nil] = STATE(876),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(877),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(1555),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1557),
    [anon_sym_yield] = ACTIONS(1559),
    [anon_sym_break] = ACTIONS(1561),
    [anon_sym_next] = ACTIONS(1563),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_defined_QMARK] = ACTIONS(1567),
    [anon_sym_not] = ACTIONS(1569),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_TILDE] = ACTIONS(1571),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2457] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(4898),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(876),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(876),
    [sym_assignment] = STATE(4898),
    [sym_operator_assignment] = STATE(4898),
    [sym_conditional] = STATE(4898),
    [sym_range] = STATE(4898),
    [sym_binary] = STATE(4898),
    [sym_unary] = STATE(4898),
    [sym_left_assignment_list] = STATE(875),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(876),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(876),
    [sym_false] = STATE(876),
    [sym_nil] = STATE(876),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(877),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(1555),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1557),
    [anon_sym_yield] = ACTIONS(1559),
    [anon_sym_break] = ACTIONS(1561),
    [anon_sym_next] = ACTIONS(1563),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_defined_QMARK] = ACTIONS(1567),
    [anon_sym_not] = ACTIONS(1569),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_TILDE] = ACTIONS(1571),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2458] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(4899),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(876),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(876),
    [sym_splat_argument] = STATE(4900),
    [sym_assignment] = STATE(4899),
    [sym_operator_assignment] = STATE(4899),
    [sym_conditional] = STATE(4899),
    [sym_range] = STATE(4899),
    [sym_binary] = STATE(4899),
    [sym_unary] = STATE(4899),
    [sym_right_assignment_list] = STATE(2570),
    [sym__arg_or_splat_arg] = STATE(4900),
    [sym_left_assignment_list] = STATE(875),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(876),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(876),
    [sym_false] = STATE(876),
    [sym_nil] = STATE(876),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(877),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(371),
    [sym__unary_minus] = ACTIONS(1555),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1557),
    [anon_sym_yield] = ACTIONS(1559),
    [anon_sym_break] = ACTIONS(1561),
    [anon_sym_next] = ACTIONS(1563),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_defined_QMARK] = ACTIONS(1567),
    [anon_sym_not] = ACTIONS(1569),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_TILDE] = ACTIONS(1571),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2459] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(4901),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(876),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(876),
    [sym_assignment] = STATE(4901),
    [sym_operator_assignment] = STATE(4901),
    [sym_conditional] = STATE(4901),
    [sym_range] = STATE(4901),
    [sym_binary] = STATE(4901),
    [sym_unary] = STATE(4901),
    [sym_left_assignment_list] = STATE(875),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(876),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(876),
    [sym_false] = STATE(876),
    [sym_nil] = STATE(876),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(877),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(1555),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1557),
    [anon_sym_yield] = ACTIONS(1559),
    [anon_sym_break] = ACTIONS(1561),
    [anon_sym_next] = ACTIONS(1563),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_defined_QMARK] = ACTIONS(1567),
    [anon_sym_not] = ACTIONS(1569),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_TILDE] = ACTIONS(1571),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2460] = {
    [sym_string] = STATE(4902),
    [aux_sym_chained_string_repeat1] = STATE(4902),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [ts_builtin_sym_end] = ACTIONS(2753),
    [anon_sym___END__] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [2461] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(4213),
    [sym__binary_star] = ACTIONS(4215),
    [ts_builtin_sym_end] = ACTIONS(6823),
    [anon_sym___END__] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(4219),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(4215),
    [anon_sym_AMP] = ACTIONS(4221),
    [anon_sym_LT] = ACTIONS(4223),
    [anon_sym_if] = ACTIONS(6823),
    [anon_sym_unless] = ACTIONS(6823),
    [anon_sym_while] = ACTIONS(6823),
    [anon_sym_until] = ACTIONS(6823),
    [anon_sym_rescue] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(4225),
    [anon_sym_DOT_DOT] = ACTIONS(4227),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4229),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(4231),
    [anon_sym_AMP_AMP] = ACTIONS(4231),
    [anon_sym_LT_LT] = ACTIONS(4233),
    [anon_sym_GT_GT] = ACTIONS(4233),
    [anon_sym_EQ_EQ] = ACTIONS(4235),
    [anon_sym_BANG_EQ] = ACTIONS(4231),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4231),
    [anon_sym_LT_EQ_GT] = ACTIONS(4231),
    [anon_sym_EQ_TILDE] = ACTIONS(4231),
    [anon_sym_BANG_TILDE] = ACTIONS(4231),
    [anon_sym_LT_EQ] = ACTIONS(4223),
    [anon_sym_GT] = ACTIONS(4223),
    [anon_sym_GT_EQ] = ACTIONS(4237),
    [anon_sym_CARET] = ACTIONS(4239),
    [anon_sym_PLUS] = ACTIONS(4213),
    [anon_sym_SLASH] = ACTIONS(4215),
    [anon_sym_PERCENT] = ACTIONS(4215),
    [sym_comment] = ACTIONS(87),
  },
  [2462] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(1627),
    [sym__binary_star] = ACTIONS(1629),
    [ts_builtin_sym_end] = ACTIONS(4211),
    [anon_sym___END__] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(1633),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(1629),
    [anon_sym_AMP] = ACTIONS(1635),
    [anon_sym_LT] = ACTIONS(1637),
    [anon_sym_if] = ACTIONS(4211),
    [anon_sym_unless] = ACTIONS(4211),
    [anon_sym_while] = ACTIONS(4211),
    [anon_sym_until] = ACTIONS(4211),
    [anon_sym_rescue] = ACTIONS(4211),
    [anon_sym_EQ_GT] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(1639),
    [anon_sym_DOT_DOT] = ACTIONS(1641),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1643),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(1645),
    [anon_sym_AMP_AMP] = ACTIONS(1645),
    [anon_sym_LT_LT] = ACTIONS(1647),
    [anon_sym_GT_GT] = ACTIONS(1647),
    [anon_sym_EQ_EQ] = ACTIONS(1649),
    [anon_sym_BANG_EQ] = ACTIONS(1645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1645),
    [anon_sym_LT_EQ_GT] = ACTIONS(1645),
    [anon_sym_EQ_TILDE] = ACTIONS(1645),
    [anon_sym_BANG_TILDE] = ACTIONS(1645),
    [anon_sym_LT_EQ] = ACTIONS(1637),
    [anon_sym_GT] = ACTIONS(1637),
    [anon_sym_GT_EQ] = ACTIONS(1651),
    [anon_sym_CARET] = ACTIONS(1653),
    [anon_sym_PLUS] = ACTIONS(1627),
    [anon_sym_SLASH] = ACTIONS(1629),
    [anon_sym_PERCENT] = ACTIONS(1629),
    [sym_comment] = ACTIONS(87),
  },
  [2463] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(1627),
    [sym__binary_star] = ACTIONS(1629),
    [ts_builtin_sym_end] = ACTIONS(4247),
    [anon_sym___END__] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(1633),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(1629),
    [anon_sym_AMP] = ACTIONS(1635),
    [anon_sym_LT] = ACTIONS(1637),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_EQ_GT] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(1639),
    [anon_sym_DOT_DOT] = ACTIONS(1641),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1643),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(1645),
    [anon_sym_AMP_AMP] = ACTIONS(1645),
    [anon_sym_LT_LT] = ACTIONS(1647),
    [anon_sym_GT_GT] = ACTIONS(1647),
    [anon_sym_EQ_EQ] = ACTIONS(1649),
    [anon_sym_BANG_EQ] = ACTIONS(1645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1645),
    [anon_sym_LT_EQ_GT] = ACTIONS(1645),
    [anon_sym_EQ_TILDE] = ACTIONS(1645),
    [anon_sym_BANG_TILDE] = ACTIONS(1645),
    [anon_sym_LT_EQ] = ACTIONS(1637),
    [anon_sym_GT] = ACTIONS(1637),
    [anon_sym_GT_EQ] = ACTIONS(1651),
    [anon_sym_CARET] = ACTIONS(1653),
    [anon_sym_PLUS] = ACTIONS(1627),
    [anon_sym_SLASH] = ACTIONS(1629),
    [anon_sym_PERCENT] = ACTIONS(1629),
    [sym_comment] = ACTIONS(87),
  },
  [2464] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4903),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_assignment] = STATE(4903),
    [sym_operator_assignment] = STATE(4903),
    [sym_conditional] = STATE(4903),
    [sym_range] = STATE(4903),
    [sym_binary] = STATE(4903),
    [sym_unary] = STATE(4903),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(880),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(373),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(383),
    [anon_sym_yield] = ACTIONS(385),
    [anon_sym_break] = ACTIONS(387),
    [anon_sym_next] = ACTIONS(389),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1575),
    [anon_sym_defined_QMARK] = ACTIONS(395),
    [anon_sym_not] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_TILDE] = ACTIONS(401),
    [sym_constant] = ACTIONS(407),
    [sym_identifier] = ACTIONS(407),
    [sym_instance_variable] = ACTIONS(405),
    [sym_class_variable] = ACTIONS(405),
    [sym_global_variable] = ACTIONS(405),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(407),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(407),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2465] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(1627),
    [sym__binary_star] = ACTIONS(1629),
    [ts_builtin_sym_end] = ACTIONS(3281),
    [anon_sym___END__] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(1633),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(1629),
    [anon_sym_AMP] = ACTIONS(1635),
    [anon_sym_LT] = ACTIONS(1637),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_unless] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_until] = ACTIONS(3281),
    [anon_sym_rescue] = ACTIONS(3281),
    [anon_sym_EQ_GT] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(1639),
    [anon_sym_DOT_DOT] = ACTIONS(1641),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1643),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(1645),
    [anon_sym_AMP_AMP] = ACTIONS(1645),
    [anon_sym_LT_LT] = ACTIONS(1647),
    [anon_sym_GT_GT] = ACTIONS(1647),
    [anon_sym_EQ_EQ] = ACTIONS(1649),
    [anon_sym_BANG_EQ] = ACTIONS(1645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1645),
    [anon_sym_LT_EQ_GT] = ACTIONS(1645),
    [anon_sym_EQ_TILDE] = ACTIONS(1645),
    [anon_sym_BANG_TILDE] = ACTIONS(1645),
    [anon_sym_LT_EQ] = ACTIONS(1637),
    [anon_sym_GT] = ACTIONS(1637),
    [anon_sym_GT_EQ] = ACTIONS(1651),
    [anon_sym_CARET] = ACTIONS(1653),
    [anon_sym_PLUS] = ACTIONS(1627),
    [anon_sym_SLASH] = ACTIONS(1629),
    [anon_sym_PERCENT] = ACTIONS(1629),
    [sym_comment] = ACTIONS(87),
  },
  [2466] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4904),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_assignment] = STATE(4904),
    [sym_operator_assignment] = STATE(4904),
    [sym_conditional] = STATE(4904),
    [sym_range] = STATE(4904),
    [sym_binary] = STATE(4904),
    [sym_unary] = STATE(4904),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(880),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(373),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(383),
    [anon_sym_yield] = ACTIONS(385),
    [anon_sym_break] = ACTIONS(387),
    [anon_sym_next] = ACTIONS(389),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1575),
    [anon_sym_defined_QMARK] = ACTIONS(395),
    [anon_sym_not] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_TILDE] = ACTIONS(401),
    [sym_constant] = ACTIONS(407),
    [sym_identifier] = ACTIONS(407),
    [sym_instance_variable] = ACTIONS(405),
    [sym_class_variable] = ACTIONS(405),
    [sym_global_variable] = ACTIONS(405),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(407),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(407),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2467] = {
    [sym_heredoc_body] = STATE(4905),
    [aux_sym_call_repeat1] = STATE(4905),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [ts_builtin_sym_end] = ACTIONS(4383),
    [anon_sym___END__] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [2468] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(889),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym__argument] = STATE(2565),
    [sym_splat_argument] = STATE(2565),
    [sym_hash_splat_argument] = STATE(2565),
    [sym_block_argument] = STATE(2565),
    [sym_assignment] = STATE(889),
    [sym_operator_assignment] = STATE(889),
    [sym_conditional] = STATE(889),
    [sym_range] = STATE(889),
    [sym_binary] = STATE(889),
    [sym_unary] = STATE(889),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(892),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(4906),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2565),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(1581),
    [sym__splat_star] = ACTIONS(1583),
    [sym__unary_minus] = ACTIONS(373),
    [sym__identifier_hash_key] = ACTIONS(1585),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(7824),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(383),
    [anon_sym_yield] = ACTIONS(385),
    [anon_sym_break] = ACTIONS(387),
    [anon_sym_next] = ACTIONS(389),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1575),
    [anon_sym_defined_QMARK] = ACTIONS(395),
    [anon_sym_not] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_TILDE] = ACTIONS(401),
    [sym_constant] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1587),
    [sym_instance_variable] = ACTIONS(405),
    [sym_class_variable] = ACTIONS(405),
    [sym_global_variable] = ACTIONS(405),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(407),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(407),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2469] = {
    [sym_heredoc_body] = STATE(4907),
    [aux_sym_call_repeat1] = STATE(4907),
    [aux_sym_argument_list_repeat1] = STATE(4908),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [ts_builtin_sym_end] = ACTIONS(4383),
    [anon_sym___END__] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4257),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [2470] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(4909),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2480),
    [sym_scope_resolution] = STATE(2478),
    [sym_call] = STATE(2478),
    [sym_method_call] = STATE(2480),
    [sym_assignment] = STATE(4909),
    [sym_operator_assignment] = STATE(4909),
    [sym_conditional] = STATE(4909),
    [sym_range] = STATE(4909),
    [sym_binary] = STATE(4909),
    [sym_unary] = STATE(4909),
    [sym_left_assignment_list] = STATE(2479),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2480),
    [sym__variable] = STATE(2478),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2480),
    [sym_false] = STATE(2480),
    [sym_nil] = STATE(2480),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2481),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4261),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4263),
    [anon_sym_yield] = ACTIONS(4265),
    [anon_sym_break] = ACTIONS(4267),
    [anon_sym_next] = ACTIONS(4269),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4271),
    [anon_sym_defined_QMARK] = ACTIONS(4273),
    [anon_sym_not] = ACTIONS(4275),
    [anon_sym_BANG] = ACTIONS(4277),
    [anon_sym_TILDE] = ACTIONS(4277),
    [sym_constant] = ACTIONS(4279),
    [sym_identifier] = ACTIONS(4279),
    [sym_instance_variable] = ACTIONS(4281),
    [sym_class_variable] = ACTIONS(4281),
    [sym_global_variable] = ACTIONS(4281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4279),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4279),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2471] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(2057),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2061),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(2061),
    [sym_argument_list] = STATE(1318),
    [sym__argument_list_with_parens] = STATE(4910),
    [sym__argument] = STATE(4911),
    [sym_splat_argument] = STATE(4911),
    [sym_hash_splat_argument] = STATE(4911),
    [sym_block_argument] = STATE(4911),
    [sym_assignment] = STATE(2057),
    [sym_operator_assignment] = STATE(2057),
    [sym_conditional] = STATE(2057),
    [sym_range] = STATE(2057),
    [sym_binary] = STATE(2057),
    [sym_unary] = STATE(2057),
    [sym_left_assignment_list] = STATE(2060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2061),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2061),
    [sym_false] = STATE(2061),
    [sym_nil] = STATE(2061),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2062),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(4911),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(3591),
    [sym__splat_star] = ACTIONS(3593),
    [sym__unary_minus] = ACTIONS(3595),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(3597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(365),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(3599),
    [anon_sym_not] = ACTIONS(3601),
    [anon_sym_BANG] = ACTIONS(3603),
    [anon_sym_TILDE] = ACTIONS(3605),
    [sym_constant] = ACTIONS(3607),
    [sym_identifier] = ACTIONS(3607),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2472] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(2057),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2061),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(2061),
    [sym_argument_list] = STATE(1324),
    [sym__argument_list_with_parens] = STATE(4910),
    [sym__argument] = STATE(4911),
    [sym_splat_argument] = STATE(4911),
    [sym_hash_splat_argument] = STATE(4911),
    [sym_block_argument] = STATE(4911),
    [sym_assignment] = STATE(2057),
    [sym_operator_assignment] = STATE(2057),
    [sym_conditional] = STATE(2057),
    [sym_range] = STATE(2057),
    [sym_binary] = STATE(2057),
    [sym_unary] = STATE(2057),
    [sym_left_assignment_list] = STATE(2060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2061),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2061),
    [sym_false] = STATE(2061),
    [sym_nil] = STATE(2061),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2062),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(4911),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(3591),
    [sym__splat_star] = ACTIONS(3593),
    [sym__unary_minus] = ACTIONS(3595),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(3597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(417),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(3599),
    [anon_sym_not] = ACTIONS(3601),
    [anon_sym_BANG] = ACTIONS(3603),
    [anon_sym_TILDE] = ACTIONS(3605),
    [sym_constant] = ACTIONS(3607),
    [sym_identifier] = ACTIONS(3607),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2473] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(2057),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2061),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(2061),
    [sym_argument_list] = STATE(1325),
    [sym__argument_list_with_parens] = STATE(4910),
    [sym__argument] = STATE(4911),
    [sym_splat_argument] = STATE(4911),
    [sym_hash_splat_argument] = STATE(4911),
    [sym_block_argument] = STATE(4911),
    [sym_assignment] = STATE(2057),
    [sym_operator_assignment] = STATE(2057),
    [sym_conditional] = STATE(2057),
    [sym_range] = STATE(2057),
    [sym_binary] = STATE(2057),
    [sym_unary] = STATE(2057),
    [sym_left_assignment_list] = STATE(2060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2061),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2061),
    [sym_false] = STATE(2061),
    [sym_nil] = STATE(2061),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2062),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(4911),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(3591),
    [sym__splat_star] = ACTIONS(3593),
    [sym__unary_minus] = ACTIONS(3595),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(3597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(421),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(3599),
    [anon_sym_not] = ACTIONS(3601),
    [anon_sym_BANG] = ACTIONS(3603),
    [anon_sym_TILDE] = ACTIONS(3605),
    [sym_constant] = ACTIONS(3607),
    [sym_identifier] = ACTIONS(3607),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2474] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(2057),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2061),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(2061),
    [sym_argument_list] = STATE(1326),
    [sym__argument_list_with_parens] = STATE(4910),
    [sym__argument] = STATE(4911),
    [sym_splat_argument] = STATE(4911),
    [sym_hash_splat_argument] = STATE(4911),
    [sym_block_argument] = STATE(4911),
    [sym_assignment] = STATE(2057),
    [sym_operator_assignment] = STATE(2057),
    [sym_conditional] = STATE(2057),
    [sym_range] = STATE(2057),
    [sym_binary] = STATE(2057),
    [sym_unary] = STATE(2057),
    [sym_left_assignment_list] = STATE(2060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2061),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2061),
    [sym_false] = STATE(2061),
    [sym_nil] = STATE(2061),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2062),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(4911),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(3591),
    [sym__splat_star] = ACTIONS(3593),
    [sym__unary_minus] = ACTIONS(3595),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(3597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(425),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(3599),
    [anon_sym_not] = ACTIONS(3601),
    [anon_sym_BANG] = ACTIONS(3603),
    [anon_sym_TILDE] = ACTIONS(3605),
    [sym_constant] = ACTIONS(3607),
    [sym_identifier] = ACTIONS(3607),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2475] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(4912),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2480),
    [sym_scope_resolution] = STATE(2478),
    [sym_call] = STATE(2478),
    [sym_method_call] = STATE(2480),
    [sym_assignment] = STATE(4912),
    [sym_operator_assignment] = STATE(4912),
    [sym_conditional] = STATE(4912),
    [sym_range] = STATE(4912),
    [sym_binary] = STATE(4912),
    [sym_unary] = STATE(4912),
    [sym_left_assignment_list] = STATE(2479),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2480),
    [sym__variable] = STATE(2478),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2480),
    [sym_false] = STATE(2480),
    [sym_nil] = STATE(2480),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2481),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4261),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4263),
    [anon_sym_yield] = ACTIONS(4265),
    [anon_sym_break] = ACTIONS(4267),
    [anon_sym_next] = ACTIONS(4269),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4271),
    [anon_sym_defined_QMARK] = ACTIONS(4273),
    [anon_sym_not] = ACTIONS(4275),
    [anon_sym_BANG] = ACTIONS(4277),
    [anon_sym_TILDE] = ACTIONS(4277),
    [sym_constant] = ACTIONS(4279),
    [sym_identifier] = ACTIONS(4279),
    [sym_instance_variable] = ACTIONS(4281),
    [sym_class_variable] = ACTIONS(4281),
    [sym_global_variable] = ACTIONS(4281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4279),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4279),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2476] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(1341),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2480),
    [sym_scope_resolution] = STATE(2478),
    [sym_call] = STATE(2478),
    [sym_method_call] = STATE(2480),
    [sym_assignment] = STATE(1341),
    [sym_operator_assignment] = STATE(1341),
    [sym_conditional] = STATE(1341),
    [sym_range] = STATE(1341),
    [sym_binary] = STATE(1341),
    [sym_unary] = STATE(1341),
    [sym_left_assignment_list] = STATE(2479),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2480),
    [sym__variable] = STATE(2478),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2480),
    [sym_false] = STATE(2480),
    [sym_nil] = STATE(2480),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2481),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4261),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4263),
    [anon_sym_yield] = ACTIONS(4265),
    [anon_sym_break] = ACTIONS(4267),
    [anon_sym_next] = ACTIONS(4269),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4271),
    [anon_sym_defined_QMARK] = ACTIONS(4273),
    [anon_sym_not] = ACTIONS(4275),
    [anon_sym_BANG] = ACTIONS(4277),
    [anon_sym_TILDE] = ACTIONS(4277),
    [sym_constant] = ACTIONS(4279),
    [sym_identifier] = ACTIONS(4279),
    [sym_instance_variable] = ACTIONS(4281),
    [sym_class_variable] = ACTIONS(4281),
    [sym_global_variable] = ACTIONS(4281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4279),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4279),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2477] = {
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(7826),
    [sym__binary_star] = ACTIONS(7828),
    [anon_sym_RPAREN] = ACTIONS(4211),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(7830),
    [anon_sym_STAR_STAR] = ACTIONS(7828),
    [anon_sym_AMP] = ACTIONS(7832),
    [anon_sym_LT] = ACTIONS(7834),
    [anon_sym_QMARK] = ACTIONS(7836),
    [anon_sym_DOT_DOT] = ACTIONS(7838),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7840),
    [anon_sym_and] = ACTIONS(7842),
    [anon_sym_or] = ACTIONS(7842),
    [anon_sym_PIPE_PIPE] = ACTIONS(7844),
    [anon_sym_AMP_AMP] = ACTIONS(7844),
    [anon_sym_LT_LT] = ACTIONS(7846),
    [anon_sym_GT_GT] = ACTIONS(7846),
    [anon_sym_EQ_EQ] = ACTIONS(7848),
    [anon_sym_BANG_EQ] = ACTIONS(7844),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7844),
    [anon_sym_LT_EQ_GT] = ACTIONS(7844),
    [anon_sym_EQ_TILDE] = ACTIONS(7844),
    [anon_sym_BANG_TILDE] = ACTIONS(7844),
    [anon_sym_LT_EQ] = ACTIONS(7834),
    [anon_sym_GT] = ACTIONS(7834),
    [anon_sym_GT_EQ] = ACTIONS(7850),
    [anon_sym_CARET] = ACTIONS(7852),
    [anon_sym_PLUS] = ACTIONS(7826),
    [anon_sym_SLASH] = ACTIONS(7828),
    [anon_sym_PERCENT] = ACTIONS(7828),
    [sym_comment] = ACTIONS(87),
  },
  [2478] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(2087),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2092),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2092),
    [sym_argument_list] = STATE(1846),
    [sym__argument_list_with_parens] = STATE(2089),
    [sym__argument] = STATE(2090),
    [sym_splat_argument] = STATE(2090),
    [sym_hash_splat_argument] = STATE(2090),
    [sym_block_argument] = STATE(2090),
    [sym_do_block] = STATE(1849),
    [sym_block] = STATE(1849),
    [sym_assignment] = STATE(2087),
    [sym_operator_assignment] = STATE(2087),
    [sym_conditional] = STATE(2087),
    [sym_range] = STATE(2087),
    [sym_binary] = STATE(2087),
    [sym_unary] = STATE(2087),
    [sym_left_assignment_list] = STATE(2091),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2092),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2092),
    [sym_false] = STATE(2092),
    [sym_nil] = STATE(2092),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(2093),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(2090),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(3639),
    [sym__splat_star] = ACTIONS(3641),
    [sym__unary_minus] = ACTIONS(3643),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(3645),
    [anon_sym_LBRACE] = ACTIONS(3327),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3647),
    [anon_sym_yield] = ACTIONS(3649),
    [anon_sym_break] = ACTIONS(3651),
    [anon_sym_next] = ACTIONS(3653),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(3337),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(3655),
    [anon_sym_not] = ACTIONS(3657),
    [anon_sym_BANG] = ACTIONS(3659),
    [anon_sym_TILDE] = ACTIONS(3661),
    [sym_constant] = ACTIONS(3663),
    [sym_identifier] = ACTIONS(3663),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2479] = {
    [anon_sym_EQ] = ACTIONS(7854),
    [sym_comment] = ACTIONS(87),
  },
  [2480] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(7856),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(7858),
    [anon_sym_DASH_EQ] = ACTIONS(7858),
    [anon_sym_STAR_EQ] = ACTIONS(7858),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7858),
    [anon_sym_SLASH_EQ] = ACTIONS(7858),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7858),
    [anon_sym_PIPE_EQ] = ACTIONS(7858),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7858),
    [anon_sym_AMP_EQ] = ACTIONS(7858),
    [anon_sym_PERCENT_EQ] = ACTIONS(7858),
    [anon_sym_GT_GT_EQ] = ACTIONS(7858),
    [anon_sym_LT_LT_EQ] = ACTIONS(7858),
    [anon_sym_CARET_EQ] = ACTIONS(7858),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2481] = {
    [sym_string] = STATE(4925),
    [aux_sym_chained_string_repeat1] = STATE(4925),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2482] = {
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(7826),
    [sym__binary_star] = ACTIONS(7828),
    [anon_sym_RPAREN] = ACTIONS(4247),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(7830),
    [anon_sym_STAR_STAR] = ACTIONS(7828),
    [anon_sym_AMP] = ACTIONS(7832),
    [anon_sym_LT] = ACTIONS(7834),
    [anon_sym_QMARK] = ACTIONS(7836),
    [anon_sym_DOT_DOT] = ACTIONS(7838),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7840),
    [anon_sym_and] = ACTIONS(7842),
    [anon_sym_or] = ACTIONS(7842),
    [anon_sym_PIPE_PIPE] = ACTIONS(7844),
    [anon_sym_AMP_AMP] = ACTIONS(7844),
    [anon_sym_LT_LT] = ACTIONS(7846),
    [anon_sym_GT_GT] = ACTIONS(7846),
    [anon_sym_EQ_EQ] = ACTIONS(7848),
    [anon_sym_BANG_EQ] = ACTIONS(7844),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7844),
    [anon_sym_LT_EQ_GT] = ACTIONS(7844),
    [anon_sym_EQ_TILDE] = ACTIONS(7844),
    [anon_sym_BANG_TILDE] = ACTIONS(7844),
    [anon_sym_LT_EQ] = ACTIONS(7834),
    [anon_sym_GT] = ACTIONS(7834),
    [anon_sym_GT_EQ] = ACTIONS(7850),
    [anon_sym_CARET] = ACTIONS(7852),
    [anon_sym_PLUS] = ACTIONS(7826),
    [anon_sym_SLASH] = ACTIONS(7828),
    [anon_sym_PERCENT] = ACTIONS(7828),
    [sym_comment] = ACTIONS(87),
  },
  [2483] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(4301),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [2484] = {
    [sym_string] = STATE(2522),
    [aux_sym_chained_string_repeat1] = STATE(2522),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2485] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(4926),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2480),
    [sym_scope_resolution] = STATE(2478),
    [sym_call] = STATE(2478),
    [sym_method_call] = STATE(2480),
    [sym_assignment] = STATE(4926),
    [sym_operator_assignment] = STATE(4926),
    [sym_conditional] = STATE(4926),
    [sym_range] = STATE(4926),
    [sym_binary] = STATE(4926),
    [sym_unary] = STATE(4926),
    [sym_left_assignment_list] = STATE(2479),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2480),
    [sym__variable] = STATE(2478),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2480),
    [sym_false] = STATE(2480),
    [sym_nil] = STATE(2480),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2481),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4261),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4263),
    [anon_sym_yield] = ACTIONS(4265),
    [anon_sym_break] = ACTIONS(4267),
    [anon_sym_next] = ACTIONS(4269),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4271),
    [anon_sym_defined_QMARK] = ACTIONS(4273),
    [anon_sym_not] = ACTIONS(4275),
    [anon_sym_BANG] = ACTIONS(4277),
    [anon_sym_TILDE] = ACTIONS(4277),
    [sym_constant] = ACTIONS(4279),
    [sym_identifier] = ACTIONS(4279),
    [sym_instance_variable] = ACTIONS(4281),
    [sym_class_variable] = ACTIONS(4281),
    [sym_global_variable] = ACTIONS(4281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4279),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4279),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2486] = {
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(7826),
    [sym__binary_star] = ACTIONS(7828),
    [anon_sym_RPAREN] = ACTIONS(3281),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(7830),
    [anon_sym_STAR_STAR] = ACTIONS(7828),
    [anon_sym_AMP] = ACTIONS(7832),
    [anon_sym_LT] = ACTIONS(7834),
    [anon_sym_QMARK] = ACTIONS(7836),
    [anon_sym_DOT_DOT] = ACTIONS(7838),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7840),
    [anon_sym_and] = ACTIONS(7842),
    [anon_sym_or] = ACTIONS(7842),
    [anon_sym_PIPE_PIPE] = ACTIONS(7844),
    [anon_sym_AMP_AMP] = ACTIONS(7844),
    [anon_sym_LT_LT] = ACTIONS(7846),
    [anon_sym_GT_GT] = ACTIONS(7846),
    [anon_sym_EQ_EQ] = ACTIONS(7848),
    [anon_sym_BANG_EQ] = ACTIONS(7844),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7844),
    [anon_sym_LT_EQ_GT] = ACTIONS(7844),
    [anon_sym_EQ_TILDE] = ACTIONS(7844),
    [anon_sym_BANG_TILDE] = ACTIONS(7844),
    [anon_sym_LT_EQ] = ACTIONS(7834),
    [anon_sym_GT] = ACTIONS(7834),
    [anon_sym_GT_EQ] = ACTIONS(7850),
    [anon_sym_CARET] = ACTIONS(7852),
    [anon_sym_PLUS] = ACTIONS(7826),
    [anon_sym_SLASH] = ACTIONS(7828),
    [anon_sym_PERCENT] = ACTIONS(7828),
    [sym_comment] = ACTIONS(87),
  },
  [2487] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4927),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2061),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(2061),
    [sym_assignment] = STATE(4927),
    [sym_operator_assignment] = STATE(4927),
    [sym_conditional] = STATE(4927),
    [sym_range] = STATE(4927),
    [sym_binary] = STATE(4927),
    [sym_unary] = STATE(4927),
    [sym_left_assignment_list] = STATE(2060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2061),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2061),
    [sym_false] = STATE(2061),
    [sym_nil] = STATE(2061),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2484),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7184),
    [anon_sym_defined_QMARK] = ACTIONS(3599),
    [anon_sym_not] = ACTIONS(3601),
    [anon_sym_BANG] = ACTIONS(3605),
    [anon_sym_TILDE] = ACTIONS(3605),
    [sym_constant] = ACTIONS(1621),
    [sym_identifier] = ACTIONS(1621),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2488] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4928),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2061),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(2061),
    [sym_assignment] = STATE(4928),
    [sym_operator_assignment] = STATE(4928),
    [sym_conditional] = STATE(4928),
    [sym_range] = STATE(4928),
    [sym_binary] = STATE(4928),
    [sym_unary] = STATE(4928),
    [sym_left_assignment_list] = STATE(2060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2061),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2061),
    [sym_false] = STATE(2061),
    [sym_nil] = STATE(2061),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2484),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7184),
    [anon_sym_defined_QMARK] = ACTIONS(3599),
    [anon_sym_not] = ACTIONS(3601),
    [anon_sym_BANG] = ACTIONS(3605),
    [anon_sym_TILDE] = ACTIONS(3605),
    [sym_constant] = ACTIONS(1621),
    [sym_identifier] = ACTIONS(1621),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2489] = {
    [anon_sym_COLON] = ACTIONS(7860),
    [sym_comment] = ACTIONS(87),
  },
  [2490] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4930),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2061),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(2061),
    [sym_assignment] = STATE(4930),
    [sym_operator_assignment] = STATE(4930),
    [sym_conditional] = STATE(4930),
    [sym_range] = STATE(4930),
    [sym_binary] = STATE(4930),
    [sym_unary] = STATE(4930),
    [sym_left_assignment_list] = STATE(2060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2061),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2061),
    [sym_false] = STATE(2061),
    [sym_nil] = STATE(2061),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2484),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7184),
    [anon_sym_defined_QMARK] = ACTIONS(3599),
    [anon_sym_not] = ACTIONS(3601),
    [anon_sym_BANG] = ACTIONS(3605),
    [anon_sym_TILDE] = ACTIONS(3605),
    [sym_constant] = ACTIONS(1621),
    [sym_identifier] = ACTIONS(1621),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2491] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(7862),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [2492] = {
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(7190),
    [sym__binary_star] = ACTIONS(7192),
    [anon_sym_RPAREN] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(7194),
    [anon_sym_STAR_STAR] = ACTIONS(7192),
    [anon_sym_AMP] = ACTIONS(7196),
    [anon_sym_LT] = ACTIONS(7198),
    [anon_sym_EQ_GT] = ACTIONS(1625),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(7200),
    [anon_sym_DOT_DOT] = ACTIONS(7202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7204),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(7206),
    [anon_sym_AMP_AMP] = ACTIONS(7206),
    [anon_sym_LT_LT] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7208),
    [anon_sym_EQ_EQ] = ACTIONS(7210),
    [anon_sym_BANG_EQ] = ACTIONS(7206),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7206),
    [anon_sym_LT_EQ_GT] = ACTIONS(7206),
    [anon_sym_EQ_TILDE] = ACTIONS(7206),
    [anon_sym_BANG_TILDE] = ACTIONS(7206),
    [anon_sym_LT_EQ] = ACTIONS(7198),
    [anon_sym_GT] = ACTIONS(7198),
    [anon_sym_GT_EQ] = ACTIONS(7212),
    [anon_sym_CARET] = ACTIONS(7214),
    [anon_sym_PLUS] = ACTIONS(7190),
    [anon_sym_SLASH] = ACTIONS(7192),
    [anon_sym_PERCENT] = ACTIONS(7192),
    [sym_comment] = ACTIONS(87),
  },
  [2493] = {
    [sym_heredoc_body] = STATE(4932),
    [aux_sym_call_repeat1] = STATE(4932),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [2494] = {
    [sym_heredoc_body] = STATE(4932),
    [aux_sym_call_repeat1] = STATE(4932),
    [aux_sym_argument_list_repeat1] = STATE(4934),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(7864),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [2495] = {
    [sym_string] = STATE(2522),
    [aux_sym_chained_string_repeat1] = STATE(2522),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(7866),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2496] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(4299),
    [sym__binary_star] = ACTIONS(4301),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(4303),
    [anon_sym_STAR_STAR] = ACTIONS(4301),
    [anon_sym_AMP] = ACTIONS(4305),
    [anon_sym_LT] = ACTIONS(4307),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(4309),
    [anon_sym_DOT_DOT] = ACTIONS(4311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4313),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(4317),
    [anon_sym_AMP_AMP] = ACTIONS(4317),
    [anon_sym_LT_LT] = ACTIONS(4319),
    [anon_sym_GT_GT] = ACTIONS(4319),
    [anon_sym_EQ_EQ] = ACTIONS(4321),
    [anon_sym_BANG_EQ] = ACTIONS(4317),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4317),
    [anon_sym_LT_EQ_GT] = ACTIONS(4317),
    [anon_sym_EQ_TILDE] = ACTIONS(4317),
    [anon_sym_BANG_TILDE] = ACTIONS(4317),
    [anon_sym_LT_EQ] = ACTIONS(4307),
    [anon_sym_GT] = ACTIONS(4307),
    [anon_sym_GT_EQ] = ACTIONS(4323),
    [anon_sym_CARET] = ACTIONS(4325),
    [anon_sym_PLUS] = ACTIONS(4299),
    [anon_sym_SLASH] = ACTIONS(4301),
    [anon_sym_PERCENT] = ACTIONS(4301),
    [sym_comment] = ACTIONS(87),
  },
  [2497] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(4935),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2480),
    [sym_scope_resolution] = STATE(2478),
    [sym_call] = STATE(2478),
    [sym_method_call] = STATE(2480),
    [sym_assignment] = STATE(4935),
    [sym_operator_assignment] = STATE(4935),
    [sym_conditional] = STATE(4935),
    [sym_range] = STATE(4935),
    [sym_binary] = STATE(4935),
    [sym_unary] = STATE(4935),
    [sym_left_assignment_list] = STATE(2479),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2480),
    [sym__variable] = STATE(2478),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2480),
    [sym_false] = STATE(2480),
    [sym_nil] = STATE(2480),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2481),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4261),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4263),
    [anon_sym_yield] = ACTIONS(4265),
    [anon_sym_break] = ACTIONS(4267),
    [anon_sym_next] = ACTIONS(4269),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4271),
    [anon_sym_defined_QMARK] = ACTIONS(4273),
    [anon_sym_not] = ACTIONS(4275),
    [anon_sym_BANG] = ACTIONS(4277),
    [anon_sym_TILDE] = ACTIONS(4277),
    [sym_constant] = ACTIONS(4279),
    [sym_identifier] = ACTIONS(4279),
    [sym_instance_variable] = ACTIONS(4281),
    [sym_class_variable] = ACTIONS(4281),
    [sym_global_variable] = ACTIONS(4281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4279),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4279),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2498] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4936),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(911),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(911),
    [sym_assignment] = STATE(4936),
    [sym_operator_assignment] = STATE(4936),
    [sym_conditional] = STATE(4936),
    [sym_range] = STATE(4936),
    [sym_binary] = STATE(4936),
    [sym_unary] = STATE(4936),
    [sym_left_assignment_list] = STATE(910),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(911),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(911),
    [sym_false] = STATE(911),
    [sym_nil] = STATE(911),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2484),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1593),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_defined_QMARK] = ACTIONS(1611),
    [anon_sym_not] = ACTIONS(1613),
    [anon_sym_BANG] = ACTIONS(1615),
    [anon_sym_TILDE] = ACTIONS(1615),
    [sym_constant] = ACTIONS(1621),
    [sym_identifier] = ACTIONS(1621),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2499] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4937),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(911),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(911),
    [sym_assignment] = STATE(4937),
    [sym_operator_assignment] = STATE(4937),
    [sym_conditional] = STATE(4937),
    [sym_range] = STATE(4937),
    [sym_binary] = STATE(4937),
    [sym_unary] = STATE(4937),
    [sym_left_assignment_list] = STATE(910),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(911),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(911),
    [sym_false] = STATE(911),
    [sym_nil] = STATE(911),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2484),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1593),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_defined_QMARK] = ACTIONS(1611),
    [anon_sym_not] = ACTIONS(1613),
    [anon_sym_BANG] = ACTIONS(1615),
    [anon_sym_TILDE] = ACTIONS(1615),
    [sym_constant] = ACTIONS(1621),
    [sym_identifier] = ACTIONS(1621),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2500] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4938),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(911),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(911),
    [sym_assignment] = STATE(4938),
    [sym_operator_assignment] = STATE(4938),
    [sym_conditional] = STATE(4938),
    [sym_range] = STATE(4938),
    [sym_binary] = STATE(4938),
    [sym_unary] = STATE(4938),
    [sym_left_assignment_list] = STATE(910),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(911),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(911),
    [sym_false] = STATE(911),
    [sym_nil] = STATE(911),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2484),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1593),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_defined_QMARK] = ACTIONS(1611),
    [anon_sym_not] = ACTIONS(1613),
    [anon_sym_BANG] = ACTIONS(1615),
    [anon_sym_TILDE] = ACTIONS(1615),
    [sym_constant] = ACTIONS(1621),
    [sym_identifier] = ACTIONS(1621),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2501] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4939),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(911),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(911),
    [sym_assignment] = STATE(4939),
    [sym_operator_assignment] = STATE(4939),
    [sym_conditional] = STATE(4939),
    [sym_range] = STATE(4939),
    [sym_binary] = STATE(4939),
    [sym_unary] = STATE(4939),
    [sym_left_assignment_list] = STATE(910),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(911),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(911),
    [sym_false] = STATE(911),
    [sym_nil] = STATE(911),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2484),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1593),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_defined_QMARK] = ACTIONS(1611),
    [anon_sym_not] = ACTIONS(1613),
    [anon_sym_BANG] = ACTIONS(1615),
    [anon_sym_TILDE] = ACTIONS(1615),
    [sym_constant] = ACTIONS(1621),
    [sym_identifier] = ACTIONS(1621),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2502] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4940),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(911),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(911),
    [sym_assignment] = STATE(4940),
    [sym_operator_assignment] = STATE(4940),
    [sym_conditional] = STATE(4940),
    [sym_range] = STATE(4940),
    [sym_binary] = STATE(4940),
    [sym_unary] = STATE(4940),
    [sym_left_assignment_list] = STATE(910),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(911),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(911),
    [sym_false] = STATE(911),
    [sym_nil] = STATE(911),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2484),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1593),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_defined_QMARK] = ACTIONS(1611),
    [anon_sym_not] = ACTIONS(1613),
    [anon_sym_BANG] = ACTIONS(1615),
    [anon_sym_TILDE] = ACTIONS(1615),
    [sym_constant] = ACTIONS(1621),
    [sym_identifier] = ACTIONS(1621),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2503] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(4941),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(4941),
    [sym_operator_assignment] = STATE(4941),
    [sym_conditional] = STATE(4941),
    [sym_range] = STATE(4941),
    [sym_binary] = STATE(4941),
    [sym_unary] = STATE(4941),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2504] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4942),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(911),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(911),
    [sym_assignment] = STATE(4942),
    [sym_operator_assignment] = STATE(4942),
    [sym_conditional] = STATE(4942),
    [sym_range] = STATE(4942),
    [sym_binary] = STATE(4942),
    [sym_unary] = STATE(4942),
    [sym_left_assignment_list] = STATE(910),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(911),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(911),
    [sym_false] = STATE(911),
    [sym_nil] = STATE(911),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2484),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1593),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_defined_QMARK] = ACTIONS(1611),
    [anon_sym_not] = ACTIONS(1613),
    [anon_sym_BANG] = ACTIONS(1615),
    [anon_sym_TILDE] = ACTIONS(1615),
    [sym_constant] = ACTIONS(1621),
    [sym_identifier] = ACTIONS(1621),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2505] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4943),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(911),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(911),
    [sym_assignment] = STATE(4943),
    [sym_operator_assignment] = STATE(4943),
    [sym_conditional] = STATE(4943),
    [sym_range] = STATE(4943),
    [sym_binary] = STATE(4943),
    [sym_unary] = STATE(4943),
    [sym_left_assignment_list] = STATE(910),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(911),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(911),
    [sym_false] = STATE(911),
    [sym_nil] = STATE(911),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2484),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1593),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_defined_QMARK] = ACTIONS(1611),
    [anon_sym_not] = ACTIONS(1613),
    [anon_sym_BANG] = ACTIONS(1615),
    [anon_sym_TILDE] = ACTIONS(1615),
    [sym_constant] = ACTIONS(1621),
    [sym_identifier] = ACTIONS(1621),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2506] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4944),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(911),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(911),
    [sym_assignment] = STATE(4944),
    [sym_operator_assignment] = STATE(4944),
    [sym_conditional] = STATE(4944),
    [sym_range] = STATE(4944),
    [sym_binary] = STATE(4944),
    [sym_unary] = STATE(4944),
    [sym_left_assignment_list] = STATE(910),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(911),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(911),
    [sym_false] = STATE(911),
    [sym_nil] = STATE(911),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2484),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1593),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_defined_QMARK] = ACTIONS(1611),
    [anon_sym_not] = ACTIONS(1613),
    [anon_sym_BANG] = ACTIONS(1615),
    [anon_sym_TILDE] = ACTIONS(1615),
    [sym_constant] = ACTIONS(1621),
    [sym_identifier] = ACTIONS(1621),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2507] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4945),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(911),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(911),
    [sym_assignment] = STATE(4945),
    [sym_operator_assignment] = STATE(4945),
    [sym_conditional] = STATE(4945),
    [sym_range] = STATE(4945),
    [sym_binary] = STATE(4945),
    [sym_unary] = STATE(4945),
    [sym_left_assignment_list] = STATE(910),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(911),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(911),
    [sym_false] = STATE(911),
    [sym_nil] = STATE(911),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2484),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1593),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_defined_QMARK] = ACTIONS(1611),
    [anon_sym_not] = ACTIONS(1613),
    [anon_sym_BANG] = ACTIONS(1615),
    [anon_sym_TILDE] = ACTIONS(1615),
    [sym_constant] = ACTIONS(1621),
    [sym_identifier] = ACTIONS(1621),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2508] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4946),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2092),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2092),
    [sym_assignment] = STATE(4946),
    [sym_operator_assignment] = STATE(4946),
    [sym_conditional] = STATE(4946),
    [sym_range] = STATE(4946),
    [sym_binary] = STATE(4946),
    [sym_unary] = STATE(4946),
    [sym_left_assignment_list] = STATE(2091),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2092),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2092),
    [sym_false] = STATE(2092),
    [sym_nil] = STATE(2092),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4439),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3643),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3647),
    [anon_sym_yield] = ACTIONS(3649),
    [anon_sym_break] = ACTIONS(3651),
    [anon_sym_next] = ACTIONS(3653),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(7250),
    [anon_sym_defined_QMARK] = ACTIONS(3655),
    [anon_sym_not] = ACTIONS(3657),
    [anon_sym_BANG] = ACTIONS(3661),
    [anon_sym_TILDE] = ACTIONS(3661),
    [sym_constant] = ACTIONS(3667),
    [sym_identifier] = ACTIONS(3667),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2509] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4947),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2092),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2092),
    [sym_assignment] = STATE(4947),
    [sym_operator_assignment] = STATE(4947),
    [sym_conditional] = STATE(4947),
    [sym_range] = STATE(4947),
    [sym_binary] = STATE(4947),
    [sym_unary] = STATE(4947),
    [sym_left_assignment_list] = STATE(2091),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2092),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2092),
    [sym_false] = STATE(2092),
    [sym_nil] = STATE(2092),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4439),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3643),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3647),
    [anon_sym_yield] = ACTIONS(3649),
    [anon_sym_break] = ACTIONS(3651),
    [anon_sym_next] = ACTIONS(3653),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(7250),
    [anon_sym_defined_QMARK] = ACTIONS(3655),
    [anon_sym_not] = ACTIONS(3657),
    [anon_sym_BANG] = ACTIONS(3661),
    [anon_sym_TILDE] = ACTIONS(3661),
    [sym_constant] = ACTIONS(3667),
    [sym_identifier] = ACTIONS(3667),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2510] = {
    [anon_sym_COLON] = ACTIONS(7868),
    [sym_comment] = ACTIONS(87),
  },
  [2511] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4949),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2092),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2092),
    [sym_assignment] = STATE(4949),
    [sym_operator_assignment] = STATE(4949),
    [sym_conditional] = STATE(4949),
    [sym_range] = STATE(4949),
    [sym_binary] = STATE(4949),
    [sym_unary] = STATE(4949),
    [sym_left_assignment_list] = STATE(2091),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2092),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2092),
    [sym_false] = STATE(2092),
    [sym_nil] = STATE(2092),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4439),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3643),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3647),
    [anon_sym_yield] = ACTIONS(3649),
    [anon_sym_break] = ACTIONS(3651),
    [anon_sym_next] = ACTIONS(3653),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(7250),
    [anon_sym_defined_QMARK] = ACTIONS(3655),
    [anon_sym_not] = ACTIONS(3657),
    [anon_sym_BANG] = ACTIONS(3661),
    [anon_sym_TILDE] = ACTIONS(3661),
    [sym_constant] = ACTIONS(3667),
    [sym_identifier] = ACTIONS(3667),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2512] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(7870),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [2513] = {
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(7256),
    [sym__binary_star] = ACTIONS(7258),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_RPAREN] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(7260),
    [anon_sym_STAR_STAR] = ACTIONS(7262),
    [anon_sym_AMP] = ACTIONS(7264),
    [anon_sym_EQ] = ACTIONS(1631),
    [anon_sym_LT] = ACTIONS(7266),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(1625),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_PLUS_EQ] = ACTIONS(1625),
    [anon_sym_DASH_EQ] = ACTIONS(1625),
    [anon_sym_STAR_EQ] = ACTIONS(1625),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1625),
    [anon_sym_SLASH_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1625),
    [anon_sym_AMP_EQ] = ACTIONS(1625),
    [anon_sym_PERCENT_EQ] = ACTIONS(1625),
    [anon_sym_GT_GT_EQ] = ACTIONS(1625),
    [anon_sym_LT_LT_EQ] = ACTIONS(1625),
    [anon_sym_CARET_EQ] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(7268),
    [anon_sym_DOT_DOT] = ACTIONS(7270),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7272),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(7274),
    [anon_sym_AMP_AMP] = ACTIONS(7274),
    [anon_sym_LT_LT] = ACTIONS(7276),
    [anon_sym_GT_GT] = ACTIONS(7276),
    [anon_sym_EQ_EQ] = ACTIONS(7274),
    [anon_sym_BANG_EQ] = ACTIONS(7278),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7278),
    [anon_sym_LT_EQ_GT] = ACTIONS(7278),
    [anon_sym_EQ_TILDE] = ACTIONS(7278),
    [anon_sym_BANG_TILDE] = ACTIONS(7278),
    [anon_sym_LT_EQ] = ACTIONS(7266),
    [anon_sym_GT] = ACTIONS(7266),
    [anon_sym_GT_EQ] = ACTIONS(7280),
    [anon_sym_CARET] = ACTIONS(7260),
    [anon_sym_PLUS] = ACTIONS(7282),
    [anon_sym_SLASH] = ACTIONS(7262),
    [anon_sym_PERCENT] = ACTIONS(7262),
    [sym_comment] = ACTIONS(87),
  },
  [2514] = {
    [sym_heredoc_body] = STATE(4951),
    [aux_sym_call_repeat1] = STATE(4951),
    [sym__heredoc_body_start] = ACTIONS(3543),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [2515] = {
    [sym_heredoc_body] = STATE(4951),
    [aux_sym_call_repeat1] = STATE(4951),
    [aux_sym_argument_list_repeat1] = STATE(4953),
    [sym__heredoc_body_start] = ACTIONS(3543),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(7872),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [2516] = {
    [sym_string] = STATE(4459),
    [aux_sym_chained_string_repeat1] = STATE(4459),
    [sym__string_start] = ACTIONS(1141),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(7874),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2517] = {
    [sym__line_break] = ACTIONS(7876),
    [sym__heredoc_body_start] = ACTIONS(7876),
    [sym__binary_minus] = ACTIONS(7876),
    [sym__binary_star] = ACTIONS(7876),
    [ts_builtin_sym_end] = ACTIONS(7876),
    [anon_sym___END__] = ACTIONS(7876),
    [anon_sym_LBRACE] = ACTIONS(7876),
    [anon_sym_RBRACE] = ACTIONS(7876),
    [anon_sym_RPAREN] = ACTIONS(7876),
    [anon_sym_DOT] = ACTIONS(7878),
    [anon_sym_COMMA] = ACTIONS(7876),
    [anon_sym_PIPE] = ACTIONS(7878),
    [anon_sym_SEMI] = ACTIONS(7876),
    [anon_sym_STAR_STAR] = ACTIONS(7876),
    [anon_sym_AMP] = ACTIONS(7878),
    [anon_sym_LT] = ACTIONS(7878),
    [anon_sym_end] = ACTIONS(7876),
    [anon_sym_if] = ACTIONS(7876),
    [anon_sym_unless] = ACTIONS(7876),
    [anon_sym_while] = ACTIONS(7876),
    [anon_sym_until] = ACTIONS(7876),
    [anon_sym_rescue] = ACTIONS(7876),
    [anon_sym_do] = ACTIONS(7876),
    [anon_sym_when] = ACTIONS(7876),
    [anon_sym_elsif] = ACTIONS(7876),
    [anon_sym_else] = ACTIONS(7876),
    [anon_sym_then] = ACTIONS(7876),
    [anon_sym_ensure] = ACTIONS(7876),
    [anon_sym_EQ_GT] = ACTIONS(7876),
    [anon_sym_LBRACK] = ACTIONS(7876),
    [anon_sym_COLON_COLON2] = ACTIONS(7876),
    [anon_sym_AMP_DOT] = ACTIONS(7876),
    [anon_sym_QMARK] = ACTIONS(7876),
    [anon_sym_DOT_DOT] = ACTIONS(7878),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7876),
    [anon_sym_and] = ACTIONS(7876),
    [anon_sym_or] = ACTIONS(7876),
    [anon_sym_PIPE_PIPE] = ACTIONS(7876),
    [anon_sym_AMP_AMP] = ACTIONS(7876),
    [anon_sym_LT_LT] = ACTIONS(7876),
    [anon_sym_GT_GT] = ACTIONS(7876),
    [anon_sym_EQ_EQ] = ACTIONS(7878),
    [anon_sym_BANG_EQ] = ACTIONS(7876),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7876),
    [anon_sym_LT_EQ_GT] = ACTIONS(7876),
    [anon_sym_EQ_TILDE] = ACTIONS(7876),
    [anon_sym_BANG_TILDE] = ACTIONS(7876),
    [anon_sym_LT_EQ] = ACTIONS(7878),
    [anon_sym_GT] = ACTIONS(7878),
    [anon_sym_GT_EQ] = ACTIONS(7876),
    [anon_sym_CARET] = ACTIONS(7876),
    [anon_sym_PLUS] = ACTIONS(7876),
    [anon_sym_SLASH] = ACTIONS(7876),
    [anon_sym_PERCENT] = ACTIONS(7876),
    [sym_comment] = ACTIONS(87),
  },
  [2518] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(906),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(911),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(911),
    [sym__argument] = STATE(3454),
    [sym_splat_argument] = STATE(3454),
    [sym_hash_splat_argument] = STATE(3454),
    [sym_block_argument] = STATE(3454),
    [sym_assignment] = STATE(906),
    [sym_operator_assignment] = STATE(906),
    [sym_conditional] = STATE(906),
    [sym_range] = STATE(906),
    [sym_binary] = STATE(906),
    [sym_unary] = STATE(906),
    [sym_left_assignment_list] = STATE(910),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(911),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(911),
    [sym_false] = STATE(911),
    [sym_nil] = STATE(911),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(912),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_heredoc_body] = STATE(4954),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(3454),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1589),
    [sym__splat_star] = ACTIONS(1591),
    [sym__unary_minus] = ACTIONS(1593),
    [sym__identifier_hash_key] = ACTIONS(1595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(5729),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1599),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_defined_QMARK] = ACTIONS(1611),
    [anon_sym_not] = ACTIONS(1613),
    [anon_sym_BANG] = ACTIONS(1615),
    [anon_sym_TILDE] = ACTIONS(1615),
    [sym_constant] = ACTIONS(1617),
    [sym_identifier] = ACTIONS(1617),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2519] = {
    [sym_heredoc_body] = STATE(3457),
    [aux_sym_argument_list_repeat1] = STATE(4956),
    [sym__heredoc_body_start] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(5729),
    [anon_sym_COMMA] = ACTIONS(7880),
    [sym_comment] = ACTIONS(87),
  },
  [2520] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4958),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(911),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(911),
    [sym_splat_argument] = STATE(4959),
    [sym_assignment] = STATE(4958),
    [sym_operator_assignment] = STATE(4958),
    [sym_conditional] = STATE(4958),
    [sym_range] = STATE(4958),
    [sym_binary] = STATE(4958),
    [sym_unary] = STATE(4958),
    [sym_right_assignment_list] = STATE(3461),
    [sym__arg_or_splat_arg] = STATE(4959),
    [sym_left_assignment_list] = STATE(910),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(911),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(911),
    [sym_false] = STATE(911),
    [sym_nil] = STATE(911),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2484),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(7882),
    [sym__unary_minus] = ACTIONS(1593),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_defined_QMARK] = ACTIONS(1611),
    [anon_sym_not] = ACTIONS(1613),
    [anon_sym_BANG] = ACTIONS(1615),
    [anon_sym_TILDE] = ACTIONS(1615),
    [sym_constant] = ACTIONS(1621),
    [sym_identifier] = ACTIONS(1621),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2521] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4960),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(911),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(911),
    [sym_assignment] = STATE(4960),
    [sym_operator_assignment] = STATE(4960),
    [sym_conditional] = STATE(4960),
    [sym_range] = STATE(4960),
    [sym_binary] = STATE(4960),
    [sym_unary] = STATE(4960),
    [sym_left_assignment_list] = STATE(910),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(911),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(911),
    [sym_false] = STATE(911),
    [sym_nil] = STATE(911),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2484),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1593),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_defined_QMARK] = ACTIONS(1611),
    [anon_sym_not] = ACTIONS(1613),
    [anon_sym_BANG] = ACTIONS(1615),
    [anon_sym_TILDE] = ACTIONS(1615),
    [sym_constant] = ACTIONS(1621),
    [sym_identifier] = ACTIONS(1621),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2522] = {
    [sym_string] = STATE(4961),
    [aux_sym_chained_string_repeat1] = STATE(4961),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_RPAREN] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_EQ_GT] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [2523] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(4213),
    [sym__binary_star] = ACTIONS(4215),
    [ts_builtin_sym_end] = ACTIONS(7027),
    [anon_sym___END__] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(4219),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(4215),
    [anon_sym_AMP] = ACTIONS(4221),
    [anon_sym_LT] = ACTIONS(4223),
    [anon_sym_if] = ACTIONS(7027),
    [anon_sym_unless] = ACTIONS(7027),
    [anon_sym_while] = ACTIONS(7027),
    [anon_sym_until] = ACTIONS(7027),
    [anon_sym_rescue] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(4225),
    [anon_sym_DOT_DOT] = ACTIONS(4227),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4229),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(4231),
    [anon_sym_AMP_AMP] = ACTIONS(4231),
    [anon_sym_LT_LT] = ACTIONS(4233),
    [anon_sym_GT_GT] = ACTIONS(4233),
    [anon_sym_EQ_EQ] = ACTIONS(4235),
    [anon_sym_BANG_EQ] = ACTIONS(4231),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4231),
    [anon_sym_LT_EQ_GT] = ACTIONS(4231),
    [anon_sym_EQ_TILDE] = ACTIONS(4231),
    [anon_sym_BANG_TILDE] = ACTIONS(4231),
    [anon_sym_LT_EQ] = ACTIONS(4223),
    [anon_sym_GT] = ACTIONS(4223),
    [anon_sym_GT_EQ] = ACTIONS(4237),
    [anon_sym_CARET] = ACTIONS(4239),
    [anon_sym_PLUS] = ACTIONS(4213),
    [anon_sym_SLASH] = ACTIONS(4215),
    [anon_sym_PERCENT] = ACTIONS(4215),
    [sym_comment] = ACTIONS(87),
  },
  [2524] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(1629),
    [ts_builtin_sym_end] = ACTIONS(5825),
    [anon_sym___END__] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(1629),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(1629),
    [anon_sym_PERCENT] = ACTIONS(1629),
    [sym_comment] = ACTIONS(87),
  },
  [2525] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [ts_builtin_sym_end] = ACTIONS(5825),
    [anon_sym___END__] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(1629),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [2526] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(1627),
    [sym__binary_star] = ACTIONS(1629),
    [ts_builtin_sym_end] = ACTIONS(5825),
    [anon_sym___END__] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(1629),
    [anon_sym_AMP] = ACTIONS(1635),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(1647),
    [anon_sym_GT_GT] = ACTIONS(1647),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(1627),
    [anon_sym_SLASH] = ACTIONS(1629),
    [anon_sym_PERCENT] = ACTIONS(1629),
    [sym_comment] = ACTIONS(87),
  },
  [2527] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(1627),
    [sym__binary_star] = ACTIONS(1629),
    [ts_builtin_sym_end] = ACTIONS(5825),
    [anon_sym___END__] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(1629),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(1647),
    [anon_sym_GT_GT] = ACTIONS(1647),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(1627),
    [anon_sym_SLASH] = ACTIONS(1629),
    [anon_sym_PERCENT] = ACTIONS(1629),
    [sym_comment] = ACTIONS(87),
  },
  [2528] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(1627),
    [sym__binary_star] = ACTIONS(1629),
    [ts_builtin_sym_end] = ACTIONS(5825),
    [anon_sym___END__] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(1633),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(1629),
    [anon_sym_AMP] = ACTIONS(1635),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(1647),
    [anon_sym_GT_GT] = ACTIONS(1647),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(1653),
    [anon_sym_PLUS] = ACTIONS(1627),
    [anon_sym_SLASH] = ACTIONS(1629),
    [anon_sym_PERCENT] = ACTIONS(1629),
    [sym_comment] = ACTIONS(87),
  },
  [2529] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(7886),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [2530] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(1627),
    [sym__binary_star] = ACTIONS(1629),
    [ts_builtin_sym_end] = ACTIONS(5927),
    [anon_sym___END__] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(1633),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(1629),
    [anon_sym_AMP] = ACTIONS(1635),
    [anon_sym_LT] = ACTIONS(1637),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_EQ_GT] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(1641),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1643),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(1645),
    [anon_sym_AMP_AMP] = ACTIONS(1645),
    [anon_sym_LT_LT] = ACTIONS(1647),
    [anon_sym_GT_GT] = ACTIONS(1647),
    [anon_sym_EQ_EQ] = ACTIONS(1649),
    [anon_sym_BANG_EQ] = ACTIONS(1645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1645),
    [anon_sym_LT_EQ_GT] = ACTIONS(1645),
    [anon_sym_EQ_TILDE] = ACTIONS(1645),
    [anon_sym_BANG_TILDE] = ACTIONS(1645),
    [anon_sym_LT_EQ] = ACTIONS(1637),
    [anon_sym_GT] = ACTIONS(1637),
    [anon_sym_GT_EQ] = ACTIONS(1651),
    [anon_sym_CARET] = ACTIONS(1653),
    [anon_sym_PLUS] = ACTIONS(1627),
    [anon_sym_SLASH] = ACTIONS(1629),
    [anon_sym_PERCENT] = ACTIONS(1629),
    [sym_comment] = ACTIONS(87),
  },
  [2531] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(1627),
    [sym__binary_star] = ACTIONS(1629),
    [ts_builtin_sym_end] = ACTIONS(5825),
    [anon_sym___END__] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(1633),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(1629),
    [anon_sym_AMP] = ACTIONS(1635),
    [anon_sym_LT] = ACTIONS(1637),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(1639),
    [anon_sym_DOT_DOT] = ACTIONS(1641),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1643),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(1645),
    [anon_sym_AMP_AMP] = ACTIONS(1645),
    [anon_sym_LT_LT] = ACTIONS(1647),
    [anon_sym_GT_GT] = ACTIONS(1647),
    [anon_sym_EQ_EQ] = ACTIONS(1649),
    [anon_sym_BANG_EQ] = ACTIONS(1645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1645),
    [anon_sym_LT_EQ_GT] = ACTIONS(1645),
    [anon_sym_EQ_TILDE] = ACTIONS(1645),
    [anon_sym_BANG_TILDE] = ACTIONS(1645),
    [anon_sym_LT_EQ] = ACTIONS(1637),
    [anon_sym_GT] = ACTIONS(1637),
    [anon_sym_GT_EQ] = ACTIONS(1651),
    [anon_sym_CARET] = ACTIONS(1653),
    [anon_sym_PLUS] = ACTIONS(1627),
    [anon_sym_SLASH] = ACTIONS(1629),
    [anon_sym_PERCENT] = ACTIONS(1629),
    [sym_comment] = ACTIONS(87),
  },
  [2532] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(1627),
    [sym__binary_star] = ACTIONS(1629),
    [ts_builtin_sym_end] = ACTIONS(5825),
    [anon_sym___END__] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(1633),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(1629),
    [anon_sym_AMP] = ACTIONS(1635),
    [anon_sym_LT] = ACTIONS(1637),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(1647),
    [anon_sym_GT_GT] = ACTIONS(1647),
    [anon_sym_EQ_EQ] = ACTIONS(1649),
    [anon_sym_BANG_EQ] = ACTIONS(1645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1645),
    [anon_sym_LT_EQ_GT] = ACTIONS(1645),
    [anon_sym_EQ_TILDE] = ACTIONS(1645),
    [anon_sym_BANG_TILDE] = ACTIONS(1645),
    [anon_sym_LT_EQ] = ACTIONS(1637),
    [anon_sym_GT] = ACTIONS(1637),
    [anon_sym_GT_EQ] = ACTIONS(1651),
    [anon_sym_CARET] = ACTIONS(1653),
    [anon_sym_PLUS] = ACTIONS(1627),
    [anon_sym_SLASH] = ACTIONS(1629),
    [anon_sym_PERCENT] = ACTIONS(1629),
    [sym_comment] = ACTIONS(87),
  },
  [2533] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(1627),
    [sym__binary_star] = ACTIONS(1629),
    [ts_builtin_sym_end] = ACTIONS(5825),
    [anon_sym___END__] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(1629),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(1627),
    [anon_sym_SLASH] = ACTIONS(1629),
    [anon_sym_PERCENT] = ACTIONS(1629),
    [sym_comment] = ACTIONS(87),
  },
  [2534] = {
    [sym__line_break] = ACTIONS(1263),
    [sym__simple_symbol] = ACTIONS(1263),
    [sym__string_start] = ACTIONS(1263),
    [sym__symbol_start] = ACTIONS(1263),
    [sym__subshell_start] = ACTIONS(1263),
    [sym__regex_start] = ACTIONS(1263),
    [sym__string_array_start] = ACTIONS(1263),
    [sym__symbol_array_start] = ACTIONS(1263),
    [sym__heredoc_body_start] = ACTIONS(1263),
    [sym_heredoc_beginning] = ACTIONS(1263),
    [sym__block_ampersand] = ACTIONS(1263),
    [sym__splat_star] = ACTIONS(1263),
    [sym__unary_minus] = ACTIONS(1263),
    [sym__binary_minus] = ACTIONS(1263),
    [sym__binary_star] = ACTIONS(1263),
    [sym__identifier_hash_key] = ACTIONS(1263),
    [ts_builtin_sym_end] = ACTIONS(1263),
    [anon_sym___END__] = ACTIONS(1265),
    [anon_sym_LBRACE] = ACTIONS(1263),
    [anon_sym_RBRACE] = ACTIONS(1263),
    [anon_sym_def] = ACTIONS(1265),
    [anon_sym_LPAREN] = ACTIONS(1265),
    [anon_sym_RPAREN] = ACTIONS(1263),
    [anon_sym_DOT] = ACTIONS(1265),
    [anon_sym_COLON_COLON] = ACTIONS(1265),
    [anon_sym_COMMA] = ACTIONS(1263),
    [anon_sym_PIPE] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_STAR_STAR] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1265),
    [anon_sym_EQ] = ACTIONS(1265),
    [anon_sym_class] = ACTIONS(1265),
    [anon_sym_LT] = ACTIONS(1265),
    [anon_sym_module] = ACTIONS(1265),
    [anon_sym_end] = ACTIONS(1265),
    [anon_sym_return] = ACTIONS(1265),
    [anon_sym_yield] = ACTIONS(1265),
    [anon_sym_break] = ACTIONS(1265),
    [anon_sym_next] = ACTIONS(1265),
    [sym_redo] = ACTIONS(1265),
    [sym_retry] = ACTIONS(1265),
    [anon_sym_if] = ACTIONS(1265),
    [anon_sym_unless] = ACTIONS(1265),
    [anon_sym_while] = ACTIONS(1265),
    [anon_sym_until] = ACTIONS(1265),
    [anon_sym_rescue] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1265),
    [anon_sym_do] = ACTIONS(1265),
    [anon_sym_case] = ACTIONS(1265),
    [anon_sym_when] = ACTIONS(1265),
    [anon_sym_elsif] = ACTIONS(1265),
    [anon_sym_else] = ACTIONS(1265),
    [anon_sym_then] = ACTIONS(1265),
    [anon_sym_begin] = ACTIONS(1265),
    [anon_sym_ensure] = ACTIONS(1265),
    [anon_sym_EQ_GT] = ACTIONS(1263),
    [anon_sym_LBRACK] = ACTIONS(1263),
    [anon_sym_COLON_COLON2] = ACTIONS(1263),
    [anon_sym_AMP_DOT] = ACTIONS(1263),
    [anon_sym_LPAREN2] = ACTIONS(1263),
    [anon_sym_PLUS_EQ] = ACTIONS(1263),
    [anon_sym_DASH_EQ] = ACTIONS(1263),
    [anon_sym_STAR_EQ] = ACTIONS(1263),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1263),
    [anon_sym_SLASH_EQ] = ACTIONS(1263),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1263),
    [anon_sym_PIPE_EQ] = ACTIONS(1263),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1263),
    [anon_sym_AMP_EQ] = ACTIONS(1263),
    [anon_sym_PERCENT_EQ] = ACTIONS(1263),
    [anon_sym_GT_GT_EQ] = ACTIONS(1263),
    [anon_sym_LT_LT_EQ] = ACTIONS(1263),
    [anon_sym_CARET_EQ] = ACTIONS(1263),
    [anon_sym_QMARK] = ACTIONS(1265),
    [anon_sym_DOT_DOT] = ACTIONS(1265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1263),
    [anon_sym_and] = ACTIONS(1265),
    [anon_sym_or] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_LT_LT] = ACTIONS(1265),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_EQ_EQ] = ACTIONS(1265),
    [anon_sym_BANG_EQ] = ACTIONS(1263),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1263),
    [anon_sym_LT_EQ_GT] = ACTIONS(1263),
    [anon_sym_EQ_TILDE] = ACTIONS(1263),
    [anon_sym_BANG_TILDE] = ACTIONS(1263),
    [anon_sym_LT_EQ] = ACTIONS(1265),
    [anon_sym_GT] = ACTIONS(1265),
    [anon_sym_GT_EQ] = ACTIONS(1263),
    [anon_sym_CARET] = ACTIONS(1265),
    [anon_sym_PLUS] = ACTIONS(1265),
    [anon_sym_SLASH] = ACTIONS(1265),
    [anon_sym_PERCENT] = ACTIONS(1265),
    [anon_sym_defined_QMARK] = ACTIONS(1263),
    [anon_sym_not] = ACTIONS(1265),
    [anon_sym_BANG] = ACTIONS(1265),
    [anon_sym_TILDE] = ACTIONS(1263),
    [sym_constant] = ACTIONS(1265),
    [sym_identifier] = ACTIONS(1265),
    [sym_instance_variable] = ACTIONS(1263),
    [sym_class_variable] = ACTIONS(1263),
    [sym_global_variable] = ACTIONS(1263),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1265),
    [sym_float] = ACTIONS(1265),
    [sym_complex] = ACTIONS(1263),
    [sym_super] = ACTIONS(1265),
    [anon_sym_true] = ACTIONS(1265),
    [anon_sym_TRUE] = ACTIONS(1265),
    [anon_sym_false] = ACTIONS(1265),
    [anon_sym_FALSE] = ACTIONS(1265),
    [sym_self] = ACTIONS(1265),
    [anon_sym_nil] = ACTIONS(1265),
    [anon_sym_NIL] = ACTIONS(1265),
    [sym_character] = ACTIONS(1263),
    [anon_sym_LBRACK2] = ACTIONS(1265),
    [anon_sym_DASH_GT] = ACTIONS(1263),
  },
  [2535] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(906),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(911),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(911),
    [sym__argument_list_with_trailing_comma] = STATE(4964),
    [sym__argument] = STATE(909),
    [sym_splat_argument] = STATE(909),
    [sym_hash_splat_argument] = STATE(909),
    [sym_block_argument] = STATE(909),
    [sym_assignment] = STATE(906),
    [sym_operator_assignment] = STATE(906),
    [sym_conditional] = STATE(906),
    [sym_range] = STATE(906),
    [sym_binary] = STATE(906),
    [sym_unary] = STATE(906),
    [sym_left_assignment_list] = STATE(910),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(911),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(911),
    [sym_false] = STATE(911),
    [sym_nil] = STATE(911),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(912),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(909),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1589),
    [sym__splat_star] = ACTIONS(1591),
    [sym__unary_minus] = ACTIONS(1593),
    [sym__identifier_hash_key] = ACTIONS(1595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(7890),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1599),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_defined_QMARK] = ACTIONS(1611),
    [anon_sym_not] = ACTIONS(1613),
    [anon_sym_BANG] = ACTIONS(1615),
    [anon_sym_TILDE] = ACTIONS(1615),
    [sym_constant] = ACTIONS(1617),
    [sym_identifier] = ACTIONS(1617),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2536] = {
    [sym__line_break] = ACTIONS(5935),
    [sym__simple_symbol] = ACTIONS(5935),
    [sym__string_start] = ACTIONS(5935),
    [sym__symbol_start] = ACTIONS(5935),
    [sym__subshell_start] = ACTIONS(5935),
    [sym__regex_start] = ACTIONS(5935),
    [sym__string_array_start] = ACTIONS(5935),
    [sym__symbol_array_start] = ACTIONS(5935),
    [sym__heredoc_body_start] = ACTIONS(5935),
    [sym_heredoc_beginning] = ACTIONS(5935),
    [sym__block_ampersand] = ACTIONS(5935),
    [sym__splat_star] = ACTIONS(5935),
    [sym__unary_minus] = ACTIONS(5935),
    [sym__binary_minus] = ACTIONS(5935),
    [sym__binary_star] = ACTIONS(5935),
    [sym__identifier_hash_key] = ACTIONS(5935),
    [ts_builtin_sym_end] = ACTIONS(5935),
    [anon_sym___END__] = ACTIONS(5937),
    [anon_sym_LBRACE] = ACTIONS(5935),
    [anon_sym_RBRACE] = ACTIONS(5935),
    [anon_sym_def] = ACTIONS(5937),
    [anon_sym_LPAREN] = ACTIONS(5937),
    [anon_sym_RPAREN] = ACTIONS(5935),
    [anon_sym_DOT] = ACTIONS(5937),
    [anon_sym_COLON_COLON] = ACTIONS(5937),
    [anon_sym_COMMA] = ACTIONS(5935),
    [anon_sym_PIPE] = ACTIONS(5937),
    [anon_sym_SEMI] = ACTIONS(5935),
    [anon_sym_STAR] = ACTIONS(5937),
    [anon_sym_STAR_STAR] = ACTIONS(5937),
    [anon_sym_AMP] = ACTIONS(5937),
    [anon_sym_EQ] = ACTIONS(5937),
    [anon_sym_class] = ACTIONS(5937),
    [anon_sym_LT] = ACTIONS(5937),
    [anon_sym_module] = ACTIONS(5937),
    [anon_sym_end] = ACTIONS(5937),
    [anon_sym_return] = ACTIONS(5937),
    [anon_sym_yield] = ACTIONS(5937),
    [anon_sym_break] = ACTIONS(5937),
    [anon_sym_next] = ACTIONS(5937),
    [sym_redo] = ACTIONS(5937),
    [sym_retry] = ACTIONS(5937),
    [anon_sym_if] = ACTIONS(5937),
    [anon_sym_unless] = ACTIONS(5937),
    [anon_sym_while] = ACTIONS(5937),
    [anon_sym_until] = ACTIONS(5937),
    [anon_sym_rescue] = ACTIONS(5937),
    [anon_sym_for] = ACTIONS(5937),
    [anon_sym_do] = ACTIONS(5937),
    [anon_sym_case] = ACTIONS(5937),
    [anon_sym_when] = ACTIONS(5937),
    [anon_sym_elsif] = ACTIONS(5937),
    [anon_sym_else] = ACTIONS(5937),
    [anon_sym_then] = ACTIONS(5937),
    [anon_sym_begin] = ACTIONS(5937),
    [anon_sym_ensure] = ACTIONS(5937),
    [anon_sym_EQ_GT] = ACTIONS(5935),
    [anon_sym_LBRACK] = ACTIONS(5935),
    [anon_sym_COLON_COLON2] = ACTIONS(5935),
    [anon_sym_AMP_DOT] = ACTIONS(5935),
    [anon_sym_LPAREN2] = ACTIONS(5935),
    [anon_sym_PLUS_EQ] = ACTIONS(5935),
    [anon_sym_DASH_EQ] = ACTIONS(5935),
    [anon_sym_STAR_EQ] = ACTIONS(5935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5935),
    [anon_sym_SLASH_EQ] = ACTIONS(5935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5935),
    [anon_sym_PIPE_EQ] = ACTIONS(5935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5935),
    [anon_sym_AMP_EQ] = ACTIONS(5935),
    [anon_sym_PERCENT_EQ] = ACTIONS(5935),
    [anon_sym_GT_GT_EQ] = ACTIONS(5935),
    [anon_sym_LT_LT_EQ] = ACTIONS(5935),
    [anon_sym_CARET_EQ] = ACTIONS(5935),
    [anon_sym_QMARK] = ACTIONS(5937),
    [anon_sym_DOT_DOT] = ACTIONS(5937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5935),
    [anon_sym_and] = ACTIONS(5937),
    [anon_sym_or] = ACTIONS(5937),
    [anon_sym_PIPE_PIPE] = ACTIONS(5937),
    [anon_sym_AMP_AMP] = ACTIONS(5937),
    [anon_sym_LT_LT] = ACTIONS(5937),
    [anon_sym_GT_GT] = ACTIONS(5937),
    [anon_sym_EQ_EQ] = ACTIONS(5937),
    [anon_sym_BANG_EQ] = ACTIONS(5935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5935),
    [anon_sym_LT_EQ_GT] = ACTIONS(5935),
    [anon_sym_EQ_TILDE] = ACTIONS(5935),
    [anon_sym_BANG_TILDE] = ACTIONS(5935),
    [anon_sym_LT_EQ] = ACTIONS(5937),
    [anon_sym_GT] = ACTIONS(5937),
    [anon_sym_GT_EQ] = ACTIONS(5935),
    [anon_sym_CARET] = ACTIONS(5937),
    [anon_sym_PLUS] = ACTIONS(5937),
    [anon_sym_SLASH] = ACTIONS(5937),
    [anon_sym_PERCENT] = ACTIONS(5937),
    [anon_sym_defined_QMARK] = ACTIONS(5935),
    [anon_sym_not] = ACTIONS(5937),
    [anon_sym_BANG] = ACTIONS(5937),
    [anon_sym_TILDE] = ACTIONS(5935),
    [sym_constant] = ACTIONS(5937),
    [sym_identifier] = ACTIONS(5937),
    [sym_instance_variable] = ACTIONS(5935),
    [sym_class_variable] = ACTIONS(5935),
    [sym_global_variable] = ACTIONS(5935),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5937),
    [sym_float] = ACTIONS(5937),
    [sym_complex] = ACTIONS(5935),
    [sym_super] = ACTIONS(5937),
    [anon_sym_true] = ACTIONS(5937),
    [anon_sym_TRUE] = ACTIONS(5937),
    [anon_sym_false] = ACTIONS(5937),
    [anon_sym_FALSE] = ACTIONS(5937),
    [sym_self] = ACTIONS(5937),
    [anon_sym_nil] = ACTIONS(5937),
    [anon_sym_NIL] = ACTIONS(5937),
    [sym_character] = ACTIONS(5935),
    [anon_sym_LBRACK2] = ACTIONS(5937),
    [anon_sym_DASH_GT] = ACTIONS(5935),
  },
  [2537] = {
    [sym__line_break] = ACTIONS(5939),
    [sym__simple_symbol] = ACTIONS(5939),
    [sym__string_start] = ACTIONS(5939),
    [sym__symbol_start] = ACTIONS(5939),
    [sym__subshell_start] = ACTIONS(5939),
    [sym__regex_start] = ACTIONS(5939),
    [sym__string_array_start] = ACTIONS(5939),
    [sym__symbol_array_start] = ACTIONS(5939),
    [sym__heredoc_body_start] = ACTIONS(5939),
    [sym_heredoc_beginning] = ACTIONS(5939),
    [sym__block_ampersand] = ACTIONS(5939),
    [sym__splat_star] = ACTIONS(5939),
    [sym__unary_minus] = ACTIONS(5939),
    [sym__binary_minus] = ACTIONS(5939),
    [sym__binary_star] = ACTIONS(5939),
    [sym__identifier_hash_key] = ACTIONS(5939),
    [ts_builtin_sym_end] = ACTIONS(5939),
    [anon_sym___END__] = ACTIONS(5941),
    [anon_sym_LBRACE] = ACTIONS(5939),
    [anon_sym_RBRACE] = ACTIONS(5939),
    [anon_sym_def] = ACTIONS(5941),
    [anon_sym_LPAREN] = ACTIONS(5941),
    [anon_sym_RPAREN] = ACTIONS(5939),
    [anon_sym_DOT] = ACTIONS(5941),
    [anon_sym_COLON_COLON] = ACTIONS(5941),
    [anon_sym_COMMA] = ACTIONS(5939),
    [anon_sym_PIPE] = ACTIONS(5941),
    [anon_sym_SEMI] = ACTIONS(5939),
    [anon_sym_STAR] = ACTIONS(5941),
    [anon_sym_STAR_STAR] = ACTIONS(5941),
    [anon_sym_AMP] = ACTIONS(5941),
    [anon_sym_EQ] = ACTIONS(5941),
    [anon_sym_class] = ACTIONS(5941),
    [anon_sym_LT] = ACTIONS(5941),
    [anon_sym_module] = ACTIONS(5941),
    [anon_sym_end] = ACTIONS(5941),
    [anon_sym_return] = ACTIONS(5941),
    [anon_sym_yield] = ACTIONS(5941),
    [anon_sym_break] = ACTIONS(5941),
    [anon_sym_next] = ACTIONS(5941),
    [sym_redo] = ACTIONS(5941),
    [sym_retry] = ACTIONS(5941),
    [anon_sym_if] = ACTIONS(5941),
    [anon_sym_unless] = ACTIONS(5941),
    [anon_sym_while] = ACTIONS(5941),
    [anon_sym_until] = ACTIONS(5941),
    [anon_sym_rescue] = ACTIONS(5941),
    [anon_sym_for] = ACTIONS(5941),
    [anon_sym_do] = ACTIONS(5941),
    [anon_sym_case] = ACTIONS(5941),
    [anon_sym_when] = ACTIONS(5941),
    [anon_sym_elsif] = ACTIONS(5941),
    [anon_sym_else] = ACTIONS(5941),
    [anon_sym_then] = ACTIONS(5941),
    [anon_sym_begin] = ACTIONS(5941),
    [anon_sym_ensure] = ACTIONS(5941),
    [anon_sym_EQ_GT] = ACTIONS(5939),
    [anon_sym_LBRACK] = ACTIONS(5939),
    [anon_sym_COLON_COLON2] = ACTIONS(5939),
    [anon_sym_AMP_DOT] = ACTIONS(5939),
    [anon_sym_LPAREN2] = ACTIONS(5939),
    [anon_sym_PLUS_EQ] = ACTIONS(5939),
    [anon_sym_DASH_EQ] = ACTIONS(5939),
    [anon_sym_STAR_EQ] = ACTIONS(5939),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5939),
    [anon_sym_SLASH_EQ] = ACTIONS(5939),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5939),
    [anon_sym_PIPE_EQ] = ACTIONS(5939),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5939),
    [anon_sym_AMP_EQ] = ACTIONS(5939),
    [anon_sym_PERCENT_EQ] = ACTIONS(5939),
    [anon_sym_GT_GT_EQ] = ACTIONS(5939),
    [anon_sym_LT_LT_EQ] = ACTIONS(5939),
    [anon_sym_CARET_EQ] = ACTIONS(5939),
    [anon_sym_QMARK] = ACTIONS(5941),
    [anon_sym_DOT_DOT] = ACTIONS(5941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5939),
    [anon_sym_and] = ACTIONS(5941),
    [anon_sym_or] = ACTIONS(5941),
    [anon_sym_PIPE_PIPE] = ACTIONS(5941),
    [anon_sym_AMP_AMP] = ACTIONS(5941),
    [anon_sym_LT_LT] = ACTIONS(5941),
    [anon_sym_GT_GT] = ACTIONS(5941),
    [anon_sym_EQ_EQ] = ACTIONS(5941),
    [anon_sym_BANG_EQ] = ACTIONS(5939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5939),
    [anon_sym_LT_EQ_GT] = ACTIONS(5939),
    [anon_sym_EQ_TILDE] = ACTIONS(5939),
    [anon_sym_BANG_TILDE] = ACTIONS(5939),
    [anon_sym_LT_EQ] = ACTIONS(5941),
    [anon_sym_GT] = ACTIONS(5941),
    [anon_sym_GT_EQ] = ACTIONS(5939),
    [anon_sym_CARET] = ACTIONS(5941),
    [anon_sym_PLUS] = ACTIONS(5941),
    [anon_sym_SLASH] = ACTIONS(5941),
    [anon_sym_PERCENT] = ACTIONS(5941),
    [anon_sym_defined_QMARK] = ACTIONS(5939),
    [anon_sym_not] = ACTIONS(5941),
    [anon_sym_BANG] = ACTIONS(5941),
    [anon_sym_TILDE] = ACTIONS(5939),
    [sym_constant] = ACTIONS(5941),
    [sym_identifier] = ACTIONS(5941),
    [sym_instance_variable] = ACTIONS(5939),
    [sym_class_variable] = ACTIONS(5939),
    [sym_global_variable] = ACTIONS(5939),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5941),
    [sym_float] = ACTIONS(5941),
    [sym_complex] = ACTIONS(5939),
    [sym_super] = ACTIONS(5941),
    [anon_sym_true] = ACTIONS(5941),
    [anon_sym_TRUE] = ACTIONS(5941),
    [anon_sym_false] = ACTIONS(5941),
    [anon_sym_FALSE] = ACTIONS(5941),
    [sym_self] = ACTIONS(5941),
    [anon_sym_nil] = ACTIONS(5941),
    [anon_sym_NIL] = ACTIONS(5941),
    [sym_character] = ACTIONS(5939),
    [anon_sym_LBRACK2] = ACTIONS(5941),
    [anon_sym_DASH_GT] = ACTIONS(5939),
  },
  [2538] = {
    [sym_argument_list_with_parens] = STATE(4965),
    [sym__argument_list_with_parens] = STATE(2537),
    [sym_operator] = STATE(4965),
    [sym_heredoc_body] = STATE(3563),
    [aux_sym_call_repeat1] = STATE(3563),
    [sym__heredoc_body_start] = ACTIONS(2519),
    [anon_sym_PIPE] = ACTIONS(4347),
    [anon_sym_STAR] = ACTIONS(4349),
    [anon_sym_STAR_STAR] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4347),
    [anon_sym_LT] = ACTIONS(4349),
    [anon_sym_LPAREN2] = ACTIONS(4351),
    [anon_sym_DOT_DOT] = ACTIONS(4347),
    [anon_sym_LT_LT] = ACTIONS(4347),
    [anon_sym_GT_GT] = ACTIONS(4347),
    [anon_sym_EQ_EQ] = ACTIONS(4349),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4347),
    [anon_sym_LT_EQ_GT] = ACTIONS(4347),
    [anon_sym_EQ_TILDE] = ACTIONS(4347),
    [anon_sym_BANG_TILDE] = ACTIONS(4347),
    [anon_sym_LT_EQ] = ACTIONS(4349),
    [anon_sym_GT] = ACTIONS(4349),
    [anon_sym_GT_EQ] = ACTIONS(4347),
    [anon_sym_CARET] = ACTIONS(4347),
    [anon_sym_PLUS] = ACTIONS(4349),
    [anon_sym_SLASH] = ACTIONS(4347),
    [anon_sym_PERCENT] = ACTIONS(4347),
    [anon_sym_BANG] = ACTIONS(4349),
    [anon_sym_TILDE] = ACTIONS(4347),
    [sym_constant] = ACTIONS(7892),
    [sym_identifier] = ACTIONS(7892),
    [anon_sym_DASH] = ACTIONS(4349),
    [anon_sym_PLUS_AT] = ACTIONS(4347),
    [anon_sym_DASH_AT] = ACTIONS(4347),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4349),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(4347),
    [anon_sym_BQUOTE] = ACTIONS(4347),
    [sym_comment] = ACTIONS(87),
  },
  [2539] = {
    [sym__line_break] = ACTIONS(5945),
    [sym__heredoc_body_start] = ACTIONS(5945),
    [sym__binary_minus] = ACTIONS(5945),
    [sym__binary_star] = ACTIONS(5945),
    [ts_builtin_sym_end] = ACTIONS(5945),
    [anon_sym___END__] = ACTIONS(5945),
    [anon_sym_LBRACE] = ACTIONS(5945),
    [anon_sym_RBRACE] = ACTIONS(5945),
    [anon_sym_RPAREN] = ACTIONS(5945),
    [anon_sym_DOT] = ACTIONS(5947),
    [anon_sym_COMMA] = ACTIONS(5945),
    [anon_sym_PIPE] = ACTIONS(5947),
    [anon_sym_SEMI] = ACTIONS(5945),
    [anon_sym_STAR_STAR] = ACTIONS(5947),
    [anon_sym_AMP] = ACTIONS(5947),
    [anon_sym_EQ] = ACTIONS(5947),
    [anon_sym_LT] = ACTIONS(5947),
    [anon_sym_end] = ACTIONS(5945),
    [anon_sym_if] = ACTIONS(5945),
    [anon_sym_unless] = ACTIONS(5945),
    [anon_sym_while] = ACTIONS(5945),
    [anon_sym_until] = ACTIONS(5945),
    [anon_sym_rescue] = ACTIONS(5945),
    [anon_sym_do] = ACTIONS(5945),
    [anon_sym_when] = ACTIONS(5945),
    [anon_sym_elsif] = ACTIONS(5945),
    [anon_sym_else] = ACTIONS(5945),
    [anon_sym_then] = ACTIONS(5945),
    [anon_sym_ensure] = ACTIONS(5945),
    [anon_sym_EQ_GT] = ACTIONS(5945),
    [anon_sym_LBRACK] = ACTIONS(5945),
    [anon_sym_COLON_COLON2] = ACTIONS(5945),
    [anon_sym_AMP_DOT] = ACTIONS(5945),
    [anon_sym_PLUS_EQ] = ACTIONS(5945),
    [anon_sym_DASH_EQ] = ACTIONS(5945),
    [anon_sym_STAR_EQ] = ACTIONS(5945),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5945),
    [anon_sym_SLASH_EQ] = ACTIONS(5945),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5945),
    [anon_sym_PIPE_EQ] = ACTIONS(5945),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5945),
    [anon_sym_AMP_EQ] = ACTIONS(5945),
    [anon_sym_PERCENT_EQ] = ACTIONS(5945),
    [anon_sym_GT_GT_EQ] = ACTIONS(5945),
    [anon_sym_LT_LT_EQ] = ACTIONS(5945),
    [anon_sym_CARET_EQ] = ACTIONS(5945),
    [anon_sym_QMARK] = ACTIONS(5945),
    [anon_sym_DOT_DOT] = ACTIONS(5947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5945),
    [anon_sym_and] = ACTIONS(5945),
    [anon_sym_or] = ACTIONS(5945),
    [anon_sym_PIPE_PIPE] = ACTIONS(5947),
    [anon_sym_AMP_AMP] = ACTIONS(5947),
    [anon_sym_LT_LT] = ACTIONS(5947),
    [anon_sym_GT_GT] = ACTIONS(5947),
    [anon_sym_EQ_EQ] = ACTIONS(5947),
    [anon_sym_BANG_EQ] = ACTIONS(5945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5945),
    [anon_sym_LT_EQ_GT] = ACTIONS(5945),
    [anon_sym_EQ_TILDE] = ACTIONS(5945),
    [anon_sym_BANG_TILDE] = ACTIONS(5945),
    [anon_sym_LT_EQ] = ACTIONS(5947),
    [anon_sym_GT] = ACTIONS(5947),
    [anon_sym_GT_EQ] = ACTIONS(5945),
    [anon_sym_CARET] = ACTIONS(5947),
    [anon_sym_PLUS] = ACTIONS(5947),
    [anon_sym_SLASH] = ACTIONS(5947),
    [anon_sym_PERCENT] = ACTIONS(5947),
    [sym_comment] = ACTIONS(87),
  },
  [2540] = {
    [anon_sym_RBRACK] = ACTIONS(7894),
    [sym_comment] = ACTIONS(87),
  },
  [2541] = {
    [sym__line_break] = ACTIONS(5951),
    [sym__simple_symbol] = ACTIONS(5951),
    [sym__string_start] = ACTIONS(5951),
    [sym__symbol_start] = ACTIONS(5951),
    [sym__subshell_start] = ACTIONS(5951),
    [sym__regex_start] = ACTIONS(5951),
    [sym__string_array_start] = ACTIONS(5951),
    [sym__symbol_array_start] = ACTIONS(5951),
    [sym__heredoc_body_start] = ACTIONS(5951),
    [sym_heredoc_beginning] = ACTIONS(5951),
    [sym__block_ampersand] = ACTIONS(5951),
    [sym__splat_star] = ACTIONS(5951),
    [sym__unary_minus] = ACTIONS(5951),
    [sym__binary_minus] = ACTIONS(5951),
    [sym__binary_star] = ACTIONS(5951),
    [sym__identifier_hash_key] = ACTIONS(5951),
    [ts_builtin_sym_end] = ACTIONS(5951),
    [anon_sym___END__] = ACTIONS(5953),
    [anon_sym_LBRACE] = ACTIONS(5951),
    [anon_sym_RBRACE] = ACTIONS(5951),
    [anon_sym_def] = ACTIONS(5953),
    [anon_sym_LPAREN] = ACTIONS(5953),
    [anon_sym_RPAREN] = ACTIONS(5951),
    [anon_sym_DOT] = ACTIONS(5953),
    [anon_sym_COLON_COLON] = ACTIONS(5953),
    [anon_sym_COMMA] = ACTIONS(5951),
    [anon_sym_PIPE] = ACTIONS(5953),
    [anon_sym_SEMI] = ACTIONS(5951),
    [anon_sym_STAR] = ACTIONS(5953),
    [anon_sym_STAR_STAR] = ACTIONS(5953),
    [anon_sym_AMP] = ACTIONS(5953),
    [anon_sym_EQ] = ACTIONS(5953),
    [anon_sym_class] = ACTIONS(5953),
    [anon_sym_LT] = ACTIONS(5953),
    [anon_sym_module] = ACTIONS(5953),
    [anon_sym_end] = ACTIONS(5953),
    [anon_sym_return] = ACTIONS(5953),
    [anon_sym_yield] = ACTIONS(5953),
    [anon_sym_break] = ACTIONS(5953),
    [anon_sym_next] = ACTIONS(5953),
    [sym_redo] = ACTIONS(5953),
    [sym_retry] = ACTIONS(5953),
    [anon_sym_if] = ACTIONS(5953),
    [anon_sym_unless] = ACTIONS(5953),
    [anon_sym_while] = ACTIONS(5953),
    [anon_sym_until] = ACTIONS(5953),
    [anon_sym_rescue] = ACTIONS(5953),
    [anon_sym_for] = ACTIONS(5953),
    [anon_sym_do] = ACTIONS(5953),
    [anon_sym_case] = ACTIONS(5953),
    [anon_sym_when] = ACTIONS(5953),
    [anon_sym_elsif] = ACTIONS(5953),
    [anon_sym_else] = ACTIONS(5953),
    [anon_sym_then] = ACTIONS(5953),
    [anon_sym_begin] = ACTIONS(5953),
    [anon_sym_ensure] = ACTIONS(5953),
    [anon_sym_EQ_GT] = ACTIONS(5951),
    [anon_sym_LBRACK] = ACTIONS(5951),
    [anon_sym_COLON_COLON2] = ACTIONS(5951),
    [anon_sym_AMP_DOT] = ACTIONS(5951),
    [anon_sym_LPAREN2] = ACTIONS(5951),
    [anon_sym_PLUS_EQ] = ACTIONS(5951),
    [anon_sym_DASH_EQ] = ACTIONS(5951),
    [anon_sym_STAR_EQ] = ACTIONS(5951),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5951),
    [anon_sym_SLASH_EQ] = ACTIONS(5951),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5951),
    [anon_sym_PIPE_EQ] = ACTIONS(5951),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5951),
    [anon_sym_AMP_EQ] = ACTIONS(5951),
    [anon_sym_PERCENT_EQ] = ACTIONS(5951),
    [anon_sym_GT_GT_EQ] = ACTIONS(5951),
    [anon_sym_LT_LT_EQ] = ACTIONS(5951),
    [anon_sym_CARET_EQ] = ACTIONS(5951),
    [anon_sym_QMARK] = ACTIONS(5953),
    [anon_sym_DOT_DOT] = ACTIONS(5953),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5951),
    [anon_sym_and] = ACTIONS(5953),
    [anon_sym_or] = ACTIONS(5953),
    [anon_sym_PIPE_PIPE] = ACTIONS(5953),
    [anon_sym_AMP_AMP] = ACTIONS(5953),
    [anon_sym_LT_LT] = ACTIONS(5953),
    [anon_sym_GT_GT] = ACTIONS(5953),
    [anon_sym_EQ_EQ] = ACTIONS(5953),
    [anon_sym_BANG_EQ] = ACTIONS(5951),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5951),
    [anon_sym_LT_EQ_GT] = ACTIONS(5951),
    [anon_sym_EQ_TILDE] = ACTIONS(5951),
    [anon_sym_BANG_TILDE] = ACTIONS(5951),
    [anon_sym_LT_EQ] = ACTIONS(5953),
    [anon_sym_GT] = ACTIONS(5953),
    [anon_sym_GT_EQ] = ACTIONS(5951),
    [anon_sym_CARET] = ACTIONS(5953),
    [anon_sym_PLUS] = ACTIONS(5953),
    [anon_sym_SLASH] = ACTIONS(5953),
    [anon_sym_PERCENT] = ACTIONS(5953),
    [anon_sym_defined_QMARK] = ACTIONS(5951),
    [anon_sym_not] = ACTIONS(5953),
    [anon_sym_BANG] = ACTIONS(5953),
    [anon_sym_TILDE] = ACTIONS(5951),
    [sym_constant] = ACTIONS(5953),
    [sym_identifier] = ACTIONS(5953),
    [sym_instance_variable] = ACTIONS(5951),
    [sym_class_variable] = ACTIONS(5951),
    [sym_global_variable] = ACTIONS(5951),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5953),
    [sym_float] = ACTIONS(5953),
    [sym_complex] = ACTIONS(5951),
    [sym_super] = ACTIONS(5953),
    [anon_sym_true] = ACTIONS(5953),
    [anon_sym_TRUE] = ACTIONS(5953),
    [anon_sym_false] = ACTIONS(5953),
    [anon_sym_FALSE] = ACTIONS(5953),
    [sym_self] = ACTIONS(5953),
    [anon_sym_nil] = ACTIONS(5953),
    [anon_sym_NIL] = ACTIONS(5953),
    [sym_character] = ACTIONS(5951),
    [anon_sym_LBRACK2] = ACTIONS(5953),
    [anon_sym_DASH_GT] = ACTIONS(5951),
  },
  [2542] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(2687),
    [sym__binary_star] = ACTIONS(2689),
    [ts_builtin_sym_end] = ACTIONS(4211),
    [anon_sym___END__] = ACTIONS(4211),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(2691),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(2693),
    [anon_sym_AMP] = ACTIONS(2695),
    [anon_sym_EQ] = ACTIONS(4217),
    [anon_sym_LT] = ACTIONS(2697),
    [anon_sym_if] = ACTIONS(4211),
    [anon_sym_unless] = ACTIONS(4211),
    [anon_sym_while] = ACTIONS(4211),
    [anon_sym_until] = ACTIONS(4211),
    [anon_sym_rescue] = ACTIONS(4211),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_EQ_GT] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_PLUS_EQ] = ACTIONS(4211),
    [anon_sym_DASH_EQ] = ACTIONS(4211),
    [anon_sym_STAR_EQ] = ACTIONS(4211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4211),
    [anon_sym_SLASH_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4211),
    [anon_sym_AMP_EQ] = ACTIONS(4211),
    [anon_sym_PERCENT_EQ] = ACTIONS(4211),
    [anon_sym_GT_GT_EQ] = ACTIONS(4211),
    [anon_sym_LT_LT_EQ] = ACTIONS(4211),
    [anon_sym_CARET_EQ] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(2699),
    [anon_sym_DOT_DOT] = ACTIONS(2701),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2703),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(2705),
    [anon_sym_AMP_AMP] = ACTIONS(2705),
    [anon_sym_LT_LT] = ACTIONS(2707),
    [anon_sym_GT_GT] = ACTIONS(2707),
    [anon_sym_EQ_EQ] = ACTIONS(2705),
    [anon_sym_BANG_EQ] = ACTIONS(2709),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2709),
    [anon_sym_LT_EQ_GT] = ACTIONS(2709),
    [anon_sym_EQ_TILDE] = ACTIONS(2709),
    [anon_sym_BANG_TILDE] = ACTIONS(2709),
    [anon_sym_LT_EQ] = ACTIONS(2697),
    [anon_sym_GT] = ACTIONS(2697),
    [anon_sym_GT_EQ] = ACTIONS(2711),
    [anon_sym_CARET] = ACTIONS(2691),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_SLASH] = ACTIONS(2693),
    [anon_sym_PERCENT] = ACTIONS(2693),
    [sym_comment] = ACTIONS(87),
  },
  [2543] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(2687),
    [sym__binary_star] = ACTIONS(2689),
    [ts_builtin_sym_end] = ACTIONS(4247),
    [anon_sym___END__] = ACTIONS(4247),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(2691),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(2693),
    [anon_sym_AMP] = ACTIONS(2695),
    [anon_sym_EQ] = ACTIONS(4249),
    [anon_sym_LT] = ACTIONS(2697),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_EQ_GT] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_PLUS_EQ] = ACTIONS(4247),
    [anon_sym_DASH_EQ] = ACTIONS(4247),
    [anon_sym_STAR_EQ] = ACTIONS(4247),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4247),
    [anon_sym_SLASH_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4247),
    [anon_sym_AMP_EQ] = ACTIONS(4247),
    [anon_sym_PERCENT_EQ] = ACTIONS(4247),
    [anon_sym_GT_GT_EQ] = ACTIONS(4247),
    [anon_sym_LT_LT_EQ] = ACTIONS(4247),
    [anon_sym_CARET_EQ] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(2699),
    [anon_sym_DOT_DOT] = ACTIONS(2701),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2703),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(2705),
    [anon_sym_AMP_AMP] = ACTIONS(2705),
    [anon_sym_LT_LT] = ACTIONS(2707),
    [anon_sym_GT_GT] = ACTIONS(2707),
    [anon_sym_EQ_EQ] = ACTIONS(2705),
    [anon_sym_BANG_EQ] = ACTIONS(2709),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2709),
    [anon_sym_LT_EQ_GT] = ACTIONS(2709),
    [anon_sym_EQ_TILDE] = ACTIONS(2709),
    [anon_sym_BANG_TILDE] = ACTIONS(2709),
    [anon_sym_LT_EQ] = ACTIONS(2697),
    [anon_sym_GT] = ACTIONS(2697),
    [anon_sym_GT_EQ] = ACTIONS(2711),
    [anon_sym_CARET] = ACTIONS(2691),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_SLASH] = ACTIONS(2693),
    [anon_sym_PERCENT] = ACTIONS(2693),
    [sym_comment] = ACTIONS(87),
  },
  [2544] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(4967),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(428),
    [sym_scope_resolution] = STATE(422),
    [sym_call] = STATE(422),
    [sym_method_call] = STATE(428),
    [sym_assignment] = STATE(4967),
    [sym_operator_assignment] = STATE(4967),
    [sym_conditional] = STATE(4967),
    [sym_range] = STATE(4967),
    [sym_binary] = STATE(4967),
    [sym_unary] = STATE(4967),
    [sym_left_assignment_list] = STATE(427),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(428),
    [sym__variable] = STATE(422),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(428),
    [sym_false] = STATE(428),
    [sym_nil] = STATE(428),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(1503),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(781),
    [anon_sym_yield] = ACTIONS(783),
    [anon_sym_break] = ACTIONS(785),
    [anon_sym_next] = ACTIONS(787),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(2623),
    [anon_sym_defined_QMARK] = ACTIONS(801),
    [anon_sym_not] = ACTIONS(803),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_TILDE] = ACTIONS(807),
    [sym_constant] = ACTIONS(815),
    [sym_identifier] = ACTIONS(815),
    [sym_instance_variable] = ACTIONS(811),
    [sym_class_variable] = ACTIONS(811),
    [sym_global_variable] = ACTIONS(811),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(815),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(815),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2545] = {
    [sym__line_break] = ACTIONS(5735),
    [sym__heredoc_body_start] = ACTIONS(5735),
    [sym__binary_minus] = ACTIONS(5735),
    [sym__binary_star] = ACTIONS(5735),
    [ts_builtin_sym_end] = ACTIONS(5735),
    [anon_sym___END__] = ACTIONS(5735),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_RBRACE] = ACTIONS(5735),
    [anon_sym_RPAREN] = ACTIONS(5735),
    [anon_sym_DOT] = ACTIONS(5737),
    [anon_sym_COMMA] = ACTIONS(5735),
    [anon_sym_PIPE] = ACTIONS(5737),
    [anon_sym_SEMI] = ACTIONS(5735),
    [anon_sym_STAR_STAR] = ACTIONS(5737),
    [anon_sym_AMP] = ACTIONS(5737),
    [anon_sym_EQ] = ACTIONS(5737),
    [anon_sym_LT] = ACTIONS(5737),
    [anon_sym_end] = ACTIONS(5735),
    [anon_sym_if] = ACTIONS(5735),
    [anon_sym_unless] = ACTIONS(5735),
    [anon_sym_while] = ACTIONS(5735),
    [anon_sym_until] = ACTIONS(5735),
    [anon_sym_rescue] = ACTIONS(5735),
    [anon_sym_do] = ACTIONS(993),
    [anon_sym_when] = ACTIONS(5735),
    [anon_sym_elsif] = ACTIONS(5735),
    [anon_sym_else] = ACTIONS(5735),
    [anon_sym_then] = ACTIONS(5735),
    [anon_sym_ensure] = ACTIONS(5735),
    [anon_sym_EQ_GT] = ACTIONS(5735),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_COLON_COLON2] = ACTIONS(5735),
    [anon_sym_AMP_DOT] = ACTIONS(5735),
    [anon_sym_PLUS_EQ] = ACTIONS(5735),
    [anon_sym_DASH_EQ] = ACTIONS(5735),
    [anon_sym_STAR_EQ] = ACTIONS(5735),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5735),
    [anon_sym_SLASH_EQ] = ACTIONS(5735),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5735),
    [anon_sym_PIPE_EQ] = ACTIONS(5735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5735),
    [anon_sym_AMP_EQ] = ACTIONS(5735),
    [anon_sym_PERCENT_EQ] = ACTIONS(5735),
    [anon_sym_GT_GT_EQ] = ACTIONS(5735),
    [anon_sym_LT_LT_EQ] = ACTIONS(5735),
    [anon_sym_CARET_EQ] = ACTIONS(5735),
    [anon_sym_QMARK] = ACTIONS(5735),
    [anon_sym_DOT_DOT] = ACTIONS(5737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5735),
    [anon_sym_and] = ACTIONS(5735),
    [anon_sym_or] = ACTIONS(5735),
    [anon_sym_PIPE_PIPE] = ACTIONS(5737),
    [anon_sym_AMP_AMP] = ACTIONS(5737),
    [anon_sym_LT_LT] = ACTIONS(5737),
    [anon_sym_GT_GT] = ACTIONS(5737),
    [anon_sym_EQ_EQ] = ACTIONS(5737),
    [anon_sym_BANG_EQ] = ACTIONS(5735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5735),
    [anon_sym_LT_EQ_GT] = ACTIONS(5735),
    [anon_sym_EQ_TILDE] = ACTIONS(5735),
    [anon_sym_BANG_TILDE] = ACTIONS(5735),
    [anon_sym_LT_EQ] = ACTIONS(5737),
    [anon_sym_GT] = ACTIONS(5737),
    [anon_sym_GT_EQ] = ACTIONS(5735),
    [anon_sym_CARET] = ACTIONS(5737),
    [anon_sym_PLUS] = ACTIONS(5737),
    [anon_sym_SLASH] = ACTIONS(5737),
    [anon_sym_PERCENT] = ACTIONS(5737),
    [sym_comment] = ACTIONS(87),
  },
  [2546] = {
    [anon_sym_RBRACE] = ACTIONS(7896),
    [sym_comment] = ACTIONS(87),
  },
  [2547] = {
    [sym__statements] = STATE(4969),
    [sym_begin_block] = STATE(489),
    [sym_end_block] = STATE(489),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(495),
    [aux_sym__statements_repeat1] = STATE(495),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(7896),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2548] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(2687),
    [sym__binary_star] = ACTIONS(2689),
    [ts_builtin_sym_end] = ACTIONS(3281),
    [anon_sym___END__] = ACTIONS(3281),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(2691),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(2693),
    [anon_sym_AMP] = ACTIONS(2695),
    [anon_sym_EQ] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(2697),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_unless] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_until] = ACTIONS(3281),
    [anon_sym_rescue] = ACTIONS(3281),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_EQ_GT] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_PLUS_EQ] = ACTIONS(3281),
    [anon_sym_DASH_EQ] = ACTIONS(3281),
    [anon_sym_STAR_EQ] = ACTIONS(3281),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3281),
    [anon_sym_SLASH_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3281),
    [anon_sym_AMP_EQ] = ACTIONS(3281),
    [anon_sym_PERCENT_EQ] = ACTIONS(3281),
    [anon_sym_GT_GT_EQ] = ACTIONS(3281),
    [anon_sym_LT_LT_EQ] = ACTIONS(3281),
    [anon_sym_CARET_EQ] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(2699),
    [anon_sym_DOT_DOT] = ACTIONS(2701),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2703),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(2705),
    [anon_sym_AMP_AMP] = ACTIONS(2705),
    [anon_sym_LT_LT] = ACTIONS(2707),
    [anon_sym_GT_GT] = ACTIONS(2707),
    [anon_sym_EQ_EQ] = ACTIONS(2705),
    [anon_sym_BANG_EQ] = ACTIONS(2709),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2709),
    [anon_sym_LT_EQ_GT] = ACTIONS(2709),
    [anon_sym_EQ_TILDE] = ACTIONS(2709),
    [anon_sym_BANG_TILDE] = ACTIONS(2709),
    [anon_sym_LT_EQ] = ACTIONS(2697),
    [anon_sym_GT] = ACTIONS(2697),
    [anon_sym_GT_EQ] = ACTIONS(2711),
    [anon_sym_CARET] = ACTIONS(2691),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_SLASH] = ACTIONS(2693),
    [anon_sym_PERCENT] = ACTIONS(2693),
    [sym_comment] = ACTIONS(87),
  },
  [2549] = {
    [sym__line_break] = ACTIONS(5771),
    [sym__heredoc_body_start] = ACTIONS(5771),
    [sym__binary_minus] = ACTIONS(5771),
    [sym__binary_star] = ACTIONS(5771),
    [ts_builtin_sym_end] = ACTIONS(5771),
    [anon_sym___END__] = ACTIONS(5771),
    [anon_sym_LBRACE] = ACTIONS(5771),
    [anon_sym_RBRACE] = ACTIONS(5771),
    [anon_sym_RPAREN] = ACTIONS(5771),
    [anon_sym_DOT] = ACTIONS(5773),
    [anon_sym_COMMA] = ACTIONS(5771),
    [anon_sym_PIPE] = ACTIONS(5773),
    [anon_sym_SEMI] = ACTIONS(5771),
    [anon_sym_STAR_STAR] = ACTIONS(5773),
    [anon_sym_AMP] = ACTIONS(5773),
    [anon_sym_EQ] = ACTIONS(5773),
    [anon_sym_LT] = ACTIONS(5773),
    [anon_sym_end] = ACTIONS(5771),
    [anon_sym_if] = ACTIONS(5771),
    [anon_sym_unless] = ACTIONS(5771),
    [anon_sym_while] = ACTIONS(5771),
    [anon_sym_until] = ACTIONS(5771),
    [anon_sym_rescue] = ACTIONS(5771),
    [anon_sym_do] = ACTIONS(5771),
    [anon_sym_when] = ACTIONS(5771),
    [anon_sym_elsif] = ACTIONS(5771),
    [anon_sym_else] = ACTIONS(5771),
    [anon_sym_then] = ACTIONS(5771),
    [anon_sym_ensure] = ACTIONS(5771),
    [anon_sym_EQ_GT] = ACTIONS(5771),
    [anon_sym_LBRACK] = ACTIONS(5771),
    [anon_sym_COLON_COLON2] = ACTIONS(5771),
    [anon_sym_AMP_DOT] = ACTIONS(5771),
    [anon_sym_PLUS_EQ] = ACTIONS(5771),
    [anon_sym_DASH_EQ] = ACTIONS(5771),
    [anon_sym_STAR_EQ] = ACTIONS(5771),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5771),
    [anon_sym_SLASH_EQ] = ACTIONS(5771),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5771),
    [anon_sym_PIPE_EQ] = ACTIONS(5771),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5771),
    [anon_sym_AMP_EQ] = ACTIONS(5771),
    [anon_sym_PERCENT_EQ] = ACTIONS(5771),
    [anon_sym_GT_GT_EQ] = ACTIONS(5771),
    [anon_sym_LT_LT_EQ] = ACTIONS(5771),
    [anon_sym_CARET_EQ] = ACTIONS(5771),
    [anon_sym_QMARK] = ACTIONS(5771),
    [anon_sym_DOT_DOT] = ACTIONS(5773),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5771),
    [anon_sym_and] = ACTIONS(5771),
    [anon_sym_or] = ACTIONS(5771),
    [anon_sym_PIPE_PIPE] = ACTIONS(5773),
    [anon_sym_AMP_AMP] = ACTIONS(5773),
    [anon_sym_LT_LT] = ACTIONS(5773),
    [anon_sym_GT_GT] = ACTIONS(5773),
    [anon_sym_EQ_EQ] = ACTIONS(5773),
    [anon_sym_BANG_EQ] = ACTIONS(5771),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5771),
    [anon_sym_LT_EQ_GT] = ACTIONS(5771),
    [anon_sym_EQ_TILDE] = ACTIONS(5771),
    [anon_sym_BANG_TILDE] = ACTIONS(5771),
    [anon_sym_LT_EQ] = ACTIONS(5773),
    [anon_sym_GT] = ACTIONS(5773),
    [anon_sym_GT_EQ] = ACTIONS(5771),
    [anon_sym_CARET] = ACTIONS(5773),
    [anon_sym_PLUS] = ACTIONS(5773),
    [anon_sym_SLASH] = ACTIONS(5773),
    [anon_sym_PERCENT] = ACTIONS(5773),
    [sym_comment] = ACTIONS(87),
  },
  [2550] = {
    [anon_sym_end] = ACTIONS(7898),
    [sym_comment] = ACTIONS(87),
  },
  [2551] = {
    [sym__statements] = STATE(4971),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_heredoc_body] = STATE(4972),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [sym__terminator] = STATE(4972),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__line_break] = ACTIONS(7900),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(7900),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(7902),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2552] = {
    [sym__statements] = STATE(4971),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_block_parameters] = STATE(4973),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(7902),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2553] = {
    [sym__line_break] = ACTIONS(4285),
    [sym__heredoc_body_start] = ACTIONS(4285),
    [sym__binary_minus] = ACTIONS(4285),
    [sym__binary_star] = ACTIONS(4285),
    [ts_builtin_sym_end] = ACTIONS(4285),
    [anon_sym___END__] = ACTIONS(4285),
    [anon_sym_LBRACE] = ACTIONS(4285),
    [anon_sym_RBRACE] = ACTIONS(4285),
    [anon_sym_RPAREN] = ACTIONS(4285),
    [anon_sym_DOT] = ACTIONS(4287),
    [anon_sym_COMMA] = ACTIONS(4285),
    [anon_sym_PIPE] = ACTIONS(4287),
    [anon_sym_SEMI] = ACTIONS(4285),
    [anon_sym_STAR_STAR] = ACTIONS(4287),
    [anon_sym_AMP] = ACTIONS(4287),
    [anon_sym_EQ] = ACTIONS(4287),
    [anon_sym_LT] = ACTIONS(4287),
    [anon_sym_end] = ACTIONS(4285),
    [anon_sym_if] = ACTIONS(4285),
    [anon_sym_unless] = ACTIONS(4285),
    [anon_sym_while] = ACTIONS(4285),
    [anon_sym_until] = ACTIONS(4285),
    [anon_sym_rescue] = ACTIONS(4285),
    [anon_sym_do] = ACTIONS(4285),
    [anon_sym_when] = ACTIONS(4285),
    [anon_sym_elsif] = ACTIONS(4285),
    [anon_sym_else] = ACTIONS(4285),
    [anon_sym_then] = ACTIONS(4285),
    [anon_sym_ensure] = ACTIONS(4285),
    [anon_sym_EQ_GT] = ACTIONS(4285),
    [anon_sym_LBRACK] = ACTIONS(4285),
    [anon_sym_COLON_COLON2] = ACTIONS(4285),
    [anon_sym_AMP_DOT] = ACTIONS(4285),
    [anon_sym_PLUS_EQ] = ACTIONS(4285),
    [anon_sym_DASH_EQ] = ACTIONS(4285),
    [anon_sym_STAR_EQ] = ACTIONS(4285),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4285),
    [anon_sym_SLASH_EQ] = ACTIONS(4285),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4285),
    [anon_sym_PIPE_EQ] = ACTIONS(4285),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4285),
    [anon_sym_AMP_EQ] = ACTIONS(4285),
    [anon_sym_PERCENT_EQ] = ACTIONS(4285),
    [anon_sym_GT_GT_EQ] = ACTIONS(4285),
    [anon_sym_LT_LT_EQ] = ACTIONS(4285),
    [anon_sym_CARET_EQ] = ACTIONS(4285),
    [anon_sym_QMARK] = ACTIONS(4285),
    [anon_sym_DOT_DOT] = ACTIONS(4287),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4285),
    [anon_sym_and] = ACTIONS(4285),
    [anon_sym_or] = ACTIONS(4285),
    [anon_sym_PIPE_PIPE] = ACTIONS(4287),
    [anon_sym_AMP_AMP] = ACTIONS(4287),
    [anon_sym_LT_LT] = ACTIONS(4287),
    [anon_sym_GT_GT] = ACTIONS(4287),
    [anon_sym_EQ_EQ] = ACTIONS(4287),
    [anon_sym_BANG_EQ] = ACTIONS(4285),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4285),
    [anon_sym_LT_EQ_GT] = ACTIONS(4285),
    [anon_sym_EQ_TILDE] = ACTIONS(4285),
    [anon_sym_BANG_TILDE] = ACTIONS(4285),
    [anon_sym_LT_EQ] = ACTIONS(4287),
    [anon_sym_GT] = ACTIONS(4287),
    [anon_sym_GT_EQ] = ACTIONS(4285),
    [anon_sym_CARET] = ACTIONS(4287),
    [anon_sym_PLUS] = ACTIONS(4287),
    [anon_sym_SLASH] = ACTIONS(4287),
    [anon_sym_PERCENT] = ACTIONS(4287),
    [sym_comment] = ACTIONS(87),
  },
  [2554] = {
    [anon_sym_RPAREN] = ACTIONS(7904),
    [sym_comment] = ACTIONS(87),
  },
  [2555] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(4975),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(428),
    [sym_scope_resolution] = STATE(422),
    [sym_call] = STATE(422),
    [sym_method_call] = STATE(428),
    [sym_assignment] = STATE(4975),
    [sym_operator_assignment] = STATE(4975),
    [sym_conditional] = STATE(4975),
    [sym_range] = STATE(4975),
    [sym_binary] = STATE(4975),
    [sym_unary] = STATE(4975),
    [sym_left_assignment_list] = STATE(427),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(428),
    [sym__variable] = STATE(422),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(428),
    [sym_false] = STATE(428),
    [sym_nil] = STATE(428),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(1503),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(781),
    [anon_sym_yield] = ACTIONS(783),
    [anon_sym_break] = ACTIONS(785),
    [anon_sym_next] = ACTIONS(787),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(2623),
    [anon_sym_defined_QMARK] = ACTIONS(801),
    [anon_sym_not] = ACTIONS(803),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_TILDE] = ACTIONS(807),
    [sym_constant] = ACTIONS(815),
    [sym_identifier] = ACTIONS(815),
    [sym_instance_variable] = ACTIONS(811),
    [sym_class_variable] = ACTIONS(811),
    [sym_global_variable] = ACTIONS(811),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(815),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(815),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2556] = {
    [sym__line_break] = ACTIONS(6155),
    [sym__heredoc_body_start] = ACTIONS(6155),
    [sym__binary_minus] = ACTIONS(6155),
    [sym__binary_star] = ACTIONS(6155),
    [ts_builtin_sym_end] = ACTIONS(6155),
    [anon_sym___END__] = ACTIONS(6155),
    [anon_sym_LBRACE] = ACTIONS(6155),
    [anon_sym_RBRACE] = ACTIONS(6155),
    [anon_sym_RPAREN] = ACTIONS(6155),
    [anon_sym_DOT] = ACTIONS(6157),
    [anon_sym_COMMA] = ACTIONS(6155),
    [anon_sym_PIPE] = ACTIONS(6157),
    [anon_sym_SEMI] = ACTIONS(6155),
    [anon_sym_STAR_STAR] = ACTIONS(6157),
    [anon_sym_AMP] = ACTIONS(6157),
    [anon_sym_EQ] = ACTIONS(6157),
    [anon_sym_LT] = ACTIONS(6157),
    [anon_sym_end] = ACTIONS(6155),
    [anon_sym_if] = ACTIONS(6155),
    [anon_sym_unless] = ACTIONS(6155),
    [anon_sym_while] = ACTIONS(6155),
    [anon_sym_until] = ACTIONS(6155),
    [anon_sym_rescue] = ACTIONS(6155),
    [anon_sym_do] = ACTIONS(6155),
    [anon_sym_when] = ACTIONS(6155),
    [anon_sym_elsif] = ACTIONS(6155),
    [anon_sym_else] = ACTIONS(6155),
    [anon_sym_then] = ACTIONS(6155),
    [anon_sym_ensure] = ACTIONS(6155),
    [anon_sym_EQ_GT] = ACTIONS(6155),
    [anon_sym_LBRACK] = ACTIONS(6155),
    [anon_sym_COLON_COLON2] = ACTIONS(6155),
    [anon_sym_AMP_DOT] = ACTIONS(6155),
    [anon_sym_PLUS_EQ] = ACTIONS(6155),
    [anon_sym_DASH_EQ] = ACTIONS(6155),
    [anon_sym_STAR_EQ] = ACTIONS(6155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6155),
    [anon_sym_SLASH_EQ] = ACTIONS(6155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6155),
    [anon_sym_PIPE_EQ] = ACTIONS(6155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6155),
    [anon_sym_AMP_EQ] = ACTIONS(6155),
    [anon_sym_PERCENT_EQ] = ACTIONS(6155),
    [anon_sym_GT_GT_EQ] = ACTIONS(6155),
    [anon_sym_LT_LT_EQ] = ACTIONS(6155),
    [anon_sym_CARET_EQ] = ACTIONS(6155),
    [anon_sym_QMARK] = ACTIONS(6155),
    [anon_sym_DOT_DOT] = ACTIONS(6157),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6155),
    [anon_sym_and] = ACTIONS(6155),
    [anon_sym_or] = ACTIONS(6155),
    [anon_sym_PIPE_PIPE] = ACTIONS(6157),
    [anon_sym_AMP_AMP] = ACTIONS(6157),
    [anon_sym_LT_LT] = ACTIONS(6157),
    [anon_sym_GT_GT] = ACTIONS(6157),
    [anon_sym_EQ_EQ] = ACTIONS(6157),
    [anon_sym_BANG_EQ] = ACTIONS(6155),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6155),
    [anon_sym_LT_EQ_GT] = ACTIONS(6155),
    [anon_sym_EQ_TILDE] = ACTIONS(6155),
    [anon_sym_BANG_TILDE] = ACTIONS(6155),
    [anon_sym_LT_EQ] = ACTIONS(6157),
    [anon_sym_GT] = ACTIONS(6157),
    [anon_sym_GT_EQ] = ACTIONS(6155),
    [anon_sym_CARET] = ACTIONS(6157),
    [anon_sym_PLUS] = ACTIONS(6157),
    [anon_sym_SLASH] = ACTIONS(6157),
    [anon_sym_PERCENT] = ACTIONS(6157),
    [sym_comment] = ACTIONS(87),
  },
  [2557] = {
    [sym_interpolation] = STATE(4977),
    [aux_sym_heredoc_body_repeat1] = STATE(4977),
    [sym__heredoc_content] = ACTIONS(7906),
    [sym_heredoc_end] = ACTIONS(7908),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(7906),
  },
  [2558] = {
    [sym_heredoc_body] = STATE(4978),
    [aux_sym_call_repeat1] = STATE(4978),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [ts_builtin_sym_end] = ACTIONS(4383),
    [anon_sym___END__] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [2559] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(937),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(428),
    [sym_scope_resolution] = STATE(422),
    [sym_call] = STATE(422),
    [sym_method_call] = STATE(428),
    [sym__argument] = STATE(4979),
    [sym_splat_argument] = STATE(4979),
    [sym_hash_splat_argument] = STATE(4979),
    [sym_block_argument] = STATE(4979),
    [sym_assignment] = STATE(937),
    [sym_operator_assignment] = STATE(937),
    [sym_conditional] = STATE(937),
    [sym_range] = STATE(937),
    [sym_binary] = STATE(937),
    [sym_unary] = STATE(937),
    [sym_left_assignment_list] = STATE(427),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(428),
    [sym__variable] = STATE(422),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(428),
    [sym_false] = STATE(428),
    [sym_nil] = STATE(428),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(942),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_heredoc_body] = STATE(4980),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(4979),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(1663),
    [sym__splat_star] = ACTIONS(1665),
    [sym__unary_minus] = ACTIONS(765),
    [sym__identifier_hash_key] = ACTIONS(1667),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(7910),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(781),
    [anon_sym_yield] = ACTIONS(783),
    [anon_sym_break] = ACTIONS(785),
    [anon_sym_next] = ACTIONS(787),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(2623),
    [anon_sym_defined_QMARK] = ACTIONS(801),
    [anon_sym_not] = ACTIONS(803),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_TILDE] = ACTIONS(807),
    [sym_constant] = ACTIONS(1675),
    [sym_identifier] = ACTIONS(1675),
    [sym_instance_variable] = ACTIONS(811),
    [sym_class_variable] = ACTIONS(811),
    [sym_global_variable] = ACTIONS(811),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(815),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(815),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2560] = {
    [sym_heredoc_body] = STATE(4981),
    [aux_sym_call_repeat1] = STATE(4981),
    [aux_sym_argument_list_repeat1] = STATE(4982),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [ts_builtin_sym_end] = ACTIONS(4383),
    [anon_sym___END__] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4375),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [2561] = {
    [sym__line_break] = ACTIONS(3235),
    [sym__heredoc_body_start] = ACTIONS(3235),
    [sym__binary_minus] = ACTIONS(3235),
    [sym__binary_star] = ACTIONS(3235),
    [ts_builtin_sym_end] = ACTIONS(3235),
    [anon_sym___END__] = ACTIONS(3235),
    [anon_sym_LBRACE] = ACTIONS(3235),
    [anon_sym_RBRACE] = ACTIONS(3235),
    [anon_sym_RPAREN] = ACTIONS(3235),
    [anon_sym_DOT] = ACTIONS(4997),
    [anon_sym_COMMA] = ACTIONS(3235),
    [anon_sym_PIPE] = ACTIONS(4997),
    [anon_sym_SEMI] = ACTIONS(3235),
    [anon_sym_STAR_STAR] = ACTIONS(3235),
    [anon_sym_AMP] = ACTIONS(4997),
    [anon_sym_LT] = ACTIONS(4997),
    [anon_sym_end] = ACTIONS(3235),
    [anon_sym_if] = ACTIONS(3235),
    [anon_sym_unless] = ACTIONS(3235),
    [anon_sym_while] = ACTIONS(3235),
    [anon_sym_until] = ACTIONS(3235),
    [anon_sym_rescue] = ACTIONS(3235),
    [anon_sym_do] = ACTIONS(3235),
    [anon_sym_when] = ACTIONS(3235),
    [anon_sym_elsif] = ACTIONS(3235),
    [anon_sym_else] = ACTIONS(3235),
    [anon_sym_then] = ACTIONS(3235),
    [anon_sym_ensure] = ACTIONS(3235),
    [anon_sym_EQ_GT] = ACTIONS(3235),
    [anon_sym_LBRACK] = ACTIONS(3235),
    [anon_sym_COLON_COLON2] = ACTIONS(3235),
    [anon_sym_AMP_DOT] = ACTIONS(3235),
    [anon_sym_QMARK] = ACTIONS(3235),
    [anon_sym_DOT_DOT] = ACTIONS(4997),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3235),
    [anon_sym_and] = ACTIONS(3235),
    [anon_sym_or] = ACTIONS(3235),
    [anon_sym_PIPE_PIPE] = ACTIONS(3235),
    [anon_sym_AMP_AMP] = ACTIONS(3235),
    [anon_sym_LT_LT] = ACTIONS(3235),
    [anon_sym_GT_GT] = ACTIONS(3235),
    [anon_sym_EQ_EQ] = ACTIONS(4997),
    [anon_sym_BANG_EQ] = ACTIONS(3235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3235),
    [anon_sym_LT_EQ_GT] = ACTIONS(3235),
    [anon_sym_EQ_TILDE] = ACTIONS(3235),
    [anon_sym_BANG_TILDE] = ACTIONS(3235),
    [anon_sym_LT_EQ] = ACTIONS(4997),
    [anon_sym_GT] = ACTIONS(4997),
    [anon_sym_GT_EQ] = ACTIONS(3235),
    [anon_sym_CARET] = ACTIONS(3235),
    [anon_sym_PLUS] = ACTIONS(3235),
    [anon_sym_SLASH] = ACTIONS(3235),
    [anon_sym_PERCENT] = ACTIONS(3235),
    [sym_comment] = ACTIONS(87),
  },
  [2562] = {
    [sym_interpolation] = STATE(1787),
    [aux_sym_heredoc_body_repeat1] = STATE(1787),
    [sym__heredoc_content] = ACTIONS(3237),
    [sym_heredoc_end] = ACTIONS(7912),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(3237),
  },
  [2563] = {
    [sym_heredoc_body] = STATE(2563),
    [aux_sym_call_repeat1] = STATE(2563),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(7916),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [ts_builtin_sym_end] = ACTIONS(7914),
    [anon_sym___END__] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [2564] = {
    [sym_interpolation] = STATE(4985),
    [aux_sym_heredoc_body_repeat1] = STATE(4985),
    [sym__heredoc_content] = ACTIONS(7921),
    [sym_heredoc_end] = ACTIONS(7923),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(7921),
  },
  [2565] = {
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [ts_builtin_sym_end] = ACTIONS(7925),
    [anon_sym___END__] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_RBRACE] = ACTIONS(7925),
    [anon_sym_RPAREN] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(7925),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7925),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_end] = ACTIONS(7925),
    [anon_sym_if] = ACTIONS(7925),
    [anon_sym_unless] = ACTIONS(7925),
    [anon_sym_while] = ACTIONS(7925),
    [anon_sym_until] = ACTIONS(7925),
    [anon_sym_rescue] = ACTIONS(7925),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_when] = ACTIONS(7925),
    [anon_sym_elsif] = ACTIONS(7925),
    [anon_sym_else] = ACTIONS(7925),
    [anon_sym_then] = ACTIONS(7925),
    [anon_sym_ensure] = ACTIONS(7925),
    [anon_sym_EQ_GT] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7925),
    [anon_sym_AMP_AMP] = ACTIONS(7925),
    [anon_sym_LT_LT] = ACTIONS(7925),
    [anon_sym_GT_GT] = ACTIONS(7925),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7925),
    [anon_sym_PLUS] = ACTIONS(7925),
    [anon_sym_SLASH] = ACTIONS(7925),
    [anon_sym_PERCENT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [2566] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(213),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym__argument] = STATE(4986),
    [sym_splat_argument] = STATE(4986),
    [sym_hash_splat_argument] = STATE(4986),
    [sym_block_argument] = STATE(4986),
    [sym_assignment] = STATE(213),
    [sym_operator_assignment] = STATE(213),
    [sym_conditional] = STATE(213),
    [sym_range] = STATE(213),
    [sym_binary] = STATE(213),
    [sym_unary] = STATE(213),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(221),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4986),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(369),
    [sym__splat_star] = ACTIONS(371),
    [sym__unary_minus] = ACTIONS(373),
    [sym__identifier_hash_key] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(4389),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(383),
    [anon_sym_yield] = ACTIONS(385),
    [anon_sym_break] = ACTIONS(387),
    [anon_sym_next] = ACTIONS(389),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1575),
    [anon_sym_defined_QMARK] = ACTIONS(395),
    [anon_sym_not] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_TILDE] = ACTIONS(401),
    [sym_constant] = ACTIONS(403),
    [sym_identifier] = ACTIONS(403),
    [sym_instance_variable] = ACTIONS(405),
    [sym_class_variable] = ACTIONS(405),
    [sym_global_variable] = ACTIONS(405),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(407),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(407),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2567] = {
    [sym_heredoc_body] = STATE(2563),
    [aux_sym_call_repeat1] = STATE(2563),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [ts_builtin_sym_end] = ACTIONS(7929),
    [anon_sym___END__] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [2568] = {
    [aux_sym_argument_list_repeat1] = STATE(2568),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [ts_builtin_sym_end] = ACTIONS(7925),
    [anon_sym___END__] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(7933),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7925),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_if] = ACTIONS(7925),
    [anon_sym_unless] = ACTIONS(7925),
    [anon_sym_while] = ACTIONS(7925),
    [anon_sym_until] = ACTIONS(7925),
    [anon_sym_rescue] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7925),
    [anon_sym_AMP_AMP] = ACTIONS(7925),
    [anon_sym_LT_LT] = ACTIONS(7925),
    [anon_sym_GT_GT] = ACTIONS(7925),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7925),
    [anon_sym_PLUS] = ACTIONS(7925),
    [anon_sym_SLASH] = ACTIONS(7925),
    [anon_sym_PERCENT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [2569] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(1627),
    [sym__binary_star] = ACTIONS(1629),
    [ts_builtin_sym_end] = ACTIONS(5115),
    [anon_sym___END__] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(1633),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(1629),
    [anon_sym_AMP] = ACTIONS(1635),
    [anon_sym_LT] = ACTIONS(1637),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_EQ_GT] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(1639),
    [anon_sym_DOT_DOT] = ACTIONS(1641),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1643),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(1645),
    [anon_sym_AMP_AMP] = ACTIONS(1645),
    [anon_sym_LT_LT] = ACTIONS(1647),
    [anon_sym_GT_GT] = ACTIONS(1647),
    [anon_sym_EQ_EQ] = ACTIONS(1649),
    [anon_sym_BANG_EQ] = ACTIONS(1645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1645),
    [anon_sym_LT_EQ_GT] = ACTIONS(1645),
    [anon_sym_EQ_TILDE] = ACTIONS(1645),
    [anon_sym_BANG_TILDE] = ACTIONS(1645),
    [anon_sym_LT_EQ] = ACTIONS(1637),
    [anon_sym_GT] = ACTIONS(1637),
    [anon_sym_GT_EQ] = ACTIONS(1651),
    [anon_sym_CARET] = ACTIONS(1653),
    [anon_sym_PLUS] = ACTIONS(1627),
    [anon_sym_SLASH] = ACTIONS(1629),
    [anon_sym_PERCENT] = ACTIONS(1629),
    [sym_comment] = ACTIONS(87),
  },
  [2570] = {
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [ts_builtin_sym_end] = ACTIONS(6191),
    [anon_sym___END__] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_RBRACE] = ACTIONS(6191),
    [anon_sym_RPAREN] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_end] = ACTIONS(6191),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_when] = ACTIONS(6191),
    [anon_sym_elsif] = ACTIONS(6191),
    [anon_sym_else] = ACTIONS(6191),
    [anon_sym_then] = ACTIONS(6191),
    [anon_sym_ensure] = ACTIONS(6191),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [2571] = {
    [aux_sym_exceptions_repeat1] = STATE(4988),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [ts_builtin_sym_end] = ACTIONS(6191),
    [anon_sym___END__] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [2572] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(1627),
    [sym__binary_star] = ACTIONS(1629),
    [ts_builtin_sym_end] = ACTIONS(6210),
    [anon_sym___END__] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(1633),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(1629),
    [anon_sym_AMP] = ACTIONS(1635),
    [anon_sym_LT] = ACTIONS(1637),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_EQ_GT] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(1639),
    [anon_sym_DOT_DOT] = ACTIONS(1641),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1643),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(1645),
    [anon_sym_AMP_AMP] = ACTIONS(1645),
    [anon_sym_LT_LT] = ACTIONS(1647),
    [anon_sym_GT_GT] = ACTIONS(1647),
    [anon_sym_EQ_EQ] = ACTIONS(1649),
    [anon_sym_BANG_EQ] = ACTIONS(1645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1645),
    [anon_sym_LT_EQ_GT] = ACTIONS(1645),
    [anon_sym_EQ_TILDE] = ACTIONS(1645),
    [anon_sym_BANG_TILDE] = ACTIONS(1645),
    [anon_sym_LT_EQ] = ACTIONS(1637),
    [anon_sym_GT] = ACTIONS(1637),
    [anon_sym_GT_EQ] = ACTIONS(1651),
    [anon_sym_CARET] = ACTIONS(1653),
    [anon_sym_PLUS] = ACTIONS(1627),
    [anon_sym_SLASH] = ACTIONS(1629),
    [anon_sym_PERCENT] = ACTIONS(1629),
    [sym_comment] = ACTIONS(87),
  },
  [2573] = {
    [sym_string] = STATE(2573),
    [aux_sym_chained_string_repeat1] = STATE(2573),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(6214),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [ts_builtin_sym_end] = ACTIONS(6212),
    [anon_sym___END__] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_EQ_GT] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [2574] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(4989),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2583),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2583),
    [sym_assignment] = STATE(4989),
    [sym_operator_assignment] = STATE(4989),
    [sym_conditional] = STATE(4989),
    [sym_range] = STATE(4989),
    [sym_binary] = STATE(4989),
    [sym_unary] = STATE(4989),
    [sym_left_assignment_list] = STATE(2582),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2583),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2583),
    [sym_false] = STATE(2583),
    [sym_nil] = STATE(2583),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2584),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4391),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4393),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_break] = ACTIONS(4397),
    [anon_sym_next] = ACTIONS(4399),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4401),
    [anon_sym_defined_QMARK] = ACTIONS(4403),
    [anon_sym_not] = ACTIONS(4405),
    [anon_sym_BANG] = ACTIONS(4407),
    [anon_sym_TILDE] = ACTIONS(4407),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2575] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(963),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(4990),
    [sym__argument] = STATE(4991),
    [sym_splat_argument] = STATE(4991),
    [sym_hash_splat_argument] = STATE(4991),
    [sym_block_argument] = STATE(4991),
    [sym_assignment] = STATE(963),
    [sym_operator_assignment] = STATE(963),
    [sym_conditional] = STATE(963),
    [sym_range] = STATE(963),
    [sym_binary] = STATE(963),
    [sym_unary] = STATE(963),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(969),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4991),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(1709),
    [sym__splat_star] = ACTIONS(1711),
    [sym__unary_minus] = ACTIONS(1713),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(1715),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1717),
    [anon_sym_yield] = ACTIONS(1719),
    [anon_sym_break] = ACTIONS(1721),
    [anon_sym_next] = ACTIONS(1723),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(377),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(1725),
    [anon_sym_not] = ACTIONS(1727),
    [anon_sym_BANG] = ACTIONS(1729),
    [anon_sym_TILDE] = ACTIONS(1731),
    [sym_constant] = ACTIONS(1733),
    [sym_identifier] = ACTIONS(1733),
    [sym_instance_variable] = ACTIONS(1735),
    [sym_class_variable] = ACTIONS(1735),
    [sym_global_variable] = ACTIONS(1735),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1737),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1737),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2576] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(963),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(4990),
    [sym__argument] = STATE(4991),
    [sym_splat_argument] = STATE(4991),
    [sym_hash_splat_argument] = STATE(4991),
    [sym_block_argument] = STATE(4991),
    [sym_assignment] = STATE(963),
    [sym_operator_assignment] = STATE(963),
    [sym_conditional] = STATE(963),
    [sym_range] = STATE(963),
    [sym_binary] = STATE(963),
    [sym_unary] = STATE(963),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(969),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4991),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(1709),
    [sym__splat_star] = ACTIONS(1711),
    [sym__unary_minus] = ACTIONS(1713),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(1715),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1717),
    [anon_sym_yield] = ACTIONS(1719),
    [anon_sym_break] = ACTIONS(1721),
    [anon_sym_next] = ACTIONS(1723),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(419),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(1725),
    [anon_sym_not] = ACTIONS(1727),
    [anon_sym_BANG] = ACTIONS(1729),
    [anon_sym_TILDE] = ACTIONS(1731),
    [sym_constant] = ACTIONS(1733),
    [sym_identifier] = ACTIONS(1733),
    [sym_instance_variable] = ACTIONS(1735),
    [sym_class_variable] = ACTIONS(1735),
    [sym_global_variable] = ACTIONS(1735),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1737),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1737),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2577] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(963),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(4990),
    [sym__argument] = STATE(4991),
    [sym_splat_argument] = STATE(4991),
    [sym_hash_splat_argument] = STATE(4991),
    [sym_block_argument] = STATE(4991),
    [sym_assignment] = STATE(963),
    [sym_operator_assignment] = STATE(963),
    [sym_conditional] = STATE(963),
    [sym_range] = STATE(963),
    [sym_binary] = STATE(963),
    [sym_unary] = STATE(963),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(969),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4991),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(1709),
    [sym__splat_star] = ACTIONS(1711),
    [sym__unary_minus] = ACTIONS(1713),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(1715),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1717),
    [anon_sym_yield] = ACTIONS(1719),
    [anon_sym_break] = ACTIONS(1721),
    [anon_sym_next] = ACTIONS(1723),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(423),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(1725),
    [anon_sym_not] = ACTIONS(1727),
    [anon_sym_BANG] = ACTIONS(1729),
    [anon_sym_TILDE] = ACTIONS(1731),
    [sym_constant] = ACTIONS(1733),
    [sym_identifier] = ACTIONS(1733),
    [sym_instance_variable] = ACTIONS(1735),
    [sym_class_variable] = ACTIONS(1735),
    [sym_global_variable] = ACTIONS(1735),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1737),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1737),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2578] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(963),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(4990),
    [sym__argument] = STATE(4991),
    [sym_splat_argument] = STATE(4991),
    [sym_hash_splat_argument] = STATE(4991),
    [sym_block_argument] = STATE(4991),
    [sym_assignment] = STATE(963),
    [sym_operator_assignment] = STATE(963),
    [sym_conditional] = STATE(963),
    [sym_range] = STATE(963),
    [sym_binary] = STATE(963),
    [sym_unary] = STATE(963),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(969),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4991),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(1709),
    [sym__splat_star] = ACTIONS(1711),
    [sym__unary_minus] = ACTIONS(1713),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(1715),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1717),
    [anon_sym_yield] = ACTIONS(1719),
    [anon_sym_break] = ACTIONS(1721),
    [anon_sym_next] = ACTIONS(1723),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(427),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(1725),
    [anon_sym_not] = ACTIONS(1727),
    [anon_sym_BANG] = ACTIONS(1729),
    [anon_sym_TILDE] = ACTIONS(1731),
    [sym_constant] = ACTIONS(1733),
    [sym_identifier] = ACTIONS(1733),
    [sym_instance_variable] = ACTIONS(1735),
    [sym_class_variable] = ACTIONS(1735),
    [sym_global_variable] = ACTIONS(1735),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1737),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1737),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2579] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(4992),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2583),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2583),
    [sym_assignment] = STATE(4992),
    [sym_operator_assignment] = STATE(4992),
    [sym_conditional] = STATE(4992),
    [sym_range] = STATE(4992),
    [sym_binary] = STATE(4992),
    [sym_unary] = STATE(4992),
    [sym_left_assignment_list] = STATE(2582),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2583),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2583),
    [sym_false] = STATE(2583),
    [sym_nil] = STATE(2583),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2584),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4391),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4393),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_break] = ACTIONS(4397),
    [anon_sym_next] = ACTIONS(4399),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4401),
    [anon_sym_defined_QMARK] = ACTIONS(4403),
    [anon_sym_not] = ACTIONS(4405),
    [anon_sym_BANG] = ACTIONS(4407),
    [anon_sym_TILDE] = ACTIONS(4407),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2580] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2583),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2583),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(2582),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2583),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2583),
    [sym_false] = STATE(2583),
    [sym_nil] = STATE(2583),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2584),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4391),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4393),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_break] = ACTIONS(4397),
    [anon_sym_next] = ACTIONS(4399),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4401),
    [anon_sym_defined_QMARK] = ACTIONS(4403),
    [anon_sym_not] = ACTIONS(4405),
    [anon_sym_BANG] = ACTIONS(4407),
    [anon_sym_TILDE] = ACTIONS(4407),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2581] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(7940),
    [sym__binary_star] = ACTIONS(7942),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(7944),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(7942),
    [anon_sym_AMP] = ACTIONS(7946),
    [anon_sym_LT] = ACTIONS(7948),
    [anon_sym_if] = ACTIONS(4211),
    [anon_sym_unless] = ACTIONS(4211),
    [anon_sym_while] = ACTIONS(4211),
    [anon_sym_until] = ACTIONS(4211),
    [anon_sym_rescue] = ACTIONS(4211),
    [anon_sym_then] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(7950),
    [anon_sym_DOT_DOT] = ACTIONS(7952),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7954),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(7956),
    [anon_sym_AMP_AMP] = ACTIONS(7956),
    [anon_sym_LT_LT] = ACTIONS(7958),
    [anon_sym_GT_GT] = ACTIONS(7958),
    [anon_sym_EQ_EQ] = ACTIONS(7960),
    [anon_sym_BANG_EQ] = ACTIONS(7956),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7956),
    [anon_sym_LT_EQ_GT] = ACTIONS(7956),
    [anon_sym_EQ_TILDE] = ACTIONS(7956),
    [anon_sym_BANG_TILDE] = ACTIONS(7956),
    [anon_sym_LT_EQ] = ACTIONS(7948),
    [anon_sym_GT] = ACTIONS(7948),
    [anon_sym_GT_EQ] = ACTIONS(7962),
    [anon_sym_CARET] = ACTIONS(7964),
    [anon_sym_PLUS] = ACTIONS(7940),
    [anon_sym_SLASH] = ACTIONS(7942),
    [anon_sym_PERCENT] = ACTIONS(7942),
    [sym_comment] = ACTIONS(87),
  },
  [2582] = {
    [anon_sym_EQ] = ACTIONS(7966),
    [sym_comment] = ACTIONS(87),
  },
  [2583] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(7968),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(7970),
    [anon_sym_DASH_EQ] = ACTIONS(7970),
    [anon_sym_STAR_EQ] = ACTIONS(7970),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7970),
    [anon_sym_SLASH_EQ] = ACTIONS(7970),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7970),
    [anon_sym_PIPE_EQ] = ACTIONS(7970),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7970),
    [anon_sym_AMP_EQ] = ACTIONS(7970),
    [anon_sym_PERCENT_EQ] = ACTIONS(7970),
    [anon_sym_GT_GT_EQ] = ACTIONS(7970),
    [anon_sym_LT_LT_EQ] = ACTIONS(7970),
    [anon_sym_CARET_EQ] = ACTIONS(7970),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2584] = {
    [sym_string] = STATE(5005),
    [aux_sym_chained_string_repeat1] = STATE(5005),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2585] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(7940),
    [sym__binary_star] = ACTIONS(7942),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(7944),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(7942),
    [anon_sym_AMP] = ACTIONS(7946),
    [anon_sym_LT] = ACTIONS(7948),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_then] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(7950),
    [anon_sym_DOT_DOT] = ACTIONS(7952),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7954),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(7956),
    [anon_sym_AMP_AMP] = ACTIONS(7956),
    [anon_sym_LT_LT] = ACTIONS(7958),
    [anon_sym_GT_GT] = ACTIONS(7958),
    [anon_sym_EQ_EQ] = ACTIONS(7960),
    [anon_sym_BANG_EQ] = ACTIONS(7956),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7956),
    [anon_sym_LT_EQ_GT] = ACTIONS(7956),
    [anon_sym_EQ_TILDE] = ACTIONS(7956),
    [anon_sym_BANG_TILDE] = ACTIONS(7956),
    [anon_sym_LT_EQ] = ACTIONS(7948),
    [anon_sym_GT] = ACTIONS(7948),
    [anon_sym_GT_EQ] = ACTIONS(7962),
    [anon_sym_CARET] = ACTIONS(7964),
    [anon_sym_PLUS] = ACTIONS(7940),
    [anon_sym_SLASH] = ACTIONS(7942),
    [anon_sym_PERCENT] = ACTIONS(7942),
    [sym_comment] = ACTIONS(87),
  },
  [2586] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(4425),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [2587] = {
    [sym_string] = STATE(2625),
    [aux_sym_chained_string_repeat1] = STATE(2625),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2588] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5006),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2583),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2583),
    [sym_assignment] = STATE(5006),
    [sym_operator_assignment] = STATE(5006),
    [sym_conditional] = STATE(5006),
    [sym_range] = STATE(5006),
    [sym_binary] = STATE(5006),
    [sym_unary] = STATE(5006),
    [sym_left_assignment_list] = STATE(2582),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2583),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2583),
    [sym_false] = STATE(2583),
    [sym_nil] = STATE(2583),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2584),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4391),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4393),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_break] = ACTIONS(4397),
    [anon_sym_next] = ACTIONS(4399),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4401),
    [anon_sym_defined_QMARK] = ACTIONS(4403),
    [anon_sym_not] = ACTIONS(4405),
    [anon_sym_BANG] = ACTIONS(4407),
    [anon_sym_TILDE] = ACTIONS(4407),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2589] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(7940),
    [sym__binary_star] = ACTIONS(7942),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(7944),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(7942),
    [anon_sym_AMP] = ACTIONS(7946),
    [anon_sym_LT] = ACTIONS(7948),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_unless] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_until] = ACTIONS(3281),
    [anon_sym_rescue] = ACTIONS(3281),
    [anon_sym_then] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(7950),
    [anon_sym_DOT_DOT] = ACTIONS(7952),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7954),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(7956),
    [anon_sym_AMP_AMP] = ACTIONS(7956),
    [anon_sym_LT_LT] = ACTIONS(7958),
    [anon_sym_GT_GT] = ACTIONS(7958),
    [anon_sym_EQ_EQ] = ACTIONS(7960),
    [anon_sym_BANG_EQ] = ACTIONS(7956),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7956),
    [anon_sym_LT_EQ_GT] = ACTIONS(7956),
    [anon_sym_EQ_TILDE] = ACTIONS(7956),
    [anon_sym_BANG_TILDE] = ACTIONS(7956),
    [anon_sym_LT_EQ] = ACTIONS(7948),
    [anon_sym_GT] = ACTIONS(7948),
    [anon_sym_GT_EQ] = ACTIONS(7962),
    [anon_sym_CARET] = ACTIONS(7964),
    [anon_sym_PLUS] = ACTIONS(7940),
    [anon_sym_SLASH] = ACTIONS(7942),
    [anon_sym_PERCENT] = ACTIONS(7942),
    [sym_comment] = ACTIONS(87),
  },
  [2590] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5007),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_assignment] = STATE(5007),
    [sym_operator_assignment] = STATE(5007),
    [sym_conditional] = STATE(5007),
    [sym_range] = STATE(5007),
    [sym_binary] = STATE(5007),
    [sym_unary] = STATE(5007),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2587),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1713),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1717),
    [anon_sym_yield] = ACTIONS(1719),
    [anon_sym_break] = ACTIONS(1721),
    [anon_sym_next] = ACTIONS(1723),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4409),
    [anon_sym_defined_QMARK] = ACTIONS(1725),
    [anon_sym_not] = ACTIONS(1727),
    [anon_sym_BANG] = ACTIONS(1731),
    [anon_sym_TILDE] = ACTIONS(1731),
    [sym_constant] = ACTIONS(1737),
    [sym_identifier] = ACTIONS(1737),
    [sym_instance_variable] = ACTIONS(1735),
    [sym_class_variable] = ACTIONS(1735),
    [sym_global_variable] = ACTIONS(1735),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1737),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1737),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2591] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5008),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_assignment] = STATE(5008),
    [sym_operator_assignment] = STATE(5008),
    [sym_conditional] = STATE(5008),
    [sym_range] = STATE(5008),
    [sym_binary] = STATE(5008),
    [sym_unary] = STATE(5008),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2587),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1713),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1717),
    [anon_sym_yield] = ACTIONS(1719),
    [anon_sym_break] = ACTIONS(1721),
    [anon_sym_next] = ACTIONS(1723),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4409),
    [anon_sym_defined_QMARK] = ACTIONS(1725),
    [anon_sym_not] = ACTIONS(1727),
    [anon_sym_BANG] = ACTIONS(1731),
    [anon_sym_TILDE] = ACTIONS(1731),
    [sym_constant] = ACTIONS(1737),
    [sym_identifier] = ACTIONS(1737),
    [sym_instance_variable] = ACTIONS(1735),
    [sym_class_variable] = ACTIONS(1735),
    [sym_global_variable] = ACTIONS(1735),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1737),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1737),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2592] = {
    [anon_sym_COLON] = ACTIONS(7972),
    [sym_comment] = ACTIONS(87),
  },
  [2593] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5010),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_assignment] = STATE(5010),
    [sym_operator_assignment] = STATE(5010),
    [sym_conditional] = STATE(5010),
    [sym_range] = STATE(5010),
    [sym_binary] = STATE(5010),
    [sym_unary] = STATE(5010),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2587),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1713),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1717),
    [anon_sym_yield] = ACTIONS(1719),
    [anon_sym_break] = ACTIONS(1721),
    [anon_sym_next] = ACTIONS(1723),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4409),
    [anon_sym_defined_QMARK] = ACTIONS(1725),
    [anon_sym_not] = ACTIONS(1727),
    [anon_sym_BANG] = ACTIONS(1731),
    [anon_sym_TILDE] = ACTIONS(1731),
    [sym_constant] = ACTIONS(1737),
    [sym_identifier] = ACTIONS(1737),
    [sym_instance_variable] = ACTIONS(1735),
    [sym_class_variable] = ACTIONS(1735),
    [sym_global_variable] = ACTIONS(1735),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1737),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1737),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2594] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(7974),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_then] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [2595] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(4423),
    [sym__binary_star] = ACTIONS(4425),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(4427),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(4425),
    [anon_sym_AMP] = ACTIONS(4429),
    [anon_sym_LT] = ACTIONS(4431),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_unless] = ACTIONS(1625),
    [anon_sym_while] = ACTIONS(1625),
    [anon_sym_until] = ACTIONS(1625),
    [anon_sym_rescue] = ACTIONS(1625),
    [anon_sym_then] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(1625),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(4433),
    [anon_sym_DOT_DOT] = ACTIONS(4435),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4437),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(4439),
    [anon_sym_AMP_AMP] = ACTIONS(4439),
    [anon_sym_LT_LT] = ACTIONS(4441),
    [anon_sym_GT_GT] = ACTIONS(4441),
    [anon_sym_EQ_EQ] = ACTIONS(4443),
    [anon_sym_BANG_EQ] = ACTIONS(4439),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4439),
    [anon_sym_LT_EQ_GT] = ACTIONS(4439),
    [anon_sym_EQ_TILDE] = ACTIONS(4439),
    [anon_sym_BANG_TILDE] = ACTIONS(4439),
    [anon_sym_LT_EQ] = ACTIONS(4431),
    [anon_sym_GT] = ACTIONS(4431),
    [anon_sym_GT_EQ] = ACTIONS(4445),
    [anon_sym_CARET] = ACTIONS(4447),
    [anon_sym_PLUS] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(4425),
    [anon_sym_PERCENT] = ACTIONS(4425),
    [sym_comment] = ACTIONS(87),
  },
  [2596] = {
    [sym_heredoc_body] = STATE(5012),
    [aux_sym_call_repeat1] = STATE(5012),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_then] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [2597] = {
    [sym_heredoc_body] = STATE(5012),
    [aux_sym_call_repeat1] = STATE(5012),
    [aux_sym_argument_list_repeat1] = STATE(5014),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(7976),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_then] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [2598] = {
    [sym_string] = STATE(2625),
    [aux_sym_chained_string_repeat1] = STATE(2625),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(7978),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2599] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(4423),
    [sym__binary_star] = ACTIONS(4425),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(4427),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(4425),
    [anon_sym_AMP] = ACTIONS(4429),
    [anon_sym_LT] = ACTIONS(4431),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(4433),
    [anon_sym_DOT_DOT] = ACTIONS(4435),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4437),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(4439),
    [anon_sym_AMP_AMP] = ACTIONS(4439),
    [anon_sym_LT_LT] = ACTIONS(4441),
    [anon_sym_GT_GT] = ACTIONS(4441),
    [anon_sym_EQ_EQ] = ACTIONS(4443),
    [anon_sym_BANG_EQ] = ACTIONS(4439),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4439),
    [anon_sym_LT_EQ_GT] = ACTIONS(4439),
    [anon_sym_EQ_TILDE] = ACTIONS(4439),
    [anon_sym_BANG_TILDE] = ACTIONS(4439),
    [anon_sym_LT_EQ] = ACTIONS(4431),
    [anon_sym_GT] = ACTIONS(4431),
    [anon_sym_GT_EQ] = ACTIONS(4445),
    [anon_sym_CARET] = ACTIONS(4447),
    [anon_sym_PLUS] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(4425),
    [anon_sym_PERCENT] = ACTIONS(4425),
    [sym_comment] = ACTIONS(87),
  },
  [2600] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5015),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2583),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2583),
    [sym_assignment] = STATE(5015),
    [sym_operator_assignment] = STATE(5015),
    [sym_conditional] = STATE(5015),
    [sym_range] = STATE(5015),
    [sym_binary] = STATE(5015),
    [sym_unary] = STATE(5015),
    [sym_left_assignment_list] = STATE(2582),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2583),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2583),
    [sym_false] = STATE(2583),
    [sym_nil] = STATE(2583),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2584),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4391),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4393),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_break] = ACTIONS(4397),
    [anon_sym_next] = ACTIONS(4399),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4401),
    [anon_sym_defined_QMARK] = ACTIONS(4403),
    [anon_sym_not] = ACTIONS(4405),
    [anon_sym_BANG] = ACTIONS(4407),
    [anon_sym_TILDE] = ACTIONS(4407),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2601] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5016),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_assignment] = STATE(5016),
    [sym_operator_assignment] = STATE(5016),
    [sym_conditional] = STATE(5016),
    [sym_range] = STATE(5016),
    [sym_binary] = STATE(5016),
    [sym_unary] = STATE(5016),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2587),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1713),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1717),
    [anon_sym_yield] = ACTIONS(1719),
    [anon_sym_break] = ACTIONS(1721),
    [anon_sym_next] = ACTIONS(1723),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4409),
    [anon_sym_defined_QMARK] = ACTIONS(1725),
    [anon_sym_not] = ACTIONS(1727),
    [anon_sym_BANG] = ACTIONS(1731),
    [anon_sym_TILDE] = ACTIONS(1731),
    [sym_constant] = ACTIONS(1737),
    [sym_identifier] = ACTIONS(1737),
    [sym_instance_variable] = ACTIONS(1735),
    [sym_class_variable] = ACTIONS(1735),
    [sym_global_variable] = ACTIONS(1735),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1737),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1737),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2602] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5017),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_assignment] = STATE(5017),
    [sym_operator_assignment] = STATE(5017),
    [sym_conditional] = STATE(5017),
    [sym_range] = STATE(5017),
    [sym_binary] = STATE(5017),
    [sym_unary] = STATE(5017),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2587),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1713),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1717),
    [anon_sym_yield] = ACTIONS(1719),
    [anon_sym_break] = ACTIONS(1721),
    [anon_sym_next] = ACTIONS(1723),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4409),
    [anon_sym_defined_QMARK] = ACTIONS(1725),
    [anon_sym_not] = ACTIONS(1727),
    [anon_sym_BANG] = ACTIONS(1731),
    [anon_sym_TILDE] = ACTIONS(1731),
    [sym_constant] = ACTIONS(1737),
    [sym_identifier] = ACTIONS(1737),
    [sym_instance_variable] = ACTIONS(1735),
    [sym_class_variable] = ACTIONS(1735),
    [sym_global_variable] = ACTIONS(1735),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1737),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1737),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2603] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5018),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_assignment] = STATE(5018),
    [sym_operator_assignment] = STATE(5018),
    [sym_conditional] = STATE(5018),
    [sym_range] = STATE(5018),
    [sym_binary] = STATE(5018),
    [sym_unary] = STATE(5018),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2587),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1713),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1717),
    [anon_sym_yield] = ACTIONS(1719),
    [anon_sym_break] = ACTIONS(1721),
    [anon_sym_next] = ACTIONS(1723),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4409),
    [anon_sym_defined_QMARK] = ACTIONS(1725),
    [anon_sym_not] = ACTIONS(1727),
    [anon_sym_BANG] = ACTIONS(1731),
    [anon_sym_TILDE] = ACTIONS(1731),
    [sym_constant] = ACTIONS(1737),
    [sym_identifier] = ACTIONS(1737),
    [sym_instance_variable] = ACTIONS(1735),
    [sym_class_variable] = ACTIONS(1735),
    [sym_global_variable] = ACTIONS(1735),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1737),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1737),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2604] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5019),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_assignment] = STATE(5019),
    [sym_operator_assignment] = STATE(5019),
    [sym_conditional] = STATE(5019),
    [sym_range] = STATE(5019),
    [sym_binary] = STATE(5019),
    [sym_unary] = STATE(5019),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2587),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1713),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1717),
    [anon_sym_yield] = ACTIONS(1719),
    [anon_sym_break] = ACTIONS(1721),
    [anon_sym_next] = ACTIONS(1723),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4409),
    [anon_sym_defined_QMARK] = ACTIONS(1725),
    [anon_sym_not] = ACTIONS(1727),
    [anon_sym_BANG] = ACTIONS(1731),
    [anon_sym_TILDE] = ACTIONS(1731),
    [sym_constant] = ACTIONS(1737),
    [sym_identifier] = ACTIONS(1737),
    [sym_instance_variable] = ACTIONS(1735),
    [sym_class_variable] = ACTIONS(1735),
    [sym_global_variable] = ACTIONS(1735),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1737),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1737),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2605] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5020),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_assignment] = STATE(5020),
    [sym_operator_assignment] = STATE(5020),
    [sym_conditional] = STATE(5020),
    [sym_range] = STATE(5020),
    [sym_binary] = STATE(5020),
    [sym_unary] = STATE(5020),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2587),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1713),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1717),
    [anon_sym_yield] = ACTIONS(1719),
    [anon_sym_break] = ACTIONS(1721),
    [anon_sym_next] = ACTIONS(1723),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4409),
    [anon_sym_defined_QMARK] = ACTIONS(1725),
    [anon_sym_not] = ACTIONS(1727),
    [anon_sym_BANG] = ACTIONS(1731),
    [anon_sym_TILDE] = ACTIONS(1731),
    [sym_constant] = ACTIONS(1737),
    [sym_identifier] = ACTIONS(1737),
    [sym_instance_variable] = ACTIONS(1735),
    [sym_class_variable] = ACTIONS(1735),
    [sym_global_variable] = ACTIONS(1735),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1737),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1737),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2606] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(5021),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(5021),
    [sym_operator_assignment] = STATE(5021),
    [sym_conditional] = STATE(5021),
    [sym_range] = STATE(5021),
    [sym_binary] = STATE(5021),
    [sym_unary] = STATE(5021),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2607] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5022),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_assignment] = STATE(5022),
    [sym_operator_assignment] = STATE(5022),
    [sym_conditional] = STATE(5022),
    [sym_range] = STATE(5022),
    [sym_binary] = STATE(5022),
    [sym_unary] = STATE(5022),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2587),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1713),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1717),
    [anon_sym_yield] = ACTIONS(1719),
    [anon_sym_break] = ACTIONS(1721),
    [anon_sym_next] = ACTIONS(1723),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4409),
    [anon_sym_defined_QMARK] = ACTIONS(1725),
    [anon_sym_not] = ACTIONS(1727),
    [anon_sym_BANG] = ACTIONS(1731),
    [anon_sym_TILDE] = ACTIONS(1731),
    [sym_constant] = ACTIONS(1737),
    [sym_identifier] = ACTIONS(1737),
    [sym_instance_variable] = ACTIONS(1735),
    [sym_class_variable] = ACTIONS(1735),
    [sym_global_variable] = ACTIONS(1735),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1737),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1737),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2608] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5023),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_assignment] = STATE(5023),
    [sym_operator_assignment] = STATE(5023),
    [sym_conditional] = STATE(5023),
    [sym_range] = STATE(5023),
    [sym_binary] = STATE(5023),
    [sym_unary] = STATE(5023),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2587),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1713),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1717),
    [anon_sym_yield] = ACTIONS(1719),
    [anon_sym_break] = ACTIONS(1721),
    [anon_sym_next] = ACTIONS(1723),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4409),
    [anon_sym_defined_QMARK] = ACTIONS(1725),
    [anon_sym_not] = ACTIONS(1727),
    [anon_sym_BANG] = ACTIONS(1731),
    [anon_sym_TILDE] = ACTIONS(1731),
    [sym_constant] = ACTIONS(1737),
    [sym_identifier] = ACTIONS(1737),
    [sym_instance_variable] = ACTIONS(1735),
    [sym_class_variable] = ACTIONS(1735),
    [sym_global_variable] = ACTIONS(1735),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1737),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1737),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2609] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5024),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_assignment] = STATE(5024),
    [sym_operator_assignment] = STATE(5024),
    [sym_conditional] = STATE(5024),
    [sym_range] = STATE(5024),
    [sym_binary] = STATE(5024),
    [sym_unary] = STATE(5024),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2587),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1713),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1717),
    [anon_sym_yield] = ACTIONS(1719),
    [anon_sym_break] = ACTIONS(1721),
    [anon_sym_next] = ACTIONS(1723),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4409),
    [anon_sym_defined_QMARK] = ACTIONS(1725),
    [anon_sym_not] = ACTIONS(1727),
    [anon_sym_BANG] = ACTIONS(1731),
    [anon_sym_TILDE] = ACTIONS(1731),
    [sym_constant] = ACTIONS(1737),
    [sym_identifier] = ACTIONS(1737),
    [sym_instance_variable] = ACTIONS(1735),
    [sym_class_variable] = ACTIONS(1735),
    [sym_global_variable] = ACTIONS(1735),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1737),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1737),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2610] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5025),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_assignment] = STATE(5025),
    [sym_operator_assignment] = STATE(5025),
    [sym_conditional] = STATE(5025),
    [sym_range] = STATE(5025),
    [sym_binary] = STATE(5025),
    [sym_unary] = STATE(5025),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2587),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1713),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1717),
    [anon_sym_yield] = ACTIONS(1719),
    [anon_sym_break] = ACTIONS(1721),
    [anon_sym_next] = ACTIONS(1723),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4409),
    [anon_sym_defined_QMARK] = ACTIONS(1725),
    [anon_sym_not] = ACTIONS(1727),
    [anon_sym_BANG] = ACTIONS(1731),
    [anon_sym_TILDE] = ACTIONS(1731),
    [sym_constant] = ACTIONS(1737),
    [sym_identifier] = ACTIONS(1737),
    [sym_instance_variable] = ACTIONS(1735),
    [sym_class_variable] = ACTIONS(1735),
    [sym_global_variable] = ACTIONS(1735),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1737),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1737),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2611] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5026),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_assignment] = STATE(5026),
    [sym_operator_assignment] = STATE(5026),
    [sym_conditional] = STATE(5026),
    [sym_range] = STATE(5026),
    [sym_binary] = STATE(5026),
    [sym_unary] = STATE(5026),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2676),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1787),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1791),
    [anon_sym_yield] = ACTIONS(1793),
    [anon_sym_break] = ACTIONS(1795),
    [anon_sym_next] = ACTIONS(1797),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(4527),
    [anon_sym_defined_QMARK] = ACTIONS(1799),
    [anon_sym_not] = ACTIONS(1801),
    [anon_sym_BANG] = ACTIONS(1805),
    [anon_sym_TILDE] = ACTIONS(1805),
    [sym_constant] = ACTIONS(1811),
    [sym_identifier] = ACTIONS(1811),
    [sym_instance_variable] = ACTIONS(1809),
    [sym_class_variable] = ACTIONS(1809),
    [sym_global_variable] = ACTIONS(1809),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1811),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1811),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2612] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5027),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_assignment] = STATE(5027),
    [sym_operator_assignment] = STATE(5027),
    [sym_conditional] = STATE(5027),
    [sym_range] = STATE(5027),
    [sym_binary] = STATE(5027),
    [sym_unary] = STATE(5027),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2676),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1787),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1791),
    [anon_sym_yield] = ACTIONS(1793),
    [anon_sym_break] = ACTIONS(1795),
    [anon_sym_next] = ACTIONS(1797),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(4527),
    [anon_sym_defined_QMARK] = ACTIONS(1799),
    [anon_sym_not] = ACTIONS(1801),
    [anon_sym_BANG] = ACTIONS(1805),
    [anon_sym_TILDE] = ACTIONS(1805),
    [sym_constant] = ACTIONS(1811),
    [sym_identifier] = ACTIONS(1811),
    [sym_instance_variable] = ACTIONS(1809),
    [sym_class_variable] = ACTIONS(1809),
    [sym_global_variable] = ACTIONS(1809),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1811),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1811),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2613] = {
    [anon_sym_COLON] = ACTIONS(7980),
    [sym_comment] = ACTIONS(87),
  },
  [2614] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5029),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_assignment] = STATE(5029),
    [sym_operator_assignment] = STATE(5029),
    [sym_conditional] = STATE(5029),
    [sym_range] = STATE(5029),
    [sym_binary] = STATE(5029),
    [sym_unary] = STATE(5029),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2676),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1787),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1791),
    [anon_sym_yield] = ACTIONS(1793),
    [anon_sym_break] = ACTIONS(1795),
    [anon_sym_next] = ACTIONS(1797),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(4527),
    [anon_sym_defined_QMARK] = ACTIONS(1799),
    [anon_sym_not] = ACTIONS(1801),
    [anon_sym_BANG] = ACTIONS(1805),
    [anon_sym_TILDE] = ACTIONS(1805),
    [sym_constant] = ACTIONS(1811),
    [sym_identifier] = ACTIONS(1811),
    [sym_instance_variable] = ACTIONS(1809),
    [sym_class_variable] = ACTIONS(1809),
    [sym_global_variable] = ACTIONS(1809),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1811),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1811),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2615] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(7982),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_then] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [2616] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(4533),
    [sym__binary_star] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(4537),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(4539),
    [anon_sym_AMP] = ACTIONS(4541),
    [anon_sym_EQ] = ACTIONS(1631),
    [anon_sym_LT] = ACTIONS(4543),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_unless] = ACTIONS(1625),
    [anon_sym_while] = ACTIONS(1625),
    [anon_sym_until] = ACTIONS(1625),
    [anon_sym_rescue] = ACTIONS(1625),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_then] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(1625),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_PLUS_EQ] = ACTIONS(1625),
    [anon_sym_DASH_EQ] = ACTIONS(1625),
    [anon_sym_STAR_EQ] = ACTIONS(1625),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1625),
    [anon_sym_SLASH_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1625),
    [anon_sym_AMP_EQ] = ACTIONS(1625),
    [anon_sym_PERCENT_EQ] = ACTIONS(1625),
    [anon_sym_GT_GT_EQ] = ACTIONS(1625),
    [anon_sym_LT_LT_EQ] = ACTIONS(1625),
    [anon_sym_CARET_EQ] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(4545),
    [anon_sym_DOT_DOT] = ACTIONS(4547),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4549),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(4551),
    [anon_sym_AMP_AMP] = ACTIONS(4551),
    [anon_sym_LT_LT] = ACTIONS(4553),
    [anon_sym_GT_GT] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4551),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4555),
    [anon_sym_LT_EQ_GT] = ACTIONS(4555),
    [anon_sym_EQ_TILDE] = ACTIONS(4555),
    [anon_sym_BANG_TILDE] = ACTIONS(4555),
    [anon_sym_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT] = ACTIONS(4543),
    [anon_sym_GT_EQ] = ACTIONS(4557),
    [anon_sym_CARET] = ACTIONS(4537),
    [anon_sym_PLUS] = ACTIONS(4559),
    [anon_sym_SLASH] = ACTIONS(4539),
    [anon_sym_PERCENT] = ACTIONS(4539),
    [sym_comment] = ACTIONS(87),
  },
  [2617] = {
    [sym_heredoc_body] = STATE(5031),
    [aux_sym_call_repeat1] = STATE(5031),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_then] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [2618] = {
    [sym_heredoc_body] = STATE(5031),
    [aux_sym_call_repeat1] = STATE(5031),
    [aux_sym_argument_list_repeat1] = STATE(5033),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(7984),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_then] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [2619] = {
    [sym_string] = STATE(2696),
    [aux_sym_chained_string_repeat1] = STATE(2696),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(747),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(7986),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2620] = {
    [sym_heredoc_body] = STATE(5034),
    [aux_sym_call_repeat1] = STATE(5034),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_then] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [2621] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(963),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym__argument] = STATE(2565),
    [sym_splat_argument] = STATE(2565),
    [sym_hash_splat_argument] = STATE(2565),
    [sym_block_argument] = STATE(2565),
    [sym_assignment] = STATE(963),
    [sym_operator_assignment] = STATE(963),
    [sym_conditional] = STATE(963),
    [sym_range] = STATE(963),
    [sym_binary] = STATE(963),
    [sym_unary] = STATE(963),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(969),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(5035),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2565),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(1709),
    [sym__splat_star] = ACTIONS(1711),
    [sym__unary_minus] = ACTIONS(1713),
    [sym__identifier_hash_key] = ACTIONS(1715),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(7988),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1717),
    [anon_sym_yield] = ACTIONS(1719),
    [anon_sym_break] = ACTIONS(1721),
    [anon_sym_next] = ACTIONS(1723),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4409),
    [anon_sym_defined_QMARK] = ACTIONS(1725),
    [anon_sym_not] = ACTIONS(1727),
    [anon_sym_BANG] = ACTIONS(1731),
    [anon_sym_TILDE] = ACTIONS(1731),
    [sym_constant] = ACTIONS(1733),
    [sym_identifier] = ACTIONS(1733),
    [sym_instance_variable] = ACTIONS(1735),
    [sym_class_variable] = ACTIONS(1735),
    [sym_global_variable] = ACTIONS(1735),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1737),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1737),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2622] = {
    [sym_heredoc_body] = STATE(5036),
    [aux_sym_call_repeat1] = STATE(5036),
    [aux_sym_argument_list_repeat1] = STATE(5037),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4457),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_then] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [2623] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5038),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_splat_argument] = STATE(5039),
    [sym_assignment] = STATE(5038),
    [sym_operator_assignment] = STATE(5038),
    [sym_conditional] = STATE(5038),
    [sym_range] = STATE(5038),
    [sym_binary] = STATE(5038),
    [sym_unary] = STATE(5038),
    [sym_right_assignment_list] = STATE(2570),
    [sym__arg_or_splat_arg] = STATE(5039),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2587),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__splat_star] = ACTIONS(4415),
    [sym__unary_minus] = ACTIONS(1713),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1717),
    [anon_sym_yield] = ACTIONS(1719),
    [anon_sym_break] = ACTIONS(1721),
    [anon_sym_next] = ACTIONS(1723),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4409),
    [anon_sym_defined_QMARK] = ACTIONS(1725),
    [anon_sym_not] = ACTIONS(1727),
    [anon_sym_BANG] = ACTIONS(1731),
    [anon_sym_TILDE] = ACTIONS(1731),
    [sym_constant] = ACTIONS(1737),
    [sym_identifier] = ACTIONS(1737),
    [sym_instance_variable] = ACTIONS(1735),
    [sym_class_variable] = ACTIONS(1735),
    [sym_global_variable] = ACTIONS(1735),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1737),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1737),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2624] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5040),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_assignment] = STATE(5040),
    [sym_operator_assignment] = STATE(5040),
    [sym_conditional] = STATE(5040),
    [sym_range] = STATE(5040),
    [sym_binary] = STATE(5040),
    [sym_unary] = STATE(5040),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2587),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1713),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1717),
    [anon_sym_yield] = ACTIONS(1719),
    [anon_sym_break] = ACTIONS(1721),
    [anon_sym_next] = ACTIONS(1723),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4409),
    [anon_sym_defined_QMARK] = ACTIONS(1725),
    [anon_sym_not] = ACTIONS(1727),
    [anon_sym_BANG] = ACTIONS(1731),
    [anon_sym_TILDE] = ACTIONS(1731),
    [sym_constant] = ACTIONS(1737),
    [sym_identifier] = ACTIONS(1737),
    [sym_instance_variable] = ACTIONS(1735),
    [sym_class_variable] = ACTIONS(1735),
    [sym_global_variable] = ACTIONS(1735),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1737),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1737),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2625] = {
    [sym_string] = STATE(5041),
    [aux_sym_chained_string_repeat1] = STATE(5041),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_then] = ACTIONS(2753),
    [anon_sym_EQ_GT] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [2626] = {
    [aux_sym_undef_repeat1] = STATE(5042),
    [sym__line_break] = ACTIONS(5497),
    [sym__heredoc_body_start] = ACTIONS(5497),
    [anon_sym_COMMA] = ACTIONS(2253),
    [anon_sym_SEMI] = ACTIONS(5497),
    [anon_sym_if] = ACTIONS(5497),
    [anon_sym_unless] = ACTIONS(5497),
    [anon_sym_while] = ACTIONS(5497),
    [anon_sym_until] = ACTIONS(5497),
    [anon_sym_rescue] = ACTIONS(5497),
    [anon_sym_then] = ACTIONS(5497),
    [sym_comment] = ACTIONS(87),
  },
  [2627] = {
    [sym__line_break] = ACTIONS(5815),
    [sym__heredoc_body_start] = ACTIONS(5815),
    [sym__binary_minus] = ACTIONS(1755),
    [sym__binary_star] = ACTIONS(1757),
    [anon_sym_PIPE] = ACTIONS(1759),
    [anon_sym_SEMI] = ACTIONS(5815),
    [anon_sym_STAR_STAR] = ACTIONS(1757),
    [anon_sym_AMP] = ACTIONS(1761),
    [anon_sym_LT] = ACTIONS(1763),
    [anon_sym_if] = ACTIONS(5815),
    [anon_sym_unless] = ACTIONS(5815),
    [anon_sym_while] = ACTIONS(5815),
    [anon_sym_until] = ACTIONS(5815),
    [anon_sym_rescue] = ACTIONS(5815),
    [anon_sym_then] = ACTIONS(5815),
    [anon_sym_QMARK] = ACTIONS(1765),
    [anon_sym_DOT_DOT] = ACTIONS(1767),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1769),
    [anon_sym_and] = ACTIONS(1771),
    [anon_sym_or] = ACTIONS(1771),
    [anon_sym_PIPE_PIPE] = ACTIONS(1773),
    [anon_sym_AMP_AMP] = ACTIONS(1773),
    [anon_sym_LT_LT] = ACTIONS(1775),
    [anon_sym_GT_GT] = ACTIONS(1775),
    [anon_sym_EQ_EQ] = ACTIONS(1777),
    [anon_sym_BANG_EQ] = ACTIONS(1773),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1773),
    [anon_sym_LT_EQ_GT] = ACTIONS(1773),
    [anon_sym_EQ_TILDE] = ACTIONS(1773),
    [anon_sym_BANG_TILDE] = ACTIONS(1773),
    [anon_sym_LT_EQ] = ACTIONS(1763),
    [anon_sym_GT] = ACTIONS(1763),
    [anon_sym_GT_EQ] = ACTIONS(1779),
    [anon_sym_CARET] = ACTIONS(1781),
    [anon_sym_PLUS] = ACTIONS(1755),
    [anon_sym_SLASH] = ACTIONS(1757),
    [anon_sym_PERCENT] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
  },
  [2628] = {
    [sym__line_break] = ACTIONS(5817),
    [sym__heredoc_body_start] = ACTIONS(5817),
    [sym__binary_minus] = ACTIONS(1755),
    [sym__binary_star] = ACTIONS(1757),
    [anon_sym_PIPE] = ACTIONS(1759),
    [anon_sym_SEMI] = ACTIONS(5817),
    [anon_sym_STAR_STAR] = ACTIONS(1757),
    [anon_sym_AMP] = ACTIONS(1761),
    [anon_sym_LT] = ACTIONS(1763),
    [anon_sym_if] = ACTIONS(5817),
    [anon_sym_unless] = ACTIONS(5817),
    [anon_sym_while] = ACTIONS(5817),
    [anon_sym_until] = ACTIONS(5817),
    [anon_sym_rescue] = ACTIONS(5817),
    [anon_sym_then] = ACTIONS(5817),
    [anon_sym_QMARK] = ACTIONS(1765),
    [anon_sym_DOT_DOT] = ACTIONS(1767),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1769),
    [anon_sym_and] = ACTIONS(1771),
    [anon_sym_or] = ACTIONS(1771),
    [anon_sym_PIPE_PIPE] = ACTIONS(1773),
    [anon_sym_AMP_AMP] = ACTIONS(1773),
    [anon_sym_LT_LT] = ACTIONS(1775),
    [anon_sym_GT_GT] = ACTIONS(1775),
    [anon_sym_EQ_EQ] = ACTIONS(1777),
    [anon_sym_BANG_EQ] = ACTIONS(1773),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1773),
    [anon_sym_LT_EQ_GT] = ACTIONS(1773),
    [anon_sym_EQ_TILDE] = ACTIONS(1773),
    [anon_sym_BANG_TILDE] = ACTIONS(1773),
    [anon_sym_LT_EQ] = ACTIONS(1763),
    [anon_sym_GT] = ACTIONS(1763),
    [anon_sym_GT_EQ] = ACTIONS(1779),
    [anon_sym_CARET] = ACTIONS(1781),
    [anon_sym_PLUS] = ACTIONS(1755),
    [anon_sym_SLASH] = ACTIONS(1757),
    [anon_sym_PERCENT] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
  },
  [2629] = {
    [sym__line_break] = ACTIONS(5819),
    [sym__heredoc_body_start] = ACTIONS(5819),
    [sym__binary_minus] = ACTIONS(1755),
    [sym__binary_star] = ACTIONS(1757),
    [anon_sym_PIPE] = ACTIONS(1759),
    [anon_sym_SEMI] = ACTIONS(5819),
    [anon_sym_STAR_STAR] = ACTIONS(1757),
    [anon_sym_AMP] = ACTIONS(1761),
    [anon_sym_LT] = ACTIONS(1763),
    [anon_sym_if] = ACTIONS(5819),
    [anon_sym_unless] = ACTIONS(5819),
    [anon_sym_while] = ACTIONS(5819),
    [anon_sym_until] = ACTIONS(5819),
    [anon_sym_rescue] = ACTIONS(5819),
    [anon_sym_then] = ACTIONS(5819),
    [anon_sym_QMARK] = ACTIONS(1765),
    [anon_sym_DOT_DOT] = ACTIONS(1767),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1769),
    [anon_sym_and] = ACTIONS(1771),
    [anon_sym_or] = ACTIONS(1771),
    [anon_sym_PIPE_PIPE] = ACTIONS(1773),
    [anon_sym_AMP_AMP] = ACTIONS(1773),
    [anon_sym_LT_LT] = ACTIONS(1775),
    [anon_sym_GT_GT] = ACTIONS(1775),
    [anon_sym_EQ_EQ] = ACTIONS(1777),
    [anon_sym_BANG_EQ] = ACTIONS(1773),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1773),
    [anon_sym_LT_EQ_GT] = ACTIONS(1773),
    [anon_sym_EQ_TILDE] = ACTIONS(1773),
    [anon_sym_BANG_TILDE] = ACTIONS(1773),
    [anon_sym_LT_EQ] = ACTIONS(1763),
    [anon_sym_GT] = ACTIONS(1763),
    [anon_sym_GT_EQ] = ACTIONS(1779),
    [anon_sym_CARET] = ACTIONS(1781),
    [anon_sym_PLUS] = ACTIONS(1755),
    [anon_sym_SLASH] = ACTIONS(1757),
    [anon_sym_PERCENT] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
  },
  [2630] = {
    [sym__line_break] = ACTIONS(5821),
    [sym__heredoc_body_start] = ACTIONS(5821),
    [sym__binary_minus] = ACTIONS(1755),
    [sym__binary_star] = ACTIONS(1757),
    [anon_sym_PIPE] = ACTIONS(1759),
    [anon_sym_SEMI] = ACTIONS(5821),
    [anon_sym_STAR_STAR] = ACTIONS(1757),
    [anon_sym_AMP] = ACTIONS(1761),
    [anon_sym_LT] = ACTIONS(1763),
    [anon_sym_if] = ACTIONS(5821),
    [anon_sym_unless] = ACTIONS(5821),
    [anon_sym_while] = ACTIONS(5821),
    [anon_sym_until] = ACTIONS(5821),
    [anon_sym_rescue] = ACTIONS(5821),
    [anon_sym_then] = ACTIONS(5821),
    [anon_sym_QMARK] = ACTIONS(1765),
    [anon_sym_DOT_DOT] = ACTIONS(1767),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1769),
    [anon_sym_and] = ACTIONS(1771),
    [anon_sym_or] = ACTIONS(1771),
    [anon_sym_PIPE_PIPE] = ACTIONS(1773),
    [anon_sym_AMP_AMP] = ACTIONS(1773),
    [anon_sym_LT_LT] = ACTIONS(1775),
    [anon_sym_GT_GT] = ACTIONS(1775),
    [anon_sym_EQ_EQ] = ACTIONS(1777),
    [anon_sym_BANG_EQ] = ACTIONS(1773),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1773),
    [anon_sym_LT_EQ_GT] = ACTIONS(1773),
    [anon_sym_EQ_TILDE] = ACTIONS(1773),
    [anon_sym_BANG_TILDE] = ACTIONS(1773),
    [anon_sym_LT_EQ] = ACTIONS(1763),
    [anon_sym_GT] = ACTIONS(1763),
    [anon_sym_GT_EQ] = ACTIONS(1779),
    [anon_sym_CARET] = ACTIONS(1781),
    [anon_sym_PLUS] = ACTIONS(1755),
    [anon_sym_SLASH] = ACTIONS(1757),
    [anon_sym_PERCENT] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
  },
  [2631] = {
    [sym__line_break] = ACTIONS(5823),
    [sym__heredoc_body_start] = ACTIONS(5823),
    [sym__binary_minus] = ACTIONS(1755),
    [sym__binary_star] = ACTIONS(1757),
    [anon_sym_PIPE] = ACTIONS(1759),
    [anon_sym_SEMI] = ACTIONS(5823),
    [anon_sym_STAR_STAR] = ACTIONS(1757),
    [anon_sym_AMP] = ACTIONS(1761),
    [anon_sym_LT] = ACTIONS(1763),
    [anon_sym_if] = ACTIONS(5823),
    [anon_sym_unless] = ACTIONS(5823),
    [anon_sym_while] = ACTIONS(5823),
    [anon_sym_until] = ACTIONS(5823),
    [anon_sym_rescue] = ACTIONS(5823),
    [anon_sym_then] = ACTIONS(5823),
    [anon_sym_QMARK] = ACTIONS(1765),
    [anon_sym_DOT_DOT] = ACTIONS(1767),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1769),
    [anon_sym_and] = ACTIONS(1771),
    [anon_sym_or] = ACTIONS(1771),
    [anon_sym_PIPE_PIPE] = ACTIONS(1773),
    [anon_sym_AMP_AMP] = ACTIONS(1773),
    [anon_sym_LT_LT] = ACTIONS(1775),
    [anon_sym_GT_GT] = ACTIONS(1775),
    [anon_sym_EQ_EQ] = ACTIONS(1777),
    [anon_sym_BANG_EQ] = ACTIONS(1773),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1773),
    [anon_sym_LT_EQ_GT] = ACTIONS(1773),
    [anon_sym_EQ_TILDE] = ACTIONS(1773),
    [anon_sym_BANG_TILDE] = ACTIONS(1773),
    [anon_sym_LT_EQ] = ACTIONS(1763),
    [anon_sym_GT] = ACTIONS(1763),
    [anon_sym_GT_EQ] = ACTIONS(1779),
    [anon_sym_CARET] = ACTIONS(1781),
    [anon_sym_PLUS] = ACTIONS(1755),
    [anon_sym_SLASH] = ACTIONS(1757),
    [anon_sym_PERCENT] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
  },
  [2632] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5043),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2645),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(2645),
    [sym_assignment] = STATE(5043),
    [sym_operator_assignment] = STATE(5043),
    [sym_conditional] = STATE(5043),
    [sym_range] = STATE(5043),
    [sym_binary] = STATE(5043),
    [sym_unary] = STATE(5043),
    [sym_left_assignment_list] = STATE(2644),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2645),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2645),
    [sym_false] = STATE(2645),
    [sym_nil] = STATE(2645),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2646),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4467),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4471),
    [anon_sym_yield] = ACTIONS(4473),
    [anon_sym_break] = ACTIONS(4475),
    [anon_sym_next] = ACTIONS(4477),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4479),
    [anon_sym_defined_QMARK] = ACTIONS(4481),
    [anon_sym_not] = ACTIONS(4483),
    [anon_sym_BANG] = ACTIONS(4485),
    [anon_sym_TILDE] = ACTIONS(4485),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2633] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5056),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5061),
    [sym_scope_resolution] = STATE(5057),
    [sym_call] = STATE(5057),
    [sym_method_call] = STATE(5061),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(5058),
    [sym__argument] = STATE(5059),
    [sym_splat_argument] = STATE(5059),
    [sym_hash_splat_argument] = STATE(5059),
    [sym_block_argument] = STATE(5059),
    [sym_assignment] = STATE(5056),
    [sym_operator_assignment] = STATE(5056),
    [sym_conditional] = STATE(5056),
    [sym_range] = STATE(5056),
    [sym_binary] = STATE(5056),
    [sym_unary] = STATE(5056),
    [sym_left_assignment_list] = STATE(5060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5061),
    [sym__variable] = STATE(5057),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5061),
    [sym_false] = STATE(5061),
    [sym_nil] = STATE(5061),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5062),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5059),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(7990),
    [sym__splat_star] = ACTIONS(7992),
    [sym__unary_minus] = ACTIONS(7994),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(7996),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(7998),
    [anon_sym_yield] = ACTIONS(8000),
    [anon_sym_break] = ACTIONS(8002),
    [anon_sym_next] = ACTIONS(8004),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(377),
    [anon_sym_else] = ACTIONS(377),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(8006),
    [anon_sym_not] = ACTIONS(8008),
    [anon_sym_BANG] = ACTIONS(8010),
    [anon_sym_TILDE] = ACTIONS(8012),
    [sym_constant] = ACTIONS(8014),
    [sym_identifier] = ACTIONS(8014),
    [sym_instance_variable] = ACTIONS(8016),
    [sym_class_variable] = ACTIONS(8016),
    [sym_global_variable] = ACTIONS(8016),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8018),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8018),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2634] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5056),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5061),
    [sym_scope_resolution] = STATE(5057),
    [sym_call] = STATE(5057),
    [sym_method_call] = STATE(5061),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(5058),
    [sym__argument] = STATE(5059),
    [sym_splat_argument] = STATE(5059),
    [sym_hash_splat_argument] = STATE(5059),
    [sym_block_argument] = STATE(5059),
    [sym_assignment] = STATE(5056),
    [sym_operator_assignment] = STATE(5056),
    [sym_conditional] = STATE(5056),
    [sym_range] = STATE(5056),
    [sym_binary] = STATE(5056),
    [sym_unary] = STATE(5056),
    [sym_left_assignment_list] = STATE(5060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5061),
    [sym__variable] = STATE(5057),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5061),
    [sym_false] = STATE(5061),
    [sym_nil] = STATE(5061),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5062),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5059),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(7990),
    [sym__splat_star] = ACTIONS(7992),
    [sym__unary_minus] = ACTIONS(7994),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(7996),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(7998),
    [anon_sym_yield] = ACTIONS(8000),
    [anon_sym_break] = ACTIONS(8002),
    [anon_sym_next] = ACTIONS(8004),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(419),
    [anon_sym_else] = ACTIONS(419),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(8006),
    [anon_sym_not] = ACTIONS(8008),
    [anon_sym_BANG] = ACTIONS(8010),
    [anon_sym_TILDE] = ACTIONS(8012),
    [sym_constant] = ACTIONS(8014),
    [sym_identifier] = ACTIONS(8014),
    [sym_instance_variable] = ACTIONS(8016),
    [sym_class_variable] = ACTIONS(8016),
    [sym_global_variable] = ACTIONS(8016),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8018),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8018),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2635] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5056),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5061),
    [sym_scope_resolution] = STATE(5057),
    [sym_call] = STATE(5057),
    [sym_method_call] = STATE(5061),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(5058),
    [sym__argument] = STATE(5059),
    [sym_splat_argument] = STATE(5059),
    [sym_hash_splat_argument] = STATE(5059),
    [sym_block_argument] = STATE(5059),
    [sym_assignment] = STATE(5056),
    [sym_operator_assignment] = STATE(5056),
    [sym_conditional] = STATE(5056),
    [sym_range] = STATE(5056),
    [sym_binary] = STATE(5056),
    [sym_unary] = STATE(5056),
    [sym_left_assignment_list] = STATE(5060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5061),
    [sym__variable] = STATE(5057),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5061),
    [sym_false] = STATE(5061),
    [sym_nil] = STATE(5061),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5062),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5059),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(7990),
    [sym__splat_star] = ACTIONS(7992),
    [sym__unary_minus] = ACTIONS(7994),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(7996),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(423),
    [anon_sym_return] = ACTIONS(7998),
    [anon_sym_yield] = ACTIONS(8000),
    [anon_sym_break] = ACTIONS(8002),
    [anon_sym_next] = ACTIONS(8004),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(423),
    [anon_sym_else] = ACTIONS(423),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(8006),
    [anon_sym_not] = ACTIONS(8008),
    [anon_sym_BANG] = ACTIONS(8010),
    [anon_sym_TILDE] = ACTIONS(8012),
    [sym_constant] = ACTIONS(8014),
    [sym_identifier] = ACTIONS(8014),
    [sym_instance_variable] = ACTIONS(8016),
    [sym_class_variable] = ACTIONS(8016),
    [sym_global_variable] = ACTIONS(8016),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8018),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8018),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2636] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5056),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5061),
    [sym_scope_resolution] = STATE(5057),
    [sym_call] = STATE(5057),
    [sym_method_call] = STATE(5061),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(5058),
    [sym__argument] = STATE(5059),
    [sym_splat_argument] = STATE(5059),
    [sym_hash_splat_argument] = STATE(5059),
    [sym_block_argument] = STATE(5059),
    [sym_assignment] = STATE(5056),
    [sym_operator_assignment] = STATE(5056),
    [sym_conditional] = STATE(5056),
    [sym_range] = STATE(5056),
    [sym_binary] = STATE(5056),
    [sym_unary] = STATE(5056),
    [sym_left_assignment_list] = STATE(5060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5061),
    [sym__variable] = STATE(5057),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5061),
    [sym_false] = STATE(5061),
    [sym_nil] = STATE(5061),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5062),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5059),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(7990),
    [sym__splat_star] = ACTIONS(7992),
    [sym__unary_minus] = ACTIONS(7994),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(7996),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(427),
    [anon_sym_return] = ACTIONS(7998),
    [anon_sym_yield] = ACTIONS(8000),
    [anon_sym_break] = ACTIONS(8002),
    [anon_sym_next] = ACTIONS(8004),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(427),
    [anon_sym_else] = ACTIONS(427),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(8006),
    [anon_sym_not] = ACTIONS(8008),
    [anon_sym_BANG] = ACTIONS(8010),
    [anon_sym_TILDE] = ACTIONS(8012),
    [sym_constant] = ACTIONS(8014),
    [sym_identifier] = ACTIONS(8014),
    [sym_instance_variable] = ACTIONS(8016),
    [sym_class_variable] = ACTIONS(8016),
    [sym_global_variable] = ACTIONS(8016),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8018),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8018),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2637] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5063),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2645),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(2645),
    [sym_assignment] = STATE(5063),
    [sym_operator_assignment] = STATE(5063),
    [sym_conditional] = STATE(5063),
    [sym_range] = STATE(5063),
    [sym_binary] = STATE(5063),
    [sym_unary] = STATE(5063),
    [sym_left_assignment_list] = STATE(2644),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2645),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2645),
    [sym_false] = STATE(2645),
    [sym_nil] = STATE(2645),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2646),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4467),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4471),
    [anon_sym_yield] = ACTIONS(4473),
    [anon_sym_break] = ACTIONS(4475),
    [anon_sym_next] = ACTIONS(4477),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4479),
    [anon_sym_defined_QMARK] = ACTIONS(4481),
    [anon_sym_not] = ACTIONS(4483),
    [anon_sym_BANG] = ACTIONS(4485),
    [anon_sym_TILDE] = ACTIONS(4485),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2638] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(298),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2645),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(2645),
    [sym_assignment] = STATE(298),
    [sym_operator_assignment] = STATE(298),
    [sym_conditional] = STATE(298),
    [sym_range] = STATE(298),
    [sym_binary] = STATE(298),
    [sym_unary] = STATE(298),
    [sym_left_assignment_list] = STATE(2644),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2645),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2645),
    [sym_false] = STATE(2645),
    [sym_nil] = STATE(2645),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2646),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4467),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4471),
    [anon_sym_yield] = ACTIONS(4473),
    [anon_sym_break] = ACTIONS(4475),
    [anon_sym_next] = ACTIONS(4477),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4479),
    [anon_sym_defined_QMARK] = ACTIONS(4481),
    [anon_sym_not] = ACTIONS(4483),
    [anon_sym_BANG] = ACTIONS(4485),
    [anon_sym_TILDE] = ACTIONS(4485),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2639] = {
    [sym_operator] = STATE(5064),
    [sym__method_name] = STATE(5064),
    [sym_setter] = STATE(5064),
    [sym_symbol] = STATE(5064),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(8020),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(8020),
    [sym_class_variable] = ACTIONS(8020),
    [sym_global_variable] = ACTIONS(8020),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [2640] = {
    [anon_sym_end] = ACTIONS(8022),
    [anon_sym_rescue] = ACTIONS(8022),
    [anon_sym_when] = ACTIONS(8022),
    [anon_sym_elsif] = ACTIONS(8022),
    [anon_sym_else] = ACTIONS(8022),
    [anon_sym_ensure] = ACTIONS(8022),
    [sym_comment] = ACTIONS(87),
  },
  [2641] = {
    [sym_heredoc_body] = STATE(370),
    [sym__terminator] = STATE(370),
    [sym__line_break] = ACTIONS(687),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(687),
    [anon_sym_end] = ACTIONS(689),
    [anon_sym_if] = ACTIONS(8024),
    [anon_sym_unless] = ACTIONS(8026),
    [anon_sym_while] = ACTIONS(8028),
    [anon_sym_until] = ACTIONS(8030),
    [anon_sym_rescue] = ACTIONS(8032),
    [anon_sym_elsif] = ACTIONS(689),
    [anon_sym_else] = ACTIONS(689),
    [sym_comment] = ACTIONS(87),
  },
  [2642] = {
    [sym__line_break] = ACTIONS(701),
    [sym__heredoc_body_start] = ACTIONS(701),
    [sym__binary_minus] = ACTIONS(8034),
    [sym__binary_star] = ACTIONS(8036),
    [anon_sym_PIPE] = ACTIONS(8038),
    [anon_sym_SEMI] = ACTIONS(701),
    [anon_sym_STAR_STAR] = ACTIONS(8036),
    [anon_sym_AMP] = ACTIONS(8040),
    [anon_sym_LT] = ACTIONS(8042),
    [anon_sym_end] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_unless] = ACTIONS(701),
    [anon_sym_while] = ACTIONS(701),
    [anon_sym_until] = ACTIONS(701),
    [anon_sym_rescue] = ACTIONS(701),
    [anon_sym_elsif] = ACTIONS(701),
    [anon_sym_else] = ACTIONS(701),
    [anon_sym_QMARK] = ACTIONS(8044),
    [anon_sym_DOT_DOT] = ACTIONS(8046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8048),
    [anon_sym_and] = ACTIONS(8050),
    [anon_sym_or] = ACTIONS(8050),
    [anon_sym_PIPE_PIPE] = ACTIONS(8052),
    [anon_sym_AMP_AMP] = ACTIONS(8052),
    [anon_sym_LT_LT] = ACTIONS(8054),
    [anon_sym_GT_GT] = ACTIONS(8054),
    [anon_sym_EQ_EQ] = ACTIONS(8056),
    [anon_sym_BANG_EQ] = ACTIONS(8052),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8052),
    [anon_sym_LT_EQ_GT] = ACTIONS(8052),
    [anon_sym_EQ_TILDE] = ACTIONS(8052),
    [anon_sym_BANG_TILDE] = ACTIONS(8052),
    [anon_sym_LT_EQ] = ACTIONS(8042),
    [anon_sym_GT] = ACTIONS(8042),
    [anon_sym_GT_EQ] = ACTIONS(8058),
    [anon_sym_CARET] = ACTIONS(8060),
    [anon_sym_PLUS] = ACTIONS(8034),
    [anon_sym_SLASH] = ACTIONS(8036),
    [anon_sym_PERCENT] = ACTIONS(8036),
    [sym_comment] = ACTIONS(87),
  },
  [2643] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5092),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5097),
    [sym_scope_resolution] = STATE(5093),
    [sym_call] = STATE(5093),
    [sym_method_call] = STATE(5097),
    [sym_argument_list] = STATE(423),
    [sym__argument_list_with_parens] = STATE(5094),
    [sym__argument] = STATE(5095),
    [sym_splat_argument] = STATE(5095),
    [sym_hash_splat_argument] = STATE(5095),
    [sym_block_argument] = STATE(5095),
    [sym_do_block] = STATE(426),
    [sym_block] = STATE(426),
    [sym_assignment] = STATE(5092),
    [sym_operator_assignment] = STATE(5092),
    [sym_conditional] = STATE(5092),
    [sym_range] = STATE(5092),
    [sym_binary] = STATE(5092),
    [sym_unary] = STATE(5092),
    [sym_left_assignment_list] = STATE(5096),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5097),
    [sym__variable] = STATE(5093),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5097),
    [sym_false] = STATE(5097),
    [sym_nil] = STATE(5097),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5098),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(5095),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(743),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(8062),
    [sym__splat_star] = ACTIONS(8064),
    [sym__unary_minus] = ACTIONS(8066),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(8068),
    [anon_sym_LBRACE] = ACTIONS(771),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(769),
    [anon_sym_return] = ACTIONS(8070),
    [anon_sym_yield] = ACTIONS(8072),
    [anon_sym_break] = ACTIONS(8074),
    [anon_sym_next] = ACTIONS(8076),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(769),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(769),
    [anon_sym_until] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(769),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_elsif] = ACTIONS(769),
    [anon_sym_else] = ACTIONS(769),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(8078),
    [anon_sym_not] = ACTIONS(8080),
    [anon_sym_BANG] = ACTIONS(8082),
    [anon_sym_TILDE] = ACTIONS(8084),
    [sym_constant] = ACTIONS(8086),
    [sym_identifier] = ACTIONS(8086),
    [sym_instance_variable] = ACTIONS(8088),
    [sym_class_variable] = ACTIONS(8088),
    [sym_global_variable] = ACTIONS(8088),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8090),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8090),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2644] = {
    [anon_sym_EQ] = ACTIONS(8092),
    [sym_comment] = ACTIONS(87),
  },
  [2645] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(8094),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_elsif] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(8096),
    [anon_sym_DASH_EQ] = ACTIONS(8096),
    [anon_sym_STAR_EQ] = ACTIONS(8096),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8096),
    [anon_sym_SLASH_EQ] = ACTIONS(8096),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8096),
    [anon_sym_PIPE_EQ] = ACTIONS(8096),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8096),
    [anon_sym_AMP_EQ] = ACTIONS(8096),
    [anon_sym_PERCENT_EQ] = ACTIONS(8096),
    [anon_sym_GT_GT_EQ] = ACTIONS(8096),
    [anon_sym_LT_LT_EQ] = ACTIONS(8096),
    [anon_sym_CARET_EQ] = ACTIONS(8096),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2646] = {
    [sym_string] = STATE(5101),
    [aux_sym_chained_string_repeat1] = STATE(5101),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_elsif] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2647] = {
    [sym_begin_block] = STATE(5102),
    [sym_end_block] = STATE(5102),
    [sym__statement] = STATE(5102),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(5102),
    [sym_unless_modifier] = STATE(5102),
    [sym_while_modifier] = STATE(5102),
    [sym_until_modifier] = STATE(5102),
    [sym_rescue_modifier] = STATE(5102),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2642),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2645),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(2645),
    [sym_assignment] = STATE(2642),
    [sym_operator_assignment] = STATE(2642),
    [sym_conditional] = STATE(2642),
    [sym_range] = STATE(2642),
    [sym_binary] = STATE(2642),
    [sym_unary] = STATE(2642),
    [sym_left_assignment_list] = STATE(2644),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2645),
    [sym__variable] = STATE(2643),
    [sym_undef] = STATE(5102),
    [sym_alias] = STATE(5102),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2645),
    [sym_false] = STATE(2645),
    [sym_nil] = STATE(2645),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2646),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(5103),
    [aux_sym__statements_repeat1] = STATE(5103),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4467),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(833),
    [anon_sym_return] = ACTIONS(4471),
    [anon_sym_yield] = ACTIONS(4473),
    [anon_sym_break] = ACTIONS(4475),
    [anon_sym_next] = ACTIONS(4477),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(833),
    [anon_sym_else] = ACTIONS(833),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4479),
    [anon_sym_defined_QMARK] = ACTIONS(4481),
    [anon_sym_not] = ACTIONS(4483),
    [anon_sym_BANG] = ACTIONS(4485),
    [anon_sym_TILDE] = ACTIONS(4485),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [anon_sym_undef] = ACTIONS(4491),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2648] = {
    [sym__line_break] = ACTIONS(8098),
    [sym__heredoc_body_start] = ACTIONS(8098),
    [sym__binary_minus] = ACTIONS(8098),
    [sym__binary_star] = ACTIONS(8098),
    [ts_builtin_sym_end] = ACTIONS(8098),
    [anon_sym___END__] = ACTIONS(8098),
    [anon_sym_LBRACE] = ACTIONS(8098),
    [anon_sym_RBRACE] = ACTIONS(8098),
    [anon_sym_RPAREN] = ACTIONS(8098),
    [anon_sym_DOT] = ACTIONS(8100),
    [anon_sym_COMMA] = ACTIONS(8098),
    [anon_sym_PIPE] = ACTIONS(8100),
    [anon_sym_SEMI] = ACTIONS(8098),
    [anon_sym_STAR_STAR] = ACTIONS(8098),
    [anon_sym_AMP] = ACTIONS(8100),
    [anon_sym_LT] = ACTIONS(8100),
    [anon_sym_end] = ACTIONS(8098),
    [anon_sym_if] = ACTIONS(8098),
    [anon_sym_unless] = ACTIONS(8098),
    [anon_sym_while] = ACTIONS(8098),
    [anon_sym_until] = ACTIONS(8098),
    [anon_sym_rescue] = ACTIONS(8098),
    [anon_sym_do] = ACTIONS(8098),
    [anon_sym_when] = ACTIONS(8098),
    [anon_sym_elsif] = ACTIONS(8098),
    [anon_sym_else] = ACTIONS(8098),
    [anon_sym_then] = ACTIONS(8098),
    [anon_sym_ensure] = ACTIONS(8098),
    [anon_sym_EQ_GT] = ACTIONS(8098),
    [anon_sym_LBRACK] = ACTIONS(8098),
    [anon_sym_COLON_COLON2] = ACTIONS(8098),
    [anon_sym_AMP_DOT] = ACTIONS(8098),
    [anon_sym_QMARK] = ACTIONS(8098),
    [anon_sym_DOT_DOT] = ACTIONS(8100),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8098),
    [anon_sym_and] = ACTIONS(8098),
    [anon_sym_or] = ACTIONS(8098),
    [anon_sym_PIPE_PIPE] = ACTIONS(8098),
    [anon_sym_AMP_AMP] = ACTIONS(8098),
    [anon_sym_LT_LT] = ACTIONS(8098),
    [anon_sym_GT_GT] = ACTIONS(8098),
    [anon_sym_EQ_EQ] = ACTIONS(8100),
    [anon_sym_BANG_EQ] = ACTIONS(8098),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8098),
    [anon_sym_LT_EQ_GT] = ACTIONS(8098),
    [anon_sym_EQ_TILDE] = ACTIONS(8098),
    [anon_sym_BANG_TILDE] = ACTIONS(8098),
    [anon_sym_LT_EQ] = ACTIONS(8100),
    [anon_sym_GT] = ACTIONS(8100),
    [anon_sym_GT_EQ] = ACTIONS(8098),
    [anon_sym_CARET] = ACTIONS(8098),
    [anon_sym_PLUS] = ACTIONS(8098),
    [anon_sym_SLASH] = ACTIONS(8098),
    [anon_sym_PERCENT] = ACTIONS(8098),
    [sym_comment] = ACTIONS(87),
  },
  [2649] = {
    [sym_begin_block] = STATE(5104),
    [sym_end_block] = STATE(5104),
    [sym__statement] = STATE(5104),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(5104),
    [sym_unless_modifier] = STATE(5104),
    [sym_while_modifier] = STATE(5104),
    [sym_until_modifier] = STATE(5104),
    [sym_rescue_modifier] = STATE(5104),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(234),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(234),
    [sym_operator_assignment] = STATE(234),
    [sym_conditional] = STATE(234),
    [sym_range] = STATE(234),
    [sym_binary] = STATE(234),
    [sym_unary] = STATE(234),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_undef] = STATE(5104),
    [sym_alias] = STATE(5104),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(429),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_yield] = ACTIONS(433),
    [anon_sym_break] = ACTIONS(435),
    [anon_sym_next] = ACTIONS(437),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(439),
    [anon_sym_defined_QMARK] = ACTIONS(441),
    [anon_sym_not] = ACTIONS(443),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [anon_sym_undef] = ACTIONS(451),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2650] = {
    [anon_sym_end] = ACTIONS(8102),
    [sym_comment] = ACTIONS(87),
  },
  [2651] = {
    [sym__statements] = STATE(5106),
    [sym_begin_block] = STATE(2641),
    [sym_end_block] = STATE(2641),
    [sym__statement] = STATE(2641),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(2641),
    [sym_unless_modifier] = STATE(2641),
    [sym_while_modifier] = STATE(2641),
    [sym_until_modifier] = STATE(2641),
    [sym_rescue_modifier] = STATE(2641),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2642),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2645),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(2645),
    [sym_assignment] = STATE(2642),
    [sym_operator_assignment] = STATE(2642),
    [sym_conditional] = STATE(2642),
    [sym_range] = STATE(2642),
    [sym_binary] = STATE(2642),
    [sym_unary] = STATE(2642),
    [sym_left_assignment_list] = STATE(2644),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2645),
    [sym__variable] = STATE(2643),
    [sym_undef] = STATE(2641),
    [sym_alias] = STATE(2641),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2645),
    [sym_false] = STATE(2645),
    [sym_nil] = STATE(2645),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2646),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(2647),
    [aux_sym__statements_repeat1] = STATE(2647),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4467),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(8104),
    [anon_sym_return] = ACTIONS(4471),
    [anon_sym_yield] = ACTIONS(4473),
    [anon_sym_break] = ACTIONS(4475),
    [anon_sym_next] = ACTIONS(4477),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(8104),
    [anon_sym_else] = ACTIONS(8104),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4479),
    [anon_sym_defined_QMARK] = ACTIONS(4481),
    [anon_sym_not] = ACTIONS(4483),
    [anon_sym_BANG] = ACTIONS(4485),
    [anon_sym_TILDE] = ACTIONS(4485),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [anon_sym_undef] = ACTIONS(4491),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2652] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(1757),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(1757),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(1757),
    [anon_sym_PERCENT] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
  },
  [2653] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(1757),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [2654] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(1755),
    [sym__binary_star] = ACTIONS(1757),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(1757),
    [anon_sym_AMP] = ACTIONS(1761),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(1775),
    [anon_sym_GT_GT] = ACTIONS(1775),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(1755),
    [anon_sym_SLASH] = ACTIONS(1757),
    [anon_sym_PERCENT] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
  },
  [2655] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(1755),
    [sym__binary_star] = ACTIONS(1757),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(1757),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(1775),
    [anon_sym_GT_GT] = ACTIONS(1775),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(1755),
    [anon_sym_SLASH] = ACTIONS(1757),
    [anon_sym_PERCENT] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
  },
  [2656] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(1755),
    [sym__binary_star] = ACTIONS(1757),
    [anon_sym_PIPE] = ACTIONS(1759),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(1757),
    [anon_sym_AMP] = ACTIONS(1761),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(1775),
    [anon_sym_GT_GT] = ACTIONS(1775),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(1781),
    [anon_sym_PLUS] = ACTIONS(1755),
    [anon_sym_SLASH] = ACTIONS(1757),
    [anon_sym_PERCENT] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
  },
  [2657] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(8106),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [2658] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(1755),
    [sym__binary_star] = ACTIONS(1757),
    [anon_sym_PIPE] = ACTIONS(1759),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(1757),
    [anon_sym_AMP] = ACTIONS(1761),
    [anon_sym_LT] = ACTIONS(1763),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_then] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(1767),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1769),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(1773),
    [anon_sym_AMP_AMP] = ACTIONS(1773),
    [anon_sym_LT_LT] = ACTIONS(1775),
    [anon_sym_GT_GT] = ACTIONS(1775),
    [anon_sym_EQ_EQ] = ACTIONS(1777),
    [anon_sym_BANG_EQ] = ACTIONS(1773),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1773),
    [anon_sym_LT_EQ_GT] = ACTIONS(1773),
    [anon_sym_EQ_TILDE] = ACTIONS(1773),
    [anon_sym_BANG_TILDE] = ACTIONS(1773),
    [anon_sym_LT_EQ] = ACTIONS(1763),
    [anon_sym_GT] = ACTIONS(1763),
    [anon_sym_GT_EQ] = ACTIONS(1779),
    [anon_sym_CARET] = ACTIONS(1781),
    [anon_sym_PLUS] = ACTIONS(1755),
    [anon_sym_SLASH] = ACTIONS(1757),
    [anon_sym_PERCENT] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
  },
  [2659] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(1755),
    [sym__binary_star] = ACTIONS(1757),
    [anon_sym_PIPE] = ACTIONS(1759),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(1757),
    [anon_sym_AMP] = ACTIONS(1761),
    [anon_sym_LT] = ACTIONS(1763),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(1765),
    [anon_sym_DOT_DOT] = ACTIONS(1767),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1769),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(1773),
    [anon_sym_AMP_AMP] = ACTIONS(1773),
    [anon_sym_LT_LT] = ACTIONS(1775),
    [anon_sym_GT_GT] = ACTIONS(1775),
    [anon_sym_EQ_EQ] = ACTIONS(1777),
    [anon_sym_BANG_EQ] = ACTIONS(1773),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1773),
    [anon_sym_LT_EQ_GT] = ACTIONS(1773),
    [anon_sym_EQ_TILDE] = ACTIONS(1773),
    [anon_sym_BANG_TILDE] = ACTIONS(1773),
    [anon_sym_LT_EQ] = ACTIONS(1763),
    [anon_sym_GT] = ACTIONS(1763),
    [anon_sym_GT_EQ] = ACTIONS(1779),
    [anon_sym_CARET] = ACTIONS(1781),
    [anon_sym_PLUS] = ACTIONS(1755),
    [anon_sym_SLASH] = ACTIONS(1757),
    [anon_sym_PERCENT] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
  },
  [2660] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(1755),
    [sym__binary_star] = ACTIONS(1757),
    [anon_sym_PIPE] = ACTIONS(1759),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(1757),
    [anon_sym_AMP] = ACTIONS(1761),
    [anon_sym_LT] = ACTIONS(1763),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(1775),
    [anon_sym_GT_GT] = ACTIONS(1775),
    [anon_sym_EQ_EQ] = ACTIONS(1777),
    [anon_sym_BANG_EQ] = ACTIONS(1773),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1773),
    [anon_sym_LT_EQ_GT] = ACTIONS(1773),
    [anon_sym_EQ_TILDE] = ACTIONS(1773),
    [anon_sym_BANG_TILDE] = ACTIONS(1773),
    [anon_sym_LT_EQ] = ACTIONS(1763),
    [anon_sym_GT] = ACTIONS(1763),
    [anon_sym_GT_EQ] = ACTIONS(1779),
    [anon_sym_CARET] = ACTIONS(1781),
    [anon_sym_PLUS] = ACTIONS(1755),
    [anon_sym_SLASH] = ACTIONS(1757),
    [anon_sym_PERCENT] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
  },
  [2661] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(1755),
    [sym__binary_star] = ACTIONS(1757),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(1757),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(1755),
    [anon_sym_SLASH] = ACTIONS(1757),
    [anon_sym_PERCENT] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
  },
  [2662] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(5108),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2672),
    [sym_scope_resolution] = STATE(2670),
    [sym_call] = STATE(2670),
    [sym_method_call] = STATE(2672),
    [sym_assignment] = STATE(5108),
    [sym_operator_assignment] = STATE(5108),
    [sym_conditional] = STATE(5108),
    [sym_range] = STATE(5108),
    [sym_binary] = STATE(5108),
    [sym_unary] = STATE(5108),
    [sym_left_assignment_list] = STATE(2671),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2672),
    [sym__variable] = STATE(2670),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2672),
    [sym_false] = STATE(2672),
    [sym_nil] = STATE(2672),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2673),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(4505),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(4507),
    [anon_sym_yield] = ACTIONS(4509),
    [anon_sym_break] = ACTIONS(4511),
    [anon_sym_next] = ACTIONS(4513),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(4515),
    [anon_sym_defined_QMARK] = ACTIONS(4517),
    [anon_sym_not] = ACTIONS(4519),
    [anon_sym_BANG] = ACTIONS(4521),
    [anon_sym_TILDE] = ACTIONS(4521),
    [sym_constant] = ACTIONS(4523),
    [sym_identifier] = ACTIONS(4523),
    [sym_instance_variable] = ACTIONS(4525),
    [sym_class_variable] = ACTIONS(4525),
    [sym_global_variable] = ACTIONS(4525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(4523),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4523),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [2663] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(1002),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_argument_list] = STATE(3610),
    [sym__argument_list_with_parens] = STATE(1004),
    [sym__argument] = STATE(1005),
    [sym_splat_argument] = STATE(1005),
    [sym_hash_splat_argument] = STATE(1005),
    [sym_block_argument] = STATE(1005),
    [sym_assignment] = STATE(1002),
    [sym_operator_assignment] = STATE(1002),
    [sym_conditional] = STATE(1002),
    [sym_range] = STATE(1002),
    [sym_binary] = STATE(1002),
    [sym_unary] = STATE(1002),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(1008),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(1005),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(1783),
    [sym__splat_star] = ACTIONS(1785),
    [sym__unary_minus] = ACTIONS(1787),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(1789),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1791),
    [anon_sym_yield] = ACTIONS(1793),
    [anon_sym_break] = ACTIONS(1795),
    [anon_sym_next] = ACTIONS(1797),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_then] = ACTIONS(377),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(365),
    [anon_sym_DASH_EQ] = ACTIONS(365),
    [anon_sym_STAR_EQ] = ACTIONS(365),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(365),
    [anon_sym_SLASH_EQ] = ACTIONS(365),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(365),
    [anon_sym_PIPE_EQ] = ACTIONS(365),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(365),
    [anon_sym_AMP_EQ] = ACTIONS(365),
    [anon_sym_PERCENT_EQ] = ACTIONS(365),
    [anon_sym_GT_GT_EQ] = ACTIONS(365),
    [anon_sym_LT_LT_EQ] = ACTIONS(365),
    [anon_sym_CARET_EQ] = ACTIONS(365),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_PERCENT] = ACTIONS(377),
    [anon_sym_defined_QMARK] = ACTIONS(1799),
    [anon_sym_not] = ACTIONS(1801),
    [anon_sym_BANG] = ACTIONS(1803),
    [anon_sym_TILDE] = ACTIONS(1805),
    [sym_constant] = ACTIONS(1807),
    [sym_identifier] = ACTIONS(1807),
    [sym_instance_variable] = ACTIONS(1809),
    [sym_class_variable] = ACTIONS(1809),
    [sym_global_variable] = ACTIONS(1809),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1811),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1811),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2664] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(1002),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_argument_list] = STATE(3611),
    [sym__argument_list_with_parens] = STATE(1004),
    [sym__argument] = STATE(1005),
    [sym_splat_argument] = STATE(1005),
    [sym_hash_splat_argument] = STATE(1005),
    [sym_block_argument] = STATE(1005),
    [sym_assignment] = STATE(1002),
    [sym_operator_assignment] = STATE(1002),
    [sym_conditional] = STATE(1002),
    [sym_range] = STATE(1002),
    [sym_binary] = STATE(1002),
    [sym_unary] = STATE(1002),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(1008),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(1005),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(1783),
    [sym__splat_star] = ACTIONS(1785),
    [sym__unary_minus] = ACTIONS(1787),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(1789),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_EQ] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1791),
    [anon_sym_yield] = ACTIONS(1793),
    [anon_sym_break] = ACTIONS(1795),
    [anon_sym_next] = ACTIONS(1797),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_then] = ACTIONS(419),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(417),
    [anon_sym_DASH_EQ] = ACTIONS(417),
    [anon_sym_STAR_EQ] = ACTIONS(417),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(417),
    [anon_sym_SLASH_EQ] = ACTIONS(417),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(417),
    [anon_sym_PIPE_EQ] = ACTIONS(417),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(417),
    [anon_sym_AMP_EQ] = ACTIONS(417),
    [anon_sym_PERCENT_EQ] = ACTIONS(417),
    [anon_sym_GT_GT_EQ] = ACTIONS(417),
    [anon_sym_LT_LT_EQ] = ACTIONS(417),
    [anon_sym_CARET_EQ] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(1799),
    [anon_sym_not] = ACTIONS(1801),
    [anon_sym_BANG] = ACTIONS(1803),
    [anon_sym_TILDE] = ACTIONS(1805),
    [sym_constant] = ACTIONS(1807),
    [sym_identifier] = ACTIONS(1807),
    [sym_instance_variable] = ACTIONS(1809),
    [sym_class_variable] = ACTIONS(1809),
    [sym_global_variable] = ACTIONS(1809),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1811),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1811),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2665] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(1002),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_argument_list] = STATE(3612),
    [sym__argument_list_with_parens] = STATE(1004),
    [sym__argument] = STATE(1005),
    [sym_splat_argument] = STATE(1005),
    [sym_hash_splat_argument] = STATE(1005),
    [sym_block_argument] = STATE(1005),
    [sym_assignment] = STATE(1002),
    [sym_operator_assignment] = STATE(1002),
    [sym_conditional] = STATE(1002),
    [sym_range] = STATE(1002),
    [sym_binary] = STATE(1002),
    [sym_unary] = STATE(1002),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(1008),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(1005),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(1783),
    [sym__splat_star] = ACTIONS(1785),
    [sym__unary_minus] = ACTIONS(1787),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(1789),
    [anon_sym_LBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_EQ] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1791),
    [anon_sym_yield] = ACTIONS(1793),
    [anon_sym_break] = ACTIONS(1795),
    [anon_sym_next] = ACTIONS(1797),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_then] = ACTIONS(423),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(421),
    [anon_sym_DASH_EQ] = ACTIONS(421),
    [anon_sym_STAR_EQ] = ACTIONS(421),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(421),
    [anon_sym_SLASH_EQ] = ACTIONS(421),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(421),
    [anon_sym_PIPE_EQ] = ACTIONS(421),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(421),
    [anon_sym_AMP_EQ] = ACTIONS(421),
    [anon_sym_PERCENT_EQ] = ACTIONS(421),
    [anon_sym_GT_GT_EQ] = ACTIONS(421),
    [anon_sym_LT_LT_EQ] = ACTIONS(421),
    [anon_sym_CARET_EQ] = ACTIONS(421),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(1799),
    [anon_sym_not] = ACTIONS(1801),
    [anon_sym_BANG] = ACTIONS(1803),
    [anon_sym_TILDE] = ACTIONS(1805),
    [sym_constant] = ACTIONS(1807),
    [sym_identifier] = ACTIONS(1807),
    [sym_instance_variable] = ACTIONS(1809),
    [sym_class_variable] = ACTIONS(1809),
    [sym_global_variable] = ACTIONS(1809),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1811),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1811),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2666] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(1002),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_argument_list] = STATE(3613),
    [sym__argument_list_with_parens] = STATE(1004),
    [sym__argument] = STATE(1005),
    [sym_splat_argument] = STATE(1005),
    [sym_hash_splat_argument] = STATE(1005),
    [sym_block_argument] = STATE(1005),
    [sym_assignment] = STATE(1002),
    [sym_operator_assignment] = STATE(1002),
    [sym_conditional] = STATE(1002),
    [sym_range] = STATE(1002),
    [sym_binary] = STATE(1002),
    [sym_unary] = STATE(1002),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(1008),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(1005),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(1783),
    [sym__splat_star] = ACTIONS(1785),
    [sym__unary_minus] = ACTIONS(1787),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(1789),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(427),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1791),
    [anon_sym_yield] = ACTIONS(1793),
    [anon_sym_break] = ACTIONS(1795),
    [anon_sym_next] = ACTIONS(1797),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_then] = ACTIONS(427),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(425),
    [anon_sym_DASH_EQ] = ACTIONS(425),
    [anon_sym_STAR_EQ] = ACTIONS(425),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(425),
    [anon_sym_SLASH_EQ] = ACTIONS(425),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(425),
    [anon_sym_PIPE_EQ] = ACTIONS(425),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(425),
    [anon_sym_AMP_EQ] = ACTIONS(425),
    [anon_sym_PERCENT_EQ] = ACTIONS(425),
    [anon_sym_GT_GT_EQ] = ACTIONS(425),
    [anon_sym_LT_LT_EQ] = ACTIONS(425),
    [anon_sym_CARET_EQ] = ACTIONS(425),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(1799),
    [anon_sym_not] = ACTIONS(1801),
    [anon_sym_BANG] = ACTIONS(1803),
    [anon_sym_TILDE] = ACTIONS(1805),
    [sym_constant] = ACTIONS(1807),
    [sym_identifier] = ACTIONS(1807),
    [sym_instance_variable] = ACTIONS(1809),
    [sym_class_variable] = ACTIONS(1809),
    [sym_global_variable] = ACTIONS(1809),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1811),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1811),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2667] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(5109),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2672),
    [sym_scope_resolution] = STATE(2670),
    [sym_call] = STATE(2670),
    [sym_method_call] = STATE(2672),
    [sym_assignment] = STATE(5109),
    [sym_operator_assignment] = STATE(5109),
    [sym_conditional] = STATE(5109),
    [sym_range] = STATE(5109),
    [sym_binary] = STATE(5109),
    [sym_unary] = STATE(5109),
    [sym_left_assignment_list] = STATE(2671),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2672),
    [sym__variable] = STATE(2670),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2672),
    [sym_false] = STATE(2672),
    [sym_nil] = STATE(2672),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2673),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(4505),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(4507),
    [anon_sym_yield] = ACTIONS(4509),
    [anon_sym_break] = ACTIONS(4511),
    [anon_sym_next] = ACTIONS(4513),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(4515),
    [anon_sym_defined_QMARK] = ACTIONS(4517),
    [anon_sym_not] = ACTIONS(4519),
    [anon_sym_BANG] = ACTIONS(4521),
    [anon_sym_TILDE] = ACTIONS(4521),
    [sym_constant] = ACTIONS(4523),
    [sym_identifier] = ACTIONS(4523),
    [sym_instance_variable] = ACTIONS(4525),
    [sym_class_variable] = ACTIONS(4525),
    [sym_global_variable] = ACTIONS(4525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(4523),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4523),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [2668] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(3628),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2672),
    [sym_scope_resolution] = STATE(2670),
    [sym_call] = STATE(2670),
    [sym_method_call] = STATE(2672),
    [sym_assignment] = STATE(3628),
    [sym_operator_assignment] = STATE(3628),
    [sym_conditional] = STATE(3628),
    [sym_range] = STATE(3628),
    [sym_binary] = STATE(3628),
    [sym_unary] = STATE(3628),
    [sym_left_assignment_list] = STATE(2671),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2672),
    [sym__variable] = STATE(2670),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2672),
    [sym_false] = STATE(2672),
    [sym_nil] = STATE(2672),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2673),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(4505),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(4507),
    [anon_sym_yield] = ACTIONS(4509),
    [anon_sym_break] = ACTIONS(4511),
    [anon_sym_next] = ACTIONS(4513),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(4515),
    [anon_sym_defined_QMARK] = ACTIONS(4517),
    [anon_sym_not] = ACTIONS(4519),
    [anon_sym_BANG] = ACTIONS(4521),
    [anon_sym_TILDE] = ACTIONS(4521),
    [sym_constant] = ACTIONS(4523),
    [sym_identifier] = ACTIONS(4523),
    [sym_instance_variable] = ACTIONS(4525),
    [sym_class_variable] = ACTIONS(4525),
    [sym_global_variable] = ACTIONS(4525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(4523),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4523),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [2669] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(8108),
    [sym__binary_star] = ACTIONS(8110),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(8112),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(8114),
    [anon_sym_AMP] = ACTIONS(8116),
    [anon_sym_EQ] = ACTIONS(4217),
    [anon_sym_LT] = ACTIONS(8118),
    [anon_sym_if] = ACTIONS(4211),
    [anon_sym_unless] = ACTIONS(4211),
    [anon_sym_while] = ACTIONS(4211),
    [anon_sym_until] = ACTIONS(4211),
    [anon_sym_rescue] = ACTIONS(4211),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_then] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_PLUS_EQ] = ACTIONS(4211),
    [anon_sym_DASH_EQ] = ACTIONS(4211),
    [anon_sym_STAR_EQ] = ACTIONS(4211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4211),
    [anon_sym_SLASH_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4211),
    [anon_sym_AMP_EQ] = ACTIONS(4211),
    [anon_sym_PERCENT_EQ] = ACTIONS(4211),
    [anon_sym_GT_GT_EQ] = ACTIONS(4211),
    [anon_sym_LT_LT_EQ] = ACTIONS(4211),
    [anon_sym_CARET_EQ] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(8120),
    [anon_sym_DOT_DOT] = ACTIONS(8122),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8124),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(8126),
    [anon_sym_AMP_AMP] = ACTIONS(8126),
    [anon_sym_LT_LT] = ACTIONS(8128),
    [anon_sym_GT_GT] = ACTIONS(8128),
    [anon_sym_EQ_EQ] = ACTIONS(8126),
    [anon_sym_BANG_EQ] = ACTIONS(8130),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8130),
    [anon_sym_LT_EQ_GT] = ACTIONS(8130),
    [anon_sym_EQ_TILDE] = ACTIONS(8130),
    [anon_sym_BANG_TILDE] = ACTIONS(8130),
    [anon_sym_LT_EQ] = ACTIONS(8118),
    [anon_sym_GT] = ACTIONS(8118),
    [anon_sym_GT_EQ] = ACTIONS(8132),
    [anon_sym_CARET] = ACTIONS(8112),
    [anon_sym_PLUS] = ACTIONS(8134),
    [anon_sym_SLASH] = ACTIONS(8114),
    [anon_sym_PERCENT] = ACTIONS(8114),
    [sym_comment] = ACTIONS(87),
  },
  [2670] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(1002),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_argument_list] = STATE(1062),
    [sym__argument_list_with_parens] = STATE(1004),
    [sym__argument] = STATE(1005),
    [sym_splat_argument] = STATE(1005),
    [sym_hash_splat_argument] = STATE(1005),
    [sym_block_argument] = STATE(1005),
    [sym_do_block] = STATE(426),
    [sym_block] = STATE(426),
    [sym_assignment] = STATE(1002),
    [sym_operator_assignment] = STATE(1002),
    [sym_conditional] = STATE(1002),
    [sym_range] = STATE(1002),
    [sym_binary] = STATE(1002),
    [sym_unary] = STATE(1002),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(1008),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(1005),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(743),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(1783),
    [sym__splat_star] = ACTIONS(1785),
    [sym__unary_minus] = ACTIONS(1787),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(1789),
    [anon_sym_LBRACE] = ACTIONS(6047),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1791),
    [anon_sym_yield] = ACTIONS(1793),
    [anon_sym_break] = ACTIONS(1795),
    [anon_sym_next] = ACTIONS(1797),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(769),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(769),
    [anon_sym_until] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(769),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(769),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_then] = ACTIONS(769),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(1799),
    [anon_sym_not] = ACTIONS(1801),
    [anon_sym_BANG] = ACTIONS(1803),
    [anon_sym_TILDE] = ACTIONS(1805),
    [sym_constant] = ACTIONS(1807),
    [sym_identifier] = ACTIONS(1807),
    [sym_instance_variable] = ACTIONS(1809),
    [sym_class_variable] = ACTIONS(1809),
    [sym_global_variable] = ACTIONS(1809),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1811),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1811),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2671] = {
    [anon_sym_EQ] = ACTIONS(8136),
    [sym_comment] = ACTIONS(87),
  },
  [2672] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(8138),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(8140),
    [anon_sym_DASH_EQ] = ACTIONS(8140),
    [anon_sym_STAR_EQ] = ACTIONS(8140),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8140),
    [anon_sym_SLASH_EQ] = ACTIONS(8140),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8140),
    [anon_sym_PIPE_EQ] = ACTIONS(8140),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8140),
    [anon_sym_AMP_EQ] = ACTIONS(8140),
    [anon_sym_PERCENT_EQ] = ACTIONS(8140),
    [anon_sym_GT_GT_EQ] = ACTIONS(8140),
    [anon_sym_LT_LT_EQ] = ACTIONS(8140),
    [anon_sym_CARET_EQ] = ACTIONS(8140),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2673] = {
    [sym_string] = STATE(5122),
    [aux_sym_chained_string_repeat1] = STATE(5122),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(2551),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2674] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(8108),
    [sym__binary_star] = ACTIONS(8110),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(8112),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(8114),
    [anon_sym_AMP] = ACTIONS(8116),
    [anon_sym_EQ] = ACTIONS(4249),
    [anon_sym_LT] = ACTIONS(8118),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_then] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_PLUS_EQ] = ACTIONS(4247),
    [anon_sym_DASH_EQ] = ACTIONS(4247),
    [anon_sym_STAR_EQ] = ACTIONS(4247),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4247),
    [anon_sym_SLASH_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4247),
    [anon_sym_AMP_EQ] = ACTIONS(4247),
    [anon_sym_PERCENT_EQ] = ACTIONS(4247),
    [anon_sym_GT_GT_EQ] = ACTIONS(4247),
    [anon_sym_LT_LT_EQ] = ACTIONS(4247),
    [anon_sym_CARET_EQ] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(8120),
    [anon_sym_DOT_DOT] = ACTIONS(8122),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8124),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(8126),
    [anon_sym_AMP_AMP] = ACTIONS(8126),
    [anon_sym_LT_LT] = ACTIONS(8128),
    [anon_sym_GT_GT] = ACTIONS(8128),
    [anon_sym_EQ_EQ] = ACTIONS(8126),
    [anon_sym_BANG_EQ] = ACTIONS(8130),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8130),
    [anon_sym_LT_EQ_GT] = ACTIONS(8130),
    [anon_sym_EQ_TILDE] = ACTIONS(8130),
    [anon_sym_BANG_TILDE] = ACTIONS(8130),
    [anon_sym_LT_EQ] = ACTIONS(8118),
    [anon_sym_GT] = ACTIONS(8118),
    [anon_sym_GT_EQ] = ACTIONS(8132),
    [anon_sym_CARET] = ACTIONS(8112),
    [anon_sym_PLUS] = ACTIONS(8134),
    [anon_sym_SLASH] = ACTIONS(8114),
    [anon_sym_PERCENT] = ACTIONS(8114),
    [sym_comment] = ACTIONS(87),
  },
  [2675] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(4539),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [2676] = {
    [sym_string] = STATE(2696),
    [aux_sym_chained_string_repeat1] = STATE(2696),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(747),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2677] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(5123),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2672),
    [sym_scope_resolution] = STATE(2670),
    [sym_call] = STATE(2670),
    [sym_method_call] = STATE(2672),
    [sym_assignment] = STATE(5123),
    [sym_operator_assignment] = STATE(5123),
    [sym_conditional] = STATE(5123),
    [sym_range] = STATE(5123),
    [sym_binary] = STATE(5123),
    [sym_unary] = STATE(5123),
    [sym_left_assignment_list] = STATE(2671),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2672),
    [sym__variable] = STATE(2670),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2672),
    [sym_false] = STATE(2672),
    [sym_nil] = STATE(2672),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2673),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(4505),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(4507),
    [anon_sym_yield] = ACTIONS(4509),
    [anon_sym_break] = ACTIONS(4511),
    [anon_sym_next] = ACTIONS(4513),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(4515),
    [anon_sym_defined_QMARK] = ACTIONS(4517),
    [anon_sym_not] = ACTIONS(4519),
    [anon_sym_BANG] = ACTIONS(4521),
    [anon_sym_TILDE] = ACTIONS(4521),
    [sym_constant] = ACTIONS(4523),
    [sym_identifier] = ACTIONS(4523),
    [sym_instance_variable] = ACTIONS(4525),
    [sym_class_variable] = ACTIONS(4525),
    [sym_global_variable] = ACTIONS(4525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(4523),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4523),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [2678] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(8108),
    [sym__binary_star] = ACTIONS(8110),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(8112),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(8114),
    [anon_sym_AMP] = ACTIONS(8116),
    [anon_sym_EQ] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(8118),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_unless] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_until] = ACTIONS(3281),
    [anon_sym_rescue] = ACTIONS(3281),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_then] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_PLUS_EQ] = ACTIONS(3281),
    [anon_sym_DASH_EQ] = ACTIONS(3281),
    [anon_sym_STAR_EQ] = ACTIONS(3281),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3281),
    [anon_sym_SLASH_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3281),
    [anon_sym_AMP_EQ] = ACTIONS(3281),
    [anon_sym_PERCENT_EQ] = ACTIONS(3281),
    [anon_sym_GT_GT_EQ] = ACTIONS(3281),
    [anon_sym_LT_LT_EQ] = ACTIONS(3281),
    [anon_sym_CARET_EQ] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(8120),
    [anon_sym_DOT_DOT] = ACTIONS(8122),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8124),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(8126),
    [anon_sym_AMP_AMP] = ACTIONS(8126),
    [anon_sym_LT_LT] = ACTIONS(8128),
    [anon_sym_GT_GT] = ACTIONS(8128),
    [anon_sym_EQ_EQ] = ACTIONS(8126),
    [anon_sym_BANG_EQ] = ACTIONS(8130),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8130),
    [anon_sym_LT_EQ_GT] = ACTIONS(8130),
    [anon_sym_EQ_TILDE] = ACTIONS(8130),
    [anon_sym_BANG_TILDE] = ACTIONS(8130),
    [anon_sym_LT_EQ] = ACTIONS(8118),
    [anon_sym_GT] = ACTIONS(8118),
    [anon_sym_GT_EQ] = ACTIONS(8132),
    [anon_sym_CARET] = ACTIONS(8112),
    [anon_sym_PLUS] = ACTIONS(8134),
    [anon_sym_SLASH] = ACTIONS(8114),
    [anon_sym_PERCENT] = ACTIONS(8114),
    [sym_comment] = ACTIONS(87),
  },
  [2679] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(4533),
    [sym__binary_star] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(4537),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(4539),
    [anon_sym_AMP] = ACTIONS(4541),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(4543),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(4545),
    [anon_sym_DOT_DOT] = ACTIONS(4547),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4549),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(4551),
    [anon_sym_AMP_AMP] = ACTIONS(4551),
    [anon_sym_LT_LT] = ACTIONS(4553),
    [anon_sym_GT_GT] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4551),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4555),
    [anon_sym_LT_EQ_GT] = ACTIONS(4555),
    [anon_sym_EQ_TILDE] = ACTIONS(4555),
    [anon_sym_BANG_TILDE] = ACTIONS(4555),
    [anon_sym_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT] = ACTIONS(4543),
    [anon_sym_GT_EQ] = ACTIONS(4557),
    [anon_sym_CARET] = ACTIONS(4537),
    [anon_sym_PLUS] = ACTIONS(4559),
    [anon_sym_SLASH] = ACTIONS(4539),
    [anon_sym_PERCENT] = ACTIONS(4539),
    [sym_comment] = ACTIONS(87),
  },
  [2680] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(5124),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2672),
    [sym_scope_resolution] = STATE(2670),
    [sym_call] = STATE(2670),
    [sym_method_call] = STATE(2672),
    [sym_assignment] = STATE(5124),
    [sym_operator_assignment] = STATE(5124),
    [sym_conditional] = STATE(5124),
    [sym_range] = STATE(5124),
    [sym_binary] = STATE(5124),
    [sym_unary] = STATE(5124),
    [sym_left_assignment_list] = STATE(2671),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2672),
    [sym__variable] = STATE(2670),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2672),
    [sym_false] = STATE(2672),
    [sym_nil] = STATE(2672),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2673),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(4505),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(4507),
    [anon_sym_yield] = ACTIONS(4509),
    [anon_sym_break] = ACTIONS(4511),
    [anon_sym_next] = ACTIONS(4513),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(4515),
    [anon_sym_defined_QMARK] = ACTIONS(4517),
    [anon_sym_not] = ACTIONS(4519),
    [anon_sym_BANG] = ACTIONS(4521),
    [anon_sym_TILDE] = ACTIONS(4521),
    [sym_constant] = ACTIONS(4523),
    [sym_identifier] = ACTIONS(4523),
    [sym_instance_variable] = ACTIONS(4525),
    [sym_class_variable] = ACTIONS(4525),
    [sym_global_variable] = ACTIONS(4525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(4523),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4523),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [2681] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5125),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_assignment] = STATE(5125),
    [sym_operator_assignment] = STATE(5125),
    [sym_conditional] = STATE(5125),
    [sym_range] = STATE(5125),
    [sym_binary] = STATE(5125),
    [sym_unary] = STATE(5125),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2676),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1787),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1791),
    [anon_sym_yield] = ACTIONS(1793),
    [anon_sym_break] = ACTIONS(1795),
    [anon_sym_next] = ACTIONS(1797),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(4527),
    [anon_sym_defined_QMARK] = ACTIONS(1799),
    [anon_sym_not] = ACTIONS(1801),
    [anon_sym_BANG] = ACTIONS(1805),
    [anon_sym_TILDE] = ACTIONS(1805),
    [sym_constant] = ACTIONS(1811),
    [sym_identifier] = ACTIONS(1811),
    [sym_instance_variable] = ACTIONS(1809),
    [sym_class_variable] = ACTIONS(1809),
    [sym_global_variable] = ACTIONS(1809),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1811),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1811),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2682] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5126),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_assignment] = STATE(5126),
    [sym_operator_assignment] = STATE(5126),
    [sym_conditional] = STATE(5126),
    [sym_range] = STATE(5126),
    [sym_binary] = STATE(5126),
    [sym_unary] = STATE(5126),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2676),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1787),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1791),
    [anon_sym_yield] = ACTIONS(1793),
    [anon_sym_break] = ACTIONS(1795),
    [anon_sym_next] = ACTIONS(1797),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(4527),
    [anon_sym_defined_QMARK] = ACTIONS(1799),
    [anon_sym_not] = ACTIONS(1801),
    [anon_sym_BANG] = ACTIONS(1805),
    [anon_sym_TILDE] = ACTIONS(1805),
    [sym_constant] = ACTIONS(1811),
    [sym_identifier] = ACTIONS(1811),
    [sym_instance_variable] = ACTIONS(1809),
    [sym_class_variable] = ACTIONS(1809),
    [sym_global_variable] = ACTIONS(1809),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1811),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1811),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2683] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5127),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_assignment] = STATE(5127),
    [sym_operator_assignment] = STATE(5127),
    [sym_conditional] = STATE(5127),
    [sym_range] = STATE(5127),
    [sym_binary] = STATE(5127),
    [sym_unary] = STATE(5127),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2676),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1787),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1791),
    [anon_sym_yield] = ACTIONS(1793),
    [anon_sym_break] = ACTIONS(1795),
    [anon_sym_next] = ACTIONS(1797),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(4527),
    [anon_sym_defined_QMARK] = ACTIONS(1799),
    [anon_sym_not] = ACTIONS(1801),
    [anon_sym_BANG] = ACTIONS(1805),
    [anon_sym_TILDE] = ACTIONS(1805),
    [sym_constant] = ACTIONS(1811),
    [sym_identifier] = ACTIONS(1811),
    [sym_instance_variable] = ACTIONS(1809),
    [sym_class_variable] = ACTIONS(1809),
    [sym_global_variable] = ACTIONS(1809),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1811),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1811),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2684] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5128),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_assignment] = STATE(5128),
    [sym_operator_assignment] = STATE(5128),
    [sym_conditional] = STATE(5128),
    [sym_range] = STATE(5128),
    [sym_binary] = STATE(5128),
    [sym_unary] = STATE(5128),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2676),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1787),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1791),
    [anon_sym_yield] = ACTIONS(1793),
    [anon_sym_break] = ACTIONS(1795),
    [anon_sym_next] = ACTIONS(1797),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(4527),
    [anon_sym_defined_QMARK] = ACTIONS(1799),
    [anon_sym_not] = ACTIONS(1801),
    [anon_sym_BANG] = ACTIONS(1805),
    [anon_sym_TILDE] = ACTIONS(1805),
    [sym_constant] = ACTIONS(1811),
    [sym_identifier] = ACTIONS(1811),
    [sym_instance_variable] = ACTIONS(1809),
    [sym_class_variable] = ACTIONS(1809),
    [sym_global_variable] = ACTIONS(1809),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1811),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1811),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2685] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5129),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_assignment] = STATE(5129),
    [sym_operator_assignment] = STATE(5129),
    [sym_conditional] = STATE(5129),
    [sym_range] = STATE(5129),
    [sym_binary] = STATE(5129),
    [sym_unary] = STATE(5129),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2676),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1787),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1791),
    [anon_sym_yield] = ACTIONS(1793),
    [anon_sym_break] = ACTIONS(1795),
    [anon_sym_next] = ACTIONS(1797),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(4527),
    [anon_sym_defined_QMARK] = ACTIONS(1799),
    [anon_sym_not] = ACTIONS(1801),
    [anon_sym_BANG] = ACTIONS(1805),
    [anon_sym_TILDE] = ACTIONS(1805),
    [sym_constant] = ACTIONS(1811),
    [sym_identifier] = ACTIONS(1811),
    [sym_instance_variable] = ACTIONS(1809),
    [sym_class_variable] = ACTIONS(1809),
    [sym_global_variable] = ACTIONS(1809),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1811),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1811),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2686] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(5130),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(5130),
    [sym_operator_assignment] = STATE(5130),
    [sym_conditional] = STATE(5130),
    [sym_range] = STATE(5130),
    [sym_binary] = STATE(5130),
    [sym_unary] = STATE(5130),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2687] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5131),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_assignment] = STATE(5131),
    [sym_operator_assignment] = STATE(5131),
    [sym_conditional] = STATE(5131),
    [sym_range] = STATE(5131),
    [sym_binary] = STATE(5131),
    [sym_unary] = STATE(5131),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2676),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1787),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1791),
    [anon_sym_yield] = ACTIONS(1793),
    [anon_sym_break] = ACTIONS(1795),
    [anon_sym_next] = ACTIONS(1797),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(4527),
    [anon_sym_defined_QMARK] = ACTIONS(1799),
    [anon_sym_not] = ACTIONS(1801),
    [anon_sym_BANG] = ACTIONS(1805),
    [anon_sym_TILDE] = ACTIONS(1805),
    [sym_constant] = ACTIONS(1811),
    [sym_identifier] = ACTIONS(1811),
    [sym_instance_variable] = ACTIONS(1809),
    [sym_class_variable] = ACTIONS(1809),
    [sym_global_variable] = ACTIONS(1809),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1811),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1811),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2688] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5132),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_assignment] = STATE(5132),
    [sym_operator_assignment] = STATE(5132),
    [sym_conditional] = STATE(5132),
    [sym_range] = STATE(5132),
    [sym_binary] = STATE(5132),
    [sym_unary] = STATE(5132),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2676),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1787),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1791),
    [anon_sym_yield] = ACTIONS(1793),
    [anon_sym_break] = ACTIONS(1795),
    [anon_sym_next] = ACTIONS(1797),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(4527),
    [anon_sym_defined_QMARK] = ACTIONS(1799),
    [anon_sym_not] = ACTIONS(1801),
    [anon_sym_BANG] = ACTIONS(1805),
    [anon_sym_TILDE] = ACTIONS(1805),
    [sym_constant] = ACTIONS(1811),
    [sym_identifier] = ACTIONS(1811),
    [sym_instance_variable] = ACTIONS(1809),
    [sym_class_variable] = ACTIONS(1809),
    [sym_global_variable] = ACTIONS(1809),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1811),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1811),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2689] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5133),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_assignment] = STATE(5133),
    [sym_operator_assignment] = STATE(5133),
    [sym_conditional] = STATE(5133),
    [sym_range] = STATE(5133),
    [sym_binary] = STATE(5133),
    [sym_unary] = STATE(5133),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2676),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1787),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1791),
    [anon_sym_yield] = ACTIONS(1793),
    [anon_sym_break] = ACTIONS(1795),
    [anon_sym_next] = ACTIONS(1797),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(4527),
    [anon_sym_defined_QMARK] = ACTIONS(1799),
    [anon_sym_not] = ACTIONS(1801),
    [anon_sym_BANG] = ACTIONS(1805),
    [anon_sym_TILDE] = ACTIONS(1805),
    [sym_constant] = ACTIONS(1811),
    [sym_identifier] = ACTIONS(1811),
    [sym_instance_variable] = ACTIONS(1809),
    [sym_class_variable] = ACTIONS(1809),
    [sym_global_variable] = ACTIONS(1809),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1811),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1811),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2690] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5134),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_assignment] = STATE(5134),
    [sym_operator_assignment] = STATE(5134),
    [sym_conditional] = STATE(5134),
    [sym_range] = STATE(5134),
    [sym_binary] = STATE(5134),
    [sym_unary] = STATE(5134),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2676),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1787),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1791),
    [anon_sym_yield] = ACTIONS(1793),
    [anon_sym_break] = ACTIONS(1795),
    [anon_sym_next] = ACTIONS(1797),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(4527),
    [anon_sym_defined_QMARK] = ACTIONS(1799),
    [anon_sym_not] = ACTIONS(1801),
    [anon_sym_BANG] = ACTIONS(1805),
    [anon_sym_TILDE] = ACTIONS(1805),
    [sym_constant] = ACTIONS(1811),
    [sym_identifier] = ACTIONS(1811),
    [sym_instance_variable] = ACTIONS(1809),
    [sym_class_variable] = ACTIONS(1809),
    [sym_global_variable] = ACTIONS(1809),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1811),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1811),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2691] = {
    [sym_heredoc_body] = STATE(5135),
    [aux_sym_call_repeat1] = STATE(5135),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_then] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [2692] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(1002),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym__argument] = STATE(3737),
    [sym_splat_argument] = STATE(3737),
    [sym_hash_splat_argument] = STATE(3737),
    [sym_block_argument] = STATE(3737),
    [sym_assignment] = STATE(1002),
    [sym_operator_assignment] = STATE(1002),
    [sym_conditional] = STATE(1002),
    [sym_range] = STATE(1002),
    [sym_binary] = STATE(1002),
    [sym_unary] = STATE(1002),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(1008),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_heredoc_body] = STATE(5136),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(3737),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(1783),
    [sym__splat_star] = ACTIONS(1785),
    [sym__unary_minus] = ACTIONS(1787),
    [sym__identifier_hash_key] = ACTIONS(1789),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(8142),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1791),
    [anon_sym_yield] = ACTIONS(1793),
    [anon_sym_break] = ACTIONS(1795),
    [anon_sym_next] = ACTIONS(1797),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(4527),
    [anon_sym_defined_QMARK] = ACTIONS(1799),
    [anon_sym_not] = ACTIONS(1801),
    [anon_sym_BANG] = ACTIONS(1805),
    [anon_sym_TILDE] = ACTIONS(1805),
    [sym_constant] = ACTIONS(1807),
    [sym_identifier] = ACTIONS(1807),
    [sym_instance_variable] = ACTIONS(1809),
    [sym_class_variable] = ACTIONS(1809),
    [sym_global_variable] = ACTIONS(1809),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1811),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1811),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2693] = {
    [sym_heredoc_body] = STATE(5137),
    [aux_sym_call_repeat1] = STATE(5137),
    [aux_sym_argument_list_repeat1] = STATE(5138),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4561),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_then] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [2694] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5139),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_splat_argument] = STATE(5140),
    [sym_assignment] = STATE(5139),
    [sym_operator_assignment] = STATE(5139),
    [sym_conditional] = STATE(5139),
    [sym_range] = STATE(5139),
    [sym_binary] = STATE(5139),
    [sym_unary] = STATE(5139),
    [sym_right_assignment_list] = STATE(3742),
    [sym__arg_or_splat_arg] = STATE(5140),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2676),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__splat_star] = ACTIONS(4451),
    [sym__unary_minus] = ACTIONS(1787),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1791),
    [anon_sym_yield] = ACTIONS(1793),
    [anon_sym_break] = ACTIONS(1795),
    [anon_sym_next] = ACTIONS(1797),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(4527),
    [anon_sym_defined_QMARK] = ACTIONS(1799),
    [anon_sym_not] = ACTIONS(1801),
    [anon_sym_BANG] = ACTIONS(1805),
    [anon_sym_TILDE] = ACTIONS(1805),
    [sym_constant] = ACTIONS(1811),
    [sym_identifier] = ACTIONS(1811),
    [sym_instance_variable] = ACTIONS(1809),
    [sym_class_variable] = ACTIONS(1809),
    [sym_global_variable] = ACTIONS(1809),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1811),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1811),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2695] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5141),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_assignment] = STATE(5141),
    [sym_operator_assignment] = STATE(5141),
    [sym_conditional] = STATE(5141),
    [sym_range] = STATE(5141),
    [sym_binary] = STATE(5141),
    [sym_unary] = STATE(5141),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2676),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1787),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1791),
    [anon_sym_yield] = ACTIONS(1793),
    [anon_sym_break] = ACTIONS(1795),
    [anon_sym_next] = ACTIONS(1797),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(4527),
    [anon_sym_defined_QMARK] = ACTIONS(1799),
    [anon_sym_not] = ACTIONS(1801),
    [anon_sym_BANG] = ACTIONS(1805),
    [anon_sym_TILDE] = ACTIONS(1805),
    [sym_constant] = ACTIONS(1811),
    [sym_identifier] = ACTIONS(1811),
    [sym_instance_variable] = ACTIONS(1809),
    [sym_class_variable] = ACTIONS(1809),
    [sym_global_variable] = ACTIONS(1809),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1811),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1811),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2696] = {
    [sym_string] = STATE(5142),
    [aux_sym_chained_string_repeat1] = STATE(5142),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(747),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2755),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_EQ] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_then] = ACTIONS(2753),
    [anon_sym_EQ_GT] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_PLUS_EQ] = ACTIONS(2753),
    [anon_sym_DASH_EQ] = ACTIONS(2753),
    [anon_sym_STAR_EQ] = ACTIONS(2753),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2753),
    [anon_sym_SLASH_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2753),
    [anon_sym_AMP_EQ] = ACTIONS(2753),
    [anon_sym_PERCENT_EQ] = ACTIONS(2753),
    [anon_sym_GT_GT_EQ] = ACTIONS(2753),
    [anon_sym_LT_LT_EQ] = ACTIONS(2753),
    [anon_sym_CARET_EQ] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2755),
    [anon_sym_AMP_AMP] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2755),
    [anon_sym_GT_GT] = ACTIONS(2755),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_SLASH] = ACTIONS(2755),
    [anon_sym_PERCENT] = ACTIONS(2755),
    [sym_comment] = ACTIONS(87),
  },
  [2697] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5143),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2704),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2704),
    [sym_assignment] = STATE(5143),
    [sym_operator_assignment] = STATE(5143),
    [sym_conditional] = STATE(5143),
    [sym_range] = STATE(5143),
    [sym_binary] = STATE(5143),
    [sym_unary] = STATE(5143),
    [sym_left_assignment_list] = STATE(2703),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2704),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2704),
    [sym_false] = STATE(2704),
    [sym_nil] = STATE(2704),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2584),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4573),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4393),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_break] = ACTIONS(4397),
    [anon_sym_next] = ACTIONS(4399),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4575),
    [anon_sym_defined_QMARK] = ACTIONS(4577),
    [anon_sym_not] = ACTIONS(4579),
    [anon_sym_BANG] = ACTIONS(4581),
    [anon_sym_TILDE] = ACTIONS(4581),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2698] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5144),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2704),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2704),
    [sym_assignment] = STATE(5144),
    [sym_operator_assignment] = STATE(5144),
    [sym_conditional] = STATE(5144),
    [sym_range] = STATE(5144),
    [sym_binary] = STATE(5144),
    [sym_unary] = STATE(5144),
    [sym_left_assignment_list] = STATE(2703),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2704),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2704),
    [sym_false] = STATE(2704),
    [sym_nil] = STATE(2704),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2584),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4573),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4393),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_break] = ACTIONS(4397),
    [anon_sym_next] = ACTIONS(4399),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4575),
    [anon_sym_defined_QMARK] = ACTIONS(4577),
    [anon_sym_not] = ACTIONS(4579),
    [anon_sym_BANG] = ACTIONS(4581),
    [anon_sym_TILDE] = ACTIONS(4581),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2699] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5145),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2704),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2704),
    [sym_assignment] = STATE(5145),
    [sym_operator_assignment] = STATE(5145),
    [sym_conditional] = STATE(5145),
    [sym_range] = STATE(5145),
    [sym_binary] = STATE(5145),
    [sym_unary] = STATE(5145),
    [sym_left_assignment_list] = STATE(2703),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2704),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2704),
    [sym_false] = STATE(2704),
    [sym_nil] = STATE(2704),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2584),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4573),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4393),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_break] = ACTIONS(4397),
    [anon_sym_next] = ACTIONS(4399),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4575),
    [anon_sym_defined_QMARK] = ACTIONS(4577),
    [anon_sym_not] = ACTIONS(4579),
    [anon_sym_BANG] = ACTIONS(4581),
    [anon_sym_TILDE] = ACTIONS(4581),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2700] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(298),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2704),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2704),
    [sym_assignment] = STATE(298),
    [sym_operator_assignment] = STATE(298),
    [sym_conditional] = STATE(298),
    [sym_range] = STATE(298),
    [sym_binary] = STATE(298),
    [sym_unary] = STATE(298),
    [sym_left_assignment_list] = STATE(2703),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2704),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2704),
    [sym_false] = STATE(2704),
    [sym_nil] = STATE(2704),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2584),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4573),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4393),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_break] = ACTIONS(4397),
    [anon_sym_next] = ACTIONS(4399),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4575),
    [anon_sym_defined_QMARK] = ACTIONS(4577),
    [anon_sym_not] = ACTIONS(4579),
    [anon_sym_BANG] = ACTIONS(4581),
    [anon_sym_TILDE] = ACTIONS(4581),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2701] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(8144),
    [sym__binary_star] = ACTIONS(8146),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(8148),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(8146),
    [anon_sym_AMP] = ACTIONS(8150),
    [anon_sym_LT] = ACTIONS(8152),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_then] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(8154),
    [anon_sym_DOT_DOT] = ACTIONS(8156),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8158),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(8160),
    [anon_sym_AMP_AMP] = ACTIONS(8160),
    [anon_sym_LT_LT] = ACTIONS(8162),
    [anon_sym_GT_GT] = ACTIONS(8162),
    [anon_sym_EQ_EQ] = ACTIONS(8164),
    [anon_sym_BANG_EQ] = ACTIONS(8160),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8160),
    [anon_sym_LT_EQ_GT] = ACTIONS(8160),
    [anon_sym_EQ_TILDE] = ACTIONS(8160),
    [anon_sym_BANG_TILDE] = ACTIONS(8160),
    [anon_sym_LT_EQ] = ACTIONS(8152),
    [anon_sym_GT] = ACTIONS(8152),
    [anon_sym_GT_EQ] = ACTIONS(8166),
    [anon_sym_CARET] = ACTIONS(8168),
    [anon_sym_PLUS] = ACTIONS(8144),
    [anon_sym_SLASH] = ACTIONS(8146),
    [anon_sym_PERCENT] = ACTIONS(8146),
    [sym_comment] = ACTIONS(87),
  },
  [2702] = {
    [aux_sym_exceptions_repeat1] = STATE(5157),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_COMMA] = ACTIONS(8170),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_then] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [2703] = {
    [anon_sym_EQ] = ACTIONS(8172),
    [sym_comment] = ACTIONS(87),
  },
  [2704] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(8174),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(8176),
    [anon_sym_DASH_EQ] = ACTIONS(8176),
    [anon_sym_STAR_EQ] = ACTIONS(8176),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8176),
    [anon_sym_SLASH_EQ] = ACTIONS(8176),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8176),
    [anon_sym_PIPE_EQ] = ACTIONS(8176),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8176),
    [anon_sym_AMP_EQ] = ACTIONS(8176),
    [anon_sym_PERCENT_EQ] = ACTIONS(8176),
    [anon_sym_GT_GT_EQ] = ACTIONS(8176),
    [anon_sym_LT_LT_EQ] = ACTIONS(8176),
    [anon_sym_CARET_EQ] = ACTIONS(8176),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2705] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(1755),
    [sym__binary_star] = ACTIONS(1757),
    [anon_sym_PIPE] = ACTIONS(1759),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(1757),
    [anon_sym_AMP] = ACTIONS(1761),
    [anon_sym_LT] = ACTIONS(1763),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_then] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(1765),
    [anon_sym_DOT_DOT] = ACTIONS(1767),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1769),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(1773),
    [anon_sym_AMP_AMP] = ACTIONS(1773),
    [anon_sym_LT_LT] = ACTIONS(1775),
    [anon_sym_GT_GT] = ACTIONS(1775),
    [anon_sym_EQ_EQ] = ACTIONS(1777),
    [anon_sym_BANG_EQ] = ACTIONS(1773),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1773),
    [anon_sym_LT_EQ_GT] = ACTIONS(1773),
    [anon_sym_EQ_TILDE] = ACTIONS(1773),
    [anon_sym_BANG_TILDE] = ACTIONS(1773),
    [anon_sym_LT_EQ] = ACTIONS(1763),
    [anon_sym_GT] = ACTIONS(1763),
    [anon_sym_GT_EQ] = ACTIONS(1779),
    [anon_sym_CARET] = ACTIONS(1781),
    [anon_sym_PLUS] = ACTIONS(1755),
    [anon_sym_SLASH] = ACTIONS(1757),
    [anon_sym_PERCENT] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
  },
  [2706] = {
    [sym_string] = STATE(2706),
    [aux_sym_chained_string_repeat1] = STATE(2706),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(6214),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_then] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [2707] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5160),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2719),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(2719),
    [sym_assignment] = STATE(5160),
    [sym_operator_assignment] = STATE(5160),
    [sym_conditional] = STATE(5160),
    [sym_range] = STATE(5160),
    [sym_binary] = STATE(5160),
    [sym_unary] = STATE(5160),
    [sym_left_assignment_list] = STATE(2718),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2719),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2719),
    [sym_false] = STATE(2719),
    [sym_nil] = STATE(2719),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2720),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4583),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4585),
    [anon_sym_yield] = ACTIONS(4587),
    [anon_sym_break] = ACTIONS(4589),
    [anon_sym_next] = ACTIONS(4591),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4593),
    [anon_sym_defined_QMARK] = ACTIONS(4595),
    [anon_sym_not] = ACTIONS(4597),
    [anon_sym_BANG] = ACTIONS(4599),
    [anon_sym_TILDE] = ACTIONS(4599),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2708] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5173),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5178),
    [sym_scope_resolution] = STATE(5174),
    [sym_call] = STATE(5174),
    [sym_method_call] = STATE(5178),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(5175),
    [sym__argument] = STATE(5176),
    [sym_splat_argument] = STATE(5176),
    [sym_hash_splat_argument] = STATE(5176),
    [sym_block_argument] = STATE(5176),
    [sym_assignment] = STATE(5173),
    [sym_operator_assignment] = STATE(5173),
    [sym_conditional] = STATE(5173),
    [sym_range] = STATE(5173),
    [sym_binary] = STATE(5173),
    [sym_unary] = STATE(5173),
    [sym_left_assignment_list] = STATE(5177),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5178),
    [sym__variable] = STATE(5174),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5178),
    [sym_false] = STATE(5178),
    [sym_nil] = STATE(5178),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5179),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5176),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(8178),
    [sym__splat_star] = ACTIONS(8180),
    [sym__unary_minus] = ACTIONS(8182),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(8184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(8186),
    [anon_sym_yield] = ACTIONS(8188),
    [anon_sym_break] = ACTIONS(8190),
    [anon_sym_next] = ACTIONS(8192),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(377),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(8194),
    [anon_sym_not] = ACTIONS(8196),
    [anon_sym_BANG] = ACTIONS(8198),
    [anon_sym_TILDE] = ACTIONS(8200),
    [sym_constant] = ACTIONS(8202),
    [sym_identifier] = ACTIONS(8202),
    [sym_instance_variable] = ACTIONS(8204),
    [sym_class_variable] = ACTIONS(8204),
    [sym_global_variable] = ACTIONS(8204),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8206),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8206),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2709] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5173),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5178),
    [sym_scope_resolution] = STATE(5174),
    [sym_call] = STATE(5174),
    [sym_method_call] = STATE(5178),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(5175),
    [sym__argument] = STATE(5176),
    [sym_splat_argument] = STATE(5176),
    [sym_hash_splat_argument] = STATE(5176),
    [sym_block_argument] = STATE(5176),
    [sym_assignment] = STATE(5173),
    [sym_operator_assignment] = STATE(5173),
    [sym_conditional] = STATE(5173),
    [sym_range] = STATE(5173),
    [sym_binary] = STATE(5173),
    [sym_unary] = STATE(5173),
    [sym_left_assignment_list] = STATE(5177),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5178),
    [sym__variable] = STATE(5174),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5178),
    [sym_false] = STATE(5178),
    [sym_nil] = STATE(5178),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5179),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5176),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(8178),
    [sym__splat_star] = ACTIONS(8180),
    [sym__unary_minus] = ACTIONS(8182),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(8184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(8186),
    [anon_sym_yield] = ACTIONS(8188),
    [anon_sym_break] = ACTIONS(8190),
    [anon_sym_next] = ACTIONS(8192),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(419),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(8194),
    [anon_sym_not] = ACTIONS(8196),
    [anon_sym_BANG] = ACTIONS(8198),
    [anon_sym_TILDE] = ACTIONS(8200),
    [sym_constant] = ACTIONS(8202),
    [sym_identifier] = ACTIONS(8202),
    [sym_instance_variable] = ACTIONS(8204),
    [sym_class_variable] = ACTIONS(8204),
    [sym_global_variable] = ACTIONS(8204),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8206),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8206),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2710] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5173),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5178),
    [sym_scope_resolution] = STATE(5174),
    [sym_call] = STATE(5174),
    [sym_method_call] = STATE(5178),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(5175),
    [sym__argument] = STATE(5176),
    [sym_splat_argument] = STATE(5176),
    [sym_hash_splat_argument] = STATE(5176),
    [sym_block_argument] = STATE(5176),
    [sym_assignment] = STATE(5173),
    [sym_operator_assignment] = STATE(5173),
    [sym_conditional] = STATE(5173),
    [sym_range] = STATE(5173),
    [sym_binary] = STATE(5173),
    [sym_unary] = STATE(5173),
    [sym_left_assignment_list] = STATE(5177),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5178),
    [sym__variable] = STATE(5174),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5178),
    [sym_false] = STATE(5178),
    [sym_nil] = STATE(5178),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5179),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5176),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(8178),
    [sym__splat_star] = ACTIONS(8180),
    [sym__unary_minus] = ACTIONS(8182),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(8184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(423),
    [anon_sym_return] = ACTIONS(8186),
    [anon_sym_yield] = ACTIONS(8188),
    [anon_sym_break] = ACTIONS(8190),
    [anon_sym_next] = ACTIONS(8192),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(423),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(8194),
    [anon_sym_not] = ACTIONS(8196),
    [anon_sym_BANG] = ACTIONS(8198),
    [anon_sym_TILDE] = ACTIONS(8200),
    [sym_constant] = ACTIONS(8202),
    [sym_identifier] = ACTIONS(8202),
    [sym_instance_variable] = ACTIONS(8204),
    [sym_class_variable] = ACTIONS(8204),
    [sym_global_variable] = ACTIONS(8204),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8206),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8206),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2711] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5173),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5178),
    [sym_scope_resolution] = STATE(5174),
    [sym_call] = STATE(5174),
    [sym_method_call] = STATE(5178),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(5175),
    [sym__argument] = STATE(5176),
    [sym_splat_argument] = STATE(5176),
    [sym_hash_splat_argument] = STATE(5176),
    [sym_block_argument] = STATE(5176),
    [sym_assignment] = STATE(5173),
    [sym_operator_assignment] = STATE(5173),
    [sym_conditional] = STATE(5173),
    [sym_range] = STATE(5173),
    [sym_binary] = STATE(5173),
    [sym_unary] = STATE(5173),
    [sym_left_assignment_list] = STATE(5177),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5178),
    [sym__variable] = STATE(5174),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5178),
    [sym_false] = STATE(5178),
    [sym_nil] = STATE(5178),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5179),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5176),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(8178),
    [sym__splat_star] = ACTIONS(8180),
    [sym__unary_minus] = ACTIONS(8182),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(8184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(427),
    [anon_sym_return] = ACTIONS(8186),
    [anon_sym_yield] = ACTIONS(8188),
    [anon_sym_break] = ACTIONS(8190),
    [anon_sym_next] = ACTIONS(8192),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(427),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(8194),
    [anon_sym_not] = ACTIONS(8196),
    [anon_sym_BANG] = ACTIONS(8198),
    [anon_sym_TILDE] = ACTIONS(8200),
    [sym_constant] = ACTIONS(8202),
    [sym_identifier] = ACTIONS(8202),
    [sym_instance_variable] = ACTIONS(8204),
    [sym_class_variable] = ACTIONS(8204),
    [sym_global_variable] = ACTIONS(8204),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8206),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8206),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2712] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5180),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2719),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(2719),
    [sym_assignment] = STATE(5180),
    [sym_operator_assignment] = STATE(5180),
    [sym_conditional] = STATE(5180),
    [sym_range] = STATE(5180),
    [sym_binary] = STATE(5180),
    [sym_unary] = STATE(5180),
    [sym_left_assignment_list] = STATE(2718),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2719),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2719),
    [sym_false] = STATE(2719),
    [sym_nil] = STATE(2719),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2720),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4583),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4585),
    [anon_sym_yield] = ACTIONS(4587),
    [anon_sym_break] = ACTIONS(4589),
    [anon_sym_next] = ACTIONS(4591),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4593),
    [anon_sym_defined_QMARK] = ACTIONS(4595),
    [anon_sym_not] = ACTIONS(4597),
    [anon_sym_BANG] = ACTIONS(4599),
    [anon_sym_TILDE] = ACTIONS(4599),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2713] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(298),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2719),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(2719),
    [sym_assignment] = STATE(298),
    [sym_operator_assignment] = STATE(298),
    [sym_conditional] = STATE(298),
    [sym_range] = STATE(298),
    [sym_binary] = STATE(298),
    [sym_unary] = STATE(298),
    [sym_left_assignment_list] = STATE(2718),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2719),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2719),
    [sym_false] = STATE(2719),
    [sym_nil] = STATE(2719),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2720),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4583),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4585),
    [anon_sym_yield] = ACTIONS(4587),
    [anon_sym_break] = ACTIONS(4589),
    [anon_sym_next] = ACTIONS(4591),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4593),
    [anon_sym_defined_QMARK] = ACTIONS(4595),
    [anon_sym_not] = ACTIONS(4597),
    [anon_sym_BANG] = ACTIONS(4599),
    [anon_sym_TILDE] = ACTIONS(4599),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2714] = {
    [sym_operator] = STATE(5181),
    [sym__method_name] = STATE(5181),
    [sym_setter] = STATE(5181),
    [sym_symbol] = STATE(5181),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(8208),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(8208),
    [sym_class_variable] = ACTIONS(8208),
    [sym_global_variable] = ACTIONS(8208),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [2715] = {
    [sym_heredoc_body] = STATE(370),
    [sym__terminator] = STATE(370),
    [sym__line_break] = ACTIONS(687),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(687),
    [anon_sym_end] = ACTIONS(689),
    [anon_sym_if] = ACTIONS(8210),
    [anon_sym_unless] = ACTIONS(8212),
    [anon_sym_while] = ACTIONS(8214),
    [anon_sym_until] = ACTIONS(8216),
    [anon_sym_rescue] = ACTIONS(8218),
    [anon_sym_else] = ACTIONS(689),
    [sym_comment] = ACTIONS(87),
  },
  [2716] = {
    [sym__line_break] = ACTIONS(701),
    [sym__heredoc_body_start] = ACTIONS(701),
    [sym__binary_minus] = ACTIONS(8220),
    [sym__binary_star] = ACTIONS(8222),
    [anon_sym_PIPE] = ACTIONS(8224),
    [anon_sym_SEMI] = ACTIONS(701),
    [anon_sym_STAR_STAR] = ACTIONS(8222),
    [anon_sym_AMP] = ACTIONS(8226),
    [anon_sym_LT] = ACTIONS(8228),
    [anon_sym_end] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_unless] = ACTIONS(701),
    [anon_sym_while] = ACTIONS(701),
    [anon_sym_until] = ACTIONS(701),
    [anon_sym_rescue] = ACTIONS(701),
    [anon_sym_else] = ACTIONS(701),
    [anon_sym_QMARK] = ACTIONS(8230),
    [anon_sym_DOT_DOT] = ACTIONS(8232),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8234),
    [anon_sym_and] = ACTIONS(8236),
    [anon_sym_or] = ACTIONS(8236),
    [anon_sym_PIPE_PIPE] = ACTIONS(8238),
    [anon_sym_AMP_AMP] = ACTIONS(8238),
    [anon_sym_LT_LT] = ACTIONS(8240),
    [anon_sym_GT_GT] = ACTIONS(8240),
    [anon_sym_EQ_EQ] = ACTIONS(8242),
    [anon_sym_BANG_EQ] = ACTIONS(8238),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8238),
    [anon_sym_LT_EQ_GT] = ACTIONS(8238),
    [anon_sym_EQ_TILDE] = ACTIONS(8238),
    [anon_sym_BANG_TILDE] = ACTIONS(8238),
    [anon_sym_LT_EQ] = ACTIONS(8228),
    [anon_sym_GT] = ACTIONS(8228),
    [anon_sym_GT_EQ] = ACTIONS(8244),
    [anon_sym_CARET] = ACTIONS(8246),
    [anon_sym_PLUS] = ACTIONS(8220),
    [anon_sym_SLASH] = ACTIONS(8222),
    [anon_sym_PERCENT] = ACTIONS(8222),
    [sym_comment] = ACTIONS(87),
  },
  [2717] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5209),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5214),
    [sym_scope_resolution] = STATE(5210),
    [sym_call] = STATE(5210),
    [sym_method_call] = STATE(5214),
    [sym_argument_list] = STATE(423),
    [sym__argument_list_with_parens] = STATE(5211),
    [sym__argument] = STATE(5212),
    [sym_splat_argument] = STATE(5212),
    [sym_hash_splat_argument] = STATE(5212),
    [sym_block_argument] = STATE(5212),
    [sym_do_block] = STATE(426),
    [sym_block] = STATE(426),
    [sym_assignment] = STATE(5209),
    [sym_operator_assignment] = STATE(5209),
    [sym_conditional] = STATE(5209),
    [sym_range] = STATE(5209),
    [sym_binary] = STATE(5209),
    [sym_unary] = STATE(5209),
    [sym_left_assignment_list] = STATE(5213),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5214),
    [sym__variable] = STATE(5210),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5214),
    [sym_false] = STATE(5214),
    [sym_nil] = STATE(5214),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5215),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(5212),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(743),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(8248),
    [sym__splat_star] = ACTIONS(8250),
    [sym__unary_minus] = ACTIONS(8252),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(8254),
    [anon_sym_LBRACE] = ACTIONS(771),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(769),
    [anon_sym_return] = ACTIONS(8256),
    [anon_sym_yield] = ACTIONS(8258),
    [anon_sym_break] = ACTIONS(8260),
    [anon_sym_next] = ACTIONS(8262),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(769),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(769),
    [anon_sym_until] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(769),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_else] = ACTIONS(769),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(8264),
    [anon_sym_not] = ACTIONS(8266),
    [anon_sym_BANG] = ACTIONS(8268),
    [anon_sym_TILDE] = ACTIONS(8270),
    [sym_constant] = ACTIONS(8272),
    [sym_identifier] = ACTIONS(8272),
    [sym_instance_variable] = ACTIONS(8274),
    [sym_class_variable] = ACTIONS(8274),
    [sym_global_variable] = ACTIONS(8274),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8276),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8276),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2718] = {
    [anon_sym_EQ] = ACTIONS(8278),
    [sym_comment] = ACTIONS(87),
  },
  [2719] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(8280),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(8282),
    [anon_sym_DASH_EQ] = ACTIONS(8282),
    [anon_sym_STAR_EQ] = ACTIONS(8282),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8282),
    [anon_sym_SLASH_EQ] = ACTIONS(8282),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8282),
    [anon_sym_PIPE_EQ] = ACTIONS(8282),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8282),
    [anon_sym_AMP_EQ] = ACTIONS(8282),
    [anon_sym_PERCENT_EQ] = ACTIONS(8282),
    [anon_sym_GT_GT_EQ] = ACTIONS(8282),
    [anon_sym_LT_LT_EQ] = ACTIONS(8282),
    [anon_sym_CARET_EQ] = ACTIONS(8282),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2720] = {
    [sym_string] = STATE(5218),
    [aux_sym_chained_string_repeat1] = STATE(5218),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2721] = {
    [sym_begin_block] = STATE(5219),
    [sym_end_block] = STATE(5219),
    [sym__statement] = STATE(5219),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(5219),
    [sym_unless_modifier] = STATE(5219),
    [sym_while_modifier] = STATE(5219),
    [sym_until_modifier] = STATE(5219),
    [sym_rescue_modifier] = STATE(5219),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2716),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2719),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(2719),
    [sym_assignment] = STATE(2716),
    [sym_operator_assignment] = STATE(2716),
    [sym_conditional] = STATE(2716),
    [sym_range] = STATE(2716),
    [sym_binary] = STATE(2716),
    [sym_unary] = STATE(2716),
    [sym_left_assignment_list] = STATE(2718),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2719),
    [sym__variable] = STATE(2717),
    [sym_undef] = STATE(5219),
    [sym_alias] = STATE(5219),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2719),
    [sym_false] = STATE(2719),
    [sym_nil] = STATE(2719),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2720),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(5220),
    [aux_sym__statements_repeat1] = STATE(5220),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4583),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(833),
    [anon_sym_return] = ACTIONS(4585),
    [anon_sym_yield] = ACTIONS(4587),
    [anon_sym_break] = ACTIONS(4589),
    [anon_sym_next] = ACTIONS(4591),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(833),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4593),
    [anon_sym_defined_QMARK] = ACTIONS(4595),
    [anon_sym_not] = ACTIONS(4597),
    [anon_sym_BANG] = ACTIONS(4599),
    [anon_sym_TILDE] = ACTIONS(4599),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [anon_sym_undef] = ACTIONS(4605),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2722] = {
    [sym__line_break] = ACTIONS(8284),
    [sym__heredoc_body_start] = ACTIONS(8284),
    [sym__binary_minus] = ACTIONS(8284),
    [sym__binary_star] = ACTIONS(8284),
    [ts_builtin_sym_end] = ACTIONS(8284),
    [anon_sym___END__] = ACTIONS(8284),
    [anon_sym_LBRACE] = ACTIONS(8284),
    [anon_sym_RBRACE] = ACTIONS(8284),
    [anon_sym_RPAREN] = ACTIONS(8284),
    [anon_sym_DOT] = ACTIONS(8286),
    [anon_sym_COMMA] = ACTIONS(8284),
    [anon_sym_PIPE] = ACTIONS(8286),
    [anon_sym_SEMI] = ACTIONS(8284),
    [anon_sym_STAR_STAR] = ACTIONS(8284),
    [anon_sym_AMP] = ACTIONS(8286),
    [anon_sym_LT] = ACTIONS(8286),
    [anon_sym_end] = ACTIONS(8284),
    [anon_sym_if] = ACTIONS(8284),
    [anon_sym_unless] = ACTIONS(8284),
    [anon_sym_while] = ACTIONS(8284),
    [anon_sym_until] = ACTIONS(8284),
    [anon_sym_rescue] = ACTIONS(8284),
    [anon_sym_do] = ACTIONS(8284),
    [anon_sym_when] = ACTIONS(8284),
    [anon_sym_elsif] = ACTIONS(8284),
    [anon_sym_else] = ACTIONS(8284),
    [anon_sym_then] = ACTIONS(8284),
    [anon_sym_ensure] = ACTIONS(8284),
    [anon_sym_EQ_GT] = ACTIONS(8284),
    [anon_sym_LBRACK] = ACTIONS(8284),
    [anon_sym_COLON_COLON2] = ACTIONS(8284),
    [anon_sym_AMP_DOT] = ACTIONS(8284),
    [anon_sym_QMARK] = ACTIONS(8284),
    [anon_sym_DOT_DOT] = ACTIONS(8286),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8284),
    [anon_sym_and] = ACTIONS(8284),
    [anon_sym_or] = ACTIONS(8284),
    [anon_sym_PIPE_PIPE] = ACTIONS(8284),
    [anon_sym_AMP_AMP] = ACTIONS(8284),
    [anon_sym_LT_LT] = ACTIONS(8284),
    [anon_sym_GT_GT] = ACTIONS(8284),
    [anon_sym_EQ_EQ] = ACTIONS(8286),
    [anon_sym_BANG_EQ] = ACTIONS(8284),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8284),
    [anon_sym_LT_EQ_GT] = ACTIONS(8284),
    [anon_sym_EQ_TILDE] = ACTIONS(8284),
    [anon_sym_BANG_TILDE] = ACTIONS(8284),
    [anon_sym_LT_EQ] = ACTIONS(8286),
    [anon_sym_GT] = ACTIONS(8286),
    [anon_sym_GT_EQ] = ACTIONS(8284),
    [anon_sym_CARET] = ACTIONS(8284),
    [anon_sym_PLUS] = ACTIONS(8284),
    [anon_sym_SLASH] = ACTIONS(8284),
    [anon_sym_PERCENT] = ACTIONS(8284),
    [sym_comment] = ACTIONS(87),
  },
  [2723] = {
    [anon_sym_end] = ACTIONS(8288),
    [sym_comment] = ACTIONS(87),
  },
  [2724] = {
    [sym__statements] = STATE(5106),
    [sym_begin_block] = STATE(2715),
    [sym_end_block] = STATE(2715),
    [sym__statement] = STATE(2715),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(2715),
    [sym_unless_modifier] = STATE(2715),
    [sym_while_modifier] = STATE(2715),
    [sym_until_modifier] = STATE(2715),
    [sym_rescue_modifier] = STATE(2715),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2716),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2719),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(2719),
    [sym_assignment] = STATE(2716),
    [sym_operator_assignment] = STATE(2716),
    [sym_conditional] = STATE(2716),
    [sym_range] = STATE(2716),
    [sym_binary] = STATE(2716),
    [sym_unary] = STATE(2716),
    [sym_left_assignment_list] = STATE(2718),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2719),
    [sym__variable] = STATE(2717),
    [sym_undef] = STATE(2715),
    [sym_alias] = STATE(2715),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2719),
    [sym_false] = STATE(2719),
    [sym_nil] = STATE(2719),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2720),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(2721),
    [aux_sym__statements_repeat1] = STATE(2721),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4583),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(8104),
    [anon_sym_return] = ACTIONS(4585),
    [anon_sym_yield] = ACTIONS(4587),
    [anon_sym_break] = ACTIONS(4589),
    [anon_sym_next] = ACTIONS(4591),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(8104),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4593),
    [anon_sym_defined_QMARK] = ACTIONS(4595),
    [anon_sym_not] = ACTIONS(4597),
    [anon_sym_BANG] = ACTIONS(4599),
    [anon_sym_TILDE] = ACTIONS(4599),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [anon_sym_undef] = ACTIONS(4605),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2725] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5222),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2734),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2734),
    [sym_assignment] = STATE(5222),
    [sym_operator_assignment] = STATE(5222),
    [sym_conditional] = STATE(5222),
    [sym_range] = STATE(5222),
    [sym_binary] = STATE(5222),
    [sym_unary] = STATE(5222),
    [sym_left_assignment_list] = STATE(2733),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2734),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2734),
    [sym_false] = STATE(2734),
    [sym_nil] = STATE(2734),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2735),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4613),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4615),
    [anon_sym_yield] = ACTIONS(4617),
    [anon_sym_break] = ACTIONS(4619),
    [anon_sym_next] = ACTIONS(4621),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4623),
    [anon_sym_defined_QMARK] = ACTIONS(4625),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_BANG] = ACTIONS(4629),
    [anon_sym_TILDE] = ACTIONS(4629),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2726] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1028),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1033),
    [sym_scope_resolution] = STATE(1029),
    [sym_call] = STATE(1029),
    [sym_method_call] = STATE(1033),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(5223),
    [sym__argument] = STATE(5224),
    [sym_splat_argument] = STATE(5224),
    [sym_hash_splat_argument] = STATE(5224),
    [sym_block_argument] = STATE(5224),
    [sym_assignment] = STATE(1028),
    [sym_operator_assignment] = STATE(1028),
    [sym_conditional] = STATE(1028),
    [sym_range] = STATE(1028),
    [sym_binary] = STATE(1028),
    [sym_unary] = STATE(1028),
    [sym_left_assignment_list] = STATE(1032),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1033),
    [sym__variable] = STATE(1029),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1033),
    [sym_false] = STATE(1033),
    [sym_nil] = STATE(1033),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1034),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5224),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(1823),
    [sym__splat_star] = ACTIONS(1825),
    [sym__unary_minus] = ACTIONS(1827),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(1829),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1831),
    [anon_sym_yield] = ACTIONS(1833),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_next] = ACTIONS(1837),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1845),
    [sym_constant] = ACTIONS(1847),
    [sym_identifier] = ACTIONS(1847),
    [sym_instance_variable] = ACTIONS(1849),
    [sym_class_variable] = ACTIONS(1849),
    [sym_global_variable] = ACTIONS(1849),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1851),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1851),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2727] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1028),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1033),
    [sym_scope_resolution] = STATE(1029),
    [sym_call] = STATE(1029),
    [sym_method_call] = STATE(1033),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(5223),
    [sym__argument] = STATE(5224),
    [sym_splat_argument] = STATE(5224),
    [sym_hash_splat_argument] = STATE(5224),
    [sym_block_argument] = STATE(5224),
    [sym_assignment] = STATE(1028),
    [sym_operator_assignment] = STATE(1028),
    [sym_conditional] = STATE(1028),
    [sym_range] = STATE(1028),
    [sym_binary] = STATE(1028),
    [sym_unary] = STATE(1028),
    [sym_left_assignment_list] = STATE(1032),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1033),
    [sym__variable] = STATE(1029),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1033),
    [sym_false] = STATE(1033),
    [sym_nil] = STATE(1033),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1034),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5224),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(1823),
    [sym__splat_star] = ACTIONS(1825),
    [sym__unary_minus] = ACTIONS(1827),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(1829),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1831),
    [anon_sym_yield] = ACTIONS(1833),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_next] = ACTIONS(1837),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1845),
    [sym_constant] = ACTIONS(1847),
    [sym_identifier] = ACTIONS(1847),
    [sym_instance_variable] = ACTIONS(1849),
    [sym_class_variable] = ACTIONS(1849),
    [sym_global_variable] = ACTIONS(1849),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1851),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1851),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2728] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1028),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1033),
    [sym_scope_resolution] = STATE(1029),
    [sym_call] = STATE(1029),
    [sym_method_call] = STATE(1033),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(5223),
    [sym__argument] = STATE(5224),
    [sym_splat_argument] = STATE(5224),
    [sym_hash_splat_argument] = STATE(5224),
    [sym_block_argument] = STATE(5224),
    [sym_assignment] = STATE(1028),
    [sym_operator_assignment] = STATE(1028),
    [sym_conditional] = STATE(1028),
    [sym_range] = STATE(1028),
    [sym_binary] = STATE(1028),
    [sym_unary] = STATE(1028),
    [sym_left_assignment_list] = STATE(1032),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1033),
    [sym__variable] = STATE(1029),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1033),
    [sym_false] = STATE(1033),
    [sym_nil] = STATE(1033),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1034),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5224),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(1823),
    [sym__splat_star] = ACTIONS(1825),
    [sym__unary_minus] = ACTIONS(1827),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(1829),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1831),
    [anon_sym_yield] = ACTIONS(1833),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_next] = ACTIONS(1837),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1845),
    [sym_constant] = ACTIONS(1847),
    [sym_identifier] = ACTIONS(1847),
    [sym_instance_variable] = ACTIONS(1849),
    [sym_class_variable] = ACTIONS(1849),
    [sym_global_variable] = ACTIONS(1849),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1851),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1851),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2729] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1028),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1033),
    [sym_scope_resolution] = STATE(1029),
    [sym_call] = STATE(1029),
    [sym_method_call] = STATE(1033),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(5223),
    [sym__argument] = STATE(5224),
    [sym_splat_argument] = STATE(5224),
    [sym_hash_splat_argument] = STATE(5224),
    [sym_block_argument] = STATE(5224),
    [sym_assignment] = STATE(1028),
    [sym_operator_assignment] = STATE(1028),
    [sym_conditional] = STATE(1028),
    [sym_range] = STATE(1028),
    [sym_binary] = STATE(1028),
    [sym_unary] = STATE(1028),
    [sym_left_assignment_list] = STATE(1032),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1033),
    [sym__variable] = STATE(1029),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1033),
    [sym_false] = STATE(1033),
    [sym_nil] = STATE(1033),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1034),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5224),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(1823),
    [sym__splat_star] = ACTIONS(1825),
    [sym__unary_minus] = ACTIONS(1827),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(1829),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1831),
    [anon_sym_yield] = ACTIONS(1833),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_next] = ACTIONS(1837),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1845),
    [sym_constant] = ACTIONS(1847),
    [sym_identifier] = ACTIONS(1847),
    [sym_instance_variable] = ACTIONS(1849),
    [sym_class_variable] = ACTIONS(1849),
    [sym_global_variable] = ACTIONS(1849),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1851),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1851),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2730] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5225),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2734),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2734),
    [sym_assignment] = STATE(5225),
    [sym_operator_assignment] = STATE(5225),
    [sym_conditional] = STATE(5225),
    [sym_range] = STATE(5225),
    [sym_binary] = STATE(5225),
    [sym_unary] = STATE(5225),
    [sym_left_assignment_list] = STATE(2733),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2734),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2734),
    [sym_false] = STATE(2734),
    [sym_nil] = STATE(2734),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2735),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4613),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4615),
    [anon_sym_yield] = ACTIONS(4617),
    [anon_sym_break] = ACTIONS(4619),
    [anon_sym_next] = ACTIONS(4621),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4623),
    [anon_sym_defined_QMARK] = ACTIONS(4625),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_BANG] = ACTIONS(4629),
    [anon_sym_TILDE] = ACTIONS(4629),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2731] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2734),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2734),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(2733),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2734),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2734),
    [sym_false] = STATE(2734),
    [sym_nil] = STATE(2734),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2735),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4613),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4615),
    [anon_sym_yield] = ACTIONS(4617),
    [anon_sym_break] = ACTIONS(4619),
    [anon_sym_next] = ACTIONS(4621),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4623),
    [anon_sym_defined_QMARK] = ACTIONS(4625),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_BANG] = ACTIONS(4629),
    [anon_sym_TILDE] = ACTIONS(4629),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2732] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(8290),
    [sym__binary_star] = ACTIONS(8292),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(8294),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(8292),
    [anon_sym_AMP] = ACTIONS(8296),
    [anon_sym_LT] = ACTIONS(8298),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(8300),
    [anon_sym_DOT_DOT] = ACTIONS(8302),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8304),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(8306),
    [anon_sym_AMP_AMP] = ACTIONS(8306),
    [anon_sym_LT_LT] = ACTIONS(8308),
    [anon_sym_GT_GT] = ACTIONS(8308),
    [anon_sym_EQ_EQ] = ACTIONS(8310),
    [anon_sym_BANG_EQ] = ACTIONS(8306),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8306),
    [anon_sym_LT_EQ_GT] = ACTIONS(8306),
    [anon_sym_EQ_TILDE] = ACTIONS(8306),
    [anon_sym_BANG_TILDE] = ACTIONS(8306),
    [anon_sym_LT_EQ] = ACTIONS(8298),
    [anon_sym_GT] = ACTIONS(8298),
    [anon_sym_GT_EQ] = ACTIONS(8312),
    [anon_sym_CARET] = ACTIONS(8314),
    [anon_sym_PLUS] = ACTIONS(8290),
    [anon_sym_SLASH] = ACTIONS(8292),
    [anon_sym_PERCENT] = ACTIONS(8292),
    [sym_comment] = ACTIONS(87),
  },
  [2733] = {
    [anon_sym_EQ] = ACTIONS(8316),
    [sym_comment] = ACTIONS(87),
  },
  [2734] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(8318),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(8320),
    [anon_sym_DASH_EQ] = ACTIONS(8320),
    [anon_sym_STAR_EQ] = ACTIONS(8320),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8320),
    [anon_sym_SLASH_EQ] = ACTIONS(8320),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8320),
    [anon_sym_PIPE_EQ] = ACTIONS(8320),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8320),
    [anon_sym_AMP_EQ] = ACTIONS(8320),
    [anon_sym_PERCENT_EQ] = ACTIONS(8320),
    [anon_sym_GT_GT_EQ] = ACTIONS(8320),
    [anon_sym_LT_LT_EQ] = ACTIONS(8320),
    [anon_sym_CARET_EQ] = ACTIONS(8320),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2735] = {
    [sym_string] = STATE(5238),
    [aux_sym_chained_string_repeat1] = STATE(5238),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2736] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(8290),
    [sym__binary_star] = ACTIONS(8292),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(8294),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(8292),
    [anon_sym_AMP] = ACTIONS(8296),
    [anon_sym_LT] = ACTIONS(8298),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(8300),
    [anon_sym_DOT_DOT] = ACTIONS(8302),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8304),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(8306),
    [anon_sym_AMP_AMP] = ACTIONS(8306),
    [anon_sym_LT_LT] = ACTIONS(8308),
    [anon_sym_GT_GT] = ACTIONS(8308),
    [anon_sym_EQ_EQ] = ACTIONS(8310),
    [anon_sym_BANG_EQ] = ACTIONS(8306),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8306),
    [anon_sym_LT_EQ_GT] = ACTIONS(8306),
    [anon_sym_EQ_TILDE] = ACTIONS(8306),
    [anon_sym_BANG_TILDE] = ACTIONS(8306),
    [anon_sym_LT_EQ] = ACTIONS(8298),
    [anon_sym_GT] = ACTIONS(8298),
    [anon_sym_GT_EQ] = ACTIONS(8312),
    [anon_sym_CARET] = ACTIONS(8314),
    [anon_sym_PLUS] = ACTIONS(8290),
    [anon_sym_SLASH] = ACTIONS(8292),
    [anon_sym_PERCENT] = ACTIONS(8292),
    [sym_comment] = ACTIONS(87),
  },
  [2737] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(4647),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [2738] = {
    [sym_string] = STATE(2777),
    [aux_sym_chained_string_repeat1] = STATE(2777),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2739] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5239),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2734),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2734),
    [sym_assignment] = STATE(5239),
    [sym_operator_assignment] = STATE(5239),
    [sym_conditional] = STATE(5239),
    [sym_range] = STATE(5239),
    [sym_binary] = STATE(5239),
    [sym_unary] = STATE(5239),
    [sym_left_assignment_list] = STATE(2733),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2734),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2734),
    [sym_false] = STATE(2734),
    [sym_nil] = STATE(2734),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2735),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4613),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4615),
    [anon_sym_yield] = ACTIONS(4617),
    [anon_sym_break] = ACTIONS(4619),
    [anon_sym_next] = ACTIONS(4621),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4623),
    [anon_sym_defined_QMARK] = ACTIONS(4625),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_BANG] = ACTIONS(4629),
    [anon_sym_TILDE] = ACTIONS(4629),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2740] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(8290),
    [sym__binary_star] = ACTIONS(8292),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(8294),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(8292),
    [anon_sym_AMP] = ACTIONS(8296),
    [anon_sym_LT] = ACTIONS(8298),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(8300),
    [anon_sym_DOT_DOT] = ACTIONS(8302),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8304),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(8306),
    [anon_sym_AMP_AMP] = ACTIONS(8306),
    [anon_sym_LT_LT] = ACTIONS(8308),
    [anon_sym_GT_GT] = ACTIONS(8308),
    [anon_sym_EQ_EQ] = ACTIONS(8310),
    [anon_sym_BANG_EQ] = ACTIONS(8306),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8306),
    [anon_sym_LT_EQ_GT] = ACTIONS(8306),
    [anon_sym_EQ_TILDE] = ACTIONS(8306),
    [anon_sym_BANG_TILDE] = ACTIONS(8306),
    [anon_sym_LT_EQ] = ACTIONS(8298),
    [anon_sym_GT] = ACTIONS(8298),
    [anon_sym_GT_EQ] = ACTIONS(8312),
    [anon_sym_CARET] = ACTIONS(8314),
    [anon_sym_PLUS] = ACTIONS(8290),
    [anon_sym_SLASH] = ACTIONS(8292),
    [anon_sym_PERCENT] = ACTIONS(8292),
    [sym_comment] = ACTIONS(87),
  },
  [2741] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5240),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1033),
    [sym_scope_resolution] = STATE(1029),
    [sym_call] = STATE(1029),
    [sym_method_call] = STATE(1033),
    [sym_assignment] = STATE(5240),
    [sym_operator_assignment] = STATE(5240),
    [sym_conditional] = STATE(5240),
    [sym_range] = STATE(5240),
    [sym_binary] = STATE(5240),
    [sym_unary] = STATE(5240),
    [sym_left_assignment_list] = STATE(1032),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1033),
    [sym__variable] = STATE(1029),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1033),
    [sym_false] = STATE(1033),
    [sym_nil] = STATE(1033),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2738),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1827),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1831),
    [anon_sym_yield] = ACTIONS(1833),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_next] = ACTIONS(1837),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4631),
    [anon_sym_defined_QMARK] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1845),
    [anon_sym_TILDE] = ACTIONS(1845),
    [sym_constant] = ACTIONS(1851),
    [sym_identifier] = ACTIONS(1851),
    [sym_instance_variable] = ACTIONS(1849),
    [sym_class_variable] = ACTIONS(1849),
    [sym_global_variable] = ACTIONS(1849),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1851),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1851),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2742] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5241),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1033),
    [sym_scope_resolution] = STATE(1029),
    [sym_call] = STATE(1029),
    [sym_method_call] = STATE(1033),
    [sym_assignment] = STATE(5241),
    [sym_operator_assignment] = STATE(5241),
    [sym_conditional] = STATE(5241),
    [sym_range] = STATE(5241),
    [sym_binary] = STATE(5241),
    [sym_unary] = STATE(5241),
    [sym_left_assignment_list] = STATE(1032),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1033),
    [sym__variable] = STATE(1029),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1033),
    [sym_false] = STATE(1033),
    [sym_nil] = STATE(1033),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2738),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1827),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1831),
    [anon_sym_yield] = ACTIONS(1833),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_next] = ACTIONS(1837),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4631),
    [anon_sym_defined_QMARK] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1845),
    [anon_sym_TILDE] = ACTIONS(1845),
    [sym_constant] = ACTIONS(1851),
    [sym_identifier] = ACTIONS(1851),
    [sym_instance_variable] = ACTIONS(1849),
    [sym_class_variable] = ACTIONS(1849),
    [sym_global_variable] = ACTIONS(1849),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1851),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1851),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2743] = {
    [anon_sym_COLON] = ACTIONS(8322),
    [sym_comment] = ACTIONS(87),
  },
  [2744] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5243),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1033),
    [sym_scope_resolution] = STATE(1029),
    [sym_call] = STATE(1029),
    [sym_method_call] = STATE(1033),
    [sym_assignment] = STATE(5243),
    [sym_operator_assignment] = STATE(5243),
    [sym_conditional] = STATE(5243),
    [sym_range] = STATE(5243),
    [sym_binary] = STATE(5243),
    [sym_unary] = STATE(5243),
    [sym_left_assignment_list] = STATE(1032),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1033),
    [sym__variable] = STATE(1029),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1033),
    [sym_false] = STATE(1033),
    [sym_nil] = STATE(1033),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2738),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1827),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1831),
    [anon_sym_yield] = ACTIONS(1833),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_next] = ACTIONS(1837),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4631),
    [anon_sym_defined_QMARK] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1845),
    [anon_sym_TILDE] = ACTIONS(1845),
    [sym_constant] = ACTIONS(1851),
    [sym_identifier] = ACTIONS(1851),
    [sym_instance_variable] = ACTIONS(1849),
    [sym_class_variable] = ACTIONS(1849),
    [sym_global_variable] = ACTIONS(1849),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1851),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1851),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2745] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(8324),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [2746] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(4645),
    [sym__binary_star] = ACTIONS(4647),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(4649),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(4647),
    [anon_sym_AMP] = ACTIONS(4651),
    [anon_sym_LT] = ACTIONS(4653),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(1625),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(4655),
    [anon_sym_DOT_DOT] = ACTIONS(4657),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4659),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(4661),
    [anon_sym_AMP_AMP] = ACTIONS(4661),
    [anon_sym_LT_LT] = ACTIONS(4663),
    [anon_sym_GT_GT] = ACTIONS(4663),
    [anon_sym_EQ_EQ] = ACTIONS(4665),
    [anon_sym_BANG_EQ] = ACTIONS(4661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4661),
    [anon_sym_LT_EQ_GT] = ACTIONS(4661),
    [anon_sym_EQ_TILDE] = ACTIONS(4661),
    [anon_sym_BANG_TILDE] = ACTIONS(4661),
    [anon_sym_LT_EQ] = ACTIONS(4653),
    [anon_sym_GT] = ACTIONS(4653),
    [anon_sym_GT_EQ] = ACTIONS(4667),
    [anon_sym_CARET] = ACTIONS(4669),
    [anon_sym_PLUS] = ACTIONS(4645),
    [anon_sym_SLASH] = ACTIONS(4647),
    [anon_sym_PERCENT] = ACTIONS(4647),
    [sym_comment] = ACTIONS(87),
  },
  [2747] = {
    [sym_heredoc_body] = STATE(5245),
    [aux_sym_call_repeat1] = STATE(5245),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [2748] = {
    [sym_heredoc_body] = STATE(5245),
    [aux_sym_call_repeat1] = STATE(5245),
    [aux_sym_argument_list_repeat1] = STATE(5247),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(8326),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [2749] = {
    [sym_string] = STATE(2777),
    [aux_sym_chained_string_repeat1] = STATE(2777),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(8328),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2750] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(4645),
    [sym__binary_star] = ACTIONS(4647),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(4649),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(4647),
    [anon_sym_AMP] = ACTIONS(4651),
    [anon_sym_LT] = ACTIONS(4653),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(4655),
    [anon_sym_DOT_DOT] = ACTIONS(4657),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4659),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(4661),
    [anon_sym_AMP_AMP] = ACTIONS(4661),
    [anon_sym_LT_LT] = ACTIONS(4663),
    [anon_sym_GT_GT] = ACTIONS(4663),
    [anon_sym_EQ_EQ] = ACTIONS(4665),
    [anon_sym_BANG_EQ] = ACTIONS(4661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4661),
    [anon_sym_LT_EQ_GT] = ACTIONS(4661),
    [anon_sym_EQ_TILDE] = ACTIONS(4661),
    [anon_sym_BANG_TILDE] = ACTIONS(4661),
    [anon_sym_LT_EQ] = ACTIONS(4653),
    [anon_sym_GT] = ACTIONS(4653),
    [anon_sym_GT_EQ] = ACTIONS(4667),
    [anon_sym_CARET] = ACTIONS(4669),
    [anon_sym_PLUS] = ACTIONS(4645),
    [anon_sym_SLASH] = ACTIONS(4647),
    [anon_sym_PERCENT] = ACTIONS(4647),
    [sym_comment] = ACTIONS(87),
  },
  [2751] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5248),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2734),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2734),
    [sym_assignment] = STATE(5248),
    [sym_operator_assignment] = STATE(5248),
    [sym_conditional] = STATE(5248),
    [sym_range] = STATE(5248),
    [sym_binary] = STATE(5248),
    [sym_unary] = STATE(5248),
    [sym_left_assignment_list] = STATE(2733),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2734),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2734),
    [sym_false] = STATE(2734),
    [sym_nil] = STATE(2734),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2735),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4613),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4615),
    [anon_sym_yield] = ACTIONS(4617),
    [anon_sym_break] = ACTIONS(4619),
    [anon_sym_next] = ACTIONS(4621),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4623),
    [anon_sym_defined_QMARK] = ACTIONS(4625),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_BANG] = ACTIONS(4629),
    [anon_sym_TILDE] = ACTIONS(4629),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2752] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5249),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1033),
    [sym_scope_resolution] = STATE(1029),
    [sym_call] = STATE(1029),
    [sym_method_call] = STATE(1033),
    [sym_assignment] = STATE(5249),
    [sym_operator_assignment] = STATE(5249),
    [sym_conditional] = STATE(5249),
    [sym_range] = STATE(5249),
    [sym_binary] = STATE(5249),
    [sym_unary] = STATE(5249),
    [sym_left_assignment_list] = STATE(1032),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1033),
    [sym__variable] = STATE(1029),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1033),
    [sym_false] = STATE(1033),
    [sym_nil] = STATE(1033),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2738),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1827),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1831),
    [anon_sym_yield] = ACTIONS(1833),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_next] = ACTIONS(1837),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4631),
    [anon_sym_defined_QMARK] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1845),
    [anon_sym_TILDE] = ACTIONS(1845),
    [sym_constant] = ACTIONS(1851),
    [sym_identifier] = ACTIONS(1851),
    [sym_instance_variable] = ACTIONS(1849),
    [sym_class_variable] = ACTIONS(1849),
    [sym_global_variable] = ACTIONS(1849),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1851),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1851),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2753] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5250),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1033),
    [sym_scope_resolution] = STATE(1029),
    [sym_call] = STATE(1029),
    [sym_method_call] = STATE(1033),
    [sym_assignment] = STATE(5250),
    [sym_operator_assignment] = STATE(5250),
    [sym_conditional] = STATE(5250),
    [sym_range] = STATE(5250),
    [sym_binary] = STATE(5250),
    [sym_unary] = STATE(5250),
    [sym_left_assignment_list] = STATE(1032),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1033),
    [sym__variable] = STATE(1029),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1033),
    [sym_false] = STATE(1033),
    [sym_nil] = STATE(1033),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2738),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1827),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1831),
    [anon_sym_yield] = ACTIONS(1833),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_next] = ACTIONS(1837),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4631),
    [anon_sym_defined_QMARK] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1845),
    [anon_sym_TILDE] = ACTIONS(1845),
    [sym_constant] = ACTIONS(1851),
    [sym_identifier] = ACTIONS(1851),
    [sym_instance_variable] = ACTIONS(1849),
    [sym_class_variable] = ACTIONS(1849),
    [sym_global_variable] = ACTIONS(1849),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1851),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1851),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2754] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5251),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1033),
    [sym_scope_resolution] = STATE(1029),
    [sym_call] = STATE(1029),
    [sym_method_call] = STATE(1033),
    [sym_assignment] = STATE(5251),
    [sym_operator_assignment] = STATE(5251),
    [sym_conditional] = STATE(5251),
    [sym_range] = STATE(5251),
    [sym_binary] = STATE(5251),
    [sym_unary] = STATE(5251),
    [sym_left_assignment_list] = STATE(1032),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1033),
    [sym__variable] = STATE(1029),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1033),
    [sym_false] = STATE(1033),
    [sym_nil] = STATE(1033),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2738),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1827),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1831),
    [anon_sym_yield] = ACTIONS(1833),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_next] = ACTIONS(1837),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4631),
    [anon_sym_defined_QMARK] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1845),
    [anon_sym_TILDE] = ACTIONS(1845),
    [sym_constant] = ACTIONS(1851),
    [sym_identifier] = ACTIONS(1851),
    [sym_instance_variable] = ACTIONS(1849),
    [sym_class_variable] = ACTIONS(1849),
    [sym_global_variable] = ACTIONS(1849),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1851),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1851),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2755] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5252),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1033),
    [sym_scope_resolution] = STATE(1029),
    [sym_call] = STATE(1029),
    [sym_method_call] = STATE(1033),
    [sym_assignment] = STATE(5252),
    [sym_operator_assignment] = STATE(5252),
    [sym_conditional] = STATE(5252),
    [sym_range] = STATE(5252),
    [sym_binary] = STATE(5252),
    [sym_unary] = STATE(5252),
    [sym_left_assignment_list] = STATE(1032),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1033),
    [sym__variable] = STATE(1029),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1033),
    [sym_false] = STATE(1033),
    [sym_nil] = STATE(1033),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2738),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1827),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1831),
    [anon_sym_yield] = ACTIONS(1833),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_next] = ACTIONS(1837),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4631),
    [anon_sym_defined_QMARK] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1845),
    [anon_sym_TILDE] = ACTIONS(1845),
    [sym_constant] = ACTIONS(1851),
    [sym_identifier] = ACTIONS(1851),
    [sym_instance_variable] = ACTIONS(1849),
    [sym_class_variable] = ACTIONS(1849),
    [sym_global_variable] = ACTIONS(1849),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1851),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1851),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2756] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5253),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1033),
    [sym_scope_resolution] = STATE(1029),
    [sym_call] = STATE(1029),
    [sym_method_call] = STATE(1033),
    [sym_assignment] = STATE(5253),
    [sym_operator_assignment] = STATE(5253),
    [sym_conditional] = STATE(5253),
    [sym_range] = STATE(5253),
    [sym_binary] = STATE(5253),
    [sym_unary] = STATE(5253),
    [sym_left_assignment_list] = STATE(1032),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1033),
    [sym__variable] = STATE(1029),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1033),
    [sym_false] = STATE(1033),
    [sym_nil] = STATE(1033),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2738),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1827),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1831),
    [anon_sym_yield] = ACTIONS(1833),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_next] = ACTIONS(1837),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4631),
    [anon_sym_defined_QMARK] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1845),
    [anon_sym_TILDE] = ACTIONS(1845),
    [sym_constant] = ACTIONS(1851),
    [sym_identifier] = ACTIONS(1851),
    [sym_instance_variable] = ACTIONS(1849),
    [sym_class_variable] = ACTIONS(1849),
    [sym_global_variable] = ACTIONS(1849),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1851),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1851),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2757] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(5254),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(5254),
    [sym_operator_assignment] = STATE(5254),
    [sym_conditional] = STATE(5254),
    [sym_range] = STATE(5254),
    [sym_binary] = STATE(5254),
    [sym_unary] = STATE(5254),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2758] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5255),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1033),
    [sym_scope_resolution] = STATE(1029),
    [sym_call] = STATE(1029),
    [sym_method_call] = STATE(1033),
    [sym_assignment] = STATE(5255),
    [sym_operator_assignment] = STATE(5255),
    [sym_conditional] = STATE(5255),
    [sym_range] = STATE(5255),
    [sym_binary] = STATE(5255),
    [sym_unary] = STATE(5255),
    [sym_left_assignment_list] = STATE(1032),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1033),
    [sym__variable] = STATE(1029),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1033),
    [sym_false] = STATE(1033),
    [sym_nil] = STATE(1033),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2738),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1827),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1831),
    [anon_sym_yield] = ACTIONS(1833),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_next] = ACTIONS(1837),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4631),
    [anon_sym_defined_QMARK] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1845),
    [anon_sym_TILDE] = ACTIONS(1845),
    [sym_constant] = ACTIONS(1851),
    [sym_identifier] = ACTIONS(1851),
    [sym_instance_variable] = ACTIONS(1849),
    [sym_class_variable] = ACTIONS(1849),
    [sym_global_variable] = ACTIONS(1849),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1851),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1851),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2759] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5256),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1033),
    [sym_scope_resolution] = STATE(1029),
    [sym_call] = STATE(1029),
    [sym_method_call] = STATE(1033),
    [sym_assignment] = STATE(5256),
    [sym_operator_assignment] = STATE(5256),
    [sym_conditional] = STATE(5256),
    [sym_range] = STATE(5256),
    [sym_binary] = STATE(5256),
    [sym_unary] = STATE(5256),
    [sym_left_assignment_list] = STATE(1032),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1033),
    [sym__variable] = STATE(1029),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1033),
    [sym_false] = STATE(1033),
    [sym_nil] = STATE(1033),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2738),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1827),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1831),
    [anon_sym_yield] = ACTIONS(1833),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_next] = ACTIONS(1837),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4631),
    [anon_sym_defined_QMARK] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1845),
    [anon_sym_TILDE] = ACTIONS(1845),
    [sym_constant] = ACTIONS(1851),
    [sym_identifier] = ACTIONS(1851),
    [sym_instance_variable] = ACTIONS(1849),
    [sym_class_variable] = ACTIONS(1849),
    [sym_global_variable] = ACTIONS(1849),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1851),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1851),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2760] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5257),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1033),
    [sym_scope_resolution] = STATE(1029),
    [sym_call] = STATE(1029),
    [sym_method_call] = STATE(1033),
    [sym_assignment] = STATE(5257),
    [sym_operator_assignment] = STATE(5257),
    [sym_conditional] = STATE(5257),
    [sym_range] = STATE(5257),
    [sym_binary] = STATE(5257),
    [sym_unary] = STATE(5257),
    [sym_left_assignment_list] = STATE(1032),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1033),
    [sym__variable] = STATE(1029),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1033),
    [sym_false] = STATE(1033),
    [sym_nil] = STATE(1033),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2738),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1827),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1831),
    [anon_sym_yield] = ACTIONS(1833),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_next] = ACTIONS(1837),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4631),
    [anon_sym_defined_QMARK] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1845),
    [anon_sym_TILDE] = ACTIONS(1845),
    [sym_constant] = ACTIONS(1851),
    [sym_identifier] = ACTIONS(1851),
    [sym_instance_variable] = ACTIONS(1849),
    [sym_class_variable] = ACTIONS(1849),
    [sym_global_variable] = ACTIONS(1849),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1851),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1851),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2761] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5258),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1033),
    [sym_scope_resolution] = STATE(1029),
    [sym_call] = STATE(1029),
    [sym_method_call] = STATE(1033),
    [sym_assignment] = STATE(5258),
    [sym_operator_assignment] = STATE(5258),
    [sym_conditional] = STATE(5258),
    [sym_range] = STATE(5258),
    [sym_binary] = STATE(5258),
    [sym_unary] = STATE(5258),
    [sym_left_assignment_list] = STATE(1032),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1033),
    [sym__variable] = STATE(1029),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1033),
    [sym_false] = STATE(1033),
    [sym_nil] = STATE(1033),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2738),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1827),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1831),
    [anon_sym_yield] = ACTIONS(1833),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_next] = ACTIONS(1837),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4631),
    [anon_sym_defined_QMARK] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1845),
    [anon_sym_TILDE] = ACTIONS(1845),
    [sym_constant] = ACTIONS(1851),
    [sym_identifier] = ACTIONS(1851),
    [sym_instance_variable] = ACTIONS(1849),
    [sym_class_variable] = ACTIONS(1849),
    [sym_global_variable] = ACTIONS(1849),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1851),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1851),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2762] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5259),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1066),
    [sym_scope_resolution] = STATE(1061),
    [sym_call] = STATE(1061),
    [sym_method_call] = STATE(1066),
    [sym_assignment] = STATE(5259),
    [sym_operator_assignment] = STATE(5259),
    [sym_conditional] = STATE(5259),
    [sym_range] = STATE(5259),
    [sym_binary] = STATE(5259),
    [sym_unary] = STATE(5259),
    [sym_left_assignment_list] = STATE(1065),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1066),
    [sym__variable] = STATE(1061),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1066),
    [sym_false] = STATE(1066),
    [sym_nil] = STATE(1066),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2804),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1895),
    [anon_sym_break] = ACTIONS(1897),
    [anon_sym_next] = ACTIONS(1899),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(4715),
    [anon_sym_defined_QMARK] = ACTIONS(1909),
    [anon_sym_not] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1915),
    [anon_sym_TILDE] = ACTIONS(1915),
    [sym_constant] = ACTIONS(1921),
    [sym_identifier] = ACTIONS(1921),
    [sym_instance_variable] = ACTIONS(1919),
    [sym_class_variable] = ACTIONS(1919),
    [sym_global_variable] = ACTIONS(1919),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1921),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1921),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2763] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5260),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1066),
    [sym_scope_resolution] = STATE(1061),
    [sym_call] = STATE(1061),
    [sym_method_call] = STATE(1066),
    [sym_assignment] = STATE(5260),
    [sym_operator_assignment] = STATE(5260),
    [sym_conditional] = STATE(5260),
    [sym_range] = STATE(5260),
    [sym_binary] = STATE(5260),
    [sym_unary] = STATE(5260),
    [sym_left_assignment_list] = STATE(1065),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1066),
    [sym__variable] = STATE(1061),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1066),
    [sym_false] = STATE(1066),
    [sym_nil] = STATE(1066),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2804),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1895),
    [anon_sym_break] = ACTIONS(1897),
    [anon_sym_next] = ACTIONS(1899),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(4715),
    [anon_sym_defined_QMARK] = ACTIONS(1909),
    [anon_sym_not] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1915),
    [anon_sym_TILDE] = ACTIONS(1915),
    [sym_constant] = ACTIONS(1921),
    [sym_identifier] = ACTIONS(1921),
    [sym_instance_variable] = ACTIONS(1919),
    [sym_class_variable] = ACTIONS(1919),
    [sym_global_variable] = ACTIONS(1919),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1921),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1921),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2764] = {
    [anon_sym_COLON] = ACTIONS(8330),
    [sym_comment] = ACTIONS(87),
  },
  [2765] = {
    [sym__statements] = STATE(2546),
    [sym_begin_block] = STATE(489),
    [sym_end_block] = STATE(489),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_block_parameters] = STATE(2547),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1516),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1519),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1519),
    [sym_hash_splat_argument] = STATE(116),
    [sym_assignment] = STATE(1516),
    [sym_operator_assignment] = STATE(1516),
    [sym_conditional] = STATE(1516),
    [sym_range] = STATE(1516),
    [sym_binary] = STATE(1516),
    [sym_unary] = STATE(1516),
    [sym_left_assignment_list] = STATE(1518),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1519),
    [sym__variable] = STATE(1517),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1519),
    [sym_false] = STATE(1519),
    [sym_nil] = STATE(1519),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1520),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(1521),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym__hash_items] = STATE(1522),
    [sym_pair] = STATE(122),
    [sym_lambda] = STATE(214),
    [sym_empty_statement] = STATE(495),
    [aux_sym__statements_repeat1] = STATE(495),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2629),
    [sym__identifier_hash_key] = ACTIONS(157),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(8332),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_PIPE] = ACTIONS(2445),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2633),
    [anon_sym_yield] = ACTIONS(2635),
    [anon_sym_break] = ACTIONS(2637),
    [anon_sym_next] = ACTIONS(2639),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2641),
    [anon_sym_defined_QMARK] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2647),
    [anon_sym_TILDE] = ACTIONS(2647),
    [sym_constant] = ACTIONS(2649),
    [sym_identifier] = ACTIONS(2649),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2766] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5263),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1066),
    [sym_scope_resolution] = STATE(1061),
    [sym_call] = STATE(1061),
    [sym_method_call] = STATE(1066),
    [sym_assignment] = STATE(5263),
    [sym_operator_assignment] = STATE(5263),
    [sym_conditional] = STATE(5263),
    [sym_range] = STATE(5263),
    [sym_binary] = STATE(5263),
    [sym_unary] = STATE(5263),
    [sym_left_assignment_list] = STATE(1065),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1066),
    [sym__variable] = STATE(1061),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1066),
    [sym_false] = STATE(1066),
    [sym_nil] = STATE(1066),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2804),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1895),
    [anon_sym_break] = ACTIONS(1897),
    [anon_sym_next] = ACTIONS(1899),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(4715),
    [anon_sym_defined_QMARK] = ACTIONS(1909),
    [anon_sym_not] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1915),
    [anon_sym_TILDE] = ACTIONS(1915),
    [sym_constant] = ACTIONS(1921),
    [sym_identifier] = ACTIONS(1921),
    [sym_instance_variable] = ACTIONS(1919),
    [sym_class_variable] = ACTIONS(1919),
    [sym_global_variable] = ACTIONS(1919),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1921),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1921),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2767] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(8334),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [2768] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(4723),
    [sym__binary_star] = ACTIONS(4725),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(4727),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(4729),
    [anon_sym_AMP] = ACTIONS(4731),
    [anon_sym_EQ] = ACTIONS(1631),
    [anon_sym_LT] = ACTIONS(4733),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(1625),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_PLUS_EQ] = ACTIONS(1625),
    [anon_sym_DASH_EQ] = ACTIONS(1625),
    [anon_sym_STAR_EQ] = ACTIONS(1625),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1625),
    [anon_sym_SLASH_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1625),
    [anon_sym_AMP_EQ] = ACTIONS(1625),
    [anon_sym_PERCENT_EQ] = ACTIONS(1625),
    [anon_sym_GT_GT_EQ] = ACTIONS(1625),
    [anon_sym_LT_LT_EQ] = ACTIONS(1625),
    [anon_sym_CARET_EQ] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(4735),
    [anon_sym_DOT_DOT] = ACTIONS(4737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4739),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(4741),
    [anon_sym_AMP_AMP] = ACTIONS(4741),
    [anon_sym_LT_LT] = ACTIONS(4743),
    [anon_sym_GT_GT] = ACTIONS(4743),
    [anon_sym_EQ_EQ] = ACTIONS(4741),
    [anon_sym_BANG_EQ] = ACTIONS(4745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4745),
    [anon_sym_LT_EQ_GT] = ACTIONS(4745),
    [anon_sym_EQ_TILDE] = ACTIONS(4745),
    [anon_sym_BANG_TILDE] = ACTIONS(4745),
    [anon_sym_LT_EQ] = ACTIONS(4733),
    [anon_sym_GT] = ACTIONS(4733),
    [anon_sym_GT_EQ] = ACTIONS(4747),
    [anon_sym_CARET] = ACTIONS(4727),
    [anon_sym_PLUS] = ACTIONS(4749),
    [anon_sym_SLASH] = ACTIONS(4729),
    [anon_sym_PERCENT] = ACTIONS(4729),
    [sym_comment] = ACTIONS(87),
  },
  [2769] = {
    [sym_heredoc_body] = STATE(5265),
    [aux_sym_call_repeat1] = STATE(5265),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [2770] = {
    [sym_heredoc_body] = STATE(5265),
    [aux_sym_call_repeat1] = STATE(5265),
    [aux_sym_argument_list_repeat1] = STATE(5267),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(8336),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [2771] = {
    [sym_string] = STATE(2825),
    [aux_sym_chained_string_repeat1] = STATE(2825),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(747),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(8338),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2772] = {
    [sym_heredoc_body] = STATE(5268),
    [aux_sym_call_repeat1] = STATE(5268),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [2773] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1028),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1033),
    [sym_scope_resolution] = STATE(1029),
    [sym_call] = STATE(1029),
    [sym_method_call] = STATE(1033),
    [sym__argument] = STATE(2565),
    [sym_splat_argument] = STATE(2565),
    [sym_hash_splat_argument] = STATE(2565),
    [sym_block_argument] = STATE(2565),
    [sym_assignment] = STATE(1028),
    [sym_operator_assignment] = STATE(1028),
    [sym_conditional] = STATE(1028),
    [sym_range] = STATE(1028),
    [sym_binary] = STATE(1028),
    [sym_unary] = STATE(1028),
    [sym_left_assignment_list] = STATE(1032),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1033),
    [sym__variable] = STATE(1029),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1033),
    [sym_false] = STATE(1033),
    [sym_nil] = STATE(1033),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1034),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(5269),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2565),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(1823),
    [sym__splat_star] = ACTIONS(1825),
    [sym__unary_minus] = ACTIONS(1827),
    [sym__identifier_hash_key] = ACTIONS(1829),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(8340),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1831),
    [anon_sym_yield] = ACTIONS(1833),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_next] = ACTIONS(1837),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4631),
    [anon_sym_defined_QMARK] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1845),
    [anon_sym_TILDE] = ACTIONS(1845),
    [sym_constant] = ACTIONS(1847),
    [sym_identifier] = ACTIONS(1847),
    [sym_instance_variable] = ACTIONS(1849),
    [sym_class_variable] = ACTIONS(1849),
    [sym_global_variable] = ACTIONS(1849),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1851),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1851),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2774] = {
    [sym_heredoc_body] = STATE(5270),
    [aux_sym_call_repeat1] = STATE(5270),
    [aux_sym_argument_list_repeat1] = STATE(5271),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4681),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [2775] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5272),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1033),
    [sym_scope_resolution] = STATE(1029),
    [sym_call] = STATE(1029),
    [sym_method_call] = STATE(1033),
    [sym_splat_argument] = STATE(5273),
    [sym_assignment] = STATE(5272),
    [sym_operator_assignment] = STATE(5272),
    [sym_conditional] = STATE(5272),
    [sym_range] = STATE(5272),
    [sym_binary] = STATE(5272),
    [sym_unary] = STATE(5272),
    [sym_right_assignment_list] = STATE(2570),
    [sym__arg_or_splat_arg] = STATE(5273),
    [sym_left_assignment_list] = STATE(1032),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1033),
    [sym__variable] = STATE(1029),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1033),
    [sym_false] = STATE(1033),
    [sym_nil] = STATE(1033),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2738),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__splat_star] = ACTIONS(4637),
    [sym__unary_minus] = ACTIONS(1827),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1831),
    [anon_sym_yield] = ACTIONS(1833),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_next] = ACTIONS(1837),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4631),
    [anon_sym_defined_QMARK] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1845),
    [anon_sym_TILDE] = ACTIONS(1845),
    [sym_constant] = ACTIONS(1851),
    [sym_identifier] = ACTIONS(1851),
    [sym_instance_variable] = ACTIONS(1849),
    [sym_class_variable] = ACTIONS(1849),
    [sym_global_variable] = ACTIONS(1849),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1851),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1851),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2776] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5274),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1033),
    [sym_scope_resolution] = STATE(1029),
    [sym_call] = STATE(1029),
    [sym_method_call] = STATE(1033),
    [sym_assignment] = STATE(5274),
    [sym_operator_assignment] = STATE(5274),
    [sym_conditional] = STATE(5274),
    [sym_range] = STATE(5274),
    [sym_binary] = STATE(5274),
    [sym_unary] = STATE(5274),
    [sym_left_assignment_list] = STATE(1032),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1033),
    [sym__variable] = STATE(1029),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1033),
    [sym_false] = STATE(1033),
    [sym_nil] = STATE(1033),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2738),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1827),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1831),
    [anon_sym_yield] = ACTIONS(1833),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_next] = ACTIONS(1837),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4631),
    [anon_sym_defined_QMARK] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1845),
    [anon_sym_TILDE] = ACTIONS(1845),
    [sym_constant] = ACTIONS(1851),
    [sym_identifier] = ACTIONS(1851),
    [sym_instance_variable] = ACTIONS(1849),
    [sym_class_variable] = ACTIONS(1849),
    [sym_global_variable] = ACTIONS(1849),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1851),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1851),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2777] = {
    [sym_string] = STATE(5275),
    [aux_sym_chained_string_repeat1] = STATE(5275),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_EQ_GT] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [2778] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(1857),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(1857),
    [anon_sym_PERCENT] = ACTIONS(1857),
    [sym_comment] = ACTIONS(87),
  },
  [2779] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [2780] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(1855),
    [sym__binary_star] = ACTIONS(1857),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(1875),
    [anon_sym_GT_GT] = ACTIONS(1875),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_SLASH] = ACTIONS(1857),
    [anon_sym_PERCENT] = ACTIONS(1857),
    [sym_comment] = ACTIONS(87),
  },
  [2781] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(1855),
    [sym__binary_star] = ACTIONS(1857),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(1875),
    [anon_sym_GT_GT] = ACTIONS(1875),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_SLASH] = ACTIONS(1857),
    [anon_sym_PERCENT] = ACTIONS(1857),
    [sym_comment] = ACTIONS(87),
  },
  [2782] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(1855),
    [sym__binary_star] = ACTIONS(1857),
    [anon_sym_PIPE] = ACTIONS(1859),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(1875),
    [anon_sym_GT_GT] = ACTIONS(1875),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_SLASH] = ACTIONS(1857),
    [anon_sym_PERCENT] = ACTIONS(1857),
    [sym_comment] = ACTIONS(87),
  },
  [2783] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(8342),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [2784] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(1855),
    [sym__binary_star] = ACTIONS(1857),
    [anon_sym_PIPE] = ACTIONS(1859),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_LT] = ACTIONS(1863),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(1867),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1869),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(1873),
    [anon_sym_AMP_AMP] = ACTIONS(1873),
    [anon_sym_LT_LT] = ACTIONS(1875),
    [anon_sym_GT_GT] = ACTIONS(1875),
    [anon_sym_EQ_EQ] = ACTIONS(1877),
    [anon_sym_BANG_EQ] = ACTIONS(1873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1873),
    [anon_sym_LT_EQ_GT] = ACTIONS(1873),
    [anon_sym_EQ_TILDE] = ACTIONS(1873),
    [anon_sym_BANG_TILDE] = ACTIONS(1873),
    [anon_sym_LT_EQ] = ACTIONS(1863),
    [anon_sym_GT] = ACTIONS(1863),
    [anon_sym_GT_EQ] = ACTIONS(1879),
    [anon_sym_CARET] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_SLASH] = ACTIONS(1857),
    [anon_sym_PERCENT] = ACTIONS(1857),
    [sym_comment] = ACTIONS(87),
  },
  [2785] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(1855),
    [sym__binary_star] = ACTIONS(1857),
    [anon_sym_PIPE] = ACTIONS(1859),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_LT] = ACTIONS(1863),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(1865),
    [anon_sym_DOT_DOT] = ACTIONS(1867),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1869),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(1873),
    [anon_sym_AMP_AMP] = ACTIONS(1873),
    [anon_sym_LT_LT] = ACTIONS(1875),
    [anon_sym_GT_GT] = ACTIONS(1875),
    [anon_sym_EQ_EQ] = ACTIONS(1877),
    [anon_sym_BANG_EQ] = ACTIONS(1873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1873),
    [anon_sym_LT_EQ_GT] = ACTIONS(1873),
    [anon_sym_EQ_TILDE] = ACTIONS(1873),
    [anon_sym_BANG_TILDE] = ACTIONS(1873),
    [anon_sym_LT_EQ] = ACTIONS(1863),
    [anon_sym_GT] = ACTIONS(1863),
    [anon_sym_GT_EQ] = ACTIONS(1879),
    [anon_sym_CARET] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_SLASH] = ACTIONS(1857),
    [anon_sym_PERCENT] = ACTIONS(1857),
    [sym_comment] = ACTIONS(87),
  },
  [2786] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(1855),
    [sym__binary_star] = ACTIONS(1857),
    [anon_sym_PIPE] = ACTIONS(1859),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_LT] = ACTIONS(1863),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(1875),
    [anon_sym_GT_GT] = ACTIONS(1875),
    [anon_sym_EQ_EQ] = ACTIONS(1877),
    [anon_sym_BANG_EQ] = ACTIONS(1873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1873),
    [anon_sym_LT_EQ_GT] = ACTIONS(1873),
    [anon_sym_EQ_TILDE] = ACTIONS(1873),
    [anon_sym_BANG_TILDE] = ACTIONS(1873),
    [anon_sym_LT_EQ] = ACTIONS(1863),
    [anon_sym_GT] = ACTIONS(1863),
    [anon_sym_GT_EQ] = ACTIONS(1879),
    [anon_sym_CARET] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_SLASH] = ACTIONS(1857),
    [anon_sym_PERCENT] = ACTIONS(1857),
    [sym_comment] = ACTIONS(87),
  },
  [2787] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(1855),
    [sym__binary_star] = ACTIONS(1857),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_SLASH] = ACTIONS(1857),
    [anon_sym_PERCENT] = ACTIONS(1857),
    [sym_comment] = ACTIONS(87),
  },
  [2788] = {
    [sym__line_break] = ACTIONS(8344),
    [sym__heredoc_body_start] = ACTIONS(8344),
    [sym__binary_minus] = ACTIONS(8344),
    [sym__binary_star] = ACTIONS(8344),
    [ts_builtin_sym_end] = ACTIONS(8344),
    [anon_sym___END__] = ACTIONS(8344),
    [anon_sym_LBRACE] = ACTIONS(8344),
    [anon_sym_RBRACE] = ACTIONS(8344),
    [anon_sym_RPAREN] = ACTIONS(8344),
    [anon_sym_DOT] = ACTIONS(8346),
    [anon_sym_COMMA] = ACTIONS(8344),
    [anon_sym_PIPE] = ACTIONS(8346),
    [anon_sym_SEMI] = ACTIONS(8344),
    [anon_sym_STAR_STAR] = ACTIONS(8344),
    [anon_sym_AMP] = ACTIONS(8346),
    [anon_sym_LT] = ACTIONS(8346),
    [anon_sym_end] = ACTIONS(8344),
    [anon_sym_if] = ACTIONS(8344),
    [anon_sym_unless] = ACTIONS(8344),
    [anon_sym_while] = ACTIONS(8344),
    [anon_sym_until] = ACTIONS(8344),
    [anon_sym_rescue] = ACTIONS(8344),
    [anon_sym_do] = ACTIONS(8344),
    [anon_sym_when] = ACTIONS(8344),
    [anon_sym_elsif] = ACTIONS(8344),
    [anon_sym_else] = ACTIONS(8344),
    [anon_sym_then] = ACTIONS(8344),
    [anon_sym_ensure] = ACTIONS(8344),
    [anon_sym_EQ_GT] = ACTIONS(8344),
    [anon_sym_LBRACK] = ACTIONS(8344),
    [anon_sym_COLON_COLON2] = ACTIONS(8344),
    [anon_sym_AMP_DOT] = ACTIONS(8344),
    [anon_sym_QMARK] = ACTIONS(8344),
    [anon_sym_DOT_DOT] = ACTIONS(8346),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8344),
    [anon_sym_and] = ACTIONS(8344),
    [anon_sym_or] = ACTIONS(8344),
    [anon_sym_PIPE_PIPE] = ACTIONS(8344),
    [anon_sym_AMP_AMP] = ACTIONS(8344),
    [anon_sym_LT_LT] = ACTIONS(8344),
    [anon_sym_GT_GT] = ACTIONS(8344),
    [anon_sym_EQ_EQ] = ACTIONS(8346),
    [anon_sym_BANG_EQ] = ACTIONS(8344),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8344),
    [anon_sym_LT_EQ_GT] = ACTIONS(8344),
    [anon_sym_EQ_TILDE] = ACTIONS(8344),
    [anon_sym_BANG_TILDE] = ACTIONS(8344),
    [anon_sym_LT_EQ] = ACTIONS(8346),
    [anon_sym_GT] = ACTIONS(8346),
    [anon_sym_GT_EQ] = ACTIONS(8344),
    [anon_sym_CARET] = ACTIONS(8344),
    [anon_sym_PLUS] = ACTIONS(8344),
    [anon_sym_SLASH] = ACTIONS(8344),
    [anon_sym_PERCENT] = ACTIONS(8344),
    [sym_comment] = ACTIONS(87),
  },
  [2789] = {
    [anon_sym_end] = ACTIONS(8348),
    [sym_comment] = ACTIONS(87),
  },
  [2790] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(5278),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2800),
    [sym_scope_resolution] = STATE(2798),
    [sym_call] = STATE(2798),
    [sym_method_call] = STATE(2800),
    [sym_assignment] = STATE(5278),
    [sym_operator_assignment] = STATE(5278),
    [sym_conditional] = STATE(5278),
    [sym_range] = STATE(5278),
    [sym_binary] = STATE(5278),
    [sym_unary] = STATE(5278),
    [sym_left_assignment_list] = STATE(2799),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2800),
    [sym__variable] = STATE(2798),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2800),
    [sym_false] = STATE(2800),
    [sym_nil] = STATE(2800),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2801),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(4693),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(4695),
    [anon_sym_yield] = ACTIONS(4697),
    [anon_sym_break] = ACTIONS(4699),
    [anon_sym_next] = ACTIONS(4701),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(4703),
    [anon_sym_defined_QMARK] = ACTIONS(4705),
    [anon_sym_not] = ACTIONS(4707),
    [anon_sym_BANG] = ACTIONS(4709),
    [anon_sym_TILDE] = ACTIONS(4709),
    [sym_constant] = ACTIONS(4711),
    [sym_identifier] = ACTIONS(4711),
    [sym_instance_variable] = ACTIONS(4713),
    [sym_class_variable] = ACTIONS(4713),
    [sym_global_variable] = ACTIONS(4713),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(4711),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4711),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [2791] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(1060),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1066),
    [sym_scope_resolution] = STATE(1061),
    [sym_call] = STATE(1061),
    [sym_method_call] = STATE(1066),
    [sym_argument_list] = STATE(3610),
    [sym__argument_list_with_parens] = STATE(1063),
    [sym__argument] = STATE(1064),
    [sym_splat_argument] = STATE(1064),
    [sym_hash_splat_argument] = STATE(1064),
    [sym_block_argument] = STATE(1064),
    [sym_assignment] = STATE(1060),
    [sym_operator_assignment] = STATE(1060),
    [sym_conditional] = STATE(1060),
    [sym_range] = STATE(1060),
    [sym_binary] = STATE(1060),
    [sym_unary] = STATE(1060),
    [sym_left_assignment_list] = STATE(1065),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1066),
    [sym__variable] = STATE(1061),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1066),
    [sym_false] = STATE(1066),
    [sym_nil] = STATE(1066),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(1067),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(1064),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(1883),
    [sym__splat_star] = ACTIONS(1885),
    [sym__unary_minus] = ACTIONS(1887),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(1889),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1895),
    [anon_sym_break] = ACTIONS(1897),
    [anon_sym_next] = ACTIONS(1899),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(365),
    [anon_sym_DASH_EQ] = ACTIONS(365),
    [anon_sym_STAR_EQ] = ACTIONS(365),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(365),
    [anon_sym_SLASH_EQ] = ACTIONS(365),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(365),
    [anon_sym_PIPE_EQ] = ACTIONS(365),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(365),
    [anon_sym_AMP_EQ] = ACTIONS(365),
    [anon_sym_PERCENT_EQ] = ACTIONS(365),
    [anon_sym_GT_GT_EQ] = ACTIONS(365),
    [anon_sym_LT_LT_EQ] = ACTIONS(365),
    [anon_sym_CARET_EQ] = ACTIONS(365),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_PERCENT] = ACTIONS(377),
    [anon_sym_defined_QMARK] = ACTIONS(1909),
    [anon_sym_not] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1913),
    [anon_sym_TILDE] = ACTIONS(1915),
    [sym_constant] = ACTIONS(1917),
    [sym_identifier] = ACTIONS(1917),
    [sym_instance_variable] = ACTIONS(1919),
    [sym_class_variable] = ACTIONS(1919),
    [sym_global_variable] = ACTIONS(1919),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1921),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1921),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2792] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(1060),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1066),
    [sym_scope_resolution] = STATE(1061),
    [sym_call] = STATE(1061),
    [sym_method_call] = STATE(1066),
    [sym_argument_list] = STATE(3611),
    [sym__argument_list_with_parens] = STATE(1063),
    [sym__argument] = STATE(1064),
    [sym_splat_argument] = STATE(1064),
    [sym_hash_splat_argument] = STATE(1064),
    [sym_block_argument] = STATE(1064),
    [sym_assignment] = STATE(1060),
    [sym_operator_assignment] = STATE(1060),
    [sym_conditional] = STATE(1060),
    [sym_range] = STATE(1060),
    [sym_binary] = STATE(1060),
    [sym_unary] = STATE(1060),
    [sym_left_assignment_list] = STATE(1065),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1066),
    [sym__variable] = STATE(1061),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1066),
    [sym_false] = STATE(1066),
    [sym_nil] = STATE(1066),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(1067),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(1064),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(1883),
    [sym__splat_star] = ACTIONS(1885),
    [sym__unary_minus] = ACTIONS(1887),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(1889),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_EQ] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1895),
    [anon_sym_break] = ACTIONS(1897),
    [anon_sym_next] = ACTIONS(1899),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(417),
    [anon_sym_DASH_EQ] = ACTIONS(417),
    [anon_sym_STAR_EQ] = ACTIONS(417),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(417),
    [anon_sym_SLASH_EQ] = ACTIONS(417),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(417),
    [anon_sym_PIPE_EQ] = ACTIONS(417),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(417),
    [anon_sym_AMP_EQ] = ACTIONS(417),
    [anon_sym_PERCENT_EQ] = ACTIONS(417),
    [anon_sym_GT_GT_EQ] = ACTIONS(417),
    [anon_sym_LT_LT_EQ] = ACTIONS(417),
    [anon_sym_CARET_EQ] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(1909),
    [anon_sym_not] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1913),
    [anon_sym_TILDE] = ACTIONS(1915),
    [sym_constant] = ACTIONS(1917),
    [sym_identifier] = ACTIONS(1917),
    [sym_instance_variable] = ACTIONS(1919),
    [sym_class_variable] = ACTIONS(1919),
    [sym_global_variable] = ACTIONS(1919),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1921),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1921),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2793] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(1060),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1066),
    [sym_scope_resolution] = STATE(1061),
    [sym_call] = STATE(1061),
    [sym_method_call] = STATE(1066),
    [sym_argument_list] = STATE(3612),
    [sym__argument_list_with_parens] = STATE(1063),
    [sym__argument] = STATE(1064),
    [sym_splat_argument] = STATE(1064),
    [sym_hash_splat_argument] = STATE(1064),
    [sym_block_argument] = STATE(1064),
    [sym_assignment] = STATE(1060),
    [sym_operator_assignment] = STATE(1060),
    [sym_conditional] = STATE(1060),
    [sym_range] = STATE(1060),
    [sym_binary] = STATE(1060),
    [sym_unary] = STATE(1060),
    [sym_left_assignment_list] = STATE(1065),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1066),
    [sym__variable] = STATE(1061),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1066),
    [sym_false] = STATE(1066),
    [sym_nil] = STATE(1066),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(1067),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(1064),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(1883),
    [sym__splat_star] = ACTIONS(1885),
    [sym__unary_minus] = ACTIONS(1887),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(1889),
    [anon_sym_LBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_EQ] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1895),
    [anon_sym_break] = ACTIONS(1897),
    [anon_sym_next] = ACTIONS(1899),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(421),
    [anon_sym_DASH_EQ] = ACTIONS(421),
    [anon_sym_STAR_EQ] = ACTIONS(421),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(421),
    [anon_sym_SLASH_EQ] = ACTIONS(421),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(421),
    [anon_sym_PIPE_EQ] = ACTIONS(421),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(421),
    [anon_sym_AMP_EQ] = ACTIONS(421),
    [anon_sym_PERCENT_EQ] = ACTIONS(421),
    [anon_sym_GT_GT_EQ] = ACTIONS(421),
    [anon_sym_LT_LT_EQ] = ACTIONS(421),
    [anon_sym_CARET_EQ] = ACTIONS(421),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(1909),
    [anon_sym_not] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1913),
    [anon_sym_TILDE] = ACTIONS(1915),
    [sym_constant] = ACTIONS(1917),
    [sym_identifier] = ACTIONS(1917),
    [sym_instance_variable] = ACTIONS(1919),
    [sym_class_variable] = ACTIONS(1919),
    [sym_global_variable] = ACTIONS(1919),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1921),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1921),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2794] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(1060),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1066),
    [sym_scope_resolution] = STATE(1061),
    [sym_call] = STATE(1061),
    [sym_method_call] = STATE(1066),
    [sym_argument_list] = STATE(3613),
    [sym__argument_list_with_parens] = STATE(1063),
    [sym__argument] = STATE(1064),
    [sym_splat_argument] = STATE(1064),
    [sym_hash_splat_argument] = STATE(1064),
    [sym_block_argument] = STATE(1064),
    [sym_assignment] = STATE(1060),
    [sym_operator_assignment] = STATE(1060),
    [sym_conditional] = STATE(1060),
    [sym_range] = STATE(1060),
    [sym_binary] = STATE(1060),
    [sym_unary] = STATE(1060),
    [sym_left_assignment_list] = STATE(1065),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1066),
    [sym__variable] = STATE(1061),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1066),
    [sym_false] = STATE(1066),
    [sym_nil] = STATE(1066),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(1067),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(1064),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(1883),
    [sym__splat_star] = ACTIONS(1885),
    [sym__unary_minus] = ACTIONS(1887),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(1889),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(427),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1895),
    [anon_sym_break] = ACTIONS(1897),
    [anon_sym_next] = ACTIONS(1899),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(425),
    [anon_sym_DASH_EQ] = ACTIONS(425),
    [anon_sym_STAR_EQ] = ACTIONS(425),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(425),
    [anon_sym_SLASH_EQ] = ACTIONS(425),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(425),
    [anon_sym_PIPE_EQ] = ACTIONS(425),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(425),
    [anon_sym_AMP_EQ] = ACTIONS(425),
    [anon_sym_PERCENT_EQ] = ACTIONS(425),
    [anon_sym_GT_GT_EQ] = ACTIONS(425),
    [anon_sym_LT_LT_EQ] = ACTIONS(425),
    [anon_sym_CARET_EQ] = ACTIONS(425),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(1909),
    [anon_sym_not] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1913),
    [anon_sym_TILDE] = ACTIONS(1915),
    [sym_constant] = ACTIONS(1917),
    [sym_identifier] = ACTIONS(1917),
    [sym_instance_variable] = ACTIONS(1919),
    [sym_class_variable] = ACTIONS(1919),
    [sym_global_variable] = ACTIONS(1919),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1921),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1921),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2795] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(5279),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2800),
    [sym_scope_resolution] = STATE(2798),
    [sym_call] = STATE(2798),
    [sym_method_call] = STATE(2800),
    [sym_assignment] = STATE(5279),
    [sym_operator_assignment] = STATE(5279),
    [sym_conditional] = STATE(5279),
    [sym_range] = STATE(5279),
    [sym_binary] = STATE(5279),
    [sym_unary] = STATE(5279),
    [sym_left_assignment_list] = STATE(2799),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2800),
    [sym__variable] = STATE(2798),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2800),
    [sym_false] = STATE(2800),
    [sym_nil] = STATE(2800),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2801),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(4693),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(4695),
    [anon_sym_yield] = ACTIONS(4697),
    [anon_sym_break] = ACTIONS(4699),
    [anon_sym_next] = ACTIONS(4701),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(4703),
    [anon_sym_defined_QMARK] = ACTIONS(4705),
    [anon_sym_not] = ACTIONS(4707),
    [anon_sym_BANG] = ACTIONS(4709),
    [anon_sym_TILDE] = ACTIONS(4709),
    [sym_constant] = ACTIONS(4711),
    [sym_identifier] = ACTIONS(4711),
    [sym_instance_variable] = ACTIONS(4713),
    [sym_class_variable] = ACTIONS(4713),
    [sym_global_variable] = ACTIONS(4713),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(4711),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4711),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [2796] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(3628),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2800),
    [sym_scope_resolution] = STATE(2798),
    [sym_call] = STATE(2798),
    [sym_method_call] = STATE(2800),
    [sym_assignment] = STATE(3628),
    [sym_operator_assignment] = STATE(3628),
    [sym_conditional] = STATE(3628),
    [sym_range] = STATE(3628),
    [sym_binary] = STATE(3628),
    [sym_unary] = STATE(3628),
    [sym_left_assignment_list] = STATE(2799),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2800),
    [sym__variable] = STATE(2798),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2800),
    [sym_false] = STATE(2800),
    [sym_nil] = STATE(2800),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2801),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(4693),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(4695),
    [anon_sym_yield] = ACTIONS(4697),
    [anon_sym_break] = ACTIONS(4699),
    [anon_sym_next] = ACTIONS(4701),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(4703),
    [anon_sym_defined_QMARK] = ACTIONS(4705),
    [anon_sym_not] = ACTIONS(4707),
    [anon_sym_BANG] = ACTIONS(4709),
    [anon_sym_TILDE] = ACTIONS(4709),
    [sym_constant] = ACTIONS(4711),
    [sym_identifier] = ACTIONS(4711),
    [sym_instance_variable] = ACTIONS(4713),
    [sym_class_variable] = ACTIONS(4713),
    [sym_global_variable] = ACTIONS(4713),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(4711),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4711),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [2797] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(8350),
    [sym__binary_star] = ACTIONS(8352),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(8354),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(8356),
    [anon_sym_AMP] = ACTIONS(8358),
    [anon_sym_EQ] = ACTIONS(4217),
    [anon_sym_LT] = ACTIONS(8360),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_PLUS_EQ] = ACTIONS(4211),
    [anon_sym_DASH_EQ] = ACTIONS(4211),
    [anon_sym_STAR_EQ] = ACTIONS(4211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4211),
    [anon_sym_SLASH_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4211),
    [anon_sym_AMP_EQ] = ACTIONS(4211),
    [anon_sym_PERCENT_EQ] = ACTIONS(4211),
    [anon_sym_GT_GT_EQ] = ACTIONS(4211),
    [anon_sym_LT_LT_EQ] = ACTIONS(4211),
    [anon_sym_CARET_EQ] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(8362),
    [anon_sym_DOT_DOT] = ACTIONS(8364),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8366),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(8368),
    [anon_sym_AMP_AMP] = ACTIONS(8368),
    [anon_sym_LT_LT] = ACTIONS(8370),
    [anon_sym_GT_GT] = ACTIONS(8370),
    [anon_sym_EQ_EQ] = ACTIONS(8368),
    [anon_sym_BANG_EQ] = ACTIONS(8372),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8372),
    [anon_sym_LT_EQ_GT] = ACTIONS(8372),
    [anon_sym_EQ_TILDE] = ACTIONS(8372),
    [anon_sym_BANG_TILDE] = ACTIONS(8372),
    [anon_sym_LT_EQ] = ACTIONS(8360),
    [anon_sym_GT] = ACTIONS(8360),
    [anon_sym_GT_EQ] = ACTIONS(8374),
    [anon_sym_CARET] = ACTIONS(8354),
    [anon_sym_PLUS] = ACTIONS(8376),
    [anon_sym_SLASH] = ACTIONS(8356),
    [anon_sym_PERCENT] = ACTIONS(8356),
    [sym_comment] = ACTIONS(87),
  },
  [2798] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(1060),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1066),
    [sym_scope_resolution] = STATE(1061),
    [sym_call] = STATE(1061),
    [sym_method_call] = STATE(1066),
    [sym_argument_list] = STATE(1062),
    [sym__argument_list_with_parens] = STATE(1063),
    [sym__argument] = STATE(1064),
    [sym_splat_argument] = STATE(1064),
    [sym_hash_splat_argument] = STATE(1064),
    [sym_block_argument] = STATE(1064),
    [sym_do_block] = STATE(426),
    [sym_block] = STATE(426),
    [sym_assignment] = STATE(1060),
    [sym_operator_assignment] = STATE(1060),
    [sym_conditional] = STATE(1060),
    [sym_range] = STATE(1060),
    [sym_binary] = STATE(1060),
    [sym_unary] = STATE(1060),
    [sym_left_assignment_list] = STATE(1065),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1066),
    [sym__variable] = STATE(1061),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1066),
    [sym_false] = STATE(1066),
    [sym_nil] = STATE(1066),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(1067),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(1064),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(743),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(1883),
    [sym__splat_star] = ACTIONS(1885),
    [sym__unary_minus] = ACTIONS(1887),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(1889),
    [anon_sym_LBRACE] = ACTIONS(6047),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1895),
    [anon_sym_break] = ACTIONS(1897),
    [anon_sym_next] = ACTIONS(1899),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(769),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(1909),
    [anon_sym_not] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1913),
    [anon_sym_TILDE] = ACTIONS(1915),
    [sym_constant] = ACTIONS(1917),
    [sym_identifier] = ACTIONS(1917),
    [sym_instance_variable] = ACTIONS(1919),
    [sym_class_variable] = ACTIONS(1919),
    [sym_global_variable] = ACTIONS(1919),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1921),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1921),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2799] = {
    [anon_sym_EQ] = ACTIONS(8378),
    [sym_comment] = ACTIONS(87),
  },
  [2800] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(8380),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(8382),
    [anon_sym_DASH_EQ] = ACTIONS(8382),
    [anon_sym_STAR_EQ] = ACTIONS(8382),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8382),
    [anon_sym_SLASH_EQ] = ACTIONS(8382),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8382),
    [anon_sym_PIPE_EQ] = ACTIONS(8382),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8382),
    [anon_sym_AMP_EQ] = ACTIONS(8382),
    [anon_sym_PERCENT_EQ] = ACTIONS(8382),
    [anon_sym_GT_GT_EQ] = ACTIONS(8382),
    [anon_sym_LT_LT_EQ] = ACTIONS(8382),
    [anon_sym_CARET_EQ] = ACTIONS(8382),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2801] = {
    [sym_string] = STATE(5292),
    [aux_sym_chained_string_repeat1] = STATE(5292),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(2551),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2802] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(8350),
    [sym__binary_star] = ACTIONS(8352),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(8354),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(8356),
    [anon_sym_AMP] = ACTIONS(8358),
    [anon_sym_EQ] = ACTIONS(4249),
    [anon_sym_LT] = ACTIONS(8360),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_PLUS_EQ] = ACTIONS(4247),
    [anon_sym_DASH_EQ] = ACTIONS(4247),
    [anon_sym_STAR_EQ] = ACTIONS(4247),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4247),
    [anon_sym_SLASH_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4247),
    [anon_sym_AMP_EQ] = ACTIONS(4247),
    [anon_sym_PERCENT_EQ] = ACTIONS(4247),
    [anon_sym_GT_GT_EQ] = ACTIONS(4247),
    [anon_sym_LT_LT_EQ] = ACTIONS(4247),
    [anon_sym_CARET_EQ] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(8362),
    [anon_sym_DOT_DOT] = ACTIONS(8364),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8366),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(8368),
    [anon_sym_AMP_AMP] = ACTIONS(8368),
    [anon_sym_LT_LT] = ACTIONS(8370),
    [anon_sym_GT_GT] = ACTIONS(8370),
    [anon_sym_EQ_EQ] = ACTIONS(8368),
    [anon_sym_BANG_EQ] = ACTIONS(8372),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8372),
    [anon_sym_LT_EQ_GT] = ACTIONS(8372),
    [anon_sym_EQ_TILDE] = ACTIONS(8372),
    [anon_sym_BANG_TILDE] = ACTIONS(8372),
    [anon_sym_LT_EQ] = ACTIONS(8360),
    [anon_sym_GT] = ACTIONS(8360),
    [anon_sym_GT_EQ] = ACTIONS(8374),
    [anon_sym_CARET] = ACTIONS(8354),
    [anon_sym_PLUS] = ACTIONS(8376),
    [anon_sym_SLASH] = ACTIONS(8356),
    [anon_sym_PERCENT] = ACTIONS(8356),
    [sym_comment] = ACTIONS(87),
  },
  [2803] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(4729),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [2804] = {
    [sym_string] = STATE(2825),
    [aux_sym_chained_string_repeat1] = STATE(2825),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(747),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2805] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(5293),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2800),
    [sym_scope_resolution] = STATE(2798),
    [sym_call] = STATE(2798),
    [sym_method_call] = STATE(2800),
    [sym_assignment] = STATE(5293),
    [sym_operator_assignment] = STATE(5293),
    [sym_conditional] = STATE(5293),
    [sym_range] = STATE(5293),
    [sym_binary] = STATE(5293),
    [sym_unary] = STATE(5293),
    [sym_left_assignment_list] = STATE(2799),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2800),
    [sym__variable] = STATE(2798),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2800),
    [sym_false] = STATE(2800),
    [sym_nil] = STATE(2800),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2801),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(4693),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(4695),
    [anon_sym_yield] = ACTIONS(4697),
    [anon_sym_break] = ACTIONS(4699),
    [anon_sym_next] = ACTIONS(4701),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(4703),
    [anon_sym_defined_QMARK] = ACTIONS(4705),
    [anon_sym_not] = ACTIONS(4707),
    [anon_sym_BANG] = ACTIONS(4709),
    [anon_sym_TILDE] = ACTIONS(4709),
    [sym_constant] = ACTIONS(4711),
    [sym_identifier] = ACTIONS(4711),
    [sym_instance_variable] = ACTIONS(4713),
    [sym_class_variable] = ACTIONS(4713),
    [sym_global_variable] = ACTIONS(4713),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(4711),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4711),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [2806] = {
    [sym__line_break] = ACTIONS(5735),
    [sym__heredoc_body_start] = ACTIONS(5735),
    [sym__binary_minus] = ACTIONS(5735),
    [sym__binary_star] = ACTIONS(5735),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_DOT] = ACTIONS(5737),
    [anon_sym_COMMA] = ACTIONS(5735),
    [anon_sym_PIPE] = ACTIONS(5737),
    [anon_sym_SEMI] = ACTIONS(5735),
    [anon_sym_STAR_STAR] = ACTIONS(5737),
    [anon_sym_AMP] = ACTIONS(5737),
    [anon_sym_EQ] = ACTIONS(5737),
    [anon_sym_LT] = ACTIONS(5737),
    [anon_sym_do] = ACTIONS(5735),
    [anon_sym_EQ_GT] = ACTIONS(993),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_COLON_COLON2] = ACTIONS(5735),
    [anon_sym_AMP_DOT] = ACTIONS(5735),
    [anon_sym_PLUS_EQ] = ACTIONS(5735),
    [anon_sym_DASH_EQ] = ACTIONS(5735),
    [anon_sym_STAR_EQ] = ACTIONS(5735),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5735),
    [anon_sym_SLASH_EQ] = ACTIONS(5735),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5735),
    [anon_sym_PIPE_EQ] = ACTIONS(5735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5735),
    [anon_sym_AMP_EQ] = ACTIONS(5735),
    [anon_sym_PERCENT_EQ] = ACTIONS(5735),
    [anon_sym_GT_GT_EQ] = ACTIONS(5735),
    [anon_sym_LT_LT_EQ] = ACTIONS(5735),
    [anon_sym_CARET_EQ] = ACTIONS(5735),
    [anon_sym_QMARK] = ACTIONS(5735),
    [anon_sym_DOT_DOT] = ACTIONS(5737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5735),
    [anon_sym_and] = ACTIONS(5735),
    [anon_sym_or] = ACTIONS(5735),
    [anon_sym_PIPE_PIPE] = ACTIONS(5737),
    [anon_sym_AMP_AMP] = ACTIONS(5737),
    [anon_sym_LT_LT] = ACTIONS(5737),
    [anon_sym_GT_GT] = ACTIONS(5737),
    [anon_sym_EQ_EQ] = ACTIONS(5737),
    [anon_sym_BANG_EQ] = ACTIONS(5735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5735),
    [anon_sym_LT_EQ_GT] = ACTIONS(5735),
    [anon_sym_EQ_TILDE] = ACTIONS(5735),
    [anon_sym_BANG_TILDE] = ACTIONS(5735),
    [anon_sym_LT_EQ] = ACTIONS(5737),
    [anon_sym_GT] = ACTIONS(5737),
    [anon_sym_GT_EQ] = ACTIONS(5735),
    [anon_sym_CARET] = ACTIONS(5737),
    [anon_sym_PLUS] = ACTIONS(5737),
    [anon_sym_SLASH] = ACTIONS(5737),
    [anon_sym_PERCENT] = ACTIONS(5737),
    [sym_comment] = ACTIONS(87),
  },
  [2807] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(8350),
    [sym__binary_star] = ACTIONS(8352),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(8354),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(8356),
    [anon_sym_AMP] = ACTIONS(8358),
    [anon_sym_EQ] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(8360),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_PLUS_EQ] = ACTIONS(3281),
    [anon_sym_DASH_EQ] = ACTIONS(3281),
    [anon_sym_STAR_EQ] = ACTIONS(3281),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3281),
    [anon_sym_SLASH_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3281),
    [anon_sym_AMP_EQ] = ACTIONS(3281),
    [anon_sym_PERCENT_EQ] = ACTIONS(3281),
    [anon_sym_GT_GT_EQ] = ACTIONS(3281),
    [anon_sym_LT_LT_EQ] = ACTIONS(3281),
    [anon_sym_CARET_EQ] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(8362),
    [anon_sym_DOT_DOT] = ACTIONS(8364),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8366),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(8368),
    [anon_sym_AMP_AMP] = ACTIONS(8368),
    [anon_sym_LT_LT] = ACTIONS(8370),
    [anon_sym_GT_GT] = ACTIONS(8370),
    [anon_sym_EQ_EQ] = ACTIONS(8368),
    [anon_sym_BANG_EQ] = ACTIONS(8372),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8372),
    [anon_sym_LT_EQ_GT] = ACTIONS(8372),
    [anon_sym_EQ_TILDE] = ACTIONS(8372),
    [anon_sym_BANG_TILDE] = ACTIONS(8372),
    [anon_sym_LT_EQ] = ACTIONS(8360),
    [anon_sym_GT] = ACTIONS(8360),
    [anon_sym_GT_EQ] = ACTIONS(8374),
    [anon_sym_CARET] = ACTIONS(8354),
    [anon_sym_PLUS] = ACTIONS(8376),
    [anon_sym_SLASH] = ACTIONS(8356),
    [anon_sym_PERCENT] = ACTIONS(8356),
    [sym_comment] = ACTIONS(87),
  },
  [2808] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(4723),
    [sym__binary_star] = ACTIONS(4725),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(4727),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(4729),
    [anon_sym_AMP] = ACTIONS(4731),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(4733),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(4735),
    [anon_sym_DOT_DOT] = ACTIONS(4737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4739),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(4741),
    [anon_sym_AMP_AMP] = ACTIONS(4741),
    [anon_sym_LT_LT] = ACTIONS(4743),
    [anon_sym_GT_GT] = ACTIONS(4743),
    [anon_sym_EQ_EQ] = ACTIONS(4741),
    [anon_sym_BANG_EQ] = ACTIONS(4745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4745),
    [anon_sym_LT_EQ_GT] = ACTIONS(4745),
    [anon_sym_EQ_TILDE] = ACTIONS(4745),
    [anon_sym_BANG_TILDE] = ACTIONS(4745),
    [anon_sym_LT_EQ] = ACTIONS(4733),
    [anon_sym_GT] = ACTIONS(4733),
    [anon_sym_GT_EQ] = ACTIONS(4747),
    [anon_sym_CARET] = ACTIONS(4727),
    [anon_sym_PLUS] = ACTIONS(4749),
    [anon_sym_SLASH] = ACTIONS(4729),
    [anon_sym_PERCENT] = ACTIONS(4729),
    [sym_comment] = ACTIONS(87),
  },
  [2809] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(5294),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2800),
    [sym_scope_resolution] = STATE(2798),
    [sym_call] = STATE(2798),
    [sym_method_call] = STATE(2800),
    [sym_assignment] = STATE(5294),
    [sym_operator_assignment] = STATE(5294),
    [sym_conditional] = STATE(5294),
    [sym_range] = STATE(5294),
    [sym_binary] = STATE(5294),
    [sym_unary] = STATE(5294),
    [sym_left_assignment_list] = STATE(2799),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2800),
    [sym__variable] = STATE(2798),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2800),
    [sym_false] = STATE(2800),
    [sym_nil] = STATE(2800),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2801),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(4693),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(4695),
    [anon_sym_yield] = ACTIONS(4697),
    [anon_sym_break] = ACTIONS(4699),
    [anon_sym_next] = ACTIONS(4701),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(4703),
    [anon_sym_defined_QMARK] = ACTIONS(4705),
    [anon_sym_not] = ACTIONS(4707),
    [anon_sym_BANG] = ACTIONS(4709),
    [anon_sym_TILDE] = ACTIONS(4709),
    [sym_constant] = ACTIONS(4711),
    [sym_identifier] = ACTIONS(4711),
    [sym_instance_variable] = ACTIONS(4713),
    [sym_class_variable] = ACTIONS(4713),
    [sym_global_variable] = ACTIONS(4713),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(4711),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4711),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [2810] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5295),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1066),
    [sym_scope_resolution] = STATE(1061),
    [sym_call] = STATE(1061),
    [sym_method_call] = STATE(1066),
    [sym_assignment] = STATE(5295),
    [sym_operator_assignment] = STATE(5295),
    [sym_conditional] = STATE(5295),
    [sym_range] = STATE(5295),
    [sym_binary] = STATE(5295),
    [sym_unary] = STATE(5295),
    [sym_left_assignment_list] = STATE(1065),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1066),
    [sym__variable] = STATE(1061),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1066),
    [sym_false] = STATE(1066),
    [sym_nil] = STATE(1066),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2804),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1895),
    [anon_sym_break] = ACTIONS(1897),
    [anon_sym_next] = ACTIONS(1899),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(4715),
    [anon_sym_defined_QMARK] = ACTIONS(1909),
    [anon_sym_not] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1915),
    [anon_sym_TILDE] = ACTIONS(1915),
    [sym_constant] = ACTIONS(1921),
    [sym_identifier] = ACTIONS(1921),
    [sym_instance_variable] = ACTIONS(1919),
    [sym_class_variable] = ACTIONS(1919),
    [sym_global_variable] = ACTIONS(1919),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1921),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1921),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2811] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5296),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1066),
    [sym_scope_resolution] = STATE(1061),
    [sym_call] = STATE(1061),
    [sym_method_call] = STATE(1066),
    [sym_assignment] = STATE(5296),
    [sym_operator_assignment] = STATE(5296),
    [sym_conditional] = STATE(5296),
    [sym_range] = STATE(5296),
    [sym_binary] = STATE(5296),
    [sym_unary] = STATE(5296),
    [sym_left_assignment_list] = STATE(1065),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1066),
    [sym__variable] = STATE(1061),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1066),
    [sym_false] = STATE(1066),
    [sym_nil] = STATE(1066),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2804),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1895),
    [anon_sym_break] = ACTIONS(1897),
    [anon_sym_next] = ACTIONS(1899),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(4715),
    [anon_sym_defined_QMARK] = ACTIONS(1909),
    [anon_sym_not] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1915),
    [anon_sym_TILDE] = ACTIONS(1915),
    [sym_constant] = ACTIONS(1921),
    [sym_identifier] = ACTIONS(1921),
    [sym_instance_variable] = ACTIONS(1919),
    [sym_class_variable] = ACTIONS(1919),
    [sym_global_variable] = ACTIONS(1919),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1921),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1921),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2812] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5297),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1066),
    [sym_scope_resolution] = STATE(1061),
    [sym_call] = STATE(1061),
    [sym_method_call] = STATE(1066),
    [sym_assignment] = STATE(5297),
    [sym_operator_assignment] = STATE(5297),
    [sym_conditional] = STATE(5297),
    [sym_range] = STATE(5297),
    [sym_binary] = STATE(5297),
    [sym_unary] = STATE(5297),
    [sym_left_assignment_list] = STATE(1065),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1066),
    [sym__variable] = STATE(1061),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1066),
    [sym_false] = STATE(1066),
    [sym_nil] = STATE(1066),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2804),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1895),
    [anon_sym_break] = ACTIONS(1897),
    [anon_sym_next] = ACTIONS(1899),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(4715),
    [anon_sym_defined_QMARK] = ACTIONS(1909),
    [anon_sym_not] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1915),
    [anon_sym_TILDE] = ACTIONS(1915),
    [sym_constant] = ACTIONS(1921),
    [sym_identifier] = ACTIONS(1921),
    [sym_instance_variable] = ACTIONS(1919),
    [sym_class_variable] = ACTIONS(1919),
    [sym_global_variable] = ACTIONS(1919),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1921),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1921),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2813] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5298),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1066),
    [sym_scope_resolution] = STATE(1061),
    [sym_call] = STATE(1061),
    [sym_method_call] = STATE(1066),
    [sym_assignment] = STATE(5298),
    [sym_operator_assignment] = STATE(5298),
    [sym_conditional] = STATE(5298),
    [sym_range] = STATE(5298),
    [sym_binary] = STATE(5298),
    [sym_unary] = STATE(5298),
    [sym_left_assignment_list] = STATE(1065),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1066),
    [sym__variable] = STATE(1061),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1066),
    [sym_false] = STATE(1066),
    [sym_nil] = STATE(1066),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2804),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1895),
    [anon_sym_break] = ACTIONS(1897),
    [anon_sym_next] = ACTIONS(1899),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(4715),
    [anon_sym_defined_QMARK] = ACTIONS(1909),
    [anon_sym_not] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1915),
    [anon_sym_TILDE] = ACTIONS(1915),
    [sym_constant] = ACTIONS(1921),
    [sym_identifier] = ACTIONS(1921),
    [sym_instance_variable] = ACTIONS(1919),
    [sym_class_variable] = ACTIONS(1919),
    [sym_global_variable] = ACTIONS(1919),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1921),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1921),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2814] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5299),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1066),
    [sym_scope_resolution] = STATE(1061),
    [sym_call] = STATE(1061),
    [sym_method_call] = STATE(1066),
    [sym_assignment] = STATE(5299),
    [sym_operator_assignment] = STATE(5299),
    [sym_conditional] = STATE(5299),
    [sym_range] = STATE(5299),
    [sym_binary] = STATE(5299),
    [sym_unary] = STATE(5299),
    [sym_left_assignment_list] = STATE(1065),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1066),
    [sym__variable] = STATE(1061),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1066),
    [sym_false] = STATE(1066),
    [sym_nil] = STATE(1066),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2804),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1895),
    [anon_sym_break] = ACTIONS(1897),
    [anon_sym_next] = ACTIONS(1899),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(4715),
    [anon_sym_defined_QMARK] = ACTIONS(1909),
    [anon_sym_not] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1915),
    [anon_sym_TILDE] = ACTIONS(1915),
    [sym_constant] = ACTIONS(1921),
    [sym_identifier] = ACTIONS(1921),
    [sym_instance_variable] = ACTIONS(1919),
    [sym_class_variable] = ACTIONS(1919),
    [sym_global_variable] = ACTIONS(1919),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1921),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1921),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2815] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(5300),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(5300),
    [sym_operator_assignment] = STATE(5300),
    [sym_conditional] = STATE(5300),
    [sym_range] = STATE(5300),
    [sym_binary] = STATE(5300),
    [sym_unary] = STATE(5300),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2816] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5301),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1066),
    [sym_scope_resolution] = STATE(1061),
    [sym_call] = STATE(1061),
    [sym_method_call] = STATE(1066),
    [sym_assignment] = STATE(5301),
    [sym_operator_assignment] = STATE(5301),
    [sym_conditional] = STATE(5301),
    [sym_range] = STATE(5301),
    [sym_binary] = STATE(5301),
    [sym_unary] = STATE(5301),
    [sym_left_assignment_list] = STATE(1065),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1066),
    [sym__variable] = STATE(1061),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1066),
    [sym_false] = STATE(1066),
    [sym_nil] = STATE(1066),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2804),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1895),
    [anon_sym_break] = ACTIONS(1897),
    [anon_sym_next] = ACTIONS(1899),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(4715),
    [anon_sym_defined_QMARK] = ACTIONS(1909),
    [anon_sym_not] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1915),
    [anon_sym_TILDE] = ACTIONS(1915),
    [sym_constant] = ACTIONS(1921),
    [sym_identifier] = ACTIONS(1921),
    [sym_instance_variable] = ACTIONS(1919),
    [sym_class_variable] = ACTIONS(1919),
    [sym_global_variable] = ACTIONS(1919),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1921),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1921),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2817] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5302),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1066),
    [sym_scope_resolution] = STATE(1061),
    [sym_call] = STATE(1061),
    [sym_method_call] = STATE(1066),
    [sym_assignment] = STATE(5302),
    [sym_operator_assignment] = STATE(5302),
    [sym_conditional] = STATE(5302),
    [sym_range] = STATE(5302),
    [sym_binary] = STATE(5302),
    [sym_unary] = STATE(5302),
    [sym_left_assignment_list] = STATE(1065),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1066),
    [sym__variable] = STATE(1061),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1066),
    [sym_false] = STATE(1066),
    [sym_nil] = STATE(1066),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2804),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1895),
    [anon_sym_break] = ACTIONS(1897),
    [anon_sym_next] = ACTIONS(1899),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(4715),
    [anon_sym_defined_QMARK] = ACTIONS(1909),
    [anon_sym_not] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1915),
    [anon_sym_TILDE] = ACTIONS(1915),
    [sym_constant] = ACTIONS(1921),
    [sym_identifier] = ACTIONS(1921),
    [sym_instance_variable] = ACTIONS(1919),
    [sym_class_variable] = ACTIONS(1919),
    [sym_global_variable] = ACTIONS(1919),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1921),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1921),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2818] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5303),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1066),
    [sym_scope_resolution] = STATE(1061),
    [sym_call] = STATE(1061),
    [sym_method_call] = STATE(1066),
    [sym_assignment] = STATE(5303),
    [sym_operator_assignment] = STATE(5303),
    [sym_conditional] = STATE(5303),
    [sym_range] = STATE(5303),
    [sym_binary] = STATE(5303),
    [sym_unary] = STATE(5303),
    [sym_left_assignment_list] = STATE(1065),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1066),
    [sym__variable] = STATE(1061),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1066),
    [sym_false] = STATE(1066),
    [sym_nil] = STATE(1066),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2804),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1895),
    [anon_sym_break] = ACTIONS(1897),
    [anon_sym_next] = ACTIONS(1899),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(4715),
    [anon_sym_defined_QMARK] = ACTIONS(1909),
    [anon_sym_not] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1915),
    [anon_sym_TILDE] = ACTIONS(1915),
    [sym_constant] = ACTIONS(1921),
    [sym_identifier] = ACTIONS(1921),
    [sym_instance_variable] = ACTIONS(1919),
    [sym_class_variable] = ACTIONS(1919),
    [sym_global_variable] = ACTIONS(1919),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1921),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1921),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2819] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5304),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1066),
    [sym_scope_resolution] = STATE(1061),
    [sym_call] = STATE(1061),
    [sym_method_call] = STATE(1066),
    [sym_assignment] = STATE(5304),
    [sym_operator_assignment] = STATE(5304),
    [sym_conditional] = STATE(5304),
    [sym_range] = STATE(5304),
    [sym_binary] = STATE(5304),
    [sym_unary] = STATE(5304),
    [sym_left_assignment_list] = STATE(1065),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1066),
    [sym__variable] = STATE(1061),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1066),
    [sym_false] = STATE(1066),
    [sym_nil] = STATE(1066),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2804),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1895),
    [anon_sym_break] = ACTIONS(1897),
    [anon_sym_next] = ACTIONS(1899),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(4715),
    [anon_sym_defined_QMARK] = ACTIONS(1909),
    [anon_sym_not] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1915),
    [anon_sym_TILDE] = ACTIONS(1915),
    [sym_constant] = ACTIONS(1921),
    [sym_identifier] = ACTIONS(1921),
    [sym_instance_variable] = ACTIONS(1919),
    [sym_class_variable] = ACTIONS(1919),
    [sym_global_variable] = ACTIONS(1919),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1921),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1921),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2820] = {
    [sym_heredoc_body] = STATE(5305),
    [aux_sym_call_repeat1] = STATE(5305),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [2821] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(1060),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1066),
    [sym_scope_resolution] = STATE(1061),
    [sym_call] = STATE(1061),
    [sym_method_call] = STATE(1066),
    [sym__argument] = STATE(3737),
    [sym_splat_argument] = STATE(3737),
    [sym_hash_splat_argument] = STATE(3737),
    [sym_block_argument] = STATE(3737),
    [sym_assignment] = STATE(1060),
    [sym_operator_assignment] = STATE(1060),
    [sym_conditional] = STATE(1060),
    [sym_range] = STATE(1060),
    [sym_binary] = STATE(1060),
    [sym_unary] = STATE(1060),
    [sym_left_assignment_list] = STATE(1065),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1066),
    [sym__variable] = STATE(1061),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1066),
    [sym_false] = STATE(1066),
    [sym_nil] = STATE(1066),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(1067),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_heredoc_body] = STATE(5306),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(3737),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(1883),
    [sym__splat_star] = ACTIONS(1885),
    [sym__unary_minus] = ACTIONS(1887),
    [sym__identifier_hash_key] = ACTIONS(1889),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(8384),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1895),
    [anon_sym_break] = ACTIONS(1897),
    [anon_sym_next] = ACTIONS(1899),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(4715),
    [anon_sym_defined_QMARK] = ACTIONS(1909),
    [anon_sym_not] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1915),
    [anon_sym_TILDE] = ACTIONS(1915),
    [sym_constant] = ACTIONS(1917),
    [sym_identifier] = ACTIONS(1917),
    [sym_instance_variable] = ACTIONS(1919),
    [sym_class_variable] = ACTIONS(1919),
    [sym_global_variable] = ACTIONS(1919),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1921),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1921),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2822] = {
    [sym_heredoc_body] = STATE(5307),
    [aux_sym_call_repeat1] = STATE(5307),
    [aux_sym_argument_list_repeat1] = STATE(5308),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4751),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [2823] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5309),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1066),
    [sym_scope_resolution] = STATE(1061),
    [sym_call] = STATE(1061),
    [sym_method_call] = STATE(1066),
    [sym_splat_argument] = STATE(5310),
    [sym_assignment] = STATE(5309),
    [sym_operator_assignment] = STATE(5309),
    [sym_conditional] = STATE(5309),
    [sym_range] = STATE(5309),
    [sym_binary] = STATE(5309),
    [sym_unary] = STATE(5309),
    [sym_right_assignment_list] = STATE(3742),
    [sym__arg_or_splat_arg] = STATE(5310),
    [sym_left_assignment_list] = STATE(1065),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1066),
    [sym__variable] = STATE(1061),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1066),
    [sym_false] = STATE(1066),
    [sym_nil] = STATE(1066),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2804),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__splat_star] = ACTIONS(4673),
    [sym__unary_minus] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1895),
    [anon_sym_break] = ACTIONS(1897),
    [anon_sym_next] = ACTIONS(1899),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(4715),
    [anon_sym_defined_QMARK] = ACTIONS(1909),
    [anon_sym_not] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1915),
    [anon_sym_TILDE] = ACTIONS(1915),
    [sym_constant] = ACTIONS(1921),
    [sym_identifier] = ACTIONS(1921),
    [sym_instance_variable] = ACTIONS(1919),
    [sym_class_variable] = ACTIONS(1919),
    [sym_global_variable] = ACTIONS(1919),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1921),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1921),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2824] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5311),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1066),
    [sym_scope_resolution] = STATE(1061),
    [sym_call] = STATE(1061),
    [sym_method_call] = STATE(1066),
    [sym_assignment] = STATE(5311),
    [sym_operator_assignment] = STATE(5311),
    [sym_conditional] = STATE(5311),
    [sym_range] = STATE(5311),
    [sym_binary] = STATE(5311),
    [sym_unary] = STATE(5311),
    [sym_left_assignment_list] = STATE(1065),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1066),
    [sym__variable] = STATE(1061),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1066),
    [sym_false] = STATE(1066),
    [sym_nil] = STATE(1066),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2804),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1895),
    [anon_sym_break] = ACTIONS(1897),
    [anon_sym_next] = ACTIONS(1899),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(4715),
    [anon_sym_defined_QMARK] = ACTIONS(1909),
    [anon_sym_not] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1915),
    [anon_sym_TILDE] = ACTIONS(1915),
    [sym_constant] = ACTIONS(1921),
    [sym_identifier] = ACTIONS(1921),
    [sym_instance_variable] = ACTIONS(1919),
    [sym_class_variable] = ACTIONS(1919),
    [sym_global_variable] = ACTIONS(1919),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1921),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1921),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2825] = {
    [sym_string] = STATE(5312),
    [aux_sym_chained_string_repeat1] = STATE(5312),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(747),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2755),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_EQ] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_EQ_GT] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_PLUS_EQ] = ACTIONS(2753),
    [anon_sym_DASH_EQ] = ACTIONS(2753),
    [anon_sym_STAR_EQ] = ACTIONS(2753),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2753),
    [anon_sym_SLASH_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2753),
    [anon_sym_AMP_EQ] = ACTIONS(2753),
    [anon_sym_PERCENT_EQ] = ACTIONS(2753),
    [anon_sym_GT_GT_EQ] = ACTIONS(2753),
    [anon_sym_LT_LT_EQ] = ACTIONS(2753),
    [anon_sym_CARET_EQ] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2755),
    [anon_sym_AMP_AMP] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2755),
    [anon_sym_GT_GT] = ACTIONS(2755),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_SLASH] = ACTIONS(2755),
    [anon_sym_PERCENT] = ACTIONS(2755),
    [sym_comment] = ACTIONS(87),
  },
  [2826] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5313),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2833),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2833),
    [sym_assignment] = STATE(5313),
    [sym_operator_assignment] = STATE(5313),
    [sym_conditional] = STATE(5313),
    [sym_range] = STATE(5313),
    [sym_binary] = STATE(5313),
    [sym_unary] = STATE(5313),
    [sym_left_assignment_list] = STATE(2832),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2833),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2833),
    [sym_false] = STATE(2833),
    [sym_nil] = STATE(2833),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2735),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4763),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4615),
    [anon_sym_yield] = ACTIONS(4617),
    [anon_sym_break] = ACTIONS(4619),
    [anon_sym_next] = ACTIONS(4621),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4765),
    [anon_sym_defined_QMARK] = ACTIONS(4767),
    [anon_sym_not] = ACTIONS(4769),
    [anon_sym_BANG] = ACTIONS(4771),
    [anon_sym_TILDE] = ACTIONS(4771),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2827] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5314),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2833),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2833),
    [sym_assignment] = STATE(5314),
    [sym_operator_assignment] = STATE(5314),
    [sym_conditional] = STATE(5314),
    [sym_range] = STATE(5314),
    [sym_binary] = STATE(5314),
    [sym_unary] = STATE(5314),
    [sym_left_assignment_list] = STATE(2832),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2833),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2833),
    [sym_false] = STATE(2833),
    [sym_nil] = STATE(2833),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2735),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4763),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4615),
    [anon_sym_yield] = ACTIONS(4617),
    [anon_sym_break] = ACTIONS(4619),
    [anon_sym_next] = ACTIONS(4621),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4765),
    [anon_sym_defined_QMARK] = ACTIONS(4767),
    [anon_sym_not] = ACTIONS(4769),
    [anon_sym_BANG] = ACTIONS(4771),
    [anon_sym_TILDE] = ACTIONS(4771),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2828] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5315),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2833),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2833),
    [sym_assignment] = STATE(5315),
    [sym_operator_assignment] = STATE(5315),
    [sym_conditional] = STATE(5315),
    [sym_range] = STATE(5315),
    [sym_binary] = STATE(5315),
    [sym_unary] = STATE(5315),
    [sym_left_assignment_list] = STATE(2832),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2833),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2833),
    [sym_false] = STATE(2833),
    [sym_nil] = STATE(2833),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2735),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4763),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4615),
    [anon_sym_yield] = ACTIONS(4617),
    [anon_sym_break] = ACTIONS(4619),
    [anon_sym_next] = ACTIONS(4621),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4765),
    [anon_sym_defined_QMARK] = ACTIONS(4767),
    [anon_sym_not] = ACTIONS(4769),
    [anon_sym_BANG] = ACTIONS(4771),
    [anon_sym_TILDE] = ACTIONS(4771),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2829] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(298),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2833),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2833),
    [sym_assignment] = STATE(298),
    [sym_operator_assignment] = STATE(298),
    [sym_conditional] = STATE(298),
    [sym_range] = STATE(298),
    [sym_binary] = STATE(298),
    [sym_unary] = STATE(298),
    [sym_left_assignment_list] = STATE(2832),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2833),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2833),
    [sym_false] = STATE(2833),
    [sym_nil] = STATE(2833),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2735),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4763),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4615),
    [anon_sym_yield] = ACTIONS(4617),
    [anon_sym_break] = ACTIONS(4619),
    [anon_sym_next] = ACTIONS(4621),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4765),
    [anon_sym_defined_QMARK] = ACTIONS(4767),
    [anon_sym_not] = ACTIONS(4769),
    [anon_sym_BANG] = ACTIONS(4771),
    [anon_sym_TILDE] = ACTIONS(4771),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2830] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(8386),
    [sym__binary_star] = ACTIONS(8388),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(8390),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(8388),
    [anon_sym_AMP] = ACTIONS(8392),
    [anon_sym_LT] = ACTIONS(8394),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(8396),
    [anon_sym_DOT_DOT] = ACTIONS(8398),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8400),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(8402),
    [anon_sym_AMP_AMP] = ACTIONS(8402),
    [anon_sym_LT_LT] = ACTIONS(8404),
    [anon_sym_GT_GT] = ACTIONS(8404),
    [anon_sym_EQ_EQ] = ACTIONS(8406),
    [anon_sym_BANG_EQ] = ACTIONS(8402),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8402),
    [anon_sym_LT_EQ_GT] = ACTIONS(8402),
    [anon_sym_EQ_TILDE] = ACTIONS(8402),
    [anon_sym_BANG_TILDE] = ACTIONS(8402),
    [anon_sym_LT_EQ] = ACTIONS(8394),
    [anon_sym_GT] = ACTIONS(8394),
    [anon_sym_GT_EQ] = ACTIONS(8408),
    [anon_sym_CARET] = ACTIONS(8410),
    [anon_sym_PLUS] = ACTIONS(8386),
    [anon_sym_SLASH] = ACTIONS(8388),
    [anon_sym_PERCENT] = ACTIONS(8388),
    [sym_comment] = ACTIONS(87),
  },
  [2831] = {
    [aux_sym_exceptions_repeat1] = STATE(5327),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_COMMA] = ACTIONS(8412),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [2832] = {
    [anon_sym_EQ] = ACTIONS(8414),
    [sym_comment] = ACTIONS(87),
  },
  [2833] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(8416),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(8418),
    [anon_sym_DASH_EQ] = ACTIONS(8418),
    [anon_sym_STAR_EQ] = ACTIONS(8418),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8418),
    [anon_sym_SLASH_EQ] = ACTIONS(8418),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8418),
    [anon_sym_PIPE_EQ] = ACTIONS(8418),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8418),
    [anon_sym_AMP_EQ] = ACTIONS(8418),
    [anon_sym_PERCENT_EQ] = ACTIONS(8418),
    [anon_sym_GT_GT_EQ] = ACTIONS(8418),
    [anon_sym_LT_LT_EQ] = ACTIONS(8418),
    [anon_sym_CARET_EQ] = ACTIONS(8418),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2834] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(1855),
    [sym__binary_star] = ACTIONS(1857),
    [anon_sym_PIPE] = ACTIONS(1859),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_LT] = ACTIONS(1863),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(1865),
    [anon_sym_DOT_DOT] = ACTIONS(1867),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1869),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(1873),
    [anon_sym_AMP_AMP] = ACTIONS(1873),
    [anon_sym_LT_LT] = ACTIONS(1875),
    [anon_sym_GT_GT] = ACTIONS(1875),
    [anon_sym_EQ_EQ] = ACTIONS(1877),
    [anon_sym_BANG_EQ] = ACTIONS(1873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1873),
    [anon_sym_LT_EQ_GT] = ACTIONS(1873),
    [anon_sym_EQ_TILDE] = ACTIONS(1873),
    [anon_sym_BANG_TILDE] = ACTIONS(1873),
    [anon_sym_LT_EQ] = ACTIONS(1863),
    [anon_sym_GT] = ACTIONS(1863),
    [anon_sym_GT_EQ] = ACTIONS(1879),
    [anon_sym_CARET] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_SLASH] = ACTIONS(1857),
    [anon_sym_PERCENT] = ACTIONS(1857),
    [sym_comment] = ACTIONS(87),
  },
  [2835] = {
    [sym_string] = STATE(2835),
    [aux_sym_chained_string_repeat1] = STATE(2835),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(6214),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_do] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [2836] = {
    [sym__line_break] = ACTIONS(8420),
    [sym__heredoc_body_start] = ACTIONS(8420),
    [sym__binary_minus] = ACTIONS(8420),
    [sym__binary_star] = ACTIONS(8420),
    [ts_builtin_sym_end] = ACTIONS(8420),
    [anon_sym___END__] = ACTIONS(8420),
    [anon_sym_LBRACE] = ACTIONS(8420),
    [anon_sym_RBRACE] = ACTIONS(8420),
    [anon_sym_RPAREN] = ACTIONS(8420),
    [anon_sym_DOT] = ACTIONS(8422),
    [anon_sym_COMMA] = ACTIONS(8420),
    [anon_sym_PIPE] = ACTIONS(8422),
    [anon_sym_SEMI] = ACTIONS(8420),
    [anon_sym_STAR_STAR] = ACTIONS(8420),
    [anon_sym_AMP] = ACTIONS(8422),
    [anon_sym_LT] = ACTIONS(8422),
    [anon_sym_end] = ACTIONS(8420),
    [anon_sym_if] = ACTIONS(8420),
    [anon_sym_unless] = ACTIONS(8420),
    [anon_sym_while] = ACTIONS(8420),
    [anon_sym_until] = ACTIONS(8420),
    [anon_sym_rescue] = ACTIONS(8420),
    [anon_sym_do] = ACTIONS(8420),
    [anon_sym_when] = ACTIONS(8420),
    [anon_sym_elsif] = ACTIONS(8420),
    [anon_sym_else] = ACTIONS(8420),
    [anon_sym_then] = ACTIONS(8420),
    [anon_sym_ensure] = ACTIONS(8420),
    [anon_sym_EQ_GT] = ACTIONS(8420),
    [anon_sym_LBRACK] = ACTIONS(8420),
    [anon_sym_COLON_COLON2] = ACTIONS(8420),
    [anon_sym_AMP_DOT] = ACTIONS(8420),
    [anon_sym_QMARK] = ACTIONS(8420),
    [anon_sym_DOT_DOT] = ACTIONS(8422),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8420),
    [anon_sym_and] = ACTIONS(8420),
    [anon_sym_or] = ACTIONS(8420),
    [anon_sym_PIPE_PIPE] = ACTIONS(8420),
    [anon_sym_AMP_AMP] = ACTIONS(8420),
    [anon_sym_LT_LT] = ACTIONS(8420),
    [anon_sym_GT_GT] = ACTIONS(8420),
    [anon_sym_EQ_EQ] = ACTIONS(8422),
    [anon_sym_BANG_EQ] = ACTIONS(8420),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8420),
    [anon_sym_LT_EQ_GT] = ACTIONS(8420),
    [anon_sym_EQ_TILDE] = ACTIONS(8420),
    [anon_sym_BANG_TILDE] = ACTIONS(8420),
    [anon_sym_LT_EQ] = ACTIONS(8422),
    [anon_sym_GT] = ACTIONS(8422),
    [anon_sym_GT_EQ] = ACTIONS(8420),
    [anon_sym_CARET] = ACTIONS(8420),
    [anon_sym_PLUS] = ACTIONS(8420),
    [anon_sym_SLASH] = ACTIONS(8420),
    [anon_sym_PERCENT] = ACTIONS(8420),
    [sym_comment] = ACTIONS(87),
  },
  [2837] = {
    [anon_sym_end] = ACTIONS(8424),
    [sym_comment] = ACTIONS(87),
  },
  [2838] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(5331),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2848),
    [sym_scope_resolution] = STATE(2846),
    [sym_call] = STATE(2846),
    [sym_method_call] = STATE(2848),
    [sym_assignment] = STATE(5331),
    [sym_operator_assignment] = STATE(5331),
    [sym_conditional] = STATE(5331),
    [sym_range] = STATE(5331),
    [sym_binary] = STATE(5331),
    [sym_unary] = STATE(5331),
    [sym_left_assignment_list] = STATE(2847),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2848),
    [sym__variable] = STATE(2846),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2848),
    [sym_false] = STATE(2848),
    [sym_nil] = STATE(2848),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2849),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4775),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4777),
    [anon_sym_yield] = ACTIONS(4779),
    [anon_sym_break] = ACTIONS(4781),
    [anon_sym_next] = ACTIONS(4783),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4785),
    [anon_sym_defined_QMARK] = ACTIONS(4787),
    [anon_sym_not] = ACTIONS(4789),
    [anon_sym_BANG] = ACTIONS(4791),
    [anon_sym_TILDE] = ACTIONS(4791),
    [sym_constant] = ACTIONS(4793),
    [sym_identifier] = ACTIONS(4793),
    [sym_instance_variable] = ACTIONS(4795),
    [sym_class_variable] = ACTIONS(4795),
    [sym_global_variable] = ACTIONS(4795),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4793),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4793),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2839] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(5337),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1089),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(1089),
    [sym_argument_list] = STATE(1318),
    [sym__argument_list_with_parens] = STATE(5338),
    [sym__argument] = STATE(5339),
    [sym_splat_argument] = STATE(5339),
    [sym_hash_splat_argument] = STATE(5339),
    [sym_block_argument] = STATE(5339),
    [sym_assignment] = STATE(5337),
    [sym_operator_assignment] = STATE(5337),
    [sym_conditional] = STATE(5337),
    [sym_range] = STATE(5337),
    [sym_binary] = STATE(5337),
    [sym_unary] = STATE(5337),
    [sym_left_assignment_list] = STATE(1088),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1089),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1089),
    [sym_false] = STATE(1089),
    [sym_nil] = STATE(1089),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(5340),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(5339),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(8426),
    [sym__splat_star] = ACTIONS(8428),
    [sym__unary_minus] = ACTIONS(1937),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(8430),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1943),
    [anon_sym_yield] = ACTIONS(1945),
    [anon_sym_break] = ACTIONS(1947),
    [anon_sym_next] = ACTIONS(1949),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_in] = ACTIONS(377),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(1953),
    [anon_sym_not] = ACTIONS(1955),
    [anon_sym_BANG] = ACTIONS(4805),
    [anon_sym_TILDE] = ACTIONS(1957),
    [sym_constant] = ACTIONS(8432),
    [sym_identifier] = ACTIONS(8432),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2840] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(5337),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1089),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(1089),
    [sym_argument_list] = STATE(1324),
    [sym__argument_list_with_parens] = STATE(5338),
    [sym__argument] = STATE(5339),
    [sym_splat_argument] = STATE(5339),
    [sym_hash_splat_argument] = STATE(5339),
    [sym_block_argument] = STATE(5339),
    [sym_assignment] = STATE(5337),
    [sym_operator_assignment] = STATE(5337),
    [sym_conditional] = STATE(5337),
    [sym_range] = STATE(5337),
    [sym_binary] = STATE(5337),
    [sym_unary] = STATE(5337),
    [sym_left_assignment_list] = STATE(1088),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1089),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1089),
    [sym_false] = STATE(1089),
    [sym_nil] = STATE(1089),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(5340),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(5339),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(8426),
    [sym__splat_star] = ACTIONS(8428),
    [sym__unary_minus] = ACTIONS(1937),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(8430),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1943),
    [anon_sym_yield] = ACTIONS(1945),
    [anon_sym_break] = ACTIONS(1947),
    [anon_sym_next] = ACTIONS(1949),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_in] = ACTIONS(419),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(1953),
    [anon_sym_not] = ACTIONS(1955),
    [anon_sym_BANG] = ACTIONS(4805),
    [anon_sym_TILDE] = ACTIONS(1957),
    [sym_constant] = ACTIONS(8432),
    [sym_identifier] = ACTIONS(8432),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2841] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(5337),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1089),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(1089),
    [sym_argument_list] = STATE(1325),
    [sym__argument_list_with_parens] = STATE(5338),
    [sym__argument] = STATE(5339),
    [sym_splat_argument] = STATE(5339),
    [sym_hash_splat_argument] = STATE(5339),
    [sym_block_argument] = STATE(5339),
    [sym_assignment] = STATE(5337),
    [sym_operator_assignment] = STATE(5337),
    [sym_conditional] = STATE(5337),
    [sym_range] = STATE(5337),
    [sym_binary] = STATE(5337),
    [sym_unary] = STATE(5337),
    [sym_left_assignment_list] = STATE(1088),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1089),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1089),
    [sym_false] = STATE(1089),
    [sym_nil] = STATE(1089),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(5340),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(5339),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(8426),
    [sym__splat_star] = ACTIONS(8428),
    [sym__unary_minus] = ACTIONS(1937),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(8430),
    [anon_sym_LBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1943),
    [anon_sym_yield] = ACTIONS(1945),
    [anon_sym_break] = ACTIONS(1947),
    [anon_sym_next] = ACTIONS(1949),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_in] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(1953),
    [anon_sym_not] = ACTIONS(1955),
    [anon_sym_BANG] = ACTIONS(4805),
    [anon_sym_TILDE] = ACTIONS(1957),
    [sym_constant] = ACTIONS(8432),
    [sym_identifier] = ACTIONS(8432),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2842] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(5337),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1089),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(1089),
    [sym_argument_list] = STATE(1326),
    [sym__argument_list_with_parens] = STATE(5338),
    [sym__argument] = STATE(5339),
    [sym_splat_argument] = STATE(5339),
    [sym_hash_splat_argument] = STATE(5339),
    [sym_block_argument] = STATE(5339),
    [sym_assignment] = STATE(5337),
    [sym_operator_assignment] = STATE(5337),
    [sym_conditional] = STATE(5337),
    [sym_range] = STATE(5337),
    [sym_binary] = STATE(5337),
    [sym_unary] = STATE(5337),
    [sym_left_assignment_list] = STATE(1088),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1089),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1089),
    [sym_false] = STATE(1089),
    [sym_nil] = STATE(1089),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(5340),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(5339),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(8426),
    [sym__splat_star] = ACTIONS(8428),
    [sym__unary_minus] = ACTIONS(1937),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(8430),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1943),
    [anon_sym_yield] = ACTIONS(1945),
    [anon_sym_break] = ACTIONS(1947),
    [anon_sym_next] = ACTIONS(1949),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_in] = ACTIONS(427),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(1953),
    [anon_sym_not] = ACTIONS(1955),
    [anon_sym_BANG] = ACTIONS(4805),
    [anon_sym_TILDE] = ACTIONS(1957),
    [sym_constant] = ACTIONS(8432),
    [sym_identifier] = ACTIONS(8432),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2843] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(5341),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2848),
    [sym_scope_resolution] = STATE(2846),
    [sym_call] = STATE(2846),
    [sym_method_call] = STATE(2848),
    [sym_assignment] = STATE(5341),
    [sym_operator_assignment] = STATE(5341),
    [sym_conditional] = STATE(5341),
    [sym_range] = STATE(5341),
    [sym_binary] = STATE(5341),
    [sym_unary] = STATE(5341),
    [sym_left_assignment_list] = STATE(2847),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2848),
    [sym__variable] = STATE(2846),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2848),
    [sym_false] = STATE(2848),
    [sym_nil] = STATE(2848),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2849),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4775),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4777),
    [anon_sym_yield] = ACTIONS(4779),
    [anon_sym_break] = ACTIONS(4781),
    [anon_sym_next] = ACTIONS(4783),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4785),
    [anon_sym_defined_QMARK] = ACTIONS(4787),
    [anon_sym_not] = ACTIONS(4789),
    [anon_sym_BANG] = ACTIONS(4791),
    [anon_sym_TILDE] = ACTIONS(4791),
    [sym_constant] = ACTIONS(4793),
    [sym_identifier] = ACTIONS(4793),
    [sym_instance_variable] = ACTIONS(4795),
    [sym_class_variable] = ACTIONS(4795),
    [sym_global_variable] = ACTIONS(4795),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4793),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4793),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2844] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(1872),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2848),
    [sym_scope_resolution] = STATE(2846),
    [sym_call] = STATE(2846),
    [sym_method_call] = STATE(2848),
    [sym_assignment] = STATE(1872),
    [sym_operator_assignment] = STATE(1872),
    [sym_conditional] = STATE(1872),
    [sym_range] = STATE(1872),
    [sym_binary] = STATE(1872),
    [sym_unary] = STATE(1872),
    [sym_left_assignment_list] = STATE(2847),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2848),
    [sym__variable] = STATE(2846),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2848),
    [sym_false] = STATE(2848),
    [sym_nil] = STATE(2848),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2849),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4775),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4777),
    [anon_sym_yield] = ACTIONS(4779),
    [anon_sym_break] = ACTIONS(4781),
    [anon_sym_next] = ACTIONS(4783),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4785),
    [anon_sym_defined_QMARK] = ACTIONS(4787),
    [anon_sym_not] = ACTIONS(4789),
    [anon_sym_BANG] = ACTIONS(4791),
    [anon_sym_TILDE] = ACTIONS(4791),
    [sym_constant] = ACTIONS(4793),
    [sym_identifier] = ACTIONS(4793),
    [sym_instance_variable] = ACTIONS(4795),
    [sym_class_variable] = ACTIONS(4795),
    [sym_global_variable] = ACTIONS(4795),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4793),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4793),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2845] = {
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(8434),
    [sym__binary_star] = ACTIONS(8436),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(8438),
    [anon_sym_STAR_STAR] = ACTIONS(8436),
    [anon_sym_AMP] = ACTIONS(8440),
    [anon_sym_LT] = ACTIONS(8442),
    [anon_sym_in] = ACTIONS(4211),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(8444),
    [anon_sym_DOT_DOT] = ACTIONS(8446),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8448),
    [anon_sym_and] = ACTIONS(8450),
    [anon_sym_or] = ACTIONS(8450),
    [anon_sym_PIPE_PIPE] = ACTIONS(8452),
    [anon_sym_AMP_AMP] = ACTIONS(8452),
    [anon_sym_LT_LT] = ACTIONS(8454),
    [anon_sym_GT_GT] = ACTIONS(8454),
    [anon_sym_EQ_EQ] = ACTIONS(8456),
    [anon_sym_BANG_EQ] = ACTIONS(8452),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8452),
    [anon_sym_LT_EQ_GT] = ACTIONS(8452),
    [anon_sym_EQ_TILDE] = ACTIONS(8452),
    [anon_sym_BANG_TILDE] = ACTIONS(8452),
    [anon_sym_LT_EQ] = ACTIONS(8442),
    [anon_sym_GT] = ACTIONS(8442),
    [anon_sym_GT_EQ] = ACTIONS(8458),
    [anon_sym_CARET] = ACTIONS(8460),
    [anon_sym_PLUS] = ACTIONS(8434),
    [anon_sym_SLASH] = ACTIONS(8436),
    [anon_sym_PERCENT] = ACTIONS(8436),
    [sym_comment] = ACTIONS(87),
  },
  [2846] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(5357),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2892),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(2892),
    [sym_argument_list] = STATE(4801),
    [sym__argument_list_with_parens] = STATE(5358),
    [sym__argument] = STATE(5359),
    [sym_splat_argument] = STATE(5359),
    [sym_hash_splat_argument] = STATE(5359),
    [sym_block_argument] = STATE(5359),
    [sym_do_block] = STATE(1849),
    [sym_block] = STATE(1849),
    [sym_assignment] = STATE(5357),
    [sym_operator_assignment] = STATE(5357),
    [sym_conditional] = STATE(5357),
    [sym_range] = STATE(5357),
    [sym_binary] = STATE(5357),
    [sym_unary] = STATE(5357),
    [sym_left_assignment_list] = STATE(2891),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2892),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2892),
    [sym_false] = STATE(2892),
    [sym_nil] = STATE(2892),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(5360),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(5359),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(8462),
    [sym__splat_star] = ACTIONS(8464),
    [sym__unary_minus] = ACTIONS(4843),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(8466),
    [anon_sym_LBRACE] = ACTIONS(7739),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4847),
    [anon_sym_yield] = ACTIONS(4849),
    [anon_sym_break] = ACTIONS(4851),
    [anon_sym_next] = ACTIONS(4853),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_in] = ACTIONS(769),
    [anon_sym_do] = ACTIONS(769),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(4855),
    [anon_sym_not] = ACTIONS(4857),
    [anon_sym_BANG] = ACTIONS(4859),
    [anon_sym_TILDE] = ACTIONS(4861),
    [sym_constant] = ACTIONS(8468),
    [sym_identifier] = ACTIONS(8468),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2847] = {
    [anon_sym_EQ] = ACTIONS(8470),
    [sym_comment] = ACTIONS(87),
  },
  [2848] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(8472),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_in] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(8474),
    [anon_sym_DASH_EQ] = ACTIONS(8474),
    [anon_sym_STAR_EQ] = ACTIONS(8474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8474),
    [anon_sym_SLASH_EQ] = ACTIONS(8474),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8474),
    [anon_sym_PIPE_EQ] = ACTIONS(8474),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8474),
    [anon_sym_AMP_EQ] = ACTIONS(8474),
    [anon_sym_PERCENT_EQ] = ACTIONS(8474),
    [anon_sym_GT_GT_EQ] = ACTIONS(8474),
    [anon_sym_LT_LT_EQ] = ACTIONS(8474),
    [anon_sym_CARET_EQ] = ACTIONS(8474),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2849] = {
    [sym_string] = STATE(5363),
    [aux_sym_chained_string_repeat1] = STATE(5363),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_in] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2850] = {
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(8434),
    [sym__binary_star] = ACTIONS(8436),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(8438),
    [anon_sym_STAR_STAR] = ACTIONS(8436),
    [anon_sym_AMP] = ACTIONS(8440),
    [anon_sym_LT] = ACTIONS(8442),
    [anon_sym_in] = ACTIONS(4247),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(8444),
    [anon_sym_DOT_DOT] = ACTIONS(8446),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8448),
    [anon_sym_and] = ACTIONS(8450),
    [anon_sym_or] = ACTIONS(8450),
    [anon_sym_PIPE_PIPE] = ACTIONS(8452),
    [anon_sym_AMP_AMP] = ACTIONS(8452),
    [anon_sym_LT_LT] = ACTIONS(8454),
    [anon_sym_GT_GT] = ACTIONS(8454),
    [anon_sym_EQ_EQ] = ACTIONS(8456),
    [anon_sym_BANG_EQ] = ACTIONS(8452),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8452),
    [anon_sym_LT_EQ_GT] = ACTIONS(8452),
    [anon_sym_EQ_TILDE] = ACTIONS(8452),
    [anon_sym_BANG_TILDE] = ACTIONS(8452),
    [anon_sym_LT_EQ] = ACTIONS(8442),
    [anon_sym_GT] = ACTIONS(8442),
    [anon_sym_GT_EQ] = ACTIONS(8458),
    [anon_sym_CARET] = ACTIONS(8460),
    [anon_sym_PLUS] = ACTIONS(8434),
    [anon_sym_SLASH] = ACTIONS(8436),
    [anon_sym_PERCENT] = ACTIONS(8436),
    [sym_comment] = ACTIONS(87),
  },
  [2851] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(4813),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_in] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [2852] = {
    [sym_string] = STATE(2899),
    [aux_sym_chained_string_repeat1] = STATE(2899),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_in] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2853] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(5364),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2848),
    [sym_scope_resolution] = STATE(2846),
    [sym_call] = STATE(2846),
    [sym_method_call] = STATE(2848),
    [sym_assignment] = STATE(5364),
    [sym_operator_assignment] = STATE(5364),
    [sym_conditional] = STATE(5364),
    [sym_range] = STATE(5364),
    [sym_binary] = STATE(5364),
    [sym_unary] = STATE(5364),
    [sym_left_assignment_list] = STATE(2847),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2848),
    [sym__variable] = STATE(2846),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2848),
    [sym_false] = STATE(2848),
    [sym_nil] = STATE(2848),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2849),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4775),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4777),
    [anon_sym_yield] = ACTIONS(4779),
    [anon_sym_break] = ACTIONS(4781),
    [anon_sym_next] = ACTIONS(4783),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4785),
    [anon_sym_defined_QMARK] = ACTIONS(4787),
    [anon_sym_not] = ACTIONS(4789),
    [anon_sym_BANG] = ACTIONS(4791),
    [anon_sym_TILDE] = ACTIONS(4791),
    [sym_constant] = ACTIONS(4793),
    [sym_identifier] = ACTIONS(4793),
    [sym_instance_variable] = ACTIONS(4795),
    [sym_class_variable] = ACTIONS(4795),
    [sym_global_variable] = ACTIONS(4795),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4793),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4793),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2854] = {
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(8434),
    [sym__binary_star] = ACTIONS(8436),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(8438),
    [anon_sym_STAR_STAR] = ACTIONS(8436),
    [anon_sym_AMP] = ACTIONS(8440),
    [anon_sym_LT] = ACTIONS(8442),
    [anon_sym_in] = ACTIONS(3281),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(8444),
    [anon_sym_DOT_DOT] = ACTIONS(8446),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8448),
    [anon_sym_and] = ACTIONS(8450),
    [anon_sym_or] = ACTIONS(8450),
    [anon_sym_PIPE_PIPE] = ACTIONS(8452),
    [anon_sym_AMP_AMP] = ACTIONS(8452),
    [anon_sym_LT_LT] = ACTIONS(8454),
    [anon_sym_GT_GT] = ACTIONS(8454),
    [anon_sym_EQ_EQ] = ACTIONS(8456),
    [anon_sym_BANG_EQ] = ACTIONS(8452),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8452),
    [anon_sym_LT_EQ_GT] = ACTIONS(8452),
    [anon_sym_EQ_TILDE] = ACTIONS(8452),
    [anon_sym_BANG_TILDE] = ACTIONS(8452),
    [anon_sym_LT_EQ] = ACTIONS(8442),
    [anon_sym_GT] = ACTIONS(8442),
    [anon_sym_GT_EQ] = ACTIONS(8458),
    [anon_sym_CARET] = ACTIONS(8460),
    [anon_sym_PLUS] = ACTIONS(8434),
    [anon_sym_SLASH] = ACTIONS(8436),
    [anon_sym_PERCENT] = ACTIONS(8436),
    [sym_comment] = ACTIONS(87),
  },
  [2855] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(5365),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1089),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(1089),
    [sym_assignment] = STATE(5365),
    [sym_operator_assignment] = STATE(5365),
    [sym_conditional] = STATE(5365),
    [sym_range] = STATE(5365),
    [sym_binary] = STATE(5365),
    [sym_unary] = STATE(5365),
    [sym_left_assignment_list] = STATE(1088),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1089),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1089),
    [sym_false] = STATE(1089),
    [sym_nil] = STATE(1089),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1937),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1943),
    [anon_sym_yield] = ACTIONS(1945),
    [anon_sym_break] = ACTIONS(1947),
    [anon_sym_next] = ACTIONS(1949),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1951),
    [anon_sym_defined_QMARK] = ACTIONS(1953),
    [anon_sym_not] = ACTIONS(1955),
    [anon_sym_BANG] = ACTIONS(1957),
    [anon_sym_TILDE] = ACTIONS(1957),
    [sym_constant] = ACTIONS(1963),
    [sym_identifier] = ACTIONS(1963),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2856] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(5366),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1089),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(1089),
    [sym_assignment] = STATE(5366),
    [sym_operator_assignment] = STATE(5366),
    [sym_conditional] = STATE(5366),
    [sym_range] = STATE(5366),
    [sym_binary] = STATE(5366),
    [sym_unary] = STATE(5366),
    [sym_left_assignment_list] = STATE(1088),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1089),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1089),
    [sym_false] = STATE(1089),
    [sym_nil] = STATE(1089),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1937),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1943),
    [anon_sym_yield] = ACTIONS(1945),
    [anon_sym_break] = ACTIONS(1947),
    [anon_sym_next] = ACTIONS(1949),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1951),
    [anon_sym_defined_QMARK] = ACTIONS(1953),
    [anon_sym_not] = ACTIONS(1955),
    [anon_sym_BANG] = ACTIONS(1957),
    [anon_sym_TILDE] = ACTIONS(1957),
    [sym_constant] = ACTIONS(1963),
    [sym_identifier] = ACTIONS(1963),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2857] = {
    [anon_sym_COLON] = ACTIONS(8476),
    [sym_comment] = ACTIONS(87),
  },
  [2858] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(5368),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1089),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(1089),
    [sym_assignment] = STATE(5368),
    [sym_operator_assignment] = STATE(5368),
    [sym_conditional] = STATE(5368),
    [sym_range] = STATE(5368),
    [sym_binary] = STATE(5368),
    [sym_unary] = STATE(5368),
    [sym_left_assignment_list] = STATE(1088),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1089),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1089),
    [sym_false] = STATE(1089),
    [sym_nil] = STATE(1089),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1937),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1943),
    [anon_sym_yield] = ACTIONS(1945),
    [anon_sym_break] = ACTIONS(1947),
    [anon_sym_next] = ACTIONS(1949),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1951),
    [anon_sym_defined_QMARK] = ACTIONS(1953),
    [anon_sym_not] = ACTIONS(1955),
    [anon_sym_BANG] = ACTIONS(1957),
    [anon_sym_TILDE] = ACTIONS(1957),
    [sym_constant] = ACTIONS(1963),
    [sym_identifier] = ACTIONS(1963),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2859] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(8478),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [2860] = {
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(4811),
    [sym__binary_star] = ACTIONS(4813),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(4815),
    [anon_sym_STAR_STAR] = ACTIONS(4813),
    [anon_sym_AMP] = ACTIONS(4817),
    [anon_sym_LT] = ACTIONS(4819),
    [anon_sym_in] = ACTIONS(1625),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(1625),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(4821),
    [anon_sym_DOT_DOT] = ACTIONS(4823),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4825),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(4829),
    [anon_sym_AMP_AMP] = ACTIONS(4829),
    [anon_sym_LT_LT] = ACTIONS(4831),
    [anon_sym_GT_GT] = ACTIONS(4831),
    [anon_sym_EQ_EQ] = ACTIONS(4833),
    [anon_sym_BANG_EQ] = ACTIONS(4829),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4829),
    [anon_sym_LT_EQ_GT] = ACTIONS(4829),
    [anon_sym_EQ_TILDE] = ACTIONS(4829),
    [anon_sym_BANG_TILDE] = ACTIONS(4829),
    [anon_sym_LT_EQ] = ACTIONS(4819),
    [anon_sym_GT] = ACTIONS(4819),
    [anon_sym_GT_EQ] = ACTIONS(4835),
    [anon_sym_CARET] = ACTIONS(4837),
    [anon_sym_PLUS] = ACTIONS(4811),
    [anon_sym_SLASH] = ACTIONS(4813),
    [anon_sym_PERCENT] = ACTIONS(4813),
    [sym_comment] = ACTIONS(87),
  },
  [2861] = {
    [sym_heredoc_body] = STATE(5370),
    [aux_sym_call_repeat1] = STATE(5370),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_in] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [2862] = {
    [sym_heredoc_body] = STATE(5370),
    [aux_sym_call_repeat1] = STATE(5370),
    [aux_sym_argument_list_repeat1] = STATE(5372),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(8480),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_in] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [2863] = {
    [sym_string] = STATE(2899),
    [aux_sym_chained_string_repeat1] = STATE(2899),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(8482),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_in] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2864] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(4811),
    [sym__binary_star] = ACTIONS(4813),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(4815),
    [anon_sym_STAR_STAR] = ACTIONS(4813),
    [anon_sym_AMP] = ACTIONS(4817),
    [anon_sym_LT] = ACTIONS(4819),
    [anon_sym_in] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(4821),
    [anon_sym_DOT_DOT] = ACTIONS(4823),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4825),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(4829),
    [anon_sym_AMP_AMP] = ACTIONS(4829),
    [anon_sym_LT_LT] = ACTIONS(4831),
    [anon_sym_GT_GT] = ACTIONS(4831),
    [anon_sym_EQ_EQ] = ACTIONS(4833),
    [anon_sym_BANG_EQ] = ACTIONS(4829),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4829),
    [anon_sym_LT_EQ_GT] = ACTIONS(4829),
    [anon_sym_EQ_TILDE] = ACTIONS(4829),
    [anon_sym_BANG_TILDE] = ACTIONS(4829),
    [anon_sym_LT_EQ] = ACTIONS(4819),
    [anon_sym_GT] = ACTIONS(4819),
    [anon_sym_GT_EQ] = ACTIONS(4835),
    [anon_sym_CARET] = ACTIONS(4837),
    [anon_sym_PLUS] = ACTIONS(4811),
    [anon_sym_SLASH] = ACTIONS(4813),
    [anon_sym_PERCENT] = ACTIONS(4813),
    [sym_comment] = ACTIONS(87),
  },
  [2865] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(5373),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2848),
    [sym_scope_resolution] = STATE(2846),
    [sym_call] = STATE(2846),
    [sym_method_call] = STATE(2848),
    [sym_assignment] = STATE(5373),
    [sym_operator_assignment] = STATE(5373),
    [sym_conditional] = STATE(5373),
    [sym_range] = STATE(5373),
    [sym_binary] = STATE(5373),
    [sym_unary] = STATE(5373),
    [sym_left_assignment_list] = STATE(2847),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2848),
    [sym__variable] = STATE(2846),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2848),
    [sym_false] = STATE(2848),
    [sym_nil] = STATE(2848),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2849),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4775),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4777),
    [anon_sym_yield] = ACTIONS(4779),
    [anon_sym_break] = ACTIONS(4781),
    [anon_sym_next] = ACTIONS(4783),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4785),
    [anon_sym_defined_QMARK] = ACTIONS(4787),
    [anon_sym_not] = ACTIONS(4789),
    [anon_sym_BANG] = ACTIONS(4791),
    [anon_sym_TILDE] = ACTIONS(4791),
    [sym_constant] = ACTIONS(4793),
    [sym_identifier] = ACTIONS(4793),
    [sym_instance_variable] = ACTIONS(4795),
    [sym_class_variable] = ACTIONS(4795),
    [sym_global_variable] = ACTIONS(4795),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4793),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4793),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2866] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(5374),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1089),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(1089),
    [sym_assignment] = STATE(5374),
    [sym_operator_assignment] = STATE(5374),
    [sym_conditional] = STATE(5374),
    [sym_range] = STATE(5374),
    [sym_binary] = STATE(5374),
    [sym_unary] = STATE(5374),
    [sym_left_assignment_list] = STATE(1088),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1089),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1089),
    [sym_false] = STATE(1089),
    [sym_nil] = STATE(1089),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1937),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1943),
    [anon_sym_yield] = ACTIONS(1945),
    [anon_sym_break] = ACTIONS(1947),
    [anon_sym_next] = ACTIONS(1949),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1951),
    [anon_sym_defined_QMARK] = ACTIONS(1953),
    [anon_sym_not] = ACTIONS(1955),
    [anon_sym_BANG] = ACTIONS(1957),
    [anon_sym_TILDE] = ACTIONS(1957),
    [sym_constant] = ACTIONS(1963),
    [sym_identifier] = ACTIONS(1963),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2867] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(5375),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1089),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(1089),
    [sym_assignment] = STATE(5375),
    [sym_operator_assignment] = STATE(5375),
    [sym_conditional] = STATE(5375),
    [sym_range] = STATE(5375),
    [sym_binary] = STATE(5375),
    [sym_unary] = STATE(5375),
    [sym_left_assignment_list] = STATE(1088),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1089),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1089),
    [sym_false] = STATE(1089),
    [sym_nil] = STATE(1089),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1937),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1943),
    [anon_sym_yield] = ACTIONS(1945),
    [anon_sym_break] = ACTIONS(1947),
    [anon_sym_next] = ACTIONS(1949),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1951),
    [anon_sym_defined_QMARK] = ACTIONS(1953),
    [anon_sym_not] = ACTIONS(1955),
    [anon_sym_BANG] = ACTIONS(1957),
    [anon_sym_TILDE] = ACTIONS(1957),
    [sym_constant] = ACTIONS(1963),
    [sym_identifier] = ACTIONS(1963),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2868] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(5376),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1089),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(1089),
    [sym_assignment] = STATE(5376),
    [sym_operator_assignment] = STATE(5376),
    [sym_conditional] = STATE(5376),
    [sym_range] = STATE(5376),
    [sym_binary] = STATE(5376),
    [sym_unary] = STATE(5376),
    [sym_left_assignment_list] = STATE(1088),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1089),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1089),
    [sym_false] = STATE(1089),
    [sym_nil] = STATE(1089),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1937),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1943),
    [anon_sym_yield] = ACTIONS(1945),
    [anon_sym_break] = ACTIONS(1947),
    [anon_sym_next] = ACTIONS(1949),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1951),
    [anon_sym_defined_QMARK] = ACTIONS(1953),
    [anon_sym_not] = ACTIONS(1955),
    [anon_sym_BANG] = ACTIONS(1957),
    [anon_sym_TILDE] = ACTIONS(1957),
    [sym_constant] = ACTIONS(1963),
    [sym_identifier] = ACTIONS(1963),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2869] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(5377),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1089),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(1089),
    [sym_assignment] = STATE(5377),
    [sym_operator_assignment] = STATE(5377),
    [sym_conditional] = STATE(5377),
    [sym_range] = STATE(5377),
    [sym_binary] = STATE(5377),
    [sym_unary] = STATE(5377),
    [sym_left_assignment_list] = STATE(1088),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1089),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1089),
    [sym_false] = STATE(1089),
    [sym_nil] = STATE(1089),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1937),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1943),
    [anon_sym_yield] = ACTIONS(1945),
    [anon_sym_break] = ACTIONS(1947),
    [anon_sym_next] = ACTIONS(1949),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1951),
    [anon_sym_defined_QMARK] = ACTIONS(1953),
    [anon_sym_not] = ACTIONS(1955),
    [anon_sym_BANG] = ACTIONS(1957),
    [anon_sym_TILDE] = ACTIONS(1957),
    [sym_constant] = ACTIONS(1963),
    [sym_identifier] = ACTIONS(1963),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2870] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(5378),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1089),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(1089),
    [sym_assignment] = STATE(5378),
    [sym_operator_assignment] = STATE(5378),
    [sym_conditional] = STATE(5378),
    [sym_range] = STATE(5378),
    [sym_binary] = STATE(5378),
    [sym_unary] = STATE(5378),
    [sym_left_assignment_list] = STATE(1088),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1089),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1089),
    [sym_false] = STATE(1089),
    [sym_nil] = STATE(1089),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1937),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1943),
    [anon_sym_yield] = ACTIONS(1945),
    [anon_sym_break] = ACTIONS(1947),
    [anon_sym_next] = ACTIONS(1949),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1951),
    [anon_sym_defined_QMARK] = ACTIONS(1953),
    [anon_sym_not] = ACTIONS(1955),
    [anon_sym_BANG] = ACTIONS(1957),
    [anon_sym_TILDE] = ACTIONS(1957),
    [sym_constant] = ACTIONS(1963),
    [sym_identifier] = ACTIONS(1963),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2871] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(5379),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(5379),
    [sym_operator_assignment] = STATE(5379),
    [sym_conditional] = STATE(5379),
    [sym_range] = STATE(5379),
    [sym_binary] = STATE(5379),
    [sym_unary] = STATE(5379),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2872] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(5380),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1089),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(1089),
    [sym_assignment] = STATE(5380),
    [sym_operator_assignment] = STATE(5380),
    [sym_conditional] = STATE(5380),
    [sym_range] = STATE(5380),
    [sym_binary] = STATE(5380),
    [sym_unary] = STATE(5380),
    [sym_left_assignment_list] = STATE(1088),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1089),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1089),
    [sym_false] = STATE(1089),
    [sym_nil] = STATE(1089),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1937),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1943),
    [anon_sym_yield] = ACTIONS(1945),
    [anon_sym_break] = ACTIONS(1947),
    [anon_sym_next] = ACTIONS(1949),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1951),
    [anon_sym_defined_QMARK] = ACTIONS(1953),
    [anon_sym_not] = ACTIONS(1955),
    [anon_sym_BANG] = ACTIONS(1957),
    [anon_sym_TILDE] = ACTIONS(1957),
    [sym_constant] = ACTIONS(1963),
    [sym_identifier] = ACTIONS(1963),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2873] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(5381),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1089),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(1089),
    [sym_assignment] = STATE(5381),
    [sym_operator_assignment] = STATE(5381),
    [sym_conditional] = STATE(5381),
    [sym_range] = STATE(5381),
    [sym_binary] = STATE(5381),
    [sym_unary] = STATE(5381),
    [sym_left_assignment_list] = STATE(1088),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1089),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1089),
    [sym_false] = STATE(1089),
    [sym_nil] = STATE(1089),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1937),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1943),
    [anon_sym_yield] = ACTIONS(1945),
    [anon_sym_break] = ACTIONS(1947),
    [anon_sym_next] = ACTIONS(1949),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1951),
    [anon_sym_defined_QMARK] = ACTIONS(1953),
    [anon_sym_not] = ACTIONS(1955),
    [anon_sym_BANG] = ACTIONS(1957),
    [anon_sym_TILDE] = ACTIONS(1957),
    [sym_constant] = ACTIONS(1963),
    [sym_identifier] = ACTIONS(1963),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2874] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(5382),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1089),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(1089),
    [sym_assignment] = STATE(5382),
    [sym_operator_assignment] = STATE(5382),
    [sym_conditional] = STATE(5382),
    [sym_range] = STATE(5382),
    [sym_binary] = STATE(5382),
    [sym_unary] = STATE(5382),
    [sym_left_assignment_list] = STATE(1088),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1089),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1089),
    [sym_false] = STATE(1089),
    [sym_nil] = STATE(1089),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1937),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1943),
    [anon_sym_yield] = ACTIONS(1945),
    [anon_sym_break] = ACTIONS(1947),
    [anon_sym_next] = ACTIONS(1949),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1951),
    [anon_sym_defined_QMARK] = ACTIONS(1953),
    [anon_sym_not] = ACTIONS(1955),
    [anon_sym_BANG] = ACTIONS(1957),
    [anon_sym_TILDE] = ACTIONS(1957),
    [sym_constant] = ACTIONS(1963),
    [sym_identifier] = ACTIONS(1963),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2875] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(5383),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1089),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(1089),
    [sym_assignment] = STATE(5383),
    [sym_operator_assignment] = STATE(5383),
    [sym_conditional] = STATE(5383),
    [sym_range] = STATE(5383),
    [sym_binary] = STATE(5383),
    [sym_unary] = STATE(5383),
    [sym_left_assignment_list] = STATE(1088),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1089),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1089),
    [sym_false] = STATE(1089),
    [sym_nil] = STATE(1089),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1937),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1943),
    [anon_sym_yield] = ACTIONS(1945),
    [anon_sym_break] = ACTIONS(1947),
    [anon_sym_next] = ACTIONS(1949),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1951),
    [anon_sym_defined_QMARK] = ACTIONS(1953),
    [anon_sym_not] = ACTIONS(1955),
    [anon_sym_BANG] = ACTIONS(1957),
    [anon_sym_TILDE] = ACTIONS(1957),
    [sym_constant] = ACTIONS(1963),
    [sym_identifier] = ACTIONS(1963),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2876] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(5384),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2892),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(2892),
    [sym_assignment] = STATE(5384),
    [sym_operator_assignment] = STATE(5384),
    [sym_conditional] = STATE(5384),
    [sym_range] = STATE(5384),
    [sym_binary] = STATE(5384),
    [sym_unary] = STATE(5384),
    [sym_left_assignment_list] = STATE(2891),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2892),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2892),
    [sym_false] = STATE(2892),
    [sym_nil] = STATE(2892),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(5385),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(4843),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4847),
    [anon_sym_yield] = ACTIONS(4849),
    [anon_sym_break] = ACTIONS(4851),
    [anon_sym_next] = ACTIONS(4853),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(8484),
    [anon_sym_defined_QMARK] = ACTIONS(4855),
    [anon_sym_not] = ACTIONS(4857),
    [anon_sym_BANG] = ACTIONS(4861),
    [anon_sym_TILDE] = ACTIONS(4861),
    [sym_constant] = ACTIONS(1963),
    [sym_identifier] = ACTIONS(1963),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2877] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(5386),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2892),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(2892),
    [sym_assignment] = STATE(5386),
    [sym_operator_assignment] = STATE(5386),
    [sym_conditional] = STATE(5386),
    [sym_range] = STATE(5386),
    [sym_binary] = STATE(5386),
    [sym_unary] = STATE(5386),
    [sym_left_assignment_list] = STATE(2891),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2892),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2892),
    [sym_false] = STATE(2892),
    [sym_nil] = STATE(2892),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(5385),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(4843),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4847),
    [anon_sym_yield] = ACTIONS(4849),
    [anon_sym_break] = ACTIONS(4851),
    [anon_sym_next] = ACTIONS(4853),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(8484),
    [anon_sym_defined_QMARK] = ACTIONS(4855),
    [anon_sym_not] = ACTIONS(4857),
    [anon_sym_BANG] = ACTIONS(4861),
    [anon_sym_TILDE] = ACTIONS(4861),
    [sym_constant] = ACTIONS(1963),
    [sym_identifier] = ACTIONS(1963),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2878] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(5387),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2892),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(2892),
    [sym_assignment] = STATE(5387),
    [sym_operator_assignment] = STATE(5387),
    [sym_conditional] = STATE(5387),
    [sym_range] = STATE(5387),
    [sym_binary] = STATE(5387),
    [sym_unary] = STATE(5387),
    [sym_left_assignment_list] = STATE(2891),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2892),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2892),
    [sym_false] = STATE(2892),
    [sym_nil] = STATE(2892),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(5385),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(4843),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4847),
    [anon_sym_yield] = ACTIONS(4849),
    [anon_sym_break] = ACTIONS(4851),
    [anon_sym_next] = ACTIONS(4853),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(8484),
    [anon_sym_defined_QMARK] = ACTIONS(4855),
    [anon_sym_not] = ACTIONS(4857),
    [anon_sym_BANG] = ACTIONS(4861),
    [anon_sym_TILDE] = ACTIONS(4861),
    [sym_constant] = ACTIONS(1963),
    [sym_identifier] = ACTIONS(1963),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2879] = {
    [anon_sym_COLON] = ACTIONS(8486),
    [sym_comment] = ACTIONS(87),
  },
  [2880] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(5389),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2892),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(2892),
    [sym_assignment] = STATE(5389),
    [sym_operator_assignment] = STATE(5389),
    [sym_conditional] = STATE(5389),
    [sym_range] = STATE(5389),
    [sym_binary] = STATE(5389),
    [sym_unary] = STATE(5389),
    [sym_left_assignment_list] = STATE(2891),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2892),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2892),
    [sym_false] = STATE(2892),
    [sym_nil] = STATE(2892),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(5385),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(4843),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4847),
    [anon_sym_yield] = ACTIONS(4849),
    [anon_sym_break] = ACTIONS(4851),
    [anon_sym_next] = ACTIONS(4853),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(8484),
    [anon_sym_defined_QMARK] = ACTIONS(4855),
    [anon_sym_not] = ACTIONS(4857),
    [anon_sym_BANG] = ACTIONS(4861),
    [anon_sym_TILDE] = ACTIONS(4861),
    [sym_constant] = ACTIONS(1963),
    [sym_identifier] = ACTIONS(1963),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2881] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(2888),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2892),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(2892),
    [sym_argument_list] = STATE(1973),
    [sym__argument_list_with_parens] = STATE(2889),
    [sym__argument] = STATE(2890),
    [sym_splat_argument] = STATE(2890),
    [sym_hash_splat_argument] = STATE(2890),
    [sym_block_argument] = STATE(2890),
    [sym_assignment] = STATE(2888),
    [sym_operator_assignment] = STATE(2888),
    [sym_conditional] = STATE(2888),
    [sym_range] = STATE(2888),
    [sym_binary] = STATE(2888),
    [sym_unary] = STATE(2888),
    [sym_left_assignment_list] = STATE(2891),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2892),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2892),
    [sym_false] = STATE(2892),
    [sym_nil] = STATE(2892),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(2893),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(2890),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(4839),
    [sym__splat_star] = ACTIONS(4841),
    [sym__unary_minus] = ACTIONS(4843),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(4845),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4847),
    [anon_sym_yield] = ACTIONS(4849),
    [anon_sym_break] = ACTIONS(4851),
    [anon_sym_next] = ACTIONS(4853),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_in] = ACTIONS(377),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(365),
    [anon_sym_DASH_EQ] = ACTIONS(365),
    [anon_sym_STAR_EQ] = ACTIONS(365),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(365),
    [anon_sym_SLASH_EQ] = ACTIONS(365),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(365),
    [anon_sym_PIPE_EQ] = ACTIONS(365),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(365),
    [anon_sym_AMP_EQ] = ACTIONS(365),
    [anon_sym_PERCENT_EQ] = ACTIONS(365),
    [anon_sym_GT_GT_EQ] = ACTIONS(365),
    [anon_sym_LT_LT_EQ] = ACTIONS(365),
    [anon_sym_CARET_EQ] = ACTIONS(365),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_PERCENT] = ACTIONS(377),
    [anon_sym_defined_QMARK] = ACTIONS(4855),
    [anon_sym_not] = ACTIONS(4857),
    [anon_sym_BANG] = ACTIONS(4859),
    [anon_sym_TILDE] = ACTIONS(4861),
    [sym_constant] = ACTIONS(4863),
    [sym_identifier] = ACTIONS(4863),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2882] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(2888),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2892),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(2892),
    [sym_argument_list] = STATE(1974),
    [sym__argument_list_with_parens] = STATE(2889),
    [sym__argument] = STATE(2890),
    [sym_splat_argument] = STATE(2890),
    [sym_hash_splat_argument] = STATE(2890),
    [sym_block_argument] = STATE(2890),
    [sym_assignment] = STATE(2888),
    [sym_operator_assignment] = STATE(2888),
    [sym_conditional] = STATE(2888),
    [sym_range] = STATE(2888),
    [sym_binary] = STATE(2888),
    [sym_unary] = STATE(2888),
    [sym_left_assignment_list] = STATE(2891),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2892),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2892),
    [sym_false] = STATE(2892),
    [sym_nil] = STATE(2892),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(2893),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(2890),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(4839),
    [sym__splat_star] = ACTIONS(4841),
    [sym__unary_minus] = ACTIONS(4843),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(4845),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_EQ] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4847),
    [anon_sym_yield] = ACTIONS(4849),
    [anon_sym_break] = ACTIONS(4851),
    [anon_sym_next] = ACTIONS(4853),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_in] = ACTIONS(419),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(417),
    [anon_sym_DASH_EQ] = ACTIONS(417),
    [anon_sym_STAR_EQ] = ACTIONS(417),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(417),
    [anon_sym_SLASH_EQ] = ACTIONS(417),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(417),
    [anon_sym_PIPE_EQ] = ACTIONS(417),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(417),
    [anon_sym_AMP_EQ] = ACTIONS(417),
    [anon_sym_PERCENT_EQ] = ACTIONS(417),
    [anon_sym_GT_GT_EQ] = ACTIONS(417),
    [anon_sym_LT_LT_EQ] = ACTIONS(417),
    [anon_sym_CARET_EQ] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(4855),
    [anon_sym_not] = ACTIONS(4857),
    [anon_sym_BANG] = ACTIONS(4859),
    [anon_sym_TILDE] = ACTIONS(4861),
    [sym_constant] = ACTIONS(4863),
    [sym_identifier] = ACTIONS(4863),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2883] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(2888),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2892),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(2892),
    [sym_argument_list] = STATE(1975),
    [sym__argument_list_with_parens] = STATE(2889),
    [sym__argument] = STATE(2890),
    [sym_splat_argument] = STATE(2890),
    [sym_hash_splat_argument] = STATE(2890),
    [sym_block_argument] = STATE(2890),
    [sym_assignment] = STATE(2888),
    [sym_operator_assignment] = STATE(2888),
    [sym_conditional] = STATE(2888),
    [sym_range] = STATE(2888),
    [sym_binary] = STATE(2888),
    [sym_unary] = STATE(2888),
    [sym_left_assignment_list] = STATE(2891),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2892),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2892),
    [sym_false] = STATE(2892),
    [sym_nil] = STATE(2892),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(2893),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(2890),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(4839),
    [sym__splat_star] = ACTIONS(4841),
    [sym__unary_minus] = ACTIONS(4843),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(4845),
    [anon_sym_LBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_EQ] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4847),
    [anon_sym_yield] = ACTIONS(4849),
    [anon_sym_break] = ACTIONS(4851),
    [anon_sym_next] = ACTIONS(4853),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_in] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(421),
    [anon_sym_DASH_EQ] = ACTIONS(421),
    [anon_sym_STAR_EQ] = ACTIONS(421),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(421),
    [anon_sym_SLASH_EQ] = ACTIONS(421),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(421),
    [anon_sym_PIPE_EQ] = ACTIONS(421),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(421),
    [anon_sym_AMP_EQ] = ACTIONS(421),
    [anon_sym_PERCENT_EQ] = ACTIONS(421),
    [anon_sym_GT_GT_EQ] = ACTIONS(421),
    [anon_sym_LT_LT_EQ] = ACTIONS(421),
    [anon_sym_CARET_EQ] = ACTIONS(421),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(4855),
    [anon_sym_not] = ACTIONS(4857),
    [anon_sym_BANG] = ACTIONS(4859),
    [anon_sym_TILDE] = ACTIONS(4861),
    [sym_constant] = ACTIONS(4863),
    [sym_identifier] = ACTIONS(4863),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2884] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(2888),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2892),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(2892),
    [sym_argument_list] = STATE(1976),
    [sym__argument_list_with_parens] = STATE(2889),
    [sym__argument] = STATE(2890),
    [sym_splat_argument] = STATE(2890),
    [sym_hash_splat_argument] = STATE(2890),
    [sym_block_argument] = STATE(2890),
    [sym_assignment] = STATE(2888),
    [sym_operator_assignment] = STATE(2888),
    [sym_conditional] = STATE(2888),
    [sym_range] = STATE(2888),
    [sym_binary] = STATE(2888),
    [sym_unary] = STATE(2888),
    [sym_left_assignment_list] = STATE(2891),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2892),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2892),
    [sym_false] = STATE(2892),
    [sym_nil] = STATE(2892),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(2893),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(2890),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(4839),
    [sym__splat_star] = ACTIONS(4841),
    [sym__unary_minus] = ACTIONS(4843),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(4845),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(427),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4847),
    [anon_sym_yield] = ACTIONS(4849),
    [anon_sym_break] = ACTIONS(4851),
    [anon_sym_next] = ACTIONS(4853),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_in] = ACTIONS(427),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(425),
    [anon_sym_DASH_EQ] = ACTIONS(425),
    [anon_sym_STAR_EQ] = ACTIONS(425),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(425),
    [anon_sym_SLASH_EQ] = ACTIONS(425),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(425),
    [anon_sym_PIPE_EQ] = ACTIONS(425),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(425),
    [anon_sym_AMP_EQ] = ACTIONS(425),
    [anon_sym_PERCENT_EQ] = ACTIONS(425),
    [anon_sym_GT_GT_EQ] = ACTIONS(425),
    [anon_sym_LT_LT_EQ] = ACTIONS(425),
    [anon_sym_CARET_EQ] = ACTIONS(425),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(4855),
    [anon_sym_not] = ACTIONS(4857),
    [anon_sym_BANG] = ACTIONS(4859),
    [anon_sym_TILDE] = ACTIONS(4861),
    [sym_constant] = ACTIONS(4863),
    [sym_identifier] = ACTIONS(4863),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2885] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(5390),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2892),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(2892),
    [sym_assignment] = STATE(5390),
    [sym_operator_assignment] = STATE(5390),
    [sym_conditional] = STATE(5390),
    [sym_range] = STATE(5390),
    [sym_binary] = STATE(5390),
    [sym_unary] = STATE(5390),
    [sym_left_assignment_list] = STATE(2891),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2892),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2892),
    [sym_false] = STATE(2892),
    [sym_nil] = STATE(2892),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(5385),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(4843),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4847),
    [anon_sym_yield] = ACTIONS(4849),
    [anon_sym_break] = ACTIONS(4851),
    [anon_sym_next] = ACTIONS(4853),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(8484),
    [anon_sym_defined_QMARK] = ACTIONS(4855),
    [anon_sym_not] = ACTIONS(4857),
    [anon_sym_BANG] = ACTIONS(4861),
    [anon_sym_TILDE] = ACTIONS(4861),
    [sym_constant] = ACTIONS(1963),
    [sym_identifier] = ACTIONS(1963),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2886] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1997),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2892),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(2892),
    [sym_assignment] = STATE(1997),
    [sym_operator_assignment] = STATE(1997),
    [sym_conditional] = STATE(1997),
    [sym_range] = STATE(1997),
    [sym_binary] = STATE(1997),
    [sym_unary] = STATE(1997),
    [sym_left_assignment_list] = STATE(2891),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2892),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2892),
    [sym_false] = STATE(2892),
    [sym_nil] = STATE(2892),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(5385),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(4843),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4847),
    [anon_sym_yield] = ACTIONS(4849),
    [anon_sym_break] = ACTIONS(4851),
    [anon_sym_next] = ACTIONS(4853),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(8484),
    [anon_sym_defined_QMARK] = ACTIONS(4855),
    [anon_sym_not] = ACTIONS(4857),
    [anon_sym_BANG] = ACTIONS(4861),
    [anon_sym_TILDE] = ACTIONS(4861),
    [sym_constant] = ACTIONS(1963),
    [sym_identifier] = ACTIONS(1963),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2887] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(8488),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [2888] = {
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(8490),
    [sym__binary_star] = ACTIONS(8492),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(8494),
    [anon_sym_STAR_STAR] = ACTIONS(8496),
    [anon_sym_AMP] = ACTIONS(8498),
    [anon_sym_EQ] = ACTIONS(1631),
    [anon_sym_LT] = ACTIONS(8500),
    [anon_sym_in] = ACTIONS(1625),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(1625),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_PLUS_EQ] = ACTIONS(1625),
    [anon_sym_DASH_EQ] = ACTIONS(1625),
    [anon_sym_STAR_EQ] = ACTIONS(1625),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1625),
    [anon_sym_SLASH_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1625),
    [anon_sym_AMP_EQ] = ACTIONS(1625),
    [anon_sym_PERCENT_EQ] = ACTIONS(1625),
    [anon_sym_GT_GT_EQ] = ACTIONS(1625),
    [anon_sym_LT_LT_EQ] = ACTIONS(1625),
    [anon_sym_CARET_EQ] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(8502),
    [anon_sym_DOT_DOT] = ACTIONS(8504),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8506),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(8508),
    [anon_sym_AMP_AMP] = ACTIONS(8508),
    [anon_sym_LT_LT] = ACTIONS(8510),
    [anon_sym_GT_GT] = ACTIONS(8510),
    [anon_sym_EQ_EQ] = ACTIONS(8508),
    [anon_sym_BANG_EQ] = ACTIONS(8512),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8512),
    [anon_sym_LT_EQ_GT] = ACTIONS(8512),
    [anon_sym_EQ_TILDE] = ACTIONS(8512),
    [anon_sym_BANG_TILDE] = ACTIONS(8512),
    [anon_sym_LT_EQ] = ACTIONS(8500),
    [anon_sym_GT] = ACTIONS(8500),
    [anon_sym_GT_EQ] = ACTIONS(8514),
    [anon_sym_CARET] = ACTIONS(8494),
    [anon_sym_PLUS] = ACTIONS(8516),
    [anon_sym_SLASH] = ACTIONS(8496),
    [anon_sym_PERCENT] = ACTIONS(8496),
    [sym_comment] = ACTIONS(87),
  },
  [2889] = {
    [sym_heredoc_body] = STATE(5402),
    [aux_sym_call_repeat1] = STATE(5402),
    [sym__heredoc_body_start] = ACTIONS(3543),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_in] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [2890] = {
    [sym_heredoc_body] = STATE(5402),
    [aux_sym_call_repeat1] = STATE(5402),
    [aux_sym_argument_list_repeat1] = STATE(5404),
    [sym__heredoc_body_start] = ACTIONS(3543),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(8518),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_in] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [2891] = {
    [anon_sym_EQ] = ACTIONS(8520),
    [sym_comment] = ACTIONS(87),
  },
  [2892] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(8522),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_in] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(8524),
    [anon_sym_DASH_EQ] = ACTIONS(8524),
    [anon_sym_STAR_EQ] = ACTIONS(8524),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8524),
    [anon_sym_SLASH_EQ] = ACTIONS(8524),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8524),
    [anon_sym_PIPE_EQ] = ACTIONS(8524),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8524),
    [anon_sym_AMP_EQ] = ACTIONS(8524),
    [anon_sym_PERCENT_EQ] = ACTIONS(8524),
    [anon_sym_GT_GT_EQ] = ACTIONS(8524),
    [anon_sym_LT_LT_EQ] = ACTIONS(8524),
    [anon_sym_CARET_EQ] = ACTIONS(8524),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2893] = {
    [sym_string] = STATE(5407),
    [aux_sym_chained_string_repeat1] = STATE(5407),
    [sym__string_start] = ACTIONS(1141),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(8526),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_in] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2894] = {
    [sym_heredoc_body] = STATE(5408),
    [aux_sym_call_repeat1] = STATE(5408),
    [sym__heredoc_body_start] = ACTIONS(3959),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4383),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_in] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [2895] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(1084),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1089),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(1089),
    [sym__argument] = STATE(3454),
    [sym_splat_argument] = STATE(3454),
    [sym_hash_splat_argument] = STATE(3454),
    [sym_block_argument] = STATE(3454),
    [sym_assignment] = STATE(1084),
    [sym_operator_assignment] = STATE(1084),
    [sym_conditional] = STATE(1084),
    [sym_range] = STATE(1084),
    [sym_binary] = STATE(1084),
    [sym_unary] = STATE(1084),
    [sym_left_assignment_list] = STATE(1088),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1089),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1089),
    [sym_false] = STATE(1089),
    [sym_nil] = STATE(1089),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1090),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_heredoc_body] = STATE(5409),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(3454),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1933),
    [sym__splat_star] = ACTIONS(1935),
    [sym__unary_minus] = ACTIONS(1937),
    [sym__identifier_hash_key] = ACTIONS(1939),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1941),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1943),
    [anon_sym_yield] = ACTIONS(1945),
    [anon_sym_break] = ACTIONS(1947),
    [anon_sym_next] = ACTIONS(1949),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1951),
    [anon_sym_defined_QMARK] = ACTIONS(1953),
    [anon_sym_not] = ACTIONS(1955),
    [anon_sym_BANG] = ACTIONS(1957),
    [anon_sym_TILDE] = ACTIONS(1957),
    [sym_constant] = ACTIONS(1959),
    [sym_identifier] = ACTIONS(1959),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2896] = {
    [sym_heredoc_body] = STATE(5410),
    [aux_sym_call_repeat1] = STATE(5410),
    [aux_sym_argument_list_repeat1] = STATE(5411),
    [sym__heredoc_body_start] = ACTIONS(3959),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4383),
    [anon_sym_COMMA] = ACTIONS(4865),
    [anon_sym_in] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [2897] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(5412),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1089),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(1089),
    [sym_splat_argument] = STATE(5413),
    [sym_assignment] = STATE(5412),
    [sym_operator_assignment] = STATE(5412),
    [sym_conditional] = STATE(5412),
    [sym_range] = STATE(5412),
    [sym_binary] = STATE(5412),
    [sym_unary] = STATE(5412),
    [sym_right_assignment_list] = STATE(4255),
    [sym__arg_or_splat_arg] = STATE(5413),
    [sym_left_assignment_list] = STATE(1088),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1089),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1089),
    [sym_false] = STATE(1089),
    [sym_nil] = STATE(1089),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(4801),
    [sym__unary_minus] = ACTIONS(1937),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1943),
    [anon_sym_yield] = ACTIONS(1945),
    [anon_sym_break] = ACTIONS(1947),
    [anon_sym_next] = ACTIONS(1949),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1951),
    [anon_sym_defined_QMARK] = ACTIONS(1953),
    [anon_sym_not] = ACTIONS(1955),
    [anon_sym_BANG] = ACTIONS(1957),
    [anon_sym_TILDE] = ACTIONS(1957),
    [sym_constant] = ACTIONS(1963),
    [sym_identifier] = ACTIONS(1963),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2898] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(5414),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1089),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(1089),
    [sym_assignment] = STATE(5414),
    [sym_operator_assignment] = STATE(5414),
    [sym_conditional] = STATE(5414),
    [sym_range] = STATE(5414),
    [sym_binary] = STATE(5414),
    [sym_unary] = STATE(5414),
    [sym_left_assignment_list] = STATE(1088),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1089),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1089),
    [sym_false] = STATE(1089),
    [sym_nil] = STATE(1089),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1937),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1943),
    [anon_sym_yield] = ACTIONS(1945),
    [anon_sym_break] = ACTIONS(1947),
    [anon_sym_next] = ACTIONS(1949),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1951),
    [anon_sym_defined_QMARK] = ACTIONS(1953),
    [anon_sym_not] = ACTIONS(1955),
    [anon_sym_BANG] = ACTIONS(1957),
    [anon_sym_TILDE] = ACTIONS(1957),
    [sym_constant] = ACTIONS(1963),
    [sym_identifier] = ACTIONS(1963),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2899] = {
    [sym_string] = STATE(5415),
    [aux_sym_chained_string_repeat1] = STATE(5415),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_in] = ACTIONS(2753),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_EQ_GT] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [2900] = {
    [sym__line_break] = ACTIONS(8528),
    [sym__heredoc_body_start] = ACTIONS(8528),
    [sym__binary_minus] = ACTIONS(1855),
    [sym__binary_star] = ACTIONS(1857),
    [anon_sym_PIPE] = ACTIONS(1859),
    [anon_sym_SEMI] = ACTIONS(8528),
    [anon_sym_STAR_STAR] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_LT] = ACTIONS(1863),
    [anon_sym_do] = ACTIONS(8528),
    [anon_sym_QMARK] = ACTIONS(1865),
    [anon_sym_DOT_DOT] = ACTIONS(1867),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1869),
    [anon_sym_and] = ACTIONS(1871),
    [anon_sym_or] = ACTIONS(1871),
    [anon_sym_PIPE_PIPE] = ACTIONS(1873),
    [anon_sym_AMP_AMP] = ACTIONS(1873),
    [anon_sym_LT_LT] = ACTIONS(1875),
    [anon_sym_GT_GT] = ACTIONS(1875),
    [anon_sym_EQ_EQ] = ACTIONS(1877),
    [anon_sym_BANG_EQ] = ACTIONS(1873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1873),
    [anon_sym_LT_EQ_GT] = ACTIONS(1873),
    [anon_sym_EQ_TILDE] = ACTIONS(1873),
    [anon_sym_BANG_TILDE] = ACTIONS(1873),
    [anon_sym_LT_EQ] = ACTIONS(1863),
    [anon_sym_GT] = ACTIONS(1863),
    [anon_sym_GT_EQ] = ACTIONS(1879),
    [anon_sym_CARET] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_SLASH] = ACTIONS(1857),
    [anon_sym_PERCENT] = ACTIONS(1857),
    [sym_comment] = ACTIONS(87),
  },
  [2901] = {
    [sym__statements] = STATE(5417),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(8530),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2902] = {
    [sym_method] = STATE(184),
    [sym_singleton_method] = STATE(184),
    [sym_class] = STATE(184),
    [sym_singleton_class] = STATE(184),
    [sym_module] = STATE(184),
    [sym_return] = STATE(184),
    [sym_yield] = STATE(184),
    [sym_break] = STATE(184),
    [sym_next] = STATE(184),
    [sym_while] = STATE(184),
    [sym_until] = STATE(184),
    [sym_for] = STATE(184),
    [sym_case] = STATE(184),
    [sym_if] = STATE(184),
    [sym_unless] = STATE(184),
    [sym_begin] = STATE(184),
    [sym__primary] = STATE(184),
    [sym_parenthesized_statements] = STATE(184),
    [sym_element_reference] = STATE(1598),
    [sym_scope_resolution] = STATE(255),
    [sym_call] = STATE(255),
    [sym_method_call] = STATE(1598),
    [sym_destructured_left_assignment] = STATE(1597),
    [sym_rest_assignment] = STATE(1597),
    [sym__lhs] = STATE(1598),
    [sym__variable] = STATE(255),
    [sym_rational] = STATE(184),
    [sym_true] = STATE(1598),
    [sym_false] = STATE(1598),
    [sym_nil] = STATE(1598),
    [sym_chained_string] = STATE(184),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(184),
    [sym_string_array] = STATE(184),
    [sym_symbol_array] = STATE(184),
    [sym_symbol] = STATE(184),
    [sym_regex] = STATE(184),
    [sym_array] = STATE(184),
    [sym_hash] = STATE(184),
    [sym_lambda] = STATE(184),
    [sym__simple_symbol] = ACTIONS(279),
    [sym__string_start] = ACTIONS(281),
    [sym__symbol_start] = ACTIONS(283),
    [sym__subshell_start] = ACTIONS(285),
    [sym__regex_start] = ACTIONS(287),
    [sym__string_array_start] = ACTIONS(289),
    [sym__symbol_array_start] = ACTIONS(291),
    [sym_heredoc_beginning] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_def] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(475),
    [anon_sym_COLON_COLON] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(477),
    [anon_sym_class] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(307),
    [anon_sym_return] = ACTIONS(309),
    [anon_sym_yield] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_next] = ACTIONS(315),
    [sym_redo] = ACTIONS(317),
    [sym_retry] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(319),
    [anon_sym_unless] = ACTIONS(321),
    [anon_sym_while] = ACTIONS(323),
    [anon_sym_until] = ACTIONS(325),
    [anon_sym_for] = ACTIONS(327),
    [anon_sym_in] = ACTIONS(8532),
    [anon_sym_case] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(331),
    [sym_constant] = ACTIONS(479),
    [sym_identifier] = ACTIONS(479),
    [sym_instance_variable] = ACTIONS(481),
    [sym_class_variable] = ACTIONS(481),
    [sym_global_variable] = ACTIONS(481),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(317),
    [sym_complex] = ACTIONS(293),
    [sym_super] = ACTIONS(479),
    [anon_sym_true] = ACTIONS(339),
    [anon_sym_TRUE] = ACTIONS(339),
    [anon_sym_false] = ACTIONS(341),
    [anon_sym_FALSE] = ACTIONS(341),
    [sym_self] = ACTIONS(479),
    [anon_sym_nil] = ACTIONS(343),
    [anon_sym_NIL] = ACTIONS(343),
    [sym_character] = ACTIONS(293),
    [anon_sym_LBRACK2] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(347),
  },
  [2903] = {
    [aux_sym__mlhs_repeat1] = STATE(2903),
    [anon_sym_COMMA] = ACTIONS(8534),
    [anon_sym_in] = ACTIONS(6203),
    [sym_comment] = ACTIONS(87),
  },
  [2904] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5419),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2913),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2913),
    [sym_assignment] = STATE(5419),
    [sym_operator_assignment] = STATE(5419),
    [sym_conditional] = STATE(5419),
    [sym_range] = STATE(5419),
    [sym_binary] = STATE(5419),
    [sym_unary] = STATE(5419),
    [sym_left_assignment_list] = STATE(2912),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2913),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2913),
    [sym_false] = STATE(2913),
    [sym_nil] = STATE(2913),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2914),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4881),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4883),
    [anon_sym_yield] = ACTIONS(4885),
    [anon_sym_break] = ACTIONS(4887),
    [anon_sym_next] = ACTIONS(4889),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4891),
    [anon_sym_defined_QMARK] = ACTIONS(4893),
    [anon_sym_not] = ACTIONS(4895),
    [anon_sym_BANG] = ACTIONS(4897),
    [anon_sym_TILDE] = ACTIONS(4897),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2905] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1108),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1113),
    [sym_scope_resolution] = STATE(1109),
    [sym_call] = STATE(1109),
    [sym_method_call] = STATE(1113),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(5420),
    [sym__argument] = STATE(5421),
    [sym_splat_argument] = STATE(5421),
    [sym_hash_splat_argument] = STATE(5421),
    [sym_block_argument] = STATE(5421),
    [sym_assignment] = STATE(1108),
    [sym_operator_assignment] = STATE(1108),
    [sym_conditional] = STATE(1108),
    [sym_range] = STATE(1108),
    [sym_binary] = STATE(1108),
    [sym_unary] = STATE(1108),
    [sym_left_assignment_list] = STATE(1112),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1113),
    [sym__variable] = STATE(1109),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1113),
    [sym_false] = STATE(1113),
    [sym_nil] = STATE(1113),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1114),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5421),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(1969),
    [sym__splat_star] = ACTIONS(1971),
    [sym__unary_minus] = ACTIONS(1973),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(1975),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1977),
    [anon_sym_yield] = ACTIONS(1979),
    [anon_sym_break] = ACTIONS(1981),
    [anon_sym_next] = ACTIONS(1983),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1991),
    [sym_constant] = ACTIONS(1993),
    [sym_identifier] = ACTIONS(1993),
    [sym_instance_variable] = ACTIONS(1995),
    [sym_class_variable] = ACTIONS(1995),
    [sym_global_variable] = ACTIONS(1995),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1997),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1997),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2906] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1108),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1113),
    [sym_scope_resolution] = STATE(1109),
    [sym_call] = STATE(1109),
    [sym_method_call] = STATE(1113),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(5420),
    [sym__argument] = STATE(5421),
    [sym_splat_argument] = STATE(5421),
    [sym_hash_splat_argument] = STATE(5421),
    [sym_block_argument] = STATE(5421),
    [sym_assignment] = STATE(1108),
    [sym_operator_assignment] = STATE(1108),
    [sym_conditional] = STATE(1108),
    [sym_range] = STATE(1108),
    [sym_binary] = STATE(1108),
    [sym_unary] = STATE(1108),
    [sym_left_assignment_list] = STATE(1112),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1113),
    [sym__variable] = STATE(1109),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1113),
    [sym_false] = STATE(1113),
    [sym_nil] = STATE(1113),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1114),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5421),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(1969),
    [sym__splat_star] = ACTIONS(1971),
    [sym__unary_minus] = ACTIONS(1973),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(1975),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1977),
    [anon_sym_yield] = ACTIONS(1979),
    [anon_sym_break] = ACTIONS(1981),
    [anon_sym_next] = ACTIONS(1983),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1991),
    [sym_constant] = ACTIONS(1993),
    [sym_identifier] = ACTIONS(1993),
    [sym_instance_variable] = ACTIONS(1995),
    [sym_class_variable] = ACTIONS(1995),
    [sym_global_variable] = ACTIONS(1995),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1997),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1997),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2907] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1108),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1113),
    [sym_scope_resolution] = STATE(1109),
    [sym_call] = STATE(1109),
    [sym_method_call] = STATE(1113),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(5420),
    [sym__argument] = STATE(5421),
    [sym_splat_argument] = STATE(5421),
    [sym_hash_splat_argument] = STATE(5421),
    [sym_block_argument] = STATE(5421),
    [sym_assignment] = STATE(1108),
    [sym_operator_assignment] = STATE(1108),
    [sym_conditional] = STATE(1108),
    [sym_range] = STATE(1108),
    [sym_binary] = STATE(1108),
    [sym_unary] = STATE(1108),
    [sym_left_assignment_list] = STATE(1112),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1113),
    [sym__variable] = STATE(1109),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1113),
    [sym_false] = STATE(1113),
    [sym_nil] = STATE(1113),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1114),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5421),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(1969),
    [sym__splat_star] = ACTIONS(1971),
    [sym__unary_minus] = ACTIONS(1973),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(1975),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1977),
    [anon_sym_yield] = ACTIONS(1979),
    [anon_sym_break] = ACTIONS(1981),
    [anon_sym_next] = ACTIONS(1983),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1991),
    [sym_constant] = ACTIONS(1993),
    [sym_identifier] = ACTIONS(1993),
    [sym_instance_variable] = ACTIONS(1995),
    [sym_class_variable] = ACTIONS(1995),
    [sym_global_variable] = ACTIONS(1995),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1997),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1997),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2908] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1108),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1113),
    [sym_scope_resolution] = STATE(1109),
    [sym_call] = STATE(1109),
    [sym_method_call] = STATE(1113),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(5420),
    [sym__argument] = STATE(5421),
    [sym_splat_argument] = STATE(5421),
    [sym_hash_splat_argument] = STATE(5421),
    [sym_block_argument] = STATE(5421),
    [sym_assignment] = STATE(1108),
    [sym_operator_assignment] = STATE(1108),
    [sym_conditional] = STATE(1108),
    [sym_range] = STATE(1108),
    [sym_binary] = STATE(1108),
    [sym_unary] = STATE(1108),
    [sym_left_assignment_list] = STATE(1112),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1113),
    [sym__variable] = STATE(1109),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1113),
    [sym_false] = STATE(1113),
    [sym_nil] = STATE(1113),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1114),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5421),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(1969),
    [sym__splat_star] = ACTIONS(1971),
    [sym__unary_minus] = ACTIONS(1973),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(1975),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1977),
    [anon_sym_yield] = ACTIONS(1979),
    [anon_sym_break] = ACTIONS(1981),
    [anon_sym_next] = ACTIONS(1983),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1991),
    [sym_constant] = ACTIONS(1993),
    [sym_identifier] = ACTIONS(1993),
    [sym_instance_variable] = ACTIONS(1995),
    [sym_class_variable] = ACTIONS(1995),
    [sym_global_variable] = ACTIONS(1995),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1997),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1997),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2909] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5422),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2913),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2913),
    [sym_assignment] = STATE(5422),
    [sym_operator_assignment] = STATE(5422),
    [sym_conditional] = STATE(5422),
    [sym_range] = STATE(5422),
    [sym_binary] = STATE(5422),
    [sym_unary] = STATE(5422),
    [sym_left_assignment_list] = STATE(2912),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2913),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2913),
    [sym_false] = STATE(2913),
    [sym_nil] = STATE(2913),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2914),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4881),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4883),
    [anon_sym_yield] = ACTIONS(4885),
    [anon_sym_break] = ACTIONS(4887),
    [anon_sym_next] = ACTIONS(4889),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4891),
    [anon_sym_defined_QMARK] = ACTIONS(4893),
    [anon_sym_not] = ACTIONS(4895),
    [anon_sym_BANG] = ACTIONS(4897),
    [anon_sym_TILDE] = ACTIONS(4897),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2910] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2913),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2913),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(2912),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2913),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2913),
    [sym_false] = STATE(2913),
    [sym_nil] = STATE(2913),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2914),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4881),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4883),
    [anon_sym_yield] = ACTIONS(4885),
    [anon_sym_break] = ACTIONS(4887),
    [anon_sym_next] = ACTIONS(4889),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4891),
    [anon_sym_defined_QMARK] = ACTIONS(4893),
    [anon_sym_not] = ACTIONS(4895),
    [anon_sym_BANG] = ACTIONS(4897),
    [anon_sym_TILDE] = ACTIONS(4897),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2911] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(8537),
    [sym__binary_star] = ACTIONS(8539),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(8541),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(8539),
    [anon_sym_AMP] = ACTIONS(8543),
    [anon_sym_LT] = ACTIONS(8545),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(8547),
    [anon_sym_DOT_DOT] = ACTIONS(8549),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8551),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(8553),
    [anon_sym_AMP_AMP] = ACTIONS(8553),
    [anon_sym_LT_LT] = ACTIONS(8555),
    [anon_sym_GT_GT] = ACTIONS(8555),
    [anon_sym_EQ_EQ] = ACTIONS(8557),
    [anon_sym_BANG_EQ] = ACTIONS(8553),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8553),
    [anon_sym_LT_EQ_GT] = ACTIONS(8553),
    [anon_sym_EQ_TILDE] = ACTIONS(8553),
    [anon_sym_BANG_TILDE] = ACTIONS(8553),
    [anon_sym_LT_EQ] = ACTIONS(8545),
    [anon_sym_GT] = ACTIONS(8545),
    [anon_sym_GT_EQ] = ACTIONS(8559),
    [anon_sym_CARET] = ACTIONS(8561),
    [anon_sym_PLUS] = ACTIONS(8537),
    [anon_sym_SLASH] = ACTIONS(8539),
    [anon_sym_PERCENT] = ACTIONS(8539),
    [sym_comment] = ACTIONS(87),
  },
  [2912] = {
    [anon_sym_EQ] = ACTIONS(8563),
    [sym_comment] = ACTIONS(87),
  },
  [2913] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(8565),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(8567),
    [anon_sym_DASH_EQ] = ACTIONS(8567),
    [anon_sym_STAR_EQ] = ACTIONS(8567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8567),
    [anon_sym_SLASH_EQ] = ACTIONS(8567),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8567),
    [anon_sym_PIPE_EQ] = ACTIONS(8567),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8567),
    [anon_sym_AMP_EQ] = ACTIONS(8567),
    [anon_sym_PERCENT_EQ] = ACTIONS(8567),
    [anon_sym_GT_GT_EQ] = ACTIONS(8567),
    [anon_sym_LT_LT_EQ] = ACTIONS(8567),
    [anon_sym_CARET_EQ] = ACTIONS(8567),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2914] = {
    [sym_string] = STATE(5435),
    [aux_sym_chained_string_repeat1] = STATE(5435),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2915] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(8537),
    [sym__binary_star] = ACTIONS(8539),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(8541),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(8539),
    [anon_sym_AMP] = ACTIONS(8543),
    [anon_sym_LT] = ACTIONS(8545),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(8547),
    [anon_sym_DOT_DOT] = ACTIONS(8549),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8551),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(8553),
    [anon_sym_AMP_AMP] = ACTIONS(8553),
    [anon_sym_LT_LT] = ACTIONS(8555),
    [anon_sym_GT_GT] = ACTIONS(8555),
    [anon_sym_EQ_EQ] = ACTIONS(8557),
    [anon_sym_BANG_EQ] = ACTIONS(8553),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8553),
    [anon_sym_LT_EQ_GT] = ACTIONS(8553),
    [anon_sym_EQ_TILDE] = ACTIONS(8553),
    [anon_sym_BANG_TILDE] = ACTIONS(8553),
    [anon_sym_LT_EQ] = ACTIONS(8545),
    [anon_sym_GT] = ACTIONS(8545),
    [anon_sym_GT_EQ] = ACTIONS(8559),
    [anon_sym_CARET] = ACTIONS(8561),
    [anon_sym_PLUS] = ACTIONS(8537),
    [anon_sym_SLASH] = ACTIONS(8539),
    [anon_sym_PERCENT] = ACTIONS(8539),
    [sym_comment] = ACTIONS(87),
  },
  [2916] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(4915),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [2917] = {
    [sym_string] = STATE(2946),
    [aux_sym_chained_string_repeat1] = STATE(2946),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2918] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5436),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2913),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2913),
    [sym_assignment] = STATE(5436),
    [sym_operator_assignment] = STATE(5436),
    [sym_conditional] = STATE(5436),
    [sym_range] = STATE(5436),
    [sym_binary] = STATE(5436),
    [sym_unary] = STATE(5436),
    [sym_left_assignment_list] = STATE(2912),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2913),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2913),
    [sym_false] = STATE(2913),
    [sym_nil] = STATE(2913),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2914),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4881),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4883),
    [anon_sym_yield] = ACTIONS(4885),
    [anon_sym_break] = ACTIONS(4887),
    [anon_sym_next] = ACTIONS(4889),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4891),
    [anon_sym_defined_QMARK] = ACTIONS(4893),
    [anon_sym_not] = ACTIONS(4895),
    [anon_sym_BANG] = ACTIONS(4897),
    [anon_sym_TILDE] = ACTIONS(4897),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2919] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(8537),
    [sym__binary_star] = ACTIONS(8539),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(8541),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(8539),
    [anon_sym_AMP] = ACTIONS(8543),
    [anon_sym_LT] = ACTIONS(8545),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(8547),
    [anon_sym_DOT_DOT] = ACTIONS(8549),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8551),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(8553),
    [anon_sym_AMP_AMP] = ACTIONS(8553),
    [anon_sym_LT_LT] = ACTIONS(8555),
    [anon_sym_GT_GT] = ACTIONS(8555),
    [anon_sym_EQ_EQ] = ACTIONS(8557),
    [anon_sym_BANG_EQ] = ACTIONS(8553),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8553),
    [anon_sym_LT_EQ_GT] = ACTIONS(8553),
    [anon_sym_EQ_TILDE] = ACTIONS(8553),
    [anon_sym_BANG_TILDE] = ACTIONS(8553),
    [anon_sym_LT_EQ] = ACTIONS(8545),
    [anon_sym_GT] = ACTIONS(8545),
    [anon_sym_GT_EQ] = ACTIONS(8559),
    [anon_sym_CARET] = ACTIONS(8561),
    [anon_sym_PLUS] = ACTIONS(8537),
    [anon_sym_SLASH] = ACTIONS(8539),
    [anon_sym_PERCENT] = ACTIONS(8539),
    [sym_comment] = ACTIONS(87),
  },
  [2920] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5437),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1113),
    [sym_scope_resolution] = STATE(1109),
    [sym_call] = STATE(1109),
    [sym_method_call] = STATE(1113),
    [sym_assignment] = STATE(5437),
    [sym_operator_assignment] = STATE(5437),
    [sym_conditional] = STATE(5437),
    [sym_range] = STATE(5437),
    [sym_binary] = STATE(5437),
    [sym_unary] = STATE(5437),
    [sym_left_assignment_list] = STATE(1112),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1113),
    [sym__variable] = STATE(1109),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1113),
    [sym_false] = STATE(1113),
    [sym_nil] = STATE(1113),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2917),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1973),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1977),
    [anon_sym_yield] = ACTIONS(1979),
    [anon_sym_break] = ACTIONS(1981),
    [anon_sym_next] = ACTIONS(1983),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4899),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1991),
    [anon_sym_TILDE] = ACTIONS(1991),
    [sym_constant] = ACTIONS(1997),
    [sym_identifier] = ACTIONS(1997),
    [sym_instance_variable] = ACTIONS(1995),
    [sym_class_variable] = ACTIONS(1995),
    [sym_global_variable] = ACTIONS(1995),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1997),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1997),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2921] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5438),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1113),
    [sym_scope_resolution] = STATE(1109),
    [sym_call] = STATE(1109),
    [sym_method_call] = STATE(1113),
    [sym_assignment] = STATE(5438),
    [sym_operator_assignment] = STATE(5438),
    [sym_conditional] = STATE(5438),
    [sym_range] = STATE(5438),
    [sym_binary] = STATE(5438),
    [sym_unary] = STATE(5438),
    [sym_left_assignment_list] = STATE(1112),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1113),
    [sym__variable] = STATE(1109),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1113),
    [sym_false] = STATE(1113),
    [sym_nil] = STATE(1113),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2917),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1973),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1977),
    [anon_sym_yield] = ACTIONS(1979),
    [anon_sym_break] = ACTIONS(1981),
    [anon_sym_next] = ACTIONS(1983),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4899),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1991),
    [anon_sym_TILDE] = ACTIONS(1991),
    [sym_constant] = ACTIONS(1997),
    [sym_identifier] = ACTIONS(1997),
    [sym_instance_variable] = ACTIONS(1995),
    [sym_class_variable] = ACTIONS(1995),
    [sym_global_variable] = ACTIONS(1995),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1997),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1997),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2922] = {
    [anon_sym_COLON] = ACTIONS(8569),
    [sym_comment] = ACTIONS(87),
  },
  [2923] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5440),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1113),
    [sym_scope_resolution] = STATE(1109),
    [sym_call] = STATE(1109),
    [sym_method_call] = STATE(1113),
    [sym_assignment] = STATE(5440),
    [sym_operator_assignment] = STATE(5440),
    [sym_conditional] = STATE(5440),
    [sym_range] = STATE(5440),
    [sym_binary] = STATE(5440),
    [sym_unary] = STATE(5440),
    [sym_left_assignment_list] = STATE(1112),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1113),
    [sym__variable] = STATE(1109),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1113),
    [sym_false] = STATE(1113),
    [sym_nil] = STATE(1113),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2917),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1973),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1977),
    [anon_sym_yield] = ACTIONS(1979),
    [anon_sym_break] = ACTIONS(1981),
    [anon_sym_next] = ACTIONS(1983),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4899),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1991),
    [anon_sym_TILDE] = ACTIONS(1991),
    [sym_constant] = ACTIONS(1997),
    [sym_identifier] = ACTIONS(1997),
    [sym_instance_variable] = ACTIONS(1995),
    [sym_class_variable] = ACTIONS(1995),
    [sym_global_variable] = ACTIONS(1995),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1997),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1997),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2924] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(8571),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [2925] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(4913),
    [sym__binary_star] = ACTIONS(4915),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(4917),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(4915),
    [anon_sym_AMP] = ACTIONS(4919),
    [anon_sym_LT] = ACTIONS(4921),
    [anon_sym_EQ_GT] = ACTIONS(1625),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_DOT_DOT] = ACTIONS(4925),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4927),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(4929),
    [anon_sym_AMP_AMP] = ACTIONS(4929),
    [anon_sym_LT_LT] = ACTIONS(4931),
    [anon_sym_GT_GT] = ACTIONS(4931),
    [anon_sym_EQ_EQ] = ACTIONS(4933),
    [anon_sym_BANG_EQ] = ACTIONS(4929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4929),
    [anon_sym_LT_EQ_GT] = ACTIONS(4929),
    [anon_sym_EQ_TILDE] = ACTIONS(4929),
    [anon_sym_BANG_TILDE] = ACTIONS(4929),
    [anon_sym_LT_EQ] = ACTIONS(4921),
    [anon_sym_GT] = ACTIONS(4921),
    [anon_sym_GT_EQ] = ACTIONS(4935),
    [anon_sym_CARET] = ACTIONS(4937),
    [anon_sym_PLUS] = ACTIONS(4913),
    [anon_sym_SLASH] = ACTIONS(4915),
    [anon_sym_PERCENT] = ACTIONS(4915),
    [sym_comment] = ACTIONS(87),
  },
  [2926] = {
    [sym_heredoc_body] = STATE(5442),
    [aux_sym_call_repeat1] = STATE(5442),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [2927] = {
    [sym_heredoc_body] = STATE(5442),
    [aux_sym_call_repeat1] = STATE(5442),
    [aux_sym_argument_list_repeat1] = STATE(5444),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(8573),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [2928] = {
    [sym_string] = STATE(2946),
    [aux_sym_chained_string_repeat1] = STATE(2946),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(8575),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2929] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(4913),
    [sym__binary_star] = ACTIONS(4915),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(4917),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(4915),
    [anon_sym_AMP] = ACTIONS(4919),
    [anon_sym_LT] = ACTIONS(4921),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_DOT_DOT] = ACTIONS(4925),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4927),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(4929),
    [anon_sym_AMP_AMP] = ACTIONS(4929),
    [anon_sym_LT_LT] = ACTIONS(4931),
    [anon_sym_GT_GT] = ACTIONS(4931),
    [anon_sym_EQ_EQ] = ACTIONS(4933),
    [anon_sym_BANG_EQ] = ACTIONS(4929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4929),
    [anon_sym_LT_EQ_GT] = ACTIONS(4929),
    [anon_sym_EQ_TILDE] = ACTIONS(4929),
    [anon_sym_BANG_TILDE] = ACTIONS(4929),
    [anon_sym_LT_EQ] = ACTIONS(4921),
    [anon_sym_GT] = ACTIONS(4921),
    [anon_sym_GT_EQ] = ACTIONS(4935),
    [anon_sym_CARET] = ACTIONS(4937),
    [anon_sym_PLUS] = ACTIONS(4913),
    [anon_sym_SLASH] = ACTIONS(4915),
    [anon_sym_PERCENT] = ACTIONS(4915),
    [sym_comment] = ACTIONS(87),
  },
  [2930] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5445),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2913),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2913),
    [sym_assignment] = STATE(5445),
    [sym_operator_assignment] = STATE(5445),
    [sym_conditional] = STATE(5445),
    [sym_range] = STATE(5445),
    [sym_binary] = STATE(5445),
    [sym_unary] = STATE(5445),
    [sym_left_assignment_list] = STATE(2912),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2913),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2913),
    [sym_false] = STATE(2913),
    [sym_nil] = STATE(2913),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2914),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4881),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4883),
    [anon_sym_yield] = ACTIONS(4885),
    [anon_sym_break] = ACTIONS(4887),
    [anon_sym_next] = ACTIONS(4889),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4891),
    [anon_sym_defined_QMARK] = ACTIONS(4893),
    [anon_sym_not] = ACTIONS(4895),
    [anon_sym_BANG] = ACTIONS(4897),
    [anon_sym_TILDE] = ACTIONS(4897),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2931] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5446),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1113),
    [sym_scope_resolution] = STATE(1109),
    [sym_call] = STATE(1109),
    [sym_method_call] = STATE(1113),
    [sym_assignment] = STATE(5446),
    [sym_operator_assignment] = STATE(5446),
    [sym_conditional] = STATE(5446),
    [sym_range] = STATE(5446),
    [sym_binary] = STATE(5446),
    [sym_unary] = STATE(5446),
    [sym_left_assignment_list] = STATE(1112),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1113),
    [sym__variable] = STATE(1109),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1113),
    [sym_false] = STATE(1113),
    [sym_nil] = STATE(1113),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2917),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1973),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1977),
    [anon_sym_yield] = ACTIONS(1979),
    [anon_sym_break] = ACTIONS(1981),
    [anon_sym_next] = ACTIONS(1983),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4899),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1991),
    [anon_sym_TILDE] = ACTIONS(1991),
    [sym_constant] = ACTIONS(1997),
    [sym_identifier] = ACTIONS(1997),
    [sym_instance_variable] = ACTIONS(1995),
    [sym_class_variable] = ACTIONS(1995),
    [sym_global_variable] = ACTIONS(1995),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1997),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1997),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2932] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5447),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1113),
    [sym_scope_resolution] = STATE(1109),
    [sym_call] = STATE(1109),
    [sym_method_call] = STATE(1113),
    [sym_assignment] = STATE(5447),
    [sym_operator_assignment] = STATE(5447),
    [sym_conditional] = STATE(5447),
    [sym_range] = STATE(5447),
    [sym_binary] = STATE(5447),
    [sym_unary] = STATE(5447),
    [sym_left_assignment_list] = STATE(1112),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1113),
    [sym__variable] = STATE(1109),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1113),
    [sym_false] = STATE(1113),
    [sym_nil] = STATE(1113),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2917),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1973),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1977),
    [anon_sym_yield] = ACTIONS(1979),
    [anon_sym_break] = ACTIONS(1981),
    [anon_sym_next] = ACTIONS(1983),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4899),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1991),
    [anon_sym_TILDE] = ACTIONS(1991),
    [sym_constant] = ACTIONS(1997),
    [sym_identifier] = ACTIONS(1997),
    [sym_instance_variable] = ACTIONS(1995),
    [sym_class_variable] = ACTIONS(1995),
    [sym_global_variable] = ACTIONS(1995),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1997),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1997),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2933] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5448),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1113),
    [sym_scope_resolution] = STATE(1109),
    [sym_call] = STATE(1109),
    [sym_method_call] = STATE(1113),
    [sym_assignment] = STATE(5448),
    [sym_operator_assignment] = STATE(5448),
    [sym_conditional] = STATE(5448),
    [sym_range] = STATE(5448),
    [sym_binary] = STATE(5448),
    [sym_unary] = STATE(5448),
    [sym_left_assignment_list] = STATE(1112),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1113),
    [sym__variable] = STATE(1109),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1113),
    [sym_false] = STATE(1113),
    [sym_nil] = STATE(1113),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2917),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1973),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1977),
    [anon_sym_yield] = ACTIONS(1979),
    [anon_sym_break] = ACTIONS(1981),
    [anon_sym_next] = ACTIONS(1983),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4899),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1991),
    [anon_sym_TILDE] = ACTIONS(1991),
    [sym_constant] = ACTIONS(1997),
    [sym_identifier] = ACTIONS(1997),
    [sym_instance_variable] = ACTIONS(1995),
    [sym_class_variable] = ACTIONS(1995),
    [sym_global_variable] = ACTIONS(1995),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1997),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1997),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2934] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5449),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1113),
    [sym_scope_resolution] = STATE(1109),
    [sym_call] = STATE(1109),
    [sym_method_call] = STATE(1113),
    [sym_assignment] = STATE(5449),
    [sym_operator_assignment] = STATE(5449),
    [sym_conditional] = STATE(5449),
    [sym_range] = STATE(5449),
    [sym_binary] = STATE(5449),
    [sym_unary] = STATE(5449),
    [sym_left_assignment_list] = STATE(1112),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1113),
    [sym__variable] = STATE(1109),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1113),
    [sym_false] = STATE(1113),
    [sym_nil] = STATE(1113),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2917),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1973),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1977),
    [anon_sym_yield] = ACTIONS(1979),
    [anon_sym_break] = ACTIONS(1981),
    [anon_sym_next] = ACTIONS(1983),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4899),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1991),
    [anon_sym_TILDE] = ACTIONS(1991),
    [sym_constant] = ACTIONS(1997),
    [sym_identifier] = ACTIONS(1997),
    [sym_instance_variable] = ACTIONS(1995),
    [sym_class_variable] = ACTIONS(1995),
    [sym_global_variable] = ACTIONS(1995),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1997),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1997),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2935] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5450),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1113),
    [sym_scope_resolution] = STATE(1109),
    [sym_call] = STATE(1109),
    [sym_method_call] = STATE(1113),
    [sym_assignment] = STATE(5450),
    [sym_operator_assignment] = STATE(5450),
    [sym_conditional] = STATE(5450),
    [sym_range] = STATE(5450),
    [sym_binary] = STATE(5450),
    [sym_unary] = STATE(5450),
    [sym_left_assignment_list] = STATE(1112),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1113),
    [sym__variable] = STATE(1109),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1113),
    [sym_false] = STATE(1113),
    [sym_nil] = STATE(1113),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2917),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1973),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1977),
    [anon_sym_yield] = ACTIONS(1979),
    [anon_sym_break] = ACTIONS(1981),
    [anon_sym_next] = ACTIONS(1983),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4899),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1991),
    [anon_sym_TILDE] = ACTIONS(1991),
    [sym_constant] = ACTIONS(1997),
    [sym_identifier] = ACTIONS(1997),
    [sym_instance_variable] = ACTIONS(1995),
    [sym_class_variable] = ACTIONS(1995),
    [sym_global_variable] = ACTIONS(1995),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1997),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1997),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2936] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(5451),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(5451),
    [sym_operator_assignment] = STATE(5451),
    [sym_conditional] = STATE(5451),
    [sym_range] = STATE(5451),
    [sym_binary] = STATE(5451),
    [sym_unary] = STATE(5451),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2937] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5452),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1113),
    [sym_scope_resolution] = STATE(1109),
    [sym_call] = STATE(1109),
    [sym_method_call] = STATE(1113),
    [sym_assignment] = STATE(5452),
    [sym_operator_assignment] = STATE(5452),
    [sym_conditional] = STATE(5452),
    [sym_range] = STATE(5452),
    [sym_binary] = STATE(5452),
    [sym_unary] = STATE(5452),
    [sym_left_assignment_list] = STATE(1112),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1113),
    [sym__variable] = STATE(1109),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1113),
    [sym_false] = STATE(1113),
    [sym_nil] = STATE(1113),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2917),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1973),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1977),
    [anon_sym_yield] = ACTIONS(1979),
    [anon_sym_break] = ACTIONS(1981),
    [anon_sym_next] = ACTIONS(1983),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4899),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1991),
    [anon_sym_TILDE] = ACTIONS(1991),
    [sym_constant] = ACTIONS(1997),
    [sym_identifier] = ACTIONS(1997),
    [sym_instance_variable] = ACTIONS(1995),
    [sym_class_variable] = ACTIONS(1995),
    [sym_global_variable] = ACTIONS(1995),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1997),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1997),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2938] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5453),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1113),
    [sym_scope_resolution] = STATE(1109),
    [sym_call] = STATE(1109),
    [sym_method_call] = STATE(1113),
    [sym_assignment] = STATE(5453),
    [sym_operator_assignment] = STATE(5453),
    [sym_conditional] = STATE(5453),
    [sym_range] = STATE(5453),
    [sym_binary] = STATE(5453),
    [sym_unary] = STATE(5453),
    [sym_left_assignment_list] = STATE(1112),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1113),
    [sym__variable] = STATE(1109),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1113),
    [sym_false] = STATE(1113),
    [sym_nil] = STATE(1113),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2917),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1973),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1977),
    [anon_sym_yield] = ACTIONS(1979),
    [anon_sym_break] = ACTIONS(1981),
    [anon_sym_next] = ACTIONS(1983),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4899),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1991),
    [anon_sym_TILDE] = ACTIONS(1991),
    [sym_constant] = ACTIONS(1997),
    [sym_identifier] = ACTIONS(1997),
    [sym_instance_variable] = ACTIONS(1995),
    [sym_class_variable] = ACTIONS(1995),
    [sym_global_variable] = ACTIONS(1995),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1997),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1997),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2939] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5454),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1113),
    [sym_scope_resolution] = STATE(1109),
    [sym_call] = STATE(1109),
    [sym_method_call] = STATE(1113),
    [sym_assignment] = STATE(5454),
    [sym_operator_assignment] = STATE(5454),
    [sym_conditional] = STATE(5454),
    [sym_range] = STATE(5454),
    [sym_binary] = STATE(5454),
    [sym_unary] = STATE(5454),
    [sym_left_assignment_list] = STATE(1112),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1113),
    [sym__variable] = STATE(1109),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1113),
    [sym_false] = STATE(1113),
    [sym_nil] = STATE(1113),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2917),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1973),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1977),
    [anon_sym_yield] = ACTIONS(1979),
    [anon_sym_break] = ACTIONS(1981),
    [anon_sym_next] = ACTIONS(1983),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4899),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1991),
    [anon_sym_TILDE] = ACTIONS(1991),
    [sym_constant] = ACTIONS(1997),
    [sym_identifier] = ACTIONS(1997),
    [sym_instance_variable] = ACTIONS(1995),
    [sym_class_variable] = ACTIONS(1995),
    [sym_global_variable] = ACTIONS(1995),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1997),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1997),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2940] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5455),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1113),
    [sym_scope_resolution] = STATE(1109),
    [sym_call] = STATE(1109),
    [sym_method_call] = STATE(1113),
    [sym_assignment] = STATE(5455),
    [sym_operator_assignment] = STATE(5455),
    [sym_conditional] = STATE(5455),
    [sym_range] = STATE(5455),
    [sym_binary] = STATE(5455),
    [sym_unary] = STATE(5455),
    [sym_left_assignment_list] = STATE(1112),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1113),
    [sym__variable] = STATE(1109),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1113),
    [sym_false] = STATE(1113),
    [sym_nil] = STATE(1113),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2917),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1973),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1977),
    [anon_sym_yield] = ACTIONS(1979),
    [anon_sym_break] = ACTIONS(1981),
    [anon_sym_next] = ACTIONS(1983),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4899),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1991),
    [anon_sym_TILDE] = ACTIONS(1991),
    [sym_constant] = ACTIONS(1997),
    [sym_identifier] = ACTIONS(1997),
    [sym_instance_variable] = ACTIONS(1995),
    [sym_class_variable] = ACTIONS(1995),
    [sym_global_variable] = ACTIONS(1995),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1997),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1997),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2941] = {
    [sym_heredoc_body] = STATE(5456),
    [aux_sym_call_repeat1] = STATE(5456),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [2942] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1108),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1113),
    [sym_scope_resolution] = STATE(1109),
    [sym_call] = STATE(1109),
    [sym_method_call] = STATE(1113),
    [sym__argument] = STATE(2565),
    [sym_splat_argument] = STATE(2565),
    [sym_hash_splat_argument] = STATE(2565),
    [sym_block_argument] = STATE(2565),
    [sym_assignment] = STATE(1108),
    [sym_operator_assignment] = STATE(1108),
    [sym_conditional] = STATE(1108),
    [sym_range] = STATE(1108),
    [sym_binary] = STATE(1108),
    [sym_unary] = STATE(1108),
    [sym_left_assignment_list] = STATE(1112),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1113),
    [sym__variable] = STATE(1109),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1113),
    [sym_false] = STATE(1113),
    [sym_nil] = STATE(1113),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1114),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(5457),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2565),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(1969),
    [sym__splat_star] = ACTIONS(1971),
    [sym__unary_minus] = ACTIONS(1973),
    [sym__identifier_hash_key] = ACTIONS(1975),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(8577),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1977),
    [anon_sym_yield] = ACTIONS(1979),
    [anon_sym_break] = ACTIONS(1981),
    [anon_sym_next] = ACTIONS(1983),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4899),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1991),
    [anon_sym_TILDE] = ACTIONS(1991),
    [sym_constant] = ACTIONS(1993),
    [sym_identifier] = ACTIONS(1993),
    [sym_instance_variable] = ACTIONS(1995),
    [sym_class_variable] = ACTIONS(1995),
    [sym_global_variable] = ACTIONS(1995),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1997),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1997),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2943] = {
    [sym_heredoc_body] = STATE(5458),
    [aux_sym_call_repeat1] = STATE(5458),
    [aux_sym_argument_list_repeat1] = STATE(5459),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4939),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [2944] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5460),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1113),
    [sym_scope_resolution] = STATE(1109),
    [sym_call] = STATE(1109),
    [sym_method_call] = STATE(1113),
    [sym_splat_argument] = STATE(5461),
    [sym_assignment] = STATE(5460),
    [sym_operator_assignment] = STATE(5460),
    [sym_conditional] = STATE(5460),
    [sym_range] = STATE(5460),
    [sym_binary] = STATE(5460),
    [sym_unary] = STATE(5460),
    [sym_right_assignment_list] = STATE(2570),
    [sym__arg_or_splat_arg] = STATE(5461),
    [sym_left_assignment_list] = STATE(1112),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1113),
    [sym__variable] = STATE(1109),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1113),
    [sym_false] = STATE(1113),
    [sym_nil] = STATE(1113),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2917),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__splat_star] = ACTIONS(4905),
    [sym__unary_minus] = ACTIONS(1973),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1977),
    [anon_sym_yield] = ACTIONS(1979),
    [anon_sym_break] = ACTIONS(1981),
    [anon_sym_next] = ACTIONS(1983),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4899),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1991),
    [anon_sym_TILDE] = ACTIONS(1991),
    [sym_constant] = ACTIONS(1997),
    [sym_identifier] = ACTIONS(1997),
    [sym_instance_variable] = ACTIONS(1995),
    [sym_class_variable] = ACTIONS(1995),
    [sym_global_variable] = ACTIONS(1995),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1997),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1997),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2945] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5462),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1113),
    [sym_scope_resolution] = STATE(1109),
    [sym_call] = STATE(1109),
    [sym_method_call] = STATE(1113),
    [sym_assignment] = STATE(5462),
    [sym_operator_assignment] = STATE(5462),
    [sym_conditional] = STATE(5462),
    [sym_range] = STATE(5462),
    [sym_binary] = STATE(5462),
    [sym_unary] = STATE(5462),
    [sym_left_assignment_list] = STATE(1112),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1113),
    [sym__variable] = STATE(1109),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1113),
    [sym_false] = STATE(1113),
    [sym_nil] = STATE(1113),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2917),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1973),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1977),
    [anon_sym_yield] = ACTIONS(1979),
    [anon_sym_break] = ACTIONS(1981),
    [anon_sym_next] = ACTIONS(1983),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4899),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1991),
    [anon_sym_TILDE] = ACTIONS(1991),
    [sym_constant] = ACTIONS(1997),
    [sym_identifier] = ACTIONS(1997),
    [sym_instance_variable] = ACTIONS(1995),
    [sym_class_variable] = ACTIONS(1995),
    [sym_global_variable] = ACTIONS(1995),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1997),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1997),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2946] = {
    [sym_string] = STATE(5463),
    [aux_sym_chained_string_repeat1] = STATE(5463),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_EQ_GT] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [2947] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(2003),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(2003),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(2003),
    [anon_sym_PERCENT] = ACTIONS(2003),
    [sym_comment] = ACTIONS(87),
  },
  [2948] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(2003),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [2949] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(2001),
    [sym__binary_star] = ACTIONS(2003),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(2003),
    [anon_sym_AMP] = ACTIONS(2007),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(2021),
    [anon_sym_GT_GT] = ACTIONS(2021),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_SLASH] = ACTIONS(2003),
    [anon_sym_PERCENT] = ACTIONS(2003),
    [sym_comment] = ACTIONS(87),
  },
  [2950] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(2001),
    [sym__binary_star] = ACTIONS(2003),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(2003),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(2021),
    [anon_sym_GT_GT] = ACTIONS(2021),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_SLASH] = ACTIONS(2003),
    [anon_sym_PERCENT] = ACTIONS(2003),
    [sym_comment] = ACTIONS(87),
  },
  [2951] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(2001),
    [sym__binary_star] = ACTIONS(2003),
    [anon_sym_PIPE] = ACTIONS(2005),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(2003),
    [anon_sym_AMP] = ACTIONS(2007),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(2021),
    [anon_sym_GT_GT] = ACTIONS(2021),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(2027),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_SLASH] = ACTIONS(2003),
    [anon_sym_PERCENT] = ACTIONS(2003),
    [sym_comment] = ACTIONS(87),
  },
  [2952] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(8579),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [2953] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(2001),
    [sym__binary_star] = ACTIONS(2003),
    [anon_sym_PIPE] = ACTIONS(2005),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(2003),
    [anon_sym_AMP] = ACTIONS(2007),
    [anon_sym_LT] = ACTIONS(2009),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(2013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2015),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(2019),
    [anon_sym_AMP_AMP] = ACTIONS(2019),
    [anon_sym_LT_LT] = ACTIONS(2021),
    [anon_sym_GT_GT] = ACTIONS(2021),
    [anon_sym_EQ_EQ] = ACTIONS(2023),
    [anon_sym_BANG_EQ] = ACTIONS(2019),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2019),
    [anon_sym_LT_EQ_GT] = ACTIONS(2019),
    [anon_sym_EQ_TILDE] = ACTIONS(2019),
    [anon_sym_BANG_TILDE] = ACTIONS(2019),
    [anon_sym_LT_EQ] = ACTIONS(2009),
    [anon_sym_GT] = ACTIONS(2009),
    [anon_sym_GT_EQ] = ACTIONS(2025),
    [anon_sym_CARET] = ACTIONS(2027),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_SLASH] = ACTIONS(2003),
    [anon_sym_PERCENT] = ACTIONS(2003),
    [sym_comment] = ACTIONS(87),
  },
  [2954] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(2001),
    [sym__binary_star] = ACTIONS(2003),
    [anon_sym_PIPE] = ACTIONS(2005),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(2003),
    [anon_sym_AMP] = ACTIONS(2007),
    [anon_sym_LT] = ACTIONS(2009),
    [anon_sym_QMARK] = ACTIONS(2011),
    [anon_sym_DOT_DOT] = ACTIONS(2013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2015),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(2019),
    [anon_sym_AMP_AMP] = ACTIONS(2019),
    [anon_sym_LT_LT] = ACTIONS(2021),
    [anon_sym_GT_GT] = ACTIONS(2021),
    [anon_sym_EQ_EQ] = ACTIONS(2023),
    [anon_sym_BANG_EQ] = ACTIONS(2019),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2019),
    [anon_sym_LT_EQ_GT] = ACTIONS(2019),
    [anon_sym_EQ_TILDE] = ACTIONS(2019),
    [anon_sym_BANG_TILDE] = ACTIONS(2019),
    [anon_sym_LT_EQ] = ACTIONS(2009),
    [anon_sym_GT] = ACTIONS(2009),
    [anon_sym_GT_EQ] = ACTIONS(2025),
    [anon_sym_CARET] = ACTIONS(2027),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_SLASH] = ACTIONS(2003),
    [anon_sym_PERCENT] = ACTIONS(2003),
    [sym_comment] = ACTIONS(87),
  },
  [2955] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(2001),
    [sym__binary_star] = ACTIONS(2003),
    [anon_sym_PIPE] = ACTIONS(2005),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(2003),
    [anon_sym_AMP] = ACTIONS(2007),
    [anon_sym_LT] = ACTIONS(2009),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(2021),
    [anon_sym_GT_GT] = ACTIONS(2021),
    [anon_sym_EQ_EQ] = ACTIONS(2023),
    [anon_sym_BANG_EQ] = ACTIONS(2019),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2019),
    [anon_sym_LT_EQ_GT] = ACTIONS(2019),
    [anon_sym_EQ_TILDE] = ACTIONS(2019),
    [anon_sym_BANG_TILDE] = ACTIONS(2019),
    [anon_sym_LT_EQ] = ACTIONS(2009),
    [anon_sym_GT] = ACTIONS(2009),
    [anon_sym_GT_EQ] = ACTIONS(2025),
    [anon_sym_CARET] = ACTIONS(2027),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_SLASH] = ACTIONS(2003),
    [anon_sym_PERCENT] = ACTIONS(2003),
    [sym_comment] = ACTIONS(87),
  },
  [2956] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(2001),
    [sym__binary_star] = ACTIONS(2003),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(2003),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_SLASH] = ACTIONS(2003),
    [anon_sym_PERCENT] = ACTIONS(2003),
    [sym_comment] = ACTIONS(87),
  },
  [2957] = {
    [sym__line_break] = ACTIONS(8581),
    [sym__heredoc_body_start] = ACTIONS(8581),
    [sym__binary_minus] = ACTIONS(8581),
    [sym__binary_star] = ACTIONS(8581),
    [ts_builtin_sym_end] = ACTIONS(8581),
    [anon_sym___END__] = ACTIONS(8581),
    [anon_sym_LBRACE] = ACTIONS(8581),
    [anon_sym_RBRACE] = ACTIONS(8581),
    [anon_sym_RPAREN] = ACTIONS(8581),
    [anon_sym_DOT] = ACTIONS(8583),
    [anon_sym_COMMA] = ACTIONS(8581),
    [anon_sym_PIPE] = ACTIONS(8583),
    [anon_sym_SEMI] = ACTIONS(8581),
    [anon_sym_STAR_STAR] = ACTIONS(8581),
    [anon_sym_AMP] = ACTIONS(8583),
    [anon_sym_LT] = ACTIONS(8583),
    [anon_sym_end] = ACTIONS(8581),
    [anon_sym_if] = ACTIONS(8581),
    [anon_sym_unless] = ACTIONS(8581),
    [anon_sym_while] = ACTIONS(8581),
    [anon_sym_until] = ACTIONS(8581),
    [anon_sym_rescue] = ACTIONS(8581),
    [anon_sym_do] = ACTIONS(8581),
    [anon_sym_when] = ACTIONS(8581),
    [anon_sym_elsif] = ACTIONS(8581),
    [anon_sym_else] = ACTIONS(8581),
    [anon_sym_then] = ACTIONS(8581),
    [anon_sym_ensure] = ACTIONS(8581),
    [anon_sym_EQ_GT] = ACTIONS(8581),
    [anon_sym_LBRACK] = ACTIONS(8581),
    [anon_sym_COLON_COLON2] = ACTIONS(8581),
    [anon_sym_AMP_DOT] = ACTIONS(8581),
    [anon_sym_QMARK] = ACTIONS(8581),
    [anon_sym_DOT_DOT] = ACTIONS(8583),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8581),
    [anon_sym_and] = ACTIONS(8581),
    [anon_sym_or] = ACTIONS(8581),
    [anon_sym_PIPE_PIPE] = ACTIONS(8581),
    [anon_sym_AMP_AMP] = ACTIONS(8581),
    [anon_sym_LT_LT] = ACTIONS(8581),
    [anon_sym_GT_GT] = ACTIONS(8581),
    [anon_sym_EQ_EQ] = ACTIONS(8583),
    [anon_sym_BANG_EQ] = ACTIONS(8581),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8581),
    [anon_sym_LT_EQ_GT] = ACTIONS(8581),
    [anon_sym_EQ_TILDE] = ACTIONS(8581),
    [anon_sym_BANG_TILDE] = ACTIONS(8581),
    [anon_sym_LT_EQ] = ACTIONS(8583),
    [anon_sym_GT] = ACTIONS(8583),
    [anon_sym_GT_EQ] = ACTIONS(8581),
    [anon_sym_CARET] = ACTIONS(8581),
    [anon_sym_PLUS] = ACTIONS(8581),
    [anon_sym_SLASH] = ACTIONS(8581),
    [anon_sym_PERCENT] = ACTIONS(8581),
    [sym_comment] = ACTIONS(87),
  },
  [2958] = {
    [anon_sym_end] = ACTIONS(8585),
    [sym_comment] = ACTIONS(87),
  },
  [2959] = {
    [sym_when] = STATE(5467),
    [sym_else] = STATE(5466),
    [aux_sym_case_repeat1] = STATE(2987),
    [aux_sym_case_repeat2] = STATE(5467),
    [anon_sym_SEMI] = ACTIONS(4995),
    [anon_sym_end] = ACTIONS(8585),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [2960] = {
    [sym_when] = STATE(2988),
    [sym_else] = STATE(5466),
    [aux_sym_case_repeat2] = STATE(2988),
    [anon_sym_end] = ACTIONS(8585),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [2961] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5468),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2968),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2968),
    [sym_assignment] = STATE(5468),
    [sym_operator_assignment] = STATE(5468),
    [sym_conditional] = STATE(5468),
    [sym_range] = STATE(5468),
    [sym_binary] = STATE(5468),
    [sym_unary] = STATE(5468),
    [sym_left_assignment_list] = STATE(2967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2968),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2968),
    [sym_false] = STATE(2968),
    [sym_nil] = STATE(2968),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2914),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4955),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4883),
    [anon_sym_yield] = ACTIONS(4885),
    [anon_sym_break] = ACTIONS(4887),
    [anon_sym_next] = ACTIONS(4889),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4957),
    [anon_sym_defined_QMARK] = ACTIONS(4959),
    [anon_sym_not] = ACTIONS(4961),
    [anon_sym_BANG] = ACTIONS(4963),
    [anon_sym_TILDE] = ACTIONS(4963),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2962] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5469),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2968),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2968),
    [sym_assignment] = STATE(5469),
    [sym_operator_assignment] = STATE(5469),
    [sym_conditional] = STATE(5469),
    [sym_range] = STATE(5469),
    [sym_binary] = STATE(5469),
    [sym_unary] = STATE(5469),
    [sym_left_assignment_list] = STATE(2967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2968),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2968),
    [sym_false] = STATE(2968),
    [sym_nil] = STATE(2968),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2914),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4955),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4883),
    [anon_sym_yield] = ACTIONS(4885),
    [anon_sym_break] = ACTIONS(4887),
    [anon_sym_next] = ACTIONS(4889),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4957),
    [anon_sym_defined_QMARK] = ACTIONS(4959),
    [anon_sym_not] = ACTIONS(4961),
    [anon_sym_BANG] = ACTIONS(4963),
    [anon_sym_TILDE] = ACTIONS(4963),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2963] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5470),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2968),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2968),
    [sym_assignment] = STATE(5470),
    [sym_operator_assignment] = STATE(5470),
    [sym_conditional] = STATE(5470),
    [sym_range] = STATE(5470),
    [sym_binary] = STATE(5470),
    [sym_unary] = STATE(5470),
    [sym_left_assignment_list] = STATE(2967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2968),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2968),
    [sym_false] = STATE(2968),
    [sym_nil] = STATE(2968),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2914),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4955),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4883),
    [anon_sym_yield] = ACTIONS(4885),
    [anon_sym_break] = ACTIONS(4887),
    [anon_sym_next] = ACTIONS(4889),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4957),
    [anon_sym_defined_QMARK] = ACTIONS(4959),
    [anon_sym_not] = ACTIONS(4961),
    [anon_sym_BANG] = ACTIONS(4963),
    [anon_sym_TILDE] = ACTIONS(4963),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2964] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(298),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2968),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2968),
    [sym_assignment] = STATE(298),
    [sym_operator_assignment] = STATE(298),
    [sym_conditional] = STATE(298),
    [sym_range] = STATE(298),
    [sym_binary] = STATE(298),
    [sym_unary] = STATE(298),
    [sym_left_assignment_list] = STATE(2967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2968),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2968),
    [sym_false] = STATE(2968),
    [sym_nil] = STATE(2968),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2914),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4955),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4883),
    [anon_sym_yield] = ACTIONS(4885),
    [anon_sym_break] = ACTIONS(4887),
    [anon_sym_next] = ACTIONS(4889),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4957),
    [anon_sym_defined_QMARK] = ACTIONS(4959),
    [anon_sym_not] = ACTIONS(4961),
    [anon_sym_BANG] = ACTIONS(4963),
    [anon_sym_TILDE] = ACTIONS(4963),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2965] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(8587),
    [sym__binary_star] = ACTIONS(8589),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(8591),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(8589),
    [anon_sym_AMP] = ACTIONS(8593),
    [anon_sym_LT] = ACTIONS(8595),
    [anon_sym_QMARK] = ACTIONS(8597),
    [anon_sym_DOT_DOT] = ACTIONS(8599),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8601),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(8603),
    [anon_sym_AMP_AMP] = ACTIONS(8603),
    [anon_sym_LT_LT] = ACTIONS(8605),
    [anon_sym_GT_GT] = ACTIONS(8605),
    [anon_sym_EQ_EQ] = ACTIONS(8607),
    [anon_sym_BANG_EQ] = ACTIONS(8603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8603),
    [anon_sym_LT_EQ_GT] = ACTIONS(8603),
    [anon_sym_EQ_TILDE] = ACTIONS(8603),
    [anon_sym_BANG_TILDE] = ACTIONS(8603),
    [anon_sym_LT_EQ] = ACTIONS(8595),
    [anon_sym_GT] = ACTIONS(8595),
    [anon_sym_GT_EQ] = ACTIONS(8609),
    [anon_sym_CARET] = ACTIONS(8611),
    [anon_sym_PLUS] = ACTIONS(8587),
    [anon_sym_SLASH] = ACTIONS(8589),
    [anon_sym_PERCENT] = ACTIONS(8589),
    [sym_comment] = ACTIONS(87),
  },
  [2966] = {
    [aux_sym_exceptions_repeat1] = STATE(5482),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_COMMA] = ACTIONS(8613),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [2967] = {
    [anon_sym_EQ] = ACTIONS(8615),
    [sym_comment] = ACTIONS(87),
  },
  [2968] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(8617),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(8619),
    [anon_sym_DASH_EQ] = ACTIONS(8619),
    [anon_sym_STAR_EQ] = ACTIONS(8619),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8619),
    [anon_sym_SLASH_EQ] = ACTIONS(8619),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8619),
    [anon_sym_PIPE_EQ] = ACTIONS(8619),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8619),
    [anon_sym_AMP_EQ] = ACTIONS(8619),
    [anon_sym_PERCENT_EQ] = ACTIONS(8619),
    [anon_sym_GT_GT_EQ] = ACTIONS(8619),
    [anon_sym_LT_LT_EQ] = ACTIONS(8619),
    [anon_sym_CARET_EQ] = ACTIONS(8619),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2969] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(2001),
    [sym__binary_star] = ACTIONS(2003),
    [anon_sym_PIPE] = ACTIONS(2005),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(2003),
    [anon_sym_AMP] = ACTIONS(2007),
    [anon_sym_LT] = ACTIONS(2009),
    [anon_sym_QMARK] = ACTIONS(2011),
    [anon_sym_DOT_DOT] = ACTIONS(2013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2015),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(2019),
    [anon_sym_AMP_AMP] = ACTIONS(2019),
    [anon_sym_LT_LT] = ACTIONS(2021),
    [anon_sym_GT_GT] = ACTIONS(2021),
    [anon_sym_EQ_EQ] = ACTIONS(2023),
    [anon_sym_BANG_EQ] = ACTIONS(2019),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2019),
    [anon_sym_LT_EQ_GT] = ACTIONS(2019),
    [anon_sym_EQ_TILDE] = ACTIONS(2019),
    [anon_sym_BANG_TILDE] = ACTIONS(2019),
    [anon_sym_LT_EQ] = ACTIONS(2009),
    [anon_sym_GT] = ACTIONS(2009),
    [anon_sym_GT_EQ] = ACTIONS(2025),
    [anon_sym_CARET] = ACTIONS(2027),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_SLASH] = ACTIONS(2003),
    [anon_sym_PERCENT] = ACTIONS(2003),
    [sym_comment] = ACTIONS(87),
  },
  [2970] = {
    [sym_string] = STATE(2970),
    [aux_sym_chained_string_repeat1] = STATE(2970),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(6214),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [2971] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5485),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2984),
    [sym_scope_resolution] = STATE(2981),
    [sym_call] = STATE(2981),
    [sym_method_call] = STATE(2984),
    [sym_assignment] = STATE(5485),
    [sym_operator_assignment] = STATE(5485),
    [sym_conditional] = STATE(5485),
    [sym_range] = STATE(5485),
    [sym_binary] = STATE(5485),
    [sym_unary] = STATE(5485),
    [sym_left_assignment_list] = STATE(2983),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2984),
    [sym__variable] = STATE(2981),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2984),
    [sym_false] = STATE(2984),
    [sym_nil] = STATE(2984),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2985),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4971),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4973),
    [anon_sym_yield] = ACTIONS(4975),
    [anon_sym_break] = ACTIONS(4977),
    [anon_sym_next] = ACTIONS(4979),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4981),
    [anon_sym_defined_QMARK] = ACTIONS(4983),
    [anon_sym_not] = ACTIONS(4985),
    [anon_sym_BANG] = ACTIONS(4987),
    [anon_sym_TILDE] = ACTIONS(4987),
    [sym_constant] = ACTIONS(4989),
    [sym_identifier] = ACTIONS(4989),
    [sym_instance_variable] = ACTIONS(4991),
    [sym_class_variable] = ACTIONS(4991),
    [sym_global_variable] = ACTIONS(4991),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4989),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4989),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2972] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5486),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2984),
    [sym_scope_resolution] = STATE(2981),
    [sym_call] = STATE(2981),
    [sym_method_call] = STATE(2984),
    [sym_assignment] = STATE(5486),
    [sym_operator_assignment] = STATE(5486),
    [sym_conditional] = STATE(5486),
    [sym_range] = STATE(5486),
    [sym_binary] = STATE(5486),
    [sym_unary] = STATE(5486),
    [sym_left_assignment_list] = STATE(2983),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2984),
    [sym__variable] = STATE(2981),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2984),
    [sym_false] = STATE(2984),
    [sym_nil] = STATE(2984),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2985),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4971),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4973),
    [anon_sym_yield] = ACTIONS(4975),
    [anon_sym_break] = ACTIONS(4977),
    [anon_sym_next] = ACTIONS(4979),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4981),
    [anon_sym_defined_QMARK] = ACTIONS(4983),
    [anon_sym_not] = ACTIONS(4985),
    [anon_sym_BANG] = ACTIONS(4987),
    [anon_sym_TILDE] = ACTIONS(4987),
    [sym_constant] = ACTIONS(4989),
    [sym_identifier] = ACTIONS(4989),
    [sym_instance_variable] = ACTIONS(4991),
    [sym_class_variable] = ACTIONS(4991),
    [sym_global_variable] = ACTIONS(4991),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4989),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4989),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2973] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5492),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3056),
    [sym_scope_resolution] = STATE(1172),
    [sym_call] = STATE(1172),
    [sym_method_call] = STATE(3056),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(5493),
    [sym__argument] = STATE(5494),
    [sym_splat_argument] = STATE(5494),
    [sym_hash_splat_argument] = STATE(5494),
    [sym_block_argument] = STATE(5494),
    [sym_assignment] = STATE(5492),
    [sym_operator_assignment] = STATE(5492),
    [sym_conditional] = STATE(5492),
    [sym_range] = STATE(5492),
    [sym_binary] = STATE(5492),
    [sym_unary] = STATE(5492),
    [sym_left_assignment_list] = STATE(3055),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3056),
    [sym__variable] = STATE(1172),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3056),
    [sym_false] = STATE(3056),
    [sym_nil] = STATE(3056),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5495),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5494),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(8621),
    [sym__splat_star] = ACTIONS(8623),
    [sym__unary_minus] = ACTIONS(5081),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(8625),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2085),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_next] = ACTIONS(2089),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(377),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(5085),
    [anon_sym_not] = ACTIONS(5087),
    [anon_sym_BANG] = ACTIONS(5089),
    [anon_sym_TILDE] = ACTIONS(5091),
    [sym_constant] = ACTIONS(8627),
    [sym_identifier] = ACTIONS(8627),
    [sym_instance_variable] = ACTIONS(2105),
    [sym_class_variable] = ACTIONS(2105),
    [sym_global_variable] = ACTIONS(2105),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2103),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2103),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2974] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5492),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3056),
    [sym_scope_resolution] = STATE(1172),
    [sym_call] = STATE(1172),
    [sym_method_call] = STATE(3056),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(5493),
    [sym__argument] = STATE(5494),
    [sym_splat_argument] = STATE(5494),
    [sym_hash_splat_argument] = STATE(5494),
    [sym_block_argument] = STATE(5494),
    [sym_assignment] = STATE(5492),
    [sym_operator_assignment] = STATE(5492),
    [sym_conditional] = STATE(5492),
    [sym_range] = STATE(5492),
    [sym_binary] = STATE(5492),
    [sym_unary] = STATE(5492),
    [sym_left_assignment_list] = STATE(3055),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3056),
    [sym__variable] = STATE(1172),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3056),
    [sym_false] = STATE(3056),
    [sym_nil] = STATE(3056),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5495),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5494),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(8621),
    [sym__splat_star] = ACTIONS(8623),
    [sym__unary_minus] = ACTIONS(5081),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(8625),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2085),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_next] = ACTIONS(2089),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(419),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(5085),
    [anon_sym_not] = ACTIONS(5087),
    [anon_sym_BANG] = ACTIONS(5089),
    [anon_sym_TILDE] = ACTIONS(5091),
    [sym_constant] = ACTIONS(8627),
    [sym_identifier] = ACTIONS(8627),
    [sym_instance_variable] = ACTIONS(2105),
    [sym_class_variable] = ACTIONS(2105),
    [sym_global_variable] = ACTIONS(2105),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2103),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2103),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2975] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5492),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3056),
    [sym_scope_resolution] = STATE(1172),
    [sym_call] = STATE(1172),
    [sym_method_call] = STATE(3056),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(5493),
    [sym__argument] = STATE(5494),
    [sym_splat_argument] = STATE(5494),
    [sym_hash_splat_argument] = STATE(5494),
    [sym_block_argument] = STATE(5494),
    [sym_assignment] = STATE(5492),
    [sym_operator_assignment] = STATE(5492),
    [sym_conditional] = STATE(5492),
    [sym_range] = STATE(5492),
    [sym_binary] = STATE(5492),
    [sym_unary] = STATE(5492),
    [sym_left_assignment_list] = STATE(3055),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3056),
    [sym__variable] = STATE(1172),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3056),
    [sym_false] = STATE(3056),
    [sym_nil] = STATE(3056),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5495),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5494),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(8621),
    [sym__splat_star] = ACTIONS(8623),
    [sym__unary_minus] = ACTIONS(5081),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(8625),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2085),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_next] = ACTIONS(2089),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(423),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(5085),
    [anon_sym_not] = ACTIONS(5087),
    [anon_sym_BANG] = ACTIONS(5089),
    [anon_sym_TILDE] = ACTIONS(5091),
    [sym_constant] = ACTIONS(8627),
    [sym_identifier] = ACTIONS(8627),
    [sym_instance_variable] = ACTIONS(2105),
    [sym_class_variable] = ACTIONS(2105),
    [sym_global_variable] = ACTIONS(2105),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2103),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2103),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2976] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5492),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3056),
    [sym_scope_resolution] = STATE(1172),
    [sym_call] = STATE(1172),
    [sym_method_call] = STATE(3056),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(5493),
    [sym__argument] = STATE(5494),
    [sym_splat_argument] = STATE(5494),
    [sym_hash_splat_argument] = STATE(5494),
    [sym_block_argument] = STATE(5494),
    [sym_assignment] = STATE(5492),
    [sym_operator_assignment] = STATE(5492),
    [sym_conditional] = STATE(5492),
    [sym_range] = STATE(5492),
    [sym_binary] = STATE(5492),
    [sym_unary] = STATE(5492),
    [sym_left_assignment_list] = STATE(3055),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3056),
    [sym__variable] = STATE(1172),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3056),
    [sym_false] = STATE(3056),
    [sym_nil] = STATE(3056),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5495),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5494),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(8621),
    [sym__splat_star] = ACTIONS(8623),
    [sym__unary_minus] = ACTIONS(5081),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(8625),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2085),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_next] = ACTIONS(2089),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(427),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(5085),
    [anon_sym_not] = ACTIONS(5087),
    [anon_sym_BANG] = ACTIONS(5089),
    [anon_sym_TILDE] = ACTIONS(5091),
    [sym_constant] = ACTIONS(8627),
    [sym_identifier] = ACTIONS(8627),
    [sym_instance_variable] = ACTIONS(2105),
    [sym_class_variable] = ACTIONS(2105),
    [sym_global_variable] = ACTIONS(2105),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2103),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2103),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2977] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5496),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2984),
    [sym_scope_resolution] = STATE(2981),
    [sym_call] = STATE(2981),
    [sym_method_call] = STATE(2984),
    [sym_assignment] = STATE(5496),
    [sym_operator_assignment] = STATE(5496),
    [sym_conditional] = STATE(5496),
    [sym_range] = STATE(5496),
    [sym_binary] = STATE(5496),
    [sym_unary] = STATE(5496),
    [sym_left_assignment_list] = STATE(2983),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2984),
    [sym__variable] = STATE(2981),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2984),
    [sym_false] = STATE(2984),
    [sym_nil] = STATE(2984),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2985),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4971),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4973),
    [anon_sym_yield] = ACTIONS(4975),
    [anon_sym_break] = ACTIONS(4977),
    [anon_sym_next] = ACTIONS(4979),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4981),
    [anon_sym_defined_QMARK] = ACTIONS(4983),
    [anon_sym_not] = ACTIONS(4985),
    [anon_sym_BANG] = ACTIONS(4987),
    [anon_sym_TILDE] = ACTIONS(4987),
    [sym_constant] = ACTIONS(4989),
    [sym_identifier] = ACTIONS(4989),
    [sym_instance_variable] = ACTIONS(4991),
    [sym_class_variable] = ACTIONS(4991),
    [sym_global_variable] = ACTIONS(4991),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4989),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4989),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2978] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(298),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2984),
    [sym_scope_resolution] = STATE(2981),
    [sym_call] = STATE(2981),
    [sym_method_call] = STATE(2984),
    [sym_assignment] = STATE(298),
    [sym_operator_assignment] = STATE(298),
    [sym_conditional] = STATE(298),
    [sym_range] = STATE(298),
    [sym_binary] = STATE(298),
    [sym_unary] = STATE(298),
    [sym_left_assignment_list] = STATE(2983),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2984),
    [sym__variable] = STATE(2981),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2984),
    [sym_false] = STATE(2984),
    [sym_nil] = STATE(2984),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2985),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4971),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4973),
    [anon_sym_yield] = ACTIONS(4975),
    [anon_sym_break] = ACTIONS(4977),
    [anon_sym_next] = ACTIONS(4979),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4981),
    [anon_sym_defined_QMARK] = ACTIONS(4983),
    [anon_sym_not] = ACTIONS(4985),
    [anon_sym_BANG] = ACTIONS(4987),
    [anon_sym_TILDE] = ACTIONS(4987),
    [sym_constant] = ACTIONS(4989),
    [sym_identifier] = ACTIONS(4989),
    [sym_instance_variable] = ACTIONS(4991),
    [sym_class_variable] = ACTIONS(4991),
    [sym_global_variable] = ACTIONS(4991),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4989),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4989),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2979] = {
    [sym_then] = STATE(5499),
    [sym_heredoc_body] = STATE(5500),
    [sym__terminator] = STATE(5500),
    [aux_sym_when_repeat1] = STATE(5501),
    [sym__line_break] = ACTIONS(8629),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_COMMA] = ACTIONS(8631),
    [anon_sym_SEMI] = ACTIONS(8629),
    [anon_sym_then] = ACTIONS(8633),
    [sym_comment] = ACTIONS(87),
  },
  [2980] = {
    [sym__line_break] = ACTIONS(8635),
    [sym__heredoc_body_start] = ACTIONS(8635),
    [sym__binary_minus] = ACTIONS(8637),
    [sym__binary_star] = ACTIONS(8639),
    [anon_sym_COMMA] = ACTIONS(8635),
    [anon_sym_PIPE] = ACTIONS(8641),
    [anon_sym_SEMI] = ACTIONS(8635),
    [anon_sym_STAR_STAR] = ACTIONS(8639),
    [anon_sym_AMP] = ACTIONS(8643),
    [anon_sym_LT] = ACTIONS(8645),
    [anon_sym_then] = ACTIONS(8635),
    [anon_sym_QMARK] = ACTIONS(8647),
    [anon_sym_DOT_DOT] = ACTIONS(8649),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8651),
    [anon_sym_and] = ACTIONS(8653),
    [anon_sym_or] = ACTIONS(8653),
    [anon_sym_PIPE_PIPE] = ACTIONS(8655),
    [anon_sym_AMP_AMP] = ACTIONS(8655),
    [anon_sym_LT_LT] = ACTIONS(8657),
    [anon_sym_GT_GT] = ACTIONS(8657),
    [anon_sym_EQ_EQ] = ACTIONS(8659),
    [anon_sym_BANG_EQ] = ACTIONS(8655),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8655),
    [anon_sym_LT_EQ_GT] = ACTIONS(8655),
    [anon_sym_EQ_TILDE] = ACTIONS(8655),
    [anon_sym_BANG_TILDE] = ACTIONS(8655),
    [anon_sym_LT_EQ] = ACTIONS(8645),
    [anon_sym_GT] = ACTIONS(8645),
    [anon_sym_GT_EQ] = ACTIONS(8661),
    [anon_sym_CARET] = ACTIONS(8663),
    [anon_sym_PLUS] = ACTIONS(8637),
    [anon_sym_SLASH] = ACTIONS(8639),
    [anon_sym_PERCENT] = ACTIONS(8639),
    [sym_comment] = ACTIONS(87),
  },
  [2981] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5517),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3096),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(3096),
    [sym_argument_list] = STATE(423),
    [sym__argument_list_with_parens] = STATE(5518),
    [sym__argument] = STATE(5519),
    [sym_splat_argument] = STATE(5519),
    [sym_hash_splat_argument] = STATE(5519),
    [sym_block_argument] = STATE(5519),
    [sym_do_block] = STATE(426),
    [sym_block] = STATE(426),
    [sym_assignment] = STATE(5517),
    [sym_operator_assignment] = STATE(5517),
    [sym_conditional] = STATE(5517),
    [sym_range] = STATE(5517),
    [sym_binary] = STATE(5517),
    [sym_unary] = STATE(5517),
    [sym_left_assignment_list] = STATE(3095),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3096),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3096),
    [sym_false] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5520),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(5519),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(743),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(8665),
    [sym__splat_star] = ACTIONS(8667),
    [sym__unary_minus] = ACTIONS(5149),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(8669),
    [anon_sym_LBRACE] = ACTIONS(771),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5153),
    [anon_sym_yield] = ACTIONS(5155),
    [anon_sym_break] = ACTIONS(5157),
    [anon_sym_next] = ACTIONS(5159),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_then] = ACTIONS(769),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(5161),
    [anon_sym_not] = ACTIONS(5163),
    [anon_sym_BANG] = ACTIONS(5165),
    [anon_sym_TILDE] = ACTIONS(5167),
    [sym_constant] = ACTIONS(8671),
    [sym_identifier] = ACTIONS(8671),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [2982] = {
    [sym__line_break] = ACTIONS(8635),
    [sym__heredoc_body_start] = ACTIONS(8635),
    [anon_sym_COMMA] = ACTIONS(8635),
    [anon_sym_SEMI] = ACTIONS(8635),
    [anon_sym_then] = ACTIONS(8635),
    [sym_comment] = ACTIONS(87),
  },
  [2983] = {
    [anon_sym_EQ] = ACTIONS(8673),
    [sym_comment] = ACTIONS(87),
  },
  [2984] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(8675),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(8677),
    [anon_sym_DASH_EQ] = ACTIONS(8677),
    [anon_sym_STAR_EQ] = ACTIONS(8677),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8677),
    [anon_sym_SLASH_EQ] = ACTIONS(8677),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8677),
    [anon_sym_PIPE_EQ] = ACTIONS(8677),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8677),
    [anon_sym_AMP_EQ] = ACTIONS(8677),
    [anon_sym_PERCENT_EQ] = ACTIONS(8677),
    [anon_sym_GT_GT_EQ] = ACTIONS(8677),
    [anon_sym_LT_LT_EQ] = ACTIONS(8677),
    [anon_sym_CARET_EQ] = ACTIONS(8677),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2985] = {
    [sym_string] = STATE(5523),
    [aux_sym_chained_string_repeat1] = STATE(5523),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2986] = {
    [sym__statements] = STATE(3163),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(5297),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2987] = {
    [aux_sym_case_repeat1] = STATE(2987),
    [anon_sym_SEMI] = ACTIONS(8679),
    [anon_sym_end] = ACTIONS(8682),
    [anon_sym_when] = ACTIONS(8682),
    [anon_sym_else] = ACTIONS(8682),
    [sym_comment] = ACTIONS(87),
  },
  [2988] = {
    [sym_when] = STATE(2988),
    [aux_sym_case_repeat2] = STATE(2988),
    [anon_sym_end] = ACTIONS(8684),
    [anon_sym_when] = ACTIONS(8686),
    [anon_sym_else] = ACTIONS(8684),
    [sym_comment] = ACTIONS(87),
  },
  [2989] = {
    [sym__simple_symbol] = ACTIONS(6813),
    [sym__string_start] = ACTIONS(6813),
    [sym__symbol_start] = ACTIONS(6813),
    [sym__subshell_start] = ACTIONS(6813),
    [sym__regex_start] = ACTIONS(6813),
    [sym__string_array_start] = ACTIONS(6813),
    [sym__symbol_array_start] = ACTIONS(6813),
    [sym_heredoc_beginning] = ACTIONS(6813),
    [sym__unary_minus] = ACTIONS(6813),
    [ts_builtin_sym_end] = ACTIONS(6813),
    [anon_sym___END__] = ACTIONS(8689),
    [anon_sym_BEGIN] = ACTIONS(8689),
    [anon_sym_LBRACE] = ACTIONS(6813),
    [anon_sym_RBRACE] = ACTIONS(6813),
    [anon_sym_END] = ACTIONS(8689),
    [anon_sym_def] = ACTIONS(8689),
    [anon_sym_LPAREN] = ACTIONS(6813),
    [anon_sym_RPAREN] = ACTIONS(6813),
    [anon_sym_COLON_COLON] = ACTIONS(6813),
    [anon_sym_PIPE] = ACTIONS(6813),
    [anon_sym_SEMI] = ACTIONS(6813),
    [anon_sym_STAR] = ACTIONS(6813),
    [anon_sym_class] = ACTIONS(8689),
    [anon_sym_module] = ACTIONS(8689),
    [anon_sym_end] = ACTIONS(8689),
    [anon_sym_return] = ACTIONS(8689),
    [anon_sym_yield] = ACTIONS(8689),
    [anon_sym_break] = ACTIONS(8689),
    [anon_sym_next] = ACTIONS(8689),
    [sym_redo] = ACTIONS(8689),
    [sym_retry] = ACTIONS(8689),
    [anon_sym_if] = ACTIONS(8689),
    [anon_sym_unless] = ACTIONS(8689),
    [anon_sym_while] = ACTIONS(8689),
    [anon_sym_until] = ACTIONS(8689),
    [anon_sym_rescue] = ACTIONS(8689),
    [anon_sym_for] = ACTIONS(8689),
    [anon_sym_case] = ACTIONS(8689),
    [anon_sym_when] = ACTIONS(8689),
    [anon_sym_elsif] = ACTIONS(8689),
    [anon_sym_else] = ACTIONS(8689),
    [anon_sym_then] = ACTIONS(8689),
    [anon_sym_begin] = ACTIONS(8689),
    [anon_sym_ensure] = ACTIONS(8689),
    [anon_sym_PLUS] = ACTIONS(8689),
    [anon_sym_defined_QMARK] = ACTIONS(6813),
    [anon_sym_not] = ACTIONS(8689),
    [anon_sym_BANG] = ACTIONS(6813),
    [anon_sym_TILDE] = ACTIONS(6813),
    [sym_constant] = ACTIONS(8689),
    [sym_identifier] = ACTIONS(8689),
    [sym_instance_variable] = ACTIONS(6813),
    [sym_class_variable] = ACTIONS(6813),
    [sym_global_variable] = ACTIONS(6813),
    [anon_sym_undef] = ACTIONS(8689),
    [anon_sym_alias] = ACTIONS(8689),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(8689),
    [sym_float] = ACTIONS(8689),
    [sym_complex] = ACTIONS(6813),
    [sym_super] = ACTIONS(8689),
    [anon_sym_true] = ACTIONS(8689),
    [anon_sym_TRUE] = ACTIONS(8689),
    [anon_sym_false] = ACTIONS(8689),
    [anon_sym_FALSE] = ACTIONS(8689),
    [sym_self] = ACTIONS(8689),
    [anon_sym_nil] = ACTIONS(8689),
    [anon_sym_NIL] = ACTIONS(8689),
    [sym_character] = ACTIONS(6813),
    [anon_sym_LBRACK2] = ACTIONS(6813),
    [anon_sym_DASH_GT] = ACTIONS(6813),
  },
  [2990] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5524),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2999),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(2999),
    [sym_assignment] = STATE(5524),
    [sym_operator_assignment] = STATE(5524),
    [sym_conditional] = STATE(5524),
    [sym_range] = STATE(5524),
    [sym_binary] = STATE(5524),
    [sym_unary] = STATE(5524),
    [sym_left_assignment_list] = STATE(2998),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2999),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2999),
    [sym_false] = STATE(2999),
    [sym_nil] = STATE(2999),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(3000),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(5001),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5003),
    [anon_sym_yield] = ACTIONS(5005),
    [anon_sym_break] = ACTIONS(5007),
    [anon_sym_next] = ACTIONS(5009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5011),
    [anon_sym_defined_QMARK] = ACTIONS(5013),
    [anon_sym_not] = ACTIONS(5015),
    [anon_sym_BANG] = ACTIONS(5017),
    [anon_sym_TILDE] = ACTIONS(5017),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2991] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1151),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1156),
    [sym_scope_resolution] = STATE(1152),
    [sym_call] = STATE(1152),
    [sym_method_call] = STATE(1156),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(5525),
    [sym__argument] = STATE(5526),
    [sym_splat_argument] = STATE(5526),
    [sym_hash_splat_argument] = STATE(5526),
    [sym_block_argument] = STATE(5526),
    [sym_assignment] = STATE(1151),
    [sym_operator_assignment] = STATE(1151),
    [sym_conditional] = STATE(1151),
    [sym_range] = STATE(1151),
    [sym_binary] = STATE(1151),
    [sym_unary] = STATE(1151),
    [sym_left_assignment_list] = STATE(1155),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1156),
    [sym__variable] = STATE(1152),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1156),
    [sym_false] = STATE(1156),
    [sym_nil] = STATE(1156),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1157),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5526),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(2047),
    [sym__splat_star] = ACTIONS(2049),
    [sym__unary_minus] = ACTIONS(2051),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(2053),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(2055),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2059),
    [anon_sym_next] = ACTIONS(2061),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(377),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(377),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [anon_sym_BANG] = ACTIONS(2067),
    [anon_sym_TILDE] = ACTIONS(2069),
    [sym_constant] = ACTIONS(2071),
    [sym_identifier] = ACTIONS(2071),
    [sym_instance_variable] = ACTIONS(2073),
    [sym_class_variable] = ACTIONS(2073),
    [sym_global_variable] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2075),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2992] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1151),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1156),
    [sym_scope_resolution] = STATE(1152),
    [sym_call] = STATE(1152),
    [sym_method_call] = STATE(1156),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(5525),
    [sym__argument] = STATE(5526),
    [sym_splat_argument] = STATE(5526),
    [sym_hash_splat_argument] = STATE(5526),
    [sym_block_argument] = STATE(5526),
    [sym_assignment] = STATE(1151),
    [sym_operator_assignment] = STATE(1151),
    [sym_conditional] = STATE(1151),
    [sym_range] = STATE(1151),
    [sym_binary] = STATE(1151),
    [sym_unary] = STATE(1151),
    [sym_left_assignment_list] = STATE(1155),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1156),
    [sym__variable] = STATE(1152),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1156),
    [sym_false] = STATE(1156),
    [sym_nil] = STATE(1156),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1157),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5526),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(2047),
    [sym__splat_star] = ACTIONS(2049),
    [sym__unary_minus] = ACTIONS(2051),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(2053),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(2055),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2059),
    [anon_sym_next] = ACTIONS(2061),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(419),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [anon_sym_BANG] = ACTIONS(2067),
    [anon_sym_TILDE] = ACTIONS(2069),
    [sym_constant] = ACTIONS(2071),
    [sym_identifier] = ACTIONS(2071),
    [sym_instance_variable] = ACTIONS(2073),
    [sym_class_variable] = ACTIONS(2073),
    [sym_global_variable] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2075),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2993] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1151),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1156),
    [sym_scope_resolution] = STATE(1152),
    [sym_call] = STATE(1152),
    [sym_method_call] = STATE(1156),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(5525),
    [sym__argument] = STATE(5526),
    [sym_splat_argument] = STATE(5526),
    [sym_hash_splat_argument] = STATE(5526),
    [sym_block_argument] = STATE(5526),
    [sym_assignment] = STATE(1151),
    [sym_operator_assignment] = STATE(1151),
    [sym_conditional] = STATE(1151),
    [sym_range] = STATE(1151),
    [sym_binary] = STATE(1151),
    [sym_unary] = STATE(1151),
    [sym_left_assignment_list] = STATE(1155),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1156),
    [sym__variable] = STATE(1152),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1156),
    [sym_false] = STATE(1156),
    [sym_nil] = STATE(1156),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1157),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5526),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(2047),
    [sym__splat_star] = ACTIONS(2049),
    [sym__unary_minus] = ACTIONS(2051),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(2053),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(423),
    [anon_sym_return] = ACTIONS(2055),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2059),
    [anon_sym_next] = ACTIONS(2061),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(423),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [anon_sym_BANG] = ACTIONS(2067),
    [anon_sym_TILDE] = ACTIONS(2069),
    [sym_constant] = ACTIONS(2071),
    [sym_identifier] = ACTIONS(2071),
    [sym_instance_variable] = ACTIONS(2073),
    [sym_class_variable] = ACTIONS(2073),
    [sym_global_variable] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2075),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2994] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1151),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1156),
    [sym_scope_resolution] = STATE(1152),
    [sym_call] = STATE(1152),
    [sym_method_call] = STATE(1156),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(5525),
    [sym__argument] = STATE(5526),
    [sym_splat_argument] = STATE(5526),
    [sym_hash_splat_argument] = STATE(5526),
    [sym_block_argument] = STATE(5526),
    [sym_assignment] = STATE(1151),
    [sym_operator_assignment] = STATE(1151),
    [sym_conditional] = STATE(1151),
    [sym_range] = STATE(1151),
    [sym_binary] = STATE(1151),
    [sym_unary] = STATE(1151),
    [sym_left_assignment_list] = STATE(1155),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1156),
    [sym__variable] = STATE(1152),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1156),
    [sym_false] = STATE(1156),
    [sym_nil] = STATE(1156),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1157),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5526),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(2047),
    [sym__splat_star] = ACTIONS(2049),
    [sym__unary_minus] = ACTIONS(2051),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(2053),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(427),
    [anon_sym_return] = ACTIONS(2055),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2059),
    [anon_sym_next] = ACTIONS(2061),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(427),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [anon_sym_BANG] = ACTIONS(2067),
    [anon_sym_TILDE] = ACTIONS(2069),
    [sym_constant] = ACTIONS(2071),
    [sym_identifier] = ACTIONS(2071),
    [sym_instance_variable] = ACTIONS(2073),
    [sym_class_variable] = ACTIONS(2073),
    [sym_global_variable] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2075),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2995] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5527),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2999),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(2999),
    [sym_assignment] = STATE(5527),
    [sym_operator_assignment] = STATE(5527),
    [sym_conditional] = STATE(5527),
    [sym_range] = STATE(5527),
    [sym_binary] = STATE(5527),
    [sym_unary] = STATE(5527),
    [sym_left_assignment_list] = STATE(2998),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2999),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2999),
    [sym_false] = STATE(2999),
    [sym_nil] = STATE(2999),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(3000),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(5001),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5003),
    [anon_sym_yield] = ACTIONS(5005),
    [anon_sym_break] = ACTIONS(5007),
    [anon_sym_next] = ACTIONS(5009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5011),
    [anon_sym_defined_QMARK] = ACTIONS(5013),
    [anon_sym_not] = ACTIONS(5015),
    [anon_sym_BANG] = ACTIONS(5017),
    [anon_sym_TILDE] = ACTIONS(5017),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2996] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2999),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(2999),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(2998),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2999),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2999),
    [sym_false] = STATE(2999),
    [sym_nil] = STATE(2999),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(3000),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(5001),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5003),
    [anon_sym_yield] = ACTIONS(5005),
    [anon_sym_break] = ACTIONS(5007),
    [anon_sym_next] = ACTIONS(5009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5011),
    [anon_sym_defined_QMARK] = ACTIONS(5013),
    [anon_sym_not] = ACTIONS(5015),
    [anon_sym_BANG] = ACTIONS(5017),
    [anon_sym_TILDE] = ACTIONS(5017),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2997] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(8691),
    [sym__binary_star] = ACTIONS(8693),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(8695),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(8693),
    [anon_sym_AMP] = ACTIONS(8697),
    [anon_sym_LT] = ACTIONS(8699),
    [anon_sym_end] = ACTIONS(4211),
    [anon_sym_if] = ACTIONS(4211),
    [anon_sym_unless] = ACTIONS(4211),
    [anon_sym_while] = ACTIONS(4211),
    [anon_sym_until] = ACTIONS(4211),
    [anon_sym_rescue] = ACTIONS(4211),
    [anon_sym_else] = ACTIONS(4211),
    [anon_sym_ensure] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(8701),
    [anon_sym_DOT_DOT] = ACTIONS(8703),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8705),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(8707),
    [anon_sym_AMP_AMP] = ACTIONS(8707),
    [anon_sym_LT_LT] = ACTIONS(8709),
    [anon_sym_GT_GT] = ACTIONS(8709),
    [anon_sym_EQ_EQ] = ACTIONS(8711),
    [anon_sym_BANG_EQ] = ACTIONS(8707),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8707),
    [anon_sym_LT_EQ_GT] = ACTIONS(8707),
    [anon_sym_EQ_TILDE] = ACTIONS(8707),
    [anon_sym_BANG_TILDE] = ACTIONS(8707),
    [anon_sym_LT_EQ] = ACTIONS(8699),
    [anon_sym_GT] = ACTIONS(8699),
    [anon_sym_GT_EQ] = ACTIONS(8713),
    [anon_sym_CARET] = ACTIONS(8715),
    [anon_sym_PLUS] = ACTIONS(8691),
    [anon_sym_SLASH] = ACTIONS(8693),
    [anon_sym_PERCENT] = ACTIONS(8693),
    [sym_comment] = ACTIONS(87),
  },
  [2998] = {
    [anon_sym_EQ] = ACTIONS(8717),
    [sym_comment] = ACTIONS(87),
  },
  [2999] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(8719),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(8721),
    [anon_sym_DASH_EQ] = ACTIONS(8721),
    [anon_sym_STAR_EQ] = ACTIONS(8721),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8721),
    [anon_sym_SLASH_EQ] = ACTIONS(8721),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8721),
    [anon_sym_PIPE_EQ] = ACTIONS(8721),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8721),
    [anon_sym_AMP_EQ] = ACTIONS(8721),
    [anon_sym_PERCENT_EQ] = ACTIONS(8721),
    [anon_sym_GT_GT_EQ] = ACTIONS(8721),
    [anon_sym_LT_LT_EQ] = ACTIONS(8721),
    [anon_sym_CARET_EQ] = ACTIONS(8721),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3000] = {
    [sym_string] = STATE(5540),
    [aux_sym_chained_string_repeat1] = STATE(5540),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [3001] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(8691),
    [sym__binary_star] = ACTIONS(8693),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(8695),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(8693),
    [anon_sym_AMP] = ACTIONS(8697),
    [anon_sym_LT] = ACTIONS(8699),
    [anon_sym_end] = ACTIONS(4247),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_else] = ACTIONS(4247),
    [anon_sym_ensure] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(8701),
    [anon_sym_DOT_DOT] = ACTIONS(8703),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8705),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(8707),
    [anon_sym_AMP_AMP] = ACTIONS(8707),
    [anon_sym_LT_LT] = ACTIONS(8709),
    [anon_sym_GT_GT] = ACTIONS(8709),
    [anon_sym_EQ_EQ] = ACTIONS(8711),
    [anon_sym_BANG_EQ] = ACTIONS(8707),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8707),
    [anon_sym_LT_EQ_GT] = ACTIONS(8707),
    [anon_sym_EQ_TILDE] = ACTIONS(8707),
    [anon_sym_BANG_TILDE] = ACTIONS(8707),
    [anon_sym_LT_EQ] = ACTIONS(8699),
    [anon_sym_GT] = ACTIONS(8699),
    [anon_sym_GT_EQ] = ACTIONS(8713),
    [anon_sym_CARET] = ACTIONS(8715),
    [anon_sym_PLUS] = ACTIONS(8691),
    [anon_sym_SLASH] = ACTIONS(8693),
    [anon_sym_PERCENT] = ACTIONS(8693),
    [sym_comment] = ACTIONS(87),
  },
  [3002] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(5035),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_ensure] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [3003] = {
    [sym_string] = STATE(3041),
    [aux_sym_chained_string_repeat1] = STATE(3041),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [3004] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5541),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2999),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(2999),
    [sym_assignment] = STATE(5541),
    [sym_operator_assignment] = STATE(5541),
    [sym_conditional] = STATE(5541),
    [sym_range] = STATE(5541),
    [sym_binary] = STATE(5541),
    [sym_unary] = STATE(5541),
    [sym_left_assignment_list] = STATE(2998),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2999),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2999),
    [sym_false] = STATE(2999),
    [sym_nil] = STATE(2999),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(3000),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(5001),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5003),
    [anon_sym_yield] = ACTIONS(5005),
    [anon_sym_break] = ACTIONS(5007),
    [anon_sym_next] = ACTIONS(5009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5011),
    [anon_sym_defined_QMARK] = ACTIONS(5013),
    [anon_sym_not] = ACTIONS(5015),
    [anon_sym_BANG] = ACTIONS(5017),
    [anon_sym_TILDE] = ACTIONS(5017),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3005] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(8691),
    [sym__binary_star] = ACTIONS(8693),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(8695),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(8693),
    [anon_sym_AMP] = ACTIONS(8697),
    [anon_sym_LT] = ACTIONS(8699),
    [anon_sym_end] = ACTIONS(3281),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_unless] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_until] = ACTIONS(3281),
    [anon_sym_rescue] = ACTIONS(3281),
    [anon_sym_else] = ACTIONS(3281),
    [anon_sym_ensure] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(8701),
    [anon_sym_DOT_DOT] = ACTIONS(8703),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8705),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(8707),
    [anon_sym_AMP_AMP] = ACTIONS(8707),
    [anon_sym_LT_LT] = ACTIONS(8709),
    [anon_sym_GT_GT] = ACTIONS(8709),
    [anon_sym_EQ_EQ] = ACTIONS(8711),
    [anon_sym_BANG_EQ] = ACTIONS(8707),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8707),
    [anon_sym_LT_EQ_GT] = ACTIONS(8707),
    [anon_sym_EQ_TILDE] = ACTIONS(8707),
    [anon_sym_BANG_TILDE] = ACTIONS(8707),
    [anon_sym_LT_EQ] = ACTIONS(8699),
    [anon_sym_GT] = ACTIONS(8699),
    [anon_sym_GT_EQ] = ACTIONS(8713),
    [anon_sym_CARET] = ACTIONS(8715),
    [anon_sym_PLUS] = ACTIONS(8691),
    [anon_sym_SLASH] = ACTIONS(8693),
    [anon_sym_PERCENT] = ACTIONS(8693),
    [sym_comment] = ACTIONS(87),
  },
  [3006] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5542),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1156),
    [sym_scope_resolution] = STATE(1152),
    [sym_call] = STATE(1152),
    [sym_method_call] = STATE(1156),
    [sym_assignment] = STATE(5542),
    [sym_operator_assignment] = STATE(5542),
    [sym_conditional] = STATE(5542),
    [sym_range] = STATE(5542),
    [sym_binary] = STATE(5542),
    [sym_unary] = STATE(5542),
    [sym_left_assignment_list] = STATE(1155),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1156),
    [sym__variable] = STATE(1152),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1156),
    [sym_false] = STATE(1156),
    [sym_nil] = STATE(1156),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3003),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2051),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2055),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2059),
    [anon_sym_next] = ACTIONS(2061),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5019),
    [anon_sym_defined_QMARK] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [anon_sym_BANG] = ACTIONS(2069),
    [anon_sym_TILDE] = ACTIONS(2069),
    [sym_constant] = ACTIONS(2075),
    [sym_identifier] = ACTIONS(2075),
    [sym_instance_variable] = ACTIONS(2073),
    [sym_class_variable] = ACTIONS(2073),
    [sym_global_variable] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2075),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3007] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5543),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1156),
    [sym_scope_resolution] = STATE(1152),
    [sym_call] = STATE(1152),
    [sym_method_call] = STATE(1156),
    [sym_assignment] = STATE(5543),
    [sym_operator_assignment] = STATE(5543),
    [sym_conditional] = STATE(5543),
    [sym_range] = STATE(5543),
    [sym_binary] = STATE(5543),
    [sym_unary] = STATE(5543),
    [sym_left_assignment_list] = STATE(1155),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1156),
    [sym__variable] = STATE(1152),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1156),
    [sym_false] = STATE(1156),
    [sym_nil] = STATE(1156),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3003),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2051),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2055),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2059),
    [anon_sym_next] = ACTIONS(2061),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5019),
    [anon_sym_defined_QMARK] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [anon_sym_BANG] = ACTIONS(2069),
    [anon_sym_TILDE] = ACTIONS(2069),
    [sym_constant] = ACTIONS(2075),
    [sym_identifier] = ACTIONS(2075),
    [sym_instance_variable] = ACTIONS(2073),
    [sym_class_variable] = ACTIONS(2073),
    [sym_global_variable] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2075),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3008] = {
    [anon_sym_COLON] = ACTIONS(8723),
    [sym_comment] = ACTIONS(87),
  },
  [3009] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5545),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1156),
    [sym_scope_resolution] = STATE(1152),
    [sym_call] = STATE(1152),
    [sym_method_call] = STATE(1156),
    [sym_assignment] = STATE(5545),
    [sym_operator_assignment] = STATE(5545),
    [sym_conditional] = STATE(5545),
    [sym_range] = STATE(5545),
    [sym_binary] = STATE(5545),
    [sym_unary] = STATE(5545),
    [sym_left_assignment_list] = STATE(1155),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1156),
    [sym__variable] = STATE(1152),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1156),
    [sym_false] = STATE(1156),
    [sym_nil] = STATE(1156),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3003),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2051),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2055),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2059),
    [anon_sym_next] = ACTIONS(2061),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5019),
    [anon_sym_defined_QMARK] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [anon_sym_BANG] = ACTIONS(2069),
    [anon_sym_TILDE] = ACTIONS(2069),
    [sym_constant] = ACTIONS(2075),
    [sym_identifier] = ACTIONS(2075),
    [sym_instance_variable] = ACTIONS(2073),
    [sym_class_variable] = ACTIONS(2073),
    [sym_global_variable] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2075),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3010] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(8725),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_else] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_ensure] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [3011] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(5033),
    [sym__binary_star] = ACTIONS(5035),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(5037),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(5035),
    [anon_sym_AMP] = ACTIONS(5039),
    [anon_sym_LT] = ACTIONS(5041),
    [anon_sym_end] = ACTIONS(1625),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_unless] = ACTIONS(1625),
    [anon_sym_while] = ACTIONS(1625),
    [anon_sym_until] = ACTIONS(1625),
    [anon_sym_rescue] = ACTIONS(1625),
    [anon_sym_else] = ACTIONS(1625),
    [anon_sym_ensure] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(1625),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(5043),
    [anon_sym_DOT_DOT] = ACTIONS(5045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5047),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(5049),
    [anon_sym_AMP_AMP] = ACTIONS(5049),
    [anon_sym_LT_LT] = ACTIONS(5051),
    [anon_sym_GT_GT] = ACTIONS(5051),
    [anon_sym_EQ_EQ] = ACTIONS(5053),
    [anon_sym_BANG_EQ] = ACTIONS(5049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5049),
    [anon_sym_LT_EQ_GT] = ACTIONS(5049),
    [anon_sym_EQ_TILDE] = ACTIONS(5049),
    [anon_sym_BANG_TILDE] = ACTIONS(5049),
    [anon_sym_LT_EQ] = ACTIONS(5041),
    [anon_sym_GT] = ACTIONS(5041),
    [anon_sym_GT_EQ] = ACTIONS(5055),
    [anon_sym_CARET] = ACTIONS(5057),
    [anon_sym_PLUS] = ACTIONS(5033),
    [anon_sym_SLASH] = ACTIONS(5035),
    [anon_sym_PERCENT] = ACTIONS(5035),
    [sym_comment] = ACTIONS(87),
  },
  [3012] = {
    [sym_heredoc_body] = STATE(5547),
    [aux_sym_call_repeat1] = STATE(5547),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_else] = ACTIONS(1681),
    [anon_sym_ensure] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [3013] = {
    [sym_heredoc_body] = STATE(5547),
    [aux_sym_call_repeat1] = STATE(5547),
    [aux_sym_argument_list_repeat1] = STATE(5549),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(8727),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_else] = ACTIONS(1681),
    [anon_sym_ensure] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [3014] = {
    [sym_string] = STATE(3041),
    [aux_sym_chained_string_repeat1] = STATE(3041),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(8729),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [3015] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(5033),
    [sym__binary_star] = ACTIONS(5035),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(5037),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(5035),
    [anon_sym_AMP] = ACTIONS(5039),
    [anon_sym_LT] = ACTIONS(5041),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_ensure] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(5043),
    [anon_sym_DOT_DOT] = ACTIONS(5045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5047),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(5049),
    [anon_sym_AMP_AMP] = ACTIONS(5049),
    [anon_sym_LT_LT] = ACTIONS(5051),
    [anon_sym_GT_GT] = ACTIONS(5051),
    [anon_sym_EQ_EQ] = ACTIONS(5053),
    [anon_sym_BANG_EQ] = ACTIONS(5049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5049),
    [anon_sym_LT_EQ_GT] = ACTIONS(5049),
    [anon_sym_EQ_TILDE] = ACTIONS(5049),
    [anon_sym_BANG_TILDE] = ACTIONS(5049),
    [anon_sym_LT_EQ] = ACTIONS(5041),
    [anon_sym_GT] = ACTIONS(5041),
    [anon_sym_GT_EQ] = ACTIONS(5055),
    [anon_sym_CARET] = ACTIONS(5057),
    [anon_sym_PLUS] = ACTIONS(5033),
    [anon_sym_SLASH] = ACTIONS(5035),
    [anon_sym_PERCENT] = ACTIONS(5035),
    [sym_comment] = ACTIONS(87),
  },
  [3016] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5550),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2999),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(2999),
    [sym_assignment] = STATE(5550),
    [sym_operator_assignment] = STATE(5550),
    [sym_conditional] = STATE(5550),
    [sym_range] = STATE(5550),
    [sym_binary] = STATE(5550),
    [sym_unary] = STATE(5550),
    [sym_left_assignment_list] = STATE(2998),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2999),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2999),
    [sym_false] = STATE(2999),
    [sym_nil] = STATE(2999),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(3000),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(5001),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5003),
    [anon_sym_yield] = ACTIONS(5005),
    [anon_sym_break] = ACTIONS(5007),
    [anon_sym_next] = ACTIONS(5009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5011),
    [anon_sym_defined_QMARK] = ACTIONS(5013),
    [anon_sym_not] = ACTIONS(5015),
    [anon_sym_BANG] = ACTIONS(5017),
    [anon_sym_TILDE] = ACTIONS(5017),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3017] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5551),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1156),
    [sym_scope_resolution] = STATE(1152),
    [sym_call] = STATE(1152),
    [sym_method_call] = STATE(1156),
    [sym_assignment] = STATE(5551),
    [sym_operator_assignment] = STATE(5551),
    [sym_conditional] = STATE(5551),
    [sym_range] = STATE(5551),
    [sym_binary] = STATE(5551),
    [sym_unary] = STATE(5551),
    [sym_left_assignment_list] = STATE(1155),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1156),
    [sym__variable] = STATE(1152),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1156),
    [sym_false] = STATE(1156),
    [sym_nil] = STATE(1156),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3003),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2051),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2055),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2059),
    [anon_sym_next] = ACTIONS(2061),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5019),
    [anon_sym_defined_QMARK] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [anon_sym_BANG] = ACTIONS(2069),
    [anon_sym_TILDE] = ACTIONS(2069),
    [sym_constant] = ACTIONS(2075),
    [sym_identifier] = ACTIONS(2075),
    [sym_instance_variable] = ACTIONS(2073),
    [sym_class_variable] = ACTIONS(2073),
    [sym_global_variable] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2075),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3018] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5552),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1156),
    [sym_scope_resolution] = STATE(1152),
    [sym_call] = STATE(1152),
    [sym_method_call] = STATE(1156),
    [sym_assignment] = STATE(5552),
    [sym_operator_assignment] = STATE(5552),
    [sym_conditional] = STATE(5552),
    [sym_range] = STATE(5552),
    [sym_binary] = STATE(5552),
    [sym_unary] = STATE(5552),
    [sym_left_assignment_list] = STATE(1155),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1156),
    [sym__variable] = STATE(1152),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1156),
    [sym_false] = STATE(1156),
    [sym_nil] = STATE(1156),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3003),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2051),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2055),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2059),
    [anon_sym_next] = ACTIONS(2061),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5019),
    [anon_sym_defined_QMARK] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [anon_sym_BANG] = ACTIONS(2069),
    [anon_sym_TILDE] = ACTIONS(2069),
    [sym_constant] = ACTIONS(2075),
    [sym_identifier] = ACTIONS(2075),
    [sym_instance_variable] = ACTIONS(2073),
    [sym_class_variable] = ACTIONS(2073),
    [sym_global_variable] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2075),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3019] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5553),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1156),
    [sym_scope_resolution] = STATE(1152),
    [sym_call] = STATE(1152),
    [sym_method_call] = STATE(1156),
    [sym_assignment] = STATE(5553),
    [sym_operator_assignment] = STATE(5553),
    [sym_conditional] = STATE(5553),
    [sym_range] = STATE(5553),
    [sym_binary] = STATE(5553),
    [sym_unary] = STATE(5553),
    [sym_left_assignment_list] = STATE(1155),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1156),
    [sym__variable] = STATE(1152),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1156),
    [sym_false] = STATE(1156),
    [sym_nil] = STATE(1156),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3003),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2051),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2055),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2059),
    [anon_sym_next] = ACTIONS(2061),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5019),
    [anon_sym_defined_QMARK] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [anon_sym_BANG] = ACTIONS(2069),
    [anon_sym_TILDE] = ACTIONS(2069),
    [sym_constant] = ACTIONS(2075),
    [sym_identifier] = ACTIONS(2075),
    [sym_instance_variable] = ACTIONS(2073),
    [sym_class_variable] = ACTIONS(2073),
    [sym_global_variable] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2075),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3020] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5554),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1156),
    [sym_scope_resolution] = STATE(1152),
    [sym_call] = STATE(1152),
    [sym_method_call] = STATE(1156),
    [sym_assignment] = STATE(5554),
    [sym_operator_assignment] = STATE(5554),
    [sym_conditional] = STATE(5554),
    [sym_range] = STATE(5554),
    [sym_binary] = STATE(5554),
    [sym_unary] = STATE(5554),
    [sym_left_assignment_list] = STATE(1155),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1156),
    [sym__variable] = STATE(1152),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1156),
    [sym_false] = STATE(1156),
    [sym_nil] = STATE(1156),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3003),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2051),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2055),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2059),
    [anon_sym_next] = ACTIONS(2061),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5019),
    [anon_sym_defined_QMARK] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [anon_sym_BANG] = ACTIONS(2069),
    [anon_sym_TILDE] = ACTIONS(2069),
    [sym_constant] = ACTIONS(2075),
    [sym_identifier] = ACTIONS(2075),
    [sym_instance_variable] = ACTIONS(2073),
    [sym_class_variable] = ACTIONS(2073),
    [sym_global_variable] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2075),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3021] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5555),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1156),
    [sym_scope_resolution] = STATE(1152),
    [sym_call] = STATE(1152),
    [sym_method_call] = STATE(1156),
    [sym_assignment] = STATE(5555),
    [sym_operator_assignment] = STATE(5555),
    [sym_conditional] = STATE(5555),
    [sym_range] = STATE(5555),
    [sym_binary] = STATE(5555),
    [sym_unary] = STATE(5555),
    [sym_left_assignment_list] = STATE(1155),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1156),
    [sym__variable] = STATE(1152),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1156),
    [sym_false] = STATE(1156),
    [sym_nil] = STATE(1156),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3003),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2051),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2055),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2059),
    [anon_sym_next] = ACTIONS(2061),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5019),
    [anon_sym_defined_QMARK] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [anon_sym_BANG] = ACTIONS(2069),
    [anon_sym_TILDE] = ACTIONS(2069),
    [sym_constant] = ACTIONS(2075),
    [sym_identifier] = ACTIONS(2075),
    [sym_instance_variable] = ACTIONS(2073),
    [sym_class_variable] = ACTIONS(2073),
    [sym_global_variable] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2075),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3022] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(5556),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(5556),
    [sym_operator_assignment] = STATE(5556),
    [sym_conditional] = STATE(5556),
    [sym_range] = STATE(5556),
    [sym_binary] = STATE(5556),
    [sym_unary] = STATE(5556),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3023] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5557),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1156),
    [sym_scope_resolution] = STATE(1152),
    [sym_call] = STATE(1152),
    [sym_method_call] = STATE(1156),
    [sym_assignment] = STATE(5557),
    [sym_operator_assignment] = STATE(5557),
    [sym_conditional] = STATE(5557),
    [sym_range] = STATE(5557),
    [sym_binary] = STATE(5557),
    [sym_unary] = STATE(5557),
    [sym_left_assignment_list] = STATE(1155),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1156),
    [sym__variable] = STATE(1152),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1156),
    [sym_false] = STATE(1156),
    [sym_nil] = STATE(1156),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3003),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2051),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2055),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2059),
    [anon_sym_next] = ACTIONS(2061),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5019),
    [anon_sym_defined_QMARK] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [anon_sym_BANG] = ACTIONS(2069),
    [anon_sym_TILDE] = ACTIONS(2069),
    [sym_constant] = ACTIONS(2075),
    [sym_identifier] = ACTIONS(2075),
    [sym_instance_variable] = ACTIONS(2073),
    [sym_class_variable] = ACTIONS(2073),
    [sym_global_variable] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2075),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3024] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5558),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1156),
    [sym_scope_resolution] = STATE(1152),
    [sym_call] = STATE(1152),
    [sym_method_call] = STATE(1156),
    [sym_assignment] = STATE(5558),
    [sym_operator_assignment] = STATE(5558),
    [sym_conditional] = STATE(5558),
    [sym_range] = STATE(5558),
    [sym_binary] = STATE(5558),
    [sym_unary] = STATE(5558),
    [sym_left_assignment_list] = STATE(1155),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1156),
    [sym__variable] = STATE(1152),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1156),
    [sym_false] = STATE(1156),
    [sym_nil] = STATE(1156),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3003),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2051),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2055),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2059),
    [anon_sym_next] = ACTIONS(2061),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5019),
    [anon_sym_defined_QMARK] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [anon_sym_BANG] = ACTIONS(2069),
    [anon_sym_TILDE] = ACTIONS(2069),
    [sym_constant] = ACTIONS(2075),
    [sym_identifier] = ACTIONS(2075),
    [sym_instance_variable] = ACTIONS(2073),
    [sym_class_variable] = ACTIONS(2073),
    [sym_global_variable] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2075),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3025] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5559),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1156),
    [sym_scope_resolution] = STATE(1152),
    [sym_call] = STATE(1152),
    [sym_method_call] = STATE(1156),
    [sym_assignment] = STATE(5559),
    [sym_operator_assignment] = STATE(5559),
    [sym_conditional] = STATE(5559),
    [sym_range] = STATE(5559),
    [sym_binary] = STATE(5559),
    [sym_unary] = STATE(5559),
    [sym_left_assignment_list] = STATE(1155),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1156),
    [sym__variable] = STATE(1152),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1156),
    [sym_false] = STATE(1156),
    [sym_nil] = STATE(1156),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3003),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2051),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2055),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2059),
    [anon_sym_next] = ACTIONS(2061),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5019),
    [anon_sym_defined_QMARK] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [anon_sym_BANG] = ACTIONS(2069),
    [anon_sym_TILDE] = ACTIONS(2069),
    [sym_constant] = ACTIONS(2075),
    [sym_identifier] = ACTIONS(2075),
    [sym_instance_variable] = ACTIONS(2073),
    [sym_class_variable] = ACTIONS(2073),
    [sym_global_variable] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2075),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3026] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5560),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1156),
    [sym_scope_resolution] = STATE(1152),
    [sym_call] = STATE(1152),
    [sym_method_call] = STATE(1156),
    [sym_assignment] = STATE(5560),
    [sym_operator_assignment] = STATE(5560),
    [sym_conditional] = STATE(5560),
    [sym_range] = STATE(5560),
    [sym_binary] = STATE(5560),
    [sym_unary] = STATE(5560),
    [sym_left_assignment_list] = STATE(1155),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1156),
    [sym__variable] = STATE(1152),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1156),
    [sym_false] = STATE(1156),
    [sym_nil] = STATE(1156),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3003),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2051),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2055),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2059),
    [anon_sym_next] = ACTIONS(2061),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5019),
    [anon_sym_defined_QMARK] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [anon_sym_BANG] = ACTIONS(2069),
    [anon_sym_TILDE] = ACTIONS(2069),
    [sym_constant] = ACTIONS(2075),
    [sym_identifier] = ACTIONS(2075),
    [sym_instance_variable] = ACTIONS(2073),
    [sym_class_variable] = ACTIONS(2073),
    [sym_global_variable] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2075),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3027] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5561),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1249),
    [sym_scope_resolution] = STATE(1245),
    [sym_call] = STATE(1245),
    [sym_method_call] = STATE(1249),
    [sym_assignment] = STATE(5561),
    [sym_operator_assignment] = STATE(5561),
    [sym_conditional] = STATE(5561),
    [sym_range] = STATE(5561),
    [sym_binary] = STATE(5561),
    [sym_unary] = STATE(5561),
    [sym_left_assignment_list] = STATE(1248),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(1245),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1249),
    [sym_false] = STATE(1249),
    [sym_nil] = STATE(1249),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3260),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2223),
    [anon_sym_break] = ACTIONS(2225),
    [anon_sym_next] = ACTIONS(2227),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(5435),
    [anon_sym_defined_QMARK] = ACTIONS(2229),
    [anon_sym_not] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(2235),
    [anon_sym_TILDE] = ACTIONS(2235),
    [sym_constant] = ACTIONS(2241),
    [sym_identifier] = ACTIONS(2241),
    [sym_instance_variable] = ACTIONS(2239),
    [sym_class_variable] = ACTIONS(2239),
    [sym_global_variable] = ACTIONS(2239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(2241),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2241),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3028] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5562),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1249),
    [sym_scope_resolution] = STATE(1245),
    [sym_call] = STATE(1245),
    [sym_method_call] = STATE(1249),
    [sym_assignment] = STATE(5562),
    [sym_operator_assignment] = STATE(5562),
    [sym_conditional] = STATE(5562),
    [sym_range] = STATE(5562),
    [sym_binary] = STATE(5562),
    [sym_unary] = STATE(5562),
    [sym_left_assignment_list] = STATE(1248),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(1245),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1249),
    [sym_false] = STATE(1249),
    [sym_nil] = STATE(1249),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3260),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2223),
    [anon_sym_break] = ACTIONS(2225),
    [anon_sym_next] = ACTIONS(2227),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(5435),
    [anon_sym_defined_QMARK] = ACTIONS(2229),
    [anon_sym_not] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(2235),
    [anon_sym_TILDE] = ACTIONS(2235),
    [sym_constant] = ACTIONS(2241),
    [sym_identifier] = ACTIONS(2241),
    [sym_instance_variable] = ACTIONS(2239),
    [sym_class_variable] = ACTIONS(2239),
    [sym_global_variable] = ACTIONS(2239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(2241),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2241),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3029] = {
    [anon_sym_COLON] = ACTIONS(8731),
    [sym_comment] = ACTIONS(87),
  },
  [3030] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5564),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1249),
    [sym_scope_resolution] = STATE(1245),
    [sym_call] = STATE(1245),
    [sym_method_call] = STATE(1249),
    [sym_assignment] = STATE(5564),
    [sym_operator_assignment] = STATE(5564),
    [sym_conditional] = STATE(5564),
    [sym_range] = STATE(5564),
    [sym_binary] = STATE(5564),
    [sym_unary] = STATE(5564),
    [sym_left_assignment_list] = STATE(1248),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(1245),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1249),
    [sym_false] = STATE(1249),
    [sym_nil] = STATE(1249),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3260),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2223),
    [anon_sym_break] = ACTIONS(2225),
    [anon_sym_next] = ACTIONS(2227),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(5435),
    [anon_sym_defined_QMARK] = ACTIONS(2229),
    [anon_sym_not] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(2235),
    [anon_sym_TILDE] = ACTIONS(2235),
    [sym_constant] = ACTIONS(2241),
    [sym_identifier] = ACTIONS(2241),
    [sym_instance_variable] = ACTIONS(2239),
    [sym_class_variable] = ACTIONS(2239),
    [sym_global_variable] = ACTIONS(2239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(2241),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2241),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3031] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(8733),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_else] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_ensure] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [3032] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(5441),
    [sym__binary_star] = ACTIONS(5443),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(5445),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(5447),
    [anon_sym_AMP] = ACTIONS(5449),
    [anon_sym_EQ] = ACTIONS(1631),
    [anon_sym_LT] = ACTIONS(5451),
    [anon_sym_end] = ACTIONS(1625),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_unless] = ACTIONS(1625),
    [anon_sym_while] = ACTIONS(1625),
    [anon_sym_until] = ACTIONS(1625),
    [anon_sym_rescue] = ACTIONS(1625),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_else] = ACTIONS(1625),
    [anon_sym_ensure] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(1625),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_PLUS_EQ] = ACTIONS(1625),
    [anon_sym_DASH_EQ] = ACTIONS(1625),
    [anon_sym_STAR_EQ] = ACTIONS(1625),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1625),
    [anon_sym_SLASH_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1625),
    [anon_sym_AMP_EQ] = ACTIONS(1625),
    [anon_sym_PERCENT_EQ] = ACTIONS(1625),
    [anon_sym_GT_GT_EQ] = ACTIONS(1625),
    [anon_sym_LT_LT_EQ] = ACTIONS(1625),
    [anon_sym_CARET_EQ] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(5453),
    [anon_sym_DOT_DOT] = ACTIONS(5455),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5457),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(5459),
    [anon_sym_AMP_AMP] = ACTIONS(5459),
    [anon_sym_LT_LT] = ACTIONS(5461),
    [anon_sym_GT_GT] = ACTIONS(5461),
    [anon_sym_EQ_EQ] = ACTIONS(5459),
    [anon_sym_BANG_EQ] = ACTIONS(5463),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5463),
    [anon_sym_LT_EQ_GT] = ACTIONS(5463),
    [anon_sym_EQ_TILDE] = ACTIONS(5463),
    [anon_sym_BANG_TILDE] = ACTIONS(5463),
    [anon_sym_LT_EQ] = ACTIONS(5451),
    [anon_sym_GT] = ACTIONS(5451),
    [anon_sym_GT_EQ] = ACTIONS(5465),
    [anon_sym_CARET] = ACTIONS(5445),
    [anon_sym_PLUS] = ACTIONS(5467),
    [anon_sym_SLASH] = ACTIONS(5447),
    [anon_sym_PERCENT] = ACTIONS(5447),
    [sym_comment] = ACTIONS(87),
  },
  [3033] = {
    [sym_heredoc_body] = STATE(5566),
    [aux_sym_call_repeat1] = STATE(5566),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_else] = ACTIONS(1681),
    [anon_sym_ensure] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [3034] = {
    [sym_heredoc_body] = STATE(5566),
    [aux_sym_call_repeat1] = STATE(5566),
    [aux_sym_argument_list_repeat1] = STATE(5568),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(8735),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_else] = ACTIONS(1681),
    [anon_sym_ensure] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [3035] = {
    [sym_string] = STATE(3280),
    [aux_sym_chained_string_repeat1] = STATE(3280),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(747),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(8737),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3036] = {
    [sym_heredoc_body] = STATE(5569),
    [aux_sym_call_repeat1] = STATE(5569),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_else] = ACTIONS(4383),
    [anon_sym_ensure] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [3037] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1151),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1156),
    [sym_scope_resolution] = STATE(1152),
    [sym_call] = STATE(1152),
    [sym_method_call] = STATE(1156),
    [sym__argument] = STATE(2565),
    [sym_splat_argument] = STATE(2565),
    [sym_hash_splat_argument] = STATE(2565),
    [sym_block_argument] = STATE(2565),
    [sym_assignment] = STATE(1151),
    [sym_operator_assignment] = STATE(1151),
    [sym_conditional] = STATE(1151),
    [sym_range] = STATE(1151),
    [sym_binary] = STATE(1151),
    [sym_unary] = STATE(1151),
    [sym_left_assignment_list] = STATE(1155),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1156),
    [sym__variable] = STATE(1152),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1156),
    [sym_false] = STATE(1156),
    [sym_nil] = STATE(1156),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1157),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(5570),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2565),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(2047),
    [sym__splat_star] = ACTIONS(2049),
    [sym__unary_minus] = ACTIONS(2051),
    [sym__identifier_hash_key] = ACTIONS(2053),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(8739),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2055),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2059),
    [anon_sym_next] = ACTIONS(2061),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5019),
    [anon_sym_defined_QMARK] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [anon_sym_BANG] = ACTIONS(2069),
    [anon_sym_TILDE] = ACTIONS(2069),
    [sym_constant] = ACTIONS(2071),
    [sym_identifier] = ACTIONS(2071),
    [sym_instance_variable] = ACTIONS(2073),
    [sym_class_variable] = ACTIONS(2073),
    [sym_global_variable] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2075),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3038] = {
    [sym_heredoc_body] = STATE(5571),
    [aux_sym_call_repeat1] = STATE(5571),
    [aux_sym_argument_list_repeat1] = STATE(5572),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(5067),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_else] = ACTIONS(4383),
    [anon_sym_ensure] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [3039] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5573),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1156),
    [sym_scope_resolution] = STATE(1152),
    [sym_call] = STATE(1152),
    [sym_method_call] = STATE(1156),
    [sym_splat_argument] = STATE(5574),
    [sym_assignment] = STATE(5573),
    [sym_operator_assignment] = STATE(5573),
    [sym_conditional] = STATE(5573),
    [sym_range] = STATE(5573),
    [sym_binary] = STATE(5573),
    [sym_unary] = STATE(5573),
    [sym_right_assignment_list] = STATE(2570),
    [sym__arg_or_splat_arg] = STATE(5574),
    [sym_left_assignment_list] = STATE(1155),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1156),
    [sym__variable] = STATE(1152),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1156),
    [sym_false] = STATE(1156),
    [sym_nil] = STATE(1156),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3003),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__splat_star] = ACTIONS(5025),
    [sym__unary_minus] = ACTIONS(2051),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2055),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2059),
    [anon_sym_next] = ACTIONS(2061),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5019),
    [anon_sym_defined_QMARK] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [anon_sym_BANG] = ACTIONS(2069),
    [anon_sym_TILDE] = ACTIONS(2069),
    [sym_constant] = ACTIONS(2075),
    [sym_identifier] = ACTIONS(2075),
    [sym_instance_variable] = ACTIONS(2073),
    [sym_class_variable] = ACTIONS(2073),
    [sym_global_variable] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2075),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3040] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5575),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1156),
    [sym_scope_resolution] = STATE(1152),
    [sym_call] = STATE(1152),
    [sym_method_call] = STATE(1156),
    [sym_assignment] = STATE(5575),
    [sym_operator_assignment] = STATE(5575),
    [sym_conditional] = STATE(5575),
    [sym_range] = STATE(5575),
    [sym_binary] = STATE(5575),
    [sym_unary] = STATE(5575),
    [sym_left_assignment_list] = STATE(1155),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1156),
    [sym__variable] = STATE(1152),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1156),
    [sym_false] = STATE(1156),
    [sym_nil] = STATE(1156),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3003),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2051),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2055),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2059),
    [anon_sym_next] = ACTIONS(2061),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5019),
    [anon_sym_defined_QMARK] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [anon_sym_BANG] = ACTIONS(2069),
    [anon_sym_TILDE] = ACTIONS(2069),
    [sym_constant] = ACTIONS(2075),
    [sym_identifier] = ACTIONS(2075),
    [sym_instance_variable] = ACTIONS(2073),
    [sym_class_variable] = ACTIONS(2073),
    [sym_global_variable] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2075),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3041] = {
    [sym_string] = STATE(5576),
    [aux_sym_chained_string_repeat1] = STATE(5576),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_end] = ACTIONS(2753),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_else] = ACTIONS(2753),
    [anon_sym_ensure] = ACTIONS(2753),
    [anon_sym_EQ_GT] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [3042] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(5117),
    [sym__binary_star] = ACTIONS(5119),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(5121),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(5119),
    [anon_sym_AMP] = ACTIONS(5123),
    [anon_sym_LT] = ACTIONS(5125),
    [anon_sym_then] = ACTIONS(4247),
    [anon_sym_EQ_GT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(5127),
    [anon_sym_DOT_DOT] = ACTIONS(5129),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5131),
    [anon_sym_and] = ACTIONS(5133),
    [anon_sym_or] = ACTIONS(5133),
    [anon_sym_PIPE_PIPE] = ACTIONS(5135),
    [anon_sym_AMP_AMP] = ACTIONS(5135),
    [anon_sym_LT_LT] = ACTIONS(5137),
    [anon_sym_GT_GT] = ACTIONS(5137),
    [anon_sym_EQ_EQ] = ACTIONS(5139),
    [anon_sym_BANG_EQ] = ACTIONS(5135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5135),
    [anon_sym_LT_EQ_GT] = ACTIONS(5135),
    [anon_sym_EQ_TILDE] = ACTIONS(5135),
    [anon_sym_BANG_TILDE] = ACTIONS(5135),
    [anon_sym_LT_EQ] = ACTIONS(5125),
    [anon_sym_GT] = ACTIONS(5125),
    [anon_sym_GT_EQ] = ACTIONS(5141),
    [anon_sym_CARET] = ACTIONS(5143),
    [anon_sym_PLUS] = ACTIONS(5117),
    [anon_sym_SLASH] = ACTIONS(5119),
    [anon_sym_PERCENT] = ACTIONS(5119),
    [sym_comment] = ACTIONS(87),
  },
  [3043] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(5119),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [3044] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5577),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3056),
    [sym_scope_resolution] = STATE(1172),
    [sym_call] = STATE(1172),
    [sym_method_call] = STATE(3056),
    [sym_assignment] = STATE(5577),
    [sym_operator_assignment] = STATE(5577),
    [sym_conditional] = STATE(5577),
    [sym_range] = STATE(5577),
    [sym_binary] = STATE(5577),
    [sym_unary] = STATE(5577),
    [sym_left_assignment_list] = STATE(3055),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3056),
    [sym__variable] = STATE(1172),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3056),
    [sym_false] = STATE(3056),
    [sym_nil] = STATE(3056),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1176),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5081),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2085),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_next] = ACTIONS(2089),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8741),
    [anon_sym_defined_QMARK] = ACTIONS(5085),
    [anon_sym_not] = ACTIONS(5087),
    [anon_sym_BANG] = ACTIONS(5091),
    [anon_sym_TILDE] = ACTIONS(5091),
    [sym_constant] = ACTIONS(2103),
    [sym_identifier] = ACTIONS(2103),
    [sym_instance_variable] = ACTIONS(2105),
    [sym_class_variable] = ACTIONS(2105),
    [sym_global_variable] = ACTIONS(2105),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2103),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2103),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3045] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5578),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3056),
    [sym_scope_resolution] = STATE(1172),
    [sym_call] = STATE(1172),
    [sym_method_call] = STATE(3056),
    [sym_assignment] = STATE(5578),
    [sym_operator_assignment] = STATE(5578),
    [sym_conditional] = STATE(5578),
    [sym_range] = STATE(5578),
    [sym_binary] = STATE(5578),
    [sym_unary] = STATE(5578),
    [sym_left_assignment_list] = STATE(3055),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3056),
    [sym__variable] = STATE(1172),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3056),
    [sym_false] = STATE(3056),
    [sym_nil] = STATE(3056),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1176),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5081),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2085),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_next] = ACTIONS(2089),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8741),
    [anon_sym_defined_QMARK] = ACTIONS(5085),
    [anon_sym_not] = ACTIONS(5087),
    [anon_sym_BANG] = ACTIONS(5091),
    [anon_sym_TILDE] = ACTIONS(5091),
    [sym_constant] = ACTIONS(2103),
    [sym_identifier] = ACTIONS(2103),
    [sym_instance_variable] = ACTIONS(2105),
    [sym_class_variable] = ACTIONS(2105),
    [sym_global_variable] = ACTIONS(2105),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2103),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2103),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3046] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5579),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3056),
    [sym_scope_resolution] = STATE(1172),
    [sym_call] = STATE(1172),
    [sym_method_call] = STATE(3056),
    [sym_assignment] = STATE(5579),
    [sym_operator_assignment] = STATE(5579),
    [sym_conditional] = STATE(5579),
    [sym_range] = STATE(5579),
    [sym_binary] = STATE(5579),
    [sym_unary] = STATE(5579),
    [sym_left_assignment_list] = STATE(3055),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3056),
    [sym__variable] = STATE(1172),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3056),
    [sym_false] = STATE(3056),
    [sym_nil] = STATE(3056),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1176),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5081),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2085),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_next] = ACTIONS(2089),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8741),
    [anon_sym_defined_QMARK] = ACTIONS(5085),
    [anon_sym_not] = ACTIONS(5087),
    [anon_sym_BANG] = ACTIONS(5091),
    [anon_sym_TILDE] = ACTIONS(5091),
    [sym_constant] = ACTIONS(2103),
    [sym_identifier] = ACTIONS(2103),
    [sym_instance_variable] = ACTIONS(2105),
    [sym_class_variable] = ACTIONS(2105),
    [sym_global_variable] = ACTIONS(2105),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2103),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2103),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3047] = {
    [anon_sym_COLON] = ACTIONS(8743),
    [sym_comment] = ACTIONS(87),
  },
  [3048] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5581),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3056),
    [sym_scope_resolution] = STATE(1172),
    [sym_call] = STATE(1172),
    [sym_method_call] = STATE(3056),
    [sym_assignment] = STATE(5581),
    [sym_operator_assignment] = STATE(5581),
    [sym_conditional] = STATE(5581),
    [sym_range] = STATE(5581),
    [sym_binary] = STATE(5581),
    [sym_unary] = STATE(5581),
    [sym_left_assignment_list] = STATE(3055),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3056),
    [sym__variable] = STATE(1172),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3056),
    [sym_false] = STATE(3056),
    [sym_nil] = STATE(3056),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1176),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5081),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2085),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_next] = ACTIONS(2089),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8741),
    [anon_sym_defined_QMARK] = ACTIONS(5085),
    [anon_sym_not] = ACTIONS(5087),
    [anon_sym_BANG] = ACTIONS(5091),
    [anon_sym_TILDE] = ACTIONS(5091),
    [sym_constant] = ACTIONS(2103),
    [sym_identifier] = ACTIONS(2103),
    [sym_instance_variable] = ACTIONS(2105),
    [sym_class_variable] = ACTIONS(2105),
    [sym_global_variable] = ACTIONS(2105),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2103),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2103),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3049] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5582),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3056),
    [sym_scope_resolution] = STATE(1172),
    [sym_call] = STATE(1172),
    [sym_method_call] = STATE(3056),
    [sym_assignment] = STATE(5582),
    [sym_operator_assignment] = STATE(5582),
    [sym_conditional] = STATE(5582),
    [sym_range] = STATE(5582),
    [sym_binary] = STATE(5582),
    [sym_unary] = STATE(5582),
    [sym_left_assignment_list] = STATE(3055),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3056),
    [sym__variable] = STATE(1172),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3056),
    [sym_false] = STATE(3056),
    [sym_nil] = STATE(3056),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1176),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5081),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2085),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_next] = ACTIONS(2089),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8741),
    [anon_sym_defined_QMARK] = ACTIONS(5085),
    [anon_sym_not] = ACTIONS(5087),
    [anon_sym_BANG] = ACTIONS(5091),
    [anon_sym_TILDE] = ACTIONS(5091),
    [sym_constant] = ACTIONS(2103),
    [sym_identifier] = ACTIONS(2103),
    [sym_instance_variable] = ACTIONS(2105),
    [sym_class_variable] = ACTIONS(2105),
    [sym_global_variable] = ACTIONS(2105),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2103),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2103),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3050] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3056),
    [sym_scope_resolution] = STATE(1172),
    [sym_call] = STATE(1172),
    [sym_method_call] = STATE(3056),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(3055),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3056),
    [sym__variable] = STATE(1172),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3056),
    [sym_false] = STATE(3056),
    [sym_nil] = STATE(3056),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1176),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5081),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2085),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_next] = ACTIONS(2089),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8741),
    [anon_sym_defined_QMARK] = ACTIONS(5085),
    [anon_sym_not] = ACTIONS(5087),
    [anon_sym_BANG] = ACTIONS(5091),
    [anon_sym_TILDE] = ACTIONS(5091),
    [sym_constant] = ACTIONS(2103),
    [sym_identifier] = ACTIONS(2103),
    [sym_instance_variable] = ACTIONS(2105),
    [sym_class_variable] = ACTIONS(2105),
    [sym_global_variable] = ACTIONS(2105),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2103),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2103),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3051] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(8745),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_then] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [3052] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(8747),
    [sym__binary_star] = ACTIONS(8749),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(8751),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(8749),
    [anon_sym_AMP] = ACTIONS(8753),
    [anon_sym_LT] = ACTIONS(8755),
    [anon_sym_then] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(1625),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(8757),
    [anon_sym_DOT_DOT] = ACTIONS(8759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8761),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(8763),
    [anon_sym_AMP_AMP] = ACTIONS(8763),
    [anon_sym_LT_LT] = ACTIONS(8765),
    [anon_sym_GT_GT] = ACTIONS(8765),
    [anon_sym_EQ_EQ] = ACTIONS(8767),
    [anon_sym_BANG_EQ] = ACTIONS(8763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8763),
    [anon_sym_LT_EQ_GT] = ACTIONS(8763),
    [anon_sym_EQ_TILDE] = ACTIONS(8763),
    [anon_sym_BANG_TILDE] = ACTIONS(8763),
    [anon_sym_LT_EQ] = ACTIONS(8755),
    [anon_sym_GT] = ACTIONS(8755),
    [anon_sym_GT_EQ] = ACTIONS(8769),
    [anon_sym_CARET] = ACTIONS(8771),
    [anon_sym_PLUS] = ACTIONS(8747),
    [anon_sym_SLASH] = ACTIONS(8749),
    [anon_sym_PERCENT] = ACTIONS(8749),
    [sym_comment] = ACTIONS(87),
  },
  [3053] = {
    [sym_heredoc_body] = STATE(5594),
    [aux_sym_call_repeat1] = STATE(5594),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_then] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [3054] = {
    [sym_heredoc_body] = STATE(5594),
    [aux_sym_call_repeat1] = STATE(5594),
    [aux_sym_argument_list_repeat1] = STATE(5596),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(8773),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_then] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [3055] = {
    [anon_sym_EQ] = ACTIONS(8775),
    [sym_comment] = ACTIONS(87),
  },
  [3056] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(8777),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(8779),
    [anon_sym_DASH_EQ] = ACTIONS(8779),
    [anon_sym_STAR_EQ] = ACTIONS(8779),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8779),
    [anon_sym_SLASH_EQ] = ACTIONS(8779),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8779),
    [anon_sym_PIPE_EQ] = ACTIONS(8779),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8779),
    [anon_sym_AMP_EQ] = ACTIONS(8779),
    [anon_sym_PERCENT_EQ] = ACTIONS(8779),
    [anon_sym_GT_GT_EQ] = ACTIONS(8779),
    [anon_sym_LT_LT_EQ] = ACTIONS(8779),
    [anon_sym_CARET_EQ] = ACTIONS(8779),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3057] = {
    [sym_string] = STATE(3102),
    [aux_sym_chained_string_repeat1] = STATE(3102),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(8781),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [3058] = {
    [sym__line_break] = ACTIONS(565),
    [sym__heredoc_body_start] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(565),
    [anon_sym_SEMI] = ACTIONS(565),
    [anon_sym_then] = ACTIONS(565),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_COLON_COLON2] = ACTIONS(565),
    [anon_sym_AMP_DOT] = ACTIONS(565),
    [sym_comment] = ACTIONS(87),
  },
  [3059] = {
    [sym__line_break] = ACTIONS(569),
    [sym__heredoc_body_start] = ACTIONS(569),
    [anon_sym_DOT] = ACTIONS(569),
    [anon_sym_SEMI] = ACTIONS(569),
    [anon_sym_then] = ACTIONS(569),
    [anon_sym_LBRACK] = ACTIONS(569),
    [anon_sym_COLON_COLON2] = ACTIONS(569),
    [anon_sym_AMP_DOT] = ACTIONS(569),
    [sym_comment] = ACTIONS(87),
  },
  [3060] = {
    [sym__line_break] = ACTIONS(573),
    [sym__heredoc_body_start] = ACTIONS(573),
    [anon_sym_DOT] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(573),
    [anon_sym_then] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(573),
    [anon_sym_COLON_COLON2] = ACTIONS(573),
    [anon_sym_AMP_DOT] = ACTIONS(573),
    [sym_comment] = ACTIONS(87),
  },
  [3061] = {
    [anon_sym_DOT] = ACTIONS(8783),
    [anon_sym_LBRACK] = ACTIONS(8785),
    [anon_sym_COLON_COLON2] = ACTIONS(1519),
    [anon_sym_AMP_DOT] = ACTIONS(8783),
    [sym_comment] = ACTIONS(87),
  },
  [3062] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5615),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5621),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(5621),
    [sym_argument_list] = STATE(5616),
    [sym__argument_list_with_parens] = STATE(5617),
    [sym__argument] = STATE(5618),
    [sym_splat_argument] = STATE(5618),
    [sym_hash_splat_argument] = STATE(5618),
    [sym_block_argument] = STATE(5618),
    [sym_do_block] = STATE(5619),
    [sym_block] = STATE(5619),
    [sym_assignment] = STATE(5615),
    [sym_operator_assignment] = STATE(5615),
    [sym_conditional] = STATE(5615),
    [sym_range] = STATE(5615),
    [sym_binary] = STATE(5615),
    [sym_unary] = STATE(5615),
    [sym_left_assignment_list] = STATE(5620),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5621),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5621),
    [sym_false] = STATE(5621),
    [sym_nil] = STATE(5621),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5622),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5618),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(743),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(8787),
    [sym__splat_star] = ACTIONS(8789),
    [sym__unary_minus] = ACTIONS(8791),
    [sym__identifier_hash_key] = ACTIONS(8793),
    [anon_sym_LBRACE] = ACTIONS(8795),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(743),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(8797),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8799),
    [anon_sym_yield] = ACTIONS(8801),
    [anon_sym_break] = ACTIONS(8803),
    [anon_sym_next] = ACTIONS(8805),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(7328),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(769),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(8807),
    [anon_sym_PLUS] = ACTIONS(8809),
    [anon_sym_defined_QMARK] = ACTIONS(8811),
    [anon_sym_not] = ACTIONS(8813),
    [anon_sym_BANG] = ACTIONS(8815),
    [anon_sym_TILDE] = ACTIONS(8815),
    [sym_constant] = ACTIONS(8817),
    [sym_identifier] = ACTIONS(8817),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3063] = {
    [sym__line_break] = ACTIONS(8819),
    [sym__heredoc_body_start] = ACTIONS(8819),
    [anon_sym_DOT] = ACTIONS(559),
    [anon_sym_SEMI] = ACTIONS(8819),
    [anon_sym_then] = ACTIONS(8819),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [3064] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(5117),
    [sym__binary_star] = ACTIONS(5119),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(5121),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(5119),
    [anon_sym_AMP] = ACTIONS(5123),
    [anon_sym_LT] = ACTIONS(5125),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(5127),
    [anon_sym_DOT_DOT] = ACTIONS(5129),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5131),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(5135),
    [anon_sym_AMP_AMP] = ACTIONS(5135),
    [anon_sym_LT_LT] = ACTIONS(5137),
    [anon_sym_GT_GT] = ACTIONS(5137),
    [anon_sym_EQ_EQ] = ACTIONS(5139),
    [anon_sym_BANG_EQ] = ACTIONS(5135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5135),
    [anon_sym_LT_EQ_GT] = ACTIONS(5135),
    [anon_sym_EQ_TILDE] = ACTIONS(5135),
    [anon_sym_BANG_TILDE] = ACTIONS(5135),
    [anon_sym_LT_EQ] = ACTIONS(5125),
    [anon_sym_GT] = ACTIONS(5125),
    [anon_sym_GT_EQ] = ACTIONS(5141),
    [anon_sym_CARET] = ACTIONS(5143),
    [anon_sym_PLUS] = ACTIONS(5117),
    [anon_sym_SLASH] = ACTIONS(5119),
    [anon_sym_PERCENT] = ACTIONS(5119),
    [sym_comment] = ACTIONS(87),
  },
  [3065] = {
    [anon_sym_end] = ACTIONS(8821),
    [anon_sym_else] = ACTIONS(8821),
    [anon_sym_ensure] = ACTIONS(8821),
    [sym_comment] = ACTIONS(87),
  },
  [3066] = {
    [sym_rescue] = STATE(5623),
    [anon_sym_end] = ACTIONS(8821),
    [anon_sym_rescue] = ACTIONS(2165),
    [anon_sym_else] = ACTIONS(8821),
    [anon_sym_ensure] = ACTIONS(8821),
    [sym_comment] = ACTIONS(87),
  },
  [3067] = {
    [sym_then] = STATE(5624),
    [sym_heredoc_body] = STATE(5625),
    [sym__terminator] = STATE(5625),
    [sym__line_break] = ACTIONS(8823),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(8823),
    [anon_sym_then] = ACTIONS(5113),
    [sym_comment] = ACTIONS(87),
  },
  [3068] = {
    [sym__statements] = STATE(2640),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym_rescue] = STATE(5623),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(8825),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(8825),
    [anon_sym_then] = ACTIONS(5187),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(8825),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3069] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5626),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1175),
    [sym_scope_resolution] = STATE(1172),
    [sym_call] = STATE(1172),
    [sym_method_call] = STATE(1175),
    [sym_assignment] = STATE(5626),
    [sym_operator_assignment] = STATE(5626),
    [sym_conditional] = STATE(5626),
    [sym_range] = STATE(5626),
    [sym_binary] = STATE(5626),
    [sym_unary] = STATE(5626),
    [sym_left_assignment_list] = STATE(1174),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1175),
    [sym__variable] = STATE(1172),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1175),
    [sym_false] = STATE(1175),
    [sym_nil] = STATE(1175),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1176),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2081),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2085),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_next] = ACTIONS(2089),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2095),
    [anon_sym_defined_QMARK] = ACTIONS(2097),
    [anon_sym_not] = ACTIONS(2099),
    [anon_sym_BANG] = ACTIONS(2101),
    [anon_sym_TILDE] = ACTIONS(2101),
    [sym_constant] = ACTIONS(2103),
    [sym_identifier] = ACTIONS(2103),
    [sym_instance_variable] = ACTIONS(2105),
    [sym_class_variable] = ACTIONS(2105),
    [sym_global_variable] = ACTIONS(2105),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2103),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2103),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3070] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5627),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1175),
    [sym_scope_resolution] = STATE(1172),
    [sym_call] = STATE(1172),
    [sym_method_call] = STATE(1175),
    [sym_assignment] = STATE(5627),
    [sym_operator_assignment] = STATE(5627),
    [sym_conditional] = STATE(5627),
    [sym_range] = STATE(5627),
    [sym_binary] = STATE(5627),
    [sym_unary] = STATE(5627),
    [sym_left_assignment_list] = STATE(1174),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1175),
    [sym__variable] = STATE(1172),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1175),
    [sym_false] = STATE(1175),
    [sym_nil] = STATE(1175),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1176),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2081),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2085),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_next] = ACTIONS(2089),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2095),
    [anon_sym_defined_QMARK] = ACTIONS(2097),
    [anon_sym_not] = ACTIONS(2099),
    [anon_sym_BANG] = ACTIONS(2101),
    [anon_sym_TILDE] = ACTIONS(2101),
    [sym_constant] = ACTIONS(2103),
    [sym_identifier] = ACTIONS(2103),
    [sym_instance_variable] = ACTIONS(2105),
    [sym_class_variable] = ACTIONS(2105),
    [sym_global_variable] = ACTIONS(2105),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2103),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2103),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3071] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5628),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1175),
    [sym_scope_resolution] = STATE(1172),
    [sym_call] = STATE(1172),
    [sym_method_call] = STATE(1175),
    [sym_assignment] = STATE(5628),
    [sym_operator_assignment] = STATE(5628),
    [sym_conditional] = STATE(5628),
    [sym_range] = STATE(5628),
    [sym_binary] = STATE(5628),
    [sym_unary] = STATE(5628),
    [sym_left_assignment_list] = STATE(1174),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1175),
    [sym__variable] = STATE(1172),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1175),
    [sym_false] = STATE(1175),
    [sym_nil] = STATE(1175),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1176),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2081),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2085),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_next] = ACTIONS(2089),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2095),
    [anon_sym_defined_QMARK] = ACTIONS(2097),
    [anon_sym_not] = ACTIONS(2099),
    [anon_sym_BANG] = ACTIONS(2101),
    [anon_sym_TILDE] = ACTIONS(2101),
    [sym_constant] = ACTIONS(2103),
    [sym_identifier] = ACTIONS(2103),
    [sym_instance_variable] = ACTIONS(2105),
    [sym_class_variable] = ACTIONS(2105),
    [sym_global_variable] = ACTIONS(2105),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2103),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2103),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3072] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5629),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1175),
    [sym_scope_resolution] = STATE(1172),
    [sym_call] = STATE(1172),
    [sym_method_call] = STATE(1175),
    [sym_assignment] = STATE(5629),
    [sym_operator_assignment] = STATE(5629),
    [sym_conditional] = STATE(5629),
    [sym_range] = STATE(5629),
    [sym_binary] = STATE(5629),
    [sym_unary] = STATE(5629),
    [sym_left_assignment_list] = STATE(1174),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1175),
    [sym__variable] = STATE(1172),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1175),
    [sym_false] = STATE(1175),
    [sym_nil] = STATE(1175),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1176),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2081),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2085),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_next] = ACTIONS(2089),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2095),
    [anon_sym_defined_QMARK] = ACTIONS(2097),
    [anon_sym_not] = ACTIONS(2099),
    [anon_sym_BANG] = ACTIONS(2101),
    [anon_sym_TILDE] = ACTIONS(2101),
    [sym_constant] = ACTIONS(2103),
    [sym_identifier] = ACTIONS(2103),
    [sym_instance_variable] = ACTIONS(2105),
    [sym_class_variable] = ACTIONS(2105),
    [sym_global_variable] = ACTIONS(2105),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2103),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2103),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3073] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5630),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1175),
    [sym_scope_resolution] = STATE(1172),
    [sym_call] = STATE(1172),
    [sym_method_call] = STATE(1175),
    [sym_assignment] = STATE(5630),
    [sym_operator_assignment] = STATE(5630),
    [sym_conditional] = STATE(5630),
    [sym_range] = STATE(5630),
    [sym_binary] = STATE(5630),
    [sym_unary] = STATE(5630),
    [sym_left_assignment_list] = STATE(1174),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1175),
    [sym__variable] = STATE(1172),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1175),
    [sym_false] = STATE(1175),
    [sym_nil] = STATE(1175),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1176),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2081),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2085),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_next] = ACTIONS(2089),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2095),
    [anon_sym_defined_QMARK] = ACTIONS(2097),
    [anon_sym_not] = ACTIONS(2099),
    [anon_sym_BANG] = ACTIONS(2101),
    [anon_sym_TILDE] = ACTIONS(2101),
    [sym_constant] = ACTIONS(2103),
    [sym_identifier] = ACTIONS(2103),
    [sym_instance_variable] = ACTIONS(2105),
    [sym_class_variable] = ACTIONS(2105),
    [sym_global_variable] = ACTIONS(2105),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2103),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2103),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3074] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(5631),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(5631),
    [sym_operator_assignment] = STATE(5631),
    [sym_conditional] = STATE(5631),
    [sym_range] = STATE(5631),
    [sym_binary] = STATE(5631),
    [sym_unary] = STATE(5631),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3075] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5632),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1175),
    [sym_scope_resolution] = STATE(1172),
    [sym_call] = STATE(1172),
    [sym_method_call] = STATE(1175),
    [sym_assignment] = STATE(5632),
    [sym_operator_assignment] = STATE(5632),
    [sym_conditional] = STATE(5632),
    [sym_range] = STATE(5632),
    [sym_binary] = STATE(5632),
    [sym_unary] = STATE(5632),
    [sym_left_assignment_list] = STATE(1174),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1175),
    [sym__variable] = STATE(1172),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1175),
    [sym_false] = STATE(1175),
    [sym_nil] = STATE(1175),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1176),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2081),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2085),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_next] = ACTIONS(2089),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2095),
    [anon_sym_defined_QMARK] = ACTIONS(2097),
    [anon_sym_not] = ACTIONS(2099),
    [anon_sym_BANG] = ACTIONS(2101),
    [anon_sym_TILDE] = ACTIONS(2101),
    [sym_constant] = ACTIONS(2103),
    [sym_identifier] = ACTIONS(2103),
    [sym_instance_variable] = ACTIONS(2105),
    [sym_class_variable] = ACTIONS(2105),
    [sym_global_variable] = ACTIONS(2105),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2103),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2103),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3076] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5633),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1175),
    [sym_scope_resolution] = STATE(1172),
    [sym_call] = STATE(1172),
    [sym_method_call] = STATE(1175),
    [sym_assignment] = STATE(5633),
    [sym_operator_assignment] = STATE(5633),
    [sym_conditional] = STATE(5633),
    [sym_range] = STATE(5633),
    [sym_binary] = STATE(5633),
    [sym_unary] = STATE(5633),
    [sym_left_assignment_list] = STATE(1174),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1175),
    [sym__variable] = STATE(1172),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1175),
    [sym_false] = STATE(1175),
    [sym_nil] = STATE(1175),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1176),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2081),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2085),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_next] = ACTIONS(2089),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2095),
    [anon_sym_defined_QMARK] = ACTIONS(2097),
    [anon_sym_not] = ACTIONS(2099),
    [anon_sym_BANG] = ACTIONS(2101),
    [anon_sym_TILDE] = ACTIONS(2101),
    [sym_constant] = ACTIONS(2103),
    [sym_identifier] = ACTIONS(2103),
    [sym_instance_variable] = ACTIONS(2105),
    [sym_class_variable] = ACTIONS(2105),
    [sym_global_variable] = ACTIONS(2105),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2103),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2103),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3077] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5634),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1175),
    [sym_scope_resolution] = STATE(1172),
    [sym_call] = STATE(1172),
    [sym_method_call] = STATE(1175),
    [sym_assignment] = STATE(5634),
    [sym_operator_assignment] = STATE(5634),
    [sym_conditional] = STATE(5634),
    [sym_range] = STATE(5634),
    [sym_binary] = STATE(5634),
    [sym_unary] = STATE(5634),
    [sym_left_assignment_list] = STATE(1174),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1175),
    [sym__variable] = STATE(1172),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1175),
    [sym_false] = STATE(1175),
    [sym_nil] = STATE(1175),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1176),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2081),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2085),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_next] = ACTIONS(2089),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2095),
    [anon_sym_defined_QMARK] = ACTIONS(2097),
    [anon_sym_not] = ACTIONS(2099),
    [anon_sym_BANG] = ACTIONS(2101),
    [anon_sym_TILDE] = ACTIONS(2101),
    [sym_constant] = ACTIONS(2103),
    [sym_identifier] = ACTIONS(2103),
    [sym_instance_variable] = ACTIONS(2105),
    [sym_class_variable] = ACTIONS(2105),
    [sym_global_variable] = ACTIONS(2105),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2103),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2103),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3078] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5635),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1175),
    [sym_scope_resolution] = STATE(1172),
    [sym_call] = STATE(1172),
    [sym_method_call] = STATE(1175),
    [sym_assignment] = STATE(5635),
    [sym_operator_assignment] = STATE(5635),
    [sym_conditional] = STATE(5635),
    [sym_range] = STATE(5635),
    [sym_binary] = STATE(5635),
    [sym_unary] = STATE(5635),
    [sym_left_assignment_list] = STATE(1174),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1175),
    [sym__variable] = STATE(1172),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1175),
    [sym_false] = STATE(1175),
    [sym_nil] = STATE(1175),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1176),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2081),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2085),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_next] = ACTIONS(2089),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2095),
    [anon_sym_defined_QMARK] = ACTIONS(2097),
    [anon_sym_not] = ACTIONS(2099),
    [anon_sym_BANG] = ACTIONS(2101),
    [anon_sym_TILDE] = ACTIONS(2101),
    [sym_constant] = ACTIONS(2103),
    [sym_identifier] = ACTIONS(2103),
    [sym_instance_variable] = ACTIONS(2105),
    [sym_class_variable] = ACTIONS(2105),
    [sym_global_variable] = ACTIONS(2105),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2103),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2103),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3079] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5636),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3096),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(3096),
    [sym_assignment] = STATE(5636),
    [sym_operator_assignment] = STATE(5636),
    [sym_conditional] = STATE(5636),
    [sym_range] = STATE(5636),
    [sym_binary] = STATE(5636),
    [sym_unary] = STATE(5636),
    [sym_left_assignment_list] = STATE(3095),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3096),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3096),
    [sym_false] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5637),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5149),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5153),
    [anon_sym_yield] = ACTIONS(5155),
    [anon_sym_break] = ACTIONS(5157),
    [anon_sym_next] = ACTIONS(5159),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(8827),
    [anon_sym_defined_QMARK] = ACTIONS(5161),
    [anon_sym_not] = ACTIONS(5163),
    [anon_sym_BANG] = ACTIONS(5167),
    [anon_sym_TILDE] = ACTIONS(5167),
    [sym_constant] = ACTIONS(5173),
    [sym_identifier] = ACTIONS(5173),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3080] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5638),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3096),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(3096),
    [sym_assignment] = STATE(5638),
    [sym_operator_assignment] = STATE(5638),
    [sym_conditional] = STATE(5638),
    [sym_range] = STATE(5638),
    [sym_binary] = STATE(5638),
    [sym_unary] = STATE(5638),
    [sym_left_assignment_list] = STATE(3095),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3096),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3096),
    [sym_false] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5637),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5149),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5153),
    [anon_sym_yield] = ACTIONS(5155),
    [anon_sym_break] = ACTIONS(5157),
    [anon_sym_next] = ACTIONS(5159),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(8827),
    [anon_sym_defined_QMARK] = ACTIONS(5161),
    [anon_sym_not] = ACTIONS(5163),
    [anon_sym_BANG] = ACTIONS(5167),
    [anon_sym_TILDE] = ACTIONS(5167),
    [sym_constant] = ACTIONS(5173),
    [sym_identifier] = ACTIONS(5173),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3081] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5639),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3096),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(3096),
    [sym_assignment] = STATE(5639),
    [sym_operator_assignment] = STATE(5639),
    [sym_conditional] = STATE(5639),
    [sym_range] = STATE(5639),
    [sym_binary] = STATE(5639),
    [sym_unary] = STATE(5639),
    [sym_left_assignment_list] = STATE(3095),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3096),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3096),
    [sym_false] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5637),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5149),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5153),
    [anon_sym_yield] = ACTIONS(5155),
    [anon_sym_break] = ACTIONS(5157),
    [anon_sym_next] = ACTIONS(5159),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(8827),
    [anon_sym_defined_QMARK] = ACTIONS(5161),
    [anon_sym_not] = ACTIONS(5163),
    [anon_sym_BANG] = ACTIONS(5167),
    [anon_sym_TILDE] = ACTIONS(5167),
    [sym_constant] = ACTIONS(5173),
    [sym_identifier] = ACTIONS(5173),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3082] = {
    [anon_sym_COLON] = ACTIONS(8829),
    [sym_comment] = ACTIONS(87),
  },
  [3083] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5641),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3096),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(3096),
    [sym_assignment] = STATE(5641),
    [sym_operator_assignment] = STATE(5641),
    [sym_conditional] = STATE(5641),
    [sym_range] = STATE(5641),
    [sym_binary] = STATE(5641),
    [sym_unary] = STATE(5641),
    [sym_left_assignment_list] = STATE(3095),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3096),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3096),
    [sym_false] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5637),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5149),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5153),
    [anon_sym_yield] = ACTIONS(5155),
    [anon_sym_break] = ACTIONS(5157),
    [anon_sym_next] = ACTIONS(5159),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(8827),
    [anon_sym_defined_QMARK] = ACTIONS(5161),
    [anon_sym_not] = ACTIONS(5163),
    [anon_sym_BANG] = ACTIONS(5167),
    [anon_sym_TILDE] = ACTIONS(5167),
    [sym_constant] = ACTIONS(5173),
    [sym_identifier] = ACTIONS(5173),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3084] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3091),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3096),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(3096),
    [sym_argument_list] = STATE(1535),
    [sym__argument_list_with_parens] = STATE(3093),
    [sym__argument] = STATE(3094),
    [sym_splat_argument] = STATE(3094),
    [sym_hash_splat_argument] = STATE(3094),
    [sym_block_argument] = STATE(3094),
    [sym_assignment] = STATE(3091),
    [sym_operator_assignment] = STATE(3091),
    [sym_conditional] = STATE(3091),
    [sym_range] = STATE(3091),
    [sym_binary] = STATE(3091),
    [sym_unary] = STATE(3091),
    [sym_left_assignment_list] = STATE(3095),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3096),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3096),
    [sym_false] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3097),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(3094),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(5145),
    [sym__splat_star] = ACTIONS(5147),
    [sym__unary_minus] = ACTIONS(5149),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(5151),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5153),
    [anon_sym_yield] = ACTIONS(5155),
    [anon_sym_break] = ACTIONS(5157),
    [anon_sym_next] = ACTIONS(5159),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_then] = ACTIONS(377),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(365),
    [anon_sym_DASH_EQ] = ACTIONS(365),
    [anon_sym_STAR_EQ] = ACTIONS(365),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(365),
    [anon_sym_SLASH_EQ] = ACTIONS(365),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(365),
    [anon_sym_PIPE_EQ] = ACTIONS(365),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(365),
    [anon_sym_AMP_EQ] = ACTIONS(365),
    [anon_sym_PERCENT_EQ] = ACTIONS(365),
    [anon_sym_GT_GT_EQ] = ACTIONS(365),
    [anon_sym_LT_LT_EQ] = ACTIONS(365),
    [anon_sym_CARET_EQ] = ACTIONS(365),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_PERCENT] = ACTIONS(377),
    [anon_sym_defined_QMARK] = ACTIONS(5161),
    [anon_sym_not] = ACTIONS(5163),
    [anon_sym_BANG] = ACTIONS(5165),
    [anon_sym_TILDE] = ACTIONS(5167),
    [sym_constant] = ACTIONS(5169),
    [sym_identifier] = ACTIONS(5169),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3085] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3091),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3096),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(3096),
    [sym_argument_list] = STATE(1536),
    [sym__argument_list_with_parens] = STATE(3093),
    [sym__argument] = STATE(3094),
    [sym_splat_argument] = STATE(3094),
    [sym_hash_splat_argument] = STATE(3094),
    [sym_block_argument] = STATE(3094),
    [sym_assignment] = STATE(3091),
    [sym_operator_assignment] = STATE(3091),
    [sym_conditional] = STATE(3091),
    [sym_range] = STATE(3091),
    [sym_binary] = STATE(3091),
    [sym_unary] = STATE(3091),
    [sym_left_assignment_list] = STATE(3095),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3096),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3096),
    [sym_false] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3097),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(3094),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(5145),
    [sym__splat_star] = ACTIONS(5147),
    [sym__unary_minus] = ACTIONS(5149),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(5151),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_EQ] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5153),
    [anon_sym_yield] = ACTIONS(5155),
    [anon_sym_break] = ACTIONS(5157),
    [anon_sym_next] = ACTIONS(5159),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_then] = ACTIONS(419),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(417),
    [anon_sym_DASH_EQ] = ACTIONS(417),
    [anon_sym_STAR_EQ] = ACTIONS(417),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(417),
    [anon_sym_SLASH_EQ] = ACTIONS(417),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(417),
    [anon_sym_PIPE_EQ] = ACTIONS(417),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(417),
    [anon_sym_AMP_EQ] = ACTIONS(417),
    [anon_sym_PERCENT_EQ] = ACTIONS(417),
    [anon_sym_GT_GT_EQ] = ACTIONS(417),
    [anon_sym_LT_LT_EQ] = ACTIONS(417),
    [anon_sym_CARET_EQ] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(5161),
    [anon_sym_not] = ACTIONS(5163),
    [anon_sym_BANG] = ACTIONS(5165),
    [anon_sym_TILDE] = ACTIONS(5167),
    [sym_constant] = ACTIONS(5169),
    [sym_identifier] = ACTIONS(5169),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3086] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3091),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3096),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(3096),
    [sym_argument_list] = STATE(1537),
    [sym__argument_list_with_parens] = STATE(3093),
    [sym__argument] = STATE(3094),
    [sym_splat_argument] = STATE(3094),
    [sym_hash_splat_argument] = STATE(3094),
    [sym_block_argument] = STATE(3094),
    [sym_assignment] = STATE(3091),
    [sym_operator_assignment] = STATE(3091),
    [sym_conditional] = STATE(3091),
    [sym_range] = STATE(3091),
    [sym_binary] = STATE(3091),
    [sym_unary] = STATE(3091),
    [sym_left_assignment_list] = STATE(3095),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3096),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3096),
    [sym_false] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3097),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(3094),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(5145),
    [sym__splat_star] = ACTIONS(5147),
    [sym__unary_minus] = ACTIONS(5149),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(5151),
    [anon_sym_LBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_EQ] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5153),
    [anon_sym_yield] = ACTIONS(5155),
    [anon_sym_break] = ACTIONS(5157),
    [anon_sym_next] = ACTIONS(5159),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_then] = ACTIONS(423),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(421),
    [anon_sym_DASH_EQ] = ACTIONS(421),
    [anon_sym_STAR_EQ] = ACTIONS(421),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(421),
    [anon_sym_SLASH_EQ] = ACTIONS(421),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(421),
    [anon_sym_PIPE_EQ] = ACTIONS(421),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(421),
    [anon_sym_AMP_EQ] = ACTIONS(421),
    [anon_sym_PERCENT_EQ] = ACTIONS(421),
    [anon_sym_GT_GT_EQ] = ACTIONS(421),
    [anon_sym_LT_LT_EQ] = ACTIONS(421),
    [anon_sym_CARET_EQ] = ACTIONS(421),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(5161),
    [anon_sym_not] = ACTIONS(5163),
    [anon_sym_BANG] = ACTIONS(5165),
    [anon_sym_TILDE] = ACTIONS(5167),
    [sym_constant] = ACTIONS(5169),
    [sym_identifier] = ACTIONS(5169),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3087] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3091),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3096),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(3096),
    [sym_argument_list] = STATE(1538),
    [sym__argument_list_with_parens] = STATE(3093),
    [sym__argument] = STATE(3094),
    [sym_splat_argument] = STATE(3094),
    [sym_hash_splat_argument] = STATE(3094),
    [sym_block_argument] = STATE(3094),
    [sym_assignment] = STATE(3091),
    [sym_operator_assignment] = STATE(3091),
    [sym_conditional] = STATE(3091),
    [sym_range] = STATE(3091),
    [sym_binary] = STATE(3091),
    [sym_unary] = STATE(3091),
    [sym_left_assignment_list] = STATE(3095),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3096),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3096),
    [sym_false] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3097),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(3094),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(5145),
    [sym__splat_star] = ACTIONS(5147),
    [sym__unary_minus] = ACTIONS(5149),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(5151),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(427),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5153),
    [anon_sym_yield] = ACTIONS(5155),
    [anon_sym_break] = ACTIONS(5157),
    [anon_sym_next] = ACTIONS(5159),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_then] = ACTIONS(427),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(425),
    [anon_sym_DASH_EQ] = ACTIONS(425),
    [anon_sym_STAR_EQ] = ACTIONS(425),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(425),
    [anon_sym_SLASH_EQ] = ACTIONS(425),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(425),
    [anon_sym_PIPE_EQ] = ACTIONS(425),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(425),
    [anon_sym_AMP_EQ] = ACTIONS(425),
    [anon_sym_PERCENT_EQ] = ACTIONS(425),
    [anon_sym_GT_GT_EQ] = ACTIONS(425),
    [anon_sym_LT_LT_EQ] = ACTIONS(425),
    [anon_sym_CARET_EQ] = ACTIONS(425),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(5161),
    [anon_sym_not] = ACTIONS(5163),
    [anon_sym_BANG] = ACTIONS(5165),
    [anon_sym_TILDE] = ACTIONS(5167),
    [sym_constant] = ACTIONS(5169),
    [sym_identifier] = ACTIONS(5169),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3088] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5642),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3096),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(3096),
    [sym_assignment] = STATE(5642),
    [sym_operator_assignment] = STATE(5642),
    [sym_conditional] = STATE(5642),
    [sym_range] = STATE(5642),
    [sym_binary] = STATE(5642),
    [sym_unary] = STATE(5642),
    [sym_left_assignment_list] = STATE(3095),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3096),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3096),
    [sym_false] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5637),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5149),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5153),
    [anon_sym_yield] = ACTIONS(5155),
    [anon_sym_break] = ACTIONS(5157),
    [anon_sym_next] = ACTIONS(5159),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(8827),
    [anon_sym_defined_QMARK] = ACTIONS(5161),
    [anon_sym_not] = ACTIONS(5163),
    [anon_sym_BANG] = ACTIONS(5167),
    [anon_sym_TILDE] = ACTIONS(5167),
    [sym_constant] = ACTIONS(5173),
    [sym_identifier] = ACTIONS(5173),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3089] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(1559),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3096),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(3096),
    [sym_assignment] = STATE(1559),
    [sym_operator_assignment] = STATE(1559),
    [sym_conditional] = STATE(1559),
    [sym_range] = STATE(1559),
    [sym_binary] = STATE(1559),
    [sym_unary] = STATE(1559),
    [sym_left_assignment_list] = STATE(3095),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3096),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3096),
    [sym_false] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5637),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5149),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5153),
    [anon_sym_yield] = ACTIONS(5155),
    [anon_sym_break] = ACTIONS(5157),
    [anon_sym_next] = ACTIONS(5159),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(8827),
    [anon_sym_defined_QMARK] = ACTIONS(5161),
    [anon_sym_not] = ACTIONS(5163),
    [anon_sym_BANG] = ACTIONS(5167),
    [anon_sym_TILDE] = ACTIONS(5167),
    [sym_constant] = ACTIONS(5173),
    [sym_identifier] = ACTIONS(5173),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3090] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(8831),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_then] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [3091] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(8833),
    [sym__binary_star] = ACTIONS(8835),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(8837),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(8839),
    [anon_sym_AMP] = ACTIONS(8841),
    [anon_sym_EQ] = ACTIONS(1631),
    [anon_sym_LT] = ACTIONS(8843),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_then] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(1625),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_PLUS_EQ] = ACTIONS(1625),
    [anon_sym_DASH_EQ] = ACTIONS(1625),
    [anon_sym_STAR_EQ] = ACTIONS(1625),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1625),
    [anon_sym_SLASH_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1625),
    [anon_sym_AMP_EQ] = ACTIONS(1625),
    [anon_sym_PERCENT_EQ] = ACTIONS(1625),
    [anon_sym_GT_GT_EQ] = ACTIONS(1625),
    [anon_sym_LT_LT_EQ] = ACTIONS(1625),
    [anon_sym_CARET_EQ] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(8845),
    [anon_sym_DOT_DOT] = ACTIONS(8847),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8849),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(8851),
    [anon_sym_AMP_AMP] = ACTIONS(8851),
    [anon_sym_LT_LT] = ACTIONS(8853),
    [anon_sym_GT_GT] = ACTIONS(8853),
    [anon_sym_EQ_EQ] = ACTIONS(8851),
    [anon_sym_BANG_EQ] = ACTIONS(8855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8855),
    [anon_sym_LT_EQ_GT] = ACTIONS(8855),
    [anon_sym_EQ_TILDE] = ACTIONS(8855),
    [anon_sym_BANG_TILDE] = ACTIONS(8855),
    [anon_sym_LT_EQ] = ACTIONS(8843),
    [anon_sym_GT] = ACTIONS(8843),
    [anon_sym_GT_EQ] = ACTIONS(8857),
    [anon_sym_CARET] = ACTIONS(8837),
    [anon_sym_PLUS] = ACTIONS(8859),
    [anon_sym_SLASH] = ACTIONS(8839),
    [anon_sym_PERCENT] = ACTIONS(8839),
    [sym_comment] = ACTIONS(87),
  },
  [3092] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3091),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3096),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(3096),
    [sym_argument_list] = STATE(1578),
    [sym__argument_list_with_parens] = STATE(3093),
    [sym__argument] = STATE(3094),
    [sym_splat_argument] = STATE(3094),
    [sym_hash_splat_argument] = STATE(3094),
    [sym_block_argument] = STATE(3094),
    [sym_do_block] = STATE(941),
    [sym_block] = STATE(941),
    [sym_assignment] = STATE(3091),
    [sym_operator_assignment] = STATE(3091),
    [sym_conditional] = STATE(3091),
    [sym_range] = STATE(3091),
    [sym_binary] = STATE(3091),
    [sym_unary] = STATE(3091),
    [sym_left_assignment_list] = STATE(3095),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3096),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3096),
    [sym_false] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3097),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(3094),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(743),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(5145),
    [sym__splat_star] = ACTIONS(5147),
    [sym__unary_minus] = ACTIONS(5149),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(5151),
    [anon_sym_LBRACE] = ACTIONS(2715),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5153),
    [anon_sym_yield] = ACTIONS(5155),
    [anon_sym_break] = ACTIONS(5157),
    [anon_sym_next] = ACTIONS(5159),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(769),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_then] = ACTIONS(769),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(5161),
    [anon_sym_not] = ACTIONS(5163),
    [anon_sym_BANG] = ACTIONS(5165),
    [anon_sym_TILDE] = ACTIONS(5167),
    [sym_constant] = ACTIONS(5169),
    [sym_identifier] = ACTIONS(5169),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3093] = {
    [sym_heredoc_body] = STATE(5654),
    [aux_sym_call_repeat1] = STATE(5654),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_then] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [3094] = {
    [sym_heredoc_body] = STATE(5654),
    [aux_sym_call_repeat1] = STATE(5654),
    [aux_sym_argument_list_repeat1] = STATE(5656),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(8861),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_then] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [3095] = {
    [anon_sym_EQ] = ACTIONS(8863),
    [sym_comment] = ACTIONS(87),
  },
  [3096] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(8865),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(8867),
    [anon_sym_DASH_EQ] = ACTIONS(8867),
    [anon_sym_STAR_EQ] = ACTIONS(8867),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8867),
    [anon_sym_SLASH_EQ] = ACTIONS(8867),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8867),
    [anon_sym_PIPE_EQ] = ACTIONS(8867),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8867),
    [anon_sym_AMP_EQ] = ACTIONS(8867),
    [anon_sym_PERCENT_EQ] = ACTIONS(8867),
    [anon_sym_GT_GT_EQ] = ACTIONS(8867),
    [anon_sym_LT_LT_EQ] = ACTIONS(8867),
    [anon_sym_CARET_EQ] = ACTIONS(8867),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3097] = {
    [sym_string] = STATE(5659),
    [aux_sym_chained_string_repeat1] = STATE(5659),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(747),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(8869),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3098] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1171),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1175),
    [sym_scope_resolution] = STATE(1172),
    [sym_call] = STATE(1172),
    [sym_method_call] = STATE(1175),
    [sym_splat_argument] = STATE(5660),
    [sym_assignment] = STATE(1171),
    [sym_operator_assignment] = STATE(1171),
    [sym_conditional] = STATE(1171),
    [sym_range] = STATE(1171),
    [sym_binary] = STATE(1171),
    [sym_unary] = STATE(1171),
    [sym__arg_or_splat_arg] = STATE(5660),
    [sym_left_assignment_list] = STATE(1174),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1175),
    [sym__variable] = STATE(1172),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1175),
    [sym_false] = STATE(1175),
    [sym_nil] = STATE(1175),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1176),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__splat_star] = ACTIONS(2079),
    [sym__unary_minus] = ACTIONS(2081),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2085),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_next] = ACTIONS(2089),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2095),
    [anon_sym_defined_QMARK] = ACTIONS(2097),
    [anon_sym_not] = ACTIONS(2099),
    [anon_sym_BANG] = ACTIONS(2101),
    [anon_sym_TILDE] = ACTIONS(2101),
    [sym_constant] = ACTIONS(2103),
    [sym_identifier] = ACTIONS(2103),
    [sym_instance_variable] = ACTIONS(2105),
    [sym_class_variable] = ACTIONS(2105),
    [sym_global_variable] = ACTIONS(2105),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2103),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2103),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3099] = {
    [aux_sym_exceptions_repeat1] = STATE(5661),
    [sym__line_break] = ACTIONS(8871),
    [sym__heredoc_body_start] = ACTIONS(8871),
    [anon_sym_COMMA] = ACTIONS(5177),
    [anon_sym_SEMI] = ACTIONS(8871),
    [anon_sym_then] = ACTIONS(8871),
    [anon_sym_EQ_GT] = ACTIONS(8871),
    [sym_comment] = ACTIONS(87),
  },
  [3100] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5663),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1175),
    [sym_scope_resolution] = STATE(1172),
    [sym_call] = STATE(1172),
    [sym_method_call] = STATE(1175),
    [sym_splat_argument] = STATE(5664),
    [sym_assignment] = STATE(5663),
    [sym_operator_assignment] = STATE(5663),
    [sym_conditional] = STATE(5663),
    [sym_range] = STATE(5663),
    [sym_binary] = STATE(5663),
    [sym_unary] = STATE(5663),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(5664),
    [sym_left_assignment_list] = STATE(1174),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1175),
    [sym__variable] = STATE(1172),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1175),
    [sym_false] = STATE(1175),
    [sym_nil] = STATE(1175),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1176),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__splat_star] = ACTIONS(8873),
    [sym__unary_minus] = ACTIONS(2081),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2085),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_next] = ACTIONS(2089),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2095),
    [anon_sym_defined_QMARK] = ACTIONS(2097),
    [anon_sym_not] = ACTIONS(2099),
    [anon_sym_BANG] = ACTIONS(2101),
    [anon_sym_TILDE] = ACTIONS(2101),
    [sym_constant] = ACTIONS(2103),
    [sym_identifier] = ACTIONS(2103),
    [sym_instance_variable] = ACTIONS(2105),
    [sym_class_variable] = ACTIONS(2105),
    [sym_global_variable] = ACTIONS(2105),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2103),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2103),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3101] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5665),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1175),
    [sym_scope_resolution] = STATE(1172),
    [sym_call] = STATE(1172),
    [sym_method_call] = STATE(1175),
    [sym_assignment] = STATE(5665),
    [sym_operator_assignment] = STATE(5665),
    [sym_conditional] = STATE(5665),
    [sym_range] = STATE(5665),
    [sym_binary] = STATE(5665),
    [sym_unary] = STATE(5665),
    [sym_left_assignment_list] = STATE(1174),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1175),
    [sym__variable] = STATE(1172),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1175),
    [sym_false] = STATE(1175),
    [sym_nil] = STATE(1175),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1176),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2081),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2085),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_next] = ACTIONS(2089),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2095),
    [anon_sym_defined_QMARK] = ACTIONS(2097),
    [anon_sym_not] = ACTIONS(2099),
    [anon_sym_BANG] = ACTIONS(2101),
    [anon_sym_TILDE] = ACTIONS(2101),
    [sym_constant] = ACTIONS(2103),
    [sym_identifier] = ACTIONS(2103),
    [sym_instance_variable] = ACTIONS(2105),
    [sym_class_variable] = ACTIONS(2105),
    [sym_global_variable] = ACTIONS(2105),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2103),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2103),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3102] = {
    [sym_string] = STATE(5666),
    [aux_sym_chained_string_repeat1] = STATE(5666),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_then] = ACTIONS(2753),
    [anon_sym_EQ_GT] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [3103] = {
    [sym__statements] = STATE(5106),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(8104),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(8104),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(8104),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(8104),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3104] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(5235),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_ensure] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [3105] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5674),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5676),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(5676),
    [sym_assignment] = STATE(5674),
    [sym_operator_assignment] = STATE(5674),
    [sym_conditional] = STATE(5674),
    [sym_range] = STATE(5674),
    [sym_binary] = STATE(5674),
    [sym_unary] = STATE(5674),
    [sym_left_assignment_list] = STATE(5675),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5676),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5676),
    [sym_false] = STATE(5676),
    [sym_nil] = STATE(5676),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5677),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8875),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8877),
    [anon_sym_yield] = ACTIONS(8879),
    [anon_sym_break] = ACTIONS(8881),
    [anon_sym_next] = ACTIONS(8883),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8885),
    [anon_sym_defined_QMARK] = ACTIONS(8887),
    [anon_sym_not] = ACTIONS(8889),
    [anon_sym_BANG] = ACTIONS(8891),
    [anon_sym_TILDE] = ACTIONS(8891),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3106] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5678),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5676),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(5676),
    [sym_assignment] = STATE(5678),
    [sym_operator_assignment] = STATE(5678),
    [sym_conditional] = STATE(5678),
    [sym_range] = STATE(5678),
    [sym_binary] = STATE(5678),
    [sym_unary] = STATE(5678),
    [sym_left_assignment_list] = STATE(5675),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5676),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5676),
    [sym_false] = STATE(5676),
    [sym_nil] = STATE(5676),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5677),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8875),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8877),
    [anon_sym_yield] = ACTIONS(8879),
    [anon_sym_break] = ACTIONS(8881),
    [anon_sym_next] = ACTIONS(8883),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8885),
    [anon_sym_defined_QMARK] = ACTIONS(8887),
    [anon_sym_not] = ACTIONS(8889),
    [anon_sym_BANG] = ACTIONS(8891),
    [anon_sym_TILDE] = ACTIONS(8891),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3107] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5679),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(3118),
    [sym_call] = STATE(3118),
    [sym_method_call] = STATE(3122),
    [sym_assignment] = STATE(5679),
    [sym_operator_assignment] = STATE(5679),
    [sym_conditional] = STATE(5679),
    [sym_range] = STATE(5679),
    [sym_binary] = STATE(5679),
    [sym_unary] = STATE(5679),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(3118),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5680),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5193),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5197),
    [anon_sym_yield] = ACTIONS(5199),
    [anon_sym_break] = ACTIONS(5201),
    [anon_sym_next] = ACTIONS(5203),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8893),
    [anon_sym_defined_QMARK] = ACTIONS(5205),
    [anon_sym_not] = ACTIONS(5207),
    [anon_sym_BANG] = ACTIONS(5211),
    [anon_sym_TILDE] = ACTIONS(5211),
    [sym_constant] = ACTIONS(5217),
    [sym_identifier] = ACTIONS(5217),
    [sym_instance_variable] = ACTIONS(5215),
    [sym_class_variable] = ACTIONS(5215),
    [sym_global_variable] = ACTIONS(5215),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5217),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5217),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3108] = {
    [anon_sym_COLON] = ACTIONS(8895),
    [sym_comment] = ACTIONS(87),
  },
  [3109] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5682),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5676),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(5676),
    [sym_assignment] = STATE(5682),
    [sym_operator_assignment] = STATE(5682),
    [sym_conditional] = STATE(5682),
    [sym_range] = STATE(5682),
    [sym_binary] = STATE(5682),
    [sym_unary] = STATE(5682),
    [sym_left_assignment_list] = STATE(5675),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5676),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5676),
    [sym_false] = STATE(5676),
    [sym_nil] = STATE(5676),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5677),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8875),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8877),
    [anon_sym_yield] = ACTIONS(8879),
    [anon_sym_break] = ACTIONS(8881),
    [anon_sym_next] = ACTIONS(8883),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8885),
    [anon_sym_defined_QMARK] = ACTIONS(8887),
    [anon_sym_not] = ACTIONS(8889),
    [anon_sym_BANG] = ACTIONS(8891),
    [anon_sym_TILDE] = ACTIONS(8891),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3110] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5688),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(3118),
    [sym_call] = STATE(3118),
    [sym_method_call] = STATE(3122),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(5689),
    [sym__argument] = STATE(5690),
    [sym_splat_argument] = STATE(5690),
    [sym_hash_splat_argument] = STATE(5690),
    [sym_block_argument] = STATE(5690),
    [sym_assignment] = STATE(5688),
    [sym_operator_assignment] = STATE(5688),
    [sym_conditional] = STATE(5688),
    [sym_range] = STATE(5688),
    [sym_binary] = STATE(5688),
    [sym_unary] = STATE(5688),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(3118),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5691),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5690),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(8897),
    [sym__splat_star] = ACTIONS(8899),
    [sym__unary_minus] = ACTIONS(5193),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(8901),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(5197),
    [anon_sym_yield] = ACTIONS(5199),
    [anon_sym_break] = ACTIONS(5201),
    [anon_sym_next] = ACTIONS(5203),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(377),
    [anon_sym_EQ_GT] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(5205),
    [anon_sym_not] = ACTIONS(5207),
    [anon_sym_BANG] = ACTIONS(5209),
    [anon_sym_TILDE] = ACTIONS(5211),
    [sym_constant] = ACTIONS(8903),
    [sym_identifier] = ACTIONS(8903),
    [sym_instance_variable] = ACTIONS(5215),
    [sym_class_variable] = ACTIONS(5215),
    [sym_global_variable] = ACTIONS(5215),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5217),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5217),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3111] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5688),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(3118),
    [sym_call] = STATE(3118),
    [sym_method_call] = STATE(3122),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(5689),
    [sym__argument] = STATE(5690),
    [sym_splat_argument] = STATE(5690),
    [sym_hash_splat_argument] = STATE(5690),
    [sym_block_argument] = STATE(5690),
    [sym_assignment] = STATE(5688),
    [sym_operator_assignment] = STATE(5688),
    [sym_conditional] = STATE(5688),
    [sym_range] = STATE(5688),
    [sym_binary] = STATE(5688),
    [sym_unary] = STATE(5688),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(3118),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5691),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5690),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(8897),
    [sym__splat_star] = ACTIONS(8899),
    [sym__unary_minus] = ACTIONS(5193),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(8901),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(5197),
    [anon_sym_yield] = ACTIONS(5199),
    [anon_sym_break] = ACTIONS(5201),
    [anon_sym_next] = ACTIONS(5203),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(419),
    [anon_sym_EQ_GT] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(5205),
    [anon_sym_not] = ACTIONS(5207),
    [anon_sym_BANG] = ACTIONS(5209),
    [anon_sym_TILDE] = ACTIONS(5211),
    [sym_constant] = ACTIONS(8903),
    [sym_identifier] = ACTIONS(8903),
    [sym_instance_variable] = ACTIONS(5215),
    [sym_class_variable] = ACTIONS(5215),
    [sym_global_variable] = ACTIONS(5215),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5217),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5217),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3112] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5688),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(3118),
    [sym_call] = STATE(3118),
    [sym_method_call] = STATE(3122),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(5689),
    [sym__argument] = STATE(5690),
    [sym_splat_argument] = STATE(5690),
    [sym_hash_splat_argument] = STATE(5690),
    [sym_block_argument] = STATE(5690),
    [sym_assignment] = STATE(5688),
    [sym_operator_assignment] = STATE(5688),
    [sym_conditional] = STATE(5688),
    [sym_range] = STATE(5688),
    [sym_binary] = STATE(5688),
    [sym_unary] = STATE(5688),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(3118),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5691),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5690),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(8897),
    [sym__splat_star] = ACTIONS(8899),
    [sym__unary_minus] = ACTIONS(5193),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(8901),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(423),
    [anon_sym_return] = ACTIONS(5197),
    [anon_sym_yield] = ACTIONS(5199),
    [anon_sym_break] = ACTIONS(5201),
    [anon_sym_next] = ACTIONS(5203),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(423),
    [anon_sym_EQ_GT] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(5205),
    [anon_sym_not] = ACTIONS(5207),
    [anon_sym_BANG] = ACTIONS(5209),
    [anon_sym_TILDE] = ACTIONS(5211),
    [sym_constant] = ACTIONS(8903),
    [sym_identifier] = ACTIONS(8903),
    [sym_instance_variable] = ACTIONS(5215),
    [sym_class_variable] = ACTIONS(5215),
    [sym_global_variable] = ACTIONS(5215),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5217),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5217),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3113] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5688),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(3118),
    [sym_call] = STATE(3118),
    [sym_method_call] = STATE(3122),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(5689),
    [sym__argument] = STATE(5690),
    [sym_splat_argument] = STATE(5690),
    [sym_hash_splat_argument] = STATE(5690),
    [sym_block_argument] = STATE(5690),
    [sym_assignment] = STATE(5688),
    [sym_operator_assignment] = STATE(5688),
    [sym_conditional] = STATE(5688),
    [sym_range] = STATE(5688),
    [sym_binary] = STATE(5688),
    [sym_unary] = STATE(5688),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(3118),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5691),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5690),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(8897),
    [sym__splat_star] = ACTIONS(8899),
    [sym__unary_minus] = ACTIONS(5193),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(8901),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(427),
    [anon_sym_return] = ACTIONS(5197),
    [anon_sym_yield] = ACTIONS(5199),
    [anon_sym_break] = ACTIONS(5201),
    [anon_sym_next] = ACTIONS(5203),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(427),
    [anon_sym_EQ_GT] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(5205),
    [anon_sym_not] = ACTIONS(5207),
    [anon_sym_BANG] = ACTIONS(5209),
    [anon_sym_TILDE] = ACTIONS(5211),
    [sym_constant] = ACTIONS(8903),
    [sym_identifier] = ACTIONS(8903),
    [sym_instance_variable] = ACTIONS(5215),
    [sym_class_variable] = ACTIONS(5215),
    [sym_global_variable] = ACTIONS(5215),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5217),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5217),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3114] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5692),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(3118),
    [sym_call] = STATE(3118),
    [sym_method_call] = STATE(3122),
    [sym_assignment] = STATE(5692),
    [sym_operator_assignment] = STATE(5692),
    [sym_conditional] = STATE(5692),
    [sym_range] = STATE(5692),
    [sym_binary] = STATE(5692),
    [sym_unary] = STATE(5692),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(3118),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5680),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5193),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5197),
    [anon_sym_yield] = ACTIONS(5199),
    [anon_sym_break] = ACTIONS(5201),
    [anon_sym_next] = ACTIONS(5203),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8893),
    [anon_sym_defined_QMARK] = ACTIONS(5205),
    [anon_sym_not] = ACTIONS(5207),
    [anon_sym_BANG] = ACTIONS(5211),
    [anon_sym_TILDE] = ACTIONS(5211),
    [sym_constant] = ACTIONS(5217),
    [sym_identifier] = ACTIONS(5217),
    [sym_instance_variable] = ACTIONS(5215),
    [sym_class_variable] = ACTIONS(5215),
    [sym_global_variable] = ACTIONS(5215),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5217),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5217),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3115] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(3118),
    [sym_call] = STATE(3118),
    [sym_method_call] = STATE(3122),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(3118),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5680),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5193),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5197),
    [anon_sym_yield] = ACTIONS(5199),
    [anon_sym_break] = ACTIONS(5201),
    [anon_sym_next] = ACTIONS(5203),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8893),
    [anon_sym_defined_QMARK] = ACTIONS(5205),
    [anon_sym_not] = ACTIONS(5207),
    [anon_sym_BANG] = ACTIONS(5211),
    [anon_sym_TILDE] = ACTIONS(5211),
    [sym_constant] = ACTIONS(5217),
    [sym_identifier] = ACTIONS(5217),
    [sym_instance_variable] = ACTIONS(5215),
    [sym_class_variable] = ACTIONS(5215),
    [sym_global_variable] = ACTIONS(5215),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5217),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5217),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3116] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(8905),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_ensure] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [3117] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(8907),
    [sym__binary_star] = ACTIONS(8909),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(8911),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(8909),
    [anon_sym_AMP] = ACTIONS(8913),
    [anon_sym_LT] = ACTIONS(8915),
    [anon_sym_end] = ACTIONS(1625),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_unless] = ACTIONS(1625),
    [anon_sym_while] = ACTIONS(1625),
    [anon_sym_until] = ACTIONS(1625),
    [anon_sym_rescue] = ACTIONS(1625),
    [anon_sym_ensure] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(8895),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(8917),
    [anon_sym_DOT_DOT] = ACTIONS(8919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8921),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(8923),
    [anon_sym_AMP_AMP] = ACTIONS(8923),
    [anon_sym_LT_LT] = ACTIONS(8925),
    [anon_sym_GT_GT] = ACTIONS(8925),
    [anon_sym_EQ_EQ] = ACTIONS(8927),
    [anon_sym_BANG_EQ] = ACTIONS(8923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8923),
    [anon_sym_LT_EQ_GT] = ACTIONS(8923),
    [anon_sym_EQ_TILDE] = ACTIONS(8923),
    [anon_sym_BANG_TILDE] = ACTIONS(8923),
    [anon_sym_LT_EQ] = ACTIONS(8915),
    [anon_sym_GT] = ACTIONS(8915),
    [anon_sym_GT_EQ] = ACTIONS(8929),
    [anon_sym_CARET] = ACTIONS(8931),
    [anon_sym_PLUS] = ACTIONS(8907),
    [anon_sym_SLASH] = ACTIONS(8909),
    [anon_sym_PERCENT] = ACTIONS(8909),
    [sym_comment] = ACTIONS(87),
  },
  [3118] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5709),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3158),
    [sym_scope_resolution] = STATE(3154),
    [sym_call] = STATE(3154),
    [sym_method_call] = STATE(3158),
    [sym_argument_list] = STATE(938),
    [sym__argument_list_with_parens] = STATE(5710),
    [sym__argument] = STATE(5711),
    [sym_splat_argument] = STATE(5711),
    [sym_hash_splat_argument] = STATE(5711),
    [sym_block_argument] = STATE(5711),
    [sym_do_block] = STATE(941),
    [sym_block] = STATE(941),
    [sym_assignment] = STATE(5709),
    [sym_operator_assignment] = STATE(5709),
    [sym_conditional] = STATE(5709),
    [sym_range] = STATE(5709),
    [sym_binary] = STATE(5709),
    [sym_unary] = STATE(5709),
    [sym_left_assignment_list] = STATE(3157),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3158),
    [sym__variable] = STATE(3154),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3158),
    [sym_false] = STATE(3158),
    [sym_nil] = STATE(3158),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5712),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(5711),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(743),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(8933),
    [sym__splat_star] = ACTIONS(8935),
    [sym__unary_minus] = ACTIONS(5265),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(8937),
    [anon_sym_LBRACE] = ACTIONS(1669),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(769),
    [anon_sym_return] = ACTIONS(5269),
    [anon_sym_yield] = ACTIONS(5271),
    [anon_sym_break] = ACTIONS(5273),
    [anon_sym_next] = ACTIONS(5275),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(769),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(769),
    [anon_sym_until] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(769),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(1671),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_ensure] = ACTIONS(769),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(5277),
    [anon_sym_not] = ACTIONS(5279),
    [anon_sym_BANG] = ACTIONS(5281),
    [anon_sym_TILDE] = ACTIONS(5283),
    [sym_constant] = ACTIONS(8939),
    [sym_identifier] = ACTIONS(8939),
    [sym_instance_variable] = ACTIONS(5287),
    [sym_class_variable] = ACTIONS(5287),
    [sym_global_variable] = ACTIONS(5287),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5289),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5289),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3119] = {
    [sym_heredoc_body] = STATE(5713),
    [aux_sym_call_repeat1] = STATE(5713),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_ensure] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [3120] = {
    [sym_heredoc_body] = STATE(5713),
    [aux_sym_call_repeat1] = STATE(5713),
    [aux_sym_argument_list_repeat1] = STATE(5715),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(8941),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_ensure] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [3121] = {
    [anon_sym_EQ] = ACTIONS(8943),
    [sym_comment] = ACTIONS(87),
  },
  [3122] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(8945),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(8947),
    [anon_sym_DASH_EQ] = ACTIONS(8947),
    [anon_sym_STAR_EQ] = ACTIONS(8947),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8947),
    [anon_sym_SLASH_EQ] = ACTIONS(8947),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8947),
    [anon_sym_PIPE_EQ] = ACTIONS(8947),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8947),
    [anon_sym_AMP_EQ] = ACTIONS(8947),
    [anon_sym_PERCENT_EQ] = ACTIONS(8947),
    [anon_sym_GT_GT_EQ] = ACTIONS(8947),
    [anon_sym_LT_LT_EQ] = ACTIONS(8947),
    [anon_sym_CARET_EQ] = ACTIONS(8947),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3123] = {
    [sym_string] = STATE(5718),
    [aux_sym_chained_string_repeat1] = STATE(5718),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(8949),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [3124] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(5233),
    [sym__binary_star] = ACTIONS(5235),
    [anon_sym_PIPE] = ACTIONS(5237),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(5235),
    [anon_sym_AMP] = ACTIONS(5239),
    [anon_sym_LT] = ACTIONS(5241),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_ensure] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(5243),
    [anon_sym_DOT_DOT] = ACTIONS(5245),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5247),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(5251),
    [anon_sym_AMP_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5253),
    [anon_sym_GT_GT] = ACTIONS(5253),
    [anon_sym_EQ_EQ] = ACTIONS(5255),
    [anon_sym_BANG_EQ] = ACTIONS(5251),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5251),
    [anon_sym_LT_EQ_GT] = ACTIONS(5251),
    [anon_sym_EQ_TILDE] = ACTIONS(5251),
    [anon_sym_BANG_TILDE] = ACTIONS(5251),
    [anon_sym_LT_EQ] = ACTIONS(5241),
    [anon_sym_GT] = ACTIONS(5241),
    [anon_sym_GT_EQ] = ACTIONS(5257),
    [anon_sym_CARET] = ACTIONS(5259),
    [anon_sym_PLUS] = ACTIONS(5233),
    [anon_sym_SLASH] = ACTIONS(5235),
    [anon_sym_PERCENT] = ACTIONS(5235),
    [sym_comment] = ACTIONS(87),
  },
  [3125] = {
    [aux_sym_undef_repeat1] = STATE(5719),
    [sym__line_break] = ACTIONS(2251),
    [sym__heredoc_body_start] = ACTIONS(2251),
    [anon_sym_COMMA] = ACTIONS(2253),
    [anon_sym_SEMI] = ACTIONS(2251),
    [anon_sym_end] = ACTIONS(2251),
    [anon_sym_if] = ACTIONS(2251),
    [anon_sym_unless] = ACTIONS(2251),
    [anon_sym_while] = ACTIONS(2251),
    [anon_sym_until] = ACTIONS(2251),
    [anon_sym_rescue] = ACTIONS(2251),
    [anon_sym_ensure] = ACTIONS(2251),
    [sym_comment] = ACTIONS(87),
  },
  [3126] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5720),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1191),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(1191),
    [sym_assignment] = STATE(5720),
    [sym_operator_assignment] = STATE(5720),
    [sym_conditional] = STATE(5720),
    [sym_range] = STATE(5720),
    [sym_binary] = STATE(5720),
    [sym_unary] = STATE(5720),
    [sym_left_assignment_list] = STATE(1190),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1191),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1191),
    [sym_false] = STATE(1191),
    [sym_nil] = STATE(1191),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1192),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2113),
    [anon_sym_yield] = ACTIONS(2115),
    [anon_sym_break] = ACTIONS(2117),
    [anon_sym_next] = ACTIONS(2119),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_defined_QMARK] = ACTIONS(2123),
    [anon_sym_not] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2127),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3127] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5721),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1191),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(1191),
    [sym_assignment] = STATE(5721),
    [sym_operator_assignment] = STATE(5721),
    [sym_conditional] = STATE(5721),
    [sym_range] = STATE(5721),
    [sym_binary] = STATE(5721),
    [sym_unary] = STATE(5721),
    [sym_left_assignment_list] = STATE(1190),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1191),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1191),
    [sym_false] = STATE(1191),
    [sym_nil] = STATE(1191),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1192),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2113),
    [anon_sym_yield] = ACTIONS(2115),
    [anon_sym_break] = ACTIONS(2117),
    [anon_sym_next] = ACTIONS(2119),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_defined_QMARK] = ACTIONS(2123),
    [anon_sym_not] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2127),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3128] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5722),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1191),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(1191),
    [sym_assignment] = STATE(5722),
    [sym_operator_assignment] = STATE(5722),
    [sym_conditional] = STATE(5722),
    [sym_range] = STATE(5722),
    [sym_binary] = STATE(5722),
    [sym_unary] = STATE(5722),
    [sym_left_assignment_list] = STATE(1190),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1191),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1191),
    [sym_false] = STATE(1191),
    [sym_nil] = STATE(1191),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1192),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2113),
    [anon_sym_yield] = ACTIONS(2115),
    [anon_sym_break] = ACTIONS(2117),
    [anon_sym_next] = ACTIONS(2119),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_defined_QMARK] = ACTIONS(2123),
    [anon_sym_not] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2127),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3129] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5723),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1191),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(1191),
    [sym_assignment] = STATE(5723),
    [sym_operator_assignment] = STATE(5723),
    [sym_conditional] = STATE(5723),
    [sym_range] = STATE(5723),
    [sym_binary] = STATE(5723),
    [sym_unary] = STATE(5723),
    [sym_left_assignment_list] = STATE(1190),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1191),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1191),
    [sym_false] = STATE(1191),
    [sym_nil] = STATE(1191),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1192),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2113),
    [anon_sym_yield] = ACTIONS(2115),
    [anon_sym_break] = ACTIONS(2117),
    [anon_sym_next] = ACTIONS(2119),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_defined_QMARK] = ACTIONS(2123),
    [anon_sym_not] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2127),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3130] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5724),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1191),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(1191),
    [sym_assignment] = STATE(5724),
    [sym_operator_assignment] = STATE(5724),
    [sym_conditional] = STATE(5724),
    [sym_range] = STATE(5724),
    [sym_binary] = STATE(5724),
    [sym_unary] = STATE(5724),
    [sym_left_assignment_list] = STATE(1190),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1191),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1191),
    [sym_false] = STATE(1191),
    [sym_nil] = STATE(1191),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1192),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2113),
    [anon_sym_yield] = ACTIONS(2115),
    [anon_sym_break] = ACTIONS(2117),
    [anon_sym_next] = ACTIONS(2119),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_defined_QMARK] = ACTIONS(2123),
    [anon_sym_not] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2127),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3131] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5725),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1191),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(1191),
    [sym_assignment] = STATE(5725),
    [sym_operator_assignment] = STATE(5725),
    [sym_conditional] = STATE(5725),
    [sym_range] = STATE(5725),
    [sym_binary] = STATE(5725),
    [sym_unary] = STATE(5725),
    [sym_left_assignment_list] = STATE(1190),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1191),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1191),
    [sym_false] = STATE(1191),
    [sym_nil] = STATE(1191),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1192),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2113),
    [anon_sym_yield] = ACTIONS(2115),
    [anon_sym_break] = ACTIONS(2117),
    [anon_sym_next] = ACTIONS(2119),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_defined_QMARK] = ACTIONS(2123),
    [anon_sym_not] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2127),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3132] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5726),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1191),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(1191),
    [sym_assignment] = STATE(5726),
    [sym_operator_assignment] = STATE(5726),
    [sym_conditional] = STATE(5726),
    [sym_range] = STATE(5726),
    [sym_binary] = STATE(5726),
    [sym_unary] = STATE(5726),
    [sym_left_assignment_list] = STATE(1190),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1191),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1191),
    [sym_false] = STATE(1191),
    [sym_nil] = STATE(1191),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1192),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2113),
    [anon_sym_yield] = ACTIONS(2115),
    [anon_sym_break] = ACTIONS(2117),
    [anon_sym_next] = ACTIONS(2119),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_defined_QMARK] = ACTIONS(2123),
    [anon_sym_not] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2127),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3133] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5727),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1191),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(1191),
    [sym_assignment] = STATE(5727),
    [sym_operator_assignment] = STATE(5727),
    [sym_conditional] = STATE(5727),
    [sym_range] = STATE(5727),
    [sym_binary] = STATE(5727),
    [sym_unary] = STATE(5727),
    [sym_left_assignment_list] = STATE(1190),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1191),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1191),
    [sym_false] = STATE(1191),
    [sym_nil] = STATE(1191),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1192),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2113),
    [anon_sym_yield] = ACTIONS(2115),
    [anon_sym_break] = ACTIONS(2117),
    [anon_sym_next] = ACTIONS(2119),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_defined_QMARK] = ACTIONS(2123),
    [anon_sym_not] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2127),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3134] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5728),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1191),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(1191),
    [sym_assignment] = STATE(5728),
    [sym_operator_assignment] = STATE(5728),
    [sym_conditional] = STATE(5728),
    [sym_range] = STATE(5728),
    [sym_binary] = STATE(5728),
    [sym_unary] = STATE(5728),
    [sym_left_assignment_list] = STATE(1190),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1191),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1191),
    [sym_false] = STATE(1191),
    [sym_nil] = STATE(1191),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1192),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2113),
    [anon_sym_yield] = ACTIONS(2115),
    [anon_sym_break] = ACTIONS(2117),
    [anon_sym_next] = ACTIONS(2119),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_defined_QMARK] = ACTIONS(2123),
    [anon_sym_not] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2127),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3135] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5729),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1191),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(1191),
    [sym_assignment] = STATE(5729),
    [sym_operator_assignment] = STATE(5729),
    [sym_conditional] = STATE(5729),
    [sym_range] = STATE(5729),
    [sym_binary] = STATE(5729),
    [sym_unary] = STATE(5729),
    [sym_left_assignment_list] = STATE(1190),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1191),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1191),
    [sym_false] = STATE(1191),
    [sym_nil] = STATE(1191),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1192),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2113),
    [anon_sym_yield] = ACTIONS(2115),
    [anon_sym_break] = ACTIONS(2117),
    [anon_sym_next] = ACTIONS(2119),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_defined_QMARK] = ACTIONS(2123),
    [anon_sym_not] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2127),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3136] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(5730),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(5730),
    [sym_operator_assignment] = STATE(5730),
    [sym_conditional] = STATE(5730),
    [sym_range] = STATE(5730),
    [sym_binary] = STATE(5730),
    [sym_unary] = STATE(5730),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3137] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5731),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1191),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(1191),
    [sym_assignment] = STATE(5731),
    [sym_operator_assignment] = STATE(5731),
    [sym_conditional] = STATE(5731),
    [sym_range] = STATE(5731),
    [sym_binary] = STATE(5731),
    [sym_unary] = STATE(5731),
    [sym_left_assignment_list] = STATE(1190),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1191),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1191),
    [sym_false] = STATE(1191),
    [sym_nil] = STATE(1191),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1192),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2113),
    [anon_sym_yield] = ACTIONS(2115),
    [anon_sym_break] = ACTIONS(2117),
    [anon_sym_next] = ACTIONS(2119),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_defined_QMARK] = ACTIONS(2123),
    [anon_sym_not] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2127),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3138] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5732),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1191),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(1191),
    [sym_assignment] = STATE(5732),
    [sym_operator_assignment] = STATE(5732),
    [sym_conditional] = STATE(5732),
    [sym_range] = STATE(5732),
    [sym_binary] = STATE(5732),
    [sym_unary] = STATE(5732),
    [sym_left_assignment_list] = STATE(1190),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1191),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1191),
    [sym_false] = STATE(1191),
    [sym_nil] = STATE(1191),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1192),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2113),
    [anon_sym_yield] = ACTIONS(2115),
    [anon_sym_break] = ACTIONS(2117),
    [anon_sym_next] = ACTIONS(2119),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_defined_QMARK] = ACTIONS(2123),
    [anon_sym_not] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2127),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3139] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5733),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1191),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(1191),
    [sym_assignment] = STATE(5733),
    [sym_operator_assignment] = STATE(5733),
    [sym_conditional] = STATE(5733),
    [sym_range] = STATE(5733),
    [sym_binary] = STATE(5733),
    [sym_unary] = STATE(5733),
    [sym_left_assignment_list] = STATE(1190),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1191),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1191),
    [sym_false] = STATE(1191),
    [sym_nil] = STATE(1191),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1192),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2113),
    [anon_sym_yield] = ACTIONS(2115),
    [anon_sym_break] = ACTIONS(2117),
    [anon_sym_next] = ACTIONS(2119),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_defined_QMARK] = ACTIONS(2123),
    [anon_sym_not] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2127),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3140] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5734),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1191),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(1191),
    [sym_assignment] = STATE(5734),
    [sym_operator_assignment] = STATE(5734),
    [sym_conditional] = STATE(5734),
    [sym_range] = STATE(5734),
    [sym_binary] = STATE(5734),
    [sym_unary] = STATE(5734),
    [sym_left_assignment_list] = STATE(1190),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1191),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1191),
    [sym_false] = STATE(1191),
    [sym_nil] = STATE(1191),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1192),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2113),
    [anon_sym_yield] = ACTIONS(2115),
    [anon_sym_break] = ACTIONS(2117),
    [anon_sym_next] = ACTIONS(2119),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_defined_QMARK] = ACTIONS(2123),
    [anon_sym_not] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2127),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3141] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(5742),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(5745),
    [sym_scope_resolution] = STATE(5743),
    [sym_call] = STATE(5743),
    [sym_method_call] = STATE(5745),
    [sym_assignment] = STATE(5742),
    [sym_operator_assignment] = STATE(5742),
    [sym_conditional] = STATE(5742),
    [sym_range] = STATE(5742),
    [sym_binary] = STATE(5742),
    [sym_unary] = STATE(5742),
    [sym_left_assignment_list] = STATE(5744),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5745),
    [sym__variable] = STATE(5743),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(5745),
    [sym_false] = STATE(5745),
    [sym_nil] = STATE(5745),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(5746),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(8951),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(8953),
    [anon_sym_yield] = ACTIONS(8955),
    [anon_sym_break] = ACTIONS(8957),
    [anon_sym_next] = ACTIONS(8959),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(8961),
    [anon_sym_defined_QMARK] = ACTIONS(8963),
    [anon_sym_not] = ACTIONS(8965),
    [anon_sym_BANG] = ACTIONS(8967),
    [anon_sym_TILDE] = ACTIONS(8967),
    [sym_constant] = ACTIONS(8969),
    [sym_identifier] = ACTIONS(8969),
    [sym_instance_variable] = ACTIONS(8971),
    [sym_class_variable] = ACTIONS(8971),
    [sym_global_variable] = ACTIONS(8971),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(8969),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8969),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [3142] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(5747),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(5745),
    [sym_scope_resolution] = STATE(5743),
    [sym_call] = STATE(5743),
    [sym_method_call] = STATE(5745),
    [sym_assignment] = STATE(5747),
    [sym_operator_assignment] = STATE(5747),
    [sym_conditional] = STATE(5747),
    [sym_range] = STATE(5747),
    [sym_binary] = STATE(5747),
    [sym_unary] = STATE(5747),
    [sym_left_assignment_list] = STATE(5744),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5745),
    [sym__variable] = STATE(5743),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(5745),
    [sym_false] = STATE(5745),
    [sym_nil] = STATE(5745),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(5746),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(8951),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(8953),
    [anon_sym_yield] = ACTIONS(8955),
    [anon_sym_break] = ACTIONS(8957),
    [anon_sym_next] = ACTIONS(8959),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(8961),
    [anon_sym_defined_QMARK] = ACTIONS(8963),
    [anon_sym_not] = ACTIONS(8965),
    [anon_sym_BANG] = ACTIONS(8967),
    [anon_sym_TILDE] = ACTIONS(8967),
    [sym_constant] = ACTIONS(8969),
    [sym_identifier] = ACTIONS(8969),
    [sym_instance_variable] = ACTIONS(8971),
    [sym_class_variable] = ACTIONS(8971),
    [sym_global_variable] = ACTIONS(8971),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(8969),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8969),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [3143] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5748),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3158),
    [sym_scope_resolution] = STATE(3154),
    [sym_call] = STATE(3154),
    [sym_method_call] = STATE(3158),
    [sym_assignment] = STATE(5748),
    [sym_operator_assignment] = STATE(5748),
    [sym_conditional] = STATE(5748),
    [sym_range] = STATE(5748),
    [sym_binary] = STATE(5748),
    [sym_unary] = STATE(5748),
    [sym_left_assignment_list] = STATE(3157),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3158),
    [sym__variable] = STATE(3154),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3158),
    [sym_false] = STATE(3158),
    [sym_nil] = STATE(3158),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5749),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5265),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5269),
    [anon_sym_yield] = ACTIONS(5271),
    [anon_sym_break] = ACTIONS(5273),
    [anon_sym_next] = ACTIONS(5275),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(8973),
    [anon_sym_defined_QMARK] = ACTIONS(5277),
    [anon_sym_not] = ACTIONS(5279),
    [anon_sym_BANG] = ACTIONS(5283),
    [anon_sym_TILDE] = ACTIONS(5283),
    [sym_constant] = ACTIONS(5289),
    [sym_identifier] = ACTIONS(5289),
    [sym_instance_variable] = ACTIONS(5287),
    [sym_class_variable] = ACTIONS(5287),
    [sym_global_variable] = ACTIONS(5287),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5289),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5289),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3144] = {
    [anon_sym_COLON] = ACTIONS(8975),
    [sym_comment] = ACTIONS(87),
  },
  [3145] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(5751),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(5745),
    [sym_scope_resolution] = STATE(5743),
    [sym_call] = STATE(5743),
    [sym_method_call] = STATE(5745),
    [sym_assignment] = STATE(5751),
    [sym_operator_assignment] = STATE(5751),
    [sym_conditional] = STATE(5751),
    [sym_range] = STATE(5751),
    [sym_binary] = STATE(5751),
    [sym_unary] = STATE(5751),
    [sym_left_assignment_list] = STATE(5744),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5745),
    [sym__variable] = STATE(5743),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(5745),
    [sym_false] = STATE(5745),
    [sym_nil] = STATE(5745),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(5746),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(8951),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(8953),
    [anon_sym_yield] = ACTIONS(8955),
    [anon_sym_break] = ACTIONS(8957),
    [anon_sym_next] = ACTIONS(8959),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(8961),
    [anon_sym_defined_QMARK] = ACTIONS(8963),
    [anon_sym_not] = ACTIONS(8965),
    [anon_sym_BANG] = ACTIONS(8967),
    [anon_sym_TILDE] = ACTIONS(8967),
    [sym_constant] = ACTIONS(8969),
    [sym_identifier] = ACTIONS(8969),
    [sym_instance_variable] = ACTIONS(8971),
    [sym_class_variable] = ACTIONS(8971),
    [sym_global_variable] = ACTIONS(8971),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(8969),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8969),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [3146] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5709),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3158),
    [sym_scope_resolution] = STATE(3154),
    [sym_call] = STATE(3154),
    [sym_method_call] = STATE(3158),
    [sym_argument_list] = STATE(1535),
    [sym__argument_list_with_parens] = STATE(5710),
    [sym__argument] = STATE(5711),
    [sym_splat_argument] = STATE(5711),
    [sym_hash_splat_argument] = STATE(5711),
    [sym_block_argument] = STATE(5711),
    [sym_assignment] = STATE(5709),
    [sym_operator_assignment] = STATE(5709),
    [sym_conditional] = STATE(5709),
    [sym_range] = STATE(5709),
    [sym_binary] = STATE(5709),
    [sym_unary] = STATE(5709),
    [sym_left_assignment_list] = STATE(3157),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3158),
    [sym__variable] = STATE(3154),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3158),
    [sym_false] = STATE(3158),
    [sym_nil] = STATE(3158),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5712),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(5711),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(8933),
    [sym__splat_star] = ACTIONS(8935),
    [sym__unary_minus] = ACTIONS(5265),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(8937),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(5269),
    [anon_sym_yield] = ACTIONS(5271),
    [anon_sym_break] = ACTIONS(5273),
    [anon_sym_next] = ACTIONS(5275),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_ensure] = ACTIONS(377),
    [anon_sym_EQ_GT] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(365),
    [anon_sym_DASH_EQ] = ACTIONS(365),
    [anon_sym_STAR_EQ] = ACTIONS(365),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(365),
    [anon_sym_SLASH_EQ] = ACTIONS(365),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(365),
    [anon_sym_PIPE_EQ] = ACTIONS(365),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(365),
    [anon_sym_AMP_EQ] = ACTIONS(365),
    [anon_sym_PERCENT_EQ] = ACTIONS(365),
    [anon_sym_GT_GT_EQ] = ACTIONS(365),
    [anon_sym_LT_LT_EQ] = ACTIONS(365),
    [anon_sym_CARET_EQ] = ACTIONS(365),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_PERCENT] = ACTIONS(377),
    [anon_sym_defined_QMARK] = ACTIONS(5277),
    [anon_sym_not] = ACTIONS(5279),
    [anon_sym_BANG] = ACTIONS(5281),
    [anon_sym_TILDE] = ACTIONS(5283),
    [sym_constant] = ACTIONS(8939),
    [sym_identifier] = ACTIONS(8939),
    [sym_instance_variable] = ACTIONS(5287),
    [sym_class_variable] = ACTIONS(5287),
    [sym_global_variable] = ACTIONS(5287),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5289),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5289),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3147] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5709),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3158),
    [sym_scope_resolution] = STATE(3154),
    [sym_call] = STATE(3154),
    [sym_method_call] = STATE(3158),
    [sym_argument_list] = STATE(1536),
    [sym__argument_list_with_parens] = STATE(5710),
    [sym__argument] = STATE(5711),
    [sym_splat_argument] = STATE(5711),
    [sym_hash_splat_argument] = STATE(5711),
    [sym_block_argument] = STATE(5711),
    [sym_assignment] = STATE(5709),
    [sym_operator_assignment] = STATE(5709),
    [sym_conditional] = STATE(5709),
    [sym_range] = STATE(5709),
    [sym_binary] = STATE(5709),
    [sym_unary] = STATE(5709),
    [sym_left_assignment_list] = STATE(3157),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3158),
    [sym__variable] = STATE(3154),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3158),
    [sym_false] = STATE(3158),
    [sym_nil] = STATE(3158),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5712),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(5711),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(8933),
    [sym__splat_star] = ACTIONS(8935),
    [sym__unary_minus] = ACTIONS(5265),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(8937),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_EQ] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(5269),
    [anon_sym_yield] = ACTIONS(5271),
    [anon_sym_break] = ACTIONS(5273),
    [anon_sym_next] = ACTIONS(5275),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_ensure] = ACTIONS(419),
    [anon_sym_EQ_GT] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(417),
    [anon_sym_DASH_EQ] = ACTIONS(417),
    [anon_sym_STAR_EQ] = ACTIONS(417),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(417),
    [anon_sym_SLASH_EQ] = ACTIONS(417),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(417),
    [anon_sym_PIPE_EQ] = ACTIONS(417),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(417),
    [anon_sym_AMP_EQ] = ACTIONS(417),
    [anon_sym_PERCENT_EQ] = ACTIONS(417),
    [anon_sym_GT_GT_EQ] = ACTIONS(417),
    [anon_sym_LT_LT_EQ] = ACTIONS(417),
    [anon_sym_CARET_EQ] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(5277),
    [anon_sym_not] = ACTIONS(5279),
    [anon_sym_BANG] = ACTIONS(5281),
    [anon_sym_TILDE] = ACTIONS(5283),
    [sym_constant] = ACTIONS(8939),
    [sym_identifier] = ACTIONS(8939),
    [sym_instance_variable] = ACTIONS(5287),
    [sym_class_variable] = ACTIONS(5287),
    [sym_global_variable] = ACTIONS(5287),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5289),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5289),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3148] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5709),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3158),
    [sym_scope_resolution] = STATE(3154),
    [sym_call] = STATE(3154),
    [sym_method_call] = STATE(3158),
    [sym_argument_list] = STATE(1537),
    [sym__argument_list_with_parens] = STATE(5710),
    [sym__argument] = STATE(5711),
    [sym_splat_argument] = STATE(5711),
    [sym_hash_splat_argument] = STATE(5711),
    [sym_block_argument] = STATE(5711),
    [sym_assignment] = STATE(5709),
    [sym_operator_assignment] = STATE(5709),
    [sym_conditional] = STATE(5709),
    [sym_range] = STATE(5709),
    [sym_binary] = STATE(5709),
    [sym_unary] = STATE(5709),
    [sym_left_assignment_list] = STATE(3157),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3158),
    [sym__variable] = STATE(3154),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3158),
    [sym_false] = STATE(3158),
    [sym_nil] = STATE(3158),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5712),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(5711),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(8933),
    [sym__splat_star] = ACTIONS(8935),
    [sym__unary_minus] = ACTIONS(5265),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(8937),
    [anon_sym_LBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_EQ] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(423),
    [anon_sym_return] = ACTIONS(5269),
    [anon_sym_yield] = ACTIONS(5271),
    [anon_sym_break] = ACTIONS(5273),
    [anon_sym_next] = ACTIONS(5275),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_ensure] = ACTIONS(423),
    [anon_sym_EQ_GT] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(421),
    [anon_sym_DASH_EQ] = ACTIONS(421),
    [anon_sym_STAR_EQ] = ACTIONS(421),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(421),
    [anon_sym_SLASH_EQ] = ACTIONS(421),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(421),
    [anon_sym_PIPE_EQ] = ACTIONS(421),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(421),
    [anon_sym_AMP_EQ] = ACTIONS(421),
    [anon_sym_PERCENT_EQ] = ACTIONS(421),
    [anon_sym_GT_GT_EQ] = ACTIONS(421),
    [anon_sym_LT_LT_EQ] = ACTIONS(421),
    [anon_sym_CARET_EQ] = ACTIONS(421),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(5277),
    [anon_sym_not] = ACTIONS(5279),
    [anon_sym_BANG] = ACTIONS(5281),
    [anon_sym_TILDE] = ACTIONS(5283),
    [sym_constant] = ACTIONS(8939),
    [sym_identifier] = ACTIONS(8939),
    [sym_instance_variable] = ACTIONS(5287),
    [sym_class_variable] = ACTIONS(5287),
    [sym_global_variable] = ACTIONS(5287),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5289),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5289),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3149] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5709),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3158),
    [sym_scope_resolution] = STATE(3154),
    [sym_call] = STATE(3154),
    [sym_method_call] = STATE(3158),
    [sym_argument_list] = STATE(1538),
    [sym__argument_list_with_parens] = STATE(5710),
    [sym__argument] = STATE(5711),
    [sym_splat_argument] = STATE(5711),
    [sym_hash_splat_argument] = STATE(5711),
    [sym_block_argument] = STATE(5711),
    [sym_assignment] = STATE(5709),
    [sym_operator_assignment] = STATE(5709),
    [sym_conditional] = STATE(5709),
    [sym_range] = STATE(5709),
    [sym_binary] = STATE(5709),
    [sym_unary] = STATE(5709),
    [sym_left_assignment_list] = STATE(3157),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3158),
    [sym__variable] = STATE(3154),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3158),
    [sym_false] = STATE(3158),
    [sym_nil] = STATE(3158),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5712),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(5711),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(8933),
    [sym__splat_star] = ACTIONS(8935),
    [sym__unary_minus] = ACTIONS(5265),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(8937),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(427),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(427),
    [anon_sym_return] = ACTIONS(5269),
    [anon_sym_yield] = ACTIONS(5271),
    [anon_sym_break] = ACTIONS(5273),
    [anon_sym_next] = ACTIONS(5275),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_ensure] = ACTIONS(427),
    [anon_sym_EQ_GT] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(425),
    [anon_sym_DASH_EQ] = ACTIONS(425),
    [anon_sym_STAR_EQ] = ACTIONS(425),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(425),
    [anon_sym_SLASH_EQ] = ACTIONS(425),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(425),
    [anon_sym_PIPE_EQ] = ACTIONS(425),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(425),
    [anon_sym_AMP_EQ] = ACTIONS(425),
    [anon_sym_PERCENT_EQ] = ACTIONS(425),
    [anon_sym_GT_GT_EQ] = ACTIONS(425),
    [anon_sym_LT_LT_EQ] = ACTIONS(425),
    [anon_sym_CARET_EQ] = ACTIONS(425),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(5277),
    [anon_sym_not] = ACTIONS(5279),
    [anon_sym_BANG] = ACTIONS(5281),
    [anon_sym_TILDE] = ACTIONS(5283),
    [sym_constant] = ACTIONS(8939),
    [sym_identifier] = ACTIONS(8939),
    [sym_instance_variable] = ACTIONS(5287),
    [sym_class_variable] = ACTIONS(5287),
    [sym_global_variable] = ACTIONS(5287),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5289),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5289),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3150] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5752),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3158),
    [sym_scope_resolution] = STATE(3154),
    [sym_call] = STATE(3154),
    [sym_method_call] = STATE(3158),
    [sym_assignment] = STATE(5752),
    [sym_operator_assignment] = STATE(5752),
    [sym_conditional] = STATE(5752),
    [sym_range] = STATE(5752),
    [sym_binary] = STATE(5752),
    [sym_unary] = STATE(5752),
    [sym_left_assignment_list] = STATE(3157),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3158),
    [sym__variable] = STATE(3154),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3158),
    [sym_false] = STATE(3158),
    [sym_nil] = STATE(3158),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5749),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5265),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5269),
    [anon_sym_yield] = ACTIONS(5271),
    [anon_sym_break] = ACTIONS(5273),
    [anon_sym_next] = ACTIONS(5275),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(8973),
    [anon_sym_defined_QMARK] = ACTIONS(5277),
    [anon_sym_not] = ACTIONS(5279),
    [anon_sym_BANG] = ACTIONS(5283),
    [anon_sym_TILDE] = ACTIONS(5283),
    [sym_constant] = ACTIONS(5289),
    [sym_identifier] = ACTIONS(5289),
    [sym_instance_variable] = ACTIONS(5287),
    [sym_class_variable] = ACTIONS(5287),
    [sym_global_variable] = ACTIONS(5287),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5289),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5289),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3151] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(1559),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3158),
    [sym_scope_resolution] = STATE(3154),
    [sym_call] = STATE(3154),
    [sym_method_call] = STATE(3158),
    [sym_assignment] = STATE(1559),
    [sym_operator_assignment] = STATE(1559),
    [sym_conditional] = STATE(1559),
    [sym_range] = STATE(1559),
    [sym_binary] = STATE(1559),
    [sym_unary] = STATE(1559),
    [sym_left_assignment_list] = STATE(3157),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3158),
    [sym__variable] = STATE(3154),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3158),
    [sym_false] = STATE(3158),
    [sym_nil] = STATE(3158),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5749),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5265),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5269),
    [anon_sym_yield] = ACTIONS(5271),
    [anon_sym_break] = ACTIONS(5273),
    [anon_sym_next] = ACTIONS(5275),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(8973),
    [anon_sym_defined_QMARK] = ACTIONS(5277),
    [anon_sym_not] = ACTIONS(5279),
    [anon_sym_BANG] = ACTIONS(5283),
    [anon_sym_TILDE] = ACTIONS(5283),
    [sym_constant] = ACTIONS(5289),
    [sym_identifier] = ACTIONS(5289),
    [sym_instance_variable] = ACTIONS(5287),
    [sym_class_variable] = ACTIONS(5287),
    [sym_global_variable] = ACTIONS(5287),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5289),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5289),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3152] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(8977),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_ensure] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [3153] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(8979),
    [sym__binary_star] = ACTIONS(8981),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(8983),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(8985),
    [anon_sym_AMP] = ACTIONS(8987),
    [anon_sym_EQ] = ACTIONS(1631),
    [anon_sym_LT] = ACTIONS(8989),
    [anon_sym_end] = ACTIONS(1625),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_unless] = ACTIONS(1625),
    [anon_sym_while] = ACTIONS(1625),
    [anon_sym_until] = ACTIONS(1625),
    [anon_sym_rescue] = ACTIONS(1625),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_ensure] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(8975),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_PLUS_EQ] = ACTIONS(1625),
    [anon_sym_DASH_EQ] = ACTIONS(1625),
    [anon_sym_STAR_EQ] = ACTIONS(1625),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1625),
    [anon_sym_SLASH_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1625),
    [anon_sym_AMP_EQ] = ACTIONS(1625),
    [anon_sym_PERCENT_EQ] = ACTIONS(1625),
    [anon_sym_GT_GT_EQ] = ACTIONS(1625),
    [anon_sym_LT_LT_EQ] = ACTIONS(1625),
    [anon_sym_CARET_EQ] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(8991),
    [anon_sym_DOT_DOT] = ACTIONS(8993),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8995),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(8997),
    [anon_sym_AMP_AMP] = ACTIONS(8997),
    [anon_sym_LT_LT] = ACTIONS(8999),
    [anon_sym_GT_GT] = ACTIONS(8999),
    [anon_sym_EQ_EQ] = ACTIONS(8997),
    [anon_sym_BANG_EQ] = ACTIONS(9001),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9001),
    [anon_sym_LT_EQ_GT] = ACTIONS(9001),
    [anon_sym_EQ_TILDE] = ACTIONS(9001),
    [anon_sym_BANG_TILDE] = ACTIONS(9001),
    [anon_sym_LT_EQ] = ACTIONS(8989),
    [anon_sym_GT] = ACTIONS(8989),
    [anon_sym_GT_EQ] = ACTIONS(9003),
    [anon_sym_CARET] = ACTIONS(8983),
    [anon_sym_PLUS] = ACTIONS(9005),
    [anon_sym_SLASH] = ACTIONS(8985),
    [anon_sym_PERCENT] = ACTIONS(8985),
    [sym_comment] = ACTIONS(87),
  },
  [3154] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5709),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3158),
    [sym_scope_resolution] = STATE(3154),
    [sym_call] = STATE(3154),
    [sym_method_call] = STATE(3158),
    [sym_argument_list] = STATE(1578),
    [sym__argument_list_with_parens] = STATE(5710),
    [sym__argument] = STATE(5711),
    [sym_splat_argument] = STATE(5711),
    [sym_hash_splat_argument] = STATE(5711),
    [sym_block_argument] = STATE(5711),
    [sym_do_block] = STATE(941),
    [sym_block] = STATE(941),
    [sym_assignment] = STATE(5709),
    [sym_operator_assignment] = STATE(5709),
    [sym_conditional] = STATE(5709),
    [sym_range] = STATE(5709),
    [sym_binary] = STATE(5709),
    [sym_unary] = STATE(5709),
    [sym_left_assignment_list] = STATE(3157),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3158),
    [sym__variable] = STATE(3154),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3158),
    [sym_false] = STATE(3158),
    [sym_nil] = STATE(3158),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5712),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(5711),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(743),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(8933),
    [sym__splat_star] = ACTIONS(8935),
    [sym__unary_minus] = ACTIONS(5265),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(8937),
    [anon_sym_LBRACE] = ACTIONS(2715),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(769),
    [anon_sym_return] = ACTIONS(5269),
    [anon_sym_yield] = ACTIONS(5271),
    [anon_sym_break] = ACTIONS(5273),
    [anon_sym_next] = ACTIONS(5275),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(769),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(769),
    [anon_sym_until] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(769),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(769),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_ensure] = ACTIONS(769),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(5277),
    [anon_sym_not] = ACTIONS(5279),
    [anon_sym_BANG] = ACTIONS(5281),
    [anon_sym_TILDE] = ACTIONS(5283),
    [sym_constant] = ACTIONS(8939),
    [sym_identifier] = ACTIONS(8939),
    [sym_instance_variable] = ACTIONS(5287),
    [sym_class_variable] = ACTIONS(5287),
    [sym_global_variable] = ACTIONS(5287),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5289),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5289),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3155] = {
    [sym_heredoc_body] = STATE(5764),
    [aux_sym_call_repeat1] = STATE(5764),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_ensure] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [3156] = {
    [sym_heredoc_body] = STATE(5764),
    [aux_sym_call_repeat1] = STATE(5764),
    [aux_sym_argument_list_repeat1] = STATE(5766),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(9007),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_ensure] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [3157] = {
    [anon_sym_EQ] = ACTIONS(9009),
    [sym_comment] = ACTIONS(87),
  },
  [3158] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(9011),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(9013),
    [anon_sym_DASH_EQ] = ACTIONS(9013),
    [anon_sym_STAR_EQ] = ACTIONS(9013),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9013),
    [anon_sym_SLASH_EQ] = ACTIONS(9013),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9013),
    [anon_sym_PIPE_EQ] = ACTIONS(9013),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9013),
    [anon_sym_AMP_EQ] = ACTIONS(9013),
    [anon_sym_PERCENT_EQ] = ACTIONS(9013),
    [anon_sym_GT_GT_EQ] = ACTIONS(9013),
    [anon_sym_LT_LT_EQ] = ACTIONS(9013),
    [anon_sym_CARET_EQ] = ACTIONS(9013),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3159] = {
    [sym_string] = STATE(5769),
    [aux_sym_chained_string_repeat1] = STATE(5769),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(747),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(9015),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3160] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5774),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5777),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(5777),
    [sym_splat_argument] = STATE(5775),
    [sym_assignment] = STATE(5774),
    [sym_operator_assignment] = STATE(5774),
    [sym_conditional] = STATE(5774),
    [sym_range] = STATE(5774),
    [sym_binary] = STATE(5774),
    [sym_unary] = STATE(5774),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(5775),
    [sym_left_assignment_list] = STATE(5776),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5777),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5777),
    [sym_false] = STATE(5777),
    [sym_nil] = STATE(5777),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5677),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(9017),
    [sym__unary_minus] = ACTIONS(9019),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8877),
    [anon_sym_yield] = ACTIONS(8879),
    [anon_sym_break] = ACTIONS(8881),
    [anon_sym_next] = ACTIONS(8883),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9021),
    [anon_sym_defined_QMARK] = ACTIONS(9023),
    [anon_sym_not] = ACTIONS(9025),
    [anon_sym_BANG] = ACTIONS(9027),
    [anon_sym_TILDE] = ACTIONS(9027),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3161] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5778),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1191),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(1191),
    [sym_assignment] = STATE(5778),
    [sym_operator_assignment] = STATE(5778),
    [sym_conditional] = STATE(5778),
    [sym_range] = STATE(5778),
    [sym_binary] = STATE(5778),
    [sym_unary] = STATE(5778),
    [sym_left_assignment_list] = STATE(1190),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1191),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1191),
    [sym_false] = STATE(1191),
    [sym_nil] = STATE(1191),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1192),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2113),
    [anon_sym_yield] = ACTIONS(2115),
    [anon_sym_break] = ACTIONS(2117),
    [anon_sym_next] = ACTIONS(2119),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_defined_QMARK] = ACTIONS(2123),
    [anon_sym_not] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2127),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3162] = {
    [sym_string] = STATE(5779),
    [aux_sym_chained_string_repeat1] = STATE(5779),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_end] = ACTIONS(2753),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_ensure] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [3163] = {
    [anon_sym_end] = ACTIONS(9029),
    [anon_sym_ensure] = ACTIONS(9029),
    [sym_comment] = ACTIONS(87),
  },
  [3164] = {
    [sym_heredoc_body] = STATE(370),
    [sym__terminator] = STATE(370),
    [sym__line_break] = ACTIONS(687),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(687),
    [anon_sym_end] = ACTIONS(2757),
    [anon_sym_if] = ACTIONS(5223),
    [anon_sym_unless] = ACTIONS(5225),
    [anon_sym_while] = ACTIONS(5227),
    [anon_sym_until] = ACTIONS(5229),
    [anon_sym_rescue] = ACTIONS(5231),
    [anon_sym_ensure] = ACTIONS(2757),
    [sym_comment] = ACTIONS(87),
  },
  [3165] = {
    [sym_begin_block] = STATE(1611),
    [sym_end_block] = STATE(1611),
    [sym__statement] = STATE(1611),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1611),
    [sym_unless_modifier] = STATE(1611),
    [sym_while_modifier] = STATE(1611),
    [sym_until_modifier] = STATE(1611),
    [sym_rescue_modifier] = STATE(1611),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1612),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1615),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(1615),
    [sym_assignment] = STATE(1612),
    [sym_operator_assignment] = STATE(1612),
    [sym_conditional] = STATE(1612),
    [sym_range] = STATE(1612),
    [sym_binary] = STATE(1612),
    [sym_unary] = STATE(1612),
    [sym_left_assignment_list] = STATE(1614),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1615),
    [sym__variable] = STATE(1613),
    [sym_undef] = STATE(1611),
    [sym_alias] = STATE(1611),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1615),
    [sym_false] = STATE(1615),
    [sym_nil] = STATE(1615),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1616),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(3165),
    [aux_sym__statements_repeat1] = STATE(3165),
    [sym__simple_symbol] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(2762),
    [sym__symbol_start] = ACTIONS(2765),
    [sym__subshell_start] = ACTIONS(2768),
    [sym__regex_start] = ACTIONS(2771),
    [sym__string_array_start] = ACTIONS(2774),
    [sym__symbol_array_start] = ACTIONS(2777),
    [sym_heredoc_beginning] = ACTIONS(2780),
    [sym__unary_minus] = ACTIONS(2783),
    [anon_sym_BEGIN] = ACTIONS(2786),
    [anon_sym_LBRACE] = ACTIONS(2789),
    [anon_sym_END] = ACTIONS(2792),
    [anon_sym_def] = ACTIONS(2795),
    [anon_sym_LPAREN] = ACTIONS(2798),
    [anon_sym_COLON_COLON] = ACTIONS(2801),
    [anon_sym_SEMI] = ACTIONS(2804),
    [anon_sym_STAR] = ACTIONS(2807),
    [anon_sym_class] = ACTIONS(2810),
    [anon_sym_module] = ACTIONS(2813),
    [anon_sym_end] = ACTIONS(2493),
    [anon_sym_return] = ACTIONS(2816),
    [anon_sym_yield] = ACTIONS(2819),
    [anon_sym_break] = ACTIONS(2822),
    [anon_sym_next] = ACTIONS(2825),
    [sym_redo] = ACTIONS(2828),
    [sym_retry] = ACTIONS(2828),
    [anon_sym_if] = ACTIONS(2831),
    [anon_sym_unless] = ACTIONS(2834),
    [anon_sym_while] = ACTIONS(2837),
    [anon_sym_until] = ACTIONS(2840),
    [anon_sym_for] = ACTIONS(2843),
    [anon_sym_case] = ACTIONS(2846),
    [anon_sym_begin] = ACTIONS(2849),
    [anon_sym_ensure] = ACTIONS(2493),
    [anon_sym_PLUS] = ACTIONS(2852),
    [anon_sym_defined_QMARK] = ACTIONS(2855),
    [anon_sym_not] = ACTIONS(2858),
    [anon_sym_BANG] = ACTIONS(2861),
    [anon_sym_TILDE] = ACTIONS(2861),
    [sym_constant] = ACTIONS(2864),
    [sym_identifier] = ACTIONS(2864),
    [sym_instance_variable] = ACTIONS(2867),
    [sym_class_variable] = ACTIONS(2867),
    [sym_global_variable] = ACTIONS(2867),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_alias] = ACTIONS(2873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2876),
    [sym_float] = ACTIONS(2828),
    [sym_complex] = ACTIONS(2780),
    [sym_super] = ACTIONS(2864),
    [anon_sym_true] = ACTIONS(2879),
    [anon_sym_TRUE] = ACTIONS(2879),
    [anon_sym_false] = ACTIONS(2882),
    [anon_sym_FALSE] = ACTIONS(2882),
    [sym_self] = ACTIONS(2864),
    [anon_sym_nil] = ACTIONS(2885),
    [anon_sym_NIL] = ACTIONS(2885),
    [sym_character] = ACTIONS(2780),
    [anon_sym_LBRACK2] = ACTIONS(2888),
    [anon_sym_DASH_GT] = ACTIONS(2891),
  },
  [3166] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(5345),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [3167] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5787),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5789),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(5789),
    [sym_assignment] = STATE(5787),
    [sym_operator_assignment] = STATE(5787),
    [sym_conditional] = STATE(5787),
    [sym_range] = STATE(5787),
    [sym_binary] = STATE(5787),
    [sym_unary] = STATE(5787),
    [sym_left_assignment_list] = STATE(5788),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5789),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5789),
    [sym_false] = STATE(5789),
    [sym_nil] = STATE(5789),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5790),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9031),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9033),
    [anon_sym_yield] = ACTIONS(9035),
    [anon_sym_break] = ACTIONS(9037),
    [anon_sym_next] = ACTIONS(9039),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9041),
    [anon_sym_defined_QMARK] = ACTIONS(9043),
    [anon_sym_not] = ACTIONS(9045),
    [anon_sym_BANG] = ACTIONS(9047),
    [anon_sym_TILDE] = ACTIONS(9047),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3168] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5791),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5789),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(5789),
    [sym_assignment] = STATE(5791),
    [sym_operator_assignment] = STATE(5791),
    [sym_conditional] = STATE(5791),
    [sym_range] = STATE(5791),
    [sym_binary] = STATE(5791),
    [sym_unary] = STATE(5791),
    [sym_left_assignment_list] = STATE(5788),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5789),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5789),
    [sym_false] = STATE(5789),
    [sym_nil] = STATE(5789),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5790),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9031),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9033),
    [anon_sym_yield] = ACTIONS(9035),
    [anon_sym_break] = ACTIONS(9037),
    [anon_sym_next] = ACTIONS(9039),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9041),
    [anon_sym_defined_QMARK] = ACTIONS(9043),
    [anon_sym_not] = ACTIONS(9045),
    [anon_sym_BANG] = ACTIONS(9047),
    [anon_sym_TILDE] = ACTIONS(9047),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3169] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5792),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3184),
    [sym_scope_resolution] = STATE(3180),
    [sym_call] = STATE(3180),
    [sym_method_call] = STATE(3184),
    [sym_assignment] = STATE(5792),
    [sym_operator_assignment] = STATE(5792),
    [sym_conditional] = STATE(5792),
    [sym_range] = STATE(5792),
    [sym_binary] = STATE(5792),
    [sym_unary] = STATE(5792),
    [sym_left_assignment_list] = STATE(3183),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3184),
    [sym__variable] = STATE(3180),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3184),
    [sym_false] = STATE(3184),
    [sym_nil] = STATE(3184),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5793),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5307),
    [anon_sym_yield] = ACTIONS(5309),
    [anon_sym_break] = ACTIONS(5311),
    [anon_sym_next] = ACTIONS(5313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9049),
    [anon_sym_defined_QMARK] = ACTIONS(5315),
    [anon_sym_not] = ACTIONS(5317),
    [anon_sym_BANG] = ACTIONS(5321),
    [anon_sym_TILDE] = ACTIONS(5321),
    [sym_constant] = ACTIONS(5327),
    [sym_identifier] = ACTIONS(5327),
    [sym_instance_variable] = ACTIONS(5325),
    [sym_class_variable] = ACTIONS(5325),
    [sym_global_variable] = ACTIONS(5325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3170] = {
    [anon_sym_COLON] = ACTIONS(9051),
    [sym_comment] = ACTIONS(87),
  },
  [3171] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5795),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5789),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(5789),
    [sym_assignment] = STATE(5795),
    [sym_operator_assignment] = STATE(5795),
    [sym_conditional] = STATE(5795),
    [sym_range] = STATE(5795),
    [sym_binary] = STATE(5795),
    [sym_unary] = STATE(5795),
    [sym_left_assignment_list] = STATE(5788),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5789),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5789),
    [sym_false] = STATE(5789),
    [sym_nil] = STATE(5789),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5790),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9031),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9033),
    [anon_sym_yield] = ACTIONS(9035),
    [anon_sym_break] = ACTIONS(9037),
    [anon_sym_next] = ACTIONS(9039),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9041),
    [anon_sym_defined_QMARK] = ACTIONS(9043),
    [anon_sym_not] = ACTIONS(9045),
    [anon_sym_BANG] = ACTIONS(9047),
    [anon_sym_TILDE] = ACTIONS(9047),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3172] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5801),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3184),
    [sym_scope_resolution] = STATE(3180),
    [sym_call] = STATE(3180),
    [sym_method_call] = STATE(3184),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(5802),
    [sym__argument] = STATE(5803),
    [sym_splat_argument] = STATE(5803),
    [sym_hash_splat_argument] = STATE(5803),
    [sym_block_argument] = STATE(5803),
    [sym_assignment] = STATE(5801),
    [sym_operator_assignment] = STATE(5801),
    [sym_conditional] = STATE(5801),
    [sym_range] = STATE(5801),
    [sym_binary] = STATE(5801),
    [sym_unary] = STATE(5801),
    [sym_left_assignment_list] = STATE(3183),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3184),
    [sym__variable] = STATE(3180),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3184),
    [sym_false] = STATE(3184),
    [sym_nil] = STATE(3184),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5804),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5803),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(9053),
    [sym__splat_star] = ACTIONS(9055),
    [sym__unary_minus] = ACTIONS(5303),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(9057),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(5307),
    [anon_sym_yield] = ACTIONS(5309),
    [anon_sym_break] = ACTIONS(5311),
    [anon_sym_next] = ACTIONS(5313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(5315),
    [anon_sym_not] = ACTIONS(5317),
    [anon_sym_BANG] = ACTIONS(5319),
    [anon_sym_TILDE] = ACTIONS(5321),
    [sym_constant] = ACTIONS(9059),
    [sym_identifier] = ACTIONS(9059),
    [sym_instance_variable] = ACTIONS(5325),
    [sym_class_variable] = ACTIONS(5325),
    [sym_global_variable] = ACTIONS(5325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3173] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5801),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3184),
    [sym_scope_resolution] = STATE(3180),
    [sym_call] = STATE(3180),
    [sym_method_call] = STATE(3184),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(5802),
    [sym__argument] = STATE(5803),
    [sym_splat_argument] = STATE(5803),
    [sym_hash_splat_argument] = STATE(5803),
    [sym_block_argument] = STATE(5803),
    [sym_assignment] = STATE(5801),
    [sym_operator_assignment] = STATE(5801),
    [sym_conditional] = STATE(5801),
    [sym_range] = STATE(5801),
    [sym_binary] = STATE(5801),
    [sym_unary] = STATE(5801),
    [sym_left_assignment_list] = STATE(3183),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3184),
    [sym__variable] = STATE(3180),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3184),
    [sym_false] = STATE(3184),
    [sym_nil] = STATE(3184),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5804),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5803),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(9053),
    [sym__splat_star] = ACTIONS(9055),
    [sym__unary_minus] = ACTIONS(5303),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(9057),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(5307),
    [anon_sym_yield] = ACTIONS(5309),
    [anon_sym_break] = ACTIONS(5311),
    [anon_sym_next] = ACTIONS(5313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(5315),
    [anon_sym_not] = ACTIONS(5317),
    [anon_sym_BANG] = ACTIONS(5319),
    [anon_sym_TILDE] = ACTIONS(5321),
    [sym_constant] = ACTIONS(9059),
    [sym_identifier] = ACTIONS(9059),
    [sym_instance_variable] = ACTIONS(5325),
    [sym_class_variable] = ACTIONS(5325),
    [sym_global_variable] = ACTIONS(5325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3174] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5801),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3184),
    [sym_scope_resolution] = STATE(3180),
    [sym_call] = STATE(3180),
    [sym_method_call] = STATE(3184),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(5802),
    [sym__argument] = STATE(5803),
    [sym_splat_argument] = STATE(5803),
    [sym_hash_splat_argument] = STATE(5803),
    [sym_block_argument] = STATE(5803),
    [sym_assignment] = STATE(5801),
    [sym_operator_assignment] = STATE(5801),
    [sym_conditional] = STATE(5801),
    [sym_range] = STATE(5801),
    [sym_binary] = STATE(5801),
    [sym_unary] = STATE(5801),
    [sym_left_assignment_list] = STATE(3183),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3184),
    [sym__variable] = STATE(3180),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3184),
    [sym_false] = STATE(3184),
    [sym_nil] = STATE(3184),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5804),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5803),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(9053),
    [sym__splat_star] = ACTIONS(9055),
    [sym__unary_minus] = ACTIONS(5303),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(9057),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(423),
    [anon_sym_return] = ACTIONS(5307),
    [anon_sym_yield] = ACTIONS(5309),
    [anon_sym_break] = ACTIONS(5311),
    [anon_sym_next] = ACTIONS(5313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(5315),
    [anon_sym_not] = ACTIONS(5317),
    [anon_sym_BANG] = ACTIONS(5319),
    [anon_sym_TILDE] = ACTIONS(5321),
    [sym_constant] = ACTIONS(9059),
    [sym_identifier] = ACTIONS(9059),
    [sym_instance_variable] = ACTIONS(5325),
    [sym_class_variable] = ACTIONS(5325),
    [sym_global_variable] = ACTIONS(5325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3175] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5801),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3184),
    [sym_scope_resolution] = STATE(3180),
    [sym_call] = STATE(3180),
    [sym_method_call] = STATE(3184),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(5802),
    [sym__argument] = STATE(5803),
    [sym_splat_argument] = STATE(5803),
    [sym_hash_splat_argument] = STATE(5803),
    [sym_block_argument] = STATE(5803),
    [sym_assignment] = STATE(5801),
    [sym_operator_assignment] = STATE(5801),
    [sym_conditional] = STATE(5801),
    [sym_range] = STATE(5801),
    [sym_binary] = STATE(5801),
    [sym_unary] = STATE(5801),
    [sym_left_assignment_list] = STATE(3183),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3184),
    [sym__variable] = STATE(3180),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3184),
    [sym_false] = STATE(3184),
    [sym_nil] = STATE(3184),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5804),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5803),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(9053),
    [sym__splat_star] = ACTIONS(9055),
    [sym__unary_minus] = ACTIONS(5303),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(9057),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(427),
    [anon_sym_return] = ACTIONS(5307),
    [anon_sym_yield] = ACTIONS(5309),
    [anon_sym_break] = ACTIONS(5311),
    [anon_sym_next] = ACTIONS(5313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(5315),
    [anon_sym_not] = ACTIONS(5317),
    [anon_sym_BANG] = ACTIONS(5319),
    [anon_sym_TILDE] = ACTIONS(5321),
    [sym_constant] = ACTIONS(9059),
    [sym_identifier] = ACTIONS(9059),
    [sym_instance_variable] = ACTIONS(5325),
    [sym_class_variable] = ACTIONS(5325),
    [sym_global_variable] = ACTIONS(5325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3176] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5805),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3184),
    [sym_scope_resolution] = STATE(3180),
    [sym_call] = STATE(3180),
    [sym_method_call] = STATE(3184),
    [sym_assignment] = STATE(5805),
    [sym_operator_assignment] = STATE(5805),
    [sym_conditional] = STATE(5805),
    [sym_range] = STATE(5805),
    [sym_binary] = STATE(5805),
    [sym_unary] = STATE(5805),
    [sym_left_assignment_list] = STATE(3183),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3184),
    [sym__variable] = STATE(3180),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3184),
    [sym_false] = STATE(3184),
    [sym_nil] = STATE(3184),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5793),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5307),
    [anon_sym_yield] = ACTIONS(5309),
    [anon_sym_break] = ACTIONS(5311),
    [anon_sym_next] = ACTIONS(5313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9049),
    [anon_sym_defined_QMARK] = ACTIONS(5315),
    [anon_sym_not] = ACTIONS(5317),
    [anon_sym_BANG] = ACTIONS(5321),
    [anon_sym_TILDE] = ACTIONS(5321),
    [sym_constant] = ACTIONS(5327),
    [sym_identifier] = ACTIONS(5327),
    [sym_instance_variable] = ACTIONS(5325),
    [sym_class_variable] = ACTIONS(5325),
    [sym_global_variable] = ACTIONS(5325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3177] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3184),
    [sym_scope_resolution] = STATE(3180),
    [sym_call] = STATE(3180),
    [sym_method_call] = STATE(3184),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(3183),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3184),
    [sym__variable] = STATE(3180),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3184),
    [sym_false] = STATE(3184),
    [sym_nil] = STATE(3184),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5793),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5307),
    [anon_sym_yield] = ACTIONS(5309),
    [anon_sym_break] = ACTIONS(5311),
    [anon_sym_next] = ACTIONS(5313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9049),
    [anon_sym_defined_QMARK] = ACTIONS(5315),
    [anon_sym_not] = ACTIONS(5317),
    [anon_sym_BANG] = ACTIONS(5321),
    [anon_sym_TILDE] = ACTIONS(5321),
    [sym_constant] = ACTIONS(5327),
    [sym_identifier] = ACTIONS(5327),
    [sym_instance_variable] = ACTIONS(5325),
    [sym_class_variable] = ACTIONS(5325),
    [sym_global_variable] = ACTIONS(5325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3178] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(9061),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [3179] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(9063),
    [sym__binary_star] = ACTIONS(9065),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(9067),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(9065),
    [anon_sym_AMP] = ACTIONS(9069),
    [anon_sym_LT] = ACTIONS(9071),
    [anon_sym_end] = ACTIONS(1625),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_unless] = ACTIONS(1625),
    [anon_sym_while] = ACTIONS(1625),
    [anon_sym_until] = ACTIONS(1625),
    [anon_sym_rescue] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(9051),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(9073),
    [anon_sym_DOT_DOT] = ACTIONS(9075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9077),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(9079),
    [anon_sym_AMP_AMP] = ACTIONS(9079),
    [anon_sym_LT_LT] = ACTIONS(9081),
    [anon_sym_GT_GT] = ACTIONS(9081),
    [anon_sym_EQ_EQ] = ACTIONS(9083),
    [anon_sym_BANG_EQ] = ACTIONS(9079),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9079),
    [anon_sym_LT_EQ_GT] = ACTIONS(9079),
    [anon_sym_EQ_TILDE] = ACTIONS(9079),
    [anon_sym_BANG_TILDE] = ACTIONS(9079),
    [anon_sym_LT_EQ] = ACTIONS(9071),
    [anon_sym_GT] = ACTIONS(9071),
    [anon_sym_GT_EQ] = ACTIONS(9085),
    [anon_sym_CARET] = ACTIONS(9087),
    [anon_sym_PLUS] = ACTIONS(9063),
    [anon_sym_SLASH] = ACTIONS(9065),
    [anon_sym_PERCENT] = ACTIONS(9065),
    [sym_comment] = ACTIONS(87),
  },
  [3180] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5822),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3220),
    [sym_scope_resolution] = STATE(3216),
    [sym_call] = STATE(3216),
    [sym_method_call] = STATE(3220),
    [sym_argument_list] = STATE(938),
    [sym__argument_list_with_parens] = STATE(5823),
    [sym__argument] = STATE(5824),
    [sym_splat_argument] = STATE(5824),
    [sym_hash_splat_argument] = STATE(5824),
    [sym_block_argument] = STATE(5824),
    [sym_do_block] = STATE(941),
    [sym_block] = STATE(941),
    [sym_assignment] = STATE(5822),
    [sym_operator_assignment] = STATE(5822),
    [sym_conditional] = STATE(5822),
    [sym_range] = STATE(5822),
    [sym_binary] = STATE(5822),
    [sym_unary] = STATE(5822),
    [sym_left_assignment_list] = STATE(3219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3220),
    [sym__variable] = STATE(3216),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3220),
    [sym_false] = STATE(3220),
    [sym_nil] = STATE(3220),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5825),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(5824),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(743),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(9089),
    [sym__splat_star] = ACTIONS(9091),
    [sym__unary_minus] = ACTIONS(5375),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(9093),
    [anon_sym_LBRACE] = ACTIONS(1669),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(769),
    [anon_sym_return] = ACTIONS(5379),
    [anon_sym_yield] = ACTIONS(5381),
    [anon_sym_break] = ACTIONS(5383),
    [anon_sym_next] = ACTIONS(5385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(769),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(769),
    [anon_sym_until] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(769),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(1671),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(5387),
    [anon_sym_not] = ACTIONS(5389),
    [anon_sym_BANG] = ACTIONS(5391),
    [anon_sym_TILDE] = ACTIONS(5393),
    [sym_constant] = ACTIONS(9095),
    [sym_identifier] = ACTIONS(9095),
    [sym_instance_variable] = ACTIONS(5397),
    [sym_class_variable] = ACTIONS(5397),
    [sym_global_variable] = ACTIONS(5397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3181] = {
    [sym_heredoc_body] = STATE(5826),
    [aux_sym_call_repeat1] = STATE(5826),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [3182] = {
    [sym_heredoc_body] = STATE(5826),
    [aux_sym_call_repeat1] = STATE(5826),
    [aux_sym_argument_list_repeat1] = STATE(5828),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(9097),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [3183] = {
    [anon_sym_EQ] = ACTIONS(9099),
    [sym_comment] = ACTIONS(87),
  },
  [3184] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(9101),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(9103),
    [anon_sym_DASH_EQ] = ACTIONS(9103),
    [anon_sym_STAR_EQ] = ACTIONS(9103),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9103),
    [anon_sym_SLASH_EQ] = ACTIONS(9103),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9103),
    [anon_sym_PIPE_EQ] = ACTIONS(9103),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9103),
    [anon_sym_AMP_EQ] = ACTIONS(9103),
    [anon_sym_PERCENT_EQ] = ACTIONS(9103),
    [anon_sym_GT_GT_EQ] = ACTIONS(9103),
    [anon_sym_LT_LT_EQ] = ACTIONS(9103),
    [anon_sym_CARET_EQ] = ACTIONS(9103),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3185] = {
    [sym_string] = STATE(5831),
    [aux_sym_chained_string_repeat1] = STATE(5831),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(9105),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [3186] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(5343),
    [sym__binary_star] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(5345),
    [anon_sym_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(5353),
    [anon_sym_DOT_DOT] = ACTIONS(5355),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5357),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(5361),
    [anon_sym_AMP_AMP] = ACTIONS(5361),
    [anon_sym_LT_LT] = ACTIONS(5363),
    [anon_sym_GT_GT] = ACTIONS(5363),
    [anon_sym_EQ_EQ] = ACTIONS(5365),
    [anon_sym_BANG_EQ] = ACTIONS(5361),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5361),
    [anon_sym_LT_EQ_GT] = ACTIONS(5361),
    [anon_sym_EQ_TILDE] = ACTIONS(5361),
    [anon_sym_BANG_TILDE] = ACTIONS(5361),
    [anon_sym_LT_EQ] = ACTIONS(5351),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5367),
    [anon_sym_CARET] = ACTIONS(5369),
    [anon_sym_PLUS] = ACTIONS(5343),
    [anon_sym_SLASH] = ACTIONS(5345),
    [anon_sym_PERCENT] = ACTIONS(5345),
    [sym_comment] = ACTIONS(87),
  },
  [3187] = {
    [aux_sym_undef_repeat1] = STATE(5832),
    [sym__line_break] = ACTIONS(2251),
    [sym__heredoc_body_start] = ACTIONS(2251),
    [anon_sym_COMMA] = ACTIONS(2253),
    [anon_sym_SEMI] = ACTIONS(2251),
    [anon_sym_end] = ACTIONS(2251),
    [anon_sym_if] = ACTIONS(2251),
    [anon_sym_unless] = ACTIONS(2251),
    [anon_sym_while] = ACTIONS(2251),
    [anon_sym_until] = ACTIONS(2251),
    [anon_sym_rescue] = ACTIONS(2251),
    [sym_comment] = ACTIONS(87),
  },
  [3188] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5833),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(5833),
    [sym_operator_assignment] = STATE(5833),
    [sym_conditional] = STATE(5833),
    [sym_range] = STATE(5833),
    [sym_binary] = STATE(5833),
    [sym_unary] = STATE(5833),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3189] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5834),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(5834),
    [sym_operator_assignment] = STATE(5834),
    [sym_conditional] = STATE(5834),
    [sym_range] = STATE(5834),
    [sym_binary] = STATE(5834),
    [sym_unary] = STATE(5834),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3190] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5835),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(5835),
    [sym_operator_assignment] = STATE(5835),
    [sym_conditional] = STATE(5835),
    [sym_range] = STATE(5835),
    [sym_binary] = STATE(5835),
    [sym_unary] = STATE(5835),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3191] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5836),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(5836),
    [sym_operator_assignment] = STATE(5836),
    [sym_conditional] = STATE(5836),
    [sym_range] = STATE(5836),
    [sym_binary] = STATE(5836),
    [sym_unary] = STATE(5836),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3192] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5837),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(5837),
    [sym_operator_assignment] = STATE(5837),
    [sym_conditional] = STATE(5837),
    [sym_range] = STATE(5837),
    [sym_binary] = STATE(5837),
    [sym_unary] = STATE(5837),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3193] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5838),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(5838),
    [sym_operator_assignment] = STATE(5838),
    [sym_conditional] = STATE(5838),
    [sym_range] = STATE(5838),
    [sym_binary] = STATE(5838),
    [sym_unary] = STATE(5838),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3194] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5839),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(5839),
    [sym_operator_assignment] = STATE(5839),
    [sym_conditional] = STATE(5839),
    [sym_range] = STATE(5839),
    [sym_binary] = STATE(5839),
    [sym_unary] = STATE(5839),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3195] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5840),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(5840),
    [sym_operator_assignment] = STATE(5840),
    [sym_conditional] = STATE(5840),
    [sym_range] = STATE(5840),
    [sym_binary] = STATE(5840),
    [sym_unary] = STATE(5840),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3196] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5841),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(5841),
    [sym_operator_assignment] = STATE(5841),
    [sym_conditional] = STATE(5841),
    [sym_range] = STATE(5841),
    [sym_binary] = STATE(5841),
    [sym_unary] = STATE(5841),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3197] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5842),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(5842),
    [sym_operator_assignment] = STATE(5842),
    [sym_conditional] = STATE(5842),
    [sym_range] = STATE(5842),
    [sym_binary] = STATE(5842),
    [sym_unary] = STATE(5842),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3198] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(5843),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(5843),
    [sym_operator_assignment] = STATE(5843),
    [sym_conditional] = STATE(5843),
    [sym_range] = STATE(5843),
    [sym_binary] = STATE(5843),
    [sym_unary] = STATE(5843),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3199] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5844),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(5844),
    [sym_operator_assignment] = STATE(5844),
    [sym_conditional] = STATE(5844),
    [sym_range] = STATE(5844),
    [sym_binary] = STATE(5844),
    [sym_unary] = STATE(5844),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3200] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5845),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(5845),
    [sym_operator_assignment] = STATE(5845),
    [sym_conditional] = STATE(5845),
    [sym_range] = STATE(5845),
    [sym_binary] = STATE(5845),
    [sym_unary] = STATE(5845),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3201] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5846),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(5846),
    [sym_operator_assignment] = STATE(5846),
    [sym_conditional] = STATE(5846),
    [sym_range] = STATE(5846),
    [sym_binary] = STATE(5846),
    [sym_unary] = STATE(5846),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3202] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5847),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(5847),
    [sym_operator_assignment] = STATE(5847),
    [sym_conditional] = STATE(5847),
    [sym_range] = STATE(5847),
    [sym_binary] = STATE(5847),
    [sym_unary] = STATE(5847),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3203] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(5855),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(5858),
    [sym_scope_resolution] = STATE(5856),
    [sym_call] = STATE(5856),
    [sym_method_call] = STATE(5858),
    [sym_assignment] = STATE(5855),
    [sym_operator_assignment] = STATE(5855),
    [sym_conditional] = STATE(5855),
    [sym_range] = STATE(5855),
    [sym_binary] = STATE(5855),
    [sym_unary] = STATE(5855),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5858),
    [sym__variable] = STATE(5856),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(5858),
    [sym_false] = STATE(5858),
    [sym_nil] = STATE(5858),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(5859),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(9107),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(9109),
    [anon_sym_yield] = ACTIONS(9111),
    [anon_sym_break] = ACTIONS(9113),
    [anon_sym_next] = ACTIONS(9115),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(9117),
    [anon_sym_defined_QMARK] = ACTIONS(9119),
    [anon_sym_not] = ACTIONS(9121),
    [anon_sym_BANG] = ACTIONS(9123),
    [anon_sym_TILDE] = ACTIONS(9123),
    [sym_constant] = ACTIONS(9125),
    [sym_identifier] = ACTIONS(9125),
    [sym_instance_variable] = ACTIONS(9127),
    [sym_class_variable] = ACTIONS(9127),
    [sym_global_variable] = ACTIONS(9127),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(9125),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9125),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [3204] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(5860),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(5858),
    [sym_scope_resolution] = STATE(5856),
    [sym_call] = STATE(5856),
    [sym_method_call] = STATE(5858),
    [sym_assignment] = STATE(5860),
    [sym_operator_assignment] = STATE(5860),
    [sym_conditional] = STATE(5860),
    [sym_range] = STATE(5860),
    [sym_binary] = STATE(5860),
    [sym_unary] = STATE(5860),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5858),
    [sym__variable] = STATE(5856),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(5858),
    [sym_false] = STATE(5858),
    [sym_nil] = STATE(5858),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(5859),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(9107),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(9109),
    [anon_sym_yield] = ACTIONS(9111),
    [anon_sym_break] = ACTIONS(9113),
    [anon_sym_next] = ACTIONS(9115),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(9117),
    [anon_sym_defined_QMARK] = ACTIONS(9119),
    [anon_sym_not] = ACTIONS(9121),
    [anon_sym_BANG] = ACTIONS(9123),
    [anon_sym_TILDE] = ACTIONS(9123),
    [sym_constant] = ACTIONS(9125),
    [sym_identifier] = ACTIONS(9125),
    [sym_instance_variable] = ACTIONS(9127),
    [sym_class_variable] = ACTIONS(9127),
    [sym_global_variable] = ACTIONS(9127),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(9125),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9125),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [3205] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5861),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3220),
    [sym_scope_resolution] = STATE(3216),
    [sym_call] = STATE(3216),
    [sym_method_call] = STATE(3220),
    [sym_assignment] = STATE(5861),
    [sym_operator_assignment] = STATE(5861),
    [sym_conditional] = STATE(5861),
    [sym_range] = STATE(5861),
    [sym_binary] = STATE(5861),
    [sym_unary] = STATE(5861),
    [sym_left_assignment_list] = STATE(3219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3220),
    [sym__variable] = STATE(3216),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3220),
    [sym_false] = STATE(3220),
    [sym_nil] = STATE(3220),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5862),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5375),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5379),
    [anon_sym_yield] = ACTIONS(5381),
    [anon_sym_break] = ACTIONS(5383),
    [anon_sym_next] = ACTIONS(5385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(9129),
    [anon_sym_defined_QMARK] = ACTIONS(5387),
    [anon_sym_not] = ACTIONS(5389),
    [anon_sym_BANG] = ACTIONS(5393),
    [anon_sym_TILDE] = ACTIONS(5393),
    [sym_constant] = ACTIONS(5399),
    [sym_identifier] = ACTIONS(5399),
    [sym_instance_variable] = ACTIONS(5397),
    [sym_class_variable] = ACTIONS(5397),
    [sym_global_variable] = ACTIONS(5397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3206] = {
    [anon_sym_COLON] = ACTIONS(9131),
    [sym_comment] = ACTIONS(87),
  },
  [3207] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(5864),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(5858),
    [sym_scope_resolution] = STATE(5856),
    [sym_call] = STATE(5856),
    [sym_method_call] = STATE(5858),
    [sym_assignment] = STATE(5864),
    [sym_operator_assignment] = STATE(5864),
    [sym_conditional] = STATE(5864),
    [sym_range] = STATE(5864),
    [sym_binary] = STATE(5864),
    [sym_unary] = STATE(5864),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5858),
    [sym__variable] = STATE(5856),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(5858),
    [sym_false] = STATE(5858),
    [sym_nil] = STATE(5858),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(5859),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(9107),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(9109),
    [anon_sym_yield] = ACTIONS(9111),
    [anon_sym_break] = ACTIONS(9113),
    [anon_sym_next] = ACTIONS(9115),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(9117),
    [anon_sym_defined_QMARK] = ACTIONS(9119),
    [anon_sym_not] = ACTIONS(9121),
    [anon_sym_BANG] = ACTIONS(9123),
    [anon_sym_TILDE] = ACTIONS(9123),
    [sym_constant] = ACTIONS(9125),
    [sym_identifier] = ACTIONS(9125),
    [sym_instance_variable] = ACTIONS(9127),
    [sym_class_variable] = ACTIONS(9127),
    [sym_global_variable] = ACTIONS(9127),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(9125),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9125),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [3208] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5822),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3220),
    [sym_scope_resolution] = STATE(3216),
    [sym_call] = STATE(3216),
    [sym_method_call] = STATE(3220),
    [sym_argument_list] = STATE(1535),
    [sym__argument_list_with_parens] = STATE(5823),
    [sym__argument] = STATE(5824),
    [sym_splat_argument] = STATE(5824),
    [sym_hash_splat_argument] = STATE(5824),
    [sym_block_argument] = STATE(5824),
    [sym_assignment] = STATE(5822),
    [sym_operator_assignment] = STATE(5822),
    [sym_conditional] = STATE(5822),
    [sym_range] = STATE(5822),
    [sym_binary] = STATE(5822),
    [sym_unary] = STATE(5822),
    [sym_left_assignment_list] = STATE(3219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3220),
    [sym__variable] = STATE(3216),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3220),
    [sym_false] = STATE(3220),
    [sym_nil] = STATE(3220),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5825),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(5824),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(9089),
    [sym__splat_star] = ACTIONS(9091),
    [sym__unary_minus] = ACTIONS(5375),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(9093),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(5379),
    [anon_sym_yield] = ACTIONS(5381),
    [anon_sym_break] = ACTIONS(5383),
    [anon_sym_next] = ACTIONS(5385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(365),
    [anon_sym_DASH_EQ] = ACTIONS(365),
    [anon_sym_STAR_EQ] = ACTIONS(365),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(365),
    [anon_sym_SLASH_EQ] = ACTIONS(365),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(365),
    [anon_sym_PIPE_EQ] = ACTIONS(365),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(365),
    [anon_sym_AMP_EQ] = ACTIONS(365),
    [anon_sym_PERCENT_EQ] = ACTIONS(365),
    [anon_sym_GT_GT_EQ] = ACTIONS(365),
    [anon_sym_LT_LT_EQ] = ACTIONS(365),
    [anon_sym_CARET_EQ] = ACTIONS(365),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_PERCENT] = ACTIONS(377),
    [anon_sym_defined_QMARK] = ACTIONS(5387),
    [anon_sym_not] = ACTIONS(5389),
    [anon_sym_BANG] = ACTIONS(5391),
    [anon_sym_TILDE] = ACTIONS(5393),
    [sym_constant] = ACTIONS(9095),
    [sym_identifier] = ACTIONS(9095),
    [sym_instance_variable] = ACTIONS(5397),
    [sym_class_variable] = ACTIONS(5397),
    [sym_global_variable] = ACTIONS(5397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3209] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5822),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3220),
    [sym_scope_resolution] = STATE(3216),
    [sym_call] = STATE(3216),
    [sym_method_call] = STATE(3220),
    [sym_argument_list] = STATE(1536),
    [sym__argument_list_with_parens] = STATE(5823),
    [sym__argument] = STATE(5824),
    [sym_splat_argument] = STATE(5824),
    [sym_hash_splat_argument] = STATE(5824),
    [sym_block_argument] = STATE(5824),
    [sym_assignment] = STATE(5822),
    [sym_operator_assignment] = STATE(5822),
    [sym_conditional] = STATE(5822),
    [sym_range] = STATE(5822),
    [sym_binary] = STATE(5822),
    [sym_unary] = STATE(5822),
    [sym_left_assignment_list] = STATE(3219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3220),
    [sym__variable] = STATE(3216),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3220),
    [sym_false] = STATE(3220),
    [sym_nil] = STATE(3220),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5825),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(5824),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(9089),
    [sym__splat_star] = ACTIONS(9091),
    [sym__unary_minus] = ACTIONS(5375),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(9093),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_EQ] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(5379),
    [anon_sym_yield] = ACTIONS(5381),
    [anon_sym_break] = ACTIONS(5383),
    [anon_sym_next] = ACTIONS(5385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(417),
    [anon_sym_DASH_EQ] = ACTIONS(417),
    [anon_sym_STAR_EQ] = ACTIONS(417),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(417),
    [anon_sym_SLASH_EQ] = ACTIONS(417),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(417),
    [anon_sym_PIPE_EQ] = ACTIONS(417),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(417),
    [anon_sym_AMP_EQ] = ACTIONS(417),
    [anon_sym_PERCENT_EQ] = ACTIONS(417),
    [anon_sym_GT_GT_EQ] = ACTIONS(417),
    [anon_sym_LT_LT_EQ] = ACTIONS(417),
    [anon_sym_CARET_EQ] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(5387),
    [anon_sym_not] = ACTIONS(5389),
    [anon_sym_BANG] = ACTIONS(5391),
    [anon_sym_TILDE] = ACTIONS(5393),
    [sym_constant] = ACTIONS(9095),
    [sym_identifier] = ACTIONS(9095),
    [sym_instance_variable] = ACTIONS(5397),
    [sym_class_variable] = ACTIONS(5397),
    [sym_global_variable] = ACTIONS(5397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3210] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5822),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3220),
    [sym_scope_resolution] = STATE(3216),
    [sym_call] = STATE(3216),
    [sym_method_call] = STATE(3220),
    [sym_argument_list] = STATE(1537),
    [sym__argument_list_with_parens] = STATE(5823),
    [sym__argument] = STATE(5824),
    [sym_splat_argument] = STATE(5824),
    [sym_hash_splat_argument] = STATE(5824),
    [sym_block_argument] = STATE(5824),
    [sym_assignment] = STATE(5822),
    [sym_operator_assignment] = STATE(5822),
    [sym_conditional] = STATE(5822),
    [sym_range] = STATE(5822),
    [sym_binary] = STATE(5822),
    [sym_unary] = STATE(5822),
    [sym_left_assignment_list] = STATE(3219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3220),
    [sym__variable] = STATE(3216),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3220),
    [sym_false] = STATE(3220),
    [sym_nil] = STATE(3220),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5825),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(5824),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(9089),
    [sym__splat_star] = ACTIONS(9091),
    [sym__unary_minus] = ACTIONS(5375),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(9093),
    [anon_sym_LBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_EQ] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(423),
    [anon_sym_return] = ACTIONS(5379),
    [anon_sym_yield] = ACTIONS(5381),
    [anon_sym_break] = ACTIONS(5383),
    [anon_sym_next] = ACTIONS(5385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(421),
    [anon_sym_DASH_EQ] = ACTIONS(421),
    [anon_sym_STAR_EQ] = ACTIONS(421),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(421),
    [anon_sym_SLASH_EQ] = ACTIONS(421),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(421),
    [anon_sym_PIPE_EQ] = ACTIONS(421),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(421),
    [anon_sym_AMP_EQ] = ACTIONS(421),
    [anon_sym_PERCENT_EQ] = ACTIONS(421),
    [anon_sym_GT_GT_EQ] = ACTIONS(421),
    [anon_sym_LT_LT_EQ] = ACTIONS(421),
    [anon_sym_CARET_EQ] = ACTIONS(421),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(5387),
    [anon_sym_not] = ACTIONS(5389),
    [anon_sym_BANG] = ACTIONS(5391),
    [anon_sym_TILDE] = ACTIONS(5393),
    [sym_constant] = ACTIONS(9095),
    [sym_identifier] = ACTIONS(9095),
    [sym_instance_variable] = ACTIONS(5397),
    [sym_class_variable] = ACTIONS(5397),
    [sym_global_variable] = ACTIONS(5397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3211] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5822),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3220),
    [sym_scope_resolution] = STATE(3216),
    [sym_call] = STATE(3216),
    [sym_method_call] = STATE(3220),
    [sym_argument_list] = STATE(1538),
    [sym__argument_list_with_parens] = STATE(5823),
    [sym__argument] = STATE(5824),
    [sym_splat_argument] = STATE(5824),
    [sym_hash_splat_argument] = STATE(5824),
    [sym_block_argument] = STATE(5824),
    [sym_assignment] = STATE(5822),
    [sym_operator_assignment] = STATE(5822),
    [sym_conditional] = STATE(5822),
    [sym_range] = STATE(5822),
    [sym_binary] = STATE(5822),
    [sym_unary] = STATE(5822),
    [sym_left_assignment_list] = STATE(3219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3220),
    [sym__variable] = STATE(3216),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3220),
    [sym_false] = STATE(3220),
    [sym_nil] = STATE(3220),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5825),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(5824),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(9089),
    [sym__splat_star] = ACTIONS(9091),
    [sym__unary_minus] = ACTIONS(5375),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(9093),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(427),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(427),
    [anon_sym_return] = ACTIONS(5379),
    [anon_sym_yield] = ACTIONS(5381),
    [anon_sym_break] = ACTIONS(5383),
    [anon_sym_next] = ACTIONS(5385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(425),
    [anon_sym_DASH_EQ] = ACTIONS(425),
    [anon_sym_STAR_EQ] = ACTIONS(425),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(425),
    [anon_sym_SLASH_EQ] = ACTIONS(425),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(425),
    [anon_sym_PIPE_EQ] = ACTIONS(425),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(425),
    [anon_sym_AMP_EQ] = ACTIONS(425),
    [anon_sym_PERCENT_EQ] = ACTIONS(425),
    [anon_sym_GT_GT_EQ] = ACTIONS(425),
    [anon_sym_LT_LT_EQ] = ACTIONS(425),
    [anon_sym_CARET_EQ] = ACTIONS(425),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(5387),
    [anon_sym_not] = ACTIONS(5389),
    [anon_sym_BANG] = ACTIONS(5391),
    [anon_sym_TILDE] = ACTIONS(5393),
    [sym_constant] = ACTIONS(9095),
    [sym_identifier] = ACTIONS(9095),
    [sym_instance_variable] = ACTIONS(5397),
    [sym_class_variable] = ACTIONS(5397),
    [sym_global_variable] = ACTIONS(5397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3212] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5865),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3220),
    [sym_scope_resolution] = STATE(3216),
    [sym_call] = STATE(3216),
    [sym_method_call] = STATE(3220),
    [sym_assignment] = STATE(5865),
    [sym_operator_assignment] = STATE(5865),
    [sym_conditional] = STATE(5865),
    [sym_range] = STATE(5865),
    [sym_binary] = STATE(5865),
    [sym_unary] = STATE(5865),
    [sym_left_assignment_list] = STATE(3219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3220),
    [sym__variable] = STATE(3216),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3220),
    [sym_false] = STATE(3220),
    [sym_nil] = STATE(3220),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5862),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5375),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5379),
    [anon_sym_yield] = ACTIONS(5381),
    [anon_sym_break] = ACTIONS(5383),
    [anon_sym_next] = ACTIONS(5385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(9129),
    [anon_sym_defined_QMARK] = ACTIONS(5387),
    [anon_sym_not] = ACTIONS(5389),
    [anon_sym_BANG] = ACTIONS(5393),
    [anon_sym_TILDE] = ACTIONS(5393),
    [sym_constant] = ACTIONS(5399),
    [sym_identifier] = ACTIONS(5399),
    [sym_instance_variable] = ACTIONS(5397),
    [sym_class_variable] = ACTIONS(5397),
    [sym_global_variable] = ACTIONS(5397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3213] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(1559),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3220),
    [sym_scope_resolution] = STATE(3216),
    [sym_call] = STATE(3216),
    [sym_method_call] = STATE(3220),
    [sym_assignment] = STATE(1559),
    [sym_operator_assignment] = STATE(1559),
    [sym_conditional] = STATE(1559),
    [sym_range] = STATE(1559),
    [sym_binary] = STATE(1559),
    [sym_unary] = STATE(1559),
    [sym_left_assignment_list] = STATE(3219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3220),
    [sym__variable] = STATE(3216),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3220),
    [sym_false] = STATE(3220),
    [sym_nil] = STATE(3220),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5862),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5375),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5379),
    [anon_sym_yield] = ACTIONS(5381),
    [anon_sym_break] = ACTIONS(5383),
    [anon_sym_next] = ACTIONS(5385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(9129),
    [anon_sym_defined_QMARK] = ACTIONS(5387),
    [anon_sym_not] = ACTIONS(5389),
    [anon_sym_BANG] = ACTIONS(5393),
    [anon_sym_TILDE] = ACTIONS(5393),
    [sym_constant] = ACTIONS(5399),
    [sym_identifier] = ACTIONS(5399),
    [sym_instance_variable] = ACTIONS(5397),
    [sym_class_variable] = ACTIONS(5397),
    [sym_global_variable] = ACTIONS(5397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3214] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(9133),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [3215] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(9135),
    [sym__binary_star] = ACTIONS(9137),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(9139),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(9141),
    [anon_sym_AMP] = ACTIONS(9143),
    [anon_sym_EQ] = ACTIONS(1631),
    [anon_sym_LT] = ACTIONS(9145),
    [anon_sym_end] = ACTIONS(1625),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_unless] = ACTIONS(1625),
    [anon_sym_while] = ACTIONS(1625),
    [anon_sym_until] = ACTIONS(1625),
    [anon_sym_rescue] = ACTIONS(1625),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(9131),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_PLUS_EQ] = ACTIONS(1625),
    [anon_sym_DASH_EQ] = ACTIONS(1625),
    [anon_sym_STAR_EQ] = ACTIONS(1625),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1625),
    [anon_sym_SLASH_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1625),
    [anon_sym_AMP_EQ] = ACTIONS(1625),
    [anon_sym_PERCENT_EQ] = ACTIONS(1625),
    [anon_sym_GT_GT_EQ] = ACTIONS(1625),
    [anon_sym_LT_LT_EQ] = ACTIONS(1625),
    [anon_sym_CARET_EQ] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(9147),
    [anon_sym_DOT_DOT] = ACTIONS(9149),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9151),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(9153),
    [anon_sym_AMP_AMP] = ACTIONS(9153),
    [anon_sym_LT_LT] = ACTIONS(9155),
    [anon_sym_GT_GT] = ACTIONS(9155),
    [anon_sym_EQ_EQ] = ACTIONS(9153),
    [anon_sym_BANG_EQ] = ACTIONS(9157),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9157),
    [anon_sym_LT_EQ_GT] = ACTIONS(9157),
    [anon_sym_EQ_TILDE] = ACTIONS(9157),
    [anon_sym_BANG_TILDE] = ACTIONS(9157),
    [anon_sym_LT_EQ] = ACTIONS(9145),
    [anon_sym_GT] = ACTIONS(9145),
    [anon_sym_GT_EQ] = ACTIONS(9159),
    [anon_sym_CARET] = ACTIONS(9139),
    [anon_sym_PLUS] = ACTIONS(9161),
    [anon_sym_SLASH] = ACTIONS(9141),
    [anon_sym_PERCENT] = ACTIONS(9141),
    [sym_comment] = ACTIONS(87),
  },
  [3216] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5822),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3220),
    [sym_scope_resolution] = STATE(3216),
    [sym_call] = STATE(3216),
    [sym_method_call] = STATE(3220),
    [sym_argument_list] = STATE(1578),
    [sym__argument_list_with_parens] = STATE(5823),
    [sym__argument] = STATE(5824),
    [sym_splat_argument] = STATE(5824),
    [sym_hash_splat_argument] = STATE(5824),
    [sym_block_argument] = STATE(5824),
    [sym_do_block] = STATE(941),
    [sym_block] = STATE(941),
    [sym_assignment] = STATE(5822),
    [sym_operator_assignment] = STATE(5822),
    [sym_conditional] = STATE(5822),
    [sym_range] = STATE(5822),
    [sym_binary] = STATE(5822),
    [sym_unary] = STATE(5822),
    [sym_left_assignment_list] = STATE(3219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3220),
    [sym__variable] = STATE(3216),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3220),
    [sym_false] = STATE(3220),
    [sym_nil] = STATE(3220),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5825),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(5824),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(743),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(9089),
    [sym__splat_star] = ACTIONS(9091),
    [sym__unary_minus] = ACTIONS(5375),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(9093),
    [anon_sym_LBRACE] = ACTIONS(2715),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(769),
    [anon_sym_return] = ACTIONS(5379),
    [anon_sym_yield] = ACTIONS(5381),
    [anon_sym_break] = ACTIONS(5383),
    [anon_sym_next] = ACTIONS(5385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(769),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(769),
    [anon_sym_until] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(769),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(769),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(5387),
    [anon_sym_not] = ACTIONS(5389),
    [anon_sym_BANG] = ACTIONS(5391),
    [anon_sym_TILDE] = ACTIONS(5393),
    [sym_constant] = ACTIONS(9095),
    [sym_identifier] = ACTIONS(9095),
    [sym_instance_variable] = ACTIONS(5397),
    [sym_class_variable] = ACTIONS(5397),
    [sym_global_variable] = ACTIONS(5397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3217] = {
    [sym_heredoc_body] = STATE(5877),
    [aux_sym_call_repeat1] = STATE(5877),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [3218] = {
    [sym_heredoc_body] = STATE(5877),
    [aux_sym_call_repeat1] = STATE(5877),
    [aux_sym_argument_list_repeat1] = STATE(5879),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(9163),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [3219] = {
    [anon_sym_EQ] = ACTIONS(9165),
    [sym_comment] = ACTIONS(87),
  },
  [3220] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(9167),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(9169),
    [anon_sym_DASH_EQ] = ACTIONS(9169),
    [anon_sym_STAR_EQ] = ACTIONS(9169),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9169),
    [anon_sym_SLASH_EQ] = ACTIONS(9169),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9169),
    [anon_sym_PIPE_EQ] = ACTIONS(9169),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9169),
    [anon_sym_AMP_EQ] = ACTIONS(9169),
    [anon_sym_PERCENT_EQ] = ACTIONS(9169),
    [anon_sym_GT_GT_EQ] = ACTIONS(9169),
    [anon_sym_LT_LT_EQ] = ACTIONS(9169),
    [anon_sym_CARET_EQ] = ACTIONS(9169),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3221] = {
    [sym_string] = STATE(5882),
    [aux_sym_chained_string_repeat1] = STATE(5882),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(747),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3222] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5887),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5890),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(5890),
    [sym_splat_argument] = STATE(5888),
    [sym_assignment] = STATE(5887),
    [sym_operator_assignment] = STATE(5887),
    [sym_conditional] = STATE(5887),
    [sym_range] = STATE(5887),
    [sym_binary] = STATE(5887),
    [sym_unary] = STATE(5887),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(5888),
    [sym_left_assignment_list] = STATE(5889),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5890),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5890),
    [sym_false] = STATE(5890),
    [sym_nil] = STATE(5890),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5790),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(9173),
    [sym__unary_minus] = ACTIONS(9175),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9033),
    [anon_sym_yield] = ACTIONS(9035),
    [anon_sym_break] = ACTIONS(9037),
    [anon_sym_next] = ACTIONS(9039),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9177),
    [anon_sym_defined_QMARK] = ACTIONS(9179),
    [anon_sym_not] = ACTIONS(9181),
    [anon_sym_BANG] = ACTIONS(9183),
    [anon_sym_TILDE] = ACTIONS(9183),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3223] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5891),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(5891),
    [sym_operator_assignment] = STATE(5891),
    [sym_conditional] = STATE(5891),
    [sym_range] = STATE(5891),
    [sym_binary] = STATE(5891),
    [sym_unary] = STATE(5891),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3224] = {
    [sym_string] = STATE(5892),
    [aux_sym_chained_string_repeat1] = STATE(5892),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_end] = ACTIONS(2753),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [3225] = {
    [sym_heredoc_body] = STATE(370),
    [sym__terminator] = STATE(370),
    [sym__line_break] = ACTIONS(687),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(687),
    [anon_sym_end] = ACTIONS(2757),
    [anon_sym_if] = ACTIONS(5333),
    [anon_sym_unless] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5337),
    [anon_sym_until] = ACTIONS(5339),
    [anon_sym_rescue] = ACTIONS(5341),
    [sym_comment] = ACTIONS(87),
  },
  [3226] = {
    [sym_begin_block] = STATE(1611),
    [sym_end_block] = STATE(1611),
    [sym__statement] = STATE(1611),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1611),
    [sym_unless_modifier] = STATE(1611),
    [sym_while_modifier] = STATE(1611),
    [sym_until_modifier] = STATE(1611),
    [sym_rescue_modifier] = STATE(1611),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1612),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1615),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(1615),
    [sym_assignment] = STATE(1612),
    [sym_operator_assignment] = STATE(1612),
    [sym_conditional] = STATE(1612),
    [sym_range] = STATE(1612),
    [sym_binary] = STATE(1612),
    [sym_unary] = STATE(1612),
    [sym_left_assignment_list] = STATE(1614),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1615),
    [sym__variable] = STATE(1613),
    [sym_undef] = STATE(1611),
    [sym_alias] = STATE(1611),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1615),
    [sym_false] = STATE(1615),
    [sym_nil] = STATE(1615),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1616),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(3226),
    [aux_sym__statements_repeat1] = STATE(3226),
    [sym__simple_symbol] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(2762),
    [sym__symbol_start] = ACTIONS(2765),
    [sym__subshell_start] = ACTIONS(2768),
    [sym__regex_start] = ACTIONS(2771),
    [sym__string_array_start] = ACTIONS(2774),
    [sym__symbol_array_start] = ACTIONS(2777),
    [sym_heredoc_beginning] = ACTIONS(2780),
    [sym__unary_minus] = ACTIONS(2783),
    [anon_sym_BEGIN] = ACTIONS(2786),
    [anon_sym_LBRACE] = ACTIONS(2789),
    [anon_sym_END] = ACTIONS(2792),
    [anon_sym_def] = ACTIONS(2795),
    [anon_sym_LPAREN] = ACTIONS(2798),
    [anon_sym_COLON_COLON] = ACTIONS(2801),
    [anon_sym_SEMI] = ACTIONS(2804),
    [anon_sym_STAR] = ACTIONS(2807),
    [anon_sym_class] = ACTIONS(2810),
    [anon_sym_module] = ACTIONS(2813),
    [anon_sym_end] = ACTIONS(2493),
    [anon_sym_return] = ACTIONS(2816),
    [anon_sym_yield] = ACTIONS(2819),
    [anon_sym_break] = ACTIONS(2822),
    [anon_sym_next] = ACTIONS(2825),
    [sym_redo] = ACTIONS(2828),
    [sym_retry] = ACTIONS(2828),
    [anon_sym_if] = ACTIONS(2831),
    [anon_sym_unless] = ACTIONS(2834),
    [anon_sym_while] = ACTIONS(2837),
    [anon_sym_until] = ACTIONS(2840),
    [anon_sym_for] = ACTIONS(2843),
    [anon_sym_case] = ACTIONS(2846),
    [anon_sym_begin] = ACTIONS(2849),
    [anon_sym_PLUS] = ACTIONS(2852),
    [anon_sym_defined_QMARK] = ACTIONS(2855),
    [anon_sym_not] = ACTIONS(2858),
    [anon_sym_BANG] = ACTIONS(2861),
    [anon_sym_TILDE] = ACTIONS(2861),
    [sym_constant] = ACTIONS(2864),
    [sym_identifier] = ACTIONS(2864),
    [sym_instance_variable] = ACTIONS(2867),
    [sym_class_variable] = ACTIONS(2867),
    [sym_global_variable] = ACTIONS(2867),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_alias] = ACTIONS(2873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2876),
    [sym_float] = ACTIONS(2828),
    [sym_complex] = ACTIONS(2780),
    [sym_super] = ACTIONS(2864),
    [anon_sym_true] = ACTIONS(2879),
    [anon_sym_TRUE] = ACTIONS(2879),
    [anon_sym_false] = ACTIONS(2882),
    [anon_sym_FALSE] = ACTIONS(2882),
    [sym_self] = ACTIONS(2864),
    [anon_sym_nil] = ACTIONS(2885),
    [anon_sym_NIL] = ACTIONS(2885),
    [sym_character] = ACTIONS(2780),
    [anon_sym_LBRACK2] = ACTIONS(2888),
    [anon_sym_DASH_GT] = ACTIONS(2891),
  },
  [3227] = {
    [aux_sym_undef_repeat1] = STATE(5893),
    [sym__line_break] = ACTIONS(5497),
    [sym__heredoc_body_start] = ACTIONS(5497),
    [anon_sym_COMMA] = ACTIONS(2253),
    [anon_sym_SEMI] = ACTIONS(5497),
    [anon_sym_end] = ACTIONS(5497),
    [anon_sym_if] = ACTIONS(5497),
    [anon_sym_unless] = ACTIONS(5497),
    [anon_sym_while] = ACTIONS(5497),
    [anon_sym_until] = ACTIONS(5497),
    [anon_sym_rescue] = ACTIONS(5497),
    [anon_sym_else] = ACTIONS(5497),
    [anon_sym_ensure] = ACTIONS(5497),
    [sym_comment] = ACTIONS(87),
  },
  [3228] = {
    [sym__line_break] = ACTIONS(9185),
    [sym__heredoc_body_start] = ACTIONS(9185),
    [sym__binary_minus] = ACTIONS(9185),
    [sym__binary_star] = ACTIONS(9185),
    [ts_builtin_sym_end] = ACTIONS(9185),
    [anon_sym___END__] = ACTIONS(9185),
    [anon_sym_LBRACE] = ACTIONS(9185),
    [anon_sym_RBRACE] = ACTIONS(9185),
    [anon_sym_RPAREN] = ACTIONS(9185),
    [anon_sym_DOT] = ACTIONS(9187),
    [anon_sym_COMMA] = ACTIONS(9185),
    [anon_sym_PIPE] = ACTIONS(9187),
    [anon_sym_SEMI] = ACTIONS(9185),
    [anon_sym_STAR_STAR] = ACTIONS(9185),
    [anon_sym_AMP] = ACTIONS(9187),
    [anon_sym_LT] = ACTIONS(9187),
    [anon_sym_end] = ACTIONS(9185),
    [anon_sym_if] = ACTIONS(9185),
    [anon_sym_unless] = ACTIONS(9185),
    [anon_sym_while] = ACTIONS(9185),
    [anon_sym_until] = ACTIONS(9185),
    [anon_sym_rescue] = ACTIONS(9185),
    [anon_sym_do] = ACTIONS(9185),
    [anon_sym_when] = ACTIONS(9185),
    [anon_sym_elsif] = ACTIONS(9185),
    [anon_sym_else] = ACTIONS(9185),
    [anon_sym_then] = ACTIONS(9185),
    [anon_sym_ensure] = ACTIONS(9185),
    [anon_sym_EQ_GT] = ACTIONS(9185),
    [anon_sym_LBRACK] = ACTIONS(9185),
    [anon_sym_COLON_COLON2] = ACTIONS(9185),
    [anon_sym_AMP_DOT] = ACTIONS(9185),
    [anon_sym_QMARK] = ACTIONS(9185),
    [anon_sym_DOT_DOT] = ACTIONS(9187),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9185),
    [anon_sym_and] = ACTIONS(9185),
    [anon_sym_or] = ACTIONS(9185),
    [anon_sym_PIPE_PIPE] = ACTIONS(9185),
    [anon_sym_AMP_AMP] = ACTIONS(9185),
    [anon_sym_LT_LT] = ACTIONS(9185),
    [anon_sym_GT_GT] = ACTIONS(9185),
    [anon_sym_EQ_EQ] = ACTIONS(9187),
    [anon_sym_BANG_EQ] = ACTIONS(9185),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9185),
    [anon_sym_LT_EQ_GT] = ACTIONS(9185),
    [anon_sym_EQ_TILDE] = ACTIONS(9185),
    [anon_sym_BANG_TILDE] = ACTIONS(9185),
    [anon_sym_LT_EQ] = ACTIONS(9187),
    [anon_sym_GT] = ACTIONS(9187),
    [anon_sym_GT_EQ] = ACTIONS(9185),
    [anon_sym_CARET] = ACTIONS(9185),
    [anon_sym_PLUS] = ACTIONS(9185),
    [anon_sym_SLASH] = ACTIONS(9185),
    [anon_sym_PERCENT] = ACTIONS(9185),
    [sym_comment] = ACTIONS(87),
  },
  [3229] = {
    [anon_sym_end] = ACTIONS(9189),
    [sym_comment] = ACTIONS(87),
  },
  [3230] = {
    [sym_ensure] = STATE(5895),
    [anon_sym_end] = ACTIONS(9189),
    [anon_sym_ensure] = ACTIONS(2169),
    [sym_comment] = ACTIONS(87),
  },
  [3231] = {
    [sym__line_break] = ACTIONS(5815),
    [sym__heredoc_body_start] = ACTIONS(5815),
    [sym__binary_minus] = ACTIONS(2185),
    [sym__binary_star] = ACTIONS(2187),
    [anon_sym_PIPE] = ACTIONS(2189),
    [anon_sym_SEMI] = ACTIONS(5815),
    [anon_sym_STAR_STAR] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2191),
    [anon_sym_LT] = ACTIONS(2193),
    [anon_sym_end] = ACTIONS(5815),
    [anon_sym_if] = ACTIONS(5815),
    [anon_sym_unless] = ACTIONS(5815),
    [anon_sym_while] = ACTIONS(5815),
    [anon_sym_until] = ACTIONS(5815),
    [anon_sym_rescue] = ACTIONS(5815),
    [anon_sym_else] = ACTIONS(5815),
    [anon_sym_ensure] = ACTIONS(5815),
    [anon_sym_QMARK] = ACTIONS(2195),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2199),
    [anon_sym_and] = ACTIONS(2201),
    [anon_sym_or] = ACTIONS(2201),
    [anon_sym_PIPE_PIPE] = ACTIONS(2203),
    [anon_sym_AMP_AMP] = ACTIONS(2203),
    [anon_sym_LT_LT] = ACTIONS(2205),
    [anon_sym_GT_GT] = ACTIONS(2205),
    [anon_sym_EQ_EQ] = ACTIONS(2207),
    [anon_sym_BANG_EQ] = ACTIONS(2203),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2203),
    [anon_sym_LT_EQ_GT] = ACTIONS(2203),
    [anon_sym_EQ_TILDE] = ACTIONS(2203),
    [anon_sym_BANG_TILDE] = ACTIONS(2203),
    [anon_sym_LT_EQ] = ACTIONS(2193),
    [anon_sym_GT] = ACTIONS(2193),
    [anon_sym_GT_EQ] = ACTIONS(2209),
    [anon_sym_CARET] = ACTIONS(2211),
    [anon_sym_PLUS] = ACTIONS(2185),
    [anon_sym_SLASH] = ACTIONS(2187),
    [anon_sym_PERCENT] = ACTIONS(2187),
    [sym_comment] = ACTIONS(87),
  },
  [3232] = {
    [sym__line_break] = ACTIONS(5817),
    [sym__heredoc_body_start] = ACTIONS(5817),
    [sym__binary_minus] = ACTIONS(2185),
    [sym__binary_star] = ACTIONS(2187),
    [anon_sym_PIPE] = ACTIONS(2189),
    [anon_sym_SEMI] = ACTIONS(5817),
    [anon_sym_STAR_STAR] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2191),
    [anon_sym_LT] = ACTIONS(2193),
    [anon_sym_end] = ACTIONS(5817),
    [anon_sym_if] = ACTIONS(5817),
    [anon_sym_unless] = ACTIONS(5817),
    [anon_sym_while] = ACTIONS(5817),
    [anon_sym_until] = ACTIONS(5817),
    [anon_sym_rescue] = ACTIONS(5817),
    [anon_sym_else] = ACTIONS(5817),
    [anon_sym_ensure] = ACTIONS(5817),
    [anon_sym_QMARK] = ACTIONS(2195),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2199),
    [anon_sym_and] = ACTIONS(2201),
    [anon_sym_or] = ACTIONS(2201),
    [anon_sym_PIPE_PIPE] = ACTIONS(2203),
    [anon_sym_AMP_AMP] = ACTIONS(2203),
    [anon_sym_LT_LT] = ACTIONS(2205),
    [anon_sym_GT_GT] = ACTIONS(2205),
    [anon_sym_EQ_EQ] = ACTIONS(2207),
    [anon_sym_BANG_EQ] = ACTIONS(2203),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2203),
    [anon_sym_LT_EQ_GT] = ACTIONS(2203),
    [anon_sym_EQ_TILDE] = ACTIONS(2203),
    [anon_sym_BANG_TILDE] = ACTIONS(2203),
    [anon_sym_LT_EQ] = ACTIONS(2193),
    [anon_sym_GT] = ACTIONS(2193),
    [anon_sym_GT_EQ] = ACTIONS(2209),
    [anon_sym_CARET] = ACTIONS(2211),
    [anon_sym_PLUS] = ACTIONS(2185),
    [anon_sym_SLASH] = ACTIONS(2187),
    [anon_sym_PERCENT] = ACTIONS(2187),
    [sym_comment] = ACTIONS(87),
  },
  [3233] = {
    [sym__line_break] = ACTIONS(5819),
    [sym__heredoc_body_start] = ACTIONS(5819),
    [sym__binary_minus] = ACTIONS(2185),
    [sym__binary_star] = ACTIONS(2187),
    [anon_sym_PIPE] = ACTIONS(2189),
    [anon_sym_SEMI] = ACTIONS(5819),
    [anon_sym_STAR_STAR] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2191),
    [anon_sym_LT] = ACTIONS(2193),
    [anon_sym_end] = ACTIONS(5819),
    [anon_sym_if] = ACTIONS(5819),
    [anon_sym_unless] = ACTIONS(5819),
    [anon_sym_while] = ACTIONS(5819),
    [anon_sym_until] = ACTIONS(5819),
    [anon_sym_rescue] = ACTIONS(5819),
    [anon_sym_else] = ACTIONS(5819),
    [anon_sym_ensure] = ACTIONS(5819),
    [anon_sym_QMARK] = ACTIONS(2195),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2199),
    [anon_sym_and] = ACTIONS(2201),
    [anon_sym_or] = ACTIONS(2201),
    [anon_sym_PIPE_PIPE] = ACTIONS(2203),
    [anon_sym_AMP_AMP] = ACTIONS(2203),
    [anon_sym_LT_LT] = ACTIONS(2205),
    [anon_sym_GT_GT] = ACTIONS(2205),
    [anon_sym_EQ_EQ] = ACTIONS(2207),
    [anon_sym_BANG_EQ] = ACTIONS(2203),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2203),
    [anon_sym_LT_EQ_GT] = ACTIONS(2203),
    [anon_sym_EQ_TILDE] = ACTIONS(2203),
    [anon_sym_BANG_TILDE] = ACTIONS(2203),
    [anon_sym_LT_EQ] = ACTIONS(2193),
    [anon_sym_GT] = ACTIONS(2193),
    [anon_sym_GT_EQ] = ACTIONS(2209),
    [anon_sym_CARET] = ACTIONS(2211),
    [anon_sym_PLUS] = ACTIONS(2185),
    [anon_sym_SLASH] = ACTIONS(2187),
    [anon_sym_PERCENT] = ACTIONS(2187),
    [sym_comment] = ACTIONS(87),
  },
  [3234] = {
    [sym__line_break] = ACTIONS(5821),
    [sym__heredoc_body_start] = ACTIONS(5821),
    [sym__binary_minus] = ACTIONS(2185),
    [sym__binary_star] = ACTIONS(2187),
    [anon_sym_PIPE] = ACTIONS(2189),
    [anon_sym_SEMI] = ACTIONS(5821),
    [anon_sym_STAR_STAR] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2191),
    [anon_sym_LT] = ACTIONS(2193),
    [anon_sym_end] = ACTIONS(5821),
    [anon_sym_if] = ACTIONS(5821),
    [anon_sym_unless] = ACTIONS(5821),
    [anon_sym_while] = ACTIONS(5821),
    [anon_sym_until] = ACTIONS(5821),
    [anon_sym_rescue] = ACTIONS(5821),
    [anon_sym_else] = ACTIONS(5821),
    [anon_sym_ensure] = ACTIONS(5821),
    [anon_sym_QMARK] = ACTIONS(2195),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2199),
    [anon_sym_and] = ACTIONS(2201),
    [anon_sym_or] = ACTIONS(2201),
    [anon_sym_PIPE_PIPE] = ACTIONS(2203),
    [anon_sym_AMP_AMP] = ACTIONS(2203),
    [anon_sym_LT_LT] = ACTIONS(2205),
    [anon_sym_GT_GT] = ACTIONS(2205),
    [anon_sym_EQ_EQ] = ACTIONS(2207),
    [anon_sym_BANG_EQ] = ACTIONS(2203),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2203),
    [anon_sym_LT_EQ_GT] = ACTIONS(2203),
    [anon_sym_EQ_TILDE] = ACTIONS(2203),
    [anon_sym_BANG_TILDE] = ACTIONS(2203),
    [anon_sym_LT_EQ] = ACTIONS(2193),
    [anon_sym_GT] = ACTIONS(2193),
    [anon_sym_GT_EQ] = ACTIONS(2209),
    [anon_sym_CARET] = ACTIONS(2211),
    [anon_sym_PLUS] = ACTIONS(2185),
    [anon_sym_SLASH] = ACTIONS(2187),
    [anon_sym_PERCENT] = ACTIONS(2187),
    [sym_comment] = ACTIONS(87),
  },
  [3235] = {
    [sym__line_break] = ACTIONS(5823),
    [sym__heredoc_body_start] = ACTIONS(5823),
    [sym__binary_minus] = ACTIONS(2185),
    [sym__binary_star] = ACTIONS(2187),
    [anon_sym_PIPE] = ACTIONS(2189),
    [anon_sym_SEMI] = ACTIONS(5823),
    [anon_sym_STAR_STAR] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2191),
    [anon_sym_LT] = ACTIONS(2193),
    [anon_sym_end] = ACTIONS(5823),
    [anon_sym_if] = ACTIONS(5823),
    [anon_sym_unless] = ACTIONS(5823),
    [anon_sym_while] = ACTIONS(5823),
    [anon_sym_until] = ACTIONS(5823),
    [anon_sym_rescue] = ACTIONS(5823),
    [anon_sym_else] = ACTIONS(5823),
    [anon_sym_ensure] = ACTIONS(5823),
    [anon_sym_QMARK] = ACTIONS(2195),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2199),
    [anon_sym_and] = ACTIONS(2201),
    [anon_sym_or] = ACTIONS(2201),
    [anon_sym_PIPE_PIPE] = ACTIONS(2203),
    [anon_sym_AMP_AMP] = ACTIONS(2203),
    [anon_sym_LT_LT] = ACTIONS(2205),
    [anon_sym_GT_GT] = ACTIONS(2205),
    [anon_sym_EQ_EQ] = ACTIONS(2207),
    [anon_sym_BANG_EQ] = ACTIONS(2203),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2203),
    [anon_sym_LT_EQ_GT] = ACTIONS(2203),
    [anon_sym_EQ_TILDE] = ACTIONS(2203),
    [anon_sym_BANG_TILDE] = ACTIONS(2203),
    [anon_sym_LT_EQ] = ACTIONS(2193),
    [anon_sym_GT] = ACTIONS(2193),
    [anon_sym_GT_EQ] = ACTIONS(2209),
    [anon_sym_CARET] = ACTIONS(2211),
    [anon_sym_PLUS] = ACTIONS(2185),
    [anon_sym_SLASH] = ACTIONS(2187),
    [anon_sym_PERCENT] = ACTIONS(2187),
    [sym_comment] = ACTIONS(87),
  },
  [3236] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(2187),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(2187),
    [anon_sym_PERCENT] = ACTIONS(2187),
    [sym_comment] = ACTIONS(87),
  },
  [3237] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [3238] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(2185),
    [sym__binary_star] = ACTIONS(2187),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2191),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(2205),
    [anon_sym_GT_GT] = ACTIONS(2205),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(2185),
    [anon_sym_SLASH] = ACTIONS(2187),
    [anon_sym_PERCENT] = ACTIONS(2187),
    [sym_comment] = ACTIONS(87),
  },
  [3239] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(2185),
    [sym__binary_star] = ACTIONS(2187),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(2205),
    [anon_sym_GT_GT] = ACTIONS(2205),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(2185),
    [anon_sym_SLASH] = ACTIONS(2187),
    [anon_sym_PERCENT] = ACTIONS(2187),
    [sym_comment] = ACTIONS(87),
  },
  [3240] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(2185),
    [sym__binary_star] = ACTIONS(2187),
    [anon_sym_PIPE] = ACTIONS(2189),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2191),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(2205),
    [anon_sym_GT_GT] = ACTIONS(2205),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(2211),
    [anon_sym_PLUS] = ACTIONS(2185),
    [anon_sym_SLASH] = ACTIONS(2187),
    [anon_sym_PERCENT] = ACTIONS(2187),
    [sym_comment] = ACTIONS(87),
  },
  [3241] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(9191),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [3242] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(2185),
    [sym__binary_star] = ACTIONS(2187),
    [anon_sym_PIPE] = ACTIONS(2189),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2191),
    [anon_sym_LT] = ACTIONS(2193),
    [anon_sym_end] = ACTIONS(5927),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_else] = ACTIONS(5927),
    [anon_sym_ensure] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2199),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(2203),
    [anon_sym_AMP_AMP] = ACTIONS(2203),
    [anon_sym_LT_LT] = ACTIONS(2205),
    [anon_sym_GT_GT] = ACTIONS(2205),
    [anon_sym_EQ_EQ] = ACTIONS(2207),
    [anon_sym_BANG_EQ] = ACTIONS(2203),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2203),
    [anon_sym_LT_EQ_GT] = ACTIONS(2203),
    [anon_sym_EQ_TILDE] = ACTIONS(2203),
    [anon_sym_BANG_TILDE] = ACTIONS(2203),
    [anon_sym_LT_EQ] = ACTIONS(2193),
    [anon_sym_GT] = ACTIONS(2193),
    [anon_sym_GT_EQ] = ACTIONS(2209),
    [anon_sym_CARET] = ACTIONS(2211),
    [anon_sym_PLUS] = ACTIONS(2185),
    [anon_sym_SLASH] = ACTIONS(2187),
    [anon_sym_PERCENT] = ACTIONS(2187),
    [sym_comment] = ACTIONS(87),
  },
  [3243] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(2185),
    [sym__binary_star] = ACTIONS(2187),
    [anon_sym_PIPE] = ACTIONS(2189),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2191),
    [anon_sym_LT] = ACTIONS(2193),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(2195),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2199),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(2203),
    [anon_sym_AMP_AMP] = ACTIONS(2203),
    [anon_sym_LT_LT] = ACTIONS(2205),
    [anon_sym_GT_GT] = ACTIONS(2205),
    [anon_sym_EQ_EQ] = ACTIONS(2207),
    [anon_sym_BANG_EQ] = ACTIONS(2203),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2203),
    [anon_sym_LT_EQ_GT] = ACTIONS(2203),
    [anon_sym_EQ_TILDE] = ACTIONS(2203),
    [anon_sym_BANG_TILDE] = ACTIONS(2203),
    [anon_sym_LT_EQ] = ACTIONS(2193),
    [anon_sym_GT] = ACTIONS(2193),
    [anon_sym_GT_EQ] = ACTIONS(2209),
    [anon_sym_CARET] = ACTIONS(2211),
    [anon_sym_PLUS] = ACTIONS(2185),
    [anon_sym_SLASH] = ACTIONS(2187),
    [anon_sym_PERCENT] = ACTIONS(2187),
    [sym_comment] = ACTIONS(87),
  },
  [3244] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(2185),
    [sym__binary_star] = ACTIONS(2187),
    [anon_sym_PIPE] = ACTIONS(2189),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2191),
    [anon_sym_LT] = ACTIONS(2193),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(2205),
    [anon_sym_GT_GT] = ACTIONS(2205),
    [anon_sym_EQ_EQ] = ACTIONS(2207),
    [anon_sym_BANG_EQ] = ACTIONS(2203),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2203),
    [anon_sym_LT_EQ_GT] = ACTIONS(2203),
    [anon_sym_EQ_TILDE] = ACTIONS(2203),
    [anon_sym_BANG_TILDE] = ACTIONS(2203),
    [anon_sym_LT_EQ] = ACTIONS(2193),
    [anon_sym_GT] = ACTIONS(2193),
    [anon_sym_GT_EQ] = ACTIONS(2209),
    [anon_sym_CARET] = ACTIONS(2211),
    [anon_sym_PLUS] = ACTIONS(2185),
    [anon_sym_SLASH] = ACTIONS(2187),
    [anon_sym_PERCENT] = ACTIONS(2187),
    [sym_comment] = ACTIONS(87),
  },
  [3245] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(2185),
    [sym__binary_star] = ACTIONS(2187),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(2185),
    [anon_sym_SLASH] = ACTIONS(2187),
    [anon_sym_PERCENT] = ACTIONS(2187),
    [sym_comment] = ACTIONS(87),
  },
  [3246] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(5897),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(3256),
    [sym_scope_resolution] = STATE(3254),
    [sym_call] = STATE(3254),
    [sym_method_call] = STATE(3256),
    [sym_assignment] = STATE(5897),
    [sym_operator_assignment] = STATE(5897),
    [sym_conditional] = STATE(5897),
    [sym_range] = STATE(5897),
    [sym_binary] = STATE(5897),
    [sym_unary] = STATE(5897),
    [sym_left_assignment_list] = STATE(3255),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3256),
    [sym__variable] = STATE(3254),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(3256),
    [sym_false] = STATE(3256),
    [sym_nil] = STATE(3256),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(3257),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(5413),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(5415),
    [anon_sym_yield] = ACTIONS(5417),
    [anon_sym_break] = ACTIONS(5419),
    [anon_sym_next] = ACTIONS(5421),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(5423),
    [anon_sym_defined_QMARK] = ACTIONS(5425),
    [anon_sym_not] = ACTIONS(5427),
    [anon_sym_BANG] = ACTIONS(5429),
    [anon_sym_TILDE] = ACTIONS(5429),
    [sym_constant] = ACTIONS(5431),
    [sym_identifier] = ACTIONS(5431),
    [sym_instance_variable] = ACTIONS(5433),
    [sym_class_variable] = ACTIONS(5433),
    [sym_global_variable] = ACTIONS(5433),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(5431),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5431),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [3247] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(1244),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1249),
    [sym_scope_resolution] = STATE(1245),
    [sym_call] = STATE(1245),
    [sym_method_call] = STATE(1249),
    [sym_argument_list] = STATE(3610),
    [sym__argument_list_with_parens] = STATE(1246),
    [sym__argument] = STATE(1247),
    [sym_splat_argument] = STATE(1247),
    [sym_hash_splat_argument] = STATE(1247),
    [sym_block_argument] = STATE(1247),
    [sym_assignment] = STATE(1244),
    [sym_operator_assignment] = STATE(1244),
    [sym_conditional] = STATE(1244),
    [sym_range] = STATE(1244),
    [sym_binary] = STATE(1244),
    [sym_unary] = STATE(1244),
    [sym_left_assignment_list] = STATE(1248),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(1245),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1249),
    [sym_false] = STATE(1249),
    [sym_nil] = STATE(1249),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(1250),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(1247),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(2213),
    [sym__splat_star] = ACTIONS(2215),
    [sym__unary_minus] = ACTIONS(2217),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(2219),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2223),
    [anon_sym_break] = ACTIONS(2225),
    [anon_sym_next] = ACTIONS(2227),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_else] = ACTIONS(377),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_ensure] = ACTIONS(377),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(365),
    [anon_sym_DASH_EQ] = ACTIONS(365),
    [anon_sym_STAR_EQ] = ACTIONS(365),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(365),
    [anon_sym_SLASH_EQ] = ACTIONS(365),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(365),
    [anon_sym_PIPE_EQ] = ACTIONS(365),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(365),
    [anon_sym_AMP_EQ] = ACTIONS(365),
    [anon_sym_PERCENT_EQ] = ACTIONS(365),
    [anon_sym_GT_GT_EQ] = ACTIONS(365),
    [anon_sym_LT_LT_EQ] = ACTIONS(365),
    [anon_sym_CARET_EQ] = ACTIONS(365),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_PERCENT] = ACTIONS(377),
    [anon_sym_defined_QMARK] = ACTIONS(2229),
    [anon_sym_not] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(2233),
    [anon_sym_TILDE] = ACTIONS(2235),
    [sym_constant] = ACTIONS(2237),
    [sym_identifier] = ACTIONS(2237),
    [sym_instance_variable] = ACTIONS(2239),
    [sym_class_variable] = ACTIONS(2239),
    [sym_global_variable] = ACTIONS(2239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(2241),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2241),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3248] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(1244),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1249),
    [sym_scope_resolution] = STATE(1245),
    [sym_call] = STATE(1245),
    [sym_method_call] = STATE(1249),
    [sym_argument_list] = STATE(3611),
    [sym__argument_list_with_parens] = STATE(1246),
    [sym__argument] = STATE(1247),
    [sym_splat_argument] = STATE(1247),
    [sym_hash_splat_argument] = STATE(1247),
    [sym_block_argument] = STATE(1247),
    [sym_assignment] = STATE(1244),
    [sym_operator_assignment] = STATE(1244),
    [sym_conditional] = STATE(1244),
    [sym_range] = STATE(1244),
    [sym_binary] = STATE(1244),
    [sym_unary] = STATE(1244),
    [sym_left_assignment_list] = STATE(1248),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(1245),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1249),
    [sym_false] = STATE(1249),
    [sym_nil] = STATE(1249),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(1250),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(1247),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(2213),
    [sym__splat_star] = ACTIONS(2215),
    [sym__unary_minus] = ACTIONS(2217),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(2219),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_EQ] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2223),
    [anon_sym_break] = ACTIONS(2225),
    [anon_sym_next] = ACTIONS(2227),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_else] = ACTIONS(419),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_ensure] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(417),
    [anon_sym_DASH_EQ] = ACTIONS(417),
    [anon_sym_STAR_EQ] = ACTIONS(417),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(417),
    [anon_sym_SLASH_EQ] = ACTIONS(417),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(417),
    [anon_sym_PIPE_EQ] = ACTIONS(417),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(417),
    [anon_sym_AMP_EQ] = ACTIONS(417),
    [anon_sym_PERCENT_EQ] = ACTIONS(417),
    [anon_sym_GT_GT_EQ] = ACTIONS(417),
    [anon_sym_LT_LT_EQ] = ACTIONS(417),
    [anon_sym_CARET_EQ] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(2229),
    [anon_sym_not] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(2233),
    [anon_sym_TILDE] = ACTIONS(2235),
    [sym_constant] = ACTIONS(2237),
    [sym_identifier] = ACTIONS(2237),
    [sym_instance_variable] = ACTIONS(2239),
    [sym_class_variable] = ACTIONS(2239),
    [sym_global_variable] = ACTIONS(2239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(2241),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2241),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3249] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(1244),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1249),
    [sym_scope_resolution] = STATE(1245),
    [sym_call] = STATE(1245),
    [sym_method_call] = STATE(1249),
    [sym_argument_list] = STATE(3612),
    [sym__argument_list_with_parens] = STATE(1246),
    [sym__argument] = STATE(1247),
    [sym_splat_argument] = STATE(1247),
    [sym_hash_splat_argument] = STATE(1247),
    [sym_block_argument] = STATE(1247),
    [sym_assignment] = STATE(1244),
    [sym_operator_assignment] = STATE(1244),
    [sym_conditional] = STATE(1244),
    [sym_range] = STATE(1244),
    [sym_binary] = STATE(1244),
    [sym_unary] = STATE(1244),
    [sym_left_assignment_list] = STATE(1248),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(1245),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1249),
    [sym_false] = STATE(1249),
    [sym_nil] = STATE(1249),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(1250),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(1247),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(2213),
    [sym__splat_star] = ACTIONS(2215),
    [sym__unary_minus] = ACTIONS(2217),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(2219),
    [anon_sym_LBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_EQ] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(423),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2223),
    [anon_sym_break] = ACTIONS(2225),
    [anon_sym_next] = ACTIONS(2227),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_else] = ACTIONS(423),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_ensure] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(421),
    [anon_sym_DASH_EQ] = ACTIONS(421),
    [anon_sym_STAR_EQ] = ACTIONS(421),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(421),
    [anon_sym_SLASH_EQ] = ACTIONS(421),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(421),
    [anon_sym_PIPE_EQ] = ACTIONS(421),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(421),
    [anon_sym_AMP_EQ] = ACTIONS(421),
    [anon_sym_PERCENT_EQ] = ACTIONS(421),
    [anon_sym_GT_GT_EQ] = ACTIONS(421),
    [anon_sym_LT_LT_EQ] = ACTIONS(421),
    [anon_sym_CARET_EQ] = ACTIONS(421),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(2229),
    [anon_sym_not] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(2233),
    [anon_sym_TILDE] = ACTIONS(2235),
    [sym_constant] = ACTIONS(2237),
    [sym_identifier] = ACTIONS(2237),
    [sym_instance_variable] = ACTIONS(2239),
    [sym_class_variable] = ACTIONS(2239),
    [sym_global_variable] = ACTIONS(2239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(2241),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2241),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3250] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(1244),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1249),
    [sym_scope_resolution] = STATE(1245),
    [sym_call] = STATE(1245),
    [sym_method_call] = STATE(1249),
    [sym_argument_list] = STATE(3613),
    [sym__argument_list_with_parens] = STATE(1246),
    [sym__argument] = STATE(1247),
    [sym_splat_argument] = STATE(1247),
    [sym_hash_splat_argument] = STATE(1247),
    [sym_block_argument] = STATE(1247),
    [sym_assignment] = STATE(1244),
    [sym_operator_assignment] = STATE(1244),
    [sym_conditional] = STATE(1244),
    [sym_range] = STATE(1244),
    [sym_binary] = STATE(1244),
    [sym_unary] = STATE(1244),
    [sym_left_assignment_list] = STATE(1248),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(1245),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1249),
    [sym_false] = STATE(1249),
    [sym_nil] = STATE(1249),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(1250),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(1247),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(2213),
    [sym__splat_star] = ACTIONS(2215),
    [sym__unary_minus] = ACTIONS(2217),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(2219),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(427),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(427),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2223),
    [anon_sym_break] = ACTIONS(2225),
    [anon_sym_next] = ACTIONS(2227),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_else] = ACTIONS(427),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_ensure] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(425),
    [anon_sym_DASH_EQ] = ACTIONS(425),
    [anon_sym_STAR_EQ] = ACTIONS(425),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(425),
    [anon_sym_SLASH_EQ] = ACTIONS(425),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(425),
    [anon_sym_PIPE_EQ] = ACTIONS(425),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(425),
    [anon_sym_AMP_EQ] = ACTIONS(425),
    [anon_sym_PERCENT_EQ] = ACTIONS(425),
    [anon_sym_GT_GT_EQ] = ACTIONS(425),
    [anon_sym_LT_LT_EQ] = ACTIONS(425),
    [anon_sym_CARET_EQ] = ACTIONS(425),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(2229),
    [anon_sym_not] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(2233),
    [anon_sym_TILDE] = ACTIONS(2235),
    [sym_constant] = ACTIONS(2237),
    [sym_identifier] = ACTIONS(2237),
    [sym_instance_variable] = ACTIONS(2239),
    [sym_class_variable] = ACTIONS(2239),
    [sym_global_variable] = ACTIONS(2239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(2241),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2241),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3251] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(5898),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(3256),
    [sym_scope_resolution] = STATE(3254),
    [sym_call] = STATE(3254),
    [sym_method_call] = STATE(3256),
    [sym_assignment] = STATE(5898),
    [sym_operator_assignment] = STATE(5898),
    [sym_conditional] = STATE(5898),
    [sym_range] = STATE(5898),
    [sym_binary] = STATE(5898),
    [sym_unary] = STATE(5898),
    [sym_left_assignment_list] = STATE(3255),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3256),
    [sym__variable] = STATE(3254),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(3256),
    [sym_false] = STATE(3256),
    [sym_nil] = STATE(3256),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(3257),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(5413),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(5415),
    [anon_sym_yield] = ACTIONS(5417),
    [anon_sym_break] = ACTIONS(5419),
    [anon_sym_next] = ACTIONS(5421),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(5423),
    [anon_sym_defined_QMARK] = ACTIONS(5425),
    [anon_sym_not] = ACTIONS(5427),
    [anon_sym_BANG] = ACTIONS(5429),
    [anon_sym_TILDE] = ACTIONS(5429),
    [sym_constant] = ACTIONS(5431),
    [sym_identifier] = ACTIONS(5431),
    [sym_instance_variable] = ACTIONS(5433),
    [sym_class_variable] = ACTIONS(5433),
    [sym_global_variable] = ACTIONS(5433),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(5431),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5431),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [3252] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(3628),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(3256),
    [sym_scope_resolution] = STATE(3254),
    [sym_call] = STATE(3254),
    [sym_method_call] = STATE(3256),
    [sym_assignment] = STATE(3628),
    [sym_operator_assignment] = STATE(3628),
    [sym_conditional] = STATE(3628),
    [sym_range] = STATE(3628),
    [sym_binary] = STATE(3628),
    [sym_unary] = STATE(3628),
    [sym_left_assignment_list] = STATE(3255),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3256),
    [sym__variable] = STATE(3254),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(3256),
    [sym_false] = STATE(3256),
    [sym_nil] = STATE(3256),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(3257),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(5413),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(5415),
    [anon_sym_yield] = ACTIONS(5417),
    [anon_sym_break] = ACTIONS(5419),
    [anon_sym_next] = ACTIONS(5421),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(5423),
    [anon_sym_defined_QMARK] = ACTIONS(5425),
    [anon_sym_not] = ACTIONS(5427),
    [anon_sym_BANG] = ACTIONS(5429),
    [anon_sym_TILDE] = ACTIONS(5429),
    [sym_constant] = ACTIONS(5431),
    [sym_identifier] = ACTIONS(5431),
    [sym_instance_variable] = ACTIONS(5433),
    [sym_class_variable] = ACTIONS(5433),
    [sym_global_variable] = ACTIONS(5433),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(5431),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5431),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [3253] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(9193),
    [sym__binary_star] = ACTIONS(9195),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(9197),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(9199),
    [anon_sym_AMP] = ACTIONS(9201),
    [anon_sym_EQ] = ACTIONS(4217),
    [anon_sym_LT] = ACTIONS(9203),
    [anon_sym_end] = ACTIONS(4211),
    [anon_sym_if] = ACTIONS(4211),
    [anon_sym_unless] = ACTIONS(4211),
    [anon_sym_while] = ACTIONS(4211),
    [anon_sym_until] = ACTIONS(4211),
    [anon_sym_rescue] = ACTIONS(4211),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_else] = ACTIONS(4211),
    [anon_sym_ensure] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_PLUS_EQ] = ACTIONS(4211),
    [anon_sym_DASH_EQ] = ACTIONS(4211),
    [anon_sym_STAR_EQ] = ACTIONS(4211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4211),
    [anon_sym_SLASH_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4211),
    [anon_sym_AMP_EQ] = ACTIONS(4211),
    [anon_sym_PERCENT_EQ] = ACTIONS(4211),
    [anon_sym_GT_GT_EQ] = ACTIONS(4211),
    [anon_sym_LT_LT_EQ] = ACTIONS(4211),
    [anon_sym_CARET_EQ] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(9205),
    [anon_sym_DOT_DOT] = ACTIONS(9207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9209),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(9211),
    [anon_sym_AMP_AMP] = ACTIONS(9211),
    [anon_sym_LT_LT] = ACTIONS(9213),
    [anon_sym_GT_GT] = ACTIONS(9213),
    [anon_sym_EQ_EQ] = ACTIONS(9211),
    [anon_sym_BANG_EQ] = ACTIONS(9215),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9215),
    [anon_sym_LT_EQ_GT] = ACTIONS(9215),
    [anon_sym_EQ_TILDE] = ACTIONS(9215),
    [anon_sym_BANG_TILDE] = ACTIONS(9215),
    [anon_sym_LT_EQ] = ACTIONS(9203),
    [anon_sym_GT] = ACTIONS(9203),
    [anon_sym_GT_EQ] = ACTIONS(9217),
    [anon_sym_CARET] = ACTIONS(9197),
    [anon_sym_PLUS] = ACTIONS(9219),
    [anon_sym_SLASH] = ACTIONS(9199),
    [anon_sym_PERCENT] = ACTIONS(9199),
    [sym_comment] = ACTIONS(87),
  },
  [3254] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(1244),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1249),
    [sym_scope_resolution] = STATE(1245),
    [sym_call] = STATE(1245),
    [sym_method_call] = STATE(1249),
    [sym_argument_list] = STATE(1062),
    [sym__argument_list_with_parens] = STATE(1246),
    [sym__argument] = STATE(1247),
    [sym_splat_argument] = STATE(1247),
    [sym_hash_splat_argument] = STATE(1247),
    [sym_block_argument] = STATE(1247),
    [sym_do_block] = STATE(426),
    [sym_block] = STATE(426),
    [sym_assignment] = STATE(1244),
    [sym_operator_assignment] = STATE(1244),
    [sym_conditional] = STATE(1244),
    [sym_range] = STATE(1244),
    [sym_binary] = STATE(1244),
    [sym_unary] = STATE(1244),
    [sym_left_assignment_list] = STATE(1248),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(1245),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1249),
    [sym_false] = STATE(1249),
    [sym_nil] = STATE(1249),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(1250),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(1247),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(743),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(2213),
    [sym__splat_star] = ACTIONS(2215),
    [sym__unary_minus] = ACTIONS(2217),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(2219),
    [anon_sym_LBRACE] = ACTIONS(6047),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(769),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2223),
    [anon_sym_break] = ACTIONS(2225),
    [anon_sym_next] = ACTIONS(2227),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(769),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(769),
    [anon_sym_until] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(769),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(769),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_else] = ACTIONS(769),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_ensure] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(2229),
    [anon_sym_not] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(2233),
    [anon_sym_TILDE] = ACTIONS(2235),
    [sym_constant] = ACTIONS(2237),
    [sym_identifier] = ACTIONS(2237),
    [sym_instance_variable] = ACTIONS(2239),
    [sym_class_variable] = ACTIONS(2239),
    [sym_global_variable] = ACTIONS(2239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(2241),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2241),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3255] = {
    [anon_sym_EQ] = ACTIONS(9221),
    [sym_comment] = ACTIONS(87),
  },
  [3256] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(9223),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(9225),
    [anon_sym_DASH_EQ] = ACTIONS(9225),
    [anon_sym_STAR_EQ] = ACTIONS(9225),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9225),
    [anon_sym_SLASH_EQ] = ACTIONS(9225),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9225),
    [anon_sym_PIPE_EQ] = ACTIONS(9225),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9225),
    [anon_sym_AMP_EQ] = ACTIONS(9225),
    [anon_sym_PERCENT_EQ] = ACTIONS(9225),
    [anon_sym_GT_GT_EQ] = ACTIONS(9225),
    [anon_sym_LT_LT_EQ] = ACTIONS(9225),
    [anon_sym_CARET_EQ] = ACTIONS(9225),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3257] = {
    [sym_string] = STATE(5911),
    [aux_sym_chained_string_repeat1] = STATE(5911),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(2551),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3258] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(9193),
    [sym__binary_star] = ACTIONS(9195),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(9197),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(9199),
    [anon_sym_AMP] = ACTIONS(9201),
    [anon_sym_EQ] = ACTIONS(4249),
    [anon_sym_LT] = ACTIONS(9203),
    [anon_sym_end] = ACTIONS(4247),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_else] = ACTIONS(4247),
    [anon_sym_ensure] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_PLUS_EQ] = ACTIONS(4247),
    [anon_sym_DASH_EQ] = ACTIONS(4247),
    [anon_sym_STAR_EQ] = ACTIONS(4247),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4247),
    [anon_sym_SLASH_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4247),
    [anon_sym_AMP_EQ] = ACTIONS(4247),
    [anon_sym_PERCENT_EQ] = ACTIONS(4247),
    [anon_sym_GT_GT_EQ] = ACTIONS(4247),
    [anon_sym_LT_LT_EQ] = ACTIONS(4247),
    [anon_sym_CARET_EQ] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(9205),
    [anon_sym_DOT_DOT] = ACTIONS(9207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9209),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(9211),
    [anon_sym_AMP_AMP] = ACTIONS(9211),
    [anon_sym_LT_LT] = ACTIONS(9213),
    [anon_sym_GT_GT] = ACTIONS(9213),
    [anon_sym_EQ_EQ] = ACTIONS(9211),
    [anon_sym_BANG_EQ] = ACTIONS(9215),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9215),
    [anon_sym_LT_EQ_GT] = ACTIONS(9215),
    [anon_sym_EQ_TILDE] = ACTIONS(9215),
    [anon_sym_BANG_TILDE] = ACTIONS(9215),
    [anon_sym_LT_EQ] = ACTIONS(9203),
    [anon_sym_GT] = ACTIONS(9203),
    [anon_sym_GT_EQ] = ACTIONS(9217),
    [anon_sym_CARET] = ACTIONS(9197),
    [anon_sym_PLUS] = ACTIONS(9219),
    [anon_sym_SLASH] = ACTIONS(9199),
    [anon_sym_PERCENT] = ACTIONS(9199),
    [sym_comment] = ACTIONS(87),
  },
  [3259] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(5447),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_ensure] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [3260] = {
    [sym_string] = STATE(3280),
    [aux_sym_chained_string_repeat1] = STATE(3280),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(747),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3261] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(5912),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(3256),
    [sym_scope_resolution] = STATE(3254),
    [sym_call] = STATE(3254),
    [sym_method_call] = STATE(3256),
    [sym_assignment] = STATE(5912),
    [sym_operator_assignment] = STATE(5912),
    [sym_conditional] = STATE(5912),
    [sym_range] = STATE(5912),
    [sym_binary] = STATE(5912),
    [sym_unary] = STATE(5912),
    [sym_left_assignment_list] = STATE(3255),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3256),
    [sym__variable] = STATE(3254),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(3256),
    [sym_false] = STATE(3256),
    [sym_nil] = STATE(3256),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(3257),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(5413),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(5415),
    [anon_sym_yield] = ACTIONS(5417),
    [anon_sym_break] = ACTIONS(5419),
    [anon_sym_next] = ACTIONS(5421),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(5423),
    [anon_sym_defined_QMARK] = ACTIONS(5425),
    [anon_sym_not] = ACTIONS(5427),
    [anon_sym_BANG] = ACTIONS(5429),
    [anon_sym_TILDE] = ACTIONS(5429),
    [sym_constant] = ACTIONS(5431),
    [sym_identifier] = ACTIONS(5431),
    [sym_instance_variable] = ACTIONS(5433),
    [sym_class_variable] = ACTIONS(5433),
    [sym_global_variable] = ACTIONS(5433),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(5431),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5431),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [3262] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(9193),
    [sym__binary_star] = ACTIONS(9195),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(9197),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(9199),
    [anon_sym_AMP] = ACTIONS(9201),
    [anon_sym_EQ] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(9203),
    [anon_sym_end] = ACTIONS(3281),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_unless] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_until] = ACTIONS(3281),
    [anon_sym_rescue] = ACTIONS(3281),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_else] = ACTIONS(3281),
    [anon_sym_ensure] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_PLUS_EQ] = ACTIONS(3281),
    [anon_sym_DASH_EQ] = ACTIONS(3281),
    [anon_sym_STAR_EQ] = ACTIONS(3281),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3281),
    [anon_sym_SLASH_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3281),
    [anon_sym_AMP_EQ] = ACTIONS(3281),
    [anon_sym_PERCENT_EQ] = ACTIONS(3281),
    [anon_sym_GT_GT_EQ] = ACTIONS(3281),
    [anon_sym_LT_LT_EQ] = ACTIONS(3281),
    [anon_sym_CARET_EQ] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(9205),
    [anon_sym_DOT_DOT] = ACTIONS(9207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9209),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(9211),
    [anon_sym_AMP_AMP] = ACTIONS(9211),
    [anon_sym_LT_LT] = ACTIONS(9213),
    [anon_sym_GT_GT] = ACTIONS(9213),
    [anon_sym_EQ_EQ] = ACTIONS(9211),
    [anon_sym_BANG_EQ] = ACTIONS(9215),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9215),
    [anon_sym_LT_EQ_GT] = ACTIONS(9215),
    [anon_sym_EQ_TILDE] = ACTIONS(9215),
    [anon_sym_BANG_TILDE] = ACTIONS(9215),
    [anon_sym_LT_EQ] = ACTIONS(9203),
    [anon_sym_GT] = ACTIONS(9203),
    [anon_sym_GT_EQ] = ACTIONS(9217),
    [anon_sym_CARET] = ACTIONS(9197),
    [anon_sym_PLUS] = ACTIONS(9219),
    [anon_sym_SLASH] = ACTIONS(9199),
    [anon_sym_PERCENT] = ACTIONS(9199),
    [sym_comment] = ACTIONS(87),
  },
  [3263] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(5441),
    [sym__binary_star] = ACTIONS(5443),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(5445),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(5447),
    [anon_sym_AMP] = ACTIONS(5449),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(5451),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_ensure] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(5453),
    [anon_sym_DOT_DOT] = ACTIONS(5455),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5457),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(5459),
    [anon_sym_AMP_AMP] = ACTIONS(5459),
    [anon_sym_LT_LT] = ACTIONS(5461),
    [anon_sym_GT_GT] = ACTIONS(5461),
    [anon_sym_EQ_EQ] = ACTIONS(5459),
    [anon_sym_BANG_EQ] = ACTIONS(5463),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5463),
    [anon_sym_LT_EQ_GT] = ACTIONS(5463),
    [anon_sym_EQ_TILDE] = ACTIONS(5463),
    [anon_sym_BANG_TILDE] = ACTIONS(5463),
    [anon_sym_LT_EQ] = ACTIONS(5451),
    [anon_sym_GT] = ACTIONS(5451),
    [anon_sym_GT_EQ] = ACTIONS(5465),
    [anon_sym_CARET] = ACTIONS(5445),
    [anon_sym_PLUS] = ACTIONS(5467),
    [anon_sym_SLASH] = ACTIONS(5447),
    [anon_sym_PERCENT] = ACTIONS(5447),
    [sym_comment] = ACTIONS(87),
  },
  [3264] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(5913),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(3256),
    [sym_scope_resolution] = STATE(3254),
    [sym_call] = STATE(3254),
    [sym_method_call] = STATE(3256),
    [sym_assignment] = STATE(5913),
    [sym_operator_assignment] = STATE(5913),
    [sym_conditional] = STATE(5913),
    [sym_range] = STATE(5913),
    [sym_binary] = STATE(5913),
    [sym_unary] = STATE(5913),
    [sym_left_assignment_list] = STATE(3255),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3256),
    [sym__variable] = STATE(3254),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(3256),
    [sym_false] = STATE(3256),
    [sym_nil] = STATE(3256),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(3257),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(5413),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(5415),
    [anon_sym_yield] = ACTIONS(5417),
    [anon_sym_break] = ACTIONS(5419),
    [anon_sym_next] = ACTIONS(5421),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(5423),
    [anon_sym_defined_QMARK] = ACTIONS(5425),
    [anon_sym_not] = ACTIONS(5427),
    [anon_sym_BANG] = ACTIONS(5429),
    [anon_sym_TILDE] = ACTIONS(5429),
    [sym_constant] = ACTIONS(5431),
    [sym_identifier] = ACTIONS(5431),
    [sym_instance_variable] = ACTIONS(5433),
    [sym_class_variable] = ACTIONS(5433),
    [sym_global_variable] = ACTIONS(5433),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(5431),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5431),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [3265] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5914),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1249),
    [sym_scope_resolution] = STATE(1245),
    [sym_call] = STATE(1245),
    [sym_method_call] = STATE(1249),
    [sym_assignment] = STATE(5914),
    [sym_operator_assignment] = STATE(5914),
    [sym_conditional] = STATE(5914),
    [sym_range] = STATE(5914),
    [sym_binary] = STATE(5914),
    [sym_unary] = STATE(5914),
    [sym_left_assignment_list] = STATE(1248),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(1245),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1249),
    [sym_false] = STATE(1249),
    [sym_nil] = STATE(1249),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3260),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2223),
    [anon_sym_break] = ACTIONS(2225),
    [anon_sym_next] = ACTIONS(2227),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(5435),
    [anon_sym_defined_QMARK] = ACTIONS(2229),
    [anon_sym_not] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(2235),
    [anon_sym_TILDE] = ACTIONS(2235),
    [sym_constant] = ACTIONS(2241),
    [sym_identifier] = ACTIONS(2241),
    [sym_instance_variable] = ACTIONS(2239),
    [sym_class_variable] = ACTIONS(2239),
    [sym_global_variable] = ACTIONS(2239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(2241),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2241),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3266] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5915),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1249),
    [sym_scope_resolution] = STATE(1245),
    [sym_call] = STATE(1245),
    [sym_method_call] = STATE(1249),
    [sym_assignment] = STATE(5915),
    [sym_operator_assignment] = STATE(5915),
    [sym_conditional] = STATE(5915),
    [sym_range] = STATE(5915),
    [sym_binary] = STATE(5915),
    [sym_unary] = STATE(5915),
    [sym_left_assignment_list] = STATE(1248),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(1245),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1249),
    [sym_false] = STATE(1249),
    [sym_nil] = STATE(1249),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3260),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2223),
    [anon_sym_break] = ACTIONS(2225),
    [anon_sym_next] = ACTIONS(2227),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(5435),
    [anon_sym_defined_QMARK] = ACTIONS(2229),
    [anon_sym_not] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(2235),
    [anon_sym_TILDE] = ACTIONS(2235),
    [sym_constant] = ACTIONS(2241),
    [sym_identifier] = ACTIONS(2241),
    [sym_instance_variable] = ACTIONS(2239),
    [sym_class_variable] = ACTIONS(2239),
    [sym_global_variable] = ACTIONS(2239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(2241),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2241),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3267] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5916),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1249),
    [sym_scope_resolution] = STATE(1245),
    [sym_call] = STATE(1245),
    [sym_method_call] = STATE(1249),
    [sym_assignment] = STATE(5916),
    [sym_operator_assignment] = STATE(5916),
    [sym_conditional] = STATE(5916),
    [sym_range] = STATE(5916),
    [sym_binary] = STATE(5916),
    [sym_unary] = STATE(5916),
    [sym_left_assignment_list] = STATE(1248),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(1245),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1249),
    [sym_false] = STATE(1249),
    [sym_nil] = STATE(1249),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3260),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2223),
    [anon_sym_break] = ACTIONS(2225),
    [anon_sym_next] = ACTIONS(2227),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(5435),
    [anon_sym_defined_QMARK] = ACTIONS(2229),
    [anon_sym_not] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(2235),
    [anon_sym_TILDE] = ACTIONS(2235),
    [sym_constant] = ACTIONS(2241),
    [sym_identifier] = ACTIONS(2241),
    [sym_instance_variable] = ACTIONS(2239),
    [sym_class_variable] = ACTIONS(2239),
    [sym_global_variable] = ACTIONS(2239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(2241),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2241),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3268] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5917),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1249),
    [sym_scope_resolution] = STATE(1245),
    [sym_call] = STATE(1245),
    [sym_method_call] = STATE(1249),
    [sym_assignment] = STATE(5917),
    [sym_operator_assignment] = STATE(5917),
    [sym_conditional] = STATE(5917),
    [sym_range] = STATE(5917),
    [sym_binary] = STATE(5917),
    [sym_unary] = STATE(5917),
    [sym_left_assignment_list] = STATE(1248),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(1245),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1249),
    [sym_false] = STATE(1249),
    [sym_nil] = STATE(1249),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3260),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2223),
    [anon_sym_break] = ACTIONS(2225),
    [anon_sym_next] = ACTIONS(2227),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(5435),
    [anon_sym_defined_QMARK] = ACTIONS(2229),
    [anon_sym_not] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(2235),
    [anon_sym_TILDE] = ACTIONS(2235),
    [sym_constant] = ACTIONS(2241),
    [sym_identifier] = ACTIONS(2241),
    [sym_instance_variable] = ACTIONS(2239),
    [sym_class_variable] = ACTIONS(2239),
    [sym_global_variable] = ACTIONS(2239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(2241),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2241),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3269] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5918),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1249),
    [sym_scope_resolution] = STATE(1245),
    [sym_call] = STATE(1245),
    [sym_method_call] = STATE(1249),
    [sym_assignment] = STATE(5918),
    [sym_operator_assignment] = STATE(5918),
    [sym_conditional] = STATE(5918),
    [sym_range] = STATE(5918),
    [sym_binary] = STATE(5918),
    [sym_unary] = STATE(5918),
    [sym_left_assignment_list] = STATE(1248),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(1245),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1249),
    [sym_false] = STATE(1249),
    [sym_nil] = STATE(1249),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3260),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2223),
    [anon_sym_break] = ACTIONS(2225),
    [anon_sym_next] = ACTIONS(2227),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(5435),
    [anon_sym_defined_QMARK] = ACTIONS(2229),
    [anon_sym_not] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(2235),
    [anon_sym_TILDE] = ACTIONS(2235),
    [sym_constant] = ACTIONS(2241),
    [sym_identifier] = ACTIONS(2241),
    [sym_instance_variable] = ACTIONS(2239),
    [sym_class_variable] = ACTIONS(2239),
    [sym_global_variable] = ACTIONS(2239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(2241),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2241),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3270] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(5919),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(5919),
    [sym_operator_assignment] = STATE(5919),
    [sym_conditional] = STATE(5919),
    [sym_range] = STATE(5919),
    [sym_binary] = STATE(5919),
    [sym_unary] = STATE(5919),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3271] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5920),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1249),
    [sym_scope_resolution] = STATE(1245),
    [sym_call] = STATE(1245),
    [sym_method_call] = STATE(1249),
    [sym_assignment] = STATE(5920),
    [sym_operator_assignment] = STATE(5920),
    [sym_conditional] = STATE(5920),
    [sym_range] = STATE(5920),
    [sym_binary] = STATE(5920),
    [sym_unary] = STATE(5920),
    [sym_left_assignment_list] = STATE(1248),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(1245),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1249),
    [sym_false] = STATE(1249),
    [sym_nil] = STATE(1249),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3260),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2223),
    [anon_sym_break] = ACTIONS(2225),
    [anon_sym_next] = ACTIONS(2227),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(5435),
    [anon_sym_defined_QMARK] = ACTIONS(2229),
    [anon_sym_not] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(2235),
    [anon_sym_TILDE] = ACTIONS(2235),
    [sym_constant] = ACTIONS(2241),
    [sym_identifier] = ACTIONS(2241),
    [sym_instance_variable] = ACTIONS(2239),
    [sym_class_variable] = ACTIONS(2239),
    [sym_global_variable] = ACTIONS(2239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(2241),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2241),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3272] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5921),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1249),
    [sym_scope_resolution] = STATE(1245),
    [sym_call] = STATE(1245),
    [sym_method_call] = STATE(1249),
    [sym_assignment] = STATE(5921),
    [sym_operator_assignment] = STATE(5921),
    [sym_conditional] = STATE(5921),
    [sym_range] = STATE(5921),
    [sym_binary] = STATE(5921),
    [sym_unary] = STATE(5921),
    [sym_left_assignment_list] = STATE(1248),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(1245),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1249),
    [sym_false] = STATE(1249),
    [sym_nil] = STATE(1249),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3260),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2223),
    [anon_sym_break] = ACTIONS(2225),
    [anon_sym_next] = ACTIONS(2227),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(5435),
    [anon_sym_defined_QMARK] = ACTIONS(2229),
    [anon_sym_not] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(2235),
    [anon_sym_TILDE] = ACTIONS(2235),
    [sym_constant] = ACTIONS(2241),
    [sym_identifier] = ACTIONS(2241),
    [sym_instance_variable] = ACTIONS(2239),
    [sym_class_variable] = ACTIONS(2239),
    [sym_global_variable] = ACTIONS(2239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(2241),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2241),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3273] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5922),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1249),
    [sym_scope_resolution] = STATE(1245),
    [sym_call] = STATE(1245),
    [sym_method_call] = STATE(1249),
    [sym_assignment] = STATE(5922),
    [sym_operator_assignment] = STATE(5922),
    [sym_conditional] = STATE(5922),
    [sym_range] = STATE(5922),
    [sym_binary] = STATE(5922),
    [sym_unary] = STATE(5922),
    [sym_left_assignment_list] = STATE(1248),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(1245),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1249),
    [sym_false] = STATE(1249),
    [sym_nil] = STATE(1249),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3260),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2223),
    [anon_sym_break] = ACTIONS(2225),
    [anon_sym_next] = ACTIONS(2227),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(5435),
    [anon_sym_defined_QMARK] = ACTIONS(2229),
    [anon_sym_not] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(2235),
    [anon_sym_TILDE] = ACTIONS(2235),
    [sym_constant] = ACTIONS(2241),
    [sym_identifier] = ACTIONS(2241),
    [sym_instance_variable] = ACTIONS(2239),
    [sym_class_variable] = ACTIONS(2239),
    [sym_global_variable] = ACTIONS(2239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(2241),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2241),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3274] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5923),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1249),
    [sym_scope_resolution] = STATE(1245),
    [sym_call] = STATE(1245),
    [sym_method_call] = STATE(1249),
    [sym_assignment] = STATE(5923),
    [sym_operator_assignment] = STATE(5923),
    [sym_conditional] = STATE(5923),
    [sym_range] = STATE(5923),
    [sym_binary] = STATE(5923),
    [sym_unary] = STATE(5923),
    [sym_left_assignment_list] = STATE(1248),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(1245),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1249),
    [sym_false] = STATE(1249),
    [sym_nil] = STATE(1249),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3260),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2223),
    [anon_sym_break] = ACTIONS(2225),
    [anon_sym_next] = ACTIONS(2227),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(5435),
    [anon_sym_defined_QMARK] = ACTIONS(2229),
    [anon_sym_not] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(2235),
    [anon_sym_TILDE] = ACTIONS(2235),
    [sym_constant] = ACTIONS(2241),
    [sym_identifier] = ACTIONS(2241),
    [sym_instance_variable] = ACTIONS(2239),
    [sym_class_variable] = ACTIONS(2239),
    [sym_global_variable] = ACTIONS(2239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(2241),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2241),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3275] = {
    [sym_heredoc_body] = STATE(5924),
    [aux_sym_call_repeat1] = STATE(5924),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_else] = ACTIONS(4383),
    [anon_sym_ensure] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [3276] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(1244),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1249),
    [sym_scope_resolution] = STATE(1245),
    [sym_call] = STATE(1245),
    [sym_method_call] = STATE(1249),
    [sym__argument] = STATE(3737),
    [sym_splat_argument] = STATE(3737),
    [sym_hash_splat_argument] = STATE(3737),
    [sym_block_argument] = STATE(3737),
    [sym_assignment] = STATE(1244),
    [sym_operator_assignment] = STATE(1244),
    [sym_conditional] = STATE(1244),
    [sym_range] = STATE(1244),
    [sym_binary] = STATE(1244),
    [sym_unary] = STATE(1244),
    [sym_left_assignment_list] = STATE(1248),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(1245),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1249),
    [sym_false] = STATE(1249),
    [sym_nil] = STATE(1249),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(1250),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_heredoc_body] = STATE(5925),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(3737),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(2213),
    [sym__splat_star] = ACTIONS(2215),
    [sym__unary_minus] = ACTIONS(2217),
    [sym__identifier_hash_key] = ACTIONS(2219),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(9227),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2223),
    [anon_sym_break] = ACTIONS(2225),
    [anon_sym_next] = ACTIONS(2227),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(5435),
    [anon_sym_defined_QMARK] = ACTIONS(2229),
    [anon_sym_not] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(2235),
    [anon_sym_TILDE] = ACTIONS(2235),
    [sym_constant] = ACTIONS(2237),
    [sym_identifier] = ACTIONS(2237),
    [sym_instance_variable] = ACTIONS(2239),
    [sym_class_variable] = ACTIONS(2239),
    [sym_global_variable] = ACTIONS(2239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(2241),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2241),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3277] = {
    [sym_heredoc_body] = STATE(5926),
    [aux_sym_call_repeat1] = STATE(5926),
    [aux_sym_argument_list_repeat1] = STATE(5927),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(5469),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_else] = ACTIONS(4383),
    [anon_sym_ensure] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [3278] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5928),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1249),
    [sym_scope_resolution] = STATE(1245),
    [sym_call] = STATE(1245),
    [sym_method_call] = STATE(1249),
    [sym_splat_argument] = STATE(5929),
    [sym_assignment] = STATE(5928),
    [sym_operator_assignment] = STATE(5928),
    [sym_conditional] = STATE(5928),
    [sym_range] = STATE(5928),
    [sym_binary] = STATE(5928),
    [sym_unary] = STATE(5928),
    [sym_right_assignment_list] = STATE(3742),
    [sym__arg_or_splat_arg] = STATE(5929),
    [sym_left_assignment_list] = STATE(1248),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(1245),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1249),
    [sym_false] = STATE(1249),
    [sym_nil] = STATE(1249),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3260),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__splat_star] = ACTIONS(5061),
    [sym__unary_minus] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2223),
    [anon_sym_break] = ACTIONS(2225),
    [anon_sym_next] = ACTIONS(2227),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(5435),
    [anon_sym_defined_QMARK] = ACTIONS(2229),
    [anon_sym_not] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(2235),
    [anon_sym_TILDE] = ACTIONS(2235),
    [sym_constant] = ACTIONS(2241),
    [sym_identifier] = ACTIONS(2241),
    [sym_instance_variable] = ACTIONS(2239),
    [sym_class_variable] = ACTIONS(2239),
    [sym_global_variable] = ACTIONS(2239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(2241),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2241),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3279] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5930),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1249),
    [sym_scope_resolution] = STATE(1245),
    [sym_call] = STATE(1245),
    [sym_method_call] = STATE(1249),
    [sym_assignment] = STATE(5930),
    [sym_operator_assignment] = STATE(5930),
    [sym_conditional] = STATE(5930),
    [sym_range] = STATE(5930),
    [sym_binary] = STATE(5930),
    [sym_unary] = STATE(5930),
    [sym_left_assignment_list] = STATE(1248),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(1245),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1249),
    [sym_false] = STATE(1249),
    [sym_nil] = STATE(1249),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3260),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2223),
    [anon_sym_break] = ACTIONS(2225),
    [anon_sym_next] = ACTIONS(2227),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(5435),
    [anon_sym_defined_QMARK] = ACTIONS(2229),
    [anon_sym_not] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(2235),
    [anon_sym_TILDE] = ACTIONS(2235),
    [sym_constant] = ACTIONS(2241),
    [sym_identifier] = ACTIONS(2241),
    [sym_instance_variable] = ACTIONS(2239),
    [sym_class_variable] = ACTIONS(2239),
    [sym_global_variable] = ACTIONS(2239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(2241),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2241),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3280] = {
    [sym_string] = STATE(5931),
    [aux_sym_chained_string_repeat1] = STATE(5931),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(747),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2755),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_EQ] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_end] = ACTIONS(2753),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_else] = ACTIONS(2753),
    [anon_sym_ensure] = ACTIONS(2753),
    [anon_sym_EQ_GT] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_PLUS_EQ] = ACTIONS(2753),
    [anon_sym_DASH_EQ] = ACTIONS(2753),
    [anon_sym_STAR_EQ] = ACTIONS(2753),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2753),
    [anon_sym_SLASH_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2753),
    [anon_sym_AMP_EQ] = ACTIONS(2753),
    [anon_sym_PERCENT_EQ] = ACTIONS(2753),
    [anon_sym_GT_GT_EQ] = ACTIONS(2753),
    [anon_sym_LT_LT_EQ] = ACTIONS(2753),
    [anon_sym_CARET_EQ] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2755),
    [anon_sym_AMP_AMP] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2755),
    [anon_sym_GT_GT] = ACTIONS(2755),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_SLASH] = ACTIONS(2755),
    [anon_sym_PERCENT] = ACTIONS(2755),
    [sym_comment] = ACTIONS(87),
  },
  [3281] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5932),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(3288),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(3288),
    [sym_assignment] = STATE(5932),
    [sym_operator_assignment] = STATE(5932),
    [sym_conditional] = STATE(5932),
    [sym_range] = STATE(5932),
    [sym_binary] = STATE(5932),
    [sym_unary] = STATE(5932),
    [sym_left_assignment_list] = STATE(3287),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3288),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(3288),
    [sym_false] = STATE(3288),
    [sym_nil] = STATE(3288),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(3000),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(5481),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5003),
    [anon_sym_yield] = ACTIONS(5005),
    [anon_sym_break] = ACTIONS(5007),
    [anon_sym_next] = ACTIONS(5009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5483),
    [anon_sym_defined_QMARK] = ACTIONS(5485),
    [anon_sym_not] = ACTIONS(5487),
    [anon_sym_BANG] = ACTIONS(5489),
    [anon_sym_TILDE] = ACTIONS(5489),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3282] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5933),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(3288),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(3288),
    [sym_assignment] = STATE(5933),
    [sym_operator_assignment] = STATE(5933),
    [sym_conditional] = STATE(5933),
    [sym_range] = STATE(5933),
    [sym_binary] = STATE(5933),
    [sym_unary] = STATE(5933),
    [sym_left_assignment_list] = STATE(3287),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3288),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(3288),
    [sym_false] = STATE(3288),
    [sym_nil] = STATE(3288),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(3000),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(5481),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5003),
    [anon_sym_yield] = ACTIONS(5005),
    [anon_sym_break] = ACTIONS(5007),
    [anon_sym_next] = ACTIONS(5009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5483),
    [anon_sym_defined_QMARK] = ACTIONS(5485),
    [anon_sym_not] = ACTIONS(5487),
    [anon_sym_BANG] = ACTIONS(5489),
    [anon_sym_TILDE] = ACTIONS(5489),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3283] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5934),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(3288),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(3288),
    [sym_assignment] = STATE(5934),
    [sym_operator_assignment] = STATE(5934),
    [sym_conditional] = STATE(5934),
    [sym_range] = STATE(5934),
    [sym_binary] = STATE(5934),
    [sym_unary] = STATE(5934),
    [sym_left_assignment_list] = STATE(3287),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3288),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(3288),
    [sym_false] = STATE(3288),
    [sym_nil] = STATE(3288),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(3000),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(5481),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5003),
    [anon_sym_yield] = ACTIONS(5005),
    [anon_sym_break] = ACTIONS(5007),
    [anon_sym_next] = ACTIONS(5009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5483),
    [anon_sym_defined_QMARK] = ACTIONS(5485),
    [anon_sym_not] = ACTIONS(5487),
    [anon_sym_BANG] = ACTIONS(5489),
    [anon_sym_TILDE] = ACTIONS(5489),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3284] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(298),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(3288),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(3288),
    [sym_assignment] = STATE(298),
    [sym_operator_assignment] = STATE(298),
    [sym_conditional] = STATE(298),
    [sym_range] = STATE(298),
    [sym_binary] = STATE(298),
    [sym_unary] = STATE(298),
    [sym_left_assignment_list] = STATE(3287),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3288),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(3288),
    [sym_false] = STATE(3288),
    [sym_nil] = STATE(3288),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(3000),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(5481),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5003),
    [anon_sym_yield] = ACTIONS(5005),
    [anon_sym_break] = ACTIONS(5007),
    [anon_sym_next] = ACTIONS(5009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5483),
    [anon_sym_defined_QMARK] = ACTIONS(5485),
    [anon_sym_not] = ACTIONS(5487),
    [anon_sym_BANG] = ACTIONS(5489),
    [anon_sym_TILDE] = ACTIONS(5489),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3285] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(9229),
    [sym__binary_star] = ACTIONS(9231),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(9233),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(9231),
    [anon_sym_AMP] = ACTIONS(9235),
    [anon_sym_LT] = ACTIONS(9237),
    [anon_sym_end] = ACTIONS(5115),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_else] = ACTIONS(5115),
    [anon_sym_ensure] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(9239),
    [anon_sym_DOT_DOT] = ACTIONS(9241),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9243),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(9245),
    [anon_sym_AMP_AMP] = ACTIONS(9245),
    [anon_sym_LT_LT] = ACTIONS(9247),
    [anon_sym_GT_GT] = ACTIONS(9247),
    [anon_sym_EQ_EQ] = ACTIONS(9249),
    [anon_sym_BANG_EQ] = ACTIONS(9245),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9245),
    [anon_sym_LT_EQ_GT] = ACTIONS(9245),
    [anon_sym_EQ_TILDE] = ACTIONS(9245),
    [anon_sym_BANG_TILDE] = ACTIONS(9245),
    [anon_sym_LT_EQ] = ACTIONS(9237),
    [anon_sym_GT] = ACTIONS(9237),
    [anon_sym_GT_EQ] = ACTIONS(9251),
    [anon_sym_CARET] = ACTIONS(9253),
    [anon_sym_PLUS] = ACTIONS(9229),
    [anon_sym_SLASH] = ACTIONS(9231),
    [anon_sym_PERCENT] = ACTIONS(9231),
    [sym_comment] = ACTIONS(87),
  },
  [3286] = {
    [aux_sym_exceptions_repeat1] = STATE(5946),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_COMMA] = ACTIONS(9255),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_end] = ACTIONS(6191),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_else] = ACTIONS(6191),
    [anon_sym_ensure] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [3287] = {
    [anon_sym_EQ] = ACTIONS(9257),
    [sym_comment] = ACTIONS(87),
  },
  [3288] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(9259),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(9261),
    [anon_sym_DASH_EQ] = ACTIONS(9261),
    [anon_sym_STAR_EQ] = ACTIONS(9261),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9261),
    [anon_sym_SLASH_EQ] = ACTIONS(9261),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9261),
    [anon_sym_PIPE_EQ] = ACTIONS(9261),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9261),
    [anon_sym_AMP_EQ] = ACTIONS(9261),
    [anon_sym_PERCENT_EQ] = ACTIONS(9261),
    [anon_sym_GT_GT_EQ] = ACTIONS(9261),
    [anon_sym_LT_LT_EQ] = ACTIONS(9261),
    [anon_sym_CARET_EQ] = ACTIONS(9261),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3289] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(2185),
    [sym__binary_star] = ACTIONS(2187),
    [anon_sym_PIPE] = ACTIONS(2189),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2191),
    [anon_sym_LT] = ACTIONS(2193),
    [anon_sym_end] = ACTIONS(6210),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_else] = ACTIONS(6210),
    [anon_sym_ensure] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(2195),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2199),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(2203),
    [anon_sym_AMP_AMP] = ACTIONS(2203),
    [anon_sym_LT_LT] = ACTIONS(2205),
    [anon_sym_GT_GT] = ACTIONS(2205),
    [anon_sym_EQ_EQ] = ACTIONS(2207),
    [anon_sym_BANG_EQ] = ACTIONS(2203),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2203),
    [anon_sym_LT_EQ_GT] = ACTIONS(2203),
    [anon_sym_EQ_TILDE] = ACTIONS(2203),
    [anon_sym_BANG_TILDE] = ACTIONS(2203),
    [anon_sym_LT_EQ] = ACTIONS(2193),
    [anon_sym_GT] = ACTIONS(2193),
    [anon_sym_GT_EQ] = ACTIONS(2209),
    [anon_sym_CARET] = ACTIONS(2211),
    [anon_sym_PLUS] = ACTIONS(2185),
    [anon_sym_SLASH] = ACTIONS(2187),
    [anon_sym_PERCENT] = ACTIONS(2187),
    [sym_comment] = ACTIONS(87),
  },
  [3290] = {
    [sym_string] = STATE(3290),
    [aux_sym_chained_string_repeat1] = STATE(3290),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(6214),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_end] = ACTIONS(6212),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_else] = ACTIONS(6212),
    [anon_sym_ensure] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [3291] = {
    [sym__line_break] = ACTIONS(9263),
    [sym__heredoc_body_start] = ACTIONS(9263),
    [ts_builtin_sym_end] = ACTIONS(9263),
    [anon_sym___END__] = ACTIONS(9263),
    [anon_sym_RBRACE] = ACTIONS(9263),
    [anon_sym_RPAREN] = ACTIONS(9263),
    [anon_sym_COMMA] = ACTIONS(9263),
    [anon_sym_SEMI] = ACTIONS(9263),
    [anon_sym_end] = ACTIONS(9263),
    [anon_sym_if] = ACTIONS(9263),
    [anon_sym_unless] = ACTIONS(9263),
    [anon_sym_while] = ACTIONS(9263),
    [anon_sym_until] = ACTIONS(9263),
    [anon_sym_rescue] = ACTIONS(9263),
    [anon_sym_when] = ACTIONS(9263),
    [anon_sym_elsif] = ACTIONS(9263),
    [anon_sym_else] = ACTIONS(9263),
    [anon_sym_then] = ACTIONS(9263),
    [anon_sym_ensure] = ACTIONS(9263),
    [sym_comment] = ACTIONS(87),
  },
  [3292] = {
    [aux_sym_undef_repeat1] = STATE(3292),
    [sym__line_break] = ACTIONS(9263),
    [sym__heredoc_body_start] = ACTIONS(9263),
    [ts_builtin_sym_end] = ACTIONS(9263),
    [anon_sym___END__] = ACTIONS(9263),
    [anon_sym_COMMA] = ACTIONS(9265),
    [anon_sym_SEMI] = ACTIONS(9263),
    [anon_sym_if] = ACTIONS(9263),
    [anon_sym_unless] = ACTIONS(9263),
    [anon_sym_while] = ACTIONS(9263),
    [anon_sym_until] = ACTIONS(9263),
    [anon_sym_rescue] = ACTIONS(9263),
    [sym_comment] = ACTIONS(87),
  },
  [3293] = {
    [sym__simple_symbol] = ACTIONS(3042),
    [sym__symbol_start] = ACTIONS(3042),
    [anon_sym_PIPE] = ACTIONS(3042),
    [anon_sym_STAR] = ACTIONS(3044),
    [anon_sym_STAR_STAR] = ACTIONS(3042),
    [anon_sym_AMP] = ACTIONS(3042),
    [anon_sym_LT] = ACTIONS(3044),
    [anon_sym_DOT_DOT] = ACTIONS(3042),
    [anon_sym_LT_LT] = ACTIONS(3042),
    [anon_sym_GT_GT] = ACTIONS(3042),
    [anon_sym_EQ_EQ] = ACTIONS(3044),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3042),
    [anon_sym_LT_EQ_GT] = ACTIONS(3042),
    [anon_sym_EQ_TILDE] = ACTIONS(3042),
    [anon_sym_BANG_TILDE] = ACTIONS(3042),
    [anon_sym_LT_EQ] = ACTIONS(3044),
    [anon_sym_GT] = ACTIONS(3044),
    [anon_sym_GT_EQ] = ACTIONS(3042),
    [anon_sym_CARET] = ACTIONS(3042),
    [anon_sym_PLUS] = ACTIONS(3044),
    [anon_sym_SLASH] = ACTIONS(3042),
    [anon_sym_PERCENT] = ACTIONS(3042),
    [anon_sym_BANG] = ACTIONS(3044),
    [anon_sym_TILDE] = ACTIONS(3042),
    [sym_constant] = ACTIONS(3042),
    [sym_identifier] = ACTIONS(3042),
    [sym_instance_variable] = ACTIONS(3042),
    [sym_class_variable] = ACTIONS(3042),
    [sym_global_variable] = ACTIONS(3042),
    [anon_sym_DASH] = ACTIONS(3044),
    [anon_sym_PLUS_AT] = ACTIONS(3042),
    [anon_sym_DASH_AT] = ACTIONS(3042),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3044),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(3042),
    [anon_sym_BQUOTE] = ACTIONS(3042),
    [sym_comment] = ACTIONS(87),
  },
  [3294] = {
    [sym__string_start] = ACTIONS(3030),
    [sym__heredoc_body_start] = ACTIONS(3030),
    [sym__binary_minus] = ACTIONS(3030),
    [sym__binary_star] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3030),
    [anon_sym_RBRACE] = ACTIONS(3030),
    [anon_sym_RPAREN] = ACTIONS(3030),
    [anon_sym_DOT] = ACTIONS(3032),
    [anon_sym_COMMA] = ACTIONS(3030),
    [anon_sym_PIPE] = ACTIONS(3032),
    [anon_sym_SEMI] = ACTIONS(3030),
    [anon_sym_STAR_STAR] = ACTIONS(3030),
    [anon_sym_AMP] = ACTIONS(3032),
    [anon_sym_COLON] = ACTIONS(3032),
    [anon_sym_EQ] = ACTIONS(3032),
    [anon_sym_LT] = ACTIONS(3032),
    [anon_sym_if] = ACTIONS(3030),
    [anon_sym_unless] = ACTIONS(3030),
    [anon_sym_while] = ACTIONS(3030),
    [anon_sym_until] = ACTIONS(3030),
    [anon_sym_rescue] = ACTIONS(3030),
    [anon_sym_in] = ACTIONS(3030),
    [anon_sym_do] = ACTIONS(3030),
    [anon_sym_EQ_GT] = ACTIONS(3030),
    [anon_sym_LBRACK] = ACTIONS(3030),
    [anon_sym_RBRACK] = ACTIONS(3030),
    [anon_sym_COLON_COLON2] = ACTIONS(3030),
    [anon_sym_AMP_DOT] = ACTIONS(3030),
    [anon_sym_QMARK] = ACTIONS(3030),
    [anon_sym_COLON2] = ACTIONS(3032),
    [anon_sym_DOT_DOT] = ACTIONS(3032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3030),
    [anon_sym_and] = ACTIONS(3030),
    [anon_sym_or] = ACTIONS(3030),
    [anon_sym_PIPE_PIPE] = ACTIONS(3030),
    [anon_sym_AMP_AMP] = ACTIONS(3030),
    [anon_sym_LT_LT] = ACTIONS(3030),
    [anon_sym_GT_GT] = ACTIONS(3030),
    [anon_sym_EQ_EQ] = ACTIONS(3032),
    [anon_sym_BANG_EQ] = ACTIONS(3030),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3030),
    [anon_sym_LT_EQ_GT] = ACTIONS(3030),
    [anon_sym_EQ_TILDE] = ACTIONS(3030),
    [anon_sym_BANG_TILDE] = ACTIONS(3030),
    [anon_sym_LT_EQ] = ACTIONS(3032),
    [anon_sym_GT] = ACTIONS(3032),
    [anon_sym_GT_EQ] = ACTIONS(3030),
    [anon_sym_CARET] = ACTIONS(3030),
    [anon_sym_PLUS] = ACTIONS(3030),
    [anon_sym_SLASH] = ACTIONS(3030),
    [anon_sym_PERCENT] = ACTIONS(3030),
    [sym_comment] = ACTIONS(87),
  },
  [3295] = {
    [sym__heredoc_body_start] = ACTIONS(3042),
    [sym__binary_minus] = ACTIONS(3042),
    [sym__binary_star] = ACTIONS(3042),
    [anon_sym_LBRACE] = ACTIONS(3042),
    [anon_sym_RBRACE] = ACTIONS(3042),
    [anon_sym_RPAREN] = ACTIONS(3042),
    [anon_sym_DOT] = ACTIONS(3044),
    [anon_sym_COMMA] = ACTIONS(3042),
    [anon_sym_PIPE] = ACTIONS(3044),
    [anon_sym_SEMI] = ACTIONS(3042),
    [anon_sym_STAR_STAR] = ACTIONS(3042),
    [anon_sym_AMP] = ACTIONS(3044),
    [anon_sym_EQ] = ACTIONS(3044),
    [anon_sym_LT] = ACTIONS(3044),
    [anon_sym_if] = ACTIONS(3042),
    [anon_sym_unless] = ACTIONS(3042),
    [anon_sym_while] = ACTIONS(3042),
    [anon_sym_until] = ACTIONS(3042),
    [anon_sym_rescue] = ACTIONS(3042),
    [anon_sym_in] = ACTIONS(3042),
    [anon_sym_do] = ACTIONS(3042),
    [anon_sym_EQ_GT] = ACTIONS(3042),
    [anon_sym_LBRACK] = ACTIONS(3042),
    [anon_sym_RBRACK] = ACTIONS(3042),
    [anon_sym_COLON_COLON2] = ACTIONS(3042),
    [anon_sym_AMP_DOT] = ACTIONS(3042),
    [anon_sym_QMARK] = ACTIONS(3042),
    [anon_sym_COLON2] = ACTIONS(3044),
    [anon_sym_DOT_DOT] = ACTIONS(3044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3042),
    [anon_sym_and] = ACTIONS(3042),
    [anon_sym_or] = ACTIONS(3042),
    [anon_sym_PIPE_PIPE] = ACTIONS(3042),
    [anon_sym_AMP_AMP] = ACTIONS(3042),
    [anon_sym_LT_LT] = ACTIONS(3042),
    [anon_sym_GT_GT] = ACTIONS(3042),
    [anon_sym_EQ_EQ] = ACTIONS(3044),
    [anon_sym_BANG_EQ] = ACTIONS(3042),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3042),
    [anon_sym_LT_EQ_GT] = ACTIONS(3042),
    [anon_sym_EQ_TILDE] = ACTIONS(3042),
    [anon_sym_BANG_TILDE] = ACTIONS(3042),
    [anon_sym_LT_EQ] = ACTIONS(3044),
    [anon_sym_GT] = ACTIONS(3044),
    [anon_sym_GT_EQ] = ACTIONS(3042),
    [anon_sym_CARET] = ACTIONS(3042),
    [anon_sym_PLUS] = ACTIONS(3042),
    [anon_sym_SLASH] = ACTIONS(3042),
    [anon_sym_PERCENT] = ACTIONS(3042),
    [sym_comment] = ACTIONS(87),
  },
  [3296] = {
    [sym__heredoc_body_start] = ACTIONS(3046),
    [sym__binary_minus] = ACTIONS(3046),
    [sym__binary_star] = ACTIONS(3046),
    [anon_sym_LBRACE] = ACTIONS(3046),
    [anon_sym_RBRACE] = ACTIONS(3046),
    [anon_sym_RPAREN] = ACTIONS(3046),
    [anon_sym_DOT] = ACTIONS(3048),
    [anon_sym_COMMA] = ACTIONS(3046),
    [anon_sym_PIPE] = ACTIONS(3048),
    [anon_sym_SEMI] = ACTIONS(3046),
    [anon_sym_STAR_STAR] = ACTIONS(3046),
    [anon_sym_AMP] = ACTIONS(3048),
    [anon_sym_EQ] = ACTIONS(3048),
    [anon_sym_LT] = ACTIONS(3048),
    [anon_sym_if] = ACTIONS(3046),
    [anon_sym_unless] = ACTIONS(3046),
    [anon_sym_while] = ACTIONS(3046),
    [anon_sym_until] = ACTIONS(3046),
    [anon_sym_rescue] = ACTIONS(3046),
    [anon_sym_in] = ACTIONS(3046),
    [anon_sym_do] = ACTIONS(3046),
    [anon_sym_EQ_GT] = ACTIONS(3046),
    [anon_sym_LBRACK] = ACTIONS(3046),
    [anon_sym_RBRACK] = ACTIONS(3046),
    [anon_sym_COLON_COLON2] = ACTIONS(3046),
    [anon_sym_AMP_DOT] = ACTIONS(3046),
    [anon_sym_QMARK] = ACTIONS(3046),
    [anon_sym_COLON2] = ACTIONS(3048),
    [anon_sym_DOT_DOT] = ACTIONS(3048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3046),
    [anon_sym_and] = ACTIONS(3046),
    [anon_sym_or] = ACTIONS(3046),
    [anon_sym_PIPE_PIPE] = ACTIONS(3046),
    [anon_sym_AMP_AMP] = ACTIONS(3046),
    [anon_sym_LT_LT] = ACTIONS(3046),
    [anon_sym_GT_GT] = ACTIONS(3046),
    [anon_sym_EQ_EQ] = ACTIONS(3048),
    [anon_sym_BANG_EQ] = ACTIONS(3046),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3046),
    [anon_sym_LT_EQ_GT] = ACTIONS(3046),
    [anon_sym_EQ_TILDE] = ACTIONS(3046),
    [anon_sym_BANG_TILDE] = ACTIONS(3046),
    [anon_sym_LT_EQ] = ACTIONS(3048),
    [anon_sym_GT] = ACTIONS(3048),
    [anon_sym_GT_EQ] = ACTIONS(3046),
    [anon_sym_CARET] = ACTIONS(3046),
    [anon_sym_PLUS] = ACTIONS(3046),
    [anon_sym_SLASH] = ACTIONS(3046),
    [anon_sym_PERCENT] = ACTIONS(3046),
    [sym_comment] = ACTIONS(87),
  },
  [3297] = {
    [sym__heredoc_body_start] = ACTIONS(3050),
    [sym__binary_minus] = ACTIONS(3050),
    [sym__binary_star] = ACTIONS(3050),
    [anon_sym_LBRACE] = ACTIONS(3050),
    [anon_sym_RBRACE] = ACTIONS(3050),
    [anon_sym_RPAREN] = ACTIONS(3050),
    [anon_sym_DOT] = ACTIONS(3052),
    [anon_sym_COMMA] = ACTIONS(3050),
    [anon_sym_PIPE] = ACTIONS(3052),
    [anon_sym_SEMI] = ACTIONS(3050),
    [anon_sym_STAR_STAR] = ACTIONS(3050),
    [anon_sym_AMP] = ACTIONS(3052),
    [anon_sym_EQ] = ACTIONS(3052),
    [anon_sym_LT] = ACTIONS(3052),
    [anon_sym_if] = ACTIONS(3050),
    [anon_sym_unless] = ACTIONS(3050),
    [anon_sym_while] = ACTIONS(3050),
    [anon_sym_until] = ACTIONS(3050),
    [anon_sym_rescue] = ACTIONS(3050),
    [anon_sym_in] = ACTIONS(3050),
    [anon_sym_do] = ACTIONS(3050),
    [anon_sym_EQ_GT] = ACTIONS(3050),
    [anon_sym_LBRACK] = ACTIONS(3050),
    [anon_sym_RBRACK] = ACTIONS(3050),
    [anon_sym_COLON_COLON2] = ACTIONS(3050),
    [anon_sym_AMP_DOT] = ACTIONS(3050),
    [anon_sym_QMARK] = ACTIONS(3050),
    [anon_sym_COLON2] = ACTIONS(3052),
    [anon_sym_DOT_DOT] = ACTIONS(3052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3050),
    [anon_sym_and] = ACTIONS(3050),
    [anon_sym_or] = ACTIONS(3050),
    [anon_sym_PIPE_PIPE] = ACTIONS(3050),
    [anon_sym_AMP_AMP] = ACTIONS(3050),
    [anon_sym_LT_LT] = ACTIONS(3050),
    [anon_sym_GT_GT] = ACTIONS(3050),
    [anon_sym_EQ_EQ] = ACTIONS(3052),
    [anon_sym_BANG_EQ] = ACTIONS(3050),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3050),
    [anon_sym_LT_EQ_GT] = ACTIONS(3050),
    [anon_sym_EQ_TILDE] = ACTIONS(3050),
    [anon_sym_BANG_TILDE] = ACTIONS(3050),
    [anon_sym_LT_EQ] = ACTIONS(3052),
    [anon_sym_GT] = ACTIONS(3052),
    [anon_sym_GT_EQ] = ACTIONS(3050),
    [anon_sym_CARET] = ACTIONS(3050),
    [anon_sym_PLUS] = ACTIONS(3050),
    [anon_sym_SLASH] = ACTIONS(3050),
    [anon_sym_PERCENT] = ACTIONS(3050),
    [sym_comment] = ACTIONS(87),
  },
  [3298] = {
    [sym__heredoc_body_start] = ACTIONS(3056),
    [sym__binary_minus] = ACTIONS(3056),
    [sym__binary_star] = ACTIONS(3056),
    [anon_sym_LBRACE] = ACTIONS(3056),
    [anon_sym_RBRACE] = ACTIONS(3056),
    [anon_sym_RPAREN] = ACTIONS(3056),
    [anon_sym_DOT] = ACTIONS(3058),
    [anon_sym_COMMA] = ACTIONS(3056),
    [anon_sym_PIPE] = ACTIONS(3058),
    [anon_sym_SEMI] = ACTIONS(3056),
    [anon_sym_STAR_STAR] = ACTIONS(3056),
    [anon_sym_AMP] = ACTIONS(3058),
    [anon_sym_EQ] = ACTIONS(3058),
    [anon_sym_LT] = ACTIONS(3058),
    [anon_sym_if] = ACTIONS(3056),
    [anon_sym_unless] = ACTIONS(3056),
    [anon_sym_while] = ACTIONS(3056),
    [anon_sym_until] = ACTIONS(3056),
    [anon_sym_rescue] = ACTIONS(3056),
    [anon_sym_in] = ACTIONS(3056),
    [anon_sym_do] = ACTIONS(3056),
    [anon_sym_EQ_GT] = ACTIONS(3056),
    [anon_sym_LBRACK] = ACTIONS(3056),
    [anon_sym_RBRACK] = ACTIONS(3056),
    [anon_sym_COLON_COLON2] = ACTIONS(3056),
    [anon_sym_AMP_DOT] = ACTIONS(3056),
    [anon_sym_QMARK] = ACTIONS(3056),
    [anon_sym_COLON2] = ACTIONS(3058),
    [anon_sym_DOT_DOT] = ACTIONS(3058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3056),
    [anon_sym_and] = ACTIONS(3056),
    [anon_sym_or] = ACTIONS(3056),
    [anon_sym_PIPE_PIPE] = ACTIONS(3056),
    [anon_sym_AMP_AMP] = ACTIONS(3056),
    [anon_sym_LT_LT] = ACTIONS(3056),
    [anon_sym_GT_GT] = ACTIONS(3056),
    [anon_sym_EQ_EQ] = ACTIONS(3058),
    [anon_sym_BANG_EQ] = ACTIONS(3056),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3056),
    [anon_sym_LT_EQ_GT] = ACTIONS(3056),
    [anon_sym_EQ_TILDE] = ACTIONS(3056),
    [anon_sym_BANG_TILDE] = ACTIONS(3056),
    [anon_sym_LT_EQ] = ACTIONS(3058),
    [anon_sym_GT] = ACTIONS(3058),
    [anon_sym_GT_EQ] = ACTIONS(3056),
    [anon_sym_CARET] = ACTIONS(3056),
    [anon_sym_PLUS] = ACTIONS(3056),
    [anon_sym_SLASH] = ACTIONS(3056),
    [anon_sym_PERCENT] = ACTIONS(3056),
    [sym_comment] = ACTIONS(87),
  },
  [3299] = {
    [sym__string_end] = ACTIONS(9268),
    [sym_comment] = ACTIONS(87),
  },
  [3300] = {
    [aux_sym_string_array_repeat1] = STATE(5952),
    [sym__string_end] = ACTIONS(9270),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(9272),
  },
  [3301] = {
    [sym__heredoc_body_start] = ACTIONS(3066),
    [sym__binary_minus] = ACTIONS(3066),
    [sym__binary_star] = ACTIONS(3066),
    [anon_sym_LBRACE] = ACTIONS(3066),
    [anon_sym_RBRACE] = ACTIONS(3066),
    [anon_sym_RPAREN] = ACTIONS(3066),
    [anon_sym_DOT] = ACTIONS(3068),
    [anon_sym_COMMA] = ACTIONS(3066),
    [anon_sym_PIPE] = ACTIONS(3068),
    [anon_sym_SEMI] = ACTIONS(3066),
    [anon_sym_STAR_STAR] = ACTIONS(3066),
    [anon_sym_AMP] = ACTIONS(3068),
    [anon_sym_EQ] = ACTIONS(3068),
    [anon_sym_LT] = ACTIONS(3068),
    [anon_sym_if] = ACTIONS(3066),
    [anon_sym_unless] = ACTIONS(3066),
    [anon_sym_while] = ACTIONS(3066),
    [anon_sym_until] = ACTIONS(3066),
    [anon_sym_rescue] = ACTIONS(3066),
    [anon_sym_in] = ACTIONS(3066),
    [anon_sym_do] = ACTIONS(3066),
    [anon_sym_EQ_GT] = ACTIONS(3066),
    [anon_sym_LBRACK] = ACTIONS(3066),
    [anon_sym_RBRACK] = ACTIONS(3066),
    [anon_sym_COLON_COLON2] = ACTIONS(3066),
    [anon_sym_AMP_DOT] = ACTIONS(3066),
    [anon_sym_QMARK] = ACTIONS(3066),
    [anon_sym_COLON2] = ACTIONS(3068),
    [anon_sym_DOT_DOT] = ACTIONS(3068),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3066),
    [anon_sym_and] = ACTIONS(3066),
    [anon_sym_or] = ACTIONS(3066),
    [anon_sym_PIPE_PIPE] = ACTIONS(3066),
    [anon_sym_AMP_AMP] = ACTIONS(3066),
    [anon_sym_LT_LT] = ACTIONS(3066),
    [anon_sym_GT_GT] = ACTIONS(3066),
    [anon_sym_EQ_EQ] = ACTIONS(3068),
    [anon_sym_BANG_EQ] = ACTIONS(3066),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3066),
    [anon_sym_LT_EQ_GT] = ACTIONS(3066),
    [anon_sym_EQ_TILDE] = ACTIONS(3066),
    [anon_sym_BANG_TILDE] = ACTIONS(3066),
    [anon_sym_LT_EQ] = ACTIONS(3068),
    [anon_sym_GT] = ACTIONS(3068),
    [anon_sym_GT_EQ] = ACTIONS(3066),
    [anon_sym_CARET] = ACTIONS(3066),
    [anon_sym_PLUS] = ACTIONS(3066),
    [anon_sym_SLASH] = ACTIONS(3066),
    [anon_sym_PERCENT] = ACTIONS(3066),
    [sym_comment] = ACTIONS(87),
  },
  [3302] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1697),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(9274),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [3303] = {
    [aux_sym_string_array_repeat1] = STATE(1699),
    [sym__string_end] = ACTIONS(9274),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(9276),
  },
  [3304] = {
    [sym__heredoc_body_start] = ACTIONS(3085),
    [sym__binary_minus] = ACTIONS(3085),
    [sym__binary_star] = ACTIONS(3085),
    [anon_sym_LBRACE] = ACTIONS(3085),
    [anon_sym_RBRACE] = ACTIONS(3085),
    [anon_sym_RPAREN] = ACTIONS(3085),
    [anon_sym_DOT] = ACTIONS(3087),
    [anon_sym_COMMA] = ACTIONS(3085),
    [anon_sym_PIPE] = ACTIONS(3087),
    [anon_sym_SEMI] = ACTIONS(3085),
    [anon_sym_STAR_STAR] = ACTIONS(3085),
    [anon_sym_AMP] = ACTIONS(3087),
    [anon_sym_EQ] = ACTIONS(3087),
    [anon_sym_LT] = ACTIONS(3087),
    [anon_sym_if] = ACTIONS(3085),
    [anon_sym_unless] = ACTIONS(3085),
    [anon_sym_while] = ACTIONS(3085),
    [anon_sym_until] = ACTIONS(3085),
    [anon_sym_rescue] = ACTIONS(3085),
    [anon_sym_in] = ACTIONS(3085),
    [anon_sym_do] = ACTIONS(3085),
    [anon_sym_EQ_GT] = ACTIONS(3085),
    [anon_sym_LBRACK] = ACTIONS(3085),
    [anon_sym_RBRACK] = ACTIONS(3085),
    [anon_sym_COLON_COLON2] = ACTIONS(3085),
    [anon_sym_AMP_DOT] = ACTIONS(3085),
    [anon_sym_QMARK] = ACTIONS(3085),
    [anon_sym_COLON2] = ACTIONS(3087),
    [anon_sym_DOT_DOT] = ACTIONS(3087),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3085),
    [anon_sym_and] = ACTIONS(3085),
    [anon_sym_or] = ACTIONS(3085),
    [anon_sym_PIPE_PIPE] = ACTIONS(3085),
    [anon_sym_AMP_AMP] = ACTIONS(3085),
    [anon_sym_LT_LT] = ACTIONS(3085),
    [anon_sym_GT_GT] = ACTIONS(3085),
    [anon_sym_EQ_EQ] = ACTIONS(3087),
    [anon_sym_BANG_EQ] = ACTIONS(3085),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3085),
    [anon_sym_LT_EQ_GT] = ACTIONS(3085),
    [anon_sym_EQ_TILDE] = ACTIONS(3085),
    [anon_sym_BANG_TILDE] = ACTIONS(3085),
    [anon_sym_LT_EQ] = ACTIONS(3087),
    [anon_sym_GT] = ACTIONS(3087),
    [anon_sym_GT_EQ] = ACTIONS(3085),
    [anon_sym_CARET] = ACTIONS(3085),
    [anon_sym_PLUS] = ACTIONS(3085),
    [anon_sym_SLASH] = ACTIONS(3085),
    [anon_sym_PERCENT] = ACTIONS(3085),
    [sym_comment] = ACTIONS(87),
  },
  [3305] = {
    [sym__string_end] = ACTIONS(9278),
    [sym_comment] = ACTIONS(87),
  },
  [3306] = {
    [aux_sym_symbol_array_repeat1] = STATE(5958),
    [sym__string_end] = ACTIONS(9280),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(9282),
  },
  [3307] = {
    [sym__heredoc_body_start] = ACTIONS(3095),
    [sym__binary_minus] = ACTIONS(3095),
    [sym__binary_star] = ACTIONS(3095),
    [anon_sym_LBRACE] = ACTIONS(3095),
    [anon_sym_RBRACE] = ACTIONS(3095),
    [anon_sym_RPAREN] = ACTIONS(3095),
    [anon_sym_DOT] = ACTIONS(3097),
    [anon_sym_COMMA] = ACTIONS(3095),
    [anon_sym_PIPE] = ACTIONS(3097),
    [anon_sym_SEMI] = ACTIONS(3095),
    [anon_sym_STAR_STAR] = ACTIONS(3095),
    [anon_sym_AMP] = ACTIONS(3097),
    [anon_sym_EQ] = ACTIONS(3097),
    [anon_sym_LT] = ACTIONS(3097),
    [anon_sym_if] = ACTIONS(3095),
    [anon_sym_unless] = ACTIONS(3095),
    [anon_sym_while] = ACTIONS(3095),
    [anon_sym_until] = ACTIONS(3095),
    [anon_sym_rescue] = ACTIONS(3095),
    [anon_sym_in] = ACTIONS(3095),
    [anon_sym_do] = ACTIONS(3095),
    [anon_sym_EQ_GT] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3095),
    [anon_sym_RBRACK] = ACTIONS(3095),
    [anon_sym_COLON_COLON2] = ACTIONS(3095),
    [anon_sym_AMP_DOT] = ACTIONS(3095),
    [anon_sym_QMARK] = ACTIONS(3095),
    [anon_sym_COLON2] = ACTIONS(3097),
    [anon_sym_DOT_DOT] = ACTIONS(3097),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3095),
    [anon_sym_and] = ACTIONS(3095),
    [anon_sym_or] = ACTIONS(3095),
    [anon_sym_PIPE_PIPE] = ACTIONS(3095),
    [anon_sym_AMP_AMP] = ACTIONS(3095),
    [anon_sym_LT_LT] = ACTIONS(3095),
    [anon_sym_GT_GT] = ACTIONS(3095),
    [anon_sym_EQ_EQ] = ACTIONS(3097),
    [anon_sym_BANG_EQ] = ACTIONS(3095),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3095),
    [anon_sym_LT_EQ_GT] = ACTIONS(3095),
    [anon_sym_EQ_TILDE] = ACTIONS(3095),
    [anon_sym_BANG_TILDE] = ACTIONS(3095),
    [anon_sym_LT_EQ] = ACTIONS(3097),
    [anon_sym_GT] = ACTIONS(3097),
    [anon_sym_GT_EQ] = ACTIONS(3095),
    [anon_sym_CARET] = ACTIONS(3095),
    [anon_sym_PLUS] = ACTIONS(3095),
    [anon_sym_SLASH] = ACTIONS(3095),
    [anon_sym_PERCENT] = ACTIONS(3095),
    [sym_comment] = ACTIONS(87),
  },
  [3308] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1705),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(9284),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [3309] = {
    [aux_sym_symbol_array_repeat1] = STATE(1707),
    [sym__string_end] = ACTIONS(9284),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(9286),
  },
  [3310] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(5537),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_RBRACK] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [3311] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(5964),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(5966),
    [sym_scope_resolution] = STATE(1285),
    [sym_call] = STATE(1285),
    [sym_method_call] = STATE(5966),
    [sym_assignment] = STATE(5964),
    [sym_operator_assignment] = STATE(5964),
    [sym_conditional] = STATE(5964),
    [sym_range] = STATE(5964),
    [sym_binary] = STATE(5964),
    [sym_unary] = STATE(5964),
    [sym_left_assignment_list] = STATE(5965),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5966),
    [sym__variable] = STATE(1285),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(5966),
    [sym_false] = STATE(5966),
    [sym_nil] = STATE(5966),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(1288),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9288),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2283),
    [anon_sym_yield] = ACTIONS(2285),
    [anon_sym_break] = ACTIONS(2287),
    [anon_sym_next] = ACTIONS(2289),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9290),
    [anon_sym_defined_QMARK] = ACTIONS(9292),
    [anon_sym_not] = ACTIONS(9294),
    [anon_sym_BANG] = ACTIONS(9296),
    [anon_sym_TILDE] = ACTIONS(9296),
    [sym_constant] = ACTIONS(2299),
    [sym_identifier] = ACTIONS(2299),
    [sym_instance_variable] = ACTIONS(2301),
    [sym_class_variable] = ACTIONS(2301),
    [sym_global_variable] = ACTIONS(2301),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2299),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2299),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3312] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(5967),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(5966),
    [sym_scope_resolution] = STATE(1285),
    [sym_call] = STATE(1285),
    [sym_method_call] = STATE(5966),
    [sym_assignment] = STATE(5967),
    [sym_operator_assignment] = STATE(5967),
    [sym_conditional] = STATE(5967),
    [sym_range] = STATE(5967),
    [sym_binary] = STATE(5967),
    [sym_unary] = STATE(5967),
    [sym_left_assignment_list] = STATE(5965),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5966),
    [sym__variable] = STATE(1285),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(5966),
    [sym_false] = STATE(5966),
    [sym_nil] = STATE(5966),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(1288),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9288),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2283),
    [anon_sym_yield] = ACTIONS(2285),
    [anon_sym_break] = ACTIONS(2287),
    [anon_sym_next] = ACTIONS(2289),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9290),
    [anon_sym_defined_QMARK] = ACTIONS(9292),
    [anon_sym_not] = ACTIONS(9294),
    [anon_sym_BANG] = ACTIONS(9296),
    [anon_sym_TILDE] = ACTIONS(9296),
    [sym_constant] = ACTIONS(2299),
    [sym_identifier] = ACTIONS(2299),
    [sym_instance_variable] = ACTIONS(2301),
    [sym_class_variable] = ACTIONS(2301),
    [sym_global_variable] = ACTIONS(2301),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2299),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2299),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3313] = {
    [anon_sym_COLON] = ACTIONS(9298),
    [sym_comment] = ACTIONS(87),
  },
  [3314] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(5969),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(5966),
    [sym_scope_resolution] = STATE(1285),
    [sym_call] = STATE(1285),
    [sym_method_call] = STATE(5966),
    [sym_assignment] = STATE(5969),
    [sym_operator_assignment] = STATE(5969),
    [sym_conditional] = STATE(5969),
    [sym_range] = STATE(5969),
    [sym_binary] = STATE(5969),
    [sym_unary] = STATE(5969),
    [sym_left_assignment_list] = STATE(5965),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5966),
    [sym__variable] = STATE(1285),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(5966),
    [sym_false] = STATE(5966),
    [sym_nil] = STATE(5966),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(1288),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9288),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2283),
    [anon_sym_yield] = ACTIONS(2285),
    [anon_sym_break] = ACTIONS(2287),
    [anon_sym_next] = ACTIONS(2289),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9290),
    [anon_sym_defined_QMARK] = ACTIONS(9292),
    [anon_sym_not] = ACTIONS(9294),
    [anon_sym_BANG] = ACTIONS(9296),
    [anon_sym_TILDE] = ACTIONS(9296),
    [sym_constant] = ACTIONS(2299),
    [sym_identifier] = ACTIONS(2299),
    [sym_instance_variable] = ACTIONS(2301),
    [sym_class_variable] = ACTIONS(2301),
    [sym_global_variable] = ACTIONS(2301),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2299),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2299),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3315] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(9300),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_RBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [3316] = {
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(5597),
    [sym__binary_star] = ACTIONS(5599),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(5601),
    [anon_sym_STAR_STAR] = ACTIONS(5599),
    [anon_sym_AMP] = ACTIONS(5603),
    [anon_sym_LT] = ACTIONS(5605),
    [anon_sym_EQ_GT] = ACTIONS(9298),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_RBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(5607),
    [anon_sym_DOT_DOT] = ACTIONS(5609),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5611),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(5613),
    [anon_sym_AMP_AMP] = ACTIONS(5613),
    [anon_sym_LT_LT] = ACTIONS(5615),
    [anon_sym_GT_GT] = ACTIONS(5615),
    [anon_sym_EQ_EQ] = ACTIONS(5617),
    [anon_sym_BANG_EQ] = ACTIONS(5613),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5613),
    [anon_sym_LT_EQ_GT] = ACTIONS(5613),
    [anon_sym_EQ_TILDE] = ACTIONS(5613),
    [anon_sym_BANG_TILDE] = ACTIONS(5613),
    [anon_sym_LT_EQ] = ACTIONS(5605),
    [anon_sym_GT] = ACTIONS(5605),
    [anon_sym_GT_EQ] = ACTIONS(5619),
    [anon_sym_CARET] = ACTIONS(5621),
    [anon_sym_PLUS] = ACTIONS(5597),
    [anon_sym_SLASH] = ACTIONS(5599),
    [anon_sym_PERCENT] = ACTIONS(5599),
    [sym_comment] = ACTIONS(87),
  },
  [3317] = {
    [sym_heredoc_body] = STATE(5971),
    [aux_sym_call_repeat1] = STATE(5971),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_RBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [3318] = {
    [sym_heredoc_body] = STATE(5971),
    [aux_sym_call_repeat1] = STATE(5971),
    [aux_sym_argument_list_repeat1] = STATE(5973),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(9302),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_RBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [3319] = {
    [sym_string] = STATE(1392),
    [aux_sym_chained_string_repeat1] = STATE(1392),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(9304),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [3320] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(5535),
    [sym__binary_star] = ACTIONS(5537),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5537),
    [anon_sym_AMP] = ACTIONS(5541),
    [anon_sym_LT] = ACTIONS(5543),
    [anon_sym_RBRACK] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(5545),
    [anon_sym_DOT_DOT] = ACTIONS(5547),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5549),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(5553),
    [anon_sym_AMP_AMP] = ACTIONS(5553),
    [anon_sym_LT_LT] = ACTIONS(5555),
    [anon_sym_GT_GT] = ACTIONS(5555),
    [anon_sym_EQ_EQ] = ACTIONS(5557),
    [anon_sym_BANG_EQ] = ACTIONS(5553),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5553),
    [anon_sym_LT_EQ_GT] = ACTIONS(5553),
    [anon_sym_EQ_TILDE] = ACTIONS(5553),
    [anon_sym_BANG_TILDE] = ACTIONS(5553),
    [anon_sym_LT_EQ] = ACTIONS(5543),
    [anon_sym_GT] = ACTIONS(5543),
    [anon_sym_GT_EQ] = ACTIONS(5559),
    [anon_sym_CARET] = ACTIONS(5561),
    [anon_sym_PLUS] = ACTIONS(5535),
    [anon_sym_SLASH] = ACTIONS(5537),
    [anon_sym_PERCENT] = ACTIONS(5537),
    [sym_comment] = ACTIONS(87),
  },
  [3321] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(5974),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(1287),
    [sym_scope_resolution] = STATE(1285),
    [sym_call] = STATE(1285),
    [sym_method_call] = STATE(1287),
    [sym_assignment] = STATE(5974),
    [sym_operator_assignment] = STATE(5974),
    [sym_conditional] = STATE(5974),
    [sym_range] = STATE(5974),
    [sym_binary] = STATE(5974),
    [sym_unary] = STATE(5974),
    [sym_left_assignment_list] = STATE(1286),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1287),
    [sym__variable] = STATE(1285),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(1287),
    [sym_false] = STATE(1287),
    [sym_nil] = STATE(1287),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(1288),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(2281),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2283),
    [anon_sym_yield] = ACTIONS(2285),
    [anon_sym_break] = ACTIONS(2287),
    [anon_sym_next] = ACTIONS(2289),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2291),
    [anon_sym_defined_QMARK] = ACTIONS(2293),
    [anon_sym_not] = ACTIONS(2295),
    [anon_sym_BANG] = ACTIONS(2297),
    [anon_sym_TILDE] = ACTIONS(2297),
    [sym_constant] = ACTIONS(2299),
    [sym_identifier] = ACTIONS(2299),
    [sym_instance_variable] = ACTIONS(2301),
    [sym_class_variable] = ACTIONS(2301),
    [sym_global_variable] = ACTIONS(2301),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2299),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2299),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3322] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(5975),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(1287),
    [sym_scope_resolution] = STATE(1285),
    [sym_call] = STATE(1285),
    [sym_method_call] = STATE(1287),
    [sym_assignment] = STATE(5975),
    [sym_operator_assignment] = STATE(5975),
    [sym_conditional] = STATE(5975),
    [sym_range] = STATE(5975),
    [sym_binary] = STATE(5975),
    [sym_unary] = STATE(5975),
    [sym_left_assignment_list] = STATE(1286),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1287),
    [sym__variable] = STATE(1285),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(1287),
    [sym_false] = STATE(1287),
    [sym_nil] = STATE(1287),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(1288),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(2281),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2283),
    [anon_sym_yield] = ACTIONS(2285),
    [anon_sym_break] = ACTIONS(2287),
    [anon_sym_next] = ACTIONS(2289),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2291),
    [anon_sym_defined_QMARK] = ACTIONS(2293),
    [anon_sym_not] = ACTIONS(2295),
    [anon_sym_BANG] = ACTIONS(2297),
    [anon_sym_TILDE] = ACTIONS(2297),
    [sym_constant] = ACTIONS(2299),
    [sym_identifier] = ACTIONS(2299),
    [sym_instance_variable] = ACTIONS(2301),
    [sym_class_variable] = ACTIONS(2301),
    [sym_global_variable] = ACTIONS(2301),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2299),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2299),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3323] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(5976),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(1287),
    [sym_scope_resolution] = STATE(1285),
    [sym_call] = STATE(1285),
    [sym_method_call] = STATE(1287),
    [sym_assignment] = STATE(5976),
    [sym_operator_assignment] = STATE(5976),
    [sym_conditional] = STATE(5976),
    [sym_range] = STATE(5976),
    [sym_binary] = STATE(5976),
    [sym_unary] = STATE(5976),
    [sym_left_assignment_list] = STATE(1286),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1287),
    [sym__variable] = STATE(1285),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(1287),
    [sym_false] = STATE(1287),
    [sym_nil] = STATE(1287),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(1288),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(2281),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2283),
    [anon_sym_yield] = ACTIONS(2285),
    [anon_sym_break] = ACTIONS(2287),
    [anon_sym_next] = ACTIONS(2289),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2291),
    [anon_sym_defined_QMARK] = ACTIONS(2293),
    [anon_sym_not] = ACTIONS(2295),
    [anon_sym_BANG] = ACTIONS(2297),
    [anon_sym_TILDE] = ACTIONS(2297),
    [sym_constant] = ACTIONS(2299),
    [sym_identifier] = ACTIONS(2299),
    [sym_instance_variable] = ACTIONS(2301),
    [sym_class_variable] = ACTIONS(2301),
    [sym_global_variable] = ACTIONS(2301),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2299),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2299),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3324] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(5977),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(1287),
    [sym_scope_resolution] = STATE(1285),
    [sym_call] = STATE(1285),
    [sym_method_call] = STATE(1287),
    [sym_assignment] = STATE(5977),
    [sym_operator_assignment] = STATE(5977),
    [sym_conditional] = STATE(5977),
    [sym_range] = STATE(5977),
    [sym_binary] = STATE(5977),
    [sym_unary] = STATE(5977),
    [sym_left_assignment_list] = STATE(1286),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1287),
    [sym__variable] = STATE(1285),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(1287),
    [sym_false] = STATE(1287),
    [sym_nil] = STATE(1287),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(1288),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(2281),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2283),
    [anon_sym_yield] = ACTIONS(2285),
    [anon_sym_break] = ACTIONS(2287),
    [anon_sym_next] = ACTIONS(2289),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2291),
    [anon_sym_defined_QMARK] = ACTIONS(2293),
    [anon_sym_not] = ACTIONS(2295),
    [anon_sym_BANG] = ACTIONS(2297),
    [anon_sym_TILDE] = ACTIONS(2297),
    [sym_constant] = ACTIONS(2299),
    [sym_identifier] = ACTIONS(2299),
    [sym_instance_variable] = ACTIONS(2301),
    [sym_class_variable] = ACTIONS(2301),
    [sym_global_variable] = ACTIONS(2301),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2299),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2299),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3325] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(5978),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(1287),
    [sym_scope_resolution] = STATE(1285),
    [sym_call] = STATE(1285),
    [sym_method_call] = STATE(1287),
    [sym_assignment] = STATE(5978),
    [sym_operator_assignment] = STATE(5978),
    [sym_conditional] = STATE(5978),
    [sym_range] = STATE(5978),
    [sym_binary] = STATE(5978),
    [sym_unary] = STATE(5978),
    [sym_left_assignment_list] = STATE(1286),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1287),
    [sym__variable] = STATE(1285),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(1287),
    [sym_false] = STATE(1287),
    [sym_nil] = STATE(1287),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(1288),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(2281),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2283),
    [anon_sym_yield] = ACTIONS(2285),
    [anon_sym_break] = ACTIONS(2287),
    [anon_sym_next] = ACTIONS(2289),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2291),
    [anon_sym_defined_QMARK] = ACTIONS(2293),
    [anon_sym_not] = ACTIONS(2295),
    [anon_sym_BANG] = ACTIONS(2297),
    [anon_sym_TILDE] = ACTIONS(2297),
    [sym_constant] = ACTIONS(2299),
    [sym_identifier] = ACTIONS(2299),
    [sym_instance_variable] = ACTIONS(2301),
    [sym_class_variable] = ACTIONS(2301),
    [sym_global_variable] = ACTIONS(2301),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2299),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2299),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3326] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(5979),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(5979),
    [sym_operator_assignment] = STATE(5979),
    [sym_conditional] = STATE(5979),
    [sym_range] = STATE(5979),
    [sym_binary] = STATE(5979),
    [sym_unary] = STATE(5979),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3327] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(5980),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(1287),
    [sym_scope_resolution] = STATE(1285),
    [sym_call] = STATE(1285),
    [sym_method_call] = STATE(1287),
    [sym_assignment] = STATE(5980),
    [sym_operator_assignment] = STATE(5980),
    [sym_conditional] = STATE(5980),
    [sym_range] = STATE(5980),
    [sym_binary] = STATE(5980),
    [sym_unary] = STATE(5980),
    [sym_left_assignment_list] = STATE(1286),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1287),
    [sym__variable] = STATE(1285),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(1287),
    [sym_false] = STATE(1287),
    [sym_nil] = STATE(1287),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(1288),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(2281),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2283),
    [anon_sym_yield] = ACTIONS(2285),
    [anon_sym_break] = ACTIONS(2287),
    [anon_sym_next] = ACTIONS(2289),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2291),
    [anon_sym_defined_QMARK] = ACTIONS(2293),
    [anon_sym_not] = ACTIONS(2295),
    [anon_sym_BANG] = ACTIONS(2297),
    [anon_sym_TILDE] = ACTIONS(2297),
    [sym_constant] = ACTIONS(2299),
    [sym_identifier] = ACTIONS(2299),
    [sym_instance_variable] = ACTIONS(2301),
    [sym_class_variable] = ACTIONS(2301),
    [sym_global_variable] = ACTIONS(2301),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2299),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2299),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3328] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(5981),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(1287),
    [sym_scope_resolution] = STATE(1285),
    [sym_call] = STATE(1285),
    [sym_method_call] = STATE(1287),
    [sym_assignment] = STATE(5981),
    [sym_operator_assignment] = STATE(5981),
    [sym_conditional] = STATE(5981),
    [sym_range] = STATE(5981),
    [sym_binary] = STATE(5981),
    [sym_unary] = STATE(5981),
    [sym_left_assignment_list] = STATE(1286),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1287),
    [sym__variable] = STATE(1285),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(1287),
    [sym_false] = STATE(1287),
    [sym_nil] = STATE(1287),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(1288),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(2281),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2283),
    [anon_sym_yield] = ACTIONS(2285),
    [anon_sym_break] = ACTIONS(2287),
    [anon_sym_next] = ACTIONS(2289),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2291),
    [anon_sym_defined_QMARK] = ACTIONS(2293),
    [anon_sym_not] = ACTIONS(2295),
    [anon_sym_BANG] = ACTIONS(2297),
    [anon_sym_TILDE] = ACTIONS(2297),
    [sym_constant] = ACTIONS(2299),
    [sym_identifier] = ACTIONS(2299),
    [sym_instance_variable] = ACTIONS(2301),
    [sym_class_variable] = ACTIONS(2301),
    [sym_global_variable] = ACTIONS(2301),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2299),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2299),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3329] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(5982),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(1287),
    [sym_scope_resolution] = STATE(1285),
    [sym_call] = STATE(1285),
    [sym_method_call] = STATE(1287),
    [sym_assignment] = STATE(5982),
    [sym_operator_assignment] = STATE(5982),
    [sym_conditional] = STATE(5982),
    [sym_range] = STATE(5982),
    [sym_binary] = STATE(5982),
    [sym_unary] = STATE(5982),
    [sym_left_assignment_list] = STATE(1286),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1287),
    [sym__variable] = STATE(1285),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(1287),
    [sym_false] = STATE(1287),
    [sym_nil] = STATE(1287),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(1288),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(2281),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2283),
    [anon_sym_yield] = ACTIONS(2285),
    [anon_sym_break] = ACTIONS(2287),
    [anon_sym_next] = ACTIONS(2289),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2291),
    [anon_sym_defined_QMARK] = ACTIONS(2293),
    [anon_sym_not] = ACTIONS(2295),
    [anon_sym_BANG] = ACTIONS(2297),
    [anon_sym_TILDE] = ACTIONS(2297),
    [sym_constant] = ACTIONS(2299),
    [sym_identifier] = ACTIONS(2299),
    [sym_instance_variable] = ACTIONS(2301),
    [sym_class_variable] = ACTIONS(2301),
    [sym_global_variable] = ACTIONS(2301),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2299),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2299),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3330] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(5983),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(1287),
    [sym_scope_resolution] = STATE(1285),
    [sym_call] = STATE(1285),
    [sym_method_call] = STATE(1287),
    [sym_assignment] = STATE(5983),
    [sym_operator_assignment] = STATE(5983),
    [sym_conditional] = STATE(5983),
    [sym_range] = STATE(5983),
    [sym_binary] = STATE(5983),
    [sym_unary] = STATE(5983),
    [sym_left_assignment_list] = STATE(1286),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1287),
    [sym__variable] = STATE(1285),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(1287),
    [sym_false] = STATE(1287),
    [sym_nil] = STATE(1287),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(1288),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(2281),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2283),
    [anon_sym_yield] = ACTIONS(2285),
    [anon_sym_break] = ACTIONS(2287),
    [anon_sym_next] = ACTIONS(2289),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2291),
    [anon_sym_defined_QMARK] = ACTIONS(2293),
    [anon_sym_not] = ACTIONS(2295),
    [anon_sym_BANG] = ACTIONS(2297),
    [anon_sym_TILDE] = ACTIONS(2297),
    [sym_constant] = ACTIONS(2299),
    [sym_identifier] = ACTIONS(2299),
    [sym_instance_variable] = ACTIONS(2301),
    [sym_class_variable] = ACTIONS(2301),
    [sym_global_variable] = ACTIONS(2301),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2299),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2299),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3331] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(5991),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(5994),
    [sym_scope_resolution] = STATE(5992),
    [sym_call] = STATE(5992),
    [sym_method_call] = STATE(5994),
    [sym_assignment] = STATE(5991),
    [sym_operator_assignment] = STATE(5991),
    [sym_conditional] = STATE(5991),
    [sym_range] = STATE(5991),
    [sym_binary] = STATE(5991),
    [sym_unary] = STATE(5991),
    [sym_left_assignment_list] = STATE(5993),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5994),
    [sym__variable] = STATE(5992),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(5994),
    [sym_false] = STATE(5994),
    [sym_nil] = STATE(5994),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(5995),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(9306),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(9308),
    [anon_sym_yield] = ACTIONS(9310),
    [anon_sym_break] = ACTIONS(9312),
    [anon_sym_next] = ACTIONS(9314),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(9316),
    [anon_sym_defined_QMARK] = ACTIONS(9318),
    [anon_sym_not] = ACTIONS(9320),
    [anon_sym_BANG] = ACTIONS(9322),
    [anon_sym_TILDE] = ACTIONS(9322),
    [sym_constant] = ACTIONS(9324),
    [sym_identifier] = ACTIONS(9324),
    [sym_instance_variable] = ACTIONS(9326),
    [sym_class_variable] = ACTIONS(9326),
    [sym_global_variable] = ACTIONS(9326),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(9324),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9324),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [3332] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(5996),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(5994),
    [sym_scope_resolution] = STATE(5992),
    [sym_call] = STATE(5992),
    [sym_method_call] = STATE(5994),
    [sym_assignment] = STATE(5996),
    [sym_operator_assignment] = STATE(5996),
    [sym_conditional] = STATE(5996),
    [sym_range] = STATE(5996),
    [sym_binary] = STATE(5996),
    [sym_unary] = STATE(5996),
    [sym_left_assignment_list] = STATE(5993),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5994),
    [sym__variable] = STATE(5992),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(5994),
    [sym_false] = STATE(5994),
    [sym_nil] = STATE(5994),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(5995),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(9306),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(9308),
    [anon_sym_yield] = ACTIONS(9310),
    [anon_sym_break] = ACTIONS(9312),
    [anon_sym_next] = ACTIONS(9314),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(9316),
    [anon_sym_defined_QMARK] = ACTIONS(9318),
    [anon_sym_not] = ACTIONS(9320),
    [anon_sym_BANG] = ACTIONS(9322),
    [anon_sym_TILDE] = ACTIONS(9322),
    [sym_constant] = ACTIONS(9324),
    [sym_identifier] = ACTIONS(9324),
    [sym_instance_variable] = ACTIONS(9326),
    [sym_class_variable] = ACTIONS(9326),
    [sym_global_variable] = ACTIONS(9326),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(9324),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9324),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [3333] = {
    [anon_sym_COLON] = ACTIONS(9328),
    [sym_comment] = ACTIONS(87),
  },
  [3334] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(5998),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(5994),
    [sym_scope_resolution] = STATE(5992),
    [sym_call] = STATE(5992),
    [sym_method_call] = STATE(5994),
    [sym_assignment] = STATE(5998),
    [sym_operator_assignment] = STATE(5998),
    [sym_conditional] = STATE(5998),
    [sym_range] = STATE(5998),
    [sym_binary] = STATE(5998),
    [sym_unary] = STATE(5998),
    [sym_left_assignment_list] = STATE(5993),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5994),
    [sym__variable] = STATE(5992),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(5994),
    [sym_false] = STATE(5994),
    [sym_nil] = STATE(5994),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(5995),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(9306),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(9308),
    [anon_sym_yield] = ACTIONS(9310),
    [anon_sym_break] = ACTIONS(9312),
    [anon_sym_next] = ACTIONS(9314),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(9316),
    [anon_sym_defined_QMARK] = ACTIONS(9318),
    [anon_sym_not] = ACTIONS(9320),
    [anon_sym_BANG] = ACTIONS(9322),
    [anon_sym_TILDE] = ACTIONS(9322),
    [sym_constant] = ACTIONS(9324),
    [sym_identifier] = ACTIONS(9324),
    [sym_instance_variable] = ACTIONS(9326),
    [sym_class_variable] = ACTIONS(9326),
    [sym_global_variable] = ACTIONS(9326),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(9324),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9324),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [3335] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(9330),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_RBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [3336] = {
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(5685),
    [sym__binary_star] = ACTIONS(5687),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(5689),
    [anon_sym_STAR_STAR] = ACTIONS(5691),
    [anon_sym_AMP] = ACTIONS(5693),
    [anon_sym_EQ] = ACTIONS(1631),
    [anon_sym_LT] = ACTIONS(5695),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(9328),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_RBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_PLUS_EQ] = ACTIONS(1625),
    [anon_sym_DASH_EQ] = ACTIONS(1625),
    [anon_sym_STAR_EQ] = ACTIONS(1625),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1625),
    [anon_sym_SLASH_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1625),
    [anon_sym_AMP_EQ] = ACTIONS(1625),
    [anon_sym_PERCENT_EQ] = ACTIONS(1625),
    [anon_sym_GT_GT_EQ] = ACTIONS(1625),
    [anon_sym_LT_LT_EQ] = ACTIONS(1625),
    [anon_sym_CARET_EQ] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(5697),
    [anon_sym_DOT_DOT] = ACTIONS(5699),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5701),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(5703),
    [anon_sym_AMP_AMP] = ACTIONS(5703),
    [anon_sym_LT_LT] = ACTIONS(5705),
    [anon_sym_GT_GT] = ACTIONS(5705),
    [anon_sym_EQ_EQ] = ACTIONS(5703),
    [anon_sym_BANG_EQ] = ACTIONS(5707),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5707),
    [anon_sym_LT_EQ_GT] = ACTIONS(5707),
    [anon_sym_EQ_TILDE] = ACTIONS(5707),
    [anon_sym_BANG_TILDE] = ACTIONS(5707),
    [anon_sym_LT_EQ] = ACTIONS(5695),
    [anon_sym_GT] = ACTIONS(5695),
    [anon_sym_GT_EQ] = ACTIONS(5709),
    [anon_sym_CARET] = ACTIONS(5689),
    [anon_sym_PLUS] = ACTIONS(5711),
    [anon_sym_SLASH] = ACTIONS(5691),
    [anon_sym_PERCENT] = ACTIONS(5691),
    [sym_comment] = ACTIONS(87),
  },
  [3337] = {
    [sym_heredoc_body] = STATE(6000),
    [aux_sym_call_repeat1] = STATE(6000),
    [sym__heredoc_body_start] = ACTIONS(6569),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_RBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [3338] = {
    [sym_heredoc_body] = STATE(6000),
    [aux_sym_call_repeat1] = STATE(6000),
    [aux_sym_argument_list_repeat1] = STATE(6002),
    [sym__heredoc_body_start] = ACTIONS(6569),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(9332),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_RBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [3339] = {
    [sym_string] = STATE(3453),
    [aux_sym_chained_string_repeat1] = STATE(3453),
    [sym__string_start] = ACTIONS(1141),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(9334),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3340] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(6004),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(1287),
    [sym_scope_resolution] = STATE(1285),
    [sym_call] = STATE(1285),
    [sym_method_call] = STATE(1287),
    [sym_splat_argument] = STATE(6005),
    [sym_assignment] = STATE(6004),
    [sym_operator_assignment] = STATE(6004),
    [sym_conditional] = STATE(6004),
    [sym_range] = STATE(6004),
    [sym_binary] = STATE(6004),
    [sym_unary] = STATE(6004),
    [sym_right_assignment_list] = STATE(3461),
    [sym__arg_or_splat_arg] = STATE(6005),
    [sym_left_assignment_list] = STATE(1286),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1287),
    [sym__variable] = STATE(1285),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(1287),
    [sym_false] = STATE(1287),
    [sym_nil] = STATE(1287),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(1288),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(9336),
    [sym__unary_minus] = ACTIONS(2281),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2283),
    [anon_sym_yield] = ACTIONS(2285),
    [anon_sym_break] = ACTIONS(2287),
    [anon_sym_next] = ACTIONS(2289),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2291),
    [anon_sym_defined_QMARK] = ACTIONS(2293),
    [anon_sym_not] = ACTIONS(2295),
    [anon_sym_BANG] = ACTIONS(2297),
    [anon_sym_TILDE] = ACTIONS(2297),
    [sym_constant] = ACTIONS(2299),
    [sym_identifier] = ACTIONS(2299),
    [sym_instance_variable] = ACTIONS(2301),
    [sym_class_variable] = ACTIONS(2301),
    [sym_global_variable] = ACTIONS(2301),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2299),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2299),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3341] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(6006),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(1287),
    [sym_scope_resolution] = STATE(1285),
    [sym_call] = STATE(1285),
    [sym_method_call] = STATE(1287),
    [sym_assignment] = STATE(6006),
    [sym_operator_assignment] = STATE(6006),
    [sym_conditional] = STATE(6006),
    [sym_range] = STATE(6006),
    [sym_binary] = STATE(6006),
    [sym_unary] = STATE(6006),
    [sym_left_assignment_list] = STATE(1286),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1287),
    [sym__variable] = STATE(1285),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(1287),
    [sym_false] = STATE(1287),
    [sym_nil] = STATE(1287),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(1288),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(2281),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2283),
    [anon_sym_yield] = ACTIONS(2285),
    [anon_sym_break] = ACTIONS(2287),
    [anon_sym_next] = ACTIONS(2289),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2291),
    [anon_sym_defined_QMARK] = ACTIONS(2293),
    [anon_sym_not] = ACTIONS(2295),
    [anon_sym_BANG] = ACTIONS(2297),
    [anon_sym_TILDE] = ACTIONS(2297),
    [sym_constant] = ACTIONS(2299),
    [sym_identifier] = ACTIONS(2299),
    [sym_instance_variable] = ACTIONS(2301),
    [sym_class_variable] = ACTIONS(2301),
    [sym_global_variable] = ACTIONS(2301),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2299),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2299),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3342] = {
    [sym_string] = STATE(6007),
    [aux_sym_chained_string_repeat1] = STATE(6007),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_RBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [3343] = {
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(5535),
    [sym__binary_star] = ACTIONS(5537),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5537),
    [anon_sym_AMP] = ACTIONS(5541),
    [anon_sym_LT] = ACTIONS(5543),
    [anon_sym_RBRACK] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(5545),
    [anon_sym_DOT_DOT] = ACTIONS(5547),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5549),
    [anon_sym_and] = ACTIONS(5551),
    [anon_sym_or] = ACTIONS(5551),
    [anon_sym_PIPE_PIPE] = ACTIONS(5553),
    [anon_sym_AMP_AMP] = ACTIONS(5553),
    [anon_sym_LT_LT] = ACTIONS(5555),
    [anon_sym_GT_GT] = ACTIONS(5555),
    [anon_sym_EQ_EQ] = ACTIONS(5557),
    [anon_sym_BANG_EQ] = ACTIONS(5553),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5553),
    [anon_sym_LT_EQ_GT] = ACTIONS(5553),
    [anon_sym_EQ_TILDE] = ACTIONS(5553),
    [anon_sym_BANG_TILDE] = ACTIONS(5553),
    [anon_sym_LT_EQ] = ACTIONS(5543),
    [anon_sym_GT] = ACTIONS(5543),
    [anon_sym_GT_EQ] = ACTIONS(5559),
    [anon_sym_CARET] = ACTIONS(5561),
    [anon_sym_PLUS] = ACTIONS(5535),
    [anon_sym_SLASH] = ACTIONS(5537),
    [anon_sym_PERCENT] = ACTIONS(5537),
    [sym_comment] = ACTIONS(87),
  },
  [3344] = {
    [sym__heredoc_body_start] = ACTIONS(3575),
    [sym__binary_minus] = ACTIONS(3575),
    [sym__binary_star] = ACTIONS(3575),
    [anon_sym_LBRACE] = ACTIONS(3575),
    [anon_sym_RBRACE] = ACTIONS(3575),
    [anon_sym_RPAREN] = ACTIONS(3575),
    [anon_sym_DOT] = ACTIONS(3577),
    [anon_sym_COMMA] = ACTIONS(3575),
    [anon_sym_PIPE] = ACTIONS(3577),
    [anon_sym_SEMI] = ACTIONS(3575),
    [anon_sym_STAR_STAR] = ACTIONS(3575),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_EQ] = ACTIONS(3577),
    [anon_sym_LT] = ACTIONS(3577),
    [anon_sym_if] = ACTIONS(3575),
    [anon_sym_unless] = ACTIONS(3575),
    [anon_sym_while] = ACTIONS(3575),
    [anon_sym_until] = ACTIONS(3575),
    [anon_sym_rescue] = ACTIONS(3575),
    [anon_sym_in] = ACTIONS(3575),
    [anon_sym_do] = ACTIONS(3575),
    [anon_sym_EQ_GT] = ACTIONS(3575),
    [anon_sym_LBRACK] = ACTIONS(3575),
    [anon_sym_RBRACK] = ACTIONS(3575),
    [anon_sym_COLON_COLON2] = ACTIONS(3575),
    [anon_sym_AMP_DOT] = ACTIONS(3575),
    [anon_sym_QMARK] = ACTIONS(3575),
    [anon_sym_COLON2] = ACTIONS(3577),
    [anon_sym_DOT_DOT] = ACTIONS(3577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3575),
    [anon_sym_and] = ACTIONS(3575),
    [anon_sym_or] = ACTIONS(3575),
    [anon_sym_PIPE_PIPE] = ACTIONS(3575),
    [anon_sym_AMP_AMP] = ACTIONS(3575),
    [anon_sym_LT_LT] = ACTIONS(3575),
    [anon_sym_GT_GT] = ACTIONS(3575),
    [anon_sym_EQ_EQ] = ACTIONS(3577),
    [anon_sym_BANG_EQ] = ACTIONS(3575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3575),
    [anon_sym_LT_EQ_GT] = ACTIONS(3575),
    [anon_sym_EQ_TILDE] = ACTIONS(3575),
    [anon_sym_BANG_TILDE] = ACTIONS(3575),
    [anon_sym_LT_EQ] = ACTIONS(3577),
    [anon_sym_GT] = ACTIONS(3577),
    [anon_sym_GT_EQ] = ACTIONS(3575),
    [anon_sym_CARET] = ACTIONS(3575),
    [anon_sym_PLUS] = ACTIONS(3575),
    [anon_sym_SLASH] = ACTIONS(3575),
    [anon_sym_PERCENT] = ACTIONS(3575),
    [sym_comment] = ACTIONS(87),
  },
  [3345] = {
    [anon_sym_RBRACE] = ACTIONS(9338),
    [sym_comment] = ACTIONS(87),
  },
  [3346] = {
    [sym__binary_minus] = ACTIONS(3609),
    [sym__binary_star] = ACTIONS(3611),
    [anon_sym_RPAREN] = ACTIONS(9340),
    [anon_sym_PIPE] = ACTIONS(3615),
    [anon_sym_STAR_STAR] = ACTIONS(3611),
    [anon_sym_AMP] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3619),
    [anon_sym_QMARK] = ACTIONS(3621),
    [anon_sym_DOT_DOT] = ACTIONS(3623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3625),
    [anon_sym_and] = ACTIONS(3627),
    [anon_sym_or] = ACTIONS(3627),
    [anon_sym_PIPE_PIPE] = ACTIONS(3629),
    [anon_sym_AMP_AMP] = ACTIONS(3629),
    [anon_sym_LT_LT] = ACTIONS(3631),
    [anon_sym_GT_GT] = ACTIONS(3631),
    [anon_sym_EQ_EQ] = ACTIONS(3633),
    [anon_sym_BANG_EQ] = ACTIONS(3629),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3629),
    [anon_sym_LT_EQ_GT] = ACTIONS(3629),
    [anon_sym_EQ_TILDE] = ACTIONS(3629),
    [anon_sym_BANG_TILDE] = ACTIONS(3629),
    [anon_sym_LT_EQ] = ACTIONS(3619),
    [anon_sym_GT] = ACTIONS(3619),
    [anon_sym_GT_EQ] = ACTIONS(3635),
    [anon_sym_CARET] = ACTIONS(3637),
    [anon_sym_PLUS] = ACTIONS(3609),
    [anon_sym_SLASH] = ACTIONS(3611),
    [anon_sym_PERCENT] = ACTIONS(3611),
    [sym_comment] = ACTIONS(87),
  },
  [3347] = {
    [sym__method_rest] = STATE(6010),
    [sym_operator] = STATE(1299),
    [sym__method_name] = STATE(1299),
    [sym_setter] = STATE(1299),
    [sym_symbol] = STATE(1299),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(9342),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(9342),
    [sym_class_variable] = ACTIONS(9342),
    [sym_global_variable] = ACTIONS(9342),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [3348] = {
    [sym__statements] = STATE(1334),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(1335),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(1336),
    [sym_rescue] = STATE(1337),
    [sym__body_statement] = STATE(6011),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9344),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3349] = {
    [sym__heredoc_body_start] = ACTIONS(3805),
    [sym__binary_minus] = ACTIONS(3805),
    [sym__binary_star] = ACTIONS(3805),
    [anon_sym_LBRACE] = ACTIONS(3805),
    [anon_sym_RBRACE] = ACTIONS(3805),
    [anon_sym_RPAREN] = ACTIONS(3805),
    [anon_sym_DOT] = ACTIONS(3807),
    [anon_sym_COMMA] = ACTIONS(3805),
    [anon_sym_PIPE] = ACTIONS(3807),
    [anon_sym_SEMI] = ACTIONS(3805),
    [anon_sym_STAR_STAR] = ACTIONS(3805),
    [anon_sym_AMP] = ACTIONS(3807),
    [anon_sym_EQ] = ACTIONS(3807),
    [anon_sym_LT] = ACTIONS(3807),
    [anon_sym_if] = ACTIONS(3805),
    [anon_sym_unless] = ACTIONS(3805),
    [anon_sym_while] = ACTIONS(3805),
    [anon_sym_until] = ACTIONS(3805),
    [anon_sym_rescue] = ACTIONS(3805),
    [anon_sym_in] = ACTIONS(3805),
    [anon_sym_do] = ACTIONS(3805),
    [anon_sym_EQ_GT] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(3805),
    [anon_sym_RBRACK] = ACTIONS(3805),
    [anon_sym_COLON_COLON2] = ACTIONS(3805),
    [anon_sym_AMP_DOT] = ACTIONS(3805),
    [anon_sym_QMARK] = ACTIONS(3805),
    [anon_sym_COLON2] = ACTIONS(3807),
    [anon_sym_DOT_DOT] = ACTIONS(3807),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3805),
    [anon_sym_and] = ACTIONS(3805),
    [anon_sym_or] = ACTIONS(3805),
    [anon_sym_PIPE_PIPE] = ACTIONS(3805),
    [anon_sym_AMP_AMP] = ACTIONS(3805),
    [anon_sym_LT_LT] = ACTIONS(3805),
    [anon_sym_GT_GT] = ACTIONS(3805),
    [anon_sym_EQ_EQ] = ACTIONS(3807),
    [anon_sym_BANG_EQ] = ACTIONS(3805),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3805),
    [anon_sym_LT_EQ_GT] = ACTIONS(3805),
    [anon_sym_EQ_TILDE] = ACTIONS(3805),
    [anon_sym_BANG_TILDE] = ACTIONS(3805),
    [anon_sym_LT_EQ] = ACTIONS(3807),
    [anon_sym_GT] = ACTIONS(3807),
    [anon_sym_GT_EQ] = ACTIONS(3805),
    [anon_sym_CARET] = ACTIONS(3805),
    [anon_sym_PLUS] = ACTIONS(3805),
    [anon_sym_SLASH] = ACTIONS(3805),
    [anon_sym_PERCENT] = ACTIONS(3805),
    [sym_comment] = ACTIONS(87),
  },
  [3350] = {
    [sym_heredoc_body] = STATE(6012),
    [sym__terminator] = STATE(6012),
    [sym__line_break] = ACTIONS(9346),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym__binary_minus] = ACTIONS(2001),
    [sym__binary_star] = ACTIONS(2003),
    [anon_sym_PIPE] = ACTIONS(2005),
    [anon_sym_SEMI] = ACTIONS(9346),
    [anon_sym_STAR_STAR] = ACTIONS(2003),
    [anon_sym_AMP] = ACTIONS(2007),
    [anon_sym_LT] = ACTIONS(2009),
    [anon_sym_QMARK] = ACTIONS(2011),
    [anon_sym_DOT_DOT] = ACTIONS(2013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2015),
    [anon_sym_and] = ACTIONS(2017),
    [anon_sym_or] = ACTIONS(2017),
    [anon_sym_PIPE_PIPE] = ACTIONS(2019),
    [anon_sym_AMP_AMP] = ACTIONS(2019),
    [anon_sym_LT_LT] = ACTIONS(2021),
    [anon_sym_GT_GT] = ACTIONS(2021),
    [anon_sym_EQ_EQ] = ACTIONS(2023),
    [anon_sym_BANG_EQ] = ACTIONS(2019),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2019),
    [anon_sym_LT_EQ_GT] = ACTIONS(2019),
    [anon_sym_EQ_TILDE] = ACTIONS(2019),
    [anon_sym_BANG_TILDE] = ACTIONS(2019),
    [anon_sym_LT_EQ] = ACTIONS(2009),
    [anon_sym_GT] = ACTIONS(2009),
    [anon_sym_GT_EQ] = ACTIONS(2025),
    [anon_sym_CARET] = ACTIONS(2027),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_SLASH] = ACTIONS(2003),
    [anon_sym_PERCENT] = ACTIONS(2003),
    [sym_comment] = ACTIONS(87),
  },
  [3351] = {
    [sym_heredoc_body] = STATE(6013),
    [sym__terminator] = STATE(6013),
    [sym__line_break] = ACTIONS(9348),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(9348),
    [sym_comment] = ACTIONS(87),
  },
  [3352] = {
    [sym__statements] = STATE(1334),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(1335),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(1336),
    [sym_rescue] = STATE(1337),
    [sym__body_statement] = STATE(6014),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9350),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3353] = {
    [sym__heredoc_body_start] = ACTIONS(4205),
    [sym__binary_minus] = ACTIONS(4205),
    [sym__binary_star] = ACTIONS(4205),
    [anon_sym_LBRACE] = ACTIONS(4205),
    [anon_sym_RBRACE] = ACTIONS(4205),
    [anon_sym_RPAREN] = ACTIONS(4205),
    [anon_sym_DOT] = ACTIONS(4207),
    [anon_sym_COMMA] = ACTIONS(4205),
    [anon_sym_PIPE] = ACTIONS(4207),
    [anon_sym_SEMI] = ACTIONS(4205),
    [anon_sym_STAR_STAR] = ACTIONS(4205),
    [anon_sym_AMP] = ACTIONS(4207),
    [anon_sym_EQ] = ACTIONS(4207),
    [anon_sym_LT] = ACTIONS(4207),
    [anon_sym_if] = ACTIONS(4205),
    [anon_sym_unless] = ACTIONS(4205),
    [anon_sym_while] = ACTIONS(4205),
    [anon_sym_until] = ACTIONS(4205),
    [anon_sym_rescue] = ACTIONS(4205),
    [anon_sym_in] = ACTIONS(4205),
    [anon_sym_do] = ACTIONS(4205),
    [anon_sym_EQ_GT] = ACTIONS(4205),
    [anon_sym_LBRACK] = ACTIONS(4205),
    [anon_sym_RBRACK] = ACTIONS(4205),
    [anon_sym_COLON_COLON2] = ACTIONS(4205),
    [anon_sym_AMP_DOT] = ACTIONS(4205),
    [anon_sym_QMARK] = ACTIONS(4205),
    [anon_sym_COLON2] = ACTIONS(4207),
    [anon_sym_DOT_DOT] = ACTIONS(4207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4205),
    [anon_sym_and] = ACTIONS(4205),
    [anon_sym_or] = ACTIONS(4205),
    [anon_sym_PIPE_PIPE] = ACTIONS(4205),
    [anon_sym_AMP_AMP] = ACTIONS(4205),
    [anon_sym_LT_LT] = ACTIONS(4205),
    [anon_sym_GT_GT] = ACTIONS(4205),
    [anon_sym_EQ_EQ] = ACTIONS(4207),
    [anon_sym_BANG_EQ] = ACTIONS(4205),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4205),
    [anon_sym_LT_EQ_GT] = ACTIONS(4205),
    [anon_sym_EQ_TILDE] = ACTIONS(4205),
    [anon_sym_BANG_TILDE] = ACTIONS(4205),
    [anon_sym_LT_EQ] = ACTIONS(4207),
    [anon_sym_GT] = ACTIONS(4207),
    [anon_sym_GT_EQ] = ACTIONS(4205),
    [anon_sym_CARET] = ACTIONS(4205),
    [anon_sym_PLUS] = ACTIONS(4205),
    [anon_sym_SLASH] = ACTIONS(4205),
    [anon_sym_PERCENT] = ACTIONS(4205),
    [sym_comment] = ACTIONS(87),
  },
  [3354] = {
    [sym__statements] = STATE(1334),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(1335),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(1336),
    [sym_rescue] = STATE(1337),
    [sym__body_statement] = STATE(6015),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9352),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3355] = {
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(5597),
    [sym__binary_star] = ACTIONS(5599),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(5601),
    [anon_sym_STAR_STAR] = ACTIONS(5599),
    [anon_sym_AMP] = ACTIONS(5603),
    [anon_sym_LT] = ACTIONS(5605),
    [anon_sym_EQ_GT] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_RBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(5607),
    [anon_sym_DOT_DOT] = ACTIONS(5609),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5611),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(5613),
    [anon_sym_AMP_AMP] = ACTIONS(5613),
    [anon_sym_LT_LT] = ACTIONS(5615),
    [anon_sym_GT_GT] = ACTIONS(5615),
    [anon_sym_EQ_EQ] = ACTIONS(5617),
    [anon_sym_BANG_EQ] = ACTIONS(5613),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5613),
    [anon_sym_LT_EQ_GT] = ACTIONS(5613),
    [anon_sym_EQ_TILDE] = ACTIONS(5613),
    [anon_sym_BANG_TILDE] = ACTIONS(5613),
    [anon_sym_LT_EQ] = ACTIONS(5605),
    [anon_sym_GT] = ACTIONS(5605),
    [anon_sym_GT_EQ] = ACTIONS(5619),
    [anon_sym_CARET] = ACTIONS(5621),
    [anon_sym_PLUS] = ACTIONS(5597),
    [anon_sym_SLASH] = ACTIONS(5599),
    [anon_sym_PERCENT] = ACTIONS(5599),
    [sym_comment] = ACTIONS(87),
  },
  [3356] = {
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(5597),
    [sym__binary_star] = ACTIONS(5599),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(5601),
    [anon_sym_STAR_STAR] = ACTIONS(5599),
    [anon_sym_AMP] = ACTIONS(5603),
    [anon_sym_LT] = ACTIONS(5605),
    [anon_sym_EQ_GT] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_RBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(5607),
    [anon_sym_DOT_DOT] = ACTIONS(5609),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5611),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(5613),
    [anon_sym_AMP_AMP] = ACTIONS(5613),
    [anon_sym_LT_LT] = ACTIONS(5615),
    [anon_sym_GT_GT] = ACTIONS(5615),
    [anon_sym_EQ_EQ] = ACTIONS(5617),
    [anon_sym_BANG_EQ] = ACTIONS(5613),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5613),
    [anon_sym_LT_EQ_GT] = ACTIONS(5613),
    [anon_sym_EQ_TILDE] = ACTIONS(5613),
    [anon_sym_BANG_TILDE] = ACTIONS(5613),
    [anon_sym_LT_EQ] = ACTIONS(5605),
    [anon_sym_GT] = ACTIONS(5605),
    [anon_sym_GT_EQ] = ACTIONS(5619),
    [anon_sym_CARET] = ACTIONS(5621),
    [anon_sym_PLUS] = ACTIONS(5597),
    [anon_sym_SLASH] = ACTIONS(5599),
    [anon_sym_PERCENT] = ACTIONS(5599),
    [sym_comment] = ACTIONS(87),
  },
  [3357] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(5599),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_RBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [3358] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(6016),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1322),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(1322),
    [sym_assignment] = STATE(6016),
    [sym_operator_assignment] = STATE(6016),
    [sym_conditional] = STATE(6016),
    [sym_range] = STATE(6016),
    [sym_binary] = STATE(6016),
    [sym_unary] = STATE(6016),
    [sym_left_assignment_list] = STATE(1321),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1322),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1322),
    [sym_false] = STATE(1322),
    [sym_nil] = STATE(1322),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1291),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2325),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5591),
    [anon_sym_defined_QMARK] = ACTIONS(2329),
    [anon_sym_not] = ACTIONS(2331),
    [anon_sym_BANG] = ACTIONS(2335),
    [anon_sym_TILDE] = ACTIONS(2335),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3359] = {
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(5597),
    [sym__binary_star] = ACTIONS(5599),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(5601),
    [anon_sym_STAR_STAR] = ACTIONS(5599),
    [anon_sym_AMP] = ACTIONS(5603),
    [anon_sym_LT] = ACTIONS(5605),
    [anon_sym_EQ_GT] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_RBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(5607),
    [anon_sym_DOT_DOT] = ACTIONS(5609),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5611),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(5613),
    [anon_sym_AMP_AMP] = ACTIONS(5613),
    [anon_sym_LT_LT] = ACTIONS(5615),
    [anon_sym_GT_GT] = ACTIONS(5615),
    [anon_sym_EQ_EQ] = ACTIONS(5617),
    [anon_sym_BANG_EQ] = ACTIONS(5613),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5613),
    [anon_sym_LT_EQ_GT] = ACTIONS(5613),
    [anon_sym_EQ_TILDE] = ACTIONS(5613),
    [anon_sym_BANG_TILDE] = ACTIONS(5613),
    [anon_sym_LT_EQ] = ACTIONS(5605),
    [anon_sym_GT] = ACTIONS(5605),
    [anon_sym_GT_EQ] = ACTIONS(5619),
    [anon_sym_CARET] = ACTIONS(5621),
    [anon_sym_PLUS] = ACTIONS(5597),
    [anon_sym_SLASH] = ACTIONS(5599),
    [anon_sym_PERCENT] = ACTIONS(5599),
    [sym_comment] = ACTIONS(87),
  },
  [3360] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(5597),
    [sym__binary_star] = ACTIONS(5599),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(5601),
    [anon_sym_STAR_STAR] = ACTIONS(5599),
    [anon_sym_AMP] = ACTIONS(5603),
    [anon_sym_LT] = ACTIONS(5605),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_RBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(5607),
    [anon_sym_DOT_DOT] = ACTIONS(5609),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5611),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(5613),
    [anon_sym_AMP_AMP] = ACTIONS(5613),
    [anon_sym_LT_LT] = ACTIONS(5615),
    [anon_sym_GT_GT] = ACTIONS(5615),
    [anon_sym_EQ_EQ] = ACTIONS(5617),
    [anon_sym_BANG_EQ] = ACTIONS(5613),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5613),
    [anon_sym_LT_EQ_GT] = ACTIONS(5613),
    [anon_sym_EQ_TILDE] = ACTIONS(5613),
    [anon_sym_BANG_TILDE] = ACTIONS(5613),
    [anon_sym_LT_EQ] = ACTIONS(5605),
    [anon_sym_GT] = ACTIONS(5605),
    [anon_sym_GT_EQ] = ACTIONS(5619),
    [anon_sym_CARET] = ACTIONS(5621),
    [anon_sym_PLUS] = ACTIONS(5597),
    [anon_sym_SLASH] = ACTIONS(5599),
    [anon_sym_PERCENT] = ACTIONS(5599),
    [sym_comment] = ACTIONS(87),
  },
  [3361] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(6017),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1322),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(1322),
    [sym_assignment] = STATE(6017),
    [sym_operator_assignment] = STATE(6017),
    [sym_conditional] = STATE(6017),
    [sym_range] = STATE(6017),
    [sym_binary] = STATE(6017),
    [sym_unary] = STATE(6017),
    [sym_left_assignment_list] = STATE(1321),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1322),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1322),
    [sym_false] = STATE(1322),
    [sym_nil] = STATE(1322),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1291),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2325),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5591),
    [anon_sym_defined_QMARK] = ACTIONS(2329),
    [anon_sym_not] = ACTIONS(2331),
    [anon_sym_BANG] = ACTIONS(2335),
    [anon_sym_TILDE] = ACTIONS(2335),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3362] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(6018),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1322),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(1322),
    [sym_assignment] = STATE(6018),
    [sym_operator_assignment] = STATE(6018),
    [sym_conditional] = STATE(6018),
    [sym_range] = STATE(6018),
    [sym_binary] = STATE(6018),
    [sym_unary] = STATE(6018),
    [sym_left_assignment_list] = STATE(1321),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1322),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1322),
    [sym_false] = STATE(1322),
    [sym_nil] = STATE(1322),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1291),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2325),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5591),
    [anon_sym_defined_QMARK] = ACTIONS(2329),
    [anon_sym_not] = ACTIONS(2331),
    [anon_sym_BANG] = ACTIONS(2335),
    [anon_sym_TILDE] = ACTIONS(2335),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3363] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(6019),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1322),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(1322),
    [sym_assignment] = STATE(6019),
    [sym_operator_assignment] = STATE(6019),
    [sym_conditional] = STATE(6019),
    [sym_range] = STATE(6019),
    [sym_binary] = STATE(6019),
    [sym_unary] = STATE(6019),
    [sym_left_assignment_list] = STATE(1321),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1322),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1322),
    [sym_false] = STATE(1322),
    [sym_nil] = STATE(1322),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1291),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2325),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5591),
    [anon_sym_defined_QMARK] = ACTIONS(2329),
    [anon_sym_not] = ACTIONS(2331),
    [anon_sym_BANG] = ACTIONS(2335),
    [anon_sym_TILDE] = ACTIONS(2335),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3364] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(6020),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1322),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(1322),
    [sym_assignment] = STATE(6020),
    [sym_operator_assignment] = STATE(6020),
    [sym_conditional] = STATE(6020),
    [sym_range] = STATE(6020),
    [sym_binary] = STATE(6020),
    [sym_unary] = STATE(6020),
    [sym_left_assignment_list] = STATE(1321),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1322),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1322),
    [sym_false] = STATE(1322),
    [sym_nil] = STATE(1322),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1291),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2325),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5591),
    [anon_sym_defined_QMARK] = ACTIONS(2329),
    [anon_sym_not] = ACTIONS(2331),
    [anon_sym_BANG] = ACTIONS(2335),
    [anon_sym_TILDE] = ACTIONS(2335),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3365] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(6021),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1322),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(1322),
    [sym_assignment] = STATE(6021),
    [sym_operator_assignment] = STATE(6021),
    [sym_conditional] = STATE(6021),
    [sym_range] = STATE(6021),
    [sym_binary] = STATE(6021),
    [sym_unary] = STATE(6021),
    [sym_left_assignment_list] = STATE(1321),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1322),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1322),
    [sym_false] = STATE(1322),
    [sym_nil] = STATE(1322),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1291),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2325),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5591),
    [anon_sym_defined_QMARK] = ACTIONS(2329),
    [anon_sym_not] = ACTIONS(2331),
    [anon_sym_BANG] = ACTIONS(2335),
    [anon_sym_TILDE] = ACTIONS(2335),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3366] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(6022),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1322),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(1322),
    [sym_assignment] = STATE(6022),
    [sym_operator_assignment] = STATE(6022),
    [sym_conditional] = STATE(6022),
    [sym_range] = STATE(6022),
    [sym_binary] = STATE(6022),
    [sym_unary] = STATE(6022),
    [sym_left_assignment_list] = STATE(1321),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1322),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1322),
    [sym_false] = STATE(1322),
    [sym_nil] = STATE(1322),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1291),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2325),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5591),
    [anon_sym_defined_QMARK] = ACTIONS(2329),
    [anon_sym_not] = ACTIONS(2331),
    [anon_sym_BANG] = ACTIONS(2335),
    [anon_sym_TILDE] = ACTIONS(2335),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3367] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(6023),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(6023),
    [sym_operator_assignment] = STATE(6023),
    [sym_conditional] = STATE(6023),
    [sym_range] = STATE(6023),
    [sym_binary] = STATE(6023),
    [sym_unary] = STATE(6023),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3368] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(6024),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1322),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(1322),
    [sym_assignment] = STATE(6024),
    [sym_operator_assignment] = STATE(6024),
    [sym_conditional] = STATE(6024),
    [sym_range] = STATE(6024),
    [sym_binary] = STATE(6024),
    [sym_unary] = STATE(6024),
    [sym_left_assignment_list] = STATE(1321),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1322),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1322),
    [sym_false] = STATE(1322),
    [sym_nil] = STATE(1322),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1291),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2325),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5591),
    [anon_sym_defined_QMARK] = ACTIONS(2329),
    [anon_sym_not] = ACTIONS(2331),
    [anon_sym_BANG] = ACTIONS(2335),
    [anon_sym_TILDE] = ACTIONS(2335),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3369] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(6025),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1322),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(1322),
    [sym_assignment] = STATE(6025),
    [sym_operator_assignment] = STATE(6025),
    [sym_conditional] = STATE(6025),
    [sym_range] = STATE(6025),
    [sym_binary] = STATE(6025),
    [sym_unary] = STATE(6025),
    [sym_left_assignment_list] = STATE(1321),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1322),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1322),
    [sym_false] = STATE(1322),
    [sym_nil] = STATE(1322),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1291),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2325),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5591),
    [anon_sym_defined_QMARK] = ACTIONS(2329),
    [anon_sym_not] = ACTIONS(2331),
    [anon_sym_BANG] = ACTIONS(2335),
    [anon_sym_TILDE] = ACTIONS(2335),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3370] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(6026),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1322),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(1322),
    [sym_assignment] = STATE(6026),
    [sym_operator_assignment] = STATE(6026),
    [sym_conditional] = STATE(6026),
    [sym_range] = STATE(6026),
    [sym_binary] = STATE(6026),
    [sym_unary] = STATE(6026),
    [sym_left_assignment_list] = STATE(1321),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1322),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1322),
    [sym_false] = STATE(1322),
    [sym_nil] = STATE(1322),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1291),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2325),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5591),
    [anon_sym_defined_QMARK] = ACTIONS(2329),
    [anon_sym_not] = ACTIONS(2331),
    [anon_sym_BANG] = ACTIONS(2335),
    [anon_sym_TILDE] = ACTIONS(2335),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3371] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(6027),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1322),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(1322),
    [sym_assignment] = STATE(6027),
    [sym_operator_assignment] = STATE(6027),
    [sym_conditional] = STATE(6027),
    [sym_range] = STATE(6027),
    [sym_binary] = STATE(6027),
    [sym_unary] = STATE(6027),
    [sym_left_assignment_list] = STATE(1321),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1322),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1322),
    [sym_false] = STATE(1322),
    [sym_nil] = STATE(1322),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1291),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2325),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5591),
    [anon_sym_defined_QMARK] = ACTIONS(2329),
    [anon_sym_not] = ACTIONS(2331),
    [anon_sym_BANG] = ACTIONS(2335),
    [anon_sym_TILDE] = ACTIONS(2335),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3372] = {
    [sym_heredoc_body] = STATE(6028),
    [aux_sym_call_repeat1] = STATE(6028),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_RBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [3373] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(1317),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1322),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(1322),
    [sym__argument] = STATE(4250),
    [sym_splat_argument] = STATE(4250),
    [sym_hash_splat_argument] = STATE(4250),
    [sym_block_argument] = STATE(4250),
    [sym_assignment] = STATE(1317),
    [sym_operator_assignment] = STATE(1317),
    [sym_conditional] = STATE(1317),
    [sym_range] = STATE(1317),
    [sym_binary] = STATE(1317),
    [sym_unary] = STATE(1317),
    [sym_left_assignment_list] = STATE(1321),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1322),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1322),
    [sym_false] = STATE(1322),
    [sym_nil] = STATE(1322),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1323),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_heredoc_body] = STATE(6029),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(4250),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(2321),
    [sym__splat_star] = ACTIONS(2323),
    [sym__unary_minus] = ACTIONS(2325),
    [sym__identifier_hash_key] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(9354),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5591),
    [anon_sym_defined_QMARK] = ACTIONS(2329),
    [anon_sym_not] = ACTIONS(2331),
    [anon_sym_BANG] = ACTIONS(2335),
    [anon_sym_TILDE] = ACTIONS(2335),
    [sym_constant] = ACTIONS(2337),
    [sym_identifier] = ACTIONS(2337),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3374] = {
    [sym_heredoc_body] = STATE(6030),
    [aux_sym_call_repeat1] = STATE(6030),
    [aux_sym_argument_list_repeat1] = STATE(6031),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(5623),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_RBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [3375] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(6032),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1322),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(1322),
    [sym_splat_argument] = STATE(6033),
    [sym_assignment] = STATE(6032),
    [sym_operator_assignment] = STATE(6032),
    [sym_conditional] = STATE(6032),
    [sym_range] = STATE(6032),
    [sym_binary] = STATE(6032),
    [sym_unary] = STATE(6032),
    [sym_right_assignment_list] = STATE(4255),
    [sym__arg_or_splat_arg] = STATE(6033),
    [sym_left_assignment_list] = STATE(1321),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1322),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1322),
    [sym_false] = STATE(1322),
    [sym_nil] = STATE(1322),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1291),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(2323),
    [sym__unary_minus] = ACTIONS(2325),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5591),
    [anon_sym_defined_QMARK] = ACTIONS(2329),
    [anon_sym_not] = ACTIONS(2331),
    [anon_sym_BANG] = ACTIONS(2335),
    [anon_sym_TILDE] = ACTIONS(2335),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3376] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(6034),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1322),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(1322),
    [sym_assignment] = STATE(6034),
    [sym_operator_assignment] = STATE(6034),
    [sym_conditional] = STATE(6034),
    [sym_range] = STATE(6034),
    [sym_binary] = STATE(6034),
    [sym_unary] = STATE(6034),
    [sym_left_assignment_list] = STATE(1321),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1322),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1322),
    [sym_false] = STATE(1322),
    [sym_nil] = STATE(1322),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1291),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2325),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5591),
    [anon_sym_defined_QMARK] = ACTIONS(2329),
    [anon_sym_not] = ACTIONS(2331),
    [anon_sym_BANG] = ACTIONS(2335),
    [anon_sym_TILDE] = ACTIONS(2335),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3377] = {
    [sym_elsif] = STATE(6036),
    [sym_else] = STATE(6036),
    [anon_sym_end] = ACTIONS(9356),
    [anon_sym_elsif] = ACTIONS(4495),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [3378] = {
    [sym__statements] = STATE(2640),
    [sym_begin_block] = STATE(2641),
    [sym_end_block] = STATE(2641),
    [sym__statement] = STATE(2641),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(2641),
    [sym_unless_modifier] = STATE(2641),
    [sym_while_modifier] = STATE(2641),
    [sym_until_modifier] = STATE(2641),
    [sym_rescue_modifier] = STATE(2641),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_elsif] = STATE(6036),
    [sym_else] = STATE(6036),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2642),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2645),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(2645),
    [sym_assignment] = STATE(2642),
    [sym_operator_assignment] = STATE(2642),
    [sym_conditional] = STATE(2642),
    [sym_range] = STATE(2642),
    [sym_binary] = STATE(2642),
    [sym_unary] = STATE(2642),
    [sym_left_assignment_list] = STATE(2644),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2645),
    [sym__variable] = STATE(2643),
    [sym_undef] = STATE(2641),
    [sym_alias] = STATE(2641),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2645),
    [sym_false] = STATE(2645),
    [sym_nil] = STATE(2645),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2646),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(2647),
    [aux_sym__statements_repeat1] = STATE(2647),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4467),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9358),
    [anon_sym_return] = ACTIONS(4471),
    [anon_sym_yield] = ACTIONS(4473),
    [anon_sym_break] = ACTIONS(4475),
    [anon_sym_next] = ACTIONS(4477),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(4499),
    [anon_sym_else] = ACTIONS(4501),
    [anon_sym_then] = ACTIONS(4503),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4479),
    [anon_sym_defined_QMARK] = ACTIONS(4481),
    [anon_sym_not] = ACTIONS(4483),
    [anon_sym_BANG] = ACTIONS(4485),
    [anon_sym_TILDE] = ACTIONS(4485),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [anon_sym_undef] = ACTIONS(4491),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3379] = {
    [sym_else] = STATE(6038),
    [anon_sym_end] = ACTIONS(9360),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [3380] = {
    [sym__statements] = STATE(2640),
    [sym_begin_block] = STATE(2715),
    [sym_end_block] = STATE(2715),
    [sym__statement] = STATE(2715),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(2715),
    [sym_unless_modifier] = STATE(2715),
    [sym_while_modifier] = STATE(2715),
    [sym_until_modifier] = STATE(2715),
    [sym_rescue_modifier] = STATE(2715),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(6038),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2716),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2719),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(2719),
    [sym_assignment] = STATE(2716),
    [sym_operator_assignment] = STATE(2716),
    [sym_conditional] = STATE(2716),
    [sym_range] = STATE(2716),
    [sym_binary] = STATE(2716),
    [sym_unary] = STATE(2716),
    [sym_left_assignment_list] = STATE(2718),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2719),
    [sym__variable] = STATE(2717),
    [sym_undef] = STATE(2715),
    [sym_alias] = STATE(2715),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2719),
    [sym_false] = STATE(2719),
    [sym_nil] = STATE(2719),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2720),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(2721),
    [aux_sym__statements_repeat1] = STATE(2721),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4583),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9362),
    [anon_sym_return] = ACTIONS(4585),
    [anon_sym_yield] = ACTIONS(4587),
    [anon_sym_break] = ACTIONS(4589),
    [anon_sym_next] = ACTIONS(4591),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(4501),
    [anon_sym_then] = ACTIONS(4611),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4593),
    [anon_sym_defined_QMARK] = ACTIONS(4595),
    [anon_sym_not] = ACTIONS(4597),
    [anon_sym_BANG] = ACTIONS(4599),
    [anon_sym_TILDE] = ACTIONS(4599),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [anon_sym_undef] = ACTIONS(4605),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3381] = {
    [sym__statements] = STATE(6040),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9364),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3382] = {
    [sym__statements] = STATE(6042),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9366),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3383] = {
    [sym__do] = STATE(6043),
    [sym_heredoc_body] = STATE(6043),
    [sym__terminator] = STATE(6043),
    [sym__line_break] = ACTIONS(9368),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(9368),
    [anon_sym_do] = ACTIONS(9368),
    [sym_comment] = ACTIONS(87),
  },
  [3384] = {
    [sym_when] = STATE(6047),
    [sym_else] = STATE(6045),
    [aux_sym_case_repeat1] = STATE(6046),
    [aux_sym_case_repeat2] = STATE(6047),
    [anon_sym_SEMI] = ACTIONS(9370),
    [anon_sym_end] = ACTIONS(9372),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [3385] = {
    [sym__heredoc_body_start] = ACTIONS(4965),
    [sym__binary_minus] = ACTIONS(4965),
    [sym__binary_star] = ACTIONS(4965),
    [anon_sym_LBRACE] = ACTIONS(4965),
    [anon_sym_RBRACE] = ACTIONS(4965),
    [anon_sym_RPAREN] = ACTIONS(4965),
    [anon_sym_DOT] = ACTIONS(4967),
    [anon_sym_COMMA] = ACTIONS(4965),
    [anon_sym_PIPE] = ACTIONS(4967),
    [anon_sym_SEMI] = ACTIONS(4965),
    [anon_sym_STAR_STAR] = ACTIONS(4965),
    [anon_sym_AMP] = ACTIONS(4967),
    [anon_sym_EQ] = ACTIONS(4967),
    [anon_sym_LT] = ACTIONS(4967),
    [anon_sym_if] = ACTIONS(4965),
    [anon_sym_unless] = ACTIONS(4965),
    [anon_sym_while] = ACTIONS(4965),
    [anon_sym_until] = ACTIONS(4965),
    [anon_sym_rescue] = ACTIONS(4965),
    [anon_sym_in] = ACTIONS(4965),
    [anon_sym_do] = ACTIONS(4965),
    [anon_sym_EQ_GT] = ACTIONS(4965),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym_RBRACK] = ACTIONS(4965),
    [anon_sym_COLON_COLON2] = ACTIONS(4965),
    [anon_sym_AMP_DOT] = ACTIONS(4965),
    [anon_sym_QMARK] = ACTIONS(4965),
    [anon_sym_COLON2] = ACTIONS(4967),
    [anon_sym_DOT_DOT] = ACTIONS(4967),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4965),
    [anon_sym_and] = ACTIONS(4965),
    [anon_sym_or] = ACTIONS(4965),
    [anon_sym_PIPE_PIPE] = ACTIONS(4965),
    [anon_sym_AMP_AMP] = ACTIONS(4965),
    [anon_sym_LT_LT] = ACTIONS(4965),
    [anon_sym_GT_GT] = ACTIONS(4965),
    [anon_sym_EQ_EQ] = ACTIONS(4967),
    [anon_sym_BANG_EQ] = ACTIONS(4965),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4965),
    [anon_sym_LT_EQ_GT] = ACTIONS(4965),
    [anon_sym_EQ_TILDE] = ACTIONS(4965),
    [anon_sym_BANG_TILDE] = ACTIONS(4965),
    [anon_sym_LT_EQ] = ACTIONS(4967),
    [anon_sym_GT] = ACTIONS(4967),
    [anon_sym_GT_EQ] = ACTIONS(4965),
    [anon_sym_CARET] = ACTIONS(4965),
    [anon_sym_PLUS] = ACTIONS(4965),
    [anon_sym_SLASH] = ACTIONS(4965),
    [anon_sym_PERCENT] = ACTIONS(4965),
    [sym_comment] = ACTIONS(87),
  },
  [3386] = {
    [anon_sym_end] = ACTIONS(9372),
    [sym_comment] = ACTIONS(87),
  },
  [3387] = {
    [sym_when] = STATE(6047),
    [sym_else] = STATE(6045),
    [aux_sym_case_repeat1] = STATE(2987),
    [aux_sym_case_repeat2] = STATE(6047),
    [anon_sym_SEMI] = ACTIONS(4995),
    [anon_sym_end] = ACTIONS(9372),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [3388] = {
    [sym_when] = STATE(2988),
    [sym_else] = STATE(6045),
    [aux_sym_case_repeat2] = STATE(2988),
    [anon_sym_end] = ACTIONS(9372),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [3389] = {
    [sym__heredoc_body_start] = ACTIONS(5407),
    [sym__binary_minus] = ACTIONS(5407),
    [sym__binary_star] = ACTIONS(5407),
    [anon_sym_LBRACE] = ACTIONS(5407),
    [anon_sym_RBRACE] = ACTIONS(5407),
    [anon_sym_RPAREN] = ACTIONS(5407),
    [anon_sym_DOT] = ACTIONS(5409),
    [anon_sym_COMMA] = ACTIONS(5407),
    [anon_sym_PIPE] = ACTIONS(5409),
    [anon_sym_SEMI] = ACTIONS(5407),
    [anon_sym_STAR_STAR] = ACTIONS(5407),
    [anon_sym_AMP] = ACTIONS(5409),
    [anon_sym_EQ] = ACTIONS(5409),
    [anon_sym_LT] = ACTIONS(5409),
    [anon_sym_if] = ACTIONS(5407),
    [anon_sym_unless] = ACTIONS(5407),
    [anon_sym_while] = ACTIONS(5407),
    [anon_sym_until] = ACTIONS(5407),
    [anon_sym_rescue] = ACTIONS(5407),
    [anon_sym_in] = ACTIONS(5407),
    [anon_sym_do] = ACTIONS(5407),
    [anon_sym_EQ_GT] = ACTIONS(5407),
    [anon_sym_LBRACK] = ACTIONS(5407),
    [anon_sym_RBRACK] = ACTIONS(5407),
    [anon_sym_COLON_COLON2] = ACTIONS(5407),
    [anon_sym_AMP_DOT] = ACTIONS(5407),
    [anon_sym_QMARK] = ACTIONS(5407),
    [anon_sym_COLON2] = ACTIONS(5409),
    [anon_sym_DOT_DOT] = ACTIONS(5409),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5407),
    [anon_sym_and] = ACTIONS(5407),
    [anon_sym_or] = ACTIONS(5407),
    [anon_sym_PIPE_PIPE] = ACTIONS(5407),
    [anon_sym_AMP_AMP] = ACTIONS(5407),
    [anon_sym_LT_LT] = ACTIONS(5407),
    [anon_sym_GT_GT] = ACTIONS(5407),
    [anon_sym_EQ_EQ] = ACTIONS(5409),
    [anon_sym_BANG_EQ] = ACTIONS(5407),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5407),
    [anon_sym_LT_EQ_GT] = ACTIONS(5407),
    [anon_sym_EQ_TILDE] = ACTIONS(5407),
    [anon_sym_BANG_TILDE] = ACTIONS(5407),
    [anon_sym_LT_EQ] = ACTIONS(5409),
    [anon_sym_GT] = ACTIONS(5409),
    [anon_sym_GT_EQ] = ACTIONS(5407),
    [anon_sym_CARET] = ACTIONS(5407),
    [anon_sym_PLUS] = ACTIONS(5407),
    [anon_sym_SLASH] = ACTIONS(5407),
    [anon_sym_PERCENT] = ACTIONS(5407),
    [sym_comment] = ACTIONS(87),
  },
  [3390] = {
    [sym_ensure] = STATE(6049),
    [anon_sym_end] = ACTIONS(9374),
    [anon_sym_ensure] = ACTIONS(2169),
    [sym_comment] = ACTIONS(87),
  },
  [3391] = {
    [anon_sym_end] = ACTIONS(9374),
    [sym_comment] = ACTIONS(87),
  },
  [3392] = {
    [sym_else] = STATE(6050),
    [sym_ensure] = STATE(6049),
    [anon_sym_end] = ACTIONS(9374),
    [anon_sym_else] = ACTIONS(2167),
    [anon_sym_ensure] = ACTIONS(2169),
    [sym_comment] = ACTIONS(87),
  },
  [3393] = {
    [sym__heredoc_body_start] = ACTIONS(5491),
    [sym__binary_minus] = ACTIONS(5491),
    [sym__binary_star] = ACTIONS(5491),
    [anon_sym_LBRACE] = ACTIONS(5491),
    [anon_sym_RBRACE] = ACTIONS(5491),
    [anon_sym_RPAREN] = ACTIONS(5491),
    [anon_sym_DOT] = ACTIONS(5493),
    [anon_sym_COMMA] = ACTIONS(5491),
    [anon_sym_PIPE] = ACTIONS(5493),
    [anon_sym_SEMI] = ACTIONS(5491),
    [anon_sym_STAR_STAR] = ACTIONS(5491),
    [anon_sym_AMP] = ACTIONS(5493),
    [anon_sym_EQ] = ACTIONS(5493),
    [anon_sym_LT] = ACTIONS(5493),
    [anon_sym_if] = ACTIONS(5491),
    [anon_sym_unless] = ACTIONS(5491),
    [anon_sym_while] = ACTIONS(5491),
    [anon_sym_until] = ACTIONS(5491),
    [anon_sym_rescue] = ACTIONS(5491),
    [anon_sym_in] = ACTIONS(5491),
    [anon_sym_do] = ACTIONS(5491),
    [anon_sym_EQ_GT] = ACTIONS(5491),
    [anon_sym_LBRACK] = ACTIONS(5491),
    [anon_sym_RBRACK] = ACTIONS(5491),
    [anon_sym_COLON_COLON2] = ACTIONS(5491),
    [anon_sym_AMP_DOT] = ACTIONS(5491),
    [anon_sym_QMARK] = ACTIONS(5491),
    [anon_sym_COLON2] = ACTIONS(5493),
    [anon_sym_DOT_DOT] = ACTIONS(5493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5491),
    [anon_sym_and] = ACTIONS(5491),
    [anon_sym_or] = ACTIONS(5491),
    [anon_sym_PIPE_PIPE] = ACTIONS(5491),
    [anon_sym_AMP_AMP] = ACTIONS(5491),
    [anon_sym_LT_LT] = ACTIONS(5491),
    [anon_sym_GT_GT] = ACTIONS(5491),
    [anon_sym_EQ_EQ] = ACTIONS(5493),
    [anon_sym_BANG_EQ] = ACTIONS(5491),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5491),
    [anon_sym_LT_EQ_GT] = ACTIONS(5491),
    [anon_sym_EQ_TILDE] = ACTIONS(5491),
    [anon_sym_BANG_TILDE] = ACTIONS(5491),
    [anon_sym_LT_EQ] = ACTIONS(5493),
    [anon_sym_GT] = ACTIONS(5493),
    [anon_sym_GT_EQ] = ACTIONS(5491),
    [anon_sym_CARET] = ACTIONS(5491),
    [anon_sym_PLUS] = ACTIONS(5491),
    [anon_sym_SLASH] = ACTIONS(5491),
    [anon_sym_PERCENT] = ACTIONS(5491),
    [sym_comment] = ACTIONS(87),
  },
  [3394] = {
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(5535),
    [sym__binary_star] = ACTIONS(5537),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5537),
    [anon_sym_AMP] = ACTIONS(5541),
    [anon_sym_LT] = ACTIONS(5543),
    [anon_sym_RBRACK] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(5545),
    [anon_sym_DOT_DOT] = ACTIONS(5547),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5549),
    [anon_sym_and] = ACTIONS(5551),
    [anon_sym_or] = ACTIONS(5551),
    [anon_sym_PIPE_PIPE] = ACTIONS(5553),
    [anon_sym_AMP_AMP] = ACTIONS(5553),
    [anon_sym_LT_LT] = ACTIONS(5555),
    [anon_sym_GT_GT] = ACTIONS(5555),
    [anon_sym_EQ_EQ] = ACTIONS(5557),
    [anon_sym_BANG_EQ] = ACTIONS(5553),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5553),
    [anon_sym_LT_EQ_GT] = ACTIONS(5553),
    [anon_sym_EQ_TILDE] = ACTIONS(5553),
    [anon_sym_BANG_TILDE] = ACTIONS(5553),
    [anon_sym_LT_EQ] = ACTIONS(5543),
    [anon_sym_GT] = ACTIONS(5543),
    [anon_sym_GT_EQ] = ACTIONS(5559),
    [anon_sym_CARET] = ACTIONS(5561),
    [anon_sym_PLUS] = ACTIONS(5535),
    [anon_sym_SLASH] = ACTIONS(5537),
    [anon_sym_PERCENT] = ACTIONS(5537),
    [sym_comment] = ACTIONS(87),
  },
  [3395] = {
    [sym__heredoc_body_start] = ACTIONS(5725),
    [sym__binary_minus] = ACTIONS(5725),
    [sym__binary_star] = ACTIONS(5725),
    [anon_sym_LBRACE] = ACTIONS(5725),
    [anon_sym_RBRACE] = ACTIONS(5725),
    [anon_sym_RPAREN] = ACTIONS(5725),
    [anon_sym_DOT] = ACTIONS(5727),
    [anon_sym_COMMA] = ACTIONS(5725),
    [anon_sym_PIPE] = ACTIONS(5727),
    [anon_sym_SEMI] = ACTIONS(5725),
    [anon_sym_STAR_STAR] = ACTIONS(5725),
    [anon_sym_AMP] = ACTIONS(5727),
    [anon_sym_EQ] = ACTIONS(5727),
    [anon_sym_LT] = ACTIONS(5727),
    [anon_sym_if] = ACTIONS(5725),
    [anon_sym_unless] = ACTIONS(5725),
    [anon_sym_while] = ACTIONS(5725),
    [anon_sym_until] = ACTIONS(5725),
    [anon_sym_rescue] = ACTIONS(5725),
    [anon_sym_in] = ACTIONS(5725),
    [anon_sym_do] = ACTIONS(5725),
    [anon_sym_EQ_GT] = ACTIONS(5725),
    [anon_sym_LBRACK] = ACTIONS(5725),
    [anon_sym_RBRACK] = ACTIONS(5725),
    [anon_sym_COLON_COLON2] = ACTIONS(5725),
    [anon_sym_AMP_DOT] = ACTIONS(5725),
    [anon_sym_QMARK] = ACTIONS(5725),
    [anon_sym_COLON2] = ACTIONS(5727),
    [anon_sym_DOT_DOT] = ACTIONS(5727),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5725),
    [anon_sym_and] = ACTIONS(5725),
    [anon_sym_or] = ACTIONS(5725),
    [anon_sym_PIPE_PIPE] = ACTIONS(5725),
    [anon_sym_AMP_AMP] = ACTIONS(5725),
    [anon_sym_LT_LT] = ACTIONS(5725),
    [anon_sym_GT_GT] = ACTIONS(5725),
    [anon_sym_EQ_EQ] = ACTIONS(5727),
    [anon_sym_BANG_EQ] = ACTIONS(5725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5725),
    [anon_sym_LT_EQ_GT] = ACTIONS(5725),
    [anon_sym_EQ_TILDE] = ACTIONS(5725),
    [anon_sym_BANG_TILDE] = ACTIONS(5725),
    [anon_sym_LT_EQ] = ACTIONS(5727),
    [anon_sym_GT] = ACTIONS(5727),
    [anon_sym_GT_EQ] = ACTIONS(5725),
    [anon_sym_CARET] = ACTIONS(5725),
    [anon_sym_PLUS] = ACTIONS(5725),
    [anon_sym_SLASH] = ACTIONS(5725),
    [anon_sym_PERCENT] = ACTIONS(5725),
    [sym_comment] = ACTIONS(87),
  },
  [3396] = {
    [sym__heredoc_body_start] = ACTIONS(5735),
    [sym__binary_minus] = ACTIONS(5735),
    [sym__binary_star] = ACTIONS(5735),
    [anon_sym_LBRACE] = ACTIONS(5735),
    [anon_sym_RBRACE] = ACTIONS(5735),
    [anon_sym_RPAREN] = ACTIONS(5735),
    [anon_sym_DOT] = ACTIONS(5737),
    [anon_sym_COMMA] = ACTIONS(5735),
    [anon_sym_PIPE] = ACTIONS(5737),
    [anon_sym_SEMI] = ACTIONS(5735),
    [anon_sym_STAR_STAR] = ACTIONS(5735),
    [anon_sym_AMP] = ACTIONS(5737),
    [anon_sym_EQ] = ACTIONS(5737),
    [anon_sym_LT] = ACTIONS(5737),
    [anon_sym_if] = ACTIONS(5735),
    [anon_sym_unless] = ACTIONS(5735),
    [anon_sym_while] = ACTIONS(5735),
    [anon_sym_until] = ACTIONS(5735),
    [anon_sym_rescue] = ACTIONS(5735),
    [anon_sym_in] = ACTIONS(5735),
    [anon_sym_do] = ACTIONS(5735),
    [anon_sym_EQ_GT] = ACTIONS(5735),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_RBRACK] = ACTIONS(5735),
    [anon_sym_COLON_COLON2] = ACTIONS(5735),
    [anon_sym_AMP_DOT] = ACTIONS(5735),
    [anon_sym_QMARK] = ACTIONS(5735),
    [anon_sym_COLON2] = ACTIONS(5737),
    [anon_sym_DOT_DOT] = ACTIONS(5737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5735),
    [anon_sym_and] = ACTIONS(5735),
    [anon_sym_or] = ACTIONS(5735),
    [anon_sym_PIPE_PIPE] = ACTIONS(5735),
    [anon_sym_AMP_AMP] = ACTIONS(5735),
    [anon_sym_LT_LT] = ACTIONS(5735),
    [anon_sym_GT_GT] = ACTIONS(5735),
    [anon_sym_EQ_EQ] = ACTIONS(5737),
    [anon_sym_BANG_EQ] = ACTIONS(5735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5735),
    [anon_sym_LT_EQ_GT] = ACTIONS(5735),
    [anon_sym_EQ_TILDE] = ACTIONS(5735),
    [anon_sym_BANG_TILDE] = ACTIONS(5735),
    [anon_sym_LT_EQ] = ACTIONS(5737),
    [anon_sym_GT] = ACTIONS(5737),
    [anon_sym_GT_EQ] = ACTIONS(5735),
    [anon_sym_CARET] = ACTIONS(5735),
    [anon_sym_PLUS] = ACTIONS(5735),
    [anon_sym_SLASH] = ACTIONS(5735),
    [anon_sym_PERCENT] = ACTIONS(5735),
    [sym_comment] = ACTIONS(87),
  },
  [3397] = {
    [anon_sym_RBRACE] = ACTIONS(9376),
    [sym_comment] = ACTIONS(87),
  },
  [3398] = {
    [sym__statements] = STATE(6052),
    [sym_begin_block] = STATE(489),
    [sym_end_block] = STATE(489),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(495),
    [aux_sym__statements_repeat1] = STATE(495),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(9376),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3399] = {
    [sym__heredoc_body_start] = ACTIONS(5771),
    [sym__binary_minus] = ACTIONS(5771),
    [sym__binary_star] = ACTIONS(5771),
    [anon_sym_LBRACE] = ACTIONS(5771),
    [anon_sym_RBRACE] = ACTIONS(5771),
    [anon_sym_RPAREN] = ACTIONS(5771),
    [anon_sym_DOT] = ACTIONS(5773),
    [anon_sym_COMMA] = ACTIONS(5771),
    [anon_sym_PIPE] = ACTIONS(5773),
    [anon_sym_SEMI] = ACTIONS(5771),
    [anon_sym_STAR_STAR] = ACTIONS(5771),
    [anon_sym_AMP] = ACTIONS(5773),
    [anon_sym_EQ] = ACTIONS(5773),
    [anon_sym_LT] = ACTIONS(5773),
    [anon_sym_if] = ACTIONS(5771),
    [anon_sym_unless] = ACTIONS(5771),
    [anon_sym_while] = ACTIONS(5771),
    [anon_sym_until] = ACTIONS(5771),
    [anon_sym_rescue] = ACTIONS(5771),
    [anon_sym_in] = ACTIONS(5771),
    [anon_sym_do] = ACTIONS(5771),
    [anon_sym_EQ_GT] = ACTIONS(5771),
    [anon_sym_LBRACK] = ACTIONS(5771),
    [anon_sym_RBRACK] = ACTIONS(5771),
    [anon_sym_COLON_COLON2] = ACTIONS(5771),
    [anon_sym_AMP_DOT] = ACTIONS(5771),
    [anon_sym_QMARK] = ACTIONS(5771),
    [anon_sym_COLON2] = ACTIONS(5773),
    [anon_sym_DOT_DOT] = ACTIONS(5773),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5771),
    [anon_sym_and] = ACTIONS(5771),
    [anon_sym_or] = ACTIONS(5771),
    [anon_sym_PIPE_PIPE] = ACTIONS(5771),
    [anon_sym_AMP_AMP] = ACTIONS(5771),
    [anon_sym_LT_LT] = ACTIONS(5771),
    [anon_sym_GT_GT] = ACTIONS(5771),
    [anon_sym_EQ_EQ] = ACTIONS(5773),
    [anon_sym_BANG_EQ] = ACTIONS(5771),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5771),
    [anon_sym_LT_EQ_GT] = ACTIONS(5771),
    [anon_sym_EQ_TILDE] = ACTIONS(5771),
    [anon_sym_BANG_TILDE] = ACTIONS(5771),
    [anon_sym_LT_EQ] = ACTIONS(5773),
    [anon_sym_GT] = ACTIONS(5773),
    [anon_sym_GT_EQ] = ACTIONS(5771),
    [anon_sym_CARET] = ACTIONS(5771),
    [anon_sym_PLUS] = ACTIONS(5771),
    [anon_sym_SLASH] = ACTIONS(5771),
    [anon_sym_PERCENT] = ACTIONS(5771),
    [sym_comment] = ACTIONS(87),
  },
  [3400] = {
    [anon_sym_end] = ACTIONS(9378),
    [sym_comment] = ACTIONS(87),
  },
  [3401] = {
    [sym__statements] = STATE(6054),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_heredoc_body] = STATE(6055),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [sym__terminator] = STATE(6055),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__line_break] = ACTIONS(9380),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(9380),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9382),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3402] = {
    [sym__statements] = STATE(6054),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_block_parameters] = STATE(6056),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9382),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3403] = {
    [sym__heredoc_body_start] = ACTIONS(5807),
    [sym__binary_minus] = ACTIONS(5807),
    [sym__binary_star] = ACTIONS(5807),
    [anon_sym_LBRACE] = ACTIONS(5807),
    [anon_sym_RBRACE] = ACTIONS(5807),
    [anon_sym_RPAREN] = ACTIONS(5807),
    [anon_sym_DOT] = ACTIONS(5809),
    [anon_sym_COMMA] = ACTIONS(5807),
    [anon_sym_PIPE] = ACTIONS(5809),
    [anon_sym_SEMI] = ACTIONS(5807),
    [anon_sym_STAR_STAR] = ACTIONS(5807),
    [anon_sym_AMP] = ACTIONS(5809),
    [anon_sym_EQ] = ACTIONS(5809),
    [anon_sym_LT] = ACTIONS(5809),
    [anon_sym_if] = ACTIONS(5807),
    [anon_sym_unless] = ACTIONS(5807),
    [anon_sym_while] = ACTIONS(5807),
    [anon_sym_until] = ACTIONS(5807),
    [anon_sym_rescue] = ACTIONS(5807),
    [anon_sym_in] = ACTIONS(5807),
    [anon_sym_do] = ACTIONS(5807),
    [anon_sym_EQ_GT] = ACTIONS(5807),
    [anon_sym_LBRACK] = ACTIONS(5807),
    [anon_sym_RBRACK] = ACTIONS(5807),
    [anon_sym_COLON_COLON2] = ACTIONS(5807),
    [anon_sym_AMP_DOT] = ACTIONS(5807),
    [anon_sym_QMARK] = ACTIONS(5807),
    [anon_sym_COLON2] = ACTIONS(5809),
    [anon_sym_DOT_DOT] = ACTIONS(5809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5807),
    [anon_sym_and] = ACTIONS(5807),
    [anon_sym_or] = ACTIONS(5807),
    [anon_sym_PIPE_PIPE] = ACTIONS(5807),
    [anon_sym_AMP_AMP] = ACTIONS(5807),
    [anon_sym_LT_LT] = ACTIONS(5807),
    [anon_sym_GT_GT] = ACTIONS(5807),
    [anon_sym_EQ_EQ] = ACTIONS(5809),
    [anon_sym_BANG_EQ] = ACTIONS(5807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5807),
    [anon_sym_LT_EQ_GT] = ACTIONS(5807),
    [anon_sym_EQ_TILDE] = ACTIONS(5807),
    [anon_sym_BANG_TILDE] = ACTIONS(5807),
    [anon_sym_LT_EQ] = ACTIONS(5809),
    [anon_sym_GT] = ACTIONS(5809),
    [anon_sym_GT_EQ] = ACTIONS(5807),
    [anon_sym_CARET] = ACTIONS(5807),
    [anon_sym_PLUS] = ACTIONS(5807),
    [anon_sym_SLASH] = ACTIONS(5807),
    [anon_sym_PERCENT] = ACTIONS(5807),
    [sym_comment] = ACTIONS(87),
  },
  [3404] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(2361),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(2361),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_RBRACK] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(2361),
    [anon_sym_PERCENT] = ACTIONS(2361),
    [sym_comment] = ACTIONS(87),
  },
  [3405] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(2361),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_RBRACK] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [3406] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(2359),
    [sym__binary_star] = ACTIONS(2361),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(2361),
    [anon_sym_AMP] = ACTIONS(2365),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_RBRACK] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(2379),
    [anon_sym_GT_GT] = ACTIONS(2379),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(2359),
    [anon_sym_SLASH] = ACTIONS(2361),
    [anon_sym_PERCENT] = ACTIONS(2361),
    [sym_comment] = ACTIONS(87),
  },
  [3407] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(2359),
    [sym__binary_star] = ACTIONS(2361),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(2361),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_RBRACK] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(2379),
    [anon_sym_GT_GT] = ACTIONS(2379),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(2359),
    [anon_sym_SLASH] = ACTIONS(2361),
    [anon_sym_PERCENT] = ACTIONS(2361),
    [sym_comment] = ACTIONS(87),
  },
  [3408] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(2359),
    [sym__binary_star] = ACTIONS(2361),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(2363),
    [anon_sym_STAR_STAR] = ACTIONS(2361),
    [anon_sym_AMP] = ACTIONS(2365),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_RBRACK] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(2379),
    [anon_sym_GT_GT] = ACTIONS(2379),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(2385),
    [anon_sym_PLUS] = ACTIONS(2359),
    [anon_sym_SLASH] = ACTIONS(2361),
    [anon_sym_PERCENT] = ACTIONS(2361),
    [sym_comment] = ACTIONS(87),
  },
  [3409] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(9384),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [3410] = {
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(2359),
    [sym__binary_star] = ACTIONS(2361),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(2363),
    [anon_sym_STAR_STAR] = ACTIONS(2361),
    [anon_sym_AMP] = ACTIONS(2365),
    [anon_sym_LT] = ACTIONS(2367),
    [anon_sym_EQ_GT] = ACTIONS(5927),
    [anon_sym_RBRACK] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(2371),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2373),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(2377),
    [anon_sym_AMP_AMP] = ACTIONS(2377),
    [anon_sym_LT_LT] = ACTIONS(2379),
    [anon_sym_GT_GT] = ACTIONS(2379),
    [anon_sym_EQ_EQ] = ACTIONS(2381),
    [anon_sym_BANG_EQ] = ACTIONS(2377),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2377),
    [anon_sym_LT_EQ_GT] = ACTIONS(2377),
    [anon_sym_EQ_TILDE] = ACTIONS(2377),
    [anon_sym_BANG_TILDE] = ACTIONS(2377),
    [anon_sym_LT_EQ] = ACTIONS(2367),
    [anon_sym_GT] = ACTIONS(2367),
    [anon_sym_GT_EQ] = ACTIONS(2383),
    [anon_sym_CARET] = ACTIONS(2385),
    [anon_sym_PLUS] = ACTIONS(2359),
    [anon_sym_SLASH] = ACTIONS(2361),
    [anon_sym_PERCENT] = ACTIONS(2361),
    [sym_comment] = ACTIONS(87),
  },
  [3411] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(2359),
    [sym__binary_star] = ACTIONS(2361),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(2363),
    [anon_sym_STAR_STAR] = ACTIONS(2361),
    [anon_sym_AMP] = ACTIONS(2365),
    [anon_sym_LT] = ACTIONS(2367),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_RBRACK] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(2369),
    [anon_sym_DOT_DOT] = ACTIONS(2371),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2373),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(2377),
    [anon_sym_AMP_AMP] = ACTIONS(2377),
    [anon_sym_LT_LT] = ACTIONS(2379),
    [anon_sym_GT_GT] = ACTIONS(2379),
    [anon_sym_EQ_EQ] = ACTIONS(2381),
    [anon_sym_BANG_EQ] = ACTIONS(2377),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2377),
    [anon_sym_LT_EQ_GT] = ACTIONS(2377),
    [anon_sym_EQ_TILDE] = ACTIONS(2377),
    [anon_sym_BANG_TILDE] = ACTIONS(2377),
    [anon_sym_LT_EQ] = ACTIONS(2367),
    [anon_sym_GT] = ACTIONS(2367),
    [anon_sym_GT_EQ] = ACTIONS(2383),
    [anon_sym_CARET] = ACTIONS(2385),
    [anon_sym_PLUS] = ACTIONS(2359),
    [anon_sym_SLASH] = ACTIONS(2361),
    [anon_sym_PERCENT] = ACTIONS(2361),
    [sym_comment] = ACTIONS(87),
  },
  [3412] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(2359),
    [sym__binary_star] = ACTIONS(2361),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(2363),
    [anon_sym_STAR_STAR] = ACTIONS(2361),
    [anon_sym_AMP] = ACTIONS(2365),
    [anon_sym_LT] = ACTIONS(2367),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_RBRACK] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(2379),
    [anon_sym_GT_GT] = ACTIONS(2379),
    [anon_sym_EQ_EQ] = ACTIONS(2381),
    [anon_sym_BANG_EQ] = ACTIONS(2377),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2377),
    [anon_sym_LT_EQ_GT] = ACTIONS(2377),
    [anon_sym_EQ_TILDE] = ACTIONS(2377),
    [anon_sym_BANG_TILDE] = ACTIONS(2377),
    [anon_sym_LT_EQ] = ACTIONS(2367),
    [anon_sym_GT] = ACTIONS(2367),
    [anon_sym_GT_EQ] = ACTIONS(2383),
    [anon_sym_CARET] = ACTIONS(2385),
    [anon_sym_PLUS] = ACTIONS(2359),
    [anon_sym_SLASH] = ACTIONS(2361),
    [anon_sym_PERCENT] = ACTIONS(2361),
    [sym_comment] = ACTIONS(87),
  },
  [3413] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(2359),
    [sym__binary_star] = ACTIONS(2361),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(2361),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_RBRACK] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(2359),
    [anon_sym_SLASH] = ACTIONS(2361),
    [anon_sym_PERCENT] = ACTIONS(2361),
    [sym_comment] = ACTIONS(87),
  },
  [3414] = {
    [sym__simple_symbol] = ACTIONS(1263),
    [sym__string_start] = ACTIONS(1263),
    [sym__symbol_start] = ACTIONS(1263),
    [sym__subshell_start] = ACTIONS(1263),
    [sym__regex_start] = ACTIONS(1263),
    [sym__string_array_start] = ACTIONS(1263),
    [sym__symbol_array_start] = ACTIONS(1263),
    [sym__heredoc_body_start] = ACTIONS(1263),
    [sym_heredoc_beginning] = ACTIONS(1263),
    [sym__block_ampersand] = ACTIONS(1263),
    [sym__splat_star] = ACTIONS(1263),
    [sym__unary_minus] = ACTIONS(1263),
    [sym__binary_minus] = ACTIONS(1263),
    [sym__binary_star] = ACTIONS(1263),
    [sym__identifier_hash_key] = ACTIONS(1263),
    [anon_sym_LBRACE] = ACTIONS(1263),
    [anon_sym_RBRACE] = ACTIONS(1263),
    [anon_sym_def] = ACTIONS(1265),
    [anon_sym_LPAREN] = ACTIONS(1265),
    [anon_sym_RPAREN] = ACTIONS(1263),
    [anon_sym_DOT] = ACTIONS(1265),
    [anon_sym_COLON_COLON] = ACTIONS(1265),
    [anon_sym_COMMA] = ACTIONS(1263),
    [anon_sym_PIPE] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_STAR_STAR] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1265),
    [anon_sym_EQ] = ACTIONS(1265),
    [anon_sym_class] = ACTIONS(1265),
    [anon_sym_LT] = ACTIONS(1265),
    [anon_sym_module] = ACTIONS(1265),
    [anon_sym_return] = ACTIONS(1265),
    [anon_sym_yield] = ACTIONS(1265),
    [anon_sym_break] = ACTIONS(1265),
    [anon_sym_next] = ACTIONS(1265),
    [sym_redo] = ACTIONS(1265),
    [sym_retry] = ACTIONS(1265),
    [anon_sym_if] = ACTIONS(1265),
    [anon_sym_unless] = ACTIONS(1265),
    [anon_sym_while] = ACTIONS(1265),
    [anon_sym_until] = ACTIONS(1265),
    [anon_sym_rescue] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1265),
    [anon_sym_in] = ACTIONS(1265),
    [anon_sym_do] = ACTIONS(1265),
    [anon_sym_case] = ACTIONS(1265),
    [anon_sym_begin] = ACTIONS(1265),
    [anon_sym_EQ_GT] = ACTIONS(1263),
    [anon_sym_LBRACK] = ACTIONS(1263),
    [anon_sym_RBRACK] = ACTIONS(1263),
    [anon_sym_COLON_COLON2] = ACTIONS(1263),
    [anon_sym_AMP_DOT] = ACTIONS(1263),
    [anon_sym_LPAREN2] = ACTIONS(1263),
    [anon_sym_PLUS_EQ] = ACTIONS(1263),
    [anon_sym_DASH_EQ] = ACTIONS(1263),
    [anon_sym_STAR_EQ] = ACTIONS(1263),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1263),
    [anon_sym_SLASH_EQ] = ACTIONS(1263),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1263),
    [anon_sym_PIPE_EQ] = ACTIONS(1263),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1263),
    [anon_sym_AMP_EQ] = ACTIONS(1263),
    [anon_sym_PERCENT_EQ] = ACTIONS(1263),
    [anon_sym_GT_GT_EQ] = ACTIONS(1263),
    [anon_sym_LT_LT_EQ] = ACTIONS(1263),
    [anon_sym_CARET_EQ] = ACTIONS(1263),
    [anon_sym_QMARK] = ACTIONS(1265),
    [anon_sym_COLON2] = ACTIONS(1265),
    [anon_sym_DOT_DOT] = ACTIONS(1265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1263),
    [anon_sym_and] = ACTIONS(1265),
    [anon_sym_or] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_LT_LT] = ACTIONS(1265),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_EQ_EQ] = ACTIONS(1265),
    [anon_sym_BANG_EQ] = ACTIONS(1263),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1263),
    [anon_sym_LT_EQ_GT] = ACTIONS(1263),
    [anon_sym_EQ_TILDE] = ACTIONS(1263),
    [anon_sym_BANG_TILDE] = ACTIONS(1263),
    [anon_sym_LT_EQ] = ACTIONS(1265),
    [anon_sym_GT] = ACTIONS(1265),
    [anon_sym_GT_EQ] = ACTIONS(1263),
    [anon_sym_CARET] = ACTIONS(1265),
    [anon_sym_PLUS] = ACTIONS(1265),
    [anon_sym_SLASH] = ACTIONS(1265),
    [anon_sym_PERCENT] = ACTIONS(1265),
    [anon_sym_defined_QMARK] = ACTIONS(1263),
    [anon_sym_not] = ACTIONS(1265),
    [anon_sym_BANG] = ACTIONS(1265),
    [anon_sym_TILDE] = ACTIONS(1263),
    [sym_constant] = ACTIONS(1265),
    [sym_identifier] = ACTIONS(1265),
    [sym_instance_variable] = ACTIONS(1263),
    [sym_class_variable] = ACTIONS(1263),
    [sym_global_variable] = ACTIONS(1263),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1265),
    [sym_float] = ACTIONS(1265),
    [sym_complex] = ACTIONS(1263),
    [sym_super] = ACTIONS(1265),
    [anon_sym_true] = ACTIONS(1265),
    [anon_sym_TRUE] = ACTIONS(1265),
    [anon_sym_false] = ACTIONS(1265),
    [anon_sym_FALSE] = ACTIONS(1265),
    [sym_self] = ACTIONS(1265),
    [anon_sym_nil] = ACTIONS(1265),
    [anon_sym_NIL] = ACTIONS(1265),
    [sym_character] = ACTIONS(1263),
    [anon_sym_LBRACK2] = ACTIONS(1265),
    [anon_sym_DASH_GT] = ACTIONS(1263),
  },
  [3415] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(906),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(911),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(911),
    [sym__argument_list_with_trailing_comma] = STATE(6059),
    [sym__argument] = STATE(909),
    [sym_splat_argument] = STATE(909),
    [sym_hash_splat_argument] = STATE(909),
    [sym_block_argument] = STATE(909),
    [sym_assignment] = STATE(906),
    [sym_operator_assignment] = STATE(906),
    [sym_conditional] = STATE(906),
    [sym_range] = STATE(906),
    [sym_binary] = STATE(906),
    [sym_unary] = STATE(906),
    [sym_left_assignment_list] = STATE(910),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(911),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(911),
    [sym_false] = STATE(911),
    [sym_nil] = STATE(911),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(912),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(909),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1589),
    [sym__splat_star] = ACTIONS(1591),
    [sym__unary_minus] = ACTIONS(1593),
    [sym__identifier_hash_key] = ACTIONS(1595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(9386),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1599),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_defined_QMARK] = ACTIONS(1611),
    [anon_sym_not] = ACTIONS(1613),
    [anon_sym_BANG] = ACTIONS(1615),
    [anon_sym_TILDE] = ACTIONS(1615),
    [sym_constant] = ACTIONS(1617),
    [sym_identifier] = ACTIONS(1617),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3416] = {
    [sym__simple_symbol] = ACTIONS(5935),
    [sym__string_start] = ACTIONS(5935),
    [sym__symbol_start] = ACTIONS(5935),
    [sym__subshell_start] = ACTIONS(5935),
    [sym__regex_start] = ACTIONS(5935),
    [sym__string_array_start] = ACTIONS(5935),
    [sym__symbol_array_start] = ACTIONS(5935),
    [sym__heredoc_body_start] = ACTIONS(5935),
    [sym_heredoc_beginning] = ACTIONS(5935),
    [sym__block_ampersand] = ACTIONS(5935),
    [sym__splat_star] = ACTIONS(5935),
    [sym__unary_minus] = ACTIONS(5935),
    [sym__binary_minus] = ACTIONS(5935),
    [sym__binary_star] = ACTIONS(5935),
    [sym__identifier_hash_key] = ACTIONS(5935),
    [anon_sym_LBRACE] = ACTIONS(5935),
    [anon_sym_RBRACE] = ACTIONS(5935),
    [anon_sym_def] = ACTIONS(5937),
    [anon_sym_LPAREN] = ACTIONS(5937),
    [anon_sym_RPAREN] = ACTIONS(5935),
    [anon_sym_DOT] = ACTIONS(5937),
    [anon_sym_COLON_COLON] = ACTIONS(5937),
    [anon_sym_COMMA] = ACTIONS(5935),
    [anon_sym_PIPE] = ACTIONS(5937),
    [anon_sym_SEMI] = ACTIONS(5935),
    [anon_sym_STAR] = ACTIONS(5937),
    [anon_sym_STAR_STAR] = ACTIONS(5937),
    [anon_sym_AMP] = ACTIONS(5937),
    [anon_sym_EQ] = ACTIONS(5937),
    [anon_sym_class] = ACTIONS(5937),
    [anon_sym_LT] = ACTIONS(5937),
    [anon_sym_module] = ACTIONS(5937),
    [anon_sym_return] = ACTIONS(5937),
    [anon_sym_yield] = ACTIONS(5937),
    [anon_sym_break] = ACTIONS(5937),
    [anon_sym_next] = ACTIONS(5937),
    [sym_redo] = ACTIONS(5937),
    [sym_retry] = ACTIONS(5937),
    [anon_sym_if] = ACTIONS(5937),
    [anon_sym_unless] = ACTIONS(5937),
    [anon_sym_while] = ACTIONS(5937),
    [anon_sym_until] = ACTIONS(5937),
    [anon_sym_rescue] = ACTIONS(5937),
    [anon_sym_for] = ACTIONS(5937),
    [anon_sym_in] = ACTIONS(5937),
    [anon_sym_do] = ACTIONS(5937),
    [anon_sym_case] = ACTIONS(5937),
    [anon_sym_begin] = ACTIONS(5937),
    [anon_sym_EQ_GT] = ACTIONS(5935),
    [anon_sym_LBRACK] = ACTIONS(5935),
    [anon_sym_RBRACK] = ACTIONS(5935),
    [anon_sym_COLON_COLON2] = ACTIONS(5935),
    [anon_sym_AMP_DOT] = ACTIONS(5935),
    [anon_sym_LPAREN2] = ACTIONS(5935),
    [anon_sym_PLUS_EQ] = ACTIONS(5935),
    [anon_sym_DASH_EQ] = ACTIONS(5935),
    [anon_sym_STAR_EQ] = ACTIONS(5935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5935),
    [anon_sym_SLASH_EQ] = ACTIONS(5935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5935),
    [anon_sym_PIPE_EQ] = ACTIONS(5935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5935),
    [anon_sym_AMP_EQ] = ACTIONS(5935),
    [anon_sym_PERCENT_EQ] = ACTIONS(5935),
    [anon_sym_GT_GT_EQ] = ACTIONS(5935),
    [anon_sym_LT_LT_EQ] = ACTIONS(5935),
    [anon_sym_CARET_EQ] = ACTIONS(5935),
    [anon_sym_QMARK] = ACTIONS(5937),
    [anon_sym_COLON2] = ACTIONS(5937),
    [anon_sym_DOT_DOT] = ACTIONS(5937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5935),
    [anon_sym_and] = ACTIONS(5937),
    [anon_sym_or] = ACTIONS(5937),
    [anon_sym_PIPE_PIPE] = ACTIONS(5937),
    [anon_sym_AMP_AMP] = ACTIONS(5937),
    [anon_sym_LT_LT] = ACTIONS(5937),
    [anon_sym_GT_GT] = ACTIONS(5937),
    [anon_sym_EQ_EQ] = ACTIONS(5937),
    [anon_sym_BANG_EQ] = ACTIONS(5935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5935),
    [anon_sym_LT_EQ_GT] = ACTIONS(5935),
    [anon_sym_EQ_TILDE] = ACTIONS(5935),
    [anon_sym_BANG_TILDE] = ACTIONS(5935),
    [anon_sym_LT_EQ] = ACTIONS(5937),
    [anon_sym_GT] = ACTIONS(5937),
    [anon_sym_GT_EQ] = ACTIONS(5935),
    [anon_sym_CARET] = ACTIONS(5937),
    [anon_sym_PLUS] = ACTIONS(5937),
    [anon_sym_SLASH] = ACTIONS(5937),
    [anon_sym_PERCENT] = ACTIONS(5937),
    [anon_sym_defined_QMARK] = ACTIONS(5935),
    [anon_sym_not] = ACTIONS(5937),
    [anon_sym_BANG] = ACTIONS(5937),
    [anon_sym_TILDE] = ACTIONS(5935),
    [sym_constant] = ACTIONS(5937),
    [sym_identifier] = ACTIONS(5937),
    [sym_instance_variable] = ACTIONS(5935),
    [sym_class_variable] = ACTIONS(5935),
    [sym_global_variable] = ACTIONS(5935),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5937),
    [sym_float] = ACTIONS(5937),
    [sym_complex] = ACTIONS(5935),
    [sym_super] = ACTIONS(5937),
    [anon_sym_true] = ACTIONS(5937),
    [anon_sym_TRUE] = ACTIONS(5937),
    [anon_sym_false] = ACTIONS(5937),
    [anon_sym_FALSE] = ACTIONS(5937),
    [sym_self] = ACTIONS(5937),
    [anon_sym_nil] = ACTIONS(5937),
    [anon_sym_NIL] = ACTIONS(5937),
    [sym_character] = ACTIONS(5935),
    [anon_sym_LBRACK2] = ACTIONS(5937),
    [anon_sym_DASH_GT] = ACTIONS(5935),
  },
  [3417] = {
    [sym__simple_symbol] = ACTIONS(5939),
    [sym__string_start] = ACTIONS(5939),
    [sym__symbol_start] = ACTIONS(5939),
    [sym__subshell_start] = ACTIONS(5939),
    [sym__regex_start] = ACTIONS(5939),
    [sym__string_array_start] = ACTIONS(5939),
    [sym__symbol_array_start] = ACTIONS(5939),
    [sym__heredoc_body_start] = ACTIONS(5939),
    [sym_heredoc_beginning] = ACTIONS(5939),
    [sym__block_ampersand] = ACTIONS(5939),
    [sym__splat_star] = ACTIONS(5939),
    [sym__unary_minus] = ACTIONS(5939),
    [sym__binary_minus] = ACTIONS(5939),
    [sym__binary_star] = ACTIONS(5939),
    [sym__identifier_hash_key] = ACTIONS(5939),
    [anon_sym_LBRACE] = ACTIONS(5939),
    [anon_sym_RBRACE] = ACTIONS(5939),
    [anon_sym_def] = ACTIONS(5941),
    [anon_sym_LPAREN] = ACTIONS(5941),
    [anon_sym_RPAREN] = ACTIONS(5939),
    [anon_sym_DOT] = ACTIONS(5941),
    [anon_sym_COLON_COLON] = ACTIONS(5941),
    [anon_sym_COMMA] = ACTIONS(5939),
    [anon_sym_PIPE] = ACTIONS(5941),
    [anon_sym_SEMI] = ACTIONS(5939),
    [anon_sym_STAR] = ACTIONS(5941),
    [anon_sym_STAR_STAR] = ACTIONS(5941),
    [anon_sym_AMP] = ACTIONS(5941),
    [anon_sym_EQ] = ACTIONS(5941),
    [anon_sym_class] = ACTIONS(5941),
    [anon_sym_LT] = ACTIONS(5941),
    [anon_sym_module] = ACTIONS(5941),
    [anon_sym_return] = ACTIONS(5941),
    [anon_sym_yield] = ACTIONS(5941),
    [anon_sym_break] = ACTIONS(5941),
    [anon_sym_next] = ACTIONS(5941),
    [sym_redo] = ACTIONS(5941),
    [sym_retry] = ACTIONS(5941),
    [anon_sym_if] = ACTIONS(5941),
    [anon_sym_unless] = ACTIONS(5941),
    [anon_sym_while] = ACTIONS(5941),
    [anon_sym_until] = ACTIONS(5941),
    [anon_sym_rescue] = ACTIONS(5941),
    [anon_sym_for] = ACTIONS(5941),
    [anon_sym_in] = ACTIONS(5941),
    [anon_sym_do] = ACTIONS(5941),
    [anon_sym_case] = ACTIONS(5941),
    [anon_sym_begin] = ACTIONS(5941),
    [anon_sym_EQ_GT] = ACTIONS(5939),
    [anon_sym_LBRACK] = ACTIONS(5939),
    [anon_sym_RBRACK] = ACTIONS(5939),
    [anon_sym_COLON_COLON2] = ACTIONS(5939),
    [anon_sym_AMP_DOT] = ACTIONS(5939),
    [anon_sym_LPAREN2] = ACTIONS(5939),
    [anon_sym_PLUS_EQ] = ACTIONS(5939),
    [anon_sym_DASH_EQ] = ACTIONS(5939),
    [anon_sym_STAR_EQ] = ACTIONS(5939),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5939),
    [anon_sym_SLASH_EQ] = ACTIONS(5939),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5939),
    [anon_sym_PIPE_EQ] = ACTIONS(5939),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5939),
    [anon_sym_AMP_EQ] = ACTIONS(5939),
    [anon_sym_PERCENT_EQ] = ACTIONS(5939),
    [anon_sym_GT_GT_EQ] = ACTIONS(5939),
    [anon_sym_LT_LT_EQ] = ACTIONS(5939),
    [anon_sym_CARET_EQ] = ACTIONS(5939),
    [anon_sym_QMARK] = ACTIONS(5941),
    [anon_sym_COLON2] = ACTIONS(5941),
    [anon_sym_DOT_DOT] = ACTIONS(5941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5939),
    [anon_sym_and] = ACTIONS(5941),
    [anon_sym_or] = ACTIONS(5941),
    [anon_sym_PIPE_PIPE] = ACTIONS(5941),
    [anon_sym_AMP_AMP] = ACTIONS(5941),
    [anon_sym_LT_LT] = ACTIONS(5941),
    [anon_sym_GT_GT] = ACTIONS(5941),
    [anon_sym_EQ_EQ] = ACTIONS(5941),
    [anon_sym_BANG_EQ] = ACTIONS(5939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5939),
    [anon_sym_LT_EQ_GT] = ACTIONS(5939),
    [anon_sym_EQ_TILDE] = ACTIONS(5939),
    [anon_sym_BANG_TILDE] = ACTIONS(5939),
    [anon_sym_LT_EQ] = ACTIONS(5941),
    [anon_sym_GT] = ACTIONS(5941),
    [anon_sym_GT_EQ] = ACTIONS(5939),
    [anon_sym_CARET] = ACTIONS(5941),
    [anon_sym_PLUS] = ACTIONS(5941),
    [anon_sym_SLASH] = ACTIONS(5941),
    [anon_sym_PERCENT] = ACTIONS(5941),
    [anon_sym_defined_QMARK] = ACTIONS(5939),
    [anon_sym_not] = ACTIONS(5941),
    [anon_sym_BANG] = ACTIONS(5941),
    [anon_sym_TILDE] = ACTIONS(5939),
    [sym_constant] = ACTIONS(5941),
    [sym_identifier] = ACTIONS(5941),
    [sym_instance_variable] = ACTIONS(5939),
    [sym_class_variable] = ACTIONS(5939),
    [sym_global_variable] = ACTIONS(5939),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5941),
    [sym_float] = ACTIONS(5941),
    [sym_complex] = ACTIONS(5939),
    [sym_super] = ACTIONS(5941),
    [anon_sym_true] = ACTIONS(5941),
    [anon_sym_TRUE] = ACTIONS(5941),
    [anon_sym_false] = ACTIONS(5941),
    [anon_sym_FALSE] = ACTIONS(5941),
    [sym_self] = ACTIONS(5941),
    [anon_sym_nil] = ACTIONS(5941),
    [anon_sym_NIL] = ACTIONS(5941),
    [sym_character] = ACTIONS(5939),
    [anon_sym_LBRACK2] = ACTIONS(5941),
    [anon_sym_DASH_GT] = ACTIONS(5939),
  },
  [3418] = {
    [sym_argument_list_with_parens] = STATE(6060),
    [sym__argument_list_with_parens] = STATE(3417),
    [sym_operator] = STATE(6060),
    [sym_heredoc_body] = STATE(3563),
    [aux_sym_call_repeat1] = STATE(3563),
    [sym__heredoc_body_start] = ACTIONS(2519),
    [anon_sym_PIPE] = ACTIONS(5661),
    [anon_sym_STAR] = ACTIONS(5663),
    [anon_sym_STAR_STAR] = ACTIONS(5661),
    [anon_sym_AMP] = ACTIONS(5661),
    [anon_sym_LT] = ACTIONS(5663),
    [anon_sym_LPAREN2] = ACTIONS(5665),
    [anon_sym_DOT_DOT] = ACTIONS(5661),
    [anon_sym_LT_LT] = ACTIONS(5661),
    [anon_sym_GT_GT] = ACTIONS(5661),
    [anon_sym_EQ_EQ] = ACTIONS(5663),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5661),
    [anon_sym_LT_EQ_GT] = ACTIONS(5661),
    [anon_sym_EQ_TILDE] = ACTIONS(5661),
    [anon_sym_BANG_TILDE] = ACTIONS(5661),
    [anon_sym_LT_EQ] = ACTIONS(5663),
    [anon_sym_GT] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5661),
    [anon_sym_CARET] = ACTIONS(5661),
    [anon_sym_PLUS] = ACTIONS(5663),
    [anon_sym_SLASH] = ACTIONS(5661),
    [anon_sym_PERCENT] = ACTIONS(5661),
    [anon_sym_BANG] = ACTIONS(5663),
    [anon_sym_TILDE] = ACTIONS(5661),
    [sym_constant] = ACTIONS(9388),
    [sym_identifier] = ACTIONS(9388),
    [anon_sym_DASH] = ACTIONS(5663),
    [anon_sym_PLUS_AT] = ACTIONS(5661),
    [anon_sym_DASH_AT] = ACTIONS(5661),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5663),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(5661),
    [anon_sym_BQUOTE] = ACTIONS(5661),
    [sym_comment] = ACTIONS(87),
  },
  [3419] = {
    [sym__heredoc_body_start] = ACTIONS(5945),
    [sym__binary_minus] = ACTIONS(5945),
    [sym__binary_star] = ACTIONS(5945),
    [anon_sym_LBRACE] = ACTIONS(5945),
    [anon_sym_RBRACE] = ACTIONS(5945),
    [anon_sym_RPAREN] = ACTIONS(5945),
    [anon_sym_DOT] = ACTIONS(5947),
    [anon_sym_COMMA] = ACTIONS(5945),
    [anon_sym_PIPE] = ACTIONS(5947),
    [anon_sym_SEMI] = ACTIONS(5945),
    [anon_sym_STAR_STAR] = ACTIONS(5947),
    [anon_sym_AMP] = ACTIONS(5947),
    [anon_sym_EQ] = ACTIONS(5947),
    [anon_sym_LT] = ACTIONS(5947),
    [anon_sym_if] = ACTIONS(5945),
    [anon_sym_unless] = ACTIONS(5945),
    [anon_sym_while] = ACTIONS(5945),
    [anon_sym_until] = ACTIONS(5945),
    [anon_sym_rescue] = ACTIONS(5945),
    [anon_sym_in] = ACTIONS(5945),
    [anon_sym_do] = ACTIONS(5945),
    [anon_sym_EQ_GT] = ACTIONS(5945),
    [anon_sym_LBRACK] = ACTIONS(5945),
    [anon_sym_RBRACK] = ACTIONS(5945),
    [anon_sym_COLON_COLON2] = ACTIONS(5945),
    [anon_sym_AMP_DOT] = ACTIONS(5945),
    [anon_sym_PLUS_EQ] = ACTIONS(5945),
    [anon_sym_DASH_EQ] = ACTIONS(5945),
    [anon_sym_STAR_EQ] = ACTIONS(5945),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5945),
    [anon_sym_SLASH_EQ] = ACTIONS(5945),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5945),
    [anon_sym_PIPE_EQ] = ACTIONS(5945),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5945),
    [anon_sym_AMP_EQ] = ACTIONS(5945),
    [anon_sym_PERCENT_EQ] = ACTIONS(5945),
    [anon_sym_GT_GT_EQ] = ACTIONS(5945),
    [anon_sym_LT_LT_EQ] = ACTIONS(5945),
    [anon_sym_CARET_EQ] = ACTIONS(5945),
    [anon_sym_QMARK] = ACTIONS(5945),
    [anon_sym_COLON2] = ACTIONS(5947),
    [anon_sym_DOT_DOT] = ACTIONS(5947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5945),
    [anon_sym_and] = ACTIONS(5945),
    [anon_sym_or] = ACTIONS(5945),
    [anon_sym_PIPE_PIPE] = ACTIONS(5947),
    [anon_sym_AMP_AMP] = ACTIONS(5947),
    [anon_sym_LT_LT] = ACTIONS(5947),
    [anon_sym_GT_GT] = ACTIONS(5947),
    [anon_sym_EQ_EQ] = ACTIONS(5947),
    [anon_sym_BANG_EQ] = ACTIONS(5945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5945),
    [anon_sym_LT_EQ_GT] = ACTIONS(5945),
    [anon_sym_EQ_TILDE] = ACTIONS(5945),
    [anon_sym_BANG_TILDE] = ACTIONS(5945),
    [anon_sym_LT_EQ] = ACTIONS(5947),
    [anon_sym_GT] = ACTIONS(5947),
    [anon_sym_GT_EQ] = ACTIONS(5945),
    [anon_sym_CARET] = ACTIONS(5947),
    [anon_sym_PLUS] = ACTIONS(5947),
    [anon_sym_SLASH] = ACTIONS(5947),
    [anon_sym_PERCENT] = ACTIONS(5947),
    [sym_comment] = ACTIONS(87),
  },
  [3420] = {
    [anon_sym_RBRACK] = ACTIONS(9390),
    [sym_comment] = ACTIONS(87),
  },
  [3421] = {
    [sym__simple_symbol] = ACTIONS(5951),
    [sym__string_start] = ACTIONS(5951),
    [sym__symbol_start] = ACTIONS(5951),
    [sym__subshell_start] = ACTIONS(5951),
    [sym__regex_start] = ACTIONS(5951),
    [sym__string_array_start] = ACTIONS(5951),
    [sym__symbol_array_start] = ACTIONS(5951),
    [sym__heredoc_body_start] = ACTIONS(5951),
    [sym_heredoc_beginning] = ACTIONS(5951),
    [sym__block_ampersand] = ACTIONS(5951),
    [sym__splat_star] = ACTIONS(5951),
    [sym__unary_minus] = ACTIONS(5951),
    [sym__binary_minus] = ACTIONS(5951),
    [sym__binary_star] = ACTIONS(5951),
    [sym__identifier_hash_key] = ACTIONS(5951),
    [anon_sym_LBRACE] = ACTIONS(5951),
    [anon_sym_RBRACE] = ACTIONS(5951),
    [anon_sym_def] = ACTIONS(5953),
    [anon_sym_LPAREN] = ACTIONS(5953),
    [anon_sym_RPAREN] = ACTIONS(5951),
    [anon_sym_DOT] = ACTIONS(5953),
    [anon_sym_COLON_COLON] = ACTIONS(5953),
    [anon_sym_COMMA] = ACTIONS(5951),
    [anon_sym_PIPE] = ACTIONS(5953),
    [anon_sym_SEMI] = ACTIONS(5951),
    [anon_sym_STAR] = ACTIONS(5953),
    [anon_sym_STAR_STAR] = ACTIONS(5953),
    [anon_sym_AMP] = ACTIONS(5953),
    [anon_sym_EQ] = ACTIONS(5953),
    [anon_sym_class] = ACTIONS(5953),
    [anon_sym_LT] = ACTIONS(5953),
    [anon_sym_module] = ACTIONS(5953),
    [anon_sym_return] = ACTIONS(5953),
    [anon_sym_yield] = ACTIONS(5953),
    [anon_sym_break] = ACTIONS(5953),
    [anon_sym_next] = ACTIONS(5953),
    [sym_redo] = ACTIONS(5953),
    [sym_retry] = ACTIONS(5953),
    [anon_sym_if] = ACTIONS(5953),
    [anon_sym_unless] = ACTIONS(5953),
    [anon_sym_while] = ACTIONS(5953),
    [anon_sym_until] = ACTIONS(5953),
    [anon_sym_rescue] = ACTIONS(5953),
    [anon_sym_for] = ACTIONS(5953),
    [anon_sym_in] = ACTIONS(5953),
    [anon_sym_do] = ACTIONS(5953),
    [anon_sym_case] = ACTIONS(5953),
    [anon_sym_begin] = ACTIONS(5953),
    [anon_sym_EQ_GT] = ACTIONS(5951),
    [anon_sym_LBRACK] = ACTIONS(5951),
    [anon_sym_RBRACK] = ACTIONS(5951),
    [anon_sym_COLON_COLON2] = ACTIONS(5951),
    [anon_sym_AMP_DOT] = ACTIONS(5951),
    [anon_sym_LPAREN2] = ACTIONS(5951),
    [anon_sym_PLUS_EQ] = ACTIONS(5951),
    [anon_sym_DASH_EQ] = ACTIONS(5951),
    [anon_sym_STAR_EQ] = ACTIONS(5951),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5951),
    [anon_sym_SLASH_EQ] = ACTIONS(5951),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5951),
    [anon_sym_PIPE_EQ] = ACTIONS(5951),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5951),
    [anon_sym_AMP_EQ] = ACTIONS(5951),
    [anon_sym_PERCENT_EQ] = ACTIONS(5951),
    [anon_sym_GT_GT_EQ] = ACTIONS(5951),
    [anon_sym_LT_LT_EQ] = ACTIONS(5951),
    [anon_sym_CARET_EQ] = ACTIONS(5951),
    [anon_sym_QMARK] = ACTIONS(5953),
    [anon_sym_COLON2] = ACTIONS(5953),
    [anon_sym_DOT_DOT] = ACTIONS(5953),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5951),
    [anon_sym_and] = ACTIONS(5953),
    [anon_sym_or] = ACTIONS(5953),
    [anon_sym_PIPE_PIPE] = ACTIONS(5953),
    [anon_sym_AMP_AMP] = ACTIONS(5953),
    [anon_sym_LT_LT] = ACTIONS(5953),
    [anon_sym_GT_GT] = ACTIONS(5953),
    [anon_sym_EQ_EQ] = ACTIONS(5953),
    [anon_sym_BANG_EQ] = ACTIONS(5951),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5951),
    [anon_sym_LT_EQ_GT] = ACTIONS(5951),
    [anon_sym_EQ_TILDE] = ACTIONS(5951),
    [anon_sym_BANG_TILDE] = ACTIONS(5951),
    [anon_sym_LT_EQ] = ACTIONS(5953),
    [anon_sym_GT] = ACTIONS(5953),
    [anon_sym_GT_EQ] = ACTIONS(5951),
    [anon_sym_CARET] = ACTIONS(5953),
    [anon_sym_PLUS] = ACTIONS(5953),
    [anon_sym_SLASH] = ACTIONS(5953),
    [anon_sym_PERCENT] = ACTIONS(5953),
    [anon_sym_defined_QMARK] = ACTIONS(5951),
    [anon_sym_not] = ACTIONS(5953),
    [anon_sym_BANG] = ACTIONS(5953),
    [anon_sym_TILDE] = ACTIONS(5951),
    [sym_constant] = ACTIONS(5953),
    [sym_identifier] = ACTIONS(5953),
    [sym_instance_variable] = ACTIONS(5951),
    [sym_class_variable] = ACTIONS(5951),
    [sym_global_variable] = ACTIONS(5951),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5953),
    [sym_float] = ACTIONS(5953),
    [sym_complex] = ACTIONS(5951),
    [sym_super] = ACTIONS(5953),
    [anon_sym_true] = ACTIONS(5953),
    [anon_sym_TRUE] = ACTIONS(5953),
    [anon_sym_false] = ACTIONS(5953),
    [anon_sym_FALSE] = ACTIONS(5953),
    [sym_self] = ACTIONS(5953),
    [anon_sym_nil] = ACTIONS(5953),
    [anon_sym_NIL] = ACTIONS(5953),
    [sym_character] = ACTIONS(5951),
    [anon_sym_LBRACK2] = ACTIONS(5953),
    [anon_sym_DASH_GT] = ACTIONS(5951),
  },
  [3422] = {
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(5685),
    [sym__binary_star] = ACTIONS(5687),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(5689),
    [anon_sym_STAR_STAR] = ACTIONS(5691),
    [anon_sym_AMP] = ACTIONS(5693),
    [anon_sym_EQ] = ACTIONS(4217),
    [anon_sym_LT] = ACTIONS(5695),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_EQ_GT] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_RBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_PLUS_EQ] = ACTIONS(4211),
    [anon_sym_DASH_EQ] = ACTIONS(4211),
    [anon_sym_STAR_EQ] = ACTIONS(4211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4211),
    [anon_sym_SLASH_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4211),
    [anon_sym_AMP_EQ] = ACTIONS(4211),
    [anon_sym_PERCENT_EQ] = ACTIONS(4211),
    [anon_sym_GT_GT_EQ] = ACTIONS(4211),
    [anon_sym_LT_LT_EQ] = ACTIONS(4211),
    [anon_sym_CARET_EQ] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(5697),
    [anon_sym_DOT_DOT] = ACTIONS(5699),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5701),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(5703),
    [anon_sym_AMP_AMP] = ACTIONS(5703),
    [anon_sym_LT_LT] = ACTIONS(5705),
    [anon_sym_GT_GT] = ACTIONS(5705),
    [anon_sym_EQ_EQ] = ACTIONS(5703),
    [anon_sym_BANG_EQ] = ACTIONS(5707),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5707),
    [anon_sym_LT_EQ_GT] = ACTIONS(5707),
    [anon_sym_EQ_TILDE] = ACTIONS(5707),
    [anon_sym_BANG_TILDE] = ACTIONS(5707),
    [anon_sym_LT_EQ] = ACTIONS(5695),
    [anon_sym_GT] = ACTIONS(5695),
    [anon_sym_GT_EQ] = ACTIONS(5709),
    [anon_sym_CARET] = ACTIONS(5689),
    [anon_sym_PLUS] = ACTIONS(5711),
    [anon_sym_SLASH] = ACTIONS(5691),
    [anon_sym_PERCENT] = ACTIONS(5691),
    [sym_comment] = ACTIONS(87),
  },
  [3423] = {
    [sym_string] = STATE(3453),
    [aux_sym_chained_string_repeat1] = STATE(3453),
    [sym__string_start] = ACTIONS(1141),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3424] = {
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(5685),
    [sym__binary_star] = ACTIONS(5687),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(5689),
    [anon_sym_STAR_STAR] = ACTIONS(5691),
    [anon_sym_AMP] = ACTIONS(5693),
    [anon_sym_EQ] = ACTIONS(4249),
    [anon_sym_LT] = ACTIONS(5695),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_EQ_GT] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_RBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_PLUS_EQ] = ACTIONS(4247),
    [anon_sym_DASH_EQ] = ACTIONS(4247),
    [anon_sym_STAR_EQ] = ACTIONS(4247),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4247),
    [anon_sym_SLASH_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4247),
    [anon_sym_AMP_EQ] = ACTIONS(4247),
    [anon_sym_PERCENT_EQ] = ACTIONS(4247),
    [anon_sym_GT_GT_EQ] = ACTIONS(4247),
    [anon_sym_LT_LT_EQ] = ACTIONS(4247),
    [anon_sym_CARET_EQ] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(5697),
    [anon_sym_DOT_DOT] = ACTIONS(5699),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5701),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(5703),
    [anon_sym_AMP_AMP] = ACTIONS(5703),
    [anon_sym_LT_LT] = ACTIONS(5705),
    [anon_sym_GT_GT] = ACTIONS(5705),
    [anon_sym_EQ_EQ] = ACTIONS(5703),
    [anon_sym_BANG_EQ] = ACTIONS(5707),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5707),
    [anon_sym_LT_EQ_GT] = ACTIONS(5707),
    [anon_sym_EQ_TILDE] = ACTIONS(5707),
    [anon_sym_BANG_TILDE] = ACTIONS(5707),
    [anon_sym_LT_EQ] = ACTIONS(5695),
    [anon_sym_GT] = ACTIONS(5695),
    [anon_sym_GT_EQ] = ACTIONS(5709),
    [anon_sym_CARET] = ACTIONS(5689),
    [anon_sym_PLUS] = ACTIONS(5711),
    [anon_sym_SLASH] = ACTIONS(5691),
    [anon_sym_PERCENT] = ACTIONS(5691),
    [sym_comment] = ACTIONS(87),
  },
  [3425] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(5691),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_RBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [3426] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6062),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1384),
    [sym_scope_resolution] = STATE(1378),
    [sym_call] = STATE(1378),
    [sym_method_call] = STATE(1384),
    [sym_assignment] = STATE(6062),
    [sym_operator_assignment] = STATE(6062),
    [sym_conditional] = STATE(6062),
    [sym_range] = STATE(6062),
    [sym_binary] = STATE(6062),
    [sym_unary] = STATE(6062),
    [sym_left_assignment_list] = STATE(1383),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1384),
    [sym__variable] = STATE(1378),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1384),
    [sym_false] = STATE(1384),
    [sym_nil] = STATE(1384),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3423),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2399),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2405),
    [anon_sym_yield] = ACTIONS(2407),
    [anon_sym_break] = ACTIONS(2409),
    [anon_sym_next] = ACTIONS(2411),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(5673),
    [anon_sym_defined_QMARK] = ACTIONS(2415),
    [anon_sym_not] = ACTIONS(2417),
    [anon_sym_BANG] = ACTIONS(2421),
    [anon_sym_TILDE] = ACTIONS(2421),
    [sym_constant] = ACTIONS(2427),
    [sym_identifier] = ACTIONS(2427),
    [sym_instance_variable] = ACTIONS(2425),
    [sym_class_variable] = ACTIONS(2425),
    [sym_global_variable] = ACTIONS(2425),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2427),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2427),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3427] = {
    [sym__heredoc_body_start] = ACTIONS(5735),
    [sym__binary_minus] = ACTIONS(5735),
    [sym__binary_star] = ACTIONS(5735),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_RBRACE] = ACTIONS(5735),
    [anon_sym_RPAREN] = ACTIONS(5735),
    [anon_sym_DOT] = ACTIONS(5737),
    [anon_sym_COMMA] = ACTIONS(5735),
    [anon_sym_PIPE] = ACTIONS(5737),
    [anon_sym_SEMI] = ACTIONS(5735),
    [anon_sym_STAR_STAR] = ACTIONS(5737),
    [anon_sym_AMP] = ACTIONS(5737),
    [anon_sym_EQ] = ACTIONS(5737),
    [anon_sym_LT] = ACTIONS(5737),
    [anon_sym_if] = ACTIONS(5735),
    [anon_sym_unless] = ACTIONS(5735),
    [anon_sym_while] = ACTIONS(5735),
    [anon_sym_until] = ACTIONS(5735),
    [anon_sym_rescue] = ACTIONS(5735),
    [anon_sym_do] = ACTIONS(993),
    [anon_sym_EQ_GT] = ACTIONS(5735),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_RBRACK] = ACTIONS(5735),
    [anon_sym_COLON_COLON2] = ACTIONS(5735),
    [anon_sym_AMP_DOT] = ACTIONS(5735),
    [anon_sym_PLUS_EQ] = ACTIONS(5735),
    [anon_sym_DASH_EQ] = ACTIONS(5735),
    [anon_sym_STAR_EQ] = ACTIONS(5735),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5735),
    [anon_sym_SLASH_EQ] = ACTIONS(5735),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5735),
    [anon_sym_PIPE_EQ] = ACTIONS(5735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5735),
    [anon_sym_AMP_EQ] = ACTIONS(5735),
    [anon_sym_PERCENT_EQ] = ACTIONS(5735),
    [anon_sym_GT_GT_EQ] = ACTIONS(5735),
    [anon_sym_LT_LT_EQ] = ACTIONS(5735),
    [anon_sym_CARET_EQ] = ACTIONS(5735),
    [anon_sym_QMARK] = ACTIONS(5735),
    [anon_sym_COLON2] = ACTIONS(5737),
    [anon_sym_DOT_DOT] = ACTIONS(5737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5735),
    [anon_sym_and] = ACTIONS(5735),
    [anon_sym_or] = ACTIONS(5735),
    [anon_sym_PIPE_PIPE] = ACTIONS(5737),
    [anon_sym_AMP_AMP] = ACTIONS(5737),
    [anon_sym_LT_LT] = ACTIONS(5737),
    [anon_sym_GT_GT] = ACTIONS(5737),
    [anon_sym_EQ_EQ] = ACTIONS(5737),
    [anon_sym_BANG_EQ] = ACTIONS(5735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5735),
    [anon_sym_LT_EQ_GT] = ACTIONS(5735),
    [anon_sym_EQ_TILDE] = ACTIONS(5735),
    [anon_sym_BANG_TILDE] = ACTIONS(5735),
    [anon_sym_LT_EQ] = ACTIONS(5737),
    [anon_sym_GT] = ACTIONS(5737),
    [anon_sym_GT_EQ] = ACTIONS(5735),
    [anon_sym_CARET] = ACTIONS(5737),
    [anon_sym_PLUS] = ACTIONS(5737),
    [anon_sym_SLASH] = ACTIONS(5737),
    [anon_sym_PERCENT] = ACTIONS(5737),
    [sym_comment] = ACTIONS(87),
  },
  [3428] = {
    [anon_sym_RBRACE] = ACTIONS(9392),
    [sym_comment] = ACTIONS(87),
  },
  [3429] = {
    [sym__statements] = STATE(6064),
    [sym_begin_block] = STATE(489),
    [sym_end_block] = STATE(489),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(495),
    [aux_sym__statements_repeat1] = STATE(495),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(9392),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3430] = {
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(5685),
    [sym__binary_star] = ACTIONS(5687),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(5689),
    [anon_sym_STAR_STAR] = ACTIONS(5691),
    [anon_sym_AMP] = ACTIONS(5693),
    [anon_sym_EQ] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(5695),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_EQ_GT] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_RBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_PLUS_EQ] = ACTIONS(3281),
    [anon_sym_DASH_EQ] = ACTIONS(3281),
    [anon_sym_STAR_EQ] = ACTIONS(3281),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3281),
    [anon_sym_SLASH_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3281),
    [anon_sym_AMP_EQ] = ACTIONS(3281),
    [anon_sym_PERCENT_EQ] = ACTIONS(3281),
    [anon_sym_GT_GT_EQ] = ACTIONS(3281),
    [anon_sym_LT_LT_EQ] = ACTIONS(3281),
    [anon_sym_CARET_EQ] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(5697),
    [anon_sym_DOT_DOT] = ACTIONS(5699),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5701),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(5703),
    [anon_sym_AMP_AMP] = ACTIONS(5703),
    [anon_sym_LT_LT] = ACTIONS(5705),
    [anon_sym_GT_GT] = ACTIONS(5705),
    [anon_sym_EQ_EQ] = ACTIONS(5703),
    [anon_sym_BANG_EQ] = ACTIONS(5707),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5707),
    [anon_sym_LT_EQ_GT] = ACTIONS(5707),
    [anon_sym_EQ_TILDE] = ACTIONS(5707),
    [anon_sym_BANG_TILDE] = ACTIONS(5707),
    [anon_sym_LT_EQ] = ACTIONS(5695),
    [anon_sym_GT] = ACTIONS(5695),
    [anon_sym_GT_EQ] = ACTIONS(5709),
    [anon_sym_CARET] = ACTIONS(5689),
    [anon_sym_PLUS] = ACTIONS(5711),
    [anon_sym_SLASH] = ACTIONS(5691),
    [anon_sym_PERCENT] = ACTIONS(5691),
    [sym_comment] = ACTIONS(87),
  },
  [3431] = {
    [sym__heredoc_body_start] = ACTIONS(5771),
    [sym__binary_minus] = ACTIONS(5771),
    [sym__binary_star] = ACTIONS(5771),
    [anon_sym_LBRACE] = ACTIONS(5771),
    [anon_sym_RBRACE] = ACTIONS(5771),
    [anon_sym_RPAREN] = ACTIONS(5771),
    [anon_sym_DOT] = ACTIONS(5773),
    [anon_sym_COMMA] = ACTIONS(5771),
    [anon_sym_PIPE] = ACTIONS(5773),
    [anon_sym_SEMI] = ACTIONS(5771),
    [anon_sym_STAR_STAR] = ACTIONS(5773),
    [anon_sym_AMP] = ACTIONS(5773),
    [anon_sym_EQ] = ACTIONS(5773),
    [anon_sym_LT] = ACTIONS(5773),
    [anon_sym_if] = ACTIONS(5771),
    [anon_sym_unless] = ACTIONS(5771),
    [anon_sym_while] = ACTIONS(5771),
    [anon_sym_until] = ACTIONS(5771),
    [anon_sym_rescue] = ACTIONS(5771),
    [anon_sym_in] = ACTIONS(5771),
    [anon_sym_do] = ACTIONS(5771),
    [anon_sym_EQ_GT] = ACTIONS(5771),
    [anon_sym_LBRACK] = ACTIONS(5771),
    [anon_sym_RBRACK] = ACTIONS(5771),
    [anon_sym_COLON_COLON2] = ACTIONS(5771),
    [anon_sym_AMP_DOT] = ACTIONS(5771),
    [anon_sym_PLUS_EQ] = ACTIONS(5771),
    [anon_sym_DASH_EQ] = ACTIONS(5771),
    [anon_sym_STAR_EQ] = ACTIONS(5771),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5771),
    [anon_sym_SLASH_EQ] = ACTIONS(5771),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5771),
    [anon_sym_PIPE_EQ] = ACTIONS(5771),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5771),
    [anon_sym_AMP_EQ] = ACTIONS(5771),
    [anon_sym_PERCENT_EQ] = ACTIONS(5771),
    [anon_sym_GT_GT_EQ] = ACTIONS(5771),
    [anon_sym_LT_LT_EQ] = ACTIONS(5771),
    [anon_sym_CARET_EQ] = ACTIONS(5771),
    [anon_sym_QMARK] = ACTIONS(5771),
    [anon_sym_COLON2] = ACTIONS(5773),
    [anon_sym_DOT_DOT] = ACTIONS(5773),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5771),
    [anon_sym_and] = ACTIONS(5771),
    [anon_sym_or] = ACTIONS(5771),
    [anon_sym_PIPE_PIPE] = ACTIONS(5773),
    [anon_sym_AMP_AMP] = ACTIONS(5773),
    [anon_sym_LT_LT] = ACTIONS(5773),
    [anon_sym_GT_GT] = ACTIONS(5773),
    [anon_sym_EQ_EQ] = ACTIONS(5773),
    [anon_sym_BANG_EQ] = ACTIONS(5771),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5771),
    [anon_sym_LT_EQ_GT] = ACTIONS(5771),
    [anon_sym_EQ_TILDE] = ACTIONS(5771),
    [anon_sym_BANG_TILDE] = ACTIONS(5771),
    [anon_sym_LT_EQ] = ACTIONS(5773),
    [anon_sym_GT] = ACTIONS(5773),
    [anon_sym_GT_EQ] = ACTIONS(5771),
    [anon_sym_CARET] = ACTIONS(5773),
    [anon_sym_PLUS] = ACTIONS(5773),
    [anon_sym_SLASH] = ACTIONS(5773),
    [anon_sym_PERCENT] = ACTIONS(5773),
    [sym_comment] = ACTIONS(87),
  },
  [3432] = {
    [anon_sym_end] = ACTIONS(9394),
    [sym_comment] = ACTIONS(87),
  },
  [3433] = {
    [sym__statements] = STATE(6066),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_heredoc_body] = STATE(6067),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [sym__terminator] = STATE(6067),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__line_break] = ACTIONS(9396),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(9396),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9398),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3434] = {
    [sym__statements] = STATE(6066),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_block_parameters] = STATE(6068),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9398),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3435] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(5685),
    [sym__binary_star] = ACTIONS(5687),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(5689),
    [anon_sym_STAR_STAR] = ACTIONS(5691),
    [anon_sym_AMP] = ACTIONS(5693),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(5695),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_RBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(5697),
    [anon_sym_DOT_DOT] = ACTIONS(5699),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5701),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(5703),
    [anon_sym_AMP_AMP] = ACTIONS(5703),
    [anon_sym_LT_LT] = ACTIONS(5705),
    [anon_sym_GT_GT] = ACTIONS(5705),
    [anon_sym_EQ_EQ] = ACTIONS(5703),
    [anon_sym_BANG_EQ] = ACTIONS(5707),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5707),
    [anon_sym_LT_EQ_GT] = ACTIONS(5707),
    [anon_sym_EQ_TILDE] = ACTIONS(5707),
    [anon_sym_BANG_TILDE] = ACTIONS(5707),
    [anon_sym_LT_EQ] = ACTIONS(5695),
    [anon_sym_GT] = ACTIONS(5695),
    [anon_sym_GT_EQ] = ACTIONS(5709),
    [anon_sym_CARET] = ACTIONS(5689),
    [anon_sym_PLUS] = ACTIONS(5711),
    [anon_sym_SLASH] = ACTIONS(5691),
    [anon_sym_PERCENT] = ACTIONS(5691),
    [sym_comment] = ACTIONS(87),
  },
  [3436] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6069),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1384),
    [sym_scope_resolution] = STATE(1378),
    [sym_call] = STATE(1378),
    [sym_method_call] = STATE(1384),
    [sym_assignment] = STATE(6069),
    [sym_operator_assignment] = STATE(6069),
    [sym_conditional] = STATE(6069),
    [sym_range] = STATE(6069),
    [sym_binary] = STATE(6069),
    [sym_unary] = STATE(6069),
    [sym_left_assignment_list] = STATE(1383),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1384),
    [sym__variable] = STATE(1378),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1384),
    [sym_false] = STATE(1384),
    [sym_nil] = STATE(1384),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3423),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2399),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2405),
    [anon_sym_yield] = ACTIONS(2407),
    [anon_sym_break] = ACTIONS(2409),
    [anon_sym_next] = ACTIONS(2411),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(5673),
    [anon_sym_defined_QMARK] = ACTIONS(2415),
    [anon_sym_not] = ACTIONS(2417),
    [anon_sym_BANG] = ACTIONS(2421),
    [anon_sym_TILDE] = ACTIONS(2421),
    [sym_constant] = ACTIONS(2427),
    [sym_identifier] = ACTIONS(2427),
    [sym_instance_variable] = ACTIONS(2425),
    [sym_class_variable] = ACTIONS(2425),
    [sym_global_variable] = ACTIONS(2425),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2427),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2427),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3437] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6070),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1384),
    [sym_scope_resolution] = STATE(1378),
    [sym_call] = STATE(1378),
    [sym_method_call] = STATE(1384),
    [sym_assignment] = STATE(6070),
    [sym_operator_assignment] = STATE(6070),
    [sym_conditional] = STATE(6070),
    [sym_range] = STATE(6070),
    [sym_binary] = STATE(6070),
    [sym_unary] = STATE(6070),
    [sym_left_assignment_list] = STATE(1383),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1384),
    [sym__variable] = STATE(1378),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1384),
    [sym_false] = STATE(1384),
    [sym_nil] = STATE(1384),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3423),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2399),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2405),
    [anon_sym_yield] = ACTIONS(2407),
    [anon_sym_break] = ACTIONS(2409),
    [anon_sym_next] = ACTIONS(2411),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(5673),
    [anon_sym_defined_QMARK] = ACTIONS(2415),
    [anon_sym_not] = ACTIONS(2417),
    [anon_sym_BANG] = ACTIONS(2421),
    [anon_sym_TILDE] = ACTIONS(2421),
    [sym_constant] = ACTIONS(2427),
    [sym_identifier] = ACTIONS(2427),
    [sym_instance_variable] = ACTIONS(2425),
    [sym_class_variable] = ACTIONS(2425),
    [sym_global_variable] = ACTIONS(2425),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2427),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2427),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3438] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6071),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1384),
    [sym_scope_resolution] = STATE(1378),
    [sym_call] = STATE(1378),
    [sym_method_call] = STATE(1384),
    [sym_assignment] = STATE(6071),
    [sym_operator_assignment] = STATE(6071),
    [sym_conditional] = STATE(6071),
    [sym_range] = STATE(6071),
    [sym_binary] = STATE(6071),
    [sym_unary] = STATE(6071),
    [sym_left_assignment_list] = STATE(1383),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1384),
    [sym__variable] = STATE(1378),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1384),
    [sym_false] = STATE(1384),
    [sym_nil] = STATE(1384),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3423),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2399),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2405),
    [anon_sym_yield] = ACTIONS(2407),
    [anon_sym_break] = ACTIONS(2409),
    [anon_sym_next] = ACTIONS(2411),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(5673),
    [anon_sym_defined_QMARK] = ACTIONS(2415),
    [anon_sym_not] = ACTIONS(2417),
    [anon_sym_BANG] = ACTIONS(2421),
    [anon_sym_TILDE] = ACTIONS(2421),
    [sym_constant] = ACTIONS(2427),
    [sym_identifier] = ACTIONS(2427),
    [sym_instance_variable] = ACTIONS(2425),
    [sym_class_variable] = ACTIONS(2425),
    [sym_global_variable] = ACTIONS(2425),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2427),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2427),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3439] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6072),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1384),
    [sym_scope_resolution] = STATE(1378),
    [sym_call] = STATE(1378),
    [sym_method_call] = STATE(1384),
    [sym_assignment] = STATE(6072),
    [sym_operator_assignment] = STATE(6072),
    [sym_conditional] = STATE(6072),
    [sym_range] = STATE(6072),
    [sym_binary] = STATE(6072),
    [sym_unary] = STATE(6072),
    [sym_left_assignment_list] = STATE(1383),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1384),
    [sym__variable] = STATE(1378),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1384),
    [sym_false] = STATE(1384),
    [sym_nil] = STATE(1384),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3423),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2399),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2405),
    [anon_sym_yield] = ACTIONS(2407),
    [anon_sym_break] = ACTIONS(2409),
    [anon_sym_next] = ACTIONS(2411),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(5673),
    [anon_sym_defined_QMARK] = ACTIONS(2415),
    [anon_sym_not] = ACTIONS(2417),
    [anon_sym_BANG] = ACTIONS(2421),
    [anon_sym_TILDE] = ACTIONS(2421),
    [sym_constant] = ACTIONS(2427),
    [sym_identifier] = ACTIONS(2427),
    [sym_instance_variable] = ACTIONS(2425),
    [sym_class_variable] = ACTIONS(2425),
    [sym_global_variable] = ACTIONS(2425),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2427),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2427),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3440] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6073),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1384),
    [sym_scope_resolution] = STATE(1378),
    [sym_call] = STATE(1378),
    [sym_method_call] = STATE(1384),
    [sym_assignment] = STATE(6073),
    [sym_operator_assignment] = STATE(6073),
    [sym_conditional] = STATE(6073),
    [sym_range] = STATE(6073),
    [sym_binary] = STATE(6073),
    [sym_unary] = STATE(6073),
    [sym_left_assignment_list] = STATE(1383),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1384),
    [sym__variable] = STATE(1378),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1384),
    [sym_false] = STATE(1384),
    [sym_nil] = STATE(1384),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3423),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2399),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2405),
    [anon_sym_yield] = ACTIONS(2407),
    [anon_sym_break] = ACTIONS(2409),
    [anon_sym_next] = ACTIONS(2411),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(5673),
    [anon_sym_defined_QMARK] = ACTIONS(2415),
    [anon_sym_not] = ACTIONS(2417),
    [anon_sym_BANG] = ACTIONS(2421),
    [anon_sym_TILDE] = ACTIONS(2421),
    [sym_constant] = ACTIONS(2427),
    [sym_identifier] = ACTIONS(2427),
    [sym_instance_variable] = ACTIONS(2425),
    [sym_class_variable] = ACTIONS(2425),
    [sym_global_variable] = ACTIONS(2425),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2427),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2427),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3441] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6074),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1384),
    [sym_scope_resolution] = STATE(1378),
    [sym_call] = STATE(1378),
    [sym_method_call] = STATE(1384),
    [sym_assignment] = STATE(6074),
    [sym_operator_assignment] = STATE(6074),
    [sym_conditional] = STATE(6074),
    [sym_range] = STATE(6074),
    [sym_binary] = STATE(6074),
    [sym_unary] = STATE(6074),
    [sym_left_assignment_list] = STATE(1383),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1384),
    [sym__variable] = STATE(1378),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1384),
    [sym_false] = STATE(1384),
    [sym_nil] = STATE(1384),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3423),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2399),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2405),
    [anon_sym_yield] = ACTIONS(2407),
    [anon_sym_break] = ACTIONS(2409),
    [anon_sym_next] = ACTIONS(2411),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(5673),
    [anon_sym_defined_QMARK] = ACTIONS(2415),
    [anon_sym_not] = ACTIONS(2417),
    [anon_sym_BANG] = ACTIONS(2421),
    [anon_sym_TILDE] = ACTIONS(2421),
    [sym_constant] = ACTIONS(2427),
    [sym_identifier] = ACTIONS(2427),
    [sym_instance_variable] = ACTIONS(2425),
    [sym_class_variable] = ACTIONS(2425),
    [sym_global_variable] = ACTIONS(2425),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2427),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2427),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3442] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(6075),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(6075),
    [sym_operator_assignment] = STATE(6075),
    [sym_conditional] = STATE(6075),
    [sym_range] = STATE(6075),
    [sym_binary] = STATE(6075),
    [sym_unary] = STATE(6075),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3443] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6076),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1384),
    [sym_scope_resolution] = STATE(1378),
    [sym_call] = STATE(1378),
    [sym_method_call] = STATE(1384),
    [sym_assignment] = STATE(6076),
    [sym_operator_assignment] = STATE(6076),
    [sym_conditional] = STATE(6076),
    [sym_range] = STATE(6076),
    [sym_binary] = STATE(6076),
    [sym_unary] = STATE(6076),
    [sym_left_assignment_list] = STATE(1383),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1384),
    [sym__variable] = STATE(1378),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1384),
    [sym_false] = STATE(1384),
    [sym_nil] = STATE(1384),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3423),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2399),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2405),
    [anon_sym_yield] = ACTIONS(2407),
    [anon_sym_break] = ACTIONS(2409),
    [anon_sym_next] = ACTIONS(2411),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(5673),
    [anon_sym_defined_QMARK] = ACTIONS(2415),
    [anon_sym_not] = ACTIONS(2417),
    [anon_sym_BANG] = ACTIONS(2421),
    [anon_sym_TILDE] = ACTIONS(2421),
    [sym_constant] = ACTIONS(2427),
    [sym_identifier] = ACTIONS(2427),
    [sym_instance_variable] = ACTIONS(2425),
    [sym_class_variable] = ACTIONS(2425),
    [sym_global_variable] = ACTIONS(2425),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2427),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2427),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3444] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6077),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1384),
    [sym_scope_resolution] = STATE(1378),
    [sym_call] = STATE(1378),
    [sym_method_call] = STATE(1384),
    [sym_assignment] = STATE(6077),
    [sym_operator_assignment] = STATE(6077),
    [sym_conditional] = STATE(6077),
    [sym_range] = STATE(6077),
    [sym_binary] = STATE(6077),
    [sym_unary] = STATE(6077),
    [sym_left_assignment_list] = STATE(1383),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1384),
    [sym__variable] = STATE(1378),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1384),
    [sym_false] = STATE(1384),
    [sym_nil] = STATE(1384),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3423),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2399),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2405),
    [anon_sym_yield] = ACTIONS(2407),
    [anon_sym_break] = ACTIONS(2409),
    [anon_sym_next] = ACTIONS(2411),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(5673),
    [anon_sym_defined_QMARK] = ACTIONS(2415),
    [anon_sym_not] = ACTIONS(2417),
    [anon_sym_BANG] = ACTIONS(2421),
    [anon_sym_TILDE] = ACTIONS(2421),
    [sym_constant] = ACTIONS(2427),
    [sym_identifier] = ACTIONS(2427),
    [sym_instance_variable] = ACTIONS(2425),
    [sym_class_variable] = ACTIONS(2425),
    [sym_global_variable] = ACTIONS(2425),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2427),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2427),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3445] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6078),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1384),
    [sym_scope_resolution] = STATE(1378),
    [sym_call] = STATE(1378),
    [sym_method_call] = STATE(1384),
    [sym_assignment] = STATE(6078),
    [sym_operator_assignment] = STATE(6078),
    [sym_conditional] = STATE(6078),
    [sym_range] = STATE(6078),
    [sym_binary] = STATE(6078),
    [sym_unary] = STATE(6078),
    [sym_left_assignment_list] = STATE(1383),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1384),
    [sym__variable] = STATE(1378),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1384),
    [sym_false] = STATE(1384),
    [sym_nil] = STATE(1384),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3423),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2399),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2405),
    [anon_sym_yield] = ACTIONS(2407),
    [anon_sym_break] = ACTIONS(2409),
    [anon_sym_next] = ACTIONS(2411),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(5673),
    [anon_sym_defined_QMARK] = ACTIONS(2415),
    [anon_sym_not] = ACTIONS(2417),
    [anon_sym_BANG] = ACTIONS(2421),
    [anon_sym_TILDE] = ACTIONS(2421),
    [sym_constant] = ACTIONS(2427),
    [sym_identifier] = ACTIONS(2427),
    [sym_instance_variable] = ACTIONS(2425),
    [sym_class_variable] = ACTIONS(2425),
    [sym_global_variable] = ACTIONS(2425),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2427),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2427),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3446] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6079),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1384),
    [sym_scope_resolution] = STATE(1378),
    [sym_call] = STATE(1378),
    [sym_method_call] = STATE(1384),
    [sym_assignment] = STATE(6079),
    [sym_operator_assignment] = STATE(6079),
    [sym_conditional] = STATE(6079),
    [sym_range] = STATE(6079),
    [sym_binary] = STATE(6079),
    [sym_unary] = STATE(6079),
    [sym_left_assignment_list] = STATE(1383),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1384),
    [sym__variable] = STATE(1378),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1384),
    [sym_false] = STATE(1384),
    [sym_nil] = STATE(1384),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3423),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2399),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2405),
    [anon_sym_yield] = ACTIONS(2407),
    [anon_sym_break] = ACTIONS(2409),
    [anon_sym_next] = ACTIONS(2411),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(5673),
    [anon_sym_defined_QMARK] = ACTIONS(2415),
    [anon_sym_not] = ACTIONS(2417),
    [anon_sym_BANG] = ACTIONS(2421),
    [anon_sym_TILDE] = ACTIONS(2421),
    [sym_constant] = ACTIONS(2427),
    [sym_identifier] = ACTIONS(2427),
    [sym_instance_variable] = ACTIONS(2425),
    [sym_class_variable] = ACTIONS(2425),
    [sym_global_variable] = ACTIONS(2425),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2427),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2427),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3447] = {
    [sym__heredoc_body_start] = ACTIONS(6155),
    [sym__binary_minus] = ACTIONS(6155),
    [sym__binary_star] = ACTIONS(6155),
    [anon_sym_LBRACE] = ACTIONS(6155),
    [anon_sym_RBRACE] = ACTIONS(6155),
    [anon_sym_RPAREN] = ACTIONS(6155),
    [anon_sym_DOT] = ACTIONS(6157),
    [anon_sym_COMMA] = ACTIONS(6155),
    [anon_sym_PIPE] = ACTIONS(6157),
    [anon_sym_SEMI] = ACTIONS(6155),
    [anon_sym_STAR_STAR] = ACTIONS(6157),
    [anon_sym_AMP] = ACTIONS(6157),
    [anon_sym_EQ] = ACTIONS(6157),
    [anon_sym_LT] = ACTIONS(6157),
    [anon_sym_if] = ACTIONS(6155),
    [anon_sym_unless] = ACTIONS(6155),
    [anon_sym_while] = ACTIONS(6155),
    [anon_sym_until] = ACTIONS(6155),
    [anon_sym_rescue] = ACTIONS(6155),
    [anon_sym_in] = ACTIONS(6155),
    [anon_sym_do] = ACTIONS(6155),
    [anon_sym_EQ_GT] = ACTIONS(6155),
    [anon_sym_LBRACK] = ACTIONS(6155),
    [anon_sym_RBRACK] = ACTIONS(6155),
    [anon_sym_COLON_COLON2] = ACTIONS(6155),
    [anon_sym_AMP_DOT] = ACTIONS(6155),
    [anon_sym_PLUS_EQ] = ACTIONS(6155),
    [anon_sym_DASH_EQ] = ACTIONS(6155),
    [anon_sym_STAR_EQ] = ACTIONS(6155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6155),
    [anon_sym_SLASH_EQ] = ACTIONS(6155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6155),
    [anon_sym_PIPE_EQ] = ACTIONS(6155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6155),
    [anon_sym_AMP_EQ] = ACTIONS(6155),
    [anon_sym_PERCENT_EQ] = ACTIONS(6155),
    [anon_sym_GT_GT_EQ] = ACTIONS(6155),
    [anon_sym_LT_LT_EQ] = ACTIONS(6155),
    [anon_sym_CARET_EQ] = ACTIONS(6155),
    [anon_sym_QMARK] = ACTIONS(6155),
    [anon_sym_COLON2] = ACTIONS(6157),
    [anon_sym_DOT_DOT] = ACTIONS(6157),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6155),
    [anon_sym_and] = ACTIONS(6155),
    [anon_sym_or] = ACTIONS(6155),
    [anon_sym_PIPE_PIPE] = ACTIONS(6157),
    [anon_sym_AMP_AMP] = ACTIONS(6157),
    [anon_sym_LT_LT] = ACTIONS(6157),
    [anon_sym_GT_GT] = ACTIONS(6157),
    [anon_sym_EQ_EQ] = ACTIONS(6157),
    [anon_sym_BANG_EQ] = ACTIONS(6155),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6155),
    [anon_sym_LT_EQ_GT] = ACTIONS(6155),
    [anon_sym_EQ_TILDE] = ACTIONS(6155),
    [anon_sym_BANG_TILDE] = ACTIONS(6155),
    [anon_sym_LT_EQ] = ACTIONS(6157),
    [anon_sym_GT] = ACTIONS(6157),
    [anon_sym_GT_EQ] = ACTIONS(6155),
    [anon_sym_CARET] = ACTIONS(6157),
    [anon_sym_PLUS] = ACTIONS(6157),
    [anon_sym_SLASH] = ACTIONS(6157),
    [anon_sym_PERCENT] = ACTIONS(6157),
    [sym_comment] = ACTIONS(87),
  },
  [3448] = {
    [sym_heredoc_body] = STATE(6080),
    [aux_sym_call_repeat1] = STATE(6080),
    [sym__heredoc_body_start] = ACTIONS(3543),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_RBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [3449] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1377),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1384),
    [sym_scope_resolution] = STATE(1378),
    [sym_call] = STATE(1378),
    [sym_method_call] = STATE(1384),
    [sym__argument] = STATE(4357),
    [sym_splat_argument] = STATE(4357),
    [sym_hash_splat_argument] = STATE(4357),
    [sym_block_argument] = STATE(4357),
    [sym_assignment] = STATE(1377),
    [sym_operator_assignment] = STATE(1377),
    [sym_conditional] = STATE(1377),
    [sym_range] = STATE(1377),
    [sym_binary] = STATE(1377),
    [sym_unary] = STATE(1377),
    [sym_left_assignment_list] = STATE(1383),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1384),
    [sym__variable] = STATE(1378),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1384),
    [sym_false] = STATE(1384),
    [sym_nil] = STATE(1384),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1385),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_heredoc_body] = STATE(6081),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(4357),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(2395),
    [sym__splat_star] = ACTIONS(2397),
    [sym__unary_minus] = ACTIONS(2399),
    [sym__identifier_hash_key] = ACTIONS(2401),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(9400),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2405),
    [anon_sym_yield] = ACTIONS(2407),
    [anon_sym_break] = ACTIONS(2409),
    [anon_sym_next] = ACTIONS(2411),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(5673),
    [anon_sym_defined_QMARK] = ACTIONS(2415),
    [anon_sym_not] = ACTIONS(2417),
    [anon_sym_BANG] = ACTIONS(2421),
    [anon_sym_TILDE] = ACTIONS(2421),
    [sym_constant] = ACTIONS(2423),
    [sym_identifier] = ACTIONS(2423),
    [sym_instance_variable] = ACTIONS(2425),
    [sym_class_variable] = ACTIONS(2425),
    [sym_global_variable] = ACTIONS(2425),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2427),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2427),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3450] = {
    [sym_heredoc_body] = STATE(6082),
    [aux_sym_call_repeat1] = STATE(6082),
    [aux_sym_argument_list_repeat1] = STATE(6083),
    [sym__heredoc_body_start] = ACTIONS(3543),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(5715),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_RBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [3451] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6084),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1384),
    [sym_scope_resolution] = STATE(1378),
    [sym_call] = STATE(1378),
    [sym_method_call] = STATE(1384),
    [sym_splat_argument] = STATE(6085),
    [sym_assignment] = STATE(6084),
    [sym_operator_assignment] = STATE(6084),
    [sym_conditional] = STATE(6084),
    [sym_range] = STATE(6084),
    [sym_binary] = STATE(6084),
    [sym_unary] = STATE(6084),
    [sym_right_assignment_list] = STATE(4362),
    [sym__arg_or_splat_arg] = STATE(6085),
    [sym_left_assignment_list] = STATE(1383),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1384),
    [sym__variable] = STATE(1378),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1384),
    [sym_false] = STATE(1384),
    [sym_nil] = STATE(1384),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3423),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__splat_star] = ACTIONS(2397),
    [sym__unary_minus] = ACTIONS(2399),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2405),
    [anon_sym_yield] = ACTIONS(2407),
    [anon_sym_break] = ACTIONS(2409),
    [anon_sym_next] = ACTIONS(2411),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(5673),
    [anon_sym_defined_QMARK] = ACTIONS(2415),
    [anon_sym_not] = ACTIONS(2417),
    [anon_sym_BANG] = ACTIONS(2421),
    [anon_sym_TILDE] = ACTIONS(2421),
    [sym_constant] = ACTIONS(2427),
    [sym_identifier] = ACTIONS(2427),
    [sym_instance_variable] = ACTIONS(2425),
    [sym_class_variable] = ACTIONS(2425),
    [sym_global_variable] = ACTIONS(2425),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2427),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2427),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3452] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6086),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1384),
    [sym_scope_resolution] = STATE(1378),
    [sym_call] = STATE(1378),
    [sym_method_call] = STATE(1384),
    [sym_assignment] = STATE(6086),
    [sym_operator_assignment] = STATE(6086),
    [sym_conditional] = STATE(6086),
    [sym_range] = STATE(6086),
    [sym_binary] = STATE(6086),
    [sym_unary] = STATE(6086),
    [sym_left_assignment_list] = STATE(1383),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1384),
    [sym__variable] = STATE(1378),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1384),
    [sym_false] = STATE(1384),
    [sym_nil] = STATE(1384),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3423),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2399),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2405),
    [anon_sym_yield] = ACTIONS(2407),
    [anon_sym_break] = ACTIONS(2409),
    [anon_sym_next] = ACTIONS(2411),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(5673),
    [anon_sym_defined_QMARK] = ACTIONS(2415),
    [anon_sym_not] = ACTIONS(2417),
    [anon_sym_BANG] = ACTIONS(2421),
    [anon_sym_TILDE] = ACTIONS(2421),
    [sym_constant] = ACTIONS(2427),
    [sym_identifier] = ACTIONS(2427),
    [sym_instance_variable] = ACTIONS(2425),
    [sym_class_variable] = ACTIONS(2425),
    [sym_global_variable] = ACTIONS(2425),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2427),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2427),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3453] = {
    [sym_string] = STATE(6087),
    [aux_sym_chained_string_repeat1] = STATE(6087),
    [sym__string_start] = ACTIONS(1141),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_STAR_STAR] = ACTIONS(2755),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_EQ] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_EQ_GT] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_RBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_PLUS_EQ] = ACTIONS(2753),
    [anon_sym_DASH_EQ] = ACTIONS(2753),
    [anon_sym_STAR_EQ] = ACTIONS(2753),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2753),
    [anon_sym_SLASH_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2753),
    [anon_sym_AMP_EQ] = ACTIONS(2753),
    [anon_sym_PERCENT_EQ] = ACTIONS(2753),
    [anon_sym_GT_GT_EQ] = ACTIONS(2753),
    [anon_sym_LT_LT_EQ] = ACTIONS(2753),
    [anon_sym_CARET_EQ] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2755),
    [anon_sym_AMP_AMP] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2755),
    [anon_sym_GT_GT] = ACTIONS(2755),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_SLASH] = ACTIONS(2755),
    [anon_sym_PERCENT] = ACTIONS(2755),
    [sym_comment] = ACTIONS(87),
  },
  [3454] = {
    [sym__heredoc_body_start] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_RPAREN] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7925),
    [anon_sym_COMMA] = ACTIONS(7925),
    [anon_sym_EQ] = ACTIONS(7925),
    [anon_sym_in] = ACTIONS(7925),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_RBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [3455] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(346),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(352),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(352),
    [sym__argument] = STATE(6088),
    [sym_splat_argument] = STATE(6088),
    [sym_hash_splat_argument] = STATE(6088),
    [sym_block_argument] = STATE(6088),
    [sym_assignment] = STATE(346),
    [sym_operator_assignment] = STATE(346),
    [sym_conditional] = STATE(346),
    [sym_range] = STATE(346),
    [sym_binary] = STATE(346),
    [sym_unary] = STATE(346),
    [sym_left_assignment_list] = STATE(351),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(352),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(352),
    [sym_false] = STATE(352),
    [sym_nil] = STATE(352),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(353),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(6088),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(593),
    [sym__splat_star] = ACTIONS(595),
    [sym__unary_minus] = ACTIONS(597),
    [sym__identifier_hash_key] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(9402),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3456] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(346),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(352),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(352),
    [sym__argument] = STATE(3454),
    [sym_splat_argument] = STATE(3454),
    [sym_hash_splat_argument] = STATE(3454),
    [sym_block_argument] = STATE(3454),
    [sym_assignment] = STATE(346),
    [sym_operator_assignment] = STATE(346),
    [sym_conditional] = STATE(346),
    [sym_range] = STATE(346),
    [sym_binary] = STATE(346),
    [sym_unary] = STATE(346),
    [sym_left_assignment_list] = STATE(351),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(352),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(352),
    [sym_false] = STATE(352),
    [sym_nil] = STATE(352),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(353),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_heredoc_body] = STATE(6089),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(3454),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(593),
    [sym__splat_star] = ACTIONS(595),
    [sym__unary_minus] = ACTIONS(597),
    [sym__identifier_hash_key] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(9402),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3457] = {
    [anon_sym_RPAREN] = ACTIONS(9402),
    [anon_sym_RBRACK] = ACTIONS(9402),
    [sym_comment] = ACTIONS(87),
  },
  [3458] = {
    [aux_sym_argument_list_repeat1] = STATE(3458),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [anon_sym_COMMA] = ACTIONS(9404),
    [anon_sym_RBRACK] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [3459] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(6091),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(352),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(352),
    [sym_assignment] = STATE(6091),
    [sym_operator_assignment] = STATE(6091),
    [sym_conditional] = STATE(6091),
    [sym_range] = STATE(6091),
    [sym_binary] = STATE(6091),
    [sym_unary] = STATE(6091),
    [sym_left_assignment_list] = STATE(351),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(352),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(352),
    [sym_false] = STATE(352),
    [sym_nil] = STATE(352),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1291),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3460] = {
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(2359),
    [sym__binary_star] = ACTIONS(2361),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(2363),
    [anon_sym_STAR_STAR] = ACTIONS(2361),
    [anon_sym_AMP] = ACTIONS(2365),
    [anon_sym_LT] = ACTIONS(2367),
    [anon_sym_EQ_GT] = ACTIONS(5115),
    [anon_sym_RBRACK] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(2369),
    [anon_sym_DOT_DOT] = ACTIONS(2371),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2373),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(2377),
    [anon_sym_AMP_AMP] = ACTIONS(2377),
    [anon_sym_LT_LT] = ACTIONS(2379),
    [anon_sym_GT_GT] = ACTIONS(2379),
    [anon_sym_EQ_EQ] = ACTIONS(2381),
    [anon_sym_BANG_EQ] = ACTIONS(2377),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2377),
    [anon_sym_LT_EQ_GT] = ACTIONS(2377),
    [anon_sym_EQ_TILDE] = ACTIONS(2377),
    [anon_sym_BANG_TILDE] = ACTIONS(2377),
    [anon_sym_LT_EQ] = ACTIONS(2367),
    [anon_sym_GT] = ACTIONS(2367),
    [anon_sym_GT_EQ] = ACTIONS(2383),
    [anon_sym_CARET] = ACTIONS(2385),
    [anon_sym_PLUS] = ACTIONS(2359),
    [anon_sym_SLASH] = ACTIONS(2361),
    [anon_sym_PERCENT] = ACTIONS(2361),
    [sym_comment] = ACTIONS(87),
  },
  [3461] = {
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_RBRACE] = ACTIONS(6191),
    [anon_sym_RPAREN] = ACTIONS(6191),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_RBRACK] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [3462] = {
    [aux_sym_exceptions_repeat1] = STATE(6093),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_RBRACK] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [3463] = {
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(2359),
    [sym__binary_star] = ACTIONS(2361),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(2363),
    [anon_sym_STAR_STAR] = ACTIONS(2361),
    [anon_sym_AMP] = ACTIONS(2365),
    [anon_sym_LT] = ACTIONS(2367),
    [anon_sym_EQ_GT] = ACTIONS(6210),
    [anon_sym_RBRACK] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(2369),
    [anon_sym_DOT_DOT] = ACTIONS(2371),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2373),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(2377),
    [anon_sym_AMP_AMP] = ACTIONS(2377),
    [anon_sym_LT_LT] = ACTIONS(2379),
    [anon_sym_GT_GT] = ACTIONS(2379),
    [anon_sym_EQ_EQ] = ACTIONS(2381),
    [anon_sym_BANG_EQ] = ACTIONS(2377),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2377),
    [anon_sym_LT_EQ_GT] = ACTIONS(2377),
    [anon_sym_EQ_TILDE] = ACTIONS(2377),
    [anon_sym_BANG_TILDE] = ACTIONS(2377),
    [anon_sym_LT_EQ] = ACTIONS(2367),
    [anon_sym_GT] = ACTIONS(2367),
    [anon_sym_GT_EQ] = ACTIONS(2383),
    [anon_sym_CARET] = ACTIONS(2385),
    [anon_sym_PLUS] = ACTIONS(2359),
    [anon_sym_SLASH] = ACTIONS(2361),
    [anon_sym_PERCENT] = ACTIONS(2361),
    [sym_comment] = ACTIONS(87),
  },
  [3464] = {
    [sym_string] = STATE(3464),
    [aux_sym_chained_string_repeat1] = STATE(3464),
    [sym__string_start] = ACTIONS(9407),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_EQ_GT] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_RBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [3465] = {
    [anon_sym_PIPE] = ACTIONS(9410),
    [anon_sym_SEMI] = ACTIONS(9412),
    [sym_comment] = ACTIONS(87),
  },
  [3466] = {
    [sym__simple_symbol] = ACTIONS(9414),
    [sym__string_start] = ACTIONS(9414),
    [sym__symbol_start] = ACTIONS(9414),
    [sym__subshell_start] = ACTIONS(9414),
    [sym__regex_start] = ACTIONS(9414),
    [sym__string_array_start] = ACTIONS(9414),
    [sym__symbol_array_start] = ACTIONS(9414),
    [sym_heredoc_beginning] = ACTIONS(9414),
    [sym__unary_minus] = ACTIONS(9414),
    [anon_sym_BEGIN] = ACTIONS(9416),
    [anon_sym_LBRACE] = ACTIONS(9414),
    [anon_sym_RBRACE] = ACTIONS(9414),
    [anon_sym_END] = ACTIONS(9416),
    [anon_sym_def] = ACTIONS(9416),
    [anon_sym_LPAREN] = ACTIONS(9414),
    [anon_sym_COLON_COLON] = ACTIONS(9414),
    [anon_sym_SEMI] = ACTIONS(9414),
    [anon_sym_STAR] = ACTIONS(9414),
    [anon_sym_class] = ACTIONS(9416),
    [anon_sym_module] = ACTIONS(9416),
    [anon_sym_return] = ACTIONS(9416),
    [anon_sym_yield] = ACTIONS(9416),
    [anon_sym_break] = ACTIONS(9416),
    [anon_sym_next] = ACTIONS(9416),
    [sym_redo] = ACTIONS(9416),
    [sym_retry] = ACTIONS(9416),
    [anon_sym_if] = ACTIONS(9416),
    [anon_sym_unless] = ACTIONS(9416),
    [anon_sym_while] = ACTIONS(9416),
    [anon_sym_until] = ACTIONS(9416),
    [anon_sym_for] = ACTIONS(9416),
    [anon_sym_case] = ACTIONS(9416),
    [anon_sym_begin] = ACTIONS(9416),
    [anon_sym_PLUS] = ACTIONS(9416),
    [anon_sym_defined_QMARK] = ACTIONS(9414),
    [anon_sym_not] = ACTIONS(9416),
    [anon_sym_BANG] = ACTIONS(9414),
    [anon_sym_TILDE] = ACTIONS(9414),
    [sym_constant] = ACTIONS(9416),
    [sym_identifier] = ACTIONS(9416),
    [sym_instance_variable] = ACTIONS(9414),
    [sym_class_variable] = ACTIONS(9414),
    [sym_global_variable] = ACTIONS(9414),
    [anon_sym_undef] = ACTIONS(9416),
    [anon_sym_alias] = ACTIONS(9416),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(9416),
    [sym_float] = ACTIONS(9416),
    [sym_complex] = ACTIONS(9414),
    [sym_super] = ACTIONS(9416),
    [anon_sym_true] = ACTIONS(9416),
    [anon_sym_TRUE] = ACTIONS(9416),
    [anon_sym_false] = ACTIONS(9416),
    [anon_sym_FALSE] = ACTIONS(9416),
    [sym_self] = ACTIONS(9416),
    [anon_sym_nil] = ACTIONS(9416),
    [anon_sym_NIL] = ACTIONS(9416),
    [sym_character] = ACTIONS(9414),
    [anon_sym_LBRACK2] = ACTIONS(9414),
    [anon_sym_DASH_GT] = ACTIONS(9414),
  },
  [3467] = {
    [sym_identifier] = ACTIONS(9418),
    [sym_comment] = ACTIONS(87),
  },
  [3468] = {
    [anon_sym_COMMA] = ACTIONS(2473),
    [anon_sym_PIPE] = ACTIONS(2473),
    [anon_sym_SEMI] = ACTIONS(2473),
    [anon_sym_COLON] = ACTIONS(9420),
    [anon_sym_EQ] = ACTIONS(9422),
    [sym_comment] = ACTIONS(87),
  },
  [3469] = {
    [aux_sym_method_parameters_repeat1] = STATE(6100),
    [anon_sym_COMMA] = ACTIONS(9424),
    [anon_sym_PIPE] = ACTIONS(9410),
    [anon_sym_SEMI] = ACTIONS(9412),
    [sym_comment] = ACTIONS(87),
  },
  [3470] = {
    [sym__line_break] = ACTIONS(9426),
    [sym__heredoc_body_start] = ACTIONS(9426),
    [sym__binary_minus] = ACTIONS(9426),
    [sym__binary_star] = ACTIONS(9426),
    [ts_builtin_sym_end] = ACTIONS(9426),
    [anon_sym___END__] = ACTIONS(9426),
    [anon_sym_LBRACE] = ACTIONS(9426),
    [anon_sym_RBRACE] = ACTIONS(9426),
    [anon_sym_RPAREN] = ACTIONS(9426),
    [anon_sym_DOT] = ACTIONS(9428),
    [anon_sym_COMMA] = ACTIONS(9426),
    [anon_sym_PIPE] = ACTIONS(9428),
    [anon_sym_SEMI] = ACTIONS(9426),
    [anon_sym_STAR_STAR] = ACTIONS(9426),
    [anon_sym_AMP] = ACTIONS(9428),
    [anon_sym_LT] = ACTIONS(9428),
    [anon_sym_end] = ACTIONS(9426),
    [anon_sym_if] = ACTIONS(9426),
    [anon_sym_unless] = ACTIONS(9426),
    [anon_sym_while] = ACTIONS(9426),
    [anon_sym_until] = ACTIONS(9426),
    [anon_sym_rescue] = ACTIONS(9426),
    [anon_sym_do] = ACTIONS(9426),
    [anon_sym_when] = ACTIONS(9426),
    [anon_sym_elsif] = ACTIONS(9426),
    [anon_sym_else] = ACTIONS(9426),
    [anon_sym_then] = ACTIONS(9426),
    [anon_sym_ensure] = ACTIONS(9426),
    [anon_sym_EQ_GT] = ACTIONS(9426),
    [anon_sym_LBRACK] = ACTIONS(9426),
    [anon_sym_COLON_COLON2] = ACTIONS(9426),
    [anon_sym_AMP_DOT] = ACTIONS(9426),
    [anon_sym_QMARK] = ACTIONS(9426),
    [anon_sym_DOT_DOT] = ACTIONS(9428),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9426),
    [anon_sym_and] = ACTIONS(9426),
    [anon_sym_or] = ACTIONS(9426),
    [anon_sym_PIPE_PIPE] = ACTIONS(9426),
    [anon_sym_AMP_AMP] = ACTIONS(9426),
    [anon_sym_LT_LT] = ACTIONS(9426),
    [anon_sym_GT_GT] = ACTIONS(9426),
    [anon_sym_EQ_EQ] = ACTIONS(9428),
    [anon_sym_BANG_EQ] = ACTIONS(9426),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9426),
    [anon_sym_LT_EQ_GT] = ACTIONS(9426),
    [anon_sym_EQ_TILDE] = ACTIONS(9426),
    [anon_sym_BANG_TILDE] = ACTIONS(9426),
    [anon_sym_LT_EQ] = ACTIONS(9428),
    [anon_sym_GT] = ACTIONS(9428),
    [anon_sym_GT_EQ] = ACTIONS(9426),
    [anon_sym_CARET] = ACTIONS(9426),
    [anon_sym_PLUS] = ACTIONS(9426),
    [anon_sym_SLASH] = ACTIONS(9426),
    [anon_sym_PERCENT] = ACTIONS(9426),
    [sym_comment] = ACTIONS(87),
  },
  [3471] = {
    [anon_sym_RBRACE] = ACTIONS(9430),
    [sym_comment] = ACTIONS(87),
  },
  [3472] = {
    [aux_sym_method_parameters_repeat1] = STATE(6103),
    [anon_sym_RPAREN] = ACTIONS(9432),
    [anon_sym_COMMA] = ACTIONS(5757),
    [sym_comment] = ACTIONS(87),
  },
  [3473] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(6104),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(4471),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(4471),
    [sym_assignment] = STATE(6104),
    [sym_operator_assignment] = STATE(6104),
    [sym_conditional] = STATE(6104),
    [sym_range] = STATE(6104),
    [sym_binary] = STATE(6104),
    [sym_unary] = STATE(6104),
    [sym_left_assignment_list] = STATE(4470),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4471),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(4471),
    [sym_false] = STATE(4471),
    [sym_nil] = STATE(4471),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(4472),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(7296),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_RPAREN] = ACTIONS(5783),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_COMMA] = ACTIONS(5783),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7298),
    [anon_sym_yield] = ACTIONS(7300),
    [anon_sym_break] = ACTIONS(7302),
    [anon_sym_next] = ACTIONS(7304),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7306),
    [anon_sym_defined_QMARK] = ACTIONS(7308),
    [anon_sym_not] = ACTIONS(7310),
    [anon_sym_BANG] = ACTIONS(7312),
    [anon_sym_TILDE] = ACTIONS(7312),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3474] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(6105),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(4471),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(4471),
    [sym_assignment] = STATE(6105),
    [sym_operator_assignment] = STATE(6105),
    [sym_conditional] = STATE(6105),
    [sym_range] = STATE(6105),
    [sym_binary] = STATE(6105),
    [sym_unary] = STATE(6105),
    [sym_left_assignment_list] = STATE(4470),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4471),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(4471),
    [sym_false] = STATE(4471),
    [sym_nil] = STATE(4471),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(4472),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(7296),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7298),
    [anon_sym_yield] = ACTIONS(7300),
    [anon_sym_break] = ACTIONS(7302),
    [anon_sym_next] = ACTIONS(7304),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7306),
    [anon_sym_defined_QMARK] = ACTIONS(7308),
    [anon_sym_not] = ACTIONS(7310),
    [anon_sym_BANG] = ACTIONS(7312),
    [anon_sym_TILDE] = ACTIONS(7312),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3475] = {
    [anon_sym_LBRACE] = ACTIONS(9434),
    [anon_sym_do] = ACTIONS(9434),
    [sym_comment] = ACTIONS(87),
  },
  [3476] = {
    [sym__formal_parameter] = STATE(6106),
    [sym__simple_formal_parameter] = STATE(6106),
    [sym_destructured_parameter] = STATE(6106),
    [sym_splat_parameter] = STATE(6106),
    [sym_hash_splat_parameter] = STATE(6106),
    [sym_block_parameter] = STATE(6106),
    [sym_keyword_parameter] = STATE(6106),
    [sym_optional_parameter] = STATE(6106),
    [anon_sym_LPAREN] = ACTIONS(2447),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [sym_identifier] = ACTIONS(2451),
    [sym_comment] = ACTIONS(87),
  },
  [3477] = {
    [aux_sym_method_parameters_repeat1] = STATE(6108),
    [anon_sym_RPAREN] = ACTIONS(9436),
    [anon_sym_COMMA] = ACTIONS(5757),
    [sym_comment] = ACTIONS(87),
  },
  [3478] = {
    [anon_sym_PIPE] = ACTIONS(9438),
    [anon_sym_SEMI] = ACTIONS(9440),
    [sym_comment] = ACTIONS(87),
  },
  [3479] = {
    [sym__line_break] = ACTIONS(9414),
    [sym__simple_symbol] = ACTIONS(9414),
    [sym__string_start] = ACTIONS(9414),
    [sym__symbol_start] = ACTIONS(9414),
    [sym__subshell_start] = ACTIONS(9414),
    [sym__regex_start] = ACTIONS(9414),
    [sym__string_array_start] = ACTIONS(9414),
    [sym__symbol_array_start] = ACTIONS(9414),
    [sym__heredoc_body_start] = ACTIONS(9414),
    [sym_heredoc_beginning] = ACTIONS(9414),
    [sym__unary_minus] = ACTIONS(9414),
    [anon_sym_BEGIN] = ACTIONS(9416),
    [anon_sym_LBRACE] = ACTIONS(9414),
    [anon_sym_END] = ACTIONS(9416),
    [anon_sym_def] = ACTIONS(9416),
    [anon_sym_LPAREN] = ACTIONS(9414),
    [anon_sym_COLON_COLON] = ACTIONS(9414),
    [anon_sym_SEMI] = ACTIONS(9414),
    [anon_sym_STAR] = ACTIONS(9414),
    [anon_sym_class] = ACTIONS(9416),
    [anon_sym_module] = ACTIONS(9416),
    [anon_sym_end] = ACTIONS(9416),
    [anon_sym_return] = ACTIONS(9416),
    [anon_sym_yield] = ACTIONS(9416),
    [anon_sym_break] = ACTIONS(9416),
    [anon_sym_next] = ACTIONS(9416),
    [sym_redo] = ACTIONS(9416),
    [sym_retry] = ACTIONS(9416),
    [anon_sym_if] = ACTIONS(9416),
    [anon_sym_unless] = ACTIONS(9416),
    [anon_sym_while] = ACTIONS(9416),
    [anon_sym_until] = ACTIONS(9416),
    [anon_sym_for] = ACTIONS(9416),
    [anon_sym_case] = ACTIONS(9416),
    [anon_sym_begin] = ACTIONS(9416),
    [anon_sym_PLUS] = ACTIONS(9416),
    [anon_sym_defined_QMARK] = ACTIONS(9414),
    [anon_sym_not] = ACTIONS(9416),
    [anon_sym_BANG] = ACTIONS(9414),
    [anon_sym_TILDE] = ACTIONS(9414),
    [sym_constant] = ACTIONS(9416),
    [sym_identifier] = ACTIONS(9416),
    [sym_instance_variable] = ACTIONS(9414),
    [sym_class_variable] = ACTIONS(9414),
    [sym_global_variable] = ACTIONS(9414),
    [anon_sym_undef] = ACTIONS(9416),
    [anon_sym_alias] = ACTIONS(9416),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(9416),
    [sym_float] = ACTIONS(9416),
    [sym_complex] = ACTIONS(9414),
    [sym_super] = ACTIONS(9416),
    [anon_sym_true] = ACTIONS(9416),
    [anon_sym_TRUE] = ACTIONS(9416),
    [anon_sym_false] = ACTIONS(9416),
    [anon_sym_FALSE] = ACTIONS(9416),
    [sym_self] = ACTIONS(9416),
    [anon_sym_nil] = ACTIONS(9416),
    [anon_sym_NIL] = ACTIONS(9416),
    [sym_character] = ACTIONS(9414),
    [anon_sym_LBRACK2] = ACTIONS(9414),
    [anon_sym_DASH_GT] = ACTIONS(9414),
  },
  [3480] = {
    [sym_identifier] = ACTIONS(9442),
    [sym_comment] = ACTIONS(87),
  },
  [3481] = {
    [aux_sym_method_parameters_repeat1] = STATE(6113),
    [anon_sym_COMMA] = ACTIONS(9444),
    [anon_sym_PIPE] = ACTIONS(9438),
    [anon_sym_SEMI] = ACTIONS(9440),
    [sym_comment] = ACTIONS(87),
  },
  [3482] = {
    [sym__line_break] = ACTIONS(9446),
    [sym__heredoc_body_start] = ACTIONS(9446),
    [sym__binary_minus] = ACTIONS(9446),
    [sym__binary_star] = ACTIONS(9446),
    [ts_builtin_sym_end] = ACTIONS(9446),
    [anon_sym___END__] = ACTIONS(9446),
    [anon_sym_LBRACE] = ACTIONS(9446),
    [anon_sym_RBRACE] = ACTIONS(9446),
    [anon_sym_RPAREN] = ACTIONS(9446),
    [anon_sym_DOT] = ACTIONS(9448),
    [anon_sym_COMMA] = ACTIONS(9446),
    [anon_sym_PIPE] = ACTIONS(9448),
    [anon_sym_SEMI] = ACTIONS(9446),
    [anon_sym_STAR_STAR] = ACTIONS(9446),
    [anon_sym_AMP] = ACTIONS(9448),
    [anon_sym_LT] = ACTIONS(9448),
    [anon_sym_end] = ACTIONS(9446),
    [anon_sym_if] = ACTIONS(9446),
    [anon_sym_unless] = ACTIONS(9446),
    [anon_sym_while] = ACTIONS(9446),
    [anon_sym_until] = ACTIONS(9446),
    [anon_sym_rescue] = ACTIONS(9446),
    [anon_sym_do] = ACTIONS(9446),
    [anon_sym_when] = ACTIONS(9446),
    [anon_sym_elsif] = ACTIONS(9446),
    [anon_sym_else] = ACTIONS(9446),
    [anon_sym_then] = ACTIONS(9446),
    [anon_sym_ensure] = ACTIONS(9446),
    [anon_sym_EQ_GT] = ACTIONS(9446),
    [anon_sym_LBRACK] = ACTIONS(9446),
    [anon_sym_COLON_COLON2] = ACTIONS(9446),
    [anon_sym_AMP_DOT] = ACTIONS(9446),
    [anon_sym_QMARK] = ACTIONS(9446),
    [anon_sym_DOT_DOT] = ACTIONS(9448),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9446),
    [anon_sym_and] = ACTIONS(9446),
    [anon_sym_or] = ACTIONS(9446),
    [anon_sym_PIPE_PIPE] = ACTIONS(9446),
    [anon_sym_AMP_AMP] = ACTIONS(9446),
    [anon_sym_LT_LT] = ACTIONS(9446),
    [anon_sym_GT_GT] = ACTIONS(9446),
    [anon_sym_EQ_EQ] = ACTIONS(9448),
    [anon_sym_BANG_EQ] = ACTIONS(9446),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9446),
    [anon_sym_LT_EQ_GT] = ACTIONS(9446),
    [anon_sym_EQ_TILDE] = ACTIONS(9446),
    [anon_sym_BANG_TILDE] = ACTIONS(9446),
    [anon_sym_LT_EQ] = ACTIONS(9448),
    [anon_sym_GT] = ACTIONS(9448),
    [anon_sym_GT_EQ] = ACTIONS(9446),
    [anon_sym_CARET] = ACTIONS(9446),
    [anon_sym_PLUS] = ACTIONS(9446),
    [anon_sym_SLASH] = ACTIONS(9446),
    [anon_sym_PERCENT] = ACTIONS(9446),
    [sym_comment] = ACTIONS(87),
  },
  [3483] = {
    [anon_sym_end] = ACTIONS(9450),
    [sym_comment] = ACTIONS(87),
  },
  [3484] = {
    [sym__statements] = STATE(6115),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9452),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3485] = {
    [sym__statements] = STATE(6115),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_heredoc_body] = STATE(6116),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [sym__terminator] = STATE(6116),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__line_break] = ACTIONS(9454),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(9454),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9452),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3486] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(6117),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(3496),
    [sym_scope_resolution] = STATE(3494),
    [sym_call] = STATE(3494),
    [sym_method_call] = STATE(3496),
    [sym_assignment] = STATE(6117),
    [sym_operator_assignment] = STATE(6117),
    [sym_conditional] = STATE(6117),
    [sym_range] = STATE(6117),
    [sym_binary] = STATE(6117),
    [sym_unary] = STATE(6117),
    [sym_left_assignment_list] = STATE(3495),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3496),
    [sym__variable] = STATE(3494),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(3496),
    [sym_false] = STATE(3496),
    [sym_nil] = STATE(3496),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(5781),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5785),
    [anon_sym_yield] = ACTIONS(5787),
    [anon_sym_break] = ACTIONS(5789),
    [anon_sym_next] = ACTIONS(5791),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5795),
    [anon_sym_defined_QMARK] = ACTIONS(5797),
    [anon_sym_not] = ACTIONS(5799),
    [anon_sym_BANG] = ACTIONS(5801),
    [anon_sym_TILDE] = ACTIONS(5801),
    [sym_constant] = ACTIONS(5803),
    [sym_identifier] = ACTIONS(5803),
    [sym_instance_variable] = ACTIONS(5805),
    [sym_class_variable] = ACTIONS(5805),
    [sym_global_variable] = ACTIONS(5805),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(5803),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(5803),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3487] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4841),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym_argument_list] = STATE(563),
    [sym__argument_list_with_parens] = STATE(4842),
    [sym__argument] = STATE(4843),
    [sym_splat_argument] = STATE(4843),
    [sym_hash_splat_argument] = STATE(4843),
    [sym_block_argument] = STATE(4843),
    [sym_assignment] = STATE(4841),
    [sym_operator_assignment] = STATE(4841),
    [sym_conditional] = STATE(4841),
    [sym_range] = STATE(4841),
    [sym_binary] = STATE(4841),
    [sym_unary] = STATE(4841),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4844),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(4843),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(7768),
    [sym__splat_star] = ACTIONS(7770),
    [sym__unary_minus] = ACTIONS(1525),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(7772),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(4161),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(7774),
    [sym_identifier] = ACTIONS(7774),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3488] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4841),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym_argument_list] = STATE(569),
    [sym__argument_list_with_parens] = STATE(4842),
    [sym__argument] = STATE(4843),
    [sym_splat_argument] = STATE(4843),
    [sym_hash_splat_argument] = STATE(4843),
    [sym_block_argument] = STATE(4843),
    [sym_assignment] = STATE(4841),
    [sym_operator_assignment] = STATE(4841),
    [sym_conditional] = STATE(4841),
    [sym_range] = STATE(4841),
    [sym_binary] = STATE(4841),
    [sym_unary] = STATE(4841),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4844),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(4843),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(7768),
    [sym__splat_star] = ACTIONS(7770),
    [sym__unary_minus] = ACTIONS(1525),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(7772),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(4161),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(7774),
    [sym_identifier] = ACTIONS(7774),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3489] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4841),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym_argument_list] = STATE(570),
    [sym__argument_list_with_parens] = STATE(4842),
    [sym__argument] = STATE(4843),
    [sym_splat_argument] = STATE(4843),
    [sym_hash_splat_argument] = STATE(4843),
    [sym_block_argument] = STATE(4843),
    [sym_assignment] = STATE(4841),
    [sym_operator_assignment] = STATE(4841),
    [sym_conditional] = STATE(4841),
    [sym_range] = STATE(4841),
    [sym_binary] = STATE(4841),
    [sym_unary] = STATE(4841),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4844),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(4843),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(7768),
    [sym__splat_star] = ACTIONS(7770),
    [sym__unary_minus] = ACTIONS(1525),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(7772),
    [anon_sym_LBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(4161),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(7774),
    [sym_identifier] = ACTIONS(7774),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3490] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4841),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym_argument_list] = STATE(571),
    [sym__argument_list_with_parens] = STATE(4842),
    [sym__argument] = STATE(4843),
    [sym_splat_argument] = STATE(4843),
    [sym_hash_splat_argument] = STATE(4843),
    [sym_block_argument] = STATE(4843),
    [sym_assignment] = STATE(4841),
    [sym_operator_assignment] = STATE(4841),
    [sym_conditional] = STATE(4841),
    [sym_range] = STATE(4841),
    [sym_binary] = STATE(4841),
    [sym_unary] = STATE(4841),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4844),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(4843),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(7768),
    [sym__splat_star] = ACTIONS(7770),
    [sym__unary_minus] = ACTIONS(1525),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(7772),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(4161),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(7774),
    [sym_identifier] = ACTIONS(7774),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3491] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(6118),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(3496),
    [sym_scope_resolution] = STATE(3494),
    [sym_call] = STATE(3494),
    [sym_method_call] = STATE(3496),
    [sym_assignment] = STATE(6118),
    [sym_operator_assignment] = STATE(6118),
    [sym_conditional] = STATE(6118),
    [sym_range] = STATE(6118),
    [sym_binary] = STATE(6118),
    [sym_unary] = STATE(6118),
    [sym_left_assignment_list] = STATE(3495),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3496),
    [sym__variable] = STATE(3494),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(3496),
    [sym_false] = STATE(3496),
    [sym_nil] = STATE(3496),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(5781),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5785),
    [anon_sym_yield] = ACTIONS(5787),
    [anon_sym_break] = ACTIONS(5789),
    [anon_sym_next] = ACTIONS(5791),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5795),
    [anon_sym_defined_QMARK] = ACTIONS(5797),
    [anon_sym_not] = ACTIONS(5799),
    [anon_sym_BANG] = ACTIONS(5801),
    [anon_sym_TILDE] = ACTIONS(5801),
    [sym_constant] = ACTIONS(5803),
    [sym_identifier] = ACTIONS(5803),
    [sym_instance_variable] = ACTIONS(5805),
    [sym_class_variable] = ACTIONS(5805),
    [sym_global_variable] = ACTIONS(5805),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(5803),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(5803),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3492] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(586),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(3496),
    [sym_scope_resolution] = STATE(3494),
    [sym_call] = STATE(3494),
    [sym_method_call] = STATE(3496),
    [sym_assignment] = STATE(586),
    [sym_operator_assignment] = STATE(586),
    [sym_conditional] = STATE(586),
    [sym_range] = STATE(586),
    [sym_binary] = STATE(586),
    [sym_unary] = STATE(586),
    [sym_left_assignment_list] = STATE(3495),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3496),
    [sym__variable] = STATE(3494),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(3496),
    [sym_false] = STATE(3496),
    [sym_nil] = STATE(3496),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(5781),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5785),
    [anon_sym_yield] = ACTIONS(5787),
    [anon_sym_break] = ACTIONS(5789),
    [anon_sym_next] = ACTIONS(5791),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5795),
    [anon_sym_defined_QMARK] = ACTIONS(5797),
    [anon_sym_not] = ACTIONS(5799),
    [anon_sym_BANG] = ACTIONS(5801),
    [anon_sym_TILDE] = ACTIONS(5801),
    [sym_constant] = ACTIONS(5803),
    [sym_identifier] = ACTIONS(5803),
    [sym_instance_variable] = ACTIONS(5805),
    [sym_class_variable] = ACTIONS(5805),
    [sym_global_variable] = ACTIONS(5805),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(5803),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(5803),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3493] = {
    [sym__binary_minus] = ACTIONS(9456),
    [sym__binary_star] = ACTIONS(9458),
    [anon_sym_LBRACE] = ACTIONS(9460),
    [anon_sym_COMMA] = ACTIONS(9460),
    [anon_sym_PIPE] = ACTIONS(9462),
    [anon_sym_STAR_STAR] = ACTIONS(9458),
    [anon_sym_AMP] = ACTIONS(9464),
    [anon_sym_LT] = ACTIONS(9466),
    [anon_sym_do] = ACTIONS(9460),
    [anon_sym_QMARK] = ACTIONS(9468),
    [anon_sym_DOT_DOT] = ACTIONS(9470),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9472),
    [anon_sym_and] = ACTIONS(9474),
    [anon_sym_or] = ACTIONS(9474),
    [anon_sym_PIPE_PIPE] = ACTIONS(9476),
    [anon_sym_AMP_AMP] = ACTIONS(9476),
    [anon_sym_LT_LT] = ACTIONS(9478),
    [anon_sym_GT_GT] = ACTIONS(9478),
    [anon_sym_EQ_EQ] = ACTIONS(9480),
    [anon_sym_BANG_EQ] = ACTIONS(9476),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9476),
    [anon_sym_LT_EQ_GT] = ACTIONS(9476),
    [anon_sym_EQ_TILDE] = ACTIONS(9476),
    [anon_sym_BANG_TILDE] = ACTIONS(9476),
    [anon_sym_LT_EQ] = ACTIONS(9466),
    [anon_sym_GT] = ACTIONS(9466),
    [anon_sym_GT_EQ] = ACTIONS(9482),
    [anon_sym_CARET] = ACTIONS(9484),
    [anon_sym_PLUS] = ACTIONS(9456),
    [anon_sym_SLASH] = ACTIONS(9458),
    [anon_sym_PERCENT] = ACTIONS(9458),
    [sym_comment] = ACTIONS(87),
  },
  [3494] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4683),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_argument_list] = STATE(6130),
    [sym__argument_list_with_parens] = STATE(4684),
    [sym__argument] = STATE(4685),
    [sym_splat_argument] = STATE(4685),
    [sym_hash_splat_argument] = STATE(4685),
    [sym_block_argument] = STATE(4685),
    [sym_do_block] = STATE(1684),
    [sym_block] = STATE(1684),
    [sym_assignment] = STATE(4683),
    [sym_operator_assignment] = STATE(4683),
    [sym_conditional] = STATE(4683),
    [sym_range] = STATE(4683),
    [sym_binary] = STATE(4683),
    [sym_unary] = STATE(4683),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4686),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(4685),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(7603),
    [sym__splat_star] = ACTIONS(7605),
    [sym__unary_minus] = ACTIONS(1159),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(7607),
    [anon_sym_LBRACE] = ACTIONS(9486),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(769),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1205),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(7609),
    [sym_identifier] = ACTIONS(7609),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3495] = {
    [anon_sym_EQ] = ACTIONS(9488),
    [sym_comment] = ACTIONS(87),
  },
  [3496] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(9490),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(9492),
    [anon_sym_DASH_EQ] = ACTIONS(9492),
    [anon_sym_STAR_EQ] = ACTIONS(9492),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9492),
    [anon_sym_SLASH_EQ] = ACTIONS(9492),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9492),
    [anon_sym_PIPE_EQ] = ACTIONS(9492),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9492),
    [anon_sym_AMP_EQ] = ACTIONS(9492),
    [anon_sym_PERCENT_EQ] = ACTIONS(9492),
    [anon_sym_GT_GT_EQ] = ACTIONS(9492),
    [anon_sym_LT_LT_EQ] = ACTIONS(9492),
    [anon_sym_CARET_EQ] = ACTIONS(9492),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3497] = {
    [sym_string] = STATE(6133),
    [aux_sym_chained_string_repeat1] = STATE(6133),
    [sym__string_start] = ACTIONS(139),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [3498] = {
    [sym__binary_minus] = ACTIONS(9456),
    [sym__binary_star] = ACTIONS(9458),
    [anon_sym_LBRACE] = ACTIONS(9494),
    [anon_sym_COMMA] = ACTIONS(9494),
    [anon_sym_PIPE] = ACTIONS(9462),
    [anon_sym_STAR_STAR] = ACTIONS(9458),
    [anon_sym_AMP] = ACTIONS(9464),
    [anon_sym_LT] = ACTIONS(9466),
    [anon_sym_do] = ACTIONS(9494),
    [anon_sym_QMARK] = ACTIONS(9468),
    [anon_sym_DOT_DOT] = ACTIONS(9470),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9472),
    [anon_sym_and] = ACTIONS(9474),
    [anon_sym_or] = ACTIONS(9474),
    [anon_sym_PIPE_PIPE] = ACTIONS(9476),
    [anon_sym_AMP_AMP] = ACTIONS(9476),
    [anon_sym_LT_LT] = ACTIONS(9478),
    [anon_sym_GT_GT] = ACTIONS(9478),
    [anon_sym_EQ_EQ] = ACTIONS(9480),
    [anon_sym_BANG_EQ] = ACTIONS(9476),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9476),
    [anon_sym_LT_EQ_GT] = ACTIONS(9476),
    [anon_sym_EQ_TILDE] = ACTIONS(9476),
    [anon_sym_BANG_TILDE] = ACTIONS(9476),
    [anon_sym_LT_EQ] = ACTIONS(9466),
    [anon_sym_GT] = ACTIONS(9466),
    [anon_sym_GT_EQ] = ACTIONS(9482),
    [anon_sym_CARET] = ACTIONS(9484),
    [anon_sym_PLUS] = ACTIONS(9456),
    [anon_sym_SLASH] = ACTIONS(9458),
    [anon_sym_PERCENT] = ACTIONS(9458),
    [sym_comment] = ACTIONS(87),
  },
  [3499] = {
    [anon_sym_LBRACE] = ACTIONS(9496),
    [anon_sym_COMMA] = ACTIONS(9496),
    [anon_sym_do] = ACTIONS(9496),
    [sym_comment] = ACTIONS(87),
  },
  [3500] = {
    [aux_sym_lambda_parameters_repeat1] = STATE(3500),
    [anon_sym_LBRACE] = ACTIONS(9496),
    [anon_sym_COMMA] = ACTIONS(9498),
    [anon_sym_do] = ACTIONS(9496),
    [sym_comment] = ACTIONS(87),
  },
  [3501] = {
    [ts_builtin_sym_end] = ACTIONS(9501),
    [sym_comment] = ACTIONS(87),
  },
  [3502] = {
    [sym__string_start] = ACTIONS(835),
    [sym__binary_minus] = ACTIONS(835),
    [sym__binary_star] = ACTIONS(835),
    [anon_sym_DOT] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(835),
    [anon_sym_PIPE] = ACTIONS(837),
    [anon_sym_STAR_STAR] = ACTIONS(835),
    [anon_sym_AMP] = ACTIONS(837),
    [anon_sym_LT] = ACTIONS(837),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_COLON_COLON2] = ACTIONS(835),
    [anon_sym_AMP_DOT] = ACTIONS(835),
    [anon_sym_QMARK] = ACTIONS(835),
    [anon_sym_COLON2] = ACTIONS(837),
    [anon_sym_DOT_DOT] = ACTIONS(837),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(835),
    [anon_sym_and] = ACTIONS(835),
    [anon_sym_or] = ACTIONS(835),
    [anon_sym_PIPE_PIPE] = ACTIONS(835),
    [anon_sym_AMP_AMP] = ACTIONS(835),
    [anon_sym_LT_LT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(835),
    [anon_sym_EQ_EQ] = ACTIONS(837),
    [anon_sym_BANG_EQ] = ACTIONS(835),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(835),
    [anon_sym_LT_EQ_GT] = ACTIONS(835),
    [anon_sym_EQ_TILDE] = ACTIONS(835),
    [anon_sym_BANG_TILDE] = ACTIONS(835),
    [anon_sym_LT_EQ] = ACTIONS(837),
    [anon_sym_GT] = ACTIONS(837),
    [anon_sym_GT_EQ] = ACTIONS(835),
    [anon_sym_CARET] = ACTIONS(835),
    [anon_sym_PLUS] = ACTIONS(835),
    [anon_sym_SLASH] = ACTIONS(835),
    [anon_sym_PERCENT] = ACTIONS(835),
    [sym_comment] = ACTIONS(87),
  },
  [3503] = {
    [sym__string_end] = ACTIONS(9503),
    [sym_comment] = ACTIONS(87),
  },
  [3504] = {
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_COLON2] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [3505] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(6142),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(6145),
    [sym_scope_resolution] = STATE(6143),
    [sym_call] = STATE(6143),
    [sym_method_call] = STATE(6145),
    [sym_assignment] = STATE(6142),
    [sym_operator_assignment] = STATE(6142),
    [sym_conditional] = STATE(6142),
    [sym_range] = STATE(6142),
    [sym_binary] = STATE(6142),
    [sym_unary] = STATE(6142),
    [sym_left_assignment_list] = STATE(6144),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6145),
    [sym__variable] = STATE(6143),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(6145),
    [sym_false] = STATE(6145),
    [sym_nil] = STATE(6145),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(6146),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9505),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9507),
    [anon_sym_yield] = ACTIONS(9509),
    [anon_sym_break] = ACTIONS(9511),
    [anon_sym_next] = ACTIONS(9513),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9515),
    [anon_sym_defined_QMARK] = ACTIONS(9517),
    [anon_sym_not] = ACTIONS(9519),
    [anon_sym_BANG] = ACTIONS(9521),
    [anon_sym_TILDE] = ACTIONS(9521),
    [sym_constant] = ACTIONS(9523),
    [sym_identifier] = ACTIONS(9523),
    [sym_instance_variable] = ACTIONS(9525),
    [sym_class_variable] = ACTIONS(9525),
    [sym_global_variable] = ACTIONS(9525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(9523),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9523),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3506] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(6147),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(6145),
    [sym_scope_resolution] = STATE(6143),
    [sym_call] = STATE(6143),
    [sym_method_call] = STATE(6145),
    [sym_assignment] = STATE(6147),
    [sym_operator_assignment] = STATE(6147),
    [sym_conditional] = STATE(6147),
    [sym_range] = STATE(6147),
    [sym_binary] = STATE(6147),
    [sym_unary] = STATE(6147),
    [sym_left_assignment_list] = STATE(6144),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6145),
    [sym__variable] = STATE(6143),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(6145),
    [sym_false] = STATE(6145),
    [sym_nil] = STATE(6145),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(6146),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9505),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9507),
    [anon_sym_yield] = ACTIONS(9509),
    [anon_sym_break] = ACTIONS(9511),
    [anon_sym_next] = ACTIONS(9513),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9515),
    [anon_sym_defined_QMARK] = ACTIONS(9517),
    [anon_sym_not] = ACTIONS(9519),
    [anon_sym_BANG] = ACTIONS(9521),
    [anon_sym_TILDE] = ACTIONS(9521),
    [sym_constant] = ACTIONS(9523),
    [sym_identifier] = ACTIONS(9523),
    [sym_instance_variable] = ACTIONS(9525),
    [sym_class_variable] = ACTIONS(9525),
    [sym_global_variable] = ACTIONS(9525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(9523),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9523),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3507] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(6149),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(3522),
    [sym_scope_resolution] = STATE(3518),
    [sym_call] = STATE(3518),
    [sym_method_call] = STATE(3522),
    [sym_assignment] = STATE(6149),
    [sym_operator_assignment] = STATE(6149),
    [sym_conditional] = STATE(6149),
    [sym_range] = STATE(6149),
    [sym_binary] = STATE(6149),
    [sym_unary] = STATE(6149),
    [sym_left_assignment_list] = STATE(3521),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3522),
    [sym__variable] = STATE(3518),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(3522),
    [sym_false] = STATE(3522),
    [sym_nil] = STATE(3522),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(6150),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(9527),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(5835),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5839),
    [anon_sym_yield] = ACTIONS(5841),
    [anon_sym_break] = ACTIONS(5843),
    [anon_sym_next] = ACTIONS(5845),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9529),
    [anon_sym_defined_QMARK] = ACTIONS(5847),
    [anon_sym_not] = ACTIONS(5849),
    [anon_sym_BANG] = ACTIONS(5853),
    [anon_sym_TILDE] = ACTIONS(5853),
    [sym_constant] = ACTIONS(5859),
    [sym_identifier] = ACTIONS(5859),
    [sym_instance_variable] = ACTIONS(5857),
    [sym_class_variable] = ACTIONS(5857),
    [sym_global_variable] = ACTIONS(5857),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5859),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5859),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3508] = {
    [anon_sym_COLON] = ACTIONS(9531),
    [sym_comment] = ACTIONS(87),
  },
  [3509] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(6152),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(6145),
    [sym_scope_resolution] = STATE(6143),
    [sym_call] = STATE(6143),
    [sym_method_call] = STATE(6145),
    [sym_assignment] = STATE(6152),
    [sym_operator_assignment] = STATE(6152),
    [sym_conditional] = STATE(6152),
    [sym_range] = STATE(6152),
    [sym_binary] = STATE(6152),
    [sym_unary] = STATE(6152),
    [sym_left_assignment_list] = STATE(6144),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6145),
    [sym__variable] = STATE(6143),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(6145),
    [sym_false] = STATE(6145),
    [sym_nil] = STATE(6145),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(6146),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9505),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9507),
    [anon_sym_yield] = ACTIONS(9509),
    [anon_sym_break] = ACTIONS(9511),
    [anon_sym_next] = ACTIONS(9513),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9515),
    [anon_sym_defined_QMARK] = ACTIONS(9517),
    [anon_sym_not] = ACTIONS(9519),
    [anon_sym_BANG] = ACTIONS(9521),
    [anon_sym_TILDE] = ACTIONS(9521),
    [sym_constant] = ACTIONS(9523),
    [sym_identifier] = ACTIONS(9523),
    [sym_instance_variable] = ACTIONS(9525),
    [sym_class_variable] = ACTIONS(9525),
    [sym_global_variable] = ACTIONS(9525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(9523),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9523),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3510] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(6158),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(3522),
    [sym_scope_resolution] = STATE(3518),
    [sym_call] = STATE(3518),
    [sym_method_call] = STATE(3522),
    [sym_argument_list] = STATE(1318),
    [sym__argument_list_with_parens] = STATE(6159),
    [sym__argument] = STATE(6160),
    [sym_splat_argument] = STATE(6160),
    [sym_hash_splat_argument] = STATE(6160),
    [sym_block_argument] = STATE(6160),
    [sym_assignment] = STATE(6158),
    [sym_operator_assignment] = STATE(6158),
    [sym_conditional] = STATE(6158),
    [sym_range] = STATE(6158),
    [sym_binary] = STATE(6158),
    [sym_unary] = STATE(6158),
    [sym_left_assignment_list] = STATE(3521),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3522),
    [sym__variable] = STATE(3518),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(3522),
    [sym_false] = STATE(3522),
    [sym_nil] = STATE(3522),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(6161),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(6160),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(9533),
    [sym__splat_star] = ACTIONS(9535),
    [sym__unary_minus] = ACTIONS(5835),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(9537),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5839),
    [anon_sym_yield] = ACTIONS(5841),
    [anon_sym_break] = ACTIONS(5843),
    [anon_sym_next] = ACTIONS(5845),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_COLON2] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(5847),
    [anon_sym_not] = ACTIONS(5849),
    [anon_sym_BANG] = ACTIONS(5851),
    [anon_sym_TILDE] = ACTIONS(5853),
    [sym_constant] = ACTIONS(9539),
    [sym_identifier] = ACTIONS(9539),
    [sym_instance_variable] = ACTIONS(5857),
    [sym_class_variable] = ACTIONS(5857),
    [sym_global_variable] = ACTIONS(5857),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5859),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5859),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3511] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(6158),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(3522),
    [sym_scope_resolution] = STATE(3518),
    [sym_call] = STATE(3518),
    [sym_method_call] = STATE(3522),
    [sym_argument_list] = STATE(1324),
    [sym__argument_list_with_parens] = STATE(6159),
    [sym__argument] = STATE(6160),
    [sym_splat_argument] = STATE(6160),
    [sym_hash_splat_argument] = STATE(6160),
    [sym_block_argument] = STATE(6160),
    [sym_assignment] = STATE(6158),
    [sym_operator_assignment] = STATE(6158),
    [sym_conditional] = STATE(6158),
    [sym_range] = STATE(6158),
    [sym_binary] = STATE(6158),
    [sym_unary] = STATE(6158),
    [sym_left_assignment_list] = STATE(3521),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3522),
    [sym__variable] = STATE(3518),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(3522),
    [sym_false] = STATE(3522),
    [sym_nil] = STATE(3522),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(6161),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(6160),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(9533),
    [sym__splat_star] = ACTIONS(9535),
    [sym__unary_minus] = ACTIONS(5835),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(9537),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5839),
    [anon_sym_yield] = ACTIONS(5841),
    [anon_sym_break] = ACTIONS(5843),
    [anon_sym_next] = ACTIONS(5845),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_COLON2] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(5847),
    [anon_sym_not] = ACTIONS(5849),
    [anon_sym_BANG] = ACTIONS(5851),
    [anon_sym_TILDE] = ACTIONS(5853),
    [sym_constant] = ACTIONS(9539),
    [sym_identifier] = ACTIONS(9539),
    [sym_instance_variable] = ACTIONS(5857),
    [sym_class_variable] = ACTIONS(5857),
    [sym_global_variable] = ACTIONS(5857),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5859),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5859),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3512] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(6158),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(3522),
    [sym_scope_resolution] = STATE(3518),
    [sym_call] = STATE(3518),
    [sym_method_call] = STATE(3522),
    [sym_argument_list] = STATE(1325),
    [sym__argument_list_with_parens] = STATE(6159),
    [sym__argument] = STATE(6160),
    [sym_splat_argument] = STATE(6160),
    [sym_hash_splat_argument] = STATE(6160),
    [sym_block_argument] = STATE(6160),
    [sym_assignment] = STATE(6158),
    [sym_operator_assignment] = STATE(6158),
    [sym_conditional] = STATE(6158),
    [sym_range] = STATE(6158),
    [sym_binary] = STATE(6158),
    [sym_unary] = STATE(6158),
    [sym_left_assignment_list] = STATE(3521),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3522),
    [sym__variable] = STATE(3518),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(3522),
    [sym_false] = STATE(3522),
    [sym_nil] = STATE(3522),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(6161),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(6160),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(9533),
    [sym__splat_star] = ACTIONS(9535),
    [sym__unary_minus] = ACTIONS(5835),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(9537),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5839),
    [anon_sym_yield] = ACTIONS(5841),
    [anon_sym_break] = ACTIONS(5843),
    [anon_sym_next] = ACTIONS(5845),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_COLON2] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(5847),
    [anon_sym_not] = ACTIONS(5849),
    [anon_sym_BANG] = ACTIONS(5851),
    [anon_sym_TILDE] = ACTIONS(5853),
    [sym_constant] = ACTIONS(9539),
    [sym_identifier] = ACTIONS(9539),
    [sym_instance_variable] = ACTIONS(5857),
    [sym_class_variable] = ACTIONS(5857),
    [sym_global_variable] = ACTIONS(5857),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5859),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5859),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3513] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(6158),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(3522),
    [sym_scope_resolution] = STATE(3518),
    [sym_call] = STATE(3518),
    [sym_method_call] = STATE(3522),
    [sym_argument_list] = STATE(1326),
    [sym__argument_list_with_parens] = STATE(6159),
    [sym__argument] = STATE(6160),
    [sym_splat_argument] = STATE(6160),
    [sym_hash_splat_argument] = STATE(6160),
    [sym_block_argument] = STATE(6160),
    [sym_assignment] = STATE(6158),
    [sym_operator_assignment] = STATE(6158),
    [sym_conditional] = STATE(6158),
    [sym_range] = STATE(6158),
    [sym_binary] = STATE(6158),
    [sym_unary] = STATE(6158),
    [sym_left_assignment_list] = STATE(3521),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3522),
    [sym__variable] = STATE(3518),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(3522),
    [sym_false] = STATE(3522),
    [sym_nil] = STATE(3522),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(6161),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(6160),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(9533),
    [sym__splat_star] = ACTIONS(9535),
    [sym__unary_minus] = ACTIONS(5835),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(9537),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5839),
    [anon_sym_yield] = ACTIONS(5841),
    [anon_sym_break] = ACTIONS(5843),
    [anon_sym_next] = ACTIONS(5845),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_COLON2] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(5847),
    [anon_sym_not] = ACTIONS(5849),
    [anon_sym_BANG] = ACTIONS(5851),
    [anon_sym_TILDE] = ACTIONS(5853),
    [sym_constant] = ACTIONS(9539),
    [sym_identifier] = ACTIONS(9539),
    [sym_instance_variable] = ACTIONS(5857),
    [sym_class_variable] = ACTIONS(5857),
    [sym_global_variable] = ACTIONS(5857),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5859),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5859),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3514] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(6162),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(3522),
    [sym_scope_resolution] = STATE(3518),
    [sym_call] = STATE(3518),
    [sym_method_call] = STATE(3522),
    [sym_assignment] = STATE(6162),
    [sym_operator_assignment] = STATE(6162),
    [sym_conditional] = STATE(6162),
    [sym_range] = STATE(6162),
    [sym_binary] = STATE(6162),
    [sym_unary] = STATE(6162),
    [sym_left_assignment_list] = STATE(3521),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3522),
    [sym__variable] = STATE(3518),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(3522),
    [sym_false] = STATE(3522),
    [sym_nil] = STATE(3522),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(6150),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(9527),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(5835),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5839),
    [anon_sym_yield] = ACTIONS(5841),
    [anon_sym_break] = ACTIONS(5843),
    [anon_sym_next] = ACTIONS(5845),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9529),
    [anon_sym_defined_QMARK] = ACTIONS(5847),
    [anon_sym_not] = ACTIONS(5849),
    [anon_sym_BANG] = ACTIONS(5853),
    [anon_sym_TILDE] = ACTIONS(5853),
    [sym_constant] = ACTIONS(5859),
    [sym_identifier] = ACTIONS(5859),
    [sym_instance_variable] = ACTIONS(5857),
    [sym_class_variable] = ACTIONS(5857),
    [sym_global_variable] = ACTIONS(5857),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5859),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5859),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3515] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(1872),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(3522),
    [sym_scope_resolution] = STATE(3518),
    [sym_call] = STATE(3518),
    [sym_method_call] = STATE(3522),
    [sym_assignment] = STATE(1872),
    [sym_operator_assignment] = STATE(1872),
    [sym_conditional] = STATE(1872),
    [sym_range] = STATE(1872),
    [sym_binary] = STATE(1872),
    [sym_unary] = STATE(1872),
    [sym_left_assignment_list] = STATE(3521),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3522),
    [sym__variable] = STATE(3518),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(3522),
    [sym_false] = STATE(3522),
    [sym_nil] = STATE(3522),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(6150),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(9527),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(5835),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5839),
    [anon_sym_yield] = ACTIONS(5841),
    [anon_sym_break] = ACTIONS(5843),
    [anon_sym_next] = ACTIONS(5845),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9529),
    [anon_sym_defined_QMARK] = ACTIONS(5847),
    [anon_sym_not] = ACTIONS(5849),
    [anon_sym_BANG] = ACTIONS(5853),
    [anon_sym_TILDE] = ACTIONS(5853),
    [sym_constant] = ACTIONS(5859),
    [sym_identifier] = ACTIONS(5859),
    [sym_instance_variable] = ACTIONS(5857),
    [sym_class_variable] = ACTIONS(5857),
    [sym_global_variable] = ACTIONS(5857),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5859),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5859),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3516] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(9541),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_COLON2] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [3517] = {
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(9543),
    [sym__binary_star] = ACTIONS(9545),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(9547),
    [anon_sym_STAR_STAR] = ACTIONS(9545),
    [anon_sym_AMP] = ACTIONS(9549),
    [anon_sym_LT] = ACTIONS(9551),
    [anon_sym_EQ_GT] = ACTIONS(9531),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(9553),
    [anon_sym_COLON2] = ACTIONS(1631),
    [anon_sym_DOT_DOT] = ACTIONS(9555),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9557),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(9559),
    [anon_sym_AMP_AMP] = ACTIONS(9559),
    [anon_sym_LT_LT] = ACTIONS(9561),
    [anon_sym_GT_GT] = ACTIONS(9561),
    [anon_sym_EQ_EQ] = ACTIONS(9563),
    [anon_sym_BANG_EQ] = ACTIONS(9559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9559),
    [anon_sym_LT_EQ_GT] = ACTIONS(9559),
    [anon_sym_EQ_TILDE] = ACTIONS(9559),
    [anon_sym_BANG_TILDE] = ACTIONS(9559),
    [anon_sym_LT_EQ] = ACTIONS(9551),
    [anon_sym_GT] = ACTIONS(9551),
    [anon_sym_GT_EQ] = ACTIONS(9565),
    [anon_sym_CARET] = ACTIONS(9567),
    [anon_sym_PLUS] = ACTIONS(9543),
    [anon_sym_SLASH] = ACTIONS(9545),
    [anon_sym_PERCENT] = ACTIONS(9545),
    [sym_comment] = ACTIONS(87),
  },
  [3518] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6179),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3553),
    [sym_scope_resolution] = STATE(3549),
    [sym_call] = STATE(3549),
    [sym_method_call] = STATE(3553),
    [sym_argument_list] = STATE(1379),
    [sym__argument_list_with_parens] = STATE(6180),
    [sym__argument] = STATE(6181),
    [sym_splat_argument] = STATE(6181),
    [sym_hash_splat_argument] = STATE(6181),
    [sym_block_argument] = STATE(6181),
    [sym_do_block] = STATE(1382),
    [sym_block] = STATE(1382),
    [sym_assignment] = STATE(6179),
    [sym_operator_assignment] = STATE(6179),
    [sym_conditional] = STATE(6179),
    [sym_range] = STATE(6179),
    [sym_binary] = STATE(6179),
    [sym_unary] = STATE(6179),
    [sym_left_assignment_list] = STATE(3552),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3553),
    [sym__variable] = STATE(3549),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3553),
    [sym_false] = STATE(3553),
    [sym_nil] = STATE(3553),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6182),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(6181),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(9569),
    [sym__splat_star] = ACTIONS(9571),
    [sym__unary_minus] = ACTIONS(5895),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(9573),
    [anon_sym_LBRACE] = ACTIONS(2403),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5899),
    [anon_sym_yield] = ACTIONS(5901),
    [anon_sym_break] = ACTIONS(5903),
    [anon_sym_next] = ACTIONS(5905),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(2413),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(5907),
    [anon_sym_not] = ACTIONS(5909),
    [anon_sym_BANG] = ACTIONS(5911),
    [anon_sym_TILDE] = ACTIONS(5913),
    [sym_constant] = ACTIONS(9575),
    [sym_identifier] = ACTIONS(9575),
    [sym_instance_variable] = ACTIONS(5917),
    [sym_class_variable] = ACTIONS(5917),
    [sym_global_variable] = ACTIONS(5917),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5919),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5919),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3519] = {
    [sym_heredoc_body] = STATE(6183),
    [aux_sym_call_repeat1] = STATE(6183),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_COLON2] = ACTIONS(1685),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [3520] = {
    [sym_heredoc_body] = STATE(6183),
    [aux_sym_call_repeat1] = STATE(6183),
    [aux_sym_argument_list_repeat1] = STATE(6185),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(9577),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_COLON2] = ACTIONS(1685),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [3521] = {
    [anon_sym_EQ] = ACTIONS(9579),
    [sym_comment] = ACTIONS(87),
  },
  [3522] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(9581),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(9583),
    [anon_sym_DASH_EQ] = ACTIONS(9583),
    [anon_sym_STAR_EQ] = ACTIONS(9583),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9583),
    [anon_sym_SLASH_EQ] = ACTIONS(9583),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9583),
    [anon_sym_PIPE_EQ] = ACTIONS(9583),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9583),
    [anon_sym_AMP_EQ] = ACTIONS(9583),
    [anon_sym_PERCENT_EQ] = ACTIONS(9583),
    [anon_sym_GT_GT_EQ] = ACTIONS(9583),
    [anon_sym_LT_LT_EQ] = ACTIONS(9583),
    [anon_sym_CARET_EQ] = ACTIONS(9583),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3523] = {
    [sym_string] = STATE(6188),
    [aux_sym_chained_string_repeat1] = STATE(6188),
    [sym__string_start] = ACTIONS(9527),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(9585),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [3524] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [3525] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(6189),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(6189),
    [sym_operator_assignment] = STATE(6189),
    [sym_conditional] = STATE(6189),
    [sym_range] = STATE(6189),
    [sym_binary] = STATE(6189),
    [sym_unary] = STATE(6189),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3526] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(6190),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(6190),
    [sym_operator_assignment] = STATE(6190),
    [sym_conditional] = STATE(6190),
    [sym_range] = STATE(6190),
    [sym_binary] = STATE(6190),
    [sym_unary] = STATE(6190),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3527] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(6191),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(6191),
    [sym_operator_assignment] = STATE(6191),
    [sym_conditional] = STATE(6191),
    [sym_range] = STATE(6191),
    [sym_binary] = STATE(6191),
    [sym_unary] = STATE(6191),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3528] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(6192),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(6192),
    [sym_operator_assignment] = STATE(6192),
    [sym_conditional] = STATE(6192),
    [sym_range] = STATE(6192),
    [sym_binary] = STATE(6192),
    [sym_unary] = STATE(6192),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3529] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(6193),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(6193),
    [sym_operator_assignment] = STATE(6193),
    [sym_conditional] = STATE(6193),
    [sym_range] = STATE(6193),
    [sym_binary] = STATE(6193),
    [sym_unary] = STATE(6193),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3530] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(6194),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(6194),
    [sym_operator_assignment] = STATE(6194),
    [sym_conditional] = STATE(6194),
    [sym_range] = STATE(6194),
    [sym_binary] = STATE(6194),
    [sym_unary] = STATE(6194),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3531] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(6195),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(51),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(51),
    [sym_assignment] = STATE(6195),
    [sym_operator_assignment] = STATE(6195),
    [sym_conditional] = STATE(6195),
    [sym_range] = STATE(6195),
    [sym_binary] = STATE(6195),
    [sym_unary] = STATE(6195),
    [sym_left_assignment_list] = STATE(48),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(51),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(51),
    [sym_false] = STATE(51),
    [sym_nil] = STATE(51),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(52),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3532] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(6196),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(6196),
    [sym_operator_assignment] = STATE(6196),
    [sym_conditional] = STATE(6196),
    [sym_range] = STATE(6196),
    [sym_binary] = STATE(6196),
    [sym_unary] = STATE(6196),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3533] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(6197),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(6197),
    [sym_operator_assignment] = STATE(6197),
    [sym_conditional] = STATE(6197),
    [sym_range] = STATE(6197),
    [sym_binary] = STATE(6197),
    [sym_unary] = STATE(6197),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3534] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(6198),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(6198),
    [sym_operator_assignment] = STATE(6198),
    [sym_conditional] = STATE(6198),
    [sym_range] = STATE(6198),
    [sym_binary] = STATE(6198),
    [sym_unary] = STATE(6198),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3535] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(6199),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(6199),
    [sym_operator_assignment] = STATE(6199),
    [sym_conditional] = STATE(6199),
    [sym_range] = STATE(6199),
    [sym_binary] = STATE(6199),
    [sym_unary] = STATE(6199),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3536] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(6207),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(6210),
    [sym_scope_resolution] = STATE(6208),
    [sym_call] = STATE(6208),
    [sym_method_call] = STATE(6210),
    [sym_assignment] = STATE(6207),
    [sym_operator_assignment] = STATE(6207),
    [sym_conditional] = STATE(6207),
    [sym_range] = STATE(6207),
    [sym_binary] = STATE(6207),
    [sym_unary] = STATE(6207),
    [sym_left_assignment_list] = STATE(6209),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6210),
    [sym__variable] = STATE(6208),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(6210),
    [sym_false] = STATE(6210),
    [sym_nil] = STATE(6210),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(6211),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(9587),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(9589),
    [anon_sym_yield] = ACTIONS(9591),
    [anon_sym_break] = ACTIONS(9593),
    [anon_sym_next] = ACTIONS(9595),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(9597),
    [anon_sym_defined_QMARK] = ACTIONS(9599),
    [anon_sym_not] = ACTIONS(9601),
    [anon_sym_BANG] = ACTIONS(9603),
    [anon_sym_TILDE] = ACTIONS(9603),
    [sym_constant] = ACTIONS(9605),
    [sym_identifier] = ACTIONS(9605),
    [sym_instance_variable] = ACTIONS(9607),
    [sym_class_variable] = ACTIONS(9607),
    [sym_global_variable] = ACTIONS(9607),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(9605),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9605),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [3537] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(6212),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(6210),
    [sym_scope_resolution] = STATE(6208),
    [sym_call] = STATE(6208),
    [sym_method_call] = STATE(6210),
    [sym_assignment] = STATE(6212),
    [sym_operator_assignment] = STATE(6212),
    [sym_conditional] = STATE(6212),
    [sym_range] = STATE(6212),
    [sym_binary] = STATE(6212),
    [sym_unary] = STATE(6212),
    [sym_left_assignment_list] = STATE(6209),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6210),
    [sym__variable] = STATE(6208),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(6210),
    [sym_false] = STATE(6210),
    [sym_nil] = STATE(6210),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(6211),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(9587),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(9589),
    [anon_sym_yield] = ACTIONS(9591),
    [anon_sym_break] = ACTIONS(9593),
    [anon_sym_next] = ACTIONS(9595),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(9597),
    [anon_sym_defined_QMARK] = ACTIONS(9599),
    [anon_sym_not] = ACTIONS(9601),
    [anon_sym_BANG] = ACTIONS(9603),
    [anon_sym_TILDE] = ACTIONS(9603),
    [sym_constant] = ACTIONS(9605),
    [sym_identifier] = ACTIONS(9605),
    [sym_instance_variable] = ACTIONS(9607),
    [sym_class_variable] = ACTIONS(9607),
    [sym_global_variable] = ACTIONS(9607),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(9605),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9605),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [3538] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6214),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3553),
    [sym_scope_resolution] = STATE(3549),
    [sym_call] = STATE(3549),
    [sym_method_call] = STATE(3553),
    [sym_assignment] = STATE(6214),
    [sym_operator_assignment] = STATE(6214),
    [sym_conditional] = STATE(6214),
    [sym_range] = STATE(6214),
    [sym_binary] = STATE(6214),
    [sym_unary] = STATE(6214),
    [sym_left_assignment_list] = STATE(3552),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3553),
    [sym__variable] = STATE(3549),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3553),
    [sym_false] = STATE(3553),
    [sym_nil] = STATE(3553),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6215),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(9609),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(5895),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5899),
    [anon_sym_yield] = ACTIONS(5901),
    [anon_sym_break] = ACTIONS(5903),
    [anon_sym_next] = ACTIONS(5905),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(9611),
    [anon_sym_defined_QMARK] = ACTIONS(5907),
    [anon_sym_not] = ACTIONS(5909),
    [anon_sym_BANG] = ACTIONS(5913),
    [anon_sym_TILDE] = ACTIONS(5913),
    [sym_constant] = ACTIONS(5919),
    [sym_identifier] = ACTIONS(5919),
    [sym_instance_variable] = ACTIONS(5917),
    [sym_class_variable] = ACTIONS(5917),
    [sym_global_variable] = ACTIONS(5917),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5919),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5919),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3539] = {
    [anon_sym_COLON] = ACTIONS(9613),
    [sym_comment] = ACTIONS(87),
  },
  [3540] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(6217),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(6210),
    [sym_scope_resolution] = STATE(6208),
    [sym_call] = STATE(6208),
    [sym_method_call] = STATE(6210),
    [sym_assignment] = STATE(6217),
    [sym_operator_assignment] = STATE(6217),
    [sym_conditional] = STATE(6217),
    [sym_range] = STATE(6217),
    [sym_binary] = STATE(6217),
    [sym_unary] = STATE(6217),
    [sym_left_assignment_list] = STATE(6209),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6210),
    [sym__variable] = STATE(6208),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(6210),
    [sym_false] = STATE(6210),
    [sym_nil] = STATE(6210),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(6211),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(9587),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(9589),
    [anon_sym_yield] = ACTIONS(9591),
    [anon_sym_break] = ACTIONS(9593),
    [anon_sym_next] = ACTIONS(9595),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(9597),
    [anon_sym_defined_QMARK] = ACTIONS(9599),
    [anon_sym_not] = ACTIONS(9601),
    [anon_sym_BANG] = ACTIONS(9603),
    [anon_sym_TILDE] = ACTIONS(9603),
    [sym_constant] = ACTIONS(9605),
    [sym_identifier] = ACTIONS(9605),
    [sym_instance_variable] = ACTIONS(9607),
    [sym_class_variable] = ACTIONS(9607),
    [sym_global_variable] = ACTIONS(9607),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(9605),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9605),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [3541] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6179),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3553),
    [sym_scope_resolution] = STATE(3549),
    [sym_call] = STATE(3549),
    [sym_method_call] = STATE(3553),
    [sym_argument_list] = STATE(1973),
    [sym__argument_list_with_parens] = STATE(6180),
    [sym__argument] = STATE(6181),
    [sym_splat_argument] = STATE(6181),
    [sym_hash_splat_argument] = STATE(6181),
    [sym_block_argument] = STATE(6181),
    [sym_assignment] = STATE(6179),
    [sym_operator_assignment] = STATE(6179),
    [sym_conditional] = STATE(6179),
    [sym_range] = STATE(6179),
    [sym_binary] = STATE(6179),
    [sym_unary] = STATE(6179),
    [sym_left_assignment_list] = STATE(3552),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3553),
    [sym__variable] = STATE(3549),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3553),
    [sym_false] = STATE(3553),
    [sym_nil] = STATE(3553),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6182),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(6181),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(9569),
    [sym__splat_star] = ACTIONS(9571),
    [sym__unary_minus] = ACTIONS(5895),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(9573),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5899),
    [anon_sym_yield] = ACTIONS(5901),
    [anon_sym_break] = ACTIONS(5903),
    [anon_sym_next] = ACTIONS(5905),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(365),
    [anon_sym_DASH_EQ] = ACTIONS(365),
    [anon_sym_STAR_EQ] = ACTIONS(365),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(365),
    [anon_sym_SLASH_EQ] = ACTIONS(365),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(365),
    [anon_sym_PIPE_EQ] = ACTIONS(365),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(365),
    [anon_sym_AMP_EQ] = ACTIONS(365),
    [anon_sym_PERCENT_EQ] = ACTIONS(365),
    [anon_sym_GT_GT_EQ] = ACTIONS(365),
    [anon_sym_LT_LT_EQ] = ACTIONS(365),
    [anon_sym_CARET_EQ] = ACTIONS(365),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_COLON2] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_PERCENT] = ACTIONS(377),
    [anon_sym_defined_QMARK] = ACTIONS(5907),
    [anon_sym_not] = ACTIONS(5909),
    [anon_sym_BANG] = ACTIONS(5911),
    [anon_sym_TILDE] = ACTIONS(5913),
    [sym_constant] = ACTIONS(9575),
    [sym_identifier] = ACTIONS(9575),
    [sym_instance_variable] = ACTIONS(5917),
    [sym_class_variable] = ACTIONS(5917),
    [sym_global_variable] = ACTIONS(5917),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5919),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5919),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3542] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6179),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3553),
    [sym_scope_resolution] = STATE(3549),
    [sym_call] = STATE(3549),
    [sym_method_call] = STATE(3553),
    [sym_argument_list] = STATE(1974),
    [sym__argument_list_with_parens] = STATE(6180),
    [sym__argument] = STATE(6181),
    [sym_splat_argument] = STATE(6181),
    [sym_hash_splat_argument] = STATE(6181),
    [sym_block_argument] = STATE(6181),
    [sym_assignment] = STATE(6179),
    [sym_operator_assignment] = STATE(6179),
    [sym_conditional] = STATE(6179),
    [sym_range] = STATE(6179),
    [sym_binary] = STATE(6179),
    [sym_unary] = STATE(6179),
    [sym_left_assignment_list] = STATE(3552),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3553),
    [sym__variable] = STATE(3549),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3553),
    [sym_false] = STATE(3553),
    [sym_nil] = STATE(3553),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6182),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(6181),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(9569),
    [sym__splat_star] = ACTIONS(9571),
    [sym__unary_minus] = ACTIONS(5895),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(9573),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_EQ] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5899),
    [anon_sym_yield] = ACTIONS(5901),
    [anon_sym_break] = ACTIONS(5903),
    [anon_sym_next] = ACTIONS(5905),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(417),
    [anon_sym_DASH_EQ] = ACTIONS(417),
    [anon_sym_STAR_EQ] = ACTIONS(417),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(417),
    [anon_sym_SLASH_EQ] = ACTIONS(417),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(417),
    [anon_sym_PIPE_EQ] = ACTIONS(417),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(417),
    [anon_sym_AMP_EQ] = ACTIONS(417),
    [anon_sym_PERCENT_EQ] = ACTIONS(417),
    [anon_sym_GT_GT_EQ] = ACTIONS(417),
    [anon_sym_LT_LT_EQ] = ACTIONS(417),
    [anon_sym_CARET_EQ] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_COLON2] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(5907),
    [anon_sym_not] = ACTIONS(5909),
    [anon_sym_BANG] = ACTIONS(5911),
    [anon_sym_TILDE] = ACTIONS(5913),
    [sym_constant] = ACTIONS(9575),
    [sym_identifier] = ACTIONS(9575),
    [sym_instance_variable] = ACTIONS(5917),
    [sym_class_variable] = ACTIONS(5917),
    [sym_global_variable] = ACTIONS(5917),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5919),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5919),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3543] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6179),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3553),
    [sym_scope_resolution] = STATE(3549),
    [sym_call] = STATE(3549),
    [sym_method_call] = STATE(3553),
    [sym_argument_list] = STATE(1975),
    [sym__argument_list_with_parens] = STATE(6180),
    [sym__argument] = STATE(6181),
    [sym_splat_argument] = STATE(6181),
    [sym_hash_splat_argument] = STATE(6181),
    [sym_block_argument] = STATE(6181),
    [sym_assignment] = STATE(6179),
    [sym_operator_assignment] = STATE(6179),
    [sym_conditional] = STATE(6179),
    [sym_range] = STATE(6179),
    [sym_binary] = STATE(6179),
    [sym_unary] = STATE(6179),
    [sym_left_assignment_list] = STATE(3552),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3553),
    [sym__variable] = STATE(3549),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3553),
    [sym_false] = STATE(3553),
    [sym_nil] = STATE(3553),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6182),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(6181),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(9569),
    [sym__splat_star] = ACTIONS(9571),
    [sym__unary_minus] = ACTIONS(5895),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(9573),
    [anon_sym_LBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_EQ] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5899),
    [anon_sym_yield] = ACTIONS(5901),
    [anon_sym_break] = ACTIONS(5903),
    [anon_sym_next] = ACTIONS(5905),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(421),
    [anon_sym_DASH_EQ] = ACTIONS(421),
    [anon_sym_STAR_EQ] = ACTIONS(421),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(421),
    [anon_sym_SLASH_EQ] = ACTIONS(421),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(421),
    [anon_sym_PIPE_EQ] = ACTIONS(421),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(421),
    [anon_sym_AMP_EQ] = ACTIONS(421),
    [anon_sym_PERCENT_EQ] = ACTIONS(421),
    [anon_sym_GT_GT_EQ] = ACTIONS(421),
    [anon_sym_LT_LT_EQ] = ACTIONS(421),
    [anon_sym_CARET_EQ] = ACTIONS(421),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_COLON2] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(5907),
    [anon_sym_not] = ACTIONS(5909),
    [anon_sym_BANG] = ACTIONS(5911),
    [anon_sym_TILDE] = ACTIONS(5913),
    [sym_constant] = ACTIONS(9575),
    [sym_identifier] = ACTIONS(9575),
    [sym_instance_variable] = ACTIONS(5917),
    [sym_class_variable] = ACTIONS(5917),
    [sym_global_variable] = ACTIONS(5917),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5919),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5919),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3544] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6179),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3553),
    [sym_scope_resolution] = STATE(3549),
    [sym_call] = STATE(3549),
    [sym_method_call] = STATE(3553),
    [sym_argument_list] = STATE(1976),
    [sym__argument_list_with_parens] = STATE(6180),
    [sym__argument] = STATE(6181),
    [sym_splat_argument] = STATE(6181),
    [sym_hash_splat_argument] = STATE(6181),
    [sym_block_argument] = STATE(6181),
    [sym_assignment] = STATE(6179),
    [sym_operator_assignment] = STATE(6179),
    [sym_conditional] = STATE(6179),
    [sym_range] = STATE(6179),
    [sym_binary] = STATE(6179),
    [sym_unary] = STATE(6179),
    [sym_left_assignment_list] = STATE(3552),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3553),
    [sym__variable] = STATE(3549),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3553),
    [sym_false] = STATE(3553),
    [sym_nil] = STATE(3553),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6182),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(6181),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(9569),
    [sym__splat_star] = ACTIONS(9571),
    [sym__unary_minus] = ACTIONS(5895),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(9573),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(427),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5899),
    [anon_sym_yield] = ACTIONS(5901),
    [anon_sym_break] = ACTIONS(5903),
    [anon_sym_next] = ACTIONS(5905),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(425),
    [anon_sym_DASH_EQ] = ACTIONS(425),
    [anon_sym_STAR_EQ] = ACTIONS(425),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(425),
    [anon_sym_SLASH_EQ] = ACTIONS(425),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(425),
    [anon_sym_PIPE_EQ] = ACTIONS(425),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(425),
    [anon_sym_AMP_EQ] = ACTIONS(425),
    [anon_sym_PERCENT_EQ] = ACTIONS(425),
    [anon_sym_GT_GT_EQ] = ACTIONS(425),
    [anon_sym_LT_LT_EQ] = ACTIONS(425),
    [anon_sym_CARET_EQ] = ACTIONS(425),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_COLON2] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(5907),
    [anon_sym_not] = ACTIONS(5909),
    [anon_sym_BANG] = ACTIONS(5911),
    [anon_sym_TILDE] = ACTIONS(5913),
    [sym_constant] = ACTIONS(9575),
    [sym_identifier] = ACTIONS(9575),
    [sym_instance_variable] = ACTIONS(5917),
    [sym_class_variable] = ACTIONS(5917),
    [sym_global_variable] = ACTIONS(5917),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5919),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5919),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3545] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6218),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3553),
    [sym_scope_resolution] = STATE(3549),
    [sym_call] = STATE(3549),
    [sym_method_call] = STATE(3553),
    [sym_assignment] = STATE(6218),
    [sym_operator_assignment] = STATE(6218),
    [sym_conditional] = STATE(6218),
    [sym_range] = STATE(6218),
    [sym_binary] = STATE(6218),
    [sym_unary] = STATE(6218),
    [sym_left_assignment_list] = STATE(3552),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3553),
    [sym__variable] = STATE(3549),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3553),
    [sym_false] = STATE(3553),
    [sym_nil] = STATE(3553),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6215),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(9609),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(5895),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5899),
    [anon_sym_yield] = ACTIONS(5901),
    [anon_sym_break] = ACTIONS(5903),
    [anon_sym_next] = ACTIONS(5905),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(9611),
    [anon_sym_defined_QMARK] = ACTIONS(5907),
    [anon_sym_not] = ACTIONS(5909),
    [anon_sym_BANG] = ACTIONS(5913),
    [anon_sym_TILDE] = ACTIONS(5913),
    [sym_constant] = ACTIONS(5919),
    [sym_identifier] = ACTIONS(5919),
    [sym_instance_variable] = ACTIONS(5917),
    [sym_class_variable] = ACTIONS(5917),
    [sym_global_variable] = ACTIONS(5917),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5919),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5919),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3546] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1997),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3553),
    [sym_scope_resolution] = STATE(3549),
    [sym_call] = STATE(3549),
    [sym_method_call] = STATE(3553),
    [sym_assignment] = STATE(1997),
    [sym_operator_assignment] = STATE(1997),
    [sym_conditional] = STATE(1997),
    [sym_range] = STATE(1997),
    [sym_binary] = STATE(1997),
    [sym_unary] = STATE(1997),
    [sym_left_assignment_list] = STATE(3552),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3553),
    [sym__variable] = STATE(3549),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3553),
    [sym_false] = STATE(3553),
    [sym_nil] = STATE(3553),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6215),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(9609),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(5895),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5899),
    [anon_sym_yield] = ACTIONS(5901),
    [anon_sym_break] = ACTIONS(5903),
    [anon_sym_next] = ACTIONS(5905),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(9611),
    [anon_sym_defined_QMARK] = ACTIONS(5907),
    [anon_sym_not] = ACTIONS(5909),
    [anon_sym_BANG] = ACTIONS(5913),
    [anon_sym_TILDE] = ACTIONS(5913),
    [sym_constant] = ACTIONS(5919),
    [sym_identifier] = ACTIONS(5919),
    [sym_instance_variable] = ACTIONS(5917),
    [sym_class_variable] = ACTIONS(5917),
    [sym_global_variable] = ACTIONS(5917),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5919),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5919),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3547] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(9615),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_COLON2] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [3548] = {
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(9617),
    [sym__binary_star] = ACTIONS(9619),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(9621),
    [anon_sym_STAR_STAR] = ACTIONS(9623),
    [anon_sym_AMP] = ACTIONS(9625),
    [anon_sym_EQ] = ACTIONS(1631),
    [anon_sym_LT] = ACTIONS(9627),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(9613),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_PLUS_EQ] = ACTIONS(1625),
    [anon_sym_DASH_EQ] = ACTIONS(1625),
    [anon_sym_STAR_EQ] = ACTIONS(1625),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1625),
    [anon_sym_SLASH_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1625),
    [anon_sym_AMP_EQ] = ACTIONS(1625),
    [anon_sym_PERCENT_EQ] = ACTIONS(1625),
    [anon_sym_GT_GT_EQ] = ACTIONS(1625),
    [anon_sym_LT_LT_EQ] = ACTIONS(1625),
    [anon_sym_CARET_EQ] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(9629),
    [anon_sym_COLON2] = ACTIONS(1631),
    [anon_sym_DOT_DOT] = ACTIONS(9631),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9633),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(9635),
    [anon_sym_AMP_AMP] = ACTIONS(9635),
    [anon_sym_LT_LT] = ACTIONS(9637),
    [anon_sym_GT_GT] = ACTIONS(9637),
    [anon_sym_EQ_EQ] = ACTIONS(9635),
    [anon_sym_BANG_EQ] = ACTIONS(9639),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9639),
    [anon_sym_LT_EQ_GT] = ACTIONS(9639),
    [anon_sym_EQ_TILDE] = ACTIONS(9639),
    [anon_sym_BANG_TILDE] = ACTIONS(9639),
    [anon_sym_LT_EQ] = ACTIONS(9627),
    [anon_sym_GT] = ACTIONS(9627),
    [anon_sym_GT_EQ] = ACTIONS(9641),
    [anon_sym_CARET] = ACTIONS(9621),
    [anon_sym_PLUS] = ACTIONS(9643),
    [anon_sym_SLASH] = ACTIONS(9623),
    [anon_sym_PERCENT] = ACTIONS(9623),
    [sym_comment] = ACTIONS(87),
  },
  [3549] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6179),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3553),
    [sym_scope_resolution] = STATE(3549),
    [sym_call] = STATE(3549),
    [sym_method_call] = STATE(3553),
    [sym_argument_list] = STATE(2016),
    [sym__argument_list_with_parens] = STATE(6180),
    [sym__argument] = STATE(6181),
    [sym_splat_argument] = STATE(6181),
    [sym_hash_splat_argument] = STATE(6181),
    [sym_block_argument] = STATE(6181),
    [sym_do_block] = STATE(1382),
    [sym_block] = STATE(1382),
    [sym_assignment] = STATE(6179),
    [sym_operator_assignment] = STATE(6179),
    [sym_conditional] = STATE(6179),
    [sym_range] = STATE(6179),
    [sym_binary] = STATE(6179),
    [sym_unary] = STATE(6179),
    [sym_left_assignment_list] = STATE(3552),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3553),
    [sym__variable] = STATE(3549),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3553),
    [sym_false] = STATE(3553),
    [sym_nil] = STATE(3553),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6182),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(6181),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(9569),
    [sym__splat_star] = ACTIONS(9571),
    [sym__unary_minus] = ACTIONS(5895),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(9573),
    [anon_sym_LBRACE] = ACTIONS(3537),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5899),
    [anon_sym_yield] = ACTIONS(5901),
    [anon_sym_break] = ACTIONS(5903),
    [anon_sym_next] = ACTIONS(5905),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(769),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(5907),
    [anon_sym_not] = ACTIONS(5909),
    [anon_sym_BANG] = ACTIONS(5911),
    [anon_sym_TILDE] = ACTIONS(5913),
    [sym_constant] = ACTIONS(9575),
    [sym_identifier] = ACTIONS(9575),
    [sym_instance_variable] = ACTIONS(5917),
    [sym_class_variable] = ACTIONS(5917),
    [sym_global_variable] = ACTIONS(5917),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5919),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5919),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3550] = {
    [sym_heredoc_body] = STATE(6230),
    [aux_sym_call_repeat1] = STATE(6230),
    [sym__heredoc_body_start] = ACTIONS(6569),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_COLON2] = ACTIONS(1685),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [3551] = {
    [sym_heredoc_body] = STATE(6230),
    [aux_sym_call_repeat1] = STATE(6230),
    [aux_sym_argument_list_repeat1] = STATE(6232),
    [sym__heredoc_body_start] = ACTIONS(6569),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(9645),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_COLON2] = ACTIONS(1685),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [3552] = {
    [anon_sym_EQ] = ACTIONS(9647),
    [sym_comment] = ACTIONS(87),
  },
  [3553] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(9649),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(9651),
    [anon_sym_DASH_EQ] = ACTIONS(9651),
    [anon_sym_STAR_EQ] = ACTIONS(9651),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9651),
    [anon_sym_SLASH_EQ] = ACTIONS(9651),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9651),
    [anon_sym_PIPE_EQ] = ACTIONS(9651),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9651),
    [anon_sym_AMP_EQ] = ACTIONS(9651),
    [anon_sym_PERCENT_EQ] = ACTIONS(9651),
    [anon_sym_GT_GT_EQ] = ACTIONS(9651),
    [anon_sym_LT_LT_EQ] = ACTIONS(9651),
    [anon_sym_CARET_EQ] = ACTIONS(9651),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3554] = {
    [sym_string] = STATE(6235),
    [aux_sym_chained_string_repeat1] = STATE(6235),
    [sym__string_start] = ACTIONS(9609),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(9653),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3555] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(6244),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(6247),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(6247),
    [sym_splat_argument] = STATE(6245),
    [sym_assignment] = STATE(6244),
    [sym_operator_assignment] = STATE(6244),
    [sym_conditional] = STATE(6244),
    [sym_range] = STATE(6244),
    [sym_binary] = STATE(6244),
    [sym_unary] = STATE(6244),
    [sym_right_assignment_list] = STATE(2035),
    [sym__arg_or_splat_arg] = STATE(6245),
    [sym_left_assignment_list] = STATE(6246),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6247),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(6247),
    [sym_false] = STATE(6247),
    [sym_nil] = STATE(6247),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(6248),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__splat_star] = ACTIONS(9655),
    [sym__unary_minus] = ACTIONS(9657),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9659),
    [anon_sym_yield] = ACTIONS(9661),
    [anon_sym_break] = ACTIONS(9663),
    [anon_sym_next] = ACTIONS(9665),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9667),
    [anon_sym_defined_QMARK] = ACTIONS(9669),
    [anon_sym_not] = ACTIONS(9671),
    [anon_sym_BANG] = ACTIONS(9673),
    [anon_sym_TILDE] = ACTIONS(9673),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3556] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(6249),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(6249),
    [sym_operator_assignment] = STATE(6249),
    [sym_conditional] = STATE(6249),
    [sym_range] = STATE(6249),
    [sym_binary] = STATE(6249),
    [sym_unary] = STATE(6249),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3557] = {
    [sym_string] = STATE(6250),
    [aux_sym_chained_string_repeat1] = STATE(6250),
    [sym__string_start] = ACTIONS(2495),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_COLON2] = ACTIONS(2755),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [3558] = {
    [sym__heredoc_body_start] = ACTIONS(3235),
    [anon_sym_PIPE] = ACTIONS(3235),
    [anon_sym_STAR] = ACTIONS(4997),
    [anon_sym_STAR_STAR] = ACTIONS(3235),
    [anon_sym_AMP] = ACTIONS(3235),
    [anon_sym_LT] = ACTIONS(4997),
    [anon_sym_LPAREN2] = ACTIONS(3235),
    [anon_sym_DOT_DOT] = ACTIONS(3235),
    [anon_sym_LT_LT] = ACTIONS(3235),
    [anon_sym_GT_GT] = ACTIONS(3235),
    [anon_sym_EQ_EQ] = ACTIONS(4997),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3235),
    [anon_sym_LT_EQ_GT] = ACTIONS(3235),
    [anon_sym_EQ_TILDE] = ACTIONS(3235),
    [anon_sym_BANG_TILDE] = ACTIONS(3235),
    [anon_sym_LT_EQ] = ACTIONS(4997),
    [anon_sym_GT] = ACTIONS(4997),
    [anon_sym_GT_EQ] = ACTIONS(3235),
    [anon_sym_CARET] = ACTIONS(3235),
    [anon_sym_PLUS] = ACTIONS(4997),
    [anon_sym_SLASH] = ACTIONS(3235),
    [anon_sym_PERCENT] = ACTIONS(3235),
    [anon_sym_BANG] = ACTIONS(4997),
    [anon_sym_TILDE] = ACTIONS(3235),
    [sym_constant] = ACTIONS(3235),
    [sym_identifier] = ACTIONS(3235),
    [anon_sym_DASH] = ACTIONS(4997),
    [anon_sym_PLUS_AT] = ACTIONS(3235),
    [anon_sym_DASH_AT] = ACTIONS(3235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4997),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(3235),
    [anon_sym_BQUOTE] = ACTIONS(3235),
    [sym_comment] = ACTIONS(87),
  },
  [3559] = {
    [sym_interpolation] = STATE(1787),
    [aux_sym_heredoc_body_repeat1] = STATE(1787),
    [sym__heredoc_content] = ACTIONS(3237),
    [sym_heredoc_end] = ACTIONS(9675),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(3237),
  },
  [3560] = {
    [sym__line_break] = ACTIONS(4285),
    [sym__simple_symbol] = ACTIONS(4285),
    [sym__string_start] = ACTIONS(4285),
    [sym__symbol_start] = ACTIONS(4285),
    [sym__subshell_start] = ACTIONS(4285),
    [sym__regex_start] = ACTIONS(4285),
    [sym__string_array_start] = ACTIONS(4285),
    [sym__symbol_array_start] = ACTIONS(4285),
    [sym__heredoc_body_start] = ACTIONS(4285),
    [sym_heredoc_beginning] = ACTIONS(4285),
    [sym__block_ampersand] = ACTIONS(4285),
    [sym__splat_star] = ACTIONS(4285),
    [sym__unary_minus] = ACTIONS(4285),
    [sym__binary_minus] = ACTIONS(4285),
    [sym__binary_star] = ACTIONS(4285),
    [sym__identifier_hash_key] = ACTIONS(4285),
    [ts_builtin_sym_end] = ACTIONS(4285),
    [anon_sym___END__] = ACTIONS(4287),
    [anon_sym_LBRACE] = ACTIONS(4285),
    [anon_sym_RBRACE] = ACTIONS(4285),
    [anon_sym_def] = ACTIONS(4287),
    [anon_sym_LPAREN] = ACTIONS(4287),
    [anon_sym_RPAREN] = ACTIONS(4285),
    [anon_sym_DOT] = ACTIONS(4287),
    [anon_sym_COLON_COLON] = ACTIONS(4287),
    [anon_sym_COMMA] = ACTIONS(4285),
    [anon_sym_PIPE] = ACTIONS(4287),
    [anon_sym_SEMI] = ACTIONS(4285),
    [anon_sym_STAR] = ACTIONS(4287),
    [anon_sym_STAR_STAR] = ACTIONS(4287),
    [anon_sym_AMP] = ACTIONS(4287),
    [anon_sym_EQ] = ACTIONS(4287),
    [anon_sym_class] = ACTIONS(4287),
    [anon_sym_LT] = ACTIONS(4287),
    [anon_sym_module] = ACTIONS(4287),
    [anon_sym_end] = ACTIONS(4287),
    [anon_sym_return] = ACTIONS(4287),
    [anon_sym_yield] = ACTIONS(4287),
    [anon_sym_break] = ACTIONS(4287),
    [anon_sym_next] = ACTIONS(4287),
    [sym_redo] = ACTIONS(4287),
    [sym_retry] = ACTIONS(4287),
    [anon_sym_if] = ACTIONS(4287),
    [anon_sym_unless] = ACTIONS(4287),
    [anon_sym_while] = ACTIONS(4287),
    [anon_sym_until] = ACTIONS(4287),
    [anon_sym_rescue] = ACTIONS(4287),
    [anon_sym_for] = ACTIONS(4287),
    [anon_sym_do] = ACTIONS(4287),
    [anon_sym_case] = ACTIONS(4287),
    [anon_sym_when] = ACTIONS(4287),
    [anon_sym_elsif] = ACTIONS(4287),
    [anon_sym_else] = ACTIONS(4287),
    [anon_sym_then] = ACTIONS(4287),
    [anon_sym_begin] = ACTIONS(4287),
    [anon_sym_ensure] = ACTIONS(4287),
    [anon_sym_LBRACK] = ACTIONS(4285),
    [anon_sym_COLON_COLON2] = ACTIONS(4285),
    [anon_sym_AMP_DOT] = ACTIONS(4285),
    [anon_sym_LPAREN2] = ACTIONS(4285),
    [anon_sym_PLUS_EQ] = ACTIONS(4285),
    [anon_sym_DASH_EQ] = ACTIONS(4285),
    [anon_sym_STAR_EQ] = ACTIONS(4285),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4285),
    [anon_sym_SLASH_EQ] = ACTIONS(4285),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4285),
    [anon_sym_PIPE_EQ] = ACTIONS(4285),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4285),
    [anon_sym_AMP_EQ] = ACTIONS(4285),
    [anon_sym_PERCENT_EQ] = ACTIONS(4285),
    [anon_sym_GT_GT_EQ] = ACTIONS(4285),
    [anon_sym_LT_LT_EQ] = ACTIONS(4285),
    [anon_sym_CARET_EQ] = ACTIONS(4285),
    [anon_sym_QMARK] = ACTIONS(4287),
    [anon_sym_DOT_DOT] = ACTIONS(4287),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4285),
    [anon_sym_and] = ACTIONS(4287),
    [anon_sym_or] = ACTIONS(4287),
    [anon_sym_PIPE_PIPE] = ACTIONS(4287),
    [anon_sym_AMP_AMP] = ACTIONS(4287),
    [anon_sym_LT_LT] = ACTIONS(4287),
    [anon_sym_GT_GT] = ACTIONS(4287),
    [anon_sym_EQ_EQ] = ACTIONS(4287),
    [anon_sym_BANG_EQ] = ACTIONS(4285),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4285),
    [anon_sym_LT_EQ_GT] = ACTIONS(4285),
    [anon_sym_EQ_TILDE] = ACTIONS(4285),
    [anon_sym_BANG_TILDE] = ACTIONS(4285),
    [anon_sym_LT_EQ] = ACTIONS(4287),
    [anon_sym_GT] = ACTIONS(4287),
    [anon_sym_GT_EQ] = ACTIONS(4285),
    [anon_sym_CARET] = ACTIONS(4287),
    [anon_sym_PLUS] = ACTIONS(4287),
    [anon_sym_SLASH] = ACTIONS(4287),
    [anon_sym_PERCENT] = ACTIONS(4287),
    [anon_sym_defined_QMARK] = ACTIONS(4285),
    [anon_sym_not] = ACTIONS(4287),
    [anon_sym_BANG] = ACTIONS(4287),
    [anon_sym_TILDE] = ACTIONS(4285),
    [sym_constant] = ACTIONS(4287),
    [sym_identifier] = ACTIONS(4287),
    [sym_instance_variable] = ACTIONS(4285),
    [sym_class_variable] = ACTIONS(4285),
    [sym_global_variable] = ACTIONS(4285),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4287),
    [sym_float] = ACTIONS(4287),
    [sym_complex] = ACTIONS(4285),
    [sym_super] = ACTIONS(4287),
    [anon_sym_true] = ACTIONS(4287),
    [anon_sym_TRUE] = ACTIONS(4287),
    [anon_sym_false] = ACTIONS(4287),
    [anon_sym_FALSE] = ACTIONS(4287),
    [sym_self] = ACTIONS(4287),
    [anon_sym_nil] = ACTIONS(4287),
    [anon_sym_NIL] = ACTIONS(4287),
    [sym_character] = ACTIONS(4285),
    [anon_sym_LBRACK2] = ACTIONS(4287),
    [anon_sym_DASH_GT] = ACTIONS(4285),
  },
  [3561] = {
    [anon_sym_RPAREN] = ACTIONS(9677),
    [sym_comment] = ACTIONS(87),
  },
  [3562] = {
    [sym__line_break] = ACTIONS(9679),
    [sym__simple_symbol] = ACTIONS(9679),
    [sym__string_start] = ACTIONS(9679),
    [sym__symbol_start] = ACTIONS(9679),
    [sym__subshell_start] = ACTIONS(9679),
    [sym__regex_start] = ACTIONS(9679),
    [sym__string_array_start] = ACTIONS(9679),
    [sym__symbol_array_start] = ACTIONS(9679),
    [sym__heredoc_body_start] = ACTIONS(9679),
    [sym_heredoc_beginning] = ACTIONS(9679),
    [sym__block_ampersand] = ACTIONS(9679),
    [sym__splat_star] = ACTIONS(9679),
    [sym__unary_minus] = ACTIONS(9679),
    [sym__binary_minus] = ACTIONS(9679),
    [sym__binary_star] = ACTIONS(9679),
    [sym__identifier_hash_key] = ACTIONS(9679),
    [ts_builtin_sym_end] = ACTIONS(9679),
    [anon_sym___END__] = ACTIONS(9681),
    [anon_sym_LBRACE] = ACTIONS(9679),
    [anon_sym_RBRACE] = ACTIONS(9679),
    [anon_sym_def] = ACTIONS(9681),
    [anon_sym_LPAREN] = ACTIONS(9681),
    [anon_sym_RPAREN] = ACTIONS(9679),
    [anon_sym_DOT] = ACTIONS(9681),
    [anon_sym_COLON_COLON] = ACTIONS(9681),
    [anon_sym_COMMA] = ACTIONS(9679),
    [anon_sym_PIPE] = ACTIONS(9681),
    [anon_sym_SEMI] = ACTIONS(9679),
    [anon_sym_STAR] = ACTIONS(9681),
    [anon_sym_STAR_STAR] = ACTIONS(9681),
    [anon_sym_AMP] = ACTIONS(9681),
    [anon_sym_EQ] = ACTIONS(9681),
    [anon_sym_class] = ACTIONS(9681),
    [anon_sym_LT] = ACTIONS(9681),
    [anon_sym_module] = ACTIONS(9681),
    [anon_sym_end] = ACTIONS(9681),
    [anon_sym_return] = ACTIONS(9681),
    [anon_sym_yield] = ACTIONS(9681),
    [anon_sym_break] = ACTIONS(9681),
    [anon_sym_next] = ACTIONS(9681),
    [sym_redo] = ACTIONS(9681),
    [sym_retry] = ACTIONS(9681),
    [anon_sym_if] = ACTIONS(9681),
    [anon_sym_unless] = ACTIONS(9681),
    [anon_sym_while] = ACTIONS(9681),
    [anon_sym_until] = ACTIONS(9681),
    [anon_sym_rescue] = ACTIONS(9681),
    [anon_sym_for] = ACTIONS(9681),
    [anon_sym_do] = ACTIONS(9681),
    [anon_sym_case] = ACTIONS(9681),
    [anon_sym_when] = ACTIONS(9681),
    [anon_sym_elsif] = ACTIONS(9681),
    [anon_sym_else] = ACTIONS(9681),
    [anon_sym_then] = ACTIONS(9681),
    [anon_sym_begin] = ACTIONS(9681),
    [anon_sym_ensure] = ACTIONS(9681),
    [anon_sym_LBRACK] = ACTIONS(9679),
    [anon_sym_COLON_COLON2] = ACTIONS(9679),
    [anon_sym_AMP_DOT] = ACTIONS(9679),
    [anon_sym_LPAREN2] = ACTIONS(9679),
    [anon_sym_PLUS_EQ] = ACTIONS(9679),
    [anon_sym_DASH_EQ] = ACTIONS(9679),
    [anon_sym_STAR_EQ] = ACTIONS(9679),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9679),
    [anon_sym_SLASH_EQ] = ACTIONS(9679),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9679),
    [anon_sym_PIPE_EQ] = ACTIONS(9679),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9679),
    [anon_sym_AMP_EQ] = ACTIONS(9679),
    [anon_sym_PERCENT_EQ] = ACTIONS(9679),
    [anon_sym_GT_GT_EQ] = ACTIONS(9679),
    [anon_sym_LT_LT_EQ] = ACTIONS(9679),
    [anon_sym_CARET_EQ] = ACTIONS(9679),
    [anon_sym_QMARK] = ACTIONS(9681),
    [anon_sym_DOT_DOT] = ACTIONS(9681),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9679),
    [anon_sym_and] = ACTIONS(9681),
    [anon_sym_or] = ACTIONS(9681),
    [anon_sym_PIPE_PIPE] = ACTIONS(9681),
    [anon_sym_AMP_AMP] = ACTIONS(9681),
    [anon_sym_LT_LT] = ACTIONS(9681),
    [anon_sym_GT_GT] = ACTIONS(9681),
    [anon_sym_EQ_EQ] = ACTIONS(9681),
    [anon_sym_BANG_EQ] = ACTIONS(9679),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9679),
    [anon_sym_LT_EQ_GT] = ACTIONS(9679),
    [anon_sym_EQ_TILDE] = ACTIONS(9679),
    [anon_sym_BANG_TILDE] = ACTIONS(9679),
    [anon_sym_LT_EQ] = ACTIONS(9681),
    [anon_sym_GT] = ACTIONS(9681),
    [anon_sym_GT_EQ] = ACTIONS(9679),
    [anon_sym_CARET] = ACTIONS(9681),
    [anon_sym_PLUS] = ACTIONS(9681),
    [anon_sym_SLASH] = ACTIONS(9681),
    [anon_sym_PERCENT] = ACTIONS(9681),
    [anon_sym_defined_QMARK] = ACTIONS(9679),
    [anon_sym_not] = ACTIONS(9681),
    [anon_sym_BANG] = ACTIONS(9681),
    [anon_sym_TILDE] = ACTIONS(9679),
    [sym_constant] = ACTIONS(9681),
    [sym_identifier] = ACTIONS(9681),
    [sym_instance_variable] = ACTIONS(9679),
    [sym_class_variable] = ACTIONS(9679),
    [sym_global_variable] = ACTIONS(9679),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(9681),
    [sym_float] = ACTIONS(9681),
    [sym_complex] = ACTIONS(9679),
    [sym_super] = ACTIONS(9681),
    [anon_sym_true] = ACTIONS(9681),
    [anon_sym_TRUE] = ACTIONS(9681),
    [anon_sym_false] = ACTIONS(9681),
    [anon_sym_FALSE] = ACTIONS(9681),
    [sym_self] = ACTIONS(9681),
    [anon_sym_nil] = ACTIONS(9681),
    [anon_sym_NIL] = ACTIONS(9681),
    [sym_character] = ACTIONS(9679),
    [anon_sym_LBRACK2] = ACTIONS(9681),
    [anon_sym_DASH_GT] = ACTIONS(9679),
  },
  [3563] = {
    [sym_heredoc_body] = STATE(3563),
    [aux_sym_call_repeat1] = STATE(3563),
    [sym__heredoc_body_start] = ACTIONS(9683),
    [anon_sym_PIPE] = ACTIONS(7914),
    [anon_sym_STAR] = ACTIONS(7919),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7914),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_LPAREN2] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7919),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [anon_sym_BANG] = ACTIONS(7919),
    [anon_sym_TILDE] = ACTIONS(7914),
    [sym_constant] = ACTIONS(7914),
    [sym_identifier] = ACTIONS(7914),
    [anon_sym_DASH] = ACTIONS(7919),
    [anon_sym_PLUS_AT] = ACTIONS(7914),
    [anon_sym_DASH_AT] = ACTIONS(7914),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(7919),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(7914),
    [anon_sym_BQUOTE] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [3564] = {
    [sym__line_break] = ACTIONS(9686),
    [sym__heredoc_body_start] = ACTIONS(9686),
    [sym__binary_minus] = ACTIONS(9686),
    [sym__binary_star] = ACTIONS(9686),
    [ts_builtin_sym_end] = ACTIONS(9686),
    [anon_sym___END__] = ACTIONS(9686),
    [anon_sym_LBRACE] = ACTIONS(9686),
    [anon_sym_RBRACE] = ACTIONS(9686),
    [anon_sym_RPAREN] = ACTIONS(9686),
    [anon_sym_DOT] = ACTIONS(9688),
    [anon_sym_COMMA] = ACTIONS(9686),
    [anon_sym_PIPE] = ACTIONS(9688),
    [anon_sym_SEMI] = ACTIONS(9686),
    [anon_sym_STAR_STAR] = ACTIONS(9688),
    [anon_sym_AMP] = ACTIONS(9688),
    [anon_sym_EQ] = ACTIONS(9688),
    [anon_sym_LT] = ACTIONS(9688),
    [anon_sym_end] = ACTIONS(9686),
    [anon_sym_if] = ACTIONS(9686),
    [anon_sym_unless] = ACTIONS(9686),
    [anon_sym_while] = ACTIONS(9686),
    [anon_sym_until] = ACTIONS(9686),
    [anon_sym_rescue] = ACTIONS(9686),
    [anon_sym_do] = ACTIONS(9686),
    [anon_sym_when] = ACTIONS(9686),
    [anon_sym_elsif] = ACTIONS(9686),
    [anon_sym_else] = ACTIONS(9686),
    [anon_sym_then] = ACTIONS(9686),
    [anon_sym_ensure] = ACTIONS(9686),
    [anon_sym_LBRACK] = ACTIONS(9686),
    [anon_sym_COLON_COLON2] = ACTIONS(9686),
    [anon_sym_AMP_DOT] = ACTIONS(9686),
    [anon_sym_PLUS_EQ] = ACTIONS(9686),
    [anon_sym_DASH_EQ] = ACTIONS(9686),
    [anon_sym_STAR_EQ] = ACTIONS(9686),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9686),
    [anon_sym_SLASH_EQ] = ACTIONS(9686),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9686),
    [anon_sym_PIPE_EQ] = ACTIONS(9686),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9686),
    [anon_sym_AMP_EQ] = ACTIONS(9686),
    [anon_sym_PERCENT_EQ] = ACTIONS(9686),
    [anon_sym_GT_GT_EQ] = ACTIONS(9686),
    [anon_sym_LT_LT_EQ] = ACTIONS(9686),
    [anon_sym_CARET_EQ] = ACTIONS(9686),
    [anon_sym_QMARK] = ACTIONS(9686),
    [anon_sym_DOT_DOT] = ACTIONS(9688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9686),
    [anon_sym_and] = ACTIONS(9686),
    [anon_sym_or] = ACTIONS(9686),
    [anon_sym_PIPE_PIPE] = ACTIONS(9688),
    [anon_sym_AMP_AMP] = ACTIONS(9688),
    [anon_sym_LT_LT] = ACTIONS(9688),
    [anon_sym_GT_GT] = ACTIONS(9688),
    [anon_sym_EQ_EQ] = ACTIONS(9688),
    [anon_sym_BANG_EQ] = ACTIONS(9686),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9686),
    [anon_sym_LT_EQ_GT] = ACTIONS(9686),
    [anon_sym_EQ_TILDE] = ACTIONS(9686),
    [anon_sym_BANG_TILDE] = ACTIONS(9686),
    [anon_sym_LT_EQ] = ACTIONS(9688),
    [anon_sym_GT] = ACTIONS(9688),
    [anon_sym_GT_EQ] = ACTIONS(9686),
    [anon_sym_CARET] = ACTIONS(9688),
    [anon_sym_PLUS] = ACTIONS(9688),
    [anon_sym_SLASH] = ACTIONS(9688),
    [anon_sym_PERCENT] = ACTIONS(9688),
    [sym_comment] = ACTIONS(87),
  },
  [3565] = {
    [sym__line_break] = ACTIONS(3030),
    [sym__string_start] = ACTIONS(3030),
    [sym__heredoc_body_start] = ACTIONS(3030),
    [sym__binary_minus] = ACTIONS(3030),
    [sym__binary_star] = ACTIONS(3030),
    [ts_builtin_sym_end] = ACTIONS(3030),
    [anon_sym___END__] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3030),
    [anon_sym_RBRACE] = ACTIONS(3030),
    [anon_sym_RPAREN] = ACTIONS(3030),
    [anon_sym_DOT] = ACTIONS(3032),
    [anon_sym_COMMA] = ACTIONS(3030),
    [anon_sym_PIPE] = ACTIONS(3032),
    [anon_sym_SEMI] = ACTIONS(3030),
    [anon_sym_STAR_STAR] = ACTIONS(3032),
    [anon_sym_AMP] = ACTIONS(3032),
    [anon_sym_COLON] = ACTIONS(3032),
    [anon_sym_EQ] = ACTIONS(3032),
    [anon_sym_LT] = ACTIONS(3032),
    [anon_sym_end] = ACTIONS(3030),
    [anon_sym_if] = ACTIONS(3030),
    [anon_sym_unless] = ACTIONS(3030),
    [anon_sym_while] = ACTIONS(3030),
    [anon_sym_until] = ACTIONS(3030),
    [anon_sym_rescue] = ACTIONS(3030),
    [anon_sym_do] = ACTIONS(3030),
    [anon_sym_when] = ACTIONS(3030),
    [anon_sym_elsif] = ACTIONS(3030),
    [anon_sym_else] = ACTIONS(3030),
    [anon_sym_then] = ACTIONS(3030),
    [anon_sym_ensure] = ACTIONS(3030),
    [anon_sym_EQ_GT] = ACTIONS(3030),
    [anon_sym_LBRACK] = ACTIONS(3030),
    [anon_sym_COLON_COLON2] = ACTIONS(3030),
    [anon_sym_AMP_DOT] = ACTIONS(3030),
    [anon_sym_PLUS_EQ] = ACTIONS(3030),
    [anon_sym_DASH_EQ] = ACTIONS(3030),
    [anon_sym_STAR_EQ] = ACTIONS(3030),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3030),
    [anon_sym_SLASH_EQ] = ACTIONS(3030),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3030),
    [anon_sym_PIPE_EQ] = ACTIONS(3030),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3030),
    [anon_sym_AMP_EQ] = ACTIONS(3030),
    [anon_sym_PERCENT_EQ] = ACTIONS(3030),
    [anon_sym_GT_GT_EQ] = ACTIONS(3030),
    [anon_sym_LT_LT_EQ] = ACTIONS(3030),
    [anon_sym_CARET_EQ] = ACTIONS(3030),
    [anon_sym_QMARK] = ACTIONS(3030),
    [anon_sym_DOT_DOT] = ACTIONS(3032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3030),
    [anon_sym_and] = ACTIONS(3030),
    [anon_sym_or] = ACTIONS(3030),
    [anon_sym_PIPE_PIPE] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_LT_LT] = ACTIONS(3032),
    [anon_sym_GT_GT] = ACTIONS(3032),
    [anon_sym_EQ_EQ] = ACTIONS(3032),
    [anon_sym_BANG_EQ] = ACTIONS(3030),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3030),
    [anon_sym_LT_EQ_GT] = ACTIONS(3030),
    [anon_sym_EQ_TILDE] = ACTIONS(3030),
    [anon_sym_BANG_TILDE] = ACTIONS(3030),
    [anon_sym_LT_EQ] = ACTIONS(3032),
    [anon_sym_GT] = ACTIONS(3032),
    [anon_sym_GT_EQ] = ACTIONS(3030),
    [anon_sym_CARET] = ACTIONS(3032),
    [anon_sym_PLUS] = ACTIONS(3032),
    [anon_sym_SLASH] = ACTIONS(3032),
    [anon_sym_PERCENT] = ACTIONS(3032),
    [sym_comment] = ACTIONS(87),
  },
  [3566] = {
    [sym__line_break] = ACTIONS(3042),
    [sym__heredoc_body_start] = ACTIONS(3042),
    [sym__binary_minus] = ACTIONS(3042),
    [sym__binary_star] = ACTIONS(3042),
    [ts_builtin_sym_end] = ACTIONS(3042),
    [anon_sym___END__] = ACTIONS(3042),
    [anon_sym_LBRACE] = ACTIONS(3042),
    [anon_sym_RBRACE] = ACTIONS(3042),
    [anon_sym_RPAREN] = ACTIONS(3042),
    [anon_sym_DOT] = ACTIONS(3044),
    [anon_sym_COMMA] = ACTIONS(3042),
    [anon_sym_PIPE] = ACTIONS(3044),
    [anon_sym_SEMI] = ACTIONS(3042),
    [anon_sym_STAR_STAR] = ACTIONS(3044),
    [anon_sym_AMP] = ACTIONS(3044),
    [anon_sym_EQ] = ACTIONS(3044),
    [anon_sym_LT] = ACTIONS(3044),
    [anon_sym_end] = ACTIONS(3042),
    [anon_sym_if] = ACTIONS(3042),
    [anon_sym_unless] = ACTIONS(3042),
    [anon_sym_while] = ACTIONS(3042),
    [anon_sym_until] = ACTIONS(3042),
    [anon_sym_rescue] = ACTIONS(3042),
    [anon_sym_do] = ACTIONS(3042),
    [anon_sym_when] = ACTIONS(3042),
    [anon_sym_elsif] = ACTIONS(3042),
    [anon_sym_else] = ACTIONS(3042),
    [anon_sym_then] = ACTIONS(3042),
    [anon_sym_ensure] = ACTIONS(3042),
    [anon_sym_EQ_GT] = ACTIONS(3042),
    [anon_sym_LBRACK] = ACTIONS(3042),
    [anon_sym_COLON_COLON2] = ACTIONS(3042),
    [anon_sym_AMP_DOT] = ACTIONS(3042),
    [anon_sym_PLUS_EQ] = ACTIONS(3042),
    [anon_sym_DASH_EQ] = ACTIONS(3042),
    [anon_sym_STAR_EQ] = ACTIONS(3042),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3042),
    [anon_sym_SLASH_EQ] = ACTIONS(3042),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3042),
    [anon_sym_PIPE_EQ] = ACTIONS(3042),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3042),
    [anon_sym_AMP_EQ] = ACTIONS(3042),
    [anon_sym_PERCENT_EQ] = ACTIONS(3042),
    [anon_sym_GT_GT_EQ] = ACTIONS(3042),
    [anon_sym_LT_LT_EQ] = ACTIONS(3042),
    [anon_sym_CARET_EQ] = ACTIONS(3042),
    [anon_sym_QMARK] = ACTIONS(3042),
    [anon_sym_DOT_DOT] = ACTIONS(3044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3042),
    [anon_sym_and] = ACTIONS(3042),
    [anon_sym_or] = ACTIONS(3042),
    [anon_sym_PIPE_PIPE] = ACTIONS(3044),
    [anon_sym_AMP_AMP] = ACTIONS(3044),
    [anon_sym_LT_LT] = ACTIONS(3044),
    [anon_sym_GT_GT] = ACTIONS(3044),
    [anon_sym_EQ_EQ] = ACTIONS(3044),
    [anon_sym_BANG_EQ] = ACTIONS(3042),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3042),
    [anon_sym_LT_EQ_GT] = ACTIONS(3042),
    [anon_sym_EQ_TILDE] = ACTIONS(3042),
    [anon_sym_BANG_TILDE] = ACTIONS(3042),
    [anon_sym_LT_EQ] = ACTIONS(3044),
    [anon_sym_GT] = ACTIONS(3044),
    [anon_sym_GT_EQ] = ACTIONS(3042),
    [anon_sym_CARET] = ACTIONS(3044),
    [anon_sym_PLUS] = ACTIONS(3044),
    [anon_sym_SLASH] = ACTIONS(3044),
    [anon_sym_PERCENT] = ACTIONS(3044),
    [sym_comment] = ACTIONS(87),
  },
  [3567] = {
    [sym__line_break] = ACTIONS(3046),
    [sym__heredoc_body_start] = ACTIONS(3046),
    [sym__binary_minus] = ACTIONS(3046),
    [sym__binary_star] = ACTIONS(3046),
    [ts_builtin_sym_end] = ACTIONS(3046),
    [anon_sym___END__] = ACTIONS(3046),
    [anon_sym_LBRACE] = ACTIONS(3046),
    [anon_sym_RBRACE] = ACTIONS(3046),
    [anon_sym_RPAREN] = ACTIONS(3046),
    [anon_sym_DOT] = ACTIONS(3048),
    [anon_sym_COMMA] = ACTIONS(3046),
    [anon_sym_PIPE] = ACTIONS(3048),
    [anon_sym_SEMI] = ACTIONS(3046),
    [anon_sym_STAR_STAR] = ACTIONS(3048),
    [anon_sym_AMP] = ACTIONS(3048),
    [anon_sym_EQ] = ACTIONS(3048),
    [anon_sym_LT] = ACTIONS(3048),
    [anon_sym_end] = ACTIONS(3046),
    [anon_sym_if] = ACTIONS(3046),
    [anon_sym_unless] = ACTIONS(3046),
    [anon_sym_while] = ACTIONS(3046),
    [anon_sym_until] = ACTIONS(3046),
    [anon_sym_rescue] = ACTIONS(3046),
    [anon_sym_do] = ACTIONS(3046),
    [anon_sym_when] = ACTIONS(3046),
    [anon_sym_elsif] = ACTIONS(3046),
    [anon_sym_else] = ACTIONS(3046),
    [anon_sym_then] = ACTIONS(3046),
    [anon_sym_ensure] = ACTIONS(3046),
    [anon_sym_EQ_GT] = ACTIONS(3046),
    [anon_sym_LBRACK] = ACTIONS(3046),
    [anon_sym_COLON_COLON2] = ACTIONS(3046),
    [anon_sym_AMP_DOT] = ACTIONS(3046),
    [anon_sym_PLUS_EQ] = ACTIONS(3046),
    [anon_sym_DASH_EQ] = ACTIONS(3046),
    [anon_sym_STAR_EQ] = ACTIONS(3046),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3046),
    [anon_sym_SLASH_EQ] = ACTIONS(3046),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3046),
    [anon_sym_PIPE_EQ] = ACTIONS(3046),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3046),
    [anon_sym_AMP_EQ] = ACTIONS(3046),
    [anon_sym_PERCENT_EQ] = ACTIONS(3046),
    [anon_sym_GT_GT_EQ] = ACTIONS(3046),
    [anon_sym_LT_LT_EQ] = ACTIONS(3046),
    [anon_sym_CARET_EQ] = ACTIONS(3046),
    [anon_sym_QMARK] = ACTIONS(3046),
    [anon_sym_DOT_DOT] = ACTIONS(3048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3046),
    [anon_sym_and] = ACTIONS(3046),
    [anon_sym_or] = ACTIONS(3046),
    [anon_sym_PIPE_PIPE] = ACTIONS(3048),
    [anon_sym_AMP_AMP] = ACTIONS(3048),
    [anon_sym_LT_LT] = ACTIONS(3048),
    [anon_sym_GT_GT] = ACTIONS(3048),
    [anon_sym_EQ_EQ] = ACTIONS(3048),
    [anon_sym_BANG_EQ] = ACTIONS(3046),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3046),
    [anon_sym_LT_EQ_GT] = ACTIONS(3046),
    [anon_sym_EQ_TILDE] = ACTIONS(3046),
    [anon_sym_BANG_TILDE] = ACTIONS(3046),
    [anon_sym_LT_EQ] = ACTIONS(3048),
    [anon_sym_GT] = ACTIONS(3048),
    [anon_sym_GT_EQ] = ACTIONS(3046),
    [anon_sym_CARET] = ACTIONS(3048),
    [anon_sym_PLUS] = ACTIONS(3048),
    [anon_sym_SLASH] = ACTIONS(3048),
    [anon_sym_PERCENT] = ACTIONS(3048),
    [sym_comment] = ACTIONS(87),
  },
  [3568] = {
    [sym__line_break] = ACTIONS(3050),
    [sym__heredoc_body_start] = ACTIONS(3050),
    [sym__binary_minus] = ACTIONS(3050),
    [sym__binary_star] = ACTIONS(3050),
    [ts_builtin_sym_end] = ACTIONS(3050),
    [anon_sym___END__] = ACTIONS(3050),
    [anon_sym_LBRACE] = ACTIONS(3050),
    [anon_sym_RBRACE] = ACTIONS(3050),
    [anon_sym_RPAREN] = ACTIONS(3050),
    [anon_sym_DOT] = ACTIONS(3052),
    [anon_sym_COMMA] = ACTIONS(3050),
    [anon_sym_PIPE] = ACTIONS(3052),
    [anon_sym_SEMI] = ACTIONS(3050),
    [anon_sym_STAR_STAR] = ACTIONS(3052),
    [anon_sym_AMP] = ACTIONS(3052),
    [anon_sym_EQ] = ACTIONS(3052),
    [anon_sym_LT] = ACTIONS(3052),
    [anon_sym_end] = ACTIONS(3050),
    [anon_sym_if] = ACTIONS(3050),
    [anon_sym_unless] = ACTIONS(3050),
    [anon_sym_while] = ACTIONS(3050),
    [anon_sym_until] = ACTIONS(3050),
    [anon_sym_rescue] = ACTIONS(3050),
    [anon_sym_do] = ACTIONS(3050),
    [anon_sym_when] = ACTIONS(3050),
    [anon_sym_elsif] = ACTIONS(3050),
    [anon_sym_else] = ACTIONS(3050),
    [anon_sym_then] = ACTIONS(3050),
    [anon_sym_ensure] = ACTIONS(3050),
    [anon_sym_EQ_GT] = ACTIONS(3050),
    [anon_sym_LBRACK] = ACTIONS(3050),
    [anon_sym_COLON_COLON2] = ACTIONS(3050),
    [anon_sym_AMP_DOT] = ACTIONS(3050),
    [anon_sym_PLUS_EQ] = ACTIONS(3050),
    [anon_sym_DASH_EQ] = ACTIONS(3050),
    [anon_sym_STAR_EQ] = ACTIONS(3050),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3050),
    [anon_sym_SLASH_EQ] = ACTIONS(3050),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3050),
    [anon_sym_PIPE_EQ] = ACTIONS(3050),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3050),
    [anon_sym_AMP_EQ] = ACTIONS(3050),
    [anon_sym_PERCENT_EQ] = ACTIONS(3050),
    [anon_sym_GT_GT_EQ] = ACTIONS(3050),
    [anon_sym_LT_LT_EQ] = ACTIONS(3050),
    [anon_sym_CARET_EQ] = ACTIONS(3050),
    [anon_sym_QMARK] = ACTIONS(3050),
    [anon_sym_DOT_DOT] = ACTIONS(3052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3050),
    [anon_sym_and] = ACTIONS(3050),
    [anon_sym_or] = ACTIONS(3050),
    [anon_sym_PIPE_PIPE] = ACTIONS(3052),
    [anon_sym_AMP_AMP] = ACTIONS(3052),
    [anon_sym_LT_LT] = ACTIONS(3052),
    [anon_sym_GT_GT] = ACTIONS(3052),
    [anon_sym_EQ_EQ] = ACTIONS(3052),
    [anon_sym_BANG_EQ] = ACTIONS(3050),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3050),
    [anon_sym_LT_EQ_GT] = ACTIONS(3050),
    [anon_sym_EQ_TILDE] = ACTIONS(3050),
    [anon_sym_BANG_TILDE] = ACTIONS(3050),
    [anon_sym_LT_EQ] = ACTIONS(3052),
    [anon_sym_GT] = ACTIONS(3052),
    [anon_sym_GT_EQ] = ACTIONS(3050),
    [anon_sym_CARET] = ACTIONS(3052),
    [anon_sym_PLUS] = ACTIONS(3052),
    [anon_sym_SLASH] = ACTIONS(3052),
    [anon_sym_PERCENT] = ACTIONS(3052),
    [sym_comment] = ACTIONS(87),
  },
  [3569] = {
    [sym__line_break] = ACTIONS(3056),
    [sym__heredoc_body_start] = ACTIONS(3056),
    [sym__binary_minus] = ACTIONS(3056),
    [sym__binary_star] = ACTIONS(3056),
    [ts_builtin_sym_end] = ACTIONS(3056),
    [anon_sym___END__] = ACTIONS(3056),
    [anon_sym_LBRACE] = ACTIONS(3056),
    [anon_sym_RBRACE] = ACTIONS(3056),
    [anon_sym_RPAREN] = ACTIONS(3056),
    [anon_sym_DOT] = ACTIONS(3058),
    [anon_sym_COMMA] = ACTIONS(3056),
    [anon_sym_PIPE] = ACTIONS(3058),
    [anon_sym_SEMI] = ACTIONS(3056),
    [anon_sym_STAR_STAR] = ACTIONS(3058),
    [anon_sym_AMP] = ACTIONS(3058),
    [anon_sym_EQ] = ACTIONS(3058),
    [anon_sym_LT] = ACTIONS(3058),
    [anon_sym_end] = ACTIONS(3056),
    [anon_sym_if] = ACTIONS(3056),
    [anon_sym_unless] = ACTIONS(3056),
    [anon_sym_while] = ACTIONS(3056),
    [anon_sym_until] = ACTIONS(3056),
    [anon_sym_rescue] = ACTIONS(3056),
    [anon_sym_do] = ACTIONS(3056),
    [anon_sym_when] = ACTIONS(3056),
    [anon_sym_elsif] = ACTIONS(3056),
    [anon_sym_else] = ACTIONS(3056),
    [anon_sym_then] = ACTIONS(3056),
    [anon_sym_ensure] = ACTIONS(3056),
    [anon_sym_EQ_GT] = ACTIONS(3056),
    [anon_sym_LBRACK] = ACTIONS(3056),
    [anon_sym_COLON_COLON2] = ACTIONS(3056),
    [anon_sym_AMP_DOT] = ACTIONS(3056),
    [anon_sym_PLUS_EQ] = ACTIONS(3056),
    [anon_sym_DASH_EQ] = ACTIONS(3056),
    [anon_sym_STAR_EQ] = ACTIONS(3056),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3056),
    [anon_sym_SLASH_EQ] = ACTIONS(3056),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3056),
    [anon_sym_PIPE_EQ] = ACTIONS(3056),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3056),
    [anon_sym_AMP_EQ] = ACTIONS(3056),
    [anon_sym_PERCENT_EQ] = ACTIONS(3056),
    [anon_sym_GT_GT_EQ] = ACTIONS(3056),
    [anon_sym_LT_LT_EQ] = ACTIONS(3056),
    [anon_sym_CARET_EQ] = ACTIONS(3056),
    [anon_sym_QMARK] = ACTIONS(3056),
    [anon_sym_DOT_DOT] = ACTIONS(3058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3056),
    [anon_sym_and] = ACTIONS(3056),
    [anon_sym_or] = ACTIONS(3056),
    [anon_sym_PIPE_PIPE] = ACTIONS(3058),
    [anon_sym_AMP_AMP] = ACTIONS(3058),
    [anon_sym_LT_LT] = ACTIONS(3058),
    [anon_sym_GT_GT] = ACTIONS(3058),
    [anon_sym_EQ_EQ] = ACTIONS(3058),
    [anon_sym_BANG_EQ] = ACTIONS(3056),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3056),
    [anon_sym_LT_EQ_GT] = ACTIONS(3056),
    [anon_sym_EQ_TILDE] = ACTIONS(3056),
    [anon_sym_BANG_TILDE] = ACTIONS(3056),
    [anon_sym_LT_EQ] = ACTIONS(3058),
    [anon_sym_GT] = ACTIONS(3058),
    [anon_sym_GT_EQ] = ACTIONS(3056),
    [anon_sym_CARET] = ACTIONS(3058),
    [anon_sym_PLUS] = ACTIONS(3058),
    [anon_sym_SLASH] = ACTIONS(3058),
    [anon_sym_PERCENT] = ACTIONS(3058),
    [sym_comment] = ACTIONS(87),
  },
  [3570] = {
    [sym__string_end] = ACTIONS(9690),
    [sym_comment] = ACTIONS(87),
  },
  [3571] = {
    [aux_sym_string_array_repeat1] = STATE(6256),
    [sym__string_end] = ACTIONS(9692),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(9694),
  },
  [3572] = {
    [sym__line_break] = ACTIONS(3066),
    [sym__heredoc_body_start] = ACTIONS(3066),
    [sym__binary_minus] = ACTIONS(3066),
    [sym__binary_star] = ACTIONS(3066),
    [ts_builtin_sym_end] = ACTIONS(3066),
    [anon_sym___END__] = ACTIONS(3066),
    [anon_sym_LBRACE] = ACTIONS(3066),
    [anon_sym_RBRACE] = ACTIONS(3066),
    [anon_sym_RPAREN] = ACTIONS(3066),
    [anon_sym_DOT] = ACTIONS(3068),
    [anon_sym_COMMA] = ACTIONS(3066),
    [anon_sym_PIPE] = ACTIONS(3068),
    [anon_sym_SEMI] = ACTIONS(3066),
    [anon_sym_STAR_STAR] = ACTIONS(3068),
    [anon_sym_AMP] = ACTIONS(3068),
    [anon_sym_EQ] = ACTIONS(3068),
    [anon_sym_LT] = ACTIONS(3068),
    [anon_sym_end] = ACTIONS(3066),
    [anon_sym_if] = ACTIONS(3066),
    [anon_sym_unless] = ACTIONS(3066),
    [anon_sym_while] = ACTIONS(3066),
    [anon_sym_until] = ACTIONS(3066),
    [anon_sym_rescue] = ACTIONS(3066),
    [anon_sym_do] = ACTIONS(3066),
    [anon_sym_when] = ACTIONS(3066),
    [anon_sym_elsif] = ACTIONS(3066),
    [anon_sym_else] = ACTIONS(3066),
    [anon_sym_then] = ACTIONS(3066),
    [anon_sym_ensure] = ACTIONS(3066),
    [anon_sym_EQ_GT] = ACTIONS(3066),
    [anon_sym_LBRACK] = ACTIONS(3066),
    [anon_sym_COLON_COLON2] = ACTIONS(3066),
    [anon_sym_AMP_DOT] = ACTIONS(3066),
    [anon_sym_PLUS_EQ] = ACTIONS(3066),
    [anon_sym_DASH_EQ] = ACTIONS(3066),
    [anon_sym_STAR_EQ] = ACTIONS(3066),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3066),
    [anon_sym_SLASH_EQ] = ACTIONS(3066),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3066),
    [anon_sym_PIPE_EQ] = ACTIONS(3066),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3066),
    [anon_sym_AMP_EQ] = ACTIONS(3066),
    [anon_sym_PERCENT_EQ] = ACTIONS(3066),
    [anon_sym_GT_GT_EQ] = ACTIONS(3066),
    [anon_sym_LT_LT_EQ] = ACTIONS(3066),
    [anon_sym_CARET_EQ] = ACTIONS(3066),
    [anon_sym_QMARK] = ACTIONS(3066),
    [anon_sym_DOT_DOT] = ACTIONS(3068),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3066),
    [anon_sym_and] = ACTIONS(3066),
    [anon_sym_or] = ACTIONS(3066),
    [anon_sym_PIPE_PIPE] = ACTIONS(3068),
    [anon_sym_AMP_AMP] = ACTIONS(3068),
    [anon_sym_LT_LT] = ACTIONS(3068),
    [anon_sym_GT_GT] = ACTIONS(3068),
    [anon_sym_EQ_EQ] = ACTIONS(3068),
    [anon_sym_BANG_EQ] = ACTIONS(3066),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3066),
    [anon_sym_LT_EQ_GT] = ACTIONS(3066),
    [anon_sym_EQ_TILDE] = ACTIONS(3066),
    [anon_sym_BANG_TILDE] = ACTIONS(3066),
    [anon_sym_LT_EQ] = ACTIONS(3068),
    [anon_sym_GT] = ACTIONS(3068),
    [anon_sym_GT_EQ] = ACTIONS(3066),
    [anon_sym_CARET] = ACTIONS(3068),
    [anon_sym_PLUS] = ACTIONS(3068),
    [anon_sym_SLASH] = ACTIONS(3068),
    [anon_sym_PERCENT] = ACTIONS(3068),
    [sym_comment] = ACTIONS(87),
  },
  [3573] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1697),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(9696),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [3574] = {
    [aux_sym_string_array_repeat1] = STATE(1699),
    [sym__string_end] = ACTIONS(9696),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(9698),
  },
  [3575] = {
    [sym__line_break] = ACTIONS(3085),
    [sym__heredoc_body_start] = ACTIONS(3085),
    [sym__binary_minus] = ACTIONS(3085),
    [sym__binary_star] = ACTIONS(3085),
    [ts_builtin_sym_end] = ACTIONS(3085),
    [anon_sym___END__] = ACTIONS(3085),
    [anon_sym_LBRACE] = ACTIONS(3085),
    [anon_sym_RBRACE] = ACTIONS(3085),
    [anon_sym_RPAREN] = ACTIONS(3085),
    [anon_sym_DOT] = ACTIONS(3087),
    [anon_sym_COMMA] = ACTIONS(3085),
    [anon_sym_PIPE] = ACTIONS(3087),
    [anon_sym_SEMI] = ACTIONS(3085),
    [anon_sym_STAR_STAR] = ACTIONS(3087),
    [anon_sym_AMP] = ACTIONS(3087),
    [anon_sym_EQ] = ACTIONS(3087),
    [anon_sym_LT] = ACTIONS(3087),
    [anon_sym_end] = ACTIONS(3085),
    [anon_sym_if] = ACTIONS(3085),
    [anon_sym_unless] = ACTIONS(3085),
    [anon_sym_while] = ACTIONS(3085),
    [anon_sym_until] = ACTIONS(3085),
    [anon_sym_rescue] = ACTIONS(3085),
    [anon_sym_do] = ACTIONS(3085),
    [anon_sym_when] = ACTIONS(3085),
    [anon_sym_elsif] = ACTIONS(3085),
    [anon_sym_else] = ACTIONS(3085),
    [anon_sym_then] = ACTIONS(3085),
    [anon_sym_ensure] = ACTIONS(3085),
    [anon_sym_EQ_GT] = ACTIONS(3085),
    [anon_sym_LBRACK] = ACTIONS(3085),
    [anon_sym_COLON_COLON2] = ACTIONS(3085),
    [anon_sym_AMP_DOT] = ACTIONS(3085),
    [anon_sym_PLUS_EQ] = ACTIONS(3085),
    [anon_sym_DASH_EQ] = ACTIONS(3085),
    [anon_sym_STAR_EQ] = ACTIONS(3085),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3085),
    [anon_sym_SLASH_EQ] = ACTIONS(3085),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3085),
    [anon_sym_PIPE_EQ] = ACTIONS(3085),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3085),
    [anon_sym_AMP_EQ] = ACTIONS(3085),
    [anon_sym_PERCENT_EQ] = ACTIONS(3085),
    [anon_sym_GT_GT_EQ] = ACTIONS(3085),
    [anon_sym_LT_LT_EQ] = ACTIONS(3085),
    [anon_sym_CARET_EQ] = ACTIONS(3085),
    [anon_sym_QMARK] = ACTIONS(3085),
    [anon_sym_DOT_DOT] = ACTIONS(3087),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3085),
    [anon_sym_and] = ACTIONS(3085),
    [anon_sym_or] = ACTIONS(3085),
    [anon_sym_PIPE_PIPE] = ACTIONS(3087),
    [anon_sym_AMP_AMP] = ACTIONS(3087),
    [anon_sym_LT_LT] = ACTIONS(3087),
    [anon_sym_GT_GT] = ACTIONS(3087),
    [anon_sym_EQ_EQ] = ACTIONS(3087),
    [anon_sym_BANG_EQ] = ACTIONS(3085),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3085),
    [anon_sym_LT_EQ_GT] = ACTIONS(3085),
    [anon_sym_EQ_TILDE] = ACTIONS(3085),
    [anon_sym_BANG_TILDE] = ACTIONS(3085),
    [anon_sym_LT_EQ] = ACTIONS(3087),
    [anon_sym_GT] = ACTIONS(3087),
    [anon_sym_GT_EQ] = ACTIONS(3085),
    [anon_sym_CARET] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3087),
    [anon_sym_SLASH] = ACTIONS(3087),
    [anon_sym_PERCENT] = ACTIONS(3087),
    [sym_comment] = ACTIONS(87),
  },
  [3576] = {
    [sym__string_end] = ACTIONS(9700),
    [sym_comment] = ACTIONS(87),
  },
  [3577] = {
    [aux_sym_symbol_array_repeat1] = STATE(6262),
    [sym__string_end] = ACTIONS(9702),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(9704),
  },
  [3578] = {
    [sym__line_break] = ACTIONS(3095),
    [sym__heredoc_body_start] = ACTIONS(3095),
    [sym__binary_minus] = ACTIONS(3095),
    [sym__binary_star] = ACTIONS(3095),
    [ts_builtin_sym_end] = ACTIONS(3095),
    [anon_sym___END__] = ACTIONS(3095),
    [anon_sym_LBRACE] = ACTIONS(3095),
    [anon_sym_RBRACE] = ACTIONS(3095),
    [anon_sym_RPAREN] = ACTIONS(3095),
    [anon_sym_DOT] = ACTIONS(3097),
    [anon_sym_COMMA] = ACTIONS(3095),
    [anon_sym_PIPE] = ACTIONS(3097),
    [anon_sym_SEMI] = ACTIONS(3095),
    [anon_sym_STAR_STAR] = ACTIONS(3097),
    [anon_sym_AMP] = ACTIONS(3097),
    [anon_sym_EQ] = ACTIONS(3097),
    [anon_sym_LT] = ACTIONS(3097),
    [anon_sym_end] = ACTIONS(3095),
    [anon_sym_if] = ACTIONS(3095),
    [anon_sym_unless] = ACTIONS(3095),
    [anon_sym_while] = ACTIONS(3095),
    [anon_sym_until] = ACTIONS(3095),
    [anon_sym_rescue] = ACTIONS(3095),
    [anon_sym_do] = ACTIONS(3095),
    [anon_sym_when] = ACTIONS(3095),
    [anon_sym_elsif] = ACTIONS(3095),
    [anon_sym_else] = ACTIONS(3095),
    [anon_sym_then] = ACTIONS(3095),
    [anon_sym_ensure] = ACTIONS(3095),
    [anon_sym_EQ_GT] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3095),
    [anon_sym_COLON_COLON2] = ACTIONS(3095),
    [anon_sym_AMP_DOT] = ACTIONS(3095),
    [anon_sym_PLUS_EQ] = ACTIONS(3095),
    [anon_sym_DASH_EQ] = ACTIONS(3095),
    [anon_sym_STAR_EQ] = ACTIONS(3095),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3095),
    [anon_sym_SLASH_EQ] = ACTIONS(3095),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3095),
    [anon_sym_PIPE_EQ] = ACTIONS(3095),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3095),
    [anon_sym_AMP_EQ] = ACTIONS(3095),
    [anon_sym_PERCENT_EQ] = ACTIONS(3095),
    [anon_sym_GT_GT_EQ] = ACTIONS(3095),
    [anon_sym_LT_LT_EQ] = ACTIONS(3095),
    [anon_sym_CARET_EQ] = ACTIONS(3095),
    [anon_sym_QMARK] = ACTIONS(3095),
    [anon_sym_DOT_DOT] = ACTIONS(3097),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3095),
    [anon_sym_and] = ACTIONS(3095),
    [anon_sym_or] = ACTIONS(3095),
    [anon_sym_PIPE_PIPE] = ACTIONS(3097),
    [anon_sym_AMP_AMP] = ACTIONS(3097),
    [anon_sym_LT_LT] = ACTIONS(3097),
    [anon_sym_GT_GT] = ACTIONS(3097),
    [anon_sym_EQ_EQ] = ACTIONS(3097),
    [anon_sym_BANG_EQ] = ACTIONS(3095),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3095),
    [anon_sym_LT_EQ_GT] = ACTIONS(3095),
    [anon_sym_EQ_TILDE] = ACTIONS(3095),
    [anon_sym_BANG_TILDE] = ACTIONS(3095),
    [anon_sym_LT_EQ] = ACTIONS(3097),
    [anon_sym_GT] = ACTIONS(3097),
    [anon_sym_GT_EQ] = ACTIONS(3095),
    [anon_sym_CARET] = ACTIONS(3097),
    [anon_sym_PLUS] = ACTIONS(3097),
    [anon_sym_SLASH] = ACTIONS(3097),
    [anon_sym_PERCENT] = ACTIONS(3097),
    [sym_comment] = ACTIONS(87),
  },
  [3579] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1705),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(9706),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [3580] = {
    [aux_sym_symbol_array_repeat1] = STATE(1707),
    [sym__string_end] = ACTIONS(9706),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(9708),
  },
  [3581] = {
    [sym__line_break] = ACTIONS(835),
    [sym__string_start] = ACTIONS(835),
    [sym__heredoc_body_start] = ACTIONS(835),
    [sym__binary_minus] = ACTIONS(835),
    [sym__binary_star] = ACTIONS(835),
    [ts_builtin_sym_end] = ACTIONS(835),
    [anon_sym___END__] = ACTIONS(835),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_RBRACE] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(835),
    [anon_sym_DOT] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(835),
    [anon_sym_PIPE] = ACTIONS(837),
    [anon_sym_SEMI] = ACTIONS(835),
    [anon_sym_STAR_STAR] = ACTIONS(837),
    [anon_sym_AMP] = ACTIONS(837),
    [anon_sym_EQ] = ACTIONS(837),
    [anon_sym_LT] = ACTIONS(837),
    [anon_sym_end] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_unless] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_until] = ACTIONS(835),
    [anon_sym_rescue] = ACTIONS(835),
    [anon_sym_do] = ACTIONS(835),
    [anon_sym_when] = ACTIONS(835),
    [anon_sym_elsif] = ACTIONS(835),
    [anon_sym_else] = ACTIONS(835),
    [anon_sym_then] = ACTIONS(835),
    [anon_sym_ensure] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_COLON_COLON2] = ACTIONS(835),
    [anon_sym_AMP_DOT] = ACTIONS(835),
    [anon_sym_PLUS_EQ] = ACTIONS(835),
    [anon_sym_DASH_EQ] = ACTIONS(835),
    [anon_sym_STAR_EQ] = ACTIONS(835),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(835),
    [anon_sym_SLASH_EQ] = ACTIONS(835),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(835),
    [anon_sym_PIPE_EQ] = ACTIONS(835),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(835),
    [anon_sym_AMP_EQ] = ACTIONS(835),
    [anon_sym_PERCENT_EQ] = ACTIONS(835),
    [anon_sym_GT_GT_EQ] = ACTIONS(835),
    [anon_sym_LT_LT_EQ] = ACTIONS(835),
    [anon_sym_CARET_EQ] = ACTIONS(835),
    [anon_sym_QMARK] = ACTIONS(835),
    [anon_sym_DOT_DOT] = ACTIONS(837),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(835),
    [anon_sym_and] = ACTIONS(835),
    [anon_sym_or] = ACTIONS(835),
    [anon_sym_PIPE_PIPE] = ACTIONS(837),
    [anon_sym_AMP_AMP] = ACTIONS(837),
    [anon_sym_LT_LT] = ACTIONS(837),
    [anon_sym_GT_GT] = ACTIONS(837),
    [anon_sym_EQ_EQ] = ACTIONS(837),
    [anon_sym_BANG_EQ] = ACTIONS(835),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(835),
    [anon_sym_LT_EQ_GT] = ACTIONS(835),
    [anon_sym_EQ_TILDE] = ACTIONS(835),
    [anon_sym_BANG_TILDE] = ACTIONS(835),
    [anon_sym_LT_EQ] = ACTIONS(837),
    [anon_sym_GT] = ACTIONS(837),
    [anon_sym_GT_EQ] = ACTIONS(835),
    [anon_sym_CARET] = ACTIONS(837),
    [anon_sym_PLUS] = ACTIONS(837),
    [anon_sym_SLASH] = ACTIONS(837),
    [anon_sym_PERCENT] = ACTIONS(837),
    [sym_comment] = ACTIONS(87),
  },
  [3582] = {
    [sym__string_end] = ACTIONS(9710),
    [sym_comment] = ACTIONS(87),
  },
  [3583] = {
    [sym__line_break] = ACTIONS(887),
    [sym__heredoc_body_start] = ACTIONS(887),
    [sym__binary_minus] = ACTIONS(887),
    [sym__binary_star] = ACTIONS(887),
    [ts_builtin_sym_end] = ACTIONS(887),
    [anon_sym___END__] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(887),
    [anon_sym_RBRACE] = ACTIONS(887),
    [anon_sym_RPAREN] = ACTIONS(887),
    [anon_sym_DOT] = ACTIONS(889),
    [anon_sym_COMMA] = ACTIONS(887),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI] = ACTIONS(887),
    [anon_sym_STAR_STAR] = ACTIONS(889),
    [anon_sym_AMP] = ACTIONS(889),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_LT] = ACTIONS(889),
    [anon_sym_end] = ACTIONS(887),
    [anon_sym_if] = ACTIONS(887),
    [anon_sym_unless] = ACTIONS(887),
    [anon_sym_while] = ACTIONS(887),
    [anon_sym_until] = ACTIONS(887),
    [anon_sym_rescue] = ACTIONS(887),
    [anon_sym_do] = ACTIONS(887),
    [anon_sym_when] = ACTIONS(887),
    [anon_sym_elsif] = ACTIONS(887),
    [anon_sym_else] = ACTIONS(887),
    [anon_sym_then] = ACTIONS(887),
    [anon_sym_ensure] = ACTIONS(887),
    [anon_sym_LBRACK] = ACTIONS(887),
    [anon_sym_COLON_COLON2] = ACTIONS(887),
    [anon_sym_AMP_DOT] = ACTIONS(887),
    [anon_sym_PLUS_EQ] = ACTIONS(887),
    [anon_sym_DASH_EQ] = ACTIONS(887),
    [anon_sym_STAR_EQ] = ACTIONS(887),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(887),
    [anon_sym_SLASH_EQ] = ACTIONS(887),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(887),
    [anon_sym_PIPE_EQ] = ACTIONS(887),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(887),
    [anon_sym_AMP_EQ] = ACTIONS(887),
    [anon_sym_PERCENT_EQ] = ACTIONS(887),
    [anon_sym_GT_GT_EQ] = ACTIONS(887),
    [anon_sym_LT_LT_EQ] = ACTIONS(887),
    [anon_sym_CARET_EQ] = ACTIONS(887),
    [anon_sym_QMARK] = ACTIONS(887),
    [anon_sym_DOT_DOT] = ACTIONS(889),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(887),
    [anon_sym_and] = ACTIONS(887),
    [anon_sym_or] = ACTIONS(887),
    [anon_sym_PIPE_PIPE] = ACTIONS(889),
    [anon_sym_AMP_AMP] = ACTIONS(889),
    [anon_sym_LT_LT] = ACTIONS(889),
    [anon_sym_GT_GT] = ACTIONS(889),
    [anon_sym_EQ_EQ] = ACTIONS(889),
    [anon_sym_BANG_EQ] = ACTIONS(887),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(887),
    [anon_sym_LT_EQ_GT] = ACTIONS(887),
    [anon_sym_EQ_TILDE] = ACTIONS(887),
    [anon_sym_BANG_TILDE] = ACTIONS(887),
    [anon_sym_LT_EQ] = ACTIONS(889),
    [anon_sym_GT] = ACTIONS(889),
    [anon_sym_GT_EQ] = ACTIONS(887),
    [anon_sym_CARET] = ACTIONS(889),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_SLASH] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [sym_comment] = ACTIONS(87),
  },
  [3584] = {
    [sym__string_end] = ACTIONS(9712),
    [sym_comment] = ACTIONS(87),
  },
  [3585] = {
    [sym__line_break] = ACTIONS(893),
    [sym__heredoc_body_start] = ACTIONS(893),
    [sym__binary_minus] = ACTIONS(893),
    [sym__binary_star] = ACTIONS(893),
    [ts_builtin_sym_end] = ACTIONS(893),
    [anon_sym___END__] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(893),
    [anon_sym_RBRACE] = ACTIONS(893),
    [anon_sym_RPAREN] = ACTIONS(893),
    [anon_sym_DOT] = ACTIONS(895),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_PIPE] = ACTIONS(895),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_STAR_STAR] = ACTIONS(895),
    [anon_sym_AMP] = ACTIONS(895),
    [anon_sym_EQ] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(895),
    [anon_sym_end] = ACTIONS(893),
    [anon_sym_if] = ACTIONS(893),
    [anon_sym_unless] = ACTIONS(893),
    [anon_sym_while] = ACTIONS(893),
    [anon_sym_until] = ACTIONS(893),
    [anon_sym_rescue] = ACTIONS(893),
    [anon_sym_do] = ACTIONS(893),
    [anon_sym_when] = ACTIONS(893),
    [anon_sym_elsif] = ACTIONS(893),
    [anon_sym_else] = ACTIONS(893),
    [anon_sym_then] = ACTIONS(893),
    [anon_sym_ensure] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(893),
    [anon_sym_COLON_COLON2] = ACTIONS(893),
    [anon_sym_AMP_DOT] = ACTIONS(893),
    [anon_sym_PLUS_EQ] = ACTIONS(893),
    [anon_sym_DASH_EQ] = ACTIONS(893),
    [anon_sym_STAR_EQ] = ACTIONS(893),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(893),
    [anon_sym_SLASH_EQ] = ACTIONS(893),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(893),
    [anon_sym_PIPE_EQ] = ACTIONS(893),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(893),
    [anon_sym_AMP_EQ] = ACTIONS(893),
    [anon_sym_PERCENT_EQ] = ACTIONS(893),
    [anon_sym_GT_GT_EQ] = ACTIONS(893),
    [anon_sym_LT_LT_EQ] = ACTIONS(893),
    [anon_sym_CARET_EQ] = ACTIONS(893),
    [anon_sym_QMARK] = ACTIONS(893),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(893),
    [anon_sym_and] = ACTIONS(893),
    [anon_sym_or] = ACTIONS(893),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_LT_LT] = ACTIONS(895),
    [anon_sym_GT_GT] = ACTIONS(895),
    [anon_sym_EQ_EQ] = ACTIONS(895),
    [anon_sym_BANG_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_LT_EQ_GT] = ACTIONS(893),
    [anon_sym_EQ_TILDE] = ACTIONS(893),
    [anon_sym_BANG_TILDE] = ACTIONS(893),
    [anon_sym_LT_EQ] = ACTIONS(895),
    [anon_sym_GT] = ACTIONS(895),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_CARET] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(895),
    [anon_sym_SLASH] = ACTIONS(895),
    [anon_sym_PERCENT] = ACTIONS(895),
    [sym_comment] = ACTIONS(87),
  },
  [3586] = {
    [sym__string_end] = ACTIONS(9714),
    [sym_comment] = ACTIONS(87),
  },
  [3587] = {
    [sym__line_break] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(899),
    [sym__binary_minus] = ACTIONS(899),
    [sym__binary_star] = ACTIONS(899),
    [ts_builtin_sym_end] = ACTIONS(899),
    [anon_sym___END__] = ACTIONS(899),
    [anon_sym_LBRACE] = ACTIONS(899),
    [anon_sym_RBRACE] = ACTIONS(899),
    [anon_sym_RPAREN] = ACTIONS(899),
    [anon_sym_DOT] = ACTIONS(901),
    [anon_sym_COMMA] = ACTIONS(899),
    [anon_sym_PIPE] = ACTIONS(901),
    [anon_sym_SEMI] = ACTIONS(899),
    [anon_sym_STAR_STAR] = ACTIONS(901),
    [anon_sym_AMP] = ACTIONS(901),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_LT] = ACTIONS(901),
    [anon_sym_end] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(899),
    [anon_sym_unless] = ACTIONS(899),
    [anon_sym_while] = ACTIONS(899),
    [anon_sym_until] = ACTIONS(899),
    [anon_sym_rescue] = ACTIONS(899),
    [anon_sym_do] = ACTIONS(899),
    [anon_sym_when] = ACTIONS(899),
    [anon_sym_elsif] = ACTIONS(899),
    [anon_sym_else] = ACTIONS(899),
    [anon_sym_then] = ACTIONS(899),
    [anon_sym_ensure] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(899),
    [anon_sym_COLON_COLON2] = ACTIONS(899),
    [anon_sym_AMP_DOT] = ACTIONS(899),
    [anon_sym_PLUS_EQ] = ACTIONS(899),
    [anon_sym_DASH_EQ] = ACTIONS(899),
    [anon_sym_STAR_EQ] = ACTIONS(899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(899),
    [anon_sym_SLASH_EQ] = ACTIONS(899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(899),
    [anon_sym_PIPE_EQ] = ACTIONS(899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(899),
    [anon_sym_AMP_EQ] = ACTIONS(899),
    [anon_sym_PERCENT_EQ] = ACTIONS(899),
    [anon_sym_GT_GT_EQ] = ACTIONS(899),
    [anon_sym_LT_LT_EQ] = ACTIONS(899),
    [anon_sym_CARET_EQ] = ACTIONS(899),
    [anon_sym_QMARK] = ACTIONS(899),
    [anon_sym_DOT_DOT] = ACTIONS(901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(899),
    [anon_sym_and] = ACTIONS(899),
    [anon_sym_or] = ACTIONS(899),
    [anon_sym_PIPE_PIPE] = ACTIONS(901),
    [anon_sym_AMP_AMP] = ACTIONS(901),
    [anon_sym_LT_LT] = ACTIONS(901),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_EQ_EQ] = ACTIONS(901),
    [anon_sym_BANG_EQ] = ACTIONS(899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(899),
    [anon_sym_LT_EQ_GT] = ACTIONS(899),
    [anon_sym_EQ_TILDE] = ACTIONS(899),
    [anon_sym_BANG_TILDE] = ACTIONS(899),
    [anon_sym_LT_EQ] = ACTIONS(901),
    [anon_sym_GT] = ACTIONS(901),
    [anon_sym_GT_EQ] = ACTIONS(899),
    [anon_sym_CARET] = ACTIONS(901),
    [anon_sym_PLUS] = ACTIONS(901),
    [anon_sym_SLASH] = ACTIONS(901),
    [anon_sym_PERCENT] = ACTIONS(901),
    [sym_comment] = ACTIONS(87),
  },
  [3588] = {
    [sym__string_end] = ACTIONS(9716),
    [sym_comment] = ACTIONS(87),
  },
  [3589] = {
    [sym__line_break] = ACTIONS(905),
    [sym__heredoc_body_start] = ACTIONS(905),
    [sym__binary_minus] = ACTIONS(905),
    [sym__binary_star] = ACTIONS(905),
    [ts_builtin_sym_end] = ACTIONS(905),
    [anon_sym___END__] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(905),
    [anon_sym_RBRACE] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(905),
    [anon_sym_DOT] = ACTIONS(907),
    [anon_sym_COMMA] = ACTIONS(905),
    [anon_sym_PIPE] = ACTIONS(907),
    [anon_sym_SEMI] = ACTIONS(905),
    [anon_sym_STAR_STAR] = ACTIONS(907),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(907),
    [anon_sym_LT] = ACTIONS(907),
    [anon_sym_end] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_unless] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_until] = ACTIONS(905),
    [anon_sym_rescue] = ACTIONS(905),
    [anon_sym_do] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(905),
    [anon_sym_elsif] = ACTIONS(905),
    [anon_sym_else] = ACTIONS(905),
    [anon_sym_then] = ACTIONS(905),
    [anon_sym_ensure] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_COLON_COLON2] = ACTIONS(905),
    [anon_sym_AMP_DOT] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_QMARK] = ACTIONS(905),
    [anon_sym_DOT_DOT] = ACTIONS(907),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(905),
    [anon_sym_and] = ACTIONS(905),
    [anon_sym_or] = ACTIONS(905),
    [anon_sym_PIPE_PIPE] = ACTIONS(907),
    [anon_sym_AMP_AMP] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(907),
    [anon_sym_GT_GT] = ACTIONS(907),
    [anon_sym_EQ_EQ] = ACTIONS(907),
    [anon_sym_BANG_EQ] = ACTIONS(905),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(905),
    [anon_sym_LT_EQ_GT] = ACTIONS(905),
    [anon_sym_EQ_TILDE] = ACTIONS(905),
    [anon_sym_BANG_TILDE] = ACTIONS(905),
    [anon_sym_LT_EQ] = ACTIONS(907),
    [anon_sym_GT] = ACTIONS(907),
    [anon_sym_GT_EQ] = ACTIONS(905),
    [anon_sym_CARET] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(907),
    [anon_sym_SLASH] = ACTIONS(907),
    [anon_sym_PERCENT] = ACTIONS(907),
    [sym_comment] = ACTIONS(87),
  },
  [3590] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(6271),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(9718),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(9720),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [3591] = {
    [aux_sym_string_array_repeat1] = STATE(6274),
    [sym__string_end] = ACTIONS(9722),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(9724),
  },
  [3592] = {
    [sym__line_break] = ACTIONS(923),
    [sym__heredoc_body_start] = ACTIONS(923),
    [sym__binary_minus] = ACTIONS(923),
    [sym__binary_star] = ACTIONS(923),
    [ts_builtin_sym_end] = ACTIONS(923),
    [anon_sym___END__] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(923),
    [anon_sym_RBRACE] = ACTIONS(923),
    [anon_sym_RPAREN] = ACTIONS(923),
    [anon_sym_DOT] = ACTIONS(925),
    [anon_sym_COMMA] = ACTIONS(923),
    [anon_sym_PIPE] = ACTIONS(925),
    [anon_sym_SEMI] = ACTIONS(923),
    [anon_sym_STAR_STAR] = ACTIONS(925),
    [anon_sym_AMP] = ACTIONS(925),
    [anon_sym_EQ] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(925),
    [anon_sym_end] = ACTIONS(923),
    [anon_sym_if] = ACTIONS(923),
    [anon_sym_unless] = ACTIONS(923),
    [anon_sym_while] = ACTIONS(923),
    [anon_sym_until] = ACTIONS(923),
    [anon_sym_rescue] = ACTIONS(923),
    [anon_sym_do] = ACTIONS(923),
    [anon_sym_when] = ACTIONS(923),
    [anon_sym_elsif] = ACTIONS(923),
    [anon_sym_else] = ACTIONS(923),
    [anon_sym_then] = ACTIONS(923),
    [anon_sym_ensure] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(923),
    [anon_sym_COLON_COLON2] = ACTIONS(923),
    [anon_sym_AMP_DOT] = ACTIONS(923),
    [anon_sym_PLUS_EQ] = ACTIONS(923),
    [anon_sym_DASH_EQ] = ACTIONS(923),
    [anon_sym_STAR_EQ] = ACTIONS(923),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(923),
    [anon_sym_SLASH_EQ] = ACTIONS(923),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(923),
    [anon_sym_PIPE_EQ] = ACTIONS(923),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(923),
    [anon_sym_AMP_EQ] = ACTIONS(923),
    [anon_sym_PERCENT_EQ] = ACTIONS(923),
    [anon_sym_GT_GT_EQ] = ACTIONS(923),
    [anon_sym_LT_LT_EQ] = ACTIONS(923),
    [anon_sym_CARET_EQ] = ACTIONS(923),
    [anon_sym_QMARK] = ACTIONS(923),
    [anon_sym_DOT_DOT] = ACTIONS(925),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(923),
    [anon_sym_and] = ACTIONS(923),
    [anon_sym_or] = ACTIONS(923),
    [anon_sym_PIPE_PIPE] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(925),
    [anon_sym_LT_LT] = ACTIONS(925),
    [anon_sym_GT_GT] = ACTIONS(925),
    [anon_sym_EQ_EQ] = ACTIONS(925),
    [anon_sym_BANG_EQ] = ACTIONS(923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(923),
    [anon_sym_LT_EQ_GT] = ACTIONS(923),
    [anon_sym_EQ_TILDE] = ACTIONS(923),
    [anon_sym_BANG_TILDE] = ACTIONS(923),
    [anon_sym_LT_EQ] = ACTIONS(925),
    [anon_sym_GT] = ACTIONS(925),
    [anon_sym_GT_EQ] = ACTIONS(923),
    [anon_sym_CARET] = ACTIONS(925),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(925),
    [anon_sym_PERCENT] = ACTIONS(925),
    [sym_comment] = ACTIONS(87),
  },
  [3593] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(6277),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(9726),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(9728),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [3594] = {
    [aux_sym_symbol_array_repeat1] = STATE(6280),
    [sym__string_end] = ACTIONS(9730),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(9732),
  },
  [3595] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [ts_builtin_sym_end] = ACTIONS(935),
    [anon_sym___END__] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [3596] = {
    [sym__line_break] = ACTIONS(993),
    [sym__heredoc_body_start] = ACTIONS(993),
    [sym__binary_minus] = ACTIONS(993),
    [sym__binary_star] = ACTIONS(993),
    [ts_builtin_sym_end] = ACTIONS(993),
    [anon_sym___END__] = ACTIONS(993),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_RBRACE] = ACTIONS(993),
    [anon_sym_RPAREN] = ACTIONS(993),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(993),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_SEMI] = ACTIONS(993),
    [anon_sym_STAR_STAR] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_EQ] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(995),
    [anon_sym_end] = ACTIONS(993),
    [anon_sym_if] = ACTIONS(993),
    [anon_sym_unless] = ACTIONS(993),
    [anon_sym_while] = ACTIONS(993),
    [anon_sym_until] = ACTIONS(993),
    [anon_sym_rescue] = ACTIONS(993),
    [anon_sym_do] = ACTIONS(993),
    [anon_sym_when] = ACTIONS(993),
    [anon_sym_elsif] = ACTIONS(993),
    [anon_sym_else] = ACTIONS(993),
    [anon_sym_then] = ACTIONS(993),
    [anon_sym_ensure] = ACTIONS(993),
    [anon_sym_LBRACK] = ACTIONS(993),
    [anon_sym_COLON_COLON2] = ACTIONS(993),
    [anon_sym_AMP_DOT] = ACTIONS(993),
    [anon_sym_PLUS_EQ] = ACTIONS(993),
    [anon_sym_DASH_EQ] = ACTIONS(993),
    [anon_sym_STAR_EQ] = ACTIONS(993),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(993),
    [anon_sym_SLASH_EQ] = ACTIONS(993),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(993),
    [anon_sym_PIPE_EQ] = ACTIONS(993),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(993),
    [anon_sym_AMP_EQ] = ACTIONS(993),
    [anon_sym_PERCENT_EQ] = ACTIONS(993),
    [anon_sym_GT_GT_EQ] = ACTIONS(993),
    [anon_sym_LT_LT_EQ] = ACTIONS(993),
    [anon_sym_CARET_EQ] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(993),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(993),
    [anon_sym_and] = ACTIONS(993),
    [anon_sym_or] = ACTIONS(993),
    [anon_sym_PIPE_PIPE] = ACTIONS(995),
    [anon_sym_AMP_AMP] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(995),
    [anon_sym_GT_GT] = ACTIONS(995),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(993),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(993),
    [anon_sym_LT_EQ_GT] = ACTIONS(993),
    [anon_sym_EQ_TILDE] = ACTIONS(993),
    [anon_sym_BANG_TILDE] = ACTIONS(993),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(993),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_PLUS] = ACTIONS(995),
    [anon_sym_SLASH] = ACTIONS(995),
    [anon_sym_PERCENT] = ACTIONS(995),
    [sym_comment] = ACTIONS(87),
  },
  [3597] = {
    [anon_sym_RBRACE] = ACTIONS(9734),
    [sym_comment] = ACTIONS(87),
  },
  [3598] = {
    [sym_heredoc_body] = STATE(6282),
    [sym__heredoc_body_start] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(9734),
    [sym_comment] = ACTIONS(87),
  },
  [3599] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(6283),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(674),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(674),
    [sym_assignment] = STATE(6283),
    [sym_operator_assignment] = STATE(6283),
    [sym_conditional] = STATE(6283),
    [sym_range] = STATE(6283),
    [sym_binary] = STATE(6283),
    [sym_unary] = STATE(6283),
    [sym_left_assignment_list] = STATE(673),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(674),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(674),
    [sym_false] = STATE(674),
    [sym_nil] = STATE(674),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(675),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1243),
    [anon_sym_yield] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1247),
    [anon_sym_next] = ACTIONS(1249),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3600] = {
    [sym__line_break] = ACTIONS(1273),
    [sym__heredoc_body_start] = ACTIONS(1273),
    [sym__binary_minus] = ACTIONS(1273),
    [sym__binary_star] = ACTIONS(1273),
    [ts_builtin_sym_end] = ACTIONS(1273),
    [anon_sym___END__] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_RBRACE] = ACTIONS(1273),
    [anon_sym_RPAREN] = ACTIONS(1273),
    [anon_sym_DOT] = ACTIONS(1275),
    [anon_sym_COMMA] = ACTIONS(1273),
    [anon_sym_PIPE] = ACTIONS(1275),
    [anon_sym_SEMI] = ACTIONS(1273),
    [anon_sym_STAR_STAR] = ACTIONS(1275),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_EQ] = ACTIONS(1275),
    [anon_sym_LT] = ACTIONS(1275),
    [anon_sym_end] = ACTIONS(1273),
    [anon_sym_if] = ACTIONS(1273),
    [anon_sym_unless] = ACTIONS(1273),
    [anon_sym_while] = ACTIONS(1273),
    [anon_sym_until] = ACTIONS(1273),
    [anon_sym_rescue] = ACTIONS(1273),
    [anon_sym_do] = ACTIONS(1273),
    [anon_sym_when] = ACTIONS(1273),
    [anon_sym_elsif] = ACTIONS(1273),
    [anon_sym_else] = ACTIONS(1273),
    [anon_sym_then] = ACTIONS(1273),
    [anon_sym_ensure] = ACTIONS(1273),
    [anon_sym_LBRACK] = ACTIONS(1273),
    [anon_sym_COLON_COLON2] = ACTIONS(1273),
    [anon_sym_AMP_DOT] = ACTIONS(1273),
    [anon_sym_PLUS_EQ] = ACTIONS(1273),
    [anon_sym_DASH_EQ] = ACTIONS(1273),
    [anon_sym_STAR_EQ] = ACTIONS(1273),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1273),
    [anon_sym_SLASH_EQ] = ACTIONS(1273),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1273),
    [anon_sym_PIPE_EQ] = ACTIONS(1273),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1273),
    [anon_sym_AMP_EQ] = ACTIONS(1273),
    [anon_sym_PERCENT_EQ] = ACTIONS(1273),
    [anon_sym_GT_GT_EQ] = ACTIONS(1273),
    [anon_sym_LT_LT_EQ] = ACTIONS(1273),
    [anon_sym_CARET_EQ] = ACTIONS(1273),
    [anon_sym_QMARK] = ACTIONS(1273),
    [anon_sym_DOT_DOT] = ACTIONS(1275),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_and] = ACTIONS(1273),
    [anon_sym_or] = ACTIONS(1273),
    [anon_sym_PIPE_PIPE] = ACTIONS(1275),
    [anon_sym_AMP_AMP] = ACTIONS(1275),
    [anon_sym_LT_LT] = ACTIONS(1275),
    [anon_sym_GT_GT] = ACTIONS(1275),
    [anon_sym_EQ_EQ] = ACTIONS(1275),
    [anon_sym_BANG_EQ] = ACTIONS(1273),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1273),
    [anon_sym_LT_EQ_GT] = ACTIONS(1273),
    [anon_sym_EQ_TILDE] = ACTIONS(1273),
    [anon_sym_BANG_TILDE] = ACTIONS(1273),
    [anon_sym_LT_EQ] = ACTIONS(1275),
    [anon_sym_GT] = ACTIONS(1275),
    [anon_sym_GT_EQ] = ACTIONS(1273),
    [anon_sym_CARET] = ACTIONS(1275),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_SLASH] = ACTIONS(1275),
    [anon_sym_PERCENT] = ACTIONS(1275),
    [sym_comment] = ACTIONS(87),
  },
  [3601] = {
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [sym_comment] = ACTIONS(87),
  },
  [3602] = {
    [sym_method_parameters] = STATE(6285),
    [sym__simple_formal_parameter] = STATE(684),
    [sym_splat_parameter] = STATE(684),
    [sym_hash_splat_parameter] = STATE(684),
    [sym_block_parameter] = STATE(684),
    [sym_keyword_parameter] = STATE(684),
    [sym_optional_parameter] = STATE(684),
    [sym_heredoc_body] = STATE(6285),
    [sym__terminator] = STATE(6285),
    [sym__line_break] = ACTIONS(9738),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_SEMI] = ACTIONS(9738),
    [anon_sym_STAR] = ACTIONS(1283),
    [anon_sym_STAR_STAR] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1287),
    [sym_identifier] = ACTIONS(1289),
    [sym_comment] = ACTIONS(87),
  },
  [3603] = {
    [sym__line_break] = ACTIONS(1291),
    [sym__heredoc_body_start] = ACTIONS(1291),
    [sym__binary_minus] = ACTIONS(1291),
    [sym__binary_star] = ACTIONS(1291),
    [ts_builtin_sym_end] = ACTIONS(1291),
    [anon_sym___END__] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1291),
    [anon_sym_RBRACE] = ACTIONS(1291),
    [anon_sym_RPAREN] = ACTIONS(1291),
    [anon_sym_DOT] = ACTIONS(1293),
    [anon_sym_COMMA] = ACTIONS(1291),
    [anon_sym_PIPE] = ACTIONS(1293),
    [anon_sym_SEMI] = ACTIONS(1291),
    [anon_sym_STAR_STAR] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1293),
    [anon_sym_EQ] = ACTIONS(1293),
    [anon_sym_LT] = ACTIONS(1293),
    [anon_sym_end] = ACTIONS(1291),
    [anon_sym_if] = ACTIONS(1291),
    [anon_sym_unless] = ACTIONS(1291),
    [anon_sym_while] = ACTIONS(1291),
    [anon_sym_until] = ACTIONS(1291),
    [anon_sym_rescue] = ACTIONS(1291),
    [anon_sym_do] = ACTIONS(1291),
    [anon_sym_when] = ACTIONS(1291),
    [anon_sym_elsif] = ACTIONS(1291),
    [anon_sym_else] = ACTIONS(1291),
    [anon_sym_then] = ACTIONS(1291),
    [anon_sym_ensure] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_COLON_COLON2] = ACTIONS(1291),
    [anon_sym_AMP_DOT] = ACTIONS(1291),
    [anon_sym_PLUS_EQ] = ACTIONS(1291),
    [anon_sym_DASH_EQ] = ACTIONS(1291),
    [anon_sym_STAR_EQ] = ACTIONS(1291),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1291),
    [anon_sym_SLASH_EQ] = ACTIONS(1291),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1291),
    [anon_sym_PIPE_EQ] = ACTIONS(1291),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1291),
    [anon_sym_AMP_EQ] = ACTIONS(1291),
    [anon_sym_PERCENT_EQ] = ACTIONS(1291),
    [anon_sym_GT_GT_EQ] = ACTIONS(1291),
    [anon_sym_LT_LT_EQ] = ACTIONS(1291),
    [anon_sym_CARET_EQ] = ACTIONS(1291),
    [anon_sym_QMARK] = ACTIONS(1291),
    [anon_sym_DOT_DOT] = ACTIONS(1293),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1291),
    [anon_sym_and] = ACTIONS(1291),
    [anon_sym_or] = ACTIONS(1291),
    [anon_sym_PIPE_PIPE] = ACTIONS(1293),
    [anon_sym_AMP_AMP] = ACTIONS(1293),
    [anon_sym_LT_LT] = ACTIONS(1293),
    [anon_sym_GT_GT] = ACTIONS(1293),
    [anon_sym_EQ_EQ] = ACTIONS(1293),
    [anon_sym_BANG_EQ] = ACTIONS(1291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1291),
    [anon_sym_LT_EQ_GT] = ACTIONS(1291),
    [anon_sym_EQ_TILDE] = ACTIONS(1291),
    [anon_sym_BANG_TILDE] = ACTIONS(1291),
    [anon_sym_LT_EQ] = ACTIONS(1293),
    [anon_sym_GT] = ACTIONS(1293),
    [anon_sym_GT_EQ] = ACTIONS(1291),
    [anon_sym_CARET] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1293),
    [anon_sym_SLASH] = ACTIONS(1293),
    [anon_sym_PERCENT] = ACTIONS(1293),
    [sym_comment] = ACTIONS(87),
  },
  [3604] = {
    [anon_sym_RPAREN] = ACTIONS(9740),
    [sym_comment] = ACTIONS(87),
  },
  [3605] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(6287),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(6287),
    [sym_operator_assignment] = STATE(6287),
    [sym_conditional] = STATE(6287),
    [sym_range] = STATE(6287),
    [sym_binary] = STATE(6287),
    [sym_unary] = STATE(6287),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(485),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(495),
    [anon_sym_defined_QMARK] = ACTIONS(497),
    [anon_sym_not] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(501),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3606] = {
    [sym_superclass] = STATE(6288),
    [sym_heredoc_body] = STATE(6289),
    [sym__terminator] = STATE(6289),
    [sym__line_break] = ACTIONS(9742),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1089),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(9742),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1089),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1517),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1089),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [3607] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_superclass] = STATE(6288),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(859),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym_argument_list] = STATE(832),
    [sym__argument_list_with_parens] = STATE(860),
    [sym__argument] = STATE(861),
    [sym_splat_argument] = STATE(861),
    [sym_hash_splat_argument] = STATE(861),
    [sym_block_argument] = STATE(861),
    [sym_do_block] = STATE(835),
    [sym_block] = STATE(835),
    [sym_assignment] = STATE(859),
    [sym_operator_assignment] = STATE(859),
    [sym_conditional] = STATE(859),
    [sym_range] = STATE(859),
    [sym_binary] = STATE(859),
    [sym_unary] = STATE(859),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(864),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_heredoc_body] = STATE(6289),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(861),
    [sym_lambda] = STATE(347),
    [sym__terminator] = STATE(6289),
    [sym__line_break] = ACTIONS(9742),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1521),
    [sym__splat_star] = ACTIONS(1523),
    [sym__unary_minus] = ACTIONS(1525),
    [sym__identifier_hash_key] = ACTIONS(1527),
    [anon_sym_LBRACE] = ACTIONS(1529),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(743),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(9742),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1531),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(1517),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1473),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(1549),
    [sym_identifier] = ACTIONS(1549),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3608] = {
    [sym_heredoc_body] = STATE(6291),
    [sym__terminator] = STATE(6291),
    [sym__line_break] = ACTIONS(9744),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1089),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(9744),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1089),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(9746),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1089),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [3609] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(859),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym_argument_list] = STATE(832),
    [sym__argument_list_with_parens] = STATE(860),
    [sym__argument] = STATE(861),
    [sym_splat_argument] = STATE(861),
    [sym_hash_splat_argument] = STATE(861),
    [sym_block_argument] = STATE(861),
    [sym_do_block] = STATE(835),
    [sym_block] = STATE(835),
    [sym_assignment] = STATE(859),
    [sym_operator_assignment] = STATE(859),
    [sym_conditional] = STATE(859),
    [sym_range] = STATE(859),
    [sym_binary] = STATE(859),
    [sym_unary] = STATE(859),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(864),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_heredoc_body] = STATE(6291),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(861),
    [sym_lambda] = STATE(347),
    [sym__terminator] = STATE(6291),
    [sym__line_break] = ACTIONS(9744),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1521),
    [sym__splat_star] = ACTIONS(1523),
    [sym__unary_minus] = ACTIONS(1525),
    [sym__identifier_hash_key] = ACTIONS(1527),
    [anon_sym_LBRACE] = ACTIONS(1529),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(743),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(9744),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1531),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_end] = ACTIONS(9746),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1473),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(1549),
    [sym_identifier] = ACTIONS(1549),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3610] = {
    [sym__line_break] = ACTIONS(1677),
    [sym__heredoc_body_start] = ACTIONS(1677),
    [sym__binary_minus] = ACTIONS(1677),
    [sym__binary_star] = ACTIONS(1677),
    [ts_builtin_sym_end] = ACTIONS(1677),
    [anon_sym___END__] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1677),
    [anon_sym_RBRACE] = ACTIONS(1677),
    [anon_sym_RPAREN] = ACTIONS(1677),
    [anon_sym_DOT] = ACTIONS(1679),
    [anon_sym_COMMA] = ACTIONS(1677),
    [anon_sym_PIPE] = ACTIONS(1679),
    [anon_sym_SEMI] = ACTIONS(1677),
    [anon_sym_STAR_STAR] = ACTIONS(1679),
    [anon_sym_AMP] = ACTIONS(1679),
    [anon_sym_EQ] = ACTIONS(1679),
    [anon_sym_LT] = ACTIONS(1679),
    [anon_sym_end] = ACTIONS(1677),
    [anon_sym_if] = ACTIONS(1677),
    [anon_sym_unless] = ACTIONS(1677),
    [anon_sym_while] = ACTIONS(1677),
    [anon_sym_until] = ACTIONS(1677),
    [anon_sym_rescue] = ACTIONS(1677),
    [anon_sym_do] = ACTIONS(1677),
    [anon_sym_when] = ACTIONS(1677),
    [anon_sym_elsif] = ACTIONS(1677),
    [anon_sym_else] = ACTIONS(1677),
    [anon_sym_then] = ACTIONS(1677),
    [anon_sym_ensure] = ACTIONS(1677),
    [anon_sym_LBRACK] = ACTIONS(1677),
    [anon_sym_COLON_COLON2] = ACTIONS(1677),
    [anon_sym_AMP_DOT] = ACTIONS(1677),
    [anon_sym_PLUS_EQ] = ACTIONS(1677),
    [anon_sym_DASH_EQ] = ACTIONS(1677),
    [anon_sym_STAR_EQ] = ACTIONS(1677),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1677),
    [anon_sym_SLASH_EQ] = ACTIONS(1677),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1677),
    [anon_sym_PIPE_EQ] = ACTIONS(1677),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1677),
    [anon_sym_AMP_EQ] = ACTIONS(1677),
    [anon_sym_PERCENT_EQ] = ACTIONS(1677),
    [anon_sym_GT_GT_EQ] = ACTIONS(1677),
    [anon_sym_LT_LT_EQ] = ACTIONS(1677),
    [anon_sym_CARET_EQ] = ACTIONS(1677),
    [anon_sym_QMARK] = ACTIONS(1677),
    [anon_sym_DOT_DOT] = ACTIONS(1679),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1677),
    [anon_sym_and] = ACTIONS(1677),
    [anon_sym_or] = ACTIONS(1677),
    [anon_sym_PIPE_PIPE] = ACTIONS(1679),
    [anon_sym_AMP_AMP] = ACTIONS(1679),
    [anon_sym_LT_LT] = ACTIONS(1679),
    [anon_sym_GT_GT] = ACTIONS(1679),
    [anon_sym_EQ_EQ] = ACTIONS(1679),
    [anon_sym_BANG_EQ] = ACTIONS(1677),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1677),
    [anon_sym_LT_EQ_GT] = ACTIONS(1677),
    [anon_sym_EQ_TILDE] = ACTIONS(1677),
    [anon_sym_BANG_TILDE] = ACTIONS(1677),
    [anon_sym_LT_EQ] = ACTIONS(1679),
    [anon_sym_GT] = ACTIONS(1679),
    [anon_sym_GT_EQ] = ACTIONS(1677),
    [anon_sym_CARET] = ACTIONS(1679),
    [anon_sym_PLUS] = ACTIONS(1679),
    [anon_sym_SLASH] = ACTIONS(1679),
    [anon_sym_PERCENT] = ACTIONS(1679),
    [sym_comment] = ACTIONS(87),
  },
  [3611] = {
    [sym__line_break] = ACTIONS(1697),
    [sym__heredoc_body_start] = ACTIONS(1697),
    [sym__binary_minus] = ACTIONS(1697),
    [sym__binary_star] = ACTIONS(1697),
    [ts_builtin_sym_end] = ACTIONS(1697),
    [anon_sym___END__] = ACTIONS(1697),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_RBRACE] = ACTIONS(1697),
    [anon_sym_RPAREN] = ACTIONS(1697),
    [anon_sym_DOT] = ACTIONS(1699),
    [anon_sym_COMMA] = ACTIONS(1697),
    [anon_sym_PIPE] = ACTIONS(1699),
    [anon_sym_SEMI] = ACTIONS(1697),
    [anon_sym_STAR_STAR] = ACTIONS(1699),
    [anon_sym_AMP] = ACTIONS(1699),
    [anon_sym_EQ] = ACTIONS(1699),
    [anon_sym_LT] = ACTIONS(1699),
    [anon_sym_end] = ACTIONS(1697),
    [anon_sym_if] = ACTIONS(1697),
    [anon_sym_unless] = ACTIONS(1697),
    [anon_sym_while] = ACTIONS(1697),
    [anon_sym_until] = ACTIONS(1697),
    [anon_sym_rescue] = ACTIONS(1697),
    [anon_sym_do] = ACTIONS(1697),
    [anon_sym_when] = ACTIONS(1697),
    [anon_sym_elsif] = ACTIONS(1697),
    [anon_sym_else] = ACTIONS(1697),
    [anon_sym_then] = ACTIONS(1697),
    [anon_sym_ensure] = ACTIONS(1697),
    [anon_sym_LBRACK] = ACTIONS(1697),
    [anon_sym_COLON_COLON2] = ACTIONS(1697),
    [anon_sym_AMP_DOT] = ACTIONS(1697),
    [anon_sym_PLUS_EQ] = ACTIONS(1697),
    [anon_sym_DASH_EQ] = ACTIONS(1697),
    [anon_sym_STAR_EQ] = ACTIONS(1697),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1697),
    [anon_sym_SLASH_EQ] = ACTIONS(1697),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1697),
    [anon_sym_PIPE_EQ] = ACTIONS(1697),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1697),
    [anon_sym_AMP_EQ] = ACTIONS(1697),
    [anon_sym_PERCENT_EQ] = ACTIONS(1697),
    [anon_sym_GT_GT_EQ] = ACTIONS(1697),
    [anon_sym_LT_LT_EQ] = ACTIONS(1697),
    [anon_sym_CARET_EQ] = ACTIONS(1697),
    [anon_sym_QMARK] = ACTIONS(1697),
    [anon_sym_DOT_DOT] = ACTIONS(1699),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1697),
    [anon_sym_and] = ACTIONS(1697),
    [anon_sym_or] = ACTIONS(1697),
    [anon_sym_PIPE_PIPE] = ACTIONS(1699),
    [anon_sym_AMP_AMP] = ACTIONS(1699),
    [anon_sym_LT_LT] = ACTIONS(1699),
    [anon_sym_GT_GT] = ACTIONS(1699),
    [anon_sym_EQ_EQ] = ACTIONS(1699),
    [anon_sym_BANG_EQ] = ACTIONS(1697),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1697),
    [anon_sym_LT_EQ_GT] = ACTIONS(1697),
    [anon_sym_EQ_TILDE] = ACTIONS(1697),
    [anon_sym_BANG_TILDE] = ACTIONS(1697),
    [anon_sym_LT_EQ] = ACTIONS(1699),
    [anon_sym_GT] = ACTIONS(1699),
    [anon_sym_GT_EQ] = ACTIONS(1697),
    [anon_sym_CARET] = ACTIONS(1699),
    [anon_sym_PLUS] = ACTIONS(1699),
    [anon_sym_SLASH] = ACTIONS(1699),
    [anon_sym_PERCENT] = ACTIONS(1699),
    [sym_comment] = ACTIONS(87),
  },
  [3612] = {
    [sym__line_break] = ACTIONS(1701),
    [sym__heredoc_body_start] = ACTIONS(1701),
    [sym__binary_minus] = ACTIONS(1701),
    [sym__binary_star] = ACTIONS(1701),
    [ts_builtin_sym_end] = ACTIONS(1701),
    [anon_sym___END__] = ACTIONS(1701),
    [anon_sym_LBRACE] = ACTIONS(1701),
    [anon_sym_RBRACE] = ACTIONS(1701),
    [anon_sym_RPAREN] = ACTIONS(1701),
    [anon_sym_DOT] = ACTIONS(1703),
    [anon_sym_COMMA] = ACTIONS(1701),
    [anon_sym_PIPE] = ACTIONS(1703),
    [anon_sym_SEMI] = ACTIONS(1701),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1703),
    [anon_sym_EQ] = ACTIONS(1703),
    [anon_sym_LT] = ACTIONS(1703),
    [anon_sym_end] = ACTIONS(1701),
    [anon_sym_if] = ACTIONS(1701),
    [anon_sym_unless] = ACTIONS(1701),
    [anon_sym_while] = ACTIONS(1701),
    [anon_sym_until] = ACTIONS(1701),
    [anon_sym_rescue] = ACTIONS(1701),
    [anon_sym_do] = ACTIONS(1701),
    [anon_sym_when] = ACTIONS(1701),
    [anon_sym_elsif] = ACTIONS(1701),
    [anon_sym_else] = ACTIONS(1701),
    [anon_sym_then] = ACTIONS(1701),
    [anon_sym_ensure] = ACTIONS(1701),
    [anon_sym_LBRACK] = ACTIONS(1701),
    [anon_sym_COLON_COLON2] = ACTIONS(1701),
    [anon_sym_AMP_DOT] = ACTIONS(1701),
    [anon_sym_PLUS_EQ] = ACTIONS(1701),
    [anon_sym_DASH_EQ] = ACTIONS(1701),
    [anon_sym_STAR_EQ] = ACTIONS(1701),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1701),
    [anon_sym_SLASH_EQ] = ACTIONS(1701),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1701),
    [anon_sym_PIPE_EQ] = ACTIONS(1701),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1701),
    [anon_sym_AMP_EQ] = ACTIONS(1701),
    [anon_sym_PERCENT_EQ] = ACTIONS(1701),
    [anon_sym_GT_GT_EQ] = ACTIONS(1701),
    [anon_sym_LT_LT_EQ] = ACTIONS(1701),
    [anon_sym_CARET_EQ] = ACTIONS(1701),
    [anon_sym_QMARK] = ACTIONS(1701),
    [anon_sym_DOT_DOT] = ACTIONS(1703),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1701),
    [anon_sym_and] = ACTIONS(1701),
    [anon_sym_or] = ACTIONS(1701),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1703),
    [anon_sym_BANG_EQ] = ACTIONS(1701),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1701),
    [anon_sym_LT_EQ_GT] = ACTIONS(1701),
    [anon_sym_EQ_TILDE] = ACTIONS(1701),
    [anon_sym_BANG_TILDE] = ACTIONS(1701),
    [anon_sym_LT_EQ] = ACTIONS(1703),
    [anon_sym_GT] = ACTIONS(1703),
    [anon_sym_GT_EQ] = ACTIONS(1701),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [3613] = {
    [sym__line_break] = ACTIONS(1705),
    [sym__heredoc_body_start] = ACTIONS(1705),
    [sym__binary_minus] = ACTIONS(1705),
    [sym__binary_star] = ACTIONS(1705),
    [ts_builtin_sym_end] = ACTIONS(1705),
    [anon_sym___END__] = ACTIONS(1705),
    [anon_sym_LBRACE] = ACTIONS(1705),
    [anon_sym_RBRACE] = ACTIONS(1705),
    [anon_sym_RPAREN] = ACTIONS(1705),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1705),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1705),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1705),
    [anon_sym_if] = ACTIONS(1705),
    [anon_sym_unless] = ACTIONS(1705),
    [anon_sym_while] = ACTIONS(1705),
    [anon_sym_until] = ACTIONS(1705),
    [anon_sym_rescue] = ACTIONS(1705),
    [anon_sym_do] = ACTIONS(1705),
    [anon_sym_when] = ACTIONS(1705),
    [anon_sym_elsif] = ACTIONS(1705),
    [anon_sym_else] = ACTIONS(1705),
    [anon_sym_then] = ACTIONS(1705),
    [anon_sym_ensure] = ACTIONS(1705),
    [anon_sym_LBRACK] = ACTIONS(1705),
    [anon_sym_COLON_COLON2] = ACTIONS(1705),
    [anon_sym_AMP_DOT] = ACTIONS(1705),
    [anon_sym_PLUS_EQ] = ACTIONS(1705),
    [anon_sym_DASH_EQ] = ACTIONS(1705),
    [anon_sym_STAR_EQ] = ACTIONS(1705),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1705),
    [anon_sym_SLASH_EQ] = ACTIONS(1705),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1705),
    [anon_sym_PIPE_EQ] = ACTIONS(1705),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1705),
    [anon_sym_AMP_EQ] = ACTIONS(1705),
    [anon_sym_PERCENT_EQ] = ACTIONS(1705),
    [anon_sym_GT_GT_EQ] = ACTIONS(1705),
    [anon_sym_LT_LT_EQ] = ACTIONS(1705),
    [anon_sym_CARET_EQ] = ACTIONS(1705),
    [anon_sym_QMARK] = ACTIONS(1705),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1705),
    [anon_sym_and] = ACTIONS(1705),
    [anon_sym_or] = ACTIONS(1705),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1705),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1705),
    [anon_sym_LT_EQ_GT] = ACTIONS(1705),
    [anon_sym_EQ_TILDE] = ACTIONS(1705),
    [anon_sym_BANG_TILDE] = ACTIONS(1705),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1705),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [3614] = {
    [sym_then] = STATE(6292),
    [sym_heredoc_body] = STATE(6293),
    [sym__terminator] = STATE(6293),
    [sym__line_break] = ACTIONS(9748),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(9748),
    [anon_sym_if] = ACTIONS(1743),
    [anon_sym_unless] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1747),
    [anon_sym_until] = ACTIONS(1749),
    [anon_sym_rescue] = ACTIONS(1751),
    [anon_sym_then] = ACTIONS(1753),
    [sym_comment] = ACTIONS(87),
  },
  [3615] = {
    [sym_then] = STATE(6294),
    [sym_heredoc_body] = STATE(6295),
    [sym__terminator] = STATE(6295),
    [sym__line_break] = ACTIONS(9750),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(9750),
    [anon_sym_if] = ACTIONS(1743),
    [anon_sym_unless] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1747),
    [anon_sym_until] = ACTIONS(1749),
    [anon_sym_rescue] = ACTIONS(1751),
    [anon_sym_then] = ACTIONS(1821),
    [sym_comment] = ACTIONS(87),
  },
  [3616] = {
    [sym__do] = STATE(6296),
    [sym_heredoc_body] = STATE(6296),
    [sym__terminator] = STATE(6296),
    [sym__line_break] = ACTIONS(9752),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym__binary_minus] = ACTIONS(1855),
    [sym__binary_star] = ACTIONS(1857),
    [anon_sym_PIPE] = ACTIONS(1859),
    [anon_sym_SEMI] = ACTIONS(9752),
    [anon_sym_STAR_STAR] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_LT] = ACTIONS(1863),
    [anon_sym_do] = ACTIONS(9752),
    [anon_sym_QMARK] = ACTIONS(1865),
    [anon_sym_DOT_DOT] = ACTIONS(1867),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1869),
    [anon_sym_and] = ACTIONS(1871),
    [anon_sym_or] = ACTIONS(1871),
    [anon_sym_PIPE_PIPE] = ACTIONS(1873),
    [anon_sym_AMP_AMP] = ACTIONS(1873),
    [anon_sym_LT_LT] = ACTIONS(1875),
    [anon_sym_GT_GT] = ACTIONS(1875),
    [anon_sym_EQ_EQ] = ACTIONS(1877),
    [anon_sym_BANG_EQ] = ACTIONS(1873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1873),
    [anon_sym_LT_EQ_GT] = ACTIONS(1873),
    [anon_sym_EQ_TILDE] = ACTIONS(1873),
    [anon_sym_BANG_TILDE] = ACTIONS(1873),
    [anon_sym_LT_EQ] = ACTIONS(1863),
    [anon_sym_GT] = ACTIONS(1863),
    [anon_sym_GT_EQ] = ACTIONS(1879),
    [anon_sym_CARET] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_SLASH] = ACTIONS(1857),
    [anon_sym_PERCENT] = ACTIONS(1857),
    [sym_comment] = ACTIONS(87),
  },
  [3617] = {
    [sym__do] = STATE(6297),
    [sym_heredoc_body] = STATE(6297),
    [sym__terminator] = STATE(6297),
    [sym__line_break] = ACTIONS(9754),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym__binary_minus] = ACTIONS(1855),
    [sym__binary_star] = ACTIONS(1857),
    [anon_sym_PIPE] = ACTIONS(1859),
    [anon_sym_SEMI] = ACTIONS(9754),
    [anon_sym_STAR_STAR] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_LT] = ACTIONS(1863),
    [anon_sym_do] = ACTIONS(9754),
    [anon_sym_QMARK] = ACTIONS(1865),
    [anon_sym_DOT_DOT] = ACTIONS(1867),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1869),
    [anon_sym_and] = ACTIONS(1871),
    [anon_sym_or] = ACTIONS(1871),
    [anon_sym_PIPE_PIPE] = ACTIONS(1873),
    [anon_sym_AMP_AMP] = ACTIONS(1873),
    [anon_sym_LT_LT] = ACTIONS(1875),
    [anon_sym_GT_GT] = ACTIONS(1875),
    [anon_sym_EQ_EQ] = ACTIONS(1877),
    [anon_sym_BANG_EQ] = ACTIONS(1873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1873),
    [anon_sym_LT_EQ_GT] = ACTIONS(1873),
    [anon_sym_EQ_TILDE] = ACTIONS(1873),
    [anon_sym_BANG_TILDE] = ACTIONS(1873),
    [anon_sym_LT_EQ] = ACTIONS(1863),
    [anon_sym_GT] = ACTIONS(1863),
    [anon_sym_GT_EQ] = ACTIONS(1879),
    [anon_sym_CARET] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_SLASH] = ACTIONS(1857),
    [anon_sym_PERCENT] = ACTIONS(1857),
    [sym_comment] = ACTIONS(87),
  },
  [3618] = {
    [sym_in] = STATE(6298),
    [anon_sym_in] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
  },
  [3619] = {
    [sym_heredoc_body] = STATE(6299),
    [sym__terminator] = STATE(6299),
    [sym__line_break] = ACTIONS(9756),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym__binary_minus] = ACTIONS(2001),
    [sym__binary_star] = ACTIONS(2003),
    [anon_sym_PIPE] = ACTIONS(2005),
    [anon_sym_SEMI] = ACTIONS(9756),
    [anon_sym_STAR_STAR] = ACTIONS(2003),
    [anon_sym_AMP] = ACTIONS(2007),
    [anon_sym_LT] = ACTIONS(2009),
    [anon_sym_QMARK] = ACTIONS(2011),
    [anon_sym_DOT_DOT] = ACTIONS(2013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2015),
    [anon_sym_and] = ACTIONS(2017),
    [anon_sym_or] = ACTIONS(2017),
    [anon_sym_PIPE_PIPE] = ACTIONS(2019),
    [anon_sym_AMP_AMP] = ACTIONS(2019),
    [anon_sym_LT_LT] = ACTIONS(2021),
    [anon_sym_GT_GT] = ACTIONS(2021),
    [anon_sym_EQ_EQ] = ACTIONS(2023),
    [anon_sym_BANG_EQ] = ACTIONS(2019),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2019),
    [anon_sym_LT_EQ_GT] = ACTIONS(2019),
    [anon_sym_EQ_TILDE] = ACTIONS(2019),
    [anon_sym_BANG_TILDE] = ACTIONS(2019),
    [anon_sym_LT_EQ] = ACTIONS(2009),
    [anon_sym_GT] = ACTIONS(2009),
    [anon_sym_GT_EQ] = ACTIONS(2025),
    [anon_sym_CARET] = ACTIONS(2027),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_SLASH] = ACTIONS(2003),
    [anon_sym_PERCENT] = ACTIONS(2003),
    [sym_comment] = ACTIONS(87),
  },
  [3620] = {
    [sym_when] = STATE(6303),
    [sym_else] = STATE(6301),
    [aux_sym_case_repeat1] = STATE(6302),
    [aux_sym_case_repeat2] = STATE(6303),
    [anon_sym_SEMI] = ACTIONS(9758),
    [anon_sym_end] = ACTIONS(9760),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [3621] = {
    [sym_else] = STATE(6305),
    [sym_ensure] = STATE(6306),
    [sym_rescue] = STATE(6307),
    [anon_sym_end] = ACTIONS(9762),
    [anon_sym_rescue] = ACTIONS(2165),
    [anon_sym_else] = ACTIONS(2167),
    [anon_sym_ensure] = ACTIONS(2169),
    [sym_comment] = ACTIONS(87),
  },
  [3622] = {
    [sym_ensure] = STATE(6306),
    [anon_sym_end] = ACTIONS(9762),
    [anon_sym_ensure] = ACTIONS(2169),
    [sym_comment] = ACTIONS(87),
  },
  [3623] = {
    [anon_sym_end] = ACTIONS(9762),
    [sym_comment] = ACTIONS(87),
  },
  [3624] = {
    [sym_else] = STATE(6305),
    [sym_ensure] = STATE(6306),
    [anon_sym_end] = ACTIONS(9762),
    [anon_sym_else] = ACTIONS(2167),
    [anon_sym_ensure] = ACTIONS(2169),
    [sym_comment] = ACTIONS(87),
  },
  [3625] = {
    [sym__line_break] = ACTIONS(2181),
    [sym__heredoc_body_start] = ACTIONS(2181),
    [sym__binary_minus] = ACTIONS(2181),
    [sym__binary_star] = ACTIONS(2181),
    [ts_builtin_sym_end] = ACTIONS(2181),
    [anon_sym___END__] = ACTIONS(2181),
    [anon_sym_LBRACE] = ACTIONS(2181),
    [anon_sym_RBRACE] = ACTIONS(2181),
    [anon_sym_RPAREN] = ACTIONS(2181),
    [anon_sym_DOT] = ACTIONS(2183),
    [anon_sym_COMMA] = ACTIONS(2181),
    [anon_sym_PIPE] = ACTIONS(2183),
    [anon_sym_SEMI] = ACTIONS(2181),
    [anon_sym_STAR_STAR] = ACTIONS(2183),
    [anon_sym_AMP] = ACTIONS(2183),
    [anon_sym_EQ] = ACTIONS(2183),
    [anon_sym_LT] = ACTIONS(2183),
    [anon_sym_end] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(2181),
    [anon_sym_unless] = ACTIONS(2181),
    [anon_sym_while] = ACTIONS(2181),
    [anon_sym_until] = ACTIONS(2181),
    [anon_sym_rescue] = ACTIONS(2181),
    [anon_sym_do] = ACTIONS(2181),
    [anon_sym_when] = ACTIONS(2181),
    [anon_sym_elsif] = ACTIONS(2181),
    [anon_sym_else] = ACTIONS(2181),
    [anon_sym_then] = ACTIONS(2181),
    [anon_sym_ensure] = ACTIONS(2181),
    [anon_sym_LBRACK] = ACTIONS(2181),
    [anon_sym_COLON_COLON2] = ACTIONS(2181),
    [anon_sym_AMP_DOT] = ACTIONS(2181),
    [anon_sym_PLUS_EQ] = ACTIONS(2181),
    [anon_sym_DASH_EQ] = ACTIONS(2181),
    [anon_sym_STAR_EQ] = ACTIONS(2181),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2181),
    [anon_sym_SLASH_EQ] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2181),
    [anon_sym_PIPE_EQ] = ACTIONS(2181),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2181),
    [anon_sym_AMP_EQ] = ACTIONS(2181),
    [anon_sym_PERCENT_EQ] = ACTIONS(2181),
    [anon_sym_GT_GT_EQ] = ACTIONS(2181),
    [anon_sym_LT_LT_EQ] = ACTIONS(2181),
    [anon_sym_CARET_EQ] = ACTIONS(2181),
    [anon_sym_QMARK] = ACTIONS(2181),
    [anon_sym_DOT_DOT] = ACTIONS(2183),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2183),
    [anon_sym_AMP_AMP] = ACTIONS(2183),
    [anon_sym_LT_LT] = ACTIONS(2183),
    [anon_sym_GT_GT] = ACTIONS(2183),
    [anon_sym_EQ_EQ] = ACTIONS(2183),
    [anon_sym_BANG_EQ] = ACTIONS(2181),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2181),
    [anon_sym_LT_EQ_GT] = ACTIONS(2181),
    [anon_sym_EQ_TILDE] = ACTIONS(2181),
    [anon_sym_BANG_TILDE] = ACTIONS(2181),
    [anon_sym_LT_EQ] = ACTIONS(2183),
    [anon_sym_GT] = ACTIONS(2183),
    [anon_sym_GT_EQ] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2183),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_SLASH] = ACTIONS(2183),
    [anon_sym_PERCENT] = ACTIONS(2183),
    [sym_comment] = ACTIONS(87),
  },
  [3626] = {
    [sym__statements] = STATE(3621),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(3622),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(3623),
    [sym_rescue] = STATE(3624),
    [sym__body_statement] = STATE(6308),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9764),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3627] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(6019),
    [sym__binary_star] = ACTIONS(6021),
    [ts_builtin_sym_end] = ACTIONS(935),
    [anon_sym___END__] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(6023),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_AMP] = ACTIONS(6027),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(6029),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(6031),
    [anon_sym_DOT_DOT] = ACTIONS(6033),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6035),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(6037),
    [anon_sym_AMP_AMP] = ACTIONS(6037),
    [anon_sym_LT_LT] = ACTIONS(6039),
    [anon_sym_GT_GT] = ACTIONS(6039),
    [anon_sym_EQ_EQ] = ACTIONS(6037),
    [anon_sym_BANG_EQ] = ACTIONS(6041),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6041),
    [anon_sym_LT_EQ_GT] = ACTIONS(6041),
    [anon_sym_EQ_TILDE] = ACTIONS(6041),
    [anon_sym_BANG_TILDE] = ACTIONS(6041),
    [anon_sym_LT_EQ] = ACTIONS(6029),
    [anon_sym_GT] = ACTIONS(6029),
    [anon_sym_GT_EQ] = ACTIONS(6043),
    [anon_sym_CARET] = ACTIONS(6023),
    [anon_sym_PLUS] = ACTIONS(6045),
    [anon_sym_SLASH] = ACTIONS(6025),
    [anon_sym_PERCENT] = ACTIONS(6025),
    [sym_comment] = ACTIONS(87),
  },
  [3628] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [ts_builtin_sym_end] = ACTIONS(935),
    [anon_sym___END__] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(937),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_when] = ACTIONS(935),
    [anon_sym_elsif] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_ensure] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [3629] = {
    [sym__line_break] = ACTIONS(2261),
    [sym__heredoc_body_start] = ACTIONS(2261),
    [sym__binary_minus] = ACTIONS(2261),
    [sym__binary_star] = ACTIONS(2261),
    [ts_builtin_sym_end] = ACTIONS(2261),
    [anon_sym___END__] = ACTIONS(2261),
    [anon_sym_LBRACE] = ACTIONS(2261),
    [anon_sym_RBRACE] = ACTIONS(2261),
    [anon_sym_RPAREN] = ACTIONS(2261),
    [anon_sym_DOT] = ACTIONS(2263),
    [anon_sym_COMMA] = ACTIONS(2261),
    [anon_sym_PIPE] = ACTIONS(2263),
    [anon_sym_SEMI] = ACTIONS(2261),
    [anon_sym_STAR_STAR] = ACTIONS(2263),
    [anon_sym_AMP] = ACTIONS(2263),
    [anon_sym_EQ] = ACTIONS(2263),
    [anon_sym_LT] = ACTIONS(2263),
    [anon_sym_end] = ACTIONS(2261),
    [anon_sym_if] = ACTIONS(2261),
    [anon_sym_unless] = ACTIONS(2261),
    [anon_sym_while] = ACTIONS(2261),
    [anon_sym_until] = ACTIONS(2261),
    [anon_sym_rescue] = ACTIONS(2261),
    [anon_sym_do] = ACTIONS(2261),
    [anon_sym_when] = ACTIONS(2261),
    [anon_sym_elsif] = ACTIONS(2261),
    [anon_sym_else] = ACTIONS(2261),
    [anon_sym_then] = ACTIONS(2261),
    [anon_sym_ensure] = ACTIONS(2261),
    [anon_sym_LBRACK] = ACTIONS(2261),
    [anon_sym_COLON_COLON2] = ACTIONS(2261),
    [anon_sym_AMP_DOT] = ACTIONS(2261),
    [anon_sym_PLUS_EQ] = ACTIONS(2261),
    [anon_sym_DASH_EQ] = ACTIONS(2261),
    [anon_sym_STAR_EQ] = ACTIONS(2261),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2261),
    [anon_sym_SLASH_EQ] = ACTIONS(2261),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2261),
    [anon_sym_PIPE_EQ] = ACTIONS(2261),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2261),
    [anon_sym_AMP_EQ] = ACTIONS(2261),
    [anon_sym_PERCENT_EQ] = ACTIONS(2261),
    [anon_sym_GT_GT_EQ] = ACTIONS(2261),
    [anon_sym_LT_LT_EQ] = ACTIONS(2261),
    [anon_sym_CARET_EQ] = ACTIONS(2261),
    [anon_sym_QMARK] = ACTIONS(2261),
    [anon_sym_DOT_DOT] = ACTIONS(2263),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2261),
    [anon_sym_and] = ACTIONS(2261),
    [anon_sym_or] = ACTIONS(2261),
    [anon_sym_PIPE_PIPE] = ACTIONS(2263),
    [anon_sym_AMP_AMP] = ACTIONS(2263),
    [anon_sym_LT_LT] = ACTIONS(2263),
    [anon_sym_GT_GT] = ACTIONS(2263),
    [anon_sym_EQ_EQ] = ACTIONS(2263),
    [anon_sym_BANG_EQ] = ACTIONS(2261),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2261),
    [anon_sym_LT_EQ_GT] = ACTIONS(2261),
    [anon_sym_EQ_TILDE] = ACTIONS(2261),
    [anon_sym_BANG_TILDE] = ACTIONS(2261),
    [anon_sym_LT_EQ] = ACTIONS(2263),
    [anon_sym_GT] = ACTIONS(2263),
    [anon_sym_GT_EQ] = ACTIONS(2261),
    [anon_sym_CARET] = ACTIONS(2263),
    [anon_sym_PLUS] = ACTIONS(2263),
    [anon_sym_SLASH] = ACTIONS(2263),
    [anon_sym_PERCENT] = ACTIONS(2263),
    [sym_comment] = ACTIONS(87),
  },
  [3630] = {
    [sym__line_break] = ACTIONS(2345),
    [sym__heredoc_body_start] = ACTIONS(2345),
    [sym__binary_minus] = ACTIONS(2345),
    [sym__binary_star] = ACTIONS(2345),
    [ts_builtin_sym_end] = ACTIONS(2345),
    [anon_sym___END__] = ACTIONS(2345),
    [anon_sym_LBRACE] = ACTIONS(2345),
    [anon_sym_RBRACE] = ACTIONS(2345),
    [anon_sym_RPAREN] = ACTIONS(2345),
    [anon_sym_DOT] = ACTIONS(2347),
    [anon_sym_COMMA] = ACTIONS(2345),
    [anon_sym_PIPE] = ACTIONS(2347),
    [anon_sym_SEMI] = ACTIONS(2345),
    [anon_sym_STAR_STAR] = ACTIONS(2347),
    [anon_sym_AMP] = ACTIONS(2347),
    [anon_sym_EQ] = ACTIONS(2347),
    [anon_sym_LT] = ACTIONS(2347),
    [anon_sym_end] = ACTIONS(2345),
    [anon_sym_if] = ACTIONS(2345),
    [anon_sym_unless] = ACTIONS(2345),
    [anon_sym_while] = ACTIONS(2345),
    [anon_sym_until] = ACTIONS(2345),
    [anon_sym_rescue] = ACTIONS(2345),
    [anon_sym_do] = ACTIONS(2345),
    [anon_sym_when] = ACTIONS(2345),
    [anon_sym_elsif] = ACTIONS(2345),
    [anon_sym_else] = ACTIONS(2345),
    [anon_sym_then] = ACTIONS(2345),
    [anon_sym_ensure] = ACTIONS(2345),
    [anon_sym_LBRACK] = ACTIONS(2345),
    [anon_sym_COLON_COLON2] = ACTIONS(2345),
    [anon_sym_AMP_DOT] = ACTIONS(2345),
    [anon_sym_PLUS_EQ] = ACTIONS(2345),
    [anon_sym_DASH_EQ] = ACTIONS(2345),
    [anon_sym_STAR_EQ] = ACTIONS(2345),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2345),
    [anon_sym_SLASH_EQ] = ACTIONS(2345),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2345),
    [anon_sym_PIPE_EQ] = ACTIONS(2345),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2345),
    [anon_sym_AMP_EQ] = ACTIONS(2345),
    [anon_sym_PERCENT_EQ] = ACTIONS(2345),
    [anon_sym_GT_GT_EQ] = ACTIONS(2345),
    [anon_sym_LT_LT_EQ] = ACTIONS(2345),
    [anon_sym_CARET_EQ] = ACTIONS(2345),
    [anon_sym_QMARK] = ACTIONS(2345),
    [anon_sym_DOT_DOT] = ACTIONS(2347),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2345),
    [anon_sym_and] = ACTIONS(2345),
    [anon_sym_or] = ACTIONS(2345),
    [anon_sym_PIPE_PIPE] = ACTIONS(2347),
    [anon_sym_AMP_AMP] = ACTIONS(2347),
    [anon_sym_LT_LT] = ACTIONS(2347),
    [anon_sym_GT_GT] = ACTIONS(2347),
    [anon_sym_EQ_EQ] = ACTIONS(2347),
    [anon_sym_BANG_EQ] = ACTIONS(2345),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2345),
    [anon_sym_LT_EQ_GT] = ACTIONS(2345),
    [anon_sym_EQ_TILDE] = ACTIONS(2345),
    [anon_sym_BANG_TILDE] = ACTIONS(2345),
    [anon_sym_LT_EQ] = ACTIONS(2347),
    [anon_sym_GT] = ACTIONS(2347),
    [anon_sym_GT_EQ] = ACTIONS(2345),
    [anon_sym_CARET] = ACTIONS(2347),
    [anon_sym_PLUS] = ACTIONS(2347),
    [anon_sym_SLASH] = ACTIONS(2347),
    [anon_sym_PERCENT] = ACTIONS(2347),
    [sym_comment] = ACTIONS(87),
  },
  [3631] = {
    [anon_sym_RBRACK] = ACTIONS(9766),
    [sym_comment] = ACTIONS(87),
  },
  [3632] = {
    [sym_do_block] = STATE(6310),
    [sym_block] = STATE(6310),
    [anon_sym_LBRACE] = ACTIONS(2719),
    [anon_sym_do] = ACTIONS(2723),
    [sym_comment] = ACTIONS(87),
  },
  [3633] = {
    [sym__line_break] = ACTIONS(2485),
    [sym__heredoc_body_start] = ACTIONS(2485),
    [sym__binary_minus] = ACTIONS(2485),
    [sym__binary_star] = ACTIONS(2485),
    [ts_builtin_sym_end] = ACTIONS(2485),
    [anon_sym___END__] = ACTIONS(2485),
    [anon_sym_LBRACE] = ACTIONS(2485),
    [anon_sym_RBRACE] = ACTIONS(2485),
    [anon_sym_RPAREN] = ACTIONS(2485),
    [anon_sym_DOT] = ACTIONS(2487),
    [anon_sym_COMMA] = ACTIONS(2485),
    [anon_sym_PIPE] = ACTIONS(2487),
    [anon_sym_SEMI] = ACTIONS(2485),
    [anon_sym_STAR_STAR] = ACTIONS(2487),
    [anon_sym_AMP] = ACTIONS(2487),
    [anon_sym_EQ] = ACTIONS(2487),
    [anon_sym_LT] = ACTIONS(2487),
    [anon_sym_end] = ACTIONS(2485),
    [anon_sym_if] = ACTIONS(2485),
    [anon_sym_unless] = ACTIONS(2485),
    [anon_sym_while] = ACTIONS(2485),
    [anon_sym_until] = ACTIONS(2485),
    [anon_sym_rescue] = ACTIONS(2485),
    [anon_sym_do] = ACTIONS(2485),
    [anon_sym_when] = ACTIONS(2485),
    [anon_sym_elsif] = ACTIONS(2485),
    [anon_sym_else] = ACTIONS(2485),
    [anon_sym_then] = ACTIONS(2485),
    [anon_sym_ensure] = ACTIONS(2485),
    [anon_sym_LBRACK] = ACTIONS(2485),
    [anon_sym_COLON_COLON2] = ACTIONS(2485),
    [anon_sym_AMP_DOT] = ACTIONS(2485),
    [anon_sym_PLUS_EQ] = ACTIONS(2485),
    [anon_sym_DASH_EQ] = ACTIONS(2485),
    [anon_sym_STAR_EQ] = ACTIONS(2485),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2485),
    [anon_sym_SLASH_EQ] = ACTIONS(2485),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2485),
    [anon_sym_PIPE_EQ] = ACTIONS(2485),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2485),
    [anon_sym_AMP_EQ] = ACTIONS(2485),
    [anon_sym_PERCENT_EQ] = ACTIONS(2485),
    [anon_sym_GT_GT_EQ] = ACTIONS(2485),
    [anon_sym_LT_LT_EQ] = ACTIONS(2485),
    [anon_sym_CARET_EQ] = ACTIONS(2485),
    [anon_sym_QMARK] = ACTIONS(2485),
    [anon_sym_DOT_DOT] = ACTIONS(2487),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2485),
    [anon_sym_and] = ACTIONS(2485),
    [anon_sym_or] = ACTIONS(2485),
    [anon_sym_PIPE_PIPE] = ACTIONS(2487),
    [anon_sym_AMP_AMP] = ACTIONS(2487),
    [anon_sym_LT_LT] = ACTIONS(2487),
    [anon_sym_GT_GT] = ACTIONS(2487),
    [anon_sym_EQ_EQ] = ACTIONS(2487),
    [anon_sym_BANG_EQ] = ACTIONS(2485),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2485),
    [anon_sym_LT_EQ_GT] = ACTIONS(2485),
    [anon_sym_EQ_TILDE] = ACTIONS(2485),
    [anon_sym_BANG_TILDE] = ACTIONS(2485),
    [anon_sym_LT_EQ] = ACTIONS(2487),
    [anon_sym_GT] = ACTIONS(2487),
    [anon_sym_GT_EQ] = ACTIONS(2485),
    [anon_sym_CARET] = ACTIONS(2487),
    [anon_sym_PLUS] = ACTIONS(2487),
    [anon_sym_SLASH] = ACTIONS(2487),
    [anon_sym_PERCENT] = ACTIONS(2487),
    [sym_comment] = ACTIONS(87),
  },
  [3634] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(6311),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(1498),
    [sym_scope_resolution] = STATE(1496),
    [sym_call] = STATE(1496),
    [sym_method_call] = STATE(1498),
    [sym_assignment] = STATE(6311),
    [sym_operator_assignment] = STATE(6311),
    [sym_conditional] = STATE(6311),
    [sym_range] = STATE(6311),
    [sym_binary] = STATE(6311),
    [sym_unary] = STATE(6311),
    [sym_left_assignment_list] = STATE(1497),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1498),
    [sym__variable] = STATE(1496),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(1498),
    [sym_false] = STATE(1498),
    [sym_nil] = STATE(1498),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(1499),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(2565),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(2577),
    [anon_sym_yield] = ACTIONS(2579),
    [anon_sym_break] = ACTIONS(2581),
    [anon_sym_next] = ACTIONS(2583),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(2601),
    [anon_sym_defined_QMARK] = ACTIONS(2603),
    [anon_sym_not] = ACTIONS(2605),
    [anon_sym_BANG] = ACTIONS(2607),
    [anon_sym_TILDE] = ACTIONS(2607),
    [sym_constant] = ACTIONS(2609),
    [sym_identifier] = ACTIONS(2609),
    [sym_instance_variable] = ACTIONS(2611),
    [sym_class_variable] = ACTIONS(2611),
    [sym_global_variable] = ACTIONS(2611),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(2609),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2609),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [3635] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(6312),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(1498),
    [sym_scope_resolution] = STATE(1496),
    [sym_call] = STATE(1496),
    [sym_method_call] = STATE(1498),
    [sym_assignment] = STATE(6312),
    [sym_operator_assignment] = STATE(6312),
    [sym_conditional] = STATE(6312),
    [sym_range] = STATE(6312),
    [sym_binary] = STATE(6312),
    [sym_unary] = STATE(6312),
    [sym_left_assignment_list] = STATE(1497),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1498),
    [sym__variable] = STATE(1496),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(1498),
    [sym_false] = STATE(1498),
    [sym_nil] = STATE(1498),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(1499),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(2565),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(2577),
    [anon_sym_yield] = ACTIONS(2579),
    [anon_sym_break] = ACTIONS(2581),
    [anon_sym_next] = ACTIONS(2583),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(2601),
    [anon_sym_defined_QMARK] = ACTIONS(2603),
    [anon_sym_not] = ACTIONS(2605),
    [anon_sym_BANG] = ACTIONS(2607),
    [anon_sym_TILDE] = ACTIONS(2607),
    [sym_constant] = ACTIONS(2609),
    [sym_identifier] = ACTIONS(2609),
    [sym_instance_variable] = ACTIONS(2611),
    [sym_class_variable] = ACTIONS(2611),
    [sym_global_variable] = ACTIONS(2611),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(2609),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2609),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [3636] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(6313),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(1498),
    [sym_scope_resolution] = STATE(1496),
    [sym_call] = STATE(1496),
    [sym_method_call] = STATE(1498),
    [sym_assignment] = STATE(6313),
    [sym_operator_assignment] = STATE(6313),
    [sym_conditional] = STATE(6313),
    [sym_range] = STATE(6313),
    [sym_binary] = STATE(6313),
    [sym_unary] = STATE(6313),
    [sym_left_assignment_list] = STATE(1497),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1498),
    [sym__variable] = STATE(1496),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(1498),
    [sym_false] = STATE(1498),
    [sym_nil] = STATE(1498),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(1499),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(2565),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(2577),
    [anon_sym_yield] = ACTIONS(2579),
    [anon_sym_break] = ACTIONS(2581),
    [anon_sym_next] = ACTIONS(2583),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(2601),
    [anon_sym_defined_QMARK] = ACTIONS(2603),
    [anon_sym_not] = ACTIONS(2605),
    [anon_sym_BANG] = ACTIONS(2607),
    [anon_sym_TILDE] = ACTIONS(2607),
    [sym_constant] = ACTIONS(2609),
    [sym_identifier] = ACTIONS(2609),
    [sym_instance_variable] = ACTIONS(2611),
    [sym_class_variable] = ACTIONS(2611),
    [sym_global_variable] = ACTIONS(2611),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(2609),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2609),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [3637] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(6314),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(1498),
    [sym_scope_resolution] = STATE(1496),
    [sym_call] = STATE(1496),
    [sym_method_call] = STATE(1498),
    [sym_assignment] = STATE(6314),
    [sym_operator_assignment] = STATE(6314),
    [sym_conditional] = STATE(6314),
    [sym_range] = STATE(6314),
    [sym_binary] = STATE(6314),
    [sym_unary] = STATE(6314),
    [sym_left_assignment_list] = STATE(1497),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1498),
    [sym__variable] = STATE(1496),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(1498),
    [sym_false] = STATE(1498),
    [sym_nil] = STATE(1498),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(1499),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(2565),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(2577),
    [anon_sym_yield] = ACTIONS(2579),
    [anon_sym_break] = ACTIONS(2581),
    [anon_sym_next] = ACTIONS(2583),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(2601),
    [anon_sym_defined_QMARK] = ACTIONS(2603),
    [anon_sym_not] = ACTIONS(2605),
    [anon_sym_BANG] = ACTIONS(2607),
    [anon_sym_TILDE] = ACTIONS(2607),
    [sym_constant] = ACTIONS(2609),
    [sym_identifier] = ACTIONS(2609),
    [sym_instance_variable] = ACTIONS(2611),
    [sym_class_variable] = ACTIONS(2611),
    [sym_global_variable] = ACTIONS(2611),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(2609),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2609),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [3638] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(6315),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(1498),
    [sym_scope_resolution] = STATE(1496),
    [sym_call] = STATE(1496),
    [sym_method_call] = STATE(1498),
    [sym_assignment] = STATE(6315),
    [sym_operator_assignment] = STATE(6315),
    [sym_conditional] = STATE(6315),
    [sym_range] = STATE(6315),
    [sym_binary] = STATE(6315),
    [sym_unary] = STATE(6315),
    [sym_left_assignment_list] = STATE(1497),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1498),
    [sym__variable] = STATE(1496),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(1498),
    [sym_false] = STATE(1498),
    [sym_nil] = STATE(1498),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(1499),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(2565),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(2577),
    [anon_sym_yield] = ACTIONS(2579),
    [anon_sym_break] = ACTIONS(2581),
    [anon_sym_next] = ACTIONS(2583),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(2601),
    [anon_sym_defined_QMARK] = ACTIONS(2603),
    [anon_sym_not] = ACTIONS(2605),
    [anon_sym_BANG] = ACTIONS(2607),
    [anon_sym_TILDE] = ACTIONS(2607),
    [sym_constant] = ACTIONS(2609),
    [sym_identifier] = ACTIONS(2609),
    [sym_instance_variable] = ACTIONS(2611),
    [sym_class_variable] = ACTIONS(2611),
    [sym_global_variable] = ACTIONS(2611),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(2609),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2609),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [3639] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(6316),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(6316),
    [sym_operator_assignment] = STATE(6316),
    [sym_conditional] = STATE(6316),
    [sym_range] = STATE(6316),
    [sym_binary] = STATE(6316),
    [sym_unary] = STATE(6316),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3640] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(6317),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(1498),
    [sym_scope_resolution] = STATE(1496),
    [sym_call] = STATE(1496),
    [sym_method_call] = STATE(1498),
    [sym_assignment] = STATE(6317),
    [sym_operator_assignment] = STATE(6317),
    [sym_conditional] = STATE(6317),
    [sym_range] = STATE(6317),
    [sym_binary] = STATE(6317),
    [sym_unary] = STATE(6317),
    [sym_left_assignment_list] = STATE(1497),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1498),
    [sym__variable] = STATE(1496),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(1498),
    [sym_false] = STATE(1498),
    [sym_nil] = STATE(1498),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(1499),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(2565),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(2577),
    [anon_sym_yield] = ACTIONS(2579),
    [anon_sym_break] = ACTIONS(2581),
    [anon_sym_next] = ACTIONS(2583),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(2601),
    [anon_sym_defined_QMARK] = ACTIONS(2603),
    [anon_sym_not] = ACTIONS(2605),
    [anon_sym_BANG] = ACTIONS(2607),
    [anon_sym_TILDE] = ACTIONS(2607),
    [sym_constant] = ACTIONS(2609),
    [sym_identifier] = ACTIONS(2609),
    [sym_instance_variable] = ACTIONS(2611),
    [sym_class_variable] = ACTIONS(2611),
    [sym_global_variable] = ACTIONS(2611),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(2609),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2609),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [3641] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(6318),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(1498),
    [sym_scope_resolution] = STATE(1496),
    [sym_call] = STATE(1496),
    [sym_method_call] = STATE(1498),
    [sym_assignment] = STATE(6318),
    [sym_operator_assignment] = STATE(6318),
    [sym_conditional] = STATE(6318),
    [sym_range] = STATE(6318),
    [sym_binary] = STATE(6318),
    [sym_unary] = STATE(6318),
    [sym_left_assignment_list] = STATE(1497),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1498),
    [sym__variable] = STATE(1496),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(1498),
    [sym_false] = STATE(1498),
    [sym_nil] = STATE(1498),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(1499),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(2565),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(2577),
    [anon_sym_yield] = ACTIONS(2579),
    [anon_sym_break] = ACTIONS(2581),
    [anon_sym_next] = ACTIONS(2583),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(2601),
    [anon_sym_defined_QMARK] = ACTIONS(2603),
    [anon_sym_not] = ACTIONS(2605),
    [anon_sym_BANG] = ACTIONS(2607),
    [anon_sym_TILDE] = ACTIONS(2607),
    [sym_constant] = ACTIONS(2609),
    [sym_identifier] = ACTIONS(2609),
    [sym_instance_variable] = ACTIONS(2611),
    [sym_class_variable] = ACTIONS(2611),
    [sym_global_variable] = ACTIONS(2611),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(2609),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2609),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [3642] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(6319),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(1498),
    [sym_scope_resolution] = STATE(1496),
    [sym_call] = STATE(1496),
    [sym_method_call] = STATE(1498),
    [sym_assignment] = STATE(6319),
    [sym_operator_assignment] = STATE(6319),
    [sym_conditional] = STATE(6319),
    [sym_range] = STATE(6319),
    [sym_binary] = STATE(6319),
    [sym_unary] = STATE(6319),
    [sym_left_assignment_list] = STATE(1497),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1498),
    [sym__variable] = STATE(1496),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(1498),
    [sym_false] = STATE(1498),
    [sym_nil] = STATE(1498),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(1499),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(2565),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(2577),
    [anon_sym_yield] = ACTIONS(2579),
    [anon_sym_break] = ACTIONS(2581),
    [anon_sym_next] = ACTIONS(2583),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(2601),
    [anon_sym_defined_QMARK] = ACTIONS(2603),
    [anon_sym_not] = ACTIONS(2605),
    [anon_sym_BANG] = ACTIONS(2607),
    [anon_sym_TILDE] = ACTIONS(2607),
    [sym_constant] = ACTIONS(2609),
    [sym_identifier] = ACTIONS(2609),
    [sym_instance_variable] = ACTIONS(2611),
    [sym_class_variable] = ACTIONS(2611),
    [sym_global_variable] = ACTIONS(2611),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(2609),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2609),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [3643] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(6320),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(1498),
    [sym_scope_resolution] = STATE(1496),
    [sym_call] = STATE(1496),
    [sym_method_call] = STATE(1498),
    [sym_assignment] = STATE(6320),
    [sym_operator_assignment] = STATE(6320),
    [sym_conditional] = STATE(6320),
    [sym_range] = STATE(6320),
    [sym_binary] = STATE(6320),
    [sym_unary] = STATE(6320),
    [sym_left_assignment_list] = STATE(1497),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1498),
    [sym__variable] = STATE(1496),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(1498),
    [sym_false] = STATE(1498),
    [sym_nil] = STATE(1498),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(1499),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(2565),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(2577),
    [anon_sym_yield] = ACTIONS(2579),
    [anon_sym_break] = ACTIONS(2581),
    [anon_sym_next] = ACTIONS(2583),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(2601),
    [anon_sym_defined_QMARK] = ACTIONS(2603),
    [anon_sym_not] = ACTIONS(2605),
    [anon_sym_BANG] = ACTIONS(2607),
    [anon_sym_TILDE] = ACTIONS(2607),
    [sym_constant] = ACTIONS(2609),
    [sym_identifier] = ACTIONS(2609),
    [sym_instance_variable] = ACTIONS(2611),
    [sym_class_variable] = ACTIONS(2611),
    [sym_global_variable] = ACTIONS(2611),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(2609),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2609),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [3644] = {
    [sym__statements] = STATE(1514),
    [sym_begin_block] = STATE(489),
    [sym_end_block] = STATE(489),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_block_parameters] = STATE(1515),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1516),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1519),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1519),
    [sym_hash_splat_argument] = STATE(116),
    [sym_assignment] = STATE(1516),
    [sym_operator_assignment] = STATE(1516),
    [sym_conditional] = STATE(1516),
    [sym_range] = STATE(1516),
    [sym_binary] = STATE(1516),
    [sym_unary] = STATE(1516),
    [sym_left_assignment_list] = STATE(1518),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1519),
    [sym__variable] = STATE(1517),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1519),
    [sym_false] = STATE(1519),
    [sym_nil] = STATE(1519),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1520),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(1521),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym__hash_items] = STATE(1522),
    [sym_pair] = STATE(122),
    [sym_lambda] = STATE(214),
    [sym_empty_statement] = STATE(495),
    [aux_sym__statements_repeat1] = STATE(495),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2629),
    [sym__identifier_hash_key] = ACTIONS(157),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(9768),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_PIPE] = ACTIONS(2445),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2633),
    [anon_sym_yield] = ACTIONS(2635),
    [anon_sym_break] = ACTIONS(2637),
    [anon_sym_next] = ACTIONS(2639),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2641),
    [anon_sym_defined_QMARK] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2647),
    [anon_sym_TILDE] = ACTIONS(2647),
    [sym_constant] = ACTIONS(2649),
    [sym_identifier] = ACTIONS(2649),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3645] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(6322),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(1498),
    [sym_scope_resolution] = STATE(1496),
    [sym_call] = STATE(1496),
    [sym_method_call] = STATE(1498),
    [sym_splat_argument] = STATE(6324),
    [sym_assignment] = STATE(6322),
    [sym_operator_assignment] = STATE(6322),
    [sym_conditional] = STATE(6322),
    [sym_range] = STATE(6322),
    [sym_binary] = STATE(6322),
    [sym_unary] = STATE(6322),
    [sym_right_assignment_list] = STATE(6323),
    [sym__arg_or_splat_arg] = STATE(6324),
    [sym_left_assignment_list] = STATE(1497),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1498),
    [sym__variable] = STATE(1496),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(1498),
    [sym_false] = STATE(1498),
    [sym_nil] = STATE(1498),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(1499),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__splat_star] = ACTIONS(763),
    [sym__unary_minus] = ACTIONS(2565),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(2577),
    [anon_sym_yield] = ACTIONS(2579),
    [anon_sym_break] = ACTIONS(2581),
    [anon_sym_next] = ACTIONS(2583),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(2601),
    [anon_sym_defined_QMARK] = ACTIONS(2603),
    [anon_sym_not] = ACTIONS(2605),
    [anon_sym_BANG] = ACTIONS(2607),
    [anon_sym_TILDE] = ACTIONS(2607),
    [sym_constant] = ACTIONS(2609),
    [sym_identifier] = ACTIONS(2609),
    [sym_instance_variable] = ACTIONS(2611),
    [sym_class_variable] = ACTIONS(2611),
    [sym_global_variable] = ACTIONS(2611),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(2609),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2609),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [3646] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(6325),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(1498),
    [sym_scope_resolution] = STATE(1496),
    [sym_call] = STATE(1496),
    [sym_method_call] = STATE(1498),
    [sym_assignment] = STATE(6325),
    [sym_operator_assignment] = STATE(6325),
    [sym_conditional] = STATE(6325),
    [sym_range] = STATE(6325),
    [sym_binary] = STATE(6325),
    [sym_unary] = STATE(6325),
    [sym_left_assignment_list] = STATE(1497),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1498),
    [sym__variable] = STATE(1496),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(1498),
    [sym_false] = STATE(1498),
    [sym_nil] = STATE(1498),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(1499),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(2565),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(2577),
    [anon_sym_yield] = ACTIONS(2579),
    [anon_sym_break] = ACTIONS(2581),
    [anon_sym_next] = ACTIONS(2583),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(2601),
    [anon_sym_defined_QMARK] = ACTIONS(2603),
    [anon_sym_not] = ACTIONS(2605),
    [anon_sym_BANG] = ACTIONS(2607),
    [anon_sym_TILDE] = ACTIONS(2607),
    [sym_constant] = ACTIONS(2609),
    [sym_identifier] = ACTIONS(2609),
    [sym_instance_variable] = ACTIONS(2611),
    [sym_class_variable] = ACTIONS(2611),
    [sym_global_variable] = ACTIONS(2611),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(2609),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2609),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [3647] = {
    [sym_string] = STATE(6326),
    [aux_sym_chained_string_repeat1] = STATE(6326),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(2551),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [ts_builtin_sym_end] = ACTIONS(2753),
    [anon_sym___END__] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2755),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_EQ] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_PLUS_EQ] = ACTIONS(2753),
    [anon_sym_DASH_EQ] = ACTIONS(2753),
    [anon_sym_STAR_EQ] = ACTIONS(2753),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2753),
    [anon_sym_SLASH_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2753),
    [anon_sym_AMP_EQ] = ACTIONS(2753),
    [anon_sym_PERCENT_EQ] = ACTIONS(2753),
    [anon_sym_GT_GT_EQ] = ACTIONS(2753),
    [anon_sym_LT_LT_EQ] = ACTIONS(2753),
    [anon_sym_CARET_EQ] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2755),
    [anon_sym_AMP_AMP] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2755),
    [anon_sym_GT_GT] = ACTIONS(2755),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_SLASH] = ACTIONS(2755),
    [anon_sym_PERCENT] = ACTIONS(2755),
    [sym_comment] = ACTIONS(87),
  },
  [3648] = {
    [sym__line_break] = ACTIONS(993),
    [sym__heredoc_body_start] = ACTIONS(993),
    [sym__binary_minus] = ACTIONS(993),
    [sym__binary_star] = ACTIONS(993),
    [ts_builtin_sym_end] = ACTIONS(993),
    [anon_sym___END__] = ACTIONS(993),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_RBRACE] = ACTIONS(993),
    [anon_sym_RPAREN] = ACTIONS(993),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(993),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_SEMI] = ACTIONS(993),
    [anon_sym_STAR_STAR] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_EQ] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(995),
    [anon_sym_end] = ACTIONS(993),
    [anon_sym_if] = ACTIONS(993),
    [anon_sym_unless] = ACTIONS(993),
    [anon_sym_while] = ACTIONS(993),
    [anon_sym_until] = ACTIONS(993),
    [anon_sym_rescue] = ACTIONS(993),
    [anon_sym_do] = ACTIONS(993),
    [anon_sym_when] = ACTIONS(993),
    [anon_sym_elsif] = ACTIONS(993),
    [anon_sym_else] = ACTIONS(993),
    [anon_sym_then] = ACTIONS(993),
    [anon_sym_ensure] = ACTIONS(993),
    [anon_sym_EQ_GT] = ACTIONS(993),
    [anon_sym_LBRACK] = ACTIONS(993),
    [anon_sym_COLON_COLON2] = ACTIONS(993),
    [anon_sym_AMP_DOT] = ACTIONS(993),
    [anon_sym_PLUS_EQ] = ACTIONS(993),
    [anon_sym_DASH_EQ] = ACTIONS(993),
    [anon_sym_STAR_EQ] = ACTIONS(993),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(993),
    [anon_sym_SLASH_EQ] = ACTIONS(993),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(993),
    [anon_sym_PIPE_EQ] = ACTIONS(993),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(993),
    [anon_sym_AMP_EQ] = ACTIONS(993),
    [anon_sym_PERCENT_EQ] = ACTIONS(993),
    [anon_sym_GT_GT_EQ] = ACTIONS(993),
    [anon_sym_LT_LT_EQ] = ACTIONS(993),
    [anon_sym_CARET_EQ] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(993),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(993),
    [anon_sym_and] = ACTIONS(993),
    [anon_sym_or] = ACTIONS(993),
    [anon_sym_PIPE_PIPE] = ACTIONS(995),
    [anon_sym_AMP_AMP] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(995),
    [anon_sym_GT_GT] = ACTIONS(995),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(993),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(993),
    [anon_sym_LT_EQ_GT] = ACTIONS(993),
    [anon_sym_EQ_TILDE] = ACTIONS(993),
    [anon_sym_BANG_TILDE] = ACTIONS(993),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(993),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_PLUS] = ACTIONS(995),
    [anon_sym_SLASH] = ACTIONS(995),
    [anon_sym_PERCENT] = ACTIONS(995),
    [sym_comment] = ACTIONS(87),
  },
  [3649] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(6019),
    [sym__binary_star] = ACTIONS(6021),
    [ts_builtin_sym_end] = ACTIONS(6823),
    [anon_sym___END__] = ACTIONS(6823),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(6023),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_AMP] = ACTIONS(6027),
    [anon_sym_EQ] = ACTIONS(7822),
    [anon_sym_LT] = ACTIONS(6029),
    [anon_sym_if] = ACTIONS(6823),
    [anon_sym_unless] = ACTIONS(6823),
    [anon_sym_while] = ACTIONS(6823),
    [anon_sym_until] = ACTIONS(6823),
    [anon_sym_rescue] = ACTIONS(6823),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_PLUS_EQ] = ACTIONS(6823),
    [anon_sym_DASH_EQ] = ACTIONS(6823),
    [anon_sym_STAR_EQ] = ACTIONS(6823),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6823),
    [anon_sym_SLASH_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6823),
    [anon_sym_AMP_EQ] = ACTIONS(6823),
    [anon_sym_PERCENT_EQ] = ACTIONS(6823),
    [anon_sym_GT_GT_EQ] = ACTIONS(6823),
    [anon_sym_LT_LT_EQ] = ACTIONS(6823),
    [anon_sym_CARET_EQ] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(6031),
    [anon_sym_DOT_DOT] = ACTIONS(6033),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6035),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(6037),
    [anon_sym_AMP_AMP] = ACTIONS(6037),
    [anon_sym_LT_LT] = ACTIONS(6039),
    [anon_sym_GT_GT] = ACTIONS(6039),
    [anon_sym_EQ_EQ] = ACTIONS(6037),
    [anon_sym_BANG_EQ] = ACTIONS(6041),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6041),
    [anon_sym_LT_EQ_GT] = ACTIONS(6041),
    [anon_sym_EQ_TILDE] = ACTIONS(6041),
    [anon_sym_BANG_TILDE] = ACTIONS(6041),
    [anon_sym_LT_EQ] = ACTIONS(6029),
    [anon_sym_GT] = ACTIONS(6029),
    [anon_sym_GT_EQ] = ACTIONS(6043),
    [anon_sym_CARET] = ACTIONS(6023),
    [anon_sym_PLUS] = ACTIONS(6045),
    [anon_sym_SLASH] = ACTIONS(6025),
    [anon_sym_PERCENT] = ACTIONS(6025),
    [sym_comment] = ACTIONS(87),
  },
  [3650] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(6069),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [3651] = {
    [sym_string] = STATE(3685),
    [aux_sym_chained_string_repeat1] = STATE(3685),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [3652] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6327),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1725),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1725),
    [sym_assignment] = STATE(6327),
    [sym_operator_assignment] = STATE(6327),
    [sym_conditional] = STATE(6327),
    [sym_range] = STATE(6327),
    [sym_binary] = STATE(6327),
    [sym_unary] = STATE(6327),
    [sym_left_assignment_list] = STATE(1724),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1725),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1725),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(4013),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(3111),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6669),
    [anon_sym_defined_QMARK] = ACTIONS(3123),
    [anon_sym_not] = ACTIONS(3125),
    [anon_sym_BANG] = ACTIONS(3129),
    [anon_sym_TILDE] = ACTIONS(3129),
    [sym_constant] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3653] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6328),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1725),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1725),
    [sym_assignment] = STATE(6328),
    [sym_operator_assignment] = STATE(6328),
    [sym_conditional] = STATE(6328),
    [sym_range] = STATE(6328),
    [sym_binary] = STATE(6328),
    [sym_unary] = STATE(6328),
    [sym_left_assignment_list] = STATE(1724),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1725),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1725),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(4013),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(3111),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6669),
    [anon_sym_defined_QMARK] = ACTIONS(3123),
    [anon_sym_not] = ACTIONS(3125),
    [anon_sym_BANG] = ACTIONS(3129),
    [anon_sym_TILDE] = ACTIONS(3129),
    [sym_constant] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3654] = {
    [anon_sym_COLON] = ACTIONS(9770),
    [sym_comment] = ACTIONS(87),
  },
  [3655] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6330),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1725),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1725),
    [sym_assignment] = STATE(6330),
    [sym_operator_assignment] = STATE(6330),
    [sym_conditional] = STATE(6330),
    [sym_range] = STATE(6330),
    [sym_binary] = STATE(6330),
    [sym_unary] = STATE(6330),
    [sym_left_assignment_list] = STATE(1724),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1725),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1725),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(4013),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(3111),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6669),
    [anon_sym_defined_QMARK] = ACTIONS(3123),
    [anon_sym_not] = ACTIONS(3125),
    [anon_sym_BANG] = ACTIONS(3129),
    [anon_sym_TILDE] = ACTIONS(3129),
    [sym_constant] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3656] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(9772),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [3657] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(6675),
    [sym__binary_star] = ACTIONS(6677),
    [anon_sym_RBRACE] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(6679),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(6677),
    [anon_sym_AMP] = ACTIONS(6681),
    [anon_sym_LT] = ACTIONS(6683),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_unless] = ACTIONS(1625),
    [anon_sym_while] = ACTIONS(1625),
    [anon_sym_until] = ACTIONS(1625),
    [anon_sym_rescue] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(1625),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(6685),
    [anon_sym_DOT_DOT] = ACTIONS(6687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6689),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(6691),
    [anon_sym_AMP_AMP] = ACTIONS(6691),
    [anon_sym_LT_LT] = ACTIONS(6693),
    [anon_sym_GT_GT] = ACTIONS(6693),
    [anon_sym_EQ_EQ] = ACTIONS(6695),
    [anon_sym_BANG_EQ] = ACTIONS(6691),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6691),
    [anon_sym_LT_EQ_GT] = ACTIONS(6691),
    [anon_sym_EQ_TILDE] = ACTIONS(6691),
    [anon_sym_BANG_TILDE] = ACTIONS(6691),
    [anon_sym_LT_EQ] = ACTIONS(6683),
    [anon_sym_GT] = ACTIONS(6683),
    [anon_sym_GT_EQ] = ACTIONS(6697),
    [anon_sym_CARET] = ACTIONS(6699),
    [anon_sym_PLUS] = ACTIONS(6675),
    [anon_sym_SLASH] = ACTIONS(6677),
    [anon_sym_PERCENT] = ACTIONS(6677),
    [sym_comment] = ACTIONS(87),
  },
  [3658] = {
    [sym_heredoc_body] = STATE(6332),
    [aux_sym_call_repeat1] = STATE(6332),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_RBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [3659] = {
    [sym_heredoc_body] = STATE(6332),
    [aux_sym_call_repeat1] = STATE(6332),
    [aux_sym_argument_list_repeat1] = STATE(6334),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_RBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [3660] = {
    [sym_string] = STATE(4035),
    [aux_sym_chained_string_repeat1] = STATE(4035),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(9776),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [3661] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(6067),
    [sym__binary_star] = ACTIONS(6069),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(6071),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(6069),
    [anon_sym_AMP] = ACTIONS(6073),
    [anon_sym_LT] = ACTIONS(6075),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(6077),
    [anon_sym_DOT_DOT] = ACTIONS(6079),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6081),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(6085),
    [anon_sym_AMP_AMP] = ACTIONS(6085),
    [anon_sym_LT_LT] = ACTIONS(6087),
    [anon_sym_GT_GT] = ACTIONS(6087),
    [anon_sym_EQ_EQ] = ACTIONS(6089),
    [anon_sym_BANG_EQ] = ACTIONS(6085),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6085),
    [anon_sym_LT_EQ_GT] = ACTIONS(6085),
    [anon_sym_EQ_TILDE] = ACTIONS(6085),
    [anon_sym_BANG_TILDE] = ACTIONS(6085),
    [anon_sym_LT_EQ] = ACTIONS(6075),
    [anon_sym_GT] = ACTIONS(6075),
    [anon_sym_GT_EQ] = ACTIONS(6091),
    [anon_sym_CARET] = ACTIONS(6093),
    [anon_sym_PLUS] = ACTIONS(6067),
    [anon_sym_SLASH] = ACTIONS(6069),
    [anon_sym_PERCENT] = ACTIONS(6069),
    [sym_comment] = ACTIONS(87),
  },
  [3662] = {
    [sym__line_break] = ACTIONS(9426),
    [sym__heredoc_body_start] = ACTIONS(9426),
    [sym__binary_minus] = ACTIONS(9426),
    [sym__binary_star] = ACTIONS(9426),
    [ts_builtin_sym_end] = ACTIONS(9426),
    [anon_sym___END__] = ACTIONS(9426),
    [anon_sym_LBRACE] = ACTIONS(9426),
    [anon_sym_RBRACE] = ACTIONS(9426),
    [anon_sym_RPAREN] = ACTIONS(9426),
    [anon_sym_DOT] = ACTIONS(9428),
    [anon_sym_COMMA] = ACTIONS(9426),
    [anon_sym_PIPE] = ACTIONS(9428),
    [anon_sym_SEMI] = ACTIONS(9426),
    [anon_sym_STAR_STAR] = ACTIONS(9428),
    [anon_sym_AMP] = ACTIONS(9428),
    [anon_sym_EQ] = ACTIONS(9428),
    [anon_sym_LT] = ACTIONS(9428),
    [anon_sym_end] = ACTIONS(9426),
    [anon_sym_if] = ACTIONS(9426),
    [anon_sym_unless] = ACTIONS(9426),
    [anon_sym_while] = ACTIONS(9426),
    [anon_sym_until] = ACTIONS(9426),
    [anon_sym_rescue] = ACTIONS(9426),
    [anon_sym_do] = ACTIONS(9426),
    [anon_sym_when] = ACTIONS(9426),
    [anon_sym_elsif] = ACTIONS(9426),
    [anon_sym_else] = ACTIONS(9426),
    [anon_sym_then] = ACTIONS(9426),
    [anon_sym_ensure] = ACTIONS(9426),
    [anon_sym_LBRACK] = ACTIONS(9426),
    [anon_sym_COLON_COLON2] = ACTIONS(9426),
    [anon_sym_AMP_DOT] = ACTIONS(9426),
    [anon_sym_PLUS_EQ] = ACTIONS(9426),
    [anon_sym_DASH_EQ] = ACTIONS(9426),
    [anon_sym_STAR_EQ] = ACTIONS(9426),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9426),
    [anon_sym_SLASH_EQ] = ACTIONS(9426),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9426),
    [anon_sym_PIPE_EQ] = ACTIONS(9426),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9426),
    [anon_sym_AMP_EQ] = ACTIONS(9426),
    [anon_sym_PERCENT_EQ] = ACTIONS(9426),
    [anon_sym_GT_GT_EQ] = ACTIONS(9426),
    [anon_sym_LT_LT_EQ] = ACTIONS(9426),
    [anon_sym_CARET_EQ] = ACTIONS(9426),
    [anon_sym_QMARK] = ACTIONS(9426),
    [anon_sym_DOT_DOT] = ACTIONS(9428),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9426),
    [anon_sym_and] = ACTIONS(9426),
    [anon_sym_or] = ACTIONS(9426),
    [anon_sym_PIPE_PIPE] = ACTIONS(9428),
    [anon_sym_AMP_AMP] = ACTIONS(9428),
    [anon_sym_LT_LT] = ACTIONS(9428),
    [anon_sym_GT_GT] = ACTIONS(9428),
    [anon_sym_EQ_EQ] = ACTIONS(9428),
    [anon_sym_BANG_EQ] = ACTIONS(9426),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9426),
    [anon_sym_LT_EQ_GT] = ACTIONS(9426),
    [anon_sym_EQ_TILDE] = ACTIONS(9426),
    [anon_sym_BANG_TILDE] = ACTIONS(9426),
    [anon_sym_LT_EQ] = ACTIONS(9428),
    [anon_sym_GT] = ACTIONS(9428),
    [anon_sym_GT_EQ] = ACTIONS(9426),
    [anon_sym_CARET] = ACTIONS(9428),
    [anon_sym_PLUS] = ACTIONS(9428),
    [anon_sym_SLASH] = ACTIONS(9428),
    [anon_sym_PERCENT] = ACTIONS(9428),
    [sym_comment] = ACTIONS(87),
  },
  [3663] = {
    [anon_sym_RBRACE] = ACTIONS(9778),
    [sym_comment] = ACTIONS(87),
  },
  [3664] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6336),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1519),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1519),
    [sym_assignment] = STATE(6336),
    [sym_operator_assignment] = STATE(6336),
    [sym_conditional] = STATE(6336),
    [sym_range] = STATE(6336),
    [sym_binary] = STATE(6336),
    [sym_unary] = STATE(6336),
    [sym_left_assignment_list] = STATE(1518),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1519),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1519),
    [sym_false] = STATE(1519),
    [sym_nil] = STATE(1519),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3651),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2629),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2633),
    [anon_sym_yield] = ACTIONS(2635),
    [anon_sym_break] = ACTIONS(2637),
    [anon_sym_next] = ACTIONS(2639),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2641),
    [anon_sym_defined_QMARK] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2647),
    [anon_sym_TILDE] = ACTIONS(2647),
    [sym_constant] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3665] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6337),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1519),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1519),
    [sym_assignment] = STATE(6337),
    [sym_operator_assignment] = STATE(6337),
    [sym_conditional] = STATE(6337),
    [sym_range] = STATE(6337),
    [sym_binary] = STATE(6337),
    [sym_unary] = STATE(6337),
    [sym_left_assignment_list] = STATE(1518),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1519),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1519),
    [sym_false] = STATE(1519),
    [sym_nil] = STATE(1519),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3651),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2629),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2633),
    [anon_sym_yield] = ACTIONS(2635),
    [anon_sym_break] = ACTIONS(2637),
    [anon_sym_next] = ACTIONS(2639),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2641),
    [anon_sym_defined_QMARK] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2647),
    [anon_sym_TILDE] = ACTIONS(2647),
    [sym_constant] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3666] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6338),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1519),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1519),
    [sym_assignment] = STATE(6338),
    [sym_operator_assignment] = STATE(6338),
    [sym_conditional] = STATE(6338),
    [sym_range] = STATE(6338),
    [sym_binary] = STATE(6338),
    [sym_unary] = STATE(6338),
    [sym_left_assignment_list] = STATE(1518),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1519),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1519),
    [sym_false] = STATE(1519),
    [sym_nil] = STATE(1519),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3651),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2629),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2633),
    [anon_sym_yield] = ACTIONS(2635),
    [anon_sym_break] = ACTIONS(2637),
    [anon_sym_next] = ACTIONS(2639),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2641),
    [anon_sym_defined_QMARK] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2647),
    [anon_sym_TILDE] = ACTIONS(2647),
    [sym_constant] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3667] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6339),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1519),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1519),
    [sym_assignment] = STATE(6339),
    [sym_operator_assignment] = STATE(6339),
    [sym_conditional] = STATE(6339),
    [sym_range] = STATE(6339),
    [sym_binary] = STATE(6339),
    [sym_unary] = STATE(6339),
    [sym_left_assignment_list] = STATE(1518),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1519),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1519),
    [sym_false] = STATE(1519),
    [sym_nil] = STATE(1519),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3651),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2629),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2633),
    [anon_sym_yield] = ACTIONS(2635),
    [anon_sym_break] = ACTIONS(2637),
    [anon_sym_next] = ACTIONS(2639),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2641),
    [anon_sym_defined_QMARK] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2647),
    [anon_sym_TILDE] = ACTIONS(2647),
    [sym_constant] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3668] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6340),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1519),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1519),
    [sym_assignment] = STATE(6340),
    [sym_operator_assignment] = STATE(6340),
    [sym_conditional] = STATE(6340),
    [sym_range] = STATE(6340),
    [sym_binary] = STATE(6340),
    [sym_unary] = STATE(6340),
    [sym_left_assignment_list] = STATE(1518),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1519),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1519),
    [sym_false] = STATE(1519),
    [sym_nil] = STATE(1519),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3651),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2629),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2633),
    [anon_sym_yield] = ACTIONS(2635),
    [anon_sym_break] = ACTIONS(2637),
    [anon_sym_next] = ACTIONS(2639),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2641),
    [anon_sym_defined_QMARK] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2647),
    [anon_sym_TILDE] = ACTIONS(2647),
    [sym_constant] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3669] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(6341),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(6341),
    [sym_operator_assignment] = STATE(6341),
    [sym_conditional] = STATE(6341),
    [sym_range] = STATE(6341),
    [sym_binary] = STATE(6341),
    [sym_unary] = STATE(6341),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3670] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6342),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1519),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1519),
    [sym_assignment] = STATE(6342),
    [sym_operator_assignment] = STATE(6342),
    [sym_conditional] = STATE(6342),
    [sym_range] = STATE(6342),
    [sym_binary] = STATE(6342),
    [sym_unary] = STATE(6342),
    [sym_left_assignment_list] = STATE(1518),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1519),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1519),
    [sym_false] = STATE(1519),
    [sym_nil] = STATE(1519),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3651),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2629),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2633),
    [anon_sym_yield] = ACTIONS(2635),
    [anon_sym_break] = ACTIONS(2637),
    [anon_sym_next] = ACTIONS(2639),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2641),
    [anon_sym_defined_QMARK] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2647),
    [anon_sym_TILDE] = ACTIONS(2647),
    [sym_constant] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3671] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6343),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1519),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1519),
    [sym_assignment] = STATE(6343),
    [sym_operator_assignment] = STATE(6343),
    [sym_conditional] = STATE(6343),
    [sym_range] = STATE(6343),
    [sym_binary] = STATE(6343),
    [sym_unary] = STATE(6343),
    [sym_left_assignment_list] = STATE(1518),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1519),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1519),
    [sym_false] = STATE(1519),
    [sym_nil] = STATE(1519),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3651),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2629),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2633),
    [anon_sym_yield] = ACTIONS(2635),
    [anon_sym_break] = ACTIONS(2637),
    [anon_sym_next] = ACTIONS(2639),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2641),
    [anon_sym_defined_QMARK] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2647),
    [anon_sym_TILDE] = ACTIONS(2647),
    [sym_constant] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3672] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6344),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1519),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1519),
    [sym_assignment] = STATE(6344),
    [sym_operator_assignment] = STATE(6344),
    [sym_conditional] = STATE(6344),
    [sym_range] = STATE(6344),
    [sym_binary] = STATE(6344),
    [sym_unary] = STATE(6344),
    [sym_left_assignment_list] = STATE(1518),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1519),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1519),
    [sym_false] = STATE(1519),
    [sym_nil] = STATE(1519),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3651),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2629),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2633),
    [anon_sym_yield] = ACTIONS(2635),
    [anon_sym_break] = ACTIONS(2637),
    [anon_sym_next] = ACTIONS(2639),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2641),
    [anon_sym_defined_QMARK] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2647),
    [anon_sym_TILDE] = ACTIONS(2647),
    [sym_constant] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3673] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6345),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1519),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1519),
    [sym_assignment] = STATE(6345),
    [sym_operator_assignment] = STATE(6345),
    [sym_conditional] = STATE(6345),
    [sym_range] = STATE(6345),
    [sym_binary] = STATE(6345),
    [sym_unary] = STATE(6345),
    [sym_left_assignment_list] = STATE(1518),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1519),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1519),
    [sym_false] = STATE(1519),
    [sym_nil] = STATE(1519),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3651),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2629),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2633),
    [anon_sym_yield] = ACTIONS(2635),
    [anon_sym_break] = ACTIONS(2637),
    [anon_sym_next] = ACTIONS(2639),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2641),
    [anon_sym_defined_QMARK] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2647),
    [anon_sym_TILDE] = ACTIONS(2647),
    [sym_constant] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3674] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(6346),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1762),
    [sym_scope_resolution] = STATE(1758),
    [sym_call] = STATE(1758),
    [sym_method_call] = STATE(1762),
    [sym_assignment] = STATE(6346),
    [sym_operator_assignment] = STATE(6346),
    [sym_conditional] = STATE(6346),
    [sym_range] = STATE(6346),
    [sym_binary] = STATE(6346),
    [sym_unary] = STATE(6346),
    [sym_left_assignment_list] = STATE(1761),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1762),
    [sym__variable] = STATE(1758),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1762),
    [sym_false] = STATE(1762),
    [sym_nil] = STATE(1762),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(4066),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(3179),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(3183),
    [anon_sym_yield] = ACTIONS(3185),
    [anon_sym_break] = ACTIONS(3187),
    [anon_sym_next] = ACTIONS(3189),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(6735),
    [anon_sym_defined_QMARK] = ACTIONS(3191),
    [anon_sym_not] = ACTIONS(3193),
    [anon_sym_BANG] = ACTIONS(3197),
    [anon_sym_TILDE] = ACTIONS(3197),
    [sym_constant] = ACTIONS(3203),
    [sym_identifier] = ACTIONS(3203),
    [sym_instance_variable] = ACTIONS(3201),
    [sym_class_variable] = ACTIONS(3201),
    [sym_global_variable] = ACTIONS(3201),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(3203),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(3203),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3675] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(6347),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1762),
    [sym_scope_resolution] = STATE(1758),
    [sym_call] = STATE(1758),
    [sym_method_call] = STATE(1762),
    [sym_assignment] = STATE(6347),
    [sym_operator_assignment] = STATE(6347),
    [sym_conditional] = STATE(6347),
    [sym_range] = STATE(6347),
    [sym_binary] = STATE(6347),
    [sym_unary] = STATE(6347),
    [sym_left_assignment_list] = STATE(1761),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1762),
    [sym__variable] = STATE(1758),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1762),
    [sym_false] = STATE(1762),
    [sym_nil] = STATE(1762),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(4066),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(3179),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(3183),
    [anon_sym_yield] = ACTIONS(3185),
    [anon_sym_break] = ACTIONS(3187),
    [anon_sym_next] = ACTIONS(3189),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(6735),
    [anon_sym_defined_QMARK] = ACTIONS(3191),
    [anon_sym_not] = ACTIONS(3193),
    [anon_sym_BANG] = ACTIONS(3197),
    [anon_sym_TILDE] = ACTIONS(3197),
    [sym_constant] = ACTIONS(3203),
    [sym_identifier] = ACTIONS(3203),
    [sym_instance_variable] = ACTIONS(3201),
    [sym_class_variable] = ACTIONS(3201),
    [sym_global_variable] = ACTIONS(3201),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(3203),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(3203),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3676] = {
    [anon_sym_COLON] = ACTIONS(9780),
    [sym_comment] = ACTIONS(87),
  },
  [3677] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(6349),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1762),
    [sym_scope_resolution] = STATE(1758),
    [sym_call] = STATE(1758),
    [sym_method_call] = STATE(1762),
    [sym_assignment] = STATE(6349),
    [sym_operator_assignment] = STATE(6349),
    [sym_conditional] = STATE(6349),
    [sym_range] = STATE(6349),
    [sym_binary] = STATE(6349),
    [sym_unary] = STATE(6349),
    [sym_left_assignment_list] = STATE(1761),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1762),
    [sym__variable] = STATE(1758),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1762),
    [sym_false] = STATE(1762),
    [sym_nil] = STATE(1762),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(4066),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(3179),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(3183),
    [anon_sym_yield] = ACTIONS(3185),
    [anon_sym_break] = ACTIONS(3187),
    [anon_sym_next] = ACTIONS(3189),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(6735),
    [anon_sym_defined_QMARK] = ACTIONS(3191),
    [anon_sym_not] = ACTIONS(3193),
    [anon_sym_BANG] = ACTIONS(3197),
    [anon_sym_TILDE] = ACTIONS(3197),
    [sym_constant] = ACTIONS(3203),
    [sym_identifier] = ACTIONS(3203),
    [sym_instance_variable] = ACTIONS(3201),
    [sym_class_variable] = ACTIONS(3201),
    [sym_global_variable] = ACTIONS(3201),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(3203),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(3203),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3678] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(9782),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [3679] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(6741),
    [sym__binary_star] = ACTIONS(6743),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_RBRACE] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(6747),
    [anon_sym_AMP] = ACTIONS(6749),
    [anon_sym_EQ] = ACTIONS(1631),
    [anon_sym_LT] = ACTIONS(6751),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_unless] = ACTIONS(1625),
    [anon_sym_while] = ACTIONS(1625),
    [anon_sym_until] = ACTIONS(1625),
    [anon_sym_rescue] = ACTIONS(1625),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(1625),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_PLUS_EQ] = ACTIONS(1625),
    [anon_sym_DASH_EQ] = ACTIONS(1625),
    [anon_sym_STAR_EQ] = ACTIONS(1625),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1625),
    [anon_sym_SLASH_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1625),
    [anon_sym_AMP_EQ] = ACTIONS(1625),
    [anon_sym_PERCENT_EQ] = ACTIONS(1625),
    [anon_sym_GT_GT_EQ] = ACTIONS(1625),
    [anon_sym_LT_LT_EQ] = ACTIONS(1625),
    [anon_sym_CARET_EQ] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(6753),
    [anon_sym_DOT_DOT] = ACTIONS(6755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6757),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(6759),
    [anon_sym_AMP_AMP] = ACTIONS(6759),
    [anon_sym_LT_LT] = ACTIONS(6761),
    [anon_sym_GT_GT] = ACTIONS(6761),
    [anon_sym_EQ_EQ] = ACTIONS(6759),
    [anon_sym_BANG_EQ] = ACTIONS(6763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6763),
    [anon_sym_LT_EQ_GT] = ACTIONS(6763),
    [anon_sym_EQ_TILDE] = ACTIONS(6763),
    [anon_sym_BANG_TILDE] = ACTIONS(6763),
    [anon_sym_LT_EQ] = ACTIONS(6751),
    [anon_sym_GT] = ACTIONS(6751),
    [anon_sym_GT_EQ] = ACTIONS(6765),
    [anon_sym_CARET] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6767),
    [anon_sym_SLASH] = ACTIONS(6747),
    [anon_sym_PERCENT] = ACTIONS(6747),
    [sym_comment] = ACTIONS(87),
  },
  [3680] = {
    [sym_heredoc_body] = STATE(6351),
    [aux_sym_call_repeat1] = STATE(6351),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_RBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [3681] = {
    [sym_heredoc_body] = STATE(6351),
    [aux_sym_call_repeat1] = STATE(6351),
    [aux_sym_argument_list_repeat1] = STATE(6353),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_RBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(9784),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [3682] = {
    [sym_string] = STATE(4086),
    [aux_sym_chained_string_repeat1] = STATE(4086),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(747),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(9786),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3683] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6358),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(6361),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(6361),
    [sym_splat_argument] = STATE(6359),
    [sym_assignment] = STATE(6358),
    [sym_operator_assignment] = STATE(6358),
    [sym_conditional] = STATE(6358),
    [sym_range] = STATE(6358),
    [sym_binary] = STATE(6358),
    [sym_unary] = STATE(6358),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(6359),
    [sym_left_assignment_list] = STATE(6360),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6361),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(6361),
    [sym_false] = STATE(6361),
    [sym_nil] = STATE(6361),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(4013),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__splat_star] = ACTIONS(9788),
    [sym__unary_minus] = ACTIONS(9790),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9792),
    [anon_sym_defined_QMARK] = ACTIONS(9794),
    [anon_sym_not] = ACTIONS(9796),
    [anon_sym_BANG] = ACTIONS(9798),
    [anon_sym_TILDE] = ACTIONS(9798),
    [sym_constant] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3684] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6362),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1519),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1519),
    [sym_assignment] = STATE(6362),
    [sym_operator_assignment] = STATE(6362),
    [sym_conditional] = STATE(6362),
    [sym_range] = STATE(6362),
    [sym_binary] = STATE(6362),
    [sym_unary] = STATE(6362),
    [sym_left_assignment_list] = STATE(1518),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1519),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1519),
    [sym_false] = STATE(1519),
    [sym_nil] = STATE(1519),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3651),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2629),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2633),
    [anon_sym_yield] = ACTIONS(2635),
    [anon_sym_break] = ACTIONS(2637),
    [anon_sym_next] = ACTIONS(2639),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2641),
    [anon_sym_defined_QMARK] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2647),
    [anon_sym_TILDE] = ACTIONS(2647),
    [sym_constant] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3685] = {
    [sym_string] = STATE(6363),
    [aux_sym_chained_string_repeat1] = STATE(6363),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_RBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_EQ_GT] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [3686] = {
    [sym__line_break] = ACTIONS(3575),
    [sym__heredoc_body_start] = ACTIONS(3575),
    [sym__binary_minus] = ACTIONS(3575),
    [sym__binary_star] = ACTIONS(3575),
    [ts_builtin_sym_end] = ACTIONS(3575),
    [anon_sym___END__] = ACTIONS(3575),
    [anon_sym_LBRACE] = ACTIONS(3575),
    [anon_sym_RBRACE] = ACTIONS(3575),
    [anon_sym_RPAREN] = ACTIONS(3575),
    [anon_sym_DOT] = ACTIONS(3577),
    [anon_sym_COMMA] = ACTIONS(3575),
    [anon_sym_PIPE] = ACTIONS(3577),
    [anon_sym_SEMI] = ACTIONS(3575),
    [anon_sym_STAR_STAR] = ACTIONS(3577),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_EQ] = ACTIONS(3577),
    [anon_sym_LT] = ACTIONS(3577),
    [anon_sym_end] = ACTIONS(3575),
    [anon_sym_if] = ACTIONS(3575),
    [anon_sym_unless] = ACTIONS(3575),
    [anon_sym_while] = ACTIONS(3575),
    [anon_sym_until] = ACTIONS(3575),
    [anon_sym_rescue] = ACTIONS(3575),
    [anon_sym_do] = ACTIONS(3575),
    [anon_sym_when] = ACTIONS(3575),
    [anon_sym_elsif] = ACTIONS(3575),
    [anon_sym_else] = ACTIONS(3575),
    [anon_sym_then] = ACTIONS(3575),
    [anon_sym_ensure] = ACTIONS(3575),
    [anon_sym_EQ_GT] = ACTIONS(3575),
    [anon_sym_LBRACK] = ACTIONS(3575),
    [anon_sym_COLON_COLON2] = ACTIONS(3575),
    [anon_sym_AMP_DOT] = ACTIONS(3575),
    [anon_sym_PLUS_EQ] = ACTIONS(3575),
    [anon_sym_DASH_EQ] = ACTIONS(3575),
    [anon_sym_STAR_EQ] = ACTIONS(3575),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3575),
    [anon_sym_SLASH_EQ] = ACTIONS(3575),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3575),
    [anon_sym_PIPE_EQ] = ACTIONS(3575),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3575),
    [anon_sym_AMP_EQ] = ACTIONS(3575),
    [anon_sym_PERCENT_EQ] = ACTIONS(3575),
    [anon_sym_GT_GT_EQ] = ACTIONS(3575),
    [anon_sym_LT_LT_EQ] = ACTIONS(3575),
    [anon_sym_CARET_EQ] = ACTIONS(3575),
    [anon_sym_QMARK] = ACTIONS(3575),
    [anon_sym_DOT_DOT] = ACTIONS(3577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3575),
    [anon_sym_and] = ACTIONS(3575),
    [anon_sym_or] = ACTIONS(3575),
    [anon_sym_PIPE_PIPE] = ACTIONS(3577),
    [anon_sym_AMP_AMP] = ACTIONS(3577),
    [anon_sym_LT_LT] = ACTIONS(3577),
    [anon_sym_GT_GT] = ACTIONS(3577),
    [anon_sym_EQ_EQ] = ACTIONS(3577),
    [anon_sym_BANG_EQ] = ACTIONS(3575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3575),
    [anon_sym_LT_EQ_GT] = ACTIONS(3575),
    [anon_sym_EQ_TILDE] = ACTIONS(3575),
    [anon_sym_BANG_TILDE] = ACTIONS(3575),
    [anon_sym_LT_EQ] = ACTIONS(3577),
    [anon_sym_GT] = ACTIONS(3577),
    [anon_sym_GT_EQ] = ACTIONS(3575),
    [anon_sym_CARET] = ACTIONS(3577),
    [anon_sym_PLUS] = ACTIONS(3577),
    [anon_sym_SLASH] = ACTIONS(3577),
    [anon_sym_PERCENT] = ACTIONS(3577),
    [sym_comment] = ACTIONS(87),
  },
  [3687] = {
    [anon_sym_RBRACE] = ACTIONS(9800),
    [sym_comment] = ACTIONS(87),
  },
  [3688] = {
    [sym__binary_minus] = ACTIONS(3609),
    [sym__binary_star] = ACTIONS(3611),
    [anon_sym_RPAREN] = ACTIONS(9802),
    [anon_sym_PIPE] = ACTIONS(3615),
    [anon_sym_STAR_STAR] = ACTIONS(3611),
    [anon_sym_AMP] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3619),
    [anon_sym_QMARK] = ACTIONS(3621),
    [anon_sym_DOT_DOT] = ACTIONS(3623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3625),
    [anon_sym_and] = ACTIONS(3627),
    [anon_sym_or] = ACTIONS(3627),
    [anon_sym_PIPE_PIPE] = ACTIONS(3629),
    [anon_sym_AMP_AMP] = ACTIONS(3629),
    [anon_sym_LT_LT] = ACTIONS(3631),
    [anon_sym_GT_GT] = ACTIONS(3631),
    [anon_sym_EQ_EQ] = ACTIONS(3633),
    [anon_sym_BANG_EQ] = ACTIONS(3629),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3629),
    [anon_sym_LT_EQ_GT] = ACTIONS(3629),
    [anon_sym_EQ_TILDE] = ACTIONS(3629),
    [anon_sym_BANG_TILDE] = ACTIONS(3629),
    [anon_sym_LT_EQ] = ACTIONS(3619),
    [anon_sym_GT] = ACTIONS(3619),
    [anon_sym_GT_EQ] = ACTIONS(3635),
    [anon_sym_CARET] = ACTIONS(3637),
    [anon_sym_PLUS] = ACTIONS(3609),
    [anon_sym_SLASH] = ACTIONS(3611),
    [anon_sym_PERCENT] = ACTIONS(3611),
    [sym_comment] = ACTIONS(87),
  },
  [3689] = {
    [sym__method_rest] = STATE(6366),
    [sym_operator] = STATE(1526),
    [sym__method_name] = STATE(1526),
    [sym_setter] = STATE(1526),
    [sym_symbol] = STATE(1526),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(9804),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(9804),
    [sym_class_variable] = ACTIONS(9804),
    [sym_global_variable] = ACTIONS(9804),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [3690] = {
    [sym__statements] = STATE(1550),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(1551),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(1552),
    [sym_rescue] = STATE(1553),
    [sym__body_statement] = STATE(6367),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9806),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3691] = {
    [sym__line_break] = ACTIONS(3805),
    [sym__heredoc_body_start] = ACTIONS(3805),
    [sym__binary_minus] = ACTIONS(3805),
    [sym__binary_star] = ACTIONS(3805),
    [ts_builtin_sym_end] = ACTIONS(3805),
    [anon_sym___END__] = ACTIONS(3805),
    [anon_sym_LBRACE] = ACTIONS(3805),
    [anon_sym_RBRACE] = ACTIONS(3805),
    [anon_sym_RPAREN] = ACTIONS(3805),
    [anon_sym_DOT] = ACTIONS(3807),
    [anon_sym_COMMA] = ACTIONS(3805),
    [anon_sym_PIPE] = ACTIONS(3807),
    [anon_sym_SEMI] = ACTIONS(3805),
    [anon_sym_STAR_STAR] = ACTIONS(3807),
    [anon_sym_AMP] = ACTIONS(3807),
    [anon_sym_EQ] = ACTIONS(3807),
    [anon_sym_LT] = ACTIONS(3807),
    [anon_sym_end] = ACTIONS(3805),
    [anon_sym_if] = ACTIONS(3805),
    [anon_sym_unless] = ACTIONS(3805),
    [anon_sym_while] = ACTIONS(3805),
    [anon_sym_until] = ACTIONS(3805),
    [anon_sym_rescue] = ACTIONS(3805),
    [anon_sym_do] = ACTIONS(3805),
    [anon_sym_when] = ACTIONS(3805),
    [anon_sym_elsif] = ACTIONS(3805),
    [anon_sym_else] = ACTIONS(3805),
    [anon_sym_then] = ACTIONS(3805),
    [anon_sym_ensure] = ACTIONS(3805),
    [anon_sym_EQ_GT] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(3805),
    [anon_sym_COLON_COLON2] = ACTIONS(3805),
    [anon_sym_AMP_DOT] = ACTIONS(3805),
    [anon_sym_PLUS_EQ] = ACTIONS(3805),
    [anon_sym_DASH_EQ] = ACTIONS(3805),
    [anon_sym_STAR_EQ] = ACTIONS(3805),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3805),
    [anon_sym_SLASH_EQ] = ACTIONS(3805),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3805),
    [anon_sym_PIPE_EQ] = ACTIONS(3805),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3805),
    [anon_sym_AMP_EQ] = ACTIONS(3805),
    [anon_sym_PERCENT_EQ] = ACTIONS(3805),
    [anon_sym_GT_GT_EQ] = ACTIONS(3805),
    [anon_sym_LT_LT_EQ] = ACTIONS(3805),
    [anon_sym_CARET_EQ] = ACTIONS(3805),
    [anon_sym_QMARK] = ACTIONS(3805),
    [anon_sym_DOT_DOT] = ACTIONS(3807),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3805),
    [anon_sym_and] = ACTIONS(3805),
    [anon_sym_or] = ACTIONS(3805),
    [anon_sym_PIPE_PIPE] = ACTIONS(3807),
    [anon_sym_AMP_AMP] = ACTIONS(3807),
    [anon_sym_LT_LT] = ACTIONS(3807),
    [anon_sym_GT_GT] = ACTIONS(3807),
    [anon_sym_EQ_EQ] = ACTIONS(3807),
    [anon_sym_BANG_EQ] = ACTIONS(3805),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3805),
    [anon_sym_LT_EQ_GT] = ACTIONS(3805),
    [anon_sym_EQ_TILDE] = ACTIONS(3805),
    [anon_sym_BANG_TILDE] = ACTIONS(3805),
    [anon_sym_LT_EQ] = ACTIONS(3807),
    [anon_sym_GT] = ACTIONS(3807),
    [anon_sym_GT_EQ] = ACTIONS(3805),
    [anon_sym_CARET] = ACTIONS(3807),
    [anon_sym_PLUS] = ACTIONS(3807),
    [anon_sym_SLASH] = ACTIONS(3807),
    [anon_sym_PERCENT] = ACTIONS(3807),
    [sym_comment] = ACTIONS(87),
  },
  [3692] = {
    [sym_heredoc_body] = STATE(6368),
    [sym__terminator] = STATE(6368),
    [sym__line_break] = ACTIONS(9808),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym__binary_minus] = ACTIONS(2001),
    [sym__binary_star] = ACTIONS(2003),
    [anon_sym_PIPE] = ACTIONS(2005),
    [anon_sym_SEMI] = ACTIONS(9808),
    [anon_sym_STAR_STAR] = ACTIONS(2003),
    [anon_sym_AMP] = ACTIONS(2007),
    [anon_sym_LT] = ACTIONS(2009),
    [anon_sym_QMARK] = ACTIONS(2011),
    [anon_sym_DOT_DOT] = ACTIONS(2013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2015),
    [anon_sym_and] = ACTIONS(2017),
    [anon_sym_or] = ACTIONS(2017),
    [anon_sym_PIPE_PIPE] = ACTIONS(2019),
    [anon_sym_AMP_AMP] = ACTIONS(2019),
    [anon_sym_LT_LT] = ACTIONS(2021),
    [anon_sym_GT_GT] = ACTIONS(2021),
    [anon_sym_EQ_EQ] = ACTIONS(2023),
    [anon_sym_BANG_EQ] = ACTIONS(2019),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2019),
    [anon_sym_LT_EQ_GT] = ACTIONS(2019),
    [anon_sym_EQ_TILDE] = ACTIONS(2019),
    [anon_sym_BANG_TILDE] = ACTIONS(2019),
    [anon_sym_LT_EQ] = ACTIONS(2009),
    [anon_sym_GT] = ACTIONS(2009),
    [anon_sym_GT_EQ] = ACTIONS(2025),
    [anon_sym_CARET] = ACTIONS(2027),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_SLASH] = ACTIONS(2003),
    [anon_sym_PERCENT] = ACTIONS(2003),
    [sym_comment] = ACTIONS(87),
  },
  [3693] = {
    [sym_heredoc_body] = STATE(6369),
    [sym__terminator] = STATE(6369),
    [sym__line_break] = ACTIONS(9810),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(9810),
    [sym_comment] = ACTIONS(87),
  },
  [3694] = {
    [sym__statements] = STATE(1550),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(1551),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(1552),
    [sym_rescue] = STATE(1553),
    [sym__body_statement] = STATE(6370),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9812),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3695] = {
    [sym__line_break] = ACTIONS(4205),
    [sym__heredoc_body_start] = ACTIONS(4205),
    [sym__binary_minus] = ACTIONS(4205),
    [sym__binary_star] = ACTIONS(4205),
    [ts_builtin_sym_end] = ACTIONS(4205),
    [anon_sym___END__] = ACTIONS(4205),
    [anon_sym_LBRACE] = ACTIONS(4205),
    [anon_sym_RBRACE] = ACTIONS(4205),
    [anon_sym_RPAREN] = ACTIONS(4205),
    [anon_sym_DOT] = ACTIONS(4207),
    [anon_sym_COMMA] = ACTIONS(4205),
    [anon_sym_PIPE] = ACTIONS(4207),
    [anon_sym_SEMI] = ACTIONS(4205),
    [anon_sym_STAR_STAR] = ACTIONS(4207),
    [anon_sym_AMP] = ACTIONS(4207),
    [anon_sym_EQ] = ACTIONS(4207),
    [anon_sym_LT] = ACTIONS(4207),
    [anon_sym_end] = ACTIONS(4205),
    [anon_sym_if] = ACTIONS(4205),
    [anon_sym_unless] = ACTIONS(4205),
    [anon_sym_while] = ACTIONS(4205),
    [anon_sym_until] = ACTIONS(4205),
    [anon_sym_rescue] = ACTIONS(4205),
    [anon_sym_do] = ACTIONS(4205),
    [anon_sym_when] = ACTIONS(4205),
    [anon_sym_elsif] = ACTIONS(4205),
    [anon_sym_else] = ACTIONS(4205),
    [anon_sym_then] = ACTIONS(4205),
    [anon_sym_ensure] = ACTIONS(4205),
    [anon_sym_EQ_GT] = ACTIONS(4205),
    [anon_sym_LBRACK] = ACTIONS(4205),
    [anon_sym_COLON_COLON2] = ACTIONS(4205),
    [anon_sym_AMP_DOT] = ACTIONS(4205),
    [anon_sym_PLUS_EQ] = ACTIONS(4205),
    [anon_sym_DASH_EQ] = ACTIONS(4205),
    [anon_sym_STAR_EQ] = ACTIONS(4205),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4205),
    [anon_sym_SLASH_EQ] = ACTIONS(4205),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4205),
    [anon_sym_PIPE_EQ] = ACTIONS(4205),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4205),
    [anon_sym_AMP_EQ] = ACTIONS(4205),
    [anon_sym_PERCENT_EQ] = ACTIONS(4205),
    [anon_sym_GT_GT_EQ] = ACTIONS(4205),
    [anon_sym_LT_LT_EQ] = ACTIONS(4205),
    [anon_sym_CARET_EQ] = ACTIONS(4205),
    [anon_sym_QMARK] = ACTIONS(4205),
    [anon_sym_DOT_DOT] = ACTIONS(4207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4205),
    [anon_sym_and] = ACTIONS(4205),
    [anon_sym_or] = ACTIONS(4205),
    [anon_sym_PIPE_PIPE] = ACTIONS(4207),
    [anon_sym_AMP_AMP] = ACTIONS(4207),
    [anon_sym_LT_LT] = ACTIONS(4207),
    [anon_sym_GT_GT] = ACTIONS(4207),
    [anon_sym_EQ_EQ] = ACTIONS(4207),
    [anon_sym_BANG_EQ] = ACTIONS(4205),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4205),
    [anon_sym_LT_EQ_GT] = ACTIONS(4205),
    [anon_sym_EQ_TILDE] = ACTIONS(4205),
    [anon_sym_BANG_TILDE] = ACTIONS(4205),
    [anon_sym_LT_EQ] = ACTIONS(4207),
    [anon_sym_GT] = ACTIONS(4207),
    [anon_sym_GT_EQ] = ACTIONS(4205),
    [anon_sym_CARET] = ACTIONS(4207),
    [anon_sym_PLUS] = ACTIONS(4207),
    [anon_sym_SLASH] = ACTIONS(4207),
    [anon_sym_PERCENT] = ACTIONS(4207),
    [sym_comment] = ACTIONS(87),
  },
  [3696] = {
    [sym__statements] = STATE(1550),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(1551),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(1552),
    [sym_rescue] = STATE(1553),
    [sym__body_statement] = STATE(6371),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9814),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3697] = {
    [sym_elsif] = STATE(6373),
    [sym_else] = STATE(6373),
    [anon_sym_end] = ACTIONS(9816),
    [anon_sym_elsif] = ACTIONS(4495),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [3698] = {
    [sym__statements] = STATE(2640),
    [sym_begin_block] = STATE(2641),
    [sym_end_block] = STATE(2641),
    [sym__statement] = STATE(2641),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(2641),
    [sym_unless_modifier] = STATE(2641),
    [sym_while_modifier] = STATE(2641),
    [sym_until_modifier] = STATE(2641),
    [sym_rescue_modifier] = STATE(2641),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_elsif] = STATE(6373),
    [sym_else] = STATE(6373),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2642),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2645),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(2645),
    [sym_assignment] = STATE(2642),
    [sym_operator_assignment] = STATE(2642),
    [sym_conditional] = STATE(2642),
    [sym_range] = STATE(2642),
    [sym_binary] = STATE(2642),
    [sym_unary] = STATE(2642),
    [sym_left_assignment_list] = STATE(2644),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2645),
    [sym__variable] = STATE(2643),
    [sym_undef] = STATE(2641),
    [sym_alias] = STATE(2641),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2645),
    [sym_false] = STATE(2645),
    [sym_nil] = STATE(2645),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2646),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(2647),
    [aux_sym__statements_repeat1] = STATE(2647),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4467),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9818),
    [anon_sym_return] = ACTIONS(4471),
    [anon_sym_yield] = ACTIONS(4473),
    [anon_sym_break] = ACTIONS(4475),
    [anon_sym_next] = ACTIONS(4477),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(4499),
    [anon_sym_else] = ACTIONS(4501),
    [anon_sym_then] = ACTIONS(4503),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4479),
    [anon_sym_defined_QMARK] = ACTIONS(4481),
    [anon_sym_not] = ACTIONS(4483),
    [anon_sym_BANG] = ACTIONS(4485),
    [anon_sym_TILDE] = ACTIONS(4485),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [anon_sym_undef] = ACTIONS(4491),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3699] = {
    [sym_else] = STATE(6375),
    [anon_sym_end] = ACTIONS(9820),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [3700] = {
    [sym__statements] = STATE(2640),
    [sym_begin_block] = STATE(2715),
    [sym_end_block] = STATE(2715),
    [sym__statement] = STATE(2715),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(2715),
    [sym_unless_modifier] = STATE(2715),
    [sym_while_modifier] = STATE(2715),
    [sym_until_modifier] = STATE(2715),
    [sym_rescue_modifier] = STATE(2715),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(6375),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2716),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2719),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(2719),
    [sym_assignment] = STATE(2716),
    [sym_operator_assignment] = STATE(2716),
    [sym_conditional] = STATE(2716),
    [sym_range] = STATE(2716),
    [sym_binary] = STATE(2716),
    [sym_unary] = STATE(2716),
    [sym_left_assignment_list] = STATE(2718),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2719),
    [sym__variable] = STATE(2717),
    [sym_undef] = STATE(2715),
    [sym_alias] = STATE(2715),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2719),
    [sym_false] = STATE(2719),
    [sym_nil] = STATE(2719),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2720),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(2721),
    [aux_sym__statements_repeat1] = STATE(2721),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4583),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9822),
    [anon_sym_return] = ACTIONS(4585),
    [anon_sym_yield] = ACTIONS(4587),
    [anon_sym_break] = ACTIONS(4589),
    [anon_sym_next] = ACTIONS(4591),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(4501),
    [anon_sym_then] = ACTIONS(4611),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4593),
    [anon_sym_defined_QMARK] = ACTIONS(4595),
    [anon_sym_not] = ACTIONS(4597),
    [anon_sym_BANG] = ACTIONS(4599),
    [anon_sym_TILDE] = ACTIONS(4599),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [anon_sym_undef] = ACTIONS(4605),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3701] = {
    [sym__statements] = STATE(6377),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9824),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3702] = {
    [sym__statements] = STATE(6379),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9826),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3703] = {
    [sym__do] = STATE(6380),
    [sym_heredoc_body] = STATE(6380),
    [sym__terminator] = STATE(6380),
    [sym__line_break] = ACTIONS(9828),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(9828),
    [anon_sym_do] = ACTIONS(9828),
    [sym_comment] = ACTIONS(87),
  },
  [3704] = {
    [sym__line_break] = ACTIONS(9446),
    [sym__heredoc_body_start] = ACTIONS(9446),
    [sym__binary_minus] = ACTIONS(9446),
    [sym__binary_star] = ACTIONS(9446),
    [ts_builtin_sym_end] = ACTIONS(9446),
    [anon_sym___END__] = ACTIONS(9446),
    [anon_sym_LBRACE] = ACTIONS(9446),
    [anon_sym_RBRACE] = ACTIONS(9446),
    [anon_sym_RPAREN] = ACTIONS(9446),
    [anon_sym_DOT] = ACTIONS(9448),
    [anon_sym_COMMA] = ACTIONS(9446),
    [anon_sym_PIPE] = ACTIONS(9448),
    [anon_sym_SEMI] = ACTIONS(9446),
    [anon_sym_STAR_STAR] = ACTIONS(9448),
    [anon_sym_AMP] = ACTIONS(9448),
    [anon_sym_EQ] = ACTIONS(9448),
    [anon_sym_LT] = ACTIONS(9448),
    [anon_sym_end] = ACTIONS(9446),
    [anon_sym_if] = ACTIONS(9446),
    [anon_sym_unless] = ACTIONS(9446),
    [anon_sym_while] = ACTIONS(9446),
    [anon_sym_until] = ACTIONS(9446),
    [anon_sym_rescue] = ACTIONS(9446),
    [anon_sym_do] = ACTIONS(9446),
    [anon_sym_when] = ACTIONS(9446),
    [anon_sym_elsif] = ACTIONS(9446),
    [anon_sym_else] = ACTIONS(9446),
    [anon_sym_then] = ACTIONS(9446),
    [anon_sym_ensure] = ACTIONS(9446),
    [anon_sym_LBRACK] = ACTIONS(9446),
    [anon_sym_COLON_COLON2] = ACTIONS(9446),
    [anon_sym_AMP_DOT] = ACTIONS(9446),
    [anon_sym_PLUS_EQ] = ACTIONS(9446),
    [anon_sym_DASH_EQ] = ACTIONS(9446),
    [anon_sym_STAR_EQ] = ACTIONS(9446),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9446),
    [anon_sym_SLASH_EQ] = ACTIONS(9446),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9446),
    [anon_sym_PIPE_EQ] = ACTIONS(9446),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9446),
    [anon_sym_AMP_EQ] = ACTIONS(9446),
    [anon_sym_PERCENT_EQ] = ACTIONS(9446),
    [anon_sym_GT_GT_EQ] = ACTIONS(9446),
    [anon_sym_LT_LT_EQ] = ACTIONS(9446),
    [anon_sym_CARET_EQ] = ACTIONS(9446),
    [anon_sym_QMARK] = ACTIONS(9446),
    [anon_sym_DOT_DOT] = ACTIONS(9448),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9446),
    [anon_sym_and] = ACTIONS(9446),
    [anon_sym_or] = ACTIONS(9446),
    [anon_sym_PIPE_PIPE] = ACTIONS(9448),
    [anon_sym_AMP_AMP] = ACTIONS(9448),
    [anon_sym_LT_LT] = ACTIONS(9448),
    [anon_sym_GT_GT] = ACTIONS(9448),
    [anon_sym_EQ_EQ] = ACTIONS(9448),
    [anon_sym_BANG_EQ] = ACTIONS(9446),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9446),
    [anon_sym_LT_EQ_GT] = ACTIONS(9446),
    [anon_sym_EQ_TILDE] = ACTIONS(9446),
    [anon_sym_BANG_TILDE] = ACTIONS(9446),
    [anon_sym_LT_EQ] = ACTIONS(9448),
    [anon_sym_GT] = ACTIONS(9448),
    [anon_sym_GT_EQ] = ACTIONS(9446),
    [anon_sym_CARET] = ACTIONS(9448),
    [anon_sym_PLUS] = ACTIONS(9448),
    [anon_sym_SLASH] = ACTIONS(9448),
    [anon_sym_PERCENT] = ACTIONS(9448),
    [sym_comment] = ACTIONS(87),
  },
  [3705] = {
    [anon_sym_end] = ACTIONS(9830),
    [sym_comment] = ACTIONS(87),
  },
  [3706] = {
    [sym__statements] = STATE(6382),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9832),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3707] = {
    [sym__statements] = STATE(6382),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_heredoc_body] = STATE(6383),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [sym__terminator] = STATE(6383),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__line_break] = ACTIONS(9834),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(9834),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9832),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3708] = {
    [sym_when] = STATE(6387),
    [sym_else] = STATE(6385),
    [aux_sym_case_repeat1] = STATE(6386),
    [aux_sym_case_repeat2] = STATE(6387),
    [anon_sym_SEMI] = ACTIONS(9836),
    [anon_sym_end] = ACTIONS(9838),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [3709] = {
    [sym__line_break] = ACTIONS(4965),
    [sym__heredoc_body_start] = ACTIONS(4965),
    [sym__binary_minus] = ACTIONS(4965),
    [sym__binary_star] = ACTIONS(4965),
    [ts_builtin_sym_end] = ACTIONS(4965),
    [anon_sym___END__] = ACTIONS(4965),
    [anon_sym_LBRACE] = ACTIONS(4965),
    [anon_sym_RBRACE] = ACTIONS(4965),
    [anon_sym_RPAREN] = ACTIONS(4965),
    [anon_sym_DOT] = ACTIONS(4967),
    [anon_sym_COMMA] = ACTIONS(4965),
    [anon_sym_PIPE] = ACTIONS(4967),
    [anon_sym_SEMI] = ACTIONS(4965),
    [anon_sym_STAR_STAR] = ACTIONS(4967),
    [anon_sym_AMP] = ACTIONS(4967),
    [anon_sym_EQ] = ACTIONS(4967),
    [anon_sym_LT] = ACTIONS(4967),
    [anon_sym_end] = ACTIONS(4965),
    [anon_sym_if] = ACTIONS(4965),
    [anon_sym_unless] = ACTIONS(4965),
    [anon_sym_while] = ACTIONS(4965),
    [anon_sym_until] = ACTIONS(4965),
    [anon_sym_rescue] = ACTIONS(4965),
    [anon_sym_do] = ACTIONS(4965),
    [anon_sym_when] = ACTIONS(4965),
    [anon_sym_elsif] = ACTIONS(4965),
    [anon_sym_else] = ACTIONS(4965),
    [anon_sym_then] = ACTIONS(4965),
    [anon_sym_ensure] = ACTIONS(4965),
    [anon_sym_EQ_GT] = ACTIONS(4965),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym_COLON_COLON2] = ACTIONS(4965),
    [anon_sym_AMP_DOT] = ACTIONS(4965),
    [anon_sym_PLUS_EQ] = ACTIONS(4965),
    [anon_sym_DASH_EQ] = ACTIONS(4965),
    [anon_sym_STAR_EQ] = ACTIONS(4965),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4965),
    [anon_sym_SLASH_EQ] = ACTIONS(4965),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4965),
    [anon_sym_PIPE_EQ] = ACTIONS(4965),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4965),
    [anon_sym_AMP_EQ] = ACTIONS(4965),
    [anon_sym_PERCENT_EQ] = ACTIONS(4965),
    [anon_sym_GT_GT_EQ] = ACTIONS(4965),
    [anon_sym_LT_LT_EQ] = ACTIONS(4965),
    [anon_sym_CARET_EQ] = ACTIONS(4965),
    [anon_sym_QMARK] = ACTIONS(4965),
    [anon_sym_DOT_DOT] = ACTIONS(4967),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4965),
    [anon_sym_and] = ACTIONS(4965),
    [anon_sym_or] = ACTIONS(4965),
    [anon_sym_PIPE_PIPE] = ACTIONS(4967),
    [anon_sym_AMP_AMP] = ACTIONS(4967),
    [anon_sym_LT_LT] = ACTIONS(4967),
    [anon_sym_GT_GT] = ACTIONS(4967),
    [anon_sym_EQ_EQ] = ACTIONS(4967),
    [anon_sym_BANG_EQ] = ACTIONS(4965),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4965),
    [anon_sym_LT_EQ_GT] = ACTIONS(4965),
    [anon_sym_EQ_TILDE] = ACTIONS(4965),
    [anon_sym_BANG_TILDE] = ACTIONS(4965),
    [anon_sym_LT_EQ] = ACTIONS(4967),
    [anon_sym_GT] = ACTIONS(4967),
    [anon_sym_GT_EQ] = ACTIONS(4965),
    [anon_sym_CARET] = ACTIONS(4967),
    [anon_sym_PLUS] = ACTIONS(4967),
    [anon_sym_SLASH] = ACTIONS(4967),
    [anon_sym_PERCENT] = ACTIONS(4967),
    [sym_comment] = ACTIONS(87),
  },
  [3710] = {
    [anon_sym_end] = ACTIONS(9838),
    [sym_comment] = ACTIONS(87),
  },
  [3711] = {
    [sym_when] = STATE(6387),
    [sym_else] = STATE(6385),
    [aux_sym_case_repeat1] = STATE(2987),
    [aux_sym_case_repeat2] = STATE(6387),
    [anon_sym_SEMI] = ACTIONS(4995),
    [anon_sym_end] = ACTIONS(9838),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [3712] = {
    [sym_when] = STATE(2988),
    [sym_else] = STATE(6385),
    [aux_sym_case_repeat2] = STATE(2988),
    [anon_sym_end] = ACTIONS(9838),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [3713] = {
    [sym__line_break] = ACTIONS(5407),
    [sym__heredoc_body_start] = ACTIONS(5407),
    [sym__binary_minus] = ACTIONS(5407),
    [sym__binary_star] = ACTIONS(5407),
    [ts_builtin_sym_end] = ACTIONS(5407),
    [anon_sym___END__] = ACTIONS(5407),
    [anon_sym_LBRACE] = ACTIONS(5407),
    [anon_sym_RBRACE] = ACTIONS(5407),
    [anon_sym_RPAREN] = ACTIONS(5407),
    [anon_sym_DOT] = ACTIONS(5409),
    [anon_sym_COMMA] = ACTIONS(5407),
    [anon_sym_PIPE] = ACTIONS(5409),
    [anon_sym_SEMI] = ACTIONS(5407),
    [anon_sym_STAR_STAR] = ACTIONS(5409),
    [anon_sym_AMP] = ACTIONS(5409),
    [anon_sym_EQ] = ACTIONS(5409),
    [anon_sym_LT] = ACTIONS(5409),
    [anon_sym_end] = ACTIONS(5407),
    [anon_sym_if] = ACTIONS(5407),
    [anon_sym_unless] = ACTIONS(5407),
    [anon_sym_while] = ACTIONS(5407),
    [anon_sym_until] = ACTIONS(5407),
    [anon_sym_rescue] = ACTIONS(5407),
    [anon_sym_do] = ACTIONS(5407),
    [anon_sym_when] = ACTIONS(5407),
    [anon_sym_elsif] = ACTIONS(5407),
    [anon_sym_else] = ACTIONS(5407),
    [anon_sym_then] = ACTIONS(5407),
    [anon_sym_ensure] = ACTIONS(5407),
    [anon_sym_EQ_GT] = ACTIONS(5407),
    [anon_sym_LBRACK] = ACTIONS(5407),
    [anon_sym_COLON_COLON2] = ACTIONS(5407),
    [anon_sym_AMP_DOT] = ACTIONS(5407),
    [anon_sym_PLUS_EQ] = ACTIONS(5407),
    [anon_sym_DASH_EQ] = ACTIONS(5407),
    [anon_sym_STAR_EQ] = ACTIONS(5407),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5407),
    [anon_sym_SLASH_EQ] = ACTIONS(5407),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5407),
    [anon_sym_PIPE_EQ] = ACTIONS(5407),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5407),
    [anon_sym_AMP_EQ] = ACTIONS(5407),
    [anon_sym_PERCENT_EQ] = ACTIONS(5407),
    [anon_sym_GT_GT_EQ] = ACTIONS(5407),
    [anon_sym_LT_LT_EQ] = ACTIONS(5407),
    [anon_sym_CARET_EQ] = ACTIONS(5407),
    [anon_sym_QMARK] = ACTIONS(5407),
    [anon_sym_DOT_DOT] = ACTIONS(5409),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5407),
    [anon_sym_and] = ACTIONS(5407),
    [anon_sym_or] = ACTIONS(5407),
    [anon_sym_PIPE_PIPE] = ACTIONS(5409),
    [anon_sym_AMP_AMP] = ACTIONS(5409),
    [anon_sym_LT_LT] = ACTIONS(5409),
    [anon_sym_GT_GT] = ACTIONS(5409),
    [anon_sym_EQ_EQ] = ACTIONS(5409),
    [anon_sym_BANG_EQ] = ACTIONS(5407),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5407),
    [anon_sym_LT_EQ_GT] = ACTIONS(5407),
    [anon_sym_EQ_TILDE] = ACTIONS(5407),
    [anon_sym_BANG_TILDE] = ACTIONS(5407),
    [anon_sym_LT_EQ] = ACTIONS(5409),
    [anon_sym_GT] = ACTIONS(5409),
    [anon_sym_GT_EQ] = ACTIONS(5407),
    [anon_sym_CARET] = ACTIONS(5409),
    [anon_sym_PLUS] = ACTIONS(5409),
    [anon_sym_SLASH] = ACTIONS(5409),
    [anon_sym_PERCENT] = ACTIONS(5409),
    [sym_comment] = ACTIONS(87),
  },
  [3714] = {
    [sym_ensure] = STATE(6389),
    [anon_sym_end] = ACTIONS(9840),
    [anon_sym_ensure] = ACTIONS(2169),
    [sym_comment] = ACTIONS(87),
  },
  [3715] = {
    [anon_sym_end] = ACTIONS(9840),
    [sym_comment] = ACTIONS(87),
  },
  [3716] = {
    [sym_else] = STATE(6390),
    [sym_ensure] = STATE(6389),
    [anon_sym_end] = ACTIONS(9840),
    [anon_sym_else] = ACTIONS(2167),
    [anon_sym_ensure] = ACTIONS(2169),
    [sym_comment] = ACTIONS(87),
  },
  [3717] = {
    [sym__line_break] = ACTIONS(5491),
    [sym__heredoc_body_start] = ACTIONS(5491),
    [sym__binary_minus] = ACTIONS(5491),
    [sym__binary_star] = ACTIONS(5491),
    [ts_builtin_sym_end] = ACTIONS(5491),
    [anon_sym___END__] = ACTIONS(5491),
    [anon_sym_LBRACE] = ACTIONS(5491),
    [anon_sym_RBRACE] = ACTIONS(5491),
    [anon_sym_RPAREN] = ACTIONS(5491),
    [anon_sym_DOT] = ACTIONS(5493),
    [anon_sym_COMMA] = ACTIONS(5491),
    [anon_sym_PIPE] = ACTIONS(5493),
    [anon_sym_SEMI] = ACTIONS(5491),
    [anon_sym_STAR_STAR] = ACTIONS(5493),
    [anon_sym_AMP] = ACTIONS(5493),
    [anon_sym_EQ] = ACTIONS(5493),
    [anon_sym_LT] = ACTIONS(5493),
    [anon_sym_end] = ACTIONS(5491),
    [anon_sym_if] = ACTIONS(5491),
    [anon_sym_unless] = ACTIONS(5491),
    [anon_sym_while] = ACTIONS(5491),
    [anon_sym_until] = ACTIONS(5491),
    [anon_sym_rescue] = ACTIONS(5491),
    [anon_sym_do] = ACTIONS(5491),
    [anon_sym_when] = ACTIONS(5491),
    [anon_sym_elsif] = ACTIONS(5491),
    [anon_sym_else] = ACTIONS(5491),
    [anon_sym_then] = ACTIONS(5491),
    [anon_sym_ensure] = ACTIONS(5491),
    [anon_sym_EQ_GT] = ACTIONS(5491),
    [anon_sym_LBRACK] = ACTIONS(5491),
    [anon_sym_COLON_COLON2] = ACTIONS(5491),
    [anon_sym_AMP_DOT] = ACTIONS(5491),
    [anon_sym_PLUS_EQ] = ACTIONS(5491),
    [anon_sym_DASH_EQ] = ACTIONS(5491),
    [anon_sym_STAR_EQ] = ACTIONS(5491),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5491),
    [anon_sym_SLASH_EQ] = ACTIONS(5491),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5491),
    [anon_sym_PIPE_EQ] = ACTIONS(5491),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5491),
    [anon_sym_AMP_EQ] = ACTIONS(5491),
    [anon_sym_PERCENT_EQ] = ACTIONS(5491),
    [anon_sym_GT_GT_EQ] = ACTIONS(5491),
    [anon_sym_LT_LT_EQ] = ACTIONS(5491),
    [anon_sym_CARET_EQ] = ACTIONS(5491),
    [anon_sym_QMARK] = ACTIONS(5491),
    [anon_sym_DOT_DOT] = ACTIONS(5493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5491),
    [anon_sym_and] = ACTIONS(5491),
    [anon_sym_or] = ACTIONS(5491),
    [anon_sym_PIPE_PIPE] = ACTIONS(5493),
    [anon_sym_AMP_AMP] = ACTIONS(5493),
    [anon_sym_LT_LT] = ACTIONS(5493),
    [anon_sym_GT_GT] = ACTIONS(5493),
    [anon_sym_EQ_EQ] = ACTIONS(5493),
    [anon_sym_BANG_EQ] = ACTIONS(5491),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5491),
    [anon_sym_LT_EQ_GT] = ACTIONS(5491),
    [anon_sym_EQ_TILDE] = ACTIONS(5491),
    [anon_sym_BANG_TILDE] = ACTIONS(5491),
    [anon_sym_LT_EQ] = ACTIONS(5493),
    [anon_sym_GT] = ACTIONS(5493),
    [anon_sym_GT_EQ] = ACTIONS(5491),
    [anon_sym_CARET] = ACTIONS(5493),
    [anon_sym_PLUS] = ACTIONS(5493),
    [anon_sym_SLASH] = ACTIONS(5493),
    [anon_sym_PERCENT] = ACTIONS(5493),
    [sym_comment] = ACTIONS(87),
  },
  [3718] = {
    [sym__line_break] = ACTIONS(7876),
    [sym__heredoc_body_start] = ACTIONS(7876),
    [sym__binary_minus] = ACTIONS(7876),
    [sym__binary_star] = ACTIONS(7876),
    [ts_builtin_sym_end] = ACTIONS(7876),
    [anon_sym___END__] = ACTIONS(7876),
    [anon_sym_LBRACE] = ACTIONS(7876),
    [anon_sym_RBRACE] = ACTIONS(7876),
    [anon_sym_RPAREN] = ACTIONS(7876),
    [anon_sym_DOT] = ACTIONS(7878),
    [anon_sym_COMMA] = ACTIONS(7876),
    [anon_sym_PIPE] = ACTIONS(7878),
    [anon_sym_SEMI] = ACTIONS(7876),
    [anon_sym_STAR_STAR] = ACTIONS(7878),
    [anon_sym_AMP] = ACTIONS(7878),
    [anon_sym_EQ] = ACTIONS(7878),
    [anon_sym_LT] = ACTIONS(7878),
    [anon_sym_end] = ACTIONS(7876),
    [anon_sym_if] = ACTIONS(7876),
    [anon_sym_unless] = ACTIONS(7876),
    [anon_sym_while] = ACTIONS(7876),
    [anon_sym_until] = ACTIONS(7876),
    [anon_sym_rescue] = ACTIONS(7876),
    [anon_sym_do] = ACTIONS(7876),
    [anon_sym_when] = ACTIONS(7876),
    [anon_sym_elsif] = ACTIONS(7876),
    [anon_sym_else] = ACTIONS(7876),
    [anon_sym_then] = ACTIONS(7876),
    [anon_sym_ensure] = ACTIONS(7876),
    [anon_sym_LBRACK] = ACTIONS(7876),
    [anon_sym_COLON_COLON2] = ACTIONS(7876),
    [anon_sym_AMP_DOT] = ACTIONS(7876),
    [anon_sym_PLUS_EQ] = ACTIONS(7876),
    [anon_sym_DASH_EQ] = ACTIONS(7876),
    [anon_sym_STAR_EQ] = ACTIONS(7876),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7876),
    [anon_sym_SLASH_EQ] = ACTIONS(7876),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7876),
    [anon_sym_PIPE_EQ] = ACTIONS(7876),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7876),
    [anon_sym_AMP_EQ] = ACTIONS(7876),
    [anon_sym_PERCENT_EQ] = ACTIONS(7876),
    [anon_sym_GT_GT_EQ] = ACTIONS(7876),
    [anon_sym_LT_LT_EQ] = ACTIONS(7876),
    [anon_sym_CARET_EQ] = ACTIONS(7876),
    [anon_sym_QMARK] = ACTIONS(7876),
    [anon_sym_DOT_DOT] = ACTIONS(7878),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7876),
    [anon_sym_and] = ACTIONS(7876),
    [anon_sym_or] = ACTIONS(7876),
    [anon_sym_PIPE_PIPE] = ACTIONS(7878),
    [anon_sym_AMP_AMP] = ACTIONS(7878),
    [anon_sym_LT_LT] = ACTIONS(7878),
    [anon_sym_GT_GT] = ACTIONS(7878),
    [anon_sym_EQ_EQ] = ACTIONS(7878),
    [anon_sym_BANG_EQ] = ACTIONS(7876),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7876),
    [anon_sym_LT_EQ_GT] = ACTIONS(7876),
    [anon_sym_EQ_TILDE] = ACTIONS(7876),
    [anon_sym_BANG_TILDE] = ACTIONS(7876),
    [anon_sym_LT_EQ] = ACTIONS(7878),
    [anon_sym_GT] = ACTIONS(7878),
    [anon_sym_GT_EQ] = ACTIONS(7876),
    [anon_sym_CARET] = ACTIONS(7878),
    [anon_sym_PLUS] = ACTIONS(7878),
    [anon_sym_SLASH] = ACTIONS(7878),
    [anon_sym_PERCENT] = ACTIONS(7878),
    [sym_comment] = ACTIONS(87),
  },
  [3719] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(6019),
    [sym__binary_star] = ACTIONS(6021),
    [ts_builtin_sym_end] = ACTIONS(7027),
    [anon_sym___END__] = ACTIONS(7027),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(6023),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_AMP] = ACTIONS(6027),
    [anon_sym_EQ] = ACTIONS(7884),
    [anon_sym_LT] = ACTIONS(6029),
    [anon_sym_if] = ACTIONS(7027),
    [anon_sym_unless] = ACTIONS(7027),
    [anon_sym_while] = ACTIONS(7027),
    [anon_sym_until] = ACTIONS(7027),
    [anon_sym_rescue] = ACTIONS(7027),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_PLUS_EQ] = ACTIONS(7027),
    [anon_sym_DASH_EQ] = ACTIONS(7027),
    [anon_sym_STAR_EQ] = ACTIONS(7027),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7027),
    [anon_sym_SLASH_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7027),
    [anon_sym_AMP_EQ] = ACTIONS(7027),
    [anon_sym_PERCENT_EQ] = ACTIONS(7027),
    [anon_sym_GT_GT_EQ] = ACTIONS(7027),
    [anon_sym_LT_LT_EQ] = ACTIONS(7027),
    [anon_sym_CARET_EQ] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(6031),
    [anon_sym_DOT_DOT] = ACTIONS(6033),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6035),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(6037),
    [anon_sym_AMP_AMP] = ACTIONS(6037),
    [anon_sym_LT_LT] = ACTIONS(6039),
    [anon_sym_GT_GT] = ACTIONS(6039),
    [anon_sym_EQ_EQ] = ACTIONS(6037),
    [anon_sym_BANG_EQ] = ACTIONS(6041),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6041),
    [anon_sym_LT_EQ_GT] = ACTIONS(6041),
    [anon_sym_EQ_TILDE] = ACTIONS(6041),
    [anon_sym_BANG_TILDE] = ACTIONS(6041),
    [anon_sym_LT_EQ] = ACTIONS(6029),
    [anon_sym_GT] = ACTIONS(6029),
    [anon_sym_GT_EQ] = ACTIONS(6043),
    [anon_sym_CARET] = ACTIONS(6023),
    [anon_sym_PLUS] = ACTIONS(6045),
    [anon_sym_SLASH] = ACTIONS(6025),
    [anon_sym_PERCENT] = ACTIONS(6025),
    [sym_comment] = ACTIONS(87),
  },
  [3720] = {
    [sym__line_break] = ACTIONS(5725),
    [sym__heredoc_body_start] = ACTIONS(5725),
    [sym__binary_minus] = ACTIONS(5725),
    [sym__binary_star] = ACTIONS(5725),
    [ts_builtin_sym_end] = ACTIONS(5725),
    [anon_sym___END__] = ACTIONS(5725),
    [anon_sym_LBRACE] = ACTIONS(5725),
    [anon_sym_RBRACE] = ACTIONS(5725),
    [anon_sym_RPAREN] = ACTIONS(5725),
    [anon_sym_DOT] = ACTIONS(5727),
    [anon_sym_COMMA] = ACTIONS(5725),
    [anon_sym_PIPE] = ACTIONS(5727),
    [anon_sym_SEMI] = ACTIONS(5725),
    [anon_sym_STAR_STAR] = ACTIONS(5727),
    [anon_sym_AMP] = ACTIONS(5727),
    [anon_sym_EQ] = ACTIONS(5727),
    [anon_sym_LT] = ACTIONS(5727),
    [anon_sym_end] = ACTIONS(5725),
    [anon_sym_if] = ACTIONS(5725),
    [anon_sym_unless] = ACTIONS(5725),
    [anon_sym_while] = ACTIONS(5725),
    [anon_sym_until] = ACTIONS(5725),
    [anon_sym_rescue] = ACTIONS(5725),
    [anon_sym_do] = ACTIONS(5725),
    [anon_sym_when] = ACTIONS(5725),
    [anon_sym_elsif] = ACTIONS(5725),
    [anon_sym_else] = ACTIONS(5725),
    [anon_sym_then] = ACTIONS(5725),
    [anon_sym_ensure] = ACTIONS(5725),
    [anon_sym_EQ_GT] = ACTIONS(5725),
    [anon_sym_LBRACK] = ACTIONS(5725),
    [anon_sym_COLON_COLON2] = ACTIONS(5725),
    [anon_sym_AMP_DOT] = ACTIONS(5725),
    [anon_sym_PLUS_EQ] = ACTIONS(5725),
    [anon_sym_DASH_EQ] = ACTIONS(5725),
    [anon_sym_STAR_EQ] = ACTIONS(5725),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5725),
    [anon_sym_SLASH_EQ] = ACTIONS(5725),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5725),
    [anon_sym_PIPE_EQ] = ACTIONS(5725),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5725),
    [anon_sym_AMP_EQ] = ACTIONS(5725),
    [anon_sym_PERCENT_EQ] = ACTIONS(5725),
    [anon_sym_GT_GT_EQ] = ACTIONS(5725),
    [anon_sym_LT_LT_EQ] = ACTIONS(5725),
    [anon_sym_CARET_EQ] = ACTIONS(5725),
    [anon_sym_QMARK] = ACTIONS(5725),
    [anon_sym_DOT_DOT] = ACTIONS(5727),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5725),
    [anon_sym_and] = ACTIONS(5725),
    [anon_sym_or] = ACTIONS(5725),
    [anon_sym_PIPE_PIPE] = ACTIONS(5727),
    [anon_sym_AMP_AMP] = ACTIONS(5727),
    [anon_sym_LT_LT] = ACTIONS(5727),
    [anon_sym_GT_GT] = ACTIONS(5727),
    [anon_sym_EQ_EQ] = ACTIONS(5727),
    [anon_sym_BANG_EQ] = ACTIONS(5725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5725),
    [anon_sym_LT_EQ_GT] = ACTIONS(5725),
    [anon_sym_EQ_TILDE] = ACTIONS(5725),
    [anon_sym_BANG_TILDE] = ACTIONS(5725),
    [anon_sym_LT_EQ] = ACTIONS(5727),
    [anon_sym_GT] = ACTIONS(5727),
    [anon_sym_GT_EQ] = ACTIONS(5725),
    [anon_sym_CARET] = ACTIONS(5727),
    [anon_sym_PLUS] = ACTIONS(5727),
    [anon_sym_SLASH] = ACTIONS(5727),
    [anon_sym_PERCENT] = ACTIONS(5727),
    [sym_comment] = ACTIONS(87),
  },
  [3721] = {
    [sym__line_break] = ACTIONS(5735),
    [sym__heredoc_body_start] = ACTIONS(5735),
    [sym__binary_minus] = ACTIONS(5735),
    [sym__binary_star] = ACTIONS(5735),
    [ts_builtin_sym_end] = ACTIONS(5735),
    [anon_sym___END__] = ACTIONS(5735),
    [anon_sym_LBRACE] = ACTIONS(5735),
    [anon_sym_RBRACE] = ACTIONS(5735),
    [anon_sym_RPAREN] = ACTIONS(5735),
    [anon_sym_DOT] = ACTIONS(5737),
    [anon_sym_COMMA] = ACTIONS(5735),
    [anon_sym_PIPE] = ACTIONS(5737),
    [anon_sym_SEMI] = ACTIONS(5735),
    [anon_sym_STAR_STAR] = ACTIONS(5737),
    [anon_sym_AMP] = ACTIONS(5737),
    [anon_sym_EQ] = ACTIONS(5737),
    [anon_sym_LT] = ACTIONS(5737),
    [anon_sym_end] = ACTIONS(5735),
    [anon_sym_if] = ACTIONS(5735),
    [anon_sym_unless] = ACTIONS(5735),
    [anon_sym_while] = ACTIONS(5735),
    [anon_sym_until] = ACTIONS(5735),
    [anon_sym_rescue] = ACTIONS(5735),
    [anon_sym_do] = ACTIONS(5735),
    [anon_sym_when] = ACTIONS(5735),
    [anon_sym_elsif] = ACTIONS(5735),
    [anon_sym_else] = ACTIONS(5735),
    [anon_sym_then] = ACTIONS(5735),
    [anon_sym_ensure] = ACTIONS(5735),
    [anon_sym_EQ_GT] = ACTIONS(5735),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_COLON_COLON2] = ACTIONS(5735),
    [anon_sym_AMP_DOT] = ACTIONS(5735),
    [anon_sym_PLUS_EQ] = ACTIONS(5735),
    [anon_sym_DASH_EQ] = ACTIONS(5735),
    [anon_sym_STAR_EQ] = ACTIONS(5735),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5735),
    [anon_sym_SLASH_EQ] = ACTIONS(5735),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5735),
    [anon_sym_PIPE_EQ] = ACTIONS(5735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5735),
    [anon_sym_AMP_EQ] = ACTIONS(5735),
    [anon_sym_PERCENT_EQ] = ACTIONS(5735),
    [anon_sym_GT_GT_EQ] = ACTIONS(5735),
    [anon_sym_LT_LT_EQ] = ACTIONS(5735),
    [anon_sym_CARET_EQ] = ACTIONS(5735),
    [anon_sym_QMARK] = ACTIONS(5735),
    [anon_sym_DOT_DOT] = ACTIONS(5737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5735),
    [anon_sym_and] = ACTIONS(5735),
    [anon_sym_or] = ACTIONS(5735),
    [anon_sym_PIPE_PIPE] = ACTIONS(5737),
    [anon_sym_AMP_AMP] = ACTIONS(5737),
    [anon_sym_LT_LT] = ACTIONS(5737),
    [anon_sym_GT_GT] = ACTIONS(5737),
    [anon_sym_EQ_EQ] = ACTIONS(5737),
    [anon_sym_BANG_EQ] = ACTIONS(5735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5735),
    [anon_sym_LT_EQ_GT] = ACTIONS(5735),
    [anon_sym_EQ_TILDE] = ACTIONS(5735),
    [anon_sym_BANG_TILDE] = ACTIONS(5735),
    [anon_sym_LT_EQ] = ACTIONS(5737),
    [anon_sym_GT] = ACTIONS(5737),
    [anon_sym_GT_EQ] = ACTIONS(5735),
    [anon_sym_CARET] = ACTIONS(5737),
    [anon_sym_PLUS] = ACTIONS(5737),
    [anon_sym_SLASH] = ACTIONS(5737),
    [anon_sym_PERCENT] = ACTIONS(5737),
    [sym_comment] = ACTIONS(87),
  },
  [3722] = {
    [sym__line_break] = ACTIONS(5807),
    [sym__heredoc_body_start] = ACTIONS(5807),
    [sym__binary_minus] = ACTIONS(5807),
    [sym__binary_star] = ACTIONS(5807),
    [ts_builtin_sym_end] = ACTIONS(5807),
    [anon_sym___END__] = ACTIONS(5807),
    [anon_sym_LBRACE] = ACTIONS(5807),
    [anon_sym_RBRACE] = ACTIONS(5807),
    [anon_sym_RPAREN] = ACTIONS(5807),
    [anon_sym_DOT] = ACTIONS(5809),
    [anon_sym_COMMA] = ACTIONS(5807),
    [anon_sym_PIPE] = ACTIONS(5809),
    [anon_sym_SEMI] = ACTIONS(5807),
    [anon_sym_STAR_STAR] = ACTIONS(5809),
    [anon_sym_AMP] = ACTIONS(5809),
    [anon_sym_EQ] = ACTIONS(5809),
    [anon_sym_LT] = ACTIONS(5809),
    [anon_sym_end] = ACTIONS(5807),
    [anon_sym_if] = ACTIONS(5807),
    [anon_sym_unless] = ACTIONS(5807),
    [anon_sym_while] = ACTIONS(5807),
    [anon_sym_until] = ACTIONS(5807),
    [anon_sym_rescue] = ACTIONS(5807),
    [anon_sym_do] = ACTIONS(5807),
    [anon_sym_when] = ACTIONS(5807),
    [anon_sym_elsif] = ACTIONS(5807),
    [anon_sym_else] = ACTIONS(5807),
    [anon_sym_then] = ACTIONS(5807),
    [anon_sym_ensure] = ACTIONS(5807),
    [anon_sym_EQ_GT] = ACTIONS(5807),
    [anon_sym_LBRACK] = ACTIONS(5807),
    [anon_sym_COLON_COLON2] = ACTIONS(5807),
    [anon_sym_AMP_DOT] = ACTIONS(5807),
    [anon_sym_PLUS_EQ] = ACTIONS(5807),
    [anon_sym_DASH_EQ] = ACTIONS(5807),
    [anon_sym_STAR_EQ] = ACTIONS(5807),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5807),
    [anon_sym_SLASH_EQ] = ACTIONS(5807),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5807),
    [anon_sym_PIPE_EQ] = ACTIONS(5807),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5807),
    [anon_sym_AMP_EQ] = ACTIONS(5807),
    [anon_sym_PERCENT_EQ] = ACTIONS(5807),
    [anon_sym_GT_GT_EQ] = ACTIONS(5807),
    [anon_sym_LT_LT_EQ] = ACTIONS(5807),
    [anon_sym_CARET_EQ] = ACTIONS(5807),
    [anon_sym_QMARK] = ACTIONS(5807),
    [anon_sym_DOT_DOT] = ACTIONS(5809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5807),
    [anon_sym_and] = ACTIONS(5807),
    [anon_sym_or] = ACTIONS(5807),
    [anon_sym_PIPE_PIPE] = ACTIONS(5809),
    [anon_sym_AMP_AMP] = ACTIONS(5809),
    [anon_sym_LT_LT] = ACTIONS(5809),
    [anon_sym_GT_GT] = ACTIONS(5809),
    [anon_sym_EQ_EQ] = ACTIONS(5809),
    [anon_sym_BANG_EQ] = ACTIONS(5807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5807),
    [anon_sym_LT_EQ_GT] = ACTIONS(5807),
    [anon_sym_EQ_TILDE] = ACTIONS(5807),
    [anon_sym_BANG_TILDE] = ACTIONS(5807),
    [anon_sym_LT_EQ] = ACTIONS(5809),
    [anon_sym_GT] = ACTIONS(5809),
    [anon_sym_GT_EQ] = ACTIONS(5807),
    [anon_sym_CARET] = ACTIONS(5809),
    [anon_sym_PLUS] = ACTIONS(5809),
    [anon_sym_SLASH] = ACTIONS(5809),
    [anon_sym_PERCENT] = ACTIONS(5809),
    [sym_comment] = ACTIONS(87),
  },
  [3723] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(2689),
    [ts_builtin_sym_end] = ACTIONS(5825),
    [anon_sym___END__] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(2693),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(2693),
    [anon_sym_PERCENT] = ACTIONS(2693),
    [sym_comment] = ACTIONS(87),
  },
  [3724] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [ts_builtin_sym_end] = ACTIONS(5825),
    [anon_sym___END__] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(2693),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(5827),
    [anon_sym_PERCENT] = ACTIONS(5827),
    [sym_comment] = ACTIONS(87),
  },
  [3725] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(2687),
    [sym__binary_star] = ACTIONS(2689),
    [ts_builtin_sym_end] = ACTIONS(5825),
    [anon_sym___END__] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(2693),
    [anon_sym_AMP] = ACTIONS(2695),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(2707),
    [anon_sym_GT_GT] = ACTIONS(2707),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_SLASH] = ACTIONS(2693),
    [anon_sym_PERCENT] = ACTIONS(2693),
    [sym_comment] = ACTIONS(87),
  },
  [3726] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(2687),
    [sym__binary_star] = ACTIONS(2689),
    [ts_builtin_sym_end] = ACTIONS(5825),
    [anon_sym___END__] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(2693),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(2707),
    [anon_sym_GT_GT] = ACTIONS(2707),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_SLASH] = ACTIONS(2693),
    [anon_sym_PERCENT] = ACTIONS(2693),
    [sym_comment] = ACTIONS(87),
  },
  [3727] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(2687),
    [sym__binary_star] = ACTIONS(2689),
    [ts_builtin_sym_end] = ACTIONS(5825),
    [anon_sym___END__] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(2691),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(2693),
    [anon_sym_AMP] = ACTIONS(2695),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(2707),
    [anon_sym_GT_GT] = ACTIONS(2707),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(2691),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_SLASH] = ACTIONS(2693),
    [anon_sym_PERCENT] = ACTIONS(2693),
    [sym_comment] = ACTIONS(87),
  },
  [3728] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(9842),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [3729] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(2687),
    [sym__binary_star] = ACTIONS(2689),
    [ts_builtin_sym_end] = ACTIONS(5927),
    [anon_sym___END__] = ACTIONS(5927),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(2691),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(2693),
    [anon_sym_AMP] = ACTIONS(2695),
    [anon_sym_EQ] = ACTIONS(7888),
    [anon_sym_LT] = ACTIONS(2697),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_EQ_GT] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_PLUS_EQ] = ACTIONS(5927),
    [anon_sym_DASH_EQ] = ACTIONS(5927),
    [anon_sym_STAR_EQ] = ACTIONS(5927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5927),
    [anon_sym_SLASH_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5927),
    [anon_sym_AMP_EQ] = ACTIONS(5927),
    [anon_sym_PERCENT_EQ] = ACTIONS(5927),
    [anon_sym_GT_GT_EQ] = ACTIONS(5927),
    [anon_sym_LT_LT_EQ] = ACTIONS(5927),
    [anon_sym_CARET_EQ] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(2701),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2703),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(2705),
    [anon_sym_AMP_AMP] = ACTIONS(2705),
    [anon_sym_LT_LT] = ACTIONS(2707),
    [anon_sym_GT_GT] = ACTIONS(2707),
    [anon_sym_EQ_EQ] = ACTIONS(2705),
    [anon_sym_BANG_EQ] = ACTIONS(2709),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2709),
    [anon_sym_LT_EQ_GT] = ACTIONS(2709),
    [anon_sym_EQ_TILDE] = ACTIONS(2709),
    [anon_sym_BANG_TILDE] = ACTIONS(2709),
    [anon_sym_LT_EQ] = ACTIONS(2697),
    [anon_sym_GT] = ACTIONS(2697),
    [anon_sym_GT_EQ] = ACTIONS(2711),
    [anon_sym_CARET] = ACTIONS(2691),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_SLASH] = ACTIONS(2693),
    [anon_sym_PERCENT] = ACTIONS(2693),
    [sym_comment] = ACTIONS(87),
  },
  [3730] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(2687),
    [sym__binary_star] = ACTIONS(2689),
    [ts_builtin_sym_end] = ACTIONS(5825),
    [anon_sym___END__] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(2691),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(2693),
    [anon_sym_AMP] = ACTIONS(2695),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(2697),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(2699),
    [anon_sym_DOT_DOT] = ACTIONS(2701),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2703),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(2705),
    [anon_sym_AMP_AMP] = ACTIONS(2705),
    [anon_sym_LT_LT] = ACTIONS(2707),
    [anon_sym_GT_GT] = ACTIONS(2707),
    [anon_sym_EQ_EQ] = ACTIONS(2705),
    [anon_sym_BANG_EQ] = ACTIONS(2709),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2709),
    [anon_sym_LT_EQ_GT] = ACTIONS(2709),
    [anon_sym_EQ_TILDE] = ACTIONS(2709),
    [anon_sym_BANG_TILDE] = ACTIONS(2709),
    [anon_sym_LT_EQ] = ACTIONS(2697),
    [anon_sym_GT] = ACTIONS(2697),
    [anon_sym_GT_EQ] = ACTIONS(2711),
    [anon_sym_CARET] = ACTIONS(2691),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_SLASH] = ACTIONS(2693),
    [anon_sym_PERCENT] = ACTIONS(2693),
    [sym_comment] = ACTIONS(87),
  },
  [3731] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(2687),
    [sym__binary_star] = ACTIONS(2689),
    [ts_builtin_sym_end] = ACTIONS(5825),
    [anon_sym___END__] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(2691),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(2693),
    [anon_sym_AMP] = ACTIONS(2695),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(2697),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(2707),
    [anon_sym_GT_GT] = ACTIONS(2707),
    [anon_sym_EQ_EQ] = ACTIONS(2705),
    [anon_sym_BANG_EQ] = ACTIONS(2709),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2709),
    [anon_sym_LT_EQ_GT] = ACTIONS(2709),
    [anon_sym_EQ_TILDE] = ACTIONS(2709),
    [anon_sym_BANG_TILDE] = ACTIONS(2709),
    [anon_sym_LT_EQ] = ACTIONS(2697),
    [anon_sym_GT] = ACTIONS(2697),
    [anon_sym_GT_EQ] = ACTIONS(2711),
    [anon_sym_CARET] = ACTIONS(2691),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_SLASH] = ACTIONS(2693),
    [anon_sym_PERCENT] = ACTIONS(2693),
    [sym_comment] = ACTIONS(87),
  },
  [3732] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(2687),
    [sym__binary_star] = ACTIONS(2689),
    [ts_builtin_sym_end] = ACTIONS(5825),
    [anon_sym___END__] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(2693),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_SLASH] = ACTIONS(2693),
    [anon_sym_PERCENT] = ACTIONS(2693),
    [sym_comment] = ACTIONS(87),
  },
  [3733] = {
    [sym__line_break] = ACTIONS(5735),
    [sym__heredoc_body_start] = ACTIONS(5735),
    [sym__binary_minus] = ACTIONS(5735),
    [sym__binary_star] = ACTIONS(5735),
    [ts_builtin_sym_end] = ACTIONS(5735),
    [anon_sym___END__] = ACTIONS(5735),
    [anon_sym_LBRACE] = ACTIONS(5735),
    [anon_sym_RBRACE] = ACTIONS(5735),
    [anon_sym_RPAREN] = ACTIONS(5735),
    [anon_sym_DOT] = ACTIONS(5737),
    [anon_sym_COMMA] = ACTIONS(5735),
    [anon_sym_PIPE] = ACTIONS(5737),
    [anon_sym_SEMI] = ACTIONS(5735),
    [anon_sym_STAR_STAR] = ACTIONS(5737),
    [anon_sym_AMP] = ACTIONS(5737),
    [anon_sym_EQ] = ACTIONS(5737),
    [anon_sym_LT] = ACTIONS(5737),
    [anon_sym_end] = ACTIONS(5735),
    [anon_sym_if] = ACTIONS(5735),
    [anon_sym_unless] = ACTIONS(5735),
    [anon_sym_while] = ACTIONS(5735),
    [anon_sym_until] = ACTIONS(5735),
    [anon_sym_rescue] = ACTIONS(5735),
    [anon_sym_do] = ACTIONS(5735),
    [anon_sym_when] = ACTIONS(5735),
    [anon_sym_elsif] = ACTIONS(5735),
    [anon_sym_else] = ACTIONS(5735),
    [anon_sym_then] = ACTIONS(5735),
    [anon_sym_ensure] = ACTIONS(5735),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_COLON_COLON2] = ACTIONS(5735),
    [anon_sym_AMP_DOT] = ACTIONS(5735),
    [anon_sym_PLUS_EQ] = ACTIONS(5735),
    [anon_sym_DASH_EQ] = ACTIONS(5735),
    [anon_sym_STAR_EQ] = ACTIONS(5735),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5735),
    [anon_sym_SLASH_EQ] = ACTIONS(5735),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5735),
    [anon_sym_PIPE_EQ] = ACTIONS(5735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5735),
    [anon_sym_AMP_EQ] = ACTIONS(5735),
    [anon_sym_PERCENT_EQ] = ACTIONS(5735),
    [anon_sym_GT_GT_EQ] = ACTIONS(5735),
    [anon_sym_LT_LT_EQ] = ACTIONS(5735),
    [anon_sym_CARET_EQ] = ACTIONS(5735),
    [anon_sym_QMARK] = ACTIONS(5735),
    [anon_sym_DOT_DOT] = ACTIONS(5737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5735),
    [anon_sym_and] = ACTIONS(5735),
    [anon_sym_or] = ACTIONS(5735),
    [anon_sym_PIPE_PIPE] = ACTIONS(5737),
    [anon_sym_AMP_AMP] = ACTIONS(5737),
    [anon_sym_LT_LT] = ACTIONS(5737),
    [anon_sym_GT_GT] = ACTIONS(5737),
    [anon_sym_EQ_EQ] = ACTIONS(5737),
    [anon_sym_BANG_EQ] = ACTIONS(5735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5735),
    [anon_sym_LT_EQ_GT] = ACTIONS(5735),
    [anon_sym_EQ_TILDE] = ACTIONS(5735),
    [anon_sym_BANG_TILDE] = ACTIONS(5735),
    [anon_sym_LT_EQ] = ACTIONS(5737),
    [anon_sym_GT] = ACTIONS(5737),
    [anon_sym_GT_EQ] = ACTIONS(5735),
    [anon_sym_CARET] = ACTIONS(5737),
    [anon_sym_PLUS] = ACTIONS(5737),
    [anon_sym_SLASH] = ACTIONS(5737),
    [anon_sym_PERCENT] = ACTIONS(5737),
    [sym_comment] = ACTIONS(87),
  },
  [3734] = {
    [sym__line_break] = ACTIONS(3235),
    [sym__heredoc_body_start] = ACTIONS(3235),
    [sym__binary_minus] = ACTIONS(3235),
    [sym__binary_star] = ACTIONS(3235),
    [ts_builtin_sym_end] = ACTIONS(3235),
    [anon_sym___END__] = ACTIONS(3235),
    [anon_sym_LBRACE] = ACTIONS(3235),
    [anon_sym_RBRACE] = ACTIONS(3235),
    [anon_sym_RPAREN] = ACTIONS(3235),
    [anon_sym_DOT] = ACTIONS(4997),
    [anon_sym_COMMA] = ACTIONS(3235),
    [anon_sym_PIPE] = ACTIONS(4997),
    [anon_sym_SEMI] = ACTIONS(3235),
    [anon_sym_STAR_STAR] = ACTIONS(4997),
    [anon_sym_AMP] = ACTIONS(4997),
    [anon_sym_EQ] = ACTIONS(4997),
    [anon_sym_LT] = ACTIONS(4997),
    [anon_sym_end] = ACTIONS(3235),
    [anon_sym_if] = ACTIONS(3235),
    [anon_sym_unless] = ACTIONS(3235),
    [anon_sym_while] = ACTIONS(3235),
    [anon_sym_until] = ACTIONS(3235),
    [anon_sym_rescue] = ACTIONS(3235),
    [anon_sym_do] = ACTIONS(3235),
    [anon_sym_when] = ACTIONS(3235),
    [anon_sym_elsif] = ACTIONS(3235),
    [anon_sym_else] = ACTIONS(3235),
    [anon_sym_then] = ACTIONS(3235),
    [anon_sym_ensure] = ACTIONS(3235),
    [anon_sym_LBRACK] = ACTIONS(3235),
    [anon_sym_COLON_COLON2] = ACTIONS(3235),
    [anon_sym_AMP_DOT] = ACTIONS(3235),
    [anon_sym_PLUS_EQ] = ACTIONS(3235),
    [anon_sym_DASH_EQ] = ACTIONS(3235),
    [anon_sym_STAR_EQ] = ACTIONS(3235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3235),
    [anon_sym_SLASH_EQ] = ACTIONS(3235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3235),
    [anon_sym_PIPE_EQ] = ACTIONS(3235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3235),
    [anon_sym_AMP_EQ] = ACTIONS(3235),
    [anon_sym_PERCENT_EQ] = ACTIONS(3235),
    [anon_sym_GT_GT_EQ] = ACTIONS(3235),
    [anon_sym_LT_LT_EQ] = ACTIONS(3235),
    [anon_sym_CARET_EQ] = ACTIONS(3235),
    [anon_sym_QMARK] = ACTIONS(3235),
    [anon_sym_DOT_DOT] = ACTIONS(4997),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3235),
    [anon_sym_and] = ACTIONS(3235),
    [anon_sym_or] = ACTIONS(3235),
    [anon_sym_PIPE_PIPE] = ACTIONS(4997),
    [anon_sym_AMP_AMP] = ACTIONS(4997),
    [anon_sym_LT_LT] = ACTIONS(4997),
    [anon_sym_GT_GT] = ACTIONS(4997),
    [anon_sym_EQ_EQ] = ACTIONS(4997),
    [anon_sym_BANG_EQ] = ACTIONS(3235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3235),
    [anon_sym_LT_EQ_GT] = ACTIONS(3235),
    [anon_sym_EQ_TILDE] = ACTIONS(3235),
    [anon_sym_BANG_TILDE] = ACTIONS(3235),
    [anon_sym_LT_EQ] = ACTIONS(4997),
    [anon_sym_GT] = ACTIONS(4997),
    [anon_sym_GT_EQ] = ACTIONS(3235),
    [anon_sym_CARET] = ACTIONS(4997),
    [anon_sym_PLUS] = ACTIONS(4997),
    [anon_sym_SLASH] = ACTIONS(4997),
    [anon_sym_PERCENT] = ACTIONS(4997),
    [sym_comment] = ACTIONS(87),
  },
  [3735] = {
    [sym_interpolation] = STATE(1787),
    [aux_sym_heredoc_body_repeat1] = STATE(1787),
    [sym__heredoc_content] = ACTIONS(3237),
    [sym_heredoc_end] = ACTIONS(9844),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(3237),
  },
  [3736] = {
    [sym_heredoc_body] = STATE(3736),
    [aux_sym_call_repeat1] = STATE(3736),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(9846),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [ts_builtin_sym_end] = ACTIONS(7914),
    [anon_sym___END__] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7919),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_EQ] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_PLUS_EQ] = ACTIONS(7914),
    [anon_sym_DASH_EQ] = ACTIONS(7914),
    [anon_sym_STAR_EQ] = ACTIONS(7914),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7914),
    [anon_sym_SLASH_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7914),
    [anon_sym_AMP_EQ] = ACTIONS(7914),
    [anon_sym_PERCENT_EQ] = ACTIONS(7914),
    [anon_sym_GT_GT_EQ] = ACTIONS(7914),
    [anon_sym_LT_LT_EQ] = ACTIONS(7914),
    [anon_sym_CARET_EQ] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7919),
    [anon_sym_AMP_AMP] = ACTIONS(7919),
    [anon_sym_LT_LT] = ACTIONS(7919),
    [anon_sym_GT_GT] = ACTIONS(7919),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7919),
    [anon_sym_PLUS] = ACTIONS(7919),
    [anon_sym_SLASH] = ACTIONS(7919),
    [anon_sym_PERCENT] = ACTIONS(7919),
    [sym_comment] = ACTIONS(87),
  },
  [3737] = {
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [ts_builtin_sym_end] = ACTIONS(7925),
    [anon_sym___END__] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_RBRACE] = ACTIONS(7925),
    [anon_sym_RPAREN] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(7925),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7927),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_EQ] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_end] = ACTIONS(7925),
    [anon_sym_if] = ACTIONS(7925),
    [anon_sym_unless] = ACTIONS(7925),
    [anon_sym_while] = ACTIONS(7925),
    [anon_sym_until] = ACTIONS(7925),
    [anon_sym_rescue] = ACTIONS(7925),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_when] = ACTIONS(7925),
    [anon_sym_elsif] = ACTIONS(7925),
    [anon_sym_else] = ACTIONS(7925),
    [anon_sym_then] = ACTIONS(7925),
    [anon_sym_ensure] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_PLUS_EQ] = ACTIONS(7925),
    [anon_sym_DASH_EQ] = ACTIONS(7925),
    [anon_sym_STAR_EQ] = ACTIONS(7925),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7925),
    [anon_sym_SLASH_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7925),
    [anon_sym_AMP_EQ] = ACTIONS(7925),
    [anon_sym_PERCENT_EQ] = ACTIONS(7925),
    [anon_sym_GT_GT_EQ] = ACTIONS(7925),
    [anon_sym_LT_LT_EQ] = ACTIONS(7925),
    [anon_sym_CARET_EQ] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7927),
    [anon_sym_AMP_AMP] = ACTIONS(7927),
    [anon_sym_LT_LT] = ACTIONS(7927),
    [anon_sym_GT_GT] = ACTIONS(7927),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7927),
    [anon_sym_PLUS] = ACTIONS(7927),
    [anon_sym_SLASH] = ACTIONS(7927),
    [anon_sym_PERCENT] = ACTIONS(7927),
    [sym_comment] = ACTIONS(87),
  },
  [3738] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(420),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(428),
    [sym_scope_resolution] = STATE(422),
    [sym_call] = STATE(422),
    [sym_method_call] = STATE(428),
    [sym__argument] = STATE(6393),
    [sym_splat_argument] = STATE(6393),
    [sym_hash_splat_argument] = STATE(6393),
    [sym_block_argument] = STATE(6393),
    [sym_assignment] = STATE(420),
    [sym_operator_assignment] = STATE(420),
    [sym_conditional] = STATE(420),
    [sym_range] = STATE(420),
    [sym_binary] = STATE(420),
    [sym_unary] = STATE(420),
    [sym_left_assignment_list] = STATE(427),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(428),
    [sym__variable] = STATE(422),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(428),
    [sym_false] = STATE(428),
    [sym_nil] = STATE(428),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(429),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(6393),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(761),
    [sym__splat_star] = ACTIONS(763),
    [sym__unary_minus] = ACTIONS(765),
    [sym__identifier_hash_key] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(6163),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(781),
    [anon_sym_yield] = ACTIONS(783),
    [anon_sym_break] = ACTIONS(785),
    [anon_sym_next] = ACTIONS(787),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(2623),
    [anon_sym_defined_QMARK] = ACTIONS(801),
    [anon_sym_not] = ACTIONS(803),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_TILDE] = ACTIONS(807),
    [sym_constant] = ACTIONS(809),
    [sym_identifier] = ACTIONS(809),
    [sym_instance_variable] = ACTIONS(811),
    [sym_class_variable] = ACTIONS(811),
    [sym_global_variable] = ACTIONS(811),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(815),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(815),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3739] = {
    [sym_heredoc_body] = STATE(3736),
    [aux_sym_call_repeat1] = STATE(3736),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [ts_builtin_sym_end] = ACTIONS(7929),
    [anon_sym___END__] = ACTIONS(7929),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7931),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_EQ] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_PLUS_EQ] = ACTIONS(7929),
    [anon_sym_DASH_EQ] = ACTIONS(7929),
    [anon_sym_STAR_EQ] = ACTIONS(7929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7929),
    [anon_sym_SLASH_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7929),
    [anon_sym_AMP_EQ] = ACTIONS(7929),
    [anon_sym_PERCENT_EQ] = ACTIONS(7929),
    [anon_sym_GT_GT_EQ] = ACTIONS(7929),
    [anon_sym_LT_LT_EQ] = ACTIONS(7929),
    [anon_sym_CARET_EQ] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7931),
    [anon_sym_AMP_AMP] = ACTIONS(7931),
    [anon_sym_LT_LT] = ACTIONS(7931),
    [anon_sym_GT_GT] = ACTIONS(7931),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7931),
    [anon_sym_PLUS] = ACTIONS(7931),
    [anon_sym_SLASH] = ACTIONS(7931),
    [anon_sym_PERCENT] = ACTIONS(7931),
    [sym_comment] = ACTIONS(87),
  },
  [3740] = {
    [aux_sym_argument_list_repeat1] = STATE(3740),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [ts_builtin_sym_end] = ACTIONS(7925),
    [anon_sym___END__] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(9849),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7927),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_EQ] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_if] = ACTIONS(7925),
    [anon_sym_unless] = ACTIONS(7925),
    [anon_sym_while] = ACTIONS(7925),
    [anon_sym_until] = ACTIONS(7925),
    [anon_sym_rescue] = ACTIONS(7925),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_PLUS_EQ] = ACTIONS(7925),
    [anon_sym_DASH_EQ] = ACTIONS(7925),
    [anon_sym_STAR_EQ] = ACTIONS(7925),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7925),
    [anon_sym_SLASH_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7925),
    [anon_sym_AMP_EQ] = ACTIONS(7925),
    [anon_sym_PERCENT_EQ] = ACTIONS(7925),
    [anon_sym_GT_GT_EQ] = ACTIONS(7925),
    [anon_sym_LT_LT_EQ] = ACTIONS(7925),
    [anon_sym_CARET_EQ] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7927),
    [anon_sym_AMP_AMP] = ACTIONS(7927),
    [anon_sym_LT_LT] = ACTIONS(7927),
    [anon_sym_GT_GT] = ACTIONS(7927),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7927),
    [anon_sym_PLUS] = ACTIONS(7927),
    [anon_sym_SLASH] = ACTIONS(7927),
    [anon_sym_PERCENT] = ACTIONS(7927),
    [sym_comment] = ACTIONS(87),
  },
  [3741] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(2687),
    [sym__binary_star] = ACTIONS(2689),
    [ts_builtin_sym_end] = ACTIONS(5115),
    [anon_sym___END__] = ACTIONS(5115),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(2691),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(2693),
    [anon_sym_AMP] = ACTIONS(2695),
    [anon_sym_EQ] = ACTIONS(7936),
    [anon_sym_LT] = ACTIONS(2697),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_EQ_GT] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_PLUS_EQ] = ACTIONS(5115),
    [anon_sym_DASH_EQ] = ACTIONS(5115),
    [anon_sym_STAR_EQ] = ACTIONS(5115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5115),
    [anon_sym_SLASH_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5115),
    [anon_sym_AMP_EQ] = ACTIONS(5115),
    [anon_sym_PERCENT_EQ] = ACTIONS(5115),
    [anon_sym_GT_GT_EQ] = ACTIONS(5115),
    [anon_sym_LT_LT_EQ] = ACTIONS(5115),
    [anon_sym_CARET_EQ] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(2699),
    [anon_sym_DOT_DOT] = ACTIONS(2701),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2703),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(2705),
    [anon_sym_AMP_AMP] = ACTIONS(2705),
    [anon_sym_LT_LT] = ACTIONS(2707),
    [anon_sym_GT_GT] = ACTIONS(2707),
    [anon_sym_EQ_EQ] = ACTIONS(2705),
    [anon_sym_BANG_EQ] = ACTIONS(2709),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2709),
    [anon_sym_LT_EQ_GT] = ACTIONS(2709),
    [anon_sym_EQ_TILDE] = ACTIONS(2709),
    [anon_sym_BANG_TILDE] = ACTIONS(2709),
    [anon_sym_LT_EQ] = ACTIONS(2697),
    [anon_sym_GT] = ACTIONS(2697),
    [anon_sym_GT_EQ] = ACTIONS(2711),
    [anon_sym_CARET] = ACTIONS(2691),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_SLASH] = ACTIONS(2693),
    [anon_sym_PERCENT] = ACTIONS(2693),
    [sym_comment] = ACTIONS(87),
  },
  [3742] = {
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [ts_builtin_sym_end] = ACTIONS(6191),
    [anon_sym___END__] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_RBRACE] = ACTIONS(6191),
    [anon_sym_RPAREN] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6193),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_end] = ACTIONS(6191),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_when] = ACTIONS(6191),
    [anon_sym_elsif] = ACTIONS(6191),
    [anon_sym_else] = ACTIONS(6191),
    [anon_sym_then] = ACTIONS(6191),
    [anon_sym_ensure] = ACTIONS(6191),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_PLUS_EQ] = ACTIONS(6191),
    [anon_sym_DASH_EQ] = ACTIONS(6191),
    [anon_sym_STAR_EQ] = ACTIONS(6191),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6191),
    [anon_sym_SLASH_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6191),
    [anon_sym_AMP_EQ] = ACTIONS(6191),
    [anon_sym_PERCENT_EQ] = ACTIONS(6191),
    [anon_sym_GT_GT_EQ] = ACTIONS(6191),
    [anon_sym_LT_LT_EQ] = ACTIONS(6191),
    [anon_sym_CARET_EQ] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6193),
    [anon_sym_AMP_AMP] = ACTIONS(6193),
    [anon_sym_LT_LT] = ACTIONS(6193),
    [anon_sym_GT_GT] = ACTIONS(6193),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6193),
    [anon_sym_PLUS] = ACTIONS(6193),
    [anon_sym_SLASH] = ACTIONS(6193),
    [anon_sym_PERCENT] = ACTIONS(6193),
    [sym_comment] = ACTIONS(87),
  },
  [3743] = {
    [aux_sym_exceptions_repeat1] = STATE(6395),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [ts_builtin_sym_end] = ACTIONS(6191),
    [anon_sym___END__] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6193),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_PLUS_EQ] = ACTIONS(6191),
    [anon_sym_DASH_EQ] = ACTIONS(6191),
    [anon_sym_STAR_EQ] = ACTIONS(6191),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6191),
    [anon_sym_SLASH_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6191),
    [anon_sym_AMP_EQ] = ACTIONS(6191),
    [anon_sym_PERCENT_EQ] = ACTIONS(6191),
    [anon_sym_GT_GT_EQ] = ACTIONS(6191),
    [anon_sym_LT_LT_EQ] = ACTIONS(6191),
    [anon_sym_CARET_EQ] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6193),
    [anon_sym_AMP_AMP] = ACTIONS(6193),
    [anon_sym_LT_LT] = ACTIONS(6193),
    [anon_sym_GT_GT] = ACTIONS(6193),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6193),
    [anon_sym_PLUS] = ACTIONS(6193),
    [anon_sym_SLASH] = ACTIONS(6193),
    [anon_sym_PERCENT] = ACTIONS(6193),
    [sym_comment] = ACTIONS(87),
  },
  [3744] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(2687),
    [sym__binary_star] = ACTIONS(2689),
    [ts_builtin_sym_end] = ACTIONS(6210),
    [anon_sym___END__] = ACTIONS(6210),
    [anon_sym_LBRACE] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(2691),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(2693),
    [anon_sym_AMP] = ACTIONS(2695),
    [anon_sym_EQ] = ACTIONS(7938),
    [anon_sym_LT] = ACTIONS(2697),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_EQ_GT] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_PLUS_EQ] = ACTIONS(6210),
    [anon_sym_DASH_EQ] = ACTIONS(6210),
    [anon_sym_STAR_EQ] = ACTIONS(6210),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6210),
    [anon_sym_SLASH_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6210),
    [anon_sym_AMP_EQ] = ACTIONS(6210),
    [anon_sym_PERCENT_EQ] = ACTIONS(6210),
    [anon_sym_GT_GT_EQ] = ACTIONS(6210),
    [anon_sym_LT_LT_EQ] = ACTIONS(6210),
    [anon_sym_CARET_EQ] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(2699),
    [anon_sym_DOT_DOT] = ACTIONS(2701),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2703),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(2705),
    [anon_sym_AMP_AMP] = ACTIONS(2705),
    [anon_sym_LT_LT] = ACTIONS(2707),
    [anon_sym_GT_GT] = ACTIONS(2707),
    [anon_sym_EQ_EQ] = ACTIONS(2705),
    [anon_sym_BANG_EQ] = ACTIONS(2709),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2709),
    [anon_sym_LT_EQ_GT] = ACTIONS(2709),
    [anon_sym_EQ_TILDE] = ACTIONS(2709),
    [anon_sym_BANG_TILDE] = ACTIONS(2709),
    [anon_sym_LT_EQ] = ACTIONS(2697),
    [anon_sym_GT] = ACTIONS(2697),
    [anon_sym_GT_EQ] = ACTIONS(2711),
    [anon_sym_CARET] = ACTIONS(2691),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_SLASH] = ACTIONS(2693),
    [anon_sym_PERCENT] = ACTIONS(2693),
    [sym_comment] = ACTIONS(87),
  },
  [3745] = {
    [sym_string] = STATE(3745),
    [aux_sym_chained_string_repeat1] = STATE(3745),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(9852),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [ts_builtin_sym_end] = ACTIONS(6212),
    [anon_sym___END__] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6217),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_EQ] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_do] = ACTIONS(6212),
    [anon_sym_EQ_GT] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_PLUS_EQ] = ACTIONS(6212),
    [anon_sym_DASH_EQ] = ACTIONS(6212),
    [anon_sym_STAR_EQ] = ACTIONS(6212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6212),
    [anon_sym_SLASH_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6212),
    [anon_sym_AMP_EQ] = ACTIONS(6212),
    [anon_sym_PERCENT_EQ] = ACTIONS(6212),
    [anon_sym_GT_GT_EQ] = ACTIONS(6212),
    [anon_sym_LT_LT_EQ] = ACTIONS(6212),
    [anon_sym_CARET_EQ] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6217),
    [anon_sym_AMP_AMP] = ACTIONS(6217),
    [anon_sym_LT_LT] = ACTIONS(6217),
    [anon_sym_GT_GT] = ACTIONS(6217),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6217),
    [anon_sym_PLUS] = ACTIONS(6217),
    [anon_sym_SLASH] = ACTIONS(6217),
    [anon_sym_PERCENT] = ACTIONS(6217),
    [sym_comment] = ACTIONS(87),
  },
  [3746] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(6165),
    [sym__binary_star] = ACTIONS(6167),
    [ts_builtin_sym_end] = ACTIONS(4247),
    [anon_sym___END__] = ACTIONS(4247),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(6169),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(6167),
    [anon_sym_AMP] = ACTIONS(6171),
    [anon_sym_LT] = ACTIONS(6173),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(6175),
    [anon_sym_DOT_DOT] = ACTIONS(6177),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6179),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(6181),
    [anon_sym_AMP_AMP] = ACTIONS(6181),
    [anon_sym_LT_LT] = ACTIONS(6183),
    [anon_sym_GT_GT] = ACTIONS(6183),
    [anon_sym_EQ_EQ] = ACTIONS(6185),
    [anon_sym_BANG_EQ] = ACTIONS(6181),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6181),
    [anon_sym_LT_EQ_GT] = ACTIONS(6181),
    [anon_sym_EQ_TILDE] = ACTIONS(6181),
    [anon_sym_BANG_TILDE] = ACTIONS(6181),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6173),
    [anon_sym_GT_EQ] = ACTIONS(6187),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_PLUS] = ACTIONS(6165),
    [anon_sym_SLASH] = ACTIONS(6167),
    [anon_sym_PERCENT] = ACTIONS(6167),
    [sym_comment] = ACTIONS(87),
  },
  [3747] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [ts_builtin_sym_end] = ACTIONS(935),
    [anon_sym___END__] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(6167),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [3748] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(6165),
    [sym__binary_star] = ACTIONS(6167),
    [ts_builtin_sym_end] = ACTIONS(935),
    [anon_sym___END__] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(6169),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(6167),
    [anon_sym_AMP] = ACTIONS(6171),
    [anon_sym_LT] = ACTIONS(6173),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(6175),
    [anon_sym_DOT_DOT] = ACTIONS(6177),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6179),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(6181),
    [anon_sym_AMP_AMP] = ACTIONS(6181),
    [anon_sym_LT_LT] = ACTIONS(6183),
    [anon_sym_GT_GT] = ACTIONS(6183),
    [anon_sym_EQ_EQ] = ACTIONS(6185),
    [anon_sym_BANG_EQ] = ACTIONS(6181),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6181),
    [anon_sym_LT_EQ_GT] = ACTIONS(6181),
    [anon_sym_EQ_TILDE] = ACTIONS(6181),
    [anon_sym_BANG_TILDE] = ACTIONS(6181),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6173),
    [anon_sym_GT_EQ] = ACTIONS(6187),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_PLUS] = ACTIONS(6165),
    [anon_sym_SLASH] = ACTIONS(6167),
    [anon_sym_PERCENT] = ACTIONS(6167),
    [sym_comment] = ACTIONS(87),
  },
  [3749] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(6396),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1596),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(1596),
    [sym_assignment] = STATE(6396),
    [sym_operator_assignment] = STATE(6396),
    [sym_conditional] = STATE(6396),
    [sym_range] = STATE(6396),
    [sym_binary] = STATE(6396),
    [sym_unary] = STATE(6396),
    [sym_left_assignment_list] = STATE(1595),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1596),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1596),
    [sym_false] = STATE(1596),
    [sym_nil] = STATE(1596),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(877),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2739),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1557),
    [anon_sym_yield] = ACTIONS(1559),
    [anon_sym_break] = ACTIONS(1561),
    [anon_sym_next] = ACTIONS(1563),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2741),
    [anon_sym_defined_QMARK] = ACTIONS(2743),
    [anon_sym_not] = ACTIONS(2745),
    [anon_sym_BANG] = ACTIONS(2747),
    [anon_sym_TILDE] = ACTIONS(2747),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3750] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(6397),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1596),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(1596),
    [sym_assignment] = STATE(6397),
    [sym_operator_assignment] = STATE(6397),
    [sym_conditional] = STATE(6397),
    [sym_range] = STATE(6397),
    [sym_binary] = STATE(6397),
    [sym_unary] = STATE(6397),
    [sym_left_assignment_list] = STATE(1595),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1596),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1596),
    [sym_false] = STATE(1596),
    [sym_nil] = STATE(1596),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(877),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2739),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1557),
    [anon_sym_yield] = ACTIONS(1559),
    [anon_sym_break] = ACTIONS(1561),
    [anon_sym_next] = ACTIONS(1563),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2741),
    [anon_sym_defined_QMARK] = ACTIONS(2743),
    [anon_sym_not] = ACTIONS(2745),
    [anon_sym_BANG] = ACTIONS(2747),
    [anon_sym_TILDE] = ACTIONS(2747),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3751] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(6398),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1596),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(1596),
    [sym_assignment] = STATE(6398),
    [sym_operator_assignment] = STATE(6398),
    [sym_conditional] = STATE(6398),
    [sym_range] = STATE(6398),
    [sym_binary] = STATE(6398),
    [sym_unary] = STATE(6398),
    [sym_left_assignment_list] = STATE(1595),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1596),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1596),
    [sym_false] = STATE(1596),
    [sym_nil] = STATE(1596),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(877),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2739),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1557),
    [anon_sym_yield] = ACTIONS(1559),
    [anon_sym_break] = ACTIONS(1561),
    [anon_sym_next] = ACTIONS(1563),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2741),
    [anon_sym_defined_QMARK] = ACTIONS(2743),
    [anon_sym_not] = ACTIONS(2745),
    [anon_sym_BANG] = ACTIONS(2747),
    [anon_sym_TILDE] = ACTIONS(2747),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3752] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(6399),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1596),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(1596),
    [sym_assignment] = STATE(6399),
    [sym_operator_assignment] = STATE(6399),
    [sym_conditional] = STATE(6399),
    [sym_range] = STATE(6399),
    [sym_binary] = STATE(6399),
    [sym_unary] = STATE(6399),
    [sym_left_assignment_list] = STATE(1595),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1596),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1596),
    [sym_false] = STATE(1596),
    [sym_nil] = STATE(1596),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(877),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2739),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1557),
    [anon_sym_yield] = ACTIONS(1559),
    [anon_sym_break] = ACTIONS(1561),
    [anon_sym_next] = ACTIONS(1563),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2741),
    [anon_sym_defined_QMARK] = ACTIONS(2743),
    [anon_sym_not] = ACTIONS(2745),
    [anon_sym_BANG] = ACTIONS(2747),
    [anon_sym_TILDE] = ACTIONS(2747),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3753] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(6400),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1596),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(1596),
    [sym_assignment] = STATE(6400),
    [sym_operator_assignment] = STATE(6400),
    [sym_conditional] = STATE(6400),
    [sym_range] = STATE(6400),
    [sym_binary] = STATE(6400),
    [sym_unary] = STATE(6400),
    [sym_left_assignment_list] = STATE(1595),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1596),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1596),
    [sym_false] = STATE(1596),
    [sym_nil] = STATE(1596),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(877),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2739),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1557),
    [anon_sym_yield] = ACTIONS(1559),
    [anon_sym_break] = ACTIONS(1561),
    [anon_sym_next] = ACTIONS(1563),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2741),
    [anon_sym_defined_QMARK] = ACTIONS(2743),
    [anon_sym_not] = ACTIONS(2745),
    [anon_sym_BANG] = ACTIONS(2747),
    [anon_sym_TILDE] = ACTIONS(2747),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3754] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(6401),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(6401),
    [sym_operator_assignment] = STATE(6401),
    [sym_conditional] = STATE(6401),
    [sym_range] = STATE(6401),
    [sym_binary] = STATE(6401),
    [sym_unary] = STATE(6401),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3755] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(6402),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1596),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(1596),
    [sym_assignment] = STATE(6402),
    [sym_operator_assignment] = STATE(6402),
    [sym_conditional] = STATE(6402),
    [sym_range] = STATE(6402),
    [sym_binary] = STATE(6402),
    [sym_unary] = STATE(6402),
    [sym_left_assignment_list] = STATE(1595),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1596),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1596),
    [sym_false] = STATE(1596),
    [sym_nil] = STATE(1596),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(877),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2739),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1557),
    [anon_sym_yield] = ACTIONS(1559),
    [anon_sym_break] = ACTIONS(1561),
    [anon_sym_next] = ACTIONS(1563),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2741),
    [anon_sym_defined_QMARK] = ACTIONS(2743),
    [anon_sym_not] = ACTIONS(2745),
    [anon_sym_BANG] = ACTIONS(2747),
    [anon_sym_TILDE] = ACTIONS(2747),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3756] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(6403),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1596),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(1596),
    [sym_assignment] = STATE(6403),
    [sym_operator_assignment] = STATE(6403),
    [sym_conditional] = STATE(6403),
    [sym_range] = STATE(6403),
    [sym_binary] = STATE(6403),
    [sym_unary] = STATE(6403),
    [sym_left_assignment_list] = STATE(1595),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1596),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1596),
    [sym_false] = STATE(1596),
    [sym_nil] = STATE(1596),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(877),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2739),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1557),
    [anon_sym_yield] = ACTIONS(1559),
    [anon_sym_break] = ACTIONS(1561),
    [anon_sym_next] = ACTIONS(1563),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2741),
    [anon_sym_defined_QMARK] = ACTIONS(2743),
    [anon_sym_not] = ACTIONS(2745),
    [anon_sym_BANG] = ACTIONS(2747),
    [anon_sym_TILDE] = ACTIONS(2747),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3757] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(6404),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1596),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(1596),
    [sym_assignment] = STATE(6404),
    [sym_operator_assignment] = STATE(6404),
    [sym_conditional] = STATE(6404),
    [sym_range] = STATE(6404),
    [sym_binary] = STATE(6404),
    [sym_unary] = STATE(6404),
    [sym_left_assignment_list] = STATE(1595),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1596),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1596),
    [sym_false] = STATE(1596),
    [sym_nil] = STATE(1596),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(877),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2739),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1557),
    [anon_sym_yield] = ACTIONS(1559),
    [anon_sym_break] = ACTIONS(1561),
    [anon_sym_next] = ACTIONS(1563),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2741),
    [anon_sym_defined_QMARK] = ACTIONS(2743),
    [anon_sym_not] = ACTIONS(2745),
    [anon_sym_BANG] = ACTIONS(2747),
    [anon_sym_TILDE] = ACTIONS(2747),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3758] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(6405),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1596),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(1596),
    [sym_assignment] = STATE(6405),
    [sym_operator_assignment] = STATE(6405),
    [sym_conditional] = STATE(6405),
    [sym_range] = STATE(6405),
    [sym_binary] = STATE(6405),
    [sym_unary] = STATE(6405),
    [sym_left_assignment_list] = STATE(1595),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1596),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1596),
    [sym_false] = STATE(1596),
    [sym_nil] = STATE(1596),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(877),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2739),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1557),
    [anon_sym_yield] = ACTIONS(1559),
    [anon_sym_break] = ACTIONS(1561),
    [anon_sym_next] = ACTIONS(1563),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2741),
    [anon_sym_defined_QMARK] = ACTIONS(2743),
    [anon_sym_not] = ACTIONS(2745),
    [anon_sym_BANG] = ACTIONS(2747),
    [anon_sym_TILDE] = ACTIONS(2747),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3759] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1592),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1596),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(1596),
    [sym_splat_argument] = STATE(6406),
    [sym_assignment] = STATE(1592),
    [sym_operator_assignment] = STATE(1592),
    [sym_conditional] = STATE(1592),
    [sym_range] = STATE(1592),
    [sym_binary] = STATE(1592),
    [sym_unary] = STATE(1592),
    [sym__arg_or_splat_arg] = STATE(6406),
    [sym_left_assignment_list] = STATE(1595),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1596),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1596),
    [sym_false] = STATE(1596),
    [sym_nil] = STATE(1596),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(877),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(2737),
    [sym__unary_minus] = ACTIONS(2739),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1557),
    [anon_sym_yield] = ACTIONS(1559),
    [anon_sym_break] = ACTIONS(1561),
    [anon_sym_next] = ACTIONS(1563),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2741),
    [anon_sym_defined_QMARK] = ACTIONS(2743),
    [anon_sym_not] = ACTIONS(2745),
    [anon_sym_BANG] = ACTIONS(2747),
    [anon_sym_TILDE] = ACTIONS(2747),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3760] = {
    [aux_sym_exceptions_repeat1] = STATE(6407),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [ts_builtin_sym_end] = ACTIONS(9855),
    [anon_sym___END__] = ACTIONS(9855),
    [anon_sym_COMMA] = ACTIONS(6195),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [3761] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1592),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1596),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(1596),
    [sym_splat_argument] = STATE(6408),
    [sym_assignment] = STATE(1592),
    [sym_operator_assignment] = STATE(1592),
    [sym_conditional] = STATE(1592),
    [sym_range] = STATE(1592),
    [sym_binary] = STATE(1592),
    [sym_unary] = STATE(1592),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(6408),
    [sym_left_assignment_list] = STATE(1595),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1596),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1596),
    [sym_false] = STATE(1596),
    [sym_nil] = STATE(1596),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(877),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(2737),
    [sym__unary_minus] = ACTIONS(2739),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1557),
    [anon_sym_yield] = ACTIONS(1559),
    [anon_sym_break] = ACTIONS(1561),
    [anon_sym_next] = ACTIONS(1563),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2741),
    [anon_sym_defined_QMARK] = ACTIONS(2743),
    [anon_sym_not] = ACTIONS(2745),
    [anon_sym_BANG] = ACTIONS(2747),
    [anon_sym_TILDE] = ACTIONS(2747),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3762] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(6409),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1596),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(1596),
    [sym_assignment] = STATE(6409),
    [sym_operator_assignment] = STATE(6409),
    [sym_conditional] = STATE(6409),
    [sym_range] = STATE(6409),
    [sym_binary] = STATE(6409),
    [sym_unary] = STATE(6409),
    [sym_left_assignment_list] = STATE(1595),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1596),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1596),
    [sym_false] = STATE(1596),
    [sym_nil] = STATE(1596),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(877),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2739),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1557),
    [anon_sym_yield] = ACTIONS(1559),
    [anon_sym_break] = ACTIONS(1561),
    [anon_sym_next] = ACTIONS(1563),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2741),
    [anon_sym_defined_QMARK] = ACTIONS(2743),
    [anon_sym_not] = ACTIONS(2745),
    [anon_sym_BANG] = ACTIONS(2747),
    [anon_sym_TILDE] = ACTIONS(2747),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3763] = {
    [sym_method] = STATE(184),
    [sym_singleton_method] = STATE(184),
    [sym_class] = STATE(184),
    [sym_singleton_class] = STATE(184),
    [sym_module] = STATE(184),
    [sym_return] = STATE(184),
    [sym_yield] = STATE(184),
    [sym_break] = STATE(184),
    [sym_next] = STATE(184),
    [sym_while] = STATE(184),
    [sym_until] = STATE(184),
    [sym_for] = STATE(184),
    [sym_case] = STATE(184),
    [sym_if] = STATE(184),
    [sym_unless] = STATE(184),
    [sym_begin] = STATE(184),
    [sym__primary] = STATE(184),
    [sym_parenthesized_statements] = STATE(184),
    [sym_element_reference] = STATE(1598),
    [sym_scope_resolution] = STATE(185),
    [sym_call] = STATE(185),
    [sym_method_call] = STATE(1598),
    [sym_destructured_left_assignment] = STATE(1597),
    [sym_rest_assignment] = STATE(1597),
    [sym__lhs] = STATE(1598),
    [sym__variable] = STATE(185),
    [sym_rational] = STATE(184),
    [sym_true] = STATE(1598),
    [sym_false] = STATE(1598),
    [sym_nil] = STATE(1598),
    [sym_chained_string] = STATE(184),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(184),
    [sym_string_array] = STATE(184),
    [sym_symbol_array] = STATE(184),
    [sym_symbol] = STATE(184),
    [sym_regex] = STATE(184),
    [sym_array] = STATE(184),
    [sym_hash] = STATE(184),
    [sym_lambda] = STATE(184),
    [sym__simple_symbol] = ACTIONS(279),
    [sym__string_start] = ACTIONS(281),
    [sym__symbol_start] = ACTIONS(283),
    [sym__subshell_start] = ACTIONS(285),
    [sym__regex_start] = ACTIONS(287),
    [sym__string_array_start] = ACTIONS(289),
    [sym__symbol_array_start] = ACTIONS(291),
    [sym_heredoc_beginning] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_def] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(475),
    [anon_sym_COLON_COLON] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(307),
    [anon_sym_return] = ACTIONS(309),
    [anon_sym_yield] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_next] = ACTIONS(315),
    [sym_redo] = ACTIONS(317),
    [sym_retry] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(319),
    [anon_sym_unless] = ACTIONS(321),
    [anon_sym_while] = ACTIONS(323),
    [anon_sym_until] = ACTIONS(325),
    [anon_sym_for] = ACTIONS(327),
    [anon_sym_case] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(331),
    [sym_constant] = ACTIONS(333),
    [sym_identifier] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(317),
    [sym_complex] = ACTIONS(293),
    [sym_super] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(339),
    [anon_sym_TRUE] = ACTIONS(339),
    [anon_sym_false] = ACTIONS(341),
    [anon_sym_FALSE] = ACTIONS(341),
    [sym_self] = ACTIONS(333),
    [anon_sym_nil] = ACTIONS(343),
    [anon_sym_NIL] = ACTIONS(343),
    [sym_character] = ACTIONS(293),
    [anon_sym_LBRACK2] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(347),
  },
  [3764] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(6285),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [3765] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(6417),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(6419),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(6419),
    [sym_assignment] = STATE(6417),
    [sym_operator_assignment] = STATE(6417),
    [sym_conditional] = STATE(6417),
    [sym_range] = STATE(6417),
    [sym_binary] = STATE(6417),
    [sym_unary] = STATE(6417),
    [sym_left_assignment_list] = STATE(6418),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6419),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(6419),
    [sym_false] = STATE(6419),
    [sym_nil] = STATE(6419),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(6420),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9859),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9861),
    [anon_sym_yield] = ACTIONS(9863),
    [anon_sym_break] = ACTIONS(9865),
    [anon_sym_next] = ACTIONS(9867),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9869),
    [anon_sym_defined_QMARK] = ACTIONS(9871),
    [anon_sym_not] = ACTIONS(9873),
    [anon_sym_BANG] = ACTIONS(9875),
    [anon_sym_TILDE] = ACTIONS(9875),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3766] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(6421),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(6419),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(6419),
    [sym_assignment] = STATE(6421),
    [sym_operator_assignment] = STATE(6421),
    [sym_conditional] = STATE(6421),
    [sym_range] = STATE(6421),
    [sym_binary] = STATE(6421),
    [sym_unary] = STATE(6421),
    [sym_left_assignment_list] = STATE(6418),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6419),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(6419),
    [sym_false] = STATE(6419),
    [sym_nil] = STATE(6419),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(6420),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9859),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9861),
    [anon_sym_yield] = ACTIONS(9863),
    [anon_sym_break] = ACTIONS(9865),
    [anon_sym_next] = ACTIONS(9867),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9869),
    [anon_sym_defined_QMARK] = ACTIONS(9871),
    [anon_sym_not] = ACTIONS(9873),
    [anon_sym_BANG] = ACTIONS(9875),
    [anon_sym_TILDE] = ACTIONS(9875),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3767] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6422),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3782),
    [sym_scope_resolution] = STATE(3778),
    [sym_call] = STATE(3778),
    [sym_method_call] = STATE(3782),
    [sym_assignment] = STATE(6422),
    [sym_operator_assignment] = STATE(6422),
    [sym_conditional] = STATE(6422),
    [sym_range] = STATE(6422),
    [sym_binary] = STATE(6422),
    [sym_unary] = STATE(6422),
    [sym_left_assignment_list] = STATE(3781),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3782),
    [sym__variable] = STATE(3778),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3782),
    [sym_false] = STATE(3782),
    [sym_nil] = STATE(3782),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(6423),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(6245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6249),
    [anon_sym_yield] = ACTIONS(6251),
    [anon_sym_break] = ACTIONS(6253),
    [anon_sym_next] = ACTIONS(6255),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9877),
    [anon_sym_defined_QMARK] = ACTIONS(6257),
    [anon_sym_not] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(6263),
    [anon_sym_TILDE] = ACTIONS(6263),
    [sym_constant] = ACTIONS(6269),
    [sym_identifier] = ACTIONS(6269),
    [sym_instance_variable] = ACTIONS(6267),
    [sym_class_variable] = ACTIONS(6267),
    [sym_global_variable] = ACTIONS(6267),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(6269),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6269),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3768] = {
    [anon_sym_COLON] = ACTIONS(9879),
    [sym_comment] = ACTIONS(87),
  },
  [3769] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(6425),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(6419),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(6419),
    [sym_assignment] = STATE(6425),
    [sym_operator_assignment] = STATE(6425),
    [sym_conditional] = STATE(6425),
    [sym_range] = STATE(6425),
    [sym_binary] = STATE(6425),
    [sym_unary] = STATE(6425),
    [sym_left_assignment_list] = STATE(6418),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6419),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(6419),
    [sym_false] = STATE(6419),
    [sym_nil] = STATE(6419),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(6420),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9859),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9861),
    [anon_sym_yield] = ACTIONS(9863),
    [anon_sym_break] = ACTIONS(9865),
    [anon_sym_next] = ACTIONS(9867),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9869),
    [anon_sym_defined_QMARK] = ACTIONS(9871),
    [anon_sym_not] = ACTIONS(9873),
    [anon_sym_BANG] = ACTIONS(9875),
    [anon_sym_TILDE] = ACTIONS(9875),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3770] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6431),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3782),
    [sym_scope_resolution] = STATE(3778),
    [sym_call] = STATE(3778),
    [sym_method_call] = STATE(3782),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(6432),
    [sym__argument] = STATE(6433),
    [sym_splat_argument] = STATE(6433),
    [sym_hash_splat_argument] = STATE(6433),
    [sym_block_argument] = STATE(6433),
    [sym_assignment] = STATE(6431),
    [sym_operator_assignment] = STATE(6431),
    [sym_conditional] = STATE(6431),
    [sym_range] = STATE(6431),
    [sym_binary] = STATE(6431),
    [sym_unary] = STATE(6431),
    [sym_left_assignment_list] = STATE(3781),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3782),
    [sym__variable] = STATE(3778),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3782),
    [sym_false] = STATE(3782),
    [sym_nil] = STATE(3782),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(6434),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(6433),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(9881),
    [sym__splat_star] = ACTIONS(9883),
    [sym__unary_minus] = ACTIONS(6245),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(9885),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6249),
    [anon_sym_yield] = ACTIONS(6251),
    [anon_sym_break] = ACTIONS(6253),
    [anon_sym_next] = ACTIONS(6255),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(6257),
    [anon_sym_not] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(6261),
    [anon_sym_TILDE] = ACTIONS(6263),
    [sym_constant] = ACTIONS(9887),
    [sym_identifier] = ACTIONS(9887),
    [sym_instance_variable] = ACTIONS(6267),
    [sym_class_variable] = ACTIONS(6267),
    [sym_global_variable] = ACTIONS(6267),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(6269),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6269),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3771] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6431),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3782),
    [sym_scope_resolution] = STATE(3778),
    [sym_call] = STATE(3778),
    [sym_method_call] = STATE(3782),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(6432),
    [sym__argument] = STATE(6433),
    [sym_splat_argument] = STATE(6433),
    [sym_hash_splat_argument] = STATE(6433),
    [sym_block_argument] = STATE(6433),
    [sym_assignment] = STATE(6431),
    [sym_operator_assignment] = STATE(6431),
    [sym_conditional] = STATE(6431),
    [sym_range] = STATE(6431),
    [sym_binary] = STATE(6431),
    [sym_unary] = STATE(6431),
    [sym_left_assignment_list] = STATE(3781),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3782),
    [sym__variable] = STATE(3778),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3782),
    [sym_false] = STATE(3782),
    [sym_nil] = STATE(3782),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(6434),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(6433),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(9881),
    [sym__splat_star] = ACTIONS(9883),
    [sym__unary_minus] = ACTIONS(6245),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(9885),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6249),
    [anon_sym_yield] = ACTIONS(6251),
    [anon_sym_break] = ACTIONS(6253),
    [anon_sym_next] = ACTIONS(6255),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(6257),
    [anon_sym_not] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(6261),
    [anon_sym_TILDE] = ACTIONS(6263),
    [sym_constant] = ACTIONS(9887),
    [sym_identifier] = ACTIONS(9887),
    [sym_instance_variable] = ACTIONS(6267),
    [sym_class_variable] = ACTIONS(6267),
    [sym_global_variable] = ACTIONS(6267),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(6269),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6269),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3772] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6431),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3782),
    [sym_scope_resolution] = STATE(3778),
    [sym_call] = STATE(3778),
    [sym_method_call] = STATE(3782),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(6432),
    [sym__argument] = STATE(6433),
    [sym_splat_argument] = STATE(6433),
    [sym_hash_splat_argument] = STATE(6433),
    [sym_block_argument] = STATE(6433),
    [sym_assignment] = STATE(6431),
    [sym_operator_assignment] = STATE(6431),
    [sym_conditional] = STATE(6431),
    [sym_range] = STATE(6431),
    [sym_binary] = STATE(6431),
    [sym_unary] = STATE(6431),
    [sym_left_assignment_list] = STATE(3781),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3782),
    [sym__variable] = STATE(3778),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3782),
    [sym_false] = STATE(3782),
    [sym_nil] = STATE(3782),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(6434),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(6433),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(9881),
    [sym__splat_star] = ACTIONS(9883),
    [sym__unary_minus] = ACTIONS(6245),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(9885),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6249),
    [anon_sym_yield] = ACTIONS(6251),
    [anon_sym_break] = ACTIONS(6253),
    [anon_sym_next] = ACTIONS(6255),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(6257),
    [anon_sym_not] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(6261),
    [anon_sym_TILDE] = ACTIONS(6263),
    [sym_constant] = ACTIONS(9887),
    [sym_identifier] = ACTIONS(9887),
    [sym_instance_variable] = ACTIONS(6267),
    [sym_class_variable] = ACTIONS(6267),
    [sym_global_variable] = ACTIONS(6267),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(6269),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6269),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3773] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6431),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3782),
    [sym_scope_resolution] = STATE(3778),
    [sym_call] = STATE(3778),
    [sym_method_call] = STATE(3782),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(6432),
    [sym__argument] = STATE(6433),
    [sym_splat_argument] = STATE(6433),
    [sym_hash_splat_argument] = STATE(6433),
    [sym_block_argument] = STATE(6433),
    [sym_assignment] = STATE(6431),
    [sym_operator_assignment] = STATE(6431),
    [sym_conditional] = STATE(6431),
    [sym_range] = STATE(6431),
    [sym_binary] = STATE(6431),
    [sym_unary] = STATE(6431),
    [sym_left_assignment_list] = STATE(3781),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3782),
    [sym__variable] = STATE(3778),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3782),
    [sym_false] = STATE(3782),
    [sym_nil] = STATE(3782),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(6434),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(6433),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(9881),
    [sym__splat_star] = ACTIONS(9883),
    [sym__unary_minus] = ACTIONS(6245),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(9885),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6249),
    [anon_sym_yield] = ACTIONS(6251),
    [anon_sym_break] = ACTIONS(6253),
    [anon_sym_next] = ACTIONS(6255),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(6257),
    [anon_sym_not] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(6261),
    [anon_sym_TILDE] = ACTIONS(6263),
    [sym_constant] = ACTIONS(9887),
    [sym_identifier] = ACTIONS(9887),
    [sym_instance_variable] = ACTIONS(6267),
    [sym_class_variable] = ACTIONS(6267),
    [sym_global_variable] = ACTIONS(6267),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(6269),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6269),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3774] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6435),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3782),
    [sym_scope_resolution] = STATE(3778),
    [sym_call] = STATE(3778),
    [sym_method_call] = STATE(3782),
    [sym_assignment] = STATE(6435),
    [sym_operator_assignment] = STATE(6435),
    [sym_conditional] = STATE(6435),
    [sym_range] = STATE(6435),
    [sym_binary] = STATE(6435),
    [sym_unary] = STATE(6435),
    [sym_left_assignment_list] = STATE(3781),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3782),
    [sym__variable] = STATE(3778),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3782),
    [sym_false] = STATE(3782),
    [sym_nil] = STATE(3782),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(6423),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(6245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6249),
    [anon_sym_yield] = ACTIONS(6251),
    [anon_sym_break] = ACTIONS(6253),
    [anon_sym_next] = ACTIONS(6255),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9877),
    [anon_sym_defined_QMARK] = ACTIONS(6257),
    [anon_sym_not] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(6263),
    [anon_sym_TILDE] = ACTIONS(6263),
    [sym_constant] = ACTIONS(6269),
    [sym_identifier] = ACTIONS(6269),
    [sym_instance_variable] = ACTIONS(6267),
    [sym_class_variable] = ACTIONS(6267),
    [sym_global_variable] = ACTIONS(6267),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(6269),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6269),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3775] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3782),
    [sym_scope_resolution] = STATE(3778),
    [sym_call] = STATE(3778),
    [sym_method_call] = STATE(3782),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(3781),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3782),
    [sym__variable] = STATE(3778),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3782),
    [sym_false] = STATE(3782),
    [sym_nil] = STATE(3782),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(6423),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(6245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6249),
    [anon_sym_yield] = ACTIONS(6251),
    [anon_sym_break] = ACTIONS(6253),
    [anon_sym_next] = ACTIONS(6255),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9877),
    [anon_sym_defined_QMARK] = ACTIONS(6257),
    [anon_sym_not] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(6263),
    [anon_sym_TILDE] = ACTIONS(6263),
    [sym_constant] = ACTIONS(6269),
    [sym_identifier] = ACTIONS(6269),
    [sym_instance_variable] = ACTIONS(6267),
    [sym_class_variable] = ACTIONS(6267),
    [sym_global_variable] = ACTIONS(6267),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(6269),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6269),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3776] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(9889),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [3777] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(9891),
    [sym__binary_star] = ACTIONS(9893),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(9895),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(9893),
    [anon_sym_AMP] = ACTIONS(9897),
    [anon_sym_LT] = ACTIONS(9899),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_unless] = ACTIONS(1625),
    [anon_sym_while] = ACTIONS(1625),
    [anon_sym_until] = ACTIONS(1625),
    [anon_sym_rescue] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(9879),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(9901),
    [anon_sym_DOT_DOT] = ACTIONS(9903),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9905),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(9907),
    [anon_sym_AMP_AMP] = ACTIONS(9907),
    [anon_sym_LT_LT] = ACTIONS(9909),
    [anon_sym_GT_GT] = ACTIONS(9909),
    [anon_sym_EQ_EQ] = ACTIONS(9911),
    [anon_sym_BANG_EQ] = ACTIONS(9907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9907),
    [anon_sym_LT_EQ_GT] = ACTIONS(9907),
    [anon_sym_EQ_TILDE] = ACTIONS(9907),
    [anon_sym_BANG_TILDE] = ACTIONS(9907),
    [anon_sym_LT_EQ] = ACTIONS(9899),
    [anon_sym_GT] = ACTIONS(9899),
    [anon_sym_GT_EQ] = ACTIONS(9913),
    [anon_sym_CARET] = ACTIONS(9915),
    [anon_sym_PLUS] = ACTIONS(9891),
    [anon_sym_SLASH] = ACTIONS(9893),
    [anon_sym_PERCENT] = ACTIONS(9893),
    [sym_comment] = ACTIONS(87),
  },
  [3778] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(6452),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3818),
    [sym_scope_resolution] = STATE(3814),
    [sym_call] = STATE(3814),
    [sym_method_call] = STATE(3818),
    [sym_argument_list] = STATE(938),
    [sym__argument_list_with_parens] = STATE(6453),
    [sym__argument] = STATE(6454),
    [sym_splat_argument] = STATE(6454),
    [sym_hash_splat_argument] = STATE(6454),
    [sym_block_argument] = STATE(6454),
    [sym_do_block] = STATE(941),
    [sym_block] = STATE(941),
    [sym_assignment] = STATE(6452),
    [sym_operator_assignment] = STATE(6452),
    [sym_conditional] = STATE(6452),
    [sym_range] = STATE(6452),
    [sym_binary] = STATE(6452),
    [sym_unary] = STATE(6452),
    [sym_left_assignment_list] = STATE(3817),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3818),
    [sym__variable] = STATE(3814),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3818),
    [sym_false] = STATE(3818),
    [sym_nil] = STATE(3818),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(6455),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(6454),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(743),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(9917),
    [sym__splat_star] = ACTIONS(9919),
    [sym__unary_minus] = ACTIONS(6315),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(9921),
    [anon_sym_LBRACE] = ACTIONS(1669),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(6319),
    [anon_sym_yield] = ACTIONS(6321),
    [anon_sym_break] = ACTIONS(6323),
    [anon_sym_next] = ACTIONS(6325),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(769),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(769),
    [anon_sym_until] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(769),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(1671),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(6327),
    [anon_sym_not] = ACTIONS(6329),
    [anon_sym_BANG] = ACTIONS(6331),
    [anon_sym_TILDE] = ACTIONS(6333),
    [sym_constant] = ACTIONS(9923),
    [sym_identifier] = ACTIONS(9923),
    [sym_instance_variable] = ACTIONS(6337),
    [sym_class_variable] = ACTIONS(6337),
    [sym_global_variable] = ACTIONS(6337),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(6339),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6339),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3779] = {
    [sym_heredoc_body] = STATE(6456),
    [aux_sym_call_repeat1] = STATE(6456),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [3780] = {
    [sym_heredoc_body] = STATE(6456),
    [aux_sym_call_repeat1] = STATE(6456),
    [aux_sym_argument_list_repeat1] = STATE(6458),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(9925),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [3781] = {
    [anon_sym_EQ] = ACTIONS(9927),
    [sym_comment] = ACTIONS(87),
  },
  [3782] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(9929),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(9931),
    [anon_sym_DASH_EQ] = ACTIONS(9931),
    [anon_sym_STAR_EQ] = ACTIONS(9931),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9931),
    [anon_sym_SLASH_EQ] = ACTIONS(9931),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9931),
    [anon_sym_PIPE_EQ] = ACTIONS(9931),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9931),
    [anon_sym_AMP_EQ] = ACTIONS(9931),
    [anon_sym_PERCENT_EQ] = ACTIONS(9931),
    [anon_sym_GT_GT_EQ] = ACTIONS(9931),
    [anon_sym_LT_LT_EQ] = ACTIONS(9931),
    [anon_sym_CARET_EQ] = ACTIONS(9931),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3783] = {
    [sym_string] = STATE(6461),
    [aux_sym_chained_string_repeat1] = STATE(6461),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(9933),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [3784] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(6283),
    [sym__binary_star] = ACTIONS(6285),
    [anon_sym_PIPE] = ACTIONS(6287),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(6285),
    [anon_sym_AMP] = ACTIONS(6289),
    [anon_sym_LT] = ACTIONS(6291),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(6293),
    [anon_sym_DOT_DOT] = ACTIONS(6295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6297),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(6301),
    [anon_sym_AMP_AMP] = ACTIONS(6301),
    [anon_sym_LT_LT] = ACTIONS(6303),
    [anon_sym_GT_GT] = ACTIONS(6303),
    [anon_sym_EQ_EQ] = ACTIONS(6305),
    [anon_sym_BANG_EQ] = ACTIONS(6301),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6301),
    [anon_sym_LT_EQ_GT] = ACTIONS(6301),
    [anon_sym_EQ_TILDE] = ACTIONS(6301),
    [anon_sym_BANG_TILDE] = ACTIONS(6301),
    [anon_sym_LT_EQ] = ACTIONS(6291),
    [anon_sym_GT] = ACTIONS(6291),
    [anon_sym_GT_EQ] = ACTIONS(6307),
    [anon_sym_CARET] = ACTIONS(6309),
    [anon_sym_PLUS] = ACTIONS(6283),
    [anon_sym_SLASH] = ACTIONS(6285),
    [anon_sym_PERCENT] = ACTIONS(6285),
    [sym_comment] = ACTIONS(87),
  },
  [3785] = {
    [aux_sym_undef_repeat1] = STATE(6462),
    [sym__line_break] = ACTIONS(2251),
    [sym__heredoc_body_start] = ACTIONS(2251),
    [anon_sym_COMMA] = ACTIONS(2253),
    [anon_sym_SEMI] = ACTIONS(2251),
    [anon_sym_if] = ACTIONS(2251),
    [anon_sym_unless] = ACTIONS(2251),
    [anon_sym_while] = ACTIONS(2251),
    [anon_sym_until] = ACTIONS(2251),
    [anon_sym_rescue] = ACTIONS(2251),
    [sym_comment] = ACTIONS(87),
  },
  [3786] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(6463),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1615),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(1615),
    [sym_assignment] = STATE(6463),
    [sym_operator_assignment] = STATE(6463),
    [sym_conditional] = STATE(6463),
    [sym_range] = STATE(6463),
    [sym_binary] = STATE(6463),
    [sym_unary] = STATE(6463),
    [sym_left_assignment_list] = STATE(1614),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1615),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1615),
    [sym_false] = STATE(1615),
    [sym_nil] = STATE(1615),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1616),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6219),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6221),
    [anon_sym_yield] = ACTIONS(6223),
    [anon_sym_break] = ACTIONS(6225),
    [anon_sym_next] = ACTIONS(6227),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6229),
    [anon_sym_defined_QMARK] = ACTIONS(6231),
    [anon_sym_not] = ACTIONS(6233),
    [anon_sym_BANG] = ACTIONS(6235),
    [anon_sym_TILDE] = ACTIONS(6235),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3787] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(6464),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1615),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(1615),
    [sym_assignment] = STATE(6464),
    [sym_operator_assignment] = STATE(6464),
    [sym_conditional] = STATE(6464),
    [sym_range] = STATE(6464),
    [sym_binary] = STATE(6464),
    [sym_unary] = STATE(6464),
    [sym_left_assignment_list] = STATE(1614),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1615),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1615),
    [sym_false] = STATE(1615),
    [sym_nil] = STATE(1615),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1616),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6219),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6221),
    [anon_sym_yield] = ACTIONS(6223),
    [anon_sym_break] = ACTIONS(6225),
    [anon_sym_next] = ACTIONS(6227),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6229),
    [anon_sym_defined_QMARK] = ACTIONS(6231),
    [anon_sym_not] = ACTIONS(6233),
    [anon_sym_BANG] = ACTIONS(6235),
    [anon_sym_TILDE] = ACTIONS(6235),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3788] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(6465),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1615),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(1615),
    [sym_assignment] = STATE(6465),
    [sym_operator_assignment] = STATE(6465),
    [sym_conditional] = STATE(6465),
    [sym_range] = STATE(6465),
    [sym_binary] = STATE(6465),
    [sym_unary] = STATE(6465),
    [sym_left_assignment_list] = STATE(1614),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1615),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1615),
    [sym_false] = STATE(1615),
    [sym_nil] = STATE(1615),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1616),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6219),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6221),
    [anon_sym_yield] = ACTIONS(6223),
    [anon_sym_break] = ACTIONS(6225),
    [anon_sym_next] = ACTIONS(6227),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6229),
    [anon_sym_defined_QMARK] = ACTIONS(6231),
    [anon_sym_not] = ACTIONS(6233),
    [anon_sym_BANG] = ACTIONS(6235),
    [anon_sym_TILDE] = ACTIONS(6235),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3789] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(6466),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1615),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(1615),
    [sym_assignment] = STATE(6466),
    [sym_operator_assignment] = STATE(6466),
    [sym_conditional] = STATE(6466),
    [sym_range] = STATE(6466),
    [sym_binary] = STATE(6466),
    [sym_unary] = STATE(6466),
    [sym_left_assignment_list] = STATE(1614),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1615),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1615),
    [sym_false] = STATE(1615),
    [sym_nil] = STATE(1615),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1616),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6219),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6221),
    [anon_sym_yield] = ACTIONS(6223),
    [anon_sym_break] = ACTIONS(6225),
    [anon_sym_next] = ACTIONS(6227),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6229),
    [anon_sym_defined_QMARK] = ACTIONS(6231),
    [anon_sym_not] = ACTIONS(6233),
    [anon_sym_BANG] = ACTIONS(6235),
    [anon_sym_TILDE] = ACTIONS(6235),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3790] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(6467),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1615),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(1615),
    [sym_assignment] = STATE(6467),
    [sym_operator_assignment] = STATE(6467),
    [sym_conditional] = STATE(6467),
    [sym_range] = STATE(6467),
    [sym_binary] = STATE(6467),
    [sym_unary] = STATE(6467),
    [sym_left_assignment_list] = STATE(1614),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1615),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1615),
    [sym_false] = STATE(1615),
    [sym_nil] = STATE(1615),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1616),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6219),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6221),
    [anon_sym_yield] = ACTIONS(6223),
    [anon_sym_break] = ACTIONS(6225),
    [anon_sym_next] = ACTIONS(6227),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6229),
    [anon_sym_defined_QMARK] = ACTIONS(6231),
    [anon_sym_not] = ACTIONS(6233),
    [anon_sym_BANG] = ACTIONS(6235),
    [anon_sym_TILDE] = ACTIONS(6235),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3791] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(6468),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1615),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(1615),
    [sym_assignment] = STATE(6468),
    [sym_operator_assignment] = STATE(6468),
    [sym_conditional] = STATE(6468),
    [sym_range] = STATE(6468),
    [sym_binary] = STATE(6468),
    [sym_unary] = STATE(6468),
    [sym_left_assignment_list] = STATE(1614),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1615),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1615),
    [sym_false] = STATE(1615),
    [sym_nil] = STATE(1615),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1616),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6219),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6221),
    [anon_sym_yield] = ACTIONS(6223),
    [anon_sym_break] = ACTIONS(6225),
    [anon_sym_next] = ACTIONS(6227),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6229),
    [anon_sym_defined_QMARK] = ACTIONS(6231),
    [anon_sym_not] = ACTIONS(6233),
    [anon_sym_BANG] = ACTIONS(6235),
    [anon_sym_TILDE] = ACTIONS(6235),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3792] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(6469),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1615),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(1615),
    [sym_assignment] = STATE(6469),
    [sym_operator_assignment] = STATE(6469),
    [sym_conditional] = STATE(6469),
    [sym_range] = STATE(6469),
    [sym_binary] = STATE(6469),
    [sym_unary] = STATE(6469),
    [sym_left_assignment_list] = STATE(1614),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1615),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1615),
    [sym_false] = STATE(1615),
    [sym_nil] = STATE(1615),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1616),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6219),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6221),
    [anon_sym_yield] = ACTIONS(6223),
    [anon_sym_break] = ACTIONS(6225),
    [anon_sym_next] = ACTIONS(6227),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6229),
    [anon_sym_defined_QMARK] = ACTIONS(6231),
    [anon_sym_not] = ACTIONS(6233),
    [anon_sym_BANG] = ACTIONS(6235),
    [anon_sym_TILDE] = ACTIONS(6235),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3793] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(6470),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1615),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(1615),
    [sym_assignment] = STATE(6470),
    [sym_operator_assignment] = STATE(6470),
    [sym_conditional] = STATE(6470),
    [sym_range] = STATE(6470),
    [sym_binary] = STATE(6470),
    [sym_unary] = STATE(6470),
    [sym_left_assignment_list] = STATE(1614),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1615),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1615),
    [sym_false] = STATE(1615),
    [sym_nil] = STATE(1615),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1616),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6219),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6221),
    [anon_sym_yield] = ACTIONS(6223),
    [anon_sym_break] = ACTIONS(6225),
    [anon_sym_next] = ACTIONS(6227),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6229),
    [anon_sym_defined_QMARK] = ACTIONS(6231),
    [anon_sym_not] = ACTIONS(6233),
    [anon_sym_BANG] = ACTIONS(6235),
    [anon_sym_TILDE] = ACTIONS(6235),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3794] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(6471),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1615),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(1615),
    [sym_assignment] = STATE(6471),
    [sym_operator_assignment] = STATE(6471),
    [sym_conditional] = STATE(6471),
    [sym_range] = STATE(6471),
    [sym_binary] = STATE(6471),
    [sym_unary] = STATE(6471),
    [sym_left_assignment_list] = STATE(1614),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1615),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1615),
    [sym_false] = STATE(1615),
    [sym_nil] = STATE(1615),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1616),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6219),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6221),
    [anon_sym_yield] = ACTIONS(6223),
    [anon_sym_break] = ACTIONS(6225),
    [anon_sym_next] = ACTIONS(6227),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6229),
    [anon_sym_defined_QMARK] = ACTIONS(6231),
    [anon_sym_not] = ACTIONS(6233),
    [anon_sym_BANG] = ACTIONS(6235),
    [anon_sym_TILDE] = ACTIONS(6235),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3795] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(6472),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1615),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(1615),
    [sym_assignment] = STATE(6472),
    [sym_operator_assignment] = STATE(6472),
    [sym_conditional] = STATE(6472),
    [sym_range] = STATE(6472),
    [sym_binary] = STATE(6472),
    [sym_unary] = STATE(6472),
    [sym_left_assignment_list] = STATE(1614),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1615),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1615),
    [sym_false] = STATE(1615),
    [sym_nil] = STATE(1615),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1616),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6219),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6221),
    [anon_sym_yield] = ACTIONS(6223),
    [anon_sym_break] = ACTIONS(6225),
    [anon_sym_next] = ACTIONS(6227),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6229),
    [anon_sym_defined_QMARK] = ACTIONS(6231),
    [anon_sym_not] = ACTIONS(6233),
    [anon_sym_BANG] = ACTIONS(6235),
    [anon_sym_TILDE] = ACTIONS(6235),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3796] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(6473),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(6473),
    [sym_operator_assignment] = STATE(6473),
    [sym_conditional] = STATE(6473),
    [sym_range] = STATE(6473),
    [sym_binary] = STATE(6473),
    [sym_unary] = STATE(6473),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3797] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(6474),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1615),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(1615),
    [sym_assignment] = STATE(6474),
    [sym_operator_assignment] = STATE(6474),
    [sym_conditional] = STATE(6474),
    [sym_range] = STATE(6474),
    [sym_binary] = STATE(6474),
    [sym_unary] = STATE(6474),
    [sym_left_assignment_list] = STATE(1614),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1615),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1615),
    [sym_false] = STATE(1615),
    [sym_nil] = STATE(1615),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1616),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6219),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6221),
    [anon_sym_yield] = ACTIONS(6223),
    [anon_sym_break] = ACTIONS(6225),
    [anon_sym_next] = ACTIONS(6227),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6229),
    [anon_sym_defined_QMARK] = ACTIONS(6231),
    [anon_sym_not] = ACTIONS(6233),
    [anon_sym_BANG] = ACTIONS(6235),
    [anon_sym_TILDE] = ACTIONS(6235),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3798] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(6475),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1615),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(1615),
    [sym_assignment] = STATE(6475),
    [sym_operator_assignment] = STATE(6475),
    [sym_conditional] = STATE(6475),
    [sym_range] = STATE(6475),
    [sym_binary] = STATE(6475),
    [sym_unary] = STATE(6475),
    [sym_left_assignment_list] = STATE(1614),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1615),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1615),
    [sym_false] = STATE(1615),
    [sym_nil] = STATE(1615),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1616),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6219),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6221),
    [anon_sym_yield] = ACTIONS(6223),
    [anon_sym_break] = ACTIONS(6225),
    [anon_sym_next] = ACTIONS(6227),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6229),
    [anon_sym_defined_QMARK] = ACTIONS(6231),
    [anon_sym_not] = ACTIONS(6233),
    [anon_sym_BANG] = ACTIONS(6235),
    [anon_sym_TILDE] = ACTIONS(6235),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3799] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(6476),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1615),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(1615),
    [sym_assignment] = STATE(6476),
    [sym_operator_assignment] = STATE(6476),
    [sym_conditional] = STATE(6476),
    [sym_range] = STATE(6476),
    [sym_binary] = STATE(6476),
    [sym_unary] = STATE(6476),
    [sym_left_assignment_list] = STATE(1614),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1615),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1615),
    [sym_false] = STATE(1615),
    [sym_nil] = STATE(1615),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1616),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6219),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6221),
    [anon_sym_yield] = ACTIONS(6223),
    [anon_sym_break] = ACTIONS(6225),
    [anon_sym_next] = ACTIONS(6227),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6229),
    [anon_sym_defined_QMARK] = ACTIONS(6231),
    [anon_sym_not] = ACTIONS(6233),
    [anon_sym_BANG] = ACTIONS(6235),
    [anon_sym_TILDE] = ACTIONS(6235),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3800] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(6477),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1615),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(1615),
    [sym_assignment] = STATE(6477),
    [sym_operator_assignment] = STATE(6477),
    [sym_conditional] = STATE(6477),
    [sym_range] = STATE(6477),
    [sym_binary] = STATE(6477),
    [sym_unary] = STATE(6477),
    [sym_left_assignment_list] = STATE(1614),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1615),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1615),
    [sym_false] = STATE(1615),
    [sym_nil] = STATE(1615),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1616),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6219),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6221),
    [anon_sym_yield] = ACTIONS(6223),
    [anon_sym_break] = ACTIONS(6225),
    [anon_sym_next] = ACTIONS(6227),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6229),
    [anon_sym_defined_QMARK] = ACTIONS(6231),
    [anon_sym_not] = ACTIONS(6233),
    [anon_sym_BANG] = ACTIONS(6235),
    [anon_sym_TILDE] = ACTIONS(6235),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3801] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(6485),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(6488),
    [sym_scope_resolution] = STATE(6486),
    [sym_call] = STATE(6486),
    [sym_method_call] = STATE(6488),
    [sym_assignment] = STATE(6485),
    [sym_operator_assignment] = STATE(6485),
    [sym_conditional] = STATE(6485),
    [sym_range] = STATE(6485),
    [sym_binary] = STATE(6485),
    [sym_unary] = STATE(6485),
    [sym_left_assignment_list] = STATE(6487),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6488),
    [sym__variable] = STATE(6486),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(6488),
    [sym_false] = STATE(6488),
    [sym_nil] = STATE(6488),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(6489),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(9935),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(9937),
    [anon_sym_yield] = ACTIONS(9939),
    [anon_sym_break] = ACTIONS(9941),
    [anon_sym_next] = ACTIONS(9943),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(9945),
    [anon_sym_defined_QMARK] = ACTIONS(9947),
    [anon_sym_not] = ACTIONS(9949),
    [anon_sym_BANG] = ACTIONS(9951),
    [anon_sym_TILDE] = ACTIONS(9951),
    [sym_constant] = ACTIONS(9953),
    [sym_identifier] = ACTIONS(9953),
    [sym_instance_variable] = ACTIONS(9955),
    [sym_class_variable] = ACTIONS(9955),
    [sym_global_variable] = ACTIONS(9955),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(9953),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9953),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [3802] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(6490),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(6488),
    [sym_scope_resolution] = STATE(6486),
    [sym_call] = STATE(6486),
    [sym_method_call] = STATE(6488),
    [sym_assignment] = STATE(6490),
    [sym_operator_assignment] = STATE(6490),
    [sym_conditional] = STATE(6490),
    [sym_range] = STATE(6490),
    [sym_binary] = STATE(6490),
    [sym_unary] = STATE(6490),
    [sym_left_assignment_list] = STATE(6487),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6488),
    [sym__variable] = STATE(6486),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(6488),
    [sym_false] = STATE(6488),
    [sym_nil] = STATE(6488),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(6489),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(9935),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(9937),
    [anon_sym_yield] = ACTIONS(9939),
    [anon_sym_break] = ACTIONS(9941),
    [anon_sym_next] = ACTIONS(9943),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(9945),
    [anon_sym_defined_QMARK] = ACTIONS(9947),
    [anon_sym_not] = ACTIONS(9949),
    [anon_sym_BANG] = ACTIONS(9951),
    [anon_sym_TILDE] = ACTIONS(9951),
    [sym_constant] = ACTIONS(9953),
    [sym_identifier] = ACTIONS(9953),
    [sym_instance_variable] = ACTIONS(9955),
    [sym_class_variable] = ACTIONS(9955),
    [sym_global_variable] = ACTIONS(9955),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(9953),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9953),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [3803] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(6491),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3818),
    [sym_scope_resolution] = STATE(3814),
    [sym_call] = STATE(3814),
    [sym_method_call] = STATE(3818),
    [sym_assignment] = STATE(6491),
    [sym_operator_assignment] = STATE(6491),
    [sym_conditional] = STATE(6491),
    [sym_range] = STATE(6491),
    [sym_binary] = STATE(6491),
    [sym_unary] = STATE(6491),
    [sym_left_assignment_list] = STATE(3817),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3818),
    [sym__variable] = STATE(3814),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3818),
    [sym_false] = STATE(3818),
    [sym_nil] = STATE(3818),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(6492),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(6319),
    [anon_sym_yield] = ACTIONS(6321),
    [anon_sym_break] = ACTIONS(6323),
    [anon_sym_next] = ACTIONS(6325),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(9957),
    [anon_sym_defined_QMARK] = ACTIONS(6327),
    [anon_sym_not] = ACTIONS(6329),
    [anon_sym_BANG] = ACTIONS(6333),
    [anon_sym_TILDE] = ACTIONS(6333),
    [sym_constant] = ACTIONS(6339),
    [sym_identifier] = ACTIONS(6339),
    [sym_instance_variable] = ACTIONS(6337),
    [sym_class_variable] = ACTIONS(6337),
    [sym_global_variable] = ACTIONS(6337),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(6339),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6339),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3804] = {
    [anon_sym_COLON] = ACTIONS(9959),
    [sym_comment] = ACTIONS(87),
  },
  [3805] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(6494),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(6488),
    [sym_scope_resolution] = STATE(6486),
    [sym_call] = STATE(6486),
    [sym_method_call] = STATE(6488),
    [sym_assignment] = STATE(6494),
    [sym_operator_assignment] = STATE(6494),
    [sym_conditional] = STATE(6494),
    [sym_range] = STATE(6494),
    [sym_binary] = STATE(6494),
    [sym_unary] = STATE(6494),
    [sym_left_assignment_list] = STATE(6487),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6488),
    [sym__variable] = STATE(6486),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(6488),
    [sym_false] = STATE(6488),
    [sym_nil] = STATE(6488),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(6489),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(9935),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(9937),
    [anon_sym_yield] = ACTIONS(9939),
    [anon_sym_break] = ACTIONS(9941),
    [anon_sym_next] = ACTIONS(9943),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(9945),
    [anon_sym_defined_QMARK] = ACTIONS(9947),
    [anon_sym_not] = ACTIONS(9949),
    [anon_sym_BANG] = ACTIONS(9951),
    [anon_sym_TILDE] = ACTIONS(9951),
    [sym_constant] = ACTIONS(9953),
    [sym_identifier] = ACTIONS(9953),
    [sym_instance_variable] = ACTIONS(9955),
    [sym_class_variable] = ACTIONS(9955),
    [sym_global_variable] = ACTIONS(9955),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(9953),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9953),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [3806] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(6452),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3818),
    [sym_scope_resolution] = STATE(3814),
    [sym_call] = STATE(3814),
    [sym_method_call] = STATE(3818),
    [sym_argument_list] = STATE(1535),
    [sym__argument_list_with_parens] = STATE(6453),
    [sym__argument] = STATE(6454),
    [sym_splat_argument] = STATE(6454),
    [sym_hash_splat_argument] = STATE(6454),
    [sym_block_argument] = STATE(6454),
    [sym_assignment] = STATE(6452),
    [sym_operator_assignment] = STATE(6452),
    [sym_conditional] = STATE(6452),
    [sym_range] = STATE(6452),
    [sym_binary] = STATE(6452),
    [sym_unary] = STATE(6452),
    [sym_left_assignment_list] = STATE(3817),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3818),
    [sym__variable] = STATE(3814),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3818),
    [sym_false] = STATE(3818),
    [sym_nil] = STATE(3818),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(6455),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(6454),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(9917),
    [sym__splat_star] = ACTIONS(9919),
    [sym__unary_minus] = ACTIONS(6315),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(9921),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(6319),
    [anon_sym_yield] = ACTIONS(6321),
    [anon_sym_break] = ACTIONS(6323),
    [anon_sym_next] = ACTIONS(6325),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(365),
    [anon_sym_DASH_EQ] = ACTIONS(365),
    [anon_sym_STAR_EQ] = ACTIONS(365),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(365),
    [anon_sym_SLASH_EQ] = ACTIONS(365),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(365),
    [anon_sym_PIPE_EQ] = ACTIONS(365),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(365),
    [anon_sym_AMP_EQ] = ACTIONS(365),
    [anon_sym_PERCENT_EQ] = ACTIONS(365),
    [anon_sym_GT_GT_EQ] = ACTIONS(365),
    [anon_sym_LT_LT_EQ] = ACTIONS(365),
    [anon_sym_CARET_EQ] = ACTIONS(365),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_PERCENT] = ACTIONS(377),
    [anon_sym_defined_QMARK] = ACTIONS(6327),
    [anon_sym_not] = ACTIONS(6329),
    [anon_sym_BANG] = ACTIONS(6331),
    [anon_sym_TILDE] = ACTIONS(6333),
    [sym_constant] = ACTIONS(9923),
    [sym_identifier] = ACTIONS(9923),
    [sym_instance_variable] = ACTIONS(6337),
    [sym_class_variable] = ACTIONS(6337),
    [sym_global_variable] = ACTIONS(6337),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(6339),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6339),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3807] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(6452),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3818),
    [sym_scope_resolution] = STATE(3814),
    [sym_call] = STATE(3814),
    [sym_method_call] = STATE(3818),
    [sym_argument_list] = STATE(1536),
    [sym__argument_list_with_parens] = STATE(6453),
    [sym__argument] = STATE(6454),
    [sym_splat_argument] = STATE(6454),
    [sym_hash_splat_argument] = STATE(6454),
    [sym_block_argument] = STATE(6454),
    [sym_assignment] = STATE(6452),
    [sym_operator_assignment] = STATE(6452),
    [sym_conditional] = STATE(6452),
    [sym_range] = STATE(6452),
    [sym_binary] = STATE(6452),
    [sym_unary] = STATE(6452),
    [sym_left_assignment_list] = STATE(3817),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3818),
    [sym__variable] = STATE(3814),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3818),
    [sym_false] = STATE(3818),
    [sym_nil] = STATE(3818),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(6455),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(6454),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(9917),
    [sym__splat_star] = ACTIONS(9919),
    [sym__unary_minus] = ACTIONS(6315),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(9921),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_EQ] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(6319),
    [anon_sym_yield] = ACTIONS(6321),
    [anon_sym_break] = ACTIONS(6323),
    [anon_sym_next] = ACTIONS(6325),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(417),
    [anon_sym_DASH_EQ] = ACTIONS(417),
    [anon_sym_STAR_EQ] = ACTIONS(417),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(417),
    [anon_sym_SLASH_EQ] = ACTIONS(417),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(417),
    [anon_sym_PIPE_EQ] = ACTIONS(417),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(417),
    [anon_sym_AMP_EQ] = ACTIONS(417),
    [anon_sym_PERCENT_EQ] = ACTIONS(417),
    [anon_sym_GT_GT_EQ] = ACTIONS(417),
    [anon_sym_LT_LT_EQ] = ACTIONS(417),
    [anon_sym_CARET_EQ] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(6327),
    [anon_sym_not] = ACTIONS(6329),
    [anon_sym_BANG] = ACTIONS(6331),
    [anon_sym_TILDE] = ACTIONS(6333),
    [sym_constant] = ACTIONS(9923),
    [sym_identifier] = ACTIONS(9923),
    [sym_instance_variable] = ACTIONS(6337),
    [sym_class_variable] = ACTIONS(6337),
    [sym_global_variable] = ACTIONS(6337),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(6339),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6339),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3808] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(6452),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3818),
    [sym_scope_resolution] = STATE(3814),
    [sym_call] = STATE(3814),
    [sym_method_call] = STATE(3818),
    [sym_argument_list] = STATE(1537),
    [sym__argument_list_with_parens] = STATE(6453),
    [sym__argument] = STATE(6454),
    [sym_splat_argument] = STATE(6454),
    [sym_hash_splat_argument] = STATE(6454),
    [sym_block_argument] = STATE(6454),
    [sym_assignment] = STATE(6452),
    [sym_operator_assignment] = STATE(6452),
    [sym_conditional] = STATE(6452),
    [sym_range] = STATE(6452),
    [sym_binary] = STATE(6452),
    [sym_unary] = STATE(6452),
    [sym_left_assignment_list] = STATE(3817),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3818),
    [sym__variable] = STATE(3814),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3818),
    [sym_false] = STATE(3818),
    [sym_nil] = STATE(3818),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(6455),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(6454),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(9917),
    [sym__splat_star] = ACTIONS(9919),
    [sym__unary_minus] = ACTIONS(6315),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(9921),
    [anon_sym_LBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_EQ] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(6319),
    [anon_sym_yield] = ACTIONS(6321),
    [anon_sym_break] = ACTIONS(6323),
    [anon_sym_next] = ACTIONS(6325),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(421),
    [anon_sym_DASH_EQ] = ACTIONS(421),
    [anon_sym_STAR_EQ] = ACTIONS(421),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(421),
    [anon_sym_SLASH_EQ] = ACTIONS(421),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(421),
    [anon_sym_PIPE_EQ] = ACTIONS(421),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(421),
    [anon_sym_AMP_EQ] = ACTIONS(421),
    [anon_sym_PERCENT_EQ] = ACTIONS(421),
    [anon_sym_GT_GT_EQ] = ACTIONS(421),
    [anon_sym_LT_LT_EQ] = ACTIONS(421),
    [anon_sym_CARET_EQ] = ACTIONS(421),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(6327),
    [anon_sym_not] = ACTIONS(6329),
    [anon_sym_BANG] = ACTIONS(6331),
    [anon_sym_TILDE] = ACTIONS(6333),
    [sym_constant] = ACTIONS(9923),
    [sym_identifier] = ACTIONS(9923),
    [sym_instance_variable] = ACTIONS(6337),
    [sym_class_variable] = ACTIONS(6337),
    [sym_global_variable] = ACTIONS(6337),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(6339),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6339),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3809] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(6452),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3818),
    [sym_scope_resolution] = STATE(3814),
    [sym_call] = STATE(3814),
    [sym_method_call] = STATE(3818),
    [sym_argument_list] = STATE(1538),
    [sym__argument_list_with_parens] = STATE(6453),
    [sym__argument] = STATE(6454),
    [sym_splat_argument] = STATE(6454),
    [sym_hash_splat_argument] = STATE(6454),
    [sym_block_argument] = STATE(6454),
    [sym_assignment] = STATE(6452),
    [sym_operator_assignment] = STATE(6452),
    [sym_conditional] = STATE(6452),
    [sym_range] = STATE(6452),
    [sym_binary] = STATE(6452),
    [sym_unary] = STATE(6452),
    [sym_left_assignment_list] = STATE(3817),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3818),
    [sym__variable] = STATE(3814),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3818),
    [sym_false] = STATE(3818),
    [sym_nil] = STATE(3818),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(6455),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(6454),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(9917),
    [sym__splat_star] = ACTIONS(9919),
    [sym__unary_minus] = ACTIONS(6315),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(9921),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(427),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(6319),
    [anon_sym_yield] = ACTIONS(6321),
    [anon_sym_break] = ACTIONS(6323),
    [anon_sym_next] = ACTIONS(6325),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(425),
    [anon_sym_DASH_EQ] = ACTIONS(425),
    [anon_sym_STAR_EQ] = ACTIONS(425),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(425),
    [anon_sym_SLASH_EQ] = ACTIONS(425),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(425),
    [anon_sym_PIPE_EQ] = ACTIONS(425),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(425),
    [anon_sym_AMP_EQ] = ACTIONS(425),
    [anon_sym_PERCENT_EQ] = ACTIONS(425),
    [anon_sym_GT_GT_EQ] = ACTIONS(425),
    [anon_sym_LT_LT_EQ] = ACTIONS(425),
    [anon_sym_CARET_EQ] = ACTIONS(425),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(6327),
    [anon_sym_not] = ACTIONS(6329),
    [anon_sym_BANG] = ACTIONS(6331),
    [anon_sym_TILDE] = ACTIONS(6333),
    [sym_constant] = ACTIONS(9923),
    [sym_identifier] = ACTIONS(9923),
    [sym_instance_variable] = ACTIONS(6337),
    [sym_class_variable] = ACTIONS(6337),
    [sym_global_variable] = ACTIONS(6337),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(6339),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6339),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3810] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(6495),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3818),
    [sym_scope_resolution] = STATE(3814),
    [sym_call] = STATE(3814),
    [sym_method_call] = STATE(3818),
    [sym_assignment] = STATE(6495),
    [sym_operator_assignment] = STATE(6495),
    [sym_conditional] = STATE(6495),
    [sym_range] = STATE(6495),
    [sym_binary] = STATE(6495),
    [sym_unary] = STATE(6495),
    [sym_left_assignment_list] = STATE(3817),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3818),
    [sym__variable] = STATE(3814),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3818),
    [sym_false] = STATE(3818),
    [sym_nil] = STATE(3818),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(6492),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(6319),
    [anon_sym_yield] = ACTIONS(6321),
    [anon_sym_break] = ACTIONS(6323),
    [anon_sym_next] = ACTIONS(6325),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(9957),
    [anon_sym_defined_QMARK] = ACTIONS(6327),
    [anon_sym_not] = ACTIONS(6329),
    [anon_sym_BANG] = ACTIONS(6333),
    [anon_sym_TILDE] = ACTIONS(6333),
    [sym_constant] = ACTIONS(6339),
    [sym_identifier] = ACTIONS(6339),
    [sym_instance_variable] = ACTIONS(6337),
    [sym_class_variable] = ACTIONS(6337),
    [sym_global_variable] = ACTIONS(6337),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(6339),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6339),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3811] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(1559),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3818),
    [sym_scope_resolution] = STATE(3814),
    [sym_call] = STATE(3814),
    [sym_method_call] = STATE(3818),
    [sym_assignment] = STATE(1559),
    [sym_operator_assignment] = STATE(1559),
    [sym_conditional] = STATE(1559),
    [sym_range] = STATE(1559),
    [sym_binary] = STATE(1559),
    [sym_unary] = STATE(1559),
    [sym_left_assignment_list] = STATE(3817),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3818),
    [sym__variable] = STATE(3814),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3818),
    [sym_false] = STATE(3818),
    [sym_nil] = STATE(3818),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(6492),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(6319),
    [anon_sym_yield] = ACTIONS(6321),
    [anon_sym_break] = ACTIONS(6323),
    [anon_sym_next] = ACTIONS(6325),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(9957),
    [anon_sym_defined_QMARK] = ACTIONS(6327),
    [anon_sym_not] = ACTIONS(6329),
    [anon_sym_BANG] = ACTIONS(6333),
    [anon_sym_TILDE] = ACTIONS(6333),
    [sym_constant] = ACTIONS(6339),
    [sym_identifier] = ACTIONS(6339),
    [sym_instance_variable] = ACTIONS(6337),
    [sym_class_variable] = ACTIONS(6337),
    [sym_global_variable] = ACTIONS(6337),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(6339),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6339),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3812] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(9961),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [3813] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(9963),
    [sym__binary_star] = ACTIONS(9965),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(9967),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(9969),
    [anon_sym_AMP] = ACTIONS(9971),
    [anon_sym_EQ] = ACTIONS(1631),
    [anon_sym_LT] = ACTIONS(9973),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_unless] = ACTIONS(1625),
    [anon_sym_while] = ACTIONS(1625),
    [anon_sym_until] = ACTIONS(1625),
    [anon_sym_rescue] = ACTIONS(1625),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(9959),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_PLUS_EQ] = ACTIONS(1625),
    [anon_sym_DASH_EQ] = ACTIONS(1625),
    [anon_sym_STAR_EQ] = ACTIONS(1625),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1625),
    [anon_sym_SLASH_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1625),
    [anon_sym_AMP_EQ] = ACTIONS(1625),
    [anon_sym_PERCENT_EQ] = ACTIONS(1625),
    [anon_sym_GT_GT_EQ] = ACTIONS(1625),
    [anon_sym_LT_LT_EQ] = ACTIONS(1625),
    [anon_sym_CARET_EQ] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(9975),
    [anon_sym_DOT_DOT] = ACTIONS(9977),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9979),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(9981),
    [anon_sym_AMP_AMP] = ACTIONS(9981),
    [anon_sym_LT_LT] = ACTIONS(9983),
    [anon_sym_GT_GT] = ACTIONS(9983),
    [anon_sym_EQ_EQ] = ACTIONS(9981),
    [anon_sym_BANG_EQ] = ACTIONS(9985),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9985),
    [anon_sym_LT_EQ_GT] = ACTIONS(9985),
    [anon_sym_EQ_TILDE] = ACTIONS(9985),
    [anon_sym_BANG_TILDE] = ACTIONS(9985),
    [anon_sym_LT_EQ] = ACTIONS(9973),
    [anon_sym_GT] = ACTIONS(9973),
    [anon_sym_GT_EQ] = ACTIONS(9987),
    [anon_sym_CARET] = ACTIONS(9967),
    [anon_sym_PLUS] = ACTIONS(9989),
    [anon_sym_SLASH] = ACTIONS(9969),
    [anon_sym_PERCENT] = ACTIONS(9969),
    [sym_comment] = ACTIONS(87),
  },
  [3814] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(6452),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3818),
    [sym_scope_resolution] = STATE(3814),
    [sym_call] = STATE(3814),
    [sym_method_call] = STATE(3818),
    [sym_argument_list] = STATE(1578),
    [sym__argument_list_with_parens] = STATE(6453),
    [sym__argument] = STATE(6454),
    [sym_splat_argument] = STATE(6454),
    [sym_hash_splat_argument] = STATE(6454),
    [sym_block_argument] = STATE(6454),
    [sym_do_block] = STATE(941),
    [sym_block] = STATE(941),
    [sym_assignment] = STATE(6452),
    [sym_operator_assignment] = STATE(6452),
    [sym_conditional] = STATE(6452),
    [sym_range] = STATE(6452),
    [sym_binary] = STATE(6452),
    [sym_unary] = STATE(6452),
    [sym_left_assignment_list] = STATE(3817),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3818),
    [sym__variable] = STATE(3814),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3818),
    [sym_false] = STATE(3818),
    [sym_nil] = STATE(3818),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(6455),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(6454),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(743),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(9917),
    [sym__splat_star] = ACTIONS(9919),
    [sym__unary_minus] = ACTIONS(6315),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(9921),
    [anon_sym_LBRACE] = ACTIONS(2715),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(6319),
    [anon_sym_yield] = ACTIONS(6321),
    [anon_sym_break] = ACTIONS(6323),
    [anon_sym_next] = ACTIONS(6325),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(769),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(769),
    [anon_sym_until] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(769),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(769),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(6327),
    [anon_sym_not] = ACTIONS(6329),
    [anon_sym_BANG] = ACTIONS(6331),
    [anon_sym_TILDE] = ACTIONS(6333),
    [sym_constant] = ACTIONS(9923),
    [sym_identifier] = ACTIONS(9923),
    [sym_instance_variable] = ACTIONS(6337),
    [sym_class_variable] = ACTIONS(6337),
    [sym_global_variable] = ACTIONS(6337),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(6339),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6339),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [3815] = {
    [sym_heredoc_body] = STATE(6507),
    [aux_sym_call_repeat1] = STATE(6507),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [3816] = {
    [sym_heredoc_body] = STATE(6507),
    [aux_sym_call_repeat1] = STATE(6507),
    [aux_sym_argument_list_repeat1] = STATE(6509),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(9991),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [3817] = {
    [anon_sym_EQ] = ACTIONS(9993),
    [sym_comment] = ACTIONS(87),
  },
  [3818] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(9995),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(9997),
    [anon_sym_DASH_EQ] = ACTIONS(9997),
    [anon_sym_STAR_EQ] = ACTIONS(9997),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9997),
    [anon_sym_SLASH_EQ] = ACTIONS(9997),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9997),
    [anon_sym_PIPE_EQ] = ACTIONS(9997),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9997),
    [anon_sym_AMP_EQ] = ACTIONS(9997),
    [anon_sym_PERCENT_EQ] = ACTIONS(9997),
    [anon_sym_GT_GT_EQ] = ACTIONS(9997),
    [anon_sym_LT_LT_EQ] = ACTIONS(9997),
    [anon_sym_CARET_EQ] = ACTIONS(9997),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3819] = {
    [sym_string] = STATE(6512),
    [aux_sym_chained_string_repeat1] = STATE(6512),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(747),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(9999),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3820] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(6517),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(6520),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(6520),
    [sym_splat_argument] = STATE(6518),
    [sym_assignment] = STATE(6517),
    [sym_operator_assignment] = STATE(6517),
    [sym_conditional] = STATE(6517),
    [sym_range] = STATE(6517),
    [sym_binary] = STATE(6517),
    [sym_unary] = STATE(6517),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(6518),
    [sym_left_assignment_list] = STATE(6519),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6520),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(6520),
    [sym_false] = STATE(6520),
    [sym_nil] = STATE(6520),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(6420),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(10001),
    [sym__unary_minus] = ACTIONS(10003),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9861),
    [anon_sym_yield] = ACTIONS(9863),
    [anon_sym_break] = ACTIONS(9865),
    [anon_sym_next] = ACTIONS(9867),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10005),
    [anon_sym_defined_QMARK] = ACTIONS(10007),
    [anon_sym_not] = ACTIONS(10009),
    [anon_sym_BANG] = ACTIONS(10011),
    [anon_sym_TILDE] = ACTIONS(10011),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3821] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(6521),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1615),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(1615),
    [sym_assignment] = STATE(6521),
    [sym_operator_assignment] = STATE(6521),
    [sym_conditional] = STATE(6521),
    [sym_range] = STATE(6521),
    [sym_binary] = STATE(6521),
    [sym_unary] = STATE(6521),
    [sym_left_assignment_list] = STATE(1614),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1615),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1615),
    [sym_false] = STATE(1615),
    [sym_nil] = STATE(1615),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1616),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6219),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6221),
    [anon_sym_yield] = ACTIONS(6223),
    [anon_sym_break] = ACTIONS(6225),
    [anon_sym_next] = ACTIONS(6227),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6229),
    [anon_sym_defined_QMARK] = ACTIONS(6231),
    [anon_sym_not] = ACTIONS(6233),
    [anon_sym_BANG] = ACTIONS(6235),
    [anon_sym_TILDE] = ACTIONS(6235),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3822] = {
    [sym_string] = STATE(6522),
    [aux_sym_chained_string_repeat1] = STATE(6522),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [3823] = {
    [anon_sym_RBRACE] = ACTIONS(3105),
    [anon_sym_if] = ACTIONS(3105),
    [anon_sym_unless] = ACTIONS(3105),
    [anon_sym_while] = ACTIONS(3105),
    [anon_sym_until] = ACTIONS(3105),
    [anon_sym_rescue] = ACTIONS(3105),
    [sym_comment] = ACTIONS(87),
  },
  [3824] = {
    [anon_sym_RBRACE] = ACTIONS(10013),
    [sym_comment] = ACTIONS(87),
  },
  [3825] = {
    [anon_sym_RBRACE] = ACTIONS(3585),
    [anon_sym_if] = ACTIONS(3585),
    [anon_sym_unless] = ACTIONS(3585),
    [anon_sym_while] = ACTIONS(3585),
    [anon_sym_until] = ACTIONS(3585),
    [anon_sym_rescue] = ACTIONS(3585),
    [sym_comment] = ACTIONS(87),
  },
  [3826] = {
    [anon_sym_RBRACE] = ACTIONS(10015),
    [sym_comment] = ACTIONS(87),
  },
  [3827] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(6525),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(3837),
    [sym_scope_resolution] = STATE(3835),
    [sym_call] = STATE(3835),
    [sym_method_call] = STATE(3837),
    [sym_assignment] = STATE(6525),
    [sym_operator_assignment] = STATE(6525),
    [sym_conditional] = STATE(6525),
    [sym_range] = STATE(6525),
    [sym_binary] = STATE(6525),
    [sym_unary] = STATE(6525),
    [sym_left_assignment_list] = STATE(3836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3837),
    [sym__variable] = STATE(3835),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(3837),
    [sym_false] = STATE(3837),
    [sym_nil] = STATE(3837),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(3838),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6351),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6353),
    [anon_sym_yield] = ACTIONS(6355),
    [anon_sym_break] = ACTIONS(6357),
    [anon_sym_next] = ACTIONS(6359),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6361),
    [anon_sym_defined_QMARK] = ACTIONS(6363),
    [anon_sym_not] = ACTIONS(6365),
    [anon_sym_BANG] = ACTIONS(6367),
    [anon_sym_TILDE] = ACTIONS(6367),
    [sym_constant] = ACTIONS(6369),
    [sym_identifier] = ACTIONS(6369),
    [sym_instance_variable] = ACTIONS(6371),
    [sym_class_variable] = ACTIONS(6371),
    [sym_global_variable] = ACTIONS(6371),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6369),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6369),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3828] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(1633),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1638),
    [sym_scope_resolution] = STATE(1634),
    [sym_call] = STATE(1634),
    [sym_method_call] = STATE(1638),
    [sym_argument_list] = STATE(1318),
    [sym__argument_list_with_parens] = STATE(6526),
    [sym__argument] = STATE(6527),
    [sym_splat_argument] = STATE(6527),
    [sym_hash_splat_argument] = STATE(6527),
    [sym_block_argument] = STATE(6527),
    [sym_assignment] = STATE(1633),
    [sym_operator_assignment] = STATE(1633),
    [sym_conditional] = STATE(1633),
    [sym_range] = STATE(1633),
    [sym_binary] = STATE(1633),
    [sym_unary] = STATE(1633),
    [sym_left_assignment_list] = STATE(1637),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1638),
    [sym__variable] = STATE(1634),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1638),
    [sym_false] = STATE(1638),
    [sym_nil] = STATE(1638),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1639),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(6527),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(2900),
    [sym__splat_star] = ACTIONS(2902),
    [sym__unary_minus] = ACTIONS(2904),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(2906),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(2910),
    [anon_sym_break] = ACTIONS(2912),
    [anon_sym_next] = ACTIONS(2914),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(2916),
    [anon_sym_not] = ACTIONS(2918),
    [anon_sym_BANG] = ACTIONS(2920),
    [anon_sym_TILDE] = ACTIONS(2922),
    [sym_constant] = ACTIONS(2924),
    [sym_identifier] = ACTIONS(2924),
    [sym_instance_variable] = ACTIONS(2926),
    [sym_class_variable] = ACTIONS(2926),
    [sym_global_variable] = ACTIONS(2926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2928),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2928),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3829] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(1633),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1638),
    [sym_scope_resolution] = STATE(1634),
    [sym_call] = STATE(1634),
    [sym_method_call] = STATE(1638),
    [sym_argument_list] = STATE(1324),
    [sym__argument_list_with_parens] = STATE(6526),
    [sym__argument] = STATE(6527),
    [sym_splat_argument] = STATE(6527),
    [sym_hash_splat_argument] = STATE(6527),
    [sym_block_argument] = STATE(6527),
    [sym_assignment] = STATE(1633),
    [sym_operator_assignment] = STATE(1633),
    [sym_conditional] = STATE(1633),
    [sym_range] = STATE(1633),
    [sym_binary] = STATE(1633),
    [sym_unary] = STATE(1633),
    [sym_left_assignment_list] = STATE(1637),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1638),
    [sym__variable] = STATE(1634),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1638),
    [sym_false] = STATE(1638),
    [sym_nil] = STATE(1638),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1639),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(6527),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(2900),
    [sym__splat_star] = ACTIONS(2902),
    [sym__unary_minus] = ACTIONS(2904),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(2906),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(2910),
    [anon_sym_break] = ACTIONS(2912),
    [anon_sym_next] = ACTIONS(2914),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(2916),
    [anon_sym_not] = ACTIONS(2918),
    [anon_sym_BANG] = ACTIONS(2920),
    [anon_sym_TILDE] = ACTIONS(2922),
    [sym_constant] = ACTIONS(2924),
    [sym_identifier] = ACTIONS(2924),
    [sym_instance_variable] = ACTIONS(2926),
    [sym_class_variable] = ACTIONS(2926),
    [sym_global_variable] = ACTIONS(2926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2928),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2928),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3830] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(1633),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1638),
    [sym_scope_resolution] = STATE(1634),
    [sym_call] = STATE(1634),
    [sym_method_call] = STATE(1638),
    [sym_argument_list] = STATE(1325),
    [sym__argument_list_with_parens] = STATE(6526),
    [sym__argument] = STATE(6527),
    [sym_splat_argument] = STATE(6527),
    [sym_hash_splat_argument] = STATE(6527),
    [sym_block_argument] = STATE(6527),
    [sym_assignment] = STATE(1633),
    [sym_operator_assignment] = STATE(1633),
    [sym_conditional] = STATE(1633),
    [sym_range] = STATE(1633),
    [sym_binary] = STATE(1633),
    [sym_unary] = STATE(1633),
    [sym_left_assignment_list] = STATE(1637),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1638),
    [sym__variable] = STATE(1634),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1638),
    [sym_false] = STATE(1638),
    [sym_nil] = STATE(1638),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1639),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(6527),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(2900),
    [sym__splat_star] = ACTIONS(2902),
    [sym__unary_minus] = ACTIONS(2904),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(2906),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(2910),
    [anon_sym_break] = ACTIONS(2912),
    [anon_sym_next] = ACTIONS(2914),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(2916),
    [anon_sym_not] = ACTIONS(2918),
    [anon_sym_BANG] = ACTIONS(2920),
    [anon_sym_TILDE] = ACTIONS(2922),
    [sym_constant] = ACTIONS(2924),
    [sym_identifier] = ACTIONS(2924),
    [sym_instance_variable] = ACTIONS(2926),
    [sym_class_variable] = ACTIONS(2926),
    [sym_global_variable] = ACTIONS(2926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2928),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2928),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3831] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(1633),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1638),
    [sym_scope_resolution] = STATE(1634),
    [sym_call] = STATE(1634),
    [sym_method_call] = STATE(1638),
    [sym_argument_list] = STATE(1326),
    [sym__argument_list_with_parens] = STATE(6526),
    [sym__argument] = STATE(6527),
    [sym_splat_argument] = STATE(6527),
    [sym_hash_splat_argument] = STATE(6527),
    [sym_block_argument] = STATE(6527),
    [sym_assignment] = STATE(1633),
    [sym_operator_assignment] = STATE(1633),
    [sym_conditional] = STATE(1633),
    [sym_range] = STATE(1633),
    [sym_binary] = STATE(1633),
    [sym_unary] = STATE(1633),
    [sym_left_assignment_list] = STATE(1637),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1638),
    [sym__variable] = STATE(1634),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1638),
    [sym_false] = STATE(1638),
    [sym_nil] = STATE(1638),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1639),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(6527),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(2900),
    [sym__splat_star] = ACTIONS(2902),
    [sym__unary_minus] = ACTIONS(2904),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(2906),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(2910),
    [anon_sym_break] = ACTIONS(2912),
    [anon_sym_next] = ACTIONS(2914),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(2916),
    [anon_sym_not] = ACTIONS(2918),
    [anon_sym_BANG] = ACTIONS(2920),
    [anon_sym_TILDE] = ACTIONS(2922),
    [sym_constant] = ACTIONS(2924),
    [sym_identifier] = ACTIONS(2924),
    [sym_instance_variable] = ACTIONS(2926),
    [sym_class_variable] = ACTIONS(2926),
    [sym_global_variable] = ACTIONS(2926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2928),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2928),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3832] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(6528),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(3837),
    [sym_scope_resolution] = STATE(3835),
    [sym_call] = STATE(3835),
    [sym_method_call] = STATE(3837),
    [sym_assignment] = STATE(6528),
    [sym_operator_assignment] = STATE(6528),
    [sym_conditional] = STATE(6528),
    [sym_range] = STATE(6528),
    [sym_binary] = STATE(6528),
    [sym_unary] = STATE(6528),
    [sym_left_assignment_list] = STATE(3836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3837),
    [sym__variable] = STATE(3835),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(3837),
    [sym_false] = STATE(3837),
    [sym_nil] = STATE(3837),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(3838),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6351),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6353),
    [anon_sym_yield] = ACTIONS(6355),
    [anon_sym_break] = ACTIONS(6357),
    [anon_sym_next] = ACTIONS(6359),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6361),
    [anon_sym_defined_QMARK] = ACTIONS(6363),
    [anon_sym_not] = ACTIONS(6365),
    [anon_sym_BANG] = ACTIONS(6367),
    [anon_sym_TILDE] = ACTIONS(6367),
    [sym_constant] = ACTIONS(6369),
    [sym_identifier] = ACTIONS(6369),
    [sym_instance_variable] = ACTIONS(6371),
    [sym_class_variable] = ACTIONS(6371),
    [sym_global_variable] = ACTIONS(6371),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6369),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6369),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3833] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(1872),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(3837),
    [sym_scope_resolution] = STATE(3835),
    [sym_call] = STATE(3835),
    [sym_method_call] = STATE(3837),
    [sym_assignment] = STATE(1872),
    [sym_operator_assignment] = STATE(1872),
    [sym_conditional] = STATE(1872),
    [sym_range] = STATE(1872),
    [sym_binary] = STATE(1872),
    [sym_unary] = STATE(1872),
    [sym_left_assignment_list] = STATE(3836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3837),
    [sym__variable] = STATE(3835),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(3837),
    [sym_false] = STATE(3837),
    [sym_nil] = STATE(3837),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(3838),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6351),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6353),
    [anon_sym_yield] = ACTIONS(6355),
    [anon_sym_break] = ACTIONS(6357),
    [anon_sym_next] = ACTIONS(6359),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6361),
    [anon_sym_defined_QMARK] = ACTIONS(6363),
    [anon_sym_not] = ACTIONS(6365),
    [anon_sym_BANG] = ACTIONS(6367),
    [anon_sym_TILDE] = ACTIONS(6367),
    [sym_constant] = ACTIONS(6369),
    [sym_identifier] = ACTIONS(6369),
    [sym_instance_variable] = ACTIONS(6371),
    [sym_class_variable] = ACTIONS(6371),
    [sym_global_variable] = ACTIONS(6371),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6369),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6369),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3834] = {
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(10017),
    [sym__binary_star] = ACTIONS(10019),
    [anon_sym_RBRACE] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(10021),
    [anon_sym_STAR_STAR] = ACTIONS(10019),
    [anon_sym_AMP] = ACTIONS(10023),
    [anon_sym_LT] = ACTIONS(10025),
    [anon_sym_if] = ACTIONS(4211),
    [anon_sym_unless] = ACTIONS(4211),
    [anon_sym_while] = ACTIONS(4211),
    [anon_sym_until] = ACTIONS(4211),
    [anon_sym_rescue] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(10027),
    [anon_sym_DOT_DOT] = ACTIONS(10029),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10031),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(10033),
    [anon_sym_AMP_AMP] = ACTIONS(10033),
    [anon_sym_LT_LT] = ACTIONS(10035),
    [anon_sym_GT_GT] = ACTIONS(10035),
    [anon_sym_EQ_EQ] = ACTIONS(10037),
    [anon_sym_BANG_EQ] = ACTIONS(10033),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10033),
    [anon_sym_LT_EQ_GT] = ACTIONS(10033),
    [anon_sym_EQ_TILDE] = ACTIONS(10033),
    [anon_sym_BANG_TILDE] = ACTIONS(10033),
    [anon_sym_LT_EQ] = ACTIONS(10025),
    [anon_sym_GT] = ACTIONS(10025),
    [anon_sym_GT_EQ] = ACTIONS(10039),
    [anon_sym_CARET] = ACTIONS(10041),
    [anon_sym_PLUS] = ACTIONS(10017),
    [anon_sym_SLASH] = ACTIONS(10019),
    [anon_sym_PERCENT] = ACTIONS(10019),
    [sym_comment] = ACTIONS(87),
  },
  [3835] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1679),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1686),
    [sym_scope_resolution] = STATE(1680),
    [sym_call] = STATE(1680),
    [sym_method_call] = STATE(1686),
    [sym_argument_list] = STATE(1846),
    [sym__argument_list_with_parens] = STATE(1682),
    [sym__argument] = STATE(1683),
    [sym_splat_argument] = STATE(1683),
    [sym_hash_splat_argument] = STATE(1683),
    [sym_block_argument] = STATE(1683),
    [sym_do_block] = STATE(1849),
    [sym_block] = STATE(1849),
    [sym_assignment] = STATE(1679),
    [sym_operator_assignment] = STATE(1679),
    [sym_conditional] = STATE(1679),
    [sym_range] = STATE(1679),
    [sym_binary] = STATE(1679),
    [sym_unary] = STATE(1679),
    [sym_left_assignment_list] = STATE(1685),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1686),
    [sym__variable] = STATE(1680),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1686),
    [sym_false] = STATE(1686),
    [sym_nil] = STATE(1686),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1687),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(1683),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(2988),
    [sym__splat_star] = ACTIONS(2990),
    [sym__unary_minus] = ACTIONS(2992),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(2994),
    [anon_sym_LBRACE] = ACTIONS(3327),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2998),
    [anon_sym_yield] = ACTIONS(3000),
    [anon_sym_break] = ACTIONS(3002),
    [anon_sym_next] = ACTIONS(3004),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(769),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(769),
    [anon_sym_until] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(769),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(3337),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(3010),
    [anon_sym_not] = ACTIONS(3012),
    [anon_sym_BANG] = ACTIONS(3014),
    [anon_sym_TILDE] = ACTIONS(3016),
    [sym_constant] = ACTIONS(3018),
    [sym_identifier] = ACTIONS(3018),
    [sym_instance_variable] = ACTIONS(3020),
    [sym_class_variable] = ACTIONS(3020),
    [sym_global_variable] = ACTIONS(3020),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3022),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3022),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3836] = {
    [anon_sym_EQ] = ACTIONS(10043),
    [sym_comment] = ACTIONS(87),
  },
  [3837] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(10045),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(10047),
    [anon_sym_DASH_EQ] = ACTIONS(10047),
    [anon_sym_STAR_EQ] = ACTIONS(10047),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10047),
    [anon_sym_SLASH_EQ] = ACTIONS(10047),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10047),
    [anon_sym_PIPE_EQ] = ACTIONS(10047),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10047),
    [anon_sym_AMP_EQ] = ACTIONS(10047),
    [anon_sym_PERCENT_EQ] = ACTIONS(10047),
    [anon_sym_GT_GT_EQ] = ACTIONS(10047),
    [anon_sym_LT_LT_EQ] = ACTIONS(10047),
    [anon_sym_CARET_EQ] = ACTIONS(10047),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3838] = {
    [sym_string] = STATE(6541),
    [aux_sym_chained_string_repeat1] = STATE(6541),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [3839] = {
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(10017),
    [sym__binary_star] = ACTIONS(10019),
    [anon_sym_RBRACE] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(10021),
    [anon_sym_STAR_STAR] = ACTIONS(10019),
    [anon_sym_AMP] = ACTIONS(10023),
    [anon_sym_LT] = ACTIONS(10025),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(10027),
    [anon_sym_DOT_DOT] = ACTIONS(10029),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10031),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(10033),
    [anon_sym_AMP_AMP] = ACTIONS(10033),
    [anon_sym_LT_LT] = ACTIONS(10035),
    [anon_sym_GT_GT] = ACTIONS(10035),
    [anon_sym_EQ_EQ] = ACTIONS(10037),
    [anon_sym_BANG_EQ] = ACTIONS(10033),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10033),
    [anon_sym_LT_EQ_GT] = ACTIONS(10033),
    [anon_sym_EQ_TILDE] = ACTIONS(10033),
    [anon_sym_BANG_TILDE] = ACTIONS(10033),
    [anon_sym_LT_EQ] = ACTIONS(10025),
    [anon_sym_GT] = ACTIONS(10025),
    [anon_sym_GT_EQ] = ACTIONS(10039),
    [anon_sym_CARET] = ACTIONS(10041),
    [anon_sym_PLUS] = ACTIONS(10017),
    [anon_sym_SLASH] = ACTIONS(10019),
    [anon_sym_PERCENT] = ACTIONS(10019),
    [sym_comment] = ACTIONS(87),
  },
  [3840] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(6389),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [3841] = {
    [sym_string] = STATE(3879),
    [aux_sym_chained_string_repeat1] = STATE(3879),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [3842] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(6542),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(3837),
    [sym_scope_resolution] = STATE(3835),
    [sym_call] = STATE(3835),
    [sym_method_call] = STATE(3837),
    [sym_assignment] = STATE(6542),
    [sym_operator_assignment] = STATE(6542),
    [sym_conditional] = STATE(6542),
    [sym_range] = STATE(6542),
    [sym_binary] = STATE(6542),
    [sym_unary] = STATE(6542),
    [sym_left_assignment_list] = STATE(3836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3837),
    [sym__variable] = STATE(3835),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(3837),
    [sym_false] = STATE(3837),
    [sym_nil] = STATE(3837),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(3838),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6351),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6353),
    [anon_sym_yield] = ACTIONS(6355),
    [anon_sym_break] = ACTIONS(6357),
    [anon_sym_next] = ACTIONS(6359),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6361),
    [anon_sym_defined_QMARK] = ACTIONS(6363),
    [anon_sym_not] = ACTIONS(6365),
    [anon_sym_BANG] = ACTIONS(6367),
    [anon_sym_TILDE] = ACTIONS(6367),
    [sym_constant] = ACTIONS(6369),
    [sym_identifier] = ACTIONS(6369),
    [sym_instance_variable] = ACTIONS(6371),
    [sym_class_variable] = ACTIONS(6371),
    [sym_global_variable] = ACTIONS(6371),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6369),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6369),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3843] = {
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(10017),
    [sym__binary_star] = ACTIONS(10019),
    [anon_sym_RBRACE] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(10021),
    [anon_sym_STAR_STAR] = ACTIONS(10019),
    [anon_sym_AMP] = ACTIONS(10023),
    [anon_sym_LT] = ACTIONS(10025),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_unless] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_until] = ACTIONS(3281),
    [anon_sym_rescue] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(10027),
    [anon_sym_DOT_DOT] = ACTIONS(10029),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10031),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(10033),
    [anon_sym_AMP_AMP] = ACTIONS(10033),
    [anon_sym_LT_LT] = ACTIONS(10035),
    [anon_sym_GT_GT] = ACTIONS(10035),
    [anon_sym_EQ_EQ] = ACTIONS(10037),
    [anon_sym_BANG_EQ] = ACTIONS(10033),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10033),
    [anon_sym_LT_EQ_GT] = ACTIONS(10033),
    [anon_sym_EQ_TILDE] = ACTIONS(10033),
    [anon_sym_BANG_TILDE] = ACTIONS(10033),
    [anon_sym_LT_EQ] = ACTIONS(10025),
    [anon_sym_GT] = ACTIONS(10025),
    [anon_sym_GT_EQ] = ACTIONS(10039),
    [anon_sym_CARET] = ACTIONS(10041),
    [anon_sym_PLUS] = ACTIONS(10017),
    [anon_sym_SLASH] = ACTIONS(10019),
    [anon_sym_PERCENT] = ACTIONS(10019),
    [sym_comment] = ACTIONS(87),
  },
  [3844] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(6543),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1638),
    [sym_scope_resolution] = STATE(1634),
    [sym_call] = STATE(1634),
    [sym_method_call] = STATE(1638),
    [sym_assignment] = STATE(6543),
    [sym_operator_assignment] = STATE(6543),
    [sym_conditional] = STATE(6543),
    [sym_range] = STATE(6543),
    [sym_binary] = STATE(6543),
    [sym_unary] = STATE(6543),
    [sym_left_assignment_list] = STATE(1637),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1638),
    [sym__variable] = STATE(1634),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1638),
    [sym_false] = STATE(1638),
    [sym_nil] = STATE(1638),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(3841),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(2910),
    [anon_sym_break] = ACTIONS(2912),
    [anon_sym_next] = ACTIONS(2914),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6373),
    [anon_sym_defined_QMARK] = ACTIONS(2916),
    [anon_sym_not] = ACTIONS(2918),
    [anon_sym_BANG] = ACTIONS(2922),
    [anon_sym_TILDE] = ACTIONS(2922),
    [sym_constant] = ACTIONS(2928),
    [sym_identifier] = ACTIONS(2928),
    [sym_instance_variable] = ACTIONS(2926),
    [sym_class_variable] = ACTIONS(2926),
    [sym_global_variable] = ACTIONS(2926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2928),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2928),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3845] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(6544),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1638),
    [sym_scope_resolution] = STATE(1634),
    [sym_call] = STATE(1634),
    [sym_method_call] = STATE(1638),
    [sym_assignment] = STATE(6544),
    [sym_operator_assignment] = STATE(6544),
    [sym_conditional] = STATE(6544),
    [sym_range] = STATE(6544),
    [sym_binary] = STATE(6544),
    [sym_unary] = STATE(6544),
    [sym_left_assignment_list] = STATE(1637),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1638),
    [sym__variable] = STATE(1634),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1638),
    [sym_false] = STATE(1638),
    [sym_nil] = STATE(1638),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(3841),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(2910),
    [anon_sym_break] = ACTIONS(2912),
    [anon_sym_next] = ACTIONS(2914),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6373),
    [anon_sym_defined_QMARK] = ACTIONS(2916),
    [anon_sym_not] = ACTIONS(2918),
    [anon_sym_BANG] = ACTIONS(2922),
    [anon_sym_TILDE] = ACTIONS(2922),
    [sym_constant] = ACTIONS(2928),
    [sym_identifier] = ACTIONS(2928),
    [sym_instance_variable] = ACTIONS(2926),
    [sym_class_variable] = ACTIONS(2926),
    [sym_global_variable] = ACTIONS(2926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2928),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2928),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3846] = {
    [anon_sym_COLON] = ACTIONS(10049),
    [sym_comment] = ACTIONS(87),
  },
  [3847] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(6546),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1638),
    [sym_scope_resolution] = STATE(1634),
    [sym_call] = STATE(1634),
    [sym_method_call] = STATE(1638),
    [sym_assignment] = STATE(6546),
    [sym_operator_assignment] = STATE(6546),
    [sym_conditional] = STATE(6546),
    [sym_range] = STATE(6546),
    [sym_binary] = STATE(6546),
    [sym_unary] = STATE(6546),
    [sym_left_assignment_list] = STATE(1637),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1638),
    [sym__variable] = STATE(1634),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1638),
    [sym_false] = STATE(1638),
    [sym_nil] = STATE(1638),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(3841),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(2910),
    [anon_sym_break] = ACTIONS(2912),
    [anon_sym_next] = ACTIONS(2914),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6373),
    [anon_sym_defined_QMARK] = ACTIONS(2916),
    [anon_sym_not] = ACTIONS(2918),
    [anon_sym_BANG] = ACTIONS(2922),
    [anon_sym_TILDE] = ACTIONS(2922),
    [sym_constant] = ACTIONS(2928),
    [sym_identifier] = ACTIONS(2928),
    [sym_instance_variable] = ACTIONS(2926),
    [sym_class_variable] = ACTIONS(2926),
    [sym_global_variable] = ACTIONS(2926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2928),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2928),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3848] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(10051),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [3849] = {
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(6387),
    [sym__binary_star] = ACTIONS(6389),
    [anon_sym_RBRACE] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(6391),
    [anon_sym_STAR_STAR] = ACTIONS(6389),
    [anon_sym_AMP] = ACTIONS(6393),
    [anon_sym_LT] = ACTIONS(6395),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_unless] = ACTIONS(1625),
    [anon_sym_while] = ACTIONS(1625),
    [anon_sym_until] = ACTIONS(1625),
    [anon_sym_rescue] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(1625),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(6397),
    [anon_sym_DOT_DOT] = ACTIONS(6399),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6401),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(6403),
    [anon_sym_AMP_AMP] = ACTIONS(6403),
    [anon_sym_LT_LT] = ACTIONS(6405),
    [anon_sym_GT_GT] = ACTIONS(6405),
    [anon_sym_EQ_EQ] = ACTIONS(6407),
    [anon_sym_BANG_EQ] = ACTIONS(6403),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6403),
    [anon_sym_LT_EQ_GT] = ACTIONS(6403),
    [anon_sym_EQ_TILDE] = ACTIONS(6403),
    [anon_sym_BANG_TILDE] = ACTIONS(6403),
    [anon_sym_LT_EQ] = ACTIONS(6395),
    [anon_sym_GT] = ACTIONS(6395),
    [anon_sym_GT_EQ] = ACTIONS(6409),
    [anon_sym_CARET] = ACTIONS(6411),
    [anon_sym_PLUS] = ACTIONS(6387),
    [anon_sym_SLASH] = ACTIONS(6389),
    [anon_sym_PERCENT] = ACTIONS(6389),
    [sym_comment] = ACTIONS(87),
  },
  [3850] = {
    [sym_heredoc_body] = STATE(6548),
    [aux_sym_call_repeat1] = STATE(6548),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_RBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [3851] = {
    [sym_heredoc_body] = STATE(6548),
    [aux_sym_call_repeat1] = STATE(6548),
    [aux_sym_argument_list_repeat1] = STATE(6550),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_RBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(10053),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [3852] = {
    [sym_string] = STATE(3879),
    [aux_sym_chained_string_repeat1] = STATE(3879),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(10055),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [3853] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(6387),
    [sym__binary_star] = ACTIONS(6389),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(6391),
    [anon_sym_STAR_STAR] = ACTIONS(6389),
    [anon_sym_AMP] = ACTIONS(6393),
    [anon_sym_LT] = ACTIONS(6395),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(6397),
    [anon_sym_DOT_DOT] = ACTIONS(6399),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6401),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(6403),
    [anon_sym_AMP_AMP] = ACTIONS(6403),
    [anon_sym_LT_LT] = ACTIONS(6405),
    [anon_sym_GT_GT] = ACTIONS(6405),
    [anon_sym_EQ_EQ] = ACTIONS(6407),
    [anon_sym_BANG_EQ] = ACTIONS(6403),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6403),
    [anon_sym_LT_EQ_GT] = ACTIONS(6403),
    [anon_sym_EQ_TILDE] = ACTIONS(6403),
    [anon_sym_BANG_TILDE] = ACTIONS(6403),
    [anon_sym_LT_EQ] = ACTIONS(6395),
    [anon_sym_GT] = ACTIONS(6395),
    [anon_sym_GT_EQ] = ACTIONS(6409),
    [anon_sym_CARET] = ACTIONS(6411),
    [anon_sym_PLUS] = ACTIONS(6387),
    [anon_sym_SLASH] = ACTIONS(6389),
    [anon_sym_PERCENT] = ACTIONS(6389),
    [sym_comment] = ACTIONS(87),
  },
  [3854] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(6551),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(3837),
    [sym_scope_resolution] = STATE(3835),
    [sym_call] = STATE(3835),
    [sym_method_call] = STATE(3837),
    [sym_assignment] = STATE(6551),
    [sym_operator_assignment] = STATE(6551),
    [sym_conditional] = STATE(6551),
    [sym_range] = STATE(6551),
    [sym_binary] = STATE(6551),
    [sym_unary] = STATE(6551),
    [sym_left_assignment_list] = STATE(3836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3837),
    [sym__variable] = STATE(3835),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(3837),
    [sym_false] = STATE(3837),
    [sym_nil] = STATE(3837),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(3838),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6351),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6353),
    [anon_sym_yield] = ACTIONS(6355),
    [anon_sym_break] = ACTIONS(6357),
    [anon_sym_next] = ACTIONS(6359),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6361),
    [anon_sym_defined_QMARK] = ACTIONS(6363),
    [anon_sym_not] = ACTIONS(6365),
    [anon_sym_BANG] = ACTIONS(6367),
    [anon_sym_TILDE] = ACTIONS(6367),
    [sym_constant] = ACTIONS(6369),
    [sym_identifier] = ACTIONS(6369),
    [sym_instance_variable] = ACTIONS(6371),
    [sym_class_variable] = ACTIONS(6371),
    [sym_global_variable] = ACTIONS(6371),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6369),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6369),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3855] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(6552),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1638),
    [sym_scope_resolution] = STATE(1634),
    [sym_call] = STATE(1634),
    [sym_method_call] = STATE(1638),
    [sym_assignment] = STATE(6552),
    [sym_operator_assignment] = STATE(6552),
    [sym_conditional] = STATE(6552),
    [sym_range] = STATE(6552),
    [sym_binary] = STATE(6552),
    [sym_unary] = STATE(6552),
    [sym_left_assignment_list] = STATE(1637),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1638),
    [sym__variable] = STATE(1634),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1638),
    [sym_false] = STATE(1638),
    [sym_nil] = STATE(1638),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(3841),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(2910),
    [anon_sym_break] = ACTIONS(2912),
    [anon_sym_next] = ACTIONS(2914),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6373),
    [anon_sym_defined_QMARK] = ACTIONS(2916),
    [anon_sym_not] = ACTIONS(2918),
    [anon_sym_BANG] = ACTIONS(2922),
    [anon_sym_TILDE] = ACTIONS(2922),
    [sym_constant] = ACTIONS(2928),
    [sym_identifier] = ACTIONS(2928),
    [sym_instance_variable] = ACTIONS(2926),
    [sym_class_variable] = ACTIONS(2926),
    [sym_global_variable] = ACTIONS(2926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2928),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2928),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3856] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(6553),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1638),
    [sym_scope_resolution] = STATE(1634),
    [sym_call] = STATE(1634),
    [sym_method_call] = STATE(1638),
    [sym_assignment] = STATE(6553),
    [sym_operator_assignment] = STATE(6553),
    [sym_conditional] = STATE(6553),
    [sym_range] = STATE(6553),
    [sym_binary] = STATE(6553),
    [sym_unary] = STATE(6553),
    [sym_left_assignment_list] = STATE(1637),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1638),
    [sym__variable] = STATE(1634),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1638),
    [sym_false] = STATE(1638),
    [sym_nil] = STATE(1638),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(3841),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(2910),
    [anon_sym_break] = ACTIONS(2912),
    [anon_sym_next] = ACTIONS(2914),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6373),
    [anon_sym_defined_QMARK] = ACTIONS(2916),
    [anon_sym_not] = ACTIONS(2918),
    [anon_sym_BANG] = ACTIONS(2922),
    [anon_sym_TILDE] = ACTIONS(2922),
    [sym_constant] = ACTIONS(2928),
    [sym_identifier] = ACTIONS(2928),
    [sym_instance_variable] = ACTIONS(2926),
    [sym_class_variable] = ACTIONS(2926),
    [sym_global_variable] = ACTIONS(2926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2928),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2928),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3857] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(6554),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1638),
    [sym_scope_resolution] = STATE(1634),
    [sym_call] = STATE(1634),
    [sym_method_call] = STATE(1638),
    [sym_assignment] = STATE(6554),
    [sym_operator_assignment] = STATE(6554),
    [sym_conditional] = STATE(6554),
    [sym_range] = STATE(6554),
    [sym_binary] = STATE(6554),
    [sym_unary] = STATE(6554),
    [sym_left_assignment_list] = STATE(1637),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1638),
    [sym__variable] = STATE(1634),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1638),
    [sym_false] = STATE(1638),
    [sym_nil] = STATE(1638),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(3841),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(2910),
    [anon_sym_break] = ACTIONS(2912),
    [anon_sym_next] = ACTIONS(2914),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6373),
    [anon_sym_defined_QMARK] = ACTIONS(2916),
    [anon_sym_not] = ACTIONS(2918),
    [anon_sym_BANG] = ACTIONS(2922),
    [anon_sym_TILDE] = ACTIONS(2922),
    [sym_constant] = ACTIONS(2928),
    [sym_identifier] = ACTIONS(2928),
    [sym_instance_variable] = ACTIONS(2926),
    [sym_class_variable] = ACTIONS(2926),
    [sym_global_variable] = ACTIONS(2926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2928),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2928),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3858] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(6555),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1638),
    [sym_scope_resolution] = STATE(1634),
    [sym_call] = STATE(1634),
    [sym_method_call] = STATE(1638),
    [sym_assignment] = STATE(6555),
    [sym_operator_assignment] = STATE(6555),
    [sym_conditional] = STATE(6555),
    [sym_range] = STATE(6555),
    [sym_binary] = STATE(6555),
    [sym_unary] = STATE(6555),
    [sym_left_assignment_list] = STATE(1637),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1638),
    [sym__variable] = STATE(1634),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1638),
    [sym_false] = STATE(1638),
    [sym_nil] = STATE(1638),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(3841),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(2910),
    [anon_sym_break] = ACTIONS(2912),
    [anon_sym_next] = ACTIONS(2914),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6373),
    [anon_sym_defined_QMARK] = ACTIONS(2916),
    [anon_sym_not] = ACTIONS(2918),
    [anon_sym_BANG] = ACTIONS(2922),
    [anon_sym_TILDE] = ACTIONS(2922),
    [sym_constant] = ACTIONS(2928),
    [sym_identifier] = ACTIONS(2928),
    [sym_instance_variable] = ACTIONS(2926),
    [sym_class_variable] = ACTIONS(2926),
    [sym_global_variable] = ACTIONS(2926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2928),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2928),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3859] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(6556),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1638),
    [sym_scope_resolution] = STATE(1634),
    [sym_call] = STATE(1634),
    [sym_method_call] = STATE(1638),
    [sym_assignment] = STATE(6556),
    [sym_operator_assignment] = STATE(6556),
    [sym_conditional] = STATE(6556),
    [sym_range] = STATE(6556),
    [sym_binary] = STATE(6556),
    [sym_unary] = STATE(6556),
    [sym_left_assignment_list] = STATE(1637),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1638),
    [sym__variable] = STATE(1634),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1638),
    [sym_false] = STATE(1638),
    [sym_nil] = STATE(1638),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(3841),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(2910),
    [anon_sym_break] = ACTIONS(2912),
    [anon_sym_next] = ACTIONS(2914),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6373),
    [anon_sym_defined_QMARK] = ACTIONS(2916),
    [anon_sym_not] = ACTIONS(2918),
    [anon_sym_BANG] = ACTIONS(2922),
    [anon_sym_TILDE] = ACTIONS(2922),
    [sym_constant] = ACTIONS(2928),
    [sym_identifier] = ACTIONS(2928),
    [sym_instance_variable] = ACTIONS(2926),
    [sym_class_variable] = ACTIONS(2926),
    [sym_global_variable] = ACTIONS(2926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2928),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2928),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3860] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(6557),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(6557),
    [sym_operator_assignment] = STATE(6557),
    [sym_conditional] = STATE(6557),
    [sym_range] = STATE(6557),
    [sym_binary] = STATE(6557),
    [sym_unary] = STATE(6557),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3861] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(6558),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1638),
    [sym_scope_resolution] = STATE(1634),
    [sym_call] = STATE(1634),
    [sym_method_call] = STATE(1638),
    [sym_assignment] = STATE(6558),
    [sym_operator_assignment] = STATE(6558),
    [sym_conditional] = STATE(6558),
    [sym_range] = STATE(6558),
    [sym_binary] = STATE(6558),
    [sym_unary] = STATE(6558),
    [sym_left_assignment_list] = STATE(1637),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1638),
    [sym__variable] = STATE(1634),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1638),
    [sym_false] = STATE(1638),
    [sym_nil] = STATE(1638),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(3841),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(2910),
    [anon_sym_break] = ACTIONS(2912),
    [anon_sym_next] = ACTIONS(2914),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6373),
    [anon_sym_defined_QMARK] = ACTIONS(2916),
    [anon_sym_not] = ACTIONS(2918),
    [anon_sym_BANG] = ACTIONS(2922),
    [anon_sym_TILDE] = ACTIONS(2922),
    [sym_constant] = ACTIONS(2928),
    [sym_identifier] = ACTIONS(2928),
    [sym_instance_variable] = ACTIONS(2926),
    [sym_class_variable] = ACTIONS(2926),
    [sym_global_variable] = ACTIONS(2926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2928),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2928),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3862] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(6559),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1638),
    [sym_scope_resolution] = STATE(1634),
    [sym_call] = STATE(1634),
    [sym_method_call] = STATE(1638),
    [sym_assignment] = STATE(6559),
    [sym_operator_assignment] = STATE(6559),
    [sym_conditional] = STATE(6559),
    [sym_range] = STATE(6559),
    [sym_binary] = STATE(6559),
    [sym_unary] = STATE(6559),
    [sym_left_assignment_list] = STATE(1637),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1638),
    [sym__variable] = STATE(1634),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1638),
    [sym_false] = STATE(1638),
    [sym_nil] = STATE(1638),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(3841),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(2910),
    [anon_sym_break] = ACTIONS(2912),
    [anon_sym_next] = ACTIONS(2914),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6373),
    [anon_sym_defined_QMARK] = ACTIONS(2916),
    [anon_sym_not] = ACTIONS(2918),
    [anon_sym_BANG] = ACTIONS(2922),
    [anon_sym_TILDE] = ACTIONS(2922),
    [sym_constant] = ACTIONS(2928),
    [sym_identifier] = ACTIONS(2928),
    [sym_instance_variable] = ACTIONS(2926),
    [sym_class_variable] = ACTIONS(2926),
    [sym_global_variable] = ACTIONS(2926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2928),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2928),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3863] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(6560),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1638),
    [sym_scope_resolution] = STATE(1634),
    [sym_call] = STATE(1634),
    [sym_method_call] = STATE(1638),
    [sym_assignment] = STATE(6560),
    [sym_operator_assignment] = STATE(6560),
    [sym_conditional] = STATE(6560),
    [sym_range] = STATE(6560),
    [sym_binary] = STATE(6560),
    [sym_unary] = STATE(6560),
    [sym_left_assignment_list] = STATE(1637),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1638),
    [sym__variable] = STATE(1634),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1638),
    [sym_false] = STATE(1638),
    [sym_nil] = STATE(1638),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(3841),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(2910),
    [anon_sym_break] = ACTIONS(2912),
    [anon_sym_next] = ACTIONS(2914),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6373),
    [anon_sym_defined_QMARK] = ACTIONS(2916),
    [anon_sym_not] = ACTIONS(2918),
    [anon_sym_BANG] = ACTIONS(2922),
    [anon_sym_TILDE] = ACTIONS(2922),
    [sym_constant] = ACTIONS(2928),
    [sym_identifier] = ACTIONS(2928),
    [sym_instance_variable] = ACTIONS(2926),
    [sym_class_variable] = ACTIONS(2926),
    [sym_global_variable] = ACTIONS(2926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2928),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2928),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3864] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(6561),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1638),
    [sym_scope_resolution] = STATE(1634),
    [sym_call] = STATE(1634),
    [sym_method_call] = STATE(1638),
    [sym_assignment] = STATE(6561),
    [sym_operator_assignment] = STATE(6561),
    [sym_conditional] = STATE(6561),
    [sym_range] = STATE(6561),
    [sym_binary] = STATE(6561),
    [sym_unary] = STATE(6561),
    [sym_left_assignment_list] = STATE(1637),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1638),
    [sym__variable] = STATE(1634),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1638),
    [sym_false] = STATE(1638),
    [sym_nil] = STATE(1638),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(3841),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(2910),
    [anon_sym_break] = ACTIONS(2912),
    [anon_sym_next] = ACTIONS(2914),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6373),
    [anon_sym_defined_QMARK] = ACTIONS(2916),
    [anon_sym_not] = ACTIONS(2918),
    [anon_sym_BANG] = ACTIONS(2922),
    [anon_sym_TILDE] = ACTIONS(2922),
    [sym_constant] = ACTIONS(2928),
    [sym_identifier] = ACTIONS(2928),
    [sym_instance_variable] = ACTIONS(2926),
    [sym_class_variable] = ACTIONS(2926),
    [sym_global_variable] = ACTIONS(2926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2928),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2928),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3865] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6562),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1686),
    [sym_scope_resolution] = STATE(1680),
    [sym_call] = STATE(1680),
    [sym_method_call] = STATE(1686),
    [sym_assignment] = STATE(6562),
    [sym_operator_assignment] = STATE(6562),
    [sym_conditional] = STATE(6562),
    [sym_range] = STATE(6562),
    [sym_binary] = STATE(6562),
    [sym_unary] = STATE(6562),
    [sym_left_assignment_list] = STATE(1685),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1686),
    [sym__variable] = STATE(1680),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1686),
    [sym_false] = STATE(1686),
    [sym_nil] = STATE(1686),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3944),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2992),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2998),
    [anon_sym_yield] = ACTIONS(3000),
    [anon_sym_break] = ACTIONS(3002),
    [anon_sym_next] = ACTIONS(3004),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6523),
    [anon_sym_defined_QMARK] = ACTIONS(3010),
    [anon_sym_not] = ACTIONS(3012),
    [anon_sym_BANG] = ACTIONS(3016),
    [anon_sym_TILDE] = ACTIONS(3016),
    [sym_constant] = ACTIONS(3022),
    [sym_identifier] = ACTIONS(3022),
    [sym_instance_variable] = ACTIONS(3020),
    [sym_class_variable] = ACTIONS(3020),
    [sym_global_variable] = ACTIONS(3020),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3022),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3022),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3866] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6563),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1686),
    [sym_scope_resolution] = STATE(1680),
    [sym_call] = STATE(1680),
    [sym_method_call] = STATE(1686),
    [sym_assignment] = STATE(6563),
    [sym_operator_assignment] = STATE(6563),
    [sym_conditional] = STATE(6563),
    [sym_range] = STATE(6563),
    [sym_binary] = STATE(6563),
    [sym_unary] = STATE(6563),
    [sym_left_assignment_list] = STATE(1685),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1686),
    [sym__variable] = STATE(1680),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1686),
    [sym_false] = STATE(1686),
    [sym_nil] = STATE(1686),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3944),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2992),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2998),
    [anon_sym_yield] = ACTIONS(3000),
    [anon_sym_break] = ACTIONS(3002),
    [anon_sym_next] = ACTIONS(3004),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6523),
    [anon_sym_defined_QMARK] = ACTIONS(3010),
    [anon_sym_not] = ACTIONS(3012),
    [anon_sym_BANG] = ACTIONS(3016),
    [anon_sym_TILDE] = ACTIONS(3016),
    [sym_constant] = ACTIONS(3022),
    [sym_identifier] = ACTIONS(3022),
    [sym_instance_variable] = ACTIONS(3020),
    [sym_class_variable] = ACTIONS(3020),
    [sym_global_variable] = ACTIONS(3020),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3022),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3022),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3867] = {
    [anon_sym_COLON] = ACTIONS(10057),
    [sym_comment] = ACTIONS(87),
  },
  [3868] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6565),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1686),
    [sym_scope_resolution] = STATE(1680),
    [sym_call] = STATE(1680),
    [sym_method_call] = STATE(1686),
    [sym_assignment] = STATE(6565),
    [sym_operator_assignment] = STATE(6565),
    [sym_conditional] = STATE(6565),
    [sym_range] = STATE(6565),
    [sym_binary] = STATE(6565),
    [sym_unary] = STATE(6565),
    [sym_left_assignment_list] = STATE(1685),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1686),
    [sym__variable] = STATE(1680),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1686),
    [sym_false] = STATE(1686),
    [sym_nil] = STATE(1686),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3944),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2992),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2998),
    [anon_sym_yield] = ACTIONS(3000),
    [anon_sym_break] = ACTIONS(3002),
    [anon_sym_next] = ACTIONS(3004),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6523),
    [anon_sym_defined_QMARK] = ACTIONS(3010),
    [anon_sym_not] = ACTIONS(3012),
    [anon_sym_BANG] = ACTIONS(3016),
    [anon_sym_TILDE] = ACTIONS(3016),
    [sym_constant] = ACTIONS(3022),
    [sym_identifier] = ACTIONS(3022),
    [sym_instance_variable] = ACTIONS(3020),
    [sym_class_variable] = ACTIONS(3020),
    [sym_global_variable] = ACTIONS(3020),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3022),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3022),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3869] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(10059),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [3870] = {
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(6537),
    [sym__binary_star] = ACTIONS(6539),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_RBRACE] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(6541),
    [anon_sym_STAR_STAR] = ACTIONS(6543),
    [anon_sym_AMP] = ACTIONS(6545),
    [anon_sym_EQ] = ACTIONS(1631),
    [anon_sym_LT] = ACTIONS(6547),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_unless] = ACTIONS(1625),
    [anon_sym_while] = ACTIONS(1625),
    [anon_sym_until] = ACTIONS(1625),
    [anon_sym_rescue] = ACTIONS(1625),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(1625),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_PLUS_EQ] = ACTIONS(1625),
    [anon_sym_DASH_EQ] = ACTIONS(1625),
    [anon_sym_STAR_EQ] = ACTIONS(1625),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1625),
    [anon_sym_SLASH_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1625),
    [anon_sym_AMP_EQ] = ACTIONS(1625),
    [anon_sym_PERCENT_EQ] = ACTIONS(1625),
    [anon_sym_GT_GT_EQ] = ACTIONS(1625),
    [anon_sym_LT_LT_EQ] = ACTIONS(1625),
    [anon_sym_CARET_EQ] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(6549),
    [anon_sym_DOT_DOT] = ACTIONS(6551),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6553),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(6555),
    [anon_sym_AMP_AMP] = ACTIONS(6555),
    [anon_sym_LT_LT] = ACTIONS(6557),
    [anon_sym_GT_GT] = ACTIONS(6557),
    [anon_sym_EQ_EQ] = ACTIONS(6555),
    [anon_sym_BANG_EQ] = ACTIONS(6559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6559),
    [anon_sym_LT_EQ_GT] = ACTIONS(6559),
    [anon_sym_EQ_TILDE] = ACTIONS(6559),
    [anon_sym_BANG_TILDE] = ACTIONS(6559),
    [anon_sym_LT_EQ] = ACTIONS(6547),
    [anon_sym_GT] = ACTIONS(6547),
    [anon_sym_GT_EQ] = ACTIONS(6561),
    [anon_sym_CARET] = ACTIONS(6541),
    [anon_sym_PLUS] = ACTIONS(6563),
    [anon_sym_SLASH] = ACTIONS(6543),
    [anon_sym_PERCENT] = ACTIONS(6543),
    [sym_comment] = ACTIONS(87),
  },
  [3871] = {
    [sym_heredoc_body] = STATE(6567),
    [aux_sym_call_repeat1] = STATE(6567),
    [sym__heredoc_body_start] = ACTIONS(3543),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_RBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [3872] = {
    [sym_heredoc_body] = STATE(6567),
    [aux_sym_call_repeat1] = STATE(6567),
    [aux_sym_argument_list_repeat1] = STATE(6569),
    [sym__heredoc_body_start] = ACTIONS(3543),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_RBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(10061),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [3873] = {
    [sym_string] = STATE(3976),
    [aux_sym_chained_string_repeat1] = STATE(3976),
    [sym__string_start] = ACTIONS(1141),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(10063),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3874] = {
    [sym_heredoc_body] = STATE(6570),
    [aux_sym_call_repeat1] = STATE(6570),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_RBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [3875] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(1633),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1638),
    [sym_scope_resolution] = STATE(1634),
    [sym_call] = STATE(1634),
    [sym_method_call] = STATE(1638),
    [sym__argument] = STATE(4250),
    [sym_splat_argument] = STATE(4250),
    [sym_hash_splat_argument] = STATE(4250),
    [sym_block_argument] = STATE(4250),
    [sym_assignment] = STATE(1633),
    [sym_operator_assignment] = STATE(1633),
    [sym_conditional] = STATE(1633),
    [sym_range] = STATE(1633),
    [sym_binary] = STATE(1633),
    [sym_unary] = STATE(1633),
    [sym_left_assignment_list] = STATE(1637),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1638),
    [sym__variable] = STATE(1634),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1638),
    [sym_false] = STATE(1638),
    [sym_nil] = STATE(1638),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1639),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_heredoc_body] = STATE(6571),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(4250),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(2900),
    [sym__splat_star] = ACTIONS(2902),
    [sym__unary_minus] = ACTIONS(2904),
    [sym__identifier_hash_key] = ACTIONS(2906),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10065),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(2910),
    [anon_sym_break] = ACTIONS(2912),
    [anon_sym_next] = ACTIONS(2914),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6373),
    [anon_sym_defined_QMARK] = ACTIONS(2916),
    [anon_sym_not] = ACTIONS(2918),
    [anon_sym_BANG] = ACTIONS(2922),
    [anon_sym_TILDE] = ACTIONS(2922),
    [sym_constant] = ACTIONS(2924),
    [sym_identifier] = ACTIONS(2924),
    [sym_instance_variable] = ACTIONS(2926),
    [sym_class_variable] = ACTIONS(2926),
    [sym_global_variable] = ACTIONS(2926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2928),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2928),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3876] = {
    [sym_heredoc_body] = STATE(6572),
    [aux_sym_call_repeat1] = STATE(6572),
    [aux_sym_argument_list_repeat1] = STATE(6573),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_RBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(6421),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [3877] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(6574),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1638),
    [sym_scope_resolution] = STATE(1634),
    [sym_call] = STATE(1634),
    [sym_method_call] = STATE(1638),
    [sym_splat_argument] = STATE(6575),
    [sym_assignment] = STATE(6574),
    [sym_operator_assignment] = STATE(6574),
    [sym_conditional] = STATE(6574),
    [sym_range] = STATE(6574),
    [sym_binary] = STATE(6574),
    [sym_unary] = STATE(6574),
    [sym_right_assignment_list] = STATE(4255),
    [sym__arg_or_splat_arg] = STATE(6575),
    [sym_left_assignment_list] = STATE(1637),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1638),
    [sym__variable] = STATE(1634),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1638),
    [sym_false] = STATE(1638),
    [sym_nil] = STATE(1638),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(3841),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(6379),
    [sym__unary_minus] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(2910),
    [anon_sym_break] = ACTIONS(2912),
    [anon_sym_next] = ACTIONS(2914),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6373),
    [anon_sym_defined_QMARK] = ACTIONS(2916),
    [anon_sym_not] = ACTIONS(2918),
    [anon_sym_BANG] = ACTIONS(2922),
    [anon_sym_TILDE] = ACTIONS(2922),
    [sym_constant] = ACTIONS(2928),
    [sym_identifier] = ACTIONS(2928),
    [sym_instance_variable] = ACTIONS(2926),
    [sym_class_variable] = ACTIONS(2926),
    [sym_global_variable] = ACTIONS(2926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2928),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2928),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3878] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(6576),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1638),
    [sym_scope_resolution] = STATE(1634),
    [sym_call] = STATE(1634),
    [sym_method_call] = STATE(1638),
    [sym_assignment] = STATE(6576),
    [sym_operator_assignment] = STATE(6576),
    [sym_conditional] = STATE(6576),
    [sym_range] = STATE(6576),
    [sym_binary] = STATE(6576),
    [sym_unary] = STATE(6576),
    [sym_left_assignment_list] = STATE(1637),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1638),
    [sym__variable] = STATE(1634),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1638),
    [sym_false] = STATE(1638),
    [sym_nil] = STATE(1638),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(3841),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(2910),
    [anon_sym_break] = ACTIONS(2912),
    [anon_sym_next] = ACTIONS(2914),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6373),
    [anon_sym_defined_QMARK] = ACTIONS(2916),
    [anon_sym_not] = ACTIONS(2918),
    [anon_sym_BANG] = ACTIONS(2922),
    [anon_sym_TILDE] = ACTIONS(2922),
    [sym_constant] = ACTIONS(2928),
    [sym_identifier] = ACTIONS(2928),
    [sym_instance_variable] = ACTIONS(2926),
    [sym_class_variable] = ACTIONS(2926),
    [sym_global_variable] = ACTIONS(2926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2928),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2928),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3879] = {
    [sym_string] = STATE(6577),
    [aux_sym_chained_string_repeat1] = STATE(6577),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_RBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_EQ_GT] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [3880] = {
    [anon_sym_RBRACE] = ACTIONS(3675),
    [anon_sym_COMMA] = ACTIONS(3675),
    [anon_sym_if] = ACTIONS(3675),
    [anon_sym_unless] = ACTIONS(3675),
    [anon_sym_while] = ACTIONS(3675),
    [anon_sym_until] = ACTIONS(3675),
    [anon_sym_rescue] = ACTIONS(3675),
    [sym_comment] = ACTIONS(87),
  },
  [3881] = {
    [sym_operator] = STATE(6578),
    [sym__method_name] = STATE(6578),
    [sym_setter] = STATE(6578),
    [sym_symbol] = STATE(6578),
    [sym__simple_symbol] = ACTIONS(279),
    [sym__symbol_start] = ACTIONS(283),
    [anon_sym_PIPE] = ACTIONS(2930),
    [anon_sym_STAR] = ACTIONS(2932),
    [anon_sym_STAR_STAR] = ACTIONS(2930),
    [anon_sym_AMP] = ACTIONS(2930),
    [anon_sym_LT] = ACTIONS(2932),
    [anon_sym_DOT_DOT] = ACTIONS(2930),
    [anon_sym_LT_LT] = ACTIONS(2930),
    [anon_sym_GT_GT] = ACTIONS(2930),
    [anon_sym_EQ_EQ] = ACTIONS(2932),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2930),
    [anon_sym_LT_EQ_GT] = ACTIONS(2930),
    [anon_sym_EQ_TILDE] = ACTIONS(2930),
    [anon_sym_BANG_TILDE] = ACTIONS(2930),
    [anon_sym_LT_EQ] = ACTIONS(2932),
    [anon_sym_GT] = ACTIONS(2932),
    [anon_sym_GT_EQ] = ACTIONS(2930),
    [anon_sym_CARET] = ACTIONS(2930),
    [anon_sym_PLUS] = ACTIONS(2932),
    [anon_sym_SLASH] = ACTIONS(2930),
    [anon_sym_PERCENT] = ACTIONS(2930),
    [anon_sym_BANG] = ACTIONS(2932),
    [anon_sym_TILDE] = ACTIONS(2930),
    [sym_constant] = ACTIONS(10067),
    [sym_identifier] = ACTIONS(2936),
    [sym_instance_variable] = ACTIONS(10067),
    [sym_class_variable] = ACTIONS(10067),
    [sym_global_variable] = ACTIONS(10067),
    [anon_sym_DASH] = ACTIONS(2932),
    [anon_sym_PLUS_AT] = ACTIONS(2930),
    [anon_sym_DASH_AT] = ACTIONS(2930),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2932),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(2930),
    [anon_sym_BQUOTE] = ACTIONS(2930),
    [sym_comment] = ACTIONS(87),
  },
  [3882] = {
    [aux_sym_undef_repeat1] = STATE(6579),
    [anon_sym_RBRACE] = ACTIONS(5497),
    [anon_sym_COMMA] = ACTIONS(6433),
    [anon_sym_if] = ACTIONS(5497),
    [anon_sym_unless] = ACTIONS(5497),
    [anon_sym_while] = ACTIONS(5497),
    [anon_sym_until] = ACTIONS(5497),
    [anon_sym_rescue] = ACTIONS(5497),
    [sym_comment] = ACTIONS(87),
  },
  [3883] = {
    [anon_sym_RBRACE] = ACTIONS(5501),
    [anon_sym_if] = ACTIONS(5501),
    [anon_sym_unless] = ACTIONS(5501),
    [anon_sym_while] = ACTIONS(5501),
    [anon_sym_until] = ACTIONS(5501),
    [anon_sym_rescue] = ACTIONS(5501),
    [sym_comment] = ACTIONS(87),
  },
  [3884] = {
    [sym__binary_minus] = ACTIONS(2952),
    [sym__binary_star] = ACTIONS(2954),
    [anon_sym_RBRACE] = ACTIONS(5815),
    [anon_sym_PIPE] = ACTIONS(2956),
    [anon_sym_STAR_STAR] = ACTIONS(2954),
    [anon_sym_AMP] = ACTIONS(2958),
    [anon_sym_LT] = ACTIONS(2960),
    [anon_sym_if] = ACTIONS(5815),
    [anon_sym_unless] = ACTIONS(5815),
    [anon_sym_while] = ACTIONS(5815),
    [anon_sym_until] = ACTIONS(5815),
    [anon_sym_rescue] = ACTIONS(5815),
    [anon_sym_QMARK] = ACTIONS(2962),
    [anon_sym_DOT_DOT] = ACTIONS(2964),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2966),
    [anon_sym_and] = ACTIONS(2968),
    [anon_sym_or] = ACTIONS(2968),
    [anon_sym_PIPE_PIPE] = ACTIONS(2970),
    [anon_sym_AMP_AMP] = ACTIONS(2970),
    [anon_sym_LT_LT] = ACTIONS(2972),
    [anon_sym_GT_GT] = ACTIONS(2972),
    [anon_sym_EQ_EQ] = ACTIONS(2974),
    [anon_sym_BANG_EQ] = ACTIONS(2970),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2970),
    [anon_sym_LT_EQ_GT] = ACTIONS(2970),
    [anon_sym_EQ_TILDE] = ACTIONS(2970),
    [anon_sym_BANG_TILDE] = ACTIONS(2970),
    [anon_sym_LT_EQ] = ACTIONS(2960),
    [anon_sym_GT] = ACTIONS(2960),
    [anon_sym_GT_EQ] = ACTIONS(2976),
    [anon_sym_CARET] = ACTIONS(2978),
    [anon_sym_PLUS] = ACTIONS(2952),
    [anon_sym_SLASH] = ACTIONS(2954),
    [anon_sym_PERCENT] = ACTIONS(2954),
    [sym_comment] = ACTIONS(87),
  },
  [3885] = {
    [sym__binary_minus] = ACTIONS(2952),
    [sym__binary_star] = ACTIONS(2954),
    [anon_sym_RBRACE] = ACTIONS(5817),
    [anon_sym_PIPE] = ACTIONS(2956),
    [anon_sym_STAR_STAR] = ACTIONS(2954),
    [anon_sym_AMP] = ACTIONS(2958),
    [anon_sym_LT] = ACTIONS(2960),
    [anon_sym_if] = ACTIONS(5817),
    [anon_sym_unless] = ACTIONS(5817),
    [anon_sym_while] = ACTIONS(5817),
    [anon_sym_until] = ACTIONS(5817),
    [anon_sym_rescue] = ACTIONS(5817),
    [anon_sym_QMARK] = ACTIONS(2962),
    [anon_sym_DOT_DOT] = ACTIONS(2964),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2966),
    [anon_sym_and] = ACTIONS(2968),
    [anon_sym_or] = ACTIONS(2968),
    [anon_sym_PIPE_PIPE] = ACTIONS(2970),
    [anon_sym_AMP_AMP] = ACTIONS(2970),
    [anon_sym_LT_LT] = ACTIONS(2972),
    [anon_sym_GT_GT] = ACTIONS(2972),
    [anon_sym_EQ_EQ] = ACTIONS(2974),
    [anon_sym_BANG_EQ] = ACTIONS(2970),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2970),
    [anon_sym_LT_EQ_GT] = ACTIONS(2970),
    [anon_sym_EQ_TILDE] = ACTIONS(2970),
    [anon_sym_BANG_TILDE] = ACTIONS(2970),
    [anon_sym_LT_EQ] = ACTIONS(2960),
    [anon_sym_GT] = ACTIONS(2960),
    [anon_sym_GT_EQ] = ACTIONS(2976),
    [anon_sym_CARET] = ACTIONS(2978),
    [anon_sym_PLUS] = ACTIONS(2952),
    [anon_sym_SLASH] = ACTIONS(2954),
    [anon_sym_PERCENT] = ACTIONS(2954),
    [sym_comment] = ACTIONS(87),
  },
  [3886] = {
    [sym__binary_minus] = ACTIONS(2952),
    [sym__binary_star] = ACTIONS(2954),
    [anon_sym_RBRACE] = ACTIONS(5819),
    [anon_sym_PIPE] = ACTIONS(2956),
    [anon_sym_STAR_STAR] = ACTIONS(2954),
    [anon_sym_AMP] = ACTIONS(2958),
    [anon_sym_LT] = ACTIONS(2960),
    [anon_sym_if] = ACTIONS(5819),
    [anon_sym_unless] = ACTIONS(5819),
    [anon_sym_while] = ACTIONS(5819),
    [anon_sym_until] = ACTIONS(5819),
    [anon_sym_rescue] = ACTIONS(5819),
    [anon_sym_QMARK] = ACTIONS(2962),
    [anon_sym_DOT_DOT] = ACTIONS(2964),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2966),
    [anon_sym_and] = ACTIONS(2968),
    [anon_sym_or] = ACTIONS(2968),
    [anon_sym_PIPE_PIPE] = ACTIONS(2970),
    [anon_sym_AMP_AMP] = ACTIONS(2970),
    [anon_sym_LT_LT] = ACTIONS(2972),
    [anon_sym_GT_GT] = ACTIONS(2972),
    [anon_sym_EQ_EQ] = ACTIONS(2974),
    [anon_sym_BANG_EQ] = ACTIONS(2970),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2970),
    [anon_sym_LT_EQ_GT] = ACTIONS(2970),
    [anon_sym_EQ_TILDE] = ACTIONS(2970),
    [anon_sym_BANG_TILDE] = ACTIONS(2970),
    [anon_sym_LT_EQ] = ACTIONS(2960),
    [anon_sym_GT] = ACTIONS(2960),
    [anon_sym_GT_EQ] = ACTIONS(2976),
    [anon_sym_CARET] = ACTIONS(2978),
    [anon_sym_PLUS] = ACTIONS(2952),
    [anon_sym_SLASH] = ACTIONS(2954),
    [anon_sym_PERCENT] = ACTIONS(2954),
    [sym_comment] = ACTIONS(87),
  },
  [3887] = {
    [sym__binary_minus] = ACTIONS(2952),
    [sym__binary_star] = ACTIONS(2954),
    [anon_sym_RBRACE] = ACTIONS(5821),
    [anon_sym_PIPE] = ACTIONS(2956),
    [anon_sym_STAR_STAR] = ACTIONS(2954),
    [anon_sym_AMP] = ACTIONS(2958),
    [anon_sym_LT] = ACTIONS(2960),
    [anon_sym_if] = ACTIONS(5821),
    [anon_sym_unless] = ACTIONS(5821),
    [anon_sym_while] = ACTIONS(5821),
    [anon_sym_until] = ACTIONS(5821),
    [anon_sym_rescue] = ACTIONS(5821),
    [anon_sym_QMARK] = ACTIONS(2962),
    [anon_sym_DOT_DOT] = ACTIONS(2964),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2966),
    [anon_sym_and] = ACTIONS(2968),
    [anon_sym_or] = ACTIONS(2968),
    [anon_sym_PIPE_PIPE] = ACTIONS(2970),
    [anon_sym_AMP_AMP] = ACTIONS(2970),
    [anon_sym_LT_LT] = ACTIONS(2972),
    [anon_sym_GT_GT] = ACTIONS(2972),
    [anon_sym_EQ_EQ] = ACTIONS(2974),
    [anon_sym_BANG_EQ] = ACTIONS(2970),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2970),
    [anon_sym_LT_EQ_GT] = ACTIONS(2970),
    [anon_sym_EQ_TILDE] = ACTIONS(2970),
    [anon_sym_BANG_TILDE] = ACTIONS(2970),
    [anon_sym_LT_EQ] = ACTIONS(2960),
    [anon_sym_GT] = ACTIONS(2960),
    [anon_sym_GT_EQ] = ACTIONS(2976),
    [anon_sym_CARET] = ACTIONS(2978),
    [anon_sym_PLUS] = ACTIONS(2952),
    [anon_sym_SLASH] = ACTIONS(2954),
    [anon_sym_PERCENT] = ACTIONS(2954),
    [sym_comment] = ACTIONS(87),
  },
  [3888] = {
    [sym__binary_minus] = ACTIONS(2952),
    [sym__binary_star] = ACTIONS(2954),
    [anon_sym_RBRACE] = ACTIONS(5823),
    [anon_sym_PIPE] = ACTIONS(2956),
    [anon_sym_STAR_STAR] = ACTIONS(2954),
    [anon_sym_AMP] = ACTIONS(2958),
    [anon_sym_LT] = ACTIONS(2960),
    [anon_sym_if] = ACTIONS(5823),
    [anon_sym_unless] = ACTIONS(5823),
    [anon_sym_while] = ACTIONS(5823),
    [anon_sym_until] = ACTIONS(5823),
    [anon_sym_rescue] = ACTIONS(5823),
    [anon_sym_QMARK] = ACTIONS(2962),
    [anon_sym_DOT_DOT] = ACTIONS(2964),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2966),
    [anon_sym_and] = ACTIONS(2968),
    [anon_sym_or] = ACTIONS(2968),
    [anon_sym_PIPE_PIPE] = ACTIONS(2970),
    [anon_sym_AMP_AMP] = ACTIONS(2970),
    [anon_sym_LT_LT] = ACTIONS(2972),
    [anon_sym_GT_GT] = ACTIONS(2972),
    [anon_sym_EQ_EQ] = ACTIONS(2974),
    [anon_sym_BANG_EQ] = ACTIONS(2970),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2970),
    [anon_sym_LT_EQ_GT] = ACTIONS(2970),
    [anon_sym_EQ_TILDE] = ACTIONS(2970),
    [anon_sym_BANG_TILDE] = ACTIONS(2970),
    [anon_sym_LT_EQ] = ACTIONS(2960),
    [anon_sym_GT] = ACTIONS(2960),
    [anon_sym_GT_EQ] = ACTIONS(2976),
    [anon_sym_CARET] = ACTIONS(2978),
    [anon_sym_PLUS] = ACTIONS(2952),
    [anon_sym_SLASH] = ACTIONS(2954),
    [anon_sym_PERCENT] = ACTIONS(2954),
    [sym_comment] = ACTIONS(87),
  },
  [3889] = {
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(2954),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(2954),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(2954),
    [anon_sym_PERCENT] = ACTIONS(2954),
    [sym_comment] = ACTIONS(87),
  },
  [3890] = {
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(2954),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [3891] = {
    [sym__binary_minus] = ACTIONS(2952),
    [sym__binary_star] = ACTIONS(2954),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(2954),
    [anon_sym_AMP] = ACTIONS(2958),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(2972),
    [anon_sym_GT_GT] = ACTIONS(2972),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(2952),
    [anon_sym_SLASH] = ACTIONS(2954),
    [anon_sym_PERCENT] = ACTIONS(2954),
    [sym_comment] = ACTIONS(87),
  },
  [3892] = {
    [sym__binary_minus] = ACTIONS(2952),
    [sym__binary_star] = ACTIONS(2954),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(2954),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(2972),
    [anon_sym_GT_GT] = ACTIONS(2972),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(2952),
    [anon_sym_SLASH] = ACTIONS(2954),
    [anon_sym_PERCENT] = ACTIONS(2954),
    [sym_comment] = ACTIONS(87),
  },
  [3893] = {
    [sym__binary_minus] = ACTIONS(2952),
    [sym__binary_star] = ACTIONS(2954),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(2956),
    [anon_sym_STAR_STAR] = ACTIONS(2954),
    [anon_sym_AMP] = ACTIONS(2958),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(2972),
    [anon_sym_GT_GT] = ACTIONS(2972),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(2978),
    [anon_sym_PLUS] = ACTIONS(2952),
    [anon_sym_SLASH] = ACTIONS(2954),
    [anon_sym_PERCENT] = ACTIONS(2954),
    [sym_comment] = ACTIONS(87),
  },
  [3894] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(10069),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [3895] = {
    [sym__binary_minus] = ACTIONS(2952),
    [sym__binary_star] = ACTIONS(2954),
    [anon_sym_RBRACE] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(2956),
    [anon_sym_STAR_STAR] = ACTIONS(2954),
    [anon_sym_AMP] = ACTIONS(2958),
    [anon_sym_LT] = ACTIONS(2960),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(2964),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2966),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(2970),
    [anon_sym_AMP_AMP] = ACTIONS(2970),
    [anon_sym_LT_LT] = ACTIONS(2972),
    [anon_sym_GT_GT] = ACTIONS(2972),
    [anon_sym_EQ_EQ] = ACTIONS(2974),
    [anon_sym_BANG_EQ] = ACTIONS(2970),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2970),
    [anon_sym_LT_EQ_GT] = ACTIONS(2970),
    [anon_sym_EQ_TILDE] = ACTIONS(2970),
    [anon_sym_BANG_TILDE] = ACTIONS(2970),
    [anon_sym_LT_EQ] = ACTIONS(2960),
    [anon_sym_GT] = ACTIONS(2960),
    [anon_sym_GT_EQ] = ACTIONS(2976),
    [anon_sym_CARET] = ACTIONS(2978),
    [anon_sym_PLUS] = ACTIONS(2952),
    [anon_sym_SLASH] = ACTIONS(2954),
    [anon_sym_PERCENT] = ACTIONS(2954),
    [sym_comment] = ACTIONS(87),
  },
  [3896] = {
    [sym__binary_minus] = ACTIONS(2952),
    [sym__binary_star] = ACTIONS(2954),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(2956),
    [anon_sym_STAR_STAR] = ACTIONS(2954),
    [anon_sym_AMP] = ACTIONS(2958),
    [anon_sym_LT] = ACTIONS(2960),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(2962),
    [anon_sym_DOT_DOT] = ACTIONS(2964),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2966),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(2970),
    [anon_sym_AMP_AMP] = ACTIONS(2970),
    [anon_sym_LT_LT] = ACTIONS(2972),
    [anon_sym_GT_GT] = ACTIONS(2972),
    [anon_sym_EQ_EQ] = ACTIONS(2974),
    [anon_sym_BANG_EQ] = ACTIONS(2970),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2970),
    [anon_sym_LT_EQ_GT] = ACTIONS(2970),
    [anon_sym_EQ_TILDE] = ACTIONS(2970),
    [anon_sym_BANG_TILDE] = ACTIONS(2970),
    [anon_sym_LT_EQ] = ACTIONS(2960),
    [anon_sym_GT] = ACTIONS(2960),
    [anon_sym_GT_EQ] = ACTIONS(2976),
    [anon_sym_CARET] = ACTIONS(2978),
    [anon_sym_PLUS] = ACTIONS(2952),
    [anon_sym_SLASH] = ACTIONS(2954),
    [anon_sym_PERCENT] = ACTIONS(2954),
    [sym_comment] = ACTIONS(87),
  },
  [3897] = {
    [sym__binary_minus] = ACTIONS(2952),
    [sym__binary_star] = ACTIONS(2954),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(2956),
    [anon_sym_STAR_STAR] = ACTIONS(2954),
    [anon_sym_AMP] = ACTIONS(2958),
    [anon_sym_LT] = ACTIONS(2960),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(2972),
    [anon_sym_GT_GT] = ACTIONS(2972),
    [anon_sym_EQ_EQ] = ACTIONS(2974),
    [anon_sym_BANG_EQ] = ACTIONS(2970),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2970),
    [anon_sym_LT_EQ_GT] = ACTIONS(2970),
    [anon_sym_EQ_TILDE] = ACTIONS(2970),
    [anon_sym_BANG_TILDE] = ACTIONS(2970),
    [anon_sym_LT_EQ] = ACTIONS(2960),
    [anon_sym_GT] = ACTIONS(2960),
    [anon_sym_GT_EQ] = ACTIONS(2976),
    [anon_sym_CARET] = ACTIONS(2978),
    [anon_sym_PLUS] = ACTIONS(2952),
    [anon_sym_SLASH] = ACTIONS(2954),
    [anon_sym_PERCENT] = ACTIONS(2954),
    [sym_comment] = ACTIONS(87),
  },
  [3898] = {
    [sym__binary_minus] = ACTIONS(2952),
    [sym__binary_star] = ACTIONS(2954),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(2954),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(2952),
    [anon_sym_SLASH] = ACTIONS(2954),
    [anon_sym_PERCENT] = ACTIONS(2954),
    [sym_comment] = ACTIONS(87),
  },
  [3899] = {
    [sym__simple_symbol] = ACTIONS(1263),
    [sym__string_start] = ACTIONS(1263),
    [sym__symbol_start] = ACTIONS(1263),
    [sym__subshell_start] = ACTIONS(1263),
    [sym__regex_start] = ACTIONS(1263),
    [sym__string_array_start] = ACTIONS(1263),
    [sym__symbol_array_start] = ACTIONS(1263),
    [sym_heredoc_beginning] = ACTIONS(1263),
    [sym__block_ampersand] = ACTIONS(1263),
    [sym__splat_star] = ACTIONS(1263),
    [sym__unary_minus] = ACTIONS(1263),
    [sym__binary_minus] = ACTIONS(1263),
    [sym__binary_star] = ACTIONS(1263),
    [sym__identifier_hash_key] = ACTIONS(1263),
    [anon_sym_LBRACE] = ACTIONS(1263),
    [anon_sym_RBRACE] = ACTIONS(1263),
    [anon_sym_def] = ACTIONS(1265),
    [anon_sym_LPAREN] = ACTIONS(1265),
    [anon_sym_RPAREN] = ACTIONS(1263),
    [anon_sym_DOT] = ACTIONS(1265),
    [anon_sym_COLON_COLON] = ACTIONS(1265),
    [anon_sym_COMMA] = ACTIONS(1263),
    [anon_sym_PIPE] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_STAR_STAR] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1265),
    [anon_sym_EQ] = ACTIONS(1265),
    [anon_sym_class] = ACTIONS(1265),
    [anon_sym_LT] = ACTIONS(1265),
    [anon_sym_module] = ACTIONS(1265),
    [anon_sym_return] = ACTIONS(1265),
    [anon_sym_yield] = ACTIONS(1265),
    [anon_sym_break] = ACTIONS(1265),
    [anon_sym_next] = ACTIONS(1265),
    [sym_redo] = ACTIONS(1265),
    [sym_retry] = ACTIONS(1265),
    [anon_sym_if] = ACTIONS(1265),
    [anon_sym_unless] = ACTIONS(1265),
    [anon_sym_while] = ACTIONS(1265),
    [anon_sym_until] = ACTIONS(1265),
    [anon_sym_rescue] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1265),
    [anon_sym_do] = ACTIONS(1265),
    [anon_sym_case] = ACTIONS(1265),
    [anon_sym_begin] = ACTIONS(1265),
    [anon_sym_LBRACK] = ACTIONS(1263),
    [anon_sym_COLON_COLON2] = ACTIONS(1263),
    [anon_sym_AMP_DOT] = ACTIONS(1263),
    [anon_sym_LPAREN2] = ACTIONS(1263),
    [anon_sym_PLUS_EQ] = ACTIONS(1263),
    [anon_sym_DASH_EQ] = ACTIONS(1263),
    [anon_sym_STAR_EQ] = ACTIONS(1263),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1263),
    [anon_sym_SLASH_EQ] = ACTIONS(1263),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1263),
    [anon_sym_PIPE_EQ] = ACTIONS(1263),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1263),
    [anon_sym_AMP_EQ] = ACTIONS(1263),
    [anon_sym_PERCENT_EQ] = ACTIONS(1263),
    [anon_sym_GT_GT_EQ] = ACTIONS(1263),
    [anon_sym_LT_LT_EQ] = ACTIONS(1263),
    [anon_sym_CARET_EQ] = ACTIONS(1263),
    [anon_sym_QMARK] = ACTIONS(1265),
    [anon_sym_COLON2] = ACTIONS(1265),
    [anon_sym_DOT_DOT] = ACTIONS(1265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1263),
    [anon_sym_and] = ACTIONS(1265),
    [anon_sym_or] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_LT_LT] = ACTIONS(1265),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_EQ_EQ] = ACTIONS(1265),
    [anon_sym_BANG_EQ] = ACTIONS(1263),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1263),
    [anon_sym_LT_EQ_GT] = ACTIONS(1263),
    [anon_sym_EQ_TILDE] = ACTIONS(1263),
    [anon_sym_BANG_TILDE] = ACTIONS(1263),
    [anon_sym_LT_EQ] = ACTIONS(1265),
    [anon_sym_GT] = ACTIONS(1265),
    [anon_sym_GT_EQ] = ACTIONS(1263),
    [anon_sym_CARET] = ACTIONS(1265),
    [anon_sym_PLUS] = ACTIONS(1265),
    [anon_sym_SLASH] = ACTIONS(1265),
    [anon_sym_PERCENT] = ACTIONS(1265),
    [anon_sym_defined_QMARK] = ACTIONS(1263),
    [anon_sym_not] = ACTIONS(1265),
    [anon_sym_BANG] = ACTIONS(1265),
    [anon_sym_TILDE] = ACTIONS(1263),
    [sym_constant] = ACTIONS(1265),
    [sym_identifier] = ACTIONS(1265),
    [sym_instance_variable] = ACTIONS(1263),
    [sym_class_variable] = ACTIONS(1263),
    [sym_global_variable] = ACTIONS(1263),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1265),
    [sym_float] = ACTIONS(1265),
    [sym_complex] = ACTIONS(1263),
    [sym_super] = ACTIONS(1265),
    [anon_sym_true] = ACTIONS(1265),
    [anon_sym_TRUE] = ACTIONS(1265),
    [anon_sym_false] = ACTIONS(1265),
    [anon_sym_FALSE] = ACTIONS(1265),
    [sym_self] = ACTIONS(1265),
    [anon_sym_nil] = ACTIONS(1265),
    [anon_sym_NIL] = ACTIONS(1265),
    [sym_character] = ACTIONS(1263),
    [anon_sym_LBRACK2] = ACTIONS(1265),
    [anon_sym_DASH_GT] = ACTIONS(1263),
  },
  [3900] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(906),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(911),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(911),
    [sym__argument_list_with_trailing_comma] = STATE(6582),
    [sym__argument] = STATE(909),
    [sym_splat_argument] = STATE(909),
    [sym_hash_splat_argument] = STATE(909),
    [sym_block_argument] = STATE(909),
    [sym_assignment] = STATE(906),
    [sym_operator_assignment] = STATE(906),
    [sym_conditional] = STATE(906),
    [sym_range] = STATE(906),
    [sym_binary] = STATE(906),
    [sym_unary] = STATE(906),
    [sym_left_assignment_list] = STATE(910),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(911),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(911),
    [sym_false] = STATE(911),
    [sym_nil] = STATE(911),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(912),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(909),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1589),
    [sym__splat_star] = ACTIONS(1591),
    [sym__unary_minus] = ACTIONS(1593),
    [sym__identifier_hash_key] = ACTIONS(1595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(10071),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1599),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_defined_QMARK] = ACTIONS(1611),
    [anon_sym_not] = ACTIONS(1613),
    [anon_sym_BANG] = ACTIONS(1615),
    [anon_sym_TILDE] = ACTIONS(1615),
    [sym_constant] = ACTIONS(1617),
    [sym_identifier] = ACTIONS(1617),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3901] = {
    [sym__simple_symbol] = ACTIONS(5935),
    [sym__string_start] = ACTIONS(5935),
    [sym__symbol_start] = ACTIONS(5935),
    [sym__subshell_start] = ACTIONS(5935),
    [sym__regex_start] = ACTIONS(5935),
    [sym__string_array_start] = ACTIONS(5935),
    [sym__symbol_array_start] = ACTIONS(5935),
    [sym_heredoc_beginning] = ACTIONS(5935),
    [sym__block_ampersand] = ACTIONS(5935),
    [sym__splat_star] = ACTIONS(5935),
    [sym__unary_minus] = ACTIONS(5935),
    [sym__binary_minus] = ACTIONS(5935),
    [sym__binary_star] = ACTIONS(5935),
    [sym__identifier_hash_key] = ACTIONS(5935),
    [anon_sym_LBRACE] = ACTIONS(5935),
    [anon_sym_RBRACE] = ACTIONS(5935),
    [anon_sym_def] = ACTIONS(5937),
    [anon_sym_LPAREN] = ACTIONS(5937),
    [anon_sym_RPAREN] = ACTIONS(5935),
    [anon_sym_DOT] = ACTIONS(5937),
    [anon_sym_COLON_COLON] = ACTIONS(5937),
    [anon_sym_COMMA] = ACTIONS(5935),
    [anon_sym_PIPE] = ACTIONS(5937),
    [anon_sym_SEMI] = ACTIONS(5935),
    [anon_sym_STAR] = ACTIONS(5937),
    [anon_sym_STAR_STAR] = ACTIONS(5937),
    [anon_sym_AMP] = ACTIONS(5937),
    [anon_sym_EQ] = ACTIONS(5937),
    [anon_sym_class] = ACTIONS(5937),
    [anon_sym_LT] = ACTIONS(5937),
    [anon_sym_module] = ACTIONS(5937),
    [anon_sym_return] = ACTIONS(5937),
    [anon_sym_yield] = ACTIONS(5937),
    [anon_sym_break] = ACTIONS(5937),
    [anon_sym_next] = ACTIONS(5937),
    [sym_redo] = ACTIONS(5937),
    [sym_retry] = ACTIONS(5937),
    [anon_sym_if] = ACTIONS(5937),
    [anon_sym_unless] = ACTIONS(5937),
    [anon_sym_while] = ACTIONS(5937),
    [anon_sym_until] = ACTIONS(5937),
    [anon_sym_rescue] = ACTIONS(5937),
    [anon_sym_for] = ACTIONS(5937),
    [anon_sym_do] = ACTIONS(5937),
    [anon_sym_case] = ACTIONS(5937),
    [anon_sym_begin] = ACTIONS(5937),
    [anon_sym_LBRACK] = ACTIONS(5935),
    [anon_sym_COLON_COLON2] = ACTIONS(5935),
    [anon_sym_AMP_DOT] = ACTIONS(5935),
    [anon_sym_LPAREN2] = ACTIONS(5935),
    [anon_sym_PLUS_EQ] = ACTIONS(5935),
    [anon_sym_DASH_EQ] = ACTIONS(5935),
    [anon_sym_STAR_EQ] = ACTIONS(5935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5935),
    [anon_sym_SLASH_EQ] = ACTIONS(5935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5935),
    [anon_sym_PIPE_EQ] = ACTIONS(5935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5935),
    [anon_sym_AMP_EQ] = ACTIONS(5935),
    [anon_sym_PERCENT_EQ] = ACTIONS(5935),
    [anon_sym_GT_GT_EQ] = ACTIONS(5935),
    [anon_sym_LT_LT_EQ] = ACTIONS(5935),
    [anon_sym_CARET_EQ] = ACTIONS(5935),
    [anon_sym_QMARK] = ACTIONS(5937),
    [anon_sym_COLON2] = ACTIONS(5937),
    [anon_sym_DOT_DOT] = ACTIONS(5937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5935),
    [anon_sym_and] = ACTIONS(5937),
    [anon_sym_or] = ACTIONS(5937),
    [anon_sym_PIPE_PIPE] = ACTIONS(5937),
    [anon_sym_AMP_AMP] = ACTIONS(5937),
    [anon_sym_LT_LT] = ACTIONS(5937),
    [anon_sym_GT_GT] = ACTIONS(5937),
    [anon_sym_EQ_EQ] = ACTIONS(5937),
    [anon_sym_BANG_EQ] = ACTIONS(5935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5935),
    [anon_sym_LT_EQ_GT] = ACTIONS(5935),
    [anon_sym_EQ_TILDE] = ACTIONS(5935),
    [anon_sym_BANG_TILDE] = ACTIONS(5935),
    [anon_sym_LT_EQ] = ACTIONS(5937),
    [anon_sym_GT] = ACTIONS(5937),
    [anon_sym_GT_EQ] = ACTIONS(5935),
    [anon_sym_CARET] = ACTIONS(5937),
    [anon_sym_PLUS] = ACTIONS(5937),
    [anon_sym_SLASH] = ACTIONS(5937),
    [anon_sym_PERCENT] = ACTIONS(5937),
    [anon_sym_defined_QMARK] = ACTIONS(5935),
    [anon_sym_not] = ACTIONS(5937),
    [anon_sym_BANG] = ACTIONS(5937),
    [anon_sym_TILDE] = ACTIONS(5935),
    [sym_constant] = ACTIONS(5937),
    [sym_identifier] = ACTIONS(5937),
    [sym_instance_variable] = ACTIONS(5935),
    [sym_class_variable] = ACTIONS(5935),
    [sym_global_variable] = ACTIONS(5935),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5937),
    [sym_float] = ACTIONS(5937),
    [sym_complex] = ACTIONS(5935),
    [sym_super] = ACTIONS(5937),
    [anon_sym_true] = ACTIONS(5937),
    [anon_sym_TRUE] = ACTIONS(5937),
    [anon_sym_false] = ACTIONS(5937),
    [anon_sym_FALSE] = ACTIONS(5937),
    [sym_self] = ACTIONS(5937),
    [anon_sym_nil] = ACTIONS(5937),
    [anon_sym_NIL] = ACTIONS(5937),
    [sym_character] = ACTIONS(5935),
    [anon_sym_LBRACK2] = ACTIONS(5937),
    [anon_sym_DASH_GT] = ACTIONS(5935),
  },
  [3902] = {
    [sym__simple_symbol] = ACTIONS(5939),
    [sym__string_start] = ACTIONS(5939),
    [sym__symbol_start] = ACTIONS(5939),
    [sym__subshell_start] = ACTIONS(5939),
    [sym__regex_start] = ACTIONS(5939),
    [sym__string_array_start] = ACTIONS(5939),
    [sym__symbol_array_start] = ACTIONS(5939),
    [sym_heredoc_beginning] = ACTIONS(5939),
    [sym__block_ampersand] = ACTIONS(5939),
    [sym__splat_star] = ACTIONS(5939),
    [sym__unary_minus] = ACTIONS(5939),
    [sym__binary_minus] = ACTIONS(5939),
    [sym__binary_star] = ACTIONS(5939),
    [sym__identifier_hash_key] = ACTIONS(5939),
    [anon_sym_LBRACE] = ACTIONS(5939),
    [anon_sym_RBRACE] = ACTIONS(5939),
    [anon_sym_def] = ACTIONS(5941),
    [anon_sym_LPAREN] = ACTIONS(5941),
    [anon_sym_RPAREN] = ACTIONS(5939),
    [anon_sym_DOT] = ACTIONS(5941),
    [anon_sym_COLON_COLON] = ACTIONS(5941),
    [anon_sym_COMMA] = ACTIONS(5939),
    [anon_sym_PIPE] = ACTIONS(5941),
    [anon_sym_SEMI] = ACTIONS(5939),
    [anon_sym_STAR] = ACTIONS(5941),
    [anon_sym_STAR_STAR] = ACTIONS(5941),
    [anon_sym_AMP] = ACTIONS(5941),
    [anon_sym_EQ] = ACTIONS(5941),
    [anon_sym_class] = ACTIONS(5941),
    [anon_sym_LT] = ACTIONS(5941),
    [anon_sym_module] = ACTIONS(5941),
    [anon_sym_return] = ACTIONS(5941),
    [anon_sym_yield] = ACTIONS(5941),
    [anon_sym_break] = ACTIONS(5941),
    [anon_sym_next] = ACTIONS(5941),
    [sym_redo] = ACTIONS(5941),
    [sym_retry] = ACTIONS(5941),
    [anon_sym_if] = ACTIONS(5941),
    [anon_sym_unless] = ACTIONS(5941),
    [anon_sym_while] = ACTIONS(5941),
    [anon_sym_until] = ACTIONS(5941),
    [anon_sym_rescue] = ACTIONS(5941),
    [anon_sym_for] = ACTIONS(5941),
    [anon_sym_do] = ACTIONS(5941),
    [anon_sym_case] = ACTIONS(5941),
    [anon_sym_begin] = ACTIONS(5941),
    [anon_sym_LBRACK] = ACTIONS(5939),
    [anon_sym_COLON_COLON2] = ACTIONS(5939),
    [anon_sym_AMP_DOT] = ACTIONS(5939),
    [anon_sym_LPAREN2] = ACTIONS(5939),
    [anon_sym_PLUS_EQ] = ACTIONS(5939),
    [anon_sym_DASH_EQ] = ACTIONS(5939),
    [anon_sym_STAR_EQ] = ACTIONS(5939),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5939),
    [anon_sym_SLASH_EQ] = ACTIONS(5939),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5939),
    [anon_sym_PIPE_EQ] = ACTIONS(5939),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5939),
    [anon_sym_AMP_EQ] = ACTIONS(5939),
    [anon_sym_PERCENT_EQ] = ACTIONS(5939),
    [anon_sym_GT_GT_EQ] = ACTIONS(5939),
    [anon_sym_LT_LT_EQ] = ACTIONS(5939),
    [anon_sym_CARET_EQ] = ACTIONS(5939),
    [anon_sym_QMARK] = ACTIONS(5941),
    [anon_sym_COLON2] = ACTIONS(5941),
    [anon_sym_DOT_DOT] = ACTIONS(5941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5939),
    [anon_sym_and] = ACTIONS(5941),
    [anon_sym_or] = ACTIONS(5941),
    [anon_sym_PIPE_PIPE] = ACTIONS(5941),
    [anon_sym_AMP_AMP] = ACTIONS(5941),
    [anon_sym_LT_LT] = ACTIONS(5941),
    [anon_sym_GT_GT] = ACTIONS(5941),
    [anon_sym_EQ_EQ] = ACTIONS(5941),
    [anon_sym_BANG_EQ] = ACTIONS(5939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5939),
    [anon_sym_LT_EQ_GT] = ACTIONS(5939),
    [anon_sym_EQ_TILDE] = ACTIONS(5939),
    [anon_sym_BANG_TILDE] = ACTIONS(5939),
    [anon_sym_LT_EQ] = ACTIONS(5941),
    [anon_sym_GT] = ACTIONS(5941),
    [anon_sym_GT_EQ] = ACTIONS(5939),
    [anon_sym_CARET] = ACTIONS(5941),
    [anon_sym_PLUS] = ACTIONS(5941),
    [anon_sym_SLASH] = ACTIONS(5941),
    [anon_sym_PERCENT] = ACTIONS(5941),
    [anon_sym_defined_QMARK] = ACTIONS(5939),
    [anon_sym_not] = ACTIONS(5941),
    [anon_sym_BANG] = ACTIONS(5941),
    [anon_sym_TILDE] = ACTIONS(5939),
    [sym_constant] = ACTIONS(5941),
    [sym_identifier] = ACTIONS(5941),
    [sym_instance_variable] = ACTIONS(5939),
    [sym_class_variable] = ACTIONS(5939),
    [sym_global_variable] = ACTIONS(5939),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5941),
    [sym_float] = ACTIONS(5941),
    [sym_complex] = ACTIONS(5939),
    [sym_super] = ACTIONS(5941),
    [anon_sym_true] = ACTIONS(5941),
    [anon_sym_TRUE] = ACTIONS(5941),
    [anon_sym_false] = ACTIONS(5941),
    [anon_sym_FALSE] = ACTIONS(5941),
    [sym_self] = ACTIONS(5941),
    [anon_sym_nil] = ACTIONS(5941),
    [anon_sym_NIL] = ACTIONS(5941),
    [sym_character] = ACTIONS(5939),
    [anon_sym_LBRACK2] = ACTIONS(5941),
    [anon_sym_DASH_GT] = ACTIONS(5939),
  },
  [3903] = {
    [sym_argument_list_with_parens] = STATE(6583),
    [sym__argument_list_with_parens] = STATE(3902),
    [sym_operator] = STATE(6583),
    [sym_heredoc_body] = STATE(3563),
    [aux_sym_call_repeat1] = STATE(3563),
    [sym__heredoc_body_start] = ACTIONS(2519),
    [anon_sym_PIPE] = ACTIONS(6441),
    [anon_sym_STAR] = ACTIONS(6443),
    [anon_sym_STAR_STAR] = ACTIONS(6441),
    [anon_sym_AMP] = ACTIONS(6441),
    [anon_sym_LT] = ACTIONS(6443),
    [anon_sym_LPAREN2] = ACTIONS(6445),
    [anon_sym_DOT_DOT] = ACTIONS(6441),
    [anon_sym_LT_LT] = ACTIONS(6441),
    [anon_sym_GT_GT] = ACTIONS(6441),
    [anon_sym_EQ_EQ] = ACTIONS(6443),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6441),
    [anon_sym_LT_EQ_GT] = ACTIONS(6441),
    [anon_sym_EQ_TILDE] = ACTIONS(6441),
    [anon_sym_BANG_TILDE] = ACTIONS(6441),
    [anon_sym_LT_EQ] = ACTIONS(6443),
    [anon_sym_GT] = ACTIONS(6443),
    [anon_sym_GT_EQ] = ACTIONS(6441),
    [anon_sym_CARET] = ACTIONS(6441),
    [anon_sym_PLUS] = ACTIONS(6443),
    [anon_sym_SLASH] = ACTIONS(6441),
    [anon_sym_PERCENT] = ACTIONS(6441),
    [anon_sym_BANG] = ACTIONS(6443),
    [anon_sym_TILDE] = ACTIONS(6441),
    [sym_constant] = ACTIONS(10073),
    [sym_identifier] = ACTIONS(10073),
    [anon_sym_DASH] = ACTIONS(6443),
    [anon_sym_PLUS_AT] = ACTIONS(6441),
    [anon_sym_DASH_AT] = ACTIONS(6441),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(6443),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(6441),
    [anon_sym_BQUOTE] = ACTIONS(6441),
    [sym_comment] = ACTIONS(87),
  },
  [3904] = {
    [sym__binary_minus] = ACTIONS(5945),
    [sym__binary_star] = ACTIONS(5945),
    [anon_sym_LBRACE] = ACTIONS(5945),
    [anon_sym_RBRACE] = ACTIONS(5945),
    [anon_sym_RPAREN] = ACTIONS(5945),
    [anon_sym_DOT] = ACTIONS(5947),
    [anon_sym_COMMA] = ACTIONS(5945),
    [anon_sym_PIPE] = ACTIONS(5947),
    [anon_sym_SEMI] = ACTIONS(5945),
    [anon_sym_STAR_STAR] = ACTIONS(5947),
    [anon_sym_AMP] = ACTIONS(5947),
    [anon_sym_EQ] = ACTIONS(5947),
    [anon_sym_LT] = ACTIONS(5947),
    [anon_sym_if] = ACTIONS(5945),
    [anon_sym_unless] = ACTIONS(5945),
    [anon_sym_while] = ACTIONS(5945),
    [anon_sym_until] = ACTIONS(5945),
    [anon_sym_rescue] = ACTIONS(5945),
    [anon_sym_do] = ACTIONS(5945),
    [anon_sym_LBRACK] = ACTIONS(5945),
    [anon_sym_COLON_COLON2] = ACTIONS(5945),
    [anon_sym_AMP_DOT] = ACTIONS(5945),
    [anon_sym_PLUS_EQ] = ACTIONS(5945),
    [anon_sym_DASH_EQ] = ACTIONS(5945),
    [anon_sym_STAR_EQ] = ACTIONS(5945),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5945),
    [anon_sym_SLASH_EQ] = ACTIONS(5945),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5945),
    [anon_sym_PIPE_EQ] = ACTIONS(5945),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5945),
    [anon_sym_AMP_EQ] = ACTIONS(5945),
    [anon_sym_PERCENT_EQ] = ACTIONS(5945),
    [anon_sym_GT_GT_EQ] = ACTIONS(5945),
    [anon_sym_LT_LT_EQ] = ACTIONS(5945),
    [anon_sym_CARET_EQ] = ACTIONS(5945),
    [anon_sym_QMARK] = ACTIONS(5945),
    [anon_sym_COLON2] = ACTIONS(5947),
    [anon_sym_DOT_DOT] = ACTIONS(5947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5945),
    [anon_sym_and] = ACTIONS(5945),
    [anon_sym_or] = ACTIONS(5945),
    [anon_sym_PIPE_PIPE] = ACTIONS(5947),
    [anon_sym_AMP_AMP] = ACTIONS(5947),
    [anon_sym_LT_LT] = ACTIONS(5947),
    [anon_sym_GT_GT] = ACTIONS(5947),
    [anon_sym_EQ_EQ] = ACTIONS(5947),
    [anon_sym_BANG_EQ] = ACTIONS(5945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5945),
    [anon_sym_LT_EQ_GT] = ACTIONS(5945),
    [anon_sym_EQ_TILDE] = ACTIONS(5945),
    [anon_sym_BANG_TILDE] = ACTIONS(5945),
    [anon_sym_LT_EQ] = ACTIONS(5947),
    [anon_sym_GT] = ACTIONS(5947),
    [anon_sym_GT_EQ] = ACTIONS(5945),
    [anon_sym_CARET] = ACTIONS(5947),
    [anon_sym_PLUS] = ACTIONS(5947),
    [anon_sym_SLASH] = ACTIONS(5947),
    [anon_sym_PERCENT] = ACTIONS(5947),
    [sym_comment] = ACTIONS(87),
  },
  [3905] = {
    [anon_sym_RBRACK] = ACTIONS(10075),
    [sym_comment] = ACTIONS(87),
  },
  [3906] = {
    [sym__simple_symbol] = ACTIONS(5951),
    [sym__string_start] = ACTIONS(5951),
    [sym__symbol_start] = ACTIONS(5951),
    [sym__subshell_start] = ACTIONS(5951),
    [sym__regex_start] = ACTIONS(5951),
    [sym__string_array_start] = ACTIONS(5951),
    [sym__symbol_array_start] = ACTIONS(5951),
    [sym_heredoc_beginning] = ACTIONS(5951),
    [sym__block_ampersand] = ACTIONS(5951),
    [sym__splat_star] = ACTIONS(5951),
    [sym__unary_minus] = ACTIONS(5951),
    [sym__binary_minus] = ACTIONS(5951),
    [sym__binary_star] = ACTIONS(5951),
    [sym__identifier_hash_key] = ACTIONS(5951),
    [anon_sym_LBRACE] = ACTIONS(5951),
    [anon_sym_RBRACE] = ACTIONS(5951),
    [anon_sym_def] = ACTIONS(5953),
    [anon_sym_LPAREN] = ACTIONS(5953),
    [anon_sym_RPAREN] = ACTIONS(5951),
    [anon_sym_DOT] = ACTIONS(5953),
    [anon_sym_COLON_COLON] = ACTIONS(5953),
    [anon_sym_COMMA] = ACTIONS(5951),
    [anon_sym_PIPE] = ACTIONS(5953),
    [anon_sym_SEMI] = ACTIONS(5951),
    [anon_sym_STAR] = ACTIONS(5953),
    [anon_sym_STAR_STAR] = ACTIONS(5953),
    [anon_sym_AMP] = ACTIONS(5953),
    [anon_sym_EQ] = ACTIONS(5953),
    [anon_sym_class] = ACTIONS(5953),
    [anon_sym_LT] = ACTIONS(5953),
    [anon_sym_module] = ACTIONS(5953),
    [anon_sym_return] = ACTIONS(5953),
    [anon_sym_yield] = ACTIONS(5953),
    [anon_sym_break] = ACTIONS(5953),
    [anon_sym_next] = ACTIONS(5953),
    [sym_redo] = ACTIONS(5953),
    [sym_retry] = ACTIONS(5953),
    [anon_sym_if] = ACTIONS(5953),
    [anon_sym_unless] = ACTIONS(5953),
    [anon_sym_while] = ACTIONS(5953),
    [anon_sym_until] = ACTIONS(5953),
    [anon_sym_rescue] = ACTIONS(5953),
    [anon_sym_for] = ACTIONS(5953),
    [anon_sym_do] = ACTIONS(5953),
    [anon_sym_case] = ACTIONS(5953),
    [anon_sym_begin] = ACTIONS(5953),
    [anon_sym_LBRACK] = ACTIONS(5951),
    [anon_sym_COLON_COLON2] = ACTIONS(5951),
    [anon_sym_AMP_DOT] = ACTIONS(5951),
    [anon_sym_LPAREN2] = ACTIONS(5951),
    [anon_sym_PLUS_EQ] = ACTIONS(5951),
    [anon_sym_DASH_EQ] = ACTIONS(5951),
    [anon_sym_STAR_EQ] = ACTIONS(5951),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5951),
    [anon_sym_SLASH_EQ] = ACTIONS(5951),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5951),
    [anon_sym_PIPE_EQ] = ACTIONS(5951),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5951),
    [anon_sym_AMP_EQ] = ACTIONS(5951),
    [anon_sym_PERCENT_EQ] = ACTIONS(5951),
    [anon_sym_GT_GT_EQ] = ACTIONS(5951),
    [anon_sym_LT_LT_EQ] = ACTIONS(5951),
    [anon_sym_CARET_EQ] = ACTIONS(5951),
    [anon_sym_QMARK] = ACTIONS(5953),
    [anon_sym_COLON2] = ACTIONS(5953),
    [anon_sym_DOT_DOT] = ACTIONS(5953),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5951),
    [anon_sym_and] = ACTIONS(5953),
    [anon_sym_or] = ACTIONS(5953),
    [anon_sym_PIPE_PIPE] = ACTIONS(5953),
    [anon_sym_AMP_AMP] = ACTIONS(5953),
    [anon_sym_LT_LT] = ACTIONS(5953),
    [anon_sym_GT_GT] = ACTIONS(5953),
    [anon_sym_EQ_EQ] = ACTIONS(5953),
    [anon_sym_BANG_EQ] = ACTIONS(5951),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5951),
    [anon_sym_LT_EQ_GT] = ACTIONS(5951),
    [anon_sym_EQ_TILDE] = ACTIONS(5951),
    [anon_sym_BANG_TILDE] = ACTIONS(5951),
    [anon_sym_LT_EQ] = ACTIONS(5953),
    [anon_sym_GT] = ACTIONS(5953),
    [anon_sym_GT_EQ] = ACTIONS(5951),
    [anon_sym_CARET] = ACTIONS(5953),
    [anon_sym_PLUS] = ACTIONS(5953),
    [anon_sym_SLASH] = ACTIONS(5953),
    [anon_sym_PERCENT] = ACTIONS(5953),
    [anon_sym_defined_QMARK] = ACTIONS(5951),
    [anon_sym_not] = ACTIONS(5953),
    [anon_sym_BANG] = ACTIONS(5953),
    [anon_sym_TILDE] = ACTIONS(5951),
    [sym_constant] = ACTIONS(5953),
    [sym_identifier] = ACTIONS(5953),
    [sym_instance_variable] = ACTIONS(5951),
    [sym_class_variable] = ACTIONS(5951),
    [sym_global_variable] = ACTIONS(5951),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5953),
    [sym_float] = ACTIONS(5953),
    [sym_complex] = ACTIONS(5951),
    [sym_super] = ACTIONS(5953),
    [anon_sym_true] = ACTIONS(5953),
    [anon_sym_TRUE] = ACTIONS(5953),
    [anon_sym_false] = ACTIONS(5953),
    [anon_sym_FALSE] = ACTIONS(5953),
    [sym_self] = ACTIONS(5953),
    [anon_sym_nil] = ACTIONS(5953),
    [anon_sym_NIL] = ACTIONS(5953),
    [sym_character] = ACTIONS(5951),
    [anon_sym_LBRACK2] = ACTIONS(5953),
    [anon_sym_DASH_GT] = ACTIONS(5951),
  },
  [3907] = {
    [sym__heredoc_body_start] = ACTIONS(101),
    [sym__binary_minus] = ACTIONS(101),
    [sym__binary_star] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_RBRACE] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(103),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_PIPE] = ACTIONS(103),
    [anon_sym_SEMI] = ACTIONS(101),
    [anon_sym_STAR_STAR] = ACTIONS(103),
    [anon_sym_AMP] = ACTIONS(103),
    [anon_sym_EQ] = ACTIONS(103),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_unless] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_until] = ACTIONS(101),
    [anon_sym_rescue] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_RBRACK] = ACTIONS(101),
    [anon_sym_COLON_COLON2] = ACTIONS(101),
    [anon_sym_AMP_DOT] = ACTIONS(101),
    [anon_sym_PLUS_EQ] = ACTIONS(101),
    [anon_sym_DASH_EQ] = ACTIONS(101),
    [anon_sym_STAR_EQ] = ACTIONS(101),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(101),
    [anon_sym_SLASH_EQ] = ACTIONS(101),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(101),
    [anon_sym_PIPE_EQ] = ACTIONS(101),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(101),
    [anon_sym_AMP_EQ] = ACTIONS(101),
    [anon_sym_PERCENT_EQ] = ACTIONS(101),
    [anon_sym_GT_GT_EQ] = ACTIONS(101),
    [anon_sym_LT_LT_EQ] = ACTIONS(101),
    [anon_sym_CARET_EQ] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(103),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_and] = ACTIONS(101),
    [anon_sym_or] = ACTIONS(101),
    [anon_sym_PIPE_PIPE] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_LT_LT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_EQ_EQ] = ACTIONS(103),
    [anon_sym_BANG_EQ] = ACTIONS(101),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(101),
    [anon_sym_LT_EQ_GT] = ACTIONS(101),
    [anon_sym_EQ_TILDE] = ACTIONS(101),
    [anon_sym_BANG_TILDE] = ACTIONS(101),
    [anon_sym_LT_EQ] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_EQ] = ACTIONS(101),
    [anon_sym_CARET] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [sym_comment] = ACTIONS(87),
  },
  [3908] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(6586),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(10077),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [3909] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(6588),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(10079),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [3910] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(6590),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(10081),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [3911] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(6592),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(10083),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [3912] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(6595),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(10085),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(10087),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [3913] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(6598),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(10089),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(10091),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [3914] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(6599),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(3940),
    [sym_scope_resolution] = STATE(3938),
    [sym_call] = STATE(3938),
    [sym_method_call] = STATE(3940),
    [sym_assignment] = STATE(6599),
    [sym_operator_assignment] = STATE(6599),
    [sym_conditional] = STATE(6599),
    [sym_range] = STATE(6599),
    [sym_binary] = STATE(6599),
    [sym_unary] = STATE(6599),
    [sym_left_assignment_list] = STATE(3939),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3940),
    [sym__variable] = STATE(3938),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(3940),
    [sym_false] = STATE(3940),
    [sym_nil] = STATE(3940),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(3941),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(6469),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(6481),
    [anon_sym_yield] = ACTIONS(6483),
    [anon_sym_break] = ACTIONS(6485),
    [anon_sym_next] = ACTIONS(6487),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(6505),
    [anon_sym_defined_QMARK] = ACTIONS(6507),
    [anon_sym_not] = ACTIONS(6509),
    [anon_sym_BANG] = ACTIONS(6511),
    [anon_sym_TILDE] = ACTIONS(6511),
    [sym_constant] = ACTIONS(6513),
    [sym_identifier] = ACTIONS(6513),
    [sym_instance_variable] = ACTIONS(6515),
    [sym_class_variable] = ACTIONS(6515),
    [sym_global_variable] = ACTIONS(6515),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(6513),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6513),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [3915] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(113),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(118),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(118),
    [sym_hash_splat_argument] = STATE(116),
    [sym_assignment] = STATE(113),
    [sym_operator_assignment] = STATE(113),
    [sym_conditional] = STATE(113),
    [sym_range] = STATE(113),
    [sym_binary] = STATE(113),
    [sym_unary] = STATE(113),
    [sym_left_assignment_list] = STATE(117),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(118),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(118),
    [sym_false] = STATE(118),
    [sym_nil] = STATE(118),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(119),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_heredoc_body] = STATE(6601),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym__hash_items] = STATE(6602),
    [sym_pair] = STATE(122),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [sym__identifier_hash_key] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_RBRACE] = ACTIONS(10093),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(209),
    [sym_identifier] = ACTIONS(209),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3916] = {
    [sym__method_rest] = STATE(6604),
    [sym__variable] = STATE(6605),
    [sym_operator] = STATE(6606),
    [sym__method_name] = STATE(6606),
    [sym_setter] = STATE(6606),
    [sym_symbol] = STATE(6606),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_LPAREN] = ACTIONS(10095),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(239),
    [sym_identifier] = ACTIONS(241),
    [sym_instance_variable] = ACTIONS(239),
    [sym_class_variable] = ACTIONS(239),
    [sym_global_variable] = ACTIONS(239),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
    [sym_super] = ACTIONS(10097),
    [sym_self] = ACTIONS(10097),
  },
  [3917] = {
    [sym__statements] = STATE(6608),
    [sym_begin_block] = STATE(144),
    [sym_end_block] = STATE(144),
    [sym__statement] = STATE(144),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(144),
    [sym_unless_modifier] = STATE(144),
    [sym_while_modifier] = STATE(144),
    [sym_until_modifier] = STATE(144),
    [sym_rescue_modifier] = STATE(144),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(145),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(150),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(150),
    [sym_assignment] = STATE(145),
    [sym_operator_assignment] = STATE(145),
    [sym_conditional] = STATE(145),
    [sym_range] = STATE(145),
    [sym_binary] = STATE(145),
    [sym_unary] = STATE(145),
    [sym_left_assignment_list] = STATE(147),
    [sym__mlhs] = STATE(148),
    [sym_destructured_left_assignment] = STATE(149),
    [sym_rest_assignment] = STATE(149),
    [sym__lhs] = STATE(150),
    [sym__variable] = STATE(146),
    [sym_undef] = STATE(144),
    [sym_alias] = STATE(144),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(150),
    [sym_false] = STATE(150),
    [sym_nil] = STATE(150),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(151),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(152),
    [aux_sym__statements_repeat1] = STATE(152),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_RPAREN] = ACTIONS(10099),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(249),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [anon_sym_undef] = ACTIONS(271),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3918] = {
    [sym_method] = STATE(191),
    [sym_singleton_method] = STATE(191),
    [sym_class] = STATE(191),
    [sym_singleton_class] = STATE(191),
    [sym_module] = STATE(191),
    [sym_return] = STATE(191),
    [sym_yield] = STATE(191),
    [sym_break] = STATE(191),
    [sym_next] = STATE(191),
    [sym_while] = STATE(191),
    [sym_until] = STATE(191),
    [sym_for] = STATE(191),
    [sym_case] = STATE(191),
    [sym_if] = STATE(191),
    [sym_unless] = STATE(191),
    [sym_begin] = STATE(191),
    [sym__primary] = STATE(191),
    [sym_parenthesized_statements] = STATE(191),
    [sym_element_reference] = STATE(191),
    [sym_scope_resolution] = STATE(6611),
    [sym_call] = STATE(193),
    [sym_method_call] = STATE(191),
    [sym__lhs] = STATE(191),
    [sym__variable] = STATE(193),
    [sym_rational] = STATE(191),
    [sym_true] = STATE(191),
    [sym_false] = STATE(191),
    [sym_nil] = STATE(191),
    [sym_chained_string] = STATE(191),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(191),
    [sym_string_array] = STATE(191),
    [sym_symbol_array] = STATE(191),
    [sym_symbol] = STATE(191),
    [sym_regex] = STATE(191),
    [sym_array] = STATE(191),
    [sym_hash] = STATE(191),
    [sym_lambda] = STATE(191),
    [sym__simple_symbol] = ACTIONS(279),
    [sym__string_start] = ACTIONS(281),
    [sym__symbol_start] = ACTIONS(283),
    [sym__subshell_start] = ACTIONS(285),
    [sym__regex_start] = ACTIONS(287),
    [sym__string_array_start] = ACTIONS(289),
    [sym__symbol_array_start] = ACTIONS(291),
    [sym_heredoc_beginning] = ACTIONS(349),
    [sym__singleton_class_left_angle_left_langle] = ACTIONS(10101),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_def] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(299),
    [anon_sym_COLON_COLON] = ACTIONS(353),
    [anon_sym_class] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(307),
    [anon_sym_return] = ACTIONS(309),
    [anon_sym_yield] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_next] = ACTIONS(315),
    [sym_redo] = ACTIONS(355),
    [sym_retry] = ACTIONS(355),
    [anon_sym_if] = ACTIONS(319),
    [anon_sym_unless] = ACTIONS(321),
    [anon_sym_while] = ACTIONS(323),
    [anon_sym_until] = ACTIONS(325),
    [anon_sym_for] = ACTIONS(327),
    [anon_sym_case] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(331),
    [sym_constant] = ACTIONS(10103),
    [sym_identifier] = ACTIONS(359),
    [sym_instance_variable] = ACTIONS(361),
    [sym_class_variable] = ACTIONS(361),
    [sym_global_variable] = ACTIONS(361),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(355),
    [sym_complex] = ACTIONS(349),
    [sym_super] = ACTIONS(359),
    [anon_sym_true] = ACTIONS(339),
    [anon_sym_TRUE] = ACTIONS(339),
    [anon_sym_false] = ACTIONS(341),
    [anon_sym_FALSE] = ACTIONS(341),
    [sym_self] = ACTIONS(359),
    [anon_sym_nil] = ACTIONS(343),
    [anon_sym_NIL] = ACTIONS(343),
    [sym_character] = ACTIONS(349),
    [anon_sym_LBRACK2] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(347),
  },
  [3919] = {
    [sym_method] = STATE(191),
    [sym_singleton_method] = STATE(191),
    [sym_class] = STATE(191),
    [sym_singleton_class] = STATE(191),
    [sym_module] = STATE(191),
    [sym_return] = STATE(191),
    [sym_yield] = STATE(191),
    [sym_break] = STATE(191),
    [sym_next] = STATE(191),
    [sym_while] = STATE(191),
    [sym_until] = STATE(191),
    [sym_for] = STATE(191),
    [sym_case] = STATE(191),
    [sym_if] = STATE(191),
    [sym_unless] = STATE(191),
    [sym_begin] = STATE(191),
    [sym__primary] = STATE(191),
    [sym_parenthesized_statements] = STATE(191),
    [sym_element_reference] = STATE(191),
    [sym_scope_resolution] = STATE(6613),
    [sym_call] = STATE(193),
    [sym_method_call] = STATE(191),
    [sym__lhs] = STATE(191),
    [sym__variable] = STATE(193),
    [sym_rational] = STATE(191),
    [sym_true] = STATE(191),
    [sym_false] = STATE(191),
    [sym_nil] = STATE(191),
    [sym_chained_string] = STATE(191),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(191),
    [sym_string_array] = STATE(191),
    [sym_symbol_array] = STATE(191),
    [sym_symbol] = STATE(191),
    [sym_regex] = STATE(191),
    [sym_array] = STATE(191),
    [sym_hash] = STATE(191),
    [sym_lambda] = STATE(191),
    [sym__simple_symbol] = ACTIONS(279),
    [sym__string_start] = ACTIONS(281),
    [sym__symbol_start] = ACTIONS(283),
    [sym__subshell_start] = ACTIONS(285),
    [sym__regex_start] = ACTIONS(287),
    [sym__string_array_start] = ACTIONS(289),
    [sym__symbol_array_start] = ACTIONS(291),
    [sym_heredoc_beginning] = ACTIONS(349),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_def] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(299),
    [anon_sym_COLON_COLON] = ACTIONS(353),
    [anon_sym_class] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(307),
    [anon_sym_return] = ACTIONS(309),
    [anon_sym_yield] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_next] = ACTIONS(315),
    [sym_redo] = ACTIONS(355),
    [sym_retry] = ACTIONS(355),
    [anon_sym_if] = ACTIONS(319),
    [anon_sym_unless] = ACTIONS(321),
    [anon_sym_while] = ACTIONS(323),
    [anon_sym_until] = ACTIONS(325),
    [anon_sym_for] = ACTIONS(327),
    [anon_sym_case] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(331),
    [sym_constant] = ACTIONS(10105),
    [sym_identifier] = ACTIONS(359),
    [sym_instance_variable] = ACTIONS(361),
    [sym_class_variable] = ACTIONS(361),
    [sym_global_variable] = ACTIONS(361),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(355),
    [sym_complex] = ACTIONS(349),
    [sym_super] = ACTIONS(359),
    [anon_sym_true] = ACTIONS(339),
    [anon_sym_TRUE] = ACTIONS(339),
    [anon_sym_false] = ACTIONS(341),
    [anon_sym_FALSE] = ACTIONS(341),
    [sym_self] = ACTIONS(359),
    [anon_sym_nil] = ACTIONS(343),
    [anon_sym_NIL] = ACTIONS(343),
    [sym_character] = ACTIONS(349),
    [anon_sym_LBRACK2] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(347),
  },
  [3920] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1679),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1686),
    [sym_scope_resolution] = STATE(1680),
    [sym_call] = STATE(1680),
    [sym_method_call] = STATE(1686),
    [sym_argument_list] = STATE(6614),
    [sym__argument_list_with_parens] = STATE(1682),
    [sym__argument] = STATE(1683),
    [sym_splat_argument] = STATE(1683),
    [sym_hash_splat_argument] = STATE(1683),
    [sym_block_argument] = STATE(1683),
    [sym_assignment] = STATE(1679),
    [sym_operator_assignment] = STATE(1679),
    [sym_conditional] = STATE(1679),
    [sym_range] = STATE(1679),
    [sym_binary] = STATE(1679),
    [sym_unary] = STATE(1679),
    [sym_left_assignment_list] = STATE(1685),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1686),
    [sym__variable] = STATE(1680),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1686),
    [sym_false] = STATE(1686),
    [sym_nil] = STATE(1686),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1687),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(1683),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(2988),
    [sym__splat_star] = ACTIONS(2990),
    [sym__unary_minus] = ACTIONS(2992),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(2994),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_RBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2998),
    [anon_sym_yield] = ACTIONS(3000),
    [anon_sym_break] = ACTIONS(3002),
    [anon_sym_next] = ACTIONS(3004),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_PLUS_EQ] = ACTIONS(365),
    [anon_sym_DASH_EQ] = ACTIONS(365),
    [anon_sym_STAR_EQ] = ACTIONS(365),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(365),
    [anon_sym_SLASH_EQ] = ACTIONS(365),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(365),
    [anon_sym_PIPE_EQ] = ACTIONS(365),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(365),
    [anon_sym_AMP_EQ] = ACTIONS(365),
    [anon_sym_PERCENT_EQ] = ACTIONS(365),
    [anon_sym_GT_GT_EQ] = ACTIONS(365),
    [anon_sym_LT_LT_EQ] = ACTIONS(365),
    [anon_sym_CARET_EQ] = ACTIONS(365),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_PERCENT] = ACTIONS(377),
    [anon_sym_defined_QMARK] = ACTIONS(3010),
    [anon_sym_not] = ACTIONS(3012),
    [anon_sym_BANG] = ACTIONS(3014),
    [anon_sym_TILDE] = ACTIONS(3016),
    [sym_constant] = ACTIONS(3018),
    [sym_identifier] = ACTIONS(3018),
    [sym_instance_variable] = ACTIONS(3020),
    [sym_class_variable] = ACTIONS(3020),
    [sym_global_variable] = ACTIONS(3020),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3022),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3022),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3921] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1679),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1686),
    [sym_scope_resolution] = STATE(1680),
    [sym_call] = STATE(1680),
    [sym_method_call] = STATE(1686),
    [sym_argument_list] = STATE(6615),
    [sym__argument_list_with_parens] = STATE(1682),
    [sym__argument] = STATE(1683),
    [sym_splat_argument] = STATE(1683),
    [sym_hash_splat_argument] = STATE(1683),
    [sym_block_argument] = STATE(1683),
    [sym_assignment] = STATE(1679),
    [sym_operator_assignment] = STATE(1679),
    [sym_conditional] = STATE(1679),
    [sym_range] = STATE(1679),
    [sym_binary] = STATE(1679),
    [sym_unary] = STATE(1679),
    [sym_left_assignment_list] = STATE(1685),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1686),
    [sym__variable] = STATE(1680),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1686),
    [sym_false] = STATE(1686),
    [sym_nil] = STATE(1686),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1687),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(1683),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(2988),
    [sym__splat_star] = ACTIONS(2990),
    [sym__unary_minus] = ACTIONS(2992),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(2994),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_RBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_EQ] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2998),
    [anon_sym_yield] = ACTIONS(3000),
    [anon_sym_break] = ACTIONS(3002),
    [anon_sym_next] = ACTIONS(3004),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_PLUS_EQ] = ACTIONS(417),
    [anon_sym_DASH_EQ] = ACTIONS(417),
    [anon_sym_STAR_EQ] = ACTIONS(417),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(417),
    [anon_sym_SLASH_EQ] = ACTIONS(417),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(417),
    [anon_sym_PIPE_EQ] = ACTIONS(417),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(417),
    [anon_sym_AMP_EQ] = ACTIONS(417),
    [anon_sym_PERCENT_EQ] = ACTIONS(417),
    [anon_sym_GT_GT_EQ] = ACTIONS(417),
    [anon_sym_LT_LT_EQ] = ACTIONS(417),
    [anon_sym_CARET_EQ] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(3010),
    [anon_sym_not] = ACTIONS(3012),
    [anon_sym_BANG] = ACTIONS(3014),
    [anon_sym_TILDE] = ACTIONS(3016),
    [sym_constant] = ACTIONS(3018),
    [sym_identifier] = ACTIONS(3018),
    [sym_instance_variable] = ACTIONS(3020),
    [sym_class_variable] = ACTIONS(3020),
    [sym_global_variable] = ACTIONS(3020),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3022),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3022),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3922] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1679),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1686),
    [sym_scope_resolution] = STATE(1680),
    [sym_call] = STATE(1680),
    [sym_method_call] = STATE(1686),
    [sym_argument_list] = STATE(6616),
    [sym__argument_list_with_parens] = STATE(1682),
    [sym__argument] = STATE(1683),
    [sym_splat_argument] = STATE(1683),
    [sym_hash_splat_argument] = STATE(1683),
    [sym_block_argument] = STATE(1683),
    [sym_assignment] = STATE(1679),
    [sym_operator_assignment] = STATE(1679),
    [sym_conditional] = STATE(1679),
    [sym_range] = STATE(1679),
    [sym_binary] = STATE(1679),
    [sym_unary] = STATE(1679),
    [sym_left_assignment_list] = STATE(1685),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1686),
    [sym__variable] = STATE(1680),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1686),
    [sym_false] = STATE(1686),
    [sym_nil] = STATE(1686),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1687),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(1683),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(2988),
    [sym__splat_star] = ACTIONS(2990),
    [sym__unary_minus] = ACTIONS(2992),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(2994),
    [anon_sym_LBRACE] = ACTIONS(421),
    [anon_sym_RBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_EQ] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2998),
    [anon_sym_yield] = ACTIONS(3000),
    [anon_sym_break] = ACTIONS(3002),
    [anon_sym_next] = ACTIONS(3004),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_PLUS_EQ] = ACTIONS(421),
    [anon_sym_DASH_EQ] = ACTIONS(421),
    [anon_sym_STAR_EQ] = ACTIONS(421),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(421),
    [anon_sym_SLASH_EQ] = ACTIONS(421),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(421),
    [anon_sym_PIPE_EQ] = ACTIONS(421),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(421),
    [anon_sym_AMP_EQ] = ACTIONS(421),
    [anon_sym_PERCENT_EQ] = ACTIONS(421),
    [anon_sym_GT_GT_EQ] = ACTIONS(421),
    [anon_sym_LT_LT_EQ] = ACTIONS(421),
    [anon_sym_CARET_EQ] = ACTIONS(421),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(3010),
    [anon_sym_not] = ACTIONS(3012),
    [anon_sym_BANG] = ACTIONS(3014),
    [anon_sym_TILDE] = ACTIONS(3016),
    [sym_constant] = ACTIONS(3018),
    [sym_identifier] = ACTIONS(3018),
    [sym_instance_variable] = ACTIONS(3020),
    [sym_class_variable] = ACTIONS(3020),
    [sym_global_variable] = ACTIONS(3020),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3022),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3022),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3923] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1679),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1686),
    [sym_scope_resolution] = STATE(1680),
    [sym_call] = STATE(1680),
    [sym_method_call] = STATE(1686),
    [sym_argument_list] = STATE(6617),
    [sym__argument_list_with_parens] = STATE(1682),
    [sym__argument] = STATE(1683),
    [sym_splat_argument] = STATE(1683),
    [sym_hash_splat_argument] = STATE(1683),
    [sym_block_argument] = STATE(1683),
    [sym_assignment] = STATE(1679),
    [sym_operator_assignment] = STATE(1679),
    [sym_conditional] = STATE(1679),
    [sym_range] = STATE(1679),
    [sym_binary] = STATE(1679),
    [sym_unary] = STATE(1679),
    [sym_left_assignment_list] = STATE(1685),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1686),
    [sym__variable] = STATE(1680),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1686),
    [sym_false] = STATE(1686),
    [sym_nil] = STATE(1686),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1687),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(1683),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(2988),
    [sym__splat_star] = ACTIONS(2990),
    [sym__unary_minus] = ACTIONS(2992),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(2994),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(427),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2998),
    [anon_sym_yield] = ACTIONS(3000),
    [anon_sym_break] = ACTIONS(3002),
    [anon_sym_next] = ACTIONS(3004),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_PLUS_EQ] = ACTIONS(425),
    [anon_sym_DASH_EQ] = ACTIONS(425),
    [anon_sym_STAR_EQ] = ACTIONS(425),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(425),
    [anon_sym_SLASH_EQ] = ACTIONS(425),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(425),
    [anon_sym_PIPE_EQ] = ACTIONS(425),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(425),
    [anon_sym_AMP_EQ] = ACTIONS(425),
    [anon_sym_PERCENT_EQ] = ACTIONS(425),
    [anon_sym_GT_GT_EQ] = ACTIONS(425),
    [anon_sym_LT_LT_EQ] = ACTIONS(425),
    [anon_sym_CARET_EQ] = ACTIONS(425),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(3010),
    [anon_sym_not] = ACTIONS(3012),
    [anon_sym_BANG] = ACTIONS(3014),
    [anon_sym_TILDE] = ACTIONS(3016),
    [sym_constant] = ACTIONS(3018),
    [sym_identifier] = ACTIONS(3018),
    [sym_instance_variable] = ACTIONS(3020),
    [sym_class_variable] = ACTIONS(3020),
    [sym_global_variable] = ACTIONS(3020),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3022),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3022),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3924] = {
    [sym_begin_block] = STATE(6618),
    [sym_end_block] = STATE(6618),
    [sym__statement] = STATE(6618),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(6618),
    [sym_unless_modifier] = STATE(6618),
    [sym_while_modifier] = STATE(6618),
    [sym_until_modifier] = STATE(6618),
    [sym_rescue_modifier] = STATE(6618),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(234),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(234),
    [sym_operator_assignment] = STATE(234),
    [sym_conditional] = STATE(234),
    [sym_range] = STATE(234),
    [sym_binary] = STATE(234),
    [sym_unary] = STATE(234),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_undef] = STATE(6618),
    [sym_alias] = STATE(6618),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(429),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_yield] = ACTIONS(433),
    [anon_sym_break] = ACTIONS(435),
    [anon_sym_next] = ACTIONS(437),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(439),
    [anon_sym_defined_QMARK] = ACTIONS(441),
    [anon_sym_not] = ACTIONS(443),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [anon_sym_undef] = ACTIONS(451),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3925] = {
    [sym_begin_block] = STATE(6619),
    [sym_end_block] = STATE(6619),
    [sym__statement] = STATE(6619),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(6619),
    [sym_unless_modifier] = STATE(6619),
    [sym_while_modifier] = STATE(6619),
    [sym_until_modifier] = STATE(6619),
    [sym_rescue_modifier] = STATE(6619),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(234),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(234),
    [sym_operator_assignment] = STATE(234),
    [sym_conditional] = STATE(234),
    [sym_range] = STATE(234),
    [sym_binary] = STATE(234),
    [sym_unary] = STATE(234),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_undef] = STATE(6619),
    [sym_alias] = STATE(6619),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(429),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_yield] = ACTIONS(433),
    [anon_sym_break] = ACTIONS(435),
    [anon_sym_next] = ACTIONS(437),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(439),
    [anon_sym_defined_QMARK] = ACTIONS(441),
    [anon_sym_not] = ACTIONS(443),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [anon_sym_undef] = ACTIONS(451),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3926] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(6620),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(6620),
    [sym_operator_assignment] = STATE(6620),
    [sym_conditional] = STATE(6620),
    [sym_range] = STATE(6620),
    [sym_binary] = STATE(6620),
    [sym_unary] = STATE(6620),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(455),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_break] = ACTIONS(459),
    [anon_sym_next] = ACTIONS(461),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_defined_QMARK] = ACTIONS(465),
    [anon_sym_not] = ACTIONS(467),
    [anon_sym_BANG] = ACTIONS(469),
    [anon_sym_TILDE] = ACTIONS(469),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3927] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(6621),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(6621),
    [sym_operator_assignment] = STATE(6621),
    [sym_conditional] = STATE(6621),
    [sym_range] = STATE(6621),
    [sym_binary] = STATE(6621),
    [sym_unary] = STATE(6621),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(455),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_break] = ACTIONS(459),
    [anon_sym_next] = ACTIONS(461),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_defined_QMARK] = ACTIONS(465),
    [anon_sym_not] = ACTIONS(467),
    [anon_sym_BANG] = ACTIONS(469),
    [anon_sym_TILDE] = ACTIONS(469),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3928] = {
    [sym_method] = STATE(184),
    [sym_singleton_method] = STATE(184),
    [sym_class] = STATE(184),
    [sym_singleton_class] = STATE(184),
    [sym_module] = STATE(184),
    [sym_return] = STATE(184),
    [sym_yield] = STATE(184),
    [sym_break] = STATE(184),
    [sym_next] = STATE(184),
    [sym_while] = STATE(184),
    [sym_until] = STATE(184),
    [sym_for] = STATE(184),
    [sym_case] = STATE(184),
    [sym_if] = STATE(184),
    [sym_unless] = STATE(184),
    [sym_begin] = STATE(184),
    [sym__primary] = STATE(184),
    [sym_parenthesized_statements] = STATE(184),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(255),
    [sym_call] = STATE(255),
    [sym_method_call] = STATE(258),
    [sym__mlhs] = STATE(6622),
    [sym_destructured_left_assignment] = STATE(257),
    [sym_rest_assignment] = STATE(257),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(255),
    [sym_rational] = STATE(184),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(184),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(184),
    [sym_string_array] = STATE(184),
    [sym_symbol_array] = STATE(184),
    [sym_symbol] = STATE(184),
    [sym_regex] = STATE(184),
    [sym_array] = STATE(184),
    [sym_hash] = STATE(184),
    [sym_lambda] = STATE(184),
    [sym__simple_symbol] = ACTIONS(279),
    [sym__string_start] = ACTIONS(281),
    [sym__symbol_start] = ACTIONS(283),
    [sym__subshell_start] = ACTIONS(285),
    [sym__regex_start] = ACTIONS(287),
    [sym__string_array_start] = ACTIONS(289),
    [sym__symbol_array_start] = ACTIONS(291),
    [sym_heredoc_beginning] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_def] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(475),
    [anon_sym_COLON_COLON] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(477),
    [anon_sym_class] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(307),
    [anon_sym_return] = ACTIONS(309),
    [anon_sym_yield] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_next] = ACTIONS(315),
    [sym_redo] = ACTIONS(317),
    [sym_retry] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(319),
    [anon_sym_unless] = ACTIONS(321),
    [anon_sym_while] = ACTIONS(323),
    [anon_sym_until] = ACTIONS(325),
    [anon_sym_for] = ACTIONS(327),
    [anon_sym_case] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(331),
    [sym_constant] = ACTIONS(479),
    [sym_identifier] = ACTIONS(479),
    [sym_instance_variable] = ACTIONS(481),
    [sym_class_variable] = ACTIONS(481),
    [sym_global_variable] = ACTIONS(481),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(317),
    [sym_complex] = ACTIONS(293),
    [sym_super] = ACTIONS(479),
    [anon_sym_true] = ACTIONS(339),
    [anon_sym_TRUE] = ACTIONS(339),
    [anon_sym_false] = ACTIONS(341),
    [anon_sym_FALSE] = ACTIONS(341),
    [sym_self] = ACTIONS(479),
    [anon_sym_nil] = ACTIONS(343),
    [anon_sym_NIL] = ACTIONS(343),
    [sym_character] = ACTIONS(293),
    [anon_sym_LBRACK2] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(347),
  },
  [3929] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(6623),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(6623),
    [sym_operator_assignment] = STATE(6623),
    [sym_conditional] = STATE(6623),
    [sym_range] = STATE(6623),
    [sym_binary] = STATE(6623),
    [sym_unary] = STATE(6623),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_heredoc_body] = STATE(6624),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__terminator] = STATE(6624),
    [sym__line_break] = ACTIONS(10107),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(485),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(10107),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(495),
    [anon_sym_defined_QMARK] = ACTIONS(497),
    [anon_sym_not] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(501),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3930] = {
    [sym__statements] = STATE(6625),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(6626),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(6627),
    [sym_rescue] = STATE(6628),
    [sym__body_statement] = STATE(6629),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_heredoc_body] = STATE(6630),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [sym__terminator] = STATE(6630),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__line_break] = ACTIONS(10109),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(10109),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10111),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3931] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(6631),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(3940),
    [sym_scope_resolution] = STATE(3938),
    [sym_call] = STATE(3938),
    [sym_method_call] = STATE(3940),
    [sym_assignment] = STATE(6631),
    [sym_operator_assignment] = STATE(6631),
    [sym_conditional] = STATE(6631),
    [sym_range] = STATE(6631),
    [sym_binary] = STATE(6631),
    [sym_unary] = STATE(6631),
    [sym_left_assignment_list] = STATE(3939),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3940),
    [sym__variable] = STATE(3938),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(3940),
    [sym_false] = STATE(3940),
    [sym_nil] = STATE(3940),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(3941),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(6469),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(6481),
    [anon_sym_yield] = ACTIONS(6483),
    [anon_sym_break] = ACTIONS(6485),
    [anon_sym_next] = ACTIONS(6487),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(6505),
    [anon_sym_defined_QMARK] = ACTIONS(6507),
    [anon_sym_not] = ACTIONS(6509),
    [anon_sym_BANG] = ACTIONS(6511),
    [anon_sym_TILDE] = ACTIONS(6511),
    [sym_constant] = ACTIONS(6513),
    [sym_identifier] = ACTIONS(6513),
    [sym_instance_variable] = ACTIONS(6515),
    [sym_class_variable] = ACTIONS(6515),
    [sym_global_variable] = ACTIONS(6515),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(6513),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6513),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [3932] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(6632),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(3940),
    [sym_scope_resolution] = STATE(3938),
    [sym_call] = STATE(3938),
    [sym_method_call] = STATE(3940),
    [sym_assignment] = STATE(6632),
    [sym_operator_assignment] = STATE(6632),
    [sym_conditional] = STATE(6632),
    [sym_range] = STATE(6632),
    [sym_binary] = STATE(6632),
    [sym_unary] = STATE(6632),
    [sym_left_assignment_list] = STATE(3939),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3940),
    [sym__variable] = STATE(3938),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(3940),
    [sym_false] = STATE(3940),
    [sym_nil] = STATE(3940),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(3941),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(6469),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(6481),
    [anon_sym_yield] = ACTIONS(6483),
    [anon_sym_break] = ACTIONS(6485),
    [anon_sym_next] = ACTIONS(6487),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(6505),
    [anon_sym_defined_QMARK] = ACTIONS(6507),
    [anon_sym_not] = ACTIONS(6509),
    [anon_sym_BANG] = ACTIONS(6511),
    [anon_sym_TILDE] = ACTIONS(6511),
    [sym_constant] = ACTIONS(6513),
    [sym_identifier] = ACTIONS(6513),
    [sym_instance_variable] = ACTIONS(6515),
    [sym_class_variable] = ACTIONS(6515),
    [sym_global_variable] = ACTIONS(6515),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(6513),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6513),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [3933] = {
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_in] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
    [anon_sym_r] = ACTIONS(10113),
  },
  [3934] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(346),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(352),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(352),
    [sym__argument_list_with_trailing_comma] = STATE(6635),
    [sym__argument] = STATE(350),
    [sym_splat_argument] = STATE(350),
    [sym_hash_splat_argument] = STATE(350),
    [sym_block_argument] = STATE(350),
    [sym_assignment] = STATE(346),
    [sym_operator_assignment] = STATE(346),
    [sym_conditional] = STATE(346),
    [sym_range] = STATE(346),
    [sym_binary] = STATE(346),
    [sym_unary] = STATE(346),
    [sym_left_assignment_list] = STATE(351),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(352),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(352),
    [sym_false] = STATE(352),
    [sym_nil] = STATE(352),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(353),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(350),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(593),
    [sym__splat_star] = ACTIONS(595),
    [sym__unary_minus] = ACTIONS(597),
    [sym__identifier_hash_key] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(10115),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3935] = {
    [sym_lambda_parameters] = STATE(6636),
    [sym__simple_formal_parameter] = STATE(362),
    [sym_splat_parameter] = STATE(362),
    [sym_hash_splat_parameter] = STATE(362),
    [sym_block_parameter] = STATE(362),
    [sym_keyword_parameter] = STATE(362),
    [sym_optional_parameter] = STATE(362),
    [sym_do_block] = STATE(6637),
    [sym_block] = STATE(6637),
    [anon_sym_LBRACE] = ACTIONS(6975),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(3337),
    [sym_identifier] = ACTIONS(679),
    [sym_comment] = ACTIONS(87),
  },
  [3936] = {
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(10117),
    [sym__binary_star] = ACTIONS(10119),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_RBRACE] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(10121),
    [anon_sym_STAR_STAR] = ACTIONS(10123),
    [anon_sym_AMP] = ACTIONS(10125),
    [anon_sym_EQ] = ACTIONS(4217),
    [anon_sym_LT] = ACTIONS(10127),
    [anon_sym_if] = ACTIONS(4211),
    [anon_sym_unless] = ACTIONS(4211),
    [anon_sym_while] = ACTIONS(4211),
    [anon_sym_until] = ACTIONS(4211),
    [anon_sym_rescue] = ACTIONS(4211),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_PLUS_EQ] = ACTIONS(4211),
    [anon_sym_DASH_EQ] = ACTIONS(4211),
    [anon_sym_STAR_EQ] = ACTIONS(4211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4211),
    [anon_sym_SLASH_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4211),
    [anon_sym_AMP_EQ] = ACTIONS(4211),
    [anon_sym_PERCENT_EQ] = ACTIONS(4211),
    [anon_sym_GT_GT_EQ] = ACTIONS(4211),
    [anon_sym_LT_LT_EQ] = ACTIONS(4211),
    [anon_sym_CARET_EQ] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(10129),
    [anon_sym_DOT_DOT] = ACTIONS(10131),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10133),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(10135),
    [anon_sym_AMP_AMP] = ACTIONS(10135),
    [anon_sym_LT_LT] = ACTIONS(10137),
    [anon_sym_GT_GT] = ACTIONS(10137),
    [anon_sym_EQ_EQ] = ACTIONS(10135),
    [anon_sym_BANG_EQ] = ACTIONS(10139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10139),
    [anon_sym_LT_EQ_GT] = ACTIONS(10139),
    [anon_sym_EQ_TILDE] = ACTIONS(10139),
    [anon_sym_BANG_TILDE] = ACTIONS(10139),
    [anon_sym_LT_EQ] = ACTIONS(10127),
    [anon_sym_GT] = ACTIONS(10127),
    [anon_sym_GT_EQ] = ACTIONS(10141),
    [anon_sym_CARET] = ACTIONS(10121),
    [anon_sym_PLUS] = ACTIONS(10143),
    [anon_sym_SLASH] = ACTIONS(10123),
    [anon_sym_PERCENT] = ACTIONS(10123),
    [sym_comment] = ACTIONS(87),
  },
  [3937] = {
    [sym__heredoc_body_start] = ACTIONS(731),
    [sym__binary_minus] = ACTIONS(731),
    [sym__binary_star] = ACTIONS(731),
    [anon_sym_LBRACE] = ACTIONS(731),
    [anon_sym_RBRACE] = ACTIONS(731),
    [anon_sym_RPAREN] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(3311),
    [anon_sym_COMMA] = ACTIONS(731),
    [anon_sym_PIPE] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(731),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_AMP] = ACTIONS(735),
    [anon_sym_EQ] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(735),
    [anon_sym_if] = ACTIONS(731),
    [anon_sym_unless] = ACTIONS(731),
    [anon_sym_while] = ACTIONS(731),
    [anon_sym_until] = ACTIONS(731),
    [anon_sym_rescue] = ACTIONS(731),
    [anon_sym_in] = ACTIONS(731),
    [anon_sym_do] = ACTIONS(731),
    [anon_sym_LBRACK] = ACTIONS(3313),
    [anon_sym_RBRACK] = ACTIONS(731),
    [anon_sym_COLON_COLON2] = ACTIONS(3315),
    [anon_sym_AMP_DOT] = ACTIONS(3317),
    [anon_sym_PLUS_EQ] = ACTIONS(731),
    [anon_sym_DASH_EQ] = ACTIONS(731),
    [anon_sym_STAR_EQ] = ACTIONS(731),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(731),
    [anon_sym_SLASH_EQ] = ACTIONS(731),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(731),
    [anon_sym_PIPE_EQ] = ACTIONS(731),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(731),
    [anon_sym_AMP_EQ] = ACTIONS(731),
    [anon_sym_PERCENT_EQ] = ACTIONS(731),
    [anon_sym_GT_GT_EQ] = ACTIONS(731),
    [anon_sym_LT_LT_EQ] = ACTIONS(731),
    [anon_sym_CARET_EQ] = ACTIONS(731),
    [anon_sym_QMARK] = ACTIONS(731),
    [anon_sym_COLON2] = ACTIONS(735),
    [anon_sym_DOT_DOT] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(731),
    [anon_sym_or] = ACTIONS(731),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_EQ_EQ] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(731),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(731),
    [anon_sym_LT_EQ_GT] = ACTIONS(731),
    [anon_sym_EQ_TILDE] = ACTIONS(731),
    [anon_sym_BANG_TILDE] = ACTIONS(731),
    [anon_sym_LT_EQ] = ACTIONS(735),
    [anon_sym_GT] = ACTIONS(735),
    [anon_sym_GT_EQ] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_SLASH] = ACTIONS(735),
    [anon_sym_PERCENT] = ACTIONS(735),
    [sym_comment] = ACTIONS(87),
  },
  [3938] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1679),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1686),
    [sym_scope_resolution] = STATE(1680),
    [sym_call] = STATE(1680),
    [sym_method_call] = STATE(1686),
    [sym_argument_list] = STATE(4801),
    [sym__argument_list_with_parens] = STATE(1682),
    [sym__argument] = STATE(1683),
    [sym_splat_argument] = STATE(1683),
    [sym_hash_splat_argument] = STATE(1683),
    [sym_block_argument] = STATE(1683),
    [sym_do_block] = STATE(1849),
    [sym_block] = STATE(1849),
    [sym_assignment] = STATE(1679),
    [sym_operator_assignment] = STATE(1679),
    [sym_conditional] = STATE(1679),
    [sym_range] = STATE(1679),
    [sym_binary] = STATE(1679),
    [sym_unary] = STATE(1679),
    [sym_left_assignment_list] = STATE(1685),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1686),
    [sym__variable] = STATE(1680),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1686),
    [sym_false] = STATE(1686),
    [sym_nil] = STATE(1686),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1687),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(1683),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(2988),
    [sym__splat_star] = ACTIONS(2990),
    [sym__unary_minus] = ACTIONS(2992),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(2994),
    [anon_sym_LBRACE] = ACTIONS(7739),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2998),
    [anon_sym_yield] = ACTIONS(3000),
    [anon_sym_break] = ACTIONS(3002),
    [anon_sym_next] = ACTIONS(3004),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(769),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(769),
    [anon_sym_until] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(769),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(769),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(3010),
    [anon_sym_not] = ACTIONS(3012),
    [anon_sym_BANG] = ACTIONS(3014),
    [anon_sym_TILDE] = ACTIONS(3016),
    [sym_constant] = ACTIONS(3018),
    [sym_identifier] = ACTIONS(3018),
    [sym_instance_variable] = ACTIONS(3020),
    [sym_class_variable] = ACTIONS(3020),
    [sym_global_variable] = ACTIONS(3020),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3022),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3022),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3939] = {
    [anon_sym_EQ] = ACTIONS(10145),
    [sym_comment] = ACTIONS(87),
  },
  [3940] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(10147),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(10149),
    [anon_sym_DASH_EQ] = ACTIONS(10149),
    [anon_sym_STAR_EQ] = ACTIONS(10149),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10149),
    [anon_sym_SLASH_EQ] = ACTIONS(10149),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10149),
    [anon_sym_PIPE_EQ] = ACTIONS(10149),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10149),
    [anon_sym_AMP_EQ] = ACTIONS(10149),
    [anon_sym_PERCENT_EQ] = ACTIONS(10149),
    [anon_sym_GT_GT_EQ] = ACTIONS(10149),
    [anon_sym_LT_LT_EQ] = ACTIONS(10149),
    [anon_sym_CARET_EQ] = ACTIONS(10149),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3941] = {
    [sym_string] = STATE(6650),
    [aux_sym_chained_string_repeat1] = STATE(6650),
    [sym__string_start] = ACTIONS(6455),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3942] = {
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(10117),
    [sym__binary_star] = ACTIONS(10119),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_RBRACE] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(10121),
    [anon_sym_STAR_STAR] = ACTIONS(10123),
    [anon_sym_AMP] = ACTIONS(10125),
    [anon_sym_EQ] = ACTIONS(4249),
    [anon_sym_LT] = ACTIONS(10127),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_PLUS_EQ] = ACTIONS(4247),
    [anon_sym_DASH_EQ] = ACTIONS(4247),
    [anon_sym_STAR_EQ] = ACTIONS(4247),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4247),
    [anon_sym_SLASH_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4247),
    [anon_sym_AMP_EQ] = ACTIONS(4247),
    [anon_sym_PERCENT_EQ] = ACTIONS(4247),
    [anon_sym_GT_GT_EQ] = ACTIONS(4247),
    [anon_sym_LT_LT_EQ] = ACTIONS(4247),
    [anon_sym_CARET_EQ] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(10129),
    [anon_sym_DOT_DOT] = ACTIONS(10131),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10133),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(10135),
    [anon_sym_AMP_AMP] = ACTIONS(10135),
    [anon_sym_LT_LT] = ACTIONS(10137),
    [anon_sym_GT_GT] = ACTIONS(10137),
    [anon_sym_EQ_EQ] = ACTIONS(10135),
    [anon_sym_BANG_EQ] = ACTIONS(10139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10139),
    [anon_sym_LT_EQ_GT] = ACTIONS(10139),
    [anon_sym_EQ_TILDE] = ACTIONS(10139),
    [anon_sym_BANG_TILDE] = ACTIONS(10139),
    [anon_sym_LT_EQ] = ACTIONS(10127),
    [anon_sym_GT] = ACTIONS(10127),
    [anon_sym_GT_EQ] = ACTIONS(10141),
    [anon_sym_CARET] = ACTIONS(10121),
    [anon_sym_PLUS] = ACTIONS(10143),
    [anon_sym_SLASH] = ACTIONS(10123),
    [anon_sym_PERCENT] = ACTIONS(10123),
    [sym_comment] = ACTIONS(87),
  },
  [3943] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(6543),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [3944] = {
    [sym_string] = STATE(3976),
    [aux_sym_chained_string_repeat1] = STATE(3976),
    [sym__string_start] = ACTIONS(1141),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3945] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(6651),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(3940),
    [sym_scope_resolution] = STATE(3938),
    [sym_call] = STATE(3938),
    [sym_method_call] = STATE(3940),
    [sym_assignment] = STATE(6651),
    [sym_operator_assignment] = STATE(6651),
    [sym_conditional] = STATE(6651),
    [sym_range] = STATE(6651),
    [sym_binary] = STATE(6651),
    [sym_unary] = STATE(6651),
    [sym_left_assignment_list] = STATE(3939),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3940),
    [sym__variable] = STATE(3938),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(3940),
    [sym_false] = STATE(3940),
    [sym_nil] = STATE(3940),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(3941),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(6469),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(6481),
    [anon_sym_yield] = ACTIONS(6483),
    [anon_sym_break] = ACTIONS(6485),
    [anon_sym_next] = ACTIONS(6487),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(6505),
    [anon_sym_defined_QMARK] = ACTIONS(6507),
    [anon_sym_not] = ACTIONS(6509),
    [anon_sym_BANG] = ACTIONS(6511),
    [anon_sym_TILDE] = ACTIONS(6511),
    [sym_constant] = ACTIONS(6513),
    [sym_identifier] = ACTIONS(6513),
    [sym_instance_variable] = ACTIONS(6515),
    [sym_class_variable] = ACTIONS(6515),
    [sym_global_variable] = ACTIONS(6515),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(6513),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6513),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [3946] = {
    [sym__heredoc_body_start] = ACTIONS(993),
    [sym__binary_minus] = ACTIONS(5735),
    [sym__binary_star] = ACTIONS(5735),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_RBRACE] = ACTIONS(5735),
    [anon_sym_RPAREN] = ACTIONS(5735),
    [anon_sym_DOT] = ACTIONS(5737),
    [anon_sym_COMMA] = ACTIONS(5735),
    [anon_sym_PIPE] = ACTIONS(5737),
    [anon_sym_SEMI] = ACTIONS(5735),
    [anon_sym_STAR_STAR] = ACTIONS(5737),
    [anon_sym_AMP] = ACTIONS(5737),
    [anon_sym_EQ] = ACTIONS(5737),
    [anon_sym_LT] = ACTIONS(5737),
    [anon_sym_if] = ACTIONS(5735),
    [anon_sym_unless] = ACTIONS(5735),
    [anon_sym_while] = ACTIONS(5735),
    [anon_sym_until] = ACTIONS(5735),
    [anon_sym_rescue] = ACTIONS(5735),
    [anon_sym_do] = ACTIONS(993),
    [anon_sym_EQ_GT] = ACTIONS(993),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_COLON_COLON2] = ACTIONS(5735),
    [anon_sym_AMP_DOT] = ACTIONS(5735),
    [anon_sym_PLUS_EQ] = ACTIONS(5735),
    [anon_sym_DASH_EQ] = ACTIONS(5735),
    [anon_sym_STAR_EQ] = ACTIONS(5735),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5735),
    [anon_sym_SLASH_EQ] = ACTIONS(5735),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5735),
    [anon_sym_PIPE_EQ] = ACTIONS(5735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5735),
    [anon_sym_AMP_EQ] = ACTIONS(5735),
    [anon_sym_PERCENT_EQ] = ACTIONS(5735),
    [anon_sym_GT_GT_EQ] = ACTIONS(5735),
    [anon_sym_LT_LT_EQ] = ACTIONS(5735),
    [anon_sym_CARET_EQ] = ACTIONS(5735),
    [anon_sym_QMARK] = ACTIONS(5735),
    [anon_sym_COLON2] = ACTIONS(5737),
    [anon_sym_DOT_DOT] = ACTIONS(5737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5735),
    [anon_sym_and] = ACTIONS(5735),
    [anon_sym_or] = ACTIONS(5735),
    [anon_sym_PIPE_PIPE] = ACTIONS(5737),
    [anon_sym_AMP_AMP] = ACTIONS(5737),
    [anon_sym_LT_LT] = ACTIONS(5737),
    [anon_sym_GT_GT] = ACTIONS(5737),
    [anon_sym_EQ_EQ] = ACTIONS(5737),
    [anon_sym_BANG_EQ] = ACTIONS(5735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5735),
    [anon_sym_LT_EQ_GT] = ACTIONS(5735),
    [anon_sym_EQ_TILDE] = ACTIONS(5735),
    [anon_sym_BANG_TILDE] = ACTIONS(5735),
    [anon_sym_LT_EQ] = ACTIONS(5737),
    [anon_sym_GT] = ACTIONS(5737),
    [anon_sym_GT_EQ] = ACTIONS(5735),
    [anon_sym_CARET] = ACTIONS(5737),
    [anon_sym_PLUS] = ACTIONS(5737),
    [anon_sym_SLASH] = ACTIONS(5737),
    [anon_sym_PERCENT] = ACTIONS(5737),
    [sym_comment] = ACTIONS(87),
  },
  [3947] = {
    [anon_sym_RBRACE] = ACTIONS(10151),
    [sym_comment] = ACTIONS(87),
  },
  [3948] = {
    [sym__statements] = STATE(6653),
    [sym_begin_block] = STATE(489),
    [sym_end_block] = STATE(489),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(495),
    [aux_sym__statements_repeat1] = STATE(495),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(10151),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3949] = {
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(10117),
    [sym__binary_star] = ACTIONS(10119),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_RBRACE] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(10121),
    [anon_sym_STAR_STAR] = ACTIONS(10123),
    [anon_sym_AMP] = ACTIONS(10125),
    [anon_sym_EQ] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(10127),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_unless] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_until] = ACTIONS(3281),
    [anon_sym_rescue] = ACTIONS(3281),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_PLUS_EQ] = ACTIONS(3281),
    [anon_sym_DASH_EQ] = ACTIONS(3281),
    [anon_sym_STAR_EQ] = ACTIONS(3281),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3281),
    [anon_sym_SLASH_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3281),
    [anon_sym_AMP_EQ] = ACTIONS(3281),
    [anon_sym_PERCENT_EQ] = ACTIONS(3281),
    [anon_sym_GT_GT_EQ] = ACTIONS(3281),
    [anon_sym_LT_LT_EQ] = ACTIONS(3281),
    [anon_sym_CARET_EQ] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(10129),
    [anon_sym_DOT_DOT] = ACTIONS(10131),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10133),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(10135),
    [anon_sym_AMP_AMP] = ACTIONS(10135),
    [anon_sym_LT_LT] = ACTIONS(10137),
    [anon_sym_GT_GT] = ACTIONS(10137),
    [anon_sym_EQ_EQ] = ACTIONS(10135),
    [anon_sym_BANG_EQ] = ACTIONS(10139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10139),
    [anon_sym_LT_EQ_GT] = ACTIONS(10139),
    [anon_sym_EQ_TILDE] = ACTIONS(10139),
    [anon_sym_BANG_TILDE] = ACTIONS(10139),
    [anon_sym_LT_EQ] = ACTIONS(10127),
    [anon_sym_GT] = ACTIONS(10127),
    [anon_sym_GT_EQ] = ACTIONS(10141),
    [anon_sym_CARET] = ACTIONS(10121),
    [anon_sym_PLUS] = ACTIONS(10143),
    [anon_sym_SLASH] = ACTIONS(10123),
    [anon_sym_PERCENT] = ACTIONS(10123),
    [sym_comment] = ACTIONS(87),
  },
  [3950] = {
    [sym__binary_minus] = ACTIONS(5771),
    [sym__binary_star] = ACTIONS(5771),
    [anon_sym_LBRACE] = ACTIONS(5771),
    [anon_sym_RBRACE] = ACTIONS(5771),
    [anon_sym_RPAREN] = ACTIONS(5771),
    [anon_sym_DOT] = ACTIONS(5773),
    [anon_sym_COMMA] = ACTIONS(5771),
    [anon_sym_PIPE] = ACTIONS(5773),
    [anon_sym_SEMI] = ACTIONS(5771),
    [anon_sym_STAR_STAR] = ACTIONS(5773),
    [anon_sym_AMP] = ACTIONS(5773),
    [anon_sym_EQ] = ACTIONS(5773),
    [anon_sym_LT] = ACTIONS(5773),
    [anon_sym_if] = ACTIONS(5771),
    [anon_sym_unless] = ACTIONS(5771),
    [anon_sym_while] = ACTIONS(5771),
    [anon_sym_until] = ACTIONS(5771),
    [anon_sym_rescue] = ACTIONS(5771),
    [anon_sym_do] = ACTIONS(5771),
    [anon_sym_LBRACK] = ACTIONS(5771),
    [anon_sym_COLON_COLON2] = ACTIONS(5771),
    [anon_sym_AMP_DOT] = ACTIONS(5771),
    [anon_sym_PLUS_EQ] = ACTIONS(5771),
    [anon_sym_DASH_EQ] = ACTIONS(5771),
    [anon_sym_STAR_EQ] = ACTIONS(5771),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5771),
    [anon_sym_SLASH_EQ] = ACTIONS(5771),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5771),
    [anon_sym_PIPE_EQ] = ACTIONS(5771),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5771),
    [anon_sym_AMP_EQ] = ACTIONS(5771),
    [anon_sym_PERCENT_EQ] = ACTIONS(5771),
    [anon_sym_GT_GT_EQ] = ACTIONS(5771),
    [anon_sym_LT_LT_EQ] = ACTIONS(5771),
    [anon_sym_CARET_EQ] = ACTIONS(5771),
    [anon_sym_QMARK] = ACTIONS(5771),
    [anon_sym_COLON2] = ACTIONS(5773),
    [anon_sym_DOT_DOT] = ACTIONS(5773),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5771),
    [anon_sym_and] = ACTIONS(5771),
    [anon_sym_or] = ACTIONS(5771),
    [anon_sym_PIPE_PIPE] = ACTIONS(5773),
    [anon_sym_AMP_AMP] = ACTIONS(5773),
    [anon_sym_LT_LT] = ACTIONS(5773),
    [anon_sym_GT_GT] = ACTIONS(5773),
    [anon_sym_EQ_EQ] = ACTIONS(5773),
    [anon_sym_BANG_EQ] = ACTIONS(5771),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5771),
    [anon_sym_LT_EQ_GT] = ACTIONS(5771),
    [anon_sym_EQ_TILDE] = ACTIONS(5771),
    [anon_sym_BANG_TILDE] = ACTIONS(5771),
    [anon_sym_LT_EQ] = ACTIONS(5773),
    [anon_sym_GT] = ACTIONS(5773),
    [anon_sym_GT_EQ] = ACTIONS(5771),
    [anon_sym_CARET] = ACTIONS(5773),
    [anon_sym_PLUS] = ACTIONS(5773),
    [anon_sym_SLASH] = ACTIONS(5773),
    [anon_sym_PERCENT] = ACTIONS(5773),
    [sym_comment] = ACTIONS(87),
  },
  [3951] = {
    [anon_sym_end] = ACTIONS(10153),
    [sym_comment] = ACTIONS(87),
  },
  [3952] = {
    [sym__statements] = STATE(6655),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_heredoc_body] = STATE(6656),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [sym__terminator] = STATE(6656),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__line_break] = ACTIONS(10155),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(10155),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10157),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3953] = {
    [sym__statements] = STATE(6655),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_block_parameters] = STATE(6657),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10157),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3954] = {
    [sym__heredoc_body_start] = ACTIONS(4285),
    [sym__binary_minus] = ACTIONS(4285),
    [sym__binary_star] = ACTIONS(4285),
    [anon_sym_LBRACE] = ACTIONS(4285),
    [anon_sym_RBRACE] = ACTIONS(4285),
    [anon_sym_RPAREN] = ACTIONS(4285),
    [anon_sym_DOT] = ACTIONS(4287),
    [anon_sym_COMMA] = ACTIONS(4285),
    [anon_sym_PIPE] = ACTIONS(4287),
    [anon_sym_SEMI] = ACTIONS(4285),
    [anon_sym_STAR_STAR] = ACTIONS(4287),
    [anon_sym_AMP] = ACTIONS(4287),
    [anon_sym_EQ] = ACTIONS(4287),
    [anon_sym_LT] = ACTIONS(4287),
    [anon_sym_if] = ACTIONS(4285),
    [anon_sym_unless] = ACTIONS(4285),
    [anon_sym_while] = ACTIONS(4285),
    [anon_sym_until] = ACTIONS(4285),
    [anon_sym_rescue] = ACTIONS(4285),
    [anon_sym_in] = ACTIONS(4285),
    [anon_sym_do] = ACTIONS(4285),
    [anon_sym_LBRACK] = ACTIONS(4285),
    [anon_sym_RBRACK] = ACTIONS(4285),
    [anon_sym_COLON_COLON2] = ACTIONS(4285),
    [anon_sym_AMP_DOT] = ACTIONS(4285),
    [anon_sym_PLUS_EQ] = ACTIONS(4285),
    [anon_sym_DASH_EQ] = ACTIONS(4285),
    [anon_sym_STAR_EQ] = ACTIONS(4285),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4285),
    [anon_sym_SLASH_EQ] = ACTIONS(4285),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4285),
    [anon_sym_PIPE_EQ] = ACTIONS(4285),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4285),
    [anon_sym_AMP_EQ] = ACTIONS(4285),
    [anon_sym_PERCENT_EQ] = ACTIONS(4285),
    [anon_sym_GT_GT_EQ] = ACTIONS(4285),
    [anon_sym_LT_LT_EQ] = ACTIONS(4285),
    [anon_sym_CARET_EQ] = ACTIONS(4285),
    [anon_sym_QMARK] = ACTIONS(4285),
    [anon_sym_COLON2] = ACTIONS(4287),
    [anon_sym_DOT_DOT] = ACTIONS(4287),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4285),
    [anon_sym_and] = ACTIONS(4285),
    [anon_sym_or] = ACTIONS(4285),
    [anon_sym_PIPE_PIPE] = ACTIONS(4287),
    [anon_sym_AMP_AMP] = ACTIONS(4287),
    [anon_sym_LT_LT] = ACTIONS(4287),
    [anon_sym_GT_GT] = ACTIONS(4287),
    [anon_sym_EQ_EQ] = ACTIONS(4287),
    [anon_sym_BANG_EQ] = ACTIONS(4285),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4285),
    [anon_sym_LT_EQ_GT] = ACTIONS(4285),
    [anon_sym_EQ_TILDE] = ACTIONS(4285),
    [anon_sym_BANG_TILDE] = ACTIONS(4285),
    [anon_sym_LT_EQ] = ACTIONS(4287),
    [anon_sym_GT] = ACTIONS(4287),
    [anon_sym_GT_EQ] = ACTIONS(4285),
    [anon_sym_CARET] = ACTIONS(4287),
    [anon_sym_PLUS] = ACTIONS(4287),
    [anon_sym_SLASH] = ACTIONS(4287),
    [anon_sym_PERCENT] = ACTIONS(4287),
    [sym_comment] = ACTIONS(87),
  },
  [3955] = {
    [anon_sym_RPAREN] = ACTIONS(10159),
    [sym_comment] = ACTIONS(87),
  },
  [3956] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(6537),
    [sym__binary_star] = ACTIONS(6539),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(6541),
    [anon_sym_STAR_STAR] = ACTIONS(6543),
    [anon_sym_AMP] = ACTIONS(6545),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(6547),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(6549),
    [anon_sym_DOT_DOT] = ACTIONS(6551),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6553),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(6555),
    [anon_sym_AMP_AMP] = ACTIONS(6555),
    [anon_sym_LT_LT] = ACTIONS(6557),
    [anon_sym_GT_GT] = ACTIONS(6557),
    [anon_sym_EQ_EQ] = ACTIONS(6555),
    [anon_sym_BANG_EQ] = ACTIONS(6559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6559),
    [anon_sym_LT_EQ_GT] = ACTIONS(6559),
    [anon_sym_EQ_TILDE] = ACTIONS(6559),
    [anon_sym_BANG_TILDE] = ACTIONS(6559),
    [anon_sym_LT_EQ] = ACTIONS(6547),
    [anon_sym_GT] = ACTIONS(6547),
    [anon_sym_GT_EQ] = ACTIONS(6561),
    [anon_sym_CARET] = ACTIONS(6541),
    [anon_sym_PLUS] = ACTIONS(6563),
    [anon_sym_SLASH] = ACTIONS(6543),
    [anon_sym_PERCENT] = ACTIONS(6543),
    [sym_comment] = ACTIONS(87),
  },
  [3957] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(6659),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(3940),
    [sym_scope_resolution] = STATE(3938),
    [sym_call] = STATE(3938),
    [sym_method_call] = STATE(3940),
    [sym_assignment] = STATE(6659),
    [sym_operator_assignment] = STATE(6659),
    [sym_conditional] = STATE(6659),
    [sym_range] = STATE(6659),
    [sym_binary] = STATE(6659),
    [sym_unary] = STATE(6659),
    [sym_left_assignment_list] = STATE(3939),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3940),
    [sym__variable] = STATE(3938),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(3940),
    [sym_false] = STATE(3940),
    [sym_nil] = STATE(3940),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(3941),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(6469),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(6481),
    [anon_sym_yield] = ACTIONS(6483),
    [anon_sym_break] = ACTIONS(6485),
    [anon_sym_next] = ACTIONS(6487),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(6505),
    [anon_sym_defined_QMARK] = ACTIONS(6507),
    [anon_sym_not] = ACTIONS(6509),
    [anon_sym_BANG] = ACTIONS(6511),
    [anon_sym_TILDE] = ACTIONS(6511),
    [sym_constant] = ACTIONS(6513),
    [sym_identifier] = ACTIONS(6513),
    [sym_instance_variable] = ACTIONS(6515),
    [sym_class_variable] = ACTIONS(6515),
    [sym_global_variable] = ACTIONS(6515),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(6513),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6513),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [3958] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6660),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1686),
    [sym_scope_resolution] = STATE(1680),
    [sym_call] = STATE(1680),
    [sym_method_call] = STATE(1686),
    [sym_assignment] = STATE(6660),
    [sym_operator_assignment] = STATE(6660),
    [sym_conditional] = STATE(6660),
    [sym_range] = STATE(6660),
    [sym_binary] = STATE(6660),
    [sym_unary] = STATE(6660),
    [sym_left_assignment_list] = STATE(1685),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1686),
    [sym__variable] = STATE(1680),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1686),
    [sym_false] = STATE(1686),
    [sym_nil] = STATE(1686),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3944),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2992),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2998),
    [anon_sym_yield] = ACTIONS(3000),
    [anon_sym_break] = ACTIONS(3002),
    [anon_sym_next] = ACTIONS(3004),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6523),
    [anon_sym_defined_QMARK] = ACTIONS(3010),
    [anon_sym_not] = ACTIONS(3012),
    [anon_sym_BANG] = ACTIONS(3016),
    [anon_sym_TILDE] = ACTIONS(3016),
    [sym_constant] = ACTIONS(3022),
    [sym_identifier] = ACTIONS(3022),
    [sym_instance_variable] = ACTIONS(3020),
    [sym_class_variable] = ACTIONS(3020),
    [sym_global_variable] = ACTIONS(3020),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3022),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3022),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3959] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6661),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1686),
    [sym_scope_resolution] = STATE(1680),
    [sym_call] = STATE(1680),
    [sym_method_call] = STATE(1686),
    [sym_assignment] = STATE(6661),
    [sym_operator_assignment] = STATE(6661),
    [sym_conditional] = STATE(6661),
    [sym_range] = STATE(6661),
    [sym_binary] = STATE(6661),
    [sym_unary] = STATE(6661),
    [sym_left_assignment_list] = STATE(1685),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1686),
    [sym__variable] = STATE(1680),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1686),
    [sym_false] = STATE(1686),
    [sym_nil] = STATE(1686),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3944),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2992),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2998),
    [anon_sym_yield] = ACTIONS(3000),
    [anon_sym_break] = ACTIONS(3002),
    [anon_sym_next] = ACTIONS(3004),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6523),
    [anon_sym_defined_QMARK] = ACTIONS(3010),
    [anon_sym_not] = ACTIONS(3012),
    [anon_sym_BANG] = ACTIONS(3016),
    [anon_sym_TILDE] = ACTIONS(3016),
    [sym_constant] = ACTIONS(3022),
    [sym_identifier] = ACTIONS(3022),
    [sym_instance_variable] = ACTIONS(3020),
    [sym_class_variable] = ACTIONS(3020),
    [sym_global_variable] = ACTIONS(3020),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3022),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3022),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3960] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6662),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1686),
    [sym_scope_resolution] = STATE(1680),
    [sym_call] = STATE(1680),
    [sym_method_call] = STATE(1686),
    [sym_assignment] = STATE(6662),
    [sym_operator_assignment] = STATE(6662),
    [sym_conditional] = STATE(6662),
    [sym_range] = STATE(6662),
    [sym_binary] = STATE(6662),
    [sym_unary] = STATE(6662),
    [sym_left_assignment_list] = STATE(1685),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1686),
    [sym__variable] = STATE(1680),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1686),
    [sym_false] = STATE(1686),
    [sym_nil] = STATE(1686),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3944),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2992),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2998),
    [anon_sym_yield] = ACTIONS(3000),
    [anon_sym_break] = ACTIONS(3002),
    [anon_sym_next] = ACTIONS(3004),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6523),
    [anon_sym_defined_QMARK] = ACTIONS(3010),
    [anon_sym_not] = ACTIONS(3012),
    [anon_sym_BANG] = ACTIONS(3016),
    [anon_sym_TILDE] = ACTIONS(3016),
    [sym_constant] = ACTIONS(3022),
    [sym_identifier] = ACTIONS(3022),
    [sym_instance_variable] = ACTIONS(3020),
    [sym_class_variable] = ACTIONS(3020),
    [sym_global_variable] = ACTIONS(3020),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3022),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3022),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3961] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6663),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1686),
    [sym_scope_resolution] = STATE(1680),
    [sym_call] = STATE(1680),
    [sym_method_call] = STATE(1686),
    [sym_assignment] = STATE(6663),
    [sym_operator_assignment] = STATE(6663),
    [sym_conditional] = STATE(6663),
    [sym_range] = STATE(6663),
    [sym_binary] = STATE(6663),
    [sym_unary] = STATE(6663),
    [sym_left_assignment_list] = STATE(1685),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1686),
    [sym__variable] = STATE(1680),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1686),
    [sym_false] = STATE(1686),
    [sym_nil] = STATE(1686),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3944),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2992),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2998),
    [anon_sym_yield] = ACTIONS(3000),
    [anon_sym_break] = ACTIONS(3002),
    [anon_sym_next] = ACTIONS(3004),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6523),
    [anon_sym_defined_QMARK] = ACTIONS(3010),
    [anon_sym_not] = ACTIONS(3012),
    [anon_sym_BANG] = ACTIONS(3016),
    [anon_sym_TILDE] = ACTIONS(3016),
    [sym_constant] = ACTIONS(3022),
    [sym_identifier] = ACTIONS(3022),
    [sym_instance_variable] = ACTIONS(3020),
    [sym_class_variable] = ACTIONS(3020),
    [sym_global_variable] = ACTIONS(3020),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3022),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3022),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3962] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6664),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1686),
    [sym_scope_resolution] = STATE(1680),
    [sym_call] = STATE(1680),
    [sym_method_call] = STATE(1686),
    [sym_assignment] = STATE(6664),
    [sym_operator_assignment] = STATE(6664),
    [sym_conditional] = STATE(6664),
    [sym_range] = STATE(6664),
    [sym_binary] = STATE(6664),
    [sym_unary] = STATE(6664),
    [sym_left_assignment_list] = STATE(1685),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1686),
    [sym__variable] = STATE(1680),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1686),
    [sym_false] = STATE(1686),
    [sym_nil] = STATE(1686),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3944),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2992),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2998),
    [anon_sym_yield] = ACTIONS(3000),
    [anon_sym_break] = ACTIONS(3002),
    [anon_sym_next] = ACTIONS(3004),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6523),
    [anon_sym_defined_QMARK] = ACTIONS(3010),
    [anon_sym_not] = ACTIONS(3012),
    [anon_sym_BANG] = ACTIONS(3016),
    [anon_sym_TILDE] = ACTIONS(3016),
    [sym_constant] = ACTIONS(3022),
    [sym_identifier] = ACTIONS(3022),
    [sym_instance_variable] = ACTIONS(3020),
    [sym_class_variable] = ACTIONS(3020),
    [sym_global_variable] = ACTIONS(3020),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3022),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3022),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3963] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(6665),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(6665),
    [sym_operator_assignment] = STATE(6665),
    [sym_conditional] = STATE(6665),
    [sym_range] = STATE(6665),
    [sym_binary] = STATE(6665),
    [sym_unary] = STATE(6665),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3964] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6666),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1686),
    [sym_scope_resolution] = STATE(1680),
    [sym_call] = STATE(1680),
    [sym_method_call] = STATE(1686),
    [sym_assignment] = STATE(6666),
    [sym_operator_assignment] = STATE(6666),
    [sym_conditional] = STATE(6666),
    [sym_range] = STATE(6666),
    [sym_binary] = STATE(6666),
    [sym_unary] = STATE(6666),
    [sym_left_assignment_list] = STATE(1685),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1686),
    [sym__variable] = STATE(1680),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1686),
    [sym_false] = STATE(1686),
    [sym_nil] = STATE(1686),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3944),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2992),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2998),
    [anon_sym_yield] = ACTIONS(3000),
    [anon_sym_break] = ACTIONS(3002),
    [anon_sym_next] = ACTIONS(3004),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6523),
    [anon_sym_defined_QMARK] = ACTIONS(3010),
    [anon_sym_not] = ACTIONS(3012),
    [anon_sym_BANG] = ACTIONS(3016),
    [anon_sym_TILDE] = ACTIONS(3016),
    [sym_constant] = ACTIONS(3022),
    [sym_identifier] = ACTIONS(3022),
    [sym_instance_variable] = ACTIONS(3020),
    [sym_class_variable] = ACTIONS(3020),
    [sym_global_variable] = ACTIONS(3020),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3022),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3022),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3965] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6667),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1686),
    [sym_scope_resolution] = STATE(1680),
    [sym_call] = STATE(1680),
    [sym_method_call] = STATE(1686),
    [sym_assignment] = STATE(6667),
    [sym_operator_assignment] = STATE(6667),
    [sym_conditional] = STATE(6667),
    [sym_range] = STATE(6667),
    [sym_binary] = STATE(6667),
    [sym_unary] = STATE(6667),
    [sym_left_assignment_list] = STATE(1685),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1686),
    [sym__variable] = STATE(1680),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1686),
    [sym_false] = STATE(1686),
    [sym_nil] = STATE(1686),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3944),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2992),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2998),
    [anon_sym_yield] = ACTIONS(3000),
    [anon_sym_break] = ACTIONS(3002),
    [anon_sym_next] = ACTIONS(3004),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6523),
    [anon_sym_defined_QMARK] = ACTIONS(3010),
    [anon_sym_not] = ACTIONS(3012),
    [anon_sym_BANG] = ACTIONS(3016),
    [anon_sym_TILDE] = ACTIONS(3016),
    [sym_constant] = ACTIONS(3022),
    [sym_identifier] = ACTIONS(3022),
    [sym_instance_variable] = ACTIONS(3020),
    [sym_class_variable] = ACTIONS(3020),
    [sym_global_variable] = ACTIONS(3020),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3022),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3022),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3966] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6668),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1686),
    [sym_scope_resolution] = STATE(1680),
    [sym_call] = STATE(1680),
    [sym_method_call] = STATE(1686),
    [sym_assignment] = STATE(6668),
    [sym_operator_assignment] = STATE(6668),
    [sym_conditional] = STATE(6668),
    [sym_range] = STATE(6668),
    [sym_binary] = STATE(6668),
    [sym_unary] = STATE(6668),
    [sym_left_assignment_list] = STATE(1685),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1686),
    [sym__variable] = STATE(1680),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1686),
    [sym_false] = STATE(1686),
    [sym_nil] = STATE(1686),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3944),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2992),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2998),
    [anon_sym_yield] = ACTIONS(3000),
    [anon_sym_break] = ACTIONS(3002),
    [anon_sym_next] = ACTIONS(3004),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6523),
    [anon_sym_defined_QMARK] = ACTIONS(3010),
    [anon_sym_not] = ACTIONS(3012),
    [anon_sym_BANG] = ACTIONS(3016),
    [anon_sym_TILDE] = ACTIONS(3016),
    [sym_constant] = ACTIONS(3022),
    [sym_identifier] = ACTIONS(3022),
    [sym_instance_variable] = ACTIONS(3020),
    [sym_class_variable] = ACTIONS(3020),
    [sym_global_variable] = ACTIONS(3020),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3022),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3022),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3967] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6669),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1686),
    [sym_scope_resolution] = STATE(1680),
    [sym_call] = STATE(1680),
    [sym_method_call] = STATE(1686),
    [sym_assignment] = STATE(6669),
    [sym_operator_assignment] = STATE(6669),
    [sym_conditional] = STATE(6669),
    [sym_range] = STATE(6669),
    [sym_binary] = STATE(6669),
    [sym_unary] = STATE(6669),
    [sym_left_assignment_list] = STATE(1685),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1686),
    [sym__variable] = STATE(1680),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1686),
    [sym_false] = STATE(1686),
    [sym_nil] = STATE(1686),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3944),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2992),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2998),
    [anon_sym_yield] = ACTIONS(3000),
    [anon_sym_break] = ACTIONS(3002),
    [anon_sym_next] = ACTIONS(3004),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6523),
    [anon_sym_defined_QMARK] = ACTIONS(3010),
    [anon_sym_not] = ACTIONS(3012),
    [anon_sym_BANG] = ACTIONS(3016),
    [anon_sym_TILDE] = ACTIONS(3016),
    [sym_constant] = ACTIONS(3022),
    [sym_identifier] = ACTIONS(3022),
    [sym_instance_variable] = ACTIONS(3020),
    [sym_class_variable] = ACTIONS(3020),
    [sym_global_variable] = ACTIONS(3020),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3022),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3022),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3968] = {
    [sym__statements] = STATE(3947),
    [sym_begin_block] = STATE(489),
    [sym_end_block] = STATE(489),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_block_parameters] = STATE(3948),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(495),
    [aux_sym__statements_repeat1] = STATE(495),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(10161),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2445),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3969] = {
    [sym__binary_minus] = ACTIONS(6155),
    [sym__binary_star] = ACTIONS(6155),
    [anon_sym_LBRACE] = ACTIONS(6155),
    [anon_sym_RBRACE] = ACTIONS(6155),
    [anon_sym_RPAREN] = ACTIONS(6155),
    [anon_sym_DOT] = ACTIONS(6157),
    [anon_sym_COMMA] = ACTIONS(6155),
    [anon_sym_PIPE] = ACTIONS(6157),
    [anon_sym_SEMI] = ACTIONS(6155),
    [anon_sym_STAR_STAR] = ACTIONS(6157),
    [anon_sym_AMP] = ACTIONS(6157),
    [anon_sym_EQ] = ACTIONS(6157),
    [anon_sym_LT] = ACTIONS(6157),
    [anon_sym_if] = ACTIONS(6155),
    [anon_sym_unless] = ACTIONS(6155),
    [anon_sym_while] = ACTIONS(6155),
    [anon_sym_until] = ACTIONS(6155),
    [anon_sym_rescue] = ACTIONS(6155),
    [anon_sym_do] = ACTIONS(6155),
    [anon_sym_LBRACK] = ACTIONS(6155),
    [anon_sym_COLON_COLON2] = ACTIONS(6155),
    [anon_sym_AMP_DOT] = ACTIONS(6155),
    [anon_sym_PLUS_EQ] = ACTIONS(6155),
    [anon_sym_DASH_EQ] = ACTIONS(6155),
    [anon_sym_STAR_EQ] = ACTIONS(6155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6155),
    [anon_sym_SLASH_EQ] = ACTIONS(6155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6155),
    [anon_sym_PIPE_EQ] = ACTIONS(6155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6155),
    [anon_sym_AMP_EQ] = ACTIONS(6155),
    [anon_sym_PERCENT_EQ] = ACTIONS(6155),
    [anon_sym_GT_GT_EQ] = ACTIONS(6155),
    [anon_sym_LT_LT_EQ] = ACTIONS(6155),
    [anon_sym_CARET_EQ] = ACTIONS(6155),
    [anon_sym_QMARK] = ACTIONS(6155),
    [anon_sym_COLON2] = ACTIONS(6157),
    [anon_sym_DOT_DOT] = ACTIONS(6157),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6155),
    [anon_sym_and] = ACTIONS(6155),
    [anon_sym_or] = ACTIONS(6155),
    [anon_sym_PIPE_PIPE] = ACTIONS(6157),
    [anon_sym_AMP_AMP] = ACTIONS(6157),
    [anon_sym_LT_LT] = ACTIONS(6157),
    [anon_sym_GT_GT] = ACTIONS(6157),
    [anon_sym_EQ_EQ] = ACTIONS(6157),
    [anon_sym_BANG_EQ] = ACTIONS(6155),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6155),
    [anon_sym_LT_EQ_GT] = ACTIONS(6155),
    [anon_sym_EQ_TILDE] = ACTIONS(6155),
    [anon_sym_BANG_TILDE] = ACTIONS(6155),
    [anon_sym_LT_EQ] = ACTIONS(6157),
    [anon_sym_GT] = ACTIONS(6157),
    [anon_sym_GT_EQ] = ACTIONS(6155),
    [anon_sym_CARET] = ACTIONS(6157),
    [anon_sym_PLUS] = ACTIONS(6157),
    [anon_sym_SLASH] = ACTIONS(6157),
    [anon_sym_PERCENT] = ACTIONS(6157),
    [sym_comment] = ACTIONS(87),
  },
  [3970] = {
    [sym_interpolation] = STATE(6672),
    [aux_sym_heredoc_body_repeat1] = STATE(6672),
    [sym__heredoc_content] = ACTIONS(10163),
    [sym_heredoc_end] = ACTIONS(10165),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(10163),
  },
  [3971] = {
    [sym_heredoc_body] = STATE(6673),
    [aux_sym_call_repeat1] = STATE(6673),
    [sym__heredoc_body_start] = ACTIONS(6569),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_RBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [3972] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1679),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1686),
    [sym_scope_resolution] = STATE(1680),
    [sym_call] = STATE(1680),
    [sym_method_call] = STATE(1686),
    [sym__argument] = STATE(6674),
    [sym_splat_argument] = STATE(6674),
    [sym_hash_splat_argument] = STATE(6674),
    [sym_block_argument] = STATE(6674),
    [sym_assignment] = STATE(1679),
    [sym_operator_assignment] = STATE(1679),
    [sym_conditional] = STATE(1679),
    [sym_range] = STATE(1679),
    [sym_binary] = STATE(1679),
    [sym_unary] = STATE(1679),
    [sym_left_assignment_list] = STATE(1685),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1686),
    [sym__variable] = STATE(1680),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1686),
    [sym_false] = STATE(1686),
    [sym_nil] = STATE(1686),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1687),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_heredoc_body] = STATE(6675),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(6674),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(2988),
    [sym__splat_star] = ACTIONS(2990),
    [sym__unary_minus] = ACTIONS(2992),
    [sym__identifier_hash_key] = ACTIONS(2994),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10167),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2998),
    [anon_sym_yield] = ACTIONS(3000),
    [anon_sym_break] = ACTIONS(3002),
    [anon_sym_next] = ACTIONS(3004),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6523),
    [anon_sym_defined_QMARK] = ACTIONS(3010),
    [anon_sym_not] = ACTIONS(3012),
    [anon_sym_BANG] = ACTIONS(3016),
    [anon_sym_TILDE] = ACTIONS(3016),
    [sym_constant] = ACTIONS(3018),
    [sym_identifier] = ACTIONS(3018),
    [sym_instance_variable] = ACTIONS(3020),
    [sym_class_variable] = ACTIONS(3020),
    [sym_global_variable] = ACTIONS(3020),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3022),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3022),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3973] = {
    [sym_heredoc_body] = STATE(6676),
    [aux_sym_call_repeat1] = STATE(6676),
    [aux_sym_argument_list_repeat1] = STATE(6677),
    [sym__heredoc_body_start] = ACTIONS(6569),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_RBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(6571),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [3974] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6678),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1686),
    [sym_scope_resolution] = STATE(1680),
    [sym_call] = STATE(1680),
    [sym_method_call] = STATE(1686),
    [sym_splat_argument] = STATE(6679),
    [sym_assignment] = STATE(6678),
    [sym_operator_assignment] = STATE(6678),
    [sym_conditional] = STATE(6678),
    [sym_range] = STATE(6678),
    [sym_binary] = STATE(6678),
    [sym_unary] = STATE(6678),
    [sym_right_assignment_list] = STATE(4362),
    [sym__arg_or_splat_arg] = STATE(6679),
    [sym_left_assignment_list] = STATE(1685),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1686),
    [sym__variable] = STATE(1680),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1686),
    [sym_false] = STATE(1686),
    [sym_nil] = STATE(1686),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3944),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__splat_star] = ACTIONS(6415),
    [sym__unary_minus] = ACTIONS(2992),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2998),
    [anon_sym_yield] = ACTIONS(3000),
    [anon_sym_break] = ACTIONS(3002),
    [anon_sym_next] = ACTIONS(3004),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6523),
    [anon_sym_defined_QMARK] = ACTIONS(3010),
    [anon_sym_not] = ACTIONS(3012),
    [anon_sym_BANG] = ACTIONS(3016),
    [anon_sym_TILDE] = ACTIONS(3016),
    [sym_constant] = ACTIONS(3022),
    [sym_identifier] = ACTIONS(3022),
    [sym_instance_variable] = ACTIONS(3020),
    [sym_class_variable] = ACTIONS(3020),
    [sym_global_variable] = ACTIONS(3020),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3022),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3022),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3975] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6680),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1686),
    [sym_scope_resolution] = STATE(1680),
    [sym_call] = STATE(1680),
    [sym_method_call] = STATE(1686),
    [sym_assignment] = STATE(6680),
    [sym_operator_assignment] = STATE(6680),
    [sym_conditional] = STATE(6680),
    [sym_range] = STATE(6680),
    [sym_binary] = STATE(6680),
    [sym_unary] = STATE(6680),
    [sym_left_assignment_list] = STATE(1685),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1686),
    [sym__variable] = STATE(1680),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1686),
    [sym_false] = STATE(1686),
    [sym_nil] = STATE(1686),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3944),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2992),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2998),
    [anon_sym_yield] = ACTIONS(3000),
    [anon_sym_break] = ACTIONS(3002),
    [anon_sym_next] = ACTIONS(3004),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6523),
    [anon_sym_defined_QMARK] = ACTIONS(3010),
    [anon_sym_not] = ACTIONS(3012),
    [anon_sym_BANG] = ACTIONS(3016),
    [anon_sym_TILDE] = ACTIONS(3016),
    [sym_constant] = ACTIONS(3022),
    [sym_identifier] = ACTIONS(3022),
    [sym_instance_variable] = ACTIONS(3020),
    [sym_class_variable] = ACTIONS(3020),
    [sym_global_variable] = ACTIONS(3020),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3022),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3022),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3976] = {
    [sym_string] = STATE(6681),
    [aux_sym_chained_string_repeat1] = STATE(6681),
    [sym__string_start] = ACTIONS(1141),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_RBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_STAR_STAR] = ACTIONS(2755),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_EQ] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_EQ_GT] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_PLUS_EQ] = ACTIONS(2753),
    [anon_sym_DASH_EQ] = ACTIONS(2753),
    [anon_sym_STAR_EQ] = ACTIONS(2753),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2753),
    [anon_sym_SLASH_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2753),
    [anon_sym_AMP_EQ] = ACTIONS(2753),
    [anon_sym_PERCENT_EQ] = ACTIONS(2753),
    [anon_sym_GT_GT_EQ] = ACTIONS(2753),
    [anon_sym_LT_LT_EQ] = ACTIONS(2753),
    [anon_sym_CARET_EQ] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2755),
    [anon_sym_AMP_AMP] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2755),
    [anon_sym_GT_GT] = ACTIONS(2755),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_SLASH] = ACTIONS(2755),
    [anon_sym_PERCENT] = ACTIONS(2755),
    [sym_comment] = ACTIONS(87),
  },
  [3977] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(6682),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(3988),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym_method_call] = STATE(3988),
    [sym_assignment] = STATE(6682),
    [sym_operator_assignment] = STATE(6682),
    [sym_conditional] = STATE(6682),
    [sym_range] = STATE(6682),
    [sym_binary] = STATE(6682),
    [sym_unary] = STATE(6682),
    [sym_left_assignment_list] = STATE(3987),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3988),
    [sym__variable] = STATE(455),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(3988),
    [sym_false] = STATE(3988),
    [sym_nil] = STATE(3988),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(3989),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(6583),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6585),
    [anon_sym_yield] = ACTIONS(6587),
    [anon_sym_break] = ACTIONS(6589),
    [anon_sym_next] = ACTIONS(6591),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6593),
    [anon_sym_defined_QMARK] = ACTIONS(6595),
    [anon_sym_not] = ACTIONS(6597),
    [anon_sym_BANG] = ACTIONS(6599),
    [anon_sym_TILDE] = ACTIONS(6599),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3978] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(6683),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(3988),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym_method_call] = STATE(3988),
    [sym_assignment] = STATE(6683),
    [sym_operator_assignment] = STATE(6683),
    [sym_conditional] = STATE(6683),
    [sym_range] = STATE(6683),
    [sym_binary] = STATE(6683),
    [sym_unary] = STATE(6683),
    [sym_left_assignment_list] = STATE(3987),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3988),
    [sym__variable] = STATE(455),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(3988),
    [sym_false] = STATE(3988),
    [sym_nil] = STATE(3988),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(3989),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(6583),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6585),
    [anon_sym_yield] = ACTIONS(6587),
    [anon_sym_break] = ACTIONS(6589),
    [anon_sym_next] = ACTIONS(6591),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6593),
    [anon_sym_defined_QMARK] = ACTIONS(6595),
    [anon_sym_not] = ACTIONS(6597),
    [anon_sym_BANG] = ACTIONS(6599),
    [anon_sym_TILDE] = ACTIONS(6599),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3979] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(1633),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1638),
    [sym_scope_resolution] = STATE(1634),
    [sym_call] = STATE(1634),
    [sym_method_call] = STATE(1638),
    [sym_argument_list] = STATE(563),
    [sym__argument_list_with_parens] = STATE(6526),
    [sym__argument] = STATE(6527),
    [sym_splat_argument] = STATE(6527),
    [sym_hash_splat_argument] = STATE(6527),
    [sym_block_argument] = STATE(6527),
    [sym_assignment] = STATE(1633),
    [sym_operator_assignment] = STATE(1633),
    [sym_conditional] = STATE(1633),
    [sym_range] = STATE(1633),
    [sym_binary] = STATE(1633),
    [sym_unary] = STATE(1633),
    [sym_left_assignment_list] = STATE(1637),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1638),
    [sym__variable] = STATE(1634),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1638),
    [sym_false] = STATE(1638),
    [sym_nil] = STATE(1638),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1639),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(6527),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(2900),
    [sym__splat_star] = ACTIONS(2902),
    [sym__unary_minus] = ACTIONS(2904),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(2906),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(2910),
    [anon_sym_break] = ACTIONS(2912),
    [anon_sym_next] = ACTIONS(2914),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(2916),
    [anon_sym_not] = ACTIONS(2918),
    [anon_sym_BANG] = ACTIONS(2920),
    [anon_sym_TILDE] = ACTIONS(2922),
    [sym_constant] = ACTIONS(2924),
    [sym_identifier] = ACTIONS(2924),
    [sym_instance_variable] = ACTIONS(2926),
    [sym_class_variable] = ACTIONS(2926),
    [sym_global_variable] = ACTIONS(2926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2928),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2928),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3980] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(1633),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1638),
    [sym_scope_resolution] = STATE(1634),
    [sym_call] = STATE(1634),
    [sym_method_call] = STATE(1638),
    [sym_argument_list] = STATE(569),
    [sym__argument_list_with_parens] = STATE(6526),
    [sym__argument] = STATE(6527),
    [sym_splat_argument] = STATE(6527),
    [sym_hash_splat_argument] = STATE(6527),
    [sym_block_argument] = STATE(6527),
    [sym_assignment] = STATE(1633),
    [sym_operator_assignment] = STATE(1633),
    [sym_conditional] = STATE(1633),
    [sym_range] = STATE(1633),
    [sym_binary] = STATE(1633),
    [sym_unary] = STATE(1633),
    [sym_left_assignment_list] = STATE(1637),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1638),
    [sym__variable] = STATE(1634),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1638),
    [sym_false] = STATE(1638),
    [sym_nil] = STATE(1638),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1639),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(6527),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(2900),
    [sym__splat_star] = ACTIONS(2902),
    [sym__unary_minus] = ACTIONS(2904),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(2906),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(2910),
    [anon_sym_break] = ACTIONS(2912),
    [anon_sym_next] = ACTIONS(2914),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(2916),
    [anon_sym_not] = ACTIONS(2918),
    [anon_sym_BANG] = ACTIONS(2920),
    [anon_sym_TILDE] = ACTIONS(2922),
    [sym_constant] = ACTIONS(2924),
    [sym_identifier] = ACTIONS(2924),
    [sym_instance_variable] = ACTIONS(2926),
    [sym_class_variable] = ACTIONS(2926),
    [sym_global_variable] = ACTIONS(2926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2928),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2928),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3981] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(1633),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1638),
    [sym_scope_resolution] = STATE(1634),
    [sym_call] = STATE(1634),
    [sym_method_call] = STATE(1638),
    [sym_argument_list] = STATE(570),
    [sym__argument_list_with_parens] = STATE(6526),
    [sym__argument] = STATE(6527),
    [sym_splat_argument] = STATE(6527),
    [sym_hash_splat_argument] = STATE(6527),
    [sym_block_argument] = STATE(6527),
    [sym_assignment] = STATE(1633),
    [sym_operator_assignment] = STATE(1633),
    [sym_conditional] = STATE(1633),
    [sym_range] = STATE(1633),
    [sym_binary] = STATE(1633),
    [sym_unary] = STATE(1633),
    [sym_left_assignment_list] = STATE(1637),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1638),
    [sym__variable] = STATE(1634),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1638),
    [sym_false] = STATE(1638),
    [sym_nil] = STATE(1638),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1639),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(6527),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(2900),
    [sym__splat_star] = ACTIONS(2902),
    [sym__unary_minus] = ACTIONS(2904),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(2906),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(2910),
    [anon_sym_break] = ACTIONS(2912),
    [anon_sym_next] = ACTIONS(2914),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(2916),
    [anon_sym_not] = ACTIONS(2918),
    [anon_sym_BANG] = ACTIONS(2920),
    [anon_sym_TILDE] = ACTIONS(2922),
    [sym_constant] = ACTIONS(2924),
    [sym_identifier] = ACTIONS(2924),
    [sym_instance_variable] = ACTIONS(2926),
    [sym_class_variable] = ACTIONS(2926),
    [sym_global_variable] = ACTIONS(2926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2928),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2928),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3982] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(1633),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1638),
    [sym_scope_resolution] = STATE(1634),
    [sym_call] = STATE(1634),
    [sym_method_call] = STATE(1638),
    [sym_argument_list] = STATE(571),
    [sym__argument_list_with_parens] = STATE(6526),
    [sym__argument] = STATE(6527),
    [sym_splat_argument] = STATE(6527),
    [sym_hash_splat_argument] = STATE(6527),
    [sym_block_argument] = STATE(6527),
    [sym_assignment] = STATE(1633),
    [sym_operator_assignment] = STATE(1633),
    [sym_conditional] = STATE(1633),
    [sym_range] = STATE(1633),
    [sym_binary] = STATE(1633),
    [sym_unary] = STATE(1633),
    [sym_left_assignment_list] = STATE(1637),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1638),
    [sym__variable] = STATE(1634),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1638),
    [sym_false] = STATE(1638),
    [sym_nil] = STATE(1638),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1639),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(6527),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(2900),
    [sym__splat_star] = ACTIONS(2902),
    [sym__unary_minus] = ACTIONS(2904),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(2906),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(2910),
    [anon_sym_break] = ACTIONS(2912),
    [anon_sym_next] = ACTIONS(2914),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(2916),
    [anon_sym_not] = ACTIONS(2918),
    [anon_sym_BANG] = ACTIONS(2920),
    [anon_sym_TILDE] = ACTIONS(2922),
    [sym_constant] = ACTIONS(2924),
    [sym_identifier] = ACTIONS(2924),
    [sym_instance_variable] = ACTIONS(2926),
    [sym_class_variable] = ACTIONS(2926),
    [sym_global_variable] = ACTIONS(2926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2928),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2928),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3983] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(6684),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(3988),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym_method_call] = STATE(3988),
    [sym_assignment] = STATE(6684),
    [sym_operator_assignment] = STATE(6684),
    [sym_conditional] = STATE(6684),
    [sym_range] = STATE(6684),
    [sym_binary] = STATE(6684),
    [sym_unary] = STATE(6684),
    [sym_left_assignment_list] = STATE(3987),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3988),
    [sym__variable] = STATE(455),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(3988),
    [sym_false] = STATE(3988),
    [sym_nil] = STATE(3988),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(3989),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(6583),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6585),
    [anon_sym_yield] = ACTIONS(6587),
    [anon_sym_break] = ACTIONS(6589),
    [anon_sym_next] = ACTIONS(6591),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6593),
    [anon_sym_defined_QMARK] = ACTIONS(6595),
    [anon_sym_not] = ACTIONS(6597),
    [anon_sym_BANG] = ACTIONS(6599),
    [anon_sym_TILDE] = ACTIONS(6599),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3984] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(586),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(3988),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym_method_call] = STATE(3988),
    [sym_assignment] = STATE(586),
    [sym_operator_assignment] = STATE(586),
    [sym_conditional] = STATE(586),
    [sym_range] = STATE(586),
    [sym_binary] = STATE(586),
    [sym_unary] = STATE(586),
    [sym_left_assignment_list] = STATE(3987),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3988),
    [sym__variable] = STATE(455),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(3988),
    [sym_false] = STATE(3988),
    [sym_nil] = STATE(3988),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(3989),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(6583),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6585),
    [anon_sym_yield] = ACTIONS(6587),
    [anon_sym_break] = ACTIONS(6589),
    [anon_sym_next] = ACTIONS(6591),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6593),
    [anon_sym_defined_QMARK] = ACTIONS(6595),
    [anon_sym_not] = ACTIONS(6597),
    [anon_sym_BANG] = ACTIONS(6599),
    [anon_sym_TILDE] = ACTIONS(6599),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3985] = {
    [sym__binary_minus] = ACTIONS(10169),
    [sym__binary_star] = ACTIONS(10171),
    [anon_sym_RBRACE] = ACTIONS(5115),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(10173),
    [anon_sym_STAR_STAR] = ACTIONS(10171),
    [anon_sym_AMP] = ACTIONS(10175),
    [anon_sym_LT] = ACTIONS(10177),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(10179),
    [anon_sym_DOT_DOT] = ACTIONS(10181),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10183),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(10185),
    [anon_sym_AMP_AMP] = ACTIONS(10185),
    [anon_sym_LT_LT] = ACTIONS(10187),
    [anon_sym_GT_GT] = ACTIONS(10187),
    [anon_sym_EQ_EQ] = ACTIONS(10189),
    [anon_sym_BANG_EQ] = ACTIONS(10185),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10185),
    [anon_sym_LT_EQ_GT] = ACTIONS(10185),
    [anon_sym_EQ_TILDE] = ACTIONS(10185),
    [anon_sym_BANG_TILDE] = ACTIONS(10185),
    [anon_sym_LT_EQ] = ACTIONS(10177),
    [anon_sym_GT] = ACTIONS(10177),
    [anon_sym_GT_EQ] = ACTIONS(10191),
    [anon_sym_CARET] = ACTIONS(10193),
    [anon_sym_PLUS] = ACTIONS(10169),
    [anon_sym_SLASH] = ACTIONS(10171),
    [anon_sym_PERCENT] = ACTIONS(10171),
    [sym_comment] = ACTIONS(87),
  },
  [3986] = {
    [aux_sym_exceptions_repeat1] = STATE(6696),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_RBRACE] = ACTIONS(6191),
    [anon_sym_COMMA] = ACTIONS(10195),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [3987] = {
    [anon_sym_EQ] = ACTIONS(10197),
    [sym_comment] = ACTIONS(87),
  },
  [3988] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(10199),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(10201),
    [anon_sym_DASH_EQ] = ACTIONS(10201),
    [anon_sym_STAR_EQ] = ACTIONS(10201),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10201),
    [anon_sym_SLASH_EQ] = ACTIONS(10201),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10201),
    [anon_sym_PIPE_EQ] = ACTIONS(10201),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10201),
    [anon_sym_AMP_EQ] = ACTIONS(10201),
    [anon_sym_PERCENT_EQ] = ACTIONS(10201),
    [anon_sym_GT_GT_EQ] = ACTIONS(10201),
    [anon_sym_LT_LT_EQ] = ACTIONS(10201),
    [anon_sym_CARET_EQ] = ACTIONS(10201),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3989] = {
    [sym_string] = STATE(6699),
    [aux_sym_chained_string_repeat1] = STATE(6699),
    [sym__string_start] = ACTIONS(139),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [3990] = {
    [sym__binary_minus] = ACTIONS(2952),
    [sym__binary_star] = ACTIONS(2954),
    [anon_sym_RBRACE] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(2956),
    [anon_sym_STAR_STAR] = ACTIONS(2954),
    [anon_sym_AMP] = ACTIONS(2958),
    [anon_sym_LT] = ACTIONS(2960),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(2962),
    [anon_sym_DOT_DOT] = ACTIONS(2964),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2966),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(2970),
    [anon_sym_AMP_AMP] = ACTIONS(2970),
    [anon_sym_LT_LT] = ACTIONS(2972),
    [anon_sym_GT_GT] = ACTIONS(2972),
    [anon_sym_EQ_EQ] = ACTIONS(2974),
    [anon_sym_BANG_EQ] = ACTIONS(2970),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2970),
    [anon_sym_LT_EQ_GT] = ACTIONS(2970),
    [anon_sym_EQ_TILDE] = ACTIONS(2970),
    [anon_sym_BANG_TILDE] = ACTIONS(2970),
    [anon_sym_LT_EQ] = ACTIONS(2960),
    [anon_sym_GT] = ACTIONS(2960),
    [anon_sym_GT_EQ] = ACTIONS(2976),
    [anon_sym_CARET] = ACTIONS(2978),
    [anon_sym_PLUS] = ACTIONS(2952),
    [anon_sym_SLASH] = ACTIONS(2954),
    [anon_sym_PERCENT] = ACTIONS(2954),
    [sym_comment] = ACTIONS(87),
  },
  [3991] = {
    [sym_string] = STATE(3991),
    [aux_sym_chained_string_repeat1] = STATE(3991),
    [sym__string_start] = ACTIONS(7159),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_RBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [3992] = {
    [sym__line_break] = ACTIONS(10203),
    [sym__heredoc_body_start] = ACTIONS(10203),
    [sym__binary_minus] = ACTIONS(10203),
    [sym__binary_star] = ACTIONS(10203),
    [ts_builtin_sym_end] = ACTIONS(10203),
    [anon_sym___END__] = ACTIONS(10203),
    [anon_sym_LBRACE] = ACTIONS(10203),
    [anon_sym_RBRACE] = ACTIONS(10203),
    [anon_sym_RPAREN] = ACTIONS(10203),
    [anon_sym_DOT] = ACTIONS(10205),
    [anon_sym_COMMA] = ACTIONS(10203),
    [anon_sym_PIPE] = ACTIONS(10205),
    [anon_sym_SEMI] = ACTIONS(10203),
    [anon_sym_STAR_STAR] = ACTIONS(10203),
    [anon_sym_AMP] = ACTIONS(10205),
    [anon_sym_LT] = ACTIONS(10205),
    [anon_sym_end] = ACTIONS(10203),
    [anon_sym_if] = ACTIONS(10203),
    [anon_sym_unless] = ACTIONS(10203),
    [anon_sym_while] = ACTIONS(10203),
    [anon_sym_until] = ACTIONS(10203),
    [anon_sym_rescue] = ACTIONS(10203),
    [anon_sym_do] = ACTIONS(10203),
    [anon_sym_when] = ACTIONS(10203),
    [anon_sym_elsif] = ACTIONS(10203),
    [anon_sym_else] = ACTIONS(10203),
    [anon_sym_then] = ACTIONS(10203),
    [anon_sym_ensure] = ACTIONS(10203),
    [anon_sym_EQ_GT] = ACTIONS(10203),
    [anon_sym_LBRACK] = ACTIONS(10203),
    [anon_sym_COLON_COLON2] = ACTIONS(10203),
    [anon_sym_AMP_DOT] = ACTIONS(10203),
    [anon_sym_QMARK] = ACTIONS(10203),
    [anon_sym_DOT_DOT] = ACTIONS(10205),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10203),
    [anon_sym_and] = ACTIONS(10203),
    [anon_sym_or] = ACTIONS(10203),
    [anon_sym_PIPE_PIPE] = ACTIONS(10203),
    [anon_sym_AMP_AMP] = ACTIONS(10203),
    [anon_sym_LT_LT] = ACTIONS(10203),
    [anon_sym_GT_GT] = ACTIONS(10203),
    [anon_sym_EQ_EQ] = ACTIONS(10205),
    [anon_sym_BANG_EQ] = ACTIONS(10203),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10203),
    [anon_sym_LT_EQ_GT] = ACTIONS(10203),
    [anon_sym_EQ_TILDE] = ACTIONS(10203),
    [anon_sym_BANG_TILDE] = ACTIONS(10203),
    [anon_sym_LT_EQ] = ACTIONS(10205),
    [anon_sym_GT] = ACTIONS(10205),
    [anon_sym_GT_EQ] = ACTIONS(10203),
    [anon_sym_CARET] = ACTIONS(10203),
    [anon_sym_PLUS] = ACTIONS(10203),
    [anon_sym_SLASH] = ACTIONS(10203),
    [anon_sym_PERCENT] = ACTIONS(10203),
    [sym_comment] = ACTIONS(87),
  },
  [3993] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1697),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(10207),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [3994] = {
    [sym__line_break] = ACTIONS(10209),
    [sym__heredoc_body_start] = ACTIONS(10209),
    [sym__binary_minus] = ACTIONS(10209),
    [sym__binary_star] = ACTIONS(10209),
    [ts_builtin_sym_end] = ACTIONS(10209),
    [anon_sym___END__] = ACTIONS(10209),
    [anon_sym_LBRACE] = ACTIONS(10209),
    [anon_sym_RBRACE] = ACTIONS(10209),
    [anon_sym_RPAREN] = ACTIONS(10209),
    [anon_sym_DOT] = ACTIONS(10211),
    [anon_sym_COMMA] = ACTIONS(10209),
    [anon_sym_PIPE] = ACTIONS(10211),
    [anon_sym_SEMI] = ACTIONS(10209),
    [anon_sym_STAR_STAR] = ACTIONS(10209),
    [anon_sym_AMP] = ACTIONS(10211),
    [anon_sym_LT] = ACTIONS(10211),
    [anon_sym_end] = ACTIONS(10209),
    [anon_sym_if] = ACTIONS(10209),
    [anon_sym_unless] = ACTIONS(10209),
    [anon_sym_while] = ACTIONS(10209),
    [anon_sym_until] = ACTIONS(10209),
    [anon_sym_rescue] = ACTIONS(10209),
    [anon_sym_do] = ACTIONS(10209),
    [anon_sym_when] = ACTIONS(10209),
    [anon_sym_elsif] = ACTIONS(10209),
    [anon_sym_else] = ACTIONS(10209),
    [anon_sym_then] = ACTIONS(10209),
    [anon_sym_ensure] = ACTIONS(10209),
    [anon_sym_EQ_GT] = ACTIONS(10209),
    [anon_sym_LBRACK] = ACTIONS(10209),
    [anon_sym_COLON_COLON2] = ACTIONS(10209),
    [anon_sym_AMP_DOT] = ACTIONS(10209),
    [anon_sym_QMARK] = ACTIONS(10209),
    [anon_sym_DOT_DOT] = ACTIONS(10211),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10209),
    [anon_sym_and] = ACTIONS(10209),
    [anon_sym_or] = ACTIONS(10209),
    [anon_sym_PIPE_PIPE] = ACTIONS(10209),
    [anon_sym_AMP_AMP] = ACTIONS(10209),
    [anon_sym_LT_LT] = ACTIONS(10209),
    [anon_sym_GT_GT] = ACTIONS(10209),
    [anon_sym_EQ_EQ] = ACTIONS(10211),
    [anon_sym_BANG_EQ] = ACTIONS(10209),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10209),
    [anon_sym_LT_EQ_GT] = ACTIONS(10209),
    [anon_sym_EQ_TILDE] = ACTIONS(10209),
    [anon_sym_BANG_TILDE] = ACTIONS(10209),
    [anon_sym_LT_EQ] = ACTIONS(10211),
    [anon_sym_GT] = ACTIONS(10211),
    [anon_sym_GT_EQ] = ACTIONS(10209),
    [anon_sym_CARET] = ACTIONS(10209),
    [anon_sym_PLUS] = ACTIONS(10209),
    [anon_sym_SLASH] = ACTIONS(10209),
    [anon_sym_PERCENT] = ACTIONS(10209),
    [sym_comment] = ACTIONS(87),
  },
  [3995] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1697),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [3996] = {
    [sym__line_break] = ACTIONS(10213),
    [sym__heredoc_body_start] = ACTIONS(10213),
    [sym__binary_minus] = ACTIONS(10213),
    [sym__binary_star] = ACTIONS(10213),
    [ts_builtin_sym_end] = ACTIONS(10213),
    [anon_sym___END__] = ACTIONS(10213),
    [anon_sym_LBRACE] = ACTIONS(10213),
    [anon_sym_RBRACE] = ACTIONS(10213),
    [anon_sym_RPAREN] = ACTIONS(10213),
    [anon_sym_DOT] = ACTIONS(10215),
    [anon_sym_COMMA] = ACTIONS(10213),
    [anon_sym_PIPE] = ACTIONS(10215),
    [anon_sym_SEMI] = ACTIONS(10213),
    [anon_sym_STAR_STAR] = ACTIONS(10213),
    [anon_sym_AMP] = ACTIONS(10215),
    [anon_sym_LT] = ACTIONS(10215),
    [anon_sym_end] = ACTIONS(10213),
    [anon_sym_if] = ACTIONS(10213),
    [anon_sym_unless] = ACTIONS(10213),
    [anon_sym_while] = ACTIONS(10213),
    [anon_sym_until] = ACTIONS(10213),
    [anon_sym_rescue] = ACTIONS(10213),
    [anon_sym_do] = ACTIONS(10213),
    [anon_sym_when] = ACTIONS(10213),
    [anon_sym_elsif] = ACTIONS(10213),
    [anon_sym_else] = ACTIONS(10213),
    [anon_sym_then] = ACTIONS(10213),
    [anon_sym_ensure] = ACTIONS(10213),
    [anon_sym_EQ_GT] = ACTIONS(10213),
    [anon_sym_LBRACK] = ACTIONS(10213),
    [anon_sym_COLON_COLON2] = ACTIONS(10213),
    [anon_sym_AMP_DOT] = ACTIONS(10213),
    [anon_sym_QMARK] = ACTIONS(10213),
    [anon_sym_DOT_DOT] = ACTIONS(10215),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10213),
    [anon_sym_and] = ACTIONS(10213),
    [anon_sym_or] = ACTIONS(10213),
    [anon_sym_PIPE_PIPE] = ACTIONS(10213),
    [anon_sym_AMP_AMP] = ACTIONS(10213),
    [anon_sym_LT_LT] = ACTIONS(10213),
    [anon_sym_GT_GT] = ACTIONS(10213),
    [anon_sym_EQ_EQ] = ACTIONS(10215),
    [anon_sym_BANG_EQ] = ACTIONS(10213),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10213),
    [anon_sym_LT_EQ_GT] = ACTIONS(10213),
    [anon_sym_EQ_TILDE] = ACTIONS(10213),
    [anon_sym_BANG_TILDE] = ACTIONS(10213),
    [anon_sym_LT_EQ] = ACTIONS(10215),
    [anon_sym_GT] = ACTIONS(10215),
    [anon_sym_GT_EQ] = ACTIONS(10213),
    [anon_sym_CARET] = ACTIONS(10213),
    [anon_sym_PLUS] = ACTIONS(10213),
    [anon_sym_SLASH] = ACTIONS(10213),
    [anon_sym_PERCENT] = ACTIONS(10213),
    [sym_comment] = ACTIONS(87),
  },
  [3997] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1705),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(10217),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [3998] = {
    [sym__line_break] = ACTIONS(10219),
    [sym__heredoc_body_start] = ACTIONS(10219),
    [sym__binary_minus] = ACTIONS(10219),
    [sym__binary_star] = ACTIONS(10219),
    [ts_builtin_sym_end] = ACTIONS(10219),
    [anon_sym___END__] = ACTIONS(10219),
    [anon_sym_LBRACE] = ACTIONS(10219),
    [anon_sym_RBRACE] = ACTIONS(10219),
    [anon_sym_RPAREN] = ACTIONS(10219),
    [anon_sym_DOT] = ACTIONS(10221),
    [anon_sym_COMMA] = ACTIONS(10219),
    [anon_sym_PIPE] = ACTIONS(10221),
    [anon_sym_SEMI] = ACTIONS(10219),
    [anon_sym_STAR_STAR] = ACTIONS(10219),
    [anon_sym_AMP] = ACTIONS(10221),
    [anon_sym_LT] = ACTIONS(10221),
    [anon_sym_end] = ACTIONS(10219),
    [anon_sym_if] = ACTIONS(10219),
    [anon_sym_unless] = ACTIONS(10219),
    [anon_sym_while] = ACTIONS(10219),
    [anon_sym_until] = ACTIONS(10219),
    [anon_sym_rescue] = ACTIONS(10219),
    [anon_sym_do] = ACTIONS(10219),
    [anon_sym_when] = ACTIONS(10219),
    [anon_sym_elsif] = ACTIONS(10219),
    [anon_sym_else] = ACTIONS(10219),
    [anon_sym_then] = ACTIONS(10219),
    [anon_sym_ensure] = ACTIONS(10219),
    [anon_sym_EQ_GT] = ACTIONS(10219),
    [anon_sym_LBRACK] = ACTIONS(10219),
    [anon_sym_COLON_COLON2] = ACTIONS(10219),
    [anon_sym_AMP_DOT] = ACTIONS(10219),
    [anon_sym_QMARK] = ACTIONS(10219),
    [anon_sym_DOT_DOT] = ACTIONS(10221),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10219),
    [anon_sym_and] = ACTIONS(10219),
    [anon_sym_or] = ACTIONS(10219),
    [anon_sym_PIPE_PIPE] = ACTIONS(10219),
    [anon_sym_AMP_AMP] = ACTIONS(10219),
    [anon_sym_LT_LT] = ACTIONS(10219),
    [anon_sym_GT_GT] = ACTIONS(10219),
    [anon_sym_EQ_EQ] = ACTIONS(10221),
    [anon_sym_BANG_EQ] = ACTIONS(10219),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10219),
    [anon_sym_LT_EQ_GT] = ACTIONS(10219),
    [anon_sym_EQ_TILDE] = ACTIONS(10219),
    [anon_sym_BANG_TILDE] = ACTIONS(10219),
    [anon_sym_LT_EQ] = ACTIONS(10221),
    [anon_sym_GT] = ACTIONS(10221),
    [anon_sym_GT_EQ] = ACTIONS(10219),
    [anon_sym_CARET] = ACTIONS(10219),
    [anon_sym_PLUS] = ACTIONS(10219),
    [anon_sym_SLASH] = ACTIONS(10219),
    [anon_sym_PERCENT] = ACTIONS(10219),
    [sym_comment] = ACTIONS(87),
  },
  [3999] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1705),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [4000] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(6702),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(4009),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4009),
    [sym_assignment] = STATE(6702),
    [sym_operator_assignment] = STATE(6702),
    [sym_conditional] = STATE(6702),
    [sym_range] = STATE(6702),
    [sym_binary] = STATE(6702),
    [sym_unary] = STATE(6702),
    [sym_left_assignment_list] = STATE(4008),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4009),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(4009),
    [sym_false] = STATE(4009),
    [sym_nil] = STATE(4009),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(4010),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6651),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6653),
    [anon_sym_yield] = ACTIONS(6655),
    [anon_sym_break] = ACTIONS(6657),
    [anon_sym_next] = ACTIONS(6659),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6661),
    [anon_sym_defined_QMARK] = ACTIONS(6663),
    [anon_sym_not] = ACTIONS(6665),
    [anon_sym_BANG] = ACTIONS(6667),
    [anon_sym_TILDE] = ACTIONS(6667),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4001] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1721),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1725),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1725),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(6703),
    [sym__argument] = STATE(6704),
    [sym_splat_argument] = STATE(6704),
    [sym_hash_splat_argument] = STATE(6704),
    [sym_block_argument] = STATE(6704),
    [sym_assignment] = STATE(1721),
    [sym_operator_assignment] = STATE(1721),
    [sym_conditional] = STATE(1721),
    [sym_range] = STATE(1721),
    [sym_binary] = STATE(1721),
    [sym_unary] = STATE(1721),
    [sym_left_assignment_list] = STATE(1724),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1725),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1725),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1726),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(6704),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(3107),
    [sym__splat_star] = ACTIONS(3109),
    [sym__unary_minus] = ACTIONS(3111),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(3113),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(3123),
    [anon_sym_not] = ACTIONS(3125),
    [anon_sym_BANG] = ACTIONS(3127),
    [anon_sym_TILDE] = ACTIONS(3129),
    [sym_constant] = ACTIONS(3131),
    [sym_identifier] = ACTIONS(3131),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4002] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1721),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1725),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1725),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(6703),
    [sym__argument] = STATE(6704),
    [sym_splat_argument] = STATE(6704),
    [sym_hash_splat_argument] = STATE(6704),
    [sym_block_argument] = STATE(6704),
    [sym_assignment] = STATE(1721),
    [sym_operator_assignment] = STATE(1721),
    [sym_conditional] = STATE(1721),
    [sym_range] = STATE(1721),
    [sym_binary] = STATE(1721),
    [sym_unary] = STATE(1721),
    [sym_left_assignment_list] = STATE(1724),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1725),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1725),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1726),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(6704),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(3107),
    [sym__splat_star] = ACTIONS(3109),
    [sym__unary_minus] = ACTIONS(3111),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(3113),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(3123),
    [anon_sym_not] = ACTIONS(3125),
    [anon_sym_BANG] = ACTIONS(3127),
    [anon_sym_TILDE] = ACTIONS(3129),
    [sym_constant] = ACTIONS(3131),
    [sym_identifier] = ACTIONS(3131),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4003] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1721),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1725),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1725),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(6703),
    [sym__argument] = STATE(6704),
    [sym_splat_argument] = STATE(6704),
    [sym_hash_splat_argument] = STATE(6704),
    [sym_block_argument] = STATE(6704),
    [sym_assignment] = STATE(1721),
    [sym_operator_assignment] = STATE(1721),
    [sym_conditional] = STATE(1721),
    [sym_range] = STATE(1721),
    [sym_binary] = STATE(1721),
    [sym_unary] = STATE(1721),
    [sym_left_assignment_list] = STATE(1724),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1725),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1725),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1726),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(6704),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(3107),
    [sym__splat_star] = ACTIONS(3109),
    [sym__unary_minus] = ACTIONS(3111),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(3113),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(3123),
    [anon_sym_not] = ACTIONS(3125),
    [anon_sym_BANG] = ACTIONS(3127),
    [anon_sym_TILDE] = ACTIONS(3129),
    [sym_constant] = ACTIONS(3131),
    [sym_identifier] = ACTIONS(3131),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4004] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1721),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1725),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1725),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(6703),
    [sym__argument] = STATE(6704),
    [sym_splat_argument] = STATE(6704),
    [sym_hash_splat_argument] = STATE(6704),
    [sym_block_argument] = STATE(6704),
    [sym_assignment] = STATE(1721),
    [sym_operator_assignment] = STATE(1721),
    [sym_conditional] = STATE(1721),
    [sym_range] = STATE(1721),
    [sym_binary] = STATE(1721),
    [sym_unary] = STATE(1721),
    [sym_left_assignment_list] = STATE(1724),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1725),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1725),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1726),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(6704),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(3107),
    [sym__splat_star] = ACTIONS(3109),
    [sym__unary_minus] = ACTIONS(3111),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(3113),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(3123),
    [anon_sym_not] = ACTIONS(3125),
    [anon_sym_BANG] = ACTIONS(3127),
    [anon_sym_TILDE] = ACTIONS(3129),
    [sym_constant] = ACTIONS(3131),
    [sym_identifier] = ACTIONS(3131),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4005] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(6705),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(4009),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4009),
    [sym_assignment] = STATE(6705),
    [sym_operator_assignment] = STATE(6705),
    [sym_conditional] = STATE(6705),
    [sym_range] = STATE(6705),
    [sym_binary] = STATE(6705),
    [sym_unary] = STATE(6705),
    [sym_left_assignment_list] = STATE(4008),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4009),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(4009),
    [sym_false] = STATE(4009),
    [sym_nil] = STATE(4009),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(4010),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6651),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6653),
    [anon_sym_yield] = ACTIONS(6655),
    [anon_sym_break] = ACTIONS(6657),
    [anon_sym_next] = ACTIONS(6659),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6661),
    [anon_sym_defined_QMARK] = ACTIONS(6663),
    [anon_sym_not] = ACTIONS(6665),
    [anon_sym_BANG] = ACTIONS(6667),
    [anon_sym_TILDE] = ACTIONS(6667),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4006] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(4009),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4009),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(4008),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4009),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(4009),
    [sym_false] = STATE(4009),
    [sym_nil] = STATE(4009),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(4010),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6651),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6653),
    [anon_sym_yield] = ACTIONS(6655),
    [anon_sym_break] = ACTIONS(6657),
    [anon_sym_next] = ACTIONS(6659),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6661),
    [anon_sym_defined_QMARK] = ACTIONS(6663),
    [anon_sym_not] = ACTIONS(6665),
    [anon_sym_BANG] = ACTIONS(6667),
    [anon_sym_TILDE] = ACTIONS(6667),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4007] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(10223),
    [sym__binary_star] = ACTIONS(10225),
    [anon_sym_RBRACE] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(10227),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(10225),
    [anon_sym_AMP] = ACTIONS(10229),
    [anon_sym_LT] = ACTIONS(10231),
    [anon_sym_if] = ACTIONS(4211),
    [anon_sym_unless] = ACTIONS(4211),
    [anon_sym_while] = ACTIONS(4211),
    [anon_sym_until] = ACTIONS(4211),
    [anon_sym_rescue] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(10233),
    [anon_sym_DOT_DOT] = ACTIONS(10235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10237),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(10239),
    [anon_sym_AMP_AMP] = ACTIONS(10239),
    [anon_sym_LT_LT] = ACTIONS(10241),
    [anon_sym_GT_GT] = ACTIONS(10241),
    [anon_sym_EQ_EQ] = ACTIONS(10243),
    [anon_sym_BANG_EQ] = ACTIONS(10239),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10239),
    [anon_sym_LT_EQ_GT] = ACTIONS(10239),
    [anon_sym_EQ_TILDE] = ACTIONS(10239),
    [anon_sym_BANG_TILDE] = ACTIONS(10239),
    [anon_sym_LT_EQ] = ACTIONS(10231),
    [anon_sym_GT] = ACTIONS(10231),
    [anon_sym_GT_EQ] = ACTIONS(10245),
    [anon_sym_CARET] = ACTIONS(10247),
    [anon_sym_PLUS] = ACTIONS(10223),
    [anon_sym_SLASH] = ACTIONS(10225),
    [anon_sym_PERCENT] = ACTIONS(10225),
    [sym_comment] = ACTIONS(87),
  },
  [4008] = {
    [anon_sym_EQ] = ACTIONS(10249),
    [sym_comment] = ACTIONS(87),
  },
  [4009] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(10251),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(10253),
    [anon_sym_DASH_EQ] = ACTIONS(10253),
    [anon_sym_STAR_EQ] = ACTIONS(10253),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10253),
    [anon_sym_SLASH_EQ] = ACTIONS(10253),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10253),
    [anon_sym_PIPE_EQ] = ACTIONS(10253),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10253),
    [anon_sym_AMP_EQ] = ACTIONS(10253),
    [anon_sym_PERCENT_EQ] = ACTIONS(10253),
    [anon_sym_GT_GT_EQ] = ACTIONS(10253),
    [anon_sym_LT_LT_EQ] = ACTIONS(10253),
    [anon_sym_CARET_EQ] = ACTIONS(10253),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [4010] = {
    [sym_string] = STATE(6718),
    [aux_sym_chained_string_repeat1] = STATE(6718),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [4011] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(10223),
    [sym__binary_star] = ACTIONS(10225),
    [anon_sym_RBRACE] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(10227),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(10225),
    [anon_sym_AMP] = ACTIONS(10229),
    [anon_sym_LT] = ACTIONS(10231),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(10233),
    [anon_sym_DOT_DOT] = ACTIONS(10235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10237),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(10239),
    [anon_sym_AMP_AMP] = ACTIONS(10239),
    [anon_sym_LT_LT] = ACTIONS(10241),
    [anon_sym_GT_GT] = ACTIONS(10241),
    [anon_sym_EQ_EQ] = ACTIONS(10243),
    [anon_sym_BANG_EQ] = ACTIONS(10239),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10239),
    [anon_sym_LT_EQ_GT] = ACTIONS(10239),
    [anon_sym_EQ_TILDE] = ACTIONS(10239),
    [anon_sym_BANG_TILDE] = ACTIONS(10239),
    [anon_sym_LT_EQ] = ACTIONS(10231),
    [anon_sym_GT] = ACTIONS(10231),
    [anon_sym_GT_EQ] = ACTIONS(10245),
    [anon_sym_CARET] = ACTIONS(10247),
    [anon_sym_PLUS] = ACTIONS(10223),
    [anon_sym_SLASH] = ACTIONS(10225),
    [anon_sym_PERCENT] = ACTIONS(10225),
    [sym_comment] = ACTIONS(87),
  },
  [4012] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(6677),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [4013] = {
    [sym_string] = STATE(4035),
    [aux_sym_chained_string_repeat1] = STATE(4035),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [4014] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(6719),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(4009),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4009),
    [sym_assignment] = STATE(6719),
    [sym_operator_assignment] = STATE(6719),
    [sym_conditional] = STATE(6719),
    [sym_range] = STATE(6719),
    [sym_binary] = STATE(6719),
    [sym_unary] = STATE(6719),
    [sym_left_assignment_list] = STATE(4008),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4009),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(4009),
    [sym_false] = STATE(4009),
    [sym_nil] = STATE(4009),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(4010),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6651),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6653),
    [anon_sym_yield] = ACTIONS(6655),
    [anon_sym_break] = ACTIONS(6657),
    [anon_sym_next] = ACTIONS(6659),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6661),
    [anon_sym_defined_QMARK] = ACTIONS(6663),
    [anon_sym_not] = ACTIONS(6665),
    [anon_sym_BANG] = ACTIONS(6667),
    [anon_sym_TILDE] = ACTIONS(6667),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4015] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(10223),
    [sym__binary_star] = ACTIONS(10225),
    [anon_sym_RBRACE] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(10227),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(10225),
    [anon_sym_AMP] = ACTIONS(10229),
    [anon_sym_LT] = ACTIONS(10231),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_unless] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_until] = ACTIONS(3281),
    [anon_sym_rescue] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(10233),
    [anon_sym_DOT_DOT] = ACTIONS(10235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10237),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(10239),
    [anon_sym_AMP_AMP] = ACTIONS(10239),
    [anon_sym_LT_LT] = ACTIONS(10241),
    [anon_sym_GT_GT] = ACTIONS(10241),
    [anon_sym_EQ_EQ] = ACTIONS(10243),
    [anon_sym_BANG_EQ] = ACTIONS(10239),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10239),
    [anon_sym_LT_EQ_GT] = ACTIONS(10239),
    [anon_sym_EQ_TILDE] = ACTIONS(10239),
    [anon_sym_BANG_TILDE] = ACTIONS(10239),
    [anon_sym_LT_EQ] = ACTIONS(10231),
    [anon_sym_GT] = ACTIONS(10231),
    [anon_sym_GT_EQ] = ACTIONS(10245),
    [anon_sym_CARET] = ACTIONS(10247),
    [anon_sym_PLUS] = ACTIONS(10223),
    [anon_sym_SLASH] = ACTIONS(10225),
    [anon_sym_PERCENT] = ACTIONS(10225),
    [sym_comment] = ACTIONS(87),
  },
  [4016] = {
    [sym_heredoc_body] = STATE(6720),
    [aux_sym_call_repeat1] = STATE(6720),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_RBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [4017] = {
    [sym_heredoc_body] = STATE(6720),
    [aux_sym_call_repeat1] = STATE(6720),
    [aux_sym_argument_list_repeat1] = STATE(6721),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_RBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [4018] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(6675),
    [sym__binary_star] = ACTIONS(6677),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(6679),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(6677),
    [anon_sym_AMP] = ACTIONS(6681),
    [anon_sym_LT] = ACTIONS(6683),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(6685),
    [anon_sym_DOT_DOT] = ACTIONS(6687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6689),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(6691),
    [anon_sym_AMP_AMP] = ACTIONS(6691),
    [anon_sym_LT_LT] = ACTIONS(6693),
    [anon_sym_GT_GT] = ACTIONS(6693),
    [anon_sym_EQ_EQ] = ACTIONS(6695),
    [anon_sym_BANG_EQ] = ACTIONS(6691),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6691),
    [anon_sym_LT_EQ_GT] = ACTIONS(6691),
    [anon_sym_EQ_TILDE] = ACTIONS(6691),
    [anon_sym_BANG_TILDE] = ACTIONS(6691),
    [anon_sym_LT_EQ] = ACTIONS(6683),
    [anon_sym_GT] = ACTIONS(6683),
    [anon_sym_GT_EQ] = ACTIONS(6697),
    [anon_sym_CARET] = ACTIONS(6699),
    [anon_sym_PLUS] = ACTIONS(6675),
    [anon_sym_SLASH] = ACTIONS(6677),
    [anon_sym_PERCENT] = ACTIONS(6677),
    [sym_comment] = ACTIONS(87),
  },
  [4019] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(6722),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(4009),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4009),
    [sym_assignment] = STATE(6722),
    [sym_operator_assignment] = STATE(6722),
    [sym_conditional] = STATE(6722),
    [sym_range] = STATE(6722),
    [sym_binary] = STATE(6722),
    [sym_unary] = STATE(6722),
    [sym_left_assignment_list] = STATE(4008),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4009),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(4009),
    [sym_false] = STATE(4009),
    [sym_nil] = STATE(4009),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(4010),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6651),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6653),
    [anon_sym_yield] = ACTIONS(6655),
    [anon_sym_break] = ACTIONS(6657),
    [anon_sym_next] = ACTIONS(6659),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6661),
    [anon_sym_defined_QMARK] = ACTIONS(6663),
    [anon_sym_not] = ACTIONS(6665),
    [anon_sym_BANG] = ACTIONS(6667),
    [anon_sym_TILDE] = ACTIONS(6667),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4020] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6723),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1725),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1725),
    [sym_assignment] = STATE(6723),
    [sym_operator_assignment] = STATE(6723),
    [sym_conditional] = STATE(6723),
    [sym_range] = STATE(6723),
    [sym_binary] = STATE(6723),
    [sym_unary] = STATE(6723),
    [sym_left_assignment_list] = STATE(1724),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1725),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1725),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(4013),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(3111),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6669),
    [anon_sym_defined_QMARK] = ACTIONS(3123),
    [anon_sym_not] = ACTIONS(3125),
    [anon_sym_BANG] = ACTIONS(3129),
    [anon_sym_TILDE] = ACTIONS(3129),
    [sym_constant] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4021] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6724),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1725),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1725),
    [sym_assignment] = STATE(6724),
    [sym_operator_assignment] = STATE(6724),
    [sym_conditional] = STATE(6724),
    [sym_range] = STATE(6724),
    [sym_binary] = STATE(6724),
    [sym_unary] = STATE(6724),
    [sym_left_assignment_list] = STATE(1724),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1725),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1725),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(4013),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(3111),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6669),
    [anon_sym_defined_QMARK] = ACTIONS(3123),
    [anon_sym_not] = ACTIONS(3125),
    [anon_sym_BANG] = ACTIONS(3129),
    [anon_sym_TILDE] = ACTIONS(3129),
    [sym_constant] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4022] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6725),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1725),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1725),
    [sym_assignment] = STATE(6725),
    [sym_operator_assignment] = STATE(6725),
    [sym_conditional] = STATE(6725),
    [sym_range] = STATE(6725),
    [sym_binary] = STATE(6725),
    [sym_unary] = STATE(6725),
    [sym_left_assignment_list] = STATE(1724),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1725),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1725),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(4013),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(3111),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6669),
    [anon_sym_defined_QMARK] = ACTIONS(3123),
    [anon_sym_not] = ACTIONS(3125),
    [anon_sym_BANG] = ACTIONS(3129),
    [anon_sym_TILDE] = ACTIONS(3129),
    [sym_constant] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4023] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6726),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1725),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1725),
    [sym_assignment] = STATE(6726),
    [sym_operator_assignment] = STATE(6726),
    [sym_conditional] = STATE(6726),
    [sym_range] = STATE(6726),
    [sym_binary] = STATE(6726),
    [sym_unary] = STATE(6726),
    [sym_left_assignment_list] = STATE(1724),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1725),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1725),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(4013),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(3111),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6669),
    [anon_sym_defined_QMARK] = ACTIONS(3123),
    [anon_sym_not] = ACTIONS(3125),
    [anon_sym_BANG] = ACTIONS(3129),
    [anon_sym_TILDE] = ACTIONS(3129),
    [sym_constant] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4024] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6727),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1725),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1725),
    [sym_assignment] = STATE(6727),
    [sym_operator_assignment] = STATE(6727),
    [sym_conditional] = STATE(6727),
    [sym_range] = STATE(6727),
    [sym_binary] = STATE(6727),
    [sym_unary] = STATE(6727),
    [sym_left_assignment_list] = STATE(1724),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1725),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1725),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(4013),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(3111),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6669),
    [anon_sym_defined_QMARK] = ACTIONS(3123),
    [anon_sym_not] = ACTIONS(3125),
    [anon_sym_BANG] = ACTIONS(3129),
    [anon_sym_TILDE] = ACTIONS(3129),
    [sym_constant] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4025] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(6728),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(6728),
    [sym_operator_assignment] = STATE(6728),
    [sym_conditional] = STATE(6728),
    [sym_range] = STATE(6728),
    [sym_binary] = STATE(6728),
    [sym_unary] = STATE(6728),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4026] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6729),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1725),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1725),
    [sym_assignment] = STATE(6729),
    [sym_operator_assignment] = STATE(6729),
    [sym_conditional] = STATE(6729),
    [sym_range] = STATE(6729),
    [sym_binary] = STATE(6729),
    [sym_unary] = STATE(6729),
    [sym_left_assignment_list] = STATE(1724),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1725),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1725),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(4013),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(3111),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6669),
    [anon_sym_defined_QMARK] = ACTIONS(3123),
    [anon_sym_not] = ACTIONS(3125),
    [anon_sym_BANG] = ACTIONS(3129),
    [anon_sym_TILDE] = ACTIONS(3129),
    [sym_constant] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4027] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6730),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1725),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1725),
    [sym_assignment] = STATE(6730),
    [sym_operator_assignment] = STATE(6730),
    [sym_conditional] = STATE(6730),
    [sym_range] = STATE(6730),
    [sym_binary] = STATE(6730),
    [sym_unary] = STATE(6730),
    [sym_left_assignment_list] = STATE(1724),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1725),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1725),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(4013),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(3111),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6669),
    [anon_sym_defined_QMARK] = ACTIONS(3123),
    [anon_sym_not] = ACTIONS(3125),
    [anon_sym_BANG] = ACTIONS(3129),
    [anon_sym_TILDE] = ACTIONS(3129),
    [sym_constant] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4028] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6731),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1725),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1725),
    [sym_assignment] = STATE(6731),
    [sym_operator_assignment] = STATE(6731),
    [sym_conditional] = STATE(6731),
    [sym_range] = STATE(6731),
    [sym_binary] = STATE(6731),
    [sym_unary] = STATE(6731),
    [sym_left_assignment_list] = STATE(1724),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1725),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1725),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(4013),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(3111),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6669),
    [anon_sym_defined_QMARK] = ACTIONS(3123),
    [anon_sym_not] = ACTIONS(3125),
    [anon_sym_BANG] = ACTIONS(3129),
    [anon_sym_TILDE] = ACTIONS(3129),
    [sym_constant] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4029] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6732),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1725),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1725),
    [sym_assignment] = STATE(6732),
    [sym_operator_assignment] = STATE(6732),
    [sym_conditional] = STATE(6732),
    [sym_range] = STATE(6732),
    [sym_binary] = STATE(6732),
    [sym_unary] = STATE(6732),
    [sym_left_assignment_list] = STATE(1724),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1725),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1725),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(4013),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(3111),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6669),
    [anon_sym_defined_QMARK] = ACTIONS(3123),
    [anon_sym_not] = ACTIONS(3125),
    [anon_sym_BANG] = ACTIONS(3129),
    [anon_sym_TILDE] = ACTIONS(3129),
    [sym_constant] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4030] = {
    [sym_heredoc_body] = STATE(6733),
    [aux_sym_call_repeat1] = STATE(6733),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_RBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [4031] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1721),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1725),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1725),
    [sym__argument] = STATE(2565),
    [sym_splat_argument] = STATE(2565),
    [sym_hash_splat_argument] = STATE(2565),
    [sym_block_argument] = STATE(2565),
    [sym_assignment] = STATE(1721),
    [sym_operator_assignment] = STATE(1721),
    [sym_conditional] = STATE(1721),
    [sym_range] = STATE(1721),
    [sym_binary] = STATE(1721),
    [sym_unary] = STATE(1721),
    [sym_left_assignment_list] = STATE(1724),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1725),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1725),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1726),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(6734),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2565),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(3107),
    [sym__splat_star] = ACTIONS(3109),
    [sym__unary_minus] = ACTIONS(3111),
    [sym__identifier_hash_key] = ACTIONS(3113),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10255),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6669),
    [anon_sym_defined_QMARK] = ACTIONS(3123),
    [anon_sym_not] = ACTIONS(3125),
    [anon_sym_BANG] = ACTIONS(3129),
    [anon_sym_TILDE] = ACTIONS(3129),
    [sym_constant] = ACTIONS(3131),
    [sym_identifier] = ACTIONS(3131),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4032] = {
    [sym_heredoc_body] = STATE(6735),
    [aux_sym_call_repeat1] = STATE(6735),
    [aux_sym_argument_list_repeat1] = STATE(6736),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_RBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(6701),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [4033] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6737),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1725),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1725),
    [sym_splat_argument] = STATE(6738),
    [sym_assignment] = STATE(6737),
    [sym_operator_assignment] = STATE(6737),
    [sym_conditional] = STATE(6737),
    [sym_range] = STATE(6737),
    [sym_binary] = STATE(6737),
    [sym_unary] = STATE(6737),
    [sym_right_assignment_list] = STATE(2570),
    [sym__arg_or_splat_arg] = STATE(6738),
    [sym_left_assignment_list] = STATE(1724),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1725),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1725),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(4013),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__splat_star] = ACTIONS(6059),
    [sym__unary_minus] = ACTIONS(3111),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6669),
    [anon_sym_defined_QMARK] = ACTIONS(3123),
    [anon_sym_not] = ACTIONS(3125),
    [anon_sym_BANG] = ACTIONS(3129),
    [anon_sym_TILDE] = ACTIONS(3129),
    [sym_constant] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4034] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6739),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1725),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1725),
    [sym_assignment] = STATE(6739),
    [sym_operator_assignment] = STATE(6739),
    [sym_conditional] = STATE(6739),
    [sym_range] = STATE(6739),
    [sym_binary] = STATE(6739),
    [sym_unary] = STATE(6739),
    [sym_left_assignment_list] = STATE(1724),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1725),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1725),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(4013),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(3111),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6669),
    [anon_sym_defined_QMARK] = ACTIONS(3123),
    [anon_sym_not] = ACTIONS(3125),
    [anon_sym_BANG] = ACTIONS(3129),
    [anon_sym_TILDE] = ACTIONS(3129),
    [sym_constant] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4035] = {
    [sym_string] = STATE(6740),
    [aux_sym_chained_string_repeat1] = STATE(6740),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_RBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_EQ_GT] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [4036] = {
    [aux_sym_undef_repeat1] = STATE(6741),
    [sym__line_break] = ACTIONS(5497),
    [sym__heredoc_body_start] = ACTIONS(5497),
    [anon_sym_RBRACE] = ACTIONS(5497),
    [anon_sym_COMMA] = ACTIONS(2253),
    [anon_sym_SEMI] = ACTIONS(5497),
    [anon_sym_if] = ACTIONS(5497),
    [anon_sym_unless] = ACTIONS(5497),
    [anon_sym_while] = ACTIONS(5497),
    [anon_sym_until] = ACTIONS(5497),
    [anon_sym_rescue] = ACTIONS(5497),
    [sym_comment] = ACTIONS(87),
  },
  [4037] = {
    [sym__line_break] = ACTIONS(5815),
    [sym__heredoc_body_start] = ACTIONS(5815),
    [sym__binary_minus] = ACTIONS(3147),
    [sym__binary_star] = ACTIONS(3149),
    [anon_sym_RBRACE] = ACTIONS(5815),
    [anon_sym_PIPE] = ACTIONS(3151),
    [anon_sym_SEMI] = ACTIONS(5815),
    [anon_sym_STAR_STAR] = ACTIONS(3149),
    [anon_sym_AMP] = ACTIONS(3153),
    [anon_sym_LT] = ACTIONS(3155),
    [anon_sym_if] = ACTIONS(5815),
    [anon_sym_unless] = ACTIONS(5815),
    [anon_sym_while] = ACTIONS(5815),
    [anon_sym_until] = ACTIONS(5815),
    [anon_sym_rescue] = ACTIONS(5815),
    [anon_sym_QMARK] = ACTIONS(3157),
    [anon_sym_DOT_DOT] = ACTIONS(3159),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3161),
    [anon_sym_and] = ACTIONS(3163),
    [anon_sym_or] = ACTIONS(3163),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3167),
    [anon_sym_GT_GT] = ACTIONS(3167),
    [anon_sym_EQ_EQ] = ACTIONS(3169),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3155),
    [anon_sym_GT] = ACTIONS(3155),
    [anon_sym_GT_EQ] = ACTIONS(3171),
    [anon_sym_CARET] = ACTIONS(3173),
    [anon_sym_PLUS] = ACTIONS(3147),
    [anon_sym_SLASH] = ACTIONS(3149),
    [anon_sym_PERCENT] = ACTIONS(3149),
    [sym_comment] = ACTIONS(87),
  },
  [4038] = {
    [sym__line_break] = ACTIONS(5817),
    [sym__heredoc_body_start] = ACTIONS(5817),
    [sym__binary_minus] = ACTIONS(3147),
    [sym__binary_star] = ACTIONS(3149),
    [anon_sym_RBRACE] = ACTIONS(5817),
    [anon_sym_PIPE] = ACTIONS(3151),
    [anon_sym_SEMI] = ACTIONS(5817),
    [anon_sym_STAR_STAR] = ACTIONS(3149),
    [anon_sym_AMP] = ACTIONS(3153),
    [anon_sym_LT] = ACTIONS(3155),
    [anon_sym_if] = ACTIONS(5817),
    [anon_sym_unless] = ACTIONS(5817),
    [anon_sym_while] = ACTIONS(5817),
    [anon_sym_until] = ACTIONS(5817),
    [anon_sym_rescue] = ACTIONS(5817),
    [anon_sym_QMARK] = ACTIONS(3157),
    [anon_sym_DOT_DOT] = ACTIONS(3159),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3161),
    [anon_sym_and] = ACTIONS(3163),
    [anon_sym_or] = ACTIONS(3163),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3167),
    [anon_sym_GT_GT] = ACTIONS(3167),
    [anon_sym_EQ_EQ] = ACTIONS(3169),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3155),
    [anon_sym_GT] = ACTIONS(3155),
    [anon_sym_GT_EQ] = ACTIONS(3171),
    [anon_sym_CARET] = ACTIONS(3173),
    [anon_sym_PLUS] = ACTIONS(3147),
    [anon_sym_SLASH] = ACTIONS(3149),
    [anon_sym_PERCENT] = ACTIONS(3149),
    [sym_comment] = ACTIONS(87),
  },
  [4039] = {
    [sym__line_break] = ACTIONS(5819),
    [sym__heredoc_body_start] = ACTIONS(5819),
    [sym__binary_minus] = ACTIONS(3147),
    [sym__binary_star] = ACTIONS(3149),
    [anon_sym_RBRACE] = ACTIONS(5819),
    [anon_sym_PIPE] = ACTIONS(3151),
    [anon_sym_SEMI] = ACTIONS(5819),
    [anon_sym_STAR_STAR] = ACTIONS(3149),
    [anon_sym_AMP] = ACTIONS(3153),
    [anon_sym_LT] = ACTIONS(3155),
    [anon_sym_if] = ACTIONS(5819),
    [anon_sym_unless] = ACTIONS(5819),
    [anon_sym_while] = ACTIONS(5819),
    [anon_sym_until] = ACTIONS(5819),
    [anon_sym_rescue] = ACTIONS(5819),
    [anon_sym_QMARK] = ACTIONS(3157),
    [anon_sym_DOT_DOT] = ACTIONS(3159),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3161),
    [anon_sym_and] = ACTIONS(3163),
    [anon_sym_or] = ACTIONS(3163),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3167),
    [anon_sym_GT_GT] = ACTIONS(3167),
    [anon_sym_EQ_EQ] = ACTIONS(3169),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3155),
    [anon_sym_GT] = ACTIONS(3155),
    [anon_sym_GT_EQ] = ACTIONS(3171),
    [anon_sym_CARET] = ACTIONS(3173),
    [anon_sym_PLUS] = ACTIONS(3147),
    [anon_sym_SLASH] = ACTIONS(3149),
    [anon_sym_PERCENT] = ACTIONS(3149),
    [sym_comment] = ACTIONS(87),
  },
  [4040] = {
    [sym__line_break] = ACTIONS(5821),
    [sym__heredoc_body_start] = ACTIONS(5821),
    [sym__binary_minus] = ACTIONS(3147),
    [sym__binary_star] = ACTIONS(3149),
    [anon_sym_RBRACE] = ACTIONS(5821),
    [anon_sym_PIPE] = ACTIONS(3151),
    [anon_sym_SEMI] = ACTIONS(5821),
    [anon_sym_STAR_STAR] = ACTIONS(3149),
    [anon_sym_AMP] = ACTIONS(3153),
    [anon_sym_LT] = ACTIONS(3155),
    [anon_sym_if] = ACTIONS(5821),
    [anon_sym_unless] = ACTIONS(5821),
    [anon_sym_while] = ACTIONS(5821),
    [anon_sym_until] = ACTIONS(5821),
    [anon_sym_rescue] = ACTIONS(5821),
    [anon_sym_QMARK] = ACTIONS(3157),
    [anon_sym_DOT_DOT] = ACTIONS(3159),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3161),
    [anon_sym_and] = ACTIONS(3163),
    [anon_sym_or] = ACTIONS(3163),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3167),
    [anon_sym_GT_GT] = ACTIONS(3167),
    [anon_sym_EQ_EQ] = ACTIONS(3169),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3155),
    [anon_sym_GT] = ACTIONS(3155),
    [anon_sym_GT_EQ] = ACTIONS(3171),
    [anon_sym_CARET] = ACTIONS(3173),
    [anon_sym_PLUS] = ACTIONS(3147),
    [anon_sym_SLASH] = ACTIONS(3149),
    [anon_sym_PERCENT] = ACTIONS(3149),
    [sym_comment] = ACTIONS(87),
  },
  [4041] = {
    [sym__line_break] = ACTIONS(5823),
    [sym__heredoc_body_start] = ACTIONS(5823),
    [sym__binary_minus] = ACTIONS(3147),
    [sym__binary_star] = ACTIONS(3149),
    [anon_sym_RBRACE] = ACTIONS(5823),
    [anon_sym_PIPE] = ACTIONS(3151),
    [anon_sym_SEMI] = ACTIONS(5823),
    [anon_sym_STAR_STAR] = ACTIONS(3149),
    [anon_sym_AMP] = ACTIONS(3153),
    [anon_sym_LT] = ACTIONS(3155),
    [anon_sym_if] = ACTIONS(5823),
    [anon_sym_unless] = ACTIONS(5823),
    [anon_sym_while] = ACTIONS(5823),
    [anon_sym_until] = ACTIONS(5823),
    [anon_sym_rescue] = ACTIONS(5823),
    [anon_sym_QMARK] = ACTIONS(3157),
    [anon_sym_DOT_DOT] = ACTIONS(3159),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3161),
    [anon_sym_and] = ACTIONS(3163),
    [anon_sym_or] = ACTIONS(3163),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3167),
    [anon_sym_GT_GT] = ACTIONS(3167),
    [anon_sym_EQ_EQ] = ACTIONS(3169),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3155),
    [anon_sym_GT] = ACTIONS(3155),
    [anon_sym_GT_EQ] = ACTIONS(3171),
    [anon_sym_CARET] = ACTIONS(3173),
    [anon_sym_PLUS] = ACTIONS(3147),
    [anon_sym_SLASH] = ACTIONS(3149),
    [anon_sym_PERCENT] = ACTIONS(3149),
    [sym_comment] = ACTIONS(87),
  },
  [4042] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(3149),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(3149),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(3149),
    [anon_sym_PERCENT] = ACTIONS(3149),
    [sym_comment] = ACTIONS(87),
  },
  [4043] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(3149),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [4044] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(3147),
    [sym__binary_star] = ACTIONS(3149),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(3149),
    [anon_sym_AMP] = ACTIONS(3153),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(3167),
    [anon_sym_GT_GT] = ACTIONS(3167),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(3147),
    [anon_sym_SLASH] = ACTIONS(3149),
    [anon_sym_PERCENT] = ACTIONS(3149),
    [sym_comment] = ACTIONS(87),
  },
  [4045] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(3147),
    [sym__binary_star] = ACTIONS(3149),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(3149),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(3167),
    [anon_sym_GT_GT] = ACTIONS(3167),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(3147),
    [anon_sym_SLASH] = ACTIONS(3149),
    [anon_sym_PERCENT] = ACTIONS(3149),
    [sym_comment] = ACTIONS(87),
  },
  [4046] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(3147),
    [sym__binary_star] = ACTIONS(3149),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(3151),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(3149),
    [anon_sym_AMP] = ACTIONS(3153),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(3167),
    [anon_sym_GT_GT] = ACTIONS(3167),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(3173),
    [anon_sym_PLUS] = ACTIONS(3147),
    [anon_sym_SLASH] = ACTIONS(3149),
    [anon_sym_PERCENT] = ACTIONS(3149),
    [sym_comment] = ACTIONS(87),
  },
  [4047] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(10257),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [4048] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(3147),
    [sym__binary_star] = ACTIONS(3149),
    [anon_sym_RBRACE] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(3151),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(3149),
    [anon_sym_AMP] = ACTIONS(3153),
    [anon_sym_LT] = ACTIONS(3155),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(3159),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3161),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3167),
    [anon_sym_GT_GT] = ACTIONS(3167),
    [anon_sym_EQ_EQ] = ACTIONS(3169),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3155),
    [anon_sym_GT] = ACTIONS(3155),
    [anon_sym_GT_EQ] = ACTIONS(3171),
    [anon_sym_CARET] = ACTIONS(3173),
    [anon_sym_PLUS] = ACTIONS(3147),
    [anon_sym_SLASH] = ACTIONS(3149),
    [anon_sym_PERCENT] = ACTIONS(3149),
    [sym_comment] = ACTIONS(87),
  },
  [4049] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(3147),
    [sym__binary_star] = ACTIONS(3149),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(3151),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(3149),
    [anon_sym_AMP] = ACTIONS(3153),
    [anon_sym_LT] = ACTIONS(3155),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(3157),
    [anon_sym_DOT_DOT] = ACTIONS(3159),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3161),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3167),
    [anon_sym_GT_GT] = ACTIONS(3167),
    [anon_sym_EQ_EQ] = ACTIONS(3169),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3155),
    [anon_sym_GT] = ACTIONS(3155),
    [anon_sym_GT_EQ] = ACTIONS(3171),
    [anon_sym_CARET] = ACTIONS(3173),
    [anon_sym_PLUS] = ACTIONS(3147),
    [anon_sym_SLASH] = ACTIONS(3149),
    [anon_sym_PERCENT] = ACTIONS(3149),
    [sym_comment] = ACTIONS(87),
  },
  [4050] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(3147),
    [sym__binary_star] = ACTIONS(3149),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(3151),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(3149),
    [anon_sym_AMP] = ACTIONS(3153),
    [anon_sym_LT] = ACTIONS(3155),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(3167),
    [anon_sym_GT_GT] = ACTIONS(3167),
    [anon_sym_EQ_EQ] = ACTIONS(3169),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3155),
    [anon_sym_GT] = ACTIONS(3155),
    [anon_sym_GT_EQ] = ACTIONS(3171),
    [anon_sym_CARET] = ACTIONS(3173),
    [anon_sym_PLUS] = ACTIONS(3147),
    [anon_sym_SLASH] = ACTIONS(3149),
    [anon_sym_PERCENT] = ACTIONS(3149),
    [sym_comment] = ACTIONS(87),
  },
  [4051] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(3147),
    [sym__binary_star] = ACTIONS(3149),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(3149),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(3147),
    [anon_sym_SLASH] = ACTIONS(3149),
    [anon_sym_PERCENT] = ACTIONS(3149),
    [sym_comment] = ACTIONS(87),
  },
  [4052] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(6743),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(4062),
    [sym_scope_resolution] = STATE(4060),
    [sym_call] = STATE(4060),
    [sym_method_call] = STATE(4062),
    [sym_assignment] = STATE(6743),
    [sym_operator_assignment] = STATE(6743),
    [sym_conditional] = STATE(6743),
    [sym_range] = STATE(6743),
    [sym_binary] = STATE(6743),
    [sym_unary] = STATE(6743),
    [sym_left_assignment_list] = STATE(4061),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4062),
    [sym__variable] = STATE(4060),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(4062),
    [sym_false] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(4063),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(6713),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(6715),
    [anon_sym_yield] = ACTIONS(6717),
    [anon_sym_break] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6721),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(6723),
    [anon_sym_defined_QMARK] = ACTIONS(6725),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6731),
    [sym_identifier] = ACTIONS(6731),
    [sym_instance_variable] = ACTIONS(6733),
    [sym_class_variable] = ACTIONS(6733),
    [sym_global_variable] = ACTIONS(6733),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(6731),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6731),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [4053] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(1757),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1762),
    [sym_scope_resolution] = STATE(1758),
    [sym_call] = STATE(1758),
    [sym_method_call] = STATE(1762),
    [sym_argument_list] = STATE(3610),
    [sym__argument_list_with_parens] = STATE(1759),
    [sym__argument] = STATE(1760),
    [sym_splat_argument] = STATE(1760),
    [sym_hash_splat_argument] = STATE(1760),
    [sym_block_argument] = STATE(1760),
    [sym_assignment] = STATE(1757),
    [sym_operator_assignment] = STATE(1757),
    [sym_conditional] = STATE(1757),
    [sym_range] = STATE(1757),
    [sym_binary] = STATE(1757),
    [sym_unary] = STATE(1757),
    [sym_left_assignment_list] = STATE(1761),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1762),
    [sym__variable] = STATE(1758),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1762),
    [sym_false] = STATE(1762),
    [sym_nil] = STATE(1762),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(1763),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(1760),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(3175),
    [sym__splat_star] = ACTIONS(3177),
    [sym__unary_minus] = ACTIONS(3179),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(3181),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_RBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(3183),
    [anon_sym_yield] = ACTIONS(3185),
    [anon_sym_break] = ACTIONS(3187),
    [anon_sym_next] = ACTIONS(3189),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(365),
    [anon_sym_DASH_EQ] = ACTIONS(365),
    [anon_sym_STAR_EQ] = ACTIONS(365),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(365),
    [anon_sym_SLASH_EQ] = ACTIONS(365),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(365),
    [anon_sym_PIPE_EQ] = ACTIONS(365),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(365),
    [anon_sym_AMP_EQ] = ACTIONS(365),
    [anon_sym_PERCENT_EQ] = ACTIONS(365),
    [anon_sym_GT_GT_EQ] = ACTIONS(365),
    [anon_sym_LT_LT_EQ] = ACTIONS(365),
    [anon_sym_CARET_EQ] = ACTIONS(365),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_PERCENT] = ACTIONS(377),
    [anon_sym_defined_QMARK] = ACTIONS(3191),
    [anon_sym_not] = ACTIONS(3193),
    [anon_sym_BANG] = ACTIONS(3195),
    [anon_sym_TILDE] = ACTIONS(3197),
    [sym_constant] = ACTIONS(3199),
    [sym_identifier] = ACTIONS(3199),
    [sym_instance_variable] = ACTIONS(3201),
    [sym_class_variable] = ACTIONS(3201),
    [sym_global_variable] = ACTIONS(3201),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(3203),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(3203),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [4054] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(1757),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1762),
    [sym_scope_resolution] = STATE(1758),
    [sym_call] = STATE(1758),
    [sym_method_call] = STATE(1762),
    [sym_argument_list] = STATE(3611),
    [sym__argument_list_with_parens] = STATE(1759),
    [sym__argument] = STATE(1760),
    [sym_splat_argument] = STATE(1760),
    [sym_hash_splat_argument] = STATE(1760),
    [sym_block_argument] = STATE(1760),
    [sym_assignment] = STATE(1757),
    [sym_operator_assignment] = STATE(1757),
    [sym_conditional] = STATE(1757),
    [sym_range] = STATE(1757),
    [sym_binary] = STATE(1757),
    [sym_unary] = STATE(1757),
    [sym_left_assignment_list] = STATE(1761),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1762),
    [sym__variable] = STATE(1758),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1762),
    [sym_false] = STATE(1762),
    [sym_nil] = STATE(1762),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(1763),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(1760),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(3175),
    [sym__splat_star] = ACTIONS(3177),
    [sym__unary_minus] = ACTIONS(3179),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(3181),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_RBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_EQ] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(3183),
    [anon_sym_yield] = ACTIONS(3185),
    [anon_sym_break] = ACTIONS(3187),
    [anon_sym_next] = ACTIONS(3189),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(417),
    [anon_sym_DASH_EQ] = ACTIONS(417),
    [anon_sym_STAR_EQ] = ACTIONS(417),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(417),
    [anon_sym_SLASH_EQ] = ACTIONS(417),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(417),
    [anon_sym_PIPE_EQ] = ACTIONS(417),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(417),
    [anon_sym_AMP_EQ] = ACTIONS(417),
    [anon_sym_PERCENT_EQ] = ACTIONS(417),
    [anon_sym_GT_GT_EQ] = ACTIONS(417),
    [anon_sym_LT_LT_EQ] = ACTIONS(417),
    [anon_sym_CARET_EQ] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(3191),
    [anon_sym_not] = ACTIONS(3193),
    [anon_sym_BANG] = ACTIONS(3195),
    [anon_sym_TILDE] = ACTIONS(3197),
    [sym_constant] = ACTIONS(3199),
    [sym_identifier] = ACTIONS(3199),
    [sym_instance_variable] = ACTIONS(3201),
    [sym_class_variable] = ACTIONS(3201),
    [sym_global_variable] = ACTIONS(3201),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(3203),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(3203),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [4055] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(1757),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1762),
    [sym_scope_resolution] = STATE(1758),
    [sym_call] = STATE(1758),
    [sym_method_call] = STATE(1762),
    [sym_argument_list] = STATE(3612),
    [sym__argument_list_with_parens] = STATE(1759),
    [sym__argument] = STATE(1760),
    [sym_splat_argument] = STATE(1760),
    [sym_hash_splat_argument] = STATE(1760),
    [sym_block_argument] = STATE(1760),
    [sym_assignment] = STATE(1757),
    [sym_operator_assignment] = STATE(1757),
    [sym_conditional] = STATE(1757),
    [sym_range] = STATE(1757),
    [sym_binary] = STATE(1757),
    [sym_unary] = STATE(1757),
    [sym_left_assignment_list] = STATE(1761),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1762),
    [sym__variable] = STATE(1758),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1762),
    [sym_false] = STATE(1762),
    [sym_nil] = STATE(1762),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(1763),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(1760),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(3175),
    [sym__splat_star] = ACTIONS(3177),
    [sym__unary_minus] = ACTIONS(3179),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(3181),
    [anon_sym_LBRACE] = ACTIONS(421),
    [anon_sym_RBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_EQ] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(3183),
    [anon_sym_yield] = ACTIONS(3185),
    [anon_sym_break] = ACTIONS(3187),
    [anon_sym_next] = ACTIONS(3189),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(421),
    [anon_sym_DASH_EQ] = ACTIONS(421),
    [anon_sym_STAR_EQ] = ACTIONS(421),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(421),
    [anon_sym_SLASH_EQ] = ACTIONS(421),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(421),
    [anon_sym_PIPE_EQ] = ACTIONS(421),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(421),
    [anon_sym_AMP_EQ] = ACTIONS(421),
    [anon_sym_PERCENT_EQ] = ACTIONS(421),
    [anon_sym_GT_GT_EQ] = ACTIONS(421),
    [anon_sym_LT_LT_EQ] = ACTIONS(421),
    [anon_sym_CARET_EQ] = ACTIONS(421),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(3191),
    [anon_sym_not] = ACTIONS(3193),
    [anon_sym_BANG] = ACTIONS(3195),
    [anon_sym_TILDE] = ACTIONS(3197),
    [sym_constant] = ACTIONS(3199),
    [sym_identifier] = ACTIONS(3199),
    [sym_instance_variable] = ACTIONS(3201),
    [sym_class_variable] = ACTIONS(3201),
    [sym_global_variable] = ACTIONS(3201),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(3203),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(3203),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [4056] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(1757),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1762),
    [sym_scope_resolution] = STATE(1758),
    [sym_call] = STATE(1758),
    [sym_method_call] = STATE(1762),
    [sym_argument_list] = STATE(3613),
    [sym__argument_list_with_parens] = STATE(1759),
    [sym__argument] = STATE(1760),
    [sym_splat_argument] = STATE(1760),
    [sym_hash_splat_argument] = STATE(1760),
    [sym_block_argument] = STATE(1760),
    [sym_assignment] = STATE(1757),
    [sym_operator_assignment] = STATE(1757),
    [sym_conditional] = STATE(1757),
    [sym_range] = STATE(1757),
    [sym_binary] = STATE(1757),
    [sym_unary] = STATE(1757),
    [sym_left_assignment_list] = STATE(1761),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1762),
    [sym__variable] = STATE(1758),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1762),
    [sym_false] = STATE(1762),
    [sym_nil] = STATE(1762),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(1763),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(1760),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(3175),
    [sym__splat_star] = ACTIONS(3177),
    [sym__unary_minus] = ACTIONS(3179),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(3181),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(427),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(3183),
    [anon_sym_yield] = ACTIONS(3185),
    [anon_sym_break] = ACTIONS(3187),
    [anon_sym_next] = ACTIONS(3189),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(425),
    [anon_sym_DASH_EQ] = ACTIONS(425),
    [anon_sym_STAR_EQ] = ACTIONS(425),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(425),
    [anon_sym_SLASH_EQ] = ACTIONS(425),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(425),
    [anon_sym_PIPE_EQ] = ACTIONS(425),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(425),
    [anon_sym_AMP_EQ] = ACTIONS(425),
    [anon_sym_PERCENT_EQ] = ACTIONS(425),
    [anon_sym_GT_GT_EQ] = ACTIONS(425),
    [anon_sym_LT_LT_EQ] = ACTIONS(425),
    [anon_sym_CARET_EQ] = ACTIONS(425),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(3191),
    [anon_sym_not] = ACTIONS(3193),
    [anon_sym_BANG] = ACTIONS(3195),
    [anon_sym_TILDE] = ACTIONS(3197),
    [sym_constant] = ACTIONS(3199),
    [sym_identifier] = ACTIONS(3199),
    [sym_instance_variable] = ACTIONS(3201),
    [sym_class_variable] = ACTIONS(3201),
    [sym_global_variable] = ACTIONS(3201),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(3203),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(3203),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [4057] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(6744),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(4062),
    [sym_scope_resolution] = STATE(4060),
    [sym_call] = STATE(4060),
    [sym_method_call] = STATE(4062),
    [sym_assignment] = STATE(6744),
    [sym_operator_assignment] = STATE(6744),
    [sym_conditional] = STATE(6744),
    [sym_range] = STATE(6744),
    [sym_binary] = STATE(6744),
    [sym_unary] = STATE(6744),
    [sym_left_assignment_list] = STATE(4061),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4062),
    [sym__variable] = STATE(4060),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(4062),
    [sym_false] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(4063),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(6713),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(6715),
    [anon_sym_yield] = ACTIONS(6717),
    [anon_sym_break] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6721),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(6723),
    [anon_sym_defined_QMARK] = ACTIONS(6725),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6731),
    [sym_identifier] = ACTIONS(6731),
    [sym_instance_variable] = ACTIONS(6733),
    [sym_class_variable] = ACTIONS(6733),
    [sym_global_variable] = ACTIONS(6733),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(6731),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6731),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [4058] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(3628),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(4062),
    [sym_scope_resolution] = STATE(4060),
    [sym_call] = STATE(4060),
    [sym_method_call] = STATE(4062),
    [sym_assignment] = STATE(3628),
    [sym_operator_assignment] = STATE(3628),
    [sym_conditional] = STATE(3628),
    [sym_range] = STATE(3628),
    [sym_binary] = STATE(3628),
    [sym_unary] = STATE(3628),
    [sym_left_assignment_list] = STATE(4061),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4062),
    [sym__variable] = STATE(4060),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(4062),
    [sym_false] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(4063),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(6713),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(6715),
    [anon_sym_yield] = ACTIONS(6717),
    [anon_sym_break] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6721),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(6723),
    [anon_sym_defined_QMARK] = ACTIONS(6725),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6731),
    [sym_identifier] = ACTIONS(6731),
    [sym_instance_variable] = ACTIONS(6733),
    [sym_class_variable] = ACTIONS(6733),
    [sym_global_variable] = ACTIONS(6733),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(6731),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6731),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [4059] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(10259),
    [sym__binary_star] = ACTIONS(10261),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_RBRACE] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(10263),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(10265),
    [anon_sym_AMP] = ACTIONS(10267),
    [anon_sym_EQ] = ACTIONS(4217),
    [anon_sym_LT] = ACTIONS(10269),
    [anon_sym_if] = ACTIONS(4211),
    [anon_sym_unless] = ACTIONS(4211),
    [anon_sym_while] = ACTIONS(4211),
    [anon_sym_until] = ACTIONS(4211),
    [anon_sym_rescue] = ACTIONS(4211),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_PLUS_EQ] = ACTIONS(4211),
    [anon_sym_DASH_EQ] = ACTIONS(4211),
    [anon_sym_STAR_EQ] = ACTIONS(4211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4211),
    [anon_sym_SLASH_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4211),
    [anon_sym_AMP_EQ] = ACTIONS(4211),
    [anon_sym_PERCENT_EQ] = ACTIONS(4211),
    [anon_sym_GT_GT_EQ] = ACTIONS(4211),
    [anon_sym_LT_LT_EQ] = ACTIONS(4211),
    [anon_sym_CARET_EQ] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(10271),
    [anon_sym_DOT_DOT] = ACTIONS(10273),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10275),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(10277),
    [anon_sym_AMP_AMP] = ACTIONS(10277),
    [anon_sym_LT_LT] = ACTIONS(10279),
    [anon_sym_GT_GT] = ACTIONS(10279),
    [anon_sym_EQ_EQ] = ACTIONS(10277),
    [anon_sym_BANG_EQ] = ACTIONS(10281),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10281),
    [anon_sym_LT_EQ_GT] = ACTIONS(10281),
    [anon_sym_EQ_TILDE] = ACTIONS(10281),
    [anon_sym_BANG_TILDE] = ACTIONS(10281),
    [anon_sym_LT_EQ] = ACTIONS(10269),
    [anon_sym_GT] = ACTIONS(10269),
    [anon_sym_GT_EQ] = ACTIONS(10283),
    [anon_sym_CARET] = ACTIONS(10263),
    [anon_sym_PLUS] = ACTIONS(10285),
    [anon_sym_SLASH] = ACTIONS(10265),
    [anon_sym_PERCENT] = ACTIONS(10265),
    [sym_comment] = ACTIONS(87),
  },
  [4060] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(1757),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1762),
    [sym_scope_resolution] = STATE(1758),
    [sym_call] = STATE(1758),
    [sym_method_call] = STATE(1762),
    [sym_argument_list] = STATE(1062),
    [sym__argument_list_with_parens] = STATE(1759),
    [sym__argument] = STATE(1760),
    [sym_splat_argument] = STATE(1760),
    [sym_hash_splat_argument] = STATE(1760),
    [sym_block_argument] = STATE(1760),
    [sym_do_block] = STATE(426),
    [sym_block] = STATE(426),
    [sym_assignment] = STATE(1757),
    [sym_operator_assignment] = STATE(1757),
    [sym_conditional] = STATE(1757),
    [sym_range] = STATE(1757),
    [sym_binary] = STATE(1757),
    [sym_unary] = STATE(1757),
    [sym_left_assignment_list] = STATE(1761),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1762),
    [sym__variable] = STATE(1758),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1762),
    [sym_false] = STATE(1762),
    [sym_nil] = STATE(1762),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(1763),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(1760),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(743),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(3175),
    [sym__splat_star] = ACTIONS(3177),
    [sym__unary_minus] = ACTIONS(3179),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(3181),
    [anon_sym_LBRACE] = ACTIONS(6047),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(3183),
    [anon_sym_yield] = ACTIONS(3185),
    [anon_sym_break] = ACTIONS(3187),
    [anon_sym_next] = ACTIONS(3189),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(769),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(769),
    [anon_sym_until] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(769),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(769),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(3191),
    [anon_sym_not] = ACTIONS(3193),
    [anon_sym_BANG] = ACTIONS(3195),
    [anon_sym_TILDE] = ACTIONS(3197),
    [sym_constant] = ACTIONS(3199),
    [sym_identifier] = ACTIONS(3199),
    [sym_instance_variable] = ACTIONS(3201),
    [sym_class_variable] = ACTIONS(3201),
    [sym_global_variable] = ACTIONS(3201),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(3203),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(3203),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [4061] = {
    [anon_sym_EQ] = ACTIONS(10287),
    [sym_comment] = ACTIONS(87),
  },
  [4062] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(10289),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(10291),
    [anon_sym_DASH_EQ] = ACTIONS(10291),
    [anon_sym_STAR_EQ] = ACTIONS(10291),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10291),
    [anon_sym_SLASH_EQ] = ACTIONS(10291),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10291),
    [anon_sym_PIPE_EQ] = ACTIONS(10291),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10291),
    [anon_sym_AMP_EQ] = ACTIONS(10291),
    [anon_sym_PERCENT_EQ] = ACTIONS(10291),
    [anon_sym_GT_GT_EQ] = ACTIONS(10291),
    [anon_sym_LT_LT_EQ] = ACTIONS(10291),
    [anon_sym_CARET_EQ] = ACTIONS(10291),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [4063] = {
    [sym_string] = STATE(6757),
    [aux_sym_chained_string_repeat1] = STATE(6757),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(2551),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [4064] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(10259),
    [sym__binary_star] = ACTIONS(10261),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_RBRACE] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(10263),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(10265),
    [anon_sym_AMP] = ACTIONS(10267),
    [anon_sym_EQ] = ACTIONS(4249),
    [anon_sym_LT] = ACTIONS(10269),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_PLUS_EQ] = ACTIONS(4247),
    [anon_sym_DASH_EQ] = ACTIONS(4247),
    [anon_sym_STAR_EQ] = ACTIONS(4247),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4247),
    [anon_sym_SLASH_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4247),
    [anon_sym_AMP_EQ] = ACTIONS(4247),
    [anon_sym_PERCENT_EQ] = ACTIONS(4247),
    [anon_sym_GT_GT_EQ] = ACTIONS(4247),
    [anon_sym_LT_LT_EQ] = ACTIONS(4247),
    [anon_sym_CARET_EQ] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(10271),
    [anon_sym_DOT_DOT] = ACTIONS(10273),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10275),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(10277),
    [anon_sym_AMP_AMP] = ACTIONS(10277),
    [anon_sym_LT_LT] = ACTIONS(10279),
    [anon_sym_GT_GT] = ACTIONS(10279),
    [anon_sym_EQ_EQ] = ACTIONS(10277),
    [anon_sym_BANG_EQ] = ACTIONS(10281),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10281),
    [anon_sym_LT_EQ_GT] = ACTIONS(10281),
    [anon_sym_EQ_TILDE] = ACTIONS(10281),
    [anon_sym_BANG_TILDE] = ACTIONS(10281),
    [anon_sym_LT_EQ] = ACTIONS(10269),
    [anon_sym_GT] = ACTIONS(10269),
    [anon_sym_GT_EQ] = ACTIONS(10283),
    [anon_sym_CARET] = ACTIONS(10263),
    [anon_sym_PLUS] = ACTIONS(10285),
    [anon_sym_SLASH] = ACTIONS(10265),
    [anon_sym_PERCENT] = ACTIONS(10265),
    [sym_comment] = ACTIONS(87),
  },
  [4065] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(6747),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [4066] = {
    [sym_string] = STATE(4086),
    [aux_sym_chained_string_repeat1] = STATE(4086),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(747),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [4067] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(6758),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(4062),
    [sym_scope_resolution] = STATE(4060),
    [sym_call] = STATE(4060),
    [sym_method_call] = STATE(4062),
    [sym_assignment] = STATE(6758),
    [sym_operator_assignment] = STATE(6758),
    [sym_conditional] = STATE(6758),
    [sym_range] = STATE(6758),
    [sym_binary] = STATE(6758),
    [sym_unary] = STATE(6758),
    [sym_left_assignment_list] = STATE(4061),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4062),
    [sym__variable] = STATE(4060),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(4062),
    [sym_false] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(4063),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(6713),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(6715),
    [anon_sym_yield] = ACTIONS(6717),
    [anon_sym_break] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6721),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(6723),
    [anon_sym_defined_QMARK] = ACTIONS(6725),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6731),
    [sym_identifier] = ACTIONS(6731),
    [sym_instance_variable] = ACTIONS(6733),
    [sym_class_variable] = ACTIONS(6733),
    [sym_global_variable] = ACTIONS(6733),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(6731),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6731),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [4068] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(10259),
    [sym__binary_star] = ACTIONS(10261),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_RBRACE] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(10263),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(10265),
    [anon_sym_AMP] = ACTIONS(10267),
    [anon_sym_EQ] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(10269),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_unless] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_until] = ACTIONS(3281),
    [anon_sym_rescue] = ACTIONS(3281),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_PLUS_EQ] = ACTIONS(3281),
    [anon_sym_DASH_EQ] = ACTIONS(3281),
    [anon_sym_STAR_EQ] = ACTIONS(3281),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3281),
    [anon_sym_SLASH_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3281),
    [anon_sym_AMP_EQ] = ACTIONS(3281),
    [anon_sym_PERCENT_EQ] = ACTIONS(3281),
    [anon_sym_GT_GT_EQ] = ACTIONS(3281),
    [anon_sym_LT_LT_EQ] = ACTIONS(3281),
    [anon_sym_CARET_EQ] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(10271),
    [anon_sym_DOT_DOT] = ACTIONS(10273),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10275),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(10277),
    [anon_sym_AMP_AMP] = ACTIONS(10277),
    [anon_sym_LT_LT] = ACTIONS(10279),
    [anon_sym_GT_GT] = ACTIONS(10279),
    [anon_sym_EQ_EQ] = ACTIONS(10277),
    [anon_sym_BANG_EQ] = ACTIONS(10281),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10281),
    [anon_sym_LT_EQ_GT] = ACTIONS(10281),
    [anon_sym_EQ_TILDE] = ACTIONS(10281),
    [anon_sym_BANG_TILDE] = ACTIONS(10281),
    [anon_sym_LT_EQ] = ACTIONS(10269),
    [anon_sym_GT] = ACTIONS(10269),
    [anon_sym_GT_EQ] = ACTIONS(10283),
    [anon_sym_CARET] = ACTIONS(10263),
    [anon_sym_PLUS] = ACTIONS(10285),
    [anon_sym_SLASH] = ACTIONS(10265),
    [anon_sym_PERCENT] = ACTIONS(10265),
    [sym_comment] = ACTIONS(87),
  },
  [4069] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(6741),
    [sym__binary_star] = ACTIONS(6743),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(6747),
    [anon_sym_AMP] = ACTIONS(6749),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(6751),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(6753),
    [anon_sym_DOT_DOT] = ACTIONS(6755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6757),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(6759),
    [anon_sym_AMP_AMP] = ACTIONS(6759),
    [anon_sym_LT_LT] = ACTIONS(6761),
    [anon_sym_GT_GT] = ACTIONS(6761),
    [anon_sym_EQ_EQ] = ACTIONS(6759),
    [anon_sym_BANG_EQ] = ACTIONS(6763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6763),
    [anon_sym_LT_EQ_GT] = ACTIONS(6763),
    [anon_sym_EQ_TILDE] = ACTIONS(6763),
    [anon_sym_BANG_TILDE] = ACTIONS(6763),
    [anon_sym_LT_EQ] = ACTIONS(6751),
    [anon_sym_GT] = ACTIONS(6751),
    [anon_sym_GT_EQ] = ACTIONS(6765),
    [anon_sym_CARET] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6767),
    [anon_sym_SLASH] = ACTIONS(6747),
    [anon_sym_PERCENT] = ACTIONS(6747),
    [sym_comment] = ACTIONS(87),
  },
  [4070] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(6759),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(4062),
    [sym_scope_resolution] = STATE(4060),
    [sym_call] = STATE(4060),
    [sym_method_call] = STATE(4062),
    [sym_assignment] = STATE(6759),
    [sym_operator_assignment] = STATE(6759),
    [sym_conditional] = STATE(6759),
    [sym_range] = STATE(6759),
    [sym_binary] = STATE(6759),
    [sym_unary] = STATE(6759),
    [sym_left_assignment_list] = STATE(4061),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4062),
    [sym__variable] = STATE(4060),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(4062),
    [sym_false] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(4063),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(6713),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(6715),
    [anon_sym_yield] = ACTIONS(6717),
    [anon_sym_break] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6721),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(6723),
    [anon_sym_defined_QMARK] = ACTIONS(6725),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6731),
    [sym_identifier] = ACTIONS(6731),
    [sym_instance_variable] = ACTIONS(6733),
    [sym_class_variable] = ACTIONS(6733),
    [sym_global_variable] = ACTIONS(6733),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(6731),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6731),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [4071] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(6760),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1762),
    [sym_scope_resolution] = STATE(1758),
    [sym_call] = STATE(1758),
    [sym_method_call] = STATE(1762),
    [sym_assignment] = STATE(6760),
    [sym_operator_assignment] = STATE(6760),
    [sym_conditional] = STATE(6760),
    [sym_range] = STATE(6760),
    [sym_binary] = STATE(6760),
    [sym_unary] = STATE(6760),
    [sym_left_assignment_list] = STATE(1761),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1762),
    [sym__variable] = STATE(1758),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1762),
    [sym_false] = STATE(1762),
    [sym_nil] = STATE(1762),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(4066),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(3179),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(3183),
    [anon_sym_yield] = ACTIONS(3185),
    [anon_sym_break] = ACTIONS(3187),
    [anon_sym_next] = ACTIONS(3189),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(6735),
    [anon_sym_defined_QMARK] = ACTIONS(3191),
    [anon_sym_not] = ACTIONS(3193),
    [anon_sym_BANG] = ACTIONS(3197),
    [anon_sym_TILDE] = ACTIONS(3197),
    [sym_constant] = ACTIONS(3203),
    [sym_identifier] = ACTIONS(3203),
    [sym_instance_variable] = ACTIONS(3201),
    [sym_class_variable] = ACTIONS(3201),
    [sym_global_variable] = ACTIONS(3201),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(3203),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(3203),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [4072] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(6761),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1762),
    [sym_scope_resolution] = STATE(1758),
    [sym_call] = STATE(1758),
    [sym_method_call] = STATE(1762),
    [sym_assignment] = STATE(6761),
    [sym_operator_assignment] = STATE(6761),
    [sym_conditional] = STATE(6761),
    [sym_range] = STATE(6761),
    [sym_binary] = STATE(6761),
    [sym_unary] = STATE(6761),
    [sym_left_assignment_list] = STATE(1761),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1762),
    [sym__variable] = STATE(1758),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1762),
    [sym_false] = STATE(1762),
    [sym_nil] = STATE(1762),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(4066),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(3179),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(3183),
    [anon_sym_yield] = ACTIONS(3185),
    [anon_sym_break] = ACTIONS(3187),
    [anon_sym_next] = ACTIONS(3189),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(6735),
    [anon_sym_defined_QMARK] = ACTIONS(3191),
    [anon_sym_not] = ACTIONS(3193),
    [anon_sym_BANG] = ACTIONS(3197),
    [anon_sym_TILDE] = ACTIONS(3197),
    [sym_constant] = ACTIONS(3203),
    [sym_identifier] = ACTIONS(3203),
    [sym_instance_variable] = ACTIONS(3201),
    [sym_class_variable] = ACTIONS(3201),
    [sym_global_variable] = ACTIONS(3201),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(3203),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(3203),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [4073] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(6762),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1762),
    [sym_scope_resolution] = STATE(1758),
    [sym_call] = STATE(1758),
    [sym_method_call] = STATE(1762),
    [sym_assignment] = STATE(6762),
    [sym_operator_assignment] = STATE(6762),
    [sym_conditional] = STATE(6762),
    [sym_range] = STATE(6762),
    [sym_binary] = STATE(6762),
    [sym_unary] = STATE(6762),
    [sym_left_assignment_list] = STATE(1761),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1762),
    [sym__variable] = STATE(1758),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1762),
    [sym_false] = STATE(1762),
    [sym_nil] = STATE(1762),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(4066),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(3179),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(3183),
    [anon_sym_yield] = ACTIONS(3185),
    [anon_sym_break] = ACTIONS(3187),
    [anon_sym_next] = ACTIONS(3189),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(6735),
    [anon_sym_defined_QMARK] = ACTIONS(3191),
    [anon_sym_not] = ACTIONS(3193),
    [anon_sym_BANG] = ACTIONS(3197),
    [anon_sym_TILDE] = ACTIONS(3197),
    [sym_constant] = ACTIONS(3203),
    [sym_identifier] = ACTIONS(3203),
    [sym_instance_variable] = ACTIONS(3201),
    [sym_class_variable] = ACTIONS(3201),
    [sym_global_variable] = ACTIONS(3201),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(3203),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(3203),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [4074] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(6763),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1762),
    [sym_scope_resolution] = STATE(1758),
    [sym_call] = STATE(1758),
    [sym_method_call] = STATE(1762),
    [sym_assignment] = STATE(6763),
    [sym_operator_assignment] = STATE(6763),
    [sym_conditional] = STATE(6763),
    [sym_range] = STATE(6763),
    [sym_binary] = STATE(6763),
    [sym_unary] = STATE(6763),
    [sym_left_assignment_list] = STATE(1761),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1762),
    [sym__variable] = STATE(1758),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1762),
    [sym_false] = STATE(1762),
    [sym_nil] = STATE(1762),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(4066),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(3179),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(3183),
    [anon_sym_yield] = ACTIONS(3185),
    [anon_sym_break] = ACTIONS(3187),
    [anon_sym_next] = ACTIONS(3189),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(6735),
    [anon_sym_defined_QMARK] = ACTIONS(3191),
    [anon_sym_not] = ACTIONS(3193),
    [anon_sym_BANG] = ACTIONS(3197),
    [anon_sym_TILDE] = ACTIONS(3197),
    [sym_constant] = ACTIONS(3203),
    [sym_identifier] = ACTIONS(3203),
    [sym_instance_variable] = ACTIONS(3201),
    [sym_class_variable] = ACTIONS(3201),
    [sym_global_variable] = ACTIONS(3201),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(3203),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(3203),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [4075] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(6764),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1762),
    [sym_scope_resolution] = STATE(1758),
    [sym_call] = STATE(1758),
    [sym_method_call] = STATE(1762),
    [sym_assignment] = STATE(6764),
    [sym_operator_assignment] = STATE(6764),
    [sym_conditional] = STATE(6764),
    [sym_range] = STATE(6764),
    [sym_binary] = STATE(6764),
    [sym_unary] = STATE(6764),
    [sym_left_assignment_list] = STATE(1761),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1762),
    [sym__variable] = STATE(1758),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1762),
    [sym_false] = STATE(1762),
    [sym_nil] = STATE(1762),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(4066),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(3179),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(3183),
    [anon_sym_yield] = ACTIONS(3185),
    [anon_sym_break] = ACTIONS(3187),
    [anon_sym_next] = ACTIONS(3189),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(6735),
    [anon_sym_defined_QMARK] = ACTIONS(3191),
    [anon_sym_not] = ACTIONS(3193),
    [anon_sym_BANG] = ACTIONS(3197),
    [anon_sym_TILDE] = ACTIONS(3197),
    [sym_constant] = ACTIONS(3203),
    [sym_identifier] = ACTIONS(3203),
    [sym_instance_variable] = ACTIONS(3201),
    [sym_class_variable] = ACTIONS(3201),
    [sym_global_variable] = ACTIONS(3201),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(3203),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(3203),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [4076] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(6765),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(6765),
    [sym_operator_assignment] = STATE(6765),
    [sym_conditional] = STATE(6765),
    [sym_range] = STATE(6765),
    [sym_binary] = STATE(6765),
    [sym_unary] = STATE(6765),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4077] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(6766),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1762),
    [sym_scope_resolution] = STATE(1758),
    [sym_call] = STATE(1758),
    [sym_method_call] = STATE(1762),
    [sym_assignment] = STATE(6766),
    [sym_operator_assignment] = STATE(6766),
    [sym_conditional] = STATE(6766),
    [sym_range] = STATE(6766),
    [sym_binary] = STATE(6766),
    [sym_unary] = STATE(6766),
    [sym_left_assignment_list] = STATE(1761),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1762),
    [sym__variable] = STATE(1758),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1762),
    [sym_false] = STATE(1762),
    [sym_nil] = STATE(1762),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(4066),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(3179),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(3183),
    [anon_sym_yield] = ACTIONS(3185),
    [anon_sym_break] = ACTIONS(3187),
    [anon_sym_next] = ACTIONS(3189),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(6735),
    [anon_sym_defined_QMARK] = ACTIONS(3191),
    [anon_sym_not] = ACTIONS(3193),
    [anon_sym_BANG] = ACTIONS(3197),
    [anon_sym_TILDE] = ACTIONS(3197),
    [sym_constant] = ACTIONS(3203),
    [sym_identifier] = ACTIONS(3203),
    [sym_instance_variable] = ACTIONS(3201),
    [sym_class_variable] = ACTIONS(3201),
    [sym_global_variable] = ACTIONS(3201),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(3203),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(3203),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [4078] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(6767),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1762),
    [sym_scope_resolution] = STATE(1758),
    [sym_call] = STATE(1758),
    [sym_method_call] = STATE(1762),
    [sym_assignment] = STATE(6767),
    [sym_operator_assignment] = STATE(6767),
    [sym_conditional] = STATE(6767),
    [sym_range] = STATE(6767),
    [sym_binary] = STATE(6767),
    [sym_unary] = STATE(6767),
    [sym_left_assignment_list] = STATE(1761),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1762),
    [sym__variable] = STATE(1758),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1762),
    [sym_false] = STATE(1762),
    [sym_nil] = STATE(1762),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(4066),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(3179),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(3183),
    [anon_sym_yield] = ACTIONS(3185),
    [anon_sym_break] = ACTIONS(3187),
    [anon_sym_next] = ACTIONS(3189),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(6735),
    [anon_sym_defined_QMARK] = ACTIONS(3191),
    [anon_sym_not] = ACTIONS(3193),
    [anon_sym_BANG] = ACTIONS(3197),
    [anon_sym_TILDE] = ACTIONS(3197),
    [sym_constant] = ACTIONS(3203),
    [sym_identifier] = ACTIONS(3203),
    [sym_instance_variable] = ACTIONS(3201),
    [sym_class_variable] = ACTIONS(3201),
    [sym_global_variable] = ACTIONS(3201),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(3203),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(3203),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [4079] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(6768),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1762),
    [sym_scope_resolution] = STATE(1758),
    [sym_call] = STATE(1758),
    [sym_method_call] = STATE(1762),
    [sym_assignment] = STATE(6768),
    [sym_operator_assignment] = STATE(6768),
    [sym_conditional] = STATE(6768),
    [sym_range] = STATE(6768),
    [sym_binary] = STATE(6768),
    [sym_unary] = STATE(6768),
    [sym_left_assignment_list] = STATE(1761),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1762),
    [sym__variable] = STATE(1758),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1762),
    [sym_false] = STATE(1762),
    [sym_nil] = STATE(1762),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(4066),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(3179),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(3183),
    [anon_sym_yield] = ACTIONS(3185),
    [anon_sym_break] = ACTIONS(3187),
    [anon_sym_next] = ACTIONS(3189),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(6735),
    [anon_sym_defined_QMARK] = ACTIONS(3191),
    [anon_sym_not] = ACTIONS(3193),
    [anon_sym_BANG] = ACTIONS(3197),
    [anon_sym_TILDE] = ACTIONS(3197),
    [sym_constant] = ACTIONS(3203),
    [sym_identifier] = ACTIONS(3203),
    [sym_instance_variable] = ACTIONS(3201),
    [sym_class_variable] = ACTIONS(3201),
    [sym_global_variable] = ACTIONS(3201),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(3203),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(3203),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [4080] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(6769),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1762),
    [sym_scope_resolution] = STATE(1758),
    [sym_call] = STATE(1758),
    [sym_method_call] = STATE(1762),
    [sym_assignment] = STATE(6769),
    [sym_operator_assignment] = STATE(6769),
    [sym_conditional] = STATE(6769),
    [sym_range] = STATE(6769),
    [sym_binary] = STATE(6769),
    [sym_unary] = STATE(6769),
    [sym_left_assignment_list] = STATE(1761),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1762),
    [sym__variable] = STATE(1758),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1762),
    [sym_false] = STATE(1762),
    [sym_nil] = STATE(1762),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(4066),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(3179),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(3183),
    [anon_sym_yield] = ACTIONS(3185),
    [anon_sym_break] = ACTIONS(3187),
    [anon_sym_next] = ACTIONS(3189),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(6735),
    [anon_sym_defined_QMARK] = ACTIONS(3191),
    [anon_sym_not] = ACTIONS(3193),
    [anon_sym_BANG] = ACTIONS(3197),
    [anon_sym_TILDE] = ACTIONS(3197),
    [sym_constant] = ACTIONS(3203),
    [sym_identifier] = ACTIONS(3203),
    [sym_instance_variable] = ACTIONS(3201),
    [sym_class_variable] = ACTIONS(3201),
    [sym_global_variable] = ACTIONS(3201),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(3203),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(3203),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [4081] = {
    [sym_heredoc_body] = STATE(6770),
    [aux_sym_call_repeat1] = STATE(6770),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_RBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [4082] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(1757),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1762),
    [sym_scope_resolution] = STATE(1758),
    [sym_call] = STATE(1758),
    [sym_method_call] = STATE(1762),
    [sym__argument] = STATE(3737),
    [sym_splat_argument] = STATE(3737),
    [sym_hash_splat_argument] = STATE(3737),
    [sym_block_argument] = STATE(3737),
    [sym_assignment] = STATE(1757),
    [sym_operator_assignment] = STATE(1757),
    [sym_conditional] = STATE(1757),
    [sym_range] = STATE(1757),
    [sym_binary] = STATE(1757),
    [sym_unary] = STATE(1757),
    [sym_left_assignment_list] = STATE(1761),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1762),
    [sym__variable] = STATE(1758),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1762),
    [sym_false] = STATE(1762),
    [sym_nil] = STATE(1762),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(1763),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_heredoc_body] = STATE(6771),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(3737),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(3175),
    [sym__splat_star] = ACTIONS(3177),
    [sym__unary_minus] = ACTIONS(3179),
    [sym__identifier_hash_key] = ACTIONS(3181),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10293),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(3183),
    [anon_sym_yield] = ACTIONS(3185),
    [anon_sym_break] = ACTIONS(3187),
    [anon_sym_next] = ACTIONS(3189),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(6735),
    [anon_sym_defined_QMARK] = ACTIONS(3191),
    [anon_sym_not] = ACTIONS(3193),
    [anon_sym_BANG] = ACTIONS(3197),
    [anon_sym_TILDE] = ACTIONS(3197),
    [sym_constant] = ACTIONS(3199),
    [sym_identifier] = ACTIONS(3199),
    [sym_instance_variable] = ACTIONS(3201),
    [sym_class_variable] = ACTIONS(3201),
    [sym_global_variable] = ACTIONS(3201),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(3203),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(3203),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [4083] = {
    [sym_heredoc_body] = STATE(6772),
    [aux_sym_call_repeat1] = STATE(6772),
    [aux_sym_argument_list_repeat1] = STATE(6773),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_RBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(6769),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [4084] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(6774),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1762),
    [sym_scope_resolution] = STATE(1758),
    [sym_call] = STATE(1758),
    [sym_method_call] = STATE(1762),
    [sym_splat_argument] = STATE(6775),
    [sym_assignment] = STATE(6774),
    [sym_operator_assignment] = STATE(6774),
    [sym_conditional] = STATE(6774),
    [sym_range] = STATE(6774),
    [sym_binary] = STATE(6774),
    [sym_unary] = STATE(6774),
    [sym_right_assignment_list] = STATE(3742),
    [sym__arg_or_splat_arg] = STATE(6775),
    [sym_left_assignment_list] = STATE(1761),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1762),
    [sym__variable] = STATE(1758),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1762),
    [sym_false] = STATE(1762),
    [sym_nil] = STATE(1762),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(4066),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__splat_star] = ACTIONS(6097),
    [sym__unary_minus] = ACTIONS(3179),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(3183),
    [anon_sym_yield] = ACTIONS(3185),
    [anon_sym_break] = ACTIONS(3187),
    [anon_sym_next] = ACTIONS(3189),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(6735),
    [anon_sym_defined_QMARK] = ACTIONS(3191),
    [anon_sym_not] = ACTIONS(3193),
    [anon_sym_BANG] = ACTIONS(3197),
    [anon_sym_TILDE] = ACTIONS(3197),
    [sym_constant] = ACTIONS(3203),
    [sym_identifier] = ACTIONS(3203),
    [sym_instance_variable] = ACTIONS(3201),
    [sym_class_variable] = ACTIONS(3201),
    [sym_global_variable] = ACTIONS(3201),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(3203),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(3203),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [4085] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(6776),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1762),
    [sym_scope_resolution] = STATE(1758),
    [sym_call] = STATE(1758),
    [sym_method_call] = STATE(1762),
    [sym_assignment] = STATE(6776),
    [sym_operator_assignment] = STATE(6776),
    [sym_conditional] = STATE(6776),
    [sym_range] = STATE(6776),
    [sym_binary] = STATE(6776),
    [sym_unary] = STATE(6776),
    [sym_left_assignment_list] = STATE(1761),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1762),
    [sym__variable] = STATE(1758),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1762),
    [sym_false] = STATE(1762),
    [sym_nil] = STATE(1762),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(4066),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(3179),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(3183),
    [anon_sym_yield] = ACTIONS(3185),
    [anon_sym_break] = ACTIONS(3187),
    [anon_sym_next] = ACTIONS(3189),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(6735),
    [anon_sym_defined_QMARK] = ACTIONS(3191),
    [anon_sym_not] = ACTIONS(3193),
    [anon_sym_BANG] = ACTIONS(3197),
    [anon_sym_TILDE] = ACTIONS(3197),
    [sym_constant] = ACTIONS(3203),
    [sym_identifier] = ACTIONS(3203),
    [sym_instance_variable] = ACTIONS(3201),
    [sym_class_variable] = ACTIONS(3201),
    [sym_global_variable] = ACTIONS(3201),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(3203),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(3203),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [4086] = {
    [sym_string] = STATE(6777),
    [aux_sym_chained_string_repeat1] = STATE(6777),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(747),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_RBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2755),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_EQ] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_EQ_GT] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_PLUS_EQ] = ACTIONS(2753),
    [anon_sym_DASH_EQ] = ACTIONS(2753),
    [anon_sym_STAR_EQ] = ACTIONS(2753),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2753),
    [anon_sym_SLASH_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2753),
    [anon_sym_AMP_EQ] = ACTIONS(2753),
    [anon_sym_PERCENT_EQ] = ACTIONS(2753),
    [anon_sym_GT_GT_EQ] = ACTIONS(2753),
    [anon_sym_LT_LT_EQ] = ACTIONS(2753),
    [anon_sym_CARET_EQ] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2755),
    [anon_sym_AMP_AMP] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2755),
    [anon_sym_GT_GT] = ACTIONS(2755),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_SLASH] = ACTIONS(2755),
    [anon_sym_PERCENT] = ACTIONS(2755),
    [sym_comment] = ACTIONS(87),
  },
  [4087] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(6778),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(4094),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4094),
    [sym_assignment] = STATE(6778),
    [sym_operator_assignment] = STATE(6778),
    [sym_conditional] = STATE(6778),
    [sym_range] = STATE(6778),
    [sym_binary] = STATE(6778),
    [sym_unary] = STATE(6778),
    [sym_left_assignment_list] = STATE(4093),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4094),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(4094),
    [sym_false] = STATE(4094),
    [sym_nil] = STATE(4094),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(4010),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6781),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6653),
    [anon_sym_yield] = ACTIONS(6655),
    [anon_sym_break] = ACTIONS(6657),
    [anon_sym_next] = ACTIONS(6659),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6783),
    [anon_sym_defined_QMARK] = ACTIONS(6785),
    [anon_sym_not] = ACTIONS(6787),
    [anon_sym_BANG] = ACTIONS(6789),
    [anon_sym_TILDE] = ACTIONS(6789),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4088] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(6779),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(4094),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4094),
    [sym_assignment] = STATE(6779),
    [sym_operator_assignment] = STATE(6779),
    [sym_conditional] = STATE(6779),
    [sym_range] = STATE(6779),
    [sym_binary] = STATE(6779),
    [sym_unary] = STATE(6779),
    [sym_left_assignment_list] = STATE(4093),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4094),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(4094),
    [sym_false] = STATE(4094),
    [sym_nil] = STATE(4094),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(4010),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6781),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6653),
    [anon_sym_yield] = ACTIONS(6655),
    [anon_sym_break] = ACTIONS(6657),
    [anon_sym_next] = ACTIONS(6659),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6783),
    [anon_sym_defined_QMARK] = ACTIONS(6785),
    [anon_sym_not] = ACTIONS(6787),
    [anon_sym_BANG] = ACTIONS(6789),
    [anon_sym_TILDE] = ACTIONS(6789),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4089] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(6780),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(4094),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4094),
    [sym_assignment] = STATE(6780),
    [sym_operator_assignment] = STATE(6780),
    [sym_conditional] = STATE(6780),
    [sym_range] = STATE(6780),
    [sym_binary] = STATE(6780),
    [sym_unary] = STATE(6780),
    [sym_left_assignment_list] = STATE(4093),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4094),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(4094),
    [sym_false] = STATE(4094),
    [sym_nil] = STATE(4094),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(4010),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6781),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6653),
    [anon_sym_yield] = ACTIONS(6655),
    [anon_sym_break] = ACTIONS(6657),
    [anon_sym_next] = ACTIONS(6659),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6783),
    [anon_sym_defined_QMARK] = ACTIONS(6785),
    [anon_sym_not] = ACTIONS(6787),
    [anon_sym_BANG] = ACTIONS(6789),
    [anon_sym_TILDE] = ACTIONS(6789),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4090] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(298),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(4094),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4094),
    [sym_assignment] = STATE(298),
    [sym_operator_assignment] = STATE(298),
    [sym_conditional] = STATE(298),
    [sym_range] = STATE(298),
    [sym_binary] = STATE(298),
    [sym_unary] = STATE(298),
    [sym_left_assignment_list] = STATE(4093),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4094),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(4094),
    [sym_false] = STATE(4094),
    [sym_nil] = STATE(4094),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(4010),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6781),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6653),
    [anon_sym_yield] = ACTIONS(6655),
    [anon_sym_break] = ACTIONS(6657),
    [anon_sym_next] = ACTIONS(6659),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6783),
    [anon_sym_defined_QMARK] = ACTIONS(6785),
    [anon_sym_not] = ACTIONS(6787),
    [anon_sym_BANG] = ACTIONS(6789),
    [anon_sym_TILDE] = ACTIONS(6789),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4091] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(10295),
    [sym__binary_star] = ACTIONS(10297),
    [anon_sym_RBRACE] = ACTIONS(5115),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(10299),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(10297),
    [anon_sym_AMP] = ACTIONS(10301),
    [anon_sym_LT] = ACTIONS(10303),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(10305),
    [anon_sym_DOT_DOT] = ACTIONS(10307),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10309),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(10311),
    [anon_sym_AMP_AMP] = ACTIONS(10311),
    [anon_sym_LT_LT] = ACTIONS(10313),
    [anon_sym_GT_GT] = ACTIONS(10313),
    [anon_sym_EQ_EQ] = ACTIONS(10315),
    [anon_sym_BANG_EQ] = ACTIONS(10311),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10311),
    [anon_sym_LT_EQ_GT] = ACTIONS(10311),
    [anon_sym_EQ_TILDE] = ACTIONS(10311),
    [anon_sym_BANG_TILDE] = ACTIONS(10311),
    [anon_sym_LT_EQ] = ACTIONS(10303),
    [anon_sym_GT] = ACTIONS(10303),
    [anon_sym_GT_EQ] = ACTIONS(10317),
    [anon_sym_CARET] = ACTIONS(10319),
    [anon_sym_PLUS] = ACTIONS(10295),
    [anon_sym_SLASH] = ACTIONS(10297),
    [anon_sym_PERCENT] = ACTIONS(10297),
    [sym_comment] = ACTIONS(87),
  },
  [4092] = {
    [aux_sym_exceptions_repeat1] = STATE(6792),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_RBRACE] = ACTIONS(6191),
    [anon_sym_COMMA] = ACTIONS(10321),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [4093] = {
    [anon_sym_EQ] = ACTIONS(10323),
    [sym_comment] = ACTIONS(87),
  },
  [4094] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(10325),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(10327),
    [anon_sym_DASH_EQ] = ACTIONS(10327),
    [anon_sym_STAR_EQ] = ACTIONS(10327),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10327),
    [anon_sym_SLASH_EQ] = ACTIONS(10327),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10327),
    [anon_sym_PIPE_EQ] = ACTIONS(10327),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10327),
    [anon_sym_AMP_EQ] = ACTIONS(10327),
    [anon_sym_PERCENT_EQ] = ACTIONS(10327),
    [anon_sym_GT_GT_EQ] = ACTIONS(10327),
    [anon_sym_LT_LT_EQ] = ACTIONS(10327),
    [anon_sym_CARET_EQ] = ACTIONS(10327),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [4095] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(3147),
    [sym__binary_star] = ACTIONS(3149),
    [anon_sym_RBRACE] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(3151),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(3149),
    [anon_sym_AMP] = ACTIONS(3153),
    [anon_sym_LT] = ACTIONS(3155),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(3157),
    [anon_sym_DOT_DOT] = ACTIONS(3159),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3161),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3167),
    [anon_sym_GT_GT] = ACTIONS(3167),
    [anon_sym_EQ_EQ] = ACTIONS(3169),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3155),
    [anon_sym_GT] = ACTIONS(3155),
    [anon_sym_GT_EQ] = ACTIONS(3171),
    [anon_sym_CARET] = ACTIONS(3173),
    [anon_sym_PLUS] = ACTIONS(3147),
    [anon_sym_SLASH] = ACTIONS(3149),
    [anon_sym_PERCENT] = ACTIONS(3149),
    [sym_comment] = ACTIONS(87),
  },
  [4096] = {
    [sym_string] = STATE(4096),
    [aux_sym_chained_string_repeat1] = STATE(4096),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(6214),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_RBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [4097] = {
    [sym__binary_minus] = ACTIONS(6601),
    [sym__binary_star] = ACTIONS(6601),
    [anon_sym_LBRACE] = ACTIONS(6601),
    [anon_sym_RBRACE] = ACTIONS(6601),
    [anon_sym_RPAREN] = ACTIONS(6601),
    [anon_sym_DOT] = ACTIONS(6603),
    [anon_sym_COMMA] = ACTIONS(6601),
    [anon_sym_PIPE] = ACTIONS(6603),
    [anon_sym_SEMI] = ACTIONS(6601),
    [anon_sym_STAR_STAR] = ACTIONS(6601),
    [anon_sym_AMP] = ACTIONS(6603),
    [anon_sym_LT] = ACTIONS(6603),
    [anon_sym_if] = ACTIONS(6601),
    [anon_sym_unless] = ACTIONS(6601),
    [anon_sym_while] = ACTIONS(6601),
    [anon_sym_until] = ACTIONS(6601),
    [anon_sym_rescue] = ACTIONS(6601),
    [anon_sym_do] = ACTIONS(6601),
    [anon_sym_EQ_GT] = ACTIONS(6601),
    [anon_sym_LBRACK] = ACTIONS(6601),
    [anon_sym_COLON_COLON2] = ACTIONS(6601),
    [anon_sym_AMP_DOT] = ACTIONS(6601),
    [anon_sym_QMARK] = ACTIONS(6601),
    [anon_sym_COLON2] = ACTIONS(6603),
    [anon_sym_DOT_DOT] = ACTIONS(6603),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6601),
    [anon_sym_and] = ACTIONS(6601),
    [anon_sym_or] = ACTIONS(6601),
    [anon_sym_PIPE_PIPE] = ACTIONS(6601),
    [anon_sym_AMP_AMP] = ACTIONS(6601),
    [anon_sym_LT_LT] = ACTIONS(6601),
    [anon_sym_GT_GT] = ACTIONS(6601),
    [anon_sym_EQ_EQ] = ACTIONS(6603),
    [anon_sym_BANG_EQ] = ACTIONS(6601),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6601),
    [anon_sym_LT_EQ_GT] = ACTIONS(6601),
    [anon_sym_EQ_TILDE] = ACTIONS(6601),
    [anon_sym_BANG_TILDE] = ACTIONS(6601),
    [anon_sym_LT_EQ] = ACTIONS(6603),
    [anon_sym_GT] = ACTIONS(6603),
    [anon_sym_GT_EQ] = ACTIONS(6601),
    [anon_sym_CARET] = ACTIONS(6601),
    [anon_sym_PLUS] = ACTIONS(6601),
    [anon_sym_SLASH] = ACTIONS(6601),
    [anon_sym_PERCENT] = ACTIONS(6601),
    [sym_comment] = ACTIONS(87),
  },
  [4098] = {
    [sym__binary_minus] = ACTIONS(6605),
    [sym__binary_star] = ACTIONS(6605),
    [anon_sym_LBRACE] = ACTIONS(6605),
    [anon_sym_RBRACE] = ACTIONS(6605),
    [anon_sym_RPAREN] = ACTIONS(6605),
    [anon_sym_DOT] = ACTIONS(6607),
    [anon_sym_COMMA] = ACTIONS(6605),
    [anon_sym_PIPE] = ACTIONS(6607),
    [anon_sym_SEMI] = ACTIONS(6605),
    [anon_sym_STAR_STAR] = ACTIONS(6605),
    [anon_sym_AMP] = ACTIONS(6607),
    [anon_sym_LT] = ACTIONS(6607),
    [anon_sym_if] = ACTIONS(6605),
    [anon_sym_unless] = ACTIONS(6605),
    [anon_sym_while] = ACTIONS(6605),
    [anon_sym_until] = ACTIONS(6605),
    [anon_sym_rescue] = ACTIONS(6605),
    [anon_sym_do] = ACTIONS(6605),
    [anon_sym_EQ_GT] = ACTIONS(6605),
    [anon_sym_LBRACK] = ACTIONS(6605),
    [anon_sym_COLON_COLON2] = ACTIONS(6605),
    [anon_sym_AMP_DOT] = ACTIONS(6605),
    [anon_sym_QMARK] = ACTIONS(6605),
    [anon_sym_COLON2] = ACTIONS(6607),
    [anon_sym_DOT_DOT] = ACTIONS(6607),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6605),
    [anon_sym_and] = ACTIONS(6605),
    [anon_sym_or] = ACTIONS(6605),
    [anon_sym_PIPE_PIPE] = ACTIONS(6605),
    [anon_sym_AMP_AMP] = ACTIONS(6605),
    [anon_sym_LT_LT] = ACTIONS(6605),
    [anon_sym_GT_GT] = ACTIONS(6605),
    [anon_sym_EQ_EQ] = ACTIONS(6607),
    [anon_sym_BANG_EQ] = ACTIONS(6605),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6605),
    [anon_sym_LT_EQ_GT] = ACTIONS(6605),
    [anon_sym_EQ_TILDE] = ACTIONS(6605),
    [anon_sym_BANG_TILDE] = ACTIONS(6605),
    [anon_sym_LT_EQ] = ACTIONS(6607),
    [anon_sym_GT] = ACTIONS(6607),
    [anon_sym_GT_EQ] = ACTIONS(6605),
    [anon_sym_CARET] = ACTIONS(6605),
    [anon_sym_PLUS] = ACTIONS(6605),
    [anon_sym_SLASH] = ACTIONS(6605),
    [anon_sym_PERCENT] = ACTIONS(6605),
    [sym_comment] = ACTIONS(87),
  },
  [4099] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1697),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(10329),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [4100] = {
    [aux_sym_string_array_repeat1] = STATE(1699),
    [sym__string_end] = ACTIONS(10329),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(10331),
  },
  [4101] = {
    [sym__binary_minus] = ACTIONS(6613),
    [sym__binary_star] = ACTIONS(6613),
    [anon_sym_LBRACE] = ACTIONS(6613),
    [anon_sym_RBRACE] = ACTIONS(6613),
    [anon_sym_RPAREN] = ACTIONS(6613),
    [anon_sym_DOT] = ACTIONS(6615),
    [anon_sym_COMMA] = ACTIONS(6613),
    [anon_sym_PIPE] = ACTIONS(6615),
    [anon_sym_SEMI] = ACTIONS(6613),
    [anon_sym_STAR_STAR] = ACTIONS(6613),
    [anon_sym_AMP] = ACTIONS(6615),
    [anon_sym_LT] = ACTIONS(6615),
    [anon_sym_if] = ACTIONS(6613),
    [anon_sym_unless] = ACTIONS(6613),
    [anon_sym_while] = ACTIONS(6613),
    [anon_sym_until] = ACTIONS(6613),
    [anon_sym_rescue] = ACTIONS(6613),
    [anon_sym_do] = ACTIONS(6613),
    [anon_sym_EQ_GT] = ACTIONS(6613),
    [anon_sym_LBRACK] = ACTIONS(6613),
    [anon_sym_COLON_COLON2] = ACTIONS(6613),
    [anon_sym_AMP_DOT] = ACTIONS(6613),
    [anon_sym_QMARK] = ACTIONS(6613),
    [anon_sym_COLON2] = ACTIONS(6615),
    [anon_sym_DOT_DOT] = ACTIONS(6615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6613),
    [anon_sym_and] = ACTIONS(6613),
    [anon_sym_or] = ACTIONS(6613),
    [anon_sym_PIPE_PIPE] = ACTIONS(6613),
    [anon_sym_AMP_AMP] = ACTIONS(6613),
    [anon_sym_LT_LT] = ACTIONS(6613),
    [anon_sym_GT_GT] = ACTIONS(6613),
    [anon_sym_EQ_EQ] = ACTIONS(6615),
    [anon_sym_BANG_EQ] = ACTIONS(6613),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6613),
    [anon_sym_LT_EQ_GT] = ACTIONS(6613),
    [anon_sym_EQ_TILDE] = ACTIONS(6613),
    [anon_sym_BANG_TILDE] = ACTIONS(6613),
    [anon_sym_LT_EQ] = ACTIONS(6615),
    [anon_sym_GT] = ACTIONS(6615),
    [anon_sym_GT_EQ] = ACTIONS(6613),
    [anon_sym_CARET] = ACTIONS(6613),
    [anon_sym_PLUS] = ACTIONS(6613),
    [anon_sym_SLASH] = ACTIONS(6613),
    [anon_sym_PERCENT] = ACTIONS(6613),
    [sym_comment] = ACTIONS(87),
  },
  [4102] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1697),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(10333),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [4103] = {
    [sym__binary_minus] = ACTIONS(6626),
    [sym__binary_star] = ACTIONS(6626),
    [anon_sym_LBRACE] = ACTIONS(6626),
    [anon_sym_RBRACE] = ACTIONS(6626),
    [anon_sym_RPAREN] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(6628),
    [anon_sym_COMMA] = ACTIONS(6626),
    [anon_sym_PIPE] = ACTIONS(6628),
    [anon_sym_SEMI] = ACTIONS(6626),
    [anon_sym_STAR_STAR] = ACTIONS(6626),
    [anon_sym_AMP] = ACTIONS(6628),
    [anon_sym_LT] = ACTIONS(6628),
    [anon_sym_if] = ACTIONS(6626),
    [anon_sym_unless] = ACTIONS(6626),
    [anon_sym_while] = ACTIONS(6626),
    [anon_sym_until] = ACTIONS(6626),
    [anon_sym_rescue] = ACTIONS(6626),
    [anon_sym_do] = ACTIONS(6626),
    [anon_sym_EQ_GT] = ACTIONS(6626),
    [anon_sym_LBRACK] = ACTIONS(6626),
    [anon_sym_COLON_COLON2] = ACTIONS(6626),
    [anon_sym_AMP_DOT] = ACTIONS(6626),
    [anon_sym_QMARK] = ACTIONS(6626),
    [anon_sym_COLON2] = ACTIONS(6628),
    [anon_sym_DOT_DOT] = ACTIONS(6628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6626),
    [anon_sym_and] = ACTIONS(6626),
    [anon_sym_or] = ACTIONS(6626),
    [anon_sym_PIPE_PIPE] = ACTIONS(6626),
    [anon_sym_AMP_AMP] = ACTIONS(6626),
    [anon_sym_LT_LT] = ACTIONS(6626),
    [anon_sym_GT_GT] = ACTIONS(6626),
    [anon_sym_EQ_EQ] = ACTIONS(6628),
    [anon_sym_BANG_EQ] = ACTIONS(6626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6626),
    [anon_sym_LT_EQ_GT] = ACTIONS(6626),
    [anon_sym_EQ_TILDE] = ACTIONS(6626),
    [anon_sym_BANG_TILDE] = ACTIONS(6626),
    [anon_sym_LT_EQ] = ACTIONS(6628),
    [anon_sym_GT] = ACTIONS(6628),
    [anon_sym_GT_EQ] = ACTIONS(6626),
    [anon_sym_CARET] = ACTIONS(6626),
    [anon_sym_PLUS] = ACTIONS(6626),
    [anon_sym_SLASH] = ACTIONS(6626),
    [anon_sym_PERCENT] = ACTIONS(6626),
    [sym_comment] = ACTIONS(87),
  },
  [4104] = {
    [sym__binary_minus] = ACTIONS(6630),
    [sym__binary_star] = ACTIONS(6630),
    [anon_sym_LBRACE] = ACTIONS(6630),
    [anon_sym_RBRACE] = ACTIONS(6630),
    [anon_sym_RPAREN] = ACTIONS(6630),
    [anon_sym_DOT] = ACTIONS(6632),
    [anon_sym_COMMA] = ACTIONS(6630),
    [anon_sym_PIPE] = ACTIONS(6632),
    [anon_sym_SEMI] = ACTIONS(6630),
    [anon_sym_STAR_STAR] = ACTIONS(6630),
    [anon_sym_AMP] = ACTIONS(6632),
    [anon_sym_LT] = ACTIONS(6632),
    [anon_sym_if] = ACTIONS(6630),
    [anon_sym_unless] = ACTIONS(6630),
    [anon_sym_while] = ACTIONS(6630),
    [anon_sym_until] = ACTIONS(6630),
    [anon_sym_rescue] = ACTIONS(6630),
    [anon_sym_do] = ACTIONS(6630),
    [anon_sym_EQ_GT] = ACTIONS(6630),
    [anon_sym_LBRACK] = ACTIONS(6630),
    [anon_sym_COLON_COLON2] = ACTIONS(6630),
    [anon_sym_AMP_DOT] = ACTIONS(6630),
    [anon_sym_QMARK] = ACTIONS(6630),
    [anon_sym_COLON2] = ACTIONS(6632),
    [anon_sym_DOT_DOT] = ACTIONS(6632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6630),
    [anon_sym_and] = ACTIONS(6630),
    [anon_sym_or] = ACTIONS(6630),
    [anon_sym_PIPE_PIPE] = ACTIONS(6630),
    [anon_sym_AMP_AMP] = ACTIONS(6630),
    [anon_sym_LT_LT] = ACTIONS(6630),
    [anon_sym_GT_GT] = ACTIONS(6630),
    [anon_sym_EQ_EQ] = ACTIONS(6632),
    [anon_sym_BANG_EQ] = ACTIONS(6630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6630),
    [anon_sym_LT_EQ_GT] = ACTIONS(6630),
    [anon_sym_EQ_TILDE] = ACTIONS(6630),
    [anon_sym_BANG_TILDE] = ACTIONS(6630),
    [anon_sym_LT_EQ] = ACTIONS(6632),
    [anon_sym_GT] = ACTIONS(6632),
    [anon_sym_GT_EQ] = ACTIONS(6630),
    [anon_sym_CARET] = ACTIONS(6630),
    [anon_sym_PLUS] = ACTIONS(6630),
    [anon_sym_SLASH] = ACTIONS(6630),
    [anon_sym_PERCENT] = ACTIONS(6630),
    [sym_comment] = ACTIONS(87),
  },
  [4105] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1705),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(10335),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [4106] = {
    [aux_sym_symbol_array_repeat1] = STATE(1707),
    [sym__string_end] = ACTIONS(10335),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(10337),
  },
  [4107] = {
    [sym__binary_minus] = ACTIONS(6638),
    [sym__binary_star] = ACTIONS(6638),
    [anon_sym_LBRACE] = ACTIONS(6638),
    [anon_sym_RBRACE] = ACTIONS(6638),
    [anon_sym_RPAREN] = ACTIONS(6638),
    [anon_sym_DOT] = ACTIONS(6640),
    [anon_sym_COMMA] = ACTIONS(6638),
    [anon_sym_PIPE] = ACTIONS(6640),
    [anon_sym_SEMI] = ACTIONS(6638),
    [anon_sym_STAR_STAR] = ACTIONS(6638),
    [anon_sym_AMP] = ACTIONS(6640),
    [anon_sym_LT] = ACTIONS(6640),
    [anon_sym_if] = ACTIONS(6638),
    [anon_sym_unless] = ACTIONS(6638),
    [anon_sym_while] = ACTIONS(6638),
    [anon_sym_until] = ACTIONS(6638),
    [anon_sym_rescue] = ACTIONS(6638),
    [anon_sym_do] = ACTIONS(6638),
    [anon_sym_EQ_GT] = ACTIONS(6638),
    [anon_sym_LBRACK] = ACTIONS(6638),
    [anon_sym_COLON_COLON2] = ACTIONS(6638),
    [anon_sym_AMP_DOT] = ACTIONS(6638),
    [anon_sym_QMARK] = ACTIONS(6638),
    [anon_sym_COLON2] = ACTIONS(6640),
    [anon_sym_DOT_DOT] = ACTIONS(6640),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6638),
    [anon_sym_and] = ACTIONS(6638),
    [anon_sym_or] = ACTIONS(6638),
    [anon_sym_PIPE_PIPE] = ACTIONS(6638),
    [anon_sym_AMP_AMP] = ACTIONS(6638),
    [anon_sym_LT_LT] = ACTIONS(6638),
    [anon_sym_GT_GT] = ACTIONS(6638),
    [anon_sym_EQ_EQ] = ACTIONS(6640),
    [anon_sym_BANG_EQ] = ACTIONS(6638),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6638),
    [anon_sym_LT_EQ_GT] = ACTIONS(6638),
    [anon_sym_EQ_TILDE] = ACTIONS(6638),
    [anon_sym_BANG_TILDE] = ACTIONS(6638),
    [anon_sym_LT_EQ] = ACTIONS(6640),
    [anon_sym_GT] = ACTIONS(6640),
    [anon_sym_GT_EQ] = ACTIONS(6638),
    [anon_sym_CARET] = ACTIONS(6638),
    [anon_sym_PLUS] = ACTIONS(6638),
    [anon_sym_SLASH] = ACTIONS(6638),
    [anon_sym_PERCENT] = ACTIONS(6638),
    [sym_comment] = ACTIONS(87),
  },
  [4108] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1705),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(10339),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [4109] = {
    [sym__heredoc_content] = ACTIONS(6437),
    [sym_heredoc_end] = ACTIONS(6437),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(6439),
    [sym_escape_sequence] = ACTIONS(6437),
  },
  [4110] = {
    [sym__binary_minus] = ACTIONS(7162),
    [sym__binary_star] = ACTIONS(7162),
    [anon_sym_LBRACE] = ACTIONS(7162),
    [anon_sym_RBRACE] = ACTIONS(7162),
    [anon_sym_RPAREN] = ACTIONS(7162),
    [anon_sym_DOT] = ACTIONS(7164),
    [anon_sym_COMMA] = ACTIONS(7162),
    [anon_sym_PIPE] = ACTIONS(7164),
    [anon_sym_SEMI] = ACTIONS(7162),
    [anon_sym_STAR_STAR] = ACTIONS(7162),
    [anon_sym_AMP] = ACTIONS(7164),
    [anon_sym_LT] = ACTIONS(7164),
    [anon_sym_if] = ACTIONS(7162),
    [anon_sym_unless] = ACTIONS(7162),
    [anon_sym_while] = ACTIONS(7162),
    [anon_sym_until] = ACTIONS(7162),
    [anon_sym_rescue] = ACTIONS(7162),
    [anon_sym_do] = ACTIONS(7162),
    [anon_sym_EQ_GT] = ACTIONS(7162),
    [anon_sym_LBRACK] = ACTIONS(7162),
    [anon_sym_COLON_COLON2] = ACTIONS(7162),
    [anon_sym_AMP_DOT] = ACTIONS(7162),
    [anon_sym_QMARK] = ACTIONS(7162),
    [anon_sym_COLON2] = ACTIONS(7164),
    [anon_sym_DOT_DOT] = ACTIONS(7164),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7162),
    [anon_sym_and] = ACTIONS(7162),
    [anon_sym_or] = ACTIONS(7162),
    [anon_sym_PIPE_PIPE] = ACTIONS(7162),
    [anon_sym_AMP_AMP] = ACTIONS(7162),
    [anon_sym_LT_LT] = ACTIONS(7162),
    [anon_sym_GT_GT] = ACTIONS(7162),
    [anon_sym_EQ_EQ] = ACTIONS(7164),
    [anon_sym_BANG_EQ] = ACTIONS(7162),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7162),
    [anon_sym_LT_EQ_GT] = ACTIONS(7162),
    [anon_sym_EQ_TILDE] = ACTIONS(7162),
    [anon_sym_BANG_TILDE] = ACTIONS(7162),
    [anon_sym_LT_EQ] = ACTIONS(7164),
    [anon_sym_GT] = ACTIONS(7164),
    [anon_sym_GT_EQ] = ACTIONS(7162),
    [anon_sym_CARET] = ACTIONS(7162),
    [anon_sym_PLUS] = ACTIONS(7162),
    [anon_sym_SLASH] = ACTIONS(7162),
    [anon_sym_PERCENT] = ACTIONS(7162),
    [sym_comment] = ACTIONS(87),
  },
  [4111] = {
    [anon_sym_DOT] = ACTIONS(10341),
    [anon_sym_COLON_COLON] = ACTIONS(10341),
    [sym_comment] = ACTIONS(87),
  },
  [4112] = {
    [sym__binary_minus] = ACTIONS(7314),
    [sym__binary_star] = ACTIONS(7314),
    [anon_sym_LBRACE] = ACTIONS(7314),
    [anon_sym_RBRACE] = ACTIONS(7314),
    [anon_sym_RPAREN] = ACTIONS(7314),
    [anon_sym_DOT] = ACTIONS(7316),
    [anon_sym_COMMA] = ACTIONS(7314),
    [anon_sym_PIPE] = ACTIONS(7316),
    [anon_sym_SEMI] = ACTIONS(7314),
    [anon_sym_STAR_STAR] = ACTIONS(7314),
    [anon_sym_AMP] = ACTIONS(7316),
    [anon_sym_LT] = ACTIONS(7316),
    [anon_sym_if] = ACTIONS(7314),
    [anon_sym_unless] = ACTIONS(7314),
    [anon_sym_while] = ACTIONS(7314),
    [anon_sym_until] = ACTIONS(7314),
    [anon_sym_rescue] = ACTIONS(7314),
    [anon_sym_do] = ACTIONS(7314),
    [anon_sym_EQ_GT] = ACTIONS(7314),
    [anon_sym_LBRACK] = ACTIONS(7314),
    [anon_sym_COLON_COLON2] = ACTIONS(7314),
    [anon_sym_AMP_DOT] = ACTIONS(7314),
    [anon_sym_QMARK] = ACTIONS(7314),
    [anon_sym_COLON2] = ACTIONS(7316),
    [anon_sym_DOT_DOT] = ACTIONS(7316),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7314),
    [anon_sym_and] = ACTIONS(7314),
    [anon_sym_or] = ACTIONS(7314),
    [anon_sym_PIPE_PIPE] = ACTIONS(7314),
    [anon_sym_AMP_AMP] = ACTIONS(7314),
    [anon_sym_LT_LT] = ACTIONS(7314),
    [anon_sym_GT_GT] = ACTIONS(7314),
    [anon_sym_EQ_EQ] = ACTIONS(7316),
    [anon_sym_BANG_EQ] = ACTIONS(7314),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7314),
    [anon_sym_LT_EQ_GT] = ACTIONS(7314),
    [anon_sym_EQ_TILDE] = ACTIONS(7314),
    [anon_sym_BANG_TILDE] = ACTIONS(7314),
    [anon_sym_LT_EQ] = ACTIONS(7316),
    [anon_sym_GT] = ACTIONS(7316),
    [anon_sym_GT_EQ] = ACTIONS(7314),
    [anon_sym_CARET] = ACTIONS(7314),
    [anon_sym_PLUS] = ACTIONS(7314),
    [anon_sym_SLASH] = ACTIONS(7314),
    [anon_sym_PERCENT] = ACTIONS(7314),
    [sym_comment] = ACTIONS(87),
  },
  [4113] = {
    [sym__binary_minus] = ACTIONS(7330),
    [sym__binary_star] = ACTIONS(7330),
    [anon_sym_LBRACE] = ACTIONS(7330),
    [anon_sym_RBRACE] = ACTIONS(7330),
    [anon_sym_RPAREN] = ACTIONS(7330),
    [anon_sym_DOT] = ACTIONS(7332),
    [anon_sym_COMMA] = ACTIONS(7330),
    [anon_sym_PIPE] = ACTIONS(7332),
    [anon_sym_SEMI] = ACTIONS(7330),
    [anon_sym_STAR_STAR] = ACTIONS(7330),
    [anon_sym_AMP] = ACTIONS(7332),
    [anon_sym_LT] = ACTIONS(7332),
    [anon_sym_if] = ACTIONS(7330),
    [anon_sym_unless] = ACTIONS(7330),
    [anon_sym_while] = ACTIONS(7330),
    [anon_sym_until] = ACTIONS(7330),
    [anon_sym_rescue] = ACTIONS(7330),
    [anon_sym_do] = ACTIONS(7330),
    [anon_sym_EQ_GT] = ACTIONS(7330),
    [anon_sym_LBRACK] = ACTIONS(7330),
    [anon_sym_COLON_COLON2] = ACTIONS(7330),
    [anon_sym_AMP_DOT] = ACTIONS(7330),
    [anon_sym_QMARK] = ACTIONS(7330),
    [anon_sym_COLON2] = ACTIONS(7332),
    [anon_sym_DOT_DOT] = ACTIONS(7332),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7330),
    [anon_sym_and] = ACTIONS(7330),
    [anon_sym_or] = ACTIONS(7330),
    [anon_sym_PIPE_PIPE] = ACTIONS(7330),
    [anon_sym_AMP_AMP] = ACTIONS(7330),
    [anon_sym_LT_LT] = ACTIONS(7330),
    [anon_sym_GT_GT] = ACTIONS(7330),
    [anon_sym_EQ_EQ] = ACTIONS(7332),
    [anon_sym_BANG_EQ] = ACTIONS(7330),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7330),
    [anon_sym_LT_EQ_GT] = ACTIONS(7330),
    [anon_sym_EQ_TILDE] = ACTIONS(7330),
    [anon_sym_BANG_TILDE] = ACTIONS(7330),
    [anon_sym_LT_EQ] = ACTIONS(7332),
    [anon_sym_GT] = ACTIONS(7332),
    [anon_sym_GT_EQ] = ACTIONS(7330),
    [anon_sym_CARET] = ACTIONS(7330),
    [anon_sym_PLUS] = ACTIONS(7330),
    [anon_sym_SLASH] = ACTIONS(7330),
    [anon_sym_PERCENT] = ACTIONS(7330),
    [sym_comment] = ACTIONS(87),
  },
  [4114] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(6802),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4119),
    [sym_scope_resolution] = STATE(539),
    [sym_call] = STATE(539),
    [sym_method_call] = STATE(4119),
    [sym_assignment] = STATE(6802),
    [sym_operator_assignment] = STATE(6802),
    [sym_conditional] = STATE(6802),
    [sym_range] = STATE(6802),
    [sym_binary] = STATE(6802),
    [sym_unary] = STATE(6802),
    [sym_left_assignment_list] = STATE(4118),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4119),
    [sym__variable] = STATE(539),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4119),
    [sym_false] = STATE(4119),
    [sym_nil] = STATE(4119),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(542),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6833),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6835),
    [anon_sym_defined_QMARK] = ACTIONS(6837),
    [anon_sym_not] = ACTIONS(6839),
    [anon_sym_BANG] = ACTIONS(6841),
    [anon_sym_TILDE] = ACTIONS(6841),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4115] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(6803),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4119),
    [sym_scope_resolution] = STATE(539),
    [sym_call] = STATE(539),
    [sym_method_call] = STATE(4119),
    [sym_assignment] = STATE(6803),
    [sym_operator_assignment] = STATE(6803),
    [sym_conditional] = STATE(6803),
    [sym_range] = STATE(6803),
    [sym_binary] = STATE(6803),
    [sym_unary] = STATE(6803),
    [sym_left_assignment_list] = STATE(4118),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4119),
    [sym__variable] = STATE(539),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4119),
    [sym_false] = STATE(4119),
    [sym_nil] = STATE(4119),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(542),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6833),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6835),
    [anon_sym_defined_QMARK] = ACTIONS(6837),
    [anon_sym_not] = ACTIONS(6839),
    [anon_sym_BANG] = ACTIONS(6841),
    [anon_sym_TILDE] = ACTIONS(6841),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4116] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(1872),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4119),
    [sym_scope_resolution] = STATE(539),
    [sym_call] = STATE(539),
    [sym_method_call] = STATE(4119),
    [sym_assignment] = STATE(1872),
    [sym_operator_assignment] = STATE(1872),
    [sym_conditional] = STATE(1872),
    [sym_range] = STATE(1872),
    [sym_binary] = STATE(1872),
    [sym_unary] = STATE(1872),
    [sym_left_assignment_list] = STATE(4118),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4119),
    [sym__variable] = STATE(539),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4119),
    [sym_false] = STATE(4119),
    [sym_nil] = STATE(4119),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(542),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6833),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6835),
    [anon_sym_defined_QMARK] = ACTIONS(6837),
    [anon_sym_not] = ACTIONS(6839),
    [anon_sym_BANG] = ACTIONS(6841),
    [anon_sym_TILDE] = ACTIONS(6841),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4117] = {
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(10343),
    [sym__binary_star] = ACTIONS(10345),
    [anon_sym_RBRACE] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(10347),
    [anon_sym_STAR_STAR] = ACTIONS(10345),
    [anon_sym_AMP] = ACTIONS(10349),
    [anon_sym_LT] = ACTIONS(10351),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(10353),
    [anon_sym_DOT_DOT] = ACTIONS(10355),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10357),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(10359),
    [anon_sym_AMP_AMP] = ACTIONS(10359),
    [anon_sym_LT_LT] = ACTIONS(10361),
    [anon_sym_GT_GT] = ACTIONS(10361),
    [anon_sym_EQ_EQ] = ACTIONS(10363),
    [anon_sym_BANG_EQ] = ACTIONS(10359),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10359),
    [anon_sym_LT_EQ_GT] = ACTIONS(10359),
    [anon_sym_EQ_TILDE] = ACTIONS(10359),
    [anon_sym_BANG_TILDE] = ACTIONS(10359),
    [anon_sym_LT_EQ] = ACTIONS(10351),
    [anon_sym_GT] = ACTIONS(10351),
    [anon_sym_GT_EQ] = ACTIONS(10365),
    [anon_sym_CARET] = ACTIONS(10367),
    [anon_sym_PLUS] = ACTIONS(10343),
    [anon_sym_SLASH] = ACTIONS(10345),
    [anon_sym_PERCENT] = ACTIONS(10345),
    [sym_comment] = ACTIONS(87),
  },
  [4118] = {
    [anon_sym_EQ] = ACTIONS(10369),
    [sym_comment] = ACTIONS(87),
  },
  [4119] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(10371),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(10373),
    [anon_sym_DASH_EQ] = ACTIONS(10373),
    [anon_sym_STAR_EQ] = ACTIONS(10373),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10373),
    [anon_sym_SLASH_EQ] = ACTIONS(10373),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10373),
    [anon_sym_PIPE_EQ] = ACTIONS(10373),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10373),
    [anon_sym_AMP_EQ] = ACTIONS(10373),
    [anon_sym_PERCENT_EQ] = ACTIONS(10373),
    [anon_sym_GT_GT_EQ] = ACTIONS(10373),
    [anon_sym_LT_LT_EQ] = ACTIONS(10373),
    [anon_sym_CARET_EQ] = ACTIONS(10373),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [4120] = {
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(10343),
    [sym__binary_star] = ACTIONS(10345),
    [anon_sym_RBRACE] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(10347),
    [anon_sym_STAR_STAR] = ACTIONS(10345),
    [anon_sym_AMP] = ACTIONS(10349),
    [anon_sym_LT] = ACTIONS(10351),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(10353),
    [anon_sym_DOT_DOT] = ACTIONS(10355),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10357),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(10359),
    [anon_sym_AMP_AMP] = ACTIONS(10359),
    [anon_sym_LT_LT] = ACTIONS(10361),
    [anon_sym_GT_GT] = ACTIONS(10361),
    [anon_sym_EQ_EQ] = ACTIONS(10363),
    [anon_sym_BANG_EQ] = ACTIONS(10359),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10359),
    [anon_sym_LT_EQ_GT] = ACTIONS(10359),
    [anon_sym_EQ_TILDE] = ACTIONS(10359),
    [anon_sym_BANG_TILDE] = ACTIONS(10359),
    [anon_sym_LT_EQ] = ACTIONS(10351),
    [anon_sym_GT] = ACTIONS(10351),
    [anon_sym_GT_EQ] = ACTIONS(10365),
    [anon_sym_CARET] = ACTIONS(10367),
    [anon_sym_PLUS] = ACTIONS(10343),
    [anon_sym_SLASH] = ACTIONS(10345),
    [anon_sym_PERCENT] = ACTIONS(10345),
    [sym_comment] = ACTIONS(87),
  },
  [4121] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(6859),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [4122] = {
    [sym_string] = STATE(4160),
    [aux_sym_chained_string_repeat1] = STATE(4160),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [4123] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(6816),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4119),
    [sym_scope_resolution] = STATE(539),
    [sym_call] = STATE(539),
    [sym_method_call] = STATE(4119),
    [sym_assignment] = STATE(6816),
    [sym_operator_assignment] = STATE(6816),
    [sym_conditional] = STATE(6816),
    [sym_range] = STATE(6816),
    [sym_binary] = STATE(6816),
    [sym_unary] = STATE(6816),
    [sym_left_assignment_list] = STATE(4118),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4119),
    [sym__variable] = STATE(539),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4119),
    [sym_false] = STATE(4119),
    [sym_nil] = STATE(4119),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(542),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6833),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6835),
    [anon_sym_defined_QMARK] = ACTIONS(6837),
    [anon_sym_not] = ACTIONS(6839),
    [anon_sym_BANG] = ACTIONS(6841),
    [anon_sym_TILDE] = ACTIONS(6841),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4124] = {
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(10343),
    [sym__binary_star] = ACTIONS(10345),
    [anon_sym_RBRACE] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(10347),
    [anon_sym_STAR_STAR] = ACTIONS(10345),
    [anon_sym_AMP] = ACTIONS(10349),
    [anon_sym_LT] = ACTIONS(10351),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(10353),
    [anon_sym_DOT_DOT] = ACTIONS(10355),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10357),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(10359),
    [anon_sym_AMP_AMP] = ACTIONS(10359),
    [anon_sym_LT_LT] = ACTIONS(10361),
    [anon_sym_GT_GT] = ACTIONS(10361),
    [anon_sym_EQ_EQ] = ACTIONS(10363),
    [anon_sym_BANG_EQ] = ACTIONS(10359),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10359),
    [anon_sym_LT_EQ_GT] = ACTIONS(10359),
    [anon_sym_EQ_TILDE] = ACTIONS(10359),
    [anon_sym_BANG_TILDE] = ACTIONS(10359),
    [anon_sym_LT_EQ] = ACTIONS(10351),
    [anon_sym_GT] = ACTIONS(10351),
    [anon_sym_GT_EQ] = ACTIONS(10365),
    [anon_sym_CARET] = ACTIONS(10367),
    [anon_sym_PLUS] = ACTIONS(10343),
    [anon_sym_SLASH] = ACTIONS(10345),
    [anon_sym_PERCENT] = ACTIONS(10345),
    [sym_comment] = ACTIONS(87),
  },
  [4125] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(6817),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1814),
    [sym_scope_resolution] = STATE(1810),
    [sym_call] = STATE(1810),
    [sym_method_call] = STATE(1814),
    [sym_assignment] = STATE(6817),
    [sym_operator_assignment] = STATE(6817),
    [sym_conditional] = STATE(6817),
    [sym_range] = STATE(6817),
    [sym_binary] = STATE(6817),
    [sym_unary] = STATE(6817),
    [sym_left_assignment_list] = STATE(1813),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1814),
    [sym__variable] = STATE(1810),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1814),
    [sym_false] = STATE(1814),
    [sym_nil] = STATE(1814),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4122),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_break] = ACTIONS(3263),
    [anon_sym_next] = ACTIONS(3265),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6843),
    [anon_sym_defined_QMARK] = ACTIONS(3267),
    [anon_sym_not] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3273),
    [anon_sym_TILDE] = ACTIONS(3273),
    [sym_constant] = ACTIONS(3279),
    [sym_identifier] = ACTIONS(3279),
    [sym_instance_variable] = ACTIONS(3277),
    [sym_class_variable] = ACTIONS(3277),
    [sym_global_variable] = ACTIONS(3277),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3279),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3279),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4126] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(6818),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1814),
    [sym_scope_resolution] = STATE(1810),
    [sym_call] = STATE(1810),
    [sym_method_call] = STATE(1814),
    [sym_assignment] = STATE(6818),
    [sym_operator_assignment] = STATE(6818),
    [sym_conditional] = STATE(6818),
    [sym_range] = STATE(6818),
    [sym_binary] = STATE(6818),
    [sym_unary] = STATE(6818),
    [sym_left_assignment_list] = STATE(1813),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1814),
    [sym__variable] = STATE(1810),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1814),
    [sym_false] = STATE(1814),
    [sym_nil] = STATE(1814),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4122),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_break] = ACTIONS(3263),
    [anon_sym_next] = ACTIONS(3265),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6843),
    [anon_sym_defined_QMARK] = ACTIONS(3267),
    [anon_sym_not] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3273),
    [anon_sym_TILDE] = ACTIONS(3273),
    [sym_constant] = ACTIONS(3279),
    [sym_identifier] = ACTIONS(3279),
    [sym_instance_variable] = ACTIONS(3277),
    [sym_class_variable] = ACTIONS(3277),
    [sym_global_variable] = ACTIONS(3277),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3279),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3279),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4127] = {
    [anon_sym_COLON] = ACTIONS(10375),
    [sym_comment] = ACTIONS(87),
  },
  [4128] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(6820),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1814),
    [sym_scope_resolution] = STATE(1810),
    [sym_call] = STATE(1810),
    [sym_method_call] = STATE(1814),
    [sym_assignment] = STATE(6820),
    [sym_operator_assignment] = STATE(6820),
    [sym_conditional] = STATE(6820),
    [sym_range] = STATE(6820),
    [sym_binary] = STATE(6820),
    [sym_unary] = STATE(6820),
    [sym_left_assignment_list] = STATE(1813),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1814),
    [sym__variable] = STATE(1810),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1814),
    [sym_false] = STATE(1814),
    [sym_nil] = STATE(1814),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4122),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_break] = ACTIONS(3263),
    [anon_sym_next] = ACTIONS(3265),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6843),
    [anon_sym_defined_QMARK] = ACTIONS(3267),
    [anon_sym_not] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3273),
    [anon_sym_TILDE] = ACTIONS(3273),
    [sym_constant] = ACTIONS(3279),
    [sym_identifier] = ACTIONS(3279),
    [sym_instance_variable] = ACTIONS(3277),
    [sym_class_variable] = ACTIONS(3277),
    [sym_global_variable] = ACTIONS(3277),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3279),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3279),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4129] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(10377),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [4130] = {
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(6857),
    [sym__binary_star] = ACTIONS(6859),
    [anon_sym_RBRACE] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(6861),
    [anon_sym_STAR_STAR] = ACTIONS(6859),
    [anon_sym_AMP] = ACTIONS(6863),
    [anon_sym_LT] = ACTIONS(6865),
    [anon_sym_EQ_GT] = ACTIONS(1625),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(6867),
    [anon_sym_DOT_DOT] = ACTIONS(6869),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6871),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(6873),
    [anon_sym_AMP_AMP] = ACTIONS(6873),
    [anon_sym_LT_LT] = ACTIONS(6875),
    [anon_sym_GT_GT] = ACTIONS(6875),
    [anon_sym_EQ_EQ] = ACTIONS(6877),
    [anon_sym_BANG_EQ] = ACTIONS(6873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6873),
    [anon_sym_LT_EQ_GT] = ACTIONS(6873),
    [anon_sym_EQ_TILDE] = ACTIONS(6873),
    [anon_sym_BANG_TILDE] = ACTIONS(6873),
    [anon_sym_LT_EQ] = ACTIONS(6865),
    [anon_sym_GT] = ACTIONS(6865),
    [anon_sym_GT_EQ] = ACTIONS(6879),
    [anon_sym_CARET] = ACTIONS(6881),
    [anon_sym_PLUS] = ACTIONS(6857),
    [anon_sym_SLASH] = ACTIONS(6859),
    [anon_sym_PERCENT] = ACTIONS(6859),
    [sym_comment] = ACTIONS(87),
  },
  [4131] = {
    [sym_heredoc_body] = STATE(6822),
    [aux_sym_call_repeat1] = STATE(6822),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_RBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [4132] = {
    [sym_heredoc_body] = STATE(6822),
    [aux_sym_call_repeat1] = STATE(6822),
    [aux_sym_argument_list_repeat1] = STATE(6824),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_RBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(10379),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [4133] = {
    [sym_string] = STATE(4160),
    [aux_sym_chained_string_repeat1] = STATE(4160),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(10381),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [4134] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(6857),
    [sym__binary_star] = ACTIONS(6859),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(6861),
    [anon_sym_STAR_STAR] = ACTIONS(6859),
    [anon_sym_AMP] = ACTIONS(6863),
    [anon_sym_LT] = ACTIONS(6865),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(6867),
    [anon_sym_DOT_DOT] = ACTIONS(6869),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6871),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(6873),
    [anon_sym_AMP_AMP] = ACTIONS(6873),
    [anon_sym_LT_LT] = ACTIONS(6875),
    [anon_sym_GT_GT] = ACTIONS(6875),
    [anon_sym_EQ_EQ] = ACTIONS(6877),
    [anon_sym_BANG_EQ] = ACTIONS(6873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6873),
    [anon_sym_LT_EQ_GT] = ACTIONS(6873),
    [anon_sym_EQ_TILDE] = ACTIONS(6873),
    [anon_sym_BANG_TILDE] = ACTIONS(6873),
    [anon_sym_LT_EQ] = ACTIONS(6865),
    [anon_sym_GT] = ACTIONS(6865),
    [anon_sym_GT_EQ] = ACTIONS(6879),
    [anon_sym_CARET] = ACTIONS(6881),
    [anon_sym_PLUS] = ACTIONS(6857),
    [anon_sym_SLASH] = ACTIONS(6859),
    [anon_sym_PERCENT] = ACTIONS(6859),
    [sym_comment] = ACTIONS(87),
  },
  [4135] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(6825),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4119),
    [sym_scope_resolution] = STATE(539),
    [sym_call] = STATE(539),
    [sym_method_call] = STATE(4119),
    [sym_assignment] = STATE(6825),
    [sym_operator_assignment] = STATE(6825),
    [sym_conditional] = STATE(6825),
    [sym_range] = STATE(6825),
    [sym_binary] = STATE(6825),
    [sym_unary] = STATE(6825),
    [sym_left_assignment_list] = STATE(4118),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4119),
    [sym__variable] = STATE(539),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4119),
    [sym_false] = STATE(4119),
    [sym_nil] = STATE(4119),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(542),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6833),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6835),
    [anon_sym_defined_QMARK] = ACTIONS(6837),
    [anon_sym_not] = ACTIONS(6839),
    [anon_sym_BANG] = ACTIONS(6841),
    [anon_sym_TILDE] = ACTIONS(6841),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4136] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(6826),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1814),
    [sym_scope_resolution] = STATE(1810),
    [sym_call] = STATE(1810),
    [sym_method_call] = STATE(1814),
    [sym_assignment] = STATE(6826),
    [sym_operator_assignment] = STATE(6826),
    [sym_conditional] = STATE(6826),
    [sym_range] = STATE(6826),
    [sym_binary] = STATE(6826),
    [sym_unary] = STATE(6826),
    [sym_left_assignment_list] = STATE(1813),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1814),
    [sym__variable] = STATE(1810),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1814),
    [sym_false] = STATE(1814),
    [sym_nil] = STATE(1814),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4122),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_break] = ACTIONS(3263),
    [anon_sym_next] = ACTIONS(3265),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6843),
    [anon_sym_defined_QMARK] = ACTIONS(3267),
    [anon_sym_not] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3273),
    [anon_sym_TILDE] = ACTIONS(3273),
    [sym_constant] = ACTIONS(3279),
    [sym_identifier] = ACTIONS(3279),
    [sym_instance_variable] = ACTIONS(3277),
    [sym_class_variable] = ACTIONS(3277),
    [sym_global_variable] = ACTIONS(3277),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3279),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3279),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4137] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(6827),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1814),
    [sym_scope_resolution] = STATE(1810),
    [sym_call] = STATE(1810),
    [sym_method_call] = STATE(1814),
    [sym_assignment] = STATE(6827),
    [sym_operator_assignment] = STATE(6827),
    [sym_conditional] = STATE(6827),
    [sym_range] = STATE(6827),
    [sym_binary] = STATE(6827),
    [sym_unary] = STATE(6827),
    [sym_left_assignment_list] = STATE(1813),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1814),
    [sym__variable] = STATE(1810),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1814),
    [sym_false] = STATE(1814),
    [sym_nil] = STATE(1814),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4122),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_break] = ACTIONS(3263),
    [anon_sym_next] = ACTIONS(3265),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6843),
    [anon_sym_defined_QMARK] = ACTIONS(3267),
    [anon_sym_not] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3273),
    [anon_sym_TILDE] = ACTIONS(3273),
    [sym_constant] = ACTIONS(3279),
    [sym_identifier] = ACTIONS(3279),
    [sym_instance_variable] = ACTIONS(3277),
    [sym_class_variable] = ACTIONS(3277),
    [sym_global_variable] = ACTIONS(3277),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3279),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3279),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4138] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(6828),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1814),
    [sym_scope_resolution] = STATE(1810),
    [sym_call] = STATE(1810),
    [sym_method_call] = STATE(1814),
    [sym_assignment] = STATE(6828),
    [sym_operator_assignment] = STATE(6828),
    [sym_conditional] = STATE(6828),
    [sym_range] = STATE(6828),
    [sym_binary] = STATE(6828),
    [sym_unary] = STATE(6828),
    [sym_left_assignment_list] = STATE(1813),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1814),
    [sym__variable] = STATE(1810),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1814),
    [sym_false] = STATE(1814),
    [sym_nil] = STATE(1814),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4122),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_break] = ACTIONS(3263),
    [anon_sym_next] = ACTIONS(3265),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6843),
    [anon_sym_defined_QMARK] = ACTIONS(3267),
    [anon_sym_not] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3273),
    [anon_sym_TILDE] = ACTIONS(3273),
    [sym_constant] = ACTIONS(3279),
    [sym_identifier] = ACTIONS(3279),
    [sym_instance_variable] = ACTIONS(3277),
    [sym_class_variable] = ACTIONS(3277),
    [sym_global_variable] = ACTIONS(3277),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3279),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3279),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4139] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(6829),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1814),
    [sym_scope_resolution] = STATE(1810),
    [sym_call] = STATE(1810),
    [sym_method_call] = STATE(1814),
    [sym_assignment] = STATE(6829),
    [sym_operator_assignment] = STATE(6829),
    [sym_conditional] = STATE(6829),
    [sym_range] = STATE(6829),
    [sym_binary] = STATE(6829),
    [sym_unary] = STATE(6829),
    [sym_left_assignment_list] = STATE(1813),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1814),
    [sym__variable] = STATE(1810),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1814),
    [sym_false] = STATE(1814),
    [sym_nil] = STATE(1814),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4122),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_break] = ACTIONS(3263),
    [anon_sym_next] = ACTIONS(3265),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6843),
    [anon_sym_defined_QMARK] = ACTIONS(3267),
    [anon_sym_not] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3273),
    [anon_sym_TILDE] = ACTIONS(3273),
    [sym_constant] = ACTIONS(3279),
    [sym_identifier] = ACTIONS(3279),
    [sym_instance_variable] = ACTIONS(3277),
    [sym_class_variable] = ACTIONS(3277),
    [sym_global_variable] = ACTIONS(3277),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3279),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3279),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4140] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(6830),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1814),
    [sym_scope_resolution] = STATE(1810),
    [sym_call] = STATE(1810),
    [sym_method_call] = STATE(1814),
    [sym_assignment] = STATE(6830),
    [sym_operator_assignment] = STATE(6830),
    [sym_conditional] = STATE(6830),
    [sym_range] = STATE(6830),
    [sym_binary] = STATE(6830),
    [sym_unary] = STATE(6830),
    [sym_left_assignment_list] = STATE(1813),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1814),
    [sym__variable] = STATE(1810),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1814),
    [sym_false] = STATE(1814),
    [sym_nil] = STATE(1814),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4122),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_break] = ACTIONS(3263),
    [anon_sym_next] = ACTIONS(3265),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6843),
    [anon_sym_defined_QMARK] = ACTIONS(3267),
    [anon_sym_not] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3273),
    [anon_sym_TILDE] = ACTIONS(3273),
    [sym_constant] = ACTIONS(3279),
    [sym_identifier] = ACTIONS(3279),
    [sym_instance_variable] = ACTIONS(3277),
    [sym_class_variable] = ACTIONS(3277),
    [sym_global_variable] = ACTIONS(3277),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3279),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3279),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4141] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(6831),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(6831),
    [sym_operator_assignment] = STATE(6831),
    [sym_conditional] = STATE(6831),
    [sym_range] = STATE(6831),
    [sym_binary] = STATE(6831),
    [sym_unary] = STATE(6831),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4142] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(6832),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1814),
    [sym_scope_resolution] = STATE(1810),
    [sym_call] = STATE(1810),
    [sym_method_call] = STATE(1814),
    [sym_assignment] = STATE(6832),
    [sym_operator_assignment] = STATE(6832),
    [sym_conditional] = STATE(6832),
    [sym_range] = STATE(6832),
    [sym_binary] = STATE(6832),
    [sym_unary] = STATE(6832),
    [sym_left_assignment_list] = STATE(1813),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1814),
    [sym__variable] = STATE(1810),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1814),
    [sym_false] = STATE(1814),
    [sym_nil] = STATE(1814),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4122),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_break] = ACTIONS(3263),
    [anon_sym_next] = ACTIONS(3265),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6843),
    [anon_sym_defined_QMARK] = ACTIONS(3267),
    [anon_sym_not] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3273),
    [anon_sym_TILDE] = ACTIONS(3273),
    [sym_constant] = ACTIONS(3279),
    [sym_identifier] = ACTIONS(3279),
    [sym_instance_variable] = ACTIONS(3277),
    [sym_class_variable] = ACTIONS(3277),
    [sym_global_variable] = ACTIONS(3277),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3279),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3279),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4143] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(6833),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1814),
    [sym_scope_resolution] = STATE(1810),
    [sym_call] = STATE(1810),
    [sym_method_call] = STATE(1814),
    [sym_assignment] = STATE(6833),
    [sym_operator_assignment] = STATE(6833),
    [sym_conditional] = STATE(6833),
    [sym_range] = STATE(6833),
    [sym_binary] = STATE(6833),
    [sym_unary] = STATE(6833),
    [sym_left_assignment_list] = STATE(1813),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1814),
    [sym__variable] = STATE(1810),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1814),
    [sym_false] = STATE(1814),
    [sym_nil] = STATE(1814),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4122),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_break] = ACTIONS(3263),
    [anon_sym_next] = ACTIONS(3265),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6843),
    [anon_sym_defined_QMARK] = ACTIONS(3267),
    [anon_sym_not] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3273),
    [anon_sym_TILDE] = ACTIONS(3273),
    [sym_constant] = ACTIONS(3279),
    [sym_identifier] = ACTIONS(3279),
    [sym_instance_variable] = ACTIONS(3277),
    [sym_class_variable] = ACTIONS(3277),
    [sym_global_variable] = ACTIONS(3277),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3279),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3279),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4144] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(6834),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1814),
    [sym_scope_resolution] = STATE(1810),
    [sym_call] = STATE(1810),
    [sym_method_call] = STATE(1814),
    [sym_assignment] = STATE(6834),
    [sym_operator_assignment] = STATE(6834),
    [sym_conditional] = STATE(6834),
    [sym_range] = STATE(6834),
    [sym_binary] = STATE(6834),
    [sym_unary] = STATE(6834),
    [sym_left_assignment_list] = STATE(1813),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1814),
    [sym__variable] = STATE(1810),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1814),
    [sym_false] = STATE(1814),
    [sym_nil] = STATE(1814),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4122),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_break] = ACTIONS(3263),
    [anon_sym_next] = ACTIONS(3265),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6843),
    [anon_sym_defined_QMARK] = ACTIONS(3267),
    [anon_sym_not] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3273),
    [anon_sym_TILDE] = ACTIONS(3273),
    [sym_constant] = ACTIONS(3279),
    [sym_identifier] = ACTIONS(3279),
    [sym_instance_variable] = ACTIONS(3277),
    [sym_class_variable] = ACTIONS(3277),
    [sym_global_variable] = ACTIONS(3277),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3279),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3279),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4145] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(6835),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1814),
    [sym_scope_resolution] = STATE(1810),
    [sym_call] = STATE(1810),
    [sym_method_call] = STATE(1814),
    [sym_assignment] = STATE(6835),
    [sym_operator_assignment] = STATE(6835),
    [sym_conditional] = STATE(6835),
    [sym_range] = STATE(6835),
    [sym_binary] = STATE(6835),
    [sym_unary] = STATE(6835),
    [sym_left_assignment_list] = STATE(1813),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1814),
    [sym__variable] = STATE(1810),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1814),
    [sym_false] = STATE(1814),
    [sym_nil] = STATE(1814),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4122),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_break] = ACTIONS(3263),
    [anon_sym_next] = ACTIONS(3265),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6843),
    [anon_sym_defined_QMARK] = ACTIONS(3267),
    [anon_sym_not] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3273),
    [anon_sym_TILDE] = ACTIONS(3273),
    [sym_constant] = ACTIONS(3279),
    [sym_identifier] = ACTIONS(3279),
    [sym_instance_variable] = ACTIONS(3277),
    [sym_class_variable] = ACTIONS(3277),
    [sym_global_variable] = ACTIONS(3277),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3279),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3279),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4146] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6836),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1851),
    [sym_scope_resolution] = STATE(1845),
    [sym_call] = STATE(1845),
    [sym_method_call] = STATE(1851),
    [sym_assignment] = STATE(6836),
    [sym_operator_assignment] = STATE(6836),
    [sym_conditional] = STATE(6836),
    [sym_range] = STATE(6836),
    [sym_binary] = STATE(6836),
    [sym_unary] = STATE(6836),
    [sym_left_assignment_list] = STATE(1850),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1851),
    [sym__variable] = STATE(1845),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1851),
    [sym_false] = STATE(1851),
    [sym_nil] = STATE(1851),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4193),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3323),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3329),
    [anon_sym_yield] = ACTIONS(3331),
    [anon_sym_break] = ACTIONS(3333),
    [anon_sym_next] = ACTIONS(3335),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6935),
    [anon_sym_defined_QMARK] = ACTIONS(3339),
    [anon_sym_not] = ACTIONS(3341),
    [anon_sym_BANG] = ACTIONS(3345),
    [anon_sym_TILDE] = ACTIONS(3345),
    [sym_constant] = ACTIONS(3351),
    [sym_identifier] = ACTIONS(3351),
    [sym_instance_variable] = ACTIONS(3349),
    [sym_class_variable] = ACTIONS(3349),
    [sym_global_variable] = ACTIONS(3349),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3351),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3351),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4147] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6837),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1851),
    [sym_scope_resolution] = STATE(1845),
    [sym_call] = STATE(1845),
    [sym_method_call] = STATE(1851),
    [sym_assignment] = STATE(6837),
    [sym_operator_assignment] = STATE(6837),
    [sym_conditional] = STATE(6837),
    [sym_range] = STATE(6837),
    [sym_binary] = STATE(6837),
    [sym_unary] = STATE(6837),
    [sym_left_assignment_list] = STATE(1850),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1851),
    [sym__variable] = STATE(1845),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1851),
    [sym_false] = STATE(1851),
    [sym_nil] = STATE(1851),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4193),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3323),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3329),
    [anon_sym_yield] = ACTIONS(3331),
    [anon_sym_break] = ACTIONS(3333),
    [anon_sym_next] = ACTIONS(3335),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6935),
    [anon_sym_defined_QMARK] = ACTIONS(3339),
    [anon_sym_not] = ACTIONS(3341),
    [anon_sym_BANG] = ACTIONS(3345),
    [anon_sym_TILDE] = ACTIONS(3345),
    [sym_constant] = ACTIONS(3351),
    [sym_identifier] = ACTIONS(3351),
    [sym_instance_variable] = ACTIONS(3349),
    [sym_class_variable] = ACTIONS(3349),
    [sym_global_variable] = ACTIONS(3349),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3351),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3351),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4148] = {
    [anon_sym_COLON] = ACTIONS(10383),
    [sym_comment] = ACTIONS(87),
  },
  [4149] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6839),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1851),
    [sym_scope_resolution] = STATE(1845),
    [sym_call] = STATE(1845),
    [sym_method_call] = STATE(1851),
    [sym_assignment] = STATE(6839),
    [sym_operator_assignment] = STATE(6839),
    [sym_conditional] = STATE(6839),
    [sym_range] = STATE(6839),
    [sym_binary] = STATE(6839),
    [sym_unary] = STATE(6839),
    [sym_left_assignment_list] = STATE(1850),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1851),
    [sym__variable] = STATE(1845),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1851),
    [sym_false] = STATE(1851),
    [sym_nil] = STATE(1851),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4193),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3323),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3329),
    [anon_sym_yield] = ACTIONS(3331),
    [anon_sym_break] = ACTIONS(3333),
    [anon_sym_next] = ACTIONS(3335),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6935),
    [anon_sym_defined_QMARK] = ACTIONS(3339),
    [anon_sym_not] = ACTIONS(3341),
    [anon_sym_BANG] = ACTIONS(3345),
    [anon_sym_TILDE] = ACTIONS(3345),
    [sym_constant] = ACTIONS(3351),
    [sym_identifier] = ACTIONS(3351),
    [sym_instance_variable] = ACTIONS(3349),
    [sym_class_variable] = ACTIONS(3349),
    [sym_global_variable] = ACTIONS(3349),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3351),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3351),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4150] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(10385),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [4151] = {
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(6947),
    [sym__binary_star] = ACTIONS(6949),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_RBRACE] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(6951),
    [anon_sym_STAR_STAR] = ACTIONS(6953),
    [anon_sym_AMP] = ACTIONS(6955),
    [anon_sym_EQ] = ACTIONS(1631),
    [anon_sym_LT] = ACTIONS(6957),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(1625),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_PLUS_EQ] = ACTIONS(1625),
    [anon_sym_DASH_EQ] = ACTIONS(1625),
    [anon_sym_STAR_EQ] = ACTIONS(1625),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1625),
    [anon_sym_SLASH_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1625),
    [anon_sym_AMP_EQ] = ACTIONS(1625),
    [anon_sym_PERCENT_EQ] = ACTIONS(1625),
    [anon_sym_GT_GT_EQ] = ACTIONS(1625),
    [anon_sym_LT_LT_EQ] = ACTIONS(1625),
    [anon_sym_CARET_EQ] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(6959),
    [anon_sym_DOT_DOT] = ACTIONS(6961),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6963),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(6965),
    [anon_sym_AMP_AMP] = ACTIONS(6965),
    [anon_sym_LT_LT] = ACTIONS(6967),
    [anon_sym_GT_GT] = ACTIONS(6967),
    [anon_sym_EQ_EQ] = ACTIONS(6965),
    [anon_sym_BANG_EQ] = ACTIONS(6969),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6969),
    [anon_sym_LT_EQ_GT] = ACTIONS(6969),
    [anon_sym_EQ_TILDE] = ACTIONS(6969),
    [anon_sym_BANG_TILDE] = ACTIONS(6969),
    [anon_sym_LT_EQ] = ACTIONS(6957),
    [anon_sym_GT] = ACTIONS(6957),
    [anon_sym_GT_EQ] = ACTIONS(6971),
    [anon_sym_CARET] = ACTIONS(6951),
    [anon_sym_PLUS] = ACTIONS(6973),
    [anon_sym_SLASH] = ACTIONS(6953),
    [anon_sym_PERCENT] = ACTIONS(6953),
    [sym_comment] = ACTIONS(87),
  },
  [4152] = {
    [sym_heredoc_body] = STATE(6841),
    [aux_sym_call_repeat1] = STATE(6841),
    [sym__heredoc_body_start] = ACTIONS(3543),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_RBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [4153] = {
    [sym_heredoc_body] = STATE(6841),
    [aux_sym_call_repeat1] = STATE(6841),
    [aux_sym_argument_list_repeat1] = STATE(6843),
    [sym__heredoc_body_start] = ACTIONS(3543),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_RBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(10387),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [4154] = {
    [sym_string] = STATE(4222),
    [aux_sym_chained_string_repeat1] = STATE(4222),
    [sym__string_start] = ACTIONS(1141),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(10389),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [4155] = {
    [sym_heredoc_body] = STATE(6844),
    [aux_sym_call_repeat1] = STATE(6844),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_RBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [4156] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(1809),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1814),
    [sym_scope_resolution] = STATE(1810),
    [sym_call] = STATE(1810),
    [sym_method_call] = STATE(1814),
    [sym__argument] = STATE(4250),
    [sym_splat_argument] = STATE(4250),
    [sym_hash_splat_argument] = STATE(4250),
    [sym_block_argument] = STATE(4250),
    [sym_assignment] = STATE(1809),
    [sym_operator_assignment] = STATE(1809),
    [sym_conditional] = STATE(1809),
    [sym_range] = STATE(1809),
    [sym_binary] = STATE(1809),
    [sym_unary] = STATE(1809),
    [sym_left_assignment_list] = STATE(1813),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1814),
    [sym__variable] = STATE(1810),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1814),
    [sym_false] = STATE(1814),
    [sym_nil] = STATE(1814),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1815),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_heredoc_body] = STATE(6845),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(4250),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(3251),
    [sym__splat_star] = ACTIONS(3253),
    [sym__unary_minus] = ACTIONS(3255),
    [sym__identifier_hash_key] = ACTIONS(3257),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10391),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_break] = ACTIONS(3263),
    [anon_sym_next] = ACTIONS(3265),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6843),
    [anon_sym_defined_QMARK] = ACTIONS(3267),
    [anon_sym_not] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3273),
    [anon_sym_TILDE] = ACTIONS(3273),
    [sym_constant] = ACTIONS(3275),
    [sym_identifier] = ACTIONS(3275),
    [sym_instance_variable] = ACTIONS(3277),
    [sym_class_variable] = ACTIONS(3277),
    [sym_global_variable] = ACTIONS(3277),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3279),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3279),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4157] = {
    [sym_heredoc_body] = STATE(6846),
    [aux_sym_call_repeat1] = STATE(6846),
    [aux_sym_argument_list_repeat1] = STATE(6847),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_RBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(6891),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [4158] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(6848),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1814),
    [sym_scope_resolution] = STATE(1810),
    [sym_call] = STATE(1810),
    [sym_method_call] = STATE(1814),
    [sym_splat_argument] = STATE(6849),
    [sym_assignment] = STATE(6848),
    [sym_operator_assignment] = STATE(6848),
    [sym_conditional] = STATE(6848),
    [sym_range] = STATE(6848),
    [sym_binary] = STATE(6848),
    [sym_unary] = STATE(6848),
    [sym_right_assignment_list] = STATE(4255),
    [sym__arg_or_splat_arg] = STATE(6849),
    [sym_left_assignment_list] = STATE(1813),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1814),
    [sym__variable] = STATE(1810),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1814),
    [sym_false] = STATE(1814),
    [sym_nil] = STATE(1814),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4122),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(6849),
    [sym__unary_minus] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_break] = ACTIONS(3263),
    [anon_sym_next] = ACTIONS(3265),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6843),
    [anon_sym_defined_QMARK] = ACTIONS(3267),
    [anon_sym_not] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3273),
    [anon_sym_TILDE] = ACTIONS(3273),
    [sym_constant] = ACTIONS(3279),
    [sym_identifier] = ACTIONS(3279),
    [sym_instance_variable] = ACTIONS(3277),
    [sym_class_variable] = ACTIONS(3277),
    [sym_global_variable] = ACTIONS(3277),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3279),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3279),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4159] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(6850),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1814),
    [sym_scope_resolution] = STATE(1810),
    [sym_call] = STATE(1810),
    [sym_method_call] = STATE(1814),
    [sym_assignment] = STATE(6850),
    [sym_operator_assignment] = STATE(6850),
    [sym_conditional] = STATE(6850),
    [sym_range] = STATE(6850),
    [sym_binary] = STATE(6850),
    [sym_unary] = STATE(6850),
    [sym_left_assignment_list] = STATE(1813),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1814),
    [sym__variable] = STATE(1810),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1814),
    [sym_false] = STATE(1814),
    [sym_nil] = STATE(1814),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4122),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_break] = ACTIONS(3263),
    [anon_sym_next] = ACTIONS(3265),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6843),
    [anon_sym_defined_QMARK] = ACTIONS(3267),
    [anon_sym_not] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3273),
    [anon_sym_TILDE] = ACTIONS(3273),
    [sym_constant] = ACTIONS(3279),
    [sym_identifier] = ACTIONS(3279),
    [sym_instance_variable] = ACTIONS(3277),
    [sym_class_variable] = ACTIONS(3277),
    [sym_global_variable] = ACTIONS(3277),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3279),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3279),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4160] = {
    [sym_string] = STATE(6851),
    [aux_sym_chained_string_repeat1] = STATE(6851),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_RBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_EQ_GT] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [4161] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(3285),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(3285),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [sym_comment] = ACTIONS(87),
  },
  [4162] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(3285),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [4163] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(3283),
    [sym__binary_star] = ACTIONS(3285),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(3285),
    [anon_sym_AMP] = ACTIONS(3289),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(3303),
    [anon_sym_GT_GT] = ACTIONS(3303),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_SLASH] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [sym_comment] = ACTIONS(87),
  },
  [4164] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(3283),
    [sym__binary_star] = ACTIONS(3285),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(3285),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(3303),
    [anon_sym_GT_GT] = ACTIONS(3303),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_SLASH] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [sym_comment] = ACTIONS(87),
  },
  [4165] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(3283),
    [sym__binary_star] = ACTIONS(3285),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(3287),
    [anon_sym_STAR_STAR] = ACTIONS(3285),
    [anon_sym_AMP] = ACTIONS(3289),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(3303),
    [anon_sym_GT_GT] = ACTIONS(3303),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(3309),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_SLASH] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [sym_comment] = ACTIONS(87),
  },
  [4166] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(10393),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [4167] = {
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(3283),
    [sym__binary_star] = ACTIONS(3285),
    [anon_sym_RBRACE] = ACTIONS(5927),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(3287),
    [anon_sym_STAR_STAR] = ACTIONS(3285),
    [anon_sym_AMP] = ACTIONS(3289),
    [anon_sym_LT] = ACTIONS(3291),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(3295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3297),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3301),
    [anon_sym_AMP_AMP] = ACTIONS(3301),
    [anon_sym_LT_LT] = ACTIONS(3303),
    [anon_sym_GT_GT] = ACTIONS(3303),
    [anon_sym_EQ_EQ] = ACTIONS(3305),
    [anon_sym_BANG_EQ] = ACTIONS(3301),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3301),
    [anon_sym_LT_EQ_GT] = ACTIONS(3301),
    [anon_sym_EQ_TILDE] = ACTIONS(3301),
    [anon_sym_BANG_TILDE] = ACTIONS(3301),
    [anon_sym_LT_EQ] = ACTIONS(3291),
    [anon_sym_GT] = ACTIONS(3291),
    [anon_sym_GT_EQ] = ACTIONS(3307),
    [anon_sym_CARET] = ACTIONS(3309),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_SLASH] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [sym_comment] = ACTIONS(87),
  },
  [4168] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(3283),
    [sym__binary_star] = ACTIONS(3285),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(3287),
    [anon_sym_STAR_STAR] = ACTIONS(3285),
    [anon_sym_AMP] = ACTIONS(3289),
    [anon_sym_LT] = ACTIONS(3291),
    [anon_sym_QMARK] = ACTIONS(3293),
    [anon_sym_DOT_DOT] = ACTIONS(3295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3297),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(3301),
    [anon_sym_AMP_AMP] = ACTIONS(3301),
    [anon_sym_LT_LT] = ACTIONS(3303),
    [anon_sym_GT_GT] = ACTIONS(3303),
    [anon_sym_EQ_EQ] = ACTIONS(3305),
    [anon_sym_BANG_EQ] = ACTIONS(3301),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3301),
    [anon_sym_LT_EQ_GT] = ACTIONS(3301),
    [anon_sym_EQ_TILDE] = ACTIONS(3301),
    [anon_sym_BANG_TILDE] = ACTIONS(3301),
    [anon_sym_LT_EQ] = ACTIONS(3291),
    [anon_sym_GT] = ACTIONS(3291),
    [anon_sym_GT_EQ] = ACTIONS(3307),
    [anon_sym_CARET] = ACTIONS(3309),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_SLASH] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [sym_comment] = ACTIONS(87),
  },
  [4169] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(3283),
    [sym__binary_star] = ACTIONS(3285),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(3287),
    [anon_sym_STAR_STAR] = ACTIONS(3285),
    [anon_sym_AMP] = ACTIONS(3289),
    [anon_sym_LT] = ACTIONS(3291),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(3303),
    [anon_sym_GT_GT] = ACTIONS(3303),
    [anon_sym_EQ_EQ] = ACTIONS(3305),
    [anon_sym_BANG_EQ] = ACTIONS(3301),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3301),
    [anon_sym_LT_EQ_GT] = ACTIONS(3301),
    [anon_sym_EQ_TILDE] = ACTIONS(3301),
    [anon_sym_BANG_TILDE] = ACTIONS(3301),
    [anon_sym_LT_EQ] = ACTIONS(3291),
    [anon_sym_GT] = ACTIONS(3291),
    [anon_sym_GT_EQ] = ACTIONS(3307),
    [anon_sym_CARET] = ACTIONS(3309),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_SLASH] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [sym_comment] = ACTIONS(87),
  },
  [4170] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(3283),
    [sym__binary_star] = ACTIONS(3285),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(3285),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_SLASH] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [sym_comment] = ACTIONS(87),
  },
  [4171] = {
    [sym__simple_symbol] = ACTIONS(1263),
    [sym__string_start] = ACTIONS(1263),
    [sym__symbol_start] = ACTIONS(1263),
    [sym__subshell_start] = ACTIONS(1263),
    [sym__regex_start] = ACTIONS(1263),
    [sym__string_array_start] = ACTIONS(1263),
    [sym__symbol_array_start] = ACTIONS(1263),
    [sym__heredoc_body_start] = ACTIONS(1263),
    [sym_heredoc_beginning] = ACTIONS(1263),
    [sym__block_ampersand] = ACTIONS(1263),
    [sym__splat_star] = ACTIONS(1263),
    [sym__unary_minus] = ACTIONS(1263),
    [sym__binary_minus] = ACTIONS(1263),
    [sym__binary_star] = ACTIONS(1263),
    [sym__identifier_hash_key] = ACTIONS(1263),
    [anon_sym_LBRACE] = ACTIONS(1263),
    [anon_sym_RBRACE] = ACTIONS(1263),
    [anon_sym_def] = ACTIONS(1265),
    [anon_sym_LPAREN] = ACTIONS(1265),
    [anon_sym_RPAREN] = ACTIONS(1263),
    [anon_sym_DOT] = ACTIONS(1265),
    [anon_sym_COLON_COLON] = ACTIONS(1265),
    [anon_sym_COMMA] = ACTIONS(1263),
    [anon_sym_PIPE] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_STAR_STAR] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1265),
    [anon_sym_EQ] = ACTIONS(1265),
    [anon_sym_class] = ACTIONS(1265),
    [anon_sym_LT] = ACTIONS(1265),
    [anon_sym_module] = ACTIONS(1265),
    [anon_sym_return] = ACTIONS(1265),
    [anon_sym_yield] = ACTIONS(1265),
    [anon_sym_break] = ACTIONS(1265),
    [anon_sym_next] = ACTIONS(1265),
    [sym_redo] = ACTIONS(1265),
    [sym_retry] = ACTIONS(1265),
    [anon_sym_if] = ACTIONS(1265),
    [anon_sym_unless] = ACTIONS(1265),
    [anon_sym_while] = ACTIONS(1265),
    [anon_sym_until] = ACTIONS(1265),
    [anon_sym_rescue] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1265),
    [anon_sym_in] = ACTIONS(1265),
    [anon_sym_do] = ACTIONS(1265),
    [anon_sym_case] = ACTIONS(1265),
    [anon_sym_begin] = ACTIONS(1265),
    [anon_sym_LBRACK] = ACTIONS(1263),
    [anon_sym_RBRACK] = ACTIONS(1263),
    [anon_sym_COLON_COLON2] = ACTIONS(1263),
    [anon_sym_AMP_DOT] = ACTIONS(1263),
    [anon_sym_LPAREN2] = ACTIONS(1263),
    [anon_sym_PLUS_EQ] = ACTIONS(1263),
    [anon_sym_DASH_EQ] = ACTIONS(1263),
    [anon_sym_STAR_EQ] = ACTIONS(1263),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1263),
    [anon_sym_SLASH_EQ] = ACTIONS(1263),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1263),
    [anon_sym_PIPE_EQ] = ACTIONS(1263),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1263),
    [anon_sym_AMP_EQ] = ACTIONS(1263),
    [anon_sym_PERCENT_EQ] = ACTIONS(1263),
    [anon_sym_GT_GT_EQ] = ACTIONS(1263),
    [anon_sym_LT_LT_EQ] = ACTIONS(1263),
    [anon_sym_CARET_EQ] = ACTIONS(1263),
    [anon_sym_QMARK] = ACTIONS(1265),
    [anon_sym_COLON2] = ACTIONS(1265),
    [anon_sym_DOT_DOT] = ACTIONS(1265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1263),
    [anon_sym_and] = ACTIONS(1265),
    [anon_sym_or] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_LT_LT] = ACTIONS(1265),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_EQ_EQ] = ACTIONS(1265),
    [anon_sym_BANG_EQ] = ACTIONS(1263),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1263),
    [anon_sym_LT_EQ_GT] = ACTIONS(1263),
    [anon_sym_EQ_TILDE] = ACTIONS(1263),
    [anon_sym_BANG_TILDE] = ACTIONS(1263),
    [anon_sym_LT_EQ] = ACTIONS(1265),
    [anon_sym_GT] = ACTIONS(1265),
    [anon_sym_GT_EQ] = ACTIONS(1263),
    [anon_sym_CARET] = ACTIONS(1265),
    [anon_sym_PLUS] = ACTIONS(1265),
    [anon_sym_SLASH] = ACTIONS(1265),
    [anon_sym_PERCENT] = ACTIONS(1265),
    [anon_sym_defined_QMARK] = ACTIONS(1263),
    [anon_sym_not] = ACTIONS(1265),
    [anon_sym_BANG] = ACTIONS(1265),
    [anon_sym_TILDE] = ACTIONS(1263),
    [sym_constant] = ACTIONS(1265),
    [sym_identifier] = ACTIONS(1265),
    [sym_instance_variable] = ACTIONS(1263),
    [sym_class_variable] = ACTIONS(1263),
    [sym_global_variable] = ACTIONS(1263),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1265),
    [sym_float] = ACTIONS(1265),
    [sym_complex] = ACTIONS(1263),
    [sym_super] = ACTIONS(1265),
    [anon_sym_true] = ACTIONS(1265),
    [anon_sym_TRUE] = ACTIONS(1265),
    [anon_sym_false] = ACTIONS(1265),
    [anon_sym_FALSE] = ACTIONS(1265),
    [sym_self] = ACTIONS(1265),
    [anon_sym_nil] = ACTIONS(1265),
    [anon_sym_NIL] = ACTIONS(1265),
    [sym_character] = ACTIONS(1263),
    [anon_sym_LBRACK2] = ACTIONS(1265),
    [anon_sym_DASH_GT] = ACTIONS(1263),
  },
  [4172] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(906),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(911),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(911),
    [sym__argument_list_with_trailing_comma] = STATE(6854),
    [sym__argument] = STATE(909),
    [sym_splat_argument] = STATE(909),
    [sym_hash_splat_argument] = STATE(909),
    [sym_block_argument] = STATE(909),
    [sym_assignment] = STATE(906),
    [sym_operator_assignment] = STATE(906),
    [sym_conditional] = STATE(906),
    [sym_range] = STATE(906),
    [sym_binary] = STATE(906),
    [sym_unary] = STATE(906),
    [sym_left_assignment_list] = STATE(910),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(911),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(911),
    [sym_false] = STATE(911),
    [sym_nil] = STATE(911),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(912),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(909),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1589),
    [sym__splat_star] = ACTIONS(1591),
    [sym__unary_minus] = ACTIONS(1593),
    [sym__identifier_hash_key] = ACTIONS(1595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(10395),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1599),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_defined_QMARK] = ACTIONS(1611),
    [anon_sym_not] = ACTIONS(1613),
    [anon_sym_BANG] = ACTIONS(1615),
    [anon_sym_TILDE] = ACTIONS(1615),
    [sym_constant] = ACTIONS(1617),
    [sym_identifier] = ACTIONS(1617),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4173] = {
    [sym__simple_symbol] = ACTIONS(5935),
    [sym__string_start] = ACTIONS(5935),
    [sym__symbol_start] = ACTIONS(5935),
    [sym__subshell_start] = ACTIONS(5935),
    [sym__regex_start] = ACTIONS(5935),
    [sym__string_array_start] = ACTIONS(5935),
    [sym__symbol_array_start] = ACTIONS(5935),
    [sym__heredoc_body_start] = ACTIONS(5935),
    [sym_heredoc_beginning] = ACTIONS(5935),
    [sym__block_ampersand] = ACTIONS(5935),
    [sym__splat_star] = ACTIONS(5935),
    [sym__unary_minus] = ACTIONS(5935),
    [sym__binary_minus] = ACTIONS(5935),
    [sym__binary_star] = ACTIONS(5935),
    [sym__identifier_hash_key] = ACTIONS(5935),
    [anon_sym_LBRACE] = ACTIONS(5935),
    [anon_sym_RBRACE] = ACTIONS(5935),
    [anon_sym_def] = ACTIONS(5937),
    [anon_sym_LPAREN] = ACTIONS(5937),
    [anon_sym_RPAREN] = ACTIONS(5935),
    [anon_sym_DOT] = ACTIONS(5937),
    [anon_sym_COLON_COLON] = ACTIONS(5937),
    [anon_sym_COMMA] = ACTIONS(5935),
    [anon_sym_PIPE] = ACTIONS(5937),
    [anon_sym_SEMI] = ACTIONS(5935),
    [anon_sym_STAR] = ACTIONS(5937),
    [anon_sym_STAR_STAR] = ACTIONS(5937),
    [anon_sym_AMP] = ACTIONS(5937),
    [anon_sym_EQ] = ACTIONS(5937),
    [anon_sym_class] = ACTIONS(5937),
    [anon_sym_LT] = ACTIONS(5937),
    [anon_sym_module] = ACTIONS(5937),
    [anon_sym_return] = ACTIONS(5937),
    [anon_sym_yield] = ACTIONS(5937),
    [anon_sym_break] = ACTIONS(5937),
    [anon_sym_next] = ACTIONS(5937),
    [sym_redo] = ACTIONS(5937),
    [sym_retry] = ACTIONS(5937),
    [anon_sym_if] = ACTIONS(5937),
    [anon_sym_unless] = ACTIONS(5937),
    [anon_sym_while] = ACTIONS(5937),
    [anon_sym_until] = ACTIONS(5937),
    [anon_sym_rescue] = ACTIONS(5937),
    [anon_sym_for] = ACTIONS(5937),
    [anon_sym_in] = ACTIONS(5937),
    [anon_sym_do] = ACTIONS(5937),
    [anon_sym_case] = ACTIONS(5937),
    [anon_sym_begin] = ACTIONS(5937),
    [anon_sym_LBRACK] = ACTIONS(5935),
    [anon_sym_RBRACK] = ACTIONS(5935),
    [anon_sym_COLON_COLON2] = ACTIONS(5935),
    [anon_sym_AMP_DOT] = ACTIONS(5935),
    [anon_sym_LPAREN2] = ACTIONS(5935),
    [anon_sym_PLUS_EQ] = ACTIONS(5935),
    [anon_sym_DASH_EQ] = ACTIONS(5935),
    [anon_sym_STAR_EQ] = ACTIONS(5935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5935),
    [anon_sym_SLASH_EQ] = ACTIONS(5935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5935),
    [anon_sym_PIPE_EQ] = ACTIONS(5935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5935),
    [anon_sym_AMP_EQ] = ACTIONS(5935),
    [anon_sym_PERCENT_EQ] = ACTIONS(5935),
    [anon_sym_GT_GT_EQ] = ACTIONS(5935),
    [anon_sym_LT_LT_EQ] = ACTIONS(5935),
    [anon_sym_CARET_EQ] = ACTIONS(5935),
    [anon_sym_QMARK] = ACTIONS(5937),
    [anon_sym_COLON2] = ACTIONS(5937),
    [anon_sym_DOT_DOT] = ACTIONS(5937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5935),
    [anon_sym_and] = ACTIONS(5937),
    [anon_sym_or] = ACTIONS(5937),
    [anon_sym_PIPE_PIPE] = ACTIONS(5937),
    [anon_sym_AMP_AMP] = ACTIONS(5937),
    [anon_sym_LT_LT] = ACTIONS(5937),
    [anon_sym_GT_GT] = ACTIONS(5937),
    [anon_sym_EQ_EQ] = ACTIONS(5937),
    [anon_sym_BANG_EQ] = ACTIONS(5935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5935),
    [anon_sym_LT_EQ_GT] = ACTIONS(5935),
    [anon_sym_EQ_TILDE] = ACTIONS(5935),
    [anon_sym_BANG_TILDE] = ACTIONS(5935),
    [anon_sym_LT_EQ] = ACTIONS(5937),
    [anon_sym_GT] = ACTIONS(5937),
    [anon_sym_GT_EQ] = ACTIONS(5935),
    [anon_sym_CARET] = ACTIONS(5937),
    [anon_sym_PLUS] = ACTIONS(5937),
    [anon_sym_SLASH] = ACTIONS(5937),
    [anon_sym_PERCENT] = ACTIONS(5937),
    [anon_sym_defined_QMARK] = ACTIONS(5935),
    [anon_sym_not] = ACTIONS(5937),
    [anon_sym_BANG] = ACTIONS(5937),
    [anon_sym_TILDE] = ACTIONS(5935),
    [sym_constant] = ACTIONS(5937),
    [sym_identifier] = ACTIONS(5937),
    [sym_instance_variable] = ACTIONS(5935),
    [sym_class_variable] = ACTIONS(5935),
    [sym_global_variable] = ACTIONS(5935),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5937),
    [sym_float] = ACTIONS(5937),
    [sym_complex] = ACTIONS(5935),
    [sym_super] = ACTIONS(5937),
    [anon_sym_true] = ACTIONS(5937),
    [anon_sym_TRUE] = ACTIONS(5937),
    [anon_sym_false] = ACTIONS(5937),
    [anon_sym_FALSE] = ACTIONS(5937),
    [sym_self] = ACTIONS(5937),
    [anon_sym_nil] = ACTIONS(5937),
    [anon_sym_NIL] = ACTIONS(5937),
    [sym_character] = ACTIONS(5935),
    [anon_sym_LBRACK2] = ACTIONS(5937),
    [anon_sym_DASH_GT] = ACTIONS(5935),
  },
  [4174] = {
    [sym__simple_symbol] = ACTIONS(5939),
    [sym__string_start] = ACTIONS(5939),
    [sym__symbol_start] = ACTIONS(5939),
    [sym__subshell_start] = ACTIONS(5939),
    [sym__regex_start] = ACTIONS(5939),
    [sym__string_array_start] = ACTIONS(5939),
    [sym__symbol_array_start] = ACTIONS(5939),
    [sym__heredoc_body_start] = ACTIONS(5939),
    [sym_heredoc_beginning] = ACTIONS(5939),
    [sym__block_ampersand] = ACTIONS(5939),
    [sym__splat_star] = ACTIONS(5939),
    [sym__unary_minus] = ACTIONS(5939),
    [sym__binary_minus] = ACTIONS(5939),
    [sym__binary_star] = ACTIONS(5939),
    [sym__identifier_hash_key] = ACTIONS(5939),
    [anon_sym_LBRACE] = ACTIONS(5939),
    [anon_sym_RBRACE] = ACTIONS(5939),
    [anon_sym_def] = ACTIONS(5941),
    [anon_sym_LPAREN] = ACTIONS(5941),
    [anon_sym_RPAREN] = ACTIONS(5939),
    [anon_sym_DOT] = ACTIONS(5941),
    [anon_sym_COLON_COLON] = ACTIONS(5941),
    [anon_sym_COMMA] = ACTIONS(5939),
    [anon_sym_PIPE] = ACTIONS(5941),
    [anon_sym_SEMI] = ACTIONS(5939),
    [anon_sym_STAR] = ACTIONS(5941),
    [anon_sym_STAR_STAR] = ACTIONS(5941),
    [anon_sym_AMP] = ACTIONS(5941),
    [anon_sym_EQ] = ACTIONS(5941),
    [anon_sym_class] = ACTIONS(5941),
    [anon_sym_LT] = ACTIONS(5941),
    [anon_sym_module] = ACTIONS(5941),
    [anon_sym_return] = ACTIONS(5941),
    [anon_sym_yield] = ACTIONS(5941),
    [anon_sym_break] = ACTIONS(5941),
    [anon_sym_next] = ACTIONS(5941),
    [sym_redo] = ACTIONS(5941),
    [sym_retry] = ACTIONS(5941),
    [anon_sym_if] = ACTIONS(5941),
    [anon_sym_unless] = ACTIONS(5941),
    [anon_sym_while] = ACTIONS(5941),
    [anon_sym_until] = ACTIONS(5941),
    [anon_sym_rescue] = ACTIONS(5941),
    [anon_sym_for] = ACTIONS(5941),
    [anon_sym_in] = ACTIONS(5941),
    [anon_sym_do] = ACTIONS(5941),
    [anon_sym_case] = ACTIONS(5941),
    [anon_sym_begin] = ACTIONS(5941),
    [anon_sym_LBRACK] = ACTIONS(5939),
    [anon_sym_RBRACK] = ACTIONS(5939),
    [anon_sym_COLON_COLON2] = ACTIONS(5939),
    [anon_sym_AMP_DOT] = ACTIONS(5939),
    [anon_sym_LPAREN2] = ACTIONS(5939),
    [anon_sym_PLUS_EQ] = ACTIONS(5939),
    [anon_sym_DASH_EQ] = ACTIONS(5939),
    [anon_sym_STAR_EQ] = ACTIONS(5939),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5939),
    [anon_sym_SLASH_EQ] = ACTIONS(5939),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5939),
    [anon_sym_PIPE_EQ] = ACTIONS(5939),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5939),
    [anon_sym_AMP_EQ] = ACTIONS(5939),
    [anon_sym_PERCENT_EQ] = ACTIONS(5939),
    [anon_sym_GT_GT_EQ] = ACTIONS(5939),
    [anon_sym_LT_LT_EQ] = ACTIONS(5939),
    [anon_sym_CARET_EQ] = ACTIONS(5939),
    [anon_sym_QMARK] = ACTIONS(5941),
    [anon_sym_COLON2] = ACTIONS(5941),
    [anon_sym_DOT_DOT] = ACTIONS(5941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5939),
    [anon_sym_and] = ACTIONS(5941),
    [anon_sym_or] = ACTIONS(5941),
    [anon_sym_PIPE_PIPE] = ACTIONS(5941),
    [anon_sym_AMP_AMP] = ACTIONS(5941),
    [anon_sym_LT_LT] = ACTIONS(5941),
    [anon_sym_GT_GT] = ACTIONS(5941),
    [anon_sym_EQ_EQ] = ACTIONS(5941),
    [anon_sym_BANG_EQ] = ACTIONS(5939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5939),
    [anon_sym_LT_EQ_GT] = ACTIONS(5939),
    [anon_sym_EQ_TILDE] = ACTIONS(5939),
    [anon_sym_BANG_TILDE] = ACTIONS(5939),
    [anon_sym_LT_EQ] = ACTIONS(5941),
    [anon_sym_GT] = ACTIONS(5941),
    [anon_sym_GT_EQ] = ACTIONS(5939),
    [anon_sym_CARET] = ACTIONS(5941),
    [anon_sym_PLUS] = ACTIONS(5941),
    [anon_sym_SLASH] = ACTIONS(5941),
    [anon_sym_PERCENT] = ACTIONS(5941),
    [anon_sym_defined_QMARK] = ACTIONS(5939),
    [anon_sym_not] = ACTIONS(5941),
    [anon_sym_BANG] = ACTIONS(5941),
    [anon_sym_TILDE] = ACTIONS(5939),
    [sym_constant] = ACTIONS(5941),
    [sym_identifier] = ACTIONS(5941),
    [sym_instance_variable] = ACTIONS(5939),
    [sym_class_variable] = ACTIONS(5939),
    [sym_global_variable] = ACTIONS(5939),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5941),
    [sym_float] = ACTIONS(5941),
    [sym_complex] = ACTIONS(5939),
    [sym_super] = ACTIONS(5941),
    [anon_sym_true] = ACTIONS(5941),
    [anon_sym_TRUE] = ACTIONS(5941),
    [anon_sym_false] = ACTIONS(5941),
    [anon_sym_FALSE] = ACTIONS(5941),
    [sym_self] = ACTIONS(5941),
    [anon_sym_nil] = ACTIONS(5941),
    [anon_sym_NIL] = ACTIONS(5941),
    [sym_character] = ACTIONS(5939),
    [anon_sym_LBRACK2] = ACTIONS(5941),
    [anon_sym_DASH_GT] = ACTIONS(5939),
  },
  [4175] = {
    [sym_argument_list_with_parens] = STATE(6855),
    [sym__argument_list_with_parens] = STATE(4174),
    [sym_operator] = STATE(6855),
    [sym_heredoc_body] = STATE(3563),
    [aux_sym_call_repeat1] = STATE(3563),
    [sym__heredoc_body_start] = ACTIONS(2519),
    [anon_sym_PIPE] = ACTIONS(6901),
    [anon_sym_STAR] = ACTIONS(6903),
    [anon_sym_STAR_STAR] = ACTIONS(6901),
    [anon_sym_AMP] = ACTIONS(6901),
    [anon_sym_LT] = ACTIONS(6903),
    [anon_sym_LPAREN2] = ACTIONS(6905),
    [anon_sym_DOT_DOT] = ACTIONS(6901),
    [anon_sym_LT_LT] = ACTIONS(6901),
    [anon_sym_GT_GT] = ACTIONS(6901),
    [anon_sym_EQ_EQ] = ACTIONS(6903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6901),
    [anon_sym_LT_EQ_GT] = ACTIONS(6901),
    [anon_sym_EQ_TILDE] = ACTIONS(6901),
    [anon_sym_BANG_TILDE] = ACTIONS(6901),
    [anon_sym_LT_EQ] = ACTIONS(6903),
    [anon_sym_GT] = ACTIONS(6903),
    [anon_sym_GT_EQ] = ACTIONS(6901),
    [anon_sym_CARET] = ACTIONS(6901),
    [anon_sym_PLUS] = ACTIONS(6903),
    [anon_sym_SLASH] = ACTIONS(6901),
    [anon_sym_PERCENT] = ACTIONS(6901),
    [anon_sym_BANG] = ACTIONS(6903),
    [anon_sym_TILDE] = ACTIONS(6901),
    [sym_constant] = ACTIONS(10397),
    [sym_identifier] = ACTIONS(10397),
    [anon_sym_DASH] = ACTIONS(6903),
    [anon_sym_PLUS_AT] = ACTIONS(6901),
    [anon_sym_DASH_AT] = ACTIONS(6901),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(6903),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(6901),
    [anon_sym_BQUOTE] = ACTIONS(6901),
    [sym_comment] = ACTIONS(87),
  },
  [4176] = {
    [sym__heredoc_body_start] = ACTIONS(5945),
    [sym__binary_minus] = ACTIONS(5945),
    [sym__binary_star] = ACTIONS(5945),
    [anon_sym_LBRACE] = ACTIONS(5945),
    [anon_sym_RBRACE] = ACTIONS(5945),
    [anon_sym_RPAREN] = ACTIONS(5945),
    [anon_sym_DOT] = ACTIONS(5947),
    [anon_sym_COMMA] = ACTIONS(5945),
    [anon_sym_PIPE] = ACTIONS(5947),
    [anon_sym_SEMI] = ACTIONS(5945),
    [anon_sym_STAR_STAR] = ACTIONS(5947),
    [anon_sym_AMP] = ACTIONS(5947),
    [anon_sym_EQ] = ACTIONS(5947),
    [anon_sym_LT] = ACTIONS(5947),
    [anon_sym_if] = ACTIONS(5945),
    [anon_sym_unless] = ACTIONS(5945),
    [anon_sym_while] = ACTIONS(5945),
    [anon_sym_until] = ACTIONS(5945),
    [anon_sym_rescue] = ACTIONS(5945),
    [anon_sym_in] = ACTIONS(5945),
    [anon_sym_do] = ACTIONS(5945),
    [anon_sym_LBRACK] = ACTIONS(5945),
    [anon_sym_RBRACK] = ACTIONS(5945),
    [anon_sym_COLON_COLON2] = ACTIONS(5945),
    [anon_sym_AMP_DOT] = ACTIONS(5945),
    [anon_sym_PLUS_EQ] = ACTIONS(5945),
    [anon_sym_DASH_EQ] = ACTIONS(5945),
    [anon_sym_STAR_EQ] = ACTIONS(5945),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5945),
    [anon_sym_SLASH_EQ] = ACTIONS(5945),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5945),
    [anon_sym_PIPE_EQ] = ACTIONS(5945),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5945),
    [anon_sym_AMP_EQ] = ACTIONS(5945),
    [anon_sym_PERCENT_EQ] = ACTIONS(5945),
    [anon_sym_GT_GT_EQ] = ACTIONS(5945),
    [anon_sym_LT_LT_EQ] = ACTIONS(5945),
    [anon_sym_CARET_EQ] = ACTIONS(5945),
    [anon_sym_QMARK] = ACTIONS(5945),
    [anon_sym_COLON2] = ACTIONS(5947),
    [anon_sym_DOT_DOT] = ACTIONS(5947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5945),
    [anon_sym_and] = ACTIONS(5945),
    [anon_sym_or] = ACTIONS(5945),
    [anon_sym_PIPE_PIPE] = ACTIONS(5947),
    [anon_sym_AMP_AMP] = ACTIONS(5947),
    [anon_sym_LT_LT] = ACTIONS(5947),
    [anon_sym_GT_GT] = ACTIONS(5947),
    [anon_sym_EQ_EQ] = ACTIONS(5947),
    [anon_sym_BANG_EQ] = ACTIONS(5945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5945),
    [anon_sym_LT_EQ_GT] = ACTIONS(5945),
    [anon_sym_EQ_TILDE] = ACTIONS(5945),
    [anon_sym_BANG_TILDE] = ACTIONS(5945),
    [anon_sym_LT_EQ] = ACTIONS(5947),
    [anon_sym_GT] = ACTIONS(5947),
    [anon_sym_GT_EQ] = ACTIONS(5945),
    [anon_sym_CARET] = ACTIONS(5947),
    [anon_sym_PLUS] = ACTIONS(5947),
    [anon_sym_SLASH] = ACTIONS(5947),
    [anon_sym_PERCENT] = ACTIONS(5947),
    [sym_comment] = ACTIONS(87),
  },
  [4177] = {
    [anon_sym_RBRACK] = ACTIONS(10399),
    [sym_comment] = ACTIONS(87),
  },
  [4178] = {
    [sym__simple_symbol] = ACTIONS(5951),
    [sym__string_start] = ACTIONS(5951),
    [sym__symbol_start] = ACTIONS(5951),
    [sym__subshell_start] = ACTIONS(5951),
    [sym__regex_start] = ACTIONS(5951),
    [sym__string_array_start] = ACTIONS(5951),
    [sym__symbol_array_start] = ACTIONS(5951),
    [sym__heredoc_body_start] = ACTIONS(5951),
    [sym_heredoc_beginning] = ACTIONS(5951),
    [sym__block_ampersand] = ACTIONS(5951),
    [sym__splat_star] = ACTIONS(5951),
    [sym__unary_minus] = ACTIONS(5951),
    [sym__binary_minus] = ACTIONS(5951),
    [sym__binary_star] = ACTIONS(5951),
    [sym__identifier_hash_key] = ACTIONS(5951),
    [anon_sym_LBRACE] = ACTIONS(5951),
    [anon_sym_RBRACE] = ACTIONS(5951),
    [anon_sym_def] = ACTIONS(5953),
    [anon_sym_LPAREN] = ACTIONS(5953),
    [anon_sym_RPAREN] = ACTIONS(5951),
    [anon_sym_DOT] = ACTIONS(5953),
    [anon_sym_COLON_COLON] = ACTIONS(5953),
    [anon_sym_COMMA] = ACTIONS(5951),
    [anon_sym_PIPE] = ACTIONS(5953),
    [anon_sym_SEMI] = ACTIONS(5951),
    [anon_sym_STAR] = ACTIONS(5953),
    [anon_sym_STAR_STAR] = ACTIONS(5953),
    [anon_sym_AMP] = ACTIONS(5953),
    [anon_sym_EQ] = ACTIONS(5953),
    [anon_sym_class] = ACTIONS(5953),
    [anon_sym_LT] = ACTIONS(5953),
    [anon_sym_module] = ACTIONS(5953),
    [anon_sym_return] = ACTIONS(5953),
    [anon_sym_yield] = ACTIONS(5953),
    [anon_sym_break] = ACTIONS(5953),
    [anon_sym_next] = ACTIONS(5953),
    [sym_redo] = ACTIONS(5953),
    [sym_retry] = ACTIONS(5953),
    [anon_sym_if] = ACTIONS(5953),
    [anon_sym_unless] = ACTIONS(5953),
    [anon_sym_while] = ACTIONS(5953),
    [anon_sym_until] = ACTIONS(5953),
    [anon_sym_rescue] = ACTIONS(5953),
    [anon_sym_for] = ACTIONS(5953),
    [anon_sym_in] = ACTIONS(5953),
    [anon_sym_do] = ACTIONS(5953),
    [anon_sym_case] = ACTIONS(5953),
    [anon_sym_begin] = ACTIONS(5953),
    [anon_sym_LBRACK] = ACTIONS(5951),
    [anon_sym_RBRACK] = ACTIONS(5951),
    [anon_sym_COLON_COLON2] = ACTIONS(5951),
    [anon_sym_AMP_DOT] = ACTIONS(5951),
    [anon_sym_LPAREN2] = ACTIONS(5951),
    [anon_sym_PLUS_EQ] = ACTIONS(5951),
    [anon_sym_DASH_EQ] = ACTIONS(5951),
    [anon_sym_STAR_EQ] = ACTIONS(5951),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5951),
    [anon_sym_SLASH_EQ] = ACTIONS(5951),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5951),
    [anon_sym_PIPE_EQ] = ACTIONS(5951),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5951),
    [anon_sym_AMP_EQ] = ACTIONS(5951),
    [anon_sym_PERCENT_EQ] = ACTIONS(5951),
    [anon_sym_GT_GT_EQ] = ACTIONS(5951),
    [anon_sym_LT_LT_EQ] = ACTIONS(5951),
    [anon_sym_CARET_EQ] = ACTIONS(5951),
    [anon_sym_QMARK] = ACTIONS(5953),
    [anon_sym_COLON2] = ACTIONS(5953),
    [anon_sym_DOT_DOT] = ACTIONS(5953),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5951),
    [anon_sym_and] = ACTIONS(5953),
    [anon_sym_or] = ACTIONS(5953),
    [anon_sym_PIPE_PIPE] = ACTIONS(5953),
    [anon_sym_AMP_AMP] = ACTIONS(5953),
    [anon_sym_LT_LT] = ACTIONS(5953),
    [anon_sym_GT_GT] = ACTIONS(5953),
    [anon_sym_EQ_EQ] = ACTIONS(5953),
    [anon_sym_BANG_EQ] = ACTIONS(5951),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5951),
    [anon_sym_LT_EQ_GT] = ACTIONS(5951),
    [anon_sym_EQ_TILDE] = ACTIONS(5951),
    [anon_sym_BANG_TILDE] = ACTIONS(5951),
    [anon_sym_LT_EQ] = ACTIONS(5953),
    [anon_sym_GT] = ACTIONS(5953),
    [anon_sym_GT_EQ] = ACTIONS(5951),
    [anon_sym_CARET] = ACTIONS(5953),
    [anon_sym_PLUS] = ACTIONS(5953),
    [anon_sym_SLASH] = ACTIONS(5953),
    [anon_sym_PERCENT] = ACTIONS(5953),
    [anon_sym_defined_QMARK] = ACTIONS(5951),
    [anon_sym_not] = ACTIONS(5953),
    [anon_sym_BANG] = ACTIONS(5953),
    [anon_sym_TILDE] = ACTIONS(5951),
    [sym_constant] = ACTIONS(5953),
    [sym_identifier] = ACTIONS(5953),
    [sym_instance_variable] = ACTIONS(5951),
    [sym_class_variable] = ACTIONS(5951),
    [sym_global_variable] = ACTIONS(5951),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5953),
    [sym_float] = ACTIONS(5953),
    [sym_complex] = ACTIONS(5951),
    [sym_super] = ACTIONS(5953),
    [anon_sym_true] = ACTIONS(5953),
    [anon_sym_TRUE] = ACTIONS(5953),
    [anon_sym_false] = ACTIONS(5953),
    [anon_sym_FALSE] = ACTIONS(5953),
    [sym_self] = ACTIONS(5953),
    [anon_sym_nil] = ACTIONS(5953),
    [anon_sym_NIL] = ACTIONS(5953),
    [sym_character] = ACTIONS(5951),
    [anon_sym_LBRACK2] = ACTIONS(5953),
    [anon_sym_DASH_GT] = ACTIONS(5951),
  },
  [4179] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(6857),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(4189),
    [sym_scope_resolution] = STATE(4187),
    [sym_call] = STATE(4187),
    [sym_method_call] = STATE(4189),
    [sym_assignment] = STATE(6857),
    [sym_operator_assignment] = STATE(6857),
    [sym_conditional] = STATE(6857),
    [sym_range] = STATE(6857),
    [sym_binary] = STATE(6857),
    [sym_unary] = STATE(6857),
    [sym_left_assignment_list] = STATE(4188),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4189),
    [sym__variable] = STATE(4187),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(4189),
    [sym_false] = STATE(4189),
    [sym_nil] = STATE(4189),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(4190),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(6913),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(6915),
    [anon_sym_yield] = ACTIONS(6917),
    [anon_sym_break] = ACTIONS(6919),
    [anon_sym_next] = ACTIONS(6921),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_defined_QMARK] = ACTIONS(6925),
    [anon_sym_not] = ACTIONS(6927),
    [anon_sym_BANG] = ACTIONS(6929),
    [anon_sym_TILDE] = ACTIONS(6929),
    [sym_constant] = ACTIONS(6931),
    [sym_identifier] = ACTIONS(6931),
    [sym_instance_variable] = ACTIONS(6933),
    [sym_class_variable] = ACTIONS(6933),
    [sym_global_variable] = ACTIONS(6933),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(6931),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6931),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [4180] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1844),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1851),
    [sym_scope_resolution] = STATE(1845),
    [sym_call] = STATE(1845),
    [sym_method_call] = STATE(1851),
    [sym_argument_list] = STATE(6614),
    [sym__argument_list_with_parens] = STATE(1847),
    [sym__argument] = STATE(1848),
    [sym_splat_argument] = STATE(1848),
    [sym_hash_splat_argument] = STATE(1848),
    [sym_block_argument] = STATE(1848),
    [sym_assignment] = STATE(1844),
    [sym_operator_assignment] = STATE(1844),
    [sym_conditional] = STATE(1844),
    [sym_range] = STATE(1844),
    [sym_binary] = STATE(1844),
    [sym_unary] = STATE(1844),
    [sym_left_assignment_list] = STATE(1850),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1851),
    [sym__variable] = STATE(1845),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1851),
    [sym_false] = STATE(1851),
    [sym_nil] = STATE(1851),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1852),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(1848),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(3319),
    [sym__splat_star] = ACTIONS(3321),
    [sym__unary_minus] = ACTIONS(3323),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(3325),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_RBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3329),
    [anon_sym_yield] = ACTIONS(3331),
    [anon_sym_break] = ACTIONS(3333),
    [anon_sym_next] = ACTIONS(3335),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_PLUS_EQ] = ACTIONS(365),
    [anon_sym_DASH_EQ] = ACTIONS(365),
    [anon_sym_STAR_EQ] = ACTIONS(365),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(365),
    [anon_sym_SLASH_EQ] = ACTIONS(365),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(365),
    [anon_sym_PIPE_EQ] = ACTIONS(365),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(365),
    [anon_sym_AMP_EQ] = ACTIONS(365),
    [anon_sym_PERCENT_EQ] = ACTIONS(365),
    [anon_sym_GT_GT_EQ] = ACTIONS(365),
    [anon_sym_LT_LT_EQ] = ACTIONS(365),
    [anon_sym_CARET_EQ] = ACTIONS(365),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_PERCENT] = ACTIONS(377),
    [anon_sym_defined_QMARK] = ACTIONS(3339),
    [anon_sym_not] = ACTIONS(3341),
    [anon_sym_BANG] = ACTIONS(3343),
    [anon_sym_TILDE] = ACTIONS(3345),
    [sym_constant] = ACTIONS(3347),
    [sym_identifier] = ACTIONS(3347),
    [sym_instance_variable] = ACTIONS(3349),
    [sym_class_variable] = ACTIONS(3349),
    [sym_global_variable] = ACTIONS(3349),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3351),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3351),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4181] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1844),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1851),
    [sym_scope_resolution] = STATE(1845),
    [sym_call] = STATE(1845),
    [sym_method_call] = STATE(1851),
    [sym_argument_list] = STATE(6615),
    [sym__argument_list_with_parens] = STATE(1847),
    [sym__argument] = STATE(1848),
    [sym_splat_argument] = STATE(1848),
    [sym_hash_splat_argument] = STATE(1848),
    [sym_block_argument] = STATE(1848),
    [sym_assignment] = STATE(1844),
    [sym_operator_assignment] = STATE(1844),
    [sym_conditional] = STATE(1844),
    [sym_range] = STATE(1844),
    [sym_binary] = STATE(1844),
    [sym_unary] = STATE(1844),
    [sym_left_assignment_list] = STATE(1850),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1851),
    [sym__variable] = STATE(1845),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1851),
    [sym_false] = STATE(1851),
    [sym_nil] = STATE(1851),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1852),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(1848),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(3319),
    [sym__splat_star] = ACTIONS(3321),
    [sym__unary_minus] = ACTIONS(3323),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(3325),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_RBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_EQ] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3329),
    [anon_sym_yield] = ACTIONS(3331),
    [anon_sym_break] = ACTIONS(3333),
    [anon_sym_next] = ACTIONS(3335),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_PLUS_EQ] = ACTIONS(417),
    [anon_sym_DASH_EQ] = ACTIONS(417),
    [anon_sym_STAR_EQ] = ACTIONS(417),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(417),
    [anon_sym_SLASH_EQ] = ACTIONS(417),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(417),
    [anon_sym_PIPE_EQ] = ACTIONS(417),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(417),
    [anon_sym_AMP_EQ] = ACTIONS(417),
    [anon_sym_PERCENT_EQ] = ACTIONS(417),
    [anon_sym_GT_GT_EQ] = ACTIONS(417),
    [anon_sym_LT_LT_EQ] = ACTIONS(417),
    [anon_sym_CARET_EQ] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(3339),
    [anon_sym_not] = ACTIONS(3341),
    [anon_sym_BANG] = ACTIONS(3343),
    [anon_sym_TILDE] = ACTIONS(3345),
    [sym_constant] = ACTIONS(3347),
    [sym_identifier] = ACTIONS(3347),
    [sym_instance_variable] = ACTIONS(3349),
    [sym_class_variable] = ACTIONS(3349),
    [sym_global_variable] = ACTIONS(3349),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3351),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3351),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4182] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1844),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1851),
    [sym_scope_resolution] = STATE(1845),
    [sym_call] = STATE(1845),
    [sym_method_call] = STATE(1851),
    [sym_argument_list] = STATE(6616),
    [sym__argument_list_with_parens] = STATE(1847),
    [sym__argument] = STATE(1848),
    [sym_splat_argument] = STATE(1848),
    [sym_hash_splat_argument] = STATE(1848),
    [sym_block_argument] = STATE(1848),
    [sym_assignment] = STATE(1844),
    [sym_operator_assignment] = STATE(1844),
    [sym_conditional] = STATE(1844),
    [sym_range] = STATE(1844),
    [sym_binary] = STATE(1844),
    [sym_unary] = STATE(1844),
    [sym_left_assignment_list] = STATE(1850),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1851),
    [sym__variable] = STATE(1845),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1851),
    [sym_false] = STATE(1851),
    [sym_nil] = STATE(1851),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1852),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(1848),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(3319),
    [sym__splat_star] = ACTIONS(3321),
    [sym__unary_minus] = ACTIONS(3323),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(3325),
    [anon_sym_LBRACE] = ACTIONS(421),
    [anon_sym_RBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_EQ] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3329),
    [anon_sym_yield] = ACTIONS(3331),
    [anon_sym_break] = ACTIONS(3333),
    [anon_sym_next] = ACTIONS(3335),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_PLUS_EQ] = ACTIONS(421),
    [anon_sym_DASH_EQ] = ACTIONS(421),
    [anon_sym_STAR_EQ] = ACTIONS(421),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(421),
    [anon_sym_SLASH_EQ] = ACTIONS(421),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(421),
    [anon_sym_PIPE_EQ] = ACTIONS(421),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(421),
    [anon_sym_AMP_EQ] = ACTIONS(421),
    [anon_sym_PERCENT_EQ] = ACTIONS(421),
    [anon_sym_GT_GT_EQ] = ACTIONS(421),
    [anon_sym_LT_LT_EQ] = ACTIONS(421),
    [anon_sym_CARET_EQ] = ACTIONS(421),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(3339),
    [anon_sym_not] = ACTIONS(3341),
    [anon_sym_BANG] = ACTIONS(3343),
    [anon_sym_TILDE] = ACTIONS(3345),
    [sym_constant] = ACTIONS(3347),
    [sym_identifier] = ACTIONS(3347),
    [sym_instance_variable] = ACTIONS(3349),
    [sym_class_variable] = ACTIONS(3349),
    [sym_global_variable] = ACTIONS(3349),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3351),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3351),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4183] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1844),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1851),
    [sym_scope_resolution] = STATE(1845),
    [sym_call] = STATE(1845),
    [sym_method_call] = STATE(1851),
    [sym_argument_list] = STATE(6617),
    [sym__argument_list_with_parens] = STATE(1847),
    [sym__argument] = STATE(1848),
    [sym_splat_argument] = STATE(1848),
    [sym_hash_splat_argument] = STATE(1848),
    [sym_block_argument] = STATE(1848),
    [sym_assignment] = STATE(1844),
    [sym_operator_assignment] = STATE(1844),
    [sym_conditional] = STATE(1844),
    [sym_range] = STATE(1844),
    [sym_binary] = STATE(1844),
    [sym_unary] = STATE(1844),
    [sym_left_assignment_list] = STATE(1850),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1851),
    [sym__variable] = STATE(1845),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1851),
    [sym_false] = STATE(1851),
    [sym_nil] = STATE(1851),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1852),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(1848),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(3319),
    [sym__splat_star] = ACTIONS(3321),
    [sym__unary_minus] = ACTIONS(3323),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(3325),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(427),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3329),
    [anon_sym_yield] = ACTIONS(3331),
    [anon_sym_break] = ACTIONS(3333),
    [anon_sym_next] = ACTIONS(3335),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_PLUS_EQ] = ACTIONS(425),
    [anon_sym_DASH_EQ] = ACTIONS(425),
    [anon_sym_STAR_EQ] = ACTIONS(425),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(425),
    [anon_sym_SLASH_EQ] = ACTIONS(425),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(425),
    [anon_sym_PIPE_EQ] = ACTIONS(425),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(425),
    [anon_sym_AMP_EQ] = ACTIONS(425),
    [anon_sym_PERCENT_EQ] = ACTIONS(425),
    [anon_sym_GT_GT_EQ] = ACTIONS(425),
    [anon_sym_LT_LT_EQ] = ACTIONS(425),
    [anon_sym_CARET_EQ] = ACTIONS(425),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(3339),
    [anon_sym_not] = ACTIONS(3341),
    [anon_sym_BANG] = ACTIONS(3343),
    [anon_sym_TILDE] = ACTIONS(3345),
    [sym_constant] = ACTIONS(3347),
    [sym_identifier] = ACTIONS(3347),
    [sym_instance_variable] = ACTIONS(3349),
    [sym_class_variable] = ACTIONS(3349),
    [sym_global_variable] = ACTIONS(3349),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3351),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3351),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4184] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(6858),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(4189),
    [sym_scope_resolution] = STATE(4187),
    [sym_call] = STATE(4187),
    [sym_method_call] = STATE(4189),
    [sym_assignment] = STATE(6858),
    [sym_operator_assignment] = STATE(6858),
    [sym_conditional] = STATE(6858),
    [sym_range] = STATE(6858),
    [sym_binary] = STATE(6858),
    [sym_unary] = STATE(6858),
    [sym_left_assignment_list] = STATE(4188),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4189),
    [sym__variable] = STATE(4187),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(4189),
    [sym_false] = STATE(4189),
    [sym_nil] = STATE(4189),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(4190),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(6913),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(6915),
    [anon_sym_yield] = ACTIONS(6917),
    [anon_sym_break] = ACTIONS(6919),
    [anon_sym_next] = ACTIONS(6921),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_defined_QMARK] = ACTIONS(6925),
    [anon_sym_not] = ACTIONS(6927),
    [anon_sym_BANG] = ACTIONS(6929),
    [anon_sym_TILDE] = ACTIONS(6929),
    [sym_constant] = ACTIONS(6931),
    [sym_identifier] = ACTIONS(6931),
    [sym_instance_variable] = ACTIONS(6933),
    [sym_class_variable] = ACTIONS(6933),
    [sym_global_variable] = ACTIONS(6933),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(6931),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6931),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [4185] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(6632),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(4189),
    [sym_scope_resolution] = STATE(4187),
    [sym_call] = STATE(4187),
    [sym_method_call] = STATE(4189),
    [sym_assignment] = STATE(6632),
    [sym_operator_assignment] = STATE(6632),
    [sym_conditional] = STATE(6632),
    [sym_range] = STATE(6632),
    [sym_binary] = STATE(6632),
    [sym_unary] = STATE(6632),
    [sym_left_assignment_list] = STATE(4188),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4189),
    [sym__variable] = STATE(4187),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(4189),
    [sym_false] = STATE(4189),
    [sym_nil] = STATE(4189),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(4190),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(6913),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(6915),
    [anon_sym_yield] = ACTIONS(6917),
    [anon_sym_break] = ACTIONS(6919),
    [anon_sym_next] = ACTIONS(6921),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_defined_QMARK] = ACTIONS(6925),
    [anon_sym_not] = ACTIONS(6927),
    [anon_sym_BANG] = ACTIONS(6929),
    [anon_sym_TILDE] = ACTIONS(6929),
    [sym_constant] = ACTIONS(6931),
    [sym_identifier] = ACTIONS(6931),
    [sym_instance_variable] = ACTIONS(6933),
    [sym_class_variable] = ACTIONS(6933),
    [sym_global_variable] = ACTIONS(6933),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(6931),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6931),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [4186] = {
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(10401),
    [sym__binary_star] = ACTIONS(10403),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_RBRACE] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(10405),
    [anon_sym_STAR_STAR] = ACTIONS(10407),
    [anon_sym_AMP] = ACTIONS(10409),
    [anon_sym_EQ] = ACTIONS(4217),
    [anon_sym_LT] = ACTIONS(10411),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_PLUS_EQ] = ACTIONS(4211),
    [anon_sym_DASH_EQ] = ACTIONS(4211),
    [anon_sym_STAR_EQ] = ACTIONS(4211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4211),
    [anon_sym_SLASH_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4211),
    [anon_sym_AMP_EQ] = ACTIONS(4211),
    [anon_sym_PERCENT_EQ] = ACTIONS(4211),
    [anon_sym_GT_GT_EQ] = ACTIONS(4211),
    [anon_sym_LT_LT_EQ] = ACTIONS(4211),
    [anon_sym_CARET_EQ] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(10413),
    [anon_sym_DOT_DOT] = ACTIONS(10415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10417),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(10419),
    [anon_sym_AMP_AMP] = ACTIONS(10419),
    [anon_sym_LT_LT] = ACTIONS(10421),
    [anon_sym_GT_GT] = ACTIONS(10421),
    [anon_sym_EQ_EQ] = ACTIONS(10419),
    [anon_sym_BANG_EQ] = ACTIONS(10423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10423),
    [anon_sym_LT_EQ_GT] = ACTIONS(10423),
    [anon_sym_EQ_TILDE] = ACTIONS(10423),
    [anon_sym_BANG_TILDE] = ACTIONS(10423),
    [anon_sym_LT_EQ] = ACTIONS(10411),
    [anon_sym_GT] = ACTIONS(10411),
    [anon_sym_GT_EQ] = ACTIONS(10425),
    [anon_sym_CARET] = ACTIONS(10405),
    [anon_sym_PLUS] = ACTIONS(10427),
    [anon_sym_SLASH] = ACTIONS(10407),
    [anon_sym_PERCENT] = ACTIONS(10407),
    [sym_comment] = ACTIONS(87),
  },
  [4187] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1844),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1851),
    [sym_scope_resolution] = STATE(1845),
    [sym_call] = STATE(1845),
    [sym_method_call] = STATE(1851),
    [sym_argument_list] = STATE(4801),
    [sym__argument_list_with_parens] = STATE(1847),
    [sym__argument] = STATE(1848),
    [sym_splat_argument] = STATE(1848),
    [sym_hash_splat_argument] = STATE(1848),
    [sym_block_argument] = STATE(1848),
    [sym_do_block] = STATE(1849),
    [sym_block] = STATE(1849),
    [sym_assignment] = STATE(1844),
    [sym_operator_assignment] = STATE(1844),
    [sym_conditional] = STATE(1844),
    [sym_range] = STATE(1844),
    [sym_binary] = STATE(1844),
    [sym_unary] = STATE(1844),
    [sym_left_assignment_list] = STATE(1850),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1851),
    [sym__variable] = STATE(1845),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1851),
    [sym_false] = STATE(1851),
    [sym_nil] = STATE(1851),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1852),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(1848),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(3319),
    [sym__splat_star] = ACTIONS(3321),
    [sym__unary_minus] = ACTIONS(3323),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(3325),
    [anon_sym_LBRACE] = ACTIONS(7739),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3329),
    [anon_sym_yield] = ACTIONS(3331),
    [anon_sym_break] = ACTIONS(3333),
    [anon_sym_next] = ACTIONS(3335),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(769),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(3339),
    [anon_sym_not] = ACTIONS(3341),
    [anon_sym_BANG] = ACTIONS(3343),
    [anon_sym_TILDE] = ACTIONS(3345),
    [sym_constant] = ACTIONS(3347),
    [sym_identifier] = ACTIONS(3347),
    [sym_instance_variable] = ACTIONS(3349),
    [sym_class_variable] = ACTIONS(3349),
    [sym_global_variable] = ACTIONS(3349),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3351),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3351),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4188] = {
    [anon_sym_EQ] = ACTIONS(10429),
    [sym_comment] = ACTIONS(87),
  },
  [4189] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(10431),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(10433),
    [anon_sym_DASH_EQ] = ACTIONS(10433),
    [anon_sym_STAR_EQ] = ACTIONS(10433),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10433),
    [anon_sym_SLASH_EQ] = ACTIONS(10433),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10433),
    [anon_sym_PIPE_EQ] = ACTIONS(10433),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10433),
    [anon_sym_AMP_EQ] = ACTIONS(10433),
    [anon_sym_PERCENT_EQ] = ACTIONS(10433),
    [anon_sym_GT_GT_EQ] = ACTIONS(10433),
    [anon_sym_LT_LT_EQ] = ACTIONS(10433),
    [anon_sym_CARET_EQ] = ACTIONS(10433),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [4190] = {
    [sym_string] = STATE(6871),
    [aux_sym_chained_string_repeat1] = STATE(6871),
    [sym__string_start] = ACTIONS(6455),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [4191] = {
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(10401),
    [sym__binary_star] = ACTIONS(10403),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_RBRACE] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(10405),
    [anon_sym_STAR_STAR] = ACTIONS(10407),
    [anon_sym_AMP] = ACTIONS(10409),
    [anon_sym_EQ] = ACTIONS(4249),
    [anon_sym_LT] = ACTIONS(10411),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_PLUS_EQ] = ACTIONS(4247),
    [anon_sym_DASH_EQ] = ACTIONS(4247),
    [anon_sym_STAR_EQ] = ACTIONS(4247),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4247),
    [anon_sym_SLASH_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4247),
    [anon_sym_AMP_EQ] = ACTIONS(4247),
    [anon_sym_PERCENT_EQ] = ACTIONS(4247),
    [anon_sym_GT_GT_EQ] = ACTIONS(4247),
    [anon_sym_LT_LT_EQ] = ACTIONS(4247),
    [anon_sym_CARET_EQ] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(10413),
    [anon_sym_DOT_DOT] = ACTIONS(10415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10417),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(10419),
    [anon_sym_AMP_AMP] = ACTIONS(10419),
    [anon_sym_LT_LT] = ACTIONS(10421),
    [anon_sym_GT_GT] = ACTIONS(10421),
    [anon_sym_EQ_EQ] = ACTIONS(10419),
    [anon_sym_BANG_EQ] = ACTIONS(10423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10423),
    [anon_sym_LT_EQ_GT] = ACTIONS(10423),
    [anon_sym_EQ_TILDE] = ACTIONS(10423),
    [anon_sym_BANG_TILDE] = ACTIONS(10423),
    [anon_sym_LT_EQ] = ACTIONS(10411),
    [anon_sym_GT] = ACTIONS(10411),
    [anon_sym_GT_EQ] = ACTIONS(10425),
    [anon_sym_CARET] = ACTIONS(10405),
    [anon_sym_PLUS] = ACTIONS(10427),
    [anon_sym_SLASH] = ACTIONS(10407),
    [anon_sym_PERCENT] = ACTIONS(10407),
    [sym_comment] = ACTIONS(87),
  },
  [4192] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(6953),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [4193] = {
    [sym_string] = STATE(4222),
    [aux_sym_chained_string_repeat1] = STATE(4222),
    [sym__string_start] = ACTIONS(1141),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [4194] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(6872),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(4189),
    [sym_scope_resolution] = STATE(4187),
    [sym_call] = STATE(4187),
    [sym_method_call] = STATE(4189),
    [sym_assignment] = STATE(6872),
    [sym_operator_assignment] = STATE(6872),
    [sym_conditional] = STATE(6872),
    [sym_range] = STATE(6872),
    [sym_binary] = STATE(6872),
    [sym_unary] = STATE(6872),
    [sym_left_assignment_list] = STATE(4188),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4189),
    [sym__variable] = STATE(4187),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(4189),
    [sym_false] = STATE(4189),
    [sym_nil] = STATE(4189),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(4190),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(6913),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(6915),
    [anon_sym_yield] = ACTIONS(6917),
    [anon_sym_break] = ACTIONS(6919),
    [anon_sym_next] = ACTIONS(6921),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_defined_QMARK] = ACTIONS(6925),
    [anon_sym_not] = ACTIONS(6927),
    [anon_sym_BANG] = ACTIONS(6929),
    [anon_sym_TILDE] = ACTIONS(6929),
    [sym_constant] = ACTIONS(6931),
    [sym_identifier] = ACTIONS(6931),
    [sym_instance_variable] = ACTIONS(6933),
    [sym_class_variable] = ACTIONS(6933),
    [sym_global_variable] = ACTIONS(6933),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(6931),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6931),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [4195] = {
    [sym__heredoc_body_start] = ACTIONS(5735),
    [sym__binary_minus] = ACTIONS(5735),
    [sym__binary_star] = ACTIONS(5735),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_RBRACE] = ACTIONS(5735),
    [anon_sym_RPAREN] = ACTIONS(5735),
    [anon_sym_DOT] = ACTIONS(5737),
    [anon_sym_COMMA] = ACTIONS(5735),
    [anon_sym_PIPE] = ACTIONS(5737),
    [anon_sym_SEMI] = ACTIONS(5735),
    [anon_sym_STAR_STAR] = ACTIONS(5737),
    [anon_sym_AMP] = ACTIONS(5737),
    [anon_sym_EQ] = ACTIONS(5737),
    [anon_sym_LT] = ACTIONS(5737),
    [anon_sym_if] = ACTIONS(5735),
    [anon_sym_unless] = ACTIONS(5735),
    [anon_sym_while] = ACTIONS(5735),
    [anon_sym_until] = ACTIONS(5735),
    [anon_sym_rescue] = ACTIONS(5735),
    [anon_sym_do] = ACTIONS(993),
    [anon_sym_EQ_GT] = ACTIONS(993),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_RBRACK] = ACTIONS(5735),
    [anon_sym_COLON_COLON2] = ACTIONS(5735),
    [anon_sym_AMP_DOT] = ACTIONS(5735),
    [anon_sym_PLUS_EQ] = ACTIONS(5735),
    [anon_sym_DASH_EQ] = ACTIONS(5735),
    [anon_sym_STAR_EQ] = ACTIONS(5735),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5735),
    [anon_sym_SLASH_EQ] = ACTIONS(5735),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5735),
    [anon_sym_PIPE_EQ] = ACTIONS(5735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5735),
    [anon_sym_AMP_EQ] = ACTIONS(5735),
    [anon_sym_PERCENT_EQ] = ACTIONS(5735),
    [anon_sym_GT_GT_EQ] = ACTIONS(5735),
    [anon_sym_LT_LT_EQ] = ACTIONS(5735),
    [anon_sym_CARET_EQ] = ACTIONS(5735),
    [anon_sym_QMARK] = ACTIONS(5735),
    [anon_sym_COLON2] = ACTIONS(5737),
    [anon_sym_DOT_DOT] = ACTIONS(5737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5735),
    [anon_sym_and] = ACTIONS(5735),
    [anon_sym_or] = ACTIONS(5735),
    [anon_sym_PIPE_PIPE] = ACTIONS(5737),
    [anon_sym_AMP_AMP] = ACTIONS(5737),
    [anon_sym_LT_LT] = ACTIONS(5737),
    [anon_sym_GT_GT] = ACTIONS(5737),
    [anon_sym_EQ_EQ] = ACTIONS(5737),
    [anon_sym_BANG_EQ] = ACTIONS(5735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5735),
    [anon_sym_LT_EQ_GT] = ACTIONS(5735),
    [anon_sym_EQ_TILDE] = ACTIONS(5735),
    [anon_sym_BANG_TILDE] = ACTIONS(5735),
    [anon_sym_LT_EQ] = ACTIONS(5737),
    [anon_sym_GT] = ACTIONS(5737),
    [anon_sym_GT_EQ] = ACTIONS(5735),
    [anon_sym_CARET] = ACTIONS(5737),
    [anon_sym_PLUS] = ACTIONS(5737),
    [anon_sym_SLASH] = ACTIONS(5737),
    [anon_sym_PERCENT] = ACTIONS(5737),
    [sym_comment] = ACTIONS(87),
  },
  [4196] = {
    [anon_sym_RBRACE] = ACTIONS(10435),
    [sym_comment] = ACTIONS(87),
  },
  [4197] = {
    [sym__statements] = STATE(6874),
    [sym_begin_block] = STATE(489),
    [sym_end_block] = STATE(489),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(495),
    [aux_sym__statements_repeat1] = STATE(495),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(10435),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4198] = {
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(10401),
    [sym__binary_star] = ACTIONS(10403),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_RBRACE] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(10405),
    [anon_sym_STAR_STAR] = ACTIONS(10407),
    [anon_sym_AMP] = ACTIONS(10409),
    [anon_sym_EQ] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(10411),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_PLUS_EQ] = ACTIONS(3281),
    [anon_sym_DASH_EQ] = ACTIONS(3281),
    [anon_sym_STAR_EQ] = ACTIONS(3281),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3281),
    [anon_sym_SLASH_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3281),
    [anon_sym_AMP_EQ] = ACTIONS(3281),
    [anon_sym_PERCENT_EQ] = ACTIONS(3281),
    [anon_sym_GT_GT_EQ] = ACTIONS(3281),
    [anon_sym_LT_LT_EQ] = ACTIONS(3281),
    [anon_sym_CARET_EQ] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(10413),
    [anon_sym_DOT_DOT] = ACTIONS(10415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10417),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(10419),
    [anon_sym_AMP_AMP] = ACTIONS(10419),
    [anon_sym_LT_LT] = ACTIONS(10421),
    [anon_sym_GT_GT] = ACTIONS(10421),
    [anon_sym_EQ_EQ] = ACTIONS(10419),
    [anon_sym_BANG_EQ] = ACTIONS(10423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10423),
    [anon_sym_LT_EQ_GT] = ACTIONS(10423),
    [anon_sym_EQ_TILDE] = ACTIONS(10423),
    [anon_sym_BANG_TILDE] = ACTIONS(10423),
    [anon_sym_LT_EQ] = ACTIONS(10411),
    [anon_sym_GT] = ACTIONS(10411),
    [anon_sym_GT_EQ] = ACTIONS(10425),
    [anon_sym_CARET] = ACTIONS(10405),
    [anon_sym_PLUS] = ACTIONS(10427),
    [anon_sym_SLASH] = ACTIONS(10407),
    [anon_sym_PERCENT] = ACTIONS(10407),
    [sym_comment] = ACTIONS(87),
  },
  [4199] = {
    [sym__heredoc_body_start] = ACTIONS(5771),
    [sym__binary_minus] = ACTIONS(5771),
    [sym__binary_star] = ACTIONS(5771),
    [anon_sym_LBRACE] = ACTIONS(5771),
    [anon_sym_RBRACE] = ACTIONS(5771),
    [anon_sym_RPAREN] = ACTIONS(5771),
    [anon_sym_DOT] = ACTIONS(5773),
    [anon_sym_COMMA] = ACTIONS(5771),
    [anon_sym_PIPE] = ACTIONS(5773),
    [anon_sym_SEMI] = ACTIONS(5771),
    [anon_sym_STAR_STAR] = ACTIONS(5773),
    [anon_sym_AMP] = ACTIONS(5773),
    [anon_sym_EQ] = ACTIONS(5773),
    [anon_sym_LT] = ACTIONS(5773),
    [anon_sym_if] = ACTIONS(5771),
    [anon_sym_unless] = ACTIONS(5771),
    [anon_sym_while] = ACTIONS(5771),
    [anon_sym_until] = ACTIONS(5771),
    [anon_sym_rescue] = ACTIONS(5771),
    [anon_sym_in] = ACTIONS(5771),
    [anon_sym_do] = ACTIONS(5771),
    [anon_sym_LBRACK] = ACTIONS(5771),
    [anon_sym_RBRACK] = ACTIONS(5771),
    [anon_sym_COLON_COLON2] = ACTIONS(5771),
    [anon_sym_AMP_DOT] = ACTIONS(5771),
    [anon_sym_PLUS_EQ] = ACTIONS(5771),
    [anon_sym_DASH_EQ] = ACTIONS(5771),
    [anon_sym_STAR_EQ] = ACTIONS(5771),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5771),
    [anon_sym_SLASH_EQ] = ACTIONS(5771),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5771),
    [anon_sym_PIPE_EQ] = ACTIONS(5771),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5771),
    [anon_sym_AMP_EQ] = ACTIONS(5771),
    [anon_sym_PERCENT_EQ] = ACTIONS(5771),
    [anon_sym_GT_GT_EQ] = ACTIONS(5771),
    [anon_sym_LT_LT_EQ] = ACTIONS(5771),
    [anon_sym_CARET_EQ] = ACTIONS(5771),
    [anon_sym_QMARK] = ACTIONS(5771),
    [anon_sym_COLON2] = ACTIONS(5773),
    [anon_sym_DOT_DOT] = ACTIONS(5773),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5771),
    [anon_sym_and] = ACTIONS(5771),
    [anon_sym_or] = ACTIONS(5771),
    [anon_sym_PIPE_PIPE] = ACTIONS(5773),
    [anon_sym_AMP_AMP] = ACTIONS(5773),
    [anon_sym_LT_LT] = ACTIONS(5773),
    [anon_sym_GT_GT] = ACTIONS(5773),
    [anon_sym_EQ_EQ] = ACTIONS(5773),
    [anon_sym_BANG_EQ] = ACTIONS(5771),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5771),
    [anon_sym_LT_EQ_GT] = ACTIONS(5771),
    [anon_sym_EQ_TILDE] = ACTIONS(5771),
    [anon_sym_BANG_TILDE] = ACTIONS(5771),
    [anon_sym_LT_EQ] = ACTIONS(5773),
    [anon_sym_GT] = ACTIONS(5773),
    [anon_sym_GT_EQ] = ACTIONS(5771),
    [anon_sym_CARET] = ACTIONS(5773),
    [anon_sym_PLUS] = ACTIONS(5773),
    [anon_sym_SLASH] = ACTIONS(5773),
    [anon_sym_PERCENT] = ACTIONS(5773),
    [sym_comment] = ACTIONS(87),
  },
  [4200] = {
    [anon_sym_end] = ACTIONS(10437),
    [sym_comment] = ACTIONS(87),
  },
  [4201] = {
    [sym__statements] = STATE(6876),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_heredoc_body] = STATE(6877),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [sym__terminator] = STATE(6877),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__line_break] = ACTIONS(10439),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(10439),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10441),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4202] = {
    [sym__statements] = STATE(6876),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_block_parameters] = STATE(6878),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10441),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4203] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(6947),
    [sym__binary_star] = ACTIONS(6949),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(6951),
    [anon_sym_STAR_STAR] = ACTIONS(6953),
    [anon_sym_AMP] = ACTIONS(6955),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(6957),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(6959),
    [anon_sym_DOT_DOT] = ACTIONS(6961),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6963),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(6965),
    [anon_sym_AMP_AMP] = ACTIONS(6965),
    [anon_sym_LT_LT] = ACTIONS(6967),
    [anon_sym_GT_GT] = ACTIONS(6967),
    [anon_sym_EQ_EQ] = ACTIONS(6965),
    [anon_sym_BANG_EQ] = ACTIONS(6969),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6969),
    [anon_sym_LT_EQ_GT] = ACTIONS(6969),
    [anon_sym_EQ_TILDE] = ACTIONS(6969),
    [anon_sym_BANG_TILDE] = ACTIONS(6969),
    [anon_sym_LT_EQ] = ACTIONS(6957),
    [anon_sym_GT] = ACTIONS(6957),
    [anon_sym_GT_EQ] = ACTIONS(6971),
    [anon_sym_CARET] = ACTIONS(6951),
    [anon_sym_PLUS] = ACTIONS(6973),
    [anon_sym_SLASH] = ACTIONS(6953),
    [anon_sym_PERCENT] = ACTIONS(6953),
    [sym_comment] = ACTIONS(87),
  },
  [4204] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(6879),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(4189),
    [sym_scope_resolution] = STATE(4187),
    [sym_call] = STATE(4187),
    [sym_method_call] = STATE(4189),
    [sym_assignment] = STATE(6879),
    [sym_operator_assignment] = STATE(6879),
    [sym_conditional] = STATE(6879),
    [sym_range] = STATE(6879),
    [sym_binary] = STATE(6879),
    [sym_unary] = STATE(6879),
    [sym_left_assignment_list] = STATE(4188),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4189),
    [sym__variable] = STATE(4187),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(4189),
    [sym_false] = STATE(4189),
    [sym_nil] = STATE(4189),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(4190),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(6913),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(6915),
    [anon_sym_yield] = ACTIONS(6917),
    [anon_sym_break] = ACTIONS(6919),
    [anon_sym_next] = ACTIONS(6921),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_defined_QMARK] = ACTIONS(6925),
    [anon_sym_not] = ACTIONS(6927),
    [anon_sym_BANG] = ACTIONS(6929),
    [anon_sym_TILDE] = ACTIONS(6929),
    [sym_constant] = ACTIONS(6931),
    [sym_identifier] = ACTIONS(6931),
    [sym_instance_variable] = ACTIONS(6933),
    [sym_class_variable] = ACTIONS(6933),
    [sym_global_variable] = ACTIONS(6933),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(6931),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6931),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [4205] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6880),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1851),
    [sym_scope_resolution] = STATE(1845),
    [sym_call] = STATE(1845),
    [sym_method_call] = STATE(1851),
    [sym_assignment] = STATE(6880),
    [sym_operator_assignment] = STATE(6880),
    [sym_conditional] = STATE(6880),
    [sym_range] = STATE(6880),
    [sym_binary] = STATE(6880),
    [sym_unary] = STATE(6880),
    [sym_left_assignment_list] = STATE(1850),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1851),
    [sym__variable] = STATE(1845),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1851),
    [sym_false] = STATE(1851),
    [sym_nil] = STATE(1851),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4193),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3323),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3329),
    [anon_sym_yield] = ACTIONS(3331),
    [anon_sym_break] = ACTIONS(3333),
    [anon_sym_next] = ACTIONS(3335),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6935),
    [anon_sym_defined_QMARK] = ACTIONS(3339),
    [anon_sym_not] = ACTIONS(3341),
    [anon_sym_BANG] = ACTIONS(3345),
    [anon_sym_TILDE] = ACTIONS(3345),
    [sym_constant] = ACTIONS(3351),
    [sym_identifier] = ACTIONS(3351),
    [sym_instance_variable] = ACTIONS(3349),
    [sym_class_variable] = ACTIONS(3349),
    [sym_global_variable] = ACTIONS(3349),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3351),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3351),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4206] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6881),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1851),
    [sym_scope_resolution] = STATE(1845),
    [sym_call] = STATE(1845),
    [sym_method_call] = STATE(1851),
    [sym_assignment] = STATE(6881),
    [sym_operator_assignment] = STATE(6881),
    [sym_conditional] = STATE(6881),
    [sym_range] = STATE(6881),
    [sym_binary] = STATE(6881),
    [sym_unary] = STATE(6881),
    [sym_left_assignment_list] = STATE(1850),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1851),
    [sym__variable] = STATE(1845),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1851),
    [sym_false] = STATE(1851),
    [sym_nil] = STATE(1851),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4193),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3323),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3329),
    [anon_sym_yield] = ACTIONS(3331),
    [anon_sym_break] = ACTIONS(3333),
    [anon_sym_next] = ACTIONS(3335),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6935),
    [anon_sym_defined_QMARK] = ACTIONS(3339),
    [anon_sym_not] = ACTIONS(3341),
    [anon_sym_BANG] = ACTIONS(3345),
    [anon_sym_TILDE] = ACTIONS(3345),
    [sym_constant] = ACTIONS(3351),
    [sym_identifier] = ACTIONS(3351),
    [sym_instance_variable] = ACTIONS(3349),
    [sym_class_variable] = ACTIONS(3349),
    [sym_global_variable] = ACTIONS(3349),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3351),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3351),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4207] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6882),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1851),
    [sym_scope_resolution] = STATE(1845),
    [sym_call] = STATE(1845),
    [sym_method_call] = STATE(1851),
    [sym_assignment] = STATE(6882),
    [sym_operator_assignment] = STATE(6882),
    [sym_conditional] = STATE(6882),
    [sym_range] = STATE(6882),
    [sym_binary] = STATE(6882),
    [sym_unary] = STATE(6882),
    [sym_left_assignment_list] = STATE(1850),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1851),
    [sym__variable] = STATE(1845),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1851),
    [sym_false] = STATE(1851),
    [sym_nil] = STATE(1851),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4193),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3323),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3329),
    [anon_sym_yield] = ACTIONS(3331),
    [anon_sym_break] = ACTIONS(3333),
    [anon_sym_next] = ACTIONS(3335),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6935),
    [anon_sym_defined_QMARK] = ACTIONS(3339),
    [anon_sym_not] = ACTIONS(3341),
    [anon_sym_BANG] = ACTIONS(3345),
    [anon_sym_TILDE] = ACTIONS(3345),
    [sym_constant] = ACTIONS(3351),
    [sym_identifier] = ACTIONS(3351),
    [sym_instance_variable] = ACTIONS(3349),
    [sym_class_variable] = ACTIONS(3349),
    [sym_global_variable] = ACTIONS(3349),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3351),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3351),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4208] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6883),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1851),
    [sym_scope_resolution] = STATE(1845),
    [sym_call] = STATE(1845),
    [sym_method_call] = STATE(1851),
    [sym_assignment] = STATE(6883),
    [sym_operator_assignment] = STATE(6883),
    [sym_conditional] = STATE(6883),
    [sym_range] = STATE(6883),
    [sym_binary] = STATE(6883),
    [sym_unary] = STATE(6883),
    [sym_left_assignment_list] = STATE(1850),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1851),
    [sym__variable] = STATE(1845),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1851),
    [sym_false] = STATE(1851),
    [sym_nil] = STATE(1851),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4193),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3323),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3329),
    [anon_sym_yield] = ACTIONS(3331),
    [anon_sym_break] = ACTIONS(3333),
    [anon_sym_next] = ACTIONS(3335),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6935),
    [anon_sym_defined_QMARK] = ACTIONS(3339),
    [anon_sym_not] = ACTIONS(3341),
    [anon_sym_BANG] = ACTIONS(3345),
    [anon_sym_TILDE] = ACTIONS(3345),
    [sym_constant] = ACTIONS(3351),
    [sym_identifier] = ACTIONS(3351),
    [sym_instance_variable] = ACTIONS(3349),
    [sym_class_variable] = ACTIONS(3349),
    [sym_global_variable] = ACTIONS(3349),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3351),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3351),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4209] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6884),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1851),
    [sym_scope_resolution] = STATE(1845),
    [sym_call] = STATE(1845),
    [sym_method_call] = STATE(1851),
    [sym_assignment] = STATE(6884),
    [sym_operator_assignment] = STATE(6884),
    [sym_conditional] = STATE(6884),
    [sym_range] = STATE(6884),
    [sym_binary] = STATE(6884),
    [sym_unary] = STATE(6884),
    [sym_left_assignment_list] = STATE(1850),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1851),
    [sym__variable] = STATE(1845),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1851),
    [sym_false] = STATE(1851),
    [sym_nil] = STATE(1851),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4193),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3323),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3329),
    [anon_sym_yield] = ACTIONS(3331),
    [anon_sym_break] = ACTIONS(3333),
    [anon_sym_next] = ACTIONS(3335),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6935),
    [anon_sym_defined_QMARK] = ACTIONS(3339),
    [anon_sym_not] = ACTIONS(3341),
    [anon_sym_BANG] = ACTIONS(3345),
    [anon_sym_TILDE] = ACTIONS(3345),
    [sym_constant] = ACTIONS(3351),
    [sym_identifier] = ACTIONS(3351),
    [sym_instance_variable] = ACTIONS(3349),
    [sym_class_variable] = ACTIONS(3349),
    [sym_global_variable] = ACTIONS(3349),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3351),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3351),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4210] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(6885),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(6885),
    [sym_operator_assignment] = STATE(6885),
    [sym_conditional] = STATE(6885),
    [sym_range] = STATE(6885),
    [sym_binary] = STATE(6885),
    [sym_unary] = STATE(6885),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4211] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6886),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1851),
    [sym_scope_resolution] = STATE(1845),
    [sym_call] = STATE(1845),
    [sym_method_call] = STATE(1851),
    [sym_assignment] = STATE(6886),
    [sym_operator_assignment] = STATE(6886),
    [sym_conditional] = STATE(6886),
    [sym_range] = STATE(6886),
    [sym_binary] = STATE(6886),
    [sym_unary] = STATE(6886),
    [sym_left_assignment_list] = STATE(1850),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1851),
    [sym__variable] = STATE(1845),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1851),
    [sym_false] = STATE(1851),
    [sym_nil] = STATE(1851),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4193),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3323),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3329),
    [anon_sym_yield] = ACTIONS(3331),
    [anon_sym_break] = ACTIONS(3333),
    [anon_sym_next] = ACTIONS(3335),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6935),
    [anon_sym_defined_QMARK] = ACTIONS(3339),
    [anon_sym_not] = ACTIONS(3341),
    [anon_sym_BANG] = ACTIONS(3345),
    [anon_sym_TILDE] = ACTIONS(3345),
    [sym_constant] = ACTIONS(3351),
    [sym_identifier] = ACTIONS(3351),
    [sym_instance_variable] = ACTIONS(3349),
    [sym_class_variable] = ACTIONS(3349),
    [sym_global_variable] = ACTIONS(3349),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3351),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3351),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4212] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6887),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1851),
    [sym_scope_resolution] = STATE(1845),
    [sym_call] = STATE(1845),
    [sym_method_call] = STATE(1851),
    [sym_assignment] = STATE(6887),
    [sym_operator_assignment] = STATE(6887),
    [sym_conditional] = STATE(6887),
    [sym_range] = STATE(6887),
    [sym_binary] = STATE(6887),
    [sym_unary] = STATE(6887),
    [sym_left_assignment_list] = STATE(1850),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1851),
    [sym__variable] = STATE(1845),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1851),
    [sym_false] = STATE(1851),
    [sym_nil] = STATE(1851),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4193),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3323),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3329),
    [anon_sym_yield] = ACTIONS(3331),
    [anon_sym_break] = ACTIONS(3333),
    [anon_sym_next] = ACTIONS(3335),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6935),
    [anon_sym_defined_QMARK] = ACTIONS(3339),
    [anon_sym_not] = ACTIONS(3341),
    [anon_sym_BANG] = ACTIONS(3345),
    [anon_sym_TILDE] = ACTIONS(3345),
    [sym_constant] = ACTIONS(3351),
    [sym_identifier] = ACTIONS(3351),
    [sym_instance_variable] = ACTIONS(3349),
    [sym_class_variable] = ACTIONS(3349),
    [sym_global_variable] = ACTIONS(3349),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3351),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3351),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4213] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6888),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1851),
    [sym_scope_resolution] = STATE(1845),
    [sym_call] = STATE(1845),
    [sym_method_call] = STATE(1851),
    [sym_assignment] = STATE(6888),
    [sym_operator_assignment] = STATE(6888),
    [sym_conditional] = STATE(6888),
    [sym_range] = STATE(6888),
    [sym_binary] = STATE(6888),
    [sym_unary] = STATE(6888),
    [sym_left_assignment_list] = STATE(1850),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1851),
    [sym__variable] = STATE(1845),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1851),
    [sym_false] = STATE(1851),
    [sym_nil] = STATE(1851),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4193),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3323),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3329),
    [anon_sym_yield] = ACTIONS(3331),
    [anon_sym_break] = ACTIONS(3333),
    [anon_sym_next] = ACTIONS(3335),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6935),
    [anon_sym_defined_QMARK] = ACTIONS(3339),
    [anon_sym_not] = ACTIONS(3341),
    [anon_sym_BANG] = ACTIONS(3345),
    [anon_sym_TILDE] = ACTIONS(3345),
    [sym_constant] = ACTIONS(3351),
    [sym_identifier] = ACTIONS(3351),
    [sym_instance_variable] = ACTIONS(3349),
    [sym_class_variable] = ACTIONS(3349),
    [sym_global_variable] = ACTIONS(3349),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3351),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3351),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4214] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6889),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1851),
    [sym_scope_resolution] = STATE(1845),
    [sym_call] = STATE(1845),
    [sym_method_call] = STATE(1851),
    [sym_assignment] = STATE(6889),
    [sym_operator_assignment] = STATE(6889),
    [sym_conditional] = STATE(6889),
    [sym_range] = STATE(6889),
    [sym_binary] = STATE(6889),
    [sym_unary] = STATE(6889),
    [sym_left_assignment_list] = STATE(1850),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1851),
    [sym__variable] = STATE(1845),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1851),
    [sym_false] = STATE(1851),
    [sym_nil] = STATE(1851),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4193),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3323),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3329),
    [anon_sym_yield] = ACTIONS(3331),
    [anon_sym_break] = ACTIONS(3333),
    [anon_sym_next] = ACTIONS(3335),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6935),
    [anon_sym_defined_QMARK] = ACTIONS(3339),
    [anon_sym_not] = ACTIONS(3341),
    [anon_sym_BANG] = ACTIONS(3345),
    [anon_sym_TILDE] = ACTIONS(3345),
    [sym_constant] = ACTIONS(3351),
    [sym_identifier] = ACTIONS(3351),
    [sym_instance_variable] = ACTIONS(3349),
    [sym_class_variable] = ACTIONS(3349),
    [sym_global_variable] = ACTIONS(3349),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3351),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3351),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4215] = {
    [sym__statements] = STATE(4196),
    [sym_begin_block] = STATE(489),
    [sym_end_block] = STATE(489),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_block_parameters] = STATE(4197),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(495),
    [aux_sym__statements_repeat1] = STATE(495),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(10443),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2445),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4216] = {
    [sym__heredoc_body_start] = ACTIONS(6155),
    [sym__binary_minus] = ACTIONS(6155),
    [sym__binary_star] = ACTIONS(6155),
    [anon_sym_LBRACE] = ACTIONS(6155),
    [anon_sym_RBRACE] = ACTIONS(6155),
    [anon_sym_RPAREN] = ACTIONS(6155),
    [anon_sym_DOT] = ACTIONS(6157),
    [anon_sym_COMMA] = ACTIONS(6155),
    [anon_sym_PIPE] = ACTIONS(6157),
    [anon_sym_SEMI] = ACTIONS(6155),
    [anon_sym_STAR_STAR] = ACTIONS(6157),
    [anon_sym_AMP] = ACTIONS(6157),
    [anon_sym_EQ] = ACTIONS(6157),
    [anon_sym_LT] = ACTIONS(6157),
    [anon_sym_if] = ACTIONS(6155),
    [anon_sym_unless] = ACTIONS(6155),
    [anon_sym_while] = ACTIONS(6155),
    [anon_sym_until] = ACTIONS(6155),
    [anon_sym_rescue] = ACTIONS(6155),
    [anon_sym_in] = ACTIONS(6155),
    [anon_sym_do] = ACTIONS(6155),
    [anon_sym_LBRACK] = ACTIONS(6155),
    [anon_sym_RBRACK] = ACTIONS(6155),
    [anon_sym_COLON_COLON2] = ACTIONS(6155),
    [anon_sym_AMP_DOT] = ACTIONS(6155),
    [anon_sym_PLUS_EQ] = ACTIONS(6155),
    [anon_sym_DASH_EQ] = ACTIONS(6155),
    [anon_sym_STAR_EQ] = ACTIONS(6155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6155),
    [anon_sym_SLASH_EQ] = ACTIONS(6155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6155),
    [anon_sym_PIPE_EQ] = ACTIONS(6155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6155),
    [anon_sym_AMP_EQ] = ACTIONS(6155),
    [anon_sym_PERCENT_EQ] = ACTIONS(6155),
    [anon_sym_GT_GT_EQ] = ACTIONS(6155),
    [anon_sym_LT_LT_EQ] = ACTIONS(6155),
    [anon_sym_CARET_EQ] = ACTIONS(6155),
    [anon_sym_QMARK] = ACTIONS(6155),
    [anon_sym_COLON2] = ACTIONS(6157),
    [anon_sym_DOT_DOT] = ACTIONS(6157),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6155),
    [anon_sym_and] = ACTIONS(6155),
    [anon_sym_or] = ACTIONS(6155),
    [anon_sym_PIPE_PIPE] = ACTIONS(6157),
    [anon_sym_AMP_AMP] = ACTIONS(6157),
    [anon_sym_LT_LT] = ACTIONS(6157),
    [anon_sym_GT_GT] = ACTIONS(6157),
    [anon_sym_EQ_EQ] = ACTIONS(6157),
    [anon_sym_BANG_EQ] = ACTIONS(6155),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6155),
    [anon_sym_LT_EQ_GT] = ACTIONS(6155),
    [anon_sym_EQ_TILDE] = ACTIONS(6155),
    [anon_sym_BANG_TILDE] = ACTIONS(6155),
    [anon_sym_LT_EQ] = ACTIONS(6157),
    [anon_sym_GT] = ACTIONS(6157),
    [anon_sym_GT_EQ] = ACTIONS(6155),
    [anon_sym_CARET] = ACTIONS(6157),
    [anon_sym_PLUS] = ACTIONS(6157),
    [anon_sym_SLASH] = ACTIONS(6157),
    [anon_sym_PERCENT] = ACTIONS(6157),
    [sym_comment] = ACTIONS(87),
  },
  [4217] = {
    [sym_heredoc_body] = STATE(6891),
    [aux_sym_call_repeat1] = STATE(6891),
    [sym__heredoc_body_start] = ACTIONS(6569),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_RBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [4218] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1844),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1851),
    [sym_scope_resolution] = STATE(1845),
    [sym_call] = STATE(1845),
    [sym_method_call] = STATE(1851),
    [sym__argument] = STATE(6674),
    [sym_splat_argument] = STATE(6674),
    [sym_hash_splat_argument] = STATE(6674),
    [sym_block_argument] = STATE(6674),
    [sym_assignment] = STATE(1844),
    [sym_operator_assignment] = STATE(1844),
    [sym_conditional] = STATE(1844),
    [sym_range] = STATE(1844),
    [sym_binary] = STATE(1844),
    [sym_unary] = STATE(1844),
    [sym_left_assignment_list] = STATE(1850),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1851),
    [sym__variable] = STATE(1845),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1851),
    [sym_false] = STATE(1851),
    [sym_nil] = STATE(1851),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1852),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_heredoc_body] = STATE(6892),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(6674),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(3319),
    [sym__splat_star] = ACTIONS(3321),
    [sym__unary_minus] = ACTIONS(3323),
    [sym__identifier_hash_key] = ACTIONS(3325),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10445),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3329),
    [anon_sym_yield] = ACTIONS(3331),
    [anon_sym_break] = ACTIONS(3333),
    [anon_sym_next] = ACTIONS(3335),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6935),
    [anon_sym_defined_QMARK] = ACTIONS(3339),
    [anon_sym_not] = ACTIONS(3341),
    [anon_sym_BANG] = ACTIONS(3345),
    [anon_sym_TILDE] = ACTIONS(3345),
    [sym_constant] = ACTIONS(3347),
    [sym_identifier] = ACTIONS(3347),
    [sym_instance_variable] = ACTIONS(3349),
    [sym_class_variable] = ACTIONS(3349),
    [sym_global_variable] = ACTIONS(3349),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3351),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3351),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4219] = {
    [sym_heredoc_body] = STATE(6893),
    [aux_sym_call_repeat1] = STATE(6893),
    [aux_sym_argument_list_repeat1] = STATE(6894),
    [sym__heredoc_body_start] = ACTIONS(6569),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_RBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(6979),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [4220] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6895),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1851),
    [sym_scope_resolution] = STATE(1845),
    [sym_call] = STATE(1845),
    [sym_method_call] = STATE(1851),
    [sym_splat_argument] = STATE(6896),
    [sym_assignment] = STATE(6895),
    [sym_operator_assignment] = STATE(6895),
    [sym_conditional] = STATE(6895),
    [sym_range] = STATE(6895),
    [sym_binary] = STATE(6895),
    [sym_unary] = STATE(6895),
    [sym_right_assignment_list] = STATE(4362),
    [sym__arg_or_splat_arg] = STATE(6896),
    [sym_left_assignment_list] = STATE(1850),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1851),
    [sym__variable] = STATE(1845),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1851),
    [sym_false] = STATE(1851),
    [sym_nil] = STATE(1851),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4193),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__splat_star] = ACTIONS(6885),
    [sym__unary_minus] = ACTIONS(3323),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3329),
    [anon_sym_yield] = ACTIONS(3331),
    [anon_sym_break] = ACTIONS(3333),
    [anon_sym_next] = ACTIONS(3335),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6935),
    [anon_sym_defined_QMARK] = ACTIONS(3339),
    [anon_sym_not] = ACTIONS(3341),
    [anon_sym_BANG] = ACTIONS(3345),
    [anon_sym_TILDE] = ACTIONS(3345),
    [sym_constant] = ACTIONS(3351),
    [sym_identifier] = ACTIONS(3351),
    [sym_instance_variable] = ACTIONS(3349),
    [sym_class_variable] = ACTIONS(3349),
    [sym_global_variable] = ACTIONS(3349),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3351),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3351),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4221] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6897),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1851),
    [sym_scope_resolution] = STATE(1845),
    [sym_call] = STATE(1845),
    [sym_method_call] = STATE(1851),
    [sym_assignment] = STATE(6897),
    [sym_operator_assignment] = STATE(6897),
    [sym_conditional] = STATE(6897),
    [sym_range] = STATE(6897),
    [sym_binary] = STATE(6897),
    [sym_unary] = STATE(6897),
    [sym_left_assignment_list] = STATE(1850),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1851),
    [sym__variable] = STATE(1845),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1851),
    [sym_false] = STATE(1851),
    [sym_nil] = STATE(1851),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4193),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3323),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3329),
    [anon_sym_yield] = ACTIONS(3331),
    [anon_sym_break] = ACTIONS(3333),
    [anon_sym_next] = ACTIONS(3335),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6935),
    [anon_sym_defined_QMARK] = ACTIONS(3339),
    [anon_sym_not] = ACTIONS(3341),
    [anon_sym_BANG] = ACTIONS(3345),
    [anon_sym_TILDE] = ACTIONS(3345),
    [sym_constant] = ACTIONS(3351),
    [sym_identifier] = ACTIONS(3351),
    [sym_instance_variable] = ACTIONS(3349),
    [sym_class_variable] = ACTIONS(3349),
    [sym_global_variable] = ACTIONS(3349),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3351),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3351),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4222] = {
    [sym_string] = STATE(6898),
    [aux_sym_chained_string_repeat1] = STATE(6898),
    [sym__string_start] = ACTIONS(1141),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_RBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_STAR_STAR] = ACTIONS(2755),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_EQ] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_EQ_GT] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_PLUS_EQ] = ACTIONS(2753),
    [anon_sym_DASH_EQ] = ACTIONS(2753),
    [anon_sym_STAR_EQ] = ACTIONS(2753),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2753),
    [anon_sym_SLASH_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2753),
    [anon_sym_AMP_EQ] = ACTIONS(2753),
    [anon_sym_PERCENT_EQ] = ACTIONS(2753),
    [anon_sym_GT_GT_EQ] = ACTIONS(2753),
    [anon_sym_LT_LT_EQ] = ACTIONS(2753),
    [anon_sym_CARET_EQ] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2755),
    [anon_sym_AMP_AMP] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2755),
    [anon_sym_GT_GT] = ACTIONS(2755),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_SLASH] = ACTIONS(2755),
    [anon_sym_PERCENT] = ACTIONS(2755),
    [sym_comment] = ACTIONS(87),
  },
  [4223] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(6899),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(541),
    [sym_scope_resolution] = STATE(539),
    [sym_call] = STATE(539),
    [sym_method_call] = STATE(541),
    [sym_assignment] = STATE(6899),
    [sym_operator_assignment] = STATE(6899),
    [sym_conditional] = STATE(6899),
    [sym_range] = STATE(6899),
    [sym_binary] = STATE(6899),
    [sym_unary] = STATE(6899),
    [sym_left_assignment_list] = STATE(540),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(541),
    [sym__variable] = STATE(539),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(541),
    [sym_false] = STATE(541),
    [sym_nil] = STATE(541),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(542),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1021),
    [anon_sym_defined_QMARK] = ACTIONS(1023),
    [anon_sym_not] = ACTIONS(1025),
    [anon_sym_BANG] = ACTIONS(1027),
    [anon_sym_TILDE] = ACTIONS(1027),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4224] = {
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(3283),
    [sym__binary_star] = ACTIONS(3285),
    [anon_sym_RBRACE] = ACTIONS(5115),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(3287),
    [anon_sym_STAR_STAR] = ACTIONS(3285),
    [anon_sym_AMP] = ACTIONS(3289),
    [anon_sym_LT] = ACTIONS(3291),
    [anon_sym_QMARK] = ACTIONS(3293),
    [anon_sym_DOT_DOT] = ACTIONS(3295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3297),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(3301),
    [anon_sym_AMP_AMP] = ACTIONS(3301),
    [anon_sym_LT_LT] = ACTIONS(3303),
    [anon_sym_GT_GT] = ACTIONS(3303),
    [anon_sym_EQ_EQ] = ACTIONS(3305),
    [anon_sym_BANG_EQ] = ACTIONS(3301),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3301),
    [anon_sym_LT_EQ_GT] = ACTIONS(3301),
    [anon_sym_EQ_TILDE] = ACTIONS(3301),
    [anon_sym_BANG_TILDE] = ACTIONS(3301),
    [anon_sym_LT_EQ] = ACTIONS(3291),
    [anon_sym_GT] = ACTIONS(3291),
    [anon_sym_GT_EQ] = ACTIONS(3307),
    [anon_sym_CARET] = ACTIONS(3309),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_SLASH] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [sym_comment] = ACTIONS(87),
  },
  [4225] = {
    [aux_sym_exceptions_repeat1] = STATE(6901),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_RBRACE] = ACTIONS(6191),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [4226] = {
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(3283),
    [sym__binary_star] = ACTIONS(3285),
    [anon_sym_RBRACE] = ACTIONS(6210),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(3287),
    [anon_sym_STAR_STAR] = ACTIONS(3285),
    [anon_sym_AMP] = ACTIONS(3289),
    [anon_sym_LT] = ACTIONS(3291),
    [anon_sym_QMARK] = ACTIONS(3293),
    [anon_sym_DOT_DOT] = ACTIONS(3295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3297),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(3301),
    [anon_sym_AMP_AMP] = ACTIONS(3301),
    [anon_sym_LT_LT] = ACTIONS(3303),
    [anon_sym_GT_GT] = ACTIONS(3303),
    [anon_sym_EQ_EQ] = ACTIONS(3305),
    [anon_sym_BANG_EQ] = ACTIONS(3301),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3301),
    [anon_sym_LT_EQ_GT] = ACTIONS(3301),
    [anon_sym_EQ_TILDE] = ACTIONS(3301),
    [anon_sym_BANG_TILDE] = ACTIONS(3301),
    [anon_sym_LT_EQ] = ACTIONS(3291),
    [anon_sym_GT] = ACTIONS(3291),
    [anon_sym_GT_EQ] = ACTIONS(3307),
    [anon_sym_CARET] = ACTIONS(3309),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_SLASH] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [sym_comment] = ACTIONS(87),
  },
  [4227] = {
    [sym_string] = STATE(4227),
    [aux_sym_chained_string_repeat1] = STATE(4227),
    [sym__string_start] = ACTIONS(9407),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_RBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [4228] = {
    [sym__statements] = STATE(579),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(580),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(581),
    [sym_rescue] = STATE(582),
    [sym__body_statement] = STATE(6902),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10447),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4229] = {
    [sym__statements] = STATE(579),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(580),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(581),
    [sym_rescue] = STATE(582),
    [sym__body_statement] = STATE(6903),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10449),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4230] = {
    [sym__binary_minus] = ACTIONS(7764),
    [sym__binary_star] = ACTIONS(7764),
    [anon_sym_LBRACE] = ACTIONS(7764),
    [anon_sym_RBRACE] = ACTIONS(7764),
    [anon_sym_RPAREN] = ACTIONS(7764),
    [anon_sym_DOT] = ACTIONS(7766),
    [anon_sym_COMMA] = ACTIONS(7764),
    [anon_sym_PIPE] = ACTIONS(7766),
    [anon_sym_SEMI] = ACTIONS(7764),
    [anon_sym_STAR_STAR] = ACTIONS(7764),
    [anon_sym_AMP] = ACTIONS(7766),
    [anon_sym_LT] = ACTIONS(7766),
    [anon_sym_if] = ACTIONS(7764),
    [anon_sym_unless] = ACTIONS(7764),
    [anon_sym_while] = ACTIONS(7764),
    [anon_sym_until] = ACTIONS(7764),
    [anon_sym_rescue] = ACTIONS(7764),
    [anon_sym_do] = ACTIONS(7764),
    [anon_sym_EQ_GT] = ACTIONS(7764),
    [anon_sym_LBRACK] = ACTIONS(7764),
    [anon_sym_COLON_COLON2] = ACTIONS(7764),
    [anon_sym_AMP_DOT] = ACTIONS(7764),
    [anon_sym_QMARK] = ACTIONS(7764),
    [anon_sym_COLON2] = ACTIONS(7766),
    [anon_sym_DOT_DOT] = ACTIONS(7766),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7764),
    [anon_sym_and] = ACTIONS(7764),
    [anon_sym_or] = ACTIONS(7764),
    [anon_sym_PIPE_PIPE] = ACTIONS(7764),
    [anon_sym_AMP_AMP] = ACTIONS(7764),
    [anon_sym_LT_LT] = ACTIONS(7764),
    [anon_sym_GT_GT] = ACTIONS(7764),
    [anon_sym_EQ_EQ] = ACTIONS(7766),
    [anon_sym_BANG_EQ] = ACTIONS(7764),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7764),
    [anon_sym_LT_EQ_GT] = ACTIONS(7764),
    [anon_sym_EQ_TILDE] = ACTIONS(7764),
    [anon_sym_BANG_TILDE] = ACTIONS(7764),
    [anon_sym_LT_EQ] = ACTIONS(7766),
    [anon_sym_GT] = ACTIONS(7766),
    [anon_sym_GT_EQ] = ACTIONS(7764),
    [anon_sym_CARET] = ACTIONS(7764),
    [anon_sym_PLUS] = ACTIONS(7764),
    [anon_sym_SLASH] = ACTIONS(7764),
    [anon_sym_PERCENT] = ACTIONS(7764),
    [sym_comment] = ACTIONS(87),
  },
  [4231] = {
    [sym__binary_minus] = ACTIONS(7818),
    [sym__binary_star] = ACTIONS(7818),
    [anon_sym_LBRACE] = ACTIONS(7818),
    [anon_sym_RBRACE] = ACTIONS(7818),
    [anon_sym_RPAREN] = ACTIONS(7818),
    [anon_sym_DOT] = ACTIONS(7820),
    [anon_sym_COMMA] = ACTIONS(7818),
    [anon_sym_PIPE] = ACTIONS(7820),
    [anon_sym_SEMI] = ACTIONS(7818),
    [anon_sym_STAR_STAR] = ACTIONS(7818),
    [anon_sym_AMP] = ACTIONS(7820),
    [anon_sym_LT] = ACTIONS(7820),
    [anon_sym_if] = ACTIONS(7818),
    [anon_sym_unless] = ACTIONS(7818),
    [anon_sym_while] = ACTIONS(7818),
    [anon_sym_until] = ACTIONS(7818),
    [anon_sym_rescue] = ACTIONS(7818),
    [anon_sym_do] = ACTIONS(7818),
    [anon_sym_EQ_GT] = ACTIONS(7818),
    [anon_sym_LBRACK] = ACTIONS(7818),
    [anon_sym_COLON_COLON2] = ACTIONS(7818),
    [anon_sym_AMP_DOT] = ACTIONS(7818),
    [anon_sym_QMARK] = ACTIONS(7818),
    [anon_sym_COLON2] = ACTIONS(7820),
    [anon_sym_DOT_DOT] = ACTIONS(7820),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7818),
    [anon_sym_and] = ACTIONS(7818),
    [anon_sym_or] = ACTIONS(7818),
    [anon_sym_PIPE_PIPE] = ACTIONS(7818),
    [anon_sym_AMP_AMP] = ACTIONS(7818),
    [anon_sym_LT_LT] = ACTIONS(7818),
    [anon_sym_GT_GT] = ACTIONS(7818),
    [anon_sym_EQ_EQ] = ACTIONS(7820),
    [anon_sym_BANG_EQ] = ACTIONS(7818),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7818),
    [anon_sym_LT_EQ_GT] = ACTIONS(7818),
    [anon_sym_EQ_TILDE] = ACTIONS(7818),
    [anon_sym_BANG_TILDE] = ACTIONS(7818),
    [anon_sym_LT_EQ] = ACTIONS(7820),
    [anon_sym_GT] = ACTIONS(7820),
    [anon_sym_GT_EQ] = ACTIONS(7818),
    [anon_sym_CARET] = ACTIONS(7818),
    [anon_sym_PLUS] = ACTIONS(7818),
    [anon_sym_SLASH] = ACTIONS(7818),
    [anon_sym_PERCENT] = ACTIONS(7818),
    [sym_comment] = ACTIONS(87),
  },
  [4232] = {
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(3371),
    [sym__binary_star] = ACTIONS(3373),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(3375),
    [anon_sym_STAR_STAR] = ACTIONS(3373),
    [anon_sym_AMP] = ACTIONS(3377),
    [anon_sym_LT] = ACTIONS(3379),
    [anon_sym_EQ_GT] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(3381),
    [anon_sym_DOT_DOT] = ACTIONS(3383),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3385),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(3387),
    [anon_sym_AMP_AMP] = ACTIONS(3387),
    [anon_sym_LT_LT] = ACTIONS(3389),
    [anon_sym_GT_GT] = ACTIONS(3389),
    [anon_sym_EQ_EQ] = ACTIONS(3391),
    [anon_sym_BANG_EQ] = ACTIONS(3387),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3387),
    [anon_sym_LT_EQ_GT] = ACTIONS(3387),
    [anon_sym_EQ_TILDE] = ACTIONS(3387),
    [anon_sym_BANG_TILDE] = ACTIONS(3387),
    [anon_sym_LT_EQ] = ACTIONS(3379),
    [anon_sym_GT] = ACTIONS(3379),
    [anon_sym_GT_EQ] = ACTIONS(3393),
    [anon_sym_CARET] = ACTIONS(3395),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_SLASH] = ACTIONS(3373),
    [anon_sym_PERCENT] = ACTIONS(3373),
    [sym_comment] = ACTIONS(87),
  },
  [4233] = {
    [sym_heredoc_body] = STATE(6904),
    [aux_sym_call_repeat1] = STATE(6904),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [4234] = {
    [sym_heredoc_body] = STATE(6905),
    [aux_sym_call_repeat1] = STATE(6905),
    [aux_sym_argument_list_repeat1] = STATE(4253),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(3399),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [4235] = {
    [sym__heredoc_body_start] = ACTIONS(7876),
    [sym__binary_minus] = ACTIONS(7876),
    [sym__binary_star] = ACTIONS(7876),
    [anon_sym_LBRACE] = ACTIONS(7876),
    [anon_sym_RBRACE] = ACTIONS(7876),
    [anon_sym_RPAREN] = ACTIONS(7876),
    [anon_sym_DOT] = ACTIONS(7878),
    [anon_sym_COMMA] = ACTIONS(7876),
    [anon_sym_PIPE] = ACTIONS(7878),
    [anon_sym_SEMI] = ACTIONS(7876),
    [anon_sym_STAR_STAR] = ACTIONS(7876),
    [anon_sym_AMP] = ACTIONS(7878),
    [anon_sym_EQ] = ACTIONS(7878),
    [anon_sym_LT] = ACTIONS(7878),
    [anon_sym_if] = ACTIONS(7876),
    [anon_sym_unless] = ACTIONS(7876),
    [anon_sym_while] = ACTIONS(7876),
    [anon_sym_until] = ACTIONS(7876),
    [anon_sym_rescue] = ACTIONS(7876),
    [anon_sym_in] = ACTIONS(7876),
    [anon_sym_do] = ACTIONS(7876),
    [anon_sym_EQ_GT] = ACTIONS(7876),
    [anon_sym_LBRACK] = ACTIONS(7876),
    [anon_sym_RBRACK] = ACTIONS(7876),
    [anon_sym_COLON_COLON2] = ACTIONS(7876),
    [anon_sym_AMP_DOT] = ACTIONS(7876),
    [anon_sym_QMARK] = ACTIONS(7876),
    [anon_sym_COLON2] = ACTIONS(7878),
    [anon_sym_DOT_DOT] = ACTIONS(7878),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7876),
    [anon_sym_and] = ACTIONS(7876),
    [anon_sym_or] = ACTIONS(7876),
    [anon_sym_PIPE_PIPE] = ACTIONS(7876),
    [anon_sym_AMP_AMP] = ACTIONS(7876),
    [anon_sym_LT_LT] = ACTIONS(7876),
    [anon_sym_GT_GT] = ACTIONS(7876),
    [anon_sym_EQ_EQ] = ACTIONS(7878),
    [anon_sym_BANG_EQ] = ACTIONS(7876),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7876),
    [anon_sym_LT_EQ_GT] = ACTIONS(7876),
    [anon_sym_EQ_TILDE] = ACTIONS(7876),
    [anon_sym_BANG_TILDE] = ACTIONS(7876),
    [anon_sym_LT_EQ] = ACTIONS(7878),
    [anon_sym_GT] = ACTIONS(7878),
    [anon_sym_GT_EQ] = ACTIONS(7876),
    [anon_sym_CARET] = ACTIONS(7876),
    [anon_sym_PLUS] = ACTIONS(7876),
    [anon_sym_SLASH] = ACTIONS(7876),
    [anon_sym_PERCENT] = ACTIONS(7876),
    [sym_comment] = ACTIONS(87),
  },
  [4236] = {
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(3371),
    [sym__binary_star] = ACTIONS(3373),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(3375),
    [anon_sym_STAR_STAR] = ACTIONS(3373),
    [anon_sym_AMP] = ACTIONS(3377),
    [anon_sym_LT] = ACTIONS(3379),
    [anon_sym_EQ_GT] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(3381),
    [anon_sym_DOT_DOT] = ACTIONS(3383),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3385),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(3387),
    [anon_sym_AMP_AMP] = ACTIONS(3387),
    [anon_sym_LT_LT] = ACTIONS(3389),
    [anon_sym_GT_GT] = ACTIONS(3389),
    [anon_sym_EQ_EQ] = ACTIONS(3391),
    [anon_sym_BANG_EQ] = ACTIONS(3387),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3387),
    [anon_sym_LT_EQ_GT] = ACTIONS(3387),
    [anon_sym_EQ_TILDE] = ACTIONS(3387),
    [anon_sym_BANG_TILDE] = ACTIONS(3387),
    [anon_sym_LT_EQ] = ACTIONS(3379),
    [anon_sym_GT] = ACTIONS(3379),
    [anon_sym_GT_EQ] = ACTIONS(3393),
    [anon_sym_CARET] = ACTIONS(3395),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_SLASH] = ACTIONS(3373),
    [anon_sym_PERCENT] = ACTIONS(3373),
    [sym_comment] = ACTIONS(87),
  },
  [4237] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(3373),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(3373),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(3373),
    [anon_sym_PERCENT] = ACTIONS(3373),
    [sym_comment] = ACTIONS(87),
  },
  [4238] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(3373),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [4239] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(3371),
    [sym__binary_star] = ACTIONS(3373),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(3373),
    [anon_sym_AMP] = ACTIONS(3377),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(3389),
    [anon_sym_GT_GT] = ACTIONS(3389),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_SLASH] = ACTIONS(3373),
    [anon_sym_PERCENT] = ACTIONS(3373),
    [sym_comment] = ACTIONS(87),
  },
  [4240] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(3371),
    [sym__binary_star] = ACTIONS(3373),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(3373),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(3389),
    [anon_sym_GT_GT] = ACTIONS(3389),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_SLASH] = ACTIONS(3373),
    [anon_sym_PERCENT] = ACTIONS(3373),
    [sym_comment] = ACTIONS(87),
  },
  [4241] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(3371),
    [sym__binary_star] = ACTIONS(3373),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(3375),
    [anon_sym_STAR_STAR] = ACTIONS(3373),
    [anon_sym_AMP] = ACTIONS(3377),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(3389),
    [anon_sym_GT_GT] = ACTIONS(3389),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(3395),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_SLASH] = ACTIONS(3373),
    [anon_sym_PERCENT] = ACTIONS(3373),
    [sym_comment] = ACTIONS(87),
  },
  [4242] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(10451),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [4243] = {
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(3371),
    [sym__binary_star] = ACTIONS(3373),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(3375),
    [anon_sym_STAR_STAR] = ACTIONS(3373),
    [anon_sym_AMP] = ACTIONS(3377),
    [anon_sym_LT] = ACTIONS(3379),
    [anon_sym_EQ_GT] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(3383),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3385),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3387),
    [anon_sym_AMP_AMP] = ACTIONS(3387),
    [anon_sym_LT_LT] = ACTIONS(3389),
    [anon_sym_GT_GT] = ACTIONS(3389),
    [anon_sym_EQ_EQ] = ACTIONS(3391),
    [anon_sym_BANG_EQ] = ACTIONS(3387),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3387),
    [anon_sym_LT_EQ_GT] = ACTIONS(3387),
    [anon_sym_EQ_TILDE] = ACTIONS(3387),
    [anon_sym_BANG_TILDE] = ACTIONS(3387),
    [anon_sym_LT_EQ] = ACTIONS(3379),
    [anon_sym_GT] = ACTIONS(3379),
    [anon_sym_GT_EQ] = ACTIONS(3393),
    [anon_sym_CARET] = ACTIONS(3395),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_SLASH] = ACTIONS(3373),
    [anon_sym_PERCENT] = ACTIONS(3373),
    [sym_comment] = ACTIONS(87),
  },
  [4244] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(3371),
    [sym__binary_star] = ACTIONS(3373),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(3375),
    [anon_sym_STAR_STAR] = ACTIONS(3373),
    [anon_sym_AMP] = ACTIONS(3377),
    [anon_sym_LT] = ACTIONS(3379),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(3381),
    [anon_sym_DOT_DOT] = ACTIONS(3383),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3385),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(3387),
    [anon_sym_AMP_AMP] = ACTIONS(3387),
    [anon_sym_LT_LT] = ACTIONS(3389),
    [anon_sym_GT_GT] = ACTIONS(3389),
    [anon_sym_EQ_EQ] = ACTIONS(3391),
    [anon_sym_BANG_EQ] = ACTIONS(3387),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3387),
    [anon_sym_LT_EQ_GT] = ACTIONS(3387),
    [anon_sym_EQ_TILDE] = ACTIONS(3387),
    [anon_sym_BANG_TILDE] = ACTIONS(3387),
    [anon_sym_LT_EQ] = ACTIONS(3379),
    [anon_sym_GT] = ACTIONS(3379),
    [anon_sym_GT_EQ] = ACTIONS(3393),
    [anon_sym_CARET] = ACTIONS(3395),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_SLASH] = ACTIONS(3373),
    [anon_sym_PERCENT] = ACTIONS(3373),
    [sym_comment] = ACTIONS(87),
  },
  [4245] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(3371),
    [sym__binary_star] = ACTIONS(3373),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(3375),
    [anon_sym_STAR_STAR] = ACTIONS(3373),
    [anon_sym_AMP] = ACTIONS(3377),
    [anon_sym_LT] = ACTIONS(3379),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(3389),
    [anon_sym_GT_GT] = ACTIONS(3389),
    [anon_sym_EQ_EQ] = ACTIONS(3391),
    [anon_sym_BANG_EQ] = ACTIONS(3387),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3387),
    [anon_sym_LT_EQ_GT] = ACTIONS(3387),
    [anon_sym_EQ_TILDE] = ACTIONS(3387),
    [anon_sym_BANG_TILDE] = ACTIONS(3387),
    [anon_sym_LT_EQ] = ACTIONS(3379),
    [anon_sym_GT] = ACTIONS(3379),
    [anon_sym_GT_EQ] = ACTIONS(3393),
    [anon_sym_CARET] = ACTIONS(3395),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_SLASH] = ACTIONS(3373),
    [anon_sym_PERCENT] = ACTIONS(3373),
    [sym_comment] = ACTIONS(87),
  },
  [4246] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(3371),
    [sym__binary_star] = ACTIONS(3373),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(3373),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_SLASH] = ACTIONS(3373),
    [anon_sym_PERCENT] = ACTIONS(3373),
    [sym_comment] = ACTIONS(87),
  },
  [4247] = {
    [sym__heredoc_body_start] = ACTIONS(3235),
    [sym__binary_minus] = ACTIONS(3235),
    [sym__binary_star] = ACTIONS(3235),
    [anon_sym_LBRACE] = ACTIONS(3235),
    [anon_sym_RBRACE] = ACTIONS(3235),
    [anon_sym_RPAREN] = ACTIONS(3235),
    [anon_sym_DOT] = ACTIONS(4997),
    [anon_sym_COMMA] = ACTIONS(3235),
    [anon_sym_PIPE] = ACTIONS(4997),
    [anon_sym_SEMI] = ACTIONS(3235),
    [anon_sym_STAR_STAR] = ACTIONS(3235),
    [anon_sym_AMP] = ACTIONS(4997),
    [anon_sym_EQ] = ACTIONS(4997),
    [anon_sym_LT] = ACTIONS(4997),
    [anon_sym_if] = ACTIONS(3235),
    [anon_sym_unless] = ACTIONS(3235),
    [anon_sym_while] = ACTIONS(3235),
    [anon_sym_until] = ACTIONS(3235),
    [anon_sym_rescue] = ACTIONS(3235),
    [anon_sym_in] = ACTIONS(3235),
    [anon_sym_do] = ACTIONS(3235),
    [anon_sym_EQ_GT] = ACTIONS(3235),
    [anon_sym_LBRACK] = ACTIONS(3235),
    [anon_sym_RBRACK] = ACTIONS(3235),
    [anon_sym_COLON_COLON2] = ACTIONS(3235),
    [anon_sym_AMP_DOT] = ACTIONS(3235),
    [anon_sym_QMARK] = ACTIONS(3235),
    [anon_sym_COLON2] = ACTIONS(4997),
    [anon_sym_DOT_DOT] = ACTIONS(4997),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3235),
    [anon_sym_and] = ACTIONS(3235),
    [anon_sym_or] = ACTIONS(3235),
    [anon_sym_PIPE_PIPE] = ACTIONS(3235),
    [anon_sym_AMP_AMP] = ACTIONS(3235),
    [anon_sym_LT_LT] = ACTIONS(3235),
    [anon_sym_GT_GT] = ACTIONS(3235),
    [anon_sym_EQ_EQ] = ACTIONS(4997),
    [anon_sym_BANG_EQ] = ACTIONS(3235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3235),
    [anon_sym_LT_EQ_GT] = ACTIONS(3235),
    [anon_sym_EQ_TILDE] = ACTIONS(3235),
    [anon_sym_BANG_TILDE] = ACTIONS(3235),
    [anon_sym_LT_EQ] = ACTIONS(4997),
    [anon_sym_GT] = ACTIONS(4997),
    [anon_sym_GT_EQ] = ACTIONS(3235),
    [anon_sym_CARET] = ACTIONS(3235),
    [anon_sym_PLUS] = ACTIONS(3235),
    [anon_sym_SLASH] = ACTIONS(3235),
    [anon_sym_PERCENT] = ACTIONS(3235),
    [sym_comment] = ACTIONS(87),
  },
  [4248] = {
    [sym_interpolation] = STATE(1787),
    [aux_sym_heredoc_body_repeat1] = STATE(1787),
    [sym__heredoc_content] = ACTIONS(3237),
    [sym_heredoc_end] = ACTIONS(10453),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(3237),
  },
  [4249] = {
    [sym_heredoc_body] = STATE(4249),
    [aux_sym_call_repeat1] = STATE(4249),
    [sym__heredoc_body_start] = ACTIONS(10455),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_EQ_GT] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [4250] = {
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_RBRACE] = ACTIONS(7925),
    [anon_sym_RPAREN] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(7925),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7925),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_EQ] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_if] = ACTIONS(7925),
    [anon_sym_unless] = ACTIONS(7925),
    [anon_sym_while] = ACTIONS(7925),
    [anon_sym_until] = ACTIONS(7925),
    [anon_sym_rescue] = ACTIONS(7925),
    [anon_sym_in] = ACTIONS(7925),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_EQ_GT] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_RBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_COLON2] = ACTIONS(7927),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7925),
    [anon_sym_AMP_AMP] = ACTIONS(7925),
    [anon_sym_LT_LT] = ACTIONS(7925),
    [anon_sym_GT_GT] = ACTIONS(7925),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7925),
    [anon_sym_PLUS] = ACTIONS(7925),
    [anon_sym_SLASH] = ACTIONS(7925),
    [anon_sym_PERCENT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [4251] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(561),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(567),
    [sym_scope_resolution] = STATE(562),
    [sym_call] = STATE(562),
    [sym_method_call] = STATE(567),
    [sym__argument] = STATE(6908),
    [sym_splat_argument] = STATE(6908),
    [sym_hash_splat_argument] = STATE(6908),
    [sym_block_argument] = STATE(6908),
    [sym_assignment] = STATE(561),
    [sym_operator_assignment] = STATE(561),
    [sym_conditional] = STATE(561),
    [sym_range] = STATE(561),
    [sym_binary] = STATE(561),
    [sym_unary] = STATE(561),
    [sym_left_assignment_list] = STATE(566),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(567),
    [sym__variable] = STATE(562),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(567),
    [sym_false] = STATE(567),
    [sym_nil] = STATE(567),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(568),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(6908),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1047),
    [sym__unary_minus] = ACTIONS(1049),
    [sym__identifier_hash_key] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(7005),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(1075),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4252] = {
    [sym_heredoc_body] = STATE(4249),
    [aux_sym_call_repeat1] = STATE(4249),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_EQ_GT] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [4253] = {
    [aux_sym_argument_list_repeat1] = STATE(4253),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(10458),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_STAR_STAR] = ACTIONS(7925),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_EQ_GT] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7925),
    [anon_sym_AMP_AMP] = ACTIONS(7925),
    [anon_sym_LT_LT] = ACTIONS(7925),
    [anon_sym_GT_GT] = ACTIONS(7925),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7925),
    [anon_sym_PLUS] = ACTIONS(7925),
    [anon_sym_SLASH] = ACTIONS(7925),
    [anon_sym_PERCENT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [4254] = {
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(3371),
    [sym__binary_star] = ACTIONS(3373),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(3375),
    [anon_sym_STAR_STAR] = ACTIONS(3373),
    [anon_sym_AMP] = ACTIONS(3377),
    [anon_sym_LT] = ACTIONS(3379),
    [anon_sym_EQ_GT] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(3381),
    [anon_sym_DOT_DOT] = ACTIONS(3383),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3385),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(3387),
    [anon_sym_AMP_AMP] = ACTIONS(3387),
    [anon_sym_LT_LT] = ACTIONS(3389),
    [anon_sym_GT_GT] = ACTIONS(3389),
    [anon_sym_EQ_EQ] = ACTIONS(3391),
    [anon_sym_BANG_EQ] = ACTIONS(3387),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3387),
    [anon_sym_LT_EQ_GT] = ACTIONS(3387),
    [anon_sym_EQ_TILDE] = ACTIONS(3387),
    [anon_sym_BANG_TILDE] = ACTIONS(3387),
    [anon_sym_LT_EQ] = ACTIONS(3379),
    [anon_sym_GT] = ACTIONS(3379),
    [anon_sym_GT_EQ] = ACTIONS(3393),
    [anon_sym_CARET] = ACTIONS(3395),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_SLASH] = ACTIONS(3373),
    [anon_sym_PERCENT] = ACTIONS(3373),
    [sym_comment] = ACTIONS(87),
  },
  [4255] = {
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_RBRACE] = ACTIONS(6191),
    [anon_sym_RPAREN] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_in] = ACTIONS(6191),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_RBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_COLON2] = ACTIONS(6193),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [4256] = {
    [aux_sym_exceptions_repeat1] = STATE(6910),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [4257] = {
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(3371),
    [sym__binary_star] = ACTIONS(3373),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(3375),
    [anon_sym_STAR_STAR] = ACTIONS(3373),
    [anon_sym_AMP] = ACTIONS(3377),
    [anon_sym_LT] = ACTIONS(3379),
    [anon_sym_EQ_GT] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(3381),
    [anon_sym_DOT_DOT] = ACTIONS(3383),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3385),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(3387),
    [anon_sym_AMP_AMP] = ACTIONS(3387),
    [anon_sym_LT_LT] = ACTIONS(3389),
    [anon_sym_GT_GT] = ACTIONS(3389),
    [anon_sym_EQ_EQ] = ACTIONS(3391),
    [anon_sym_BANG_EQ] = ACTIONS(3387),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3387),
    [anon_sym_LT_EQ_GT] = ACTIONS(3387),
    [anon_sym_EQ_TILDE] = ACTIONS(3387),
    [anon_sym_BANG_TILDE] = ACTIONS(3387),
    [anon_sym_LT_EQ] = ACTIONS(3379),
    [anon_sym_GT] = ACTIONS(3379),
    [anon_sym_GT_EQ] = ACTIONS(3393),
    [anon_sym_CARET] = ACTIONS(3395),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_SLASH] = ACTIONS(3373),
    [anon_sym_PERCENT] = ACTIONS(3373),
    [sym_comment] = ACTIONS(87),
  },
  [4258] = {
    [sym_string] = STATE(4258),
    [aux_sym_chained_string_repeat1] = STATE(4258),
    [sym__string_start] = ACTIONS(9407),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_EQ_GT] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [4259] = {
    [sym__binary_minus] = ACTIONS(8098),
    [sym__binary_star] = ACTIONS(8098),
    [anon_sym_LBRACE] = ACTIONS(8098),
    [anon_sym_RBRACE] = ACTIONS(8098),
    [anon_sym_RPAREN] = ACTIONS(8098),
    [anon_sym_DOT] = ACTIONS(8100),
    [anon_sym_COMMA] = ACTIONS(8098),
    [anon_sym_PIPE] = ACTIONS(8100),
    [anon_sym_SEMI] = ACTIONS(8098),
    [anon_sym_STAR_STAR] = ACTIONS(8098),
    [anon_sym_AMP] = ACTIONS(8100),
    [anon_sym_LT] = ACTIONS(8100),
    [anon_sym_if] = ACTIONS(8098),
    [anon_sym_unless] = ACTIONS(8098),
    [anon_sym_while] = ACTIONS(8098),
    [anon_sym_until] = ACTIONS(8098),
    [anon_sym_rescue] = ACTIONS(8098),
    [anon_sym_do] = ACTIONS(8098),
    [anon_sym_EQ_GT] = ACTIONS(8098),
    [anon_sym_LBRACK] = ACTIONS(8098),
    [anon_sym_COLON_COLON2] = ACTIONS(8098),
    [anon_sym_AMP_DOT] = ACTIONS(8098),
    [anon_sym_QMARK] = ACTIONS(8098),
    [anon_sym_COLON2] = ACTIONS(8100),
    [anon_sym_DOT_DOT] = ACTIONS(8100),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8098),
    [anon_sym_and] = ACTIONS(8098),
    [anon_sym_or] = ACTIONS(8098),
    [anon_sym_PIPE_PIPE] = ACTIONS(8098),
    [anon_sym_AMP_AMP] = ACTIONS(8098),
    [anon_sym_LT_LT] = ACTIONS(8098),
    [anon_sym_GT_GT] = ACTIONS(8098),
    [anon_sym_EQ_EQ] = ACTIONS(8100),
    [anon_sym_BANG_EQ] = ACTIONS(8098),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8098),
    [anon_sym_LT_EQ_GT] = ACTIONS(8098),
    [anon_sym_EQ_TILDE] = ACTIONS(8098),
    [anon_sym_BANG_TILDE] = ACTIONS(8098),
    [anon_sym_LT_EQ] = ACTIONS(8100),
    [anon_sym_GT] = ACTIONS(8100),
    [anon_sym_GT_EQ] = ACTIONS(8098),
    [anon_sym_CARET] = ACTIONS(8098),
    [anon_sym_PLUS] = ACTIONS(8098),
    [anon_sym_SLASH] = ACTIONS(8098),
    [anon_sym_PERCENT] = ACTIONS(8098),
    [sym_comment] = ACTIONS(87),
  },
  [4260] = {
    [anon_sym_end] = ACTIONS(10461),
    [sym_comment] = ACTIONS(87),
  },
  [4261] = {
    [sym__binary_minus] = ACTIONS(8284),
    [sym__binary_star] = ACTIONS(8284),
    [anon_sym_LBRACE] = ACTIONS(8284),
    [anon_sym_RBRACE] = ACTIONS(8284),
    [anon_sym_RPAREN] = ACTIONS(8284),
    [anon_sym_DOT] = ACTIONS(8286),
    [anon_sym_COMMA] = ACTIONS(8284),
    [anon_sym_PIPE] = ACTIONS(8286),
    [anon_sym_SEMI] = ACTIONS(8284),
    [anon_sym_STAR_STAR] = ACTIONS(8284),
    [anon_sym_AMP] = ACTIONS(8286),
    [anon_sym_LT] = ACTIONS(8286),
    [anon_sym_if] = ACTIONS(8284),
    [anon_sym_unless] = ACTIONS(8284),
    [anon_sym_while] = ACTIONS(8284),
    [anon_sym_until] = ACTIONS(8284),
    [anon_sym_rescue] = ACTIONS(8284),
    [anon_sym_do] = ACTIONS(8284),
    [anon_sym_EQ_GT] = ACTIONS(8284),
    [anon_sym_LBRACK] = ACTIONS(8284),
    [anon_sym_COLON_COLON2] = ACTIONS(8284),
    [anon_sym_AMP_DOT] = ACTIONS(8284),
    [anon_sym_QMARK] = ACTIONS(8284),
    [anon_sym_COLON2] = ACTIONS(8286),
    [anon_sym_DOT_DOT] = ACTIONS(8286),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8284),
    [anon_sym_and] = ACTIONS(8284),
    [anon_sym_or] = ACTIONS(8284),
    [anon_sym_PIPE_PIPE] = ACTIONS(8284),
    [anon_sym_AMP_AMP] = ACTIONS(8284),
    [anon_sym_LT_LT] = ACTIONS(8284),
    [anon_sym_GT_GT] = ACTIONS(8284),
    [anon_sym_EQ_EQ] = ACTIONS(8286),
    [anon_sym_BANG_EQ] = ACTIONS(8284),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8284),
    [anon_sym_LT_EQ_GT] = ACTIONS(8284),
    [anon_sym_EQ_TILDE] = ACTIONS(8284),
    [anon_sym_BANG_TILDE] = ACTIONS(8284),
    [anon_sym_LT_EQ] = ACTIONS(8286),
    [anon_sym_GT] = ACTIONS(8286),
    [anon_sym_GT_EQ] = ACTIONS(8284),
    [anon_sym_CARET] = ACTIONS(8284),
    [anon_sym_PLUS] = ACTIONS(8284),
    [anon_sym_SLASH] = ACTIONS(8284),
    [anon_sym_PERCENT] = ACTIONS(8284),
    [sym_comment] = ACTIONS(87),
  },
  [4262] = {
    [anon_sym_end] = ACTIONS(10463),
    [sym_comment] = ACTIONS(87),
  },
  [4263] = {
    [sym__binary_minus] = ACTIONS(8344),
    [sym__binary_star] = ACTIONS(8344),
    [anon_sym_LBRACE] = ACTIONS(8344),
    [anon_sym_RBRACE] = ACTIONS(8344),
    [anon_sym_RPAREN] = ACTIONS(8344),
    [anon_sym_DOT] = ACTIONS(8346),
    [anon_sym_COMMA] = ACTIONS(8344),
    [anon_sym_PIPE] = ACTIONS(8346),
    [anon_sym_SEMI] = ACTIONS(8344),
    [anon_sym_STAR_STAR] = ACTIONS(8344),
    [anon_sym_AMP] = ACTIONS(8346),
    [anon_sym_LT] = ACTIONS(8346),
    [anon_sym_if] = ACTIONS(8344),
    [anon_sym_unless] = ACTIONS(8344),
    [anon_sym_while] = ACTIONS(8344),
    [anon_sym_until] = ACTIONS(8344),
    [anon_sym_rescue] = ACTIONS(8344),
    [anon_sym_do] = ACTIONS(8344),
    [anon_sym_EQ_GT] = ACTIONS(8344),
    [anon_sym_LBRACK] = ACTIONS(8344),
    [anon_sym_COLON_COLON2] = ACTIONS(8344),
    [anon_sym_AMP_DOT] = ACTIONS(8344),
    [anon_sym_QMARK] = ACTIONS(8344),
    [anon_sym_COLON2] = ACTIONS(8346),
    [anon_sym_DOT_DOT] = ACTIONS(8346),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8344),
    [anon_sym_and] = ACTIONS(8344),
    [anon_sym_or] = ACTIONS(8344),
    [anon_sym_PIPE_PIPE] = ACTIONS(8344),
    [anon_sym_AMP_AMP] = ACTIONS(8344),
    [anon_sym_LT_LT] = ACTIONS(8344),
    [anon_sym_GT_GT] = ACTIONS(8344),
    [anon_sym_EQ_EQ] = ACTIONS(8346),
    [anon_sym_BANG_EQ] = ACTIONS(8344),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8344),
    [anon_sym_LT_EQ_GT] = ACTIONS(8344),
    [anon_sym_EQ_TILDE] = ACTIONS(8344),
    [anon_sym_BANG_TILDE] = ACTIONS(8344),
    [anon_sym_LT_EQ] = ACTIONS(8346),
    [anon_sym_GT] = ACTIONS(8346),
    [anon_sym_GT_EQ] = ACTIONS(8344),
    [anon_sym_CARET] = ACTIONS(8344),
    [anon_sym_PLUS] = ACTIONS(8344),
    [anon_sym_SLASH] = ACTIONS(8344),
    [anon_sym_PERCENT] = ACTIONS(8344),
    [sym_comment] = ACTIONS(87),
  },
  [4264] = {
    [anon_sym_end] = ACTIONS(10465),
    [sym_comment] = ACTIONS(87),
  },
  [4265] = {
    [sym__binary_minus] = ACTIONS(8420),
    [sym__binary_star] = ACTIONS(8420),
    [anon_sym_LBRACE] = ACTIONS(8420),
    [anon_sym_RBRACE] = ACTIONS(8420),
    [anon_sym_RPAREN] = ACTIONS(8420),
    [anon_sym_DOT] = ACTIONS(8422),
    [anon_sym_COMMA] = ACTIONS(8420),
    [anon_sym_PIPE] = ACTIONS(8422),
    [anon_sym_SEMI] = ACTIONS(8420),
    [anon_sym_STAR_STAR] = ACTIONS(8420),
    [anon_sym_AMP] = ACTIONS(8422),
    [anon_sym_LT] = ACTIONS(8422),
    [anon_sym_if] = ACTIONS(8420),
    [anon_sym_unless] = ACTIONS(8420),
    [anon_sym_while] = ACTIONS(8420),
    [anon_sym_until] = ACTIONS(8420),
    [anon_sym_rescue] = ACTIONS(8420),
    [anon_sym_do] = ACTIONS(8420),
    [anon_sym_EQ_GT] = ACTIONS(8420),
    [anon_sym_LBRACK] = ACTIONS(8420),
    [anon_sym_COLON_COLON2] = ACTIONS(8420),
    [anon_sym_AMP_DOT] = ACTIONS(8420),
    [anon_sym_QMARK] = ACTIONS(8420),
    [anon_sym_COLON2] = ACTIONS(8422),
    [anon_sym_DOT_DOT] = ACTIONS(8422),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8420),
    [anon_sym_and] = ACTIONS(8420),
    [anon_sym_or] = ACTIONS(8420),
    [anon_sym_PIPE_PIPE] = ACTIONS(8420),
    [anon_sym_AMP_AMP] = ACTIONS(8420),
    [anon_sym_LT_LT] = ACTIONS(8420),
    [anon_sym_GT_GT] = ACTIONS(8420),
    [anon_sym_EQ_EQ] = ACTIONS(8422),
    [anon_sym_BANG_EQ] = ACTIONS(8420),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8420),
    [anon_sym_LT_EQ_GT] = ACTIONS(8420),
    [anon_sym_EQ_TILDE] = ACTIONS(8420),
    [anon_sym_BANG_TILDE] = ACTIONS(8420),
    [anon_sym_LT_EQ] = ACTIONS(8422),
    [anon_sym_GT] = ACTIONS(8422),
    [anon_sym_GT_EQ] = ACTIONS(8420),
    [anon_sym_CARET] = ACTIONS(8420),
    [anon_sym_PLUS] = ACTIONS(8420),
    [anon_sym_SLASH] = ACTIONS(8420),
    [anon_sym_PERCENT] = ACTIONS(8420),
    [sym_comment] = ACTIONS(87),
  },
  [4266] = {
    [anon_sym_end] = ACTIONS(10467),
    [sym_comment] = ACTIONS(87),
  },
  [4267] = {
    [sym__statements] = STATE(6916),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10469),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4268] = {
    [sym__binary_minus] = ACTIONS(8581),
    [sym__binary_star] = ACTIONS(8581),
    [anon_sym_LBRACE] = ACTIONS(8581),
    [anon_sym_RBRACE] = ACTIONS(8581),
    [anon_sym_RPAREN] = ACTIONS(8581),
    [anon_sym_DOT] = ACTIONS(8583),
    [anon_sym_COMMA] = ACTIONS(8581),
    [anon_sym_PIPE] = ACTIONS(8583),
    [anon_sym_SEMI] = ACTIONS(8581),
    [anon_sym_STAR_STAR] = ACTIONS(8581),
    [anon_sym_AMP] = ACTIONS(8583),
    [anon_sym_LT] = ACTIONS(8583),
    [anon_sym_if] = ACTIONS(8581),
    [anon_sym_unless] = ACTIONS(8581),
    [anon_sym_while] = ACTIONS(8581),
    [anon_sym_until] = ACTIONS(8581),
    [anon_sym_rescue] = ACTIONS(8581),
    [anon_sym_do] = ACTIONS(8581),
    [anon_sym_EQ_GT] = ACTIONS(8581),
    [anon_sym_LBRACK] = ACTIONS(8581),
    [anon_sym_COLON_COLON2] = ACTIONS(8581),
    [anon_sym_AMP_DOT] = ACTIONS(8581),
    [anon_sym_QMARK] = ACTIONS(8581),
    [anon_sym_COLON2] = ACTIONS(8583),
    [anon_sym_DOT_DOT] = ACTIONS(8583),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8581),
    [anon_sym_and] = ACTIONS(8581),
    [anon_sym_or] = ACTIONS(8581),
    [anon_sym_PIPE_PIPE] = ACTIONS(8581),
    [anon_sym_AMP_AMP] = ACTIONS(8581),
    [anon_sym_LT_LT] = ACTIONS(8581),
    [anon_sym_GT_GT] = ACTIONS(8581),
    [anon_sym_EQ_EQ] = ACTIONS(8583),
    [anon_sym_BANG_EQ] = ACTIONS(8581),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8581),
    [anon_sym_LT_EQ_GT] = ACTIONS(8581),
    [anon_sym_EQ_TILDE] = ACTIONS(8581),
    [anon_sym_BANG_TILDE] = ACTIONS(8581),
    [anon_sym_LT_EQ] = ACTIONS(8583),
    [anon_sym_GT] = ACTIONS(8583),
    [anon_sym_GT_EQ] = ACTIONS(8581),
    [anon_sym_CARET] = ACTIONS(8581),
    [anon_sym_PLUS] = ACTIONS(8581),
    [anon_sym_SLASH] = ACTIONS(8581),
    [anon_sym_PERCENT] = ACTIONS(8581),
    [sym_comment] = ACTIONS(87),
  },
  [4269] = {
    [anon_sym_end] = ACTIONS(10471),
    [sym_comment] = ACTIONS(87),
  },
  [4270] = {
    [sym_when] = STATE(6919),
    [sym_else] = STATE(6918),
    [aux_sym_case_repeat1] = STATE(2987),
    [aux_sym_case_repeat2] = STATE(6919),
    [anon_sym_SEMI] = ACTIONS(4995),
    [anon_sym_end] = ACTIONS(10471),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [4271] = {
    [sym_when] = STATE(2988),
    [sym_else] = STATE(6918),
    [aux_sym_case_repeat2] = STATE(2988),
    [anon_sym_end] = ACTIONS(10471),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [4272] = {
    [sym__binary_minus] = ACTIONS(9185),
    [sym__binary_star] = ACTIONS(9185),
    [anon_sym_LBRACE] = ACTIONS(9185),
    [anon_sym_RBRACE] = ACTIONS(9185),
    [anon_sym_RPAREN] = ACTIONS(9185),
    [anon_sym_DOT] = ACTIONS(9187),
    [anon_sym_COMMA] = ACTIONS(9185),
    [anon_sym_PIPE] = ACTIONS(9187),
    [anon_sym_SEMI] = ACTIONS(9185),
    [anon_sym_STAR_STAR] = ACTIONS(9185),
    [anon_sym_AMP] = ACTIONS(9187),
    [anon_sym_LT] = ACTIONS(9187),
    [anon_sym_if] = ACTIONS(9185),
    [anon_sym_unless] = ACTIONS(9185),
    [anon_sym_while] = ACTIONS(9185),
    [anon_sym_until] = ACTIONS(9185),
    [anon_sym_rescue] = ACTIONS(9185),
    [anon_sym_do] = ACTIONS(9185),
    [anon_sym_EQ_GT] = ACTIONS(9185),
    [anon_sym_LBRACK] = ACTIONS(9185),
    [anon_sym_COLON_COLON2] = ACTIONS(9185),
    [anon_sym_AMP_DOT] = ACTIONS(9185),
    [anon_sym_QMARK] = ACTIONS(9185),
    [anon_sym_COLON2] = ACTIONS(9187),
    [anon_sym_DOT_DOT] = ACTIONS(9187),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9185),
    [anon_sym_and] = ACTIONS(9185),
    [anon_sym_or] = ACTIONS(9185),
    [anon_sym_PIPE_PIPE] = ACTIONS(9185),
    [anon_sym_AMP_AMP] = ACTIONS(9185),
    [anon_sym_LT_LT] = ACTIONS(9185),
    [anon_sym_GT_GT] = ACTIONS(9185),
    [anon_sym_EQ_EQ] = ACTIONS(9187),
    [anon_sym_BANG_EQ] = ACTIONS(9185),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9185),
    [anon_sym_LT_EQ_GT] = ACTIONS(9185),
    [anon_sym_EQ_TILDE] = ACTIONS(9185),
    [anon_sym_BANG_TILDE] = ACTIONS(9185),
    [anon_sym_LT_EQ] = ACTIONS(9187),
    [anon_sym_GT] = ACTIONS(9187),
    [anon_sym_GT_EQ] = ACTIONS(9185),
    [anon_sym_CARET] = ACTIONS(9185),
    [anon_sym_PLUS] = ACTIONS(9185),
    [anon_sym_SLASH] = ACTIONS(9185),
    [anon_sym_PERCENT] = ACTIONS(9185),
    [sym_comment] = ACTIONS(87),
  },
  [4273] = {
    [anon_sym_end] = ACTIONS(10473),
    [sym_comment] = ACTIONS(87),
  },
  [4274] = {
    [sym_ensure] = STATE(6921),
    [anon_sym_end] = ACTIONS(10473),
    [anon_sym_ensure] = ACTIONS(2169),
    [sym_comment] = ACTIONS(87),
  },
  [4275] = {
    [sym__binary_minus] = ACTIONS(9426),
    [sym__binary_star] = ACTIONS(9426),
    [anon_sym_LBRACE] = ACTIONS(9426),
    [anon_sym_RBRACE] = ACTIONS(9426),
    [anon_sym_RPAREN] = ACTIONS(9426),
    [anon_sym_DOT] = ACTIONS(9428),
    [anon_sym_COMMA] = ACTIONS(9426),
    [anon_sym_PIPE] = ACTIONS(9428),
    [anon_sym_SEMI] = ACTIONS(9426),
    [anon_sym_STAR_STAR] = ACTIONS(9426),
    [anon_sym_AMP] = ACTIONS(9428),
    [anon_sym_LT] = ACTIONS(9428),
    [anon_sym_if] = ACTIONS(9426),
    [anon_sym_unless] = ACTIONS(9426),
    [anon_sym_while] = ACTIONS(9426),
    [anon_sym_until] = ACTIONS(9426),
    [anon_sym_rescue] = ACTIONS(9426),
    [anon_sym_do] = ACTIONS(9426),
    [anon_sym_EQ_GT] = ACTIONS(9426),
    [anon_sym_LBRACK] = ACTIONS(9426),
    [anon_sym_COLON_COLON2] = ACTIONS(9426),
    [anon_sym_AMP_DOT] = ACTIONS(9426),
    [anon_sym_QMARK] = ACTIONS(9426),
    [anon_sym_COLON2] = ACTIONS(9428),
    [anon_sym_DOT_DOT] = ACTIONS(9428),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9426),
    [anon_sym_and] = ACTIONS(9426),
    [anon_sym_or] = ACTIONS(9426),
    [anon_sym_PIPE_PIPE] = ACTIONS(9426),
    [anon_sym_AMP_AMP] = ACTIONS(9426),
    [anon_sym_LT_LT] = ACTIONS(9426),
    [anon_sym_GT_GT] = ACTIONS(9426),
    [anon_sym_EQ_EQ] = ACTIONS(9428),
    [anon_sym_BANG_EQ] = ACTIONS(9426),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9426),
    [anon_sym_LT_EQ_GT] = ACTIONS(9426),
    [anon_sym_EQ_TILDE] = ACTIONS(9426),
    [anon_sym_BANG_TILDE] = ACTIONS(9426),
    [anon_sym_LT_EQ] = ACTIONS(9428),
    [anon_sym_GT] = ACTIONS(9428),
    [anon_sym_GT_EQ] = ACTIONS(9426),
    [anon_sym_CARET] = ACTIONS(9426),
    [anon_sym_PLUS] = ACTIONS(9426),
    [anon_sym_SLASH] = ACTIONS(9426),
    [anon_sym_PERCENT] = ACTIONS(9426),
    [sym_comment] = ACTIONS(87),
  },
  [4276] = {
    [anon_sym_RBRACE] = ACTIONS(10475),
    [sym_comment] = ACTIONS(87),
  },
  [4277] = {
    [sym__binary_minus] = ACTIONS(9446),
    [sym__binary_star] = ACTIONS(9446),
    [anon_sym_LBRACE] = ACTIONS(9446),
    [anon_sym_RBRACE] = ACTIONS(9446),
    [anon_sym_RPAREN] = ACTIONS(9446),
    [anon_sym_DOT] = ACTIONS(9448),
    [anon_sym_COMMA] = ACTIONS(9446),
    [anon_sym_PIPE] = ACTIONS(9448),
    [anon_sym_SEMI] = ACTIONS(9446),
    [anon_sym_STAR_STAR] = ACTIONS(9446),
    [anon_sym_AMP] = ACTIONS(9448),
    [anon_sym_LT] = ACTIONS(9448),
    [anon_sym_if] = ACTIONS(9446),
    [anon_sym_unless] = ACTIONS(9446),
    [anon_sym_while] = ACTIONS(9446),
    [anon_sym_until] = ACTIONS(9446),
    [anon_sym_rescue] = ACTIONS(9446),
    [anon_sym_do] = ACTIONS(9446),
    [anon_sym_EQ_GT] = ACTIONS(9446),
    [anon_sym_LBRACK] = ACTIONS(9446),
    [anon_sym_COLON_COLON2] = ACTIONS(9446),
    [anon_sym_AMP_DOT] = ACTIONS(9446),
    [anon_sym_QMARK] = ACTIONS(9446),
    [anon_sym_COLON2] = ACTIONS(9448),
    [anon_sym_DOT_DOT] = ACTIONS(9448),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9446),
    [anon_sym_and] = ACTIONS(9446),
    [anon_sym_or] = ACTIONS(9446),
    [anon_sym_PIPE_PIPE] = ACTIONS(9446),
    [anon_sym_AMP_AMP] = ACTIONS(9446),
    [anon_sym_LT_LT] = ACTIONS(9446),
    [anon_sym_GT_GT] = ACTIONS(9446),
    [anon_sym_EQ_EQ] = ACTIONS(9448),
    [anon_sym_BANG_EQ] = ACTIONS(9446),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9446),
    [anon_sym_LT_EQ_GT] = ACTIONS(9446),
    [anon_sym_EQ_TILDE] = ACTIONS(9446),
    [anon_sym_BANG_TILDE] = ACTIONS(9446),
    [anon_sym_LT_EQ] = ACTIONS(9448),
    [anon_sym_GT] = ACTIONS(9448),
    [anon_sym_GT_EQ] = ACTIONS(9446),
    [anon_sym_CARET] = ACTIONS(9446),
    [anon_sym_PLUS] = ACTIONS(9446),
    [anon_sym_SLASH] = ACTIONS(9446),
    [anon_sym_PERCENT] = ACTIONS(9446),
    [sym_comment] = ACTIONS(87),
  },
  [4278] = {
    [anon_sym_end] = ACTIONS(10477),
    [sym_comment] = ACTIONS(87),
  },
  [4279] = {
    [sym__statements] = STATE(6924),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10479),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4280] = {
    [sym__statements] = STATE(6924),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_heredoc_body] = STATE(6925),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [sym__terminator] = STATE(6925),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__line_break] = ACTIONS(10481),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(10481),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10479),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4281] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(6926),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(118),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(118),
    [sym_assignment] = STATE(6926),
    [sym_operator_assignment] = STATE(6926),
    [sym_conditional] = STATE(6926),
    [sym_range] = STATE(6926),
    [sym_binary] = STATE(6926),
    [sym_unary] = STATE(6926),
    [sym_left_assignment_list] = STATE(117),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(118),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(118),
    [sym_false] = STATE(118),
    [sym_nil] = STATE(118),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(514),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4282] = {
    [sym__simple_symbol] = ACTIONS(4285),
    [sym__string_start] = ACTIONS(4285),
    [sym__symbol_start] = ACTIONS(4285),
    [sym__subshell_start] = ACTIONS(4285),
    [sym__regex_start] = ACTIONS(4285),
    [sym__string_array_start] = ACTIONS(4285),
    [sym__symbol_array_start] = ACTIONS(4285),
    [sym_heredoc_beginning] = ACTIONS(4285),
    [sym__block_ampersand] = ACTIONS(4285),
    [sym__splat_star] = ACTIONS(4285),
    [sym__unary_minus] = ACTIONS(4285),
    [sym__binary_minus] = ACTIONS(4285),
    [sym__binary_star] = ACTIONS(4285),
    [sym__identifier_hash_key] = ACTIONS(4285),
    [anon_sym_LBRACE] = ACTIONS(4285),
    [anon_sym_def] = ACTIONS(4287),
    [anon_sym_LPAREN] = ACTIONS(4287),
    [anon_sym_DOT] = ACTIONS(4287),
    [anon_sym_COLON_COLON] = ACTIONS(4287),
    [anon_sym_COMMA] = ACTIONS(4285),
    [anon_sym_PIPE] = ACTIONS(4287),
    [anon_sym_STAR] = ACTIONS(4287),
    [anon_sym_STAR_STAR] = ACTIONS(4287),
    [anon_sym_AMP] = ACTIONS(4287),
    [anon_sym_EQ] = ACTIONS(4287),
    [anon_sym_class] = ACTIONS(4287),
    [anon_sym_LT] = ACTIONS(4287),
    [anon_sym_module] = ACTIONS(4287),
    [anon_sym_return] = ACTIONS(4287),
    [anon_sym_yield] = ACTIONS(4287),
    [anon_sym_break] = ACTIONS(4287),
    [anon_sym_next] = ACTIONS(4287),
    [sym_redo] = ACTIONS(4287),
    [sym_retry] = ACTIONS(4287),
    [anon_sym_if] = ACTIONS(4287),
    [anon_sym_unless] = ACTIONS(4287),
    [anon_sym_while] = ACTIONS(4287),
    [anon_sym_until] = ACTIONS(4287),
    [anon_sym_for] = ACTIONS(4287),
    [anon_sym_do] = ACTIONS(4287),
    [anon_sym_case] = ACTIONS(4287),
    [anon_sym_begin] = ACTIONS(4287),
    [anon_sym_EQ_GT] = ACTIONS(4285),
    [anon_sym_LBRACK] = ACTIONS(4285),
    [anon_sym_COLON_COLON2] = ACTIONS(4285),
    [anon_sym_AMP_DOT] = ACTIONS(4285),
    [anon_sym_LPAREN2] = ACTIONS(4285),
    [anon_sym_PLUS_EQ] = ACTIONS(4285),
    [anon_sym_DASH_EQ] = ACTIONS(4285),
    [anon_sym_STAR_EQ] = ACTIONS(4285),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4285),
    [anon_sym_SLASH_EQ] = ACTIONS(4285),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4285),
    [anon_sym_PIPE_EQ] = ACTIONS(4285),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4285),
    [anon_sym_AMP_EQ] = ACTIONS(4285),
    [anon_sym_PERCENT_EQ] = ACTIONS(4285),
    [anon_sym_GT_GT_EQ] = ACTIONS(4285),
    [anon_sym_LT_LT_EQ] = ACTIONS(4285),
    [anon_sym_CARET_EQ] = ACTIONS(4285),
    [anon_sym_QMARK] = ACTIONS(4287),
    [anon_sym_DOT_DOT] = ACTIONS(4287),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4285),
    [anon_sym_and] = ACTIONS(4287),
    [anon_sym_or] = ACTIONS(4287),
    [anon_sym_PIPE_PIPE] = ACTIONS(4287),
    [anon_sym_AMP_AMP] = ACTIONS(4287),
    [anon_sym_LT_LT] = ACTIONS(4287),
    [anon_sym_GT_GT] = ACTIONS(4287),
    [anon_sym_EQ_EQ] = ACTIONS(4287),
    [anon_sym_BANG_EQ] = ACTIONS(4285),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4285),
    [anon_sym_LT_EQ_GT] = ACTIONS(4285),
    [anon_sym_EQ_TILDE] = ACTIONS(4285),
    [anon_sym_BANG_TILDE] = ACTIONS(4285),
    [anon_sym_LT_EQ] = ACTIONS(4287),
    [anon_sym_GT] = ACTIONS(4287),
    [anon_sym_GT_EQ] = ACTIONS(4285),
    [anon_sym_CARET] = ACTIONS(4287),
    [anon_sym_PLUS] = ACTIONS(4287),
    [anon_sym_SLASH] = ACTIONS(4287),
    [anon_sym_PERCENT] = ACTIONS(4287),
    [anon_sym_defined_QMARK] = ACTIONS(4285),
    [anon_sym_not] = ACTIONS(4287),
    [anon_sym_BANG] = ACTIONS(4287),
    [anon_sym_TILDE] = ACTIONS(4285),
    [sym_constant] = ACTIONS(4287),
    [sym_identifier] = ACTIONS(4287),
    [sym_instance_variable] = ACTIONS(4285),
    [sym_class_variable] = ACTIONS(4285),
    [sym_global_variable] = ACTIONS(4285),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4287),
    [sym_float] = ACTIONS(4287),
    [sym_complex] = ACTIONS(4285),
    [sym_super] = ACTIONS(4287),
    [anon_sym_true] = ACTIONS(4287),
    [anon_sym_TRUE] = ACTIONS(4287),
    [anon_sym_false] = ACTIONS(4287),
    [anon_sym_FALSE] = ACTIONS(4287),
    [sym_self] = ACTIONS(4287),
    [anon_sym_nil] = ACTIONS(4287),
    [anon_sym_NIL] = ACTIONS(4287),
    [sym_character] = ACTIONS(4285),
    [anon_sym_LBRACK2] = ACTIONS(4287),
    [anon_sym_DASH_GT] = ACTIONS(4285),
  },
  [4283] = {
    [anon_sym_RPAREN] = ACTIONS(10483),
    [sym_comment] = ACTIONS(87),
  },
  [4284] = {
    [sym__simple_symbol] = ACTIONS(9679),
    [sym__string_start] = ACTIONS(9679),
    [sym__symbol_start] = ACTIONS(9679),
    [sym__subshell_start] = ACTIONS(9679),
    [sym__regex_start] = ACTIONS(9679),
    [sym__string_array_start] = ACTIONS(9679),
    [sym__symbol_array_start] = ACTIONS(9679),
    [sym_heredoc_beginning] = ACTIONS(9679),
    [sym__block_ampersand] = ACTIONS(9679),
    [sym__splat_star] = ACTIONS(9679),
    [sym__unary_minus] = ACTIONS(9679),
    [sym__binary_minus] = ACTIONS(9679),
    [sym__binary_star] = ACTIONS(9679),
    [sym__identifier_hash_key] = ACTIONS(9679),
    [anon_sym_LBRACE] = ACTIONS(9679),
    [anon_sym_def] = ACTIONS(9681),
    [anon_sym_LPAREN] = ACTIONS(9681),
    [anon_sym_DOT] = ACTIONS(9681),
    [anon_sym_COLON_COLON] = ACTIONS(9681),
    [anon_sym_COMMA] = ACTIONS(9679),
    [anon_sym_PIPE] = ACTIONS(9681),
    [anon_sym_STAR] = ACTIONS(9681),
    [anon_sym_STAR_STAR] = ACTIONS(9681),
    [anon_sym_AMP] = ACTIONS(9681),
    [anon_sym_EQ] = ACTIONS(9681),
    [anon_sym_class] = ACTIONS(9681),
    [anon_sym_LT] = ACTIONS(9681),
    [anon_sym_module] = ACTIONS(9681),
    [anon_sym_return] = ACTIONS(9681),
    [anon_sym_yield] = ACTIONS(9681),
    [anon_sym_break] = ACTIONS(9681),
    [anon_sym_next] = ACTIONS(9681),
    [sym_redo] = ACTIONS(9681),
    [sym_retry] = ACTIONS(9681),
    [anon_sym_if] = ACTIONS(9681),
    [anon_sym_unless] = ACTIONS(9681),
    [anon_sym_while] = ACTIONS(9681),
    [anon_sym_until] = ACTIONS(9681),
    [anon_sym_for] = ACTIONS(9681),
    [anon_sym_do] = ACTIONS(9681),
    [anon_sym_case] = ACTIONS(9681),
    [anon_sym_begin] = ACTIONS(9681),
    [anon_sym_EQ_GT] = ACTIONS(9679),
    [anon_sym_LBRACK] = ACTIONS(9679),
    [anon_sym_COLON_COLON2] = ACTIONS(9679),
    [anon_sym_AMP_DOT] = ACTIONS(9679),
    [anon_sym_LPAREN2] = ACTIONS(9679),
    [anon_sym_PLUS_EQ] = ACTIONS(9679),
    [anon_sym_DASH_EQ] = ACTIONS(9679),
    [anon_sym_STAR_EQ] = ACTIONS(9679),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9679),
    [anon_sym_SLASH_EQ] = ACTIONS(9679),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9679),
    [anon_sym_PIPE_EQ] = ACTIONS(9679),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9679),
    [anon_sym_AMP_EQ] = ACTIONS(9679),
    [anon_sym_PERCENT_EQ] = ACTIONS(9679),
    [anon_sym_GT_GT_EQ] = ACTIONS(9679),
    [anon_sym_LT_LT_EQ] = ACTIONS(9679),
    [anon_sym_CARET_EQ] = ACTIONS(9679),
    [anon_sym_QMARK] = ACTIONS(9681),
    [anon_sym_DOT_DOT] = ACTIONS(9681),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9679),
    [anon_sym_and] = ACTIONS(9681),
    [anon_sym_or] = ACTIONS(9681),
    [anon_sym_PIPE_PIPE] = ACTIONS(9681),
    [anon_sym_AMP_AMP] = ACTIONS(9681),
    [anon_sym_LT_LT] = ACTIONS(9681),
    [anon_sym_GT_GT] = ACTIONS(9681),
    [anon_sym_EQ_EQ] = ACTIONS(9681),
    [anon_sym_BANG_EQ] = ACTIONS(9679),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9679),
    [anon_sym_LT_EQ_GT] = ACTIONS(9679),
    [anon_sym_EQ_TILDE] = ACTIONS(9679),
    [anon_sym_BANG_TILDE] = ACTIONS(9679),
    [anon_sym_LT_EQ] = ACTIONS(9681),
    [anon_sym_GT] = ACTIONS(9681),
    [anon_sym_GT_EQ] = ACTIONS(9679),
    [anon_sym_CARET] = ACTIONS(9681),
    [anon_sym_PLUS] = ACTIONS(9681),
    [anon_sym_SLASH] = ACTIONS(9681),
    [anon_sym_PERCENT] = ACTIONS(9681),
    [anon_sym_defined_QMARK] = ACTIONS(9679),
    [anon_sym_not] = ACTIONS(9681),
    [anon_sym_BANG] = ACTIONS(9681),
    [anon_sym_TILDE] = ACTIONS(9679),
    [sym_constant] = ACTIONS(9681),
    [sym_identifier] = ACTIONS(9681),
    [sym_instance_variable] = ACTIONS(9679),
    [sym_class_variable] = ACTIONS(9679),
    [sym_global_variable] = ACTIONS(9679),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(9681),
    [sym_float] = ACTIONS(9681),
    [sym_complex] = ACTIONS(9679),
    [sym_super] = ACTIONS(9681),
    [anon_sym_true] = ACTIONS(9681),
    [anon_sym_TRUE] = ACTIONS(9681),
    [anon_sym_false] = ACTIONS(9681),
    [anon_sym_FALSE] = ACTIONS(9681),
    [sym_self] = ACTIONS(9681),
    [anon_sym_nil] = ACTIONS(9681),
    [anon_sym_NIL] = ACTIONS(9681),
    [sym_character] = ACTIONS(9679),
    [anon_sym_LBRACK2] = ACTIONS(9681),
    [anon_sym_DASH_GT] = ACTIONS(9679),
  },
  [4285] = {
    [sym__binary_minus] = ACTIONS(9686),
    [sym__binary_star] = ACTIONS(9686),
    [anon_sym_DOT] = ACTIONS(9688),
    [anon_sym_COMMA] = ACTIONS(9686),
    [anon_sym_PIPE] = ACTIONS(9688),
    [anon_sym_STAR_STAR] = ACTIONS(9688),
    [anon_sym_AMP] = ACTIONS(9688),
    [anon_sym_EQ] = ACTIONS(9688),
    [anon_sym_LT] = ACTIONS(9688),
    [anon_sym_EQ_GT] = ACTIONS(9686),
    [anon_sym_LBRACK] = ACTIONS(9686),
    [anon_sym_COLON_COLON2] = ACTIONS(9686),
    [anon_sym_AMP_DOT] = ACTIONS(9686),
    [anon_sym_PLUS_EQ] = ACTIONS(9686),
    [anon_sym_DASH_EQ] = ACTIONS(9686),
    [anon_sym_STAR_EQ] = ACTIONS(9686),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9686),
    [anon_sym_SLASH_EQ] = ACTIONS(9686),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9686),
    [anon_sym_PIPE_EQ] = ACTIONS(9686),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9686),
    [anon_sym_AMP_EQ] = ACTIONS(9686),
    [anon_sym_PERCENT_EQ] = ACTIONS(9686),
    [anon_sym_GT_GT_EQ] = ACTIONS(9686),
    [anon_sym_LT_LT_EQ] = ACTIONS(9686),
    [anon_sym_CARET_EQ] = ACTIONS(9686),
    [anon_sym_QMARK] = ACTIONS(9686),
    [anon_sym_DOT_DOT] = ACTIONS(9688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9686),
    [anon_sym_and] = ACTIONS(9686),
    [anon_sym_or] = ACTIONS(9686),
    [anon_sym_PIPE_PIPE] = ACTIONS(9688),
    [anon_sym_AMP_AMP] = ACTIONS(9688),
    [anon_sym_LT_LT] = ACTIONS(9688),
    [anon_sym_GT_GT] = ACTIONS(9688),
    [anon_sym_EQ_EQ] = ACTIONS(9688),
    [anon_sym_BANG_EQ] = ACTIONS(9686),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9686),
    [anon_sym_LT_EQ_GT] = ACTIONS(9686),
    [anon_sym_EQ_TILDE] = ACTIONS(9686),
    [anon_sym_BANG_TILDE] = ACTIONS(9686),
    [anon_sym_LT_EQ] = ACTIONS(9688),
    [anon_sym_GT] = ACTIONS(9688),
    [anon_sym_GT_EQ] = ACTIONS(9686),
    [anon_sym_CARET] = ACTIONS(9688),
    [anon_sym_PLUS] = ACTIONS(9688),
    [anon_sym_SLASH] = ACTIONS(9688),
    [anon_sym_PERCENT] = ACTIONS(9688),
    [sym_comment] = ACTIONS(87),
  },
  [4286] = {
    [sym__string_start] = ACTIONS(3030),
    [sym__heredoc_body_start] = ACTIONS(3030),
    [sym__binary_minus] = ACTIONS(3030),
    [sym__binary_star] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3030),
    [anon_sym_RBRACE] = ACTIONS(3030),
    [anon_sym_RPAREN] = ACTIONS(3030),
    [anon_sym_DOT] = ACTIONS(3032),
    [anon_sym_COMMA] = ACTIONS(3030),
    [anon_sym_PIPE] = ACTIONS(3032),
    [anon_sym_SEMI] = ACTIONS(3030),
    [anon_sym_STAR_STAR] = ACTIONS(3032),
    [anon_sym_AMP] = ACTIONS(3032),
    [anon_sym_COLON] = ACTIONS(3032),
    [anon_sym_EQ] = ACTIONS(3032),
    [anon_sym_LT] = ACTIONS(3032),
    [anon_sym_if] = ACTIONS(3030),
    [anon_sym_unless] = ACTIONS(3030),
    [anon_sym_while] = ACTIONS(3030),
    [anon_sym_until] = ACTIONS(3030),
    [anon_sym_rescue] = ACTIONS(3030),
    [anon_sym_in] = ACTIONS(3030),
    [anon_sym_do] = ACTIONS(3030),
    [anon_sym_EQ_GT] = ACTIONS(3030),
    [anon_sym_LBRACK] = ACTIONS(3030),
    [anon_sym_RBRACK] = ACTIONS(3030),
    [anon_sym_COLON_COLON2] = ACTIONS(3030),
    [anon_sym_AMP_DOT] = ACTIONS(3030),
    [anon_sym_PLUS_EQ] = ACTIONS(3030),
    [anon_sym_DASH_EQ] = ACTIONS(3030),
    [anon_sym_STAR_EQ] = ACTIONS(3030),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3030),
    [anon_sym_SLASH_EQ] = ACTIONS(3030),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3030),
    [anon_sym_PIPE_EQ] = ACTIONS(3030),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3030),
    [anon_sym_AMP_EQ] = ACTIONS(3030),
    [anon_sym_PERCENT_EQ] = ACTIONS(3030),
    [anon_sym_GT_GT_EQ] = ACTIONS(3030),
    [anon_sym_LT_LT_EQ] = ACTIONS(3030),
    [anon_sym_CARET_EQ] = ACTIONS(3030),
    [anon_sym_QMARK] = ACTIONS(3030),
    [anon_sym_COLON2] = ACTIONS(3032),
    [anon_sym_DOT_DOT] = ACTIONS(3032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3030),
    [anon_sym_and] = ACTIONS(3030),
    [anon_sym_or] = ACTIONS(3030),
    [anon_sym_PIPE_PIPE] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_LT_LT] = ACTIONS(3032),
    [anon_sym_GT_GT] = ACTIONS(3032),
    [anon_sym_EQ_EQ] = ACTIONS(3032),
    [anon_sym_BANG_EQ] = ACTIONS(3030),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3030),
    [anon_sym_LT_EQ_GT] = ACTIONS(3030),
    [anon_sym_EQ_TILDE] = ACTIONS(3030),
    [anon_sym_BANG_TILDE] = ACTIONS(3030),
    [anon_sym_LT_EQ] = ACTIONS(3032),
    [anon_sym_GT] = ACTIONS(3032),
    [anon_sym_GT_EQ] = ACTIONS(3030),
    [anon_sym_CARET] = ACTIONS(3032),
    [anon_sym_PLUS] = ACTIONS(3032),
    [anon_sym_SLASH] = ACTIONS(3032),
    [anon_sym_PERCENT] = ACTIONS(3032),
    [sym_comment] = ACTIONS(87),
  },
  [4287] = {
    [sym__heredoc_body_start] = ACTIONS(3042),
    [sym__binary_minus] = ACTIONS(3042),
    [sym__binary_star] = ACTIONS(3042),
    [anon_sym_LBRACE] = ACTIONS(3042),
    [anon_sym_RBRACE] = ACTIONS(3042),
    [anon_sym_RPAREN] = ACTIONS(3042),
    [anon_sym_DOT] = ACTIONS(3044),
    [anon_sym_COMMA] = ACTIONS(3042),
    [anon_sym_PIPE] = ACTIONS(3044),
    [anon_sym_SEMI] = ACTIONS(3042),
    [anon_sym_STAR_STAR] = ACTIONS(3044),
    [anon_sym_AMP] = ACTIONS(3044),
    [anon_sym_EQ] = ACTIONS(3044),
    [anon_sym_LT] = ACTIONS(3044),
    [anon_sym_if] = ACTIONS(3042),
    [anon_sym_unless] = ACTIONS(3042),
    [anon_sym_while] = ACTIONS(3042),
    [anon_sym_until] = ACTIONS(3042),
    [anon_sym_rescue] = ACTIONS(3042),
    [anon_sym_in] = ACTIONS(3042),
    [anon_sym_do] = ACTIONS(3042),
    [anon_sym_EQ_GT] = ACTIONS(3042),
    [anon_sym_LBRACK] = ACTIONS(3042),
    [anon_sym_RBRACK] = ACTIONS(3042),
    [anon_sym_COLON_COLON2] = ACTIONS(3042),
    [anon_sym_AMP_DOT] = ACTIONS(3042),
    [anon_sym_PLUS_EQ] = ACTIONS(3042),
    [anon_sym_DASH_EQ] = ACTIONS(3042),
    [anon_sym_STAR_EQ] = ACTIONS(3042),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3042),
    [anon_sym_SLASH_EQ] = ACTIONS(3042),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3042),
    [anon_sym_PIPE_EQ] = ACTIONS(3042),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3042),
    [anon_sym_AMP_EQ] = ACTIONS(3042),
    [anon_sym_PERCENT_EQ] = ACTIONS(3042),
    [anon_sym_GT_GT_EQ] = ACTIONS(3042),
    [anon_sym_LT_LT_EQ] = ACTIONS(3042),
    [anon_sym_CARET_EQ] = ACTIONS(3042),
    [anon_sym_QMARK] = ACTIONS(3042),
    [anon_sym_COLON2] = ACTIONS(3044),
    [anon_sym_DOT_DOT] = ACTIONS(3044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3042),
    [anon_sym_and] = ACTIONS(3042),
    [anon_sym_or] = ACTIONS(3042),
    [anon_sym_PIPE_PIPE] = ACTIONS(3044),
    [anon_sym_AMP_AMP] = ACTIONS(3044),
    [anon_sym_LT_LT] = ACTIONS(3044),
    [anon_sym_GT_GT] = ACTIONS(3044),
    [anon_sym_EQ_EQ] = ACTIONS(3044),
    [anon_sym_BANG_EQ] = ACTIONS(3042),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3042),
    [anon_sym_LT_EQ_GT] = ACTIONS(3042),
    [anon_sym_EQ_TILDE] = ACTIONS(3042),
    [anon_sym_BANG_TILDE] = ACTIONS(3042),
    [anon_sym_LT_EQ] = ACTIONS(3044),
    [anon_sym_GT] = ACTIONS(3044),
    [anon_sym_GT_EQ] = ACTIONS(3042),
    [anon_sym_CARET] = ACTIONS(3044),
    [anon_sym_PLUS] = ACTIONS(3044),
    [anon_sym_SLASH] = ACTIONS(3044),
    [anon_sym_PERCENT] = ACTIONS(3044),
    [sym_comment] = ACTIONS(87),
  },
  [4288] = {
    [sym__heredoc_body_start] = ACTIONS(3046),
    [sym__binary_minus] = ACTIONS(3046),
    [sym__binary_star] = ACTIONS(3046),
    [anon_sym_LBRACE] = ACTIONS(3046),
    [anon_sym_RBRACE] = ACTIONS(3046),
    [anon_sym_RPAREN] = ACTIONS(3046),
    [anon_sym_DOT] = ACTIONS(3048),
    [anon_sym_COMMA] = ACTIONS(3046),
    [anon_sym_PIPE] = ACTIONS(3048),
    [anon_sym_SEMI] = ACTIONS(3046),
    [anon_sym_STAR_STAR] = ACTIONS(3048),
    [anon_sym_AMP] = ACTIONS(3048),
    [anon_sym_EQ] = ACTIONS(3048),
    [anon_sym_LT] = ACTIONS(3048),
    [anon_sym_if] = ACTIONS(3046),
    [anon_sym_unless] = ACTIONS(3046),
    [anon_sym_while] = ACTIONS(3046),
    [anon_sym_until] = ACTIONS(3046),
    [anon_sym_rescue] = ACTIONS(3046),
    [anon_sym_in] = ACTIONS(3046),
    [anon_sym_do] = ACTIONS(3046),
    [anon_sym_EQ_GT] = ACTIONS(3046),
    [anon_sym_LBRACK] = ACTIONS(3046),
    [anon_sym_RBRACK] = ACTIONS(3046),
    [anon_sym_COLON_COLON2] = ACTIONS(3046),
    [anon_sym_AMP_DOT] = ACTIONS(3046),
    [anon_sym_PLUS_EQ] = ACTIONS(3046),
    [anon_sym_DASH_EQ] = ACTIONS(3046),
    [anon_sym_STAR_EQ] = ACTIONS(3046),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3046),
    [anon_sym_SLASH_EQ] = ACTIONS(3046),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3046),
    [anon_sym_PIPE_EQ] = ACTIONS(3046),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3046),
    [anon_sym_AMP_EQ] = ACTIONS(3046),
    [anon_sym_PERCENT_EQ] = ACTIONS(3046),
    [anon_sym_GT_GT_EQ] = ACTIONS(3046),
    [anon_sym_LT_LT_EQ] = ACTIONS(3046),
    [anon_sym_CARET_EQ] = ACTIONS(3046),
    [anon_sym_QMARK] = ACTIONS(3046),
    [anon_sym_COLON2] = ACTIONS(3048),
    [anon_sym_DOT_DOT] = ACTIONS(3048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3046),
    [anon_sym_and] = ACTIONS(3046),
    [anon_sym_or] = ACTIONS(3046),
    [anon_sym_PIPE_PIPE] = ACTIONS(3048),
    [anon_sym_AMP_AMP] = ACTIONS(3048),
    [anon_sym_LT_LT] = ACTIONS(3048),
    [anon_sym_GT_GT] = ACTIONS(3048),
    [anon_sym_EQ_EQ] = ACTIONS(3048),
    [anon_sym_BANG_EQ] = ACTIONS(3046),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3046),
    [anon_sym_LT_EQ_GT] = ACTIONS(3046),
    [anon_sym_EQ_TILDE] = ACTIONS(3046),
    [anon_sym_BANG_TILDE] = ACTIONS(3046),
    [anon_sym_LT_EQ] = ACTIONS(3048),
    [anon_sym_GT] = ACTIONS(3048),
    [anon_sym_GT_EQ] = ACTIONS(3046),
    [anon_sym_CARET] = ACTIONS(3048),
    [anon_sym_PLUS] = ACTIONS(3048),
    [anon_sym_SLASH] = ACTIONS(3048),
    [anon_sym_PERCENT] = ACTIONS(3048),
    [sym_comment] = ACTIONS(87),
  },
  [4289] = {
    [sym__heredoc_body_start] = ACTIONS(3050),
    [sym__binary_minus] = ACTIONS(3050),
    [sym__binary_star] = ACTIONS(3050),
    [anon_sym_LBRACE] = ACTIONS(3050),
    [anon_sym_RBRACE] = ACTIONS(3050),
    [anon_sym_RPAREN] = ACTIONS(3050),
    [anon_sym_DOT] = ACTIONS(3052),
    [anon_sym_COMMA] = ACTIONS(3050),
    [anon_sym_PIPE] = ACTIONS(3052),
    [anon_sym_SEMI] = ACTIONS(3050),
    [anon_sym_STAR_STAR] = ACTIONS(3052),
    [anon_sym_AMP] = ACTIONS(3052),
    [anon_sym_EQ] = ACTIONS(3052),
    [anon_sym_LT] = ACTIONS(3052),
    [anon_sym_if] = ACTIONS(3050),
    [anon_sym_unless] = ACTIONS(3050),
    [anon_sym_while] = ACTIONS(3050),
    [anon_sym_until] = ACTIONS(3050),
    [anon_sym_rescue] = ACTIONS(3050),
    [anon_sym_in] = ACTIONS(3050),
    [anon_sym_do] = ACTIONS(3050),
    [anon_sym_EQ_GT] = ACTIONS(3050),
    [anon_sym_LBRACK] = ACTIONS(3050),
    [anon_sym_RBRACK] = ACTIONS(3050),
    [anon_sym_COLON_COLON2] = ACTIONS(3050),
    [anon_sym_AMP_DOT] = ACTIONS(3050),
    [anon_sym_PLUS_EQ] = ACTIONS(3050),
    [anon_sym_DASH_EQ] = ACTIONS(3050),
    [anon_sym_STAR_EQ] = ACTIONS(3050),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3050),
    [anon_sym_SLASH_EQ] = ACTIONS(3050),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3050),
    [anon_sym_PIPE_EQ] = ACTIONS(3050),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3050),
    [anon_sym_AMP_EQ] = ACTIONS(3050),
    [anon_sym_PERCENT_EQ] = ACTIONS(3050),
    [anon_sym_GT_GT_EQ] = ACTIONS(3050),
    [anon_sym_LT_LT_EQ] = ACTIONS(3050),
    [anon_sym_CARET_EQ] = ACTIONS(3050),
    [anon_sym_QMARK] = ACTIONS(3050),
    [anon_sym_COLON2] = ACTIONS(3052),
    [anon_sym_DOT_DOT] = ACTIONS(3052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3050),
    [anon_sym_and] = ACTIONS(3050),
    [anon_sym_or] = ACTIONS(3050),
    [anon_sym_PIPE_PIPE] = ACTIONS(3052),
    [anon_sym_AMP_AMP] = ACTIONS(3052),
    [anon_sym_LT_LT] = ACTIONS(3052),
    [anon_sym_GT_GT] = ACTIONS(3052),
    [anon_sym_EQ_EQ] = ACTIONS(3052),
    [anon_sym_BANG_EQ] = ACTIONS(3050),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3050),
    [anon_sym_LT_EQ_GT] = ACTIONS(3050),
    [anon_sym_EQ_TILDE] = ACTIONS(3050),
    [anon_sym_BANG_TILDE] = ACTIONS(3050),
    [anon_sym_LT_EQ] = ACTIONS(3052),
    [anon_sym_GT] = ACTIONS(3052),
    [anon_sym_GT_EQ] = ACTIONS(3050),
    [anon_sym_CARET] = ACTIONS(3052),
    [anon_sym_PLUS] = ACTIONS(3052),
    [anon_sym_SLASH] = ACTIONS(3052),
    [anon_sym_PERCENT] = ACTIONS(3052),
    [sym_comment] = ACTIONS(87),
  },
  [4290] = {
    [sym__heredoc_body_start] = ACTIONS(3056),
    [sym__binary_minus] = ACTIONS(3056),
    [sym__binary_star] = ACTIONS(3056),
    [anon_sym_LBRACE] = ACTIONS(3056),
    [anon_sym_RBRACE] = ACTIONS(3056),
    [anon_sym_RPAREN] = ACTIONS(3056),
    [anon_sym_DOT] = ACTIONS(3058),
    [anon_sym_COMMA] = ACTIONS(3056),
    [anon_sym_PIPE] = ACTIONS(3058),
    [anon_sym_SEMI] = ACTIONS(3056),
    [anon_sym_STAR_STAR] = ACTIONS(3058),
    [anon_sym_AMP] = ACTIONS(3058),
    [anon_sym_EQ] = ACTIONS(3058),
    [anon_sym_LT] = ACTIONS(3058),
    [anon_sym_if] = ACTIONS(3056),
    [anon_sym_unless] = ACTIONS(3056),
    [anon_sym_while] = ACTIONS(3056),
    [anon_sym_until] = ACTIONS(3056),
    [anon_sym_rescue] = ACTIONS(3056),
    [anon_sym_in] = ACTIONS(3056),
    [anon_sym_do] = ACTIONS(3056),
    [anon_sym_EQ_GT] = ACTIONS(3056),
    [anon_sym_LBRACK] = ACTIONS(3056),
    [anon_sym_RBRACK] = ACTIONS(3056),
    [anon_sym_COLON_COLON2] = ACTIONS(3056),
    [anon_sym_AMP_DOT] = ACTIONS(3056),
    [anon_sym_PLUS_EQ] = ACTIONS(3056),
    [anon_sym_DASH_EQ] = ACTIONS(3056),
    [anon_sym_STAR_EQ] = ACTIONS(3056),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3056),
    [anon_sym_SLASH_EQ] = ACTIONS(3056),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3056),
    [anon_sym_PIPE_EQ] = ACTIONS(3056),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3056),
    [anon_sym_AMP_EQ] = ACTIONS(3056),
    [anon_sym_PERCENT_EQ] = ACTIONS(3056),
    [anon_sym_GT_GT_EQ] = ACTIONS(3056),
    [anon_sym_LT_LT_EQ] = ACTIONS(3056),
    [anon_sym_CARET_EQ] = ACTIONS(3056),
    [anon_sym_QMARK] = ACTIONS(3056),
    [anon_sym_COLON2] = ACTIONS(3058),
    [anon_sym_DOT_DOT] = ACTIONS(3058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3056),
    [anon_sym_and] = ACTIONS(3056),
    [anon_sym_or] = ACTIONS(3056),
    [anon_sym_PIPE_PIPE] = ACTIONS(3058),
    [anon_sym_AMP_AMP] = ACTIONS(3058),
    [anon_sym_LT_LT] = ACTIONS(3058),
    [anon_sym_GT_GT] = ACTIONS(3058),
    [anon_sym_EQ_EQ] = ACTIONS(3058),
    [anon_sym_BANG_EQ] = ACTIONS(3056),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3056),
    [anon_sym_LT_EQ_GT] = ACTIONS(3056),
    [anon_sym_EQ_TILDE] = ACTIONS(3056),
    [anon_sym_BANG_TILDE] = ACTIONS(3056),
    [anon_sym_LT_EQ] = ACTIONS(3058),
    [anon_sym_GT] = ACTIONS(3058),
    [anon_sym_GT_EQ] = ACTIONS(3056),
    [anon_sym_CARET] = ACTIONS(3058),
    [anon_sym_PLUS] = ACTIONS(3058),
    [anon_sym_SLASH] = ACTIONS(3058),
    [anon_sym_PERCENT] = ACTIONS(3058),
    [sym_comment] = ACTIONS(87),
  },
  [4291] = {
    [sym__string_end] = ACTIONS(10485),
    [sym_comment] = ACTIONS(87),
  },
  [4292] = {
    [aux_sym_string_array_repeat1] = STATE(6931),
    [sym__string_end] = ACTIONS(10487),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(10489),
  },
  [4293] = {
    [sym__heredoc_body_start] = ACTIONS(3066),
    [sym__binary_minus] = ACTIONS(3066),
    [sym__binary_star] = ACTIONS(3066),
    [anon_sym_LBRACE] = ACTIONS(3066),
    [anon_sym_RBRACE] = ACTIONS(3066),
    [anon_sym_RPAREN] = ACTIONS(3066),
    [anon_sym_DOT] = ACTIONS(3068),
    [anon_sym_COMMA] = ACTIONS(3066),
    [anon_sym_PIPE] = ACTIONS(3068),
    [anon_sym_SEMI] = ACTIONS(3066),
    [anon_sym_STAR_STAR] = ACTIONS(3068),
    [anon_sym_AMP] = ACTIONS(3068),
    [anon_sym_EQ] = ACTIONS(3068),
    [anon_sym_LT] = ACTIONS(3068),
    [anon_sym_if] = ACTIONS(3066),
    [anon_sym_unless] = ACTIONS(3066),
    [anon_sym_while] = ACTIONS(3066),
    [anon_sym_until] = ACTIONS(3066),
    [anon_sym_rescue] = ACTIONS(3066),
    [anon_sym_in] = ACTIONS(3066),
    [anon_sym_do] = ACTIONS(3066),
    [anon_sym_EQ_GT] = ACTIONS(3066),
    [anon_sym_LBRACK] = ACTIONS(3066),
    [anon_sym_RBRACK] = ACTIONS(3066),
    [anon_sym_COLON_COLON2] = ACTIONS(3066),
    [anon_sym_AMP_DOT] = ACTIONS(3066),
    [anon_sym_PLUS_EQ] = ACTIONS(3066),
    [anon_sym_DASH_EQ] = ACTIONS(3066),
    [anon_sym_STAR_EQ] = ACTIONS(3066),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3066),
    [anon_sym_SLASH_EQ] = ACTIONS(3066),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3066),
    [anon_sym_PIPE_EQ] = ACTIONS(3066),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3066),
    [anon_sym_AMP_EQ] = ACTIONS(3066),
    [anon_sym_PERCENT_EQ] = ACTIONS(3066),
    [anon_sym_GT_GT_EQ] = ACTIONS(3066),
    [anon_sym_LT_LT_EQ] = ACTIONS(3066),
    [anon_sym_CARET_EQ] = ACTIONS(3066),
    [anon_sym_QMARK] = ACTIONS(3066),
    [anon_sym_COLON2] = ACTIONS(3068),
    [anon_sym_DOT_DOT] = ACTIONS(3068),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3066),
    [anon_sym_and] = ACTIONS(3066),
    [anon_sym_or] = ACTIONS(3066),
    [anon_sym_PIPE_PIPE] = ACTIONS(3068),
    [anon_sym_AMP_AMP] = ACTIONS(3068),
    [anon_sym_LT_LT] = ACTIONS(3068),
    [anon_sym_GT_GT] = ACTIONS(3068),
    [anon_sym_EQ_EQ] = ACTIONS(3068),
    [anon_sym_BANG_EQ] = ACTIONS(3066),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3066),
    [anon_sym_LT_EQ_GT] = ACTIONS(3066),
    [anon_sym_EQ_TILDE] = ACTIONS(3066),
    [anon_sym_BANG_TILDE] = ACTIONS(3066),
    [anon_sym_LT_EQ] = ACTIONS(3068),
    [anon_sym_GT] = ACTIONS(3068),
    [anon_sym_GT_EQ] = ACTIONS(3066),
    [anon_sym_CARET] = ACTIONS(3068),
    [anon_sym_PLUS] = ACTIONS(3068),
    [anon_sym_SLASH] = ACTIONS(3068),
    [anon_sym_PERCENT] = ACTIONS(3068),
    [sym_comment] = ACTIONS(87),
  },
  [4294] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1697),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(10491),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [4295] = {
    [aux_sym_string_array_repeat1] = STATE(1699),
    [sym__string_end] = ACTIONS(10491),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(10493),
  },
  [4296] = {
    [sym__heredoc_body_start] = ACTIONS(3085),
    [sym__binary_minus] = ACTIONS(3085),
    [sym__binary_star] = ACTIONS(3085),
    [anon_sym_LBRACE] = ACTIONS(3085),
    [anon_sym_RBRACE] = ACTIONS(3085),
    [anon_sym_RPAREN] = ACTIONS(3085),
    [anon_sym_DOT] = ACTIONS(3087),
    [anon_sym_COMMA] = ACTIONS(3085),
    [anon_sym_PIPE] = ACTIONS(3087),
    [anon_sym_SEMI] = ACTIONS(3085),
    [anon_sym_STAR_STAR] = ACTIONS(3087),
    [anon_sym_AMP] = ACTIONS(3087),
    [anon_sym_EQ] = ACTIONS(3087),
    [anon_sym_LT] = ACTIONS(3087),
    [anon_sym_if] = ACTIONS(3085),
    [anon_sym_unless] = ACTIONS(3085),
    [anon_sym_while] = ACTIONS(3085),
    [anon_sym_until] = ACTIONS(3085),
    [anon_sym_rescue] = ACTIONS(3085),
    [anon_sym_in] = ACTIONS(3085),
    [anon_sym_do] = ACTIONS(3085),
    [anon_sym_EQ_GT] = ACTIONS(3085),
    [anon_sym_LBRACK] = ACTIONS(3085),
    [anon_sym_RBRACK] = ACTIONS(3085),
    [anon_sym_COLON_COLON2] = ACTIONS(3085),
    [anon_sym_AMP_DOT] = ACTIONS(3085),
    [anon_sym_PLUS_EQ] = ACTIONS(3085),
    [anon_sym_DASH_EQ] = ACTIONS(3085),
    [anon_sym_STAR_EQ] = ACTIONS(3085),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3085),
    [anon_sym_SLASH_EQ] = ACTIONS(3085),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3085),
    [anon_sym_PIPE_EQ] = ACTIONS(3085),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3085),
    [anon_sym_AMP_EQ] = ACTIONS(3085),
    [anon_sym_PERCENT_EQ] = ACTIONS(3085),
    [anon_sym_GT_GT_EQ] = ACTIONS(3085),
    [anon_sym_LT_LT_EQ] = ACTIONS(3085),
    [anon_sym_CARET_EQ] = ACTIONS(3085),
    [anon_sym_QMARK] = ACTIONS(3085),
    [anon_sym_COLON2] = ACTIONS(3087),
    [anon_sym_DOT_DOT] = ACTIONS(3087),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3085),
    [anon_sym_and] = ACTIONS(3085),
    [anon_sym_or] = ACTIONS(3085),
    [anon_sym_PIPE_PIPE] = ACTIONS(3087),
    [anon_sym_AMP_AMP] = ACTIONS(3087),
    [anon_sym_LT_LT] = ACTIONS(3087),
    [anon_sym_GT_GT] = ACTIONS(3087),
    [anon_sym_EQ_EQ] = ACTIONS(3087),
    [anon_sym_BANG_EQ] = ACTIONS(3085),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3085),
    [anon_sym_LT_EQ_GT] = ACTIONS(3085),
    [anon_sym_EQ_TILDE] = ACTIONS(3085),
    [anon_sym_BANG_TILDE] = ACTIONS(3085),
    [anon_sym_LT_EQ] = ACTIONS(3087),
    [anon_sym_GT] = ACTIONS(3087),
    [anon_sym_GT_EQ] = ACTIONS(3085),
    [anon_sym_CARET] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3087),
    [anon_sym_SLASH] = ACTIONS(3087),
    [anon_sym_PERCENT] = ACTIONS(3087),
    [sym_comment] = ACTIONS(87),
  },
  [4297] = {
    [sym__string_end] = ACTIONS(10495),
    [sym_comment] = ACTIONS(87),
  },
  [4298] = {
    [aux_sym_symbol_array_repeat1] = STATE(6937),
    [sym__string_end] = ACTIONS(10497),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(10499),
  },
  [4299] = {
    [sym__heredoc_body_start] = ACTIONS(3095),
    [sym__binary_minus] = ACTIONS(3095),
    [sym__binary_star] = ACTIONS(3095),
    [anon_sym_LBRACE] = ACTIONS(3095),
    [anon_sym_RBRACE] = ACTIONS(3095),
    [anon_sym_RPAREN] = ACTIONS(3095),
    [anon_sym_DOT] = ACTIONS(3097),
    [anon_sym_COMMA] = ACTIONS(3095),
    [anon_sym_PIPE] = ACTIONS(3097),
    [anon_sym_SEMI] = ACTIONS(3095),
    [anon_sym_STAR_STAR] = ACTIONS(3097),
    [anon_sym_AMP] = ACTIONS(3097),
    [anon_sym_EQ] = ACTIONS(3097),
    [anon_sym_LT] = ACTIONS(3097),
    [anon_sym_if] = ACTIONS(3095),
    [anon_sym_unless] = ACTIONS(3095),
    [anon_sym_while] = ACTIONS(3095),
    [anon_sym_until] = ACTIONS(3095),
    [anon_sym_rescue] = ACTIONS(3095),
    [anon_sym_in] = ACTIONS(3095),
    [anon_sym_do] = ACTIONS(3095),
    [anon_sym_EQ_GT] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3095),
    [anon_sym_RBRACK] = ACTIONS(3095),
    [anon_sym_COLON_COLON2] = ACTIONS(3095),
    [anon_sym_AMP_DOT] = ACTIONS(3095),
    [anon_sym_PLUS_EQ] = ACTIONS(3095),
    [anon_sym_DASH_EQ] = ACTIONS(3095),
    [anon_sym_STAR_EQ] = ACTIONS(3095),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3095),
    [anon_sym_SLASH_EQ] = ACTIONS(3095),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3095),
    [anon_sym_PIPE_EQ] = ACTIONS(3095),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3095),
    [anon_sym_AMP_EQ] = ACTIONS(3095),
    [anon_sym_PERCENT_EQ] = ACTIONS(3095),
    [anon_sym_GT_GT_EQ] = ACTIONS(3095),
    [anon_sym_LT_LT_EQ] = ACTIONS(3095),
    [anon_sym_CARET_EQ] = ACTIONS(3095),
    [anon_sym_QMARK] = ACTIONS(3095),
    [anon_sym_COLON2] = ACTIONS(3097),
    [anon_sym_DOT_DOT] = ACTIONS(3097),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3095),
    [anon_sym_and] = ACTIONS(3095),
    [anon_sym_or] = ACTIONS(3095),
    [anon_sym_PIPE_PIPE] = ACTIONS(3097),
    [anon_sym_AMP_AMP] = ACTIONS(3097),
    [anon_sym_LT_LT] = ACTIONS(3097),
    [anon_sym_GT_GT] = ACTIONS(3097),
    [anon_sym_EQ_EQ] = ACTIONS(3097),
    [anon_sym_BANG_EQ] = ACTIONS(3095),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3095),
    [anon_sym_LT_EQ_GT] = ACTIONS(3095),
    [anon_sym_EQ_TILDE] = ACTIONS(3095),
    [anon_sym_BANG_TILDE] = ACTIONS(3095),
    [anon_sym_LT_EQ] = ACTIONS(3097),
    [anon_sym_GT] = ACTIONS(3097),
    [anon_sym_GT_EQ] = ACTIONS(3095),
    [anon_sym_CARET] = ACTIONS(3097),
    [anon_sym_PLUS] = ACTIONS(3097),
    [anon_sym_SLASH] = ACTIONS(3097),
    [anon_sym_PERCENT] = ACTIONS(3097),
    [sym_comment] = ACTIONS(87),
  },
  [4300] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1705),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(10501),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [4301] = {
    [aux_sym_symbol_array_repeat1] = STATE(1707),
    [sym__string_end] = ACTIONS(10501),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(10503),
  },
  [4302] = {
    [sym__heredoc_body_start] = ACTIONS(993),
    [sym__binary_minus] = ACTIONS(993),
    [sym__binary_star] = ACTIONS(993),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_RBRACE] = ACTIONS(993),
    [anon_sym_RPAREN] = ACTIONS(993),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(993),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_SEMI] = ACTIONS(993),
    [anon_sym_STAR_STAR] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_EQ] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(995),
    [anon_sym_if] = ACTIONS(993),
    [anon_sym_unless] = ACTIONS(993),
    [anon_sym_while] = ACTIONS(993),
    [anon_sym_until] = ACTIONS(993),
    [anon_sym_rescue] = ACTIONS(993),
    [anon_sym_in] = ACTIONS(993),
    [anon_sym_do] = ACTIONS(993),
    [anon_sym_EQ_GT] = ACTIONS(993),
    [anon_sym_LBRACK] = ACTIONS(993),
    [anon_sym_RBRACK] = ACTIONS(993),
    [anon_sym_COLON_COLON2] = ACTIONS(993),
    [anon_sym_AMP_DOT] = ACTIONS(993),
    [anon_sym_PLUS_EQ] = ACTIONS(993),
    [anon_sym_DASH_EQ] = ACTIONS(993),
    [anon_sym_STAR_EQ] = ACTIONS(993),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(993),
    [anon_sym_SLASH_EQ] = ACTIONS(993),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(993),
    [anon_sym_PIPE_EQ] = ACTIONS(993),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(993),
    [anon_sym_AMP_EQ] = ACTIONS(993),
    [anon_sym_PERCENT_EQ] = ACTIONS(993),
    [anon_sym_GT_GT_EQ] = ACTIONS(993),
    [anon_sym_LT_LT_EQ] = ACTIONS(993),
    [anon_sym_CARET_EQ] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(993),
    [anon_sym_COLON2] = ACTIONS(995),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(993),
    [anon_sym_and] = ACTIONS(993),
    [anon_sym_or] = ACTIONS(993),
    [anon_sym_PIPE_PIPE] = ACTIONS(995),
    [anon_sym_AMP_AMP] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(995),
    [anon_sym_GT_GT] = ACTIONS(995),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(993),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(993),
    [anon_sym_LT_EQ_GT] = ACTIONS(993),
    [anon_sym_EQ_TILDE] = ACTIONS(993),
    [anon_sym_BANG_TILDE] = ACTIONS(993),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(993),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_PLUS] = ACTIONS(995),
    [anon_sym_SLASH] = ACTIONS(995),
    [anon_sym_PERCENT] = ACTIONS(995),
    [sym_comment] = ACTIONS(87),
  },
  [4303] = {
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(3509),
    [sym__binary_star] = ACTIONS(3511),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(3513),
    [anon_sym_STAR_STAR] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(3517),
    [anon_sym_EQ] = ACTIONS(7822),
    [anon_sym_LT] = ACTIONS(3519),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_EQ_GT] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_PLUS_EQ] = ACTIONS(6823),
    [anon_sym_DASH_EQ] = ACTIONS(6823),
    [anon_sym_STAR_EQ] = ACTIONS(6823),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6823),
    [anon_sym_SLASH_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6823),
    [anon_sym_AMP_EQ] = ACTIONS(6823),
    [anon_sym_PERCENT_EQ] = ACTIONS(6823),
    [anon_sym_GT_GT_EQ] = ACTIONS(6823),
    [anon_sym_LT_LT_EQ] = ACTIONS(6823),
    [anon_sym_CARET_EQ] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(3521),
    [anon_sym_DOT_DOT] = ACTIONS(3523),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3525),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(3527),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_LT_LT] = ACTIONS(3529),
    [anon_sym_GT_GT] = ACTIONS(3529),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ] = ACTIONS(3531),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3531),
    [anon_sym_LT_EQ_GT] = ACTIONS(3531),
    [anon_sym_EQ_TILDE] = ACTIONS(3531),
    [anon_sym_BANG_TILDE] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3519),
    [anon_sym_GT] = ACTIONS(3519),
    [anon_sym_GT_EQ] = ACTIONS(3533),
    [anon_sym_CARET] = ACTIONS(3513),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_SLASH] = ACTIONS(3515),
    [anon_sym_PERCENT] = ACTIONS(3515),
    [sym_comment] = ACTIONS(87),
  },
  [4304] = {
    [sym__binary_minus] = ACTIONS(9426),
    [sym__binary_star] = ACTIONS(9426),
    [anon_sym_DOT] = ACTIONS(9428),
    [anon_sym_COMMA] = ACTIONS(9426),
    [anon_sym_PIPE] = ACTIONS(9428),
    [anon_sym_STAR_STAR] = ACTIONS(9428),
    [anon_sym_AMP] = ACTIONS(9428),
    [anon_sym_EQ] = ACTIONS(9428),
    [anon_sym_LT] = ACTIONS(9428),
    [anon_sym_EQ_GT] = ACTIONS(9426),
    [anon_sym_LBRACK] = ACTIONS(9426),
    [anon_sym_COLON_COLON2] = ACTIONS(9426),
    [anon_sym_AMP_DOT] = ACTIONS(9426),
    [anon_sym_PLUS_EQ] = ACTIONS(9426),
    [anon_sym_DASH_EQ] = ACTIONS(9426),
    [anon_sym_STAR_EQ] = ACTIONS(9426),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9426),
    [anon_sym_SLASH_EQ] = ACTIONS(9426),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9426),
    [anon_sym_PIPE_EQ] = ACTIONS(9426),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9426),
    [anon_sym_AMP_EQ] = ACTIONS(9426),
    [anon_sym_PERCENT_EQ] = ACTIONS(9426),
    [anon_sym_GT_GT_EQ] = ACTIONS(9426),
    [anon_sym_LT_LT_EQ] = ACTIONS(9426),
    [anon_sym_CARET_EQ] = ACTIONS(9426),
    [anon_sym_QMARK] = ACTIONS(9426),
    [anon_sym_DOT_DOT] = ACTIONS(9428),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9426),
    [anon_sym_and] = ACTIONS(9426),
    [anon_sym_or] = ACTIONS(9426),
    [anon_sym_PIPE_PIPE] = ACTIONS(9428),
    [anon_sym_AMP_AMP] = ACTIONS(9428),
    [anon_sym_LT_LT] = ACTIONS(9428),
    [anon_sym_GT_GT] = ACTIONS(9428),
    [anon_sym_EQ_EQ] = ACTIONS(9428),
    [anon_sym_BANG_EQ] = ACTIONS(9426),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9426),
    [anon_sym_LT_EQ_GT] = ACTIONS(9426),
    [anon_sym_EQ_TILDE] = ACTIONS(9426),
    [anon_sym_BANG_TILDE] = ACTIONS(9426),
    [anon_sym_LT_EQ] = ACTIONS(9428),
    [anon_sym_GT] = ACTIONS(9428),
    [anon_sym_GT_EQ] = ACTIONS(9426),
    [anon_sym_CARET] = ACTIONS(9428),
    [anon_sym_PLUS] = ACTIONS(9428),
    [anon_sym_SLASH] = ACTIONS(9428),
    [anon_sym_PERCENT] = ACTIONS(9428),
    [sym_comment] = ACTIONS(87),
  },
  [4305] = {
    [anon_sym_RBRACE] = ACTIONS(10505),
    [sym_comment] = ACTIONS(87),
  },
  [4306] = {
    [sym__heredoc_body_start] = ACTIONS(3575),
    [sym__binary_minus] = ACTIONS(3575),
    [sym__binary_star] = ACTIONS(3575),
    [anon_sym_LBRACE] = ACTIONS(3575),
    [anon_sym_RBRACE] = ACTIONS(3575),
    [anon_sym_RPAREN] = ACTIONS(3575),
    [anon_sym_DOT] = ACTIONS(3577),
    [anon_sym_COMMA] = ACTIONS(3575),
    [anon_sym_PIPE] = ACTIONS(3577),
    [anon_sym_SEMI] = ACTIONS(3575),
    [anon_sym_STAR_STAR] = ACTIONS(3577),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_EQ] = ACTIONS(3577),
    [anon_sym_LT] = ACTIONS(3577),
    [anon_sym_if] = ACTIONS(3575),
    [anon_sym_unless] = ACTIONS(3575),
    [anon_sym_while] = ACTIONS(3575),
    [anon_sym_until] = ACTIONS(3575),
    [anon_sym_rescue] = ACTIONS(3575),
    [anon_sym_in] = ACTIONS(3575),
    [anon_sym_do] = ACTIONS(3575),
    [anon_sym_EQ_GT] = ACTIONS(3575),
    [anon_sym_LBRACK] = ACTIONS(3575),
    [anon_sym_RBRACK] = ACTIONS(3575),
    [anon_sym_COLON_COLON2] = ACTIONS(3575),
    [anon_sym_AMP_DOT] = ACTIONS(3575),
    [anon_sym_PLUS_EQ] = ACTIONS(3575),
    [anon_sym_DASH_EQ] = ACTIONS(3575),
    [anon_sym_STAR_EQ] = ACTIONS(3575),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3575),
    [anon_sym_SLASH_EQ] = ACTIONS(3575),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3575),
    [anon_sym_PIPE_EQ] = ACTIONS(3575),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3575),
    [anon_sym_AMP_EQ] = ACTIONS(3575),
    [anon_sym_PERCENT_EQ] = ACTIONS(3575),
    [anon_sym_GT_GT_EQ] = ACTIONS(3575),
    [anon_sym_LT_LT_EQ] = ACTIONS(3575),
    [anon_sym_CARET_EQ] = ACTIONS(3575),
    [anon_sym_QMARK] = ACTIONS(3575),
    [anon_sym_COLON2] = ACTIONS(3577),
    [anon_sym_DOT_DOT] = ACTIONS(3577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3575),
    [anon_sym_and] = ACTIONS(3575),
    [anon_sym_or] = ACTIONS(3575),
    [anon_sym_PIPE_PIPE] = ACTIONS(3577),
    [anon_sym_AMP_AMP] = ACTIONS(3577),
    [anon_sym_LT_LT] = ACTIONS(3577),
    [anon_sym_GT_GT] = ACTIONS(3577),
    [anon_sym_EQ_EQ] = ACTIONS(3577),
    [anon_sym_BANG_EQ] = ACTIONS(3575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3575),
    [anon_sym_LT_EQ_GT] = ACTIONS(3575),
    [anon_sym_EQ_TILDE] = ACTIONS(3575),
    [anon_sym_BANG_TILDE] = ACTIONS(3575),
    [anon_sym_LT_EQ] = ACTIONS(3577),
    [anon_sym_GT] = ACTIONS(3577),
    [anon_sym_GT_EQ] = ACTIONS(3575),
    [anon_sym_CARET] = ACTIONS(3577),
    [anon_sym_PLUS] = ACTIONS(3577),
    [anon_sym_SLASH] = ACTIONS(3577),
    [anon_sym_PERCENT] = ACTIONS(3577),
    [sym_comment] = ACTIONS(87),
  },
  [4307] = {
    [anon_sym_RBRACE] = ACTIONS(10507),
    [sym_comment] = ACTIONS(87),
  },
  [4308] = {
    [sym__binary_minus] = ACTIONS(3609),
    [sym__binary_star] = ACTIONS(3611),
    [anon_sym_RPAREN] = ACTIONS(10509),
    [anon_sym_PIPE] = ACTIONS(3615),
    [anon_sym_STAR_STAR] = ACTIONS(3611),
    [anon_sym_AMP] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3619),
    [anon_sym_QMARK] = ACTIONS(3621),
    [anon_sym_DOT_DOT] = ACTIONS(3623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3625),
    [anon_sym_and] = ACTIONS(3627),
    [anon_sym_or] = ACTIONS(3627),
    [anon_sym_PIPE_PIPE] = ACTIONS(3629),
    [anon_sym_AMP_AMP] = ACTIONS(3629),
    [anon_sym_LT_LT] = ACTIONS(3631),
    [anon_sym_GT_GT] = ACTIONS(3631),
    [anon_sym_EQ_EQ] = ACTIONS(3633),
    [anon_sym_BANG_EQ] = ACTIONS(3629),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3629),
    [anon_sym_LT_EQ_GT] = ACTIONS(3629),
    [anon_sym_EQ_TILDE] = ACTIONS(3629),
    [anon_sym_BANG_TILDE] = ACTIONS(3629),
    [anon_sym_LT_EQ] = ACTIONS(3619),
    [anon_sym_GT] = ACTIONS(3619),
    [anon_sym_GT_EQ] = ACTIONS(3635),
    [anon_sym_CARET] = ACTIONS(3637),
    [anon_sym_PLUS] = ACTIONS(3609),
    [anon_sym_SLASH] = ACTIONS(3611),
    [anon_sym_PERCENT] = ACTIONS(3611),
    [sym_comment] = ACTIONS(87),
  },
  [4309] = {
    [sym__method_rest] = STATE(6943),
    [sym_operator] = STATE(1964),
    [sym__method_name] = STATE(1964),
    [sym_setter] = STATE(1964),
    [sym_symbol] = STATE(1964),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(10511),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(10511),
    [sym_class_variable] = ACTIONS(10511),
    [sym_global_variable] = ACTIONS(10511),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [4310] = {
    [sym__statements] = STATE(1988),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(1989),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(1990),
    [sym_rescue] = STATE(1991),
    [sym__body_statement] = STATE(6944),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10513),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4311] = {
    [sym__heredoc_body_start] = ACTIONS(3805),
    [sym__binary_minus] = ACTIONS(3805),
    [sym__binary_star] = ACTIONS(3805),
    [anon_sym_LBRACE] = ACTIONS(3805),
    [anon_sym_RBRACE] = ACTIONS(3805),
    [anon_sym_RPAREN] = ACTIONS(3805),
    [anon_sym_DOT] = ACTIONS(3807),
    [anon_sym_COMMA] = ACTIONS(3805),
    [anon_sym_PIPE] = ACTIONS(3807),
    [anon_sym_SEMI] = ACTIONS(3805),
    [anon_sym_STAR_STAR] = ACTIONS(3807),
    [anon_sym_AMP] = ACTIONS(3807),
    [anon_sym_EQ] = ACTIONS(3807),
    [anon_sym_LT] = ACTIONS(3807),
    [anon_sym_if] = ACTIONS(3805),
    [anon_sym_unless] = ACTIONS(3805),
    [anon_sym_while] = ACTIONS(3805),
    [anon_sym_until] = ACTIONS(3805),
    [anon_sym_rescue] = ACTIONS(3805),
    [anon_sym_in] = ACTIONS(3805),
    [anon_sym_do] = ACTIONS(3805),
    [anon_sym_EQ_GT] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(3805),
    [anon_sym_RBRACK] = ACTIONS(3805),
    [anon_sym_COLON_COLON2] = ACTIONS(3805),
    [anon_sym_AMP_DOT] = ACTIONS(3805),
    [anon_sym_PLUS_EQ] = ACTIONS(3805),
    [anon_sym_DASH_EQ] = ACTIONS(3805),
    [anon_sym_STAR_EQ] = ACTIONS(3805),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3805),
    [anon_sym_SLASH_EQ] = ACTIONS(3805),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3805),
    [anon_sym_PIPE_EQ] = ACTIONS(3805),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3805),
    [anon_sym_AMP_EQ] = ACTIONS(3805),
    [anon_sym_PERCENT_EQ] = ACTIONS(3805),
    [anon_sym_GT_GT_EQ] = ACTIONS(3805),
    [anon_sym_LT_LT_EQ] = ACTIONS(3805),
    [anon_sym_CARET_EQ] = ACTIONS(3805),
    [anon_sym_QMARK] = ACTIONS(3805),
    [anon_sym_COLON2] = ACTIONS(3807),
    [anon_sym_DOT_DOT] = ACTIONS(3807),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3805),
    [anon_sym_and] = ACTIONS(3805),
    [anon_sym_or] = ACTIONS(3805),
    [anon_sym_PIPE_PIPE] = ACTIONS(3807),
    [anon_sym_AMP_AMP] = ACTIONS(3807),
    [anon_sym_LT_LT] = ACTIONS(3807),
    [anon_sym_GT_GT] = ACTIONS(3807),
    [anon_sym_EQ_EQ] = ACTIONS(3807),
    [anon_sym_BANG_EQ] = ACTIONS(3805),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3805),
    [anon_sym_LT_EQ_GT] = ACTIONS(3805),
    [anon_sym_EQ_TILDE] = ACTIONS(3805),
    [anon_sym_BANG_TILDE] = ACTIONS(3805),
    [anon_sym_LT_EQ] = ACTIONS(3807),
    [anon_sym_GT] = ACTIONS(3807),
    [anon_sym_GT_EQ] = ACTIONS(3805),
    [anon_sym_CARET] = ACTIONS(3807),
    [anon_sym_PLUS] = ACTIONS(3807),
    [anon_sym_SLASH] = ACTIONS(3807),
    [anon_sym_PERCENT] = ACTIONS(3807),
    [sym_comment] = ACTIONS(87),
  },
  [4312] = {
    [sym_heredoc_body] = STATE(6945),
    [sym__terminator] = STATE(6945),
    [sym__line_break] = ACTIONS(10515),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym__binary_minus] = ACTIONS(2001),
    [sym__binary_star] = ACTIONS(2003),
    [anon_sym_PIPE] = ACTIONS(2005),
    [anon_sym_SEMI] = ACTIONS(10515),
    [anon_sym_STAR_STAR] = ACTIONS(2003),
    [anon_sym_AMP] = ACTIONS(2007),
    [anon_sym_LT] = ACTIONS(2009),
    [anon_sym_QMARK] = ACTIONS(2011),
    [anon_sym_DOT_DOT] = ACTIONS(2013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2015),
    [anon_sym_and] = ACTIONS(2017),
    [anon_sym_or] = ACTIONS(2017),
    [anon_sym_PIPE_PIPE] = ACTIONS(2019),
    [anon_sym_AMP_AMP] = ACTIONS(2019),
    [anon_sym_LT_LT] = ACTIONS(2021),
    [anon_sym_GT_GT] = ACTIONS(2021),
    [anon_sym_EQ_EQ] = ACTIONS(2023),
    [anon_sym_BANG_EQ] = ACTIONS(2019),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2019),
    [anon_sym_LT_EQ_GT] = ACTIONS(2019),
    [anon_sym_EQ_TILDE] = ACTIONS(2019),
    [anon_sym_BANG_TILDE] = ACTIONS(2019),
    [anon_sym_LT_EQ] = ACTIONS(2009),
    [anon_sym_GT] = ACTIONS(2009),
    [anon_sym_GT_EQ] = ACTIONS(2025),
    [anon_sym_CARET] = ACTIONS(2027),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_SLASH] = ACTIONS(2003),
    [anon_sym_PERCENT] = ACTIONS(2003),
    [sym_comment] = ACTIONS(87),
  },
  [4313] = {
    [sym_heredoc_body] = STATE(6946),
    [sym__terminator] = STATE(6946),
    [sym__line_break] = ACTIONS(10517),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(10517),
    [sym_comment] = ACTIONS(87),
  },
  [4314] = {
    [sym__statements] = STATE(1988),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(1989),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(1990),
    [sym_rescue] = STATE(1991),
    [sym__body_statement] = STATE(6947),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10519),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4315] = {
    [sym__heredoc_body_start] = ACTIONS(4205),
    [sym__binary_minus] = ACTIONS(4205),
    [sym__binary_star] = ACTIONS(4205),
    [anon_sym_LBRACE] = ACTIONS(4205),
    [anon_sym_RBRACE] = ACTIONS(4205),
    [anon_sym_RPAREN] = ACTIONS(4205),
    [anon_sym_DOT] = ACTIONS(4207),
    [anon_sym_COMMA] = ACTIONS(4205),
    [anon_sym_PIPE] = ACTIONS(4207),
    [anon_sym_SEMI] = ACTIONS(4205),
    [anon_sym_STAR_STAR] = ACTIONS(4207),
    [anon_sym_AMP] = ACTIONS(4207),
    [anon_sym_EQ] = ACTIONS(4207),
    [anon_sym_LT] = ACTIONS(4207),
    [anon_sym_if] = ACTIONS(4205),
    [anon_sym_unless] = ACTIONS(4205),
    [anon_sym_while] = ACTIONS(4205),
    [anon_sym_until] = ACTIONS(4205),
    [anon_sym_rescue] = ACTIONS(4205),
    [anon_sym_in] = ACTIONS(4205),
    [anon_sym_do] = ACTIONS(4205),
    [anon_sym_EQ_GT] = ACTIONS(4205),
    [anon_sym_LBRACK] = ACTIONS(4205),
    [anon_sym_RBRACK] = ACTIONS(4205),
    [anon_sym_COLON_COLON2] = ACTIONS(4205),
    [anon_sym_AMP_DOT] = ACTIONS(4205),
    [anon_sym_PLUS_EQ] = ACTIONS(4205),
    [anon_sym_DASH_EQ] = ACTIONS(4205),
    [anon_sym_STAR_EQ] = ACTIONS(4205),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4205),
    [anon_sym_SLASH_EQ] = ACTIONS(4205),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4205),
    [anon_sym_PIPE_EQ] = ACTIONS(4205),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4205),
    [anon_sym_AMP_EQ] = ACTIONS(4205),
    [anon_sym_PERCENT_EQ] = ACTIONS(4205),
    [anon_sym_GT_GT_EQ] = ACTIONS(4205),
    [anon_sym_LT_LT_EQ] = ACTIONS(4205),
    [anon_sym_CARET_EQ] = ACTIONS(4205),
    [anon_sym_QMARK] = ACTIONS(4205),
    [anon_sym_COLON2] = ACTIONS(4207),
    [anon_sym_DOT_DOT] = ACTIONS(4207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4205),
    [anon_sym_and] = ACTIONS(4205),
    [anon_sym_or] = ACTIONS(4205),
    [anon_sym_PIPE_PIPE] = ACTIONS(4207),
    [anon_sym_AMP_AMP] = ACTIONS(4207),
    [anon_sym_LT_LT] = ACTIONS(4207),
    [anon_sym_GT_GT] = ACTIONS(4207),
    [anon_sym_EQ_EQ] = ACTIONS(4207),
    [anon_sym_BANG_EQ] = ACTIONS(4205),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4205),
    [anon_sym_LT_EQ_GT] = ACTIONS(4205),
    [anon_sym_EQ_TILDE] = ACTIONS(4205),
    [anon_sym_BANG_TILDE] = ACTIONS(4205),
    [anon_sym_LT_EQ] = ACTIONS(4207),
    [anon_sym_GT] = ACTIONS(4207),
    [anon_sym_GT_EQ] = ACTIONS(4205),
    [anon_sym_CARET] = ACTIONS(4207),
    [anon_sym_PLUS] = ACTIONS(4207),
    [anon_sym_SLASH] = ACTIONS(4207),
    [anon_sym_PERCENT] = ACTIONS(4207),
    [sym_comment] = ACTIONS(87),
  },
  [4316] = {
    [sym__statements] = STATE(1988),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(1989),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(1990),
    [sym_rescue] = STATE(1991),
    [sym__body_statement] = STATE(6948),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10521),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4317] = {
    [sym_elsif] = STATE(6950),
    [sym_else] = STATE(6950),
    [anon_sym_end] = ACTIONS(10523),
    [anon_sym_elsif] = ACTIONS(4495),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [4318] = {
    [sym__statements] = STATE(2640),
    [sym_begin_block] = STATE(2641),
    [sym_end_block] = STATE(2641),
    [sym__statement] = STATE(2641),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(2641),
    [sym_unless_modifier] = STATE(2641),
    [sym_while_modifier] = STATE(2641),
    [sym_until_modifier] = STATE(2641),
    [sym_rescue_modifier] = STATE(2641),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_elsif] = STATE(6950),
    [sym_else] = STATE(6950),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2642),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2645),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(2645),
    [sym_assignment] = STATE(2642),
    [sym_operator_assignment] = STATE(2642),
    [sym_conditional] = STATE(2642),
    [sym_range] = STATE(2642),
    [sym_binary] = STATE(2642),
    [sym_unary] = STATE(2642),
    [sym_left_assignment_list] = STATE(2644),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2645),
    [sym__variable] = STATE(2643),
    [sym_undef] = STATE(2641),
    [sym_alias] = STATE(2641),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2645),
    [sym_false] = STATE(2645),
    [sym_nil] = STATE(2645),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2646),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(2647),
    [aux_sym__statements_repeat1] = STATE(2647),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4467),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10525),
    [anon_sym_return] = ACTIONS(4471),
    [anon_sym_yield] = ACTIONS(4473),
    [anon_sym_break] = ACTIONS(4475),
    [anon_sym_next] = ACTIONS(4477),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(4499),
    [anon_sym_else] = ACTIONS(4501),
    [anon_sym_then] = ACTIONS(4503),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4479),
    [anon_sym_defined_QMARK] = ACTIONS(4481),
    [anon_sym_not] = ACTIONS(4483),
    [anon_sym_BANG] = ACTIONS(4485),
    [anon_sym_TILDE] = ACTIONS(4485),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [anon_sym_undef] = ACTIONS(4491),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4319] = {
    [sym_else] = STATE(6952),
    [anon_sym_end] = ACTIONS(10527),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [4320] = {
    [sym__statements] = STATE(2640),
    [sym_begin_block] = STATE(2715),
    [sym_end_block] = STATE(2715),
    [sym__statement] = STATE(2715),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(2715),
    [sym_unless_modifier] = STATE(2715),
    [sym_while_modifier] = STATE(2715),
    [sym_until_modifier] = STATE(2715),
    [sym_rescue_modifier] = STATE(2715),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(6952),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2716),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2719),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(2719),
    [sym_assignment] = STATE(2716),
    [sym_operator_assignment] = STATE(2716),
    [sym_conditional] = STATE(2716),
    [sym_range] = STATE(2716),
    [sym_binary] = STATE(2716),
    [sym_unary] = STATE(2716),
    [sym_left_assignment_list] = STATE(2718),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2719),
    [sym__variable] = STATE(2717),
    [sym_undef] = STATE(2715),
    [sym_alias] = STATE(2715),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2719),
    [sym_false] = STATE(2719),
    [sym_nil] = STATE(2719),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2720),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(2721),
    [aux_sym__statements_repeat1] = STATE(2721),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4583),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10529),
    [anon_sym_return] = ACTIONS(4585),
    [anon_sym_yield] = ACTIONS(4587),
    [anon_sym_break] = ACTIONS(4589),
    [anon_sym_next] = ACTIONS(4591),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(4501),
    [anon_sym_then] = ACTIONS(4611),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4593),
    [anon_sym_defined_QMARK] = ACTIONS(4595),
    [anon_sym_not] = ACTIONS(4597),
    [anon_sym_BANG] = ACTIONS(4599),
    [anon_sym_TILDE] = ACTIONS(4599),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [anon_sym_undef] = ACTIONS(4605),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4321] = {
    [sym__statements] = STATE(6954),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10531),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4322] = {
    [sym__statements] = STATE(6956),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10533),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4323] = {
    [sym__do] = STATE(6957),
    [sym_heredoc_body] = STATE(6957),
    [sym__terminator] = STATE(6957),
    [sym__line_break] = ACTIONS(10535),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(10535),
    [anon_sym_do] = ACTIONS(10535),
    [sym_comment] = ACTIONS(87),
  },
  [4324] = {
    [sym__binary_minus] = ACTIONS(9446),
    [sym__binary_star] = ACTIONS(9446),
    [anon_sym_DOT] = ACTIONS(9448),
    [anon_sym_COMMA] = ACTIONS(9446),
    [anon_sym_PIPE] = ACTIONS(9448),
    [anon_sym_STAR_STAR] = ACTIONS(9448),
    [anon_sym_AMP] = ACTIONS(9448),
    [anon_sym_EQ] = ACTIONS(9448),
    [anon_sym_LT] = ACTIONS(9448),
    [anon_sym_EQ_GT] = ACTIONS(9446),
    [anon_sym_LBRACK] = ACTIONS(9446),
    [anon_sym_COLON_COLON2] = ACTIONS(9446),
    [anon_sym_AMP_DOT] = ACTIONS(9446),
    [anon_sym_PLUS_EQ] = ACTIONS(9446),
    [anon_sym_DASH_EQ] = ACTIONS(9446),
    [anon_sym_STAR_EQ] = ACTIONS(9446),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9446),
    [anon_sym_SLASH_EQ] = ACTIONS(9446),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9446),
    [anon_sym_PIPE_EQ] = ACTIONS(9446),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9446),
    [anon_sym_AMP_EQ] = ACTIONS(9446),
    [anon_sym_PERCENT_EQ] = ACTIONS(9446),
    [anon_sym_GT_GT_EQ] = ACTIONS(9446),
    [anon_sym_LT_LT_EQ] = ACTIONS(9446),
    [anon_sym_CARET_EQ] = ACTIONS(9446),
    [anon_sym_QMARK] = ACTIONS(9446),
    [anon_sym_DOT_DOT] = ACTIONS(9448),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9446),
    [anon_sym_and] = ACTIONS(9446),
    [anon_sym_or] = ACTIONS(9446),
    [anon_sym_PIPE_PIPE] = ACTIONS(9448),
    [anon_sym_AMP_AMP] = ACTIONS(9448),
    [anon_sym_LT_LT] = ACTIONS(9448),
    [anon_sym_GT_GT] = ACTIONS(9448),
    [anon_sym_EQ_EQ] = ACTIONS(9448),
    [anon_sym_BANG_EQ] = ACTIONS(9446),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9446),
    [anon_sym_LT_EQ_GT] = ACTIONS(9446),
    [anon_sym_EQ_TILDE] = ACTIONS(9446),
    [anon_sym_BANG_TILDE] = ACTIONS(9446),
    [anon_sym_LT_EQ] = ACTIONS(9448),
    [anon_sym_GT] = ACTIONS(9448),
    [anon_sym_GT_EQ] = ACTIONS(9446),
    [anon_sym_CARET] = ACTIONS(9448),
    [anon_sym_PLUS] = ACTIONS(9448),
    [anon_sym_SLASH] = ACTIONS(9448),
    [anon_sym_PERCENT] = ACTIONS(9448),
    [sym_comment] = ACTIONS(87),
  },
  [4325] = {
    [anon_sym_end] = ACTIONS(10537),
    [sym_comment] = ACTIONS(87),
  },
  [4326] = {
    [sym__statements] = STATE(6959),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10539),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4327] = {
    [sym__statements] = STATE(6959),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_heredoc_body] = STATE(6960),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [sym__terminator] = STATE(6960),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__line_break] = ACTIONS(10541),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(10541),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10539),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4328] = {
    [sym_when] = STATE(6964),
    [sym_else] = STATE(6962),
    [aux_sym_case_repeat1] = STATE(6963),
    [aux_sym_case_repeat2] = STATE(6964),
    [anon_sym_SEMI] = ACTIONS(10543),
    [anon_sym_end] = ACTIONS(10545),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [4329] = {
    [sym__heredoc_body_start] = ACTIONS(4965),
    [sym__binary_minus] = ACTIONS(4965),
    [sym__binary_star] = ACTIONS(4965),
    [anon_sym_LBRACE] = ACTIONS(4965),
    [anon_sym_RBRACE] = ACTIONS(4965),
    [anon_sym_RPAREN] = ACTIONS(4965),
    [anon_sym_DOT] = ACTIONS(4967),
    [anon_sym_COMMA] = ACTIONS(4965),
    [anon_sym_PIPE] = ACTIONS(4967),
    [anon_sym_SEMI] = ACTIONS(4965),
    [anon_sym_STAR_STAR] = ACTIONS(4967),
    [anon_sym_AMP] = ACTIONS(4967),
    [anon_sym_EQ] = ACTIONS(4967),
    [anon_sym_LT] = ACTIONS(4967),
    [anon_sym_if] = ACTIONS(4965),
    [anon_sym_unless] = ACTIONS(4965),
    [anon_sym_while] = ACTIONS(4965),
    [anon_sym_until] = ACTIONS(4965),
    [anon_sym_rescue] = ACTIONS(4965),
    [anon_sym_in] = ACTIONS(4965),
    [anon_sym_do] = ACTIONS(4965),
    [anon_sym_EQ_GT] = ACTIONS(4965),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym_RBRACK] = ACTIONS(4965),
    [anon_sym_COLON_COLON2] = ACTIONS(4965),
    [anon_sym_AMP_DOT] = ACTIONS(4965),
    [anon_sym_PLUS_EQ] = ACTIONS(4965),
    [anon_sym_DASH_EQ] = ACTIONS(4965),
    [anon_sym_STAR_EQ] = ACTIONS(4965),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4965),
    [anon_sym_SLASH_EQ] = ACTIONS(4965),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4965),
    [anon_sym_PIPE_EQ] = ACTIONS(4965),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4965),
    [anon_sym_AMP_EQ] = ACTIONS(4965),
    [anon_sym_PERCENT_EQ] = ACTIONS(4965),
    [anon_sym_GT_GT_EQ] = ACTIONS(4965),
    [anon_sym_LT_LT_EQ] = ACTIONS(4965),
    [anon_sym_CARET_EQ] = ACTIONS(4965),
    [anon_sym_QMARK] = ACTIONS(4965),
    [anon_sym_COLON2] = ACTIONS(4967),
    [anon_sym_DOT_DOT] = ACTIONS(4967),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4965),
    [anon_sym_and] = ACTIONS(4965),
    [anon_sym_or] = ACTIONS(4965),
    [anon_sym_PIPE_PIPE] = ACTIONS(4967),
    [anon_sym_AMP_AMP] = ACTIONS(4967),
    [anon_sym_LT_LT] = ACTIONS(4967),
    [anon_sym_GT_GT] = ACTIONS(4967),
    [anon_sym_EQ_EQ] = ACTIONS(4967),
    [anon_sym_BANG_EQ] = ACTIONS(4965),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4965),
    [anon_sym_LT_EQ_GT] = ACTIONS(4965),
    [anon_sym_EQ_TILDE] = ACTIONS(4965),
    [anon_sym_BANG_TILDE] = ACTIONS(4965),
    [anon_sym_LT_EQ] = ACTIONS(4967),
    [anon_sym_GT] = ACTIONS(4967),
    [anon_sym_GT_EQ] = ACTIONS(4965),
    [anon_sym_CARET] = ACTIONS(4967),
    [anon_sym_PLUS] = ACTIONS(4967),
    [anon_sym_SLASH] = ACTIONS(4967),
    [anon_sym_PERCENT] = ACTIONS(4967),
    [sym_comment] = ACTIONS(87),
  },
  [4330] = {
    [anon_sym_end] = ACTIONS(10545),
    [sym_comment] = ACTIONS(87),
  },
  [4331] = {
    [sym_when] = STATE(6964),
    [sym_else] = STATE(6962),
    [aux_sym_case_repeat1] = STATE(2987),
    [aux_sym_case_repeat2] = STATE(6964),
    [anon_sym_SEMI] = ACTIONS(4995),
    [anon_sym_end] = ACTIONS(10545),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [4332] = {
    [sym_when] = STATE(2988),
    [sym_else] = STATE(6962),
    [aux_sym_case_repeat2] = STATE(2988),
    [anon_sym_end] = ACTIONS(10545),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [4333] = {
    [sym__heredoc_body_start] = ACTIONS(5407),
    [sym__binary_minus] = ACTIONS(5407),
    [sym__binary_star] = ACTIONS(5407),
    [anon_sym_LBRACE] = ACTIONS(5407),
    [anon_sym_RBRACE] = ACTIONS(5407),
    [anon_sym_RPAREN] = ACTIONS(5407),
    [anon_sym_DOT] = ACTIONS(5409),
    [anon_sym_COMMA] = ACTIONS(5407),
    [anon_sym_PIPE] = ACTIONS(5409),
    [anon_sym_SEMI] = ACTIONS(5407),
    [anon_sym_STAR_STAR] = ACTIONS(5409),
    [anon_sym_AMP] = ACTIONS(5409),
    [anon_sym_EQ] = ACTIONS(5409),
    [anon_sym_LT] = ACTIONS(5409),
    [anon_sym_if] = ACTIONS(5407),
    [anon_sym_unless] = ACTIONS(5407),
    [anon_sym_while] = ACTIONS(5407),
    [anon_sym_until] = ACTIONS(5407),
    [anon_sym_rescue] = ACTIONS(5407),
    [anon_sym_in] = ACTIONS(5407),
    [anon_sym_do] = ACTIONS(5407),
    [anon_sym_EQ_GT] = ACTIONS(5407),
    [anon_sym_LBRACK] = ACTIONS(5407),
    [anon_sym_RBRACK] = ACTIONS(5407),
    [anon_sym_COLON_COLON2] = ACTIONS(5407),
    [anon_sym_AMP_DOT] = ACTIONS(5407),
    [anon_sym_PLUS_EQ] = ACTIONS(5407),
    [anon_sym_DASH_EQ] = ACTIONS(5407),
    [anon_sym_STAR_EQ] = ACTIONS(5407),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5407),
    [anon_sym_SLASH_EQ] = ACTIONS(5407),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5407),
    [anon_sym_PIPE_EQ] = ACTIONS(5407),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5407),
    [anon_sym_AMP_EQ] = ACTIONS(5407),
    [anon_sym_PERCENT_EQ] = ACTIONS(5407),
    [anon_sym_GT_GT_EQ] = ACTIONS(5407),
    [anon_sym_LT_LT_EQ] = ACTIONS(5407),
    [anon_sym_CARET_EQ] = ACTIONS(5407),
    [anon_sym_QMARK] = ACTIONS(5407),
    [anon_sym_COLON2] = ACTIONS(5409),
    [anon_sym_DOT_DOT] = ACTIONS(5409),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5407),
    [anon_sym_and] = ACTIONS(5407),
    [anon_sym_or] = ACTIONS(5407),
    [anon_sym_PIPE_PIPE] = ACTIONS(5409),
    [anon_sym_AMP_AMP] = ACTIONS(5409),
    [anon_sym_LT_LT] = ACTIONS(5409),
    [anon_sym_GT_GT] = ACTIONS(5409),
    [anon_sym_EQ_EQ] = ACTIONS(5409),
    [anon_sym_BANG_EQ] = ACTIONS(5407),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5407),
    [anon_sym_LT_EQ_GT] = ACTIONS(5407),
    [anon_sym_EQ_TILDE] = ACTIONS(5407),
    [anon_sym_BANG_TILDE] = ACTIONS(5407),
    [anon_sym_LT_EQ] = ACTIONS(5409),
    [anon_sym_GT] = ACTIONS(5409),
    [anon_sym_GT_EQ] = ACTIONS(5407),
    [anon_sym_CARET] = ACTIONS(5409),
    [anon_sym_PLUS] = ACTIONS(5409),
    [anon_sym_SLASH] = ACTIONS(5409),
    [anon_sym_PERCENT] = ACTIONS(5409),
    [sym_comment] = ACTIONS(87),
  },
  [4334] = {
    [sym_ensure] = STATE(6966),
    [anon_sym_end] = ACTIONS(10547),
    [anon_sym_ensure] = ACTIONS(2169),
    [sym_comment] = ACTIONS(87),
  },
  [4335] = {
    [anon_sym_end] = ACTIONS(10547),
    [sym_comment] = ACTIONS(87),
  },
  [4336] = {
    [sym_else] = STATE(6967),
    [sym_ensure] = STATE(6966),
    [anon_sym_end] = ACTIONS(10547),
    [anon_sym_else] = ACTIONS(2167),
    [anon_sym_ensure] = ACTIONS(2169),
    [sym_comment] = ACTIONS(87),
  },
  [4337] = {
    [sym__heredoc_body_start] = ACTIONS(5491),
    [sym__binary_minus] = ACTIONS(5491),
    [sym__binary_star] = ACTIONS(5491),
    [anon_sym_LBRACE] = ACTIONS(5491),
    [anon_sym_RBRACE] = ACTIONS(5491),
    [anon_sym_RPAREN] = ACTIONS(5491),
    [anon_sym_DOT] = ACTIONS(5493),
    [anon_sym_COMMA] = ACTIONS(5491),
    [anon_sym_PIPE] = ACTIONS(5493),
    [anon_sym_SEMI] = ACTIONS(5491),
    [anon_sym_STAR_STAR] = ACTIONS(5493),
    [anon_sym_AMP] = ACTIONS(5493),
    [anon_sym_EQ] = ACTIONS(5493),
    [anon_sym_LT] = ACTIONS(5493),
    [anon_sym_if] = ACTIONS(5491),
    [anon_sym_unless] = ACTIONS(5491),
    [anon_sym_while] = ACTIONS(5491),
    [anon_sym_until] = ACTIONS(5491),
    [anon_sym_rescue] = ACTIONS(5491),
    [anon_sym_in] = ACTIONS(5491),
    [anon_sym_do] = ACTIONS(5491),
    [anon_sym_EQ_GT] = ACTIONS(5491),
    [anon_sym_LBRACK] = ACTIONS(5491),
    [anon_sym_RBRACK] = ACTIONS(5491),
    [anon_sym_COLON_COLON2] = ACTIONS(5491),
    [anon_sym_AMP_DOT] = ACTIONS(5491),
    [anon_sym_PLUS_EQ] = ACTIONS(5491),
    [anon_sym_DASH_EQ] = ACTIONS(5491),
    [anon_sym_STAR_EQ] = ACTIONS(5491),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5491),
    [anon_sym_SLASH_EQ] = ACTIONS(5491),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5491),
    [anon_sym_PIPE_EQ] = ACTIONS(5491),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5491),
    [anon_sym_AMP_EQ] = ACTIONS(5491),
    [anon_sym_PERCENT_EQ] = ACTIONS(5491),
    [anon_sym_GT_GT_EQ] = ACTIONS(5491),
    [anon_sym_LT_LT_EQ] = ACTIONS(5491),
    [anon_sym_CARET_EQ] = ACTIONS(5491),
    [anon_sym_QMARK] = ACTIONS(5491),
    [anon_sym_COLON2] = ACTIONS(5493),
    [anon_sym_DOT_DOT] = ACTIONS(5493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5491),
    [anon_sym_and] = ACTIONS(5491),
    [anon_sym_or] = ACTIONS(5491),
    [anon_sym_PIPE_PIPE] = ACTIONS(5493),
    [anon_sym_AMP_AMP] = ACTIONS(5493),
    [anon_sym_LT_LT] = ACTIONS(5493),
    [anon_sym_GT_GT] = ACTIONS(5493),
    [anon_sym_EQ_EQ] = ACTIONS(5493),
    [anon_sym_BANG_EQ] = ACTIONS(5491),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5491),
    [anon_sym_LT_EQ_GT] = ACTIONS(5491),
    [anon_sym_EQ_TILDE] = ACTIONS(5491),
    [anon_sym_BANG_TILDE] = ACTIONS(5491),
    [anon_sym_LT_EQ] = ACTIONS(5493),
    [anon_sym_GT] = ACTIONS(5493),
    [anon_sym_GT_EQ] = ACTIONS(5491),
    [anon_sym_CARET] = ACTIONS(5493),
    [anon_sym_PLUS] = ACTIONS(5493),
    [anon_sym_SLASH] = ACTIONS(5493),
    [anon_sym_PERCENT] = ACTIONS(5493),
    [sym_comment] = ACTIONS(87),
  },
  [4338] = {
    [sym__heredoc_body_start] = ACTIONS(7876),
    [sym__binary_minus] = ACTIONS(7876),
    [sym__binary_star] = ACTIONS(7876),
    [anon_sym_LBRACE] = ACTIONS(7876),
    [anon_sym_RBRACE] = ACTIONS(7876),
    [anon_sym_RPAREN] = ACTIONS(7876),
    [anon_sym_DOT] = ACTIONS(7878),
    [anon_sym_COMMA] = ACTIONS(7876),
    [anon_sym_PIPE] = ACTIONS(7878),
    [anon_sym_SEMI] = ACTIONS(7876),
    [anon_sym_STAR_STAR] = ACTIONS(7878),
    [anon_sym_AMP] = ACTIONS(7878),
    [anon_sym_EQ] = ACTIONS(7878),
    [anon_sym_LT] = ACTIONS(7878),
    [anon_sym_if] = ACTIONS(7876),
    [anon_sym_unless] = ACTIONS(7876),
    [anon_sym_while] = ACTIONS(7876),
    [anon_sym_until] = ACTIONS(7876),
    [anon_sym_rescue] = ACTIONS(7876),
    [anon_sym_in] = ACTIONS(7876),
    [anon_sym_do] = ACTIONS(7876),
    [anon_sym_EQ_GT] = ACTIONS(7876),
    [anon_sym_LBRACK] = ACTIONS(7876),
    [anon_sym_RBRACK] = ACTIONS(7876),
    [anon_sym_COLON_COLON2] = ACTIONS(7876),
    [anon_sym_AMP_DOT] = ACTIONS(7876),
    [anon_sym_PLUS_EQ] = ACTIONS(7876),
    [anon_sym_DASH_EQ] = ACTIONS(7876),
    [anon_sym_STAR_EQ] = ACTIONS(7876),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7876),
    [anon_sym_SLASH_EQ] = ACTIONS(7876),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7876),
    [anon_sym_PIPE_EQ] = ACTIONS(7876),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7876),
    [anon_sym_AMP_EQ] = ACTIONS(7876),
    [anon_sym_PERCENT_EQ] = ACTIONS(7876),
    [anon_sym_GT_GT_EQ] = ACTIONS(7876),
    [anon_sym_LT_LT_EQ] = ACTIONS(7876),
    [anon_sym_CARET_EQ] = ACTIONS(7876),
    [anon_sym_QMARK] = ACTIONS(7876),
    [anon_sym_COLON2] = ACTIONS(7878),
    [anon_sym_DOT_DOT] = ACTIONS(7878),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7876),
    [anon_sym_and] = ACTIONS(7876),
    [anon_sym_or] = ACTIONS(7876),
    [anon_sym_PIPE_PIPE] = ACTIONS(7878),
    [anon_sym_AMP_AMP] = ACTIONS(7878),
    [anon_sym_LT_LT] = ACTIONS(7878),
    [anon_sym_GT_GT] = ACTIONS(7878),
    [anon_sym_EQ_EQ] = ACTIONS(7878),
    [anon_sym_BANG_EQ] = ACTIONS(7876),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7876),
    [anon_sym_LT_EQ_GT] = ACTIONS(7876),
    [anon_sym_EQ_TILDE] = ACTIONS(7876),
    [anon_sym_BANG_TILDE] = ACTIONS(7876),
    [anon_sym_LT_EQ] = ACTIONS(7878),
    [anon_sym_GT] = ACTIONS(7878),
    [anon_sym_GT_EQ] = ACTIONS(7876),
    [anon_sym_CARET] = ACTIONS(7878),
    [anon_sym_PLUS] = ACTIONS(7878),
    [anon_sym_SLASH] = ACTIONS(7878),
    [anon_sym_PERCENT] = ACTIONS(7878),
    [sym_comment] = ACTIONS(87),
  },
  [4339] = {
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(3509),
    [sym__binary_star] = ACTIONS(3511),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(3513),
    [anon_sym_STAR_STAR] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(3517),
    [anon_sym_EQ] = ACTIONS(7884),
    [anon_sym_LT] = ACTIONS(3519),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_EQ_GT] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_PLUS_EQ] = ACTIONS(7027),
    [anon_sym_DASH_EQ] = ACTIONS(7027),
    [anon_sym_STAR_EQ] = ACTIONS(7027),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7027),
    [anon_sym_SLASH_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7027),
    [anon_sym_AMP_EQ] = ACTIONS(7027),
    [anon_sym_PERCENT_EQ] = ACTIONS(7027),
    [anon_sym_GT_GT_EQ] = ACTIONS(7027),
    [anon_sym_LT_LT_EQ] = ACTIONS(7027),
    [anon_sym_CARET_EQ] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(3521),
    [anon_sym_DOT_DOT] = ACTIONS(3523),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3525),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(3527),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_LT_LT] = ACTIONS(3529),
    [anon_sym_GT_GT] = ACTIONS(3529),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ] = ACTIONS(3531),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3531),
    [anon_sym_LT_EQ_GT] = ACTIONS(3531),
    [anon_sym_EQ_TILDE] = ACTIONS(3531),
    [anon_sym_BANG_TILDE] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3519),
    [anon_sym_GT] = ACTIONS(3519),
    [anon_sym_GT_EQ] = ACTIONS(3533),
    [anon_sym_CARET] = ACTIONS(3513),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_SLASH] = ACTIONS(3515),
    [anon_sym_PERCENT] = ACTIONS(3515),
    [sym_comment] = ACTIONS(87),
  },
  [4340] = {
    [sym__heredoc_body_start] = ACTIONS(5725),
    [sym__binary_minus] = ACTIONS(5725),
    [sym__binary_star] = ACTIONS(5725),
    [anon_sym_LBRACE] = ACTIONS(5725),
    [anon_sym_RBRACE] = ACTIONS(5725),
    [anon_sym_RPAREN] = ACTIONS(5725),
    [anon_sym_DOT] = ACTIONS(5727),
    [anon_sym_COMMA] = ACTIONS(5725),
    [anon_sym_PIPE] = ACTIONS(5727),
    [anon_sym_SEMI] = ACTIONS(5725),
    [anon_sym_STAR_STAR] = ACTIONS(5727),
    [anon_sym_AMP] = ACTIONS(5727),
    [anon_sym_EQ] = ACTIONS(5727),
    [anon_sym_LT] = ACTIONS(5727),
    [anon_sym_if] = ACTIONS(5725),
    [anon_sym_unless] = ACTIONS(5725),
    [anon_sym_while] = ACTIONS(5725),
    [anon_sym_until] = ACTIONS(5725),
    [anon_sym_rescue] = ACTIONS(5725),
    [anon_sym_in] = ACTIONS(5725),
    [anon_sym_do] = ACTIONS(5725),
    [anon_sym_EQ_GT] = ACTIONS(5725),
    [anon_sym_LBRACK] = ACTIONS(5725),
    [anon_sym_RBRACK] = ACTIONS(5725),
    [anon_sym_COLON_COLON2] = ACTIONS(5725),
    [anon_sym_AMP_DOT] = ACTIONS(5725),
    [anon_sym_PLUS_EQ] = ACTIONS(5725),
    [anon_sym_DASH_EQ] = ACTIONS(5725),
    [anon_sym_STAR_EQ] = ACTIONS(5725),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5725),
    [anon_sym_SLASH_EQ] = ACTIONS(5725),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5725),
    [anon_sym_PIPE_EQ] = ACTIONS(5725),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5725),
    [anon_sym_AMP_EQ] = ACTIONS(5725),
    [anon_sym_PERCENT_EQ] = ACTIONS(5725),
    [anon_sym_GT_GT_EQ] = ACTIONS(5725),
    [anon_sym_LT_LT_EQ] = ACTIONS(5725),
    [anon_sym_CARET_EQ] = ACTIONS(5725),
    [anon_sym_QMARK] = ACTIONS(5725),
    [anon_sym_COLON2] = ACTIONS(5727),
    [anon_sym_DOT_DOT] = ACTIONS(5727),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5725),
    [anon_sym_and] = ACTIONS(5725),
    [anon_sym_or] = ACTIONS(5725),
    [anon_sym_PIPE_PIPE] = ACTIONS(5727),
    [anon_sym_AMP_AMP] = ACTIONS(5727),
    [anon_sym_LT_LT] = ACTIONS(5727),
    [anon_sym_GT_GT] = ACTIONS(5727),
    [anon_sym_EQ_EQ] = ACTIONS(5727),
    [anon_sym_BANG_EQ] = ACTIONS(5725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5725),
    [anon_sym_LT_EQ_GT] = ACTIONS(5725),
    [anon_sym_EQ_TILDE] = ACTIONS(5725),
    [anon_sym_BANG_TILDE] = ACTIONS(5725),
    [anon_sym_LT_EQ] = ACTIONS(5727),
    [anon_sym_GT] = ACTIONS(5727),
    [anon_sym_GT_EQ] = ACTIONS(5725),
    [anon_sym_CARET] = ACTIONS(5727),
    [anon_sym_PLUS] = ACTIONS(5727),
    [anon_sym_SLASH] = ACTIONS(5727),
    [anon_sym_PERCENT] = ACTIONS(5727),
    [sym_comment] = ACTIONS(87),
  },
  [4341] = {
    [sym__heredoc_body_start] = ACTIONS(5735),
    [sym__binary_minus] = ACTIONS(5735),
    [sym__binary_star] = ACTIONS(5735),
    [anon_sym_LBRACE] = ACTIONS(5735),
    [anon_sym_RBRACE] = ACTIONS(5735),
    [anon_sym_RPAREN] = ACTIONS(5735),
    [anon_sym_DOT] = ACTIONS(5737),
    [anon_sym_COMMA] = ACTIONS(5735),
    [anon_sym_PIPE] = ACTIONS(5737),
    [anon_sym_SEMI] = ACTIONS(5735),
    [anon_sym_STAR_STAR] = ACTIONS(5737),
    [anon_sym_AMP] = ACTIONS(5737),
    [anon_sym_EQ] = ACTIONS(5737),
    [anon_sym_LT] = ACTIONS(5737),
    [anon_sym_if] = ACTIONS(5735),
    [anon_sym_unless] = ACTIONS(5735),
    [anon_sym_while] = ACTIONS(5735),
    [anon_sym_until] = ACTIONS(5735),
    [anon_sym_rescue] = ACTIONS(5735),
    [anon_sym_in] = ACTIONS(5735),
    [anon_sym_do] = ACTIONS(5735),
    [anon_sym_EQ_GT] = ACTIONS(5735),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_RBRACK] = ACTIONS(5735),
    [anon_sym_COLON_COLON2] = ACTIONS(5735),
    [anon_sym_AMP_DOT] = ACTIONS(5735),
    [anon_sym_PLUS_EQ] = ACTIONS(5735),
    [anon_sym_DASH_EQ] = ACTIONS(5735),
    [anon_sym_STAR_EQ] = ACTIONS(5735),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5735),
    [anon_sym_SLASH_EQ] = ACTIONS(5735),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5735),
    [anon_sym_PIPE_EQ] = ACTIONS(5735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5735),
    [anon_sym_AMP_EQ] = ACTIONS(5735),
    [anon_sym_PERCENT_EQ] = ACTIONS(5735),
    [anon_sym_GT_GT_EQ] = ACTIONS(5735),
    [anon_sym_LT_LT_EQ] = ACTIONS(5735),
    [anon_sym_CARET_EQ] = ACTIONS(5735),
    [anon_sym_QMARK] = ACTIONS(5735),
    [anon_sym_COLON2] = ACTIONS(5737),
    [anon_sym_DOT_DOT] = ACTIONS(5737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5735),
    [anon_sym_and] = ACTIONS(5735),
    [anon_sym_or] = ACTIONS(5735),
    [anon_sym_PIPE_PIPE] = ACTIONS(5737),
    [anon_sym_AMP_AMP] = ACTIONS(5737),
    [anon_sym_LT_LT] = ACTIONS(5737),
    [anon_sym_GT_GT] = ACTIONS(5737),
    [anon_sym_EQ_EQ] = ACTIONS(5737),
    [anon_sym_BANG_EQ] = ACTIONS(5735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5735),
    [anon_sym_LT_EQ_GT] = ACTIONS(5735),
    [anon_sym_EQ_TILDE] = ACTIONS(5735),
    [anon_sym_BANG_TILDE] = ACTIONS(5735),
    [anon_sym_LT_EQ] = ACTIONS(5737),
    [anon_sym_GT] = ACTIONS(5737),
    [anon_sym_GT_EQ] = ACTIONS(5735),
    [anon_sym_CARET] = ACTIONS(5737),
    [anon_sym_PLUS] = ACTIONS(5737),
    [anon_sym_SLASH] = ACTIONS(5737),
    [anon_sym_PERCENT] = ACTIONS(5737),
    [sym_comment] = ACTIONS(87),
  },
  [4342] = {
    [sym__heredoc_body_start] = ACTIONS(5807),
    [sym__binary_minus] = ACTIONS(5807),
    [sym__binary_star] = ACTIONS(5807),
    [anon_sym_LBRACE] = ACTIONS(5807),
    [anon_sym_RBRACE] = ACTIONS(5807),
    [anon_sym_RPAREN] = ACTIONS(5807),
    [anon_sym_DOT] = ACTIONS(5809),
    [anon_sym_COMMA] = ACTIONS(5807),
    [anon_sym_PIPE] = ACTIONS(5809),
    [anon_sym_SEMI] = ACTIONS(5807),
    [anon_sym_STAR_STAR] = ACTIONS(5809),
    [anon_sym_AMP] = ACTIONS(5809),
    [anon_sym_EQ] = ACTIONS(5809),
    [anon_sym_LT] = ACTIONS(5809),
    [anon_sym_if] = ACTIONS(5807),
    [anon_sym_unless] = ACTIONS(5807),
    [anon_sym_while] = ACTIONS(5807),
    [anon_sym_until] = ACTIONS(5807),
    [anon_sym_rescue] = ACTIONS(5807),
    [anon_sym_in] = ACTIONS(5807),
    [anon_sym_do] = ACTIONS(5807),
    [anon_sym_EQ_GT] = ACTIONS(5807),
    [anon_sym_LBRACK] = ACTIONS(5807),
    [anon_sym_RBRACK] = ACTIONS(5807),
    [anon_sym_COLON_COLON2] = ACTIONS(5807),
    [anon_sym_AMP_DOT] = ACTIONS(5807),
    [anon_sym_PLUS_EQ] = ACTIONS(5807),
    [anon_sym_DASH_EQ] = ACTIONS(5807),
    [anon_sym_STAR_EQ] = ACTIONS(5807),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5807),
    [anon_sym_SLASH_EQ] = ACTIONS(5807),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5807),
    [anon_sym_PIPE_EQ] = ACTIONS(5807),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5807),
    [anon_sym_AMP_EQ] = ACTIONS(5807),
    [anon_sym_PERCENT_EQ] = ACTIONS(5807),
    [anon_sym_GT_GT_EQ] = ACTIONS(5807),
    [anon_sym_LT_LT_EQ] = ACTIONS(5807),
    [anon_sym_CARET_EQ] = ACTIONS(5807),
    [anon_sym_QMARK] = ACTIONS(5807),
    [anon_sym_COLON2] = ACTIONS(5809),
    [anon_sym_DOT_DOT] = ACTIONS(5809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5807),
    [anon_sym_and] = ACTIONS(5807),
    [anon_sym_or] = ACTIONS(5807),
    [anon_sym_PIPE_PIPE] = ACTIONS(5809),
    [anon_sym_AMP_AMP] = ACTIONS(5809),
    [anon_sym_LT_LT] = ACTIONS(5809),
    [anon_sym_GT_GT] = ACTIONS(5809),
    [anon_sym_EQ_EQ] = ACTIONS(5809),
    [anon_sym_BANG_EQ] = ACTIONS(5807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5807),
    [anon_sym_LT_EQ_GT] = ACTIONS(5807),
    [anon_sym_EQ_TILDE] = ACTIONS(5807),
    [anon_sym_BANG_TILDE] = ACTIONS(5807),
    [anon_sym_LT_EQ] = ACTIONS(5809),
    [anon_sym_GT] = ACTIONS(5809),
    [anon_sym_GT_EQ] = ACTIONS(5807),
    [anon_sym_CARET] = ACTIONS(5809),
    [anon_sym_PLUS] = ACTIONS(5809),
    [anon_sym_SLASH] = ACTIONS(5809),
    [anon_sym_PERCENT] = ACTIONS(5809),
    [sym_comment] = ACTIONS(87),
  },
  [4343] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(3511),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(3515),
    [anon_sym_PERCENT] = ACTIONS(3515),
    [sym_comment] = ACTIONS(87),
  },
  [4344] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(5827),
    [anon_sym_PERCENT] = ACTIONS(5827),
    [sym_comment] = ACTIONS(87),
  },
  [4345] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(3509),
    [sym__binary_star] = ACTIONS(3511),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(3517),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(3529),
    [anon_sym_GT_GT] = ACTIONS(3529),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_SLASH] = ACTIONS(3515),
    [anon_sym_PERCENT] = ACTIONS(3515),
    [sym_comment] = ACTIONS(87),
  },
  [4346] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(3509),
    [sym__binary_star] = ACTIONS(3511),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(3529),
    [anon_sym_GT_GT] = ACTIONS(3529),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_SLASH] = ACTIONS(3515),
    [anon_sym_PERCENT] = ACTIONS(3515),
    [sym_comment] = ACTIONS(87),
  },
  [4347] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(3509),
    [sym__binary_star] = ACTIONS(3511),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(3513),
    [anon_sym_STAR_STAR] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(3517),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(3529),
    [anon_sym_GT_GT] = ACTIONS(3529),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(3513),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_SLASH] = ACTIONS(3515),
    [anon_sym_PERCENT] = ACTIONS(3515),
    [sym_comment] = ACTIONS(87),
  },
  [4348] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(10549),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [4349] = {
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(3509),
    [sym__binary_star] = ACTIONS(3511),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(3513),
    [anon_sym_STAR_STAR] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(3517),
    [anon_sym_EQ] = ACTIONS(7888),
    [anon_sym_LT] = ACTIONS(3519),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_EQ_GT] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_PLUS_EQ] = ACTIONS(5927),
    [anon_sym_DASH_EQ] = ACTIONS(5927),
    [anon_sym_STAR_EQ] = ACTIONS(5927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5927),
    [anon_sym_SLASH_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5927),
    [anon_sym_AMP_EQ] = ACTIONS(5927),
    [anon_sym_PERCENT_EQ] = ACTIONS(5927),
    [anon_sym_GT_GT_EQ] = ACTIONS(5927),
    [anon_sym_LT_LT_EQ] = ACTIONS(5927),
    [anon_sym_CARET_EQ] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(3523),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3525),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3527),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_LT_LT] = ACTIONS(3529),
    [anon_sym_GT_GT] = ACTIONS(3529),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ] = ACTIONS(3531),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3531),
    [anon_sym_LT_EQ_GT] = ACTIONS(3531),
    [anon_sym_EQ_TILDE] = ACTIONS(3531),
    [anon_sym_BANG_TILDE] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3519),
    [anon_sym_GT] = ACTIONS(3519),
    [anon_sym_GT_EQ] = ACTIONS(3533),
    [anon_sym_CARET] = ACTIONS(3513),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_SLASH] = ACTIONS(3515),
    [anon_sym_PERCENT] = ACTIONS(3515),
    [sym_comment] = ACTIONS(87),
  },
  [4350] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(3509),
    [sym__binary_star] = ACTIONS(3511),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(3513),
    [anon_sym_STAR_STAR] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(3517),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(3519),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(3521),
    [anon_sym_DOT_DOT] = ACTIONS(3523),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3525),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(3527),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_LT_LT] = ACTIONS(3529),
    [anon_sym_GT_GT] = ACTIONS(3529),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ] = ACTIONS(3531),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3531),
    [anon_sym_LT_EQ_GT] = ACTIONS(3531),
    [anon_sym_EQ_TILDE] = ACTIONS(3531),
    [anon_sym_BANG_TILDE] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3519),
    [anon_sym_GT] = ACTIONS(3519),
    [anon_sym_GT_EQ] = ACTIONS(3533),
    [anon_sym_CARET] = ACTIONS(3513),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_SLASH] = ACTIONS(3515),
    [anon_sym_PERCENT] = ACTIONS(3515),
    [sym_comment] = ACTIONS(87),
  },
  [4351] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(3509),
    [sym__binary_star] = ACTIONS(3511),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(3513),
    [anon_sym_STAR_STAR] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(3517),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(3519),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(3529),
    [anon_sym_GT_GT] = ACTIONS(3529),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ] = ACTIONS(3531),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3531),
    [anon_sym_LT_EQ_GT] = ACTIONS(3531),
    [anon_sym_EQ_TILDE] = ACTIONS(3531),
    [anon_sym_BANG_TILDE] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3519),
    [anon_sym_GT] = ACTIONS(3519),
    [anon_sym_GT_EQ] = ACTIONS(3533),
    [anon_sym_CARET] = ACTIONS(3513),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_SLASH] = ACTIONS(3515),
    [anon_sym_PERCENT] = ACTIONS(3515),
    [sym_comment] = ACTIONS(87),
  },
  [4352] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(3509),
    [sym__binary_star] = ACTIONS(3511),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_SLASH] = ACTIONS(3515),
    [anon_sym_PERCENT] = ACTIONS(3515),
    [sym_comment] = ACTIONS(87),
  },
  [4353] = {
    [sym__binary_minus] = ACTIONS(5735),
    [sym__binary_star] = ACTIONS(5735),
    [anon_sym_DOT] = ACTIONS(5737),
    [anon_sym_COMMA] = ACTIONS(5735),
    [anon_sym_PIPE] = ACTIONS(5737),
    [anon_sym_STAR_STAR] = ACTIONS(5737),
    [anon_sym_AMP] = ACTIONS(5737),
    [anon_sym_EQ] = ACTIONS(5737),
    [anon_sym_LT] = ACTIONS(5737),
    [anon_sym_EQ_GT] = ACTIONS(5735),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_COLON_COLON2] = ACTIONS(5735),
    [anon_sym_AMP_DOT] = ACTIONS(5735),
    [anon_sym_PLUS_EQ] = ACTIONS(5735),
    [anon_sym_DASH_EQ] = ACTIONS(5735),
    [anon_sym_STAR_EQ] = ACTIONS(5735),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5735),
    [anon_sym_SLASH_EQ] = ACTIONS(5735),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5735),
    [anon_sym_PIPE_EQ] = ACTIONS(5735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5735),
    [anon_sym_AMP_EQ] = ACTIONS(5735),
    [anon_sym_PERCENT_EQ] = ACTIONS(5735),
    [anon_sym_GT_GT_EQ] = ACTIONS(5735),
    [anon_sym_LT_LT_EQ] = ACTIONS(5735),
    [anon_sym_CARET_EQ] = ACTIONS(5735),
    [anon_sym_QMARK] = ACTIONS(5735),
    [anon_sym_DOT_DOT] = ACTIONS(5737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5735),
    [anon_sym_and] = ACTIONS(5735),
    [anon_sym_or] = ACTIONS(5735),
    [anon_sym_PIPE_PIPE] = ACTIONS(5737),
    [anon_sym_AMP_AMP] = ACTIONS(5737),
    [anon_sym_LT_LT] = ACTIONS(5737),
    [anon_sym_GT_GT] = ACTIONS(5737),
    [anon_sym_EQ_EQ] = ACTIONS(5737),
    [anon_sym_BANG_EQ] = ACTIONS(5735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5735),
    [anon_sym_LT_EQ_GT] = ACTIONS(5735),
    [anon_sym_EQ_TILDE] = ACTIONS(5735),
    [anon_sym_BANG_TILDE] = ACTIONS(5735),
    [anon_sym_LT_EQ] = ACTIONS(5737),
    [anon_sym_GT] = ACTIONS(5737),
    [anon_sym_GT_EQ] = ACTIONS(5735),
    [anon_sym_CARET] = ACTIONS(5737),
    [anon_sym_PLUS] = ACTIONS(5737),
    [anon_sym_SLASH] = ACTIONS(5737),
    [anon_sym_PERCENT] = ACTIONS(5737),
    [sym_comment] = ACTIONS(87),
  },
  [4354] = {
    [sym__heredoc_body_start] = ACTIONS(3235),
    [sym__binary_minus] = ACTIONS(3235),
    [sym__binary_star] = ACTIONS(3235),
    [anon_sym_LBRACE] = ACTIONS(3235),
    [anon_sym_RBRACE] = ACTIONS(3235),
    [anon_sym_RPAREN] = ACTIONS(3235),
    [anon_sym_DOT] = ACTIONS(4997),
    [anon_sym_COMMA] = ACTIONS(3235),
    [anon_sym_PIPE] = ACTIONS(4997),
    [anon_sym_SEMI] = ACTIONS(3235),
    [anon_sym_STAR_STAR] = ACTIONS(4997),
    [anon_sym_AMP] = ACTIONS(4997),
    [anon_sym_EQ] = ACTIONS(4997),
    [anon_sym_LT] = ACTIONS(4997),
    [anon_sym_if] = ACTIONS(3235),
    [anon_sym_unless] = ACTIONS(3235),
    [anon_sym_while] = ACTIONS(3235),
    [anon_sym_until] = ACTIONS(3235),
    [anon_sym_rescue] = ACTIONS(3235),
    [anon_sym_in] = ACTIONS(3235),
    [anon_sym_do] = ACTIONS(3235),
    [anon_sym_EQ_GT] = ACTIONS(3235),
    [anon_sym_LBRACK] = ACTIONS(3235),
    [anon_sym_RBRACK] = ACTIONS(3235),
    [anon_sym_COLON_COLON2] = ACTIONS(3235),
    [anon_sym_AMP_DOT] = ACTIONS(3235),
    [anon_sym_PLUS_EQ] = ACTIONS(3235),
    [anon_sym_DASH_EQ] = ACTIONS(3235),
    [anon_sym_STAR_EQ] = ACTIONS(3235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3235),
    [anon_sym_SLASH_EQ] = ACTIONS(3235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3235),
    [anon_sym_PIPE_EQ] = ACTIONS(3235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3235),
    [anon_sym_AMP_EQ] = ACTIONS(3235),
    [anon_sym_PERCENT_EQ] = ACTIONS(3235),
    [anon_sym_GT_GT_EQ] = ACTIONS(3235),
    [anon_sym_LT_LT_EQ] = ACTIONS(3235),
    [anon_sym_CARET_EQ] = ACTIONS(3235),
    [anon_sym_QMARK] = ACTIONS(3235),
    [anon_sym_COLON2] = ACTIONS(4997),
    [anon_sym_DOT_DOT] = ACTIONS(4997),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3235),
    [anon_sym_and] = ACTIONS(3235),
    [anon_sym_or] = ACTIONS(3235),
    [anon_sym_PIPE_PIPE] = ACTIONS(4997),
    [anon_sym_AMP_AMP] = ACTIONS(4997),
    [anon_sym_LT_LT] = ACTIONS(4997),
    [anon_sym_GT_GT] = ACTIONS(4997),
    [anon_sym_EQ_EQ] = ACTIONS(4997),
    [anon_sym_BANG_EQ] = ACTIONS(3235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3235),
    [anon_sym_LT_EQ_GT] = ACTIONS(3235),
    [anon_sym_EQ_TILDE] = ACTIONS(3235),
    [anon_sym_BANG_TILDE] = ACTIONS(3235),
    [anon_sym_LT_EQ] = ACTIONS(4997),
    [anon_sym_GT] = ACTIONS(4997),
    [anon_sym_GT_EQ] = ACTIONS(3235),
    [anon_sym_CARET] = ACTIONS(4997),
    [anon_sym_PLUS] = ACTIONS(4997),
    [anon_sym_SLASH] = ACTIONS(4997),
    [anon_sym_PERCENT] = ACTIONS(4997),
    [sym_comment] = ACTIONS(87),
  },
  [4355] = {
    [sym_interpolation] = STATE(1787),
    [aux_sym_heredoc_body_repeat1] = STATE(1787),
    [sym__heredoc_content] = ACTIONS(3237),
    [sym_heredoc_end] = ACTIONS(10551),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(3237),
  },
  [4356] = {
    [sym_heredoc_body] = STATE(4356),
    [aux_sym_call_repeat1] = STATE(4356),
    [sym__heredoc_body_start] = ACTIONS(10553),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_STAR_STAR] = ACTIONS(7919),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_EQ] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_EQ_GT] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_PLUS_EQ] = ACTIONS(7914),
    [anon_sym_DASH_EQ] = ACTIONS(7914),
    [anon_sym_STAR_EQ] = ACTIONS(7914),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7914),
    [anon_sym_SLASH_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7914),
    [anon_sym_AMP_EQ] = ACTIONS(7914),
    [anon_sym_PERCENT_EQ] = ACTIONS(7914),
    [anon_sym_GT_GT_EQ] = ACTIONS(7914),
    [anon_sym_LT_LT_EQ] = ACTIONS(7914),
    [anon_sym_CARET_EQ] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7919),
    [anon_sym_AMP_AMP] = ACTIONS(7919),
    [anon_sym_LT_LT] = ACTIONS(7919),
    [anon_sym_GT_GT] = ACTIONS(7919),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7919),
    [anon_sym_PLUS] = ACTIONS(7919),
    [anon_sym_SLASH] = ACTIONS(7919),
    [anon_sym_PERCENT] = ACTIONS(7919),
    [sym_comment] = ACTIONS(87),
  },
  [4357] = {
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_RBRACE] = ACTIONS(7925),
    [anon_sym_RPAREN] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(7925),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7927),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_EQ] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_if] = ACTIONS(7925),
    [anon_sym_unless] = ACTIONS(7925),
    [anon_sym_while] = ACTIONS(7925),
    [anon_sym_until] = ACTIONS(7925),
    [anon_sym_rescue] = ACTIONS(7925),
    [anon_sym_in] = ACTIONS(7925),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_EQ_GT] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_RBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_PLUS_EQ] = ACTIONS(7925),
    [anon_sym_DASH_EQ] = ACTIONS(7925),
    [anon_sym_STAR_EQ] = ACTIONS(7925),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7925),
    [anon_sym_SLASH_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7925),
    [anon_sym_AMP_EQ] = ACTIONS(7925),
    [anon_sym_PERCENT_EQ] = ACTIONS(7925),
    [anon_sym_GT_GT_EQ] = ACTIONS(7925),
    [anon_sym_LT_LT_EQ] = ACTIONS(7925),
    [anon_sym_CARET_EQ] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_COLON2] = ACTIONS(7927),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7927),
    [anon_sym_AMP_AMP] = ACTIONS(7927),
    [anon_sym_LT_LT] = ACTIONS(7927),
    [anon_sym_GT_GT] = ACTIONS(7927),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7927),
    [anon_sym_PLUS] = ACTIONS(7927),
    [anon_sym_SLASH] = ACTIONS(7927),
    [anon_sym_PERCENT] = ACTIONS(7927),
    [sym_comment] = ACTIONS(87),
  },
  [4358] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(644),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym__argument] = STATE(6970),
    [sym_splat_argument] = STATE(6970),
    [sym_hash_splat_argument] = STATE(6970),
    [sym_block_argument] = STATE(6970),
    [sym_assignment] = STATE(644),
    [sym_operator_assignment] = STATE(644),
    [sym_conditional] = STATE(644),
    [sym_range] = STATE(644),
    [sym_binary] = STATE(644),
    [sym_unary] = STATE(644),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(653),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(6970),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(1155),
    [sym__splat_star] = ACTIONS(1157),
    [sym__unary_minus] = ACTIONS(1159),
    [sym__identifier_hash_key] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(3469),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1209),
    [sym_identifier] = ACTIONS(1209),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4359] = {
    [sym_heredoc_body] = STATE(4356),
    [aux_sym_call_repeat1] = STATE(4356),
    [sym__heredoc_body_start] = ACTIONS(3543),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_STAR_STAR] = ACTIONS(7931),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_EQ] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_EQ_GT] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_PLUS_EQ] = ACTIONS(7929),
    [anon_sym_DASH_EQ] = ACTIONS(7929),
    [anon_sym_STAR_EQ] = ACTIONS(7929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7929),
    [anon_sym_SLASH_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7929),
    [anon_sym_AMP_EQ] = ACTIONS(7929),
    [anon_sym_PERCENT_EQ] = ACTIONS(7929),
    [anon_sym_GT_GT_EQ] = ACTIONS(7929),
    [anon_sym_LT_LT_EQ] = ACTIONS(7929),
    [anon_sym_CARET_EQ] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7931),
    [anon_sym_AMP_AMP] = ACTIONS(7931),
    [anon_sym_LT_LT] = ACTIONS(7931),
    [anon_sym_GT_GT] = ACTIONS(7931),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7931),
    [anon_sym_PLUS] = ACTIONS(7931),
    [anon_sym_SLASH] = ACTIONS(7931),
    [anon_sym_PERCENT] = ACTIONS(7931),
    [sym_comment] = ACTIONS(87),
  },
  [4360] = {
    [aux_sym_argument_list_repeat1] = STATE(4360),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(10556),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_STAR_STAR] = ACTIONS(7927),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_EQ] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_EQ_GT] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_PLUS_EQ] = ACTIONS(7925),
    [anon_sym_DASH_EQ] = ACTIONS(7925),
    [anon_sym_STAR_EQ] = ACTIONS(7925),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7925),
    [anon_sym_SLASH_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7925),
    [anon_sym_AMP_EQ] = ACTIONS(7925),
    [anon_sym_PERCENT_EQ] = ACTIONS(7925),
    [anon_sym_GT_GT_EQ] = ACTIONS(7925),
    [anon_sym_LT_LT_EQ] = ACTIONS(7925),
    [anon_sym_CARET_EQ] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7927),
    [anon_sym_AMP_AMP] = ACTIONS(7927),
    [anon_sym_LT_LT] = ACTIONS(7927),
    [anon_sym_GT_GT] = ACTIONS(7927),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7927),
    [anon_sym_PLUS] = ACTIONS(7927),
    [anon_sym_SLASH] = ACTIONS(7927),
    [anon_sym_PERCENT] = ACTIONS(7927),
    [sym_comment] = ACTIONS(87),
  },
  [4361] = {
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(3509),
    [sym__binary_star] = ACTIONS(3511),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(3513),
    [anon_sym_STAR_STAR] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(3517),
    [anon_sym_EQ] = ACTIONS(7936),
    [anon_sym_LT] = ACTIONS(3519),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_EQ_GT] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_PLUS_EQ] = ACTIONS(5115),
    [anon_sym_DASH_EQ] = ACTIONS(5115),
    [anon_sym_STAR_EQ] = ACTIONS(5115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5115),
    [anon_sym_SLASH_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5115),
    [anon_sym_AMP_EQ] = ACTIONS(5115),
    [anon_sym_PERCENT_EQ] = ACTIONS(5115),
    [anon_sym_GT_GT_EQ] = ACTIONS(5115),
    [anon_sym_LT_LT_EQ] = ACTIONS(5115),
    [anon_sym_CARET_EQ] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(3521),
    [anon_sym_DOT_DOT] = ACTIONS(3523),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3525),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(3527),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_LT_LT] = ACTIONS(3529),
    [anon_sym_GT_GT] = ACTIONS(3529),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ] = ACTIONS(3531),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3531),
    [anon_sym_LT_EQ_GT] = ACTIONS(3531),
    [anon_sym_EQ_TILDE] = ACTIONS(3531),
    [anon_sym_BANG_TILDE] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3519),
    [anon_sym_GT] = ACTIONS(3519),
    [anon_sym_GT_EQ] = ACTIONS(3533),
    [anon_sym_CARET] = ACTIONS(3513),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_SLASH] = ACTIONS(3515),
    [anon_sym_PERCENT] = ACTIONS(3515),
    [sym_comment] = ACTIONS(87),
  },
  [4362] = {
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_RBRACE] = ACTIONS(6191),
    [anon_sym_RPAREN] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6193),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_in] = ACTIONS(6191),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_RBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_PLUS_EQ] = ACTIONS(6191),
    [anon_sym_DASH_EQ] = ACTIONS(6191),
    [anon_sym_STAR_EQ] = ACTIONS(6191),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6191),
    [anon_sym_SLASH_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6191),
    [anon_sym_AMP_EQ] = ACTIONS(6191),
    [anon_sym_PERCENT_EQ] = ACTIONS(6191),
    [anon_sym_GT_GT_EQ] = ACTIONS(6191),
    [anon_sym_LT_LT_EQ] = ACTIONS(6191),
    [anon_sym_CARET_EQ] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_COLON2] = ACTIONS(6193),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6193),
    [anon_sym_AMP_AMP] = ACTIONS(6193),
    [anon_sym_LT_LT] = ACTIONS(6193),
    [anon_sym_GT_GT] = ACTIONS(6193),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6193),
    [anon_sym_PLUS] = ACTIONS(6193),
    [anon_sym_SLASH] = ACTIONS(6193),
    [anon_sym_PERCENT] = ACTIONS(6193),
    [sym_comment] = ACTIONS(87),
  },
  [4363] = {
    [aux_sym_exceptions_repeat1] = STATE(6972),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_STAR_STAR] = ACTIONS(6193),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_PLUS_EQ] = ACTIONS(6191),
    [anon_sym_DASH_EQ] = ACTIONS(6191),
    [anon_sym_STAR_EQ] = ACTIONS(6191),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6191),
    [anon_sym_SLASH_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6191),
    [anon_sym_AMP_EQ] = ACTIONS(6191),
    [anon_sym_PERCENT_EQ] = ACTIONS(6191),
    [anon_sym_GT_GT_EQ] = ACTIONS(6191),
    [anon_sym_LT_LT_EQ] = ACTIONS(6191),
    [anon_sym_CARET_EQ] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6193),
    [anon_sym_AMP_AMP] = ACTIONS(6193),
    [anon_sym_LT_LT] = ACTIONS(6193),
    [anon_sym_GT_GT] = ACTIONS(6193),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6193),
    [anon_sym_PLUS] = ACTIONS(6193),
    [anon_sym_SLASH] = ACTIONS(6193),
    [anon_sym_PERCENT] = ACTIONS(6193),
    [sym_comment] = ACTIONS(87),
  },
  [4364] = {
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(3509),
    [sym__binary_star] = ACTIONS(3511),
    [anon_sym_LBRACE] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(3513),
    [anon_sym_STAR_STAR] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(3517),
    [anon_sym_EQ] = ACTIONS(7938),
    [anon_sym_LT] = ACTIONS(3519),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_EQ_GT] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_PLUS_EQ] = ACTIONS(6210),
    [anon_sym_DASH_EQ] = ACTIONS(6210),
    [anon_sym_STAR_EQ] = ACTIONS(6210),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6210),
    [anon_sym_SLASH_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6210),
    [anon_sym_AMP_EQ] = ACTIONS(6210),
    [anon_sym_PERCENT_EQ] = ACTIONS(6210),
    [anon_sym_GT_GT_EQ] = ACTIONS(6210),
    [anon_sym_LT_LT_EQ] = ACTIONS(6210),
    [anon_sym_CARET_EQ] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(3521),
    [anon_sym_DOT_DOT] = ACTIONS(3523),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3525),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(3527),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_LT_LT] = ACTIONS(3529),
    [anon_sym_GT_GT] = ACTIONS(3529),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ] = ACTIONS(3531),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3531),
    [anon_sym_LT_EQ_GT] = ACTIONS(3531),
    [anon_sym_EQ_TILDE] = ACTIONS(3531),
    [anon_sym_BANG_TILDE] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3519),
    [anon_sym_GT] = ACTIONS(3519),
    [anon_sym_GT_EQ] = ACTIONS(3533),
    [anon_sym_CARET] = ACTIONS(3513),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_SLASH] = ACTIONS(3515),
    [anon_sym_PERCENT] = ACTIONS(3515),
    [sym_comment] = ACTIONS(87),
  },
  [4365] = {
    [sym_string] = STATE(4365),
    [aux_sym_chained_string_repeat1] = STATE(4365),
    [sym__string_start] = ACTIONS(10559),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_STAR_STAR] = ACTIONS(6217),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_EQ] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_do] = ACTIONS(6212),
    [anon_sym_EQ_GT] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_PLUS_EQ] = ACTIONS(6212),
    [anon_sym_DASH_EQ] = ACTIONS(6212),
    [anon_sym_STAR_EQ] = ACTIONS(6212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6212),
    [anon_sym_SLASH_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6212),
    [anon_sym_AMP_EQ] = ACTIONS(6212),
    [anon_sym_PERCENT_EQ] = ACTIONS(6212),
    [anon_sym_GT_GT_EQ] = ACTIONS(6212),
    [anon_sym_LT_LT_EQ] = ACTIONS(6212),
    [anon_sym_CARET_EQ] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6217),
    [anon_sym_AMP_AMP] = ACTIONS(6217),
    [anon_sym_LT_LT] = ACTIONS(6217),
    [anon_sym_GT_GT] = ACTIONS(6217),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6217),
    [anon_sym_PLUS] = ACTIONS(6217),
    [anon_sym_SLASH] = ACTIONS(6217),
    [anon_sym_PERCENT] = ACTIONS(6217),
    [sym_comment] = ACTIONS(87),
  },
  [4366] = {
    [sym__binary_minus] = ACTIONS(7125),
    [sym__binary_star] = ACTIONS(7127),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(7129),
    [anon_sym_STAR_STAR] = ACTIONS(7127),
    [anon_sym_AMP] = ACTIONS(7131),
    [anon_sym_LT] = ACTIONS(7133),
    [anon_sym_EQ_GT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(7135),
    [anon_sym_DOT_DOT] = ACTIONS(7137),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7139),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(7141),
    [anon_sym_AMP_AMP] = ACTIONS(7141),
    [anon_sym_LT_LT] = ACTIONS(7143),
    [anon_sym_GT_GT] = ACTIONS(7143),
    [anon_sym_EQ_EQ] = ACTIONS(7145),
    [anon_sym_BANG_EQ] = ACTIONS(7141),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7141),
    [anon_sym_LT_EQ_GT] = ACTIONS(7141),
    [anon_sym_EQ_TILDE] = ACTIONS(7141),
    [anon_sym_BANG_TILDE] = ACTIONS(7141),
    [anon_sym_LT_EQ] = ACTIONS(7133),
    [anon_sym_GT] = ACTIONS(7133),
    [anon_sym_GT_EQ] = ACTIONS(7147),
    [anon_sym_CARET] = ACTIONS(7149),
    [anon_sym_PLUS] = ACTIONS(7125),
    [anon_sym_SLASH] = ACTIONS(7127),
    [anon_sym_PERCENT] = ACTIONS(7127),
    [sym_comment] = ACTIONS(87),
  },
  [4367] = {
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(7127),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [4368] = {
    [sym__binary_minus] = ACTIONS(7125),
    [sym__binary_star] = ACTIONS(7127),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(7129),
    [anon_sym_STAR_STAR] = ACTIONS(7127),
    [anon_sym_AMP] = ACTIONS(7131),
    [anon_sym_LT] = ACTIONS(7133),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(7135),
    [anon_sym_DOT_DOT] = ACTIONS(7137),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7139),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(7141),
    [anon_sym_AMP_AMP] = ACTIONS(7141),
    [anon_sym_LT_LT] = ACTIONS(7143),
    [anon_sym_GT_GT] = ACTIONS(7143),
    [anon_sym_EQ_EQ] = ACTIONS(7145),
    [anon_sym_BANG_EQ] = ACTIONS(7141),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7141),
    [anon_sym_LT_EQ_GT] = ACTIONS(7141),
    [anon_sym_EQ_TILDE] = ACTIONS(7141),
    [anon_sym_BANG_TILDE] = ACTIONS(7141),
    [anon_sym_LT_EQ] = ACTIONS(7133),
    [anon_sym_GT] = ACTIONS(7133),
    [anon_sym_GT_EQ] = ACTIONS(7147),
    [anon_sym_CARET] = ACTIONS(7149),
    [anon_sym_PLUS] = ACTIONS(7125),
    [anon_sym_SLASH] = ACTIONS(7127),
    [anon_sym_PERCENT] = ACTIONS(7127),
    [sym_comment] = ACTIONS(87),
  },
  [4369] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(6973),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(2038),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(2038),
    [sym_assignment] = STATE(6973),
    [sym_operator_assignment] = STATE(6973),
    [sym_conditional] = STATE(6973),
    [sym_range] = STATE(6973),
    [sym_binary] = STATE(6973),
    [sym_unary] = STATE(6973),
    [sym_left_assignment_list] = STATE(2037),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2038),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(2038),
    [sym_false] = STATE(2038),
    [sym_nil] = STATE(2038),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(2039),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(3557),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3559),
    [anon_sym_yield] = ACTIONS(3561),
    [anon_sym_break] = ACTIONS(3563),
    [anon_sym_next] = ACTIONS(3565),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3567),
    [anon_sym_defined_QMARK] = ACTIONS(3569),
    [anon_sym_not] = ACTIONS(3571),
    [anon_sym_BANG] = ACTIONS(3573),
    [anon_sym_TILDE] = ACTIONS(3573),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4370] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(6974),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(2038),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(2038),
    [sym_assignment] = STATE(6974),
    [sym_operator_assignment] = STATE(6974),
    [sym_conditional] = STATE(6974),
    [sym_range] = STATE(6974),
    [sym_binary] = STATE(6974),
    [sym_unary] = STATE(6974),
    [sym_left_assignment_list] = STATE(2037),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2038),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(2038),
    [sym_false] = STATE(2038),
    [sym_nil] = STATE(2038),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(2039),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(3557),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3559),
    [anon_sym_yield] = ACTIONS(3561),
    [anon_sym_break] = ACTIONS(3563),
    [anon_sym_next] = ACTIONS(3565),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3567),
    [anon_sym_defined_QMARK] = ACTIONS(3569),
    [anon_sym_not] = ACTIONS(3571),
    [anon_sym_BANG] = ACTIONS(3573),
    [anon_sym_TILDE] = ACTIONS(3573),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4371] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(6975),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(2038),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(2038),
    [sym_assignment] = STATE(6975),
    [sym_operator_assignment] = STATE(6975),
    [sym_conditional] = STATE(6975),
    [sym_range] = STATE(6975),
    [sym_binary] = STATE(6975),
    [sym_unary] = STATE(6975),
    [sym_left_assignment_list] = STATE(2037),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2038),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(2038),
    [sym_false] = STATE(2038),
    [sym_nil] = STATE(2038),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(2039),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(3557),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3559),
    [anon_sym_yield] = ACTIONS(3561),
    [anon_sym_break] = ACTIONS(3563),
    [anon_sym_next] = ACTIONS(3565),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3567),
    [anon_sym_defined_QMARK] = ACTIONS(3569),
    [anon_sym_not] = ACTIONS(3571),
    [anon_sym_BANG] = ACTIONS(3573),
    [anon_sym_TILDE] = ACTIONS(3573),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4372] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(6976),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(2038),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(2038),
    [sym_assignment] = STATE(6976),
    [sym_operator_assignment] = STATE(6976),
    [sym_conditional] = STATE(6976),
    [sym_range] = STATE(6976),
    [sym_binary] = STATE(6976),
    [sym_unary] = STATE(6976),
    [sym_left_assignment_list] = STATE(2037),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2038),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(2038),
    [sym_false] = STATE(2038),
    [sym_nil] = STATE(2038),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(2039),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(3557),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3559),
    [anon_sym_yield] = ACTIONS(3561),
    [anon_sym_break] = ACTIONS(3563),
    [anon_sym_next] = ACTIONS(3565),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3567),
    [anon_sym_defined_QMARK] = ACTIONS(3569),
    [anon_sym_not] = ACTIONS(3571),
    [anon_sym_BANG] = ACTIONS(3573),
    [anon_sym_TILDE] = ACTIONS(3573),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4373] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(6977),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(2038),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(2038),
    [sym_assignment] = STATE(6977),
    [sym_operator_assignment] = STATE(6977),
    [sym_conditional] = STATE(6977),
    [sym_range] = STATE(6977),
    [sym_binary] = STATE(6977),
    [sym_unary] = STATE(6977),
    [sym_left_assignment_list] = STATE(2037),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2038),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(2038),
    [sym_false] = STATE(2038),
    [sym_nil] = STATE(2038),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(2039),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(3557),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3559),
    [anon_sym_yield] = ACTIONS(3561),
    [anon_sym_break] = ACTIONS(3563),
    [anon_sym_next] = ACTIONS(3565),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3567),
    [anon_sym_defined_QMARK] = ACTIONS(3569),
    [anon_sym_not] = ACTIONS(3571),
    [anon_sym_BANG] = ACTIONS(3573),
    [anon_sym_TILDE] = ACTIONS(3573),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4374] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(6978),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(6978),
    [sym_operator_assignment] = STATE(6978),
    [sym_conditional] = STATE(6978),
    [sym_range] = STATE(6978),
    [sym_binary] = STATE(6978),
    [sym_unary] = STATE(6978),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4375] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(6979),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(2038),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(2038),
    [sym_assignment] = STATE(6979),
    [sym_operator_assignment] = STATE(6979),
    [sym_conditional] = STATE(6979),
    [sym_range] = STATE(6979),
    [sym_binary] = STATE(6979),
    [sym_unary] = STATE(6979),
    [sym_left_assignment_list] = STATE(2037),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2038),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(2038),
    [sym_false] = STATE(2038),
    [sym_nil] = STATE(2038),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(2039),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(3557),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3559),
    [anon_sym_yield] = ACTIONS(3561),
    [anon_sym_break] = ACTIONS(3563),
    [anon_sym_next] = ACTIONS(3565),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3567),
    [anon_sym_defined_QMARK] = ACTIONS(3569),
    [anon_sym_not] = ACTIONS(3571),
    [anon_sym_BANG] = ACTIONS(3573),
    [anon_sym_TILDE] = ACTIONS(3573),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4376] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(6980),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(2038),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(2038),
    [sym_assignment] = STATE(6980),
    [sym_operator_assignment] = STATE(6980),
    [sym_conditional] = STATE(6980),
    [sym_range] = STATE(6980),
    [sym_binary] = STATE(6980),
    [sym_unary] = STATE(6980),
    [sym_left_assignment_list] = STATE(2037),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2038),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(2038),
    [sym_false] = STATE(2038),
    [sym_nil] = STATE(2038),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(2039),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(3557),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3559),
    [anon_sym_yield] = ACTIONS(3561),
    [anon_sym_break] = ACTIONS(3563),
    [anon_sym_next] = ACTIONS(3565),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3567),
    [anon_sym_defined_QMARK] = ACTIONS(3569),
    [anon_sym_not] = ACTIONS(3571),
    [anon_sym_BANG] = ACTIONS(3573),
    [anon_sym_TILDE] = ACTIONS(3573),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4377] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(6981),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(2038),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(2038),
    [sym_assignment] = STATE(6981),
    [sym_operator_assignment] = STATE(6981),
    [sym_conditional] = STATE(6981),
    [sym_range] = STATE(6981),
    [sym_binary] = STATE(6981),
    [sym_unary] = STATE(6981),
    [sym_left_assignment_list] = STATE(2037),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2038),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(2038),
    [sym_false] = STATE(2038),
    [sym_nil] = STATE(2038),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(2039),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(3557),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3559),
    [anon_sym_yield] = ACTIONS(3561),
    [anon_sym_break] = ACTIONS(3563),
    [anon_sym_next] = ACTIONS(3565),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3567),
    [anon_sym_defined_QMARK] = ACTIONS(3569),
    [anon_sym_not] = ACTIONS(3571),
    [anon_sym_BANG] = ACTIONS(3573),
    [anon_sym_TILDE] = ACTIONS(3573),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4378] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(6982),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(2038),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(2038),
    [sym_assignment] = STATE(6982),
    [sym_operator_assignment] = STATE(6982),
    [sym_conditional] = STATE(6982),
    [sym_range] = STATE(6982),
    [sym_binary] = STATE(6982),
    [sym_unary] = STATE(6982),
    [sym_left_assignment_list] = STATE(2037),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2038),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(2038),
    [sym_false] = STATE(2038),
    [sym_nil] = STATE(2038),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(2039),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(3557),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3559),
    [anon_sym_yield] = ACTIONS(3561),
    [anon_sym_break] = ACTIONS(3563),
    [anon_sym_next] = ACTIONS(3565),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3567),
    [anon_sym_defined_QMARK] = ACTIONS(3569),
    [anon_sym_not] = ACTIONS(3571),
    [anon_sym_BANG] = ACTIONS(3573),
    [anon_sym_TILDE] = ACTIONS(3573),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4379] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(2034),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(2038),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(2038),
    [sym_splat_argument] = STATE(6983),
    [sym_assignment] = STATE(2034),
    [sym_operator_assignment] = STATE(2034),
    [sym_conditional] = STATE(2034),
    [sym_range] = STATE(2034),
    [sym_binary] = STATE(2034),
    [sym_unary] = STATE(2034),
    [sym__arg_or_splat_arg] = STATE(6983),
    [sym_left_assignment_list] = STATE(2037),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2038),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(2038),
    [sym_false] = STATE(2038),
    [sym_nil] = STATE(2038),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(2039),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__splat_star] = ACTIONS(3555),
    [sym__unary_minus] = ACTIONS(3557),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3559),
    [anon_sym_yield] = ACTIONS(3561),
    [anon_sym_break] = ACTIONS(3563),
    [anon_sym_next] = ACTIONS(3565),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3567),
    [anon_sym_defined_QMARK] = ACTIONS(3569),
    [anon_sym_not] = ACTIONS(3571),
    [anon_sym_BANG] = ACTIONS(3573),
    [anon_sym_TILDE] = ACTIONS(3573),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4380] = {
    [aux_sym_exceptions_repeat1] = STATE(6984),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_COMMA] = ACTIONS(7151),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_EQ_GT] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [4381] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(2034),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(2038),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(2038),
    [sym_splat_argument] = STATE(6985),
    [sym_assignment] = STATE(2034),
    [sym_operator_assignment] = STATE(2034),
    [sym_conditional] = STATE(2034),
    [sym_range] = STATE(2034),
    [sym_binary] = STATE(2034),
    [sym_unary] = STATE(2034),
    [sym_right_assignment_list] = STATE(2035),
    [sym__arg_or_splat_arg] = STATE(6985),
    [sym_left_assignment_list] = STATE(2037),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2038),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(2038),
    [sym_false] = STATE(2038),
    [sym_nil] = STATE(2038),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(2039),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__splat_star] = ACTIONS(3555),
    [sym__unary_minus] = ACTIONS(3557),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3559),
    [anon_sym_yield] = ACTIONS(3561),
    [anon_sym_break] = ACTIONS(3563),
    [anon_sym_next] = ACTIONS(3565),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3567),
    [anon_sym_defined_QMARK] = ACTIONS(3569),
    [anon_sym_not] = ACTIONS(3571),
    [anon_sym_BANG] = ACTIONS(3573),
    [anon_sym_TILDE] = ACTIONS(3573),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4382] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(6986),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(2038),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(2038),
    [sym_assignment] = STATE(6986),
    [sym_operator_assignment] = STATE(6986),
    [sym_conditional] = STATE(6986),
    [sym_range] = STATE(6986),
    [sym_binary] = STATE(6986),
    [sym_unary] = STATE(6986),
    [sym_left_assignment_list] = STATE(2037),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2038),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(2038),
    [sym_false] = STATE(2038),
    [sym_nil] = STATE(2038),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(2039),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(3557),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3559),
    [anon_sym_yield] = ACTIONS(3561),
    [anon_sym_break] = ACTIONS(3563),
    [anon_sym_next] = ACTIONS(3565),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3567),
    [anon_sym_defined_QMARK] = ACTIONS(3569),
    [anon_sym_not] = ACTIONS(3571),
    [anon_sym_BANG] = ACTIONS(3573),
    [anon_sym_TILDE] = ACTIONS(3573),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4383] = {
    [sym_string] = STATE(6987),
    [aux_sym_chained_string_repeat1] = STATE(6987),
    [sym__string_start] = ACTIONS(139),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_EQ_GT] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [4384] = {
    [sym__simple_symbol] = ACTIONS(3235),
    [sym__string_start] = ACTIONS(3235),
    [sym__symbol_start] = ACTIONS(3235),
    [sym__subshell_start] = ACTIONS(3235),
    [sym__regex_start] = ACTIONS(3235),
    [sym__string_array_start] = ACTIONS(3235),
    [sym__symbol_array_start] = ACTIONS(3235),
    [sym__heredoc_body_start] = ACTIONS(3235),
    [sym_heredoc_beginning] = ACTIONS(3235),
    [sym__unary_minus] = ACTIONS(3235),
    [sym__identifier_hash_key] = ACTIONS(3235),
    [anon_sym_LBRACE] = ACTIONS(3235),
    [anon_sym_RBRACE] = ACTIONS(3235),
    [anon_sym_def] = ACTIONS(4997),
    [anon_sym_LPAREN] = ACTIONS(3235),
    [anon_sym_COLON_COLON] = ACTIONS(3235),
    [anon_sym_STAR] = ACTIONS(4997),
    [anon_sym_STAR_STAR] = ACTIONS(3235),
    [anon_sym_class] = ACTIONS(4997),
    [anon_sym_module] = ACTIONS(4997),
    [anon_sym_return] = ACTIONS(4997),
    [anon_sym_yield] = ACTIONS(4997),
    [anon_sym_break] = ACTIONS(4997),
    [anon_sym_next] = ACTIONS(4997),
    [sym_redo] = ACTIONS(4997),
    [sym_retry] = ACTIONS(4997),
    [anon_sym_if] = ACTIONS(4997),
    [anon_sym_unless] = ACTIONS(4997),
    [anon_sym_while] = ACTIONS(4997),
    [anon_sym_until] = ACTIONS(4997),
    [anon_sym_for] = ACTIONS(4997),
    [anon_sym_case] = ACTIONS(4997),
    [anon_sym_begin] = ACTIONS(4997),
    [anon_sym_PLUS] = ACTIONS(4997),
    [anon_sym_defined_QMARK] = ACTIONS(3235),
    [anon_sym_not] = ACTIONS(4997),
    [anon_sym_BANG] = ACTIONS(3235),
    [anon_sym_TILDE] = ACTIONS(3235),
    [sym_constant] = ACTIONS(4997),
    [sym_identifier] = ACTIONS(4997),
    [sym_instance_variable] = ACTIONS(3235),
    [sym_class_variable] = ACTIONS(3235),
    [sym_global_variable] = ACTIONS(3235),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4997),
    [sym_float] = ACTIONS(4997),
    [sym_complex] = ACTIONS(3235),
    [sym_super] = ACTIONS(4997),
    [anon_sym_true] = ACTIONS(4997),
    [anon_sym_TRUE] = ACTIONS(4997),
    [anon_sym_false] = ACTIONS(4997),
    [anon_sym_FALSE] = ACTIONS(4997),
    [sym_self] = ACTIONS(4997),
    [anon_sym_nil] = ACTIONS(4997),
    [anon_sym_NIL] = ACTIONS(4997),
    [sym_character] = ACTIONS(3235),
    [anon_sym_LBRACK2] = ACTIONS(3235),
    [anon_sym_DASH_GT] = ACTIONS(3235),
  },
  [4385] = {
    [sym_interpolation] = STATE(1787),
    [aux_sym_heredoc_body_repeat1] = STATE(1787),
    [sym__heredoc_content] = ACTIONS(3237),
    [sym_heredoc_end] = ACTIONS(10562),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(3237),
  },
  [4386] = {
    [sym__heredoc_body_start] = ACTIONS(10564),
    [anon_sym_RBRACE] = ACTIONS(10564),
    [sym_comment] = ACTIONS(87),
  },
  [4387] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(6989),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4392),
    [sym_scope_resolution] = STATE(2478),
    [sym_call] = STATE(2478),
    [sym_method_call] = STATE(4392),
    [sym_assignment] = STATE(6989),
    [sym_operator_assignment] = STATE(6989),
    [sym_conditional] = STATE(6989),
    [sym_range] = STATE(6989),
    [sym_binary] = STATE(6989),
    [sym_unary] = STATE(6989),
    [sym_left_assignment_list] = STATE(4391),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4392),
    [sym__variable] = STATE(2478),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4392),
    [sym_false] = STATE(4392),
    [sym_nil] = STATE(4392),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2481),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7174),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4263),
    [anon_sym_yield] = ACTIONS(4265),
    [anon_sym_break] = ACTIONS(4267),
    [anon_sym_next] = ACTIONS(4269),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7176),
    [anon_sym_defined_QMARK] = ACTIONS(7178),
    [anon_sym_not] = ACTIONS(7180),
    [anon_sym_BANG] = ACTIONS(7182),
    [anon_sym_TILDE] = ACTIONS(7182),
    [sym_constant] = ACTIONS(4279),
    [sym_identifier] = ACTIONS(4279),
    [sym_instance_variable] = ACTIONS(4281),
    [sym_class_variable] = ACTIONS(4281),
    [sym_global_variable] = ACTIONS(4281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4279),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4279),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4388] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(6990),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4392),
    [sym_scope_resolution] = STATE(2478),
    [sym_call] = STATE(2478),
    [sym_method_call] = STATE(4392),
    [sym_assignment] = STATE(6990),
    [sym_operator_assignment] = STATE(6990),
    [sym_conditional] = STATE(6990),
    [sym_range] = STATE(6990),
    [sym_binary] = STATE(6990),
    [sym_unary] = STATE(6990),
    [sym_left_assignment_list] = STATE(4391),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4392),
    [sym__variable] = STATE(2478),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4392),
    [sym_false] = STATE(4392),
    [sym_nil] = STATE(4392),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2481),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7174),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4263),
    [anon_sym_yield] = ACTIONS(4265),
    [anon_sym_break] = ACTIONS(4267),
    [anon_sym_next] = ACTIONS(4269),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7176),
    [anon_sym_defined_QMARK] = ACTIONS(7178),
    [anon_sym_not] = ACTIONS(7180),
    [anon_sym_BANG] = ACTIONS(7182),
    [anon_sym_TILDE] = ACTIONS(7182),
    [sym_constant] = ACTIONS(4279),
    [sym_identifier] = ACTIONS(4279),
    [sym_instance_variable] = ACTIONS(4281),
    [sym_class_variable] = ACTIONS(4281),
    [sym_global_variable] = ACTIONS(4281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4279),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4279),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4389] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(1872),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4392),
    [sym_scope_resolution] = STATE(2478),
    [sym_call] = STATE(2478),
    [sym_method_call] = STATE(4392),
    [sym_assignment] = STATE(1872),
    [sym_operator_assignment] = STATE(1872),
    [sym_conditional] = STATE(1872),
    [sym_range] = STATE(1872),
    [sym_binary] = STATE(1872),
    [sym_unary] = STATE(1872),
    [sym_left_assignment_list] = STATE(4391),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4392),
    [sym__variable] = STATE(2478),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4392),
    [sym_false] = STATE(4392),
    [sym_nil] = STATE(4392),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2481),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7174),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4263),
    [anon_sym_yield] = ACTIONS(4265),
    [anon_sym_break] = ACTIONS(4267),
    [anon_sym_next] = ACTIONS(4269),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7176),
    [anon_sym_defined_QMARK] = ACTIONS(7178),
    [anon_sym_not] = ACTIONS(7180),
    [anon_sym_BANG] = ACTIONS(7182),
    [anon_sym_TILDE] = ACTIONS(7182),
    [sym_constant] = ACTIONS(4279),
    [sym_identifier] = ACTIONS(4279),
    [sym_instance_variable] = ACTIONS(4281),
    [sym_class_variable] = ACTIONS(4281),
    [sym_global_variable] = ACTIONS(4281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4279),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4279),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4390] = {
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(10566),
    [sym__binary_star] = ACTIONS(10568),
    [anon_sym_RPAREN] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(10570),
    [anon_sym_STAR_STAR] = ACTIONS(10568),
    [anon_sym_AMP] = ACTIONS(10572),
    [anon_sym_LT] = ACTIONS(10574),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(10576),
    [anon_sym_DOT_DOT] = ACTIONS(10578),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10580),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(10582),
    [anon_sym_AMP_AMP] = ACTIONS(10582),
    [anon_sym_LT_LT] = ACTIONS(10584),
    [anon_sym_GT_GT] = ACTIONS(10584),
    [anon_sym_EQ_EQ] = ACTIONS(10586),
    [anon_sym_BANG_EQ] = ACTIONS(10582),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10582),
    [anon_sym_LT_EQ_GT] = ACTIONS(10582),
    [anon_sym_EQ_TILDE] = ACTIONS(10582),
    [anon_sym_BANG_TILDE] = ACTIONS(10582),
    [anon_sym_LT_EQ] = ACTIONS(10574),
    [anon_sym_GT] = ACTIONS(10574),
    [anon_sym_GT_EQ] = ACTIONS(10588),
    [anon_sym_CARET] = ACTIONS(10590),
    [anon_sym_PLUS] = ACTIONS(10566),
    [anon_sym_SLASH] = ACTIONS(10568),
    [anon_sym_PERCENT] = ACTIONS(10568),
    [sym_comment] = ACTIONS(87),
  },
  [4391] = {
    [anon_sym_EQ] = ACTIONS(10592),
    [sym_comment] = ACTIONS(87),
  },
  [4392] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(10594),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(10596),
    [anon_sym_DASH_EQ] = ACTIONS(10596),
    [anon_sym_STAR_EQ] = ACTIONS(10596),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10596),
    [anon_sym_SLASH_EQ] = ACTIONS(10596),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10596),
    [anon_sym_PIPE_EQ] = ACTIONS(10596),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10596),
    [anon_sym_AMP_EQ] = ACTIONS(10596),
    [anon_sym_PERCENT_EQ] = ACTIONS(10596),
    [anon_sym_GT_GT_EQ] = ACTIONS(10596),
    [anon_sym_LT_LT_EQ] = ACTIONS(10596),
    [anon_sym_CARET_EQ] = ACTIONS(10596),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [4393] = {
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(10566),
    [sym__binary_star] = ACTIONS(10568),
    [anon_sym_RPAREN] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(10570),
    [anon_sym_STAR_STAR] = ACTIONS(10568),
    [anon_sym_AMP] = ACTIONS(10572),
    [anon_sym_LT] = ACTIONS(10574),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(10576),
    [anon_sym_DOT_DOT] = ACTIONS(10578),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10580),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(10582),
    [anon_sym_AMP_AMP] = ACTIONS(10582),
    [anon_sym_LT_LT] = ACTIONS(10584),
    [anon_sym_GT_GT] = ACTIONS(10584),
    [anon_sym_EQ_EQ] = ACTIONS(10586),
    [anon_sym_BANG_EQ] = ACTIONS(10582),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10582),
    [anon_sym_LT_EQ_GT] = ACTIONS(10582),
    [anon_sym_EQ_TILDE] = ACTIONS(10582),
    [anon_sym_BANG_TILDE] = ACTIONS(10582),
    [anon_sym_LT_EQ] = ACTIONS(10574),
    [anon_sym_GT] = ACTIONS(10574),
    [anon_sym_GT_EQ] = ACTIONS(10588),
    [anon_sym_CARET] = ACTIONS(10590),
    [anon_sym_PLUS] = ACTIONS(10566),
    [anon_sym_SLASH] = ACTIONS(10568),
    [anon_sym_PERCENT] = ACTIONS(10568),
    [sym_comment] = ACTIONS(87),
  },
  [4394] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(7192),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [4395] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7003),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4392),
    [sym_scope_resolution] = STATE(2478),
    [sym_call] = STATE(2478),
    [sym_method_call] = STATE(4392),
    [sym_assignment] = STATE(7003),
    [sym_operator_assignment] = STATE(7003),
    [sym_conditional] = STATE(7003),
    [sym_range] = STATE(7003),
    [sym_binary] = STATE(7003),
    [sym_unary] = STATE(7003),
    [sym_left_assignment_list] = STATE(4391),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4392),
    [sym__variable] = STATE(2478),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4392),
    [sym_false] = STATE(4392),
    [sym_nil] = STATE(4392),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2481),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7174),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4263),
    [anon_sym_yield] = ACTIONS(4265),
    [anon_sym_break] = ACTIONS(4267),
    [anon_sym_next] = ACTIONS(4269),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7176),
    [anon_sym_defined_QMARK] = ACTIONS(7178),
    [anon_sym_not] = ACTIONS(7180),
    [anon_sym_BANG] = ACTIONS(7182),
    [anon_sym_TILDE] = ACTIONS(7182),
    [sym_constant] = ACTIONS(4279),
    [sym_identifier] = ACTIONS(4279),
    [sym_instance_variable] = ACTIONS(4281),
    [sym_class_variable] = ACTIONS(4281),
    [sym_global_variable] = ACTIONS(4281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4279),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4279),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4396] = {
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(10566),
    [sym__binary_star] = ACTIONS(10568),
    [anon_sym_RPAREN] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(10570),
    [anon_sym_STAR_STAR] = ACTIONS(10568),
    [anon_sym_AMP] = ACTIONS(10572),
    [anon_sym_LT] = ACTIONS(10574),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(10576),
    [anon_sym_DOT_DOT] = ACTIONS(10578),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10580),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(10582),
    [anon_sym_AMP_AMP] = ACTIONS(10582),
    [anon_sym_LT_LT] = ACTIONS(10584),
    [anon_sym_GT_GT] = ACTIONS(10584),
    [anon_sym_EQ_EQ] = ACTIONS(10586),
    [anon_sym_BANG_EQ] = ACTIONS(10582),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10582),
    [anon_sym_LT_EQ_GT] = ACTIONS(10582),
    [anon_sym_EQ_TILDE] = ACTIONS(10582),
    [anon_sym_BANG_TILDE] = ACTIONS(10582),
    [anon_sym_LT_EQ] = ACTIONS(10574),
    [anon_sym_GT] = ACTIONS(10574),
    [anon_sym_GT_EQ] = ACTIONS(10588),
    [anon_sym_CARET] = ACTIONS(10590),
    [anon_sym_PLUS] = ACTIONS(10566),
    [anon_sym_SLASH] = ACTIONS(10568),
    [anon_sym_PERCENT] = ACTIONS(10568),
    [sym_comment] = ACTIONS(87),
  },
  [4397] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(7190),
    [sym__binary_star] = ACTIONS(7192),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(7194),
    [anon_sym_STAR_STAR] = ACTIONS(7192),
    [anon_sym_AMP] = ACTIONS(7196),
    [anon_sym_LT] = ACTIONS(7198),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(7200),
    [anon_sym_DOT_DOT] = ACTIONS(7202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7204),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(7206),
    [anon_sym_AMP_AMP] = ACTIONS(7206),
    [anon_sym_LT_LT] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7208),
    [anon_sym_EQ_EQ] = ACTIONS(7210),
    [anon_sym_BANG_EQ] = ACTIONS(7206),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7206),
    [anon_sym_LT_EQ_GT] = ACTIONS(7206),
    [anon_sym_EQ_TILDE] = ACTIONS(7206),
    [anon_sym_BANG_TILDE] = ACTIONS(7206),
    [anon_sym_LT_EQ] = ACTIONS(7198),
    [anon_sym_GT] = ACTIONS(7198),
    [anon_sym_GT_EQ] = ACTIONS(7212),
    [anon_sym_CARET] = ACTIONS(7214),
    [anon_sym_PLUS] = ACTIONS(7190),
    [anon_sym_SLASH] = ACTIONS(7192),
    [anon_sym_PERCENT] = ACTIONS(7192),
    [sym_comment] = ACTIONS(87),
  },
  [4398] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7004),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4392),
    [sym_scope_resolution] = STATE(2478),
    [sym_call] = STATE(2478),
    [sym_method_call] = STATE(4392),
    [sym_assignment] = STATE(7004),
    [sym_operator_assignment] = STATE(7004),
    [sym_conditional] = STATE(7004),
    [sym_range] = STATE(7004),
    [sym_binary] = STATE(7004),
    [sym_unary] = STATE(7004),
    [sym_left_assignment_list] = STATE(4391),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4392),
    [sym__variable] = STATE(2478),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4392),
    [sym_false] = STATE(4392),
    [sym_nil] = STATE(4392),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2481),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7174),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4263),
    [anon_sym_yield] = ACTIONS(4265),
    [anon_sym_break] = ACTIONS(4267),
    [anon_sym_next] = ACTIONS(4269),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7176),
    [anon_sym_defined_QMARK] = ACTIONS(7178),
    [anon_sym_not] = ACTIONS(7180),
    [anon_sym_BANG] = ACTIONS(7182),
    [anon_sym_TILDE] = ACTIONS(7182),
    [sym_constant] = ACTIONS(4279),
    [sym_identifier] = ACTIONS(4279),
    [sym_instance_variable] = ACTIONS(4281),
    [sym_class_variable] = ACTIONS(4281),
    [sym_global_variable] = ACTIONS(4281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4279),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4279),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4399] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(7005),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2061),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(2061),
    [sym_assignment] = STATE(7005),
    [sym_operator_assignment] = STATE(7005),
    [sym_conditional] = STATE(7005),
    [sym_range] = STATE(7005),
    [sym_binary] = STATE(7005),
    [sym_unary] = STATE(7005),
    [sym_left_assignment_list] = STATE(2060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2061),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2061),
    [sym_false] = STATE(2061),
    [sym_nil] = STATE(2061),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2484),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7184),
    [anon_sym_defined_QMARK] = ACTIONS(3599),
    [anon_sym_not] = ACTIONS(3601),
    [anon_sym_BANG] = ACTIONS(3605),
    [anon_sym_TILDE] = ACTIONS(3605),
    [sym_constant] = ACTIONS(1621),
    [sym_identifier] = ACTIONS(1621),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4400] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(7006),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2061),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(2061),
    [sym_assignment] = STATE(7006),
    [sym_operator_assignment] = STATE(7006),
    [sym_conditional] = STATE(7006),
    [sym_range] = STATE(7006),
    [sym_binary] = STATE(7006),
    [sym_unary] = STATE(7006),
    [sym_left_assignment_list] = STATE(2060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2061),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2061),
    [sym_false] = STATE(2061),
    [sym_nil] = STATE(2061),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2484),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7184),
    [anon_sym_defined_QMARK] = ACTIONS(3599),
    [anon_sym_not] = ACTIONS(3601),
    [anon_sym_BANG] = ACTIONS(3605),
    [anon_sym_TILDE] = ACTIONS(3605),
    [sym_constant] = ACTIONS(1621),
    [sym_identifier] = ACTIONS(1621),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4401] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(7007),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2061),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(2061),
    [sym_assignment] = STATE(7007),
    [sym_operator_assignment] = STATE(7007),
    [sym_conditional] = STATE(7007),
    [sym_range] = STATE(7007),
    [sym_binary] = STATE(7007),
    [sym_unary] = STATE(7007),
    [sym_left_assignment_list] = STATE(2060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2061),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2061),
    [sym_false] = STATE(2061),
    [sym_nil] = STATE(2061),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2484),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7184),
    [anon_sym_defined_QMARK] = ACTIONS(3599),
    [anon_sym_not] = ACTIONS(3601),
    [anon_sym_BANG] = ACTIONS(3605),
    [anon_sym_TILDE] = ACTIONS(3605),
    [sym_constant] = ACTIONS(1621),
    [sym_identifier] = ACTIONS(1621),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4402] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(7008),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2061),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(2061),
    [sym_assignment] = STATE(7008),
    [sym_operator_assignment] = STATE(7008),
    [sym_conditional] = STATE(7008),
    [sym_range] = STATE(7008),
    [sym_binary] = STATE(7008),
    [sym_unary] = STATE(7008),
    [sym_left_assignment_list] = STATE(2060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2061),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2061),
    [sym_false] = STATE(2061),
    [sym_nil] = STATE(2061),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2484),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7184),
    [anon_sym_defined_QMARK] = ACTIONS(3599),
    [anon_sym_not] = ACTIONS(3601),
    [anon_sym_BANG] = ACTIONS(3605),
    [anon_sym_TILDE] = ACTIONS(3605),
    [sym_constant] = ACTIONS(1621),
    [sym_identifier] = ACTIONS(1621),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4403] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(7009),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2061),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(2061),
    [sym_assignment] = STATE(7009),
    [sym_operator_assignment] = STATE(7009),
    [sym_conditional] = STATE(7009),
    [sym_range] = STATE(7009),
    [sym_binary] = STATE(7009),
    [sym_unary] = STATE(7009),
    [sym_left_assignment_list] = STATE(2060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2061),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2061),
    [sym_false] = STATE(2061),
    [sym_nil] = STATE(2061),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2484),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7184),
    [anon_sym_defined_QMARK] = ACTIONS(3599),
    [anon_sym_not] = ACTIONS(3601),
    [anon_sym_BANG] = ACTIONS(3605),
    [anon_sym_TILDE] = ACTIONS(3605),
    [sym_constant] = ACTIONS(1621),
    [sym_identifier] = ACTIONS(1621),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4404] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(7010),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(7010),
    [sym_operator_assignment] = STATE(7010),
    [sym_conditional] = STATE(7010),
    [sym_range] = STATE(7010),
    [sym_binary] = STATE(7010),
    [sym_unary] = STATE(7010),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4405] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(7011),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2061),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(2061),
    [sym_assignment] = STATE(7011),
    [sym_operator_assignment] = STATE(7011),
    [sym_conditional] = STATE(7011),
    [sym_range] = STATE(7011),
    [sym_binary] = STATE(7011),
    [sym_unary] = STATE(7011),
    [sym_left_assignment_list] = STATE(2060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2061),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2061),
    [sym_false] = STATE(2061),
    [sym_nil] = STATE(2061),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2484),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7184),
    [anon_sym_defined_QMARK] = ACTIONS(3599),
    [anon_sym_not] = ACTIONS(3601),
    [anon_sym_BANG] = ACTIONS(3605),
    [anon_sym_TILDE] = ACTIONS(3605),
    [sym_constant] = ACTIONS(1621),
    [sym_identifier] = ACTIONS(1621),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4406] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(7012),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2061),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(2061),
    [sym_assignment] = STATE(7012),
    [sym_operator_assignment] = STATE(7012),
    [sym_conditional] = STATE(7012),
    [sym_range] = STATE(7012),
    [sym_binary] = STATE(7012),
    [sym_unary] = STATE(7012),
    [sym_left_assignment_list] = STATE(2060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2061),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2061),
    [sym_false] = STATE(2061),
    [sym_nil] = STATE(2061),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2484),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7184),
    [anon_sym_defined_QMARK] = ACTIONS(3599),
    [anon_sym_not] = ACTIONS(3601),
    [anon_sym_BANG] = ACTIONS(3605),
    [anon_sym_TILDE] = ACTIONS(3605),
    [sym_constant] = ACTIONS(1621),
    [sym_identifier] = ACTIONS(1621),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4407] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(7013),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2061),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(2061),
    [sym_assignment] = STATE(7013),
    [sym_operator_assignment] = STATE(7013),
    [sym_conditional] = STATE(7013),
    [sym_range] = STATE(7013),
    [sym_binary] = STATE(7013),
    [sym_unary] = STATE(7013),
    [sym_left_assignment_list] = STATE(2060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2061),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2061),
    [sym_false] = STATE(2061),
    [sym_nil] = STATE(2061),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2484),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7184),
    [anon_sym_defined_QMARK] = ACTIONS(3599),
    [anon_sym_not] = ACTIONS(3601),
    [anon_sym_BANG] = ACTIONS(3605),
    [anon_sym_TILDE] = ACTIONS(3605),
    [sym_constant] = ACTIONS(1621),
    [sym_identifier] = ACTIONS(1621),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4408] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(7014),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2061),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(2061),
    [sym_assignment] = STATE(7014),
    [sym_operator_assignment] = STATE(7014),
    [sym_conditional] = STATE(7014),
    [sym_range] = STATE(7014),
    [sym_binary] = STATE(7014),
    [sym_unary] = STATE(7014),
    [sym_left_assignment_list] = STATE(2060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2061),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2061),
    [sym_false] = STATE(2061),
    [sym_nil] = STATE(2061),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2484),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7184),
    [anon_sym_defined_QMARK] = ACTIONS(3599),
    [anon_sym_not] = ACTIONS(3601),
    [anon_sym_BANG] = ACTIONS(3605),
    [anon_sym_TILDE] = ACTIONS(3605),
    [sym_constant] = ACTIONS(1621),
    [sym_identifier] = ACTIONS(1621),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4409] = {
    [sym_heredoc_body] = STATE(7015),
    [aux_sym_call_repeat1] = STATE(7015),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_RPAREN] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [4410] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(2057),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2061),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(2061),
    [sym__argument] = STATE(4250),
    [sym_splat_argument] = STATE(4250),
    [sym_hash_splat_argument] = STATE(4250),
    [sym_block_argument] = STATE(4250),
    [sym_assignment] = STATE(2057),
    [sym_operator_assignment] = STATE(2057),
    [sym_conditional] = STATE(2057),
    [sym_range] = STATE(2057),
    [sym_binary] = STATE(2057),
    [sym_unary] = STATE(2057),
    [sym_left_assignment_list] = STATE(2060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2061),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2061),
    [sym_false] = STATE(2061),
    [sym_nil] = STATE(2061),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2062),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_heredoc_body] = STATE(7016),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(4250),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(3591),
    [sym__splat_star] = ACTIONS(3593),
    [sym__unary_minus] = ACTIONS(3595),
    [sym__identifier_hash_key] = ACTIONS(3597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10598),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7184),
    [anon_sym_defined_QMARK] = ACTIONS(3599),
    [anon_sym_not] = ACTIONS(3601),
    [anon_sym_BANG] = ACTIONS(3605),
    [anon_sym_TILDE] = ACTIONS(3605),
    [sym_constant] = ACTIONS(3607),
    [sym_identifier] = ACTIONS(3607),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4411] = {
    [sym_heredoc_body] = STATE(7017),
    [aux_sym_call_repeat1] = STATE(7017),
    [aux_sym_argument_list_repeat1] = STATE(7018),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_RPAREN] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(7216),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [4412] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(7019),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2061),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(2061),
    [sym_splat_argument] = STATE(7020),
    [sym_assignment] = STATE(7019),
    [sym_operator_assignment] = STATE(7019),
    [sym_conditional] = STATE(7019),
    [sym_range] = STATE(7019),
    [sym_binary] = STATE(7019),
    [sym_unary] = STATE(7019),
    [sym_right_assignment_list] = STATE(4255),
    [sym__arg_or_splat_arg] = STATE(7020),
    [sym_left_assignment_list] = STATE(2060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2061),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2061),
    [sym_false] = STATE(2061),
    [sym_nil] = STATE(2061),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2484),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(4291),
    [sym__unary_minus] = ACTIONS(3595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7184),
    [anon_sym_defined_QMARK] = ACTIONS(3599),
    [anon_sym_not] = ACTIONS(3601),
    [anon_sym_BANG] = ACTIONS(3605),
    [anon_sym_TILDE] = ACTIONS(3605),
    [sym_constant] = ACTIONS(1621),
    [sym_identifier] = ACTIONS(1621),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4413] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(7021),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2061),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(2061),
    [sym_assignment] = STATE(7021),
    [sym_operator_assignment] = STATE(7021),
    [sym_conditional] = STATE(7021),
    [sym_range] = STATE(7021),
    [sym_binary] = STATE(7021),
    [sym_unary] = STATE(7021),
    [sym_left_assignment_list] = STATE(2060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2061),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2061),
    [sym_false] = STATE(2061),
    [sym_nil] = STATE(2061),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2484),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7184),
    [anon_sym_defined_QMARK] = ACTIONS(3599),
    [anon_sym_not] = ACTIONS(3601),
    [anon_sym_BANG] = ACTIONS(3605),
    [anon_sym_TILDE] = ACTIONS(3605),
    [sym_constant] = ACTIONS(1621),
    [sym_identifier] = ACTIONS(1621),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4414] = {
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(3611),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(3611),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(3611),
    [anon_sym_PERCENT] = ACTIONS(3611),
    [sym_comment] = ACTIONS(87),
  },
  [4415] = {
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(3611),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [4416] = {
    [sym__method_rest] = STATE(7022),
    [sym_operator] = STATE(132),
    [sym__method_name] = STATE(132),
    [sym_setter] = STATE(132),
    [sym_symbol] = STATE(132),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(3679),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(3679),
    [sym_class_variable] = ACTIONS(3679),
    [sym_global_variable] = ACTIONS(3679),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [4417] = {
    [sym__binary_minus] = ACTIONS(3609),
    [sym__binary_star] = ACTIONS(3611),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(3611),
    [anon_sym_AMP] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(3631),
    [anon_sym_GT_GT] = ACTIONS(3631),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(3609),
    [anon_sym_SLASH] = ACTIONS(3611),
    [anon_sym_PERCENT] = ACTIONS(3611),
    [sym_comment] = ACTIONS(87),
  },
  [4418] = {
    [sym__binary_minus] = ACTIONS(3609),
    [sym__binary_star] = ACTIONS(3611),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(3611),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(3631),
    [anon_sym_GT_GT] = ACTIONS(3631),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(3609),
    [anon_sym_SLASH] = ACTIONS(3611),
    [anon_sym_PERCENT] = ACTIONS(3611),
    [sym_comment] = ACTIONS(87),
  },
  [4419] = {
    [sym__binary_minus] = ACTIONS(3609),
    [sym__binary_star] = ACTIONS(3611),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(3615),
    [anon_sym_STAR_STAR] = ACTIONS(3611),
    [anon_sym_AMP] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(3631),
    [anon_sym_GT_GT] = ACTIONS(3631),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(3637),
    [anon_sym_PLUS] = ACTIONS(3609),
    [anon_sym_SLASH] = ACTIONS(3611),
    [anon_sym_PERCENT] = ACTIONS(3611),
    [sym_comment] = ACTIONS(87),
  },
  [4420] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(10600),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [4421] = {
    [sym__binary_minus] = ACTIONS(3609),
    [sym__binary_star] = ACTIONS(3611),
    [anon_sym_RPAREN] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(3615),
    [anon_sym_STAR_STAR] = ACTIONS(3611),
    [anon_sym_AMP] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3619),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(3623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3625),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3629),
    [anon_sym_AMP_AMP] = ACTIONS(3629),
    [anon_sym_LT_LT] = ACTIONS(3631),
    [anon_sym_GT_GT] = ACTIONS(3631),
    [anon_sym_EQ_EQ] = ACTIONS(3633),
    [anon_sym_BANG_EQ] = ACTIONS(3629),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3629),
    [anon_sym_LT_EQ_GT] = ACTIONS(3629),
    [anon_sym_EQ_TILDE] = ACTIONS(3629),
    [anon_sym_BANG_TILDE] = ACTIONS(3629),
    [anon_sym_LT_EQ] = ACTIONS(3619),
    [anon_sym_GT] = ACTIONS(3619),
    [anon_sym_GT_EQ] = ACTIONS(3635),
    [anon_sym_CARET] = ACTIONS(3637),
    [anon_sym_PLUS] = ACTIONS(3609),
    [anon_sym_SLASH] = ACTIONS(3611),
    [anon_sym_PERCENT] = ACTIONS(3611),
    [sym_comment] = ACTIONS(87),
  },
  [4422] = {
    [sym__binary_minus] = ACTIONS(3609),
    [sym__binary_star] = ACTIONS(3611),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(3615),
    [anon_sym_STAR_STAR] = ACTIONS(3611),
    [anon_sym_AMP] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3619),
    [anon_sym_QMARK] = ACTIONS(3621),
    [anon_sym_DOT_DOT] = ACTIONS(3623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3625),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(3629),
    [anon_sym_AMP_AMP] = ACTIONS(3629),
    [anon_sym_LT_LT] = ACTIONS(3631),
    [anon_sym_GT_GT] = ACTIONS(3631),
    [anon_sym_EQ_EQ] = ACTIONS(3633),
    [anon_sym_BANG_EQ] = ACTIONS(3629),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3629),
    [anon_sym_LT_EQ_GT] = ACTIONS(3629),
    [anon_sym_EQ_TILDE] = ACTIONS(3629),
    [anon_sym_BANG_TILDE] = ACTIONS(3629),
    [anon_sym_LT_EQ] = ACTIONS(3619),
    [anon_sym_GT] = ACTIONS(3619),
    [anon_sym_GT_EQ] = ACTIONS(3635),
    [anon_sym_CARET] = ACTIONS(3637),
    [anon_sym_PLUS] = ACTIONS(3609),
    [anon_sym_SLASH] = ACTIONS(3611),
    [anon_sym_PERCENT] = ACTIONS(3611),
    [sym_comment] = ACTIONS(87),
  },
  [4423] = {
    [sym__binary_minus] = ACTIONS(3609),
    [sym__binary_star] = ACTIONS(3611),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(3615),
    [anon_sym_STAR_STAR] = ACTIONS(3611),
    [anon_sym_AMP] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3619),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(3631),
    [anon_sym_GT_GT] = ACTIONS(3631),
    [anon_sym_EQ_EQ] = ACTIONS(3633),
    [anon_sym_BANG_EQ] = ACTIONS(3629),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3629),
    [anon_sym_LT_EQ_GT] = ACTIONS(3629),
    [anon_sym_EQ_TILDE] = ACTIONS(3629),
    [anon_sym_BANG_TILDE] = ACTIONS(3629),
    [anon_sym_LT_EQ] = ACTIONS(3619),
    [anon_sym_GT] = ACTIONS(3619),
    [anon_sym_GT_EQ] = ACTIONS(3635),
    [anon_sym_CARET] = ACTIONS(3637),
    [anon_sym_PLUS] = ACTIONS(3609),
    [anon_sym_SLASH] = ACTIONS(3611),
    [anon_sym_PERCENT] = ACTIONS(3611),
    [sym_comment] = ACTIONS(87),
  },
  [4424] = {
    [sym__binary_minus] = ACTIONS(3609),
    [sym__binary_star] = ACTIONS(3611),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(3611),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(3609),
    [anon_sym_SLASH] = ACTIONS(3611),
    [anon_sym_PERCENT] = ACTIONS(3611),
    [sym_comment] = ACTIONS(87),
  },
  [4425] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(7024),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(4435),
    [sym_scope_resolution] = STATE(4433),
    [sym_call] = STATE(4433),
    [sym_method_call] = STATE(4435),
    [sym_assignment] = STATE(7024),
    [sym_operator_assignment] = STATE(7024),
    [sym_conditional] = STATE(7024),
    [sym_range] = STATE(7024),
    [sym_binary] = STATE(7024),
    [sym_unary] = STATE(7024),
    [sym_left_assignment_list] = STATE(4434),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4435),
    [sym__variable] = STATE(4433),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(4435),
    [sym_false] = STATE(4435),
    [sym_nil] = STATE(4435),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(4436),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(7228),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(7230),
    [anon_sym_yield] = ACTIONS(7232),
    [anon_sym_break] = ACTIONS(7234),
    [anon_sym_next] = ACTIONS(7236),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(7238),
    [anon_sym_defined_QMARK] = ACTIONS(7240),
    [anon_sym_not] = ACTIONS(7242),
    [anon_sym_BANG] = ACTIONS(7244),
    [anon_sym_TILDE] = ACTIONS(7244),
    [sym_constant] = ACTIONS(7246),
    [sym_identifier] = ACTIONS(7246),
    [sym_instance_variable] = ACTIONS(7248),
    [sym_class_variable] = ACTIONS(7248),
    [sym_global_variable] = ACTIONS(7248),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(7246),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(7246),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [4426] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(2087),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2092),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2092),
    [sym_argument_list] = STATE(6614),
    [sym__argument_list_with_parens] = STATE(2089),
    [sym__argument] = STATE(2090),
    [sym_splat_argument] = STATE(2090),
    [sym_hash_splat_argument] = STATE(2090),
    [sym_block_argument] = STATE(2090),
    [sym_assignment] = STATE(2087),
    [sym_operator_assignment] = STATE(2087),
    [sym_conditional] = STATE(2087),
    [sym_range] = STATE(2087),
    [sym_binary] = STATE(2087),
    [sym_unary] = STATE(2087),
    [sym_left_assignment_list] = STATE(2091),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2092),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2092),
    [sym_false] = STATE(2092),
    [sym_nil] = STATE(2092),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(2093),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(2090),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(3639),
    [sym__splat_star] = ACTIONS(3641),
    [sym__unary_minus] = ACTIONS(3643),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(3645),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_RPAREN] = ACTIONS(365),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3647),
    [anon_sym_yield] = ACTIONS(3649),
    [anon_sym_break] = ACTIONS(3651),
    [anon_sym_next] = ACTIONS(3653),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_PLUS_EQ] = ACTIONS(365),
    [anon_sym_DASH_EQ] = ACTIONS(365),
    [anon_sym_STAR_EQ] = ACTIONS(365),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(365),
    [anon_sym_SLASH_EQ] = ACTIONS(365),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(365),
    [anon_sym_PIPE_EQ] = ACTIONS(365),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(365),
    [anon_sym_AMP_EQ] = ACTIONS(365),
    [anon_sym_PERCENT_EQ] = ACTIONS(365),
    [anon_sym_GT_GT_EQ] = ACTIONS(365),
    [anon_sym_LT_LT_EQ] = ACTIONS(365),
    [anon_sym_CARET_EQ] = ACTIONS(365),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_PERCENT] = ACTIONS(377),
    [anon_sym_defined_QMARK] = ACTIONS(3655),
    [anon_sym_not] = ACTIONS(3657),
    [anon_sym_BANG] = ACTIONS(3659),
    [anon_sym_TILDE] = ACTIONS(3661),
    [sym_constant] = ACTIONS(3663),
    [sym_identifier] = ACTIONS(3663),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4427] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(2087),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2092),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2092),
    [sym_argument_list] = STATE(6615),
    [sym__argument_list_with_parens] = STATE(2089),
    [sym__argument] = STATE(2090),
    [sym_splat_argument] = STATE(2090),
    [sym_hash_splat_argument] = STATE(2090),
    [sym_block_argument] = STATE(2090),
    [sym_assignment] = STATE(2087),
    [sym_operator_assignment] = STATE(2087),
    [sym_conditional] = STATE(2087),
    [sym_range] = STATE(2087),
    [sym_binary] = STATE(2087),
    [sym_unary] = STATE(2087),
    [sym_left_assignment_list] = STATE(2091),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2092),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2092),
    [sym_false] = STATE(2092),
    [sym_nil] = STATE(2092),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(2093),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(2090),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(3639),
    [sym__splat_star] = ACTIONS(3641),
    [sym__unary_minus] = ACTIONS(3643),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(3645),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_RPAREN] = ACTIONS(417),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_EQ] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3647),
    [anon_sym_yield] = ACTIONS(3649),
    [anon_sym_break] = ACTIONS(3651),
    [anon_sym_next] = ACTIONS(3653),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_PLUS_EQ] = ACTIONS(417),
    [anon_sym_DASH_EQ] = ACTIONS(417),
    [anon_sym_STAR_EQ] = ACTIONS(417),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(417),
    [anon_sym_SLASH_EQ] = ACTIONS(417),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(417),
    [anon_sym_PIPE_EQ] = ACTIONS(417),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(417),
    [anon_sym_AMP_EQ] = ACTIONS(417),
    [anon_sym_PERCENT_EQ] = ACTIONS(417),
    [anon_sym_GT_GT_EQ] = ACTIONS(417),
    [anon_sym_LT_LT_EQ] = ACTIONS(417),
    [anon_sym_CARET_EQ] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(3655),
    [anon_sym_not] = ACTIONS(3657),
    [anon_sym_BANG] = ACTIONS(3659),
    [anon_sym_TILDE] = ACTIONS(3661),
    [sym_constant] = ACTIONS(3663),
    [sym_identifier] = ACTIONS(3663),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4428] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(2087),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2092),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2092),
    [sym_argument_list] = STATE(6616),
    [sym__argument_list_with_parens] = STATE(2089),
    [sym__argument] = STATE(2090),
    [sym_splat_argument] = STATE(2090),
    [sym_hash_splat_argument] = STATE(2090),
    [sym_block_argument] = STATE(2090),
    [sym_assignment] = STATE(2087),
    [sym_operator_assignment] = STATE(2087),
    [sym_conditional] = STATE(2087),
    [sym_range] = STATE(2087),
    [sym_binary] = STATE(2087),
    [sym_unary] = STATE(2087),
    [sym_left_assignment_list] = STATE(2091),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2092),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2092),
    [sym_false] = STATE(2092),
    [sym_nil] = STATE(2092),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(2093),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(2090),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(3639),
    [sym__splat_star] = ACTIONS(3641),
    [sym__unary_minus] = ACTIONS(3643),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(3645),
    [anon_sym_LBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_RPAREN] = ACTIONS(421),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_EQ] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3647),
    [anon_sym_yield] = ACTIONS(3649),
    [anon_sym_break] = ACTIONS(3651),
    [anon_sym_next] = ACTIONS(3653),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_PLUS_EQ] = ACTIONS(421),
    [anon_sym_DASH_EQ] = ACTIONS(421),
    [anon_sym_STAR_EQ] = ACTIONS(421),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(421),
    [anon_sym_SLASH_EQ] = ACTIONS(421),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(421),
    [anon_sym_PIPE_EQ] = ACTIONS(421),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(421),
    [anon_sym_AMP_EQ] = ACTIONS(421),
    [anon_sym_PERCENT_EQ] = ACTIONS(421),
    [anon_sym_GT_GT_EQ] = ACTIONS(421),
    [anon_sym_LT_LT_EQ] = ACTIONS(421),
    [anon_sym_CARET_EQ] = ACTIONS(421),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(3655),
    [anon_sym_not] = ACTIONS(3657),
    [anon_sym_BANG] = ACTIONS(3659),
    [anon_sym_TILDE] = ACTIONS(3661),
    [sym_constant] = ACTIONS(3663),
    [sym_identifier] = ACTIONS(3663),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4429] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(2087),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2092),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2092),
    [sym_argument_list] = STATE(6617),
    [sym__argument_list_with_parens] = STATE(2089),
    [sym__argument] = STATE(2090),
    [sym_splat_argument] = STATE(2090),
    [sym_hash_splat_argument] = STATE(2090),
    [sym_block_argument] = STATE(2090),
    [sym_assignment] = STATE(2087),
    [sym_operator_assignment] = STATE(2087),
    [sym_conditional] = STATE(2087),
    [sym_range] = STATE(2087),
    [sym_binary] = STATE(2087),
    [sym_unary] = STATE(2087),
    [sym_left_assignment_list] = STATE(2091),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2092),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2092),
    [sym_false] = STATE(2092),
    [sym_nil] = STATE(2092),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(2093),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(2090),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(3639),
    [sym__splat_star] = ACTIONS(3641),
    [sym__unary_minus] = ACTIONS(3643),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(3645),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_RPAREN] = ACTIONS(425),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(427),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3647),
    [anon_sym_yield] = ACTIONS(3649),
    [anon_sym_break] = ACTIONS(3651),
    [anon_sym_next] = ACTIONS(3653),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_PLUS_EQ] = ACTIONS(425),
    [anon_sym_DASH_EQ] = ACTIONS(425),
    [anon_sym_STAR_EQ] = ACTIONS(425),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(425),
    [anon_sym_SLASH_EQ] = ACTIONS(425),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(425),
    [anon_sym_PIPE_EQ] = ACTIONS(425),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(425),
    [anon_sym_AMP_EQ] = ACTIONS(425),
    [anon_sym_PERCENT_EQ] = ACTIONS(425),
    [anon_sym_GT_GT_EQ] = ACTIONS(425),
    [anon_sym_LT_LT_EQ] = ACTIONS(425),
    [anon_sym_CARET_EQ] = ACTIONS(425),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(3655),
    [anon_sym_not] = ACTIONS(3657),
    [anon_sym_BANG] = ACTIONS(3659),
    [anon_sym_TILDE] = ACTIONS(3661),
    [sym_constant] = ACTIONS(3663),
    [sym_identifier] = ACTIONS(3663),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4430] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(7025),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(4435),
    [sym_scope_resolution] = STATE(4433),
    [sym_call] = STATE(4433),
    [sym_method_call] = STATE(4435),
    [sym_assignment] = STATE(7025),
    [sym_operator_assignment] = STATE(7025),
    [sym_conditional] = STATE(7025),
    [sym_range] = STATE(7025),
    [sym_binary] = STATE(7025),
    [sym_unary] = STATE(7025),
    [sym_left_assignment_list] = STATE(4434),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4435),
    [sym__variable] = STATE(4433),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(4435),
    [sym_false] = STATE(4435),
    [sym_nil] = STATE(4435),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(4436),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(7228),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(7230),
    [anon_sym_yield] = ACTIONS(7232),
    [anon_sym_break] = ACTIONS(7234),
    [anon_sym_next] = ACTIONS(7236),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(7238),
    [anon_sym_defined_QMARK] = ACTIONS(7240),
    [anon_sym_not] = ACTIONS(7242),
    [anon_sym_BANG] = ACTIONS(7244),
    [anon_sym_TILDE] = ACTIONS(7244),
    [sym_constant] = ACTIONS(7246),
    [sym_identifier] = ACTIONS(7246),
    [sym_instance_variable] = ACTIONS(7248),
    [sym_class_variable] = ACTIONS(7248),
    [sym_global_variable] = ACTIONS(7248),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(7246),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(7246),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [4431] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(6632),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(4435),
    [sym_scope_resolution] = STATE(4433),
    [sym_call] = STATE(4433),
    [sym_method_call] = STATE(4435),
    [sym_assignment] = STATE(6632),
    [sym_operator_assignment] = STATE(6632),
    [sym_conditional] = STATE(6632),
    [sym_range] = STATE(6632),
    [sym_binary] = STATE(6632),
    [sym_unary] = STATE(6632),
    [sym_left_assignment_list] = STATE(4434),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4435),
    [sym__variable] = STATE(4433),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(4435),
    [sym_false] = STATE(4435),
    [sym_nil] = STATE(4435),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(4436),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(7228),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(7230),
    [anon_sym_yield] = ACTIONS(7232),
    [anon_sym_break] = ACTIONS(7234),
    [anon_sym_next] = ACTIONS(7236),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(7238),
    [anon_sym_defined_QMARK] = ACTIONS(7240),
    [anon_sym_not] = ACTIONS(7242),
    [anon_sym_BANG] = ACTIONS(7244),
    [anon_sym_TILDE] = ACTIONS(7244),
    [sym_constant] = ACTIONS(7246),
    [sym_identifier] = ACTIONS(7246),
    [sym_instance_variable] = ACTIONS(7248),
    [sym_class_variable] = ACTIONS(7248),
    [sym_global_variable] = ACTIONS(7248),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(7246),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(7246),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [4432] = {
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(10602),
    [sym__binary_star] = ACTIONS(10604),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_RPAREN] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(10606),
    [anon_sym_STAR_STAR] = ACTIONS(10608),
    [anon_sym_AMP] = ACTIONS(10610),
    [anon_sym_EQ] = ACTIONS(4217),
    [anon_sym_LT] = ACTIONS(10612),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_PLUS_EQ] = ACTIONS(4211),
    [anon_sym_DASH_EQ] = ACTIONS(4211),
    [anon_sym_STAR_EQ] = ACTIONS(4211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4211),
    [anon_sym_SLASH_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4211),
    [anon_sym_AMP_EQ] = ACTIONS(4211),
    [anon_sym_PERCENT_EQ] = ACTIONS(4211),
    [anon_sym_GT_GT_EQ] = ACTIONS(4211),
    [anon_sym_LT_LT_EQ] = ACTIONS(4211),
    [anon_sym_CARET_EQ] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(10614),
    [anon_sym_DOT_DOT] = ACTIONS(10616),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10618),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(10620),
    [anon_sym_AMP_AMP] = ACTIONS(10620),
    [anon_sym_LT_LT] = ACTIONS(10622),
    [anon_sym_GT_GT] = ACTIONS(10622),
    [anon_sym_EQ_EQ] = ACTIONS(10620),
    [anon_sym_BANG_EQ] = ACTIONS(10624),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10624),
    [anon_sym_LT_EQ_GT] = ACTIONS(10624),
    [anon_sym_EQ_TILDE] = ACTIONS(10624),
    [anon_sym_BANG_TILDE] = ACTIONS(10624),
    [anon_sym_LT_EQ] = ACTIONS(10612),
    [anon_sym_GT] = ACTIONS(10612),
    [anon_sym_GT_EQ] = ACTIONS(10626),
    [anon_sym_CARET] = ACTIONS(10606),
    [anon_sym_PLUS] = ACTIONS(10628),
    [anon_sym_SLASH] = ACTIONS(10608),
    [anon_sym_PERCENT] = ACTIONS(10608),
    [sym_comment] = ACTIONS(87),
  },
  [4433] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(2087),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2092),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2092),
    [sym_argument_list] = STATE(4801),
    [sym__argument_list_with_parens] = STATE(2089),
    [sym__argument] = STATE(2090),
    [sym_splat_argument] = STATE(2090),
    [sym_hash_splat_argument] = STATE(2090),
    [sym_block_argument] = STATE(2090),
    [sym_do_block] = STATE(1849),
    [sym_block] = STATE(1849),
    [sym_assignment] = STATE(2087),
    [sym_operator_assignment] = STATE(2087),
    [sym_conditional] = STATE(2087),
    [sym_range] = STATE(2087),
    [sym_binary] = STATE(2087),
    [sym_unary] = STATE(2087),
    [sym_left_assignment_list] = STATE(2091),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2092),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2092),
    [sym_false] = STATE(2092),
    [sym_nil] = STATE(2092),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(2093),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(2090),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(3639),
    [sym__splat_star] = ACTIONS(3641),
    [sym__unary_minus] = ACTIONS(3643),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(3645),
    [anon_sym_LBRACE] = ACTIONS(7739),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3647),
    [anon_sym_yield] = ACTIONS(3649),
    [anon_sym_break] = ACTIONS(3651),
    [anon_sym_next] = ACTIONS(3653),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(769),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(3655),
    [anon_sym_not] = ACTIONS(3657),
    [anon_sym_BANG] = ACTIONS(3659),
    [anon_sym_TILDE] = ACTIONS(3661),
    [sym_constant] = ACTIONS(3663),
    [sym_identifier] = ACTIONS(3663),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4434] = {
    [anon_sym_EQ] = ACTIONS(10630),
    [sym_comment] = ACTIONS(87),
  },
  [4435] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(10632),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(10634),
    [anon_sym_DASH_EQ] = ACTIONS(10634),
    [anon_sym_STAR_EQ] = ACTIONS(10634),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10634),
    [anon_sym_SLASH_EQ] = ACTIONS(10634),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10634),
    [anon_sym_PIPE_EQ] = ACTIONS(10634),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10634),
    [anon_sym_AMP_EQ] = ACTIONS(10634),
    [anon_sym_PERCENT_EQ] = ACTIONS(10634),
    [anon_sym_GT_GT_EQ] = ACTIONS(10634),
    [anon_sym_LT_LT_EQ] = ACTIONS(10634),
    [anon_sym_CARET_EQ] = ACTIONS(10634),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [4436] = {
    [sym_string] = STATE(7038),
    [aux_sym_chained_string_repeat1] = STATE(7038),
    [sym__string_start] = ACTIONS(6455),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [4437] = {
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(10602),
    [sym__binary_star] = ACTIONS(10604),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_RPAREN] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(10606),
    [anon_sym_STAR_STAR] = ACTIONS(10608),
    [anon_sym_AMP] = ACTIONS(10610),
    [anon_sym_EQ] = ACTIONS(4249),
    [anon_sym_LT] = ACTIONS(10612),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_PLUS_EQ] = ACTIONS(4247),
    [anon_sym_DASH_EQ] = ACTIONS(4247),
    [anon_sym_STAR_EQ] = ACTIONS(4247),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4247),
    [anon_sym_SLASH_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4247),
    [anon_sym_AMP_EQ] = ACTIONS(4247),
    [anon_sym_PERCENT_EQ] = ACTIONS(4247),
    [anon_sym_GT_GT_EQ] = ACTIONS(4247),
    [anon_sym_LT_LT_EQ] = ACTIONS(4247),
    [anon_sym_CARET_EQ] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(10614),
    [anon_sym_DOT_DOT] = ACTIONS(10616),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10618),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(10620),
    [anon_sym_AMP_AMP] = ACTIONS(10620),
    [anon_sym_LT_LT] = ACTIONS(10622),
    [anon_sym_GT_GT] = ACTIONS(10622),
    [anon_sym_EQ_EQ] = ACTIONS(10620),
    [anon_sym_BANG_EQ] = ACTIONS(10624),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10624),
    [anon_sym_LT_EQ_GT] = ACTIONS(10624),
    [anon_sym_EQ_TILDE] = ACTIONS(10624),
    [anon_sym_BANG_TILDE] = ACTIONS(10624),
    [anon_sym_LT_EQ] = ACTIONS(10612),
    [anon_sym_GT] = ACTIONS(10612),
    [anon_sym_GT_EQ] = ACTIONS(10626),
    [anon_sym_CARET] = ACTIONS(10606),
    [anon_sym_PLUS] = ACTIONS(10628),
    [anon_sym_SLASH] = ACTIONS(10608),
    [anon_sym_PERCENT] = ACTIONS(10608),
    [sym_comment] = ACTIONS(87),
  },
  [4438] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(7262),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [4439] = {
    [sym_string] = STATE(4459),
    [aux_sym_chained_string_repeat1] = STATE(4459),
    [sym__string_start] = ACTIONS(1141),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [4440] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(7039),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(4435),
    [sym_scope_resolution] = STATE(4433),
    [sym_call] = STATE(4433),
    [sym_method_call] = STATE(4435),
    [sym_assignment] = STATE(7039),
    [sym_operator_assignment] = STATE(7039),
    [sym_conditional] = STATE(7039),
    [sym_range] = STATE(7039),
    [sym_binary] = STATE(7039),
    [sym_unary] = STATE(7039),
    [sym_left_assignment_list] = STATE(4434),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4435),
    [sym__variable] = STATE(4433),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(4435),
    [sym_false] = STATE(4435),
    [sym_nil] = STATE(4435),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(4436),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(7228),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(7230),
    [anon_sym_yield] = ACTIONS(7232),
    [anon_sym_break] = ACTIONS(7234),
    [anon_sym_next] = ACTIONS(7236),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(7238),
    [anon_sym_defined_QMARK] = ACTIONS(7240),
    [anon_sym_not] = ACTIONS(7242),
    [anon_sym_BANG] = ACTIONS(7244),
    [anon_sym_TILDE] = ACTIONS(7244),
    [sym_constant] = ACTIONS(7246),
    [sym_identifier] = ACTIONS(7246),
    [sym_instance_variable] = ACTIONS(7248),
    [sym_class_variable] = ACTIONS(7248),
    [sym_global_variable] = ACTIONS(7248),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(7246),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(7246),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [4441] = {
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(10602),
    [sym__binary_star] = ACTIONS(10604),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_RPAREN] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(10606),
    [anon_sym_STAR_STAR] = ACTIONS(10608),
    [anon_sym_AMP] = ACTIONS(10610),
    [anon_sym_EQ] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(10612),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_PLUS_EQ] = ACTIONS(3281),
    [anon_sym_DASH_EQ] = ACTIONS(3281),
    [anon_sym_STAR_EQ] = ACTIONS(3281),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3281),
    [anon_sym_SLASH_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3281),
    [anon_sym_AMP_EQ] = ACTIONS(3281),
    [anon_sym_PERCENT_EQ] = ACTIONS(3281),
    [anon_sym_GT_GT_EQ] = ACTIONS(3281),
    [anon_sym_LT_LT_EQ] = ACTIONS(3281),
    [anon_sym_CARET_EQ] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(10614),
    [anon_sym_DOT_DOT] = ACTIONS(10616),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10618),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(10620),
    [anon_sym_AMP_AMP] = ACTIONS(10620),
    [anon_sym_LT_LT] = ACTIONS(10622),
    [anon_sym_GT_GT] = ACTIONS(10622),
    [anon_sym_EQ_EQ] = ACTIONS(10620),
    [anon_sym_BANG_EQ] = ACTIONS(10624),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10624),
    [anon_sym_LT_EQ_GT] = ACTIONS(10624),
    [anon_sym_EQ_TILDE] = ACTIONS(10624),
    [anon_sym_BANG_TILDE] = ACTIONS(10624),
    [anon_sym_LT_EQ] = ACTIONS(10612),
    [anon_sym_GT] = ACTIONS(10612),
    [anon_sym_GT_EQ] = ACTIONS(10626),
    [anon_sym_CARET] = ACTIONS(10606),
    [anon_sym_PLUS] = ACTIONS(10628),
    [anon_sym_SLASH] = ACTIONS(10608),
    [anon_sym_PERCENT] = ACTIONS(10608),
    [sym_comment] = ACTIONS(87),
  },
  [4442] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(7256),
    [sym__binary_star] = ACTIONS(7258),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(7260),
    [anon_sym_STAR_STAR] = ACTIONS(7262),
    [anon_sym_AMP] = ACTIONS(7264),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(7266),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(7268),
    [anon_sym_DOT_DOT] = ACTIONS(7270),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7272),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(7274),
    [anon_sym_AMP_AMP] = ACTIONS(7274),
    [anon_sym_LT_LT] = ACTIONS(7276),
    [anon_sym_GT_GT] = ACTIONS(7276),
    [anon_sym_EQ_EQ] = ACTIONS(7274),
    [anon_sym_BANG_EQ] = ACTIONS(7278),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7278),
    [anon_sym_LT_EQ_GT] = ACTIONS(7278),
    [anon_sym_EQ_TILDE] = ACTIONS(7278),
    [anon_sym_BANG_TILDE] = ACTIONS(7278),
    [anon_sym_LT_EQ] = ACTIONS(7266),
    [anon_sym_GT] = ACTIONS(7266),
    [anon_sym_GT_EQ] = ACTIONS(7280),
    [anon_sym_CARET] = ACTIONS(7260),
    [anon_sym_PLUS] = ACTIONS(7282),
    [anon_sym_SLASH] = ACTIONS(7262),
    [anon_sym_PERCENT] = ACTIONS(7262),
    [sym_comment] = ACTIONS(87),
  },
  [4443] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(7040),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(4435),
    [sym_scope_resolution] = STATE(4433),
    [sym_call] = STATE(4433),
    [sym_method_call] = STATE(4435),
    [sym_assignment] = STATE(7040),
    [sym_operator_assignment] = STATE(7040),
    [sym_conditional] = STATE(7040),
    [sym_range] = STATE(7040),
    [sym_binary] = STATE(7040),
    [sym_unary] = STATE(7040),
    [sym_left_assignment_list] = STATE(4434),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4435),
    [sym__variable] = STATE(4433),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(4435),
    [sym_false] = STATE(4435),
    [sym_nil] = STATE(4435),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(4436),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(7228),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(7230),
    [anon_sym_yield] = ACTIONS(7232),
    [anon_sym_break] = ACTIONS(7234),
    [anon_sym_next] = ACTIONS(7236),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(7238),
    [anon_sym_defined_QMARK] = ACTIONS(7240),
    [anon_sym_not] = ACTIONS(7242),
    [anon_sym_BANG] = ACTIONS(7244),
    [anon_sym_TILDE] = ACTIONS(7244),
    [sym_constant] = ACTIONS(7246),
    [sym_identifier] = ACTIONS(7246),
    [sym_instance_variable] = ACTIONS(7248),
    [sym_class_variable] = ACTIONS(7248),
    [sym_global_variable] = ACTIONS(7248),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(7246),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(7246),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [4444] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(7041),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2092),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2092),
    [sym_assignment] = STATE(7041),
    [sym_operator_assignment] = STATE(7041),
    [sym_conditional] = STATE(7041),
    [sym_range] = STATE(7041),
    [sym_binary] = STATE(7041),
    [sym_unary] = STATE(7041),
    [sym_left_assignment_list] = STATE(2091),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2092),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2092),
    [sym_false] = STATE(2092),
    [sym_nil] = STATE(2092),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4439),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3643),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3647),
    [anon_sym_yield] = ACTIONS(3649),
    [anon_sym_break] = ACTIONS(3651),
    [anon_sym_next] = ACTIONS(3653),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(7250),
    [anon_sym_defined_QMARK] = ACTIONS(3655),
    [anon_sym_not] = ACTIONS(3657),
    [anon_sym_BANG] = ACTIONS(3661),
    [anon_sym_TILDE] = ACTIONS(3661),
    [sym_constant] = ACTIONS(3667),
    [sym_identifier] = ACTIONS(3667),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4445] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(7042),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2092),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2092),
    [sym_assignment] = STATE(7042),
    [sym_operator_assignment] = STATE(7042),
    [sym_conditional] = STATE(7042),
    [sym_range] = STATE(7042),
    [sym_binary] = STATE(7042),
    [sym_unary] = STATE(7042),
    [sym_left_assignment_list] = STATE(2091),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2092),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2092),
    [sym_false] = STATE(2092),
    [sym_nil] = STATE(2092),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4439),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3643),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3647),
    [anon_sym_yield] = ACTIONS(3649),
    [anon_sym_break] = ACTIONS(3651),
    [anon_sym_next] = ACTIONS(3653),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(7250),
    [anon_sym_defined_QMARK] = ACTIONS(3655),
    [anon_sym_not] = ACTIONS(3657),
    [anon_sym_BANG] = ACTIONS(3661),
    [anon_sym_TILDE] = ACTIONS(3661),
    [sym_constant] = ACTIONS(3667),
    [sym_identifier] = ACTIONS(3667),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4446] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(7043),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2092),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2092),
    [sym_assignment] = STATE(7043),
    [sym_operator_assignment] = STATE(7043),
    [sym_conditional] = STATE(7043),
    [sym_range] = STATE(7043),
    [sym_binary] = STATE(7043),
    [sym_unary] = STATE(7043),
    [sym_left_assignment_list] = STATE(2091),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2092),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2092),
    [sym_false] = STATE(2092),
    [sym_nil] = STATE(2092),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4439),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3643),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3647),
    [anon_sym_yield] = ACTIONS(3649),
    [anon_sym_break] = ACTIONS(3651),
    [anon_sym_next] = ACTIONS(3653),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(7250),
    [anon_sym_defined_QMARK] = ACTIONS(3655),
    [anon_sym_not] = ACTIONS(3657),
    [anon_sym_BANG] = ACTIONS(3661),
    [anon_sym_TILDE] = ACTIONS(3661),
    [sym_constant] = ACTIONS(3667),
    [sym_identifier] = ACTIONS(3667),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4447] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(7044),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2092),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2092),
    [sym_assignment] = STATE(7044),
    [sym_operator_assignment] = STATE(7044),
    [sym_conditional] = STATE(7044),
    [sym_range] = STATE(7044),
    [sym_binary] = STATE(7044),
    [sym_unary] = STATE(7044),
    [sym_left_assignment_list] = STATE(2091),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2092),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2092),
    [sym_false] = STATE(2092),
    [sym_nil] = STATE(2092),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4439),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3643),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3647),
    [anon_sym_yield] = ACTIONS(3649),
    [anon_sym_break] = ACTIONS(3651),
    [anon_sym_next] = ACTIONS(3653),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(7250),
    [anon_sym_defined_QMARK] = ACTIONS(3655),
    [anon_sym_not] = ACTIONS(3657),
    [anon_sym_BANG] = ACTIONS(3661),
    [anon_sym_TILDE] = ACTIONS(3661),
    [sym_constant] = ACTIONS(3667),
    [sym_identifier] = ACTIONS(3667),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4448] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(7045),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2092),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2092),
    [sym_assignment] = STATE(7045),
    [sym_operator_assignment] = STATE(7045),
    [sym_conditional] = STATE(7045),
    [sym_range] = STATE(7045),
    [sym_binary] = STATE(7045),
    [sym_unary] = STATE(7045),
    [sym_left_assignment_list] = STATE(2091),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2092),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2092),
    [sym_false] = STATE(2092),
    [sym_nil] = STATE(2092),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4439),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3643),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3647),
    [anon_sym_yield] = ACTIONS(3649),
    [anon_sym_break] = ACTIONS(3651),
    [anon_sym_next] = ACTIONS(3653),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(7250),
    [anon_sym_defined_QMARK] = ACTIONS(3655),
    [anon_sym_not] = ACTIONS(3657),
    [anon_sym_BANG] = ACTIONS(3661),
    [anon_sym_TILDE] = ACTIONS(3661),
    [sym_constant] = ACTIONS(3667),
    [sym_identifier] = ACTIONS(3667),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4449] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(7046),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(7046),
    [sym_operator_assignment] = STATE(7046),
    [sym_conditional] = STATE(7046),
    [sym_range] = STATE(7046),
    [sym_binary] = STATE(7046),
    [sym_unary] = STATE(7046),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4450] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(7047),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2092),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2092),
    [sym_assignment] = STATE(7047),
    [sym_operator_assignment] = STATE(7047),
    [sym_conditional] = STATE(7047),
    [sym_range] = STATE(7047),
    [sym_binary] = STATE(7047),
    [sym_unary] = STATE(7047),
    [sym_left_assignment_list] = STATE(2091),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2092),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2092),
    [sym_false] = STATE(2092),
    [sym_nil] = STATE(2092),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4439),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3643),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3647),
    [anon_sym_yield] = ACTIONS(3649),
    [anon_sym_break] = ACTIONS(3651),
    [anon_sym_next] = ACTIONS(3653),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(7250),
    [anon_sym_defined_QMARK] = ACTIONS(3655),
    [anon_sym_not] = ACTIONS(3657),
    [anon_sym_BANG] = ACTIONS(3661),
    [anon_sym_TILDE] = ACTIONS(3661),
    [sym_constant] = ACTIONS(3667),
    [sym_identifier] = ACTIONS(3667),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4451] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(7048),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2092),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2092),
    [sym_assignment] = STATE(7048),
    [sym_operator_assignment] = STATE(7048),
    [sym_conditional] = STATE(7048),
    [sym_range] = STATE(7048),
    [sym_binary] = STATE(7048),
    [sym_unary] = STATE(7048),
    [sym_left_assignment_list] = STATE(2091),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2092),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2092),
    [sym_false] = STATE(2092),
    [sym_nil] = STATE(2092),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4439),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3643),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3647),
    [anon_sym_yield] = ACTIONS(3649),
    [anon_sym_break] = ACTIONS(3651),
    [anon_sym_next] = ACTIONS(3653),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(7250),
    [anon_sym_defined_QMARK] = ACTIONS(3655),
    [anon_sym_not] = ACTIONS(3657),
    [anon_sym_BANG] = ACTIONS(3661),
    [anon_sym_TILDE] = ACTIONS(3661),
    [sym_constant] = ACTIONS(3667),
    [sym_identifier] = ACTIONS(3667),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4452] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(7049),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2092),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2092),
    [sym_assignment] = STATE(7049),
    [sym_operator_assignment] = STATE(7049),
    [sym_conditional] = STATE(7049),
    [sym_range] = STATE(7049),
    [sym_binary] = STATE(7049),
    [sym_unary] = STATE(7049),
    [sym_left_assignment_list] = STATE(2091),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2092),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2092),
    [sym_false] = STATE(2092),
    [sym_nil] = STATE(2092),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4439),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3643),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3647),
    [anon_sym_yield] = ACTIONS(3649),
    [anon_sym_break] = ACTIONS(3651),
    [anon_sym_next] = ACTIONS(3653),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(7250),
    [anon_sym_defined_QMARK] = ACTIONS(3655),
    [anon_sym_not] = ACTIONS(3657),
    [anon_sym_BANG] = ACTIONS(3661),
    [anon_sym_TILDE] = ACTIONS(3661),
    [sym_constant] = ACTIONS(3667),
    [sym_identifier] = ACTIONS(3667),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4453] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(7050),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2092),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2092),
    [sym_assignment] = STATE(7050),
    [sym_operator_assignment] = STATE(7050),
    [sym_conditional] = STATE(7050),
    [sym_range] = STATE(7050),
    [sym_binary] = STATE(7050),
    [sym_unary] = STATE(7050),
    [sym_left_assignment_list] = STATE(2091),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2092),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2092),
    [sym_false] = STATE(2092),
    [sym_nil] = STATE(2092),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4439),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3643),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3647),
    [anon_sym_yield] = ACTIONS(3649),
    [anon_sym_break] = ACTIONS(3651),
    [anon_sym_next] = ACTIONS(3653),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(7250),
    [anon_sym_defined_QMARK] = ACTIONS(3655),
    [anon_sym_not] = ACTIONS(3657),
    [anon_sym_BANG] = ACTIONS(3661),
    [anon_sym_TILDE] = ACTIONS(3661),
    [sym_constant] = ACTIONS(3667),
    [sym_identifier] = ACTIONS(3667),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4454] = {
    [sym_heredoc_body] = STATE(7051),
    [aux_sym_call_repeat1] = STATE(7051),
    [sym__heredoc_body_start] = ACTIONS(6569),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_RPAREN] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [4455] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(2087),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2092),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2092),
    [sym__argument] = STATE(6674),
    [sym_splat_argument] = STATE(6674),
    [sym_hash_splat_argument] = STATE(6674),
    [sym_block_argument] = STATE(6674),
    [sym_assignment] = STATE(2087),
    [sym_operator_assignment] = STATE(2087),
    [sym_conditional] = STATE(2087),
    [sym_range] = STATE(2087),
    [sym_binary] = STATE(2087),
    [sym_unary] = STATE(2087),
    [sym_left_assignment_list] = STATE(2091),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2092),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2092),
    [sym_false] = STATE(2092),
    [sym_nil] = STATE(2092),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(2093),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_heredoc_body] = STATE(7052),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(6674),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(3639),
    [sym__splat_star] = ACTIONS(3641),
    [sym__unary_minus] = ACTIONS(3643),
    [sym__identifier_hash_key] = ACTIONS(3645),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10636),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3647),
    [anon_sym_yield] = ACTIONS(3649),
    [anon_sym_break] = ACTIONS(3651),
    [anon_sym_next] = ACTIONS(3653),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(7250),
    [anon_sym_defined_QMARK] = ACTIONS(3655),
    [anon_sym_not] = ACTIONS(3657),
    [anon_sym_BANG] = ACTIONS(3661),
    [anon_sym_TILDE] = ACTIONS(3661),
    [sym_constant] = ACTIONS(3663),
    [sym_identifier] = ACTIONS(3663),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4456] = {
    [sym_heredoc_body] = STATE(7053),
    [aux_sym_call_repeat1] = STATE(7053),
    [aux_sym_argument_list_repeat1] = STATE(7054),
    [sym__heredoc_body_start] = ACTIONS(6569),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_RPAREN] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(7284),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [4457] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(7055),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2092),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2092),
    [sym_splat_argument] = STATE(7056),
    [sym_assignment] = STATE(7055),
    [sym_operator_assignment] = STATE(7055),
    [sym_conditional] = STATE(7055),
    [sym_range] = STATE(7055),
    [sym_binary] = STATE(7055),
    [sym_unary] = STATE(7055),
    [sym_right_assignment_list] = STATE(4362),
    [sym__arg_or_splat_arg] = STATE(7056),
    [sym_left_assignment_list] = STATE(2091),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2092),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2092),
    [sym_false] = STATE(2092),
    [sym_nil] = STATE(2092),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4439),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__splat_star] = ACTIONS(4329),
    [sym__unary_minus] = ACTIONS(3643),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3647),
    [anon_sym_yield] = ACTIONS(3649),
    [anon_sym_break] = ACTIONS(3651),
    [anon_sym_next] = ACTIONS(3653),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(7250),
    [anon_sym_defined_QMARK] = ACTIONS(3655),
    [anon_sym_not] = ACTIONS(3657),
    [anon_sym_BANG] = ACTIONS(3661),
    [anon_sym_TILDE] = ACTIONS(3661),
    [sym_constant] = ACTIONS(3667),
    [sym_identifier] = ACTIONS(3667),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4458] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(7057),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2092),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2092),
    [sym_assignment] = STATE(7057),
    [sym_operator_assignment] = STATE(7057),
    [sym_conditional] = STATE(7057),
    [sym_range] = STATE(7057),
    [sym_binary] = STATE(7057),
    [sym_unary] = STATE(7057),
    [sym_left_assignment_list] = STATE(2091),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2092),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2092),
    [sym_false] = STATE(2092),
    [sym_nil] = STATE(2092),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4439),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3643),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3647),
    [anon_sym_yield] = ACTIONS(3649),
    [anon_sym_break] = ACTIONS(3651),
    [anon_sym_next] = ACTIONS(3653),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(7250),
    [anon_sym_defined_QMARK] = ACTIONS(3655),
    [anon_sym_not] = ACTIONS(3657),
    [anon_sym_BANG] = ACTIONS(3661),
    [anon_sym_TILDE] = ACTIONS(3661),
    [sym_constant] = ACTIONS(3667),
    [sym_identifier] = ACTIONS(3667),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4459] = {
    [sym_string] = STATE(7058),
    [aux_sym_chained_string_repeat1] = STATE(7058),
    [sym__string_start] = ACTIONS(1141),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_RPAREN] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_STAR_STAR] = ACTIONS(2755),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_EQ] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_EQ_GT] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_PLUS_EQ] = ACTIONS(2753),
    [anon_sym_DASH_EQ] = ACTIONS(2753),
    [anon_sym_STAR_EQ] = ACTIONS(2753),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2753),
    [anon_sym_SLASH_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2753),
    [anon_sym_AMP_EQ] = ACTIONS(2753),
    [anon_sym_PERCENT_EQ] = ACTIONS(2753),
    [anon_sym_GT_GT_EQ] = ACTIONS(2753),
    [anon_sym_LT_LT_EQ] = ACTIONS(2753),
    [anon_sym_CARET_EQ] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2755),
    [anon_sym_AMP_AMP] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2755),
    [anon_sym_GT_GT] = ACTIONS(2755),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_SLASH] = ACTIONS(2755),
    [anon_sym_PERCENT] = ACTIONS(2755),
    [sym_comment] = ACTIONS(87),
  },
  [4460] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(7059),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(4471),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(4471),
    [sym_assignment] = STATE(7059),
    [sym_operator_assignment] = STATE(7059),
    [sym_conditional] = STATE(7059),
    [sym_range] = STATE(7059),
    [sym_binary] = STATE(7059),
    [sym_unary] = STATE(7059),
    [sym_left_assignment_list] = STATE(4470),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4471),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(4471),
    [sym_false] = STATE(4471),
    [sym_nil] = STATE(4471),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(4472),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(7296),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7298),
    [anon_sym_yield] = ACTIONS(7300),
    [anon_sym_break] = ACTIONS(7302),
    [anon_sym_next] = ACTIONS(7304),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7306),
    [anon_sym_defined_QMARK] = ACTIONS(7308),
    [anon_sym_not] = ACTIONS(7310),
    [anon_sym_BANG] = ACTIONS(7312),
    [anon_sym_TILDE] = ACTIONS(7312),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4461] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(7060),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(4471),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(4471),
    [sym_assignment] = STATE(7060),
    [sym_operator_assignment] = STATE(7060),
    [sym_conditional] = STATE(7060),
    [sym_range] = STATE(7060),
    [sym_binary] = STATE(7060),
    [sym_unary] = STATE(7060),
    [sym_left_assignment_list] = STATE(4470),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4471),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(4471),
    [sym_false] = STATE(4471),
    [sym_nil] = STATE(4471),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(4472),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(7296),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7298),
    [anon_sym_yield] = ACTIONS(7300),
    [anon_sym_break] = ACTIONS(7302),
    [anon_sym_next] = ACTIONS(7304),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7306),
    [anon_sym_defined_QMARK] = ACTIONS(7308),
    [anon_sym_not] = ACTIONS(7310),
    [anon_sym_BANG] = ACTIONS(7312),
    [anon_sym_TILDE] = ACTIONS(7312),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4462] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(2057),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2061),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(2061),
    [sym_argument_list] = STATE(563),
    [sym__argument_list_with_parens] = STATE(4910),
    [sym__argument] = STATE(4911),
    [sym_splat_argument] = STATE(4911),
    [sym_hash_splat_argument] = STATE(4911),
    [sym_block_argument] = STATE(4911),
    [sym_assignment] = STATE(2057),
    [sym_operator_assignment] = STATE(2057),
    [sym_conditional] = STATE(2057),
    [sym_range] = STATE(2057),
    [sym_binary] = STATE(2057),
    [sym_unary] = STATE(2057),
    [sym_left_assignment_list] = STATE(2060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2061),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2061),
    [sym_false] = STATE(2061),
    [sym_nil] = STATE(2061),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2062),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(4911),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(3591),
    [sym__splat_star] = ACTIONS(3593),
    [sym__unary_minus] = ACTIONS(3595),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(3597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(365),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(3599),
    [anon_sym_not] = ACTIONS(3601),
    [anon_sym_BANG] = ACTIONS(3603),
    [anon_sym_TILDE] = ACTIONS(3605),
    [sym_constant] = ACTIONS(3607),
    [sym_identifier] = ACTIONS(3607),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4463] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(2057),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2061),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(2061),
    [sym_argument_list] = STATE(569),
    [sym__argument_list_with_parens] = STATE(4910),
    [sym__argument] = STATE(4911),
    [sym_splat_argument] = STATE(4911),
    [sym_hash_splat_argument] = STATE(4911),
    [sym_block_argument] = STATE(4911),
    [sym_assignment] = STATE(2057),
    [sym_operator_assignment] = STATE(2057),
    [sym_conditional] = STATE(2057),
    [sym_range] = STATE(2057),
    [sym_binary] = STATE(2057),
    [sym_unary] = STATE(2057),
    [sym_left_assignment_list] = STATE(2060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2061),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2061),
    [sym_false] = STATE(2061),
    [sym_nil] = STATE(2061),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2062),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(4911),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(3591),
    [sym__splat_star] = ACTIONS(3593),
    [sym__unary_minus] = ACTIONS(3595),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(3597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(417),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(3599),
    [anon_sym_not] = ACTIONS(3601),
    [anon_sym_BANG] = ACTIONS(3603),
    [anon_sym_TILDE] = ACTIONS(3605),
    [sym_constant] = ACTIONS(3607),
    [sym_identifier] = ACTIONS(3607),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4464] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(2057),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2061),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(2061),
    [sym_argument_list] = STATE(570),
    [sym__argument_list_with_parens] = STATE(4910),
    [sym__argument] = STATE(4911),
    [sym_splat_argument] = STATE(4911),
    [sym_hash_splat_argument] = STATE(4911),
    [sym_block_argument] = STATE(4911),
    [sym_assignment] = STATE(2057),
    [sym_operator_assignment] = STATE(2057),
    [sym_conditional] = STATE(2057),
    [sym_range] = STATE(2057),
    [sym_binary] = STATE(2057),
    [sym_unary] = STATE(2057),
    [sym_left_assignment_list] = STATE(2060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2061),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2061),
    [sym_false] = STATE(2061),
    [sym_nil] = STATE(2061),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2062),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(4911),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(3591),
    [sym__splat_star] = ACTIONS(3593),
    [sym__unary_minus] = ACTIONS(3595),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(3597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(421),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(3599),
    [anon_sym_not] = ACTIONS(3601),
    [anon_sym_BANG] = ACTIONS(3603),
    [anon_sym_TILDE] = ACTIONS(3605),
    [sym_constant] = ACTIONS(3607),
    [sym_identifier] = ACTIONS(3607),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4465] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(2057),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2061),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(2061),
    [sym_argument_list] = STATE(571),
    [sym__argument_list_with_parens] = STATE(4910),
    [sym__argument] = STATE(4911),
    [sym_splat_argument] = STATE(4911),
    [sym_hash_splat_argument] = STATE(4911),
    [sym_block_argument] = STATE(4911),
    [sym_assignment] = STATE(2057),
    [sym_operator_assignment] = STATE(2057),
    [sym_conditional] = STATE(2057),
    [sym_range] = STATE(2057),
    [sym_binary] = STATE(2057),
    [sym_unary] = STATE(2057),
    [sym_left_assignment_list] = STATE(2060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2061),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2061),
    [sym_false] = STATE(2061),
    [sym_nil] = STATE(2061),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2062),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(4911),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(3591),
    [sym__splat_star] = ACTIONS(3593),
    [sym__unary_minus] = ACTIONS(3595),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(3597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(425),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(3599),
    [anon_sym_not] = ACTIONS(3601),
    [anon_sym_BANG] = ACTIONS(3603),
    [anon_sym_TILDE] = ACTIONS(3605),
    [sym_constant] = ACTIONS(3607),
    [sym_identifier] = ACTIONS(3607),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4466] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(7061),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(4471),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(4471),
    [sym_assignment] = STATE(7061),
    [sym_operator_assignment] = STATE(7061),
    [sym_conditional] = STATE(7061),
    [sym_range] = STATE(7061),
    [sym_binary] = STATE(7061),
    [sym_unary] = STATE(7061),
    [sym_left_assignment_list] = STATE(4470),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4471),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(4471),
    [sym_false] = STATE(4471),
    [sym_nil] = STATE(4471),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(4472),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(7296),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7298),
    [anon_sym_yield] = ACTIONS(7300),
    [anon_sym_break] = ACTIONS(7302),
    [anon_sym_next] = ACTIONS(7304),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7306),
    [anon_sym_defined_QMARK] = ACTIONS(7308),
    [anon_sym_not] = ACTIONS(7310),
    [anon_sym_BANG] = ACTIONS(7312),
    [anon_sym_TILDE] = ACTIONS(7312),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4467] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(586),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(4471),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(4471),
    [sym_assignment] = STATE(586),
    [sym_operator_assignment] = STATE(586),
    [sym_conditional] = STATE(586),
    [sym_range] = STATE(586),
    [sym_binary] = STATE(586),
    [sym_unary] = STATE(586),
    [sym_left_assignment_list] = STATE(4470),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4471),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(4471),
    [sym_false] = STATE(4471),
    [sym_nil] = STATE(4471),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(4472),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(7296),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7298),
    [anon_sym_yield] = ACTIONS(7300),
    [anon_sym_break] = ACTIONS(7302),
    [anon_sym_next] = ACTIONS(7304),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7306),
    [anon_sym_defined_QMARK] = ACTIONS(7308),
    [anon_sym_not] = ACTIONS(7310),
    [anon_sym_BANG] = ACTIONS(7312),
    [anon_sym_TILDE] = ACTIONS(7312),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4468] = {
    [sym__binary_minus] = ACTIONS(10638),
    [sym__binary_star] = ACTIONS(10640),
    [anon_sym_RPAREN] = ACTIONS(5115),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(10642),
    [anon_sym_STAR_STAR] = ACTIONS(10640),
    [anon_sym_AMP] = ACTIONS(10644),
    [anon_sym_LT] = ACTIONS(10646),
    [anon_sym_QMARK] = ACTIONS(10648),
    [anon_sym_DOT_DOT] = ACTIONS(10650),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10652),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(10654),
    [anon_sym_AMP_AMP] = ACTIONS(10654),
    [anon_sym_LT_LT] = ACTIONS(10656),
    [anon_sym_GT_GT] = ACTIONS(10656),
    [anon_sym_EQ_EQ] = ACTIONS(10658),
    [anon_sym_BANG_EQ] = ACTIONS(10654),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10654),
    [anon_sym_LT_EQ_GT] = ACTIONS(10654),
    [anon_sym_EQ_TILDE] = ACTIONS(10654),
    [anon_sym_BANG_TILDE] = ACTIONS(10654),
    [anon_sym_LT_EQ] = ACTIONS(10646),
    [anon_sym_GT] = ACTIONS(10646),
    [anon_sym_GT_EQ] = ACTIONS(10660),
    [anon_sym_CARET] = ACTIONS(10662),
    [anon_sym_PLUS] = ACTIONS(10638),
    [anon_sym_SLASH] = ACTIONS(10640),
    [anon_sym_PERCENT] = ACTIONS(10640),
    [sym_comment] = ACTIONS(87),
  },
  [4469] = {
    [aux_sym_exceptions_repeat1] = STATE(7073),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_RPAREN] = ACTIONS(6191),
    [anon_sym_COMMA] = ACTIONS(10664),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [4470] = {
    [anon_sym_EQ] = ACTIONS(10666),
    [sym_comment] = ACTIONS(87),
  },
  [4471] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(10668),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(10670),
    [anon_sym_DASH_EQ] = ACTIONS(10670),
    [anon_sym_STAR_EQ] = ACTIONS(10670),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10670),
    [anon_sym_SLASH_EQ] = ACTIONS(10670),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10670),
    [anon_sym_PIPE_EQ] = ACTIONS(10670),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10670),
    [anon_sym_AMP_EQ] = ACTIONS(10670),
    [anon_sym_PERCENT_EQ] = ACTIONS(10670),
    [anon_sym_GT_GT_EQ] = ACTIONS(10670),
    [anon_sym_LT_LT_EQ] = ACTIONS(10670),
    [anon_sym_CARET_EQ] = ACTIONS(10670),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [4472] = {
    [sym_string] = STATE(7076),
    [aux_sym_chained_string_repeat1] = STATE(7076),
    [sym__string_start] = ACTIONS(139),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [4473] = {
    [sym__binary_minus] = ACTIONS(3609),
    [sym__binary_star] = ACTIONS(3611),
    [anon_sym_RPAREN] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(3615),
    [anon_sym_STAR_STAR] = ACTIONS(3611),
    [anon_sym_AMP] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3619),
    [anon_sym_QMARK] = ACTIONS(3621),
    [anon_sym_DOT_DOT] = ACTIONS(3623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3625),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(3629),
    [anon_sym_AMP_AMP] = ACTIONS(3629),
    [anon_sym_LT_LT] = ACTIONS(3631),
    [anon_sym_GT_GT] = ACTIONS(3631),
    [anon_sym_EQ_EQ] = ACTIONS(3633),
    [anon_sym_BANG_EQ] = ACTIONS(3629),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3629),
    [anon_sym_LT_EQ_GT] = ACTIONS(3629),
    [anon_sym_EQ_TILDE] = ACTIONS(3629),
    [anon_sym_BANG_TILDE] = ACTIONS(3629),
    [anon_sym_LT_EQ] = ACTIONS(3619),
    [anon_sym_GT] = ACTIONS(3619),
    [anon_sym_GT_EQ] = ACTIONS(3635),
    [anon_sym_CARET] = ACTIONS(3637),
    [anon_sym_PLUS] = ACTIONS(3609),
    [anon_sym_SLASH] = ACTIONS(3611),
    [anon_sym_PERCENT] = ACTIONS(3611),
    [sym_comment] = ACTIONS(87),
  },
  [4474] = {
    [sym_string] = STATE(4474),
    [aux_sym_chained_string_repeat1] = STATE(4474),
    [sym__string_start] = ACTIONS(7159),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_RPAREN] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [4475] = {
    [sym__simple_symbol] = ACTIONS(10672),
    [sym__string_start] = ACTIONS(10672),
    [sym__symbol_start] = ACTIONS(10672),
    [sym__subshell_start] = ACTIONS(10672),
    [sym__regex_start] = ACTIONS(10672),
    [sym__string_array_start] = ACTIONS(10672),
    [sym__symbol_array_start] = ACTIONS(10672),
    [sym_heredoc_beginning] = ACTIONS(10672),
    [sym__unary_minus] = ACTIONS(10672),
    [anon_sym_BEGIN] = ACTIONS(10674),
    [anon_sym_LBRACE] = ACTIONS(10672),
    [anon_sym_END] = ACTIONS(10674),
    [anon_sym_def] = ACTIONS(10674),
    [anon_sym_LPAREN] = ACTIONS(10672),
    [anon_sym_COLON_COLON] = ACTIONS(10672),
    [anon_sym_SEMI] = ACTIONS(10672),
    [anon_sym_STAR] = ACTIONS(10672),
    [anon_sym_class] = ACTIONS(10674),
    [anon_sym_module] = ACTIONS(10674),
    [anon_sym_end] = ACTIONS(10674),
    [anon_sym_return] = ACTIONS(10674),
    [anon_sym_yield] = ACTIONS(10674),
    [anon_sym_break] = ACTIONS(10674),
    [anon_sym_next] = ACTIONS(10674),
    [sym_redo] = ACTIONS(10674),
    [sym_retry] = ACTIONS(10674),
    [anon_sym_if] = ACTIONS(10674),
    [anon_sym_unless] = ACTIONS(10674),
    [anon_sym_while] = ACTIONS(10674),
    [anon_sym_until] = ACTIONS(10674),
    [anon_sym_rescue] = ACTIONS(10674),
    [anon_sym_for] = ACTIONS(10674),
    [anon_sym_case] = ACTIONS(10674),
    [anon_sym_else] = ACTIONS(10674),
    [anon_sym_begin] = ACTIONS(10674),
    [anon_sym_ensure] = ACTIONS(10674),
    [anon_sym_PLUS] = ACTIONS(10674),
    [anon_sym_defined_QMARK] = ACTIONS(10672),
    [anon_sym_not] = ACTIONS(10674),
    [anon_sym_BANG] = ACTIONS(10672),
    [anon_sym_TILDE] = ACTIONS(10672),
    [sym_constant] = ACTIONS(10674),
    [sym_identifier] = ACTIONS(10674),
    [sym_instance_variable] = ACTIONS(10672),
    [sym_class_variable] = ACTIONS(10672),
    [sym_global_variable] = ACTIONS(10672),
    [anon_sym_undef] = ACTIONS(10674),
    [anon_sym_alias] = ACTIONS(10674),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(10674),
    [sym_float] = ACTIONS(10674),
    [sym_complex] = ACTIONS(10672),
    [sym_super] = ACTIONS(10674),
    [anon_sym_true] = ACTIONS(10674),
    [anon_sym_TRUE] = ACTIONS(10674),
    [anon_sym_false] = ACTIONS(10674),
    [anon_sym_FALSE] = ACTIONS(10674),
    [sym_self] = ACTIONS(10674),
    [anon_sym_nil] = ACTIONS(10674),
    [anon_sym_NIL] = ACTIONS(10674),
    [sym_character] = ACTIONS(10672),
    [anon_sym_LBRACK2] = ACTIONS(10672),
    [anon_sym_DASH_GT] = ACTIONS(10672),
  },
  [4476] = {
    [sym_heredoc_body] = STATE(7077),
    [sym__terminator] = STATE(7077),
    [sym__line_break] = ACTIONS(10676),
    [sym__simple_symbol] = ACTIONS(10672),
    [sym__string_start] = ACTIONS(10672),
    [sym__symbol_start] = ACTIONS(10672),
    [sym__subshell_start] = ACTIONS(10672),
    [sym__regex_start] = ACTIONS(10672),
    [sym__string_array_start] = ACTIONS(10672),
    [sym__symbol_array_start] = ACTIONS(10672),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(10672),
    [sym__unary_minus] = ACTIONS(10672),
    [anon_sym_BEGIN] = ACTIONS(10674),
    [anon_sym_LBRACE] = ACTIONS(10672),
    [anon_sym_END] = ACTIONS(10674),
    [anon_sym_def] = ACTIONS(10674),
    [anon_sym_LPAREN] = ACTIONS(10672),
    [anon_sym_COLON_COLON] = ACTIONS(10672),
    [anon_sym_SEMI] = ACTIONS(10676),
    [anon_sym_STAR] = ACTIONS(10672),
    [anon_sym_class] = ACTIONS(10674),
    [anon_sym_module] = ACTIONS(10674),
    [anon_sym_end] = ACTIONS(10674),
    [anon_sym_return] = ACTIONS(10674),
    [anon_sym_yield] = ACTIONS(10674),
    [anon_sym_break] = ACTIONS(10674),
    [anon_sym_next] = ACTIONS(10674),
    [sym_redo] = ACTIONS(10674),
    [sym_retry] = ACTIONS(10674),
    [anon_sym_if] = ACTIONS(10674),
    [anon_sym_unless] = ACTIONS(10674),
    [anon_sym_while] = ACTIONS(10674),
    [anon_sym_until] = ACTIONS(10674),
    [anon_sym_rescue] = ACTIONS(10674),
    [anon_sym_for] = ACTIONS(10674),
    [anon_sym_case] = ACTIONS(10674),
    [anon_sym_else] = ACTIONS(10674),
    [anon_sym_begin] = ACTIONS(10674),
    [anon_sym_ensure] = ACTIONS(10674),
    [anon_sym_PLUS] = ACTIONS(10674),
    [anon_sym_defined_QMARK] = ACTIONS(10672),
    [anon_sym_not] = ACTIONS(10674),
    [anon_sym_BANG] = ACTIONS(10672),
    [anon_sym_TILDE] = ACTIONS(10672),
    [sym_constant] = ACTIONS(10674),
    [sym_identifier] = ACTIONS(10674),
    [sym_instance_variable] = ACTIONS(10672),
    [sym_class_variable] = ACTIONS(10672),
    [sym_global_variable] = ACTIONS(10672),
    [anon_sym_undef] = ACTIONS(10674),
    [anon_sym_alias] = ACTIONS(10674),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(10674),
    [sym_float] = ACTIONS(10674),
    [sym_complex] = ACTIONS(10672),
    [sym_super] = ACTIONS(10674),
    [anon_sym_true] = ACTIONS(10674),
    [anon_sym_TRUE] = ACTIONS(10674),
    [anon_sym_false] = ACTIONS(10674),
    [anon_sym_FALSE] = ACTIONS(10674),
    [sym_self] = ACTIONS(10674),
    [anon_sym_nil] = ACTIONS(10674),
    [anon_sym_NIL] = ACTIONS(10674),
    [sym_character] = ACTIONS(10672),
    [anon_sym_LBRACK2] = ACTIONS(10672),
    [anon_sym_DASH_GT] = ACTIONS(10672),
  },
  [4477] = {
    [aux_sym_method_parameters_repeat1] = STATE(6108),
    [anon_sym_RPAREN] = ACTIONS(10678),
    [anon_sym_COMMA] = ACTIONS(5757),
    [sym_comment] = ACTIONS(87),
  },
  [4478] = {
    [sym__statements] = STATE(7080),
    [sym_begin_block] = STATE(489),
    [sym_end_block] = STATE(489),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_block_parameters] = STATE(7081),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(495),
    [aux_sym__statements_repeat1] = STATE(495),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(10680),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2445),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4479] = {
    [sym__statements] = STATE(7083),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_block_parameters] = STATE(7084),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_heredoc_body] = STATE(7085),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [sym__terminator] = STATE(7085),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__line_break] = ACTIONS(10682),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(10682),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10684),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4480] = {
    [sym_do_block] = STATE(7086),
    [sym_block] = STATE(7086),
    [anon_sym_LBRACE] = ACTIONS(7326),
    [anon_sym_do] = ACTIONS(10686),
    [sym_comment] = ACTIONS(87),
  },
  [4481] = {
    [sym__line_break] = ACTIONS(2485),
    [sym__heredoc_body_start] = ACTIONS(2485),
    [anon_sym_COMMA] = ACTIONS(2485),
    [anon_sym_SEMI] = ACTIONS(2485),
    [sym_comment] = ACTIONS(87),
  },
  [4482] = {
    [sym__line_break] = ACTIONS(9460),
    [sym__heredoc_body_start] = ACTIONS(9460),
    [sym__binary_minus] = ACTIONS(8587),
    [sym__binary_star] = ACTIONS(8589),
    [anon_sym_COMMA] = ACTIONS(9460),
    [anon_sym_PIPE] = ACTIONS(8591),
    [anon_sym_SEMI] = ACTIONS(9460),
    [anon_sym_STAR_STAR] = ACTIONS(8589),
    [anon_sym_AMP] = ACTIONS(8593),
    [anon_sym_LT] = ACTIONS(8595),
    [anon_sym_QMARK] = ACTIONS(8597),
    [anon_sym_DOT_DOT] = ACTIONS(8599),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8601),
    [anon_sym_and] = ACTIONS(10688),
    [anon_sym_or] = ACTIONS(10688),
    [anon_sym_PIPE_PIPE] = ACTIONS(8603),
    [anon_sym_AMP_AMP] = ACTIONS(8603),
    [anon_sym_LT_LT] = ACTIONS(8605),
    [anon_sym_GT_GT] = ACTIONS(8605),
    [anon_sym_EQ_EQ] = ACTIONS(8607),
    [anon_sym_BANG_EQ] = ACTIONS(8603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8603),
    [anon_sym_LT_EQ_GT] = ACTIONS(8603),
    [anon_sym_EQ_TILDE] = ACTIONS(8603),
    [anon_sym_BANG_TILDE] = ACTIONS(8603),
    [anon_sym_LT_EQ] = ACTIONS(8595),
    [anon_sym_GT] = ACTIONS(8595),
    [anon_sym_GT_EQ] = ACTIONS(8609),
    [anon_sym_CARET] = ACTIONS(8611),
    [anon_sym_PLUS] = ACTIONS(8587),
    [anon_sym_SLASH] = ACTIONS(8589),
    [anon_sym_PERCENT] = ACTIONS(8589),
    [sym_comment] = ACTIONS(87),
  },
  [4483] = {
    [sym__line_break] = ACTIONS(9494),
    [sym__heredoc_body_start] = ACTIONS(9494),
    [sym__binary_minus] = ACTIONS(8587),
    [sym__binary_star] = ACTIONS(8589),
    [anon_sym_COMMA] = ACTIONS(9494),
    [anon_sym_PIPE] = ACTIONS(8591),
    [anon_sym_SEMI] = ACTIONS(9494),
    [anon_sym_STAR_STAR] = ACTIONS(8589),
    [anon_sym_AMP] = ACTIONS(8593),
    [anon_sym_LT] = ACTIONS(8595),
    [anon_sym_QMARK] = ACTIONS(8597),
    [anon_sym_DOT_DOT] = ACTIONS(8599),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8601),
    [anon_sym_and] = ACTIONS(10688),
    [anon_sym_or] = ACTIONS(10688),
    [anon_sym_PIPE_PIPE] = ACTIONS(8603),
    [anon_sym_AMP_AMP] = ACTIONS(8603),
    [anon_sym_LT_LT] = ACTIONS(8605),
    [anon_sym_GT_GT] = ACTIONS(8605),
    [anon_sym_EQ_EQ] = ACTIONS(8607),
    [anon_sym_BANG_EQ] = ACTIONS(8603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8603),
    [anon_sym_LT_EQ_GT] = ACTIONS(8603),
    [anon_sym_EQ_TILDE] = ACTIONS(8603),
    [anon_sym_BANG_TILDE] = ACTIONS(8603),
    [anon_sym_LT_EQ] = ACTIONS(8595),
    [anon_sym_GT] = ACTIONS(8595),
    [anon_sym_GT_EQ] = ACTIONS(8609),
    [anon_sym_CARET] = ACTIONS(8611),
    [anon_sym_PLUS] = ACTIONS(8587),
    [anon_sym_SLASH] = ACTIONS(8589),
    [anon_sym_PERCENT] = ACTIONS(8589),
    [sym_comment] = ACTIONS(87),
  },
  [4484] = {
    [sym__formal_parameter] = STATE(7087),
    [sym__simple_formal_parameter] = STATE(7087),
    [sym_destructured_parameter] = STATE(7087),
    [sym_splat_parameter] = STATE(7087),
    [sym_hash_splat_parameter] = STATE(7087),
    [sym_block_parameter] = STATE(7087),
    [sym_keyword_parameter] = STATE(7087),
    [sym_optional_parameter] = STATE(7087),
    [anon_sym_LPAREN] = ACTIONS(2447),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [sym_identifier] = ACTIONS(2451),
    [sym_comment] = ACTIONS(87),
  },
  [4485] = {
    [sym_heredoc_body] = STATE(7077),
    [sym__terminator] = STATE(7077),
    [aux_sym_method_parameters_repeat1] = STATE(7089),
    [sym__line_break] = ACTIONS(10676),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_COMMA] = ACTIONS(10690),
    [anon_sym_SEMI] = ACTIONS(10676),
    [sym_comment] = ACTIONS(87),
  },
  [4486] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7090),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4495),
    [sym_scope_resolution] = STATE(4433),
    [sym_call] = STATE(4433),
    [sym_method_call] = STATE(4495),
    [sym_assignment] = STATE(7090),
    [sym_operator_assignment] = STATE(7090),
    [sym_conditional] = STATE(7090),
    [sym_range] = STATE(7090),
    [sym_binary] = STATE(7090),
    [sym_unary] = STATE(7090),
    [sym_left_assignment_list] = STATE(4494),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4495),
    [sym__variable] = STATE(4433),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4495),
    [sym_false] = STATE(4495),
    [sym_nil] = STATE(4495),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(4496),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(4005),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(4009),
    [sym__subshell_start] = ACTIONS(4011),
    [sym__regex_start] = ACTIONS(4013),
    [sym__string_array_start] = ACTIONS(4015),
    [sym__symbol_array_start] = ACTIONS(4017),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7336),
    [anon_sym_LBRACE] = ACTIONS(4021),
    [anon_sym_def] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4025),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(4027),
    [anon_sym_module] = ACTIONS(4029),
    [anon_sym_return] = ACTIONS(7338),
    [anon_sym_yield] = ACTIONS(7340),
    [anon_sym_break] = ACTIONS(7342),
    [anon_sym_next] = ACTIONS(7344),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(4039),
    [anon_sym_unless] = ACTIONS(4041),
    [anon_sym_while] = ACTIONS(4043),
    [anon_sym_until] = ACTIONS(4045),
    [anon_sym_for] = ACTIONS(4047),
    [anon_sym_case] = ACTIONS(4049),
    [anon_sym_begin] = ACTIONS(4051),
    [anon_sym_PLUS] = ACTIONS(7346),
    [anon_sym_defined_QMARK] = ACTIONS(7348),
    [anon_sym_not] = ACTIONS(7350),
    [anon_sym_BANG] = ACTIONS(7352),
    [anon_sym_TILDE] = ACTIONS(7352),
    [sym_constant] = ACTIONS(7246),
    [sym_identifier] = ACTIONS(7246),
    [sym_instance_variable] = ACTIONS(7248),
    [sym_class_variable] = ACTIONS(7248),
    [sym_global_variable] = ACTIONS(7248),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4065),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(7246),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(7246),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(4067),
    [anon_sym_DASH_GT] = ACTIONS(4069),
  },
  [4487] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(7096),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2125),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2125),
    [sym_argument_list] = STATE(4761),
    [sym__argument_list_with_parens] = STATE(7097),
    [sym__argument] = STATE(7098),
    [sym_splat_argument] = STATE(7098),
    [sym_hash_splat_argument] = STATE(7098),
    [sym_block_argument] = STATE(7098),
    [sym_assignment] = STATE(7096),
    [sym_operator_assignment] = STATE(7096),
    [sym_conditional] = STATE(7096),
    [sym_range] = STATE(7096),
    [sym_binary] = STATE(7096),
    [sym_unary] = STATE(7096),
    [sym_left_assignment_list] = STATE(2124),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2125),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2125),
    [sym_false] = STATE(2125),
    [sym_nil] = STATE(2125),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(7099),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(7098),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(10692),
    [sym__splat_star] = ACTIONS(10694),
    [sym__unary_minus] = ACTIONS(3705),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(10696),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(365),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3713),
    [anon_sym_break] = ACTIONS(3715),
    [anon_sym_next] = ACTIONS(3717),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(7693),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(3721),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_BANG] = ACTIONS(7362),
    [anon_sym_TILDE] = ACTIONS(3725),
    [sym_constant] = ACTIONS(10698),
    [sym_identifier] = ACTIONS(10698),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4488] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(7096),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2125),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2125),
    [sym_argument_list] = STATE(4765),
    [sym__argument_list_with_parens] = STATE(7097),
    [sym__argument] = STATE(7098),
    [sym_splat_argument] = STATE(7098),
    [sym_hash_splat_argument] = STATE(7098),
    [sym_block_argument] = STATE(7098),
    [sym_assignment] = STATE(7096),
    [sym_operator_assignment] = STATE(7096),
    [sym_conditional] = STATE(7096),
    [sym_range] = STATE(7096),
    [sym_binary] = STATE(7096),
    [sym_unary] = STATE(7096),
    [sym_left_assignment_list] = STATE(2124),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2125),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2125),
    [sym_false] = STATE(2125),
    [sym_nil] = STATE(2125),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(7099),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(7098),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(10692),
    [sym__splat_star] = ACTIONS(10694),
    [sym__unary_minus] = ACTIONS(3705),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(10696),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(417),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_EQ] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3713),
    [anon_sym_break] = ACTIONS(3715),
    [anon_sym_next] = ACTIONS(3717),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(7693),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(3721),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_BANG] = ACTIONS(7362),
    [anon_sym_TILDE] = ACTIONS(3725),
    [sym_constant] = ACTIONS(10698),
    [sym_identifier] = ACTIONS(10698),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4489] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(7096),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2125),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2125),
    [sym_argument_list] = STATE(4766),
    [sym__argument_list_with_parens] = STATE(7097),
    [sym__argument] = STATE(7098),
    [sym_splat_argument] = STATE(7098),
    [sym_hash_splat_argument] = STATE(7098),
    [sym_block_argument] = STATE(7098),
    [sym_assignment] = STATE(7096),
    [sym_operator_assignment] = STATE(7096),
    [sym_conditional] = STATE(7096),
    [sym_range] = STATE(7096),
    [sym_binary] = STATE(7096),
    [sym_unary] = STATE(7096),
    [sym_left_assignment_list] = STATE(2124),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2125),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2125),
    [sym_false] = STATE(2125),
    [sym_nil] = STATE(2125),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(7099),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(7098),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(10692),
    [sym__splat_star] = ACTIONS(10694),
    [sym__unary_minus] = ACTIONS(3705),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(10696),
    [anon_sym_LBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(421),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_EQ] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3713),
    [anon_sym_break] = ACTIONS(3715),
    [anon_sym_next] = ACTIONS(3717),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(7693),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(3721),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_BANG] = ACTIONS(7362),
    [anon_sym_TILDE] = ACTIONS(3725),
    [sym_constant] = ACTIONS(10698),
    [sym_identifier] = ACTIONS(10698),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4490] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(7096),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2125),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2125),
    [sym_argument_list] = STATE(4767),
    [sym__argument_list_with_parens] = STATE(7097),
    [sym__argument] = STATE(7098),
    [sym_splat_argument] = STATE(7098),
    [sym_hash_splat_argument] = STATE(7098),
    [sym_block_argument] = STATE(7098),
    [sym_assignment] = STATE(7096),
    [sym_operator_assignment] = STATE(7096),
    [sym_conditional] = STATE(7096),
    [sym_range] = STATE(7096),
    [sym_binary] = STATE(7096),
    [sym_unary] = STATE(7096),
    [sym_left_assignment_list] = STATE(2124),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2125),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2125),
    [sym_false] = STATE(2125),
    [sym_nil] = STATE(2125),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(7099),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(7098),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(10692),
    [sym__splat_star] = ACTIONS(10694),
    [sym__unary_minus] = ACTIONS(3705),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(10696),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(425),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3713),
    [anon_sym_break] = ACTIONS(3715),
    [anon_sym_next] = ACTIONS(3717),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(7693),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(3721),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_BANG] = ACTIONS(7362),
    [anon_sym_TILDE] = ACTIONS(3725),
    [sym_constant] = ACTIONS(10698),
    [sym_identifier] = ACTIONS(10698),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4491] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7100),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4495),
    [sym_scope_resolution] = STATE(4433),
    [sym_call] = STATE(4433),
    [sym_method_call] = STATE(4495),
    [sym_assignment] = STATE(7100),
    [sym_operator_assignment] = STATE(7100),
    [sym_conditional] = STATE(7100),
    [sym_range] = STATE(7100),
    [sym_binary] = STATE(7100),
    [sym_unary] = STATE(7100),
    [sym_left_assignment_list] = STATE(4494),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4495),
    [sym__variable] = STATE(4433),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4495),
    [sym_false] = STATE(4495),
    [sym_nil] = STATE(4495),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(4496),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(4005),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(4009),
    [sym__subshell_start] = ACTIONS(4011),
    [sym__regex_start] = ACTIONS(4013),
    [sym__string_array_start] = ACTIONS(4015),
    [sym__symbol_array_start] = ACTIONS(4017),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7336),
    [anon_sym_LBRACE] = ACTIONS(4021),
    [anon_sym_def] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4025),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(4027),
    [anon_sym_module] = ACTIONS(4029),
    [anon_sym_return] = ACTIONS(7338),
    [anon_sym_yield] = ACTIONS(7340),
    [anon_sym_break] = ACTIONS(7342),
    [anon_sym_next] = ACTIONS(7344),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(4039),
    [anon_sym_unless] = ACTIONS(4041),
    [anon_sym_while] = ACTIONS(4043),
    [anon_sym_until] = ACTIONS(4045),
    [anon_sym_for] = ACTIONS(4047),
    [anon_sym_case] = ACTIONS(4049),
    [anon_sym_begin] = ACTIONS(4051),
    [anon_sym_PLUS] = ACTIONS(7346),
    [anon_sym_defined_QMARK] = ACTIONS(7348),
    [anon_sym_not] = ACTIONS(7350),
    [anon_sym_BANG] = ACTIONS(7352),
    [anon_sym_TILDE] = ACTIONS(7352),
    [sym_constant] = ACTIONS(7246),
    [sym_identifier] = ACTIONS(7246),
    [sym_instance_variable] = ACTIONS(7248),
    [sym_class_variable] = ACTIONS(7248),
    [sym_global_variable] = ACTIONS(7248),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4065),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(7246),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(7246),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(4067),
    [anon_sym_DASH_GT] = ACTIONS(4069),
  },
  [4492] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(4782),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4495),
    [sym_scope_resolution] = STATE(4433),
    [sym_call] = STATE(4433),
    [sym_method_call] = STATE(4495),
    [sym_assignment] = STATE(4782),
    [sym_operator_assignment] = STATE(4782),
    [sym_conditional] = STATE(4782),
    [sym_range] = STATE(4782),
    [sym_binary] = STATE(4782),
    [sym_unary] = STATE(4782),
    [sym_left_assignment_list] = STATE(4494),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4495),
    [sym__variable] = STATE(4433),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4495),
    [sym_false] = STATE(4495),
    [sym_nil] = STATE(4495),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(4496),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(4005),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(4009),
    [sym__subshell_start] = ACTIONS(4011),
    [sym__regex_start] = ACTIONS(4013),
    [sym__string_array_start] = ACTIONS(4015),
    [sym__symbol_array_start] = ACTIONS(4017),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7336),
    [anon_sym_LBRACE] = ACTIONS(4021),
    [anon_sym_def] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4025),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(4027),
    [anon_sym_module] = ACTIONS(4029),
    [anon_sym_return] = ACTIONS(7338),
    [anon_sym_yield] = ACTIONS(7340),
    [anon_sym_break] = ACTIONS(7342),
    [anon_sym_next] = ACTIONS(7344),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(4039),
    [anon_sym_unless] = ACTIONS(4041),
    [anon_sym_while] = ACTIONS(4043),
    [anon_sym_until] = ACTIONS(4045),
    [anon_sym_for] = ACTIONS(4047),
    [anon_sym_case] = ACTIONS(4049),
    [anon_sym_begin] = ACTIONS(4051),
    [anon_sym_PLUS] = ACTIONS(7346),
    [anon_sym_defined_QMARK] = ACTIONS(7348),
    [anon_sym_not] = ACTIONS(7350),
    [anon_sym_BANG] = ACTIONS(7352),
    [anon_sym_TILDE] = ACTIONS(7352),
    [sym_constant] = ACTIONS(7246),
    [sym_identifier] = ACTIONS(7246),
    [sym_instance_variable] = ACTIONS(7248),
    [sym_class_variable] = ACTIONS(7248),
    [sym_global_variable] = ACTIONS(7248),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4065),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(7246),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(7246),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(4067),
    [anon_sym_DASH_GT] = ACTIONS(4069),
  },
  [4493] = {
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(10700),
    [sym__binary_star] = ACTIONS(10702),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_RPAREN] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(10704),
    [anon_sym_STAR_STAR] = ACTIONS(10702),
    [anon_sym_AMP] = ACTIONS(10706),
    [anon_sym_EQ] = ACTIONS(4217),
    [anon_sym_LT] = ACTIONS(10708),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(10710),
    [anon_sym_DOT_DOT] = ACTIONS(10712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10714),
    [anon_sym_and] = ACTIONS(10716),
    [anon_sym_or] = ACTIONS(10716),
    [anon_sym_PIPE_PIPE] = ACTIONS(10718),
    [anon_sym_AMP_AMP] = ACTIONS(10718),
    [anon_sym_LT_LT] = ACTIONS(10720),
    [anon_sym_GT_GT] = ACTIONS(10720),
    [anon_sym_EQ_EQ] = ACTIONS(10722),
    [anon_sym_BANG_EQ] = ACTIONS(10718),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10718),
    [anon_sym_LT_EQ_GT] = ACTIONS(10718),
    [anon_sym_EQ_TILDE] = ACTIONS(10718),
    [anon_sym_BANG_TILDE] = ACTIONS(10718),
    [anon_sym_LT_EQ] = ACTIONS(10708),
    [anon_sym_GT] = ACTIONS(10708),
    [anon_sym_GT_EQ] = ACTIONS(10724),
    [anon_sym_CARET] = ACTIONS(10726),
    [anon_sym_PLUS] = ACTIONS(10700),
    [anon_sym_SLASH] = ACTIONS(10702),
    [anon_sym_PERCENT] = ACTIONS(10702),
    [sym_comment] = ACTIONS(87),
  },
  [4494] = {
    [anon_sym_EQ] = ACTIONS(10728),
    [sym_comment] = ACTIONS(87),
  },
  [4495] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(10730),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(10732),
    [anon_sym_DASH_EQ] = ACTIONS(10732),
    [anon_sym_STAR_EQ] = ACTIONS(10732),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10732),
    [anon_sym_SLASH_EQ] = ACTIONS(10732),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10732),
    [anon_sym_PIPE_EQ] = ACTIONS(10732),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10732),
    [anon_sym_AMP_EQ] = ACTIONS(10732),
    [anon_sym_PERCENT_EQ] = ACTIONS(10732),
    [anon_sym_GT_GT_EQ] = ACTIONS(10732),
    [anon_sym_LT_LT_EQ] = ACTIONS(10732),
    [anon_sym_CARET_EQ] = ACTIONS(10732),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [4496] = {
    [sym_string] = STATE(7113),
    [aux_sym_chained_string_repeat1] = STATE(7113),
    [sym__string_start] = ACTIONS(4007),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [4497] = {
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(10700),
    [sym__binary_star] = ACTIONS(10702),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_RPAREN] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(10704),
    [anon_sym_STAR_STAR] = ACTIONS(10702),
    [anon_sym_AMP] = ACTIONS(10706),
    [anon_sym_EQ] = ACTIONS(4249),
    [anon_sym_LT] = ACTIONS(10708),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(10710),
    [anon_sym_DOT_DOT] = ACTIONS(10712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10714),
    [anon_sym_and] = ACTIONS(10716),
    [anon_sym_or] = ACTIONS(10716),
    [anon_sym_PIPE_PIPE] = ACTIONS(10718),
    [anon_sym_AMP_AMP] = ACTIONS(10718),
    [anon_sym_LT_LT] = ACTIONS(10720),
    [anon_sym_GT_GT] = ACTIONS(10720),
    [anon_sym_EQ_EQ] = ACTIONS(10722),
    [anon_sym_BANG_EQ] = ACTIONS(10718),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10718),
    [anon_sym_LT_EQ_GT] = ACTIONS(10718),
    [anon_sym_EQ_TILDE] = ACTIONS(10718),
    [anon_sym_BANG_TILDE] = ACTIONS(10718),
    [anon_sym_LT_EQ] = ACTIONS(10708),
    [anon_sym_GT] = ACTIONS(10708),
    [anon_sym_GT_EQ] = ACTIONS(10724),
    [anon_sym_CARET] = ACTIONS(10726),
    [anon_sym_PLUS] = ACTIONS(10700),
    [anon_sym_SLASH] = ACTIONS(10702),
    [anon_sym_PERCENT] = ACTIONS(10702),
    [sym_comment] = ACTIONS(87),
  },
  [4498] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(7370),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [4499] = {
    [sym_string] = STATE(4528),
    [aux_sym_chained_string_repeat1] = STATE(4528),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [4500] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7114),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4495),
    [sym_scope_resolution] = STATE(4433),
    [sym_call] = STATE(4433),
    [sym_method_call] = STATE(4495),
    [sym_assignment] = STATE(7114),
    [sym_operator_assignment] = STATE(7114),
    [sym_conditional] = STATE(7114),
    [sym_range] = STATE(7114),
    [sym_binary] = STATE(7114),
    [sym_unary] = STATE(7114),
    [sym_left_assignment_list] = STATE(4494),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4495),
    [sym__variable] = STATE(4433),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4495),
    [sym_false] = STATE(4495),
    [sym_nil] = STATE(4495),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(4496),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(4005),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(4009),
    [sym__subshell_start] = ACTIONS(4011),
    [sym__regex_start] = ACTIONS(4013),
    [sym__string_array_start] = ACTIONS(4015),
    [sym__symbol_array_start] = ACTIONS(4017),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7336),
    [anon_sym_LBRACE] = ACTIONS(4021),
    [anon_sym_def] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4025),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(4027),
    [anon_sym_module] = ACTIONS(4029),
    [anon_sym_return] = ACTIONS(7338),
    [anon_sym_yield] = ACTIONS(7340),
    [anon_sym_break] = ACTIONS(7342),
    [anon_sym_next] = ACTIONS(7344),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(4039),
    [anon_sym_unless] = ACTIONS(4041),
    [anon_sym_while] = ACTIONS(4043),
    [anon_sym_until] = ACTIONS(4045),
    [anon_sym_for] = ACTIONS(4047),
    [anon_sym_case] = ACTIONS(4049),
    [anon_sym_begin] = ACTIONS(4051),
    [anon_sym_PLUS] = ACTIONS(7346),
    [anon_sym_defined_QMARK] = ACTIONS(7348),
    [anon_sym_not] = ACTIONS(7350),
    [anon_sym_BANG] = ACTIONS(7352),
    [anon_sym_TILDE] = ACTIONS(7352),
    [sym_constant] = ACTIONS(7246),
    [sym_identifier] = ACTIONS(7246),
    [sym_instance_variable] = ACTIONS(7248),
    [sym_class_variable] = ACTIONS(7248),
    [sym_global_variable] = ACTIONS(7248),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4065),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(7246),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(7246),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(4067),
    [anon_sym_DASH_GT] = ACTIONS(4069),
  },
  [4501] = {
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(10700),
    [sym__binary_star] = ACTIONS(10702),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_RPAREN] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(10704),
    [anon_sym_STAR_STAR] = ACTIONS(10702),
    [anon_sym_AMP] = ACTIONS(10706),
    [anon_sym_EQ] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(10708),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(10710),
    [anon_sym_DOT_DOT] = ACTIONS(10712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10714),
    [anon_sym_and] = ACTIONS(10716),
    [anon_sym_or] = ACTIONS(10716),
    [anon_sym_PIPE_PIPE] = ACTIONS(10718),
    [anon_sym_AMP_AMP] = ACTIONS(10718),
    [anon_sym_LT_LT] = ACTIONS(10720),
    [anon_sym_GT_GT] = ACTIONS(10720),
    [anon_sym_EQ_EQ] = ACTIONS(10722),
    [anon_sym_BANG_EQ] = ACTIONS(10718),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10718),
    [anon_sym_LT_EQ_GT] = ACTIONS(10718),
    [anon_sym_EQ_TILDE] = ACTIONS(10718),
    [anon_sym_BANG_TILDE] = ACTIONS(10718),
    [anon_sym_LT_EQ] = ACTIONS(10708),
    [anon_sym_GT] = ACTIONS(10708),
    [anon_sym_GT_EQ] = ACTIONS(10724),
    [anon_sym_CARET] = ACTIONS(10726),
    [anon_sym_PLUS] = ACTIONS(10700),
    [anon_sym_SLASH] = ACTIONS(10702),
    [anon_sym_PERCENT] = ACTIONS(10702),
    [sym_comment] = ACTIONS(87),
  },
  [4502] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(7115),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2125),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2125),
    [sym_assignment] = STATE(7115),
    [sym_operator_assignment] = STATE(7115),
    [sym_conditional] = STATE(7115),
    [sym_range] = STATE(7115),
    [sym_binary] = STATE(7115),
    [sym_unary] = STATE(7115),
    [sym_left_assignment_list] = STATE(2124),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2125),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2125),
    [sym_false] = STATE(2125),
    [sym_nil] = STATE(2125),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4499),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3705),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3713),
    [anon_sym_break] = ACTIONS(3715),
    [anon_sym_next] = ACTIONS(3717),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3719),
    [anon_sym_defined_QMARK] = ACTIONS(3721),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [sym_constant] = ACTIONS(3667),
    [sym_identifier] = ACTIONS(3667),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4503] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(7116),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2125),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2125),
    [sym_assignment] = STATE(7116),
    [sym_operator_assignment] = STATE(7116),
    [sym_conditional] = STATE(7116),
    [sym_range] = STATE(7116),
    [sym_binary] = STATE(7116),
    [sym_unary] = STATE(7116),
    [sym_left_assignment_list] = STATE(2124),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2125),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2125),
    [sym_false] = STATE(2125),
    [sym_nil] = STATE(2125),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4499),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3705),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3713),
    [anon_sym_break] = ACTIONS(3715),
    [anon_sym_next] = ACTIONS(3717),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3719),
    [anon_sym_defined_QMARK] = ACTIONS(3721),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [sym_constant] = ACTIONS(3667),
    [sym_identifier] = ACTIONS(3667),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4504] = {
    [anon_sym_COLON] = ACTIONS(10734),
    [sym_comment] = ACTIONS(87),
  },
  [4505] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(7118),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2125),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2125),
    [sym_assignment] = STATE(7118),
    [sym_operator_assignment] = STATE(7118),
    [sym_conditional] = STATE(7118),
    [sym_range] = STATE(7118),
    [sym_binary] = STATE(7118),
    [sym_unary] = STATE(7118),
    [sym_left_assignment_list] = STATE(2124),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2125),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2125),
    [sym_false] = STATE(2125),
    [sym_nil] = STATE(2125),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4499),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3705),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3713),
    [anon_sym_break] = ACTIONS(3715),
    [anon_sym_next] = ACTIONS(3717),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3719),
    [anon_sym_defined_QMARK] = ACTIONS(3721),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [sym_constant] = ACTIONS(3667),
    [sym_identifier] = ACTIONS(3667),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4506] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(10736),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [4507] = {
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(7368),
    [sym__binary_star] = ACTIONS(7370),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_RPAREN] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(7372),
    [anon_sym_STAR_STAR] = ACTIONS(7370),
    [anon_sym_AMP] = ACTIONS(7374),
    [anon_sym_EQ] = ACTIONS(1631),
    [anon_sym_LT] = ACTIONS(7376),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(1625),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(7378),
    [anon_sym_DOT_DOT] = ACTIONS(7380),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7382),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(7386),
    [anon_sym_AMP_AMP] = ACTIONS(7386),
    [anon_sym_LT_LT] = ACTIONS(7388),
    [anon_sym_GT_GT] = ACTIONS(7388),
    [anon_sym_EQ_EQ] = ACTIONS(7390),
    [anon_sym_BANG_EQ] = ACTIONS(7386),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7386),
    [anon_sym_LT_EQ_GT] = ACTIONS(7386),
    [anon_sym_EQ_TILDE] = ACTIONS(7386),
    [anon_sym_BANG_TILDE] = ACTIONS(7386),
    [anon_sym_LT_EQ] = ACTIONS(7376),
    [anon_sym_GT] = ACTIONS(7376),
    [anon_sym_GT_EQ] = ACTIONS(7392),
    [anon_sym_CARET] = ACTIONS(7394),
    [anon_sym_PLUS] = ACTIONS(7368),
    [anon_sym_SLASH] = ACTIONS(7370),
    [anon_sym_PERCENT] = ACTIONS(7370),
    [sym_comment] = ACTIONS(87),
  },
  [4508] = {
    [sym_heredoc_body] = STATE(7120),
    [aux_sym_call_repeat1] = STATE(7120),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [4509] = {
    [sym_heredoc_body] = STATE(7120),
    [aux_sym_call_repeat1] = STATE(7120),
    [aux_sym_argument_list_repeat1] = STATE(7122),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(10738),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [4510] = {
    [sym_string] = STATE(4528),
    [aux_sym_chained_string_repeat1] = STATE(4528),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(10740),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [4511] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(7368),
    [sym__binary_star] = ACTIONS(7370),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(7372),
    [anon_sym_STAR_STAR] = ACTIONS(7370),
    [anon_sym_AMP] = ACTIONS(7374),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(7376),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(7378),
    [anon_sym_DOT_DOT] = ACTIONS(7380),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7382),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(7386),
    [anon_sym_AMP_AMP] = ACTIONS(7386),
    [anon_sym_LT_LT] = ACTIONS(7388),
    [anon_sym_GT_GT] = ACTIONS(7388),
    [anon_sym_EQ_EQ] = ACTIONS(7390),
    [anon_sym_BANG_EQ] = ACTIONS(7386),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7386),
    [anon_sym_LT_EQ_GT] = ACTIONS(7386),
    [anon_sym_EQ_TILDE] = ACTIONS(7386),
    [anon_sym_BANG_TILDE] = ACTIONS(7386),
    [anon_sym_LT_EQ] = ACTIONS(7376),
    [anon_sym_GT] = ACTIONS(7376),
    [anon_sym_GT_EQ] = ACTIONS(7392),
    [anon_sym_CARET] = ACTIONS(7394),
    [anon_sym_PLUS] = ACTIONS(7368),
    [anon_sym_SLASH] = ACTIONS(7370),
    [anon_sym_PERCENT] = ACTIONS(7370),
    [sym_comment] = ACTIONS(87),
  },
  [4512] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7123),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4495),
    [sym_scope_resolution] = STATE(4433),
    [sym_call] = STATE(4433),
    [sym_method_call] = STATE(4495),
    [sym_assignment] = STATE(7123),
    [sym_operator_assignment] = STATE(7123),
    [sym_conditional] = STATE(7123),
    [sym_range] = STATE(7123),
    [sym_binary] = STATE(7123),
    [sym_unary] = STATE(7123),
    [sym_left_assignment_list] = STATE(4494),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4495),
    [sym__variable] = STATE(4433),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4495),
    [sym_false] = STATE(4495),
    [sym_nil] = STATE(4495),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(4496),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(4005),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(4009),
    [sym__subshell_start] = ACTIONS(4011),
    [sym__regex_start] = ACTIONS(4013),
    [sym__string_array_start] = ACTIONS(4015),
    [sym__symbol_array_start] = ACTIONS(4017),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7336),
    [anon_sym_LBRACE] = ACTIONS(4021),
    [anon_sym_def] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4025),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(4027),
    [anon_sym_module] = ACTIONS(4029),
    [anon_sym_return] = ACTIONS(7338),
    [anon_sym_yield] = ACTIONS(7340),
    [anon_sym_break] = ACTIONS(7342),
    [anon_sym_next] = ACTIONS(7344),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(4039),
    [anon_sym_unless] = ACTIONS(4041),
    [anon_sym_while] = ACTIONS(4043),
    [anon_sym_until] = ACTIONS(4045),
    [anon_sym_for] = ACTIONS(4047),
    [anon_sym_case] = ACTIONS(4049),
    [anon_sym_begin] = ACTIONS(4051),
    [anon_sym_PLUS] = ACTIONS(7346),
    [anon_sym_defined_QMARK] = ACTIONS(7348),
    [anon_sym_not] = ACTIONS(7350),
    [anon_sym_BANG] = ACTIONS(7352),
    [anon_sym_TILDE] = ACTIONS(7352),
    [sym_constant] = ACTIONS(7246),
    [sym_identifier] = ACTIONS(7246),
    [sym_instance_variable] = ACTIONS(7248),
    [sym_class_variable] = ACTIONS(7248),
    [sym_global_variable] = ACTIONS(7248),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4065),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(7246),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(7246),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(4067),
    [anon_sym_DASH_GT] = ACTIONS(4069),
  },
  [4513] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(7124),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2125),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2125),
    [sym_assignment] = STATE(7124),
    [sym_operator_assignment] = STATE(7124),
    [sym_conditional] = STATE(7124),
    [sym_range] = STATE(7124),
    [sym_binary] = STATE(7124),
    [sym_unary] = STATE(7124),
    [sym_left_assignment_list] = STATE(2124),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2125),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2125),
    [sym_false] = STATE(2125),
    [sym_nil] = STATE(2125),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4499),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3705),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3713),
    [anon_sym_break] = ACTIONS(3715),
    [anon_sym_next] = ACTIONS(3717),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3719),
    [anon_sym_defined_QMARK] = ACTIONS(3721),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [sym_constant] = ACTIONS(3667),
    [sym_identifier] = ACTIONS(3667),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4514] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(7125),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2125),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2125),
    [sym_assignment] = STATE(7125),
    [sym_operator_assignment] = STATE(7125),
    [sym_conditional] = STATE(7125),
    [sym_range] = STATE(7125),
    [sym_binary] = STATE(7125),
    [sym_unary] = STATE(7125),
    [sym_left_assignment_list] = STATE(2124),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2125),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2125),
    [sym_false] = STATE(2125),
    [sym_nil] = STATE(2125),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4499),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3705),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3713),
    [anon_sym_break] = ACTIONS(3715),
    [anon_sym_next] = ACTIONS(3717),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3719),
    [anon_sym_defined_QMARK] = ACTIONS(3721),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [sym_constant] = ACTIONS(3667),
    [sym_identifier] = ACTIONS(3667),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4515] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(7126),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2125),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2125),
    [sym_assignment] = STATE(7126),
    [sym_operator_assignment] = STATE(7126),
    [sym_conditional] = STATE(7126),
    [sym_range] = STATE(7126),
    [sym_binary] = STATE(7126),
    [sym_unary] = STATE(7126),
    [sym_left_assignment_list] = STATE(2124),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2125),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2125),
    [sym_false] = STATE(2125),
    [sym_nil] = STATE(2125),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4499),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3705),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3713),
    [anon_sym_break] = ACTIONS(3715),
    [anon_sym_next] = ACTIONS(3717),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3719),
    [anon_sym_defined_QMARK] = ACTIONS(3721),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [sym_constant] = ACTIONS(3667),
    [sym_identifier] = ACTIONS(3667),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4516] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(7127),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2125),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2125),
    [sym_assignment] = STATE(7127),
    [sym_operator_assignment] = STATE(7127),
    [sym_conditional] = STATE(7127),
    [sym_range] = STATE(7127),
    [sym_binary] = STATE(7127),
    [sym_unary] = STATE(7127),
    [sym_left_assignment_list] = STATE(2124),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2125),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2125),
    [sym_false] = STATE(2125),
    [sym_nil] = STATE(2125),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4499),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3705),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3713),
    [anon_sym_break] = ACTIONS(3715),
    [anon_sym_next] = ACTIONS(3717),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3719),
    [anon_sym_defined_QMARK] = ACTIONS(3721),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [sym_constant] = ACTIONS(3667),
    [sym_identifier] = ACTIONS(3667),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4517] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(7128),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2125),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2125),
    [sym_assignment] = STATE(7128),
    [sym_operator_assignment] = STATE(7128),
    [sym_conditional] = STATE(7128),
    [sym_range] = STATE(7128),
    [sym_binary] = STATE(7128),
    [sym_unary] = STATE(7128),
    [sym_left_assignment_list] = STATE(2124),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2125),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2125),
    [sym_false] = STATE(2125),
    [sym_nil] = STATE(2125),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4499),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3705),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3713),
    [anon_sym_break] = ACTIONS(3715),
    [anon_sym_next] = ACTIONS(3717),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3719),
    [anon_sym_defined_QMARK] = ACTIONS(3721),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [sym_constant] = ACTIONS(3667),
    [sym_identifier] = ACTIONS(3667),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4518] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(7129),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(7129),
    [sym_operator_assignment] = STATE(7129),
    [sym_conditional] = STATE(7129),
    [sym_range] = STATE(7129),
    [sym_binary] = STATE(7129),
    [sym_unary] = STATE(7129),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4519] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(7130),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2125),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2125),
    [sym_assignment] = STATE(7130),
    [sym_operator_assignment] = STATE(7130),
    [sym_conditional] = STATE(7130),
    [sym_range] = STATE(7130),
    [sym_binary] = STATE(7130),
    [sym_unary] = STATE(7130),
    [sym_left_assignment_list] = STATE(2124),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2125),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2125),
    [sym_false] = STATE(2125),
    [sym_nil] = STATE(2125),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4499),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3705),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3713),
    [anon_sym_break] = ACTIONS(3715),
    [anon_sym_next] = ACTIONS(3717),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3719),
    [anon_sym_defined_QMARK] = ACTIONS(3721),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [sym_constant] = ACTIONS(3667),
    [sym_identifier] = ACTIONS(3667),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4520] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(7131),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2125),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2125),
    [sym_assignment] = STATE(7131),
    [sym_operator_assignment] = STATE(7131),
    [sym_conditional] = STATE(7131),
    [sym_range] = STATE(7131),
    [sym_binary] = STATE(7131),
    [sym_unary] = STATE(7131),
    [sym_left_assignment_list] = STATE(2124),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2125),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2125),
    [sym_false] = STATE(2125),
    [sym_nil] = STATE(2125),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4499),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3705),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3713),
    [anon_sym_break] = ACTIONS(3715),
    [anon_sym_next] = ACTIONS(3717),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3719),
    [anon_sym_defined_QMARK] = ACTIONS(3721),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [sym_constant] = ACTIONS(3667),
    [sym_identifier] = ACTIONS(3667),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4521] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(7132),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2125),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2125),
    [sym_assignment] = STATE(7132),
    [sym_operator_assignment] = STATE(7132),
    [sym_conditional] = STATE(7132),
    [sym_range] = STATE(7132),
    [sym_binary] = STATE(7132),
    [sym_unary] = STATE(7132),
    [sym_left_assignment_list] = STATE(2124),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2125),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2125),
    [sym_false] = STATE(2125),
    [sym_nil] = STATE(2125),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4499),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3705),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3713),
    [anon_sym_break] = ACTIONS(3715),
    [anon_sym_next] = ACTIONS(3717),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3719),
    [anon_sym_defined_QMARK] = ACTIONS(3721),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [sym_constant] = ACTIONS(3667),
    [sym_identifier] = ACTIONS(3667),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4522] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(7133),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2125),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2125),
    [sym_assignment] = STATE(7133),
    [sym_operator_assignment] = STATE(7133),
    [sym_conditional] = STATE(7133),
    [sym_range] = STATE(7133),
    [sym_binary] = STATE(7133),
    [sym_unary] = STATE(7133),
    [sym_left_assignment_list] = STATE(2124),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2125),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2125),
    [sym_false] = STATE(2125),
    [sym_nil] = STATE(2125),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4499),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3705),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3713),
    [anon_sym_break] = ACTIONS(3715),
    [anon_sym_next] = ACTIONS(3717),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3719),
    [anon_sym_defined_QMARK] = ACTIONS(3721),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [sym_constant] = ACTIONS(3667),
    [sym_identifier] = ACTIONS(3667),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4523] = {
    [sym_heredoc_body] = STATE(7134),
    [aux_sym_call_repeat1] = STATE(7134),
    [sym__heredoc_body_start] = ACTIONS(3959),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_RPAREN] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4383),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_EQ] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [4524] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(2121),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2125),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2125),
    [sym__argument] = STATE(3454),
    [sym_splat_argument] = STATE(3454),
    [sym_hash_splat_argument] = STATE(3454),
    [sym_block_argument] = STATE(3454),
    [sym_assignment] = STATE(2121),
    [sym_operator_assignment] = STATE(2121),
    [sym_conditional] = STATE(2121),
    [sym_range] = STATE(2121),
    [sym_binary] = STATE(2121),
    [sym_unary] = STATE(2121),
    [sym_left_assignment_list] = STATE(2124),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2125),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2125),
    [sym_false] = STATE(2125),
    [sym_nil] = STATE(2125),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2126),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_heredoc_body] = STATE(7135),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(3454),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(3701),
    [sym__splat_star] = ACTIONS(3703),
    [sym__unary_minus] = ACTIONS(3705),
    [sym__identifier_hash_key] = ACTIONS(3707),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(3709),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3713),
    [anon_sym_break] = ACTIONS(3715),
    [anon_sym_next] = ACTIONS(3717),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3719),
    [anon_sym_defined_QMARK] = ACTIONS(3721),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [sym_constant] = ACTIONS(3727),
    [sym_identifier] = ACTIONS(3727),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4525] = {
    [sym_heredoc_body] = STATE(7136),
    [aux_sym_call_repeat1] = STATE(7136),
    [aux_sym_argument_list_repeat1] = STATE(7137),
    [sym__heredoc_body_start] = ACTIONS(3959),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_RPAREN] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4383),
    [anon_sym_COMMA] = ACTIONS(7396),
    [anon_sym_EQ] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [4526] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(7138),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2125),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2125),
    [sym_splat_argument] = STATE(7139),
    [sym_assignment] = STATE(7138),
    [sym_operator_assignment] = STATE(7138),
    [sym_conditional] = STATE(7138),
    [sym_range] = STATE(7138),
    [sym_binary] = STATE(7138),
    [sym_unary] = STATE(7138),
    [sym_right_assignment_list] = STATE(4255),
    [sym__arg_or_splat_arg] = STATE(7139),
    [sym_left_assignment_list] = STATE(2124),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2125),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2125),
    [sym_false] = STATE(2125),
    [sym_nil] = STATE(2125),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4499),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(7358),
    [sym__unary_minus] = ACTIONS(3705),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3713),
    [anon_sym_break] = ACTIONS(3715),
    [anon_sym_next] = ACTIONS(3717),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3719),
    [anon_sym_defined_QMARK] = ACTIONS(3721),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [sym_constant] = ACTIONS(3667),
    [sym_identifier] = ACTIONS(3667),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4527] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(7140),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2125),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2125),
    [sym_assignment] = STATE(7140),
    [sym_operator_assignment] = STATE(7140),
    [sym_conditional] = STATE(7140),
    [sym_range] = STATE(7140),
    [sym_binary] = STATE(7140),
    [sym_unary] = STATE(7140),
    [sym_left_assignment_list] = STATE(2124),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2125),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2125),
    [sym_false] = STATE(2125),
    [sym_nil] = STATE(2125),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4499),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3705),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3713),
    [anon_sym_break] = ACTIONS(3715),
    [anon_sym_next] = ACTIONS(3717),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3719),
    [anon_sym_defined_QMARK] = ACTIONS(3721),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [sym_constant] = ACTIONS(3667),
    [sym_identifier] = ACTIONS(3667),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4528] = {
    [sym_string] = STATE(7141),
    [aux_sym_chained_string_repeat1] = STATE(7141),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_RPAREN] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_EQ] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_EQ_GT] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [4529] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(7408),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [4530] = {
    [sym_heredoc_body] = STATE(7142),
    [aux_sym_call_repeat1] = STATE(7142),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [4531] = {
    [sym_heredoc_body] = STATE(7142),
    [aux_sym_call_repeat1] = STATE(7142),
    [aux_sym_argument_list_repeat1] = STATE(7143),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(3795),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [4532] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(7406),
    [sym__binary_star] = ACTIONS(7408),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(7410),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(7408),
    [anon_sym_AMP] = ACTIONS(7412),
    [anon_sym_LT] = ACTIONS(7414),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(7416),
    [anon_sym_DOT_DOT] = ACTIONS(7418),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7420),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(7422),
    [anon_sym_AMP_AMP] = ACTIONS(7422),
    [anon_sym_LT_LT] = ACTIONS(7424),
    [anon_sym_GT_GT] = ACTIONS(7424),
    [anon_sym_EQ_EQ] = ACTIONS(7426),
    [anon_sym_BANG_EQ] = ACTIONS(7422),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7422),
    [anon_sym_LT_EQ_GT] = ACTIONS(7422),
    [anon_sym_EQ_TILDE] = ACTIONS(7422),
    [anon_sym_BANG_TILDE] = ACTIONS(7422),
    [anon_sym_LT_EQ] = ACTIONS(7414),
    [anon_sym_GT] = ACTIONS(7414),
    [anon_sym_GT_EQ] = ACTIONS(7428),
    [anon_sym_CARET] = ACTIONS(7430),
    [anon_sym_PLUS] = ACTIONS(7406),
    [anon_sym_SLASH] = ACTIONS(7408),
    [anon_sym_PERCENT] = ACTIONS(7408),
    [sym_comment] = ACTIONS(87),
  },
  [4533] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7144),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2136),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(2136),
    [sym_assignment] = STATE(7144),
    [sym_operator_assignment] = STATE(7144),
    [sym_conditional] = STATE(7144),
    [sym_range] = STATE(7144),
    [sym_binary] = STATE(7144),
    [sym_unary] = STATE(7144),
    [sym_left_assignment_list] = STATE(2135),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2136),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2136),
    [sym_false] = STATE(2136),
    [sym_nil] = STATE(2136),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2137),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3729),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3731),
    [anon_sym_yield] = ACTIONS(3733),
    [anon_sym_break] = ACTIONS(3735),
    [anon_sym_next] = ACTIONS(3737),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3739),
    [anon_sym_defined_QMARK] = ACTIONS(3741),
    [anon_sym_not] = ACTIONS(3743),
    [anon_sym_BANG] = ACTIONS(3745),
    [anon_sym_TILDE] = ACTIONS(3745),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4534] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7145),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2136),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(2136),
    [sym_assignment] = STATE(7145),
    [sym_operator_assignment] = STATE(7145),
    [sym_conditional] = STATE(7145),
    [sym_range] = STATE(7145),
    [sym_binary] = STATE(7145),
    [sym_unary] = STATE(7145),
    [sym_left_assignment_list] = STATE(2135),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2136),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2136),
    [sym_false] = STATE(2136),
    [sym_nil] = STATE(2136),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2137),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3729),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3731),
    [anon_sym_yield] = ACTIONS(3733),
    [anon_sym_break] = ACTIONS(3735),
    [anon_sym_next] = ACTIONS(3737),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3739),
    [anon_sym_defined_QMARK] = ACTIONS(3741),
    [anon_sym_not] = ACTIONS(3743),
    [anon_sym_BANG] = ACTIONS(3745),
    [anon_sym_TILDE] = ACTIONS(3745),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4535] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7146),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2136),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(2136),
    [sym_assignment] = STATE(7146),
    [sym_operator_assignment] = STATE(7146),
    [sym_conditional] = STATE(7146),
    [sym_range] = STATE(7146),
    [sym_binary] = STATE(7146),
    [sym_unary] = STATE(7146),
    [sym_left_assignment_list] = STATE(2135),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2136),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2136),
    [sym_false] = STATE(2136),
    [sym_nil] = STATE(2136),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2137),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3729),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3731),
    [anon_sym_yield] = ACTIONS(3733),
    [anon_sym_break] = ACTIONS(3735),
    [anon_sym_next] = ACTIONS(3737),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3739),
    [anon_sym_defined_QMARK] = ACTIONS(3741),
    [anon_sym_not] = ACTIONS(3743),
    [anon_sym_BANG] = ACTIONS(3745),
    [anon_sym_TILDE] = ACTIONS(3745),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4536] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7147),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2136),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(2136),
    [sym_assignment] = STATE(7147),
    [sym_operator_assignment] = STATE(7147),
    [sym_conditional] = STATE(7147),
    [sym_range] = STATE(7147),
    [sym_binary] = STATE(7147),
    [sym_unary] = STATE(7147),
    [sym_left_assignment_list] = STATE(2135),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2136),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2136),
    [sym_false] = STATE(2136),
    [sym_nil] = STATE(2136),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2137),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3729),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3731),
    [anon_sym_yield] = ACTIONS(3733),
    [anon_sym_break] = ACTIONS(3735),
    [anon_sym_next] = ACTIONS(3737),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3739),
    [anon_sym_defined_QMARK] = ACTIONS(3741),
    [anon_sym_not] = ACTIONS(3743),
    [anon_sym_BANG] = ACTIONS(3745),
    [anon_sym_TILDE] = ACTIONS(3745),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4537] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7148),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2136),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(2136),
    [sym_assignment] = STATE(7148),
    [sym_operator_assignment] = STATE(7148),
    [sym_conditional] = STATE(7148),
    [sym_range] = STATE(7148),
    [sym_binary] = STATE(7148),
    [sym_unary] = STATE(7148),
    [sym_left_assignment_list] = STATE(2135),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2136),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2136),
    [sym_false] = STATE(2136),
    [sym_nil] = STATE(2136),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2137),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3729),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3731),
    [anon_sym_yield] = ACTIONS(3733),
    [anon_sym_break] = ACTIONS(3735),
    [anon_sym_next] = ACTIONS(3737),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3739),
    [anon_sym_defined_QMARK] = ACTIONS(3741),
    [anon_sym_not] = ACTIONS(3743),
    [anon_sym_BANG] = ACTIONS(3745),
    [anon_sym_TILDE] = ACTIONS(3745),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4538] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(7149),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(7149),
    [sym_operator_assignment] = STATE(7149),
    [sym_conditional] = STATE(7149),
    [sym_range] = STATE(7149),
    [sym_binary] = STATE(7149),
    [sym_unary] = STATE(7149),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4539] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7150),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2136),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(2136),
    [sym_assignment] = STATE(7150),
    [sym_operator_assignment] = STATE(7150),
    [sym_conditional] = STATE(7150),
    [sym_range] = STATE(7150),
    [sym_binary] = STATE(7150),
    [sym_unary] = STATE(7150),
    [sym_left_assignment_list] = STATE(2135),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2136),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2136),
    [sym_false] = STATE(2136),
    [sym_nil] = STATE(2136),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2137),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3729),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3731),
    [anon_sym_yield] = ACTIONS(3733),
    [anon_sym_break] = ACTIONS(3735),
    [anon_sym_next] = ACTIONS(3737),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3739),
    [anon_sym_defined_QMARK] = ACTIONS(3741),
    [anon_sym_not] = ACTIONS(3743),
    [anon_sym_BANG] = ACTIONS(3745),
    [anon_sym_TILDE] = ACTIONS(3745),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4540] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7151),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2136),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(2136),
    [sym_assignment] = STATE(7151),
    [sym_operator_assignment] = STATE(7151),
    [sym_conditional] = STATE(7151),
    [sym_range] = STATE(7151),
    [sym_binary] = STATE(7151),
    [sym_unary] = STATE(7151),
    [sym_left_assignment_list] = STATE(2135),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2136),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2136),
    [sym_false] = STATE(2136),
    [sym_nil] = STATE(2136),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2137),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3729),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3731),
    [anon_sym_yield] = ACTIONS(3733),
    [anon_sym_break] = ACTIONS(3735),
    [anon_sym_next] = ACTIONS(3737),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3739),
    [anon_sym_defined_QMARK] = ACTIONS(3741),
    [anon_sym_not] = ACTIONS(3743),
    [anon_sym_BANG] = ACTIONS(3745),
    [anon_sym_TILDE] = ACTIONS(3745),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4541] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7152),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2136),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(2136),
    [sym_assignment] = STATE(7152),
    [sym_operator_assignment] = STATE(7152),
    [sym_conditional] = STATE(7152),
    [sym_range] = STATE(7152),
    [sym_binary] = STATE(7152),
    [sym_unary] = STATE(7152),
    [sym_left_assignment_list] = STATE(2135),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2136),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2136),
    [sym_false] = STATE(2136),
    [sym_nil] = STATE(2136),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2137),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3729),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3731),
    [anon_sym_yield] = ACTIONS(3733),
    [anon_sym_break] = ACTIONS(3735),
    [anon_sym_next] = ACTIONS(3737),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3739),
    [anon_sym_defined_QMARK] = ACTIONS(3741),
    [anon_sym_not] = ACTIONS(3743),
    [anon_sym_BANG] = ACTIONS(3745),
    [anon_sym_TILDE] = ACTIONS(3745),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4542] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7153),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2136),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(2136),
    [sym_assignment] = STATE(7153),
    [sym_operator_assignment] = STATE(7153),
    [sym_conditional] = STATE(7153),
    [sym_range] = STATE(7153),
    [sym_binary] = STATE(7153),
    [sym_unary] = STATE(7153),
    [sym_left_assignment_list] = STATE(2135),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2136),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2136),
    [sym_false] = STATE(2136),
    [sym_nil] = STATE(2136),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2137),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3729),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3731),
    [anon_sym_yield] = ACTIONS(3733),
    [anon_sym_break] = ACTIONS(3735),
    [anon_sym_next] = ACTIONS(3737),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3739),
    [anon_sym_defined_QMARK] = ACTIONS(3741),
    [anon_sym_not] = ACTIONS(3743),
    [anon_sym_BANG] = ACTIONS(3745),
    [anon_sym_TILDE] = ACTIONS(3745),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4543] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7154),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2136),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(2136),
    [sym_splat_argument] = STATE(7155),
    [sym_assignment] = STATE(7154),
    [sym_operator_assignment] = STATE(7154),
    [sym_conditional] = STATE(7154),
    [sym_range] = STATE(7154),
    [sym_binary] = STATE(7154),
    [sym_unary] = STATE(7154),
    [sym_right_assignment_list] = STATE(2570),
    [sym__arg_or_splat_arg] = STATE(7155),
    [sym_left_assignment_list] = STATE(2135),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2136),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2136),
    [sym_false] = STATE(2136),
    [sym_nil] = STATE(2136),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2137),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(1301),
    [sym__unary_minus] = ACTIONS(3729),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3731),
    [anon_sym_yield] = ACTIONS(3733),
    [anon_sym_break] = ACTIONS(3735),
    [anon_sym_next] = ACTIONS(3737),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3739),
    [anon_sym_defined_QMARK] = ACTIONS(3741),
    [anon_sym_not] = ACTIONS(3743),
    [anon_sym_BANG] = ACTIONS(3745),
    [anon_sym_TILDE] = ACTIONS(3745),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4544] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7156),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2136),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(2136),
    [sym_assignment] = STATE(7156),
    [sym_operator_assignment] = STATE(7156),
    [sym_conditional] = STATE(7156),
    [sym_range] = STATE(7156),
    [sym_binary] = STATE(7156),
    [sym_unary] = STATE(7156),
    [sym_left_assignment_list] = STATE(2135),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2136),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2136),
    [sym_false] = STATE(2136),
    [sym_nil] = STATE(2136),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2137),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3729),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3731),
    [anon_sym_yield] = ACTIONS(3733),
    [anon_sym_break] = ACTIONS(3735),
    [anon_sym_next] = ACTIONS(3737),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3739),
    [anon_sym_defined_QMARK] = ACTIONS(3741),
    [anon_sym_not] = ACTIONS(3743),
    [anon_sym_BANG] = ACTIONS(3745),
    [anon_sym_TILDE] = ACTIONS(3745),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4545] = {
    [sym_string] = STATE(7157),
    [aux_sym_chained_string_repeat1] = STATE(7157),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_RPAREN] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [4546] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(7406),
    [sym__binary_star] = ACTIONS(7408),
    [anon_sym_RPAREN] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(7410),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(7408),
    [anon_sym_AMP] = ACTIONS(7412),
    [anon_sym_LT] = ACTIONS(7414),
    [anon_sym_if] = ACTIONS(6823),
    [anon_sym_unless] = ACTIONS(6823),
    [anon_sym_while] = ACTIONS(6823),
    [anon_sym_until] = ACTIONS(6823),
    [anon_sym_rescue] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(7416),
    [anon_sym_DOT_DOT] = ACTIONS(7418),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7420),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(7422),
    [anon_sym_AMP_AMP] = ACTIONS(7422),
    [anon_sym_LT_LT] = ACTIONS(7424),
    [anon_sym_GT_GT] = ACTIONS(7424),
    [anon_sym_EQ_EQ] = ACTIONS(7426),
    [anon_sym_BANG_EQ] = ACTIONS(7422),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7422),
    [anon_sym_LT_EQ_GT] = ACTIONS(7422),
    [anon_sym_EQ_TILDE] = ACTIONS(7422),
    [anon_sym_BANG_TILDE] = ACTIONS(7422),
    [anon_sym_LT_EQ] = ACTIONS(7414),
    [anon_sym_GT] = ACTIONS(7414),
    [anon_sym_GT_EQ] = ACTIONS(7428),
    [anon_sym_CARET] = ACTIONS(7430),
    [anon_sym_PLUS] = ACTIONS(7406),
    [anon_sym_SLASH] = ACTIONS(7408),
    [anon_sym_PERCENT] = ACTIONS(7408),
    [sym_comment] = ACTIONS(87),
  },
  [4547] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(3761),
    [sym__binary_star] = ACTIONS(3763),
    [anon_sym_RPAREN] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(3765),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(3763),
    [anon_sym_AMP] = ACTIONS(3767),
    [anon_sym_LT] = ACTIONS(3769),
    [anon_sym_if] = ACTIONS(4211),
    [anon_sym_unless] = ACTIONS(4211),
    [anon_sym_while] = ACTIONS(4211),
    [anon_sym_until] = ACTIONS(4211),
    [anon_sym_rescue] = ACTIONS(4211),
    [anon_sym_EQ_GT] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(3771),
    [anon_sym_DOT_DOT] = ACTIONS(3773),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3775),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(3777),
    [anon_sym_AMP_AMP] = ACTIONS(3777),
    [anon_sym_LT_LT] = ACTIONS(3779),
    [anon_sym_GT_GT] = ACTIONS(3779),
    [anon_sym_EQ_EQ] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3777),
    [anon_sym_LT_EQ_GT] = ACTIONS(3777),
    [anon_sym_EQ_TILDE] = ACTIONS(3777),
    [anon_sym_BANG_TILDE] = ACTIONS(3777),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3783),
    [anon_sym_CARET] = ACTIONS(3785),
    [anon_sym_PLUS] = ACTIONS(3761),
    [anon_sym_SLASH] = ACTIONS(3763),
    [anon_sym_PERCENT] = ACTIONS(3763),
    [sym_comment] = ACTIONS(87),
  },
  [4548] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(3761),
    [sym__binary_star] = ACTIONS(3763),
    [anon_sym_RPAREN] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(3765),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(3763),
    [anon_sym_AMP] = ACTIONS(3767),
    [anon_sym_LT] = ACTIONS(3769),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_EQ_GT] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(3771),
    [anon_sym_DOT_DOT] = ACTIONS(3773),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3775),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(3777),
    [anon_sym_AMP_AMP] = ACTIONS(3777),
    [anon_sym_LT_LT] = ACTIONS(3779),
    [anon_sym_GT_GT] = ACTIONS(3779),
    [anon_sym_EQ_EQ] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3777),
    [anon_sym_LT_EQ_GT] = ACTIONS(3777),
    [anon_sym_EQ_TILDE] = ACTIONS(3777),
    [anon_sym_BANG_TILDE] = ACTIONS(3777),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3783),
    [anon_sym_CARET] = ACTIONS(3785),
    [anon_sym_PLUS] = ACTIONS(3761),
    [anon_sym_SLASH] = ACTIONS(3763),
    [anon_sym_PERCENT] = ACTIONS(3763),
    [sym_comment] = ACTIONS(87),
  },
  [4549] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7158),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(705),
    [sym_scope_resolution] = STATE(701),
    [sym_call] = STATE(701),
    [sym_method_call] = STATE(705),
    [sym_assignment] = STATE(7158),
    [sym_operator_assignment] = STATE(7158),
    [sym_conditional] = STATE(7158),
    [sym_range] = STATE(7158),
    [sym_binary] = STATE(7158),
    [sym_unary] = STATE(7158),
    [sym_left_assignment_list] = STATE(704),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(705),
    [sym__variable] = STATE(701),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(705),
    [sym_false] = STATE(705),
    [sym_nil] = STATE(705),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2140),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3747),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4550] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(3761),
    [sym__binary_star] = ACTIONS(3763),
    [anon_sym_RPAREN] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(3765),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(3763),
    [anon_sym_AMP] = ACTIONS(3767),
    [anon_sym_LT] = ACTIONS(3769),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_unless] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_until] = ACTIONS(3281),
    [anon_sym_rescue] = ACTIONS(3281),
    [anon_sym_EQ_GT] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3771),
    [anon_sym_DOT_DOT] = ACTIONS(3773),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3775),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(3777),
    [anon_sym_AMP_AMP] = ACTIONS(3777),
    [anon_sym_LT_LT] = ACTIONS(3779),
    [anon_sym_GT_GT] = ACTIONS(3779),
    [anon_sym_EQ_EQ] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3777),
    [anon_sym_LT_EQ_GT] = ACTIONS(3777),
    [anon_sym_EQ_TILDE] = ACTIONS(3777),
    [anon_sym_BANG_TILDE] = ACTIONS(3777),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3783),
    [anon_sym_CARET] = ACTIONS(3785),
    [anon_sym_PLUS] = ACTIONS(3761),
    [anon_sym_SLASH] = ACTIONS(3763),
    [anon_sym_PERCENT] = ACTIONS(3763),
    [sym_comment] = ACTIONS(87),
  },
  [4551] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7159),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(705),
    [sym_scope_resolution] = STATE(701),
    [sym_call] = STATE(701),
    [sym_method_call] = STATE(705),
    [sym_assignment] = STATE(7159),
    [sym_operator_assignment] = STATE(7159),
    [sym_conditional] = STATE(7159),
    [sym_range] = STATE(7159),
    [sym_binary] = STATE(7159),
    [sym_unary] = STATE(7159),
    [sym_left_assignment_list] = STATE(704),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(705),
    [sym__variable] = STATE(701),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(705),
    [sym_false] = STATE(705),
    [sym_nil] = STATE(705),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2140),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3747),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4552] = {
    [sym_heredoc_body] = STATE(7160),
    [aux_sym_call_repeat1] = STATE(7160),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_RPAREN] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [4553] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2148),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(705),
    [sym_scope_resolution] = STATE(701),
    [sym_call] = STATE(701),
    [sym_method_call] = STATE(705),
    [sym__argument] = STATE(2565),
    [sym_splat_argument] = STATE(2565),
    [sym_hash_splat_argument] = STATE(2565),
    [sym_block_argument] = STATE(2565),
    [sym_assignment] = STATE(2148),
    [sym_operator_assignment] = STATE(2148),
    [sym_conditional] = STATE(2148),
    [sym_range] = STATE(2148),
    [sym_binary] = STATE(2148),
    [sym_unary] = STATE(2148),
    [sym_left_assignment_list] = STATE(704),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(705),
    [sym__variable] = STATE(701),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(705),
    [sym_false] = STATE(705),
    [sym_nil] = STATE(705),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2151),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(7161),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2565),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(3751),
    [sym__splat_star] = ACTIONS(3753),
    [sym__unary_minus] = ACTIONS(1303),
    [sym__identifier_hash_key] = ACTIONS(3755),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10742),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3747),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(3757),
    [sym_identifier] = ACTIONS(3757),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4554] = {
    [sym_heredoc_body] = STATE(7162),
    [aux_sym_call_repeat1] = STATE(7162),
    [aux_sym_argument_list_repeat1] = STATE(7163),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_RPAREN] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(7442),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [4555] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(7406),
    [sym__binary_star] = ACTIONS(7408),
    [anon_sym_RPAREN] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(7410),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(7408),
    [anon_sym_AMP] = ACTIONS(7412),
    [anon_sym_LT] = ACTIONS(7414),
    [anon_sym_if] = ACTIONS(7027),
    [anon_sym_unless] = ACTIONS(7027),
    [anon_sym_while] = ACTIONS(7027),
    [anon_sym_until] = ACTIONS(7027),
    [anon_sym_rescue] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(7416),
    [anon_sym_DOT_DOT] = ACTIONS(7418),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7420),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(7422),
    [anon_sym_AMP_AMP] = ACTIONS(7422),
    [anon_sym_LT_LT] = ACTIONS(7424),
    [anon_sym_GT_GT] = ACTIONS(7424),
    [anon_sym_EQ_EQ] = ACTIONS(7426),
    [anon_sym_BANG_EQ] = ACTIONS(7422),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7422),
    [anon_sym_LT_EQ_GT] = ACTIONS(7422),
    [anon_sym_EQ_TILDE] = ACTIONS(7422),
    [anon_sym_BANG_TILDE] = ACTIONS(7422),
    [anon_sym_LT_EQ] = ACTIONS(7414),
    [anon_sym_GT] = ACTIONS(7414),
    [anon_sym_GT_EQ] = ACTIONS(7428),
    [anon_sym_CARET] = ACTIONS(7430),
    [anon_sym_PLUS] = ACTIONS(7406),
    [anon_sym_SLASH] = ACTIONS(7408),
    [anon_sym_PERCENT] = ACTIONS(7408),
    [sym_comment] = ACTIONS(87),
  },
  [4556] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(3763),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(3763),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(3763),
    [anon_sym_PERCENT] = ACTIONS(3763),
    [sym_comment] = ACTIONS(87),
  },
  [4557] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(3763),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [4558] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(3761),
    [sym__binary_star] = ACTIONS(3763),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(3763),
    [anon_sym_AMP] = ACTIONS(3767),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(3779),
    [anon_sym_GT_GT] = ACTIONS(3779),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(3761),
    [anon_sym_SLASH] = ACTIONS(3763),
    [anon_sym_PERCENT] = ACTIONS(3763),
    [sym_comment] = ACTIONS(87),
  },
  [4559] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(3761),
    [sym__binary_star] = ACTIONS(3763),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(3763),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(3779),
    [anon_sym_GT_GT] = ACTIONS(3779),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(3761),
    [anon_sym_SLASH] = ACTIONS(3763),
    [anon_sym_PERCENT] = ACTIONS(3763),
    [sym_comment] = ACTIONS(87),
  },
  [4560] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(3761),
    [sym__binary_star] = ACTIONS(3763),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(3765),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(3763),
    [anon_sym_AMP] = ACTIONS(3767),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(3779),
    [anon_sym_GT_GT] = ACTIONS(3779),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(3785),
    [anon_sym_PLUS] = ACTIONS(3761),
    [anon_sym_SLASH] = ACTIONS(3763),
    [anon_sym_PERCENT] = ACTIONS(3763),
    [sym_comment] = ACTIONS(87),
  },
  [4561] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(10744),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [4562] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(3761),
    [sym__binary_star] = ACTIONS(3763),
    [anon_sym_RPAREN] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(3765),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(3763),
    [anon_sym_AMP] = ACTIONS(3767),
    [anon_sym_LT] = ACTIONS(3769),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_EQ_GT] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(3773),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3775),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3777),
    [anon_sym_AMP_AMP] = ACTIONS(3777),
    [anon_sym_LT_LT] = ACTIONS(3779),
    [anon_sym_GT_GT] = ACTIONS(3779),
    [anon_sym_EQ_EQ] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3777),
    [anon_sym_LT_EQ_GT] = ACTIONS(3777),
    [anon_sym_EQ_TILDE] = ACTIONS(3777),
    [anon_sym_BANG_TILDE] = ACTIONS(3777),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3783),
    [anon_sym_CARET] = ACTIONS(3785),
    [anon_sym_PLUS] = ACTIONS(3761),
    [anon_sym_SLASH] = ACTIONS(3763),
    [anon_sym_PERCENT] = ACTIONS(3763),
    [sym_comment] = ACTIONS(87),
  },
  [4563] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(3761),
    [sym__binary_star] = ACTIONS(3763),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(3765),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(3763),
    [anon_sym_AMP] = ACTIONS(3767),
    [anon_sym_LT] = ACTIONS(3769),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(3771),
    [anon_sym_DOT_DOT] = ACTIONS(3773),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3775),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(3777),
    [anon_sym_AMP_AMP] = ACTIONS(3777),
    [anon_sym_LT_LT] = ACTIONS(3779),
    [anon_sym_GT_GT] = ACTIONS(3779),
    [anon_sym_EQ_EQ] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3777),
    [anon_sym_LT_EQ_GT] = ACTIONS(3777),
    [anon_sym_EQ_TILDE] = ACTIONS(3777),
    [anon_sym_BANG_TILDE] = ACTIONS(3777),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3783),
    [anon_sym_CARET] = ACTIONS(3785),
    [anon_sym_PLUS] = ACTIONS(3761),
    [anon_sym_SLASH] = ACTIONS(3763),
    [anon_sym_PERCENT] = ACTIONS(3763),
    [sym_comment] = ACTIONS(87),
  },
  [4564] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(3761),
    [sym__binary_star] = ACTIONS(3763),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(3765),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(3763),
    [anon_sym_AMP] = ACTIONS(3767),
    [anon_sym_LT] = ACTIONS(3769),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(3779),
    [anon_sym_GT_GT] = ACTIONS(3779),
    [anon_sym_EQ_EQ] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3777),
    [anon_sym_LT_EQ_GT] = ACTIONS(3777),
    [anon_sym_EQ_TILDE] = ACTIONS(3777),
    [anon_sym_BANG_TILDE] = ACTIONS(3777),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3783),
    [anon_sym_CARET] = ACTIONS(3785),
    [anon_sym_PLUS] = ACTIONS(3761),
    [anon_sym_SLASH] = ACTIONS(3763),
    [anon_sym_PERCENT] = ACTIONS(3763),
    [sym_comment] = ACTIONS(87),
  },
  [4565] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(3761),
    [sym__binary_star] = ACTIONS(3763),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(3763),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(3761),
    [anon_sym_SLASH] = ACTIONS(3763),
    [anon_sym_PERCENT] = ACTIONS(3763),
    [sym_comment] = ACTIONS(87),
  },
  [4566] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(3837),
    [sym__binary_star] = ACTIONS(3839),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_RPAREN] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(3841),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(3843),
    [anon_sym_AMP] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(4217),
    [anon_sym_LT] = ACTIONS(3847),
    [anon_sym_if] = ACTIONS(4211),
    [anon_sym_unless] = ACTIONS(4211),
    [anon_sym_while] = ACTIONS(4211),
    [anon_sym_until] = ACTIONS(4211),
    [anon_sym_rescue] = ACTIONS(4211),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_EQ_GT] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_PLUS_EQ] = ACTIONS(4211),
    [anon_sym_DASH_EQ] = ACTIONS(4211),
    [anon_sym_STAR_EQ] = ACTIONS(4211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4211),
    [anon_sym_SLASH_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4211),
    [anon_sym_AMP_EQ] = ACTIONS(4211),
    [anon_sym_PERCENT_EQ] = ACTIONS(4211),
    [anon_sym_GT_GT_EQ] = ACTIONS(4211),
    [anon_sym_LT_LT_EQ] = ACTIONS(4211),
    [anon_sym_CARET_EQ] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(3849),
    [anon_sym_DOT_DOT] = ACTIONS(3851),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3853),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(3855),
    [anon_sym_AMP_AMP] = ACTIONS(3855),
    [anon_sym_LT_LT] = ACTIONS(3857),
    [anon_sym_GT_GT] = ACTIONS(3857),
    [anon_sym_EQ_EQ] = ACTIONS(3855),
    [anon_sym_BANG_EQ] = ACTIONS(3859),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3859),
    [anon_sym_LT_EQ_GT] = ACTIONS(3859),
    [anon_sym_EQ_TILDE] = ACTIONS(3859),
    [anon_sym_BANG_TILDE] = ACTIONS(3859),
    [anon_sym_LT_EQ] = ACTIONS(3847),
    [anon_sym_GT] = ACTIONS(3847),
    [anon_sym_GT_EQ] = ACTIONS(3861),
    [anon_sym_CARET] = ACTIONS(3841),
    [anon_sym_PLUS] = ACTIONS(3863),
    [anon_sym_SLASH] = ACTIONS(3843),
    [anon_sym_PERCENT] = ACTIONS(3843),
    [sym_comment] = ACTIONS(87),
  },
  [4567] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(3837),
    [sym__binary_star] = ACTIONS(3839),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_RPAREN] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(3841),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(3843),
    [anon_sym_AMP] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(4249),
    [anon_sym_LT] = ACTIONS(3847),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_EQ_GT] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_PLUS_EQ] = ACTIONS(4247),
    [anon_sym_DASH_EQ] = ACTIONS(4247),
    [anon_sym_STAR_EQ] = ACTIONS(4247),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4247),
    [anon_sym_SLASH_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4247),
    [anon_sym_AMP_EQ] = ACTIONS(4247),
    [anon_sym_PERCENT_EQ] = ACTIONS(4247),
    [anon_sym_GT_GT_EQ] = ACTIONS(4247),
    [anon_sym_LT_LT_EQ] = ACTIONS(4247),
    [anon_sym_CARET_EQ] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(3849),
    [anon_sym_DOT_DOT] = ACTIONS(3851),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3853),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(3855),
    [anon_sym_AMP_AMP] = ACTIONS(3855),
    [anon_sym_LT_LT] = ACTIONS(3857),
    [anon_sym_GT_GT] = ACTIONS(3857),
    [anon_sym_EQ_EQ] = ACTIONS(3855),
    [anon_sym_BANG_EQ] = ACTIONS(3859),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3859),
    [anon_sym_LT_EQ_GT] = ACTIONS(3859),
    [anon_sym_EQ_TILDE] = ACTIONS(3859),
    [anon_sym_BANG_TILDE] = ACTIONS(3859),
    [anon_sym_LT_EQ] = ACTIONS(3847),
    [anon_sym_GT] = ACTIONS(3847),
    [anon_sym_GT_EQ] = ACTIONS(3861),
    [anon_sym_CARET] = ACTIONS(3841),
    [anon_sym_PLUS] = ACTIONS(3863),
    [anon_sym_SLASH] = ACTIONS(3843),
    [anon_sym_PERCENT] = ACTIONS(3843),
    [sym_comment] = ACTIONS(87),
  },
  [4568] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(7165),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(742),
    [sym_scope_resolution] = STATE(738),
    [sym_call] = STATE(738),
    [sym_method_call] = STATE(742),
    [sym_assignment] = STATE(7165),
    [sym_operator_assignment] = STATE(7165),
    [sym_conditional] = STATE(7165),
    [sym_range] = STATE(7165),
    [sym_binary] = STATE(7165),
    [sym_unary] = STATE(7165),
    [sym_left_assignment_list] = STATE(741),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(742),
    [sym__variable] = STATE(738),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(742),
    [sym_false] = STATE(742),
    [sym_nil] = STATE(742),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2209),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1381),
    [anon_sym_break] = ACTIONS(1383),
    [anon_sym_next] = ACTIONS(1385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(3831),
    [anon_sym_defined_QMARK] = ACTIONS(1387),
    [anon_sym_not] = ACTIONS(1389),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_TILDE] = ACTIONS(1393),
    [sym_constant] = ACTIONS(1399),
    [sym_identifier] = ACTIONS(1399),
    [sym_instance_variable] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1397),
    [sym_global_variable] = ACTIONS(1397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [4569] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(3837),
    [sym__binary_star] = ACTIONS(3839),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_RPAREN] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(3841),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(3843),
    [anon_sym_AMP] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(3847),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_unless] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_until] = ACTIONS(3281),
    [anon_sym_rescue] = ACTIONS(3281),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_EQ_GT] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_PLUS_EQ] = ACTIONS(3281),
    [anon_sym_DASH_EQ] = ACTIONS(3281),
    [anon_sym_STAR_EQ] = ACTIONS(3281),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3281),
    [anon_sym_SLASH_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3281),
    [anon_sym_AMP_EQ] = ACTIONS(3281),
    [anon_sym_PERCENT_EQ] = ACTIONS(3281),
    [anon_sym_GT_GT_EQ] = ACTIONS(3281),
    [anon_sym_LT_LT_EQ] = ACTIONS(3281),
    [anon_sym_CARET_EQ] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3849),
    [anon_sym_DOT_DOT] = ACTIONS(3851),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3853),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(3855),
    [anon_sym_AMP_AMP] = ACTIONS(3855),
    [anon_sym_LT_LT] = ACTIONS(3857),
    [anon_sym_GT_GT] = ACTIONS(3857),
    [anon_sym_EQ_EQ] = ACTIONS(3855),
    [anon_sym_BANG_EQ] = ACTIONS(3859),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3859),
    [anon_sym_LT_EQ_GT] = ACTIONS(3859),
    [anon_sym_EQ_TILDE] = ACTIONS(3859),
    [anon_sym_BANG_TILDE] = ACTIONS(3859),
    [anon_sym_LT_EQ] = ACTIONS(3847),
    [anon_sym_GT] = ACTIONS(3847),
    [anon_sym_GT_EQ] = ACTIONS(3861),
    [anon_sym_CARET] = ACTIONS(3841),
    [anon_sym_PLUS] = ACTIONS(3863),
    [anon_sym_SLASH] = ACTIONS(3843),
    [anon_sym_PERCENT] = ACTIONS(3843),
    [sym_comment] = ACTIONS(87),
  },
  [4570] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(7166),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(742),
    [sym_scope_resolution] = STATE(738),
    [sym_call] = STATE(738),
    [sym_method_call] = STATE(742),
    [sym_assignment] = STATE(7166),
    [sym_operator_assignment] = STATE(7166),
    [sym_conditional] = STATE(7166),
    [sym_range] = STATE(7166),
    [sym_binary] = STATE(7166),
    [sym_unary] = STATE(7166),
    [sym_left_assignment_list] = STATE(741),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(742),
    [sym__variable] = STATE(738),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(742),
    [sym_false] = STATE(742),
    [sym_nil] = STATE(742),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2209),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1381),
    [anon_sym_break] = ACTIONS(1383),
    [anon_sym_next] = ACTIONS(1385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(3831),
    [anon_sym_defined_QMARK] = ACTIONS(1387),
    [anon_sym_not] = ACTIONS(1389),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_TILDE] = ACTIONS(1393),
    [sym_constant] = ACTIONS(1399),
    [sym_identifier] = ACTIONS(1399),
    [sym_instance_variable] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1397),
    [sym_global_variable] = ACTIONS(1397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [4571] = {
    [sym_heredoc_body] = STATE(7167),
    [aux_sym_call_repeat1] = STATE(7167),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_RPAREN] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [4572] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(2169),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(742),
    [sym_scope_resolution] = STATE(738),
    [sym_call] = STATE(738),
    [sym_method_call] = STATE(742),
    [sym__argument] = STATE(4979),
    [sym_splat_argument] = STATE(4979),
    [sym_hash_splat_argument] = STATE(4979),
    [sym_block_argument] = STATE(4979),
    [sym_assignment] = STATE(2169),
    [sym_operator_assignment] = STATE(2169),
    [sym_conditional] = STATE(2169),
    [sym_range] = STATE(2169),
    [sym_binary] = STATE(2169),
    [sym_unary] = STATE(2169),
    [sym_left_assignment_list] = STATE(741),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(742),
    [sym__variable] = STATE(738),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(742),
    [sym_false] = STATE(742),
    [sym_nil] = STATE(742),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2172),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_heredoc_body] = STATE(7168),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(4979),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(3787),
    [sym__splat_star] = ACTIONS(3789),
    [sym__unary_minus] = ACTIONS(1375),
    [sym__identifier_hash_key] = ACTIONS(3791),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10746),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1381),
    [anon_sym_break] = ACTIONS(1383),
    [anon_sym_next] = ACTIONS(1385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(3831),
    [anon_sym_defined_QMARK] = ACTIONS(1387),
    [anon_sym_not] = ACTIONS(1389),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_TILDE] = ACTIONS(1393),
    [sym_constant] = ACTIONS(3793),
    [sym_identifier] = ACTIONS(3793),
    [sym_instance_variable] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1397),
    [sym_global_variable] = ACTIONS(1397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [4573] = {
    [sym_heredoc_body] = STATE(7169),
    [aux_sym_call_repeat1] = STATE(7169),
    [aux_sym_argument_list_repeat1] = STATE(7170),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_RPAREN] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(7450),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [4574] = {
    [sym_heredoc_body] = STATE(4574),
    [aux_sym_call_repeat1] = STATE(4574),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(7916),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_RPAREN] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [4575] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(700),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(705),
    [sym_scope_resolution] = STATE(701),
    [sym_call] = STATE(701),
    [sym_method_call] = STATE(705),
    [sym__argument] = STATE(4986),
    [sym_splat_argument] = STATE(4986),
    [sym_hash_splat_argument] = STATE(4986),
    [sym_block_argument] = STATE(4986),
    [sym_assignment] = STATE(700),
    [sym_operator_assignment] = STATE(700),
    [sym_conditional] = STATE(700),
    [sym_range] = STATE(700),
    [sym_binary] = STATE(700),
    [sym_unary] = STATE(700),
    [sym_left_assignment_list] = STATE(704),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(705),
    [sym__variable] = STATE(701),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(705),
    [sym_false] = STATE(705),
    [sym_nil] = STATE(705),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(706),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4986),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(1299),
    [sym__splat_star] = ACTIONS(1301),
    [sym__unary_minus] = ACTIONS(1303),
    [sym__identifier_hash_key] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(7454),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3747),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1323),
    [sym_identifier] = ACTIONS(1323),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4576] = {
    [sym_heredoc_body] = STATE(4574),
    [aux_sym_call_repeat1] = STATE(4574),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_RPAREN] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [4577] = {
    [aux_sym_argument_list_repeat1] = STATE(4577),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_RPAREN] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(10748),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7925),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_if] = ACTIONS(7925),
    [anon_sym_unless] = ACTIONS(7925),
    [anon_sym_while] = ACTIONS(7925),
    [anon_sym_until] = ACTIONS(7925),
    [anon_sym_rescue] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7925),
    [anon_sym_AMP_AMP] = ACTIONS(7925),
    [anon_sym_LT_LT] = ACTIONS(7925),
    [anon_sym_GT_GT] = ACTIONS(7925),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7925),
    [anon_sym_PLUS] = ACTIONS(7925),
    [anon_sym_SLASH] = ACTIONS(7925),
    [anon_sym_PERCENT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [4578] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(3761),
    [sym__binary_star] = ACTIONS(3763),
    [anon_sym_RPAREN] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(3765),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(3763),
    [anon_sym_AMP] = ACTIONS(3767),
    [anon_sym_LT] = ACTIONS(3769),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_EQ_GT] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(3771),
    [anon_sym_DOT_DOT] = ACTIONS(3773),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3775),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(3777),
    [anon_sym_AMP_AMP] = ACTIONS(3777),
    [anon_sym_LT_LT] = ACTIONS(3779),
    [anon_sym_GT_GT] = ACTIONS(3779),
    [anon_sym_EQ_EQ] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3777),
    [anon_sym_LT_EQ_GT] = ACTIONS(3777),
    [anon_sym_EQ_TILDE] = ACTIONS(3777),
    [anon_sym_BANG_TILDE] = ACTIONS(3777),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3783),
    [anon_sym_CARET] = ACTIONS(3785),
    [anon_sym_PLUS] = ACTIONS(3761),
    [anon_sym_SLASH] = ACTIONS(3763),
    [anon_sym_PERCENT] = ACTIONS(3763),
    [sym_comment] = ACTIONS(87),
  },
  [4579] = {
    [aux_sym_exceptions_repeat1] = STATE(7172),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_RPAREN] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [4580] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(3761),
    [sym__binary_star] = ACTIONS(3763),
    [anon_sym_RPAREN] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(3765),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(3763),
    [anon_sym_AMP] = ACTIONS(3767),
    [anon_sym_LT] = ACTIONS(3769),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_EQ_GT] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(3771),
    [anon_sym_DOT_DOT] = ACTIONS(3773),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3775),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(3777),
    [anon_sym_AMP_AMP] = ACTIONS(3777),
    [anon_sym_LT_LT] = ACTIONS(3779),
    [anon_sym_GT_GT] = ACTIONS(3779),
    [anon_sym_EQ_EQ] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3777),
    [anon_sym_LT_EQ_GT] = ACTIONS(3777),
    [anon_sym_EQ_TILDE] = ACTIONS(3777),
    [anon_sym_BANG_TILDE] = ACTIONS(3777),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3783),
    [anon_sym_CARET] = ACTIONS(3785),
    [anon_sym_PLUS] = ACTIONS(3761),
    [anon_sym_SLASH] = ACTIONS(3763),
    [anon_sym_PERCENT] = ACTIONS(3763),
    [sym_comment] = ACTIONS(87),
  },
  [4581] = {
    [sym_string] = STATE(4581),
    [aux_sym_chained_string_repeat1] = STATE(4581),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(6214),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_RPAREN] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_EQ_GT] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [4582] = {
    [aux_sym_undef_repeat1] = STATE(4582),
    [sym__line_break] = ACTIONS(9263),
    [sym__heredoc_body_start] = ACTIONS(9263),
    [anon_sym_RPAREN] = ACTIONS(9263),
    [anon_sym_COMMA] = ACTIONS(9265),
    [anon_sym_SEMI] = ACTIONS(9263),
    [anon_sym_if] = ACTIONS(9263),
    [anon_sym_unless] = ACTIONS(9263),
    [anon_sym_while] = ACTIONS(9263),
    [anon_sym_until] = ACTIONS(9263),
    [anon_sym_rescue] = ACTIONS(9263),
    [sym_comment] = ACTIONS(87),
  },
  [4583] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7173),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(686),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(686),
    [sym_assignment] = STATE(7173),
    [sym_operator_assignment] = STATE(7173),
    [sym_conditional] = STATE(7173),
    [sym_range] = STATE(7173),
    [sym_binary] = STATE(7173),
    [sym_unary] = STATE(7173),
    [sym_left_assignment_list] = STATE(147),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(686),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(686),
    [sym_false] = STATE(686),
    [sym_nil] = STATE(686),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(151),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4584] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(7464),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [4585] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(7458),
    [sym__binary_star] = ACTIONS(7460),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(7462),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(7464),
    [anon_sym_AMP] = ACTIONS(7466),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(7468),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(7470),
    [anon_sym_DOT_DOT] = ACTIONS(7472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7474),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(7476),
    [anon_sym_AMP_AMP] = ACTIONS(7476),
    [anon_sym_LT_LT] = ACTIONS(7478),
    [anon_sym_GT_GT] = ACTIONS(7478),
    [anon_sym_EQ_EQ] = ACTIONS(7476),
    [anon_sym_BANG_EQ] = ACTIONS(7480),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7480),
    [anon_sym_LT_EQ_GT] = ACTIONS(7480),
    [anon_sym_EQ_TILDE] = ACTIONS(7480),
    [anon_sym_BANG_TILDE] = ACTIONS(7480),
    [anon_sym_LT_EQ] = ACTIONS(7468),
    [anon_sym_GT] = ACTIONS(7468),
    [anon_sym_GT_EQ] = ACTIONS(7482),
    [anon_sym_CARET] = ACTIONS(7462),
    [anon_sym_PLUS] = ACTIONS(7484),
    [anon_sym_SLASH] = ACTIONS(7464),
    [anon_sym_PERCENT] = ACTIONS(7464),
    [sym_comment] = ACTIONS(87),
  },
  [4586] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(7174),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2205),
    [sym_scope_resolution] = STATE(2203),
    [sym_call] = STATE(2203),
    [sym_method_call] = STATE(2205),
    [sym_assignment] = STATE(7174),
    [sym_operator_assignment] = STATE(7174),
    [sym_conditional] = STATE(7174),
    [sym_range] = STATE(7174),
    [sym_binary] = STATE(7174),
    [sym_unary] = STATE(7174),
    [sym_left_assignment_list] = STATE(2204),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2205),
    [sym__variable] = STATE(2203),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2205),
    [sym_false] = STATE(2205),
    [sym_nil] = STATE(2205),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2206),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(3809),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(3811),
    [anon_sym_yield] = ACTIONS(3813),
    [anon_sym_break] = ACTIONS(3815),
    [anon_sym_next] = ACTIONS(3817),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(3819),
    [anon_sym_defined_QMARK] = ACTIONS(3821),
    [anon_sym_not] = ACTIONS(3823),
    [anon_sym_BANG] = ACTIONS(3825),
    [anon_sym_TILDE] = ACTIONS(3825),
    [sym_constant] = ACTIONS(3827),
    [sym_identifier] = ACTIONS(3827),
    [sym_instance_variable] = ACTIONS(3829),
    [sym_class_variable] = ACTIONS(3829),
    [sym_global_variable] = ACTIONS(3829),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(3827),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3827),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [4587] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(7175),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2205),
    [sym_scope_resolution] = STATE(2203),
    [sym_call] = STATE(2203),
    [sym_method_call] = STATE(2205),
    [sym_assignment] = STATE(7175),
    [sym_operator_assignment] = STATE(7175),
    [sym_conditional] = STATE(7175),
    [sym_range] = STATE(7175),
    [sym_binary] = STATE(7175),
    [sym_unary] = STATE(7175),
    [sym_left_assignment_list] = STATE(2204),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2205),
    [sym__variable] = STATE(2203),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2205),
    [sym_false] = STATE(2205),
    [sym_nil] = STATE(2205),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2206),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(3809),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(3811),
    [anon_sym_yield] = ACTIONS(3813),
    [anon_sym_break] = ACTIONS(3815),
    [anon_sym_next] = ACTIONS(3817),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(3819),
    [anon_sym_defined_QMARK] = ACTIONS(3821),
    [anon_sym_not] = ACTIONS(3823),
    [anon_sym_BANG] = ACTIONS(3825),
    [anon_sym_TILDE] = ACTIONS(3825),
    [sym_constant] = ACTIONS(3827),
    [sym_identifier] = ACTIONS(3827),
    [sym_instance_variable] = ACTIONS(3829),
    [sym_class_variable] = ACTIONS(3829),
    [sym_global_variable] = ACTIONS(3829),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(3827),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3827),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [4588] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(7176),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2205),
    [sym_scope_resolution] = STATE(2203),
    [sym_call] = STATE(2203),
    [sym_method_call] = STATE(2205),
    [sym_assignment] = STATE(7176),
    [sym_operator_assignment] = STATE(7176),
    [sym_conditional] = STATE(7176),
    [sym_range] = STATE(7176),
    [sym_binary] = STATE(7176),
    [sym_unary] = STATE(7176),
    [sym_left_assignment_list] = STATE(2204),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2205),
    [sym__variable] = STATE(2203),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2205),
    [sym_false] = STATE(2205),
    [sym_nil] = STATE(2205),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2206),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(3809),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(3811),
    [anon_sym_yield] = ACTIONS(3813),
    [anon_sym_break] = ACTIONS(3815),
    [anon_sym_next] = ACTIONS(3817),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(3819),
    [anon_sym_defined_QMARK] = ACTIONS(3821),
    [anon_sym_not] = ACTIONS(3823),
    [anon_sym_BANG] = ACTIONS(3825),
    [anon_sym_TILDE] = ACTIONS(3825),
    [sym_constant] = ACTIONS(3827),
    [sym_identifier] = ACTIONS(3827),
    [sym_instance_variable] = ACTIONS(3829),
    [sym_class_variable] = ACTIONS(3829),
    [sym_global_variable] = ACTIONS(3829),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(3827),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3827),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [4589] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(7177),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2205),
    [sym_scope_resolution] = STATE(2203),
    [sym_call] = STATE(2203),
    [sym_method_call] = STATE(2205),
    [sym_assignment] = STATE(7177),
    [sym_operator_assignment] = STATE(7177),
    [sym_conditional] = STATE(7177),
    [sym_range] = STATE(7177),
    [sym_binary] = STATE(7177),
    [sym_unary] = STATE(7177),
    [sym_left_assignment_list] = STATE(2204),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2205),
    [sym__variable] = STATE(2203),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2205),
    [sym_false] = STATE(2205),
    [sym_nil] = STATE(2205),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2206),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(3809),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(3811),
    [anon_sym_yield] = ACTIONS(3813),
    [anon_sym_break] = ACTIONS(3815),
    [anon_sym_next] = ACTIONS(3817),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(3819),
    [anon_sym_defined_QMARK] = ACTIONS(3821),
    [anon_sym_not] = ACTIONS(3823),
    [anon_sym_BANG] = ACTIONS(3825),
    [anon_sym_TILDE] = ACTIONS(3825),
    [sym_constant] = ACTIONS(3827),
    [sym_identifier] = ACTIONS(3827),
    [sym_instance_variable] = ACTIONS(3829),
    [sym_class_variable] = ACTIONS(3829),
    [sym_global_variable] = ACTIONS(3829),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(3827),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3827),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [4590] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(7178),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2205),
    [sym_scope_resolution] = STATE(2203),
    [sym_call] = STATE(2203),
    [sym_method_call] = STATE(2205),
    [sym_assignment] = STATE(7178),
    [sym_operator_assignment] = STATE(7178),
    [sym_conditional] = STATE(7178),
    [sym_range] = STATE(7178),
    [sym_binary] = STATE(7178),
    [sym_unary] = STATE(7178),
    [sym_left_assignment_list] = STATE(2204),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2205),
    [sym__variable] = STATE(2203),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2205),
    [sym_false] = STATE(2205),
    [sym_nil] = STATE(2205),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2206),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(3809),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(3811),
    [anon_sym_yield] = ACTIONS(3813),
    [anon_sym_break] = ACTIONS(3815),
    [anon_sym_next] = ACTIONS(3817),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(3819),
    [anon_sym_defined_QMARK] = ACTIONS(3821),
    [anon_sym_not] = ACTIONS(3823),
    [anon_sym_BANG] = ACTIONS(3825),
    [anon_sym_TILDE] = ACTIONS(3825),
    [sym_constant] = ACTIONS(3827),
    [sym_identifier] = ACTIONS(3827),
    [sym_instance_variable] = ACTIONS(3829),
    [sym_class_variable] = ACTIONS(3829),
    [sym_global_variable] = ACTIONS(3829),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(3827),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3827),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [4591] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(7179),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(7179),
    [sym_operator_assignment] = STATE(7179),
    [sym_conditional] = STATE(7179),
    [sym_range] = STATE(7179),
    [sym_binary] = STATE(7179),
    [sym_unary] = STATE(7179),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4592] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(7180),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2205),
    [sym_scope_resolution] = STATE(2203),
    [sym_call] = STATE(2203),
    [sym_method_call] = STATE(2205),
    [sym_assignment] = STATE(7180),
    [sym_operator_assignment] = STATE(7180),
    [sym_conditional] = STATE(7180),
    [sym_range] = STATE(7180),
    [sym_binary] = STATE(7180),
    [sym_unary] = STATE(7180),
    [sym_left_assignment_list] = STATE(2204),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2205),
    [sym__variable] = STATE(2203),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2205),
    [sym_false] = STATE(2205),
    [sym_nil] = STATE(2205),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2206),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(3809),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(3811),
    [anon_sym_yield] = ACTIONS(3813),
    [anon_sym_break] = ACTIONS(3815),
    [anon_sym_next] = ACTIONS(3817),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(3819),
    [anon_sym_defined_QMARK] = ACTIONS(3821),
    [anon_sym_not] = ACTIONS(3823),
    [anon_sym_BANG] = ACTIONS(3825),
    [anon_sym_TILDE] = ACTIONS(3825),
    [sym_constant] = ACTIONS(3827),
    [sym_identifier] = ACTIONS(3827),
    [sym_instance_variable] = ACTIONS(3829),
    [sym_class_variable] = ACTIONS(3829),
    [sym_global_variable] = ACTIONS(3829),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(3827),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3827),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [4593] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(7181),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2205),
    [sym_scope_resolution] = STATE(2203),
    [sym_call] = STATE(2203),
    [sym_method_call] = STATE(2205),
    [sym_assignment] = STATE(7181),
    [sym_operator_assignment] = STATE(7181),
    [sym_conditional] = STATE(7181),
    [sym_range] = STATE(7181),
    [sym_binary] = STATE(7181),
    [sym_unary] = STATE(7181),
    [sym_left_assignment_list] = STATE(2204),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2205),
    [sym__variable] = STATE(2203),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2205),
    [sym_false] = STATE(2205),
    [sym_nil] = STATE(2205),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2206),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(3809),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(3811),
    [anon_sym_yield] = ACTIONS(3813),
    [anon_sym_break] = ACTIONS(3815),
    [anon_sym_next] = ACTIONS(3817),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(3819),
    [anon_sym_defined_QMARK] = ACTIONS(3821),
    [anon_sym_not] = ACTIONS(3823),
    [anon_sym_BANG] = ACTIONS(3825),
    [anon_sym_TILDE] = ACTIONS(3825),
    [sym_constant] = ACTIONS(3827),
    [sym_identifier] = ACTIONS(3827),
    [sym_instance_variable] = ACTIONS(3829),
    [sym_class_variable] = ACTIONS(3829),
    [sym_global_variable] = ACTIONS(3829),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(3827),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3827),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [4594] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(7182),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2205),
    [sym_scope_resolution] = STATE(2203),
    [sym_call] = STATE(2203),
    [sym_method_call] = STATE(2205),
    [sym_assignment] = STATE(7182),
    [sym_operator_assignment] = STATE(7182),
    [sym_conditional] = STATE(7182),
    [sym_range] = STATE(7182),
    [sym_binary] = STATE(7182),
    [sym_unary] = STATE(7182),
    [sym_left_assignment_list] = STATE(2204),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2205),
    [sym__variable] = STATE(2203),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2205),
    [sym_false] = STATE(2205),
    [sym_nil] = STATE(2205),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2206),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(3809),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(3811),
    [anon_sym_yield] = ACTIONS(3813),
    [anon_sym_break] = ACTIONS(3815),
    [anon_sym_next] = ACTIONS(3817),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(3819),
    [anon_sym_defined_QMARK] = ACTIONS(3821),
    [anon_sym_not] = ACTIONS(3823),
    [anon_sym_BANG] = ACTIONS(3825),
    [anon_sym_TILDE] = ACTIONS(3825),
    [sym_constant] = ACTIONS(3827),
    [sym_identifier] = ACTIONS(3827),
    [sym_instance_variable] = ACTIONS(3829),
    [sym_class_variable] = ACTIONS(3829),
    [sym_global_variable] = ACTIONS(3829),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(3827),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3827),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [4595] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(7183),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2205),
    [sym_scope_resolution] = STATE(2203),
    [sym_call] = STATE(2203),
    [sym_method_call] = STATE(2205),
    [sym_assignment] = STATE(7183),
    [sym_operator_assignment] = STATE(7183),
    [sym_conditional] = STATE(7183),
    [sym_range] = STATE(7183),
    [sym_binary] = STATE(7183),
    [sym_unary] = STATE(7183),
    [sym_left_assignment_list] = STATE(2204),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2205),
    [sym__variable] = STATE(2203),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2205),
    [sym_false] = STATE(2205),
    [sym_nil] = STATE(2205),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2206),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(3809),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(3811),
    [anon_sym_yield] = ACTIONS(3813),
    [anon_sym_break] = ACTIONS(3815),
    [anon_sym_next] = ACTIONS(3817),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(3819),
    [anon_sym_defined_QMARK] = ACTIONS(3821),
    [anon_sym_not] = ACTIONS(3823),
    [anon_sym_BANG] = ACTIONS(3825),
    [anon_sym_TILDE] = ACTIONS(3825),
    [sym_constant] = ACTIONS(3827),
    [sym_identifier] = ACTIONS(3827),
    [sym_instance_variable] = ACTIONS(3829),
    [sym_class_variable] = ACTIONS(3829),
    [sym_global_variable] = ACTIONS(3829),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(3827),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3827),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [4596] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(7184),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2205),
    [sym_scope_resolution] = STATE(2203),
    [sym_call] = STATE(2203),
    [sym_method_call] = STATE(2205),
    [sym_splat_argument] = STATE(7185),
    [sym_assignment] = STATE(7184),
    [sym_operator_assignment] = STATE(7184),
    [sym_conditional] = STATE(7184),
    [sym_range] = STATE(7184),
    [sym_binary] = STATE(7184),
    [sym_unary] = STATE(7184),
    [sym_right_assignment_list] = STATE(6323),
    [sym__arg_or_splat_arg] = STATE(7185),
    [sym_left_assignment_list] = STATE(2204),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2205),
    [sym__variable] = STATE(2203),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2205),
    [sym_false] = STATE(2205),
    [sym_nil] = STATE(2205),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2206),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__splat_star] = ACTIONS(1373),
    [sym__unary_minus] = ACTIONS(3809),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(3811),
    [anon_sym_yield] = ACTIONS(3813),
    [anon_sym_break] = ACTIONS(3815),
    [anon_sym_next] = ACTIONS(3817),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(3819),
    [anon_sym_defined_QMARK] = ACTIONS(3821),
    [anon_sym_not] = ACTIONS(3823),
    [anon_sym_BANG] = ACTIONS(3825),
    [anon_sym_TILDE] = ACTIONS(3825),
    [sym_constant] = ACTIONS(3827),
    [sym_identifier] = ACTIONS(3827),
    [sym_instance_variable] = ACTIONS(3829),
    [sym_class_variable] = ACTIONS(3829),
    [sym_global_variable] = ACTIONS(3829),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(3827),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3827),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [4597] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(7186),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2205),
    [sym_scope_resolution] = STATE(2203),
    [sym_call] = STATE(2203),
    [sym_method_call] = STATE(2205),
    [sym_assignment] = STATE(7186),
    [sym_operator_assignment] = STATE(7186),
    [sym_conditional] = STATE(7186),
    [sym_range] = STATE(7186),
    [sym_binary] = STATE(7186),
    [sym_unary] = STATE(7186),
    [sym_left_assignment_list] = STATE(2204),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2205),
    [sym__variable] = STATE(2203),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2205),
    [sym_false] = STATE(2205),
    [sym_nil] = STATE(2205),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2206),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(3809),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(3811),
    [anon_sym_yield] = ACTIONS(3813),
    [anon_sym_break] = ACTIONS(3815),
    [anon_sym_next] = ACTIONS(3817),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(3819),
    [anon_sym_defined_QMARK] = ACTIONS(3821),
    [anon_sym_not] = ACTIONS(3823),
    [anon_sym_BANG] = ACTIONS(3825),
    [anon_sym_TILDE] = ACTIONS(3825),
    [sym_constant] = ACTIONS(3827),
    [sym_identifier] = ACTIONS(3827),
    [sym_instance_variable] = ACTIONS(3829),
    [sym_class_variable] = ACTIONS(3829),
    [sym_global_variable] = ACTIONS(3829),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(3827),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3827),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [4598] = {
    [sym_string] = STATE(7187),
    [aux_sym_chained_string_repeat1] = STATE(7187),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(2551),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_RPAREN] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2755),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_EQ] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_PLUS_EQ] = ACTIONS(2753),
    [anon_sym_DASH_EQ] = ACTIONS(2753),
    [anon_sym_STAR_EQ] = ACTIONS(2753),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2753),
    [anon_sym_SLASH_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2753),
    [anon_sym_AMP_EQ] = ACTIONS(2753),
    [anon_sym_PERCENT_EQ] = ACTIONS(2753),
    [anon_sym_GT_GT_EQ] = ACTIONS(2753),
    [anon_sym_LT_LT_EQ] = ACTIONS(2753),
    [anon_sym_CARET_EQ] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2755),
    [anon_sym_AMP_AMP] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2755),
    [anon_sym_GT_GT] = ACTIONS(2755),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_SLASH] = ACTIONS(2755),
    [anon_sym_PERCENT] = ACTIONS(2755),
    [sym_comment] = ACTIONS(87),
  },
  [4599] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(7458),
    [sym__binary_star] = ACTIONS(7460),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_RPAREN] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(7462),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(7464),
    [anon_sym_AMP] = ACTIONS(7466),
    [anon_sym_EQ] = ACTIONS(7822),
    [anon_sym_LT] = ACTIONS(7468),
    [anon_sym_if] = ACTIONS(6823),
    [anon_sym_unless] = ACTIONS(6823),
    [anon_sym_while] = ACTIONS(6823),
    [anon_sym_until] = ACTIONS(6823),
    [anon_sym_rescue] = ACTIONS(6823),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_PLUS_EQ] = ACTIONS(6823),
    [anon_sym_DASH_EQ] = ACTIONS(6823),
    [anon_sym_STAR_EQ] = ACTIONS(6823),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6823),
    [anon_sym_SLASH_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6823),
    [anon_sym_AMP_EQ] = ACTIONS(6823),
    [anon_sym_PERCENT_EQ] = ACTIONS(6823),
    [anon_sym_GT_GT_EQ] = ACTIONS(6823),
    [anon_sym_LT_LT_EQ] = ACTIONS(6823),
    [anon_sym_CARET_EQ] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(7470),
    [anon_sym_DOT_DOT] = ACTIONS(7472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7474),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(7476),
    [anon_sym_AMP_AMP] = ACTIONS(7476),
    [anon_sym_LT_LT] = ACTIONS(7478),
    [anon_sym_GT_GT] = ACTIONS(7478),
    [anon_sym_EQ_EQ] = ACTIONS(7476),
    [anon_sym_BANG_EQ] = ACTIONS(7480),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7480),
    [anon_sym_LT_EQ_GT] = ACTIONS(7480),
    [anon_sym_EQ_TILDE] = ACTIONS(7480),
    [anon_sym_BANG_TILDE] = ACTIONS(7480),
    [anon_sym_LT_EQ] = ACTIONS(7468),
    [anon_sym_GT] = ACTIONS(7468),
    [anon_sym_GT_EQ] = ACTIONS(7482),
    [anon_sym_CARET] = ACTIONS(7462),
    [anon_sym_PLUS] = ACTIONS(7484),
    [anon_sym_SLASH] = ACTIONS(7464),
    [anon_sym_PERCENT] = ACTIONS(7464),
    [sym_comment] = ACTIONS(87),
  },
  [4600] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(7458),
    [sym__binary_star] = ACTIONS(7460),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_RPAREN] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(7462),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(7464),
    [anon_sym_AMP] = ACTIONS(7466),
    [anon_sym_EQ] = ACTIONS(7884),
    [anon_sym_LT] = ACTIONS(7468),
    [anon_sym_if] = ACTIONS(7027),
    [anon_sym_unless] = ACTIONS(7027),
    [anon_sym_while] = ACTIONS(7027),
    [anon_sym_until] = ACTIONS(7027),
    [anon_sym_rescue] = ACTIONS(7027),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_PLUS_EQ] = ACTIONS(7027),
    [anon_sym_DASH_EQ] = ACTIONS(7027),
    [anon_sym_STAR_EQ] = ACTIONS(7027),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7027),
    [anon_sym_SLASH_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7027),
    [anon_sym_AMP_EQ] = ACTIONS(7027),
    [anon_sym_PERCENT_EQ] = ACTIONS(7027),
    [anon_sym_GT_GT_EQ] = ACTIONS(7027),
    [anon_sym_LT_LT_EQ] = ACTIONS(7027),
    [anon_sym_CARET_EQ] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(7470),
    [anon_sym_DOT_DOT] = ACTIONS(7472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7474),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(7476),
    [anon_sym_AMP_AMP] = ACTIONS(7476),
    [anon_sym_LT_LT] = ACTIONS(7478),
    [anon_sym_GT_GT] = ACTIONS(7478),
    [anon_sym_EQ_EQ] = ACTIONS(7476),
    [anon_sym_BANG_EQ] = ACTIONS(7480),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7480),
    [anon_sym_LT_EQ_GT] = ACTIONS(7480),
    [anon_sym_EQ_TILDE] = ACTIONS(7480),
    [anon_sym_BANG_TILDE] = ACTIONS(7480),
    [anon_sym_LT_EQ] = ACTIONS(7468),
    [anon_sym_GT] = ACTIONS(7468),
    [anon_sym_GT_EQ] = ACTIONS(7482),
    [anon_sym_CARET] = ACTIONS(7462),
    [anon_sym_PLUS] = ACTIONS(7484),
    [anon_sym_SLASH] = ACTIONS(7464),
    [anon_sym_PERCENT] = ACTIONS(7464),
    [sym_comment] = ACTIONS(87),
  },
  [4601] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(3839),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(3843),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(3843),
    [anon_sym_PERCENT] = ACTIONS(3843),
    [sym_comment] = ACTIONS(87),
  },
  [4602] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(3843),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(5827),
    [anon_sym_PERCENT] = ACTIONS(5827),
    [sym_comment] = ACTIONS(87),
  },
  [4603] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(3837),
    [sym__binary_star] = ACTIONS(3839),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(3843),
    [anon_sym_AMP] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(3857),
    [anon_sym_GT_GT] = ACTIONS(3857),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(3863),
    [anon_sym_SLASH] = ACTIONS(3843),
    [anon_sym_PERCENT] = ACTIONS(3843),
    [sym_comment] = ACTIONS(87),
  },
  [4604] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(3837),
    [sym__binary_star] = ACTIONS(3839),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(3843),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(3857),
    [anon_sym_GT_GT] = ACTIONS(3857),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(3863),
    [anon_sym_SLASH] = ACTIONS(3843),
    [anon_sym_PERCENT] = ACTIONS(3843),
    [sym_comment] = ACTIONS(87),
  },
  [4605] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(3837),
    [sym__binary_star] = ACTIONS(3839),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(3841),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(3843),
    [anon_sym_AMP] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(3857),
    [anon_sym_GT_GT] = ACTIONS(3857),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(3841),
    [anon_sym_PLUS] = ACTIONS(3863),
    [anon_sym_SLASH] = ACTIONS(3843),
    [anon_sym_PERCENT] = ACTIONS(3843),
    [sym_comment] = ACTIONS(87),
  },
  [4606] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(10751),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [4607] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(3837),
    [sym__binary_star] = ACTIONS(3839),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_RPAREN] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(3841),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(3843),
    [anon_sym_AMP] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(7888),
    [anon_sym_LT] = ACTIONS(3847),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_EQ_GT] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_PLUS_EQ] = ACTIONS(5927),
    [anon_sym_DASH_EQ] = ACTIONS(5927),
    [anon_sym_STAR_EQ] = ACTIONS(5927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5927),
    [anon_sym_SLASH_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5927),
    [anon_sym_AMP_EQ] = ACTIONS(5927),
    [anon_sym_PERCENT_EQ] = ACTIONS(5927),
    [anon_sym_GT_GT_EQ] = ACTIONS(5927),
    [anon_sym_LT_LT_EQ] = ACTIONS(5927),
    [anon_sym_CARET_EQ] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(3851),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3853),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3855),
    [anon_sym_AMP_AMP] = ACTIONS(3855),
    [anon_sym_LT_LT] = ACTIONS(3857),
    [anon_sym_GT_GT] = ACTIONS(3857),
    [anon_sym_EQ_EQ] = ACTIONS(3855),
    [anon_sym_BANG_EQ] = ACTIONS(3859),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3859),
    [anon_sym_LT_EQ_GT] = ACTIONS(3859),
    [anon_sym_EQ_TILDE] = ACTIONS(3859),
    [anon_sym_BANG_TILDE] = ACTIONS(3859),
    [anon_sym_LT_EQ] = ACTIONS(3847),
    [anon_sym_GT] = ACTIONS(3847),
    [anon_sym_GT_EQ] = ACTIONS(3861),
    [anon_sym_CARET] = ACTIONS(3841),
    [anon_sym_PLUS] = ACTIONS(3863),
    [anon_sym_SLASH] = ACTIONS(3843),
    [anon_sym_PERCENT] = ACTIONS(3843),
    [sym_comment] = ACTIONS(87),
  },
  [4608] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(3837),
    [sym__binary_star] = ACTIONS(3839),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(3841),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(3843),
    [anon_sym_AMP] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(3847),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(3849),
    [anon_sym_DOT_DOT] = ACTIONS(3851),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3853),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(3855),
    [anon_sym_AMP_AMP] = ACTIONS(3855),
    [anon_sym_LT_LT] = ACTIONS(3857),
    [anon_sym_GT_GT] = ACTIONS(3857),
    [anon_sym_EQ_EQ] = ACTIONS(3855),
    [anon_sym_BANG_EQ] = ACTIONS(3859),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3859),
    [anon_sym_LT_EQ_GT] = ACTIONS(3859),
    [anon_sym_EQ_TILDE] = ACTIONS(3859),
    [anon_sym_BANG_TILDE] = ACTIONS(3859),
    [anon_sym_LT_EQ] = ACTIONS(3847),
    [anon_sym_GT] = ACTIONS(3847),
    [anon_sym_GT_EQ] = ACTIONS(3861),
    [anon_sym_CARET] = ACTIONS(3841),
    [anon_sym_PLUS] = ACTIONS(3863),
    [anon_sym_SLASH] = ACTIONS(3843),
    [anon_sym_PERCENT] = ACTIONS(3843),
    [sym_comment] = ACTIONS(87),
  },
  [4609] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(3837),
    [sym__binary_star] = ACTIONS(3839),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(3841),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(3843),
    [anon_sym_AMP] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(3847),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(3857),
    [anon_sym_GT_GT] = ACTIONS(3857),
    [anon_sym_EQ_EQ] = ACTIONS(3855),
    [anon_sym_BANG_EQ] = ACTIONS(3859),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3859),
    [anon_sym_LT_EQ_GT] = ACTIONS(3859),
    [anon_sym_EQ_TILDE] = ACTIONS(3859),
    [anon_sym_BANG_TILDE] = ACTIONS(3859),
    [anon_sym_LT_EQ] = ACTIONS(3847),
    [anon_sym_GT] = ACTIONS(3847),
    [anon_sym_GT_EQ] = ACTIONS(3861),
    [anon_sym_CARET] = ACTIONS(3841),
    [anon_sym_PLUS] = ACTIONS(3863),
    [anon_sym_SLASH] = ACTIONS(3843),
    [anon_sym_PERCENT] = ACTIONS(3843),
    [sym_comment] = ACTIONS(87),
  },
  [4610] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(3837),
    [sym__binary_star] = ACTIONS(3839),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(3843),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(3863),
    [anon_sym_SLASH] = ACTIONS(3843),
    [anon_sym_PERCENT] = ACTIONS(3843),
    [sym_comment] = ACTIONS(87),
  },
  [4611] = {
    [sym_heredoc_body] = STATE(4611),
    [aux_sym_call_repeat1] = STATE(4611),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(9846),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_RPAREN] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7919),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_EQ] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_PLUS_EQ] = ACTIONS(7914),
    [anon_sym_DASH_EQ] = ACTIONS(7914),
    [anon_sym_STAR_EQ] = ACTIONS(7914),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7914),
    [anon_sym_SLASH_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7914),
    [anon_sym_AMP_EQ] = ACTIONS(7914),
    [anon_sym_PERCENT_EQ] = ACTIONS(7914),
    [anon_sym_GT_GT_EQ] = ACTIONS(7914),
    [anon_sym_LT_LT_EQ] = ACTIONS(7914),
    [anon_sym_CARET_EQ] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7919),
    [anon_sym_AMP_AMP] = ACTIONS(7919),
    [anon_sym_LT_LT] = ACTIONS(7919),
    [anon_sym_GT_GT] = ACTIONS(7919),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7919),
    [anon_sym_PLUS] = ACTIONS(7919),
    [anon_sym_SLASH] = ACTIONS(7919),
    [anon_sym_PERCENT] = ACTIONS(7919),
    [sym_comment] = ACTIONS(87),
  },
  [4612] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(737),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(742),
    [sym_scope_resolution] = STATE(738),
    [sym_call] = STATE(738),
    [sym_method_call] = STATE(742),
    [sym__argument] = STATE(6393),
    [sym_splat_argument] = STATE(6393),
    [sym_hash_splat_argument] = STATE(6393),
    [sym_block_argument] = STATE(6393),
    [sym_assignment] = STATE(737),
    [sym_operator_assignment] = STATE(737),
    [sym_conditional] = STATE(737),
    [sym_range] = STATE(737),
    [sym_binary] = STATE(737),
    [sym_unary] = STATE(737),
    [sym_left_assignment_list] = STATE(741),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(742),
    [sym__variable] = STATE(738),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(742),
    [sym_false] = STATE(742),
    [sym_nil] = STATE(742),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(743),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(6393),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(1371),
    [sym__splat_star] = ACTIONS(1373),
    [sym__unary_minus] = ACTIONS(1375),
    [sym__identifier_hash_key] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(7492),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1381),
    [anon_sym_break] = ACTIONS(1383),
    [anon_sym_next] = ACTIONS(1385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(3831),
    [anon_sym_defined_QMARK] = ACTIONS(1387),
    [anon_sym_not] = ACTIONS(1389),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_TILDE] = ACTIONS(1393),
    [sym_constant] = ACTIONS(1395),
    [sym_identifier] = ACTIONS(1395),
    [sym_instance_variable] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1397),
    [sym_global_variable] = ACTIONS(1397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [4613] = {
    [sym_heredoc_body] = STATE(4611),
    [aux_sym_call_repeat1] = STATE(4611),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_RPAREN] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7931),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_EQ] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_PLUS_EQ] = ACTIONS(7929),
    [anon_sym_DASH_EQ] = ACTIONS(7929),
    [anon_sym_STAR_EQ] = ACTIONS(7929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7929),
    [anon_sym_SLASH_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7929),
    [anon_sym_AMP_EQ] = ACTIONS(7929),
    [anon_sym_PERCENT_EQ] = ACTIONS(7929),
    [anon_sym_GT_GT_EQ] = ACTIONS(7929),
    [anon_sym_LT_LT_EQ] = ACTIONS(7929),
    [anon_sym_CARET_EQ] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7931),
    [anon_sym_AMP_AMP] = ACTIONS(7931),
    [anon_sym_LT_LT] = ACTIONS(7931),
    [anon_sym_GT_GT] = ACTIONS(7931),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7931),
    [anon_sym_PLUS] = ACTIONS(7931),
    [anon_sym_SLASH] = ACTIONS(7931),
    [anon_sym_PERCENT] = ACTIONS(7931),
    [sym_comment] = ACTIONS(87),
  },
  [4614] = {
    [aux_sym_argument_list_repeat1] = STATE(4614),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_RPAREN] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(10753),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7927),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_EQ] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_if] = ACTIONS(7925),
    [anon_sym_unless] = ACTIONS(7925),
    [anon_sym_while] = ACTIONS(7925),
    [anon_sym_until] = ACTIONS(7925),
    [anon_sym_rescue] = ACTIONS(7925),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_PLUS_EQ] = ACTIONS(7925),
    [anon_sym_DASH_EQ] = ACTIONS(7925),
    [anon_sym_STAR_EQ] = ACTIONS(7925),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7925),
    [anon_sym_SLASH_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7925),
    [anon_sym_AMP_EQ] = ACTIONS(7925),
    [anon_sym_PERCENT_EQ] = ACTIONS(7925),
    [anon_sym_GT_GT_EQ] = ACTIONS(7925),
    [anon_sym_LT_LT_EQ] = ACTIONS(7925),
    [anon_sym_CARET_EQ] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7927),
    [anon_sym_AMP_AMP] = ACTIONS(7927),
    [anon_sym_LT_LT] = ACTIONS(7927),
    [anon_sym_GT_GT] = ACTIONS(7927),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7927),
    [anon_sym_PLUS] = ACTIONS(7927),
    [anon_sym_SLASH] = ACTIONS(7927),
    [anon_sym_PERCENT] = ACTIONS(7927),
    [sym_comment] = ACTIONS(87),
  },
  [4615] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(3837),
    [sym__binary_star] = ACTIONS(3839),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_RPAREN] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(3841),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(3843),
    [anon_sym_AMP] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(7936),
    [anon_sym_LT] = ACTIONS(3847),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_EQ_GT] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_PLUS_EQ] = ACTIONS(5115),
    [anon_sym_DASH_EQ] = ACTIONS(5115),
    [anon_sym_STAR_EQ] = ACTIONS(5115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5115),
    [anon_sym_SLASH_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5115),
    [anon_sym_AMP_EQ] = ACTIONS(5115),
    [anon_sym_PERCENT_EQ] = ACTIONS(5115),
    [anon_sym_GT_GT_EQ] = ACTIONS(5115),
    [anon_sym_LT_LT_EQ] = ACTIONS(5115),
    [anon_sym_CARET_EQ] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(3849),
    [anon_sym_DOT_DOT] = ACTIONS(3851),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3853),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(3855),
    [anon_sym_AMP_AMP] = ACTIONS(3855),
    [anon_sym_LT_LT] = ACTIONS(3857),
    [anon_sym_GT_GT] = ACTIONS(3857),
    [anon_sym_EQ_EQ] = ACTIONS(3855),
    [anon_sym_BANG_EQ] = ACTIONS(3859),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3859),
    [anon_sym_LT_EQ_GT] = ACTIONS(3859),
    [anon_sym_EQ_TILDE] = ACTIONS(3859),
    [anon_sym_BANG_TILDE] = ACTIONS(3859),
    [anon_sym_LT_EQ] = ACTIONS(3847),
    [anon_sym_GT] = ACTIONS(3847),
    [anon_sym_GT_EQ] = ACTIONS(3861),
    [anon_sym_CARET] = ACTIONS(3841),
    [anon_sym_PLUS] = ACTIONS(3863),
    [anon_sym_SLASH] = ACTIONS(3843),
    [anon_sym_PERCENT] = ACTIONS(3843),
    [sym_comment] = ACTIONS(87),
  },
  [4616] = {
    [aux_sym_exceptions_repeat1] = STATE(7190),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_RPAREN] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6193),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_PLUS_EQ] = ACTIONS(6191),
    [anon_sym_DASH_EQ] = ACTIONS(6191),
    [anon_sym_STAR_EQ] = ACTIONS(6191),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6191),
    [anon_sym_SLASH_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6191),
    [anon_sym_AMP_EQ] = ACTIONS(6191),
    [anon_sym_PERCENT_EQ] = ACTIONS(6191),
    [anon_sym_GT_GT_EQ] = ACTIONS(6191),
    [anon_sym_LT_LT_EQ] = ACTIONS(6191),
    [anon_sym_CARET_EQ] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6193),
    [anon_sym_AMP_AMP] = ACTIONS(6193),
    [anon_sym_LT_LT] = ACTIONS(6193),
    [anon_sym_GT_GT] = ACTIONS(6193),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6193),
    [anon_sym_PLUS] = ACTIONS(6193),
    [anon_sym_SLASH] = ACTIONS(6193),
    [anon_sym_PERCENT] = ACTIONS(6193),
    [sym_comment] = ACTIONS(87),
  },
  [4617] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(3837),
    [sym__binary_star] = ACTIONS(3839),
    [anon_sym_LBRACE] = ACTIONS(6210),
    [anon_sym_RPAREN] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(3841),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(3843),
    [anon_sym_AMP] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(7938),
    [anon_sym_LT] = ACTIONS(3847),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_EQ_GT] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_PLUS_EQ] = ACTIONS(6210),
    [anon_sym_DASH_EQ] = ACTIONS(6210),
    [anon_sym_STAR_EQ] = ACTIONS(6210),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6210),
    [anon_sym_SLASH_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6210),
    [anon_sym_AMP_EQ] = ACTIONS(6210),
    [anon_sym_PERCENT_EQ] = ACTIONS(6210),
    [anon_sym_GT_GT_EQ] = ACTIONS(6210),
    [anon_sym_LT_LT_EQ] = ACTIONS(6210),
    [anon_sym_CARET_EQ] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(3849),
    [anon_sym_DOT_DOT] = ACTIONS(3851),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3853),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(3855),
    [anon_sym_AMP_AMP] = ACTIONS(3855),
    [anon_sym_LT_LT] = ACTIONS(3857),
    [anon_sym_GT_GT] = ACTIONS(3857),
    [anon_sym_EQ_EQ] = ACTIONS(3855),
    [anon_sym_BANG_EQ] = ACTIONS(3859),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3859),
    [anon_sym_LT_EQ_GT] = ACTIONS(3859),
    [anon_sym_EQ_TILDE] = ACTIONS(3859),
    [anon_sym_BANG_TILDE] = ACTIONS(3859),
    [anon_sym_LT_EQ] = ACTIONS(3847),
    [anon_sym_GT] = ACTIONS(3847),
    [anon_sym_GT_EQ] = ACTIONS(3861),
    [anon_sym_CARET] = ACTIONS(3841),
    [anon_sym_PLUS] = ACTIONS(3863),
    [anon_sym_SLASH] = ACTIONS(3843),
    [anon_sym_PERCENT] = ACTIONS(3843),
    [sym_comment] = ACTIONS(87),
  },
  [4618] = {
    [sym_string] = STATE(4618),
    [aux_sym_chained_string_repeat1] = STATE(4618),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(9852),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_RPAREN] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6217),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_EQ] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_do] = ACTIONS(6212),
    [anon_sym_EQ_GT] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_PLUS_EQ] = ACTIONS(6212),
    [anon_sym_DASH_EQ] = ACTIONS(6212),
    [anon_sym_STAR_EQ] = ACTIONS(6212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6212),
    [anon_sym_SLASH_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6212),
    [anon_sym_AMP_EQ] = ACTIONS(6212),
    [anon_sym_PERCENT_EQ] = ACTIONS(6212),
    [anon_sym_GT_GT_EQ] = ACTIONS(6212),
    [anon_sym_LT_LT_EQ] = ACTIONS(6212),
    [anon_sym_CARET_EQ] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6217),
    [anon_sym_AMP_AMP] = ACTIONS(6217),
    [anon_sym_LT_LT] = ACTIONS(6217),
    [anon_sym_GT_GT] = ACTIONS(6217),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6217),
    [anon_sym_PLUS] = ACTIONS(6217),
    [anon_sym_SLASH] = ACTIONS(6217),
    [anon_sym_PERCENT] = ACTIONS(6217),
    [sym_comment] = ACTIONS(87),
  },
  [4619] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(7494),
    [sym__binary_star] = ACTIONS(7496),
    [anon_sym_RPAREN] = ACTIONS(4247),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(7498),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(7496),
    [anon_sym_AMP] = ACTIONS(7500),
    [anon_sym_LT] = ACTIONS(7502),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(7504),
    [anon_sym_DOT_DOT] = ACTIONS(7506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7508),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(7510),
    [anon_sym_AMP_AMP] = ACTIONS(7510),
    [anon_sym_LT_LT] = ACTIONS(7512),
    [anon_sym_GT_GT] = ACTIONS(7512),
    [anon_sym_EQ_EQ] = ACTIONS(7514),
    [anon_sym_BANG_EQ] = ACTIONS(7510),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7510),
    [anon_sym_LT_EQ_GT] = ACTIONS(7510),
    [anon_sym_EQ_TILDE] = ACTIONS(7510),
    [anon_sym_BANG_TILDE] = ACTIONS(7510),
    [anon_sym_LT_EQ] = ACTIONS(7502),
    [anon_sym_GT] = ACTIONS(7502),
    [anon_sym_GT_EQ] = ACTIONS(7516),
    [anon_sym_CARET] = ACTIONS(7518),
    [anon_sym_PLUS] = ACTIONS(7494),
    [anon_sym_SLASH] = ACTIONS(7496),
    [anon_sym_PERCENT] = ACTIONS(7496),
    [sym_comment] = ACTIONS(87),
  },
  [4620] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(7496),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [4621] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(7494),
    [sym__binary_star] = ACTIONS(7496),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(7498),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(7496),
    [anon_sym_AMP] = ACTIONS(7500),
    [anon_sym_LT] = ACTIONS(7502),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(7504),
    [anon_sym_DOT_DOT] = ACTIONS(7506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7508),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(7510),
    [anon_sym_AMP_AMP] = ACTIONS(7510),
    [anon_sym_LT_LT] = ACTIONS(7512),
    [anon_sym_GT_GT] = ACTIONS(7512),
    [anon_sym_EQ_EQ] = ACTIONS(7514),
    [anon_sym_BANG_EQ] = ACTIONS(7510),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7510),
    [anon_sym_LT_EQ_GT] = ACTIONS(7510),
    [anon_sym_EQ_TILDE] = ACTIONS(7510),
    [anon_sym_BANG_TILDE] = ACTIONS(7510),
    [anon_sym_LT_EQ] = ACTIONS(7502),
    [anon_sym_GT] = ACTIONS(7502),
    [anon_sym_GT_EQ] = ACTIONS(7516),
    [anon_sym_CARET] = ACTIONS(7518),
    [anon_sym_PLUS] = ACTIONS(7494),
    [anon_sym_SLASH] = ACTIONS(7496),
    [anon_sym_PERCENT] = ACTIONS(7496),
    [sym_comment] = ACTIONS(87),
  },
  [4622] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7191),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2237),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(2237),
    [sym_assignment] = STATE(7191),
    [sym_operator_assignment] = STATE(7191),
    [sym_conditional] = STATE(7191),
    [sym_range] = STATE(7191),
    [sym_binary] = STATE(7191),
    [sym_unary] = STATE(7191),
    [sym_left_assignment_list] = STATE(2236),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2237),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2237),
    [sym_false] = STATE(2237),
    [sym_nil] = STATE(2237),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2137),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3877),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3731),
    [anon_sym_yield] = ACTIONS(3733),
    [anon_sym_break] = ACTIONS(3735),
    [anon_sym_next] = ACTIONS(3737),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3879),
    [anon_sym_defined_QMARK] = ACTIONS(3881),
    [anon_sym_not] = ACTIONS(3883),
    [anon_sym_BANG] = ACTIONS(3885),
    [anon_sym_TILDE] = ACTIONS(3885),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4623] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7192),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2237),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(2237),
    [sym_assignment] = STATE(7192),
    [sym_operator_assignment] = STATE(7192),
    [sym_conditional] = STATE(7192),
    [sym_range] = STATE(7192),
    [sym_binary] = STATE(7192),
    [sym_unary] = STATE(7192),
    [sym_left_assignment_list] = STATE(2236),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2237),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2237),
    [sym_false] = STATE(2237),
    [sym_nil] = STATE(2237),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2137),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3877),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3731),
    [anon_sym_yield] = ACTIONS(3733),
    [anon_sym_break] = ACTIONS(3735),
    [anon_sym_next] = ACTIONS(3737),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3879),
    [anon_sym_defined_QMARK] = ACTIONS(3881),
    [anon_sym_not] = ACTIONS(3883),
    [anon_sym_BANG] = ACTIONS(3885),
    [anon_sym_TILDE] = ACTIONS(3885),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4624] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7193),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2237),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(2237),
    [sym_assignment] = STATE(7193),
    [sym_operator_assignment] = STATE(7193),
    [sym_conditional] = STATE(7193),
    [sym_range] = STATE(7193),
    [sym_binary] = STATE(7193),
    [sym_unary] = STATE(7193),
    [sym_left_assignment_list] = STATE(2236),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2237),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2237),
    [sym_false] = STATE(2237),
    [sym_nil] = STATE(2237),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2137),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3877),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3731),
    [anon_sym_yield] = ACTIONS(3733),
    [anon_sym_break] = ACTIONS(3735),
    [anon_sym_next] = ACTIONS(3737),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3879),
    [anon_sym_defined_QMARK] = ACTIONS(3881),
    [anon_sym_not] = ACTIONS(3883),
    [anon_sym_BANG] = ACTIONS(3885),
    [anon_sym_TILDE] = ACTIONS(3885),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4625] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7194),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2237),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(2237),
    [sym_assignment] = STATE(7194),
    [sym_operator_assignment] = STATE(7194),
    [sym_conditional] = STATE(7194),
    [sym_range] = STATE(7194),
    [sym_binary] = STATE(7194),
    [sym_unary] = STATE(7194),
    [sym_left_assignment_list] = STATE(2236),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2237),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2237),
    [sym_false] = STATE(2237),
    [sym_nil] = STATE(2237),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2137),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3877),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3731),
    [anon_sym_yield] = ACTIONS(3733),
    [anon_sym_break] = ACTIONS(3735),
    [anon_sym_next] = ACTIONS(3737),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3879),
    [anon_sym_defined_QMARK] = ACTIONS(3881),
    [anon_sym_not] = ACTIONS(3883),
    [anon_sym_BANG] = ACTIONS(3885),
    [anon_sym_TILDE] = ACTIONS(3885),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4626] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7195),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2237),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(2237),
    [sym_assignment] = STATE(7195),
    [sym_operator_assignment] = STATE(7195),
    [sym_conditional] = STATE(7195),
    [sym_range] = STATE(7195),
    [sym_binary] = STATE(7195),
    [sym_unary] = STATE(7195),
    [sym_left_assignment_list] = STATE(2236),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2237),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2237),
    [sym_false] = STATE(2237),
    [sym_nil] = STATE(2237),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2137),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3877),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3731),
    [anon_sym_yield] = ACTIONS(3733),
    [anon_sym_break] = ACTIONS(3735),
    [anon_sym_next] = ACTIONS(3737),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3879),
    [anon_sym_defined_QMARK] = ACTIONS(3881),
    [anon_sym_not] = ACTIONS(3883),
    [anon_sym_BANG] = ACTIONS(3885),
    [anon_sym_TILDE] = ACTIONS(3885),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4627] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(7196),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(7196),
    [sym_operator_assignment] = STATE(7196),
    [sym_conditional] = STATE(7196),
    [sym_range] = STATE(7196),
    [sym_binary] = STATE(7196),
    [sym_unary] = STATE(7196),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4628] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7197),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2237),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(2237),
    [sym_assignment] = STATE(7197),
    [sym_operator_assignment] = STATE(7197),
    [sym_conditional] = STATE(7197),
    [sym_range] = STATE(7197),
    [sym_binary] = STATE(7197),
    [sym_unary] = STATE(7197),
    [sym_left_assignment_list] = STATE(2236),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2237),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2237),
    [sym_false] = STATE(2237),
    [sym_nil] = STATE(2237),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2137),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3877),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3731),
    [anon_sym_yield] = ACTIONS(3733),
    [anon_sym_break] = ACTIONS(3735),
    [anon_sym_next] = ACTIONS(3737),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3879),
    [anon_sym_defined_QMARK] = ACTIONS(3881),
    [anon_sym_not] = ACTIONS(3883),
    [anon_sym_BANG] = ACTIONS(3885),
    [anon_sym_TILDE] = ACTIONS(3885),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4629] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7198),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2237),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(2237),
    [sym_assignment] = STATE(7198),
    [sym_operator_assignment] = STATE(7198),
    [sym_conditional] = STATE(7198),
    [sym_range] = STATE(7198),
    [sym_binary] = STATE(7198),
    [sym_unary] = STATE(7198),
    [sym_left_assignment_list] = STATE(2236),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2237),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2237),
    [sym_false] = STATE(2237),
    [sym_nil] = STATE(2237),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2137),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3877),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3731),
    [anon_sym_yield] = ACTIONS(3733),
    [anon_sym_break] = ACTIONS(3735),
    [anon_sym_next] = ACTIONS(3737),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3879),
    [anon_sym_defined_QMARK] = ACTIONS(3881),
    [anon_sym_not] = ACTIONS(3883),
    [anon_sym_BANG] = ACTIONS(3885),
    [anon_sym_TILDE] = ACTIONS(3885),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4630] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7199),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2237),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(2237),
    [sym_assignment] = STATE(7199),
    [sym_operator_assignment] = STATE(7199),
    [sym_conditional] = STATE(7199),
    [sym_range] = STATE(7199),
    [sym_binary] = STATE(7199),
    [sym_unary] = STATE(7199),
    [sym_left_assignment_list] = STATE(2236),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2237),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2237),
    [sym_false] = STATE(2237),
    [sym_nil] = STATE(2237),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2137),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3877),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3731),
    [anon_sym_yield] = ACTIONS(3733),
    [anon_sym_break] = ACTIONS(3735),
    [anon_sym_next] = ACTIONS(3737),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3879),
    [anon_sym_defined_QMARK] = ACTIONS(3881),
    [anon_sym_not] = ACTIONS(3883),
    [anon_sym_BANG] = ACTIONS(3885),
    [anon_sym_TILDE] = ACTIONS(3885),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4631] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7200),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2237),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(2237),
    [sym_assignment] = STATE(7200),
    [sym_operator_assignment] = STATE(7200),
    [sym_conditional] = STATE(7200),
    [sym_range] = STATE(7200),
    [sym_binary] = STATE(7200),
    [sym_unary] = STATE(7200),
    [sym_left_assignment_list] = STATE(2236),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2237),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2237),
    [sym_false] = STATE(2237),
    [sym_nil] = STATE(2237),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2137),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3877),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3731),
    [anon_sym_yield] = ACTIONS(3733),
    [anon_sym_break] = ACTIONS(3735),
    [anon_sym_next] = ACTIONS(3737),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3879),
    [anon_sym_defined_QMARK] = ACTIONS(3881),
    [anon_sym_not] = ACTIONS(3883),
    [anon_sym_BANG] = ACTIONS(3885),
    [anon_sym_TILDE] = ACTIONS(3885),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4632] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2234),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2237),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(2237),
    [sym_splat_argument] = STATE(6406),
    [sym_assignment] = STATE(2234),
    [sym_operator_assignment] = STATE(2234),
    [sym_conditional] = STATE(2234),
    [sym_range] = STATE(2234),
    [sym_binary] = STATE(2234),
    [sym_unary] = STATE(2234),
    [sym__arg_or_splat_arg] = STATE(6406),
    [sym_left_assignment_list] = STATE(2236),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2237),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2237),
    [sym_false] = STATE(2237),
    [sym_nil] = STATE(2237),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2137),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(3875),
    [sym__unary_minus] = ACTIONS(3877),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3731),
    [anon_sym_yield] = ACTIONS(3733),
    [anon_sym_break] = ACTIONS(3735),
    [anon_sym_next] = ACTIONS(3737),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3879),
    [anon_sym_defined_QMARK] = ACTIONS(3881),
    [anon_sym_not] = ACTIONS(3883),
    [anon_sym_BANG] = ACTIONS(3885),
    [anon_sym_TILDE] = ACTIONS(3885),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4633] = {
    [aux_sym_exceptions_repeat1] = STATE(7201),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_RPAREN] = ACTIONS(9855),
    [anon_sym_COMMA] = ACTIONS(7520),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [4634] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2234),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2237),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(2237),
    [sym_splat_argument] = STATE(7202),
    [sym_assignment] = STATE(2234),
    [sym_operator_assignment] = STATE(2234),
    [sym_conditional] = STATE(2234),
    [sym_range] = STATE(2234),
    [sym_binary] = STATE(2234),
    [sym_unary] = STATE(2234),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(7202),
    [sym_left_assignment_list] = STATE(2236),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2237),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2237),
    [sym_false] = STATE(2237),
    [sym_nil] = STATE(2237),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2137),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(3875),
    [sym__unary_minus] = ACTIONS(3877),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3731),
    [anon_sym_yield] = ACTIONS(3733),
    [anon_sym_break] = ACTIONS(3735),
    [anon_sym_next] = ACTIONS(3737),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3879),
    [anon_sym_defined_QMARK] = ACTIONS(3881),
    [anon_sym_not] = ACTIONS(3883),
    [anon_sym_BANG] = ACTIONS(3885),
    [anon_sym_TILDE] = ACTIONS(3885),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4635] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7203),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2237),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(2237),
    [sym_assignment] = STATE(7203),
    [sym_operator_assignment] = STATE(7203),
    [sym_conditional] = STATE(7203),
    [sym_range] = STATE(7203),
    [sym_binary] = STATE(7203),
    [sym_unary] = STATE(7203),
    [sym_left_assignment_list] = STATE(2236),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2237),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2237),
    [sym_false] = STATE(2237),
    [sym_nil] = STATE(2237),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2137),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3877),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3731),
    [anon_sym_yield] = ACTIONS(3733),
    [anon_sym_break] = ACTIONS(3735),
    [anon_sym_next] = ACTIONS(3737),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3879),
    [anon_sym_defined_QMARK] = ACTIONS(3881),
    [anon_sym_not] = ACTIONS(3883),
    [anon_sym_BANG] = ACTIONS(3885),
    [anon_sym_TILDE] = ACTIONS(3885),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4636] = {
    [sym_method] = STATE(184),
    [sym_singleton_method] = STATE(184),
    [sym_class] = STATE(184),
    [sym_singleton_class] = STATE(184),
    [sym_module] = STATE(184),
    [sym_return] = STATE(184),
    [sym_yield] = STATE(184),
    [sym_break] = STATE(184),
    [sym_next] = STATE(184),
    [sym_while] = STATE(184),
    [sym_until] = STATE(184),
    [sym_for] = STATE(184),
    [sym_case] = STATE(184),
    [sym_if] = STATE(184),
    [sym_unless] = STATE(184),
    [sym_begin] = STATE(184),
    [sym__primary] = STATE(184),
    [sym_parenthesized_statements] = STATE(184),
    [sym_element_reference] = STATE(1598),
    [sym_scope_resolution] = STATE(687),
    [sym_call] = STATE(687),
    [sym_method_call] = STATE(1598),
    [sym_destructured_left_assignment] = STATE(1597),
    [sym_rest_assignment] = STATE(1597),
    [sym__lhs] = STATE(1598),
    [sym__variable] = STATE(687),
    [sym_rational] = STATE(184),
    [sym_true] = STATE(1598),
    [sym_false] = STATE(1598),
    [sym_nil] = STATE(1598),
    [sym_chained_string] = STATE(184),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(184),
    [sym_string_array] = STATE(184),
    [sym_symbol_array] = STATE(184),
    [sym_symbol] = STATE(184),
    [sym_regex] = STATE(184),
    [sym_array] = STATE(184),
    [sym_hash] = STATE(184),
    [sym_lambda] = STATE(184),
    [sym__simple_symbol] = ACTIONS(279),
    [sym__string_start] = ACTIONS(281),
    [sym__symbol_start] = ACTIONS(283),
    [sym__subshell_start] = ACTIONS(285),
    [sym__regex_start] = ACTIONS(287),
    [sym__string_array_start] = ACTIONS(289),
    [sym__symbol_array_start] = ACTIONS(291),
    [sym_heredoc_beginning] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_def] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(475),
    [anon_sym_COLON_COLON] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(249),
    [anon_sym_class] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(307),
    [anon_sym_return] = ACTIONS(309),
    [anon_sym_yield] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_next] = ACTIONS(315),
    [sym_redo] = ACTIONS(317),
    [sym_retry] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(319),
    [anon_sym_unless] = ACTIONS(321),
    [anon_sym_while] = ACTIONS(323),
    [anon_sym_until] = ACTIONS(325),
    [anon_sym_for] = ACTIONS(327),
    [anon_sym_case] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(331),
    [sym_constant] = ACTIONS(1295),
    [sym_identifier] = ACTIONS(1295),
    [sym_instance_variable] = ACTIONS(1297),
    [sym_class_variable] = ACTIONS(1297),
    [sym_global_variable] = ACTIONS(1297),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(317),
    [sym_complex] = ACTIONS(293),
    [sym_super] = ACTIONS(1295),
    [anon_sym_true] = ACTIONS(339),
    [anon_sym_TRUE] = ACTIONS(339),
    [anon_sym_false] = ACTIONS(341),
    [anon_sym_FALSE] = ACTIONS(341),
    [sym_self] = ACTIONS(1295),
    [anon_sym_nil] = ACTIONS(343),
    [anon_sym_NIL] = ACTIONS(343),
    [sym_character] = ACTIONS(293),
    [anon_sym_LBRACK2] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(347),
  },
  [4637] = {
    [anon_sym_DOT] = ACTIONS(6601),
    [anon_sym_LBRACK] = ACTIONS(6601),
    [anon_sym_COLON_COLON2] = ACTIONS(6601),
    [anon_sym_AMP_DOT] = ACTIONS(6601),
    [sym_comment] = ACTIONS(87),
  },
  [4638] = {
    [anon_sym_DOT] = ACTIONS(6605),
    [anon_sym_LBRACK] = ACTIONS(6605),
    [anon_sym_COLON_COLON2] = ACTIONS(6605),
    [anon_sym_AMP_DOT] = ACTIONS(6605),
    [sym_comment] = ACTIONS(87),
  },
  [4639] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1697),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(10756),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [4640] = {
    [aux_sym_string_array_repeat1] = STATE(1699),
    [sym__string_end] = ACTIONS(10756),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(10758),
  },
  [4641] = {
    [anon_sym_DOT] = ACTIONS(6613),
    [anon_sym_LBRACK] = ACTIONS(6613),
    [anon_sym_COLON_COLON2] = ACTIONS(6613),
    [anon_sym_AMP_DOT] = ACTIONS(6613),
    [sym_comment] = ACTIONS(87),
  },
  [4642] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1697),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(10760),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [4643] = {
    [anon_sym_DOT] = ACTIONS(6626),
    [anon_sym_LBRACK] = ACTIONS(6626),
    [anon_sym_COLON_COLON2] = ACTIONS(6626),
    [anon_sym_AMP_DOT] = ACTIONS(6626),
    [sym_comment] = ACTIONS(87),
  },
  [4644] = {
    [anon_sym_DOT] = ACTIONS(6630),
    [anon_sym_LBRACK] = ACTIONS(6630),
    [anon_sym_COLON_COLON2] = ACTIONS(6630),
    [anon_sym_AMP_DOT] = ACTIONS(6630),
    [sym_comment] = ACTIONS(87),
  },
  [4645] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1705),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(10762),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [4646] = {
    [aux_sym_symbol_array_repeat1] = STATE(1707),
    [sym__string_end] = ACTIONS(10762),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(10764),
  },
  [4647] = {
    [anon_sym_DOT] = ACTIONS(6638),
    [anon_sym_LBRACK] = ACTIONS(6638),
    [anon_sym_COLON_COLON2] = ACTIONS(6638),
    [anon_sym_AMP_DOT] = ACTIONS(6638),
    [sym_comment] = ACTIONS(87),
  },
  [4648] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1705),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(10766),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [4649] = {
    [anon_sym_DOT] = ACTIONS(7162),
    [anon_sym_LBRACK] = ACTIONS(7162),
    [anon_sym_COLON_COLON2] = ACTIONS(7162),
    [anon_sym_AMP_DOT] = ACTIONS(7162),
    [sym_comment] = ACTIONS(87),
  },
  [4650] = {
    [anon_sym_DOT] = ACTIONS(10768),
    [anon_sym_COLON_COLON] = ACTIONS(10768),
    [sym_comment] = ACTIONS(87),
  },
  [4651] = {
    [anon_sym_DOT] = ACTIONS(7314),
    [anon_sym_LBRACK] = ACTIONS(7314),
    [anon_sym_COLON_COLON2] = ACTIONS(7314),
    [anon_sym_AMP_DOT] = ACTIONS(7314),
    [sym_comment] = ACTIONS(87),
  },
  [4652] = {
    [anon_sym_DOT] = ACTIONS(7330),
    [anon_sym_LBRACK] = ACTIONS(7330),
    [anon_sym_COLON_COLON2] = ACTIONS(7330),
    [anon_sym_AMP_DOT] = ACTIONS(7330),
    [sym_comment] = ACTIONS(87),
  },
  [4653] = {
    [sym__statements] = STATE(802),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(803),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(804),
    [sym_rescue] = STATE(805),
    [sym__body_statement] = STATE(7211),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10770),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4654] = {
    [sym__statements] = STATE(802),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(803),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(804),
    [sym_rescue] = STATE(805),
    [sym__body_statement] = STATE(7212),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10772),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4655] = {
    [anon_sym_DOT] = ACTIONS(7764),
    [anon_sym_LBRACK] = ACTIONS(7764),
    [anon_sym_COLON_COLON2] = ACTIONS(7764),
    [anon_sym_AMP_DOT] = ACTIONS(7764),
    [sym_comment] = ACTIONS(87),
  },
  [4656] = {
    [anon_sym_DOT] = ACTIONS(7818),
    [anon_sym_LBRACK] = ACTIONS(7818),
    [anon_sym_COLON_COLON2] = ACTIONS(7818),
    [anon_sym_AMP_DOT] = ACTIONS(7818),
    [sym_comment] = ACTIONS(87),
  },
  [4657] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(7577),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [4658] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7213),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2279),
    [sym_scope_resolution] = STATE(2277),
    [sym_call] = STATE(2277),
    [sym_method_call] = STATE(2279),
    [sym_assignment] = STATE(7213),
    [sym_operator_assignment] = STATE(7213),
    [sym_conditional] = STATE(7213),
    [sym_range] = STATE(7213),
    [sym_binary] = STATE(7213),
    [sym_unary] = STATE(7213),
    [sym_left_assignment_list] = STATE(2278),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2277),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2279),
    [sym_false] = STATE(2279),
    [sym_nil] = STATE(2279),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2280),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3931),
    [anon_sym_yield] = ACTIONS(3933),
    [anon_sym_break] = ACTIONS(3935),
    [anon_sym_next] = ACTIONS(3937),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3939),
    [anon_sym_defined_QMARK] = ACTIONS(3941),
    [anon_sym_not] = ACTIONS(3943),
    [anon_sym_BANG] = ACTIONS(3945),
    [anon_sym_TILDE] = ACTIONS(3945),
    [sym_constant] = ACTIONS(3947),
    [sym_identifier] = ACTIONS(3947),
    [sym_instance_variable] = ACTIONS(3949),
    [sym_class_variable] = ACTIONS(3949),
    [sym_global_variable] = ACTIONS(3949),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3947),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3947),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4659] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7214),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2279),
    [sym_scope_resolution] = STATE(2277),
    [sym_call] = STATE(2277),
    [sym_method_call] = STATE(2279),
    [sym_assignment] = STATE(7214),
    [sym_operator_assignment] = STATE(7214),
    [sym_conditional] = STATE(7214),
    [sym_range] = STATE(7214),
    [sym_binary] = STATE(7214),
    [sym_unary] = STATE(7214),
    [sym_left_assignment_list] = STATE(2278),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2277),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2279),
    [sym_false] = STATE(2279),
    [sym_nil] = STATE(2279),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2280),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3931),
    [anon_sym_yield] = ACTIONS(3933),
    [anon_sym_break] = ACTIONS(3935),
    [anon_sym_next] = ACTIONS(3937),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3939),
    [anon_sym_defined_QMARK] = ACTIONS(3941),
    [anon_sym_not] = ACTIONS(3943),
    [anon_sym_BANG] = ACTIONS(3945),
    [anon_sym_TILDE] = ACTIONS(3945),
    [sym_constant] = ACTIONS(3947),
    [sym_identifier] = ACTIONS(3947),
    [sym_instance_variable] = ACTIONS(3949),
    [sym_class_variable] = ACTIONS(3949),
    [sym_global_variable] = ACTIONS(3949),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3947),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3947),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4660] = {
    [anon_sym_COLON] = ACTIONS(10774),
    [sym_comment] = ACTIONS(87),
  },
  [4661] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7216),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2279),
    [sym_scope_resolution] = STATE(2277),
    [sym_call] = STATE(2277),
    [sym_method_call] = STATE(2279),
    [sym_assignment] = STATE(7216),
    [sym_operator_assignment] = STATE(7216),
    [sym_conditional] = STATE(7216),
    [sym_range] = STATE(7216),
    [sym_binary] = STATE(7216),
    [sym_unary] = STATE(7216),
    [sym_left_assignment_list] = STATE(2278),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2277),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2279),
    [sym_false] = STATE(2279),
    [sym_nil] = STATE(2279),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2280),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3931),
    [anon_sym_yield] = ACTIONS(3933),
    [anon_sym_break] = ACTIONS(3935),
    [anon_sym_next] = ACTIONS(3937),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3939),
    [anon_sym_defined_QMARK] = ACTIONS(3941),
    [anon_sym_not] = ACTIONS(3943),
    [anon_sym_BANG] = ACTIONS(3945),
    [anon_sym_TILDE] = ACTIONS(3945),
    [sym_constant] = ACTIONS(3947),
    [sym_identifier] = ACTIONS(3947),
    [sym_instance_variable] = ACTIONS(3949),
    [sym_class_variable] = ACTIONS(3949),
    [sym_global_variable] = ACTIONS(3949),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3947),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3947),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4662] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(10776),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [4663] = {
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(3371),
    [sym__binary_star] = ACTIONS(3373),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(3375),
    [anon_sym_STAR_STAR] = ACTIONS(3373),
    [anon_sym_AMP] = ACTIONS(3377),
    [anon_sym_LT] = ACTIONS(3379),
    [anon_sym_EQ_GT] = ACTIONS(10774),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(3381),
    [anon_sym_DOT_DOT] = ACTIONS(3383),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3385),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(3387),
    [anon_sym_AMP_AMP] = ACTIONS(3387),
    [anon_sym_LT_LT] = ACTIONS(3389),
    [anon_sym_GT_GT] = ACTIONS(3389),
    [anon_sym_EQ_EQ] = ACTIONS(3391),
    [anon_sym_BANG_EQ] = ACTIONS(3387),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3387),
    [anon_sym_LT_EQ_GT] = ACTIONS(3387),
    [anon_sym_EQ_TILDE] = ACTIONS(3387),
    [anon_sym_BANG_TILDE] = ACTIONS(3387),
    [anon_sym_LT_EQ] = ACTIONS(3379),
    [anon_sym_GT] = ACTIONS(3379),
    [anon_sym_GT_EQ] = ACTIONS(3393),
    [anon_sym_CARET] = ACTIONS(3395),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_SLASH] = ACTIONS(3373),
    [anon_sym_PERCENT] = ACTIONS(3373),
    [sym_comment] = ACTIONS(87),
  },
  [4664] = {
    [sym_heredoc_body] = STATE(7218),
    [aux_sym_call_repeat1] = STATE(7218),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [4665] = {
    [sym_heredoc_body] = STATE(7218),
    [aux_sym_call_repeat1] = STATE(7218),
    [aux_sym_argument_list_repeat1] = STATE(7220),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(10778),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [4666] = {
    [sym_string] = STATE(1890),
    [aux_sym_chained_string_repeat1] = STATE(1890),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(10780),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [4667] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(7575),
    [sym__binary_star] = ACTIONS(7577),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(7579),
    [anon_sym_STAR_STAR] = ACTIONS(7577),
    [anon_sym_AMP] = ACTIONS(7581),
    [anon_sym_LT] = ACTIONS(7583),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(7585),
    [anon_sym_DOT_DOT] = ACTIONS(7587),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7589),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(7593),
    [anon_sym_AMP_AMP] = ACTIONS(7593),
    [anon_sym_LT_LT] = ACTIONS(7595),
    [anon_sym_GT_GT] = ACTIONS(7595),
    [anon_sym_EQ_EQ] = ACTIONS(7597),
    [anon_sym_BANG_EQ] = ACTIONS(7593),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7593),
    [anon_sym_LT_EQ_GT] = ACTIONS(7593),
    [anon_sym_EQ_TILDE] = ACTIONS(7593),
    [anon_sym_BANG_TILDE] = ACTIONS(7593),
    [anon_sym_LT_EQ] = ACTIONS(7583),
    [anon_sym_GT] = ACTIONS(7583),
    [anon_sym_GT_EQ] = ACTIONS(7599),
    [anon_sym_CARET] = ACTIONS(7601),
    [anon_sym_PLUS] = ACTIONS(7575),
    [anon_sym_SLASH] = ACTIONS(7577),
    [anon_sym_PERCENT] = ACTIONS(7577),
    [sym_comment] = ACTIONS(87),
  },
  [4668] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7221),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2279),
    [sym_scope_resolution] = STATE(2277),
    [sym_call] = STATE(2277),
    [sym_method_call] = STATE(2279),
    [sym_assignment] = STATE(7221),
    [sym_operator_assignment] = STATE(7221),
    [sym_conditional] = STATE(7221),
    [sym_range] = STATE(7221),
    [sym_binary] = STATE(7221),
    [sym_unary] = STATE(7221),
    [sym_left_assignment_list] = STATE(2278),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2277),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2279),
    [sym_false] = STATE(2279),
    [sym_nil] = STATE(2279),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2280),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3931),
    [anon_sym_yield] = ACTIONS(3933),
    [anon_sym_break] = ACTIONS(3935),
    [anon_sym_next] = ACTIONS(3937),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3939),
    [anon_sym_defined_QMARK] = ACTIONS(3941),
    [anon_sym_not] = ACTIONS(3943),
    [anon_sym_BANG] = ACTIONS(3945),
    [anon_sym_TILDE] = ACTIONS(3945),
    [sym_constant] = ACTIONS(3947),
    [sym_identifier] = ACTIONS(3947),
    [sym_instance_variable] = ACTIONS(3949),
    [sym_class_variable] = ACTIONS(3949),
    [sym_global_variable] = ACTIONS(3949),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3947),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3947),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4669] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7222),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2279),
    [sym_scope_resolution] = STATE(2277),
    [sym_call] = STATE(2277),
    [sym_method_call] = STATE(2279),
    [sym_assignment] = STATE(7222),
    [sym_operator_assignment] = STATE(7222),
    [sym_conditional] = STATE(7222),
    [sym_range] = STATE(7222),
    [sym_binary] = STATE(7222),
    [sym_unary] = STATE(7222),
    [sym_left_assignment_list] = STATE(2278),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2277),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2279),
    [sym_false] = STATE(2279),
    [sym_nil] = STATE(2279),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2280),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3931),
    [anon_sym_yield] = ACTIONS(3933),
    [anon_sym_break] = ACTIONS(3935),
    [anon_sym_next] = ACTIONS(3937),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3939),
    [anon_sym_defined_QMARK] = ACTIONS(3941),
    [anon_sym_not] = ACTIONS(3943),
    [anon_sym_BANG] = ACTIONS(3945),
    [anon_sym_TILDE] = ACTIONS(3945),
    [sym_constant] = ACTIONS(3947),
    [sym_identifier] = ACTIONS(3947),
    [sym_instance_variable] = ACTIONS(3949),
    [sym_class_variable] = ACTIONS(3949),
    [sym_global_variable] = ACTIONS(3949),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3947),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3947),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4670] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7223),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2279),
    [sym_scope_resolution] = STATE(2277),
    [sym_call] = STATE(2277),
    [sym_method_call] = STATE(2279),
    [sym_assignment] = STATE(7223),
    [sym_operator_assignment] = STATE(7223),
    [sym_conditional] = STATE(7223),
    [sym_range] = STATE(7223),
    [sym_binary] = STATE(7223),
    [sym_unary] = STATE(7223),
    [sym_left_assignment_list] = STATE(2278),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2277),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2279),
    [sym_false] = STATE(2279),
    [sym_nil] = STATE(2279),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2280),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3931),
    [anon_sym_yield] = ACTIONS(3933),
    [anon_sym_break] = ACTIONS(3935),
    [anon_sym_next] = ACTIONS(3937),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3939),
    [anon_sym_defined_QMARK] = ACTIONS(3941),
    [anon_sym_not] = ACTIONS(3943),
    [anon_sym_BANG] = ACTIONS(3945),
    [anon_sym_TILDE] = ACTIONS(3945),
    [sym_constant] = ACTIONS(3947),
    [sym_identifier] = ACTIONS(3947),
    [sym_instance_variable] = ACTIONS(3949),
    [sym_class_variable] = ACTIONS(3949),
    [sym_global_variable] = ACTIONS(3949),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3947),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3947),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4671] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7224),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2279),
    [sym_scope_resolution] = STATE(2277),
    [sym_call] = STATE(2277),
    [sym_method_call] = STATE(2279),
    [sym_assignment] = STATE(7224),
    [sym_operator_assignment] = STATE(7224),
    [sym_conditional] = STATE(7224),
    [sym_range] = STATE(7224),
    [sym_binary] = STATE(7224),
    [sym_unary] = STATE(7224),
    [sym_left_assignment_list] = STATE(2278),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2277),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2279),
    [sym_false] = STATE(2279),
    [sym_nil] = STATE(2279),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2280),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3931),
    [anon_sym_yield] = ACTIONS(3933),
    [anon_sym_break] = ACTIONS(3935),
    [anon_sym_next] = ACTIONS(3937),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3939),
    [anon_sym_defined_QMARK] = ACTIONS(3941),
    [anon_sym_not] = ACTIONS(3943),
    [anon_sym_BANG] = ACTIONS(3945),
    [anon_sym_TILDE] = ACTIONS(3945),
    [sym_constant] = ACTIONS(3947),
    [sym_identifier] = ACTIONS(3947),
    [sym_instance_variable] = ACTIONS(3949),
    [sym_class_variable] = ACTIONS(3949),
    [sym_global_variable] = ACTIONS(3949),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3947),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3947),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4672] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7225),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2279),
    [sym_scope_resolution] = STATE(2277),
    [sym_call] = STATE(2277),
    [sym_method_call] = STATE(2279),
    [sym_assignment] = STATE(7225),
    [sym_operator_assignment] = STATE(7225),
    [sym_conditional] = STATE(7225),
    [sym_range] = STATE(7225),
    [sym_binary] = STATE(7225),
    [sym_unary] = STATE(7225),
    [sym_left_assignment_list] = STATE(2278),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2277),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2279),
    [sym_false] = STATE(2279),
    [sym_nil] = STATE(2279),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2280),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3931),
    [anon_sym_yield] = ACTIONS(3933),
    [anon_sym_break] = ACTIONS(3935),
    [anon_sym_next] = ACTIONS(3937),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3939),
    [anon_sym_defined_QMARK] = ACTIONS(3941),
    [anon_sym_not] = ACTIONS(3943),
    [anon_sym_BANG] = ACTIONS(3945),
    [anon_sym_TILDE] = ACTIONS(3945),
    [sym_constant] = ACTIONS(3947),
    [sym_identifier] = ACTIONS(3947),
    [sym_instance_variable] = ACTIONS(3949),
    [sym_class_variable] = ACTIONS(3949),
    [sym_global_variable] = ACTIONS(3949),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3947),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3947),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4673] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(7226),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(7226),
    [sym_operator_assignment] = STATE(7226),
    [sym_conditional] = STATE(7226),
    [sym_range] = STATE(7226),
    [sym_binary] = STATE(7226),
    [sym_unary] = STATE(7226),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4674] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7227),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2279),
    [sym_scope_resolution] = STATE(2277),
    [sym_call] = STATE(2277),
    [sym_method_call] = STATE(2279),
    [sym_assignment] = STATE(7227),
    [sym_operator_assignment] = STATE(7227),
    [sym_conditional] = STATE(7227),
    [sym_range] = STATE(7227),
    [sym_binary] = STATE(7227),
    [sym_unary] = STATE(7227),
    [sym_left_assignment_list] = STATE(2278),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2277),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2279),
    [sym_false] = STATE(2279),
    [sym_nil] = STATE(2279),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2280),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3931),
    [anon_sym_yield] = ACTIONS(3933),
    [anon_sym_break] = ACTIONS(3935),
    [anon_sym_next] = ACTIONS(3937),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3939),
    [anon_sym_defined_QMARK] = ACTIONS(3941),
    [anon_sym_not] = ACTIONS(3943),
    [anon_sym_BANG] = ACTIONS(3945),
    [anon_sym_TILDE] = ACTIONS(3945),
    [sym_constant] = ACTIONS(3947),
    [sym_identifier] = ACTIONS(3947),
    [sym_instance_variable] = ACTIONS(3949),
    [sym_class_variable] = ACTIONS(3949),
    [sym_global_variable] = ACTIONS(3949),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3947),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3947),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4675] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7228),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2279),
    [sym_scope_resolution] = STATE(2277),
    [sym_call] = STATE(2277),
    [sym_method_call] = STATE(2279),
    [sym_assignment] = STATE(7228),
    [sym_operator_assignment] = STATE(7228),
    [sym_conditional] = STATE(7228),
    [sym_range] = STATE(7228),
    [sym_binary] = STATE(7228),
    [sym_unary] = STATE(7228),
    [sym_left_assignment_list] = STATE(2278),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2277),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2279),
    [sym_false] = STATE(2279),
    [sym_nil] = STATE(2279),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2280),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3931),
    [anon_sym_yield] = ACTIONS(3933),
    [anon_sym_break] = ACTIONS(3935),
    [anon_sym_next] = ACTIONS(3937),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3939),
    [anon_sym_defined_QMARK] = ACTIONS(3941),
    [anon_sym_not] = ACTIONS(3943),
    [anon_sym_BANG] = ACTIONS(3945),
    [anon_sym_TILDE] = ACTIONS(3945),
    [sym_constant] = ACTIONS(3947),
    [sym_identifier] = ACTIONS(3947),
    [sym_instance_variable] = ACTIONS(3949),
    [sym_class_variable] = ACTIONS(3949),
    [sym_global_variable] = ACTIONS(3949),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3947),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3947),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4676] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7229),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2279),
    [sym_scope_resolution] = STATE(2277),
    [sym_call] = STATE(2277),
    [sym_method_call] = STATE(2279),
    [sym_assignment] = STATE(7229),
    [sym_operator_assignment] = STATE(7229),
    [sym_conditional] = STATE(7229),
    [sym_range] = STATE(7229),
    [sym_binary] = STATE(7229),
    [sym_unary] = STATE(7229),
    [sym_left_assignment_list] = STATE(2278),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2277),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2279),
    [sym_false] = STATE(2279),
    [sym_nil] = STATE(2279),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2280),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3931),
    [anon_sym_yield] = ACTIONS(3933),
    [anon_sym_break] = ACTIONS(3935),
    [anon_sym_next] = ACTIONS(3937),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3939),
    [anon_sym_defined_QMARK] = ACTIONS(3941),
    [anon_sym_not] = ACTIONS(3943),
    [anon_sym_BANG] = ACTIONS(3945),
    [anon_sym_TILDE] = ACTIONS(3945),
    [sym_constant] = ACTIONS(3947),
    [sym_identifier] = ACTIONS(3947),
    [sym_instance_variable] = ACTIONS(3949),
    [sym_class_variable] = ACTIONS(3949),
    [sym_global_variable] = ACTIONS(3949),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3947),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3947),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4677] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7230),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2279),
    [sym_scope_resolution] = STATE(2277),
    [sym_call] = STATE(2277),
    [sym_method_call] = STATE(2279),
    [sym_assignment] = STATE(7230),
    [sym_operator_assignment] = STATE(7230),
    [sym_conditional] = STATE(7230),
    [sym_range] = STATE(7230),
    [sym_binary] = STATE(7230),
    [sym_unary] = STATE(7230),
    [sym_left_assignment_list] = STATE(2278),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2277),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2279),
    [sym_false] = STATE(2279),
    [sym_nil] = STATE(2279),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2280),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3931),
    [anon_sym_yield] = ACTIONS(3933),
    [anon_sym_break] = ACTIONS(3935),
    [anon_sym_next] = ACTIONS(3937),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3939),
    [anon_sym_defined_QMARK] = ACTIONS(3941),
    [anon_sym_not] = ACTIONS(3943),
    [anon_sym_BANG] = ACTIONS(3945),
    [anon_sym_TILDE] = ACTIONS(3945),
    [sym_constant] = ACTIONS(3947),
    [sym_identifier] = ACTIONS(3947),
    [sym_instance_variable] = ACTIONS(3949),
    [sym_class_variable] = ACTIONS(3949),
    [sym_global_variable] = ACTIONS(3949),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3947),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3947),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4678] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(7238),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(7240),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(7240),
    [sym_assignment] = STATE(7238),
    [sym_operator_assignment] = STATE(7238),
    [sym_conditional] = STATE(7238),
    [sym_range] = STATE(7238),
    [sym_binary] = STATE(7238),
    [sym_unary] = STATE(7238),
    [sym_left_assignment_list] = STATE(7239),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7240),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(7240),
    [sym_false] = STATE(7240),
    [sym_nil] = STATE(7240),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(7241),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(10782),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(10784),
    [anon_sym_yield] = ACTIONS(10786),
    [anon_sym_break] = ACTIONS(10788),
    [anon_sym_next] = ACTIONS(10790),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(10792),
    [anon_sym_defined_QMARK] = ACTIONS(10794),
    [anon_sym_not] = ACTIONS(10796),
    [anon_sym_BANG] = ACTIONS(10798),
    [anon_sym_TILDE] = ACTIONS(10798),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [4679] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(7242),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(7240),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(7240),
    [sym_assignment] = STATE(7242),
    [sym_operator_assignment] = STATE(7242),
    [sym_conditional] = STATE(7242),
    [sym_range] = STATE(7242),
    [sym_binary] = STATE(7242),
    [sym_unary] = STATE(7242),
    [sym_left_assignment_list] = STATE(7239),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7240),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(7240),
    [sym_false] = STATE(7240),
    [sym_nil] = STATE(7240),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(7241),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(10782),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(10784),
    [anon_sym_yield] = ACTIONS(10786),
    [anon_sym_break] = ACTIONS(10788),
    [anon_sym_next] = ACTIONS(10790),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(10792),
    [anon_sym_defined_QMARK] = ACTIONS(10794),
    [anon_sym_not] = ACTIONS(10796),
    [anon_sym_BANG] = ACTIONS(10798),
    [anon_sym_TILDE] = ACTIONS(10798),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [4680] = {
    [anon_sym_COLON] = ACTIONS(10800),
    [sym_comment] = ACTIONS(87),
  },
  [4681] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(7244),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(7240),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(7240),
    [sym_assignment] = STATE(7244),
    [sym_operator_assignment] = STATE(7244),
    [sym_conditional] = STATE(7244),
    [sym_range] = STATE(7244),
    [sym_binary] = STATE(7244),
    [sym_unary] = STATE(7244),
    [sym_left_assignment_list] = STATE(7239),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7240),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(7240),
    [sym_false] = STATE(7240),
    [sym_nil] = STATE(7240),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(7241),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(10782),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(10784),
    [anon_sym_yield] = ACTIONS(10786),
    [anon_sym_break] = ACTIONS(10788),
    [anon_sym_next] = ACTIONS(10790),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(10792),
    [anon_sym_defined_QMARK] = ACTIONS(10794),
    [anon_sym_not] = ACTIONS(10796),
    [anon_sym_BANG] = ACTIONS(10798),
    [anon_sym_TILDE] = ACTIONS(10798),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [4682] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(10802),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [4683] = {
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(3509),
    [sym__binary_star] = ACTIONS(3511),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(3513),
    [anon_sym_STAR_STAR] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(3517),
    [anon_sym_EQ] = ACTIONS(1631),
    [anon_sym_LT] = ACTIONS(3519),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(10800),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_PLUS_EQ] = ACTIONS(1625),
    [anon_sym_DASH_EQ] = ACTIONS(1625),
    [anon_sym_STAR_EQ] = ACTIONS(1625),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1625),
    [anon_sym_SLASH_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1625),
    [anon_sym_AMP_EQ] = ACTIONS(1625),
    [anon_sym_PERCENT_EQ] = ACTIONS(1625),
    [anon_sym_GT_GT_EQ] = ACTIONS(1625),
    [anon_sym_LT_LT_EQ] = ACTIONS(1625),
    [anon_sym_CARET_EQ] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(3521),
    [anon_sym_DOT_DOT] = ACTIONS(3523),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3525),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(3527),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_LT_LT] = ACTIONS(3529),
    [anon_sym_GT_GT] = ACTIONS(3529),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ] = ACTIONS(3531),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3531),
    [anon_sym_LT_EQ_GT] = ACTIONS(3531),
    [anon_sym_EQ_TILDE] = ACTIONS(3531),
    [anon_sym_BANG_TILDE] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3519),
    [anon_sym_GT] = ACTIONS(3519),
    [anon_sym_GT_EQ] = ACTIONS(3533),
    [anon_sym_CARET] = ACTIONS(3513),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_SLASH] = ACTIONS(3515),
    [anon_sym_PERCENT] = ACTIONS(3515),
    [sym_comment] = ACTIONS(87),
  },
  [4684] = {
    [sym_heredoc_body] = STATE(7246),
    [aux_sym_call_repeat1] = STATE(7246),
    [sym__heredoc_body_start] = ACTIONS(6569),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [4685] = {
    [sym_heredoc_body] = STATE(7246),
    [aux_sym_call_repeat1] = STATE(7246),
    [aux_sym_argument_list_repeat1] = STATE(7248),
    [sym__heredoc_body_start] = ACTIONS(6569),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(10804),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [4686] = {
    [sym_string] = STATE(2025),
    [aux_sym_chained_string_repeat1] = STATE(2025),
    [sym__string_start] = ACTIONS(1141),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(10806),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [4687] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7249),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2279),
    [sym_scope_resolution] = STATE(2277),
    [sym_call] = STATE(2277),
    [sym_method_call] = STATE(2279),
    [sym_splat_argument] = STATE(7250),
    [sym_assignment] = STATE(7249),
    [sym_operator_assignment] = STATE(7249),
    [sym_conditional] = STATE(7249),
    [sym_range] = STATE(7249),
    [sym_binary] = STATE(7249),
    [sym_unary] = STATE(7249),
    [sym_right_assignment_list] = STATE(4255),
    [sym__arg_or_splat_arg] = STATE(7250),
    [sym_left_assignment_list] = STATE(2278),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2277),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2279),
    [sym_false] = STATE(2279),
    [sym_nil] = STATE(2279),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2280),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(7569),
    [sym__unary_minus] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3931),
    [anon_sym_yield] = ACTIONS(3933),
    [anon_sym_break] = ACTIONS(3935),
    [anon_sym_next] = ACTIONS(3937),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3939),
    [anon_sym_defined_QMARK] = ACTIONS(3941),
    [anon_sym_not] = ACTIONS(3943),
    [anon_sym_BANG] = ACTIONS(3945),
    [anon_sym_TILDE] = ACTIONS(3945),
    [sym_constant] = ACTIONS(3947),
    [sym_identifier] = ACTIONS(3947),
    [sym_instance_variable] = ACTIONS(3949),
    [sym_class_variable] = ACTIONS(3949),
    [sym_global_variable] = ACTIONS(3949),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3947),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3947),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4688] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7251),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2279),
    [sym_scope_resolution] = STATE(2277),
    [sym_call] = STATE(2277),
    [sym_method_call] = STATE(2279),
    [sym_assignment] = STATE(7251),
    [sym_operator_assignment] = STATE(7251),
    [sym_conditional] = STATE(7251),
    [sym_range] = STATE(7251),
    [sym_binary] = STATE(7251),
    [sym_unary] = STATE(7251),
    [sym_left_assignment_list] = STATE(2278),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2277),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2279),
    [sym_false] = STATE(2279),
    [sym_nil] = STATE(2279),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2280),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3931),
    [anon_sym_yield] = ACTIONS(3933),
    [anon_sym_break] = ACTIONS(3935),
    [anon_sym_next] = ACTIONS(3937),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3939),
    [anon_sym_defined_QMARK] = ACTIONS(3941),
    [anon_sym_not] = ACTIONS(3943),
    [anon_sym_BANG] = ACTIONS(3945),
    [anon_sym_TILDE] = ACTIONS(3945),
    [sym_constant] = ACTIONS(3947),
    [sym_identifier] = ACTIONS(3947),
    [sym_instance_variable] = ACTIONS(3949),
    [sym_class_variable] = ACTIONS(3949),
    [sym_global_variable] = ACTIONS(3949),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3947),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3947),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4689] = {
    [sym_string] = STATE(7252),
    [aux_sym_chained_string_repeat1] = STATE(7252),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [4690] = {
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(7575),
    [sym__binary_star] = ACTIONS(7577),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(7579),
    [anon_sym_STAR_STAR] = ACTIONS(7577),
    [anon_sym_AMP] = ACTIONS(7581),
    [anon_sym_LT] = ACTIONS(7583),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(7585),
    [anon_sym_DOT_DOT] = ACTIONS(7587),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7589),
    [anon_sym_and] = ACTIONS(7591),
    [anon_sym_or] = ACTIONS(7591),
    [anon_sym_PIPE_PIPE] = ACTIONS(7593),
    [anon_sym_AMP_AMP] = ACTIONS(7593),
    [anon_sym_LT_LT] = ACTIONS(7595),
    [anon_sym_GT_GT] = ACTIONS(7595),
    [anon_sym_EQ_EQ] = ACTIONS(7597),
    [anon_sym_BANG_EQ] = ACTIONS(7593),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7593),
    [anon_sym_LT_EQ_GT] = ACTIONS(7593),
    [anon_sym_EQ_TILDE] = ACTIONS(7593),
    [anon_sym_BANG_TILDE] = ACTIONS(7593),
    [anon_sym_LT_EQ] = ACTIONS(7583),
    [anon_sym_GT] = ACTIONS(7583),
    [anon_sym_GT_EQ] = ACTIONS(7599),
    [anon_sym_CARET] = ACTIONS(7601),
    [anon_sym_PLUS] = ACTIONS(7575),
    [anon_sym_SLASH] = ACTIONS(7577),
    [anon_sym_PERCENT] = ACTIONS(7577),
    [sym_comment] = ACTIONS(87),
  },
  [4691] = {
    [sym__heredoc_body_start] = ACTIONS(7876),
    [anon_sym_LBRACE] = ACTIONS(7876),
    [anon_sym_RPAREN] = ACTIONS(7876),
    [anon_sym_DOT] = ACTIONS(7876),
    [anon_sym_COMMA] = ACTIONS(7876),
    [anon_sym_EQ] = ACTIONS(7876),
    [anon_sym_in] = ACTIONS(7876),
    [anon_sym_do] = ACTIONS(7876),
    [anon_sym_LBRACK] = ACTIONS(7876),
    [anon_sym_COLON_COLON2] = ACTIONS(7876),
    [anon_sym_AMP_DOT] = ACTIONS(7876),
    [sym_comment] = ACTIONS(87),
  },
  [4692] = {
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(7575),
    [sym__binary_star] = ACTIONS(7577),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(7579),
    [anon_sym_STAR_STAR] = ACTIONS(7577),
    [anon_sym_AMP] = ACTIONS(7581),
    [anon_sym_LT] = ACTIONS(7583),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(7585),
    [anon_sym_DOT_DOT] = ACTIONS(7587),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7589),
    [anon_sym_and] = ACTIONS(7591),
    [anon_sym_or] = ACTIONS(7591),
    [anon_sym_PIPE_PIPE] = ACTIONS(7593),
    [anon_sym_AMP_AMP] = ACTIONS(7593),
    [anon_sym_LT_LT] = ACTIONS(7595),
    [anon_sym_GT_GT] = ACTIONS(7595),
    [anon_sym_EQ_EQ] = ACTIONS(7597),
    [anon_sym_BANG_EQ] = ACTIONS(7593),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7593),
    [anon_sym_LT_EQ_GT] = ACTIONS(7593),
    [anon_sym_EQ_TILDE] = ACTIONS(7593),
    [anon_sym_BANG_TILDE] = ACTIONS(7593),
    [anon_sym_LT_EQ] = ACTIONS(7583),
    [anon_sym_GT] = ACTIONS(7583),
    [anon_sym_GT_EQ] = ACTIONS(7599),
    [anon_sym_CARET] = ACTIONS(7601),
    [anon_sym_PLUS] = ACTIONS(7575),
    [anon_sym_SLASH] = ACTIONS(7577),
    [anon_sym_PERCENT] = ACTIONS(7577),
    [sym_comment] = ACTIONS(87),
  },
  [4693] = {
    [sym__heredoc_body_start] = ACTIONS(3235),
    [anon_sym_LBRACE] = ACTIONS(3235),
    [anon_sym_RPAREN] = ACTIONS(3235),
    [anon_sym_DOT] = ACTIONS(3235),
    [anon_sym_COMMA] = ACTIONS(3235),
    [anon_sym_EQ] = ACTIONS(3235),
    [anon_sym_in] = ACTIONS(3235),
    [anon_sym_do] = ACTIONS(3235),
    [anon_sym_LBRACK] = ACTIONS(3235),
    [anon_sym_COLON_COLON2] = ACTIONS(3235),
    [anon_sym_AMP_DOT] = ACTIONS(3235),
    [sym_comment] = ACTIONS(87),
  },
  [4694] = {
    [sym_interpolation] = STATE(1787),
    [aux_sym_heredoc_body_repeat1] = STATE(1787),
    [sym__heredoc_content] = ACTIONS(3237),
    [sym_heredoc_end] = ACTIONS(10808),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(3237),
  },
  [4695] = {
    [sym_heredoc_body] = STATE(4695),
    [aux_sym_call_repeat1] = STATE(4695),
    [sym__heredoc_body_start] = ACTIONS(10810),
    [anon_sym_DOT] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [4696] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(787),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(567),
    [sym_scope_resolution] = STATE(562),
    [sym_call] = STATE(562),
    [sym_method_call] = STATE(567),
    [sym__argument] = STATE(6088),
    [sym_splat_argument] = STATE(6088),
    [sym_hash_splat_argument] = STATE(6088),
    [sym_block_argument] = STATE(6088),
    [sym_assignment] = STATE(787),
    [sym_operator_assignment] = STATE(787),
    [sym_conditional] = STATE(787),
    [sym_range] = STATE(787),
    [sym_binary] = STATE(787),
    [sym_unary] = STATE(787),
    [sym_left_assignment_list] = STATE(566),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(567),
    [sym__variable] = STATE(562),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(567),
    [sym_false] = STATE(567),
    [sym_nil] = STATE(567),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(791),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(6088),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1447),
    [sym__splat_star] = ACTIONS(1449),
    [sym__unary_minus] = ACTIONS(1049),
    [sym__identifier_hash_key] = ACTIONS(1451),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1453),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1459),
    [sym_identifier] = ACTIONS(1459),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4697] = {
    [sym_heredoc_body] = STATE(4695),
    [aux_sym_call_repeat1] = STATE(4695),
    [sym__heredoc_body_start] = ACTIONS(3959),
    [anon_sym_DOT] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [4698] = {
    [aux_sym_argument_list_repeat1] = STATE(4698),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7925),
    [anon_sym_COMMA] = ACTIONS(10813),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [4699] = {
    [anon_sym_DOT] = ACTIONS(8098),
    [anon_sym_LBRACK] = ACTIONS(8098),
    [anon_sym_COLON_COLON2] = ACTIONS(8098),
    [anon_sym_AMP_DOT] = ACTIONS(8098),
    [sym_comment] = ACTIONS(87),
  },
  [4700] = {
    [anon_sym_end] = ACTIONS(10816),
    [sym_comment] = ACTIONS(87),
  },
  [4701] = {
    [anon_sym_DOT] = ACTIONS(8284),
    [anon_sym_LBRACK] = ACTIONS(8284),
    [anon_sym_COLON_COLON2] = ACTIONS(8284),
    [anon_sym_AMP_DOT] = ACTIONS(8284),
    [sym_comment] = ACTIONS(87),
  },
  [4702] = {
    [anon_sym_end] = ACTIONS(10818),
    [sym_comment] = ACTIONS(87),
  },
  [4703] = {
    [anon_sym_DOT] = ACTIONS(8344),
    [anon_sym_LBRACK] = ACTIONS(8344),
    [anon_sym_COLON_COLON2] = ACTIONS(8344),
    [anon_sym_AMP_DOT] = ACTIONS(8344),
    [sym_comment] = ACTIONS(87),
  },
  [4704] = {
    [anon_sym_end] = ACTIONS(10820),
    [sym_comment] = ACTIONS(87),
  },
  [4705] = {
    [anon_sym_DOT] = ACTIONS(8420),
    [anon_sym_LBRACK] = ACTIONS(8420),
    [anon_sym_COLON_COLON2] = ACTIONS(8420),
    [anon_sym_AMP_DOT] = ACTIONS(8420),
    [sym_comment] = ACTIONS(87),
  },
  [4706] = {
    [anon_sym_end] = ACTIONS(10822),
    [sym_comment] = ACTIONS(87),
  },
  [4707] = {
    [sym__statements] = STATE(7259),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10824),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4708] = {
    [anon_sym_DOT] = ACTIONS(8581),
    [anon_sym_LBRACK] = ACTIONS(8581),
    [anon_sym_COLON_COLON2] = ACTIONS(8581),
    [anon_sym_AMP_DOT] = ACTIONS(8581),
    [sym_comment] = ACTIONS(87),
  },
  [4709] = {
    [anon_sym_end] = ACTIONS(10826),
    [sym_comment] = ACTIONS(87),
  },
  [4710] = {
    [sym_when] = STATE(7262),
    [sym_else] = STATE(7261),
    [aux_sym_case_repeat1] = STATE(2987),
    [aux_sym_case_repeat2] = STATE(7262),
    [anon_sym_SEMI] = ACTIONS(4995),
    [anon_sym_end] = ACTIONS(10826),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [4711] = {
    [sym_when] = STATE(2988),
    [sym_else] = STATE(7261),
    [aux_sym_case_repeat2] = STATE(2988),
    [anon_sym_end] = ACTIONS(10826),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [4712] = {
    [anon_sym_DOT] = ACTIONS(9185),
    [anon_sym_LBRACK] = ACTIONS(9185),
    [anon_sym_COLON_COLON2] = ACTIONS(9185),
    [anon_sym_AMP_DOT] = ACTIONS(9185),
    [sym_comment] = ACTIONS(87),
  },
  [4713] = {
    [anon_sym_end] = ACTIONS(10828),
    [sym_comment] = ACTIONS(87),
  },
  [4714] = {
    [sym_ensure] = STATE(7264),
    [anon_sym_end] = ACTIONS(10828),
    [anon_sym_ensure] = ACTIONS(2169),
    [sym_comment] = ACTIONS(87),
  },
  [4715] = {
    [anon_sym_LBRACE] = ACTIONS(9426),
    [anon_sym_RPAREN] = ACTIONS(9426),
    [anon_sym_DOT] = ACTIONS(9426),
    [anon_sym_COMMA] = ACTIONS(9426),
    [anon_sym_PIPE] = ACTIONS(9426),
    [anon_sym_SEMI] = ACTIONS(9426),
    [anon_sym_EQ] = ACTIONS(9426),
    [anon_sym_in] = ACTIONS(9426),
    [anon_sym_do] = ACTIONS(9426),
    [anon_sym_LBRACK] = ACTIONS(9426),
    [anon_sym_COLON_COLON2] = ACTIONS(9426),
    [anon_sym_AMP_DOT] = ACTIONS(9426),
    [sym_comment] = ACTIONS(87),
  },
  [4716] = {
    [anon_sym_RBRACE] = ACTIONS(10830),
    [sym_comment] = ACTIONS(87),
  },
  [4717] = {
    [anon_sym_LBRACE] = ACTIONS(9446),
    [anon_sym_RPAREN] = ACTIONS(9446),
    [anon_sym_DOT] = ACTIONS(9446),
    [anon_sym_COMMA] = ACTIONS(9446),
    [anon_sym_PIPE] = ACTIONS(9446),
    [anon_sym_SEMI] = ACTIONS(9446),
    [anon_sym_EQ] = ACTIONS(9446),
    [anon_sym_in] = ACTIONS(9446),
    [anon_sym_do] = ACTIONS(9446),
    [anon_sym_LBRACK] = ACTIONS(9446),
    [anon_sym_COLON_COLON2] = ACTIONS(9446),
    [anon_sym_AMP_DOT] = ACTIONS(9446),
    [sym_comment] = ACTIONS(87),
  },
  [4718] = {
    [anon_sym_end] = ACTIONS(10832),
    [sym_comment] = ACTIONS(87),
  },
  [4719] = {
    [sym__statements] = STATE(7267),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10834),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4720] = {
    [sym__statements] = STATE(7267),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_heredoc_body] = STATE(7268),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [sym__terminator] = STATE(7268),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__line_break] = ACTIONS(10836),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(10836),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10834),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4721] = {
    [sym__simple_symbol] = ACTIONS(4285),
    [sym__string_start] = ACTIONS(4285),
    [sym__symbol_start] = ACTIONS(4285),
    [sym__subshell_start] = ACTIONS(4285),
    [sym__regex_start] = ACTIONS(4285),
    [sym__string_array_start] = ACTIONS(4285),
    [sym__symbol_array_start] = ACTIONS(4285),
    [sym_heredoc_beginning] = ACTIONS(4285),
    [sym__block_ampersand] = ACTIONS(4285),
    [sym__splat_star] = ACTIONS(4285),
    [sym__unary_minus] = ACTIONS(4285),
    [sym__identifier_hash_key] = ACTIONS(4285),
    [anon_sym_LBRACE] = ACTIONS(4285),
    [anon_sym_def] = ACTIONS(4287),
    [anon_sym_LPAREN] = ACTIONS(4287),
    [anon_sym_RPAREN] = ACTIONS(4285),
    [anon_sym_DOT] = ACTIONS(4285),
    [anon_sym_COLON_COLON] = ACTIONS(4287),
    [anon_sym_COMMA] = ACTIONS(4285),
    [anon_sym_STAR] = ACTIONS(4287),
    [anon_sym_STAR_STAR] = ACTIONS(4285),
    [anon_sym_EQ] = ACTIONS(4285),
    [anon_sym_class] = ACTIONS(4287),
    [anon_sym_module] = ACTIONS(4287),
    [anon_sym_return] = ACTIONS(4287),
    [anon_sym_yield] = ACTIONS(4287),
    [anon_sym_break] = ACTIONS(4287),
    [anon_sym_next] = ACTIONS(4287),
    [sym_redo] = ACTIONS(4287),
    [sym_retry] = ACTIONS(4287),
    [anon_sym_if] = ACTIONS(4287),
    [anon_sym_unless] = ACTIONS(4287),
    [anon_sym_while] = ACTIONS(4287),
    [anon_sym_until] = ACTIONS(4287),
    [anon_sym_for] = ACTIONS(4287),
    [anon_sym_in] = ACTIONS(4287),
    [anon_sym_do] = ACTIONS(4287),
    [anon_sym_case] = ACTIONS(4287),
    [anon_sym_begin] = ACTIONS(4287),
    [anon_sym_LBRACK] = ACTIONS(4285),
    [anon_sym_COLON_COLON2] = ACTIONS(4285),
    [anon_sym_AMP_DOT] = ACTIONS(4285),
    [anon_sym_LPAREN2] = ACTIONS(4285),
    [anon_sym_PLUS] = ACTIONS(4287),
    [anon_sym_defined_QMARK] = ACTIONS(4285),
    [anon_sym_not] = ACTIONS(4287),
    [anon_sym_BANG] = ACTIONS(4285),
    [anon_sym_TILDE] = ACTIONS(4285),
    [sym_constant] = ACTIONS(4287),
    [sym_identifier] = ACTIONS(4287),
    [sym_instance_variable] = ACTIONS(4285),
    [sym_class_variable] = ACTIONS(4285),
    [sym_global_variable] = ACTIONS(4285),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4287),
    [sym_float] = ACTIONS(4287),
    [sym_complex] = ACTIONS(4285),
    [sym_super] = ACTIONS(4287),
    [anon_sym_true] = ACTIONS(4287),
    [anon_sym_TRUE] = ACTIONS(4287),
    [anon_sym_false] = ACTIONS(4287),
    [anon_sym_FALSE] = ACTIONS(4287),
    [sym_self] = ACTIONS(4287),
    [anon_sym_nil] = ACTIONS(4287),
    [anon_sym_NIL] = ACTIONS(4287),
    [sym_character] = ACTIONS(4285),
    [anon_sym_LBRACK2] = ACTIONS(4287),
    [anon_sym_DASH_GT] = ACTIONS(4285),
  },
  [4722] = {
    [anon_sym_RPAREN] = ACTIONS(10838),
    [sym_comment] = ACTIONS(87),
  },
  [4723] = {
    [sym__simple_symbol] = ACTIONS(9679),
    [sym__string_start] = ACTIONS(9679),
    [sym__symbol_start] = ACTIONS(9679),
    [sym__subshell_start] = ACTIONS(9679),
    [sym__regex_start] = ACTIONS(9679),
    [sym__string_array_start] = ACTIONS(9679),
    [sym__symbol_array_start] = ACTIONS(9679),
    [sym_heredoc_beginning] = ACTIONS(9679),
    [sym__block_ampersand] = ACTIONS(9679),
    [sym__splat_star] = ACTIONS(9679),
    [sym__unary_minus] = ACTIONS(9679),
    [sym__identifier_hash_key] = ACTIONS(9679),
    [anon_sym_LBRACE] = ACTIONS(9679),
    [anon_sym_def] = ACTIONS(9681),
    [anon_sym_LPAREN] = ACTIONS(9681),
    [anon_sym_RPAREN] = ACTIONS(9679),
    [anon_sym_DOT] = ACTIONS(9679),
    [anon_sym_COLON_COLON] = ACTIONS(9681),
    [anon_sym_COMMA] = ACTIONS(9679),
    [anon_sym_STAR] = ACTIONS(9681),
    [anon_sym_STAR_STAR] = ACTIONS(9679),
    [anon_sym_EQ] = ACTIONS(9679),
    [anon_sym_class] = ACTIONS(9681),
    [anon_sym_module] = ACTIONS(9681),
    [anon_sym_return] = ACTIONS(9681),
    [anon_sym_yield] = ACTIONS(9681),
    [anon_sym_break] = ACTIONS(9681),
    [anon_sym_next] = ACTIONS(9681),
    [sym_redo] = ACTIONS(9681),
    [sym_retry] = ACTIONS(9681),
    [anon_sym_if] = ACTIONS(9681),
    [anon_sym_unless] = ACTIONS(9681),
    [anon_sym_while] = ACTIONS(9681),
    [anon_sym_until] = ACTIONS(9681),
    [anon_sym_for] = ACTIONS(9681),
    [anon_sym_in] = ACTIONS(9681),
    [anon_sym_do] = ACTIONS(9681),
    [anon_sym_case] = ACTIONS(9681),
    [anon_sym_begin] = ACTIONS(9681),
    [anon_sym_LBRACK] = ACTIONS(9679),
    [anon_sym_COLON_COLON2] = ACTIONS(9679),
    [anon_sym_AMP_DOT] = ACTIONS(9679),
    [anon_sym_LPAREN2] = ACTIONS(9679),
    [anon_sym_PLUS] = ACTIONS(9681),
    [anon_sym_defined_QMARK] = ACTIONS(9679),
    [anon_sym_not] = ACTIONS(9681),
    [anon_sym_BANG] = ACTIONS(9679),
    [anon_sym_TILDE] = ACTIONS(9679),
    [sym_constant] = ACTIONS(9681),
    [sym_identifier] = ACTIONS(9681),
    [sym_instance_variable] = ACTIONS(9679),
    [sym_class_variable] = ACTIONS(9679),
    [sym_global_variable] = ACTIONS(9679),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(9681),
    [sym_float] = ACTIONS(9681),
    [sym_complex] = ACTIONS(9679),
    [sym_super] = ACTIONS(9681),
    [anon_sym_true] = ACTIONS(9681),
    [anon_sym_TRUE] = ACTIONS(9681),
    [anon_sym_false] = ACTIONS(9681),
    [anon_sym_FALSE] = ACTIONS(9681),
    [sym_self] = ACTIONS(9681),
    [anon_sym_nil] = ACTIONS(9681),
    [anon_sym_NIL] = ACTIONS(9681),
    [sym_character] = ACTIONS(9679),
    [anon_sym_LBRACK2] = ACTIONS(9681),
    [anon_sym_DASH_GT] = ACTIONS(9679),
  },
  [4724] = {
    [anon_sym_RPAREN] = ACTIONS(9686),
    [anon_sym_DOT] = ACTIONS(9686),
    [anon_sym_COMMA] = ACTIONS(9686),
    [anon_sym_EQ] = ACTIONS(9686),
    [anon_sym_in] = ACTIONS(9686),
    [anon_sym_LBRACK] = ACTIONS(9686),
    [anon_sym_COLON_COLON2] = ACTIONS(9686),
    [anon_sym_AMP_DOT] = ACTIONS(9686),
    [sym_comment] = ACTIONS(87),
  },
  [4725] = {
    [sym__string_start] = ACTIONS(835),
    [sym__heredoc_body_start] = ACTIONS(835),
    [sym__binary_minus] = ACTIONS(835),
    [sym__binary_star] = ACTIONS(835),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(835),
    [anon_sym_DOT] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(835),
    [anon_sym_PIPE] = ACTIONS(837),
    [anon_sym_STAR_STAR] = ACTIONS(835),
    [anon_sym_AMP] = ACTIONS(837),
    [anon_sym_EQ] = ACTIONS(837),
    [anon_sym_LT] = ACTIONS(837),
    [anon_sym_do] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_COLON_COLON2] = ACTIONS(835),
    [anon_sym_AMP_DOT] = ACTIONS(835),
    [anon_sym_QMARK] = ACTIONS(835),
    [anon_sym_COLON2] = ACTIONS(837),
    [anon_sym_DOT_DOT] = ACTIONS(837),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(835),
    [anon_sym_and] = ACTIONS(835),
    [anon_sym_or] = ACTIONS(835),
    [anon_sym_PIPE_PIPE] = ACTIONS(835),
    [anon_sym_AMP_AMP] = ACTIONS(835),
    [anon_sym_LT_LT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(835),
    [anon_sym_EQ_EQ] = ACTIONS(837),
    [anon_sym_BANG_EQ] = ACTIONS(835),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(835),
    [anon_sym_LT_EQ_GT] = ACTIONS(835),
    [anon_sym_EQ_TILDE] = ACTIONS(835),
    [anon_sym_BANG_TILDE] = ACTIONS(835),
    [anon_sym_LT_EQ] = ACTIONS(837),
    [anon_sym_GT] = ACTIONS(837),
    [anon_sym_GT_EQ] = ACTIONS(835),
    [anon_sym_CARET] = ACTIONS(835),
    [anon_sym_PLUS] = ACTIONS(835),
    [anon_sym_SLASH] = ACTIONS(835),
    [anon_sym_PERCENT] = ACTIONS(835),
    [sym_comment] = ACTIONS(87),
  },
  [4726] = {
    [sym__string_end] = ACTIONS(10840),
    [sym_comment] = ACTIONS(87),
  },
  [4727] = {
    [sym__heredoc_body_start] = ACTIONS(887),
    [sym__binary_minus] = ACTIONS(887),
    [sym__binary_star] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(887),
    [anon_sym_RPAREN] = ACTIONS(887),
    [anon_sym_DOT] = ACTIONS(889),
    [anon_sym_COMMA] = ACTIONS(887),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_STAR_STAR] = ACTIONS(887),
    [anon_sym_AMP] = ACTIONS(889),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_LT] = ACTIONS(889),
    [anon_sym_do] = ACTIONS(887),
    [anon_sym_LBRACK] = ACTIONS(887),
    [anon_sym_COLON_COLON2] = ACTIONS(887),
    [anon_sym_AMP_DOT] = ACTIONS(887),
    [anon_sym_QMARK] = ACTIONS(887),
    [anon_sym_DOT_DOT] = ACTIONS(889),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(887),
    [anon_sym_and] = ACTIONS(887),
    [anon_sym_or] = ACTIONS(887),
    [anon_sym_PIPE_PIPE] = ACTIONS(887),
    [anon_sym_AMP_AMP] = ACTIONS(887),
    [anon_sym_LT_LT] = ACTIONS(887),
    [anon_sym_GT_GT] = ACTIONS(887),
    [anon_sym_EQ_EQ] = ACTIONS(889),
    [anon_sym_BANG_EQ] = ACTIONS(887),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(887),
    [anon_sym_LT_EQ_GT] = ACTIONS(887),
    [anon_sym_EQ_TILDE] = ACTIONS(887),
    [anon_sym_BANG_TILDE] = ACTIONS(887),
    [anon_sym_LT_EQ] = ACTIONS(889),
    [anon_sym_GT] = ACTIONS(889),
    [anon_sym_GT_EQ] = ACTIONS(887),
    [anon_sym_CARET] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_SLASH] = ACTIONS(887),
    [anon_sym_PERCENT] = ACTIONS(887),
    [sym_comment] = ACTIONS(87),
  },
  [4728] = {
    [sym__string_end] = ACTIONS(10842),
    [sym_comment] = ACTIONS(87),
  },
  [4729] = {
    [sym__heredoc_body_start] = ACTIONS(893),
    [sym__binary_minus] = ACTIONS(893),
    [sym__binary_star] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(893),
    [anon_sym_RPAREN] = ACTIONS(893),
    [anon_sym_DOT] = ACTIONS(895),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_PIPE] = ACTIONS(895),
    [anon_sym_STAR_STAR] = ACTIONS(893),
    [anon_sym_AMP] = ACTIONS(895),
    [anon_sym_EQ] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(895),
    [anon_sym_do] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(893),
    [anon_sym_COLON_COLON2] = ACTIONS(893),
    [anon_sym_AMP_DOT] = ACTIONS(893),
    [anon_sym_QMARK] = ACTIONS(893),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(893),
    [anon_sym_and] = ACTIONS(893),
    [anon_sym_or] = ACTIONS(893),
    [anon_sym_PIPE_PIPE] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(893),
    [anon_sym_LT_LT] = ACTIONS(893),
    [anon_sym_GT_GT] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(895),
    [anon_sym_BANG_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_LT_EQ_GT] = ACTIONS(893),
    [anon_sym_EQ_TILDE] = ACTIONS(893),
    [anon_sym_BANG_TILDE] = ACTIONS(893),
    [anon_sym_LT_EQ] = ACTIONS(895),
    [anon_sym_GT] = ACTIONS(895),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_CARET] = ACTIONS(893),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_SLASH] = ACTIONS(893),
    [anon_sym_PERCENT] = ACTIONS(893),
    [sym_comment] = ACTIONS(87),
  },
  [4730] = {
    [sym__string_end] = ACTIONS(10844),
    [sym_comment] = ACTIONS(87),
  },
  [4731] = {
    [sym__heredoc_body_start] = ACTIONS(899),
    [sym__binary_minus] = ACTIONS(899),
    [sym__binary_star] = ACTIONS(899),
    [anon_sym_LBRACE] = ACTIONS(899),
    [anon_sym_RPAREN] = ACTIONS(899),
    [anon_sym_DOT] = ACTIONS(901),
    [anon_sym_COMMA] = ACTIONS(899),
    [anon_sym_PIPE] = ACTIONS(901),
    [anon_sym_STAR_STAR] = ACTIONS(899),
    [anon_sym_AMP] = ACTIONS(901),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_LT] = ACTIONS(901),
    [anon_sym_do] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(899),
    [anon_sym_COLON_COLON2] = ACTIONS(899),
    [anon_sym_AMP_DOT] = ACTIONS(899),
    [anon_sym_QMARK] = ACTIONS(899),
    [anon_sym_DOT_DOT] = ACTIONS(901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(899),
    [anon_sym_and] = ACTIONS(899),
    [anon_sym_or] = ACTIONS(899),
    [anon_sym_PIPE_PIPE] = ACTIONS(899),
    [anon_sym_AMP_AMP] = ACTIONS(899),
    [anon_sym_LT_LT] = ACTIONS(899),
    [anon_sym_GT_GT] = ACTIONS(899),
    [anon_sym_EQ_EQ] = ACTIONS(901),
    [anon_sym_BANG_EQ] = ACTIONS(899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(899),
    [anon_sym_LT_EQ_GT] = ACTIONS(899),
    [anon_sym_EQ_TILDE] = ACTIONS(899),
    [anon_sym_BANG_TILDE] = ACTIONS(899),
    [anon_sym_LT_EQ] = ACTIONS(901),
    [anon_sym_GT] = ACTIONS(901),
    [anon_sym_GT_EQ] = ACTIONS(899),
    [anon_sym_CARET] = ACTIONS(899),
    [anon_sym_PLUS] = ACTIONS(899),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [sym_comment] = ACTIONS(87),
  },
  [4732] = {
    [sym__string_end] = ACTIONS(10846),
    [sym_comment] = ACTIONS(87),
  },
  [4733] = {
    [sym__heredoc_body_start] = ACTIONS(905),
    [sym__binary_minus] = ACTIONS(905),
    [sym__binary_star] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(905),
    [anon_sym_DOT] = ACTIONS(907),
    [anon_sym_COMMA] = ACTIONS(905),
    [anon_sym_PIPE] = ACTIONS(907),
    [anon_sym_STAR_STAR] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(907),
    [anon_sym_LT] = ACTIONS(907),
    [anon_sym_do] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_COLON_COLON2] = ACTIONS(905),
    [anon_sym_AMP_DOT] = ACTIONS(905),
    [anon_sym_QMARK] = ACTIONS(905),
    [anon_sym_DOT_DOT] = ACTIONS(907),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(905),
    [anon_sym_and] = ACTIONS(905),
    [anon_sym_or] = ACTIONS(905),
    [anon_sym_PIPE_PIPE] = ACTIONS(905),
    [anon_sym_AMP_AMP] = ACTIONS(905),
    [anon_sym_LT_LT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(905),
    [anon_sym_EQ_EQ] = ACTIONS(907),
    [anon_sym_BANG_EQ] = ACTIONS(905),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(905),
    [anon_sym_LT_EQ_GT] = ACTIONS(905),
    [anon_sym_EQ_TILDE] = ACTIONS(905),
    [anon_sym_BANG_TILDE] = ACTIONS(905),
    [anon_sym_LT_EQ] = ACTIONS(907),
    [anon_sym_GT] = ACTIONS(907),
    [anon_sym_GT_EQ] = ACTIONS(905),
    [anon_sym_CARET] = ACTIONS(905),
    [anon_sym_PLUS] = ACTIONS(905),
    [anon_sym_SLASH] = ACTIONS(905),
    [anon_sym_PERCENT] = ACTIONS(905),
    [sym_comment] = ACTIONS(87),
  },
  [4734] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(7276),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(10848),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(10850),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [4735] = {
    [aux_sym_string_array_repeat1] = STATE(7279),
    [sym__string_end] = ACTIONS(10852),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(10854),
  },
  [4736] = {
    [sym__heredoc_body_start] = ACTIONS(923),
    [sym__binary_minus] = ACTIONS(923),
    [sym__binary_star] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(923),
    [anon_sym_RPAREN] = ACTIONS(923),
    [anon_sym_DOT] = ACTIONS(925),
    [anon_sym_COMMA] = ACTIONS(923),
    [anon_sym_PIPE] = ACTIONS(925),
    [anon_sym_STAR_STAR] = ACTIONS(923),
    [anon_sym_AMP] = ACTIONS(925),
    [anon_sym_EQ] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(925),
    [anon_sym_do] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(923),
    [anon_sym_COLON_COLON2] = ACTIONS(923),
    [anon_sym_AMP_DOT] = ACTIONS(923),
    [anon_sym_QMARK] = ACTIONS(923),
    [anon_sym_DOT_DOT] = ACTIONS(925),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(923),
    [anon_sym_and] = ACTIONS(923),
    [anon_sym_or] = ACTIONS(923),
    [anon_sym_PIPE_PIPE] = ACTIONS(923),
    [anon_sym_AMP_AMP] = ACTIONS(923),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_EQ_EQ] = ACTIONS(925),
    [anon_sym_BANG_EQ] = ACTIONS(923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(923),
    [anon_sym_LT_EQ_GT] = ACTIONS(923),
    [anon_sym_EQ_TILDE] = ACTIONS(923),
    [anon_sym_BANG_TILDE] = ACTIONS(923),
    [anon_sym_LT_EQ] = ACTIONS(925),
    [anon_sym_GT] = ACTIONS(925),
    [anon_sym_GT_EQ] = ACTIONS(923),
    [anon_sym_CARET] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(923),
    [anon_sym_SLASH] = ACTIONS(923),
    [anon_sym_PERCENT] = ACTIONS(923),
    [sym_comment] = ACTIONS(87),
  },
  [4737] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(7282),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(10856),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(10858),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [4738] = {
    [aux_sym_symbol_array_repeat1] = STATE(7285),
    [sym__string_end] = ACTIONS(10860),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(10862),
  },
  [4739] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(7713),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [4740] = {
    [sym__heredoc_body_start] = ACTIONS(993),
    [sym__binary_minus] = ACTIONS(993),
    [sym__binary_star] = ACTIONS(993),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_RPAREN] = ACTIONS(993),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(993),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_STAR_STAR] = ACTIONS(993),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_EQ] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(995),
    [anon_sym_do] = ACTIONS(993),
    [anon_sym_LBRACK] = ACTIONS(993),
    [anon_sym_COLON_COLON2] = ACTIONS(993),
    [anon_sym_AMP_DOT] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(993),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(993),
    [anon_sym_and] = ACTIONS(993),
    [anon_sym_or] = ACTIONS(993),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_AMP_AMP] = ACTIONS(993),
    [anon_sym_LT_LT] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(993),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(993),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(993),
    [anon_sym_LT_EQ_GT] = ACTIONS(993),
    [anon_sym_EQ_TILDE] = ACTIONS(993),
    [anon_sym_BANG_TILDE] = ACTIONS(993),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(993),
    [anon_sym_CARET] = ACTIONS(993),
    [anon_sym_PLUS] = ACTIONS(993),
    [anon_sym_SLASH] = ACTIONS(993),
    [anon_sym_PERCENT] = ACTIONS(993),
    [sym_comment] = ACTIONS(87),
  },
  [4741] = {
    [anon_sym_RBRACE] = ACTIONS(10864),
    [sym_comment] = ACTIONS(87),
  },
  [4742] = {
    [sym_heredoc_body] = STATE(7287),
    [sym__heredoc_body_start] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(10864),
    [sym_comment] = ACTIONS(87),
  },
  [4743] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(7288),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(674),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(674),
    [sym_assignment] = STATE(7288),
    [sym_operator_assignment] = STATE(7288),
    [sym_conditional] = STATE(7288),
    [sym_range] = STATE(7288),
    [sym_binary] = STATE(7288),
    [sym_unary] = STATE(7288),
    [sym_left_assignment_list] = STATE(673),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(674),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(674),
    [sym_false] = STATE(674),
    [sym_nil] = STATE(674),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(675),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1243),
    [anon_sym_yield] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1247),
    [anon_sym_next] = ACTIONS(1249),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4744] = {
    [sym__heredoc_body_start] = ACTIONS(1273),
    [sym__binary_minus] = ACTIONS(1273),
    [sym__binary_star] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_RPAREN] = ACTIONS(1273),
    [anon_sym_DOT] = ACTIONS(1275),
    [anon_sym_COMMA] = ACTIONS(1273),
    [anon_sym_PIPE] = ACTIONS(1275),
    [anon_sym_STAR_STAR] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_EQ] = ACTIONS(1275),
    [anon_sym_LT] = ACTIONS(1275),
    [anon_sym_do] = ACTIONS(1273),
    [anon_sym_LBRACK] = ACTIONS(1273),
    [anon_sym_COLON_COLON2] = ACTIONS(1273),
    [anon_sym_AMP_DOT] = ACTIONS(1273),
    [anon_sym_QMARK] = ACTIONS(1273),
    [anon_sym_DOT_DOT] = ACTIONS(1275),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_and] = ACTIONS(1273),
    [anon_sym_or] = ACTIONS(1273),
    [anon_sym_PIPE_PIPE] = ACTIONS(1273),
    [anon_sym_AMP_AMP] = ACTIONS(1273),
    [anon_sym_LT_LT] = ACTIONS(1273),
    [anon_sym_GT_GT] = ACTIONS(1273),
    [anon_sym_EQ_EQ] = ACTIONS(1275),
    [anon_sym_BANG_EQ] = ACTIONS(1273),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1273),
    [anon_sym_LT_EQ_GT] = ACTIONS(1273),
    [anon_sym_EQ_TILDE] = ACTIONS(1273),
    [anon_sym_BANG_TILDE] = ACTIONS(1273),
    [anon_sym_LT_EQ] = ACTIONS(1275),
    [anon_sym_GT] = ACTIONS(1275),
    [anon_sym_GT_EQ] = ACTIONS(1273),
    [anon_sym_CARET] = ACTIONS(1273),
    [anon_sym_PLUS] = ACTIONS(1273),
    [anon_sym_SLASH] = ACTIONS(1273),
    [anon_sym_PERCENT] = ACTIONS(1273),
    [sym_comment] = ACTIONS(87),
  },
  [4745] = {
    [anon_sym_DOT] = ACTIONS(10866),
    [anon_sym_COLON_COLON] = ACTIONS(10866),
    [sym_comment] = ACTIONS(87),
  },
  [4746] = {
    [sym_method_parameters] = STATE(7290),
    [sym__simple_formal_parameter] = STATE(684),
    [sym_splat_parameter] = STATE(684),
    [sym_hash_splat_parameter] = STATE(684),
    [sym_block_parameter] = STATE(684),
    [sym_keyword_parameter] = STATE(684),
    [sym_optional_parameter] = STATE(684),
    [sym_heredoc_body] = STATE(7290),
    [sym__terminator] = STATE(7290),
    [sym__line_break] = ACTIONS(10868),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_SEMI] = ACTIONS(10868),
    [anon_sym_STAR] = ACTIONS(1283),
    [anon_sym_STAR_STAR] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1287),
    [sym_identifier] = ACTIONS(1289),
    [sym_comment] = ACTIONS(87),
  },
  [4747] = {
    [sym__heredoc_body_start] = ACTIONS(1291),
    [sym__binary_minus] = ACTIONS(1291),
    [sym__binary_star] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1291),
    [anon_sym_RPAREN] = ACTIONS(1291),
    [anon_sym_DOT] = ACTIONS(1293),
    [anon_sym_COMMA] = ACTIONS(1291),
    [anon_sym_PIPE] = ACTIONS(1293),
    [anon_sym_STAR_STAR] = ACTIONS(1291),
    [anon_sym_AMP] = ACTIONS(1293),
    [anon_sym_EQ] = ACTIONS(1293),
    [anon_sym_LT] = ACTIONS(1293),
    [anon_sym_do] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_COLON_COLON2] = ACTIONS(1291),
    [anon_sym_AMP_DOT] = ACTIONS(1291),
    [anon_sym_QMARK] = ACTIONS(1291),
    [anon_sym_DOT_DOT] = ACTIONS(1293),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1291),
    [anon_sym_and] = ACTIONS(1291),
    [anon_sym_or] = ACTIONS(1291),
    [anon_sym_PIPE_PIPE] = ACTIONS(1291),
    [anon_sym_AMP_AMP] = ACTIONS(1291),
    [anon_sym_LT_LT] = ACTIONS(1291),
    [anon_sym_GT_GT] = ACTIONS(1291),
    [anon_sym_EQ_EQ] = ACTIONS(1293),
    [anon_sym_BANG_EQ] = ACTIONS(1291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1291),
    [anon_sym_LT_EQ_GT] = ACTIONS(1291),
    [anon_sym_EQ_TILDE] = ACTIONS(1291),
    [anon_sym_BANG_TILDE] = ACTIONS(1291),
    [anon_sym_LT_EQ] = ACTIONS(1293),
    [anon_sym_GT] = ACTIONS(1293),
    [anon_sym_GT_EQ] = ACTIONS(1291),
    [anon_sym_CARET] = ACTIONS(1291),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_SLASH] = ACTIONS(1291),
    [anon_sym_PERCENT] = ACTIONS(1291),
    [sym_comment] = ACTIONS(87),
  },
  [4748] = {
    [anon_sym_RPAREN] = ACTIONS(10870),
    [sym_comment] = ACTIONS(87),
  },
  [4749] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7292),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(7292),
    [sym_operator_assignment] = STATE(7292),
    [sym_conditional] = STATE(7292),
    [sym_range] = STATE(7292),
    [sym_binary] = STATE(7292),
    [sym_unary] = STATE(7292),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(485),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(495),
    [anon_sym_defined_QMARK] = ACTIONS(497),
    [anon_sym_not] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(501),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4750] = {
    [sym_superclass] = STATE(7293),
    [sym_heredoc_body] = STATE(7294),
    [sym__terminator] = STATE(7294),
    [sym__line_break] = ACTIONS(10872),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1089),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(10872),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1089),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1517),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1089),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [4751] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_superclass] = STATE(7293),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(859),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym_argument_list] = STATE(832),
    [sym__argument_list_with_parens] = STATE(860),
    [sym__argument] = STATE(861),
    [sym_splat_argument] = STATE(861),
    [sym_hash_splat_argument] = STATE(861),
    [sym_block_argument] = STATE(861),
    [sym_do_block] = STATE(835),
    [sym_block] = STATE(835),
    [sym_assignment] = STATE(859),
    [sym_operator_assignment] = STATE(859),
    [sym_conditional] = STATE(859),
    [sym_range] = STATE(859),
    [sym_binary] = STATE(859),
    [sym_unary] = STATE(859),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(864),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_heredoc_body] = STATE(7294),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(861),
    [sym_lambda] = STATE(347),
    [sym__terminator] = STATE(7294),
    [sym__line_break] = ACTIONS(10872),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1521),
    [sym__splat_star] = ACTIONS(1523),
    [sym__unary_minus] = ACTIONS(1525),
    [sym__identifier_hash_key] = ACTIONS(1527),
    [anon_sym_LBRACE] = ACTIONS(1529),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(743),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(10872),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1531),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(1517),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1473),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(1549),
    [sym_identifier] = ACTIONS(1549),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4752] = {
    [sym_heredoc_body] = STATE(7296),
    [sym__terminator] = STATE(7296),
    [sym__line_break] = ACTIONS(10874),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1089),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(10874),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1089),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(10876),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1089),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [4753] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(859),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym_argument_list] = STATE(832),
    [sym__argument_list_with_parens] = STATE(860),
    [sym__argument] = STATE(861),
    [sym_splat_argument] = STATE(861),
    [sym_hash_splat_argument] = STATE(861),
    [sym_block_argument] = STATE(861),
    [sym_do_block] = STATE(835),
    [sym_block] = STATE(835),
    [sym_assignment] = STATE(859),
    [sym_operator_assignment] = STATE(859),
    [sym_conditional] = STATE(859),
    [sym_range] = STATE(859),
    [sym_binary] = STATE(859),
    [sym_unary] = STATE(859),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(864),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_heredoc_body] = STATE(7296),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(861),
    [sym_lambda] = STATE(347),
    [sym__terminator] = STATE(7296),
    [sym__line_break] = ACTIONS(10874),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1521),
    [sym__splat_star] = ACTIONS(1523),
    [sym__unary_minus] = ACTIONS(1525),
    [sym__identifier_hash_key] = ACTIONS(1527),
    [anon_sym_LBRACE] = ACTIONS(1529),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(743),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(10874),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1531),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_end] = ACTIONS(10876),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1473),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(1549),
    [sym_identifier] = ACTIONS(1549),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4754] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7297),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2357),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(2357),
    [sym_assignment] = STATE(7297),
    [sym_operator_assignment] = STATE(7297),
    [sym_conditional] = STATE(7297),
    [sym_range] = STATE(7297),
    [sym_binary] = STATE(7297),
    [sym_unary] = STATE(7297),
    [sym_left_assignment_list] = STATE(2356),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2357),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2357),
    [sym_false] = STATE(2357),
    [sym_nil] = STATE(2357),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2358),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(4005),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(4009),
    [sym__subshell_start] = ACTIONS(4011),
    [sym__regex_start] = ACTIONS(4013),
    [sym__string_array_start] = ACTIONS(4015),
    [sym__symbol_array_start] = ACTIONS(4017),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4019),
    [anon_sym_LBRACE] = ACTIONS(4021),
    [anon_sym_def] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4025),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(4027),
    [anon_sym_module] = ACTIONS(4029),
    [anon_sym_return] = ACTIONS(4031),
    [anon_sym_yield] = ACTIONS(4033),
    [anon_sym_break] = ACTIONS(4035),
    [anon_sym_next] = ACTIONS(4037),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(4039),
    [anon_sym_unless] = ACTIONS(4041),
    [anon_sym_while] = ACTIONS(4043),
    [anon_sym_until] = ACTIONS(4045),
    [anon_sym_for] = ACTIONS(4047),
    [anon_sym_case] = ACTIONS(4049),
    [anon_sym_begin] = ACTIONS(4051),
    [anon_sym_PLUS] = ACTIONS(4053),
    [anon_sym_defined_QMARK] = ACTIONS(4055),
    [anon_sym_not] = ACTIONS(4057),
    [anon_sym_BANG] = ACTIONS(4059),
    [anon_sym_TILDE] = ACTIONS(4059),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4065),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(4067),
    [anon_sym_DASH_GT] = ACTIONS(4069),
  },
  [4755] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7298),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2357),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(2357),
    [sym_assignment] = STATE(7298),
    [sym_operator_assignment] = STATE(7298),
    [sym_conditional] = STATE(7298),
    [sym_range] = STATE(7298),
    [sym_binary] = STATE(7298),
    [sym_unary] = STATE(7298),
    [sym_left_assignment_list] = STATE(2356),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2357),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2357),
    [sym_false] = STATE(2357),
    [sym_nil] = STATE(2357),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2358),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(4005),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(4009),
    [sym__subshell_start] = ACTIONS(4011),
    [sym__regex_start] = ACTIONS(4013),
    [sym__string_array_start] = ACTIONS(4015),
    [sym__symbol_array_start] = ACTIONS(4017),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4019),
    [anon_sym_LBRACE] = ACTIONS(4021),
    [anon_sym_def] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4025),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(4027),
    [anon_sym_module] = ACTIONS(4029),
    [anon_sym_return] = ACTIONS(4031),
    [anon_sym_yield] = ACTIONS(4033),
    [anon_sym_break] = ACTIONS(4035),
    [anon_sym_next] = ACTIONS(4037),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(4039),
    [anon_sym_unless] = ACTIONS(4041),
    [anon_sym_while] = ACTIONS(4043),
    [anon_sym_until] = ACTIONS(4045),
    [anon_sym_for] = ACTIONS(4047),
    [anon_sym_case] = ACTIONS(4049),
    [anon_sym_begin] = ACTIONS(4051),
    [anon_sym_PLUS] = ACTIONS(4053),
    [anon_sym_defined_QMARK] = ACTIONS(4055),
    [anon_sym_not] = ACTIONS(4057),
    [anon_sym_BANG] = ACTIONS(4059),
    [anon_sym_TILDE] = ACTIONS(4059),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4065),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(4067),
    [anon_sym_DASH_GT] = ACTIONS(4069),
  },
  [4756] = {
    [anon_sym_COLON] = ACTIONS(10878),
    [sym_comment] = ACTIONS(87),
  },
  [4757] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7300),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2357),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(2357),
    [sym_assignment] = STATE(7300),
    [sym_operator_assignment] = STATE(7300),
    [sym_conditional] = STATE(7300),
    [sym_range] = STATE(7300),
    [sym_binary] = STATE(7300),
    [sym_unary] = STATE(7300),
    [sym_left_assignment_list] = STATE(2356),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2357),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2357),
    [sym_false] = STATE(2357),
    [sym_nil] = STATE(2357),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2358),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(4005),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(4009),
    [sym__subshell_start] = ACTIONS(4011),
    [sym__regex_start] = ACTIONS(4013),
    [sym__string_array_start] = ACTIONS(4015),
    [sym__symbol_array_start] = ACTIONS(4017),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4019),
    [anon_sym_LBRACE] = ACTIONS(4021),
    [anon_sym_def] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4025),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(4027),
    [anon_sym_module] = ACTIONS(4029),
    [anon_sym_return] = ACTIONS(4031),
    [anon_sym_yield] = ACTIONS(4033),
    [anon_sym_break] = ACTIONS(4035),
    [anon_sym_next] = ACTIONS(4037),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(4039),
    [anon_sym_unless] = ACTIONS(4041),
    [anon_sym_while] = ACTIONS(4043),
    [anon_sym_until] = ACTIONS(4045),
    [anon_sym_for] = ACTIONS(4047),
    [anon_sym_case] = ACTIONS(4049),
    [anon_sym_begin] = ACTIONS(4051),
    [anon_sym_PLUS] = ACTIONS(4053),
    [anon_sym_defined_QMARK] = ACTIONS(4055),
    [anon_sym_not] = ACTIONS(4057),
    [anon_sym_BANG] = ACTIONS(4059),
    [anon_sym_TILDE] = ACTIONS(4059),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4065),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(4067),
    [anon_sym_DASH_GT] = ACTIONS(4069),
  },
  [4758] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(906),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(911),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(911),
    [sym__argument_list_with_trailing_comma] = STATE(7302),
    [sym__argument] = STATE(909),
    [sym_splat_argument] = STATE(909),
    [sym_hash_splat_argument] = STATE(909),
    [sym_block_argument] = STATE(909),
    [sym_assignment] = STATE(906),
    [sym_operator_assignment] = STATE(906),
    [sym_conditional] = STATE(906),
    [sym_range] = STATE(906),
    [sym_binary] = STATE(906),
    [sym_unary] = STATE(906),
    [sym_left_assignment_list] = STATE(910),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(911),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(911),
    [sym_false] = STATE(911),
    [sym_nil] = STATE(911),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(912),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(909),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1589),
    [sym__splat_star] = ACTIONS(1591),
    [sym__unary_minus] = ACTIONS(1593),
    [sym__identifier_hash_key] = ACTIONS(1595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(10880),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1599),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_defined_QMARK] = ACTIONS(1611),
    [anon_sym_not] = ACTIONS(1613),
    [anon_sym_BANG] = ACTIONS(1615),
    [anon_sym_TILDE] = ACTIONS(1615),
    [sym_constant] = ACTIONS(1617),
    [sym_identifier] = ACTIONS(1617),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4759] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(10882),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [4760] = {
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(4087),
    [sym__binary_star] = ACTIONS(4089),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(4091),
    [anon_sym_STAR_STAR] = ACTIONS(4089),
    [anon_sym_AMP] = ACTIONS(4093),
    [anon_sym_EQ] = ACTIONS(1631),
    [anon_sym_LT] = ACTIONS(4095),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(10878),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(4097),
    [anon_sym_DOT_DOT] = ACTIONS(4099),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4101),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(4105),
    [anon_sym_AMP_AMP] = ACTIONS(4105),
    [anon_sym_LT_LT] = ACTIONS(4107),
    [anon_sym_GT_GT] = ACTIONS(4107),
    [anon_sym_EQ_EQ] = ACTIONS(4109),
    [anon_sym_BANG_EQ] = ACTIONS(4105),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4105),
    [anon_sym_LT_EQ_GT] = ACTIONS(4105),
    [anon_sym_EQ_TILDE] = ACTIONS(4105),
    [anon_sym_BANG_TILDE] = ACTIONS(4105),
    [anon_sym_LT_EQ] = ACTIONS(4095),
    [anon_sym_GT] = ACTIONS(4095),
    [anon_sym_GT_EQ] = ACTIONS(4111),
    [anon_sym_CARET] = ACTIONS(4113),
    [anon_sym_PLUS] = ACTIONS(4087),
    [anon_sym_SLASH] = ACTIONS(4089),
    [anon_sym_PERCENT] = ACTIONS(4089),
    [sym_comment] = ACTIONS(87),
  },
  [4761] = {
    [sym__heredoc_body_start] = ACTIONS(1677),
    [sym__binary_minus] = ACTIONS(1677),
    [sym__binary_star] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1677),
    [anon_sym_RPAREN] = ACTIONS(1677),
    [anon_sym_DOT] = ACTIONS(1679),
    [anon_sym_COMMA] = ACTIONS(1677),
    [anon_sym_PIPE] = ACTIONS(1679),
    [anon_sym_STAR_STAR] = ACTIONS(1677),
    [anon_sym_AMP] = ACTIONS(1679),
    [anon_sym_EQ] = ACTIONS(1679),
    [anon_sym_LT] = ACTIONS(1679),
    [anon_sym_do] = ACTIONS(1677),
    [anon_sym_LBRACK] = ACTIONS(1677),
    [anon_sym_COLON_COLON2] = ACTIONS(1677),
    [anon_sym_AMP_DOT] = ACTIONS(1677),
    [anon_sym_QMARK] = ACTIONS(1677),
    [anon_sym_DOT_DOT] = ACTIONS(1679),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1677),
    [anon_sym_and] = ACTIONS(1677),
    [anon_sym_or] = ACTIONS(1677),
    [anon_sym_PIPE_PIPE] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_LT_LT] = ACTIONS(1677),
    [anon_sym_GT_GT] = ACTIONS(1677),
    [anon_sym_EQ_EQ] = ACTIONS(1679),
    [anon_sym_BANG_EQ] = ACTIONS(1677),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1677),
    [anon_sym_LT_EQ_GT] = ACTIONS(1677),
    [anon_sym_EQ_TILDE] = ACTIONS(1677),
    [anon_sym_BANG_TILDE] = ACTIONS(1677),
    [anon_sym_LT_EQ] = ACTIONS(1679),
    [anon_sym_GT] = ACTIONS(1679),
    [anon_sym_GT_EQ] = ACTIONS(1677),
    [anon_sym_CARET] = ACTIONS(1677),
    [anon_sym_PLUS] = ACTIONS(1677),
    [anon_sym_SLASH] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [sym_comment] = ACTIONS(87),
  },
  [4762] = {
    [sym_heredoc_body] = STATE(7305),
    [aux_sym_call_repeat1] = STATE(7305),
    [sym__heredoc_body_start] = ACTIONS(10884),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [4763] = {
    [sym_heredoc_body] = STATE(7305),
    [aux_sym_call_repeat1] = STATE(7305),
    [aux_sym_argument_list_repeat1] = STATE(7307),
    [sym__heredoc_body_start] = ACTIONS(10884),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(10886),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [4764] = {
    [sym_string] = STATE(2392),
    [aux_sym_chained_string_repeat1] = STATE(2392),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(10888),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [4765] = {
    [sym__heredoc_body_start] = ACTIONS(1697),
    [sym__binary_minus] = ACTIONS(1697),
    [sym__binary_star] = ACTIONS(1697),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_RPAREN] = ACTIONS(1697),
    [anon_sym_DOT] = ACTIONS(1699),
    [anon_sym_COMMA] = ACTIONS(1697),
    [anon_sym_PIPE] = ACTIONS(1699),
    [anon_sym_STAR_STAR] = ACTIONS(1697),
    [anon_sym_AMP] = ACTIONS(1699),
    [anon_sym_EQ] = ACTIONS(1699),
    [anon_sym_LT] = ACTIONS(1699),
    [anon_sym_do] = ACTIONS(1697),
    [anon_sym_LBRACK] = ACTIONS(1697),
    [anon_sym_COLON_COLON2] = ACTIONS(1697),
    [anon_sym_AMP_DOT] = ACTIONS(1697),
    [anon_sym_QMARK] = ACTIONS(1697),
    [anon_sym_DOT_DOT] = ACTIONS(1699),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1697),
    [anon_sym_and] = ACTIONS(1697),
    [anon_sym_or] = ACTIONS(1697),
    [anon_sym_PIPE_PIPE] = ACTIONS(1697),
    [anon_sym_AMP_AMP] = ACTIONS(1697),
    [anon_sym_LT_LT] = ACTIONS(1697),
    [anon_sym_GT_GT] = ACTIONS(1697),
    [anon_sym_EQ_EQ] = ACTIONS(1699),
    [anon_sym_BANG_EQ] = ACTIONS(1697),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1697),
    [anon_sym_LT_EQ_GT] = ACTIONS(1697),
    [anon_sym_EQ_TILDE] = ACTIONS(1697),
    [anon_sym_BANG_TILDE] = ACTIONS(1697),
    [anon_sym_LT_EQ] = ACTIONS(1699),
    [anon_sym_GT] = ACTIONS(1699),
    [anon_sym_GT_EQ] = ACTIONS(1697),
    [anon_sym_CARET] = ACTIONS(1697),
    [anon_sym_PLUS] = ACTIONS(1697),
    [anon_sym_SLASH] = ACTIONS(1697),
    [anon_sym_PERCENT] = ACTIONS(1697),
    [sym_comment] = ACTIONS(87),
  },
  [4766] = {
    [sym__heredoc_body_start] = ACTIONS(1701),
    [sym__binary_minus] = ACTIONS(1701),
    [sym__binary_star] = ACTIONS(1701),
    [anon_sym_LBRACE] = ACTIONS(1701),
    [anon_sym_RPAREN] = ACTIONS(1701),
    [anon_sym_DOT] = ACTIONS(1703),
    [anon_sym_COMMA] = ACTIONS(1701),
    [anon_sym_PIPE] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1701),
    [anon_sym_AMP] = ACTIONS(1703),
    [anon_sym_EQ] = ACTIONS(1703),
    [anon_sym_LT] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1701),
    [anon_sym_LBRACK] = ACTIONS(1701),
    [anon_sym_COLON_COLON2] = ACTIONS(1701),
    [anon_sym_AMP_DOT] = ACTIONS(1701),
    [anon_sym_QMARK] = ACTIONS(1701),
    [anon_sym_DOT_DOT] = ACTIONS(1703),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1701),
    [anon_sym_and] = ACTIONS(1701),
    [anon_sym_or] = ACTIONS(1701),
    [anon_sym_PIPE_PIPE] = ACTIONS(1701),
    [anon_sym_AMP_AMP] = ACTIONS(1701),
    [anon_sym_LT_LT] = ACTIONS(1701),
    [anon_sym_GT_GT] = ACTIONS(1701),
    [anon_sym_EQ_EQ] = ACTIONS(1703),
    [anon_sym_BANG_EQ] = ACTIONS(1701),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1701),
    [anon_sym_LT_EQ_GT] = ACTIONS(1701),
    [anon_sym_EQ_TILDE] = ACTIONS(1701),
    [anon_sym_BANG_TILDE] = ACTIONS(1701),
    [anon_sym_LT_EQ] = ACTIONS(1703),
    [anon_sym_GT] = ACTIONS(1703),
    [anon_sym_GT_EQ] = ACTIONS(1701),
    [anon_sym_CARET] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(1701),
    [anon_sym_SLASH] = ACTIONS(1701),
    [anon_sym_PERCENT] = ACTIONS(1701),
    [sym_comment] = ACTIONS(87),
  },
  [4767] = {
    [sym__heredoc_body_start] = ACTIONS(1705),
    [sym__binary_minus] = ACTIONS(1705),
    [sym__binary_star] = ACTIONS(1705),
    [anon_sym_LBRACE] = ACTIONS(1705),
    [anon_sym_RPAREN] = ACTIONS(1705),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1705),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1705),
    [anon_sym_LBRACK] = ACTIONS(1705),
    [anon_sym_COLON_COLON2] = ACTIONS(1705),
    [anon_sym_AMP_DOT] = ACTIONS(1705),
    [anon_sym_QMARK] = ACTIONS(1705),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1705),
    [anon_sym_and] = ACTIONS(1705),
    [anon_sym_or] = ACTIONS(1705),
    [anon_sym_PIPE_PIPE] = ACTIONS(1705),
    [anon_sym_AMP_AMP] = ACTIONS(1705),
    [anon_sym_LT_LT] = ACTIONS(1705),
    [anon_sym_GT_GT] = ACTIONS(1705),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1705),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1705),
    [anon_sym_LT_EQ_GT] = ACTIONS(1705),
    [anon_sym_EQ_TILDE] = ACTIONS(1705),
    [anon_sym_BANG_TILDE] = ACTIONS(1705),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1705),
    [anon_sym_CARET] = ACTIONS(1705),
    [anon_sym_PLUS] = ACTIONS(1705),
    [anon_sym_SLASH] = ACTIONS(1705),
    [anon_sym_PERCENT] = ACTIONS(1705),
    [sym_comment] = ACTIONS(87),
  },
  [4768] = {
    [sym_then] = STATE(7308),
    [sym_heredoc_body] = STATE(7309),
    [sym__terminator] = STATE(7309),
    [sym__line_break] = ACTIONS(10890),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(10890),
    [anon_sym_if] = ACTIONS(1743),
    [anon_sym_unless] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1747),
    [anon_sym_until] = ACTIONS(1749),
    [anon_sym_rescue] = ACTIONS(1751),
    [anon_sym_then] = ACTIONS(1753),
    [sym_comment] = ACTIONS(87),
  },
  [4769] = {
    [sym_then] = STATE(7310),
    [sym_heredoc_body] = STATE(7311),
    [sym__terminator] = STATE(7311),
    [sym__line_break] = ACTIONS(10892),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(10892),
    [anon_sym_if] = ACTIONS(1743),
    [anon_sym_unless] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1747),
    [anon_sym_until] = ACTIONS(1749),
    [anon_sym_rescue] = ACTIONS(1751),
    [anon_sym_then] = ACTIONS(1821),
    [sym_comment] = ACTIONS(87),
  },
  [4770] = {
    [sym__do] = STATE(7312),
    [sym_heredoc_body] = STATE(7312),
    [sym__terminator] = STATE(7312),
    [sym__line_break] = ACTIONS(10894),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym__binary_minus] = ACTIONS(1855),
    [sym__binary_star] = ACTIONS(1857),
    [anon_sym_PIPE] = ACTIONS(1859),
    [anon_sym_SEMI] = ACTIONS(10894),
    [anon_sym_STAR_STAR] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_LT] = ACTIONS(1863),
    [anon_sym_do] = ACTIONS(10894),
    [anon_sym_QMARK] = ACTIONS(1865),
    [anon_sym_DOT_DOT] = ACTIONS(1867),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1869),
    [anon_sym_and] = ACTIONS(1871),
    [anon_sym_or] = ACTIONS(1871),
    [anon_sym_PIPE_PIPE] = ACTIONS(1873),
    [anon_sym_AMP_AMP] = ACTIONS(1873),
    [anon_sym_LT_LT] = ACTIONS(1875),
    [anon_sym_GT_GT] = ACTIONS(1875),
    [anon_sym_EQ_EQ] = ACTIONS(1877),
    [anon_sym_BANG_EQ] = ACTIONS(1873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1873),
    [anon_sym_LT_EQ_GT] = ACTIONS(1873),
    [anon_sym_EQ_TILDE] = ACTIONS(1873),
    [anon_sym_BANG_TILDE] = ACTIONS(1873),
    [anon_sym_LT_EQ] = ACTIONS(1863),
    [anon_sym_GT] = ACTIONS(1863),
    [anon_sym_GT_EQ] = ACTIONS(1879),
    [anon_sym_CARET] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_SLASH] = ACTIONS(1857),
    [anon_sym_PERCENT] = ACTIONS(1857),
    [sym_comment] = ACTIONS(87),
  },
  [4771] = {
    [sym__do] = STATE(7313),
    [sym_heredoc_body] = STATE(7313),
    [sym__terminator] = STATE(7313),
    [sym__line_break] = ACTIONS(10896),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym__binary_minus] = ACTIONS(1855),
    [sym__binary_star] = ACTIONS(1857),
    [anon_sym_PIPE] = ACTIONS(1859),
    [anon_sym_SEMI] = ACTIONS(10896),
    [anon_sym_STAR_STAR] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_LT] = ACTIONS(1863),
    [anon_sym_do] = ACTIONS(10896),
    [anon_sym_QMARK] = ACTIONS(1865),
    [anon_sym_DOT_DOT] = ACTIONS(1867),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1869),
    [anon_sym_and] = ACTIONS(1871),
    [anon_sym_or] = ACTIONS(1871),
    [anon_sym_PIPE_PIPE] = ACTIONS(1873),
    [anon_sym_AMP_AMP] = ACTIONS(1873),
    [anon_sym_LT_LT] = ACTIONS(1875),
    [anon_sym_GT_GT] = ACTIONS(1875),
    [anon_sym_EQ_EQ] = ACTIONS(1877),
    [anon_sym_BANG_EQ] = ACTIONS(1873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1873),
    [anon_sym_LT_EQ_GT] = ACTIONS(1873),
    [anon_sym_EQ_TILDE] = ACTIONS(1873),
    [anon_sym_BANG_TILDE] = ACTIONS(1873),
    [anon_sym_LT_EQ] = ACTIONS(1863),
    [anon_sym_GT] = ACTIONS(1863),
    [anon_sym_GT_EQ] = ACTIONS(1879),
    [anon_sym_CARET] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_SLASH] = ACTIONS(1857),
    [anon_sym_PERCENT] = ACTIONS(1857),
    [sym_comment] = ACTIONS(87),
  },
  [4772] = {
    [sym_in] = STATE(7314),
    [anon_sym_in] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
  },
  [4773] = {
    [sym_heredoc_body] = STATE(7315),
    [sym__terminator] = STATE(7315),
    [sym__line_break] = ACTIONS(10898),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym__binary_minus] = ACTIONS(2001),
    [sym__binary_star] = ACTIONS(2003),
    [anon_sym_PIPE] = ACTIONS(2005),
    [anon_sym_SEMI] = ACTIONS(10898),
    [anon_sym_STAR_STAR] = ACTIONS(2003),
    [anon_sym_AMP] = ACTIONS(2007),
    [anon_sym_LT] = ACTIONS(2009),
    [anon_sym_QMARK] = ACTIONS(2011),
    [anon_sym_DOT_DOT] = ACTIONS(2013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2015),
    [anon_sym_and] = ACTIONS(2017),
    [anon_sym_or] = ACTIONS(2017),
    [anon_sym_PIPE_PIPE] = ACTIONS(2019),
    [anon_sym_AMP_AMP] = ACTIONS(2019),
    [anon_sym_LT_LT] = ACTIONS(2021),
    [anon_sym_GT_GT] = ACTIONS(2021),
    [anon_sym_EQ_EQ] = ACTIONS(2023),
    [anon_sym_BANG_EQ] = ACTIONS(2019),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2019),
    [anon_sym_LT_EQ_GT] = ACTIONS(2019),
    [anon_sym_EQ_TILDE] = ACTIONS(2019),
    [anon_sym_BANG_TILDE] = ACTIONS(2019),
    [anon_sym_LT_EQ] = ACTIONS(2009),
    [anon_sym_GT] = ACTIONS(2009),
    [anon_sym_GT_EQ] = ACTIONS(2025),
    [anon_sym_CARET] = ACTIONS(2027),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_SLASH] = ACTIONS(2003),
    [anon_sym_PERCENT] = ACTIONS(2003),
    [sym_comment] = ACTIONS(87),
  },
  [4774] = {
    [sym_when] = STATE(7319),
    [sym_else] = STATE(7317),
    [aux_sym_case_repeat1] = STATE(7318),
    [aux_sym_case_repeat2] = STATE(7319),
    [anon_sym_SEMI] = ACTIONS(10900),
    [anon_sym_end] = ACTIONS(10902),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [4775] = {
    [sym_else] = STATE(7321),
    [sym_ensure] = STATE(7322),
    [sym_rescue] = STATE(7323),
    [anon_sym_end] = ACTIONS(10904),
    [anon_sym_rescue] = ACTIONS(2165),
    [anon_sym_else] = ACTIONS(2167),
    [anon_sym_ensure] = ACTIONS(2169),
    [sym_comment] = ACTIONS(87),
  },
  [4776] = {
    [sym_ensure] = STATE(7322),
    [anon_sym_end] = ACTIONS(10904),
    [anon_sym_ensure] = ACTIONS(2169),
    [sym_comment] = ACTIONS(87),
  },
  [4777] = {
    [anon_sym_end] = ACTIONS(10904),
    [sym_comment] = ACTIONS(87),
  },
  [4778] = {
    [sym_else] = STATE(7321),
    [sym_ensure] = STATE(7322),
    [anon_sym_end] = ACTIONS(10904),
    [anon_sym_else] = ACTIONS(2167),
    [anon_sym_ensure] = ACTIONS(2169),
    [sym_comment] = ACTIONS(87),
  },
  [4779] = {
    [sym__heredoc_body_start] = ACTIONS(2181),
    [sym__binary_minus] = ACTIONS(2181),
    [sym__binary_star] = ACTIONS(2181),
    [anon_sym_LBRACE] = ACTIONS(2181),
    [anon_sym_RPAREN] = ACTIONS(2181),
    [anon_sym_DOT] = ACTIONS(2183),
    [anon_sym_COMMA] = ACTIONS(2181),
    [anon_sym_PIPE] = ACTIONS(2183),
    [anon_sym_STAR_STAR] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2183),
    [anon_sym_EQ] = ACTIONS(2183),
    [anon_sym_LT] = ACTIONS(2183),
    [anon_sym_do] = ACTIONS(2181),
    [anon_sym_LBRACK] = ACTIONS(2181),
    [anon_sym_COLON_COLON2] = ACTIONS(2181),
    [anon_sym_AMP_DOT] = ACTIONS(2181),
    [anon_sym_QMARK] = ACTIONS(2181),
    [anon_sym_DOT_DOT] = ACTIONS(2183),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2181),
    [anon_sym_AMP_AMP] = ACTIONS(2181),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym_EQ_EQ] = ACTIONS(2183),
    [anon_sym_BANG_EQ] = ACTIONS(2181),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2181),
    [anon_sym_LT_EQ_GT] = ACTIONS(2181),
    [anon_sym_EQ_TILDE] = ACTIONS(2181),
    [anon_sym_BANG_TILDE] = ACTIONS(2181),
    [anon_sym_LT_EQ] = ACTIONS(2183),
    [anon_sym_GT] = ACTIONS(2183),
    [anon_sym_GT_EQ] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [sym_comment] = ACTIONS(87),
  },
  [4780] = {
    [sym__statements] = STATE(4775),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(4776),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(4777),
    [sym_rescue] = STATE(4778),
    [sym__body_statement] = STATE(7324),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10906),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4781] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(7711),
    [sym__binary_star] = ACTIONS(7713),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(7715),
    [anon_sym_STAR_STAR] = ACTIONS(7713),
    [anon_sym_AMP] = ACTIONS(7717),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(7719),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(7721),
    [anon_sym_DOT_DOT] = ACTIONS(7723),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7725),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(7729),
    [anon_sym_AMP_AMP] = ACTIONS(7729),
    [anon_sym_LT_LT] = ACTIONS(7731),
    [anon_sym_GT_GT] = ACTIONS(7731),
    [anon_sym_EQ_EQ] = ACTIONS(7733),
    [anon_sym_BANG_EQ] = ACTIONS(7729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7729),
    [anon_sym_LT_EQ_GT] = ACTIONS(7729),
    [anon_sym_EQ_TILDE] = ACTIONS(7729),
    [anon_sym_BANG_TILDE] = ACTIONS(7729),
    [anon_sym_LT_EQ] = ACTIONS(7719),
    [anon_sym_GT] = ACTIONS(7719),
    [anon_sym_GT_EQ] = ACTIONS(7735),
    [anon_sym_CARET] = ACTIONS(7737),
    [anon_sym_PLUS] = ACTIONS(7711),
    [anon_sym_SLASH] = ACTIONS(7713),
    [anon_sym_PERCENT] = ACTIONS(7713),
    [sym_comment] = ACTIONS(87),
  },
  [4782] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(935),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [4783] = {
    [sym__heredoc_body_start] = ACTIONS(2261),
    [sym__binary_minus] = ACTIONS(2261),
    [sym__binary_star] = ACTIONS(2261),
    [anon_sym_LBRACE] = ACTIONS(2261),
    [anon_sym_RPAREN] = ACTIONS(2261),
    [anon_sym_DOT] = ACTIONS(2263),
    [anon_sym_COMMA] = ACTIONS(2261),
    [anon_sym_PIPE] = ACTIONS(2263),
    [anon_sym_STAR_STAR] = ACTIONS(2261),
    [anon_sym_AMP] = ACTIONS(2263),
    [anon_sym_EQ] = ACTIONS(2263),
    [anon_sym_LT] = ACTIONS(2263),
    [anon_sym_do] = ACTIONS(2261),
    [anon_sym_LBRACK] = ACTIONS(2261),
    [anon_sym_COLON_COLON2] = ACTIONS(2261),
    [anon_sym_AMP_DOT] = ACTIONS(2261),
    [anon_sym_QMARK] = ACTIONS(2261),
    [anon_sym_DOT_DOT] = ACTIONS(2263),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2261),
    [anon_sym_and] = ACTIONS(2261),
    [anon_sym_or] = ACTIONS(2261),
    [anon_sym_PIPE_PIPE] = ACTIONS(2261),
    [anon_sym_AMP_AMP] = ACTIONS(2261),
    [anon_sym_LT_LT] = ACTIONS(2261),
    [anon_sym_GT_GT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(2263),
    [anon_sym_BANG_EQ] = ACTIONS(2261),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2261),
    [anon_sym_LT_EQ_GT] = ACTIONS(2261),
    [anon_sym_EQ_TILDE] = ACTIONS(2261),
    [anon_sym_BANG_TILDE] = ACTIONS(2261),
    [anon_sym_LT_EQ] = ACTIONS(2263),
    [anon_sym_GT] = ACTIONS(2263),
    [anon_sym_GT_EQ] = ACTIONS(2261),
    [anon_sym_CARET] = ACTIONS(2261),
    [anon_sym_PLUS] = ACTIONS(2261),
    [anon_sym_SLASH] = ACTIONS(2261),
    [anon_sym_PERCENT] = ACTIONS(2261),
    [sym_comment] = ACTIONS(87),
  },
  [4784] = {
    [sym__heredoc_body_start] = ACTIONS(2345),
    [sym__binary_minus] = ACTIONS(2345),
    [sym__binary_star] = ACTIONS(2345),
    [anon_sym_LBRACE] = ACTIONS(2345),
    [anon_sym_RPAREN] = ACTIONS(2345),
    [anon_sym_DOT] = ACTIONS(2347),
    [anon_sym_COMMA] = ACTIONS(2345),
    [anon_sym_PIPE] = ACTIONS(2347),
    [anon_sym_STAR_STAR] = ACTIONS(2345),
    [anon_sym_AMP] = ACTIONS(2347),
    [anon_sym_EQ] = ACTIONS(2347),
    [anon_sym_LT] = ACTIONS(2347),
    [anon_sym_do] = ACTIONS(2345),
    [anon_sym_LBRACK] = ACTIONS(2345),
    [anon_sym_COLON_COLON2] = ACTIONS(2345),
    [anon_sym_AMP_DOT] = ACTIONS(2345),
    [anon_sym_QMARK] = ACTIONS(2345),
    [anon_sym_DOT_DOT] = ACTIONS(2347),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2345),
    [anon_sym_and] = ACTIONS(2345),
    [anon_sym_or] = ACTIONS(2345),
    [anon_sym_PIPE_PIPE] = ACTIONS(2345),
    [anon_sym_AMP_AMP] = ACTIONS(2345),
    [anon_sym_LT_LT] = ACTIONS(2345),
    [anon_sym_GT_GT] = ACTIONS(2345),
    [anon_sym_EQ_EQ] = ACTIONS(2347),
    [anon_sym_BANG_EQ] = ACTIONS(2345),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2345),
    [anon_sym_LT_EQ_GT] = ACTIONS(2345),
    [anon_sym_EQ_TILDE] = ACTIONS(2345),
    [anon_sym_BANG_TILDE] = ACTIONS(2345),
    [anon_sym_LT_EQ] = ACTIONS(2347),
    [anon_sym_GT] = ACTIONS(2347),
    [anon_sym_GT_EQ] = ACTIONS(2345),
    [anon_sym_CARET] = ACTIONS(2345),
    [anon_sym_PLUS] = ACTIONS(2345),
    [anon_sym_SLASH] = ACTIONS(2345),
    [anon_sym_PERCENT] = ACTIONS(2345),
    [sym_comment] = ACTIONS(87),
  },
  [4785] = {
    [anon_sym_RBRACK] = ACTIONS(10908),
    [sym_comment] = ACTIONS(87),
  },
  [4786] = {
    [sym__statements] = STATE(7327),
    [sym_begin_block] = STATE(489),
    [sym_end_block] = STATE(489),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_block_parameters] = STATE(7328),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(495),
    [aux_sym__statements_repeat1] = STATE(495),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(10910),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2445),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4787] = {
    [sym__statements] = STATE(7330),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_block_parameters] = STATE(7331),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_heredoc_body] = STATE(7332),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [sym__terminator] = STATE(7332),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__line_break] = ACTIONS(10912),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(10912),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10914),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4788] = {
    [sym_do_block] = STATE(7333),
    [sym_block] = STATE(7333),
    [anon_sym_LBRACE] = ACTIONS(7707),
    [anon_sym_do] = ACTIONS(10916),
    [sym_comment] = ACTIONS(87),
  },
  [4789] = {
    [sym__heredoc_body_start] = ACTIONS(2485),
    [sym__binary_minus] = ACTIONS(2485),
    [sym__binary_star] = ACTIONS(2485),
    [anon_sym_LBRACE] = ACTIONS(2485),
    [anon_sym_RPAREN] = ACTIONS(2485),
    [anon_sym_DOT] = ACTIONS(2487),
    [anon_sym_COMMA] = ACTIONS(2485),
    [anon_sym_PIPE] = ACTIONS(2487),
    [anon_sym_STAR_STAR] = ACTIONS(2485),
    [anon_sym_AMP] = ACTIONS(2487),
    [anon_sym_EQ] = ACTIONS(2487),
    [anon_sym_LT] = ACTIONS(2487),
    [anon_sym_do] = ACTIONS(2485),
    [anon_sym_LBRACK] = ACTIONS(2485),
    [anon_sym_COLON_COLON2] = ACTIONS(2485),
    [anon_sym_AMP_DOT] = ACTIONS(2485),
    [anon_sym_QMARK] = ACTIONS(2485),
    [anon_sym_DOT_DOT] = ACTIONS(2487),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2485),
    [anon_sym_and] = ACTIONS(2485),
    [anon_sym_or] = ACTIONS(2485),
    [anon_sym_PIPE_PIPE] = ACTIONS(2485),
    [anon_sym_AMP_AMP] = ACTIONS(2485),
    [anon_sym_LT_LT] = ACTIONS(2485),
    [anon_sym_GT_GT] = ACTIONS(2485),
    [anon_sym_EQ_EQ] = ACTIONS(2487),
    [anon_sym_BANG_EQ] = ACTIONS(2485),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2485),
    [anon_sym_LT_EQ_GT] = ACTIONS(2485),
    [anon_sym_EQ_TILDE] = ACTIONS(2485),
    [anon_sym_BANG_TILDE] = ACTIONS(2485),
    [anon_sym_LT_EQ] = ACTIONS(2487),
    [anon_sym_GT] = ACTIONS(2487),
    [anon_sym_GT_EQ] = ACTIONS(2485),
    [anon_sym_CARET] = ACTIONS(2485),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_SLASH] = ACTIONS(2485),
    [anon_sym_PERCENT] = ACTIONS(2485),
    [sym_comment] = ACTIONS(87),
  },
  [4790] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7334),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2357),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(2357),
    [sym_assignment] = STATE(7334),
    [sym_operator_assignment] = STATE(7334),
    [sym_conditional] = STATE(7334),
    [sym_range] = STATE(7334),
    [sym_binary] = STATE(7334),
    [sym_unary] = STATE(7334),
    [sym_left_assignment_list] = STATE(2356),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2357),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2357),
    [sym_false] = STATE(2357),
    [sym_nil] = STATE(2357),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2358),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(4005),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(4009),
    [sym__subshell_start] = ACTIONS(4011),
    [sym__regex_start] = ACTIONS(4013),
    [sym__string_array_start] = ACTIONS(4015),
    [sym__symbol_array_start] = ACTIONS(4017),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4019),
    [anon_sym_LBRACE] = ACTIONS(4021),
    [anon_sym_def] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4025),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(4027),
    [anon_sym_module] = ACTIONS(4029),
    [anon_sym_return] = ACTIONS(4031),
    [anon_sym_yield] = ACTIONS(4033),
    [anon_sym_break] = ACTIONS(4035),
    [anon_sym_next] = ACTIONS(4037),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(4039),
    [anon_sym_unless] = ACTIONS(4041),
    [anon_sym_while] = ACTIONS(4043),
    [anon_sym_until] = ACTIONS(4045),
    [anon_sym_for] = ACTIONS(4047),
    [anon_sym_case] = ACTIONS(4049),
    [anon_sym_begin] = ACTIONS(4051),
    [anon_sym_PLUS] = ACTIONS(4053),
    [anon_sym_defined_QMARK] = ACTIONS(4055),
    [anon_sym_not] = ACTIONS(4057),
    [anon_sym_BANG] = ACTIONS(4059),
    [anon_sym_TILDE] = ACTIONS(4059),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4065),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(4067),
    [anon_sym_DASH_GT] = ACTIONS(4069),
  },
  [4791] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7335),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2357),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(2357),
    [sym_assignment] = STATE(7335),
    [sym_operator_assignment] = STATE(7335),
    [sym_conditional] = STATE(7335),
    [sym_range] = STATE(7335),
    [sym_binary] = STATE(7335),
    [sym_unary] = STATE(7335),
    [sym_left_assignment_list] = STATE(2356),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2357),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2357),
    [sym_false] = STATE(2357),
    [sym_nil] = STATE(2357),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2358),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(4005),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(4009),
    [sym__subshell_start] = ACTIONS(4011),
    [sym__regex_start] = ACTIONS(4013),
    [sym__string_array_start] = ACTIONS(4015),
    [sym__symbol_array_start] = ACTIONS(4017),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4019),
    [anon_sym_LBRACE] = ACTIONS(4021),
    [anon_sym_def] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4025),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(4027),
    [anon_sym_module] = ACTIONS(4029),
    [anon_sym_return] = ACTIONS(4031),
    [anon_sym_yield] = ACTIONS(4033),
    [anon_sym_break] = ACTIONS(4035),
    [anon_sym_next] = ACTIONS(4037),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(4039),
    [anon_sym_unless] = ACTIONS(4041),
    [anon_sym_while] = ACTIONS(4043),
    [anon_sym_until] = ACTIONS(4045),
    [anon_sym_for] = ACTIONS(4047),
    [anon_sym_case] = ACTIONS(4049),
    [anon_sym_begin] = ACTIONS(4051),
    [anon_sym_PLUS] = ACTIONS(4053),
    [anon_sym_defined_QMARK] = ACTIONS(4055),
    [anon_sym_not] = ACTIONS(4057),
    [anon_sym_BANG] = ACTIONS(4059),
    [anon_sym_TILDE] = ACTIONS(4059),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4065),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(4067),
    [anon_sym_DASH_GT] = ACTIONS(4069),
  },
  [4792] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7336),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2357),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(2357),
    [sym_assignment] = STATE(7336),
    [sym_operator_assignment] = STATE(7336),
    [sym_conditional] = STATE(7336),
    [sym_range] = STATE(7336),
    [sym_binary] = STATE(7336),
    [sym_unary] = STATE(7336),
    [sym_left_assignment_list] = STATE(2356),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2357),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2357),
    [sym_false] = STATE(2357),
    [sym_nil] = STATE(2357),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2358),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(4005),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(4009),
    [sym__subshell_start] = ACTIONS(4011),
    [sym__regex_start] = ACTIONS(4013),
    [sym__string_array_start] = ACTIONS(4015),
    [sym__symbol_array_start] = ACTIONS(4017),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4019),
    [anon_sym_LBRACE] = ACTIONS(4021),
    [anon_sym_def] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4025),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(4027),
    [anon_sym_module] = ACTIONS(4029),
    [anon_sym_return] = ACTIONS(4031),
    [anon_sym_yield] = ACTIONS(4033),
    [anon_sym_break] = ACTIONS(4035),
    [anon_sym_next] = ACTIONS(4037),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(4039),
    [anon_sym_unless] = ACTIONS(4041),
    [anon_sym_while] = ACTIONS(4043),
    [anon_sym_until] = ACTIONS(4045),
    [anon_sym_for] = ACTIONS(4047),
    [anon_sym_case] = ACTIONS(4049),
    [anon_sym_begin] = ACTIONS(4051),
    [anon_sym_PLUS] = ACTIONS(4053),
    [anon_sym_defined_QMARK] = ACTIONS(4055),
    [anon_sym_not] = ACTIONS(4057),
    [anon_sym_BANG] = ACTIONS(4059),
    [anon_sym_TILDE] = ACTIONS(4059),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4065),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(4067),
    [anon_sym_DASH_GT] = ACTIONS(4069),
  },
  [4793] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7337),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2357),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(2357),
    [sym_assignment] = STATE(7337),
    [sym_operator_assignment] = STATE(7337),
    [sym_conditional] = STATE(7337),
    [sym_range] = STATE(7337),
    [sym_binary] = STATE(7337),
    [sym_unary] = STATE(7337),
    [sym_left_assignment_list] = STATE(2356),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2357),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2357),
    [sym_false] = STATE(2357),
    [sym_nil] = STATE(2357),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2358),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(4005),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(4009),
    [sym__subshell_start] = ACTIONS(4011),
    [sym__regex_start] = ACTIONS(4013),
    [sym__string_array_start] = ACTIONS(4015),
    [sym__symbol_array_start] = ACTIONS(4017),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4019),
    [anon_sym_LBRACE] = ACTIONS(4021),
    [anon_sym_def] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4025),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(4027),
    [anon_sym_module] = ACTIONS(4029),
    [anon_sym_return] = ACTIONS(4031),
    [anon_sym_yield] = ACTIONS(4033),
    [anon_sym_break] = ACTIONS(4035),
    [anon_sym_next] = ACTIONS(4037),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(4039),
    [anon_sym_unless] = ACTIONS(4041),
    [anon_sym_while] = ACTIONS(4043),
    [anon_sym_until] = ACTIONS(4045),
    [anon_sym_for] = ACTIONS(4047),
    [anon_sym_case] = ACTIONS(4049),
    [anon_sym_begin] = ACTIONS(4051),
    [anon_sym_PLUS] = ACTIONS(4053),
    [anon_sym_defined_QMARK] = ACTIONS(4055),
    [anon_sym_not] = ACTIONS(4057),
    [anon_sym_BANG] = ACTIONS(4059),
    [anon_sym_TILDE] = ACTIONS(4059),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4065),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(4067),
    [anon_sym_DASH_GT] = ACTIONS(4069),
  },
  [4794] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7338),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2357),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(2357),
    [sym_assignment] = STATE(7338),
    [sym_operator_assignment] = STATE(7338),
    [sym_conditional] = STATE(7338),
    [sym_range] = STATE(7338),
    [sym_binary] = STATE(7338),
    [sym_unary] = STATE(7338),
    [sym_left_assignment_list] = STATE(2356),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2357),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2357),
    [sym_false] = STATE(2357),
    [sym_nil] = STATE(2357),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2358),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(4005),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(4009),
    [sym__subshell_start] = ACTIONS(4011),
    [sym__regex_start] = ACTIONS(4013),
    [sym__string_array_start] = ACTIONS(4015),
    [sym__symbol_array_start] = ACTIONS(4017),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4019),
    [anon_sym_LBRACE] = ACTIONS(4021),
    [anon_sym_def] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4025),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(4027),
    [anon_sym_module] = ACTIONS(4029),
    [anon_sym_return] = ACTIONS(4031),
    [anon_sym_yield] = ACTIONS(4033),
    [anon_sym_break] = ACTIONS(4035),
    [anon_sym_next] = ACTIONS(4037),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(4039),
    [anon_sym_unless] = ACTIONS(4041),
    [anon_sym_while] = ACTIONS(4043),
    [anon_sym_until] = ACTIONS(4045),
    [anon_sym_for] = ACTIONS(4047),
    [anon_sym_case] = ACTIONS(4049),
    [anon_sym_begin] = ACTIONS(4051),
    [anon_sym_PLUS] = ACTIONS(4053),
    [anon_sym_defined_QMARK] = ACTIONS(4055),
    [anon_sym_not] = ACTIONS(4057),
    [anon_sym_BANG] = ACTIONS(4059),
    [anon_sym_TILDE] = ACTIONS(4059),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4065),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(4067),
    [anon_sym_DASH_GT] = ACTIONS(4069),
  },
  [4795] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(7339),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(7339),
    [sym_operator_assignment] = STATE(7339),
    [sym_conditional] = STATE(7339),
    [sym_range] = STATE(7339),
    [sym_binary] = STATE(7339),
    [sym_unary] = STATE(7339),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4796] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7340),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2357),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(2357),
    [sym_assignment] = STATE(7340),
    [sym_operator_assignment] = STATE(7340),
    [sym_conditional] = STATE(7340),
    [sym_range] = STATE(7340),
    [sym_binary] = STATE(7340),
    [sym_unary] = STATE(7340),
    [sym_left_assignment_list] = STATE(2356),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2357),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2357),
    [sym_false] = STATE(2357),
    [sym_nil] = STATE(2357),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2358),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(4005),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(4009),
    [sym__subshell_start] = ACTIONS(4011),
    [sym__regex_start] = ACTIONS(4013),
    [sym__string_array_start] = ACTIONS(4015),
    [sym__symbol_array_start] = ACTIONS(4017),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4019),
    [anon_sym_LBRACE] = ACTIONS(4021),
    [anon_sym_def] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4025),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(4027),
    [anon_sym_module] = ACTIONS(4029),
    [anon_sym_return] = ACTIONS(4031),
    [anon_sym_yield] = ACTIONS(4033),
    [anon_sym_break] = ACTIONS(4035),
    [anon_sym_next] = ACTIONS(4037),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(4039),
    [anon_sym_unless] = ACTIONS(4041),
    [anon_sym_while] = ACTIONS(4043),
    [anon_sym_until] = ACTIONS(4045),
    [anon_sym_for] = ACTIONS(4047),
    [anon_sym_case] = ACTIONS(4049),
    [anon_sym_begin] = ACTIONS(4051),
    [anon_sym_PLUS] = ACTIONS(4053),
    [anon_sym_defined_QMARK] = ACTIONS(4055),
    [anon_sym_not] = ACTIONS(4057),
    [anon_sym_BANG] = ACTIONS(4059),
    [anon_sym_TILDE] = ACTIONS(4059),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4065),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(4067),
    [anon_sym_DASH_GT] = ACTIONS(4069),
  },
  [4797] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7341),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2357),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(2357),
    [sym_assignment] = STATE(7341),
    [sym_operator_assignment] = STATE(7341),
    [sym_conditional] = STATE(7341),
    [sym_range] = STATE(7341),
    [sym_binary] = STATE(7341),
    [sym_unary] = STATE(7341),
    [sym_left_assignment_list] = STATE(2356),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2357),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2357),
    [sym_false] = STATE(2357),
    [sym_nil] = STATE(2357),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2358),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(4005),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(4009),
    [sym__subshell_start] = ACTIONS(4011),
    [sym__regex_start] = ACTIONS(4013),
    [sym__string_array_start] = ACTIONS(4015),
    [sym__symbol_array_start] = ACTIONS(4017),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4019),
    [anon_sym_LBRACE] = ACTIONS(4021),
    [anon_sym_def] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4025),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(4027),
    [anon_sym_module] = ACTIONS(4029),
    [anon_sym_return] = ACTIONS(4031),
    [anon_sym_yield] = ACTIONS(4033),
    [anon_sym_break] = ACTIONS(4035),
    [anon_sym_next] = ACTIONS(4037),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(4039),
    [anon_sym_unless] = ACTIONS(4041),
    [anon_sym_while] = ACTIONS(4043),
    [anon_sym_until] = ACTIONS(4045),
    [anon_sym_for] = ACTIONS(4047),
    [anon_sym_case] = ACTIONS(4049),
    [anon_sym_begin] = ACTIONS(4051),
    [anon_sym_PLUS] = ACTIONS(4053),
    [anon_sym_defined_QMARK] = ACTIONS(4055),
    [anon_sym_not] = ACTIONS(4057),
    [anon_sym_BANG] = ACTIONS(4059),
    [anon_sym_TILDE] = ACTIONS(4059),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4065),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(4067),
    [anon_sym_DASH_GT] = ACTIONS(4069),
  },
  [4798] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7342),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2357),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(2357),
    [sym_assignment] = STATE(7342),
    [sym_operator_assignment] = STATE(7342),
    [sym_conditional] = STATE(7342),
    [sym_range] = STATE(7342),
    [sym_binary] = STATE(7342),
    [sym_unary] = STATE(7342),
    [sym_left_assignment_list] = STATE(2356),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2357),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2357),
    [sym_false] = STATE(2357),
    [sym_nil] = STATE(2357),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2358),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(4005),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(4009),
    [sym__subshell_start] = ACTIONS(4011),
    [sym__regex_start] = ACTIONS(4013),
    [sym__string_array_start] = ACTIONS(4015),
    [sym__symbol_array_start] = ACTIONS(4017),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4019),
    [anon_sym_LBRACE] = ACTIONS(4021),
    [anon_sym_def] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4025),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(4027),
    [anon_sym_module] = ACTIONS(4029),
    [anon_sym_return] = ACTIONS(4031),
    [anon_sym_yield] = ACTIONS(4033),
    [anon_sym_break] = ACTIONS(4035),
    [anon_sym_next] = ACTIONS(4037),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(4039),
    [anon_sym_unless] = ACTIONS(4041),
    [anon_sym_while] = ACTIONS(4043),
    [anon_sym_until] = ACTIONS(4045),
    [anon_sym_for] = ACTIONS(4047),
    [anon_sym_case] = ACTIONS(4049),
    [anon_sym_begin] = ACTIONS(4051),
    [anon_sym_PLUS] = ACTIONS(4053),
    [anon_sym_defined_QMARK] = ACTIONS(4055),
    [anon_sym_not] = ACTIONS(4057),
    [anon_sym_BANG] = ACTIONS(4059),
    [anon_sym_TILDE] = ACTIONS(4059),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4065),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(4067),
    [anon_sym_DASH_GT] = ACTIONS(4069),
  },
  [4799] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7343),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2357),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(2357),
    [sym_assignment] = STATE(7343),
    [sym_operator_assignment] = STATE(7343),
    [sym_conditional] = STATE(7343),
    [sym_range] = STATE(7343),
    [sym_binary] = STATE(7343),
    [sym_unary] = STATE(7343),
    [sym_left_assignment_list] = STATE(2356),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2357),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2357),
    [sym_false] = STATE(2357),
    [sym_nil] = STATE(2357),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2358),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(4005),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(4009),
    [sym__subshell_start] = ACTIONS(4011),
    [sym__regex_start] = ACTIONS(4013),
    [sym__string_array_start] = ACTIONS(4015),
    [sym__symbol_array_start] = ACTIONS(4017),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4019),
    [anon_sym_LBRACE] = ACTIONS(4021),
    [anon_sym_def] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4025),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(4027),
    [anon_sym_module] = ACTIONS(4029),
    [anon_sym_return] = ACTIONS(4031),
    [anon_sym_yield] = ACTIONS(4033),
    [anon_sym_break] = ACTIONS(4035),
    [anon_sym_next] = ACTIONS(4037),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(4039),
    [anon_sym_unless] = ACTIONS(4041),
    [anon_sym_while] = ACTIONS(4043),
    [anon_sym_until] = ACTIONS(4045),
    [anon_sym_for] = ACTIONS(4047),
    [anon_sym_case] = ACTIONS(4049),
    [anon_sym_begin] = ACTIONS(4051),
    [anon_sym_PLUS] = ACTIONS(4053),
    [anon_sym_defined_QMARK] = ACTIONS(4055),
    [anon_sym_not] = ACTIONS(4057),
    [anon_sym_BANG] = ACTIONS(4059),
    [anon_sym_TILDE] = ACTIONS(4059),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4065),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(4067),
    [anon_sym_DASH_GT] = ACTIONS(4069),
  },
  [4800] = {
    [sym__statements] = STATE(4196),
    [sym_begin_block] = STATE(489),
    [sym_end_block] = STATE(489),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_block_parameters] = STATE(4197),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1516),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1519),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1519),
    [sym_hash_splat_argument] = STATE(116),
    [sym_assignment] = STATE(1516),
    [sym_operator_assignment] = STATE(1516),
    [sym_conditional] = STATE(1516),
    [sym_range] = STATE(1516),
    [sym_binary] = STATE(1516),
    [sym_unary] = STATE(1516),
    [sym_left_assignment_list] = STATE(1518),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1519),
    [sym__variable] = STATE(1517),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1519),
    [sym_false] = STATE(1519),
    [sym_nil] = STATE(1519),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1520),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(1959),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym__hash_items] = STATE(1960),
    [sym_pair] = STATE(122),
    [sym_lambda] = STATE(214),
    [sym_empty_statement] = STATE(495),
    [aux_sym__statements_repeat1] = STATE(495),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2629),
    [sym__identifier_hash_key] = ACTIONS(157),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(10918),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_PIPE] = ACTIONS(2445),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2633),
    [anon_sym_yield] = ACTIONS(2635),
    [anon_sym_break] = ACTIONS(2637),
    [anon_sym_next] = ACTIONS(2639),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2641),
    [anon_sym_defined_QMARK] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2647),
    [anon_sym_TILDE] = ACTIONS(2647),
    [sym_constant] = ACTIONS(2649),
    [sym_identifier] = ACTIONS(2649),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4801] = {
    [sym_do_block] = STATE(4216),
    [sym_block] = STATE(4216),
    [sym__heredoc_body_start] = ACTIONS(2717),
    [sym__binary_minus] = ACTIONS(2717),
    [sym__binary_star] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(6975),
    [anon_sym_RBRACE] = ACTIONS(2717),
    [anon_sym_RPAREN] = ACTIONS(2717),
    [anon_sym_DOT] = ACTIONS(2721),
    [anon_sym_COMMA] = ACTIONS(2717),
    [anon_sym_PIPE] = ACTIONS(2721),
    [anon_sym_SEMI] = ACTIONS(2717),
    [anon_sym_STAR_STAR] = ACTIONS(2721),
    [anon_sym_AMP] = ACTIONS(2721),
    [anon_sym_EQ] = ACTIONS(2721),
    [anon_sym_LT] = ACTIONS(2721),
    [anon_sym_if] = ACTIONS(2717),
    [anon_sym_unless] = ACTIONS(2717),
    [anon_sym_while] = ACTIONS(2717),
    [anon_sym_until] = ACTIONS(2717),
    [anon_sym_rescue] = ACTIONS(2717),
    [anon_sym_in] = ACTIONS(2717),
    [anon_sym_do] = ACTIONS(2717),
    [anon_sym_LBRACK] = ACTIONS(2717),
    [anon_sym_RBRACK] = ACTIONS(2717),
    [anon_sym_COLON_COLON2] = ACTIONS(2717),
    [anon_sym_AMP_DOT] = ACTIONS(2717),
    [anon_sym_PLUS_EQ] = ACTIONS(2717),
    [anon_sym_DASH_EQ] = ACTIONS(2717),
    [anon_sym_STAR_EQ] = ACTIONS(2717),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2717),
    [anon_sym_SLASH_EQ] = ACTIONS(2717),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2717),
    [anon_sym_PIPE_EQ] = ACTIONS(2717),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2717),
    [anon_sym_AMP_EQ] = ACTIONS(2717),
    [anon_sym_PERCENT_EQ] = ACTIONS(2717),
    [anon_sym_GT_GT_EQ] = ACTIONS(2717),
    [anon_sym_LT_LT_EQ] = ACTIONS(2717),
    [anon_sym_CARET_EQ] = ACTIONS(2717),
    [anon_sym_QMARK] = ACTIONS(2717),
    [anon_sym_COLON2] = ACTIONS(2721),
    [anon_sym_DOT_DOT] = ACTIONS(2721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2717),
    [anon_sym_and] = ACTIONS(2717),
    [anon_sym_or] = ACTIONS(2717),
    [anon_sym_PIPE_PIPE] = ACTIONS(2721),
    [anon_sym_AMP_AMP] = ACTIONS(2721),
    [anon_sym_LT_LT] = ACTIONS(2721),
    [anon_sym_GT_GT] = ACTIONS(2721),
    [anon_sym_EQ_EQ] = ACTIONS(2721),
    [anon_sym_BANG_EQ] = ACTIONS(2717),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2717),
    [anon_sym_LT_EQ_GT] = ACTIONS(2717),
    [anon_sym_EQ_TILDE] = ACTIONS(2717),
    [anon_sym_BANG_TILDE] = ACTIONS(2717),
    [anon_sym_LT_EQ] = ACTIONS(2721),
    [anon_sym_GT] = ACTIONS(2721),
    [anon_sym_GT_EQ] = ACTIONS(2717),
    [anon_sym_CARET] = ACTIONS(2721),
    [anon_sym_PLUS] = ACTIONS(2721),
    [anon_sym_SLASH] = ACTIONS(2721),
    [anon_sym_PERCENT] = ACTIONS(2721),
    [sym_comment] = ACTIONS(87),
  },
  [4802] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7345),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2357),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(2357),
    [sym_splat_argument] = STATE(7347),
    [sym_assignment] = STATE(7345),
    [sym_operator_assignment] = STATE(7345),
    [sym_conditional] = STATE(7345),
    [sym_range] = STATE(7345),
    [sym_binary] = STATE(7345),
    [sym_unary] = STATE(7345),
    [sym_right_assignment_list] = STATE(7346),
    [sym__arg_or_splat_arg] = STATE(7347),
    [sym_left_assignment_list] = STATE(2356),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2357),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2357),
    [sym_false] = STATE(2357),
    [sym_nil] = STATE(2357),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2358),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(4005),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(4009),
    [sym__subshell_start] = ACTIONS(4011),
    [sym__regex_start] = ACTIONS(4013),
    [sym__string_array_start] = ACTIONS(4015),
    [sym__symbol_array_start] = ACTIONS(4017),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(7689),
    [sym__unary_minus] = ACTIONS(4019),
    [anon_sym_LBRACE] = ACTIONS(4021),
    [anon_sym_def] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4025),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(4027),
    [anon_sym_module] = ACTIONS(4029),
    [anon_sym_return] = ACTIONS(4031),
    [anon_sym_yield] = ACTIONS(4033),
    [anon_sym_break] = ACTIONS(4035),
    [anon_sym_next] = ACTIONS(4037),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(4039),
    [anon_sym_unless] = ACTIONS(4041),
    [anon_sym_while] = ACTIONS(4043),
    [anon_sym_until] = ACTIONS(4045),
    [anon_sym_for] = ACTIONS(4047),
    [anon_sym_case] = ACTIONS(4049),
    [anon_sym_begin] = ACTIONS(4051),
    [anon_sym_PLUS] = ACTIONS(4053),
    [anon_sym_defined_QMARK] = ACTIONS(4055),
    [anon_sym_not] = ACTIONS(4057),
    [anon_sym_BANG] = ACTIONS(4059),
    [anon_sym_TILDE] = ACTIONS(4059),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4065),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(4067),
    [anon_sym_DASH_GT] = ACTIONS(4069),
  },
  [4803] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7348),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2357),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(2357),
    [sym_assignment] = STATE(7348),
    [sym_operator_assignment] = STATE(7348),
    [sym_conditional] = STATE(7348),
    [sym_range] = STATE(7348),
    [sym_binary] = STATE(7348),
    [sym_unary] = STATE(7348),
    [sym_left_assignment_list] = STATE(2356),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2357),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2357),
    [sym_false] = STATE(2357),
    [sym_nil] = STATE(2357),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2358),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(4005),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(4009),
    [sym__subshell_start] = ACTIONS(4011),
    [sym__regex_start] = ACTIONS(4013),
    [sym__string_array_start] = ACTIONS(4015),
    [sym__symbol_array_start] = ACTIONS(4017),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4019),
    [anon_sym_LBRACE] = ACTIONS(4021),
    [anon_sym_def] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4025),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(4027),
    [anon_sym_module] = ACTIONS(4029),
    [anon_sym_return] = ACTIONS(4031),
    [anon_sym_yield] = ACTIONS(4033),
    [anon_sym_break] = ACTIONS(4035),
    [anon_sym_next] = ACTIONS(4037),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(4039),
    [anon_sym_unless] = ACTIONS(4041),
    [anon_sym_while] = ACTIONS(4043),
    [anon_sym_until] = ACTIONS(4045),
    [anon_sym_for] = ACTIONS(4047),
    [anon_sym_case] = ACTIONS(4049),
    [anon_sym_begin] = ACTIONS(4051),
    [anon_sym_PLUS] = ACTIONS(4053),
    [anon_sym_defined_QMARK] = ACTIONS(4055),
    [anon_sym_not] = ACTIONS(4057),
    [anon_sym_BANG] = ACTIONS(4059),
    [anon_sym_TILDE] = ACTIONS(4059),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4065),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(4067),
    [anon_sym_DASH_GT] = ACTIONS(4069),
  },
  [4804] = {
    [sym_string] = STATE(7349),
    [aux_sym_chained_string_repeat1] = STATE(7349),
    [sym__string_start] = ACTIONS(4007),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_EQ] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [4805] = {
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(7711),
    [sym__binary_star] = ACTIONS(7713),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(7715),
    [anon_sym_STAR_STAR] = ACTIONS(7713),
    [anon_sym_AMP] = ACTIONS(7717),
    [anon_sym_EQ] = ACTIONS(7822),
    [anon_sym_LT] = ACTIONS(7719),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(7721),
    [anon_sym_DOT_DOT] = ACTIONS(7723),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7725),
    [anon_sym_and] = ACTIONS(7727),
    [anon_sym_or] = ACTIONS(7727),
    [anon_sym_PIPE_PIPE] = ACTIONS(7729),
    [anon_sym_AMP_AMP] = ACTIONS(7729),
    [anon_sym_LT_LT] = ACTIONS(7731),
    [anon_sym_GT_GT] = ACTIONS(7731),
    [anon_sym_EQ_EQ] = ACTIONS(7733),
    [anon_sym_BANG_EQ] = ACTIONS(7729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7729),
    [anon_sym_LT_EQ_GT] = ACTIONS(7729),
    [anon_sym_EQ_TILDE] = ACTIONS(7729),
    [anon_sym_BANG_TILDE] = ACTIONS(7729),
    [anon_sym_LT_EQ] = ACTIONS(7719),
    [anon_sym_GT] = ACTIONS(7719),
    [anon_sym_GT_EQ] = ACTIONS(7735),
    [anon_sym_CARET] = ACTIONS(7737),
    [anon_sym_PLUS] = ACTIONS(7711),
    [anon_sym_SLASH] = ACTIONS(7713),
    [anon_sym_PERCENT] = ACTIONS(7713),
    [sym_comment] = ACTIONS(87),
  },
  [4806] = {
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(4087),
    [sym__binary_star] = ACTIONS(4089),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(4091),
    [anon_sym_STAR_STAR] = ACTIONS(4089),
    [anon_sym_AMP] = ACTIONS(4093),
    [anon_sym_EQ] = ACTIONS(4217),
    [anon_sym_LT] = ACTIONS(4095),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_EQ_GT] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(4097),
    [anon_sym_DOT_DOT] = ACTIONS(4099),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4101),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(4105),
    [anon_sym_AMP_AMP] = ACTIONS(4105),
    [anon_sym_LT_LT] = ACTIONS(4107),
    [anon_sym_GT_GT] = ACTIONS(4107),
    [anon_sym_EQ_EQ] = ACTIONS(4109),
    [anon_sym_BANG_EQ] = ACTIONS(4105),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4105),
    [anon_sym_LT_EQ_GT] = ACTIONS(4105),
    [anon_sym_EQ_TILDE] = ACTIONS(4105),
    [anon_sym_BANG_TILDE] = ACTIONS(4105),
    [anon_sym_LT_EQ] = ACTIONS(4095),
    [anon_sym_GT] = ACTIONS(4095),
    [anon_sym_GT_EQ] = ACTIONS(4111),
    [anon_sym_CARET] = ACTIONS(4113),
    [anon_sym_PLUS] = ACTIONS(4087),
    [anon_sym_SLASH] = ACTIONS(4089),
    [anon_sym_PERCENT] = ACTIONS(4089),
    [sym_comment] = ACTIONS(87),
  },
  [4807] = {
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(4087),
    [sym__binary_star] = ACTIONS(4089),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(4091),
    [anon_sym_STAR_STAR] = ACTIONS(4089),
    [anon_sym_AMP] = ACTIONS(4093),
    [anon_sym_EQ] = ACTIONS(4249),
    [anon_sym_LT] = ACTIONS(4095),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_EQ_GT] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(4097),
    [anon_sym_DOT_DOT] = ACTIONS(4099),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4101),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(4105),
    [anon_sym_AMP_AMP] = ACTIONS(4105),
    [anon_sym_LT_LT] = ACTIONS(4107),
    [anon_sym_GT_GT] = ACTIONS(4107),
    [anon_sym_EQ_EQ] = ACTIONS(4109),
    [anon_sym_BANG_EQ] = ACTIONS(4105),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4105),
    [anon_sym_LT_EQ_GT] = ACTIONS(4105),
    [anon_sym_EQ_TILDE] = ACTIONS(4105),
    [anon_sym_BANG_TILDE] = ACTIONS(4105),
    [anon_sym_LT_EQ] = ACTIONS(4095),
    [anon_sym_GT] = ACTIONS(4095),
    [anon_sym_GT_EQ] = ACTIONS(4111),
    [anon_sym_CARET] = ACTIONS(4113),
    [anon_sym_PLUS] = ACTIONS(4087),
    [anon_sym_SLASH] = ACTIONS(4089),
    [anon_sym_PERCENT] = ACTIONS(4089),
    [sym_comment] = ACTIONS(87),
  },
  [4808] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(7350),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(837),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(837),
    [sym_assignment] = STATE(7350),
    [sym_operator_assignment] = STATE(7350),
    [sym_conditional] = STATE(7350),
    [sym_range] = STATE(7350),
    [sym_binary] = STATE(7350),
    [sym_unary] = STATE(7350),
    [sym_left_assignment_list] = STATE(836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(837),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(837),
    [sym_false] = STATE(837),
    [sym_nil] = STATE(837),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2361),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1485),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1493),
    [anon_sym_yield] = ACTIONS(1495),
    [anon_sym_break] = ACTIONS(1497),
    [anon_sym_next] = ACTIONS(1499),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1507),
    [anon_sym_TILDE] = ACTIONS(1507),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4809] = {
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(4087),
    [sym__binary_star] = ACTIONS(4089),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(4091),
    [anon_sym_STAR_STAR] = ACTIONS(4089),
    [anon_sym_AMP] = ACTIONS(4093),
    [anon_sym_EQ] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(4095),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_EQ_GT] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(4097),
    [anon_sym_DOT_DOT] = ACTIONS(4099),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4101),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(4105),
    [anon_sym_AMP_AMP] = ACTIONS(4105),
    [anon_sym_LT_LT] = ACTIONS(4107),
    [anon_sym_GT_GT] = ACTIONS(4107),
    [anon_sym_EQ_EQ] = ACTIONS(4109),
    [anon_sym_BANG_EQ] = ACTIONS(4105),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4105),
    [anon_sym_LT_EQ_GT] = ACTIONS(4105),
    [anon_sym_EQ_TILDE] = ACTIONS(4105),
    [anon_sym_BANG_TILDE] = ACTIONS(4105),
    [anon_sym_LT_EQ] = ACTIONS(4095),
    [anon_sym_GT] = ACTIONS(4095),
    [anon_sym_GT_EQ] = ACTIONS(4111),
    [anon_sym_CARET] = ACTIONS(4113),
    [anon_sym_PLUS] = ACTIONS(4087),
    [anon_sym_SLASH] = ACTIONS(4089),
    [anon_sym_PERCENT] = ACTIONS(4089),
    [sym_comment] = ACTIONS(87),
  },
  [4810] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(7351),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(837),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(837),
    [sym_assignment] = STATE(7351),
    [sym_operator_assignment] = STATE(7351),
    [sym_conditional] = STATE(7351),
    [sym_range] = STATE(7351),
    [sym_binary] = STATE(7351),
    [sym_unary] = STATE(7351),
    [sym_left_assignment_list] = STATE(836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(837),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(837),
    [sym_false] = STATE(837),
    [sym_nil] = STATE(837),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2361),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1485),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1493),
    [anon_sym_yield] = ACTIONS(1495),
    [anon_sym_break] = ACTIONS(1497),
    [anon_sym_next] = ACTIONS(1499),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1507),
    [anon_sym_TILDE] = ACTIONS(1507),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4811] = {
    [sym_heredoc_body] = STATE(7352),
    [aux_sym_call_repeat1] = STATE(7352),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [4812] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(2370),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(837),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(837),
    [sym__argument] = STATE(4250),
    [sym_splat_argument] = STATE(4250),
    [sym_hash_splat_argument] = STATE(4250),
    [sym_block_argument] = STATE(4250),
    [sym_assignment] = STATE(2370),
    [sym_operator_assignment] = STATE(2370),
    [sym_conditional] = STATE(2370),
    [sym_range] = STATE(2370),
    [sym_binary] = STATE(2370),
    [sym_unary] = STATE(2370),
    [sym_left_assignment_list] = STATE(836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(837),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(837),
    [sym_false] = STATE(837),
    [sym_nil] = STATE(837),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2373),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_heredoc_body] = STATE(7353),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(4250),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(4075),
    [sym__splat_star] = ACTIONS(4077),
    [sym__unary_minus] = ACTIONS(1485),
    [sym__identifier_hash_key] = ACTIONS(4079),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10920),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1493),
    [anon_sym_yield] = ACTIONS(1495),
    [anon_sym_break] = ACTIONS(1497),
    [anon_sym_next] = ACTIONS(1499),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1507),
    [anon_sym_TILDE] = ACTIONS(1507),
    [sym_constant] = ACTIONS(4083),
    [sym_identifier] = ACTIONS(4083),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4813] = {
    [sym_heredoc_body] = STATE(7354),
    [aux_sym_call_repeat1] = STATE(7354),
    [aux_sym_argument_list_repeat1] = STATE(7355),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(7751),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [4814] = {
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(7711),
    [sym__binary_star] = ACTIONS(7713),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(7715),
    [anon_sym_STAR_STAR] = ACTIONS(7713),
    [anon_sym_AMP] = ACTIONS(7717),
    [anon_sym_EQ] = ACTIONS(7884),
    [anon_sym_LT] = ACTIONS(7719),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(7721),
    [anon_sym_DOT_DOT] = ACTIONS(7723),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7725),
    [anon_sym_and] = ACTIONS(7727),
    [anon_sym_or] = ACTIONS(7727),
    [anon_sym_PIPE_PIPE] = ACTIONS(7729),
    [anon_sym_AMP_AMP] = ACTIONS(7729),
    [anon_sym_LT_LT] = ACTIONS(7731),
    [anon_sym_GT_GT] = ACTIONS(7731),
    [anon_sym_EQ_EQ] = ACTIONS(7733),
    [anon_sym_BANG_EQ] = ACTIONS(7729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7729),
    [anon_sym_LT_EQ_GT] = ACTIONS(7729),
    [anon_sym_EQ_TILDE] = ACTIONS(7729),
    [anon_sym_BANG_TILDE] = ACTIONS(7729),
    [anon_sym_LT_EQ] = ACTIONS(7719),
    [anon_sym_GT] = ACTIONS(7719),
    [anon_sym_GT_EQ] = ACTIONS(7735),
    [anon_sym_CARET] = ACTIONS(7737),
    [anon_sym_PLUS] = ACTIONS(7711),
    [anon_sym_SLASH] = ACTIONS(7713),
    [anon_sym_PERCENT] = ACTIONS(7713),
    [sym_comment] = ACTIONS(87),
  },
  [4815] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(4089),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(4089),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(4089),
    [anon_sym_PERCENT] = ACTIONS(4089),
    [sym_comment] = ACTIONS(87),
  },
  [4816] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(4089),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [4817] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4087),
    [sym__binary_star] = ACTIONS(4089),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(4089),
    [anon_sym_AMP] = ACTIONS(4093),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(4107),
    [anon_sym_GT_GT] = ACTIONS(4107),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(4087),
    [anon_sym_SLASH] = ACTIONS(4089),
    [anon_sym_PERCENT] = ACTIONS(4089),
    [sym_comment] = ACTIONS(87),
  },
  [4818] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4087),
    [sym__binary_star] = ACTIONS(4089),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(4089),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(4107),
    [anon_sym_GT_GT] = ACTIONS(4107),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(4087),
    [anon_sym_SLASH] = ACTIONS(4089),
    [anon_sym_PERCENT] = ACTIONS(4089),
    [sym_comment] = ACTIONS(87),
  },
  [4819] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4087),
    [sym__binary_star] = ACTIONS(4089),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(4091),
    [anon_sym_STAR_STAR] = ACTIONS(4089),
    [anon_sym_AMP] = ACTIONS(4093),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(4107),
    [anon_sym_GT_GT] = ACTIONS(4107),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(4113),
    [anon_sym_PLUS] = ACTIONS(4087),
    [anon_sym_SLASH] = ACTIONS(4089),
    [anon_sym_PERCENT] = ACTIONS(4089),
    [sym_comment] = ACTIONS(87),
  },
  [4820] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(10922),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [4821] = {
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(4087),
    [sym__binary_star] = ACTIONS(4089),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(4091),
    [anon_sym_STAR_STAR] = ACTIONS(4089),
    [anon_sym_AMP] = ACTIONS(4093),
    [anon_sym_EQ] = ACTIONS(7888),
    [anon_sym_LT] = ACTIONS(4095),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_EQ_GT] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(4099),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4101),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(4105),
    [anon_sym_AMP_AMP] = ACTIONS(4105),
    [anon_sym_LT_LT] = ACTIONS(4107),
    [anon_sym_GT_GT] = ACTIONS(4107),
    [anon_sym_EQ_EQ] = ACTIONS(4109),
    [anon_sym_BANG_EQ] = ACTIONS(4105),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4105),
    [anon_sym_LT_EQ_GT] = ACTIONS(4105),
    [anon_sym_EQ_TILDE] = ACTIONS(4105),
    [anon_sym_BANG_TILDE] = ACTIONS(4105),
    [anon_sym_LT_EQ] = ACTIONS(4095),
    [anon_sym_GT] = ACTIONS(4095),
    [anon_sym_GT_EQ] = ACTIONS(4111),
    [anon_sym_CARET] = ACTIONS(4113),
    [anon_sym_PLUS] = ACTIONS(4087),
    [anon_sym_SLASH] = ACTIONS(4089),
    [anon_sym_PERCENT] = ACTIONS(4089),
    [sym_comment] = ACTIONS(87),
  },
  [4822] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4087),
    [sym__binary_star] = ACTIONS(4089),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(4091),
    [anon_sym_STAR_STAR] = ACTIONS(4089),
    [anon_sym_AMP] = ACTIONS(4093),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(4095),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(4097),
    [anon_sym_DOT_DOT] = ACTIONS(4099),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4101),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(4105),
    [anon_sym_AMP_AMP] = ACTIONS(4105),
    [anon_sym_LT_LT] = ACTIONS(4107),
    [anon_sym_GT_GT] = ACTIONS(4107),
    [anon_sym_EQ_EQ] = ACTIONS(4109),
    [anon_sym_BANG_EQ] = ACTIONS(4105),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4105),
    [anon_sym_LT_EQ_GT] = ACTIONS(4105),
    [anon_sym_EQ_TILDE] = ACTIONS(4105),
    [anon_sym_BANG_TILDE] = ACTIONS(4105),
    [anon_sym_LT_EQ] = ACTIONS(4095),
    [anon_sym_GT] = ACTIONS(4095),
    [anon_sym_GT_EQ] = ACTIONS(4111),
    [anon_sym_CARET] = ACTIONS(4113),
    [anon_sym_PLUS] = ACTIONS(4087),
    [anon_sym_SLASH] = ACTIONS(4089),
    [anon_sym_PERCENT] = ACTIONS(4089),
    [sym_comment] = ACTIONS(87),
  },
  [4823] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4087),
    [sym__binary_star] = ACTIONS(4089),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(4091),
    [anon_sym_STAR_STAR] = ACTIONS(4089),
    [anon_sym_AMP] = ACTIONS(4093),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(4095),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(4107),
    [anon_sym_GT_GT] = ACTIONS(4107),
    [anon_sym_EQ_EQ] = ACTIONS(4109),
    [anon_sym_BANG_EQ] = ACTIONS(4105),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4105),
    [anon_sym_LT_EQ_GT] = ACTIONS(4105),
    [anon_sym_EQ_TILDE] = ACTIONS(4105),
    [anon_sym_BANG_TILDE] = ACTIONS(4105),
    [anon_sym_LT_EQ] = ACTIONS(4095),
    [anon_sym_GT] = ACTIONS(4095),
    [anon_sym_GT_EQ] = ACTIONS(4111),
    [anon_sym_CARET] = ACTIONS(4113),
    [anon_sym_PLUS] = ACTIONS(4087),
    [anon_sym_SLASH] = ACTIONS(4089),
    [anon_sym_PERCENT] = ACTIONS(4089),
    [sym_comment] = ACTIONS(87),
  },
  [4824] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4087),
    [sym__binary_star] = ACTIONS(4089),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(4089),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(4087),
    [anon_sym_SLASH] = ACTIONS(4089),
    [anon_sym_PERCENT] = ACTIONS(4089),
    [sym_comment] = ACTIONS(87),
  },
  [4825] = {
    [sym_heredoc_body] = STATE(4825),
    [aux_sym_call_repeat1] = STATE(4825),
    [sym__heredoc_body_start] = ACTIONS(10810),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7914),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_EQ] = ACTIONS(7914),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [4826] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(831),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(837),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(837),
    [sym__argument] = STATE(6088),
    [sym_splat_argument] = STATE(6088),
    [sym_hash_splat_argument] = STATE(6088),
    [sym_block_argument] = STATE(6088),
    [sym_assignment] = STATE(831),
    [sym_operator_assignment] = STATE(831),
    [sym_conditional] = STATE(831),
    [sym_range] = STATE(831),
    [sym_binary] = STATE(831),
    [sym_unary] = STATE(831),
    [sym_left_assignment_list] = STATE(836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(837),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(837),
    [sym_false] = STATE(837),
    [sym_nil] = STATE(837),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(838),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(6088),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1481),
    [sym__splat_star] = ACTIONS(1483),
    [sym__unary_minus] = ACTIONS(1485),
    [sym__identifier_hash_key] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1491),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1493),
    [anon_sym_yield] = ACTIONS(1495),
    [anon_sym_break] = ACTIONS(1497),
    [anon_sym_next] = ACTIONS(1499),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1507),
    [anon_sym_TILDE] = ACTIONS(1507),
    [sym_constant] = ACTIONS(1509),
    [sym_identifier] = ACTIONS(1509),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4827] = {
    [sym_heredoc_body] = STATE(4825),
    [aux_sym_call_repeat1] = STATE(4825),
    [sym__heredoc_body_start] = ACTIONS(3959),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7929),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_EQ] = ACTIONS(7929),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [4828] = {
    [aux_sym_argument_list_repeat1] = STATE(4828),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7925),
    [anon_sym_COMMA] = ACTIONS(10924),
    [anon_sym_EQ] = ACTIONS(7925),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [4829] = {
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(4087),
    [sym__binary_star] = ACTIONS(4089),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(4091),
    [anon_sym_STAR_STAR] = ACTIONS(4089),
    [anon_sym_AMP] = ACTIONS(4093),
    [anon_sym_EQ] = ACTIONS(7936),
    [anon_sym_LT] = ACTIONS(4095),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_EQ_GT] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(4097),
    [anon_sym_DOT_DOT] = ACTIONS(4099),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4101),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(4105),
    [anon_sym_AMP_AMP] = ACTIONS(4105),
    [anon_sym_LT_LT] = ACTIONS(4107),
    [anon_sym_GT_GT] = ACTIONS(4107),
    [anon_sym_EQ_EQ] = ACTIONS(4109),
    [anon_sym_BANG_EQ] = ACTIONS(4105),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4105),
    [anon_sym_LT_EQ_GT] = ACTIONS(4105),
    [anon_sym_EQ_TILDE] = ACTIONS(4105),
    [anon_sym_BANG_TILDE] = ACTIONS(4105),
    [anon_sym_LT_EQ] = ACTIONS(4095),
    [anon_sym_GT] = ACTIONS(4095),
    [anon_sym_GT_EQ] = ACTIONS(4111),
    [anon_sym_CARET] = ACTIONS(4113),
    [anon_sym_PLUS] = ACTIONS(4087),
    [anon_sym_SLASH] = ACTIONS(4089),
    [anon_sym_PERCENT] = ACTIONS(4089),
    [sym_comment] = ACTIONS(87),
  },
  [4830] = {
    [aux_sym_exceptions_repeat1] = STATE(7358),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [4831] = {
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(4087),
    [sym__binary_star] = ACTIONS(4089),
    [anon_sym_LBRACE] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(4091),
    [anon_sym_STAR_STAR] = ACTIONS(4089),
    [anon_sym_AMP] = ACTIONS(4093),
    [anon_sym_EQ] = ACTIONS(7938),
    [anon_sym_LT] = ACTIONS(4095),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_EQ_GT] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(4097),
    [anon_sym_DOT_DOT] = ACTIONS(4099),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4101),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(4105),
    [anon_sym_AMP_AMP] = ACTIONS(4105),
    [anon_sym_LT_LT] = ACTIONS(4107),
    [anon_sym_GT_GT] = ACTIONS(4107),
    [anon_sym_EQ_EQ] = ACTIONS(4109),
    [anon_sym_BANG_EQ] = ACTIONS(4105),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4105),
    [anon_sym_LT_EQ_GT] = ACTIONS(4105),
    [anon_sym_EQ_TILDE] = ACTIONS(4105),
    [anon_sym_BANG_TILDE] = ACTIONS(4105),
    [anon_sym_LT_EQ] = ACTIONS(4095),
    [anon_sym_GT] = ACTIONS(4095),
    [anon_sym_GT_EQ] = ACTIONS(4111),
    [anon_sym_CARET] = ACTIONS(4113),
    [anon_sym_PLUS] = ACTIONS(4087),
    [anon_sym_SLASH] = ACTIONS(4089),
    [anon_sym_PERCENT] = ACTIONS(4089),
    [sym_comment] = ACTIONS(87),
  },
  [4832] = {
    [sym_string] = STATE(4832),
    [aux_sym_chained_string_repeat1] = STATE(4832),
    [sym__string_start] = ACTIONS(9407),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_EQ] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_do] = ACTIONS(6212),
    [anon_sym_EQ_GT] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [4833] = {
    [sym__line_break] = ACTIONS(10927),
    [sym__heredoc_body_start] = ACTIONS(10927),
    [sym__binary_minus] = ACTIONS(10927),
    [sym__binary_star] = ACTIONS(10927),
    [ts_builtin_sym_end] = ACTIONS(10927),
    [anon_sym___END__] = ACTIONS(10927),
    [anon_sym_LBRACE] = ACTIONS(10927),
    [anon_sym_RBRACE] = ACTIONS(10927),
    [anon_sym_RPAREN] = ACTIONS(10927),
    [anon_sym_DOT] = ACTIONS(10929),
    [anon_sym_COMMA] = ACTIONS(10927),
    [anon_sym_PIPE] = ACTIONS(10929),
    [anon_sym_SEMI] = ACTIONS(10927),
    [anon_sym_STAR_STAR] = ACTIONS(10927),
    [anon_sym_AMP] = ACTIONS(10929),
    [anon_sym_LT] = ACTIONS(10929),
    [anon_sym_end] = ACTIONS(10927),
    [anon_sym_if] = ACTIONS(10927),
    [anon_sym_unless] = ACTIONS(10927),
    [anon_sym_while] = ACTIONS(10927),
    [anon_sym_until] = ACTIONS(10927),
    [anon_sym_rescue] = ACTIONS(10927),
    [anon_sym_do] = ACTIONS(10927),
    [anon_sym_when] = ACTIONS(10927),
    [anon_sym_elsif] = ACTIONS(10927),
    [anon_sym_else] = ACTIONS(10927),
    [anon_sym_then] = ACTIONS(10927),
    [anon_sym_ensure] = ACTIONS(10927),
    [anon_sym_EQ_GT] = ACTIONS(10927),
    [anon_sym_LBRACK] = ACTIONS(10927),
    [anon_sym_COLON_COLON2] = ACTIONS(10927),
    [anon_sym_AMP_DOT] = ACTIONS(10927),
    [anon_sym_QMARK] = ACTIONS(10927),
    [anon_sym_DOT_DOT] = ACTIONS(10929),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10927),
    [anon_sym_and] = ACTIONS(10927),
    [anon_sym_or] = ACTIONS(10927),
    [anon_sym_PIPE_PIPE] = ACTIONS(10927),
    [anon_sym_AMP_AMP] = ACTIONS(10927),
    [anon_sym_LT_LT] = ACTIONS(10927),
    [anon_sym_GT_GT] = ACTIONS(10927),
    [anon_sym_EQ_EQ] = ACTIONS(10929),
    [anon_sym_BANG_EQ] = ACTIONS(10927),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10927),
    [anon_sym_LT_EQ_GT] = ACTIONS(10927),
    [anon_sym_EQ_TILDE] = ACTIONS(10927),
    [anon_sym_BANG_TILDE] = ACTIONS(10927),
    [anon_sym_LT_EQ] = ACTIONS(10929),
    [anon_sym_GT] = ACTIONS(10929),
    [anon_sym_GT_EQ] = ACTIONS(10927),
    [anon_sym_CARET] = ACTIONS(10927),
    [anon_sym_PLUS] = ACTIONS(10927),
    [anon_sym_SLASH] = ACTIONS(10927),
    [anon_sym_PERCENT] = ACTIONS(10927),
    [sym_comment] = ACTIONS(87),
  },
  [4834] = {
    [sym__line_break] = ACTIONS(10931),
    [sym__heredoc_body_start] = ACTIONS(10931),
    [sym__binary_minus] = ACTIONS(10931),
    [sym__binary_star] = ACTIONS(10931),
    [ts_builtin_sym_end] = ACTIONS(10931),
    [anon_sym___END__] = ACTIONS(10931),
    [anon_sym_LBRACE] = ACTIONS(10931),
    [anon_sym_RBRACE] = ACTIONS(10931),
    [anon_sym_RPAREN] = ACTIONS(10931),
    [anon_sym_DOT] = ACTIONS(10933),
    [anon_sym_COMMA] = ACTIONS(10931),
    [anon_sym_PIPE] = ACTIONS(10933),
    [anon_sym_SEMI] = ACTIONS(10931),
    [anon_sym_STAR_STAR] = ACTIONS(10931),
    [anon_sym_AMP] = ACTIONS(10933),
    [anon_sym_LT] = ACTIONS(10933),
    [anon_sym_end] = ACTIONS(10931),
    [anon_sym_if] = ACTIONS(10931),
    [anon_sym_unless] = ACTIONS(10931),
    [anon_sym_while] = ACTIONS(10931),
    [anon_sym_until] = ACTIONS(10931),
    [anon_sym_rescue] = ACTIONS(10931),
    [anon_sym_do] = ACTIONS(10931),
    [anon_sym_when] = ACTIONS(10931),
    [anon_sym_elsif] = ACTIONS(10931),
    [anon_sym_else] = ACTIONS(10931),
    [anon_sym_then] = ACTIONS(10931),
    [anon_sym_ensure] = ACTIONS(10931),
    [anon_sym_EQ_GT] = ACTIONS(10931),
    [anon_sym_LBRACK] = ACTIONS(10931),
    [anon_sym_COLON_COLON2] = ACTIONS(10931),
    [anon_sym_AMP_DOT] = ACTIONS(10931),
    [anon_sym_QMARK] = ACTIONS(10931),
    [anon_sym_DOT_DOT] = ACTIONS(10933),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10931),
    [anon_sym_and] = ACTIONS(10931),
    [anon_sym_or] = ACTIONS(10931),
    [anon_sym_PIPE_PIPE] = ACTIONS(10931),
    [anon_sym_AMP_AMP] = ACTIONS(10931),
    [anon_sym_LT_LT] = ACTIONS(10931),
    [anon_sym_GT_GT] = ACTIONS(10931),
    [anon_sym_EQ_EQ] = ACTIONS(10933),
    [anon_sym_BANG_EQ] = ACTIONS(10931),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10931),
    [anon_sym_LT_EQ_GT] = ACTIONS(10931),
    [anon_sym_EQ_TILDE] = ACTIONS(10931),
    [anon_sym_BANG_TILDE] = ACTIONS(10931),
    [anon_sym_LT_EQ] = ACTIONS(10933),
    [anon_sym_GT] = ACTIONS(10933),
    [anon_sym_GT_EQ] = ACTIONS(10931),
    [anon_sym_CARET] = ACTIONS(10931),
    [anon_sym_PLUS] = ACTIONS(10931),
    [anon_sym_SLASH] = ACTIONS(10931),
    [anon_sym_PERCENT] = ACTIONS(10931),
    [sym_comment] = ACTIONS(87),
  },
  [4835] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(7778),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [4836] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7359),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2408),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(2408),
    [sym_assignment] = STATE(7359),
    [sym_operator_assignment] = STATE(7359),
    [sym_conditional] = STATE(7359),
    [sym_range] = STATE(7359),
    [sym_binary] = STATE(7359),
    [sym_unary] = STATE(7359),
    [sym_left_assignment_list] = STATE(2407),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2408),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2408),
    [sym_false] = STATE(2408),
    [sym_nil] = STATE(2408),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2409),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4133),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4135),
    [anon_sym_yield] = ACTIONS(4137),
    [anon_sym_break] = ACTIONS(4139),
    [anon_sym_next] = ACTIONS(4141),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4143),
    [anon_sym_defined_QMARK] = ACTIONS(4145),
    [anon_sym_not] = ACTIONS(4147),
    [anon_sym_BANG] = ACTIONS(4149),
    [anon_sym_TILDE] = ACTIONS(4149),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4837] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7360),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2408),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(2408),
    [sym_assignment] = STATE(7360),
    [sym_operator_assignment] = STATE(7360),
    [sym_conditional] = STATE(7360),
    [sym_range] = STATE(7360),
    [sym_binary] = STATE(7360),
    [sym_unary] = STATE(7360),
    [sym_left_assignment_list] = STATE(2407),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2408),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2408),
    [sym_false] = STATE(2408),
    [sym_nil] = STATE(2408),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2409),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4133),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4135),
    [anon_sym_yield] = ACTIONS(4137),
    [anon_sym_break] = ACTIONS(4139),
    [anon_sym_next] = ACTIONS(4141),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4143),
    [anon_sym_defined_QMARK] = ACTIONS(4145),
    [anon_sym_not] = ACTIONS(4147),
    [anon_sym_BANG] = ACTIONS(4149),
    [anon_sym_TILDE] = ACTIONS(4149),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4838] = {
    [anon_sym_COLON] = ACTIONS(10935),
    [sym_comment] = ACTIONS(87),
  },
  [4839] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7362),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2408),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(2408),
    [sym_assignment] = STATE(7362),
    [sym_operator_assignment] = STATE(7362),
    [sym_conditional] = STATE(7362),
    [sym_range] = STATE(7362),
    [sym_binary] = STATE(7362),
    [sym_unary] = STATE(7362),
    [sym_left_assignment_list] = STATE(2407),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2408),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2408),
    [sym_false] = STATE(2408),
    [sym_nil] = STATE(2408),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2409),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4133),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4135),
    [anon_sym_yield] = ACTIONS(4137),
    [anon_sym_break] = ACTIONS(4139),
    [anon_sym_next] = ACTIONS(4141),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4143),
    [anon_sym_defined_QMARK] = ACTIONS(4145),
    [anon_sym_not] = ACTIONS(4147),
    [anon_sym_BANG] = ACTIONS(4149),
    [anon_sym_TILDE] = ACTIONS(4149),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4840] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(10937),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [4841] = {
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(4167),
    [sym__binary_star] = ACTIONS(4169),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(4171),
    [anon_sym_STAR_STAR] = ACTIONS(4169),
    [anon_sym_AMP] = ACTIONS(4173),
    [anon_sym_LT] = ACTIONS(4175),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(10935),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_DOT_DOT] = ACTIONS(4179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4181),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(4185),
    [anon_sym_AMP_AMP] = ACTIONS(4185),
    [anon_sym_LT_LT] = ACTIONS(4187),
    [anon_sym_GT_GT] = ACTIONS(4187),
    [anon_sym_EQ_EQ] = ACTIONS(4189),
    [anon_sym_BANG_EQ] = ACTIONS(4185),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4185),
    [anon_sym_LT_EQ_GT] = ACTIONS(4185),
    [anon_sym_EQ_TILDE] = ACTIONS(4185),
    [anon_sym_BANG_TILDE] = ACTIONS(4185),
    [anon_sym_LT_EQ] = ACTIONS(4175),
    [anon_sym_GT] = ACTIONS(4175),
    [anon_sym_GT_EQ] = ACTIONS(4191),
    [anon_sym_CARET] = ACTIONS(4193),
    [anon_sym_PLUS] = ACTIONS(4167),
    [anon_sym_SLASH] = ACTIONS(4169),
    [anon_sym_PERCENT] = ACTIONS(4169),
    [sym_comment] = ACTIONS(87),
  },
  [4842] = {
    [sym_heredoc_body] = STATE(7364),
    [aux_sym_call_repeat1] = STATE(7364),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [4843] = {
    [sym_heredoc_body] = STATE(7364),
    [aux_sym_call_repeat1] = STATE(7364),
    [aux_sym_argument_list_repeat1] = STATE(7366),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(10939),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [4844] = {
    [sym_string] = STATE(2442),
    [aux_sym_chained_string_repeat1] = STATE(2442),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(10941),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [4845] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(7776),
    [sym__binary_star] = ACTIONS(7778),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(7780),
    [anon_sym_STAR_STAR] = ACTIONS(7778),
    [anon_sym_AMP] = ACTIONS(7782),
    [anon_sym_LT] = ACTIONS(7784),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(7786),
    [anon_sym_DOT_DOT] = ACTIONS(7788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7790),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(7794),
    [anon_sym_AMP_AMP] = ACTIONS(7794),
    [anon_sym_LT_LT] = ACTIONS(7796),
    [anon_sym_GT_GT] = ACTIONS(7796),
    [anon_sym_EQ_EQ] = ACTIONS(7798),
    [anon_sym_BANG_EQ] = ACTIONS(7794),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7794),
    [anon_sym_LT_EQ_GT] = ACTIONS(7794),
    [anon_sym_EQ_TILDE] = ACTIONS(7794),
    [anon_sym_BANG_TILDE] = ACTIONS(7794),
    [anon_sym_LT_EQ] = ACTIONS(7784),
    [anon_sym_GT] = ACTIONS(7784),
    [anon_sym_GT_EQ] = ACTIONS(7800),
    [anon_sym_CARET] = ACTIONS(7802),
    [anon_sym_PLUS] = ACTIONS(7776),
    [anon_sym_SLASH] = ACTIONS(7778),
    [anon_sym_PERCENT] = ACTIONS(7778),
    [sym_comment] = ACTIONS(87),
  },
  [4846] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7367),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2408),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(2408),
    [sym_assignment] = STATE(7367),
    [sym_operator_assignment] = STATE(7367),
    [sym_conditional] = STATE(7367),
    [sym_range] = STATE(7367),
    [sym_binary] = STATE(7367),
    [sym_unary] = STATE(7367),
    [sym_left_assignment_list] = STATE(2407),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2408),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2408),
    [sym_false] = STATE(2408),
    [sym_nil] = STATE(2408),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2409),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4133),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4135),
    [anon_sym_yield] = ACTIONS(4137),
    [anon_sym_break] = ACTIONS(4139),
    [anon_sym_next] = ACTIONS(4141),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4143),
    [anon_sym_defined_QMARK] = ACTIONS(4145),
    [anon_sym_not] = ACTIONS(4147),
    [anon_sym_BANG] = ACTIONS(4149),
    [anon_sym_TILDE] = ACTIONS(4149),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4847] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7368),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2408),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(2408),
    [sym_assignment] = STATE(7368),
    [sym_operator_assignment] = STATE(7368),
    [sym_conditional] = STATE(7368),
    [sym_range] = STATE(7368),
    [sym_binary] = STATE(7368),
    [sym_unary] = STATE(7368),
    [sym_left_assignment_list] = STATE(2407),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2408),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2408),
    [sym_false] = STATE(2408),
    [sym_nil] = STATE(2408),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2409),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4133),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4135),
    [anon_sym_yield] = ACTIONS(4137),
    [anon_sym_break] = ACTIONS(4139),
    [anon_sym_next] = ACTIONS(4141),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4143),
    [anon_sym_defined_QMARK] = ACTIONS(4145),
    [anon_sym_not] = ACTIONS(4147),
    [anon_sym_BANG] = ACTIONS(4149),
    [anon_sym_TILDE] = ACTIONS(4149),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4848] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7369),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2408),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(2408),
    [sym_assignment] = STATE(7369),
    [sym_operator_assignment] = STATE(7369),
    [sym_conditional] = STATE(7369),
    [sym_range] = STATE(7369),
    [sym_binary] = STATE(7369),
    [sym_unary] = STATE(7369),
    [sym_left_assignment_list] = STATE(2407),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2408),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2408),
    [sym_false] = STATE(2408),
    [sym_nil] = STATE(2408),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2409),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4133),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4135),
    [anon_sym_yield] = ACTIONS(4137),
    [anon_sym_break] = ACTIONS(4139),
    [anon_sym_next] = ACTIONS(4141),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4143),
    [anon_sym_defined_QMARK] = ACTIONS(4145),
    [anon_sym_not] = ACTIONS(4147),
    [anon_sym_BANG] = ACTIONS(4149),
    [anon_sym_TILDE] = ACTIONS(4149),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4849] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7370),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2408),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(2408),
    [sym_assignment] = STATE(7370),
    [sym_operator_assignment] = STATE(7370),
    [sym_conditional] = STATE(7370),
    [sym_range] = STATE(7370),
    [sym_binary] = STATE(7370),
    [sym_unary] = STATE(7370),
    [sym_left_assignment_list] = STATE(2407),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2408),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2408),
    [sym_false] = STATE(2408),
    [sym_nil] = STATE(2408),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2409),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4133),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4135),
    [anon_sym_yield] = ACTIONS(4137),
    [anon_sym_break] = ACTIONS(4139),
    [anon_sym_next] = ACTIONS(4141),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4143),
    [anon_sym_defined_QMARK] = ACTIONS(4145),
    [anon_sym_not] = ACTIONS(4147),
    [anon_sym_BANG] = ACTIONS(4149),
    [anon_sym_TILDE] = ACTIONS(4149),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4850] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7371),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2408),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(2408),
    [sym_assignment] = STATE(7371),
    [sym_operator_assignment] = STATE(7371),
    [sym_conditional] = STATE(7371),
    [sym_range] = STATE(7371),
    [sym_binary] = STATE(7371),
    [sym_unary] = STATE(7371),
    [sym_left_assignment_list] = STATE(2407),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2408),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2408),
    [sym_false] = STATE(2408),
    [sym_nil] = STATE(2408),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2409),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4133),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4135),
    [anon_sym_yield] = ACTIONS(4137),
    [anon_sym_break] = ACTIONS(4139),
    [anon_sym_next] = ACTIONS(4141),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4143),
    [anon_sym_defined_QMARK] = ACTIONS(4145),
    [anon_sym_not] = ACTIONS(4147),
    [anon_sym_BANG] = ACTIONS(4149),
    [anon_sym_TILDE] = ACTIONS(4149),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4851] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(7372),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(7372),
    [sym_operator_assignment] = STATE(7372),
    [sym_conditional] = STATE(7372),
    [sym_range] = STATE(7372),
    [sym_binary] = STATE(7372),
    [sym_unary] = STATE(7372),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4852] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7373),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2408),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(2408),
    [sym_assignment] = STATE(7373),
    [sym_operator_assignment] = STATE(7373),
    [sym_conditional] = STATE(7373),
    [sym_range] = STATE(7373),
    [sym_binary] = STATE(7373),
    [sym_unary] = STATE(7373),
    [sym_left_assignment_list] = STATE(2407),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2408),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2408),
    [sym_false] = STATE(2408),
    [sym_nil] = STATE(2408),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2409),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4133),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4135),
    [anon_sym_yield] = ACTIONS(4137),
    [anon_sym_break] = ACTIONS(4139),
    [anon_sym_next] = ACTIONS(4141),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4143),
    [anon_sym_defined_QMARK] = ACTIONS(4145),
    [anon_sym_not] = ACTIONS(4147),
    [anon_sym_BANG] = ACTIONS(4149),
    [anon_sym_TILDE] = ACTIONS(4149),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4853] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7374),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2408),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(2408),
    [sym_assignment] = STATE(7374),
    [sym_operator_assignment] = STATE(7374),
    [sym_conditional] = STATE(7374),
    [sym_range] = STATE(7374),
    [sym_binary] = STATE(7374),
    [sym_unary] = STATE(7374),
    [sym_left_assignment_list] = STATE(2407),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2408),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2408),
    [sym_false] = STATE(2408),
    [sym_nil] = STATE(2408),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2409),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4133),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4135),
    [anon_sym_yield] = ACTIONS(4137),
    [anon_sym_break] = ACTIONS(4139),
    [anon_sym_next] = ACTIONS(4141),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4143),
    [anon_sym_defined_QMARK] = ACTIONS(4145),
    [anon_sym_not] = ACTIONS(4147),
    [anon_sym_BANG] = ACTIONS(4149),
    [anon_sym_TILDE] = ACTIONS(4149),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4854] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7375),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2408),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(2408),
    [sym_assignment] = STATE(7375),
    [sym_operator_assignment] = STATE(7375),
    [sym_conditional] = STATE(7375),
    [sym_range] = STATE(7375),
    [sym_binary] = STATE(7375),
    [sym_unary] = STATE(7375),
    [sym_left_assignment_list] = STATE(2407),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2408),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2408),
    [sym_false] = STATE(2408),
    [sym_nil] = STATE(2408),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2409),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4133),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4135),
    [anon_sym_yield] = ACTIONS(4137),
    [anon_sym_break] = ACTIONS(4139),
    [anon_sym_next] = ACTIONS(4141),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4143),
    [anon_sym_defined_QMARK] = ACTIONS(4145),
    [anon_sym_not] = ACTIONS(4147),
    [anon_sym_BANG] = ACTIONS(4149),
    [anon_sym_TILDE] = ACTIONS(4149),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4855] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7376),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2408),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(2408),
    [sym_assignment] = STATE(7376),
    [sym_operator_assignment] = STATE(7376),
    [sym_conditional] = STATE(7376),
    [sym_range] = STATE(7376),
    [sym_binary] = STATE(7376),
    [sym_unary] = STATE(7376),
    [sym_left_assignment_list] = STATE(2407),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2408),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2408),
    [sym_false] = STATE(2408),
    [sym_nil] = STATE(2408),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2409),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4133),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4135),
    [anon_sym_yield] = ACTIONS(4137),
    [anon_sym_break] = ACTIONS(4139),
    [anon_sym_next] = ACTIONS(4141),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4143),
    [anon_sym_defined_QMARK] = ACTIONS(4145),
    [anon_sym_not] = ACTIONS(4147),
    [anon_sym_BANG] = ACTIONS(4149),
    [anon_sym_TILDE] = ACTIONS(4149),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4856] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7377),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2408),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(2408),
    [sym_splat_argument] = STATE(7378),
    [sym_assignment] = STATE(7377),
    [sym_operator_assignment] = STATE(7377),
    [sym_conditional] = STATE(7377),
    [sym_range] = STATE(7377),
    [sym_binary] = STATE(7377),
    [sym_unary] = STATE(7377),
    [sym_right_assignment_list] = STATE(4255),
    [sym__arg_or_splat_arg] = STATE(7378),
    [sym_left_assignment_list] = STATE(2407),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2408),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2408),
    [sym_false] = STATE(2408),
    [sym_nil] = STATE(2408),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2409),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(7770),
    [sym__unary_minus] = ACTIONS(4133),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4135),
    [anon_sym_yield] = ACTIONS(4137),
    [anon_sym_break] = ACTIONS(4139),
    [anon_sym_next] = ACTIONS(4141),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4143),
    [anon_sym_defined_QMARK] = ACTIONS(4145),
    [anon_sym_not] = ACTIONS(4147),
    [anon_sym_BANG] = ACTIONS(4149),
    [anon_sym_TILDE] = ACTIONS(4149),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4857] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7379),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2408),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(2408),
    [sym_assignment] = STATE(7379),
    [sym_operator_assignment] = STATE(7379),
    [sym_conditional] = STATE(7379),
    [sym_range] = STATE(7379),
    [sym_binary] = STATE(7379),
    [sym_unary] = STATE(7379),
    [sym_left_assignment_list] = STATE(2407),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2408),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2408),
    [sym_false] = STATE(2408),
    [sym_nil] = STATE(2408),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2409),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4133),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4135),
    [anon_sym_yield] = ACTIONS(4137),
    [anon_sym_break] = ACTIONS(4139),
    [anon_sym_next] = ACTIONS(4141),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4143),
    [anon_sym_defined_QMARK] = ACTIONS(4145),
    [anon_sym_not] = ACTIONS(4147),
    [anon_sym_BANG] = ACTIONS(4149),
    [anon_sym_TILDE] = ACTIONS(4149),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4858] = {
    [sym_string] = STATE(7380),
    [aux_sym_chained_string_repeat1] = STATE(7380),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [4859] = {
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(7776),
    [sym__binary_star] = ACTIONS(7778),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(7780),
    [anon_sym_STAR_STAR] = ACTIONS(7778),
    [anon_sym_AMP] = ACTIONS(7782),
    [anon_sym_LT] = ACTIONS(7784),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(7786),
    [anon_sym_DOT_DOT] = ACTIONS(7788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7790),
    [anon_sym_and] = ACTIONS(7792),
    [anon_sym_or] = ACTIONS(7792),
    [anon_sym_PIPE_PIPE] = ACTIONS(7794),
    [anon_sym_AMP_AMP] = ACTIONS(7794),
    [anon_sym_LT_LT] = ACTIONS(7796),
    [anon_sym_GT_GT] = ACTIONS(7796),
    [anon_sym_EQ_EQ] = ACTIONS(7798),
    [anon_sym_BANG_EQ] = ACTIONS(7794),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7794),
    [anon_sym_LT_EQ_GT] = ACTIONS(7794),
    [anon_sym_EQ_TILDE] = ACTIONS(7794),
    [anon_sym_BANG_TILDE] = ACTIONS(7794),
    [anon_sym_LT_EQ] = ACTIONS(7784),
    [anon_sym_GT] = ACTIONS(7784),
    [anon_sym_GT_EQ] = ACTIONS(7800),
    [anon_sym_CARET] = ACTIONS(7802),
    [anon_sym_PLUS] = ACTIONS(7776),
    [anon_sym_SLASH] = ACTIONS(7778),
    [anon_sym_PERCENT] = ACTIONS(7778),
    [sym_comment] = ACTIONS(87),
  },
  [4860] = {
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(4167),
    [sym__binary_star] = ACTIONS(4169),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(4171),
    [anon_sym_STAR_STAR] = ACTIONS(4169),
    [anon_sym_AMP] = ACTIONS(4173),
    [anon_sym_LT] = ACTIONS(4175),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_EQ_GT] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_DOT_DOT] = ACTIONS(4179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4181),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(4185),
    [anon_sym_AMP_AMP] = ACTIONS(4185),
    [anon_sym_LT_LT] = ACTIONS(4187),
    [anon_sym_GT_GT] = ACTIONS(4187),
    [anon_sym_EQ_EQ] = ACTIONS(4189),
    [anon_sym_BANG_EQ] = ACTIONS(4185),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4185),
    [anon_sym_LT_EQ_GT] = ACTIONS(4185),
    [anon_sym_EQ_TILDE] = ACTIONS(4185),
    [anon_sym_BANG_TILDE] = ACTIONS(4185),
    [anon_sym_LT_EQ] = ACTIONS(4175),
    [anon_sym_GT] = ACTIONS(4175),
    [anon_sym_GT_EQ] = ACTIONS(4191),
    [anon_sym_CARET] = ACTIONS(4193),
    [anon_sym_PLUS] = ACTIONS(4167),
    [anon_sym_SLASH] = ACTIONS(4169),
    [anon_sym_PERCENT] = ACTIONS(4169),
    [sym_comment] = ACTIONS(87),
  },
  [4861] = {
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(4167),
    [sym__binary_star] = ACTIONS(4169),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(4171),
    [anon_sym_STAR_STAR] = ACTIONS(4169),
    [anon_sym_AMP] = ACTIONS(4173),
    [anon_sym_LT] = ACTIONS(4175),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_EQ_GT] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_DOT_DOT] = ACTIONS(4179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4181),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(4185),
    [anon_sym_AMP_AMP] = ACTIONS(4185),
    [anon_sym_LT_LT] = ACTIONS(4187),
    [anon_sym_GT_GT] = ACTIONS(4187),
    [anon_sym_EQ_EQ] = ACTIONS(4189),
    [anon_sym_BANG_EQ] = ACTIONS(4185),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4185),
    [anon_sym_LT_EQ_GT] = ACTIONS(4185),
    [anon_sym_EQ_TILDE] = ACTIONS(4185),
    [anon_sym_BANG_TILDE] = ACTIONS(4185),
    [anon_sym_LT_EQ] = ACTIONS(4175),
    [anon_sym_GT] = ACTIONS(4175),
    [anon_sym_GT_EQ] = ACTIONS(4191),
    [anon_sym_CARET] = ACTIONS(4193),
    [anon_sym_PLUS] = ACTIONS(4167),
    [anon_sym_SLASH] = ACTIONS(4169),
    [anon_sym_PERCENT] = ACTIONS(4169),
    [sym_comment] = ACTIONS(87),
  },
  [4862] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(7381),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym_assignment] = STATE(7381),
    [sym_operator_assignment] = STATE(7381),
    [sym_conditional] = STATE(7381),
    [sym_range] = STATE(7381),
    [sym_binary] = STATE(7381),
    [sym_unary] = STATE(7381),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2412),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4863] = {
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(4167),
    [sym__binary_star] = ACTIONS(4169),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(4171),
    [anon_sym_STAR_STAR] = ACTIONS(4169),
    [anon_sym_AMP] = ACTIONS(4173),
    [anon_sym_LT] = ACTIONS(4175),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_EQ_GT] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_DOT_DOT] = ACTIONS(4179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4181),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(4185),
    [anon_sym_AMP_AMP] = ACTIONS(4185),
    [anon_sym_LT_LT] = ACTIONS(4187),
    [anon_sym_GT_GT] = ACTIONS(4187),
    [anon_sym_EQ_EQ] = ACTIONS(4189),
    [anon_sym_BANG_EQ] = ACTIONS(4185),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4185),
    [anon_sym_LT_EQ_GT] = ACTIONS(4185),
    [anon_sym_EQ_TILDE] = ACTIONS(4185),
    [anon_sym_BANG_TILDE] = ACTIONS(4185),
    [anon_sym_LT_EQ] = ACTIONS(4175),
    [anon_sym_GT] = ACTIONS(4175),
    [anon_sym_GT_EQ] = ACTIONS(4191),
    [anon_sym_CARET] = ACTIONS(4193),
    [anon_sym_PLUS] = ACTIONS(4167),
    [anon_sym_SLASH] = ACTIONS(4169),
    [anon_sym_PERCENT] = ACTIONS(4169),
    [sym_comment] = ACTIONS(87),
  },
  [4864] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(7382),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym_assignment] = STATE(7382),
    [sym_operator_assignment] = STATE(7382),
    [sym_conditional] = STATE(7382),
    [sym_range] = STATE(7382),
    [sym_binary] = STATE(7382),
    [sym_unary] = STATE(7382),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2412),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4865] = {
    [sym_heredoc_body] = STATE(7383),
    [aux_sym_call_repeat1] = STATE(7383),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [4866] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(2421),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym__argument] = STATE(4250),
    [sym_splat_argument] = STATE(4250),
    [sym_hash_splat_argument] = STATE(4250),
    [sym_block_argument] = STATE(4250),
    [sym_assignment] = STATE(2421),
    [sym_operator_assignment] = STATE(2421),
    [sym_conditional] = STATE(2421),
    [sym_range] = STATE(2421),
    [sym_binary] = STATE(2421),
    [sym_unary] = STATE(2421),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2424),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_heredoc_body] = STATE(7384),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(4250),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(4155),
    [sym__splat_star] = ACTIONS(4157),
    [sym__unary_minus] = ACTIONS(1525),
    [sym__identifier_hash_key] = ACTIONS(4159),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10943),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(4163),
    [sym_identifier] = ACTIONS(4163),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4867] = {
    [sym_heredoc_body] = STATE(7385),
    [aux_sym_call_repeat1] = STATE(7385),
    [aux_sym_argument_list_repeat1] = STATE(7386),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(7814),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [4868] = {
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(7776),
    [sym__binary_star] = ACTIONS(7778),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(7780),
    [anon_sym_STAR_STAR] = ACTIONS(7778),
    [anon_sym_AMP] = ACTIONS(7782),
    [anon_sym_LT] = ACTIONS(7784),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(7786),
    [anon_sym_DOT_DOT] = ACTIONS(7788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7790),
    [anon_sym_and] = ACTIONS(7792),
    [anon_sym_or] = ACTIONS(7792),
    [anon_sym_PIPE_PIPE] = ACTIONS(7794),
    [anon_sym_AMP_AMP] = ACTIONS(7794),
    [anon_sym_LT_LT] = ACTIONS(7796),
    [anon_sym_GT_GT] = ACTIONS(7796),
    [anon_sym_EQ_EQ] = ACTIONS(7798),
    [anon_sym_BANG_EQ] = ACTIONS(7794),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7794),
    [anon_sym_LT_EQ_GT] = ACTIONS(7794),
    [anon_sym_EQ_TILDE] = ACTIONS(7794),
    [anon_sym_BANG_TILDE] = ACTIONS(7794),
    [anon_sym_LT_EQ] = ACTIONS(7784),
    [anon_sym_GT] = ACTIONS(7784),
    [anon_sym_GT_EQ] = ACTIONS(7800),
    [anon_sym_CARET] = ACTIONS(7802),
    [anon_sym_PLUS] = ACTIONS(7776),
    [anon_sym_SLASH] = ACTIONS(7778),
    [anon_sym_PERCENT] = ACTIONS(7778),
    [sym_comment] = ACTIONS(87),
  },
  [4869] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(4169),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(4169),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(4169),
    [anon_sym_PERCENT] = ACTIONS(4169),
    [sym_comment] = ACTIONS(87),
  },
  [4870] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(4169),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [4871] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4167),
    [sym__binary_star] = ACTIONS(4169),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(4169),
    [anon_sym_AMP] = ACTIONS(4173),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(4187),
    [anon_sym_GT_GT] = ACTIONS(4187),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(4167),
    [anon_sym_SLASH] = ACTIONS(4169),
    [anon_sym_PERCENT] = ACTIONS(4169),
    [sym_comment] = ACTIONS(87),
  },
  [4872] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4167),
    [sym__binary_star] = ACTIONS(4169),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(4169),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(4187),
    [anon_sym_GT_GT] = ACTIONS(4187),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(4167),
    [anon_sym_SLASH] = ACTIONS(4169),
    [anon_sym_PERCENT] = ACTIONS(4169),
    [sym_comment] = ACTIONS(87),
  },
  [4873] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4167),
    [sym__binary_star] = ACTIONS(4169),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(4171),
    [anon_sym_STAR_STAR] = ACTIONS(4169),
    [anon_sym_AMP] = ACTIONS(4173),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(4187),
    [anon_sym_GT_GT] = ACTIONS(4187),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(4193),
    [anon_sym_PLUS] = ACTIONS(4167),
    [anon_sym_SLASH] = ACTIONS(4169),
    [anon_sym_PERCENT] = ACTIONS(4169),
    [sym_comment] = ACTIONS(87),
  },
  [4874] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(10945),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [4875] = {
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(4167),
    [sym__binary_star] = ACTIONS(4169),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(4171),
    [anon_sym_STAR_STAR] = ACTIONS(4169),
    [anon_sym_AMP] = ACTIONS(4173),
    [anon_sym_LT] = ACTIONS(4175),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_EQ_GT] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(4179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4181),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(4185),
    [anon_sym_AMP_AMP] = ACTIONS(4185),
    [anon_sym_LT_LT] = ACTIONS(4187),
    [anon_sym_GT_GT] = ACTIONS(4187),
    [anon_sym_EQ_EQ] = ACTIONS(4189),
    [anon_sym_BANG_EQ] = ACTIONS(4185),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4185),
    [anon_sym_LT_EQ_GT] = ACTIONS(4185),
    [anon_sym_EQ_TILDE] = ACTIONS(4185),
    [anon_sym_BANG_TILDE] = ACTIONS(4185),
    [anon_sym_LT_EQ] = ACTIONS(4175),
    [anon_sym_GT] = ACTIONS(4175),
    [anon_sym_GT_EQ] = ACTIONS(4191),
    [anon_sym_CARET] = ACTIONS(4193),
    [anon_sym_PLUS] = ACTIONS(4167),
    [anon_sym_SLASH] = ACTIONS(4169),
    [anon_sym_PERCENT] = ACTIONS(4169),
    [sym_comment] = ACTIONS(87),
  },
  [4876] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4167),
    [sym__binary_star] = ACTIONS(4169),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(4171),
    [anon_sym_STAR_STAR] = ACTIONS(4169),
    [anon_sym_AMP] = ACTIONS(4173),
    [anon_sym_LT] = ACTIONS(4175),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_DOT_DOT] = ACTIONS(4179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4181),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(4185),
    [anon_sym_AMP_AMP] = ACTIONS(4185),
    [anon_sym_LT_LT] = ACTIONS(4187),
    [anon_sym_GT_GT] = ACTIONS(4187),
    [anon_sym_EQ_EQ] = ACTIONS(4189),
    [anon_sym_BANG_EQ] = ACTIONS(4185),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4185),
    [anon_sym_LT_EQ_GT] = ACTIONS(4185),
    [anon_sym_EQ_TILDE] = ACTIONS(4185),
    [anon_sym_BANG_TILDE] = ACTIONS(4185),
    [anon_sym_LT_EQ] = ACTIONS(4175),
    [anon_sym_GT] = ACTIONS(4175),
    [anon_sym_GT_EQ] = ACTIONS(4191),
    [anon_sym_CARET] = ACTIONS(4193),
    [anon_sym_PLUS] = ACTIONS(4167),
    [anon_sym_SLASH] = ACTIONS(4169),
    [anon_sym_PERCENT] = ACTIONS(4169),
    [sym_comment] = ACTIONS(87),
  },
  [4877] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4167),
    [sym__binary_star] = ACTIONS(4169),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(4171),
    [anon_sym_STAR_STAR] = ACTIONS(4169),
    [anon_sym_AMP] = ACTIONS(4173),
    [anon_sym_LT] = ACTIONS(4175),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(4187),
    [anon_sym_GT_GT] = ACTIONS(4187),
    [anon_sym_EQ_EQ] = ACTIONS(4189),
    [anon_sym_BANG_EQ] = ACTIONS(4185),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4185),
    [anon_sym_LT_EQ_GT] = ACTIONS(4185),
    [anon_sym_EQ_TILDE] = ACTIONS(4185),
    [anon_sym_BANG_TILDE] = ACTIONS(4185),
    [anon_sym_LT_EQ] = ACTIONS(4175),
    [anon_sym_GT] = ACTIONS(4175),
    [anon_sym_GT_EQ] = ACTIONS(4191),
    [anon_sym_CARET] = ACTIONS(4193),
    [anon_sym_PLUS] = ACTIONS(4167),
    [anon_sym_SLASH] = ACTIONS(4169),
    [anon_sym_PERCENT] = ACTIONS(4169),
    [sym_comment] = ACTIONS(87),
  },
  [4878] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4167),
    [sym__binary_star] = ACTIONS(4169),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(4169),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(4167),
    [anon_sym_SLASH] = ACTIONS(4169),
    [anon_sym_PERCENT] = ACTIONS(4169),
    [sym_comment] = ACTIONS(87),
  },
  [4879] = {
    [sym_heredoc_body] = STATE(4879),
    [aux_sym_call_repeat1] = STATE(4879),
    [sym__heredoc_body_start] = ACTIONS(10810),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7914),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [4880] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(859),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym__argument] = STATE(6088),
    [sym_splat_argument] = STATE(6088),
    [sym_hash_splat_argument] = STATE(6088),
    [sym_block_argument] = STATE(6088),
    [sym_assignment] = STATE(859),
    [sym_operator_assignment] = STATE(859),
    [sym_conditional] = STATE(859),
    [sym_range] = STATE(859),
    [sym_binary] = STATE(859),
    [sym_unary] = STATE(859),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(864),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(6088),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1521),
    [sym__splat_star] = ACTIONS(1523),
    [sym__unary_minus] = ACTIONS(1525),
    [sym__identifier_hash_key] = ACTIONS(1527),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1531),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(1549),
    [sym_identifier] = ACTIONS(1549),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4881] = {
    [sym_heredoc_body] = STATE(4879),
    [aux_sym_call_repeat1] = STATE(4879),
    [sym__heredoc_body_start] = ACTIONS(3959),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7929),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [4882] = {
    [aux_sym_argument_list_repeat1] = STATE(4882),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7925),
    [anon_sym_COMMA] = ACTIONS(10947),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [4883] = {
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(4167),
    [sym__binary_star] = ACTIONS(4169),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(4171),
    [anon_sym_STAR_STAR] = ACTIONS(4169),
    [anon_sym_AMP] = ACTIONS(4173),
    [anon_sym_LT] = ACTIONS(4175),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_EQ_GT] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_DOT_DOT] = ACTIONS(4179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4181),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(4185),
    [anon_sym_AMP_AMP] = ACTIONS(4185),
    [anon_sym_LT_LT] = ACTIONS(4187),
    [anon_sym_GT_GT] = ACTIONS(4187),
    [anon_sym_EQ_EQ] = ACTIONS(4189),
    [anon_sym_BANG_EQ] = ACTIONS(4185),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4185),
    [anon_sym_LT_EQ_GT] = ACTIONS(4185),
    [anon_sym_EQ_TILDE] = ACTIONS(4185),
    [anon_sym_BANG_TILDE] = ACTIONS(4185),
    [anon_sym_LT_EQ] = ACTIONS(4175),
    [anon_sym_GT] = ACTIONS(4175),
    [anon_sym_GT_EQ] = ACTIONS(4191),
    [anon_sym_CARET] = ACTIONS(4193),
    [anon_sym_PLUS] = ACTIONS(4167),
    [anon_sym_SLASH] = ACTIONS(4169),
    [anon_sym_PERCENT] = ACTIONS(4169),
    [sym_comment] = ACTIONS(87),
  },
  [4884] = {
    [aux_sym_exceptions_repeat1] = STATE(7389),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [4885] = {
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(4167),
    [sym__binary_star] = ACTIONS(4169),
    [anon_sym_LBRACE] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(4171),
    [anon_sym_STAR_STAR] = ACTIONS(4169),
    [anon_sym_AMP] = ACTIONS(4173),
    [anon_sym_LT] = ACTIONS(4175),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_EQ_GT] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_DOT_DOT] = ACTIONS(4179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4181),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(4185),
    [anon_sym_AMP_AMP] = ACTIONS(4185),
    [anon_sym_LT_LT] = ACTIONS(4187),
    [anon_sym_GT_GT] = ACTIONS(4187),
    [anon_sym_EQ_EQ] = ACTIONS(4189),
    [anon_sym_BANG_EQ] = ACTIONS(4185),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4185),
    [anon_sym_LT_EQ_GT] = ACTIONS(4185),
    [anon_sym_EQ_TILDE] = ACTIONS(4185),
    [anon_sym_BANG_TILDE] = ACTIONS(4185),
    [anon_sym_LT_EQ] = ACTIONS(4175),
    [anon_sym_GT] = ACTIONS(4175),
    [anon_sym_GT_EQ] = ACTIONS(4191),
    [anon_sym_CARET] = ACTIONS(4193),
    [anon_sym_PLUS] = ACTIONS(4167),
    [anon_sym_SLASH] = ACTIONS(4169),
    [anon_sym_PERCENT] = ACTIONS(4169),
    [sym_comment] = ACTIONS(87),
  },
  [4886] = {
    [sym_string] = STATE(4886),
    [aux_sym_chained_string_repeat1] = STATE(4886),
    [sym__string_start] = ACTIONS(9407),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_do] = ACTIONS(6212),
    [anon_sym_EQ_GT] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [4887] = {
    [sym_heredoc_body] = STATE(7390),
    [aux_sym_call_repeat1] = STATE(7390),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [ts_builtin_sym_end] = ACTIONS(4383),
    [anon_sym___END__] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [4888] = {
    [sym_heredoc_body] = STATE(7391),
    [aux_sym_call_repeat1] = STATE(7391),
    [aux_sym_argument_list_repeat1] = STATE(2568),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [ts_builtin_sym_end] = ACTIONS(4383),
    [anon_sym___END__] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(1687),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [4889] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(4215),
    [ts_builtin_sym_end] = ACTIONS(5825),
    [anon_sym___END__] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(4215),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(4215),
    [anon_sym_PERCENT] = ACTIONS(4215),
    [sym_comment] = ACTIONS(87),
  },
  [4890] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [ts_builtin_sym_end] = ACTIONS(5825),
    [anon_sym___END__] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(4215),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [4891] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4213),
    [sym__binary_star] = ACTIONS(4215),
    [ts_builtin_sym_end] = ACTIONS(5825),
    [anon_sym___END__] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(4215),
    [anon_sym_AMP] = ACTIONS(4221),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(4233),
    [anon_sym_GT_GT] = ACTIONS(4233),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(4213),
    [anon_sym_SLASH] = ACTIONS(4215),
    [anon_sym_PERCENT] = ACTIONS(4215),
    [sym_comment] = ACTIONS(87),
  },
  [4892] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4213),
    [sym__binary_star] = ACTIONS(4215),
    [ts_builtin_sym_end] = ACTIONS(5825),
    [anon_sym___END__] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(4215),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(4233),
    [anon_sym_GT_GT] = ACTIONS(4233),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(4213),
    [anon_sym_SLASH] = ACTIONS(4215),
    [anon_sym_PERCENT] = ACTIONS(4215),
    [sym_comment] = ACTIONS(87),
  },
  [4893] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4213),
    [sym__binary_star] = ACTIONS(4215),
    [ts_builtin_sym_end] = ACTIONS(5825),
    [anon_sym___END__] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(4219),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(4215),
    [anon_sym_AMP] = ACTIONS(4221),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(4233),
    [anon_sym_GT_GT] = ACTIONS(4233),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(4239),
    [anon_sym_PLUS] = ACTIONS(4213),
    [anon_sym_SLASH] = ACTIONS(4215),
    [anon_sym_PERCENT] = ACTIONS(4215),
    [sym_comment] = ACTIONS(87),
  },
  [4894] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(10950),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [4895] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(4213),
    [sym__binary_star] = ACTIONS(4215),
    [ts_builtin_sym_end] = ACTIONS(5927),
    [anon_sym___END__] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(4219),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(4215),
    [anon_sym_AMP] = ACTIONS(4221),
    [anon_sym_LT] = ACTIONS(4223),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(4227),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4229),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(4231),
    [anon_sym_AMP_AMP] = ACTIONS(4231),
    [anon_sym_LT_LT] = ACTIONS(4233),
    [anon_sym_GT_GT] = ACTIONS(4233),
    [anon_sym_EQ_EQ] = ACTIONS(4235),
    [anon_sym_BANG_EQ] = ACTIONS(4231),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4231),
    [anon_sym_LT_EQ_GT] = ACTIONS(4231),
    [anon_sym_EQ_TILDE] = ACTIONS(4231),
    [anon_sym_BANG_TILDE] = ACTIONS(4231),
    [anon_sym_LT_EQ] = ACTIONS(4223),
    [anon_sym_GT] = ACTIONS(4223),
    [anon_sym_GT_EQ] = ACTIONS(4237),
    [anon_sym_CARET] = ACTIONS(4239),
    [anon_sym_PLUS] = ACTIONS(4213),
    [anon_sym_SLASH] = ACTIONS(4215),
    [anon_sym_PERCENT] = ACTIONS(4215),
    [sym_comment] = ACTIONS(87),
  },
  [4896] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4213),
    [sym__binary_star] = ACTIONS(4215),
    [ts_builtin_sym_end] = ACTIONS(5825),
    [anon_sym___END__] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(4219),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(4215),
    [anon_sym_AMP] = ACTIONS(4221),
    [anon_sym_LT] = ACTIONS(4223),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(4225),
    [anon_sym_DOT_DOT] = ACTIONS(4227),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4229),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(4231),
    [anon_sym_AMP_AMP] = ACTIONS(4231),
    [anon_sym_LT_LT] = ACTIONS(4233),
    [anon_sym_GT_GT] = ACTIONS(4233),
    [anon_sym_EQ_EQ] = ACTIONS(4235),
    [anon_sym_BANG_EQ] = ACTIONS(4231),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4231),
    [anon_sym_LT_EQ_GT] = ACTIONS(4231),
    [anon_sym_EQ_TILDE] = ACTIONS(4231),
    [anon_sym_BANG_TILDE] = ACTIONS(4231),
    [anon_sym_LT_EQ] = ACTIONS(4223),
    [anon_sym_GT] = ACTIONS(4223),
    [anon_sym_GT_EQ] = ACTIONS(4237),
    [anon_sym_CARET] = ACTIONS(4239),
    [anon_sym_PLUS] = ACTIONS(4213),
    [anon_sym_SLASH] = ACTIONS(4215),
    [anon_sym_PERCENT] = ACTIONS(4215),
    [sym_comment] = ACTIONS(87),
  },
  [4897] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4213),
    [sym__binary_star] = ACTIONS(4215),
    [ts_builtin_sym_end] = ACTIONS(5825),
    [anon_sym___END__] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(4219),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(4215),
    [anon_sym_AMP] = ACTIONS(4221),
    [anon_sym_LT] = ACTIONS(4223),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(4233),
    [anon_sym_GT_GT] = ACTIONS(4233),
    [anon_sym_EQ_EQ] = ACTIONS(4235),
    [anon_sym_BANG_EQ] = ACTIONS(4231),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4231),
    [anon_sym_LT_EQ_GT] = ACTIONS(4231),
    [anon_sym_EQ_TILDE] = ACTIONS(4231),
    [anon_sym_BANG_TILDE] = ACTIONS(4231),
    [anon_sym_LT_EQ] = ACTIONS(4223),
    [anon_sym_GT] = ACTIONS(4223),
    [anon_sym_GT_EQ] = ACTIONS(4237),
    [anon_sym_CARET] = ACTIONS(4239),
    [anon_sym_PLUS] = ACTIONS(4213),
    [anon_sym_SLASH] = ACTIONS(4215),
    [anon_sym_PERCENT] = ACTIONS(4215),
    [sym_comment] = ACTIONS(87),
  },
  [4898] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4213),
    [sym__binary_star] = ACTIONS(4215),
    [ts_builtin_sym_end] = ACTIONS(5825),
    [anon_sym___END__] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(4215),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(4213),
    [anon_sym_SLASH] = ACTIONS(4215),
    [anon_sym_PERCENT] = ACTIONS(4215),
    [sym_comment] = ACTIONS(87),
  },
  [4899] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(4213),
    [sym__binary_star] = ACTIONS(4215),
    [ts_builtin_sym_end] = ACTIONS(5115),
    [anon_sym___END__] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(4219),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(4215),
    [anon_sym_AMP] = ACTIONS(4221),
    [anon_sym_LT] = ACTIONS(4223),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(4225),
    [anon_sym_DOT_DOT] = ACTIONS(4227),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4229),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(4231),
    [anon_sym_AMP_AMP] = ACTIONS(4231),
    [anon_sym_LT_LT] = ACTIONS(4233),
    [anon_sym_GT_GT] = ACTIONS(4233),
    [anon_sym_EQ_EQ] = ACTIONS(4235),
    [anon_sym_BANG_EQ] = ACTIONS(4231),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4231),
    [anon_sym_LT_EQ_GT] = ACTIONS(4231),
    [anon_sym_EQ_TILDE] = ACTIONS(4231),
    [anon_sym_BANG_TILDE] = ACTIONS(4231),
    [anon_sym_LT_EQ] = ACTIONS(4223),
    [anon_sym_GT] = ACTIONS(4223),
    [anon_sym_GT_EQ] = ACTIONS(4237),
    [anon_sym_CARET] = ACTIONS(4239),
    [anon_sym_PLUS] = ACTIONS(4213),
    [anon_sym_SLASH] = ACTIONS(4215),
    [anon_sym_PERCENT] = ACTIONS(4215),
    [sym_comment] = ACTIONS(87),
  },
  [4900] = {
    [aux_sym_exceptions_repeat1] = STATE(7394),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [ts_builtin_sym_end] = ACTIONS(6191),
    [anon_sym___END__] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [4901] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(4213),
    [sym__binary_star] = ACTIONS(4215),
    [ts_builtin_sym_end] = ACTIONS(6210),
    [anon_sym___END__] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(4219),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(4215),
    [anon_sym_AMP] = ACTIONS(4221),
    [anon_sym_LT] = ACTIONS(4223),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(4225),
    [anon_sym_DOT_DOT] = ACTIONS(4227),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4229),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(4231),
    [anon_sym_AMP_AMP] = ACTIONS(4231),
    [anon_sym_LT_LT] = ACTIONS(4233),
    [anon_sym_GT_GT] = ACTIONS(4233),
    [anon_sym_EQ_EQ] = ACTIONS(4235),
    [anon_sym_BANG_EQ] = ACTIONS(4231),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4231),
    [anon_sym_LT_EQ_GT] = ACTIONS(4231),
    [anon_sym_EQ_TILDE] = ACTIONS(4231),
    [anon_sym_BANG_TILDE] = ACTIONS(4231),
    [anon_sym_LT_EQ] = ACTIONS(4223),
    [anon_sym_GT] = ACTIONS(4223),
    [anon_sym_GT_EQ] = ACTIONS(4237),
    [anon_sym_CARET] = ACTIONS(4239),
    [anon_sym_PLUS] = ACTIONS(4213),
    [anon_sym_SLASH] = ACTIONS(4215),
    [anon_sym_PERCENT] = ACTIONS(4215),
    [sym_comment] = ACTIONS(87),
  },
  [4902] = {
    [sym_string] = STATE(4902),
    [aux_sym_chained_string_repeat1] = STATE(4902),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(6214),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [ts_builtin_sym_end] = ACTIONS(6212),
    [anon_sym___END__] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [4903] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(1627),
    [sym__binary_star] = ACTIONS(1629),
    [ts_builtin_sym_end] = ACTIONS(6823),
    [anon_sym___END__] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(1633),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(1629),
    [anon_sym_AMP] = ACTIONS(1635),
    [anon_sym_LT] = ACTIONS(1637),
    [anon_sym_if] = ACTIONS(6823),
    [anon_sym_unless] = ACTIONS(6823),
    [anon_sym_while] = ACTIONS(6823),
    [anon_sym_until] = ACTIONS(6823),
    [anon_sym_rescue] = ACTIONS(6823),
    [anon_sym_EQ_GT] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(1639),
    [anon_sym_DOT_DOT] = ACTIONS(1641),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1643),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(1645),
    [anon_sym_AMP_AMP] = ACTIONS(1645),
    [anon_sym_LT_LT] = ACTIONS(1647),
    [anon_sym_GT_GT] = ACTIONS(1647),
    [anon_sym_EQ_EQ] = ACTIONS(1649),
    [anon_sym_BANG_EQ] = ACTIONS(1645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1645),
    [anon_sym_LT_EQ_GT] = ACTIONS(1645),
    [anon_sym_EQ_TILDE] = ACTIONS(1645),
    [anon_sym_BANG_TILDE] = ACTIONS(1645),
    [anon_sym_LT_EQ] = ACTIONS(1637),
    [anon_sym_GT] = ACTIONS(1637),
    [anon_sym_GT_EQ] = ACTIONS(1651),
    [anon_sym_CARET] = ACTIONS(1653),
    [anon_sym_PLUS] = ACTIONS(1627),
    [anon_sym_SLASH] = ACTIONS(1629),
    [anon_sym_PERCENT] = ACTIONS(1629),
    [sym_comment] = ACTIONS(87),
  },
  [4904] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(1627),
    [sym__binary_star] = ACTIONS(1629),
    [ts_builtin_sym_end] = ACTIONS(7027),
    [anon_sym___END__] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(1633),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(1629),
    [anon_sym_AMP] = ACTIONS(1635),
    [anon_sym_LT] = ACTIONS(1637),
    [anon_sym_if] = ACTIONS(7027),
    [anon_sym_unless] = ACTIONS(7027),
    [anon_sym_while] = ACTIONS(7027),
    [anon_sym_until] = ACTIONS(7027),
    [anon_sym_rescue] = ACTIONS(7027),
    [anon_sym_EQ_GT] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(1639),
    [anon_sym_DOT_DOT] = ACTIONS(1641),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1643),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(1645),
    [anon_sym_AMP_AMP] = ACTIONS(1645),
    [anon_sym_LT_LT] = ACTIONS(1647),
    [anon_sym_GT_GT] = ACTIONS(1647),
    [anon_sym_EQ_EQ] = ACTIONS(1649),
    [anon_sym_BANG_EQ] = ACTIONS(1645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1645),
    [anon_sym_LT_EQ_GT] = ACTIONS(1645),
    [anon_sym_EQ_TILDE] = ACTIONS(1645),
    [anon_sym_BANG_TILDE] = ACTIONS(1645),
    [anon_sym_LT_EQ] = ACTIONS(1637),
    [anon_sym_GT] = ACTIONS(1637),
    [anon_sym_GT_EQ] = ACTIONS(1651),
    [anon_sym_CARET] = ACTIONS(1653),
    [anon_sym_PLUS] = ACTIONS(1627),
    [anon_sym_SLASH] = ACTIONS(1629),
    [anon_sym_PERCENT] = ACTIONS(1629),
    [sym_comment] = ACTIONS(87),
  },
  [4905] = {
    [sym_heredoc_body] = STATE(4905),
    [aux_sym_call_repeat1] = STATE(4905),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(7916),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [ts_builtin_sym_end] = ACTIONS(7914),
    [anon_sym___END__] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_EQ_GT] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [4906] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(889),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym__argument] = STATE(4986),
    [sym_splat_argument] = STATE(4986),
    [sym_hash_splat_argument] = STATE(4986),
    [sym_block_argument] = STATE(4986),
    [sym_assignment] = STATE(889),
    [sym_operator_assignment] = STATE(889),
    [sym_conditional] = STATE(889),
    [sym_range] = STATE(889),
    [sym_binary] = STATE(889),
    [sym_unary] = STATE(889),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(892),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4986),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(1581),
    [sym__splat_star] = ACTIONS(1583),
    [sym__unary_minus] = ACTIONS(373),
    [sym__identifier_hash_key] = ACTIONS(1585),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(7824),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(383),
    [anon_sym_yield] = ACTIONS(385),
    [anon_sym_break] = ACTIONS(387),
    [anon_sym_next] = ACTIONS(389),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1575),
    [anon_sym_defined_QMARK] = ACTIONS(395),
    [anon_sym_not] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_TILDE] = ACTIONS(401),
    [sym_constant] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1587),
    [sym_instance_variable] = ACTIONS(405),
    [sym_class_variable] = ACTIONS(405),
    [sym_global_variable] = ACTIONS(405),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(407),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(407),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4907] = {
    [sym_heredoc_body] = STATE(4905),
    [aux_sym_call_repeat1] = STATE(4905),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [ts_builtin_sym_end] = ACTIONS(7929),
    [anon_sym___END__] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_EQ_GT] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [4908] = {
    [aux_sym_argument_list_repeat1] = STATE(4908),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [ts_builtin_sym_end] = ACTIONS(7925),
    [anon_sym___END__] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(10952),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7925),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_if] = ACTIONS(7925),
    [anon_sym_unless] = ACTIONS(7925),
    [anon_sym_while] = ACTIONS(7925),
    [anon_sym_until] = ACTIONS(7925),
    [anon_sym_rescue] = ACTIONS(7925),
    [anon_sym_EQ_GT] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7925),
    [anon_sym_AMP_AMP] = ACTIONS(7925),
    [anon_sym_LT_LT] = ACTIONS(7925),
    [anon_sym_GT_GT] = ACTIONS(7925),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7925),
    [anon_sym_PLUS] = ACTIONS(7925),
    [anon_sym_SLASH] = ACTIONS(7925),
    [anon_sym_PERCENT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [4909] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(7828),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [4910] = {
    [sym_heredoc_body] = STATE(7395),
    [aux_sym_call_repeat1] = STATE(7395),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [4911] = {
    [sym_heredoc_body] = STATE(7395),
    [aux_sym_call_repeat1] = STATE(7395),
    [aux_sym_argument_list_repeat1] = STATE(7396),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(7216),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [4912] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(7826),
    [sym__binary_star] = ACTIONS(7828),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(7830),
    [anon_sym_STAR_STAR] = ACTIONS(7828),
    [anon_sym_AMP] = ACTIONS(7832),
    [anon_sym_LT] = ACTIONS(7834),
    [anon_sym_QMARK] = ACTIONS(7836),
    [anon_sym_DOT_DOT] = ACTIONS(7838),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7840),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(7844),
    [anon_sym_AMP_AMP] = ACTIONS(7844),
    [anon_sym_LT_LT] = ACTIONS(7846),
    [anon_sym_GT_GT] = ACTIONS(7846),
    [anon_sym_EQ_EQ] = ACTIONS(7848),
    [anon_sym_BANG_EQ] = ACTIONS(7844),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7844),
    [anon_sym_LT_EQ_GT] = ACTIONS(7844),
    [anon_sym_EQ_TILDE] = ACTIONS(7844),
    [anon_sym_BANG_TILDE] = ACTIONS(7844),
    [anon_sym_LT_EQ] = ACTIONS(7834),
    [anon_sym_GT] = ACTIONS(7834),
    [anon_sym_GT_EQ] = ACTIONS(7850),
    [anon_sym_CARET] = ACTIONS(7852),
    [anon_sym_PLUS] = ACTIONS(7826),
    [anon_sym_SLASH] = ACTIONS(7828),
    [anon_sym_PERCENT] = ACTIONS(7828),
    [sym_comment] = ACTIONS(87),
  },
  [4913] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7397),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2480),
    [sym_scope_resolution] = STATE(2478),
    [sym_call] = STATE(2478),
    [sym_method_call] = STATE(2480),
    [sym_assignment] = STATE(7397),
    [sym_operator_assignment] = STATE(7397),
    [sym_conditional] = STATE(7397),
    [sym_range] = STATE(7397),
    [sym_binary] = STATE(7397),
    [sym_unary] = STATE(7397),
    [sym_left_assignment_list] = STATE(2479),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2480),
    [sym__variable] = STATE(2478),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2480),
    [sym_false] = STATE(2480),
    [sym_nil] = STATE(2480),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2481),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4261),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4263),
    [anon_sym_yield] = ACTIONS(4265),
    [anon_sym_break] = ACTIONS(4267),
    [anon_sym_next] = ACTIONS(4269),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4271),
    [anon_sym_defined_QMARK] = ACTIONS(4273),
    [anon_sym_not] = ACTIONS(4275),
    [anon_sym_BANG] = ACTIONS(4277),
    [anon_sym_TILDE] = ACTIONS(4277),
    [sym_constant] = ACTIONS(4279),
    [sym_identifier] = ACTIONS(4279),
    [sym_instance_variable] = ACTIONS(4281),
    [sym_class_variable] = ACTIONS(4281),
    [sym_global_variable] = ACTIONS(4281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4279),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4279),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4914] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7398),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2480),
    [sym_scope_resolution] = STATE(2478),
    [sym_call] = STATE(2478),
    [sym_method_call] = STATE(2480),
    [sym_assignment] = STATE(7398),
    [sym_operator_assignment] = STATE(7398),
    [sym_conditional] = STATE(7398),
    [sym_range] = STATE(7398),
    [sym_binary] = STATE(7398),
    [sym_unary] = STATE(7398),
    [sym_left_assignment_list] = STATE(2479),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2480),
    [sym__variable] = STATE(2478),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2480),
    [sym_false] = STATE(2480),
    [sym_nil] = STATE(2480),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2481),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4261),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4263),
    [anon_sym_yield] = ACTIONS(4265),
    [anon_sym_break] = ACTIONS(4267),
    [anon_sym_next] = ACTIONS(4269),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4271),
    [anon_sym_defined_QMARK] = ACTIONS(4273),
    [anon_sym_not] = ACTIONS(4275),
    [anon_sym_BANG] = ACTIONS(4277),
    [anon_sym_TILDE] = ACTIONS(4277),
    [sym_constant] = ACTIONS(4279),
    [sym_identifier] = ACTIONS(4279),
    [sym_instance_variable] = ACTIONS(4281),
    [sym_class_variable] = ACTIONS(4281),
    [sym_global_variable] = ACTIONS(4281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4279),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4279),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4915] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7399),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2480),
    [sym_scope_resolution] = STATE(2478),
    [sym_call] = STATE(2478),
    [sym_method_call] = STATE(2480),
    [sym_assignment] = STATE(7399),
    [sym_operator_assignment] = STATE(7399),
    [sym_conditional] = STATE(7399),
    [sym_range] = STATE(7399),
    [sym_binary] = STATE(7399),
    [sym_unary] = STATE(7399),
    [sym_left_assignment_list] = STATE(2479),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2480),
    [sym__variable] = STATE(2478),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2480),
    [sym_false] = STATE(2480),
    [sym_nil] = STATE(2480),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2481),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4261),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4263),
    [anon_sym_yield] = ACTIONS(4265),
    [anon_sym_break] = ACTIONS(4267),
    [anon_sym_next] = ACTIONS(4269),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4271),
    [anon_sym_defined_QMARK] = ACTIONS(4273),
    [anon_sym_not] = ACTIONS(4275),
    [anon_sym_BANG] = ACTIONS(4277),
    [anon_sym_TILDE] = ACTIONS(4277),
    [sym_constant] = ACTIONS(4279),
    [sym_identifier] = ACTIONS(4279),
    [sym_instance_variable] = ACTIONS(4281),
    [sym_class_variable] = ACTIONS(4281),
    [sym_global_variable] = ACTIONS(4281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4279),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4279),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4916] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7400),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2480),
    [sym_scope_resolution] = STATE(2478),
    [sym_call] = STATE(2478),
    [sym_method_call] = STATE(2480),
    [sym_assignment] = STATE(7400),
    [sym_operator_assignment] = STATE(7400),
    [sym_conditional] = STATE(7400),
    [sym_range] = STATE(7400),
    [sym_binary] = STATE(7400),
    [sym_unary] = STATE(7400),
    [sym_left_assignment_list] = STATE(2479),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2480),
    [sym__variable] = STATE(2478),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2480),
    [sym_false] = STATE(2480),
    [sym_nil] = STATE(2480),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2481),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4261),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4263),
    [anon_sym_yield] = ACTIONS(4265),
    [anon_sym_break] = ACTIONS(4267),
    [anon_sym_next] = ACTIONS(4269),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4271),
    [anon_sym_defined_QMARK] = ACTIONS(4273),
    [anon_sym_not] = ACTIONS(4275),
    [anon_sym_BANG] = ACTIONS(4277),
    [anon_sym_TILDE] = ACTIONS(4277),
    [sym_constant] = ACTIONS(4279),
    [sym_identifier] = ACTIONS(4279),
    [sym_instance_variable] = ACTIONS(4281),
    [sym_class_variable] = ACTIONS(4281),
    [sym_global_variable] = ACTIONS(4281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4279),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4279),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4917] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7401),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2480),
    [sym_scope_resolution] = STATE(2478),
    [sym_call] = STATE(2478),
    [sym_method_call] = STATE(2480),
    [sym_assignment] = STATE(7401),
    [sym_operator_assignment] = STATE(7401),
    [sym_conditional] = STATE(7401),
    [sym_range] = STATE(7401),
    [sym_binary] = STATE(7401),
    [sym_unary] = STATE(7401),
    [sym_left_assignment_list] = STATE(2479),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2480),
    [sym__variable] = STATE(2478),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2480),
    [sym_false] = STATE(2480),
    [sym_nil] = STATE(2480),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2481),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4261),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4263),
    [anon_sym_yield] = ACTIONS(4265),
    [anon_sym_break] = ACTIONS(4267),
    [anon_sym_next] = ACTIONS(4269),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4271),
    [anon_sym_defined_QMARK] = ACTIONS(4273),
    [anon_sym_not] = ACTIONS(4275),
    [anon_sym_BANG] = ACTIONS(4277),
    [anon_sym_TILDE] = ACTIONS(4277),
    [sym_constant] = ACTIONS(4279),
    [sym_identifier] = ACTIONS(4279),
    [sym_instance_variable] = ACTIONS(4281),
    [sym_class_variable] = ACTIONS(4281),
    [sym_global_variable] = ACTIONS(4281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4279),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4279),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4918] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(7402),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(7402),
    [sym_operator_assignment] = STATE(7402),
    [sym_conditional] = STATE(7402),
    [sym_range] = STATE(7402),
    [sym_binary] = STATE(7402),
    [sym_unary] = STATE(7402),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4919] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7403),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2480),
    [sym_scope_resolution] = STATE(2478),
    [sym_call] = STATE(2478),
    [sym_method_call] = STATE(2480),
    [sym_assignment] = STATE(7403),
    [sym_operator_assignment] = STATE(7403),
    [sym_conditional] = STATE(7403),
    [sym_range] = STATE(7403),
    [sym_binary] = STATE(7403),
    [sym_unary] = STATE(7403),
    [sym_left_assignment_list] = STATE(2479),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2480),
    [sym__variable] = STATE(2478),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2480),
    [sym_false] = STATE(2480),
    [sym_nil] = STATE(2480),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2481),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4261),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4263),
    [anon_sym_yield] = ACTIONS(4265),
    [anon_sym_break] = ACTIONS(4267),
    [anon_sym_next] = ACTIONS(4269),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4271),
    [anon_sym_defined_QMARK] = ACTIONS(4273),
    [anon_sym_not] = ACTIONS(4275),
    [anon_sym_BANG] = ACTIONS(4277),
    [anon_sym_TILDE] = ACTIONS(4277),
    [sym_constant] = ACTIONS(4279),
    [sym_identifier] = ACTIONS(4279),
    [sym_instance_variable] = ACTIONS(4281),
    [sym_class_variable] = ACTIONS(4281),
    [sym_global_variable] = ACTIONS(4281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4279),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4279),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4920] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7404),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2480),
    [sym_scope_resolution] = STATE(2478),
    [sym_call] = STATE(2478),
    [sym_method_call] = STATE(2480),
    [sym_assignment] = STATE(7404),
    [sym_operator_assignment] = STATE(7404),
    [sym_conditional] = STATE(7404),
    [sym_range] = STATE(7404),
    [sym_binary] = STATE(7404),
    [sym_unary] = STATE(7404),
    [sym_left_assignment_list] = STATE(2479),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2480),
    [sym__variable] = STATE(2478),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2480),
    [sym_false] = STATE(2480),
    [sym_nil] = STATE(2480),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2481),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4261),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4263),
    [anon_sym_yield] = ACTIONS(4265),
    [anon_sym_break] = ACTIONS(4267),
    [anon_sym_next] = ACTIONS(4269),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4271),
    [anon_sym_defined_QMARK] = ACTIONS(4273),
    [anon_sym_not] = ACTIONS(4275),
    [anon_sym_BANG] = ACTIONS(4277),
    [anon_sym_TILDE] = ACTIONS(4277),
    [sym_constant] = ACTIONS(4279),
    [sym_identifier] = ACTIONS(4279),
    [sym_instance_variable] = ACTIONS(4281),
    [sym_class_variable] = ACTIONS(4281),
    [sym_global_variable] = ACTIONS(4281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4279),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4279),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4921] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7405),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2480),
    [sym_scope_resolution] = STATE(2478),
    [sym_call] = STATE(2478),
    [sym_method_call] = STATE(2480),
    [sym_assignment] = STATE(7405),
    [sym_operator_assignment] = STATE(7405),
    [sym_conditional] = STATE(7405),
    [sym_range] = STATE(7405),
    [sym_binary] = STATE(7405),
    [sym_unary] = STATE(7405),
    [sym_left_assignment_list] = STATE(2479),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2480),
    [sym__variable] = STATE(2478),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2480),
    [sym_false] = STATE(2480),
    [sym_nil] = STATE(2480),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2481),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4261),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4263),
    [anon_sym_yield] = ACTIONS(4265),
    [anon_sym_break] = ACTIONS(4267),
    [anon_sym_next] = ACTIONS(4269),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4271),
    [anon_sym_defined_QMARK] = ACTIONS(4273),
    [anon_sym_not] = ACTIONS(4275),
    [anon_sym_BANG] = ACTIONS(4277),
    [anon_sym_TILDE] = ACTIONS(4277),
    [sym_constant] = ACTIONS(4279),
    [sym_identifier] = ACTIONS(4279),
    [sym_instance_variable] = ACTIONS(4281),
    [sym_class_variable] = ACTIONS(4281),
    [sym_global_variable] = ACTIONS(4281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4279),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4279),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4922] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7406),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2480),
    [sym_scope_resolution] = STATE(2478),
    [sym_call] = STATE(2478),
    [sym_method_call] = STATE(2480),
    [sym_assignment] = STATE(7406),
    [sym_operator_assignment] = STATE(7406),
    [sym_conditional] = STATE(7406),
    [sym_range] = STATE(7406),
    [sym_binary] = STATE(7406),
    [sym_unary] = STATE(7406),
    [sym_left_assignment_list] = STATE(2479),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2480),
    [sym__variable] = STATE(2478),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2480),
    [sym_false] = STATE(2480),
    [sym_nil] = STATE(2480),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2481),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4261),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4263),
    [anon_sym_yield] = ACTIONS(4265),
    [anon_sym_break] = ACTIONS(4267),
    [anon_sym_next] = ACTIONS(4269),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4271),
    [anon_sym_defined_QMARK] = ACTIONS(4273),
    [anon_sym_not] = ACTIONS(4275),
    [anon_sym_BANG] = ACTIONS(4277),
    [anon_sym_TILDE] = ACTIONS(4277),
    [sym_constant] = ACTIONS(4279),
    [sym_identifier] = ACTIONS(4279),
    [sym_instance_variable] = ACTIONS(4281),
    [sym_class_variable] = ACTIONS(4281),
    [sym_global_variable] = ACTIONS(4281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4279),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4279),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4923] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7408),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2480),
    [sym_scope_resolution] = STATE(2478),
    [sym_call] = STATE(2478),
    [sym_method_call] = STATE(2480),
    [sym_splat_argument] = STATE(7409),
    [sym_assignment] = STATE(7408),
    [sym_operator_assignment] = STATE(7408),
    [sym_conditional] = STATE(7408),
    [sym_range] = STATE(7408),
    [sym_binary] = STATE(7408),
    [sym_unary] = STATE(7408),
    [sym_right_assignment_list] = STATE(3461),
    [sym__arg_or_splat_arg] = STATE(7409),
    [sym_left_assignment_list] = STATE(2479),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2480),
    [sym__variable] = STATE(2478),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2480),
    [sym_false] = STATE(2480),
    [sym_nil] = STATE(2480),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2481),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(10955),
    [sym__unary_minus] = ACTIONS(4261),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4263),
    [anon_sym_yield] = ACTIONS(4265),
    [anon_sym_break] = ACTIONS(4267),
    [anon_sym_next] = ACTIONS(4269),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4271),
    [anon_sym_defined_QMARK] = ACTIONS(4273),
    [anon_sym_not] = ACTIONS(4275),
    [anon_sym_BANG] = ACTIONS(4277),
    [anon_sym_TILDE] = ACTIONS(4277),
    [sym_constant] = ACTIONS(4279),
    [sym_identifier] = ACTIONS(4279),
    [sym_instance_variable] = ACTIONS(4281),
    [sym_class_variable] = ACTIONS(4281),
    [sym_global_variable] = ACTIONS(4281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4279),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4279),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4924] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7410),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2480),
    [sym_scope_resolution] = STATE(2478),
    [sym_call] = STATE(2478),
    [sym_method_call] = STATE(2480),
    [sym_assignment] = STATE(7410),
    [sym_operator_assignment] = STATE(7410),
    [sym_conditional] = STATE(7410),
    [sym_range] = STATE(7410),
    [sym_binary] = STATE(7410),
    [sym_unary] = STATE(7410),
    [sym_left_assignment_list] = STATE(2479),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2480),
    [sym__variable] = STATE(2478),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2480),
    [sym_false] = STATE(2480),
    [sym_nil] = STATE(2480),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2481),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4261),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4263),
    [anon_sym_yield] = ACTIONS(4265),
    [anon_sym_break] = ACTIONS(4267),
    [anon_sym_next] = ACTIONS(4269),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4271),
    [anon_sym_defined_QMARK] = ACTIONS(4273),
    [anon_sym_not] = ACTIONS(4275),
    [anon_sym_BANG] = ACTIONS(4277),
    [anon_sym_TILDE] = ACTIONS(4277),
    [sym_constant] = ACTIONS(4279),
    [sym_identifier] = ACTIONS(4279),
    [sym_instance_variable] = ACTIONS(4281),
    [sym_class_variable] = ACTIONS(4281),
    [sym_global_variable] = ACTIONS(4281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4279),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4279),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4925] = {
    [sym_string] = STATE(7411),
    [aux_sym_chained_string_repeat1] = STATE(7411),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_RPAREN] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [4926] = {
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(7826),
    [sym__binary_star] = ACTIONS(7828),
    [anon_sym_RPAREN] = ACTIONS(6823),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(7830),
    [anon_sym_STAR_STAR] = ACTIONS(7828),
    [anon_sym_AMP] = ACTIONS(7832),
    [anon_sym_LT] = ACTIONS(7834),
    [anon_sym_QMARK] = ACTIONS(7836),
    [anon_sym_DOT_DOT] = ACTIONS(7838),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7840),
    [anon_sym_and] = ACTIONS(7842),
    [anon_sym_or] = ACTIONS(7842),
    [anon_sym_PIPE_PIPE] = ACTIONS(7844),
    [anon_sym_AMP_AMP] = ACTIONS(7844),
    [anon_sym_LT_LT] = ACTIONS(7846),
    [anon_sym_GT_GT] = ACTIONS(7846),
    [anon_sym_EQ_EQ] = ACTIONS(7848),
    [anon_sym_BANG_EQ] = ACTIONS(7844),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7844),
    [anon_sym_LT_EQ_GT] = ACTIONS(7844),
    [anon_sym_EQ_TILDE] = ACTIONS(7844),
    [anon_sym_BANG_TILDE] = ACTIONS(7844),
    [anon_sym_LT_EQ] = ACTIONS(7834),
    [anon_sym_GT] = ACTIONS(7834),
    [anon_sym_GT_EQ] = ACTIONS(7850),
    [anon_sym_CARET] = ACTIONS(7852),
    [anon_sym_PLUS] = ACTIONS(7826),
    [anon_sym_SLASH] = ACTIONS(7828),
    [anon_sym_PERCENT] = ACTIONS(7828),
    [sym_comment] = ACTIONS(87),
  },
  [4927] = {
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(7190),
    [sym__binary_star] = ACTIONS(7192),
    [anon_sym_RPAREN] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(7194),
    [anon_sym_STAR_STAR] = ACTIONS(7192),
    [anon_sym_AMP] = ACTIONS(7196),
    [anon_sym_LT] = ACTIONS(7198),
    [anon_sym_EQ_GT] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(7200),
    [anon_sym_DOT_DOT] = ACTIONS(7202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7204),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(7206),
    [anon_sym_AMP_AMP] = ACTIONS(7206),
    [anon_sym_LT_LT] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7208),
    [anon_sym_EQ_EQ] = ACTIONS(7210),
    [anon_sym_BANG_EQ] = ACTIONS(7206),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7206),
    [anon_sym_LT_EQ_GT] = ACTIONS(7206),
    [anon_sym_EQ_TILDE] = ACTIONS(7206),
    [anon_sym_BANG_TILDE] = ACTIONS(7206),
    [anon_sym_LT_EQ] = ACTIONS(7198),
    [anon_sym_GT] = ACTIONS(7198),
    [anon_sym_GT_EQ] = ACTIONS(7212),
    [anon_sym_CARET] = ACTIONS(7214),
    [anon_sym_PLUS] = ACTIONS(7190),
    [anon_sym_SLASH] = ACTIONS(7192),
    [anon_sym_PERCENT] = ACTIONS(7192),
    [sym_comment] = ACTIONS(87),
  },
  [4928] = {
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(7190),
    [sym__binary_star] = ACTIONS(7192),
    [anon_sym_RPAREN] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(7194),
    [anon_sym_STAR_STAR] = ACTIONS(7192),
    [anon_sym_AMP] = ACTIONS(7196),
    [anon_sym_LT] = ACTIONS(7198),
    [anon_sym_EQ_GT] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(7200),
    [anon_sym_DOT_DOT] = ACTIONS(7202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7204),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(7206),
    [anon_sym_AMP_AMP] = ACTIONS(7206),
    [anon_sym_LT_LT] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7208),
    [anon_sym_EQ_EQ] = ACTIONS(7210),
    [anon_sym_BANG_EQ] = ACTIONS(7206),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7206),
    [anon_sym_LT_EQ_GT] = ACTIONS(7206),
    [anon_sym_EQ_TILDE] = ACTIONS(7206),
    [anon_sym_BANG_TILDE] = ACTIONS(7206),
    [anon_sym_LT_EQ] = ACTIONS(7198),
    [anon_sym_GT] = ACTIONS(7198),
    [anon_sym_GT_EQ] = ACTIONS(7212),
    [anon_sym_CARET] = ACTIONS(7214),
    [anon_sym_PLUS] = ACTIONS(7190),
    [anon_sym_SLASH] = ACTIONS(7192),
    [anon_sym_PERCENT] = ACTIONS(7192),
    [sym_comment] = ACTIONS(87),
  },
  [4929] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(7412),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2061),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(2061),
    [sym_assignment] = STATE(7412),
    [sym_operator_assignment] = STATE(7412),
    [sym_conditional] = STATE(7412),
    [sym_range] = STATE(7412),
    [sym_binary] = STATE(7412),
    [sym_unary] = STATE(7412),
    [sym_left_assignment_list] = STATE(2060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2061),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2061),
    [sym_false] = STATE(2061),
    [sym_nil] = STATE(2061),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2484),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7184),
    [anon_sym_defined_QMARK] = ACTIONS(3599),
    [anon_sym_not] = ACTIONS(3601),
    [anon_sym_BANG] = ACTIONS(3605),
    [anon_sym_TILDE] = ACTIONS(3605),
    [sym_constant] = ACTIONS(1621),
    [sym_identifier] = ACTIONS(1621),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4930] = {
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(7190),
    [sym__binary_star] = ACTIONS(7192),
    [anon_sym_RPAREN] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(7194),
    [anon_sym_STAR_STAR] = ACTIONS(7192),
    [anon_sym_AMP] = ACTIONS(7196),
    [anon_sym_LT] = ACTIONS(7198),
    [anon_sym_EQ_GT] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(7200),
    [anon_sym_DOT_DOT] = ACTIONS(7202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7204),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(7206),
    [anon_sym_AMP_AMP] = ACTIONS(7206),
    [anon_sym_LT_LT] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7208),
    [anon_sym_EQ_EQ] = ACTIONS(7210),
    [anon_sym_BANG_EQ] = ACTIONS(7206),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7206),
    [anon_sym_LT_EQ_GT] = ACTIONS(7206),
    [anon_sym_EQ_TILDE] = ACTIONS(7206),
    [anon_sym_BANG_TILDE] = ACTIONS(7206),
    [anon_sym_LT_EQ] = ACTIONS(7198),
    [anon_sym_GT] = ACTIONS(7198),
    [anon_sym_GT_EQ] = ACTIONS(7212),
    [anon_sym_CARET] = ACTIONS(7214),
    [anon_sym_PLUS] = ACTIONS(7190),
    [anon_sym_SLASH] = ACTIONS(7192),
    [anon_sym_PERCENT] = ACTIONS(7192),
    [sym_comment] = ACTIONS(87),
  },
  [4931] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(7413),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2061),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(2061),
    [sym_assignment] = STATE(7413),
    [sym_operator_assignment] = STATE(7413),
    [sym_conditional] = STATE(7413),
    [sym_range] = STATE(7413),
    [sym_binary] = STATE(7413),
    [sym_unary] = STATE(7413),
    [sym_left_assignment_list] = STATE(2060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2061),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2061),
    [sym_false] = STATE(2061),
    [sym_nil] = STATE(2061),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2484),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7184),
    [anon_sym_defined_QMARK] = ACTIONS(3599),
    [anon_sym_not] = ACTIONS(3601),
    [anon_sym_BANG] = ACTIONS(3605),
    [anon_sym_TILDE] = ACTIONS(3605),
    [sym_constant] = ACTIONS(1621),
    [sym_identifier] = ACTIONS(1621),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4932] = {
    [sym_heredoc_body] = STATE(7414),
    [aux_sym_call_repeat1] = STATE(7414),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_RPAREN] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [4933] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(2492),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2061),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(2061),
    [sym__argument] = STATE(4250),
    [sym_splat_argument] = STATE(4250),
    [sym_hash_splat_argument] = STATE(4250),
    [sym_block_argument] = STATE(4250),
    [sym_assignment] = STATE(2492),
    [sym_operator_assignment] = STATE(2492),
    [sym_conditional] = STATE(2492),
    [sym_range] = STATE(2492),
    [sym_binary] = STATE(2492),
    [sym_unary] = STATE(2492),
    [sym_left_assignment_list] = STATE(2060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2061),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2061),
    [sym_false] = STATE(2061),
    [sym_nil] = STATE(2061),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2495),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_heredoc_body] = STATE(7415),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(4250),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(4289),
    [sym__splat_star] = ACTIONS(4291),
    [sym__unary_minus] = ACTIONS(3595),
    [sym__identifier_hash_key] = ACTIONS(4293),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10957),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7184),
    [anon_sym_defined_QMARK] = ACTIONS(3599),
    [anon_sym_not] = ACTIONS(3601),
    [anon_sym_BANG] = ACTIONS(3605),
    [anon_sym_TILDE] = ACTIONS(3605),
    [sym_constant] = ACTIONS(4295),
    [sym_identifier] = ACTIONS(4295),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4934] = {
    [sym_heredoc_body] = STATE(7416),
    [aux_sym_call_repeat1] = STATE(7416),
    [aux_sym_argument_list_repeat1] = STATE(7417),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_RPAREN] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(7864),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [4935] = {
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(7826),
    [sym__binary_star] = ACTIONS(7828),
    [anon_sym_RPAREN] = ACTIONS(7027),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(7830),
    [anon_sym_STAR_STAR] = ACTIONS(7828),
    [anon_sym_AMP] = ACTIONS(7832),
    [anon_sym_LT] = ACTIONS(7834),
    [anon_sym_QMARK] = ACTIONS(7836),
    [anon_sym_DOT_DOT] = ACTIONS(7838),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7840),
    [anon_sym_and] = ACTIONS(7842),
    [anon_sym_or] = ACTIONS(7842),
    [anon_sym_PIPE_PIPE] = ACTIONS(7844),
    [anon_sym_AMP_AMP] = ACTIONS(7844),
    [anon_sym_LT_LT] = ACTIONS(7846),
    [anon_sym_GT_GT] = ACTIONS(7846),
    [anon_sym_EQ_EQ] = ACTIONS(7848),
    [anon_sym_BANG_EQ] = ACTIONS(7844),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7844),
    [anon_sym_LT_EQ_GT] = ACTIONS(7844),
    [anon_sym_EQ_TILDE] = ACTIONS(7844),
    [anon_sym_BANG_TILDE] = ACTIONS(7844),
    [anon_sym_LT_EQ] = ACTIONS(7834),
    [anon_sym_GT] = ACTIONS(7834),
    [anon_sym_GT_EQ] = ACTIONS(7850),
    [anon_sym_CARET] = ACTIONS(7852),
    [anon_sym_PLUS] = ACTIONS(7826),
    [anon_sym_SLASH] = ACTIONS(7828),
    [anon_sym_PERCENT] = ACTIONS(7828),
    [sym_comment] = ACTIONS(87),
  },
  [4936] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(4301),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(4301),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(4301),
    [anon_sym_PERCENT] = ACTIONS(4301),
    [sym_comment] = ACTIONS(87),
  },
  [4937] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(4301),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [4938] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4299),
    [sym__binary_star] = ACTIONS(4301),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(4301),
    [anon_sym_AMP] = ACTIONS(4305),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(4319),
    [anon_sym_GT_GT] = ACTIONS(4319),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(4299),
    [anon_sym_SLASH] = ACTIONS(4301),
    [anon_sym_PERCENT] = ACTIONS(4301),
    [sym_comment] = ACTIONS(87),
  },
  [4939] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4299),
    [sym__binary_star] = ACTIONS(4301),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(4301),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(4319),
    [anon_sym_GT_GT] = ACTIONS(4319),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(4299),
    [anon_sym_SLASH] = ACTIONS(4301),
    [anon_sym_PERCENT] = ACTIONS(4301),
    [sym_comment] = ACTIONS(87),
  },
  [4940] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4299),
    [sym__binary_star] = ACTIONS(4301),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(4303),
    [anon_sym_STAR_STAR] = ACTIONS(4301),
    [anon_sym_AMP] = ACTIONS(4305),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(4319),
    [anon_sym_GT_GT] = ACTIONS(4319),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(4325),
    [anon_sym_PLUS] = ACTIONS(4299),
    [anon_sym_SLASH] = ACTIONS(4301),
    [anon_sym_PERCENT] = ACTIONS(4301),
    [sym_comment] = ACTIONS(87),
  },
  [4941] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(10959),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [4942] = {
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(4299),
    [sym__binary_star] = ACTIONS(4301),
    [anon_sym_RPAREN] = ACTIONS(5927),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(4303),
    [anon_sym_STAR_STAR] = ACTIONS(4301),
    [anon_sym_AMP] = ACTIONS(4305),
    [anon_sym_LT] = ACTIONS(4307),
    [anon_sym_EQ_GT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(4311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4313),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(4317),
    [anon_sym_AMP_AMP] = ACTIONS(4317),
    [anon_sym_LT_LT] = ACTIONS(4319),
    [anon_sym_GT_GT] = ACTIONS(4319),
    [anon_sym_EQ_EQ] = ACTIONS(4321),
    [anon_sym_BANG_EQ] = ACTIONS(4317),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4317),
    [anon_sym_LT_EQ_GT] = ACTIONS(4317),
    [anon_sym_EQ_TILDE] = ACTIONS(4317),
    [anon_sym_BANG_TILDE] = ACTIONS(4317),
    [anon_sym_LT_EQ] = ACTIONS(4307),
    [anon_sym_GT] = ACTIONS(4307),
    [anon_sym_GT_EQ] = ACTIONS(4323),
    [anon_sym_CARET] = ACTIONS(4325),
    [anon_sym_PLUS] = ACTIONS(4299),
    [anon_sym_SLASH] = ACTIONS(4301),
    [anon_sym_PERCENT] = ACTIONS(4301),
    [sym_comment] = ACTIONS(87),
  },
  [4943] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4299),
    [sym__binary_star] = ACTIONS(4301),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(4303),
    [anon_sym_STAR_STAR] = ACTIONS(4301),
    [anon_sym_AMP] = ACTIONS(4305),
    [anon_sym_LT] = ACTIONS(4307),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(4309),
    [anon_sym_DOT_DOT] = ACTIONS(4311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4313),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(4317),
    [anon_sym_AMP_AMP] = ACTIONS(4317),
    [anon_sym_LT_LT] = ACTIONS(4319),
    [anon_sym_GT_GT] = ACTIONS(4319),
    [anon_sym_EQ_EQ] = ACTIONS(4321),
    [anon_sym_BANG_EQ] = ACTIONS(4317),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4317),
    [anon_sym_LT_EQ_GT] = ACTIONS(4317),
    [anon_sym_EQ_TILDE] = ACTIONS(4317),
    [anon_sym_BANG_TILDE] = ACTIONS(4317),
    [anon_sym_LT_EQ] = ACTIONS(4307),
    [anon_sym_GT] = ACTIONS(4307),
    [anon_sym_GT_EQ] = ACTIONS(4323),
    [anon_sym_CARET] = ACTIONS(4325),
    [anon_sym_PLUS] = ACTIONS(4299),
    [anon_sym_SLASH] = ACTIONS(4301),
    [anon_sym_PERCENT] = ACTIONS(4301),
    [sym_comment] = ACTIONS(87),
  },
  [4944] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4299),
    [sym__binary_star] = ACTIONS(4301),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(4303),
    [anon_sym_STAR_STAR] = ACTIONS(4301),
    [anon_sym_AMP] = ACTIONS(4305),
    [anon_sym_LT] = ACTIONS(4307),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(4319),
    [anon_sym_GT_GT] = ACTIONS(4319),
    [anon_sym_EQ_EQ] = ACTIONS(4321),
    [anon_sym_BANG_EQ] = ACTIONS(4317),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4317),
    [anon_sym_LT_EQ_GT] = ACTIONS(4317),
    [anon_sym_EQ_TILDE] = ACTIONS(4317),
    [anon_sym_BANG_TILDE] = ACTIONS(4317),
    [anon_sym_LT_EQ] = ACTIONS(4307),
    [anon_sym_GT] = ACTIONS(4307),
    [anon_sym_GT_EQ] = ACTIONS(4323),
    [anon_sym_CARET] = ACTIONS(4325),
    [anon_sym_PLUS] = ACTIONS(4299),
    [anon_sym_SLASH] = ACTIONS(4301),
    [anon_sym_PERCENT] = ACTIONS(4301),
    [sym_comment] = ACTIONS(87),
  },
  [4945] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4299),
    [sym__binary_star] = ACTIONS(4301),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(4301),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(4299),
    [anon_sym_SLASH] = ACTIONS(4301),
    [anon_sym_PERCENT] = ACTIONS(4301),
    [sym_comment] = ACTIONS(87),
  },
  [4946] = {
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(7256),
    [sym__binary_star] = ACTIONS(7258),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_RPAREN] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(7260),
    [anon_sym_STAR_STAR] = ACTIONS(7262),
    [anon_sym_AMP] = ACTIONS(7264),
    [anon_sym_EQ] = ACTIONS(4217),
    [anon_sym_LT] = ACTIONS(7266),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_EQ_GT] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_PLUS_EQ] = ACTIONS(4211),
    [anon_sym_DASH_EQ] = ACTIONS(4211),
    [anon_sym_STAR_EQ] = ACTIONS(4211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4211),
    [anon_sym_SLASH_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4211),
    [anon_sym_AMP_EQ] = ACTIONS(4211),
    [anon_sym_PERCENT_EQ] = ACTIONS(4211),
    [anon_sym_GT_GT_EQ] = ACTIONS(4211),
    [anon_sym_LT_LT_EQ] = ACTIONS(4211),
    [anon_sym_CARET_EQ] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(7268),
    [anon_sym_DOT_DOT] = ACTIONS(7270),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7272),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(7274),
    [anon_sym_AMP_AMP] = ACTIONS(7274),
    [anon_sym_LT_LT] = ACTIONS(7276),
    [anon_sym_GT_GT] = ACTIONS(7276),
    [anon_sym_EQ_EQ] = ACTIONS(7274),
    [anon_sym_BANG_EQ] = ACTIONS(7278),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7278),
    [anon_sym_LT_EQ_GT] = ACTIONS(7278),
    [anon_sym_EQ_TILDE] = ACTIONS(7278),
    [anon_sym_BANG_TILDE] = ACTIONS(7278),
    [anon_sym_LT_EQ] = ACTIONS(7266),
    [anon_sym_GT] = ACTIONS(7266),
    [anon_sym_GT_EQ] = ACTIONS(7280),
    [anon_sym_CARET] = ACTIONS(7260),
    [anon_sym_PLUS] = ACTIONS(7282),
    [anon_sym_SLASH] = ACTIONS(7262),
    [anon_sym_PERCENT] = ACTIONS(7262),
    [sym_comment] = ACTIONS(87),
  },
  [4947] = {
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(7256),
    [sym__binary_star] = ACTIONS(7258),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_RPAREN] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(7260),
    [anon_sym_STAR_STAR] = ACTIONS(7262),
    [anon_sym_AMP] = ACTIONS(7264),
    [anon_sym_EQ] = ACTIONS(4249),
    [anon_sym_LT] = ACTIONS(7266),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_EQ_GT] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_PLUS_EQ] = ACTIONS(4247),
    [anon_sym_DASH_EQ] = ACTIONS(4247),
    [anon_sym_STAR_EQ] = ACTIONS(4247),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4247),
    [anon_sym_SLASH_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4247),
    [anon_sym_AMP_EQ] = ACTIONS(4247),
    [anon_sym_PERCENT_EQ] = ACTIONS(4247),
    [anon_sym_GT_GT_EQ] = ACTIONS(4247),
    [anon_sym_LT_LT_EQ] = ACTIONS(4247),
    [anon_sym_CARET_EQ] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(7268),
    [anon_sym_DOT_DOT] = ACTIONS(7270),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7272),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(7274),
    [anon_sym_AMP_AMP] = ACTIONS(7274),
    [anon_sym_LT_LT] = ACTIONS(7276),
    [anon_sym_GT_GT] = ACTIONS(7276),
    [anon_sym_EQ_EQ] = ACTIONS(7274),
    [anon_sym_BANG_EQ] = ACTIONS(7278),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7278),
    [anon_sym_LT_EQ_GT] = ACTIONS(7278),
    [anon_sym_EQ_TILDE] = ACTIONS(7278),
    [anon_sym_BANG_TILDE] = ACTIONS(7278),
    [anon_sym_LT_EQ] = ACTIONS(7266),
    [anon_sym_GT] = ACTIONS(7266),
    [anon_sym_GT_EQ] = ACTIONS(7280),
    [anon_sym_CARET] = ACTIONS(7260),
    [anon_sym_PLUS] = ACTIONS(7282),
    [anon_sym_SLASH] = ACTIONS(7262),
    [anon_sym_PERCENT] = ACTIONS(7262),
    [sym_comment] = ACTIONS(87),
  },
  [4948] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(7419),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2092),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2092),
    [sym_assignment] = STATE(7419),
    [sym_operator_assignment] = STATE(7419),
    [sym_conditional] = STATE(7419),
    [sym_range] = STATE(7419),
    [sym_binary] = STATE(7419),
    [sym_unary] = STATE(7419),
    [sym_left_assignment_list] = STATE(2091),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2092),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2092),
    [sym_false] = STATE(2092),
    [sym_nil] = STATE(2092),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4439),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3643),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3647),
    [anon_sym_yield] = ACTIONS(3649),
    [anon_sym_break] = ACTIONS(3651),
    [anon_sym_next] = ACTIONS(3653),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(7250),
    [anon_sym_defined_QMARK] = ACTIONS(3655),
    [anon_sym_not] = ACTIONS(3657),
    [anon_sym_BANG] = ACTIONS(3661),
    [anon_sym_TILDE] = ACTIONS(3661),
    [sym_constant] = ACTIONS(3667),
    [sym_identifier] = ACTIONS(3667),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4949] = {
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(7256),
    [sym__binary_star] = ACTIONS(7258),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_RPAREN] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(7260),
    [anon_sym_STAR_STAR] = ACTIONS(7262),
    [anon_sym_AMP] = ACTIONS(7264),
    [anon_sym_EQ] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(7266),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_EQ_GT] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_PLUS_EQ] = ACTIONS(3281),
    [anon_sym_DASH_EQ] = ACTIONS(3281),
    [anon_sym_STAR_EQ] = ACTIONS(3281),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3281),
    [anon_sym_SLASH_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3281),
    [anon_sym_AMP_EQ] = ACTIONS(3281),
    [anon_sym_PERCENT_EQ] = ACTIONS(3281),
    [anon_sym_GT_GT_EQ] = ACTIONS(3281),
    [anon_sym_LT_LT_EQ] = ACTIONS(3281),
    [anon_sym_CARET_EQ] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(7268),
    [anon_sym_DOT_DOT] = ACTIONS(7270),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7272),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(7274),
    [anon_sym_AMP_AMP] = ACTIONS(7274),
    [anon_sym_LT_LT] = ACTIONS(7276),
    [anon_sym_GT_GT] = ACTIONS(7276),
    [anon_sym_EQ_EQ] = ACTIONS(7274),
    [anon_sym_BANG_EQ] = ACTIONS(7278),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7278),
    [anon_sym_LT_EQ_GT] = ACTIONS(7278),
    [anon_sym_EQ_TILDE] = ACTIONS(7278),
    [anon_sym_BANG_TILDE] = ACTIONS(7278),
    [anon_sym_LT_EQ] = ACTIONS(7266),
    [anon_sym_GT] = ACTIONS(7266),
    [anon_sym_GT_EQ] = ACTIONS(7280),
    [anon_sym_CARET] = ACTIONS(7260),
    [anon_sym_PLUS] = ACTIONS(7282),
    [anon_sym_SLASH] = ACTIONS(7262),
    [anon_sym_PERCENT] = ACTIONS(7262),
    [sym_comment] = ACTIONS(87),
  },
  [4950] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(7420),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2092),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2092),
    [sym_assignment] = STATE(7420),
    [sym_operator_assignment] = STATE(7420),
    [sym_conditional] = STATE(7420),
    [sym_range] = STATE(7420),
    [sym_binary] = STATE(7420),
    [sym_unary] = STATE(7420),
    [sym_left_assignment_list] = STATE(2091),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2092),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2092),
    [sym_false] = STATE(2092),
    [sym_nil] = STATE(2092),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4439),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3643),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3647),
    [anon_sym_yield] = ACTIONS(3649),
    [anon_sym_break] = ACTIONS(3651),
    [anon_sym_next] = ACTIONS(3653),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(7250),
    [anon_sym_defined_QMARK] = ACTIONS(3655),
    [anon_sym_not] = ACTIONS(3657),
    [anon_sym_BANG] = ACTIONS(3661),
    [anon_sym_TILDE] = ACTIONS(3661),
    [sym_constant] = ACTIONS(3667),
    [sym_identifier] = ACTIONS(3667),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4951] = {
    [sym_heredoc_body] = STATE(7421),
    [aux_sym_call_repeat1] = STATE(7421),
    [sym__heredoc_body_start] = ACTIONS(3543),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_RPAREN] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [4952] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(2513),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2092),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2092),
    [sym__argument] = STATE(4357),
    [sym_splat_argument] = STATE(4357),
    [sym_hash_splat_argument] = STATE(4357),
    [sym_block_argument] = STATE(4357),
    [sym_assignment] = STATE(2513),
    [sym_operator_assignment] = STATE(2513),
    [sym_conditional] = STATE(2513),
    [sym_range] = STATE(2513),
    [sym_binary] = STATE(2513),
    [sym_unary] = STATE(2513),
    [sym_left_assignment_list] = STATE(2091),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2092),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2092),
    [sym_false] = STATE(2092),
    [sym_nil] = STATE(2092),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(2516),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_heredoc_body] = STATE(7422),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(4357),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(4327),
    [sym__splat_star] = ACTIONS(4329),
    [sym__unary_minus] = ACTIONS(3643),
    [sym__identifier_hash_key] = ACTIONS(4331),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10961),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3647),
    [anon_sym_yield] = ACTIONS(3649),
    [anon_sym_break] = ACTIONS(3651),
    [anon_sym_next] = ACTIONS(3653),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(7250),
    [anon_sym_defined_QMARK] = ACTIONS(3655),
    [anon_sym_not] = ACTIONS(3657),
    [anon_sym_BANG] = ACTIONS(3661),
    [anon_sym_TILDE] = ACTIONS(3661),
    [sym_constant] = ACTIONS(4333),
    [sym_identifier] = ACTIONS(4333),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4953] = {
    [sym_heredoc_body] = STATE(7423),
    [aux_sym_call_repeat1] = STATE(7423),
    [aux_sym_argument_list_repeat1] = STATE(7424),
    [sym__heredoc_body_start] = ACTIONS(3543),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_RPAREN] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(7872),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [4954] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(906),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(911),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(911),
    [sym__argument] = STATE(6088),
    [sym_splat_argument] = STATE(6088),
    [sym_hash_splat_argument] = STATE(6088),
    [sym_block_argument] = STATE(6088),
    [sym_assignment] = STATE(906),
    [sym_operator_assignment] = STATE(906),
    [sym_conditional] = STATE(906),
    [sym_range] = STATE(906),
    [sym_binary] = STATE(906),
    [sym_unary] = STATE(906),
    [sym_left_assignment_list] = STATE(910),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(911),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(911),
    [sym_false] = STATE(911),
    [sym_nil] = STATE(911),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(912),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(6088),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1589),
    [sym__splat_star] = ACTIONS(1591),
    [sym__unary_minus] = ACTIONS(1593),
    [sym__identifier_hash_key] = ACTIONS(1595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(9402),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1599),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_defined_QMARK] = ACTIONS(1611),
    [anon_sym_not] = ACTIONS(1613),
    [anon_sym_BANG] = ACTIONS(1615),
    [anon_sym_TILDE] = ACTIONS(1615),
    [sym_constant] = ACTIONS(1617),
    [sym_identifier] = ACTIONS(1617),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4955] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(906),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(911),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(911),
    [sym__argument] = STATE(3454),
    [sym_splat_argument] = STATE(3454),
    [sym_hash_splat_argument] = STATE(3454),
    [sym_block_argument] = STATE(3454),
    [sym_assignment] = STATE(906),
    [sym_operator_assignment] = STATE(906),
    [sym_conditional] = STATE(906),
    [sym_range] = STATE(906),
    [sym_binary] = STATE(906),
    [sym_unary] = STATE(906),
    [sym_left_assignment_list] = STATE(910),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(911),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(911),
    [sym_false] = STATE(911),
    [sym_nil] = STATE(911),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(912),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_heredoc_body] = STATE(7425),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(3454),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1589),
    [sym__splat_star] = ACTIONS(1591),
    [sym__unary_minus] = ACTIONS(1593),
    [sym__identifier_hash_key] = ACTIONS(1595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(9402),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1599),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_defined_QMARK] = ACTIONS(1611),
    [anon_sym_not] = ACTIONS(1613),
    [anon_sym_BANG] = ACTIONS(1615),
    [anon_sym_TILDE] = ACTIONS(1615),
    [sym_constant] = ACTIONS(1617),
    [sym_identifier] = ACTIONS(1617),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4956] = {
    [aux_sym_argument_list_repeat1] = STATE(4956),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [anon_sym_RPAREN] = ACTIONS(7925),
    [anon_sym_COMMA] = ACTIONS(10963),
    [sym_comment] = ACTIONS(87),
  },
  [4957] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(7427),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(911),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(911),
    [sym_assignment] = STATE(7427),
    [sym_operator_assignment] = STATE(7427),
    [sym_conditional] = STATE(7427),
    [sym_range] = STATE(7427),
    [sym_binary] = STATE(7427),
    [sym_unary] = STATE(7427),
    [sym_left_assignment_list] = STATE(910),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(911),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(911),
    [sym_false] = STATE(911),
    [sym_nil] = STATE(911),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2484),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1593),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_defined_QMARK] = ACTIONS(1611),
    [anon_sym_not] = ACTIONS(1613),
    [anon_sym_BANG] = ACTIONS(1615),
    [anon_sym_TILDE] = ACTIONS(1615),
    [sym_constant] = ACTIONS(1621),
    [sym_identifier] = ACTIONS(1621),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4958] = {
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(4299),
    [sym__binary_star] = ACTIONS(4301),
    [anon_sym_RPAREN] = ACTIONS(5115),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(4303),
    [anon_sym_STAR_STAR] = ACTIONS(4301),
    [anon_sym_AMP] = ACTIONS(4305),
    [anon_sym_LT] = ACTIONS(4307),
    [anon_sym_EQ_GT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(4309),
    [anon_sym_DOT_DOT] = ACTIONS(4311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4313),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(4317),
    [anon_sym_AMP_AMP] = ACTIONS(4317),
    [anon_sym_LT_LT] = ACTIONS(4319),
    [anon_sym_GT_GT] = ACTIONS(4319),
    [anon_sym_EQ_EQ] = ACTIONS(4321),
    [anon_sym_BANG_EQ] = ACTIONS(4317),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4317),
    [anon_sym_LT_EQ_GT] = ACTIONS(4317),
    [anon_sym_EQ_TILDE] = ACTIONS(4317),
    [anon_sym_BANG_TILDE] = ACTIONS(4317),
    [anon_sym_LT_EQ] = ACTIONS(4307),
    [anon_sym_GT] = ACTIONS(4307),
    [anon_sym_GT_EQ] = ACTIONS(4323),
    [anon_sym_CARET] = ACTIONS(4325),
    [anon_sym_PLUS] = ACTIONS(4299),
    [anon_sym_SLASH] = ACTIONS(4301),
    [anon_sym_PERCENT] = ACTIONS(4301),
    [sym_comment] = ACTIONS(87),
  },
  [4959] = {
    [aux_sym_exceptions_repeat1] = STATE(7429),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_RPAREN] = ACTIONS(6191),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [4960] = {
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(4299),
    [sym__binary_star] = ACTIONS(4301),
    [anon_sym_RPAREN] = ACTIONS(6210),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(4303),
    [anon_sym_STAR_STAR] = ACTIONS(4301),
    [anon_sym_AMP] = ACTIONS(4305),
    [anon_sym_LT] = ACTIONS(4307),
    [anon_sym_EQ_GT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(4309),
    [anon_sym_DOT_DOT] = ACTIONS(4311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4313),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(4317),
    [anon_sym_AMP_AMP] = ACTIONS(4317),
    [anon_sym_LT_LT] = ACTIONS(4319),
    [anon_sym_GT_GT] = ACTIONS(4319),
    [anon_sym_EQ_EQ] = ACTIONS(4321),
    [anon_sym_BANG_EQ] = ACTIONS(4317),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4317),
    [anon_sym_LT_EQ_GT] = ACTIONS(4317),
    [anon_sym_EQ_TILDE] = ACTIONS(4317),
    [anon_sym_BANG_TILDE] = ACTIONS(4317),
    [anon_sym_LT_EQ] = ACTIONS(4307),
    [anon_sym_GT] = ACTIONS(4307),
    [anon_sym_GT_EQ] = ACTIONS(4323),
    [anon_sym_CARET] = ACTIONS(4325),
    [anon_sym_PLUS] = ACTIONS(4299),
    [anon_sym_SLASH] = ACTIONS(4301),
    [anon_sym_PERCENT] = ACTIONS(4301),
    [sym_comment] = ACTIONS(87),
  },
  [4961] = {
    [sym_string] = STATE(4961),
    [aux_sym_chained_string_repeat1] = STATE(4961),
    [sym__string_start] = ACTIONS(9407),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_RPAREN] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_EQ_GT] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [4962] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7430),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_assignment] = STATE(7430),
    [sym_operator_assignment] = STATE(7430),
    [sym_conditional] = STATE(7430),
    [sym_range] = STATE(7430),
    [sym_binary] = STATE(7430),
    [sym_unary] = STATE(7430),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(880),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(373),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(383),
    [anon_sym_yield] = ACTIONS(385),
    [anon_sym_break] = ACTIONS(387),
    [anon_sym_next] = ACTIONS(389),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1575),
    [anon_sym_defined_QMARK] = ACTIONS(395),
    [anon_sym_not] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_TILDE] = ACTIONS(401),
    [sym_constant] = ACTIONS(407),
    [sym_identifier] = ACTIONS(407),
    [sym_instance_variable] = ACTIONS(405),
    [sym_class_variable] = ACTIONS(405),
    [sym_global_variable] = ACTIONS(405),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(407),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(407),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4963] = {
    [sym__line_break] = ACTIONS(4285),
    [sym__simple_symbol] = ACTIONS(4285),
    [sym__string_start] = ACTIONS(4285),
    [sym__symbol_start] = ACTIONS(4285),
    [sym__subshell_start] = ACTIONS(4285),
    [sym__regex_start] = ACTIONS(4285),
    [sym__string_array_start] = ACTIONS(4285),
    [sym__symbol_array_start] = ACTIONS(4285),
    [sym__heredoc_body_start] = ACTIONS(4285),
    [sym_heredoc_beginning] = ACTIONS(4285),
    [sym__block_ampersand] = ACTIONS(4285),
    [sym__splat_star] = ACTIONS(4285),
    [sym__unary_minus] = ACTIONS(4285),
    [sym__binary_minus] = ACTIONS(4285),
    [sym__binary_star] = ACTIONS(4285),
    [sym__identifier_hash_key] = ACTIONS(4285),
    [ts_builtin_sym_end] = ACTIONS(4285),
    [anon_sym___END__] = ACTIONS(4287),
    [anon_sym_LBRACE] = ACTIONS(4285),
    [anon_sym_RBRACE] = ACTIONS(4285),
    [anon_sym_def] = ACTIONS(4287),
    [anon_sym_LPAREN] = ACTIONS(4287),
    [anon_sym_RPAREN] = ACTIONS(4285),
    [anon_sym_DOT] = ACTIONS(4287),
    [anon_sym_COLON_COLON] = ACTIONS(4287),
    [anon_sym_COMMA] = ACTIONS(4285),
    [anon_sym_PIPE] = ACTIONS(4287),
    [anon_sym_SEMI] = ACTIONS(4285),
    [anon_sym_STAR] = ACTIONS(4287),
    [anon_sym_STAR_STAR] = ACTIONS(4287),
    [anon_sym_AMP] = ACTIONS(4287),
    [anon_sym_EQ] = ACTIONS(4287),
    [anon_sym_class] = ACTIONS(4287),
    [anon_sym_LT] = ACTIONS(4287),
    [anon_sym_module] = ACTIONS(4287),
    [anon_sym_end] = ACTIONS(4287),
    [anon_sym_return] = ACTIONS(4287),
    [anon_sym_yield] = ACTIONS(4287),
    [anon_sym_break] = ACTIONS(4287),
    [anon_sym_next] = ACTIONS(4287),
    [sym_redo] = ACTIONS(4287),
    [sym_retry] = ACTIONS(4287),
    [anon_sym_if] = ACTIONS(4287),
    [anon_sym_unless] = ACTIONS(4287),
    [anon_sym_while] = ACTIONS(4287),
    [anon_sym_until] = ACTIONS(4287),
    [anon_sym_rescue] = ACTIONS(4287),
    [anon_sym_for] = ACTIONS(4287),
    [anon_sym_do] = ACTIONS(4287),
    [anon_sym_case] = ACTIONS(4287),
    [anon_sym_when] = ACTIONS(4287),
    [anon_sym_elsif] = ACTIONS(4287),
    [anon_sym_else] = ACTIONS(4287),
    [anon_sym_then] = ACTIONS(4287),
    [anon_sym_begin] = ACTIONS(4287),
    [anon_sym_ensure] = ACTIONS(4287),
    [anon_sym_EQ_GT] = ACTIONS(4285),
    [anon_sym_LBRACK] = ACTIONS(4285),
    [anon_sym_COLON_COLON2] = ACTIONS(4285),
    [anon_sym_AMP_DOT] = ACTIONS(4285),
    [anon_sym_LPAREN2] = ACTIONS(4285),
    [anon_sym_PLUS_EQ] = ACTIONS(4285),
    [anon_sym_DASH_EQ] = ACTIONS(4285),
    [anon_sym_STAR_EQ] = ACTIONS(4285),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4285),
    [anon_sym_SLASH_EQ] = ACTIONS(4285),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4285),
    [anon_sym_PIPE_EQ] = ACTIONS(4285),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4285),
    [anon_sym_AMP_EQ] = ACTIONS(4285),
    [anon_sym_PERCENT_EQ] = ACTIONS(4285),
    [anon_sym_GT_GT_EQ] = ACTIONS(4285),
    [anon_sym_LT_LT_EQ] = ACTIONS(4285),
    [anon_sym_CARET_EQ] = ACTIONS(4285),
    [anon_sym_QMARK] = ACTIONS(4287),
    [anon_sym_DOT_DOT] = ACTIONS(4287),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4285),
    [anon_sym_and] = ACTIONS(4287),
    [anon_sym_or] = ACTIONS(4287),
    [anon_sym_PIPE_PIPE] = ACTIONS(4287),
    [anon_sym_AMP_AMP] = ACTIONS(4287),
    [anon_sym_LT_LT] = ACTIONS(4287),
    [anon_sym_GT_GT] = ACTIONS(4287),
    [anon_sym_EQ_EQ] = ACTIONS(4287),
    [anon_sym_BANG_EQ] = ACTIONS(4285),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4285),
    [anon_sym_LT_EQ_GT] = ACTIONS(4285),
    [anon_sym_EQ_TILDE] = ACTIONS(4285),
    [anon_sym_BANG_TILDE] = ACTIONS(4285),
    [anon_sym_LT_EQ] = ACTIONS(4287),
    [anon_sym_GT] = ACTIONS(4287),
    [anon_sym_GT_EQ] = ACTIONS(4285),
    [anon_sym_CARET] = ACTIONS(4287),
    [anon_sym_PLUS] = ACTIONS(4287),
    [anon_sym_SLASH] = ACTIONS(4287),
    [anon_sym_PERCENT] = ACTIONS(4287),
    [anon_sym_defined_QMARK] = ACTIONS(4285),
    [anon_sym_not] = ACTIONS(4287),
    [anon_sym_BANG] = ACTIONS(4287),
    [anon_sym_TILDE] = ACTIONS(4285),
    [sym_constant] = ACTIONS(4287),
    [sym_identifier] = ACTIONS(4287),
    [sym_instance_variable] = ACTIONS(4285),
    [sym_class_variable] = ACTIONS(4285),
    [sym_global_variable] = ACTIONS(4285),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4287),
    [sym_float] = ACTIONS(4287),
    [sym_complex] = ACTIONS(4285),
    [sym_super] = ACTIONS(4287),
    [anon_sym_true] = ACTIONS(4287),
    [anon_sym_TRUE] = ACTIONS(4287),
    [anon_sym_false] = ACTIONS(4287),
    [anon_sym_FALSE] = ACTIONS(4287),
    [sym_self] = ACTIONS(4287),
    [anon_sym_nil] = ACTIONS(4287),
    [anon_sym_NIL] = ACTIONS(4287),
    [sym_character] = ACTIONS(4285),
    [anon_sym_LBRACK2] = ACTIONS(4287),
    [anon_sym_DASH_GT] = ACTIONS(4285),
  },
  [4964] = {
    [anon_sym_RPAREN] = ACTIONS(10966),
    [sym_comment] = ACTIONS(87),
  },
  [4965] = {
    [sym__line_break] = ACTIONS(9679),
    [sym__simple_symbol] = ACTIONS(9679),
    [sym__string_start] = ACTIONS(9679),
    [sym__symbol_start] = ACTIONS(9679),
    [sym__subshell_start] = ACTIONS(9679),
    [sym__regex_start] = ACTIONS(9679),
    [sym__string_array_start] = ACTIONS(9679),
    [sym__symbol_array_start] = ACTIONS(9679),
    [sym__heredoc_body_start] = ACTIONS(9679),
    [sym_heredoc_beginning] = ACTIONS(9679),
    [sym__block_ampersand] = ACTIONS(9679),
    [sym__splat_star] = ACTIONS(9679),
    [sym__unary_minus] = ACTIONS(9679),
    [sym__binary_minus] = ACTIONS(9679),
    [sym__binary_star] = ACTIONS(9679),
    [sym__identifier_hash_key] = ACTIONS(9679),
    [ts_builtin_sym_end] = ACTIONS(9679),
    [anon_sym___END__] = ACTIONS(9681),
    [anon_sym_LBRACE] = ACTIONS(9679),
    [anon_sym_RBRACE] = ACTIONS(9679),
    [anon_sym_def] = ACTIONS(9681),
    [anon_sym_LPAREN] = ACTIONS(9681),
    [anon_sym_RPAREN] = ACTIONS(9679),
    [anon_sym_DOT] = ACTIONS(9681),
    [anon_sym_COLON_COLON] = ACTIONS(9681),
    [anon_sym_COMMA] = ACTIONS(9679),
    [anon_sym_PIPE] = ACTIONS(9681),
    [anon_sym_SEMI] = ACTIONS(9679),
    [anon_sym_STAR] = ACTIONS(9681),
    [anon_sym_STAR_STAR] = ACTIONS(9681),
    [anon_sym_AMP] = ACTIONS(9681),
    [anon_sym_EQ] = ACTIONS(9681),
    [anon_sym_class] = ACTIONS(9681),
    [anon_sym_LT] = ACTIONS(9681),
    [anon_sym_module] = ACTIONS(9681),
    [anon_sym_end] = ACTIONS(9681),
    [anon_sym_return] = ACTIONS(9681),
    [anon_sym_yield] = ACTIONS(9681),
    [anon_sym_break] = ACTIONS(9681),
    [anon_sym_next] = ACTIONS(9681),
    [sym_redo] = ACTIONS(9681),
    [sym_retry] = ACTIONS(9681),
    [anon_sym_if] = ACTIONS(9681),
    [anon_sym_unless] = ACTIONS(9681),
    [anon_sym_while] = ACTIONS(9681),
    [anon_sym_until] = ACTIONS(9681),
    [anon_sym_rescue] = ACTIONS(9681),
    [anon_sym_for] = ACTIONS(9681),
    [anon_sym_do] = ACTIONS(9681),
    [anon_sym_case] = ACTIONS(9681),
    [anon_sym_when] = ACTIONS(9681),
    [anon_sym_elsif] = ACTIONS(9681),
    [anon_sym_else] = ACTIONS(9681),
    [anon_sym_then] = ACTIONS(9681),
    [anon_sym_begin] = ACTIONS(9681),
    [anon_sym_ensure] = ACTIONS(9681),
    [anon_sym_EQ_GT] = ACTIONS(9679),
    [anon_sym_LBRACK] = ACTIONS(9679),
    [anon_sym_COLON_COLON2] = ACTIONS(9679),
    [anon_sym_AMP_DOT] = ACTIONS(9679),
    [anon_sym_LPAREN2] = ACTIONS(9679),
    [anon_sym_PLUS_EQ] = ACTIONS(9679),
    [anon_sym_DASH_EQ] = ACTIONS(9679),
    [anon_sym_STAR_EQ] = ACTIONS(9679),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9679),
    [anon_sym_SLASH_EQ] = ACTIONS(9679),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9679),
    [anon_sym_PIPE_EQ] = ACTIONS(9679),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9679),
    [anon_sym_AMP_EQ] = ACTIONS(9679),
    [anon_sym_PERCENT_EQ] = ACTIONS(9679),
    [anon_sym_GT_GT_EQ] = ACTIONS(9679),
    [anon_sym_LT_LT_EQ] = ACTIONS(9679),
    [anon_sym_CARET_EQ] = ACTIONS(9679),
    [anon_sym_QMARK] = ACTIONS(9681),
    [anon_sym_DOT_DOT] = ACTIONS(9681),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9679),
    [anon_sym_and] = ACTIONS(9681),
    [anon_sym_or] = ACTIONS(9681),
    [anon_sym_PIPE_PIPE] = ACTIONS(9681),
    [anon_sym_AMP_AMP] = ACTIONS(9681),
    [anon_sym_LT_LT] = ACTIONS(9681),
    [anon_sym_GT_GT] = ACTIONS(9681),
    [anon_sym_EQ_EQ] = ACTIONS(9681),
    [anon_sym_BANG_EQ] = ACTIONS(9679),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9679),
    [anon_sym_LT_EQ_GT] = ACTIONS(9679),
    [anon_sym_EQ_TILDE] = ACTIONS(9679),
    [anon_sym_BANG_TILDE] = ACTIONS(9679),
    [anon_sym_LT_EQ] = ACTIONS(9681),
    [anon_sym_GT] = ACTIONS(9681),
    [anon_sym_GT_EQ] = ACTIONS(9679),
    [anon_sym_CARET] = ACTIONS(9681),
    [anon_sym_PLUS] = ACTIONS(9681),
    [anon_sym_SLASH] = ACTIONS(9681),
    [anon_sym_PERCENT] = ACTIONS(9681),
    [anon_sym_defined_QMARK] = ACTIONS(9679),
    [anon_sym_not] = ACTIONS(9681),
    [anon_sym_BANG] = ACTIONS(9681),
    [anon_sym_TILDE] = ACTIONS(9679),
    [sym_constant] = ACTIONS(9681),
    [sym_identifier] = ACTIONS(9681),
    [sym_instance_variable] = ACTIONS(9679),
    [sym_class_variable] = ACTIONS(9679),
    [sym_global_variable] = ACTIONS(9679),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(9681),
    [sym_float] = ACTIONS(9681),
    [sym_complex] = ACTIONS(9679),
    [sym_super] = ACTIONS(9681),
    [anon_sym_true] = ACTIONS(9681),
    [anon_sym_TRUE] = ACTIONS(9681),
    [anon_sym_false] = ACTIONS(9681),
    [anon_sym_FALSE] = ACTIONS(9681),
    [sym_self] = ACTIONS(9681),
    [anon_sym_nil] = ACTIONS(9681),
    [anon_sym_NIL] = ACTIONS(9681),
    [sym_character] = ACTIONS(9679),
    [anon_sym_LBRACK2] = ACTIONS(9681),
    [anon_sym_DASH_GT] = ACTIONS(9679),
  },
  [4966] = {
    [sym__line_break] = ACTIONS(9686),
    [sym__heredoc_body_start] = ACTIONS(9686),
    [sym__binary_minus] = ACTIONS(9686),
    [sym__binary_star] = ACTIONS(9686),
    [ts_builtin_sym_end] = ACTIONS(9686),
    [anon_sym___END__] = ACTIONS(9686),
    [anon_sym_LBRACE] = ACTIONS(9686),
    [anon_sym_RBRACE] = ACTIONS(9686),
    [anon_sym_RPAREN] = ACTIONS(9686),
    [anon_sym_DOT] = ACTIONS(9688),
    [anon_sym_COMMA] = ACTIONS(9686),
    [anon_sym_PIPE] = ACTIONS(9688),
    [anon_sym_SEMI] = ACTIONS(9686),
    [anon_sym_STAR_STAR] = ACTIONS(9688),
    [anon_sym_AMP] = ACTIONS(9688),
    [anon_sym_EQ] = ACTIONS(9688),
    [anon_sym_LT] = ACTIONS(9688),
    [anon_sym_end] = ACTIONS(9686),
    [anon_sym_if] = ACTIONS(9686),
    [anon_sym_unless] = ACTIONS(9686),
    [anon_sym_while] = ACTIONS(9686),
    [anon_sym_until] = ACTIONS(9686),
    [anon_sym_rescue] = ACTIONS(9686),
    [anon_sym_do] = ACTIONS(9686),
    [anon_sym_when] = ACTIONS(9686),
    [anon_sym_elsif] = ACTIONS(9686),
    [anon_sym_else] = ACTIONS(9686),
    [anon_sym_then] = ACTIONS(9686),
    [anon_sym_ensure] = ACTIONS(9686),
    [anon_sym_EQ_GT] = ACTIONS(9686),
    [anon_sym_LBRACK] = ACTIONS(9686),
    [anon_sym_COLON_COLON2] = ACTIONS(9686),
    [anon_sym_AMP_DOT] = ACTIONS(9686),
    [anon_sym_PLUS_EQ] = ACTIONS(9686),
    [anon_sym_DASH_EQ] = ACTIONS(9686),
    [anon_sym_STAR_EQ] = ACTIONS(9686),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9686),
    [anon_sym_SLASH_EQ] = ACTIONS(9686),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9686),
    [anon_sym_PIPE_EQ] = ACTIONS(9686),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9686),
    [anon_sym_AMP_EQ] = ACTIONS(9686),
    [anon_sym_PERCENT_EQ] = ACTIONS(9686),
    [anon_sym_GT_GT_EQ] = ACTIONS(9686),
    [anon_sym_LT_LT_EQ] = ACTIONS(9686),
    [anon_sym_CARET_EQ] = ACTIONS(9686),
    [anon_sym_QMARK] = ACTIONS(9686),
    [anon_sym_DOT_DOT] = ACTIONS(9688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9686),
    [anon_sym_and] = ACTIONS(9686),
    [anon_sym_or] = ACTIONS(9686),
    [anon_sym_PIPE_PIPE] = ACTIONS(9688),
    [anon_sym_AMP_AMP] = ACTIONS(9688),
    [anon_sym_LT_LT] = ACTIONS(9688),
    [anon_sym_GT_GT] = ACTIONS(9688),
    [anon_sym_EQ_EQ] = ACTIONS(9688),
    [anon_sym_BANG_EQ] = ACTIONS(9686),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9686),
    [anon_sym_LT_EQ_GT] = ACTIONS(9686),
    [anon_sym_EQ_TILDE] = ACTIONS(9686),
    [anon_sym_BANG_TILDE] = ACTIONS(9686),
    [anon_sym_LT_EQ] = ACTIONS(9688),
    [anon_sym_GT] = ACTIONS(9688),
    [anon_sym_GT_EQ] = ACTIONS(9686),
    [anon_sym_CARET] = ACTIONS(9688),
    [anon_sym_PLUS] = ACTIONS(9688),
    [anon_sym_SLASH] = ACTIONS(9688),
    [anon_sym_PERCENT] = ACTIONS(9688),
    [sym_comment] = ACTIONS(87),
  },
  [4967] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(2687),
    [sym__binary_star] = ACTIONS(2689),
    [ts_builtin_sym_end] = ACTIONS(6823),
    [anon_sym___END__] = ACTIONS(6823),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(2691),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(2693),
    [anon_sym_AMP] = ACTIONS(2695),
    [anon_sym_EQ] = ACTIONS(7822),
    [anon_sym_LT] = ACTIONS(2697),
    [anon_sym_if] = ACTIONS(6823),
    [anon_sym_unless] = ACTIONS(6823),
    [anon_sym_while] = ACTIONS(6823),
    [anon_sym_until] = ACTIONS(6823),
    [anon_sym_rescue] = ACTIONS(6823),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_EQ_GT] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_PLUS_EQ] = ACTIONS(6823),
    [anon_sym_DASH_EQ] = ACTIONS(6823),
    [anon_sym_STAR_EQ] = ACTIONS(6823),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6823),
    [anon_sym_SLASH_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6823),
    [anon_sym_AMP_EQ] = ACTIONS(6823),
    [anon_sym_PERCENT_EQ] = ACTIONS(6823),
    [anon_sym_GT_GT_EQ] = ACTIONS(6823),
    [anon_sym_LT_LT_EQ] = ACTIONS(6823),
    [anon_sym_CARET_EQ] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(2699),
    [anon_sym_DOT_DOT] = ACTIONS(2701),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2703),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(2705),
    [anon_sym_AMP_AMP] = ACTIONS(2705),
    [anon_sym_LT_LT] = ACTIONS(2707),
    [anon_sym_GT_GT] = ACTIONS(2707),
    [anon_sym_EQ_EQ] = ACTIONS(2705),
    [anon_sym_BANG_EQ] = ACTIONS(2709),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2709),
    [anon_sym_LT_EQ_GT] = ACTIONS(2709),
    [anon_sym_EQ_TILDE] = ACTIONS(2709),
    [anon_sym_BANG_TILDE] = ACTIONS(2709),
    [anon_sym_LT_EQ] = ACTIONS(2697),
    [anon_sym_GT] = ACTIONS(2697),
    [anon_sym_GT_EQ] = ACTIONS(2711),
    [anon_sym_CARET] = ACTIONS(2691),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_SLASH] = ACTIONS(2693),
    [anon_sym_PERCENT] = ACTIONS(2693),
    [sym_comment] = ACTIONS(87),
  },
  [4968] = {
    [sym__line_break] = ACTIONS(9426),
    [sym__heredoc_body_start] = ACTIONS(9426),
    [sym__binary_minus] = ACTIONS(9426),
    [sym__binary_star] = ACTIONS(9426),
    [ts_builtin_sym_end] = ACTIONS(9426),
    [anon_sym___END__] = ACTIONS(9426),
    [anon_sym_LBRACE] = ACTIONS(9426),
    [anon_sym_RBRACE] = ACTIONS(9426),
    [anon_sym_RPAREN] = ACTIONS(9426),
    [anon_sym_DOT] = ACTIONS(9428),
    [anon_sym_COMMA] = ACTIONS(9426),
    [anon_sym_PIPE] = ACTIONS(9428),
    [anon_sym_SEMI] = ACTIONS(9426),
    [anon_sym_STAR_STAR] = ACTIONS(9428),
    [anon_sym_AMP] = ACTIONS(9428),
    [anon_sym_EQ] = ACTIONS(9428),
    [anon_sym_LT] = ACTIONS(9428),
    [anon_sym_end] = ACTIONS(9426),
    [anon_sym_if] = ACTIONS(9426),
    [anon_sym_unless] = ACTIONS(9426),
    [anon_sym_while] = ACTIONS(9426),
    [anon_sym_until] = ACTIONS(9426),
    [anon_sym_rescue] = ACTIONS(9426),
    [anon_sym_do] = ACTIONS(9426),
    [anon_sym_when] = ACTIONS(9426),
    [anon_sym_elsif] = ACTIONS(9426),
    [anon_sym_else] = ACTIONS(9426),
    [anon_sym_then] = ACTIONS(9426),
    [anon_sym_ensure] = ACTIONS(9426),
    [anon_sym_EQ_GT] = ACTIONS(9426),
    [anon_sym_LBRACK] = ACTIONS(9426),
    [anon_sym_COLON_COLON2] = ACTIONS(9426),
    [anon_sym_AMP_DOT] = ACTIONS(9426),
    [anon_sym_PLUS_EQ] = ACTIONS(9426),
    [anon_sym_DASH_EQ] = ACTIONS(9426),
    [anon_sym_STAR_EQ] = ACTIONS(9426),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9426),
    [anon_sym_SLASH_EQ] = ACTIONS(9426),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9426),
    [anon_sym_PIPE_EQ] = ACTIONS(9426),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9426),
    [anon_sym_AMP_EQ] = ACTIONS(9426),
    [anon_sym_PERCENT_EQ] = ACTIONS(9426),
    [anon_sym_GT_GT_EQ] = ACTIONS(9426),
    [anon_sym_LT_LT_EQ] = ACTIONS(9426),
    [anon_sym_CARET_EQ] = ACTIONS(9426),
    [anon_sym_QMARK] = ACTIONS(9426),
    [anon_sym_DOT_DOT] = ACTIONS(9428),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9426),
    [anon_sym_and] = ACTIONS(9426),
    [anon_sym_or] = ACTIONS(9426),
    [anon_sym_PIPE_PIPE] = ACTIONS(9428),
    [anon_sym_AMP_AMP] = ACTIONS(9428),
    [anon_sym_LT_LT] = ACTIONS(9428),
    [anon_sym_GT_GT] = ACTIONS(9428),
    [anon_sym_EQ_EQ] = ACTIONS(9428),
    [anon_sym_BANG_EQ] = ACTIONS(9426),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9426),
    [anon_sym_LT_EQ_GT] = ACTIONS(9426),
    [anon_sym_EQ_TILDE] = ACTIONS(9426),
    [anon_sym_BANG_TILDE] = ACTIONS(9426),
    [anon_sym_LT_EQ] = ACTIONS(9428),
    [anon_sym_GT] = ACTIONS(9428),
    [anon_sym_GT_EQ] = ACTIONS(9426),
    [anon_sym_CARET] = ACTIONS(9428),
    [anon_sym_PLUS] = ACTIONS(9428),
    [anon_sym_SLASH] = ACTIONS(9428),
    [anon_sym_PERCENT] = ACTIONS(9428),
    [sym_comment] = ACTIONS(87),
  },
  [4969] = {
    [anon_sym_RBRACE] = ACTIONS(10968),
    [sym_comment] = ACTIONS(87),
  },
  [4970] = {
    [sym__line_break] = ACTIONS(9446),
    [sym__heredoc_body_start] = ACTIONS(9446),
    [sym__binary_minus] = ACTIONS(9446),
    [sym__binary_star] = ACTIONS(9446),
    [ts_builtin_sym_end] = ACTIONS(9446),
    [anon_sym___END__] = ACTIONS(9446),
    [anon_sym_LBRACE] = ACTIONS(9446),
    [anon_sym_RBRACE] = ACTIONS(9446),
    [anon_sym_RPAREN] = ACTIONS(9446),
    [anon_sym_DOT] = ACTIONS(9448),
    [anon_sym_COMMA] = ACTIONS(9446),
    [anon_sym_PIPE] = ACTIONS(9448),
    [anon_sym_SEMI] = ACTIONS(9446),
    [anon_sym_STAR_STAR] = ACTIONS(9448),
    [anon_sym_AMP] = ACTIONS(9448),
    [anon_sym_EQ] = ACTIONS(9448),
    [anon_sym_LT] = ACTIONS(9448),
    [anon_sym_end] = ACTIONS(9446),
    [anon_sym_if] = ACTIONS(9446),
    [anon_sym_unless] = ACTIONS(9446),
    [anon_sym_while] = ACTIONS(9446),
    [anon_sym_until] = ACTIONS(9446),
    [anon_sym_rescue] = ACTIONS(9446),
    [anon_sym_do] = ACTIONS(9446),
    [anon_sym_when] = ACTIONS(9446),
    [anon_sym_elsif] = ACTIONS(9446),
    [anon_sym_else] = ACTIONS(9446),
    [anon_sym_then] = ACTIONS(9446),
    [anon_sym_ensure] = ACTIONS(9446),
    [anon_sym_EQ_GT] = ACTIONS(9446),
    [anon_sym_LBRACK] = ACTIONS(9446),
    [anon_sym_COLON_COLON2] = ACTIONS(9446),
    [anon_sym_AMP_DOT] = ACTIONS(9446),
    [anon_sym_PLUS_EQ] = ACTIONS(9446),
    [anon_sym_DASH_EQ] = ACTIONS(9446),
    [anon_sym_STAR_EQ] = ACTIONS(9446),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9446),
    [anon_sym_SLASH_EQ] = ACTIONS(9446),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9446),
    [anon_sym_PIPE_EQ] = ACTIONS(9446),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9446),
    [anon_sym_AMP_EQ] = ACTIONS(9446),
    [anon_sym_PERCENT_EQ] = ACTIONS(9446),
    [anon_sym_GT_GT_EQ] = ACTIONS(9446),
    [anon_sym_LT_LT_EQ] = ACTIONS(9446),
    [anon_sym_CARET_EQ] = ACTIONS(9446),
    [anon_sym_QMARK] = ACTIONS(9446),
    [anon_sym_DOT_DOT] = ACTIONS(9448),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9446),
    [anon_sym_and] = ACTIONS(9446),
    [anon_sym_or] = ACTIONS(9446),
    [anon_sym_PIPE_PIPE] = ACTIONS(9448),
    [anon_sym_AMP_AMP] = ACTIONS(9448),
    [anon_sym_LT_LT] = ACTIONS(9448),
    [anon_sym_GT_GT] = ACTIONS(9448),
    [anon_sym_EQ_EQ] = ACTIONS(9448),
    [anon_sym_BANG_EQ] = ACTIONS(9446),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9446),
    [anon_sym_LT_EQ_GT] = ACTIONS(9446),
    [anon_sym_EQ_TILDE] = ACTIONS(9446),
    [anon_sym_BANG_TILDE] = ACTIONS(9446),
    [anon_sym_LT_EQ] = ACTIONS(9448),
    [anon_sym_GT] = ACTIONS(9448),
    [anon_sym_GT_EQ] = ACTIONS(9446),
    [anon_sym_CARET] = ACTIONS(9448),
    [anon_sym_PLUS] = ACTIONS(9448),
    [anon_sym_SLASH] = ACTIONS(9448),
    [anon_sym_PERCENT] = ACTIONS(9448),
    [sym_comment] = ACTIONS(87),
  },
  [4971] = {
    [anon_sym_end] = ACTIONS(10970),
    [sym_comment] = ACTIONS(87),
  },
  [4972] = {
    [sym__statements] = STATE(7434),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10972),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4973] = {
    [sym__statements] = STATE(7434),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_heredoc_body] = STATE(7435),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [sym__terminator] = STATE(7435),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__line_break] = ACTIONS(10974),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(10974),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10972),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4974] = {
    [sym__line_break] = ACTIONS(7876),
    [sym__heredoc_body_start] = ACTIONS(7876),
    [sym__binary_minus] = ACTIONS(7876),
    [sym__binary_star] = ACTIONS(7876),
    [ts_builtin_sym_end] = ACTIONS(7876),
    [anon_sym___END__] = ACTIONS(7876),
    [anon_sym_LBRACE] = ACTIONS(7876),
    [anon_sym_RBRACE] = ACTIONS(7876),
    [anon_sym_RPAREN] = ACTIONS(7876),
    [anon_sym_DOT] = ACTIONS(7878),
    [anon_sym_COMMA] = ACTIONS(7876),
    [anon_sym_PIPE] = ACTIONS(7878),
    [anon_sym_SEMI] = ACTIONS(7876),
    [anon_sym_STAR_STAR] = ACTIONS(7878),
    [anon_sym_AMP] = ACTIONS(7878),
    [anon_sym_EQ] = ACTIONS(7878),
    [anon_sym_LT] = ACTIONS(7878),
    [anon_sym_end] = ACTIONS(7876),
    [anon_sym_if] = ACTIONS(7876),
    [anon_sym_unless] = ACTIONS(7876),
    [anon_sym_while] = ACTIONS(7876),
    [anon_sym_until] = ACTIONS(7876),
    [anon_sym_rescue] = ACTIONS(7876),
    [anon_sym_do] = ACTIONS(7876),
    [anon_sym_when] = ACTIONS(7876),
    [anon_sym_elsif] = ACTIONS(7876),
    [anon_sym_else] = ACTIONS(7876),
    [anon_sym_then] = ACTIONS(7876),
    [anon_sym_ensure] = ACTIONS(7876),
    [anon_sym_EQ_GT] = ACTIONS(7876),
    [anon_sym_LBRACK] = ACTIONS(7876),
    [anon_sym_COLON_COLON2] = ACTIONS(7876),
    [anon_sym_AMP_DOT] = ACTIONS(7876),
    [anon_sym_PLUS_EQ] = ACTIONS(7876),
    [anon_sym_DASH_EQ] = ACTIONS(7876),
    [anon_sym_STAR_EQ] = ACTIONS(7876),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7876),
    [anon_sym_SLASH_EQ] = ACTIONS(7876),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7876),
    [anon_sym_PIPE_EQ] = ACTIONS(7876),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7876),
    [anon_sym_AMP_EQ] = ACTIONS(7876),
    [anon_sym_PERCENT_EQ] = ACTIONS(7876),
    [anon_sym_GT_GT_EQ] = ACTIONS(7876),
    [anon_sym_LT_LT_EQ] = ACTIONS(7876),
    [anon_sym_CARET_EQ] = ACTIONS(7876),
    [anon_sym_QMARK] = ACTIONS(7876),
    [anon_sym_DOT_DOT] = ACTIONS(7878),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7876),
    [anon_sym_and] = ACTIONS(7876),
    [anon_sym_or] = ACTIONS(7876),
    [anon_sym_PIPE_PIPE] = ACTIONS(7878),
    [anon_sym_AMP_AMP] = ACTIONS(7878),
    [anon_sym_LT_LT] = ACTIONS(7878),
    [anon_sym_GT_GT] = ACTIONS(7878),
    [anon_sym_EQ_EQ] = ACTIONS(7878),
    [anon_sym_BANG_EQ] = ACTIONS(7876),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7876),
    [anon_sym_LT_EQ_GT] = ACTIONS(7876),
    [anon_sym_EQ_TILDE] = ACTIONS(7876),
    [anon_sym_BANG_TILDE] = ACTIONS(7876),
    [anon_sym_LT_EQ] = ACTIONS(7878),
    [anon_sym_GT] = ACTIONS(7878),
    [anon_sym_GT_EQ] = ACTIONS(7876),
    [anon_sym_CARET] = ACTIONS(7878),
    [anon_sym_PLUS] = ACTIONS(7878),
    [anon_sym_SLASH] = ACTIONS(7878),
    [anon_sym_PERCENT] = ACTIONS(7878),
    [sym_comment] = ACTIONS(87),
  },
  [4975] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(2687),
    [sym__binary_star] = ACTIONS(2689),
    [ts_builtin_sym_end] = ACTIONS(7027),
    [anon_sym___END__] = ACTIONS(7027),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(2691),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(2693),
    [anon_sym_AMP] = ACTIONS(2695),
    [anon_sym_EQ] = ACTIONS(7884),
    [anon_sym_LT] = ACTIONS(2697),
    [anon_sym_if] = ACTIONS(7027),
    [anon_sym_unless] = ACTIONS(7027),
    [anon_sym_while] = ACTIONS(7027),
    [anon_sym_until] = ACTIONS(7027),
    [anon_sym_rescue] = ACTIONS(7027),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_EQ_GT] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_PLUS_EQ] = ACTIONS(7027),
    [anon_sym_DASH_EQ] = ACTIONS(7027),
    [anon_sym_STAR_EQ] = ACTIONS(7027),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7027),
    [anon_sym_SLASH_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7027),
    [anon_sym_AMP_EQ] = ACTIONS(7027),
    [anon_sym_PERCENT_EQ] = ACTIONS(7027),
    [anon_sym_GT_GT_EQ] = ACTIONS(7027),
    [anon_sym_LT_LT_EQ] = ACTIONS(7027),
    [anon_sym_CARET_EQ] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(2699),
    [anon_sym_DOT_DOT] = ACTIONS(2701),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2703),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(2705),
    [anon_sym_AMP_AMP] = ACTIONS(2705),
    [anon_sym_LT_LT] = ACTIONS(2707),
    [anon_sym_GT_GT] = ACTIONS(2707),
    [anon_sym_EQ_EQ] = ACTIONS(2705),
    [anon_sym_BANG_EQ] = ACTIONS(2709),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2709),
    [anon_sym_LT_EQ_GT] = ACTIONS(2709),
    [anon_sym_EQ_TILDE] = ACTIONS(2709),
    [anon_sym_BANG_TILDE] = ACTIONS(2709),
    [anon_sym_LT_EQ] = ACTIONS(2697),
    [anon_sym_GT] = ACTIONS(2697),
    [anon_sym_GT_EQ] = ACTIONS(2711),
    [anon_sym_CARET] = ACTIONS(2691),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_SLASH] = ACTIONS(2693),
    [anon_sym_PERCENT] = ACTIONS(2693),
    [sym_comment] = ACTIONS(87),
  },
  [4976] = {
    [sym__line_break] = ACTIONS(3235),
    [sym__heredoc_body_start] = ACTIONS(3235),
    [sym__binary_minus] = ACTIONS(3235),
    [sym__binary_star] = ACTIONS(3235),
    [ts_builtin_sym_end] = ACTIONS(3235),
    [anon_sym___END__] = ACTIONS(3235),
    [anon_sym_LBRACE] = ACTIONS(3235),
    [anon_sym_RBRACE] = ACTIONS(3235),
    [anon_sym_RPAREN] = ACTIONS(3235),
    [anon_sym_DOT] = ACTIONS(4997),
    [anon_sym_COMMA] = ACTIONS(3235),
    [anon_sym_PIPE] = ACTIONS(4997),
    [anon_sym_SEMI] = ACTIONS(3235),
    [anon_sym_STAR_STAR] = ACTIONS(4997),
    [anon_sym_AMP] = ACTIONS(4997),
    [anon_sym_EQ] = ACTIONS(4997),
    [anon_sym_LT] = ACTIONS(4997),
    [anon_sym_end] = ACTIONS(3235),
    [anon_sym_if] = ACTIONS(3235),
    [anon_sym_unless] = ACTIONS(3235),
    [anon_sym_while] = ACTIONS(3235),
    [anon_sym_until] = ACTIONS(3235),
    [anon_sym_rescue] = ACTIONS(3235),
    [anon_sym_do] = ACTIONS(3235),
    [anon_sym_when] = ACTIONS(3235),
    [anon_sym_elsif] = ACTIONS(3235),
    [anon_sym_else] = ACTIONS(3235),
    [anon_sym_then] = ACTIONS(3235),
    [anon_sym_ensure] = ACTIONS(3235),
    [anon_sym_EQ_GT] = ACTIONS(3235),
    [anon_sym_LBRACK] = ACTIONS(3235),
    [anon_sym_COLON_COLON2] = ACTIONS(3235),
    [anon_sym_AMP_DOT] = ACTIONS(3235),
    [anon_sym_PLUS_EQ] = ACTIONS(3235),
    [anon_sym_DASH_EQ] = ACTIONS(3235),
    [anon_sym_STAR_EQ] = ACTIONS(3235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3235),
    [anon_sym_SLASH_EQ] = ACTIONS(3235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3235),
    [anon_sym_PIPE_EQ] = ACTIONS(3235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3235),
    [anon_sym_AMP_EQ] = ACTIONS(3235),
    [anon_sym_PERCENT_EQ] = ACTIONS(3235),
    [anon_sym_GT_GT_EQ] = ACTIONS(3235),
    [anon_sym_LT_LT_EQ] = ACTIONS(3235),
    [anon_sym_CARET_EQ] = ACTIONS(3235),
    [anon_sym_QMARK] = ACTIONS(3235),
    [anon_sym_DOT_DOT] = ACTIONS(4997),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3235),
    [anon_sym_and] = ACTIONS(3235),
    [anon_sym_or] = ACTIONS(3235),
    [anon_sym_PIPE_PIPE] = ACTIONS(4997),
    [anon_sym_AMP_AMP] = ACTIONS(4997),
    [anon_sym_LT_LT] = ACTIONS(4997),
    [anon_sym_GT_GT] = ACTIONS(4997),
    [anon_sym_EQ_EQ] = ACTIONS(4997),
    [anon_sym_BANG_EQ] = ACTIONS(3235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3235),
    [anon_sym_LT_EQ_GT] = ACTIONS(3235),
    [anon_sym_EQ_TILDE] = ACTIONS(3235),
    [anon_sym_BANG_TILDE] = ACTIONS(3235),
    [anon_sym_LT_EQ] = ACTIONS(4997),
    [anon_sym_GT] = ACTIONS(4997),
    [anon_sym_GT_EQ] = ACTIONS(3235),
    [anon_sym_CARET] = ACTIONS(4997),
    [anon_sym_PLUS] = ACTIONS(4997),
    [anon_sym_SLASH] = ACTIONS(4997),
    [anon_sym_PERCENT] = ACTIONS(4997),
    [sym_comment] = ACTIONS(87),
  },
  [4977] = {
    [sym_interpolation] = STATE(1787),
    [aux_sym_heredoc_body_repeat1] = STATE(1787),
    [sym__heredoc_content] = ACTIONS(3237),
    [sym_heredoc_end] = ACTIONS(10976),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(3237),
  },
  [4978] = {
    [sym_heredoc_body] = STATE(4978),
    [aux_sym_call_repeat1] = STATE(4978),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(10978),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [ts_builtin_sym_end] = ACTIONS(7914),
    [anon_sym___END__] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7919),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_EQ] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_EQ_GT] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_PLUS_EQ] = ACTIONS(7914),
    [anon_sym_DASH_EQ] = ACTIONS(7914),
    [anon_sym_STAR_EQ] = ACTIONS(7914),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7914),
    [anon_sym_SLASH_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7914),
    [anon_sym_AMP_EQ] = ACTIONS(7914),
    [anon_sym_PERCENT_EQ] = ACTIONS(7914),
    [anon_sym_GT_GT_EQ] = ACTIONS(7914),
    [anon_sym_LT_LT_EQ] = ACTIONS(7914),
    [anon_sym_CARET_EQ] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7919),
    [anon_sym_AMP_AMP] = ACTIONS(7919),
    [anon_sym_LT_LT] = ACTIONS(7919),
    [anon_sym_GT_GT] = ACTIONS(7919),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7919),
    [anon_sym_PLUS] = ACTIONS(7919),
    [anon_sym_SLASH] = ACTIONS(7919),
    [anon_sym_PERCENT] = ACTIONS(7919),
    [sym_comment] = ACTIONS(87),
  },
  [4979] = {
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [ts_builtin_sym_end] = ACTIONS(7925),
    [anon_sym___END__] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_RBRACE] = ACTIONS(7925),
    [anon_sym_RPAREN] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(7925),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7927),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_EQ] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_end] = ACTIONS(7925),
    [anon_sym_if] = ACTIONS(7925),
    [anon_sym_unless] = ACTIONS(7925),
    [anon_sym_while] = ACTIONS(7925),
    [anon_sym_until] = ACTIONS(7925),
    [anon_sym_rescue] = ACTIONS(7925),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_when] = ACTIONS(7925),
    [anon_sym_elsif] = ACTIONS(7925),
    [anon_sym_else] = ACTIONS(7925),
    [anon_sym_then] = ACTIONS(7925),
    [anon_sym_ensure] = ACTIONS(7925),
    [anon_sym_EQ_GT] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_PLUS_EQ] = ACTIONS(7925),
    [anon_sym_DASH_EQ] = ACTIONS(7925),
    [anon_sym_STAR_EQ] = ACTIONS(7925),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7925),
    [anon_sym_SLASH_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7925),
    [anon_sym_AMP_EQ] = ACTIONS(7925),
    [anon_sym_PERCENT_EQ] = ACTIONS(7925),
    [anon_sym_GT_GT_EQ] = ACTIONS(7925),
    [anon_sym_LT_LT_EQ] = ACTIONS(7925),
    [anon_sym_CARET_EQ] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7927),
    [anon_sym_AMP_AMP] = ACTIONS(7927),
    [anon_sym_LT_LT] = ACTIONS(7927),
    [anon_sym_GT_GT] = ACTIONS(7927),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7927),
    [anon_sym_PLUS] = ACTIONS(7927),
    [anon_sym_SLASH] = ACTIONS(7927),
    [anon_sym_PERCENT] = ACTIONS(7927),
    [sym_comment] = ACTIONS(87),
  },
  [4980] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(937),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(428),
    [sym_scope_resolution] = STATE(422),
    [sym_call] = STATE(422),
    [sym_method_call] = STATE(428),
    [sym__argument] = STATE(7437),
    [sym_splat_argument] = STATE(7437),
    [sym_hash_splat_argument] = STATE(7437),
    [sym_block_argument] = STATE(7437),
    [sym_assignment] = STATE(937),
    [sym_operator_assignment] = STATE(937),
    [sym_conditional] = STATE(937),
    [sym_range] = STATE(937),
    [sym_binary] = STATE(937),
    [sym_unary] = STATE(937),
    [sym_left_assignment_list] = STATE(427),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(428),
    [sym__variable] = STATE(422),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(428),
    [sym_false] = STATE(428),
    [sym_nil] = STATE(428),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(942),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(7437),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(1663),
    [sym__splat_star] = ACTIONS(1665),
    [sym__unary_minus] = ACTIONS(765),
    [sym__identifier_hash_key] = ACTIONS(1667),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(7910),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(781),
    [anon_sym_yield] = ACTIONS(783),
    [anon_sym_break] = ACTIONS(785),
    [anon_sym_next] = ACTIONS(787),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(2623),
    [anon_sym_defined_QMARK] = ACTIONS(801),
    [anon_sym_not] = ACTIONS(803),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_TILDE] = ACTIONS(807),
    [sym_constant] = ACTIONS(1675),
    [sym_identifier] = ACTIONS(1675),
    [sym_instance_variable] = ACTIONS(811),
    [sym_class_variable] = ACTIONS(811),
    [sym_global_variable] = ACTIONS(811),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(815),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(815),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [4981] = {
    [sym_heredoc_body] = STATE(4978),
    [aux_sym_call_repeat1] = STATE(4978),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [ts_builtin_sym_end] = ACTIONS(7929),
    [anon_sym___END__] = ACTIONS(7929),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7931),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_EQ] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_EQ_GT] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_PLUS_EQ] = ACTIONS(7929),
    [anon_sym_DASH_EQ] = ACTIONS(7929),
    [anon_sym_STAR_EQ] = ACTIONS(7929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7929),
    [anon_sym_SLASH_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7929),
    [anon_sym_AMP_EQ] = ACTIONS(7929),
    [anon_sym_PERCENT_EQ] = ACTIONS(7929),
    [anon_sym_GT_GT_EQ] = ACTIONS(7929),
    [anon_sym_LT_LT_EQ] = ACTIONS(7929),
    [anon_sym_CARET_EQ] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7931),
    [anon_sym_AMP_AMP] = ACTIONS(7931),
    [anon_sym_LT_LT] = ACTIONS(7931),
    [anon_sym_GT_GT] = ACTIONS(7931),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7931),
    [anon_sym_PLUS] = ACTIONS(7931),
    [anon_sym_SLASH] = ACTIONS(7931),
    [anon_sym_PERCENT] = ACTIONS(7931),
    [sym_comment] = ACTIONS(87),
  },
  [4982] = {
    [aux_sym_argument_list_repeat1] = STATE(4982),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [ts_builtin_sym_end] = ACTIONS(7925),
    [anon_sym___END__] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(10981),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7927),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_EQ] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_if] = ACTIONS(7925),
    [anon_sym_unless] = ACTIONS(7925),
    [anon_sym_while] = ACTIONS(7925),
    [anon_sym_until] = ACTIONS(7925),
    [anon_sym_rescue] = ACTIONS(7925),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_EQ_GT] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_PLUS_EQ] = ACTIONS(7925),
    [anon_sym_DASH_EQ] = ACTIONS(7925),
    [anon_sym_STAR_EQ] = ACTIONS(7925),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7925),
    [anon_sym_SLASH_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7925),
    [anon_sym_AMP_EQ] = ACTIONS(7925),
    [anon_sym_PERCENT_EQ] = ACTIONS(7925),
    [anon_sym_GT_GT_EQ] = ACTIONS(7925),
    [anon_sym_LT_LT_EQ] = ACTIONS(7925),
    [anon_sym_CARET_EQ] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7927),
    [anon_sym_AMP_AMP] = ACTIONS(7927),
    [anon_sym_LT_LT] = ACTIONS(7927),
    [anon_sym_GT_GT] = ACTIONS(7927),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7927),
    [anon_sym_PLUS] = ACTIONS(7927),
    [anon_sym_SLASH] = ACTIONS(7927),
    [anon_sym_PERCENT] = ACTIONS(7927),
    [sym_comment] = ACTIONS(87),
  },
  [4983] = {
    [sym__line_break] = ACTIONS(6813),
    [sym__heredoc_body_start] = ACTIONS(6813),
    [sym__binary_minus] = ACTIONS(6813),
    [sym__binary_star] = ACTIONS(6813),
    [ts_builtin_sym_end] = ACTIONS(6813),
    [anon_sym___END__] = ACTIONS(6813),
    [anon_sym_LBRACE] = ACTIONS(6813),
    [anon_sym_RBRACE] = ACTIONS(6813),
    [anon_sym_RPAREN] = ACTIONS(6813),
    [anon_sym_DOT] = ACTIONS(8689),
    [anon_sym_COMMA] = ACTIONS(6813),
    [anon_sym_PIPE] = ACTIONS(8689),
    [anon_sym_SEMI] = ACTIONS(6813),
    [anon_sym_STAR_STAR] = ACTIONS(6813),
    [anon_sym_AMP] = ACTIONS(8689),
    [anon_sym_LT] = ACTIONS(8689),
    [anon_sym_end] = ACTIONS(6813),
    [anon_sym_if] = ACTIONS(6813),
    [anon_sym_unless] = ACTIONS(6813),
    [anon_sym_while] = ACTIONS(6813),
    [anon_sym_until] = ACTIONS(6813),
    [anon_sym_rescue] = ACTIONS(6813),
    [anon_sym_do] = ACTIONS(6813),
    [anon_sym_when] = ACTIONS(6813),
    [anon_sym_elsif] = ACTIONS(6813),
    [anon_sym_else] = ACTIONS(6813),
    [anon_sym_then] = ACTIONS(6813),
    [anon_sym_ensure] = ACTIONS(6813),
    [anon_sym_EQ_GT] = ACTIONS(6813),
    [anon_sym_LBRACK] = ACTIONS(6813),
    [anon_sym_COLON_COLON2] = ACTIONS(6813),
    [anon_sym_AMP_DOT] = ACTIONS(6813),
    [anon_sym_QMARK] = ACTIONS(6813),
    [anon_sym_DOT_DOT] = ACTIONS(8689),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6813),
    [anon_sym_and] = ACTIONS(6813),
    [anon_sym_or] = ACTIONS(6813),
    [anon_sym_PIPE_PIPE] = ACTIONS(6813),
    [anon_sym_AMP_AMP] = ACTIONS(6813),
    [anon_sym_LT_LT] = ACTIONS(6813),
    [anon_sym_GT_GT] = ACTIONS(6813),
    [anon_sym_EQ_EQ] = ACTIONS(8689),
    [anon_sym_BANG_EQ] = ACTIONS(6813),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6813),
    [anon_sym_LT_EQ_GT] = ACTIONS(6813),
    [anon_sym_EQ_TILDE] = ACTIONS(6813),
    [anon_sym_BANG_TILDE] = ACTIONS(6813),
    [anon_sym_LT_EQ] = ACTIONS(8689),
    [anon_sym_GT] = ACTIONS(8689),
    [anon_sym_GT_EQ] = ACTIONS(6813),
    [anon_sym_CARET] = ACTIONS(6813),
    [anon_sym_PLUS] = ACTIONS(6813),
    [anon_sym_SLASH] = ACTIONS(6813),
    [anon_sym_PERCENT] = ACTIONS(6813),
    [sym_comment] = ACTIONS(87),
  },
  [4984] = {
    [sym__simple_symbol] = ACTIONS(3235),
    [sym__string_start] = ACTIONS(3235),
    [sym__symbol_start] = ACTIONS(3235),
    [sym__subshell_start] = ACTIONS(3235),
    [sym__regex_start] = ACTIONS(3235),
    [sym__string_array_start] = ACTIONS(3235),
    [sym__symbol_array_start] = ACTIONS(3235),
    [sym_heredoc_beginning] = ACTIONS(3235),
    [sym__block_ampersand] = ACTIONS(3235),
    [sym__splat_star] = ACTIONS(3235),
    [sym__unary_minus] = ACTIONS(3235),
    [sym__identifier_hash_key] = ACTIONS(3235),
    [anon_sym_LBRACE] = ACTIONS(3235),
    [anon_sym_def] = ACTIONS(4997),
    [anon_sym_LPAREN] = ACTIONS(3235),
    [anon_sym_RPAREN] = ACTIONS(3235),
    [anon_sym_COLON_COLON] = ACTIONS(3235),
    [anon_sym_STAR] = ACTIONS(4997),
    [anon_sym_STAR_STAR] = ACTIONS(3235),
    [anon_sym_class] = ACTIONS(4997),
    [anon_sym_module] = ACTIONS(4997),
    [anon_sym_return] = ACTIONS(4997),
    [anon_sym_yield] = ACTIONS(4997),
    [anon_sym_break] = ACTIONS(4997),
    [anon_sym_next] = ACTIONS(4997),
    [sym_redo] = ACTIONS(4997),
    [sym_retry] = ACTIONS(4997),
    [anon_sym_if] = ACTIONS(4997),
    [anon_sym_unless] = ACTIONS(4997),
    [anon_sym_while] = ACTIONS(4997),
    [anon_sym_until] = ACTIONS(4997),
    [anon_sym_for] = ACTIONS(4997),
    [anon_sym_case] = ACTIONS(4997),
    [anon_sym_begin] = ACTIONS(4997),
    [anon_sym_RBRACK] = ACTIONS(3235),
    [anon_sym_PLUS] = ACTIONS(4997),
    [anon_sym_defined_QMARK] = ACTIONS(3235),
    [anon_sym_not] = ACTIONS(4997),
    [anon_sym_BANG] = ACTIONS(3235),
    [anon_sym_TILDE] = ACTIONS(3235),
    [sym_constant] = ACTIONS(4997),
    [sym_identifier] = ACTIONS(4997),
    [sym_instance_variable] = ACTIONS(3235),
    [sym_class_variable] = ACTIONS(3235),
    [sym_global_variable] = ACTIONS(3235),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4997),
    [sym_float] = ACTIONS(4997),
    [sym_complex] = ACTIONS(3235),
    [sym_super] = ACTIONS(4997),
    [anon_sym_true] = ACTIONS(4997),
    [anon_sym_TRUE] = ACTIONS(4997),
    [anon_sym_false] = ACTIONS(4997),
    [anon_sym_FALSE] = ACTIONS(4997),
    [sym_self] = ACTIONS(4997),
    [anon_sym_nil] = ACTIONS(4997),
    [anon_sym_NIL] = ACTIONS(4997),
    [sym_character] = ACTIONS(3235),
    [anon_sym_LBRACK2] = ACTIONS(3235),
    [anon_sym_DASH_GT] = ACTIONS(3235),
  },
  [4985] = {
    [sym_interpolation] = STATE(1787),
    [aux_sym_heredoc_body_repeat1] = STATE(1787),
    [sym__heredoc_content] = ACTIONS(3237),
    [sym_heredoc_end] = ACTIONS(10984),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(3237),
  },
  [4986] = {
    [sym__line_break] = ACTIONS(10986),
    [sym__heredoc_body_start] = ACTIONS(10986),
    [sym__binary_minus] = ACTIONS(10986),
    [sym__binary_star] = ACTIONS(10986),
    [ts_builtin_sym_end] = ACTIONS(10986),
    [anon_sym___END__] = ACTIONS(10986),
    [anon_sym_LBRACE] = ACTIONS(10986),
    [anon_sym_RBRACE] = ACTIONS(10986),
    [anon_sym_RPAREN] = ACTIONS(10986),
    [anon_sym_DOT] = ACTIONS(10988),
    [anon_sym_COMMA] = ACTIONS(10986),
    [anon_sym_PIPE] = ACTIONS(10988),
    [anon_sym_SEMI] = ACTIONS(10986),
    [anon_sym_STAR_STAR] = ACTIONS(10986),
    [anon_sym_AMP] = ACTIONS(10988),
    [anon_sym_LT] = ACTIONS(10988),
    [anon_sym_end] = ACTIONS(10986),
    [anon_sym_if] = ACTIONS(10986),
    [anon_sym_unless] = ACTIONS(10986),
    [anon_sym_while] = ACTIONS(10986),
    [anon_sym_until] = ACTIONS(10986),
    [anon_sym_rescue] = ACTIONS(10986),
    [anon_sym_do] = ACTIONS(10986),
    [anon_sym_when] = ACTIONS(10986),
    [anon_sym_elsif] = ACTIONS(10986),
    [anon_sym_else] = ACTIONS(10986),
    [anon_sym_then] = ACTIONS(10986),
    [anon_sym_ensure] = ACTIONS(10986),
    [anon_sym_EQ_GT] = ACTIONS(10986),
    [anon_sym_LBRACK] = ACTIONS(10986),
    [anon_sym_COLON_COLON2] = ACTIONS(10986),
    [anon_sym_AMP_DOT] = ACTIONS(10986),
    [anon_sym_QMARK] = ACTIONS(10986),
    [anon_sym_DOT_DOT] = ACTIONS(10988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10986),
    [anon_sym_and] = ACTIONS(10986),
    [anon_sym_or] = ACTIONS(10986),
    [anon_sym_PIPE_PIPE] = ACTIONS(10986),
    [anon_sym_AMP_AMP] = ACTIONS(10986),
    [anon_sym_LT_LT] = ACTIONS(10986),
    [anon_sym_GT_GT] = ACTIONS(10986),
    [anon_sym_EQ_EQ] = ACTIONS(10988),
    [anon_sym_BANG_EQ] = ACTIONS(10986),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10986),
    [anon_sym_LT_EQ_GT] = ACTIONS(10986),
    [anon_sym_EQ_TILDE] = ACTIONS(10986),
    [anon_sym_BANG_TILDE] = ACTIONS(10986),
    [anon_sym_LT_EQ] = ACTIONS(10988),
    [anon_sym_GT] = ACTIONS(10988),
    [anon_sym_GT_EQ] = ACTIONS(10986),
    [anon_sym_CARET] = ACTIONS(10986),
    [anon_sym_PLUS] = ACTIONS(10986),
    [anon_sym_SLASH] = ACTIONS(10986),
    [anon_sym_PERCENT] = ACTIONS(10986),
    [sym_comment] = ACTIONS(87),
  },
  [4987] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2569),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_splat_argument] = STATE(7439),
    [sym_assignment] = STATE(2569),
    [sym_operator_assignment] = STATE(2569),
    [sym_conditional] = STATE(2569),
    [sym_range] = STATE(2569),
    [sym_binary] = STATE(2569),
    [sym_unary] = STATE(2569),
    [sym__arg_or_splat_arg] = STATE(7439),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(880),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__splat_star] = ACTIONS(1583),
    [sym__unary_minus] = ACTIONS(373),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(383),
    [anon_sym_yield] = ACTIONS(385),
    [anon_sym_break] = ACTIONS(387),
    [anon_sym_next] = ACTIONS(389),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1575),
    [anon_sym_defined_QMARK] = ACTIONS(395),
    [anon_sym_not] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_TILDE] = ACTIONS(401),
    [sym_constant] = ACTIONS(407),
    [sym_identifier] = ACTIONS(407),
    [sym_instance_variable] = ACTIONS(405),
    [sym_class_variable] = ACTIONS(405),
    [sym_global_variable] = ACTIONS(405),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(407),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(407),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4988] = {
    [aux_sym_exceptions_repeat1] = STATE(7440),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [ts_builtin_sym_end] = ACTIONS(9855),
    [anon_sym___END__] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(10990),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_EQ_GT] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [4989] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(7942),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [4990] = {
    [sym_heredoc_body] = STATE(7441),
    [aux_sym_call_repeat1] = STATE(7441),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_then] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [4991] = {
    [sym_heredoc_body] = STATE(7441),
    [aux_sym_call_repeat1] = STATE(7441),
    [aux_sym_argument_list_repeat1] = STATE(7442),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(4457),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_then] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [4992] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(7940),
    [sym__binary_star] = ACTIONS(7942),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(7944),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(7942),
    [anon_sym_AMP] = ACTIONS(7946),
    [anon_sym_LT] = ACTIONS(7948),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(7950),
    [anon_sym_DOT_DOT] = ACTIONS(7952),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7954),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(7956),
    [anon_sym_AMP_AMP] = ACTIONS(7956),
    [anon_sym_LT_LT] = ACTIONS(7958),
    [anon_sym_GT_GT] = ACTIONS(7958),
    [anon_sym_EQ_EQ] = ACTIONS(7960),
    [anon_sym_BANG_EQ] = ACTIONS(7956),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7956),
    [anon_sym_LT_EQ_GT] = ACTIONS(7956),
    [anon_sym_EQ_TILDE] = ACTIONS(7956),
    [anon_sym_BANG_TILDE] = ACTIONS(7956),
    [anon_sym_LT_EQ] = ACTIONS(7948),
    [anon_sym_GT] = ACTIONS(7948),
    [anon_sym_GT_EQ] = ACTIONS(7962),
    [anon_sym_CARET] = ACTIONS(7964),
    [anon_sym_PLUS] = ACTIONS(7940),
    [anon_sym_SLASH] = ACTIONS(7942),
    [anon_sym_PERCENT] = ACTIONS(7942),
    [sym_comment] = ACTIONS(87),
  },
  [4993] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7443),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2583),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2583),
    [sym_assignment] = STATE(7443),
    [sym_operator_assignment] = STATE(7443),
    [sym_conditional] = STATE(7443),
    [sym_range] = STATE(7443),
    [sym_binary] = STATE(7443),
    [sym_unary] = STATE(7443),
    [sym_left_assignment_list] = STATE(2582),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2583),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2583),
    [sym_false] = STATE(2583),
    [sym_nil] = STATE(2583),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2584),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4391),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4393),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_break] = ACTIONS(4397),
    [anon_sym_next] = ACTIONS(4399),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4401),
    [anon_sym_defined_QMARK] = ACTIONS(4403),
    [anon_sym_not] = ACTIONS(4405),
    [anon_sym_BANG] = ACTIONS(4407),
    [anon_sym_TILDE] = ACTIONS(4407),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4994] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7444),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2583),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2583),
    [sym_assignment] = STATE(7444),
    [sym_operator_assignment] = STATE(7444),
    [sym_conditional] = STATE(7444),
    [sym_range] = STATE(7444),
    [sym_binary] = STATE(7444),
    [sym_unary] = STATE(7444),
    [sym_left_assignment_list] = STATE(2582),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2583),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2583),
    [sym_false] = STATE(2583),
    [sym_nil] = STATE(2583),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2584),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4391),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4393),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_break] = ACTIONS(4397),
    [anon_sym_next] = ACTIONS(4399),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4401),
    [anon_sym_defined_QMARK] = ACTIONS(4403),
    [anon_sym_not] = ACTIONS(4405),
    [anon_sym_BANG] = ACTIONS(4407),
    [anon_sym_TILDE] = ACTIONS(4407),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4995] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7445),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2583),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2583),
    [sym_assignment] = STATE(7445),
    [sym_operator_assignment] = STATE(7445),
    [sym_conditional] = STATE(7445),
    [sym_range] = STATE(7445),
    [sym_binary] = STATE(7445),
    [sym_unary] = STATE(7445),
    [sym_left_assignment_list] = STATE(2582),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2583),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2583),
    [sym_false] = STATE(2583),
    [sym_nil] = STATE(2583),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2584),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4391),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4393),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_break] = ACTIONS(4397),
    [anon_sym_next] = ACTIONS(4399),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4401),
    [anon_sym_defined_QMARK] = ACTIONS(4403),
    [anon_sym_not] = ACTIONS(4405),
    [anon_sym_BANG] = ACTIONS(4407),
    [anon_sym_TILDE] = ACTIONS(4407),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4996] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7446),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2583),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2583),
    [sym_assignment] = STATE(7446),
    [sym_operator_assignment] = STATE(7446),
    [sym_conditional] = STATE(7446),
    [sym_range] = STATE(7446),
    [sym_binary] = STATE(7446),
    [sym_unary] = STATE(7446),
    [sym_left_assignment_list] = STATE(2582),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2583),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2583),
    [sym_false] = STATE(2583),
    [sym_nil] = STATE(2583),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2584),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4391),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4393),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_break] = ACTIONS(4397),
    [anon_sym_next] = ACTIONS(4399),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4401),
    [anon_sym_defined_QMARK] = ACTIONS(4403),
    [anon_sym_not] = ACTIONS(4405),
    [anon_sym_BANG] = ACTIONS(4407),
    [anon_sym_TILDE] = ACTIONS(4407),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4997] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7447),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2583),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2583),
    [sym_assignment] = STATE(7447),
    [sym_operator_assignment] = STATE(7447),
    [sym_conditional] = STATE(7447),
    [sym_range] = STATE(7447),
    [sym_binary] = STATE(7447),
    [sym_unary] = STATE(7447),
    [sym_left_assignment_list] = STATE(2582),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2583),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2583),
    [sym_false] = STATE(2583),
    [sym_nil] = STATE(2583),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2584),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4391),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4393),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_break] = ACTIONS(4397),
    [anon_sym_next] = ACTIONS(4399),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4401),
    [anon_sym_defined_QMARK] = ACTIONS(4403),
    [anon_sym_not] = ACTIONS(4405),
    [anon_sym_BANG] = ACTIONS(4407),
    [anon_sym_TILDE] = ACTIONS(4407),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4998] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(7448),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(7448),
    [sym_operator_assignment] = STATE(7448),
    [sym_conditional] = STATE(7448),
    [sym_range] = STATE(7448),
    [sym_binary] = STATE(7448),
    [sym_unary] = STATE(7448),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4999] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7449),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2583),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2583),
    [sym_assignment] = STATE(7449),
    [sym_operator_assignment] = STATE(7449),
    [sym_conditional] = STATE(7449),
    [sym_range] = STATE(7449),
    [sym_binary] = STATE(7449),
    [sym_unary] = STATE(7449),
    [sym_left_assignment_list] = STATE(2582),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2583),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2583),
    [sym_false] = STATE(2583),
    [sym_nil] = STATE(2583),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2584),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4391),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4393),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_break] = ACTIONS(4397),
    [anon_sym_next] = ACTIONS(4399),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4401),
    [anon_sym_defined_QMARK] = ACTIONS(4403),
    [anon_sym_not] = ACTIONS(4405),
    [anon_sym_BANG] = ACTIONS(4407),
    [anon_sym_TILDE] = ACTIONS(4407),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5000] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7450),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2583),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2583),
    [sym_assignment] = STATE(7450),
    [sym_operator_assignment] = STATE(7450),
    [sym_conditional] = STATE(7450),
    [sym_range] = STATE(7450),
    [sym_binary] = STATE(7450),
    [sym_unary] = STATE(7450),
    [sym_left_assignment_list] = STATE(2582),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2583),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2583),
    [sym_false] = STATE(2583),
    [sym_nil] = STATE(2583),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2584),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4391),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4393),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_break] = ACTIONS(4397),
    [anon_sym_next] = ACTIONS(4399),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4401),
    [anon_sym_defined_QMARK] = ACTIONS(4403),
    [anon_sym_not] = ACTIONS(4405),
    [anon_sym_BANG] = ACTIONS(4407),
    [anon_sym_TILDE] = ACTIONS(4407),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5001] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7451),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2583),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2583),
    [sym_assignment] = STATE(7451),
    [sym_operator_assignment] = STATE(7451),
    [sym_conditional] = STATE(7451),
    [sym_range] = STATE(7451),
    [sym_binary] = STATE(7451),
    [sym_unary] = STATE(7451),
    [sym_left_assignment_list] = STATE(2582),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2583),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2583),
    [sym_false] = STATE(2583),
    [sym_nil] = STATE(2583),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2584),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4391),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4393),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_break] = ACTIONS(4397),
    [anon_sym_next] = ACTIONS(4399),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4401),
    [anon_sym_defined_QMARK] = ACTIONS(4403),
    [anon_sym_not] = ACTIONS(4405),
    [anon_sym_BANG] = ACTIONS(4407),
    [anon_sym_TILDE] = ACTIONS(4407),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5002] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7452),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2583),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2583),
    [sym_assignment] = STATE(7452),
    [sym_operator_assignment] = STATE(7452),
    [sym_conditional] = STATE(7452),
    [sym_range] = STATE(7452),
    [sym_binary] = STATE(7452),
    [sym_unary] = STATE(7452),
    [sym_left_assignment_list] = STATE(2582),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2583),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2583),
    [sym_false] = STATE(2583),
    [sym_nil] = STATE(2583),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2584),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4391),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4393),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_break] = ACTIONS(4397),
    [anon_sym_next] = ACTIONS(4399),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4401),
    [anon_sym_defined_QMARK] = ACTIONS(4403),
    [anon_sym_not] = ACTIONS(4405),
    [anon_sym_BANG] = ACTIONS(4407),
    [anon_sym_TILDE] = ACTIONS(4407),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5003] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7453),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2583),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2583),
    [sym_splat_argument] = STATE(7454),
    [sym_assignment] = STATE(7453),
    [sym_operator_assignment] = STATE(7453),
    [sym_conditional] = STATE(7453),
    [sym_range] = STATE(7453),
    [sym_binary] = STATE(7453),
    [sym_unary] = STATE(7453),
    [sym_right_assignment_list] = STATE(2570),
    [sym__arg_or_splat_arg] = STATE(7454),
    [sym_left_assignment_list] = STATE(2582),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2583),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2583),
    [sym_false] = STATE(2583),
    [sym_nil] = STATE(2583),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2584),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(1711),
    [sym__unary_minus] = ACTIONS(4391),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4393),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_break] = ACTIONS(4397),
    [anon_sym_next] = ACTIONS(4399),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4401),
    [anon_sym_defined_QMARK] = ACTIONS(4403),
    [anon_sym_not] = ACTIONS(4405),
    [anon_sym_BANG] = ACTIONS(4407),
    [anon_sym_TILDE] = ACTIONS(4407),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5004] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7455),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2583),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2583),
    [sym_assignment] = STATE(7455),
    [sym_operator_assignment] = STATE(7455),
    [sym_conditional] = STATE(7455),
    [sym_range] = STATE(7455),
    [sym_binary] = STATE(7455),
    [sym_unary] = STATE(7455),
    [sym_left_assignment_list] = STATE(2582),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2583),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2583),
    [sym_false] = STATE(2583),
    [sym_nil] = STATE(2583),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2584),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4391),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4393),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_break] = ACTIONS(4397),
    [anon_sym_next] = ACTIONS(4399),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4401),
    [anon_sym_defined_QMARK] = ACTIONS(4403),
    [anon_sym_not] = ACTIONS(4405),
    [anon_sym_BANG] = ACTIONS(4407),
    [anon_sym_TILDE] = ACTIONS(4407),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5005] = {
    [sym_string] = STATE(7456),
    [aux_sym_chained_string_repeat1] = STATE(7456),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_then] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [5006] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(7940),
    [sym__binary_star] = ACTIONS(7942),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(7944),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(7942),
    [anon_sym_AMP] = ACTIONS(7946),
    [anon_sym_LT] = ACTIONS(7948),
    [anon_sym_if] = ACTIONS(6823),
    [anon_sym_unless] = ACTIONS(6823),
    [anon_sym_while] = ACTIONS(6823),
    [anon_sym_until] = ACTIONS(6823),
    [anon_sym_rescue] = ACTIONS(6823),
    [anon_sym_then] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(7950),
    [anon_sym_DOT_DOT] = ACTIONS(7952),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7954),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(7956),
    [anon_sym_AMP_AMP] = ACTIONS(7956),
    [anon_sym_LT_LT] = ACTIONS(7958),
    [anon_sym_GT_GT] = ACTIONS(7958),
    [anon_sym_EQ_EQ] = ACTIONS(7960),
    [anon_sym_BANG_EQ] = ACTIONS(7956),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7956),
    [anon_sym_LT_EQ_GT] = ACTIONS(7956),
    [anon_sym_EQ_TILDE] = ACTIONS(7956),
    [anon_sym_BANG_TILDE] = ACTIONS(7956),
    [anon_sym_LT_EQ] = ACTIONS(7948),
    [anon_sym_GT] = ACTIONS(7948),
    [anon_sym_GT_EQ] = ACTIONS(7962),
    [anon_sym_CARET] = ACTIONS(7964),
    [anon_sym_PLUS] = ACTIONS(7940),
    [anon_sym_SLASH] = ACTIONS(7942),
    [anon_sym_PERCENT] = ACTIONS(7942),
    [sym_comment] = ACTIONS(87),
  },
  [5007] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(4423),
    [sym__binary_star] = ACTIONS(4425),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(4427),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(4425),
    [anon_sym_AMP] = ACTIONS(4429),
    [anon_sym_LT] = ACTIONS(4431),
    [anon_sym_if] = ACTIONS(4211),
    [anon_sym_unless] = ACTIONS(4211),
    [anon_sym_while] = ACTIONS(4211),
    [anon_sym_until] = ACTIONS(4211),
    [anon_sym_rescue] = ACTIONS(4211),
    [anon_sym_then] = ACTIONS(4211),
    [anon_sym_EQ_GT] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(4433),
    [anon_sym_DOT_DOT] = ACTIONS(4435),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4437),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(4439),
    [anon_sym_AMP_AMP] = ACTIONS(4439),
    [anon_sym_LT_LT] = ACTIONS(4441),
    [anon_sym_GT_GT] = ACTIONS(4441),
    [anon_sym_EQ_EQ] = ACTIONS(4443),
    [anon_sym_BANG_EQ] = ACTIONS(4439),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4439),
    [anon_sym_LT_EQ_GT] = ACTIONS(4439),
    [anon_sym_EQ_TILDE] = ACTIONS(4439),
    [anon_sym_BANG_TILDE] = ACTIONS(4439),
    [anon_sym_LT_EQ] = ACTIONS(4431),
    [anon_sym_GT] = ACTIONS(4431),
    [anon_sym_GT_EQ] = ACTIONS(4445),
    [anon_sym_CARET] = ACTIONS(4447),
    [anon_sym_PLUS] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(4425),
    [anon_sym_PERCENT] = ACTIONS(4425),
    [sym_comment] = ACTIONS(87),
  },
  [5008] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(4423),
    [sym__binary_star] = ACTIONS(4425),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(4427),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(4425),
    [anon_sym_AMP] = ACTIONS(4429),
    [anon_sym_LT] = ACTIONS(4431),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_then] = ACTIONS(4247),
    [anon_sym_EQ_GT] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(4433),
    [anon_sym_DOT_DOT] = ACTIONS(4435),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4437),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(4439),
    [anon_sym_AMP_AMP] = ACTIONS(4439),
    [anon_sym_LT_LT] = ACTIONS(4441),
    [anon_sym_GT_GT] = ACTIONS(4441),
    [anon_sym_EQ_EQ] = ACTIONS(4443),
    [anon_sym_BANG_EQ] = ACTIONS(4439),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4439),
    [anon_sym_LT_EQ_GT] = ACTIONS(4439),
    [anon_sym_EQ_TILDE] = ACTIONS(4439),
    [anon_sym_BANG_TILDE] = ACTIONS(4439),
    [anon_sym_LT_EQ] = ACTIONS(4431),
    [anon_sym_GT] = ACTIONS(4431),
    [anon_sym_GT_EQ] = ACTIONS(4445),
    [anon_sym_CARET] = ACTIONS(4447),
    [anon_sym_PLUS] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(4425),
    [anon_sym_PERCENT] = ACTIONS(4425),
    [sym_comment] = ACTIONS(87),
  },
  [5009] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7457),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_assignment] = STATE(7457),
    [sym_operator_assignment] = STATE(7457),
    [sym_conditional] = STATE(7457),
    [sym_range] = STATE(7457),
    [sym_binary] = STATE(7457),
    [sym_unary] = STATE(7457),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2587),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1713),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1717),
    [anon_sym_yield] = ACTIONS(1719),
    [anon_sym_break] = ACTIONS(1721),
    [anon_sym_next] = ACTIONS(1723),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4409),
    [anon_sym_defined_QMARK] = ACTIONS(1725),
    [anon_sym_not] = ACTIONS(1727),
    [anon_sym_BANG] = ACTIONS(1731),
    [anon_sym_TILDE] = ACTIONS(1731),
    [sym_constant] = ACTIONS(1737),
    [sym_identifier] = ACTIONS(1737),
    [sym_instance_variable] = ACTIONS(1735),
    [sym_class_variable] = ACTIONS(1735),
    [sym_global_variable] = ACTIONS(1735),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1737),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1737),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5010] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(4423),
    [sym__binary_star] = ACTIONS(4425),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(4427),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(4425),
    [anon_sym_AMP] = ACTIONS(4429),
    [anon_sym_LT] = ACTIONS(4431),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_unless] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_until] = ACTIONS(3281),
    [anon_sym_rescue] = ACTIONS(3281),
    [anon_sym_then] = ACTIONS(3281),
    [anon_sym_EQ_GT] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(4433),
    [anon_sym_DOT_DOT] = ACTIONS(4435),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4437),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(4439),
    [anon_sym_AMP_AMP] = ACTIONS(4439),
    [anon_sym_LT_LT] = ACTIONS(4441),
    [anon_sym_GT_GT] = ACTIONS(4441),
    [anon_sym_EQ_EQ] = ACTIONS(4443),
    [anon_sym_BANG_EQ] = ACTIONS(4439),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4439),
    [anon_sym_LT_EQ_GT] = ACTIONS(4439),
    [anon_sym_EQ_TILDE] = ACTIONS(4439),
    [anon_sym_BANG_TILDE] = ACTIONS(4439),
    [anon_sym_LT_EQ] = ACTIONS(4431),
    [anon_sym_GT] = ACTIONS(4431),
    [anon_sym_GT_EQ] = ACTIONS(4445),
    [anon_sym_CARET] = ACTIONS(4447),
    [anon_sym_PLUS] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(4425),
    [anon_sym_PERCENT] = ACTIONS(4425),
    [sym_comment] = ACTIONS(87),
  },
  [5011] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7458),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_assignment] = STATE(7458),
    [sym_operator_assignment] = STATE(7458),
    [sym_conditional] = STATE(7458),
    [sym_range] = STATE(7458),
    [sym_binary] = STATE(7458),
    [sym_unary] = STATE(7458),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2587),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1713),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1717),
    [anon_sym_yield] = ACTIONS(1719),
    [anon_sym_break] = ACTIONS(1721),
    [anon_sym_next] = ACTIONS(1723),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4409),
    [anon_sym_defined_QMARK] = ACTIONS(1725),
    [anon_sym_not] = ACTIONS(1727),
    [anon_sym_BANG] = ACTIONS(1731),
    [anon_sym_TILDE] = ACTIONS(1731),
    [sym_constant] = ACTIONS(1737),
    [sym_identifier] = ACTIONS(1737),
    [sym_instance_variable] = ACTIONS(1735),
    [sym_class_variable] = ACTIONS(1735),
    [sym_global_variable] = ACTIONS(1735),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1737),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1737),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5012] = {
    [sym_heredoc_body] = STATE(7459),
    [aux_sym_call_repeat1] = STATE(7459),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_then] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [5013] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2595),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym__argument] = STATE(2565),
    [sym_splat_argument] = STATE(2565),
    [sym_hash_splat_argument] = STATE(2565),
    [sym_block_argument] = STATE(2565),
    [sym_assignment] = STATE(2595),
    [sym_operator_assignment] = STATE(2595),
    [sym_conditional] = STATE(2595),
    [sym_range] = STATE(2595),
    [sym_binary] = STATE(2595),
    [sym_unary] = STATE(2595),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2598),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(7460),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2565),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(4413),
    [sym__splat_star] = ACTIONS(4415),
    [sym__unary_minus] = ACTIONS(1713),
    [sym__identifier_hash_key] = ACTIONS(4417),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10992),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1717),
    [anon_sym_yield] = ACTIONS(1719),
    [anon_sym_break] = ACTIONS(1721),
    [anon_sym_next] = ACTIONS(1723),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4409),
    [anon_sym_defined_QMARK] = ACTIONS(1725),
    [anon_sym_not] = ACTIONS(1727),
    [anon_sym_BANG] = ACTIONS(1731),
    [anon_sym_TILDE] = ACTIONS(1731),
    [sym_constant] = ACTIONS(4419),
    [sym_identifier] = ACTIONS(4419),
    [sym_instance_variable] = ACTIONS(1735),
    [sym_class_variable] = ACTIONS(1735),
    [sym_global_variable] = ACTIONS(1735),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1737),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1737),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5014] = {
    [sym_heredoc_body] = STATE(7461),
    [aux_sym_call_repeat1] = STATE(7461),
    [aux_sym_argument_list_repeat1] = STATE(7462),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(7976),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_then] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [5015] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(7940),
    [sym__binary_star] = ACTIONS(7942),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(7944),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(7942),
    [anon_sym_AMP] = ACTIONS(7946),
    [anon_sym_LT] = ACTIONS(7948),
    [anon_sym_if] = ACTIONS(7027),
    [anon_sym_unless] = ACTIONS(7027),
    [anon_sym_while] = ACTIONS(7027),
    [anon_sym_until] = ACTIONS(7027),
    [anon_sym_rescue] = ACTIONS(7027),
    [anon_sym_then] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(7950),
    [anon_sym_DOT_DOT] = ACTIONS(7952),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7954),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(7956),
    [anon_sym_AMP_AMP] = ACTIONS(7956),
    [anon_sym_LT_LT] = ACTIONS(7958),
    [anon_sym_GT_GT] = ACTIONS(7958),
    [anon_sym_EQ_EQ] = ACTIONS(7960),
    [anon_sym_BANG_EQ] = ACTIONS(7956),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7956),
    [anon_sym_LT_EQ_GT] = ACTIONS(7956),
    [anon_sym_EQ_TILDE] = ACTIONS(7956),
    [anon_sym_BANG_TILDE] = ACTIONS(7956),
    [anon_sym_LT_EQ] = ACTIONS(7948),
    [anon_sym_GT] = ACTIONS(7948),
    [anon_sym_GT_EQ] = ACTIONS(7962),
    [anon_sym_CARET] = ACTIONS(7964),
    [anon_sym_PLUS] = ACTIONS(7940),
    [anon_sym_SLASH] = ACTIONS(7942),
    [anon_sym_PERCENT] = ACTIONS(7942),
    [sym_comment] = ACTIONS(87),
  },
  [5016] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(4425),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(4425),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(4425),
    [anon_sym_PERCENT] = ACTIONS(4425),
    [sym_comment] = ACTIONS(87),
  },
  [5017] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(4425),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [5018] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4423),
    [sym__binary_star] = ACTIONS(4425),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(4425),
    [anon_sym_AMP] = ACTIONS(4429),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(4441),
    [anon_sym_GT_GT] = ACTIONS(4441),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(4425),
    [anon_sym_PERCENT] = ACTIONS(4425),
    [sym_comment] = ACTIONS(87),
  },
  [5019] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4423),
    [sym__binary_star] = ACTIONS(4425),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(4425),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(4441),
    [anon_sym_GT_GT] = ACTIONS(4441),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(4425),
    [anon_sym_PERCENT] = ACTIONS(4425),
    [sym_comment] = ACTIONS(87),
  },
  [5020] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4423),
    [sym__binary_star] = ACTIONS(4425),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(4427),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(4425),
    [anon_sym_AMP] = ACTIONS(4429),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(4441),
    [anon_sym_GT_GT] = ACTIONS(4441),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(4447),
    [anon_sym_PLUS] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(4425),
    [anon_sym_PERCENT] = ACTIONS(4425),
    [sym_comment] = ACTIONS(87),
  },
  [5021] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(10994),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [5022] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(4423),
    [sym__binary_star] = ACTIONS(4425),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(4427),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(4425),
    [anon_sym_AMP] = ACTIONS(4429),
    [anon_sym_LT] = ACTIONS(4431),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_then] = ACTIONS(5927),
    [anon_sym_EQ_GT] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(4435),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4437),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(4439),
    [anon_sym_AMP_AMP] = ACTIONS(4439),
    [anon_sym_LT_LT] = ACTIONS(4441),
    [anon_sym_GT_GT] = ACTIONS(4441),
    [anon_sym_EQ_EQ] = ACTIONS(4443),
    [anon_sym_BANG_EQ] = ACTIONS(4439),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4439),
    [anon_sym_LT_EQ_GT] = ACTIONS(4439),
    [anon_sym_EQ_TILDE] = ACTIONS(4439),
    [anon_sym_BANG_TILDE] = ACTIONS(4439),
    [anon_sym_LT_EQ] = ACTIONS(4431),
    [anon_sym_GT] = ACTIONS(4431),
    [anon_sym_GT_EQ] = ACTIONS(4445),
    [anon_sym_CARET] = ACTIONS(4447),
    [anon_sym_PLUS] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(4425),
    [anon_sym_PERCENT] = ACTIONS(4425),
    [sym_comment] = ACTIONS(87),
  },
  [5023] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4423),
    [sym__binary_star] = ACTIONS(4425),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(4427),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(4425),
    [anon_sym_AMP] = ACTIONS(4429),
    [anon_sym_LT] = ACTIONS(4431),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(4433),
    [anon_sym_DOT_DOT] = ACTIONS(4435),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4437),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(4439),
    [anon_sym_AMP_AMP] = ACTIONS(4439),
    [anon_sym_LT_LT] = ACTIONS(4441),
    [anon_sym_GT_GT] = ACTIONS(4441),
    [anon_sym_EQ_EQ] = ACTIONS(4443),
    [anon_sym_BANG_EQ] = ACTIONS(4439),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4439),
    [anon_sym_LT_EQ_GT] = ACTIONS(4439),
    [anon_sym_EQ_TILDE] = ACTIONS(4439),
    [anon_sym_BANG_TILDE] = ACTIONS(4439),
    [anon_sym_LT_EQ] = ACTIONS(4431),
    [anon_sym_GT] = ACTIONS(4431),
    [anon_sym_GT_EQ] = ACTIONS(4445),
    [anon_sym_CARET] = ACTIONS(4447),
    [anon_sym_PLUS] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(4425),
    [anon_sym_PERCENT] = ACTIONS(4425),
    [sym_comment] = ACTIONS(87),
  },
  [5024] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4423),
    [sym__binary_star] = ACTIONS(4425),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(4427),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(4425),
    [anon_sym_AMP] = ACTIONS(4429),
    [anon_sym_LT] = ACTIONS(4431),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(4441),
    [anon_sym_GT_GT] = ACTIONS(4441),
    [anon_sym_EQ_EQ] = ACTIONS(4443),
    [anon_sym_BANG_EQ] = ACTIONS(4439),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4439),
    [anon_sym_LT_EQ_GT] = ACTIONS(4439),
    [anon_sym_EQ_TILDE] = ACTIONS(4439),
    [anon_sym_BANG_TILDE] = ACTIONS(4439),
    [anon_sym_LT_EQ] = ACTIONS(4431),
    [anon_sym_GT] = ACTIONS(4431),
    [anon_sym_GT_EQ] = ACTIONS(4445),
    [anon_sym_CARET] = ACTIONS(4447),
    [anon_sym_PLUS] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(4425),
    [anon_sym_PERCENT] = ACTIONS(4425),
    [sym_comment] = ACTIONS(87),
  },
  [5025] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4423),
    [sym__binary_star] = ACTIONS(4425),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(4425),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(4425),
    [anon_sym_PERCENT] = ACTIONS(4425),
    [sym_comment] = ACTIONS(87),
  },
  [5026] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(4533),
    [sym__binary_star] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(4537),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(4539),
    [anon_sym_AMP] = ACTIONS(4541),
    [anon_sym_EQ] = ACTIONS(4217),
    [anon_sym_LT] = ACTIONS(4543),
    [anon_sym_if] = ACTIONS(4211),
    [anon_sym_unless] = ACTIONS(4211),
    [anon_sym_while] = ACTIONS(4211),
    [anon_sym_until] = ACTIONS(4211),
    [anon_sym_rescue] = ACTIONS(4211),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_then] = ACTIONS(4211),
    [anon_sym_EQ_GT] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_PLUS_EQ] = ACTIONS(4211),
    [anon_sym_DASH_EQ] = ACTIONS(4211),
    [anon_sym_STAR_EQ] = ACTIONS(4211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4211),
    [anon_sym_SLASH_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4211),
    [anon_sym_AMP_EQ] = ACTIONS(4211),
    [anon_sym_PERCENT_EQ] = ACTIONS(4211),
    [anon_sym_GT_GT_EQ] = ACTIONS(4211),
    [anon_sym_LT_LT_EQ] = ACTIONS(4211),
    [anon_sym_CARET_EQ] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(4545),
    [anon_sym_DOT_DOT] = ACTIONS(4547),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4549),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(4551),
    [anon_sym_AMP_AMP] = ACTIONS(4551),
    [anon_sym_LT_LT] = ACTIONS(4553),
    [anon_sym_GT_GT] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4551),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4555),
    [anon_sym_LT_EQ_GT] = ACTIONS(4555),
    [anon_sym_EQ_TILDE] = ACTIONS(4555),
    [anon_sym_BANG_TILDE] = ACTIONS(4555),
    [anon_sym_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT] = ACTIONS(4543),
    [anon_sym_GT_EQ] = ACTIONS(4557),
    [anon_sym_CARET] = ACTIONS(4537),
    [anon_sym_PLUS] = ACTIONS(4559),
    [anon_sym_SLASH] = ACTIONS(4539),
    [anon_sym_PERCENT] = ACTIONS(4539),
    [sym_comment] = ACTIONS(87),
  },
  [5027] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(4533),
    [sym__binary_star] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(4537),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(4539),
    [anon_sym_AMP] = ACTIONS(4541),
    [anon_sym_EQ] = ACTIONS(4249),
    [anon_sym_LT] = ACTIONS(4543),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_then] = ACTIONS(4247),
    [anon_sym_EQ_GT] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_PLUS_EQ] = ACTIONS(4247),
    [anon_sym_DASH_EQ] = ACTIONS(4247),
    [anon_sym_STAR_EQ] = ACTIONS(4247),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4247),
    [anon_sym_SLASH_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4247),
    [anon_sym_AMP_EQ] = ACTIONS(4247),
    [anon_sym_PERCENT_EQ] = ACTIONS(4247),
    [anon_sym_GT_GT_EQ] = ACTIONS(4247),
    [anon_sym_LT_LT_EQ] = ACTIONS(4247),
    [anon_sym_CARET_EQ] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(4545),
    [anon_sym_DOT_DOT] = ACTIONS(4547),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4549),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(4551),
    [anon_sym_AMP_AMP] = ACTIONS(4551),
    [anon_sym_LT_LT] = ACTIONS(4553),
    [anon_sym_GT_GT] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4551),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4555),
    [anon_sym_LT_EQ_GT] = ACTIONS(4555),
    [anon_sym_EQ_TILDE] = ACTIONS(4555),
    [anon_sym_BANG_TILDE] = ACTIONS(4555),
    [anon_sym_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT] = ACTIONS(4543),
    [anon_sym_GT_EQ] = ACTIONS(4557),
    [anon_sym_CARET] = ACTIONS(4537),
    [anon_sym_PLUS] = ACTIONS(4559),
    [anon_sym_SLASH] = ACTIONS(4539),
    [anon_sym_PERCENT] = ACTIONS(4539),
    [sym_comment] = ACTIONS(87),
  },
  [5028] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(7464),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_assignment] = STATE(7464),
    [sym_operator_assignment] = STATE(7464),
    [sym_conditional] = STATE(7464),
    [sym_range] = STATE(7464),
    [sym_binary] = STATE(7464),
    [sym_unary] = STATE(7464),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2676),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1787),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1791),
    [anon_sym_yield] = ACTIONS(1793),
    [anon_sym_break] = ACTIONS(1795),
    [anon_sym_next] = ACTIONS(1797),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(4527),
    [anon_sym_defined_QMARK] = ACTIONS(1799),
    [anon_sym_not] = ACTIONS(1801),
    [anon_sym_BANG] = ACTIONS(1805),
    [anon_sym_TILDE] = ACTIONS(1805),
    [sym_constant] = ACTIONS(1811),
    [sym_identifier] = ACTIONS(1811),
    [sym_instance_variable] = ACTIONS(1809),
    [sym_class_variable] = ACTIONS(1809),
    [sym_global_variable] = ACTIONS(1809),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1811),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1811),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5029] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(4533),
    [sym__binary_star] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(4537),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(4539),
    [anon_sym_AMP] = ACTIONS(4541),
    [anon_sym_EQ] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(4543),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_unless] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_until] = ACTIONS(3281),
    [anon_sym_rescue] = ACTIONS(3281),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_then] = ACTIONS(3281),
    [anon_sym_EQ_GT] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_PLUS_EQ] = ACTIONS(3281),
    [anon_sym_DASH_EQ] = ACTIONS(3281),
    [anon_sym_STAR_EQ] = ACTIONS(3281),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3281),
    [anon_sym_SLASH_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3281),
    [anon_sym_AMP_EQ] = ACTIONS(3281),
    [anon_sym_PERCENT_EQ] = ACTIONS(3281),
    [anon_sym_GT_GT_EQ] = ACTIONS(3281),
    [anon_sym_LT_LT_EQ] = ACTIONS(3281),
    [anon_sym_CARET_EQ] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(4545),
    [anon_sym_DOT_DOT] = ACTIONS(4547),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4549),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(4551),
    [anon_sym_AMP_AMP] = ACTIONS(4551),
    [anon_sym_LT_LT] = ACTIONS(4553),
    [anon_sym_GT_GT] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4551),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4555),
    [anon_sym_LT_EQ_GT] = ACTIONS(4555),
    [anon_sym_EQ_TILDE] = ACTIONS(4555),
    [anon_sym_BANG_TILDE] = ACTIONS(4555),
    [anon_sym_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT] = ACTIONS(4543),
    [anon_sym_GT_EQ] = ACTIONS(4557),
    [anon_sym_CARET] = ACTIONS(4537),
    [anon_sym_PLUS] = ACTIONS(4559),
    [anon_sym_SLASH] = ACTIONS(4539),
    [anon_sym_PERCENT] = ACTIONS(4539),
    [sym_comment] = ACTIONS(87),
  },
  [5030] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(7465),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_assignment] = STATE(7465),
    [sym_operator_assignment] = STATE(7465),
    [sym_conditional] = STATE(7465),
    [sym_range] = STATE(7465),
    [sym_binary] = STATE(7465),
    [sym_unary] = STATE(7465),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2676),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1787),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1791),
    [anon_sym_yield] = ACTIONS(1793),
    [anon_sym_break] = ACTIONS(1795),
    [anon_sym_next] = ACTIONS(1797),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(4527),
    [anon_sym_defined_QMARK] = ACTIONS(1799),
    [anon_sym_not] = ACTIONS(1801),
    [anon_sym_BANG] = ACTIONS(1805),
    [anon_sym_TILDE] = ACTIONS(1805),
    [sym_constant] = ACTIONS(1811),
    [sym_identifier] = ACTIONS(1811),
    [sym_instance_variable] = ACTIONS(1809),
    [sym_class_variable] = ACTIONS(1809),
    [sym_global_variable] = ACTIONS(1809),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1811),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1811),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5031] = {
    [sym_heredoc_body] = STATE(7466),
    [aux_sym_call_repeat1] = STATE(7466),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_then] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [5032] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(2616),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym__argument] = STATE(4979),
    [sym_splat_argument] = STATE(4979),
    [sym_hash_splat_argument] = STATE(4979),
    [sym_block_argument] = STATE(4979),
    [sym_assignment] = STATE(2616),
    [sym_operator_assignment] = STATE(2616),
    [sym_conditional] = STATE(2616),
    [sym_range] = STATE(2616),
    [sym_binary] = STATE(2616),
    [sym_unary] = STATE(2616),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2619),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_heredoc_body] = STATE(7467),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(4979),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(4449),
    [sym__splat_star] = ACTIONS(4451),
    [sym__unary_minus] = ACTIONS(1787),
    [sym__identifier_hash_key] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10996),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1791),
    [anon_sym_yield] = ACTIONS(1793),
    [anon_sym_break] = ACTIONS(1795),
    [anon_sym_next] = ACTIONS(1797),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(4527),
    [anon_sym_defined_QMARK] = ACTIONS(1799),
    [anon_sym_not] = ACTIONS(1801),
    [anon_sym_BANG] = ACTIONS(1805),
    [anon_sym_TILDE] = ACTIONS(1805),
    [sym_constant] = ACTIONS(4455),
    [sym_identifier] = ACTIONS(4455),
    [sym_instance_variable] = ACTIONS(1809),
    [sym_class_variable] = ACTIONS(1809),
    [sym_global_variable] = ACTIONS(1809),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1811),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1811),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5033] = {
    [sym_heredoc_body] = STATE(7468),
    [aux_sym_call_repeat1] = STATE(7468),
    [aux_sym_argument_list_repeat1] = STATE(7469),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(7984),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_then] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [5034] = {
    [sym_heredoc_body] = STATE(5034),
    [aux_sym_call_repeat1] = STATE(5034),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(7916),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_then] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [5035] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(963),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym__argument] = STATE(4986),
    [sym_splat_argument] = STATE(4986),
    [sym_hash_splat_argument] = STATE(4986),
    [sym_block_argument] = STATE(4986),
    [sym_assignment] = STATE(963),
    [sym_operator_assignment] = STATE(963),
    [sym_conditional] = STATE(963),
    [sym_range] = STATE(963),
    [sym_binary] = STATE(963),
    [sym_unary] = STATE(963),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(969),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4986),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(1709),
    [sym__splat_star] = ACTIONS(1711),
    [sym__unary_minus] = ACTIONS(1713),
    [sym__identifier_hash_key] = ACTIONS(1715),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(7988),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1717),
    [anon_sym_yield] = ACTIONS(1719),
    [anon_sym_break] = ACTIONS(1721),
    [anon_sym_next] = ACTIONS(1723),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4409),
    [anon_sym_defined_QMARK] = ACTIONS(1725),
    [anon_sym_not] = ACTIONS(1727),
    [anon_sym_BANG] = ACTIONS(1731),
    [anon_sym_TILDE] = ACTIONS(1731),
    [sym_constant] = ACTIONS(1733),
    [sym_identifier] = ACTIONS(1733),
    [sym_instance_variable] = ACTIONS(1735),
    [sym_class_variable] = ACTIONS(1735),
    [sym_global_variable] = ACTIONS(1735),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1737),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1737),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5036] = {
    [sym_heredoc_body] = STATE(5034),
    [aux_sym_call_repeat1] = STATE(5034),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_then] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [5037] = {
    [aux_sym_argument_list_repeat1] = STATE(5037),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(10998),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7925),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_if] = ACTIONS(7925),
    [anon_sym_unless] = ACTIONS(7925),
    [anon_sym_while] = ACTIONS(7925),
    [anon_sym_until] = ACTIONS(7925),
    [anon_sym_rescue] = ACTIONS(7925),
    [anon_sym_then] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7925),
    [anon_sym_AMP_AMP] = ACTIONS(7925),
    [anon_sym_LT_LT] = ACTIONS(7925),
    [anon_sym_GT_GT] = ACTIONS(7925),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7925),
    [anon_sym_PLUS] = ACTIONS(7925),
    [anon_sym_SLASH] = ACTIONS(7925),
    [anon_sym_PERCENT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [5038] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(4423),
    [sym__binary_star] = ACTIONS(4425),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(4427),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(4425),
    [anon_sym_AMP] = ACTIONS(4429),
    [anon_sym_LT] = ACTIONS(4431),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_then] = ACTIONS(5115),
    [anon_sym_EQ_GT] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(4433),
    [anon_sym_DOT_DOT] = ACTIONS(4435),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4437),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(4439),
    [anon_sym_AMP_AMP] = ACTIONS(4439),
    [anon_sym_LT_LT] = ACTIONS(4441),
    [anon_sym_GT_GT] = ACTIONS(4441),
    [anon_sym_EQ_EQ] = ACTIONS(4443),
    [anon_sym_BANG_EQ] = ACTIONS(4439),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4439),
    [anon_sym_LT_EQ_GT] = ACTIONS(4439),
    [anon_sym_EQ_TILDE] = ACTIONS(4439),
    [anon_sym_BANG_TILDE] = ACTIONS(4439),
    [anon_sym_LT_EQ] = ACTIONS(4431),
    [anon_sym_GT] = ACTIONS(4431),
    [anon_sym_GT_EQ] = ACTIONS(4445),
    [anon_sym_CARET] = ACTIONS(4447),
    [anon_sym_PLUS] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(4425),
    [anon_sym_PERCENT] = ACTIONS(4425),
    [sym_comment] = ACTIONS(87),
  },
  [5039] = {
    [aux_sym_exceptions_repeat1] = STATE(7471),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_then] = ACTIONS(6191),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [5040] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(4423),
    [sym__binary_star] = ACTIONS(4425),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(4427),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(4425),
    [anon_sym_AMP] = ACTIONS(4429),
    [anon_sym_LT] = ACTIONS(4431),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_then] = ACTIONS(6210),
    [anon_sym_EQ_GT] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(4433),
    [anon_sym_DOT_DOT] = ACTIONS(4435),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4437),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(4439),
    [anon_sym_AMP_AMP] = ACTIONS(4439),
    [anon_sym_LT_LT] = ACTIONS(4441),
    [anon_sym_GT_GT] = ACTIONS(4441),
    [anon_sym_EQ_EQ] = ACTIONS(4443),
    [anon_sym_BANG_EQ] = ACTIONS(4439),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4439),
    [anon_sym_LT_EQ_GT] = ACTIONS(4439),
    [anon_sym_EQ_TILDE] = ACTIONS(4439),
    [anon_sym_BANG_TILDE] = ACTIONS(4439),
    [anon_sym_LT_EQ] = ACTIONS(4431),
    [anon_sym_GT] = ACTIONS(4431),
    [anon_sym_GT_EQ] = ACTIONS(4445),
    [anon_sym_CARET] = ACTIONS(4447),
    [anon_sym_PLUS] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(4425),
    [anon_sym_PERCENT] = ACTIONS(4425),
    [sym_comment] = ACTIONS(87),
  },
  [5041] = {
    [sym_string] = STATE(5041),
    [aux_sym_chained_string_repeat1] = STATE(5041),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(6214),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_then] = ACTIONS(6212),
    [anon_sym_EQ_GT] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [5042] = {
    [aux_sym_undef_repeat1] = STATE(5042),
    [sym__line_break] = ACTIONS(9263),
    [sym__heredoc_body_start] = ACTIONS(9263),
    [anon_sym_COMMA] = ACTIONS(9265),
    [anon_sym_SEMI] = ACTIONS(9263),
    [anon_sym_if] = ACTIONS(9263),
    [anon_sym_unless] = ACTIONS(9263),
    [anon_sym_while] = ACTIONS(9263),
    [anon_sym_until] = ACTIONS(9263),
    [anon_sym_rescue] = ACTIONS(9263),
    [anon_sym_then] = ACTIONS(9263),
    [sym_comment] = ACTIONS(87),
  },
  [5043] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8036),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_elsif] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [5044] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7479),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7481),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(7481),
    [sym_assignment] = STATE(7479),
    [sym_operator_assignment] = STATE(7479),
    [sym_conditional] = STATE(7479),
    [sym_range] = STATE(7479),
    [sym_binary] = STATE(7479),
    [sym_unary] = STATE(7479),
    [sym_left_assignment_list] = STATE(7480),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7481),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7481),
    [sym_false] = STATE(7481),
    [sym_nil] = STATE(7481),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7482),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11001),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11003),
    [anon_sym_yield] = ACTIONS(11005),
    [anon_sym_break] = ACTIONS(11007),
    [anon_sym_next] = ACTIONS(11009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11011),
    [anon_sym_defined_QMARK] = ACTIONS(11013),
    [anon_sym_not] = ACTIONS(11015),
    [anon_sym_BANG] = ACTIONS(11017),
    [anon_sym_TILDE] = ACTIONS(11017),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5045] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7483),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7481),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(7481),
    [sym_assignment] = STATE(7483),
    [sym_operator_assignment] = STATE(7483),
    [sym_conditional] = STATE(7483),
    [sym_range] = STATE(7483),
    [sym_binary] = STATE(7483),
    [sym_unary] = STATE(7483),
    [sym_left_assignment_list] = STATE(7480),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7481),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7481),
    [sym_false] = STATE(7481),
    [sym_nil] = STATE(7481),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7482),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11001),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11003),
    [anon_sym_yield] = ACTIONS(11005),
    [anon_sym_break] = ACTIONS(11007),
    [anon_sym_next] = ACTIONS(11009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11011),
    [anon_sym_defined_QMARK] = ACTIONS(11013),
    [anon_sym_not] = ACTIONS(11015),
    [anon_sym_BANG] = ACTIONS(11017),
    [anon_sym_TILDE] = ACTIONS(11017),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5046] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7484),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5061),
    [sym_scope_resolution] = STATE(5057),
    [sym_call] = STATE(5057),
    [sym_method_call] = STATE(5061),
    [sym_assignment] = STATE(7484),
    [sym_operator_assignment] = STATE(7484),
    [sym_conditional] = STATE(7484),
    [sym_range] = STATE(7484),
    [sym_binary] = STATE(7484),
    [sym_unary] = STATE(7484),
    [sym_left_assignment_list] = STATE(5060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5061),
    [sym__variable] = STATE(5057),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5061),
    [sym_false] = STATE(5061),
    [sym_nil] = STATE(5061),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7485),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(7994),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7998),
    [anon_sym_yield] = ACTIONS(8000),
    [anon_sym_break] = ACTIONS(8002),
    [anon_sym_next] = ACTIONS(8004),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11019),
    [anon_sym_defined_QMARK] = ACTIONS(8006),
    [anon_sym_not] = ACTIONS(8008),
    [anon_sym_BANG] = ACTIONS(8012),
    [anon_sym_TILDE] = ACTIONS(8012),
    [sym_constant] = ACTIONS(8018),
    [sym_identifier] = ACTIONS(8018),
    [sym_instance_variable] = ACTIONS(8016),
    [sym_class_variable] = ACTIONS(8016),
    [sym_global_variable] = ACTIONS(8016),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8018),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8018),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5047] = {
    [anon_sym_COLON] = ACTIONS(11021),
    [sym_comment] = ACTIONS(87),
  },
  [5048] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7487),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7481),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(7481),
    [sym_assignment] = STATE(7487),
    [sym_operator_assignment] = STATE(7487),
    [sym_conditional] = STATE(7487),
    [sym_range] = STATE(7487),
    [sym_binary] = STATE(7487),
    [sym_unary] = STATE(7487),
    [sym_left_assignment_list] = STATE(7480),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7481),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7481),
    [sym_false] = STATE(7481),
    [sym_nil] = STATE(7481),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7482),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11001),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11003),
    [anon_sym_yield] = ACTIONS(11005),
    [anon_sym_break] = ACTIONS(11007),
    [anon_sym_next] = ACTIONS(11009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11011),
    [anon_sym_defined_QMARK] = ACTIONS(11013),
    [anon_sym_not] = ACTIONS(11015),
    [anon_sym_BANG] = ACTIONS(11017),
    [anon_sym_TILDE] = ACTIONS(11017),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5049] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7493),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5061),
    [sym_scope_resolution] = STATE(5057),
    [sym_call] = STATE(5057),
    [sym_method_call] = STATE(5061),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(7494),
    [sym__argument] = STATE(7495),
    [sym_splat_argument] = STATE(7495),
    [sym_hash_splat_argument] = STATE(7495),
    [sym_block_argument] = STATE(7495),
    [sym_assignment] = STATE(7493),
    [sym_operator_assignment] = STATE(7493),
    [sym_conditional] = STATE(7493),
    [sym_range] = STATE(7493),
    [sym_binary] = STATE(7493),
    [sym_unary] = STATE(7493),
    [sym_left_assignment_list] = STATE(5060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5061),
    [sym__variable] = STATE(5057),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5061),
    [sym_false] = STATE(5061),
    [sym_nil] = STATE(5061),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7496),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(7495),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(11023),
    [sym__splat_star] = ACTIONS(11025),
    [sym__unary_minus] = ACTIONS(7994),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(11027),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(7998),
    [anon_sym_yield] = ACTIONS(8000),
    [anon_sym_break] = ACTIONS(8002),
    [anon_sym_next] = ACTIONS(8004),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(377),
    [anon_sym_else] = ACTIONS(377),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(8006),
    [anon_sym_not] = ACTIONS(8008),
    [anon_sym_BANG] = ACTIONS(8010),
    [anon_sym_TILDE] = ACTIONS(8012),
    [sym_constant] = ACTIONS(11029),
    [sym_identifier] = ACTIONS(11029),
    [sym_instance_variable] = ACTIONS(8016),
    [sym_class_variable] = ACTIONS(8016),
    [sym_global_variable] = ACTIONS(8016),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8018),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8018),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5050] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7493),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5061),
    [sym_scope_resolution] = STATE(5057),
    [sym_call] = STATE(5057),
    [sym_method_call] = STATE(5061),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(7494),
    [sym__argument] = STATE(7495),
    [sym_splat_argument] = STATE(7495),
    [sym_hash_splat_argument] = STATE(7495),
    [sym_block_argument] = STATE(7495),
    [sym_assignment] = STATE(7493),
    [sym_operator_assignment] = STATE(7493),
    [sym_conditional] = STATE(7493),
    [sym_range] = STATE(7493),
    [sym_binary] = STATE(7493),
    [sym_unary] = STATE(7493),
    [sym_left_assignment_list] = STATE(5060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5061),
    [sym__variable] = STATE(5057),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5061),
    [sym_false] = STATE(5061),
    [sym_nil] = STATE(5061),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7496),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(7495),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(11023),
    [sym__splat_star] = ACTIONS(11025),
    [sym__unary_minus] = ACTIONS(7994),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(11027),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(7998),
    [anon_sym_yield] = ACTIONS(8000),
    [anon_sym_break] = ACTIONS(8002),
    [anon_sym_next] = ACTIONS(8004),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(419),
    [anon_sym_else] = ACTIONS(419),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(8006),
    [anon_sym_not] = ACTIONS(8008),
    [anon_sym_BANG] = ACTIONS(8010),
    [anon_sym_TILDE] = ACTIONS(8012),
    [sym_constant] = ACTIONS(11029),
    [sym_identifier] = ACTIONS(11029),
    [sym_instance_variable] = ACTIONS(8016),
    [sym_class_variable] = ACTIONS(8016),
    [sym_global_variable] = ACTIONS(8016),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8018),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8018),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5051] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7493),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5061),
    [sym_scope_resolution] = STATE(5057),
    [sym_call] = STATE(5057),
    [sym_method_call] = STATE(5061),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(7494),
    [sym__argument] = STATE(7495),
    [sym_splat_argument] = STATE(7495),
    [sym_hash_splat_argument] = STATE(7495),
    [sym_block_argument] = STATE(7495),
    [sym_assignment] = STATE(7493),
    [sym_operator_assignment] = STATE(7493),
    [sym_conditional] = STATE(7493),
    [sym_range] = STATE(7493),
    [sym_binary] = STATE(7493),
    [sym_unary] = STATE(7493),
    [sym_left_assignment_list] = STATE(5060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5061),
    [sym__variable] = STATE(5057),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5061),
    [sym_false] = STATE(5061),
    [sym_nil] = STATE(5061),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7496),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(7495),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(11023),
    [sym__splat_star] = ACTIONS(11025),
    [sym__unary_minus] = ACTIONS(7994),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(11027),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(423),
    [anon_sym_return] = ACTIONS(7998),
    [anon_sym_yield] = ACTIONS(8000),
    [anon_sym_break] = ACTIONS(8002),
    [anon_sym_next] = ACTIONS(8004),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(423),
    [anon_sym_else] = ACTIONS(423),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(8006),
    [anon_sym_not] = ACTIONS(8008),
    [anon_sym_BANG] = ACTIONS(8010),
    [anon_sym_TILDE] = ACTIONS(8012),
    [sym_constant] = ACTIONS(11029),
    [sym_identifier] = ACTIONS(11029),
    [sym_instance_variable] = ACTIONS(8016),
    [sym_class_variable] = ACTIONS(8016),
    [sym_global_variable] = ACTIONS(8016),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8018),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8018),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5052] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7493),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5061),
    [sym_scope_resolution] = STATE(5057),
    [sym_call] = STATE(5057),
    [sym_method_call] = STATE(5061),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(7494),
    [sym__argument] = STATE(7495),
    [sym_splat_argument] = STATE(7495),
    [sym_hash_splat_argument] = STATE(7495),
    [sym_block_argument] = STATE(7495),
    [sym_assignment] = STATE(7493),
    [sym_operator_assignment] = STATE(7493),
    [sym_conditional] = STATE(7493),
    [sym_range] = STATE(7493),
    [sym_binary] = STATE(7493),
    [sym_unary] = STATE(7493),
    [sym_left_assignment_list] = STATE(5060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5061),
    [sym__variable] = STATE(5057),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5061),
    [sym_false] = STATE(5061),
    [sym_nil] = STATE(5061),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7496),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(7495),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(11023),
    [sym__splat_star] = ACTIONS(11025),
    [sym__unary_minus] = ACTIONS(7994),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(11027),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(427),
    [anon_sym_return] = ACTIONS(7998),
    [anon_sym_yield] = ACTIONS(8000),
    [anon_sym_break] = ACTIONS(8002),
    [anon_sym_next] = ACTIONS(8004),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(427),
    [anon_sym_else] = ACTIONS(427),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(8006),
    [anon_sym_not] = ACTIONS(8008),
    [anon_sym_BANG] = ACTIONS(8010),
    [anon_sym_TILDE] = ACTIONS(8012),
    [sym_constant] = ACTIONS(11029),
    [sym_identifier] = ACTIONS(11029),
    [sym_instance_variable] = ACTIONS(8016),
    [sym_class_variable] = ACTIONS(8016),
    [sym_global_variable] = ACTIONS(8016),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8018),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8018),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5053] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7497),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5061),
    [sym_scope_resolution] = STATE(5057),
    [sym_call] = STATE(5057),
    [sym_method_call] = STATE(5061),
    [sym_assignment] = STATE(7497),
    [sym_operator_assignment] = STATE(7497),
    [sym_conditional] = STATE(7497),
    [sym_range] = STATE(7497),
    [sym_binary] = STATE(7497),
    [sym_unary] = STATE(7497),
    [sym_left_assignment_list] = STATE(5060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5061),
    [sym__variable] = STATE(5057),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5061),
    [sym_false] = STATE(5061),
    [sym_nil] = STATE(5061),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7485),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(7994),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7998),
    [anon_sym_yield] = ACTIONS(8000),
    [anon_sym_break] = ACTIONS(8002),
    [anon_sym_next] = ACTIONS(8004),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11019),
    [anon_sym_defined_QMARK] = ACTIONS(8006),
    [anon_sym_not] = ACTIONS(8008),
    [anon_sym_BANG] = ACTIONS(8012),
    [anon_sym_TILDE] = ACTIONS(8012),
    [sym_constant] = ACTIONS(8018),
    [sym_identifier] = ACTIONS(8018),
    [sym_instance_variable] = ACTIONS(8016),
    [sym_class_variable] = ACTIONS(8016),
    [sym_global_variable] = ACTIONS(8016),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8018),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8018),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5054] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5061),
    [sym_scope_resolution] = STATE(5057),
    [sym_call] = STATE(5057),
    [sym_method_call] = STATE(5061),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(5060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5061),
    [sym__variable] = STATE(5057),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5061),
    [sym_false] = STATE(5061),
    [sym_nil] = STATE(5061),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7485),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(7994),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7998),
    [anon_sym_yield] = ACTIONS(8000),
    [anon_sym_break] = ACTIONS(8002),
    [anon_sym_next] = ACTIONS(8004),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11019),
    [anon_sym_defined_QMARK] = ACTIONS(8006),
    [anon_sym_not] = ACTIONS(8008),
    [anon_sym_BANG] = ACTIONS(8012),
    [anon_sym_TILDE] = ACTIONS(8012),
    [sym_constant] = ACTIONS(8018),
    [sym_identifier] = ACTIONS(8018),
    [sym_instance_variable] = ACTIONS(8016),
    [sym_class_variable] = ACTIONS(8016),
    [sym_global_variable] = ACTIONS(8016),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8018),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8018),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5055] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(11031),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_elsif] = ACTIONS(1091),
    [anon_sym_else] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [5056] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(11033),
    [sym__binary_star] = ACTIONS(11035),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(11037),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(11035),
    [anon_sym_AMP] = ACTIONS(11039),
    [anon_sym_LT] = ACTIONS(11041),
    [anon_sym_end] = ACTIONS(1625),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_unless] = ACTIONS(1625),
    [anon_sym_while] = ACTIONS(1625),
    [anon_sym_until] = ACTIONS(1625),
    [anon_sym_rescue] = ACTIONS(1625),
    [anon_sym_elsif] = ACTIONS(1625),
    [anon_sym_else] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(11021),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(11043),
    [anon_sym_DOT_DOT] = ACTIONS(11045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11047),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(11049),
    [anon_sym_AMP_AMP] = ACTIONS(11049),
    [anon_sym_LT_LT] = ACTIONS(11051),
    [anon_sym_GT_GT] = ACTIONS(11051),
    [anon_sym_EQ_EQ] = ACTIONS(11053),
    [anon_sym_BANG_EQ] = ACTIONS(11049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11049),
    [anon_sym_LT_EQ_GT] = ACTIONS(11049),
    [anon_sym_EQ_TILDE] = ACTIONS(11049),
    [anon_sym_BANG_TILDE] = ACTIONS(11049),
    [anon_sym_LT_EQ] = ACTIONS(11041),
    [anon_sym_GT] = ACTIONS(11041),
    [anon_sym_GT_EQ] = ACTIONS(11055),
    [anon_sym_CARET] = ACTIONS(11057),
    [anon_sym_PLUS] = ACTIONS(11033),
    [anon_sym_SLASH] = ACTIONS(11035),
    [anon_sym_PERCENT] = ACTIONS(11035),
    [sym_comment] = ACTIONS(87),
  },
  [5057] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(7514),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5097),
    [sym_scope_resolution] = STATE(5093),
    [sym_call] = STATE(5093),
    [sym_method_call] = STATE(5097),
    [sym_argument_list] = STATE(938),
    [sym__argument_list_with_parens] = STATE(7515),
    [sym__argument] = STATE(7516),
    [sym_splat_argument] = STATE(7516),
    [sym_hash_splat_argument] = STATE(7516),
    [sym_block_argument] = STATE(7516),
    [sym_do_block] = STATE(941),
    [sym_block] = STATE(941),
    [sym_assignment] = STATE(7514),
    [sym_operator_assignment] = STATE(7514),
    [sym_conditional] = STATE(7514),
    [sym_range] = STATE(7514),
    [sym_binary] = STATE(7514),
    [sym_unary] = STATE(7514),
    [sym_left_assignment_list] = STATE(5096),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5097),
    [sym__variable] = STATE(5093),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5097),
    [sym_false] = STATE(5097),
    [sym_nil] = STATE(5097),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7517),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(7516),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(743),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(11059),
    [sym__splat_star] = ACTIONS(11061),
    [sym__unary_minus] = ACTIONS(8066),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(11063),
    [anon_sym_LBRACE] = ACTIONS(1669),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(769),
    [anon_sym_return] = ACTIONS(8070),
    [anon_sym_yield] = ACTIONS(8072),
    [anon_sym_break] = ACTIONS(8074),
    [anon_sym_next] = ACTIONS(8076),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(769),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(769),
    [anon_sym_until] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(769),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(1671),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_elsif] = ACTIONS(769),
    [anon_sym_else] = ACTIONS(769),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(8078),
    [anon_sym_not] = ACTIONS(8080),
    [anon_sym_BANG] = ACTIONS(8082),
    [anon_sym_TILDE] = ACTIONS(8084),
    [sym_constant] = ACTIONS(11065),
    [sym_identifier] = ACTIONS(11065),
    [sym_instance_variable] = ACTIONS(8088),
    [sym_class_variable] = ACTIONS(8088),
    [sym_global_variable] = ACTIONS(8088),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8090),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8090),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5058] = {
    [sym_heredoc_body] = STATE(7518),
    [aux_sym_call_repeat1] = STATE(7518),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_elsif] = ACTIONS(1681),
    [anon_sym_else] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [5059] = {
    [sym_heredoc_body] = STATE(7518),
    [aux_sym_call_repeat1] = STATE(7518),
    [aux_sym_argument_list_repeat1] = STATE(7520),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(11067),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_elsif] = ACTIONS(1681),
    [anon_sym_else] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [5060] = {
    [anon_sym_EQ] = ACTIONS(11069),
    [sym_comment] = ACTIONS(87),
  },
  [5061] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(11071),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_elsif] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(11073),
    [anon_sym_DASH_EQ] = ACTIONS(11073),
    [anon_sym_STAR_EQ] = ACTIONS(11073),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11073),
    [anon_sym_SLASH_EQ] = ACTIONS(11073),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11073),
    [anon_sym_PIPE_EQ] = ACTIONS(11073),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11073),
    [anon_sym_AMP_EQ] = ACTIONS(11073),
    [anon_sym_PERCENT_EQ] = ACTIONS(11073),
    [anon_sym_GT_GT_EQ] = ACTIONS(11073),
    [anon_sym_LT_LT_EQ] = ACTIONS(11073),
    [anon_sym_CARET_EQ] = ACTIONS(11073),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5062] = {
    [sym_string] = STATE(7523),
    [aux_sym_chained_string_repeat1] = STATE(7523),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(11075),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_elsif] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [5063] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(8034),
    [sym__binary_star] = ACTIONS(8036),
    [anon_sym_PIPE] = ACTIONS(8038),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8036),
    [anon_sym_AMP] = ACTIONS(8040),
    [anon_sym_LT] = ACTIONS(8042),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_elsif] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(8044),
    [anon_sym_DOT_DOT] = ACTIONS(8046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8048),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(8052),
    [anon_sym_AMP_AMP] = ACTIONS(8052),
    [anon_sym_LT_LT] = ACTIONS(8054),
    [anon_sym_GT_GT] = ACTIONS(8054),
    [anon_sym_EQ_EQ] = ACTIONS(8056),
    [anon_sym_BANG_EQ] = ACTIONS(8052),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8052),
    [anon_sym_LT_EQ_GT] = ACTIONS(8052),
    [anon_sym_EQ_TILDE] = ACTIONS(8052),
    [anon_sym_BANG_TILDE] = ACTIONS(8052),
    [anon_sym_LT_EQ] = ACTIONS(8042),
    [anon_sym_GT] = ACTIONS(8042),
    [anon_sym_GT_EQ] = ACTIONS(8058),
    [anon_sym_CARET] = ACTIONS(8060),
    [anon_sym_PLUS] = ACTIONS(8034),
    [anon_sym_SLASH] = ACTIONS(8036),
    [anon_sym_PERCENT] = ACTIONS(8036),
    [sym_comment] = ACTIONS(87),
  },
  [5064] = {
    [aux_sym_undef_repeat1] = STATE(7524),
    [sym__line_break] = ACTIONS(2251),
    [sym__heredoc_body_start] = ACTIONS(2251),
    [anon_sym_COMMA] = ACTIONS(2253),
    [anon_sym_SEMI] = ACTIONS(2251),
    [anon_sym_end] = ACTIONS(2251),
    [anon_sym_if] = ACTIONS(2251),
    [anon_sym_unless] = ACTIONS(2251),
    [anon_sym_while] = ACTIONS(2251),
    [anon_sym_until] = ACTIONS(2251),
    [anon_sym_rescue] = ACTIONS(2251),
    [anon_sym_elsif] = ACTIONS(2251),
    [anon_sym_else] = ACTIONS(2251),
    [sym_comment] = ACTIONS(87),
  },
  [5065] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7525),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2645),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(2645),
    [sym_assignment] = STATE(7525),
    [sym_operator_assignment] = STATE(7525),
    [sym_conditional] = STATE(7525),
    [sym_range] = STATE(7525),
    [sym_binary] = STATE(7525),
    [sym_unary] = STATE(7525),
    [sym_left_assignment_list] = STATE(2644),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2645),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2645),
    [sym_false] = STATE(2645),
    [sym_nil] = STATE(2645),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2646),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4467),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4471),
    [anon_sym_yield] = ACTIONS(4473),
    [anon_sym_break] = ACTIONS(4475),
    [anon_sym_next] = ACTIONS(4477),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4479),
    [anon_sym_defined_QMARK] = ACTIONS(4481),
    [anon_sym_not] = ACTIONS(4483),
    [anon_sym_BANG] = ACTIONS(4485),
    [anon_sym_TILDE] = ACTIONS(4485),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5066] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7526),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2645),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(2645),
    [sym_assignment] = STATE(7526),
    [sym_operator_assignment] = STATE(7526),
    [sym_conditional] = STATE(7526),
    [sym_range] = STATE(7526),
    [sym_binary] = STATE(7526),
    [sym_unary] = STATE(7526),
    [sym_left_assignment_list] = STATE(2644),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2645),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2645),
    [sym_false] = STATE(2645),
    [sym_nil] = STATE(2645),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2646),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4467),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4471),
    [anon_sym_yield] = ACTIONS(4473),
    [anon_sym_break] = ACTIONS(4475),
    [anon_sym_next] = ACTIONS(4477),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4479),
    [anon_sym_defined_QMARK] = ACTIONS(4481),
    [anon_sym_not] = ACTIONS(4483),
    [anon_sym_BANG] = ACTIONS(4485),
    [anon_sym_TILDE] = ACTIONS(4485),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5067] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7527),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2645),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(2645),
    [sym_assignment] = STATE(7527),
    [sym_operator_assignment] = STATE(7527),
    [sym_conditional] = STATE(7527),
    [sym_range] = STATE(7527),
    [sym_binary] = STATE(7527),
    [sym_unary] = STATE(7527),
    [sym_left_assignment_list] = STATE(2644),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2645),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2645),
    [sym_false] = STATE(2645),
    [sym_nil] = STATE(2645),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2646),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4467),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4471),
    [anon_sym_yield] = ACTIONS(4473),
    [anon_sym_break] = ACTIONS(4475),
    [anon_sym_next] = ACTIONS(4477),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4479),
    [anon_sym_defined_QMARK] = ACTIONS(4481),
    [anon_sym_not] = ACTIONS(4483),
    [anon_sym_BANG] = ACTIONS(4485),
    [anon_sym_TILDE] = ACTIONS(4485),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5068] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7528),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2645),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(2645),
    [sym_assignment] = STATE(7528),
    [sym_operator_assignment] = STATE(7528),
    [sym_conditional] = STATE(7528),
    [sym_range] = STATE(7528),
    [sym_binary] = STATE(7528),
    [sym_unary] = STATE(7528),
    [sym_left_assignment_list] = STATE(2644),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2645),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2645),
    [sym_false] = STATE(2645),
    [sym_nil] = STATE(2645),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2646),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4467),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4471),
    [anon_sym_yield] = ACTIONS(4473),
    [anon_sym_break] = ACTIONS(4475),
    [anon_sym_next] = ACTIONS(4477),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4479),
    [anon_sym_defined_QMARK] = ACTIONS(4481),
    [anon_sym_not] = ACTIONS(4483),
    [anon_sym_BANG] = ACTIONS(4485),
    [anon_sym_TILDE] = ACTIONS(4485),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5069] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7529),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2645),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(2645),
    [sym_assignment] = STATE(7529),
    [sym_operator_assignment] = STATE(7529),
    [sym_conditional] = STATE(7529),
    [sym_range] = STATE(7529),
    [sym_binary] = STATE(7529),
    [sym_unary] = STATE(7529),
    [sym_left_assignment_list] = STATE(2644),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2645),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2645),
    [sym_false] = STATE(2645),
    [sym_nil] = STATE(2645),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2646),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4467),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4471),
    [anon_sym_yield] = ACTIONS(4473),
    [anon_sym_break] = ACTIONS(4475),
    [anon_sym_next] = ACTIONS(4477),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4479),
    [anon_sym_defined_QMARK] = ACTIONS(4481),
    [anon_sym_not] = ACTIONS(4483),
    [anon_sym_BANG] = ACTIONS(4485),
    [anon_sym_TILDE] = ACTIONS(4485),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5070] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7530),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2645),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(2645),
    [sym_assignment] = STATE(7530),
    [sym_operator_assignment] = STATE(7530),
    [sym_conditional] = STATE(7530),
    [sym_range] = STATE(7530),
    [sym_binary] = STATE(7530),
    [sym_unary] = STATE(7530),
    [sym_left_assignment_list] = STATE(2644),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2645),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2645),
    [sym_false] = STATE(2645),
    [sym_nil] = STATE(2645),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2646),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4467),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4471),
    [anon_sym_yield] = ACTIONS(4473),
    [anon_sym_break] = ACTIONS(4475),
    [anon_sym_next] = ACTIONS(4477),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4479),
    [anon_sym_defined_QMARK] = ACTIONS(4481),
    [anon_sym_not] = ACTIONS(4483),
    [anon_sym_BANG] = ACTIONS(4485),
    [anon_sym_TILDE] = ACTIONS(4485),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5071] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7531),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2645),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(2645),
    [sym_assignment] = STATE(7531),
    [sym_operator_assignment] = STATE(7531),
    [sym_conditional] = STATE(7531),
    [sym_range] = STATE(7531),
    [sym_binary] = STATE(7531),
    [sym_unary] = STATE(7531),
    [sym_left_assignment_list] = STATE(2644),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2645),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2645),
    [sym_false] = STATE(2645),
    [sym_nil] = STATE(2645),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2646),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4467),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4471),
    [anon_sym_yield] = ACTIONS(4473),
    [anon_sym_break] = ACTIONS(4475),
    [anon_sym_next] = ACTIONS(4477),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4479),
    [anon_sym_defined_QMARK] = ACTIONS(4481),
    [anon_sym_not] = ACTIONS(4483),
    [anon_sym_BANG] = ACTIONS(4485),
    [anon_sym_TILDE] = ACTIONS(4485),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5072] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7532),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2645),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(2645),
    [sym_assignment] = STATE(7532),
    [sym_operator_assignment] = STATE(7532),
    [sym_conditional] = STATE(7532),
    [sym_range] = STATE(7532),
    [sym_binary] = STATE(7532),
    [sym_unary] = STATE(7532),
    [sym_left_assignment_list] = STATE(2644),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2645),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2645),
    [sym_false] = STATE(2645),
    [sym_nil] = STATE(2645),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2646),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4467),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4471),
    [anon_sym_yield] = ACTIONS(4473),
    [anon_sym_break] = ACTIONS(4475),
    [anon_sym_next] = ACTIONS(4477),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4479),
    [anon_sym_defined_QMARK] = ACTIONS(4481),
    [anon_sym_not] = ACTIONS(4483),
    [anon_sym_BANG] = ACTIONS(4485),
    [anon_sym_TILDE] = ACTIONS(4485),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5073] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7533),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2645),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(2645),
    [sym_assignment] = STATE(7533),
    [sym_operator_assignment] = STATE(7533),
    [sym_conditional] = STATE(7533),
    [sym_range] = STATE(7533),
    [sym_binary] = STATE(7533),
    [sym_unary] = STATE(7533),
    [sym_left_assignment_list] = STATE(2644),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2645),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2645),
    [sym_false] = STATE(2645),
    [sym_nil] = STATE(2645),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2646),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4467),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4471),
    [anon_sym_yield] = ACTIONS(4473),
    [anon_sym_break] = ACTIONS(4475),
    [anon_sym_next] = ACTIONS(4477),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4479),
    [anon_sym_defined_QMARK] = ACTIONS(4481),
    [anon_sym_not] = ACTIONS(4483),
    [anon_sym_BANG] = ACTIONS(4485),
    [anon_sym_TILDE] = ACTIONS(4485),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5074] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7534),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2645),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(2645),
    [sym_assignment] = STATE(7534),
    [sym_operator_assignment] = STATE(7534),
    [sym_conditional] = STATE(7534),
    [sym_range] = STATE(7534),
    [sym_binary] = STATE(7534),
    [sym_unary] = STATE(7534),
    [sym_left_assignment_list] = STATE(2644),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2645),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2645),
    [sym_false] = STATE(2645),
    [sym_nil] = STATE(2645),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2646),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4467),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4471),
    [anon_sym_yield] = ACTIONS(4473),
    [anon_sym_break] = ACTIONS(4475),
    [anon_sym_next] = ACTIONS(4477),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4479),
    [anon_sym_defined_QMARK] = ACTIONS(4481),
    [anon_sym_not] = ACTIONS(4483),
    [anon_sym_BANG] = ACTIONS(4485),
    [anon_sym_TILDE] = ACTIONS(4485),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5075] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(7535),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(7535),
    [sym_operator_assignment] = STATE(7535),
    [sym_conditional] = STATE(7535),
    [sym_range] = STATE(7535),
    [sym_binary] = STATE(7535),
    [sym_unary] = STATE(7535),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5076] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7536),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2645),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(2645),
    [sym_assignment] = STATE(7536),
    [sym_operator_assignment] = STATE(7536),
    [sym_conditional] = STATE(7536),
    [sym_range] = STATE(7536),
    [sym_binary] = STATE(7536),
    [sym_unary] = STATE(7536),
    [sym_left_assignment_list] = STATE(2644),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2645),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2645),
    [sym_false] = STATE(2645),
    [sym_nil] = STATE(2645),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2646),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4467),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4471),
    [anon_sym_yield] = ACTIONS(4473),
    [anon_sym_break] = ACTIONS(4475),
    [anon_sym_next] = ACTIONS(4477),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4479),
    [anon_sym_defined_QMARK] = ACTIONS(4481),
    [anon_sym_not] = ACTIONS(4483),
    [anon_sym_BANG] = ACTIONS(4485),
    [anon_sym_TILDE] = ACTIONS(4485),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5077] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7537),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2645),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(2645),
    [sym_assignment] = STATE(7537),
    [sym_operator_assignment] = STATE(7537),
    [sym_conditional] = STATE(7537),
    [sym_range] = STATE(7537),
    [sym_binary] = STATE(7537),
    [sym_unary] = STATE(7537),
    [sym_left_assignment_list] = STATE(2644),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2645),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2645),
    [sym_false] = STATE(2645),
    [sym_nil] = STATE(2645),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2646),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4467),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4471),
    [anon_sym_yield] = ACTIONS(4473),
    [anon_sym_break] = ACTIONS(4475),
    [anon_sym_next] = ACTIONS(4477),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4479),
    [anon_sym_defined_QMARK] = ACTIONS(4481),
    [anon_sym_not] = ACTIONS(4483),
    [anon_sym_BANG] = ACTIONS(4485),
    [anon_sym_TILDE] = ACTIONS(4485),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5078] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7538),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2645),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(2645),
    [sym_assignment] = STATE(7538),
    [sym_operator_assignment] = STATE(7538),
    [sym_conditional] = STATE(7538),
    [sym_range] = STATE(7538),
    [sym_binary] = STATE(7538),
    [sym_unary] = STATE(7538),
    [sym_left_assignment_list] = STATE(2644),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2645),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2645),
    [sym_false] = STATE(2645),
    [sym_nil] = STATE(2645),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2646),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4467),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4471),
    [anon_sym_yield] = ACTIONS(4473),
    [anon_sym_break] = ACTIONS(4475),
    [anon_sym_next] = ACTIONS(4477),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4479),
    [anon_sym_defined_QMARK] = ACTIONS(4481),
    [anon_sym_not] = ACTIONS(4483),
    [anon_sym_BANG] = ACTIONS(4485),
    [anon_sym_TILDE] = ACTIONS(4485),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5079] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7539),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2645),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(2645),
    [sym_assignment] = STATE(7539),
    [sym_operator_assignment] = STATE(7539),
    [sym_conditional] = STATE(7539),
    [sym_range] = STATE(7539),
    [sym_binary] = STATE(7539),
    [sym_unary] = STATE(7539),
    [sym_left_assignment_list] = STATE(2644),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2645),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2645),
    [sym_false] = STATE(2645),
    [sym_nil] = STATE(2645),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2646),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4467),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4471),
    [anon_sym_yield] = ACTIONS(4473),
    [anon_sym_break] = ACTIONS(4475),
    [anon_sym_next] = ACTIONS(4477),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4479),
    [anon_sym_defined_QMARK] = ACTIONS(4481),
    [anon_sym_not] = ACTIONS(4483),
    [anon_sym_BANG] = ACTIONS(4485),
    [anon_sym_TILDE] = ACTIONS(4485),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5080] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(7547),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7550),
    [sym_scope_resolution] = STATE(7548),
    [sym_call] = STATE(7548),
    [sym_method_call] = STATE(7550),
    [sym_assignment] = STATE(7547),
    [sym_operator_assignment] = STATE(7547),
    [sym_conditional] = STATE(7547),
    [sym_range] = STATE(7547),
    [sym_binary] = STATE(7547),
    [sym_unary] = STATE(7547),
    [sym_left_assignment_list] = STATE(7549),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7550),
    [sym__variable] = STATE(7548),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7550),
    [sym_false] = STATE(7550),
    [sym_nil] = STATE(7550),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7551),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11077),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11079),
    [anon_sym_yield] = ACTIONS(11081),
    [anon_sym_break] = ACTIONS(11083),
    [anon_sym_next] = ACTIONS(11085),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11087),
    [anon_sym_defined_QMARK] = ACTIONS(11089),
    [anon_sym_not] = ACTIONS(11091),
    [anon_sym_BANG] = ACTIONS(11093),
    [anon_sym_TILDE] = ACTIONS(11093),
    [sym_constant] = ACTIONS(11095),
    [sym_identifier] = ACTIONS(11095),
    [sym_instance_variable] = ACTIONS(11097),
    [sym_class_variable] = ACTIONS(11097),
    [sym_global_variable] = ACTIONS(11097),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11095),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11095),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [5081] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(7552),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7550),
    [sym_scope_resolution] = STATE(7548),
    [sym_call] = STATE(7548),
    [sym_method_call] = STATE(7550),
    [sym_assignment] = STATE(7552),
    [sym_operator_assignment] = STATE(7552),
    [sym_conditional] = STATE(7552),
    [sym_range] = STATE(7552),
    [sym_binary] = STATE(7552),
    [sym_unary] = STATE(7552),
    [sym_left_assignment_list] = STATE(7549),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7550),
    [sym__variable] = STATE(7548),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7550),
    [sym_false] = STATE(7550),
    [sym_nil] = STATE(7550),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7551),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11077),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11079),
    [anon_sym_yield] = ACTIONS(11081),
    [anon_sym_break] = ACTIONS(11083),
    [anon_sym_next] = ACTIONS(11085),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11087),
    [anon_sym_defined_QMARK] = ACTIONS(11089),
    [anon_sym_not] = ACTIONS(11091),
    [anon_sym_BANG] = ACTIONS(11093),
    [anon_sym_TILDE] = ACTIONS(11093),
    [sym_constant] = ACTIONS(11095),
    [sym_identifier] = ACTIONS(11095),
    [sym_instance_variable] = ACTIONS(11097),
    [sym_class_variable] = ACTIONS(11097),
    [sym_global_variable] = ACTIONS(11097),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11095),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11095),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [5082] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(7553),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5097),
    [sym_scope_resolution] = STATE(5093),
    [sym_call] = STATE(5093),
    [sym_method_call] = STATE(5097),
    [sym_assignment] = STATE(7553),
    [sym_operator_assignment] = STATE(7553),
    [sym_conditional] = STATE(7553),
    [sym_range] = STATE(7553),
    [sym_binary] = STATE(7553),
    [sym_unary] = STATE(7553),
    [sym_left_assignment_list] = STATE(5096),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5097),
    [sym__variable] = STATE(5093),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5097),
    [sym_false] = STATE(5097),
    [sym_nil] = STATE(5097),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7554),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(8066),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(8070),
    [anon_sym_yield] = ACTIONS(8072),
    [anon_sym_break] = ACTIONS(8074),
    [anon_sym_next] = ACTIONS(8076),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(11099),
    [anon_sym_defined_QMARK] = ACTIONS(8078),
    [anon_sym_not] = ACTIONS(8080),
    [anon_sym_BANG] = ACTIONS(8084),
    [anon_sym_TILDE] = ACTIONS(8084),
    [sym_constant] = ACTIONS(8090),
    [sym_identifier] = ACTIONS(8090),
    [sym_instance_variable] = ACTIONS(8088),
    [sym_class_variable] = ACTIONS(8088),
    [sym_global_variable] = ACTIONS(8088),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8090),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8090),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5083] = {
    [anon_sym_COLON] = ACTIONS(11101),
    [sym_comment] = ACTIONS(87),
  },
  [5084] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(7556),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7550),
    [sym_scope_resolution] = STATE(7548),
    [sym_call] = STATE(7548),
    [sym_method_call] = STATE(7550),
    [sym_assignment] = STATE(7556),
    [sym_operator_assignment] = STATE(7556),
    [sym_conditional] = STATE(7556),
    [sym_range] = STATE(7556),
    [sym_binary] = STATE(7556),
    [sym_unary] = STATE(7556),
    [sym_left_assignment_list] = STATE(7549),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7550),
    [sym__variable] = STATE(7548),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7550),
    [sym_false] = STATE(7550),
    [sym_nil] = STATE(7550),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7551),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11077),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11079),
    [anon_sym_yield] = ACTIONS(11081),
    [anon_sym_break] = ACTIONS(11083),
    [anon_sym_next] = ACTIONS(11085),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11087),
    [anon_sym_defined_QMARK] = ACTIONS(11089),
    [anon_sym_not] = ACTIONS(11091),
    [anon_sym_BANG] = ACTIONS(11093),
    [anon_sym_TILDE] = ACTIONS(11093),
    [sym_constant] = ACTIONS(11095),
    [sym_identifier] = ACTIONS(11095),
    [sym_instance_variable] = ACTIONS(11097),
    [sym_class_variable] = ACTIONS(11097),
    [sym_global_variable] = ACTIONS(11097),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11095),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11095),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [5085] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(7514),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5097),
    [sym_scope_resolution] = STATE(5093),
    [sym_call] = STATE(5093),
    [sym_method_call] = STATE(5097),
    [sym_argument_list] = STATE(1535),
    [sym__argument_list_with_parens] = STATE(7515),
    [sym__argument] = STATE(7516),
    [sym_splat_argument] = STATE(7516),
    [sym_hash_splat_argument] = STATE(7516),
    [sym_block_argument] = STATE(7516),
    [sym_assignment] = STATE(7514),
    [sym_operator_assignment] = STATE(7514),
    [sym_conditional] = STATE(7514),
    [sym_range] = STATE(7514),
    [sym_binary] = STATE(7514),
    [sym_unary] = STATE(7514),
    [sym_left_assignment_list] = STATE(5096),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5097),
    [sym__variable] = STATE(5093),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5097),
    [sym_false] = STATE(5097),
    [sym_nil] = STATE(5097),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7517),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(7516),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(11059),
    [sym__splat_star] = ACTIONS(11061),
    [sym__unary_minus] = ACTIONS(8066),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(11063),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(8070),
    [anon_sym_yield] = ACTIONS(8072),
    [anon_sym_break] = ACTIONS(8074),
    [anon_sym_next] = ACTIONS(8076),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_elsif] = ACTIONS(377),
    [anon_sym_else] = ACTIONS(377),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(365),
    [anon_sym_DASH_EQ] = ACTIONS(365),
    [anon_sym_STAR_EQ] = ACTIONS(365),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(365),
    [anon_sym_SLASH_EQ] = ACTIONS(365),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(365),
    [anon_sym_PIPE_EQ] = ACTIONS(365),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(365),
    [anon_sym_AMP_EQ] = ACTIONS(365),
    [anon_sym_PERCENT_EQ] = ACTIONS(365),
    [anon_sym_GT_GT_EQ] = ACTIONS(365),
    [anon_sym_LT_LT_EQ] = ACTIONS(365),
    [anon_sym_CARET_EQ] = ACTIONS(365),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_PERCENT] = ACTIONS(377),
    [anon_sym_defined_QMARK] = ACTIONS(8078),
    [anon_sym_not] = ACTIONS(8080),
    [anon_sym_BANG] = ACTIONS(8082),
    [anon_sym_TILDE] = ACTIONS(8084),
    [sym_constant] = ACTIONS(11065),
    [sym_identifier] = ACTIONS(11065),
    [sym_instance_variable] = ACTIONS(8088),
    [sym_class_variable] = ACTIONS(8088),
    [sym_global_variable] = ACTIONS(8088),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8090),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8090),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5086] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(7514),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5097),
    [sym_scope_resolution] = STATE(5093),
    [sym_call] = STATE(5093),
    [sym_method_call] = STATE(5097),
    [sym_argument_list] = STATE(1536),
    [sym__argument_list_with_parens] = STATE(7515),
    [sym__argument] = STATE(7516),
    [sym_splat_argument] = STATE(7516),
    [sym_hash_splat_argument] = STATE(7516),
    [sym_block_argument] = STATE(7516),
    [sym_assignment] = STATE(7514),
    [sym_operator_assignment] = STATE(7514),
    [sym_conditional] = STATE(7514),
    [sym_range] = STATE(7514),
    [sym_binary] = STATE(7514),
    [sym_unary] = STATE(7514),
    [sym_left_assignment_list] = STATE(5096),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5097),
    [sym__variable] = STATE(5093),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5097),
    [sym_false] = STATE(5097),
    [sym_nil] = STATE(5097),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7517),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(7516),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(11059),
    [sym__splat_star] = ACTIONS(11061),
    [sym__unary_minus] = ACTIONS(8066),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(11063),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_EQ] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(8070),
    [anon_sym_yield] = ACTIONS(8072),
    [anon_sym_break] = ACTIONS(8074),
    [anon_sym_next] = ACTIONS(8076),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_elsif] = ACTIONS(419),
    [anon_sym_else] = ACTIONS(419),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(417),
    [anon_sym_DASH_EQ] = ACTIONS(417),
    [anon_sym_STAR_EQ] = ACTIONS(417),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(417),
    [anon_sym_SLASH_EQ] = ACTIONS(417),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(417),
    [anon_sym_PIPE_EQ] = ACTIONS(417),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(417),
    [anon_sym_AMP_EQ] = ACTIONS(417),
    [anon_sym_PERCENT_EQ] = ACTIONS(417),
    [anon_sym_GT_GT_EQ] = ACTIONS(417),
    [anon_sym_LT_LT_EQ] = ACTIONS(417),
    [anon_sym_CARET_EQ] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(8078),
    [anon_sym_not] = ACTIONS(8080),
    [anon_sym_BANG] = ACTIONS(8082),
    [anon_sym_TILDE] = ACTIONS(8084),
    [sym_constant] = ACTIONS(11065),
    [sym_identifier] = ACTIONS(11065),
    [sym_instance_variable] = ACTIONS(8088),
    [sym_class_variable] = ACTIONS(8088),
    [sym_global_variable] = ACTIONS(8088),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8090),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8090),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5087] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(7514),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5097),
    [sym_scope_resolution] = STATE(5093),
    [sym_call] = STATE(5093),
    [sym_method_call] = STATE(5097),
    [sym_argument_list] = STATE(1537),
    [sym__argument_list_with_parens] = STATE(7515),
    [sym__argument] = STATE(7516),
    [sym_splat_argument] = STATE(7516),
    [sym_hash_splat_argument] = STATE(7516),
    [sym_block_argument] = STATE(7516),
    [sym_assignment] = STATE(7514),
    [sym_operator_assignment] = STATE(7514),
    [sym_conditional] = STATE(7514),
    [sym_range] = STATE(7514),
    [sym_binary] = STATE(7514),
    [sym_unary] = STATE(7514),
    [sym_left_assignment_list] = STATE(5096),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5097),
    [sym__variable] = STATE(5093),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5097),
    [sym_false] = STATE(5097),
    [sym_nil] = STATE(5097),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7517),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(7516),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(11059),
    [sym__splat_star] = ACTIONS(11061),
    [sym__unary_minus] = ACTIONS(8066),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(11063),
    [anon_sym_LBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_EQ] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(423),
    [anon_sym_return] = ACTIONS(8070),
    [anon_sym_yield] = ACTIONS(8072),
    [anon_sym_break] = ACTIONS(8074),
    [anon_sym_next] = ACTIONS(8076),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_elsif] = ACTIONS(423),
    [anon_sym_else] = ACTIONS(423),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(421),
    [anon_sym_DASH_EQ] = ACTIONS(421),
    [anon_sym_STAR_EQ] = ACTIONS(421),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(421),
    [anon_sym_SLASH_EQ] = ACTIONS(421),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(421),
    [anon_sym_PIPE_EQ] = ACTIONS(421),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(421),
    [anon_sym_AMP_EQ] = ACTIONS(421),
    [anon_sym_PERCENT_EQ] = ACTIONS(421),
    [anon_sym_GT_GT_EQ] = ACTIONS(421),
    [anon_sym_LT_LT_EQ] = ACTIONS(421),
    [anon_sym_CARET_EQ] = ACTIONS(421),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(8078),
    [anon_sym_not] = ACTIONS(8080),
    [anon_sym_BANG] = ACTIONS(8082),
    [anon_sym_TILDE] = ACTIONS(8084),
    [sym_constant] = ACTIONS(11065),
    [sym_identifier] = ACTIONS(11065),
    [sym_instance_variable] = ACTIONS(8088),
    [sym_class_variable] = ACTIONS(8088),
    [sym_global_variable] = ACTIONS(8088),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8090),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8090),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5088] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(7514),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5097),
    [sym_scope_resolution] = STATE(5093),
    [sym_call] = STATE(5093),
    [sym_method_call] = STATE(5097),
    [sym_argument_list] = STATE(1538),
    [sym__argument_list_with_parens] = STATE(7515),
    [sym__argument] = STATE(7516),
    [sym_splat_argument] = STATE(7516),
    [sym_hash_splat_argument] = STATE(7516),
    [sym_block_argument] = STATE(7516),
    [sym_assignment] = STATE(7514),
    [sym_operator_assignment] = STATE(7514),
    [sym_conditional] = STATE(7514),
    [sym_range] = STATE(7514),
    [sym_binary] = STATE(7514),
    [sym_unary] = STATE(7514),
    [sym_left_assignment_list] = STATE(5096),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5097),
    [sym__variable] = STATE(5093),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5097),
    [sym_false] = STATE(5097),
    [sym_nil] = STATE(5097),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7517),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(7516),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(11059),
    [sym__splat_star] = ACTIONS(11061),
    [sym__unary_minus] = ACTIONS(8066),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(11063),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(427),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(427),
    [anon_sym_return] = ACTIONS(8070),
    [anon_sym_yield] = ACTIONS(8072),
    [anon_sym_break] = ACTIONS(8074),
    [anon_sym_next] = ACTIONS(8076),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_elsif] = ACTIONS(427),
    [anon_sym_else] = ACTIONS(427),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(425),
    [anon_sym_DASH_EQ] = ACTIONS(425),
    [anon_sym_STAR_EQ] = ACTIONS(425),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(425),
    [anon_sym_SLASH_EQ] = ACTIONS(425),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(425),
    [anon_sym_PIPE_EQ] = ACTIONS(425),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(425),
    [anon_sym_AMP_EQ] = ACTIONS(425),
    [anon_sym_PERCENT_EQ] = ACTIONS(425),
    [anon_sym_GT_GT_EQ] = ACTIONS(425),
    [anon_sym_LT_LT_EQ] = ACTIONS(425),
    [anon_sym_CARET_EQ] = ACTIONS(425),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(8078),
    [anon_sym_not] = ACTIONS(8080),
    [anon_sym_BANG] = ACTIONS(8082),
    [anon_sym_TILDE] = ACTIONS(8084),
    [sym_constant] = ACTIONS(11065),
    [sym_identifier] = ACTIONS(11065),
    [sym_instance_variable] = ACTIONS(8088),
    [sym_class_variable] = ACTIONS(8088),
    [sym_global_variable] = ACTIONS(8088),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8090),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8090),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5089] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(7557),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5097),
    [sym_scope_resolution] = STATE(5093),
    [sym_call] = STATE(5093),
    [sym_method_call] = STATE(5097),
    [sym_assignment] = STATE(7557),
    [sym_operator_assignment] = STATE(7557),
    [sym_conditional] = STATE(7557),
    [sym_range] = STATE(7557),
    [sym_binary] = STATE(7557),
    [sym_unary] = STATE(7557),
    [sym_left_assignment_list] = STATE(5096),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5097),
    [sym__variable] = STATE(5093),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5097),
    [sym_false] = STATE(5097),
    [sym_nil] = STATE(5097),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7554),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(8066),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(8070),
    [anon_sym_yield] = ACTIONS(8072),
    [anon_sym_break] = ACTIONS(8074),
    [anon_sym_next] = ACTIONS(8076),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(11099),
    [anon_sym_defined_QMARK] = ACTIONS(8078),
    [anon_sym_not] = ACTIONS(8080),
    [anon_sym_BANG] = ACTIONS(8084),
    [anon_sym_TILDE] = ACTIONS(8084),
    [sym_constant] = ACTIONS(8090),
    [sym_identifier] = ACTIONS(8090),
    [sym_instance_variable] = ACTIONS(8088),
    [sym_class_variable] = ACTIONS(8088),
    [sym_global_variable] = ACTIONS(8088),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8090),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8090),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5090] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(1559),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5097),
    [sym_scope_resolution] = STATE(5093),
    [sym_call] = STATE(5093),
    [sym_method_call] = STATE(5097),
    [sym_assignment] = STATE(1559),
    [sym_operator_assignment] = STATE(1559),
    [sym_conditional] = STATE(1559),
    [sym_range] = STATE(1559),
    [sym_binary] = STATE(1559),
    [sym_unary] = STATE(1559),
    [sym_left_assignment_list] = STATE(5096),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5097),
    [sym__variable] = STATE(5093),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5097),
    [sym_false] = STATE(5097),
    [sym_nil] = STATE(5097),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7554),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(8066),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(8070),
    [anon_sym_yield] = ACTIONS(8072),
    [anon_sym_break] = ACTIONS(8074),
    [anon_sym_next] = ACTIONS(8076),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(11099),
    [anon_sym_defined_QMARK] = ACTIONS(8078),
    [anon_sym_not] = ACTIONS(8080),
    [anon_sym_BANG] = ACTIONS(8084),
    [anon_sym_TILDE] = ACTIONS(8084),
    [sym_constant] = ACTIONS(8090),
    [sym_identifier] = ACTIONS(8090),
    [sym_instance_variable] = ACTIONS(8088),
    [sym_class_variable] = ACTIONS(8088),
    [sym_global_variable] = ACTIONS(8088),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8090),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8090),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5091] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(11103),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_elsif] = ACTIONS(1091),
    [anon_sym_else] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [5092] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(11105),
    [sym__binary_star] = ACTIONS(11107),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(11109),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(11111),
    [anon_sym_AMP] = ACTIONS(11113),
    [anon_sym_EQ] = ACTIONS(1631),
    [anon_sym_LT] = ACTIONS(11115),
    [anon_sym_end] = ACTIONS(1625),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_unless] = ACTIONS(1625),
    [anon_sym_while] = ACTIONS(1625),
    [anon_sym_until] = ACTIONS(1625),
    [anon_sym_rescue] = ACTIONS(1625),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_elsif] = ACTIONS(1625),
    [anon_sym_else] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(11101),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_PLUS_EQ] = ACTIONS(1625),
    [anon_sym_DASH_EQ] = ACTIONS(1625),
    [anon_sym_STAR_EQ] = ACTIONS(1625),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1625),
    [anon_sym_SLASH_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1625),
    [anon_sym_AMP_EQ] = ACTIONS(1625),
    [anon_sym_PERCENT_EQ] = ACTIONS(1625),
    [anon_sym_GT_GT_EQ] = ACTIONS(1625),
    [anon_sym_LT_LT_EQ] = ACTIONS(1625),
    [anon_sym_CARET_EQ] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(11117),
    [anon_sym_DOT_DOT] = ACTIONS(11119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11121),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(11123),
    [anon_sym_AMP_AMP] = ACTIONS(11123),
    [anon_sym_LT_LT] = ACTIONS(11125),
    [anon_sym_GT_GT] = ACTIONS(11125),
    [anon_sym_EQ_EQ] = ACTIONS(11123),
    [anon_sym_BANG_EQ] = ACTIONS(11127),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11127),
    [anon_sym_LT_EQ_GT] = ACTIONS(11127),
    [anon_sym_EQ_TILDE] = ACTIONS(11127),
    [anon_sym_BANG_TILDE] = ACTIONS(11127),
    [anon_sym_LT_EQ] = ACTIONS(11115),
    [anon_sym_GT] = ACTIONS(11115),
    [anon_sym_GT_EQ] = ACTIONS(11129),
    [anon_sym_CARET] = ACTIONS(11109),
    [anon_sym_PLUS] = ACTIONS(11131),
    [anon_sym_SLASH] = ACTIONS(11111),
    [anon_sym_PERCENT] = ACTIONS(11111),
    [sym_comment] = ACTIONS(87),
  },
  [5093] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(7514),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5097),
    [sym_scope_resolution] = STATE(5093),
    [sym_call] = STATE(5093),
    [sym_method_call] = STATE(5097),
    [sym_argument_list] = STATE(1578),
    [sym__argument_list_with_parens] = STATE(7515),
    [sym__argument] = STATE(7516),
    [sym_splat_argument] = STATE(7516),
    [sym_hash_splat_argument] = STATE(7516),
    [sym_block_argument] = STATE(7516),
    [sym_do_block] = STATE(941),
    [sym_block] = STATE(941),
    [sym_assignment] = STATE(7514),
    [sym_operator_assignment] = STATE(7514),
    [sym_conditional] = STATE(7514),
    [sym_range] = STATE(7514),
    [sym_binary] = STATE(7514),
    [sym_unary] = STATE(7514),
    [sym_left_assignment_list] = STATE(5096),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5097),
    [sym__variable] = STATE(5093),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5097),
    [sym_false] = STATE(5097),
    [sym_nil] = STATE(5097),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7517),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(7516),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(743),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(11059),
    [sym__splat_star] = ACTIONS(11061),
    [sym__unary_minus] = ACTIONS(8066),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(11063),
    [anon_sym_LBRACE] = ACTIONS(2715),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(769),
    [anon_sym_return] = ACTIONS(8070),
    [anon_sym_yield] = ACTIONS(8072),
    [anon_sym_break] = ACTIONS(8074),
    [anon_sym_next] = ACTIONS(8076),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(769),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(769),
    [anon_sym_until] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(769),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(769),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_elsif] = ACTIONS(769),
    [anon_sym_else] = ACTIONS(769),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(8078),
    [anon_sym_not] = ACTIONS(8080),
    [anon_sym_BANG] = ACTIONS(8082),
    [anon_sym_TILDE] = ACTIONS(8084),
    [sym_constant] = ACTIONS(11065),
    [sym_identifier] = ACTIONS(11065),
    [sym_instance_variable] = ACTIONS(8088),
    [sym_class_variable] = ACTIONS(8088),
    [sym_global_variable] = ACTIONS(8088),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8090),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8090),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5094] = {
    [sym_heredoc_body] = STATE(7569),
    [aux_sym_call_repeat1] = STATE(7569),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_elsif] = ACTIONS(1681),
    [anon_sym_else] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [5095] = {
    [sym_heredoc_body] = STATE(7569),
    [aux_sym_call_repeat1] = STATE(7569),
    [aux_sym_argument_list_repeat1] = STATE(7571),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(11133),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_elsif] = ACTIONS(1681),
    [anon_sym_else] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [5096] = {
    [anon_sym_EQ] = ACTIONS(11135),
    [sym_comment] = ACTIONS(87),
  },
  [5097] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(11137),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_elsif] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(11139),
    [anon_sym_DASH_EQ] = ACTIONS(11139),
    [anon_sym_STAR_EQ] = ACTIONS(11139),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11139),
    [anon_sym_SLASH_EQ] = ACTIONS(11139),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11139),
    [anon_sym_PIPE_EQ] = ACTIONS(11139),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11139),
    [anon_sym_AMP_EQ] = ACTIONS(11139),
    [anon_sym_PERCENT_EQ] = ACTIONS(11139),
    [anon_sym_GT_GT_EQ] = ACTIONS(11139),
    [anon_sym_LT_LT_EQ] = ACTIONS(11139),
    [anon_sym_CARET_EQ] = ACTIONS(11139),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5098] = {
    [sym_string] = STATE(7574),
    [aux_sym_chained_string_repeat1] = STATE(7574),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(747),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(11141),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_elsif] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5099] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7579),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7582),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(7582),
    [sym_splat_argument] = STATE(7580),
    [sym_assignment] = STATE(7579),
    [sym_operator_assignment] = STATE(7579),
    [sym_conditional] = STATE(7579),
    [sym_range] = STATE(7579),
    [sym_binary] = STATE(7579),
    [sym_unary] = STATE(7579),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(7580),
    [sym_left_assignment_list] = STATE(7581),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7582),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7582),
    [sym_false] = STATE(7582),
    [sym_nil] = STATE(7582),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7482),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(11143),
    [sym__unary_minus] = ACTIONS(11145),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11003),
    [anon_sym_yield] = ACTIONS(11005),
    [anon_sym_break] = ACTIONS(11007),
    [anon_sym_next] = ACTIONS(11009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11147),
    [anon_sym_defined_QMARK] = ACTIONS(11149),
    [anon_sym_not] = ACTIONS(11151),
    [anon_sym_BANG] = ACTIONS(11153),
    [anon_sym_TILDE] = ACTIONS(11153),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5100] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7583),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2645),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(2645),
    [sym_assignment] = STATE(7583),
    [sym_operator_assignment] = STATE(7583),
    [sym_conditional] = STATE(7583),
    [sym_range] = STATE(7583),
    [sym_binary] = STATE(7583),
    [sym_unary] = STATE(7583),
    [sym_left_assignment_list] = STATE(2644),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2645),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2645),
    [sym_false] = STATE(2645),
    [sym_nil] = STATE(2645),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2646),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4467),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4471),
    [anon_sym_yield] = ACTIONS(4473),
    [anon_sym_break] = ACTIONS(4475),
    [anon_sym_next] = ACTIONS(4477),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4479),
    [anon_sym_defined_QMARK] = ACTIONS(4481),
    [anon_sym_not] = ACTIONS(4483),
    [anon_sym_BANG] = ACTIONS(4485),
    [anon_sym_TILDE] = ACTIONS(4485),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5101] = {
    [sym_string] = STATE(7584),
    [aux_sym_chained_string_repeat1] = STATE(7584),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_end] = ACTIONS(2753),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_elsif] = ACTIONS(2753),
    [anon_sym_else] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [5102] = {
    [sym_heredoc_body] = STATE(370),
    [sym__terminator] = STATE(370),
    [sym__line_break] = ACTIONS(687),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(687),
    [anon_sym_end] = ACTIONS(2757),
    [anon_sym_if] = ACTIONS(8024),
    [anon_sym_unless] = ACTIONS(8026),
    [anon_sym_while] = ACTIONS(8028),
    [anon_sym_until] = ACTIONS(8030),
    [anon_sym_rescue] = ACTIONS(8032),
    [anon_sym_elsif] = ACTIONS(2757),
    [anon_sym_else] = ACTIONS(2757),
    [sym_comment] = ACTIONS(87),
  },
  [5103] = {
    [sym_begin_block] = STATE(1611),
    [sym_end_block] = STATE(1611),
    [sym__statement] = STATE(1611),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1611),
    [sym_unless_modifier] = STATE(1611),
    [sym_while_modifier] = STATE(1611),
    [sym_until_modifier] = STATE(1611),
    [sym_rescue_modifier] = STATE(1611),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1612),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1615),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(1615),
    [sym_assignment] = STATE(1612),
    [sym_operator_assignment] = STATE(1612),
    [sym_conditional] = STATE(1612),
    [sym_range] = STATE(1612),
    [sym_binary] = STATE(1612),
    [sym_unary] = STATE(1612),
    [sym_left_assignment_list] = STATE(1614),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1615),
    [sym__variable] = STATE(1613),
    [sym_undef] = STATE(1611),
    [sym_alias] = STATE(1611),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1615),
    [sym_false] = STATE(1615),
    [sym_nil] = STATE(1615),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1616),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(5103),
    [aux_sym__statements_repeat1] = STATE(5103),
    [sym__simple_symbol] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(2762),
    [sym__symbol_start] = ACTIONS(2765),
    [sym__subshell_start] = ACTIONS(2768),
    [sym__regex_start] = ACTIONS(2771),
    [sym__string_array_start] = ACTIONS(2774),
    [sym__symbol_array_start] = ACTIONS(2777),
    [sym_heredoc_beginning] = ACTIONS(2780),
    [sym__unary_minus] = ACTIONS(2783),
    [anon_sym_BEGIN] = ACTIONS(2786),
    [anon_sym_LBRACE] = ACTIONS(2789),
    [anon_sym_END] = ACTIONS(2792),
    [anon_sym_def] = ACTIONS(2795),
    [anon_sym_LPAREN] = ACTIONS(2798),
    [anon_sym_COLON_COLON] = ACTIONS(2801),
    [anon_sym_SEMI] = ACTIONS(2804),
    [anon_sym_STAR] = ACTIONS(2807),
    [anon_sym_class] = ACTIONS(2810),
    [anon_sym_module] = ACTIONS(2813),
    [anon_sym_end] = ACTIONS(2493),
    [anon_sym_return] = ACTIONS(2816),
    [anon_sym_yield] = ACTIONS(2819),
    [anon_sym_break] = ACTIONS(2822),
    [anon_sym_next] = ACTIONS(2825),
    [sym_redo] = ACTIONS(2828),
    [sym_retry] = ACTIONS(2828),
    [anon_sym_if] = ACTIONS(2831),
    [anon_sym_unless] = ACTIONS(2834),
    [anon_sym_while] = ACTIONS(2837),
    [anon_sym_until] = ACTIONS(2840),
    [anon_sym_for] = ACTIONS(2843),
    [anon_sym_case] = ACTIONS(2846),
    [anon_sym_elsif] = ACTIONS(2493),
    [anon_sym_else] = ACTIONS(2493),
    [anon_sym_begin] = ACTIONS(2849),
    [anon_sym_PLUS] = ACTIONS(2852),
    [anon_sym_defined_QMARK] = ACTIONS(2855),
    [anon_sym_not] = ACTIONS(2858),
    [anon_sym_BANG] = ACTIONS(2861),
    [anon_sym_TILDE] = ACTIONS(2861),
    [sym_constant] = ACTIONS(2864),
    [sym_identifier] = ACTIONS(2864),
    [sym_instance_variable] = ACTIONS(2867),
    [sym_class_variable] = ACTIONS(2867),
    [sym_global_variable] = ACTIONS(2867),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_alias] = ACTIONS(2873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2876),
    [sym_float] = ACTIONS(2828),
    [sym_complex] = ACTIONS(2780),
    [sym_super] = ACTIONS(2864),
    [anon_sym_true] = ACTIONS(2879),
    [anon_sym_TRUE] = ACTIONS(2879),
    [anon_sym_false] = ACTIONS(2882),
    [anon_sym_FALSE] = ACTIONS(2882),
    [sym_self] = ACTIONS(2864),
    [anon_sym_nil] = ACTIONS(2885),
    [anon_sym_NIL] = ACTIONS(2885),
    [sym_character] = ACTIONS(2780),
    [anon_sym_LBRACK2] = ACTIONS(2888),
    [anon_sym_DASH_GT] = ACTIONS(2891),
  },
  [5104] = {
    [sym_then] = STATE(7585),
    [sym_heredoc_body] = STATE(7586),
    [sym__terminator] = STATE(7586),
    [sym__line_break] = ACTIONS(11155),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(11155),
    [anon_sym_if] = ACTIONS(1743),
    [anon_sym_unless] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1747),
    [anon_sym_until] = ACTIONS(1749),
    [anon_sym_rescue] = ACTIONS(1751),
    [anon_sym_then] = ACTIONS(1753),
    [sym_comment] = ACTIONS(87),
  },
  [5105] = {
    [sym__line_break] = ACTIONS(11157),
    [sym__heredoc_body_start] = ACTIONS(11157),
    [sym__binary_minus] = ACTIONS(11157),
    [sym__binary_star] = ACTIONS(11157),
    [ts_builtin_sym_end] = ACTIONS(11157),
    [anon_sym___END__] = ACTIONS(11157),
    [anon_sym_LBRACE] = ACTIONS(11157),
    [anon_sym_RBRACE] = ACTIONS(11157),
    [anon_sym_RPAREN] = ACTIONS(11157),
    [anon_sym_DOT] = ACTIONS(11159),
    [anon_sym_COMMA] = ACTIONS(11157),
    [anon_sym_PIPE] = ACTIONS(11159),
    [anon_sym_SEMI] = ACTIONS(11157),
    [anon_sym_STAR_STAR] = ACTIONS(11157),
    [anon_sym_AMP] = ACTIONS(11159),
    [anon_sym_LT] = ACTIONS(11159),
    [anon_sym_end] = ACTIONS(11157),
    [anon_sym_if] = ACTIONS(11157),
    [anon_sym_unless] = ACTIONS(11157),
    [anon_sym_while] = ACTIONS(11157),
    [anon_sym_until] = ACTIONS(11157),
    [anon_sym_rescue] = ACTIONS(11157),
    [anon_sym_do] = ACTIONS(11157),
    [anon_sym_when] = ACTIONS(11157),
    [anon_sym_elsif] = ACTIONS(11157),
    [anon_sym_else] = ACTIONS(11157),
    [anon_sym_then] = ACTIONS(11157),
    [anon_sym_ensure] = ACTIONS(11157),
    [anon_sym_EQ_GT] = ACTIONS(11157),
    [anon_sym_LBRACK] = ACTIONS(11157),
    [anon_sym_COLON_COLON2] = ACTIONS(11157),
    [anon_sym_AMP_DOT] = ACTIONS(11157),
    [anon_sym_QMARK] = ACTIONS(11157),
    [anon_sym_DOT_DOT] = ACTIONS(11159),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11157),
    [anon_sym_and] = ACTIONS(11157),
    [anon_sym_or] = ACTIONS(11157),
    [anon_sym_PIPE_PIPE] = ACTIONS(11157),
    [anon_sym_AMP_AMP] = ACTIONS(11157),
    [anon_sym_LT_LT] = ACTIONS(11157),
    [anon_sym_GT_GT] = ACTIONS(11157),
    [anon_sym_EQ_EQ] = ACTIONS(11159),
    [anon_sym_BANG_EQ] = ACTIONS(11157),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11157),
    [anon_sym_LT_EQ_GT] = ACTIONS(11157),
    [anon_sym_EQ_TILDE] = ACTIONS(11157),
    [anon_sym_BANG_TILDE] = ACTIONS(11157),
    [anon_sym_LT_EQ] = ACTIONS(11159),
    [anon_sym_GT] = ACTIONS(11159),
    [anon_sym_GT_EQ] = ACTIONS(11157),
    [anon_sym_CARET] = ACTIONS(11157),
    [anon_sym_PLUS] = ACTIONS(11157),
    [anon_sym_SLASH] = ACTIONS(11157),
    [anon_sym_PERCENT] = ACTIONS(11157),
    [sym_comment] = ACTIONS(87),
  },
  [5106] = {
    [anon_sym_end] = ACTIONS(11161),
    [anon_sym_rescue] = ACTIONS(11161),
    [anon_sym_when] = ACTIONS(11161),
    [anon_sym_elsif] = ACTIONS(11161),
    [anon_sym_else] = ACTIONS(11161),
    [anon_sym_ensure] = ACTIONS(11161),
    [sym_comment] = ACTIONS(87),
  },
  [5107] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7587),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(7587),
    [sym_operator_assignment] = STATE(7587),
    [sym_conditional] = STATE(7587),
    [sym_range] = STATE(7587),
    [sym_binary] = STATE(7587),
    [sym_unary] = STATE(7587),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(429),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_yield] = ACTIONS(433),
    [anon_sym_break] = ACTIONS(435),
    [anon_sym_next] = ACTIONS(437),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(439),
    [anon_sym_defined_QMARK] = ACTIONS(441),
    [anon_sym_not] = ACTIONS(443),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5108] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8114),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [5109] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(8108),
    [sym__binary_star] = ACTIONS(8110),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(8112),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8114),
    [anon_sym_AMP] = ACTIONS(8116),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(8118),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(8120),
    [anon_sym_DOT_DOT] = ACTIONS(8122),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8124),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(8126),
    [anon_sym_AMP_AMP] = ACTIONS(8126),
    [anon_sym_LT_LT] = ACTIONS(8128),
    [anon_sym_GT_GT] = ACTIONS(8128),
    [anon_sym_EQ_EQ] = ACTIONS(8126),
    [anon_sym_BANG_EQ] = ACTIONS(8130),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8130),
    [anon_sym_LT_EQ_GT] = ACTIONS(8130),
    [anon_sym_EQ_TILDE] = ACTIONS(8130),
    [anon_sym_BANG_TILDE] = ACTIONS(8130),
    [anon_sym_LT_EQ] = ACTIONS(8118),
    [anon_sym_GT] = ACTIONS(8118),
    [anon_sym_GT_EQ] = ACTIONS(8132),
    [anon_sym_CARET] = ACTIONS(8112),
    [anon_sym_PLUS] = ACTIONS(8134),
    [anon_sym_SLASH] = ACTIONS(8114),
    [anon_sym_PERCENT] = ACTIONS(8114),
    [sym_comment] = ACTIONS(87),
  },
  [5110] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(7588),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2672),
    [sym_scope_resolution] = STATE(2670),
    [sym_call] = STATE(2670),
    [sym_method_call] = STATE(2672),
    [sym_assignment] = STATE(7588),
    [sym_operator_assignment] = STATE(7588),
    [sym_conditional] = STATE(7588),
    [sym_range] = STATE(7588),
    [sym_binary] = STATE(7588),
    [sym_unary] = STATE(7588),
    [sym_left_assignment_list] = STATE(2671),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2672),
    [sym__variable] = STATE(2670),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2672),
    [sym_false] = STATE(2672),
    [sym_nil] = STATE(2672),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2673),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(4505),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(4507),
    [anon_sym_yield] = ACTIONS(4509),
    [anon_sym_break] = ACTIONS(4511),
    [anon_sym_next] = ACTIONS(4513),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(4515),
    [anon_sym_defined_QMARK] = ACTIONS(4517),
    [anon_sym_not] = ACTIONS(4519),
    [anon_sym_BANG] = ACTIONS(4521),
    [anon_sym_TILDE] = ACTIONS(4521),
    [sym_constant] = ACTIONS(4523),
    [sym_identifier] = ACTIONS(4523),
    [sym_instance_variable] = ACTIONS(4525),
    [sym_class_variable] = ACTIONS(4525),
    [sym_global_variable] = ACTIONS(4525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(4523),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4523),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [5111] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(7589),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2672),
    [sym_scope_resolution] = STATE(2670),
    [sym_call] = STATE(2670),
    [sym_method_call] = STATE(2672),
    [sym_assignment] = STATE(7589),
    [sym_operator_assignment] = STATE(7589),
    [sym_conditional] = STATE(7589),
    [sym_range] = STATE(7589),
    [sym_binary] = STATE(7589),
    [sym_unary] = STATE(7589),
    [sym_left_assignment_list] = STATE(2671),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2672),
    [sym__variable] = STATE(2670),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2672),
    [sym_false] = STATE(2672),
    [sym_nil] = STATE(2672),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2673),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(4505),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(4507),
    [anon_sym_yield] = ACTIONS(4509),
    [anon_sym_break] = ACTIONS(4511),
    [anon_sym_next] = ACTIONS(4513),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(4515),
    [anon_sym_defined_QMARK] = ACTIONS(4517),
    [anon_sym_not] = ACTIONS(4519),
    [anon_sym_BANG] = ACTIONS(4521),
    [anon_sym_TILDE] = ACTIONS(4521),
    [sym_constant] = ACTIONS(4523),
    [sym_identifier] = ACTIONS(4523),
    [sym_instance_variable] = ACTIONS(4525),
    [sym_class_variable] = ACTIONS(4525),
    [sym_global_variable] = ACTIONS(4525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(4523),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4523),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [5112] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(7590),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2672),
    [sym_scope_resolution] = STATE(2670),
    [sym_call] = STATE(2670),
    [sym_method_call] = STATE(2672),
    [sym_assignment] = STATE(7590),
    [sym_operator_assignment] = STATE(7590),
    [sym_conditional] = STATE(7590),
    [sym_range] = STATE(7590),
    [sym_binary] = STATE(7590),
    [sym_unary] = STATE(7590),
    [sym_left_assignment_list] = STATE(2671),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2672),
    [sym__variable] = STATE(2670),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2672),
    [sym_false] = STATE(2672),
    [sym_nil] = STATE(2672),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2673),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(4505),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(4507),
    [anon_sym_yield] = ACTIONS(4509),
    [anon_sym_break] = ACTIONS(4511),
    [anon_sym_next] = ACTIONS(4513),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(4515),
    [anon_sym_defined_QMARK] = ACTIONS(4517),
    [anon_sym_not] = ACTIONS(4519),
    [anon_sym_BANG] = ACTIONS(4521),
    [anon_sym_TILDE] = ACTIONS(4521),
    [sym_constant] = ACTIONS(4523),
    [sym_identifier] = ACTIONS(4523),
    [sym_instance_variable] = ACTIONS(4525),
    [sym_class_variable] = ACTIONS(4525),
    [sym_global_variable] = ACTIONS(4525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(4523),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4523),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [5113] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(7591),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2672),
    [sym_scope_resolution] = STATE(2670),
    [sym_call] = STATE(2670),
    [sym_method_call] = STATE(2672),
    [sym_assignment] = STATE(7591),
    [sym_operator_assignment] = STATE(7591),
    [sym_conditional] = STATE(7591),
    [sym_range] = STATE(7591),
    [sym_binary] = STATE(7591),
    [sym_unary] = STATE(7591),
    [sym_left_assignment_list] = STATE(2671),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2672),
    [sym__variable] = STATE(2670),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2672),
    [sym_false] = STATE(2672),
    [sym_nil] = STATE(2672),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2673),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(4505),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(4507),
    [anon_sym_yield] = ACTIONS(4509),
    [anon_sym_break] = ACTIONS(4511),
    [anon_sym_next] = ACTIONS(4513),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(4515),
    [anon_sym_defined_QMARK] = ACTIONS(4517),
    [anon_sym_not] = ACTIONS(4519),
    [anon_sym_BANG] = ACTIONS(4521),
    [anon_sym_TILDE] = ACTIONS(4521),
    [sym_constant] = ACTIONS(4523),
    [sym_identifier] = ACTIONS(4523),
    [sym_instance_variable] = ACTIONS(4525),
    [sym_class_variable] = ACTIONS(4525),
    [sym_global_variable] = ACTIONS(4525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(4523),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4523),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [5114] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(7592),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2672),
    [sym_scope_resolution] = STATE(2670),
    [sym_call] = STATE(2670),
    [sym_method_call] = STATE(2672),
    [sym_assignment] = STATE(7592),
    [sym_operator_assignment] = STATE(7592),
    [sym_conditional] = STATE(7592),
    [sym_range] = STATE(7592),
    [sym_binary] = STATE(7592),
    [sym_unary] = STATE(7592),
    [sym_left_assignment_list] = STATE(2671),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2672),
    [sym__variable] = STATE(2670),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2672),
    [sym_false] = STATE(2672),
    [sym_nil] = STATE(2672),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2673),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(4505),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(4507),
    [anon_sym_yield] = ACTIONS(4509),
    [anon_sym_break] = ACTIONS(4511),
    [anon_sym_next] = ACTIONS(4513),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(4515),
    [anon_sym_defined_QMARK] = ACTIONS(4517),
    [anon_sym_not] = ACTIONS(4519),
    [anon_sym_BANG] = ACTIONS(4521),
    [anon_sym_TILDE] = ACTIONS(4521),
    [sym_constant] = ACTIONS(4523),
    [sym_identifier] = ACTIONS(4523),
    [sym_instance_variable] = ACTIONS(4525),
    [sym_class_variable] = ACTIONS(4525),
    [sym_global_variable] = ACTIONS(4525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(4523),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4523),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [5115] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(7593),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(7593),
    [sym_operator_assignment] = STATE(7593),
    [sym_conditional] = STATE(7593),
    [sym_range] = STATE(7593),
    [sym_binary] = STATE(7593),
    [sym_unary] = STATE(7593),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5116] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(7594),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2672),
    [sym_scope_resolution] = STATE(2670),
    [sym_call] = STATE(2670),
    [sym_method_call] = STATE(2672),
    [sym_assignment] = STATE(7594),
    [sym_operator_assignment] = STATE(7594),
    [sym_conditional] = STATE(7594),
    [sym_range] = STATE(7594),
    [sym_binary] = STATE(7594),
    [sym_unary] = STATE(7594),
    [sym_left_assignment_list] = STATE(2671),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2672),
    [sym__variable] = STATE(2670),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2672),
    [sym_false] = STATE(2672),
    [sym_nil] = STATE(2672),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2673),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(4505),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(4507),
    [anon_sym_yield] = ACTIONS(4509),
    [anon_sym_break] = ACTIONS(4511),
    [anon_sym_next] = ACTIONS(4513),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(4515),
    [anon_sym_defined_QMARK] = ACTIONS(4517),
    [anon_sym_not] = ACTIONS(4519),
    [anon_sym_BANG] = ACTIONS(4521),
    [anon_sym_TILDE] = ACTIONS(4521),
    [sym_constant] = ACTIONS(4523),
    [sym_identifier] = ACTIONS(4523),
    [sym_instance_variable] = ACTIONS(4525),
    [sym_class_variable] = ACTIONS(4525),
    [sym_global_variable] = ACTIONS(4525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(4523),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4523),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [5117] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(7595),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2672),
    [sym_scope_resolution] = STATE(2670),
    [sym_call] = STATE(2670),
    [sym_method_call] = STATE(2672),
    [sym_assignment] = STATE(7595),
    [sym_operator_assignment] = STATE(7595),
    [sym_conditional] = STATE(7595),
    [sym_range] = STATE(7595),
    [sym_binary] = STATE(7595),
    [sym_unary] = STATE(7595),
    [sym_left_assignment_list] = STATE(2671),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2672),
    [sym__variable] = STATE(2670),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2672),
    [sym_false] = STATE(2672),
    [sym_nil] = STATE(2672),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2673),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(4505),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(4507),
    [anon_sym_yield] = ACTIONS(4509),
    [anon_sym_break] = ACTIONS(4511),
    [anon_sym_next] = ACTIONS(4513),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(4515),
    [anon_sym_defined_QMARK] = ACTIONS(4517),
    [anon_sym_not] = ACTIONS(4519),
    [anon_sym_BANG] = ACTIONS(4521),
    [anon_sym_TILDE] = ACTIONS(4521),
    [sym_constant] = ACTIONS(4523),
    [sym_identifier] = ACTIONS(4523),
    [sym_instance_variable] = ACTIONS(4525),
    [sym_class_variable] = ACTIONS(4525),
    [sym_global_variable] = ACTIONS(4525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(4523),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4523),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [5118] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(7596),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2672),
    [sym_scope_resolution] = STATE(2670),
    [sym_call] = STATE(2670),
    [sym_method_call] = STATE(2672),
    [sym_assignment] = STATE(7596),
    [sym_operator_assignment] = STATE(7596),
    [sym_conditional] = STATE(7596),
    [sym_range] = STATE(7596),
    [sym_binary] = STATE(7596),
    [sym_unary] = STATE(7596),
    [sym_left_assignment_list] = STATE(2671),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2672),
    [sym__variable] = STATE(2670),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2672),
    [sym_false] = STATE(2672),
    [sym_nil] = STATE(2672),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2673),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(4505),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(4507),
    [anon_sym_yield] = ACTIONS(4509),
    [anon_sym_break] = ACTIONS(4511),
    [anon_sym_next] = ACTIONS(4513),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(4515),
    [anon_sym_defined_QMARK] = ACTIONS(4517),
    [anon_sym_not] = ACTIONS(4519),
    [anon_sym_BANG] = ACTIONS(4521),
    [anon_sym_TILDE] = ACTIONS(4521),
    [sym_constant] = ACTIONS(4523),
    [sym_identifier] = ACTIONS(4523),
    [sym_instance_variable] = ACTIONS(4525),
    [sym_class_variable] = ACTIONS(4525),
    [sym_global_variable] = ACTIONS(4525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(4523),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4523),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [5119] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(7597),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2672),
    [sym_scope_resolution] = STATE(2670),
    [sym_call] = STATE(2670),
    [sym_method_call] = STATE(2672),
    [sym_assignment] = STATE(7597),
    [sym_operator_assignment] = STATE(7597),
    [sym_conditional] = STATE(7597),
    [sym_range] = STATE(7597),
    [sym_binary] = STATE(7597),
    [sym_unary] = STATE(7597),
    [sym_left_assignment_list] = STATE(2671),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2672),
    [sym__variable] = STATE(2670),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2672),
    [sym_false] = STATE(2672),
    [sym_nil] = STATE(2672),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2673),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(4505),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(4507),
    [anon_sym_yield] = ACTIONS(4509),
    [anon_sym_break] = ACTIONS(4511),
    [anon_sym_next] = ACTIONS(4513),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(4515),
    [anon_sym_defined_QMARK] = ACTIONS(4517),
    [anon_sym_not] = ACTIONS(4519),
    [anon_sym_BANG] = ACTIONS(4521),
    [anon_sym_TILDE] = ACTIONS(4521),
    [sym_constant] = ACTIONS(4523),
    [sym_identifier] = ACTIONS(4523),
    [sym_instance_variable] = ACTIONS(4525),
    [sym_class_variable] = ACTIONS(4525),
    [sym_global_variable] = ACTIONS(4525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(4523),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4523),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [5120] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(7598),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2672),
    [sym_scope_resolution] = STATE(2670),
    [sym_call] = STATE(2670),
    [sym_method_call] = STATE(2672),
    [sym_splat_argument] = STATE(7599),
    [sym_assignment] = STATE(7598),
    [sym_operator_assignment] = STATE(7598),
    [sym_conditional] = STATE(7598),
    [sym_range] = STATE(7598),
    [sym_binary] = STATE(7598),
    [sym_unary] = STATE(7598),
    [sym_right_assignment_list] = STATE(6323),
    [sym__arg_or_splat_arg] = STATE(7599),
    [sym_left_assignment_list] = STATE(2671),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2672),
    [sym__variable] = STATE(2670),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2672),
    [sym_false] = STATE(2672),
    [sym_nil] = STATE(2672),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2673),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__splat_star] = ACTIONS(1785),
    [sym__unary_minus] = ACTIONS(4505),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(4507),
    [anon_sym_yield] = ACTIONS(4509),
    [anon_sym_break] = ACTIONS(4511),
    [anon_sym_next] = ACTIONS(4513),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(4515),
    [anon_sym_defined_QMARK] = ACTIONS(4517),
    [anon_sym_not] = ACTIONS(4519),
    [anon_sym_BANG] = ACTIONS(4521),
    [anon_sym_TILDE] = ACTIONS(4521),
    [sym_constant] = ACTIONS(4523),
    [sym_identifier] = ACTIONS(4523),
    [sym_instance_variable] = ACTIONS(4525),
    [sym_class_variable] = ACTIONS(4525),
    [sym_global_variable] = ACTIONS(4525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(4523),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4523),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [5121] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(7600),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2672),
    [sym_scope_resolution] = STATE(2670),
    [sym_call] = STATE(2670),
    [sym_method_call] = STATE(2672),
    [sym_assignment] = STATE(7600),
    [sym_operator_assignment] = STATE(7600),
    [sym_conditional] = STATE(7600),
    [sym_range] = STATE(7600),
    [sym_binary] = STATE(7600),
    [sym_unary] = STATE(7600),
    [sym_left_assignment_list] = STATE(2671),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2672),
    [sym__variable] = STATE(2670),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2672),
    [sym_false] = STATE(2672),
    [sym_nil] = STATE(2672),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2673),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(4505),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(4507),
    [anon_sym_yield] = ACTIONS(4509),
    [anon_sym_break] = ACTIONS(4511),
    [anon_sym_next] = ACTIONS(4513),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(4515),
    [anon_sym_defined_QMARK] = ACTIONS(4517),
    [anon_sym_not] = ACTIONS(4519),
    [anon_sym_BANG] = ACTIONS(4521),
    [anon_sym_TILDE] = ACTIONS(4521),
    [sym_constant] = ACTIONS(4523),
    [sym_identifier] = ACTIONS(4523),
    [sym_instance_variable] = ACTIONS(4525),
    [sym_class_variable] = ACTIONS(4525),
    [sym_global_variable] = ACTIONS(4525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(4523),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4523),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [5122] = {
    [sym_string] = STATE(7601),
    [aux_sym_chained_string_repeat1] = STATE(7601),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(2551),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2755),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_EQ] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_then] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_PLUS_EQ] = ACTIONS(2753),
    [anon_sym_DASH_EQ] = ACTIONS(2753),
    [anon_sym_STAR_EQ] = ACTIONS(2753),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2753),
    [anon_sym_SLASH_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2753),
    [anon_sym_AMP_EQ] = ACTIONS(2753),
    [anon_sym_PERCENT_EQ] = ACTIONS(2753),
    [anon_sym_GT_GT_EQ] = ACTIONS(2753),
    [anon_sym_LT_LT_EQ] = ACTIONS(2753),
    [anon_sym_CARET_EQ] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2755),
    [anon_sym_AMP_AMP] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2755),
    [anon_sym_GT_GT] = ACTIONS(2755),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_SLASH] = ACTIONS(2755),
    [anon_sym_PERCENT] = ACTIONS(2755),
    [sym_comment] = ACTIONS(87),
  },
  [5123] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(8108),
    [sym__binary_star] = ACTIONS(8110),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(8112),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(8114),
    [anon_sym_AMP] = ACTIONS(8116),
    [anon_sym_EQ] = ACTIONS(7822),
    [anon_sym_LT] = ACTIONS(8118),
    [anon_sym_if] = ACTIONS(6823),
    [anon_sym_unless] = ACTIONS(6823),
    [anon_sym_while] = ACTIONS(6823),
    [anon_sym_until] = ACTIONS(6823),
    [anon_sym_rescue] = ACTIONS(6823),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_then] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_PLUS_EQ] = ACTIONS(6823),
    [anon_sym_DASH_EQ] = ACTIONS(6823),
    [anon_sym_STAR_EQ] = ACTIONS(6823),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6823),
    [anon_sym_SLASH_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6823),
    [anon_sym_AMP_EQ] = ACTIONS(6823),
    [anon_sym_PERCENT_EQ] = ACTIONS(6823),
    [anon_sym_GT_GT_EQ] = ACTIONS(6823),
    [anon_sym_LT_LT_EQ] = ACTIONS(6823),
    [anon_sym_CARET_EQ] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(8120),
    [anon_sym_DOT_DOT] = ACTIONS(8122),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8124),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(8126),
    [anon_sym_AMP_AMP] = ACTIONS(8126),
    [anon_sym_LT_LT] = ACTIONS(8128),
    [anon_sym_GT_GT] = ACTIONS(8128),
    [anon_sym_EQ_EQ] = ACTIONS(8126),
    [anon_sym_BANG_EQ] = ACTIONS(8130),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8130),
    [anon_sym_LT_EQ_GT] = ACTIONS(8130),
    [anon_sym_EQ_TILDE] = ACTIONS(8130),
    [anon_sym_BANG_TILDE] = ACTIONS(8130),
    [anon_sym_LT_EQ] = ACTIONS(8118),
    [anon_sym_GT] = ACTIONS(8118),
    [anon_sym_GT_EQ] = ACTIONS(8132),
    [anon_sym_CARET] = ACTIONS(8112),
    [anon_sym_PLUS] = ACTIONS(8134),
    [anon_sym_SLASH] = ACTIONS(8114),
    [anon_sym_PERCENT] = ACTIONS(8114),
    [sym_comment] = ACTIONS(87),
  },
  [5124] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(8108),
    [sym__binary_star] = ACTIONS(8110),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(8112),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(8114),
    [anon_sym_AMP] = ACTIONS(8116),
    [anon_sym_EQ] = ACTIONS(7884),
    [anon_sym_LT] = ACTIONS(8118),
    [anon_sym_if] = ACTIONS(7027),
    [anon_sym_unless] = ACTIONS(7027),
    [anon_sym_while] = ACTIONS(7027),
    [anon_sym_until] = ACTIONS(7027),
    [anon_sym_rescue] = ACTIONS(7027),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_then] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_PLUS_EQ] = ACTIONS(7027),
    [anon_sym_DASH_EQ] = ACTIONS(7027),
    [anon_sym_STAR_EQ] = ACTIONS(7027),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7027),
    [anon_sym_SLASH_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7027),
    [anon_sym_AMP_EQ] = ACTIONS(7027),
    [anon_sym_PERCENT_EQ] = ACTIONS(7027),
    [anon_sym_GT_GT_EQ] = ACTIONS(7027),
    [anon_sym_LT_LT_EQ] = ACTIONS(7027),
    [anon_sym_CARET_EQ] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(8120),
    [anon_sym_DOT_DOT] = ACTIONS(8122),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8124),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(8126),
    [anon_sym_AMP_AMP] = ACTIONS(8126),
    [anon_sym_LT_LT] = ACTIONS(8128),
    [anon_sym_GT_GT] = ACTIONS(8128),
    [anon_sym_EQ_EQ] = ACTIONS(8126),
    [anon_sym_BANG_EQ] = ACTIONS(8130),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8130),
    [anon_sym_LT_EQ_GT] = ACTIONS(8130),
    [anon_sym_EQ_TILDE] = ACTIONS(8130),
    [anon_sym_BANG_TILDE] = ACTIONS(8130),
    [anon_sym_LT_EQ] = ACTIONS(8118),
    [anon_sym_GT] = ACTIONS(8118),
    [anon_sym_GT_EQ] = ACTIONS(8132),
    [anon_sym_CARET] = ACTIONS(8112),
    [anon_sym_PLUS] = ACTIONS(8134),
    [anon_sym_SLASH] = ACTIONS(8114),
    [anon_sym_PERCENT] = ACTIONS(8114),
    [sym_comment] = ACTIONS(87),
  },
  [5125] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(4539),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(4539),
    [anon_sym_PERCENT] = ACTIONS(4539),
    [sym_comment] = ACTIONS(87),
  },
  [5126] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(4539),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(5827),
    [anon_sym_PERCENT] = ACTIONS(5827),
    [sym_comment] = ACTIONS(87),
  },
  [5127] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4533),
    [sym__binary_star] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(4539),
    [anon_sym_AMP] = ACTIONS(4541),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(4553),
    [anon_sym_GT_GT] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(4559),
    [anon_sym_SLASH] = ACTIONS(4539),
    [anon_sym_PERCENT] = ACTIONS(4539),
    [sym_comment] = ACTIONS(87),
  },
  [5128] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4533),
    [sym__binary_star] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(4539),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(4553),
    [anon_sym_GT_GT] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(4559),
    [anon_sym_SLASH] = ACTIONS(4539),
    [anon_sym_PERCENT] = ACTIONS(4539),
    [sym_comment] = ACTIONS(87),
  },
  [5129] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4533),
    [sym__binary_star] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(4537),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(4539),
    [anon_sym_AMP] = ACTIONS(4541),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(4553),
    [anon_sym_GT_GT] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(4537),
    [anon_sym_PLUS] = ACTIONS(4559),
    [anon_sym_SLASH] = ACTIONS(4539),
    [anon_sym_PERCENT] = ACTIONS(4539),
    [sym_comment] = ACTIONS(87),
  },
  [5130] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(11163),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [5131] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(4533),
    [sym__binary_star] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(4537),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(4539),
    [anon_sym_AMP] = ACTIONS(4541),
    [anon_sym_EQ] = ACTIONS(7888),
    [anon_sym_LT] = ACTIONS(4543),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_then] = ACTIONS(5927),
    [anon_sym_EQ_GT] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_PLUS_EQ] = ACTIONS(5927),
    [anon_sym_DASH_EQ] = ACTIONS(5927),
    [anon_sym_STAR_EQ] = ACTIONS(5927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5927),
    [anon_sym_SLASH_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5927),
    [anon_sym_AMP_EQ] = ACTIONS(5927),
    [anon_sym_PERCENT_EQ] = ACTIONS(5927),
    [anon_sym_GT_GT_EQ] = ACTIONS(5927),
    [anon_sym_LT_LT_EQ] = ACTIONS(5927),
    [anon_sym_CARET_EQ] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(4547),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4549),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(4551),
    [anon_sym_AMP_AMP] = ACTIONS(4551),
    [anon_sym_LT_LT] = ACTIONS(4553),
    [anon_sym_GT_GT] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4551),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4555),
    [anon_sym_LT_EQ_GT] = ACTIONS(4555),
    [anon_sym_EQ_TILDE] = ACTIONS(4555),
    [anon_sym_BANG_TILDE] = ACTIONS(4555),
    [anon_sym_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT] = ACTIONS(4543),
    [anon_sym_GT_EQ] = ACTIONS(4557),
    [anon_sym_CARET] = ACTIONS(4537),
    [anon_sym_PLUS] = ACTIONS(4559),
    [anon_sym_SLASH] = ACTIONS(4539),
    [anon_sym_PERCENT] = ACTIONS(4539),
    [sym_comment] = ACTIONS(87),
  },
  [5132] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4533),
    [sym__binary_star] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(4537),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(4539),
    [anon_sym_AMP] = ACTIONS(4541),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(4543),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(4545),
    [anon_sym_DOT_DOT] = ACTIONS(4547),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4549),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(4551),
    [anon_sym_AMP_AMP] = ACTIONS(4551),
    [anon_sym_LT_LT] = ACTIONS(4553),
    [anon_sym_GT_GT] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4551),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4555),
    [anon_sym_LT_EQ_GT] = ACTIONS(4555),
    [anon_sym_EQ_TILDE] = ACTIONS(4555),
    [anon_sym_BANG_TILDE] = ACTIONS(4555),
    [anon_sym_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT] = ACTIONS(4543),
    [anon_sym_GT_EQ] = ACTIONS(4557),
    [anon_sym_CARET] = ACTIONS(4537),
    [anon_sym_PLUS] = ACTIONS(4559),
    [anon_sym_SLASH] = ACTIONS(4539),
    [anon_sym_PERCENT] = ACTIONS(4539),
    [sym_comment] = ACTIONS(87),
  },
  [5133] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4533),
    [sym__binary_star] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(4537),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(4539),
    [anon_sym_AMP] = ACTIONS(4541),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(4543),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(4553),
    [anon_sym_GT_GT] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4551),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4555),
    [anon_sym_LT_EQ_GT] = ACTIONS(4555),
    [anon_sym_EQ_TILDE] = ACTIONS(4555),
    [anon_sym_BANG_TILDE] = ACTIONS(4555),
    [anon_sym_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT] = ACTIONS(4543),
    [anon_sym_GT_EQ] = ACTIONS(4557),
    [anon_sym_CARET] = ACTIONS(4537),
    [anon_sym_PLUS] = ACTIONS(4559),
    [anon_sym_SLASH] = ACTIONS(4539),
    [anon_sym_PERCENT] = ACTIONS(4539),
    [sym_comment] = ACTIONS(87),
  },
  [5134] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4533),
    [sym__binary_star] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(4539),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(4559),
    [anon_sym_SLASH] = ACTIONS(4539),
    [anon_sym_PERCENT] = ACTIONS(4539),
    [sym_comment] = ACTIONS(87),
  },
  [5135] = {
    [sym_heredoc_body] = STATE(5135),
    [aux_sym_call_repeat1] = STATE(5135),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(9846),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7919),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_EQ] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_then] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_PLUS_EQ] = ACTIONS(7914),
    [anon_sym_DASH_EQ] = ACTIONS(7914),
    [anon_sym_STAR_EQ] = ACTIONS(7914),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7914),
    [anon_sym_SLASH_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7914),
    [anon_sym_AMP_EQ] = ACTIONS(7914),
    [anon_sym_PERCENT_EQ] = ACTIONS(7914),
    [anon_sym_GT_GT_EQ] = ACTIONS(7914),
    [anon_sym_LT_LT_EQ] = ACTIONS(7914),
    [anon_sym_CARET_EQ] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7919),
    [anon_sym_AMP_AMP] = ACTIONS(7919),
    [anon_sym_LT_LT] = ACTIONS(7919),
    [anon_sym_GT_GT] = ACTIONS(7919),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7919),
    [anon_sym_PLUS] = ACTIONS(7919),
    [anon_sym_SLASH] = ACTIONS(7919),
    [anon_sym_PERCENT] = ACTIONS(7919),
    [sym_comment] = ACTIONS(87),
  },
  [5136] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(1002),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym__argument] = STATE(6393),
    [sym_splat_argument] = STATE(6393),
    [sym_hash_splat_argument] = STATE(6393),
    [sym_block_argument] = STATE(6393),
    [sym_assignment] = STATE(1002),
    [sym_operator_assignment] = STATE(1002),
    [sym_conditional] = STATE(1002),
    [sym_range] = STATE(1002),
    [sym_binary] = STATE(1002),
    [sym_unary] = STATE(1002),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(1008),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(6393),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(1783),
    [sym__splat_star] = ACTIONS(1785),
    [sym__unary_minus] = ACTIONS(1787),
    [sym__identifier_hash_key] = ACTIONS(1789),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(8142),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1791),
    [anon_sym_yield] = ACTIONS(1793),
    [anon_sym_break] = ACTIONS(1795),
    [anon_sym_next] = ACTIONS(1797),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(4527),
    [anon_sym_defined_QMARK] = ACTIONS(1799),
    [anon_sym_not] = ACTIONS(1801),
    [anon_sym_BANG] = ACTIONS(1805),
    [anon_sym_TILDE] = ACTIONS(1805),
    [sym_constant] = ACTIONS(1807),
    [sym_identifier] = ACTIONS(1807),
    [sym_instance_variable] = ACTIONS(1809),
    [sym_class_variable] = ACTIONS(1809),
    [sym_global_variable] = ACTIONS(1809),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1811),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1811),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5137] = {
    [sym_heredoc_body] = STATE(5135),
    [aux_sym_call_repeat1] = STATE(5135),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7931),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_EQ] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_then] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_PLUS_EQ] = ACTIONS(7929),
    [anon_sym_DASH_EQ] = ACTIONS(7929),
    [anon_sym_STAR_EQ] = ACTIONS(7929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7929),
    [anon_sym_SLASH_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7929),
    [anon_sym_AMP_EQ] = ACTIONS(7929),
    [anon_sym_PERCENT_EQ] = ACTIONS(7929),
    [anon_sym_GT_GT_EQ] = ACTIONS(7929),
    [anon_sym_LT_LT_EQ] = ACTIONS(7929),
    [anon_sym_CARET_EQ] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7931),
    [anon_sym_AMP_AMP] = ACTIONS(7931),
    [anon_sym_LT_LT] = ACTIONS(7931),
    [anon_sym_GT_GT] = ACTIONS(7931),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7931),
    [anon_sym_PLUS] = ACTIONS(7931),
    [anon_sym_SLASH] = ACTIONS(7931),
    [anon_sym_PERCENT] = ACTIONS(7931),
    [sym_comment] = ACTIONS(87),
  },
  [5138] = {
    [aux_sym_argument_list_repeat1] = STATE(5138),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(11165),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7927),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_EQ] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_if] = ACTIONS(7925),
    [anon_sym_unless] = ACTIONS(7925),
    [anon_sym_while] = ACTIONS(7925),
    [anon_sym_until] = ACTIONS(7925),
    [anon_sym_rescue] = ACTIONS(7925),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_then] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_PLUS_EQ] = ACTIONS(7925),
    [anon_sym_DASH_EQ] = ACTIONS(7925),
    [anon_sym_STAR_EQ] = ACTIONS(7925),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7925),
    [anon_sym_SLASH_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7925),
    [anon_sym_AMP_EQ] = ACTIONS(7925),
    [anon_sym_PERCENT_EQ] = ACTIONS(7925),
    [anon_sym_GT_GT_EQ] = ACTIONS(7925),
    [anon_sym_LT_LT_EQ] = ACTIONS(7925),
    [anon_sym_CARET_EQ] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7927),
    [anon_sym_AMP_AMP] = ACTIONS(7927),
    [anon_sym_LT_LT] = ACTIONS(7927),
    [anon_sym_GT_GT] = ACTIONS(7927),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7927),
    [anon_sym_PLUS] = ACTIONS(7927),
    [anon_sym_SLASH] = ACTIONS(7927),
    [anon_sym_PERCENT] = ACTIONS(7927),
    [sym_comment] = ACTIONS(87),
  },
  [5139] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(4533),
    [sym__binary_star] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(4537),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(4539),
    [anon_sym_AMP] = ACTIONS(4541),
    [anon_sym_EQ] = ACTIONS(7936),
    [anon_sym_LT] = ACTIONS(4543),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_then] = ACTIONS(5115),
    [anon_sym_EQ_GT] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_PLUS_EQ] = ACTIONS(5115),
    [anon_sym_DASH_EQ] = ACTIONS(5115),
    [anon_sym_STAR_EQ] = ACTIONS(5115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5115),
    [anon_sym_SLASH_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5115),
    [anon_sym_AMP_EQ] = ACTIONS(5115),
    [anon_sym_PERCENT_EQ] = ACTIONS(5115),
    [anon_sym_GT_GT_EQ] = ACTIONS(5115),
    [anon_sym_LT_LT_EQ] = ACTIONS(5115),
    [anon_sym_CARET_EQ] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(4545),
    [anon_sym_DOT_DOT] = ACTIONS(4547),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4549),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(4551),
    [anon_sym_AMP_AMP] = ACTIONS(4551),
    [anon_sym_LT_LT] = ACTIONS(4553),
    [anon_sym_GT_GT] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4551),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4555),
    [anon_sym_LT_EQ_GT] = ACTIONS(4555),
    [anon_sym_EQ_TILDE] = ACTIONS(4555),
    [anon_sym_BANG_TILDE] = ACTIONS(4555),
    [anon_sym_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT] = ACTIONS(4543),
    [anon_sym_GT_EQ] = ACTIONS(4557),
    [anon_sym_CARET] = ACTIONS(4537),
    [anon_sym_PLUS] = ACTIONS(4559),
    [anon_sym_SLASH] = ACTIONS(4539),
    [anon_sym_PERCENT] = ACTIONS(4539),
    [sym_comment] = ACTIONS(87),
  },
  [5140] = {
    [aux_sym_exceptions_repeat1] = STATE(7604),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6193),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_then] = ACTIONS(6191),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_PLUS_EQ] = ACTIONS(6191),
    [anon_sym_DASH_EQ] = ACTIONS(6191),
    [anon_sym_STAR_EQ] = ACTIONS(6191),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6191),
    [anon_sym_SLASH_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6191),
    [anon_sym_AMP_EQ] = ACTIONS(6191),
    [anon_sym_PERCENT_EQ] = ACTIONS(6191),
    [anon_sym_GT_GT_EQ] = ACTIONS(6191),
    [anon_sym_LT_LT_EQ] = ACTIONS(6191),
    [anon_sym_CARET_EQ] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6193),
    [anon_sym_AMP_AMP] = ACTIONS(6193),
    [anon_sym_LT_LT] = ACTIONS(6193),
    [anon_sym_GT_GT] = ACTIONS(6193),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6193),
    [anon_sym_PLUS] = ACTIONS(6193),
    [anon_sym_SLASH] = ACTIONS(6193),
    [anon_sym_PERCENT] = ACTIONS(6193),
    [sym_comment] = ACTIONS(87),
  },
  [5141] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(4533),
    [sym__binary_star] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(4537),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(4539),
    [anon_sym_AMP] = ACTIONS(4541),
    [anon_sym_EQ] = ACTIONS(7938),
    [anon_sym_LT] = ACTIONS(4543),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_then] = ACTIONS(6210),
    [anon_sym_EQ_GT] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_PLUS_EQ] = ACTIONS(6210),
    [anon_sym_DASH_EQ] = ACTIONS(6210),
    [anon_sym_STAR_EQ] = ACTIONS(6210),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6210),
    [anon_sym_SLASH_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6210),
    [anon_sym_AMP_EQ] = ACTIONS(6210),
    [anon_sym_PERCENT_EQ] = ACTIONS(6210),
    [anon_sym_GT_GT_EQ] = ACTIONS(6210),
    [anon_sym_LT_LT_EQ] = ACTIONS(6210),
    [anon_sym_CARET_EQ] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(4545),
    [anon_sym_DOT_DOT] = ACTIONS(4547),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4549),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(4551),
    [anon_sym_AMP_AMP] = ACTIONS(4551),
    [anon_sym_LT_LT] = ACTIONS(4553),
    [anon_sym_GT_GT] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4551),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4555),
    [anon_sym_LT_EQ_GT] = ACTIONS(4555),
    [anon_sym_EQ_TILDE] = ACTIONS(4555),
    [anon_sym_BANG_TILDE] = ACTIONS(4555),
    [anon_sym_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT] = ACTIONS(4543),
    [anon_sym_GT_EQ] = ACTIONS(4557),
    [anon_sym_CARET] = ACTIONS(4537),
    [anon_sym_PLUS] = ACTIONS(4559),
    [anon_sym_SLASH] = ACTIONS(4539),
    [anon_sym_PERCENT] = ACTIONS(4539),
    [sym_comment] = ACTIONS(87),
  },
  [5142] = {
    [sym_string] = STATE(5142),
    [aux_sym_chained_string_repeat1] = STATE(5142),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(9852),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6217),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_EQ] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_do] = ACTIONS(6212),
    [anon_sym_then] = ACTIONS(6212),
    [anon_sym_EQ_GT] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_PLUS_EQ] = ACTIONS(6212),
    [anon_sym_DASH_EQ] = ACTIONS(6212),
    [anon_sym_STAR_EQ] = ACTIONS(6212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6212),
    [anon_sym_SLASH_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6212),
    [anon_sym_AMP_EQ] = ACTIONS(6212),
    [anon_sym_PERCENT_EQ] = ACTIONS(6212),
    [anon_sym_GT_GT_EQ] = ACTIONS(6212),
    [anon_sym_LT_LT_EQ] = ACTIONS(6212),
    [anon_sym_CARET_EQ] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6217),
    [anon_sym_AMP_AMP] = ACTIONS(6217),
    [anon_sym_LT_LT] = ACTIONS(6217),
    [anon_sym_GT_GT] = ACTIONS(6217),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6217),
    [anon_sym_PLUS] = ACTIONS(6217),
    [anon_sym_SLASH] = ACTIONS(6217),
    [anon_sym_PERCENT] = ACTIONS(6217),
    [sym_comment] = ACTIONS(87),
  },
  [5143] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(8144),
    [sym__binary_star] = ACTIONS(8146),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(8148),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(8146),
    [anon_sym_AMP] = ACTIONS(8150),
    [anon_sym_LT] = ACTIONS(8152),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_then] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(8154),
    [anon_sym_DOT_DOT] = ACTIONS(8156),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8158),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(8160),
    [anon_sym_AMP_AMP] = ACTIONS(8160),
    [anon_sym_LT_LT] = ACTIONS(8162),
    [anon_sym_GT_GT] = ACTIONS(8162),
    [anon_sym_EQ_EQ] = ACTIONS(8164),
    [anon_sym_BANG_EQ] = ACTIONS(8160),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8160),
    [anon_sym_LT_EQ_GT] = ACTIONS(8160),
    [anon_sym_EQ_TILDE] = ACTIONS(8160),
    [anon_sym_BANG_TILDE] = ACTIONS(8160),
    [anon_sym_LT_EQ] = ACTIONS(8152),
    [anon_sym_GT] = ACTIONS(8152),
    [anon_sym_GT_EQ] = ACTIONS(8166),
    [anon_sym_CARET] = ACTIONS(8168),
    [anon_sym_PLUS] = ACTIONS(8144),
    [anon_sym_SLASH] = ACTIONS(8146),
    [anon_sym_PERCENT] = ACTIONS(8146),
    [sym_comment] = ACTIONS(87),
  },
  [5144] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8146),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [5145] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(8144),
    [sym__binary_star] = ACTIONS(8146),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(8148),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8146),
    [anon_sym_AMP] = ACTIONS(8150),
    [anon_sym_LT] = ACTIONS(8152),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(8154),
    [anon_sym_DOT_DOT] = ACTIONS(8156),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8158),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(8160),
    [anon_sym_AMP_AMP] = ACTIONS(8160),
    [anon_sym_LT_LT] = ACTIONS(8162),
    [anon_sym_GT_GT] = ACTIONS(8162),
    [anon_sym_EQ_EQ] = ACTIONS(8164),
    [anon_sym_BANG_EQ] = ACTIONS(8160),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8160),
    [anon_sym_LT_EQ_GT] = ACTIONS(8160),
    [anon_sym_EQ_TILDE] = ACTIONS(8160),
    [anon_sym_BANG_TILDE] = ACTIONS(8160),
    [anon_sym_LT_EQ] = ACTIONS(8152),
    [anon_sym_GT] = ACTIONS(8152),
    [anon_sym_GT_EQ] = ACTIONS(8166),
    [anon_sym_CARET] = ACTIONS(8168),
    [anon_sym_PLUS] = ACTIONS(8144),
    [anon_sym_SLASH] = ACTIONS(8146),
    [anon_sym_PERCENT] = ACTIONS(8146),
    [sym_comment] = ACTIONS(87),
  },
  [5146] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7605),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2704),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2704),
    [sym_assignment] = STATE(7605),
    [sym_operator_assignment] = STATE(7605),
    [sym_conditional] = STATE(7605),
    [sym_range] = STATE(7605),
    [sym_binary] = STATE(7605),
    [sym_unary] = STATE(7605),
    [sym_left_assignment_list] = STATE(2703),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2704),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2704),
    [sym_false] = STATE(2704),
    [sym_nil] = STATE(2704),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2584),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4573),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4393),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_break] = ACTIONS(4397),
    [anon_sym_next] = ACTIONS(4399),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4575),
    [anon_sym_defined_QMARK] = ACTIONS(4577),
    [anon_sym_not] = ACTIONS(4579),
    [anon_sym_BANG] = ACTIONS(4581),
    [anon_sym_TILDE] = ACTIONS(4581),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5147] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7606),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2704),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2704),
    [sym_assignment] = STATE(7606),
    [sym_operator_assignment] = STATE(7606),
    [sym_conditional] = STATE(7606),
    [sym_range] = STATE(7606),
    [sym_binary] = STATE(7606),
    [sym_unary] = STATE(7606),
    [sym_left_assignment_list] = STATE(2703),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2704),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2704),
    [sym_false] = STATE(2704),
    [sym_nil] = STATE(2704),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2584),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4573),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4393),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_break] = ACTIONS(4397),
    [anon_sym_next] = ACTIONS(4399),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4575),
    [anon_sym_defined_QMARK] = ACTIONS(4577),
    [anon_sym_not] = ACTIONS(4579),
    [anon_sym_BANG] = ACTIONS(4581),
    [anon_sym_TILDE] = ACTIONS(4581),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5148] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7607),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2704),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2704),
    [sym_assignment] = STATE(7607),
    [sym_operator_assignment] = STATE(7607),
    [sym_conditional] = STATE(7607),
    [sym_range] = STATE(7607),
    [sym_binary] = STATE(7607),
    [sym_unary] = STATE(7607),
    [sym_left_assignment_list] = STATE(2703),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2704),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2704),
    [sym_false] = STATE(2704),
    [sym_nil] = STATE(2704),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2584),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4573),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4393),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_break] = ACTIONS(4397),
    [anon_sym_next] = ACTIONS(4399),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4575),
    [anon_sym_defined_QMARK] = ACTIONS(4577),
    [anon_sym_not] = ACTIONS(4579),
    [anon_sym_BANG] = ACTIONS(4581),
    [anon_sym_TILDE] = ACTIONS(4581),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5149] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7608),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2704),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2704),
    [sym_assignment] = STATE(7608),
    [sym_operator_assignment] = STATE(7608),
    [sym_conditional] = STATE(7608),
    [sym_range] = STATE(7608),
    [sym_binary] = STATE(7608),
    [sym_unary] = STATE(7608),
    [sym_left_assignment_list] = STATE(2703),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2704),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2704),
    [sym_false] = STATE(2704),
    [sym_nil] = STATE(2704),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2584),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4573),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4393),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_break] = ACTIONS(4397),
    [anon_sym_next] = ACTIONS(4399),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4575),
    [anon_sym_defined_QMARK] = ACTIONS(4577),
    [anon_sym_not] = ACTIONS(4579),
    [anon_sym_BANG] = ACTIONS(4581),
    [anon_sym_TILDE] = ACTIONS(4581),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5150] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7609),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2704),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2704),
    [sym_assignment] = STATE(7609),
    [sym_operator_assignment] = STATE(7609),
    [sym_conditional] = STATE(7609),
    [sym_range] = STATE(7609),
    [sym_binary] = STATE(7609),
    [sym_unary] = STATE(7609),
    [sym_left_assignment_list] = STATE(2703),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2704),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2704),
    [sym_false] = STATE(2704),
    [sym_nil] = STATE(2704),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2584),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4573),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4393),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_break] = ACTIONS(4397),
    [anon_sym_next] = ACTIONS(4399),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4575),
    [anon_sym_defined_QMARK] = ACTIONS(4577),
    [anon_sym_not] = ACTIONS(4579),
    [anon_sym_BANG] = ACTIONS(4581),
    [anon_sym_TILDE] = ACTIONS(4581),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5151] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(7610),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(7610),
    [sym_operator_assignment] = STATE(7610),
    [sym_conditional] = STATE(7610),
    [sym_range] = STATE(7610),
    [sym_binary] = STATE(7610),
    [sym_unary] = STATE(7610),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5152] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7611),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2704),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2704),
    [sym_assignment] = STATE(7611),
    [sym_operator_assignment] = STATE(7611),
    [sym_conditional] = STATE(7611),
    [sym_range] = STATE(7611),
    [sym_binary] = STATE(7611),
    [sym_unary] = STATE(7611),
    [sym_left_assignment_list] = STATE(2703),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2704),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2704),
    [sym_false] = STATE(2704),
    [sym_nil] = STATE(2704),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2584),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4573),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4393),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_break] = ACTIONS(4397),
    [anon_sym_next] = ACTIONS(4399),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4575),
    [anon_sym_defined_QMARK] = ACTIONS(4577),
    [anon_sym_not] = ACTIONS(4579),
    [anon_sym_BANG] = ACTIONS(4581),
    [anon_sym_TILDE] = ACTIONS(4581),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5153] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7612),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2704),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2704),
    [sym_assignment] = STATE(7612),
    [sym_operator_assignment] = STATE(7612),
    [sym_conditional] = STATE(7612),
    [sym_range] = STATE(7612),
    [sym_binary] = STATE(7612),
    [sym_unary] = STATE(7612),
    [sym_left_assignment_list] = STATE(2703),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2704),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2704),
    [sym_false] = STATE(2704),
    [sym_nil] = STATE(2704),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2584),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4573),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4393),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_break] = ACTIONS(4397),
    [anon_sym_next] = ACTIONS(4399),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4575),
    [anon_sym_defined_QMARK] = ACTIONS(4577),
    [anon_sym_not] = ACTIONS(4579),
    [anon_sym_BANG] = ACTIONS(4581),
    [anon_sym_TILDE] = ACTIONS(4581),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5154] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7613),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2704),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2704),
    [sym_assignment] = STATE(7613),
    [sym_operator_assignment] = STATE(7613),
    [sym_conditional] = STATE(7613),
    [sym_range] = STATE(7613),
    [sym_binary] = STATE(7613),
    [sym_unary] = STATE(7613),
    [sym_left_assignment_list] = STATE(2703),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2704),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2704),
    [sym_false] = STATE(2704),
    [sym_nil] = STATE(2704),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2584),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4573),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4393),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_break] = ACTIONS(4397),
    [anon_sym_next] = ACTIONS(4399),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4575),
    [anon_sym_defined_QMARK] = ACTIONS(4577),
    [anon_sym_not] = ACTIONS(4579),
    [anon_sym_BANG] = ACTIONS(4581),
    [anon_sym_TILDE] = ACTIONS(4581),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5155] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7614),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2704),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2704),
    [sym_assignment] = STATE(7614),
    [sym_operator_assignment] = STATE(7614),
    [sym_conditional] = STATE(7614),
    [sym_range] = STATE(7614),
    [sym_binary] = STATE(7614),
    [sym_unary] = STATE(7614),
    [sym_left_assignment_list] = STATE(2703),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2704),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2704),
    [sym_false] = STATE(2704),
    [sym_nil] = STATE(2704),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2584),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4573),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4393),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_break] = ACTIONS(4397),
    [anon_sym_next] = ACTIONS(4399),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4575),
    [anon_sym_defined_QMARK] = ACTIONS(4577),
    [anon_sym_not] = ACTIONS(4579),
    [anon_sym_BANG] = ACTIONS(4581),
    [anon_sym_TILDE] = ACTIONS(4581),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5156] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2701),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2704),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2704),
    [sym_splat_argument] = STATE(6406),
    [sym_assignment] = STATE(2701),
    [sym_operator_assignment] = STATE(2701),
    [sym_conditional] = STATE(2701),
    [sym_range] = STATE(2701),
    [sym_binary] = STATE(2701),
    [sym_unary] = STATE(2701),
    [sym__arg_or_splat_arg] = STATE(6406),
    [sym_left_assignment_list] = STATE(2703),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2704),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2704),
    [sym_false] = STATE(2704),
    [sym_nil] = STATE(2704),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2584),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(4571),
    [sym__unary_minus] = ACTIONS(4573),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4393),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_break] = ACTIONS(4397),
    [anon_sym_next] = ACTIONS(4399),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4575),
    [anon_sym_defined_QMARK] = ACTIONS(4577),
    [anon_sym_not] = ACTIONS(4579),
    [anon_sym_BANG] = ACTIONS(4581),
    [anon_sym_TILDE] = ACTIONS(4581),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5157] = {
    [aux_sym_exceptions_repeat1] = STATE(7615),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_COMMA] = ACTIONS(8170),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_then] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [5158] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2701),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2704),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2704),
    [sym_splat_argument] = STATE(7616),
    [sym_assignment] = STATE(2701),
    [sym_operator_assignment] = STATE(2701),
    [sym_conditional] = STATE(2701),
    [sym_range] = STATE(2701),
    [sym_binary] = STATE(2701),
    [sym_unary] = STATE(2701),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(7616),
    [sym_left_assignment_list] = STATE(2703),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2704),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2704),
    [sym_false] = STATE(2704),
    [sym_nil] = STATE(2704),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2584),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(4571),
    [sym__unary_minus] = ACTIONS(4573),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4393),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_break] = ACTIONS(4397),
    [anon_sym_next] = ACTIONS(4399),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4575),
    [anon_sym_defined_QMARK] = ACTIONS(4577),
    [anon_sym_not] = ACTIONS(4579),
    [anon_sym_BANG] = ACTIONS(4581),
    [anon_sym_TILDE] = ACTIONS(4581),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5159] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7617),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2704),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2704),
    [sym_assignment] = STATE(7617),
    [sym_operator_assignment] = STATE(7617),
    [sym_conditional] = STATE(7617),
    [sym_range] = STATE(7617),
    [sym_binary] = STATE(7617),
    [sym_unary] = STATE(7617),
    [sym_left_assignment_list] = STATE(2703),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2704),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2704),
    [sym_false] = STATE(2704),
    [sym_nil] = STATE(2704),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2584),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4573),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4393),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_break] = ACTIONS(4397),
    [anon_sym_next] = ACTIONS(4399),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4575),
    [anon_sym_defined_QMARK] = ACTIONS(4577),
    [anon_sym_not] = ACTIONS(4579),
    [anon_sym_BANG] = ACTIONS(4581),
    [anon_sym_TILDE] = ACTIONS(4581),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5160] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8222),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [5161] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7625),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7627),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(7627),
    [sym_assignment] = STATE(7625),
    [sym_operator_assignment] = STATE(7625),
    [sym_conditional] = STATE(7625),
    [sym_range] = STATE(7625),
    [sym_binary] = STATE(7625),
    [sym_unary] = STATE(7625),
    [sym_left_assignment_list] = STATE(7626),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7627),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7627),
    [sym_false] = STATE(7627),
    [sym_nil] = STATE(7627),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7628),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11168),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11170),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_break] = ACTIONS(11174),
    [anon_sym_next] = ACTIONS(11176),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11178),
    [anon_sym_defined_QMARK] = ACTIONS(11180),
    [anon_sym_not] = ACTIONS(11182),
    [anon_sym_BANG] = ACTIONS(11184),
    [anon_sym_TILDE] = ACTIONS(11184),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5162] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7629),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7627),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(7627),
    [sym_assignment] = STATE(7629),
    [sym_operator_assignment] = STATE(7629),
    [sym_conditional] = STATE(7629),
    [sym_range] = STATE(7629),
    [sym_binary] = STATE(7629),
    [sym_unary] = STATE(7629),
    [sym_left_assignment_list] = STATE(7626),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7627),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7627),
    [sym_false] = STATE(7627),
    [sym_nil] = STATE(7627),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7628),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11168),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11170),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_break] = ACTIONS(11174),
    [anon_sym_next] = ACTIONS(11176),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11178),
    [anon_sym_defined_QMARK] = ACTIONS(11180),
    [anon_sym_not] = ACTIONS(11182),
    [anon_sym_BANG] = ACTIONS(11184),
    [anon_sym_TILDE] = ACTIONS(11184),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5163] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7630),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5178),
    [sym_scope_resolution] = STATE(5174),
    [sym_call] = STATE(5174),
    [sym_method_call] = STATE(5178),
    [sym_assignment] = STATE(7630),
    [sym_operator_assignment] = STATE(7630),
    [sym_conditional] = STATE(7630),
    [sym_range] = STATE(7630),
    [sym_binary] = STATE(7630),
    [sym_unary] = STATE(7630),
    [sym_left_assignment_list] = STATE(5177),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5178),
    [sym__variable] = STATE(5174),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5178),
    [sym_false] = STATE(5178),
    [sym_nil] = STATE(5178),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7631),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8186),
    [anon_sym_yield] = ACTIONS(8188),
    [anon_sym_break] = ACTIONS(8190),
    [anon_sym_next] = ACTIONS(8192),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11186),
    [anon_sym_defined_QMARK] = ACTIONS(8194),
    [anon_sym_not] = ACTIONS(8196),
    [anon_sym_BANG] = ACTIONS(8200),
    [anon_sym_TILDE] = ACTIONS(8200),
    [sym_constant] = ACTIONS(8206),
    [sym_identifier] = ACTIONS(8206),
    [sym_instance_variable] = ACTIONS(8204),
    [sym_class_variable] = ACTIONS(8204),
    [sym_global_variable] = ACTIONS(8204),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8206),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8206),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5164] = {
    [anon_sym_COLON] = ACTIONS(11188),
    [sym_comment] = ACTIONS(87),
  },
  [5165] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7633),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7627),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(7627),
    [sym_assignment] = STATE(7633),
    [sym_operator_assignment] = STATE(7633),
    [sym_conditional] = STATE(7633),
    [sym_range] = STATE(7633),
    [sym_binary] = STATE(7633),
    [sym_unary] = STATE(7633),
    [sym_left_assignment_list] = STATE(7626),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7627),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7627),
    [sym_false] = STATE(7627),
    [sym_nil] = STATE(7627),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7628),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11168),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11170),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_break] = ACTIONS(11174),
    [anon_sym_next] = ACTIONS(11176),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11178),
    [anon_sym_defined_QMARK] = ACTIONS(11180),
    [anon_sym_not] = ACTIONS(11182),
    [anon_sym_BANG] = ACTIONS(11184),
    [anon_sym_TILDE] = ACTIONS(11184),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5166] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7639),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5178),
    [sym_scope_resolution] = STATE(5174),
    [sym_call] = STATE(5174),
    [sym_method_call] = STATE(5178),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(7640),
    [sym__argument] = STATE(7641),
    [sym_splat_argument] = STATE(7641),
    [sym_hash_splat_argument] = STATE(7641),
    [sym_block_argument] = STATE(7641),
    [sym_assignment] = STATE(7639),
    [sym_operator_assignment] = STATE(7639),
    [sym_conditional] = STATE(7639),
    [sym_range] = STATE(7639),
    [sym_binary] = STATE(7639),
    [sym_unary] = STATE(7639),
    [sym_left_assignment_list] = STATE(5177),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5178),
    [sym__variable] = STATE(5174),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5178),
    [sym_false] = STATE(5178),
    [sym_nil] = STATE(5178),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7642),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(7641),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(11190),
    [sym__splat_star] = ACTIONS(11192),
    [sym__unary_minus] = ACTIONS(8182),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(11194),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(8186),
    [anon_sym_yield] = ACTIONS(8188),
    [anon_sym_break] = ACTIONS(8190),
    [anon_sym_next] = ACTIONS(8192),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(377),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(8194),
    [anon_sym_not] = ACTIONS(8196),
    [anon_sym_BANG] = ACTIONS(8198),
    [anon_sym_TILDE] = ACTIONS(8200),
    [sym_constant] = ACTIONS(11196),
    [sym_identifier] = ACTIONS(11196),
    [sym_instance_variable] = ACTIONS(8204),
    [sym_class_variable] = ACTIONS(8204),
    [sym_global_variable] = ACTIONS(8204),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8206),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8206),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5167] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7639),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5178),
    [sym_scope_resolution] = STATE(5174),
    [sym_call] = STATE(5174),
    [sym_method_call] = STATE(5178),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(7640),
    [sym__argument] = STATE(7641),
    [sym_splat_argument] = STATE(7641),
    [sym_hash_splat_argument] = STATE(7641),
    [sym_block_argument] = STATE(7641),
    [sym_assignment] = STATE(7639),
    [sym_operator_assignment] = STATE(7639),
    [sym_conditional] = STATE(7639),
    [sym_range] = STATE(7639),
    [sym_binary] = STATE(7639),
    [sym_unary] = STATE(7639),
    [sym_left_assignment_list] = STATE(5177),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5178),
    [sym__variable] = STATE(5174),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5178),
    [sym_false] = STATE(5178),
    [sym_nil] = STATE(5178),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7642),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(7641),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(11190),
    [sym__splat_star] = ACTIONS(11192),
    [sym__unary_minus] = ACTIONS(8182),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(11194),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(8186),
    [anon_sym_yield] = ACTIONS(8188),
    [anon_sym_break] = ACTIONS(8190),
    [anon_sym_next] = ACTIONS(8192),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(419),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(8194),
    [anon_sym_not] = ACTIONS(8196),
    [anon_sym_BANG] = ACTIONS(8198),
    [anon_sym_TILDE] = ACTIONS(8200),
    [sym_constant] = ACTIONS(11196),
    [sym_identifier] = ACTIONS(11196),
    [sym_instance_variable] = ACTIONS(8204),
    [sym_class_variable] = ACTIONS(8204),
    [sym_global_variable] = ACTIONS(8204),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8206),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8206),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5168] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7639),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5178),
    [sym_scope_resolution] = STATE(5174),
    [sym_call] = STATE(5174),
    [sym_method_call] = STATE(5178),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(7640),
    [sym__argument] = STATE(7641),
    [sym_splat_argument] = STATE(7641),
    [sym_hash_splat_argument] = STATE(7641),
    [sym_block_argument] = STATE(7641),
    [sym_assignment] = STATE(7639),
    [sym_operator_assignment] = STATE(7639),
    [sym_conditional] = STATE(7639),
    [sym_range] = STATE(7639),
    [sym_binary] = STATE(7639),
    [sym_unary] = STATE(7639),
    [sym_left_assignment_list] = STATE(5177),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5178),
    [sym__variable] = STATE(5174),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5178),
    [sym_false] = STATE(5178),
    [sym_nil] = STATE(5178),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7642),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(7641),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(11190),
    [sym__splat_star] = ACTIONS(11192),
    [sym__unary_minus] = ACTIONS(8182),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(11194),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(423),
    [anon_sym_return] = ACTIONS(8186),
    [anon_sym_yield] = ACTIONS(8188),
    [anon_sym_break] = ACTIONS(8190),
    [anon_sym_next] = ACTIONS(8192),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(423),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(8194),
    [anon_sym_not] = ACTIONS(8196),
    [anon_sym_BANG] = ACTIONS(8198),
    [anon_sym_TILDE] = ACTIONS(8200),
    [sym_constant] = ACTIONS(11196),
    [sym_identifier] = ACTIONS(11196),
    [sym_instance_variable] = ACTIONS(8204),
    [sym_class_variable] = ACTIONS(8204),
    [sym_global_variable] = ACTIONS(8204),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8206),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8206),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5169] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7639),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5178),
    [sym_scope_resolution] = STATE(5174),
    [sym_call] = STATE(5174),
    [sym_method_call] = STATE(5178),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(7640),
    [sym__argument] = STATE(7641),
    [sym_splat_argument] = STATE(7641),
    [sym_hash_splat_argument] = STATE(7641),
    [sym_block_argument] = STATE(7641),
    [sym_assignment] = STATE(7639),
    [sym_operator_assignment] = STATE(7639),
    [sym_conditional] = STATE(7639),
    [sym_range] = STATE(7639),
    [sym_binary] = STATE(7639),
    [sym_unary] = STATE(7639),
    [sym_left_assignment_list] = STATE(5177),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5178),
    [sym__variable] = STATE(5174),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5178),
    [sym_false] = STATE(5178),
    [sym_nil] = STATE(5178),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7642),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(7641),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(11190),
    [sym__splat_star] = ACTIONS(11192),
    [sym__unary_minus] = ACTIONS(8182),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(11194),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(427),
    [anon_sym_return] = ACTIONS(8186),
    [anon_sym_yield] = ACTIONS(8188),
    [anon_sym_break] = ACTIONS(8190),
    [anon_sym_next] = ACTIONS(8192),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(427),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(8194),
    [anon_sym_not] = ACTIONS(8196),
    [anon_sym_BANG] = ACTIONS(8198),
    [anon_sym_TILDE] = ACTIONS(8200),
    [sym_constant] = ACTIONS(11196),
    [sym_identifier] = ACTIONS(11196),
    [sym_instance_variable] = ACTIONS(8204),
    [sym_class_variable] = ACTIONS(8204),
    [sym_global_variable] = ACTIONS(8204),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8206),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8206),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5170] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7643),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5178),
    [sym_scope_resolution] = STATE(5174),
    [sym_call] = STATE(5174),
    [sym_method_call] = STATE(5178),
    [sym_assignment] = STATE(7643),
    [sym_operator_assignment] = STATE(7643),
    [sym_conditional] = STATE(7643),
    [sym_range] = STATE(7643),
    [sym_binary] = STATE(7643),
    [sym_unary] = STATE(7643),
    [sym_left_assignment_list] = STATE(5177),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5178),
    [sym__variable] = STATE(5174),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5178),
    [sym_false] = STATE(5178),
    [sym_nil] = STATE(5178),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7631),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8186),
    [anon_sym_yield] = ACTIONS(8188),
    [anon_sym_break] = ACTIONS(8190),
    [anon_sym_next] = ACTIONS(8192),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11186),
    [anon_sym_defined_QMARK] = ACTIONS(8194),
    [anon_sym_not] = ACTIONS(8196),
    [anon_sym_BANG] = ACTIONS(8200),
    [anon_sym_TILDE] = ACTIONS(8200),
    [sym_constant] = ACTIONS(8206),
    [sym_identifier] = ACTIONS(8206),
    [sym_instance_variable] = ACTIONS(8204),
    [sym_class_variable] = ACTIONS(8204),
    [sym_global_variable] = ACTIONS(8204),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8206),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8206),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5171] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5178),
    [sym_scope_resolution] = STATE(5174),
    [sym_call] = STATE(5174),
    [sym_method_call] = STATE(5178),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(5177),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5178),
    [sym__variable] = STATE(5174),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5178),
    [sym_false] = STATE(5178),
    [sym_nil] = STATE(5178),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7631),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8186),
    [anon_sym_yield] = ACTIONS(8188),
    [anon_sym_break] = ACTIONS(8190),
    [anon_sym_next] = ACTIONS(8192),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11186),
    [anon_sym_defined_QMARK] = ACTIONS(8194),
    [anon_sym_not] = ACTIONS(8196),
    [anon_sym_BANG] = ACTIONS(8200),
    [anon_sym_TILDE] = ACTIONS(8200),
    [sym_constant] = ACTIONS(8206),
    [sym_identifier] = ACTIONS(8206),
    [sym_instance_variable] = ACTIONS(8204),
    [sym_class_variable] = ACTIONS(8204),
    [sym_global_variable] = ACTIONS(8204),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8206),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8206),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5172] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(11198),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_else] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [5173] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(11200),
    [sym__binary_star] = ACTIONS(11202),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(11204),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(11202),
    [anon_sym_AMP] = ACTIONS(11206),
    [anon_sym_LT] = ACTIONS(11208),
    [anon_sym_end] = ACTIONS(1625),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_unless] = ACTIONS(1625),
    [anon_sym_while] = ACTIONS(1625),
    [anon_sym_until] = ACTIONS(1625),
    [anon_sym_rescue] = ACTIONS(1625),
    [anon_sym_else] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(11188),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(11210),
    [anon_sym_DOT_DOT] = ACTIONS(11212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11214),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(11216),
    [anon_sym_AMP_AMP] = ACTIONS(11216),
    [anon_sym_LT_LT] = ACTIONS(11218),
    [anon_sym_GT_GT] = ACTIONS(11218),
    [anon_sym_EQ_EQ] = ACTIONS(11220),
    [anon_sym_BANG_EQ] = ACTIONS(11216),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11216),
    [anon_sym_LT_EQ_GT] = ACTIONS(11216),
    [anon_sym_EQ_TILDE] = ACTIONS(11216),
    [anon_sym_BANG_TILDE] = ACTIONS(11216),
    [anon_sym_LT_EQ] = ACTIONS(11208),
    [anon_sym_GT] = ACTIONS(11208),
    [anon_sym_GT_EQ] = ACTIONS(11222),
    [anon_sym_CARET] = ACTIONS(11224),
    [anon_sym_PLUS] = ACTIONS(11200),
    [anon_sym_SLASH] = ACTIONS(11202),
    [anon_sym_PERCENT] = ACTIONS(11202),
    [sym_comment] = ACTIONS(87),
  },
  [5174] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(7660),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5214),
    [sym_scope_resolution] = STATE(5210),
    [sym_call] = STATE(5210),
    [sym_method_call] = STATE(5214),
    [sym_argument_list] = STATE(938),
    [sym__argument_list_with_parens] = STATE(7661),
    [sym__argument] = STATE(7662),
    [sym_splat_argument] = STATE(7662),
    [sym_hash_splat_argument] = STATE(7662),
    [sym_block_argument] = STATE(7662),
    [sym_do_block] = STATE(941),
    [sym_block] = STATE(941),
    [sym_assignment] = STATE(7660),
    [sym_operator_assignment] = STATE(7660),
    [sym_conditional] = STATE(7660),
    [sym_range] = STATE(7660),
    [sym_binary] = STATE(7660),
    [sym_unary] = STATE(7660),
    [sym_left_assignment_list] = STATE(5213),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5214),
    [sym__variable] = STATE(5210),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5214),
    [sym_false] = STATE(5214),
    [sym_nil] = STATE(5214),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7663),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(7662),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(743),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(11226),
    [sym__splat_star] = ACTIONS(11228),
    [sym__unary_minus] = ACTIONS(8252),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(11230),
    [anon_sym_LBRACE] = ACTIONS(1669),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(769),
    [anon_sym_return] = ACTIONS(8256),
    [anon_sym_yield] = ACTIONS(8258),
    [anon_sym_break] = ACTIONS(8260),
    [anon_sym_next] = ACTIONS(8262),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(769),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(769),
    [anon_sym_until] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(769),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(1671),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_else] = ACTIONS(769),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(8264),
    [anon_sym_not] = ACTIONS(8266),
    [anon_sym_BANG] = ACTIONS(8268),
    [anon_sym_TILDE] = ACTIONS(8270),
    [sym_constant] = ACTIONS(11232),
    [sym_identifier] = ACTIONS(11232),
    [sym_instance_variable] = ACTIONS(8274),
    [sym_class_variable] = ACTIONS(8274),
    [sym_global_variable] = ACTIONS(8274),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8276),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8276),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5175] = {
    [sym_heredoc_body] = STATE(7664),
    [aux_sym_call_repeat1] = STATE(7664),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_else] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [5176] = {
    [sym_heredoc_body] = STATE(7664),
    [aux_sym_call_repeat1] = STATE(7664),
    [aux_sym_argument_list_repeat1] = STATE(7666),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(11234),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_else] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [5177] = {
    [anon_sym_EQ] = ACTIONS(11236),
    [sym_comment] = ACTIONS(87),
  },
  [5178] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(11238),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(11240),
    [anon_sym_DASH_EQ] = ACTIONS(11240),
    [anon_sym_STAR_EQ] = ACTIONS(11240),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11240),
    [anon_sym_SLASH_EQ] = ACTIONS(11240),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11240),
    [anon_sym_PIPE_EQ] = ACTIONS(11240),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11240),
    [anon_sym_AMP_EQ] = ACTIONS(11240),
    [anon_sym_PERCENT_EQ] = ACTIONS(11240),
    [anon_sym_GT_GT_EQ] = ACTIONS(11240),
    [anon_sym_LT_LT_EQ] = ACTIONS(11240),
    [anon_sym_CARET_EQ] = ACTIONS(11240),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5179] = {
    [sym_string] = STATE(7669),
    [aux_sym_chained_string_repeat1] = STATE(7669),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(11242),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [5180] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(8220),
    [sym__binary_star] = ACTIONS(8222),
    [anon_sym_PIPE] = ACTIONS(8224),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8222),
    [anon_sym_AMP] = ACTIONS(8226),
    [anon_sym_LT] = ACTIONS(8228),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(8230),
    [anon_sym_DOT_DOT] = ACTIONS(8232),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8234),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(8238),
    [anon_sym_AMP_AMP] = ACTIONS(8238),
    [anon_sym_LT_LT] = ACTIONS(8240),
    [anon_sym_GT_GT] = ACTIONS(8240),
    [anon_sym_EQ_EQ] = ACTIONS(8242),
    [anon_sym_BANG_EQ] = ACTIONS(8238),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8238),
    [anon_sym_LT_EQ_GT] = ACTIONS(8238),
    [anon_sym_EQ_TILDE] = ACTIONS(8238),
    [anon_sym_BANG_TILDE] = ACTIONS(8238),
    [anon_sym_LT_EQ] = ACTIONS(8228),
    [anon_sym_GT] = ACTIONS(8228),
    [anon_sym_GT_EQ] = ACTIONS(8244),
    [anon_sym_CARET] = ACTIONS(8246),
    [anon_sym_PLUS] = ACTIONS(8220),
    [anon_sym_SLASH] = ACTIONS(8222),
    [anon_sym_PERCENT] = ACTIONS(8222),
    [sym_comment] = ACTIONS(87),
  },
  [5181] = {
    [aux_sym_undef_repeat1] = STATE(7670),
    [sym__line_break] = ACTIONS(2251),
    [sym__heredoc_body_start] = ACTIONS(2251),
    [anon_sym_COMMA] = ACTIONS(2253),
    [anon_sym_SEMI] = ACTIONS(2251),
    [anon_sym_end] = ACTIONS(2251),
    [anon_sym_if] = ACTIONS(2251),
    [anon_sym_unless] = ACTIONS(2251),
    [anon_sym_while] = ACTIONS(2251),
    [anon_sym_until] = ACTIONS(2251),
    [anon_sym_rescue] = ACTIONS(2251),
    [anon_sym_else] = ACTIONS(2251),
    [sym_comment] = ACTIONS(87),
  },
  [5182] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7671),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2719),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(2719),
    [sym_assignment] = STATE(7671),
    [sym_operator_assignment] = STATE(7671),
    [sym_conditional] = STATE(7671),
    [sym_range] = STATE(7671),
    [sym_binary] = STATE(7671),
    [sym_unary] = STATE(7671),
    [sym_left_assignment_list] = STATE(2718),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2719),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2719),
    [sym_false] = STATE(2719),
    [sym_nil] = STATE(2719),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2720),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4583),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4585),
    [anon_sym_yield] = ACTIONS(4587),
    [anon_sym_break] = ACTIONS(4589),
    [anon_sym_next] = ACTIONS(4591),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4593),
    [anon_sym_defined_QMARK] = ACTIONS(4595),
    [anon_sym_not] = ACTIONS(4597),
    [anon_sym_BANG] = ACTIONS(4599),
    [anon_sym_TILDE] = ACTIONS(4599),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5183] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7672),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2719),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(2719),
    [sym_assignment] = STATE(7672),
    [sym_operator_assignment] = STATE(7672),
    [sym_conditional] = STATE(7672),
    [sym_range] = STATE(7672),
    [sym_binary] = STATE(7672),
    [sym_unary] = STATE(7672),
    [sym_left_assignment_list] = STATE(2718),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2719),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2719),
    [sym_false] = STATE(2719),
    [sym_nil] = STATE(2719),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2720),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4583),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4585),
    [anon_sym_yield] = ACTIONS(4587),
    [anon_sym_break] = ACTIONS(4589),
    [anon_sym_next] = ACTIONS(4591),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4593),
    [anon_sym_defined_QMARK] = ACTIONS(4595),
    [anon_sym_not] = ACTIONS(4597),
    [anon_sym_BANG] = ACTIONS(4599),
    [anon_sym_TILDE] = ACTIONS(4599),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5184] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7673),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2719),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(2719),
    [sym_assignment] = STATE(7673),
    [sym_operator_assignment] = STATE(7673),
    [sym_conditional] = STATE(7673),
    [sym_range] = STATE(7673),
    [sym_binary] = STATE(7673),
    [sym_unary] = STATE(7673),
    [sym_left_assignment_list] = STATE(2718),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2719),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2719),
    [sym_false] = STATE(2719),
    [sym_nil] = STATE(2719),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2720),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4583),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4585),
    [anon_sym_yield] = ACTIONS(4587),
    [anon_sym_break] = ACTIONS(4589),
    [anon_sym_next] = ACTIONS(4591),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4593),
    [anon_sym_defined_QMARK] = ACTIONS(4595),
    [anon_sym_not] = ACTIONS(4597),
    [anon_sym_BANG] = ACTIONS(4599),
    [anon_sym_TILDE] = ACTIONS(4599),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5185] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7674),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2719),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(2719),
    [sym_assignment] = STATE(7674),
    [sym_operator_assignment] = STATE(7674),
    [sym_conditional] = STATE(7674),
    [sym_range] = STATE(7674),
    [sym_binary] = STATE(7674),
    [sym_unary] = STATE(7674),
    [sym_left_assignment_list] = STATE(2718),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2719),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2719),
    [sym_false] = STATE(2719),
    [sym_nil] = STATE(2719),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2720),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4583),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4585),
    [anon_sym_yield] = ACTIONS(4587),
    [anon_sym_break] = ACTIONS(4589),
    [anon_sym_next] = ACTIONS(4591),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4593),
    [anon_sym_defined_QMARK] = ACTIONS(4595),
    [anon_sym_not] = ACTIONS(4597),
    [anon_sym_BANG] = ACTIONS(4599),
    [anon_sym_TILDE] = ACTIONS(4599),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5186] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7675),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2719),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(2719),
    [sym_assignment] = STATE(7675),
    [sym_operator_assignment] = STATE(7675),
    [sym_conditional] = STATE(7675),
    [sym_range] = STATE(7675),
    [sym_binary] = STATE(7675),
    [sym_unary] = STATE(7675),
    [sym_left_assignment_list] = STATE(2718),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2719),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2719),
    [sym_false] = STATE(2719),
    [sym_nil] = STATE(2719),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2720),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4583),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4585),
    [anon_sym_yield] = ACTIONS(4587),
    [anon_sym_break] = ACTIONS(4589),
    [anon_sym_next] = ACTIONS(4591),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4593),
    [anon_sym_defined_QMARK] = ACTIONS(4595),
    [anon_sym_not] = ACTIONS(4597),
    [anon_sym_BANG] = ACTIONS(4599),
    [anon_sym_TILDE] = ACTIONS(4599),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5187] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7676),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2719),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(2719),
    [sym_assignment] = STATE(7676),
    [sym_operator_assignment] = STATE(7676),
    [sym_conditional] = STATE(7676),
    [sym_range] = STATE(7676),
    [sym_binary] = STATE(7676),
    [sym_unary] = STATE(7676),
    [sym_left_assignment_list] = STATE(2718),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2719),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2719),
    [sym_false] = STATE(2719),
    [sym_nil] = STATE(2719),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2720),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4583),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4585),
    [anon_sym_yield] = ACTIONS(4587),
    [anon_sym_break] = ACTIONS(4589),
    [anon_sym_next] = ACTIONS(4591),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4593),
    [anon_sym_defined_QMARK] = ACTIONS(4595),
    [anon_sym_not] = ACTIONS(4597),
    [anon_sym_BANG] = ACTIONS(4599),
    [anon_sym_TILDE] = ACTIONS(4599),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5188] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7677),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2719),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(2719),
    [sym_assignment] = STATE(7677),
    [sym_operator_assignment] = STATE(7677),
    [sym_conditional] = STATE(7677),
    [sym_range] = STATE(7677),
    [sym_binary] = STATE(7677),
    [sym_unary] = STATE(7677),
    [sym_left_assignment_list] = STATE(2718),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2719),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2719),
    [sym_false] = STATE(2719),
    [sym_nil] = STATE(2719),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2720),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4583),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4585),
    [anon_sym_yield] = ACTIONS(4587),
    [anon_sym_break] = ACTIONS(4589),
    [anon_sym_next] = ACTIONS(4591),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4593),
    [anon_sym_defined_QMARK] = ACTIONS(4595),
    [anon_sym_not] = ACTIONS(4597),
    [anon_sym_BANG] = ACTIONS(4599),
    [anon_sym_TILDE] = ACTIONS(4599),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5189] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7678),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2719),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(2719),
    [sym_assignment] = STATE(7678),
    [sym_operator_assignment] = STATE(7678),
    [sym_conditional] = STATE(7678),
    [sym_range] = STATE(7678),
    [sym_binary] = STATE(7678),
    [sym_unary] = STATE(7678),
    [sym_left_assignment_list] = STATE(2718),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2719),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2719),
    [sym_false] = STATE(2719),
    [sym_nil] = STATE(2719),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2720),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4583),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4585),
    [anon_sym_yield] = ACTIONS(4587),
    [anon_sym_break] = ACTIONS(4589),
    [anon_sym_next] = ACTIONS(4591),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4593),
    [anon_sym_defined_QMARK] = ACTIONS(4595),
    [anon_sym_not] = ACTIONS(4597),
    [anon_sym_BANG] = ACTIONS(4599),
    [anon_sym_TILDE] = ACTIONS(4599),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5190] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7679),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2719),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(2719),
    [sym_assignment] = STATE(7679),
    [sym_operator_assignment] = STATE(7679),
    [sym_conditional] = STATE(7679),
    [sym_range] = STATE(7679),
    [sym_binary] = STATE(7679),
    [sym_unary] = STATE(7679),
    [sym_left_assignment_list] = STATE(2718),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2719),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2719),
    [sym_false] = STATE(2719),
    [sym_nil] = STATE(2719),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2720),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4583),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4585),
    [anon_sym_yield] = ACTIONS(4587),
    [anon_sym_break] = ACTIONS(4589),
    [anon_sym_next] = ACTIONS(4591),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4593),
    [anon_sym_defined_QMARK] = ACTIONS(4595),
    [anon_sym_not] = ACTIONS(4597),
    [anon_sym_BANG] = ACTIONS(4599),
    [anon_sym_TILDE] = ACTIONS(4599),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5191] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7680),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2719),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(2719),
    [sym_assignment] = STATE(7680),
    [sym_operator_assignment] = STATE(7680),
    [sym_conditional] = STATE(7680),
    [sym_range] = STATE(7680),
    [sym_binary] = STATE(7680),
    [sym_unary] = STATE(7680),
    [sym_left_assignment_list] = STATE(2718),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2719),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2719),
    [sym_false] = STATE(2719),
    [sym_nil] = STATE(2719),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2720),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4583),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4585),
    [anon_sym_yield] = ACTIONS(4587),
    [anon_sym_break] = ACTIONS(4589),
    [anon_sym_next] = ACTIONS(4591),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4593),
    [anon_sym_defined_QMARK] = ACTIONS(4595),
    [anon_sym_not] = ACTIONS(4597),
    [anon_sym_BANG] = ACTIONS(4599),
    [anon_sym_TILDE] = ACTIONS(4599),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5192] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(7681),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(7681),
    [sym_operator_assignment] = STATE(7681),
    [sym_conditional] = STATE(7681),
    [sym_range] = STATE(7681),
    [sym_binary] = STATE(7681),
    [sym_unary] = STATE(7681),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5193] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7682),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2719),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(2719),
    [sym_assignment] = STATE(7682),
    [sym_operator_assignment] = STATE(7682),
    [sym_conditional] = STATE(7682),
    [sym_range] = STATE(7682),
    [sym_binary] = STATE(7682),
    [sym_unary] = STATE(7682),
    [sym_left_assignment_list] = STATE(2718),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2719),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2719),
    [sym_false] = STATE(2719),
    [sym_nil] = STATE(2719),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2720),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4583),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4585),
    [anon_sym_yield] = ACTIONS(4587),
    [anon_sym_break] = ACTIONS(4589),
    [anon_sym_next] = ACTIONS(4591),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4593),
    [anon_sym_defined_QMARK] = ACTIONS(4595),
    [anon_sym_not] = ACTIONS(4597),
    [anon_sym_BANG] = ACTIONS(4599),
    [anon_sym_TILDE] = ACTIONS(4599),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5194] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7683),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2719),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(2719),
    [sym_assignment] = STATE(7683),
    [sym_operator_assignment] = STATE(7683),
    [sym_conditional] = STATE(7683),
    [sym_range] = STATE(7683),
    [sym_binary] = STATE(7683),
    [sym_unary] = STATE(7683),
    [sym_left_assignment_list] = STATE(2718),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2719),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2719),
    [sym_false] = STATE(2719),
    [sym_nil] = STATE(2719),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2720),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4583),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4585),
    [anon_sym_yield] = ACTIONS(4587),
    [anon_sym_break] = ACTIONS(4589),
    [anon_sym_next] = ACTIONS(4591),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4593),
    [anon_sym_defined_QMARK] = ACTIONS(4595),
    [anon_sym_not] = ACTIONS(4597),
    [anon_sym_BANG] = ACTIONS(4599),
    [anon_sym_TILDE] = ACTIONS(4599),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5195] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7684),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2719),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(2719),
    [sym_assignment] = STATE(7684),
    [sym_operator_assignment] = STATE(7684),
    [sym_conditional] = STATE(7684),
    [sym_range] = STATE(7684),
    [sym_binary] = STATE(7684),
    [sym_unary] = STATE(7684),
    [sym_left_assignment_list] = STATE(2718),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2719),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2719),
    [sym_false] = STATE(2719),
    [sym_nil] = STATE(2719),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2720),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4583),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4585),
    [anon_sym_yield] = ACTIONS(4587),
    [anon_sym_break] = ACTIONS(4589),
    [anon_sym_next] = ACTIONS(4591),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4593),
    [anon_sym_defined_QMARK] = ACTIONS(4595),
    [anon_sym_not] = ACTIONS(4597),
    [anon_sym_BANG] = ACTIONS(4599),
    [anon_sym_TILDE] = ACTIONS(4599),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5196] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7685),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2719),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(2719),
    [sym_assignment] = STATE(7685),
    [sym_operator_assignment] = STATE(7685),
    [sym_conditional] = STATE(7685),
    [sym_range] = STATE(7685),
    [sym_binary] = STATE(7685),
    [sym_unary] = STATE(7685),
    [sym_left_assignment_list] = STATE(2718),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2719),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2719),
    [sym_false] = STATE(2719),
    [sym_nil] = STATE(2719),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2720),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4583),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4585),
    [anon_sym_yield] = ACTIONS(4587),
    [anon_sym_break] = ACTIONS(4589),
    [anon_sym_next] = ACTIONS(4591),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4593),
    [anon_sym_defined_QMARK] = ACTIONS(4595),
    [anon_sym_not] = ACTIONS(4597),
    [anon_sym_BANG] = ACTIONS(4599),
    [anon_sym_TILDE] = ACTIONS(4599),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5197] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(7693),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7696),
    [sym_scope_resolution] = STATE(7694),
    [sym_call] = STATE(7694),
    [sym_method_call] = STATE(7696),
    [sym_assignment] = STATE(7693),
    [sym_operator_assignment] = STATE(7693),
    [sym_conditional] = STATE(7693),
    [sym_range] = STATE(7693),
    [sym_binary] = STATE(7693),
    [sym_unary] = STATE(7693),
    [sym_left_assignment_list] = STATE(7695),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7696),
    [sym__variable] = STATE(7694),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7696),
    [sym_false] = STATE(7696),
    [sym_nil] = STATE(7696),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7697),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11244),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11246),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_break] = ACTIONS(11250),
    [anon_sym_next] = ACTIONS(11252),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11254),
    [anon_sym_defined_QMARK] = ACTIONS(11256),
    [anon_sym_not] = ACTIONS(11258),
    [anon_sym_BANG] = ACTIONS(11260),
    [anon_sym_TILDE] = ACTIONS(11260),
    [sym_constant] = ACTIONS(11262),
    [sym_identifier] = ACTIONS(11262),
    [sym_instance_variable] = ACTIONS(11264),
    [sym_class_variable] = ACTIONS(11264),
    [sym_global_variable] = ACTIONS(11264),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11262),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11262),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [5198] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(7698),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7696),
    [sym_scope_resolution] = STATE(7694),
    [sym_call] = STATE(7694),
    [sym_method_call] = STATE(7696),
    [sym_assignment] = STATE(7698),
    [sym_operator_assignment] = STATE(7698),
    [sym_conditional] = STATE(7698),
    [sym_range] = STATE(7698),
    [sym_binary] = STATE(7698),
    [sym_unary] = STATE(7698),
    [sym_left_assignment_list] = STATE(7695),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7696),
    [sym__variable] = STATE(7694),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7696),
    [sym_false] = STATE(7696),
    [sym_nil] = STATE(7696),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7697),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11244),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11246),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_break] = ACTIONS(11250),
    [anon_sym_next] = ACTIONS(11252),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11254),
    [anon_sym_defined_QMARK] = ACTIONS(11256),
    [anon_sym_not] = ACTIONS(11258),
    [anon_sym_BANG] = ACTIONS(11260),
    [anon_sym_TILDE] = ACTIONS(11260),
    [sym_constant] = ACTIONS(11262),
    [sym_identifier] = ACTIONS(11262),
    [sym_instance_variable] = ACTIONS(11264),
    [sym_class_variable] = ACTIONS(11264),
    [sym_global_variable] = ACTIONS(11264),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11262),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11262),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [5199] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(7699),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5214),
    [sym_scope_resolution] = STATE(5210),
    [sym_call] = STATE(5210),
    [sym_method_call] = STATE(5214),
    [sym_assignment] = STATE(7699),
    [sym_operator_assignment] = STATE(7699),
    [sym_conditional] = STATE(7699),
    [sym_range] = STATE(7699),
    [sym_binary] = STATE(7699),
    [sym_unary] = STATE(7699),
    [sym_left_assignment_list] = STATE(5213),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5214),
    [sym__variable] = STATE(5210),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5214),
    [sym_false] = STATE(5214),
    [sym_nil] = STATE(5214),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7700),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(8252),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(8256),
    [anon_sym_yield] = ACTIONS(8258),
    [anon_sym_break] = ACTIONS(8260),
    [anon_sym_next] = ACTIONS(8262),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(11266),
    [anon_sym_defined_QMARK] = ACTIONS(8264),
    [anon_sym_not] = ACTIONS(8266),
    [anon_sym_BANG] = ACTIONS(8270),
    [anon_sym_TILDE] = ACTIONS(8270),
    [sym_constant] = ACTIONS(8276),
    [sym_identifier] = ACTIONS(8276),
    [sym_instance_variable] = ACTIONS(8274),
    [sym_class_variable] = ACTIONS(8274),
    [sym_global_variable] = ACTIONS(8274),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8276),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8276),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5200] = {
    [anon_sym_COLON] = ACTIONS(11268),
    [sym_comment] = ACTIONS(87),
  },
  [5201] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(7702),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7696),
    [sym_scope_resolution] = STATE(7694),
    [sym_call] = STATE(7694),
    [sym_method_call] = STATE(7696),
    [sym_assignment] = STATE(7702),
    [sym_operator_assignment] = STATE(7702),
    [sym_conditional] = STATE(7702),
    [sym_range] = STATE(7702),
    [sym_binary] = STATE(7702),
    [sym_unary] = STATE(7702),
    [sym_left_assignment_list] = STATE(7695),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7696),
    [sym__variable] = STATE(7694),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7696),
    [sym_false] = STATE(7696),
    [sym_nil] = STATE(7696),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7697),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11244),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11246),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_break] = ACTIONS(11250),
    [anon_sym_next] = ACTIONS(11252),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11254),
    [anon_sym_defined_QMARK] = ACTIONS(11256),
    [anon_sym_not] = ACTIONS(11258),
    [anon_sym_BANG] = ACTIONS(11260),
    [anon_sym_TILDE] = ACTIONS(11260),
    [sym_constant] = ACTIONS(11262),
    [sym_identifier] = ACTIONS(11262),
    [sym_instance_variable] = ACTIONS(11264),
    [sym_class_variable] = ACTIONS(11264),
    [sym_global_variable] = ACTIONS(11264),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11262),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11262),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [5202] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(7660),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5214),
    [sym_scope_resolution] = STATE(5210),
    [sym_call] = STATE(5210),
    [sym_method_call] = STATE(5214),
    [sym_argument_list] = STATE(1535),
    [sym__argument_list_with_parens] = STATE(7661),
    [sym__argument] = STATE(7662),
    [sym_splat_argument] = STATE(7662),
    [sym_hash_splat_argument] = STATE(7662),
    [sym_block_argument] = STATE(7662),
    [sym_assignment] = STATE(7660),
    [sym_operator_assignment] = STATE(7660),
    [sym_conditional] = STATE(7660),
    [sym_range] = STATE(7660),
    [sym_binary] = STATE(7660),
    [sym_unary] = STATE(7660),
    [sym_left_assignment_list] = STATE(5213),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5214),
    [sym__variable] = STATE(5210),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5214),
    [sym_false] = STATE(5214),
    [sym_nil] = STATE(5214),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7663),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(7662),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(11226),
    [sym__splat_star] = ACTIONS(11228),
    [sym__unary_minus] = ACTIONS(8252),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(11230),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(8256),
    [anon_sym_yield] = ACTIONS(8258),
    [anon_sym_break] = ACTIONS(8260),
    [anon_sym_next] = ACTIONS(8262),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_else] = ACTIONS(377),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(365),
    [anon_sym_DASH_EQ] = ACTIONS(365),
    [anon_sym_STAR_EQ] = ACTIONS(365),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(365),
    [anon_sym_SLASH_EQ] = ACTIONS(365),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(365),
    [anon_sym_PIPE_EQ] = ACTIONS(365),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(365),
    [anon_sym_AMP_EQ] = ACTIONS(365),
    [anon_sym_PERCENT_EQ] = ACTIONS(365),
    [anon_sym_GT_GT_EQ] = ACTIONS(365),
    [anon_sym_LT_LT_EQ] = ACTIONS(365),
    [anon_sym_CARET_EQ] = ACTIONS(365),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_PERCENT] = ACTIONS(377),
    [anon_sym_defined_QMARK] = ACTIONS(8264),
    [anon_sym_not] = ACTIONS(8266),
    [anon_sym_BANG] = ACTIONS(8268),
    [anon_sym_TILDE] = ACTIONS(8270),
    [sym_constant] = ACTIONS(11232),
    [sym_identifier] = ACTIONS(11232),
    [sym_instance_variable] = ACTIONS(8274),
    [sym_class_variable] = ACTIONS(8274),
    [sym_global_variable] = ACTIONS(8274),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8276),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8276),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5203] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(7660),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5214),
    [sym_scope_resolution] = STATE(5210),
    [sym_call] = STATE(5210),
    [sym_method_call] = STATE(5214),
    [sym_argument_list] = STATE(1536),
    [sym__argument_list_with_parens] = STATE(7661),
    [sym__argument] = STATE(7662),
    [sym_splat_argument] = STATE(7662),
    [sym_hash_splat_argument] = STATE(7662),
    [sym_block_argument] = STATE(7662),
    [sym_assignment] = STATE(7660),
    [sym_operator_assignment] = STATE(7660),
    [sym_conditional] = STATE(7660),
    [sym_range] = STATE(7660),
    [sym_binary] = STATE(7660),
    [sym_unary] = STATE(7660),
    [sym_left_assignment_list] = STATE(5213),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5214),
    [sym__variable] = STATE(5210),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5214),
    [sym_false] = STATE(5214),
    [sym_nil] = STATE(5214),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7663),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(7662),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(11226),
    [sym__splat_star] = ACTIONS(11228),
    [sym__unary_minus] = ACTIONS(8252),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(11230),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_EQ] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(8256),
    [anon_sym_yield] = ACTIONS(8258),
    [anon_sym_break] = ACTIONS(8260),
    [anon_sym_next] = ACTIONS(8262),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_else] = ACTIONS(419),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(417),
    [anon_sym_DASH_EQ] = ACTIONS(417),
    [anon_sym_STAR_EQ] = ACTIONS(417),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(417),
    [anon_sym_SLASH_EQ] = ACTIONS(417),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(417),
    [anon_sym_PIPE_EQ] = ACTIONS(417),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(417),
    [anon_sym_AMP_EQ] = ACTIONS(417),
    [anon_sym_PERCENT_EQ] = ACTIONS(417),
    [anon_sym_GT_GT_EQ] = ACTIONS(417),
    [anon_sym_LT_LT_EQ] = ACTIONS(417),
    [anon_sym_CARET_EQ] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(8264),
    [anon_sym_not] = ACTIONS(8266),
    [anon_sym_BANG] = ACTIONS(8268),
    [anon_sym_TILDE] = ACTIONS(8270),
    [sym_constant] = ACTIONS(11232),
    [sym_identifier] = ACTIONS(11232),
    [sym_instance_variable] = ACTIONS(8274),
    [sym_class_variable] = ACTIONS(8274),
    [sym_global_variable] = ACTIONS(8274),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8276),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8276),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5204] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(7660),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5214),
    [sym_scope_resolution] = STATE(5210),
    [sym_call] = STATE(5210),
    [sym_method_call] = STATE(5214),
    [sym_argument_list] = STATE(1537),
    [sym__argument_list_with_parens] = STATE(7661),
    [sym__argument] = STATE(7662),
    [sym_splat_argument] = STATE(7662),
    [sym_hash_splat_argument] = STATE(7662),
    [sym_block_argument] = STATE(7662),
    [sym_assignment] = STATE(7660),
    [sym_operator_assignment] = STATE(7660),
    [sym_conditional] = STATE(7660),
    [sym_range] = STATE(7660),
    [sym_binary] = STATE(7660),
    [sym_unary] = STATE(7660),
    [sym_left_assignment_list] = STATE(5213),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5214),
    [sym__variable] = STATE(5210),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5214),
    [sym_false] = STATE(5214),
    [sym_nil] = STATE(5214),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7663),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(7662),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(11226),
    [sym__splat_star] = ACTIONS(11228),
    [sym__unary_minus] = ACTIONS(8252),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(11230),
    [anon_sym_LBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_EQ] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(423),
    [anon_sym_return] = ACTIONS(8256),
    [anon_sym_yield] = ACTIONS(8258),
    [anon_sym_break] = ACTIONS(8260),
    [anon_sym_next] = ACTIONS(8262),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_else] = ACTIONS(423),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(421),
    [anon_sym_DASH_EQ] = ACTIONS(421),
    [anon_sym_STAR_EQ] = ACTIONS(421),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(421),
    [anon_sym_SLASH_EQ] = ACTIONS(421),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(421),
    [anon_sym_PIPE_EQ] = ACTIONS(421),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(421),
    [anon_sym_AMP_EQ] = ACTIONS(421),
    [anon_sym_PERCENT_EQ] = ACTIONS(421),
    [anon_sym_GT_GT_EQ] = ACTIONS(421),
    [anon_sym_LT_LT_EQ] = ACTIONS(421),
    [anon_sym_CARET_EQ] = ACTIONS(421),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(8264),
    [anon_sym_not] = ACTIONS(8266),
    [anon_sym_BANG] = ACTIONS(8268),
    [anon_sym_TILDE] = ACTIONS(8270),
    [sym_constant] = ACTIONS(11232),
    [sym_identifier] = ACTIONS(11232),
    [sym_instance_variable] = ACTIONS(8274),
    [sym_class_variable] = ACTIONS(8274),
    [sym_global_variable] = ACTIONS(8274),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8276),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8276),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5205] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(7660),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5214),
    [sym_scope_resolution] = STATE(5210),
    [sym_call] = STATE(5210),
    [sym_method_call] = STATE(5214),
    [sym_argument_list] = STATE(1538),
    [sym__argument_list_with_parens] = STATE(7661),
    [sym__argument] = STATE(7662),
    [sym_splat_argument] = STATE(7662),
    [sym_hash_splat_argument] = STATE(7662),
    [sym_block_argument] = STATE(7662),
    [sym_assignment] = STATE(7660),
    [sym_operator_assignment] = STATE(7660),
    [sym_conditional] = STATE(7660),
    [sym_range] = STATE(7660),
    [sym_binary] = STATE(7660),
    [sym_unary] = STATE(7660),
    [sym_left_assignment_list] = STATE(5213),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5214),
    [sym__variable] = STATE(5210),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5214),
    [sym_false] = STATE(5214),
    [sym_nil] = STATE(5214),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7663),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(7662),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(11226),
    [sym__splat_star] = ACTIONS(11228),
    [sym__unary_minus] = ACTIONS(8252),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(11230),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(427),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(427),
    [anon_sym_return] = ACTIONS(8256),
    [anon_sym_yield] = ACTIONS(8258),
    [anon_sym_break] = ACTIONS(8260),
    [anon_sym_next] = ACTIONS(8262),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_else] = ACTIONS(427),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(425),
    [anon_sym_DASH_EQ] = ACTIONS(425),
    [anon_sym_STAR_EQ] = ACTIONS(425),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(425),
    [anon_sym_SLASH_EQ] = ACTIONS(425),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(425),
    [anon_sym_PIPE_EQ] = ACTIONS(425),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(425),
    [anon_sym_AMP_EQ] = ACTIONS(425),
    [anon_sym_PERCENT_EQ] = ACTIONS(425),
    [anon_sym_GT_GT_EQ] = ACTIONS(425),
    [anon_sym_LT_LT_EQ] = ACTIONS(425),
    [anon_sym_CARET_EQ] = ACTIONS(425),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(8264),
    [anon_sym_not] = ACTIONS(8266),
    [anon_sym_BANG] = ACTIONS(8268),
    [anon_sym_TILDE] = ACTIONS(8270),
    [sym_constant] = ACTIONS(11232),
    [sym_identifier] = ACTIONS(11232),
    [sym_instance_variable] = ACTIONS(8274),
    [sym_class_variable] = ACTIONS(8274),
    [sym_global_variable] = ACTIONS(8274),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8276),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8276),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5206] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(7703),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5214),
    [sym_scope_resolution] = STATE(5210),
    [sym_call] = STATE(5210),
    [sym_method_call] = STATE(5214),
    [sym_assignment] = STATE(7703),
    [sym_operator_assignment] = STATE(7703),
    [sym_conditional] = STATE(7703),
    [sym_range] = STATE(7703),
    [sym_binary] = STATE(7703),
    [sym_unary] = STATE(7703),
    [sym_left_assignment_list] = STATE(5213),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5214),
    [sym__variable] = STATE(5210),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5214),
    [sym_false] = STATE(5214),
    [sym_nil] = STATE(5214),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7700),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(8252),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(8256),
    [anon_sym_yield] = ACTIONS(8258),
    [anon_sym_break] = ACTIONS(8260),
    [anon_sym_next] = ACTIONS(8262),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(11266),
    [anon_sym_defined_QMARK] = ACTIONS(8264),
    [anon_sym_not] = ACTIONS(8266),
    [anon_sym_BANG] = ACTIONS(8270),
    [anon_sym_TILDE] = ACTIONS(8270),
    [sym_constant] = ACTIONS(8276),
    [sym_identifier] = ACTIONS(8276),
    [sym_instance_variable] = ACTIONS(8274),
    [sym_class_variable] = ACTIONS(8274),
    [sym_global_variable] = ACTIONS(8274),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8276),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8276),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5207] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(1559),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5214),
    [sym_scope_resolution] = STATE(5210),
    [sym_call] = STATE(5210),
    [sym_method_call] = STATE(5214),
    [sym_assignment] = STATE(1559),
    [sym_operator_assignment] = STATE(1559),
    [sym_conditional] = STATE(1559),
    [sym_range] = STATE(1559),
    [sym_binary] = STATE(1559),
    [sym_unary] = STATE(1559),
    [sym_left_assignment_list] = STATE(5213),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5214),
    [sym__variable] = STATE(5210),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5214),
    [sym_false] = STATE(5214),
    [sym_nil] = STATE(5214),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7700),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(8252),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(8256),
    [anon_sym_yield] = ACTIONS(8258),
    [anon_sym_break] = ACTIONS(8260),
    [anon_sym_next] = ACTIONS(8262),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(11266),
    [anon_sym_defined_QMARK] = ACTIONS(8264),
    [anon_sym_not] = ACTIONS(8266),
    [anon_sym_BANG] = ACTIONS(8270),
    [anon_sym_TILDE] = ACTIONS(8270),
    [sym_constant] = ACTIONS(8276),
    [sym_identifier] = ACTIONS(8276),
    [sym_instance_variable] = ACTIONS(8274),
    [sym_class_variable] = ACTIONS(8274),
    [sym_global_variable] = ACTIONS(8274),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8276),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8276),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5208] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(11270),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_else] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [5209] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(11272),
    [sym__binary_star] = ACTIONS(11274),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(11276),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(11278),
    [anon_sym_AMP] = ACTIONS(11280),
    [anon_sym_EQ] = ACTIONS(1631),
    [anon_sym_LT] = ACTIONS(11282),
    [anon_sym_end] = ACTIONS(1625),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_unless] = ACTIONS(1625),
    [anon_sym_while] = ACTIONS(1625),
    [anon_sym_until] = ACTIONS(1625),
    [anon_sym_rescue] = ACTIONS(1625),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_else] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(11268),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_PLUS_EQ] = ACTIONS(1625),
    [anon_sym_DASH_EQ] = ACTIONS(1625),
    [anon_sym_STAR_EQ] = ACTIONS(1625),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1625),
    [anon_sym_SLASH_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1625),
    [anon_sym_AMP_EQ] = ACTIONS(1625),
    [anon_sym_PERCENT_EQ] = ACTIONS(1625),
    [anon_sym_GT_GT_EQ] = ACTIONS(1625),
    [anon_sym_LT_LT_EQ] = ACTIONS(1625),
    [anon_sym_CARET_EQ] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(11284),
    [anon_sym_DOT_DOT] = ACTIONS(11286),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11288),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(11290),
    [anon_sym_AMP_AMP] = ACTIONS(11290),
    [anon_sym_LT_LT] = ACTIONS(11292),
    [anon_sym_GT_GT] = ACTIONS(11292),
    [anon_sym_EQ_EQ] = ACTIONS(11290),
    [anon_sym_BANG_EQ] = ACTIONS(11294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11294),
    [anon_sym_LT_EQ_GT] = ACTIONS(11294),
    [anon_sym_EQ_TILDE] = ACTIONS(11294),
    [anon_sym_BANG_TILDE] = ACTIONS(11294),
    [anon_sym_LT_EQ] = ACTIONS(11282),
    [anon_sym_GT] = ACTIONS(11282),
    [anon_sym_GT_EQ] = ACTIONS(11296),
    [anon_sym_CARET] = ACTIONS(11276),
    [anon_sym_PLUS] = ACTIONS(11298),
    [anon_sym_SLASH] = ACTIONS(11278),
    [anon_sym_PERCENT] = ACTIONS(11278),
    [sym_comment] = ACTIONS(87),
  },
  [5210] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(7660),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5214),
    [sym_scope_resolution] = STATE(5210),
    [sym_call] = STATE(5210),
    [sym_method_call] = STATE(5214),
    [sym_argument_list] = STATE(1578),
    [sym__argument_list_with_parens] = STATE(7661),
    [sym__argument] = STATE(7662),
    [sym_splat_argument] = STATE(7662),
    [sym_hash_splat_argument] = STATE(7662),
    [sym_block_argument] = STATE(7662),
    [sym_do_block] = STATE(941),
    [sym_block] = STATE(941),
    [sym_assignment] = STATE(7660),
    [sym_operator_assignment] = STATE(7660),
    [sym_conditional] = STATE(7660),
    [sym_range] = STATE(7660),
    [sym_binary] = STATE(7660),
    [sym_unary] = STATE(7660),
    [sym_left_assignment_list] = STATE(5213),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5214),
    [sym__variable] = STATE(5210),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5214),
    [sym_false] = STATE(5214),
    [sym_nil] = STATE(5214),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7663),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(7662),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(743),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(11226),
    [sym__splat_star] = ACTIONS(11228),
    [sym__unary_minus] = ACTIONS(8252),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(11230),
    [anon_sym_LBRACE] = ACTIONS(2715),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(769),
    [anon_sym_return] = ACTIONS(8256),
    [anon_sym_yield] = ACTIONS(8258),
    [anon_sym_break] = ACTIONS(8260),
    [anon_sym_next] = ACTIONS(8262),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(769),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(769),
    [anon_sym_until] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(769),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(769),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_else] = ACTIONS(769),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(8264),
    [anon_sym_not] = ACTIONS(8266),
    [anon_sym_BANG] = ACTIONS(8268),
    [anon_sym_TILDE] = ACTIONS(8270),
    [sym_constant] = ACTIONS(11232),
    [sym_identifier] = ACTIONS(11232),
    [sym_instance_variable] = ACTIONS(8274),
    [sym_class_variable] = ACTIONS(8274),
    [sym_global_variable] = ACTIONS(8274),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8276),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8276),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5211] = {
    [sym_heredoc_body] = STATE(7715),
    [aux_sym_call_repeat1] = STATE(7715),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_else] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [5212] = {
    [sym_heredoc_body] = STATE(7715),
    [aux_sym_call_repeat1] = STATE(7715),
    [aux_sym_argument_list_repeat1] = STATE(7717),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(11300),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_else] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [5213] = {
    [anon_sym_EQ] = ACTIONS(11302),
    [sym_comment] = ACTIONS(87),
  },
  [5214] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(11304),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(11306),
    [anon_sym_DASH_EQ] = ACTIONS(11306),
    [anon_sym_STAR_EQ] = ACTIONS(11306),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11306),
    [anon_sym_SLASH_EQ] = ACTIONS(11306),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11306),
    [anon_sym_PIPE_EQ] = ACTIONS(11306),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11306),
    [anon_sym_AMP_EQ] = ACTIONS(11306),
    [anon_sym_PERCENT_EQ] = ACTIONS(11306),
    [anon_sym_GT_GT_EQ] = ACTIONS(11306),
    [anon_sym_LT_LT_EQ] = ACTIONS(11306),
    [anon_sym_CARET_EQ] = ACTIONS(11306),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5215] = {
    [sym_string] = STATE(7720),
    [aux_sym_chained_string_repeat1] = STATE(7720),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(747),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(11308),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5216] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7725),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7728),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(7728),
    [sym_splat_argument] = STATE(7726),
    [sym_assignment] = STATE(7725),
    [sym_operator_assignment] = STATE(7725),
    [sym_conditional] = STATE(7725),
    [sym_range] = STATE(7725),
    [sym_binary] = STATE(7725),
    [sym_unary] = STATE(7725),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(7726),
    [sym_left_assignment_list] = STATE(7727),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7728),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7728),
    [sym_false] = STATE(7728),
    [sym_nil] = STATE(7728),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7628),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(11310),
    [sym__unary_minus] = ACTIONS(11312),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11170),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_break] = ACTIONS(11174),
    [anon_sym_next] = ACTIONS(11176),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11314),
    [anon_sym_defined_QMARK] = ACTIONS(11316),
    [anon_sym_not] = ACTIONS(11318),
    [anon_sym_BANG] = ACTIONS(11320),
    [anon_sym_TILDE] = ACTIONS(11320),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5217] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7729),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2719),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(2719),
    [sym_assignment] = STATE(7729),
    [sym_operator_assignment] = STATE(7729),
    [sym_conditional] = STATE(7729),
    [sym_range] = STATE(7729),
    [sym_binary] = STATE(7729),
    [sym_unary] = STATE(7729),
    [sym_left_assignment_list] = STATE(2718),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2719),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2719),
    [sym_false] = STATE(2719),
    [sym_nil] = STATE(2719),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2720),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4583),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4585),
    [anon_sym_yield] = ACTIONS(4587),
    [anon_sym_break] = ACTIONS(4589),
    [anon_sym_next] = ACTIONS(4591),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4593),
    [anon_sym_defined_QMARK] = ACTIONS(4595),
    [anon_sym_not] = ACTIONS(4597),
    [anon_sym_BANG] = ACTIONS(4599),
    [anon_sym_TILDE] = ACTIONS(4599),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5218] = {
    [sym_string] = STATE(7730),
    [aux_sym_chained_string_repeat1] = STATE(7730),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_end] = ACTIONS(2753),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_else] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [5219] = {
    [sym_heredoc_body] = STATE(370),
    [sym__terminator] = STATE(370),
    [sym__line_break] = ACTIONS(687),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(687),
    [anon_sym_end] = ACTIONS(2757),
    [anon_sym_if] = ACTIONS(8210),
    [anon_sym_unless] = ACTIONS(8212),
    [anon_sym_while] = ACTIONS(8214),
    [anon_sym_until] = ACTIONS(8216),
    [anon_sym_rescue] = ACTIONS(8218),
    [anon_sym_else] = ACTIONS(2757),
    [sym_comment] = ACTIONS(87),
  },
  [5220] = {
    [sym_begin_block] = STATE(1611),
    [sym_end_block] = STATE(1611),
    [sym__statement] = STATE(1611),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1611),
    [sym_unless_modifier] = STATE(1611),
    [sym_while_modifier] = STATE(1611),
    [sym_until_modifier] = STATE(1611),
    [sym_rescue_modifier] = STATE(1611),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1612),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1615),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(1615),
    [sym_assignment] = STATE(1612),
    [sym_operator_assignment] = STATE(1612),
    [sym_conditional] = STATE(1612),
    [sym_range] = STATE(1612),
    [sym_binary] = STATE(1612),
    [sym_unary] = STATE(1612),
    [sym_left_assignment_list] = STATE(1614),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1615),
    [sym__variable] = STATE(1613),
    [sym_undef] = STATE(1611),
    [sym_alias] = STATE(1611),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1615),
    [sym_false] = STATE(1615),
    [sym_nil] = STATE(1615),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1616),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(5220),
    [aux_sym__statements_repeat1] = STATE(5220),
    [sym__simple_symbol] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(2762),
    [sym__symbol_start] = ACTIONS(2765),
    [sym__subshell_start] = ACTIONS(2768),
    [sym__regex_start] = ACTIONS(2771),
    [sym__string_array_start] = ACTIONS(2774),
    [sym__symbol_array_start] = ACTIONS(2777),
    [sym_heredoc_beginning] = ACTIONS(2780),
    [sym__unary_minus] = ACTIONS(2783),
    [anon_sym_BEGIN] = ACTIONS(2786),
    [anon_sym_LBRACE] = ACTIONS(2789),
    [anon_sym_END] = ACTIONS(2792),
    [anon_sym_def] = ACTIONS(2795),
    [anon_sym_LPAREN] = ACTIONS(2798),
    [anon_sym_COLON_COLON] = ACTIONS(2801),
    [anon_sym_SEMI] = ACTIONS(2804),
    [anon_sym_STAR] = ACTIONS(2807),
    [anon_sym_class] = ACTIONS(2810),
    [anon_sym_module] = ACTIONS(2813),
    [anon_sym_end] = ACTIONS(2493),
    [anon_sym_return] = ACTIONS(2816),
    [anon_sym_yield] = ACTIONS(2819),
    [anon_sym_break] = ACTIONS(2822),
    [anon_sym_next] = ACTIONS(2825),
    [sym_redo] = ACTIONS(2828),
    [sym_retry] = ACTIONS(2828),
    [anon_sym_if] = ACTIONS(2831),
    [anon_sym_unless] = ACTIONS(2834),
    [anon_sym_while] = ACTIONS(2837),
    [anon_sym_until] = ACTIONS(2840),
    [anon_sym_for] = ACTIONS(2843),
    [anon_sym_case] = ACTIONS(2846),
    [anon_sym_else] = ACTIONS(2493),
    [anon_sym_begin] = ACTIONS(2849),
    [anon_sym_PLUS] = ACTIONS(2852),
    [anon_sym_defined_QMARK] = ACTIONS(2855),
    [anon_sym_not] = ACTIONS(2858),
    [anon_sym_BANG] = ACTIONS(2861),
    [anon_sym_TILDE] = ACTIONS(2861),
    [sym_constant] = ACTIONS(2864),
    [sym_identifier] = ACTIONS(2864),
    [sym_instance_variable] = ACTIONS(2867),
    [sym_class_variable] = ACTIONS(2867),
    [sym_global_variable] = ACTIONS(2867),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_alias] = ACTIONS(2873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2876),
    [sym_float] = ACTIONS(2828),
    [sym_complex] = ACTIONS(2780),
    [sym_super] = ACTIONS(2864),
    [anon_sym_true] = ACTIONS(2879),
    [anon_sym_TRUE] = ACTIONS(2879),
    [anon_sym_false] = ACTIONS(2882),
    [anon_sym_FALSE] = ACTIONS(2882),
    [sym_self] = ACTIONS(2864),
    [anon_sym_nil] = ACTIONS(2885),
    [anon_sym_NIL] = ACTIONS(2885),
    [sym_character] = ACTIONS(2780),
    [anon_sym_LBRACK2] = ACTIONS(2888),
    [anon_sym_DASH_GT] = ACTIONS(2891),
  },
  [5221] = {
    [sym__line_break] = ACTIONS(11322),
    [sym__heredoc_body_start] = ACTIONS(11322),
    [sym__binary_minus] = ACTIONS(11322),
    [sym__binary_star] = ACTIONS(11322),
    [ts_builtin_sym_end] = ACTIONS(11322),
    [anon_sym___END__] = ACTIONS(11322),
    [anon_sym_LBRACE] = ACTIONS(11322),
    [anon_sym_RBRACE] = ACTIONS(11322),
    [anon_sym_RPAREN] = ACTIONS(11322),
    [anon_sym_DOT] = ACTIONS(11324),
    [anon_sym_COMMA] = ACTIONS(11322),
    [anon_sym_PIPE] = ACTIONS(11324),
    [anon_sym_SEMI] = ACTIONS(11322),
    [anon_sym_STAR_STAR] = ACTIONS(11322),
    [anon_sym_AMP] = ACTIONS(11324),
    [anon_sym_LT] = ACTIONS(11324),
    [anon_sym_end] = ACTIONS(11322),
    [anon_sym_if] = ACTIONS(11322),
    [anon_sym_unless] = ACTIONS(11322),
    [anon_sym_while] = ACTIONS(11322),
    [anon_sym_until] = ACTIONS(11322),
    [anon_sym_rescue] = ACTIONS(11322),
    [anon_sym_do] = ACTIONS(11322),
    [anon_sym_when] = ACTIONS(11322),
    [anon_sym_elsif] = ACTIONS(11322),
    [anon_sym_else] = ACTIONS(11322),
    [anon_sym_then] = ACTIONS(11322),
    [anon_sym_ensure] = ACTIONS(11322),
    [anon_sym_EQ_GT] = ACTIONS(11322),
    [anon_sym_LBRACK] = ACTIONS(11322),
    [anon_sym_COLON_COLON2] = ACTIONS(11322),
    [anon_sym_AMP_DOT] = ACTIONS(11322),
    [anon_sym_QMARK] = ACTIONS(11322),
    [anon_sym_DOT_DOT] = ACTIONS(11324),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11322),
    [anon_sym_and] = ACTIONS(11322),
    [anon_sym_or] = ACTIONS(11322),
    [anon_sym_PIPE_PIPE] = ACTIONS(11322),
    [anon_sym_AMP_AMP] = ACTIONS(11322),
    [anon_sym_LT_LT] = ACTIONS(11322),
    [anon_sym_GT_GT] = ACTIONS(11322),
    [anon_sym_EQ_EQ] = ACTIONS(11324),
    [anon_sym_BANG_EQ] = ACTIONS(11322),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11322),
    [anon_sym_LT_EQ_GT] = ACTIONS(11322),
    [anon_sym_EQ_TILDE] = ACTIONS(11322),
    [anon_sym_BANG_TILDE] = ACTIONS(11322),
    [anon_sym_LT_EQ] = ACTIONS(11324),
    [anon_sym_GT] = ACTIONS(11324),
    [anon_sym_GT_EQ] = ACTIONS(11322),
    [anon_sym_CARET] = ACTIONS(11322),
    [anon_sym_PLUS] = ACTIONS(11322),
    [anon_sym_SLASH] = ACTIONS(11322),
    [anon_sym_PERCENT] = ACTIONS(11322),
    [sym_comment] = ACTIONS(87),
  },
  [5222] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8292),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [5223] = {
    [sym_heredoc_body] = STATE(7731),
    [aux_sym_call_repeat1] = STATE(7731),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [5224] = {
    [sym_heredoc_body] = STATE(7731),
    [aux_sym_call_repeat1] = STATE(7731),
    [aux_sym_argument_list_repeat1] = STATE(7732),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(4681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [5225] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(8290),
    [sym__binary_star] = ACTIONS(8292),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(8294),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8292),
    [anon_sym_AMP] = ACTIONS(8296),
    [anon_sym_LT] = ACTIONS(8298),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(8300),
    [anon_sym_DOT_DOT] = ACTIONS(8302),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8304),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(8306),
    [anon_sym_AMP_AMP] = ACTIONS(8306),
    [anon_sym_LT_LT] = ACTIONS(8308),
    [anon_sym_GT_GT] = ACTIONS(8308),
    [anon_sym_EQ_EQ] = ACTIONS(8310),
    [anon_sym_BANG_EQ] = ACTIONS(8306),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8306),
    [anon_sym_LT_EQ_GT] = ACTIONS(8306),
    [anon_sym_EQ_TILDE] = ACTIONS(8306),
    [anon_sym_BANG_TILDE] = ACTIONS(8306),
    [anon_sym_LT_EQ] = ACTIONS(8298),
    [anon_sym_GT] = ACTIONS(8298),
    [anon_sym_GT_EQ] = ACTIONS(8312),
    [anon_sym_CARET] = ACTIONS(8314),
    [anon_sym_PLUS] = ACTIONS(8290),
    [anon_sym_SLASH] = ACTIONS(8292),
    [anon_sym_PERCENT] = ACTIONS(8292),
    [sym_comment] = ACTIONS(87),
  },
  [5226] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7733),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2734),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2734),
    [sym_assignment] = STATE(7733),
    [sym_operator_assignment] = STATE(7733),
    [sym_conditional] = STATE(7733),
    [sym_range] = STATE(7733),
    [sym_binary] = STATE(7733),
    [sym_unary] = STATE(7733),
    [sym_left_assignment_list] = STATE(2733),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2734),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2734),
    [sym_false] = STATE(2734),
    [sym_nil] = STATE(2734),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2735),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4613),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4615),
    [anon_sym_yield] = ACTIONS(4617),
    [anon_sym_break] = ACTIONS(4619),
    [anon_sym_next] = ACTIONS(4621),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4623),
    [anon_sym_defined_QMARK] = ACTIONS(4625),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_BANG] = ACTIONS(4629),
    [anon_sym_TILDE] = ACTIONS(4629),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5227] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7734),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2734),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2734),
    [sym_assignment] = STATE(7734),
    [sym_operator_assignment] = STATE(7734),
    [sym_conditional] = STATE(7734),
    [sym_range] = STATE(7734),
    [sym_binary] = STATE(7734),
    [sym_unary] = STATE(7734),
    [sym_left_assignment_list] = STATE(2733),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2734),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2734),
    [sym_false] = STATE(2734),
    [sym_nil] = STATE(2734),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2735),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4613),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4615),
    [anon_sym_yield] = ACTIONS(4617),
    [anon_sym_break] = ACTIONS(4619),
    [anon_sym_next] = ACTIONS(4621),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4623),
    [anon_sym_defined_QMARK] = ACTIONS(4625),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_BANG] = ACTIONS(4629),
    [anon_sym_TILDE] = ACTIONS(4629),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5228] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7735),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2734),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2734),
    [sym_assignment] = STATE(7735),
    [sym_operator_assignment] = STATE(7735),
    [sym_conditional] = STATE(7735),
    [sym_range] = STATE(7735),
    [sym_binary] = STATE(7735),
    [sym_unary] = STATE(7735),
    [sym_left_assignment_list] = STATE(2733),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2734),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2734),
    [sym_false] = STATE(2734),
    [sym_nil] = STATE(2734),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2735),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4613),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4615),
    [anon_sym_yield] = ACTIONS(4617),
    [anon_sym_break] = ACTIONS(4619),
    [anon_sym_next] = ACTIONS(4621),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4623),
    [anon_sym_defined_QMARK] = ACTIONS(4625),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_BANG] = ACTIONS(4629),
    [anon_sym_TILDE] = ACTIONS(4629),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5229] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7736),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2734),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2734),
    [sym_assignment] = STATE(7736),
    [sym_operator_assignment] = STATE(7736),
    [sym_conditional] = STATE(7736),
    [sym_range] = STATE(7736),
    [sym_binary] = STATE(7736),
    [sym_unary] = STATE(7736),
    [sym_left_assignment_list] = STATE(2733),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2734),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2734),
    [sym_false] = STATE(2734),
    [sym_nil] = STATE(2734),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2735),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4613),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4615),
    [anon_sym_yield] = ACTIONS(4617),
    [anon_sym_break] = ACTIONS(4619),
    [anon_sym_next] = ACTIONS(4621),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4623),
    [anon_sym_defined_QMARK] = ACTIONS(4625),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_BANG] = ACTIONS(4629),
    [anon_sym_TILDE] = ACTIONS(4629),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5230] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7737),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2734),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2734),
    [sym_assignment] = STATE(7737),
    [sym_operator_assignment] = STATE(7737),
    [sym_conditional] = STATE(7737),
    [sym_range] = STATE(7737),
    [sym_binary] = STATE(7737),
    [sym_unary] = STATE(7737),
    [sym_left_assignment_list] = STATE(2733),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2734),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2734),
    [sym_false] = STATE(2734),
    [sym_nil] = STATE(2734),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2735),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4613),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4615),
    [anon_sym_yield] = ACTIONS(4617),
    [anon_sym_break] = ACTIONS(4619),
    [anon_sym_next] = ACTIONS(4621),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4623),
    [anon_sym_defined_QMARK] = ACTIONS(4625),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_BANG] = ACTIONS(4629),
    [anon_sym_TILDE] = ACTIONS(4629),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5231] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(7738),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(7738),
    [sym_operator_assignment] = STATE(7738),
    [sym_conditional] = STATE(7738),
    [sym_range] = STATE(7738),
    [sym_binary] = STATE(7738),
    [sym_unary] = STATE(7738),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5232] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7739),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2734),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2734),
    [sym_assignment] = STATE(7739),
    [sym_operator_assignment] = STATE(7739),
    [sym_conditional] = STATE(7739),
    [sym_range] = STATE(7739),
    [sym_binary] = STATE(7739),
    [sym_unary] = STATE(7739),
    [sym_left_assignment_list] = STATE(2733),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2734),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2734),
    [sym_false] = STATE(2734),
    [sym_nil] = STATE(2734),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2735),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4613),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4615),
    [anon_sym_yield] = ACTIONS(4617),
    [anon_sym_break] = ACTIONS(4619),
    [anon_sym_next] = ACTIONS(4621),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4623),
    [anon_sym_defined_QMARK] = ACTIONS(4625),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_BANG] = ACTIONS(4629),
    [anon_sym_TILDE] = ACTIONS(4629),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5233] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7740),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2734),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2734),
    [sym_assignment] = STATE(7740),
    [sym_operator_assignment] = STATE(7740),
    [sym_conditional] = STATE(7740),
    [sym_range] = STATE(7740),
    [sym_binary] = STATE(7740),
    [sym_unary] = STATE(7740),
    [sym_left_assignment_list] = STATE(2733),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2734),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2734),
    [sym_false] = STATE(2734),
    [sym_nil] = STATE(2734),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2735),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4613),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4615),
    [anon_sym_yield] = ACTIONS(4617),
    [anon_sym_break] = ACTIONS(4619),
    [anon_sym_next] = ACTIONS(4621),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4623),
    [anon_sym_defined_QMARK] = ACTIONS(4625),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_BANG] = ACTIONS(4629),
    [anon_sym_TILDE] = ACTIONS(4629),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5234] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7741),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2734),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2734),
    [sym_assignment] = STATE(7741),
    [sym_operator_assignment] = STATE(7741),
    [sym_conditional] = STATE(7741),
    [sym_range] = STATE(7741),
    [sym_binary] = STATE(7741),
    [sym_unary] = STATE(7741),
    [sym_left_assignment_list] = STATE(2733),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2734),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2734),
    [sym_false] = STATE(2734),
    [sym_nil] = STATE(2734),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2735),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4613),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4615),
    [anon_sym_yield] = ACTIONS(4617),
    [anon_sym_break] = ACTIONS(4619),
    [anon_sym_next] = ACTIONS(4621),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4623),
    [anon_sym_defined_QMARK] = ACTIONS(4625),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_BANG] = ACTIONS(4629),
    [anon_sym_TILDE] = ACTIONS(4629),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5235] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7742),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2734),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2734),
    [sym_assignment] = STATE(7742),
    [sym_operator_assignment] = STATE(7742),
    [sym_conditional] = STATE(7742),
    [sym_range] = STATE(7742),
    [sym_binary] = STATE(7742),
    [sym_unary] = STATE(7742),
    [sym_left_assignment_list] = STATE(2733),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2734),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2734),
    [sym_false] = STATE(2734),
    [sym_nil] = STATE(2734),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2735),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4613),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4615),
    [anon_sym_yield] = ACTIONS(4617),
    [anon_sym_break] = ACTIONS(4619),
    [anon_sym_next] = ACTIONS(4621),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4623),
    [anon_sym_defined_QMARK] = ACTIONS(4625),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_BANG] = ACTIONS(4629),
    [anon_sym_TILDE] = ACTIONS(4629),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5236] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7743),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2734),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2734),
    [sym_splat_argument] = STATE(7744),
    [sym_assignment] = STATE(7743),
    [sym_operator_assignment] = STATE(7743),
    [sym_conditional] = STATE(7743),
    [sym_range] = STATE(7743),
    [sym_binary] = STATE(7743),
    [sym_unary] = STATE(7743),
    [sym_right_assignment_list] = STATE(2570),
    [sym__arg_or_splat_arg] = STATE(7744),
    [sym_left_assignment_list] = STATE(2733),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2734),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2734),
    [sym_false] = STATE(2734),
    [sym_nil] = STATE(2734),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2735),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(1825),
    [sym__unary_minus] = ACTIONS(4613),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4615),
    [anon_sym_yield] = ACTIONS(4617),
    [anon_sym_break] = ACTIONS(4619),
    [anon_sym_next] = ACTIONS(4621),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4623),
    [anon_sym_defined_QMARK] = ACTIONS(4625),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_BANG] = ACTIONS(4629),
    [anon_sym_TILDE] = ACTIONS(4629),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5237] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7745),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2734),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2734),
    [sym_assignment] = STATE(7745),
    [sym_operator_assignment] = STATE(7745),
    [sym_conditional] = STATE(7745),
    [sym_range] = STATE(7745),
    [sym_binary] = STATE(7745),
    [sym_unary] = STATE(7745),
    [sym_left_assignment_list] = STATE(2733),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2734),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2734),
    [sym_false] = STATE(2734),
    [sym_nil] = STATE(2734),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2735),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4613),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4615),
    [anon_sym_yield] = ACTIONS(4617),
    [anon_sym_break] = ACTIONS(4619),
    [anon_sym_next] = ACTIONS(4621),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4623),
    [anon_sym_defined_QMARK] = ACTIONS(4625),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_BANG] = ACTIONS(4629),
    [anon_sym_TILDE] = ACTIONS(4629),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5238] = {
    [sym_string] = STATE(7746),
    [aux_sym_chained_string_repeat1] = STATE(7746),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [5239] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(8290),
    [sym__binary_star] = ACTIONS(8292),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(8294),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(8292),
    [anon_sym_AMP] = ACTIONS(8296),
    [anon_sym_LT] = ACTIONS(8298),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(8300),
    [anon_sym_DOT_DOT] = ACTIONS(8302),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8304),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(8306),
    [anon_sym_AMP_AMP] = ACTIONS(8306),
    [anon_sym_LT_LT] = ACTIONS(8308),
    [anon_sym_GT_GT] = ACTIONS(8308),
    [anon_sym_EQ_EQ] = ACTIONS(8310),
    [anon_sym_BANG_EQ] = ACTIONS(8306),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8306),
    [anon_sym_LT_EQ_GT] = ACTIONS(8306),
    [anon_sym_EQ_TILDE] = ACTIONS(8306),
    [anon_sym_BANG_TILDE] = ACTIONS(8306),
    [anon_sym_LT_EQ] = ACTIONS(8298),
    [anon_sym_GT] = ACTIONS(8298),
    [anon_sym_GT_EQ] = ACTIONS(8312),
    [anon_sym_CARET] = ACTIONS(8314),
    [anon_sym_PLUS] = ACTIONS(8290),
    [anon_sym_SLASH] = ACTIONS(8292),
    [anon_sym_PERCENT] = ACTIONS(8292),
    [sym_comment] = ACTIONS(87),
  },
  [5240] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(4645),
    [sym__binary_star] = ACTIONS(4647),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(4649),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(4647),
    [anon_sym_AMP] = ACTIONS(4651),
    [anon_sym_LT] = ACTIONS(4653),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_EQ_GT] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(4655),
    [anon_sym_DOT_DOT] = ACTIONS(4657),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4659),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(4661),
    [anon_sym_AMP_AMP] = ACTIONS(4661),
    [anon_sym_LT_LT] = ACTIONS(4663),
    [anon_sym_GT_GT] = ACTIONS(4663),
    [anon_sym_EQ_EQ] = ACTIONS(4665),
    [anon_sym_BANG_EQ] = ACTIONS(4661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4661),
    [anon_sym_LT_EQ_GT] = ACTIONS(4661),
    [anon_sym_EQ_TILDE] = ACTIONS(4661),
    [anon_sym_BANG_TILDE] = ACTIONS(4661),
    [anon_sym_LT_EQ] = ACTIONS(4653),
    [anon_sym_GT] = ACTIONS(4653),
    [anon_sym_GT_EQ] = ACTIONS(4667),
    [anon_sym_CARET] = ACTIONS(4669),
    [anon_sym_PLUS] = ACTIONS(4645),
    [anon_sym_SLASH] = ACTIONS(4647),
    [anon_sym_PERCENT] = ACTIONS(4647),
    [sym_comment] = ACTIONS(87),
  },
  [5241] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(4645),
    [sym__binary_star] = ACTIONS(4647),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(4649),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(4647),
    [anon_sym_AMP] = ACTIONS(4651),
    [anon_sym_LT] = ACTIONS(4653),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_EQ_GT] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(4655),
    [anon_sym_DOT_DOT] = ACTIONS(4657),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4659),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(4661),
    [anon_sym_AMP_AMP] = ACTIONS(4661),
    [anon_sym_LT_LT] = ACTIONS(4663),
    [anon_sym_GT_GT] = ACTIONS(4663),
    [anon_sym_EQ_EQ] = ACTIONS(4665),
    [anon_sym_BANG_EQ] = ACTIONS(4661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4661),
    [anon_sym_LT_EQ_GT] = ACTIONS(4661),
    [anon_sym_EQ_TILDE] = ACTIONS(4661),
    [anon_sym_BANG_TILDE] = ACTIONS(4661),
    [anon_sym_LT_EQ] = ACTIONS(4653),
    [anon_sym_GT] = ACTIONS(4653),
    [anon_sym_GT_EQ] = ACTIONS(4667),
    [anon_sym_CARET] = ACTIONS(4669),
    [anon_sym_PLUS] = ACTIONS(4645),
    [anon_sym_SLASH] = ACTIONS(4647),
    [anon_sym_PERCENT] = ACTIONS(4647),
    [sym_comment] = ACTIONS(87),
  },
  [5242] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7747),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1033),
    [sym_scope_resolution] = STATE(1029),
    [sym_call] = STATE(1029),
    [sym_method_call] = STATE(1033),
    [sym_assignment] = STATE(7747),
    [sym_operator_assignment] = STATE(7747),
    [sym_conditional] = STATE(7747),
    [sym_range] = STATE(7747),
    [sym_binary] = STATE(7747),
    [sym_unary] = STATE(7747),
    [sym_left_assignment_list] = STATE(1032),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1033),
    [sym__variable] = STATE(1029),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1033),
    [sym_false] = STATE(1033),
    [sym_nil] = STATE(1033),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2738),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1827),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1831),
    [anon_sym_yield] = ACTIONS(1833),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_next] = ACTIONS(1837),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4631),
    [anon_sym_defined_QMARK] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1845),
    [anon_sym_TILDE] = ACTIONS(1845),
    [sym_constant] = ACTIONS(1851),
    [sym_identifier] = ACTIONS(1851),
    [sym_instance_variable] = ACTIONS(1849),
    [sym_class_variable] = ACTIONS(1849),
    [sym_global_variable] = ACTIONS(1849),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1851),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1851),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5243] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(4645),
    [sym__binary_star] = ACTIONS(4647),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(4649),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(4647),
    [anon_sym_AMP] = ACTIONS(4651),
    [anon_sym_LT] = ACTIONS(4653),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_EQ_GT] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(4655),
    [anon_sym_DOT_DOT] = ACTIONS(4657),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4659),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(4661),
    [anon_sym_AMP_AMP] = ACTIONS(4661),
    [anon_sym_LT_LT] = ACTIONS(4663),
    [anon_sym_GT_GT] = ACTIONS(4663),
    [anon_sym_EQ_EQ] = ACTIONS(4665),
    [anon_sym_BANG_EQ] = ACTIONS(4661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4661),
    [anon_sym_LT_EQ_GT] = ACTIONS(4661),
    [anon_sym_EQ_TILDE] = ACTIONS(4661),
    [anon_sym_BANG_TILDE] = ACTIONS(4661),
    [anon_sym_LT_EQ] = ACTIONS(4653),
    [anon_sym_GT] = ACTIONS(4653),
    [anon_sym_GT_EQ] = ACTIONS(4667),
    [anon_sym_CARET] = ACTIONS(4669),
    [anon_sym_PLUS] = ACTIONS(4645),
    [anon_sym_SLASH] = ACTIONS(4647),
    [anon_sym_PERCENT] = ACTIONS(4647),
    [sym_comment] = ACTIONS(87),
  },
  [5244] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7748),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1033),
    [sym_scope_resolution] = STATE(1029),
    [sym_call] = STATE(1029),
    [sym_method_call] = STATE(1033),
    [sym_assignment] = STATE(7748),
    [sym_operator_assignment] = STATE(7748),
    [sym_conditional] = STATE(7748),
    [sym_range] = STATE(7748),
    [sym_binary] = STATE(7748),
    [sym_unary] = STATE(7748),
    [sym_left_assignment_list] = STATE(1032),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1033),
    [sym__variable] = STATE(1029),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1033),
    [sym_false] = STATE(1033),
    [sym_nil] = STATE(1033),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2738),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1827),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1831),
    [anon_sym_yield] = ACTIONS(1833),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_next] = ACTIONS(1837),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4631),
    [anon_sym_defined_QMARK] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1845),
    [anon_sym_TILDE] = ACTIONS(1845),
    [sym_constant] = ACTIONS(1851),
    [sym_identifier] = ACTIONS(1851),
    [sym_instance_variable] = ACTIONS(1849),
    [sym_class_variable] = ACTIONS(1849),
    [sym_global_variable] = ACTIONS(1849),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1851),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1851),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5245] = {
    [sym_heredoc_body] = STATE(7749),
    [aux_sym_call_repeat1] = STATE(7749),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [5246] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2746),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1033),
    [sym_scope_resolution] = STATE(1029),
    [sym_call] = STATE(1029),
    [sym_method_call] = STATE(1033),
    [sym__argument] = STATE(2565),
    [sym_splat_argument] = STATE(2565),
    [sym_hash_splat_argument] = STATE(2565),
    [sym_block_argument] = STATE(2565),
    [sym_assignment] = STATE(2746),
    [sym_operator_assignment] = STATE(2746),
    [sym_conditional] = STATE(2746),
    [sym_range] = STATE(2746),
    [sym_binary] = STATE(2746),
    [sym_unary] = STATE(2746),
    [sym_left_assignment_list] = STATE(1032),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1033),
    [sym__variable] = STATE(1029),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1033),
    [sym_false] = STATE(1033),
    [sym_nil] = STATE(1033),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2749),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(7750),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2565),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(4635),
    [sym__splat_star] = ACTIONS(4637),
    [sym__unary_minus] = ACTIONS(1827),
    [sym__identifier_hash_key] = ACTIONS(4639),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11326),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1831),
    [anon_sym_yield] = ACTIONS(1833),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_next] = ACTIONS(1837),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4631),
    [anon_sym_defined_QMARK] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1845),
    [anon_sym_TILDE] = ACTIONS(1845),
    [sym_constant] = ACTIONS(4641),
    [sym_identifier] = ACTIONS(4641),
    [sym_instance_variable] = ACTIONS(1849),
    [sym_class_variable] = ACTIONS(1849),
    [sym_global_variable] = ACTIONS(1849),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1851),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1851),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5247] = {
    [sym_heredoc_body] = STATE(7751),
    [aux_sym_call_repeat1] = STATE(7751),
    [aux_sym_argument_list_repeat1] = STATE(7752),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(8326),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [5248] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(8290),
    [sym__binary_star] = ACTIONS(8292),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(8294),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(8292),
    [anon_sym_AMP] = ACTIONS(8296),
    [anon_sym_LT] = ACTIONS(8298),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(8300),
    [anon_sym_DOT_DOT] = ACTIONS(8302),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8304),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(8306),
    [anon_sym_AMP_AMP] = ACTIONS(8306),
    [anon_sym_LT_LT] = ACTIONS(8308),
    [anon_sym_GT_GT] = ACTIONS(8308),
    [anon_sym_EQ_EQ] = ACTIONS(8310),
    [anon_sym_BANG_EQ] = ACTIONS(8306),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8306),
    [anon_sym_LT_EQ_GT] = ACTIONS(8306),
    [anon_sym_EQ_TILDE] = ACTIONS(8306),
    [anon_sym_BANG_TILDE] = ACTIONS(8306),
    [anon_sym_LT_EQ] = ACTIONS(8298),
    [anon_sym_GT] = ACTIONS(8298),
    [anon_sym_GT_EQ] = ACTIONS(8312),
    [anon_sym_CARET] = ACTIONS(8314),
    [anon_sym_PLUS] = ACTIONS(8290),
    [anon_sym_SLASH] = ACTIONS(8292),
    [anon_sym_PERCENT] = ACTIONS(8292),
    [sym_comment] = ACTIONS(87),
  },
  [5249] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(4647),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(4647),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(4647),
    [anon_sym_PERCENT] = ACTIONS(4647),
    [sym_comment] = ACTIONS(87),
  },
  [5250] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(4647),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [5251] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4645),
    [sym__binary_star] = ACTIONS(4647),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(4647),
    [anon_sym_AMP] = ACTIONS(4651),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(4663),
    [anon_sym_GT_GT] = ACTIONS(4663),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(4645),
    [anon_sym_SLASH] = ACTIONS(4647),
    [anon_sym_PERCENT] = ACTIONS(4647),
    [sym_comment] = ACTIONS(87),
  },
  [5252] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4645),
    [sym__binary_star] = ACTIONS(4647),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(4647),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(4663),
    [anon_sym_GT_GT] = ACTIONS(4663),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(4645),
    [anon_sym_SLASH] = ACTIONS(4647),
    [anon_sym_PERCENT] = ACTIONS(4647),
    [sym_comment] = ACTIONS(87),
  },
  [5253] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4645),
    [sym__binary_star] = ACTIONS(4647),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(4649),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(4647),
    [anon_sym_AMP] = ACTIONS(4651),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(4663),
    [anon_sym_GT_GT] = ACTIONS(4663),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(4669),
    [anon_sym_PLUS] = ACTIONS(4645),
    [anon_sym_SLASH] = ACTIONS(4647),
    [anon_sym_PERCENT] = ACTIONS(4647),
    [sym_comment] = ACTIONS(87),
  },
  [5254] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(11328),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [5255] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(4645),
    [sym__binary_star] = ACTIONS(4647),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(4649),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(4647),
    [anon_sym_AMP] = ACTIONS(4651),
    [anon_sym_LT] = ACTIONS(4653),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_EQ_GT] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(4657),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4659),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(4661),
    [anon_sym_AMP_AMP] = ACTIONS(4661),
    [anon_sym_LT_LT] = ACTIONS(4663),
    [anon_sym_GT_GT] = ACTIONS(4663),
    [anon_sym_EQ_EQ] = ACTIONS(4665),
    [anon_sym_BANG_EQ] = ACTIONS(4661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4661),
    [anon_sym_LT_EQ_GT] = ACTIONS(4661),
    [anon_sym_EQ_TILDE] = ACTIONS(4661),
    [anon_sym_BANG_TILDE] = ACTIONS(4661),
    [anon_sym_LT_EQ] = ACTIONS(4653),
    [anon_sym_GT] = ACTIONS(4653),
    [anon_sym_GT_EQ] = ACTIONS(4667),
    [anon_sym_CARET] = ACTIONS(4669),
    [anon_sym_PLUS] = ACTIONS(4645),
    [anon_sym_SLASH] = ACTIONS(4647),
    [anon_sym_PERCENT] = ACTIONS(4647),
    [sym_comment] = ACTIONS(87),
  },
  [5256] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4645),
    [sym__binary_star] = ACTIONS(4647),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(4649),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(4647),
    [anon_sym_AMP] = ACTIONS(4651),
    [anon_sym_LT] = ACTIONS(4653),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(4655),
    [anon_sym_DOT_DOT] = ACTIONS(4657),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4659),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(4661),
    [anon_sym_AMP_AMP] = ACTIONS(4661),
    [anon_sym_LT_LT] = ACTIONS(4663),
    [anon_sym_GT_GT] = ACTIONS(4663),
    [anon_sym_EQ_EQ] = ACTIONS(4665),
    [anon_sym_BANG_EQ] = ACTIONS(4661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4661),
    [anon_sym_LT_EQ_GT] = ACTIONS(4661),
    [anon_sym_EQ_TILDE] = ACTIONS(4661),
    [anon_sym_BANG_TILDE] = ACTIONS(4661),
    [anon_sym_LT_EQ] = ACTIONS(4653),
    [anon_sym_GT] = ACTIONS(4653),
    [anon_sym_GT_EQ] = ACTIONS(4667),
    [anon_sym_CARET] = ACTIONS(4669),
    [anon_sym_PLUS] = ACTIONS(4645),
    [anon_sym_SLASH] = ACTIONS(4647),
    [anon_sym_PERCENT] = ACTIONS(4647),
    [sym_comment] = ACTIONS(87),
  },
  [5257] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4645),
    [sym__binary_star] = ACTIONS(4647),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(4649),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(4647),
    [anon_sym_AMP] = ACTIONS(4651),
    [anon_sym_LT] = ACTIONS(4653),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(4663),
    [anon_sym_GT_GT] = ACTIONS(4663),
    [anon_sym_EQ_EQ] = ACTIONS(4665),
    [anon_sym_BANG_EQ] = ACTIONS(4661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4661),
    [anon_sym_LT_EQ_GT] = ACTIONS(4661),
    [anon_sym_EQ_TILDE] = ACTIONS(4661),
    [anon_sym_BANG_TILDE] = ACTIONS(4661),
    [anon_sym_LT_EQ] = ACTIONS(4653),
    [anon_sym_GT] = ACTIONS(4653),
    [anon_sym_GT_EQ] = ACTIONS(4667),
    [anon_sym_CARET] = ACTIONS(4669),
    [anon_sym_PLUS] = ACTIONS(4645),
    [anon_sym_SLASH] = ACTIONS(4647),
    [anon_sym_PERCENT] = ACTIONS(4647),
    [sym_comment] = ACTIONS(87),
  },
  [5258] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4645),
    [sym__binary_star] = ACTIONS(4647),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(4647),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(4645),
    [anon_sym_SLASH] = ACTIONS(4647),
    [anon_sym_PERCENT] = ACTIONS(4647),
    [sym_comment] = ACTIONS(87),
  },
  [5259] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(4723),
    [sym__binary_star] = ACTIONS(4725),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(4727),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(4729),
    [anon_sym_AMP] = ACTIONS(4731),
    [anon_sym_EQ] = ACTIONS(4217),
    [anon_sym_LT] = ACTIONS(4733),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_EQ_GT] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_PLUS_EQ] = ACTIONS(4211),
    [anon_sym_DASH_EQ] = ACTIONS(4211),
    [anon_sym_STAR_EQ] = ACTIONS(4211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4211),
    [anon_sym_SLASH_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4211),
    [anon_sym_AMP_EQ] = ACTIONS(4211),
    [anon_sym_PERCENT_EQ] = ACTIONS(4211),
    [anon_sym_GT_GT_EQ] = ACTIONS(4211),
    [anon_sym_LT_LT_EQ] = ACTIONS(4211),
    [anon_sym_CARET_EQ] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(4735),
    [anon_sym_DOT_DOT] = ACTIONS(4737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4739),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(4741),
    [anon_sym_AMP_AMP] = ACTIONS(4741),
    [anon_sym_LT_LT] = ACTIONS(4743),
    [anon_sym_GT_GT] = ACTIONS(4743),
    [anon_sym_EQ_EQ] = ACTIONS(4741),
    [anon_sym_BANG_EQ] = ACTIONS(4745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4745),
    [anon_sym_LT_EQ_GT] = ACTIONS(4745),
    [anon_sym_EQ_TILDE] = ACTIONS(4745),
    [anon_sym_BANG_TILDE] = ACTIONS(4745),
    [anon_sym_LT_EQ] = ACTIONS(4733),
    [anon_sym_GT] = ACTIONS(4733),
    [anon_sym_GT_EQ] = ACTIONS(4747),
    [anon_sym_CARET] = ACTIONS(4727),
    [anon_sym_PLUS] = ACTIONS(4749),
    [anon_sym_SLASH] = ACTIONS(4729),
    [anon_sym_PERCENT] = ACTIONS(4729),
    [sym_comment] = ACTIONS(87),
  },
  [5260] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(4723),
    [sym__binary_star] = ACTIONS(4725),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(4727),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(4729),
    [anon_sym_AMP] = ACTIONS(4731),
    [anon_sym_EQ] = ACTIONS(4249),
    [anon_sym_LT] = ACTIONS(4733),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_EQ_GT] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_PLUS_EQ] = ACTIONS(4247),
    [anon_sym_DASH_EQ] = ACTIONS(4247),
    [anon_sym_STAR_EQ] = ACTIONS(4247),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4247),
    [anon_sym_SLASH_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4247),
    [anon_sym_AMP_EQ] = ACTIONS(4247),
    [anon_sym_PERCENT_EQ] = ACTIONS(4247),
    [anon_sym_GT_GT_EQ] = ACTIONS(4247),
    [anon_sym_LT_LT_EQ] = ACTIONS(4247),
    [anon_sym_CARET_EQ] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(4735),
    [anon_sym_DOT_DOT] = ACTIONS(4737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4739),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(4741),
    [anon_sym_AMP_AMP] = ACTIONS(4741),
    [anon_sym_LT_LT] = ACTIONS(4743),
    [anon_sym_GT_GT] = ACTIONS(4743),
    [anon_sym_EQ_EQ] = ACTIONS(4741),
    [anon_sym_BANG_EQ] = ACTIONS(4745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4745),
    [anon_sym_LT_EQ_GT] = ACTIONS(4745),
    [anon_sym_EQ_TILDE] = ACTIONS(4745),
    [anon_sym_BANG_TILDE] = ACTIONS(4745),
    [anon_sym_LT_EQ] = ACTIONS(4733),
    [anon_sym_GT] = ACTIONS(4733),
    [anon_sym_GT_EQ] = ACTIONS(4747),
    [anon_sym_CARET] = ACTIONS(4727),
    [anon_sym_PLUS] = ACTIONS(4749),
    [anon_sym_SLASH] = ACTIONS(4729),
    [anon_sym_PERCENT] = ACTIONS(4729),
    [sym_comment] = ACTIONS(87),
  },
  [5261] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(7754),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1066),
    [sym_scope_resolution] = STATE(1061),
    [sym_call] = STATE(1061),
    [sym_method_call] = STATE(1066),
    [sym_assignment] = STATE(7754),
    [sym_operator_assignment] = STATE(7754),
    [sym_conditional] = STATE(7754),
    [sym_range] = STATE(7754),
    [sym_binary] = STATE(7754),
    [sym_unary] = STATE(7754),
    [sym_left_assignment_list] = STATE(1065),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1066),
    [sym__variable] = STATE(1061),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1066),
    [sym_false] = STATE(1066),
    [sym_nil] = STATE(1066),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2804),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1895),
    [anon_sym_break] = ACTIONS(1897),
    [anon_sym_next] = ACTIONS(1899),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(4715),
    [anon_sym_defined_QMARK] = ACTIONS(1909),
    [anon_sym_not] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1915),
    [anon_sym_TILDE] = ACTIONS(1915),
    [sym_constant] = ACTIONS(1921),
    [sym_identifier] = ACTIONS(1921),
    [sym_instance_variable] = ACTIONS(1919),
    [sym_class_variable] = ACTIONS(1919),
    [sym_global_variable] = ACTIONS(1919),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1921),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1921),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5262] = {
    [sym__line_break] = ACTIONS(5735),
    [sym__heredoc_body_start] = ACTIONS(5735),
    [sym__binary_minus] = ACTIONS(5735),
    [sym__binary_star] = ACTIONS(5735),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_DOT] = ACTIONS(5737),
    [anon_sym_COMMA] = ACTIONS(5735),
    [anon_sym_PIPE] = ACTIONS(5737),
    [anon_sym_SEMI] = ACTIONS(5735),
    [anon_sym_STAR_STAR] = ACTIONS(5737),
    [anon_sym_AMP] = ACTIONS(5737),
    [anon_sym_EQ] = ACTIONS(5737),
    [anon_sym_LT] = ACTIONS(5737),
    [anon_sym_do] = ACTIONS(5735),
    [anon_sym_EQ_GT] = ACTIONS(5735),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_COLON_COLON2] = ACTIONS(5735),
    [anon_sym_AMP_DOT] = ACTIONS(5735),
    [anon_sym_PLUS_EQ] = ACTIONS(5735),
    [anon_sym_DASH_EQ] = ACTIONS(5735),
    [anon_sym_STAR_EQ] = ACTIONS(5735),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5735),
    [anon_sym_SLASH_EQ] = ACTIONS(5735),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5735),
    [anon_sym_PIPE_EQ] = ACTIONS(5735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5735),
    [anon_sym_AMP_EQ] = ACTIONS(5735),
    [anon_sym_PERCENT_EQ] = ACTIONS(5735),
    [anon_sym_GT_GT_EQ] = ACTIONS(5735),
    [anon_sym_LT_LT_EQ] = ACTIONS(5735),
    [anon_sym_CARET_EQ] = ACTIONS(5735),
    [anon_sym_QMARK] = ACTIONS(5735),
    [anon_sym_DOT_DOT] = ACTIONS(5737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5735),
    [anon_sym_and] = ACTIONS(5735),
    [anon_sym_or] = ACTIONS(5735),
    [anon_sym_PIPE_PIPE] = ACTIONS(5737),
    [anon_sym_AMP_AMP] = ACTIONS(5737),
    [anon_sym_LT_LT] = ACTIONS(5737),
    [anon_sym_GT_GT] = ACTIONS(5737),
    [anon_sym_EQ_EQ] = ACTIONS(5737),
    [anon_sym_BANG_EQ] = ACTIONS(5735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5735),
    [anon_sym_LT_EQ_GT] = ACTIONS(5735),
    [anon_sym_EQ_TILDE] = ACTIONS(5735),
    [anon_sym_BANG_TILDE] = ACTIONS(5735),
    [anon_sym_LT_EQ] = ACTIONS(5737),
    [anon_sym_GT] = ACTIONS(5737),
    [anon_sym_GT_EQ] = ACTIONS(5735),
    [anon_sym_CARET] = ACTIONS(5737),
    [anon_sym_PLUS] = ACTIONS(5737),
    [anon_sym_SLASH] = ACTIONS(5737),
    [anon_sym_PERCENT] = ACTIONS(5737),
    [sym_comment] = ACTIONS(87),
  },
  [5263] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(4723),
    [sym__binary_star] = ACTIONS(4725),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(4727),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(4729),
    [anon_sym_AMP] = ACTIONS(4731),
    [anon_sym_EQ] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(4733),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_EQ_GT] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_PLUS_EQ] = ACTIONS(3281),
    [anon_sym_DASH_EQ] = ACTIONS(3281),
    [anon_sym_STAR_EQ] = ACTIONS(3281),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3281),
    [anon_sym_SLASH_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3281),
    [anon_sym_AMP_EQ] = ACTIONS(3281),
    [anon_sym_PERCENT_EQ] = ACTIONS(3281),
    [anon_sym_GT_GT_EQ] = ACTIONS(3281),
    [anon_sym_LT_LT_EQ] = ACTIONS(3281),
    [anon_sym_CARET_EQ] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(4735),
    [anon_sym_DOT_DOT] = ACTIONS(4737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4739),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(4741),
    [anon_sym_AMP_AMP] = ACTIONS(4741),
    [anon_sym_LT_LT] = ACTIONS(4743),
    [anon_sym_GT_GT] = ACTIONS(4743),
    [anon_sym_EQ_EQ] = ACTIONS(4741),
    [anon_sym_BANG_EQ] = ACTIONS(4745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4745),
    [anon_sym_LT_EQ_GT] = ACTIONS(4745),
    [anon_sym_EQ_TILDE] = ACTIONS(4745),
    [anon_sym_BANG_TILDE] = ACTIONS(4745),
    [anon_sym_LT_EQ] = ACTIONS(4733),
    [anon_sym_GT] = ACTIONS(4733),
    [anon_sym_GT_EQ] = ACTIONS(4747),
    [anon_sym_CARET] = ACTIONS(4727),
    [anon_sym_PLUS] = ACTIONS(4749),
    [anon_sym_SLASH] = ACTIONS(4729),
    [anon_sym_PERCENT] = ACTIONS(4729),
    [sym_comment] = ACTIONS(87),
  },
  [5264] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(7755),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1066),
    [sym_scope_resolution] = STATE(1061),
    [sym_call] = STATE(1061),
    [sym_method_call] = STATE(1066),
    [sym_assignment] = STATE(7755),
    [sym_operator_assignment] = STATE(7755),
    [sym_conditional] = STATE(7755),
    [sym_range] = STATE(7755),
    [sym_binary] = STATE(7755),
    [sym_unary] = STATE(7755),
    [sym_left_assignment_list] = STATE(1065),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1066),
    [sym__variable] = STATE(1061),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1066),
    [sym_false] = STATE(1066),
    [sym_nil] = STATE(1066),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2804),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1895),
    [anon_sym_break] = ACTIONS(1897),
    [anon_sym_next] = ACTIONS(1899),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(4715),
    [anon_sym_defined_QMARK] = ACTIONS(1909),
    [anon_sym_not] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1915),
    [anon_sym_TILDE] = ACTIONS(1915),
    [sym_constant] = ACTIONS(1921),
    [sym_identifier] = ACTIONS(1921),
    [sym_instance_variable] = ACTIONS(1919),
    [sym_class_variable] = ACTIONS(1919),
    [sym_global_variable] = ACTIONS(1919),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1921),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1921),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5265] = {
    [sym_heredoc_body] = STATE(7756),
    [aux_sym_call_repeat1] = STATE(7756),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [5266] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(2768),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1066),
    [sym_scope_resolution] = STATE(1061),
    [sym_call] = STATE(1061),
    [sym_method_call] = STATE(1066),
    [sym__argument] = STATE(4979),
    [sym_splat_argument] = STATE(4979),
    [sym_hash_splat_argument] = STATE(4979),
    [sym_block_argument] = STATE(4979),
    [sym_assignment] = STATE(2768),
    [sym_operator_assignment] = STATE(2768),
    [sym_conditional] = STATE(2768),
    [sym_range] = STATE(2768),
    [sym_binary] = STATE(2768),
    [sym_unary] = STATE(2768),
    [sym_left_assignment_list] = STATE(1065),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1066),
    [sym__variable] = STATE(1061),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1066),
    [sym_false] = STATE(1066),
    [sym_nil] = STATE(1066),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2771),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_heredoc_body] = STATE(7757),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(4979),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(4671),
    [sym__splat_star] = ACTIONS(4673),
    [sym__unary_minus] = ACTIONS(1887),
    [sym__identifier_hash_key] = ACTIONS(4675),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11330),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1895),
    [anon_sym_break] = ACTIONS(1897),
    [anon_sym_next] = ACTIONS(1899),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(4715),
    [anon_sym_defined_QMARK] = ACTIONS(1909),
    [anon_sym_not] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1915),
    [anon_sym_TILDE] = ACTIONS(1915),
    [sym_constant] = ACTIONS(4679),
    [sym_identifier] = ACTIONS(4679),
    [sym_instance_variable] = ACTIONS(1919),
    [sym_class_variable] = ACTIONS(1919),
    [sym_global_variable] = ACTIONS(1919),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1921),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1921),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5267] = {
    [sym_heredoc_body] = STATE(7758),
    [aux_sym_call_repeat1] = STATE(7758),
    [aux_sym_argument_list_repeat1] = STATE(7759),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(8336),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [5268] = {
    [sym_heredoc_body] = STATE(5268),
    [aux_sym_call_repeat1] = STATE(5268),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(7916),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [5269] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1028),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1033),
    [sym_scope_resolution] = STATE(1029),
    [sym_call] = STATE(1029),
    [sym_method_call] = STATE(1033),
    [sym__argument] = STATE(4986),
    [sym_splat_argument] = STATE(4986),
    [sym_hash_splat_argument] = STATE(4986),
    [sym_block_argument] = STATE(4986),
    [sym_assignment] = STATE(1028),
    [sym_operator_assignment] = STATE(1028),
    [sym_conditional] = STATE(1028),
    [sym_range] = STATE(1028),
    [sym_binary] = STATE(1028),
    [sym_unary] = STATE(1028),
    [sym_left_assignment_list] = STATE(1032),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1033),
    [sym__variable] = STATE(1029),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1033),
    [sym_false] = STATE(1033),
    [sym_nil] = STATE(1033),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1034),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4986),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(1823),
    [sym__splat_star] = ACTIONS(1825),
    [sym__unary_minus] = ACTIONS(1827),
    [sym__identifier_hash_key] = ACTIONS(1829),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(8340),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1831),
    [anon_sym_yield] = ACTIONS(1833),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_next] = ACTIONS(1837),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4631),
    [anon_sym_defined_QMARK] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1845),
    [anon_sym_TILDE] = ACTIONS(1845),
    [sym_constant] = ACTIONS(1847),
    [sym_identifier] = ACTIONS(1847),
    [sym_instance_variable] = ACTIONS(1849),
    [sym_class_variable] = ACTIONS(1849),
    [sym_global_variable] = ACTIONS(1849),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1851),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1851),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5270] = {
    [sym_heredoc_body] = STATE(5268),
    [aux_sym_call_repeat1] = STATE(5268),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [5271] = {
    [aux_sym_argument_list_repeat1] = STATE(5271),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(11332),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7925),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7925),
    [anon_sym_AMP_AMP] = ACTIONS(7925),
    [anon_sym_LT_LT] = ACTIONS(7925),
    [anon_sym_GT_GT] = ACTIONS(7925),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7925),
    [anon_sym_PLUS] = ACTIONS(7925),
    [anon_sym_SLASH] = ACTIONS(7925),
    [anon_sym_PERCENT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [5272] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(4645),
    [sym__binary_star] = ACTIONS(4647),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(4649),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(4647),
    [anon_sym_AMP] = ACTIONS(4651),
    [anon_sym_LT] = ACTIONS(4653),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_EQ_GT] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(4655),
    [anon_sym_DOT_DOT] = ACTIONS(4657),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4659),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(4661),
    [anon_sym_AMP_AMP] = ACTIONS(4661),
    [anon_sym_LT_LT] = ACTIONS(4663),
    [anon_sym_GT_GT] = ACTIONS(4663),
    [anon_sym_EQ_EQ] = ACTIONS(4665),
    [anon_sym_BANG_EQ] = ACTIONS(4661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4661),
    [anon_sym_LT_EQ_GT] = ACTIONS(4661),
    [anon_sym_EQ_TILDE] = ACTIONS(4661),
    [anon_sym_BANG_TILDE] = ACTIONS(4661),
    [anon_sym_LT_EQ] = ACTIONS(4653),
    [anon_sym_GT] = ACTIONS(4653),
    [anon_sym_GT_EQ] = ACTIONS(4667),
    [anon_sym_CARET] = ACTIONS(4669),
    [anon_sym_PLUS] = ACTIONS(4645),
    [anon_sym_SLASH] = ACTIONS(4647),
    [anon_sym_PERCENT] = ACTIONS(4647),
    [sym_comment] = ACTIONS(87),
  },
  [5273] = {
    [aux_sym_exceptions_repeat1] = STATE(7761),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [5274] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(4645),
    [sym__binary_star] = ACTIONS(4647),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(4649),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(4647),
    [anon_sym_AMP] = ACTIONS(4651),
    [anon_sym_LT] = ACTIONS(4653),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_EQ_GT] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(4655),
    [anon_sym_DOT_DOT] = ACTIONS(4657),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4659),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(4661),
    [anon_sym_AMP_AMP] = ACTIONS(4661),
    [anon_sym_LT_LT] = ACTIONS(4663),
    [anon_sym_GT_GT] = ACTIONS(4663),
    [anon_sym_EQ_EQ] = ACTIONS(4665),
    [anon_sym_BANG_EQ] = ACTIONS(4661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4661),
    [anon_sym_LT_EQ_GT] = ACTIONS(4661),
    [anon_sym_EQ_TILDE] = ACTIONS(4661),
    [anon_sym_BANG_TILDE] = ACTIONS(4661),
    [anon_sym_LT_EQ] = ACTIONS(4653),
    [anon_sym_GT] = ACTIONS(4653),
    [anon_sym_GT_EQ] = ACTIONS(4667),
    [anon_sym_CARET] = ACTIONS(4669),
    [anon_sym_PLUS] = ACTIONS(4645),
    [anon_sym_SLASH] = ACTIONS(4647),
    [anon_sym_PERCENT] = ACTIONS(4647),
    [sym_comment] = ACTIONS(87),
  },
  [5275] = {
    [sym_string] = STATE(5275),
    [aux_sym_chained_string_repeat1] = STATE(5275),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(6214),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_do] = ACTIONS(6212),
    [anon_sym_EQ_GT] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [5276] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7762),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(7762),
    [sym_operator_assignment] = STATE(7762),
    [sym_conditional] = STATE(7762),
    [sym_range] = STATE(7762),
    [sym_binary] = STATE(7762),
    [sym_unary] = STATE(7762),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(455),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_break] = ACTIONS(459),
    [anon_sym_next] = ACTIONS(461),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_defined_QMARK] = ACTIONS(465),
    [anon_sym_not] = ACTIONS(467),
    [anon_sym_BANG] = ACTIONS(469),
    [anon_sym_TILDE] = ACTIONS(469),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5277] = {
    [sym__line_break] = ACTIONS(11335),
    [sym__heredoc_body_start] = ACTIONS(11335),
    [sym__binary_minus] = ACTIONS(11335),
    [sym__binary_star] = ACTIONS(11335),
    [ts_builtin_sym_end] = ACTIONS(11335),
    [anon_sym___END__] = ACTIONS(11335),
    [anon_sym_LBRACE] = ACTIONS(11335),
    [anon_sym_RBRACE] = ACTIONS(11335),
    [anon_sym_RPAREN] = ACTIONS(11335),
    [anon_sym_DOT] = ACTIONS(11337),
    [anon_sym_COMMA] = ACTIONS(11335),
    [anon_sym_PIPE] = ACTIONS(11337),
    [anon_sym_SEMI] = ACTIONS(11335),
    [anon_sym_STAR_STAR] = ACTIONS(11335),
    [anon_sym_AMP] = ACTIONS(11337),
    [anon_sym_LT] = ACTIONS(11337),
    [anon_sym_end] = ACTIONS(11335),
    [anon_sym_if] = ACTIONS(11335),
    [anon_sym_unless] = ACTIONS(11335),
    [anon_sym_while] = ACTIONS(11335),
    [anon_sym_until] = ACTIONS(11335),
    [anon_sym_rescue] = ACTIONS(11335),
    [anon_sym_do] = ACTIONS(11335),
    [anon_sym_when] = ACTIONS(11335),
    [anon_sym_elsif] = ACTIONS(11335),
    [anon_sym_else] = ACTIONS(11335),
    [anon_sym_then] = ACTIONS(11335),
    [anon_sym_ensure] = ACTIONS(11335),
    [anon_sym_EQ_GT] = ACTIONS(11335),
    [anon_sym_LBRACK] = ACTIONS(11335),
    [anon_sym_COLON_COLON2] = ACTIONS(11335),
    [anon_sym_AMP_DOT] = ACTIONS(11335),
    [anon_sym_QMARK] = ACTIONS(11335),
    [anon_sym_DOT_DOT] = ACTIONS(11337),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11335),
    [anon_sym_and] = ACTIONS(11335),
    [anon_sym_or] = ACTIONS(11335),
    [anon_sym_PIPE_PIPE] = ACTIONS(11335),
    [anon_sym_AMP_AMP] = ACTIONS(11335),
    [anon_sym_LT_LT] = ACTIONS(11335),
    [anon_sym_GT_GT] = ACTIONS(11335),
    [anon_sym_EQ_EQ] = ACTIONS(11337),
    [anon_sym_BANG_EQ] = ACTIONS(11335),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11335),
    [anon_sym_LT_EQ_GT] = ACTIONS(11335),
    [anon_sym_EQ_TILDE] = ACTIONS(11335),
    [anon_sym_BANG_TILDE] = ACTIONS(11335),
    [anon_sym_LT_EQ] = ACTIONS(11337),
    [anon_sym_GT] = ACTIONS(11337),
    [anon_sym_GT_EQ] = ACTIONS(11335),
    [anon_sym_CARET] = ACTIONS(11335),
    [anon_sym_PLUS] = ACTIONS(11335),
    [anon_sym_SLASH] = ACTIONS(11335),
    [anon_sym_PERCENT] = ACTIONS(11335),
    [sym_comment] = ACTIONS(87),
  },
  [5278] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8356),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [5279] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(8350),
    [sym__binary_star] = ACTIONS(8352),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(8354),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8356),
    [anon_sym_AMP] = ACTIONS(8358),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(8360),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(8362),
    [anon_sym_DOT_DOT] = ACTIONS(8364),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8366),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(8368),
    [anon_sym_AMP_AMP] = ACTIONS(8368),
    [anon_sym_LT_LT] = ACTIONS(8370),
    [anon_sym_GT_GT] = ACTIONS(8370),
    [anon_sym_EQ_EQ] = ACTIONS(8368),
    [anon_sym_BANG_EQ] = ACTIONS(8372),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8372),
    [anon_sym_LT_EQ_GT] = ACTIONS(8372),
    [anon_sym_EQ_TILDE] = ACTIONS(8372),
    [anon_sym_BANG_TILDE] = ACTIONS(8372),
    [anon_sym_LT_EQ] = ACTIONS(8360),
    [anon_sym_GT] = ACTIONS(8360),
    [anon_sym_GT_EQ] = ACTIONS(8374),
    [anon_sym_CARET] = ACTIONS(8354),
    [anon_sym_PLUS] = ACTIONS(8376),
    [anon_sym_SLASH] = ACTIONS(8356),
    [anon_sym_PERCENT] = ACTIONS(8356),
    [sym_comment] = ACTIONS(87),
  },
  [5280] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(7763),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2800),
    [sym_scope_resolution] = STATE(2798),
    [sym_call] = STATE(2798),
    [sym_method_call] = STATE(2800),
    [sym_assignment] = STATE(7763),
    [sym_operator_assignment] = STATE(7763),
    [sym_conditional] = STATE(7763),
    [sym_range] = STATE(7763),
    [sym_binary] = STATE(7763),
    [sym_unary] = STATE(7763),
    [sym_left_assignment_list] = STATE(2799),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2800),
    [sym__variable] = STATE(2798),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2800),
    [sym_false] = STATE(2800),
    [sym_nil] = STATE(2800),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2801),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(4693),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(4695),
    [anon_sym_yield] = ACTIONS(4697),
    [anon_sym_break] = ACTIONS(4699),
    [anon_sym_next] = ACTIONS(4701),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(4703),
    [anon_sym_defined_QMARK] = ACTIONS(4705),
    [anon_sym_not] = ACTIONS(4707),
    [anon_sym_BANG] = ACTIONS(4709),
    [anon_sym_TILDE] = ACTIONS(4709),
    [sym_constant] = ACTIONS(4711),
    [sym_identifier] = ACTIONS(4711),
    [sym_instance_variable] = ACTIONS(4713),
    [sym_class_variable] = ACTIONS(4713),
    [sym_global_variable] = ACTIONS(4713),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(4711),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4711),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [5281] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(7764),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2800),
    [sym_scope_resolution] = STATE(2798),
    [sym_call] = STATE(2798),
    [sym_method_call] = STATE(2800),
    [sym_assignment] = STATE(7764),
    [sym_operator_assignment] = STATE(7764),
    [sym_conditional] = STATE(7764),
    [sym_range] = STATE(7764),
    [sym_binary] = STATE(7764),
    [sym_unary] = STATE(7764),
    [sym_left_assignment_list] = STATE(2799),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2800),
    [sym__variable] = STATE(2798),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2800),
    [sym_false] = STATE(2800),
    [sym_nil] = STATE(2800),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2801),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(4693),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(4695),
    [anon_sym_yield] = ACTIONS(4697),
    [anon_sym_break] = ACTIONS(4699),
    [anon_sym_next] = ACTIONS(4701),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(4703),
    [anon_sym_defined_QMARK] = ACTIONS(4705),
    [anon_sym_not] = ACTIONS(4707),
    [anon_sym_BANG] = ACTIONS(4709),
    [anon_sym_TILDE] = ACTIONS(4709),
    [sym_constant] = ACTIONS(4711),
    [sym_identifier] = ACTIONS(4711),
    [sym_instance_variable] = ACTIONS(4713),
    [sym_class_variable] = ACTIONS(4713),
    [sym_global_variable] = ACTIONS(4713),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(4711),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4711),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [5282] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(7765),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2800),
    [sym_scope_resolution] = STATE(2798),
    [sym_call] = STATE(2798),
    [sym_method_call] = STATE(2800),
    [sym_assignment] = STATE(7765),
    [sym_operator_assignment] = STATE(7765),
    [sym_conditional] = STATE(7765),
    [sym_range] = STATE(7765),
    [sym_binary] = STATE(7765),
    [sym_unary] = STATE(7765),
    [sym_left_assignment_list] = STATE(2799),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2800),
    [sym__variable] = STATE(2798),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2800),
    [sym_false] = STATE(2800),
    [sym_nil] = STATE(2800),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2801),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(4693),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(4695),
    [anon_sym_yield] = ACTIONS(4697),
    [anon_sym_break] = ACTIONS(4699),
    [anon_sym_next] = ACTIONS(4701),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(4703),
    [anon_sym_defined_QMARK] = ACTIONS(4705),
    [anon_sym_not] = ACTIONS(4707),
    [anon_sym_BANG] = ACTIONS(4709),
    [anon_sym_TILDE] = ACTIONS(4709),
    [sym_constant] = ACTIONS(4711),
    [sym_identifier] = ACTIONS(4711),
    [sym_instance_variable] = ACTIONS(4713),
    [sym_class_variable] = ACTIONS(4713),
    [sym_global_variable] = ACTIONS(4713),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(4711),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4711),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [5283] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(7766),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2800),
    [sym_scope_resolution] = STATE(2798),
    [sym_call] = STATE(2798),
    [sym_method_call] = STATE(2800),
    [sym_assignment] = STATE(7766),
    [sym_operator_assignment] = STATE(7766),
    [sym_conditional] = STATE(7766),
    [sym_range] = STATE(7766),
    [sym_binary] = STATE(7766),
    [sym_unary] = STATE(7766),
    [sym_left_assignment_list] = STATE(2799),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2800),
    [sym__variable] = STATE(2798),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2800),
    [sym_false] = STATE(2800),
    [sym_nil] = STATE(2800),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2801),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(4693),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(4695),
    [anon_sym_yield] = ACTIONS(4697),
    [anon_sym_break] = ACTIONS(4699),
    [anon_sym_next] = ACTIONS(4701),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(4703),
    [anon_sym_defined_QMARK] = ACTIONS(4705),
    [anon_sym_not] = ACTIONS(4707),
    [anon_sym_BANG] = ACTIONS(4709),
    [anon_sym_TILDE] = ACTIONS(4709),
    [sym_constant] = ACTIONS(4711),
    [sym_identifier] = ACTIONS(4711),
    [sym_instance_variable] = ACTIONS(4713),
    [sym_class_variable] = ACTIONS(4713),
    [sym_global_variable] = ACTIONS(4713),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(4711),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4711),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [5284] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(7767),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2800),
    [sym_scope_resolution] = STATE(2798),
    [sym_call] = STATE(2798),
    [sym_method_call] = STATE(2800),
    [sym_assignment] = STATE(7767),
    [sym_operator_assignment] = STATE(7767),
    [sym_conditional] = STATE(7767),
    [sym_range] = STATE(7767),
    [sym_binary] = STATE(7767),
    [sym_unary] = STATE(7767),
    [sym_left_assignment_list] = STATE(2799),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2800),
    [sym__variable] = STATE(2798),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2800),
    [sym_false] = STATE(2800),
    [sym_nil] = STATE(2800),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2801),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(4693),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(4695),
    [anon_sym_yield] = ACTIONS(4697),
    [anon_sym_break] = ACTIONS(4699),
    [anon_sym_next] = ACTIONS(4701),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(4703),
    [anon_sym_defined_QMARK] = ACTIONS(4705),
    [anon_sym_not] = ACTIONS(4707),
    [anon_sym_BANG] = ACTIONS(4709),
    [anon_sym_TILDE] = ACTIONS(4709),
    [sym_constant] = ACTIONS(4711),
    [sym_identifier] = ACTIONS(4711),
    [sym_instance_variable] = ACTIONS(4713),
    [sym_class_variable] = ACTIONS(4713),
    [sym_global_variable] = ACTIONS(4713),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(4711),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4711),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [5285] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(7768),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(7768),
    [sym_operator_assignment] = STATE(7768),
    [sym_conditional] = STATE(7768),
    [sym_range] = STATE(7768),
    [sym_binary] = STATE(7768),
    [sym_unary] = STATE(7768),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5286] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(7769),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2800),
    [sym_scope_resolution] = STATE(2798),
    [sym_call] = STATE(2798),
    [sym_method_call] = STATE(2800),
    [sym_assignment] = STATE(7769),
    [sym_operator_assignment] = STATE(7769),
    [sym_conditional] = STATE(7769),
    [sym_range] = STATE(7769),
    [sym_binary] = STATE(7769),
    [sym_unary] = STATE(7769),
    [sym_left_assignment_list] = STATE(2799),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2800),
    [sym__variable] = STATE(2798),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2800),
    [sym_false] = STATE(2800),
    [sym_nil] = STATE(2800),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2801),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(4693),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(4695),
    [anon_sym_yield] = ACTIONS(4697),
    [anon_sym_break] = ACTIONS(4699),
    [anon_sym_next] = ACTIONS(4701),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(4703),
    [anon_sym_defined_QMARK] = ACTIONS(4705),
    [anon_sym_not] = ACTIONS(4707),
    [anon_sym_BANG] = ACTIONS(4709),
    [anon_sym_TILDE] = ACTIONS(4709),
    [sym_constant] = ACTIONS(4711),
    [sym_identifier] = ACTIONS(4711),
    [sym_instance_variable] = ACTIONS(4713),
    [sym_class_variable] = ACTIONS(4713),
    [sym_global_variable] = ACTIONS(4713),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(4711),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4711),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [5287] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(7770),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2800),
    [sym_scope_resolution] = STATE(2798),
    [sym_call] = STATE(2798),
    [sym_method_call] = STATE(2800),
    [sym_assignment] = STATE(7770),
    [sym_operator_assignment] = STATE(7770),
    [sym_conditional] = STATE(7770),
    [sym_range] = STATE(7770),
    [sym_binary] = STATE(7770),
    [sym_unary] = STATE(7770),
    [sym_left_assignment_list] = STATE(2799),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2800),
    [sym__variable] = STATE(2798),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2800),
    [sym_false] = STATE(2800),
    [sym_nil] = STATE(2800),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2801),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(4693),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(4695),
    [anon_sym_yield] = ACTIONS(4697),
    [anon_sym_break] = ACTIONS(4699),
    [anon_sym_next] = ACTIONS(4701),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(4703),
    [anon_sym_defined_QMARK] = ACTIONS(4705),
    [anon_sym_not] = ACTIONS(4707),
    [anon_sym_BANG] = ACTIONS(4709),
    [anon_sym_TILDE] = ACTIONS(4709),
    [sym_constant] = ACTIONS(4711),
    [sym_identifier] = ACTIONS(4711),
    [sym_instance_variable] = ACTIONS(4713),
    [sym_class_variable] = ACTIONS(4713),
    [sym_global_variable] = ACTIONS(4713),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(4711),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4711),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [5288] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(7771),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2800),
    [sym_scope_resolution] = STATE(2798),
    [sym_call] = STATE(2798),
    [sym_method_call] = STATE(2800),
    [sym_assignment] = STATE(7771),
    [sym_operator_assignment] = STATE(7771),
    [sym_conditional] = STATE(7771),
    [sym_range] = STATE(7771),
    [sym_binary] = STATE(7771),
    [sym_unary] = STATE(7771),
    [sym_left_assignment_list] = STATE(2799),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2800),
    [sym__variable] = STATE(2798),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2800),
    [sym_false] = STATE(2800),
    [sym_nil] = STATE(2800),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2801),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(4693),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(4695),
    [anon_sym_yield] = ACTIONS(4697),
    [anon_sym_break] = ACTIONS(4699),
    [anon_sym_next] = ACTIONS(4701),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(4703),
    [anon_sym_defined_QMARK] = ACTIONS(4705),
    [anon_sym_not] = ACTIONS(4707),
    [anon_sym_BANG] = ACTIONS(4709),
    [anon_sym_TILDE] = ACTIONS(4709),
    [sym_constant] = ACTIONS(4711),
    [sym_identifier] = ACTIONS(4711),
    [sym_instance_variable] = ACTIONS(4713),
    [sym_class_variable] = ACTIONS(4713),
    [sym_global_variable] = ACTIONS(4713),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(4711),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4711),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [5289] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(7772),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2800),
    [sym_scope_resolution] = STATE(2798),
    [sym_call] = STATE(2798),
    [sym_method_call] = STATE(2800),
    [sym_assignment] = STATE(7772),
    [sym_operator_assignment] = STATE(7772),
    [sym_conditional] = STATE(7772),
    [sym_range] = STATE(7772),
    [sym_binary] = STATE(7772),
    [sym_unary] = STATE(7772),
    [sym_left_assignment_list] = STATE(2799),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2800),
    [sym__variable] = STATE(2798),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2800),
    [sym_false] = STATE(2800),
    [sym_nil] = STATE(2800),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2801),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(4693),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(4695),
    [anon_sym_yield] = ACTIONS(4697),
    [anon_sym_break] = ACTIONS(4699),
    [anon_sym_next] = ACTIONS(4701),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(4703),
    [anon_sym_defined_QMARK] = ACTIONS(4705),
    [anon_sym_not] = ACTIONS(4707),
    [anon_sym_BANG] = ACTIONS(4709),
    [anon_sym_TILDE] = ACTIONS(4709),
    [sym_constant] = ACTIONS(4711),
    [sym_identifier] = ACTIONS(4711),
    [sym_instance_variable] = ACTIONS(4713),
    [sym_class_variable] = ACTIONS(4713),
    [sym_global_variable] = ACTIONS(4713),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(4711),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4711),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [5290] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(7773),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2800),
    [sym_scope_resolution] = STATE(2798),
    [sym_call] = STATE(2798),
    [sym_method_call] = STATE(2800),
    [sym_splat_argument] = STATE(7774),
    [sym_assignment] = STATE(7773),
    [sym_operator_assignment] = STATE(7773),
    [sym_conditional] = STATE(7773),
    [sym_range] = STATE(7773),
    [sym_binary] = STATE(7773),
    [sym_unary] = STATE(7773),
    [sym_right_assignment_list] = STATE(6323),
    [sym__arg_or_splat_arg] = STATE(7774),
    [sym_left_assignment_list] = STATE(2799),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2800),
    [sym__variable] = STATE(2798),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2800),
    [sym_false] = STATE(2800),
    [sym_nil] = STATE(2800),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2801),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__splat_star] = ACTIONS(1885),
    [sym__unary_minus] = ACTIONS(4693),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(4695),
    [anon_sym_yield] = ACTIONS(4697),
    [anon_sym_break] = ACTIONS(4699),
    [anon_sym_next] = ACTIONS(4701),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(4703),
    [anon_sym_defined_QMARK] = ACTIONS(4705),
    [anon_sym_not] = ACTIONS(4707),
    [anon_sym_BANG] = ACTIONS(4709),
    [anon_sym_TILDE] = ACTIONS(4709),
    [sym_constant] = ACTIONS(4711),
    [sym_identifier] = ACTIONS(4711),
    [sym_instance_variable] = ACTIONS(4713),
    [sym_class_variable] = ACTIONS(4713),
    [sym_global_variable] = ACTIONS(4713),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(4711),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4711),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [5291] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(7775),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2800),
    [sym_scope_resolution] = STATE(2798),
    [sym_call] = STATE(2798),
    [sym_method_call] = STATE(2800),
    [sym_assignment] = STATE(7775),
    [sym_operator_assignment] = STATE(7775),
    [sym_conditional] = STATE(7775),
    [sym_range] = STATE(7775),
    [sym_binary] = STATE(7775),
    [sym_unary] = STATE(7775),
    [sym_left_assignment_list] = STATE(2799),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2800),
    [sym__variable] = STATE(2798),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2800),
    [sym_false] = STATE(2800),
    [sym_nil] = STATE(2800),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2801),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(4693),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(4695),
    [anon_sym_yield] = ACTIONS(4697),
    [anon_sym_break] = ACTIONS(4699),
    [anon_sym_next] = ACTIONS(4701),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(4703),
    [anon_sym_defined_QMARK] = ACTIONS(4705),
    [anon_sym_not] = ACTIONS(4707),
    [anon_sym_BANG] = ACTIONS(4709),
    [anon_sym_TILDE] = ACTIONS(4709),
    [sym_constant] = ACTIONS(4711),
    [sym_identifier] = ACTIONS(4711),
    [sym_instance_variable] = ACTIONS(4713),
    [sym_class_variable] = ACTIONS(4713),
    [sym_global_variable] = ACTIONS(4713),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(4711),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4711),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [5292] = {
    [sym_string] = STATE(7776),
    [aux_sym_chained_string_repeat1] = STATE(7776),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(2551),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2755),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_EQ] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_PLUS_EQ] = ACTIONS(2753),
    [anon_sym_DASH_EQ] = ACTIONS(2753),
    [anon_sym_STAR_EQ] = ACTIONS(2753),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2753),
    [anon_sym_SLASH_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2753),
    [anon_sym_AMP_EQ] = ACTIONS(2753),
    [anon_sym_PERCENT_EQ] = ACTIONS(2753),
    [anon_sym_GT_GT_EQ] = ACTIONS(2753),
    [anon_sym_LT_LT_EQ] = ACTIONS(2753),
    [anon_sym_CARET_EQ] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2755),
    [anon_sym_AMP_AMP] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2755),
    [anon_sym_GT_GT] = ACTIONS(2755),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_SLASH] = ACTIONS(2755),
    [anon_sym_PERCENT] = ACTIONS(2755),
    [sym_comment] = ACTIONS(87),
  },
  [5293] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(8350),
    [sym__binary_star] = ACTIONS(8352),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(8354),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(8356),
    [anon_sym_AMP] = ACTIONS(8358),
    [anon_sym_EQ] = ACTIONS(7822),
    [anon_sym_LT] = ACTIONS(8360),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_PLUS_EQ] = ACTIONS(6823),
    [anon_sym_DASH_EQ] = ACTIONS(6823),
    [anon_sym_STAR_EQ] = ACTIONS(6823),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6823),
    [anon_sym_SLASH_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6823),
    [anon_sym_AMP_EQ] = ACTIONS(6823),
    [anon_sym_PERCENT_EQ] = ACTIONS(6823),
    [anon_sym_GT_GT_EQ] = ACTIONS(6823),
    [anon_sym_LT_LT_EQ] = ACTIONS(6823),
    [anon_sym_CARET_EQ] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(8362),
    [anon_sym_DOT_DOT] = ACTIONS(8364),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8366),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(8368),
    [anon_sym_AMP_AMP] = ACTIONS(8368),
    [anon_sym_LT_LT] = ACTIONS(8370),
    [anon_sym_GT_GT] = ACTIONS(8370),
    [anon_sym_EQ_EQ] = ACTIONS(8368),
    [anon_sym_BANG_EQ] = ACTIONS(8372),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8372),
    [anon_sym_LT_EQ_GT] = ACTIONS(8372),
    [anon_sym_EQ_TILDE] = ACTIONS(8372),
    [anon_sym_BANG_TILDE] = ACTIONS(8372),
    [anon_sym_LT_EQ] = ACTIONS(8360),
    [anon_sym_GT] = ACTIONS(8360),
    [anon_sym_GT_EQ] = ACTIONS(8374),
    [anon_sym_CARET] = ACTIONS(8354),
    [anon_sym_PLUS] = ACTIONS(8376),
    [anon_sym_SLASH] = ACTIONS(8356),
    [anon_sym_PERCENT] = ACTIONS(8356),
    [sym_comment] = ACTIONS(87),
  },
  [5294] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(8350),
    [sym__binary_star] = ACTIONS(8352),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(8354),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(8356),
    [anon_sym_AMP] = ACTIONS(8358),
    [anon_sym_EQ] = ACTIONS(7884),
    [anon_sym_LT] = ACTIONS(8360),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_PLUS_EQ] = ACTIONS(7027),
    [anon_sym_DASH_EQ] = ACTIONS(7027),
    [anon_sym_STAR_EQ] = ACTIONS(7027),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7027),
    [anon_sym_SLASH_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7027),
    [anon_sym_AMP_EQ] = ACTIONS(7027),
    [anon_sym_PERCENT_EQ] = ACTIONS(7027),
    [anon_sym_GT_GT_EQ] = ACTIONS(7027),
    [anon_sym_LT_LT_EQ] = ACTIONS(7027),
    [anon_sym_CARET_EQ] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(8362),
    [anon_sym_DOT_DOT] = ACTIONS(8364),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8366),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(8368),
    [anon_sym_AMP_AMP] = ACTIONS(8368),
    [anon_sym_LT_LT] = ACTIONS(8370),
    [anon_sym_GT_GT] = ACTIONS(8370),
    [anon_sym_EQ_EQ] = ACTIONS(8368),
    [anon_sym_BANG_EQ] = ACTIONS(8372),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8372),
    [anon_sym_LT_EQ_GT] = ACTIONS(8372),
    [anon_sym_EQ_TILDE] = ACTIONS(8372),
    [anon_sym_BANG_TILDE] = ACTIONS(8372),
    [anon_sym_LT_EQ] = ACTIONS(8360),
    [anon_sym_GT] = ACTIONS(8360),
    [anon_sym_GT_EQ] = ACTIONS(8374),
    [anon_sym_CARET] = ACTIONS(8354),
    [anon_sym_PLUS] = ACTIONS(8376),
    [anon_sym_SLASH] = ACTIONS(8356),
    [anon_sym_PERCENT] = ACTIONS(8356),
    [sym_comment] = ACTIONS(87),
  },
  [5295] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(4725),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(4729),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(4729),
    [anon_sym_PERCENT] = ACTIONS(4729),
    [sym_comment] = ACTIONS(87),
  },
  [5296] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(4729),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(5827),
    [anon_sym_PERCENT] = ACTIONS(5827),
    [sym_comment] = ACTIONS(87),
  },
  [5297] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4723),
    [sym__binary_star] = ACTIONS(4725),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(4729),
    [anon_sym_AMP] = ACTIONS(4731),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(4743),
    [anon_sym_GT_GT] = ACTIONS(4743),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(4749),
    [anon_sym_SLASH] = ACTIONS(4729),
    [anon_sym_PERCENT] = ACTIONS(4729),
    [sym_comment] = ACTIONS(87),
  },
  [5298] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4723),
    [sym__binary_star] = ACTIONS(4725),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(4729),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(4743),
    [anon_sym_GT_GT] = ACTIONS(4743),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(4749),
    [anon_sym_SLASH] = ACTIONS(4729),
    [anon_sym_PERCENT] = ACTIONS(4729),
    [sym_comment] = ACTIONS(87),
  },
  [5299] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4723),
    [sym__binary_star] = ACTIONS(4725),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(4727),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(4729),
    [anon_sym_AMP] = ACTIONS(4731),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(4743),
    [anon_sym_GT_GT] = ACTIONS(4743),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(4727),
    [anon_sym_PLUS] = ACTIONS(4749),
    [anon_sym_SLASH] = ACTIONS(4729),
    [anon_sym_PERCENT] = ACTIONS(4729),
    [sym_comment] = ACTIONS(87),
  },
  [5300] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(11339),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [5301] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(4723),
    [sym__binary_star] = ACTIONS(4725),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(4727),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(4729),
    [anon_sym_AMP] = ACTIONS(4731),
    [anon_sym_EQ] = ACTIONS(7888),
    [anon_sym_LT] = ACTIONS(4733),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_EQ_GT] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_PLUS_EQ] = ACTIONS(5927),
    [anon_sym_DASH_EQ] = ACTIONS(5927),
    [anon_sym_STAR_EQ] = ACTIONS(5927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5927),
    [anon_sym_SLASH_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5927),
    [anon_sym_AMP_EQ] = ACTIONS(5927),
    [anon_sym_PERCENT_EQ] = ACTIONS(5927),
    [anon_sym_GT_GT_EQ] = ACTIONS(5927),
    [anon_sym_LT_LT_EQ] = ACTIONS(5927),
    [anon_sym_CARET_EQ] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(4737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4739),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(4741),
    [anon_sym_AMP_AMP] = ACTIONS(4741),
    [anon_sym_LT_LT] = ACTIONS(4743),
    [anon_sym_GT_GT] = ACTIONS(4743),
    [anon_sym_EQ_EQ] = ACTIONS(4741),
    [anon_sym_BANG_EQ] = ACTIONS(4745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4745),
    [anon_sym_LT_EQ_GT] = ACTIONS(4745),
    [anon_sym_EQ_TILDE] = ACTIONS(4745),
    [anon_sym_BANG_TILDE] = ACTIONS(4745),
    [anon_sym_LT_EQ] = ACTIONS(4733),
    [anon_sym_GT] = ACTIONS(4733),
    [anon_sym_GT_EQ] = ACTIONS(4747),
    [anon_sym_CARET] = ACTIONS(4727),
    [anon_sym_PLUS] = ACTIONS(4749),
    [anon_sym_SLASH] = ACTIONS(4729),
    [anon_sym_PERCENT] = ACTIONS(4729),
    [sym_comment] = ACTIONS(87),
  },
  [5302] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4723),
    [sym__binary_star] = ACTIONS(4725),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(4727),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(4729),
    [anon_sym_AMP] = ACTIONS(4731),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(4733),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(4735),
    [anon_sym_DOT_DOT] = ACTIONS(4737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4739),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(4741),
    [anon_sym_AMP_AMP] = ACTIONS(4741),
    [anon_sym_LT_LT] = ACTIONS(4743),
    [anon_sym_GT_GT] = ACTIONS(4743),
    [anon_sym_EQ_EQ] = ACTIONS(4741),
    [anon_sym_BANG_EQ] = ACTIONS(4745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4745),
    [anon_sym_LT_EQ_GT] = ACTIONS(4745),
    [anon_sym_EQ_TILDE] = ACTIONS(4745),
    [anon_sym_BANG_TILDE] = ACTIONS(4745),
    [anon_sym_LT_EQ] = ACTIONS(4733),
    [anon_sym_GT] = ACTIONS(4733),
    [anon_sym_GT_EQ] = ACTIONS(4747),
    [anon_sym_CARET] = ACTIONS(4727),
    [anon_sym_PLUS] = ACTIONS(4749),
    [anon_sym_SLASH] = ACTIONS(4729),
    [anon_sym_PERCENT] = ACTIONS(4729),
    [sym_comment] = ACTIONS(87),
  },
  [5303] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4723),
    [sym__binary_star] = ACTIONS(4725),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(4727),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(4729),
    [anon_sym_AMP] = ACTIONS(4731),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(4733),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(4743),
    [anon_sym_GT_GT] = ACTIONS(4743),
    [anon_sym_EQ_EQ] = ACTIONS(4741),
    [anon_sym_BANG_EQ] = ACTIONS(4745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4745),
    [anon_sym_LT_EQ_GT] = ACTIONS(4745),
    [anon_sym_EQ_TILDE] = ACTIONS(4745),
    [anon_sym_BANG_TILDE] = ACTIONS(4745),
    [anon_sym_LT_EQ] = ACTIONS(4733),
    [anon_sym_GT] = ACTIONS(4733),
    [anon_sym_GT_EQ] = ACTIONS(4747),
    [anon_sym_CARET] = ACTIONS(4727),
    [anon_sym_PLUS] = ACTIONS(4749),
    [anon_sym_SLASH] = ACTIONS(4729),
    [anon_sym_PERCENT] = ACTIONS(4729),
    [sym_comment] = ACTIONS(87),
  },
  [5304] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4723),
    [sym__binary_star] = ACTIONS(4725),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(4729),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(4749),
    [anon_sym_SLASH] = ACTIONS(4729),
    [anon_sym_PERCENT] = ACTIONS(4729),
    [sym_comment] = ACTIONS(87),
  },
  [5305] = {
    [sym_heredoc_body] = STATE(5305),
    [aux_sym_call_repeat1] = STATE(5305),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(9846),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7919),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_EQ] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_PLUS_EQ] = ACTIONS(7914),
    [anon_sym_DASH_EQ] = ACTIONS(7914),
    [anon_sym_STAR_EQ] = ACTIONS(7914),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7914),
    [anon_sym_SLASH_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7914),
    [anon_sym_AMP_EQ] = ACTIONS(7914),
    [anon_sym_PERCENT_EQ] = ACTIONS(7914),
    [anon_sym_GT_GT_EQ] = ACTIONS(7914),
    [anon_sym_LT_LT_EQ] = ACTIONS(7914),
    [anon_sym_CARET_EQ] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7919),
    [anon_sym_AMP_AMP] = ACTIONS(7919),
    [anon_sym_LT_LT] = ACTIONS(7919),
    [anon_sym_GT_GT] = ACTIONS(7919),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7919),
    [anon_sym_PLUS] = ACTIONS(7919),
    [anon_sym_SLASH] = ACTIONS(7919),
    [anon_sym_PERCENT] = ACTIONS(7919),
    [sym_comment] = ACTIONS(87),
  },
  [5306] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(1060),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1066),
    [sym_scope_resolution] = STATE(1061),
    [sym_call] = STATE(1061),
    [sym_method_call] = STATE(1066),
    [sym__argument] = STATE(6393),
    [sym_splat_argument] = STATE(6393),
    [sym_hash_splat_argument] = STATE(6393),
    [sym_block_argument] = STATE(6393),
    [sym_assignment] = STATE(1060),
    [sym_operator_assignment] = STATE(1060),
    [sym_conditional] = STATE(1060),
    [sym_range] = STATE(1060),
    [sym_binary] = STATE(1060),
    [sym_unary] = STATE(1060),
    [sym_left_assignment_list] = STATE(1065),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1066),
    [sym__variable] = STATE(1061),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1066),
    [sym_false] = STATE(1066),
    [sym_nil] = STATE(1066),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(1067),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(6393),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(1883),
    [sym__splat_star] = ACTIONS(1885),
    [sym__unary_minus] = ACTIONS(1887),
    [sym__identifier_hash_key] = ACTIONS(1889),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(8384),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1895),
    [anon_sym_break] = ACTIONS(1897),
    [anon_sym_next] = ACTIONS(1899),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(4715),
    [anon_sym_defined_QMARK] = ACTIONS(1909),
    [anon_sym_not] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1915),
    [anon_sym_TILDE] = ACTIONS(1915),
    [sym_constant] = ACTIONS(1917),
    [sym_identifier] = ACTIONS(1917),
    [sym_instance_variable] = ACTIONS(1919),
    [sym_class_variable] = ACTIONS(1919),
    [sym_global_variable] = ACTIONS(1919),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1921),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1921),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5307] = {
    [sym_heredoc_body] = STATE(5305),
    [aux_sym_call_repeat1] = STATE(5305),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7931),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_EQ] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_PLUS_EQ] = ACTIONS(7929),
    [anon_sym_DASH_EQ] = ACTIONS(7929),
    [anon_sym_STAR_EQ] = ACTIONS(7929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7929),
    [anon_sym_SLASH_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7929),
    [anon_sym_AMP_EQ] = ACTIONS(7929),
    [anon_sym_PERCENT_EQ] = ACTIONS(7929),
    [anon_sym_GT_GT_EQ] = ACTIONS(7929),
    [anon_sym_LT_LT_EQ] = ACTIONS(7929),
    [anon_sym_CARET_EQ] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7931),
    [anon_sym_AMP_AMP] = ACTIONS(7931),
    [anon_sym_LT_LT] = ACTIONS(7931),
    [anon_sym_GT_GT] = ACTIONS(7931),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7931),
    [anon_sym_PLUS] = ACTIONS(7931),
    [anon_sym_SLASH] = ACTIONS(7931),
    [anon_sym_PERCENT] = ACTIONS(7931),
    [sym_comment] = ACTIONS(87),
  },
  [5308] = {
    [aux_sym_argument_list_repeat1] = STATE(5308),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(11341),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7927),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_EQ] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_PLUS_EQ] = ACTIONS(7925),
    [anon_sym_DASH_EQ] = ACTIONS(7925),
    [anon_sym_STAR_EQ] = ACTIONS(7925),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7925),
    [anon_sym_SLASH_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7925),
    [anon_sym_AMP_EQ] = ACTIONS(7925),
    [anon_sym_PERCENT_EQ] = ACTIONS(7925),
    [anon_sym_GT_GT_EQ] = ACTIONS(7925),
    [anon_sym_LT_LT_EQ] = ACTIONS(7925),
    [anon_sym_CARET_EQ] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7927),
    [anon_sym_AMP_AMP] = ACTIONS(7927),
    [anon_sym_LT_LT] = ACTIONS(7927),
    [anon_sym_GT_GT] = ACTIONS(7927),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7927),
    [anon_sym_PLUS] = ACTIONS(7927),
    [anon_sym_SLASH] = ACTIONS(7927),
    [anon_sym_PERCENT] = ACTIONS(7927),
    [sym_comment] = ACTIONS(87),
  },
  [5309] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(4723),
    [sym__binary_star] = ACTIONS(4725),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(4727),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(4729),
    [anon_sym_AMP] = ACTIONS(4731),
    [anon_sym_EQ] = ACTIONS(7936),
    [anon_sym_LT] = ACTIONS(4733),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_EQ_GT] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_PLUS_EQ] = ACTIONS(5115),
    [anon_sym_DASH_EQ] = ACTIONS(5115),
    [anon_sym_STAR_EQ] = ACTIONS(5115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5115),
    [anon_sym_SLASH_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5115),
    [anon_sym_AMP_EQ] = ACTIONS(5115),
    [anon_sym_PERCENT_EQ] = ACTIONS(5115),
    [anon_sym_GT_GT_EQ] = ACTIONS(5115),
    [anon_sym_LT_LT_EQ] = ACTIONS(5115),
    [anon_sym_CARET_EQ] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(4735),
    [anon_sym_DOT_DOT] = ACTIONS(4737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4739),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(4741),
    [anon_sym_AMP_AMP] = ACTIONS(4741),
    [anon_sym_LT_LT] = ACTIONS(4743),
    [anon_sym_GT_GT] = ACTIONS(4743),
    [anon_sym_EQ_EQ] = ACTIONS(4741),
    [anon_sym_BANG_EQ] = ACTIONS(4745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4745),
    [anon_sym_LT_EQ_GT] = ACTIONS(4745),
    [anon_sym_EQ_TILDE] = ACTIONS(4745),
    [anon_sym_BANG_TILDE] = ACTIONS(4745),
    [anon_sym_LT_EQ] = ACTIONS(4733),
    [anon_sym_GT] = ACTIONS(4733),
    [anon_sym_GT_EQ] = ACTIONS(4747),
    [anon_sym_CARET] = ACTIONS(4727),
    [anon_sym_PLUS] = ACTIONS(4749),
    [anon_sym_SLASH] = ACTIONS(4729),
    [anon_sym_PERCENT] = ACTIONS(4729),
    [sym_comment] = ACTIONS(87),
  },
  [5310] = {
    [aux_sym_exceptions_repeat1] = STATE(7779),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6193),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_PLUS_EQ] = ACTIONS(6191),
    [anon_sym_DASH_EQ] = ACTIONS(6191),
    [anon_sym_STAR_EQ] = ACTIONS(6191),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6191),
    [anon_sym_SLASH_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6191),
    [anon_sym_AMP_EQ] = ACTIONS(6191),
    [anon_sym_PERCENT_EQ] = ACTIONS(6191),
    [anon_sym_GT_GT_EQ] = ACTIONS(6191),
    [anon_sym_LT_LT_EQ] = ACTIONS(6191),
    [anon_sym_CARET_EQ] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6193),
    [anon_sym_AMP_AMP] = ACTIONS(6193),
    [anon_sym_LT_LT] = ACTIONS(6193),
    [anon_sym_GT_GT] = ACTIONS(6193),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6193),
    [anon_sym_PLUS] = ACTIONS(6193),
    [anon_sym_SLASH] = ACTIONS(6193),
    [anon_sym_PERCENT] = ACTIONS(6193),
    [sym_comment] = ACTIONS(87),
  },
  [5311] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(4723),
    [sym__binary_star] = ACTIONS(4725),
    [anon_sym_LBRACE] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(4727),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(4729),
    [anon_sym_AMP] = ACTIONS(4731),
    [anon_sym_EQ] = ACTIONS(7938),
    [anon_sym_LT] = ACTIONS(4733),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_EQ_GT] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_PLUS_EQ] = ACTIONS(6210),
    [anon_sym_DASH_EQ] = ACTIONS(6210),
    [anon_sym_STAR_EQ] = ACTIONS(6210),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6210),
    [anon_sym_SLASH_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6210),
    [anon_sym_AMP_EQ] = ACTIONS(6210),
    [anon_sym_PERCENT_EQ] = ACTIONS(6210),
    [anon_sym_GT_GT_EQ] = ACTIONS(6210),
    [anon_sym_LT_LT_EQ] = ACTIONS(6210),
    [anon_sym_CARET_EQ] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(4735),
    [anon_sym_DOT_DOT] = ACTIONS(4737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4739),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(4741),
    [anon_sym_AMP_AMP] = ACTIONS(4741),
    [anon_sym_LT_LT] = ACTIONS(4743),
    [anon_sym_GT_GT] = ACTIONS(4743),
    [anon_sym_EQ_EQ] = ACTIONS(4741),
    [anon_sym_BANG_EQ] = ACTIONS(4745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4745),
    [anon_sym_LT_EQ_GT] = ACTIONS(4745),
    [anon_sym_EQ_TILDE] = ACTIONS(4745),
    [anon_sym_BANG_TILDE] = ACTIONS(4745),
    [anon_sym_LT_EQ] = ACTIONS(4733),
    [anon_sym_GT] = ACTIONS(4733),
    [anon_sym_GT_EQ] = ACTIONS(4747),
    [anon_sym_CARET] = ACTIONS(4727),
    [anon_sym_PLUS] = ACTIONS(4749),
    [anon_sym_SLASH] = ACTIONS(4729),
    [anon_sym_PERCENT] = ACTIONS(4729),
    [sym_comment] = ACTIONS(87),
  },
  [5312] = {
    [sym_string] = STATE(5312),
    [aux_sym_chained_string_repeat1] = STATE(5312),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(9852),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6217),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_EQ] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_do] = ACTIONS(6212),
    [anon_sym_EQ_GT] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_PLUS_EQ] = ACTIONS(6212),
    [anon_sym_DASH_EQ] = ACTIONS(6212),
    [anon_sym_STAR_EQ] = ACTIONS(6212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6212),
    [anon_sym_SLASH_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6212),
    [anon_sym_AMP_EQ] = ACTIONS(6212),
    [anon_sym_PERCENT_EQ] = ACTIONS(6212),
    [anon_sym_GT_GT_EQ] = ACTIONS(6212),
    [anon_sym_LT_LT_EQ] = ACTIONS(6212),
    [anon_sym_CARET_EQ] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6217),
    [anon_sym_AMP_AMP] = ACTIONS(6217),
    [anon_sym_LT_LT] = ACTIONS(6217),
    [anon_sym_GT_GT] = ACTIONS(6217),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6217),
    [anon_sym_PLUS] = ACTIONS(6217),
    [anon_sym_SLASH] = ACTIONS(6217),
    [anon_sym_PERCENT] = ACTIONS(6217),
    [sym_comment] = ACTIONS(87),
  },
  [5313] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(8386),
    [sym__binary_star] = ACTIONS(8388),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(8390),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(8388),
    [anon_sym_AMP] = ACTIONS(8392),
    [anon_sym_LT] = ACTIONS(8394),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(8396),
    [anon_sym_DOT_DOT] = ACTIONS(8398),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8400),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(8402),
    [anon_sym_AMP_AMP] = ACTIONS(8402),
    [anon_sym_LT_LT] = ACTIONS(8404),
    [anon_sym_GT_GT] = ACTIONS(8404),
    [anon_sym_EQ_EQ] = ACTIONS(8406),
    [anon_sym_BANG_EQ] = ACTIONS(8402),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8402),
    [anon_sym_LT_EQ_GT] = ACTIONS(8402),
    [anon_sym_EQ_TILDE] = ACTIONS(8402),
    [anon_sym_BANG_TILDE] = ACTIONS(8402),
    [anon_sym_LT_EQ] = ACTIONS(8394),
    [anon_sym_GT] = ACTIONS(8394),
    [anon_sym_GT_EQ] = ACTIONS(8408),
    [anon_sym_CARET] = ACTIONS(8410),
    [anon_sym_PLUS] = ACTIONS(8386),
    [anon_sym_SLASH] = ACTIONS(8388),
    [anon_sym_PERCENT] = ACTIONS(8388),
    [sym_comment] = ACTIONS(87),
  },
  [5314] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8388),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [5315] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(8386),
    [sym__binary_star] = ACTIONS(8388),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(8390),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8388),
    [anon_sym_AMP] = ACTIONS(8392),
    [anon_sym_LT] = ACTIONS(8394),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(8396),
    [anon_sym_DOT_DOT] = ACTIONS(8398),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8400),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(8402),
    [anon_sym_AMP_AMP] = ACTIONS(8402),
    [anon_sym_LT_LT] = ACTIONS(8404),
    [anon_sym_GT_GT] = ACTIONS(8404),
    [anon_sym_EQ_EQ] = ACTIONS(8406),
    [anon_sym_BANG_EQ] = ACTIONS(8402),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8402),
    [anon_sym_LT_EQ_GT] = ACTIONS(8402),
    [anon_sym_EQ_TILDE] = ACTIONS(8402),
    [anon_sym_BANG_TILDE] = ACTIONS(8402),
    [anon_sym_LT_EQ] = ACTIONS(8394),
    [anon_sym_GT] = ACTIONS(8394),
    [anon_sym_GT_EQ] = ACTIONS(8408),
    [anon_sym_CARET] = ACTIONS(8410),
    [anon_sym_PLUS] = ACTIONS(8386),
    [anon_sym_SLASH] = ACTIONS(8388),
    [anon_sym_PERCENT] = ACTIONS(8388),
    [sym_comment] = ACTIONS(87),
  },
  [5316] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7780),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2833),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2833),
    [sym_assignment] = STATE(7780),
    [sym_operator_assignment] = STATE(7780),
    [sym_conditional] = STATE(7780),
    [sym_range] = STATE(7780),
    [sym_binary] = STATE(7780),
    [sym_unary] = STATE(7780),
    [sym_left_assignment_list] = STATE(2832),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2833),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2833),
    [sym_false] = STATE(2833),
    [sym_nil] = STATE(2833),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2735),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4763),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4615),
    [anon_sym_yield] = ACTIONS(4617),
    [anon_sym_break] = ACTIONS(4619),
    [anon_sym_next] = ACTIONS(4621),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4765),
    [anon_sym_defined_QMARK] = ACTIONS(4767),
    [anon_sym_not] = ACTIONS(4769),
    [anon_sym_BANG] = ACTIONS(4771),
    [anon_sym_TILDE] = ACTIONS(4771),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5317] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7781),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2833),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2833),
    [sym_assignment] = STATE(7781),
    [sym_operator_assignment] = STATE(7781),
    [sym_conditional] = STATE(7781),
    [sym_range] = STATE(7781),
    [sym_binary] = STATE(7781),
    [sym_unary] = STATE(7781),
    [sym_left_assignment_list] = STATE(2832),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2833),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2833),
    [sym_false] = STATE(2833),
    [sym_nil] = STATE(2833),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2735),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4763),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4615),
    [anon_sym_yield] = ACTIONS(4617),
    [anon_sym_break] = ACTIONS(4619),
    [anon_sym_next] = ACTIONS(4621),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4765),
    [anon_sym_defined_QMARK] = ACTIONS(4767),
    [anon_sym_not] = ACTIONS(4769),
    [anon_sym_BANG] = ACTIONS(4771),
    [anon_sym_TILDE] = ACTIONS(4771),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5318] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7782),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2833),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2833),
    [sym_assignment] = STATE(7782),
    [sym_operator_assignment] = STATE(7782),
    [sym_conditional] = STATE(7782),
    [sym_range] = STATE(7782),
    [sym_binary] = STATE(7782),
    [sym_unary] = STATE(7782),
    [sym_left_assignment_list] = STATE(2832),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2833),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2833),
    [sym_false] = STATE(2833),
    [sym_nil] = STATE(2833),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2735),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4763),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4615),
    [anon_sym_yield] = ACTIONS(4617),
    [anon_sym_break] = ACTIONS(4619),
    [anon_sym_next] = ACTIONS(4621),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4765),
    [anon_sym_defined_QMARK] = ACTIONS(4767),
    [anon_sym_not] = ACTIONS(4769),
    [anon_sym_BANG] = ACTIONS(4771),
    [anon_sym_TILDE] = ACTIONS(4771),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5319] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7783),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2833),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2833),
    [sym_assignment] = STATE(7783),
    [sym_operator_assignment] = STATE(7783),
    [sym_conditional] = STATE(7783),
    [sym_range] = STATE(7783),
    [sym_binary] = STATE(7783),
    [sym_unary] = STATE(7783),
    [sym_left_assignment_list] = STATE(2832),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2833),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2833),
    [sym_false] = STATE(2833),
    [sym_nil] = STATE(2833),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2735),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4763),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4615),
    [anon_sym_yield] = ACTIONS(4617),
    [anon_sym_break] = ACTIONS(4619),
    [anon_sym_next] = ACTIONS(4621),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4765),
    [anon_sym_defined_QMARK] = ACTIONS(4767),
    [anon_sym_not] = ACTIONS(4769),
    [anon_sym_BANG] = ACTIONS(4771),
    [anon_sym_TILDE] = ACTIONS(4771),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5320] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7784),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2833),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2833),
    [sym_assignment] = STATE(7784),
    [sym_operator_assignment] = STATE(7784),
    [sym_conditional] = STATE(7784),
    [sym_range] = STATE(7784),
    [sym_binary] = STATE(7784),
    [sym_unary] = STATE(7784),
    [sym_left_assignment_list] = STATE(2832),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2833),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2833),
    [sym_false] = STATE(2833),
    [sym_nil] = STATE(2833),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2735),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4763),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4615),
    [anon_sym_yield] = ACTIONS(4617),
    [anon_sym_break] = ACTIONS(4619),
    [anon_sym_next] = ACTIONS(4621),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4765),
    [anon_sym_defined_QMARK] = ACTIONS(4767),
    [anon_sym_not] = ACTIONS(4769),
    [anon_sym_BANG] = ACTIONS(4771),
    [anon_sym_TILDE] = ACTIONS(4771),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5321] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(7785),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(7785),
    [sym_operator_assignment] = STATE(7785),
    [sym_conditional] = STATE(7785),
    [sym_range] = STATE(7785),
    [sym_binary] = STATE(7785),
    [sym_unary] = STATE(7785),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5322] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7786),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2833),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2833),
    [sym_assignment] = STATE(7786),
    [sym_operator_assignment] = STATE(7786),
    [sym_conditional] = STATE(7786),
    [sym_range] = STATE(7786),
    [sym_binary] = STATE(7786),
    [sym_unary] = STATE(7786),
    [sym_left_assignment_list] = STATE(2832),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2833),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2833),
    [sym_false] = STATE(2833),
    [sym_nil] = STATE(2833),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2735),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4763),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4615),
    [anon_sym_yield] = ACTIONS(4617),
    [anon_sym_break] = ACTIONS(4619),
    [anon_sym_next] = ACTIONS(4621),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4765),
    [anon_sym_defined_QMARK] = ACTIONS(4767),
    [anon_sym_not] = ACTIONS(4769),
    [anon_sym_BANG] = ACTIONS(4771),
    [anon_sym_TILDE] = ACTIONS(4771),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5323] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7787),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2833),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2833),
    [sym_assignment] = STATE(7787),
    [sym_operator_assignment] = STATE(7787),
    [sym_conditional] = STATE(7787),
    [sym_range] = STATE(7787),
    [sym_binary] = STATE(7787),
    [sym_unary] = STATE(7787),
    [sym_left_assignment_list] = STATE(2832),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2833),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2833),
    [sym_false] = STATE(2833),
    [sym_nil] = STATE(2833),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2735),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4763),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4615),
    [anon_sym_yield] = ACTIONS(4617),
    [anon_sym_break] = ACTIONS(4619),
    [anon_sym_next] = ACTIONS(4621),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4765),
    [anon_sym_defined_QMARK] = ACTIONS(4767),
    [anon_sym_not] = ACTIONS(4769),
    [anon_sym_BANG] = ACTIONS(4771),
    [anon_sym_TILDE] = ACTIONS(4771),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5324] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7788),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2833),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2833),
    [sym_assignment] = STATE(7788),
    [sym_operator_assignment] = STATE(7788),
    [sym_conditional] = STATE(7788),
    [sym_range] = STATE(7788),
    [sym_binary] = STATE(7788),
    [sym_unary] = STATE(7788),
    [sym_left_assignment_list] = STATE(2832),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2833),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2833),
    [sym_false] = STATE(2833),
    [sym_nil] = STATE(2833),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2735),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4763),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4615),
    [anon_sym_yield] = ACTIONS(4617),
    [anon_sym_break] = ACTIONS(4619),
    [anon_sym_next] = ACTIONS(4621),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4765),
    [anon_sym_defined_QMARK] = ACTIONS(4767),
    [anon_sym_not] = ACTIONS(4769),
    [anon_sym_BANG] = ACTIONS(4771),
    [anon_sym_TILDE] = ACTIONS(4771),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5325] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7789),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2833),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2833),
    [sym_assignment] = STATE(7789),
    [sym_operator_assignment] = STATE(7789),
    [sym_conditional] = STATE(7789),
    [sym_range] = STATE(7789),
    [sym_binary] = STATE(7789),
    [sym_unary] = STATE(7789),
    [sym_left_assignment_list] = STATE(2832),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2833),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2833),
    [sym_false] = STATE(2833),
    [sym_nil] = STATE(2833),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2735),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4763),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4615),
    [anon_sym_yield] = ACTIONS(4617),
    [anon_sym_break] = ACTIONS(4619),
    [anon_sym_next] = ACTIONS(4621),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4765),
    [anon_sym_defined_QMARK] = ACTIONS(4767),
    [anon_sym_not] = ACTIONS(4769),
    [anon_sym_BANG] = ACTIONS(4771),
    [anon_sym_TILDE] = ACTIONS(4771),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5326] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2830),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2833),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2833),
    [sym_splat_argument] = STATE(6406),
    [sym_assignment] = STATE(2830),
    [sym_operator_assignment] = STATE(2830),
    [sym_conditional] = STATE(2830),
    [sym_range] = STATE(2830),
    [sym_binary] = STATE(2830),
    [sym_unary] = STATE(2830),
    [sym__arg_or_splat_arg] = STATE(6406),
    [sym_left_assignment_list] = STATE(2832),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2833),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2833),
    [sym_false] = STATE(2833),
    [sym_nil] = STATE(2833),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2735),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(4761),
    [sym__unary_minus] = ACTIONS(4763),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4615),
    [anon_sym_yield] = ACTIONS(4617),
    [anon_sym_break] = ACTIONS(4619),
    [anon_sym_next] = ACTIONS(4621),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4765),
    [anon_sym_defined_QMARK] = ACTIONS(4767),
    [anon_sym_not] = ACTIONS(4769),
    [anon_sym_BANG] = ACTIONS(4771),
    [anon_sym_TILDE] = ACTIONS(4771),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5327] = {
    [aux_sym_exceptions_repeat1] = STATE(7790),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_COMMA] = ACTIONS(8412),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_do] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [5328] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2830),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2833),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2833),
    [sym_splat_argument] = STATE(7791),
    [sym_assignment] = STATE(2830),
    [sym_operator_assignment] = STATE(2830),
    [sym_conditional] = STATE(2830),
    [sym_range] = STATE(2830),
    [sym_binary] = STATE(2830),
    [sym_unary] = STATE(2830),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(7791),
    [sym_left_assignment_list] = STATE(2832),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2833),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2833),
    [sym_false] = STATE(2833),
    [sym_nil] = STATE(2833),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2735),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(4761),
    [sym__unary_minus] = ACTIONS(4763),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4615),
    [anon_sym_yield] = ACTIONS(4617),
    [anon_sym_break] = ACTIONS(4619),
    [anon_sym_next] = ACTIONS(4621),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4765),
    [anon_sym_defined_QMARK] = ACTIONS(4767),
    [anon_sym_not] = ACTIONS(4769),
    [anon_sym_BANG] = ACTIONS(4771),
    [anon_sym_TILDE] = ACTIONS(4771),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5329] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7792),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2833),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2833),
    [sym_assignment] = STATE(7792),
    [sym_operator_assignment] = STATE(7792),
    [sym_conditional] = STATE(7792),
    [sym_range] = STATE(7792),
    [sym_binary] = STATE(7792),
    [sym_unary] = STATE(7792),
    [sym_left_assignment_list] = STATE(2832),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2833),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2833),
    [sym_false] = STATE(2833),
    [sym_nil] = STATE(2833),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2735),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4763),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4615),
    [anon_sym_yield] = ACTIONS(4617),
    [anon_sym_break] = ACTIONS(4619),
    [anon_sym_next] = ACTIONS(4621),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4765),
    [anon_sym_defined_QMARK] = ACTIONS(4767),
    [anon_sym_not] = ACTIONS(4769),
    [anon_sym_BANG] = ACTIONS(4771),
    [anon_sym_TILDE] = ACTIONS(4771),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5330] = {
    [sym__line_break] = ACTIONS(11344),
    [sym__heredoc_body_start] = ACTIONS(11344),
    [sym__binary_minus] = ACTIONS(11344),
    [sym__binary_star] = ACTIONS(11344),
    [ts_builtin_sym_end] = ACTIONS(11344),
    [anon_sym___END__] = ACTIONS(11344),
    [anon_sym_LBRACE] = ACTIONS(11344),
    [anon_sym_RBRACE] = ACTIONS(11344),
    [anon_sym_RPAREN] = ACTIONS(11344),
    [anon_sym_DOT] = ACTIONS(11346),
    [anon_sym_COMMA] = ACTIONS(11344),
    [anon_sym_PIPE] = ACTIONS(11346),
    [anon_sym_SEMI] = ACTIONS(11344),
    [anon_sym_STAR_STAR] = ACTIONS(11344),
    [anon_sym_AMP] = ACTIONS(11346),
    [anon_sym_LT] = ACTIONS(11346),
    [anon_sym_end] = ACTIONS(11344),
    [anon_sym_if] = ACTIONS(11344),
    [anon_sym_unless] = ACTIONS(11344),
    [anon_sym_while] = ACTIONS(11344),
    [anon_sym_until] = ACTIONS(11344),
    [anon_sym_rescue] = ACTIONS(11344),
    [anon_sym_do] = ACTIONS(11344),
    [anon_sym_when] = ACTIONS(11344),
    [anon_sym_elsif] = ACTIONS(11344),
    [anon_sym_else] = ACTIONS(11344),
    [anon_sym_then] = ACTIONS(11344),
    [anon_sym_ensure] = ACTIONS(11344),
    [anon_sym_EQ_GT] = ACTIONS(11344),
    [anon_sym_LBRACK] = ACTIONS(11344),
    [anon_sym_COLON_COLON2] = ACTIONS(11344),
    [anon_sym_AMP_DOT] = ACTIONS(11344),
    [anon_sym_QMARK] = ACTIONS(11344),
    [anon_sym_DOT_DOT] = ACTIONS(11346),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11344),
    [anon_sym_and] = ACTIONS(11344),
    [anon_sym_or] = ACTIONS(11344),
    [anon_sym_PIPE_PIPE] = ACTIONS(11344),
    [anon_sym_AMP_AMP] = ACTIONS(11344),
    [anon_sym_LT_LT] = ACTIONS(11344),
    [anon_sym_GT_GT] = ACTIONS(11344),
    [anon_sym_EQ_EQ] = ACTIONS(11346),
    [anon_sym_BANG_EQ] = ACTIONS(11344),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11344),
    [anon_sym_LT_EQ_GT] = ACTIONS(11344),
    [anon_sym_EQ_TILDE] = ACTIONS(11344),
    [anon_sym_BANG_TILDE] = ACTIONS(11344),
    [anon_sym_LT_EQ] = ACTIONS(11346),
    [anon_sym_GT] = ACTIONS(11346),
    [anon_sym_GT_EQ] = ACTIONS(11344),
    [anon_sym_CARET] = ACTIONS(11344),
    [anon_sym_PLUS] = ACTIONS(11344),
    [anon_sym_SLASH] = ACTIONS(11344),
    [anon_sym_PERCENT] = ACTIONS(11344),
    [sym_comment] = ACTIONS(87),
  },
  [5331] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(8436),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_in] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [5332] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7793),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2848),
    [sym_scope_resolution] = STATE(2846),
    [sym_call] = STATE(2846),
    [sym_method_call] = STATE(2848),
    [sym_assignment] = STATE(7793),
    [sym_operator_assignment] = STATE(7793),
    [sym_conditional] = STATE(7793),
    [sym_range] = STATE(7793),
    [sym_binary] = STATE(7793),
    [sym_unary] = STATE(7793),
    [sym_left_assignment_list] = STATE(2847),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2848),
    [sym__variable] = STATE(2846),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2848),
    [sym_false] = STATE(2848),
    [sym_nil] = STATE(2848),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2849),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4775),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4777),
    [anon_sym_yield] = ACTIONS(4779),
    [anon_sym_break] = ACTIONS(4781),
    [anon_sym_next] = ACTIONS(4783),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4785),
    [anon_sym_defined_QMARK] = ACTIONS(4787),
    [anon_sym_not] = ACTIONS(4789),
    [anon_sym_BANG] = ACTIONS(4791),
    [anon_sym_TILDE] = ACTIONS(4791),
    [sym_constant] = ACTIONS(4793),
    [sym_identifier] = ACTIONS(4793),
    [sym_instance_variable] = ACTIONS(4795),
    [sym_class_variable] = ACTIONS(4795),
    [sym_global_variable] = ACTIONS(4795),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4793),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4793),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5333] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7794),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2848),
    [sym_scope_resolution] = STATE(2846),
    [sym_call] = STATE(2846),
    [sym_method_call] = STATE(2848),
    [sym_assignment] = STATE(7794),
    [sym_operator_assignment] = STATE(7794),
    [sym_conditional] = STATE(7794),
    [sym_range] = STATE(7794),
    [sym_binary] = STATE(7794),
    [sym_unary] = STATE(7794),
    [sym_left_assignment_list] = STATE(2847),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2848),
    [sym__variable] = STATE(2846),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2848),
    [sym_false] = STATE(2848),
    [sym_nil] = STATE(2848),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2849),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4775),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4777),
    [anon_sym_yield] = ACTIONS(4779),
    [anon_sym_break] = ACTIONS(4781),
    [anon_sym_next] = ACTIONS(4783),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4785),
    [anon_sym_defined_QMARK] = ACTIONS(4787),
    [anon_sym_not] = ACTIONS(4789),
    [anon_sym_BANG] = ACTIONS(4791),
    [anon_sym_TILDE] = ACTIONS(4791),
    [sym_constant] = ACTIONS(4793),
    [sym_identifier] = ACTIONS(4793),
    [sym_instance_variable] = ACTIONS(4795),
    [sym_class_variable] = ACTIONS(4795),
    [sym_global_variable] = ACTIONS(4795),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4793),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4793),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5334] = {
    [anon_sym_COLON] = ACTIONS(11348),
    [sym_comment] = ACTIONS(87),
  },
  [5335] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7796),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2848),
    [sym_scope_resolution] = STATE(2846),
    [sym_call] = STATE(2846),
    [sym_method_call] = STATE(2848),
    [sym_assignment] = STATE(7796),
    [sym_operator_assignment] = STATE(7796),
    [sym_conditional] = STATE(7796),
    [sym_range] = STATE(7796),
    [sym_binary] = STATE(7796),
    [sym_unary] = STATE(7796),
    [sym_left_assignment_list] = STATE(2847),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2848),
    [sym__variable] = STATE(2846),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2848),
    [sym_false] = STATE(2848),
    [sym_nil] = STATE(2848),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2849),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4775),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4777),
    [anon_sym_yield] = ACTIONS(4779),
    [anon_sym_break] = ACTIONS(4781),
    [anon_sym_next] = ACTIONS(4783),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4785),
    [anon_sym_defined_QMARK] = ACTIONS(4787),
    [anon_sym_not] = ACTIONS(4789),
    [anon_sym_BANG] = ACTIONS(4791),
    [anon_sym_TILDE] = ACTIONS(4791),
    [sym_constant] = ACTIONS(4793),
    [sym_identifier] = ACTIONS(4793),
    [sym_instance_variable] = ACTIONS(4795),
    [sym_class_variable] = ACTIONS(4795),
    [sym_global_variable] = ACTIONS(4795),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4793),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4793),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5336] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(11350),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [5337] = {
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(4811),
    [sym__binary_star] = ACTIONS(4813),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(4815),
    [anon_sym_STAR_STAR] = ACTIONS(4813),
    [anon_sym_AMP] = ACTIONS(4817),
    [anon_sym_LT] = ACTIONS(4819),
    [anon_sym_in] = ACTIONS(1625),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(11348),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(4821),
    [anon_sym_DOT_DOT] = ACTIONS(4823),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4825),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(4829),
    [anon_sym_AMP_AMP] = ACTIONS(4829),
    [anon_sym_LT_LT] = ACTIONS(4831),
    [anon_sym_GT_GT] = ACTIONS(4831),
    [anon_sym_EQ_EQ] = ACTIONS(4833),
    [anon_sym_BANG_EQ] = ACTIONS(4829),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4829),
    [anon_sym_LT_EQ_GT] = ACTIONS(4829),
    [anon_sym_EQ_TILDE] = ACTIONS(4829),
    [anon_sym_BANG_TILDE] = ACTIONS(4829),
    [anon_sym_LT_EQ] = ACTIONS(4819),
    [anon_sym_GT] = ACTIONS(4819),
    [anon_sym_GT_EQ] = ACTIONS(4835),
    [anon_sym_CARET] = ACTIONS(4837),
    [anon_sym_PLUS] = ACTIONS(4811),
    [anon_sym_SLASH] = ACTIONS(4813),
    [anon_sym_PERCENT] = ACTIONS(4813),
    [sym_comment] = ACTIONS(87),
  },
  [5338] = {
    [sym_heredoc_body] = STATE(7798),
    [aux_sym_call_repeat1] = STATE(7798),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_in] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [5339] = {
    [sym_heredoc_body] = STATE(7798),
    [aux_sym_call_repeat1] = STATE(7798),
    [aux_sym_argument_list_repeat1] = STATE(7800),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(11352),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_in] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [5340] = {
    [sym_string] = STATE(2899),
    [aux_sym_chained_string_repeat1] = STATE(2899),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(11354),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_in] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [5341] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(8434),
    [sym__binary_star] = ACTIONS(8436),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(8438),
    [anon_sym_STAR_STAR] = ACTIONS(8436),
    [anon_sym_AMP] = ACTIONS(8440),
    [anon_sym_LT] = ACTIONS(8442),
    [anon_sym_in] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(8444),
    [anon_sym_DOT_DOT] = ACTIONS(8446),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8448),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(8452),
    [anon_sym_AMP_AMP] = ACTIONS(8452),
    [anon_sym_LT_LT] = ACTIONS(8454),
    [anon_sym_GT_GT] = ACTIONS(8454),
    [anon_sym_EQ_EQ] = ACTIONS(8456),
    [anon_sym_BANG_EQ] = ACTIONS(8452),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8452),
    [anon_sym_LT_EQ_GT] = ACTIONS(8452),
    [anon_sym_EQ_TILDE] = ACTIONS(8452),
    [anon_sym_BANG_TILDE] = ACTIONS(8452),
    [anon_sym_LT_EQ] = ACTIONS(8442),
    [anon_sym_GT] = ACTIONS(8442),
    [anon_sym_GT_EQ] = ACTIONS(8458),
    [anon_sym_CARET] = ACTIONS(8460),
    [anon_sym_PLUS] = ACTIONS(8434),
    [anon_sym_SLASH] = ACTIONS(8436),
    [anon_sym_PERCENT] = ACTIONS(8436),
    [sym_comment] = ACTIONS(87),
  },
  [5342] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7801),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2848),
    [sym_scope_resolution] = STATE(2846),
    [sym_call] = STATE(2846),
    [sym_method_call] = STATE(2848),
    [sym_assignment] = STATE(7801),
    [sym_operator_assignment] = STATE(7801),
    [sym_conditional] = STATE(7801),
    [sym_range] = STATE(7801),
    [sym_binary] = STATE(7801),
    [sym_unary] = STATE(7801),
    [sym_left_assignment_list] = STATE(2847),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2848),
    [sym__variable] = STATE(2846),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2848),
    [sym_false] = STATE(2848),
    [sym_nil] = STATE(2848),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2849),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4775),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4777),
    [anon_sym_yield] = ACTIONS(4779),
    [anon_sym_break] = ACTIONS(4781),
    [anon_sym_next] = ACTIONS(4783),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4785),
    [anon_sym_defined_QMARK] = ACTIONS(4787),
    [anon_sym_not] = ACTIONS(4789),
    [anon_sym_BANG] = ACTIONS(4791),
    [anon_sym_TILDE] = ACTIONS(4791),
    [sym_constant] = ACTIONS(4793),
    [sym_identifier] = ACTIONS(4793),
    [sym_instance_variable] = ACTIONS(4795),
    [sym_class_variable] = ACTIONS(4795),
    [sym_global_variable] = ACTIONS(4795),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4793),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4793),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5343] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7802),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2848),
    [sym_scope_resolution] = STATE(2846),
    [sym_call] = STATE(2846),
    [sym_method_call] = STATE(2848),
    [sym_assignment] = STATE(7802),
    [sym_operator_assignment] = STATE(7802),
    [sym_conditional] = STATE(7802),
    [sym_range] = STATE(7802),
    [sym_binary] = STATE(7802),
    [sym_unary] = STATE(7802),
    [sym_left_assignment_list] = STATE(2847),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2848),
    [sym__variable] = STATE(2846),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2848),
    [sym_false] = STATE(2848),
    [sym_nil] = STATE(2848),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2849),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4775),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4777),
    [anon_sym_yield] = ACTIONS(4779),
    [anon_sym_break] = ACTIONS(4781),
    [anon_sym_next] = ACTIONS(4783),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4785),
    [anon_sym_defined_QMARK] = ACTIONS(4787),
    [anon_sym_not] = ACTIONS(4789),
    [anon_sym_BANG] = ACTIONS(4791),
    [anon_sym_TILDE] = ACTIONS(4791),
    [sym_constant] = ACTIONS(4793),
    [sym_identifier] = ACTIONS(4793),
    [sym_instance_variable] = ACTIONS(4795),
    [sym_class_variable] = ACTIONS(4795),
    [sym_global_variable] = ACTIONS(4795),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4793),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4793),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5344] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7803),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2848),
    [sym_scope_resolution] = STATE(2846),
    [sym_call] = STATE(2846),
    [sym_method_call] = STATE(2848),
    [sym_assignment] = STATE(7803),
    [sym_operator_assignment] = STATE(7803),
    [sym_conditional] = STATE(7803),
    [sym_range] = STATE(7803),
    [sym_binary] = STATE(7803),
    [sym_unary] = STATE(7803),
    [sym_left_assignment_list] = STATE(2847),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2848),
    [sym__variable] = STATE(2846),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2848),
    [sym_false] = STATE(2848),
    [sym_nil] = STATE(2848),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2849),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4775),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4777),
    [anon_sym_yield] = ACTIONS(4779),
    [anon_sym_break] = ACTIONS(4781),
    [anon_sym_next] = ACTIONS(4783),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4785),
    [anon_sym_defined_QMARK] = ACTIONS(4787),
    [anon_sym_not] = ACTIONS(4789),
    [anon_sym_BANG] = ACTIONS(4791),
    [anon_sym_TILDE] = ACTIONS(4791),
    [sym_constant] = ACTIONS(4793),
    [sym_identifier] = ACTIONS(4793),
    [sym_instance_variable] = ACTIONS(4795),
    [sym_class_variable] = ACTIONS(4795),
    [sym_global_variable] = ACTIONS(4795),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4793),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4793),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5345] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7804),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2848),
    [sym_scope_resolution] = STATE(2846),
    [sym_call] = STATE(2846),
    [sym_method_call] = STATE(2848),
    [sym_assignment] = STATE(7804),
    [sym_operator_assignment] = STATE(7804),
    [sym_conditional] = STATE(7804),
    [sym_range] = STATE(7804),
    [sym_binary] = STATE(7804),
    [sym_unary] = STATE(7804),
    [sym_left_assignment_list] = STATE(2847),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2848),
    [sym__variable] = STATE(2846),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2848),
    [sym_false] = STATE(2848),
    [sym_nil] = STATE(2848),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2849),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4775),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4777),
    [anon_sym_yield] = ACTIONS(4779),
    [anon_sym_break] = ACTIONS(4781),
    [anon_sym_next] = ACTIONS(4783),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4785),
    [anon_sym_defined_QMARK] = ACTIONS(4787),
    [anon_sym_not] = ACTIONS(4789),
    [anon_sym_BANG] = ACTIONS(4791),
    [anon_sym_TILDE] = ACTIONS(4791),
    [sym_constant] = ACTIONS(4793),
    [sym_identifier] = ACTIONS(4793),
    [sym_instance_variable] = ACTIONS(4795),
    [sym_class_variable] = ACTIONS(4795),
    [sym_global_variable] = ACTIONS(4795),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4793),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4793),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5346] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7805),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2848),
    [sym_scope_resolution] = STATE(2846),
    [sym_call] = STATE(2846),
    [sym_method_call] = STATE(2848),
    [sym_assignment] = STATE(7805),
    [sym_operator_assignment] = STATE(7805),
    [sym_conditional] = STATE(7805),
    [sym_range] = STATE(7805),
    [sym_binary] = STATE(7805),
    [sym_unary] = STATE(7805),
    [sym_left_assignment_list] = STATE(2847),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2848),
    [sym__variable] = STATE(2846),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2848),
    [sym_false] = STATE(2848),
    [sym_nil] = STATE(2848),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2849),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4775),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4777),
    [anon_sym_yield] = ACTIONS(4779),
    [anon_sym_break] = ACTIONS(4781),
    [anon_sym_next] = ACTIONS(4783),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4785),
    [anon_sym_defined_QMARK] = ACTIONS(4787),
    [anon_sym_not] = ACTIONS(4789),
    [anon_sym_BANG] = ACTIONS(4791),
    [anon_sym_TILDE] = ACTIONS(4791),
    [sym_constant] = ACTIONS(4793),
    [sym_identifier] = ACTIONS(4793),
    [sym_instance_variable] = ACTIONS(4795),
    [sym_class_variable] = ACTIONS(4795),
    [sym_global_variable] = ACTIONS(4795),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4793),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4793),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5347] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(7806),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(7806),
    [sym_operator_assignment] = STATE(7806),
    [sym_conditional] = STATE(7806),
    [sym_range] = STATE(7806),
    [sym_binary] = STATE(7806),
    [sym_unary] = STATE(7806),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5348] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7807),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2848),
    [sym_scope_resolution] = STATE(2846),
    [sym_call] = STATE(2846),
    [sym_method_call] = STATE(2848),
    [sym_assignment] = STATE(7807),
    [sym_operator_assignment] = STATE(7807),
    [sym_conditional] = STATE(7807),
    [sym_range] = STATE(7807),
    [sym_binary] = STATE(7807),
    [sym_unary] = STATE(7807),
    [sym_left_assignment_list] = STATE(2847),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2848),
    [sym__variable] = STATE(2846),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2848),
    [sym_false] = STATE(2848),
    [sym_nil] = STATE(2848),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2849),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4775),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4777),
    [anon_sym_yield] = ACTIONS(4779),
    [anon_sym_break] = ACTIONS(4781),
    [anon_sym_next] = ACTIONS(4783),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4785),
    [anon_sym_defined_QMARK] = ACTIONS(4787),
    [anon_sym_not] = ACTIONS(4789),
    [anon_sym_BANG] = ACTIONS(4791),
    [anon_sym_TILDE] = ACTIONS(4791),
    [sym_constant] = ACTIONS(4793),
    [sym_identifier] = ACTIONS(4793),
    [sym_instance_variable] = ACTIONS(4795),
    [sym_class_variable] = ACTIONS(4795),
    [sym_global_variable] = ACTIONS(4795),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4793),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4793),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5349] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7808),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2848),
    [sym_scope_resolution] = STATE(2846),
    [sym_call] = STATE(2846),
    [sym_method_call] = STATE(2848),
    [sym_assignment] = STATE(7808),
    [sym_operator_assignment] = STATE(7808),
    [sym_conditional] = STATE(7808),
    [sym_range] = STATE(7808),
    [sym_binary] = STATE(7808),
    [sym_unary] = STATE(7808),
    [sym_left_assignment_list] = STATE(2847),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2848),
    [sym__variable] = STATE(2846),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2848),
    [sym_false] = STATE(2848),
    [sym_nil] = STATE(2848),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2849),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4775),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4777),
    [anon_sym_yield] = ACTIONS(4779),
    [anon_sym_break] = ACTIONS(4781),
    [anon_sym_next] = ACTIONS(4783),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4785),
    [anon_sym_defined_QMARK] = ACTIONS(4787),
    [anon_sym_not] = ACTIONS(4789),
    [anon_sym_BANG] = ACTIONS(4791),
    [anon_sym_TILDE] = ACTIONS(4791),
    [sym_constant] = ACTIONS(4793),
    [sym_identifier] = ACTIONS(4793),
    [sym_instance_variable] = ACTIONS(4795),
    [sym_class_variable] = ACTIONS(4795),
    [sym_global_variable] = ACTIONS(4795),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4793),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4793),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5350] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7809),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2848),
    [sym_scope_resolution] = STATE(2846),
    [sym_call] = STATE(2846),
    [sym_method_call] = STATE(2848),
    [sym_assignment] = STATE(7809),
    [sym_operator_assignment] = STATE(7809),
    [sym_conditional] = STATE(7809),
    [sym_range] = STATE(7809),
    [sym_binary] = STATE(7809),
    [sym_unary] = STATE(7809),
    [sym_left_assignment_list] = STATE(2847),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2848),
    [sym__variable] = STATE(2846),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2848),
    [sym_false] = STATE(2848),
    [sym_nil] = STATE(2848),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2849),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4775),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4777),
    [anon_sym_yield] = ACTIONS(4779),
    [anon_sym_break] = ACTIONS(4781),
    [anon_sym_next] = ACTIONS(4783),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4785),
    [anon_sym_defined_QMARK] = ACTIONS(4787),
    [anon_sym_not] = ACTIONS(4789),
    [anon_sym_BANG] = ACTIONS(4791),
    [anon_sym_TILDE] = ACTIONS(4791),
    [sym_constant] = ACTIONS(4793),
    [sym_identifier] = ACTIONS(4793),
    [sym_instance_variable] = ACTIONS(4795),
    [sym_class_variable] = ACTIONS(4795),
    [sym_global_variable] = ACTIONS(4795),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4793),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4793),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5351] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7810),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2848),
    [sym_scope_resolution] = STATE(2846),
    [sym_call] = STATE(2846),
    [sym_method_call] = STATE(2848),
    [sym_assignment] = STATE(7810),
    [sym_operator_assignment] = STATE(7810),
    [sym_conditional] = STATE(7810),
    [sym_range] = STATE(7810),
    [sym_binary] = STATE(7810),
    [sym_unary] = STATE(7810),
    [sym_left_assignment_list] = STATE(2847),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2848),
    [sym__variable] = STATE(2846),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2848),
    [sym_false] = STATE(2848),
    [sym_nil] = STATE(2848),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2849),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4775),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4777),
    [anon_sym_yield] = ACTIONS(4779),
    [anon_sym_break] = ACTIONS(4781),
    [anon_sym_next] = ACTIONS(4783),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4785),
    [anon_sym_defined_QMARK] = ACTIONS(4787),
    [anon_sym_not] = ACTIONS(4789),
    [anon_sym_BANG] = ACTIONS(4791),
    [anon_sym_TILDE] = ACTIONS(4791),
    [sym_constant] = ACTIONS(4793),
    [sym_identifier] = ACTIONS(4793),
    [sym_instance_variable] = ACTIONS(4795),
    [sym_class_variable] = ACTIONS(4795),
    [sym_global_variable] = ACTIONS(4795),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4793),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4793),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5352] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(7818),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(7820),
    [sym_scope_resolution] = STATE(2846),
    [sym_call] = STATE(2846),
    [sym_method_call] = STATE(7820),
    [sym_assignment] = STATE(7818),
    [sym_operator_assignment] = STATE(7818),
    [sym_conditional] = STATE(7818),
    [sym_range] = STATE(7818),
    [sym_binary] = STATE(7818),
    [sym_unary] = STATE(7818),
    [sym_left_assignment_list] = STATE(7819),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7820),
    [sym__variable] = STATE(2846),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(7820),
    [sym_false] = STATE(7820),
    [sym_nil] = STATE(7820),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(7821),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(11356),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(11358),
    [anon_sym_yield] = ACTIONS(11360),
    [anon_sym_break] = ACTIONS(11362),
    [anon_sym_next] = ACTIONS(11364),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(11366),
    [anon_sym_defined_QMARK] = ACTIONS(11368),
    [anon_sym_not] = ACTIONS(11370),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_TILDE] = ACTIONS(11372),
    [sym_constant] = ACTIONS(4793),
    [sym_identifier] = ACTIONS(4793),
    [sym_instance_variable] = ACTIONS(4795),
    [sym_class_variable] = ACTIONS(4795),
    [sym_global_variable] = ACTIONS(4795),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(4793),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4793),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [5353] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(7822),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(7820),
    [sym_scope_resolution] = STATE(2846),
    [sym_call] = STATE(2846),
    [sym_method_call] = STATE(7820),
    [sym_assignment] = STATE(7822),
    [sym_operator_assignment] = STATE(7822),
    [sym_conditional] = STATE(7822),
    [sym_range] = STATE(7822),
    [sym_binary] = STATE(7822),
    [sym_unary] = STATE(7822),
    [sym_left_assignment_list] = STATE(7819),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7820),
    [sym__variable] = STATE(2846),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(7820),
    [sym_false] = STATE(7820),
    [sym_nil] = STATE(7820),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(7821),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(11356),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(11358),
    [anon_sym_yield] = ACTIONS(11360),
    [anon_sym_break] = ACTIONS(11362),
    [anon_sym_next] = ACTIONS(11364),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(11366),
    [anon_sym_defined_QMARK] = ACTIONS(11368),
    [anon_sym_not] = ACTIONS(11370),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_TILDE] = ACTIONS(11372),
    [sym_constant] = ACTIONS(4793),
    [sym_identifier] = ACTIONS(4793),
    [sym_instance_variable] = ACTIONS(4795),
    [sym_class_variable] = ACTIONS(4795),
    [sym_global_variable] = ACTIONS(4795),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(4793),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4793),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [5354] = {
    [anon_sym_COLON] = ACTIONS(11374),
    [sym_comment] = ACTIONS(87),
  },
  [5355] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(7824),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(7820),
    [sym_scope_resolution] = STATE(2846),
    [sym_call] = STATE(2846),
    [sym_method_call] = STATE(7820),
    [sym_assignment] = STATE(7824),
    [sym_operator_assignment] = STATE(7824),
    [sym_conditional] = STATE(7824),
    [sym_range] = STATE(7824),
    [sym_binary] = STATE(7824),
    [sym_unary] = STATE(7824),
    [sym_left_assignment_list] = STATE(7819),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7820),
    [sym__variable] = STATE(2846),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(7820),
    [sym_false] = STATE(7820),
    [sym_nil] = STATE(7820),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(7821),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(11356),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(11358),
    [anon_sym_yield] = ACTIONS(11360),
    [anon_sym_break] = ACTIONS(11362),
    [anon_sym_next] = ACTIONS(11364),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(11366),
    [anon_sym_defined_QMARK] = ACTIONS(11368),
    [anon_sym_not] = ACTIONS(11370),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_TILDE] = ACTIONS(11372),
    [sym_constant] = ACTIONS(4793),
    [sym_identifier] = ACTIONS(4793),
    [sym_instance_variable] = ACTIONS(4795),
    [sym_class_variable] = ACTIONS(4795),
    [sym_global_variable] = ACTIONS(4795),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(4793),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4793),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [5356] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(11376),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [5357] = {
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(8490),
    [sym__binary_star] = ACTIONS(8492),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(8494),
    [anon_sym_STAR_STAR] = ACTIONS(8496),
    [anon_sym_AMP] = ACTIONS(8498),
    [anon_sym_EQ] = ACTIONS(1631),
    [anon_sym_LT] = ACTIONS(8500),
    [anon_sym_in] = ACTIONS(1625),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(11374),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_PLUS_EQ] = ACTIONS(1625),
    [anon_sym_DASH_EQ] = ACTIONS(1625),
    [anon_sym_STAR_EQ] = ACTIONS(1625),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1625),
    [anon_sym_SLASH_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1625),
    [anon_sym_AMP_EQ] = ACTIONS(1625),
    [anon_sym_PERCENT_EQ] = ACTIONS(1625),
    [anon_sym_GT_GT_EQ] = ACTIONS(1625),
    [anon_sym_LT_LT_EQ] = ACTIONS(1625),
    [anon_sym_CARET_EQ] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(8502),
    [anon_sym_DOT_DOT] = ACTIONS(8504),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8506),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(8508),
    [anon_sym_AMP_AMP] = ACTIONS(8508),
    [anon_sym_LT_LT] = ACTIONS(8510),
    [anon_sym_GT_GT] = ACTIONS(8510),
    [anon_sym_EQ_EQ] = ACTIONS(8508),
    [anon_sym_BANG_EQ] = ACTIONS(8512),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8512),
    [anon_sym_LT_EQ_GT] = ACTIONS(8512),
    [anon_sym_EQ_TILDE] = ACTIONS(8512),
    [anon_sym_BANG_TILDE] = ACTIONS(8512),
    [anon_sym_LT_EQ] = ACTIONS(8500),
    [anon_sym_GT] = ACTIONS(8500),
    [anon_sym_GT_EQ] = ACTIONS(8514),
    [anon_sym_CARET] = ACTIONS(8494),
    [anon_sym_PLUS] = ACTIONS(8516),
    [anon_sym_SLASH] = ACTIONS(8496),
    [anon_sym_PERCENT] = ACTIONS(8496),
    [sym_comment] = ACTIONS(87),
  },
  [5358] = {
    [sym_heredoc_body] = STATE(7826),
    [aux_sym_call_repeat1] = STATE(7826),
    [sym__heredoc_body_start] = ACTIONS(6569),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_in] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [5359] = {
    [sym_heredoc_body] = STATE(7826),
    [aux_sym_call_repeat1] = STATE(7826),
    [aux_sym_argument_list_repeat1] = STATE(7828),
    [sym__heredoc_body_start] = ACTIONS(6569),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(11378),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_in] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [5360] = {
    [sym_string] = STATE(5407),
    [aux_sym_chained_string_repeat1] = STATE(5407),
    [sym__string_start] = ACTIONS(1141),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(11380),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_in] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5361] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7829),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2848),
    [sym_scope_resolution] = STATE(2846),
    [sym_call] = STATE(2846),
    [sym_method_call] = STATE(2848),
    [sym_splat_argument] = STATE(7830),
    [sym_assignment] = STATE(7829),
    [sym_operator_assignment] = STATE(7829),
    [sym_conditional] = STATE(7829),
    [sym_range] = STATE(7829),
    [sym_binary] = STATE(7829),
    [sym_unary] = STATE(7829),
    [sym_right_assignment_list] = STATE(4255),
    [sym__arg_or_splat_arg] = STATE(7830),
    [sym_left_assignment_list] = STATE(2847),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2848),
    [sym__variable] = STATE(2846),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2848),
    [sym_false] = STATE(2848),
    [sym_nil] = STATE(2848),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2849),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(8428),
    [sym__unary_minus] = ACTIONS(4775),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4777),
    [anon_sym_yield] = ACTIONS(4779),
    [anon_sym_break] = ACTIONS(4781),
    [anon_sym_next] = ACTIONS(4783),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4785),
    [anon_sym_defined_QMARK] = ACTIONS(4787),
    [anon_sym_not] = ACTIONS(4789),
    [anon_sym_BANG] = ACTIONS(4791),
    [anon_sym_TILDE] = ACTIONS(4791),
    [sym_constant] = ACTIONS(4793),
    [sym_identifier] = ACTIONS(4793),
    [sym_instance_variable] = ACTIONS(4795),
    [sym_class_variable] = ACTIONS(4795),
    [sym_global_variable] = ACTIONS(4795),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4793),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4793),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5362] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7831),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2848),
    [sym_scope_resolution] = STATE(2846),
    [sym_call] = STATE(2846),
    [sym_method_call] = STATE(2848),
    [sym_assignment] = STATE(7831),
    [sym_operator_assignment] = STATE(7831),
    [sym_conditional] = STATE(7831),
    [sym_range] = STATE(7831),
    [sym_binary] = STATE(7831),
    [sym_unary] = STATE(7831),
    [sym_left_assignment_list] = STATE(2847),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2848),
    [sym__variable] = STATE(2846),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2848),
    [sym_false] = STATE(2848),
    [sym_nil] = STATE(2848),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2849),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4775),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4777),
    [anon_sym_yield] = ACTIONS(4779),
    [anon_sym_break] = ACTIONS(4781),
    [anon_sym_next] = ACTIONS(4783),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4785),
    [anon_sym_defined_QMARK] = ACTIONS(4787),
    [anon_sym_not] = ACTIONS(4789),
    [anon_sym_BANG] = ACTIONS(4791),
    [anon_sym_TILDE] = ACTIONS(4791),
    [sym_constant] = ACTIONS(4793),
    [sym_identifier] = ACTIONS(4793),
    [sym_instance_variable] = ACTIONS(4795),
    [sym_class_variable] = ACTIONS(4795),
    [sym_global_variable] = ACTIONS(4795),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4793),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4793),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5363] = {
    [sym_string] = STATE(7832),
    [aux_sym_chained_string_repeat1] = STATE(7832),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_in] = ACTIONS(2753),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [5364] = {
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(8434),
    [sym__binary_star] = ACTIONS(8436),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(8438),
    [anon_sym_STAR_STAR] = ACTIONS(8436),
    [anon_sym_AMP] = ACTIONS(8440),
    [anon_sym_LT] = ACTIONS(8442),
    [anon_sym_in] = ACTIONS(6823),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(8444),
    [anon_sym_DOT_DOT] = ACTIONS(8446),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8448),
    [anon_sym_and] = ACTIONS(8450),
    [anon_sym_or] = ACTIONS(8450),
    [anon_sym_PIPE_PIPE] = ACTIONS(8452),
    [anon_sym_AMP_AMP] = ACTIONS(8452),
    [anon_sym_LT_LT] = ACTIONS(8454),
    [anon_sym_GT_GT] = ACTIONS(8454),
    [anon_sym_EQ_EQ] = ACTIONS(8456),
    [anon_sym_BANG_EQ] = ACTIONS(8452),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8452),
    [anon_sym_LT_EQ_GT] = ACTIONS(8452),
    [anon_sym_EQ_TILDE] = ACTIONS(8452),
    [anon_sym_BANG_TILDE] = ACTIONS(8452),
    [anon_sym_LT_EQ] = ACTIONS(8442),
    [anon_sym_GT] = ACTIONS(8442),
    [anon_sym_GT_EQ] = ACTIONS(8458),
    [anon_sym_CARET] = ACTIONS(8460),
    [anon_sym_PLUS] = ACTIONS(8434),
    [anon_sym_SLASH] = ACTIONS(8436),
    [anon_sym_PERCENT] = ACTIONS(8436),
    [sym_comment] = ACTIONS(87),
  },
  [5365] = {
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(4811),
    [sym__binary_star] = ACTIONS(4813),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(4815),
    [anon_sym_STAR_STAR] = ACTIONS(4813),
    [anon_sym_AMP] = ACTIONS(4817),
    [anon_sym_LT] = ACTIONS(4819),
    [anon_sym_in] = ACTIONS(4211),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_EQ_GT] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(4821),
    [anon_sym_DOT_DOT] = ACTIONS(4823),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4825),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(4829),
    [anon_sym_AMP_AMP] = ACTIONS(4829),
    [anon_sym_LT_LT] = ACTIONS(4831),
    [anon_sym_GT_GT] = ACTIONS(4831),
    [anon_sym_EQ_EQ] = ACTIONS(4833),
    [anon_sym_BANG_EQ] = ACTIONS(4829),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4829),
    [anon_sym_LT_EQ_GT] = ACTIONS(4829),
    [anon_sym_EQ_TILDE] = ACTIONS(4829),
    [anon_sym_BANG_TILDE] = ACTIONS(4829),
    [anon_sym_LT_EQ] = ACTIONS(4819),
    [anon_sym_GT] = ACTIONS(4819),
    [anon_sym_GT_EQ] = ACTIONS(4835),
    [anon_sym_CARET] = ACTIONS(4837),
    [anon_sym_PLUS] = ACTIONS(4811),
    [anon_sym_SLASH] = ACTIONS(4813),
    [anon_sym_PERCENT] = ACTIONS(4813),
    [sym_comment] = ACTIONS(87),
  },
  [5366] = {
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(4811),
    [sym__binary_star] = ACTIONS(4813),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(4815),
    [anon_sym_STAR_STAR] = ACTIONS(4813),
    [anon_sym_AMP] = ACTIONS(4817),
    [anon_sym_LT] = ACTIONS(4819),
    [anon_sym_in] = ACTIONS(4247),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_EQ_GT] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(4821),
    [anon_sym_DOT_DOT] = ACTIONS(4823),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4825),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(4829),
    [anon_sym_AMP_AMP] = ACTIONS(4829),
    [anon_sym_LT_LT] = ACTIONS(4831),
    [anon_sym_GT_GT] = ACTIONS(4831),
    [anon_sym_EQ_EQ] = ACTIONS(4833),
    [anon_sym_BANG_EQ] = ACTIONS(4829),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4829),
    [anon_sym_LT_EQ_GT] = ACTIONS(4829),
    [anon_sym_EQ_TILDE] = ACTIONS(4829),
    [anon_sym_BANG_TILDE] = ACTIONS(4829),
    [anon_sym_LT_EQ] = ACTIONS(4819),
    [anon_sym_GT] = ACTIONS(4819),
    [anon_sym_GT_EQ] = ACTIONS(4835),
    [anon_sym_CARET] = ACTIONS(4837),
    [anon_sym_PLUS] = ACTIONS(4811),
    [anon_sym_SLASH] = ACTIONS(4813),
    [anon_sym_PERCENT] = ACTIONS(4813),
    [sym_comment] = ACTIONS(87),
  },
  [5367] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(7833),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1089),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(1089),
    [sym_assignment] = STATE(7833),
    [sym_operator_assignment] = STATE(7833),
    [sym_conditional] = STATE(7833),
    [sym_range] = STATE(7833),
    [sym_binary] = STATE(7833),
    [sym_unary] = STATE(7833),
    [sym_left_assignment_list] = STATE(1088),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1089),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1089),
    [sym_false] = STATE(1089),
    [sym_nil] = STATE(1089),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1937),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1943),
    [anon_sym_yield] = ACTIONS(1945),
    [anon_sym_break] = ACTIONS(1947),
    [anon_sym_next] = ACTIONS(1949),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1951),
    [anon_sym_defined_QMARK] = ACTIONS(1953),
    [anon_sym_not] = ACTIONS(1955),
    [anon_sym_BANG] = ACTIONS(1957),
    [anon_sym_TILDE] = ACTIONS(1957),
    [sym_constant] = ACTIONS(1963),
    [sym_identifier] = ACTIONS(1963),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5368] = {
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(4811),
    [sym__binary_star] = ACTIONS(4813),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(4815),
    [anon_sym_STAR_STAR] = ACTIONS(4813),
    [anon_sym_AMP] = ACTIONS(4817),
    [anon_sym_LT] = ACTIONS(4819),
    [anon_sym_in] = ACTIONS(3281),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_EQ_GT] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(4821),
    [anon_sym_DOT_DOT] = ACTIONS(4823),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4825),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(4829),
    [anon_sym_AMP_AMP] = ACTIONS(4829),
    [anon_sym_LT_LT] = ACTIONS(4831),
    [anon_sym_GT_GT] = ACTIONS(4831),
    [anon_sym_EQ_EQ] = ACTIONS(4833),
    [anon_sym_BANG_EQ] = ACTIONS(4829),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4829),
    [anon_sym_LT_EQ_GT] = ACTIONS(4829),
    [anon_sym_EQ_TILDE] = ACTIONS(4829),
    [anon_sym_BANG_TILDE] = ACTIONS(4829),
    [anon_sym_LT_EQ] = ACTIONS(4819),
    [anon_sym_GT] = ACTIONS(4819),
    [anon_sym_GT_EQ] = ACTIONS(4835),
    [anon_sym_CARET] = ACTIONS(4837),
    [anon_sym_PLUS] = ACTIONS(4811),
    [anon_sym_SLASH] = ACTIONS(4813),
    [anon_sym_PERCENT] = ACTIONS(4813),
    [sym_comment] = ACTIONS(87),
  },
  [5369] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(7834),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1089),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(1089),
    [sym_assignment] = STATE(7834),
    [sym_operator_assignment] = STATE(7834),
    [sym_conditional] = STATE(7834),
    [sym_range] = STATE(7834),
    [sym_binary] = STATE(7834),
    [sym_unary] = STATE(7834),
    [sym_left_assignment_list] = STATE(1088),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1089),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1089),
    [sym_false] = STATE(1089),
    [sym_nil] = STATE(1089),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1937),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1943),
    [anon_sym_yield] = ACTIONS(1945),
    [anon_sym_break] = ACTIONS(1947),
    [anon_sym_next] = ACTIONS(1949),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1951),
    [anon_sym_defined_QMARK] = ACTIONS(1953),
    [anon_sym_not] = ACTIONS(1955),
    [anon_sym_BANG] = ACTIONS(1957),
    [anon_sym_TILDE] = ACTIONS(1957),
    [sym_constant] = ACTIONS(1963),
    [sym_identifier] = ACTIONS(1963),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5370] = {
    [sym_heredoc_body] = STATE(7835),
    [aux_sym_call_repeat1] = STATE(7835),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_in] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [5371] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(2860),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1089),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(1089),
    [sym__argument] = STATE(4250),
    [sym_splat_argument] = STATE(4250),
    [sym_hash_splat_argument] = STATE(4250),
    [sym_block_argument] = STATE(4250),
    [sym_assignment] = STATE(2860),
    [sym_operator_assignment] = STATE(2860),
    [sym_conditional] = STATE(2860),
    [sym_range] = STATE(2860),
    [sym_binary] = STATE(2860),
    [sym_unary] = STATE(2860),
    [sym_left_assignment_list] = STATE(1088),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1089),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1089),
    [sym_false] = STATE(1089),
    [sym_nil] = STATE(1089),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2863),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_heredoc_body] = STATE(7836),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(4250),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(4799),
    [sym__splat_star] = ACTIONS(4801),
    [sym__unary_minus] = ACTIONS(1937),
    [sym__identifier_hash_key] = ACTIONS(4803),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11382),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1943),
    [anon_sym_yield] = ACTIONS(1945),
    [anon_sym_break] = ACTIONS(1947),
    [anon_sym_next] = ACTIONS(1949),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1951),
    [anon_sym_defined_QMARK] = ACTIONS(1953),
    [anon_sym_not] = ACTIONS(1955),
    [anon_sym_BANG] = ACTIONS(1957),
    [anon_sym_TILDE] = ACTIONS(1957),
    [sym_constant] = ACTIONS(4807),
    [sym_identifier] = ACTIONS(4807),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5372] = {
    [sym_heredoc_body] = STATE(7837),
    [aux_sym_call_repeat1] = STATE(7837),
    [aux_sym_argument_list_repeat1] = STATE(7838),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(8480),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_in] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [5373] = {
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(8434),
    [sym__binary_star] = ACTIONS(8436),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(8438),
    [anon_sym_STAR_STAR] = ACTIONS(8436),
    [anon_sym_AMP] = ACTIONS(8440),
    [anon_sym_LT] = ACTIONS(8442),
    [anon_sym_in] = ACTIONS(7027),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(8444),
    [anon_sym_DOT_DOT] = ACTIONS(8446),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8448),
    [anon_sym_and] = ACTIONS(8450),
    [anon_sym_or] = ACTIONS(8450),
    [anon_sym_PIPE_PIPE] = ACTIONS(8452),
    [anon_sym_AMP_AMP] = ACTIONS(8452),
    [anon_sym_LT_LT] = ACTIONS(8454),
    [anon_sym_GT_GT] = ACTIONS(8454),
    [anon_sym_EQ_EQ] = ACTIONS(8456),
    [anon_sym_BANG_EQ] = ACTIONS(8452),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8452),
    [anon_sym_LT_EQ_GT] = ACTIONS(8452),
    [anon_sym_EQ_TILDE] = ACTIONS(8452),
    [anon_sym_BANG_TILDE] = ACTIONS(8452),
    [anon_sym_LT_EQ] = ACTIONS(8442),
    [anon_sym_GT] = ACTIONS(8442),
    [anon_sym_GT_EQ] = ACTIONS(8458),
    [anon_sym_CARET] = ACTIONS(8460),
    [anon_sym_PLUS] = ACTIONS(8434),
    [anon_sym_SLASH] = ACTIONS(8436),
    [anon_sym_PERCENT] = ACTIONS(8436),
    [sym_comment] = ACTIONS(87),
  },
  [5374] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(4813),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(4813),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_in] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(4813),
    [anon_sym_PERCENT] = ACTIONS(4813),
    [sym_comment] = ACTIONS(87),
  },
  [5375] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(4813),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_in] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [5376] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4811),
    [sym__binary_star] = ACTIONS(4813),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(4813),
    [anon_sym_AMP] = ACTIONS(4817),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_in] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(4831),
    [anon_sym_GT_GT] = ACTIONS(4831),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(4811),
    [anon_sym_SLASH] = ACTIONS(4813),
    [anon_sym_PERCENT] = ACTIONS(4813),
    [sym_comment] = ACTIONS(87),
  },
  [5377] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4811),
    [sym__binary_star] = ACTIONS(4813),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(4813),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_in] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(4831),
    [anon_sym_GT_GT] = ACTIONS(4831),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(4811),
    [anon_sym_SLASH] = ACTIONS(4813),
    [anon_sym_PERCENT] = ACTIONS(4813),
    [sym_comment] = ACTIONS(87),
  },
  [5378] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4811),
    [sym__binary_star] = ACTIONS(4813),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(4815),
    [anon_sym_STAR_STAR] = ACTIONS(4813),
    [anon_sym_AMP] = ACTIONS(4817),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_in] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(4831),
    [anon_sym_GT_GT] = ACTIONS(4831),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(4837),
    [anon_sym_PLUS] = ACTIONS(4811),
    [anon_sym_SLASH] = ACTIONS(4813),
    [anon_sym_PERCENT] = ACTIONS(4813),
    [sym_comment] = ACTIONS(87),
  },
  [5379] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(11384),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [5380] = {
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(4811),
    [sym__binary_star] = ACTIONS(4813),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(4815),
    [anon_sym_STAR_STAR] = ACTIONS(4813),
    [anon_sym_AMP] = ACTIONS(4817),
    [anon_sym_LT] = ACTIONS(4819),
    [anon_sym_in] = ACTIONS(5927),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_EQ_GT] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(4823),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4825),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(4829),
    [anon_sym_AMP_AMP] = ACTIONS(4829),
    [anon_sym_LT_LT] = ACTIONS(4831),
    [anon_sym_GT_GT] = ACTIONS(4831),
    [anon_sym_EQ_EQ] = ACTIONS(4833),
    [anon_sym_BANG_EQ] = ACTIONS(4829),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4829),
    [anon_sym_LT_EQ_GT] = ACTIONS(4829),
    [anon_sym_EQ_TILDE] = ACTIONS(4829),
    [anon_sym_BANG_TILDE] = ACTIONS(4829),
    [anon_sym_LT_EQ] = ACTIONS(4819),
    [anon_sym_GT] = ACTIONS(4819),
    [anon_sym_GT_EQ] = ACTIONS(4835),
    [anon_sym_CARET] = ACTIONS(4837),
    [anon_sym_PLUS] = ACTIONS(4811),
    [anon_sym_SLASH] = ACTIONS(4813),
    [anon_sym_PERCENT] = ACTIONS(4813),
    [sym_comment] = ACTIONS(87),
  },
  [5381] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4811),
    [sym__binary_star] = ACTIONS(4813),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(4815),
    [anon_sym_STAR_STAR] = ACTIONS(4813),
    [anon_sym_AMP] = ACTIONS(4817),
    [anon_sym_LT] = ACTIONS(4819),
    [anon_sym_in] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(4821),
    [anon_sym_DOT_DOT] = ACTIONS(4823),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(4829),
    [anon_sym_AMP_AMP] = ACTIONS(4829),
    [anon_sym_LT_LT] = ACTIONS(4831),
    [anon_sym_GT_GT] = ACTIONS(4831),
    [anon_sym_EQ_EQ] = ACTIONS(4833),
    [anon_sym_BANG_EQ] = ACTIONS(4829),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4829),
    [anon_sym_LT_EQ_GT] = ACTIONS(4829),
    [anon_sym_EQ_TILDE] = ACTIONS(4829),
    [anon_sym_BANG_TILDE] = ACTIONS(4829),
    [anon_sym_LT_EQ] = ACTIONS(4819),
    [anon_sym_GT] = ACTIONS(4819),
    [anon_sym_GT_EQ] = ACTIONS(4835),
    [anon_sym_CARET] = ACTIONS(4837),
    [anon_sym_PLUS] = ACTIONS(4811),
    [anon_sym_SLASH] = ACTIONS(4813),
    [anon_sym_PERCENT] = ACTIONS(4813),
    [sym_comment] = ACTIONS(87),
  },
  [5382] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4811),
    [sym__binary_star] = ACTIONS(4813),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(4815),
    [anon_sym_STAR_STAR] = ACTIONS(4813),
    [anon_sym_AMP] = ACTIONS(4817),
    [anon_sym_LT] = ACTIONS(4819),
    [anon_sym_in] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(4831),
    [anon_sym_GT_GT] = ACTIONS(4831),
    [anon_sym_EQ_EQ] = ACTIONS(4833),
    [anon_sym_BANG_EQ] = ACTIONS(4829),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4829),
    [anon_sym_LT_EQ_GT] = ACTIONS(4829),
    [anon_sym_EQ_TILDE] = ACTIONS(4829),
    [anon_sym_BANG_TILDE] = ACTIONS(4829),
    [anon_sym_LT_EQ] = ACTIONS(4819),
    [anon_sym_GT] = ACTIONS(4819),
    [anon_sym_GT_EQ] = ACTIONS(4835),
    [anon_sym_CARET] = ACTIONS(4837),
    [anon_sym_PLUS] = ACTIONS(4811),
    [anon_sym_SLASH] = ACTIONS(4813),
    [anon_sym_PERCENT] = ACTIONS(4813),
    [sym_comment] = ACTIONS(87),
  },
  [5383] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4811),
    [sym__binary_star] = ACTIONS(4813),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(4813),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_in] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(4811),
    [anon_sym_SLASH] = ACTIONS(4813),
    [anon_sym_PERCENT] = ACTIONS(4813),
    [sym_comment] = ACTIONS(87),
  },
  [5384] = {
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(8490),
    [sym__binary_star] = ACTIONS(8492),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(8494),
    [anon_sym_STAR_STAR] = ACTIONS(8496),
    [anon_sym_AMP] = ACTIONS(8498),
    [anon_sym_EQ] = ACTIONS(4217),
    [anon_sym_LT] = ACTIONS(8500),
    [anon_sym_in] = ACTIONS(4211),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_EQ_GT] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_PLUS_EQ] = ACTIONS(4211),
    [anon_sym_DASH_EQ] = ACTIONS(4211),
    [anon_sym_STAR_EQ] = ACTIONS(4211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4211),
    [anon_sym_SLASH_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4211),
    [anon_sym_AMP_EQ] = ACTIONS(4211),
    [anon_sym_PERCENT_EQ] = ACTIONS(4211),
    [anon_sym_GT_GT_EQ] = ACTIONS(4211),
    [anon_sym_LT_LT_EQ] = ACTIONS(4211),
    [anon_sym_CARET_EQ] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(8502),
    [anon_sym_DOT_DOT] = ACTIONS(8504),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8506),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(8508),
    [anon_sym_AMP_AMP] = ACTIONS(8508),
    [anon_sym_LT_LT] = ACTIONS(8510),
    [anon_sym_GT_GT] = ACTIONS(8510),
    [anon_sym_EQ_EQ] = ACTIONS(8508),
    [anon_sym_BANG_EQ] = ACTIONS(8512),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8512),
    [anon_sym_LT_EQ_GT] = ACTIONS(8512),
    [anon_sym_EQ_TILDE] = ACTIONS(8512),
    [anon_sym_BANG_TILDE] = ACTIONS(8512),
    [anon_sym_LT_EQ] = ACTIONS(8500),
    [anon_sym_GT] = ACTIONS(8500),
    [anon_sym_GT_EQ] = ACTIONS(8514),
    [anon_sym_CARET] = ACTIONS(8494),
    [anon_sym_PLUS] = ACTIONS(8516),
    [anon_sym_SLASH] = ACTIONS(8496),
    [anon_sym_PERCENT] = ACTIONS(8496),
    [sym_comment] = ACTIONS(87),
  },
  [5385] = {
    [sym_string] = STATE(5407),
    [aux_sym_chained_string_repeat1] = STATE(5407),
    [sym__string_start] = ACTIONS(1141),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_in] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5386] = {
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(8490),
    [sym__binary_star] = ACTIONS(8492),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(8494),
    [anon_sym_STAR_STAR] = ACTIONS(8496),
    [anon_sym_AMP] = ACTIONS(8498),
    [anon_sym_EQ] = ACTIONS(4249),
    [anon_sym_LT] = ACTIONS(8500),
    [anon_sym_in] = ACTIONS(4247),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_EQ_GT] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_PLUS_EQ] = ACTIONS(4247),
    [anon_sym_DASH_EQ] = ACTIONS(4247),
    [anon_sym_STAR_EQ] = ACTIONS(4247),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4247),
    [anon_sym_SLASH_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4247),
    [anon_sym_AMP_EQ] = ACTIONS(4247),
    [anon_sym_PERCENT_EQ] = ACTIONS(4247),
    [anon_sym_GT_GT_EQ] = ACTIONS(4247),
    [anon_sym_LT_LT_EQ] = ACTIONS(4247),
    [anon_sym_CARET_EQ] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(8502),
    [anon_sym_DOT_DOT] = ACTIONS(8504),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8506),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(8508),
    [anon_sym_AMP_AMP] = ACTIONS(8508),
    [anon_sym_LT_LT] = ACTIONS(8510),
    [anon_sym_GT_GT] = ACTIONS(8510),
    [anon_sym_EQ_EQ] = ACTIONS(8508),
    [anon_sym_BANG_EQ] = ACTIONS(8512),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8512),
    [anon_sym_LT_EQ_GT] = ACTIONS(8512),
    [anon_sym_EQ_TILDE] = ACTIONS(8512),
    [anon_sym_BANG_TILDE] = ACTIONS(8512),
    [anon_sym_LT_EQ] = ACTIONS(8500),
    [anon_sym_GT] = ACTIONS(8500),
    [anon_sym_GT_EQ] = ACTIONS(8514),
    [anon_sym_CARET] = ACTIONS(8494),
    [anon_sym_PLUS] = ACTIONS(8516),
    [anon_sym_SLASH] = ACTIONS(8496),
    [anon_sym_PERCENT] = ACTIONS(8496),
    [sym_comment] = ACTIONS(87),
  },
  [5387] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(8496),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_in] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [5388] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(7840),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2892),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(2892),
    [sym_assignment] = STATE(7840),
    [sym_operator_assignment] = STATE(7840),
    [sym_conditional] = STATE(7840),
    [sym_range] = STATE(7840),
    [sym_binary] = STATE(7840),
    [sym_unary] = STATE(7840),
    [sym_left_assignment_list] = STATE(2891),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2892),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2892),
    [sym_false] = STATE(2892),
    [sym_nil] = STATE(2892),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(5385),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(4843),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4847),
    [anon_sym_yield] = ACTIONS(4849),
    [anon_sym_break] = ACTIONS(4851),
    [anon_sym_next] = ACTIONS(4853),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(8484),
    [anon_sym_defined_QMARK] = ACTIONS(4855),
    [anon_sym_not] = ACTIONS(4857),
    [anon_sym_BANG] = ACTIONS(4861),
    [anon_sym_TILDE] = ACTIONS(4861),
    [sym_constant] = ACTIONS(1963),
    [sym_identifier] = ACTIONS(1963),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [5389] = {
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(8490),
    [sym__binary_star] = ACTIONS(8492),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(8494),
    [anon_sym_STAR_STAR] = ACTIONS(8496),
    [anon_sym_AMP] = ACTIONS(8498),
    [anon_sym_EQ] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(8500),
    [anon_sym_in] = ACTIONS(3281),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_EQ_GT] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_PLUS_EQ] = ACTIONS(3281),
    [anon_sym_DASH_EQ] = ACTIONS(3281),
    [anon_sym_STAR_EQ] = ACTIONS(3281),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3281),
    [anon_sym_SLASH_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3281),
    [anon_sym_AMP_EQ] = ACTIONS(3281),
    [anon_sym_PERCENT_EQ] = ACTIONS(3281),
    [anon_sym_GT_GT_EQ] = ACTIONS(3281),
    [anon_sym_LT_LT_EQ] = ACTIONS(3281),
    [anon_sym_CARET_EQ] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(8502),
    [anon_sym_DOT_DOT] = ACTIONS(8504),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8506),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(8508),
    [anon_sym_AMP_AMP] = ACTIONS(8508),
    [anon_sym_LT_LT] = ACTIONS(8510),
    [anon_sym_GT_GT] = ACTIONS(8510),
    [anon_sym_EQ_EQ] = ACTIONS(8508),
    [anon_sym_BANG_EQ] = ACTIONS(8512),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8512),
    [anon_sym_LT_EQ_GT] = ACTIONS(8512),
    [anon_sym_EQ_TILDE] = ACTIONS(8512),
    [anon_sym_BANG_TILDE] = ACTIONS(8512),
    [anon_sym_LT_EQ] = ACTIONS(8500),
    [anon_sym_GT] = ACTIONS(8500),
    [anon_sym_GT_EQ] = ACTIONS(8514),
    [anon_sym_CARET] = ACTIONS(8494),
    [anon_sym_PLUS] = ACTIONS(8516),
    [anon_sym_SLASH] = ACTIONS(8496),
    [anon_sym_PERCENT] = ACTIONS(8496),
    [sym_comment] = ACTIONS(87),
  },
  [5390] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(8490),
    [sym__binary_star] = ACTIONS(8492),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(8494),
    [anon_sym_STAR_STAR] = ACTIONS(8496),
    [anon_sym_AMP] = ACTIONS(8498),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(8500),
    [anon_sym_in] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(8502),
    [anon_sym_DOT_DOT] = ACTIONS(8504),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8506),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(8508),
    [anon_sym_AMP_AMP] = ACTIONS(8508),
    [anon_sym_LT_LT] = ACTIONS(8510),
    [anon_sym_GT_GT] = ACTIONS(8510),
    [anon_sym_EQ_EQ] = ACTIONS(8508),
    [anon_sym_BANG_EQ] = ACTIONS(8512),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8512),
    [anon_sym_LT_EQ_GT] = ACTIONS(8512),
    [anon_sym_EQ_TILDE] = ACTIONS(8512),
    [anon_sym_BANG_TILDE] = ACTIONS(8512),
    [anon_sym_LT_EQ] = ACTIONS(8500),
    [anon_sym_GT] = ACTIONS(8500),
    [anon_sym_GT_EQ] = ACTIONS(8514),
    [anon_sym_CARET] = ACTIONS(8494),
    [anon_sym_PLUS] = ACTIONS(8516),
    [anon_sym_SLASH] = ACTIONS(8496),
    [anon_sym_PERCENT] = ACTIONS(8496),
    [sym_comment] = ACTIONS(87),
  },
  [5391] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(7841),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2892),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(2892),
    [sym_assignment] = STATE(7841),
    [sym_operator_assignment] = STATE(7841),
    [sym_conditional] = STATE(7841),
    [sym_range] = STATE(7841),
    [sym_binary] = STATE(7841),
    [sym_unary] = STATE(7841),
    [sym_left_assignment_list] = STATE(2891),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2892),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2892),
    [sym_false] = STATE(2892),
    [sym_nil] = STATE(2892),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(5385),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(4843),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4847),
    [anon_sym_yield] = ACTIONS(4849),
    [anon_sym_break] = ACTIONS(4851),
    [anon_sym_next] = ACTIONS(4853),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(8484),
    [anon_sym_defined_QMARK] = ACTIONS(4855),
    [anon_sym_not] = ACTIONS(4857),
    [anon_sym_BANG] = ACTIONS(4861),
    [anon_sym_TILDE] = ACTIONS(4861),
    [sym_constant] = ACTIONS(1963),
    [sym_identifier] = ACTIONS(1963),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [5392] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(7842),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2892),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(2892),
    [sym_assignment] = STATE(7842),
    [sym_operator_assignment] = STATE(7842),
    [sym_conditional] = STATE(7842),
    [sym_range] = STATE(7842),
    [sym_binary] = STATE(7842),
    [sym_unary] = STATE(7842),
    [sym_left_assignment_list] = STATE(2891),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2892),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2892),
    [sym_false] = STATE(2892),
    [sym_nil] = STATE(2892),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(5385),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(4843),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4847),
    [anon_sym_yield] = ACTIONS(4849),
    [anon_sym_break] = ACTIONS(4851),
    [anon_sym_next] = ACTIONS(4853),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(8484),
    [anon_sym_defined_QMARK] = ACTIONS(4855),
    [anon_sym_not] = ACTIONS(4857),
    [anon_sym_BANG] = ACTIONS(4861),
    [anon_sym_TILDE] = ACTIONS(4861),
    [sym_constant] = ACTIONS(1963),
    [sym_identifier] = ACTIONS(1963),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [5393] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(7843),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2892),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(2892),
    [sym_assignment] = STATE(7843),
    [sym_operator_assignment] = STATE(7843),
    [sym_conditional] = STATE(7843),
    [sym_range] = STATE(7843),
    [sym_binary] = STATE(7843),
    [sym_unary] = STATE(7843),
    [sym_left_assignment_list] = STATE(2891),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2892),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2892),
    [sym_false] = STATE(2892),
    [sym_nil] = STATE(2892),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(5385),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(4843),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4847),
    [anon_sym_yield] = ACTIONS(4849),
    [anon_sym_break] = ACTIONS(4851),
    [anon_sym_next] = ACTIONS(4853),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(8484),
    [anon_sym_defined_QMARK] = ACTIONS(4855),
    [anon_sym_not] = ACTIONS(4857),
    [anon_sym_BANG] = ACTIONS(4861),
    [anon_sym_TILDE] = ACTIONS(4861),
    [sym_constant] = ACTIONS(1963),
    [sym_identifier] = ACTIONS(1963),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [5394] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(7844),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2892),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(2892),
    [sym_assignment] = STATE(7844),
    [sym_operator_assignment] = STATE(7844),
    [sym_conditional] = STATE(7844),
    [sym_range] = STATE(7844),
    [sym_binary] = STATE(7844),
    [sym_unary] = STATE(7844),
    [sym_left_assignment_list] = STATE(2891),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2892),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2892),
    [sym_false] = STATE(2892),
    [sym_nil] = STATE(2892),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(5385),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(4843),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4847),
    [anon_sym_yield] = ACTIONS(4849),
    [anon_sym_break] = ACTIONS(4851),
    [anon_sym_next] = ACTIONS(4853),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(8484),
    [anon_sym_defined_QMARK] = ACTIONS(4855),
    [anon_sym_not] = ACTIONS(4857),
    [anon_sym_BANG] = ACTIONS(4861),
    [anon_sym_TILDE] = ACTIONS(4861),
    [sym_constant] = ACTIONS(1963),
    [sym_identifier] = ACTIONS(1963),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [5395] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(7845),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2892),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(2892),
    [sym_assignment] = STATE(7845),
    [sym_operator_assignment] = STATE(7845),
    [sym_conditional] = STATE(7845),
    [sym_range] = STATE(7845),
    [sym_binary] = STATE(7845),
    [sym_unary] = STATE(7845),
    [sym_left_assignment_list] = STATE(2891),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2892),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2892),
    [sym_false] = STATE(2892),
    [sym_nil] = STATE(2892),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(5385),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(4843),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4847),
    [anon_sym_yield] = ACTIONS(4849),
    [anon_sym_break] = ACTIONS(4851),
    [anon_sym_next] = ACTIONS(4853),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(8484),
    [anon_sym_defined_QMARK] = ACTIONS(4855),
    [anon_sym_not] = ACTIONS(4857),
    [anon_sym_BANG] = ACTIONS(4861),
    [anon_sym_TILDE] = ACTIONS(4861),
    [sym_constant] = ACTIONS(1963),
    [sym_identifier] = ACTIONS(1963),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [5396] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(7846),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2892),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(2892),
    [sym_assignment] = STATE(7846),
    [sym_operator_assignment] = STATE(7846),
    [sym_conditional] = STATE(7846),
    [sym_range] = STATE(7846),
    [sym_binary] = STATE(7846),
    [sym_unary] = STATE(7846),
    [sym_left_assignment_list] = STATE(2891),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2892),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2892),
    [sym_false] = STATE(2892),
    [sym_nil] = STATE(2892),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(5385),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(4843),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4847),
    [anon_sym_yield] = ACTIONS(4849),
    [anon_sym_break] = ACTIONS(4851),
    [anon_sym_next] = ACTIONS(4853),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(8484),
    [anon_sym_defined_QMARK] = ACTIONS(4855),
    [anon_sym_not] = ACTIONS(4857),
    [anon_sym_BANG] = ACTIONS(4861),
    [anon_sym_TILDE] = ACTIONS(4861),
    [sym_constant] = ACTIONS(1963),
    [sym_identifier] = ACTIONS(1963),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [5397] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(7847),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(7847),
    [sym_operator_assignment] = STATE(7847),
    [sym_conditional] = STATE(7847),
    [sym_range] = STATE(7847),
    [sym_binary] = STATE(7847),
    [sym_unary] = STATE(7847),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5398] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(7848),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2892),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(2892),
    [sym_assignment] = STATE(7848),
    [sym_operator_assignment] = STATE(7848),
    [sym_conditional] = STATE(7848),
    [sym_range] = STATE(7848),
    [sym_binary] = STATE(7848),
    [sym_unary] = STATE(7848),
    [sym_left_assignment_list] = STATE(2891),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2892),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2892),
    [sym_false] = STATE(2892),
    [sym_nil] = STATE(2892),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(5385),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(4843),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4847),
    [anon_sym_yield] = ACTIONS(4849),
    [anon_sym_break] = ACTIONS(4851),
    [anon_sym_next] = ACTIONS(4853),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(8484),
    [anon_sym_defined_QMARK] = ACTIONS(4855),
    [anon_sym_not] = ACTIONS(4857),
    [anon_sym_BANG] = ACTIONS(4861),
    [anon_sym_TILDE] = ACTIONS(4861),
    [sym_constant] = ACTIONS(1963),
    [sym_identifier] = ACTIONS(1963),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [5399] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(7849),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2892),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(2892),
    [sym_assignment] = STATE(7849),
    [sym_operator_assignment] = STATE(7849),
    [sym_conditional] = STATE(7849),
    [sym_range] = STATE(7849),
    [sym_binary] = STATE(7849),
    [sym_unary] = STATE(7849),
    [sym_left_assignment_list] = STATE(2891),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2892),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2892),
    [sym_false] = STATE(2892),
    [sym_nil] = STATE(2892),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(5385),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(4843),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4847),
    [anon_sym_yield] = ACTIONS(4849),
    [anon_sym_break] = ACTIONS(4851),
    [anon_sym_next] = ACTIONS(4853),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(8484),
    [anon_sym_defined_QMARK] = ACTIONS(4855),
    [anon_sym_not] = ACTIONS(4857),
    [anon_sym_BANG] = ACTIONS(4861),
    [anon_sym_TILDE] = ACTIONS(4861),
    [sym_constant] = ACTIONS(1963),
    [sym_identifier] = ACTIONS(1963),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [5400] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(7850),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2892),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(2892),
    [sym_assignment] = STATE(7850),
    [sym_operator_assignment] = STATE(7850),
    [sym_conditional] = STATE(7850),
    [sym_range] = STATE(7850),
    [sym_binary] = STATE(7850),
    [sym_unary] = STATE(7850),
    [sym_left_assignment_list] = STATE(2891),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2892),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2892),
    [sym_false] = STATE(2892),
    [sym_nil] = STATE(2892),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(5385),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(4843),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4847),
    [anon_sym_yield] = ACTIONS(4849),
    [anon_sym_break] = ACTIONS(4851),
    [anon_sym_next] = ACTIONS(4853),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(8484),
    [anon_sym_defined_QMARK] = ACTIONS(4855),
    [anon_sym_not] = ACTIONS(4857),
    [anon_sym_BANG] = ACTIONS(4861),
    [anon_sym_TILDE] = ACTIONS(4861),
    [sym_constant] = ACTIONS(1963),
    [sym_identifier] = ACTIONS(1963),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [5401] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(7851),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2892),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(2892),
    [sym_assignment] = STATE(7851),
    [sym_operator_assignment] = STATE(7851),
    [sym_conditional] = STATE(7851),
    [sym_range] = STATE(7851),
    [sym_binary] = STATE(7851),
    [sym_unary] = STATE(7851),
    [sym_left_assignment_list] = STATE(2891),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2892),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2892),
    [sym_false] = STATE(2892),
    [sym_nil] = STATE(2892),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(5385),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(4843),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4847),
    [anon_sym_yield] = ACTIONS(4849),
    [anon_sym_break] = ACTIONS(4851),
    [anon_sym_next] = ACTIONS(4853),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(8484),
    [anon_sym_defined_QMARK] = ACTIONS(4855),
    [anon_sym_not] = ACTIONS(4857),
    [anon_sym_BANG] = ACTIONS(4861),
    [anon_sym_TILDE] = ACTIONS(4861),
    [sym_constant] = ACTIONS(1963),
    [sym_identifier] = ACTIONS(1963),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [5402] = {
    [sym_heredoc_body] = STATE(7852),
    [aux_sym_call_repeat1] = STATE(7852),
    [sym__heredoc_body_start] = ACTIONS(3543),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_in] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [5403] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(2888),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2892),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(2892),
    [sym__argument] = STATE(4357),
    [sym_splat_argument] = STATE(4357),
    [sym_hash_splat_argument] = STATE(4357),
    [sym_block_argument] = STATE(4357),
    [sym_assignment] = STATE(2888),
    [sym_operator_assignment] = STATE(2888),
    [sym_conditional] = STATE(2888),
    [sym_range] = STATE(2888),
    [sym_binary] = STATE(2888),
    [sym_unary] = STATE(2888),
    [sym_left_assignment_list] = STATE(2891),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2892),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2892),
    [sym_false] = STATE(2892),
    [sym_nil] = STATE(2892),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(2893),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_heredoc_body] = STATE(7853),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(4357),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(4839),
    [sym__splat_star] = ACTIONS(4841),
    [sym__unary_minus] = ACTIONS(4843),
    [sym__identifier_hash_key] = ACTIONS(4845),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11386),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4847),
    [anon_sym_yield] = ACTIONS(4849),
    [anon_sym_break] = ACTIONS(4851),
    [anon_sym_next] = ACTIONS(4853),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(8484),
    [anon_sym_defined_QMARK] = ACTIONS(4855),
    [anon_sym_not] = ACTIONS(4857),
    [anon_sym_BANG] = ACTIONS(4861),
    [anon_sym_TILDE] = ACTIONS(4861),
    [sym_constant] = ACTIONS(4863),
    [sym_identifier] = ACTIONS(4863),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [5404] = {
    [sym_heredoc_body] = STATE(7854),
    [aux_sym_call_repeat1] = STATE(7854),
    [aux_sym_argument_list_repeat1] = STATE(7855),
    [sym__heredoc_body_start] = ACTIONS(3543),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(8518),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_in] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [5405] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(7856),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2892),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(2892),
    [sym_splat_argument] = STATE(7857),
    [sym_assignment] = STATE(7856),
    [sym_operator_assignment] = STATE(7856),
    [sym_conditional] = STATE(7856),
    [sym_range] = STATE(7856),
    [sym_binary] = STATE(7856),
    [sym_unary] = STATE(7856),
    [sym_right_assignment_list] = STATE(4362),
    [sym__arg_or_splat_arg] = STATE(7857),
    [sym_left_assignment_list] = STATE(2891),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2892),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2892),
    [sym_false] = STATE(2892),
    [sym_nil] = STATE(2892),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(5385),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__splat_star] = ACTIONS(4841),
    [sym__unary_minus] = ACTIONS(4843),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4847),
    [anon_sym_yield] = ACTIONS(4849),
    [anon_sym_break] = ACTIONS(4851),
    [anon_sym_next] = ACTIONS(4853),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(8484),
    [anon_sym_defined_QMARK] = ACTIONS(4855),
    [anon_sym_not] = ACTIONS(4857),
    [anon_sym_BANG] = ACTIONS(4861),
    [anon_sym_TILDE] = ACTIONS(4861),
    [sym_constant] = ACTIONS(1963),
    [sym_identifier] = ACTIONS(1963),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [5406] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(7858),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2892),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(2892),
    [sym_assignment] = STATE(7858),
    [sym_operator_assignment] = STATE(7858),
    [sym_conditional] = STATE(7858),
    [sym_range] = STATE(7858),
    [sym_binary] = STATE(7858),
    [sym_unary] = STATE(7858),
    [sym_left_assignment_list] = STATE(2891),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2892),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2892),
    [sym_false] = STATE(2892),
    [sym_nil] = STATE(2892),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(5385),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(4843),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4847),
    [anon_sym_yield] = ACTIONS(4849),
    [anon_sym_break] = ACTIONS(4851),
    [anon_sym_next] = ACTIONS(4853),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(8484),
    [anon_sym_defined_QMARK] = ACTIONS(4855),
    [anon_sym_not] = ACTIONS(4857),
    [anon_sym_BANG] = ACTIONS(4861),
    [anon_sym_TILDE] = ACTIONS(4861),
    [sym_constant] = ACTIONS(1963),
    [sym_identifier] = ACTIONS(1963),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [5407] = {
    [sym_string] = STATE(7859),
    [aux_sym_chained_string_repeat1] = STATE(7859),
    [sym__string_start] = ACTIONS(1141),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_STAR_STAR] = ACTIONS(2755),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_EQ] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_in] = ACTIONS(2753),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_EQ_GT] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_PLUS_EQ] = ACTIONS(2753),
    [anon_sym_DASH_EQ] = ACTIONS(2753),
    [anon_sym_STAR_EQ] = ACTIONS(2753),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2753),
    [anon_sym_SLASH_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2753),
    [anon_sym_AMP_EQ] = ACTIONS(2753),
    [anon_sym_PERCENT_EQ] = ACTIONS(2753),
    [anon_sym_GT_GT_EQ] = ACTIONS(2753),
    [anon_sym_LT_LT_EQ] = ACTIONS(2753),
    [anon_sym_CARET_EQ] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2755),
    [anon_sym_AMP_AMP] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2755),
    [anon_sym_GT_GT] = ACTIONS(2755),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_SLASH] = ACTIONS(2755),
    [anon_sym_PERCENT] = ACTIONS(2755),
    [sym_comment] = ACTIONS(87),
  },
  [5408] = {
    [sym_heredoc_body] = STATE(5408),
    [aux_sym_call_repeat1] = STATE(5408),
    [sym__heredoc_body_start] = ACTIONS(10810),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7914),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_in] = ACTIONS(7914),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [5409] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(1084),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1089),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(1089),
    [sym__argument] = STATE(6088),
    [sym_splat_argument] = STATE(6088),
    [sym_hash_splat_argument] = STATE(6088),
    [sym_block_argument] = STATE(6088),
    [sym_assignment] = STATE(1084),
    [sym_operator_assignment] = STATE(1084),
    [sym_conditional] = STATE(1084),
    [sym_range] = STATE(1084),
    [sym_binary] = STATE(1084),
    [sym_unary] = STATE(1084),
    [sym_left_assignment_list] = STATE(1088),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1089),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1089),
    [sym_false] = STATE(1089),
    [sym_nil] = STATE(1089),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1090),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(6088),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1933),
    [sym__splat_star] = ACTIONS(1935),
    [sym__unary_minus] = ACTIONS(1937),
    [sym__identifier_hash_key] = ACTIONS(1939),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1941),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1943),
    [anon_sym_yield] = ACTIONS(1945),
    [anon_sym_break] = ACTIONS(1947),
    [anon_sym_next] = ACTIONS(1949),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1951),
    [anon_sym_defined_QMARK] = ACTIONS(1953),
    [anon_sym_not] = ACTIONS(1955),
    [anon_sym_BANG] = ACTIONS(1957),
    [anon_sym_TILDE] = ACTIONS(1957),
    [sym_constant] = ACTIONS(1959),
    [sym_identifier] = ACTIONS(1959),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5410] = {
    [sym_heredoc_body] = STATE(5408),
    [aux_sym_call_repeat1] = STATE(5408),
    [sym__heredoc_body_start] = ACTIONS(3959),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7929),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_in] = ACTIONS(7929),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [5411] = {
    [aux_sym_argument_list_repeat1] = STATE(5411),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7925),
    [anon_sym_COMMA] = ACTIONS(11388),
    [anon_sym_in] = ACTIONS(7925),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [5412] = {
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(4811),
    [sym__binary_star] = ACTIONS(4813),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(4815),
    [anon_sym_STAR_STAR] = ACTIONS(4813),
    [anon_sym_AMP] = ACTIONS(4817),
    [anon_sym_LT] = ACTIONS(4819),
    [anon_sym_in] = ACTIONS(5115),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_EQ_GT] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(4821),
    [anon_sym_DOT_DOT] = ACTIONS(4823),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4825),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(4829),
    [anon_sym_AMP_AMP] = ACTIONS(4829),
    [anon_sym_LT_LT] = ACTIONS(4831),
    [anon_sym_GT_GT] = ACTIONS(4831),
    [anon_sym_EQ_EQ] = ACTIONS(4833),
    [anon_sym_BANG_EQ] = ACTIONS(4829),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4829),
    [anon_sym_LT_EQ_GT] = ACTIONS(4829),
    [anon_sym_EQ_TILDE] = ACTIONS(4829),
    [anon_sym_BANG_TILDE] = ACTIONS(4829),
    [anon_sym_LT_EQ] = ACTIONS(4819),
    [anon_sym_GT] = ACTIONS(4819),
    [anon_sym_GT_EQ] = ACTIONS(4835),
    [anon_sym_CARET] = ACTIONS(4837),
    [anon_sym_PLUS] = ACTIONS(4811),
    [anon_sym_SLASH] = ACTIONS(4813),
    [anon_sym_PERCENT] = ACTIONS(4813),
    [sym_comment] = ACTIONS(87),
  },
  [5413] = {
    [aux_sym_exceptions_repeat1] = STATE(7861),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_in] = ACTIONS(6191),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [5414] = {
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(4811),
    [sym__binary_star] = ACTIONS(4813),
    [anon_sym_LBRACE] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(4815),
    [anon_sym_STAR_STAR] = ACTIONS(4813),
    [anon_sym_AMP] = ACTIONS(4817),
    [anon_sym_LT] = ACTIONS(4819),
    [anon_sym_in] = ACTIONS(6210),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_EQ_GT] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(4821),
    [anon_sym_DOT_DOT] = ACTIONS(4823),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4825),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(4829),
    [anon_sym_AMP_AMP] = ACTIONS(4829),
    [anon_sym_LT_LT] = ACTIONS(4831),
    [anon_sym_GT_GT] = ACTIONS(4831),
    [anon_sym_EQ_EQ] = ACTIONS(4833),
    [anon_sym_BANG_EQ] = ACTIONS(4829),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4829),
    [anon_sym_LT_EQ_GT] = ACTIONS(4829),
    [anon_sym_EQ_TILDE] = ACTIONS(4829),
    [anon_sym_BANG_TILDE] = ACTIONS(4829),
    [anon_sym_LT_EQ] = ACTIONS(4819),
    [anon_sym_GT] = ACTIONS(4819),
    [anon_sym_GT_EQ] = ACTIONS(4835),
    [anon_sym_CARET] = ACTIONS(4837),
    [anon_sym_PLUS] = ACTIONS(4811),
    [anon_sym_SLASH] = ACTIONS(4813),
    [anon_sym_PERCENT] = ACTIONS(4813),
    [sym_comment] = ACTIONS(87),
  },
  [5415] = {
    [sym_string] = STATE(5415),
    [aux_sym_chained_string_repeat1] = STATE(5415),
    [sym__string_start] = ACTIONS(9407),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_in] = ACTIONS(6212),
    [anon_sym_do] = ACTIONS(6212),
    [anon_sym_EQ_GT] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [5416] = {
    [sym__line_break] = ACTIONS(11391),
    [sym__heredoc_body_start] = ACTIONS(11391),
    [sym__binary_minus] = ACTIONS(11391),
    [sym__binary_star] = ACTIONS(11391),
    [ts_builtin_sym_end] = ACTIONS(11391),
    [anon_sym___END__] = ACTIONS(11391),
    [anon_sym_LBRACE] = ACTIONS(11391),
    [anon_sym_RBRACE] = ACTIONS(11391),
    [anon_sym_RPAREN] = ACTIONS(11391),
    [anon_sym_DOT] = ACTIONS(11393),
    [anon_sym_COMMA] = ACTIONS(11391),
    [anon_sym_PIPE] = ACTIONS(11393),
    [anon_sym_SEMI] = ACTIONS(11391),
    [anon_sym_STAR_STAR] = ACTIONS(11391),
    [anon_sym_AMP] = ACTIONS(11393),
    [anon_sym_LT] = ACTIONS(11393),
    [anon_sym_end] = ACTIONS(11391),
    [anon_sym_if] = ACTIONS(11391),
    [anon_sym_unless] = ACTIONS(11391),
    [anon_sym_while] = ACTIONS(11391),
    [anon_sym_until] = ACTIONS(11391),
    [anon_sym_rescue] = ACTIONS(11391),
    [anon_sym_do] = ACTIONS(11391),
    [anon_sym_when] = ACTIONS(11391),
    [anon_sym_elsif] = ACTIONS(11391),
    [anon_sym_else] = ACTIONS(11391),
    [anon_sym_then] = ACTIONS(11391),
    [anon_sym_ensure] = ACTIONS(11391),
    [anon_sym_EQ_GT] = ACTIONS(11391),
    [anon_sym_LBRACK] = ACTIONS(11391),
    [anon_sym_COLON_COLON2] = ACTIONS(11391),
    [anon_sym_AMP_DOT] = ACTIONS(11391),
    [anon_sym_QMARK] = ACTIONS(11391),
    [anon_sym_DOT_DOT] = ACTIONS(11393),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11391),
    [anon_sym_and] = ACTIONS(11391),
    [anon_sym_or] = ACTIONS(11391),
    [anon_sym_PIPE_PIPE] = ACTIONS(11391),
    [anon_sym_AMP_AMP] = ACTIONS(11391),
    [anon_sym_LT_LT] = ACTIONS(11391),
    [anon_sym_GT_GT] = ACTIONS(11391),
    [anon_sym_EQ_EQ] = ACTIONS(11393),
    [anon_sym_BANG_EQ] = ACTIONS(11391),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11391),
    [anon_sym_LT_EQ_GT] = ACTIONS(11391),
    [anon_sym_EQ_TILDE] = ACTIONS(11391),
    [anon_sym_BANG_TILDE] = ACTIONS(11391),
    [anon_sym_LT_EQ] = ACTIONS(11393),
    [anon_sym_GT] = ACTIONS(11393),
    [anon_sym_GT_EQ] = ACTIONS(11391),
    [anon_sym_CARET] = ACTIONS(11391),
    [anon_sym_PLUS] = ACTIONS(11391),
    [anon_sym_SLASH] = ACTIONS(11391),
    [anon_sym_PERCENT] = ACTIONS(11391),
    [sym_comment] = ACTIONS(87),
  },
  [5417] = {
    [anon_sym_end] = ACTIONS(11395),
    [sym_comment] = ACTIONS(87),
  },
  [5418] = {
    [sym_method] = STATE(184),
    [sym_singleton_method] = STATE(184),
    [sym_class] = STATE(184),
    [sym_singleton_class] = STATE(184),
    [sym_module] = STATE(184),
    [sym_return] = STATE(184),
    [sym_yield] = STATE(184),
    [sym_break] = STATE(184),
    [sym_next] = STATE(184),
    [sym_while] = STATE(184),
    [sym_until] = STATE(184),
    [sym_for] = STATE(184),
    [sym_case] = STATE(184),
    [sym_if] = STATE(184),
    [sym_unless] = STATE(184),
    [sym_begin] = STATE(184),
    [sym__primary] = STATE(184),
    [sym_parenthesized_statements] = STATE(184),
    [sym_element_reference] = STATE(1598),
    [sym_scope_resolution] = STATE(255),
    [sym_call] = STATE(255),
    [sym_method_call] = STATE(1598),
    [sym_destructured_left_assignment] = STATE(1597),
    [sym_rest_assignment] = STATE(1597),
    [sym__lhs] = STATE(1598),
    [sym__variable] = STATE(255),
    [sym_rational] = STATE(184),
    [sym_true] = STATE(1598),
    [sym_false] = STATE(1598),
    [sym_nil] = STATE(1598),
    [sym_chained_string] = STATE(184),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(184),
    [sym_string_array] = STATE(184),
    [sym_symbol_array] = STATE(184),
    [sym_symbol] = STATE(184),
    [sym_regex] = STATE(184),
    [sym_array] = STATE(184),
    [sym_hash] = STATE(184),
    [sym_lambda] = STATE(184),
    [sym__simple_symbol] = ACTIONS(279),
    [sym__string_start] = ACTIONS(281),
    [sym__symbol_start] = ACTIONS(283),
    [sym__subshell_start] = ACTIONS(285),
    [sym__regex_start] = ACTIONS(287),
    [sym__string_array_start] = ACTIONS(289),
    [sym__symbol_array_start] = ACTIONS(291),
    [sym_heredoc_beginning] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_def] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(475),
    [anon_sym_COLON_COLON] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(477),
    [anon_sym_class] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(307),
    [anon_sym_return] = ACTIONS(309),
    [anon_sym_yield] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(313),
    [anon_sym_next] = ACTIONS(315),
    [sym_redo] = ACTIONS(317),
    [sym_retry] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(319),
    [anon_sym_unless] = ACTIONS(321),
    [anon_sym_while] = ACTIONS(323),
    [anon_sym_until] = ACTIONS(325),
    [anon_sym_for] = ACTIONS(327),
    [anon_sym_case] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(331),
    [sym_constant] = ACTIONS(479),
    [sym_identifier] = ACTIONS(479),
    [sym_instance_variable] = ACTIONS(481),
    [sym_class_variable] = ACTIONS(481),
    [sym_global_variable] = ACTIONS(481),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(317),
    [sym_complex] = ACTIONS(293),
    [sym_super] = ACTIONS(479),
    [anon_sym_true] = ACTIONS(339),
    [anon_sym_TRUE] = ACTIONS(339),
    [anon_sym_false] = ACTIONS(341),
    [anon_sym_FALSE] = ACTIONS(341),
    [sym_self] = ACTIONS(479),
    [anon_sym_nil] = ACTIONS(343),
    [anon_sym_NIL] = ACTIONS(343),
    [sym_character] = ACTIONS(293),
    [anon_sym_LBRACK2] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(347),
  },
  [5419] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8539),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [5420] = {
    [sym_heredoc_body] = STATE(7863),
    [aux_sym_call_repeat1] = STATE(7863),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [5421] = {
    [sym_heredoc_body] = STATE(7863),
    [aux_sym_call_repeat1] = STATE(7863),
    [aux_sym_argument_list_repeat1] = STATE(7864),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(4939),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [5422] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(8537),
    [sym__binary_star] = ACTIONS(8539),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(8541),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8539),
    [anon_sym_AMP] = ACTIONS(8543),
    [anon_sym_LT] = ACTIONS(8545),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(8547),
    [anon_sym_DOT_DOT] = ACTIONS(8549),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8551),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(8553),
    [anon_sym_AMP_AMP] = ACTIONS(8553),
    [anon_sym_LT_LT] = ACTIONS(8555),
    [anon_sym_GT_GT] = ACTIONS(8555),
    [anon_sym_EQ_EQ] = ACTIONS(8557),
    [anon_sym_BANG_EQ] = ACTIONS(8553),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8553),
    [anon_sym_LT_EQ_GT] = ACTIONS(8553),
    [anon_sym_EQ_TILDE] = ACTIONS(8553),
    [anon_sym_BANG_TILDE] = ACTIONS(8553),
    [anon_sym_LT_EQ] = ACTIONS(8545),
    [anon_sym_GT] = ACTIONS(8545),
    [anon_sym_GT_EQ] = ACTIONS(8559),
    [anon_sym_CARET] = ACTIONS(8561),
    [anon_sym_PLUS] = ACTIONS(8537),
    [anon_sym_SLASH] = ACTIONS(8539),
    [anon_sym_PERCENT] = ACTIONS(8539),
    [sym_comment] = ACTIONS(87),
  },
  [5423] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7865),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2913),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2913),
    [sym_assignment] = STATE(7865),
    [sym_operator_assignment] = STATE(7865),
    [sym_conditional] = STATE(7865),
    [sym_range] = STATE(7865),
    [sym_binary] = STATE(7865),
    [sym_unary] = STATE(7865),
    [sym_left_assignment_list] = STATE(2912),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2913),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2913),
    [sym_false] = STATE(2913),
    [sym_nil] = STATE(2913),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2914),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4881),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4883),
    [anon_sym_yield] = ACTIONS(4885),
    [anon_sym_break] = ACTIONS(4887),
    [anon_sym_next] = ACTIONS(4889),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4891),
    [anon_sym_defined_QMARK] = ACTIONS(4893),
    [anon_sym_not] = ACTIONS(4895),
    [anon_sym_BANG] = ACTIONS(4897),
    [anon_sym_TILDE] = ACTIONS(4897),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5424] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7866),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2913),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2913),
    [sym_assignment] = STATE(7866),
    [sym_operator_assignment] = STATE(7866),
    [sym_conditional] = STATE(7866),
    [sym_range] = STATE(7866),
    [sym_binary] = STATE(7866),
    [sym_unary] = STATE(7866),
    [sym_left_assignment_list] = STATE(2912),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2913),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2913),
    [sym_false] = STATE(2913),
    [sym_nil] = STATE(2913),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2914),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4881),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4883),
    [anon_sym_yield] = ACTIONS(4885),
    [anon_sym_break] = ACTIONS(4887),
    [anon_sym_next] = ACTIONS(4889),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4891),
    [anon_sym_defined_QMARK] = ACTIONS(4893),
    [anon_sym_not] = ACTIONS(4895),
    [anon_sym_BANG] = ACTIONS(4897),
    [anon_sym_TILDE] = ACTIONS(4897),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5425] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7867),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2913),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2913),
    [sym_assignment] = STATE(7867),
    [sym_operator_assignment] = STATE(7867),
    [sym_conditional] = STATE(7867),
    [sym_range] = STATE(7867),
    [sym_binary] = STATE(7867),
    [sym_unary] = STATE(7867),
    [sym_left_assignment_list] = STATE(2912),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2913),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2913),
    [sym_false] = STATE(2913),
    [sym_nil] = STATE(2913),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2914),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4881),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4883),
    [anon_sym_yield] = ACTIONS(4885),
    [anon_sym_break] = ACTIONS(4887),
    [anon_sym_next] = ACTIONS(4889),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4891),
    [anon_sym_defined_QMARK] = ACTIONS(4893),
    [anon_sym_not] = ACTIONS(4895),
    [anon_sym_BANG] = ACTIONS(4897),
    [anon_sym_TILDE] = ACTIONS(4897),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5426] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7868),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2913),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2913),
    [sym_assignment] = STATE(7868),
    [sym_operator_assignment] = STATE(7868),
    [sym_conditional] = STATE(7868),
    [sym_range] = STATE(7868),
    [sym_binary] = STATE(7868),
    [sym_unary] = STATE(7868),
    [sym_left_assignment_list] = STATE(2912),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2913),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2913),
    [sym_false] = STATE(2913),
    [sym_nil] = STATE(2913),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2914),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4881),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4883),
    [anon_sym_yield] = ACTIONS(4885),
    [anon_sym_break] = ACTIONS(4887),
    [anon_sym_next] = ACTIONS(4889),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4891),
    [anon_sym_defined_QMARK] = ACTIONS(4893),
    [anon_sym_not] = ACTIONS(4895),
    [anon_sym_BANG] = ACTIONS(4897),
    [anon_sym_TILDE] = ACTIONS(4897),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5427] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7869),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2913),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2913),
    [sym_assignment] = STATE(7869),
    [sym_operator_assignment] = STATE(7869),
    [sym_conditional] = STATE(7869),
    [sym_range] = STATE(7869),
    [sym_binary] = STATE(7869),
    [sym_unary] = STATE(7869),
    [sym_left_assignment_list] = STATE(2912),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2913),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2913),
    [sym_false] = STATE(2913),
    [sym_nil] = STATE(2913),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2914),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4881),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4883),
    [anon_sym_yield] = ACTIONS(4885),
    [anon_sym_break] = ACTIONS(4887),
    [anon_sym_next] = ACTIONS(4889),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4891),
    [anon_sym_defined_QMARK] = ACTIONS(4893),
    [anon_sym_not] = ACTIONS(4895),
    [anon_sym_BANG] = ACTIONS(4897),
    [anon_sym_TILDE] = ACTIONS(4897),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5428] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(7870),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(7870),
    [sym_operator_assignment] = STATE(7870),
    [sym_conditional] = STATE(7870),
    [sym_range] = STATE(7870),
    [sym_binary] = STATE(7870),
    [sym_unary] = STATE(7870),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5429] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7871),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2913),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2913),
    [sym_assignment] = STATE(7871),
    [sym_operator_assignment] = STATE(7871),
    [sym_conditional] = STATE(7871),
    [sym_range] = STATE(7871),
    [sym_binary] = STATE(7871),
    [sym_unary] = STATE(7871),
    [sym_left_assignment_list] = STATE(2912),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2913),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2913),
    [sym_false] = STATE(2913),
    [sym_nil] = STATE(2913),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2914),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4881),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4883),
    [anon_sym_yield] = ACTIONS(4885),
    [anon_sym_break] = ACTIONS(4887),
    [anon_sym_next] = ACTIONS(4889),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4891),
    [anon_sym_defined_QMARK] = ACTIONS(4893),
    [anon_sym_not] = ACTIONS(4895),
    [anon_sym_BANG] = ACTIONS(4897),
    [anon_sym_TILDE] = ACTIONS(4897),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5430] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7872),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2913),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2913),
    [sym_assignment] = STATE(7872),
    [sym_operator_assignment] = STATE(7872),
    [sym_conditional] = STATE(7872),
    [sym_range] = STATE(7872),
    [sym_binary] = STATE(7872),
    [sym_unary] = STATE(7872),
    [sym_left_assignment_list] = STATE(2912),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2913),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2913),
    [sym_false] = STATE(2913),
    [sym_nil] = STATE(2913),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2914),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4881),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4883),
    [anon_sym_yield] = ACTIONS(4885),
    [anon_sym_break] = ACTIONS(4887),
    [anon_sym_next] = ACTIONS(4889),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4891),
    [anon_sym_defined_QMARK] = ACTIONS(4893),
    [anon_sym_not] = ACTIONS(4895),
    [anon_sym_BANG] = ACTIONS(4897),
    [anon_sym_TILDE] = ACTIONS(4897),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5431] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7873),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2913),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2913),
    [sym_assignment] = STATE(7873),
    [sym_operator_assignment] = STATE(7873),
    [sym_conditional] = STATE(7873),
    [sym_range] = STATE(7873),
    [sym_binary] = STATE(7873),
    [sym_unary] = STATE(7873),
    [sym_left_assignment_list] = STATE(2912),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2913),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2913),
    [sym_false] = STATE(2913),
    [sym_nil] = STATE(2913),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2914),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4881),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4883),
    [anon_sym_yield] = ACTIONS(4885),
    [anon_sym_break] = ACTIONS(4887),
    [anon_sym_next] = ACTIONS(4889),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4891),
    [anon_sym_defined_QMARK] = ACTIONS(4893),
    [anon_sym_not] = ACTIONS(4895),
    [anon_sym_BANG] = ACTIONS(4897),
    [anon_sym_TILDE] = ACTIONS(4897),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5432] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7874),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2913),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2913),
    [sym_assignment] = STATE(7874),
    [sym_operator_assignment] = STATE(7874),
    [sym_conditional] = STATE(7874),
    [sym_range] = STATE(7874),
    [sym_binary] = STATE(7874),
    [sym_unary] = STATE(7874),
    [sym_left_assignment_list] = STATE(2912),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2913),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2913),
    [sym_false] = STATE(2913),
    [sym_nil] = STATE(2913),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2914),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4881),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4883),
    [anon_sym_yield] = ACTIONS(4885),
    [anon_sym_break] = ACTIONS(4887),
    [anon_sym_next] = ACTIONS(4889),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4891),
    [anon_sym_defined_QMARK] = ACTIONS(4893),
    [anon_sym_not] = ACTIONS(4895),
    [anon_sym_BANG] = ACTIONS(4897),
    [anon_sym_TILDE] = ACTIONS(4897),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5433] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7875),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2913),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2913),
    [sym_splat_argument] = STATE(7876),
    [sym_assignment] = STATE(7875),
    [sym_operator_assignment] = STATE(7875),
    [sym_conditional] = STATE(7875),
    [sym_range] = STATE(7875),
    [sym_binary] = STATE(7875),
    [sym_unary] = STATE(7875),
    [sym_right_assignment_list] = STATE(2570),
    [sym__arg_or_splat_arg] = STATE(7876),
    [sym_left_assignment_list] = STATE(2912),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2913),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2913),
    [sym_false] = STATE(2913),
    [sym_nil] = STATE(2913),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2914),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(1971),
    [sym__unary_minus] = ACTIONS(4881),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4883),
    [anon_sym_yield] = ACTIONS(4885),
    [anon_sym_break] = ACTIONS(4887),
    [anon_sym_next] = ACTIONS(4889),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4891),
    [anon_sym_defined_QMARK] = ACTIONS(4893),
    [anon_sym_not] = ACTIONS(4895),
    [anon_sym_BANG] = ACTIONS(4897),
    [anon_sym_TILDE] = ACTIONS(4897),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5434] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7877),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2913),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2913),
    [sym_assignment] = STATE(7877),
    [sym_operator_assignment] = STATE(7877),
    [sym_conditional] = STATE(7877),
    [sym_range] = STATE(7877),
    [sym_binary] = STATE(7877),
    [sym_unary] = STATE(7877),
    [sym_left_assignment_list] = STATE(2912),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2913),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2913),
    [sym_false] = STATE(2913),
    [sym_nil] = STATE(2913),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2914),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4881),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4883),
    [anon_sym_yield] = ACTIONS(4885),
    [anon_sym_break] = ACTIONS(4887),
    [anon_sym_next] = ACTIONS(4889),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4891),
    [anon_sym_defined_QMARK] = ACTIONS(4893),
    [anon_sym_not] = ACTIONS(4895),
    [anon_sym_BANG] = ACTIONS(4897),
    [anon_sym_TILDE] = ACTIONS(4897),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5435] = {
    [sym_string] = STATE(7878),
    [aux_sym_chained_string_repeat1] = STATE(7878),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [5436] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(8537),
    [sym__binary_star] = ACTIONS(8539),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(8541),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(8539),
    [anon_sym_AMP] = ACTIONS(8543),
    [anon_sym_LT] = ACTIONS(8545),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(8547),
    [anon_sym_DOT_DOT] = ACTIONS(8549),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8551),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(8553),
    [anon_sym_AMP_AMP] = ACTIONS(8553),
    [anon_sym_LT_LT] = ACTIONS(8555),
    [anon_sym_GT_GT] = ACTIONS(8555),
    [anon_sym_EQ_EQ] = ACTIONS(8557),
    [anon_sym_BANG_EQ] = ACTIONS(8553),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8553),
    [anon_sym_LT_EQ_GT] = ACTIONS(8553),
    [anon_sym_EQ_TILDE] = ACTIONS(8553),
    [anon_sym_BANG_TILDE] = ACTIONS(8553),
    [anon_sym_LT_EQ] = ACTIONS(8545),
    [anon_sym_GT] = ACTIONS(8545),
    [anon_sym_GT_EQ] = ACTIONS(8559),
    [anon_sym_CARET] = ACTIONS(8561),
    [anon_sym_PLUS] = ACTIONS(8537),
    [anon_sym_SLASH] = ACTIONS(8539),
    [anon_sym_PERCENT] = ACTIONS(8539),
    [sym_comment] = ACTIONS(87),
  },
  [5437] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(4913),
    [sym__binary_star] = ACTIONS(4915),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(4917),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(4915),
    [anon_sym_AMP] = ACTIONS(4919),
    [anon_sym_LT] = ACTIONS(4921),
    [anon_sym_EQ_GT] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_DOT_DOT] = ACTIONS(4925),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4927),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(4929),
    [anon_sym_AMP_AMP] = ACTIONS(4929),
    [anon_sym_LT_LT] = ACTIONS(4931),
    [anon_sym_GT_GT] = ACTIONS(4931),
    [anon_sym_EQ_EQ] = ACTIONS(4933),
    [anon_sym_BANG_EQ] = ACTIONS(4929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4929),
    [anon_sym_LT_EQ_GT] = ACTIONS(4929),
    [anon_sym_EQ_TILDE] = ACTIONS(4929),
    [anon_sym_BANG_TILDE] = ACTIONS(4929),
    [anon_sym_LT_EQ] = ACTIONS(4921),
    [anon_sym_GT] = ACTIONS(4921),
    [anon_sym_GT_EQ] = ACTIONS(4935),
    [anon_sym_CARET] = ACTIONS(4937),
    [anon_sym_PLUS] = ACTIONS(4913),
    [anon_sym_SLASH] = ACTIONS(4915),
    [anon_sym_PERCENT] = ACTIONS(4915),
    [sym_comment] = ACTIONS(87),
  },
  [5438] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(4913),
    [sym__binary_star] = ACTIONS(4915),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(4917),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(4915),
    [anon_sym_AMP] = ACTIONS(4919),
    [anon_sym_LT] = ACTIONS(4921),
    [anon_sym_EQ_GT] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_DOT_DOT] = ACTIONS(4925),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4927),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(4929),
    [anon_sym_AMP_AMP] = ACTIONS(4929),
    [anon_sym_LT_LT] = ACTIONS(4931),
    [anon_sym_GT_GT] = ACTIONS(4931),
    [anon_sym_EQ_EQ] = ACTIONS(4933),
    [anon_sym_BANG_EQ] = ACTIONS(4929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4929),
    [anon_sym_LT_EQ_GT] = ACTIONS(4929),
    [anon_sym_EQ_TILDE] = ACTIONS(4929),
    [anon_sym_BANG_TILDE] = ACTIONS(4929),
    [anon_sym_LT_EQ] = ACTIONS(4921),
    [anon_sym_GT] = ACTIONS(4921),
    [anon_sym_GT_EQ] = ACTIONS(4935),
    [anon_sym_CARET] = ACTIONS(4937),
    [anon_sym_PLUS] = ACTIONS(4913),
    [anon_sym_SLASH] = ACTIONS(4915),
    [anon_sym_PERCENT] = ACTIONS(4915),
    [sym_comment] = ACTIONS(87),
  },
  [5439] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7879),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1113),
    [sym_scope_resolution] = STATE(1109),
    [sym_call] = STATE(1109),
    [sym_method_call] = STATE(1113),
    [sym_assignment] = STATE(7879),
    [sym_operator_assignment] = STATE(7879),
    [sym_conditional] = STATE(7879),
    [sym_range] = STATE(7879),
    [sym_binary] = STATE(7879),
    [sym_unary] = STATE(7879),
    [sym_left_assignment_list] = STATE(1112),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1113),
    [sym__variable] = STATE(1109),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1113),
    [sym_false] = STATE(1113),
    [sym_nil] = STATE(1113),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2917),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1973),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1977),
    [anon_sym_yield] = ACTIONS(1979),
    [anon_sym_break] = ACTIONS(1981),
    [anon_sym_next] = ACTIONS(1983),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4899),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1991),
    [anon_sym_TILDE] = ACTIONS(1991),
    [sym_constant] = ACTIONS(1997),
    [sym_identifier] = ACTIONS(1997),
    [sym_instance_variable] = ACTIONS(1995),
    [sym_class_variable] = ACTIONS(1995),
    [sym_global_variable] = ACTIONS(1995),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1997),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1997),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5440] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(4913),
    [sym__binary_star] = ACTIONS(4915),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(4917),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(4915),
    [anon_sym_AMP] = ACTIONS(4919),
    [anon_sym_LT] = ACTIONS(4921),
    [anon_sym_EQ_GT] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_DOT_DOT] = ACTIONS(4925),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4927),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(4929),
    [anon_sym_AMP_AMP] = ACTIONS(4929),
    [anon_sym_LT_LT] = ACTIONS(4931),
    [anon_sym_GT_GT] = ACTIONS(4931),
    [anon_sym_EQ_EQ] = ACTIONS(4933),
    [anon_sym_BANG_EQ] = ACTIONS(4929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4929),
    [anon_sym_LT_EQ_GT] = ACTIONS(4929),
    [anon_sym_EQ_TILDE] = ACTIONS(4929),
    [anon_sym_BANG_TILDE] = ACTIONS(4929),
    [anon_sym_LT_EQ] = ACTIONS(4921),
    [anon_sym_GT] = ACTIONS(4921),
    [anon_sym_GT_EQ] = ACTIONS(4935),
    [anon_sym_CARET] = ACTIONS(4937),
    [anon_sym_PLUS] = ACTIONS(4913),
    [anon_sym_SLASH] = ACTIONS(4915),
    [anon_sym_PERCENT] = ACTIONS(4915),
    [sym_comment] = ACTIONS(87),
  },
  [5441] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7880),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1113),
    [sym_scope_resolution] = STATE(1109),
    [sym_call] = STATE(1109),
    [sym_method_call] = STATE(1113),
    [sym_assignment] = STATE(7880),
    [sym_operator_assignment] = STATE(7880),
    [sym_conditional] = STATE(7880),
    [sym_range] = STATE(7880),
    [sym_binary] = STATE(7880),
    [sym_unary] = STATE(7880),
    [sym_left_assignment_list] = STATE(1112),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1113),
    [sym__variable] = STATE(1109),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1113),
    [sym_false] = STATE(1113),
    [sym_nil] = STATE(1113),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2917),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1973),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1977),
    [anon_sym_yield] = ACTIONS(1979),
    [anon_sym_break] = ACTIONS(1981),
    [anon_sym_next] = ACTIONS(1983),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4899),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1991),
    [anon_sym_TILDE] = ACTIONS(1991),
    [sym_constant] = ACTIONS(1997),
    [sym_identifier] = ACTIONS(1997),
    [sym_instance_variable] = ACTIONS(1995),
    [sym_class_variable] = ACTIONS(1995),
    [sym_global_variable] = ACTIONS(1995),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1997),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1997),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5442] = {
    [sym_heredoc_body] = STATE(7881),
    [aux_sym_call_repeat1] = STATE(7881),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [5443] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2925),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1113),
    [sym_scope_resolution] = STATE(1109),
    [sym_call] = STATE(1109),
    [sym_method_call] = STATE(1113),
    [sym__argument] = STATE(2565),
    [sym_splat_argument] = STATE(2565),
    [sym_hash_splat_argument] = STATE(2565),
    [sym_block_argument] = STATE(2565),
    [sym_assignment] = STATE(2925),
    [sym_operator_assignment] = STATE(2925),
    [sym_conditional] = STATE(2925),
    [sym_range] = STATE(2925),
    [sym_binary] = STATE(2925),
    [sym_unary] = STATE(2925),
    [sym_left_assignment_list] = STATE(1112),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1113),
    [sym__variable] = STATE(1109),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1113),
    [sym_false] = STATE(1113),
    [sym_nil] = STATE(1113),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2928),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(7882),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2565),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(4903),
    [sym__splat_star] = ACTIONS(4905),
    [sym__unary_minus] = ACTIONS(1973),
    [sym__identifier_hash_key] = ACTIONS(4907),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11397),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1977),
    [anon_sym_yield] = ACTIONS(1979),
    [anon_sym_break] = ACTIONS(1981),
    [anon_sym_next] = ACTIONS(1983),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4899),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1991),
    [anon_sym_TILDE] = ACTIONS(1991),
    [sym_constant] = ACTIONS(4909),
    [sym_identifier] = ACTIONS(4909),
    [sym_instance_variable] = ACTIONS(1995),
    [sym_class_variable] = ACTIONS(1995),
    [sym_global_variable] = ACTIONS(1995),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1997),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1997),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5444] = {
    [sym_heredoc_body] = STATE(7883),
    [aux_sym_call_repeat1] = STATE(7883),
    [aux_sym_argument_list_repeat1] = STATE(7884),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(8573),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [5445] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(8537),
    [sym__binary_star] = ACTIONS(8539),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(8541),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(8539),
    [anon_sym_AMP] = ACTIONS(8543),
    [anon_sym_LT] = ACTIONS(8545),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(8547),
    [anon_sym_DOT_DOT] = ACTIONS(8549),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8551),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(8553),
    [anon_sym_AMP_AMP] = ACTIONS(8553),
    [anon_sym_LT_LT] = ACTIONS(8555),
    [anon_sym_GT_GT] = ACTIONS(8555),
    [anon_sym_EQ_EQ] = ACTIONS(8557),
    [anon_sym_BANG_EQ] = ACTIONS(8553),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8553),
    [anon_sym_LT_EQ_GT] = ACTIONS(8553),
    [anon_sym_EQ_TILDE] = ACTIONS(8553),
    [anon_sym_BANG_TILDE] = ACTIONS(8553),
    [anon_sym_LT_EQ] = ACTIONS(8545),
    [anon_sym_GT] = ACTIONS(8545),
    [anon_sym_GT_EQ] = ACTIONS(8559),
    [anon_sym_CARET] = ACTIONS(8561),
    [anon_sym_PLUS] = ACTIONS(8537),
    [anon_sym_SLASH] = ACTIONS(8539),
    [anon_sym_PERCENT] = ACTIONS(8539),
    [sym_comment] = ACTIONS(87),
  },
  [5446] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(4915),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(4915),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(4915),
    [anon_sym_PERCENT] = ACTIONS(4915),
    [sym_comment] = ACTIONS(87),
  },
  [5447] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(4915),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [5448] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4913),
    [sym__binary_star] = ACTIONS(4915),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(4915),
    [anon_sym_AMP] = ACTIONS(4919),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(4931),
    [anon_sym_GT_GT] = ACTIONS(4931),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(4913),
    [anon_sym_SLASH] = ACTIONS(4915),
    [anon_sym_PERCENT] = ACTIONS(4915),
    [sym_comment] = ACTIONS(87),
  },
  [5449] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4913),
    [sym__binary_star] = ACTIONS(4915),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(4915),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(4931),
    [anon_sym_GT_GT] = ACTIONS(4931),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(4913),
    [anon_sym_SLASH] = ACTIONS(4915),
    [anon_sym_PERCENT] = ACTIONS(4915),
    [sym_comment] = ACTIONS(87),
  },
  [5450] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4913),
    [sym__binary_star] = ACTIONS(4915),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(4917),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(4915),
    [anon_sym_AMP] = ACTIONS(4919),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(4931),
    [anon_sym_GT_GT] = ACTIONS(4931),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(4937),
    [anon_sym_PLUS] = ACTIONS(4913),
    [anon_sym_SLASH] = ACTIONS(4915),
    [anon_sym_PERCENT] = ACTIONS(4915),
    [sym_comment] = ACTIONS(87),
  },
  [5451] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(11399),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [5452] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(4913),
    [sym__binary_star] = ACTIONS(4915),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(4917),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(4915),
    [anon_sym_AMP] = ACTIONS(4919),
    [anon_sym_LT] = ACTIONS(4921),
    [anon_sym_EQ_GT] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(4925),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4927),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(4929),
    [anon_sym_AMP_AMP] = ACTIONS(4929),
    [anon_sym_LT_LT] = ACTIONS(4931),
    [anon_sym_GT_GT] = ACTIONS(4931),
    [anon_sym_EQ_EQ] = ACTIONS(4933),
    [anon_sym_BANG_EQ] = ACTIONS(4929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4929),
    [anon_sym_LT_EQ_GT] = ACTIONS(4929),
    [anon_sym_EQ_TILDE] = ACTIONS(4929),
    [anon_sym_BANG_TILDE] = ACTIONS(4929),
    [anon_sym_LT_EQ] = ACTIONS(4921),
    [anon_sym_GT] = ACTIONS(4921),
    [anon_sym_GT_EQ] = ACTIONS(4935),
    [anon_sym_CARET] = ACTIONS(4937),
    [anon_sym_PLUS] = ACTIONS(4913),
    [anon_sym_SLASH] = ACTIONS(4915),
    [anon_sym_PERCENT] = ACTIONS(4915),
    [sym_comment] = ACTIONS(87),
  },
  [5453] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4913),
    [sym__binary_star] = ACTIONS(4915),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(4917),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(4915),
    [anon_sym_AMP] = ACTIONS(4919),
    [anon_sym_LT] = ACTIONS(4921),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_DOT_DOT] = ACTIONS(4925),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4927),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(4929),
    [anon_sym_AMP_AMP] = ACTIONS(4929),
    [anon_sym_LT_LT] = ACTIONS(4931),
    [anon_sym_GT_GT] = ACTIONS(4931),
    [anon_sym_EQ_EQ] = ACTIONS(4933),
    [anon_sym_BANG_EQ] = ACTIONS(4929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4929),
    [anon_sym_LT_EQ_GT] = ACTIONS(4929),
    [anon_sym_EQ_TILDE] = ACTIONS(4929),
    [anon_sym_BANG_TILDE] = ACTIONS(4929),
    [anon_sym_LT_EQ] = ACTIONS(4921),
    [anon_sym_GT] = ACTIONS(4921),
    [anon_sym_GT_EQ] = ACTIONS(4935),
    [anon_sym_CARET] = ACTIONS(4937),
    [anon_sym_PLUS] = ACTIONS(4913),
    [anon_sym_SLASH] = ACTIONS(4915),
    [anon_sym_PERCENT] = ACTIONS(4915),
    [sym_comment] = ACTIONS(87),
  },
  [5454] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4913),
    [sym__binary_star] = ACTIONS(4915),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(4917),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(4915),
    [anon_sym_AMP] = ACTIONS(4919),
    [anon_sym_LT] = ACTIONS(4921),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(4931),
    [anon_sym_GT_GT] = ACTIONS(4931),
    [anon_sym_EQ_EQ] = ACTIONS(4933),
    [anon_sym_BANG_EQ] = ACTIONS(4929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4929),
    [anon_sym_LT_EQ_GT] = ACTIONS(4929),
    [anon_sym_EQ_TILDE] = ACTIONS(4929),
    [anon_sym_BANG_TILDE] = ACTIONS(4929),
    [anon_sym_LT_EQ] = ACTIONS(4921),
    [anon_sym_GT] = ACTIONS(4921),
    [anon_sym_GT_EQ] = ACTIONS(4935),
    [anon_sym_CARET] = ACTIONS(4937),
    [anon_sym_PLUS] = ACTIONS(4913),
    [anon_sym_SLASH] = ACTIONS(4915),
    [anon_sym_PERCENT] = ACTIONS(4915),
    [sym_comment] = ACTIONS(87),
  },
  [5455] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(4913),
    [sym__binary_star] = ACTIONS(4915),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(4915),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(4913),
    [anon_sym_SLASH] = ACTIONS(4915),
    [anon_sym_PERCENT] = ACTIONS(4915),
    [sym_comment] = ACTIONS(87),
  },
  [5456] = {
    [sym_heredoc_body] = STATE(5456),
    [aux_sym_call_repeat1] = STATE(5456),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(7916),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [5457] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1108),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1113),
    [sym_scope_resolution] = STATE(1109),
    [sym_call] = STATE(1109),
    [sym_method_call] = STATE(1113),
    [sym__argument] = STATE(4986),
    [sym_splat_argument] = STATE(4986),
    [sym_hash_splat_argument] = STATE(4986),
    [sym_block_argument] = STATE(4986),
    [sym_assignment] = STATE(1108),
    [sym_operator_assignment] = STATE(1108),
    [sym_conditional] = STATE(1108),
    [sym_range] = STATE(1108),
    [sym_binary] = STATE(1108),
    [sym_unary] = STATE(1108),
    [sym_left_assignment_list] = STATE(1112),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1113),
    [sym__variable] = STATE(1109),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1113),
    [sym_false] = STATE(1113),
    [sym_nil] = STATE(1113),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1114),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4986),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(1969),
    [sym__splat_star] = ACTIONS(1971),
    [sym__unary_minus] = ACTIONS(1973),
    [sym__identifier_hash_key] = ACTIONS(1975),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(8577),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1977),
    [anon_sym_yield] = ACTIONS(1979),
    [anon_sym_break] = ACTIONS(1981),
    [anon_sym_next] = ACTIONS(1983),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4899),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1991),
    [anon_sym_TILDE] = ACTIONS(1991),
    [sym_constant] = ACTIONS(1993),
    [sym_identifier] = ACTIONS(1993),
    [sym_instance_variable] = ACTIONS(1995),
    [sym_class_variable] = ACTIONS(1995),
    [sym_global_variable] = ACTIONS(1995),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1997),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1997),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5458] = {
    [sym_heredoc_body] = STATE(5456),
    [aux_sym_call_repeat1] = STATE(5456),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [5459] = {
    [aux_sym_argument_list_repeat1] = STATE(5459),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(11401),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7925),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7925),
    [anon_sym_AMP_AMP] = ACTIONS(7925),
    [anon_sym_LT_LT] = ACTIONS(7925),
    [anon_sym_GT_GT] = ACTIONS(7925),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7925),
    [anon_sym_PLUS] = ACTIONS(7925),
    [anon_sym_SLASH] = ACTIONS(7925),
    [anon_sym_PERCENT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [5460] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(4913),
    [sym__binary_star] = ACTIONS(4915),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(4917),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(4915),
    [anon_sym_AMP] = ACTIONS(4919),
    [anon_sym_LT] = ACTIONS(4921),
    [anon_sym_EQ_GT] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_DOT_DOT] = ACTIONS(4925),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4927),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(4929),
    [anon_sym_AMP_AMP] = ACTIONS(4929),
    [anon_sym_LT_LT] = ACTIONS(4931),
    [anon_sym_GT_GT] = ACTIONS(4931),
    [anon_sym_EQ_EQ] = ACTIONS(4933),
    [anon_sym_BANG_EQ] = ACTIONS(4929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4929),
    [anon_sym_LT_EQ_GT] = ACTIONS(4929),
    [anon_sym_EQ_TILDE] = ACTIONS(4929),
    [anon_sym_BANG_TILDE] = ACTIONS(4929),
    [anon_sym_LT_EQ] = ACTIONS(4921),
    [anon_sym_GT] = ACTIONS(4921),
    [anon_sym_GT_EQ] = ACTIONS(4935),
    [anon_sym_CARET] = ACTIONS(4937),
    [anon_sym_PLUS] = ACTIONS(4913),
    [anon_sym_SLASH] = ACTIONS(4915),
    [anon_sym_PERCENT] = ACTIONS(4915),
    [sym_comment] = ACTIONS(87),
  },
  [5461] = {
    [aux_sym_exceptions_repeat1] = STATE(7887),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [5462] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(4913),
    [sym__binary_star] = ACTIONS(4915),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(4917),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(4915),
    [anon_sym_AMP] = ACTIONS(4919),
    [anon_sym_LT] = ACTIONS(4921),
    [anon_sym_EQ_GT] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_DOT_DOT] = ACTIONS(4925),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4927),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(4929),
    [anon_sym_AMP_AMP] = ACTIONS(4929),
    [anon_sym_LT_LT] = ACTIONS(4931),
    [anon_sym_GT_GT] = ACTIONS(4931),
    [anon_sym_EQ_EQ] = ACTIONS(4933),
    [anon_sym_BANG_EQ] = ACTIONS(4929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4929),
    [anon_sym_LT_EQ_GT] = ACTIONS(4929),
    [anon_sym_EQ_TILDE] = ACTIONS(4929),
    [anon_sym_BANG_TILDE] = ACTIONS(4929),
    [anon_sym_LT_EQ] = ACTIONS(4921),
    [anon_sym_GT] = ACTIONS(4921),
    [anon_sym_GT_EQ] = ACTIONS(4935),
    [anon_sym_CARET] = ACTIONS(4937),
    [anon_sym_PLUS] = ACTIONS(4913),
    [anon_sym_SLASH] = ACTIONS(4915),
    [anon_sym_PERCENT] = ACTIONS(4915),
    [sym_comment] = ACTIONS(87),
  },
  [5463] = {
    [sym_string] = STATE(5463),
    [aux_sym_chained_string_repeat1] = STATE(5463),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(6214),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_EQ_GT] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [5464] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7888),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(7888),
    [sym_operator_assignment] = STATE(7888),
    [sym_conditional] = STATE(7888),
    [sym_range] = STATE(7888),
    [sym_binary] = STATE(7888),
    [sym_unary] = STATE(7888),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(485),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(495),
    [anon_sym_defined_QMARK] = ACTIONS(497),
    [anon_sym_not] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(501),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5465] = {
    [sym__line_break] = ACTIONS(11404),
    [sym__heredoc_body_start] = ACTIONS(11404),
    [sym__binary_minus] = ACTIONS(11404),
    [sym__binary_star] = ACTIONS(11404),
    [ts_builtin_sym_end] = ACTIONS(11404),
    [anon_sym___END__] = ACTIONS(11404),
    [anon_sym_LBRACE] = ACTIONS(11404),
    [anon_sym_RBRACE] = ACTIONS(11404),
    [anon_sym_RPAREN] = ACTIONS(11404),
    [anon_sym_DOT] = ACTIONS(11406),
    [anon_sym_COMMA] = ACTIONS(11404),
    [anon_sym_PIPE] = ACTIONS(11406),
    [anon_sym_SEMI] = ACTIONS(11404),
    [anon_sym_STAR_STAR] = ACTIONS(11404),
    [anon_sym_AMP] = ACTIONS(11406),
    [anon_sym_LT] = ACTIONS(11406),
    [anon_sym_end] = ACTIONS(11404),
    [anon_sym_if] = ACTIONS(11404),
    [anon_sym_unless] = ACTIONS(11404),
    [anon_sym_while] = ACTIONS(11404),
    [anon_sym_until] = ACTIONS(11404),
    [anon_sym_rescue] = ACTIONS(11404),
    [anon_sym_do] = ACTIONS(11404),
    [anon_sym_when] = ACTIONS(11404),
    [anon_sym_elsif] = ACTIONS(11404),
    [anon_sym_else] = ACTIONS(11404),
    [anon_sym_then] = ACTIONS(11404),
    [anon_sym_ensure] = ACTIONS(11404),
    [anon_sym_EQ_GT] = ACTIONS(11404),
    [anon_sym_LBRACK] = ACTIONS(11404),
    [anon_sym_COLON_COLON2] = ACTIONS(11404),
    [anon_sym_AMP_DOT] = ACTIONS(11404),
    [anon_sym_QMARK] = ACTIONS(11404),
    [anon_sym_DOT_DOT] = ACTIONS(11406),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11404),
    [anon_sym_and] = ACTIONS(11404),
    [anon_sym_or] = ACTIONS(11404),
    [anon_sym_PIPE_PIPE] = ACTIONS(11404),
    [anon_sym_AMP_AMP] = ACTIONS(11404),
    [anon_sym_LT_LT] = ACTIONS(11404),
    [anon_sym_GT_GT] = ACTIONS(11404),
    [anon_sym_EQ_EQ] = ACTIONS(11406),
    [anon_sym_BANG_EQ] = ACTIONS(11404),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11404),
    [anon_sym_LT_EQ_GT] = ACTIONS(11404),
    [anon_sym_EQ_TILDE] = ACTIONS(11404),
    [anon_sym_BANG_TILDE] = ACTIONS(11404),
    [anon_sym_LT_EQ] = ACTIONS(11406),
    [anon_sym_GT] = ACTIONS(11406),
    [anon_sym_GT_EQ] = ACTIONS(11404),
    [anon_sym_CARET] = ACTIONS(11404),
    [anon_sym_PLUS] = ACTIONS(11404),
    [anon_sym_SLASH] = ACTIONS(11404),
    [anon_sym_PERCENT] = ACTIONS(11404),
    [sym_comment] = ACTIONS(87),
  },
  [5466] = {
    [anon_sym_end] = ACTIONS(11408),
    [sym_comment] = ACTIONS(87),
  },
  [5467] = {
    [sym_when] = STATE(2988),
    [sym_else] = STATE(7890),
    [aux_sym_case_repeat2] = STATE(2988),
    [anon_sym_end] = ACTIONS(11408),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [5468] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(8587),
    [sym__binary_star] = ACTIONS(8589),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(8591),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(8589),
    [anon_sym_AMP] = ACTIONS(8593),
    [anon_sym_LT] = ACTIONS(8595),
    [anon_sym_QMARK] = ACTIONS(8597),
    [anon_sym_DOT_DOT] = ACTIONS(8599),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8601),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(8603),
    [anon_sym_AMP_AMP] = ACTIONS(8603),
    [anon_sym_LT_LT] = ACTIONS(8605),
    [anon_sym_GT_GT] = ACTIONS(8605),
    [anon_sym_EQ_EQ] = ACTIONS(8607),
    [anon_sym_BANG_EQ] = ACTIONS(8603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8603),
    [anon_sym_LT_EQ_GT] = ACTIONS(8603),
    [anon_sym_EQ_TILDE] = ACTIONS(8603),
    [anon_sym_BANG_TILDE] = ACTIONS(8603),
    [anon_sym_LT_EQ] = ACTIONS(8595),
    [anon_sym_GT] = ACTIONS(8595),
    [anon_sym_GT_EQ] = ACTIONS(8609),
    [anon_sym_CARET] = ACTIONS(8611),
    [anon_sym_PLUS] = ACTIONS(8587),
    [anon_sym_SLASH] = ACTIONS(8589),
    [anon_sym_PERCENT] = ACTIONS(8589),
    [sym_comment] = ACTIONS(87),
  },
  [5469] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8589),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [5470] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(8587),
    [sym__binary_star] = ACTIONS(8589),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(8591),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8589),
    [anon_sym_AMP] = ACTIONS(8593),
    [anon_sym_LT] = ACTIONS(8595),
    [anon_sym_QMARK] = ACTIONS(8597),
    [anon_sym_DOT_DOT] = ACTIONS(8599),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8601),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(8603),
    [anon_sym_AMP_AMP] = ACTIONS(8603),
    [anon_sym_LT_LT] = ACTIONS(8605),
    [anon_sym_GT_GT] = ACTIONS(8605),
    [anon_sym_EQ_EQ] = ACTIONS(8607),
    [anon_sym_BANG_EQ] = ACTIONS(8603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8603),
    [anon_sym_LT_EQ_GT] = ACTIONS(8603),
    [anon_sym_EQ_TILDE] = ACTIONS(8603),
    [anon_sym_BANG_TILDE] = ACTIONS(8603),
    [anon_sym_LT_EQ] = ACTIONS(8595),
    [anon_sym_GT] = ACTIONS(8595),
    [anon_sym_GT_EQ] = ACTIONS(8609),
    [anon_sym_CARET] = ACTIONS(8611),
    [anon_sym_PLUS] = ACTIONS(8587),
    [anon_sym_SLASH] = ACTIONS(8589),
    [anon_sym_PERCENT] = ACTIONS(8589),
    [sym_comment] = ACTIONS(87),
  },
  [5471] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7891),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2968),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2968),
    [sym_assignment] = STATE(7891),
    [sym_operator_assignment] = STATE(7891),
    [sym_conditional] = STATE(7891),
    [sym_range] = STATE(7891),
    [sym_binary] = STATE(7891),
    [sym_unary] = STATE(7891),
    [sym_left_assignment_list] = STATE(2967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2968),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2968),
    [sym_false] = STATE(2968),
    [sym_nil] = STATE(2968),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2914),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4955),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4883),
    [anon_sym_yield] = ACTIONS(4885),
    [anon_sym_break] = ACTIONS(4887),
    [anon_sym_next] = ACTIONS(4889),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4957),
    [anon_sym_defined_QMARK] = ACTIONS(4959),
    [anon_sym_not] = ACTIONS(4961),
    [anon_sym_BANG] = ACTIONS(4963),
    [anon_sym_TILDE] = ACTIONS(4963),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5472] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7892),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2968),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2968),
    [sym_assignment] = STATE(7892),
    [sym_operator_assignment] = STATE(7892),
    [sym_conditional] = STATE(7892),
    [sym_range] = STATE(7892),
    [sym_binary] = STATE(7892),
    [sym_unary] = STATE(7892),
    [sym_left_assignment_list] = STATE(2967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2968),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2968),
    [sym_false] = STATE(2968),
    [sym_nil] = STATE(2968),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2914),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4955),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4883),
    [anon_sym_yield] = ACTIONS(4885),
    [anon_sym_break] = ACTIONS(4887),
    [anon_sym_next] = ACTIONS(4889),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4957),
    [anon_sym_defined_QMARK] = ACTIONS(4959),
    [anon_sym_not] = ACTIONS(4961),
    [anon_sym_BANG] = ACTIONS(4963),
    [anon_sym_TILDE] = ACTIONS(4963),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5473] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7893),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2968),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2968),
    [sym_assignment] = STATE(7893),
    [sym_operator_assignment] = STATE(7893),
    [sym_conditional] = STATE(7893),
    [sym_range] = STATE(7893),
    [sym_binary] = STATE(7893),
    [sym_unary] = STATE(7893),
    [sym_left_assignment_list] = STATE(2967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2968),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2968),
    [sym_false] = STATE(2968),
    [sym_nil] = STATE(2968),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2914),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4955),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4883),
    [anon_sym_yield] = ACTIONS(4885),
    [anon_sym_break] = ACTIONS(4887),
    [anon_sym_next] = ACTIONS(4889),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4957),
    [anon_sym_defined_QMARK] = ACTIONS(4959),
    [anon_sym_not] = ACTIONS(4961),
    [anon_sym_BANG] = ACTIONS(4963),
    [anon_sym_TILDE] = ACTIONS(4963),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5474] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7894),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2968),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2968),
    [sym_assignment] = STATE(7894),
    [sym_operator_assignment] = STATE(7894),
    [sym_conditional] = STATE(7894),
    [sym_range] = STATE(7894),
    [sym_binary] = STATE(7894),
    [sym_unary] = STATE(7894),
    [sym_left_assignment_list] = STATE(2967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2968),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2968),
    [sym_false] = STATE(2968),
    [sym_nil] = STATE(2968),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2914),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4955),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4883),
    [anon_sym_yield] = ACTIONS(4885),
    [anon_sym_break] = ACTIONS(4887),
    [anon_sym_next] = ACTIONS(4889),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4957),
    [anon_sym_defined_QMARK] = ACTIONS(4959),
    [anon_sym_not] = ACTIONS(4961),
    [anon_sym_BANG] = ACTIONS(4963),
    [anon_sym_TILDE] = ACTIONS(4963),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5475] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7895),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2968),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2968),
    [sym_assignment] = STATE(7895),
    [sym_operator_assignment] = STATE(7895),
    [sym_conditional] = STATE(7895),
    [sym_range] = STATE(7895),
    [sym_binary] = STATE(7895),
    [sym_unary] = STATE(7895),
    [sym_left_assignment_list] = STATE(2967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2968),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2968),
    [sym_false] = STATE(2968),
    [sym_nil] = STATE(2968),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2914),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4955),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4883),
    [anon_sym_yield] = ACTIONS(4885),
    [anon_sym_break] = ACTIONS(4887),
    [anon_sym_next] = ACTIONS(4889),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4957),
    [anon_sym_defined_QMARK] = ACTIONS(4959),
    [anon_sym_not] = ACTIONS(4961),
    [anon_sym_BANG] = ACTIONS(4963),
    [anon_sym_TILDE] = ACTIONS(4963),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5476] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(7896),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(7896),
    [sym_operator_assignment] = STATE(7896),
    [sym_conditional] = STATE(7896),
    [sym_range] = STATE(7896),
    [sym_binary] = STATE(7896),
    [sym_unary] = STATE(7896),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5477] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7897),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2968),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2968),
    [sym_assignment] = STATE(7897),
    [sym_operator_assignment] = STATE(7897),
    [sym_conditional] = STATE(7897),
    [sym_range] = STATE(7897),
    [sym_binary] = STATE(7897),
    [sym_unary] = STATE(7897),
    [sym_left_assignment_list] = STATE(2967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2968),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2968),
    [sym_false] = STATE(2968),
    [sym_nil] = STATE(2968),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2914),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4955),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4883),
    [anon_sym_yield] = ACTIONS(4885),
    [anon_sym_break] = ACTIONS(4887),
    [anon_sym_next] = ACTIONS(4889),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4957),
    [anon_sym_defined_QMARK] = ACTIONS(4959),
    [anon_sym_not] = ACTIONS(4961),
    [anon_sym_BANG] = ACTIONS(4963),
    [anon_sym_TILDE] = ACTIONS(4963),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5478] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7898),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2968),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2968),
    [sym_assignment] = STATE(7898),
    [sym_operator_assignment] = STATE(7898),
    [sym_conditional] = STATE(7898),
    [sym_range] = STATE(7898),
    [sym_binary] = STATE(7898),
    [sym_unary] = STATE(7898),
    [sym_left_assignment_list] = STATE(2967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2968),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2968),
    [sym_false] = STATE(2968),
    [sym_nil] = STATE(2968),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2914),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4955),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4883),
    [anon_sym_yield] = ACTIONS(4885),
    [anon_sym_break] = ACTIONS(4887),
    [anon_sym_next] = ACTIONS(4889),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4957),
    [anon_sym_defined_QMARK] = ACTIONS(4959),
    [anon_sym_not] = ACTIONS(4961),
    [anon_sym_BANG] = ACTIONS(4963),
    [anon_sym_TILDE] = ACTIONS(4963),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5479] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7899),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2968),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2968),
    [sym_assignment] = STATE(7899),
    [sym_operator_assignment] = STATE(7899),
    [sym_conditional] = STATE(7899),
    [sym_range] = STATE(7899),
    [sym_binary] = STATE(7899),
    [sym_unary] = STATE(7899),
    [sym_left_assignment_list] = STATE(2967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2968),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2968),
    [sym_false] = STATE(2968),
    [sym_nil] = STATE(2968),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2914),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4955),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4883),
    [anon_sym_yield] = ACTIONS(4885),
    [anon_sym_break] = ACTIONS(4887),
    [anon_sym_next] = ACTIONS(4889),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4957),
    [anon_sym_defined_QMARK] = ACTIONS(4959),
    [anon_sym_not] = ACTIONS(4961),
    [anon_sym_BANG] = ACTIONS(4963),
    [anon_sym_TILDE] = ACTIONS(4963),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5480] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7900),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2968),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2968),
    [sym_assignment] = STATE(7900),
    [sym_operator_assignment] = STATE(7900),
    [sym_conditional] = STATE(7900),
    [sym_range] = STATE(7900),
    [sym_binary] = STATE(7900),
    [sym_unary] = STATE(7900),
    [sym_left_assignment_list] = STATE(2967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2968),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2968),
    [sym_false] = STATE(2968),
    [sym_nil] = STATE(2968),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2914),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4955),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4883),
    [anon_sym_yield] = ACTIONS(4885),
    [anon_sym_break] = ACTIONS(4887),
    [anon_sym_next] = ACTIONS(4889),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4957),
    [anon_sym_defined_QMARK] = ACTIONS(4959),
    [anon_sym_not] = ACTIONS(4961),
    [anon_sym_BANG] = ACTIONS(4963),
    [anon_sym_TILDE] = ACTIONS(4963),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5481] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2965),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2968),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2968),
    [sym_splat_argument] = STATE(6406),
    [sym_assignment] = STATE(2965),
    [sym_operator_assignment] = STATE(2965),
    [sym_conditional] = STATE(2965),
    [sym_range] = STATE(2965),
    [sym_binary] = STATE(2965),
    [sym_unary] = STATE(2965),
    [sym__arg_or_splat_arg] = STATE(6406),
    [sym_left_assignment_list] = STATE(2967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2968),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2968),
    [sym_false] = STATE(2968),
    [sym_nil] = STATE(2968),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2914),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(4953),
    [sym__unary_minus] = ACTIONS(4955),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4883),
    [anon_sym_yield] = ACTIONS(4885),
    [anon_sym_break] = ACTIONS(4887),
    [anon_sym_next] = ACTIONS(4889),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4957),
    [anon_sym_defined_QMARK] = ACTIONS(4959),
    [anon_sym_not] = ACTIONS(4961),
    [anon_sym_BANG] = ACTIONS(4963),
    [anon_sym_TILDE] = ACTIONS(4963),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5482] = {
    [aux_sym_exceptions_repeat1] = STATE(7901),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_COMMA] = ACTIONS(8613),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [5483] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2965),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2968),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2968),
    [sym_splat_argument] = STATE(7902),
    [sym_assignment] = STATE(2965),
    [sym_operator_assignment] = STATE(2965),
    [sym_conditional] = STATE(2965),
    [sym_range] = STATE(2965),
    [sym_binary] = STATE(2965),
    [sym_unary] = STATE(2965),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(7902),
    [sym_left_assignment_list] = STATE(2967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2968),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2968),
    [sym_false] = STATE(2968),
    [sym_nil] = STATE(2968),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2914),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(4953),
    [sym__unary_minus] = ACTIONS(4955),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4883),
    [anon_sym_yield] = ACTIONS(4885),
    [anon_sym_break] = ACTIONS(4887),
    [anon_sym_next] = ACTIONS(4889),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4957),
    [anon_sym_defined_QMARK] = ACTIONS(4959),
    [anon_sym_not] = ACTIONS(4961),
    [anon_sym_BANG] = ACTIONS(4963),
    [anon_sym_TILDE] = ACTIONS(4963),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5484] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7903),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2968),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2968),
    [sym_assignment] = STATE(7903),
    [sym_operator_assignment] = STATE(7903),
    [sym_conditional] = STATE(7903),
    [sym_range] = STATE(7903),
    [sym_binary] = STATE(7903),
    [sym_unary] = STATE(7903),
    [sym_left_assignment_list] = STATE(2967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2968),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2968),
    [sym_false] = STATE(2968),
    [sym_nil] = STATE(2968),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2914),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4955),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4883),
    [anon_sym_yield] = ACTIONS(4885),
    [anon_sym_break] = ACTIONS(4887),
    [anon_sym_next] = ACTIONS(4889),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4957),
    [anon_sym_defined_QMARK] = ACTIONS(4959),
    [anon_sym_not] = ACTIONS(4961),
    [anon_sym_BANG] = ACTIONS(4963),
    [anon_sym_TILDE] = ACTIONS(4963),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5485] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(8637),
    [sym__binary_star] = ACTIONS(8639),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(8641),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(8639),
    [anon_sym_AMP] = ACTIONS(8643),
    [anon_sym_LT] = ACTIONS(8645),
    [anon_sym_then] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(8647),
    [anon_sym_DOT_DOT] = ACTIONS(8649),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8651),
    [anon_sym_and] = ACTIONS(8653),
    [anon_sym_or] = ACTIONS(8653),
    [anon_sym_PIPE_PIPE] = ACTIONS(8655),
    [anon_sym_AMP_AMP] = ACTIONS(8655),
    [anon_sym_LT_LT] = ACTIONS(8657),
    [anon_sym_GT_GT] = ACTIONS(8657),
    [anon_sym_EQ_EQ] = ACTIONS(8659),
    [anon_sym_BANG_EQ] = ACTIONS(8655),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8655),
    [anon_sym_LT_EQ_GT] = ACTIONS(8655),
    [anon_sym_EQ_TILDE] = ACTIONS(8655),
    [anon_sym_BANG_TILDE] = ACTIONS(8655),
    [anon_sym_LT_EQ] = ACTIONS(8645),
    [anon_sym_GT] = ACTIONS(8645),
    [anon_sym_GT_EQ] = ACTIONS(8661),
    [anon_sym_CARET] = ACTIONS(8663),
    [anon_sym_PLUS] = ACTIONS(8637),
    [anon_sym_SLASH] = ACTIONS(8639),
    [anon_sym_PERCENT] = ACTIONS(8639),
    [sym_comment] = ACTIONS(87),
  },
  [5486] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8639),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [5487] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7907),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7909),
    [sym_scope_resolution] = STATE(2981),
    [sym_call] = STATE(2981),
    [sym_method_call] = STATE(7909),
    [sym_assignment] = STATE(7907),
    [sym_operator_assignment] = STATE(7907),
    [sym_conditional] = STATE(7907),
    [sym_range] = STATE(7907),
    [sym_binary] = STATE(7907),
    [sym_unary] = STATE(7907),
    [sym_left_assignment_list] = STATE(7908),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7909),
    [sym__variable] = STATE(2981),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7909),
    [sym_false] = STATE(7909),
    [sym_nil] = STATE(7909),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2985),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11410),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4973),
    [anon_sym_yield] = ACTIONS(4975),
    [anon_sym_break] = ACTIONS(4977),
    [anon_sym_next] = ACTIONS(4979),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11412),
    [anon_sym_defined_QMARK] = ACTIONS(11414),
    [anon_sym_not] = ACTIONS(11416),
    [anon_sym_BANG] = ACTIONS(11418),
    [anon_sym_TILDE] = ACTIONS(11418),
    [sym_constant] = ACTIONS(4989),
    [sym_identifier] = ACTIONS(4989),
    [sym_instance_variable] = ACTIONS(4991),
    [sym_class_variable] = ACTIONS(4991),
    [sym_global_variable] = ACTIONS(4991),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4989),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4989),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5488] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7910),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7909),
    [sym_scope_resolution] = STATE(2981),
    [sym_call] = STATE(2981),
    [sym_method_call] = STATE(7909),
    [sym_assignment] = STATE(7910),
    [sym_operator_assignment] = STATE(7910),
    [sym_conditional] = STATE(7910),
    [sym_range] = STATE(7910),
    [sym_binary] = STATE(7910),
    [sym_unary] = STATE(7910),
    [sym_left_assignment_list] = STATE(7908),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7909),
    [sym__variable] = STATE(2981),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7909),
    [sym_false] = STATE(7909),
    [sym_nil] = STATE(7909),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2985),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11410),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4973),
    [anon_sym_yield] = ACTIONS(4975),
    [anon_sym_break] = ACTIONS(4977),
    [anon_sym_next] = ACTIONS(4979),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11412),
    [anon_sym_defined_QMARK] = ACTIONS(11414),
    [anon_sym_not] = ACTIONS(11416),
    [anon_sym_BANG] = ACTIONS(11418),
    [anon_sym_TILDE] = ACTIONS(11418),
    [sym_constant] = ACTIONS(4989),
    [sym_identifier] = ACTIONS(4989),
    [sym_instance_variable] = ACTIONS(4991),
    [sym_class_variable] = ACTIONS(4991),
    [sym_global_variable] = ACTIONS(4991),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4989),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4989),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5489] = {
    [anon_sym_COLON] = ACTIONS(11420),
    [sym_comment] = ACTIONS(87),
  },
  [5490] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7912),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7909),
    [sym_scope_resolution] = STATE(2981),
    [sym_call] = STATE(2981),
    [sym_method_call] = STATE(7909),
    [sym_assignment] = STATE(7912),
    [sym_operator_assignment] = STATE(7912),
    [sym_conditional] = STATE(7912),
    [sym_range] = STATE(7912),
    [sym_binary] = STATE(7912),
    [sym_unary] = STATE(7912),
    [sym_left_assignment_list] = STATE(7908),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7909),
    [sym__variable] = STATE(2981),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7909),
    [sym_false] = STATE(7909),
    [sym_nil] = STATE(7909),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2985),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11410),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4973),
    [anon_sym_yield] = ACTIONS(4975),
    [anon_sym_break] = ACTIONS(4977),
    [anon_sym_next] = ACTIONS(4979),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11412),
    [anon_sym_defined_QMARK] = ACTIONS(11414),
    [anon_sym_not] = ACTIONS(11416),
    [anon_sym_BANG] = ACTIONS(11418),
    [anon_sym_TILDE] = ACTIONS(11418),
    [sym_constant] = ACTIONS(4989),
    [sym_identifier] = ACTIONS(4989),
    [sym_instance_variable] = ACTIONS(4991),
    [sym_class_variable] = ACTIONS(4991),
    [sym_global_variable] = ACTIONS(4991),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4989),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4989),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5491] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(11422),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_then] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [5492] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(8747),
    [sym__binary_star] = ACTIONS(8749),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(8751),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(8749),
    [anon_sym_AMP] = ACTIONS(8753),
    [anon_sym_LT] = ACTIONS(8755),
    [anon_sym_then] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(11420),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(8757),
    [anon_sym_DOT_DOT] = ACTIONS(8759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8761),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(8763),
    [anon_sym_AMP_AMP] = ACTIONS(8763),
    [anon_sym_LT_LT] = ACTIONS(8765),
    [anon_sym_GT_GT] = ACTIONS(8765),
    [anon_sym_EQ_EQ] = ACTIONS(8767),
    [anon_sym_BANG_EQ] = ACTIONS(8763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8763),
    [anon_sym_LT_EQ_GT] = ACTIONS(8763),
    [anon_sym_EQ_TILDE] = ACTIONS(8763),
    [anon_sym_BANG_TILDE] = ACTIONS(8763),
    [anon_sym_LT_EQ] = ACTIONS(8755),
    [anon_sym_GT] = ACTIONS(8755),
    [anon_sym_GT_EQ] = ACTIONS(8769),
    [anon_sym_CARET] = ACTIONS(8771),
    [anon_sym_PLUS] = ACTIONS(8747),
    [anon_sym_SLASH] = ACTIONS(8749),
    [anon_sym_PERCENT] = ACTIONS(8749),
    [sym_comment] = ACTIONS(87),
  },
  [5493] = {
    [sym_heredoc_body] = STATE(7914),
    [aux_sym_call_repeat1] = STATE(7914),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_then] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [5494] = {
    [sym_heredoc_body] = STATE(7914),
    [aux_sym_call_repeat1] = STATE(7914),
    [aux_sym_argument_list_repeat1] = STATE(7916),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(11424),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_then] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [5495] = {
    [sym_string] = STATE(3102),
    [aux_sym_chained_string_repeat1] = STATE(3102),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(11426),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [5496] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(8637),
    [sym__binary_star] = ACTIONS(8639),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(8641),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8639),
    [anon_sym_AMP] = ACTIONS(8643),
    [anon_sym_LT] = ACTIONS(8645),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(8647),
    [anon_sym_DOT_DOT] = ACTIONS(8649),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8651),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(8655),
    [anon_sym_AMP_AMP] = ACTIONS(8655),
    [anon_sym_LT_LT] = ACTIONS(8657),
    [anon_sym_GT_GT] = ACTIONS(8657),
    [anon_sym_EQ_EQ] = ACTIONS(8659),
    [anon_sym_BANG_EQ] = ACTIONS(8655),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8655),
    [anon_sym_LT_EQ_GT] = ACTIONS(8655),
    [anon_sym_EQ_TILDE] = ACTIONS(8655),
    [anon_sym_BANG_TILDE] = ACTIONS(8655),
    [anon_sym_LT_EQ] = ACTIONS(8645),
    [anon_sym_GT] = ACTIONS(8645),
    [anon_sym_GT_EQ] = ACTIONS(8661),
    [anon_sym_CARET] = ACTIONS(8663),
    [anon_sym_PLUS] = ACTIONS(8637),
    [anon_sym_SLASH] = ACTIONS(8639),
    [anon_sym_PERCENT] = ACTIONS(8639),
    [sym_comment] = ACTIONS(87),
  },
  [5497] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_pattern] = STATE(7917),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2980),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2984),
    [sym_scope_resolution] = STATE(2981),
    [sym_call] = STATE(2981),
    [sym_method_call] = STATE(2984),
    [sym_splat_argument] = STATE(2982),
    [sym_assignment] = STATE(2980),
    [sym_operator_assignment] = STATE(2980),
    [sym_conditional] = STATE(2980),
    [sym_range] = STATE(2980),
    [sym_binary] = STATE(2980),
    [sym_unary] = STATE(2980),
    [sym_left_assignment_list] = STATE(2983),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2984),
    [sym__variable] = STATE(2981),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2984),
    [sym_false] = STATE(2984),
    [sym_nil] = STATE(2984),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2985),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(4969),
    [sym__unary_minus] = ACTIONS(4971),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4973),
    [anon_sym_yield] = ACTIONS(4975),
    [anon_sym_break] = ACTIONS(4977),
    [anon_sym_next] = ACTIONS(4979),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4981),
    [anon_sym_defined_QMARK] = ACTIONS(4983),
    [anon_sym_not] = ACTIONS(4985),
    [anon_sym_BANG] = ACTIONS(4987),
    [anon_sym_TILDE] = ACTIONS(4987),
    [sym_constant] = ACTIONS(4989),
    [sym_identifier] = ACTIONS(4989),
    [sym_instance_variable] = ACTIONS(4991),
    [sym_class_variable] = ACTIONS(4991),
    [sym_global_variable] = ACTIONS(4991),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4989),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4989),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5498] = {
    [sym__statements] = STATE(2640),
    [sym_begin_block] = STATE(7926),
    [sym_end_block] = STATE(7926),
    [sym__statement] = STATE(7926),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(7926),
    [sym_unless_modifier] = STATE(7926),
    [sym_while_modifier] = STATE(7926),
    [sym_until_modifier] = STATE(7926),
    [sym_rescue_modifier] = STATE(7926),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7927),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7930),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(7930),
    [sym_assignment] = STATE(7927),
    [sym_operator_assignment] = STATE(7927),
    [sym_conditional] = STATE(7927),
    [sym_range] = STATE(7927),
    [sym_binary] = STATE(7927),
    [sym_unary] = STATE(7927),
    [sym_left_assignment_list] = STATE(7929),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7930),
    [sym__variable] = STATE(7928),
    [sym_undef] = STATE(7926),
    [sym_alias] = STATE(7926),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7930),
    [sym_false] = STATE(7930),
    [sym_nil] = STATE(7930),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7931),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(7932),
    [aux_sym__statements_repeat1] = STATE(7932),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11428),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(4469),
    [anon_sym_return] = ACTIONS(11430),
    [anon_sym_yield] = ACTIONS(11432),
    [anon_sym_break] = ACTIONS(11434),
    [anon_sym_next] = ACTIONS(11436),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_when] = ACTIONS(4469),
    [anon_sym_else] = ACTIONS(4469),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11438),
    [anon_sym_defined_QMARK] = ACTIONS(11440),
    [anon_sym_not] = ACTIONS(11442),
    [anon_sym_BANG] = ACTIONS(11444),
    [anon_sym_TILDE] = ACTIONS(11444),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [anon_sym_undef] = ACTIONS(11450),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5499] = {
    [anon_sym_end] = ACTIONS(11452),
    [anon_sym_when] = ACTIONS(11452),
    [anon_sym_else] = ACTIONS(11452),
    [sym_comment] = ACTIONS(87),
  },
  [5500] = {
    [sym__statements] = STATE(2640),
    [sym_begin_block] = STATE(7926),
    [sym_end_block] = STATE(7926),
    [sym__statement] = STATE(7926),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(7926),
    [sym_unless_modifier] = STATE(7926),
    [sym_while_modifier] = STATE(7926),
    [sym_until_modifier] = STATE(7926),
    [sym_rescue_modifier] = STATE(7926),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7927),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7930),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(7930),
    [sym_assignment] = STATE(7927),
    [sym_operator_assignment] = STATE(7927),
    [sym_conditional] = STATE(7927),
    [sym_range] = STATE(7927),
    [sym_binary] = STATE(7927),
    [sym_unary] = STATE(7927),
    [sym_left_assignment_list] = STATE(7929),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7930),
    [sym__variable] = STATE(7928),
    [sym_undef] = STATE(7926),
    [sym_alias] = STATE(7926),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7930),
    [sym_false] = STATE(7930),
    [sym_nil] = STATE(7930),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7931),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(7932),
    [aux_sym__statements_repeat1] = STATE(7932),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11428),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(11454),
    [anon_sym_return] = ACTIONS(11430),
    [anon_sym_yield] = ACTIONS(11432),
    [anon_sym_break] = ACTIONS(11434),
    [anon_sym_next] = ACTIONS(11436),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_when] = ACTIONS(11454),
    [anon_sym_else] = ACTIONS(11454),
    [anon_sym_then] = ACTIONS(11456),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11438),
    [anon_sym_defined_QMARK] = ACTIONS(11440),
    [anon_sym_not] = ACTIONS(11442),
    [anon_sym_BANG] = ACTIONS(11444),
    [anon_sym_TILDE] = ACTIONS(11444),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [anon_sym_undef] = ACTIONS(11450),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5501] = {
    [sym_then] = STATE(7934),
    [sym_heredoc_body] = STATE(7935),
    [sym__terminator] = STATE(7935),
    [aux_sym_when_repeat1] = STATE(7936),
    [sym__line_break] = ACTIONS(11458),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_COMMA] = ACTIONS(8631),
    [anon_sym_SEMI] = ACTIONS(11458),
    [anon_sym_then] = ACTIONS(8633),
    [sym_comment] = ACTIONS(87),
  },
  [5502] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7937),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2984),
    [sym_scope_resolution] = STATE(2981),
    [sym_call] = STATE(2981),
    [sym_method_call] = STATE(2984),
    [sym_assignment] = STATE(7937),
    [sym_operator_assignment] = STATE(7937),
    [sym_conditional] = STATE(7937),
    [sym_range] = STATE(7937),
    [sym_binary] = STATE(7937),
    [sym_unary] = STATE(7937),
    [sym_left_assignment_list] = STATE(2983),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2984),
    [sym__variable] = STATE(2981),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2984),
    [sym_false] = STATE(2984),
    [sym_nil] = STATE(2984),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2985),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4971),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4973),
    [anon_sym_yield] = ACTIONS(4975),
    [anon_sym_break] = ACTIONS(4977),
    [anon_sym_next] = ACTIONS(4979),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4981),
    [anon_sym_defined_QMARK] = ACTIONS(4983),
    [anon_sym_not] = ACTIONS(4985),
    [anon_sym_BANG] = ACTIONS(4987),
    [anon_sym_TILDE] = ACTIONS(4987),
    [sym_constant] = ACTIONS(4989),
    [sym_identifier] = ACTIONS(4989),
    [sym_instance_variable] = ACTIONS(4991),
    [sym_class_variable] = ACTIONS(4991),
    [sym_global_variable] = ACTIONS(4991),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4989),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4989),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5503] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7938),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2984),
    [sym_scope_resolution] = STATE(2981),
    [sym_call] = STATE(2981),
    [sym_method_call] = STATE(2984),
    [sym_assignment] = STATE(7938),
    [sym_operator_assignment] = STATE(7938),
    [sym_conditional] = STATE(7938),
    [sym_range] = STATE(7938),
    [sym_binary] = STATE(7938),
    [sym_unary] = STATE(7938),
    [sym_left_assignment_list] = STATE(2983),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2984),
    [sym__variable] = STATE(2981),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2984),
    [sym_false] = STATE(2984),
    [sym_nil] = STATE(2984),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2985),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4971),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4973),
    [anon_sym_yield] = ACTIONS(4975),
    [anon_sym_break] = ACTIONS(4977),
    [anon_sym_next] = ACTIONS(4979),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4981),
    [anon_sym_defined_QMARK] = ACTIONS(4983),
    [anon_sym_not] = ACTIONS(4985),
    [anon_sym_BANG] = ACTIONS(4987),
    [anon_sym_TILDE] = ACTIONS(4987),
    [sym_constant] = ACTIONS(4989),
    [sym_identifier] = ACTIONS(4989),
    [sym_instance_variable] = ACTIONS(4991),
    [sym_class_variable] = ACTIONS(4991),
    [sym_global_variable] = ACTIONS(4991),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4989),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4989),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5504] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7939),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2984),
    [sym_scope_resolution] = STATE(2981),
    [sym_call] = STATE(2981),
    [sym_method_call] = STATE(2984),
    [sym_assignment] = STATE(7939),
    [sym_operator_assignment] = STATE(7939),
    [sym_conditional] = STATE(7939),
    [sym_range] = STATE(7939),
    [sym_binary] = STATE(7939),
    [sym_unary] = STATE(7939),
    [sym_left_assignment_list] = STATE(2983),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2984),
    [sym__variable] = STATE(2981),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2984),
    [sym_false] = STATE(2984),
    [sym_nil] = STATE(2984),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2985),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4971),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4973),
    [anon_sym_yield] = ACTIONS(4975),
    [anon_sym_break] = ACTIONS(4977),
    [anon_sym_next] = ACTIONS(4979),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4981),
    [anon_sym_defined_QMARK] = ACTIONS(4983),
    [anon_sym_not] = ACTIONS(4985),
    [anon_sym_BANG] = ACTIONS(4987),
    [anon_sym_TILDE] = ACTIONS(4987),
    [sym_constant] = ACTIONS(4989),
    [sym_identifier] = ACTIONS(4989),
    [sym_instance_variable] = ACTIONS(4991),
    [sym_class_variable] = ACTIONS(4991),
    [sym_global_variable] = ACTIONS(4991),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4989),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4989),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5505] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7940),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2984),
    [sym_scope_resolution] = STATE(2981),
    [sym_call] = STATE(2981),
    [sym_method_call] = STATE(2984),
    [sym_assignment] = STATE(7940),
    [sym_operator_assignment] = STATE(7940),
    [sym_conditional] = STATE(7940),
    [sym_range] = STATE(7940),
    [sym_binary] = STATE(7940),
    [sym_unary] = STATE(7940),
    [sym_left_assignment_list] = STATE(2983),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2984),
    [sym__variable] = STATE(2981),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2984),
    [sym_false] = STATE(2984),
    [sym_nil] = STATE(2984),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2985),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4971),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4973),
    [anon_sym_yield] = ACTIONS(4975),
    [anon_sym_break] = ACTIONS(4977),
    [anon_sym_next] = ACTIONS(4979),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4981),
    [anon_sym_defined_QMARK] = ACTIONS(4983),
    [anon_sym_not] = ACTIONS(4985),
    [anon_sym_BANG] = ACTIONS(4987),
    [anon_sym_TILDE] = ACTIONS(4987),
    [sym_constant] = ACTIONS(4989),
    [sym_identifier] = ACTIONS(4989),
    [sym_instance_variable] = ACTIONS(4991),
    [sym_class_variable] = ACTIONS(4991),
    [sym_global_variable] = ACTIONS(4991),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4989),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4989),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5506] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7941),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2984),
    [sym_scope_resolution] = STATE(2981),
    [sym_call] = STATE(2981),
    [sym_method_call] = STATE(2984),
    [sym_assignment] = STATE(7941),
    [sym_operator_assignment] = STATE(7941),
    [sym_conditional] = STATE(7941),
    [sym_range] = STATE(7941),
    [sym_binary] = STATE(7941),
    [sym_unary] = STATE(7941),
    [sym_left_assignment_list] = STATE(2983),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2984),
    [sym__variable] = STATE(2981),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2984),
    [sym_false] = STATE(2984),
    [sym_nil] = STATE(2984),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2985),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4971),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4973),
    [anon_sym_yield] = ACTIONS(4975),
    [anon_sym_break] = ACTIONS(4977),
    [anon_sym_next] = ACTIONS(4979),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4981),
    [anon_sym_defined_QMARK] = ACTIONS(4983),
    [anon_sym_not] = ACTIONS(4985),
    [anon_sym_BANG] = ACTIONS(4987),
    [anon_sym_TILDE] = ACTIONS(4987),
    [sym_constant] = ACTIONS(4989),
    [sym_identifier] = ACTIONS(4989),
    [sym_instance_variable] = ACTIONS(4991),
    [sym_class_variable] = ACTIONS(4991),
    [sym_global_variable] = ACTIONS(4991),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4989),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4989),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5507] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(7942),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(7942),
    [sym_operator_assignment] = STATE(7942),
    [sym_conditional] = STATE(7942),
    [sym_range] = STATE(7942),
    [sym_binary] = STATE(7942),
    [sym_unary] = STATE(7942),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5508] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7943),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2984),
    [sym_scope_resolution] = STATE(2981),
    [sym_call] = STATE(2981),
    [sym_method_call] = STATE(2984),
    [sym_assignment] = STATE(7943),
    [sym_operator_assignment] = STATE(7943),
    [sym_conditional] = STATE(7943),
    [sym_range] = STATE(7943),
    [sym_binary] = STATE(7943),
    [sym_unary] = STATE(7943),
    [sym_left_assignment_list] = STATE(2983),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2984),
    [sym__variable] = STATE(2981),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2984),
    [sym_false] = STATE(2984),
    [sym_nil] = STATE(2984),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2985),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4971),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4973),
    [anon_sym_yield] = ACTIONS(4975),
    [anon_sym_break] = ACTIONS(4977),
    [anon_sym_next] = ACTIONS(4979),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4981),
    [anon_sym_defined_QMARK] = ACTIONS(4983),
    [anon_sym_not] = ACTIONS(4985),
    [anon_sym_BANG] = ACTIONS(4987),
    [anon_sym_TILDE] = ACTIONS(4987),
    [sym_constant] = ACTIONS(4989),
    [sym_identifier] = ACTIONS(4989),
    [sym_instance_variable] = ACTIONS(4991),
    [sym_class_variable] = ACTIONS(4991),
    [sym_global_variable] = ACTIONS(4991),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4989),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4989),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5509] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7944),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2984),
    [sym_scope_resolution] = STATE(2981),
    [sym_call] = STATE(2981),
    [sym_method_call] = STATE(2984),
    [sym_assignment] = STATE(7944),
    [sym_operator_assignment] = STATE(7944),
    [sym_conditional] = STATE(7944),
    [sym_range] = STATE(7944),
    [sym_binary] = STATE(7944),
    [sym_unary] = STATE(7944),
    [sym_left_assignment_list] = STATE(2983),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2984),
    [sym__variable] = STATE(2981),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2984),
    [sym_false] = STATE(2984),
    [sym_nil] = STATE(2984),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2985),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4971),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4973),
    [anon_sym_yield] = ACTIONS(4975),
    [anon_sym_break] = ACTIONS(4977),
    [anon_sym_next] = ACTIONS(4979),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4981),
    [anon_sym_defined_QMARK] = ACTIONS(4983),
    [anon_sym_not] = ACTIONS(4985),
    [anon_sym_BANG] = ACTIONS(4987),
    [anon_sym_TILDE] = ACTIONS(4987),
    [sym_constant] = ACTIONS(4989),
    [sym_identifier] = ACTIONS(4989),
    [sym_instance_variable] = ACTIONS(4991),
    [sym_class_variable] = ACTIONS(4991),
    [sym_global_variable] = ACTIONS(4991),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4989),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4989),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5510] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7945),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2984),
    [sym_scope_resolution] = STATE(2981),
    [sym_call] = STATE(2981),
    [sym_method_call] = STATE(2984),
    [sym_assignment] = STATE(7945),
    [sym_operator_assignment] = STATE(7945),
    [sym_conditional] = STATE(7945),
    [sym_range] = STATE(7945),
    [sym_binary] = STATE(7945),
    [sym_unary] = STATE(7945),
    [sym_left_assignment_list] = STATE(2983),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2984),
    [sym__variable] = STATE(2981),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2984),
    [sym_false] = STATE(2984),
    [sym_nil] = STATE(2984),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2985),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4971),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4973),
    [anon_sym_yield] = ACTIONS(4975),
    [anon_sym_break] = ACTIONS(4977),
    [anon_sym_next] = ACTIONS(4979),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4981),
    [anon_sym_defined_QMARK] = ACTIONS(4983),
    [anon_sym_not] = ACTIONS(4985),
    [anon_sym_BANG] = ACTIONS(4987),
    [anon_sym_TILDE] = ACTIONS(4987),
    [sym_constant] = ACTIONS(4989),
    [sym_identifier] = ACTIONS(4989),
    [sym_instance_variable] = ACTIONS(4991),
    [sym_class_variable] = ACTIONS(4991),
    [sym_global_variable] = ACTIONS(4991),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4989),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4989),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5511] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7946),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2984),
    [sym_scope_resolution] = STATE(2981),
    [sym_call] = STATE(2981),
    [sym_method_call] = STATE(2984),
    [sym_assignment] = STATE(7946),
    [sym_operator_assignment] = STATE(7946),
    [sym_conditional] = STATE(7946),
    [sym_range] = STATE(7946),
    [sym_binary] = STATE(7946),
    [sym_unary] = STATE(7946),
    [sym_left_assignment_list] = STATE(2983),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2984),
    [sym__variable] = STATE(2981),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2984),
    [sym_false] = STATE(2984),
    [sym_nil] = STATE(2984),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2985),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4971),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4973),
    [anon_sym_yield] = ACTIONS(4975),
    [anon_sym_break] = ACTIONS(4977),
    [anon_sym_next] = ACTIONS(4979),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4981),
    [anon_sym_defined_QMARK] = ACTIONS(4983),
    [anon_sym_not] = ACTIONS(4985),
    [anon_sym_BANG] = ACTIONS(4987),
    [anon_sym_TILDE] = ACTIONS(4987),
    [sym_constant] = ACTIONS(4989),
    [sym_identifier] = ACTIONS(4989),
    [sym_instance_variable] = ACTIONS(4991),
    [sym_class_variable] = ACTIONS(4991),
    [sym_global_variable] = ACTIONS(4991),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4989),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4989),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5512] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(7954),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7957),
    [sym_scope_resolution] = STATE(7955),
    [sym_call] = STATE(7955),
    [sym_method_call] = STATE(7957),
    [sym_assignment] = STATE(7954),
    [sym_operator_assignment] = STATE(7954),
    [sym_conditional] = STATE(7954),
    [sym_range] = STATE(7954),
    [sym_binary] = STATE(7954),
    [sym_unary] = STATE(7954),
    [sym_left_assignment_list] = STATE(7956),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7957),
    [sym__variable] = STATE(7955),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7957),
    [sym_false] = STATE(7957),
    [sym_nil] = STATE(7957),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7958),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11460),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11462),
    [anon_sym_yield] = ACTIONS(11464),
    [anon_sym_break] = ACTIONS(11466),
    [anon_sym_next] = ACTIONS(11468),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11470),
    [anon_sym_defined_QMARK] = ACTIONS(11472),
    [anon_sym_not] = ACTIONS(11474),
    [anon_sym_BANG] = ACTIONS(11476),
    [anon_sym_TILDE] = ACTIONS(11476),
    [sym_constant] = ACTIONS(11478),
    [sym_identifier] = ACTIONS(11478),
    [sym_instance_variable] = ACTIONS(11480),
    [sym_class_variable] = ACTIONS(11480),
    [sym_global_variable] = ACTIONS(11480),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11478),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11478),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [5513] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(7959),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7957),
    [sym_scope_resolution] = STATE(7955),
    [sym_call] = STATE(7955),
    [sym_method_call] = STATE(7957),
    [sym_assignment] = STATE(7959),
    [sym_operator_assignment] = STATE(7959),
    [sym_conditional] = STATE(7959),
    [sym_range] = STATE(7959),
    [sym_binary] = STATE(7959),
    [sym_unary] = STATE(7959),
    [sym_left_assignment_list] = STATE(7956),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7957),
    [sym__variable] = STATE(7955),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7957),
    [sym_false] = STATE(7957),
    [sym_nil] = STATE(7957),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7958),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11460),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11462),
    [anon_sym_yield] = ACTIONS(11464),
    [anon_sym_break] = ACTIONS(11466),
    [anon_sym_next] = ACTIONS(11468),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11470),
    [anon_sym_defined_QMARK] = ACTIONS(11472),
    [anon_sym_not] = ACTIONS(11474),
    [anon_sym_BANG] = ACTIONS(11476),
    [anon_sym_TILDE] = ACTIONS(11476),
    [sym_constant] = ACTIONS(11478),
    [sym_identifier] = ACTIONS(11478),
    [sym_instance_variable] = ACTIONS(11480),
    [sym_class_variable] = ACTIONS(11480),
    [sym_global_variable] = ACTIONS(11480),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11478),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11478),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [5514] = {
    [anon_sym_COLON] = ACTIONS(11482),
    [sym_comment] = ACTIONS(87),
  },
  [5515] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(7961),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7957),
    [sym_scope_resolution] = STATE(7955),
    [sym_call] = STATE(7955),
    [sym_method_call] = STATE(7957),
    [sym_assignment] = STATE(7961),
    [sym_operator_assignment] = STATE(7961),
    [sym_conditional] = STATE(7961),
    [sym_range] = STATE(7961),
    [sym_binary] = STATE(7961),
    [sym_unary] = STATE(7961),
    [sym_left_assignment_list] = STATE(7956),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7957),
    [sym__variable] = STATE(7955),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7957),
    [sym_false] = STATE(7957),
    [sym_nil] = STATE(7957),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7958),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11460),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11462),
    [anon_sym_yield] = ACTIONS(11464),
    [anon_sym_break] = ACTIONS(11466),
    [anon_sym_next] = ACTIONS(11468),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11470),
    [anon_sym_defined_QMARK] = ACTIONS(11472),
    [anon_sym_not] = ACTIONS(11474),
    [anon_sym_BANG] = ACTIONS(11476),
    [anon_sym_TILDE] = ACTIONS(11476),
    [sym_constant] = ACTIONS(11478),
    [sym_identifier] = ACTIONS(11478),
    [sym_instance_variable] = ACTIONS(11480),
    [sym_class_variable] = ACTIONS(11480),
    [sym_global_variable] = ACTIONS(11480),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11478),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11478),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [5516] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(11484),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_then] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [5517] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(8833),
    [sym__binary_star] = ACTIONS(8835),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(8837),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(8839),
    [anon_sym_AMP] = ACTIONS(8841),
    [anon_sym_EQ] = ACTIONS(1631),
    [anon_sym_LT] = ACTIONS(8843),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_then] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(11482),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_PLUS_EQ] = ACTIONS(1625),
    [anon_sym_DASH_EQ] = ACTIONS(1625),
    [anon_sym_STAR_EQ] = ACTIONS(1625),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1625),
    [anon_sym_SLASH_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1625),
    [anon_sym_AMP_EQ] = ACTIONS(1625),
    [anon_sym_PERCENT_EQ] = ACTIONS(1625),
    [anon_sym_GT_GT_EQ] = ACTIONS(1625),
    [anon_sym_LT_LT_EQ] = ACTIONS(1625),
    [anon_sym_CARET_EQ] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(8845),
    [anon_sym_DOT_DOT] = ACTIONS(8847),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8849),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(8851),
    [anon_sym_AMP_AMP] = ACTIONS(8851),
    [anon_sym_LT_LT] = ACTIONS(8853),
    [anon_sym_GT_GT] = ACTIONS(8853),
    [anon_sym_EQ_EQ] = ACTIONS(8851),
    [anon_sym_BANG_EQ] = ACTIONS(8855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8855),
    [anon_sym_LT_EQ_GT] = ACTIONS(8855),
    [anon_sym_EQ_TILDE] = ACTIONS(8855),
    [anon_sym_BANG_TILDE] = ACTIONS(8855),
    [anon_sym_LT_EQ] = ACTIONS(8843),
    [anon_sym_GT] = ACTIONS(8843),
    [anon_sym_GT_EQ] = ACTIONS(8857),
    [anon_sym_CARET] = ACTIONS(8837),
    [anon_sym_PLUS] = ACTIONS(8859),
    [anon_sym_SLASH] = ACTIONS(8839),
    [anon_sym_PERCENT] = ACTIONS(8839),
    [sym_comment] = ACTIONS(87),
  },
  [5518] = {
    [sym_heredoc_body] = STATE(7963),
    [aux_sym_call_repeat1] = STATE(7963),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_then] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [5519] = {
    [sym_heredoc_body] = STATE(7963),
    [aux_sym_call_repeat1] = STATE(7963),
    [aux_sym_argument_list_repeat1] = STATE(7965),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(11486),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_then] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [5520] = {
    [sym_string] = STATE(5659),
    [aux_sym_chained_string_repeat1] = STATE(5659),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(747),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(11488),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5521] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7967),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2984),
    [sym_scope_resolution] = STATE(2981),
    [sym_call] = STATE(2981),
    [sym_method_call] = STATE(2984),
    [sym_splat_argument] = STATE(7968),
    [sym_assignment] = STATE(7967),
    [sym_operator_assignment] = STATE(7967),
    [sym_conditional] = STATE(7967),
    [sym_range] = STATE(7967),
    [sym_binary] = STATE(7967),
    [sym_unary] = STATE(7967),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(7968),
    [sym_left_assignment_list] = STATE(2983),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2984),
    [sym__variable] = STATE(2981),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2984),
    [sym_false] = STATE(2984),
    [sym_nil] = STATE(2984),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2985),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(11490),
    [sym__unary_minus] = ACTIONS(4971),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4973),
    [anon_sym_yield] = ACTIONS(4975),
    [anon_sym_break] = ACTIONS(4977),
    [anon_sym_next] = ACTIONS(4979),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4981),
    [anon_sym_defined_QMARK] = ACTIONS(4983),
    [anon_sym_not] = ACTIONS(4985),
    [anon_sym_BANG] = ACTIONS(4987),
    [anon_sym_TILDE] = ACTIONS(4987),
    [sym_constant] = ACTIONS(4989),
    [sym_identifier] = ACTIONS(4989),
    [sym_instance_variable] = ACTIONS(4991),
    [sym_class_variable] = ACTIONS(4991),
    [sym_global_variable] = ACTIONS(4991),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4989),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4989),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5522] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7969),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2984),
    [sym_scope_resolution] = STATE(2981),
    [sym_call] = STATE(2981),
    [sym_method_call] = STATE(2984),
    [sym_assignment] = STATE(7969),
    [sym_operator_assignment] = STATE(7969),
    [sym_conditional] = STATE(7969),
    [sym_range] = STATE(7969),
    [sym_binary] = STATE(7969),
    [sym_unary] = STATE(7969),
    [sym_left_assignment_list] = STATE(2983),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2984),
    [sym__variable] = STATE(2981),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2984),
    [sym_false] = STATE(2984),
    [sym_nil] = STATE(2984),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2985),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4971),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4973),
    [anon_sym_yield] = ACTIONS(4975),
    [anon_sym_break] = ACTIONS(4977),
    [anon_sym_next] = ACTIONS(4979),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4981),
    [anon_sym_defined_QMARK] = ACTIONS(4983),
    [anon_sym_not] = ACTIONS(4985),
    [anon_sym_BANG] = ACTIONS(4987),
    [anon_sym_TILDE] = ACTIONS(4987),
    [sym_constant] = ACTIONS(4989),
    [sym_identifier] = ACTIONS(4989),
    [sym_instance_variable] = ACTIONS(4991),
    [sym_class_variable] = ACTIONS(4991),
    [sym_global_variable] = ACTIONS(4991),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4989),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4989),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5523] = {
    [sym_string] = STATE(7970),
    [aux_sym_chained_string_repeat1] = STATE(7970),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_then] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [5524] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8693),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_ensure] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [5525] = {
    [sym_heredoc_body] = STATE(7971),
    [aux_sym_call_repeat1] = STATE(7971),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_else] = ACTIONS(1681),
    [anon_sym_ensure] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [5526] = {
    [sym_heredoc_body] = STATE(7971),
    [aux_sym_call_repeat1] = STATE(7971),
    [aux_sym_argument_list_repeat1] = STATE(7972),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(5067),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_else] = ACTIONS(1681),
    [anon_sym_ensure] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [5527] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(8691),
    [sym__binary_star] = ACTIONS(8693),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(8695),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8693),
    [anon_sym_AMP] = ACTIONS(8697),
    [anon_sym_LT] = ACTIONS(8699),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_ensure] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(8701),
    [anon_sym_DOT_DOT] = ACTIONS(8703),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8705),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(8707),
    [anon_sym_AMP_AMP] = ACTIONS(8707),
    [anon_sym_LT_LT] = ACTIONS(8709),
    [anon_sym_GT_GT] = ACTIONS(8709),
    [anon_sym_EQ_EQ] = ACTIONS(8711),
    [anon_sym_BANG_EQ] = ACTIONS(8707),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8707),
    [anon_sym_LT_EQ_GT] = ACTIONS(8707),
    [anon_sym_EQ_TILDE] = ACTIONS(8707),
    [anon_sym_BANG_TILDE] = ACTIONS(8707),
    [anon_sym_LT_EQ] = ACTIONS(8699),
    [anon_sym_GT] = ACTIONS(8699),
    [anon_sym_GT_EQ] = ACTIONS(8713),
    [anon_sym_CARET] = ACTIONS(8715),
    [anon_sym_PLUS] = ACTIONS(8691),
    [anon_sym_SLASH] = ACTIONS(8693),
    [anon_sym_PERCENT] = ACTIONS(8693),
    [sym_comment] = ACTIONS(87),
  },
  [5528] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7973),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2999),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(2999),
    [sym_assignment] = STATE(7973),
    [sym_operator_assignment] = STATE(7973),
    [sym_conditional] = STATE(7973),
    [sym_range] = STATE(7973),
    [sym_binary] = STATE(7973),
    [sym_unary] = STATE(7973),
    [sym_left_assignment_list] = STATE(2998),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2999),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2999),
    [sym_false] = STATE(2999),
    [sym_nil] = STATE(2999),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(3000),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(5001),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5003),
    [anon_sym_yield] = ACTIONS(5005),
    [anon_sym_break] = ACTIONS(5007),
    [anon_sym_next] = ACTIONS(5009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5011),
    [anon_sym_defined_QMARK] = ACTIONS(5013),
    [anon_sym_not] = ACTIONS(5015),
    [anon_sym_BANG] = ACTIONS(5017),
    [anon_sym_TILDE] = ACTIONS(5017),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5529] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7974),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2999),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(2999),
    [sym_assignment] = STATE(7974),
    [sym_operator_assignment] = STATE(7974),
    [sym_conditional] = STATE(7974),
    [sym_range] = STATE(7974),
    [sym_binary] = STATE(7974),
    [sym_unary] = STATE(7974),
    [sym_left_assignment_list] = STATE(2998),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2999),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2999),
    [sym_false] = STATE(2999),
    [sym_nil] = STATE(2999),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(3000),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(5001),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5003),
    [anon_sym_yield] = ACTIONS(5005),
    [anon_sym_break] = ACTIONS(5007),
    [anon_sym_next] = ACTIONS(5009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5011),
    [anon_sym_defined_QMARK] = ACTIONS(5013),
    [anon_sym_not] = ACTIONS(5015),
    [anon_sym_BANG] = ACTIONS(5017),
    [anon_sym_TILDE] = ACTIONS(5017),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5530] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7975),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2999),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(2999),
    [sym_assignment] = STATE(7975),
    [sym_operator_assignment] = STATE(7975),
    [sym_conditional] = STATE(7975),
    [sym_range] = STATE(7975),
    [sym_binary] = STATE(7975),
    [sym_unary] = STATE(7975),
    [sym_left_assignment_list] = STATE(2998),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2999),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2999),
    [sym_false] = STATE(2999),
    [sym_nil] = STATE(2999),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(3000),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(5001),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5003),
    [anon_sym_yield] = ACTIONS(5005),
    [anon_sym_break] = ACTIONS(5007),
    [anon_sym_next] = ACTIONS(5009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5011),
    [anon_sym_defined_QMARK] = ACTIONS(5013),
    [anon_sym_not] = ACTIONS(5015),
    [anon_sym_BANG] = ACTIONS(5017),
    [anon_sym_TILDE] = ACTIONS(5017),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5531] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7976),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2999),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(2999),
    [sym_assignment] = STATE(7976),
    [sym_operator_assignment] = STATE(7976),
    [sym_conditional] = STATE(7976),
    [sym_range] = STATE(7976),
    [sym_binary] = STATE(7976),
    [sym_unary] = STATE(7976),
    [sym_left_assignment_list] = STATE(2998),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2999),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2999),
    [sym_false] = STATE(2999),
    [sym_nil] = STATE(2999),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(3000),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(5001),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5003),
    [anon_sym_yield] = ACTIONS(5005),
    [anon_sym_break] = ACTIONS(5007),
    [anon_sym_next] = ACTIONS(5009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5011),
    [anon_sym_defined_QMARK] = ACTIONS(5013),
    [anon_sym_not] = ACTIONS(5015),
    [anon_sym_BANG] = ACTIONS(5017),
    [anon_sym_TILDE] = ACTIONS(5017),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5532] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7977),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2999),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(2999),
    [sym_assignment] = STATE(7977),
    [sym_operator_assignment] = STATE(7977),
    [sym_conditional] = STATE(7977),
    [sym_range] = STATE(7977),
    [sym_binary] = STATE(7977),
    [sym_unary] = STATE(7977),
    [sym_left_assignment_list] = STATE(2998),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2999),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2999),
    [sym_false] = STATE(2999),
    [sym_nil] = STATE(2999),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(3000),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(5001),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5003),
    [anon_sym_yield] = ACTIONS(5005),
    [anon_sym_break] = ACTIONS(5007),
    [anon_sym_next] = ACTIONS(5009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5011),
    [anon_sym_defined_QMARK] = ACTIONS(5013),
    [anon_sym_not] = ACTIONS(5015),
    [anon_sym_BANG] = ACTIONS(5017),
    [anon_sym_TILDE] = ACTIONS(5017),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5533] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(7978),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(7978),
    [sym_operator_assignment] = STATE(7978),
    [sym_conditional] = STATE(7978),
    [sym_range] = STATE(7978),
    [sym_binary] = STATE(7978),
    [sym_unary] = STATE(7978),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5534] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7979),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2999),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(2999),
    [sym_assignment] = STATE(7979),
    [sym_operator_assignment] = STATE(7979),
    [sym_conditional] = STATE(7979),
    [sym_range] = STATE(7979),
    [sym_binary] = STATE(7979),
    [sym_unary] = STATE(7979),
    [sym_left_assignment_list] = STATE(2998),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2999),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2999),
    [sym_false] = STATE(2999),
    [sym_nil] = STATE(2999),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(3000),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(5001),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5003),
    [anon_sym_yield] = ACTIONS(5005),
    [anon_sym_break] = ACTIONS(5007),
    [anon_sym_next] = ACTIONS(5009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5011),
    [anon_sym_defined_QMARK] = ACTIONS(5013),
    [anon_sym_not] = ACTIONS(5015),
    [anon_sym_BANG] = ACTIONS(5017),
    [anon_sym_TILDE] = ACTIONS(5017),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5535] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7980),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2999),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(2999),
    [sym_assignment] = STATE(7980),
    [sym_operator_assignment] = STATE(7980),
    [sym_conditional] = STATE(7980),
    [sym_range] = STATE(7980),
    [sym_binary] = STATE(7980),
    [sym_unary] = STATE(7980),
    [sym_left_assignment_list] = STATE(2998),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2999),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2999),
    [sym_false] = STATE(2999),
    [sym_nil] = STATE(2999),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(3000),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(5001),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5003),
    [anon_sym_yield] = ACTIONS(5005),
    [anon_sym_break] = ACTIONS(5007),
    [anon_sym_next] = ACTIONS(5009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5011),
    [anon_sym_defined_QMARK] = ACTIONS(5013),
    [anon_sym_not] = ACTIONS(5015),
    [anon_sym_BANG] = ACTIONS(5017),
    [anon_sym_TILDE] = ACTIONS(5017),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5536] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7981),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2999),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(2999),
    [sym_assignment] = STATE(7981),
    [sym_operator_assignment] = STATE(7981),
    [sym_conditional] = STATE(7981),
    [sym_range] = STATE(7981),
    [sym_binary] = STATE(7981),
    [sym_unary] = STATE(7981),
    [sym_left_assignment_list] = STATE(2998),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2999),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2999),
    [sym_false] = STATE(2999),
    [sym_nil] = STATE(2999),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(3000),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(5001),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5003),
    [anon_sym_yield] = ACTIONS(5005),
    [anon_sym_break] = ACTIONS(5007),
    [anon_sym_next] = ACTIONS(5009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5011),
    [anon_sym_defined_QMARK] = ACTIONS(5013),
    [anon_sym_not] = ACTIONS(5015),
    [anon_sym_BANG] = ACTIONS(5017),
    [anon_sym_TILDE] = ACTIONS(5017),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5537] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7982),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2999),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(2999),
    [sym_assignment] = STATE(7982),
    [sym_operator_assignment] = STATE(7982),
    [sym_conditional] = STATE(7982),
    [sym_range] = STATE(7982),
    [sym_binary] = STATE(7982),
    [sym_unary] = STATE(7982),
    [sym_left_assignment_list] = STATE(2998),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2999),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2999),
    [sym_false] = STATE(2999),
    [sym_nil] = STATE(2999),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(3000),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(5001),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5003),
    [anon_sym_yield] = ACTIONS(5005),
    [anon_sym_break] = ACTIONS(5007),
    [anon_sym_next] = ACTIONS(5009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5011),
    [anon_sym_defined_QMARK] = ACTIONS(5013),
    [anon_sym_not] = ACTIONS(5015),
    [anon_sym_BANG] = ACTIONS(5017),
    [anon_sym_TILDE] = ACTIONS(5017),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5538] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7983),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2999),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(2999),
    [sym_splat_argument] = STATE(7984),
    [sym_assignment] = STATE(7983),
    [sym_operator_assignment] = STATE(7983),
    [sym_conditional] = STATE(7983),
    [sym_range] = STATE(7983),
    [sym_binary] = STATE(7983),
    [sym_unary] = STATE(7983),
    [sym_right_assignment_list] = STATE(2570),
    [sym__arg_or_splat_arg] = STATE(7984),
    [sym_left_assignment_list] = STATE(2998),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2999),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2999),
    [sym_false] = STATE(2999),
    [sym_nil] = STATE(2999),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(3000),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(2049),
    [sym__unary_minus] = ACTIONS(5001),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5003),
    [anon_sym_yield] = ACTIONS(5005),
    [anon_sym_break] = ACTIONS(5007),
    [anon_sym_next] = ACTIONS(5009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5011),
    [anon_sym_defined_QMARK] = ACTIONS(5013),
    [anon_sym_not] = ACTIONS(5015),
    [anon_sym_BANG] = ACTIONS(5017),
    [anon_sym_TILDE] = ACTIONS(5017),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5539] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7985),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2999),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(2999),
    [sym_assignment] = STATE(7985),
    [sym_operator_assignment] = STATE(7985),
    [sym_conditional] = STATE(7985),
    [sym_range] = STATE(7985),
    [sym_binary] = STATE(7985),
    [sym_unary] = STATE(7985),
    [sym_left_assignment_list] = STATE(2998),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2999),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2999),
    [sym_false] = STATE(2999),
    [sym_nil] = STATE(2999),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(3000),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(5001),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5003),
    [anon_sym_yield] = ACTIONS(5005),
    [anon_sym_break] = ACTIONS(5007),
    [anon_sym_next] = ACTIONS(5009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5011),
    [anon_sym_defined_QMARK] = ACTIONS(5013),
    [anon_sym_not] = ACTIONS(5015),
    [anon_sym_BANG] = ACTIONS(5017),
    [anon_sym_TILDE] = ACTIONS(5017),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5540] = {
    [sym_string] = STATE(7986),
    [aux_sym_chained_string_repeat1] = STATE(7986),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_end] = ACTIONS(2753),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_else] = ACTIONS(2753),
    [anon_sym_ensure] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [5541] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(8691),
    [sym__binary_star] = ACTIONS(8693),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(8695),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(8693),
    [anon_sym_AMP] = ACTIONS(8697),
    [anon_sym_LT] = ACTIONS(8699),
    [anon_sym_end] = ACTIONS(6823),
    [anon_sym_if] = ACTIONS(6823),
    [anon_sym_unless] = ACTIONS(6823),
    [anon_sym_while] = ACTIONS(6823),
    [anon_sym_until] = ACTIONS(6823),
    [anon_sym_rescue] = ACTIONS(6823),
    [anon_sym_else] = ACTIONS(6823),
    [anon_sym_ensure] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(8701),
    [anon_sym_DOT_DOT] = ACTIONS(8703),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8705),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(8707),
    [anon_sym_AMP_AMP] = ACTIONS(8707),
    [anon_sym_LT_LT] = ACTIONS(8709),
    [anon_sym_GT_GT] = ACTIONS(8709),
    [anon_sym_EQ_EQ] = ACTIONS(8711),
    [anon_sym_BANG_EQ] = ACTIONS(8707),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8707),
    [anon_sym_LT_EQ_GT] = ACTIONS(8707),
    [anon_sym_EQ_TILDE] = ACTIONS(8707),
    [anon_sym_BANG_TILDE] = ACTIONS(8707),
    [anon_sym_LT_EQ] = ACTIONS(8699),
    [anon_sym_GT] = ACTIONS(8699),
    [anon_sym_GT_EQ] = ACTIONS(8713),
    [anon_sym_CARET] = ACTIONS(8715),
    [anon_sym_PLUS] = ACTIONS(8691),
    [anon_sym_SLASH] = ACTIONS(8693),
    [anon_sym_PERCENT] = ACTIONS(8693),
    [sym_comment] = ACTIONS(87),
  },
  [5542] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(5033),
    [sym__binary_star] = ACTIONS(5035),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(5037),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(5035),
    [anon_sym_AMP] = ACTIONS(5039),
    [anon_sym_LT] = ACTIONS(5041),
    [anon_sym_end] = ACTIONS(4211),
    [anon_sym_if] = ACTIONS(4211),
    [anon_sym_unless] = ACTIONS(4211),
    [anon_sym_while] = ACTIONS(4211),
    [anon_sym_until] = ACTIONS(4211),
    [anon_sym_rescue] = ACTIONS(4211),
    [anon_sym_else] = ACTIONS(4211),
    [anon_sym_ensure] = ACTIONS(4211),
    [anon_sym_EQ_GT] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(5043),
    [anon_sym_DOT_DOT] = ACTIONS(5045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5047),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(5049),
    [anon_sym_AMP_AMP] = ACTIONS(5049),
    [anon_sym_LT_LT] = ACTIONS(5051),
    [anon_sym_GT_GT] = ACTIONS(5051),
    [anon_sym_EQ_EQ] = ACTIONS(5053),
    [anon_sym_BANG_EQ] = ACTIONS(5049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5049),
    [anon_sym_LT_EQ_GT] = ACTIONS(5049),
    [anon_sym_EQ_TILDE] = ACTIONS(5049),
    [anon_sym_BANG_TILDE] = ACTIONS(5049),
    [anon_sym_LT_EQ] = ACTIONS(5041),
    [anon_sym_GT] = ACTIONS(5041),
    [anon_sym_GT_EQ] = ACTIONS(5055),
    [anon_sym_CARET] = ACTIONS(5057),
    [anon_sym_PLUS] = ACTIONS(5033),
    [anon_sym_SLASH] = ACTIONS(5035),
    [anon_sym_PERCENT] = ACTIONS(5035),
    [sym_comment] = ACTIONS(87),
  },
  [5543] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(5033),
    [sym__binary_star] = ACTIONS(5035),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(5037),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(5035),
    [anon_sym_AMP] = ACTIONS(5039),
    [anon_sym_LT] = ACTIONS(5041),
    [anon_sym_end] = ACTIONS(4247),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_else] = ACTIONS(4247),
    [anon_sym_ensure] = ACTIONS(4247),
    [anon_sym_EQ_GT] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(5043),
    [anon_sym_DOT_DOT] = ACTIONS(5045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5047),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(5049),
    [anon_sym_AMP_AMP] = ACTIONS(5049),
    [anon_sym_LT_LT] = ACTIONS(5051),
    [anon_sym_GT_GT] = ACTIONS(5051),
    [anon_sym_EQ_EQ] = ACTIONS(5053),
    [anon_sym_BANG_EQ] = ACTIONS(5049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5049),
    [anon_sym_LT_EQ_GT] = ACTIONS(5049),
    [anon_sym_EQ_TILDE] = ACTIONS(5049),
    [anon_sym_BANG_TILDE] = ACTIONS(5049),
    [anon_sym_LT_EQ] = ACTIONS(5041),
    [anon_sym_GT] = ACTIONS(5041),
    [anon_sym_GT_EQ] = ACTIONS(5055),
    [anon_sym_CARET] = ACTIONS(5057),
    [anon_sym_PLUS] = ACTIONS(5033),
    [anon_sym_SLASH] = ACTIONS(5035),
    [anon_sym_PERCENT] = ACTIONS(5035),
    [sym_comment] = ACTIONS(87),
  },
  [5544] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7987),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1156),
    [sym_scope_resolution] = STATE(1152),
    [sym_call] = STATE(1152),
    [sym_method_call] = STATE(1156),
    [sym_assignment] = STATE(7987),
    [sym_operator_assignment] = STATE(7987),
    [sym_conditional] = STATE(7987),
    [sym_range] = STATE(7987),
    [sym_binary] = STATE(7987),
    [sym_unary] = STATE(7987),
    [sym_left_assignment_list] = STATE(1155),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1156),
    [sym__variable] = STATE(1152),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1156),
    [sym_false] = STATE(1156),
    [sym_nil] = STATE(1156),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3003),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2051),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2055),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2059),
    [anon_sym_next] = ACTIONS(2061),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5019),
    [anon_sym_defined_QMARK] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [anon_sym_BANG] = ACTIONS(2069),
    [anon_sym_TILDE] = ACTIONS(2069),
    [sym_constant] = ACTIONS(2075),
    [sym_identifier] = ACTIONS(2075),
    [sym_instance_variable] = ACTIONS(2073),
    [sym_class_variable] = ACTIONS(2073),
    [sym_global_variable] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2075),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5545] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(5033),
    [sym__binary_star] = ACTIONS(5035),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(5037),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(5035),
    [anon_sym_AMP] = ACTIONS(5039),
    [anon_sym_LT] = ACTIONS(5041),
    [anon_sym_end] = ACTIONS(3281),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_unless] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_until] = ACTIONS(3281),
    [anon_sym_rescue] = ACTIONS(3281),
    [anon_sym_else] = ACTIONS(3281),
    [anon_sym_ensure] = ACTIONS(3281),
    [anon_sym_EQ_GT] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(5043),
    [anon_sym_DOT_DOT] = ACTIONS(5045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5047),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(5049),
    [anon_sym_AMP_AMP] = ACTIONS(5049),
    [anon_sym_LT_LT] = ACTIONS(5051),
    [anon_sym_GT_GT] = ACTIONS(5051),
    [anon_sym_EQ_EQ] = ACTIONS(5053),
    [anon_sym_BANG_EQ] = ACTIONS(5049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5049),
    [anon_sym_LT_EQ_GT] = ACTIONS(5049),
    [anon_sym_EQ_TILDE] = ACTIONS(5049),
    [anon_sym_BANG_TILDE] = ACTIONS(5049),
    [anon_sym_LT_EQ] = ACTIONS(5041),
    [anon_sym_GT] = ACTIONS(5041),
    [anon_sym_GT_EQ] = ACTIONS(5055),
    [anon_sym_CARET] = ACTIONS(5057),
    [anon_sym_PLUS] = ACTIONS(5033),
    [anon_sym_SLASH] = ACTIONS(5035),
    [anon_sym_PERCENT] = ACTIONS(5035),
    [sym_comment] = ACTIONS(87),
  },
  [5546] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7988),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1156),
    [sym_scope_resolution] = STATE(1152),
    [sym_call] = STATE(1152),
    [sym_method_call] = STATE(1156),
    [sym_assignment] = STATE(7988),
    [sym_operator_assignment] = STATE(7988),
    [sym_conditional] = STATE(7988),
    [sym_range] = STATE(7988),
    [sym_binary] = STATE(7988),
    [sym_unary] = STATE(7988),
    [sym_left_assignment_list] = STATE(1155),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1156),
    [sym__variable] = STATE(1152),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1156),
    [sym_false] = STATE(1156),
    [sym_nil] = STATE(1156),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3003),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2051),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2055),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2059),
    [anon_sym_next] = ACTIONS(2061),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5019),
    [anon_sym_defined_QMARK] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [anon_sym_BANG] = ACTIONS(2069),
    [anon_sym_TILDE] = ACTIONS(2069),
    [sym_constant] = ACTIONS(2075),
    [sym_identifier] = ACTIONS(2075),
    [sym_instance_variable] = ACTIONS(2073),
    [sym_class_variable] = ACTIONS(2073),
    [sym_global_variable] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2075),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5547] = {
    [sym_heredoc_body] = STATE(7989),
    [aux_sym_call_repeat1] = STATE(7989),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_else] = ACTIONS(4383),
    [anon_sym_ensure] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [5548] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3011),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1156),
    [sym_scope_resolution] = STATE(1152),
    [sym_call] = STATE(1152),
    [sym_method_call] = STATE(1156),
    [sym__argument] = STATE(2565),
    [sym_splat_argument] = STATE(2565),
    [sym_hash_splat_argument] = STATE(2565),
    [sym_block_argument] = STATE(2565),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_left_assignment_list] = STATE(1155),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1156),
    [sym__variable] = STATE(1152),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1156),
    [sym_false] = STATE(1156),
    [sym_nil] = STATE(1156),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3014),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(7990),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2565),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(5023),
    [sym__splat_star] = ACTIONS(5025),
    [sym__unary_minus] = ACTIONS(2051),
    [sym__identifier_hash_key] = ACTIONS(5027),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11492),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2055),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2059),
    [anon_sym_next] = ACTIONS(2061),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5019),
    [anon_sym_defined_QMARK] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [anon_sym_BANG] = ACTIONS(2069),
    [anon_sym_TILDE] = ACTIONS(2069),
    [sym_constant] = ACTIONS(5029),
    [sym_identifier] = ACTIONS(5029),
    [sym_instance_variable] = ACTIONS(2073),
    [sym_class_variable] = ACTIONS(2073),
    [sym_global_variable] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2075),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5549] = {
    [sym_heredoc_body] = STATE(7991),
    [aux_sym_call_repeat1] = STATE(7991),
    [aux_sym_argument_list_repeat1] = STATE(7992),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(8727),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_else] = ACTIONS(4383),
    [anon_sym_ensure] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [5550] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(8691),
    [sym__binary_star] = ACTIONS(8693),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(8695),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(8693),
    [anon_sym_AMP] = ACTIONS(8697),
    [anon_sym_LT] = ACTIONS(8699),
    [anon_sym_end] = ACTIONS(7027),
    [anon_sym_if] = ACTIONS(7027),
    [anon_sym_unless] = ACTIONS(7027),
    [anon_sym_while] = ACTIONS(7027),
    [anon_sym_until] = ACTIONS(7027),
    [anon_sym_rescue] = ACTIONS(7027),
    [anon_sym_else] = ACTIONS(7027),
    [anon_sym_ensure] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(8701),
    [anon_sym_DOT_DOT] = ACTIONS(8703),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8705),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(8707),
    [anon_sym_AMP_AMP] = ACTIONS(8707),
    [anon_sym_LT_LT] = ACTIONS(8709),
    [anon_sym_GT_GT] = ACTIONS(8709),
    [anon_sym_EQ_EQ] = ACTIONS(8711),
    [anon_sym_BANG_EQ] = ACTIONS(8707),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8707),
    [anon_sym_LT_EQ_GT] = ACTIONS(8707),
    [anon_sym_EQ_TILDE] = ACTIONS(8707),
    [anon_sym_BANG_TILDE] = ACTIONS(8707),
    [anon_sym_LT_EQ] = ACTIONS(8699),
    [anon_sym_GT] = ACTIONS(8699),
    [anon_sym_GT_EQ] = ACTIONS(8713),
    [anon_sym_CARET] = ACTIONS(8715),
    [anon_sym_PLUS] = ACTIONS(8691),
    [anon_sym_SLASH] = ACTIONS(8693),
    [anon_sym_PERCENT] = ACTIONS(8693),
    [sym_comment] = ACTIONS(87),
  },
  [5551] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5035),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(5035),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5035),
    [anon_sym_PERCENT] = ACTIONS(5035),
    [sym_comment] = ACTIONS(87),
  },
  [5552] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(5035),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [5553] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5033),
    [sym__binary_star] = ACTIONS(5035),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(5035),
    [anon_sym_AMP] = ACTIONS(5039),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5051),
    [anon_sym_GT_GT] = ACTIONS(5051),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5033),
    [anon_sym_SLASH] = ACTIONS(5035),
    [anon_sym_PERCENT] = ACTIONS(5035),
    [sym_comment] = ACTIONS(87),
  },
  [5554] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5033),
    [sym__binary_star] = ACTIONS(5035),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(5035),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5051),
    [anon_sym_GT_GT] = ACTIONS(5051),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5033),
    [anon_sym_SLASH] = ACTIONS(5035),
    [anon_sym_PERCENT] = ACTIONS(5035),
    [sym_comment] = ACTIONS(87),
  },
  [5555] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5033),
    [sym__binary_star] = ACTIONS(5035),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5037),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(5035),
    [anon_sym_AMP] = ACTIONS(5039),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5051),
    [anon_sym_GT_GT] = ACTIONS(5051),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5057),
    [anon_sym_PLUS] = ACTIONS(5033),
    [anon_sym_SLASH] = ACTIONS(5035),
    [anon_sym_PERCENT] = ACTIONS(5035),
    [sym_comment] = ACTIONS(87),
  },
  [5556] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(11494),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [5557] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(5033),
    [sym__binary_star] = ACTIONS(5035),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(5037),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(5035),
    [anon_sym_AMP] = ACTIONS(5039),
    [anon_sym_LT] = ACTIONS(5041),
    [anon_sym_end] = ACTIONS(5927),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_else] = ACTIONS(5927),
    [anon_sym_ensure] = ACTIONS(5927),
    [anon_sym_EQ_GT] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(5045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5047),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(5049),
    [anon_sym_AMP_AMP] = ACTIONS(5049),
    [anon_sym_LT_LT] = ACTIONS(5051),
    [anon_sym_GT_GT] = ACTIONS(5051),
    [anon_sym_EQ_EQ] = ACTIONS(5053),
    [anon_sym_BANG_EQ] = ACTIONS(5049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5049),
    [anon_sym_LT_EQ_GT] = ACTIONS(5049),
    [anon_sym_EQ_TILDE] = ACTIONS(5049),
    [anon_sym_BANG_TILDE] = ACTIONS(5049),
    [anon_sym_LT_EQ] = ACTIONS(5041),
    [anon_sym_GT] = ACTIONS(5041),
    [anon_sym_GT_EQ] = ACTIONS(5055),
    [anon_sym_CARET] = ACTIONS(5057),
    [anon_sym_PLUS] = ACTIONS(5033),
    [anon_sym_SLASH] = ACTIONS(5035),
    [anon_sym_PERCENT] = ACTIONS(5035),
    [sym_comment] = ACTIONS(87),
  },
  [5558] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5033),
    [sym__binary_star] = ACTIONS(5035),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5037),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(5035),
    [anon_sym_AMP] = ACTIONS(5039),
    [anon_sym_LT] = ACTIONS(5041),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5043),
    [anon_sym_DOT_DOT] = ACTIONS(5045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5047),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5049),
    [anon_sym_AMP_AMP] = ACTIONS(5049),
    [anon_sym_LT_LT] = ACTIONS(5051),
    [anon_sym_GT_GT] = ACTIONS(5051),
    [anon_sym_EQ_EQ] = ACTIONS(5053),
    [anon_sym_BANG_EQ] = ACTIONS(5049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5049),
    [anon_sym_LT_EQ_GT] = ACTIONS(5049),
    [anon_sym_EQ_TILDE] = ACTIONS(5049),
    [anon_sym_BANG_TILDE] = ACTIONS(5049),
    [anon_sym_LT_EQ] = ACTIONS(5041),
    [anon_sym_GT] = ACTIONS(5041),
    [anon_sym_GT_EQ] = ACTIONS(5055),
    [anon_sym_CARET] = ACTIONS(5057),
    [anon_sym_PLUS] = ACTIONS(5033),
    [anon_sym_SLASH] = ACTIONS(5035),
    [anon_sym_PERCENT] = ACTIONS(5035),
    [sym_comment] = ACTIONS(87),
  },
  [5559] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5033),
    [sym__binary_star] = ACTIONS(5035),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5037),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(5035),
    [anon_sym_AMP] = ACTIONS(5039),
    [anon_sym_LT] = ACTIONS(5041),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5051),
    [anon_sym_GT_GT] = ACTIONS(5051),
    [anon_sym_EQ_EQ] = ACTIONS(5053),
    [anon_sym_BANG_EQ] = ACTIONS(5049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5049),
    [anon_sym_LT_EQ_GT] = ACTIONS(5049),
    [anon_sym_EQ_TILDE] = ACTIONS(5049),
    [anon_sym_BANG_TILDE] = ACTIONS(5049),
    [anon_sym_LT_EQ] = ACTIONS(5041),
    [anon_sym_GT] = ACTIONS(5041),
    [anon_sym_GT_EQ] = ACTIONS(5055),
    [anon_sym_CARET] = ACTIONS(5057),
    [anon_sym_PLUS] = ACTIONS(5033),
    [anon_sym_SLASH] = ACTIONS(5035),
    [anon_sym_PERCENT] = ACTIONS(5035),
    [sym_comment] = ACTIONS(87),
  },
  [5560] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5033),
    [sym__binary_star] = ACTIONS(5035),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(5035),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5033),
    [anon_sym_SLASH] = ACTIONS(5035),
    [anon_sym_PERCENT] = ACTIONS(5035),
    [sym_comment] = ACTIONS(87),
  },
  [5561] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(5441),
    [sym__binary_star] = ACTIONS(5443),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(5445),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(5447),
    [anon_sym_AMP] = ACTIONS(5449),
    [anon_sym_EQ] = ACTIONS(4217),
    [anon_sym_LT] = ACTIONS(5451),
    [anon_sym_end] = ACTIONS(4211),
    [anon_sym_if] = ACTIONS(4211),
    [anon_sym_unless] = ACTIONS(4211),
    [anon_sym_while] = ACTIONS(4211),
    [anon_sym_until] = ACTIONS(4211),
    [anon_sym_rescue] = ACTIONS(4211),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_else] = ACTIONS(4211),
    [anon_sym_ensure] = ACTIONS(4211),
    [anon_sym_EQ_GT] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_PLUS_EQ] = ACTIONS(4211),
    [anon_sym_DASH_EQ] = ACTIONS(4211),
    [anon_sym_STAR_EQ] = ACTIONS(4211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4211),
    [anon_sym_SLASH_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4211),
    [anon_sym_AMP_EQ] = ACTIONS(4211),
    [anon_sym_PERCENT_EQ] = ACTIONS(4211),
    [anon_sym_GT_GT_EQ] = ACTIONS(4211),
    [anon_sym_LT_LT_EQ] = ACTIONS(4211),
    [anon_sym_CARET_EQ] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(5453),
    [anon_sym_DOT_DOT] = ACTIONS(5455),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5457),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(5459),
    [anon_sym_AMP_AMP] = ACTIONS(5459),
    [anon_sym_LT_LT] = ACTIONS(5461),
    [anon_sym_GT_GT] = ACTIONS(5461),
    [anon_sym_EQ_EQ] = ACTIONS(5459),
    [anon_sym_BANG_EQ] = ACTIONS(5463),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5463),
    [anon_sym_LT_EQ_GT] = ACTIONS(5463),
    [anon_sym_EQ_TILDE] = ACTIONS(5463),
    [anon_sym_BANG_TILDE] = ACTIONS(5463),
    [anon_sym_LT_EQ] = ACTIONS(5451),
    [anon_sym_GT] = ACTIONS(5451),
    [anon_sym_GT_EQ] = ACTIONS(5465),
    [anon_sym_CARET] = ACTIONS(5445),
    [anon_sym_PLUS] = ACTIONS(5467),
    [anon_sym_SLASH] = ACTIONS(5447),
    [anon_sym_PERCENT] = ACTIONS(5447),
    [sym_comment] = ACTIONS(87),
  },
  [5562] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(5441),
    [sym__binary_star] = ACTIONS(5443),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(5445),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(5447),
    [anon_sym_AMP] = ACTIONS(5449),
    [anon_sym_EQ] = ACTIONS(4249),
    [anon_sym_LT] = ACTIONS(5451),
    [anon_sym_end] = ACTIONS(4247),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_else] = ACTIONS(4247),
    [anon_sym_ensure] = ACTIONS(4247),
    [anon_sym_EQ_GT] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_PLUS_EQ] = ACTIONS(4247),
    [anon_sym_DASH_EQ] = ACTIONS(4247),
    [anon_sym_STAR_EQ] = ACTIONS(4247),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4247),
    [anon_sym_SLASH_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4247),
    [anon_sym_AMP_EQ] = ACTIONS(4247),
    [anon_sym_PERCENT_EQ] = ACTIONS(4247),
    [anon_sym_GT_GT_EQ] = ACTIONS(4247),
    [anon_sym_LT_LT_EQ] = ACTIONS(4247),
    [anon_sym_CARET_EQ] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(5453),
    [anon_sym_DOT_DOT] = ACTIONS(5455),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5457),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(5459),
    [anon_sym_AMP_AMP] = ACTIONS(5459),
    [anon_sym_LT_LT] = ACTIONS(5461),
    [anon_sym_GT_GT] = ACTIONS(5461),
    [anon_sym_EQ_EQ] = ACTIONS(5459),
    [anon_sym_BANG_EQ] = ACTIONS(5463),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5463),
    [anon_sym_LT_EQ_GT] = ACTIONS(5463),
    [anon_sym_EQ_TILDE] = ACTIONS(5463),
    [anon_sym_BANG_TILDE] = ACTIONS(5463),
    [anon_sym_LT_EQ] = ACTIONS(5451),
    [anon_sym_GT] = ACTIONS(5451),
    [anon_sym_GT_EQ] = ACTIONS(5465),
    [anon_sym_CARET] = ACTIONS(5445),
    [anon_sym_PLUS] = ACTIONS(5467),
    [anon_sym_SLASH] = ACTIONS(5447),
    [anon_sym_PERCENT] = ACTIONS(5447),
    [sym_comment] = ACTIONS(87),
  },
  [5563] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(7994),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1249),
    [sym_scope_resolution] = STATE(1245),
    [sym_call] = STATE(1245),
    [sym_method_call] = STATE(1249),
    [sym_assignment] = STATE(7994),
    [sym_operator_assignment] = STATE(7994),
    [sym_conditional] = STATE(7994),
    [sym_range] = STATE(7994),
    [sym_binary] = STATE(7994),
    [sym_unary] = STATE(7994),
    [sym_left_assignment_list] = STATE(1248),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(1245),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1249),
    [sym_false] = STATE(1249),
    [sym_nil] = STATE(1249),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3260),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2223),
    [anon_sym_break] = ACTIONS(2225),
    [anon_sym_next] = ACTIONS(2227),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(5435),
    [anon_sym_defined_QMARK] = ACTIONS(2229),
    [anon_sym_not] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(2235),
    [anon_sym_TILDE] = ACTIONS(2235),
    [sym_constant] = ACTIONS(2241),
    [sym_identifier] = ACTIONS(2241),
    [sym_instance_variable] = ACTIONS(2239),
    [sym_class_variable] = ACTIONS(2239),
    [sym_global_variable] = ACTIONS(2239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(2241),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2241),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5564] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(5441),
    [sym__binary_star] = ACTIONS(5443),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(5445),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(5447),
    [anon_sym_AMP] = ACTIONS(5449),
    [anon_sym_EQ] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(5451),
    [anon_sym_end] = ACTIONS(3281),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_unless] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_until] = ACTIONS(3281),
    [anon_sym_rescue] = ACTIONS(3281),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_else] = ACTIONS(3281),
    [anon_sym_ensure] = ACTIONS(3281),
    [anon_sym_EQ_GT] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_PLUS_EQ] = ACTIONS(3281),
    [anon_sym_DASH_EQ] = ACTIONS(3281),
    [anon_sym_STAR_EQ] = ACTIONS(3281),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3281),
    [anon_sym_SLASH_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3281),
    [anon_sym_AMP_EQ] = ACTIONS(3281),
    [anon_sym_PERCENT_EQ] = ACTIONS(3281),
    [anon_sym_GT_GT_EQ] = ACTIONS(3281),
    [anon_sym_LT_LT_EQ] = ACTIONS(3281),
    [anon_sym_CARET_EQ] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(5453),
    [anon_sym_DOT_DOT] = ACTIONS(5455),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5457),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(5459),
    [anon_sym_AMP_AMP] = ACTIONS(5459),
    [anon_sym_LT_LT] = ACTIONS(5461),
    [anon_sym_GT_GT] = ACTIONS(5461),
    [anon_sym_EQ_EQ] = ACTIONS(5459),
    [anon_sym_BANG_EQ] = ACTIONS(5463),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5463),
    [anon_sym_LT_EQ_GT] = ACTIONS(5463),
    [anon_sym_EQ_TILDE] = ACTIONS(5463),
    [anon_sym_BANG_TILDE] = ACTIONS(5463),
    [anon_sym_LT_EQ] = ACTIONS(5451),
    [anon_sym_GT] = ACTIONS(5451),
    [anon_sym_GT_EQ] = ACTIONS(5465),
    [anon_sym_CARET] = ACTIONS(5445),
    [anon_sym_PLUS] = ACTIONS(5467),
    [anon_sym_SLASH] = ACTIONS(5447),
    [anon_sym_PERCENT] = ACTIONS(5447),
    [sym_comment] = ACTIONS(87),
  },
  [5565] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(7995),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1249),
    [sym_scope_resolution] = STATE(1245),
    [sym_call] = STATE(1245),
    [sym_method_call] = STATE(1249),
    [sym_assignment] = STATE(7995),
    [sym_operator_assignment] = STATE(7995),
    [sym_conditional] = STATE(7995),
    [sym_range] = STATE(7995),
    [sym_binary] = STATE(7995),
    [sym_unary] = STATE(7995),
    [sym_left_assignment_list] = STATE(1248),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(1245),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1249),
    [sym_false] = STATE(1249),
    [sym_nil] = STATE(1249),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3260),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2223),
    [anon_sym_break] = ACTIONS(2225),
    [anon_sym_next] = ACTIONS(2227),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(5435),
    [anon_sym_defined_QMARK] = ACTIONS(2229),
    [anon_sym_not] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(2235),
    [anon_sym_TILDE] = ACTIONS(2235),
    [sym_constant] = ACTIONS(2241),
    [sym_identifier] = ACTIONS(2241),
    [sym_instance_variable] = ACTIONS(2239),
    [sym_class_variable] = ACTIONS(2239),
    [sym_global_variable] = ACTIONS(2239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(2241),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2241),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5566] = {
    [sym_heredoc_body] = STATE(7996),
    [aux_sym_call_repeat1] = STATE(7996),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_else] = ACTIONS(4383),
    [anon_sym_ensure] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [5567] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3032),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1249),
    [sym_scope_resolution] = STATE(1245),
    [sym_call] = STATE(1245),
    [sym_method_call] = STATE(1249),
    [sym__argument] = STATE(4979),
    [sym_splat_argument] = STATE(4979),
    [sym_hash_splat_argument] = STATE(4979),
    [sym_block_argument] = STATE(4979),
    [sym_assignment] = STATE(3032),
    [sym_operator_assignment] = STATE(3032),
    [sym_conditional] = STATE(3032),
    [sym_range] = STATE(3032),
    [sym_binary] = STATE(3032),
    [sym_unary] = STATE(3032),
    [sym_left_assignment_list] = STATE(1248),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(1245),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1249),
    [sym_false] = STATE(1249),
    [sym_nil] = STATE(1249),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3035),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_heredoc_body] = STATE(7997),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(4979),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(5059),
    [sym__splat_star] = ACTIONS(5061),
    [sym__unary_minus] = ACTIONS(2217),
    [sym__identifier_hash_key] = ACTIONS(5063),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11496),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2223),
    [anon_sym_break] = ACTIONS(2225),
    [anon_sym_next] = ACTIONS(2227),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(5435),
    [anon_sym_defined_QMARK] = ACTIONS(2229),
    [anon_sym_not] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(2235),
    [anon_sym_TILDE] = ACTIONS(2235),
    [sym_constant] = ACTIONS(5065),
    [sym_identifier] = ACTIONS(5065),
    [sym_instance_variable] = ACTIONS(2239),
    [sym_class_variable] = ACTIONS(2239),
    [sym_global_variable] = ACTIONS(2239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(2241),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2241),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5568] = {
    [sym_heredoc_body] = STATE(7998),
    [aux_sym_call_repeat1] = STATE(7998),
    [aux_sym_argument_list_repeat1] = STATE(7999),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(8735),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_else] = ACTIONS(4383),
    [anon_sym_ensure] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [5569] = {
    [sym_heredoc_body] = STATE(5569),
    [aux_sym_call_repeat1] = STATE(5569),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(7916),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_end] = ACTIONS(7914),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_else] = ACTIONS(7914),
    [anon_sym_ensure] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [5570] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1151),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1156),
    [sym_scope_resolution] = STATE(1152),
    [sym_call] = STATE(1152),
    [sym_method_call] = STATE(1156),
    [sym__argument] = STATE(4986),
    [sym_splat_argument] = STATE(4986),
    [sym_hash_splat_argument] = STATE(4986),
    [sym_block_argument] = STATE(4986),
    [sym_assignment] = STATE(1151),
    [sym_operator_assignment] = STATE(1151),
    [sym_conditional] = STATE(1151),
    [sym_range] = STATE(1151),
    [sym_binary] = STATE(1151),
    [sym_unary] = STATE(1151),
    [sym_left_assignment_list] = STATE(1155),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1156),
    [sym__variable] = STATE(1152),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1156),
    [sym_false] = STATE(1156),
    [sym_nil] = STATE(1156),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1157),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4986),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(2047),
    [sym__splat_star] = ACTIONS(2049),
    [sym__unary_minus] = ACTIONS(2051),
    [sym__identifier_hash_key] = ACTIONS(2053),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(8739),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2055),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2059),
    [anon_sym_next] = ACTIONS(2061),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5019),
    [anon_sym_defined_QMARK] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [anon_sym_BANG] = ACTIONS(2069),
    [anon_sym_TILDE] = ACTIONS(2069),
    [sym_constant] = ACTIONS(2071),
    [sym_identifier] = ACTIONS(2071),
    [sym_instance_variable] = ACTIONS(2073),
    [sym_class_variable] = ACTIONS(2073),
    [sym_global_variable] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2075),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5571] = {
    [sym_heredoc_body] = STATE(5569),
    [aux_sym_call_repeat1] = STATE(5569),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_end] = ACTIONS(7929),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_else] = ACTIONS(7929),
    [anon_sym_ensure] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [5572] = {
    [aux_sym_argument_list_repeat1] = STATE(5572),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(11498),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7925),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_end] = ACTIONS(7925),
    [anon_sym_if] = ACTIONS(7925),
    [anon_sym_unless] = ACTIONS(7925),
    [anon_sym_while] = ACTIONS(7925),
    [anon_sym_until] = ACTIONS(7925),
    [anon_sym_rescue] = ACTIONS(7925),
    [anon_sym_else] = ACTIONS(7925),
    [anon_sym_ensure] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7925),
    [anon_sym_AMP_AMP] = ACTIONS(7925),
    [anon_sym_LT_LT] = ACTIONS(7925),
    [anon_sym_GT_GT] = ACTIONS(7925),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7925),
    [anon_sym_PLUS] = ACTIONS(7925),
    [anon_sym_SLASH] = ACTIONS(7925),
    [anon_sym_PERCENT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [5573] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(5033),
    [sym__binary_star] = ACTIONS(5035),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(5037),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(5035),
    [anon_sym_AMP] = ACTIONS(5039),
    [anon_sym_LT] = ACTIONS(5041),
    [anon_sym_end] = ACTIONS(5115),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_else] = ACTIONS(5115),
    [anon_sym_ensure] = ACTIONS(5115),
    [anon_sym_EQ_GT] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(5043),
    [anon_sym_DOT_DOT] = ACTIONS(5045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5047),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(5049),
    [anon_sym_AMP_AMP] = ACTIONS(5049),
    [anon_sym_LT_LT] = ACTIONS(5051),
    [anon_sym_GT_GT] = ACTIONS(5051),
    [anon_sym_EQ_EQ] = ACTIONS(5053),
    [anon_sym_BANG_EQ] = ACTIONS(5049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5049),
    [anon_sym_LT_EQ_GT] = ACTIONS(5049),
    [anon_sym_EQ_TILDE] = ACTIONS(5049),
    [anon_sym_BANG_TILDE] = ACTIONS(5049),
    [anon_sym_LT_EQ] = ACTIONS(5041),
    [anon_sym_GT] = ACTIONS(5041),
    [anon_sym_GT_EQ] = ACTIONS(5055),
    [anon_sym_CARET] = ACTIONS(5057),
    [anon_sym_PLUS] = ACTIONS(5033),
    [anon_sym_SLASH] = ACTIONS(5035),
    [anon_sym_PERCENT] = ACTIONS(5035),
    [sym_comment] = ACTIONS(87),
  },
  [5574] = {
    [aux_sym_exceptions_repeat1] = STATE(8001),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_end] = ACTIONS(6191),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_else] = ACTIONS(6191),
    [anon_sym_ensure] = ACTIONS(6191),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [5575] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(5033),
    [sym__binary_star] = ACTIONS(5035),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(5037),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(5035),
    [anon_sym_AMP] = ACTIONS(5039),
    [anon_sym_LT] = ACTIONS(5041),
    [anon_sym_end] = ACTIONS(6210),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_else] = ACTIONS(6210),
    [anon_sym_ensure] = ACTIONS(6210),
    [anon_sym_EQ_GT] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(5043),
    [anon_sym_DOT_DOT] = ACTIONS(5045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5047),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(5049),
    [anon_sym_AMP_AMP] = ACTIONS(5049),
    [anon_sym_LT_LT] = ACTIONS(5051),
    [anon_sym_GT_GT] = ACTIONS(5051),
    [anon_sym_EQ_EQ] = ACTIONS(5053),
    [anon_sym_BANG_EQ] = ACTIONS(5049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5049),
    [anon_sym_LT_EQ_GT] = ACTIONS(5049),
    [anon_sym_EQ_TILDE] = ACTIONS(5049),
    [anon_sym_BANG_TILDE] = ACTIONS(5049),
    [anon_sym_LT_EQ] = ACTIONS(5041),
    [anon_sym_GT] = ACTIONS(5041),
    [anon_sym_GT_EQ] = ACTIONS(5055),
    [anon_sym_CARET] = ACTIONS(5057),
    [anon_sym_PLUS] = ACTIONS(5033),
    [anon_sym_SLASH] = ACTIONS(5035),
    [anon_sym_PERCENT] = ACTIONS(5035),
    [sym_comment] = ACTIONS(87),
  },
  [5576] = {
    [sym_string] = STATE(5576),
    [aux_sym_chained_string_repeat1] = STATE(5576),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(6214),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_end] = ACTIONS(6212),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_else] = ACTIONS(6212),
    [anon_sym_ensure] = ACTIONS(6212),
    [anon_sym_EQ_GT] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [5577] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(8747),
    [sym__binary_star] = ACTIONS(8749),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(8751),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(8749),
    [anon_sym_AMP] = ACTIONS(8753),
    [anon_sym_LT] = ACTIONS(8755),
    [anon_sym_then] = ACTIONS(4211),
    [anon_sym_EQ_GT] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(8757),
    [anon_sym_DOT_DOT] = ACTIONS(8759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8761),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(8763),
    [anon_sym_AMP_AMP] = ACTIONS(8763),
    [anon_sym_LT_LT] = ACTIONS(8765),
    [anon_sym_GT_GT] = ACTIONS(8765),
    [anon_sym_EQ_EQ] = ACTIONS(8767),
    [anon_sym_BANG_EQ] = ACTIONS(8763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8763),
    [anon_sym_LT_EQ_GT] = ACTIONS(8763),
    [anon_sym_EQ_TILDE] = ACTIONS(8763),
    [anon_sym_BANG_TILDE] = ACTIONS(8763),
    [anon_sym_LT_EQ] = ACTIONS(8755),
    [anon_sym_GT] = ACTIONS(8755),
    [anon_sym_GT_EQ] = ACTIONS(8769),
    [anon_sym_CARET] = ACTIONS(8771),
    [anon_sym_PLUS] = ACTIONS(8747),
    [anon_sym_SLASH] = ACTIONS(8749),
    [anon_sym_PERCENT] = ACTIONS(8749),
    [sym_comment] = ACTIONS(87),
  },
  [5578] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(8747),
    [sym__binary_star] = ACTIONS(8749),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(8751),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(8749),
    [anon_sym_AMP] = ACTIONS(8753),
    [anon_sym_LT] = ACTIONS(8755),
    [anon_sym_then] = ACTIONS(4247),
    [anon_sym_EQ_GT] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(8757),
    [anon_sym_DOT_DOT] = ACTIONS(8759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8761),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(8763),
    [anon_sym_AMP_AMP] = ACTIONS(8763),
    [anon_sym_LT_LT] = ACTIONS(8765),
    [anon_sym_GT_GT] = ACTIONS(8765),
    [anon_sym_EQ_EQ] = ACTIONS(8767),
    [anon_sym_BANG_EQ] = ACTIONS(8763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8763),
    [anon_sym_LT_EQ_GT] = ACTIONS(8763),
    [anon_sym_EQ_TILDE] = ACTIONS(8763),
    [anon_sym_BANG_TILDE] = ACTIONS(8763),
    [anon_sym_LT_EQ] = ACTIONS(8755),
    [anon_sym_GT] = ACTIONS(8755),
    [anon_sym_GT_EQ] = ACTIONS(8769),
    [anon_sym_CARET] = ACTIONS(8771),
    [anon_sym_PLUS] = ACTIONS(8747),
    [anon_sym_SLASH] = ACTIONS(8749),
    [anon_sym_PERCENT] = ACTIONS(8749),
    [sym_comment] = ACTIONS(87),
  },
  [5579] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8749),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [5580] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8002),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3056),
    [sym_scope_resolution] = STATE(1172),
    [sym_call] = STATE(1172),
    [sym_method_call] = STATE(3056),
    [sym_assignment] = STATE(8002),
    [sym_operator_assignment] = STATE(8002),
    [sym_conditional] = STATE(8002),
    [sym_range] = STATE(8002),
    [sym_binary] = STATE(8002),
    [sym_unary] = STATE(8002),
    [sym_left_assignment_list] = STATE(3055),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3056),
    [sym__variable] = STATE(1172),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3056),
    [sym_false] = STATE(3056),
    [sym_nil] = STATE(3056),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1176),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5081),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2085),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_next] = ACTIONS(2089),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8741),
    [anon_sym_defined_QMARK] = ACTIONS(5085),
    [anon_sym_not] = ACTIONS(5087),
    [anon_sym_BANG] = ACTIONS(5091),
    [anon_sym_TILDE] = ACTIONS(5091),
    [sym_constant] = ACTIONS(2103),
    [sym_identifier] = ACTIONS(2103),
    [sym_instance_variable] = ACTIONS(2105),
    [sym_class_variable] = ACTIONS(2105),
    [sym_global_variable] = ACTIONS(2105),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2103),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2103),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5581] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(8747),
    [sym__binary_star] = ACTIONS(8749),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(8751),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(8749),
    [anon_sym_AMP] = ACTIONS(8753),
    [anon_sym_LT] = ACTIONS(8755),
    [anon_sym_then] = ACTIONS(3281),
    [anon_sym_EQ_GT] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(8757),
    [anon_sym_DOT_DOT] = ACTIONS(8759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8761),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(8763),
    [anon_sym_AMP_AMP] = ACTIONS(8763),
    [anon_sym_LT_LT] = ACTIONS(8765),
    [anon_sym_GT_GT] = ACTIONS(8765),
    [anon_sym_EQ_EQ] = ACTIONS(8767),
    [anon_sym_BANG_EQ] = ACTIONS(8763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8763),
    [anon_sym_LT_EQ_GT] = ACTIONS(8763),
    [anon_sym_EQ_TILDE] = ACTIONS(8763),
    [anon_sym_BANG_TILDE] = ACTIONS(8763),
    [anon_sym_LT_EQ] = ACTIONS(8755),
    [anon_sym_GT] = ACTIONS(8755),
    [anon_sym_GT_EQ] = ACTIONS(8769),
    [anon_sym_CARET] = ACTIONS(8771),
    [anon_sym_PLUS] = ACTIONS(8747),
    [anon_sym_SLASH] = ACTIONS(8749),
    [anon_sym_PERCENT] = ACTIONS(8749),
    [sym_comment] = ACTIONS(87),
  },
  [5582] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(8747),
    [sym__binary_star] = ACTIONS(8749),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(8751),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8749),
    [anon_sym_AMP] = ACTIONS(8753),
    [anon_sym_LT] = ACTIONS(8755),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(8757),
    [anon_sym_DOT_DOT] = ACTIONS(8759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8761),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(8763),
    [anon_sym_AMP_AMP] = ACTIONS(8763),
    [anon_sym_LT_LT] = ACTIONS(8765),
    [anon_sym_GT_GT] = ACTIONS(8765),
    [anon_sym_EQ_EQ] = ACTIONS(8767),
    [anon_sym_BANG_EQ] = ACTIONS(8763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8763),
    [anon_sym_LT_EQ_GT] = ACTIONS(8763),
    [anon_sym_EQ_TILDE] = ACTIONS(8763),
    [anon_sym_BANG_TILDE] = ACTIONS(8763),
    [anon_sym_LT_EQ] = ACTIONS(8755),
    [anon_sym_GT] = ACTIONS(8755),
    [anon_sym_GT_EQ] = ACTIONS(8769),
    [anon_sym_CARET] = ACTIONS(8771),
    [anon_sym_PLUS] = ACTIONS(8747),
    [anon_sym_SLASH] = ACTIONS(8749),
    [anon_sym_PERCENT] = ACTIONS(8749),
    [sym_comment] = ACTIONS(87),
  },
  [5583] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8003),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3056),
    [sym_scope_resolution] = STATE(1172),
    [sym_call] = STATE(1172),
    [sym_method_call] = STATE(3056),
    [sym_assignment] = STATE(8003),
    [sym_operator_assignment] = STATE(8003),
    [sym_conditional] = STATE(8003),
    [sym_range] = STATE(8003),
    [sym_binary] = STATE(8003),
    [sym_unary] = STATE(8003),
    [sym_left_assignment_list] = STATE(3055),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3056),
    [sym__variable] = STATE(1172),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3056),
    [sym_false] = STATE(3056),
    [sym_nil] = STATE(3056),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1176),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5081),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2085),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_next] = ACTIONS(2089),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8741),
    [anon_sym_defined_QMARK] = ACTIONS(5085),
    [anon_sym_not] = ACTIONS(5087),
    [anon_sym_BANG] = ACTIONS(5091),
    [anon_sym_TILDE] = ACTIONS(5091),
    [sym_constant] = ACTIONS(2103),
    [sym_identifier] = ACTIONS(2103),
    [sym_instance_variable] = ACTIONS(2105),
    [sym_class_variable] = ACTIONS(2105),
    [sym_global_variable] = ACTIONS(2105),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2103),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2103),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5584] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8004),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3056),
    [sym_scope_resolution] = STATE(1172),
    [sym_call] = STATE(1172),
    [sym_method_call] = STATE(3056),
    [sym_assignment] = STATE(8004),
    [sym_operator_assignment] = STATE(8004),
    [sym_conditional] = STATE(8004),
    [sym_range] = STATE(8004),
    [sym_binary] = STATE(8004),
    [sym_unary] = STATE(8004),
    [sym_left_assignment_list] = STATE(3055),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3056),
    [sym__variable] = STATE(1172),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3056),
    [sym_false] = STATE(3056),
    [sym_nil] = STATE(3056),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1176),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5081),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2085),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_next] = ACTIONS(2089),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8741),
    [anon_sym_defined_QMARK] = ACTIONS(5085),
    [anon_sym_not] = ACTIONS(5087),
    [anon_sym_BANG] = ACTIONS(5091),
    [anon_sym_TILDE] = ACTIONS(5091),
    [sym_constant] = ACTIONS(2103),
    [sym_identifier] = ACTIONS(2103),
    [sym_instance_variable] = ACTIONS(2105),
    [sym_class_variable] = ACTIONS(2105),
    [sym_global_variable] = ACTIONS(2105),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2103),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2103),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5585] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8005),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3056),
    [sym_scope_resolution] = STATE(1172),
    [sym_call] = STATE(1172),
    [sym_method_call] = STATE(3056),
    [sym_assignment] = STATE(8005),
    [sym_operator_assignment] = STATE(8005),
    [sym_conditional] = STATE(8005),
    [sym_range] = STATE(8005),
    [sym_binary] = STATE(8005),
    [sym_unary] = STATE(8005),
    [sym_left_assignment_list] = STATE(3055),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3056),
    [sym__variable] = STATE(1172),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3056),
    [sym_false] = STATE(3056),
    [sym_nil] = STATE(3056),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1176),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5081),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2085),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_next] = ACTIONS(2089),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8741),
    [anon_sym_defined_QMARK] = ACTIONS(5085),
    [anon_sym_not] = ACTIONS(5087),
    [anon_sym_BANG] = ACTIONS(5091),
    [anon_sym_TILDE] = ACTIONS(5091),
    [sym_constant] = ACTIONS(2103),
    [sym_identifier] = ACTIONS(2103),
    [sym_instance_variable] = ACTIONS(2105),
    [sym_class_variable] = ACTIONS(2105),
    [sym_global_variable] = ACTIONS(2105),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2103),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2103),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5586] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8006),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3056),
    [sym_scope_resolution] = STATE(1172),
    [sym_call] = STATE(1172),
    [sym_method_call] = STATE(3056),
    [sym_assignment] = STATE(8006),
    [sym_operator_assignment] = STATE(8006),
    [sym_conditional] = STATE(8006),
    [sym_range] = STATE(8006),
    [sym_binary] = STATE(8006),
    [sym_unary] = STATE(8006),
    [sym_left_assignment_list] = STATE(3055),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3056),
    [sym__variable] = STATE(1172),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3056),
    [sym_false] = STATE(3056),
    [sym_nil] = STATE(3056),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1176),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5081),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2085),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_next] = ACTIONS(2089),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8741),
    [anon_sym_defined_QMARK] = ACTIONS(5085),
    [anon_sym_not] = ACTIONS(5087),
    [anon_sym_BANG] = ACTIONS(5091),
    [anon_sym_TILDE] = ACTIONS(5091),
    [sym_constant] = ACTIONS(2103),
    [sym_identifier] = ACTIONS(2103),
    [sym_instance_variable] = ACTIONS(2105),
    [sym_class_variable] = ACTIONS(2105),
    [sym_global_variable] = ACTIONS(2105),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2103),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2103),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5587] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8007),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3056),
    [sym_scope_resolution] = STATE(1172),
    [sym_call] = STATE(1172),
    [sym_method_call] = STATE(3056),
    [sym_assignment] = STATE(8007),
    [sym_operator_assignment] = STATE(8007),
    [sym_conditional] = STATE(8007),
    [sym_range] = STATE(8007),
    [sym_binary] = STATE(8007),
    [sym_unary] = STATE(8007),
    [sym_left_assignment_list] = STATE(3055),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3056),
    [sym__variable] = STATE(1172),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3056),
    [sym_false] = STATE(3056),
    [sym_nil] = STATE(3056),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1176),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5081),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2085),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_next] = ACTIONS(2089),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8741),
    [anon_sym_defined_QMARK] = ACTIONS(5085),
    [anon_sym_not] = ACTIONS(5087),
    [anon_sym_BANG] = ACTIONS(5091),
    [anon_sym_TILDE] = ACTIONS(5091),
    [sym_constant] = ACTIONS(2103),
    [sym_identifier] = ACTIONS(2103),
    [sym_instance_variable] = ACTIONS(2105),
    [sym_class_variable] = ACTIONS(2105),
    [sym_global_variable] = ACTIONS(2105),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2103),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2103),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5588] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8008),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3056),
    [sym_scope_resolution] = STATE(1172),
    [sym_call] = STATE(1172),
    [sym_method_call] = STATE(3056),
    [sym_assignment] = STATE(8008),
    [sym_operator_assignment] = STATE(8008),
    [sym_conditional] = STATE(8008),
    [sym_range] = STATE(8008),
    [sym_binary] = STATE(8008),
    [sym_unary] = STATE(8008),
    [sym_left_assignment_list] = STATE(3055),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3056),
    [sym__variable] = STATE(1172),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3056),
    [sym_false] = STATE(3056),
    [sym_nil] = STATE(3056),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1176),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5081),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2085),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_next] = ACTIONS(2089),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8741),
    [anon_sym_defined_QMARK] = ACTIONS(5085),
    [anon_sym_not] = ACTIONS(5087),
    [anon_sym_BANG] = ACTIONS(5091),
    [anon_sym_TILDE] = ACTIONS(5091),
    [sym_constant] = ACTIONS(2103),
    [sym_identifier] = ACTIONS(2103),
    [sym_instance_variable] = ACTIONS(2105),
    [sym_class_variable] = ACTIONS(2105),
    [sym_global_variable] = ACTIONS(2105),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2103),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2103),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5589] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(8009),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(8009),
    [sym_operator_assignment] = STATE(8009),
    [sym_conditional] = STATE(8009),
    [sym_range] = STATE(8009),
    [sym_binary] = STATE(8009),
    [sym_unary] = STATE(8009),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5590] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8010),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3056),
    [sym_scope_resolution] = STATE(1172),
    [sym_call] = STATE(1172),
    [sym_method_call] = STATE(3056),
    [sym_assignment] = STATE(8010),
    [sym_operator_assignment] = STATE(8010),
    [sym_conditional] = STATE(8010),
    [sym_range] = STATE(8010),
    [sym_binary] = STATE(8010),
    [sym_unary] = STATE(8010),
    [sym_left_assignment_list] = STATE(3055),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3056),
    [sym__variable] = STATE(1172),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3056),
    [sym_false] = STATE(3056),
    [sym_nil] = STATE(3056),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1176),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5081),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2085),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_next] = ACTIONS(2089),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8741),
    [anon_sym_defined_QMARK] = ACTIONS(5085),
    [anon_sym_not] = ACTIONS(5087),
    [anon_sym_BANG] = ACTIONS(5091),
    [anon_sym_TILDE] = ACTIONS(5091),
    [sym_constant] = ACTIONS(2103),
    [sym_identifier] = ACTIONS(2103),
    [sym_instance_variable] = ACTIONS(2105),
    [sym_class_variable] = ACTIONS(2105),
    [sym_global_variable] = ACTIONS(2105),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2103),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2103),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5591] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8011),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3056),
    [sym_scope_resolution] = STATE(1172),
    [sym_call] = STATE(1172),
    [sym_method_call] = STATE(3056),
    [sym_assignment] = STATE(8011),
    [sym_operator_assignment] = STATE(8011),
    [sym_conditional] = STATE(8011),
    [sym_range] = STATE(8011),
    [sym_binary] = STATE(8011),
    [sym_unary] = STATE(8011),
    [sym_left_assignment_list] = STATE(3055),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3056),
    [sym__variable] = STATE(1172),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3056),
    [sym_false] = STATE(3056),
    [sym_nil] = STATE(3056),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1176),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5081),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2085),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_next] = ACTIONS(2089),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8741),
    [anon_sym_defined_QMARK] = ACTIONS(5085),
    [anon_sym_not] = ACTIONS(5087),
    [anon_sym_BANG] = ACTIONS(5091),
    [anon_sym_TILDE] = ACTIONS(5091),
    [sym_constant] = ACTIONS(2103),
    [sym_identifier] = ACTIONS(2103),
    [sym_instance_variable] = ACTIONS(2105),
    [sym_class_variable] = ACTIONS(2105),
    [sym_global_variable] = ACTIONS(2105),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2103),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2103),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5592] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8012),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3056),
    [sym_scope_resolution] = STATE(1172),
    [sym_call] = STATE(1172),
    [sym_method_call] = STATE(3056),
    [sym_assignment] = STATE(8012),
    [sym_operator_assignment] = STATE(8012),
    [sym_conditional] = STATE(8012),
    [sym_range] = STATE(8012),
    [sym_binary] = STATE(8012),
    [sym_unary] = STATE(8012),
    [sym_left_assignment_list] = STATE(3055),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3056),
    [sym__variable] = STATE(1172),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3056),
    [sym_false] = STATE(3056),
    [sym_nil] = STATE(3056),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1176),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5081),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2085),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_next] = ACTIONS(2089),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8741),
    [anon_sym_defined_QMARK] = ACTIONS(5085),
    [anon_sym_not] = ACTIONS(5087),
    [anon_sym_BANG] = ACTIONS(5091),
    [anon_sym_TILDE] = ACTIONS(5091),
    [sym_constant] = ACTIONS(2103),
    [sym_identifier] = ACTIONS(2103),
    [sym_instance_variable] = ACTIONS(2105),
    [sym_class_variable] = ACTIONS(2105),
    [sym_global_variable] = ACTIONS(2105),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2103),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2103),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5593] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8013),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3056),
    [sym_scope_resolution] = STATE(1172),
    [sym_call] = STATE(1172),
    [sym_method_call] = STATE(3056),
    [sym_assignment] = STATE(8013),
    [sym_operator_assignment] = STATE(8013),
    [sym_conditional] = STATE(8013),
    [sym_range] = STATE(8013),
    [sym_binary] = STATE(8013),
    [sym_unary] = STATE(8013),
    [sym_left_assignment_list] = STATE(3055),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3056),
    [sym__variable] = STATE(1172),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3056),
    [sym_false] = STATE(3056),
    [sym_nil] = STATE(3056),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1176),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5081),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2085),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_next] = ACTIONS(2089),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8741),
    [anon_sym_defined_QMARK] = ACTIONS(5085),
    [anon_sym_not] = ACTIONS(5087),
    [anon_sym_BANG] = ACTIONS(5091),
    [anon_sym_TILDE] = ACTIONS(5091),
    [sym_constant] = ACTIONS(2103),
    [sym_identifier] = ACTIONS(2103),
    [sym_instance_variable] = ACTIONS(2105),
    [sym_class_variable] = ACTIONS(2105),
    [sym_global_variable] = ACTIONS(2105),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2103),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2103),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5594] = {
    [sym_heredoc_body] = STATE(8014),
    [aux_sym_call_repeat1] = STATE(8014),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_then] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [5595] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3052),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3056),
    [sym_scope_resolution] = STATE(1172),
    [sym_call] = STATE(1172),
    [sym_method_call] = STATE(3056),
    [sym__argument] = STATE(2565),
    [sym_splat_argument] = STATE(2565),
    [sym_hash_splat_argument] = STATE(2565),
    [sym_block_argument] = STATE(2565),
    [sym_assignment] = STATE(3052),
    [sym_operator_assignment] = STATE(3052),
    [sym_conditional] = STATE(3052),
    [sym_range] = STATE(3052),
    [sym_binary] = STATE(3052),
    [sym_unary] = STATE(3052),
    [sym_left_assignment_list] = STATE(3055),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3056),
    [sym__variable] = STATE(1172),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3056),
    [sym_false] = STATE(3056),
    [sym_nil] = STATE(3056),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3057),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(8015),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2565),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(5077),
    [sym__splat_star] = ACTIONS(5079),
    [sym__unary_minus] = ACTIONS(5081),
    [sym__identifier_hash_key] = ACTIONS(5083),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11501),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2085),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_next] = ACTIONS(2089),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8741),
    [anon_sym_defined_QMARK] = ACTIONS(5085),
    [anon_sym_not] = ACTIONS(5087),
    [anon_sym_BANG] = ACTIONS(5091),
    [anon_sym_TILDE] = ACTIONS(5091),
    [sym_constant] = ACTIONS(5093),
    [sym_identifier] = ACTIONS(5093),
    [sym_instance_variable] = ACTIONS(2105),
    [sym_class_variable] = ACTIONS(2105),
    [sym_global_variable] = ACTIONS(2105),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2103),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2103),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5596] = {
    [sym_heredoc_body] = STATE(8016),
    [aux_sym_call_repeat1] = STATE(8016),
    [aux_sym_argument_list_repeat1] = STATE(8017),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(8773),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_then] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [5597] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8018),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3056),
    [sym_scope_resolution] = STATE(1172),
    [sym_call] = STATE(1172),
    [sym_method_call] = STATE(3056),
    [sym_splat_argument] = STATE(8019),
    [sym_assignment] = STATE(8018),
    [sym_operator_assignment] = STATE(8018),
    [sym_conditional] = STATE(8018),
    [sym_range] = STATE(8018),
    [sym_binary] = STATE(8018),
    [sym_unary] = STATE(8018),
    [sym_right_assignment_list] = STATE(2570),
    [sym__arg_or_splat_arg] = STATE(8019),
    [sym_left_assignment_list] = STATE(3055),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3056),
    [sym__variable] = STATE(1172),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3056),
    [sym_false] = STATE(3056),
    [sym_nil] = STATE(3056),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1176),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__splat_star] = ACTIONS(5079),
    [sym__unary_minus] = ACTIONS(5081),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2085),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_next] = ACTIONS(2089),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8741),
    [anon_sym_defined_QMARK] = ACTIONS(5085),
    [anon_sym_not] = ACTIONS(5087),
    [anon_sym_BANG] = ACTIONS(5091),
    [anon_sym_TILDE] = ACTIONS(5091),
    [sym_constant] = ACTIONS(2103),
    [sym_identifier] = ACTIONS(2103),
    [sym_instance_variable] = ACTIONS(2105),
    [sym_class_variable] = ACTIONS(2105),
    [sym_global_variable] = ACTIONS(2105),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2103),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2103),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5598] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8020),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3056),
    [sym_scope_resolution] = STATE(1172),
    [sym_call] = STATE(1172),
    [sym_method_call] = STATE(3056),
    [sym_assignment] = STATE(8020),
    [sym_operator_assignment] = STATE(8020),
    [sym_conditional] = STATE(8020),
    [sym_range] = STATE(8020),
    [sym_binary] = STATE(8020),
    [sym_unary] = STATE(8020),
    [sym_left_assignment_list] = STATE(3055),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3056),
    [sym__variable] = STATE(1172),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3056),
    [sym_false] = STATE(3056),
    [sym_nil] = STATE(3056),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1176),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5081),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2085),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_next] = ACTIONS(2089),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8741),
    [anon_sym_defined_QMARK] = ACTIONS(5085),
    [anon_sym_not] = ACTIONS(5087),
    [anon_sym_BANG] = ACTIONS(5091),
    [anon_sym_TILDE] = ACTIONS(5091),
    [sym_constant] = ACTIONS(2103),
    [sym_identifier] = ACTIONS(2103),
    [sym_instance_variable] = ACTIONS(2105),
    [sym_class_variable] = ACTIONS(2105),
    [sym_global_variable] = ACTIONS(2105),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2103),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2103),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5599] = {
    [sym_argument_list_with_parens] = STATE(8023),
    [sym__argument_list_with_parens] = STATE(8024),
    [sym_operator] = STATE(8023),
    [sym_heredoc_body] = STATE(8025),
    [aux_sym_call_repeat1] = STATE(8025),
    [sym__heredoc_body_start] = ACTIONS(2519),
    [anon_sym_PIPE] = ACTIONS(11503),
    [anon_sym_STAR] = ACTIONS(11505),
    [anon_sym_STAR_STAR] = ACTIONS(11503),
    [anon_sym_AMP] = ACTIONS(11503),
    [anon_sym_LT] = ACTIONS(11505),
    [anon_sym_LPAREN2] = ACTIONS(11507),
    [anon_sym_DOT_DOT] = ACTIONS(11503),
    [anon_sym_LT_LT] = ACTIONS(11503),
    [anon_sym_GT_GT] = ACTIONS(11503),
    [anon_sym_EQ_EQ] = ACTIONS(11505),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11503),
    [anon_sym_LT_EQ_GT] = ACTIONS(11503),
    [anon_sym_EQ_TILDE] = ACTIONS(11503),
    [anon_sym_BANG_TILDE] = ACTIONS(11503),
    [anon_sym_LT_EQ] = ACTIONS(11505),
    [anon_sym_GT] = ACTIONS(11505),
    [anon_sym_GT_EQ] = ACTIONS(11503),
    [anon_sym_CARET] = ACTIONS(11503),
    [anon_sym_PLUS] = ACTIONS(11505),
    [anon_sym_SLASH] = ACTIONS(11503),
    [anon_sym_PERCENT] = ACTIONS(11503),
    [anon_sym_BANG] = ACTIONS(11505),
    [anon_sym_TILDE] = ACTIONS(11503),
    [sym_constant] = ACTIONS(11509),
    [sym_identifier] = ACTIONS(11509),
    [anon_sym_DASH] = ACTIONS(11505),
    [anon_sym_PLUS_AT] = ACTIONS(11503),
    [anon_sym_DASH_AT] = ACTIONS(11503),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11505),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(11503),
    [anon_sym_BQUOTE] = ACTIONS(11503),
    [sym_comment] = ACTIONS(87),
  },
  [5600] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(346),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(352),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(352),
    [sym__argument_list_with_trailing_comma] = STATE(8027),
    [sym__argument] = STATE(350),
    [sym_splat_argument] = STATE(350),
    [sym_hash_splat_argument] = STATE(350),
    [sym_block_argument] = STATE(350),
    [sym_assignment] = STATE(346),
    [sym_operator_assignment] = STATE(346),
    [sym_conditional] = STATE(346),
    [sym_range] = STATE(346),
    [sym_binary] = STATE(346),
    [sym_unary] = STATE(346),
    [sym_left_assignment_list] = STATE(351),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(352),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(352),
    [sym_false] = STATE(352),
    [sym_nil] = STATE(352),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(353),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(350),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(593),
    [sym__splat_star] = ACTIONS(595),
    [sym__unary_minus] = ACTIONS(597),
    [sym__identifier_hash_key] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(11511),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5601] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8035),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(8037),
    [sym_scope_resolution] = STATE(7955),
    [sym_call] = STATE(7955),
    [sym_method_call] = STATE(8037),
    [sym_assignment] = STATE(8035),
    [sym_operator_assignment] = STATE(8035),
    [sym_conditional] = STATE(8035),
    [sym_range] = STATE(8035),
    [sym_binary] = STATE(8035),
    [sym_unary] = STATE(8035),
    [sym_left_assignment_list] = STATE(8036),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(8037),
    [sym__variable] = STATE(7955),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(8037),
    [sym_false] = STATE(8037),
    [sym_nil] = STATE(8037),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(8038),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11513),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11515),
    [anon_sym_yield] = ACTIONS(11517),
    [anon_sym_break] = ACTIONS(11519),
    [anon_sym_next] = ACTIONS(11521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11523),
    [anon_sym_defined_QMARK] = ACTIONS(11525),
    [anon_sym_not] = ACTIONS(11527),
    [anon_sym_BANG] = ACTIONS(11529),
    [anon_sym_TILDE] = ACTIONS(11529),
    [sym_constant] = ACTIONS(11478),
    [sym_identifier] = ACTIONS(11478),
    [sym_instance_variable] = ACTIONS(11480),
    [sym_class_variable] = ACTIONS(11480),
    [sym_global_variable] = ACTIONS(11480),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11478),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11478),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5602] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8039),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(8037),
    [sym_scope_resolution] = STATE(7955),
    [sym_call] = STATE(7955),
    [sym_method_call] = STATE(8037),
    [sym_assignment] = STATE(8039),
    [sym_operator_assignment] = STATE(8039),
    [sym_conditional] = STATE(8039),
    [sym_range] = STATE(8039),
    [sym_binary] = STATE(8039),
    [sym_unary] = STATE(8039),
    [sym_left_assignment_list] = STATE(8036),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(8037),
    [sym__variable] = STATE(7955),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(8037),
    [sym_false] = STATE(8037),
    [sym_nil] = STATE(8037),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(8038),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11513),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11515),
    [anon_sym_yield] = ACTIONS(11517),
    [anon_sym_break] = ACTIONS(11519),
    [anon_sym_next] = ACTIONS(11521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11523),
    [anon_sym_defined_QMARK] = ACTIONS(11525),
    [anon_sym_not] = ACTIONS(11527),
    [anon_sym_BANG] = ACTIONS(11529),
    [anon_sym_TILDE] = ACTIONS(11529),
    [sym_constant] = ACTIONS(11478),
    [sym_identifier] = ACTIONS(11478),
    [sym_instance_variable] = ACTIONS(11480),
    [sym_class_variable] = ACTIONS(11480),
    [sym_global_variable] = ACTIONS(11480),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11478),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11478),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5603] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8040),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5621),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(5621),
    [sym_assignment] = STATE(8040),
    [sym_operator_assignment] = STATE(8040),
    [sym_conditional] = STATE(8040),
    [sym_range] = STATE(8040),
    [sym_binary] = STATE(8040),
    [sym_unary] = STATE(8040),
    [sym_left_assignment_list] = STATE(5620),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5621),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5621),
    [sym_false] = STATE(5621),
    [sym_nil] = STATE(5621),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(8041),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(8791),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8799),
    [anon_sym_yield] = ACTIONS(8801),
    [anon_sym_break] = ACTIONS(8803),
    [anon_sym_next] = ACTIONS(8805),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8809),
    [anon_sym_defined_QMARK] = ACTIONS(8811),
    [anon_sym_not] = ACTIONS(8813),
    [anon_sym_BANG] = ACTIONS(8815),
    [anon_sym_TILDE] = ACTIONS(8815),
    [sym_constant] = ACTIONS(5173),
    [sym_identifier] = ACTIONS(5173),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5604] = {
    [anon_sym_COLON] = ACTIONS(11531),
    [sym_comment] = ACTIONS(87),
  },
  [5605] = {
    [sym__statements] = STATE(7080),
    [sym_begin_block] = STATE(489),
    [sym_end_block] = STATE(489),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_block_parameters] = STATE(7081),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1516),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1519),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1519),
    [sym_hash_splat_argument] = STATE(116),
    [sym_assignment] = STATE(1516),
    [sym_operator_assignment] = STATE(1516),
    [sym_conditional] = STATE(1516),
    [sym_range] = STATE(1516),
    [sym_binary] = STATE(1516),
    [sym_unary] = STATE(1516),
    [sym_left_assignment_list] = STATE(1518),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1519),
    [sym__variable] = STATE(1517),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1519),
    [sym_false] = STATE(1519),
    [sym_nil] = STATE(1519),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1520),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(120),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym__hash_items] = STATE(121),
    [sym_pair] = STATE(122),
    [sym_lambda] = STATE(214),
    [sym_empty_statement] = STATE(495),
    [aux_sym__statements_repeat1] = STATE(495),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2629),
    [sym__identifier_hash_key] = ACTIONS(157),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(11533),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_PIPE] = ACTIONS(2445),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2633),
    [anon_sym_yield] = ACTIONS(2635),
    [anon_sym_break] = ACTIONS(2637),
    [anon_sym_next] = ACTIONS(2639),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2641),
    [anon_sym_defined_QMARK] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2647),
    [anon_sym_TILDE] = ACTIONS(2647),
    [sym_constant] = ACTIONS(2649),
    [sym_identifier] = ACTIONS(2649),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5606] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8044),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(8037),
    [sym_scope_resolution] = STATE(7955),
    [sym_call] = STATE(7955),
    [sym_method_call] = STATE(8037),
    [sym_assignment] = STATE(8044),
    [sym_operator_assignment] = STATE(8044),
    [sym_conditional] = STATE(8044),
    [sym_range] = STATE(8044),
    [sym_binary] = STATE(8044),
    [sym_unary] = STATE(8044),
    [sym_left_assignment_list] = STATE(8036),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(8037),
    [sym__variable] = STATE(7955),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(8037),
    [sym_false] = STATE(8037),
    [sym_nil] = STATE(8037),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(8038),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11513),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11515),
    [anon_sym_yield] = ACTIONS(11517),
    [anon_sym_break] = ACTIONS(11519),
    [anon_sym_next] = ACTIONS(11521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11523),
    [anon_sym_defined_QMARK] = ACTIONS(11525),
    [anon_sym_not] = ACTIONS(11527),
    [anon_sym_BANG] = ACTIONS(11529),
    [anon_sym_TILDE] = ACTIONS(11529),
    [sym_constant] = ACTIONS(11478),
    [sym_identifier] = ACTIONS(11478),
    [sym_instance_variable] = ACTIONS(11480),
    [sym_class_variable] = ACTIONS(11480),
    [sym_global_variable] = ACTIONS(11480),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11478),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11478),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5607] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8050),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5621),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(5621),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(8051),
    [sym__argument] = STATE(8052),
    [sym_splat_argument] = STATE(8052),
    [sym_hash_splat_argument] = STATE(8052),
    [sym_block_argument] = STATE(8052),
    [sym_assignment] = STATE(8050),
    [sym_operator_assignment] = STATE(8050),
    [sym_conditional] = STATE(8050),
    [sym_range] = STATE(8050),
    [sym_binary] = STATE(8050),
    [sym_unary] = STATE(8050),
    [sym_left_assignment_list] = STATE(5620),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5621),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5621),
    [sym_false] = STATE(5621),
    [sym_nil] = STATE(5621),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(8053),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(8052),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(11535),
    [sym__splat_star] = ACTIONS(11537),
    [sym__unary_minus] = ACTIONS(8791),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(11539),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8799),
    [anon_sym_yield] = ACTIONS(8801),
    [anon_sym_break] = ACTIONS(8803),
    [anon_sym_next] = ACTIONS(8805),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(377),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(8811),
    [anon_sym_not] = ACTIONS(8813),
    [anon_sym_BANG] = ACTIONS(11541),
    [anon_sym_TILDE] = ACTIONS(8815),
    [sym_constant] = ACTIONS(11543),
    [sym_identifier] = ACTIONS(11543),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5608] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8050),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5621),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(5621),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(8051),
    [sym__argument] = STATE(8052),
    [sym_splat_argument] = STATE(8052),
    [sym_hash_splat_argument] = STATE(8052),
    [sym_block_argument] = STATE(8052),
    [sym_assignment] = STATE(8050),
    [sym_operator_assignment] = STATE(8050),
    [sym_conditional] = STATE(8050),
    [sym_range] = STATE(8050),
    [sym_binary] = STATE(8050),
    [sym_unary] = STATE(8050),
    [sym_left_assignment_list] = STATE(5620),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5621),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5621),
    [sym_false] = STATE(5621),
    [sym_nil] = STATE(5621),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(8053),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(8052),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(11535),
    [sym__splat_star] = ACTIONS(11537),
    [sym__unary_minus] = ACTIONS(8791),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(11539),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8799),
    [anon_sym_yield] = ACTIONS(8801),
    [anon_sym_break] = ACTIONS(8803),
    [anon_sym_next] = ACTIONS(8805),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(419),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(8811),
    [anon_sym_not] = ACTIONS(8813),
    [anon_sym_BANG] = ACTIONS(11541),
    [anon_sym_TILDE] = ACTIONS(8815),
    [sym_constant] = ACTIONS(11543),
    [sym_identifier] = ACTIONS(11543),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5609] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8050),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5621),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(5621),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(8051),
    [sym__argument] = STATE(8052),
    [sym_splat_argument] = STATE(8052),
    [sym_hash_splat_argument] = STATE(8052),
    [sym_block_argument] = STATE(8052),
    [sym_assignment] = STATE(8050),
    [sym_operator_assignment] = STATE(8050),
    [sym_conditional] = STATE(8050),
    [sym_range] = STATE(8050),
    [sym_binary] = STATE(8050),
    [sym_unary] = STATE(8050),
    [sym_left_assignment_list] = STATE(5620),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5621),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5621),
    [sym_false] = STATE(5621),
    [sym_nil] = STATE(5621),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(8053),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(8052),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(11535),
    [sym__splat_star] = ACTIONS(11537),
    [sym__unary_minus] = ACTIONS(8791),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(11539),
    [anon_sym_LBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8799),
    [anon_sym_yield] = ACTIONS(8801),
    [anon_sym_break] = ACTIONS(8803),
    [anon_sym_next] = ACTIONS(8805),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(423),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(8811),
    [anon_sym_not] = ACTIONS(8813),
    [anon_sym_BANG] = ACTIONS(11541),
    [anon_sym_TILDE] = ACTIONS(8815),
    [sym_constant] = ACTIONS(11543),
    [sym_identifier] = ACTIONS(11543),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5610] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8050),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5621),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(5621),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(8051),
    [sym__argument] = STATE(8052),
    [sym_splat_argument] = STATE(8052),
    [sym_hash_splat_argument] = STATE(8052),
    [sym_block_argument] = STATE(8052),
    [sym_assignment] = STATE(8050),
    [sym_operator_assignment] = STATE(8050),
    [sym_conditional] = STATE(8050),
    [sym_range] = STATE(8050),
    [sym_binary] = STATE(8050),
    [sym_unary] = STATE(8050),
    [sym_left_assignment_list] = STATE(5620),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5621),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5621),
    [sym_false] = STATE(5621),
    [sym_nil] = STATE(5621),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(8053),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(8052),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(11535),
    [sym__splat_star] = ACTIONS(11537),
    [sym__unary_minus] = ACTIONS(8791),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(11539),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8799),
    [anon_sym_yield] = ACTIONS(8801),
    [anon_sym_break] = ACTIONS(8803),
    [anon_sym_next] = ACTIONS(8805),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(427),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(8811),
    [anon_sym_not] = ACTIONS(8813),
    [anon_sym_BANG] = ACTIONS(11541),
    [anon_sym_TILDE] = ACTIONS(8815),
    [sym_constant] = ACTIONS(11543),
    [sym_identifier] = ACTIONS(11543),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5611] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(906),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(911),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(911),
    [sym__argument_list_with_trailing_comma] = STATE(8055),
    [sym__argument] = STATE(909),
    [sym_splat_argument] = STATE(909),
    [sym_hash_splat_argument] = STATE(909),
    [sym_block_argument] = STATE(909),
    [sym_assignment] = STATE(906),
    [sym_operator_assignment] = STATE(906),
    [sym_conditional] = STATE(906),
    [sym_range] = STATE(906),
    [sym_binary] = STATE(906),
    [sym_unary] = STATE(906),
    [sym_left_assignment_list] = STATE(910),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(911),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(911),
    [sym_false] = STATE(911),
    [sym_nil] = STATE(911),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(912),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(909),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1589),
    [sym__splat_star] = ACTIONS(1591),
    [sym__unary_minus] = ACTIONS(1593),
    [sym__identifier_hash_key] = ACTIONS(1595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(11545),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1599),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_defined_QMARK] = ACTIONS(1611),
    [anon_sym_not] = ACTIONS(1613),
    [anon_sym_BANG] = ACTIONS(1615),
    [anon_sym_TILDE] = ACTIONS(1615),
    [sym_constant] = ACTIONS(1617),
    [sym_identifier] = ACTIONS(1617),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5612] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8056),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5621),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(5621),
    [sym_assignment] = STATE(8056),
    [sym_operator_assignment] = STATE(8056),
    [sym_conditional] = STATE(8056),
    [sym_range] = STATE(8056),
    [sym_binary] = STATE(8056),
    [sym_unary] = STATE(8056),
    [sym_left_assignment_list] = STATE(5620),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5621),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5621),
    [sym_false] = STATE(5621),
    [sym_nil] = STATE(5621),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(8041),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(8791),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8799),
    [anon_sym_yield] = ACTIONS(8801),
    [anon_sym_break] = ACTIONS(8803),
    [anon_sym_next] = ACTIONS(8805),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8809),
    [anon_sym_defined_QMARK] = ACTIONS(8811),
    [anon_sym_not] = ACTIONS(8813),
    [anon_sym_BANG] = ACTIONS(8815),
    [anon_sym_TILDE] = ACTIONS(8815),
    [sym_constant] = ACTIONS(5173),
    [sym_identifier] = ACTIONS(5173),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5613] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5621),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(5621),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(5620),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5621),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5621),
    [sym_false] = STATE(5621),
    [sym_nil] = STATE(5621),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(8041),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(8791),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8799),
    [anon_sym_yield] = ACTIONS(8801),
    [anon_sym_break] = ACTIONS(8803),
    [anon_sym_next] = ACTIONS(8805),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8809),
    [anon_sym_defined_QMARK] = ACTIONS(8811),
    [anon_sym_not] = ACTIONS(8813),
    [anon_sym_BANG] = ACTIONS(8815),
    [anon_sym_TILDE] = ACTIONS(8815),
    [sym_constant] = ACTIONS(5173),
    [sym_identifier] = ACTIONS(5173),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5614] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(11547),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_then] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [5615] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(11549),
    [sym__binary_star] = ACTIONS(11551),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(11553),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(11551),
    [anon_sym_AMP] = ACTIONS(11555),
    [anon_sym_LT] = ACTIONS(11557),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_then] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(11531),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(11559),
    [anon_sym_DOT_DOT] = ACTIONS(11561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11563),
    [anon_sym_and] = ACTIONS(11565),
    [anon_sym_or] = ACTIONS(11565),
    [anon_sym_PIPE_PIPE] = ACTIONS(11567),
    [anon_sym_AMP_AMP] = ACTIONS(11567),
    [anon_sym_LT_LT] = ACTIONS(11569),
    [anon_sym_GT_GT] = ACTIONS(11569),
    [anon_sym_EQ_EQ] = ACTIONS(11571),
    [anon_sym_BANG_EQ] = ACTIONS(11567),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11567),
    [anon_sym_LT_EQ_GT] = ACTIONS(11567),
    [anon_sym_EQ_TILDE] = ACTIONS(11567),
    [anon_sym_BANG_TILDE] = ACTIONS(11567),
    [anon_sym_LT_EQ] = ACTIONS(11557),
    [anon_sym_GT] = ACTIONS(11557),
    [anon_sym_GT_EQ] = ACTIONS(11573),
    [anon_sym_CARET] = ACTIONS(11575),
    [anon_sym_PLUS] = ACTIONS(11549),
    [anon_sym_SLASH] = ACTIONS(11551),
    [anon_sym_PERCENT] = ACTIONS(11551),
    [sym_comment] = ACTIONS(87),
  },
  [5616] = {
    [sym_do_block] = STATE(8068),
    [sym_block] = STATE(8068),
    [sym__line_break] = ACTIONS(2717),
    [sym__heredoc_body_start] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(7326),
    [anon_sym_DOT] = ACTIONS(2717),
    [anon_sym_SEMI] = ACTIONS(2717),
    [anon_sym_do] = ACTIONS(10686),
    [anon_sym_then] = ACTIONS(2717),
    [anon_sym_LBRACK] = ACTIONS(2717),
    [anon_sym_COLON_COLON2] = ACTIONS(2717),
    [anon_sym_AMP_DOT] = ACTIONS(2717),
    [sym_comment] = ACTIONS(87),
  },
  [5617] = {
    [sym_heredoc_body] = STATE(8070),
    [aux_sym_call_repeat1] = STATE(8070),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(11577),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1681),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_then] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [5618] = {
    [sym_heredoc_body] = STATE(8070),
    [aux_sym_call_repeat1] = STATE(8070),
    [aux_sym_argument_list_repeat1] = STATE(8072),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(11577),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1681),
    [anon_sym_COMMA] = ACTIONS(11579),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_then] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [5619] = {
    [sym__line_break] = ACTIONS(2717),
    [sym__heredoc_body_start] = ACTIONS(2717),
    [anon_sym_DOT] = ACTIONS(2717),
    [anon_sym_SEMI] = ACTIONS(2717),
    [anon_sym_then] = ACTIONS(2717),
    [anon_sym_LBRACK] = ACTIONS(2717),
    [anon_sym_COLON_COLON2] = ACTIONS(2717),
    [anon_sym_AMP_DOT] = ACTIONS(2717),
    [sym_comment] = ACTIONS(87),
  },
  [5620] = {
    [anon_sym_EQ] = ACTIONS(11581),
    [sym_comment] = ACTIONS(87),
  },
  [5621] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(11583),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(11585),
    [anon_sym_DASH_EQ] = ACTIONS(11585),
    [anon_sym_STAR_EQ] = ACTIONS(11585),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11585),
    [anon_sym_SLASH_EQ] = ACTIONS(11585),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11585),
    [anon_sym_PIPE_EQ] = ACTIONS(11585),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11585),
    [anon_sym_AMP_EQ] = ACTIONS(11585),
    [anon_sym_PERCENT_EQ] = ACTIONS(11585),
    [anon_sym_GT_GT_EQ] = ACTIONS(11585),
    [anon_sym_LT_LT_EQ] = ACTIONS(11585),
    [anon_sym_CARET_EQ] = ACTIONS(11585),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5622] = {
    [sym_string] = STATE(8075),
    [aux_sym_chained_string_repeat1] = STATE(8075),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(11587),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [5623] = {
    [anon_sym_end] = ACTIONS(11589),
    [anon_sym_else] = ACTIONS(11589),
    [anon_sym_ensure] = ACTIONS(11589),
    [sym_comment] = ACTIONS(87),
  },
  [5624] = {
    [sym_rescue] = STATE(8076),
    [anon_sym_end] = ACTIONS(11589),
    [anon_sym_rescue] = ACTIONS(2165),
    [anon_sym_else] = ACTIONS(11589),
    [anon_sym_ensure] = ACTIONS(11589),
    [sym_comment] = ACTIONS(87),
  },
  [5625] = {
    [sym__statements] = STATE(2640),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym_rescue] = STATE(8076),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(11591),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(11591),
    [anon_sym_then] = ACTIONS(5187),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(11591),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5626] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5119),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(5119),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5119),
    [anon_sym_PERCENT] = ACTIONS(5119),
    [sym_comment] = ACTIONS(87),
  },
  [5627] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(5119),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [5628] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5117),
    [sym__binary_star] = ACTIONS(5119),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(5119),
    [anon_sym_AMP] = ACTIONS(5123),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5137),
    [anon_sym_GT_GT] = ACTIONS(5137),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5117),
    [anon_sym_SLASH] = ACTIONS(5119),
    [anon_sym_PERCENT] = ACTIONS(5119),
    [sym_comment] = ACTIONS(87),
  },
  [5629] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5117),
    [sym__binary_star] = ACTIONS(5119),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(5119),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5137),
    [anon_sym_GT_GT] = ACTIONS(5137),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5117),
    [anon_sym_SLASH] = ACTIONS(5119),
    [anon_sym_PERCENT] = ACTIONS(5119),
    [sym_comment] = ACTIONS(87),
  },
  [5630] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5117),
    [sym__binary_star] = ACTIONS(5119),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5121),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(5119),
    [anon_sym_AMP] = ACTIONS(5123),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5137),
    [anon_sym_GT_GT] = ACTIONS(5137),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5143),
    [anon_sym_PLUS] = ACTIONS(5117),
    [anon_sym_SLASH] = ACTIONS(5119),
    [anon_sym_PERCENT] = ACTIONS(5119),
    [sym_comment] = ACTIONS(87),
  },
  [5631] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(11593),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [5632] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(5117),
    [sym__binary_star] = ACTIONS(5119),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(5121),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(5119),
    [anon_sym_AMP] = ACTIONS(5123),
    [anon_sym_LT] = ACTIONS(5125),
    [anon_sym_then] = ACTIONS(5927),
    [anon_sym_EQ_GT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(5129),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5131),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(5135),
    [anon_sym_AMP_AMP] = ACTIONS(5135),
    [anon_sym_LT_LT] = ACTIONS(5137),
    [anon_sym_GT_GT] = ACTIONS(5137),
    [anon_sym_EQ_EQ] = ACTIONS(5139),
    [anon_sym_BANG_EQ] = ACTIONS(5135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5135),
    [anon_sym_LT_EQ_GT] = ACTIONS(5135),
    [anon_sym_EQ_TILDE] = ACTIONS(5135),
    [anon_sym_BANG_TILDE] = ACTIONS(5135),
    [anon_sym_LT_EQ] = ACTIONS(5125),
    [anon_sym_GT] = ACTIONS(5125),
    [anon_sym_GT_EQ] = ACTIONS(5141),
    [anon_sym_CARET] = ACTIONS(5143),
    [anon_sym_PLUS] = ACTIONS(5117),
    [anon_sym_SLASH] = ACTIONS(5119),
    [anon_sym_PERCENT] = ACTIONS(5119),
    [sym_comment] = ACTIONS(87),
  },
  [5633] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5117),
    [sym__binary_star] = ACTIONS(5119),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5121),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(5119),
    [anon_sym_AMP] = ACTIONS(5123),
    [anon_sym_LT] = ACTIONS(5125),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5127),
    [anon_sym_DOT_DOT] = ACTIONS(5129),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5131),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5135),
    [anon_sym_AMP_AMP] = ACTIONS(5135),
    [anon_sym_LT_LT] = ACTIONS(5137),
    [anon_sym_GT_GT] = ACTIONS(5137),
    [anon_sym_EQ_EQ] = ACTIONS(5139),
    [anon_sym_BANG_EQ] = ACTIONS(5135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5135),
    [anon_sym_LT_EQ_GT] = ACTIONS(5135),
    [anon_sym_EQ_TILDE] = ACTIONS(5135),
    [anon_sym_BANG_TILDE] = ACTIONS(5135),
    [anon_sym_LT_EQ] = ACTIONS(5125),
    [anon_sym_GT] = ACTIONS(5125),
    [anon_sym_GT_EQ] = ACTIONS(5141),
    [anon_sym_CARET] = ACTIONS(5143),
    [anon_sym_PLUS] = ACTIONS(5117),
    [anon_sym_SLASH] = ACTIONS(5119),
    [anon_sym_PERCENT] = ACTIONS(5119),
    [sym_comment] = ACTIONS(87),
  },
  [5634] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5117),
    [sym__binary_star] = ACTIONS(5119),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5121),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(5119),
    [anon_sym_AMP] = ACTIONS(5123),
    [anon_sym_LT] = ACTIONS(5125),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5137),
    [anon_sym_GT_GT] = ACTIONS(5137),
    [anon_sym_EQ_EQ] = ACTIONS(5139),
    [anon_sym_BANG_EQ] = ACTIONS(5135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5135),
    [anon_sym_LT_EQ_GT] = ACTIONS(5135),
    [anon_sym_EQ_TILDE] = ACTIONS(5135),
    [anon_sym_BANG_TILDE] = ACTIONS(5135),
    [anon_sym_LT_EQ] = ACTIONS(5125),
    [anon_sym_GT] = ACTIONS(5125),
    [anon_sym_GT_EQ] = ACTIONS(5141),
    [anon_sym_CARET] = ACTIONS(5143),
    [anon_sym_PLUS] = ACTIONS(5117),
    [anon_sym_SLASH] = ACTIONS(5119),
    [anon_sym_PERCENT] = ACTIONS(5119),
    [sym_comment] = ACTIONS(87),
  },
  [5635] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5117),
    [sym__binary_star] = ACTIONS(5119),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(5119),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5117),
    [anon_sym_SLASH] = ACTIONS(5119),
    [anon_sym_PERCENT] = ACTIONS(5119),
    [sym_comment] = ACTIONS(87),
  },
  [5636] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(8833),
    [sym__binary_star] = ACTIONS(8835),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(8837),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(8839),
    [anon_sym_AMP] = ACTIONS(8841),
    [anon_sym_EQ] = ACTIONS(4217),
    [anon_sym_LT] = ACTIONS(8843),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_then] = ACTIONS(4211),
    [anon_sym_EQ_GT] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_PLUS_EQ] = ACTIONS(4211),
    [anon_sym_DASH_EQ] = ACTIONS(4211),
    [anon_sym_STAR_EQ] = ACTIONS(4211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4211),
    [anon_sym_SLASH_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4211),
    [anon_sym_AMP_EQ] = ACTIONS(4211),
    [anon_sym_PERCENT_EQ] = ACTIONS(4211),
    [anon_sym_GT_GT_EQ] = ACTIONS(4211),
    [anon_sym_LT_LT_EQ] = ACTIONS(4211),
    [anon_sym_CARET_EQ] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(8845),
    [anon_sym_DOT_DOT] = ACTIONS(8847),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8849),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(8851),
    [anon_sym_AMP_AMP] = ACTIONS(8851),
    [anon_sym_LT_LT] = ACTIONS(8853),
    [anon_sym_GT_GT] = ACTIONS(8853),
    [anon_sym_EQ_EQ] = ACTIONS(8851),
    [anon_sym_BANG_EQ] = ACTIONS(8855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8855),
    [anon_sym_LT_EQ_GT] = ACTIONS(8855),
    [anon_sym_EQ_TILDE] = ACTIONS(8855),
    [anon_sym_BANG_TILDE] = ACTIONS(8855),
    [anon_sym_LT_EQ] = ACTIONS(8843),
    [anon_sym_GT] = ACTIONS(8843),
    [anon_sym_GT_EQ] = ACTIONS(8857),
    [anon_sym_CARET] = ACTIONS(8837),
    [anon_sym_PLUS] = ACTIONS(8859),
    [anon_sym_SLASH] = ACTIONS(8839),
    [anon_sym_PERCENT] = ACTIONS(8839),
    [sym_comment] = ACTIONS(87),
  },
  [5637] = {
    [sym_string] = STATE(5659),
    [aux_sym_chained_string_repeat1] = STATE(5659),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(747),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5638] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(8833),
    [sym__binary_star] = ACTIONS(8835),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(8837),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(8839),
    [anon_sym_AMP] = ACTIONS(8841),
    [anon_sym_EQ] = ACTIONS(4249),
    [anon_sym_LT] = ACTIONS(8843),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_then] = ACTIONS(4247),
    [anon_sym_EQ_GT] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_PLUS_EQ] = ACTIONS(4247),
    [anon_sym_DASH_EQ] = ACTIONS(4247),
    [anon_sym_STAR_EQ] = ACTIONS(4247),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4247),
    [anon_sym_SLASH_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4247),
    [anon_sym_AMP_EQ] = ACTIONS(4247),
    [anon_sym_PERCENT_EQ] = ACTIONS(4247),
    [anon_sym_GT_GT_EQ] = ACTIONS(4247),
    [anon_sym_LT_LT_EQ] = ACTIONS(4247),
    [anon_sym_CARET_EQ] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(8845),
    [anon_sym_DOT_DOT] = ACTIONS(8847),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8849),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(8851),
    [anon_sym_AMP_AMP] = ACTIONS(8851),
    [anon_sym_LT_LT] = ACTIONS(8853),
    [anon_sym_GT_GT] = ACTIONS(8853),
    [anon_sym_EQ_EQ] = ACTIONS(8851),
    [anon_sym_BANG_EQ] = ACTIONS(8855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8855),
    [anon_sym_LT_EQ_GT] = ACTIONS(8855),
    [anon_sym_EQ_TILDE] = ACTIONS(8855),
    [anon_sym_BANG_TILDE] = ACTIONS(8855),
    [anon_sym_LT_EQ] = ACTIONS(8843),
    [anon_sym_GT] = ACTIONS(8843),
    [anon_sym_GT_EQ] = ACTIONS(8857),
    [anon_sym_CARET] = ACTIONS(8837),
    [anon_sym_PLUS] = ACTIONS(8859),
    [anon_sym_SLASH] = ACTIONS(8839),
    [anon_sym_PERCENT] = ACTIONS(8839),
    [sym_comment] = ACTIONS(87),
  },
  [5639] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8839),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [5640] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8078),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3096),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(3096),
    [sym_assignment] = STATE(8078),
    [sym_operator_assignment] = STATE(8078),
    [sym_conditional] = STATE(8078),
    [sym_range] = STATE(8078),
    [sym_binary] = STATE(8078),
    [sym_unary] = STATE(8078),
    [sym_left_assignment_list] = STATE(3095),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3096),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3096),
    [sym_false] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5637),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5149),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5153),
    [anon_sym_yield] = ACTIONS(5155),
    [anon_sym_break] = ACTIONS(5157),
    [anon_sym_next] = ACTIONS(5159),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(8827),
    [anon_sym_defined_QMARK] = ACTIONS(5161),
    [anon_sym_not] = ACTIONS(5163),
    [anon_sym_BANG] = ACTIONS(5167),
    [anon_sym_TILDE] = ACTIONS(5167),
    [sym_constant] = ACTIONS(5173),
    [sym_identifier] = ACTIONS(5173),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5641] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(8833),
    [sym__binary_star] = ACTIONS(8835),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(8837),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(8839),
    [anon_sym_AMP] = ACTIONS(8841),
    [anon_sym_EQ] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(8843),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_then] = ACTIONS(3281),
    [anon_sym_EQ_GT] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_PLUS_EQ] = ACTIONS(3281),
    [anon_sym_DASH_EQ] = ACTIONS(3281),
    [anon_sym_STAR_EQ] = ACTIONS(3281),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3281),
    [anon_sym_SLASH_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3281),
    [anon_sym_AMP_EQ] = ACTIONS(3281),
    [anon_sym_PERCENT_EQ] = ACTIONS(3281),
    [anon_sym_GT_GT_EQ] = ACTIONS(3281),
    [anon_sym_LT_LT_EQ] = ACTIONS(3281),
    [anon_sym_CARET_EQ] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(8845),
    [anon_sym_DOT_DOT] = ACTIONS(8847),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8849),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(8851),
    [anon_sym_AMP_AMP] = ACTIONS(8851),
    [anon_sym_LT_LT] = ACTIONS(8853),
    [anon_sym_GT_GT] = ACTIONS(8853),
    [anon_sym_EQ_EQ] = ACTIONS(8851),
    [anon_sym_BANG_EQ] = ACTIONS(8855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8855),
    [anon_sym_LT_EQ_GT] = ACTIONS(8855),
    [anon_sym_EQ_TILDE] = ACTIONS(8855),
    [anon_sym_BANG_TILDE] = ACTIONS(8855),
    [anon_sym_LT_EQ] = ACTIONS(8843),
    [anon_sym_GT] = ACTIONS(8843),
    [anon_sym_GT_EQ] = ACTIONS(8857),
    [anon_sym_CARET] = ACTIONS(8837),
    [anon_sym_PLUS] = ACTIONS(8859),
    [anon_sym_SLASH] = ACTIONS(8839),
    [anon_sym_PERCENT] = ACTIONS(8839),
    [sym_comment] = ACTIONS(87),
  },
  [5642] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(8833),
    [sym__binary_star] = ACTIONS(8835),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(8837),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8839),
    [anon_sym_AMP] = ACTIONS(8841),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(8843),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(8845),
    [anon_sym_DOT_DOT] = ACTIONS(8847),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8849),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(8851),
    [anon_sym_AMP_AMP] = ACTIONS(8851),
    [anon_sym_LT_LT] = ACTIONS(8853),
    [anon_sym_GT_GT] = ACTIONS(8853),
    [anon_sym_EQ_EQ] = ACTIONS(8851),
    [anon_sym_BANG_EQ] = ACTIONS(8855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8855),
    [anon_sym_LT_EQ_GT] = ACTIONS(8855),
    [anon_sym_EQ_TILDE] = ACTIONS(8855),
    [anon_sym_BANG_TILDE] = ACTIONS(8855),
    [anon_sym_LT_EQ] = ACTIONS(8843),
    [anon_sym_GT] = ACTIONS(8843),
    [anon_sym_GT_EQ] = ACTIONS(8857),
    [anon_sym_CARET] = ACTIONS(8837),
    [anon_sym_PLUS] = ACTIONS(8859),
    [anon_sym_SLASH] = ACTIONS(8839),
    [anon_sym_PERCENT] = ACTIONS(8839),
    [sym_comment] = ACTIONS(87),
  },
  [5643] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8079),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3096),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(3096),
    [sym_assignment] = STATE(8079),
    [sym_operator_assignment] = STATE(8079),
    [sym_conditional] = STATE(8079),
    [sym_range] = STATE(8079),
    [sym_binary] = STATE(8079),
    [sym_unary] = STATE(8079),
    [sym_left_assignment_list] = STATE(3095),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3096),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3096),
    [sym_false] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5637),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5149),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5153),
    [anon_sym_yield] = ACTIONS(5155),
    [anon_sym_break] = ACTIONS(5157),
    [anon_sym_next] = ACTIONS(5159),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(8827),
    [anon_sym_defined_QMARK] = ACTIONS(5161),
    [anon_sym_not] = ACTIONS(5163),
    [anon_sym_BANG] = ACTIONS(5167),
    [anon_sym_TILDE] = ACTIONS(5167),
    [sym_constant] = ACTIONS(5173),
    [sym_identifier] = ACTIONS(5173),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5644] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8080),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3096),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(3096),
    [sym_assignment] = STATE(8080),
    [sym_operator_assignment] = STATE(8080),
    [sym_conditional] = STATE(8080),
    [sym_range] = STATE(8080),
    [sym_binary] = STATE(8080),
    [sym_unary] = STATE(8080),
    [sym_left_assignment_list] = STATE(3095),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3096),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3096),
    [sym_false] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5637),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5149),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5153),
    [anon_sym_yield] = ACTIONS(5155),
    [anon_sym_break] = ACTIONS(5157),
    [anon_sym_next] = ACTIONS(5159),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(8827),
    [anon_sym_defined_QMARK] = ACTIONS(5161),
    [anon_sym_not] = ACTIONS(5163),
    [anon_sym_BANG] = ACTIONS(5167),
    [anon_sym_TILDE] = ACTIONS(5167),
    [sym_constant] = ACTIONS(5173),
    [sym_identifier] = ACTIONS(5173),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5645] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8081),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3096),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(3096),
    [sym_assignment] = STATE(8081),
    [sym_operator_assignment] = STATE(8081),
    [sym_conditional] = STATE(8081),
    [sym_range] = STATE(8081),
    [sym_binary] = STATE(8081),
    [sym_unary] = STATE(8081),
    [sym_left_assignment_list] = STATE(3095),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3096),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3096),
    [sym_false] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5637),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5149),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5153),
    [anon_sym_yield] = ACTIONS(5155),
    [anon_sym_break] = ACTIONS(5157),
    [anon_sym_next] = ACTIONS(5159),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(8827),
    [anon_sym_defined_QMARK] = ACTIONS(5161),
    [anon_sym_not] = ACTIONS(5163),
    [anon_sym_BANG] = ACTIONS(5167),
    [anon_sym_TILDE] = ACTIONS(5167),
    [sym_constant] = ACTIONS(5173),
    [sym_identifier] = ACTIONS(5173),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5646] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8082),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3096),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(3096),
    [sym_assignment] = STATE(8082),
    [sym_operator_assignment] = STATE(8082),
    [sym_conditional] = STATE(8082),
    [sym_range] = STATE(8082),
    [sym_binary] = STATE(8082),
    [sym_unary] = STATE(8082),
    [sym_left_assignment_list] = STATE(3095),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3096),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3096),
    [sym_false] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5637),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5149),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5153),
    [anon_sym_yield] = ACTIONS(5155),
    [anon_sym_break] = ACTIONS(5157),
    [anon_sym_next] = ACTIONS(5159),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(8827),
    [anon_sym_defined_QMARK] = ACTIONS(5161),
    [anon_sym_not] = ACTIONS(5163),
    [anon_sym_BANG] = ACTIONS(5167),
    [anon_sym_TILDE] = ACTIONS(5167),
    [sym_constant] = ACTIONS(5173),
    [sym_identifier] = ACTIONS(5173),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5647] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8083),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3096),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(3096),
    [sym_assignment] = STATE(8083),
    [sym_operator_assignment] = STATE(8083),
    [sym_conditional] = STATE(8083),
    [sym_range] = STATE(8083),
    [sym_binary] = STATE(8083),
    [sym_unary] = STATE(8083),
    [sym_left_assignment_list] = STATE(3095),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3096),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3096),
    [sym_false] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5637),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5149),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5153),
    [anon_sym_yield] = ACTIONS(5155),
    [anon_sym_break] = ACTIONS(5157),
    [anon_sym_next] = ACTIONS(5159),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(8827),
    [anon_sym_defined_QMARK] = ACTIONS(5161),
    [anon_sym_not] = ACTIONS(5163),
    [anon_sym_BANG] = ACTIONS(5167),
    [anon_sym_TILDE] = ACTIONS(5167),
    [sym_constant] = ACTIONS(5173),
    [sym_identifier] = ACTIONS(5173),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5648] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8084),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3096),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(3096),
    [sym_assignment] = STATE(8084),
    [sym_operator_assignment] = STATE(8084),
    [sym_conditional] = STATE(8084),
    [sym_range] = STATE(8084),
    [sym_binary] = STATE(8084),
    [sym_unary] = STATE(8084),
    [sym_left_assignment_list] = STATE(3095),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3096),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3096),
    [sym_false] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5637),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5149),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5153),
    [anon_sym_yield] = ACTIONS(5155),
    [anon_sym_break] = ACTIONS(5157),
    [anon_sym_next] = ACTIONS(5159),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(8827),
    [anon_sym_defined_QMARK] = ACTIONS(5161),
    [anon_sym_not] = ACTIONS(5163),
    [anon_sym_BANG] = ACTIONS(5167),
    [anon_sym_TILDE] = ACTIONS(5167),
    [sym_constant] = ACTIONS(5173),
    [sym_identifier] = ACTIONS(5173),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5649] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(8085),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(8085),
    [sym_operator_assignment] = STATE(8085),
    [sym_conditional] = STATE(8085),
    [sym_range] = STATE(8085),
    [sym_binary] = STATE(8085),
    [sym_unary] = STATE(8085),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5650] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8086),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3096),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(3096),
    [sym_assignment] = STATE(8086),
    [sym_operator_assignment] = STATE(8086),
    [sym_conditional] = STATE(8086),
    [sym_range] = STATE(8086),
    [sym_binary] = STATE(8086),
    [sym_unary] = STATE(8086),
    [sym_left_assignment_list] = STATE(3095),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3096),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3096),
    [sym_false] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5637),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5149),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5153),
    [anon_sym_yield] = ACTIONS(5155),
    [anon_sym_break] = ACTIONS(5157),
    [anon_sym_next] = ACTIONS(5159),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(8827),
    [anon_sym_defined_QMARK] = ACTIONS(5161),
    [anon_sym_not] = ACTIONS(5163),
    [anon_sym_BANG] = ACTIONS(5167),
    [anon_sym_TILDE] = ACTIONS(5167),
    [sym_constant] = ACTIONS(5173),
    [sym_identifier] = ACTIONS(5173),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5651] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8087),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3096),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(3096),
    [sym_assignment] = STATE(8087),
    [sym_operator_assignment] = STATE(8087),
    [sym_conditional] = STATE(8087),
    [sym_range] = STATE(8087),
    [sym_binary] = STATE(8087),
    [sym_unary] = STATE(8087),
    [sym_left_assignment_list] = STATE(3095),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3096),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3096),
    [sym_false] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5637),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5149),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5153),
    [anon_sym_yield] = ACTIONS(5155),
    [anon_sym_break] = ACTIONS(5157),
    [anon_sym_next] = ACTIONS(5159),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(8827),
    [anon_sym_defined_QMARK] = ACTIONS(5161),
    [anon_sym_not] = ACTIONS(5163),
    [anon_sym_BANG] = ACTIONS(5167),
    [anon_sym_TILDE] = ACTIONS(5167),
    [sym_constant] = ACTIONS(5173),
    [sym_identifier] = ACTIONS(5173),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5652] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8088),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3096),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(3096),
    [sym_assignment] = STATE(8088),
    [sym_operator_assignment] = STATE(8088),
    [sym_conditional] = STATE(8088),
    [sym_range] = STATE(8088),
    [sym_binary] = STATE(8088),
    [sym_unary] = STATE(8088),
    [sym_left_assignment_list] = STATE(3095),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3096),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3096),
    [sym_false] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5637),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5149),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5153),
    [anon_sym_yield] = ACTIONS(5155),
    [anon_sym_break] = ACTIONS(5157),
    [anon_sym_next] = ACTIONS(5159),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(8827),
    [anon_sym_defined_QMARK] = ACTIONS(5161),
    [anon_sym_not] = ACTIONS(5163),
    [anon_sym_BANG] = ACTIONS(5167),
    [anon_sym_TILDE] = ACTIONS(5167),
    [sym_constant] = ACTIONS(5173),
    [sym_identifier] = ACTIONS(5173),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5653] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8089),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3096),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(3096),
    [sym_assignment] = STATE(8089),
    [sym_operator_assignment] = STATE(8089),
    [sym_conditional] = STATE(8089),
    [sym_range] = STATE(8089),
    [sym_binary] = STATE(8089),
    [sym_unary] = STATE(8089),
    [sym_left_assignment_list] = STATE(3095),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3096),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3096),
    [sym_false] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5637),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5149),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5153),
    [anon_sym_yield] = ACTIONS(5155),
    [anon_sym_break] = ACTIONS(5157),
    [anon_sym_next] = ACTIONS(5159),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(8827),
    [anon_sym_defined_QMARK] = ACTIONS(5161),
    [anon_sym_not] = ACTIONS(5163),
    [anon_sym_BANG] = ACTIONS(5167),
    [anon_sym_TILDE] = ACTIONS(5167),
    [sym_constant] = ACTIONS(5173),
    [sym_identifier] = ACTIONS(5173),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5654] = {
    [sym_heredoc_body] = STATE(8090),
    [aux_sym_call_repeat1] = STATE(8090),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_then] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [5655] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3091),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3096),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(3096),
    [sym__argument] = STATE(4979),
    [sym_splat_argument] = STATE(4979),
    [sym_hash_splat_argument] = STATE(4979),
    [sym_block_argument] = STATE(4979),
    [sym_assignment] = STATE(3091),
    [sym_operator_assignment] = STATE(3091),
    [sym_conditional] = STATE(3091),
    [sym_range] = STATE(3091),
    [sym_binary] = STATE(3091),
    [sym_unary] = STATE(3091),
    [sym_left_assignment_list] = STATE(3095),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3096),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3096),
    [sym_false] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3097),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_heredoc_body] = STATE(8091),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(4979),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(5145),
    [sym__splat_star] = ACTIONS(5147),
    [sym__unary_minus] = ACTIONS(5149),
    [sym__identifier_hash_key] = ACTIONS(5151),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11595),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5153),
    [anon_sym_yield] = ACTIONS(5155),
    [anon_sym_break] = ACTIONS(5157),
    [anon_sym_next] = ACTIONS(5159),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(8827),
    [anon_sym_defined_QMARK] = ACTIONS(5161),
    [anon_sym_not] = ACTIONS(5163),
    [anon_sym_BANG] = ACTIONS(5167),
    [anon_sym_TILDE] = ACTIONS(5167),
    [sym_constant] = ACTIONS(5169),
    [sym_identifier] = ACTIONS(5169),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5656] = {
    [sym_heredoc_body] = STATE(8092),
    [aux_sym_call_repeat1] = STATE(8092),
    [aux_sym_argument_list_repeat1] = STATE(8093),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(8861),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_then] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [5657] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8094),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3096),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(3096),
    [sym_splat_argument] = STATE(8095),
    [sym_assignment] = STATE(8094),
    [sym_operator_assignment] = STATE(8094),
    [sym_conditional] = STATE(8094),
    [sym_range] = STATE(8094),
    [sym_binary] = STATE(8094),
    [sym_unary] = STATE(8094),
    [sym_right_assignment_list] = STATE(3742),
    [sym__arg_or_splat_arg] = STATE(8095),
    [sym_left_assignment_list] = STATE(3095),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3096),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3096),
    [sym_false] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5637),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__splat_star] = ACTIONS(5147),
    [sym__unary_minus] = ACTIONS(5149),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5153),
    [anon_sym_yield] = ACTIONS(5155),
    [anon_sym_break] = ACTIONS(5157),
    [anon_sym_next] = ACTIONS(5159),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(8827),
    [anon_sym_defined_QMARK] = ACTIONS(5161),
    [anon_sym_not] = ACTIONS(5163),
    [anon_sym_BANG] = ACTIONS(5167),
    [anon_sym_TILDE] = ACTIONS(5167),
    [sym_constant] = ACTIONS(5173),
    [sym_identifier] = ACTIONS(5173),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5658] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8096),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3096),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(3096),
    [sym_assignment] = STATE(8096),
    [sym_operator_assignment] = STATE(8096),
    [sym_conditional] = STATE(8096),
    [sym_range] = STATE(8096),
    [sym_binary] = STATE(8096),
    [sym_unary] = STATE(8096),
    [sym_left_assignment_list] = STATE(3095),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3096),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3096),
    [sym_false] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5637),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5149),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5153),
    [anon_sym_yield] = ACTIONS(5155),
    [anon_sym_break] = ACTIONS(5157),
    [anon_sym_next] = ACTIONS(5159),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(8827),
    [anon_sym_defined_QMARK] = ACTIONS(5161),
    [anon_sym_not] = ACTIONS(5163),
    [anon_sym_BANG] = ACTIONS(5167),
    [anon_sym_TILDE] = ACTIONS(5167),
    [sym_constant] = ACTIONS(5173),
    [sym_identifier] = ACTIONS(5173),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5659] = {
    [sym_string] = STATE(8097),
    [aux_sym_chained_string_repeat1] = STATE(8097),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(747),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2755),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_EQ] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_then] = ACTIONS(2753),
    [anon_sym_EQ_GT] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_PLUS_EQ] = ACTIONS(2753),
    [anon_sym_DASH_EQ] = ACTIONS(2753),
    [anon_sym_STAR_EQ] = ACTIONS(2753),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2753),
    [anon_sym_SLASH_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2753),
    [anon_sym_AMP_EQ] = ACTIONS(2753),
    [anon_sym_PERCENT_EQ] = ACTIONS(2753),
    [anon_sym_GT_GT_EQ] = ACTIONS(2753),
    [anon_sym_LT_LT_EQ] = ACTIONS(2753),
    [anon_sym_CARET_EQ] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2755),
    [anon_sym_AMP_AMP] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2755),
    [anon_sym_GT_GT] = ACTIONS(2755),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_SLASH] = ACTIONS(2755),
    [anon_sym_PERCENT] = ACTIONS(2755),
    [sym_comment] = ACTIONS(87),
  },
  [5660] = {
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [anon_sym_COMMA] = ACTIONS(11597),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_then] = ACTIONS(11597),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [5661] = {
    [aux_sym_exceptions_repeat1] = STATE(5661),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [anon_sym_COMMA] = ACTIONS(11599),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_then] = ACTIONS(11597),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [5662] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8098),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1175),
    [sym_scope_resolution] = STATE(1172),
    [sym_call] = STATE(1172),
    [sym_method_call] = STATE(1175),
    [sym_assignment] = STATE(8098),
    [sym_operator_assignment] = STATE(8098),
    [sym_conditional] = STATE(8098),
    [sym_range] = STATE(8098),
    [sym_binary] = STATE(8098),
    [sym_unary] = STATE(8098),
    [sym_left_assignment_list] = STATE(1174),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1175),
    [sym__variable] = STATE(1172),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1175),
    [sym_false] = STATE(1175),
    [sym_nil] = STATE(1175),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1176),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2081),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2085),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_next] = ACTIONS(2089),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2095),
    [anon_sym_defined_QMARK] = ACTIONS(2097),
    [anon_sym_not] = ACTIONS(2099),
    [anon_sym_BANG] = ACTIONS(2101),
    [anon_sym_TILDE] = ACTIONS(2101),
    [sym_constant] = ACTIONS(2103),
    [sym_identifier] = ACTIONS(2103),
    [sym_instance_variable] = ACTIONS(2105),
    [sym_class_variable] = ACTIONS(2105),
    [sym_global_variable] = ACTIONS(2105),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2103),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2103),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5663] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(5117),
    [sym__binary_star] = ACTIONS(5119),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(5121),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(5119),
    [anon_sym_AMP] = ACTIONS(5123),
    [anon_sym_LT] = ACTIONS(5125),
    [anon_sym_then] = ACTIONS(5115),
    [anon_sym_EQ_GT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(5127),
    [anon_sym_DOT_DOT] = ACTIONS(5129),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5131),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(5135),
    [anon_sym_AMP_AMP] = ACTIONS(5135),
    [anon_sym_LT_LT] = ACTIONS(5137),
    [anon_sym_GT_GT] = ACTIONS(5137),
    [anon_sym_EQ_EQ] = ACTIONS(5139),
    [anon_sym_BANG_EQ] = ACTIONS(5135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5135),
    [anon_sym_LT_EQ_GT] = ACTIONS(5135),
    [anon_sym_EQ_TILDE] = ACTIONS(5135),
    [anon_sym_BANG_TILDE] = ACTIONS(5135),
    [anon_sym_LT_EQ] = ACTIONS(5125),
    [anon_sym_GT] = ACTIONS(5125),
    [anon_sym_GT_EQ] = ACTIONS(5141),
    [anon_sym_CARET] = ACTIONS(5143),
    [anon_sym_PLUS] = ACTIONS(5117),
    [anon_sym_SLASH] = ACTIONS(5119),
    [anon_sym_PERCENT] = ACTIONS(5119),
    [sym_comment] = ACTIONS(87),
  },
  [5664] = {
    [aux_sym_exceptions_repeat1] = STATE(8100),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_then] = ACTIONS(6191),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [5665] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(5117),
    [sym__binary_star] = ACTIONS(5119),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(5121),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(5119),
    [anon_sym_AMP] = ACTIONS(5123),
    [anon_sym_LT] = ACTIONS(5125),
    [anon_sym_then] = ACTIONS(6210),
    [anon_sym_EQ_GT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(5127),
    [anon_sym_DOT_DOT] = ACTIONS(5129),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5131),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(5135),
    [anon_sym_AMP_AMP] = ACTIONS(5135),
    [anon_sym_LT_LT] = ACTIONS(5137),
    [anon_sym_GT_GT] = ACTIONS(5137),
    [anon_sym_EQ_EQ] = ACTIONS(5139),
    [anon_sym_BANG_EQ] = ACTIONS(5135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5135),
    [anon_sym_LT_EQ_GT] = ACTIONS(5135),
    [anon_sym_EQ_TILDE] = ACTIONS(5135),
    [anon_sym_BANG_TILDE] = ACTIONS(5135),
    [anon_sym_LT_EQ] = ACTIONS(5125),
    [anon_sym_GT] = ACTIONS(5125),
    [anon_sym_GT_EQ] = ACTIONS(5141),
    [anon_sym_CARET] = ACTIONS(5143),
    [anon_sym_PLUS] = ACTIONS(5117),
    [anon_sym_SLASH] = ACTIONS(5119),
    [anon_sym_PERCENT] = ACTIONS(5119),
    [sym_comment] = ACTIONS(87),
  },
  [5666] = {
    [sym_string] = STATE(5666),
    [aux_sym_chained_string_repeat1] = STATE(5666),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(6214),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_then] = ACTIONS(6212),
    [anon_sym_EQ_GT] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [5667] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8101),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5676),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(5676),
    [sym_assignment] = STATE(8101),
    [sym_operator_assignment] = STATE(8101),
    [sym_conditional] = STATE(8101),
    [sym_range] = STATE(8101),
    [sym_binary] = STATE(8101),
    [sym_unary] = STATE(8101),
    [sym_left_assignment_list] = STATE(5675),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5676),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5676),
    [sym_false] = STATE(5676),
    [sym_nil] = STATE(5676),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5677),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8875),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8877),
    [anon_sym_yield] = ACTIONS(8879),
    [anon_sym_break] = ACTIONS(8881),
    [anon_sym_next] = ACTIONS(8883),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8885),
    [anon_sym_defined_QMARK] = ACTIONS(8887),
    [anon_sym_not] = ACTIONS(8889),
    [anon_sym_BANG] = ACTIONS(8891),
    [anon_sym_TILDE] = ACTIONS(8891),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5668] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3117),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(3118),
    [sym_call] = STATE(3118),
    [sym_method_call] = STATE(3122),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(8102),
    [sym__argument] = STATE(8103),
    [sym_splat_argument] = STATE(8103),
    [sym_hash_splat_argument] = STATE(8103),
    [sym_block_argument] = STATE(8103),
    [sym_assignment] = STATE(3117),
    [sym_operator_assignment] = STATE(3117),
    [sym_conditional] = STATE(3117),
    [sym_range] = STATE(3117),
    [sym_binary] = STATE(3117),
    [sym_unary] = STATE(3117),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(3118),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3123),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(8103),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(5189),
    [sym__splat_star] = ACTIONS(5191),
    [sym__unary_minus] = ACTIONS(5193),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(5195),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(5197),
    [anon_sym_yield] = ACTIONS(5199),
    [anon_sym_break] = ACTIONS(5201),
    [anon_sym_next] = ACTIONS(5203),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(377),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(5205),
    [anon_sym_not] = ACTIONS(5207),
    [anon_sym_BANG] = ACTIONS(5209),
    [anon_sym_TILDE] = ACTIONS(5211),
    [sym_constant] = ACTIONS(5213),
    [sym_identifier] = ACTIONS(5213),
    [sym_instance_variable] = ACTIONS(5215),
    [sym_class_variable] = ACTIONS(5215),
    [sym_global_variable] = ACTIONS(5215),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5217),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5217),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5669] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3117),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(3118),
    [sym_call] = STATE(3118),
    [sym_method_call] = STATE(3122),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(8102),
    [sym__argument] = STATE(8103),
    [sym_splat_argument] = STATE(8103),
    [sym_hash_splat_argument] = STATE(8103),
    [sym_block_argument] = STATE(8103),
    [sym_assignment] = STATE(3117),
    [sym_operator_assignment] = STATE(3117),
    [sym_conditional] = STATE(3117),
    [sym_range] = STATE(3117),
    [sym_binary] = STATE(3117),
    [sym_unary] = STATE(3117),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(3118),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3123),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(8103),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(5189),
    [sym__splat_star] = ACTIONS(5191),
    [sym__unary_minus] = ACTIONS(5193),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(5195),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(5197),
    [anon_sym_yield] = ACTIONS(5199),
    [anon_sym_break] = ACTIONS(5201),
    [anon_sym_next] = ACTIONS(5203),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(5205),
    [anon_sym_not] = ACTIONS(5207),
    [anon_sym_BANG] = ACTIONS(5209),
    [anon_sym_TILDE] = ACTIONS(5211),
    [sym_constant] = ACTIONS(5213),
    [sym_identifier] = ACTIONS(5213),
    [sym_instance_variable] = ACTIONS(5215),
    [sym_class_variable] = ACTIONS(5215),
    [sym_global_variable] = ACTIONS(5215),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5217),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5217),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5670] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3117),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(3118),
    [sym_call] = STATE(3118),
    [sym_method_call] = STATE(3122),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(8102),
    [sym__argument] = STATE(8103),
    [sym_splat_argument] = STATE(8103),
    [sym_hash_splat_argument] = STATE(8103),
    [sym_block_argument] = STATE(8103),
    [sym_assignment] = STATE(3117),
    [sym_operator_assignment] = STATE(3117),
    [sym_conditional] = STATE(3117),
    [sym_range] = STATE(3117),
    [sym_binary] = STATE(3117),
    [sym_unary] = STATE(3117),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(3118),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3123),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(8103),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(5189),
    [sym__splat_star] = ACTIONS(5191),
    [sym__unary_minus] = ACTIONS(5193),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(5195),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(423),
    [anon_sym_return] = ACTIONS(5197),
    [anon_sym_yield] = ACTIONS(5199),
    [anon_sym_break] = ACTIONS(5201),
    [anon_sym_next] = ACTIONS(5203),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(5205),
    [anon_sym_not] = ACTIONS(5207),
    [anon_sym_BANG] = ACTIONS(5209),
    [anon_sym_TILDE] = ACTIONS(5211),
    [sym_constant] = ACTIONS(5213),
    [sym_identifier] = ACTIONS(5213),
    [sym_instance_variable] = ACTIONS(5215),
    [sym_class_variable] = ACTIONS(5215),
    [sym_global_variable] = ACTIONS(5215),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5217),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5217),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5671] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3117),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(3118),
    [sym_call] = STATE(3118),
    [sym_method_call] = STATE(3122),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(8102),
    [sym__argument] = STATE(8103),
    [sym_splat_argument] = STATE(8103),
    [sym_hash_splat_argument] = STATE(8103),
    [sym_block_argument] = STATE(8103),
    [sym_assignment] = STATE(3117),
    [sym_operator_assignment] = STATE(3117),
    [sym_conditional] = STATE(3117),
    [sym_range] = STATE(3117),
    [sym_binary] = STATE(3117),
    [sym_unary] = STATE(3117),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(3118),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3123),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(8103),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(5189),
    [sym__splat_star] = ACTIONS(5191),
    [sym__unary_minus] = ACTIONS(5193),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(5195),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(427),
    [anon_sym_return] = ACTIONS(5197),
    [anon_sym_yield] = ACTIONS(5199),
    [anon_sym_break] = ACTIONS(5201),
    [anon_sym_next] = ACTIONS(5203),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(5205),
    [anon_sym_not] = ACTIONS(5207),
    [anon_sym_BANG] = ACTIONS(5209),
    [anon_sym_TILDE] = ACTIONS(5211),
    [sym_constant] = ACTIONS(5213),
    [sym_identifier] = ACTIONS(5213),
    [sym_instance_variable] = ACTIONS(5215),
    [sym_class_variable] = ACTIONS(5215),
    [sym_global_variable] = ACTIONS(5215),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5217),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5217),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5672] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8104),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5676),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(5676),
    [sym_assignment] = STATE(8104),
    [sym_operator_assignment] = STATE(8104),
    [sym_conditional] = STATE(8104),
    [sym_range] = STATE(8104),
    [sym_binary] = STATE(8104),
    [sym_unary] = STATE(8104),
    [sym_left_assignment_list] = STATE(5675),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5676),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5676),
    [sym_false] = STATE(5676),
    [sym_nil] = STATE(5676),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5677),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8875),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8877),
    [anon_sym_yield] = ACTIONS(8879),
    [anon_sym_break] = ACTIONS(8881),
    [anon_sym_next] = ACTIONS(8883),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8885),
    [anon_sym_defined_QMARK] = ACTIONS(8887),
    [anon_sym_not] = ACTIONS(8889),
    [anon_sym_BANG] = ACTIONS(8891),
    [anon_sym_TILDE] = ACTIONS(8891),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5673] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5676),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(5676),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(5675),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5676),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5676),
    [sym_false] = STATE(5676),
    [sym_nil] = STATE(5676),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5677),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8875),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8877),
    [anon_sym_yield] = ACTIONS(8879),
    [anon_sym_break] = ACTIONS(8881),
    [anon_sym_next] = ACTIONS(8883),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8885),
    [anon_sym_defined_QMARK] = ACTIONS(8887),
    [anon_sym_not] = ACTIONS(8889),
    [anon_sym_BANG] = ACTIONS(8891),
    [anon_sym_TILDE] = ACTIONS(8891),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5674] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(11602),
    [sym__binary_star] = ACTIONS(11604),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(11606),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(11604),
    [anon_sym_AMP] = ACTIONS(11608),
    [anon_sym_LT] = ACTIONS(11610),
    [anon_sym_end] = ACTIONS(4211),
    [anon_sym_if] = ACTIONS(4211),
    [anon_sym_unless] = ACTIONS(4211),
    [anon_sym_while] = ACTIONS(4211),
    [anon_sym_until] = ACTIONS(4211),
    [anon_sym_rescue] = ACTIONS(4211),
    [anon_sym_ensure] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(11612),
    [anon_sym_DOT_DOT] = ACTIONS(11614),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11616),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11618),
    [anon_sym_AMP_AMP] = ACTIONS(11618),
    [anon_sym_LT_LT] = ACTIONS(11620),
    [anon_sym_GT_GT] = ACTIONS(11620),
    [anon_sym_EQ_EQ] = ACTIONS(11622),
    [anon_sym_BANG_EQ] = ACTIONS(11618),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11618),
    [anon_sym_LT_EQ_GT] = ACTIONS(11618),
    [anon_sym_EQ_TILDE] = ACTIONS(11618),
    [anon_sym_BANG_TILDE] = ACTIONS(11618),
    [anon_sym_LT_EQ] = ACTIONS(11610),
    [anon_sym_GT] = ACTIONS(11610),
    [anon_sym_GT_EQ] = ACTIONS(11624),
    [anon_sym_CARET] = ACTIONS(11626),
    [anon_sym_PLUS] = ACTIONS(11602),
    [anon_sym_SLASH] = ACTIONS(11604),
    [anon_sym_PERCENT] = ACTIONS(11604),
    [sym_comment] = ACTIONS(87),
  },
  [5675] = {
    [anon_sym_EQ] = ACTIONS(11628),
    [sym_comment] = ACTIONS(87),
  },
  [5676] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(11630),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(11632),
    [anon_sym_DASH_EQ] = ACTIONS(11632),
    [anon_sym_STAR_EQ] = ACTIONS(11632),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11632),
    [anon_sym_SLASH_EQ] = ACTIONS(11632),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11632),
    [anon_sym_PIPE_EQ] = ACTIONS(11632),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11632),
    [anon_sym_AMP_EQ] = ACTIONS(11632),
    [anon_sym_PERCENT_EQ] = ACTIONS(11632),
    [anon_sym_GT_GT_EQ] = ACTIONS(11632),
    [anon_sym_LT_LT_EQ] = ACTIONS(11632),
    [anon_sym_CARET_EQ] = ACTIONS(11632),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5677] = {
    [sym_string] = STATE(8117),
    [aux_sym_chained_string_repeat1] = STATE(8117),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [5678] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(11602),
    [sym__binary_star] = ACTIONS(11604),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(11606),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(11604),
    [anon_sym_AMP] = ACTIONS(11608),
    [anon_sym_LT] = ACTIONS(11610),
    [anon_sym_end] = ACTIONS(4247),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_ensure] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(11612),
    [anon_sym_DOT_DOT] = ACTIONS(11614),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11616),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(11618),
    [anon_sym_AMP_AMP] = ACTIONS(11618),
    [anon_sym_LT_LT] = ACTIONS(11620),
    [anon_sym_GT_GT] = ACTIONS(11620),
    [anon_sym_EQ_EQ] = ACTIONS(11622),
    [anon_sym_BANG_EQ] = ACTIONS(11618),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11618),
    [anon_sym_LT_EQ_GT] = ACTIONS(11618),
    [anon_sym_EQ_TILDE] = ACTIONS(11618),
    [anon_sym_BANG_TILDE] = ACTIONS(11618),
    [anon_sym_LT_EQ] = ACTIONS(11610),
    [anon_sym_GT] = ACTIONS(11610),
    [anon_sym_GT_EQ] = ACTIONS(11624),
    [anon_sym_CARET] = ACTIONS(11626),
    [anon_sym_PLUS] = ACTIONS(11602),
    [anon_sym_SLASH] = ACTIONS(11604),
    [anon_sym_PERCENT] = ACTIONS(11604),
    [sym_comment] = ACTIONS(87),
  },
  [5679] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8909),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_ensure] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [5680] = {
    [sym_string] = STATE(5718),
    [aux_sym_chained_string_repeat1] = STATE(5718),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [5681] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8118),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5676),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(5676),
    [sym_assignment] = STATE(8118),
    [sym_operator_assignment] = STATE(8118),
    [sym_conditional] = STATE(8118),
    [sym_range] = STATE(8118),
    [sym_binary] = STATE(8118),
    [sym_unary] = STATE(8118),
    [sym_left_assignment_list] = STATE(5675),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5676),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5676),
    [sym_false] = STATE(5676),
    [sym_nil] = STATE(5676),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5677),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8875),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8877),
    [anon_sym_yield] = ACTIONS(8879),
    [anon_sym_break] = ACTIONS(8881),
    [anon_sym_next] = ACTIONS(8883),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8885),
    [anon_sym_defined_QMARK] = ACTIONS(8887),
    [anon_sym_not] = ACTIONS(8889),
    [anon_sym_BANG] = ACTIONS(8891),
    [anon_sym_TILDE] = ACTIONS(8891),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5682] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(11602),
    [sym__binary_star] = ACTIONS(11604),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(11606),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(11604),
    [anon_sym_AMP] = ACTIONS(11608),
    [anon_sym_LT] = ACTIONS(11610),
    [anon_sym_end] = ACTIONS(3281),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_unless] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_until] = ACTIONS(3281),
    [anon_sym_rescue] = ACTIONS(3281),
    [anon_sym_ensure] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(11612),
    [anon_sym_DOT_DOT] = ACTIONS(11614),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11616),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(11618),
    [anon_sym_AMP_AMP] = ACTIONS(11618),
    [anon_sym_LT_LT] = ACTIONS(11620),
    [anon_sym_GT_GT] = ACTIONS(11620),
    [anon_sym_EQ_EQ] = ACTIONS(11622),
    [anon_sym_BANG_EQ] = ACTIONS(11618),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11618),
    [anon_sym_LT_EQ_GT] = ACTIONS(11618),
    [anon_sym_EQ_TILDE] = ACTIONS(11618),
    [anon_sym_BANG_TILDE] = ACTIONS(11618),
    [anon_sym_LT_EQ] = ACTIONS(11610),
    [anon_sym_GT] = ACTIONS(11610),
    [anon_sym_GT_EQ] = ACTIONS(11624),
    [anon_sym_CARET] = ACTIONS(11626),
    [anon_sym_PLUS] = ACTIONS(11602),
    [anon_sym_SLASH] = ACTIONS(11604),
    [anon_sym_PERCENT] = ACTIONS(11604),
    [sym_comment] = ACTIONS(87),
  },
  [5683] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8119),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(3118),
    [sym_call] = STATE(3118),
    [sym_method_call] = STATE(3122),
    [sym_assignment] = STATE(8119),
    [sym_operator_assignment] = STATE(8119),
    [sym_conditional] = STATE(8119),
    [sym_range] = STATE(8119),
    [sym_binary] = STATE(8119),
    [sym_unary] = STATE(8119),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(3118),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5680),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5193),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5197),
    [anon_sym_yield] = ACTIONS(5199),
    [anon_sym_break] = ACTIONS(5201),
    [anon_sym_next] = ACTIONS(5203),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8893),
    [anon_sym_defined_QMARK] = ACTIONS(5205),
    [anon_sym_not] = ACTIONS(5207),
    [anon_sym_BANG] = ACTIONS(5211),
    [anon_sym_TILDE] = ACTIONS(5211),
    [sym_constant] = ACTIONS(5217),
    [sym_identifier] = ACTIONS(5217),
    [sym_instance_variable] = ACTIONS(5215),
    [sym_class_variable] = ACTIONS(5215),
    [sym_global_variable] = ACTIONS(5215),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5217),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5217),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5684] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8120),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(3118),
    [sym_call] = STATE(3118),
    [sym_method_call] = STATE(3122),
    [sym_assignment] = STATE(8120),
    [sym_operator_assignment] = STATE(8120),
    [sym_conditional] = STATE(8120),
    [sym_range] = STATE(8120),
    [sym_binary] = STATE(8120),
    [sym_unary] = STATE(8120),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(3118),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5680),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5193),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5197),
    [anon_sym_yield] = ACTIONS(5199),
    [anon_sym_break] = ACTIONS(5201),
    [anon_sym_next] = ACTIONS(5203),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8893),
    [anon_sym_defined_QMARK] = ACTIONS(5205),
    [anon_sym_not] = ACTIONS(5207),
    [anon_sym_BANG] = ACTIONS(5211),
    [anon_sym_TILDE] = ACTIONS(5211),
    [sym_constant] = ACTIONS(5217),
    [sym_identifier] = ACTIONS(5217),
    [sym_instance_variable] = ACTIONS(5215),
    [sym_class_variable] = ACTIONS(5215),
    [sym_global_variable] = ACTIONS(5215),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5217),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5217),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5685] = {
    [anon_sym_COLON] = ACTIONS(11634),
    [sym_comment] = ACTIONS(87),
  },
  [5686] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8122),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(3118),
    [sym_call] = STATE(3118),
    [sym_method_call] = STATE(3122),
    [sym_assignment] = STATE(8122),
    [sym_operator_assignment] = STATE(8122),
    [sym_conditional] = STATE(8122),
    [sym_range] = STATE(8122),
    [sym_binary] = STATE(8122),
    [sym_unary] = STATE(8122),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(3118),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5680),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5193),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5197),
    [anon_sym_yield] = ACTIONS(5199),
    [anon_sym_break] = ACTIONS(5201),
    [anon_sym_next] = ACTIONS(5203),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8893),
    [anon_sym_defined_QMARK] = ACTIONS(5205),
    [anon_sym_not] = ACTIONS(5207),
    [anon_sym_BANG] = ACTIONS(5211),
    [anon_sym_TILDE] = ACTIONS(5211),
    [sym_constant] = ACTIONS(5217),
    [sym_identifier] = ACTIONS(5217),
    [sym_instance_variable] = ACTIONS(5215),
    [sym_class_variable] = ACTIONS(5215),
    [sym_global_variable] = ACTIONS(5215),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5217),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5217),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5687] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(11636),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_ensure] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [5688] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(8907),
    [sym__binary_star] = ACTIONS(8909),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(8911),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(8909),
    [anon_sym_AMP] = ACTIONS(8913),
    [anon_sym_LT] = ACTIONS(8915),
    [anon_sym_end] = ACTIONS(1625),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_unless] = ACTIONS(1625),
    [anon_sym_while] = ACTIONS(1625),
    [anon_sym_until] = ACTIONS(1625),
    [anon_sym_rescue] = ACTIONS(1625),
    [anon_sym_ensure] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(1625),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(8917),
    [anon_sym_DOT_DOT] = ACTIONS(8919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8921),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(8923),
    [anon_sym_AMP_AMP] = ACTIONS(8923),
    [anon_sym_LT_LT] = ACTIONS(8925),
    [anon_sym_GT_GT] = ACTIONS(8925),
    [anon_sym_EQ_EQ] = ACTIONS(8927),
    [anon_sym_BANG_EQ] = ACTIONS(8923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8923),
    [anon_sym_LT_EQ_GT] = ACTIONS(8923),
    [anon_sym_EQ_TILDE] = ACTIONS(8923),
    [anon_sym_BANG_TILDE] = ACTIONS(8923),
    [anon_sym_LT_EQ] = ACTIONS(8915),
    [anon_sym_GT] = ACTIONS(8915),
    [anon_sym_GT_EQ] = ACTIONS(8929),
    [anon_sym_CARET] = ACTIONS(8931),
    [anon_sym_PLUS] = ACTIONS(8907),
    [anon_sym_SLASH] = ACTIONS(8909),
    [anon_sym_PERCENT] = ACTIONS(8909),
    [sym_comment] = ACTIONS(87),
  },
  [5689] = {
    [sym_heredoc_body] = STATE(8124),
    [aux_sym_call_repeat1] = STATE(8124),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_ensure] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [5690] = {
    [sym_heredoc_body] = STATE(8124),
    [aux_sym_call_repeat1] = STATE(8124),
    [aux_sym_argument_list_repeat1] = STATE(8126),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(11638),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_ensure] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [5691] = {
    [sym_string] = STATE(5718),
    [aux_sym_chained_string_repeat1] = STATE(5718),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(11640),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [5692] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(8907),
    [sym__binary_star] = ACTIONS(8909),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(8911),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8909),
    [anon_sym_AMP] = ACTIONS(8913),
    [anon_sym_LT] = ACTIONS(8915),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_ensure] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(8917),
    [anon_sym_DOT_DOT] = ACTIONS(8919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8921),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(8923),
    [anon_sym_AMP_AMP] = ACTIONS(8923),
    [anon_sym_LT_LT] = ACTIONS(8925),
    [anon_sym_GT_GT] = ACTIONS(8925),
    [anon_sym_EQ_EQ] = ACTIONS(8927),
    [anon_sym_BANG_EQ] = ACTIONS(8923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8923),
    [anon_sym_LT_EQ_GT] = ACTIONS(8923),
    [anon_sym_EQ_TILDE] = ACTIONS(8923),
    [anon_sym_BANG_TILDE] = ACTIONS(8923),
    [anon_sym_LT_EQ] = ACTIONS(8915),
    [anon_sym_GT] = ACTIONS(8915),
    [anon_sym_GT_EQ] = ACTIONS(8929),
    [anon_sym_CARET] = ACTIONS(8931),
    [anon_sym_PLUS] = ACTIONS(8907),
    [anon_sym_SLASH] = ACTIONS(8909),
    [anon_sym_PERCENT] = ACTIONS(8909),
    [sym_comment] = ACTIONS(87),
  },
  [5693] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8127),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5676),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(5676),
    [sym_assignment] = STATE(8127),
    [sym_operator_assignment] = STATE(8127),
    [sym_conditional] = STATE(8127),
    [sym_range] = STATE(8127),
    [sym_binary] = STATE(8127),
    [sym_unary] = STATE(8127),
    [sym_left_assignment_list] = STATE(5675),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5676),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5676),
    [sym_false] = STATE(5676),
    [sym_nil] = STATE(5676),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5677),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8875),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8877),
    [anon_sym_yield] = ACTIONS(8879),
    [anon_sym_break] = ACTIONS(8881),
    [anon_sym_next] = ACTIONS(8883),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8885),
    [anon_sym_defined_QMARK] = ACTIONS(8887),
    [anon_sym_not] = ACTIONS(8889),
    [anon_sym_BANG] = ACTIONS(8891),
    [anon_sym_TILDE] = ACTIONS(8891),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5694] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8128),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(3118),
    [sym_call] = STATE(3118),
    [sym_method_call] = STATE(3122),
    [sym_assignment] = STATE(8128),
    [sym_operator_assignment] = STATE(8128),
    [sym_conditional] = STATE(8128),
    [sym_range] = STATE(8128),
    [sym_binary] = STATE(8128),
    [sym_unary] = STATE(8128),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(3118),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5680),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5193),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5197),
    [anon_sym_yield] = ACTIONS(5199),
    [anon_sym_break] = ACTIONS(5201),
    [anon_sym_next] = ACTIONS(5203),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8893),
    [anon_sym_defined_QMARK] = ACTIONS(5205),
    [anon_sym_not] = ACTIONS(5207),
    [anon_sym_BANG] = ACTIONS(5211),
    [anon_sym_TILDE] = ACTIONS(5211),
    [sym_constant] = ACTIONS(5217),
    [sym_identifier] = ACTIONS(5217),
    [sym_instance_variable] = ACTIONS(5215),
    [sym_class_variable] = ACTIONS(5215),
    [sym_global_variable] = ACTIONS(5215),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5217),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5217),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5695] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8129),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(3118),
    [sym_call] = STATE(3118),
    [sym_method_call] = STATE(3122),
    [sym_assignment] = STATE(8129),
    [sym_operator_assignment] = STATE(8129),
    [sym_conditional] = STATE(8129),
    [sym_range] = STATE(8129),
    [sym_binary] = STATE(8129),
    [sym_unary] = STATE(8129),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(3118),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5680),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5193),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5197),
    [anon_sym_yield] = ACTIONS(5199),
    [anon_sym_break] = ACTIONS(5201),
    [anon_sym_next] = ACTIONS(5203),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8893),
    [anon_sym_defined_QMARK] = ACTIONS(5205),
    [anon_sym_not] = ACTIONS(5207),
    [anon_sym_BANG] = ACTIONS(5211),
    [anon_sym_TILDE] = ACTIONS(5211),
    [sym_constant] = ACTIONS(5217),
    [sym_identifier] = ACTIONS(5217),
    [sym_instance_variable] = ACTIONS(5215),
    [sym_class_variable] = ACTIONS(5215),
    [sym_global_variable] = ACTIONS(5215),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5217),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5217),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5696] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8130),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(3118),
    [sym_call] = STATE(3118),
    [sym_method_call] = STATE(3122),
    [sym_assignment] = STATE(8130),
    [sym_operator_assignment] = STATE(8130),
    [sym_conditional] = STATE(8130),
    [sym_range] = STATE(8130),
    [sym_binary] = STATE(8130),
    [sym_unary] = STATE(8130),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(3118),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5680),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5193),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5197),
    [anon_sym_yield] = ACTIONS(5199),
    [anon_sym_break] = ACTIONS(5201),
    [anon_sym_next] = ACTIONS(5203),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8893),
    [anon_sym_defined_QMARK] = ACTIONS(5205),
    [anon_sym_not] = ACTIONS(5207),
    [anon_sym_BANG] = ACTIONS(5211),
    [anon_sym_TILDE] = ACTIONS(5211),
    [sym_constant] = ACTIONS(5217),
    [sym_identifier] = ACTIONS(5217),
    [sym_instance_variable] = ACTIONS(5215),
    [sym_class_variable] = ACTIONS(5215),
    [sym_global_variable] = ACTIONS(5215),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5217),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5217),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5697] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8131),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(3118),
    [sym_call] = STATE(3118),
    [sym_method_call] = STATE(3122),
    [sym_assignment] = STATE(8131),
    [sym_operator_assignment] = STATE(8131),
    [sym_conditional] = STATE(8131),
    [sym_range] = STATE(8131),
    [sym_binary] = STATE(8131),
    [sym_unary] = STATE(8131),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(3118),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5680),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5193),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5197),
    [anon_sym_yield] = ACTIONS(5199),
    [anon_sym_break] = ACTIONS(5201),
    [anon_sym_next] = ACTIONS(5203),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8893),
    [anon_sym_defined_QMARK] = ACTIONS(5205),
    [anon_sym_not] = ACTIONS(5207),
    [anon_sym_BANG] = ACTIONS(5211),
    [anon_sym_TILDE] = ACTIONS(5211),
    [sym_constant] = ACTIONS(5217),
    [sym_identifier] = ACTIONS(5217),
    [sym_instance_variable] = ACTIONS(5215),
    [sym_class_variable] = ACTIONS(5215),
    [sym_global_variable] = ACTIONS(5215),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5217),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5217),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5698] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8132),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(3118),
    [sym_call] = STATE(3118),
    [sym_method_call] = STATE(3122),
    [sym_assignment] = STATE(8132),
    [sym_operator_assignment] = STATE(8132),
    [sym_conditional] = STATE(8132),
    [sym_range] = STATE(8132),
    [sym_binary] = STATE(8132),
    [sym_unary] = STATE(8132),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(3118),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5680),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5193),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5197),
    [anon_sym_yield] = ACTIONS(5199),
    [anon_sym_break] = ACTIONS(5201),
    [anon_sym_next] = ACTIONS(5203),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8893),
    [anon_sym_defined_QMARK] = ACTIONS(5205),
    [anon_sym_not] = ACTIONS(5207),
    [anon_sym_BANG] = ACTIONS(5211),
    [anon_sym_TILDE] = ACTIONS(5211),
    [sym_constant] = ACTIONS(5217),
    [sym_identifier] = ACTIONS(5217),
    [sym_instance_variable] = ACTIONS(5215),
    [sym_class_variable] = ACTIONS(5215),
    [sym_global_variable] = ACTIONS(5215),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5217),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5217),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5699] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(8133),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(8133),
    [sym_operator_assignment] = STATE(8133),
    [sym_conditional] = STATE(8133),
    [sym_range] = STATE(8133),
    [sym_binary] = STATE(8133),
    [sym_unary] = STATE(8133),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5700] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8134),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(3118),
    [sym_call] = STATE(3118),
    [sym_method_call] = STATE(3122),
    [sym_assignment] = STATE(8134),
    [sym_operator_assignment] = STATE(8134),
    [sym_conditional] = STATE(8134),
    [sym_range] = STATE(8134),
    [sym_binary] = STATE(8134),
    [sym_unary] = STATE(8134),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(3118),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5680),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5193),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5197),
    [anon_sym_yield] = ACTIONS(5199),
    [anon_sym_break] = ACTIONS(5201),
    [anon_sym_next] = ACTIONS(5203),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8893),
    [anon_sym_defined_QMARK] = ACTIONS(5205),
    [anon_sym_not] = ACTIONS(5207),
    [anon_sym_BANG] = ACTIONS(5211),
    [anon_sym_TILDE] = ACTIONS(5211),
    [sym_constant] = ACTIONS(5217),
    [sym_identifier] = ACTIONS(5217),
    [sym_instance_variable] = ACTIONS(5215),
    [sym_class_variable] = ACTIONS(5215),
    [sym_global_variable] = ACTIONS(5215),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5217),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5217),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5701] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8135),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(3118),
    [sym_call] = STATE(3118),
    [sym_method_call] = STATE(3122),
    [sym_assignment] = STATE(8135),
    [sym_operator_assignment] = STATE(8135),
    [sym_conditional] = STATE(8135),
    [sym_range] = STATE(8135),
    [sym_binary] = STATE(8135),
    [sym_unary] = STATE(8135),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(3118),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5680),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5193),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5197),
    [anon_sym_yield] = ACTIONS(5199),
    [anon_sym_break] = ACTIONS(5201),
    [anon_sym_next] = ACTIONS(5203),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8893),
    [anon_sym_defined_QMARK] = ACTIONS(5205),
    [anon_sym_not] = ACTIONS(5207),
    [anon_sym_BANG] = ACTIONS(5211),
    [anon_sym_TILDE] = ACTIONS(5211),
    [sym_constant] = ACTIONS(5217),
    [sym_identifier] = ACTIONS(5217),
    [sym_instance_variable] = ACTIONS(5215),
    [sym_class_variable] = ACTIONS(5215),
    [sym_global_variable] = ACTIONS(5215),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5217),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5217),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5702] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8136),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(3118),
    [sym_call] = STATE(3118),
    [sym_method_call] = STATE(3122),
    [sym_assignment] = STATE(8136),
    [sym_operator_assignment] = STATE(8136),
    [sym_conditional] = STATE(8136),
    [sym_range] = STATE(8136),
    [sym_binary] = STATE(8136),
    [sym_unary] = STATE(8136),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(3118),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5680),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5193),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5197),
    [anon_sym_yield] = ACTIONS(5199),
    [anon_sym_break] = ACTIONS(5201),
    [anon_sym_next] = ACTIONS(5203),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8893),
    [anon_sym_defined_QMARK] = ACTIONS(5205),
    [anon_sym_not] = ACTIONS(5207),
    [anon_sym_BANG] = ACTIONS(5211),
    [anon_sym_TILDE] = ACTIONS(5211),
    [sym_constant] = ACTIONS(5217),
    [sym_identifier] = ACTIONS(5217),
    [sym_instance_variable] = ACTIONS(5215),
    [sym_class_variable] = ACTIONS(5215),
    [sym_global_variable] = ACTIONS(5215),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5217),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5217),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5703] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8137),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(3118),
    [sym_call] = STATE(3118),
    [sym_method_call] = STATE(3122),
    [sym_assignment] = STATE(8137),
    [sym_operator_assignment] = STATE(8137),
    [sym_conditional] = STATE(8137),
    [sym_range] = STATE(8137),
    [sym_binary] = STATE(8137),
    [sym_unary] = STATE(8137),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(3118),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5680),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5193),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5197),
    [anon_sym_yield] = ACTIONS(5199),
    [anon_sym_break] = ACTIONS(5201),
    [anon_sym_next] = ACTIONS(5203),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8893),
    [anon_sym_defined_QMARK] = ACTIONS(5205),
    [anon_sym_not] = ACTIONS(5207),
    [anon_sym_BANG] = ACTIONS(5211),
    [anon_sym_TILDE] = ACTIONS(5211),
    [sym_constant] = ACTIONS(5217),
    [sym_identifier] = ACTIONS(5217),
    [sym_instance_variable] = ACTIONS(5215),
    [sym_class_variable] = ACTIONS(5215),
    [sym_global_variable] = ACTIONS(5215),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5217),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5217),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5704] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8138),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3158),
    [sym_scope_resolution] = STATE(3154),
    [sym_call] = STATE(3154),
    [sym_method_call] = STATE(3158),
    [sym_assignment] = STATE(8138),
    [sym_operator_assignment] = STATE(8138),
    [sym_conditional] = STATE(8138),
    [sym_range] = STATE(8138),
    [sym_binary] = STATE(8138),
    [sym_unary] = STATE(8138),
    [sym_left_assignment_list] = STATE(3157),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3158),
    [sym__variable] = STATE(3154),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3158),
    [sym_false] = STATE(3158),
    [sym_nil] = STATE(3158),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5749),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5265),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5269),
    [anon_sym_yield] = ACTIONS(5271),
    [anon_sym_break] = ACTIONS(5273),
    [anon_sym_next] = ACTIONS(5275),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(8973),
    [anon_sym_defined_QMARK] = ACTIONS(5277),
    [anon_sym_not] = ACTIONS(5279),
    [anon_sym_BANG] = ACTIONS(5283),
    [anon_sym_TILDE] = ACTIONS(5283),
    [sym_constant] = ACTIONS(5289),
    [sym_identifier] = ACTIONS(5289),
    [sym_instance_variable] = ACTIONS(5287),
    [sym_class_variable] = ACTIONS(5287),
    [sym_global_variable] = ACTIONS(5287),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5289),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5289),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5705] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8139),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3158),
    [sym_scope_resolution] = STATE(3154),
    [sym_call] = STATE(3154),
    [sym_method_call] = STATE(3158),
    [sym_assignment] = STATE(8139),
    [sym_operator_assignment] = STATE(8139),
    [sym_conditional] = STATE(8139),
    [sym_range] = STATE(8139),
    [sym_binary] = STATE(8139),
    [sym_unary] = STATE(8139),
    [sym_left_assignment_list] = STATE(3157),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3158),
    [sym__variable] = STATE(3154),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3158),
    [sym_false] = STATE(3158),
    [sym_nil] = STATE(3158),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5749),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5265),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5269),
    [anon_sym_yield] = ACTIONS(5271),
    [anon_sym_break] = ACTIONS(5273),
    [anon_sym_next] = ACTIONS(5275),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(8973),
    [anon_sym_defined_QMARK] = ACTIONS(5277),
    [anon_sym_not] = ACTIONS(5279),
    [anon_sym_BANG] = ACTIONS(5283),
    [anon_sym_TILDE] = ACTIONS(5283),
    [sym_constant] = ACTIONS(5289),
    [sym_identifier] = ACTIONS(5289),
    [sym_instance_variable] = ACTIONS(5287),
    [sym_class_variable] = ACTIONS(5287),
    [sym_global_variable] = ACTIONS(5287),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5289),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5289),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5706] = {
    [anon_sym_COLON] = ACTIONS(11642),
    [sym_comment] = ACTIONS(87),
  },
  [5707] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8141),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3158),
    [sym_scope_resolution] = STATE(3154),
    [sym_call] = STATE(3154),
    [sym_method_call] = STATE(3158),
    [sym_assignment] = STATE(8141),
    [sym_operator_assignment] = STATE(8141),
    [sym_conditional] = STATE(8141),
    [sym_range] = STATE(8141),
    [sym_binary] = STATE(8141),
    [sym_unary] = STATE(8141),
    [sym_left_assignment_list] = STATE(3157),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3158),
    [sym__variable] = STATE(3154),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3158),
    [sym_false] = STATE(3158),
    [sym_nil] = STATE(3158),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5749),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5265),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5269),
    [anon_sym_yield] = ACTIONS(5271),
    [anon_sym_break] = ACTIONS(5273),
    [anon_sym_next] = ACTIONS(5275),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(8973),
    [anon_sym_defined_QMARK] = ACTIONS(5277),
    [anon_sym_not] = ACTIONS(5279),
    [anon_sym_BANG] = ACTIONS(5283),
    [anon_sym_TILDE] = ACTIONS(5283),
    [sym_constant] = ACTIONS(5289),
    [sym_identifier] = ACTIONS(5289),
    [sym_instance_variable] = ACTIONS(5287),
    [sym_class_variable] = ACTIONS(5287),
    [sym_global_variable] = ACTIONS(5287),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5289),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5289),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5708] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(11644),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_ensure] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [5709] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(8979),
    [sym__binary_star] = ACTIONS(8981),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(8983),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(8985),
    [anon_sym_AMP] = ACTIONS(8987),
    [anon_sym_EQ] = ACTIONS(1631),
    [anon_sym_LT] = ACTIONS(8989),
    [anon_sym_end] = ACTIONS(1625),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_unless] = ACTIONS(1625),
    [anon_sym_while] = ACTIONS(1625),
    [anon_sym_until] = ACTIONS(1625),
    [anon_sym_rescue] = ACTIONS(1625),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_ensure] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(1625),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_PLUS_EQ] = ACTIONS(1625),
    [anon_sym_DASH_EQ] = ACTIONS(1625),
    [anon_sym_STAR_EQ] = ACTIONS(1625),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1625),
    [anon_sym_SLASH_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1625),
    [anon_sym_AMP_EQ] = ACTIONS(1625),
    [anon_sym_PERCENT_EQ] = ACTIONS(1625),
    [anon_sym_GT_GT_EQ] = ACTIONS(1625),
    [anon_sym_LT_LT_EQ] = ACTIONS(1625),
    [anon_sym_CARET_EQ] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(8991),
    [anon_sym_DOT_DOT] = ACTIONS(8993),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8995),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(8997),
    [anon_sym_AMP_AMP] = ACTIONS(8997),
    [anon_sym_LT_LT] = ACTIONS(8999),
    [anon_sym_GT_GT] = ACTIONS(8999),
    [anon_sym_EQ_EQ] = ACTIONS(8997),
    [anon_sym_BANG_EQ] = ACTIONS(9001),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9001),
    [anon_sym_LT_EQ_GT] = ACTIONS(9001),
    [anon_sym_EQ_TILDE] = ACTIONS(9001),
    [anon_sym_BANG_TILDE] = ACTIONS(9001),
    [anon_sym_LT_EQ] = ACTIONS(8989),
    [anon_sym_GT] = ACTIONS(8989),
    [anon_sym_GT_EQ] = ACTIONS(9003),
    [anon_sym_CARET] = ACTIONS(8983),
    [anon_sym_PLUS] = ACTIONS(9005),
    [anon_sym_SLASH] = ACTIONS(8985),
    [anon_sym_PERCENT] = ACTIONS(8985),
    [sym_comment] = ACTIONS(87),
  },
  [5710] = {
    [sym_heredoc_body] = STATE(8143),
    [aux_sym_call_repeat1] = STATE(8143),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_ensure] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [5711] = {
    [sym_heredoc_body] = STATE(8143),
    [aux_sym_call_repeat1] = STATE(8143),
    [aux_sym_argument_list_repeat1] = STATE(8145),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(11646),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_ensure] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [5712] = {
    [sym_string] = STATE(5769),
    [aux_sym_chained_string_repeat1] = STATE(5769),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(747),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(11648),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5713] = {
    [sym_heredoc_body] = STATE(8146),
    [aux_sym_call_repeat1] = STATE(8146),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_ensure] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [5714] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3117),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(3118),
    [sym_call] = STATE(3118),
    [sym_method_call] = STATE(3122),
    [sym__argument] = STATE(2565),
    [sym_splat_argument] = STATE(2565),
    [sym_hash_splat_argument] = STATE(2565),
    [sym_block_argument] = STATE(2565),
    [sym_assignment] = STATE(3117),
    [sym_operator_assignment] = STATE(3117),
    [sym_conditional] = STATE(3117),
    [sym_range] = STATE(3117),
    [sym_binary] = STATE(3117),
    [sym_unary] = STATE(3117),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(3118),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3123),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(8147),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2565),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(5189),
    [sym__splat_star] = ACTIONS(5191),
    [sym__unary_minus] = ACTIONS(5193),
    [sym__identifier_hash_key] = ACTIONS(5195),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11650),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5197),
    [anon_sym_yield] = ACTIONS(5199),
    [anon_sym_break] = ACTIONS(5201),
    [anon_sym_next] = ACTIONS(5203),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8893),
    [anon_sym_defined_QMARK] = ACTIONS(5205),
    [anon_sym_not] = ACTIONS(5207),
    [anon_sym_BANG] = ACTIONS(5211),
    [anon_sym_TILDE] = ACTIONS(5211),
    [sym_constant] = ACTIONS(5213),
    [sym_identifier] = ACTIONS(5213),
    [sym_instance_variable] = ACTIONS(5215),
    [sym_class_variable] = ACTIONS(5215),
    [sym_global_variable] = ACTIONS(5215),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5217),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5217),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5715] = {
    [sym_heredoc_body] = STATE(8148),
    [aux_sym_call_repeat1] = STATE(8148),
    [aux_sym_argument_list_repeat1] = STATE(8149),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(8941),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_ensure] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [5716] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8150),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(3118),
    [sym_call] = STATE(3118),
    [sym_method_call] = STATE(3122),
    [sym_splat_argument] = STATE(8151),
    [sym_assignment] = STATE(8150),
    [sym_operator_assignment] = STATE(8150),
    [sym_conditional] = STATE(8150),
    [sym_range] = STATE(8150),
    [sym_binary] = STATE(8150),
    [sym_unary] = STATE(8150),
    [sym_right_assignment_list] = STATE(2570),
    [sym__arg_or_splat_arg] = STATE(8151),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(3118),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5680),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__splat_star] = ACTIONS(8899),
    [sym__unary_minus] = ACTIONS(5193),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5197),
    [anon_sym_yield] = ACTIONS(5199),
    [anon_sym_break] = ACTIONS(5201),
    [anon_sym_next] = ACTIONS(5203),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8893),
    [anon_sym_defined_QMARK] = ACTIONS(5205),
    [anon_sym_not] = ACTIONS(5207),
    [anon_sym_BANG] = ACTIONS(5211),
    [anon_sym_TILDE] = ACTIONS(5211),
    [sym_constant] = ACTIONS(5217),
    [sym_identifier] = ACTIONS(5217),
    [sym_instance_variable] = ACTIONS(5215),
    [sym_class_variable] = ACTIONS(5215),
    [sym_global_variable] = ACTIONS(5215),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5217),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5217),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5717] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8152),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(3118),
    [sym_call] = STATE(3118),
    [sym_method_call] = STATE(3122),
    [sym_assignment] = STATE(8152),
    [sym_operator_assignment] = STATE(8152),
    [sym_conditional] = STATE(8152),
    [sym_range] = STATE(8152),
    [sym_binary] = STATE(8152),
    [sym_unary] = STATE(8152),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(3118),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5680),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5193),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5197),
    [anon_sym_yield] = ACTIONS(5199),
    [anon_sym_break] = ACTIONS(5201),
    [anon_sym_next] = ACTIONS(5203),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8893),
    [anon_sym_defined_QMARK] = ACTIONS(5205),
    [anon_sym_not] = ACTIONS(5207),
    [anon_sym_BANG] = ACTIONS(5211),
    [anon_sym_TILDE] = ACTIONS(5211),
    [sym_constant] = ACTIONS(5217),
    [sym_identifier] = ACTIONS(5217),
    [sym_instance_variable] = ACTIONS(5215),
    [sym_class_variable] = ACTIONS(5215),
    [sym_global_variable] = ACTIONS(5215),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5217),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5217),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5718] = {
    [sym_string] = STATE(8153),
    [aux_sym_chained_string_repeat1] = STATE(8153),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_end] = ACTIONS(2753),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_ensure] = ACTIONS(2753),
    [anon_sym_EQ_GT] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [5719] = {
    [aux_sym_undef_repeat1] = STATE(8154),
    [sym__line_break] = ACTIONS(5497),
    [sym__heredoc_body_start] = ACTIONS(5497),
    [anon_sym_COMMA] = ACTIONS(2253),
    [anon_sym_SEMI] = ACTIONS(5497),
    [anon_sym_end] = ACTIONS(5497),
    [anon_sym_if] = ACTIONS(5497),
    [anon_sym_unless] = ACTIONS(5497),
    [anon_sym_while] = ACTIONS(5497),
    [anon_sym_until] = ACTIONS(5497),
    [anon_sym_rescue] = ACTIONS(5497),
    [anon_sym_ensure] = ACTIONS(5497),
    [sym_comment] = ACTIONS(87),
  },
  [5720] = {
    [sym__line_break] = ACTIONS(5815),
    [sym__heredoc_body_start] = ACTIONS(5815),
    [sym__binary_minus] = ACTIONS(5233),
    [sym__binary_star] = ACTIONS(5235),
    [anon_sym_PIPE] = ACTIONS(5237),
    [anon_sym_SEMI] = ACTIONS(5815),
    [anon_sym_STAR_STAR] = ACTIONS(5235),
    [anon_sym_AMP] = ACTIONS(5239),
    [anon_sym_LT] = ACTIONS(5241),
    [anon_sym_end] = ACTIONS(5815),
    [anon_sym_if] = ACTIONS(5815),
    [anon_sym_unless] = ACTIONS(5815),
    [anon_sym_while] = ACTIONS(5815),
    [anon_sym_until] = ACTIONS(5815),
    [anon_sym_rescue] = ACTIONS(5815),
    [anon_sym_ensure] = ACTIONS(5815),
    [anon_sym_QMARK] = ACTIONS(5243),
    [anon_sym_DOT_DOT] = ACTIONS(5245),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5247),
    [anon_sym_and] = ACTIONS(5249),
    [anon_sym_or] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5251),
    [anon_sym_AMP_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5253),
    [anon_sym_GT_GT] = ACTIONS(5253),
    [anon_sym_EQ_EQ] = ACTIONS(5255),
    [anon_sym_BANG_EQ] = ACTIONS(5251),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5251),
    [anon_sym_LT_EQ_GT] = ACTIONS(5251),
    [anon_sym_EQ_TILDE] = ACTIONS(5251),
    [anon_sym_BANG_TILDE] = ACTIONS(5251),
    [anon_sym_LT_EQ] = ACTIONS(5241),
    [anon_sym_GT] = ACTIONS(5241),
    [anon_sym_GT_EQ] = ACTIONS(5257),
    [anon_sym_CARET] = ACTIONS(5259),
    [anon_sym_PLUS] = ACTIONS(5233),
    [anon_sym_SLASH] = ACTIONS(5235),
    [anon_sym_PERCENT] = ACTIONS(5235),
    [sym_comment] = ACTIONS(87),
  },
  [5721] = {
    [sym__line_break] = ACTIONS(5817),
    [sym__heredoc_body_start] = ACTIONS(5817),
    [sym__binary_minus] = ACTIONS(5233),
    [sym__binary_star] = ACTIONS(5235),
    [anon_sym_PIPE] = ACTIONS(5237),
    [anon_sym_SEMI] = ACTIONS(5817),
    [anon_sym_STAR_STAR] = ACTIONS(5235),
    [anon_sym_AMP] = ACTIONS(5239),
    [anon_sym_LT] = ACTIONS(5241),
    [anon_sym_end] = ACTIONS(5817),
    [anon_sym_if] = ACTIONS(5817),
    [anon_sym_unless] = ACTIONS(5817),
    [anon_sym_while] = ACTIONS(5817),
    [anon_sym_until] = ACTIONS(5817),
    [anon_sym_rescue] = ACTIONS(5817),
    [anon_sym_ensure] = ACTIONS(5817),
    [anon_sym_QMARK] = ACTIONS(5243),
    [anon_sym_DOT_DOT] = ACTIONS(5245),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5247),
    [anon_sym_and] = ACTIONS(5249),
    [anon_sym_or] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5251),
    [anon_sym_AMP_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5253),
    [anon_sym_GT_GT] = ACTIONS(5253),
    [anon_sym_EQ_EQ] = ACTIONS(5255),
    [anon_sym_BANG_EQ] = ACTIONS(5251),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5251),
    [anon_sym_LT_EQ_GT] = ACTIONS(5251),
    [anon_sym_EQ_TILDE] = ACTIONS(5251),
    [anon_sym_BANG_TILDE] = ACTIONS(5251),
    [anon_sym_LT_EQ] = ACTIONS(5241),
    [anon_sym_GT] = ACTIONS(5241),
    [anon_sym_GT_EQ] = ACTIONS(5257),
    [anon_sym_CARET] = ACTIONS(5259),
    [anon_sym_PLUS] = ACTIONS(5233),
    [anon_sym_SLASH] = ACTIONS(5235),
    [anon_sym_PERCENT] = ACTIONS(5235),
    [sym_comment] = ACTIONS(87),
  },
  [5722] = {
    [sym__line_break] = ACTIONS(5819),
    [sym__heredoc_body_start] = ACTIONS(5819),
    [sym__binary_minus] = ACTIONS(5233),
    [sym__binary_star] = ACTIONS(5235),
    [anon_sym_PIPE] = ACTIONS(5237),
    [anon_sym_SEMI] = ACTIONS(5819),
    [anon_sym_STAR_STAR] = ACTIONS(5235),
    [anon_sym_AMP] = ACTIONS(5239),
    [anon_sym_LT] = ACTIONS(5241),
    [anon_sym_end] = ACTIONS(5819),
    [anon_sym_if] = ACTIONS(5819),
    [anon_sym_unless] = ACTIONS(5819),
    [anon_sym_while] = ACTIONS(5819),
    [anon_sym_until] = ACTIONS(5819),
    [anon_sym_rescue] = ACTIONS(5819),
    [anon_sym_ensure] = ACTIONS(5819),
    [anon_sym_QMARK] = ACTIONS(5243),
    [anon_sym_DOT_DOT] = ACTIONS(5245),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5247),
    [anon_sym_and] = ACTIONS(5249),
    [anon_sym_or] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5251),
    [anon_sym_AMP_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5253),
    [anon_sym_GT_GT] = ACTIONS(5253),
    [anon_sym_EQ_EQ] = ACTIONS(5255),
    [anon_sym_BANG_EQ] = ACTIONS(5251),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5251),
    [anon_sym_LT_EQ_GT] = ACTIONS(5251),
    [anon_sym_EQ_TILDE] = ACTIONS(5251),
    [anon_sym_BANG_TILDE] = ACTIONS(5251),
    [anon_sym_LT_EQ] = ACTIONS(5241),
    [anon_sym_GT] = ACTIONS(5241),
    [anon_sym_GT_EQ] = ACTIONS(5257),
    [anon_sym_CARET] = ACTIONS(5259),
    [anon_sym_PLUS] = ACTIONS(5233),
    [anon_sym_SLASH] = ACTIONS(5235),
    [anon_sym_PERCENT] = ACTIONS(5235),
    [sym_comment] = ACTIONS(87),
  },
  [5723] = {
    [sym__line_break] = ACTIONS(5821),
    [sym__heredoc_body_start] = ACTIONS(5821),
    [sym__binary_minus] = ACTIONS(5233),
    [sym__binary_star] = ACTIONS(5235),
    [anon_sym_PIPE] = ACTIONS(5237),
    [anon_sym_SEMI] = ACTIONS(5821),
    [anon_sym_STAR_STAR] = ACTIONS(5235),
    [anon_sym_AMP] = ACTIONS(5239),
    [anon_sym_LT] = ACTIONS(5241),
    [anon_sym_end] = ACTIONS(5821),
    [anon_sym_if] = ACTIONS(5821),
    [anon_sym_unless] = ACTIONS(5821),
    [anon_sym_while] = ACTIONS(5821),
    [anon_sym_until] = ACTIONS(5821),
    [anon_sym_rescue] = ACTIONS(5821),
    [anon_sym_ensure] = ACTIONS(5821),
    [anon_sym_QMARK] = ACTIONS(5243),
    [anon_sym_DOT_DOT] = ACTIONS(5245),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5247),
    [anon_sym_and] = ACTIONS(5249),
    [anon_sym_or] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5251),
    [anon_sym_AMP_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5253),
    [anon_sym_GT_GT] = ACTIONS(5253),
    [anon_sym_EQ_EQ] = ACTIONS(5255),
    [anon_sym_BANG_EQ] = ACTIONS(5251),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5251),
    [anon_sym_LT_EQ_GT] = ACTIONS(5251),
    [anon_sym_EQ_TILDE] = ACTIONS(5251),
    [anon_sym_BANG_TILDE] = ACTIONS(5251),
    [anon_sym_LT_EQ] = ACTIONS(5241),
    [anon_sym_GT] = ACTIONS(5241),
    [anon_sym_GT_EQ] = ACTIONS(5257),
    [anon_sym_CARET] = ACTIONS(5259),
    [anon_sym_PLUS] = ACTIONS(5233),
    [anon_sym_SLASH] = ACTIONS(5235),
    [anon_sym_PERCENT] = ACTIONS(5235),
    [sym_comment] = ACTIONS(87),
  },
  [5724] = {
    [sym__line_break] = ACTIONS(5823),
    [sym__heredoc_body_start] = ACTIONS(5823),
    [sym__binary_minus] = ACTIONS(5233),
    [sym__binary_star] = ACTIONS(5235),
    [anon_sym_PIPE] = ACTIONS(5237),
    [anon_sym_SEMI] = ACTIONS(5823),
    [anon_sym_STAR_STAR] = ACTIONS(5235),
    [anon_sym_AMP] = ACTIONS(5239),
    [anon_sym_LT] = ACTIONS(5241),
    [anon_sym_end] = ACTIONS(5823),
    [anon_sym_if] = ACTIONS(5823),
    [anon_sym_unless] = ACTIONS(5823),
    [anon_sym_while] = ACTIONS(5823),
    [anon_sym_until] = ACTIONS(5823),
    [anon_sym_rescue] = ACTIONS(5823),
    [anon_sym_ensure] = ACTIONS(5823),
    [anon_sym_QMARK] = ACTIONS(5243),
    [anon_sym_DOT_DOT] = ACTIONS(5245),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5247),
    [anon_sym_and] = ACTIONS(5249),
    [anon_sym_or] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5251),
    [anon_sym_AMP_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5253),
    [anon_sym_GT_GT] = ACTIONS(5253),
    [anon_sym_EQ_EQ] = ACTIONS(5255),
    [anon_sym_BANG_EQ] = ACTIONS(5251),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5251),
    [anon_sym_LT_EQ_GT] = ACTIONS(5251),
    [anon_sym_EQ_TILDE] = ACTIONS(5251),
    [anon_sym_BANG_TILDE] = ACTIONS(5251),
    [anon_sym_LT_EQ] = ACTIONS(5241),
    [anon_sym_GT] = ACTIONS(5241),
    [anon_sym_GT_EQ] = ACTIONS(5257),
    [anon_sym_CARET] = ACTIONS(5259),
    [anon_sym_PLUS] = ACTIONS(5233),
    [anon_sym_SLASH] = ACTIONS(5235),
    [anon_sym_PERCENT] = ACTIONS(5235),
    [sym_comment] = ACTIONS(87),
  },
  [5725] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5235),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(5235),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5235),
    [anon_sym_PERCENT] = ACTIONS(5235),
    [sym_comment] = ACTIONS(87),
  },
  [5726] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(5235),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [5727] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5233),
    [sym__binary_star] = ACTIONS(5235),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(5235),
    [anon_sym_AMP] = ACTIONS(5239),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5253),
    [anon_sym_GT_GT] = ACTIONS(5253),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5233),
    [anon_sym_SLASH] = ACTIONS(5235),
    [anon_sym_PERCENT] = ACTIONS(5235),
    [sym_comment] = ACTIONS(87),
  },
  [5728] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5233),
    [sym__binary_star] = ACTIONS(5235),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(5235),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5253),
    [anon_sym_GT_GT] = ACTIONS(5253),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5233),
    [anon_sym_SLASH] = ACTIONS(5235),
    [anon_sym_PERCENT] = ACTIONS(5235),
    [sym_comment] = ACTIONS(87),
  },
  [5729] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5233),
    [sym__binary_star] = ACTIONS(5235),
    [anon_sym_PIPE] = ACTIONS(5237),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(5235),
    [anon_sym_AMP] = ACTIONS(5239),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5253),
    [anon_sym_GT_GT] = ACTIONS(5253),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5259),
    [anon_sym_PLUS] = ACTIONS(5233),
    [anon_sym_SLASH] = ACTIONS(5235),
    [anon_sym_PERCENT] = ACTIONS(5235),
    [sym_comment] = ACTIONS(87),
  },
  [5730] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(11652),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [5731] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(5233),
    [sym__binary_star] = ACTIONS(5235),
    [anon_sym_PIPE] = ACTIONS(5237),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(5235),
    [anon_sym_AMP] = ACTIONS(5239),
    [anon_sym_LT] = ACTIONS(5241),
    [anon_sym_end] = ACTIONS(5927),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_ensure] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(5245),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5247),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(5251),
    [anon_sym_AMP_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5253),
    [anon_sym_GT_GT] = ACTIONS(5253),
    [anon_sym_EQ_EQ] = ACTIONS(5255),
    [anon_sym_BANG_EQ] = ACTIONS(5251),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5251),
    [anon_sym_LT_EQ_GT] = ACTIONS(5251),
    [anon_sym_EQ_TILDE] = ACTIONS(5251),
    [anon_sym_BANG_TILDE] = ACTIONS(5251),
    [anon_sym_LT_EQ] = ACTIONS(5241),
    [anon_sym_GT] = ACTIONS(5241),
    [anon_sym_GT_EQ] = ACTIONS(5257),
    [anon_sym_CARET] = ACTIONS(5259),
    [anon_sym_PLUS] = ACTIONS(5233),
    [anon_sym_SLASH] = ACTIONS(5235),
    [anon_sym_PERCENT] = ACTIONS(5235),
    [sym_comment] = ACTIONS(87),
  },
  [5732] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5233),
    [sym__binary_star] = ACTIONS(5235),
    [anon_sym_PIPE] = ACTIONS(5237),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(5235),
    [anon_sym_AMP] = ACTIONS(5239),
    [anon_sym_LT] = ACTIONS(5241),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5243),
    [anon_sym_DOT_DOT] = ACTIONS(5245),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5247),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5251),
    [anon_sym_AMP_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5253),
    [anon_sym_GT_GT] = ACTIONS(5253),
    [anon_sym_EQ_EQ] = ACTIONS(5255),
    [anon_sym_BANG_EQ] = ACTIONS(5251),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5251),
    [anon_sym_LT_EQ_GT] = ACTIONS(5251),
    [anon_sym_EQ_TILDE] = ACTIONS(5251),
    [anon_sym_BANG_TILDE] = ACTIONS(5251),
    [anon_sym_LT_EQ] = ACTIONS(5241),
    [anon_sym_GT] = ACTIONS(5241),
    [anon_sym_GT_EQ] = ACTIONS(5257),
    [anon_sym_CARET] = ACTIONS(5259),
    [anon_sym_PLUS] = ACTIONS(5233),
    [anon_sym_SLASH] = ACTIONS(5235),
    [anon_sym_PERCENT] = ACTIONS(5235),
    [sym_comment] = ACTIONS(87),
  },
  [5733] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5233),
    [sym__binary_star] = ACTIONS(5235),
    [anon_sym_PIPE] = ACTIONS(5237),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(5235),
    [anon_sym_AMP] = ACTIONS(5239),
    [anon_sym_LT] = ACTIONS(5241),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5253),
    [anon_sym_GT_GT] = ACTIONS(5253),
    [anon_sym_EQ_EQ] = ACTIONS(5255),
    [anon_sym_BANG_EQ] = ACTIONS(5251),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5251),
    [anon_sym_LT_EQ_GT] = ACTIONS(5251),
    [anon_sym_EQ_TILDE] = ACTIONS(5251),
    [anon_sym_BANG_TILDE] = ACTIONS(5251),
    [anon_sym_LT_EQ] = ACTIONS(5241),
    [anon_sym_GT] = ACTIONS(5241),
    [anon_sym_GT_EQ] = ACTIONS(5257),
    [anon_sym_CARET] = ACTIONS(5259),
    [anon_sym_PLUS] = ACTIONS(5233),
    [anon_sym_SLASH] = ACTIONS(5235),
    [anon_sym_PERCENT] = ACTIONS(5235),
    [sym_comment] = ACTIONS(87),
  },
  [5734] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5233),
    [sym__binary_star] = ACTIONS(5235),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(5235),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5233),
    [anon_sym_SLASH] = ACTIONS(5235),
    [anon_sym_PERCENT] = ACTIONS(5235),
    [sym_comment] = ACTIONS(87),
  },
  [5735] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(8156),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(5745),
    [sym_scope_resolution] = STATE(5743),
    [sym_call] = STATE(5743),
    [sym_method_call] = STATE(5745),
    [sym_assignment] = STATE(8156),
    [sym_operator_assignment] = STATE(8156),
    [sym_conditional] = STATE(8156),
    [sym_range] = STATE(8156),
    [sym_binary] = STATE(8156),
    [sym_unary] = STATE(8156),
    [sym_left_assignment_list] = STATE(5744),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5745),
    [sym__variable] = STATE(5743),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(5745),
    [sym_false] = STATE(5745),
    [sym_nil] = STATE(5745),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(5746),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(8951),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(8953),
    [anon_sym_yield] = ACTIONS(8955),
    [anon_sym_break] = ACTIONS(8957),
    [anon_sym_next] = ACTIONS(8959),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(8961),
    [anon_sym_defined_QMARK] = ACTIONS(8963),
    [anon_sym_not] = ACTIONS(8965),
    [anon_sym_BANG] = ACTIONS(8967),
    [anon_sym_TILDE] = ACTIONS(8967),
    [sym_constant] = ACTIONS(8969),
    [sym_identifier] = ACTIONS(8969),
    [sym_instance_variable] = ACTIONS(8971),
    [sym_class_variable] = ACTIONS(8971),
    [sym_global_variable] = ACTIONS(8971),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(8969),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8969),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [5736] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3153),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3158),
    [sym_scope_resolution] = STATE(3154),
    [sym_call] = STATE(3154),
    [sym_method_call] = STATE(3158),
    [sym_argument_list] = STATE(3610),
    [sym__argument_list_with_parens] = STATE(3155),
    [sym__argument] = STATE(3156),
    [sym_splat_argument] = STATE(3156),
    [sym_hash_splat_argument] = STATE(3156),
    [sym_block_argument] = STATE(3156),
    [sym_assignment] = STATE(3153),
    [sym_operator_assignment] = STATE(3153),
    [sym_conditional] = STATE(3153),
    [sym_range] = STATE(3153),
    [sym_binary] = STATE(3153),
    [sym_unary] = STATE(3153),
    [sym_left_assignment_list] = STATE(3157),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3158),
    [sym__variable] = STATE(3154),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3158),
    [sym_false] = STATE(3158),
    [sym_nil] = STATE(3158),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3159),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(3156),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(5261),
    [sym__splat_star] = ACTIONS(5263),
    [sym__unary_minus] = ACTIONS(5265),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(5267),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(5269),
    [anon_sym_yield] = ACTIONS(5271),
    [anon_sym_break] = ACTIONS(5273),
    [anon_sym_next] = ACTIONS(5275),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_ensure] = ACTIONS(377),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(365),
    [anon_sym_DASH_EQ] = ACTIONS(365),
    [anon_sym_STAR_EQ] = ACTIONS(365),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(365),
    [anon_sym_SLASH_EQ] = ACTIONS(365),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(365),
    [anon_sym_PIPE_EQ] = ACTIONS(365),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(365),
    [anon_sym_AMP_EQ] = ACTIONS(365),
    [anon_sym_PERCENT_EQ] = ACTIONS(365),
    [anon_sym_GT_GT_EQ] = ACTIONS(365),
    [anon_sym_LT_LT_EQ] = ACTIONS(365),
    [anon_sym_CARET_EQ] = ACTIONS(365),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_PERCENT] = ACTIONS(377),
    [anon_sym_defined_QMARK] = ACTIONS(5277),
    [anon_sym_not] = ACTIONS(5279),
    [anon_sym_BANG] = ACTIONS(5281),
    [anon_sym_TILDE] = ACTIONS(5283),
    [sym_constant] = ACTIONS(5285),
    [sym_identifier] = ACTIONS(5285),
    [sym_instance_variable] = ACTIONS(5287),
    [sym_class_variable] = ACTIONS(5287),
    [sym_global_variable] = ACTIONS(5287),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5289),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5289),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5737] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3153),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3158),
    [sym_scope_resolution] = STATE(3154),
    [sym_call] = STATE(3154),
    [sym_method_call] = STATE(3158),
    [sym_argument_list] = STATE(3611),
    [sym__argument_list_with_parens] = STATE(3155),
    [sym__argument] = STATE(3156),
    [sym_splat_argument] = STATE(3156),
    [sym_hash_splat_argument] = STATE(3156),
    [sym_block_argument] = STATE(3156),
    [sym_assignment] = STATE(3153),
    [sym_operator_assignment] = STATE(3153),
    [sym_conditional] = STATE(3153),
    [sym_range] = STATE(3153),
    [sym_binary] = STATE(3153),
    [sym_unary] = STATE(3153),
    [sym_left_assignment_list] = STATE(3157),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3158),
    [sym__variable] = STATE(3154),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3158),
    [sym_false] = STATE(3158),
    [sym_nil] = STATE(3158),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3159),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(3156),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(5261),
    [sym__splat_star] = ACTIONS(5263),
    [sym__unary_minus] = ACTIONS(5265),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(5267),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_EQ] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(5269),
    [anon_sym_yield] = ACTIONS(5271),
    [anon_sym_break] = ACTIONS(5273),
    [anon_sym_next] = ACTIONS(5275),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_ensure] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(417),
    [anon_sym_DASH_EQ] = ACTIONS(417),
    [anon_sym_STAR_EQ] = ACTIONS(417),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(417),
    [anon_sym_SLASH_EQ] = ACTIONS(417),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(417),
    [anon_sym_PIPE_EQ] = ACTIONS(417),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(417),
    [anon_sym_AMP_EQ] = ACTIONS(417),
    [anon_sym_PERCENT_EQ] = ACTIONS(417),
    [anon_sym_GT_GT_EQ] = ACTIONS(417),
    [anon_sym_LT_LT_EQ] = ACTIONS(417),
    [anon_sym_CARET_EQ] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(5277),
    [anon_sym_not] = ACTIONS(5279),
    [anon_sym_BANG] = ACTIONS(5281),
    [anon_sym_TILDE] = ACTIONS(5283),
    [sym_constant] = ACTIONS(5285),
    [sym_identifier] = ACTIONS(5285),
    [sym_instance_variable] = ACTIONS(5287),
    [sym_class_variable] = ACTIONS(5287),
    [sym_global_variable] = ACTIONS(5287),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5289),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5289),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5738] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3153),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3158),
    [sym_scope_resolution] = STATE(3154),
    [sym_call] = STATE(3154),
    [sym_method_call] = STATE(3158),
    [sym_argument_list] = STATE(3612),
    [sym__argument_list_with_parens] = STATE(3155),
    [sym__argument] = STATE(3156),
    [sym_splat_argument] = STATE(3156),
    [sym_hash_splat_argument] = STATE(3156),
    [sym_block_argument] = STATE(3156),
    [sym_assignment] = STATE(3153),
    [sym_operator_assignment] = STATE(3153),
    [sym_conditional] = STATE(3153),
    [sym_range] = STATE(3153),
    [sym_binary] = STATE(3153),
    [sym_unary] = STATE(3153),
    [sym_left_assignment_list] = STATE(3157),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3158),
    [sym__variable] = STATE(3154),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3158),
    [sym_false] = STATE(3158),
    [sym_nil] = STATE(3158),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3159),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(3156),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(5261),
    [sym__splat_star] = ACTIONS(5263),
    [sym__unary_minus] = ACTIONS(5265),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(5267),
    [anon_sym_LBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_EQ] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(423),
    [anon_sym_return] = ACTIONS(5269),
    [anon_sym_yield] = ACTIONS(5271),
    [anon_sym_break] = ACTIONS(5273),
    [anon_sym_next] = ACTIONS(5275),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_ensure] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(421),
    [anon_sym_DASH_EQ] = ACTIONS(421),
    [anon_sym_STAR_EQ] = ACTIONS(421),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(421),
    [anon_sym_SLASH_EQ] = ACTIONS(421),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(421),
    [anon_sym_PIPE_EQ] = ACTIONS(421),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(421),
    [anon_sym_AMP_EQ] = ACTIONS(421),
    [anon_sym_PERCENT_EQ] = ACTIONS(421),
    [anon_sym_GT_GT_EQ] = ACTIONS(421),
    [anon_sym_LT_LT_EQ] = ACTIONS(421),
    [anon_sym_CARET_EQ] = ACTIONS(421),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(5277),
    [anon_sym_not] = ACTIONS(5279),
    [anon_sym_BANG] = ACTIONS(5281),
    [anon_sym_TILDE] = ACTIONS(5283),
    [sym_constant] = ACTIONS(5285),
    [sym_identifier] = ACTIONS(5285),
    [sym_instance_variable] = ACTIONS(5287),
    [sym_class_variable] = ACTIONS(5287),
    [sym_global_variable] = ACTIONS(5287),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5289),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5289),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5739] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3153),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3158),
    [sym_scope_resolution] = STATE(3154),
    [sym_call] = STATE(3154),
    [sym_method_call] = STATE(3158),
    [sym_argument_list] = STATE(3613),
    [sym__argument_list_with_parens] = STATE(3155),
    [sym__argument] = STATE(3156),
    [sym_splat_argument] = STATE(3156),
    [sym_hash_splat_argument] = STATE(3156),
    [sym_block_argument] = STATE(3156),
    [sym_assignment] = STATE(3153),
    [sym_operator_assignment] = STATE(3153),
    [sym_conditional] = STATE(3153),
    [sym_range] = STATE(3153),
    [sym_binary] = STATE(3153),
    [sym_unary] = STATE(3153),
    [sym_left_assignment_list] = STATE(3157),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3158),
    [sym__variable] = STATE(3154),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3158),
    [sym_false] = STATE(3158),
    [sym_nil] = STATE(3158),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3159),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(3156),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(5261),
    [sym__splat_star] = ACTIONS(5263),
    [sym__unary_minus] = ACTIONS(5265),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(5267),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(427),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(427),
    [anon_sym_return] = ACTIONS(5269),
    [anon_sym_yield] = ACTIONS(5271),
    [anon_sym_break] = ACTIONS(5273),
    [anon_sym_next] = ACTIONS(5275),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_ensure] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(425),
    [anon_sym_DASH_EQ] = ACTIONS(425),
    [anon_sym_STAR_EQ] = ACTIONS(425),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(425),
    [anon_sym_SLASH_EQ] = ACTIONS(425),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(425),
    [anon_sym_PIPE_EQ] = ACTIONS(425),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(425),
    [anon_sym_AMP_EQ] = ACTIONS(425),
    [anon_sym_PERCENT_EQ] = ACTIONS(425),
    [anon_sym_GT_GT_EQ] = ACTIONS(425),
    [anon_sym_LT_LT_EQ] = ACTIONS(425),
    [anon_sym_CARET_EQ] = ACTIONS(425),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(5277),
    [anon_sym_not] = ACTIONS(5279),
    [anon_sym_BANG] = ACTIONS(5281),
    [anon_sym_TILDE] = ACTIONS(5283),
    [sym_constant] = ACTIONS(5285),
    [sym_identifier] = ACTIONS(5285),
    [sym_instance_variable] = ACTIONS(5287),
    [sym_class_variable] = ACTIONS(5287),
    [sym_global_variable] = ACTIONS(5287),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5289),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5289),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5740] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(8157),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(5745),
    [sym_scope_resolution] = STATE(5743),
    [sym_call] = STATE(5743),
    [sym_method_call] = STATE(5745),
    [sym_assignment] = STATE(8157),
    [sym_operator_assignment] = STATE(8157),
    [sym_conditional] = STATE(8157),
    [sym_range] = STATE(8157),
    [sym_binary] = STATE(8157),
    [sym_unary] = STATE(8157),
    [sym_left_assignment_list] = STATE(5744),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5745),
    [sym__variable] = STATE(5743),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(5745),
    [sym_false] = STATE(5745),
    [sym_nil] = STATE(5745),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(5746),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(8951),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(8953),
    [anon_sym_yield] = ACTIONS(8955),
    [anon_sym_break] = ACTIONS(8957),
    [anon_sym_next] = ACTIONS(8959),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(8961),
    [anon_sym_defined_QMARK] = ACTIONS(8963),
    [anon_sym_not] = ACTIONS(8965),
    [anon_sym_BANG] = ACTIONS(8967),
    [anon_sym_TILDE] = ACTIONS(8967),
    [sym_constant] = ACTIONS(8969),
    [sym_identifier] = ACTIONS(8969),
    [sym_instance_variable] = ACTIONS(8971),
    [sym_class_variable] = ACTIONS(8971),
    [sym_global_variable] = ACTIONS(8971),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(8969),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8969),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [5741] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(3628),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(5745),
    [sym_scope_resolution] = STATE(5743),
    [sym_call] = STATE(5743),
    [sym_method_call] = STATE(5745),
    [sym_assignment] = STATE(3628),
    [sym_operator_assignment] = STATE(3628),
    [sym_conditional] = STATE(3628),
    [sym_range] = STATE(3628),
    [sym_binary] = STATE(3628),
    [sym_unary] = STATE(3628),
    [sym_left_assignment_list] = STATE(5744),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5745),
    [sym__variable] = STATE(5743),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(5745),
    [sym_false] = STATE(5745),
    [sym_nil] = STATE(5745),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(5746),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(8951),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(8953),
    [anon_sym_yield] = ACTIONS(8955),
    [anon_sym_break] = ACTIONS(8957),
    [anon_sym_next] = ACTIONS(8959),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(8961),
    [anon_sym_defined_QMARK] = ACTIONS(8963),
    [anon_sym_not] = ACTIONS(8965),
    [anon_sym_BANG] = ACTIONS(8967),
    [anon_sym_TILDE] = ACTIONS(8967),
    [sym_constant] = ACTIONS(8969),
    [sym_identifier] = ACTIONS(8969),
    [sym_instance_variable] = ACTIONS(8971),
    [sym_class_variable] = ACTIONS(8971),
    [sym_global_variable] = ACTIONS(8971),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(8969),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8969),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [5742] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(11654),
    [sym__binary_star] = ACTIONS(11656),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(11658),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(11660),
    [anon_sym_AMP] = ACTIONS(11662),
    [anon_sym_EQ] = ACTIONS(4217),
    [anon_sym_LT] = ACTIONS(11664),
    [anon_sym_end] = ACTIONS(4211),
    [anon_sym_if] = ACTIONS(4211),
    [anon_sym_unless] = ACTIONS(4211),
    [anon_sym_while] = ACTIONS(4211),
    [anon_sym_until] = ACTIONS(4211),
    [anon_sym_rescue] = ACTIONS(4211),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_ensure] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_PLUS_EQ] = ACTIONS(4211),
    [anon_sym_DASH_EQ] = ACTIONS(4211),
    [anon_sym_STAR_EQ] = ACTIONS(4211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4211),
    [anon_sym_SLASH_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4211),
    [anon_sym_AMP_EQ] = ACTIONS(4211),
    [anon_sym_PERCENT_EQ] = ACTIONS(4211),
    [anon_sym_GT_GT_EQ] = ACTIONS(4211),
    [anon_sym_LT_LT_EQ] = ACTIONS(4211),
    [anon_sym_CARET_EQ] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(11666),
    [anon_sym_DOT_DOT] = ACTIONS(11668),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11670),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11672),
    [anon_sym_AMP_AMP] = ACTIONS(11672),
    [anon_sym_LT_LT] = ACTIONS(11674),
    [anon_sym_GT_GT] = ACTIONS(11674),
    [anon_sym_EQ_EQ] = ACTIONS(11672),
    [anon_sym_BANG_EQ] = ACTIONS(11676),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11676),
    [anon_sym_LT_EQ_GT] = ACTIONS(11676),
    [anon_sym_EQ_TILDE] = ACTIONS(11676),
    [anon_sym_BANG_TILDE] = ACTIONS(11676),
    [anon_sym_LT_EQ] = ACTIONS(11664),
    [anon_sym_GT] = ACTIONS(11664),
    [anon_sym_GT_EQ] = ACTIONS(11678),
    [anon_sym_CARET] = ACTIONS(11658),
    [anon_sym_PLUS] = ACTIONS(11680),
    [anon_sym_SLASH] = ACTIONS(11660),
    [anon_sym_PERCENT] = ACTIONS(11660),
    [sym_comment] = ACTIONS(87),
  },
  [5743] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3153),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3158),
    [sym_scope_resolution] = STATE(3154),
    [sym_call] = STATE(3154),
    [sym_method_call] = STATE(3158),
    [sym_argument_list] = STATE(1062),
    [sym__argument_list_with_parens] = STATE(3155),
    [sym__argument] = STATE(3156),
    [sym_splat_argument] = STATE(3156),
    [sym_hash_splat_argument] = STATE(3156),
    [sym_block_argument] = STATE(3156),
    [sym_do_block] = STATE(426),
    [sym_block] = STATE(426),
    [sym_assignment] = STATE(3153),
    [sym_operator_assignment] = STATE(3153),
    [sym_conditional] = STATE(3153),
    [sym_range] = STATE(3153),
    [sym_binary] = STATE(3153),
    [sym_unary] = STATE(3153),
    [sym_left_assignment_list] = STATE(3157),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3158),
    [sym__variable] = STATE(3154),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3158),
    [sym_false] = STATE(3158),
    [sym_nil] = STATE(3158),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3159),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(3156),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(743),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(5261),
    [sym__splat_star] = ACTIONS(5263),
    [sym__unary_minus] = ACTIONS(5265),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(5267),
    [anon_sym_LBRACE] = ACTIONS(6047),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(769),
    [anon_sym_return] = ACTIONS(5269),
    [anon_sym_yield] = ACTIONS(5271),
    [anon_sym_break] = ACTIONS(5273),
    [anon_sym_next] = ACTIONS(5275),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(769),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(769),
    [anon_sym_until] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(769),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(769),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_ensure] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(5277),
    [anon_sym_not] = ACTIONS(5279),
    [anon_sym_BANG] = ACTIONS(5281),
    [anon_sym_TILDE] = ACTIONS(5283),
    [sym_constant] = ACTIONS(5285),
    [sym_identifier] = ACTIONS(5285),
    [sym_instance_variable] = ACTIONS(5287),
    [sym_class_variable] = ACTIONS(5287),
    [sym_global_variable] = ACTIONS(5287),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5289),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5289),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5744] = {
    [anon_sym_EQ] = ACTIONS(11682),
    [sym_comment] = ACTIONS(87),
  },
  [5745] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(11684),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(11686),
    [anon_sym_DASH_EQ] = ACTIONS(11686),
    [anon_sym_STAR_EQ] = ACTIONS(11686),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11686),
    [anon_sym_SLASH_EQ] = ACTIONS(11686),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11686),
    [anon_sym_PIPE_EQ] = ACTIONS(11686),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11686),
    [anon_sym_AMP_EQ] = ACTIONS(11686),
    [anon_sym_PERCENT_EQ] = ACTIONS(11686),
    [anon_sym_GT_GT_EQ] = ACTIONS(11686),
    [anon_sym_LT_LT_EQ] = ACTIONS(11686),
    [anon_sym_CARET_EQ] = ACTIONS(11686),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5746] = {
    [sym_string] = STATE(8170),
    [aux_sym_chained_string_repeat1] = STATE(8170),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(2551),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5747] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(11654),
    [sym__binary_star] = ACTIONS(11656),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(11658),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(11660),
    [anon_sym_AMP] = ACTIONS(11662),
    [anon_sym_EQ] = ACTIONS(4249),
    [anon_sym_LT] = ACTIONS(11664),
    [anon_sym_end] = ACTIONS(4247),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_ensure] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_PLUS_EQ] = ACTIONS(4247),
    [anon_sym_DASH_EQ] = ACTIONS(4247),
    [anon_sym_STAR_EQ] = ACTIONS(4247),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4247),
    [anon_sym_SLASH_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4247),
    [anon_sym_AMP_EQ] = ACTIONS(4247),
    [anon_sym_PERCENT_EQ] = ACTIONS(4247),
    [anon_sym_GT_GT_EQ] = ACTIONS(4247),
    [anon_sym_LT_LT_EQ] = ACTIONS(4247),
    [anon_sym_CARET_EQ] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(11666),
    [anon_sym_DOT_DOT] = ACTIONS(11668),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11670),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(11672),
    [anon_sym_AMP_AMP] = ACTIONS(11672),
    [anon_sym_LT_LT] = ACTIONS(11674),
    [anon_sym_GT_GT] = ACTIONS(11674),
    [anon_sym_EQ_EQ] = ACTIONS(11672),
    [anon_sym_BANG_EQ] = ACTIONS(11676),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11676),
    [anon_sym_LT_EQ_GT] = ACTIONS(11676),
    [anon_sym_EQ_TILDE] = ACTIONS(11676),
    [anon_sym_BANG_TILDE] = ACTIONS(11676),
    [anon_sym_LT_EQ] = ACTIONS(11664),
    [anon_sym_GT] = ACTIONS(11664),
    [anon_sym_GT_EQ] = ACTIONS(11678),
    [anon_sym_CARET] = ACTIONS(11658),
    [anon_sym_PLUS] = ACTIONS(11680),
    [anon_sym_SLASH] = ACTIONS(11660),
    [anon_sym_PERCENT] = ACTIONS(11660),
    [sym_comment] = ACTIONS(87),
  },
  [5748] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8985),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_ensure] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [5749] = {
    [sym_string] = STATE(5769),
    [aux_sym_chained_string_repeat1] = STATE(5769),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(747),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5750] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(8171),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(5745),
    [sym_scope_resolution] = STATE(5743),
    [sym_call] = STATE(5743),
    [sym_method_call] = STATE(5745),
    [sym_assignment] = STATE(8171),
    [sym_operator_assignment] = STATE(8171),
    [sym_conditional] = STATE(8171),
    [sym_range] = STATE(8171),
    [sym_binary] = STATE(8171),
    [sym_unary] = STATE(8171),
    [sym_left_assignment_list] = STATE(5744),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5745),
    [sym__variable] = STATE(5743),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(5745),
    [sym_false] = STATE(5745),
    [sym_nil] = STATE(5745),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(5746),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(8951),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(8953),
    [anon_sym_yield] = ACTIONS(8955),
    [anon_sym_break] = ACTIONS(8957),
    [anon_sym_next] = ACTIONS(8959),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(8961),
    [anon_sym_defined_QMARK] = ACTIONS(8963),
    [anon_sym_not] = ACTIONS(8965),
    [anon_sym_BANG] = ACTIONS(8967),
    [anon_sym_TILDE] = ACTIONS(8967),
    [sym_constant] = ACTIONS(8969),
    [sym_identifier] = ACTIONS(8969),
    [sym_instance_variable] = ACTIONS(8971),
    [sym_class_variable] = ACTIONS(8971),
    [sym_global_variable] = ACTIONS(8971),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(8969),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8969),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [5751] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(11654),
    [sym__binary_star] = ACTIONS(11656),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(11658),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(11660),
    [anon_sym_AMP] = ACTIONS(11662),
    [anon_sym_EQ] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(11664),
    [anon_sym_end] = ACTIONS(3281),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_unless] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_until] = ACTIONS(3281),
    [anon_sym_rescue] = ACTIONS(3281),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_ensure] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_PLUS_EQ] = ACTIONS(3281),
    [anon_sym_DASH_EQ] = ACTIONS(3281),
    [anon_sym_STAR_EQ] = ACTIONS(3281),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3281),
    [anon_sym_SLASH_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3281),
    [anon_sym_AMP_EQ] = ACTIONS(3281),
    [anon_sym_PERCENT_EQ] = ACTIONS(3281),
    [anon_sym_GT_GT_EQ] = ACTIONS(3281),
    [anon_sym_LT_LT_EQ] = ACTIONS(3281),
    [anon_sym_CARET_EQ] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(11666),
    [anon_sym_DOT_DOT] = ACTIONS(11668),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11670),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(11672),
    [anon_sym_AMP_AMP] = ACTIONS(11672),
    [anon_sym_LT_LT] = ACTIONS(11674),
    [anon_sym_GT_GT] = ACTIONS(11674),
    [anon_sym_EQ_EQ] = ACTIONS(11672),
    [anon_sym_BANG_EQ] = ACTIONS(11676),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11676),
    [anon_sym_LT_EQ_GT] = ACTIONS(11676),
    [anon_sym_EQ_TILDE] = ACTIONS(11676),
    [anon_sym_BANG_TILDE] = ACTIONS(11676),
    [anon_sym_LT_EQ] = ACTIONS(11664),
    [anon_sym_GT] = ACTIONS(11664),
    [anon_sym_GT_EQ] = ACTIONS(11678),
    [anon_sym_CARET] = ACTIONS(11658),
    [anon_sym_PLUS] = ACTIONS(11680),
    [anon_sym_SLASH] = ACTIONS(11660),
    [anon_sym_PERCENT] = ACTIONS(11660),
    [sym_comment] = ACTIONS(87),
  },
  [5752] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(8979),
    [sym__binary_star] = ACTIONS(8981),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(8983),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8985),
    [anon_sym_AMP] = ACTIONS(8987),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(8989),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_ensure] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(8991),
    [anon_sym_DOT_DOT] = ACTIONS(8993),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8995),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(8997),
    [anon_sym_AMP_AMP] = ACTIONS(8997),
    [anon_sym_LT_LT] = ACTIONS(8999),
    [anon_sym_GT_GT] = ACTIONS(8999),
    [anon_sym_EQ_EQ] = ACTIONS(8997),
    [anon_sym_BANG_EQ] = ACTIONS(9001),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9001),
    [anon_sym_LT_EQ_GT] = ACTIONS(9001),
    [anon_sym_EQ_TILDE] = ACTIONS(9001),
    [anon_sym_BANG_TILDE] = ACTIONS(9001),
    [anon_sym_LT_EQ] = ACTIONS(8989),
    [anon_sym_GT] = ACTIONS(8989),
    [anon_sym_GT_EQ] = ACTIONS(9003),
    [anon_sym_CARET] = ACTIONS(8983),
    [anon_sym_PLUS] = ACTIONS(9005),
    [anon_sym_SLASH] = ACTIONS(8985),
    [anon_sym_PERCENT] = ACTIONS(8985),
    [sym_comment] = ACTIONS(87),
  },
  [5753] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(8172),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(5745),
    [sym_scope_resolution] = STATE(5743),
    [sym_call] = STATE(5743),
    [sym_method_call] = STATE(5745),
    [sym_assignment] = STATE(8172),
    [sym_operator_assignment] = STATE(8172),
    [sym_conditional] = STATE(8172),
    [sym_range] = STATE(8172),
    [sym_binary] = STATE(8172),
    [sym_unary] = STATE(8172),
    [sym_left_assignment_list] = STATE(5744),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5745),
    [sym__variable] = STATE(5743),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(5745),
    [sym_false] = STATE(5745),
    [sym_nil] = STATE(5745),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(5746),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(8951),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(8953),
    [anon_sym_yield] = ACTIONS(8955),
    [anon_sym_break] = ACTIONS(8957),
    [anon_sym_next] = ACTIONS(8959),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(8961),
    [anon_sym_defined_QMARK] = ACTIONS(8963),
    [anon_sym_not] = ACTIONS(8965),
    [anon_sym_BANG] = ACTIONS(8967),
    [anon_sym_TILDE] = ACTIONS(8967),
    [sym_constant] = ACTIONS(8969),
    [sym_identifier] = ACTIONS(8969),
    [sym_instance_variable] = ACTIONS(8971),
    [sym_class_variable] = ACTIONS(8971),
    [sym_global_variable] = ACTIONS(8971),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(8969),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8969),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [5754] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8173),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3158),
    [sym_scope_resolution] = STATE(3154),
    [sym_call] = STATE(3154),
    [sym_method_call] = STATE(3158),
    [sym_assignment] = STATE(8173),
    [sym_operator_assignment] = STATE(8173),
    [sym_conditional] = STATE(8173),
    [sym_range] = STATE(8173),
    [sym_binary] = STATE(8173),
    [sym_unary] = STATE(8173),
    [sym_left_assignment_list] = STATE(3157),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3158),
    [sym__variable] = STATE(3154),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3158),
    [sym_false] = STATE(3158),
    [sym_nil] = STATE(3158),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5749),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5265),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5269),
    [anon_sym_yield] = ACTIONS(5271),
    [anon_sym_break] = ACTIONS(5273),
    [anon_sym_next] = ACTIONS(5275),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(8973),
    [anon_sym_defined_QMARK] = ACTIONS(5277),
    [anon_sym_not] = ACTIONS(5279),
    [anon_sym_BANG] = ACTIONS(5283),
    [anon_sym_TILDE] = ACTIONS(5283),
    [sym_constant] = ACTIONS(5289),
    [sym_identifier] = ACTIONS(5289),
    [sym_instance_variable] = ACTIONS(5287),
    [sym_class_variable] = ACTIONS(5287),
    [sym_global_variable] = ACTIONS(5287),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5289),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5289),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5755] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8174),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3158),
    [sym_scope_resolution] = STATE(3154),
    [sym_call] = STATE(3154),
    [sym_method_call] = STATE(3158),
    [sym_assignment] = STATE(8174),
    [sym_operator_assignment] = STATE(8174),
    [sym_conditional] = STATE(8174),
    [sym_range] = STATE(8174),
    [sym_binary] = STATE(8174),
    [sym_unary] = STATE(8174),
    [sym_left_assignment_list] = STATE(3157),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3158),
    [sym__variable] = STATE(3154),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3158),
    [sym_false] = STATE(3158),
    [sym_nil] = STATE(3158),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5749),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5265),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5269),
    [anon_sym_yield] = ACTIONS(5271),
    [anon_sym_break] = ACTIONS(5273),
    [anon_sym_next] = ACTIONS(5275),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(8973),
    [anon_sym_defined_QMARK] = ACTIONS(5277),
    [anon_sym_not] = ACTIONS(5279),
    [anon_sym_BANG] = ACTIONS(5283),
    [anon_sym_TILDE] = ACTIONS(5283),
    [sym_constant] = ACTIONS(5289),
    [sym_identifier] = ACTIONS(5289),
    [sym_instance_variable] = ACTIONS(5287),
    [sym_class_variable] = ACTIONS(5287),
    [sym_global_variable] = ACTIONS(5287),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5289),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5289),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5756] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8175),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3158),
    [sym_scope_resolution] = STATE(3154),
    [sym_call] = STATE(3154),
    [sym_method_call] = STATE(3158),
    [sym_assignment] = STATE(8175),
    [sym_operator_assignment] = STATE(8175),
    [sym_conditional] = STATE(8175),
    [sym_range] = STATE(8175),
    [sym_binary] = STATE(8175),
    [sym_unary] = STATE(8175),
    [sym_left_assignment_list] = STATE(3157),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3158),
    [sym__variable] = STATE(3154),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3158),
    [sym_false] = STATE(3158),
    [sym_nil] = STATE(3158),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5749),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5265),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5269),
    [anon_sym_yield] = ACTIONS(5271),
    [anon_sym_break] = ACTIONS(5273),
    [anon_sym_next] = ACTIONS(5275),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(8973),
    [anon_sym_defined_QMARK] = ACTIONS(5277),
    [anon_sym_not] = ACTIONS(5279),
    [anon_sym_BANG] = ACTIONS(5283),
    [anon_sym_TILDE] = ACTIONS(5283),
    [sym_constant] = ACTIONS(5289),
    [sym_identifier] = ACTIONS(5289),
    [sym_instance_variable] = ACTIONS(5287),
    [sym_class_variable] = ACTIONS(5287),
    [sym_global_variable] = ACTIONS(5287),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5289),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5289),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5757] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8176),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3158),
    [sym_scope_resolution] = STATE(3154),
    [sym_call] = STATE(3154),
    [sym_method_call] = STATE(3158),
    [sym_assignment] = STATE(8176),
    [sym_operator_assignment] = STATE(8176),
    [sym_conditional] = STATE(8176),
    [sym_range] = STATE(8176),
    [sym_binary] = STATE(8176),
    [sym_unary] = STATE(8176),
    [sym_left_assignment_list] = STATE(3157),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3158),
    [sym__variable] = STATE(3154),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3158),
    [sym_false] = STATE(3158),
    [sym_nil] = STATE(3158),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5749),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5265),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5269),
    [anon_sym_yield] = ACTIONS(5271),
    [anon_sym_break] = ACTIONS(5273),
    [anon_sym_next] = ACTIONS(5275),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(8973),
    [anon_sym_defined_QMARK] = ACTIONS(5277),
    [anon_sym_not] = ACTIONS(5279),
    [anon_sym_BANG] = ACTIONS(5283),
    [anon_sym_TILDE] = ACTIONS(5283),
    [sym_constant] = ACTIONS(5289),
    [sym_identifier] = ACTIONS(5289),
    [sym_instance_variable] = ACTIONS(5287),
    [sym_class_variable] = ACTIONS(5287),
    [sym_global_variable] = ACTIONS(5287),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5289),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5289),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5758] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8177),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3158),
    [sym_scope_resolution] = STATE(3154),
    [sym_call] = STATE(3154),
    [sym_method_call] = STATE(3158),
    [sym_assignment] = STATE(8177),
    [sym_operator_assignment] = STATE(8177),
    [sym_conditional] = STATE(8177),
    [sym_range] = STATE(8177),
    [sym_binary] = STATE(8177),
    [sym_unary] = STATE(8177),
    [sym_left_assignment_list] = STATE(3157),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3158),
    [sym__variable] = STATE(3154),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3158),
    [sym_false] = STATE(3158),
    [sym_nil] = STATE(3158),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5749),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5265),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5269),
    [anon_sym_yield] = ACTIONS(5271),
    [anon_sym_break] = ACTIONS(5273),
    [anon_sym_next] = ACTIONS(5275),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(8973),
    [anon_sym_defined_QMARK] = ACTIONS(5277),
    [anon_sym_not] = ACTIONS(5279),
    [anon_sym_BANG] = ACTIONS(5283),
    [anon_sym_TILDE] = ACTIONS(5283),
    [sym_constant] = ACTIONS(5289),
    [sym_identifier] = ACTIONS(5289),
    [sym_instance_variable] = ACTIONS(5287),
    [sym_class_variable] = ACTIONS(5287),
    [sym_global_variable] = ACTIONS(5287),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5289),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5289),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5759] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(8178),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(8178),
    [sym_operator_assignment] = STATE(8178),
    [sym_conditional] = STATE(8178),
    [sym_range] = STATE(8178),
    [sym_binary] = STATE(8178),
    [sym_unary] = STATE(8178),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5760] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8179),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3158),
    [sym_scope_resolution] = STATE(3154),
    [sym_call] = STATE(3154),
    [sym_method_call] = STATE(3158),
    [sym_assignment] = STATE(8179),
    [sym_operator_assignment] = STATE(8179),
    [sym_conditional] = STATE(8179),
    [sym_range] = STATE(8179),
    [sym_binary] = STATE(8179),
    [sym_unary] = STATE(8179),
    [sym_left_assignment_list] = STATE(3157),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3158),
    [sym__variable] = STATE(3154),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3158),
    [sym_false] = STATE(3158),
    [sym_nil] = STATE(3158),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5749),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5265),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5269),
    [anon_sym_yield] = ACTIONS(5271),
    [anon_sym_break] = ACTIONS(5273),
    [anon_sym_next] = ACTIONS(5275),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(8973),
    [anon_sym_defined_QMARK] = ACTIONS(5277),
    [anon_sym_not] = ACTIONS(5279),
    [anon_sym_BANG] = ACTIONS(5283),
    [anon_sym_TILDE] = ACTIONS(5283),
    [sym_constant] = ACTIONS(5289),
    [sym_identifier] = ACTIONS(5289),
    [sym_instance_variable] = ACTIONS(5287),
    [sym_class_variable] = ACTIONS(5287),
    [sym_global_variable] = ACTIONS(5287),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5289),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5289),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5761] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8180),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3158),
    [sym_scope_resolution] = STATE(3154),
    [sym_call] = STATE(3154),
    [sym_method_call] = STATE(3158),
    [sym_assignment] = STATE(8180),
    [sym_operator_assignment] = STATE(8180),
    [sym_conditional] = STATE(8180),
    [sym_range] = STATE(8180),
    [sym_binary] = STATE(8180),
    [sym_unary] = STATE(8180),
    [sym_left_assignment_list] = STATE(3157),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3158),
    [sym__variable] = STATE(3154),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3158),
    [sym_false] = STATE(3158),
    [sym_nil] = STATE(3158),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5749),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5265),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5269),
    [anon_sym_yield] = ACTIONS(5271),
    [anon_sym_break] = ACTIONS(5273),
    [anon_sym_next] = ACTIONS(5275),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(8973),
    [anon_sym_defined_QMARK] = ACTIONS(5277),
    [anon_sym_not] = ACTIONS(5279),
    [anon_sym_BANG] = ACTIONS(5283),
    [anon_sym_TILDE] = ACTIONS(5283),
    [sym_constant] = ACTIONS(5289),
    [sym_identifier] = ACTIONS(5289),
    [sym_instance_variable] = ACTIONS(5287),
    [sym_class_variable] = ACTIONS(5287),
    [sym_global_variable] = ACTIONS(5287),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5289),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5289),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5762] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8181),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3158),
    [sym_scope_resolution] = STATE(3154),
    [sym_call] = STATE(3154),
    [sym_method_call] = STATE(3158),
    [sym_assignment] = STATE(8181),
    [sym_operator_assignment] = STATE(8181),
    [sym_conditional] = STATE(8181),
    [sym_range] = STATE(8181),
    [sym_binary] = STATE(8181),
    [sym_unary] = STATE(8181),
    [sym_left_assignment_list] = STATE(3157),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3158),
    [sym__variable] = STATE(3154),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3158),
    [sym_false] = STATE(3158),
    [sym_nil] = STATE(3158),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5749),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5265),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5269),
    [anon_sym_yield] = ACTIONS(5271),
    [anon_sym_break] = ACTIONS(5273),
    [anon_sym_next] = ACTIONS(5275),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(8973),
    [anon_sym_defined_QMARK] = ACTIONS(5277),
    [anon_sym_not] = ACTIONS(5279),
    [anon_sym_BANG] = ACTIONS(5283),
    [anon_sym_TILDE] = ACTIONS(5283),
    [sym_constant] = ACTIONS(5289),
    [sym_identifier] = ACTIONS(5289),
    [sym_instance_variable] = ACTIONS(5287),
    [sym_class_variable] = ACTIONS(5287),
    [sym_global_variable] = ACTIONS(5287),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5289),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5289),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5763] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8182),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3158),
    [sym_scope_resolution] = STATE(3154),
    [sym_call] = STATE(3154),
    [sym_method_call] = STATE(3158),
    [sym_assignment] = STATE(8182),
    [sym_operator_assignment] = STATE(8182),
    [sym_conditional] = STATE(8182),
    [sym_range] = STATE(8182),
    [sym_binary] = STATE(8182),
    [sym_unary] = STATE(8182),
    [sym_left_assignment_list] = STATE(3157),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3158),
    [sym__variable] = STATE(3154),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3158),
    [sym_false] = STATE(3158),
    [sym_nil] = STATE(3158),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5749),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5265),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5269),
    [anon_sym_yield] = ACTIONS(5271),
    [anon_sym_break] = ACTIONS(5273),
    [anon_sym_next] = ACTIONS(5275),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(8973),
    [anon_sym_defined_QMARK] = ACTIONS(5277),
    [anon_sym_not] = ACTIONS(5279),
    [anon_sym_BANG] = ACTIONS(5283),
    [anon_sym_TILDE] = ACTIONS(5283),
    [sym_constant] = ACTIONS(5289),
    [sym_identifier] = ACTIONS(5289),
    [sym_instance_variable] = ACTIONS(5287),
    [sym_class_variable] = ACTIONS(5287),
    [sym_global_variable] = ACTIONS(5287),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5289),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5289),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5764] = {
    [sym_heredoc_body] = STATE(8183),
    [aux_sym_call_repeat1] = STATE(8183),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_ensure] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [5765] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3153),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3158),
    [sym_scope_resolution] = STATE(3154),
    [sym_call] = STATE(3154),
    [sym_method_call] = STATE(3158),
    [sym__argument] = STATE(3737),
    [sym_splat_argument] = STATE(3737),
    [sym_hash_splat_argument] = STATE(3737),
    [sym_block_argument] = STATE(3737),
    [sym_assignment] = STATE(3153),
    [sym_operator_assignment] = STATE(3153),
    [sym_conditional] = STATE(3153),
    [sym_range] = STATE(3153),
    [sym_binary] = STATE(3153),
    [sym_unary] = STATE(3153),
    [sym_left_assignment_list] = STATE(3157),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3158),
    [sym__variable] = STATE(3154),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3158),
    [sym_false] = STATE(3158),
    [sym_nil] = STATE(3158),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3159),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_heredoc_body] = STATE(8184),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(3737),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(5261),
    [sym__splat_star] = ACTIONS(5263),
    [sym__unary_minus] = ACTIONS(5265),
    [sym__identifier_hash_key] = ACTIONS(5267),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11688),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5269),
    [anon_sym_yield] = ACTIONS(5271),
    [anon_sym_break] = ACTIONS(5273),
    [anon_sym_next] = ACTIONS(5275),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(8973),
    [anon_sym_defined_QMARK] = ACTIONS(5277),
    [anon_sym_not] = ACTIONS(5279),
    [anon_sym_BANG] = ACTIONS(5283),
    [anon_sym_TILDE] = ACTIONS(5283),
    [sym_constant] = ACTIONS(5285),
    [sym_identifier] = ACTIONS(5285),
    [sym_instance_variable] = ACTIONS(5287),
    [sym_class_variable] = ACTIONS(5287),
    [sym_global_variable] = ACTIONS(5287),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5289),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5289),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5766] = {
    [sym_heredoc_body] = STATE(8185),
    [aux_sym_call_repeat1] = STATE(8185),
    [aux_sym_argument_list_repeat1] = STATE(8186),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(9007),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_ensure] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [5767] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8187),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3158),
    [sym_scope_resolution] = STATE(3154),
    [sym_call] = STATE(3154),
    [sym_method_call] = STATE(3158),
    [sym_splat_argument] = STATE(8188),
    [sym_assignment] = STATE(8187),
    [sym_operator_assignment] = STATE(8187),
    [sym_conditional] = STATE(8187),
    [sym_range] = STATE(8187),
    [sym_binary] = STATE(8187),
    [sym_unary] = STATE(8187),
    [sym_right_assignment_list] = STATE(3742),
    [sym__arg_or_splat_arg] = STATE(8188),
    [sym_left_assignment_list] = STATE(3157),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3158),
    [sym__variable] = STATE(3154),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3158),
    [sym_false] = STATE(3158),
    [sym_nil] = STATE(3158),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5749),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__splat_star] = ACTIONS(8935),
    [sym__unary_minus] = ACTIONS(5265),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5269),
    [anon_sym_yield] = ACTIONS(5271),
    [anon_sym_break] = ACTIONS(5273),
    [anon_sym_next] = ACTIONS(5275),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(8973),
    [anon_sym_defined_QMARK] = ACTIONS(5277),
    [anon_sym_not] = ACTIONS(5279),
    [anon_sym_BANG] = ACTIONS(5283),
    [anon_sym_TILDE] = ACTIONS(5283),
    [sym_constant] = ACTIONS(5289),
    [sym_identifier] = ACTIONS(5289),
    [sym_instance_variable] = ACTIONS(5287),
    [sym_class_variable] = ACTIONS(5287),
    [sym_global_variable] = ACTIONS(5287),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5289),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5289),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5768] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8189),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3158),
    [sym_scope_resolution] = STATE(3154),
    [sym_call] = STATE(3154),
    [sym_method_call] = STATE(3158),
    [sym_assignment] = STATE(8189),
    [sym_operator_assignment] = STATE(8189),
    [sym_conditional] = STATE(8189),
    [sym_range] = STATE(8189),
    [sym_binary] = STATE(8189),
    [sym_unary] = STATE(8189),
    [sym_left_assignment_list] = STATE(3157),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3158),
    [sym__variable] = STATE(3154),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3158),
    [sym_false] = STATE(3158),
    [sym_nil] = STATE(3158),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5749),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5265),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5269),
    [anon_sym_yield] = ACTIONS(5271),
    [anon_sym_break] = ACTIONS(5273),
    [anon_sym_next] = ACTIONS(5275),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(8973),
    [anon_sym_defined_QMARK] = ACTIONS(5277),
    [anon_sym_not] = ACTIONS(5279),
    [anon_sym_BANG] = ACTIONS(5283),
    [anon_sym_TILDE] = ACTIONS(5283),
    [sym_constant] = ACTIONS(5289),
    [sym_identifier] = ACTIONS(5289),
    [sym_instance_variable] = ACTIONS(5287),
    [sym_class_variable] = ACTIONS(5287),
    [sym_global_variable] = ACTIONS(5287),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5289),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5289),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5769] = {
    [sym_string] = STATE(8190),
    [aux_sym_chained_string_repeat1] = STATE(8190),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(747),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2755),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_EQ] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_end] = ACTIONS(2753),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_ensure] = ACTIONS(2753),
    [anon_sym_EQ_GT] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_PLUS_EQ] = ACTIONS(2753),
    [anon_sym_DASH_EQ] = ACTIONS(2753),
    [anon_sym_STAR_EQ] = ACTIONS(2753),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2753),
    [anon_sym_SLASH_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2753),
    [anon_sym_AMP_EQ] = ACTIONS(2753),
    [anon_sym_PERCENT_EQ] = ACTIONS(2753),
    [anon_sym_GT_GT_EQ] = ACTIONS(2753),
    [anon_sym_LT_LT_EQ] = ACTIONS(2753),
    [anon_sym_CARET_EQ] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2755),
    [anon_sym_AMP_AMP] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2755),
    [anon_sym_GT_GT] = ACTIONS(2755),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_SLASH] = ACTIONS(2755),
    [anon_sym_PERCENT] = ACTIONS(2755),
    [sym_comment] = ACTIONS(87),
  },
  [5770] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8191),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5777),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(5777),
    [sym_assignment] = STATE(8191),
    [sym_operator_assignment] = STATE(8191),
    [sym_conditional] = STATE(8191),
    [sym_range] = STATE(8191),
    [sym_binary] = STATE(8191),
    [sym_unary] = STATE(8191),
    [sym_left_assignment_list] = STATE(5776),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5777),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5777),
    [sym_false] = STATE(5777),
    [sym_nil] = STATE(5777),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5677),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9019),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8877),
    [anon_sym_yield] = ACTIONS(8879),
    [anon_sym_break] = ACTIONS(8881),
    [anon_sym_next] = ACTIONS(8883),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9021),
    [anon_sym_defined_QMARK] = ACTIONS(9023),
    [anon_sym_not] = ACTIONS(9025),
    [anon_sym_BANG] = ACTIONS(9027),
    [anon_sym_TILDE] = ACTIONS(9027),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5771] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8192),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5777),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(5777),
    [sym_assignment] = STATE(8192),
    [sym_operator_assignment] = STATE(8192),
    [sym_conditional] = STATE(8192),
    [sym_range] = STATE(8192),
    [sym_binary] = STATE(8192),
    [sym_unary] = STATE(8192),
    [sym_left_assignment_list] = STATE(5776),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5777),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5777),
    [sym_false] = STATE(5777),
    [sym_nil] = STATE(5777),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5677),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9019),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8877),
    [anon_sym_yield] = ACTIONS(8879),
    [anon_sym_break] = ACTIONS(8881),
    [anon_sym_next] = ACTIONS(8883),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9021),
    [anon_sym_defined_QMARK] = ACTIONS(9023),
    [anon_sym_not] = ACTIONS(9025),
    [anon_sym_BANG] = ACTIONS(9027),
    [anon_sym_TILDE] = ACTIONS(9027),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5772] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8193),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5777),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(5777),
    [sym_assignment] = STATE(8193),
    [sym_operator_assignment] = STATE(8193),
    [sym_conditional] = STATE(8193),
    [sym_range] = STATE(8193),
    [sym_binary] = STATE(8193),
    [sym_unary] = STATE(8193),
    [sym_left_assignment_list] = STATE(5776),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5777),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5777),
    [sym_false] = STATE(5777),
    [sym_nil] = STATE(5777),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5677),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9019),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8877),
    [anon_sym_yield] = ACTIONS(8879),
    [anon_sym_break] = ACTIONS(8881),
    [anon_sym_next] = ACTIONS(8883),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9021),
    [anon_sym_defined_QMARK] = ACTIONS(9023),
    [anon_sym_not] = ACTIONS(9025),
    [anon_sym_BANG] = ACTIONS(9027),
    [anon_sym_TILDE] = ACTIONS(9027),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5773] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(298),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5777),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(5777),
    [sym_assignment] = STATE(298),
    [sym_operator_assignment] = STATE(298),
    [sym_conditional] = STATE(298),
    [sym_range] = STATE(298),
    [sym_binary] = STATE(298),
    [sym_unary] = STATE(298),
    [sym_left_assignment_list] = STATE(5776),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5777),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5777),
    [sym_false] = STATE(5777),
    [sym_nil] = STATE(5777),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5677),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9019),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8877),
    [anon_sym_yield] = ACTIONS(8879),
    [anon_sym_break] = ACTIONS(8881),
    [anon_sym_next] = ACTIONS(8883),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9021),
    [anon_sym_defined_QMARK] = ACTIONS(9023),
    [anon_sym_not] = ACTIONS(9025),
    [anon_sym_BANG] = ACTIONS(9027),
    [anon_sym_TILDE] = ACTIONS(9027),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5774] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(11690),
    [sym__binary_star] = ACTIONS(11692),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(11694),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(11692),
    [anon_sym_AMP] = ACTIONS(11696),
    [anon_sym_LT] = ACTIONS(11698),
    [anon_sym_end] = ACTIONS(5115),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_ensure] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(11700),
    [anon_sym_DOT_DOT] = ACTIONS(11702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11704),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(11706),
    [anon_sym_AMP_AMP] = ACTIONS(11706),
    [anon_sym_LT_LT] = ACTIONS(11708),
    [anon_sym_GT_GT] = ACTIONS(11708),
    [anon_sym_EQ_EQ] = ACTIONS(11710),
    [anon_sym_BANG_EQ] = ACTIONS(11706),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11706),
    [anon_sym_LT_EQ_GT] = ACTIONS(11706),
    [anon_sym_EQ_TILDE] = ACTIONS(11706),
    [anon_sym_BANG_TILDE] = ACTIONS(11706),
    [anon_sym_LT_EQ] = ACTIONS(11698),
    [anon_sym_GT] = ACTIONS(11698),
    [anon_sym_GT_EQ] = ACTIONS(11712),
    [anon_sym_CARET] = ACTIONS(11714),
    [anon_sym_PLUS] = ACTIONS(11690),
    [anon_sym_SLASH] = ACTIONS(11692),
    [anon_sym_PERCENT] = ACTIONS(11692),
    [sym_comment] = ACTIONS(87),
  },
  [5775] = {
    [aux_sym_exceptions_repeat1] = STATE(8205),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_COMMA] = ACTIONS(11716),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_end] = ACTIONS(6191),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_ensure] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [5776] = {
    [anon_sym_EQ] = ACTIONS(11718),
    [sym_comment] = ACTIONS(87),
  },
  [5777] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(11720),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(11722),
    [anon_sym_DASH_EQ] = ACTIONS(11722),
    [anon_sym_STAR_EQ] = ACTIONS(11722),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11722),
    [anon_sym_SLASH_EQ] = ACTIONS(11722),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11722),
    [anon_sym_PIPE_EQ] = ACTIONS(11722),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11722),
    [anon_sym_AMP_EQ] = ACTIONS(11722),
    [anon_sym_PERCENT_EQ] = ACTIONS(11722),
    [anon_sym_GT_GT_EQ] = ACTIONS(11722),
    [anon_sym_LT_LT_EQ] = ACTIONS(11722),
    [anon_sym_CARET_EQ] = ACTIONS(11722),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5778] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(5233),
    [sym__binary_star] = ACTIONS(5235),
    [anon_sym_PIPE] = ACTIONS(5237),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(5235),
    [anon_sym_AMP] = ACTIONS(5239),
    [anon_sym_LT] = ACTIONS(5241),
    [anon_sym_end] = ACTIONS(6210),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_ensure] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(5243),
    [anon_sym_DOT_DOT] = ACTIONS(5245),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5247),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(5251),
    [anon_sym_AMP_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5253),
    [anon_sym_GT_GT] = ACTIONS(5253),
    [anon_sym_EQ_EQ] = ACTIONS(5255),
    [anon_sym_BANG_EQ] = ACTIONS(5251),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5251),
    [anon_sym_LT_EQ_GT] = ACTIONS(5251),
    [anon_sym_EQ_TILDE] = ACTIONS(5251),
    [anon_sym_BANG_TILDE] = ACTIONS(5251),
    [anon_sym_LT_EQ] = ACTIONS(5241),
    [anon_sym_GT] = ACTIONS(5241),
    [anon_sym_GT_EQ] = ACTIONS(5257),
    [anon_sym_CARET] = ACTIONS(5259),
    [anon_sym_PLUS] = ACTIONS(5233),
    [anon_sym_SLASH] = ACTIONS(5235),
    [anon_sym_PERCENT] = ACTIONS(5235),
    [sym_comment] = ACTIONS(87),
  },
  [5779] = {
    [sym_string] = STATE(5779),
    [aux_sym_chained_string_repeat1] = STATE(5779),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(6214),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_end] = ACTIONS(6212),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_ensure] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [5780] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8208),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5789),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(5789),
    [sym_assignment] = STATE(8208),
    [sym_operator_assignment] = STATE(8208),
    [sym_conditional] = STATE(8208),
    [sym_range] = STATE(8208),
    [sym_binary] = STATE(8208),
    [sym_unary] = STATE(8208),
    [sym_left_assignment_list] = STATE(5788),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5789),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5789),
    [sym_false] = STATE(5789),
    [sym_nil] = STATE(5789),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5790),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9031),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9033),
    [anon_sym_yield] = ACTIONS(9035),
    [anon_sym_break] = ACTIONS(9037),
    [anon_sym_next] = ACTIONS(9039),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9041),
    [anon_sym_defined_QMARK] = ACTIONS(9043),
    [anon_sym_not] = ACTIONS(9045),
    [anon_sym_BANG] = ACTIONS(9047),
    [anon_sym_TILDE] = ACTIONS(9047),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5781] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3179),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3184),
    [sym_scope_resolution] = STATE(3180),
    [sym_call] = STATE(3180),
    [sym_method_call] = STATE(3184),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(8209),
    [sym__argument] = STATE(8210),
    [sym_splat_argument] = STATE(8210),
    [sym_hash_splat_argument] = STATE(8210),
    [sym_block_argument] = STATE(8210),
    [sym_assignment] = STATE(3179),
    [sym_operator_assignment] = STATE(3179),
    [sym_conditional] = STATE(3179),
    [sym_range] = STATE(3179),
    [sym_binary] = STATE(3179),
    [sym_unary] = STATE(3179),
    [sym_left_assignment_list] = STATE(3183),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3184),
    [sym__variable] = STATE(3180),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3184),
    [sym_false] = STATE(3184),
    [sym_nil] = STATE(3184),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3185),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(8210),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(5299),
    [sym__splat_star] = ACTIONS(5301),
    [sym__unary_minus] = ACTIONS(5303),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(5305),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(5307),
    [anon_sym_yield] = ACTIONS(5309),
    [anon_sym_break] = ACTIONS(5311),
    [anon_sym_next] = ACTIONS(5313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(5315),
    [anon_sym_not] = ACTIONS(5317),
    [anon_sym_BANG] = ACTIONS(5319),
    [anon_sym_TILDE] = ACTIONS(5321),
    [sym_constant] = ACTIONS(5323),
    [sym_identifier] = ACTIONS(5323),
    [sym_instance_variable] = ACTIONS(5325),
    [sym_class_variable] = ACTIONS(5325),
    [sym_global_variable] = ACTIONS(5325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5782] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3179),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3184),
    [sym_scope_resolution] = STATE(3180),
    [sym_call] = STATE(3180),
    [sym_method_call] = STATE(3184),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(8209),
    [sym__argument] = STATE(8210),
    [sym_splat_argument] = STATE(8210),
    [sym_hash_splat_argument] = STATE(8210),
    [sym_block_argument] = STATE(8210),
    [sym_assignment] = STATE(3179),
    [sym_operator_assignment] = STATE(3179),
    [sym_conditional] = STATE(3179),
    [sym_range] = STATE(3179),
    [sym_binary] = STATE(3179),
    [sym_unary] = STATE(3179),
    [sym_left_assignment_list] = STATE(3183),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3184),
    [sym__variable] = STATE(3180),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3184),
    [sym_false] = STATE(3184),
    [sym_nil] = STATE(3184),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3185),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(8210),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(5299),
    [sym__splat_star] = ACTIONS(5301),
    [sym__unary_minus] = ACTIONS(5303),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(5305),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(5307),
    [anon_sym_yield] = ACTIONS(5309),
    [anon_sym_break] = ACTIONS(5311),
    [anon_sym_next] = ACTIONS(5313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(5315),
    [anon_sym_not] = ACTIONS(5317),
    [anon_sym_BANG] = ACTIONS(5319),
    [anon_sym_TILDE] = ACTIONS(5321),
    [sym_constant] = ACTIONS(5323),
    [sym_identifier] = ACTIONS(5323),
    [sym_instance_variable] = ACTIONS(5325),
    [sym_class_variable] = ACTIONS(5325),
    [sym_global_variable] = ACTIONS(5325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5783] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3179),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3184),
    [sym_scope_resolution] = STATE(3180),
    [sym_call] = STATE(3180),
    [sym_method_call] = STATE(3184),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(8209),
    [sym__argument] = STATE(8210),
    [sym_splat_argument] = STATE(8210),
    [sym_hash_splat_argument] = STATE(8210),
    [sym_block_argument] = STATE(8210),
    [sym_assignment] = STATE(3179),
    [sym_operator_assignment] = STATE(3179),
    [sym_conditional] = STATE(3179),
    [sym_range] = STATE(3179),
    [sym_binary] = STATE(3179),
    [sym_unary] = STATE(3179),
    [sym_left_assignment_list] = STATE(3183),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3184),
    [sym__variable] = STATE(3180),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3184),
    [sym_false] = STATE(3184),
    [sym_nil] = STATE(3184),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3185),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(8210),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(5299),
    [sym__splat_star] = ACTIONS(5301),
    [sym__unary_minus] = ACTIONS(5303),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(5305),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(423),
    [anon_sym_return] = ACTIONS(5307),
    [anon_sym_yield] = ACTIONS(5309),
    [anon_sym_break] = ACTIONS(5311),
    [anon_sym_next] = ACTIONS(5313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(5315),
    [anon_sym_not] = ACTIONS(5317),
    [anon_sym_BANG] = ACTIONS(5319),
    [anon_sym_TILDE] = ACTIONS(5321),
    [sym_constant] = ACTIONS(5323),
    [sym_identifier] = ACTIONS(5323),
    [sym_instance_variable] = ACTIONS(5325),
    [sym_class_variable] = ACTIONS(5325),
    [sym_global_variable] = ACTIONS(5325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5784] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3179),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3184),
    [sym_scope_resolution] = STATE(3180),
    [sym_call] = STATE(3180),
    [sym_method_call] = STATE(3184),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(8209),
    [sym__argument] = STATE(8210),
    [sym_splat_argument] = STATE(8210),
    [sym_hash_splat_argument] = STATE(8210),
    [sym_block_argument] = STATE(8210),
    [sym_assignment] = STATE(3179),
    [sym_operator_assignment] = STATE(3179),
    [sym_conditional] = STATE(3179),
    [sym_range] = STATE(3179),
    [sym_binary] = STATE(3179),
    [sym_unary] = STATE(3179),
    [sym_left_assignment_list] = STATE(3183),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3184),
    [sym__variable] = STATE(3180),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3184),
    [sym_false] = STATE(3184),
    [sym_nil] = STATE(3184),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3185),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(8210),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(5299),
    [sym__splat_star] = ACTIONS(5301),
    [sym__unary_minus] = ACTIONS(5303),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(5305),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(427),
    [anon_sym_return] = ACTIONS(5307),
    [anon_sym_yield] = ACTIONS(5309),
    [anon_sym_break] = ACTIONS(5311),
    [anon_sym_next] = ACTIONS(5313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(5315),
    [anon_sym_not] = ACTIONS(5317),
    [anon_sym_BANG] = ACTIONS(5319),
    [anon_sym_TILDE] = ACTIONS(5321),
    [sym_constant] = ACTIONS(5323),
    [sym_identifier] = ACTIONS(5323),
    [sym_instance_variable] = ACTIONS(5325),
    [sym_class_variable] = ACTIONS(5325),
    [sym_global_variable] = ACTIONS(5325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5785] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8211),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5789),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(5789),
    [sym_assignment] = STATE(8211),
    [sym_operator_assignment] = STATE(8211),
    [sym_conditional] = STATE(8211),
    [sym_range] = STATE(8211),
    [sym_binary] = STATE(8211),
    [sym_unary] = STATE(8211),
    [sym_left_assignment_list] = STATE(5788),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5789),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5789),
    [sym_false] = STATE(5789),
    [sym_nil] = STATE(5789),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5790),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9031),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9033),
    [anon_sym_yield] = ACTIONS(9035),
    [anon_sym_break] = ACTIONS(9037),
    [anon_sym_next] = ACTIONS(9039),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9041),
    [anon_sym_defined_QMARK] = ACTIONS(9043),
    [anon_sym_not] = ACTIONS(9045),
    [anon_sym_BANG] = ACTIONS(9047),
    [anon_sym_TILDE] = ACTIONS(9047),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5786] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5789),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(5789),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(5788),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5789),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5789),
    [sym_false] = STATE(5789),
    [sym_nil] = STATE(5789),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5790),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9031),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9033),
    [anon_sym_yield] = ACTIONS(9035),
    [anon_sym_break] = ACTIONS(9037),
    [anon_sym_next] = ACTIONS(9039),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9041),
    [anon_sym_defined_QMARK] = ACTIONS(9043),
    [anon_sym_not] = ACTIONS(9045),
    [anon_sym_BANG] = ACTIONS(9047),
    [anon_sym_TILDE] = ACTIONS(9047),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5787] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(11724),
    [sym__binary_star] = ACTIONS(11726),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(11728),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(11726),
    [anon_sym_AMP] = ACTIONS(11730),
    [anon_sym_LT] = ACTIONS(11732),
    [anon_sym_end] = ACTIONS(4211),
    [anon_sym_if] = ACTIONS(4211),
    [anon_sym_unless] = ACTIONS(4211),
    [anon_sym_while] = ACTIONS(4211),
    [anon_sym_until] = ACTIONS(4211),
    [anon_sym_rescue] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(11734),
    [anon_sym_DOT_DOT] = ACTIONS(11736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11738),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11740),
    [anon_sym_AMP_AMP] = ACTIONS(11740),
    [anon_sym_LT_LT] = ACTIONS(11742),
    [anon_sym_GT_GT] = ACTIONS(11742),
    [anon_sym_EQ_EQ] = ACTIONS(11744),
    [anon_sym_BANG_EQ] = ACTIONS(11740),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11740),
    [anon_sym_LT_EQ_GT] = ACTIONS(11740),
    [anon_sym_EQ_TILDE] = ACTIONS(11740),
    [anon_sym_BANG_TILDE] = ACTIONS(11740),
    [anon_sym_LT_EQ] = ACTIONS(11732),
    [anon_sym_GT] = ACTIONS(11732),
    [anon_sym_GT_EQ] = ACTIONS(11746),
    [anon_sym_CARET] = ACTIONS(11748),
    [anon_sym_PLUS] = ACTIONS(11724),
    [anon_sym_SLASH] = ACTIONS(11726),
    [anon_sym_PERCENT] = ACTIONS(11726),
    [sym_comment] = ACTIONS(87),
  },
  [5788] = {
    [anon_sym_EQ] = ACTIONS(11750),
    [sym_comment] = ACTIONS(87),
  },
  [5789] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(11752),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(11754),
    [anon_sym_DASH_EQ] = ACTIONS(11754),
    [anon_sym_STAR_EQ] = ACTIONS(11754),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11754),
    [anon_sym_SLASH_EQ] = ACTIONS(11754),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11754),
    [anon_sym_PIPE_EQ] = ACTIONS(11754),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11754),
    [anon_sym_AMP_EQ] = ACTIONS(11754),
    [anon_sym_PERCENT_EQ] = ACTIONS(11754),
    [anon_sym_GT_GT_EQ] = ACTIONS(11754),
    [anon_sym_LT_LT_EQ] = ACTIONS(11754),
    [anon_sym_CARET_EQ] = ACTIONS(11754),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5790] = {
    [sym_string] = STATE(8224),
    [aux_sym_chained_string_repeat1] = STATE(8224),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [5791] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(11724),
    [sym__binary_star] = ACTIONS(11726),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(11728),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(11726),
    [anon_sym_AMP] = ACTIONS(11730),
    [anon_sym_LT] = ACTIONS(11732),
    [anon_sym_end] = ACTIONS(4247),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(11734),
    [anon_sym_DOT_DOT] = ACTIONS(11736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11738),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(11740),
    [anon_sym_AMP_AMP] = ACTIONS(11740),
    [anon_sym_LT_LT] = ACTIONS(11742),
    [anon_sym_GT_GT] = ACTIONS(11742),
    [anon_sym_EQ_EQ] = ACTIONS(11744),
    [anon_sym_BANG_EQ] = ACTIONS(11740),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11740),
    [anon_sym_LT_EQ_GT] = ACTIONS(11740),
    [anon_sym_EQ_TILDE] = ACTIONS(11740),
    [anon_sym_BANG_TILDE] = ACTIONS(11740),
    [anon_sym_LT_EQ] = ACTIONS(11732),
    [anon_sym_GT] = ACTIONS(11732),
    [anon_sym_GT_EQ] = ACTIONS(11746),
    [anon_sym_CARET] = ACTIONS(11748),
    [anon_sym_PLUS] = ACTIONS(11724),
    [anon_sym_SLASH] = ACTIONS(11726),
    [anon_sym_PERCENT] = ACTIONS(11726),
    [sym_comment] = ACTIONS(87),
  },
  [5792] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(9065),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [5793] = {
    [sym_string] = STATE(5831),
    [aux_sym_chained_string_repeat1] = STATE(5831),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [5794] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8225),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5789),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(5789),
    [sym_assignment] = STATE(8225),
    [sym_operator_assignment] = STATE(8225),
    [sym_conditional] = STATE(8225),
    [sym_range] = STATE(8225),
    [sym_binary] = STATE(8225),
    [sym_unary] = STATE(8225),
    [sym_left_assignment_list] = STATE(5788),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5789),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5789),
    [sym_false] = STATE(5789),
    [sym_nil] = STATE(5789),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5790),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9031),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9033),
    [anon_sym_yield] = ACTIONS(9035),
    [anon_sym_break] = ACTIONS(9037),
    [anon_sym_next] = ACTIONS(9039),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9041),
    [anon_sym_defined_QMARK] = ACTIONS(9043),
    [anon_sym_not] = ACTIONS(9045),
    [anon_sym_BANG] = ACTIONS(9047),
    [anon_sym_TILDE] = ACTIONS(9047),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5795] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(11724),
    [sym__binary_star] = ACTIONS(11726),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(11728),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(11726),
    [anon_sym_AMP] = ACTIONS(11730),
    [anon_sym_LT] = ACTIONS(11732),
    [anon_sym_end] = ACTIONS(3281),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_unless] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_until] = ACTIONS(3281),
    [anon_sym_rescue] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(11734),
    [anon_sym_DOT_DOT] = ACTIONS(11736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11738),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(11740),
    [anon_sym_AMP_AMP] = ACTIONS(11740),
    [anon_sym_LT_LT] = ACTIONS(11742),
    [anon_sym_GT_GT] = ACTIONS(11742),
    [anon_sym_EQ_EQ] = ACTIONS(11744),
    [anon_sym_BANG_EQ] = ACTIONS(11740),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11740),
    [anon_sym_LT_EQ_GT] = ACTIONS(11740),
    [anon_sym_EQ_TILDE] = ACTIONS(11740),
    [anon_sym_BANG_TILDE] = ACTIONS(11740),
    [anon_sym_LT_EQ] = ACTIONS(11732),
    [anon_sym_GT] = ACTIONS(11732),
    [anon_sym_GT_EQ] = ACTIONS(11746),
    [anon_sym_CARET] = ACTIONS(11748),
    [anon_sym_PLUS] = ACTIONS(11724),
    [anon_sym_SLASH] = ACTIONS(11726),
    [anon_sym_PERCENT] = ACTIONS(11726),
    [sym_comment] = ACTIONS(87),
  },
  [5796] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8226),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3184),
    [sym_scope_resolution] = STATE(3180),
    [sym_call] = STATE(3180),
    [sym_method_call] = STATE(3184),
    [sym_assignment] = STATE(8226),
    [sym_operator_assignment] = STATE(8226),
    [sym_conditional] = STATE(8226),
    [sym_range] = STATE(8226),
    [sym_binary] = STATE(8226),
    [sym_unary] = STATE(8226),
    [sym_left_assignment_list] = STATE(3183),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3184),
    [sym__variable] = STATE(3180),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3184),
    [sym_false] = STATE(3184),
    [sym_nil] = STATE(3184),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5793),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5307),
    [anon_sym_yield] = ACTIONS(5309),
    [anon_sym_break] = ACTIONS(5311),
    [anon_sym_next] = ACTIONS(5313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9049),
    [anon_sym_defined_QMARK] = ACTIONS(5315),
    [anon_sym_not] = ACTIONS(5317),
    [anon_sym_BANG] = ACTIONS(5321),
    [anon_sym_TILDE] = ACTIONS(5321),
    [sym_constant] = ACTIONS(5327),
    [sym_identifier] = ACTIONS(5327),
    [sym_instance_variable] = ACTIONS(5325),
    [sym_class_variable] = ACTIONS(5325),
    [sym_global_variable] = ACTIONS(5325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5797] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8227),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3184),
    [sym_scope_resolution] = STATE(3180),
    [sym_call] = STATE(3180),
    [sym_method_call] = STATE(3184),
    [sym_assignment] = STATE(8227),
    [sym_operator_assignment] = STATE(8227),
    [sym_conditional] = STATE(8227),
    [sym_range] = STATE(8227),
    [sym_binary] = STATE(8227),
    [sym_unary] = STATE(8227),
    [sym_left_assignment_list] = STATE(3183),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3184),
    [sym__variable] = STATE(3180),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3184),
    [sym_false] = STATE(3184),
    [sym_nil] = STATE(3184),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5793),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5307),
    [anon_sym_yield] = ACTIONS(5309),
    [anon_sym_break] = ACTIONS(5311),
    [anon_sym_next] = ACTIONS(5313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9049),
    [anon_sym_defined_QMARK] = ACTIONS(5315),
    [anon_sym_not] = ACTIONS(5317),
    [anon_sym_BANG] = ACTIONS(5321),
    [anon_sym_TILDE] = ACTIONS(5321),
    [sym_constant] = ACTIONS(5327),
    [sym_identifier] = ACTIONS(5327),
    [sym_instance_variable] = ACTIONS(5325),
    [sym_class_variable] = ACTIONS(5325),
    [sym_global_variable] = ACTIONS(5325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5798] = {
    [anon_sym_COLON] = ACTIONS(11756),
    [sym_comment] = ACTIONS(87),
  },
  [5799] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8229),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3184),
    [sym_scope_resolution] = STATE(3180),
    [sym_call] = STATE(3180),
    [sym_method_call] = STATE(3184),
    [sym_assignment] = STATE(8229),
    [sym_operator_assignment] = STATE(8229),
    [sym_conditional] = STATE(8229),
    [sym_range] = STATE(8229),
    [sym_binary] = STATE(8229),
    [sym_unary] = STATE(8229),
    [sym_left_assignment_list] = STATE(3183),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3184),
    [sym__variable] = STATE(3180),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3184),
    [sym_false] = STATE(3184),
    [sym_nil] = STATE(3184),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5793),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5307),
    [anon_sym_yield] = ACTIONS(5309),
    [anon_sym_break] = ACTIONS(5311),
    [anon_sym_next] = ACTIONS(5313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9049),
    [anon_sym_defined_QMARK] = ACTIONS(5315),
    [anon_sym_not] = ACTIONS(5317),
    [anon_sym_BANG] = ACTIONS(5321),
    [anon_sym_TILDE] = ACTIONS(5321),
    [sym_constant] = ACTIONS(5327),
    [sym_identifier] = ACTIONS(5327),
    [sym_instance_variable] = ACTIONS(5325),
    [sym_class_variable] = ACTIONS(5325),
    [sym_global_variable] = ACTIONS(5325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5800] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(11758),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [5801] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(9063),
    [sym__binary_star] = ACTIONS(9065),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(9067),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(9065),
    [anon_sym_AMP] = ACTIONS(9069),
    [anon_sym_LT] = ACTIONS(9071),
    [anon_sym_end] = ACTIONS(1625),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_unless] = ACTIONS(1625),
    [anon_sym_while] = ACTIONS(1625),
    [anon_sym_until] = ACTIONS(1625),
    [anon_sym_rescue] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(1625),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(9073),
    [anon_sym_DOT_DOT] = ACTIONS(9075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9077),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(9079),
    [anon_sym_AMP_AMP] = ACTIONS(9079),
    [anon_sym_LT_LT] = ACTIONS(9081),
    [anon_sym_GT_GT] = ACTIONS(9081),
    [anon_sym_EQ_EQ] = ACTIONS(9083),
    [anon_sym_BANG_EQ] = ACTIONS(9079),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9079),
    [anon_sym_LT_EQ_GT] = ACTIONS(9079),
    [anon_sym_EQ_TILDE] = ACTIONS(9079),
    [anon_sym_BANG_TILDE] = ACTIONS(9079),
    [anon_sym_LT_EQ] = ACTIONS(9071),
    [anon_sym_GT] = ACTIONS(9071),
    [anon_sym_GT_EQ] = ACTIONS(9085),
    [anon_sym_CARET] = ACTIONS(9087),
    [anon_sym_PLUS] = ACTIONS(9063),
    [anon_sym_SLASH] = ACTIONS(9065),
    [anon_sym_PERCENT] = ACTIONS(9065),
    [sym_comment] = ACTIONS(87),
  },
  [5802] = {
    [sym_heredoc_body] = STATE(8231),
    [aux_sym_call_repeat1] = STATE(8231),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [5803] = {
    [sym_heredoc_body] = STATE(8231),
    [aux_sym_call_repeat1] = STATE(8231),
    [aux_sym_argument_list_repeat1] = STATE(8233),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(11760),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [5804] = {
    [sym_string] = STATE(5831),
    [aux_sym_chained_string_repeat1] = STATE(5831),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(11762),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [5805] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(9063),
    [sym__binary_star] = ACTIONS(9065),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(9067),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(9065),
    [anon_sym_AMP] = ACTIONS(9069),
    [anon_sym_LT] = ACTIONS(9071),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(9073),
    [anon_sym_DOT_DOT] = ACTIONS(9075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9077),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(9079),
    [anon_sym_AMP_AMP] = ACTIONS(9079),
    [anon_sym_LT_LT] = ACTIONS(9081),
    [anon_sym_GT_GT] = ACTIONS(9081),
    [anon_sym_EQ_EQ] = ACTIONS(9083),
    [anon_sym_BANG_EQ] = ACTIONS(9079),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9079),
    [anon_sym_LT_EQ_GT] = ACTIONS(9079),
    [anon_sym_EQ_TILDE] = ACTIONS(9079),
    [anon_sym_BANG_TILDE] = ACTIONS(9079),
    [anon_sym_LT_EQ] = ACTIONS(9071),
    [anon_sym_GT] = ACTIONS(9071),
    [anon_sym_GT_EQ] = ACTIONS(9085),
    [anon_sym_CARET] = ACTIONS(9087),
    [anon_sym_PLUS] = ACTIONS(9063),
    [anon_sym_SLASH] = ACTIONS(9065),
    [anon_sym_PERCENT] = ACTIONS(9065),
    [sym_comment] = ACTIONS(87),
  },
  [5806] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8234),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5789),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(5789),
    [sym_assignment] = STATE(8234),
    [sym_operator_assignment] = STATE(8234),
    [sym_conditional] = STATE(8234),
    [sym_range] = STATE(8234),
    [sym_binary] = STATE(8234),
    [sym_unary] = STATE(8234),
    [sym_left_assignment_list] = STATE(5788),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5789),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5789),
    [sym_false] = STATE(5789),
    [sym_nil] = STATE(5789),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5790),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9031),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9033),
    [anon_sym_yield] = ACTIONS(9035),
    [anon_sym_break] = ACTIONS(9037),
    [anon_sym_next] = ACTIONS(9039),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9041),
    [anon_sym_defined_QMARK] = ACTIONS(9043),
    [anon_sym_not] = ACTIONS(9045),
    [anon_sym_BANG] = ACTIONS(9047),
    [anon_sym_TILDE] = ACTIONS(9047),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5807] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8235),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3184),
    [sym_scope_resolution] = STATE(3180),
    [sym_call] = STATE(3180),
    [sym_method_call] = STATE(3184),
    [sym_assignment] = STATE(8235),
    [sym_operator_assignment] = STATE(8235),
    [sym_conditional] = STATE(8235),
    [sym_range] = STATE(8235),
    [sym_binary] = STATE(8235),
    [sym_unary] = STATE(8235),
    [sym_left_assignment_list] = STATE(3183),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3184),
    [sym__variable] = STATE(3180),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3184),
    [sym_false] = STATE(3184),
    [sym_nil] = STATE(3184),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5793),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5307),
    [anon_sym_yield] = ACTIONS(5309),
    [anon_sym_break] = ACTIONS(5311),
    [anon_sym_next] = ACTIONS(5313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9049),
    [anon_sym_defined_QMARK] = ACTIONS(5315),
    [anon_sym_not] = ACTIONS(5317),
    [anon_sym_BANG] = ACTIONS(5321),
    [anon_sym_TILDE] = ACTIONS(5321),
    [sym_constant] = ACTIONS(5327),
    [sym_identifier] = ACTIONS(5327),
    [sym_instance_variable] = ACTIONS(5325),
    [sym_class_variable] = ACTIONS(5325),
    [sym_global_variable] = ACTIONS(5325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5808] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8236),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3184),
    [sym_scope_resolution] = STATE(3180),
    [sym_call] = STATE(3180),
    [sym_method_call] = STATE(3184),
    [sym_assignment] = STATE(8236),
    [sym_operator_assignment] = STATE(8236),
    [sym_conditional] = STATE(8236),
    [sym_range] = STATE(8236),
    [sym_binary] = STATE(8236),
    [sym_unary] = STATE(8236),
    [sym_left_assignment_list] = STATE(3183),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3184),
    [sym__variable] = STATE(3180),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3184),
    [sym_false] = STATE(3184),
    [sym_nil] = STATE(3184),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5793),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5307),
    [anon_sym_yield] = ACTIONS(5309),
    [anon_sym_break] = ACTIONS(5311),
    [anon_sym_next] = ACTIONS(5313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9049),
    [anon_sym_defined_QMARK] = ACTIONS(5315),
    [anon_sym_not] = ACTIONS(5317),
    [anon_sym_BANG] = ACTIONS(5321),
    [anon_sym_TILDE] = ACTIONS(5321),
    [sym_constant] = ACTIONS(5327),
    [sym_identifier] = ACTIONS(5327),
    [sym_instance_variable] = ACTIONS(5325),
    [sym_class_variable] = ACTIONS(5325),
    [sym_global_variable] = ACTIONS(5325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5809] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8237),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3184),
    [sym_scope_resolution] = STATE(3180),
    [sym_call] = STATE(3180),
    [sym_method_call] = STATE(3184),
    [sym_assignment] = STATE(8237),
    [sym_operator_assignment] = STATE(8237),
    [sym_conditional] = STATE(8237),
    [sym_range] = STATE(8237),
    [sym_binary] = STATE(8237),
    [sym_unary] = STATE(8237),
    [sym_left_assignment_list] = STATE(3183),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3184),
    [sym__variable] = STATE(3180),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3184),
    [sym_false] = STATE(3184),
    [sym_nil] = STATE(3184),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5793),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5307),
    [anon_sym_yield] = ACTIONS(5309),
    [anon_sym_break] = ACTIONS(5311),
    [anon_sym_next] = ACTIONS(5313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9049),
    [anon_sym_defined_QMARK] = ACTIONS(5315),
    [anon_sym_not] = ACTIONS(5317),
    [anon_sym_BANG] = ACTIONS(5321),
    [anon_sym_TILDE] = ACTIONS(5321),
    [sym_constant] = ACTIONS(5327),
    [sym_identifier] = ACTIONS(5327),
    [sym_instance_variable] = ACTIONS(5325),
    [sym_class_variable] = ACTIONS(5325),
    [sym_global_variable] = ACTIONS(5325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5810] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8238),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3184),
    [sym_scope_resolution] = STATE(3180),
    [sym_call] = STATE(3180),
    [sym_method_call] = STATE(3184),
    [sym_assignment] = STATE(8238),
    [sym_operator_assignment] = STATE(8238),
    [sym_conditional] = STATE(8238),
    [sym_range] = STATE(8238),
    [sym_binary] = STATE(8238),
    [sym_unary] = STATE(8238),
    [sym_left_assignment_list] = STATE(3183),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3184),
    [sym__variable] = STATE(3180),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3184),
    [sym_false] = STATE(3184),
    [sym_nil] = STATE(3184),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5793),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5307),
    [anon_sym_yield] = ACTIONS(5309),
    [anon_sym_break] = ACTIONS(5311),
    [anon_sym_next] = ACTIONS(5313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9049),
    [anon_sym_defined_QMARK] = ACTIONS(5315),
    [anon_sym_not] = ACTIONS(5317),
    [anon_sym_BANG] = ACTIONS(5321),
    [anon_sym_TILDE] = ACTIONS(5321),
    [sym_constant] = ACTIONS(5327),
    [sym_identifier] = ACTIONS(5327),
    [sym_instance_variable] = ACTIONS(5325),
    [sym_class_variable] = ACTIONS(5325),
    [sym_global_variable] = ACTIONS(5325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5811] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8239),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3184),
    [sym_scope_resolution] = STATE(3180),
    [sym_call] = STATE(3180),
    [sym_method_call] = STATE(3184),
    [sym_assignment] = STATE(8239),
    [sym_operator_assignment] = STATE(8239),
    [sym_conditional] = STATE(8239),
    [sym_range] = STATE(8239),
    [sym_binary] = STATE(8239),
    [sym_unary] = STATE(8239),
    [sym_left_assignment_list] = STATE(3183),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3184),
    [sym__variable] = STATE(3180),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3184),
    [sym_false] = STATE(3184),
    [sym_nil] = STATE(3184),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5793),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5307),
    [anon_sym_yield] = ACTIONS(5309),
    [anon_sym_break] = ACTIONS(5311),
    [anon_sym_next] = ACTIONS(5313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9049),
    [anon_sym_defined_QMARK] = ACTIONS(5315),
    [anon_sym_not] = ACTIONS(5317),
    [anon_sym_BANG] = ACTIONS(5321),
    [anon_sym_TILDE] = ACTIONS(5321),
    [sym_constant] = ACTIONS(5327),
    [sym_identifier] = ACTIONS(5327),
    [sym_instance_variable] = ACTIONS(5325),
    [sym_class_variable] = ACTIONS(5325),
    [sym_global_variable] = ACTIONS(5325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5812] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(8240),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(8240),
    [sym_operator_assignment] = STATE(8240),
    [sym_conditional] = STATE(8240),
    [sym_range] = STATE(8240),
    [sym_binary] = STATE(8240),
    [sym_unary] = STATE(8240),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5813] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8241),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3184),
    [sym_scope_resolution] = STATE(3180),
    [sym_call] = STATE(3180),
    [sym_method_call] = STATE(3184),
    [sym_assignment] = STATE(8241),
    [sym_operator_assignment] = STATE(8241),
    [sym_conditional] = STATE(8241),
    [sym_range] = STATE(8241),
    [sym_binary] = STATE(8241),
    [sym_unary] = STATE(8241),
    [sym_left_assignment_list] = STATE(3183),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3184),
    [sym__variable] = STATE(3180),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3184),
    [sym_false] = STATE(3184),
    [sym_nil] = STATE(3184),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5793),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5307),
    [anon_sym_yield] = ACTIONS(5309),
    [anon_sym_break] = ACTIONS(5311),
    [anon_sym_next] = ACTIONS(5313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9049),
    [anon_sym_defined_QMARK] = ACTIONS(5315),
    [anon_sym_not] = ACTIONS(5317),
    [anon_sym_BANG] = ACTIONS(5321),
    [anon_sym_TILDE] = ACTIONS(5321),
    [sym_constant] = ACTIONS(5327),
    [sym_identifier] = ACTIONS(5327),
    [sym_instance_variable] = ACTIONS(5325),
    [sym_class_variable] = ACTIONS(5325),
    [sym_global_variable] = ACTIONS(5325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5814] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8242),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3184),
    [sym_scope_resolution] = STATE(3180),
    [sym_call] = STATE(3180),
    [sym_method_call] = STATE(3184),
    [sym_assignment] = STATE(8242),
    [sym_operator_assignment] = STATE(8242),
    [sym_conditional] = STATE(8242),
    [sym_range] = STATE(8242),
    [sym_binary] = STATE(8242),
    [sym_unary] = STATE(8242),
    [sym_left_assignment_list] = STATE(3183),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3184),
    [sym__variable] = STATE(3180),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3184),
    [sym_false] = STATE(3184),
    [sym_nil] = STATE(3184),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5793),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5307),
    [anon_sym_yield] = ACTIONS(5309),
    [anon_sym_break] = ACTIONS(5311),
    [anon_sym_next] = ACTIONS(5313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9049),
    [anon_sym_defined_QMARK] = ACTIONS(5315),
    [anon_sym_not] = ACTIONS(5317),
    [anon_sym_BANG] = ACTIONS(5321),
    [anon_sym_TILDE] = ACTIONS(5321),
    [sym_constant] = ACTIONS(5327),
    [sym_identifier] = ACTIONS(5327),
    [sym_instance_variable] = ACTIONS(5325),
    [sym_class_variable] = ACTIONS(5325),
    [sym_global_variable] = ACTIONS(5325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5815] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8243),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3184),
    [sym_scope_resolution] = STATE(3180),
    [sym_call] = STATE(3180),
    [sym_method_call] = STATE(3184),
    [sym_assignment] = STATE(8243),
    [sym_operator_assignment] = STATE(8243),
    [sym_conditional] = STATE(8243),
    [sym_range] = STATE(8243),
    [sym_binary] = STATE(8243),
    [sym_unary] = STATE(8243),
    [sym_left_assignment_list] = STATE(3183),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3184),
    [sym__variable] = STATE(3180),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3184),
    [sym_false] = STATE(3184),
    [sym_nil] = STATE(3184),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5793),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5307),
    [anon_sym_yield] = ACTIONS(5309),
    [anon_sym_break] = ACTIONS(5311),
    [anon_sym_next] = ACTIONS(5313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9049),
    [anon_sym_defined_QMARK] = ACTIONS(5315),
    [anon_sym_not] = ACTIONS(5317),
    [anon_sym_BANG] = ACTIONS(5321),
    [anon_sym_TILDE] = ACTIONS(5321),
    [sym_constant] = ACTIONS(5327),
    [sym_identifier] = ACTIONS(5327),
    [sym_instance_variable] = ACTIONS(5325),
    [sym_class_variable] = ACTIONS(5325),
    [sym_global_variable] = ACTIONS(5325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5816] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8244),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3184),
    [sym_scope_resolution] = STATE(3180),
    [sym_call] = STATE(3180),
    [sym_method_call] = STATE(3184),
    [sym_assignment] = STATE(8244),
    [sym_operator_assignment] = STATE(8244),
    [sym_conditional] = STATE(8244),
    [sym_range] = STATE(8244),
    [sym_binary] = STATE(8244),
    [sym_unary] = STATE(8244),
    [sym_left_assignment_list] = STATE(3183),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3184),
    [sym__variable] = STATE(3180),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3184),
    [sym_false] = STATE(3184),
    [sym_nil] = STATE(3184),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5793),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5307),
    [anon_sym_yield] = ACTIONS(5309),
    [anon_sym_break] = ACTIONS(5311),
    [anon_sym_next] = ACTIONS(5313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9049),
    [anon_sym_defined_QMARK] = ACTIONS(5315),
    [anon_sym_not] = ACTIONS(5317),
    [anon_sym_BANG] = ACTIONS(5321),
    [anon_sym_TILDE] = ACTIONS(5321),
    [sym_constant] = ACTIONS(5327),
    [sym_identifier] = ACTIONS(5327),
    [sym_instance_variable] = ACTIONS(5325),
    [sym_class_variable] = ACTIONS(5325),
    [sym_global_variable] = ACTIONS(5325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5817] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8245),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3220),
    [sym_scope_resolution] = STATE(3216),
    [sym_call] = STATE(3216),
    [sym_method_call] = STATE(3220),
    [sym_assignment] = STATE(8245),
    [sym_operator_assignment] = STATE(8245),
    [sym_conditional] = STATE(8245),
    [sym_range] = STATE(8245),
    [sym_binary] = STATE(8245),
    [sym_unary] = STATE(8245),
    [sym_left_assignment_list] = STATE(3219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3220),
    [sym__variable] = STATE(3216),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3220),
    [sym_false] = STATE(3220),
    [sym_nil] = STATE(3220),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5862),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5375),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5379),
    [anon_sym_yield] = ACTIONS(5381),
    [anon_sym_break] = ACTIONS(5383),
    [anon_sym_next] = ACTIONS(5385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(9129),
    [anon_sym_defined_QMARK] = ACTIONS(5387),
    [anon_sym_not] = ACTIONS(5389),
    [anon_sym_BANG] = ACTIONS(5393),
    [anon_sym_TILDE] = ACTIONS(5393),
    [sym_constant] = ACTIONS(5399),
    [sym_identifier] = ACTIONS(5399),
    [sym_instance_variable] = ACTIONS(5397),
    [sym_class_variable] = ACTIONS(5397),
    [sym_global_variable] = ACTIONS(5397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5818] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8246),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3220),
    [sym_scope_resolution] = STATE(3216),
    [sym_call] = STATE(3216),
    [sym_method_call] = STATE(3220),
    [sym_assignment] = STATE(8246),
    [sym_operator_assignment] = STATE(8246),
    [sym_conditional] = STATE(8246),
    [sym_range] = STATE(8246),
    [sym_binary] = STATE(8246),
    [sym_unary] = STATE(8246),
    [sym_left_assignment_list] = STATE(3219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3220),
    [sym__variable] = STATE(3216),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3220),
    [sym_false] = STATE(3220),
    [sym_nil] = STATE(3220),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5862),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5375),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5379),
    [anon_sym_yield] = ACTIONS(5381),
    [anon_sym_break] = ACTIONS(5383),
    [anon_sym_next] = ACTIONS(5385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(9129),
    [anon_sym_defined_QMARK] = ACTIONS(5387),
    [anon_sym_not] = ACTIONS(5389),
    [anon_sym_BANG] = ACTIONS(5393),
    [anon_sym_TILDE] = ACTIONS(5393),
    [sym_constant] = ACTIONS(5399),
    [sym_identifier] = ACTIONS(5399),
    [sym_instance_variable] = ACTIONS(5397),
    [sym_class_variable] = ACTIONS(5397),
    [sym_global_variable] = ACTIONS(5397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5819] = {
    [anon_sym_COLON] = ACTIONS(11764),
    [sym_comment] = ACTIONS(87),
  },
  [5820] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8248),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3220),
    [sym_scope_resolution] = STATE(3216),
    [sym_call] = STATE(3216),
    [sym_method_call] = STATE(3220),
    [sym_assignment] = STATE(8248),
    [sym_operator_assignment] = STATE(8248),
    [sym_conditional] = STATE(8248),
    [sym_range] = STATE(8248),
    [sym_binary] = STATE(8248),
    [sym_unary] = STATE(8248),
    [sym_left_assignment_list] = STATE(3219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3220),
    [sym__variable] = STATE(3216),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3220),
    [sym_false] = STATE(3220),
    [sym_nil] = STATE(3220),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5862),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5375),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5379),
    [anon_sym_yield] = ACTIONS(5381),
    [anon_sym_break] = ACTIONS(5383),
    [anon_sym_next] = ACTIONS(5385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(9129),
    [anon_sym_defined_QMARK] = ACTIONS(5387),
    [anon_sym_not] = ACTIONS(5389),
    [anon_sym_BANG] = ACTIONS(5393),
    [anon_sym_TILDE] = ACTIONS(5393),
    [sym_constant] = ACTIONS(5399),
    [sym_identifier] = ACTIONS(5399),
    [sym_instance_variable] = ACTIONS(5397),
    [sym_class_variable] = ACTIONS(5397),
    [sym_global_variable] = ACTIONS(5397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5821] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(11766),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [5822] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(9135),
    [sym__binary_star] = ACTIONS(9137),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(9139),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(9141),
    [anon_sym_AMP] = ACTIONS(9143),
    [anon_sym_EQ] = ACTIONS(1631),
    [anon_sym_LT] = ACTIONS(9145),
    [anon_sym_end] = ACTIONS(1625),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_unless] = ACTIONS(1625),
    [anon_sym_while] = ACTIONS(1625),
    [anon_sym_until] = ACTIONS(1625),
    [anon_sym_rescue] = ACTIONS(1625),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(1625),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_PLUS_EQ] = ACTIONS(1625),
    [anon_sym_DASH_EQ] = ACTIONS(1625),
    [anon_sym_STAR_EQ] = ACTIONS(1625),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1625),
    [anon_sym_SLASH_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1625),
    [anon_sym_AMP_EQ] = ACTIONS(1625),
    [anon_sym_PERCENT_EQ] = ACTIONS(1625),
    [anon_sym_GT_GT_EQ] = ACTIONS(1625),
    [anon_sym_LT_LT_EQ] = ACTIONS(1625),
    [anon_sym_CARET_EQ] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(9147),
    [anon_sym_DOT_DOT] = ACTIONS(9149),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9151),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(9153),
    [anon_sym_AMP_AMP] = ACTIONS(9153),
    [anon_sym_LT_LT] = ACTIONS(9155),
    [anon_sym_GT_GT] = ACTIONS(9155),
    [anon_sym_EQ_EQ] = ACTIONS(9153),
    [anon_sym_BANG_EQ] = ACTIONS(9157),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9157),
    [anon_sym_LT_EQ_GT] = ACTIONS(9157),
    [anon_sym_EQ_TILDE] = ACTIONS(9157),
    [anon_sym_BANG_TILDE] = ACTIONS(9157),
    [anon_sym_LT_EQ] = ACTIONS(9145),
    [anon_sym_GT] = ACTIONS(9145),
    [anon_sym_GT_EQ] = ACTIONS(9159),
    [anon_sym_CARET] = ACTIONS(9139),
    [anon_sym_PLUS] = ACTIONS(9161),
    [anon_sym_SLASH] = ACTIONS(9141),
    [anon_sym_PERCENT] = ACTIONS(9141),
    [sym_comment] = ACTIONS(87),
  },
  [5823] = {
    [sym_heredoc_body] = STATE(8250),
    [aux_sym_call_repeat1] = STATE(8250),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [5824] = {
    [sym_heredoc_body] = STATE(8250),
    [aux_sym_call_repeat1] = STATE(8250),
    [aux_sym_argument_list_repeat1] = STATE(8252),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(11768),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [5825] = {
    [sym_string] = STATE(5882),
    [aux_sym_chained_string_repeat1] = STATE(5882),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(747),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(11770),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5826] = {
    [sym_heredoc_body] = STATE(8253),
    [aux_sym_call_repeat1] = STATE(8253),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [5827] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3179),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3184),
    [sym_scope_resolution] = STATE(3180),
    [sym_call] = STATE(3180),
    [sym_method_call] = STATE(3184),
    [sym__argument] = STATE(2565),
    [sym_splat_argument] = STATE(2565),
    [sym_hash_splat_argument] = STATE(2565),
    [sym_block_argument] = STATE(2565),
    [sym_assignment] = STATE(3179),
    [sym_operator_assignment] = STATE(3179),
    [sym_conditional] = STATE(3179),
    [sym_range] = STATE(3179),
    [sym_binary] = STATE(3179),
    [sym_unary] = STATE(3179),
    [sym_left_assignment_list] = STATE(3183),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3184),
    [sym__variable] = STATE(3180),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3184),
    [sym_false] = STATE(3184),
    [sym_nil] = STATE(3184),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3185),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(8254),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2565),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(5299),
    [sym__splat_star] = ACTIONS(5301),
    [sym__unary_minus] = ACTIONS(5303),
    [sym__identifier_hash_key] = ACTIONS(5305),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11772),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5307),
    [anon_sym_yield] = ACTIONS(5309),
    [anon_sym_break] = ACTIONS(5311),
    [anon_sym_next] = ACTIONS(5313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9049),
    [anon_sym_defined_QMARK] = ACTIONS(5315),
    [anon_sym_not] = ACTIONS(5317),
    [anon_sym_BANG] = ACTIONS(5321),
    [anon_sym_TILDE] = ACTIONS(5321),
    [sym_constant] = ACTIONS(5323),
    [sym_identifier] = ACTIONS(5323),
    [sym_instance_variable] = ACTIONS(5325),
    [sym_class_variable] = ACTIONS(5325),
    [sym_global_variable] = ACTIONS(5325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5828] = {
    [sym_heredoc_body] = STATE(8255),
    [aux_sym_call_repeat1] = STATE(8255),
    [aux_sym_argument_list_repeat1] = STATE(8256),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(9097),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [5829] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8257),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3184),
    [sym_scope_resolution] = STATE(3180),
    [sym_call] = STATE(3180),
    [sym_method_call] = STATE(3184),
    [sym_splat_argument] = STATE(8258),
    [sym_assignment] = STATE(8257),
    [sym_operator_assignment] = STATE(8257),
    [sym_conditional] = STATE(8257),
    [sym_range] = STATE(8257),
    [sym_binary] = STATE(8257),
    [sym_unary] = STATE(8257),
    [sym_right_assignment_list] = STATE(2570),
    [sym__arg_or_splat_arg] = STATE(8258),
    [sym_left_assignment_list] = STATE(3183),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3184),
    [sym__variable] = STATE(3180),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3184),
    [sym_false] = STATE(3184),
    [sym_nil] = STATE(3184),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5793),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__splat_star] = ACTIONS(9055),
    [sym__unary_minus] = ACTIONS(5303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5307),
    [anon_sym_yield] = ACTIONS(5309),
    [anon_sym_break] = ACTIONS(5311),
    [anon_sym_next] = ACTIONS(5313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9049),
    [anon_sym_defined_QMARK] = ACTIONS(5315),
    [anon_sym_not] = ACTIONS(5317),
    [anon_sym_BANG] = ACTIONS(5321),
    [anon_sym_TILDE] = ACTIONS(5321),
    [sym_constant] = ACTIONS(5327),
    [sym_identifier] = ACTIONS(5327),
    [sym_instance_variable] = ACTIONS(5325),
    [sym_class_variable] = ACTIONS(5325),
    [sym_global_variable] = ACTIONS(5325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5830] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8259),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3184),
    [sym_scope_resolution] = STATE(3180),
    [sym_call] = STATE(3180),
    [sym_method_call] = STATE(3184),
    [sym_assignment] = STATE(8259),
    [sym_operator_assignment] = STATE(8259),
    [sym_conditional] = STATE(8259),
    [sym_range] = STATE(8259),
    [sym_binary] = STATE(8259),
    [sym_unary] = STATE(8259),
    [sym_left_assignment_list] = STATE(3183),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3184),
    [sym__variable] = STATE(3180),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3184),
    [sym_false] = STATE(3184),
    [sym_nil] = STATE(3184),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5793),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5307),
    [anon_sym_yield] = ACTIONS(5309),
    [anon_sym_break] = ACTIONS(5311),
    [anon_sym_next] = ACTIONS(5313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9049),
    [anon_sym_defined_QMARK] = ACTIONS(5315),
    [anon_sym_not] = ACTIONS(5317),
    [anon_sym_BANG] = ACTIONS(5321),
    [anon_sym_TILDE] = ACTIONS(5321),
    [sym_constant] = ACTIONS(5327),
    [sym_identifier] = ACTIONS(5327),
    [sym_instance_variable] = ACTIONS(5325),
    [sym_class_variable] = ACTIONS(5325),
    [sym_global_variable] = ACTIONS(5325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5831] = {
    [sym_string] = STATE(8260),
    [aux_sym_chained_string_repeat1] = STATE(8260),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_end] = ACTIONS(2753),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_EQ_GT] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [5832] = {
    [aux_sym_undef_repeat1] = STATE(8261),
    [sym__line_break] = ACTIONS(5497),
    [sym__heredoc_body_start] = ACTIONS(5497),
    [anon_sym_COMMA] = ACTIONS(2253),
    [anon_sym_SEMI] = ACTIONS(5497),
    [anon_sym_end] = ACTIONS(5497),
    [anon_sym_if] = ACTIONS(5497),
    [anon_sym_unless] = ACTIONS(5497),
    [anon_sym_while] = ACTIONS(5497),
    [anon_sym_until] = ACTIONS(5497),
    [anon_sym_rescue] = ACTIONS(5497),
    [sym_comment] = ACTIONS(87),
  },
  [5833] = {
    [sym__line_break] = ACTIONS(5815),
    [sym__heredoc_body_start] = ACTIONS(5815),
    [sym__binary_minus] = ACTIONS(5343),
    [sym__binary_star] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_SEMI] = ACTIONS(5815),
    [anon_sym_STAR_STAR] = ACTIONS(5345),
    [anon_sym_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_end] = ACTIONS(5815),
    [anon_sym_if] = ACTIONS(5815),
    [anon_sym_unless] = ACTIONS(5815),
    [anon_sym_while] = ACTIONS(5815),
    [anon_sym_until] = ACTIONS(5815),
    [anon_sym_rescue] = ACTIONS(5815),
    [anon_sym_QMARK] = ACTIONS(5353),
    [anon_sym_DOT_DOT] = ACTIONS(5355),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5357),
    [anon_sym_and] = ACTIONS(5359),
    [anon_sym_or] = ACTIONS(5359),
    [anon_sym_PIPE_PIPE] = ACTIONS(5361),
    [anon_sym_AMP_AMP] = ACTIONS(5361),
    [anon_sym_LT_LT] = ACTIONS(5363),
    [anon_sym_GT_GT] = ACTIONS(5363),
    [anon_sym_EQ_EQ] = ACTIONS(5365),
    [anon_sym_BANG_EQ] = ACTIONS(5361),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5361),
    [anon_sym_LT_EQ_GT] = ACTIONS(5361),
    [anon_sym_EQ_TILDE] = ACTIONS(5361),
    [anon_sym_BANG_TILDE] = ACTIONS(5361),
    [anon_sym_LT_EQ] = ACTIONS(5351),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5367),
    [anon_sym_CARET] = ACTIONS(5369),
    [anon_sym_PLUS] = ACTIONS(5343),
    [anon_sym_SLASH] = ACTIONS(5345),
    [anon_sym_PERCENT] = ACTIONS(5345),
    [sym_comment] = ACTIONS(87),
  },
  [5834] = {
    [sym__line_break] = ACTIONS(5817),
    [sym__heredoc_body_start] = ACTIONS(5817),
    [sym__binary_minus] = ACTIONS(5343),
    [sym__binary_star] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_SEMI] = ACTIONS(5817),
    [anon_sym_STAR_STAR] = ACTIONS(5345),
    [anon_sym_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_end] = ACTIONS(5817),
    [anon_sym_if] = ACTIONS(5817),
    [anon_sym_unless] = ACTIONS(5817),
    [anon_sym_while] = ACTIONS(5817),
    [anon_sym_until] = ACTIONS(5817),
    [anon_sym_rescue] = ACTIONS(5817),
    [anon_sym_QMARK] = ACTIONS(5353),
    [anon_sym_DOT_DOT] = ACTIONS(5355),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5357),
    [anon_sym_and] = ACTIONS(5359),
    [anon_sym_or] = ACTIONS(5359),
    [anon_sym_PIPE_PIPE] = ACTIONS(5361),
    [anon_sym_AMP_AMP] = ACTIONS(5361),
    [anon_sym_LT_LT] = ACTIONS(5363),
    [anon_sym_GT_GT] = ACTIONS(5363),
    [anon_sym_EQ_EQ] = ACTIONS(5365),
    [anon_sym_BANG_EQ] = ACTIONS(5361),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5361),
    [anon_sym_LT_EQ_GT] = ACTIONS(5361),
    [anon_sym_EQ_TILDE] = ACTIONS(5361),
    [anon_sym_BANG_TILDE] = ACTIONS(5361),
    [anon_sym_LT_EQ] = ACTIONS(5351),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5367),
    [anon_sym_CARET] = ACTIONS(5369),
    [anon_sym_PLUS] = ACTIONS(5343),
    [anon_sym_SLASH] = ACTIONS(5345),
    [anon_sym_PERCENT] = ACTIONS(5345),
    [sym_comment] = ACTIONS(87),
  },
  [5835] = {
    [sym__line_break] = ACTIONS(5819),
    [sym__heredoc_body_start] = ACTIONS(5819),
    [sym__binary_minus] = ACTIONS(5343),
    [sym__binary_star] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_SEMI] = ACTIONS(5819),
    [anon_sym_STAR_STAR] = ACTIONS(5345),
    [anon_sym_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_end] = ACTIONS(5819),
    [anon_sym_if] = ACTIONS(5819),
    [anon_sym_unless] = ACTIONS(5819),
    [anon_sym_while] = ACTIONS(5819),
    [anon_sym_until] = ACTIONS(5819),
    [anon_sym_rescue] = ACTIONS(5819),
    [anon_sym_QMARK] = ACTIONS(5353),
    [anon_sym_DOT_DOT] = ACTIONS(5355),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5357),
    [anon_sym_and] = ACTIONS(5359),
    [anon_sym_or] = ACTIONS(5359),
    [anon_sym_PIPE_PIPE] = ACTIONS(5361),
    [anon_sym_AMP_AMP] = ACTIONS(5361),
    [anon_sym_LT_LT] = ACTIONS(5363),
    [anon_sym_GT_GT] = ACTIONS(5363),
    [anon_sym_EQ_EQ] = ACTIONS(5365),
    [anon_sym_BANG_EQ] = ACTIONS(5361),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5361),
    [anon_sym_LT_EQ_GT] = ACTIONS(5361),
    [anon_sym_EQ_TILDE] = ACTIONS(5361),
    [anon_sym_BANG_TILDE] = ACTIONS(5361),
    [anon_sym_LT_EQ] = ACTIONS(5351),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5367),
    [anon_sym_CARET] = ACTIONS(5369),
    [anon_sym_PLUS] = ACTIONS(5343),
    [anon_sym_SLASH] = ACTIONS(5345),
    [anon_sym_PERCENT] = ACTIONS(5345),
    [sym_comment] = ACTIONS(87),
  },
  [5836] = {
    [sym__line_break] = ACTIONS(5821),
    [sym__heredoc_body_start] = ACTIONS(5821),
    [sym__binary_minus] = ACTIONS(5343),
    [sym__binary_star] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_SEMI] = ACTIONS(5821),
    [anon_sym_STAR_STAR] = ACTIONS(5345),
    [anon_sym_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_end] = ACTIONS(5821),
    [anon_sym_if] = ACTIONS(5821),
    [anon_sym_unless] = ACTIONS(5821),
    [anon_sym_while] = ACTIONS(5821),
    [anon_sym_until] = ACTIONS(5821),
    [anon_sym_rescue] = ACTIONS(5821),
    [anon_sym_QMARK] = ACTIONS(5353),
    [anon_sym_DOT_DOT] = ACTIONS(5355),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5357),
    [anon_sym_and] = ACTIONS(5359),
    [anon_sym_or] = ACTIONS(5359),
    [anon_sym_PIPE_PIPE] = ACTIONS(5361),
    [anon_sym_AMP_AMP] = ACTIONS(5361),
    [anon_sym_LT_LT] = ACTIONS(5363),
    [anon_sym_GT_GT] = ACTIONS(5363),
    [anon_sym_EQ_EQ] = ACTIONS(5365),
    [anon_sym_BANG_EQ] = ACTIONS(5361),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5361),
    [anon_sym_LT_EQ_GT] = ACTIONS(5361),
    [anon_sym_EQ_TILDE] = ACTIONS(5361),
    [anon_sym_BANG_TILDE] = ACTIONS(5361),
    [anon_sym_LT_EQ] = ACTIONS(5351),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5367),
    [anon_sym_CARET] = ACTIONS(5369),
    [anon_sym_PLUS] = ACTIONS(5343),
    [anon_sym_SLASH] = ACTIONS(5345),
    [anon_sym_PERCENT] = ACTIONS(5345),
    [sym_comment] = ACTIONS(87),
  },
  [5837] = {
    [sym__line_break] = ACTIONS(5823),
    [sym__heredoc_body_start] = ACTIONS(5823),
    [sym__binary_minus] = ACTIONS(5343),
    [sym__binary_star] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_SEMI] = ACTIONS(5823),
    [anon_sym_STAR_STAR] = ACTIONS(5345),
    [anon_sym_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_end] = ACTIONS(5823),
    [anon_sym_if] = ACTIONS(5823),
    [anon_sym_unless] = ACTIONS(5823),
    [anon_sym_while] = ACTIONS(5823),
    [anon_sym_until] = ACTIONS(5823),
    [anon_sym_rescue] = ACTIONS(5823),
    [anon_sym_QMARK] = ACTIONS(5353),
    [anon_sym_DOT_DOT] = ACTIONS(5355),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5357),
    [anon_sym_and] = ACTIONS(5359),
    [anon_sym_or] = ACTIONS(5359),
    [anon_sym_PIPE_PIPE] = ACTIONS(5361),
    [anon_sym_AMP_AMP] = ACTIONS(5361),
    [anon_sym_LT_LT] = ACTIONS(5363),
    [anon_sym_GT_GT] = ACTIONS(5363),
    [anon_sym_EQ_EQ] = ACTIONS(5365),
    [anon_sym_BANG_EQ] = ACTIONS(5361),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5361),
    [anon_sym_LT_EQ_GT] = ACTIONS(5361),
    [anon_sym_EQ_TILDE] = ACTIONS(5361),
    [anon_sym_BANG_TILDE] = ACTIONS(5361),
    [anon_sym_LT_EQ] = ACTIONS(5351),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5367),
    [anon_sym_CARET] = ACTIONS(5369),
    [anon_sym_PLUS] = ACTIONS(5343),
    [anon_sym_SLASH] = ACTIONS(5345),
    [anon_sym_PERCENT] = ACTIONS(5345),
    [sym_comment] = ACTIONS(87),
  },
  [5838] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(5345),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5345),
    [anon_sym_PERCENT] = ACTIONS(5345),
    [sym_comment] = ACTIONS(87),
  },
  [5839] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(5345),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [5840] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5343),
    [sym__binary_star] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(5345),
    [anon_sym_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5363),
    [anon_sym_GT_GT] = ACTIONS(5363),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5343),
    [anon_sym_SLASH] = ACTIONS(5345),
    [anon_sym_PERCENT] = ACTIONS(5345),
    [sym_comment] = ACTIONS(87),
  },
  [5841] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5343),
    [sym__binary_star] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(5345),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5363),
    [anon_sym_GT_GT] = ACTIONS(5363),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5343),
    [anon_sym_SLASH] = ACTIONS(5345),
    [anon_sym_PERCENT] = ACTIONS(5345),
    [sym_comment] = ACTIONS(87),
  },
  [5842] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5343),
    [sym__binary_star] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(5345),
    [anon_sym_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5363),
    [anon_sym_GT_GT] = ACTIONS(5363),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5369),
    [anon_sym_PLUS] = ACTIONS(5343),
    [anon_sym_SLASH] = ACTIONS(5345),
    [anon_sym_PERCENT] = ACTIONS(5345),
    [sym_comment] = ACTIONS(87),
  },
  [5843] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(11774),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [5844] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(5343),
    [sym__binary_star] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(5345),
    [anon_sym_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_end] = ACTIONS(5927),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(5355),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5357),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(5361),
    [anon_sym_AMP_AMP] = ACTIONS(5361),
    [anon_sym_LT_LT] = ACTIONS(5363),
    [anon_sym_GT_GT] = ACTIONS(5363),
    [anon_sym_EQ_EQ] = ACTIONS(5365),
    [anon_sym_BANG_EQ] = ACTIONS(5361),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5361),
    [anon_sym_LT_EQ_GT] = ACTIONS(5361),
    [anon_sym_EQ_TILDE] = ACTIONS(5361),
    [anon_sym_BANG_TILDE] = ACTIONS(5361),
    [anon_sym_LT_EQ] = ACTIONS(5351),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5367),
    [anon_sym_CARET] = ACTIONS(5369),
    [anon_sym_PLUS] = ACTIONS(5343),
    [anon_sym_SLASH] = ACTIONS(5345),
    [anon_sym_PERCENT] = ACTIONS(5345),
    [sym_comment] = ACTIONS(87),
  },
  [5845] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5343),
    [sym__binary_star] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(5345),
    [anon_sym_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5353),
    [anon_sym_DOT_DOT] = ACTIONS(5355),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5357),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5361),
    [anon_sym_AMP_AMP] = ACTIONS(5361),
    [anon_sym_LT_LT] = ACTIONS(5363),
    [anon_sym_GT_GT] = ACTIONS(5363),
    [anon_sym_EQ_EQ] = ACTIONS(5365),
    [anon_sym_BANG_EQ] = ACTIONS(5361),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5361),
    [anon_sym_LT_EQ_GT] = ACTIONS(5361),
    [anon_sym_EQ_TILDE] = ACTIONS(5361),
    [anon_sym_BANG_TILDE] = ACTIONS(5361),
    [anon_sym_LT_EQ] = ACTIONS(5351),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5367),
    [anon_sym_CARET] = ACTIONS(5369),
    [anon_sym_PLUS] = ACTIONS(5343),
    [anon_sym_SLASH] = ACTIONS(5345),
    [anon_sym_PERCENT] = ACTIONS(5345),
    [sym_comment] = ACTIONS(87),
  },
  [5846] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5343),
    [sym__binary_star] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(5345),
    [anon_sym_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5363),
    [anon_sym_GT_GT] = ACTIONS(5363),
    [anon_sym_EQ_EQ] = ACTIONS(5365),
    [anon_sym_BANG_EQ] = ACTIONS(5361),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5361),
    [anon_sym_LT_EQ_GT] = ACTIONS(5361),
    [anon_sym_EQ_TILDE] = ACTIONS(5361),
    [anon_sym_BANG_TILDE] = ACTIONS(5361),
    [anon_sym_LT_EQ] = ACTIONS(5351),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5367),
    [anon_sym_CARET] = ACTIONS(5369),
    [anon_sym_PLUS] = ACTIONS(5343),
    [anon_sym_SLASH] = ACTIONS(5345),
    [anon_sym_PERCENT] = ACTIONS(5345),
    [sym_comment] = ACTIONS(87),
  },
  [5847] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5343),
    [sym__binary_star] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(5345),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5343),
    [anon_sym_SLASH] = ACTIONS(5345),
    [anon_sym_PERCENT] = ACTIONS(5345),
    [sym_comment] = ACTIONS(87),
  },
  [5848] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(8263),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(5858),
    [sym_scope_resolution] = STATE(5856),
    [sym_call] = STATE(5856),
    [sym_method_call] = STATE(5858),
    [sym_assignment] = STATE(8263),
    [sym_operator_assignment] = STATE(8263),
    [sym_conditional] = STATE(8263),
    [sym_range] = STATE(8263),
    [sym_binary] = STATE(8263),
    [sym_unary] = STATE(8263),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5858),
    [sym__variable] = STATE(5856),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(5858),
    [sym_false] = STATE(5858),
    [sym_nil] = STATE(5858),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(5859),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(9107),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(9109),
    [anon_sym_yield] = ACTIONS(9111),
    [anon_sym_break] = ACTIONS(9113),
    [anon_sym_next] = ACTIONS(9115),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(9117),
    [anon_sym_defined_QMARK] = ACTIONS(9119),
    [anon_sym_not] = ACTIONS(9121),
    [anon_sym_BANG] = ACTIONS(9123),
    [anon_sym_TILDE] = ACTIONS(9123),
    [sym_constant] = ACTIONS(9125),
    [sym_identifier] = ACTIONS(9125),
    [sym_instance_variable] = ACTIONS(9127),
    [sym_class_variable] = ACTIONS(9127),
    [sym_global_variable] = ACTIONS(9127),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(9125),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9125),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [5849] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3215),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3220),
    [sym_scope_resolution] = STATE(3216),
    [sym_call] = STATE(3216),
    [sym_method_call] = STATE(3220),
    [sym_argument_list] = STATE(3610),
    [sym__argument_list_with_parens] = STATE(3217),
    [sym__argument] = STATE(3218),
    [sym_splat_argument] = STATE(3218),
    [sym_hash_splat_argument] = STATE(3218),
    [sym_block_argument] = STATE(3218),
    [sym_assignment] = STATE(3215),
    [sym_operator_assignment] = STATE(3215),
    [sym_conditional] = STATE(3215),
    [sym_range] = STATE(3215),
    [sym_binary] = STATE(3215),
    [sym_unary] = STATE(3215),
    [sym_left_assignment_list] = STATE(3219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3220),
    [sym__variable] = STATE(3216),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3220),
    [sym_false] = STATE(3220),
    [sym_nil] = STATE(3220),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3221),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(3218),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(5371),
    [sym__splat_star] = ACTIONS(5373),
    [sym__unary_minus] = ACTIONS(5375),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(5377),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(5379),
    [anon_sym_yield] = ACTIONS(5381),
    [anon_sym_break] = ACTIONS(5383),
    [anon_sym_next] = ACTIONS(5385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(365),
    [anon_sym_DASH_EQ] = ACTIONS(365),
    [anon_sym_STAR_EQ] = ACTIONS(365),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(365),
    [anon_sym_SLASH_EQ] = ACTIONS(365),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(365),
    [anon_sym_PIPE_EQ] = ACTIONS(365),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(365),
    [anon_sym_AMP_EQ] = ACTIONS(365),
    [anon_sym_PERCENT_EQ] = ACTIONS(365),
    [anon_sym_GT_GT_EQ] = ACTIONS(365),
    [anon_sym_LT_LT_EQ] = ACTIONS(365),
    [anon_sym_CARET_EQ] = ACTIONS(365),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_PERCENT] = ACTIONS(377),
    [anon_sym_defined_QMARK] = ACTIONS(5387),
    [anon_sym_not] = ACTIONS(5389),
    [anon_sym_BANG] = ACTIONS(5391),
    [anon_sym_TILDE] = ACTIONS(5393),
    [sym_constant] = ACTIONS(5395),
    [sym_identifier] = ACTIONS(5395),
    [sym_instance_variable] = ACTIONS(5397),
    [sym_class_variable] = ACTIONS(5397),
    [sym_global_variable] = ACTIONS(5397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5850] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3215),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3220),
    [sym_scope_resolution] = STATE(3216),
    [sym_call] = STATE(3216),
    [sym_method_call] = STATE(3220),
    [sym_argument_list] = STATE(3611),
    [sym__argument_list_with_parens] = STATE(3217),
    [sym__argument] = STATE(3218),
    [sym_splat_argument] = STATE(3218),
    [sym_hash_splat_argument] = STATE(3218),
    [sym_block_argument] = STATE(3218),
    [sym_assignment] = STATE(3215),
    [sym_operator_assignment] = STATE(3215),
    [sym_conditional] = STATE(3215),
    [sym_range] = STATE(3215),
    [sym_binary] = STATE(3215),
    [sym_unary] = STATE(3215),
    [sym_left_assignment_list] = STATE(3219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3220),
    [sym__variable] = STATE(3216),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3220),
    [sym_false] = STATE(3220),
    [sym_nil] = STATE(3220),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3221),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(3218),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(5371),
    [sym__splat_star] = ACTIONS(5373),
    [sym__unary_minus] = ACTIONS(5375),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(5377),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_EQ] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(5379),
    [anon_sym_yield] = ACTIONS(5381),
    [anon_sym_break] = ACTIONS(5383),
    [anon_sym_next] = ACTIONS(5385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(417),
    [anon_sym_DASH_EQ] = ACTIONS(417),
    [anon_sym_STAR_EQ] = ACTIONS(417),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(417),
    [anon_sym_SLASH_EQ] = ACTIONS(417),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(417),
    [anon_sym_PIPE_EQ] = ACTIONS(417),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(417),
    [anon_sym_AMP_EQ] = ACTIONS(417),
    [anon_sym_PERCENT_EQ] = ACTIONS(417),
    [anon_sym_GT_GT_EQ] = ACTIONS(417),
    [anon_sym_LT_LT_EQ] = ACTIONS(417),
    [anon_sym_CARET_EQ] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(5387),
    [anon_sym_not] = ACTIONS(5389),
    [anon_sym_BANG] = ACTIONS(5391),
    [anon_sym_TILDE] = ACTIONS(5393),
    [sym_constant] = ACTIONS(5395),
    [sym_identifier] = ACTIONS(5395),
    [sym_instance_variable] = ACTIONS(5397),
    [sym_class_variable] = ACTIONS(5397),
    [sym_global_variable] = ACTIONS(5397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5851] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3215),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3220),
    [sym_scope_resolution] = STATE(3216),
    [sym_call] = STATE(3216),
    [sym_method_call] = STATE(3220),
    [sym_argument_list] = STATE(3612),
    [sym__argument_list_with_parens] = STATE(3217),
    [sym__argument] = STATE(3218),
    [sym_splat_argument] = STATE(3218),
    [sym_hash_splat_argument] = STATE(3218),
    [sym_block_argument] = STATE(3218),
    [sym_assignment] = STATE(3215),
    [sym_operator_assignment] = STATE(3215),
    [sym_conditional] = STATE(3215),
    [sym_range] = STATE(3215),
    [sym_binary] = STATE(3215),
    [sym_unary] = STATE(3215),
    [sym_left_assignment_list] = STATE(3219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3220),
    [sym__variable] = STATE(3216),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3220),
    [sym_false] = STATE(3220),
    [sym_nil] = STATE(3220),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3221),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(3218),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(5371),
    [sym__splat_star] = ACTIONS(5373),
    [sym__unary_minus] = ACTIONS(5375),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(5377),
    [anon_sym_LBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_EQ] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(423),
    [anon_sym_return] = ACTIONS(5379),
    [anon_sym_yield] = ACTIONS(5381),
    [anon_sym_break] = ACTIONS(5383),
    [anon_sym_next] = ACTIONS(5385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(421),
    [anon_sym_DASH_EQ] = ACTIONS(421),
    [anon_sym_STAR_EQ] = ACTIONS(421),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(421),
    [anon_sym_SLASH_EQ] = ACTIONS(421),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(421),
    [anon_sym_PIPE_EQ] = ACTIONS(421),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(421),
    [anon_sym_AMP_EQ] = ACTIONS(421),
    [anon_sym_PERCENT_EQ] = ACTIONS(421),
    [anon_sym_GT_GT_EQ] = ACTIONS(421),
    [anon_sym_LT_LT_EQ] = ACTIONS(421),
    [anon_sym_CARET_EQ] = ACTIONS(421),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(5387),
    [anon_sym_not] = ACTIONS(5389),
    [anon_sym_BANG] = ACTIONS(5391),
    [anon_sym_TILDE] = ACTIONS(5393),
    [sym_constant] = ACTIONS(5395),
    [sym_identifier] = ACTIONS(5395),
    [sym_instance_variable] = ACTIONS(5397),
    [sym_class_variable] = ACTIONS(5397),
    [sym_global_variable] = ACTIONS(5397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5852] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3215),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3220),
    [sym_scope_resolution] = STATE(3216),
    [sym_call] = STATE(3216),
    [sym_method_call] = STATE(3220),
    [sym_argument_list] = STATE(3613),
    [sym__argument_list_with_parens] = STATE(3217),
    [sym__argument] = STATE(3218),
    [sym_splat_argument] = STATE(3218),
    [sym_hash_splat_argument] = STATE(3218),
    [sym_block_argument] = STATE(3218),
    [sym_assignment] = STATE(3215),
    [sym_operator_assignment] = STATE(3215),
    [sym_conditional] = STATE(3215),
    [sym_range] = STATE(3215),
    [sym_binary] = STATE(3215),
    [sym_unary] = STATE(3215),
    [sym_left_assignment_list] = STATE(3219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3220),
    [sym__variable] = STATE(3216),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3220),
    [sym_false] = STATE(3220),
    [sym_nil] = STATE(3220),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3221),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(3218),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(5371),
    [sym__splat_star] = ACTIONS(5373),
    [sym__unary_minus] = ACTIONS(5375),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(5377),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(427),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(427),
    [anon_sym_return] = ACTIONS(5379),
    [anon_sym_yield] = ACTIONS(5381),
    [anon_sym_break] = ACTIONS(5383),
    [anon_sym_next] = ACTIONS(5385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(425),
    [anon_sym_DASH_EQ] = ACTIONS(425),
    [anon_sym_STAR_EQ] = ACTIONS(425),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(425),
    [anon_sym_SLASH_EQ] = ACTIONS(425),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(425),
    [anon_sym_PIPE_EQ] = ACTIONS(425),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(425),
    [anon_sym_AMP_EQ] = ACTIONS(425),
    [anon_sym_PERCENT_EQ] = ACTIONS(425),
    [anon_sym_GT_GT_EQ] = ACTIONS(425),
    [anon_sym_LT_LT_EQ] = ACTIONS(425),
    [anon_sym_CARET_EQ] = ACTIONS(425),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(5387),
    [anon_sym_not] = ACTIONS(5389),
    [anon_sym_BANG] = ACTIONS(5391),
    [anon_sym_TILDE] = ACTIONS(5393),
    [sym_constant] = ACTIONS(5395),
    [sym_identifier] = ACTIONS(5395),
    [sym_instance_variable] = ACTIONS(5397),
    [sym_class_variable] = ACTIONS(5397),
    [sym_global_variable] = ACTIONS(5397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5853] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(8264),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(5858),
    [sym_scope_resolution] = STATE(5856),
    [sym_call] = STATE(5856),
    [sym_method_call] = STATE(5858),
    [sym_assignment] = STATE(8264),
    [sym_operator_assignment] = STATE(8264),
    [sym_conditional] = STATE(8264),
    [sym_range] = STATE(8264),
    [sym_binary] = STATE(8264),
    [sym_unary] = STATE(8264),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5858),
    [sym__variable] = STATE(5856),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(5858),
    [sym_false] = STATE(5858),
    [sym_nil] = STATE(5858),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(5859),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(9107),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(9109),
    [anon_sym_yield] = ACTIONS(9111),
    [anon_sym_break] = ACTIONS(9113),
    [anon_sym_next] = ACTIONS(9115),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(9117),
    [anon_sym_defined_QMARK] = ACTIONS(9119),
    [anon_sym_not] = ACTIONS(9121),
    [anon_sym_BANG] = ACTIONS(9123),
    [anon_sym_TILDE] = ACTIONS(9123),
    [sym_constant] = ACTIONS(9125),
    [sym_identifier] = ACTIONS(9125),
    [sym_instance_variable] = ACTIONS(9127),
    [sym_class_variable] = ACTIONS(9127),
    [sym_global_variable] = ACTIONS(9127),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(9125),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9125),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [5854] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(3628),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(5858),
    [sym_scope_resolution] = STATE(5856),
    [sym_call] = STATE(5856),
    [sym_method_call] = STATE(5858),
    [sym_assignment] = STATE(3628),
    [sym_operator_assignment] = STATE(3628),
    [sym_conditional] = STATE(3628),
    [sym_range] = STATE(3628),
    [sym_binary] = STATE(3628),
    [sym_unary] = STATE(3628),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5858),
    [sym__variable] = STATE(5856),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(5858),
    [sym_false] = STATE(5858),
    [sym_nil] = STATE(5858),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(5859),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(9107),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(9109),
    [anon_sym_yield] = ACTIONS(9111),
    [anon_sym_break] = ACTIONS(9113),
    [anon_sym_next] = ACTIONS(9115),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(9117),
    [anon_sym_defined_QMARK] = ACTIONS(9119),
    [anon_sym_not] = ACTIONS(9121),
    [anon_sym_BANG] = ACTIONS(9123),
    [anon_sym_TILDE] = ACTIONS(9123),
    [sym_constant] = ACTIONS(9125),
    [sym_identifier] = ACTIONS(9125),
    [sym_instance_variable] = ACTIONS(9127),
    [sym_class_variable] = ACTIONS(9127),
    [sym_global_variable] = ACTIONS(9127),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(9125),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9125),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [5855] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(11776),
    [sym__binary_star] = ACTIONS(11778),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(11780),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(11782),
    [anon_sym_AMP] = ACTIONS(11784),
    [anon_sym_EQ] = ACTIONS(4217),
    [anon_sym_LT] = ACTIONS(11786),
    [anon_sym_end] = ACTIONS(4211),
    [anon_sym_if] = ACTIONS(4211),
    [anon_sym_unless] = ACTIONS(4211),
    [anon_sym_while] = ACTIONS(4211),
    [anon_sym_until] = ACTIONS(4211),
    [anon_sym_rescue] = ACTIONS(4211),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_PLUS_EQ] = ACTIONS(4211),
    [anon_sym_DASH_EQ] = ACTIONS(4211),
    [anon_sym_STAR_EQ] = ACTIONS(4211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4211),
    [anon_sym_SLASH_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4211),
    [anon_sym_AMP_EQ] = ACTIONS(4211),
    [anon_sym_PERCENT_EQ] = ACTIONS(4211),
    [anon_sym_GT_GT_EQ] = ACTIONS(4211),
    [anon_sym_LT_LT_EQ] = ACTIONS(4211),
    [anon_sym_CARET_EQ] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(11788),
    [anon_sym_DOT_DOT] = ACTIONS(11790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11792),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11794),
    [anon_sym_AMP_AMP] = ACTIONS(11794),
    [anon_sym_LT_LT] = ACTIONS(11796),
    [anon_sym_GT_GT] = ACTIONS(11796),
    [anon_sym_EQ_EQ] = ACTIONS(11794),
    [anon_sym_BANG_EQ] = ACTIONS(11798),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11798),
    [anon_sym_LT_EQ_GT] = ACTIONS(11798),
    [anon_sym_EQ_TILDE] = ACTIONS(11798),
    [anon_sym_BANG_TILDE] = ACTIONS(11798),
    [anon_sym_LT_EQ] = ACTIONS(11786),
    [anon_sym_GT] = ACTIONS(11786),
    [anon_sym_GT_EQ] = ACTIONS(11800),
    [anon_sym_CARET] = ACTIONS(11780),
    [anon_sym_PLUS] = ACTIONS(11802),
    [anon_sym_SLASH] = ACTIONS(11782),
    [anon_sym_PERCENT] = ACTIONS(11782),
    [sym_comment] = ACTIONS(87),
  },
  [5856] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3215),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3220),
    [sym_scope_resolution] = STATE(3216),
    [sym_call] = STATE(3216),
    [sym_method_call] = STATE(3220),
    [sym_argument_list] = STATE(1062),
    [sym__argument_list_with_parens] = STATE(3217),
    [sym__argument] = STATE(3218),
    [sym_splat_argument] = STATE(3218),
    [sym_hash_splat_argument] = STATE(3218),
    [sym_block_argument] = STATE(3218),
    [sym_do_block] = STATE(426),
    [sym_block] = STATE(426),
    [sym_assignment] = STATE(3215),
    [sym_operator_assignment] = STATE(3215),
    [sym_conditional] = STATE(3215),
    [sym_range] = STATE(3215),
    [sym_binary] = STATE(3215),
    [sym_unary] = STATE(3215),
    [sym_left_assignment_list] = STATE(3219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3220),
    [sym__variable] = STATE(3216),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3220),
    [sym_false] = STATE(3220),
    [sym_nil] = STATE(3220),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3221),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(3218),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(743),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(5371),
    [sym__splat_star] = ACTIONS(5373),
    [sym__unary_minus] = ACTIONS(5375),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(5377),
    [anon_sym_LBRACE] = ACTIONS(6047),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(769),
    [anon_sym_return] = ACTIONS(5379),
    [anon_sym_yield] = ACTIONS(5381),
    [anon_sym_break] = ACTIONS(5383),
    [anon_sym_next] = ACTIONS(5385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(769),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(769),
    [anon_sym_until] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(769),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(769),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(5387),
    [anon_sym_not] = ACTIONS(5389),
    [anon_sym_BANG] = ACTIONS(5391),
    [anon_sym_TILDE] = ACTIONS(5393),
    [sym_constant] = ACTIONS(5395),
    [sym_identifier] = ACTIONS(5395),
    [sym_instance_variable] = ACTIONS(5397),
    [sym_class_variable] = ACTIONS(5397),
    [sym_global_variable] = ACTIONS(5397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5857] = {
    [anon_sym_EQ] = ACTIONS(11804),
    [sym_comment] = ACTIONS(87),
  },
  [5858] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(11806),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(11808),
    [anon_sym_DASH_EQ] = ACTIONS(11808),
    [anon_sym_STAR_EQ] = ACTIONS(11808),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11808),
    [anon_sym_SLASH_EQ] = ACTIONS(11808),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11808),
    [anon_sym_PIPE_EQ] = ACTIONS(11808),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11808),
    [anon_sym_AMP_EQ] = ACTIONS(11808),
    [anon_sym_PERCENT_EQ] = ACTIONS(11808),
    [anon_sym_GT_GT_EQ] = ACTIONS(11808),
    [anon_sym_LT_LT_EQ] = ACTIONS(11808),
    [anon_sym_CARET_EQ] = ACTIONS(11808),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5859] = {
    [sym_string] = STATE(8277),
    [aux_sym_chained_string_repeat1] = STATE(8277),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(2551),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5860] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(11776),
    [sym__binary_star] = ACTIONS(11778),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(11780),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(11782),
    [anon_sym_AMP] = ACTIONS(11784),
    [anon_sym_EQ] = ACTIONS(4249),
    [anon_sym_LT] = ACTIONS(11786),
    [anon_sym_end] = ACTIONS(4247),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_PLUS_EQ] = ACTIONS(4247),
    [anon_sym_DASH_EQ] = ACTIONS(4247),
    [anon_sym_STAR_EQ] = ACTIONS(4247),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4247),
    [anon_sym_SLASH_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4247),
    [anon_sym_AMP_EQ] = ACTIONS(4247),
    [anon_sym_PERCENT_EQ] = ACTIONS(4247),
    [anon_sym_GT_GT_EQ] = ACTIONS(4247),
    [anon_sym_LT_LT_EQ] = ACTIONS(4247),
    [anon_sym_CARET_EQ] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(11788),
    [anon_sym_DOT_DOT] = ACTIONS(11790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11792),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(11794),
    [anon_sym_AMP_AMP] = ACTIONS(11794),
    [anon_sym_LT_LT] = ACTIONS(11796),
    [anon_sym_GT_GT] = ACTIONS(11796),
    [anon_sym_EQ_EQ] = ACTIONS(11794),
    [anon_sym_BANG_EQ] = ACTIONS(11798),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11798),
    [anon_sym_LT_EQ_GT] = ACTIONS(11798),
    [anon_sym_EQ_TILDE] = ACTIONS(11798),
    [anon_sym_BANG_TILDE] = ACTIONS(11798),
    [anon_sym_LT_EQ] = ACTIONS(11786),
    [anon_sym_GT] = ACTIONS(11786),
    [anon_sym_GT_EQ] = ACTIONS(11800),
    [anon_sym_CARET] = ACTIONS(11780),
    [anon_sym_PLUS] = ACTIONS(11802),
    [anon_sym_SLASH] = ACTIONS(11782),
    [anon_sym_PERCENT] = ACTIONS(11782),
    [sym_comment] = ACTIONS(87),
  },
  [5861] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(9141),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [5862] = {
    [sym_string] = STATE(5882),
    [aux_sym_chained_string_repeat1] = STATE(5882),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(747),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5863] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(8278),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(5858),
    [sym_scope_resolution] = STATE(5856),
    [sym_call] = STATE(5856),
    [sym_method_call] = STATE(5858),
    [sym_assignment] = STATE(8278),
    [sym_operator_assignment] = STATE(8278),
    [sym_conditional] = STATE(8278),
    [sym_range] = STATE(8278),
    [sym_binary] = STATE(8278),
    [sym_unary] = STATE(8278),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5858),
    [sym__variable] = STATE(5856),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(5858),
    [sym_false] = STATE(5858),
    [sym_nil] = STATE(5858),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(5859),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(9107),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(9109),
    [anon_sym_yield] = ACTIONS(9111),
    [anon_sym_break] = ACTIONS(9113),
    [anon_sym_next] = ACTIONS(9115),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(9117),
    [anon_sym_defined_QMARK] = ACTIONS(9119),
    [anon_sym_not] = ACTIONS(9121),
    [anon_sym_BANG] = ACTIONS(9123),
    [anon_sym_TILDE] = ACTIONS(9123),
    [sym_constant] = ACTIONS(9125),
    [sym_identifier] = ACTIONS(9125),
    [sym_instance_variable] = ACTIONS(9127),
    [sym_class_variable] = ACTIONS(9127),
    [sym_global_variable] = ACTIONS(9127),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(9125),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9125),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [5864] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(11776),
    [sym__binary_star] = ACTIONS(11778),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(11780),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(11782),
    [anon_sym_AMP] = ACTIONS(11784),
    [anon_sym_EQ] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(11786),
    [anon_sym_end] = ACTIONS(3281),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_unless] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_until] = ACTIONS(3281),
    [anon_sym_rescue] = ACTIONS(3281),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_PLUS_EQ] = ACTIONS(3281),
    [anon_sym_DASH_EQ] = ACTIONS(3281),
    [anon_sym_STAR_EQ] = ACTIONS(3281),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3281),
    [anon_sym_SLASH_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3281),
    [anon_sym_AMP_EQ] = ACTIONS(3281),
    [anon_sym_PERCENT_EQ] = ACTIONS(3281),
    [anon_sym_GT_GT_EQ] = ACTIONS(3281),
    [anon_sym_LT_LT_EQ] = ACTIONS(3281),
    [anon_sym_CARET_EQ] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(11788),
    [anon_sym_DOT_DOT] = ACTIONS(11790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11792),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(11794),
    [anon_sym_AMP_AMP] = ACTIONS(11794),
    [anon_sym_LT_LT] = ACTIONS(11796),
    [anon_sym_GT_GT] = ACTIONS(11796),
    [anon_sym_EQ_EQ] = ACTIONS(11794),
    [anon_sym_BANG_EQ] = ACTIONS(11798),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11798),
    [anon_sym_LT_EQ_GT] = ACTIONS(11798),
    [anon_sym_EQ_TILDE] = ACTIONS(11798),
    [anon_sym_BANG_TILDE] = ACTIONS(11798),
    [anon_sym_LT_EQ] = ACTIONS(11786),
    [anon_sym_GT] = ACTIONS(11786),
    [anon_sym_GT_EQ] = ACTIONS(11800),
    [anon_sym_CARET] = ACTIONS(11780),
    [anon_sym_PLUS] = ACTIONS(11802),
    [anon_sym_SLASH] = ACTIONS(11782),
    [anon_sym_PERCENT] = ACTIONS(11782),
    [sym_comment] = ACTIONS(87),
  },
  [5865] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(9135),
    [sym__binary_star] = ACTIONS(9137),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(9139),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(9141),
    [anon_sym_AMP] = ACTIONS(9143),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(9145),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(9147),
    [anon_sym_DOT_DOT] = ACTIONS(9149),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9151),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(9153),
    [anon_sym_AMP_AMP] = ACTIONS(9153),
    [anon_sym_LT_LT] = ACTIONS(9155),
    [anon_sym_GT_GT] = ACTIONS(9155),
    [anon_sym_EQ_EQ] = ACTIONS(9153),
    [anon_sym_BANG_EQ] = ACTIONS(9157),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9157),
    [anon_sym_LT_EQ_GT] = ACTIONS(9157),
    [anon_sym_EQ_TILDE] = ACTIONS(9157),
    [anon_sym_BANG_TILDE] = ACTIONS(9157),
    [anon_sym_LT_EQ] = ACTIONS(9145),
    [anon_sym_GT] = ACTIONS(9145),
    [anon_sym_GT_EQ] = ACTIONS(9159),
    [anon_sym_CARET] = ACTIONS(9139),
    [anon_sym_PLUS] = ACTIONS(9161),
    [anon_sym_SLASH] = ACTIONS(9141),
    [anon_sym_PERCENT] = ACTIONS(9141),
    [sym_comment] = ACTIONS(87),
  },
  [5866] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(8279),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(5858),
    [sym_scope_resolution] = STATE(5856),
    [sym_call] = STATE(5856),
    [sym_method_call] = STATE(5858),
    [sym_assignment] = STATE(8279),
    [sym_operator_assignment] = STATE(8279),
    [sym_conditional] = STATE(8279),
    [sym_range] = STATE(8279),
    [sym_binary] = STATE(8279),
    [sym_unary] = STATE(8279),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5858),
    [sym__variable] = STATE(5856),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(5858),
    [sym_false] = STATE(5858),
    [sym_nil] = STATE(5858),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(5859),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(9107),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(9109),
    [anon_sym_yield] = ACTIONS(9111),
    [anon_sym_break] = ACTIONS(9113),
    [anon_sym_next] = ACTIONS(9115),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(9117),
    [anon_sym_defined_QMARK] = ACTIONS(9119),
    [anon_sym_not] = ACTIONS(9121),
    [anon_sym_BANG] = ACTIONS(9123),
    [anon_sym_TILDE] = ACTIONS(9123),
    [sym_constant] = ACTIONS(9125),
    [sym_identifier] = ACTIONS(9125),
    [sym_instance_variable] = ACTIONS(9127),
    [sym_class_variable] = ACTIONS(9127),
    [sym_global_variable] = ACTIONS(9127),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(9125),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9125),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [5867] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8280),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3220),
    [sym_scope_resolution] = STATE(3216),
    [sym_call] = STATE(3216),
    [sym_method_call] = STATE(3220),
    [sym_assignment] = STATE(8280),
    [sym_operator_assignment] = STATE(8280),
    [sym_conditional] = STATE(8280),
    [sym_range] = STATE(8280),
    [sym_binary] = STATE(8280),
    [sym_unary] = STATE(8280),
    [sym_left_assignment_list] = STATE(3219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3220),
    [sym__variable] = STATE(3216),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3220),
    [sym_false] = STATE(3220),
    [sym_nil] = STATE(3220),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5862),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5375),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5379),
    [anon_sym_yield] = ACTIONS(5381),
    [anon_sym_break] = ACTIONS(5383),
    [anon_sym_next] = ACTIONS(5385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(9129),
    [anon_sym_defined_QMARK] = ACTIONS(5387),
    [anon_sym_not] = ACTIONS(5389),
    [anon_sym_BANG] = ACTIONS(5393),
    [anon_sym_TILDE] = ACTIONS(5393),
    [sym_constant] = ACTIONS(5399),
    [sym_identifier] = ACTIONS(5399),
    [sym_instance_variable] = ACTIONS(5397),
    [sym_class_variable] = ACTIONS(5397),
    [sym_global_variable] = ACTIONS(5397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5868] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8281),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3220),
    [sym_scope_resolution] = STATE(3216),
    [sym_call] = STATE(3216),
    [sym_method_call] = STATE(3220),
    [sym_assignment] = STATE(8281),
    [sym_operator_assignment] = STATE(8281),
    [sym_conditional] = STATE(8281),
    [sym_range] = STATE(8281),
    [sym_binary] = STATE(8281),
    [sym_unary] = STATE(8281),
    [sym_left_assignment_list] = STATE(3219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3220),
    [sym__variable] = STATE(3216),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3220),
    [sym_false] = STATE(3220),
    [sym_nil] = STATE(3220),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5862),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5375),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5379),
    [anon_sym_yield] = ACTIONS(5381),
    [anon_sym_break] = ACTIONS(5383),
    [anon_sym_next] = ACTIONS(5385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(9129),
    [anon_sym_defined_QMARK] = ACTIONS(5387),
    [anon_sym_not] = ACTIONS(5389),
    [anon_sym_BANG] = ACTIONS(5393),
    [anon_sym_TILDE] = ACTIONS(5393),
    [sym_constant] = ACTIONS(5399),
    [sym_identifier] = ACTIONS(5399),
    [sym_instance_variable] = ACTIONS(5397),
    [sym_class_variable] = ACTIONS(5397),
    [sym_global_variable] = ACTIONS(5397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5869] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8282),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3220),
    [sym_scope_resolution] = STATE(3216),
    [sym_call] = STATE(3216),
    [sym_method_call] = STATE(3220),
    [sym_assignment] = STATE(8282),
    [sym_operator_assignment] = STATE(8282),
    [sym_conditional] = STATE(8282),
    [sym_range] = STATE(8282),
    [sym_binary] = STATE(8282),
    [sym_unary] = STATE(8282),
    [sym_left_assignment_list] = STATE(3219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3220),
    [sym__variable] = STATE(3216),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3220),
    [sym_false] = STATE(3220),
    [sym_nil] = STATE(3220),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5862),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5375),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5379),
    [anon_sym_yield] = ACTIONS(5381),
    [anon_sym_break] = ACTIONS(5383),
    [anon_sym_next] = ACTIONS(5385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(9129),
    [anon_sym_defined_QMARK] = ACTIONS(5387),
    [anon_sym_not] = ACTIONS(5389),
    [anon_sym_BANG] = ACTIONS(5393),
    [anon_sym_TILDE] = ACTIONS(5393),
    [sym_constant] = ACTIONS(5399),
    [sym_identifier] = ACTIONS(5399),
    [sym_instance_variable] = ACTIONS(5397),
    [sym_class_variable] = ACTIONS(5397),
    [sym_global_variable] = ACTIONS(5397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5870] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8283),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3220),
    [sym_scope_resolution] = STATE(3216),
    [sym_call] = STATE(3216),
    [sym_method_call] = STATE(3220),
    [sym_assignment] = STATE(8283),
    [sym_operator_assignment] = STATE(8283),
    [sym_conditional] = STATE(8283),
    [sym_range] = STATE(8283),
    [sym_binary] = STATE(8283),
    [sym_unary] = STATE(8283),
    [sym_left_assignment_list] = STATE(3219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3220),
    [sym__variable] = STATE(3216),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3220),
    [sym_false] = STATE(3220),
    [sym_nil] = STATE(3220),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5862),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5375),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5379),
    [anon_sym_yield] = ACTIONS(5381),
    [anon_sym_break] = ACTIONS(5383),
    [anon_sym_next] = ACTIONS(5385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(9129),
    [anon_sym_defined_QMARK] = ACTIONS(5387),
    [anon_sym_not] = ACTIONS(5389),
    [anon_sym_BANG] = ACTIONS(5393),
    [anon_sym_TILDE] = ACTIONS(5393),
    [sym_constant] = ACTIONS(5399),
    [sym_identifier] = ACTIONS(5399),
    [sym_instance_variable] = ACTIONS(5397),
    [sym_class_variable] = ACTIONS(5397),
    [sym_global_variable] = ACTIONS(5397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5871] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8284),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3220),
    [sym_scope_resolution] = STATE(3216),
    [sym_call] = STATE(3216),
    [sym_method_call] = STATE(3220),
    [sym_assignment] = STATE(8284),
    [sym_operator_assignment] = STATE(8284),
    [sym_conditional] = STATE(8284),
    [sym_range] = STATE(8284),
    [sym_binary] = STATE(8284),
    [sym_unary] = STATE(8284),
    [sym_left_assignment_list] = STATE(3219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3220),
    [sym__variable] = STATE(3216),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3220),
    [sym_false] = STATE(3220),
    [sym_nil] = STATE(3220),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5862),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5375),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5379),
    [anon_sym_yield] = ACTIONS(5381),
    [anon_sym_break] = ACTIONS(5383),
    [anon_sym_next] = ACTIONS(5385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(9129),
    [anon_sym_defined_QMARK] = ACTIONS(5387),
    [anon_sym_not] = ACTIONS(5389),
    [anon_sym_BANG] = ACTIONS(5393),
    [anon_sym_TILDE] = ACTIONS(5393),
    [sym_constant] = ACTIONS(5399),
    [sym_identifier] = ACTIONS(5399),
    [sym_instance_variable] = ACTIONS(5397),
    [sym_class_variable] = ACTIONS(5397),
    [sym_global_variable] = ACTIONS(5397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5872] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(8285),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(8285),
    [sym_operator_assignment] = STATE(8285),
    [sym_conditional] = STATE(8285),
    [sym_range] = STATE(8285),
    [sym_binary] = STATE(8285),
    [sym_unary] = STATE(8285),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5873] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8286),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3220),
    [sym_scope_resolution] = STATE(3216),
    [sym_call] = STATE(3216),
    [sym_method_call] = STATE(3220),
    [sym_assignment] = STATE(8286),
    [sym_operator_assignment] = STATE(8286),
    [sym_conditional] = STATE(8286),
    [sym_range] = STATE(8286),
    [sym_binary] = STATE(8286),
    [sym_unary] = STATE(8286),
    [sym_left_assignment_list] = STATE(3219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3220),
    [sym__variable] = STATE(3216),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3220),
    [sym_false] = STATE(3220),
    [sym_nil] = STATE(3220),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5862),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5375),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5379),
    [anon_sym_yield] = ACTIONS(5381),
    [anon_sym_break] = ACTIONS(5383),
    [anon_sym_next] = ACTIONS(5385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(9129),
    [anon_sym_defined_QMARK] = ACTIONS(5387),
    [anon_sym_not] = ACTIONS(5389),
    [anon_sym_BANG] = ACTIONS(5393),
    [anon_sym_TILDE] = ACTIONS(5393),
    [sym_constant] = ACTIONS(5399),
    [sym_identifier] = ACTIONS(5399),
    [sym_instance_variable] = ACTIONS(5397),
    [sym_class_variable] = ACTIONS(5397),
    [sym_global_variable] = ACTIONS(5397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5874] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8287),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3220),
    [sym_scope_resolution] = STATE(3216),
    [sym_call] = STATE(3216),
    [sym_method_call] = STATE(3220),
    [sym_assignment] = STATE(8287),
    [sym_operator_assignment] = STATE(8287),
    [sym_conditional] = STATE(8287),
    [sym_range] = STATE(8287),
    [sym_binary] = STATE(8287),
    [sym_unary] = STATE(8287),
    [sym_left_assignment_list] = STATE(3219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3220),
    [sym__variable] = STATE(3216),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3220),
    [sym_false] = STATE(3220),
    [sym_nil] = STATE(3220),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5862),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5375),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5379),
    [anon_sym_yield] = ACTIONS(5381),
    [anon_sym_break] = ACTIONS(5383),
    [anon_sym_next] = ACTIONS(5385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(9129),
    [anon_sym_defined_QMARK] = ACTIONS(5387),
    [anon_sym_not] = ACTIONS(5389),
    [anon_sym_BANG] = ACTIONS(5393),
    [anon_sym_TILDE] = ACTIONS(5393),
    [sym_constant] = ACTIONS(5399),
    [sym_identifier] = ACTIONS(5399),
    [sym_instance_variable] = ACTIONS(5397),
    [sym_class_variable] = ACTIONS(5397),
    [sym_global_variable] = ACTIONS(5397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5875] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8288),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3220),
    [sym_scope_resolution] = STATE(3216),
    [sym_call] = STATE(3216),
    [sym_method_call] = STATE(3220),
    [sym_assignment] = STATE(8288),
    [sym_operator_assignment] = STATE(8288),
    [sym_conditional] = STATE(8288),
    [sym_range] = STATE(8288),
    [sym_binary] = STATE(8288),
    [sym_unary] = STATE(8288),
    [sym_left_assignment_list] = STATE(3219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3220),
    [sym__variable] = STATE(3216),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3220),
    [sym_false] = STATE(3220),
    [sym_nil] = STATE(3220),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5862),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5375),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5379),
    [anon_sym_yield] = ACTIONS(5381),
    [anon_sym_break] = ACTIONS(5383),
    [anon_sym_next] = ACTIONS(5385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(9129),
    [anon_sym_defined_QMARK] = ACTIONS(5387),
    [anon_sym_not] = ACTIONS(5389),
    [anon_sym_BANG] = ACTIONS(5393),
    [anon_sym_TILDE] = ACTIONS(5393),
    [sym_constant] = ACTIONS(5399),
    [sym_identifier] = ACTIONS(5399),
    [sym_instance_variable] = ACTIONS(5397),
    [sym_class_variable] = ACTIONS(5397),
    [sym_global_variable] = ACTIONS(5397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5876] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8289),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3220),
    [sym_scope_resolution] = STATE(3216),
    [sym_call] = STATE(3216),
    [sym_method_call] = STATE(3220),
    [sym_assignment] = STATE(8289),
    [sym_operator_assignment] = STATE(8289),
    [sym_conditional] = STATE(8289),
    [sym_range] = STATE(8289),
    [sym_binary] = STATE(8289),
    [sym_unary] = STATE(8289),
    [sym_left_assignment_list] = STATE(3219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3220),
    [sym__variable] = STATE(3216),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3220),
    [sym_false] = STATE(3220),
    [sym_nil] = STATE(3220),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5862),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5375),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5379),
    [anon_sym_yield] = ACTIONS(5381),
    [anon_sym_break] = ACTIONS(5383),
    [anon_sym_next] = ACTIONS(5385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(9129),
    [anon_sym_defined_QMARK] = ACTIONS(5387),
    [anon_sym_not] = ACTIONS(5389),
    [anon_sym_BANG] = ACTIONS(5393),
    [anon_sym_TILDE] = ACTIONS(5393),
    [sym_constant] = ACTIONS(5399),
    [sym_identifier] = ACTIONS(5399),
    [sym_instance_variable] = ACTIONS(5397),
    [sym_class_variable] = ACTIONS(5397),
    [sym_global_variable] = ACTIONS(5397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5877] = {
    [sym_heredoc_body] = STATE(8290),
    [aux_sym_call_repeat1] = STATE(8290),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [5878] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3215),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3220),
    [sym_scope_resolution] = STATE(3216),
    [sym_call] = STATE(3216),
    [sym_method_call] = STATE(3220),
    [sym__argument] = STATE(3737),
    [sym_splat_argument] = STATE(3737),
    [sym_hash_splat_argument] = STATE(3737),
    [sym_block_argument] = STATE(3737),
    [sym_assignment] = STATE(3215),
    [sym_operator_assignment] = STATE(3215),
    [sym_conditional] = STATE(3215),
    [sym_range] = STATE(3215),
    [sym_binary] = STATE(3215),
    [sym_unary] = STATE(3215),
    [sym_left_assignment_list] = STATE(3219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3220),
    [sym__variable] = STATE(3216),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3220),
    [sym_false] = STATE(3220),
    [sym_nil] = STATE(3220),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3221),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_heredoc_body] = STATE(8291),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(3737),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(5371),
    [sym__splat_star] = ACTIONS(5373),
    [sym__unary_minus] = ACTIONS(5375),
    [sym__identifier_hash_key] = ACTIONS(5377),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11810),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5379),
    [anon_sym_yield] = ACTIONS(5381),
    [anon_sym_break] = ACTIONS(5383),
    [anon_sym_next] = ACTIONS(5385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(9129),
    [anon_sym_defined_QMARK] = ACTIONS(5387),
    [anon_sym_not] = ACTIONS(5389),
    [anon_sym_BANG] = ACTIONS(5393),
    [anon_sym_TILDE] = ACTIONS(5393),
    [sym_constant] = ACTIONS(5395),
    [sym_identifier] = ACTIONS(5395),
    [sym_instance_variable] = ACTIONS(5397),
    [sym_class_variable] = ACTIONS(5397),
    [sym_global_variable] = ACTIONS(5397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5879] = {
    [sym_heredoc_body] = STATE(8292),
    [aux_sym_call_repeat1] = STATE(8292),
    [aux_sym_argument_list_repeat1] = STATE(8293),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(9163),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [5880] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8294),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3220),
    [sym_scope_resolution] = STATE(3216),
    [sym_call] = STATE(3216),
    [sym_method_call] = STATE(3220),
    [sym_splat_argument] = STATE(8295),
    [sym_assignment] = STATE(8294),
    [sym_operator_assignment] = STATE(8294),
    [sym_conditional] = STATE(8294),
    [sym_range] = STATE(8294),
    [sym_binary] = STATE(8294),
    [sym_unary] = STATE(8294),
    [sym_right_assignment_list] = STATE(3742),
    [sym__arg_or_splat_arg] = STATE(8295),
    [sym_left_assignment_list] = STATE(3219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3220),
    [sym__variable] = STATE(3216),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3220),
    [sym_false] = STATE(3220),
    [sym_nil] = STATE(3220),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5862),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__splat_star] = ACTIONS(9091),
    [sym__unary_minus] = ACTIONS(5375),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5379),
    [anon_sym_yield] = ACTIONS(5381),
    [anon_sym_break] = ACTIONS(5383),
    [anon_sym_next] = ACTIONS(5385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(9129),
    [anon_sym_defined_QMARK] = ACTIONS(5387),
    [anon_sym_not] = ACTIONS(5389),
    [anon_sym_BANG] = ACTIONS(5393),
    [anon_sym_TILDE] = ACTIONS(5393),
    [sym_constant] = ACTIONS(5399),
    [sym_identifier] = ACTIONS(5399),
    [sym_instance_variable] = ACTIONS(5397),
    [sym_class_variable] = ACTIONS(5397),
    [sym_global_variable] = ACTIONS(5397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5881] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8296),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3220),
    [sym_scope_resolution] = STATE(3216),
    [sym_call] = STATE(3216),
    [sym_method_call] = STATE(3220),
    [sym_assignment] = STATE(8296),
    [sym_operator_assignment] = STATE(8296),
    [sym_conditional] = STATE(8296),
    [sym_range] = STATE(8296),
    [sym_binary] = STATE(8296),
    [sym_unary] = STATE(8296),
    [sym_left_assignment_list] = STATE(3219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3220),
    [sym__variable] = STATE(3216),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3220),
    [sym_false] = STATE(3220),
    [sym_nil] = STATE(3220),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5862),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5375),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5379),
    [anon_sym_yield] = ACTIONS(5381),
    [anon_sym_break] = ACTIONS(5383),
    [anon_sym_next] = ACTIONS(5385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(9129),
    [anon_sym_defined_QMARK] = ACTIONS(5387),
    [anon_sym_not] = ACTIONS(5389),
    [anon_sym_BANG] = ACTIONS(5393),
    [anon_sym_TILDE] = ACTIONS(5393),
    [sym_constant] = ACTIONS(5399),
    [sym_identifier] = ACTIONS(5399),
    [sym_instance_variable] = ACTIONS(5397),
    [sym_class_variable] = ACTIONS(5397),
    [sym_global_variable] = ACTIONS(5397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5882] = {
    [sym_string] = STATE(8297),
    [aux_sym_chained_string_repeat1] = STATE(8297),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(747),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2755),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_EQ] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_end] = ACTIONS(2753),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_EQ_GT] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_PLUS_EQ] = ACTIONS(2753),
    [anon_sym_DASH_EQ] = ACTIONS(2753),
    [anon_sym_STAR_EQ] = ACTIONS(2753),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2753),
    [anon_sym_SLASH_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2753),
    [anon_sym_AMP_EQ] = ACTIONS(2753),
    [anon_sym_PERCENT_EQ] = ACTIONS(2753),
    [anon_sym_GT_GT_EQ] = ACTIONS(2753),
    [anon_sym_LT_LT_EQ] = ACTIONS(2753),
    [anon_sym_CARET_EQ] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2755),
    [anon_sym_AMP_AMP] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2755),
    [anon_sym_GT_GT] = ACTIONS(2755),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_SLASH] = ACTIONS(2755),
    [anon_sym_PERCENT] = ACTIONS(2755),
    [sym_comment] = ACTIONS(87),
  },
  [5883] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8298),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5890),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(5890),
    [sym_assignment] = STATE(8298),
    [sym_operator_assignment] = STATE(8298),
    [sym_conditional] = STATE(8298),
    [sym_range] = STATE(8298),
    [sym_binary] = STATE(8298),
    [sym_unary] = STATE(8298),
    [sym_left_assignment_list] = STATE(5889),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5890),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5890),
    [sym_false] = STATE(5890),
    [sym_nil] = STATE(5890),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5790),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9175),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9033),
    [anon_sym_yield] = ACTIONS(9035),
    [anon_sym_break] = ACTIONS(9037),
    [anon_sym_next] = ACTIONS(9039),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9177),
    [anon_sym_defined_QMARK] = ACTIONS(9179),
    [anon_sym_not] = ACTIONS(9181),
    [anon_sym_BANG] = ACTIONS(9183),
    [anon_sym_TILDE] = ACTIONS(9183),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5884] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8299),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5890),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(5890),
    [sym_assignment] = STATE(8299),
    [sym_operator_assignment] = STATE(8299),
    [sym_conditional] = STATE(8299),
    [sym_range] = STATE(8299),
    [sym_binary] = STATE(8299),
    [sym_unary] = STATE(8299),
    [sym_left_assignment_list] = STATE(5889),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5890),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5890),
    [sym_false] = STATE(5890),
    [sym_nil] = STATE(5890),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5790),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9175),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9033),
    [anon_sym_yield] = ACTIONS(9035),
    [anon_sym_break] = ACTIONS(9037),
    [anon_sym_next] = ACTIONS(9039),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9177),
    [anon_sym_defined_QMARK] = ACTIONS(9179),
    [anon_sym_not] = ACTIONS(9181),
    [anon_sym_BANG] = ACTIONS(9183),
    [anon_sym_TILDE] = ACTIONS(9183),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5885] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8300),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5890),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(5890),
    [sym_assignment] = STATE(8300),
    [sym_operator_assignment] = STATE(8300),
    [sym_conditional] = STATE(8300),
    [sym_range] = STATE(8300),
    [sym_binary] = STATE(8300),
    [sym_unary] = STATE(8300),
    [sym_left_assignment_list] = STATE(5889),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5890),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5890),
    [sym_false] = STATE(5890),
    [sym_nil] = STATE(5890),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5790),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9175),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9033),
    [anon_sym_yield] = ACTIONS(9035),
    [anon_sym_break] = ACTIONS(9037),
    [anon_sym_next] = ACTIONS(9039),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9177),
    [anon_sym_defined_QMARK] = ACTIONS(9179),
    [anon_sym_not] = ACTIONS(9181),
    [anon_sym_BANG] = ACTIONS(9183),
    [anon_sym_TILDE] = ACTIONS(9183),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5886] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(298),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5890),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(5890),
    [sym_assignment] = STATE(298),
    [sym_operator_assignment] = STATE(298),
    [sym_conditional] = STATE(298),
    [sym_range] = STATE(298),
    [sym_binary] = STATE(298),
    [sym_unary] = STATE(298),
    [sym_left_assignment_list] = STATE(5889),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5890),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5890),
    [sym_false] = STATE(5890),
    [sym_nil] = STATE(5890),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5790),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9175),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9033),
    [anon_sym_yield] = ACTIONS(9035),
    [anon_sym_break] = ACTIONS(9037),
    [anon_sym_next] = ACTIONS(9039),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9177),
    [anon_sym_defined_QMARK] = ACTIONS(9179),
    [anon_sym_not] = ACTIONS(9181),
    [anon_sym_BANG] = ACTIONS(9183),
    [anon_sym_TILDE] = ACTIONS(9183),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5887] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(11812),
    [sym__binary_star] = ACTIONS(11814),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(11816),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(11814),
    [anon_sym_AMP] = ACTIONS(11818),
    [anon_sym_LT] = ACTIONS(11820),
    [anon_sym_end] = ACTIONS(5115),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(11822),
    [anon_sym_DOT_DOT] = ACTIONS(11824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11826),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(11828),
    [anon_sym_AMP_AMP] = ACTIONS(11828),
    [anon_sym_LT_LT] = ACTIONS(11830),
    [anon_sym_GT_GT] = ACTIONS(11830),
    [anon_sym_EQ_EQ] = ACTIONS(11832),
    [anon_sym_BANG_EQ] = ACTIONS(11828),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11828),
    [anon_sym_LT_EQ_GT] = ACTIONS(11828),
    [anon_sym_EQ_TILDE] = ACTIONS(11828),
    [anon_sym_BANG_TILDE] = ACTIONS(11828),
    [anon_sym_LT_EQ] = ACTIONS(11820),
    [anon_sym_GT] = ACTIONS(11820),
    [anon_sym_GT_EQ] = ACTIONS(11834),
    [anon_sym_CARET] = ACTIONS(11836),
    [anon_sym_PLUS] = ACTIONS(11812),
    [anon_sym_SLASH] = ACTIONS(11814),
    [anon_sym_PERCENT] = ACTIONS(11814),
    [sym_comment] = ACTIONS(87),
  },
  [5888] = {
    [aux_sym_exceptions_repeat1] = STATE(8312),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_COMMA] = ACTIONS(11838),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_end] = ACTIONS(6191),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [5889] = {
    [anon_sym_EQ] = ACTIONS(11840),
    [sym_comment] = ACTIONS(87),
  },
  [5890] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(11842),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(11844),
    [anon_sym_DASH_EQ] = ACTIONS(11844),
    [anon_sym_STAR_EQ] = ACTIONS(11844),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11844),
    [anon_sym_SLASH_EQ] = ACTIONS(11844),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11844),
    [anon_sym_PIPE_EQ] = ACTIONS(11844),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11844),
    [anon_sym_AMP_EQ] = ACTIONS(11844),
    [anon_sym_PERCENT_EQ] = ACTIONS(11844),
    [anon_sym_GT_GT_EQ] = ACTIONS(11844),
    [anon_sym_LT_LT_EQ] = ACTIONS(11844),
    [anon_sym_CARET_EQ] = ACTIONS(11844),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5891] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(5343),
    [sym__binary_star] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(5345),
    [anon_sym_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_end] = ACTIONS(6210),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(5353),
    [anon_sym_DOT_DOT] = ACTIONS(5355),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5357),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(5361),
    [anon_sym_AMP_AMP] = ACTIONS(5361),
    [anon_sym_LT_LT] = ACTIONS(5363),
    [anon_sym_GT_GT] = ACTIONS(5363),
    [anon_sym_EQ_EQ] = ACTIONS(5365),
    [anon_sym_BANG_EQ] = ACTIONS(5361),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5361),
    [anon_sym_LT_EQ_GT] = ACTIONS(5361),
    [anon_sym_EQ_TILDE] = ACTIONS(5361),
    [anon_sym_BANG_TILDE] = ACTIONS(5361),
    [anon_sym_LT_EQ] = ACTIONS(5351),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5367),
    [anon_sym_CARET] = ACTIONS(5369),
    [anon_sym_PLUS] = ACTIONS(5343),
    [anon_sym_SLASH] = ACTIONS(5345),
    [anon_sym_PERCENT] = ACTIONS(5345),
    [sym_comment] = ACTIONS(87),
  },
  [5892] = {
    [sym_string] = STATE(5892),
    [aux_sym_chained_string_repeat1] = STATE(5892),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(6214),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_end] = ACTIONS(6212),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [5893] = {
    [aux_sym_undef_repeat1] = STATE(5893),
    [sym__line_break] = ACTIONS(9263),
    [sym__heredoc_body_start] = ACTIONS(9263),
    [anon_sym_COMMA] = ACTIONS(9265),
    [anon_sym_SEMI] = ACTIONS(9263),
    [anon_sym_end] = ACTIONS(9263),
    [anon_sym_if] = ACTIONS(9263),
    [anon_sym_unless] = ACTIONS(9263),
    [anon_sym_while] = ACTIONS(9263),
    [anon_sym_until] = ACTIONS(9263),
    [anon_sym_rescue] = ACTIONS(9263),
    [anon_sym_else] = ACTIONS(9263),
    [anon_sym_ensure] = ACTIONS(9263),
    [sym_comment] = ACTIONS(87),
  },
  [5894] = {
    [sym__line_break] = ACTIONS(11846),
    [sym__heredoc_body_start] = ACTIONS(11846),
    [sym__binary_minus] = ACTIONS(11846),
    [sym__binary_star] = ACTIONS(11846),
    [ts_builtin_sym_end] = ACTIONS(11846),
    [anon_sym___END__] = ACTIONS(11846),
    [anon_sym_LBRACE] = ACTIONS(11846),
    [anon_sym_RBRACE] = ACTIONS(11846),
    [anon_sym_RPAREN] = ACTIONS(11846),
    [anon_sym_DOT] = ACTIONS(11848),
    [anon_sym_COMMA] = ACTIONS(11846),
    [anon_sym_PIPE] = ACTIONS(11848),
    [anon_sym_SEMI] = ACTIONS(11846),
    [anon_sym_STAR_STAR] = ACTIONS(11846),
    [anon_sym_AMP] = ACTIONS(11848),
    [anon_sym_LT] = ACTIONS(11848),
    [anon_sym_end] = ACTIONS(11846),
    [anon_sym_if] = ACTIONS(11846),
    [anon_sym_unless] = ACTIONS(11846),
    [anon_sym_while] = ACTIONS(11846),
    [anon_sym_until] = ACTIONS(11846),
    [anon_sym_rescue] = ACTIONS(11846),
    [anon_sym_do] = ACTIONS(11846),
    [anon_sym_when] = ACTIONS(11846),
    [anon_sym_elsif] = ACTIONS(11846),
    [anon_sym_else] = ACTIONS(11846),
    [anon_sym_then] = ACTIONS(11846),
    [anon_sym_ensure] = ACTIONS(11846),
    [anon_sym_EQ_GT] = ACTIONS(11846),
    [anon_sym_LBRACK] = ACTIONS(11846),
    [anon_sym_COLON_COLON2] = ACTIONS(11846),
    [anon_sym_AMP_DOT] = ACTIONS(11846),
    [anon_sym_QMARK] = ACTIONS(11846),
    [anon_sym_DOT_DOT] = ACTIONS(11848),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11846),
    [anon_sym_and] = ACTIONS(11846),
    [anon_sym_or] = ACTIONS(11846),
    [anon_sym_PIPE_PIPE] = ACTIONS(11846),
    [anon_sym_AMP_AMP] = ACTIONS(11846),
    [anon_sym_LT_LT] = ACTIONS(11846),
    [anon_sym_GT_GT] = ACTIONS(11846),
    [anon_sym_EQ_EQ] = ACTIONS(11848),
    [anon_sym_BANG_EQ] = ACTIONS(11846),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11846),
    [anon_sym_LT_EQ_GT] = ACTIONS(11846),
    [anon_sym_EQ_TILDE] = ACTIONS(11846),
    [anon_sym_BANG_TILDE] = ACTIONS(11846),
    [anon_sym_LT_EQ] = ACTIONS(11848),
    [anon_sym_GT] = ACTIONS(11848),
    [anon_sym_GT_EQ] = ACTIONS(11846),
    [anon_sym_CARET] = ACTIONS(11846),
    [anon_sym_PLUS] = ACTIONS(11846),
    [anon_sym_SLASH] = ACTIONS(11846),
    [anon_sym_PERCENT] = ACTIONS(11846),
    [sym_comment] = ACTIONS(87),
  },
  [5895] = {
    [anon_sym_end] = ACTIONS(11850),
    [sym_comment] = ACTIONS(87),
  },
  [5896] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8316),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(8316),
    [sym_operator_assignment] = STATE(8316),
    [sym_conditional] = STATE(8316),
    [sym_range] = STATE(8316),
    [sym_binary] = STATE(8316),
    [sym_unary] = STATE(8316),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5897] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(9199),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_ensure] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [5898] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(9193),
    [sym__binary_star] = ACTIONS(9195),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(9197),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(9199),
    [anon_sym_AMP] = ACTIONS(9201),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(9203),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_ensure] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(9205),
    [anon_sym_DOT_DOT] = ACTIONS(9207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9209),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(9211),
    [anon_sym_AMP_AMP] = ACTIONS(9211),
    [anon_sym_LT_LT] = ACTIONS(9213),
    [anon_sym_GT_GT] = ACTIONS(9213),
    [anon_sym_EQ_EQ] = ACTIONS(9211),
    [anon_sym_BANG_EQ] = ACTIONS(9215),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9215),
    [anon_sym_LT_EQ_GT] = ACTIONS(9215),
    [anon_sym_EQ_TILDE] = ACTIONS(9215),
    [anon_sym_BANG_TILDE] = ACTIONS(9215),
    [anon_sym_LT_EQ] = ACTIONS(9203),
    [anon_sym_GT] = ACTIONS(9203),
    [anon_sym_GT_EQ] = ACTIONS(9217),
    [anon_sym_CARET] = ACTIONS(9197),
    [anon_sym_PLUS] = ACTIONS(9219),
    [anon_sym_SLASH] = ACTIONS(9199),
    [anon_sym_PERCENT] = ACTIONS(9199),
    [sym_comment] = ACTIONS(87),
  },
  [5899] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(8317),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(3256),
    [sym_scope_resolution] = STATE(3254),
    [sym_call] = STATE(3254),
    [sym_method_call] = STATE(3256),
    [sym_assignment] = STATE(8317),
    [sym_operator_assignment] = STATE(8317),
    [sym_conditional] = STATE(8317),
    [sym_range] = STATE(8317),
    [sym_binary] = STATE(8317),
    [sym_unary] = STATE(8317),
    [sym_left_assignment_list] = STATE(3255),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3256),
    [sym__variable] = STATE(3254),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(3256),
    [sym_false] = STATE(3256),
    [sym_nil] = STATE(3256),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(3257),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(5413),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(5415),
    [anon_sym_yield] = ACTIONS(5417),
    [anon_sym_break] = ACTIONS(5419),
    [anon_sym_next] = ACTIONS(5421),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(5423),
    [anon_sym_defined_QMARK] = ACTIONS(5425),
    [anon_sym_not] = ACTIONS(5427),
    [anon_sym_BANG] = ACTIONS(5429),
    [anon_sym_TILDE] = ACTIONS(5429),
    [sym_constant] = ACTIONS(5431),
    [sym_identifier] = ACTIONS(5431),
    [sym_instance_variable] = ACTIONS(5433),
    [sym_class_variable] = ACTIONS(5433),
    [sym_global_variable] = ACTIONS(5433),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(5431),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5431),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [5900] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(8318),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(3256),
    [sym_scope_resolution] = STATE(3254),
    [sym_call] = STATE(3254),
    [sym_method_call] = STATE(3256),
    [sym_assignment] = STATE(8318),
    [sym_operator_assignment] = STATE(8318),
    [sym_conditional] = STATE(8318),
    [sym_range] = STATE(8318),
    [sym_binary] = STATE(8318),
    [sym_unary] = STATE(8318),
    [sym_left_assignment_list] = STATE(3255),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3256),
    [sym__variable] = STATE(3254),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(3256),
    [sym_false] = STATE(3256),
    [sym_nil] = STATE(3256),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(3257),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(5413),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(5415),
    [anon_sym_yield] = ACTIONS(5417),
    [anon_sym_break] = ACTIONS(5419),
    [anon_sym_next] = ACTIONS(5421),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(5423),
    [anon_sym_defined_QMARK] = ACTIONS(5425),
    [anon_sym_not] = ACTIONS(5427),
    [anon_sym_BANG] = ACTIONS(5429),
    [anon_sym_TILDE] = ACTIONS(5429),
    [sym_constant] = ACTIONS(5431),
    [sym_identifier] = ACTIONS(5431),
    [sym_instance_variable] = ACTIONS(5433),
    [sym_class_variable] = ACTIONS(5433),
    [sym_global_variable] = ACTIONS(5433),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(5431),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5431),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [5901] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(8319),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(3256),
    [sym_scope_resolution] = STATE(3254),
    [sym_call] = STATE(3254),
    [sym_method_call] = STATE(3256),
    [sym_assignment] = STATE(8319),
    [sym_operator_assignment] = STATE(8319),
    [sym_conditional] = STATE(8319),
    [sym_range] = STATE(8319),
    [sym_binary] = STATE(8319),
    [sym_unary] = STATE(8319),
    [sym_left_assignment_list] = STATE(3255),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3256),
    [sym__variable] = STATE(3254),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(3256),
    [sym_false] = STATE(3256),
    [sym_nil] = STATE(3256),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(3257),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(5413),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(5415),
    [anon_sym_yield] = ACTIONS(5417),
    [anon_sym_break] = ACTIONS(5419),
    [anon_sym_next] = ACTIONS(5421),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(5423),
    [anon_sym_defined_QMARK] = ACTIONS(5425),
    [anon_sym_not] = ACTIONS(5427),
    [anon_sym_BANG] = ACTIONS(5429),
    [anon_sym_TILDE] = ACTIONS(5429),
    [sym_constant] = ACTIONS(5431),
    [sym_identifier] = ACTIONS(5431),
    [sym_instance_variable] = ACTIONS(5433),
    [sym_class_variable] = ACTIONS(5433),
    [sym_global_variable] = ACTIONS(5433),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(5431),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5431),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [5902] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(8320),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(3256),
    [sym_scope_resolution] = STATE(3254),
    [sym_call] = STATE(3254),
    [sym_method_call] = STATE(3256),
    [sym_assignment] = STATE(8320),
    [sym_operator_assignment] = STATE(8320),
    [sym_conditional] = STATE(8320),
    [sym_range] = STATE(8320),
    [sym_binary] = STATE(8320),
    [sym_unary] = STATE(8320),
    [sym_left_assignment_list] = STATE(3255),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3256),
    [sym__variable] = STATE(3254),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(3256),
    [sym_false] = STATE(3256),
    [sym_nil] = STATE(3256),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(3257),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(5413),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(5415),
    [anon_sym_yield] = ACTIONS(5417),
    [anon_sym_break] = ACTIONS(5419),
    [anon_sym_next] = ACTIONS(5421),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(5423),
    [anon_sym_defined_QMARK] = ACTIONS(5425),
    [anon_sym_not] = ACTIONS(5427),
    [anon_sym_BANG] = ACTIONS(5429),
    [anon_sym_TILDE] = ACTIONS(5429),
    [sym_constant] = ACTIONS(5431),
    [sym_identifier] = ACTIONS(5431),
    [sym_instance_variable] = ACTIONS(5433),
    [sym_class_variable] = ACTIONS(5433),
    [sym_global_variable] = ACTIONS(5433),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(5431),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5431),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [5903] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(8321),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(3256),
    [sym_scope_resolution] = STATE(3254),
    [sym_call] = STATE(3254),
    [sym_method_call] = STATE(3256),
    [sym_assignment] = STATE(8321),
    [sym_operator_assignment] = STATE(8321),
    [sym_conditional] = STATE(8321),
    [sym_range] = STATE(8321),
    [sym_binary] = STATE(8321),
    [sym_unary] = STATE(8321),
    [sym_left_assignment_list] = STATE(3255),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3256),
    [sym__variable] = STATE(3254),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(3256),
    [sym_false] = STATE(3256),
    [sym_nil] = STATE(3256),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(3257),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(5413),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(5415),
    [anon_sym_yield] = ACTIONS(5417),
    [anon_sym_break] = ACTIONS(5419),
    [anon_sym_next] = ACTIONS(5421),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(5423),
    [anon_sym_defined_QMARK] = ACTIONS(5425),
    [anon_sym_not] = ACTIONS(5427),
    [anon_sym_BANG] = ACTIONS(5429),
    [anon_sym_TILDE] = ACTIONS(5429),
    [sym_constant] = ACTIONS(5431),
    [sym_identifier] = ACTIONS(5431),
    [sym_instance_variable] = ACTIONS(5433),
    [sym_class_variable] = ACTIONS(5433),
    [sym_global_variable] = ACTIONS(5433),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(5431),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5431),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [5904] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(8322),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(8322),
    [sym_operator_assignment] = STATE(8322),
    [sym_conditional] = STATE(8322),
    [sym_range] = STATE(8322),
    [sym_binary] = STATE(8322),
    [sym_unary] = STATE(8322),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5905] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(8323),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(3256),
    [sym_scope_resolution] = STATE(3254),
    [sym_call] = STATE(3254),
    [sym_method_call] = STATE(3256),
    [sym_assignment] = STATE(8323),
    [sym_operator_assignment] = STATE(8323),
    [sym_conditional] = STATE(8323),
    [sym_range] = STATE(8323),
    [sym_binary] = STATE(8323),
    [sym_unary] = STATE(8323),
    [sym_left_assignment_list] = STATE(3255),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3256),
    [sym__variable] = STATE(3254),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(3256),
    [sym_false] = STATE(3256),
    [sym_nil] = STATE(3256),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(3257),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(5413),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(5415),
    [anon_sym_yield] = ACTIONS(5417),
    [anon_sym_break] = ACTIONS(5419),
    [anon_sym_next] = ACTIONS(5421),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(5423),
    [anon_sym_defined_QMARK] = ACTIONS(5425),
    [anon_sym_not] = ACTIONS(5427),
    [anon_sym_BANG] = ACTIONS(5429),
    [anon_sym_TILDE] = ACTIONS(5429),
    [sym_constant] = ACTIONS(5431),
    [sym_identifier] = ACTIONS(5431),
    [sym_instance_variable] = ACTIONS(5433),
    [sym_class_variable] = ACTIONS(5433),
    [sym_global_variable] = ACTIONS(5433),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(5431),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5431),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [5906] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(8324),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(3256),
    [sym_scope_resolution] = STATE(3254),
    [sym_call] = STATE(3254),
    [sym_method_call] = STATE(3256),
    [sym_assignment] = STATE(8324),
    [sym_operator_assignment] = STATE(8324),
    [sym_conditional] = STATE(8324),
    [sym_range] = STATE(8324),
    [sym_binary] = STATE(8324),
    [sym_unary] = STATE(8324),
    [sym_left_assignment_list] = STATE(3255),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3256),
    [sym__variable] = STATE(3254),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(3256),
    [sym_false] = STATE(3256),
    [sym_nil] = STATE(3256),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(3257),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(5413),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(5415),
    [anon_sym_yield] = ACTIONS(5417),
    [anon_sym_break] = ACTIONS(5419),
    [anon_sym_next] = ACTIONS(5421),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(5423),
    [anon_sym_defined_QMARK] = ACTIONS(5425),
    [anon_sym_not] = ACTIONS(5427),
    [anon_sym_BANG] = ACTIONS(5429),
    [anon_sym_TILDE] = ACTIONS(5429),
    [sym_constant] = ACTIONS(5431),
    [sym_identifier] = ACTIONS(5431),
    [sym_instance_variable] = ACTIONS(5433),
    [sym_class_variable] = ACTIONS(5433),
    [sym_global_variable] = ACTIONS(5433),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(5431),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5431),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [5907] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(8325),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(3256),
    [sym_scope_resolution] = STATE(3254),
    [sym_call] = STATE(3254),
    [sym_method_call] = STATE(3256),
    [sym_assignment] = STATE(8325),
    [sym_operator_assignment] = STATE(8325),
    [sym_conditional] = STATE(8325),
    [sym_range] = STATE(8325),
    [sym_binary] = STATE(8325),
    [sym_unary] = STATE(8325),
    [sym_left_assignment_list] = STATE(3255),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3256),
    [sym__variable] = STATE(3254),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(3256),
    [sym_false] = STATE(3256),
    [sym_nil] = STATE(3256),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(3257),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(5413),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(5415),
    [anon_sym_yield] = ACTIONS(5417),
    [anon_sym_break] = ACTIONS(5419),
    [anon_sym_next] = ACTIONS(5421),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(5423),
    [anon_sym_defined_QMARK] = ACTIONS(5425),
    [anon_sym_not] = ACTIONS(5427),
    [anon_sym_BANG] = ACTIONS(5429),
    [anon_sym_TILDE] = ACTIONS(5429),
    [sym_constant] = ACTIONS(5431),
    [sym_identifier] = ACTIONS(5431),
    [sym_instance_variable] = ACTIONS(5433),
    [sym_class_variable] = ACTIONS(5433),
    [sym_global_variable] = ACTIONS(5433),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(5431),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5431),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [5908] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(8326),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(3256),
    [sym_scope_resolution] = STATE(3254),
    [sym_call] = STATE(3254),
    [sym_method_call] = STATE(3256),
    [sym_assignment] = STATE(8326),
    [sym_operator_assignment] = STATE(8326),
    [sym_conditional] = STATE(8326),
    [sym_range] = STATE(8326),
    [sym_binary] = STATE(8326),
    [sym_unary] = STATE(8326),
    [sym_left_assignment_list] = STATE(3255),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3256),
    [sym__variable] = STATE(3254),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(3256),
    [sym_false] = STATE(3256),
    [sym_nil] = STATE(3256),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(3257),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(5413),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(5415),
    [anon_sym_yield] = ACTIONS(5417),
    [anon_sym_break] = ACTIONS(5419),
    [anon_sym_next] = ACTIONS(5421),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(5423),
    [anon_sym_defined_QMARK] = ACTIONS(5425),
    [anon_sym_not] = ACTIONS(5427),
    [anon_sym_BANG] = ACTIONS(5429),
    [anon_sym_TILDE] = ACTIONS(5429),
    [sym_constant] = ACTIONS(5431),
    [sym_identifier] = ACTIONS(5431),
    [sym_instance_variable] = ACTIONS(5433),
    [sym_class_variable] = ACTIONS(5433),
    [sym_global_variable] = ACTIONS(5433),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(5431),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5431),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [5909] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(8327),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(3256),
    [sym_scope_resolution] = STATE(3254),
    [sym_call] = STATE(3254),
    [sym_method_call] = STATE(3256),
    [sym_splat_argument] = STATE(8328),
    [sym_assignment] = STATE(8327),
    [sym_operator_assignment] = STATE(8327),
    [sym_conditional] = STATE(8327),
    [sym_range] = STATE(8327),
    [sym_binary] = STATE(8327),
    [sym_unary] = STATE(8327),
    [sym_right_assignment_list] = STATE(6323),
    [sym__arg_or_splat_arg] = STATE(8328),
    [sym_left_assignment_list] = STATE(3255),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3256),
    [sym__variable] = STATE(3254),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(3256),
    [sym_false] = STATE(3256),
    [sym_nil] = STATE(3256),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(3257),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__splat_star] = ACTIONS(2215),
    [sym__unary_minus] = ACTIONS(5413),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(5415),
    [anon_sym_yield] = ACTIONS(5417),
    [anon_sym_break] = ACTIONS(5419),
    [anon_sym_next] = ACTIONS(5421),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(5423),
    [anon_sym_defined_QMARK] = ACTIONS(5425),
    [anon_sym_not] = ACTIONS(5427),
    [anon_sym_BANG] = ACTIONS(5429),
    [anon_sym_TILDE] = ACTIONS(5429),
    [sym_constant] = ACTIONS(5431),
    [sym_identifier] = ACTIONS(5431),
    [sym_instance_variable] = ACTIONS(5433),
    [sym_class_variable] = ACTIONS(5433),
    [sym_global_variable] = ACTIONS(5433),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(5431),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5431),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [5910] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(8329),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(3256),
    [sym_scope_resolution] = STATE(3254),
    [sym_call] = STATE(3254),
    [sym_method_call] = STATE(3256),
    [sym_assignment] = STATE(8329),
    [sym_operator_assignment] = STATE(8329),
    [sym_conditional] = STATE(8329),
    [sym_range] = STATE(8329),
    [sym_binary] = STATE(8329),
    [sym_unary] = STATE(8329),
    [sym_left_assignment_list] = STATE(3255),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3256),
    [sym__variable] = STATE(3254),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(3256),
    [sym_false] = STATE(3256),
    [sym_nil] = STATE(3256),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(3257),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(5413),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(5415),
    [anon_sym_yield] = ACTIONS(5417),
    [anon_sym_break] = ACTIONS(5419),
    [anon_sym_next] = ACTIONS(5421),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(5423),
    [anon_sym_defined_QMARK] = ACTIONS(5425),
    [anon_sym_not] = ACTIONS(5427),
    [anon_sym_BANG] = ACTIONS(5429),
    [anon_sym_TILDE] = ACTIONS(5429),
    [sym_constant] = ACTIONS(5431),
    [sym_identifier] = ACTIONS(5431),
    [sym_instance_variable] = ACTIONS(5433),
    [sym_class_variable] = ACTIONS(5433),
    [sym_global_variable] = ACTIONS(5433),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(5431),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5431),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [5911] = {
    [sym_string] = STATE(8330),
    [aux_sym_chained_string_repeat1] = STATE(8330),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(2551),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2755),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_EQ] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_end] = ACTIONS(2753),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_else] = ACTIONS(2753),
    [anon_sym_ensure] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_PLUS_EQ] = ACTIONS(2753),
    [anon_sym_DASH_EQ] = ACTIONS(2753),
    [anon_sym_STAR_EQ] = ACTIONS(2753),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2753),
    [anon_sym_SLASH_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2753),
    [anon_sym_AMP_EQ] = ACTIONS(2753),
    [anon_sym_PERCENT_EQ] = ACTIONS(2753),
    [anon_sym_GT_GT_EQ] = ACTIONS(2753),
    [anon_sym_LT_LT_EQ] = ACTIONS(2753),
    [anon_sym_CARET_EQ] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2755),
    [anon_sym_AMP_AMP] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2755),
    [anon_sym_GT_GT] = ACTIONS(2755),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_SLASH] = ACTIONS(2755),
    [anon_sym_PERCENT] = ACTIONS(2755),
    [sym_comment] = ACTIONS(87),
  },
  [5912] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(9193),
    [sym__binary_star] = ACTIONS(9195),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(9197),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(9199),
    [anon_sym_AMP] = ACTIONS(9201),
    [anon_sym_EQ] = ACTIONS(7822),
    [anon_sym_LT] = ACTIONS(9203),
    [anon_sym_end] = ACTIONS(6823),
    [anon_sym_if] = ACTIONS(6823),
    [anon_sym_unless] = ACTIONS(6823),
    [anon_sym_while] = ACTIONS(6823),
    [anon_sym_until] = ACTIONS(6823),
    [anon_sym_rescue] = ACTIONS(6823),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_else] = ACTIONS(6823),
    [anon_sym_ensure] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_PLUS_EQ] = ACTIONS(6823),
    [anon_sym_DASH_EQ] = ACTIONS(6823),
    [anon_sym_STAR_EQ] = ACTIONS(6823),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6823),
    [anon_sym_SLASH_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6823),
    [anon_sym_AMP_EQ] = ACTIONS(6823),
    [anon_sym_PERCENT_EQ] = ACTIONS(6823),
    [anon_sym_GT_GT_EQ] = ACTIONS(6823),
    [anon_sym_LT_LT_EQ] = ACTIONS(6823),
    [anon_sym_CARET_EQ] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(9205),
    [anon_sym_DOT_DOT] = ACTIONS(9207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9209),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(9211),
    [anon_sym_AMP_AMP] = ACTIONS(9211),
    [anon_sym_LT_LT] = ACTIONS(9213),
    [anon_sym_GT_GT] = ACTIONS(9213),
    [anon_sym_EQ_EQ] = ACTIONS(9211),
    [anon_sym_BANG_EQ] = ACTIONS(9215),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9215),
    [anon_sym_LT_EQ_GT] = ACTIONS(9215),
    [anon_sym_EQ_TILDE] = ACTIONS(9215),
    [anon_sym_BANG_TILDE] = ACTIONS(9215),
    [anon_sym_LT_EQ] = ACTIONS(9203),
    [anon_sym_GT] = ACTIONS(9203),
    [anon_sym_GT_EQ] = ACTIONS(9217),
    [anon_sym_CARET] = ACTIONS(9197),
    [anon_sym_PLUS] = ACTIONS(9219),
    [anon_sym_SLASH] = ACTIONS(9199),
    [anon_sym_PERCENT] = ACTIONS(9199),
    [sym_comment] = ACTIONS(87),
  },
  [5913] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(9193),
    [sym__binary_star] = ACTIONS(9195),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(9197),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(9199),
    [anon_sym_AMP] = ACTIONS(9201),
    [anon_sym_EQ] = ACTIONS(7884),
    [anon_sym_LT] = ACTIONS(9203),
    [anon_sym_end] = ACTIONS(7027),
    [anon_sym_if] = ACTIONS(7027),
    [anon_sym_unless] = ACTIONS(7027),
    [anon_sym_while] = ACTIONS(7027),
    [anon_sym_until] = ACTIONS(7027),
    [anon_sym_rescue] = ACTIONS(7027),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_else] = ACTIONS(7027),
    [anon_sym_ensure] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_PLUS_EQ] = ACTIONS(7027),
    [anon_sym_DASH_EQ] = ACTIONS(7027),
    [anon_sym_STAR_EQ] = ACTIONS(7027),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7027),
    [anon_sym_SLASH_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7027),
    [anon_sym_AMP_EQ] = ACTIONS(7027),
    [anon_sym_PERCENT_EQ] = ACTIONS(7027),
    [anon_sym_GT_GT_EQ] = ACTIONS(7027),
    [anon_sym_LT_LT_EQ] = ACTIONS(7027),
    [anon_sym_CARET_EQ] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(9205),
    [anon_sym_DOT_DOT] = ACTIONS(9207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9209),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(9211),
    [anon_sym_AMP_AMP] = ACTIONS(9211),
    [anon_sym_LT_LT] = ACTIONS(9213),
    [anon_sym_GT_GT] = ACTIONS(9213),
    [anon_sym_EQ_EQ] = ACTIONS(9211),
    [anon_sym_BANG_EQ] = ACTIONS(9215),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9215),
    [anon_sym_LT_EQ_GT] = ACTIONS(9215),
    [anon_sym_EQ_TILDE] = ACTIONS(9215),
    [anon_sym_BANG_TILDE] = ACTIONS(9215),
    [anon_sym_LT_EQ] = ACTIONS(9203),
    [anon_sym_GT] = ACTIONS(9203),
    [anon_sym_GT_EQ] = ACTIONS(9217),
    [anon_sym_CARET] = ACTIONS(9197),
    [anon_sym_PLUS] = ACTIONS(9219),
    [anon_sym_SLASH] = ACTIONS(9199),
    [anon_sym_PERCENT] = ACTIONS(9199),
    [sym_comment] = ACTIONS(87),
  },
  [5914] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5443),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(5447),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(5447),
    [anon_sym_PERCENT] = ACTIONS(5447),
    [sym_comment] = ACTIONS(87),
  },
  [5915] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(5447),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(5827),
    [anon_sym_PERCENT] = ACTIONS(5827),
    [sym_comment] = ACTIONS(87),
  },
  [5916] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5441),
    [sym__binary_star] = ACTIONS(5443),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(5447),
    [anon_sym_AMP] = ACTIONS(5449),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5461),
    [anon_sym_GT_GT] = ACTIONS(5461),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5467),
    [anon_sym_SLASH] = ACTIONS(5447),
    [anon_sym_PERCENT] = ACTIONS(5447),
    [sym_comment] = ACTIONS(87),
  },
  [5917] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5441),
    [sym__binary_star] = ACTIONS(5443),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(5447),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5461),
    [anon_sym_GT_GT] = ACTIONS(5461),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5467),
    [anon_sym_SLASH] = ACTIONS(5447),
    [anon_sym_PERCENT] = ACTIONS(5447),
    [sym_comment] = ACTIONS(87),
  },
  [5918] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5441),
    [sym__binary_star] = ACTIONS(5443),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5445),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(5447),
    [anon_sym_AMP] = ACTIONS(5449),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5461),
    [anon_sym_GT_GT] = ACTIONS(5461),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5445),
    [anon_sym_PLUS] = ACTIONS(5467),
    [anon_sym_SLASH] = ACTIONS(5447),
    [anon_sym_PERCENT] = ACTIONS(5447),
    [sym_comment] = ACTIONS(87),
  },
  [5919] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(11852),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [5920] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(5441),
    [sym__binary_star] = ACTIONS(5443),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(5445),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(5447),
    [anon_sym_AMP] = ACTIONS(5449),
    [anon_sym_EQ] = ACTIONS(7888),
    [anon_sym_LT] = ACTIONS(5451),
    [anon_sym_end] = ACTIONS(5927),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_else] = ACTIONS(5927),
    [anon_sym_ensure] = ACTIONS(5927),
    [anon_sym_EQ_GT] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_PLUS_EQ] = ACTIONS(5927),
    [anon_sym_DASH_EQ] = ACTIONS(5927),
    [anon_sym_STAR_EQ] = ACTIONS(5927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5927),
    [anon_sym_SLASH_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5927),
    [anon_sym_AMP_EQ] = ACTIONS(5927),
    [anon_sym_PERCENT_EQ] = ACTIONS(5927),
    [anon_sym_GT_GT_EQ] = ACTIONS(5927),
    [anon_sym_LT_LT_EQ] = ACTIONS(5927),
    [anon_sym_CARET_EQ] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(5455),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5457),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(5459),
    [anon_sym_AMP_AMP] = ACTIONS(5459),
    [anon_sym_LT_LT] = ACTIONS(5461),
    [anon_sym_GT_GT] = ACTIONS(5461),
    [anon_sym_EQ_EQ] = ACTIONS(5459),
    [anon_sym_BANG_EQ] = ACTIONS(5463),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5463),
    [anon_sym_LT_EQ_GT] = ACTIONS(5463),
    [anon_sym_EQ_TILDE] = ACTIONS(5463),
    [anon_sym_BANG_TILDE] = ACTIONS(5463),
    [anon_sym_LT_EQ] = ACTIONS(5451),
    [anon_sym_GT] = ACTIONS(5451),
    [anon_sym_GT_EQ] = ACTIONS(5465),
    [anon_sym_CARET] = ACTIONS(5445),
    [anon_sym_PLUS] = ACTIONS(5467),
    [anon_sym_SLASH] = ACTIONS(5447),
    [anon_sym_PERCENT] = ACTIONS(5447),
    [sym_comment] = ACTIONS(87),
  },
  [5921] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5441),
    [sym__binary_star] = ACTIONS(5443),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5445),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(5447),
    [anon_sym_AMP] = ACTIONS(5449),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5451),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5453),
    [anon_sym_DOT_DOT] = ACTIONS(5455),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5457),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5459),
    [anon_sym_AMP_AMP] = ACTIONS(5459),
    [anon_sym_LT_LT] = ACTIONS(5461),
    [anon_sym_GT_GT] = ACTIONS(5461),
    [anon_sym_EQ_EQ] = ACTIONS(5459),
    [anon_sym_BANG_EQ] = ACTIONS(5463),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5463),
    [anon_sym_LT_EQ_GT] = ACTIONS(5463),
    [anon_sym_EQ_TILDE] = ACTIONS(5463),
    [anon_sym_BANG_TILDE] = ACTIONS(5463),
    [anon_sym_LT_EQ] = ACTIONS(5451),
    [anon_sym_GT] = ACTIONS(5451),
    [anon_sym_GT_EQ] = ACTIONS(5465),
    [anon_sym_CARET] = ACTIONS(5445),
    [anon_sym_PLUS] = ACTIONS(5467),
    [anon_sym_SLASH] = ACTIONS(5447),
    [anon_sym_PERCENT] = ACTIONS(5447),
    [sym_comment] = ACTIONS(87),
  },
  [5922] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5441),
    [sym__binary_star] = ACTIONS(5443),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5445),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(5447),
    [anon_sym_AMP] = ACTIONS(5449),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5451),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5461),
    [anon_sym_GT_GT] = ACTIONS(5461),
    [anon_sym_EQ_EQ] = ACTIONS(5459),
    [anon_sym_BANG_EQ] = ACTIONS(5463),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5463),
    [anon_sym_LT_EQ_GT] = ACTIONS(5463),
    [anon_sym_EQ_TILDE] = ACTIONS(5463),
    [anon_sym_BANG_TILDE] = ACTIONS(5463),
    [anon_sym_LT_EQ] = ACTIONS(5451),
    [anon_sym_GT] = ACTIONS(5451),
    [anon_sym_GT_EQ] = ACTIONS(5465),
    [anon_sym_CARET] = ACTIONS(5445),
    [anon_sym_PLUS] = ACTIONS(5467),
    [anon_sym_SLASH] = ACTIONS(5447),
    [anon_sym_PERCENT] = ACTIONS(5447),
    [sym_comment] = ACTIONS(87),
  },
  [5923] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5441),
    [sym__binary_star] = ACTIONS(5443),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(5447),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5467),
    [anon_sym_SLASH] = ACTIONS(5447),
    [anon_sym_PERCENT] = ACTIONS(5447),
    [sym_comment] = ACTIONS(87),
  },
  [5924] = {
    [sym_heredoc_body] = STATE(5924),
    [aux_sym_call_repeat1] = STATE(5924),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(9846),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7919),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_EQ] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_end] = ACTIONS(7914),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_else] = ACTIONS(7914),
    [anon_sym_ensure] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_PLUS_EQ] = ACTIONS(7914),
    [anon_sym_DASH_EQ] = ACTIONS(7914),
    [anon_sym_STAR_EQ] = ACTIONS(7914),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7914),
    [anon_sym_SLASH_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7914),
    [anon_sym_AMP_EQ] = ACTIONS(7914),
    [anon_sym_PERCENT_EQ] = ACTIONS(7914),
    [anon_sym_GT_GT_EQ] = ACTIONS(7914),
    [anon_sym_LT_LT_EQ] = ACTIONS(7914),
    [anon_sym_CARET_EQ] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7919),
    [anon_sym_AMP_AMP] = ACTIONS(7919),
    [anon_sym_LT_LT] = ACTIONS(7919),
    [anon_sym_GT_GT] = ACTIONS(7919),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7919),
    [anon_sym_PLUS] = ACTIONS(7919),
    [anon_sym_SLASH] = ACTIONS(7919),
    [anon_sym_PERCENT] = ACTIONS(7919),
    [sym_comment] = ACTIONS(87),
  },
  [5925] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(1244),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1249),
    [sym_scope_resolution] = STATE(1245),
    [sym_call] = STATE(1245),
    [sym_method_call] = STATE(1249),
    [sym__argument] = STATE(6393),
    [sym_splat_argument] = STATE(6393),
    [sym_hash_splat_argument] = STATE(6393),
    [sym_block_argument] = STATE(6393),
    [sym_assignment] = STATE(1244),
    [sym_operator_assignment] = STATE(1244),
    [sym_conditional] = STATE(1244),
    [sym_range] = STATE(1244),
    [sym_binary] = STATE(1244),
    [sym_unary] = STATE(1244),
    [sym_left_assignment_list] = STATE(1248),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(1245),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1249),
    [sym_false] = STATE(1249),
    [sym_nil] = STATE(1249),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(1250),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(6393),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(2213),
    [sym__splat_star] = ACTIONS(2215),
    [sym__unary_minus] = ACTIONS(2217),
    [sym__identifier_hash_key] = ACTIONS(2219),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(9227),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2223),
    [anon_sym_break] = ACTIONS(2225),
    [anon_sym_next] = ACTIONS(2227),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(5435),
    [anon_sym_defined_QMARK] = ACTIONS(2229),
    [anon_sym_not] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(2235),
    [anon_sym_TILDE] = ACTIONS(2235),
    [sym_constant] = ACTIONS(2237),
    [sym_identifier] = ACTIONS(2237),
    [sym_instance_variable] = ACTIONS(2239),
    [sym_class_variable] = ACTIONS(2239),
    [sym_global_variable] = ACTIONS(2239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(2241),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2241),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [5926] = {
    [sym_heredoc_body] = STATE(5924),
    [aux_sym_call_repeat1] = STATE(5924),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7931),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_EQ] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_end] = ACTIONS(7929),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_else] = ACTIONS(7929),
    [anon_sym_ensure] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_PLUS_EQ] = ACTIONS(7929),
    [anon_sym_DASH_EQ] = ACTIONS(7929),
    [anon_sym_STAR_EQ] = ACTIONS(7929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7929),
    [anon_sym_SLASH_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7929),
    [anon_sym_AMP_EQ] = ACTIONS(7929),
    [anon_sym_PERCENT_EQ] = ACTIONS(7929),
    [anon_sym_GT_GT_EQ] = ACTIONS(7929),
    [anon_sym_LT_LT_EQ] = ACTIONS(7929),
    [anon_sym_CARET_EQ] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7931),
    [anon_sym_AMP_AMP] = ACTIONS(7931),
    [anon_sym_LT_LT] = ACTIONS(7931),
    [anon_sym_GT_GT] = ACTIONS(7931),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7931),
    [anon_sym_PLUS] = ACTIONS(7931),
    [anon_sym_SLASH] = ACTIONS(7931),
    [anon_sym_PERCENT] = ACTIONS(7931),
    [sym_comment] = ACTIONS(87),
  },
  [5927] = {
    [aux_sym_argument_list_repeat1] = STATE(5927),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(11854),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7927),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_EQ] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_end] = ACTIONS(7925),
    [anon_sym_if] = ACTIONS(7925),
    [anon_sym_unless] = ACTIONS(7925),
    [anon_sym_while] = ACTIONS(7925),
    [anon_sym_until] = ACTIONS(7925),
    [anon_sym_rescue] = ACTIONS(7925),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_else] = ACTIONS(7925),
    [anon_sym_ensure] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_PLUS_EQ] = ACTIONS(7925),
    [anon_sym_DASH_EQ] = ACTIONS(7925),
    [anon_sym_STAR_EQ] = ACTIONS(7925),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7925),
    [anon_sym_SLASH_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7925),
    [anon_sym_AMP_EQ] = ACTIONS(7925),
    [anon_sym_PERCENT_EQ] = ACTIONS(7925),
    [anon_sym_GT_GT_EQ] = ACTIONS(7925),
    [anon_sym_LT_LT_EQ] = ACTIONS(7925),
    [anon_sym_CARET_EQ] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7927),
    [anon_sym_AMP_AMP] = ACTIONS(7927),
    [anon_sym_LT_LT] = ACTIONS(7927),
    [anon_sym_GT_GT] = ACTIONS(7927),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7927),
    [anon_sym_PLUS] = ACTIONS(7927),
    [anon_sym_SLASH] = ACTIONS(7927),
    [anon_sym_PERCENT] = ACTIONS(7927),
    [sym_comment] = ACTIONS(87),
  },
  [5928] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(5441),
    [sym__binary_star] = ACTIONS(5443),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(5445),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(5447),
    [anon_sym_AMP] = ACTIONS(5449),
    [anon_sym_EQ] = ACTIONS(7936),
    [anon_sym_LT] = ACTIONS(5451),
    [anon_sym_end] = ACTIONS(5115),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_else] = ACTIONS(5115),
    [anon_sym_ensure] = ACTIONS(5115),
    [anon_sym_EQ_GT] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_PLUS_EQ] = ACTIONS(5115),
    [anon_sym_DASH_EQ] = ACTIONS(5115),
    [anon_sym_STAR_EQ] = ACTIONS(5115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5115),
    [anon_sym_SLASH_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5115),
    [anon_sym_AMP_EQ] = ACTIONS(5115),
    [anon_sym_PERCENT_EQ] = ACTIONS(5115),
    [anon_sym_GT_GT_EQ] = ACTIONS(5115),
    [anon_sym_LT_LT_EQ] = ACTIONS(5115),
    [anon_sym_CARET_EQ] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(5453),
    [anon_sym_DOT_DOT] = ACTIONS(5455),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5457),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(5459),
    [anon_sym_AMP_AMP] = ACTIONS(5459),
    [anon_sym_LT_LT] = ACTIONS(5461),
    [anon_sym_GT_GT] = ACTIONS(5461),
    [anon_sym_EQ_EQ] = ACTIONS(5459),
    [anon_sym_BANG_EQ] = ACTIONS(5463),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5463),
    [anon_sym_LT_EQ_GT] = ACTIONS(5463),
    [anon_sym_EQ_TILDE] = ACTIONS(5463),
    [anon_sym_BANG_TILDE] = ACTIONS(5463),
    [anon_sym_LT_EQ] = ACTIONS(5451),
    [anon_sym_GT] = ACTIONS(5451),
    [anon_sym_GT_EQ] = ACTIONS(5465),
    [anon_sym_CARET] = ACTIONS(5445),
    [anon_sym_PLUS] = ACTIONS(5467),
    [anon_sym_SLASH] = ACTIONS(5447),
    [anon_sym_PERCENT] = ACTIONS(5447),
    [sym_comment] = ACTIONS(87),
  },
  [5929] = {
    [aux_sym_exceptions_repeat1] = STATE(8333),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6193),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_end] = ACTIONS(6191),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_else] = ACTIONS(6191),
    [anon_sym_ensure] = ACTIONS(6191),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_PLUS_EQ] = ACTIONS(6191),
    [anon_sym_DASH_EQ] = ACTIONS(6191),
    [anon_sym_STAR_EQ] = ACTIONS(6191),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6191),
    [anon_sym_SLASH_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6191),
    [anon_sym_AMP_EQ] = ACTIONS(6191),
    [anon_sym_PERCENT_EQ] = ACTIONS(6191),
    [anon_sym_GT_GT_EQ] = ACTIONS(6191),
    [anon_sym_LT_LT_EQ] = ACTIONS(6191),
    [anon_sym_CARET_EQ] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6193),
    [anon_sym_AMP_AMP] = ACTIONS(6193),
    [anon_sym_LT_LT] = ACTIONS(6193),
    [anon_sym_GT_GT] = ACTIONS(6193),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6193),
    [anon_sym_PLUS] = ACTIONS(6193),
    [anon_sym_SLASH] = ACTIONS(6193),
    [anon_sym_PERCENT] = ACTIONS(6193),
    [sym_comment] = ACTIONS(87),
  },
  [5930] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(5441),
    [sym__binary_star] = ACTIONS(5443),
    [anon_sym_LBRACE] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(5445),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(5447),
    [anon_sym_AMP] = ACTIONS(5449),
    [anon_sym_EQ] = ACTIONS(7938),
    [anon_sym_LT] = ACTIONS(5451),
    [anon_sym_end] = ACTIONS(6210),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_else] = ACTIONS(6210),
    [anon_sym_ensure] = ACTIONS(6210),
    [anon_sym_EQ_GT] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_PLUS_EQ] = ACTIONS(6210),
    [anon_sym_DASH_EQ] = ACTIONS(6210),
    [anon_sym_STAR_EQ] = ACTIONS(6210),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6210),
    [anon_sym_SLASH_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6210),
    [anon_sym_AMP_EQ] = ACTIONS(6210),
    [anon_sym_PERCENT_EQ] = ACTIONS(6210),
    [anon_sym_GT_GT_EQ] = ACTIONS(6210),
    [anon_sym_LT_LT_EQ] = ACTIONS(6210),
    [anon_sym_CARET_EQ] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(5453),
    [anon_sym_DOT_DOT] = ACTIONS(5455),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5457),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(5459),
    [anon_sym_AMP_AMP] = ACTIONS(5459),
    [anon_sym_LT_LT] = ACTIONS(5461),
    [anon_sym_GT_GT] = ACTIONS(5461),
    [anon_sym_EQ_EQ] = ACTIONS(5459),
    [anon_sym_BANG_EQ] = ACTIONS(5463),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5463),
    [anon_sym_LT_EQ_GT] = ACTIONS(5463),
    [anon_sym_EQ_TILDE] = ACTIONS(5463),
    [anon_sym_BANG_TILDE] = ACTIONS(5463),
    [anon_sym_LT_EQ] = ACTIONS(5451),
    [anon_sym_GT] = ACTIONS(5451),
    [anon_sym_GT_EQ] = ACTIONS(5465),
    [anon_sym_CARET] = ACTIONS(5445),
    [anon_sym_PLUS] = ACTIONS(5467),
    [anon_sym_SLASH] = ACTIONS(5447),
    [anon_sym_PERCENT] = ACTIONS(5447),
    [sym_comment] = ACTIONS(87),
  },
  [5931] = {
    [sym_string] = STATE(5931),
    [aux_sym_chained_string_repeat1] = STATE(5931),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(9852),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6217),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_EQ] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_end] = ACTIONS(6212),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_do] = ACTIONS(6212),
    [anon_sym_else] = ACTIONS(6212),
    [anon_sym_ensure] = ACTIONS(6212),
    [anon_sym_EQ_GT] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_PLUS_EQ] = ACTIONS(6212),
    [anon_sym_DASH_EQ] = ACTIONS(6212),
    [anon_sym_STAR_EQ] = ACTIONS(6212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6212),
    [anon_sym_SLASH_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6212),
    [anon_sym_AMP_EQ] = ACTIONS(6212),
    [anon_sym_PERCENT_EQ] = ACTIONS(6212),
    [anon_sym_GT_GT_EQ] = ACTIONS(6212),
    [anon_sym_LT_LT_EQ] = ACTIONS(6212),
    [anon_sym_CARET_EQ] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6217),
    [anon_sym_AMP_AMP] = ACTIONS(6217),
    [anon_sym_LT_LT] = ACTIONS(6217),
    [anon_sym_GT_GT] = ACTIONS(6217),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6217),
    [anon_sym_PLUS] = ACTIONS(6217),
    [anon_sym_SLASH] = ACTIONS(6217),
    [anon_sym_PERCENT] = ACTIONS(6217),
    [sym_comment] = ACTIONS(87),
  },
  [5932] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(9229),
    [sym__binary_star] = ACTIONS(9231),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(9233),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(9231),
    [anon_sym_AMP] = ACTIONS(9235),
    [anon_sym_LT] = ACTIONS(9237),
    [anon_sym_end] = ACTIONS(4247),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_else] = ACTIONS(4247),
    [anon_sym_ensure] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(9239),
    [anon_sym_DOT_DOT] = ACTIONS(9241),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9243),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(9245),
    [anon_sym_AMP_AMP] = ACTIONS(9245),
    [anon_sym_LT_LT] = ACTIONS(9247),
    [anon_sym_GT_GT] = ACTIONS(9247),
    [anon_sym_EQ_EQ] = ACTIONS(9249),
    [anon_sym_BANG_EQ] = ACTIONS(9245),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9245),
    [anon_sym_LT_EQ_GT] = ACTIONS(9245),
    [anon_sym_EQ_TILDE] = ACTIONS(9245),
    [anon_sym_BANG_TILDE] = ACTIONS(9245),
    [anon_sym_LT_EQ] = ACTIONS(9237),
    [anon_sym_GT] = ACTIONS(9237),
    [anon_sym_GT_EQ] = ACTIONS(9251),
    [anon_sym_CARET] = ACTIONS(9253),
    [anon_sym_PLUS] = ACTIONS(9229),
    [anon_sym_SLASH] = ACTIONS(9231),
    [anon_sym_PERCENT] = ACTIONS(9231),
    [sym_comment] = ACTIONS(87),
  },
  [5933] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(9231),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_ensure] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [5934] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(9229),
    [sym__binary_star] = ACTIONS(9231),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(9233),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(9231),
    [anon_sym_AMP] = ACTIONS(9235),
    [anon_sym_LT] = ACTIONS(9237),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_ensure] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(9239),
    [anon_sym_DOT_DOT] = ACTIONS(9241),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9243),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(9245),
    [anon_sym_AMP_AMP] = ACTIONS(9245),
    [anon_sym_LT_LT] = ACTIONS(9247),
    [anon_sym_GT_GT] = ACTIONS(9247),
    [anon_sym_EQ_EQ] = ACTIONS(9249),
    [anon_sym_BANG_EQ] = ACTIONS(9245),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9245),
    [anon_sym_LT_EQ_GT] = ACTIONS(9245),
    [anon_sym_EQ_TILDE] = ACTIONS(9245),
    [anon_sym_BANG_TILDE] = ACTIONS(9245),
    [anon_sym_LT_EQ] = ACTIONS(9237),
    [anon_sym_GT] = ACTIONS(9237),
    [anon_sym_GT_EQ] = ACTIONS(9251),
    [anon_sym_CARET] = ACTIONS(9253),
    [anon_sym_PLUS] = ACTIONS(9229),
    [anon_sym_SLASH] = ACTIONS(9231),
    [anon_sym_PERCENT] = ACTIONS(9231),
    [sym_comment] = ACTIONS(87),
  },
  [5935] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8334),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(3288),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(3288),
    [sym_assignment] = STATE(8334),
    [sym_operator_assignment] = STATE(8334),
    [sym_conditional] = STATE(8334),
    [sym_range] = STATE(8334),
    [sym_binary] = STATE(8334),
    [sym_unary] = STATE(8334),
    [sym_left_assignment_list] = STATE(3287),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3288),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(3288),
    [sym_false] = STATE(3288),
    [sym_nil] = STATE(3288),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(3000),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(5481),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5003),
    [anon_sym_yield] = ACTIONS(5005),
    [anon_sym_break] = ACTIONS(5007),
    [anon_sym_next] = ACTIONS(5009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5483),
    [anon_sym_defined_QMARK] = ACTIONS(5485),
    [anon_sym_not] = ACTIONS(5487),
    [anon_sym_BANG] = ACTIONS(5489),
    [anon_sym_TILDE] = ACTIONS(5489),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5936] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8335),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(3288),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(3288),
    [sym_assignment] = STATE(8335),
    [sym_operator_assignment] = STATE(8335),
    [sym_conditional] = STATE(8335),
    [sym_range] = STATE(8335),
    [sym_binary] = STATE(8335),
    [sym_unary] = STATE(8335),
    [sym_left_assignment_list] = STATE(3287),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3288),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(3288),
    [sym_false] = STATE(3288),
    [sym_nil] = STATE(3288),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(3000),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(5481),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5003),
    [anon_sym_yield] = ACTIONS(5005),
    [anon_sym_break] = ACTIONS(5007),
    [anon_sym_next] = ACTIONS(5009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5483),
    [anon_sym_defined_QMARK] = ACTIONS(5485),
    [anon_sym_not] = ACTIONS(5487),
    [anon_sym_BANG] = ACTIONS(5489),
    [anon_sym_TILDE] = ACTIONS(5489),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5937] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8336),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(3288),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(3288),
    [sym_assignment] = STATE(8336),
    [sym_operator_assignment] = STATE(8336),
    [sym_conditional] = STATE(8336),
    [sym_range] = STATE(8336),
    [sym_binary] = STATE(8336),
    [sym_unary] = STATE(8336),
    [sym_left_assignment_list] = STATE(3287),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3288),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(3288),
    [sym_false] = STATE(3288),
    [sym_nil] = STATE(3288),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(3000),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(5481),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5003),
    [anon_sym_yield] = ACTIONS(5005),
    [anon_sym_break] = ACTIONS(5007),
    [anon_sym_next] = ACTIONS(5009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5483),
    [anon_sym_defined_QMARK] = ACTIONS(5485),
    [anon_sym_not] = ACTIONS(5487),
    [anon_sym_BANG] = ACTIONS(5489),
    [anon_sym_TILDE] = ACTIONS(5489),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5938] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8337),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(3288),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(3288),
    [sym_assignment] = STATE(8337),
    [sym_operator_assignment] = STATE(8337),
    [sym_conditional] = STATE(8337),
    [sym_range] = STATE(8337),
    [sym_binary] = STATE(8337),
    [sym_unary] = STATE(8337),
    [sym_left_assignment_list] = STATE(3287),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3288),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(3288),
    [sym_false] = STATE(3288),
    [sym_nil] = STATE(3288),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(3000),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(5481),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5003),
    [anon_sym_yield] = ACTIONS(5005),
    [anon_sym_break] = ACTIONS(5007),
    [anon_sym_next] = ACTIONS(5009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5483),
    [anon_sym_defined_QMARK] = ACTIONS(5485),
    [anon_sym_not] = ACTIONS(5487),
    [anon_sym_BANG] = ACTIONS(5489),
    [anon_sym_TILDE] = ACTIONS(5489),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5939] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8338),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(3288),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(3288),
    [sym_assignment] = STATE(8338),
    [sym_operator_assignment] = STATE(8338),
    [sym_conditional] = STATE(8338),
    [sym_range] = STATE(8338),
    [sym_binary] = STATE(8338),
    [sym_unary] = STATE(8338),
    [sym_left_assignment_list] = STATE(3287),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3288),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(3288),
    [sym_false] = STATE(3288),
    [sym_nil] = STATE(3288),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(3000),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(5481),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5003),
    [anon_sym_yield] = ACTIONS(5005),
    [anon_sym_break] = ACTIONS(5007),
    [anon_sym_next] = ACTIONS(5009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5483),
    [anon_sym_defined_QMARK] = ACTIONS(5485),
    [anon_sym_not] = ACTIONS(5487),
    [anon_sym_BANG] = ACTIONS(5489),
    [anon_sym_TILDE] = ACTIONS(5489),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5940] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(8339),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(8339),
    [sym_operator_assignment] = STATE(8339),
    [sym_conditional] = STATE(8339),
    [sym_range] = STATE(8339),
    [sym_binary] = STATE(8339),
    [sym_unary] = STATE(8339),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5941] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8340),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(3288),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(3288),
    [sym_assignment] = STATE(8340),
    [sym_operator_assignment] = STATE(8340),
    [sym_conditional] = STATE(8340),
    [sym_range] = STATE(8340),
    [sym_binary] = STATE(8340),
    [sym_unary] = STATE(8340),
    [sym_left_assignment_list] = STATE(3287),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3288),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(3288),
    [sym_false] = STATE(3288),
    [sym_nil] = STATE(3288),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(3000),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(5481),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5003),
    [anon_sym_yield] = ACTIONS(5005),
    [anon_sym_break] = ACTIONS(5007),
    [anon_sym_next] = ACTIONS(5009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5483),
    [anon_sym_defined_QMARK] = ACTIONS(5485),
    [anon_sym_not] = ACTIONS(5487),
    [anon_sym_BANG] = ACTIONS(5489),
    [anon_sym_TILDE] = ACTIONS(5489),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5942] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8341),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(3288),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(3288),
    [sym_assignment] = STATE(8341),
    [sym_operator_assignment] = STATE(8341),
    [sym_conditional] = STATE(8341),
    [sym_range] = STATE(8341),
    [sym_binary] = STATE(8341),
    [sym_unary] = STATE(8341),
    [sym_left_assignment_list] = STATE(3287),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3288),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(3288),
    [sym_false] = STATE(3288),
    [sym_nil] = STATE(3288),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(3000),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(5481),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5003),
    [anon_sym_yield] = ACTIONS(5005),
    [anon_sym_break] = ACTIONS(5007),
    [anon_sym_next] = ACTIONS(5009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5483),
    [anon_sym_defined_QMARK] = ACTIONS(5485),
    [anon_sym_not] = ACTIONS(5487),
    [anon_sym_BANG] = ACTIONS(5489),
    [anon_sym_TILDE] = ACTIONS(5489),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5943] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8342),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(3288),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(3288),
    [sym_assignment] = STATE(8342),
    [sym_operator_assignment] = STATE(8342),
    [sym_conditional] = STATE(8342),
    [sym_range] = STATE(8342),
    [sym_binary] = STATE(8342),
    [sym_unary] = STATE(8342),
    [sym_left_assignment_list] = STATE(3287),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3288),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(3288),
    [sym_false] = STATE(3288),
    [sym_nil] = STATE(3288),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(3000),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(5481),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5003),
    [anon_sym_yield] = ACTIONS(5005),
    [anon_sym_break] = ACTIONS(5007),
    [anon_sym_next] = ACTIONS(5009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5483),
    [anon_sym_defined_QMARK] = ACTIONS(5485),
    [anon_sym_not] = ACTIONS(5487),
    [anon_sym_BANG] = ACTIONS(5489),
    [anon_sym_TILDE] = ACTIONS(5489),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5944] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8343),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(3288),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(3288),
    [sym_assignment] = STATE(8343),
    [sym_operator_assignment] = STATE(8343),
    [sym_conditional] = STATE(8343),
    [sym_range] = STATE(8343),
    [sym_binary] = STATE(8343),
    [sym_unary] = STATE(8343),
    [sym_left_assignment_list] = STATE(3287),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3288),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(3288),
    [sym_false] = STATE(3288),
    [sym_nil] = STATE(3288),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(3000),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(5481),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5003),
    [anon_sym_yield] = ACTIONS(5005),
    [anon_sym_break] = ACTIONS(5007),
    [anon_sym_next] = ACTIONS(5009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5483),
    [anon_sym_defined_QMARK] = ACTIONS(5485),
    [anon_sym_not] = ACTIONS(5487),
    [anon_sym_BANG] = ACTIONS(5489),
    [anon_sym_TILDE] = ACTIONS(5489),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5945] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(3285),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(3288),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(3288),
    [sym_splat_argument] = STATE(6406),
    [sym_assignment] = STATE(3285),
    [sym_operator_assignment] = STATE(3285),
    [sym_conditional] = STATE(3285),
    [sym_range] = STATE(3285),
    [sym_binary] = STATE(3285),
    [sym_unary] = STATE(3285),
    [sym__arg_or_splat_arg] = STATE(6406),
    [sym_left_assignment_list] = STATE(3287),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3288),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(3288),
    [sym_false] = STATE(3288),
    [sym_nil] = STATE(3288),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(3000),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(5479),
    [sym__unary_minus] = ACTIONS(5481),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5003),
    [anon_sym_yield] = ACTIONS(5005),
    [anon_sym_break] = ACTIONS(5007),
    [anon_sym_next] = ACTIONS(5009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5483),
    [anon_sym_defined_QMARK] = ACTIONS(5485),
    [anon_sym_not] = ACTIONS(5487),
    [anon_sym_BANG] = ACTIONS(5489),
    [anon_sym_TILDE] = ACTIONS(5489),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5946] = {
    [aux_sym_exceptions_repeat1] = STATE(8344),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_COMMA] = ACTIONS(9255),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_end] = ACTIONS(9855),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_else] = ACTIONS(9855),
    [anon_sym_ensure] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [5947] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(3285),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(3288),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(3288),
    [sym_splat_argument] = STATE(8345),
    [sym_assignment] = STATE(3285),
    [sym_operator_assignment] = STATE(3285),
    [sym_conditional] = STATE(3285),
    [sym_range] = STATE(3285),
    [sym_binary] = STATE(3285),
    [sym_unary] = STATE(3285),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(8345),
    [sym_left_assignment_list] = STATE(3287),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3288),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(3288),
    [sym_false] = STATE(3288),
    [sym_nil] = STATE(3288),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(3000),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(5479),
    [sym__unary_minus] = ACTIONS(5481),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5003),
    [anon_sym_yield] = ACTIONS(5005),
    [anon_sym_break] = ACTIONS(5007),
    [anon_sym_next] = ACTIONS(5009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5483),
    [anon_sym_defined_QMARK] = ACTIONS(5485),
    [anon_sym_not] = ACTIONS(5487),
    [anon_sym_BANG] = ACTIONS(5489),
    [anon_sym_TILDE] = ACTIONS(5489),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5948] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8346),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(3288),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(3288),
    [sym_assignment] = STATE(8346),
    [sym_operator_assignment] = STATE(8346),
    [sym_conditional] = STATE(8346),
    [sym_range] = STATE(8346),
    [sym_binary] = STATE(8346),
    [sym_unary] = STATE(8346),
    [sym_left_assignment_list] = STATE(3287),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3288),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(3288),
    [sym_false] = STATE(3288),
    [sym_nil] = STATE(3288),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(3000),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(5481),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5003),
    [anon_sym_yield] = ACTIONS(5005),
    [anon_sym_break] = ACTIONS(5007),
    [anon_sym_next] = ACTIONS(5009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5483),
    [anon_sym_defined_QMARK] = ACTIONS(5485),
    [anon_sym_not] = ACTIONS(5487),
    [anon_sym_BANG] = ACTIONS(5489),
    [anon_sym_TILDE] = ACTIONS(5489),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5949] = {
    [sym__heredoc_body_start] = ACTIONS(6601),
    [sym__binary_minus] = ACTIONS(6601),
    [sym__binary_star] = ACTIONS(6601),
    [anon_sym_LBRACE] = ACTIONS(6601),
    [anon_sym_RBRACE] = ACTIONS(6601),
    [anon_sym_RPAREN] = ACTIONS(6601),
    [anon_sym_DOT] = ACTIONS(6603),
    [anon_sym_COMMA] = ACTIONS(6601),
    [anon_sym_PIPE] = ACTIONS(6603),
    [anon_sym_SEMI] = ACTIONS(6601),
    [anon_sym_STAR_STAR] = ACTIONS(6601),
    [anon_sym_AMP] = ACTIONS(6603),
    [anon_sym_EQ] = ACTIONS(6603),
    [anon_sym_LT] = ACTIONS(6603),
    [anon_sym_if] = ACTIONS(6601),
    [anon_sym_unless] = ACTIONS(6601),
    [anon_sym_while] = ACTIONS(6601),
    [anon_sym_until] = ACTIONS(6601),
    [anon_sym_rescue] = ACTIONS(6601),
    [anon_sym_in] = ACTIONS(6601),
    [anon_sym_do] = ACTIONS(6601),
    [anon_sym_EQ_GT] = ACTIONS(6601),
    [anon_sym_LBRACK] = ACTIONS(6601),
    [anon_sym_RBRACK] = ACTIONS(6601),
    [anon_sym_COLON_COLON2] = ACTIONS(6601),
    [anon_sym_AMP_DOT] = ACTIONS(6601),
    [anon_sym_QMARK] = ACTIONS(6601),
    [anon_sym_COLON2] = ACTIONS(6603),
    [anon_sym_DOT_DOT] = ACTIONS(6603),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6601),
    [anon_sym_and] = ACTIONS(6601),
    [anon_sym_or] = ACTIONS(6601),
    [anon_sym_PIPE_PIPE] = ACTIONS(6601),
    [anon_sym_AMP_AMP] = ACTIONS(6601),
    [anon_sym_LT_LT] = ACTIONS(6601),
    [anon_sym_GT_GT] = ACTIONS(6601),
    [anon_sym_EQ_EQ] = ACTIONS(6603),
    [anon_sym_BANG_EQ] = ACTIONS(6601),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6601),
    [anon_sym_LT_EQ_GT] = ACTIONS(6601),
    [anon_sym_EQ_TILDE] = ACTIONS(6601),
    [anon_sym_BANG_TILDE] = ACTIONS(6601),
    [anon_sym_LT_EQ] = ACTIONS(6603),
    [anon_sym_GT] = ACTIONS(6603),
    [anon_sym_GT_EQ] = ACTIONS(6601),
    [anon_sym_CARET] = ACTIONS(6601),
    [anon_sym_PLUS] = ACTIONS(6601),
    [anon_sym_SLASH] = ACTIONS(6601),
    [anon_sym_PERCENT] = ACTIONS(6601),
    [sym_comment] = ACTIONS(87),
  },
  [5950] = {
    [sym__heredoc_body_start] = ACTIONS(6605),
    [sym__binary_minus] = ACTIONS(6605),
    [sym__binary_star] = ACTIONS(6605),
    [anon_sym_LBRACE] = ACTIONS(6605),
    [anon_sym_RBRACE] = ACTIONS(6605),
    [anon_sym_RPAREN] = ACTIONS(6605),
    [anon_sym_DOT] = ACTIONS(6607),
    [anon_sym_COMMA] = ACTIONS(6605),
    [anon_sym_PIPE] = ACTIONS(6607),
    [anon_sym_SEMI] = ACTIONS(6605),
    [anon_sym_STAR_STAR] = ACTIONS(6605),
    [anon_sym_AMP] = ACTIONS(6607),
    [anon_sym_EQ] = ACTIONS(6607),
    [anon_sym_LT] = ACTIONS(6607),
    [anon_sym_if] = ACTIONS(6605),
    [anon_sym_unless] = ACTIONS(6605),
    [anon_sym_while] = ACTIONS(6605),
    [anon_sym_until] = ACTIONS(6605),
    [anon_sym_rescue] = ACTIONS(6605),
    [anon_sym_in] = ACTIONS(6605),
    [anon_sym_do] = ACTIONS(6605),
    [anon_sym_EQ_GT] = ACTIONS(6605),
    [anon_sym_LBRACK] = ACTIONS(6605),
    [anon_sym_RBRACK] = ACTIONS(6605),
    [anon_sym_COLON_COLON2] = ACTIONS(6605),
    [anon_sym_AMP_DOT] = ACTIONS(6605),
    [anon_sym_QMARK] = ACTIONS(6605),
    [anon_sym_COLON2] = ACTIONS(6607),
    [anon_sym_DOT_DOT] = ACTIONS(6607),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6605),
    [anon_sym_and] = ACTIONS(6605),
    [anon_sym_or] = ACTIONS(6605),
    [anon_sym_PIPE_PIPE] = ACTIONS(6605),
    [anon_sym_AMP_AMP] = ACTIONS(6605),
    [anon_sym_LT_LT] = ACTIONS(6605),
    [anon_sym_GT_GT] = ACTIONS(6605),
    [anon_sym_EQ_EQ] = ACTIONS(6607),
    [anon_sym_BANG_EQ] = ACTIONS(6605),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6605),
    [anon_sym_LT_EQ_GT] = ACTIONS(6605),
    [anon_sym_EQ_TILDE] = ACTIONS(6605),
    [anon_sym_BANG_TILDE] = ACTIONS(6605),
    [anon_sym_LT_EQ] = ACTIONS(6607),
    [anon_sym_GT] = ACTIONS(6607),
    [anon_sym_GT_EQ] = ACTIONS(6605),
    [anon_sym_CARET] = ACTIONS(6605),
    [anon_sym_PLUS] = ACTIONS(6605),
    [anon_sym_SLASH] = ACTIONS(6605),
    [anon_sym_PERCENT] = ACTIONS(6605),
    [sym_comment] = ACTIONS(87),
  },
  [5951] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1697),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(11857),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [5952] = {
    [aux_sym_string_array_repeat1] = STATE(1699),
    [sym__string_end] = ACTIONS(11857),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(11859),
  },
  [5953] = {
    [sym__heredoc_body_start] = ACTIONS(6613),
    [sym__binary_minus] = ACTIONS(6613),
    [sym__binary_star] = ACTIONS(6613),
    [anon_sym_LBRACE] = ACTIONS(6613),
    [anon_sym_RBRACE] = ACTIONS(6613),
    [anon_sym_RPAREN] = ACTIONS(6613),
    [anon_sym_DOT] = ACTIONS(6615),
    [anon_sym_COMMA] = ACTIONS(6613),
    [anon_sym_PIPE] = ACTIONS(6615),
    [anon_sym_SEMI] = ACTIONS(6613),
    [anon_sym_STAR_STAR] = ACTIONS(6613),
    [anon_sym_AMP] = ACTIONS(6615),
    [anon_sym_EQ] = ACTIONS(6615),
    [anon_sym_LT] = ACTIONS(6615),
    [anon_sym_if] = ACTIONS(6613),
    [anon_sym_unless] = ACTIONS(6613),
    [anon_sym_while] = ACTIONS(6613),
    [anon_sym_until] = ACTIONS(6613),
    [anon_sym_rescue] = ACTIONS(6613),
    [anon_sym_in] = ACTIONS(6613),
    [anon_sym_do] = ACTIONS(6613),
    [anon_sym_EQ_GT] = ACTIONS(6613),
    [anon_sym_LBRACK] = ACTIONS(6613),
    [anon_sym_RBRACK] = ACTIONS(6613),
    [anon_sym_COLON_COLON2] = ACTIONS(6613),
    [anon_sym_AMP_DOT] = ACTIONS(6613),
    [anon_sym_QMARK] = ACTIONS(6613),
    [anon_sym_COLON2] = ACTIONS(6615),
    [anon_sym_DOT_DOT] = ACTIONS(6615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6613),
    [anon_sym_and] = ACTIONS(6613),
    [anon_sym_or] = ACTIONS(6613),
    [anon_sym_PIPE_PIPE] = ACTIONS(6613),
    [anon_sym_AMP_AMP] = ACTIONS(6613),
    [anon_sym_LT_LT] = ACTIONS(6613),
    [anon_sym_GT_GT] = ACTIONS(6613),
    [anon_sym_EQ_EQ] = ACTIONS(6615),
    [anon_sym_BANG_EQ] = ACTIONS(6613),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6613),
    [anon_sym_LT_EQ_GT] = ACTIONS(6613),
    [anon_sym_EQ_TILDE] = ACTIONS(6613),
    [anon_sym_BANG_TILDE] = ACTIONS(6613),
    [anon_sym_LT_EQ] = ACTIONS(6615),
    [anon_sym_GT] = ACTIONS(6615),
    [anon_sym_GT_EQ] = ACTIONS(6613),
    [anon_sym_CARET] = ACTIONS(6613),
    [anon_sym_PLUS] = ACTIONS(6613),
    [anon_sym_SLASH] = ACTIONS(6613),
    [anon_sym_PERCENT] = ACTIONS(6613),
    [sym_comment] = ACTIONS(87),
  },
  [5954] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1697),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(11861),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [5955] = {
    [sym__heredoc_body_start] = ACTIONS(6626),
    [sym__binary_minus] = ACTIONS(6626),
    [sym__binary_star] = ACTIONS(6626),
    [anon_sym_LBRACE] = ACTIONS(6626),
    [anon_sym_RBRACE] = ACTIONS(6626),
    [anon_sym_RPAREN] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(6628),
    [anon_sym_COMMA] = ACTIONS(6626),
    [anon_sym_PIPE] = ACTIONS(6628),
    [anon_sym_SEMI] = ACTIONS(6626),
    [anon_sym_STAR_STAR] = ACTIONS(6626),
    [anon_sym_AMP] = ACTIONS(6628),
    [anon_sym_EQ] = ACTIONS(6628),
    [anon_sym_LT] = ACTIONS(6628),
    [anon_sym_if] = ACTIONS(6626),
    [anon_sym_unless] = ACTIONS(6626),
    [anon_sym_while] = ACTIONS(6626),
    [anon_sym_until] = ACTIONS(6626),
    [anon_sym_rescue] = ACTIONS(6626),
    [anon_sym_in] = ACTIONS(6626),
    [anon_sym_do] = ACTIONS(6626),
    [anon_sym_EQ_GT] = ACTIONS(6626),
    [anon_sym_LBRACK] = ACTIONS(6626),
    [anon_sym_RBRACK] = ACTIONS(6626),
    [anon_sym_COLON_COLON2] = ACTIONS(6626),
    [anon_sym_AMP_DOT] = ACTIONS(6626),
    [anon_sym_QMARK] = ACTIONS(6626),
    [anon_sym_COLON2] = ACTIONS(6628),
    [anon_sym_DOT_DOT] = ACTIONS(6628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6626),
    [anon_sym_and] = ACTIONS(6626),
    [anon_sym_or] = ACTIONS(6626),
    [anon_sym_PIPE_PIPE] = ACTIONS(6626),
    [anon_sym_AMP_AMP] = ACTIONS(6626),
    [anon_sym_LT_LT] = ACTIONS(6626),
    [anon_sym_GT_GT] = ACTIONS(6626),
    [anon_sym_EQ_EQ] = ACTIONS(6628),
    [anon_sym_BANG_EQ] = ACTIONS(6626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6626),
    [anon_sym_LT_EQ_GT] = ACTIONS(6626),
    [anon_sym_EQ_TILDE] = ACTIONS(6626),
    [anon_sym_BANG_TILDE] = ACTIONS(6626),
    [anon_sym_LT_EQ] = ACTIONS(6628),
    [anon_sym_GT] = ACTIONS(6628),
    [anon_sym_GT_EQ] = ACTIONS(6626),
    [anon_sym_CARET] = ACTIONS(6626),
    [anon_sym_PLUS] = ACTIONS(6626),
    [anon_sym_SLASH] = ACTIONS(6626),
    [anon_sym_PERCENT] = ACTIONS(6626),
    [sym_comment] = ACTIONS(87),
  },
  [5956] = {
    [sym__heredoc_body_start] = ACTIONS(6630),
    [sym__binary_minus] = ACTIONS(6630),
    [sym__binary_star] = ACTIONS(6630),
    [anon_sym_LBRACE] = ACTIONS(6630),
    [anon_sym_RBRACE] = ACTIONS(6630),
    [anon_sym_RPAREN] = ACTIONS(6630),
    [anon_sym_DOT] = ACTIONS(6632),
    [anon_sym_COMMA] = ACTIONS(6630),
    [anon_sym_PIPE] = ACTIONS(6632),
    [anon_sym_SEMI] = ACTIONS(6630),
    [anon_sym_STAR_STAR] = ACTIONS(6630),
    [anon_sym_AMP] = ACTIONS(6632),
    [anon_sym_EQ] = ACTIONS(6632),
    [anon_sym_LT] = ACTIONS(6632),
    [anon_sym_if] = ACTIONS(6630),
    [anon_sym_unless] = ACTIONS(6630),
    [anon_sym_while] = ACTIONS(6630),
    [anon_sym_until] = ACTIONS(6630),
    [anon_sym_rescue] = ACTIONS(6630),
    [anon_sym_in] = ACTIONS(6630),
    [anon_sym_do] = ACTIONS(6630),
    [anon_sym_EQ_GT] = ACTIONS(6630),
    [anon_sym_LBRACK] = ACTIONS(6630),
    [anon_sym_RBRACK] = ACTIONS(6630),
    [anon_sym_COLON_COLON2] = ACTIONS(6630),
    [anon_sym_AMP_DOT] = ACTIONS(6630),
    [anon_sym_QMARK] = ACTIONS(6630),
    [anon_sym_COLON2] = ACTIONS(6632),
    [anon_sym_DOT_DOT] = ACTIONS(6632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6630),
    [anon_sym_and] = ACTIONS(6630),
    [anon_sym_or] = ACTIONS(6630),
    [anon_sym_PIPE_PIPE] = ACTIONS(6630),
    [anon_sym_AMP_AMP] = ACTIONS(6630),
    [anon_sym_LT_LT] = ACTIONS(6630),
    [anon_sym_GT_GT] = ACTIONS(6630),
    [anon_sym_EQ_EQ] = ACTIONS(6632),
    [anon_sym_BANG_EQ] = ACTIONS(6630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6630),
    [anon_sym_LT_EQ_GT] = ACTIONS(6630),
    [anon_sym_EQ_TILDE] = ACTIONS(6630),
    [anon_sym_BANG_TILDE] = ACTIONS(6630),
    [anon_sym_LT_EQ] = ACTIONS(6632),
    [anon_sym_GT] = ACTIONS(6632),
    [anon_sym_GT_EQ] = ACTIONS(6630),
    [anon_sym_CARET] = ACTIONS(6630),
    [anon_sym_PLUS] = ACTIONS(6630),
    [anon_sym_SLASH] = ACTIONS(6630),
    [anon_sym_PERCENT] = ACTIONS(6630),
    [sym_comment] = ACTIONS(87),
  },
  [5957] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1705),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(11863),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [5958] = {
    [aux_sym_symbol_array_repeat1] = STATE(1707),
    [sym__string_end] = ACTIONS(11863),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(11865),
  },
  [5959] = {
    [sym__heredoc_body_start] = ACTIONS(6638),
    [sym__binary_minus] = ACTIONS(6638),
    [sym__binary_star] = ACTIONS(6638),
    [anon_sym_LBRACE] = ACTIONS(6638),
    [anon_sym_RBRACE] = ACTIONS(6638),
    [anon_sym_RPAREN] = ACTIONS(6638),
    [anon_sym_DOT] = ACTIONS(6640),
    [anon_sym_COMMA] = ACTIONS(6638),
    [anon_sym_PIPE] = ACTIONS(6640),
    [anon_sym_SEMI] = ACTIONS(6638),
    [anon_sym_STAR_STAR] = ACTIONS(6638),
    [anon_sym_AMP] = ACTIONS(6640),
    [anon_sym_EQ] = ACTIONS(6640),
    [anon_sym_LT] = ACTIONS(6640),
    [anon_sym_if] = ACTIONS(6638),
    [anon_sym_unless] = ACTIONS(6638),
    [anon_sym_while] = ACTIONS(6638),
    [anon_sym_until] = ACTIONS(6638),
    [anon_sym_rescue] = ACTIONS(6638),
    [anon_sym_in] = ACTIONS(6638),
    [anon_sym_do] = ACTIONS(6638),
    [anon_sym_EQ_GT] = ACTIONS(6638),
    [anon_sym_LBRACK] = ACTIONS(6638),
    [anon_sym_RBRACK] = ACTIONS(6638),
    [anon_sym_COLON_COLON2] = ACTIONS(6638),
    [anon_sym_AMP_DOT] = ACTIONS(6638),
    [anon_sym_QMARK] = ACTIONS(6638),
    [anon_sym_COLON2] = ACTIONS(6640),
    [anon_sym_DOT_DOT] = ACTIONS(6640),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6638),
    [anon_sym_and] = ACTIONS(6638),
    [anon_sym_or] = ACTIONS(6638),
    [anon_sym_PIPE_PIPE] = ACTIONS(6638),
    [anon_sym_AMP_AMP] = ACTIONS(6638),
    [anon_sym_LT_LT] = ACTIONS(6638),
    [anon_sym_GT_GT] = ACTIONS(6638),
    [anon_sym_EQ_EQ] = ACTIONS(6640),
    [anon_sym_BANG_EQ] = ACTIONS(6638),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6638),
    [anon_sym_LT_EQ_GT] = ACTIONS(6638),
    [anon_sym_EQ_TILDE] = ACTIONS(6638),
    [anon_sym_BANG_TILDE] = ACTIONS(6638),
    [anon_sym_LT_EQ] = ACTIONS(6640),
    [anon_sym_GT] = ACTIONS(6640),
    [anon_sym_GT_EQ] = ACTIONS(6638),
    [anon_sym_CARET] = ACTIONS(6638),
    [anon_sym_PLUS] = ACTIONS(6638),
    [anon_sym_SLASH] = ACTIONS(6638),
    [anon_sym_PERCENT] = ACTIONS(6638),
    [sym_comment] = ACTIONS(87),
  },
  [5960] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1705),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(11867),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [5961] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(8353),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(5966),
    [sym_scope_resolution] = STATE(1285),
    [sym_call] = STATE(1285),
    [sym_method_call] = STATE(5966),
    [sym_assignment] = STATE(8353),
    [sym_operator_assignment] = STATE(8353),
    [sym_conditional] = STATE(8353),
    [sym_range] = STATE(8353),
    [sym_binary] = STATE(8353),
    [sym_unary] = STATE(8353),
    [sym_left_assignment_list] = STATE(5965),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5966),
    [sym__variable] = STATE(1285),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(5966),
    [sym_false] = STATE(5966),
    [sym_nil] = STATE(5966),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(1288),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9288),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2283),
    [anon_sym_yield] = ACTIONS(2285),
    [anon_sym_break] = ACTIONS(2287),
    [anon_sym_next] = ACTIONS(2289),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9290),
    [anon_sym_defined_QMARK] = ACTIONS(9292),
    [anon_sym_not] = ACTIONS(9294),
    [anon_sym_BANG] = ACTIONS(9296),
    [anon_sym_TILDE] = ACTIONS(9296),
    [sym_constant] = ACTIONS(2299),
    [sym_identifier] = ACTIONS(2299),
    [sym_instance_variable] = ACTIONS(2301),
    [sym_class_variable] = ACTIONS(2301),
    [sym_global_variable] = ACTIONS(2301),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2299),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2299),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5962] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(8354),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(5966),
    [sym_scope_resolution] = STATE(1285),
    [sym_call] = STATE(1285),
    [sym_method_call] = STATE(5966),
    [sym_assignment] = STATE(8354),
    [sym_operator_assignment] = STATE(8354),
    [sym_conditional] = STATE(8354),
    [sym_range] = STATE(8354),
    [sym_binary] = STATE(8354),
    [sym_unary] = STATE(8354),
    [sym_left_assignment_list] = STATE(5965),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5966),
    [sym__variable] = STATE(1285),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(5966),
    [sym_false] = STATE(5966),
    [sym_nil] = STATE(5966),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(1288),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9288),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2283),
    [anon_sym_yield] = ACTIONS(2285),
    [anon_sym_break] = ACTIONS(2287),
    [anon_sym_next] = ACTIONS(2289),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9290),
    [anon_sym_defined_QMARK] = ACTIONS(9292),
    [anon_sym_not] = ACTIONS(9294),
    [anon_sym_BANG] = ACTIONS(9296),
    [anon_sym_TILDE] = ACTIONS(9296),
    [sym_constant] = ACTIONS(2299),
    [sym_identifier] = ACTIONS(2299),
    [sym_instance_variable] = ACTIONS(2301),
    [sym_class_variable] = ACTIONS(2301),
    [sym_global_variable] = ACTIONS(2301),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2299),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2299),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5963] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(1872),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(5966),
    [sym_scope_resolution] = STATE(1285),
    [sym_call] = STATE(1285),
    [sym_method_call] = STATE(5966),
    [sym_assignment] = STATE(1872),
    [sym_operator_assignment] = STATE(1872),
    [sym_conditional] = STATE(1872),
    [sym_range] = STATE(1872),
    [sym_binary] = STATE(1872),
    [sym_unary] = STATE(1872),
    [sym_left_assignment_list] = STATE(5965),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5966),
    [sym__variable] = STATE(1285),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(5966),
    [sym_false] = STATE(5966),
    [sym_nil] = STATE(5966),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(1288),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9288),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2283),
    [anon_sym_yield] = ACTIONS(2285),
    [anon_sym_break] = ACTIONS(2287),
    [anon_sym_next] = ACTIONS(2289),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9290),
    [anon_sym_defined_QMARK] = ACTIONS(9292),
    [anon_sym_not] = ACTIONS(9294),
    [anon_sym_BANG] = ACTIONS(9296),
    [anon_sym_TILDE] = ACTIONS(9296),
    [sym_constant] = ACTIONS(2299),
    [sym_identifier] = ACTIONS(2299),
    [sym_instance_variable] = ACTIONS(2301),
    [sym_class_variable] = ACTIONS(2301),
    [sym_global_variable] = ACTIONS(2301),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2299),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2299),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5964] = {
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(11869),
    [sym__binary_star] = ACTIONS(11871),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(11873),
    [anon_sym_STAR_STAR] = ACTIONS(11871),
    [anon_sym_AMP] = ACTIONS(11875),
    [anon_sym_LT] = ACTIONS(11877),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_RBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(11879),
    [anon_sym_DOT_DOT] = ACTIONS(11881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11883),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11885),
    [anon_sym_AMP_AMP] = ACTIONS(11885),
    [anon_sym_LT_LT] = ACTIONS(11887),
    [anon_sym_GT_GT] = ACTIONS(11887),
    [anon_sym_EQ_EQ] = ACTIONS(11889),
    [anon_sym_BANG_EQ] = ACTIONS(11885),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11885),
    [anon_sym_LT_EQ_GT] = ACTIONS(11885),
    [anon_sym_EQ_TILDE] = ACTIONS(11885),
    [anon_sym_BANG_TILDE] = ACTIONS(11885),
    [anon_sym_LT_EQ] = ACTIONS(11877),
    [anon_sym_GT] = ACTIONS(11877),
    [anon_sym_GT_EQ] = ACTIONS(11891),
    [anon_sym_CARET] = ACTIONS(11893),
    [anon_sym_PLUS] = ACTIONS(11869),
    [anon_sym_SLASH] = ACTIONS(11871),
    [anon_sym_PERCENT] = ACTIONS(11871),
    [sym_comment] = ACTIONS(87),
  },
  [5965] = {
    [anon_sym_EQ] = ACTIONS(11895),
    [sym_comment] = ACTIONS(87),
  },
  [5966] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(11897),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(11899),
    [anon_sym_DASH_EQ] = ACTIONS(11899),
    [anon_sym_STAR_EQ] = ACTIONS(11899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11899),
    [anon_sym_SLASH_EQ] = ACTIONS(11899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11899),
    [anon_sym_PIPE_EQ] = ACTIONS(11899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11899),
    [anon_sym_AMP_EQ] = ACTIONS(11899),
    [anon_sym_PERCENT_EQ] = ACTIONS(11899),
    [anon_sym_GT_GT_EQ] = ACTIONS(11899),
    [anon_sym_LT_LT_EQ] = ACTIONS(11899),
    [anon_sym_CARET_EQ] = ACTIONS(11899),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5967] = {
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(11869),
    [sym__binary_star] = ACTIONS(11871),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(11873),
    [anon_sym_STAR_STAR] = ACTIONS(11871),
    [anon_sym_AMP] = ACTIONS(11875),
    [anon_sym_LT] = ACTIONS(11877),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_RBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(11879),
    [anon_sym_DOT_DOT] = ACTIONS(11881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11883),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(11885),
    [anon_sym_AMP_AMP] = ACTIONS(11885),
    [anon_sym_LT_LT] = ACTIONS(11887),
    [anon_sym_GT_GT] = ACTIONS(11887),
    [anon_sym_EQ_EQ] = ACTIONS(11889),
    [anon_sym_BANG_EQ] = ACTIONS(11885),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11885),
    [anon_sym_LT_EQ_GT] = ACTIONS(11885),
    [anon_sym_EQ_TILDE] = ACTIONS(11885),
    [anon_sym_BANG_TILDE] = ACTIONS(11885),
    [anon_sym_LT_EQ] = ACTIONS(11877),
    [anon_sym_GT] = ACTIONS(11877),
    [anon_sym_GT_EQ] = ACTIONS(11891),
    [anon_sym_CARET] = ACTIONS(11893),
    [anon_sym_PLUS] = ACTIONS(11869),
    [anon_sym_SLASH] = ACTIONS(11871),
    [anon_sym_PERCENT] = ACTIONS(11871),
    [sym_comment] = ACTIONS(87),
  },
  [5968] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(8367),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(5966),
    [sym_scope_resolution] = STATE(1285),
    [sym_call] = STATE(1285),
    [sym_method_call] = STATE(5966),
    [sym_assignment] = STATE(8367),
    [sym_operator_assignment] = STATE(8367),
    [sym_conditional] = STATE(8367),
    [sym_range] = STATE(8367),
    [sym_binary] = STATE(8367),
    [sym_unary] = STATE(8367),
    [sym_left_assignment_list] = STATE(5965),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5966),
    [sym__variable] = STATE(1285),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(5966),
    [sym_false] = STATE(5966),
    [sym_nil] = STATE(5966),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(1288),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9288),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2283),
    [anon_sym_yield] = ACTIONS(2285),
    [anon_sym_break] = ACTIONS(2287),
    [anon_sym_next] = ACTIONS(2289),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9290),
    [anon_sym_defined_QMARK] = ACTIONS(9292),
    [anon_sym_not] = ACTIONS(9294),
    [anon_sym_BANG] = ACTIONS(9296),
    [anon_sym_TILDE] = ACTIONS(9296),
    [sym_constant] = ACTIONS(2299),
    [sym_identifier] = ACTIONS(2299),
    [sym_instance_variable] = ACTIONS(2301),
    [sym_class_variable] = ACTIONS(2301),
    [sym_global_variable] = ACTIONS(2301),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2299),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2299),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5969] = {
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(11869),
    [sym__binary_star] = ACTIONS(11871),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(11873),
    [anon_sym_STAR_STAR] = ACTIONS(11871),
    [anon_sym_AMP] = ACTIONS(11875),
    [anon_sym_LT] = ACTIONS(11877),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_RBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(11879),
    [anon_sym_DOT_DOT] = ACTIONS(11881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11883),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(11885),
    [anon_sym_AMP_AMP] = ACTIONS(11885),
    [anon_sym_LT_LT] = ACTIONS(11887),
    [anon_sym_GT_GT] = ACTIONS(11887),
    [anon_sym_EQ_EQ] = ACTIONS(11889),
    [anon_sym_BANG_EQ] = ACTIONS(11885),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11885),
    [anon_sym_LT_EQ_GT] = ACTIONS(11885),
    [anon_sym_EQ_TILDE] = ACTIONS(11885),
    [anon_sym_BANG_TILDE] = ACTIONS(11885),
    [anon_sym_LT_EQ] = ACTIONS(11877),
    [anon_sym_GT] = ACTIONS(11877),
    [anon_sym_GT_EQ] = ACTIONS(11891),
    [anon_sym_CARET] = ACTIONS(11893),
    [anon_sym_PLUS] = ACTIONS(11869),
    [anon_sym_SLASH] = ACTIONS(11871),
    [anon_sym_PERCENT] = ACTIONS(11871),
    [sym_comment] = ACTIONS(87),
  },
  [5970] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(8368),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(5966),
    [sym_scope_resolution] = STATE(1285),
    [sym_call] = STATE(1285),
    [sym_method_call] = STATE(5966),
    [sym_assignment] = STATE(8368),
    [sym_operator_assignment] = STATE(8368),
    [sym_conditional] = STATE(8368),
    [sym_range] = STATE(8368),
    [sym_binary] = STATE(8368),
    [sym_unary] = STATE(8368),
    [sym_left_assignment_list] = STATE(5965),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5966),
    [sym__variable] = STATE(1285),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(5966),
    [sym_false] = STATE(5966),
    [sym_nil] = STATE(5966),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(1288),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9288),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2283),
    [anon_sym_yield] = ACTIONS(2285),
    [anon_sym_break] = ACTIONS(2287),
    [anon_sym_next] = ACTIONS(2289),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9290),
    [anon_sym_defined_QMARK] = ACTIONS(9292),
    [anon_sym_not] = ACTIONS(9294),
    [anon_sym_BANG] = ACTIONS(9296),
    [anon_sym_TILDE] = ACTIONS(9296),
    [sym_constant] = ACTIONS(2299),
    [sym_identifier] = ACTIONS(2299),
    [sym_instance_variable] = ACTIONS(2301),
    [sym_class_variable] = ACTIONS(2301),
    [sym_global_variable] = ACTIONS(2301),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2299),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2299),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5971] = {
    [sym_heredoc_body] = STATE(8369),
    [aux_sym_call_repeat1] = STATE(8369),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_RBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [5972] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(3316),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1322),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(1322),
    [sym__argument] = STATE(4250),
    [sym_splat_argument] = STATE(4250),
    [sym_hash_splat_argument] = STATE(4250),
    [sym_block_argument] = STATE(4250),
    [sym_assignment] = STATE(3316),
    [sym_operator_assignment] = STATE(3316),
    [sym_conditional] = STATE(3316),
    [sym_range] = STATE(3316),
    [sym_binary] = STATE(3316),
    [sym_unary] = STATE(3316),
    [sym_left_assignment_list] = STATE(1321),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1322),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1322),
    [sym_false] = STATE(1322),
    [sym_nil] = STATE(1322),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(3319),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_heredoc_body] = STATE(8370),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(4250),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(5527),
    [sym__splat_star] = ACTIONS(5529),
    [sym__unary_minus] = ACTIONS(2325),
    [sym__identifier_hash_key] = ACTIONS(5531),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11901),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5591),
    [anon_sym_defined_QMARK] = ACTIONS(2329),
    [anon_sym_not] = ACTIONS(2331),
    [anon_sym_BANG] = ACTIONS(2335),
    [anon_sym_TILDE] = ACTIONS(2335),
    [sym_constant] = ACTIONS(5533),
    [sym_identifier] = ACTIONS(5533),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5973] = {
    [sym_heredoc_body] = STATE(8371),
    [aux_sym_call_repeat1] = STATE(8371),
    [aux_sym_argument_list_repeat1] = STATE(8372),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(9302),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_RBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [5974] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5537),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(5537),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_RBRACK] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5537),
    [anon_sym_PERCENT] = ACTIONS(5537),
    [sym_comment] = ACTIONS(87),
  },
  [5975] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(5537),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_RBRACK] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [5976] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5535),
    [sym__binary_star] = ACTIONS(5537),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(5537),
    [anon_sym_AMP] = ACTIONS(5541),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_RBRACK] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5555),
    [anon_sym_GT_GT] = ACTIONS(5555),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5535),
    [anon_sym_SLASH] = ACTIONS(5537),
    [anon_sym_PERCENT] = ACTIONS(5537),
    [sym_comment] = ACTIONS(87),
  },
  [5977] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5535),
    [sym__binary_star] = ACTIONS(5537),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(5537),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_RBRACK] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5555),
    [anon_sym_GT_GT] = ACTIONS(5555),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5535),
    [anon_sym_SLASH] = ACTIONS(5537),
    [anon_sym_PERCENT] = ACTIONS(5537),
    [sym_comment] = ACTIONS(87),
  },
  [5978] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5535),
    [sym__binary_star] = ACTIONS(5537),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5537),
    [anon_sym_AMP] = ACTIONS(5541),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_RBRACK] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5555),
    [anon_sym_GT_GT] = ACTIONS(5555),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5561),
    [anon_sym_PLUS] = ACTIONS(5535),
    [anon_sym_SLASH] = ACTIONS(5537),
    [anon_sym_PERCENT] = ACTIONS(5537),
    [sym_comment] = ACTIONS(87),
  },
  [5979] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(11903),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [5980] = {
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(5535),
    [sym__binary_star] = ACTIONS(5537),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5537),
    [anon_sym_AMP] = ACTIONS(5541),
    [anon_sym_LT] = ACTIONS(5543),
    [anon_sym_RBRACK] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(5547),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5549),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(5553),
    [anon_sym_AMP_AMP] = ACTIONS(5553),
    [anon_sym_LT_LT] = ACTIONS(5555),
    [anon_sym_GT_GT] = ACTIONS(5555),
    [anon_sym_EQ_EQ] = ACTIONS(5557),
    [anon_sym_BANG_EQ] = ACTIONS(5553),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5553),
    [anon_sym_LT_EQ_GT] = ACTIONS(5553),
    [anon_sym_EQ_TILDE] = ACTIONS(5553),
    [anon_sym_BANG_TILDE] = ACTIONS(5553),
    [anon_sym_LT_EQ] = ACTIONS(5543),
    [anon_sym_GT] = ACTIONS(5543),
    [anon_sym_GT_EQ] = ACTIONS(5559),
    [anon_sym_CARET] = ACTIONS(5561),
    [anon_sym_PLUS] = ACTIONS(5535),
    [anon_sym_SLASH] = ACTIONS(5537),
    [anon_sym_PERCENT] = ACTIONS(5537),
    [sym_comment] = ACTIONS(87),
  },
  [5981] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5535),
    [sym__binary_star] = ACTIONS(5537),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5537),
    [anon_sym_AMP] = ACTIONS(5541),
    [anon_sym_LT] = ACTIONS(5543),
    [anon_sym_RBRACK] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5545),
    [anon_sym_DOT_DOT] = ACTIONS(5547),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5549),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5553),
    [anon_sym_AMP_AMP] = ACTIONS(5553),
    [anon_sym_LT_LT] = ACTIONS(5555),
    [anon_sym_GT_GT] = ACTIONS(5555),
    [anon_sym_EQ_EQ] = ACTIONS(5557),
    [anon_sym_BANG_EQ] = ACTIONS(5553),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5553),
    [anon_sym_LT_EQ_GT] = ACTIONS(5553),
    [anon_sym_EQ_TILDE] = ACTIONS(5553),
    [anon_sym_BANG_TILDE] = ACTIONS(5553),
    [anon_sym_LT_EQ] = ACTIONS(5543),
    [anon_sym_GT] = ACTIONS(5543),
    [anon_sym_GT_EQ] = ACTIONS(5559),
    [anon_sym_CARET] = ACTIONS(5561),
    [anon_sym_PLUS] = ACTIONS(5535),
    [anon_sym_SLASH] = ACTIONS(5537),
    [anon_sym_PERCENT] = ACTIONS(5537),
    [sym_comment] = ACTIONS(87),
  },
  [5982] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5535),
    [sym__binary_star] = ACTIONS(5537),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5537),
    [anon_sym_AMP] = ACTIONS(5541),
    [anon_sym_LT] = ACTIONS(5543),
    [anon_sym_RBRACK] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5555),
    [anon_sym_GT_GT] = ACTIONS(5555),
    [anon_sym_EQ_EQ] = ACTIONS(5557),
    [anon_sym_BANG_EQ] = ACTIONS(5553),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5553),
    [anon_sym_LT_EQ_GT] = ACTIONS(5553),
    [anon_sym_EQ_TILDE] = ACTIONS(5553),
    [anon_sym_BANG_TILDE] = ACTIONS(5553),
    [anon_sym_LT_EQ] = ACTIONS(5543),
    [anon_sym_GT] = ACTIONS(5543),
    [anon_sym_GT_EQ] = ACTIONS(5559),
    [anon_sym_CARET] = ACTIONS(5561),
    [anon_sym_PLUS] = ACTIONS(5535),
    [anon_sym_SLASH] = ACTIONS(5537),
    [anon_sym_PERCENT] = ACTIONS(5537),
    [sym_comment] = ACTIONS(87),
  },
  [5983] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5535),
    [sym__binary_star] = ACTIONS(5537),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(5537),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_RBRACK] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5535),
    [anon_sym_SLASH] = ACTIONS(5537),
    [anon_sym_PERCENT] = ACTIONS(5537),
    [sym_comment] = ACTIONS(87),
  },
  [5984] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(8374),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(5994),
    [sym_scope_resolution] = STATE(5992),
    [sym_call] = STATE(5992),
    [sym_method_call] = STATE(5994),
    [sym_assignment] = STATE(8374),
    [sym_operator_assignment] = STATE(8374),
    [sym_conditional] = STATE(8374),
    [sym_range] = STATE(8374),
    [sym_binary] = STATE(8374),
    [sym_unary] = STATE(8374),
    [sym_left_assignment_list] = STATE(5993),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5994),
    [sym__variable] = STATE(5992),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(5994),
    [sym_false] = STATE(5994),
    [sym_nil] = STATE(5994),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(5995),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(9306),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(9308),
    [anon_sym_yield] = ACTIONS(9310),
    [anon_sym_break] = ACTIONS(9312),
    [anon_sym_next] = ACTIONS(9314),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(9316),
    [anon_sym_defined_QMARK] = ACTIONS(9318),
    [anon_sym_not] = ACTIONS(9320),
    [anon_sym_BANG] = ACTIONS(9322),
    [anon_sym_TILDE] = ACTIONS(9322),
    [sym_constant] = ACTIONS(9324),
    [sym_identifier] = ACTIONS(9324),
    [sym_instance_variable] = ACTIONS(9326),
    [sym_class_variable] = ACTIONS(9326),
    [sym_global_variable] = ACTIONS(9326),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(9324),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9324),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [5985] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3336),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1384),
    [sym_scope_resolution] = STATE(1378),
    [sym_call] = STATE(1378),
    [sym_method_call] = STATE(1384),
    [sym_argument_list] = STATE(6614),
    [sym__argument_list_with_parens] = STATE(3337),
    [sym__argument] = STATE(3338),
    [sym_splat_argument] = STATE(3338),
    [sym_hash_splat_argument] = STATE(3338),
    [sym_block_argument] = STATE(3338),
    [sym_assignment] = STATE(3336),
    [sym_operator_assignment] = STATE(3336),
    [sym_conditional] = STATE(3336),
    [sym_range] = STATE(3336),
    [sym_binary] = STATE(3336),
    [sym_unary] = STATE(3336),
    [sym_left_assignment_list] = STATE(1383),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1384),
    [sym__variable] = STATE(1378),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1384),
    [sym_false] = STATE(1384),
    [sym_nil] = STATE(1384),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3339),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(3338),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(5563),
    [sym__splat_star] = ACTIONS(5565),
    [sym__unary_minus] = ACTIONS(2399),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(5567),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2405),
    [anon_sym_yield] = ACTIONS(2407),
    [anon_sym_break] = ACTIONS(2409),
    [anon_sym_next] = ACTIONS(2411),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_RBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_PLUS_EQ] = ACTIONS(365),
    [anon_sym_DASH_EQ] = ACTIONS(365),
    [anon_sym_STAR_EQ] = ACTIONS(365),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(365),
    [anon_sym_SLASH_EQ] = ACTIONS(365),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(365),
    [anon_sym_PIPE_EQ] = ACTIONS(365),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(365),
    [anon_sym_AMP_EQ] = ACTIONS(365),
    [anon_sym_PERCENT_EQ] = ACTIONS(365),
    [anon_sym_GT_GT_EQ] = ACTIONS(365),
    [anon_sym_LT_LT_EQ] = ACTIONS(365),
    [anon_sym_CARET_EQ] = ACTIONS(365),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_PERCENT] = ACTIONS(377),
    [anon_sym_defined_QMARK] = ACTIONS(2415),
    [anon_sym_not] = ACTIONS(2417),
    [anon_sym_BANG] = ACTIONS(2419),
    [anon_sym_TILDE] = ACTIONS(2421),
    [sym_constant] = ACTIONS(5569),
    [sym_identifier] = ACTIONS(5569),
    [sym_instance_variable] = ACTIONS(2425),
    [sym_class_variable] = ACTIONS(2425),
    [sym_global_variable] = ACTIONS(2425),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2427),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2427),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [5986] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3336),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1384),
    [sym_scope_resolution] = STATE(1378),
    [sym_call] = STATE(1378),
    [sym_method_call] = STATE(1384),
    [sym_argument_list] = STATE(6615),
    [sym__argument_list_with_parens] = STATE(3337),
    [sym__argument] = STATE(3338),
    [sym_splat_argument] = STATE(3338),
    [sym_hash_splat_argument] = STATE(3338),
    [sym_block_argument] = STATE(3338),
    [sym_assignment] = STATE(3336),
    [sym_operator_assignment] = STATE(3336),
    [sym_conditional] = STATE(3336),
    [sym_range] = STATE(3336),
    [sym_binary] = STATE(3336),
    [sym_unary] = STATE(3336),
    [sym_left_assignment_list] = STATE(1383),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1384),
    [sym__variable] = STATE(1378),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1384),
    [sym_false] = STATE(1384),
    [sym_nil] = STATE(1384),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3339),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(3338),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(5563),
    [sym__splat_star] = ACTIONS(5565),
    [sym__unary_minus] = ACTIONS(2399),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(5567),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_EQ] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2405),
    [anon_sym_yield] = ACTIONS(2407),
    [anon_sym_break] = ACTIONS(2409),
    [anon_sym_next] = ACTIONS(2411),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_RBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_PLUS_EQ] = ACTIONS(417),
    [anon_sym_DASH_EQ] = ACTIONS(417),
    [anon_sym_STAR_EQ] = ACTIONS(417),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(417),
    [anon_sym_SLASH_EQ] = ACTIONS(417),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(417),
    [anon_sym_PIPE_EQ] = ACTIONS(417),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(417),
    [anon_sym_AMP_EQ] = ACTIONS(417),
    [anon_sym_PERCENT_EQ] = ACTIONS(417),
    [anon_sym_GT_GT_EQ] = ACTIONS(417),
    [anon_sym_LT_LT_EQ] = ACTIONS(417),
    [anon_sym_CARET_EQ] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(2415),
    [anon_sym_not] = ACTIONS(2417),
    [anon_sym_BANG] = ACTIONS(2419),
    [anon_sym_TILDE] = ACTIONS(2421),
    [sym_constant] = ACTIONS(5569),
    [sym_identifier] = ACTIONS(5569),
    [sym_instance_variable] = ACTIONS(2425),
    [sym_class_variable] = ACTIONS(2425),
    [sym_global_variable] = ACTIONS(2425),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2427),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2427),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [5987] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3336),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1384),
    [sym_scope_resolution] = STATE(1378),
    [sym_call] = STATE(1378),
    [sym_method_call] = STATE(1384),
    [sym_argument_list] = STATE(6616),
    [sym__argument_list_with_parens] = STATE(3337),
    [sym__argument] = STATE(3338),
    [sym_splat_argument] = STATE(3338),
    [sym_hash_splat_argument] = STATE(3338),
    [sym_block_argument] = STATE(3338),
    [sym_assignment] = STATE(3336),
    [sym_operator_assignment] = STATE(3336),
    [sym_conditional] = STATE(3336),
    [sym_range] = STATE(3336),
    [sym_binary] = STATE(3336),
    [sym_unary] = STATE(3336),
    [sym_left_assignment_list] = STATE(1383),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1384),
    [sym__variable] = STATE(1378),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1384),
    [sym_false] = STATE(1384),
    [sym_nil] = STATE(1384),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3339),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(3338),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(5563),
    [sym__splat_star] = ACTIONS(5565),
    [sym__unary_minus] = ACTIONS(2399),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(5567),
    [anon_sym_LBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_EQ] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2405),
    [anon_sym_yield] = ACTIONS(2407),
    [anon_sym_break] = ACTIONS(2409),
    [anon_sym_next] = ACTIONS(2411),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_RBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_PLUS_EQ] = ACTIONS(421),
    [anon_sym_DASH_EQ] = ACTIONS(421),
    [anon_sym_STAR_EQ] = ACTIONS(421),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(421),
    [anon_sym_SLASH_EQ] = ACTIONS(421),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(421),
    [anon_sym_PIPE_EQ] = ACTIONS(421),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(421),
    [anon_sym_AMP_EQ] = ACTIONS(421),
    [anon_sym_PERCENT_EQ] = ACTIONS(421),
    [anon_sym_GT_GT_EQ] = ACTIONS(421),
    [anon_sym_LT_LT_EQ] = ACTIONS(421),
    [anon_sym_CARET_EQ] = ACTIONS(421),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(2415),
    [anon_sym_not] = ACTIONS(2417),
    [anon_sym_BANG] = ACTIONS(2419),
    [anon_sym_TILDE] = ACTIONS(2421),
    [sym_constant] = ACTIONS(5569),
    [sym_identifier] = ACTIONS(5569),
    [sym_instance_variable] = ACTIONS(2425),
    [sym_class_variable] = ACTIONS(2425),
    [sym_global_variable] = ACTIONS(2425),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2427),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2427),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [5988] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3336),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1384),
    [sym_scope_resolution] = STATE(1378),
    [sym_call] = STATE(1378),
    [sym_method_call] = STATE(1384),
    [sym_argument_list] = STATE(6617),
    [sym__argument_list_with_parens] = STATE(3337),
    [sym__argument] = STATE(3338),
    [sym_splat_argument] = STATE(3338),
    [sym_hash_splat_argument] = STATE(3338),
    [sym_block_argument] = STATE(3338),
    [sym_assignment] = STATE(3336),
    [sym_operator_assignment] = STATE(3336),
    [sym_conditional] = STATE(3336),
    [sym_range] = STATE(3336),
    [sym_binary] = STATE(3336),
    [sym_unary] = STATE(3336),
    [sym_left_assignment_list] = STATE(1383),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1384),
    [sym__variable] = STATE(1378),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1384),
    [sym_false] = STATE(1384),
    [sym_nil] = STATE(1384),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3339),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(3338),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(5563),
    [sym__splat_star] = ACTIONS(5565),
    [sym__unary_minus] = ACTIONS(2399),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(5567),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(427),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2405),
    [anon_sym_yield] = ACTIONS(2407),
    [anon_sym_break] = ACTIONS(2409),
    [anon_sym_next] = ACTIONS(2411),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_RBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_PLUS_EQ] = ACTIONS(425),
    [anon_sym_DASH_EQ] = ACTIONS(425),
    [anon_sym_STAR_EQ] = ACTIONS(425),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(425),
    [anon_sym_SLASH_EQ] = ACTIONS(425),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(425),
    [anon_sym_PIPE_EQ] = ACTIONS(425),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(425),
    [anon_sym_AMP_EQ] = ACTIONS(425),
    [anon_sym_PERCENT_EQ] = ACTIONS(425),
    [anon_sym_GT_GT_EQ] = ACTIONS(425),
    [anon_sym_LT_LT_EQ] = ACTIONS(425),
    [anon_sym_CARET_EQ] = ACTIONS(425),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(2415),
    [anon_sym_not] = ACTIONS(2417),
    [anon_sym_BANG] = ACTIONS(2419),
    [anon_sym_TILDE] = ACTIONS(2421),
    [sym_constant] = ACTIONS(5569),
    [sym_identifier] = ACTIONS(5569),
    [sym_instance_variable] = ACTIONS(2425),
    [sym_class_variable] = ACTIONS(2425),
    [sym_global_variable] = ACTIONS(2425),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2427),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2427),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [5989] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(8375),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(5994),
    [sym_scope_resolution] = STATE(5992),
    [sym_call] = STATE(5992),
    [sym_method_call] = STATE(5994),
    [sym_assignment] = STATE(8375),
    [sym_operator_assignment] = STATE(8375),
    [sym_conditional] = STATE(8375),
    [sym_range] = STATE(8375),
    [sym_binary] = STATE(8375),
    [sym_unary] = STATE(8375),
    [sym_left_assignment_list] = STATE(5993),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5994),
    [sym__variable] = STATE(5992),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(5994),
    [sym_false] = STATE(5994),
    [sym_nil] = STATE(5994),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(5995),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(9306),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(9308),
    [anon_sym_yield] = ACTIONS(9310),
    [anon_sym_break] = ACTIONS(9312),
    [anon_sym_next] = ACTIONS(9314),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(9316),
    [anon_sym_defined_QMARK] = ACTIONS(9318),
    [anon_sym_not] = ACTIONS(9320),
    [anon_sym_BANG] = ACTIONS(9322),
    [anon_sym_TILDE] = ACTIONS(9322),
    [sym_constant] = ACTIONS(9324),
    [sym_identifier] = ACTIONS(9324),
    [sym_instance_variable] = ACTIONS(9326),
    [sym_class_variable] = ACTIONS(9326),
    [sym_global_variable] = ACTIONS(9326),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(9324),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9324),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [5990] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(6632),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(5994),
    [sym_scope_resolution] = STATE(5992),
    [sym_call] = STATE(5992),
    [sym_method_call] = STATE(5994),
    [sym_assignment] = STATE(6632),
    [sym_operator_assignment] = STATE(6632),
    [sym_conditional] = STATE(6632),
    [sym_range] = STATE(6632),
    [sym_binary] = STATE(6632),
    [sym_unary] = STATE(6632),
    [sym_left_assignment_list] = STATE(5993),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5994),
    [sym__variable] = STATE(5992),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(5994),
    [sym_false] = STATE(5994),
    [sym_nil] = STATE(5994),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(5995),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(9306),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(9308),
    [anon_sym_yield] = ACTIONS(9310),
    [anon_sym_break] = ACTIONS(9312),
    [anon_sym_next] = ACTIONS(9314),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(9316),
    [anon_sym_defined_QMARK] = ACTIONS(9318),
    [anon_sym_not] = ACTIONS(9320),
    [anon_sym_BANG] = ACTIONS(9322),
    [anon_sym_TILDE] = ACTIONS(9322),
    [sym_constant] = ACTIONS(9324),
    [sym_identifier] = ACTIONS(9324),
    [sym_instance_variable] = ACTIONS(9326),
    [sym_class_variable] = ACTIONS(9326),
    [sym_global_variable] = ACTIONS(9326),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(9324),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9324),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [5991] = {
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(11905),
    [sym__binary_star] = ACTIONS(11907),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(11909),
    [anon_sym_STAR_STAR] = ACTIONS(11911),
    [anon_sym_AMP] = ACTIONS(11913),
    [anon_sym_EQ] = ACTIONS(4217),
    [anon_sym_LT] = ACTIONS(11915),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_RBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_PLUS_EQ] = ACTIONS(4211),
    [anon_sym_DASH_EQ] = ACTIONS(4211),
    [anon_sym_STAR_EQ] = ACTIONS(4211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4211),
    [anon_sym_SLASH_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4211),
    [anon_sym_AMP_EQ] = ACTIONS(4211),
    [anon_sym_PERCENT_EQ] = ACTIONS(4211),
    [anon_sym_GT_GT_EQ] = ACTIONS(4211),
    [anon_sym_LT_LT_EQ] = ACTIONS(4211),
    [anon_sym_CARET_EQ] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(11917),
    [anon_sym_DOT_DOT] = ACTIONS(11919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11921),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11923),
    [anon_sym_AMP_AMP] = ACTIONS(11923),
    [anon_sym_LT_LT] = ACTIONS(11925),
    [anon_sym_GT_GT] = ACTIONS(11925),
    [anon_sym_EQ_EQ] = ACTIONS(11923),
    [anon_sym_BANG_EQ] = ACTIONS(11927),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11927),
    [anon_sym_LT_EQ_GT] = ACTIONS(11927),
    [anon_sym_EQ_TILDE] = ACTIONS(11927),
    [anon_sym_BANG_TILDE] = ACTIONS(11927),
    [anon_sym_LT_EQ] = ACTIONS(11915),
    [anon_sym_GT] = ACTIONS(11915),
    [anon_sym_GT_EQ] = ACTIONS(11929),
    [anon_sym_CARET] = ACTIONS(11909),
    [anon_sym_PLUS] = ACTIONS(11931),
    [anon_sym_SLASH] = ACTIONS(11911),
    [anon_sym_PERCENT] = ACTIONS(11911),
    [sym_comment] = ACTIONS(87),
  },
  [5992] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3336),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1384),
    [sym_scope_resolution] = STATE(1378),
    [sym_call] = STATE(1378),
    [sym_method_call] = STATE(1384),
    [sym_argument_list] = STATE(4801),
    [sym__argument_list_with_parens] = STATE(3337),
    [sym__argument] = STATE(3338),
    [sym_splat_argument] = STATE(3338),
    [sym_hash_splat_argument] = STATE(3338),
    [sym_block_argument] = STATE(3338),
    [sym_do_block] = STATE(1849),
    [sym_block] = STATE(1849),
    [sym_assignment] = STATE(3336),
    [sym_operator_assignment] = STATE(3336),
    [sym_conditional] = STATE(3336),
    [sym_range] = STATE(3336),
    [sym_binary] = STATE(3336),
    [sym_unary] = STATE(3336),
    [sym_left_assignment_list] = STATE(1383),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1384),
    [sym__variable] = STATE(1378),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1384),
    [sym_false] = STATE(1384),
    [sym_nil] = STATE(1384),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3339),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(3338),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(5563),
    [sym__splat_star] = ACTIONS(5565),
    [sym__unary_minus] = ACTIONS(2399),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(5567),
    [anon_sym_LBRACE] = ACTIONS(7739),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2405),
    [anon_sym_yield] = ACTIONS(2407),
    [anon_sym_break] = ACTIONS(2409),
    [anon_sym_next] = ACTIONS(2411),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(769),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_RBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(2415),
    [anon_sym_not] = ACTIONS(2417),
    [anon_sym_BANG] = ACTIONS(2419),
    [anon_sym_TILDE] = ACTIONS(2421),
    [sym_constant] = ACTIONS(5569),
    [sym_identifier] = ACTIONS(5569),
    [sym_instance_variable] = ACTIONS(2425),
    [sym_class_variable] = ACTIONS(2425),
    [sym_global_variable] = ACTIONS(2425),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2427),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2427),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [5993] = {
    [anon_sym_EQ] = ACTIONS(11933),
    [sym_comment] = ACTIONS(87),
  },
  [5994] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(11935),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(11937),
    [anon_sym_DASH_EQ] = ACTIONS(11937),
    [anon_sym_STAR_EQ] = ACTIONS(11937),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11937),
    [anon_sym_SLASH_EQ] = ACTIONS(11937),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11937),
    [anon_sym_PIPE_EQ] = ACTIONS(11937),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11937),
    [anon_sym_AMP_EQ] = ACTIONS(11937),
    [anon_sym_PERCENT_EQ] = ACTIONS(11937),
    [anon_sym_GT_GT_EQ] = ACTIONS(11937),
    [anon_sym_LT_LT_EQ] = ACTIONS(11937),
    [anon_sym_CARET_EQ] = ACTIONS(11937),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5995] = {
    [sym_string] = STATE(8388),
    [aux_sym_chained_string_repeat1] = STATE(8388),
    [sym__string_start] = ACTIONS(6455),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5996] = {
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(11905),
    [sym__binary_star] = ACTIONS(11907),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(11909),
    [anon_sym_STAR_STAR] = ACTIONS(11911),
    [anon_sym_AMP] = ACTIONS(11913),
    [anon_sym_EQ] = ACTIONS(4249),
    [anon_sym_LT] = ACTIONS(11915),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_RBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_PLUS_EQ] = ACTIONS(4247),
    [anon_sym_DASH_EQ] = ACTIONS(4247),
    [anon_sym_STAR_EQ] = ACTIONS(4247),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4247),
    [anon_sym_SLASH_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4247),
    [anon_sym_AMP_EQ] = ACTIONS(4247),
    [anon_sym_PERCENT_EQ] = ACTIONS(4247),
    [anon_sym_GT_GT_EQ] = ACTIONS(4247),
    [anon_sym_LT_LT_EQ] = ACTIONS(4247),
    [anon_sym_CARET_EQ] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(11917),
    [anon_sym_DOT_DOT] = ACTIONS(11919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11921),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(11923),
    [anon_sym_AMP_AMP] = ACTIONS(11923),
    [anon_sym_LT_LT] = ACTIONS(11925),
    [anon_sym_GT_GT] = ACTIONS(11925),
    [anon_sym_EQ_EQ] = ACTIONS(11923),
    [anon_sym_BANG_EQ] = ACTIONS(11927),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11927),
    [anon_sym_LT_EQ_GT] = ACTIONS(11927),
    [anon_sym_EQ_TILDE] = ACTIONS(11927),
    [anon_sym_BANG_TILDE] = ACTIONS(11927),
    [anon_sym_LT_EQ] = ACTIONS(11915),
    [anon_sym_GT] = ACTIONS(11915),
    [anon_sym_GT_EQ] = ACTIONS(11929),
    [anon_sym_CARET] = ACTIONS(11909),
    [anon_sym_PLUS] = ACTIONS(11931),
    [anon_sym_SLASH] = ACTIONS(11911),
    [anon_sym_PERCENT] = ACTIONS(11911),
    [sym_comment] = ACTIONS(87),
  },
  [5997] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(8389),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(5994),
    [sym_scope_resolution] = STATE(5992),
    [sym_call] = STATE(5992),
    [sym_method_call] = STATE(5994),
    [sym_assignment] = STATE(8389),
    [sym_operator_assignment] = STATE(8389),
    [sym_conditional] = STATE(8389),
    [sym_range] = STATE(8389),
    [sym_binary] = STATE(8389),
    [sym_unary] = STATE(8389),
    [sym_left_assignment_list] = STATE(5993),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5994),
    [sym__variable] = STATE(5992),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(5994),
    [sym_false] = STATE(5994),
    [sym_nil] = STATE(5994),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(5995),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(9306),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(9308),
    [anon_sym_yield] = ACTIONS(9310),
    [anon_sym_break] = ACTIONS(9312),
    [anon_sym_next] = ACTIONS(9314),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(9316),
    [anon_sym_defined_QMARK] = ACTIONS(9318),
    [anon_sym_not] = ACTIONS(9320),
    [anon_sym_BANG] = ACTIONS(9322),
    [anon_sym_TILDE] = ACTIONS(9322),
    [sym_constant] = ACTIONS(9324),
    [sym_identifier] = ACTIONS(9324),
    [sym_instance_variable] = ACTIONS(9326),
    [sym_class_variable] = ACTIONS(9326),
    [sym_global_variable] = ACTIONS(9326),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(9324),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9324),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [5998] = {
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(11905),
    [sym__binary_star] = ACTIONS(11907),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(11909),
    [anon_sym_STAR_STAR] = ACTIONS(11911),
    [anon_sym_AMP] = ACTIONS(11913),
    [anon_sym_EQ] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(11915),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_RBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_PLUS_EQ] = ACTIONS(3281),
    [anon_sym_DASH_EQ] = ACTIONS(3281),
    [anon_sym_STAR_EQ] = ACTIONS(3281),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3281),
    [anon_sym_SLASH_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3281),
    [anon_sym_AMP_EQ] = ACTIONS(3281),
    [anon_sym_PERCENT_EQ] = ACTIONS(3281),
    [anon_sym_GT_GT_EQ] = ACTIONS(3281),
    [anon_sym_LT_LT_EQ] = ACTIONS(3281),
    [anon_sym_CARET_EQ] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(11917),
    [anon_sym_DOT_DOT] = ACTIONS(11919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11921),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(11923),
    [anon_sym_AMP_AMP] = ACTIONS(11923),
    [anon_sym_LT_LT] = ACTIONS(11925),
    [anon_sym_GT_GT] = ACTIONS(11925),
    [anon_sym_EQ_EQ] = ACTIONS(11923),
    [anon_sym_BANG_EQ] = ACTIONS(11927),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11927),
    [anon_sym_LT_EQ_GT] = ACTIONS(11927),
    [anon_sym_EQ_TILDE] = ACTIONS(11927),
    [anon_sym_BANG_TILDE] = ACTIONS(11927),
    [anon_sym_LT_EQ] = ACTIONS(11915),
    [anon_sym_GT] = ACTIONS(11915),
    [anon_sym_GT_EQ] = ACTIONS(11929),
    [anon_sym_CARET] = ACTIONS(11909),
    [anon_sym_PLUS] = ACTIONS(11931),
    [anon_sym_SLASH] = ACTIONS(11911),
    [anon_sym_PERCENT] = ACTIONS(11911),
    [sym_comment] = ACTIONS(87),
  },
  [5999] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(8390),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(5994),
    [sym_scope_resolution] = STATE(5992),
    [sym_call] = STATE(5992),
    [sym_method_call] = STATE(5994),
    [sym_assignment] = STATE(8390),
    [sym_operator_assignment] = STATE(8390),
    [sym_conditional] = STATE(8390),
    [sym_range] = STATE(8390),
    [sym_binary] = STATE(8390),
    [sym_unary] = STATE(8390),
    [sym_left_assignment_list] = STATE(5993),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5994),
    [sym__variable] = STATE(5992),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(5994),
    [sym_false] = STATE(5994),
    [sym_nil] = STATE(5994),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(5995),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(9306),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(9308),
    [anon_sym_yield] = ACTIONS(9310),
    [anon_sym_break] = ACTIONS(9312),
    [anon_sym_next] = ACTIONS(9314),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(9316),
    [anon_sym_defined_QMARK] = ACTIONS(9318),
    [anon_sym_not] = ACTIONS(9320),
    [anon_sym_BANG] = ACTIONS(9322),
    [anon_sym_TILDE] = ACTIONS(9322),
    [sym_constant] = ACTIONS(9324),
    [sym_identifier] = ACTIONS(9324),
    [sym_instance_variable] = ACTIONS(9326),
    [sym_class_variable] = ACTIONS(9326),
    [sym_global_variable] = ACTIONS(9326),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(9324),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9324),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [6000] = {
    [sym_heredoc_body] = STATE(8391),
    [aux_sym_call_repeat1] = STATE(8391),
    [sym__heredoc_body_start] = ACTIONS(6569),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_RBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [6001] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3336),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1384),
    [sym_scope_resolution] = STATE(1378),
    [sym_call] = STATE(1378),
    [sym_method_call] = STATE(1384),
    [sym__argument] = STATE(6674),
    [sym_splat_argument] = STATE(6674),
    [sym_hash_splat_argument] = STATE(6674),
    [sym_block_argument] = STATE(6674),
    [sym_assignment] = STATE(3336),
    [sym_operator_assignment] = STATE(3336),
    [sym_conditional] = STATE(3336),
    [sym_range] = STATE(3336),
    [sym_binary] = STATE(3336),
    [sym_unary] = STATE(3336),
    [sym_left_assignment_list] = STATE(1383),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1384),
    [sym__variable] = STATE(1378),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1384),
    [sym_false] = STATE(1384),
    [sym_nil] = STATE(1384),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3339),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_heredoc_body] = STATE(8392),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(6674),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(5563),
    [sym__splat_star] = ACTIONS(5565),
    [sym__unary_minus] = ACTIONS(2399),
    [sym__identifier_hash_key] = ACTIONS(5567),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11939),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2405),
    [anon_sym_yield] = ACTIONS(2407),
    [anon_sym_break] = ACTIONS(2409),
    [anon_sym_next] = ACTIONS(2411),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(5673),
    [anon_sym_defined_QMARK] = ACTIONS(2415),
    [anon_sym_not] = ACTIONS(2417),
    [anon_sym_BANG] = ACTIONS(2421),
    [anon_sym_TILDE] = ACTIONS(2421),
    [sym_constant] = ACTIONS(5569),
    [sym_identifier] = ACTIONS(5569),
    [sym_instance_variable] = ACTIONS(2425),
    [sym_class_variable] = ACTIONS(2425),
    [sym_global_variable] = ACTIONS(2425),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2427),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2427),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6002] = {
    [sym_heredoc_body] = STATE(8393),
    [aux_sym_call_repeat1] = STATE(8393),
    [aux_sym_argument_list_repeat1] = STATE(8394),
    [sym__heredoc_body_start] = ACTIONS(6569),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(9332),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_RBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [6003] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(8395),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(1287),
    [sym_scope_resolution] = STATE(1285),
    [sym_call] = STATE(1285),
    [sym_method_call] = STATE(1287),
    [sym_assignment] = STATE(8395),
    [sym_operator_assignment] = STATE(8395),
    [sym_conditional] = STATE(8395),
    [sym_range] = STATE(8395),
    [sym_binary] = STATE(8395),
    [sym_unary] = STATE(8395),
    [sym_left_assignment_list] = STATE(1286),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1287),
    [sym__variable] = STATE(1285),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(1287),
    [sym_false] = STATE(1287),
    [sym_nil] = STATE(1287),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(1288),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(2281),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2283),
    [anon_sym_yield] = ACTIONS(2285),
    [anon_sym_break] = ACTIONS(2287),
    [anon_sym_next] = ACTIONS(2289),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2291),
    [anon_sym_defined_QMARK] = ACTIONS(2293),
    [anon_sym_not] = ACTIONS(2295),
    [anon_sym_BANG] = ACTIONS(2297),
    [anon_sym_TILDE] = ACTIONS(2297),
    [sym_constant] = ACTIONS(2299),
    [sym_identifier] = ACTIONS(2299),
    [sym_instance_variable] = ACTIONS(2301),
    [sym_class_variable] = ACTIONS(2301),
    [sym_global_variable] = ACTIONS(2301),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2299),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2299),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6004] = {
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(5535),
    [sym__binary_star] = ACTIONS(5537),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5537),
    [anon_sym_AMP] = ACTIONS(5541),
    [anon_sym_LT] = ACTIONS(5543),
    [anon_sym_RBRACK] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(5545),
    [anon_sym_DOT_DOT] = ACTIONS(5547),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5549),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(5553),
    [anon_sym_AMP_AMP] = ACTIONS(5553),
    [anon_sym_LT_LT] = ACTIONS(5555),
    [anon_sym_GT_GT] = ACTIONS(5555),
    [anon_sym_EQ_EQ] = ACTIONS(5557),
    [anon_sym_BANG_EQ] = ACTIONS(5553),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5553),
    [anon_sym_LT_EQ_GT] = ACTIONS(5553),
    [anon_sym_EQ_TILDE] = ACTIONS(5553),
    [anon_sym_BANG_TILDE] = ACTIONS(5553),
    [anon_sym_LT_EQ] = ACTIONS(5543),
    [anon_sym_GT] = ACTIONS(5543),
    [anon_sym_GT_EQ] = ACTIONS(5559),
    [anon_sym_CARET] = ACTIONS(5561),
    [anon_sym_PLUS] = ACTIONS(5535),
    [anon_sym_SLASH] = ACTIONS(5537),
    [anon_sym_PERCENT] = ACTIONS(5537),
    [sym_comment] = ACTIONS(87),
  },
  [6005] = {
    [aux_sym_exceptions_repeat1] = STATE(8397),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RBRACK] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [6006] = {
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(5535),
    [sym__binary_star] = ACTIONS(5537),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5537),
    [anon_sym_AMP] = ACTIONS(5541),
    [anon_sym_LT] = ACTIONS(5543),
    [anon_sym_RBRACK] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(5545),
    [anon_sym_DOT_DOT] = ACTIONS(5547),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5549),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(5553),
    [anon_sym_AMP_AMP] = ACTIONS(5553),
    [anon_sym_LT_LT] = ACTIONS(5555),
    [anon_sym_GT_GT] = ACTIONS(5555),
    [anon_sym_EQ_EQ] = ACTIONS(5557),
    [anon_sym_BANG_EQ] = ACTIONS(5553),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5553),
    [anon_sym_LT_EQ_GT] = ACTIONS(5553),
    [anon_sym_EQ_TILDE] = ACTIONS(5553),
    [anon_sym_BANG_TILDE] = ACTIONS(5553),
    [anon_sym_LT_EQ] = ACTIONS(5543),
    [anon_sym_GT] = ACTIONS(5543),
    [anon_sym_GT_EQ] = ACTIONS(5559),
    [anon_sym_CARET] = ACTIONS(5561),
    [anon_sym_PLUS] = ACTIONS(5535),
    [anon_sym_SLASH] = ACTIONS(5537),
    [anon_sym_PERCENT] = ACTIONS(5537),
    [sym_comment] = ACTIONS(87),
  },
  [6007] = {
    [sym_string] = STATE(6007),
    [aux_sym_chained_string_repeat1] = STATE(6007),
    [sym__string_start] = ACTIONS(9407),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_RBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [6008] = {
    [sym__heredoc_body_start] = ACTIONS(7162),
    [sym__binary_minus] = ACTIONS(7162),
    [sym__binary_star] = ACTIONS(7162),
    [anon_sym_LBRACE] = ACTIONS(7162),
    [anon_sym_RBRACE] = ACTIONS(7162),
    [anon_sym_RPAREN] = ACTIONS(7162),
    [anon_sym_DOT] = ACTIONS(7164),
    [anon_sym_COMMA] = ACTIONS(7162),
    [anon_sym_PIPE] = ACTIONS(7164),
    [anon_sym_SEMI] = ACTIONS(7162),
    [anon_sym_STAR_STAR] = ACTIONS(7162),
    [anon_sym_AMP] = ACTIONS(7164),
    [anon_sym_EQ] = ACTIONS(7164),
    [anon_sym_LT] = ACTIONS(7164),
    [anon_sym_if] = ACTIONS(7162),
    [anon_sym_unless] = ACTIONS(7162),
    [anon_sym_while] = ACTIONS(7162),
    [anon_sym_until] = ACTIONS(7162),
    [anon_sym_rescue] = ACTIONS(7162),
    [anon_sym_in] = ACTIONS(7162),
    [anon_sym_do] = ACTIONS(7162),
    [anon_sym_EQ_GT] = ACTIONS(7162),
    [anon_sym_LBRACK] = ACTIONS(7162),
    [anon_sym_RBRACK] = ACTIONS(7162),
    [anon_sym_COLON_COLON2] = ACTIONS(7162),
    [anon_sym_AMP_DOT] = ACTIONS(7162),
    [anon_sym_QMARK] = ACTIONS(7162),
    [anon_sym_COLON2] = ACTIONS(7164),
    [anon_sym_DOT_DOT] = ACTIONS(7164),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7162),
    [anon_sym_and] = ACTIONS(7162),
    [anon_sym_or] = ACTIONS(7162),
    [anon_sym_PIPE_PIPE] = ACTIONS(7162),
    [anon_sym_AMP_AMP] = ACTIONS(7162),
    [anon_sym_LT_LT] = ACTIONS(7162),
    [anon_sym_GT_GT] = ACTIONS(7162),
    [anon_sym_EQ_EQ] = ACTIONS(7164),
    [anon_sym_BANG_EQ] = ACTIONS(7162),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7162),
    [anon_sym_LT_EQ_GT] = ACTIONS(7162),
    [anon_sym_EQ_TILDE] = ACTIONS(7162),
    [anon_sym_BANG_TILDE] = ACTIONS(7162),
    [anon_sym_LT_EQ] = ACTIONS(7164),
    [anon_sym_GT] = ACTIONS(7164),
    [anon_sym_GT_EQ] = ACTIONS(7162),
    [anon_sym_CARET] = ACTIONS(7162),
    [anon_sym_PLUS] = ACTIONS(7162),
    [anon_sym_SLASH] = ACTIONS(7162),
    [anon_sym_PERCENT] = ACTIONS(7162),
    [sym_comment] = ACTIONS(87),
  },
  [6009] = {
    [anon_sym_DOT] = ACTIONS(11941),
    [anon_sym_COLON_COLON] = ACTIONS(11941),
    [sym_comment] = ACTIONS(87),
  },
  [6010] = {
    [sym__heredoc_body_start] = ACTIONS(7314),
    [sym__binary_minus] = ACTIONS(7314),
    [sym__binary_star] = ACTIONS(7314),
    [anon_sym_LBRACE] = ACTIONS(7314),
    [anon_sym_RBRACE] = ACTIONS(7314),
    [anon_sym_RPAREN] = ACTIONS(7314),
    [anon_sym_DOT] = ACTIONS(7316),
    [anon_sym_COMMA] = ACTIONS(7314),
    [anon_sym_PIPE] = ACTIONS(7316),
    [anon_sym_SEMI] = ACTIONS(7314),
    [anon_sym_STAR_STAR] = ACTIONS(7314),
    [anon_sym_AMP] = ACTIONS(7316),
    [anon_sym_EQ] = ACTIONS(7316),
    [anon_sym_LT] = ACTIONS(7316),
    [anon_sym_if] = ACTIONS(7314),
    [anon_sym_unless] = ACTIONS(7314),
    [anon_sym_while] = ACTIONS(7314),
    [anon_sym_until] = ACTIONS(7314),
    [anon_sym_rescue] = ACTIONS(7314),
    [anon_sym_in] = ACTIONS(7314),
    [anon_sym_do] = ACTIONS(7314),
    [anon_sym_EQ_GT] = ACTIONS(7314),
    [anon_sym_LBRACK] = ACTIONS(7314),
    [anon_sym_RBRACK] = ACTIONS(7314),
    [anon_sym_COLON_COLON2] = ACTIONS(7314),
    [anon_sym_AMP_DOT] = ACTIONS(7314),
    [anon_sym_QMARK] = ACTIONS(7314),
    [anon_sym_COLON2] = ACTIONS(7316),
    [anon_sym_DOT_DOT] = ACTIONS(7316),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7314),
    [anon_sym_and] = ACTIONS(7314),
    [anon_sym_or] = ACTIONS(7314),
    [anon_sym_PIPE_PIPE] = ACTIONS(7314),
    [anon_sym_AMP_AMP] = ACTIONS(7314),
    [anon_sym_LT_LT] = ACTIONS(7314),
    [anon_sym_GT_GT] = ACTIONS(7314),
    [anon_sym_EQ_EQ] = ACTIONS(7316),
    [anon_sym_BANG_EQ] = ACTIONS(7314),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7314),
    [anon_sym_LT_EQ_GT] = ACTIONS(7314),
    [anon_sym_EQ_TILDE] = ACTIONS(7314),
    [anon_sym_BANG_TILDE] = ACTIONS(7314),
    [anon_sym_LT_EQ] = ACTIONS(7316),
    [anon_sym_GT] = ACTIONS(7316),
    [anon_sym_GT_EQ] = ACTIONS(7314),
    [anon_sym_CARET] = ACTIONS(7314),
    [anon_sym_PLUS] = ACTIONS(7314),
    [anon_sym_SLASH] = ACTIONS(7314),
    [anon_sym_PERCENT] = ACTIONS(7314),
    [sym_comment] = ACTIONS(87),
  },
  [6011] = {
    [sym__heredoc_body_start] = ACTIONS(7330),
    [sym__binary_minus] = ACTIONS(7330),
    [sym__binary_star] = ACTIONS(7330),
    [anon_sym_LBRACE] = ACTIONS(7330),
    [anon_sym_RBRACE] = ACTIONS(7330),
    [anon_sym_RPAREN] = ACTIONS(7330),
    [anon_sym_DOT] = ACTIONS(7332),
    [anon_sym_COMMA] = ACTIONS(7330),
    [anon_sym_PIPE] = ACTIONS(7332),
    [anon_sym_SEMI] = ACTIONS(7330),
    [anon_sym_STAR_STAR] = ACTIONS(7330),
    [anon_sym_AMP] = ACTIONS(7332),
    [anon_sym_EQ] = ACTIONS(7332),
    [anon_sym_LT] = ACTIONS(7332),
    [anon_sym_if] = ACTIONS(7330),
    [anon_sym_unless] = ACTIONS(7330),
    [anon_sym_while] = ACTIONS(7330),
    [anon_sym_until] = ACTIONS(7330),
    [anon_sym_rescue] = ACTIONS(7330),
    [anon_sym_in] = ACTIONS(7330),
    [anon_sym_do] = ACTIONS(7330),
    [anon_sym_EQ_GT] = ACTIONS(7330),
    [anon_sym_LBRACK] = ACTIONS(7330),
    [anon_sym_RBRACK] = ACTIONS(7330),
    [anon_sym_COLON_COLON2] = ACTIONS(7330),
    [anon_sym_AMP_DOT] = ACTIONS(7330),
    [anon_sym_QMARK] = ACTIONS(7330),
    [anon_sym_COLON2] = ACTIONS(7332),
    [anon_sym_DOT_DOT] = ACTIONS(7332),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7330),
    [anon_sym_and] = ACTIONS(7330),
    [anon_sym_or] = ACTIONS(7330),
    [anon_sym_PIPE_PIPE] = ACTIONS(7330),
    [anon_sym_AMP_AMP] = ACTIONS(7330),
    [anon_sym_LT_LT] = ACTIONS(7330),
    [anon_sym_GT_GT] = ACTIONS(7330),
    [anon_sym_EQ_EQ] = ACTIONS(7332),
    [anon_sym_BANG_EQ] = ACTIONS(7330),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7330),
    [anon_sym_LT_EQ_GT] = ACTIONS(7330),
    [anon_sym_EQ_TILDE] = ACTIONS(7330),
    [anon_sym_BANG_TILDE] = ACTIONS(7330),
    [anon_sym_LT_EQ] = ACTIONS(7332),
    [anon_sym_GT] = ACTIONS(7332),
    [anon_sym_GT_EQ] = ACTIONS(7330),
    [anon_sym_CARET] = ACTIONS(7330),
    [anon_sym_PLUS] = ACTIONS(7330),
    [anon_sym_SLASH] = ACTIONS(7330),
    [anon_sym_PERCENT] = ACTIONS(7330),
    [sym_comment] = ACTIONS(87),
  },
  [6012] = {
    [sym__statements] = STATE(1334),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(1335),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(1336),
    [sym_rescue] = STATE(1337),
    [sym__body_statement] = STATE(8399),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(11943),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6013] = {
    [sym__statements] = STATE(1334),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(1335),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(1336),
    [sym_rescue] = STATE(1337),
    [sym__body_statement] = STATE(8400),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(11945),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6014] = {
    [sym__heredoc_body_start] = ACTIONS(7764),
    [sym__binary_minus] = ACTIONS(7764),
    [sym__binary_star] = ACTIONS(7764),
    [anon_sym_LBRACE] = ACTIONS(7764),
    [anon_sym_RBRACE] = ACTIONS(7764),
    [anon_sym_RPAREN] = ACTIONS(7764),
    [anon_sym_DOT] = ACTIONS(7766),
    [anon_sym_COMMA] = ACTIONS(7764),
    [anon_sym_PIPE] = ACTIONS(7766),
    [anon_sym_SEMI] = ACTIONS(7764),
    [anon_sym_STAR_STAR] = ACTIONS(7764),
    [anon_sym_AMP] = ACTIONS(7766),
    [anon_sym_EQ] = ACTIONS(7766),
    [anon_sym_LT] = ACTIONS(7766),
    [anon_sym_if] = ACTIONS(7764),
    [anon_sym_unless] = ACTIONS(7764),
    [anon_sym_while] = ACTIONS(7764),
    [anon_sym_until] = ACTIONS(7764),
    [anon_sym_rescue] = ACTIONS(7764),
    [anon_sym_in] = ACTIONS(7764),
    [anon_sym_do] = ACTIONS(7764),
    [anon_sym_EQ_GT] = ACTIONS(7764),
    [anon_sym_LBRACK] = ACTIONS(7764),
    [anon_sym_RBRACK] = ACTIONS(7764),
    [anon_sym_COLON_COLON2] = ACTIONS(7764),
    [anon_sym_AMP_DOT] = ACTIONS(7764),
    [anon_sym_QMARK] = ACTIONS(7764),
    [anon_sym_COLON2] = ACTIONS(7766),
    [anon_sym_DOT_DOT] = ACTIONS(7766),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7764),
    [anon_sym_and] = ACTIONS(7764),
    [anon_sym_or] = ACTIONS(7764),
    [anon_sym_PIPE_PIPE] = ACTIONS(7764),
    [anon_sym_AMP_AMP] = ACTIONS(7764),
    [anon_sym_LT_LT] = ACTIONS(7764),
    [anon_sym_GT_GT] = ACTIONS(7764),
    [anon_sym_EQ_EQ] = ACTIONS(7766),
    [anon_sym_BANG_EQ] = ACTIONS(7764),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7764),
    [anon_sym_LT_EQ_GT] = ACTIONS(7764),
    [anon_sym_EQ_TILDE] = ACTIONS(7764),
    [anon_sym_BANG_TILDE] = ACTIONS(7764),
    [anon_sym_LT_EQ] = ACTIONS(7766),
    [anon_sym_GT] = ACTIONS(7766),
    [anon_sym_GT_EQ] = ACTIONS(7764),
    [anon_sym_CARET] = ACTIONS(7764),
    [anon_sym_PLUS] = ACTIONS(7764),
    [anon_sym_SLASH] = ACTIONS(7764),
    [anon_sym_PERCENT] = ACTIONS(7764),
    [sym_comment] = ACTIONS(87),
  },
  [6015] = {
    [sym__heredoc_body_start] = ACTIONS(7818),
    [sym__binary_minus] = ACTIONS(7818),
    [sym__binary_star] = ACTIONS(7818),
    [anon_sym_LBRACE] = ACTIONS(7818),
    [anon_sym_RBRACE] = ACTIONS(7818),
    [anon_sym_RPAREN] = ACTIONS(7818),
    [anon_sym_DOT] = ACTIONS(7820),
    [anon_sym_COMMA] = ACTIONS(7818),
    [anon_sym_PIPE] = ACTIONS(7820),
    [anon_sym_SEMI] = ACTIONS(7818),
    [anon_sym_STAR_STAR] = ACTIONS(7818),
    [anon_sym_AMP] = ACTIONS(7820),
    [anon_sym_EQ] = ACTIONS(7820),
    [anon_sym_LT] = ACTIONS(7820),
    [anon_sym_if] = ACTIONS(7818),
    [anon_sym_unless] = ACTIONS(7818),
    [anon_sym_while] = ACTIONS(7818),
    [anon_sym_until] = ACTIONS(7818),
    [anon_sym_rescue] = ACTIONS(7818),
    [anon_sym_in] = ACTIONS(7818),
    [anon_sym_do] = ACTIONS(7818),
    [anon_sym_EQ_GT] = ACTIONS(7818),
    [anon_sym_LBRACK] = ACTIONS(7818),
    [anon_sym_RBRACK] = ACTIONS(7818),
    [anon_sym_COLON_COLON2] = ACTIONS(7818),
    [anon_sym_AMP_DOT] = ACTIONS(7818),
    [anon_sym_QMARK] = ACTIONS(7818),
    [anon_sym_COLON2] = ACTIONS(7820),
    [anon_sym_DOT_DOT] = ACTIONS(7820),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7818),
    [anon_sym_and] = ACTIONS(7818),
    [anon_sym_or] = ACTIONS(7818),
    [anon_sym_PIPE_PIPE] = ACTIONS(7818),
    [anon_sym_AMP_AMP] = ACTIONS(7818),
    [anon_sym_LT_LT] = ACTIONS(7818),
    [anon_sym_GT_GT] = ACTIONS(7818),
    [anon_sym_EQ_EQ] = ACTIONS(7820),
    [anon_sym_BANG_EQ] = ACTIONS(7818),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7818),
    [anon_sym_LT_EQ_GT] = ACTIONS(7818),
    [anon_sym_EQ_TILDE] = ACTIONS(7818),
    [anon_sym_BANG_TILDE] = ACTIONS(7818),
    [anon_sym_LT_EQ] = ACTIONS(7820),
    [anon_sym_GT] = ACTIONS(7820),
    [anon_sym_GT_EQ] = ACTIONS(7818),
    [anon_sym_CARET] = ACTIONS(7818),
    [anon_sym_PLUS] = ACTIONS(7818),
    [anon_sym_SLASH] = ACTIONS(7818),
    [anon_sym_PERCENT] = ACTIONS(7818),
    [sym_comment] = ACTIONS(87),
  },
  [6016] = {
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(5597),
    [sym__binary_star] = ACTIONS(5599),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(5601),
    [anon_sym_STAR_STAR] = ACTIONS(5599),
    [anon_sym_AMP] = ACTIONS(5603),
    [anon_sym_LT] = ACTIONS(5605),
    [anon_sym_EQ_GT] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_RBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(5607),
    [anon_sym_DOT_DOT] = ACTIONS(5609),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5611),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(5613),
    [anon_sym_AMP_AMP] = ACTIONS(5613),
    [anon_sym_LT_LT] = ACTIONS(5615),
    [anon_sym_GT_GT] = ACTIONS(5615),
    [anon_sym_EQ_EQ] = ACTIONS(5617),
    [anon_sym_BANG_EQ] = ACTIONS(5613),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5613),
    [anon_sym_LT_EQ_GT] = ACTIONS(5613),
    [anon_sym_EQ_TILDE] = ACTIONS(5613),
    [anon_sym_BANG_TILDE] = ACTIONS(5613),
    [anon_sym_LT_EQ] = ACTIONS(5605),
    [anon_sym_GT] = ACTIONS(5605),
    [anon_sym_GT_EQ] = ACTIONS(5619),
    [anon_sym_CARET] = ACTIONS(5621),
    [anon_sym_PLUS] = ACTIONS(5597),
    [anon_sym_SLASH] = ACTIONS(5599),
    [anon_sym_PERCENT] = ACTIONS(5599),
    [sym_comment] = ACTIONS(87),
  },
  [6017] = {
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(5597),
    [sym__binary_star] = ACTIONS(5599),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(5601),
    [anon_sym_STAR_STAR] = ACTIONS(5599),
    [anon_sym_AMP] = ACTIONS(5603),
    [anon_sym_LT] = ACTIONS(5605),
    [anon_sym_EQ_GT] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_RBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(5607),
    [anon_sym_DOT_DOT] = ACTIONS(5609),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5611),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(5613),
    [anon_sym_AMP_AMP] = ACTIONS(5613),
    [anon_sym_LT_LT] = ACTIONS(5615),
    [anon_sym_GT_GT] = ACTIONS(5615),
    [anon_sym_EQ_EQ] = ACTIONS(5617),
    [anon_sym_BANG_EQ] = ACTIONS(5613),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5613),
    [anon_sym_LT_EQ_GT] = ACTIONS(5613),
    [anon_sym_EQ_TILDE] = ACTIONS(5613),
    [anon_sym_BANG_TILDE] = ACTIONS(5613),
    [anon_sym_LT_EQ] = ACTIONS(5605),
    [anon_sym_GT] = ACTIONS(5605),
    [anon_sym_GT_EQ] = ACTIONS(5619),
    [anon_sym_CARET] = ACTIONS(5621),
    [anon_sym_PLUS] = ACTIONS(5597),
    [anon_sym_SLASH] = ACTIONS(5599),
    [anon_sym_PERCENT] = ACTIONS(5599),
    [sym_comment] = ACTIONS(87),
  },
  [6018] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5599),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(5599),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_RBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5599),
    [anon_sym_PERCENT] = ACTIONS(5599),
    [sym_comment] = ACTIONS(87),
  },
  [6019] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(5599),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_RBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [6020] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5597),
    [sym__binary_star] = ACTIONS(5599),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(5599),
    [anon_sym_AMP] = ACTIONS(5603),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_RBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5615),
    [anon_sym_GT_GT] = ACTIONS(5615),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5597),
    [anon_sym_SLASH] = ACTIONS(5599),
    [anon_sym_PERCENT] = ACTIONS(5599),
    [sym_comment] = ACTIONS(87),
  },
  [6021] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5597),
    [sym__binary_star] = ACTIONS(5599),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(5599),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_RBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5615),
    [anon_sym_GT_GT] = ACTIONS(5615),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5597),
    [anon_sym_SLASH] = ACTIONS(5599),
    [anon_sym_PERCENT] = ACTIONS(5599),
    [sym_comment] = ACTIONS(87),
  },
  [6022] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5597),
    [sym__binary_star] = ACTIONS(5599),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5601),
    [anon_sym_STAR_STAR] = ACTIONS(5599),
    [anon_sym_AMP] = ACTIONS(5603),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_RBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5615),
    [anon_sym_GT_GT] = ACTIONS(5615),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5621),
    [anon_sym_PLUS] = ACTIONS(5597),
    [anon_sym_SLASH] = ACTIONS(5599),
    [anon_sym_PERCENT] = ACTIONS(5599),
    [sym_comment] = ACTIONS(87),
  },
  [6023] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(11947),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [6024] = {
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(5597),
    [sym__binary_star] = ACTIONS(5599),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(5601),
    [anon_sym_STAR_STAR] = ACTIONS(5599),
    [anon_sym_AMP] = ACTIONS(5603),
    [anon_sym_LT] = ACTIONS(5605),
    [anon_sym_EQ_GT] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_RBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(5609),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5611),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(5613),
    [anon_sym_AMP_AMP] = ACTIONS(5613),
    [anon_sym_LT_LT] = ACTIONS(5615),
    [anon_sym_GT_GT] = ACTIONS(5615),
    [anon_sym_EQ_EQ] = ACTIONS(5617),
    [anon_sym_BANG_EQ] = ACTIONS(5613),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5613),
    [anon_sym_LT_EQ_GT] = ACTIONS(5613),
    [anon_sym_EQ_TILDE] = ACTIONS(5613),
    [anon_sym_BANG_TILDE] = ACTIONS(5613),
    [anon_sym_LT_EQ] = ACTIONS(5605),
    [anon_sym_GT] = ACTIONS(5605),
    [anon_sym_GT_EQ] = ACTIONS(5619),
    [anon_sym_CARET] = ACTIONS(5621),
    [anon_sym_PLUS] = ACTIONS(5597),
    [anon_sym_SLASH] = ACTIONS(5599),
    [anon_sym_PERCENT] = ACTIONS(5599),
    [sym_comment] = ACTIONS(87),
  },
  [6025] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5597),
    [sym__binary_star] = ACTIONS(5599),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5601),
    [anon_sym_STAR_STAR] = ACTIONS(5599),
    [anon_sym_AMP] = ACTIONS(5603),
    [anon_sym_LT] = ACTIONS(5605),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_RBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5607),
    [anon_sym_DOT_DOT] = ACTIONS(5609),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5611),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5613),
    [anon_sym_AMP_AMP] = ACTIONS(5613),
    [anon_sym_LT_LT] = ACTIONS(5615),
    [anon_sym_GT_GT] = ACTIONS(5615),
    [anon_sym_EQ_EQ] = ACTIONS(5617),
    [anon_sym_BANG_EQ] = ACTIONS(5613),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5613),
    [anon_sym_LT_EQ_GT] = ACTIONS(5613),
    [anon_sym_EQ_TILDE] = ACTIONS(5613),
    [anon_sym_BANG_TILDE] = ACTIONS(5613),
    [anon_sym_LT_EQ] = ACTIONS(5605),
    [anon_sym_GT] = ACTIONS(5605),
    [anon_sym_GT_EQ] = ACTIONS(5619),
    [anon_sym_CARET] = ACTIONS(5621),
    [anon_sym_PLUS] = ACTIONS(5597),
    [anon_sym_SLASH] = ACTIONS(5599),
    [anon_sym_PERCENT] = ACTIONS(5599),
    [sym_comment] = ACTIONS(87),
  },
  [6026] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5597),
    [sym__binary_star] = ACTIONS(5599),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5601),
    [anon_sym_STAR_STAR] = ACTIONS(5599),
    [anon_sym_AMP] = ACTIONS(5603),
    [anon_sym_LT] = ACTIONS(5605),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_RBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5615),
    [anon_sym_GT_GT] = ACTIONS(5615),
    [anon_sym_EQ_EQ] = ACTIONS(5617),
    [anon_sym_BANG_EQ] = ACTIONS(5613),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5613),
    [anon_sym_LT_EQ_GT] = ACTIONS(5613),
    [anon_sym_EQ_TILDE] = ACTIONS(5613),
    [anon_sym_BANG_TILDE] = ACTIONS(5613),
    [anon_sym_LT_EQ] = ACTIONS(5605),
    [anon_sym_GT] = ACTIONS(5605),
    [anon_sym_GT_EQ] = ACTIONS(5619),
    [anon_sym_CARET] = ACTIONS(5621),
    [anon_sym_PLUS] = ACTIONS(5597),
    [anon_sym_SLASH] = ACTIONS(5599),
    [anon_sym_PERCENT] = ACTIONS(5599),
    [sym_comment] = ACTIONS(87),
  },
  [6027] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5597),
    [sym__binary_star] = ACTIONS(5599),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(5599),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_RBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5597),
    [anon_sym_SLASH] = ACTIONS(5599),
    [anon_sym_PERCENT] = ACTIONS(5599),
    [sym_comment] = ACTIONS(87),
  },
  [6028] = {
    [sym_heredoc_body] = STATE(6028),
    [aux_sym_call_repeat1] = STATE(6028),
    [sym__heredoc_body_start] = ACTIONS(10455),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_EQ_GT] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_RBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [6029] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(1317),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1322),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(1322),
    [sym__argument] = STATE(6908),
    [sym_splat_argument] = STATE(6908),
    [sym_hash_splat_argument] = STATE(6908),
    [sym_block_argument] = STATE(6908),
    [sym_assignment] = STATE(1317),
    [sym_operator_assignment] = STATE(1317),
    [sym_conditional] = STATE(1317),
    [sym_range] = STATE(1317),
    [sym_binary] = STATE(1317),
    [sym_unary] = STATE(1317),
    [sym_left_assignment_list] = STATE(1321),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1322),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1322),
    [sym_false] = STATE(1322),
    [sym_nil] = STATE(1322),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1323),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(6908),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(2321),
    [sym__splat_star] = ACTIONS(2323),
    [sym__unary_minus] = ACTIONS(2325),
    [sym__identifier_hash_key] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(9354),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5591),
    [anon_sym_defined_QMARK] = ACTIONS(2329),
    [anon_sym_not] = ACTIONS(2331),
    [anon_sym_BANG] = ACTIONS(2335),
    [anon_sym_TILDE] = ACTIONS(2335),
    [sym_constant] = ACTIONS(2337),
    [sym_identifier] = ACTIONS(2337),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6030] = {
    [sym_heredoc_body] = STATE(6028),
    [aux_sym_call_repeat1] = STATE(6028),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_EQ_GT] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_RBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [6031] = {
    [aux_sym_argument_list_repeat1] = STATE(6031),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(11949),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_STAR_STAR] = ACTIONS(7925),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_EQ_GT] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_RBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7925),
    [anon_sym_AMP_AMP] = ACTIONS(7925),
    [anon_sym_LT_LT] = ACTIONS(7925),
    [anon_sym_GT_GT] = ACTIONS(7925),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7925),
    [anon_sym_PLUS] = ACTIONS(7925),
    [anon_sym_SLASH] = ACTIONS(7925),
    [anon_sym_PERCENT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [6032] = {
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(5597),
    [sym__binary_star] = ACTIONS(5599),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(5601),
    [anon_sym_STAR_STAR] = ACTIONS(5599),
    [anon_sym_AMP] = ACTIONS(5603),
    [anon_sym_LT] = ACTIONS(5605),
    [anon_sym_EQ_GT] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_RBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(5607),
    [anon_sym_DOT_DOT] = ACTIONS(5609),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5611),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(5613),
    [anon_sym_AMP_AMP] = ACTIONS(5613),
    [anon_sym_LT_LT] = ACTIONS(5615),
    [anon_sym_GT_GT] = ACTIONS(5615),
    [anon_sym_EQ_EQ] = ACTIONS(5617),
    [anon_sym_BANG_EQ] = ACTIONS(5613),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5613),
    [anon_sym_LT_EQ_GT] = ACTIONS(5613),
    [anon_sym_EQ_TILDE] = ACTIONS(5613),
    [anon_sym_BANG_TILDE] = ACTIONS(5613),
    [anon_sym_LT_EQ] = ACTIONS(5605),
    [anon_sym_GT] = ACTIONS(5605),
    [anon_sym_GT_EQ] = ACTIONS(5619),
    [anon_sym_CARET] = ACTIONS(5621),
    [anon_sym_PLUS] = ACTIONS(5597),
    [anon_sym_SLASH] = ACTIONS(5599),
    [anon_sym_PERCENT] = ACTIONS(5599),
    [sym_comment] = ACTIONS(87),
  },
  [6033] = {
    [aux_sym_exceptions_repeat1] = STATE(8403),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_RBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [6034] = {
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(5597),
    [sym__binary_star] = ACTIONS(5599),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(5601),
    [anon_sym_STAR_STAR] = ACTIONS(5599),
    [anon_sym_AMP] = ACTIONS(5603),
    [anon_sym_LT] = ACTIONS(5605),
    [anon_sym_EQ_GT] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_RBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(5607),
    [anon_sym_DOT_DOT] = ACTIONS(5609),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5611),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(5613),
    [anon_sym_AMP_AMP] = ACTIONS(5613),
    [anon_sym_LT_LT] = ACTIONS(5615),
    [anon_sym_GT_GT] = ACTIONS(5615),
    [anon_sym_EQ_EQ] = ACTIONS(5617),
    [anon_sym_BANG_EQ] = ACTIONS(5613),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5613),
    [anon_sym_LT_EQ_GT] = ACTIONS(5613),
    [anon_sym_EQ_TILDE] = ACTIONS(5613),
    [anon_sym_BANG_TILDE] = ACTIONS(5613),
    [anon_sym_LT_EQ] = ACTIONS(5605),
    [anon_sym_GT] = ACTIONS(5605),
    [anon_sym_GT_EQ] = ACTIONS(5619),
    [anon_sym_CARET] = ACTIONS(5621),
    [anon_sym_PLUS] = ACTIONS(5597),
    [anon_sym_SLASH] = ACTIONS(5599),
    [anon_sym_PERCENT] = ACTIONS(5599),
    [sym_comment] = ACTIONS(87),
  },
  [6035] = {
    [sym__heredoc_body_start] = ACTIONS(8098),
    [sym__binary_minus] = ACTIONS(8098),
    [sym__binary_star] = ACTIONS(8098),
    [anon_sym_LBRACE] = ACTIONS(8098),
    [anon_sym_RBRACE] = ACTIONS(8098),
    [anon_sym_RPAREN] = ACTIONS(8098),
    [anon_sym_DOT] = ACTIONS(8100),
    [anon_sym_COMMA] = ACTIONS(8098),
    [anon_sym_PIPE] = ACTIONS(8100),
    [anon_sym_SEMI] = ACTIONS(8098),
    [anon_sym_STAR_STAR] = ACTIONS(8098),
    [anon_sym_AMP] = ACTIONS(8100),
    [anon_sym_EQ] = ACTIONS(8100),
    [anon_sym_LT] = ACTIONS(8100),
    [anon_sym_if] = ACTIONS(8098),
    [anon_sym_unless] = ACTIONS(8098),
    [anon_sym_while] = ACTIONS(8098),
    [anon_sym_until] = ACTIONS(8098),
    [anon_sym_rescue] = ACTIONS(8098),
    [anon_sym_in] = ACTIONS(8098),
    [anon_sym_do] = ACTIONS(8098),
    [anon_sym_EQ_GT] = ACTIONS(8098),
    [anon_sym_LBRACK] = ACTIONS(8098),
    [anon_sym_RBRACK] = ACTIONS(8098),
    [anon_sym_COLON_COLON2] = ACTIONS(8098),
    [anon_sym_AMP_DOT] = ACTIONS(8098),
    [anon_sym_QMARK] = ACTIONS(8098),
    [anon_sym_COLON2] = ACTIONS(8100),
    [anon_sym_DOT_DOT] = ACTIONS(8100),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8098),
    [anon_sym_and] = ACTIONS(8098),
    [anon_sym_or] = ACTIONS(8098),
    [anon_sym_PIPE_PIPE] = ACTIONS(8098),
    [anon_sym_AMP_AMP] = ACTIONS(8098),
    [anon_sym_LT_LT] = ACTIONS(8098),
    [anon_sym_GT_GT] = ACTIONS(8098),
    [anon_sym_EQ_EQ] = ACTIONS(8100),
    [anon_sym_BANG_EQ] = ACTIONS(8098),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8098),
    [anon_sym_LT_EQ_GT] = ACTIONS(8098),
    [anon_sym_EQ_TILDE] = ACTIONS(8098),
    [anon_sym_BANG_TILDE] = ACTIONS(8098),
    [anon_sym_LT_EQ] = ACTIONS(8100),
    [anon_sym_GT] = ACTIONS(8100),
    [anon_sym_GT_EQ] = ACTIONS(8098),
    [anon_sym_CARET] = ACTIONS(8098),
    [anon_sym_PLUS] = ACTIONS(8098),
    [anon_sym_SLASH] = ACTIONS(8098),
    [anon_sym_PERCENT] = ACTIONS(8098),
    [sym_comment] = ACTIONS(87),
  },
  [6036] = {
    [anon_sym_end] = ACTIONS(11952),
    [sym_comment] = ACTIONS(87),
  },
  [6037] = {
    [sym__heredoc_body_start] = ACTIONS(8284),
    [sym__binary_minus] = ACTIONS(8284),
    [sym__binary_star] = ACTIONS(8284),
    [anon_sym_LBRACE] = ACTIONS(8284),
    [anon_sym_RBRACE] = ACTIONS(8284),
    [anon_sym_RPAREN] = ACTIONS(8284),
    [anon_sym_DOT] = ACTIONS(8286),
    [anon_sym_COMMA] = ACTIONS(8284),
    [anon_sym_PIPE] = ACTIONS(8286),
    [anon_sym_SEMI] = ACTIONS(8284),
    [anon_sym_STAR_STAR] = ACTIONS(8284),
    [anon_sym_AMP] = ACTIONS(8286),
    [anon_sym_EQ] = ACTIONS(8286),
    [anon_sym_LT] = ACTIONS(8286),
    [anon_sym_if] = ACTIONS(8284),
    [anon_sym_unless] = ACTIONS(8284),
    [anon_sym_while] = ACTIONS(8284),
    [anon_sym_until] = ACTIONS(8284),
    [anon_sym_rescue] = ACTIONS(8284),
    [anon_sym_in] = ACTIONS(8284),
    [anon_sym_do] = ACTIONS(8284),
    [anon_sym_EQ_GT] = ACTIONS(8284),
    [anon_sym_LBRACK] = ACTIONS(8284),
    [anon_sym_RBRACK] = ACTIONS(8284),
    [anon_sym_COLON_COLON2] = ACTIONS(8284),
    [anon_sym_AMP_DOT] = ACTIONS(8284),
    [anon_sym_QMARK] = ACTIONS(8284),
    [anon_sym_COLON2] = ACTIONS(8286),
    [anon_sym_DOT_DOT] = ACTIONS(8286),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8284),
    [anon_sym_and] = ACTIONS(8284),
    [anon_sym_or] = ACTIONS(8284),
    [anon_sym_PIPE_PIPE] = ACTIONS(8284),
    [anon_sym_AMP_AMP] = ACTIONS(8284),
    [anon_sym_LT_LT] = ACTIONS(8284),
    [anon_sym_GT_GT] = ACTIONS(8284),
    [anon_sym_EQ_EQ] = ACTIONS(8286),
    [anon_sym_BANG_EQ] = ACTIONS(8284),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8284),
    [anon_sym_LT_EQ_GT] = ACTIONS(8284),
    [anon_sym_EQ_TILDE] = ACTIONS(8284),
    [anon_sym_BANG_TILDE] = ACTIONS(8284),
    [anon_sym_LT_EQ] = ACTIONS(8286),
    [anon_sym_GT] = ACTIONS(8286),
    [anon_sym_GT_EQ] = ACTIONS(8284),
    [anon_sym_CARET] = ACTIONS(8284),
    [anon_sym_PLUS] = ACTIONS(8284),
    [anon_sym_SLASH] = ACTIONS(8284),
    [anon_sym_PERCENT] = ACTIONS(8284),
    [sym_comment] = ACTIONS(87),
  },
  [6038] = {
    [anon_sym_end] = ACTIONS(11954),
    [sym_comment] = ACTIONS(87),
  },
  [6039] = {
    [sym__heredoc_body_start] = ACTIONS(8344),
    [sym__binary_minus] = ACTIONS(8344),
    [sym__binary_star] = ACTIONS(8344),
    [anon_sym_LBRACE] = ACTIONS(8344),
    [anon_sym_RBRACE] = ACTIONS(8344),
    [anon_sym_RPAREN] = ACTIONS(8344),
    [anon_sym_DOT] = ACTIONS(8346),
    [anon_sym_COMMA] = ACTIONS(8344),
    [anon_sym_PIPE] = ACTIONS(8346),
    [anon_sym_SEMI] = ACTIONS(8344),
    [anon_sym_STAR_STAR] = ACTIONS(8344),
    [anon_sym_AMP] = ACTIONS(8346),
    [anon_sym_EQ] = ACTIONS(8346),
    [anon_sym_LT] = ACTIONS(8346),
    [anon_sym_if] = ACTIONS(8344),
    [anon_sym_unless] = ACTIONS(8344),
    [anon_sym_while] = ACTIONS(8344),
    [anon_sym_until] = ACTIONS(8344),
    [anon_sym_rescue] = ACTIONS(8344),
    [anon_sym_in] = ACTIONS(8344),
    [anon_sym_do] = ACTIONS(8344),
    [anon_sym_EQ_GT] = ACTIONS(8344),
    [anon_sym_LBRACK] = ACTIONS(8344),
    [anon_sym_RBRACK] = ACTIONS(8344),
    [anon_sym_COLON_COLON2] = ACTIONS(8344),
    [anon_sym_AMP_DOT] = ACTIONS(8344),
    [anon_sym_QMARK] = ACTIONS(8344),
    [anon_sym_COLON2] = ACTIONS(8346),
    [anon_sym_DOT_DOT] = ACTIONS(8346),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8344),
    [anon_sym_and] = ACTIONS(8344),
    [anon_sym_or] = ACTIONS(8344),
    [anon_sym_PIPE_PIPE] = ACTIONS(8344),
    [anon_sym_AMP_AMP] = ACTIONS(8344),
    [anon_sym_LT_LT] = ACTIONS(8344),
    [anon_sym_GT_GT] = ACTIONS(8344),
    [anon_sym_EQ_EQ] = ACTIONS(8346),
    [anon_sym_BANG_EQ] = ACTIONS(8344),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8344),
    [anon_sym_LT_EQ_GT] = ACTIONS(8344),
    [anon_sym_EQ_TILDE] = ACTIONS(8344),
    [anon_sym_BANG_TILDE] = ACTIONS(8344),
    [anon_sym_LT_EQ] = ACTIONS(8346),
    [anon_sym_GT] = ACTIONS(8346),
    [anon_sym_GT_EQ] = ACTIONS(8344),
    [anon_sym_CARET] = ACTIONS(8344),
    [anon_sym_PLUS] = ACTIONS(8344),
    [anon_sym_SLASH] = ACTIONS(8344),
    [anon_sym_PERCENT] = ACTIONS(8344),
    [sym_comment] = ACTIONS(87),
  },
  [6040] = {
    [anon_sym_end] = ACTIONS(11956),
    [sym_comment] = ACTIONS(87),
  },
  [6041] = {
    [sym__heredoc_body_start] = ACTIONS(8420),
    [sym__binary_minus] = ACTIONS(8420),
    [sym__binary_star] = ACTIONS(8420),
    [anon_sym_LBRACE] = ACTIONS(8420),
    [anon_sym_RBRACE] = ACTIONS(8420),
    [anon_sym_RPAREN] = ACTIONS(8420),
    [anon_sym_DOT] = ACTIONS(8422),
    [anon_sym_COMMA] = ACTIONS(8420),
    [anon_sym_PIPE] = ACTIONS(8422),
    [anon_sym_SEMI] = ACTIONS(8420),
    [anon_sym_STAR_STAR] = ACTIONS(8420),
    [anon_sym_AMP] = ACTIONS(8422),
    [anon_sym_EQ] = ACTIONS(8422),
    [anon_sym_LT] = ACTIONS(8422),
    [anon_sym_if] = ACTIONS(8420),
    [anon_sym_unless] = ACTIONS(8420),
    [anon_sym_while] = ACTIONS(8420),
    [anon_sym_until] = ACTIONS(8420),
    [anon_sym_rescue] = ACTIONS(8420),
    [anon_sym_in] = ACTIONS(8420),
    [anon_sym_do] = ACTIONS(8420),
    [anon_sym_EQ_GT] = ACTIONS(8420),
    [anon_sym_LBRACK] = ACTIONS(8420),
    [anon_sym_RBRACK] = ACTIONS(8420),
    [anon_sym_COLON_COLON2] = ACTIONS(8420),
    [anon_sym_AMP_DOT] = ACTIONS(8420),
    [anon_sym_QMARK] = ACTIONS(8420),
    [anon_sym_COLON2] = ACTIONS(8422),
    [anon_sym_DOT_DOT] = ACTIONS(8422),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8420),
    [anon_sym_and] = ACTIONS(8420),
    [anon_sym_or] = ACTIONS(8420),
    [anon_sym_PIPE_PIPE] = ACTIONS(8420),
    [anon_sym_AMP_AMP] = ACTIONS(8420),
    [anon_sym_LT_LT] = ACTIONS(8420),
    [anon_sym_GT_GT] = ACTIONS(8420),
    [anon_sym_EQ_EQ] = ACTIONS(8422),
    [anon_sym_BANG_EQ] = ACTIONS(8420),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8420),
    [anon_sym_LT_EQ_GT] = ACTIONS(8420),
    [anon_sym_EQ_TILDE] = ACTIONS(8420),
    [anon_sym_BANG_TILDE] = ACTIONS(8420),
    [anon_sym_LT_EQ] = ACTIONS(8422),
    [anon_sym_GT] = ACTIONS(8422),
    [anon_sym_GT_EQ] = ACTIONS(8420),
    [anon_sym_CARET] = ACTIONS(8420),
    [anon_sym_PLUS] = ACTIONS(8420),
    [anon_sym_SLASH] = ACTIONS(8420),
    [anon_sym_PERCENT] = ACTIONS(8420),
    [sym_comment] = ACTIONS(87),
  },
  [6042] = {
    [anon_sym_end] = ACTIONS(11958),
    [sym_comment] = ACTIONS(87),
  },
  [6043] = {
    [sym__statements] = STATE(8409),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(11960),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6044] = {
    [sym__heredoc_body_start] = ACTIONS(8581),
    [sym__binary_minus] = ACTIONS(8581),
    [sym__binary_star] = ACTIONS(8581),
    [anon_sym_LBRACE] = ACTIONS(8581),
    [anon_sym_RBRACE] = ACTIONS(8581),
    [anon_sym_RPAREN] = ACTIONS(8581),
    [anon_sym_DOT] = ACTIONS(8583),
    [anon_sym_COMMA] = ACTIONS(8581),
    [anon_sym_PIPE] = ACTIONS(8583),
    [anon_sym_SEMI] = ACTIONS(8581),
    [anon_sym_STAR_STAR] = ACTIONS(8581),
    [anon_sym_AMP] = ACTIONS(8583),
    [anon_sym_EQ] = ACTIONS(8583),
    [anon_sym_LT] = ACTIONS(8583),
    [anon_sym_if] = ACTIONS(8581),
    [anon_sym_unless] = ACTIONS(8581),
    [anon_sym_while] = ACTIONS(8581),
    [anon_sym_until] = ACTIONS(8581),
    [anon_sym_rescue] = ACTIONS(8581),
    [anon_sym_in] = ACTIONS(8581),
    [anon_sym_do] = ACTIONS(8581),
    [anon_sym_EQ_GT] = ACTIONS(8581),
    [anon_sym_LBRACK] = ACTIONS(8581),
    [anon_sym_RBRACK] = ACTIONS(8581),
    [anon_sym_COLON_COLON2] = ACTIONS(8581),
    [anon_sym_AMP_DOT] = ACTIONS(8581),
    [anon_sym_QMARK] = ACTIONS(8581),
    [anon_sym_COLON2] = ACTIONS(8583),
    [anon_sym_DOT_DOT] = ACTIONS(8583),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8581),
    [anon_sym_and] = ACTIONS(8581),
    [anon_sym_or] = ACTIONS(8581),
    [anon_sym_PIPE_PIPE] = ACTIONS(8581),
    [anon_sym_AMP_AMP] = ACTIONS(8581),
    [anon_sym_LT_LT] = ACTIONS(8581),
    [anon_sym_GT_GT] = ACTIONS(8581),
    [anon_sym_EQ_EQ] = ACTIONS(8583),
    [anon_sym_BANG_EQ] = ACTIONS(8581),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8581),
    [anon_sym_LT_EQ_GT] = ACTIONS(8581),
    [anon_sym_EQ_TILDE] = ACTIONS(8581),
    [anon_sym_BANG_TILDE] = ACTIONS(8581),
    [anon_sym_LT_EQ] = ACTIONS(8583),
    [anon_sym_GT] = ACTIONS(8583),
    [anon_sym_GT_EQ] = ACTIONS(8581),
    [anon_sym_CARET] = ACTIONS(8581),
    [anon_sym_PLUS] = ACTIONS(8581),
    [anon_sym_SLASH] = ACTIONS(8581),
    [anon_sym_PERCENT] = ACTIONS(8581),
    [sym_comment] = ACTIONS(87),
  },
  [6045] = {
    [anon_sym_end] = ACTIONS(11962),
    [sym_comment] = ACTIONS(87),
  },
  [6046] = {
    [sym_when] = STATE(8412),
    [sym_else] = STATE(8411),
    [aux_sym_case_repeat1] = STATE(2987),
    [aux_sym_case_repeat2] = STATE(8412),
    [anon_sym_SEMI] = ACTIONS(4995),
    [anon_sym_end] = ACTIONS(11962),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [6047] = {
    [sym_when] = STATE(2988),
    [sym_else] = STATE(8411),
    [aux_sym_case_repeat2] = STATE(2988),
    [anon_sym_end] = ACTIONS(11962),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [6048] = {
    [sym__heredoc_body_start] = ACTIONS(9185),
    [sym__binary_minus] = ACTIONS(9185),
    [sym__binary_star] = ACTIONS(9185),
    [anon_sym_LBRACE] = ACTIONS(9185),
    [anon_sym_RBRACE] = ACTIONS(9185),
    [anon_sym_RPAREN] = ACTIONS(9185),
    [anon_sym_DOT] = ACTIONS(9187),
    [anon_sym_COMMA] = ACTIONS(9185),
    [anon_sym_PIPE] = ACTIONS(9187),
    [anon_sym_SEMI] = ACTIONS(9185),
    [anon_sym_STAR_STAR] = ACTIONS(9185),
    [anon_sym_AMP] = ACTIONS(9187),
    [anon_sym_EQ] = ACTIONS(9187),
    [anon_sym_LT] = ACTIONS(9187),
    [anon_sym_if] = ACTIONS(9185),
    [anon_sym_unless] = ACTIONS(9185),
    [anon_sym_while] = ACTIONS(9185),
    [anon_sym_until] = ACTIONS(9185),
    [anon_sym_rescue] = ACTIONS(9185),
    [anon_sym_in] = ACTIONS(9185),
    [anon_sym_do] = ACTIONS(9185),
    [anon_sym_EQ_GT] = ACTIONS(9185),
    [anon_sym_LBRACK] = ACTIONS(9185),
    [anon_sym_RBRACK] = ACTIONS(9185),
    [anon_sym_COLON_COLON2] = ACTIONS(9185),
    [anon_sym_AMP_DOT] = ACTIONS(9185),
    [anon_sym_QMARK] = ACTIONS(9185),
    [anon_sym_COLON2] = ACTIONS(9187),
    [anon_sym_DOT_DOT] = ACTIONS(9187),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9185),
    [anon_sym_and] = ACTIONS(9185),
    [anon_sym_or] = ACTIONS(9185),
    [anon_sym_PIPE_PIPE] = ACTIONS(9185),
    [anon_sym_AMP_AMP] = ACTIONS(9185),
    [anon_sym_LT_LT] = ACTIONS(9185),
    [anon_sym_GT_GT] = ACTIONS(9185),
    [anon_sym_EQ_EQ] = ACTIONS(9187),
    [anon_sym_BANG_EQ] = ACTIONS(9185),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9185),
    [anon_sym_LT_EQ_GT] = ACTIONS(9185),
    [anon_sym_EQ_TILDE] = ACTIONS(9185),
    [anon_sym_BANG_TILDE] = ACTIONS(9185),
    [anon_sym_LT_EQ] = ACTIONS(9187),
    [anon_sym_GT] = ACTIONS(9187),
    [anon_sym_GT_EQ] = ACTIONS(9185),
    [anon_sym_CARET] = ACTIONS(9185),
    [anon_sym_PLUS] = ACTIONS(9185),
    [anon_sym_SLASH] = ACTIONS(9185),
    [anon_sym_PERCENT] = ACTIONS(9185),
    [sym_comment] = ACTIONS(87),
  },
  [6049] = {
    [anon_sym_end] = ACTIONS(11964),
    [sym_comment] = ACTIONS(87),
  },
  [6050] = {
    [sym_ensure] = STATE(8414),
    [anon_sym_end] = ACTIONS(11964),
    [anon_sym_ensure] = ACTIONS(2169),
    [sym_comment] = ACTIONS(87),
  },
  [6051] = {
    [sym__heredoc_body_start] = ACTIONS(9426),
    [sym__binary_minus] = ACTIONS(9426),
    [sym__binary_star] = ACTIONS(9426),
    [anon_sym_LBRACE] = ACTIONS(9426),
    [anon_sym_RBRACE] = ACTIONS(9426),
    [anon_sym_RPAREN] = ACTIONS(9426),
    [anon_sym_DOT] = ACTIONS(9428),
    [anon_sym_COMMA] = ACTIONS(9426),
    [anon_sym_PIPE] = ACTIONS(9428),
    [anon_sym_SEMI] = ACTIONS(9426),
    [anon_sym_STAR_STAR] = ACTIONS(9426),
    [anon_sym_AMP] = ACTIONS(9428),
    [anon_sym_EQ] = ACTIONS(9428),
    [anon_sym_LT] = ACTIONS(9428),
    [anon_sym_if] = ACTIONS(9426),
    [anon_sym_unless] = ACTIONS(9426),
    [anon_sym_while] = ACTIONS(9426),
    [anon_sym_until] = ACTIONS(9426),
    [anon_sym_rescue] = ACTIONS(9426),
    [anon_sym_in] = ACTIONS(9426),
    [anon_sym_do] = ACTIONS(9426),
    [anon_sym_EQ_GT] = ACTIONS(9426),
    [anon_sym_LBRACK] = ACTIONS(9426),
    [anon_sym_RBRACK] = ACTIONS(9426),
    [anon_sym_COLON_COLON2] = ACTIONS(9426),
    [anon_sym_AMP_DOT] = ACTIONS(9426),
    [anon_sym_QMARK] = ACTIONS(9426),
    [anon_sym_COLON2] = ACTIONS(9428),
    [anon_sym_DOT_DOT] = ACTIONS(9428),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9426),
    [anon_sym_and] = ACTIONS(9426),
    [anon_sym_or] = ACTIONS(9426),
    [anon_sym_PIPE_PIPE] = ACTIONS(9426),
    [anon_sym_AMP_AMP] = ACTIONS(9426),
    [anon_sym_LT_LT] = ACTIONS(9426),
    [anon_sym_GT_GT] = ACTIONS(9426),
    [anon_sym_EQ_EQ] = ACTIONS(9428),
    [anon_sym_BANG_EQ] = ACTIONS(9426),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9426),
    [anon_sym_LT_EQ_GT] = ACTIONS(9426),
    [anon_sym_EQ_TILDE] = ACTIONS(9426),
    [anon_sym_BANG_TILDE] = ACTIONS(9426),
    [anon_sym_LT_EQ] = ACTIONS(9428),
    [anon_sym_GT] = ACTIONS(9428),
    [anon_sym_GT_EQ] = ACTIONS(9426),
    [anon_sym_CARET] = ACTIONS(9426),
    [anon_sym_PLUS] = ACTIONS(9426),
    [anon_sym_SLASH] = ACTIONS(9426),
    [anon_sym_PERCENT] = ACTIONS(9426),
    [sym_comment] = ACTIONS(87),
  },
  [6052] = {
    [anon_sym_RBRACE] = ACTIONS(11966),
    [sym_comment] = ACTIONS(87),
  },
  [6053] = {
    [sym__heredoc_body_start] = ACTIONS(9446),
    [sym__binary_minus] = ACTIONS(9446),
    [sym__binary_star] = ACTIONS(9446),
    [anon_sym_LBRACE] = ACTIONS(9446),
    [anon_sym_RBRACE] = ACTIONS(9446),
    [anon_sym_RPAREN] = ACTIONS(9446),
    [anon_sym_DOT] = ACTIONS(9448),
    [anon_sym_COMMA] = ACTIONS(9446),
    [anon_sym_PIPE] = ACTIONS(9448),
    [anon_sym_SEMI] = ACTIONS(9446),
    [anon_sym_STAR_STAR] = ACTIONS(9446),
    [anon_sym_AMP] = ACTIONS(9448),
    [anon_sym_EQ] = ACTIONS(9448),
    [anon_sym_LT] = ACTIONS(9448),
    [anon_sym_if] = ACTIONS(9446),
    [anon_sym_unless] = ACTIONS(9446),
    [anon_sym_while] = ACTIONS(9446),
    [anon_sym_until] = ACTIONS(9446),
    [anon_sym_rescue] = ACTIONS(9446),
    [anon_sym_in] = ACTIONS(9446),
    [anon_sym_do] = ACTIONS(9446),
    [anon_sym_EQ_GT] = ACTIONS(9446),
    [anon_sym_LBRACK] = ACTIONS(9446),
    [anon_sym_RBRACK] = ACTIONS(9446),
    [anon_sym_COLON_COLON2] = ACTIONS(9446),
    [anon_sym_AMP_DOT] = ACTIONS(9446),
    [anon_sym_QMARK] = ACTIONS(9446),
    [anon_sym_COLON2] = ACTIONS(9448),
    [anon_sym_DOT_DOT] = ACTIONS(9448),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9446),
    [anon_sym_and] = ACTIONS(9446),
    [anon_sym_or] = ACTIONS(9446),
    [anon_sym_PIPE_PIPE] = ACTIONS(9446),
    [anon_sym_AMP_AMP] = ACTIONS(9446),
    [anon_sym_LT_LT] = ACTIONS(9446),
    [anon_sym_GT_GT] = ACTIONS(9446),
    [anon_sym_EQ_EQ] = ACTIONS(9448),
    [anon_sym_BANG_EQ] = ACTIONS(9446),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9446),
    [anon_sym_LT_EQ_GT] = ACTIONS(9446),
    [anon_sym_EQ_TILDE] = ACTIONS(9446),
    [anon_sym_BANG_TILDE] = ACTIONS(9446),
    [anon_sym_LT_EQ] = ACTIONS(9448),
    [anon_sym_GT] = ACTIONS(9448),
    [anon_sym_GT_EQ] = ACTIONS(9446),
    [anon_sym_CARET] = ACTIONS(9446),
    [anon_sym_PLUS] = ACTIONS(9446),
    [anon_sym_SLASH] = ACTIONS(9446),
    [anon_sym_PERCENT] = ACTIONS(9446),
    [sym_comment] = ACTIONS(87),
  },
  [6054] = {
    [anon_sym_end] = ACTIONS(11968),
    [sym_comment] = ACTIONS(87),
  },
  [6055] = {
    [sym__statements] = STATE(8417),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(11970),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6056] = {
    [sym__statements] = STATE(8417),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_heredoc_body] = STATE(8418),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [sym__terminator] = STATE(8418),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__line_break] = ACTIONS(11972),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(11972),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(11970),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6057] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(8419),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(352),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(352),
    [sym_assignment] = STATE(8419),
    [sym_operator_assignment] = STATE(8419),
    [sym_conditional] = STATE(8419),
    [sym_range] = STATE(8419),
    [sym_binary] = STATE(8419),
    [sym_unary] = STATE(8419),
    [sym_left_assignment_list] = STATE(351),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(352),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(352),
    [sym_false] = STATE(352),
    [sym_nil] = STATE(352),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1291),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6058] = {
    [sym__simple_symbol] = ACTIONS(4285),
    [sym__string_start] = ACTIONS(4285),
    [sym__symbol_start] = ACTIONS(4285),
    [sym__subshell_start] = ACTIONS(4285),
    [sym__regex_start] = ACTIONS(4285),
    [sym__string_array_start] = ACTIONS(4285),
    [sym__symbol_array_start] = ACTIONS(4285),
    [sym__heredoc_body_start] = ACTIONS(4285),
    [sym_heredoc_beginning] = ACTIONS(4285),
    [sym__block_ampersand] = ACTIONS(4285),
    [sym__splat_star] = ACTIONS(4285),
    [sym__unary_minus] = ACTIONS(4285),
    [sym__binary_minus] = ACTIONS(4285),
    [sym__binary_star] = ACTIONS(4285),
    [sym__identifier_hash_key] = ACTIONS(4285),
    [anon_sym_LBRACE] = ACTIONS(4285),
    [anon_sym_RBRACE] = ACTIONS(4285),
    [anon_sym_def] = ACTIONS(4287),
    [anon_sym_LPAREN] = ACTIONS(4287),
    [anon_sym_RPAREN] = ACTIONS(4285),
    [anon_sym_DOT] = ACTIONS(4287),
    [anon_sym_COLON_COLON] = ACTIONS(4287),
    [anon_sym_COMMA] = ACTIONS(4285),
    [anon_sym_PIPE] = ACTIONS(4287),
    [anon_sym_SEMI] = ACTIONS(4285),
    [anon_sym_STAR] = ACTIONS(4287),
    [anon_sym_STAR_STAR] = ACTIONS(4287),
    [anon_sym_AMP] = ACTIONS(4287),
    [anon_sym_EQ] = ACTIONS(4287),
    [anon_sym_class] = ACTIONS(4287),
    [anon_sym_LT] = ACTIONS(4287),
    [anon_sym_module] = ACTIONS(4287),
    [anon_sym_return] = ACTIONS(4287),
    [anon_sym_yield] = ACTIONS(4287),
    [anon_sym_break] = ACTIONS(4287),
    [anon_sym_next] = ACTIONS(4287),
    [sym_redo] = ACTIONS(4287),
    [sym_retry] = ACTIONS(4287),
    [anon_sym_if] = ACTIONS(4287),
    [anon_sym_unless] = ACTIONS(4287),
    [anon_sym_while] = ACTIONS(4287),
    [anon_sym_until] = ACTIONS(4287),
    [anon_sym_rescue] = ACTIONS(4287),
    [anon_sym_for] = ACTIONS(4287),
    [anon_sym_in] = ACTIONS(4287),
    [anon_sym_do] = ACTIONS(4287),
    [anon_sym_case] = ACTIONS(4287),
    [anon_sym_begin] = ACTIONS(4287),
    [anon_sym_EQ_GT] = ACTIONS(4285),
    [anon_sym_LBRACK] = ACTIONS(4285),
    [anon_sym_RBRACK] = ACTIONS(4285),
    [anon_sym_COLON_COLON2] = ACTIONS(4285),
    [anon_sym_AMP_DOT] = ACTIONS(4285),
    [anon_sym_LPAREN2] = ACTIONS(4285),
    [anon_sym_PLUS_EQ] = ACTIONS(4285),
    [anon_sym_DASH_EQ] = ACTIONS(4285),
    [anon_sym_STAR_EQ] = ACTIONS(4285),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4285),
    [anon_sym_SLASH_EQ] = ACTIONS(4285),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4285),
    [anon_sym_PIPE_EQ] = ACTIONS(4285),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4285),
    [anon_sym_AMP_EQ] = ACTIONS(4285),
    [anon_sym_PERCENT_EQ] = ACTIONS(4285),
    [anon_sym_GT_GT_EQ] = ACTIONS(4285),
    [anon_sym_LT_LT_EQ] = ACTIONS(4285),
    [anon_sym_CARET_EQ] = ACTIONS(4285),
    [anon_sym_QMARK] = ACTIONS(4287),
    [anon_sym_COLON2] = ACTIONS(4287),
    [anon_sym_DOT_DOT] = ACTIONS(4287),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4285),
    [anon_sym_and] = ACTIONS(4287),
    [anon_sym_or] = ACTIONS(4287),
    [anon_sym_PIPE_PIPE] = ACTIONS(4287),
    [anon_sym_AMP_AMP] = ACTIONS(4287),
    [anon_sym_LT_LT] = ACTIONS(4287),
    [anon_sym_GT_GT] = ACTIONS(4287),
    [anon_sym_EQ_EQ] = ACTIONS(4287),
    [anon_sym_BANG_EQ] = ACTIONS(4285),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4285),
    [anon_sym_LT_EQ_GT] = ACTIONS(4285),
    [anon_sym_EQ_TILDE] = ACTIONS(4285),
    [anon_sym_BANG_TILDE] = ACTIONS(4285),
    [anon_sym_LT_EQ] = ACTIONS(4287),
    [anon_sym_GT] = ACTIONS(4287),
    [anon_sym_GT_EQ] = ACTIONS(4285),
    [anon_sym_CARET] = ACTIONS(4287),
    [anon_sym_PLUS] = ACTIONS(4287),
    [anon_sym_SLASH] = ACTIONS(4287),
    [anon_sym_PERCENT] = ACTIONS(4287),
    [anon_sym_defined_QMARK] = ACTIONS(4285),
    [anon_sym_not] = ACTIONS(4287),
    [anon_sym_BANG] = ACTIONS(4287),
    [anon_sym_TILDE] = ACTIONS(4285),
    [sym_constant] = ACTIONS(4287),
    [sym_identifier] = ACTIONS(4287),
    [sym_instance_variable] = ACTIONS(4285),
    [sym_class_variable] = ACTIONS(4285),
    [sym_global_variable] = ACTIONS(4285),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4287),
    [sym_float] = ACTIONS(4287),
    [sym_complex] = ACTIONS(4285),
    [sym_super] = ACTIONS(4287),
    [anon_sym_true] = ACTIONS(4287),
    [anon_sym_TRUE] = ACTIONS(4287),
    [anon_sym_false] = ACTIONS(4287),
    [anon_sym_FALSE] = ACTIONS(4287),
    [sym_self] = ACTIONS(4287),
    [anon_sym_nil] = ACTIONS(4287),
    [anon_sym_NIL] = ACTIONS(4287),
    [sym_character] = ACTIONS(4285),
    [anon_sym_LBRACK2] = ACTIONS(4287),
    [anon_sym_DASH_GT] = ACTIONS(4285),
  },
  [6059] = {
    [anon_sym_RPAREN] = ACTIONS(11974),
    [sym_comment] = ACTIONS(87),
  },
  [6060] = {
    [sym__simple_symbol] = ACTIONS(9679),
    [sym__string_start] = ACTIONS(9679),
    [sym__symbol_start] = ACTIONS(9679),
    [sym__subshell_start] = ACTIONS(9679),
    [sym__regex_start] = ACTIONS(9679),
    [sym__string_array_start] = ACTIONS(9679),
    [sym__symbol_array_start] = ACTIONS(9679),
    [sym__heredoc_body_start] = ACTIONS(9679),
    [sym_heredoc_beginning] = ACTIONS(9679),
    [sym__block_ampersand] = ACTIONS(9679),
    [sym__splat_star] = ACTIONS(9679),
    [sym__unary_minus] = ACTIONS(9679),
    [sym__binary_minus] = ACTIONS(9679),
    [sym__binary_star] = ACTIONS(9679),
    [sym__identifier_hash_key] = ACTIONS(9679),
    [anon_sym_LBRACE] = ACTIONS(9679),
    [anon_sym_RBRACE] = ACTIONS(9679),
    [anon_sym_def] = ACTIONS(9681),
    [anon_sym_LPAREN] = ACTIONS(9681),
    [anon_sym_RPAREN] = ACTIONS(9679),
    [anon_sym_DOT] = ACTIONS(9681),
    [anon_sym_COLON_COLON] = ACTIONS(9681),
    [anon_sym_COMMA] = ACTIONS(9679),
    [anon_sym_PIPE] = ACTIONS(9681),
    [anon_sym_SEMI] = ACTIONS(9679),
    [anon_sym_STAR] = ACTIONS(9681),
    [anon_sym_STAR_STAR] = ACTIONS(9681),
    [anon_sym_AMP] = ACTIONS(9681),
    [anon_sym_EQ] = ACTIONS(9681),
    [anon_sym_class] = ACTIONS(9681),
    [anon_sym_LT] = ACTIONS(9681),
    [anon_sym_module] = ACTIONS(9681),
    [anon_sym_return] = ACTIONS(9681),
    [anon_sym_yield] = ACTIONS(9681),
    [anon_sym_break] = ACTIONS(9681),
    [anon_sym_next] = ACTIONS(9681),
    [sym_redo] = ACTIONS(9681),
    [sym_retry] = ACTIONS(9681),
    [anon_sym_if] = ACTIONS(9681),
    [anon_sym_unless] = ACTIONS(9681),
    [anon_sym_while] = ACTIONS(9681),
    [anon_sym_until] = ACTIONS(9681),
    [anon_sym_rescue] = ACTIONS(9681),
    [anon_sym_for] = ACTIONS(9681),
    [anon_sym_in] = ACTIONS(9681),
    [anon_sym_do] = ACTIONS(9681),
    [anon_sym_case] = ACTIONS(9681),
    [anon_sym_begin] = ACTIONS(9681),
    [anon_sym_EQ_GT] = ACTIONS(9679),
    [anon_sym_LBRACK] = ACTIONS(9679),
    [anon_sym_RBRACK] = ACTIONS(9679),
    [anon_sym_COLON_COLON2] = ACTIONS(9679),
    [anon_sym_AMP_DOT] = ACTIONS(9679),
    [anon_sym_LPAREN2] = ACTIONS(9679),
    [anon_sym_PLUS_EQ] = ACTIONS(9679),
    [anon_sym_DASH_EQ] = ACTIONS(9679),
    [anon_sym_STAR_EQ] = ACTIONS(9679),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9679),
    [anon_sym_SLASH_EQ] = ACTIONS(9679),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9679),
    [anon_sym_PIPE_EQ] = ACTIONS(9679),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9679),
    [anon_sym_AMP_EQ] = ACTIONS(9679),
    [anon_sym_PERCENT_EQ] = ACTIONS(9679),
    [anon_sym_GT_GT_EQ] = ACTIONS(9679),
    [anon_sym_LT_LT_EQ] = ACTIONS(9679),
    [anon_sym_CARET_EQ] = ACTIONS(9679),
    [anon_sym_QMARK] = ACTIONS(9681),
    [anon_sym_COLON2] = ACTIONS(9681),
    [anon_sym_DOT_DOT] = ACTIONS(9681),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9679),
    [anon_sym_and] = ACTIONS(9681),
    [anon_sym_or] = ACTIONS(9681),
    [anon_sym_PIPE_PIPE] = ACTIONS(9681),
    [anon_sym_AMP_AMP] = ACTIONS(9681),
    [anon_sym_LT_LT] = ACTIONS(9681),
    [anon_sym_GT_GT] = ACTIONS(9681),
    [anon_sym_EQ_EQ] = ACTIONS(9681),
    [anon_sym_BANG_EQ] = ACTIONS(9679),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9679),
    [anon_sym_LT_EQ_GT] = ACTIONS(9679),
    [anon_sym_EQ_TILDE] = ACTIONS(9679),
    [anon_sym_BANG_TILDE] = ACTIONS(9679),
    [anon_sym_LT_EQ] = ACTIONS(9681),
    [anon_sym_GT] = ACTIONS(9681),
    [anon_sym_GT_EQ] = ACTIONS(9679),
    [anon_sym_CARET] = ACTIONS(9681),
    [anon_sym_PLUS] = ACTIONS(9681),
    [anon_sym_SLASH] = ACTIONS(9681),
    [anon_sym_PERCENT] = ACTIONS(9681),
    [anon_sym_defined_QMARK] = ACTIONS(9679),
    [anon_sym_not] = ACTIONS(9681),
    [anon_sym_BANG] = ACTIONS(9681),
    [anon_sym_TILDE] = ACTIONS(9679),
    [sym_constant] = ACTIONS(9681),
    [sym_identifier] = ACTIONS(9681),
    [sym_instance_variable] = ACTIONS(9679),
    [sym_class_variable] = ACTIONS(9679),
    [sym_global_variable] = ACTIONS(9679),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(9681),
    [sym_float] = ACTIONS(9681),
    [sym_complex] = ACTIONS(9679),
    [sym_super] = ACTIONS(9681),
    [anon_sym_true] = ACTIONS(9681),
    [anon_sym_TRUE] = ACTIONS(9681),
    [anon_sym_false] = ACTIONS(9681),
    [anon_sym_FALSE] = ACTIONS(9681),
    [sym_self] = ACTIONS(9681),
    [anon_sym_nil] = ACTIONS(9681),
    [anon_sym_NIL] = ACTIONS(9681),
    [sym_character] = ACTIONS(9679),
    [anon_sym_LBRACK2] = ACTIONS(9681),
    [anon_sym_DASH_GT] = ACTIONS(9679),
  },
  [6061] = {
    [sym__heredoc_body_start] = ACTIONS(9686),
    [sym__binary_minus] = ACTIONS(9686),
    [sym__binary_star] = ACTIONS(9686),
    [anon_sym_LBRACE] = ACTIONS(9686),
    [anon_sym_RBRACE] = ACTIONS(9686),
    [anon_sym_RPAREN] = ACTIONS(9686),
    [anon_sym_DOT] = ACTIONS(9688),
    [anon_sym_COMMA] = ACTIONS(9686),
    [anon_sym_PIPE] = ACTIONS(9688),
    [anon_sym_SEMI] = ACTIONS(9686),
    [anon_sym_STAR_STAR] = ACTIONS(9688),
    [anon_sym_AMP] = ACTIONS(9688),
    [anon_sym_EQ] = ACTIONS(9688),
    [anon_sym_LT] = ACTIONS(9688),
    [anon_sym_if] = ACTIONS(9686),
    [anon_sym_unless] = ACTIONS(9686),
    [anon_sym_while] = ACTIONS(9686),
    [anon_sym_until] = ACTIONS(9686),
    [anon_sym_rescue] = ACTIONS(9686),
    [anon_sym_in] = ACTIONS(9686),
    [anon_sym_do] = ACTIONS(9686),
    [anon_sym_EQ_GT] = ACTIONS(9686),
    [anon_sym_LBRACK] = ACTIONS(9686),
    [anon_sym_RBRACK] = ACTIONS(9686),
    [anon_sym_COLON_COLON2] = ACTIONS(9686),
    [anon_sym_AMP_DOT] = ACTIONS(9686),
    [anon_sym_PLUS_EQ] = ACTIONS(9686),
    [anon_sym_DASH_EQ] = ACTIONS(9686),
    [anon_sym_STAR_EQ] = ACTIONS(9686),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9686),
    [anon_sym_SLASH_EQ] = ACTIONS(9686),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9686),
    [anon_sym_PIPE_EQ] = ACTIONS(9686),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9686),
    [anon_sym_AMP_EQ] = ACTIONS(9686),
    [anon_sym_PERCENT_EQ] = ACTIONS(9686),
    [anon_sym_GT_GT_EQ] = ACTIONS(9686),
    [anon_sym_LT_LT_EQ] = ACTIONS(9686),
    [anon_sym_CARET_EQ] = ACTIONS(9686),
    [anon_sym_QMARK] = ACTIONS(9686),
    [anon_sym_COLON2] = ACTIONS(9688),
    [anon_sym_DOT_DOT] = ACTIONS(9688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9686),
    [anon_sym_and] = ACTIONS(9686),
    [anon_sym_or] = ACTIONS(9686),
    [anon_sym_PIPE_PIPE] = ACTIONS(9688),
    [anon_sym_AMP_AMP] = ACTIONS(9688),
    [anon_sym_LT_LT] = ACTIONS(9688),
    [anon_sym_GT_GT] = ACTIONS(9688),
    [anon_sym_EQ_EQ] = ACTIONS(9688),
    [anon_sym_BANG_EQ] = ACTIONS(9686),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9686),
    [anon_sym_LT_EQ_GT] = ACTIONS(9686),
    [anon_sym_EQ_TILDE] = ACTIONS(9686),
    [anon_sym_BANG_TILDE] = ACTIONS(9686),
    [anon_sym_LT_EQ] = ACTIONS(9688),
    [anon_sym_GT] = ACTIONS(9688),
    [anon_sym_GT_EQ] = ACTIONS(9686),
    [anon_sym_CARET] = ACTIONS(9688),
    [anon_sym_PLUS] = ACTIONS(9688),
    [anon_sym_SLASH] = ACTIONS(9688),
    [anon_sym_PERCENT] = ACTIONS(9688),
    [sym_comment] = ACTIONS(87),
  },
  [6062] = {
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(5685),
    [sym__binary_star] = ACTIONS(5687),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(5689),
    [anon_sym_STAR_STAR] = ACTIONS(5691),
    [anon_sym_AMP] = ACTIONS(5693),
    [anon_sym_EQ] = ACTIONS(7822),
    [anon_sym_LT] = ACTIONS(5695),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_EQ_GT] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_RBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_PLUS_EQ] = ACTIONS(6823),
    [anon_sym_DASH_EQ] = ACTIONS(6823),
    [anon_sym_STAR_EQ] = ACTIONS(6823),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6823),
    [anon_sym_SLASH_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6823),
    [anon_sym_AMP_EQ] = ACTIONS(6823),
    [anon_sym_PERCENT_EQ] = ACTIONS(6823),
    [anon_sym_GT_GT_EQ] = ACTIONS(6823),
    [anon_sym_LT_LT_EQ] = ACTIONS(6823),
    [anon_sym_CARET_EQ] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(5697),
    [anon_sym_DOT_DOT] = ACTIONS(5699),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5701),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(5703),
    [anon_sym_AMP_AMP] = ACTIONS(5703),
    [anon_sym_LT_LT] = ACTIONS(5705),
    [anon_sym_GT_GT] = ACTIONS(5705),
    [anon_sym_EQ_EQ] = ACTIONS(5703),
    [anon_sym_BANG_EQ] = ACTIONS(5707),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5707),
    [anon_sym_LT_EQ_GT] = ACTIONS(5707),
    [anon_sym_EQ_TILDE] = ACTIONS(5707),
    [anon_sym_BANG_TILDE] = ACTIONS(5707),
    [anon_sym_LT_EQ] = ACTIONS(5695),
    [anon_sym_GT] = ACTIONS(5695),
    [anon_sym_GT_EQ] = ACTIONS(5709),
    [anon_sym_CARET] = ACTIONS(5689),
    [anon_sym_PLUS] = ACTIONS(5711),
    [anon_sym_SLASH] = ACTIONS(5691),
    [anon_sym_PERCENT] = ACTIONS(5691),
    [sym_comment] = ACTIONS(87),
  },
  [6063] = {
    [sym__heredoc_body_start] = ACTIONS(9426),
    [sym__binary_minus] = ACTIONS(9426),
    [sym__binary_star] = ACTIONS(9426),
    [anon_sym_LBRACE] = ACTIONS(9426),
    [anon_sym_RBRACE] = ACTIONS(9426),
    [anon_sym_RPAREN] = ACTIONS(9426),
    [anon_sym_DOT] = ACTIONS(9428),
    [anon_sym_COMMA] = ACTIONS(9426),
    [anon_sym_PIPE] = ACTIONS(9428),
    [anon_sym_SEMI] = ACTIONS(9426),
    [anon_sym_STAR_STAR] = ACTIONS(9428),
    [anon_sym_AMP] = ACTIONS(9428),
    [anon_sym_EQ] = ACTIONS(9428),
    [anon_sym_LT] = ACTIONS(9428),
    [anon_sym_if] = ACTIONS(9426),
    [anon_sym_unless] = ACTIONS(9426),
    [anon_sym_while] = ACTIONS(9426),
    [anon_sym_until] = ACTIONS(9426),
    [anon_sym_rescue] = ACTIONS(9426),
    [anon_sym_in] = ACTIONS(9426),
    [anon_sym_do] = ACTIONS(9426),
    [anon_sym_EQ_GT] = ACTIONS(9426),
    [anon_sym_LBRACK] = ACTIONS(9426),
    [anon_sym_RBRACK] = ACTIONS(9426),
    [anon_sym_COLON_COLON2] = ACTIONS(9426),
    [anon_sym_AMP_DOT] = ACTIONS(9426),
    [anon_sym_PLUS_EQ] = ACTIONS(9426),
    [anon_sym_DASH_EQ] = ACTIONS(9426),
    [anon_sym_STAR_EQ] = ACTIONS(9426),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9426),
    [anon_sym_SLASH_EQ] = ACTIONS(9426),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9426),
    [anon_sym_PIPE_EQ] = ACTIONS(9426),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9426),
    [anon_sym_AMP_EQ] = ACTIONS(9426),
    [anon_sym_PERCENT_EQ] = ACTIONS(9426),
    [anon_sym_GT_GT_EQ] = ACTIONS(9426),
    [anon_sym_LT_LT_EQ] = ACTIONS(9426),
    [anon_sym_CARET_EQ] = ACTIONS(9426),
    [anon_sym_QMARK] = ACTIONS(9426),
    [anon_sym_COLON2] = ACTIONS(9428),
    [anon_sym_DOT_DOT] = ACTIONS(9428),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9426),
    [anon_sym_and] = ACTIONS(9426),
    [anon_sym_or] = ACTIONS(9426),
    [anon_sym_PIPE_PIPE] = ACTIONS(9428),
    [anon_sym_AMP_AMP] = ACTIONS(9428),
    [anon_sym_LT_LT] = ACTIONS(9428),
    [anon_sym_GT_GT] = ACTIONS(9428),
    [anon_sym_EQ_EQ] = ACTIONS(9428),
    [anon_sym_BANG_EQ] = ACTIONS(9426),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9426),
    [anon_sym_LT_EQ_GT] = ACTIONS(9426),
    [anon_sym_EQ_TILDE] = ACTIONS(9426),
    [anon_sym_BANG_TILDE] = ACTIONS(9426),
    [anon_sym_LT_EQ] = ACTIONS(9428),
    [anon_sym_GT] = ACTIONS(9428),
    [anon_sym_GT_EQ] = ACTIONS(9426),
    [anon_sym_CARET] = ACTIONS(9428),
    [anon_sym_PLUS] = ACTIONS(9428),
    [anon_sym_SLASH] = ACTIONS(9428),
    [anon_sym_PERCENT] = ACTIONS(9428),
    [sym_comment] = ACTIONS(87),
  },
  [6064] = {
    [anon_sym_RBRACE] = ACTIONS(11976),
    [sym_comment] = ACTIONS(87),
  },
  [6065] = {
    [sym__heredoc_body_start] = ACTIONS(9446),
    [sym__binary_minus] = ACTIONS(9446),
    [sym__binary_star] = ACTIONS(9446),
    [anon_sym_LBRACE] = ACTIONS(9446),
    [anon_sym_RBRACE] = ACTIONS(9446),
    [anon_sym_RPAREN] = ACTIONS(9446),
    [anon_sym_DOT] = ACTIONS(9448),
    [anon_sym_COMMA] = ACTIONS(9446),
    [anon_sym_PIPE] = ACTIONS(9448),
    [anon_sym_SEMI] = ACTIONS(9446),
    [anon_sym_STAR_STAR] = ACTIONS(9448),
    [anon_sym_AMP] = ACTIONS(9448),
    [anon_sym_EQ] = ACTIONS(9448),
    [anon_sym_LT] = ACTIONS(9448),
    [anon_sym_if] = ACTIONS(9446),
    [anon_sym_unless] = ACTIONS(9446),
    [anon_sym_while] = ACTIONS(9446),
    [anon_sym_until] = ACTIONS(9446),
    [anon_sym_rescue] = ACTIONS(9446),
    [anon_sym_in] = ACTIONS(9446),
    [anon_sym_do] = ACTIONS(9446),
    [anon_sym_EQ_GT] = ACTIONS(9446),
    [anon_sym_LBRACK] = ACTIONS(9446),
    [anon_sym_RBRACK] = ACTIONS(9446),
    [anon_sym_COLON_COLON2] = ACTIONS(9446),
    [anon_sym_AMP_DOT] = ACTIONS(9446),
    [anon_sym_PLUS_EQ] = ACTIONS(9446),
    [anon_sym_DASH_EQ] = ACTIONS(9446),
    [anon_sym_STAR_EQ] = ACTIONS(9446),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9446),
    [anon_sym_SLASH_EQ] = ACTIONS(9446),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9446),
    [anon_sym_PIPE_EQ] = ACTIONS(9446),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9446),
    [anon_sym_AMP_EQ] = ACTIONS(9446),
    [anon_sym_PERCENT_EQ] = ACTIONS(9446),
    [anon_sym_GT_GT_EQ] = ACTIONS(9446),
    [anon_sym_LT_LT_EQ] = ACTIONS(9446),
    [anon_sym_CARET_EQ] = ACTIONS(9446),
    [anon_sym_QMARK] = ACTIONS(9446),
    [anon_sym_COLON2] = ACTIONS(9448),
    [anon_sym_DOT_DOT] = ACTIONS(9448),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9446),
    [anon_sym_and] = ACTIONS(9446),
    [anon_sym_or] = ACTIONS(9446),
    [anon_sym_PIPE_PIPE] = ACTIONS(9448),
    [anon_sym_AMP_AMP] = ACTIONS(9448),
    [anon_sym_LT_LT] = ACTIONS(9448),
    [anon_sym_GT_GT] = ACTIONS(9448),
    [anon_sym_EQ_EQ] = ACTIONS(9448),
    [anon_sym_BANG_EQ] = ACTIONS(9446),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9446),
    [anon_sym_LT_EQ_GT] = ACTIONS(9446),
    [anon_sym_EQ_TILDE] = ACTIONS(9446),
    [anon_sym_BANG_TILDE] = ACTIONS(9446),
    [anon_sym_LT_EQ] = ACTIONS(9448),
    [anon_sym_GT] = ACTIONS(9448),
    [anon_sym_GT_EQ] = ACTIONS(9446),
    [anon_sym_CARET] = ACTIONS(9448),
    [anon_sym_PLUS] = ACTIONS(9448),
    [anon_sym_SLASH] = ACTIONS(9448),
    [anon_sym_PERCENT] = ACTIONS(9448),
    [sym_comment] = ACTIONS(87),
  },
  [6066] = {
    [anon_sym_end] = ACTIONS(11978),
    [sym_comment] = ACTIONS(87),
  },
  [6067] = {
    [sym__statements] = STATE(8423),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(11980),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6068] = {
    [sym__statements] = STATE(8423),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_heredoc_body] = STATE(8424),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [sym__terminator] = STATE(8424),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__line_break] = ACTIONS(11982),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(11982),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(11980),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6069] = {
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(5685),
    [sym__binary_star] = ACTIONS(5687),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(5689),
    [anon_sym_STAR_STAR] = ACTIONS(5691),
    [anon_sym_AMP] = ACTIONS(5693),
    [anon_sym_EQ] = ACTIONS(7884),
    [anon_sym_LT] = ACTIONS(5695),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_EQ_GT] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_RBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_PLUS_EQ] = ACTIONS(7027),
    [anon_sym_DASH_EQ] = ACTIONS(7027),
    [anon_sym_STAR_EQ] = ACTIONS(7027),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7027),
    [anon_sym_SLASH_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7027),
    [anon_sym_AMP_EQ] = ACTIONS(7027),
    [anon_sym_PERCENT_EQ] = ACTIONS(7027),
    [anon_sym_GT_GT_EQ] = ACTIONS(7027),
    [anon_sym_LT_LT_EQ] = ACTIONS(7027),
    [anon_sym_CARET_EQ] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(5697),
    [anon_sym_DOT_DOT] = ACTIONS(5699),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5701),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(5703),
    [anon_sym_AMP_AMP] = ACTIONS(5703),
    [anon_sym_LT_LT] = ACTIONS(5705),
    [anon_sym_GT_GT] = ACTIONS(5705),
    [anon_sym_EQ_EQ] = ACTIONS(5703),
    [anon_sym_BANG_EQ] = ACTIONS(5707),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5707),
    [anon_sym_LT_EQ_GT] = ACTIONS(5707),
    [anon_sym_EQ_TILDE] = ACTIONS(5707),
    [anon_sym_BANG_TILDE] = ACTIONS(5707),
    [anon_sym_LT_EQ] = ACTIONS(5695),
    [anon_sym_GT] = ACTIONS(5695),
    [anon_sym_GT_EQ] = ACTIONS(5709),
    [anon_sym_CARET] = ACTIONS(5689),
    [anon_sym_PLUS] = ACTIONS(5711),
    [anon_sym_SLASH] = ACTIONS(5691),
    [anon_sym_PERCENT] = ACTIONS(5691),
    [sym_comment] = ACTIONS(87),
  },
  [6070] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5687),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(5691),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_RBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(5691),
    [anon_sym_PERCENT] = ACTIONS(5691),
    [sym_comment] = ACTIONS(87),
  },
  [6071] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(5691),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_RBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(5827),
    [anon_sym_PERCENT] = ACTIONS(5827),
    [sym_comment] = ACTIONS(87),
  },
  [6072] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5685),
    [sym__binary_star] = ACTIONS(5687),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(5691),
    [anon_sym_AMP] = ACTIONS(5693),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_RBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5705),
    [anon_sym_GT_GT] = ACTIONS(5705),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5711),
    [anon_sym_SLASH] = ACTIONS(5691),
    [anon_sym_PERCENT] = ACTIONS(5691),
    [sym_comment] = ACTIONS(87),
  },
  [6073] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5685),
    [sym__binary_star] = ACTIONS(5687),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(5691),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_RBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5705),
    [anon_sym_GT_GT] = ACTIONS(5705),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5711),
    [anon_sym_SLASH] = ACTIONS(5691),
    [anon_sym_PERCENT] = ACTIONS(5691),
    [sym_comment] = ACTIONS(87),
  },
  [6074] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5685),
    [sym__binary_star] = ACTIONS(5687),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5689),
    [anon_sym_STAR_STAR] = ACTIONS(5691),
    [anon_sym_AMP] = ACTIONS(5693),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_RBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5705),
    [anon_sym_GT_GT] = ACTIONS(5705),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5689),
    [anon_sym_PLUS] = ACTIONS(5711),
    [anon_sym_SLASH] = ACTIONS(5691),
    [anon_sym_PERCENT] = ACTIONS(5691),
    [sym_comment] = ACTIONS(87),
  },
  [6075] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(11984),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [6076] = {
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(5685),
    [sym__binary_star] = ACTIONS(5687),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(5689),
    [anon_sym_STAR_STAR] = ACTIONS(5691),
    [anon_sym_AMP] = ACTIONS(5693),
    [anon_sym_EQ] = ACTIONS(7888),
    [anon_sym_LT] = ACTIONS(5695),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_EQ_GT] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_RBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_PLUS_EQ] = ACTIONS(5927),
    [anon_sym_DASH_EQ] = ACTIONS(5927),
    [anon_sym_STAR_EQ] = ACTIONS(5927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5927),
    [anon_sym_SLASH_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5927),
    [anon_sym_AMP_EQ] = ACTIONS(5927),
    [anon_sym_PERCENT_EQ] = ACTIONS(5927),
    [anon_sym_GT_GT_EQ] = ACTIONS(5927),
    [anon_sym_LT_LT_EQ] = ACTIONS(5927),
    [anon_sym_CARET_EQ] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(5699),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5701),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(5703),
    [anon_sym_AMP_AMP] = ACTIONS(5703),
    [anon_sym_LT_LT] = ACTIONS(5705),
    [anon_sym_GT_GT] = ACTIONS(5705),
    [anon_sym_EQ_EQ] = ACTIONS(5703),
    [anon_sym_BANG_EQ] = ACTIONS(5707),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5707),
    [anon_sym_LT_EQ_GT] = ACTIONS(5707),
    [anon_sym_EQ_TILDE] = ACTIONS(5707),
    [anon_sym_BANG_TILDE] = ACTIONS(5707),
    [anon_sym_LT_EQ] = ACTIONS(5695),
    [anon_sym_GT] = ACTIONS(5695),
    [anon_sym_GT_EQ] = ACTIONS(5709),
    [anon_sym_CARET] = ACTIONS(5689),
    [anon_sym_PLUS] = ACTIONS(5711),
    [anon_sym_SLASH] = ACTIONS(5691),
    [anon_sym_PERCENT] = ACTIONS(5691),
    [sym_comment] = ACTIONS(87),
  },
  [6077] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5685),
    [sym__binary_star] = ACTIONS(5687),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5689),
    [anon_sym_STAR_STAR] = ACTIONS(5691),
    [anon_sym_AMP] = ACTIONS(5693),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5695),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_RBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5697),
    [anon_sym_DOT_DOT] = ACTIONS(5699),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5701),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5703),
    [anon_sym_AMP_AMP] = ACTIONS(5703),
    [anon_sym_LT_LT] = ACTIONS(5705),
    [anon_sym_GT_GT] = ACTIONS(5705),
    [anon_sym_EQ_EQ] = ACTIONS(5703),
    [anon_sym_BANG_EQ] = ACTIONS(5707),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5707),
    [anon_sym_LT_EQ_GT] = ACTIONS(5707),
    [anon_sym_EQ_TILDE] = ACTIONS(5707),
    [anon_sym_BANG_TILDE] = ACTIONS(5707),
    [anon_sym_LT_EQ] = ACTIONS(5695),
    [anon_sym_GT] = ACTIONS(5695),
    [anon_sym_GT_EQ] = ACTIONS(5709),
    [anon_sym_CARET] = ACTIONS(5689),
    [anon_sym_PLUS] = ACTIONS(5711),
    [anon_sym_SLASH] = ACTIONS(5691),
    [anon_sym_PERCENT] = ACTIONS(5691),
    [sym_comment] = ACTIONS(87),
  },
  [6078] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5685),
    [sym__binary_star] = ACTIONS(5687),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5689),
    [anon_sym_STAR_STAR] = ACTIONS(5691),
    [anon_sym_AMP] = ACTIONS(5693),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5695),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_RBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5705),
    [anon_sym_GT_GT] = ACTIONS(5705),
    [anon_sym_EQ_EQ] = ACTIONS(5703),
    [anon_sym_BANG_EQ] = ACTIONS(5707),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5707),
    [anon_sym_LT_EQ_GT] = ACTIONS(5707),
    [anon_sym_EQ_TILDE] = ACTIONS(5707),
    [anon_sym_BANG_TILDE] = ACTIONS(5707),
    [anon_sym_LT_EQ] = ACTIONS(5695),
    [anon_sym_GT] = ACTIONS(5695),
    [anon_sym_GT_EQ] = ACTIONS(5709),
    [anon_sym_CARET] = ACTIONS(5689),
    [anon_sym_PLUS] = ACTIONS(5711),
    [anon_sym_SLASH] = ACTIONS(5691),
    [anon_sym_PERCENT] = ACTIONS(5691),
    [sym_comment] = ACTIONS(87),
  },
  [6079] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5685),
    [sym__binary_star] = ACTIONS(5687),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(5691),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_RBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5711),
    [anon_sym_SLASH] = ACTIONS(5691),
    [anon_sym_PERCENT] = ACTIONS(5691),
    [sym_comment] = ACTIONS(87),
  },
  [6080] = {
    [sym_heredoc_body] = STATE(6080),
    [aux_sym_call_repeat1] = STATE(6080),
    [sym__heredoc_body_start] = ACTIONS(10553),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_STAR_STAR] = ACTIONS(7919),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_EQ] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_EQ_GT] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_RBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_PLUS_EQ] = ACTIONS(7914),
    [anon_sym_DASH_EQ] = ACTIONS(7914),
    [anon_sym_STAR_EQ] = ACTIONS(7914),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7914),
    [anon_sym_SLASH_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7914),
    [anon_sym_AMP_EQ] = ACTIONS(7914),
    [anon_sym_PERCENT_EQ] = ACTIONS(7914),
    [anon_sym_GT_GT_EQ] = ACTIONS(7914),
    [anon_sym_LT_LT_EQ] = ACTIONS(7914),
    [anon_sym_CARET_EQ] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7919),
    [anon_sym_AMP_AMP] = ACTIONS(7919),
    [anon_sym_LT_LT] = ACTIONS(7919),
    [anon_sym_GT_GT] = ACTIONS(7919),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7919),
    [anon_sym_PLUS] = ACTIONS(7919),
    [anon_sym_SLASH] = ACTIONS(7919),
    [anon_sym_PERCENT] = ACTIONS(7919),
    [sym_comment] = ACTIONS(87),
  },
  [6081] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1377),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1384),
    [sym_scope_resolution] = STATE(1378),
    [sym_call] = STATE(1378),
    [sym_method_call] = STATE(1384),
    [sym__argument] = STATE(6970),
    [sym_splat_argument] = STATE(6970),
    [sym_hash_splat_argument] = STATE(6970),
    [sym_block_argument] = STATE(6970),
    [sym_assignment] = STATE(1377),
    [sym_operator_assignment] = STATE(1377),
    [sym_conditional] = STATE(1377),
    [sym_range] = STATE(1377),
    [sym_binary] = STATE(1377),
    [sym_unary] = STATE(1377),
    [sym_left_assignment_list] = STATE(1383),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1384),
    [sym__variable] = STATE(1378),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1384),
    [sym_false] = STATE(1384),
    [sym_nil] = STATE(1384),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1385),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(6970),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(2395),
    [sym__splat_star] = ACTIONS(2397),
    [sym__unary_minus] = ACTIONS(2399),
    [sym__identifier_hash_key] = ACTIONS(2401),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(9400),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2405),
    [anon_sym_yield] = ACTIONS(2407),
    [anon_sym_break] = ACTIONS(2409),
    [anon_sym_next] = ACTIONS(2411),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(5673),
    [anon_sym_defined_QMARK] = ACTIONS(2415),
    [anon_sym_not] = ACTIONS(2417),
    [anon_sym_BANG] = ACTIONS(2421),
    [anon_sym_TILDE] = ACTIONS(2421),
    [sym_constant] = ACTIONS(2423),
    [sym_identifier] = ACTIONS(2423),
    [sym_instance_variable] = ACTIONS(2425),
    [sym_class_variable] = ACTIONS(2425),
    [sym_global_variable] = ACTIONS(2425),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2427),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2427),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6082] = {
    [sym_heredoc_body] = STATE(6080),
    [aux_sym_call_repeat1] = STATE(6080),
    [sym__heredoc_body_start] = ACTIONS(3543),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_STAR_STAR] = ACTIONS(7931),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_EQ] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_EQ_GT] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_RBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_PLUS_EQ] = ACTIONS(7929),
    [anon_sym_DASH_EQ] = ACTIONS(7929),
    [anon_sym_STAR_EQ] = ACTIONS(7929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7929),
    [anon_sym_SLASH_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7929),
    [anon_sym_AMP_EQ] = ACTIONS(7929),
    [anon_sym_PERCENT_EQ] = ACTIONS(7929),
    [anon_sym_GT_GT_EQ] = ACTIONS(7929),
    [anon_sym_LT_LT_EQ] = ACTIONS(7929),
    [anon_sym_CARET_EQ] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7931),
    [anon_sym_AMP_AMP] = ACTIONS(7931),
    [anon_sym_LT_LT] = ACTIONS(7931),
    [anon_sym_GT_GT] = ACTIONS(7931),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7931),
    [anon_sym_PLUS] = ACTIONS(7931),
    [anon_sym_SLASH] = ACTIONS(7931),
    [anon_sym_PERCENT] = ACTIONS(7931),
    [sym_comment] = ACTIONS(87),
  },
  [6083] = {
    [aux_sym_argument_list_repeat1] = STATE(6083),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(11986),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_STAR_STAR] = ACTIONS(7927),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_EQ] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_EQ_GT] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_RBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_PLUS_EQ] = ACTIONS(7925),
    [anon_sym_DASH_EQ] = ACTIONS(7925),
    [anon_sym_STAR_EQ] = ACTIONS(7925),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7925),
    [anon_sym_SLASH_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7925),
    [anon_sym_AMP_EQ] = ACTIONS(7925),
    [anon_sym_PERCENT_EQ] = ACTIONS(7925),
    [anon_sym_GT_GT_EQ] = ACTIONS(7925),
    [anon_sym_LT_LT_EQ] = ACTIONS(7925),
    [anon_sym_CARET_EQ] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7927),
    [anon_sym_AMP_AMP] = ACTIONS(7927),
    [anon_sym_LT_LT] = ACTIONS(7927),
    [anon_sym_GT_GT] = ACTIONS(7927),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7927),
    [anon_sym_PLUS] = ACTIONS(7927),
    [anon_sym_SLASH] = ACTIONS(7927),
    [anon_sym_PERCENT] = ACTIONS(7927),
    [sym_comment] = ACTIONS(87),
  },
  [6084] = {
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(5685),
    [sym__binary_star] = ACTIONS(5687),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(5689),
    [anon_sym_STAR_STAR] = ACTIONS(5691),
    [anon_sym_AMP] = ACTIONS(5693),
    [anon_sym_EQ] = ACTIONS(7936),
    [anon_sym_LT] = ACTIONS(5695),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_EQ_GT] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_RBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_PLUS_EQ] = ACTIONS(5115),
    [anon_sym_DASH_EQ] = ACTIONS(5115),
    [anon_sym_STAR_EQ] = ACTIONS(5115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5115),
    [anon_sym_SLASH_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5115),
    [anon_sym_AMP_EQ] = ACTIONS(5115),
    [anon_sym_PERCENT_EQ] = ACTIONS(5115),
    [anon_sym_GT_GT_EQ] = ACTIONS(5115),
    [anon_sym_LT_LT_EQ] = ACTIONS(5115),
    [anon_sym_CARET_EQ] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(5697),
    [anon_sym_DOT_DOT] = ACTIONS(5699),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5701),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(5703),
    [anon_sym_AMP_AMP] = ACTIONS(5703),
    [anon_sym_LT_LT] = ACTIONS(5705),
    [anon_sym_GT_GT] = ACTIONS(5705),
    [anon_sym_EQ_EQ] = ACTIONS(5703),
    [anon_sym_BANG_EQ] = ACTIONS(5707),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5707),
    [anon_sym_LT_EQ_GT] = ACTIONS(5707),
    [anon_sym_EQ_TILDE] = ACTIONS(5707),
    [anon_sym_BANG_TILDE] = ACTIONS(5707),
    [anon_sym_LT_EQ] = ACTIONS(5695),
    [anon_sym_GT] = ACTIONS(5695),
    [anon_sym_GT_EQ] = ACTIONS(5709),
    [anon_sym_CARET] = ACTIONS(5689),
    [anon_sym_PLUS] = ACTIONS(5711),
    [anon_sym_SLASH] = ACTIONS(5691),
    [anon_sym_PERCENT] = ACTIONS(5691),
    [sym_comment] = ACTIONS(87),
  },
  [6085] = {
    [aux_sym_exceptions_repeat1] = STATE(8427),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_STAR_STAR] = ACTIONS(6193),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_RBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_PLUS_EQ] = ACTIONS(6191),
    [anon_sym_DASH_EQ] = ACTIONS(6191),
    [anon_sym_STAR_EQ] = ACTIONS(6191),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6191),
    [anon_sym_SLASH_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6191),
    [anon_sym_AMP_EQ] = ACTIONS(6191),
    [anon_sym_PERCENT_EQ] = ACTIONS(6191),
    [anon_sym_GT_GT_EQ] = ACTIONS(6191),
    [anon_sym_LT_LT_EQ] = ACTIONS(6191),
    [anon_sym_CARET_EQ] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6193),
    [anon_sym_AMP_AMP] = ACTIONS(6193),
    [anon_sym_LT_LT] = ACTIONS(6193),
    [anon_sym_GT_GT] = ACTIONS(6193),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6193),
    [anon_sym_PLUS] = ACTIONS(6193),
    [anon_sym_SLASH] = ACTIONS(6193),
    [anon_sym_PERCENT] = ACTIONS(6193),
    [sym_comment] = ACTIONS(87),
  },
  [6086] = {
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(5685),
    [sym__binary_star] = ACTIONS(5687),
    [anon_sym_LBRACE] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(5689),
    [anon_sym_STAR_STAR] = ACTIONS(5691),
    [anon_sym_AMP] = ACTIONS(5693),
    [anon_sym_EQ] = ACTIONS(7938),
    [anon_sym_LT] = ACTIONS(5695),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_EQ_GT] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_RBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_PLUS_EQ] = ACTIONS(6210),
    [anon_sym_DASH_EQ] = ACTIONS(6210),
    [anon_sym_STAR_EQ] = ACTIONS(6210),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6210),
    [anon_sym_SLASH_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6210),
    [anon_sym_AMP_EQ] = ACTIONS(6210),
    [anon_sym_PERCENT_EQ] = ACTIONS(6210),
    [anon_sym_GT_GT_EQ] = ACTIONS(6210),
    [anon_sym_LT_LT_EQ] = ACTIONS(6210),
    [anon_sym_CARET_EQ] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(5697),
    [anon_sym_DOT_DOT] = ACTIONS(5699),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5701),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(5703),
    [anon_sym_AMP_AMP] = ACTIONS(5703),
    [anon_sym_LT_LT] = ACTIONS(5705),
    [anon_sym_GT_GT] = ACTIONS(5705),
    [anon_sym_EQ_EQ] = ACTIONS(5703),
    [anon_sym_BANG_EQ] = ACTIONS(5707),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5707),
    [anon_sym_LT_EQ_GT] = ACTIONS(5707),
    [anon_sym_EQ_TILDE] = ACTIONS(5707),
    [anon_sym_BANG_TILDE] = ACTIONS(5707),
    [anon_sym_LT_EQ] = ACTIONS(5695),
    [anon_sym_GT] = ACTIONS(5695),
    [anon_sym_GT_EQ] = ACTIONS(5709),
    [anon_sym_CARET] = ACTIONS(5689),
    [anon_sym_PLUS] = ACTIONS(5711),
    [anon_sym_SLASH] = ACTIONS(5691),
    [anon_sym_PERCENT] = ACTIONS(5691),
    [sym_comment] = ACTIONS(87),
  },
  [6087] = {
    [sym_string] = STATE(6087),
    [aux_sym_chained_string_repeat1] = STATE(6087),
    [sym__string_start] = ACTIONS(10559),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_STAR_STAR] = ACTIONS(6217),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_EQ] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_do] = ACTIONS(6212),
    [anon_sym_EQ_GT] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_RBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_PLUS_EQ] = ACTIONS(6212),
    [anon_sym_DASH_EQ] = ACTIONS(6212),
    [anon_sym_STAR_EQ] = ACTIONS(6212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6212),
    [anon_sym_SLASH_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6212),
    [anon_sym_AMP_EQ] = ACTIONS(6212),
    [anon_sym_PERCENT_EQ] = ACTIONS(6212),
    [anon_sym_GT_GT_EQ] = ACTIONS(6212),
    [anon_sym_LT_LT_EQ] = ACTIONS(6212),
    [anon_sym_CARET_EQ] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6217),
    [anon_sym_AMP_AMP] = ACTIONS(6217),
    [anon_sym_LT_LT] = ACTIONS(6217),
    [anon_sym_GT_GT] = ACTIONS(6217),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6217),
    [anon_sym_PLUS] = ACTIONS(6217),
    [anon_sym_SLASH] = ACTIONS(6217),
    [anon_sym_PERCENT] = ACTIONS(6217),
    [sym_comment] = ACTIONS(87),
  },
  [6088] = {
    [sym__heredoc_body_start] = ACTIONS(10986),
    [anon_sym_LBRACE] = ACTIONS(10986),
    [anon_sym_RPAREN] = ACTIONS(10986),
    [anon_sym_DOT] = ACTIONS(10986),
    [anon_sym_COMMA] = ACTIONS(10986),
    [anon_sym_EQ] = ACTIONS(10986),
    [anon_sym_in] = ACTIONS(10986),
    [anon_sym_do] = ACTIONS(10986),
    [anon_sym_LBRACK] = ACTIONS(10986),
    [anon_sym_RBRACK] = ACTIONS(10986),
    [anon_sym_COLON_COLON2] = ACTIONS(10986),
    [anon_sym_AMP_DOT] = ACTIONS(10986),
    [sym_comment] = ACTIONS(87),
  },
  [6089] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(346),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(352),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(352),
    [sym__argument] = STATE(6088),
    [sym_splat_argument] = STATE(6088),
    [sym_hash_splat_argument] = STATE(6088),
    [sym_block_argument] = STATE(6088),
    [sym_assignment] = STATE(346),
    [sym_operator_assignment] = STATE(346),
    [sym_conditional] = STATE(346),
    [sym_range] = STATE(346),
    [sym_binary] = STATE(346),
    [sym_unary] = STATE(346),
    [sym_left_assignment_list] = STATE(351),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(352),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(352),
    [sym_false] = STATE(352),
    [sym_nil] = STATE(352),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(353),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(6088),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(593),
    [sym__splat_star] = ACTIONS(595),
    [sym__unary_minus] = ACTIONS(597),
    [sym__identifier_hash_key] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(11989),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6090] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(346),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(352),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(352),
    [sym__argument] = STATE(3454),
    [sym_splat_argument] = STATE(3454),
    [sym_hash_splat_argument] = STATE(3454),
    [sym_block_argument] = STATE(3454),
    [sym_assignment] = STATE(346),
    [sym_operator_assignment] = STATE(346),
    [sym_conditional] = STATE(346),
    [sym_range] = STATE(346),
    [sym_binary] = STATE(346),
    [sym_unary] = STATE(346),
    [sym_left_assignment_list] = STATE(351),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(352),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(352),
    [sym_false] = STATE(352),
    [sym_nil] = STATE(352),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(353),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_heredoc_body] = STATE(8428),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(3454),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(593),
    [sym__splat_star] = ACTIONS(595),
    [sym__unary_minus] = ACTIONS(597),
    [sym__identifier_hash_key] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6091] = {
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(2359),
    [sym__binary_star] = ACTIONS(2361),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(2363),
    [anon_sym_STAR_STAR] = ACTIONS(2361),
    [anon_sym_AMP] = ACTIONS(2365),
    [anon_sym_LT] = ACTIONS(2367),
    [anon_sym_EQ_GT] = ACTIONS(4247),
    [anon_sym_RBRACK] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(2369),
    [anon_sym_DOT_DOT] = ACTIONS(2371),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2373),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(2377),
    [anon_sym_AMP_AMP] = ACTIONS(2377),
    [anon_sym_LT_LT] = ACTIONS(2379),
    [anon_sym_GT_GT] = ACTIONS(2379),
    [anon_sym_EQ_EQ] = ACTIONS(2381),
    [anon_sym_BANG_EQ] = ACTIONS(2377),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2377),
    [anon_sym_LT_EQ_GT] = ACTIONS(2377),
    [anon_sym_EQ_TILDE] = ACTIONS(2377),
    [anon_sym_BANG_TILDE] = ACTIONS(2377),
    [anon_sym_LT_EQ] = ACTIONS(2367),
    [anon_sym_GT] = ACTIONS(2367),
    [anon_sym_GT_EQ] = ACTIONS(2383),
    [anon_sym_CARET] = ACTIONS(2385),
    [anon_sym_PLUS] = ACTIONS(2359),
    [anon_sym_SLASH] = ACTIONS(2361),
    [anon_sym_PERCENT] = ACTIONS(2361),
    [sym_comment] = ACTIONS(87),
  },
  [6092] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(3460),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(352),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(352),
    [sym_splat_argument] = STATE(8429),
    [sym_assignment] = STATE(3460),
    [sym_operator_assignment] = STATE(3460),
    [sym_conditional] = STATE(3460),
    [sym_range] = STATE(3460),
    [sym_binary] = STATE(3460),
    [sym_unary] = STATE(3460),
    [sym__arg_or_splat_arg] = STATE(8429),
    [sym_left_assignment_list] = STATE(351),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(352),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(352),
    [sym_false] = STATE(352),
    [sym_nil] = STATE(352),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1291),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(5733),
    [sym__unary_minus] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6093] = {
    [aux_sym_exceptions_repeat1] = STATE(8430),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_COMMA] = ACTIONS(11991),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_EQ_GT] = ACTIONS(9855),
    [anon_sym_RBRACK] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [6094] = {
    [sym__simple_symbol] = ACTIONS(11993),
    [sym__string_start] = ACTIONS(11993),
    [sym__symbol_start] = ACTIONS(11993),
    [sym__subshell_start] = ACTIONS(11993),
    [sym__regex_start] = ACTIONS(11993),
    [sym__string_array_start] = ACTIONS(11993),
    [sym__symbol_array_start] = ACTIONS(11993),
    [sym_heredoc_beginning] = ACTIONS(11993),
    [sym__unary_minus] = ACTIONS(11993),
    [anon_sym_BEGIN] = ACTIONS(11995),
    [anon_sym_LBRACE] = ACTIONS(11993),
    [anon_sym_RBRACE] = ACTIONS(11993),
    [anon_sym_END] = ACTIONS(11995),
    [anon_sym_def] = ACTIONS(11995),
    [anon_sym_LPAREN] = ACTIONS(11993),
    [anon_sym_COLON_COLON] = ACTIONS(11993),
    [anon_sym_SEMI] = ACTIONS(11993),
    [anon_sym_STAR] = ACTIONS(11993),
    [anon_sym_class] = ACTIONS(11995),
    [anon_sym_module] = ACTIONS(11995),
    [anon_sym_return] = ACTIONS(11995),
    [anon_sym_yield] = ACTIONS(11995),
    [anon_sym_break] = ACTIONS(11995),
    [anon_sym_next] = ACTIONS(11995),
    [sym_redo] = ACTIONS(11995),
    [sym_retry] = ACTIONS(11995),
    [anon_sym_if] = ACTIONS(11995),
    [anon_sym_unless] = ACTIONS(11995),
    [anon_sym_while] = ACTIONS(11995),
    [anon_sym_until] = ACTIONS(11995),
    [anon_sym_for] = ACTIONS(11995),
    [anon_sym_case] = ACTIONS(11995),
    [anon_sym_begin] = ACTIONS(11995),
    [anon_sym_PLUS] = ACTIONS(11995),
    [anon_sym_defined_QMARK] = ACTIONS(11993),
    [anon_sym_not] = ACTIONS(11995),
    [anon_sym_BANG] = ACTIONS(11993),
    [anon_sym_TILDE] = ACTIONS(11993),
    [sym_constant] = ACTIONS(11995),
    [sym_identifier] = ACTIONS(11995),
    [sym_instance_variable] = ACTIONS(11993),
    [sym_class_variable] = ACTIONS(11993),
    [sym_global_variable] = ACTIONS(11993),
    [anon_sym_undef] = ACTIONS(11995),
    [anon_sym_alias] = ACTIONS(11995),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(11995),
    [sym_float] = ACTIONS(11995),
    [sym_complex] = ACTIONS(11993),
    [sym_super] = ACTIONS(11995),
    [anon_sym_true] = ACTIONS(11995),
    [anon_sym_TRUE] = ACTIONS(11995),
    [anon_sym_false] = ACTIONS(11995),
    [anon_sym_FALSE] = ACTIONS(11995),
    [sym_self] = ACTIONS(11995),
    [anon_sym_nil] = ACTIONS(11995),
    [anon_sym_NIL] = ACTIONS(11995),
    [sym_character] = ACTIONS(11993),
    [anon_sym_LBRACK2] = ACTIONS(11993),
    [anon_sym_DASH_GT] = ACTIONS(11993),
  },
  [6095] = {
    [sym_identifier] = ACTIONS(11997),
    [sym_comment] = ACTIONS(87),
  },
  [6096] = {
    [aux_sym_block_parameters_repeat1] = STATE(8434),
    [anon_sym_COMMA] = ACTIONS(11999),
    [anon_sym_PIPE] = ACTIONS(12001),
    [sym_comment] = ACTIONS(87),
  },
  [6097] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(8442),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(8445),
    [sym_scope_resolution] = STATE(8443),
    [sym_call] = STATE(8443),
    [sym_method_call] = STATE(8445),
    [sym_assignment] = STATE(8442),
    [sym_operator_assignment] = STATE(8442),
    [sym_conditional] = STATE(8442),
    [sym_range] = STATE(8442),
    [sym_binary] = STATE(8442),
    [sym_unary] = STATE(8442),
    [sym_left_assignment_list] = STATE(8444),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(8445),
    [sym__variable] = STATE(8443),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(8445),
    [sym_false] = STATE(8445),
    [sym_nil] = STATE(8445),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(8446),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(12003),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_COMMA] = ACTIONS(5783),
    [anon_sym_PIPE] = ACTIONS(5783),
    [anon_sym_SEMI] = ACTIONS(5783),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(12005),
    [anon_sym_yield] = ACTIONS(12007),
    [anon_sym_break] = ACTIONS(12009),
    [anon_sym_next] = ACTIONS(12011),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(12013),
    [anon_sym_defined_QMARK] = ACTIONS(12015),
    [anon_sym_not] = ACTIONS(12017),
    [anon_sym_BANG] = ACTIONS(12019),
    [anon_sym_TILDE] = ACTIONS(12019),
    [sym_constant] = ACTIONS(12021),
    [sym_identifier] = ACTIONS(12021),
    [sym_instance_variable] = ACTIONS(12023),
    [sym_class_variable] = ACTIONS(12023),
    [sym_global_variable] = ACTIONS(12023),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(12021),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(12021),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6098] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(8447),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(8445),
    [sym_scope_resolution] = STATE(8443),
    [sym_call] = STATE(8443),
    [sym_method_call] = STATE(8445),
    [sym_assignment] = STATE(8447),
    [sym_operator_assignment] = STATE(8447),
    [sym_conditional] = STATE(8447),
    [sym_range] = STATE(8447),
    [sym_binary] = STATE(8447),
    [sym_unary] = STATE(8447),
    [sym_left_assignment_list] = STATE(8444),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(8445),
    [sym__variable] = STATE(8443),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(8445),
    [sym_false] = STATE(8445),
    [sym_nil] = STATE(8445),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(8446),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(12003),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(12005),
    [anon_sym_yield] = ACTIONS(12007),
    [anon_sym_break] = ACTIONS(12009),
    [anon_sym_next] = ACTIONS(12011),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(12013),
    [anon_sym_defined_QMARK] = ACTIONS(12015),
    [anon_sym_not] = ACTIONS(12017),
    [anon_sym_BANG] = ACTIONS(12019),
    [anon_sym_TILDE] = ACTIONS(12019),
    [sym_constant] = ACTIONS(12021),
    [sym_identifier] = ACTIONS(12021),
    [sym_instance_variable] = ACTIONS(12023),
    [sym_class_variable] = ACTIONS(12023),
    [sym_global_variable] = ACTIONS(12023),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(12021),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(12021),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6099] = {
    [sym__formal_parameter] = STATE(6106),
    [sym__simple_formal_parameter] = STATE(6106),
    [sym_destructured_parameter] = STATE(6106),
    [sym_splat_parameter] = STATE(6106),
    [sym_hash_splat_parameter] = STATE(6106),
    [sym_block_parameter] = STATE(6106),
    [sym_keyword_parameter] = STATE(6106),
    [sym_optional_parameter] = STATE(6106),
    [anon_sym_LPAREN] = ACTIONS(2447),
    [anon_sym_PIPE] = ACTIONS(12001),
    [anon_sym_SEMI] = ACTIONS(12025),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [sym_identifier] = ACTIONS(5745),
    [sym_comment] = ACTIONS(87),
  },
  [6100] = {
    [aux_sym_method_parameters_repeat1] = STATE(8450),
    [anon_sym_COMMA] = ACTIONS(12027),
    [anon_sym_PIPE] = ACTIONS(12001),
    [anon_sym_SEMI] = ACTIONS(12025),
    [sym_comment] = ACTIONS(87),
  },
  [6101] = {
    [sym__line_break] = ACTIONS(12029),
    [sym__heredoc_body_start] = ACTIONS(12029),
    [sym__binary_minus] = ACTIONS(12029),
    [sym__binary_star] = ACTIONS(12029),
    [ts_builtin_sym_end] = ACTIONS(12029),
    [anon_sym___END__] = ACTIONS(12029),
    [anon_sym_LBRACE] = ACTIONS(12029),
    [anon_sym_RBRACE] = ACTIONS(12029),
    [anon_sym_RPAREN] = ACTIONS(12029),
    [anon_sym_DOT] = ACTIONS(12031),
    [anon_sym_COMMA] = ACTIONS(12029),
    [anon_sym_PIPE] = ACTIONS(12031),
    [anon_sym_SEMI] = ACTIONS(12029),
    [anon_sym_STAR_STAR] = ACTIONS(12029),
    [anon_sym_AMP] = ACTIONS(12031),
    [anon_sym_LT] = ACTIONS(12031),
    [anon_sym_end] = ACTIONS(12029),
    [anon_sym_if] = ACTIONS(12029),
    [anon_sym_unless] = ACTIONS(12029),
    [anon_sym_while] = ACTIONS(12029),
    [anon_sym_until] = ACTIONS(12029),
    [anon_sym_rescue] = ACTIONS(12029),
    [anon_sym_do] = ACTIONS(12029),
    [anon_sym_when] = ACTIONS(12029),
    [anon_sym_elsif] = ACTIONS(12029),
    [anon_sym_else] = ACTIONS(12029),
    [anon_sym_then] = ACTIONS(12029),
    [anon_sym_ensure] = ACTIONS(12029),
    [anon_sym_EQ_GT] = ACTIONS(12029),
    [anon_sym_LBRACK] = ACTIONS(12029),
    [anon_sym_COLON_COLON2] = ACTIONS(12029),
    [anon_sym_AMP_DOT] = ACTIONS(12029),
    [anon_sym_QMARK] = ACTIONS(12029),
    [anon_sym_DOT_DOT] = ACTIONS(12031),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12029),
    [anon_sym_and] = ACTIONS(12029),
    [anon_sym_or] = ACTIONS(12029),
    [anon_sym_PIPE_PIPE] = ACTIONS(12029),
    [anon_sym_AMP_AMP] = ACTIONS(12029),
    [anon_sym_LT_LT] = ACTIONS(12029),
    [anon_sym_GT_GT] = ACTIONS(12029),
    [anon_sym_EQ_EQ] = ACTIONS(12031),
    [anon_sym_BANG_EQ] = ACTIONS(12029),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12029),
    [anon_sym_LT_EQ_GT] = ACTIONS(12029),
    [anon_sym_EQ_TILDE] = ACTIONS(12029),
    [anon_sym_BANG_TILDE] = ACTIONS(12029),
    [anon_sym_LT_EQ] = ACTIONS(12031),
    [anon_sym_GT] = ACTIONS(12031),
    [anon_sym_GT_EQ] = ACTIONS(12029),
    [anon_sym_CARET] = ACTIONS(12029),
    [anon_sym_PLUS] = ACTIONS(12029),
    [anon_sym_SLASH] = ACTIONS(12029),
    [anon_sym_PERCENT] = ACTIONS(12029),
    [sym_comment] = ACTIONS(87),
  },
  [6102] = {
    [anon_sym_RPAREN] = ACTIONS(12033),
    [anon_sym_COMMA] = ACTIONS(12033),
    [anon_sym_PIPE] = ACTIONS(12033),
    [anon_sym_SEMI] = ACTIONS(12033),
    [sym_comment] = ACTIONS(87),
  },
  [6103] = {
    [aux_sym_method_parameters_repeat1] = STATE(6108),
    [anon_sym_RPAREN] = ACTIONS(12035),
    [anon_sym_COMMA] = ACTIONS(5757),
    [sym_comment] = ACTIONS(87),
  },
  [6104] = {
    [sym__binary_minus] = ACTIONS(10638),
    [sym__binary_star] = ACTIONS(10640),
    [anon_sym_RPAREN] = ACTIONS(9460),
    [anon_sym_COMMA] = ACTIONS(9460),
    [anon_sym_PIPE] = ACTIONS(10642),
    [anon_sym_STAR_STAR] = ACTIONS(10640),
    [anon_sym_AMP] = ACTIONS(10644),
    [anon_sym_LT] = ACTIONS(10646),
    [anon_sym_QMARK] = ACTIONS(10648),
    [anon_sym_DOT_DOT] = ACTIONS(10650),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10652),
    [anon_sym_and] = ACTIONS(12037),
    [anon_sym_or] = ACTIONS(12037),
    [anon_sym_PIPE_PIPE] = ACTIONS(10654),
    [anon_sym_AMP_AMP] = ACTIONS(10654),
    [anon_sym_LT_LT] = ACTIONS(10656),
    [anon_sym_GT_GT] = ACTIONS(10656),
    [anon_sym_EQ_EQ] = ACTIONS(10658),
    [anon_sym_BANG_EQ] = ACTIONS(10654),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10654),
    [anon_sym_LT_EQ_GT] = ACTIONS(10654),
    [anon_sym_EQ_TILDE] = ACTIONS(10654),
    [anon_sym_BANG_TILDE] = ACTIONS(10654),
    [anon_sym_LT_EQ] = ACTIONS(10646),
    [anon_sym_GT] = ACTIONS(10646),
    [anon_sym_GT_EQ] = ACTIONS(10660),
    [anon_sym_CARET] = ACTIONS(10662),
    [anon_sym_PLUS] = ACTIONS(10638),
    [anon_sym_SLASH] = ACTIONS(10640),
    [anon_sym_PERCENT] = ACTIONS(10640),
    [sym_comment] = ACTIONS(87),
  },
  [6105] = {
    [sym__binary_minus] = ACTIONS(10638),
    [sym__binary_star] = ACTIONS(10640),
    [anon_sym_RPAREN] = ACTIONS(9494),
    [anon_sym_COMMA] = ACTIONS(9494),
    [anon_sym_PIPE] = ACTIONS(10642),
    [anon_sym_STAR_STAR] = ACTIONS(10640),
    [anon_sym_AMP] = ACTIONS(10644),
    [anon_sym_LT] = ACTIONS(10646),
    [anon_sym_QMARK] = ACTIONS(10648),
    [anon_sym_DOT_DOT] = ACTIONS(10650),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10652),
    [anon_sym_and] = ACTIONS(12037),
    [anon_sym_or] = ACTIONS(12037),
    [anon_sym_PIPE_PIPE] = ACTIONS(10654),
    [anon_sym_AMP_AMP] = ACTIONS(10654),
    [anon_sym_LT_LT] = ACTIONS(10656),
    [anon_sym_GT_GT] = ACTIONS(10656),
    [anon_sym_EQ_EQ] = ACTIONS(10658),
    [anon_sym_BANG_EQ] = ACTIONS(10654),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10654),
    [anon_sym_LT_EQ_GT] = ACTIONS(10654),
    [anon_sym_EQ_TILDE] = ACTIONS(10654),
    [anon_sym_BANG_TILDE] = ACTIONS(10654),
    [anon_sym_LT_EQ] = ACTIONS(10646),
    [anon_sym_GT] = ACTIONS(10646),
    [anon_sym_GT_EQ] = ACTIONS(10660),
    [anon_sym_CARET] = ACTIONS(10662),
    [anon_sym_PLUS] = ACTIONS(10638),
    [anon_sym_SLASH] = ACTIONS(10640),
    [anon_sym_PERCENT] = ACTIONS(10640),
    [sym_comment] = ACTIONS(87),
  },
  [6106] = {
    [anon_sym_RPAREN] = ACTIONS(12039),
    [anon_sym_COMMA] = ACTIONS(12039),
    [anon_sym_PIPE] = ACTIONS(12039),
    [anon_sym_SEMI] = ACTIONS(12039),
    [sym_comment] = ACTIONS(87),
  },
  [6107] = {
    [anon_sym_LBRACE] = ACTIONS(12041),
    [anon_sym_do] = ACTIONS(12041),
    [sym_comment] = ACTIONS(87),
  },
  [6108] = {
    [aux_sym_method_parameters_repeat1] = STATE(6108),
    [anon_sym_RPAREN] = ACTIONS(12039),
    [anon_sym_COMMA] = ACTIONS(12043),
    [sym_comment] = ACTIONS(87),
  },
  [6109] = {
    [sym__line_break] = ACTIONS(11993),
    [sym__simple_symbol] = ACTIONS(11993),
    [sym__string_start] = ACTIONS(11993),
    [sym__symbol_start] = ACTIONS(11993),
    [sym__subshell_start] = ACTIONS(11993),
    [sym__regex_start] = ACTIONS(11993),
    [sym__string_array_start] = ACTIONS(11993),
    [sym__symbol_array_start] = ACTIONS(11993),
    [sym__heredoc_body_start] = ACTIONS(11993),
    [sym_heredoc_beginning] = ACTIONS(11993),
    [sym__unary_minus] = ACTIONS(11993),
    [anon_sym_BEGIN] = ACTIONS(11995),
    [anon_sym_LBRACE] = ACTIONS(11993),
    [anon_sym_END] = ACTIONS(11995),
    [anon_sym_def] = ACTIONS(11995),
    [anon_sym_LPAREN] = ACTIONS(11993),
    [anon_sym_COLON_COLON] = ACTIONS(11993),
    [anon_sym_SEMI] = ACTIONS(11993),
    [anon_sym_STAR] = ACTIONS(11993),
    [anon_sym_class] = ACTIONS(11995),
    [anon_sym_module] = ACTIONS(11995),
    [anon_sym_end] = ACTIONS(11995),
    [anon_sym_return] = ACTIONS(11995),
    [anon_sym_yield] = ACTIONS(11995),
    [anon_sym_break] = ACTIONS(11995),
    [anon_sym_next] = ACTIONS(11995),
    [sym_redo] = ACTIONS(11995),
    [sym_retry] = ACTIONS(11995),
    [anon_sym_if] = ACTIONS(11995),
    [anon_sym_unless] = ACTIONS(11995),
    [anon_sym_while] = ACTIONS(11995),
    [anon_sym_until] = ACTIONS(11995),
    [anon_sym_for] = ACTIONS(11995),
    [anon_sym_case] = ACTIONS(11995),
    [anon_sym_begin] = ACTIONS(11995),
    [anon_sym_PLUS] = ACTIONS(11995),
    [anon_sym_defined_QMARK] = ACTIONS(11993),
    [anon_sym_not] = ACTIONS(11995),
    [anon_sym_BANG] = ACTIONS(11993),
    [anon_sym_TILDE] = ACTIONS(11993),
    [sym_constant] = ACTIONS(11995),
    [sym_identifier] = ACTIONS(11995),
    [sym_instance_variable] = ACTIONS(11993),
    [sym_class_variable] = ACTIONS(11993),
    [sym_global_variable] = ACTIONS(11993),
    [anon_sym_undef] = ACTIONS(11995),
    [anon_sym_alias] = ACTIONS(11995),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(11995),
    [sym_float] = ACTIONS(11995),
    [sym_complex] = ACTIONS(11993),
    [sym_super] = ACTIONS(11995),
    [anon_sym_true] = ACTIONS(11995),
    [anon_sym_TRUE] = ACTIONS(11995),
    [anon_sym_false] = ACTIONS(11995),
    [anon_sym_FALSE] = ACTIONS(11995),
    [sym_self] = ACTIONS(11995),
    [anon_sym_nil] = ACTIONS(11995),
    [anon_sym_NIL] = ACTIONS(11995),
    [sym_character] = ACTIONS(11993),
    [anon_sym_LBRACK2] = ACTIONS(11993),
    [anon_sym_DASH_GT] = ACTIONS(11993),
  },
  [6110] = {
    [sym_identifier] = ACTIONS(12046),
    [sym_comment] = ACTIONS(87),
  },
  [6111] = {
    [aux_sym_block_parameters_repeat1] = STATE(8454),
    [anon_sym_COMMA] = ACTIONS(11999),
    [anon_sym_PIPE] = ACTIONS(12048),
    [sym_comment] = ACTIONS(87),
  },
  [6112] = {
    [sym__formal_parameter] = STATE(6106),
    [sym__simple_formal_parameter] = STATE(6106),
    [sym_destructured_parameter] = STATE(6106),
    [sym_splat_parameter] = STATE(6106),
    [sym_hash_splat_parameter] = STATE(6106),
    [sym_block_parameter] = STATE(6106),
    [sym_keyword_parameter] = STATE(6106),
    [sym_optional_parameter] = STATE(6106),
    [anon_sym_LPAREN] = ACTIONS(2447),
    [anon_sym_PIPE] = ACTIONS(12048),
    [anon_sym_SEMI] = ACTIONS(12050),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [sym_identifier] = ACTIONS(5745),
    [sym_comment] = ACTIONS(87),
  },
  [6113] = {
    [aux_sym_method_parameters_repeat1] = STATE(8450),
    [anon_sym_COMMA] = ACTIONS(12052),
    [anon_sym_PIPE] = ACTIONS(12048),
    [anon_sym_SEMI] = ACTIONS(12050),
    [sym_comment] = ACTIONS(87),
  },
  [6114] = {
    [sym__line_break] = ACTIONS(12054),
    [sym__heredoc_body_start] = ACTIONS(12054),
    [sym__binary_minus] = ACTIONS(12054),
    [sym__binary_star] = ACTIONS(12054),
    [ts_builtin_sym_end] = ACTIONS(12054),
    [anon_sym___END__] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_RBRACE] = ACTIONS(12054),
    [anon_sym_RPAREN] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12056),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_PIPE] = ACTIONS(12056),
    [anon_sym_SEMI] = ACTIONS(12054),
    [anon_sym_STAR_STAR] = ACTIONS(12054),
    [anon_sym_AMP] = ACTIONS(12056),
    [anon_sym_LT] = ACTIONS(12056),
    [anon_sym_end] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_unless] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [anon_sym_until] = ACTIONS(12054),
    [anon_sym_rescue] = ACTIONS(12054),
    [anon_sym_do] = ACTIONS(12054),
    [anon_sym_when] = ACTIONS(12054),
    [anon_sym_elsif] = ACTIONS(12054),
    [anon_sym_else] = ACTIONS(12054),
    [anon_sym_then] = ACTIONS(12054),
    [anon_sym_ensure] = ACTIONS(12054),
    [anon_sym_EQ_GT] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_COLON_COLON2] = ACTIONS(12054),
    [anon_sym_AMP_DOT] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_DOT_DOT] = ACTIONS(12056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_and] = ACTIONS(12054),
    [anon_sym_or] = ACTIONS(12054),
    [anon_sym_PIPE_PIPE] = ACTIONS(12054),
    [anon_sym_AMP_AMP] = ACTIONS(12054),
    [anon_sym_LT_LT] = ACTIONS(12054),
    [anon_sym_GT_GT] = ACTIONS(12054),
    [anon_sym_EQ_EQ] = ACTIONS(12056),
    [anon_sym_BANG_EQ] = ACTIONS(12054),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12054),
    [anon_sym_LT_EQ_GT] = ACTIONS(12054),
    [anon_sym_EQ_TILDE] = ACTIONS(12054),
    [anon_sym_BANG_TILDE] = ACTIONS(12054),
    [anon_sym_LT_EQ] = ACTIONS(12056),
    [anon_sym_GT] = ACTIONS(12056),
    [anon_sym_GT_EQ] = ACTIONS(12054),
    [anon_sym_CARET] = ACTIONS(12054),
    [anon_sym_PLUS] = ACTIONS(12054),
    [anon_sym_SLASH] = ACTIONS(12054),
    [anon_sym_PERCENT] = ACTIONS(12054),
    [sym_comment] = ACTIONS(87),
  },
  [6115] = {
    [anon_sym_end] = ACTIONS(12058),
    [sym_comment] = ACTIONS(87),
  },
  [6116] = {
    [sym__statements] = STATE(8458),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12060),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6117] = {
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(9458),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [6118] = {
    [sym__binary_minus] = ACTIONS(9456),
    [sym__binary_star] = ACTIONS(9458),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(9462),
    [anon_sym_STAR_STAR] = ACTIONS(9458),
    [anon_sym_AMP] = ACTIONS(9464),
    [anon_sym_LT] = ACTIONS(9466),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(9468),
    [anon_sym_DOT_DOT] = ACTIONS(9470),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9472),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(9476),
    [anon_sym_AMP_AMP] = ACTIONS(9476),
    [anon_sym_LT_LT] = ACTIONS(9478),
    [anon_sym_GT_GT] = ACTIONS(9478),
    [anon_sym_EQ_EQ] = ACTIONS(9480),
    [anon_sym_BANG_EQ] = ACTIONS(9476),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9476),
    [anon_sym_LT_EQ_GT] = ACTIONS(9476),
    [anon_sym_EQ_TILDE] = ACTIONS(9476),
    [anon_sym_BANG_TILDE] = ACTIONS(9476),
    [anon_sym_LT_EQ] = ACTIONS(9466),
    [anon_sym_GT] = ACTIONS(9466),
    [anon_sym_GT_EQ] = ACTIONS(9482),
    [anon_sym_CARET] = ACTIONS(9484),
    [anon_sym_PLUS] = ACTIONS(9456),
    [anon_sym_SLASH] = ACTIONS(9458),
    [anon_sym_PERCENT] = ACTIONS(9458),
    [sym_comment] = ACTIONS(87),
  },
  [6119] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(8459),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(3496),
    [sym_scope_resolution] = STATE(3494),
    [sym_call] = STATE(3494),
    [sym_method_call] = STATE(3496),
    [sym_assignment] = STATE(8459),
    [sym_operator_assignment] = STATE(8459),
    [sym_conditional] = STATE(8459),
    [sym_range] = STATE(8459),
    [sym_binary] = STATE(8459),
    [sym_unary] = STATE(8459),
    [sym_left_assignment_list] = STATE(3495),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3496),
    [sym__variable] = STATE(3494),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(3496),
    [sym_false] = STATE(3496),
    [sym_nil] = STATE(3496),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(5781),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5785),
    [anon_sym_yield] = ACTIONS(5787),
    [anon_sym_break] = ACTIONS(5789),
    [anon_sym_next] = ACTIONS(5791),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5795),
    [anon_sym_defined_QMARK] = ACTIONS(5797),
    [anon_sym_not] = ACTIONS(5799),
    [anon_sym_BANG] = ACTIONS(5801),
    [anon_sym_TILDE] = ACTIONS(5801),
    [sym_constant] = ACTIONS(5803),
    [sym_identifier] = ACTIONS(5803),
    [sym_instance_variable] = ACTIONS(5805),
    [sym_class_variable] = ACTIONS(5805),
    [sym_global_variable] = ACTIONS(5805),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(5803),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(5803),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6120] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(8460),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(3496),
    [sym_scope_resolution] = STATE(3494),
    [sym_call] = STATE(3494),
    [sym_method_call] = STATE(3496),
    [sym_assignment] = STATE(8460),
    [sym_operator_assignment] = STATE(8460),
    [sym_conditional] = STATE(8460),
    [sym_range] = STATE(8460),
    [sym_binary] = STATE(8460),
    [sym_unary] = STATE(8460),
    [sym_left_assignment_list] = STATE(3495),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3496),
    [sym__variable] = STATE(3494),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(3496),
    [sym_false] = STATE(3496),
    [sym_nil] = STATE(3496),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(5781),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5785),
    [anon_sym_yield] = ACTIONS(5787),
    [anon_sym_break] = ACTIONS(5789),
    [anon_sym_next] = ACTIONS(5791),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5795),
    [anon_sym_defined_QMARK] = ACTIONS(5797),
    [anon_sym_not] = ACTIONS(5799),
    [anon_sym_BANG] = ACTIONS(5801),
    [anon_sym_TILDE] = ACTIONS(5801),
    [sym_constant] = ACTIONS(5803),
    [sym_identifier] = ACTIONS(5803),
    [sym_instance_variable] = ACTIONS(5805),
    [sym_class_variable] = ACTIONS(5805),
    [sym_global_variable] = ACTIONS(5805),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(5803),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(5803),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6121] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(8461),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(3496),
    [sym_scope_resolution] = STATE(3494),
    [sym_call] = STATE(3494),
    [sym_method_call] = STATE(3496),
    [sym_assignment] = STATE(8461),
    [sym_operator_assignment] = STATE(8461),
    [sym_conditional] = STATE(8461),
    [sym_range] = STATE(8461),
    [sym_binary] = STATE(8461),
    [sym_unary] = STATE(8461),
    [sym_left_assignment_list] = STATE(3495),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3496),
    [sym__variable] = STATE(3494),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(3496),
    [sym_false] = STATE(3496),
    [sym_nil] = STATE(3496),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(5781),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5785),
    [anon_sym_yield] = ACTIONS(5787),
    [anon_sym_break] = ACTIONS(5789),
    [anon_sym_next] = ACTIONS(5791),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5795),
    [anon_sym_defined_QMARK] = ACTIONS(5797),
    [anon_sym_not] = ACTIONS(5799),
    [anon_sym_BANG] = ACTIONS(5801),
    [anon_sym_TILDE] = ACTIONS(5801),
    [sym_constant] = ACTIONS(5803),
    [sym_identifier] = ACTIONS(5803),
    [sym_instance_variable] = ACTIONS(5805),
    [sym_class_variable] = ACTIONS(5805),
    [sym_global_variable] = ACTIONS(5805),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(5803),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(5803),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6122] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(8462),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(3496),
    [sym_scope_resolution] = STATE(3494),
    [sym_call] = STATE(3494),
    [sym_method_call] = STATE(3496),
    [sym_assignment] = STATE(8462),
    [sym_operator_assignment] = STATE(8462),
    [sym_conditional] = STATE(8462),
    [sym_range] = STATE(8462),
    [sym_binary] = STATE(8462),
    [sym_unary] = STATE(8462),
    [sym_left_assignment_list] = STATE(3495),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3496),
    [sym__variable] = STATE(3494),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(3496),
    [sym_false] = STATE(3496),
    [sym_nil] = STATE(3496),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(5781),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5785),
    [anon_sym_yield] = ACTIONS(5787),
    [anon_sym_break] = ACTIONS(5789),
    [anon_sym_next] = ACTIONS(5791),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5795),
    [anon_sym_defined_QMARK] = ACTIONS(5797),
    [anon_sym_not] = ACTIONS(5799),
    [anon_sym_BANG] = ACTIONS(5801),
    [anon_sym_TILDE] = ACTIONS(5801),
    [sym_constant] = ACTIONS(5803),
    [sym_identifier] = ACTIONS(5803),
    [sym_instance_variable] = ACTIONS(5805),
    [sym_class_variable] = ACTIONS(5805),
    [sym_global_variable] = ACTIONS(5805),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(5803),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(5803),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6123] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(8463),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(3496),
    [sym_scope_resolution] = STATE(3494),
    [sym_call] = STATE(3494),
    [sym_method_call] = STATE(3496),
    [sym_assignment] = STATE(8463),
    [sym_operator_assignment] = STATE(8463),
    [sym_conditional] = STATE(8463),
    [sym_range] = STATE(8463),
    [sym_binary] = STATE(8463),
    [sym_unary] = STATE(8463),
    [sym_left_assignment_list] = STATE(3495),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3496),
    [sym__variable] = STATE(3494),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(3496),
    [sym_false] = STATE(3496),
    [sym_nil] = STATE(3496),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(5781),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5785),
    [anon_sym_yield] = ACTIONS(5787),
    [anon_sym_break] = ACTIONS(5789),
    [anon_sym_next] = ACTIONS(5791),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5795),
    [anon_sym_defined_QMARK] = ACTIONS(5797),
    [anon_sym_not] = ACTIONS(5799),
    [anon_sym_BANG] = ACTIONS(5801),
    [anon_sym_TILDE] = ACTIONS(5801),
    [sym_constant] = ACTIONS(5803),
    [sym_identifier] = ACTIONS(5803),
    [sym_instance_variable] = ACTIONS(5805),
    [sym_class_variable] = ACTIONS(5805),
    [sym_global_variable] = ACTIONS(5805),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(5803),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(5803),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6124] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(8464),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(8464),
    [sym_operator_assignment] = STATE(8464),
    [sym_conditional] = STATE(8464),
    [sym_range] = STATE(8464),
    [sym_binary] = STATE(8464),
    [sym_unary] = STATE(8464),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6125] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(8465),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(3496),
    [sym_scope_resolution] = STATE(3494),
    [sym_call] = STATE(3494),
    [sym_method_call] = STATE(3496),
    [sym_assignment] = STATE(8465),
    [sym_operator_assignment] = STATE(8465),
    [sym_conditional] = STATE(8465),
    [sym_range] = STATE(8465),
    [sym_binary] = STATE(8465),
    [sym_unary] = STATE(8465),
    [sym_left_assignment_list] = STATE(3495),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3496),
    [sym__variable] = STATE(3494),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(3496),
    [sym_false] = STATE(3496),
    [sym_nil] = STATE(3496),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(5781),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5785),
    [anon_sym_yield] = ACTIONS(5787),
    [anon_sym_break] = ACTIONS(5789),
    [anon_sym_next] = ACTIONS(5791),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5795),
    [anon_sym_defined_QMARK] = ACTIONS(5797),
    [anon_sym_not] = ACTIONS(5799),
    [anon_sym_BANG] = ACTIONS(5801),
    [anon_sym_TILDE] = ACTIONS(5801),
    [sym_constant] = ACTIONS(5803),
    [sym_identifier] = ACTIONS(5803),
    [sym_instance_variable] = ACTIONS(5805),
    [sym_class_variable] = ACTIONS(5805),
    [sym_global_variable] = ACTIONS(5805),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(5803),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(5803),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6126] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(8466),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(3496),
    [sym_scope_resolution] = STATE(3494),
    [sym_call] = STATE(3494),
    [sym_method_call] = STATE(3496),
    [sym_assignment] = STATE(8466),
    [sym_operator_assignment] = STATE(8466),
    [sym_conditional] = STATE(8466),
    [sym_range] = STATE(8466),
    [sym_binary] = STATE(8466),
    [sym_unary] = STATE(8466),
    [sym_left_assignment_list] = STATE(3495),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3496),
    [sym__variable] = STATE(3494),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(3496),
    [sym_false] = STATE(3496),
    [sym_nil] = STATE(3496),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(5781),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5785),
    [anon_sym_yield] = ACTIONS(5787),
    [anon_sym_break] = ACTIONS(5789),
    [anon_sym_next] = ACTIONS(5791),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5795),
    [anon_sym_defined_QMARK] = ACTIONS(5797),
    [anon_sym_not] = ACTIONS(5799),
    [anon_sym_BANG] = ACTIONS(5801),
    [anon_sym_TILDE] = ACTIONS(5801),
    [sym_constant] = ACTIONS(5803),
    [sym_identifier] = ACTIONS(5803),
    [sym_instance_variable] = ACTIONS(5805),
    [sym_class_variable] = ACTIONS(5805),
    [sym_global_variable] = ACTIONS(5805),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(5803),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(5803),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6127] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(8467),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(3496),
    [sym_scope_resolution] = STATE(3494),
    [sym_call] = STATE(3494),
    [sym_method_call] = STATE(3496),
    [sym_assignment] = STATE(8467),
    [sym_operator_assignment] = STATE(8467),
    [sym_conditional] = STATE(8467),
    [sym_range] = STATE(8467),
    [sym_binary] = STATE(8467),
    [sym_unary] = STATE(8467),
    [sym_left_assignment_list] = STATE(3495),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3496),
    [sym__variable] = STATE(3494),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(3496),
    [sym_false] = STATE(3496),
    [sym_nil] = STATE(3496),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(5781),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5785),
    [anon_sym_yield] = ACTIONS(5787),
    [anon_sym_break] = ACTIONS(5789),
    [anon_sym_next] = ACTIONS(5791),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5795),
    [anon_sym_defined_QMARK] = ACTIONS(5797),
    [anon_sym_not] = ACTIONS(5799),
    [anon_sym_BANG] = ACTIONS(5801),
    [anon_sym_TILDE] = ACTIONS(5801),
    [sym_constant] = ACTIONS(5803),
    [sym_identifier] = ACTIONS(5803),
    [sym_instance_variable] = ACTIONS(5805),
    [sym_class_variable] = ACTIONS(5805),
    [sym_global_variable] = ACTIONS(5805),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(5803),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(5803),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6128] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(8468),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(3496),
    [sym_scope_resolution] = STATE(3494),
    [sym_call] = STATE(3494),
    [sym_method_call] = STATE(3496),
    [sym_assignment] = STATE(8468),
    [sym_operator_assignment] = STATE(8468),
    [sym_conditional] = STATE(8468),
    [sym_range] = STATE(8468),
    [sym_binary] = STATE(8468),
    [sym_unary] = STATE(8468),
    [sym_left_assignment_list] = STATE(3495),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3496),
    [sym__variable] = STATE(3494),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(3496),
    [sym_false] = STATE(3496),
    [sym_nil] = STATE(3496),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(5781),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5785),
    [anon_sym_yield] = ACTIONS(5787),
    [anon_sym_break] = ACTIONS(5789),
    [anon_sym_next] = ACTIONS(5791),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5795),
    [anon_sym_defined_QMARK] = ACTIONS(5797),
    [anon_sym_not] = ACTIONS(5799),
    [anon_sym_BANG] = ACTIONS(5801),
    [anon_sym_TILDE] = ACTIONS(5801),
    [sym_constant] = ACTIONS(5803),
    [sym_identifier] = ACTIONS(5803),
    [sym_instance_variable] = ACTIONS(5805),
    [sym_class_variable] = ACTIONS(5805),
    [sym_global_variable] = ACTIONS(5805),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(5803),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(5803),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6129] = {
    [sym__statements] = STATE(3947),
    [sym_begin_block] = STATE(489),
    [sym_end_block] = STATE(489),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_block_parameters] = STATE(3948),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1516),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1519),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1519),
    [sym_hash_splat_argument] = STATE(116),
    [sym_assignment] = STATE(1516),
    [sym_operator_assignment] = STATE(1516),
    [sym_conditional] = STATE(1516),
    [sym_range] = STATE(1516),
    [sym_binary] = STATE(1516),
    [sym_unary] = STATE(1516),
    [sym_left_assignment_list] = STATE(1518),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1519),
    [sym__variable] = STATE(1517),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1519),
    [sym_false] = STATE(1519),
    [sym_nil] = STATE(1519),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1520),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(1959),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym__hash_items] = STATE(1960),
    [sym_pair] = STATE(122),
    [sym_lambda] = STATE(214),
    [sym_empty_statement] = STATE(495),
    [aux_sym__statements_repeat1] = STATE(495),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2629),
    [sym__identifier_hash_key] = ACTIONS(157),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(12062),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_PIPE] = ACTIONS(2445),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2633),
    [anon_sym_yield] = ACTIONS(2635),
    [anon_sym_break] = ACTIONS(2637),
    [anon_sym_next] = ACTIONS(2639),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2641),
    [anon_sym_defined_QMARK] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2647),
    [anon_sym_TILDE] = ACTIONS(2647),
    [sym_constant] = ACTIONS(2649),
    [sym_identifier] = ACTIONS(2649),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6130] = {
    [sym_do_block] = STATE(3969),
    [sym_block] = STATE(3969),
    [sym__binary_minus] = ACTIONS(2717),
    [sym__binary_star] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(6565),
    [anon_sym_DOT] = ACTIONS(2721),
    [anon_sym_COMMA] = ACTIONS(2717),
    [anon_sym_PIPE] = ACTIONS(2721),
    [anon_sym_STAR_STAR] = ACTIONS(2721),
    [anon_sym_AMP] = ACTIONS(2721),
    [anon_sym_EQ] = ACTIONS(2721),
    [anon_sym_LT] = ACTIONS(2721),
    [anon_sym_do] = ACTIONS(2717),
    [anon_sym_LBRACK] = ACTIONS(2717),
    [anon_sym_COLON_COLON2] = ACTIONS(2717),
    [anon_sym_AMP_DOT] = ACTIONS(2717),
    [anon_sym_PLUS_EQ] = ACTIONS(2717),
    [anon_sym_DASH_EQ] = ACTIONS(2717),
    [anon_sym_STAR_EQ] = ACTIONS(2717),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2717),
    [anon_sym_SLASH_EQ] = ACTIONS(2717),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2717),
    [anon_sym_PIPE_EQ] = ACTIONS(2717),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2717),
    [anon_sym_AMP_EQ] = ACTIONS(2717),
    [anon_sym_PERCENT_EQ] = ACTIONS(2717),
    [anon_sym_GT_GT_EQ] = ACTIONS(2717),
    [anon_sym_LT_LT_EQ] = ACTIONS(2717),
    [anon_sym_CARET_EQ] = ACTIONS(2717),
    [anon_sym_QMARK] = ACTIONS(2717),
    [anon_sym_DOT_DOT] = ACTIONS(2721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2717),
    [anon_sym_and] = ACTIONS(2717),
    [anon_sym_or] = ACTIONS(2717),
    [anon_sym_PIPE_PIPE] = ACTIONS(2721),
    [anon_sym_AMP_AMP] = ACTIONS(2721),
    [anon_sym_LT_LT] = ACTIONS(2721),
    [anon_sym_GT_GT] = ACTIONS(2721),
    [anon_sym_EQ_EQ] = ACTIONS(2721),
    [anon_sym_BANG_EQ] = ACTIONS(2717),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2717),
    [anon_sym_LT_EQ_GT] = ACTIONS(2717),
    [anon_sym_EQ_TILDE] = ACTIONS(2717),
    [anon_sym_BANG_TILDE] = ACTIONS(2717),
    [anon_sym_LT_EQ] = ACTIONS(2721),
    [anon_sym_GT] = ACTIONS(2721),
    [anon_sym_GT_EQ] = ACTIONS(2717),
    [anon_sym_CARET] = ACTIONS(2721),
    [anon_sym_PLUS] = ACTIONS(2721),
    [anon_sym_SLASH] = ACTIONS(2721),
    [anon_sym_PERCENT] = ACTIONS(2721),
    [sym_comment] = ACTIONS(87),
  },
  [6131] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(8471),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(3496),
    [sym_scope_resolution] = STATE(3494),
    [sym_call] = STATE(3494),
    [sym_method_call] = STATE(3496),
    [sym_splat_argument] = STATE(8472),
    [sym_assignment] = STATE(8471),
    [sym_operator_assignment] = STATE(8471),
    [sym_conditional] = STATE(8471),
    [sym_range] = STATE(8471),
    [sym_binary] = STATE(8471),
    [sym_unary] = STATE(8471),
    [sym_right_assignment_list] = STATE(2035),
    [sym__arg_or_splat_arg] = STATE(8472),
    [sym_left_assignment_list] = STATE(3495),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3496),
    [sym__variable] = STATE(3494),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(3496),
    [sym_false] = STATE(3496),
    [sym_nil] = STATE(3496),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__splat_star] = ACTIONS(12064),
    [sym__unary_minus] = ACTIONS(5781),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5785),
    [anon_sym_yield] = ACTIONS(5787),
    [anon_sym_break] = ACTIONS(5789),
    [anon_sym_next] = ACTIONS(5791),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5795),
    [anon_sym_defined_QMARK] = ACTIONS(5797),
    [anon_sym_not] = ACTIONS(5799),
    [anon_sym_BANG] = ACTIONS(5801),
    [anon_sym_TILDE] = ACTIONS(5801),
    [sym_constant] = ACTIONS(5803),
    [sym_identifier] = ACTIONS(5803),
    [sym_instance_variable] = ACTIONS(5805),
    [sym_class_variable] = ACTIONS(5805),
    [sym_global_variable] = ACTIONS(5805),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(5803),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(5803),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6132] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(8473),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(3496),
    [sym_scope_resolution] = STATE(3494),
    [sym_call] = STATE(3494),
    [sym_method_call] = STATE(3496),
    [sym_assignment] = STATE(8473),
    [sym_operator_assignment] = STATE(8473),
    [sym_conditional] = STATE(8473),
    [sym_range] = STATE(8473),
    [sym_binary] = STATE(8473),
    [sym_unary] = STATE(8473),
    [sym_left_assignment_list] = STATE(3495),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3496),
    [sym__variable] = STATE(3494),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(3496),
    [sym_false] = STATE(3496),
    [sym_nil] = STATE(3496),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(5781),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5785),
    [anon_sym_yield] = ACTIONS(5787),
    [anon_sym_break] = ACTIONS(5789),
    [anon_sym_next] = ACTIONS(5791),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5795),
    [anon_sym_defined_QMARK] = ACTIONS(5797),
    [anon_sym_not] = ACTIONS(5799),
    [anon_sym_BANG] = ACTIONS(5801),
    [anon_sym_TILDE] = ACTIONS(5801),
    [sym_constant] = ACTIONS(5803),
    [sym_identifier] = ACTIONS(5803),
    [sym_instance_variable] = ACTIONS(5805),
    [sym_class_variable] = ACTIONS(5805),
    [sym_global_variable] = ACTIONS(5805),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(5803),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(5803),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6133] = {
    [sym_string] = STATE(8474),
    [aux_sym_chained_string_repeat1] = STATE(8474),
    [sym__string_start] = ACTIONS(139),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [6134] = {
    [sym__string_start] = ACTIONS(3030),
    [sym__binary_minus] = ACTIONS(3030),
    [sym__binary_star] = ACTIONS(3030),
    [anon_sym_DOT] = ACTIONS(3032),
    [anon_sym_COMMA] = ACTIONS(3030),
    [anon_sym_PIPE] = ACTIONS(3032),
    [anon_sym_STAR_STAR] = ACTIONS(3030),
    [anon_sym_AMP] = ACTIONS(3032),
    [anon_sym_LT] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(3030),
    [anon_sym_COLON_COLON2] = ACTIONS(3030),
    [anon_sym_AMP_DOT] = ACTIONS(3030),
    [anon_sym_QMARK] = ACTIONS(3030),
    [anon_sym_COLON2] = ACTIONS(3032),
    [anon_sym_DOT_DOT] = ACTIONS(3032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3030),
    [anon_sym_and] = ACTIONS(3030),
    [anon_sym_or] = ACTIONS(3030),
    [anon_sym_PIPE_PIPE] = ACTIONS(3030),
    [anon_sym_AMP_AMP] = ACTIONS(3030),
    [anon_sym_LT_LT] = ACTIONS(3030),
    [anon_sym_GT_GT] = ACTIONS(3030),
    [anon_sym_EQ_EQ] = ACTIONS(3032),
    [anon_sym_BANG_EQ] = ACTIONS(3030),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3030),
    [anon_sym_LT_EQ_GT] = ACTIONS(3030),
    [anon_sym_EQ_TILDE] = ACTIONS(3030),
    [anon_sym_BANG_TILDE] = ACTIONS(3030),
    [anon_sym_LT_EQ] = ACTIONS(3032),
    [anon_sym_GT] = ACTIONS(3032),
    [anon_sym_GT_EQ] = ACTIONS(3030),
    [anon_sym_CARET] = ACTIONS(3030),
    [anon_sym_PLUS] = ACTIONS(3030),
    [anon_sym_SLASH] = ACTIONS(3030),
    [anon_sym_PERCENT] = ACTIONS(3030),
    [sym_comment] = ACTIONS(87),
  },
  [6135] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(8475),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(6145),
    [sym_scope_resolution] = STATE(6143),
    [sym_call] = STATE(6143),
    [sym_method_call] = STATE(6145),
    [sym_assignment] = STATE(8475),
    [sym_operator_assignment] = STATE(8475),
    [sym_conditional] = STATE(8475),
    [sym_range] = STATE(8475),
    [sym_binary] = STATE(8475),
    [sym_unary] = STATE(8475),
    [sym_left_assignment_list] = STATE(6144),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6145),
    [sym__variable] = STATE(6143),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(6145),
    [sym_false] = STATE(6145),
    [sym_nil] = STATE(6145),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(6146),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9505),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9507),
    [anon_sym_yield] = ACTIONS(9509),
    [anon_sym_break] = ACTIONS(9511),
    [anon_sym_next] = ACTIONS(9513),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9515),
    [anon_sym_defined_QMARK] = ACTIONS(9517),
    [anon_sym_not] = ACTIONS(9519),
    [anon_sym_BANG] = ACTIONS(9521),
    [anon_sym_TILDE] = ACTIONS(9521),
    [sym_constant] = ACTIONS(9523),
    [sym_identifier] = ACTIONS(9523),
    [sym_instance_variable] = ACTIONS(9525),
    [sym_class_variable] = ACTIONS(9525),
    [sym_global_variable] = ACTIONS(9525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(9523),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9523),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6136] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(3517),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(3522),
    [sym_scope_resolution] = STATE(3518),
    [sym_call] = STATE(3518),
    [sym_method_call] = STATE(3522),
    [sym_argument_list] = STATE(1318),
    [sym__argument_list_with_parens] = STATE(8476),
    [sym__argument] = STATE(8477),
    [sym_splat_argument] = STATE(8477),
    [sym_hash_splat_argument] = STATE(8477),
    [sym_block_argument] = STATE(8477),
    [sym_assignment] = STATE(3517),
    [sym_operator_assignment] = STATE(3517),
    [sym_conditional] = STATE(3517),
    [sym_range] = STATE(3517),
    [sym_binary] = STATE(3517),
    [sym_unary] = STATE(3517),
    [sym_left_assignment_list] = STATE(3521),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3522),
    [sym__variable] = STATE(3518),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(3522),
    [sym_false] = STATE(3522),
    [sym_nil] = STATE(3522),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(3523),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(8477),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(5831),
    [sym__splat_star] = ACTIONS(5833),
    [sym__unary_minus] = ACTIONS(5835),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(5837),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5839),
    [anon_sym_yield] = ACTIONS(5841),
    [anon_sym_break] = ACTIONS(5843),
    [anon_sym_next] = ACTIONS(5845),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_COLON2] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(5847),
    [anon_sym_not] = ACTIONS(5849),
    [anon_sym_BANG] = ACTIONS(5851),
    [anon_sym_TILDE] = ACTIONS(5853),
    [sym_constant] = ACTIONS(5855),
    [sym_identifier] = ACTIONS(5855),
    [sym_instance_variable] = ACTIONS(5857),
    [sym_class_variable] = ACTIONS(5857),
    [sym_global_variable] = ACTIONS(5857),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5859),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5859),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6137] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(3517),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(3522),
    [sym_scope_resolution] = STATE(3518),
    [sym_call] = STATE(3518),
    [sym_method_call] = STATE(3522),
    [sym_argument_list] = STATE(1324),
    [sym__argument_list_with_parens] = STATE(8476),
    [sym__argument] = STATE(8477),
    [sym_splat_argument] = STATE(8477),
    [sym_hash_splat_argument] = STATE(8477),
    [sym_block_argument] = STATE(8477),
    [sym_assignment] = STATE(3517),
    [sym_operator_assignment] = STATE(3517),
    [sym_conditional] = STATE(3517),
    [sym_range] = STATE(3517),
    [sym_binary] = STATE(3517),
    [sym_unary] = STATE(3517),
    [sym_left_assignment_list] = STATE(3521),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3522),
    [sym__variable] = STATE(3518),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(3522),
    [sym_false] = STATE(3522),
    [sym_nil] = STATE(3522),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(3523),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(8477),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(5831),
    [sym__splat_star] = ACTIONS(5833),
    [sym__unary_minus] = ACTIONS(5835),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(5837),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5839),
    [anon_sym_yield] = ACTIONS(5841),
    [anon_sym_break] = ACTIONS(5843),
    [anon_sym_next] = ACTIONS(5845),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_COLON2] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(5847),
    [anon_sym_not] = ACTIONS(5849),
    [anon_sym_BANG] = ACTIONS(5851),
    [anon_sym_TILDE] = ACTIONS(5853),
    [sym_constant] = ACTIONS(5855),
    [sym_identifier] = ACTIONS(5855),
    [sym_instance_variable] = ACTIONS(5857),
    [sym_class_variable] = ACTIONS(5857),
    [sym_global_variable] = ACTIONS(5857),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5859),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5859),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6138] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(3517),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(3522),
    [sym_scope_resolution] = STATE(3518),
    [sym_call] = STATE(3518),
    [sym_method_call] = STATE(3522),
    [sym_argument_list] = STATE(1325),
    [sym__argument_list_with_parens] = STATE(8476),
    [sym__argument] = STATE(8477),
    [sym_splat_argument] = STATE(8477),
    [sym_hash_splat_argument] = STATE(8477),
    [sym_block_argument] = STATE(8477),
    [sym_assignment] = STATE(3517),
    [sym_operator_assignment] = STATE(3517),
    [sym_conditional] = STATE(3517),
    [sym_range] = STATE(3517),
    [sym_binary] = STATE(3517),
    [sym_unary] = STATE(3517),
    [sym_left_assignment_list] = STATE(3521),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3522),
    [sym__variable] = STATE(3518),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(3522),
    [sym_false] = STATE(3522),
    [sym_nil] = STATE(3522),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(3523),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(8477),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(5831),
    [sym__splat_star] = ACTIONS(5833),
    [sym__unary_minus] = ACTIONS(5835),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(5837),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5839),
    [anon_sym_yield] = ACTIONS(5841),
    [anon_sym_break] = ACTIONS(5843),
    [anon_sym_next] = ACTIONS(5845),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_COLON2] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(5847),
    [anon_sym_not] = ACTIONS(5849),
    [anon_sym_BANG] = ACTIONS(5851),
    [anon_sym_TILDE] = ACTIONS(5853),
    [sym_constant] = ACTIONS(5855),
    [sym_identifier] = ACTIONS(5855),
    [sym_instance_variable] = ACTIONS(5857),
    [sym_class_variable] = ACTIONS(5857),
    [sym_global_variable] = ACTIONS(5857),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5859),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5859),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6139] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(3517),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(3522),
    [sym_scope_resolution] = STATE(3518),
    [sym_call] = STATE(3518),
    [sym_method_call] = STATE(3522),
    [sym_argument_list] = STATE(1326),
    [sym__argument_list_with_parens] = STATE(8476),
    [sym__argument] = STATE(8477),
    [sym_splat_argument] = STATE(8477),
    [sym_hash_splat_argument] = STATE(8477),
    [sym_block_argument] = STATE(8477),
    [sym_assignment] = STATE(3517),
    [sym_operator_assignment] = STATE(3517),
    [sym_conditional] = STATE(3517),
    [sym_range] = STATE(3517),
    [sym_binary] = STATE(3517),
    [sym_unary] = STATE(3517),
    [sym_left_assignment_list] = STATE(3521),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3522),
    [sym__variable] = STATE(3518),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(3522),
    [sym_false] = STATE(3522),
    [sym_nil] = STATE(3522),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(3523),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(8477),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(5831),
    [sym__splat_star] = ACTIONS(5833),
    [sym__unary_minus] = ACTIONS(5835),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(5837),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5839),
    [anon_sym_yield] = ACTIONS(5841),
    [anon_sym_break] = ACTIONS(5843),
    [anon_sym_next] = ACTIONS(5845),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_COLON2] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(5847),
    [anon_sym_not] = ACTIONS(5849),
    [anon_sym_BANG] = ACTIONS(5851),
    [anon_sym_TILDE] = ACTIONS(5853),
    [sym_constant] = ACTIONS(5855),
    [sym_identifier] = ACTIONS(5855),
    [sym_instance_variable] = ACTIONS(5857),
    [sym_class_variable] = ACTIONS(5857),
    [sym_global_variable] = ACTIONS(5857),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5859),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5859),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6140] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(8478),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(6145),
    [sym_scope_resolution] = STATE(6143),
    [sym_call] = STATE(6143),
    [sym_method_call] = STATE(6145),
    [sym_assignment] = STATE(8478),
    [sym_operator_assignment] = STATE(8478),
    [sym_conditional] = STATE(8478),
    [sym_range] = STATE(8478),
    [sym_binary] = STATE(8478),
    [sym_unary] = STATE(8478),
    [sym_left_assignment_list] = STATE(6144),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6145),
    [sym__variable] = STATE(6143),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(6145),
    [sym_false] = STATE(6145),
    [sym_nil] = STATE(6145),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(6146),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9505),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9507),
    [anon_sym_yield] = ACTIONS(9509),
    [anon_sym_break] = ACTIONS(9511),
    [anon_sym_next] = ACTIONS(9513),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9515),
    [anon_sym_defined_QMARK] = ACTIONS(9517),
    [anon_sym_not] = ACTIONS(9519),
    [anon_sym_BANG] = ACTIONS(9521),
    [anon_sym_TILDE] = ACTIONS(9521),
    [sym_constant] = ACTIONS(9523),
    [sym_identifier] = ACTIONS(9523),
    [sym_instance_variable] = ACTIONS(9525),
    [sym_class_variable] = ACTIONS(9525),
    [sym_global_variable] = ACTIONS(9525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(9523),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9523),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6141] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(1872),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(6145),
    [sym_scope_resolution] = STATE(6143),
    [sym_call] = STATE(6143),
    [sym_method_call] = STATE(6145),
    [sym_assignment] = STATE(1872),
    [sym_operator_assignment] = STATE(1872),
    [sym_conditional] = STATE(1872),
    [sym_range] = STATE(1872),
    [sym_binary] = STATE(1872),
    [sym_unary] = STATE(1872),
    [sym_left_assignment_list] = STATE(6144),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6145),
    [sym__variable] = STATE(6143),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(6145),
    [sym_false] = STATE(6145),
    [sym_nil] = STATE(6145),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(6146),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9505),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9507),
    [anon_sym_yield] = ACTIONS(9509),
    [anon_sym_break] = ACTIONS(9511),
    [anon_sym_next] = ACTIONS(9513),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9515),
    [anon_sym_defined_QMARK] = ACTIONS(9517),
    [anon_sym_not] = ACTIONS(9519),
    [anon_sym_BANG] = ACTIONS(9521),
    [anon_sym_TILDE] = ACTIONS(9521),
    [sym_constant] = ACTIONS(9523),
    [sym_identifier] = ACTIONS(9523),
    [sym_instance_variable] = ACTIONS(9525),
    [sym_class_variable] = ACTIONS(9525),
    [sym_global_variable] = ACTIONS(9525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(9523),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9523),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6142] = {
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(12066),
    [sym__binary_star] = ACTIONS(12068),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(12070),
    [anon_sym_STAR_STAR] = ACTIONS(12068),
    [anon_sym_AMP] = ACTIONS(12072),
    [anon_sym_LT] = ACTIONS(12074),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(12076),
    [anon_sym_COLON2] = ACTIONS(4217),
    [anon_sym_DOT_DOT] = ACTIONS(12078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12080),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(12082),
    [anon_sym_AMP_AMP] = ACTIONS(12082),
    [anon_sym_LT_LT] = ACTIONS(12084),
    [anon_sym_GT_GT] = ACTIONS(12084),
    [anon_sym_EQ_EQ] = ACTIONS(12086),
    [anon_sym_BANG_EQ] = ACTIONS(12082),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12082),
    [anon_sym_LT_EQ_GT] = ACTIONS(12082),
    [anon_sym_EQ_TILDE] = ACTIONS(12082),
    [anon_sym_BANG_TILDE] = ACTIONS(12082),
    [anon_sym_LT_EQ] = ACTIONS(12074),
    [anon_sym_GT] = ACTIONS(12074),
    [anon_sym_GT_EQ] = ACTIONS(12088),
    [anon_sym_CARET] = ACTIONS(12090),
    [anon_sym_PLUS] = ACTIONS(12066),
    [anon_sym_SLASH] = ACTIONS(12068),
    [anon_sym_PERCENT] = ACTIONS(12068),
    [sym_comment] = ACTIONS(87),
  },
  [6143] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3548),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3553),
    [sym_scope_resolution] = STATE(3549),
    [sym_call] = STATE(3549),
    [sym_method_call] = STATE(3553),
    [sym_argument_list] = STATE(1846),
    [sym__argument_list_with_parens] = STATE(3550),
    [sym__argument] = STATE(3551),
    [sym_splat_argument] = STATE(3551),
    [sym_hash_splat_argument] = STATE(3551),
    [sym_block_argument] = STATE(3551),
    [sym_do_block] = STATE(1849),
    [sym_block] = STATE(1849),
    [sym_assignment] = STATE(3548),
    [sym_operator_assignment] = STATE(3548),
    [sym_conditional] = STATE(3548),
    [sym_range] = STATE(3548),
    [sym_binary] = STATE(3548),
    [sym_unary] = STATE(3548),
    [sym_left_assignment_list] = STATE(3552),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3553),
    [sym__variable] = STATE(3549),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3553),
    [sym_false] = STATE(3553),
    [sym_nil] = STATE(3553),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3554),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(3551),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(5891),
    [sym__splat_star] = ACTIONS(5893),
    [sym__unary_minus] = ACTIONS(5895),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(5897),
    [anon_sym_LBRACE] = ACTIONS(3327),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5899),
    [anon_sym_yield] = ACTIONS(5901),
    [anon_sym_break] = ACTIONS(5903),
    [anon_sym_next] = ACTIONS(5905),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(3337),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(5907),
    [anon_sym_not] = ACTIONS(5909),
    [anon_sym_BANG] = ACTIONS(5911),
    [anon_sym_TILDE] = ACTIONS(5913),
    [sym_constant] = ACTIONS(5915),
    [sym_identifier] = ACTIONS(5915),
    [sym_instance_variable] = ACTIONS(5917),
    [sym_class_variable] = ACTIONS(5917),
    [sym_global_variable] = ACTIONS(5917),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5919),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5919),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6144] = {
    [anon_sym_EQ] = ACTIONS(12092),
    [sym_comment] = ACTIONS(87),
  },
  [6145] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(12096),
    [anon_sym_DASH_EQ] = ACTIONS(12096),
    [anon_sym_STAR_EQ] = ACTIONS(12096),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12096),
    [anon_sym_SLASH_EQ] = ACTIONS(12096),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12096),
    [anon_sym_PIPE_EQ] = ACTIONS(12096),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12096),
    [anon_sym_AMP_EQ] = ACTIONS(12096),
    [anon_sym_PERCENT_EQ] = ACTIONS(12096),
    [anon_sym_GT_GT_EQ] = ACTIONS(12096),
    [anon_sym_LT_LT_EQ] = ACTIONS(12096),
    [anon_sym_CARET_EQ] = ACTIONS(12096),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [6146] = {
    [sym_string] = STATE(8491),
    [aux_sym_chained_string_repeat1] = STATE(8491),
    [sym__string_start] = ACTIONS(4007),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [6147] = {
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(12066),
    [sym__binary_star] = ACTIONS(12068),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(12070),
    [anon_sym_STAR_STAR] = ACTIONS(12068),
    [anon_sym_AMP] = ACTIONS(12072),
    [anon_sym_LT] = ACTIONS(12074),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(12076),
    [anon_sym_COLON2] = ACTIONS(4249),
    [anon_sym_DOT_DOT] = ACTIONS(12078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12080),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(12082),
    [anon_sym_AMP_AMP] = ACTIONS(12082),
    [anon_sym_LT_LT] = ACTIONS(12084),
    [anon_sym_GT_GT] = ACTIONS(12084),
    [anon_sym_EQ_EQ] = ACTIONS(12086),
    [anon_sym_BANG_EQ] = ACTIONS(12082),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12082),
    [anon_sym_LT_EQ_GT] = ACTIONS(12082),
    [anon_sym_EQ_TILDE] = ACTIONS(12082),
    [anon_sym_BANG_TILDE] = ACTIONS(12082),
    [anon_sym_LT_EQ] = ACTIONS(12074),
    [anon_sym_GT] = ACTIONS(12074),
    [anon_sym_GT_EQ] = ACTIONS(12088),
    [anon_sym_CARET] = ACTIONS(12090),
    [anon_sym_PLUS] = ACTIONS(12066),
    [anon_sym_SLASH] = ACTIONS(12068),
    [anon_sym_PERCENT] = ACTIONS(12068),
    [sym_comment] = ACTIONS(87),
  },
  [6148] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(8493),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(12098),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [6149] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(9545),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_COLON2] = ACTIONS(937),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [6150] = {
    [sym_string] = STATE(6188),
    [aux_sym_chained_string_repeat1] = STATE(6188),
    [sym__string_start] = ACTIONS(9527),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [6151] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(8494),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(6145),
    [sym_scope_resolution] = STATE(6143),
    [sym_call] = STATE(6143),
    [sym_method_call] = STATE(6145),
    [sym_assignment] = STATE(8494),
    [sym_operator_assignment] = STATE(8494),
    [sym_conditional] = STATE(8494),
    [sym_range] = STATE(8494),
    [sym_binary] = STATE(8494),
    [sym_unary] = STATE(8494),
    [sym_left_assignment_list] = STATE(6144),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6145),
    [sym__variable] = STATE(6143),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(6145),
    [sym_false] = STATE(6145),
    [sym_nil] = STATE(6145),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(6146),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9505),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9507),
    [anon_sym_yield] = ACTIONS(9509),
    [anon_sym_break] = ACTIONS(9511),
    [anon_sym_next] = ACTIONS(9513),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9515),
    [anon_sym_defined_QMARK] = ACTIONS(9517),
    [anon_sym_not] = ACTIONS(9519),
    [anon_sym_BANG] = ACTIONS(9521),
    [anon_sym_TILDE] = ACTIONS(9521),
    [sym_constant] = ACTIONS(9523),
    [sym_identifier] = ACTIONS(9523),
    [sym_instance_variable] = ACTIONS(9525),
    [sym_class_variable] = ACTIONS(9525),
    [sym_global_variable] = ACTIONS(9525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(9523),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9523),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6152] = {
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(12066),
    [sym__binary_star] = ACTIONS(12068),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(12070),
    [anon_sym_STAR_STAR] = ACTIONS(12068),
    [anon_sym_AMP] = ACTIONS(12072),
    [anon_sym_LT] = ACTIONS(12074),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(12076),
    [anon_sym_COLON2] = ACTIONS(4251),
    [anon_sym_DOT_DOT] = ACTIONS(12078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12080),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(12082),
    [anon_sym_AMP_AMP] = ACTIONS(12082),
    [anon_sym_LT_LT] = ACTIONS(12084),
    [anon_sym_GT_GT] = ACTIONS(12084),
    [anon_sym_EQ_EQ] = ACTIONS(12086),
    [anon_sym_BANG_EQ] = ACTIONS(12082),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12082),
    [anon_sym_LT_EQ_GT] = ACTIONS(12082),
    [anon_sym_EQ_TILDE] = ACTIONS(12082),
    [anon_sym_BANG_TILDE] = ACTIONS(12082),
    [anon_sym_LT_EQ] = ACTIONS(12074),
    [anon_sym_GT] = ACTIONS(12074),
    [anon_sym_GT_EQ] = ACTIONS(12088),
    [anon_sym_CARET] = ACTIONS(12090),
    [anon_sym_PLUS] = ACTIONS(12066),
    [anon_sym_SLASH] = ACTIONS(12068),
    [anon_sym_PERCENT] = ACTIONS(12068),
    [sym_comment] = ACTIONS(87),
  },
  [6153] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(8495),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(3522),
    [sym_scope_resolution] = STATE(3518),
    [sym_call] = STATE(3518),
    [sym_method_call] = STATE(3522),
    [sym_assignment] = STATE(8495),
    [sym_operator_assignment] = STATE(8495),
    [sym_conditional] = STATE(8495),
    [sym_range] = STATE(8495),
    [sym_binary] = STATE(8495),
    [sym_unary] = STATE(8495),
    [sym_left_assignment_list] = STATE(3521),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3522),
    [sym__variable] = STATE(3518),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(3522),
    [sym_false] = STATE(3522),
    [sym_nil] = STATE(3522),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(6150),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(9527),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(5835),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5839),
    [anon_sym_yield] = ACTIONS(5841),
    [anon_sym_break] = ACTIONS(5843),
    [anon_sym_next] = ACTIONS(5845),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9529),
    [anon_sym_defined_QMARK] = ACTIONS(5847),
    [anon_sym_not] = ACTIONS(5849),
    [anon_sym_BANG] = ACTIONS(5853),
    [anon_sym_TILDE] = ACTIONS(5853),
    [sym_constant] = ACTIONS(5859),
    [sym_identifier] = ACTIONS(5859),
    [sym_instance_variable] = ACTIONS(5857),
    [sym_class_variable] = ACTIONS(5857),
    [sym_global_variable] = ACTIONS(5857),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5859),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5859),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6154] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(8496),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(3522),
    [sym_scope_resolution] = STATE(3518),
    [sym_call] = STATE(3518),
    [sym_method_call] = STATE(3522),
    [sym_assignment] = STATE(8496),
    [sym_operator_assignment] = STATE(8496),
    [sym_conditional] = STATE(8496),
    [sym_range] = STATE(8496),
    [sym_binary] = STATE(8496),
    [sym_unary] = STATE(8496),
    [sym_left_assignment_list] = STATE(3521),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3522),
    [sym__variable] = STATE(3518),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(3522),
    [sym_false] = STATE(3522),
    [sym_nil] = STATE(3522),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(6150),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(9527),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(5835),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5839),
    [anon_sym_yield] = ACTIONS(5841),
    [anon_sym_break] = ACTIONS(5843),
    [anon_sym_next] = ACTIONS(5845),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9529),
    [anon_sym_defined_QMARK] = ACTIONS(5847),
    [anon_sym_not] = ACTIONS(5849),
    [anon_sym_BANG] = ACTIONS(5853),
    [anon_sym_TILDE] = ACTIONS(5853),
    [sym_constant] = ACTIONS(5859),
    [sym_identifier] = ACTIONS(5859),
    [sym_instance_variable] = ACTIONS(5857),
    [sym_class_variable] = ACTIONS(5857),
    [sym_global_variable] = ACTIONS(5857),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5859),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5859),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6155] = {
    [anon_sym_COLON] = ACTIONS(12100),
    [sym_comment] = ACTIONS(87),
  },
  [6156] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(8498),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(3522),
    [sym_scope_resolution] = STATE(3518),
    [sym_call] = STATE(3518),
    [sym_method_call] = STATE(3522),
    [sym_assignment] = STATE(8498),
    [sym_operator_assignment] = STATE(8498),
    [sym_conditional] = STATE(8498),
    [sym_range] = STATE(8498),
    [sym_binary] = STATE(8498),
    [sym_unary] = STATE(8498),
    [sym_left_assignment_list] = STATE(3521),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3522),
    [sym__variable] = STATE(3518),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(3522),
    [sym_false] = STATE(3522),
    [sym_nil] = STATE(3522),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(6150),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(9527),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(5835),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5839),
    [anon_sym_yield] = ACTIONS(5841),
    [anon_sym_break] = ACTIONS(5843),
    [anon_sym_next] = ACTIONS(5845),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9529),
    [anon_sym_defined_QMARK] = ACTIONS(5847),
    [anon_sym_not] = ACTIONS(5849),
    [anon_sym_BANG] = ACTIONS(5853),
    [anon_sym_TILDE] = ACTIONS(5853),
    [sym_constant] = ACTIONS(5859),
    [sym_identifier] = ACTIONS(5859),
    [sym_instance_variable] = ACTIONS(5857),
    [sym_class_variable] = ACTIONS(5857),
    [sym_global_variable] = ACTIONS(5857),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5859),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5859),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6157] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(12102),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_COLON2] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [6158] = {
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(9543),
    [sym__binary_star] = ACTIONS(9545),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(9547),
    [anon_sym_STAR_STAR] = ACTIONS(9545),
    [anon_sym_AMP] = ACTIONS(9549),
    [anon_sym_LT] = ACTIONS(9551),
    [anon_sym_EQ_GT] = ACTIONS(1625),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(9553),
    [anon_sym_COLON2] = ACTIONS(1631),
    [anon_sym_DOT_DOT] = ACTIONS(9555),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9557),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(9559),
    [anon_sym_AMP_AMP] = ACTIONS(9559),
    [anon_sym_LT_LT] = ACTIONS(9561),
    [anon_sym_GT_GT] = ACTIONS(9561),
    [anon_sym_EQ_EQ] = ACTIONS(9563),
    [anon_sym_BANG_EQ] = ACTIONS(9559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9559),
    [anon_sym_LT_EQ_GT] = ACTIONS(9559),
    [anon_sym_EQ_TILDE] = ACTIONS(9559),
    [anon_sym_BANG_TILDE] = ACTIONS(9559),
    [anon_sym_LT_EQ] = ACTIONS(9551),
    [anon_sym_GT] = ACTIONS(9551),
    [anon_sym_GT_EQ] = ACTIONS(9565),
    [anon_sym_CARET] = ACTIONS(9567),
    [anon_sym_PLUS] = ACTIONS(9543),
    [anon_sym_SLASH] = ACTIONS(9545),
    [anon_sym_PERCENT] = ACTIONS(9545),
    [sym_comment] = ACTIONS(87),
  },
  [6159] = {
    [sym_heredoc_body] = STATE(8500),
    [aux_sym_call_repeat1] = STATE(8500),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_COLON2] = ACTIONS(1685),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [6160] = {
    [sym_heredoc_body] = STATE(8500),
    [aux_sym_call_repeat1] = STATE(8500),
    [aux_sym_argument_list_repeat1] = STATE(8502),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(12104),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_COLON2] = ACTIONS(1685),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [6161] = {
    [sym_string] = STATE(6188),
    [aux_sym_chained_string_repeat1] = STATE(6188),
    [sym__string_start] = ACTIONS(9527),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(12106),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [6162] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(9543),
    [sym__binary_star] = ACTIONS(9545),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(9547),
    [anon_sym_STAR_STAR] = ACTIONS(9545),
    [anon_sym_AMP] = ACTIONS(9549),
    [anon_sym_LT] = ACTIONS(9551),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(9553),
    [anon_sym_COLON2] = ACTIONS(937),
    [anon_sym_DOT_DOT] = ACTIONS(9555),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9557),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(9559),
    [anon_sym_AMP_AMP] = ACTIONS(9559),
    [anon_sym_LT_LT] = ACTIONS(9561),
    [anon_sym_GT_GT] = ACTIONS(9561),
    [anon_sym_EQ_EQ] = ACTIONS(9563),
    [anon_sym_BANG_EQ] = ACTIONS(9559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9559),
    [anon_sym_LT_EQ_GT] = ACTIONS(9559),
    [anon_sym_EQ_TILDE] = ACTIONS(9559),
    [anon_sym_BANG_TILDE] = ACTIONS(9559),
    [anon_sym_LT_EQ] = ACTIONS(9551),
    [anon_sym_GT] = ACTIONS(9551),
    [anon_sym_GT_EQ] = ACTIONS(9565),
    [anon_sym_CARET] = ACTIONS(9567),
    [anon_sym_PLUS] = ACTIONS(9543),
    [anon_sym_SLASH] = ACTIONS(9545),
    [anon_sym_PERCENT] = ACTIONS(9545),
    [sym_comment] = ACTIONS(87),
  },
  [6163] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(8503),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(6145),
    [sym_scope_resolution] = STATE(6143),
    [sym_call] = STATE(6143),
    [sym_method_call] = STATE(6145),
    [sym_assignment] = STATE(8503),
    [sym_operator_assignment] = STATE(8503),
    [sym_conditional] = STATE(8503),
    [sym_range] = STATE(8503),
    [sym_binary] = STATE(8503),
    [sym_unary] = STATE(8503),
    [sym_left_assignment_list] = STATE(6144),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6145),
    [sym__variable] = STATE(6143),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(6145),
    [sym_false] = STATE(6145),
    [sym_nil] = STATE(6145),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(6146),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9505),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9507),
    [anon_sym_yield] = ACTIONS(9509),
    [anon_sym_break] = ACTIONS(9511),
    [anon_sym_next] = ACTIONS(9513),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9515),
    [anon_sym_defined_QMARK] = ACTIONS(9517),
    [anon_sym_not] = ACTIONS(9519),
    [anon_sym_BANG] = ACTIONS(9521),
    [anon_sym_TILDE] = ACTIONS(9521),
    [sym_constant] = ACTIONS(9523),
    [sym_identifier] = ACTIONS(9523),
    [sym_instance_variable] = ACTIONS(9525),
    [sym_class_variable] = ACTIONS(9525),
    [sym_global_variable] = ACTIONS(9525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(9523),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9523),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6164] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(8504),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(3522),
    [sym_scope_resolution] = STATE(3518),
    [sym_call] = STATE(3518),
    [sym_method_call] = STATE(3522),
    [sym_assignment] = STATE(8504),
    [sym_operator_assignment] = STATE(8504),
    [sym_conditional] = STATE(8504),
    [sym_range] = STATE(8504),
    [sym_binary] = STATE(8504),
    [sym_unary] = STATE(8504),
    [sym_left_assignment_list] = STATE(3521),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3522),
    [sym__variable] = STATE(3518),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(3522),
    [sym_false] = STATE(3522),
    [sym_nil] = STATE(3522),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(6150),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(9527),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(5835),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5839),
    [anon_sym_yield] = ACTIONS(5841),
    [anon_sym_break] = ACTIONS(5843),
    [anon_sym_next] = ACTIONS(5845),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9529),
    [anon_sym_defined_QMARK] = ACTIONS(5847),
    [anon_sym_not] = ACTIONS(5849),
    [anon_sym_BANG] = ACTIONS(5853),
    [anon_sym_TILDE] = ACTIONS(5853),
    [sym_constant] = ACTIONS(5859),
    [sym_identifier] = ACTIONS(5859),
    [sym_instance_variable] = ACTIONS(5857),
    [sym_class_variable] = ACTIONS(5857),
    [sym_global_variable] = ACTIONS(5857),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5859),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5859),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6165] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(8505),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(3522),
    [sym_scope_resolution] = STATE(3518),
    [sym_call] = STATE(3518),
    [sym_method_call] = STATE(3522),
    [sym_assignment] = STATE(8505),
    [sym_operator_assignment] = STATE(8505),
    [sym_conditional] = STATE(8505),
    [sym_range] = STATE(8505),
    [sym_binary] = STATE(8505),
    [sym_unary] = STATE(8505),
    [sym_left_assignment_list] = STATE(3521),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3522),
    [sym__variable] = STATE(3518),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(3522),
    [sym_false] = STATE(3522),
    [sym_nil] = STATE(3522),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(6150),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(9527),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(5835),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5839),
    [anon_sym_yield] = ACTIONS(5841),
    [anon_sym_break] = ACTIONS(5843),
    [anon_sym_next] = ACTIONS(5845),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9529),
    [anon_sym_defined_QMARK] = ACTIONS(5847),
    [anon_sym_not] = ACTIONS(5849),
    [anon_sym_BANG] = ACTIONS(5853),
    [anon_sym_TILDE] = ACTIONS(5853),
    [sym_constant] = ACTIONS(5859),
    [sym_identifier] = ACTIONS(5859),
    [sym_instance_variable] = ACTIONS(5857),
    [sym_class_variable] = ACTIONS(5857),
    [sym_global_variable] = ACTIONS(5857),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5859),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5859),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6166] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(8506),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(3522),
    [sym_scope_resolution] = STATE(3518),
    [sym_call] = STATE(3518),
    [sym_method_call] = STATE(3522),
    [sym_assignment] = STATE(8506),
    [sym_operator_assignment] = STATE(8506),
    [sym_conditional] = STATE(8506),
    [sym_range] = STATE(8506),
    [sym_binary] = STATE(8506),
    [sym_unary] = STATE(8506),
    [sym_left_assignment_list] = STATE(3521),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3522),
    [sym__variable] = STATE(3518),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(3522),
    [sym_false] = STATE(3522),
    [sym_nil] = STATE(3522),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(6150),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(9527),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(5835),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5839),
    [anon_sym_yield] = ACTIONS(5841),
    [anon_sym_break] = ACTIONS(5843),
    [anon_sym_next] = ACTIONS(5845),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9529),
    [anon_sym_defined_QMARK] = ACTIONS(5847),
    [anon_sym_not] = ACTIONS(5849),
    [anon_sym_BANG] = ACTIONS(5853),
    [anon_sym_TILDE] = ACTIONS(5853),
    [sym_constant] = ACTIONS(5859),
    [sym_identifier] = ACTIONS(5859),
    [sym_instance_variable] = ACTIONS(5857),
    [sym_class_variable] = ACTIONS(5857),
    [sym_global_variable] = ACTIONS(5857),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5859),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5859),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6167] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(8507),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(3522),
    [sym_scope_resolution] = STATE(3518),
    [sym_call] = STATE(3518),
    [sym_method_call] = STATE(3522),
    [sym_assignment] = STATE(8507),
    [sym_operator_assignment] = STATE(8507),
    [sym_conditional] = STATE(8507),
    [sym_range] = STATE(8507),
    [sym_binary] = STATE(8507),
    [sym_unary] = STATE(8507),
    [sym_left_assignment_list] = STATE(3521),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3522),
    [sym__variable] = STATE(3518),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(3522),
    [sym_false] = STATE(3522),
    [sym_nil] = STATE(3522),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(6150),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(9527),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(5835),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5839),
    [anon_sym_yield] = ACTIONS(5841),
    [anon_sym_break] = ACTIONS(5843),
    [anon_sym_next] = ACTIONS(5845),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9529),
    [anon_sym_defined_QMARK] = ACTIONS(5847),
    [anon_sym_not] = ACTIONS(5849),
    [anon_sym_BANG] = ACTIONS(5853),
    [anon_sym_TILDE] = ACTIONS(5853),
    [sym_constant] = ACTIONS(5859),
    [sym_identifier] = ACTIONS(5859),
    [sym_instance_variable] = ACTIONS(5857),
    [sym_class_variable] = ACTIONS(5857),
    [sym_global_variable] = ACTIONS(5857),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5859),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5859),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6168] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(8508),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(3522),
    [sym_scope_resolution] = STATE(3518),
    [sym_call] = STATE(3518),
    [sym_method_call] = STATE(3522),
    [sym_assignment] = STATE(8508),
    [sym_operator_assignment] = STATE(8508),
    [sym_conditional] = STATE(8508),
    [sym_range] = STATE(8508),
    [sym_binary] = STATE(8508),
    [sym_unary] = STATE(8508),
    [sym_left_assignment_list] = STATE(3521),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3522),
    [sym__variable] = STATE(3518),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(3522),
    [sym_false] = STATE(3522),
    [sym_nil] = STATE(3522),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(6150),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(9527),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(5835),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5839),
    [anon_sym_yield] = ACTIONS(5841),
    [anon_sym_break] = ACTIONS(5843),
    [anon_sym_next] = ACTIONS(5845),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9529),
    [anon_sym_defined_QMARK] = ACTIONS(5847),
    [anon_sym_not] = ACTIONS(5849),
    [anon_sym_BANG] = ACTIONS(5853),
    [anon_sym_TILDE] = ACTIONS(5853),
    [sym_constant] = ACTIONS(5859),
    [sym_identifier] = ACTIONS(5859),
    [sym_instance_variable] = ACTIONS(5857),
    [sym_class_variable] = ACTIONS(5857),
    [sym_global_variable] = ACTIONS(5857),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5859),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5859),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6169] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(8509),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(8509),
    [sym_operator_assignment] = STATE(8509),
    [sym_conditional] = STATE(8509),
    [sym_range] = STATE(8509),
    [sym_binary] = STATE(8509),
    [sym_unary] = STATE(8509),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6170] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(8510),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(3522),
    [sym_scope_resolution] = STATE(3518),
    [sym_call] = STATE(3518),
    [sym_method_call] = STATE(3522),
    [sym_assignment] = STATE(8510),
    [sym_operator_assignment] = STATE(8510),
    [sym_conditional] = STATE(8510),
    [sym_range] = STATE(8510),
    [sym_binary] = STATE(8510),
    [sym_unary] = STATE(8510),
    [sym_left_assignment_list] = STATE(3521),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3522),
    [sym__variable] = STATE(3518),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(3522),
    [sym_false] = STATE(3522),
    [sym_nil] = STATE(3522),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(6150),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(9527),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(5835),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5839),
    [anon_sym_yield] = ACTIONS(5841),
    [anon_sym_break] = ACTIONS(5843),
    [anon_sym_next] = ACTIONS(5845),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9529),
    [anon_sym_defined_QMARK] = ACTIONS(5847),
    [anon_sym_not] = ACTIONS(5849),
    [anon_sym_BANG] = ACTIONS(5853),
    [anon_sym_TILDE] = ACTIONS(5853),
    [sym_constant] = ACTIONS(5859),
    [sym_identifier] = ACTIONS(5859),
    [sym_instance_variable] = ACTIONS(5857),
    [sym_class_variable] = ACTIONS(5857),
    [sym_global_variable] = ACTIONS(5857),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5859),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5859),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6171] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(8511),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(3522),
    [sym_scope_resolution] = STATE(3518),
    [sym_call] = STATE(3518),
    [sym_method_call] = STATE(3522),
    [sym_assignment] = STATE(8511),
    [sym_operator_assignment] = STATE(8511),
    [sym_conditional] = STATE(8511),
    [sym_range] = STATE(8511),
    [sym_binary] = STATE(8511),
    [sym_unary] = STATE(8511),
    [sym_left_assignment_list] = STATE(3521),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3522),
    [sym__variable] = STATE(3518),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(3522),
    [sym_false] = STATE(3522),
    [sym_nil] = STATE(3522),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(6150),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(9527),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(5835),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5839),
    [anon_sym_yield] = ACTIONS(5841),
    [anon_sym_break] = ACTIONS(5843),
    [anon_sym_next] = ACTIONS(5845),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9529),
    [anon_sym_defined_QMARK] = ACTIONS(5847),
    [anon_sym_not] = ACTIONS(5849),
    [anon_sym_BANG] = ACTIONS(5853),
    [anon_sym_TILDE] = ACTIONS(5853),
    [sym_constant] = ACTIONS(5859),
    [sym_identifier] = ACTIONS(5859),
    [sym_instance_variable] = ACTIONS(5857),
    [sym_class_variable] = ACTIONS(5857),
    [sym_global_variable] = ACTIONS(5857),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5859),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5859),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6172] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(8512),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(3522),
    [sym_scope_resolution] = STATE(3518),
    [sym_call] = STATE(3518),
    [sym_method_call] = STATE(3522),
    [sym_assignment] = STATE(8512),
    [sym_operator_assignment] = STATE(8512),
    [sym_conditional] = STATE(8512),
    [sym_range] = STATE(8512),
    [sym_binary] = STATE(8512),
    [sym_unary] = STATE(8512),
    [sym_left_assignment_list] = STATE(3521),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3522),
    [sym__variable] = STATE(3518),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(3522),
    [sym_false] = STATE(3522),
    [sym_nil] = STATE(3522),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(6150),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(9527),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(5835),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5839),
    [anon_sym_yield] = ACTIONS(5841),
    [anon_sym_break] = ACTIONS(5843),
    [anon_sym_next] = ACTIONS(5845),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9529),
    [anon_sym_defined_QMARK] = ACTIONS(5847),
    [anon_sym_not] = ACTIONS(5849),
    [anon_sym_BANG] = ACTIONS(5853),
    [anon_sym_TILDE] = ACTIONS(5853),
    [sym_constant] = ACTIONS(5859),
    [sym_identifier] = ACTIONS(5859),
    [sym_instance_variable] = ACTIONS(5857),
    [sym_class_variable] = ACTIONS(5857),
    [sym_global_variable] = ACTIONS(5857),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5859),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5859),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6173] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(8513),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(3522),
    [sym_scope_resolution] = STATE(3518),
    [sym_call] = STATE(3518),
    [sym_method_call] = STATE(3522),
    [sym_assignment] = STATE(8513),
    [sym_operator_assignment] = STATE(8513),
    [sym_conditional] = STATE(8513),
    [sym_range] = STATE(8513),
    [sym_binary] = STATE(8513),
    [sym_unary] = STATE(8513),
    [sym_left_assignment_list] = STATE(3521),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3522),
    [sym__variable] = STATE(3518),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(3522),
    [sym_false] = STATE(3522),
    [sym_nil] = STATE(3522),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(6150),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(9527),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(5835),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5839),
    [anon_sym_yield] = ACTIONS(5841),
    [anon_sym_break] = ACTIONS(5843),
    [anon_sym_next] = ACTIONS(5845),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9529),
    [anon_sym_defined_QMARK] = ACTIONS(5847),
    [anon_sym_not] = ACTIONS(5849),
    [anon_sym_BANG] = ACTIONS(5853),
    [anon_sym_TILDE] = ACTIONS(5853),
    [sym_constant] = ACTIONS(5859),
    [sym_identifier] = ACTIONS(5859),
    [sym_instance_variable] = ACTIONS(5857),
    [sym_class_variable] = ACTIONS(5857),
    [sym_global_variable] = ACTIONS(5857),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5859),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5859),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6174] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(8514),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3553),
    [sym_scope_resolution] = STATE(3549),
    [sym_call] = STATE(3549),
    [sym_method_call] = STATE(3553),
    [sym_assignment] = STATE(8514),
    [sym_operator_assignment] = STATE(8514),
    [sym_conditional] = STATE(8514),
    [sym_range] = STATE(8514),
    [sym_binary] = STATE(8514),
    [sym_unary] = STATE(8514),
    [sym_left_assignment_list] = STATE(3552),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3553),
    [sym__variable] = STATE(3549),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3553),
    [sym_false] = STATE(3553),
    [sym_nil] = STATE(3553),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6215),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(9609),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(5895),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5899),
    [anon_sym_yield] = ACTIONS(5901),
    [anon_sym_break] = ACTIONS(5903),
    [anon_sym_next] = ACTIONS(5905),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(9611),
    [anon_sym_defined_QMARK] = ACTIONS(5907),
    [anon_sym_not] = ACTIONS(5909),
    [anon_sym_BANG] = ACTIONS(5913),
    [anon_sym_TILDE] = ACTIONS(5913),
    [sym_constant] = ACTIONS(5919),
    [sym_identifier] = ACTIONS(5919),
    [sym_instance_variable] = ACTIONS(5917),
    [sym_class_variable] = ACTIONS(5917),
    [sym_global_variable] = ACTIONS(5917),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5919),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5919),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6175] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(8515),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3553),
    [sym_scope_resolution] = STATE(3549),
    [sym_call] = STATE(3549),
    [sym_method_call] = STATE(3553),
    [sym_assignment] = STATE(8515),
    [sym_operator_assignment] = STATE(8515),
    [sym_conditional] = STATE(8515),
    [sym_range] = STATE(8515),
    [sym_binary] = STATE(8515),
    [sym_unary] = STATE(8515),
    [sym_left_assignment_list] = STATE(3552),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3553),
    [sym__variable] = STATE(3549),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3553),
    [sym_false] = STATE(3553),
    [sym_nil] = STATE(3553),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6215),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(9609),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(5895),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5899),
    [anon_sym_yield] = ACTIONS(5901),
    [anon_sym_break] = ACTIONS(5903),
    [anon_sym_next] = ACTIONS(5905),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(9611),
    [anon_sym_defined_QMARK] = ACTIONS(5907),
    [anon_sym_not] = ACTIONS(5909),
    [anon_sym_BANG] = ACTIONS(5913),
    [anon_sym_TILDE] = ACTIONS(5913),
    [sym_constant] = ACTIONS(5919),
    [sym_identifier] = ACTIONS(5919),
    [sym_instance_variable] = ACTIONS(5917),
    [sym_class_variable] = ACTIONS(5917),
    [sym_global_variable] = ACTIONS(5917),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5919),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5919),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6176] = {
    [anon_sym_COLON] = ACTIONS(12108),
    [sym_comment] = ACTIONS(87),
  },
  [6177] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(8517),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3553),
    [sym_scope_resolution] = STATE(3549),
    [sym_call] = STATE(3549),
    [sym_method_call] = STATE(3553),
    [sym_assignment] = STATE(8517),
    [sym_operator_assignment] = STATE(8517),
    [sym_conditional] = STATE(8517),
    [sym_range] = STATE(8517),
    [sym_binary] = STATE(8517),
    [sym_unary] = STATE(8517),
    [sym_left_assignment_list] = STATE(3552),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3553),
    [sym__variable] = STATE(3549),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3553),
    [sym_false] = STATE(3553),
    [sym_nil] = STATE(3553),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6215),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(9609),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(5895),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5899),
    [anon_sym_yield] = ACTIONS(5901),
    [anon_sym_break] = ACTIONS(5903),
    [anon_sym_next] = ACTIONS(5905),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(9611),
    [anon_sym_defined_QMARK] = ACTIONS(5907),
    [anon_sym_not] = ACTIONS(5909),
    [anon_sym_BANG] = ACTIONS(5913),
    [anon_sym_TILDE] = ACTIONS(5913),
    [sym_constant] = ACTIONS(5919),
    [sym_identifier] = ACTIONS(5919),
    [sym_instance_variable] = ACTIONS(5917),
    [sym_class_variable] = ACTIONS(5917),
    [sym_global_variable] = ACTIONS(5917),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5919),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5919),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6178] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(12110),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_COLON2] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [6179] = {
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(9617),
    [sym__binary_star] = ACTIONS(9619),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(9621),
    [anon_sym_STAR_STAR] = ACTIONS(9623),
    [anon_sym_AMP] = ACTIONS(9625),
    [anon_sym_EQ] = ACTIONS(1631),
    [anon_sym_LT] = ACTIONS(9627),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(1625),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_PLUS_EQ] = ACTIONS(1625),
    [anon_sym_DASH_EQ] = ACTIONS(1625),
    [anon_sym_STAR_EQ] = ACTIONS(1625),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1625),
    [anon_sym_SLASH_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1625),
    [anon_sym_AMP_EQ] = ACTIONS(1625),
    [anon_sym_PERCENT_EQ] = ACTIONS(1625),
    [anon_sym_GT_GT_EQ] = ACTIONS(1625),
    [anon_sym_LT_LT_EQ] = ACTIONS(1625),
    [anon_sym_CARET_EQ] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(9629),
    [anon_sym_COLON2] = ACTIONS(1631),
    [anon_sym_DOT_DOT] = ACTIONS(9631),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9633),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(9635),
    [anon_sym_AMP_AMP] = ACTIONS(9635),
    [anon_sym_LT_LT] = ACTIONS(9637),
    [anon_sym_GT_GT] = ACTIONS(9637),
    [anon_sym_EQ_EQ] = ACTIONS(9635),
    [anon_sym_BANG_EQ] = ACTIONS(9639),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9639),
    [anon_sym_LT_EQ_GT] = ACTIONS(9639),
    [anon_sym_EQ_TILDE] = ACTIONS(9639),
    [anon_sym_BANG_TILDE] = ACTIONS(9639),
    [anon_sym_LT_EQ] = ACTIONS(9627),
    [anon_sym_GT] = ACTIONS(9627),
    [anon_sym_GT_EQ] = ACTIONS(9641),
    [anon_sym_CARET] = ACTIONS(9621),
    [anon_sym_PLUS] = ACTIONS(9643),
    [anon_sym_SLASH] = ACTIONS(9623),
    [anon_sym_PERCENT] = ACTIONS(9623),
    [sym_comment] = ACTIONS(87),
  },
  [6180] = {
    [sym_heredoc_body] = STATE(8519),
    [aux_sym_call_repeat1] = STATE(8519),
    [sym__heredoc_body_start] = ACTIONS(3543),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_COLON2] = ACTIONS(1685),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [6181] = {
    [sym_heredoc_body] = STATE(8519),
    [aux_sym_call_repeat1] = STATE(8519),
    [aux_sym_argument_list_repeat1] = STATE(8521),
    [sym__heredoc_body_start] = ACTIONS(3543),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(12112),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_COLON2] = ACTIONS(1685),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [6182] = {
    [sym_string] = STATE(6235),
    [aux_sym_chained_string_repeat1] = STATE(6235),
    [sym__string_start] = ACTIONS(9609),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(12114),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [6183] = {
    [sym_heredoc_body] = STATE(8522),
    [aux_sym_call_repeat1] = STATE(8522),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_COLON2] = ACTIONS(4385),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [6184] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(3517),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(3522),
    [sym_scope_resolution] = STATE(3518),
    [sym_call] = STATE(3518),
    [sym_method_call] = STATE(3522),
    [sym__argument] = STATE(4250),
    [sym_splat_argument] = STATE(4250),
    [sym_hash_splat_argument] = STATE(4250),
    [sym_block_argument] = STATE(4250),
    [sym_assignment] = STATE(3517),
    [sym_operator_assignment] = STATE(3517),
    [sym_conditional] = STATE(3517),
    [sym_range] = STATE(3517),
    [sym_binary] = STATE(3517),
    [sym_unary] = STATE(3517),
    [sym_left_assignment_list] = STATE(3521),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3522),
    [sym__variable] = STATE(3518),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(3522),
    [sym_false] = STATE(3522),
    [sym_nil] = STATE(3522),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(3523),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_heredoc_body] = STATE(8523),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(4250),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(5831),
    [sym__splat_star] = ACTIONS(5833),
    [sym__unary_minus] = ACTIONS(5835),
    [sym__identifier_hash_key] = ACTIONS(5837),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12116),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5839),
    [anon_sym_yield] = ACTIONS(5841),
    [anon_sym_break] = ACTIONS(5843),
    [anon_sym_next] = ACTIONS(5845),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9529),
    [anon_sym_defined_QMARK] = ACTIONS(5847),
    [anon_sym_not] = ACTIONS(5849),
    [anon_sym_BANG] = ACTIONS(5853),
    [anon_sym_TILDE] = ACTIONS(5853),
    [sym_constant] = ACTIONS(5855),
    [sym_identifier] = ACTIONS(5855),
    [sym_instance_variable] = ACTIONS(5857),
    [sym_class_variable] = ACTIONS(5857),
    [sym_global_variable] = ACTIONS(5857),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5859),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5859),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6185] = {
    [sym_heredoc_body] = STATE(8524),
    [aux_sym_call_repeat1] = STATE(8524),
    [aux_sym_argument_list_repeat1] = STATE(8525),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(9577),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_COLON2] = ACTIONS(4385),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [6186] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(8526),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(3522),
    [sym_scope_resolution] = STATE(3518),
    [sym_call] = STATE(3518),
    [sym_method_call] = STATE(3522),
    [sym_splat_argument] = STATE(8527),
    [sym_assignment] = STATE(8526),
    [sym_operator_assignment] = STATE(8526),
    [sym_conditional] = STATE(8526),
    [sym_range] = STATE(8526),
    [sym_binary] = STATE(8526),
    [sym_unary] = STATE(8526),
    [sym_right_assignment_list] = STATE(4255),
    [sym__arg_or_splat_arg] = STATE(8527),
    [sym_left_assignment_list] = STATE(3521),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3522),
    [sym__variable] = STATE(3518),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(3522),
    [sym_false] = STATE(3522),
    [sym_nil] = STATE(3522),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(6150),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(9527),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(9535),
    [sym__unary_minus] = ACTIONS(5835),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5839),
    [anon_sym_yield] = ACTIONS(5841),
    [anon_sym_break] = ACTIONS(5843),
    [anon_sym_next] = ACTIONS(5845),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9529),
    [anon_sym_defined_QMARK] = ACTIONS(5847),
    [anon_sym_not] = ACTIONS(5849),
    [anon_sym_BANG] = ACTIONS(5853),
    [anon_sym_TILDE] = ACTIONS(5853),
    [sym_constant] = ACTIONS(5859),
    [sym_identifier] = ACTIONS(5859),
    [sym_instance_variable] = ACTIONS(5857),
    [sym_class_variable] = ACTIONS(5857),
    [sym_global_variable] = ACTIONS(5857),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5859),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5859),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6187] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(8528),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(3522),
    [sym_scope_resolution] = STATE(3518),
    [sym_call] = STATE(3518),
    [sym_method_call] = STATE(3522),
    [sym_assignment] = STATE(8528),
    [sym_operator_assignment] = STATE(8528),
    [sym_conditional] = STATE(8528),
    [sym_range] = STATE(8528),
    [sym_binary] = STATE(8528),
    [sym_unary] = STATE(8528),
    [sym_left_assignment_list] = STATE(3521),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3522),
    [sym__variable] = STATE(3518),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(3522),
    [sym_false] = STATE(3522),
    [sym_nil] = STATE(3522),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(6150),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(9527),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(5835),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5839),
    [anon_sym_yield] = ACTIONS(5841),
    [anon_sym_break] = ACTIONS(5843),
    [anon_sym_next] = ACTIONS(5845),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9529),
    [anon_sym_defined_QMARK] = ACTIONS(5847),
    [anon_sym_not] = ACTIONS(5849),
    [anon_sym_BANG] = ACTIONS(5853),
    [anon_sym_TILDE] = ACTIONS(5853),
    [sym_constant] = ACTIONS(5859),
    [sym_identifier] = ACTIONS(5859),
    [sym_instance_variable] = ACTIONS(5857),
    [sym_class_variable] = ACTIONS(5857),
    [sym_global_variable] = ACTIONS(5857),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5859),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5859),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6188] = {
    [sym_string] = STATE(8529),
    [aux_sym_chained_string_repeat1] = STATE(8529),
    [sym__string_start] = ACTIONS(9527),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_EQ_GT] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_COLON2] = ACTIONS(2755),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [6189] = {
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_COLON2] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [6190] = {
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_COLON2] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [6191] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_COLON2] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [6192] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_COLON2] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [6193] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_COLON2] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [6194] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(12118),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [6195] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(703),
    [sym__binary_star] = ACTIONS(705),
    [ts_builtin_sym_end] = ACTIONS(12120),
    [anon_sym___END__] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(707),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(705),
    [anon_sym_AMP] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(713),
    [anon_sym_DOT_DOT] = ACTIONS(715),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(717),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(721),
    [anon_sym_AMP_AMP] = ACTIONS(721),
    [anon_sym_LT_LT] = ACTIONS(723),
    [anon_sym_GT_GT] = ACTIONS(723),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(721),
    [anon_sym_LT_EQ_GT] = ACTIONS(721),
    [anon_sym_EQ_TILDE] = ACTIONS(721),
    [anon_sym_BANG_TILDE] = ACTIONS(721),
    [anon_sym_LT_EQ] = ACTIONS(711),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_EQ] = ACTIONS(727),
    [anon_sym_CARET] = ACTIONS(729),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_SLASH] = ACTIONS(705),
    [anon_sym_PERCENT] = ACTIONS(705),
    [sym_comment] = ACTIONS(87),
  },
  [6196] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_COLON2] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [6197] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [6198] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_COLON2] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [6199] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_COLON2] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [6200] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(8531),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(6210),
    [sym_scope_resolution] = STATE(6208),
    [sym_call] = STATE(6208),
    [sym_method_call] = STATE(6210),
    [sym_assignment] = STATE(8531),
    [sym_operator_assignment] = STATE(8531),
    [sym_conditional] = STATE(8531),
    [sym_range] = STATE(8531),
    [sym_binary] = STATE(8531),
    [sym_unary] = STATE(8531),
    [sym_left_assignment_list] = STATE(6209),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6210),
    [sym__variable] = STATE(6208),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(6210),
    [sym_false] = STATE(6210),
    [sym_nil] = STATE(6210),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(6211),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(9587),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(9589),
    [anon_sym_yield] = ACTIONS(9591),
    [anon_sym_break] = ACTIONS(9593),
    [anon_sym_next] = ACTIONS(9595),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(9597),
    [anon_sym_defined_QMARK] = ACTIONS(9599),
    [anon_sym_not] = ACTIONS(9601),
    [anon_sym_BANG] = ACTIONS(9603),
    [anon_sym_TILDE] = ACTIONS(9603),
    [sym_constant] = ACTIONS(9605),
    [sym_identifier] = ACTIONS(9605),
    [sym_instance_variable] = ACTIONS(9607),
    [sym_class_variable] = ACTIONS(9607),
    [sym_global_variable] = ACTIONS(9607),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(9605),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9605),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [6201] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3548),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3553),
    [sym_scope_resolution] = STATE(3549),
    [sym_call] = STATE(3549),
    [sym_method_call] = STATE(3553),
    [sym_argument_list] = STATE(6614),
    [sym__argument_list_with_parens] = STATE(3550),
    [sym__argument] = STATE(3551),
    [sym_splat_argument] = STATE(3551),
    [sym_hash_splat_argument] = STATE(3551),
    [sym_block_argument] = STATE(3551),
    [sym_assignment] = STATE(3548),
    [sym_operator_assignment] = STATE(3548),
    [sym_conditional] = STATE(3548),
    [sym_range] = STATE(3548),
    [sym_binary] = STATE(3548),
    [sym_unary] = STATE(3548),
    [sym_left_assignment_list] = STATE(3552),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3553),
    [sym__variable] = STATE(3549),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3553),
    [sym_false] = STATE(3553),
    [sym_nil] = STATE(3553),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3554),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(3551),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(5891),
    [sym__splat_star] = ACTIONS(5893),
    [sym__unary_minus] = ACTIONS(5895),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(5897),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5899),
    [anon_sym_yield] = ACTIONS(5901),
    [anon_sym_break] = ACTIONS(5903),
    [anon_sym_next] = ACTIONS(5905),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_PLUS_EQ] = ACTIONS(365),
    [anon_sym_DASH_EQ] = ACTIONS(365),
    [anon_sym_STAR_EQ] = ACTIONS(365),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(365),
    [anon_sym_SLASH_EQ] = ACTIONS(365),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(365),
    [anon_sym_PIPE_EQ] = ACTIONS(365),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(365),
    [anon_sym_AMP_EQ] = ACTIONS(365),
    [anon_sym_PERCENT_EQ] = ACTIONS(365),
    [anon_sym_GT_GT_EQ] = ACTIONS(365),
    [anon_sym_LT_LT_EQ] = ACTIONS(365),
    [anon_sym_CARET_EQ] = ACTIONS(365),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_COLON2] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_PERCENT] = ACTIONS(377),
    [anon_sym_defined_QMARK] = ACTIONS(5907),
    [anon_sym_not] = ACTIONS(5909),
    [anon_sym_BANG] = ACTIONS(5911),
    [anon_sym_TILDE] = ACTIONS(5913),
    [sym_constant] = ACTIONS(5915),
    [sym_identifier] = ACTIONS(5915),
    [sym_instance_variable] = ACTIONS(5917),
    [sym_class_variable] = ACTIONS(5917),
    [sym_global_variable] = ACTIONS(5917),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5919),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5919),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6202] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3548),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3553),
    [sym_scope_resolution] = STATE(3549),
    [sym_call] = STATE(3549),
    [sym_method_call] = STATE(3553),
    [sym_argument_list] = STATE(6615),
    [sym__argument_list_with_parens] = STATE(3550),
    [sym__argument] = STATE(3551),
    [sym_splat_argument] = STATE(3551),
    [sym_hash_splat_argument] = STATE(3551),
    [sym_block_argument] = STATE(3551),
    [sym_assignment] = STATE(3548),
    [sym_operator_assignment] = STATE(3548),
    [sym_conditional] = STATE(3548),
    [sym_range] = STATE(3548),
    [sym_binary] = STATE(3548),
    [sym_unary] = STATE(3548),
    [sym_left_assignment_list] = STATE(3552),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3553),
    [sym__variable] = STATE(3549),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3553),
    [sym_false] = STATE(3553),
    [sym_nil] = STATE(3553),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3554),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(3551),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(5891),
    [sym__splat_star] = ACTIONS(5893),
    [sym__unary_minus] = ACTIONS(5895),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(5897),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_EQ] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5899),
    [anon_sym_yield] = ACTIONS(5901),
    [anon_sym_break] = ACTIONS(5903),
    [anon_sym_next] = ACTIONS(5905),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_PLUS_EQ] = ACTIONS(417),
    [anon_sym_DASH_EQ] = ACTIONS(417),
    [anon_sym_STAR_EQ] = ACTIONS(417),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(417),
    [anon_sym_SLASH_EQ] = ACTIONS(417),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(417),
    [anon_sym_PIPE_EQ] = ACTIONS(417),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(417),
    [anon_sym_AMP_EQ] = ACTIONS(417),
    [anon_sym_PERCENT_EQ] = ACTIONS(417),
    [anon_sym_GT_GT_EQ] = ACTIONS(417),
    [anon_sym_LT_LT_EQ] = ACTIONS(417),
    [anon_sym_CARET_EQ] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_COLON2] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(5907),
    [anon_sym_not] = ACTIONS(5909),
    [anon_sym_BANG] = ACTIONS(5911),
    [anon_sym_TILDE] = ACTIONS(5913),
    [sym_constant] = ACTIONS(5915),
    [sym_identifier] = ACTIONS(5915),
    [sym_instance_variable] = ACTIONS(5917),
    [sym_class_variable] = ACTIONS(5917),
    [sym_global_variable] = ACTIONS(5917),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5919),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5919),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6203] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3548),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3553),
    [sym_scope_resolution] = STATE(3549),
    [sym_call] = STATE(3549),
    [sym_method_call] = STATE(3553),
    [sym_argument_list] = STATE(6616),
    [sym__argument_list_with_parens] = STATE(3550),
    [sym__argument] = STATE(3551),
    [sym_splat_argument] = STATE(3551),
    [sym_hash_splat_argument] = STATE(3551),
    [sym_block_argument] = STATE(3551),
    [sym_assignment] = STATE(3548),
    [sym_operator_assignment] = STATE(3548),
    [sym_conditional] = STATE(3548),
    [sym_range] = STATE(3548),
    [sym_binary] = STATE(3548),
    [sym_unary] = STATE(3548),
    [sym_left_assignment_list] = STATE(3552),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3553),
    [sym__variable] = STATE(3549),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3553),
    [sym_false] = STATE(3553),
    [sym_nil] = STATE(3553),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3554),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(3551),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(5891),
    [sym__splat_star] = ACTIONS(5893),
    [sym__unary_minus] = ACTIONS(5895),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(5897),
    [anon_sym_LBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_EQ] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5899),
    [anon_sym_yield] = ACTIONS(5901),
    [anon_sym_break] = ACTIONS(5903),
    [anon_sym_next] = ACTIONS(5905),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_PLUS_EQ] = ACTIONS(421),
    [anon_sym_DASH_EQ] = ACTIONS(421),
    [anon_sym_STAR_EQ] = ACTIONS(421),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(421),
    [anon_sym_SLASH_EQ] = ACTIONS(421),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(421),
    [anon_sym_PIPE_EQ] = ACTIONS(421),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(421),
    [anon_sym_AMP_EQ] = ACTIONS(421),
    [anon_sym_PERCENT_EQ] = ACTIONS(421),
    [anon_sym_GT_GT_EQ] = ACTIONS(421),
    [anon_sym_LT_LT_EQ] = ACTIONS(421),
    [anon_sym_CARET_EQ] = ACTIONS(421),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_COLON2] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(5907),
    [anon_sym_not] = ACTIONS(5909),
    [anon_sym_BANG] = ACTIONS(5911),
    [anon_sym_TILDE] = ACTIONS(5913),
    [sym_constant] = ACTIONS(5915),
    [sym_identifier] = ACTIONS(5915),
    [sym_instance_variable] = ACTIONS(5917),
    [sym_class_variable] = ACTIONS(5917),
    [sym_global_variable] = ACTIONS(5917),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5919),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5919),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6204] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3548),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3553),
    [sym_scope_resolution] = STATE(3549),
    [sym_call] = STATE(3549),
    [sym_method_call] = STATE(3553),
    [sym_argument_list] = STATE(6617),
    [sym__argument_list_with_parens] = STATE(3550),
    [sym__argument] = STATE(3551),
    [sym_splat_argument] = STATE(3551),
    [sym_hash_splat_argument] = STATE(3551),
    [sym_block_argument] = STATE(3551),
    [sym_assignment] = STATE(3548),
    [sym_operator_assignment] = STATE(3548),
    [sym_conditional] = STATE(3548),
    [sym_range] = STATE(3548),
    [sym_binary] = STATE(3548),
    [sym_unary] = STATE(3548),
    [sym_left_assignment_list] = STATE(3552),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3553),
    [sym__variable] = STATE(3549),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3553),
    [sym_false] = STATE(3553),
    [sym_nil] = STATE(3553),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3554),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(3551),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(5891),
    [sym__splat_star] = ACTIONS(5893),
    [sym__unary_minus] = ACTIONS(5895),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(5897),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(427),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5899),
    [anon_sym_yield] = ACTIONS(5901),
    [anon_sym_break] = ACTIONS(5903),
    [anon_sym_next] = ACTIONS(5905),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_PLUS_EQ] = ACTIONS(425),
    [anon_sym_DASH_EQ] = ACTIONS(425),
    [anon_sym_STAR_EQ] = ACTIONS(425),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(425),
    [anon_sym_SLASH_EQ] = ACTIONS(425),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(425),
    [anon_sym_PIPE_EQ] = ACTIONS(425),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(425),
    [anon_sym_AMP_EQ] = ACTIONS(425),
    [anon_sym_PERCENT_EQ] = ACTIONS(425),
    [anon_sym_GT_GT_EQ] = ACTIONS(425),
    [anon_sym_LT_LT_EQ] = ACTIONS(425),
    [anon_sym_CARET_EQ] = ACTIONS(425),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_COLON2] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(5907),
    [anon_sym_not] = ACTIONS(5909),
    [anon_sym_BANG] = ACTIONS(5911),
    [anon_sym_TILDE] = ACTIONS(5913),
    [sym_constant] = ACTIONS(5915),
    [sym_identifier] = ACTIONS(5915),
    [sym_instance_variable] = ACTIONS(5917),
    [sym_class_variable] = ACTIONS(5917),
    [sym_global_variable] = ACTIONS(5917),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5919),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5919),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6205] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(8532),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(6210),
    [sym_scope_resolution] = STATE(6208),
    [sym_call] = STATE(6208),
    [sym_method_call] = STATE(6210),
    [sym_assignment] = STATE(8532),
    [sym_operator_assignment] = STATE(8532),
    [sym_conditional] = STATE(8532),
    [sym_range] = STATE(8532),
    [sym_binary] = STATE(8532),
    [sym_unary] = STATE(8532),
    [sym_left_assignment_list] = STATE(6209),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6210),
    [sym__variable] = STATE(6208),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(6210),
    [sym_false] = STATE(6210),
    [sym_nil] = STATE(6210),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(6211),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(9587),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(9589),
    [anon_sym_yield] = ACTIONS(9591),
    [anon_sym_break] = ACTIONS(9593),
    [anon_sym_next] = ACTIONS(9595),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(9597),
    [anon_sym_defined_QMARK] = ACTIONS(9599),
    [anon_sym_not] = ACTIONS(9601),
    [anon_sym_BANG] = ACTIONS(9603),
    [anon_sym_TILDE] = ACTIONS(9603),
    [sym_constant] = ACTIONS(9605),
    [sym_identifier] = ACTIONS(9605),
    [sym_instance_variable] = ACTIONS(9607),
    [sym_class_variable] = ACTIONS(9607),
    [sym_global_variable] = ACTIONS(9607),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(9605),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9605),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [6206] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(6632),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(6210),
    [sym_scope_resolution] = STATE(6208),
    [sym_call] = STATE(6208),
    [sym_method_call] = STATE(6210),
    [sym_assignment] = STATE(6632),
    [sym_operator_assignment] = STATE(6632),
    [sym_conditional] = STATE(6632),
    [sym_range] = STATE(6632),
    [sym_binary] = STATE(6632),
    [sym_unary] = STATE(6632),
    [sym_left_assignment_list] = STATE(6209),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6210),
    [sym__variable] = STATE(6208),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(6210),
    [sym_false] = STATE(6210),
    [sym_nil] = STATE(6210),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(6211),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(9587),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(9589),
    [anon_sym_yield] = ACTIONS(9591),
    [anon_sym_break] = ACTIONS(9593),
    [anon_sym_next] = ACTIONS(9595),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(9597),
    [anon_sym_defined_QMARK] = ACTIONS(9599),
    [anon_sym_not] = ACTIONS(9601),
    [anon_sym_BANG] = ACTIONS(9603),
    [anon_sym_TILDE] = ACTIONS(9603),
    [sym_constant] = ACTIONS(9605),
    [sym_identifier] = ACTIONS(9605),
    [sym_instance_variable] = ACTIONS(9607),
    [sym_class_variable] = ACTIONS(9607),
    [sym_global_variable] = ACTIONS(9607),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(9605),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9605),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [6207] = {
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(12122),
    [sym__binary_star] = ACTIONS(12124),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(12126),
    [anon_sym_STAR_STAR] = ACTIONS(12128),
    [anon_sym_AMP] = ACTIONS(12130),
    [anon_sym_EQ] = ACTIONS(4217),
    [anon_sym_LT] = ACTIONS(12132),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_PLUS_EQ] = ACTIONS(4211),
    [anon_sym_DASH_EQ] = ACTIONS(4211),
    [anon_sym_STAR_EQ] = ACTIONS(4211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4211),
    [anon_sym_SLASH_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4211),
    [anon_sym_AMP_EQ] = ACTIONS(4211),
    [anon_sym_PERCENT_EQ] = ACTIONS(4211),
    [anon_sym_GT_GT_EQ] = ACTIONS(4211),
    [anon_sym_LT_LT_EQ] = ACTIONS(4211),
    [anon_sym_CARET_EQ] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(12134),
    [anon_sym_COLON2] = ACTIONS(4217),
    [anon_sym_DOT_DOT] = ACTIONS(12136),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12138),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(12140),
    [anon_sym_AMP_AMP] = ACTIONS(12140),
    [anon_sym_LT_LT] = ACTIONS(12142),
    [anon_sym_GT_GT] = ACTIONS(12142),
    [anon_sym_EQ_EQ] = ACTIONS(12140),
    [anon_sym_BANG_EQ] = ACTIONS(12144),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12144),
    [anon_sym_LT_EQ_GT] = ACTIONS(12144),
    [anon_sym_EQ_TILDE] = ACTIONS(12144),
    [anon_sym_BANG_TILDE] = ACTIONS(12144),
    [anon_sym_LT_EQ] = ACTIONS(12132),
    [anon_sym_GT] = ACTIONS(12132),
    [anon_sym_GT_EQ] = ACTIONS(12146),
    [anon_sym_CARET] = ACTIONS(12126),
    [anon_sym_PLUS] = ACTIONS(12148),
    [anon_sym_SLASH] = ACTIONS(12128),
    [anon_sym_PERCENT] = ACTIONS(12128),
    [sym_comment] = ACTIONS(87),
  },
  [6208] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3548),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3553),
    [sym_scope_resolution] = STATE(3549),
    [sym_call] = STATE(3549),
    [sym_method_call] = STATE(3553),
    [sym_argument_list] = STATE(4801),
    [sym__argument_list_with_parens] = STATE(3550),
    [sym__argument] = STATE(3551),
    [sym_splat_argument] = STATE(3551),
    [sym_hash_splat_argument] = STATE(3551),
    [sym_block_argument] = STATE(3551),
    [sym_do_block] = STATE(1849),
    [sym_block] = STATE(1849),
    [sym_assignment] = STATE(3548),
    [sym_operator_assignment] = STATE(3548),
    [sym_conditional] = STATE(3548),
    [sym_range] = STATE(3548),
    [sym_binary] = STATE(3548),
    [sym_unary] = STATE(3548),
    [sym_left_assignment_list] = STATE(3552),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3553),
    [sym__variable] = STATE(3549),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3553),
    [sym_false] = STATE(3553),
    [sym_nil] = STATE(3553),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3554),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(3551),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(5891),
    [sym__splat_star] = ACTIONS(5893),
    [sym__unary_minus] = ACTIONS(5895),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(5897),
    [anon_sym_LBRACE] = ACTIONS(7739),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5899),
    [anon_sym_yield] = ACTIONS(5901),
    [anon_sym_break] = ACTIONS(5903),
    [anon_sym_next] = ACTIONS(5905),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(769),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(5907),
    [anon_sym_not] = ACTIONS(5909),
    [anon_sym_BANG] = ACTIONS(5911),
    [anon_sym_TILDE] = ACTIONS(5913),
    [sym_constant] = ACTIONS(5915),
    [sym_identifier] = ACTIONS(5915),
    [sym_instance_variable] = ACTIONS(5917),
    [sym_class_variable] = ACTIONS(5917),
    [sym_global_variable] = ACTIONS(5917),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5919),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5919),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6209] = {
    [anon_sym_EQ] = ACTIONS(12150),
    [sym_comment] = ACTIONS(87),
  },
  [6210] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(12152),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(12154),
    [anon_sym_DASH_EQ] = ACTIONS(12154),
    [anon_sym_STAR_EQ] = ACTIONS(12154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12154),
    [anon_sym_SLASH_EQ] = ACTIONS(12154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12154),
    [anon_sym_PIPE_EQ] = ACTIONS(12154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12154),
    [anon_sym_AMP_EQ] = ACTIONS(12154),
    [anon_sym_PERCENT_EQ] = ACTIONS(12154),
    [anon_sym_GT_GT_EQ] = ACTIONS(12154),
    [anon_sym_LT_LT_EQ] = ACTIONS(12154),
    [anon_sym_CARET_EQ] = ACTIONS(12154),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [6211] = {
    [sym_string] = STATE(8545),
    [aux_sym_chained_string_repeat1] = STATE(8545),
    [sym__string_start] = ACTIONS(6455),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [6212] = {
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(12122),
    [sym__binary_star] = ACTIONS(12124),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(12126),
    [anon_sym_STAR_STAR] = ACTIONS(12128),
    [anon_sym_AMP] = ACTIONS(12130),
    [anon_sym_EQ] = ACTIONS(4249),
    [anon_sym_LT] = ACTIONS(12132),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_PLUS_EQ] = ACTIONS(4247),
    [anon_sym_DASH_EQ] = ACTIONS(4247),
    [anon_sym_STAR_EQ] = ACTIONS(4247),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4247),
    [anon_sym_SLASH_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4247),
    [anon_sym_AMP_EQ] = ACTIONS(4247),
    [anon_sym_PERCENT_EQ] = ACTIONS(4247),
    [anon_sym_GT_GT_EQ] = ACTIONS(4247),
    [anon_sym_LT_LT_EQ] = ACTIONS(4247),
    [anon_sym_CARET_EQ] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(12134),
    [anon_sym_COLON2] = ACTIONS(4249),
    [anon_sym_DOT_DOT] = ACTIONS(12136),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12138),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(12140),
    [anon_sym_AMP_AMP] = ACTIONS(12140),
    [anon_sym_LT_LT] = ACTIONS(12142),
    [anon_sym_GT_GT] = ACTIONS(12142),
    [anon_sym_EQ_EQ] = ACTIONS(12140),
    [anon_sym_BANG_EQ] = ACTIONS(12144),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12144),
    [anon_sym_LT_EQ_GT] = ACTIONS(12144),
    [anon_sym_EQ_TILDE] = ACTIONS(12144),
    [anon_sym_BANG_TILDE] = ACTIONS(12144),
    [anon_sym_LT_EQ] = ACTIONS(12132),
    [anon_sym_GT] = ACTIONS(12132),
    [anon_sym_GT_EQ] = ACTIONS(12146),
    [anon_sym_CARET] = ACTIONS(12126),
    [anon_sym_PLUS] = ACTIONS(12148),
    [anon_sym_SLASH] = ACTIONS(12128),
    [anon_sym_PERCENT] = ACTIONS(12128),
    [sym_comment] = ACTIONS(87),
  },
  [6213] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(8547),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(12156),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [6214] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(9623),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_COLON2] = ACTIONS(937),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [6215] = {
    [sym_string] = STATE(6235),
    [aux_sym_chained_string_repeat1] = STATE(6235),
    [sym__string_start] = ACTIONS(9609),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [6216] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(8548),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(6210),
    [sym_scope_resolution] = STATE(6208),
    [sym_call] = STATE(6208),
    [sym_method_call] = STATE(6210),
    [sym_assignment] = STATE(8548),
    [sym_operator_assignment] = STATE(8548),
    [sym_conditional] = STATE(8548),
    [sym_range] = STATE(8548),
    [sym_binary] = STATE(8548),
    [sym_unary] = STATE(8548),
    [sym_left_assignment_list] = STATE(6209),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6210),
    [sym__variable] = STATE(6208),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(6210),
    [sym_false] = STATE(6210),
    [sym_nil] = STATE(6210),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(6211),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(9587),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(9589),
    [anon_sym_yield] = ACTIONS(9591),
    [anon_sym_break] = ACTIONS(9593),
    [anon_sym_next] = ACTIONS(9595),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(9597),
    [anon_sym_defined_QMARK] = ACTIONS(9599),
    [anon_sym_not] = ACTIONS(9601),
    [anon_sym_BANG] = ACTIONS(9603),
    [anon_sym_TILDE] = ACTIONS(9603),
    [sym_constant] = ACTIONS(9605),
    [sym_identifier] = ACTIONS(9605),
    [sym_instance_variable] = ACTIONS(9607),
    [sym_class_variable] = ACTIONS(9607),
    [sym_global_variable] = ACTIONS(9607),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(9605),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9605),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [6217] = {
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(12122),
    [sym__binary_star] = ACTIONS(12124),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(12126),
    [anon_sym_STAR_STAR] = ACTIONS(12128),
    [anon_sym_AMP] = ACTIONS(12130),
    [anon_sym_EQ] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(12132),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_PLUS_EQ] = ACTIONS(3281),
    [anon_sym_DASH_EQ] = ACTIONS(3281),
    [anon_sym_STAR_EQ] = ACTIONS(3281),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3281),
    [anon_sym_SLASH_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3281),
    [anon_sym_AMP_EQ] = ACTIONS(3281),
    [anon_sym_PERCENT_EQ] = ACTIONS(3281),
    [anon_sym_GT_GT_EQ] = ACTIONS(3281),
    [anon_sym_LT_LT_EQ] = ACTIONS(3281),
    [anon_sym_CARET_EQ] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(12134),
    [anon_sym_COLON2] = ACTIONS(4251),
    [anon_sym_DOT_DOT] = ACTIONS(12136),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12138),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(12140),
    [anon_sym_AMP_AMP] = ACTIONS(12140),
    [anon_sym_LT_LT] = ACTIONS(12142),
    [anon_sym_GT_GT] = ACTIONS(12142),
    [anon_sym_EQ_EQ] = ACTIONS(12140),
    [anon_sym_BANG_EQ] = ACTIONS(12144),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12144),
    [anon_sym_LT_EQ_GT] = ACTIONS(12144),
    [anon_sym_EQ_TILDE] = ACTIONS(12144),
    [anon_sym_BANG_TILDE] = ACTIONS(12144),
    [anon_sym_LT_EQ] = ACTIONS(12132),
    [anon_sym_GT] = ACTIONS(12132),
    [anon_sym_GT_EQ] = ACTIONS(12146),
    [anon_sym_CARET] = ACTIONS(12126),
    [anon_sym_PLUS] = ACTIONS(12148),
    [anon_sym_SLASH] = ACTIONS(12128),
    [anon_sym_PERCENT] = ACTIONS(12128),
    [sym_comment] = ACTIONS(87),
  },
  [6218] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(9617),
    [sym__binary_star] = ACTIONS(9619),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(9621),
    [anon_sym_STAR_STAR] = ACTIONS(9623),
    [anon_sym_AMP] = ACTIONS(9625),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(9627),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(9629),
    [anon_sym_COLON2] = ACTIONS(937),
    [anon_sym_DOT_DOT] = ACTIONS(9631),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9633),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(9635),
    [anon_sym_AMP_AMP] = ACTIONS(9635),
    [anon_sym_LT_LT] = ACTIONS(9637),
    [anon_sym_GT_GT] = ACTIONS(9637),
    [anon_sym_EQ_EQ] = ACTIONS(9635),
    [anon_sym_BANG_EQ] = ACTIONS(9639),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9639),
    [anon_sym_LT_EQ_GT] = ACTIONS(9639),
    [anon_sym_EQ_TILDE] = ACTIONS(9639),
    [anon_sym_BANG_TILDE] = ACTIONS(9639),
    [anon_sym_LT_EQ] = ACTIONS(9627),
    [anon_sym_GT] = ACTIONS(9627),
    [anon_sym_GT_EQ] = ACTIONS(9641),
    [anon_sym_CARET] = ACTIONS(9621),
    [anon_sym_PLUS] = ACTIONS(9643),
    [anon_sym_SLASH] = ACTIONS(9623),
    [anon_sym_PERCENT] = ACTIONS(9623),
    [sym_comment] = ACTIONS(87),
  },
  [6219] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(8549),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(6210),
    [sym_scope_resolution] = STATE(6208),
    [sym_call] = STATE(6208),
    [sym_method_call] = STATE(6210),
    [sym_assignment] = STATE(8549),
    [sym_operator_assignment] = STATE(8549),
    [sym_conditional] = STATE(8549),
    [sym_range] = STATE(8549),
    [sym_binary] = STATE(8549),
    [sym_unary] = STATE(8549),
    [sym_left_assignment_list] = STATE(6209),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6210),
    [sym__variable] = STATE(6208),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(6210),
    [sym_false] = STATE(6210),
    [sym_nil] = STATE(6210),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(6211),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(9587),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(9589),
    [anon_sym_yield] = ACTIONS(9591),
    [anon_sym_break] = ACTIONS(9593),
    [anon_sym_next] = ACTIONS(9595),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(9597),
    [anon_sym_defined_QMARK] = ACTIONS(9599),
    [anon_sym_not] = ACTIONS(9601),
    [anon_sym_BANG] = ACTIONS(9603),
    [anon_sym_TILDE] = ACTIONS(9603),
    [sym_constant] = ACTIONS(9605),
    [sym_identifier] = ACTIONS(9605),
    [sym_instance_variable] = ACTIONS(9607),
    [sym_class_variable] = ACTIONS(9607),
    [sym_global_variable] = ACTIONS(9607),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(9605),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9605),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [6220] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(8550),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3553),
    [sym_scope_resolution] = STATE(3549),
    [sym_call] = STATE(3549),
    [sym_method_call] = STATE(3553),
    [sym_assignment] = STATE(8550),
    [sym_operator_assignment] = STATE(8550),
    [sym_conditional] = STATE(8550),
    [sym_range] = STATE(8550),
    [sym_binary] = STATE(8550),
    [sym_unary] = STATE(8550),
    [sym_left_assignment_list] = STATE(3552),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3553),
    [sym__variable] = STATE(3549),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3553),
    [sym_false] = STATE(3553),
    [sym_nil] = STATE(3553),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6215),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(9609),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(5895),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5899),
    [anon_sym_yield] = ACTIONS(5901),
    [anon_sym_break] = ACTIONS(5903),
    [anon_sym_next] = ACTIONS(5905),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(9611),
    [anon_sym_defined_QMARK] = ACTIONS(5907),
    [anon_sym_not] = ACTIONS(5909),
    [anon_sym_BANG] = ACTIONS(5913),
    [anon_sym_TILDE] = ACTIONS(5913),
    [sym_constant] = ACTIONS(5919),
    [sym_identifier] = ACTIONS(5919),
    [sym_instance_variable] = ACTIONS(5917),
    [sym_class_variable] = ACTIONS(5917),
    [sym_global_variable] = ACTIONS(5917),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5919),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5919),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6221] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(8551),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3553),
    [sym_scope_resolution] = STATE(3549),
    [sym_call] = STATE(3549),
    [sym_method_call] = STATE(3553),
    [sym_assignment] = STATE(8551),
    [sym_operator_assignment] = STATE(8551),
    [sym_conditional] = STATE(8551),
    [sym_range] = STATE(8551),
    [sym_binary] = STATE(8551),
    [sym_unary] = STATE(8551),
    [sym_left_assignment_list] = STATE(3552),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3553),
    [sym__variable] = STATE(3549),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3553),
    [sym_false] = STATE(3553),
    [sym_nil] = STATE(3553),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6215),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(9609),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(5895),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5899),
    [anon_sym_yield] = ACTIONS(5901),
    [anon_sym_break] = ACTIONS(5903),
    [anon_sym_next] = ACTIONS(5905),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(9611),
    [anon_sym_defined_QMARK] = ACTIONS(5907),
    [anon_sym_not] = ACTIONS(5909),
    [anon_sym_BANG] = ACTIONS(5913),
    [anon_sym_TILDE] = ACTIONS(5913),
    [sym_constant] = ACTIONS(5919),
    [sym_identifier] = ACTIONS(5919),
    [sym_instance_variable] = ACTIONS(5917),
    [sym_class_variable] = ACTIONS(5917),
    [sym_global_variable] = ACTIONS(5917),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5919),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5919),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6222] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(8552),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3553),
    [sym_scope_resolution] = STATE(3549),
    [sym_call] = STATE(3549),
    [sym_method_call] = STATE(3553),
    [sym_assignment] = STATE(8552),
    [sym_operator_assignment] = STATE(8552),
    [sym_conditional] = STATE(8552),
    [sym_range] = STATE(8552),
    [sym_binary] = STATE(8552),
    [sym_unary] = STATE(8552),
    [sym_left_assignment_list] = STATE(3552),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3553),
    [sym__variable] = STATE(3549),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3553),
    [sym_false] = STATE(3553),
    [sym_nil] = STATE(3553),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6215),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(9609),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(5895),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5899),
    [anon_sym_yield] = ACTIONS(5901),
    [anon_sym_break] = ACTIONS(5903),
    [anon_sym_next] = ACTIONS(5905),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(9611),
    [anon_sym_defined_QMARK] = ACTIONS(5907),
    [anon_sym_not] = ACTIONS(5909),
    [anon_sym_BANG] = ACTIONS(5913),
    [anon_sym_TILDE] = ACTIONS(5913),
    [sym_constant] = ACTIONS(5919),
    [sym_identifier] = ACTIONS(5919),
    [sym_instance_variable] = ACTIONS(5917),
    [sym_class_variable] = ACTIONS(5917),
    [sym_global_variable] = ACTIONS(5917),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5919),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5919),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6223] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(8553),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3553),
    [sym_scope_resolution] = STATE(3549),
    [sym_call] = STATE(3549),
    [sym_method_call] = STATE(3553),
    [sym_assignment] = STATE(8553),
    [sym_operator_assignment] = STATE(8553),
    [sym_conditional] = STATE(8553),
    [sym_range] = STATE(8553),
    [sym_binary] = STATE(8553),
    [sym_unary] = STATE(8553),
    [sym_left_assignment_list] = STATE(3552),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3553),
    [sym__variable] = STATE(3549),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3553),
    [sym_false] = STATE(3553),
    [sym_nil] = STATE(3553),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6215),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(9609),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(5895),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5899),
    [anon_sym_yield] = ACTIONS(5901),
    [anon_sym_break] = ACTIONS(5903),
    [anon_sym_next] = ACTIONS(5905),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(9611),
    [anon_sym_defined_QMARK] = ACTIONS(5907),
    [anon_sym_not] = ACTIONS(5909),
    [anon_sym_BANG] = ACTIONS(5913),
    [anon_sym_TILDE] = ACTIONS(5913),
    [sym_constant] = ACTIONS(5919),
    [sym_identifier] = ACTIONS(5919),
    [sym_instance_variable] = ACTIONS(5917),
    [sym_class_variable] = ACTIONS(5917),
    [sym_global_variable] = ACTIONS(5917),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5919),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5919),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6224] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(8554),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3553),
    [sym_scope_resolution] = STATE(3549),
    [sym_call] = STATE(3549),
    [sym_method_call] = STATE(3553),
    [sym_assignment] = STATE(8554),
    [sym_operator_assignment] = STATE(8554),
    [sym_conditional] = STATE(8554),
    [sym_range] = STATE(8554),
    [sym_binary] = STATE(8554),
    [sym_unary] = STATE(8554),
    [sym_left_assignment_list] = STATE(3552),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3553),
    [sym__variable] = STATE(3549),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3553),
    [sym_false] = STATE(3553),
    [sym_nil] = STATE(3553),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6215),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(9609),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(5895),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5899),
    [anon_sym_yield] = ACTIONS(5901),
    [anon_sym_break] = ACTIONS(5903),
    [anon_sym_next] = ACTIONS(5905),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(9611),
    [anon_sym_defined_QMARK] = ACTIONS(5907),
    [anon_sym_not] = ACTIONS(5909),
    [anon_sym_BANG] = ACTIONS(5913),
    [anon_sym_TILDE] = ACTIONS(5913),
    [sym_constant] = ACTIONS(5919),
    [sym_identifier] = ACTIONS(5919),
    [sym_instance_variable] = ACTIONS(5917),
    [sym_class_variable] = ACTIONS(5917),
    [sym_global_variable] = ACTIONS(5917),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5919),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5919),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6225] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(8555),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(8555),
    [sym_operator_assignment] = STATE(8555),
    [sym_conditional] = STATE(8555),
    [sym_range] = STATE(8555),
    [sym_binary] = STATE(8555),
    [sym_unary] = STATE(8555),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6226] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(8556),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3553),
    [sym_scope_resolution] = STATE(3549),
    [sym_call] = STATE(3549),
    [sym_method_call] = STATE(3553),
    [sym_assignment] = STATE(8556),
    [sym_operator_assignment] = STATE(8556),
    [sym_conditional] = STATE(8556),
    [sym_range] = STATE(8556),
    [sym_binary] = STATE(8556),
    [sym_unary] = STATE(8556),
    [sym_left_assignment_list] = STATE(3552),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3553),
    [sym__variable] = STATE(3549),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3553),
    [sym_false] = STATE(3553),
    [sym_nil] = STATE(3553),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6215),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(9609),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(5895),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5899),
    [anon_sym_yield] = ACTIONS(5901),
    [anon_sym_break] = ACTIONS(5903),
    [anon_sym_next] = ACTIONS(5905),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(9611),
    [anon_sym_defined_QMARK] = ACTIONS(5907),
    [anon_sym_not] = ACTIONS(5909),
    [anon_sym_BANG] = ACTIONS(5913),
    [anon_sym_TILDE] = ACTIONS(5913),
    [sym_constant] = ACTIONS(5919),
    [sym_identifier] = ACTIONS(5919),
    [sym_instance_variable] = ACTIONS(5917),
    [sym_class_variable] = ACTIONS(5917),
    [sym_global_variable] = ACTIONS(5917),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5919),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5919),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6227] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(8557),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3553),
    [sym_scope_resolution] = STATE(3549),
    [sym_call] = STATE(3549),
    [sym_method_call] = STATE(3553),
    [sym_assignment] = STATE(8557),
    [sym_operator_assignment] = STATE(8557),
    [sym_conditional] = STATE(8557),
    [sym_range] = STATE(8557),
    [sym_binary] = STATE(8557),
    [sym_unary] = STATE(8557),
    [sym_left_assignment_list] = STATE(3552),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3553),
    [sym__variable] = STATE(3549),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3553),
    [sym_false] = STATE(3553),
    [sym_nil] = STATE(3553),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6215),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(9609),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(5895),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5899),
    [anon_sym_yield] = ACTIONS(5901),
    [anon_sym_break] = ACTIONS(5903),
    [anon_sym_next] = ACTIONS(5905),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(9611),
    [anon_sym_defined_QMARK] = ACTIONS(5907),
    [anon_sym_not] = ACTIONS(5909),
    [anon_sym_BANG] = ACTIONS(5913),
    [anon_sym_TILDE] = ACTIONS(5913),
    [sym_constant] = ACTIONS(5919),
    [sym_identifier] = ACTIONS(5919),
    [sym_instance_variable] = ACTIONS(5917),
    [sym_class_variable] = ACTIONS(5917),
    [sym_global_variable] = ACTIONS(5917),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5919),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5919),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6228] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(8558),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3553),
    [sym_scope_resolution] = STATE(3549),
    [sym_call] = STATE(3549),
    [sym_method_call] = STATE(3553),
    [sym_assignment] = STATE(8558),
    [sym_operator_assignment] = STATE(8558),
    [sym_conditional] = STATE(8558),
    [sym_range] = STATE(8558),
    [sym_binary] = STATE(8558),
    [sym_unary] = STATE(8558),
    [sym_left_assignment_list] = STATE(3552),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3553),
    [sym__variable] = STATE(3549),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3553),
    [sym_false] = STATE(3553),
    [sym_nil] = STATE(3553),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6215),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(9609),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(5895),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5899),
    [anon_sym_yield] = ACTIONS(5901),
    [anon_sym_break] = ACTIONS(5903),
    [anon_sym_next] = ACTIONS(5905),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(9611),
    [anon_sym_defined_QMARK] = ACTIONS(5907),
    [anon_sym_not] = ACTIONS(5909),
    [anon_sym_BANG] = ACTIONS(5913),
    [anon_sym_TILDE] = ACTIONS(5913),
    [sym_constant] = ACTIONS(5919),
    [sym_identifier] = ACTIONS(5919),
    [sym_instance_variable] = ACTIONS(5917),
    [sym_class_variable] = ACTIONS(5917),
    [sym_global_variable] = ACTIONS(5917),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5919),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5919),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6229] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(8559),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3553),
    [sym_scope_resolution] = STATE(3549),
    [sym_call] = STATE(3549),
    [sym_method_call] = STATE(3553),
    [sym_assignment] = STATE(8559),
    [sym_operator_assignment] = STATE(8559),
    [sym_conditional] = STATE(8559),
    [sym_range] = STATE(8559),
    [sym_binary] = STATE(8559),
    [sym_unary] = STATE(8559),
    [sym_left_assignment_list] = STATE(3552),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3553),
    [sym__variable] = STATE(3549),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3553),
    [sym_false] = STATE(3553),
    [sym_nil] = STATE(3553),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6215),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(9609),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(5895),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5899),
    [anon_sym_yield] = ACTIONS(5901),
    [anon_sym_break] = ACTIONS(5903),
    [anon_sym_next] = ACTIONS(5905),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(9611),
    [anon_sym_defined_QMARK] = ACTIONS(5907),
    [anon_sym_not] = ACTIONS(5909),
    [anon_sym_BANG] = ACTIONS(5913),
    [anon_sym_TILDE] = ACTIONS(5913),
    [sym_constant] = ACTIONS(5919),
    [sym_identifier] = ACTIONS(5919),
    [sym_instance_variable] = ACTIONS(5917),
    [sym_class_variable] = ACTIONS(5917),
    [sym_global_variable] = ACTIONS(5917),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5919),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5919),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6230] = {
    [sym_heredoc_body] = STATE(8560),
    [aux_sym_call_repeat1] = STATE(8560),
    [sym__heredoc_body_start] = ACTIONS(6569),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_COLON2] = ACTIONS(4385),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [6231] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3548),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3553),
    [sym_scope_resolution] = STATE(3549),
    [sym_call] = STATE(3549),
    [sym_method_call] = STATE(3553),
    [sym__argument] = STATE(6674),
    [sym_splat_argument] = STATE(6674),
    [sym_hash_splat_argument] = STATE(6674),
    [sym_block_argument] = STATE(6674),
    [sym_assignment] = STATE(3548),
    [sym_operator_assignment] = STATE(3548),
    [sym_conditional] = STATE(3548),
    [sym_range] = STATE(3548),
    [sym_binary] = STATE(3548),
    [sym_unary] = STATE(3548),
    [sym_left_assignment_list] = STATE(3552),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3553),
    [sym__variable] = STATE(3549),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3553),
    [sym_false] = STATE(3553),
    [sym_nil] = STATE(3553),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3554),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_heredoc_body] = STATE(8561),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(6674),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(5891),
    [sym__splat_star] = ACTIONS(5893),
    [sym__unary_minus] = ACTIONS(5895),
    [sym__identifier_hash_key] = ACTIONS(5897),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12158),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5899),
    [anon_sym_yield] = ACTIONS(5901),
    [anon_sym_break] = ACTIONS(5903),
    [anon_sym_next] = ACTIONS(5905),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(9611),
    [anon_sym_defined_QMARK] = ACTIONS(5907),
    [anon_sym_not] = ACTIONS(5909),
    [anon_sym_BANG] = ACTIONS(5913),
    [anon_sym_TILDE] = ACTIONS(5913),
    [sym_constant] = ACTIONS(5915),
    [sym_identifier] = ACTIONS(5915),
    [sym_instance_variable] = ACTIONS(5917),
    [sym_class_variable] = ACTIONS(5917),
    [sym_global_variable] = ACTIONS(5917),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5919),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5919),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6232] = {
    [sym_heredoc_body] = STATE(8562),
    [aux_sym_call_repeat1] = STATE(8562),
    [aux_sym_argument_list_repeat1] = STATE(8563),
    [sym__heredoc_body_start] = ACTIONS(6569),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(9645),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_COLON2] = ACTIONS(4385),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [6233] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(8564),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3553),
    [sym_scope_resolution] = STATE(3549),
    [sym_call] = STATE(3549),
    [sym_method_call] = STATE(3553),
    [sym_splat_argument] = STATE(8565),
    [sym_assignment] = STATE(8564),
    [sym_operator_assignment] = STATE(8564),
    [sym_conditional] = STATE(8564),
    [sym_range] = STATE(8564),
    [sym_binary] = STATE(8564),
    [sym_unary] = STATE(8564),
    [sym_right_assignment_list] = STATE(4362),
    [sym__arg_or_splat_arg] = STATE(8565),
    [sym_left_assignment_list] = STATE(3552),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3553),
    [sym__variable] = STATE(3549),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3553),
    [sym_false] = STATE(3553),
    [sym_nil] = STATE(3553),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6215),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(9609),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__splat_star] = ACTIONS(9571),
    [sym__unary_minus] = ACTIONS(5895),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5899),
    [anon_sym_yield] = ACTIONS(5901),
    [anon_sym_break] = ACTIONS(5903),
    [anon_sym_next] = ACTIONS(5905),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(9611),
    [anon_sym_defined_QMARK] = ACTIONS(5907),
    [anon_sym_not] = ACTIONS(5909),
    [anon_sym_BANG] = ACTIONS(5913),
    [anon_sym_TILDE] = ACTIONS(5913),
    [sym_constant] = ACTIONS(5919),
    [sym_identifier] = ACTIONS(5919),
    [sym_instance_variable] = ACTIONS(5917),
    [sym_class_variable] = ACTIONS(5917),
    [sym_global_variable] = ACTIONS(5917),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5919),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5919),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6234] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(8566),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3553),
    [sym_scope_resolution] = STATE(3549),
    [sym_call] = STATE(3549),
    [sym_method_call] = STATE(3553),
    [sym_assignment] = STATE(8566),
    [sym_operator_assignment] = STATE(8566),
    [sym_conditional] = STATE(8566),
    [sym_range] = STATE(8566),
    [sym_binary] = STATE(8566),
    [sym_unary] = STATE(8566),
    [sym_left_assignment_list] = STATE(3552),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3553),
    [sym__variable] = STATE(3549),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3553),
    [sym_false] = STATE(3553),
    [sym_nil] = STATE(3553),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6215),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(9609),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(5895),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5899),
    [anon_sym_yield] = ACTIONS(5901),
    [anon_sym_break] = ACTIONS(5903),
    [anon_sym_next] = ACTIONS(5905),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(9611),
    [anon_sym_defined_QMARK] = ACTIONS(5907),
    [anon_sym_not] = ACTIONS(5909),
    [anon_sym_BANG] = ACTIONS(5913),
    [anon_sym_TILDE] = ACTIONS(5913),
    [sym_constant] = ACTIONS(5919),
    [sym_identifier] = ACTIONS(5919),
    [sym_instance_variable] = ACTIONS(5917),
    [sym_class_variable] = ACTIONS(5917),
    [sym_global_variable] = ACTIONS(5917),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5919),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5919),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6235] = {
    [sym_string] = STATE(8567),
    [aux_sym_chained_string_repeat1] = STATE(8567),
    [sym__string_start] = ACTIONS(9609),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_STAR_STAR] = ACTIONS(2755),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_EQ] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_EQ_GT] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_PLUS_EQ] = ACTIONS(2753),
    [anon_sym_DASH_EQ] = ACTIONS(2753),
    [anon_sym_STAR_EQ] = ACTIONS(2753),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2753),
    [anon_sym_SLASH_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2753),
    [anon_sym_AMP_EQ] = ACTIONS(2753),
    [anon_sym_PERCENT_EQ] = ACTIONS(2753),
    [anon_sym_GT_GT_EQ] = ACTIONS(2753),
    [anon_sym_LT_LT_EQ] = ACTIONS(2753),
    [anon_sym_CARET_EQ] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_COLON2] = ACTIONS(2755),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2755),
    [anon_sym_AMP_AMP] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2755),
    [anon_sym_GT_GT] = ACTIONS(2755),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_SLASH] = ACTIONS(2755),
    [anon_sym_PERCENT] = ACTIONS(2755),
    [sym_comment] = ACTIONS(87),
  },
  [6236] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(8568),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(6247),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(6247),
    [sym_assignment] = STATE(8568),
    [sym_operator_assignment] = STATE(8568),
    [sym_conditional] = STATE(8568),
    [sym_range] = STATE(8568),
    [sym_binary] = STATE(8568),
    [sym_unary] = STATE(8568),
    [sym_left_assignment_list] = STATE(6246),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6247),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(6247),
    [sym_false] = STATE(6247),
    [sym_nil] = STATE(6247),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(6248),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(9657),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9659),
    [anon_sym_yield] = ACTIONS(9661),
    [anon_sym_break] = ACTIONS(9663),
    [anon_sym_next] = ACTIONS(9665),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9667),
    [anon_sym_defined_QMARK] = ACTIONS(9669),
    [anon_sym_not] = ACTIONS(9671),
    [anon_sym_BANG] = ACTIONS(9673),
    [anon_sym_TILDE] = ACTIONS(9673),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6237] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(8569),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(6247),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(6247),
    [sym_assignment] = STATE(8569),
    [sym_operator_assignment] = STATE(8569),
    [sym_conditional] = STATE(8569),
    [sym_range] = STATE(8569),
    [sym_binary] = STATE(8569),
    [sym_unary] = STATE(8569),
    [sym_left_assignment_list] = STATE(6246),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6247),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(6247),
    [sym_false] = STATE(6247),
    [sym_nil] = STATE(6247),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(6248),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(9657),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9659),
    [anon_sym_yield] = ACTIONS(9661),
    [anon_sym_break] = ACTIONS(9663),
    [anon_sym_next] = ACTIONS(9665),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9667),
    [anon_sym_defined_QMARK] = ACTIONS(9669),
    [anon_sym_not] = ACTIONS(9671),
    [anon_sym_BANG] = ACTIONS(9673),
    [anon_sym_TILDE] = ACTIONS(9673),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6238] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(3517),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(3522),
    [sym_scope_resolution] = STATE(3518),
    [sym_call] = STATE(3518),
    [sym_method_call] = STATE(3522),
    [sym_argument_list] = STATE(563),
    [sym__argument_list_with_parens] = STATE(8476),
    [sym__argument] = STATE(8477),
    [sym_splat_argument] = STATE(8477),
    [sym_hash_splat_argument] = STATE(8477),
    [sym_block_argument] = STATE(8477),
    [sym_assignment] = STATE(3517),
    [sym_operator_assignment] = STATE(3517),
    [sym_conditional] = STATE(3517),
    [sym_range] = STATE(3517),
    [sym_binary] = STATE(3517),
    [sym_unary] = STATE(3517),
    [sym_left_assignment_list] = STATE(3521),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3522),
    [sym__variable] = STATE(3518),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(3522),
    [sym_false] = STATE(3522),
    [sym_nil] = STATE(3522),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(3523),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(8477),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(5831),
    [sym__splat_star] = ACTIONS(5833),
    [sym__unary_minus] = ACTIONS(5835),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(5837),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5839),
    [anon_sym_yield] = ACTIONS(5841),
    [anon_sym_break] = ACTIONS(5843),
    [anon_sym_next] = ACTIONS(5845),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_COLON2] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(5847),
    [anon_sym_not] = ACTIONS(5849),
    [anon_sym_BANG] = ACTIONS(5851),
    [anon_sym_TILDE] = ACTIONS(5853),
    [sym_constant] = ACTIONS(5855),
    [sym_identifier] = ACTIONS(5855),
    [sym_instance_variable] = ACTIONS(5857),
    [sym_class_variable] = ACTIONS(5857),
    [sym_global_variable] = ACTIONS(5857),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5859),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5859),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6239] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(3517),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(3522),
    [sym_scope_resolution] = STATE(3518),
    [sym_call] = STATE(3518),
    [sym_method_call] = STATE(3522),
    [sym_argument_list] = STATE(569),
    [sym__argument_list_with_parens] = STATE(8476),
    [sym__argument] = STATE(8477),
    [sym_splat_argument] = STATE(8477),
    [sym_hash_splat_argument] = STATE(8477),
    [sym_block_argument] = STATE(8477),
    [sym_assignment] = STATE(3517),
    [sym_operator_assignment] = STATE(3517),
    [sym_conditional] = STATE(3517),
    [sym_range] = STATE(3517),
    [sym_binary] = STATE(3517),
    [sym_unary] = STATE(3517),
    [sym_left_assignment_list] = STATE(3521),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3522),
    [sym__variable] = STATE(3518),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(3522),
    [sym_false] = STATE(3522),
    [sym_nil] = STATE(3522),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(3523),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(8477),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(5831),
    [sym__splat_star] = ACTIONS(5833),
    [sym__unary_minus] = ACTIONS(5835),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(5837),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5839),
    [anon_sym_yield] = ACTIONS(5841),
    [anon_sym_break] = ACTIONS(5843),
    [anon_sym_next] = ACTIONS(5845),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_COLON2] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(5847),
    [anon_sym_not] = ACTIONS(5849),
    [anon_sym_BANG] = ACTIONS(5851),
    [anon_sym_TILDE] = ACTIONS(5853),
    [sym_constant] = ACTIONS(5855),
    [sym_identifier] = ACTIONS(5855),
    [sym_instance_variable] = ACTIONS(5857),
    [sym_class_variable] = ACTIONS(5857),
    [sym_global_variable] = ACTIONS(5857),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5859),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5859),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6240] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(3517),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(3522),
    [sym_scope_resolution] = STATE(3518),
    [sym_call] = STATE(3518),
    [sym_method_call] = STATE(3522),
    [sym_argument_list] = STATE(570),
    [sym__argument_list_with_parens] = STATE(8476),
    [sym__argument] = STATE(8477),
    [sym_splat_argument] = STATE(8477),
    [sym_hash_splat_argument] = STATE(8477),
    [sym_block_argument] = STATE(8477),
    [sym_assignment] = STATE(3517),
    [sym_operator_assignment] = STATE(3517),
    [sym_conditional] = STATE(3517),
    [sym_range] = STATE(3517),
    [sym_binary] = STATE(3517),
    [sym_unary] = STATE(3517),
    [sym_left_assignment_list] = STATE(3521),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3522),
    [sym__variable] = STATE(3518),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(3522),
    [sym_false] = STATE(3522),
    [sym_nil] = STATE(3522),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(3523),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(8477),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(5831),
    [sym__splat_star] = ACTIONS(5833),
    [sym__unary_minus] = ACTIONS(5835),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(5837),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5839),
    [anon_sym_yield] = ACTIONS(5841),
    [anon_sym_break] = ACTIONS(5843),
    [anon_sym_next] = ACTIONS(5845),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_COLON2] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(5847),
    [anon_sym_not] = ACTIONS(5849),
    [anon_sym_BANG] = ACTIONS(5851),
    [anon_sym_TILDE] = ACTIONS(5853),
    [sym_constant] = ACTIONS(5855),
    [sym_identifier] = ACTIONS(5855),
    [sym_instance_variable] = ACTIONS(5857),
    [sym_class_variable] = ACTIONS(5857),
    [sym_global_variable] = ACTIONS(5857),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5859),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5859),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6241] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(3517),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(3522),
    [sym_scope_resolution] = STATE(3518),
    [sym_call] = STATE(3518),
    [sym_method_call] = STATE(3522),
    [sym_argument_list] = STATE(571),
    [sym__argument_list_with_parens] = STATE(8476),
    [sym__argument] = STATE(8477),
    [sym_splat_argument] = STATE(8477),
    [sym_hash_splat_argument] = STATE(8477),
    [sym_block_argument] = STATE(8477),
    [sym_assignment] = STATE(3517),
    [sym_operator_assignment] = STATE(3517),
    [sym_conditional] = STATE(3517),
    [sym_range] = STATE(3517),
    [sym_binary] = STATE(3517),
    [sym_unary] = STATE(3517),
    [sym_left_assignment_list] = STATE(3521),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3522),
    [sym__variable] = STATE(3518),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(3522),
    [sym_false] = STATE(3522),
    [sym_nil] = STATE(3522),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(3523),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(8477),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(5831),
    [sym__splat_star] = ACTIONS(5833),
    [sym__unary_minus] = ACTIONS(5835),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(5837),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5839),
    [anon_sym_yield] = ACTIONS(5841),
    [anon_sym_break] = ACTIONS(5843),
    [anon_sym_next] = ACTIONS(5845),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_COLON2] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(5847),
    [anon_sym_not] = ACTIONS(5849),
    [anon_sym_BANG] = ACTIONS(5851),
    [anon_sym_TILDE] = ACTIONS(5853),
    [sym_constant] = ACTIONS(5855),
    [sym_identifier] = ACTIONS(5855),
    [sym_instance_variable] = ACTIONS(5857),
    [sym_class_variable] = ACTIONS(5857),
    [sym_global_variable] = ACTIONS(5857),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5859),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5859),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6242] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(8570),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(6247),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(6247),
    [sym_assignment] = STATE(8570),
    [sym_operator_assignment] = STATE(8570),
    [sym_conditional] = STATE(8570),
    [sym_range] = STATE(8570),
    [sym_binary] = STATE(8570),
    [sym_unary] = STATE(8570),
    [sym_left_assignment_list] = STATE(6246),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6247),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(6247),
    [sym_false] = STATE(6247),
    [sym_nil] = STATE(6247),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(6248),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(9657),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9659),
    [anon_sym_yield] = ACTIONS(9661),
    [anon_sym_break] = ACTIONS(9663),
    [anon_sym_next] = ACTIONS(9665),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9667),
    [anon_sym_defined_QMARK] = ACTIONS(9669),
    [anon_sym_not] = ACTIONS(9671),
    [anon_sym_BANG] = ACTIONS(9673),
    [anon_sym_TILDE] = ACTIONS(9673),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6243] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(586),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(6247),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(6247),
    [sym_assignment] = STATE(586),
    [sym_operator_assignment] = STATE(586),
    [sym_conditional] = STATE(586),
    [sym_range] = STATE(586),
    [sym_binary] = STATE(586),
    [sym_unary] = STATE(586),
    [sym_left_assignment_list] = STATE(6246),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6247),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(6247),
    [sym_false] = STATE(6247),
    [sym_nil] = STATE(6247),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(6248),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(9657),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9659),
    [anon_sym_yield] = ACTIONS(9661),
    [anon_sym_break] = ACTIONS(9663),
    [anon_sym_next] = ACTIONS(9665),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9667),
    [anon_sym_defined_QMARK] = ACTIONS(9669),
    [anon_sym_not] = ACTIONS(9671),
    [anon_sym_BANG] = ACTIONS(9673),
    [anon_sym_TILDE] = ACTIONS(9673),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6244] = {
    [sym__binary_minus] = ACTIONS(12160),
    [sym__binary_star] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(12164),
    [anon_sym_STAR_STAR] = ACTIONS(12162),
    [anon_sym_AMP] = ACTIONS(12166),
    [anon_sym_LT] = ACTIONS(12168),
    [anon_sym_QMARK] = ACTIONS(12170),
    [anon_sym_COLON2] = ACTIONS(5115),
    [anon_sym_DOT_DOT] = ACTIONS(12172),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12174),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(12176),
    [anon_sym_AMP_AMP] = ACTIONS(12176),
    [anon_sym_LT_LT] = ACTIONS(12178),
    [anon_sym_GT_GT] = ACTIONS(12178),
    [anon_sym_EQ_EQ] = ACTIONS(12180),
    [anon_sym_BANG_EQ] = ACTIONS(12176),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12176),
    [anon_sym_LT_EQ_GT] = ACTIONS(12176),
    [anon_sym_EQ_TILDE] = ACTIONS(12176),
    [anon_sym_BANG_TILDE] = ACTIONS(12176),
    [anon_sym_LT_EQ] = ACTIONS(12168),
    [anon_sym_GT] = ACTIONS(12168),
    [anon_sym_GT_EQ] = ACTIONS(12182),
    [anon_sym_CARET] = ACTIONS(12184),
    [anon_sym_PLUS] = ACTIONS(12160),
    [anon_sym_SLASH] = ACTIONS(12162),
    [anon_sym_PERCENT] = ACTIONS(12162),
    [sym_comment] = ACTIONS(87),
  },
  [6245] = {
    [aux_sym_exceptions_repeat1] = STATE(8582),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_COMMA] = ACTIONS(12186),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_COLON2] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [6246] = {
    [anon_sym_EQ] = ACTIONS(12188),
    [sym_comment] = ACTIONS(87),
  },
  [6247] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(12190),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(12192),
    [anon_sym_DASH_EQ] = ACTIONS(12192),
    [anon_sym_STAR_EQ] = ACTIONS(12192),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12192),
    [anon_sym_SLASH_EQ] = ACTIONS(12192),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12192),
    [anon_sym_PIPE_EQ] = ACTIONS(12192),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12192),
    [anon_sym_AMP_EQ] = ACTIONS(12192),
    [anon_sym_PERCENT_EQ] = ACTIONS(12192),
    [anon_sym_GT_GT_EQ] = ACTIONS(12192),
    [anon_sym_LT_LT_EQ] = ACTIONS(12192),
    [anon_sym_CARET_EQ] = ACTIONS(12192),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [6248] = {
    [sym_string] = STATE(8585),
    [aux_sym_chained_string_repeat1] = STATE(8585),
    [sym__string_start] = ACTIONS(2495),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [6249] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(6210),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [6250] = {
    [sym_string] = STATE(6250),
    [aux_sym_chained_string_repeat1] = STATE(6250),
    [sym__string_start] = ACTIONS(12194),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_COLON2] = ACTIONS(6217),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [6251] = {
    [sym__heredoc_body_start] = ACTIONS(6813),
    [anon_sym_PIPE] = ACTIONS(6813),
    [anon_sym_STAR] = ACTIONS(8689),
    [anon_sym_STAR_STAR] = ACTIONS(6813),
    [anon_sym_AMP] = ACTIONS(6813),
    [anon_sym_LT] = ACTIONS(8689),
    [anon_sym_LPAREN2] = ACTIONS(6813),
    [anon_sym_DOT_DOT] = ACTIONS(6813),
    [anon_sym_LT_LT] = ACTIONS(6813),
    [anon_sym_GT_GT] = ACTIONS(6813),
    [anon_sym_EQ_EQ] = ACTIONS(8689),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6813),
    [anon_sym_LT_EQ_GT] = ACTIONS(6813),
    [anon_sym_EQ_TILDE] = ACTIONS(6813),
    [anon_sym_BANG_TILDE] = ACTIONS(6813),
    [anon_sym_LT_EQ] = ACTIONS(8689),
    [anon_sym_GT] = ACTIONS(8689),
    [anon_sym_GT_EQ] = ACTIONS(6813),
    [anon_sym_CARET] = ACTIONS(6813),
    [anon_sym_PLUS] = ACTIONS(8689),
    [anon_sym_SLASH] = ACTIONS(6813),
    [anon_sym_PERCENT] = ACTIONS(6813),
    [anon_sym_BANG] = ACTIONS(8689),
    [anon_sym_TILDE] = ACTIONS(6813),
    [sym_constant] = ACTIONS(6813),
    [sym_identifier] = ACTIONS(6813),
    [anon_sym_DASH] = ACTIONS(8689),
    [anon_sym_PLUS_AT] = ACTIONS(6813),
    [anon_sym_DASH_AT] = ACTIONS(6813),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(8689),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(6813),
    [anon_sym_BQUOTE] = ACTIONS(6813),
    [sym_comment] = ACTIONS(87),
  },
  [6252] = {
    [sym__line_break] = ACTIONS(7876),
    [sym__simple_symbol] = ACTIONS(7876),
    [sym__string_start] = ACTIONS(7876),
    [sym__symbol_start] = ACTIONS(7876),
    [sym__subshell_start] = ACTIONS(7876),
    [sym__regex_start] = ACTIONS(7876),
    [sym__string_array_start] = ACTIONS(7876),
    [sym__symbol_array_start] = ACTIONS(7876),
    [sym__heredoc_body_start] = ACTIONS(7876),
    [sym_heredoc_beginning] = ACTIONS(7876),
    [sym__block_ampersand] = ACTIONS(7876),
    [sym__splat_star] = ACTIONS(7876),
    [sym__unary_minus] = ACTIONS(7876),
    [sym__binary_minus] = ACTIONS(7876),
    [sym__binary_star] = ACTIONS(7876),
    [sym__identifier_hash_key] = ACTIONS(7876),
    [ts_builtin_sym_end] = ACTIONS(7876),
    [anon_sym___END__] = ACTIONS(7878),
    [anon_sym_LBRACE] = ACTIONS(7876),
    [anon_sym_RBRACE] = ACTIONS(7876),
    [anon_sym_def] = ACTIONS(7878),
    [anon_sym_LPAREN] = ACTIONS(7878),
    [anon_sym_RPAREN] = ACTIONS(7876),
    [anon_sym_DOT] = ACTIONS(7878),
    [anon_sym_COLON_COLON] = ACTIONS(7878),
    [anon_sym_COMMA] = ACTIONS(7876),
    [anon_sym_PIPE] = ACTIONS(7878),
    [anon_sym_SEMI] = ACTIONS(7876),
    [anon_sym_STAR] = ACTIONS(7878),
    [anon_sym_STAR_STAR] = ACTIONS(7878),
    [anon_sym_AMP] = ACTIONS(7878),
    [anon_sym_EQ] = ACTIONS(7878),
    [anon_sym_class] = ACTIONS(7878),
    [anon_sym_LT] = ACTIONS(7878),
    [anon_sym_module] = ACTIONS(7878),
    [anon_sym_end] = ACTIONS(7878),
    [anon_sym_return] = ACTIONS(7878),
    [anon_sym_yield] = ACTIONS(7878),
    [anon_sym_break] = ACTIONS(7878),
    [anon_sym_next] = ACTIONS(7878),
    [sym_redo] = ACTIONS(7878),
    [sym_retry] = ACTIONS(7878),
    [anon_sym_if] = ACTIONS(7878),
    [anon_sym_unless] = ACTIONS(7878),
    [anon_sym_while] = ACTIONS(7878),
    [anon_sym_until] = ACTIONS(7878),
    [anon_sym_rescue] = ACTIONS(7878),
    [anon_sym_for] = ACTIONS(7878),
    [anon_sym_do] = ACTIONS(7878),
    [anon_sym_case] = ACTIONS(7878),
    [anon_sym_when] = ACTIONS(7878),
    [anon_sym_elsif] = ACTIONS(7878),
    [anon_sym_else] = ACTIONS(7878),
    [anon_sym_then] = ACTIONS(7878),
    [anon_sym_begin] = ACTIONS(7878),
    [anon_sym_ensure] = ACTIONS(7878),
    [anon_sym_LBRACK] = ACTIONS(7876),
    [anon_sym_COLON_COLON2] = ACTIONS(7876),
    [anon_sym_AMP_DOT] = ACTIONS(7876),
    [anon_sym_LPAREN2] = ACTIONS(7876),
    [anon_sym_PLUS_EQ] = ACTIONS(7876),
    [anon_sym_DASH_EQ] = ACTIONS(7876),
    [anon_sym_STAR_EQ] = ACTIONS(7876),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7876),
    [anon_sym_SLASH_EQ] = ACTIONS(7876),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7876),
    [anon_sym_PIPE_EQ] = ACTIONS(7876),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7876),
    [anon_sym_AMP_EQ] = ACTIONS(7876),
    [anon_sym_PERCENT_EQ] = ACTIONS(7876),
    [anon_sym_GT_GT_EQ] = ACTIONS(7876),
    [anon_sym_LT_LT_EQ] = ACTIONS(7876),
    [anon_sym_CARET_EQ] = ACTIONS(7876),
    [anon_sym_QMARK] = ACTIONS(7878),
    [anon_sym_DOT_DOT] = ACTIONS(7878),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7876),
    [anon_sym_and] = ACTIONS(7878),
    [anon_sym_or] = ACTIONS(7878),
    [anon_sym_PIPE_PIPE] = ACTIONS(7878),
    [anon_sym_AMP_AMP] = ACTIONS(7878),
    [anon_sym_LT_LT] = ACTIONS(7878),
    [anon_sym_GT_GT] = ACTIONS(7878),
    [anon_sym_EQ_EQ] = ACTIONS(7878),
    [anon_sym_BANG_EQ] = ACTIONS(7876),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7876),
    [anon_sym_LT_EQ_GT] = ACTIONS(7876),
    [anon_sym_EQ_TILDE] = ACTIONS(7876),
    [anon_sym_BANG_TILDE] = ACTIONS(7876),
    [anon_sym_LT_EQ] = ACTIONS(7878),
    [anon_sym_GT] = ACTIONS(7878),
    [anon_sym_GT_EQ] = ACTIONS(7876),
    [anon_sym_CARET] = ACTIONS(7878),
    [anon_sym_PLUS] = ACTIONS(7878),
    [anon_sym_SLASH] = ACTIONS(7878),
    [anon_sym_PERCENT] = ACTIONS(7878),
    [anon_sym_defined_QMARK] = ACTIONS(7876),
    [anon_sym_not] = ACTIONS(7878),
    [anon_sym_BANG] = ACTIONS(7878),
    [anon_sym_TILDE] = ACTIONS(7876),
    [sym_constant] = ACTIONS(7878),
    [sym_identifier] = ACTIONS(7878),
    [sym_instance_variable] = ACTIONS(7876),
    [sym_class_variable] = ACTIONS(7876),
    [sym_global_variable] = ACTIONS(7876),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(7878),
    [sym_float] = ACTIONS(7878),
    [sym_complex] = ACTIONS(7876),
    [sym_super] = ACTIONS(7878),
    [anon_sym_true] = ACTIONS(7878),
    [anon_sym_TRUE] = ACTIONS(7878),
    [anon_sym_false] = ACTIONS(7878),
    [anon_sym_FALSE] = ACTIONS(7878),
    [sym_self] = ACTIONS(7878),
    [anon_sym_nil] = ACTIONS(7878),
    [anon_sym_NIL] = ACTIONS(7878),
    [sym_character] = ACTIONS(7876),
    [anon_sym_LBRACK2] = ACTIONS(7878),
    [anon_sym_DASH_GT] = ACTIONS(7876),
  },
  [6253] = {
    [sym__line_break] = ACTIONS(6601),
    [sym__heredoc_body_start] = ACTIONS(6601),
    [sym__binary_minus] = ACTIONS(6601),
    [sym__binary_star] = ACTIONS(6601),
    [ts_builtin_sym_end] = ACTIONS(6601),
    [anon_sym___END__] = ACTIONS(6601),
    [anon_sym_LBRACE] = ACTIONS(6601),
    [anon_sym_RBRACE] = ACTIONS(6601),
    [anon_sym_RPAREN] = ACTIONS(6601),
    [anon_sym_DOT] = ACTIONS(6603),
    [anon_sym_COMMA] = ACTIONS(6601),
    [anon_sym_PIPE] = ACTIONS(6603),
    [anon_sym_SEMI] = ACTIONS(6601),
    [anon_sym_STAR_STAR] = ACTIONS(6603),
    [anon_sym_AMP] = ACTIONS(6603),
    [anon_sym_EQ] = ACTIONS(6603),
    [anon_sym_LT] = ACTIONS(6603),
    [anon_sym_end] = ACTIONS(6601),
    [anon_sym_if] = ACTIONS(6601),
    [anon_sym_unless] = ACTIONS(6601),
    [anon_sym_while] = ACTIONS(6601),
    [anon_sym_until] = ACTIONS(6601),
    [anon_sym_rescue] = ACTIONS(6601),
    [anon_sym_do] = ACTIONS(6601),
    [anon_sym_when] = ACTIONS(6601),
    [anon_sym_elsif] = ACTIONS(6601),
    [anon_sym_else] = ACTIONS(6601),
    [anon_sym_then] = ACTIONS(6601),
    [anon_sym_ensure] = ACTIONS(6601),
    [anon_sym_EQ_GT] = ACTIONS(6601),
    [anon_sym_LBRACK] = ACTIONS(6601),
    [anon_sym_COLON_COLON2] = ACTIONS(6601),
    [anon_sym_AMP_DOT] = ACTIONS(6601),
    [anon_sym_PLUS_EQ] = ACTIONS(6601),
    [anon_sym_DASH_EQ] = ACTIONS(6601),
    [anon_sym_STAR_EQ] = ACTIONS(6601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6601),
    [anon_sym_SLASH_EQ] = ACTIONS(6601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6601),
    [anon_sym_PIPE_EQ] = ACTIONS(6601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6601),
    [anon_sym_AMP_EQ] = ACTIONS(6601),
    [anon_sym_PERCENT_EQ] = ACTIONS(6601),
    [anon_sym_GT_GT_EQ] = ACTIONS(6601),
    [anon_sym_LT_LT_EQ] = ACTIONS(6601),
    [anon_sym_CARET_EQ] = ACTIONS(6601),
    [anon_sym_QMARK] = ACTIONS(6601),
    [anon_sym_DOT_DOT] = ACTIONS(6603),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6601),
    [anon_sym_and] = ACTIONS(6601),
    [anon_sym_or] = ACTIONS(6601),
    [anon_sym_PIPE_PIPE] = ACTIONS(6603),
    [anon_sym_AMP_AMP] = ACTIONS(6603),
    [anon_sym_LT_LT] = ACTIONS(6603),
    [anon_sym_GT_GT] = ACTIONS(6603),
    [anon_sym_EQ_EQ] = ACTIONS(6603),
    [anon_sym_BANG_EQ] = ACTIONS(6601),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6601),
    [anon_sym_LT_EQ_GT] = ACTIONS(6601),
    [anon_sym_EQ_TILDE] = ACTIONS(6601),
    [anon_sym_BANG_TILDE] = ACTIONS(6601),
    [anon_sym_LT_EQ] = ACTIONS(6603),
    [anon_sym_GT] = ACTIONS(6603),
    [anon_sym_GT_EQ] = ACTIONS(6601),
    [anon_sym_CARET] = ACTIONS(6603),
    [anon_sym_PLUS] = ACTIONS(6603),
    [anon_sym_SLASH] = ACTIONS(6603),
    [anon_sym_PERCENT] = ACTIONS(6603),
    [sym_comment] = ACTIONS(87),
  },
  [6254] = {
    [sym__line_break] = ACTIONS(6605),
    [sym__heredoc_body_start] = ACTIONS(6605),
    [sym__binary_minus] = ACTIONS(6605),
    [sym__binary_star] = ACTIONS(6605),
    [ts_builtin_sym_end] = ACTIONS(6605),
    [anon_sym___END__] = ACTIONS(6605),
    [anon_sym_LBRACE] = ACTIONS(6605),
    [anon_sym_RBRACE] = ACTIONS(6605),
    [anon_sym_RPAREN] = ACTIONS(6605),
    [anon_sym_DOT] = ACTIONS(6607),
    [anon_sym_COMMA] = ACTIONS(6605),
    [anon_sym_PIPE] = ACTIONS(6607),
    [anon_sym_SEMI] = ACTIONS(6605),
    [anon_sym_STAR_STAR] = ACTIONS(6607),
    [anon_sym_AMP] = ACTIONS(6607),
    [anon_sym_EQ] = ACTIONS(6607),
    [anon_sym_LT] = ACTIONS(6607),
    [anon_sym_end] = ACTIONS(6605),
    [anon_sym_if] = ACTIONS(6605),
    [anon_sym_unless] = ACTIONS(6605),
    [anon_sym_while] = ACTIONS(6605),
    [anon_sym_until] = ACTIONS(6605),
    [anon_sym_rescue] = ACTIONS(6605),
    [anon_sym_do] = ACTIONS(6605),
    [anon_sym_when] = ACTIONS(6605),
    [anon_sym_elsif] = ACTIONS(6605),
    [anon_sym_else] = ACTIONS(6605),
    [anon_sym_then] = ACTIONS(6605),
    [anon_sym_ensure] = ACTIONS(6605),
    [anon_sym_EQ_GT] = ACTIONS(6605),
    [anon_sym_LBRACK] = ACTIONS(6605),
    [anon_sym_COLON_COLON2] = ACTIONS(6605),
    [anon_sym_AMP_DOT] = ACTIONS(6605),
    [anon_sym_PLUS_EQ] = ACTIONS(6605),
    [anon_sym_DASH_EQ] = ACTIONS(6605),
    [anon_sym_STAR_EQ] = ACTIONS(6605),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6605),
    [anon_sym_SLASH_EQ] = ACTIONS(6605),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6605),
    [anon_sym_PIPE_EQ] = ACTIONS(6605),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6605),
    [anon_sym_AMP_EQ] = ACTIONS(6605),
    [anon_sym_PERCENT_EQ] = ACTIONS(6605),
    [anon_sym_GT_GT_EQ] = ACTIONS(6605),
    [anon_sym_LT_LT_EQ] = ACTIONS(6605),
    [anon_sym_CARET_EQ] = ACTIONS(6605),
    [anon_sym_QMARK] = ACTIONS(6605),
    [anon_sym_DOT_DOT] = ACTIONS(6607),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6605),
    [anon_sym_and] = ACTIONS(6605),
    [anon_sym_or] = ACTIONS(6605),
    [anon_sym_PIPE_PIPE] = ACTIONS(6607),
    [anon_sym_AMP_AMP] = ACTIONS(6607),
    [anon_sym_LT_LT] = ACTIONS(6607),
    [anon_sym_GT_GT] = ACTIONS(6607),
    [anon_sym_EQ_EQ] = ACTIONS(6607),
    [anon_sym_BANG_EQ] = ACTIONS(6605),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6605),
    [anon_sym_LT_EQ_GT] = ACTIONS(6605),
    [anon_sym_EQ_TILDE] = ACTIONS(6605),
    [anon_sym_BANG_TILDE] = ACTIONS(6605),
    [anon_sym_LT_EQ] = ACTIONS(6607),
    [anon_sym_GT] = ACTIONS(6607),
    [anon_sym_GT_EQ] = ACTIONS(6605),
    [anon_sym_CARET] = ACTIONS(6607),
    [anon_sym_PLUS] = ACTIONS(6607),
    [anon_sym_SLASH] = ACTIONS(6607),
    [anon_sym_PERCENT] = ACTIONS(6607),
    [sym_comment] = ACTIONS(87),
  },
  [6255] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1697),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(12197),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [6256] = {
    [aux_sym_string_array_repeat1] = STATE(1699),
    [sym__string_end] = ACTIONS(12197),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(12199),
  },
  [6257] = {
    [sym__line_break] = ACTIONS(6613),
    [sym__heredoc_body_start] = ACTIONS(6613),
    [sym__binary_minus] = ACTIONS(6613),
    [sym__binary_star] = ACTIONS(6613),
    [ts_builtin_sym_end] = ACTIONS(6613),
    [anon_sym___END__] = ACTIONS(6613),
    [anon_sym_LBRACE] = ACTIONS(6613),
    [anon_sym_RBRACE] = ACTIONS(6613),
    [anon_sym_RPAREN] = ACTIONS(6613),
    [anon_sym_DOT] = ACTIONS(6615),
    [anon_sym_COMMA] = ACTIONS(6613),
    [anon_sym_PIPE] = ACTIONS(6615),
    [anon_sym_SEMI] = ACTIONS(6613),
    [anon_sym_STAR_STAR] = ACTIONS(6615),
    [anon_sym_AMP] = ACTIONS(6615),
    [anon_sym_EQ] = ACTIONS(6615),
    [anon_sym_LT] = ACTIONS(6615),
    [anon_sym_end] = ACTIONS(6613),
    [anon_sym_if] = ACTIONS(6613),
    [anon_sym_unless] = ACTIONS(6613),
    [anon_sym_while] = ACTIONS(6613),
    [anon_sym_until] = ACTIONS(6613),
    [anon_sym_rescue] = ACTIONS(6613),
    [anon_sym_do] = ACTIONS(6613),
    [anon_sym_when] = ACTIONS(6613),
    [anon_sym_elsif] = ACTIONS(6613),
    [anon_sym_else] = ACTIONS(6613),
    [anon_sym_then] = ACTIONS(6613),
    [anon_sym_ensure] = ACTIONS(6613),
    [anon_sym_EQ_GT] = ACTIONS(6613),
    [anon_sym_LBRACK] = ACTIONS(6613),
    [anon_sym_COLON_COLON2] = ACTIONS(6613),
    [anon_sym_AMP_DOT] = ACTIONS(6613),
    [anon_sym_PLUS_EQ] = ACTIONS(6613),
    [anon_sym_DASH_EQ] = ACTIONS(6613),
    [anon_sym_STAR_EQ] = ACTIONS(6613),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6613),
    [anon_sym_SLASH_EQ] = ACTIONS(6613),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6613),
    [anon_sym_PIPE_EQ] = ACTIONS(6613),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6613),
    [anon_sym_AMP_EQ] = ACTIONS(6613),
    [anon_sym_PERCENT_EQ] = ACTIONS(6613),
    [anon_sym_GT_GT_EQ] = ACTIONS(6613),
    [anon_sym_LT_LT_EQ] = ACTIONS(6613),
    [anon_sym_CARET_EQ] = ACTIONS(6613),
    [anon_sym_QMARK] = ACTIONS(6613),
    [anon_sym_DOT_DOT] = ACTIONS(6615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6613),
    [anon_sym_and] = ACTIONS(6613),
    [anon_sym_or] = ACTIONS(6613),
    [anon_sym_PIPE_PIPE] = ACTIONS(6615),
    [anon_sym_AMP_AMP] = ACTIONS(6615),
    [anon_sym_LT_LT] = ACTIONS(6615),
    [anon_sym_GT_GT] = ACTIONS(6615),
    [anon_sym_EQ_EQ] = ACTIONS(6615),
    [anon_sym_BANG_EQ] = ACTIONS(6613),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6613),
    [anon_sym_LT_EQ_GT] = ACTIONS(6613),
    [anon_sym_EQ_TILDE] = ACTIONS(6613),
    [anon_sym_BANG_TILDE] = ACTIONS(6613),
    [anon_sym_LT_EQ] = ACTIONS(6615),
    [anon_sym_GT] = ACTIONS(6615),
    [anon_sym_GT_EQ] = ACTIONS(6613),
    [anon_sym_CARET] = ACTIONS(6615),
    [anon_sym_PLUS] = ACTIONS(6615),
    [anon_sym_SLASH] = ACTIONS(6615),
    [anon_sym_PERCENT] = ACTIONS(6615),
    [sym_comment] = ACTIONS(87),
  },
  [6258] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1697),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(12201),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [6259] = {
    [sym__line_break] = ACTIONS(6626),
    [sym__heredoc_body_start] = ACTIONS(6626),
    [sym__binary_minus] = ACTIONS(6626),
    [sym__binary_star] = ACTIONS(6626),
    [ts_builtin_sym_end] = ACTIONS(6626),
    [anon_sym___END__] = ACTIONS(6626),
    [anon_sym_LBRACE] = ACTIONS(6626),
    [anon_sym_RBRACE] = ACTIONS(6626),
    [anon_sym_RPAREN] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(6628),
    [anon_sym_COMMA] = ACTIONS(6626),
    [anon_sym_PIPE] = ACTIONS(6628),
    [anon_sym_SEMI] = ACTIONS(6626),
    [anon_sym_STAR_STAR] = ACTIONS(6628),
    [anon_sym_AMP] = ACTIONS(6628),
    [anon_sym_EQ] = ACTIONS(6628),
    [anon_sym_LT] = ACTIONS(6628),
    [anon_sym_end] = ACTIONS(6626),
    [anon_sym_if] = ACTIONS(6626),
    [anon_sym_unless] = ACTIONS(6626),
    [anon_sym_while] = ACTIONS(6626),
    [anon_sym_until] = ACTIONS(6626),
    [anon_sym_rescue] = ACTIONS(6626),
    [anon_sym_do] = ACTIONS(6626),
    [anon_sym_when] = ACTIONS(6626),
    [anon_sym_elsif] = ACTIONS(6626),
    [anon_sym_else] = ACTIONS(6626),
    [anon_sym_then] = ACTIONS(6626),
    [anon_sym_ensure] = ACTIONS(6626),
    [anon_sym_EQ_GT] = ACTIONS(6626),
    [anon_sym_LBRACK] = ACTIONS(6626),
    [anon_sym_COLON_COLON2] = ACTIONS(6626),
    [anon_sym_AMP_DOT] = ACTIONS(6626),
    [anon_sym_PLUS_EQ] = ACTIONS(6626),
    [anon_sym_DASH_EQ] = ACTIONS(6626),
    [anon_sym_STAR_EQ] = ACTIONS(6626),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6626),
    [anon_sym_SLASH_EQ] = ACTIONS(6626),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6626),
    [anon_sym_PIPE_EQ] = ACTIONS(6626),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6626),
    [anon_sym_AMP_EQ] = ACTIONS(6626),
    [anon_sym_PERCENT_EQ] = ACTIONS(6626),
    [anon_sym_GT_GT_EQ] = ACTIONS(6626),
    [anon_sym_LT_LT_EQ] = ACTIONS(6626),
    [anon_sym_CARET_EQ] = ACTIONS(6626),
    [anon_sym_QMARK] = ACTIONS(6626),
    [anon_sym_DOT_DOT] = ACTIONS(6628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6626),
    [anon_sym_and] = ACTIONS(6626),
    [anon_sym_or] = ACTIONS(6626),
    [anon_sym_PIPE_PIPE] = ACTIONS(6628),
    [anon_sym_AMP_AMP] = ACTIONS(6628),
    [anon_sym_LT_LT] = ACTIONS(6628),
    [anon_sym_GT_GT] = ACTIONS(6628),
    [anon_sym_EQ_EQ] = ACTIONS(6628),
    [anon_sym_BANG_EQ] = ACTIONS(6626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6626),
    [anon_sym_LT_EQ_GT] = ACTIONS(6626),
    [anon_sym_EQ_TILDE] = ACTIONS(6626),
    [anon_sym_BANG_TILDE] = ACTIONS(6626),
    [anon_sym_LT_EQ] = ACTIONS(6628),
    [anon_sym_GT] = ACTIONS(6628),
    [anon_sym_GT_EQ] = ACTIONS(6626),
    [anon_sym_CARET] = ACTIONS(6628),
    [anon_sym_PLUS] = ACTIONS(6628),
    [anon_sym_SLASH] = ACTIONS(6628),
    [anon_sym_PERCENT] = ACTIONS(6628),
    [sym_comment] = ACTIONS(87),
  },
  [6260] = {
    [sym__line_break] = ACTIONS(6630),
    [sym__heredoc_body_start] = ACTIONS(6630),
    [sym__binary_minus] = ACTIONS(6630),
    [sym__binary_star] = ACTIONS(6630),
    [ts_builtin_sym_end] = ACTIONS(6630),
    [anon_sym___END__] = ACTIONS(6630),
    [anon_sym_LBRACE] = ACTIONS(6630),
    [anon_sym_RBRACE] = ACTIONS(6630),
    [anon_sym_RPAREN] = ACTIONS(6630),
    [anon_sym_DOT] = ACTIONS(6632),
    [anon_sym_COMMA] = ACTIONS(6630),
    [anon_sym_PIPE] = ACTIONS(6632),
    [anon_sym_SEMI] = ACTIONS(6630),
    [anon_sym_STAR_STAR] = ACTIONS(6632),
    [anon_sym_AMP] = ACTIONS(6632),
    [anon_sym_EQ] = ACTIONS(6632),
    [anon_sym_LT] = ACTIONS(6632),
    [anon_sym_end] = ACTIONS(6630),
    [anon_sym_if] = ACTIONS(6630),
    [anon_sym_unless] = ACTIONS(6630),
    [anon_sym_while] = ACTIONS(6630),
    [anon_sym_until] = ACTIONS(6630),
    [anon_sym_rescue] = ACTIONS(6630),
    [anon_sym_do] = ACTIONS(6630),
    [anon_sym_when] = ACTIONS(6630),
    [anon_sym_elsif] = ACTIONS(6630),
    [anon_sym_else] = ACTIONS(6630),
    [anon_sym_then] = ACTIONS(6630),
    [anon_sym_ensure] = ACTIONS(6630),
    [anon_sym_EQ_GT] = ACTIONS(6630),
    [anon_sym_LBRACK] = ACTIONS(6630),
    [anon_sym_COLON_COLON2] = ACTIONS(6630),
    [anon_sym_AMP_DOT] = ACTIONS(6630),
    [anon_sym_PLUS_EQ] = ACTIONS(6630),
    [anon_sym_DASH_EQ] = ACTIONS(6630),
    [anon_sym_STAR_EQ] = ACTIONS(6630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6630),
    [anon_sym_SLASH_EQ] = ACTIONS(6630),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6630),
    [anon_sym_PIPE_EQ] = ACTIONS(6630),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6630),
    [anon_sym_AMP_EQ] = ACTIONS(6630),
    [anon_sym_PERCENT_EQ] = ACTIONS(6630),
    [anon_sym_GT_GT_EQ] = ACTIONS(6630),
    [anon_sym_LT_LT_EQ] = ACTIONS(6630),
    [anon_sym_CARET_EQ] = ACTIONS(6630),
    [anon_sym_QMARK] = ACTIONS(6630),
    [anon_sym_DOT_DOT] = ACTIONS(6632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6630),
    [anon_sym_and] = ACTIONS(6630),
    [anon_sym_or] = ACTIONS(6630),
    [anon_sym_PIPE_PIPE] = ACTIONS(6632),
    [anon_sym_AMP_AMP] = ACTIONS(6632),
    [anon_sym_LT_LT] = ACTIONS(6632),
    [anon_sym_GT_GT] = ACTIONS(6632),
    [anon_sym_EQ_EQ] = ACTIONS(6632),
    [anon_sym_BANG_EQ] = ACTIONS(6630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6630),
    [anon_sym_LT_EQ_GT] = ACTIONS(6630),
    [anon_sym_EQ_TILDE] = ACTIONS(6630),
    [anon_sym_BANG_TILDE] = ACTIONS(6630),
    [anon_sym_LT_EQ] = ACTIONS(6632),
    [anon_sym_GT] = ACTIONS(6632),
    [anon_sym_GT_EQ] = ACTIONS(6630),
    [anon_sym_CARET] = ACTIONS(6632),
    [anon_sym_PLUS] = ACTIONS(6632),
    [anon_sym_SLASH] = ACTIONS(6632),
    [anon_sym_PERCENT] = ACTIONS(6632),
    [sym_comment] = ACTIONS(87),
  },
  [6261] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1705),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(12203),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [6262] = {
    [aux_sym_symbol_array_repeat1] = STATE(1707),
    [sym__string_end] = ACTIONS(12203),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(12205),
  },
  [6263] = {
    [sym__line_break] = ACTIONS(6638),
    [sym__heredoc_body_start] = ACTIONS(6638),
    [sym__binary_minus] = ACTIONS(6638),
    [sym__binary_star] = ACTIONS(6638),
    [ts_builtin_sym_end] = ACTIONS(6638),
    [anon_sym___END__] = ACTIONS(6638),
    [anon_sym_LBRACE] = ACTIONS(6638),
    [anon_sym_RBRACE] = ACTIONS(6638),
    [anon_sym_RPAREN] = ACTIONS(6638),
    [anon_sym_DOT] = ACTIONS(6640),
    [anon_sym_COMMA] = ACTIONS(6638),
    [anon_sym_PIPE] = ACTIONS(6640),
    [anon_sym_SEMI] = ACTIONS(6638),
    [anon_sym_STAR_STAR] = ACTIONS(6640),
    [anon_sym_AMP] = ACTIONS(6640),
    [anon_sym_EQ] = ACTIONS(6640),
    [anon_sym_LT] = ACTIONS(6640),
    [anon_sym_end] = ACTIONS(6638),
    [anon_sym_if] = ACTIONS(6638),
    [anon_sym_unless] = ACTIONS(6638),
    [anon_sym_while] = ACTIONS(6638),
    [anon_sym_until] = ACTIONS(6638),
    [anon_sym_rescue] = ACTIONS(6638),
    [anon_sym_do] = ACTIONS(6638),
    [anon_sym_when] = ACTIONS(6638),
    [anon_sym_elsif] = ACTIONS(6638),
    [anon_sym_else] = ACTIONS(6638),
    [anon_sym_then] = ACTIONS(6638),
    [anon_sym_ensure] = ACTIONS(6638),
    [anon_sym_EQ_GT] = ACTIONS(6638),
    [anon_sym_LBRACK] = ACTIONS(6638),
    [anon_sym_COLON_COLON2] = ACTIONS(6638),
    [anon_sym_AMP_DOT] = ACTIONS(6638),
    [anon_sym_PLUS_EQ] = ACTIONS(6638),
    [anon_sym_DASH_EQ] = ACTIONS(6638),
    [anon_sym_STAR_EQ] = ACTIONS(6638),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6638),
    [anon_sym_SLASH_EQ] = ACTIONS(6638),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6638),
    [anon_sym_PIPE_EQ] = ACTIONS(6638),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6638),
    [anon_sym_AMP_EQ] = ACTIONS(6638),
    [anon_sym_PERCENT_EQ] = ACTIONS(6638),
    [anon_sym_GT_GT_EQ] = ACTIONS(6638),
    [anon_sym_LT_LT_EQ] = ACTIONS(6638),
    [anon_sym_CARET_EQ] = ACTIONS(6638),
    [anon_sym_QMARK] = ACTIONS(6638),
    [anon_sym_DOT_DOT] = ACTIONS(6640),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6638),
    [anon_sym_and] = ACTIONS(6638),
    [anon_sym_or] = ACTIONS(6638),
    [anon_sym_PIPE_PIPE] = ACTIONS(6640),
    [anon_sym_AMP_AMP] = ACTIONS(6640),
    [anon_sym_LT_LT] = ACTIONS(6640),
    [anon_sym_GT_GT] = ACTIONS(6640),
    [anon_sym_EQ_EQ] = ACTIONS(6640),
    [anon_sym_BANG_EQ] = ACTIONS(6638),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6638),
    [anon_sym_LT_EQ_GT] = ACTIONS(6638),
    [anon_sym_EQ_TILDE] = ACTIONS(6638),
    [anon_sym_BANG_TILDE] = ACTIONS(6638),
    [anon_sym_LT_EQ] = ACTIONS(6640),
    [anon_sym_GT] = ACTIONS(6640),
    [anon_sym_GT_EQ] = ACTIONS(6638),
    [anon_sym_CARET] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(6640),
    [anon_sym_SLASH] = ACTIONS(6640),
    [anon_sym_PERCENT] = ACTIONS(6640),
    [sym_comment] = ACTIONS(87),
  },
  [6264] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1705),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(12207),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [6265] = {
    [sym__line_break] = ACTIONS(3030),
    [sym__string_start] = ACTIONS(3030),
    [sym__heredoc_body_start] = ACTIONS(3030),
    [sym__binary_minus] = ACTIONS(3030),
    [sym__binary_star] = ACTIONS(3030),
    [ts_builtin_sym_end] = ACTIONS(3030),
    [anon_sym___END__] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3030),
    [anon_sym_RBRACE] = ACTIONS(3030),
    [anon_sym_RPAREN] = ACTIONS(3030),
    [anon_sym_DOT] = ACTIONS(3032),
    [anon_sym_COMMA] = ACTIONS(3030),
    [anon_sym_PIPE] = ACTIONS(3032),
    [anon_sym_SEMI] = ACTIONS(3030),
    [anon_sym_STAR_STAR] = ACTIONS(3032),
    [anon_sym_AMP] = ACTIONS(3032),
    [anon_sym_EQ] = ACTIONS(3032),
    [anon_sym_LT] = ACTIONS(3032),
    [anon_sym_end] = ACTIONS(3030),
    [anon_sym_if] = ACTIONS(3030),
    [anon_sym_unless] = ACTIONS(3030),
    [anon_sym_while] = ACTIONS(3030),
    [anon_sym_until] = ACTIONS(3030),
    [anon_sym_rescue] = ACTIONS(3030),
    [anon_sym_do] = ACTIONS(3030),
    [anon_sym_when] = ACTIONS(3030),
    [anon_sym_elsif] = ACTIONS(3030),
    [anon_sym_else] = ACTIONS(3030),
    [anon_sym_then] = ACTIONS(3030),
    [anon_sym_ensure] = ACTIONS(3030),
    [anon_sym_LBRACK] = ACTIONS(3030),
    [anon_sym_COLON_COLON2] = ACTIONS(3030),
    [anon_sym_AMP_DOT] = ACTIONS(3030),
    [anon_sym_PLUS_EQ] = ACTIONS(3030),
    [anon_sym_DASH_EQ] = ACTIONS(3030),
    [anon_sym_STAR_EQ] = ACTIONS(3030),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3030),
    [anon_sym_SLASH_EQ] = ACTIONS(3030),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3030),
    [anon_sym_PIPE_EQ] = ACTIONS(3030),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3030),
    [anon_sym_AMP_EQ] = ACTIONS(3030),
    [anon_sym_PERCENT_EQ] = ACTIONS(3030),
    [anon_sym_GT_GT_EQ] = ACTIONS(3030),
    [anon_sym_LT_LT_EQ] = ACTIONS(3030),
    [anon_sym_CARET_EQ] = ACTIONS(3030),
    [anon_sym_QMARK] = ACTIONS(3030),
    [anon_sym_DOT_DOT] = ACTIONS(3032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3030),
    [anon_sym_and] = ACTIONS(3030),
    [anon_sym_or] = ACTIONS(3030),
    [anon_sym_PIPE_PIPE] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_LT_LT] = ACTIONS(3032),
    [anon_sym_GT_GT] = ACTIONS(3032),
    [anon_sym_EQ_EQ] = ACTIONS(3032),
    [anon_sym_BANG_EQ] = ACTIONS(3030),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3030),
    [anon_sym_LT_EQ_GT] = ACTIONS(3030),
    [anon_sym_EQ_TILDE] = ACTIONS(3030),
    [anon_sym_BANG_TILDE] = ACTIONS(3030),
    [anon_sym_LT_EQ] = ACTIONS(3032),
    [anon_sym_GT] = ACTIONS(3032),
    [anon_sym_GT_EQ] = ACTIONS(3030),
    [anon_sym_CARET] = ACTIONS(3032),
    [anon_sym_PLUS] = ACTIONS(3032),
    [anon_sym_SLASH] = ACTIONS(3032),
    [anon_sym_PERCENT] = ACTIONS(3032),
    [sym_comment] = ACTIONS(87),
  },
  [6266] = {
    [sym__line_break] = ACTIONS(3042),
    [sym__heredoc_body_start] = ACTIONS(3042),
    [sym__binary_minus] = ACTIONS(3042),
    [sym__binary_star] = ACTIONS(3042),
    [ts_builtin_sym_end] = ACTIONS(3042),
    [anon_sym___END__] = ACTIONS(3042),
    [anon_sym_LBRACE] = ACTIONS(3042),
    [anon_sym_RBRACE] = ACTIONS(3042),
    [anon_sym_RPAREN] = ACTIONS(3042),
    [anon_sym_DOT] = ACTIONS(3044),
    [anon_sym_COMMA] = ACTIONS(3042),
    [anon_sym_PIPE] = ACTIONS(3044),
    [anon_sym_SEMI] = ACTIONS(3042),
    [anon_sym_STAR_STAR] = ACTIONS(3044),
    [anon_sym_AMP] = ACTIONS(3044),
    [anon_sym_EQ] = ACTIONS(3044),
    [anon_sym_LT] = ACTIONS(3044),
    [anon_sym_end] = ACTIONS(3042),
    [anon_sym_if] = ACTIONS(3042),
    [anon_sym_unless] = ACTIONS(3042),
    [anon_sym_while] = ACTIONS(3042),
    [anon_sym_until] = ACTIONS(3042),
    [anon_sym_rescue] = ACTIONS(3042),
    [anon_sym_do] = ACTIONS(3042),
    [anon_sym_when] = ACTIONS(3042),
    [anon_sym_elsif] = ACTIONS(3042),
    [anon_sym_else] = ACTIONS(3042),
    [anon_sym_then] = ACTIONS(3042),
    [anon_sym_ensure] = ACTIONS(3042),
    [anon_sym_LBRACK] = ACTIONS(3042),
    [anon_sym_COLON_COLON2] = ACTIONS(3042),
    [anon_sym_AMP_DOT] = ACTIONS(3042),
    [anon_sym_PLUS_EQ] = ACTIONS(3042),
    [anon_sym_DASH_EQ] = ACTIONS(3042),
    [anon_sym_STAR_EQ] = ACTIONS(3042),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3042),
    [anon_sym_SLASH_EQ] = ACTIONS(3042),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3042),
    [anon_sym_PIPE_EQ] = ACTIONS(3042),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3042),
    [anon_sym_AMP_EQ] = ACTIONS(3042),
    [anon_sym_PERCENT_EQ] = ACTIONS(3042),
    [anon_sym_GT_GT_EQ] = ACTIONS(3042),
    [anon_sym_LT_LT_EQ] = ACTIONS(3042),
    [anon_sym_CARET_EQ] = ACTIONS(3042),
    [anon_sym_QMARK] = ACTIONS(3042),
    [anon_sym_DOT_DOT] = ACTIONS(3044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3042),
    [anon_sym_and] = ACTIONS(3042),
    [anon_sym_or] = ACTIONS(3042),
    [anon_sym_PIPE_PIPE] = ACTIONS(3044),
    [anon_sym_AMP_AMP] = ACTIONS(3044),
    [anon_sym_LT_LT] = ACTIONS(3044),
    [anon_sym_GT_GT] = ACTIONS(3044),
    [anon_sym_EQ_EQ] = ACTIONS(3044),
    [anon_sym_BANG_EQ] = ACTIONS(3042),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3042),
    [anon_sym_LT_EQ_GT] = ACTIONS(3042),
    [anon_sym_EQ_TILDE] = ACTIONS(3042),
    [anon_sym_BANG_TILDE] = ACTIONS(3042),
    [anon_sym_LT_EQ] = ACTIONS(3044),
    [anon_sym_GT] = ACTIONS(3044),
    [anon_sym_GT_EQ] = ACTIONS(3042),
    [anon_sym_CARET] = ACTIONS(3044),
    [anon_sym_PLUS] = ACTIONS(3044),
    [anon_sym_SLASH] = ACTIONS(3044),
    [anon_sym_PERCENT] = ACTIONS(3044),
    [sym_comment] = ACTIONS(87),
  },
  [6267] = {
    [sym__line_break] = ACTIONS(3046),
    [sym__heredoc_body_start] = ACTIONS(3046),
    [sym__binary_minus] = ACTIONS(3046),
    [sym__binary_star] = ACTIONS(3046),
    [ts_builtin_sym_end] = ACTIONS(3046),
    [anon_sym___END__] = ACTIONS(3046),
    [anon_sym_LBRACE] = ACTIONS(3046),
    [anon_sym_RBRACE] = ACTIONS(3046),
    [anon_sym_RPAREN] = ACTIONS(3046),
    [anon_sym_DOT] = ACTIONS(3048),
    [anon_sym_COMMA] = ACTIONS(3046),
    [anon_sym_PIPE] = ACTIONS(3048),
    [anon_sym_SEMI] = ACTIONS(3046),
    [anon_sym_STAR_STAR] = ACTIONS(3048),
    [anon_sym_AMP] = ACTIONS(3048),
    [anon_sym_EQ] = ACTIONS(3048),
    [anon_sym_LT] = ACTIONS(3048),
    [anon_sym_end] = ACTIONS(3046),
    [anon_sym_if] = ACTIONS(3046),
    [anon_sym_unless] = ACTIONS(3046),
    [anon_sym_while] = ACTIONS(3046),
    [anon_sym_until] = ACTIONS(3046),
    [anon_sym_rescue] = ACTIONS(3046),
    [anon_sym_do] = ACTIONS(3046),
    [anon_sym_when] = ACTIONS(3046),
    [anon_sym_elsif] = ACTIONS(3046),
    [anon_sym_else] = ACTIONS(3046),
    [anon_sym_then] = ACTIONS(3046),
    [anon_sym_ensure] = ACTIONS(3046),
    [anon_sym_LBRACK] = ACTIONS(3046),
    [anon_sym_COLON_COLON2] = ACTIONS(3046),
    [anon_sym_AMP_DOT] = ACTIONS(3046),
    [anon_sym_PLUS_EQ] = ACTIONS(3046),
    [anon_sym_DASH_EQ] = ACTIONS(3046),
    [anon_sym_STAR_EQ] = ACTIONS(3046),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3046),
    [anon_sym_SLASH_EQ] = ACTIONS(3046),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3046),
    [anon_sym_PIPE_EQ] = ACTIONS(3046),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3046),
    [anon_sym_AMP_EQ] = ACTIONS(3046),
    [anon_sym_PERCENT_EQ] = ACTIONS(3046),
    [anon_sym_GT_GT_EQ] = ACTIONS(3046),
    [anon_sym_LT_LT_EQ] = ACTIONS(3046),
    [anon_sym_CARET_EQ] = ACTIONS(3046),
    [anon_sym_QMARK] = ACTIONS(3046),
    [anon_sym_DOT_DOT] = ACTIONS(3048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3046),
    [anon_sym_and] = ACTIONS(3046),
    [anon_sym_or] = ACTIONS(3046),
    [anon_sym_PIPE_PIPE] = ACTIONS(3048),
    [anon_sym_AMP_AMP] = ACTIONS(3048),
    [anon_sym_LT_LT] = ACTIONS(3048),
    [anon_sym_GT_GT] = ACTIONS(3048),
    [anon_sym_EQ_EQ] = ACTIONS(3048),
    [anon_sym_BANG_EQ] = ACTIONS(3046),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3046),
    [anon_sym_LT_EQ_GT] = ACTIONS(3046),
    [anon_sym_EQ_TILDE] = ACTIONS(3046),
    [anon_sym_BANG_TILDE] = ACTIONS(3046),
    [anon_sym_LT_EQ] = ACTIONS(3048),
    [anon_sym_GT] = ACTIONS(3048),
    [anon_sym_GT_EQ] = ACTIONS(3046),
    [anon_sym_CARET] = ACTIONS(3048),
    [anon_sym_PLUS] = ACTIONS(3048),
    [anon_sym_SLASH] = ACTIONS(3048),
    [anon_sym_PERCENT] = ACTIONS(3048),
    [sym_comment] = ACTIONS(87),
  },
  [6268] = {
    [sym__line_break] = ACTIONS(3050),
    [sym__heredoc_body_start] = ACTIONS(3050),
    [sym__binary_minus] = ACTIONS(3050),
    [sym__binary_star] = ACTIONS(3050),
    [ts_builtin_sym_end] = ACTIONS(3050),
    [anon_sym___END__] = ACTIONS(3050),
    [anon_sym_LBRACE] = ACTIONS(3050),
    [anon_sym_RBRACE] = ACTIONS(3050),
    [anon_sym_RPAREN] = ACTIONS(3050),
    [anon_sym_DOT] = ACTIONS(3052),
    [anon_sym_COMMA] = ACTIONS(3050),
    [anon_sym_PIPE] = ACTIONS(3052),
    [anon_sym_SEMI] = ACTIONS(3050),
    [anon_sym_STAR_STAR] = ACTIONS(3052),
    [anon_sym_AMP] = ACTIONS(3052),
    [anon_sym_EQ] = ACTIONS(3052),
    [anon_sym_LT] = ACTIONS(3052),
    [anon_sym_end] = ACTIONS(3050),
    [anon_sym_if] = ACTIONS(3050),
    [anon_sym_unless] = ACTIONS(3050),
    [anon_sym_while] = ACTIONS(3050),
    [anon_sym_until] = ACTIONS(3050),
    [anon_sym_rescue] = ACTIONS(3050),
    [anon_sym_do] = ACTIONS(3050),
    [anon_sym_when] = ACTIONS(3050),
    [anon_sym_elsif] = ACTIONS(3050),
    [anon_sym_else] = ACTIONS(3050),
    [anon_sym_then] = ACTIONS(3050),
    [anon_sym_ensure] = ACTIONS(3050),
    [anon_sym_LBRACK] = ACTIONS(3050),
    [anon_sym_COLON_COLON2] = ACTIONS(3050),
    [anon_sym_AMP_DOT] = ACTIONS(3050),
    [anon_sym_PLUS_EQ] = ACTIONS(3050),
    [anon_sym_DASH_EQ] = ACTIONS(3050),
    [anon_sym_STAR_EQ] = ACTIONS(3050),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3050),
    [anon_sym_SLASH_EQ] = ACTIONS(3050),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3050),
    [anon_sym_PIPE_EQ] = ACTIONS(3050),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3050),
    [anon_sym_AMP_EQ] = ACTIONS(3050),
    [anon_sym_PERCENT_EQ] = ACTIONS(3050),
    [anon_sym_GT_GT_EQ] = ACTIONS(3050),
    [anon_sym_LT_LT_EQ] = ACTIONS(3050),
    [anon_sym_CARET_EQ] = ACTIONS(3050),
    [anon_sym_QMARK] = ACTIONS(3050),
    [anon_sym_DOT_DOT] = ACTIONS(3052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3050),
    [anon_sym_and] = ACTIONS(3050),
    [anon_sym_or] = ACTIONS(3050),
    [anon_sym_PIPE_PIPE] = ACTIONS(3052),
    [anon_sym_AMP_AMP] = ACTIONS(3052),
    [anon_sym_LT_LT] = ACTIONS(3052),
    [anon_sym_GT_GT] = ACTIONS(3052),
    [anon_sym_EQ_EQ] = ACTIONS(3052),
    [anon_sym_BANG_EQ] = ACTIONS(3050),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3050),
    [anon_sym_LT_EQ_GT] = ACTIONS(3050),
    [anon_sym_EQ_TILDE] = ACTIONS(3050),
    [anon_sym_BANG_TILDE] = ACTIONS(3050),
    [anon_sym_LT_EQ] = ACTIONS(3052),
    [anon_sym_GT] = ACTIONS(3052),
    [anon_sym_GT_EQ] = ACTIONS(3050),
    [anon_sym_CARET] = ACTIONS(3052),
    [anon_sym_PLUS] = ACTIONS(3052),
    [anon_sym_SLASH] = ACTIONS(3052),
    [anon_sym_PERCENT] = ACTIONS(3052),
    [sym_comment] = ACTIONS(87),
  },
  [6269] = {
    [sym__line_break] = ACTIONS(3056),
    [sym__heredoc_body_start] = ACTIONS(3056),
    [sym__binary_minus] = ACTIONS(3056),
    [sym__binary_star] = ACTIONS(3056),
    [ts_builtin_sym_end] = ACTIONS(3056),
    [anon_sym___END__] = ACTIONS(3056),
    [anon_sym_LBRACE] = ACTIONS(3056),
    [anon_sym_RBRACE] = ACTIONS(3056),
    [anon_sym_RPAREN] = ACTIONS(3056),
    [anon_sym_DOT] = ACTIONS(3058),
    [anon_sym_COMMA] = ACTIONS(3056),
    [anon_sym_PIPE] = ACTIONS(3058),
    [anon_sym_SEMI] = ACTIONS(3056),
    [anon_sym_STAR_STAR] = ACTIONS(3058),
    [anon_sym_AMP] = ACTIONS(3058),
    [anon_sym_EQ] = ACTIONS(3058),
    [anon_sym_LT] = ACTIONS(3058),
    [anon_sym_end] = ACTIONS(3056),
    [anon_sym_if] = ACTIONS(3056),
    [anon_sym_unless] = ACTIONS(3056),
    [anon_sym_while] = ACTIONS(3056),
    [anon_sym_until] = ACTIONS(3056),
    [anon_sym_rescue] = ACTIONS(3056),
    [anon_sym_do] = ACTIONS(3056),
    [anon_sym_when] = ACTIONS(3056),
    [anon_sym_elsif] = ACTIONS(3056),
    [anon_sym_else] = ACTIONS(3056),
    [anon_sym_then] = ACTIONS(3056),
    [anon_sym_ensure] = ACTIONS(3056),
    [anon_sym_LBRACK] = ACTIONS(3056),
    [anon_sym_COLON_COLON2] = ACTIONS(3056),
    [anon_sym_AMP_DOT] = ACTIONS(3056),
    [anon_sym_PLUS_EQ] = ACTIONS(3056),
    [anon_sym_DASH_EQ] = ACTIONS(3056),
    [anon_sym_STAR_EQ] = ACTIONS(3056),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3056),
    [anon_sym_SLASH_EQ] = ACTIONS(3056),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3056),
    [anon_sym_PIPE_EQ] = ACTIONS(3056),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3056),
    [anon_sym_AMP_EQ] = ACTIONS(3056),
    [anon_sym_PERCENT_EQ] = ACTIONS(3056),
    [anon_sym_GT_GT_EQ] = ACTIONS(3056),
    [anon_sym_LT_LT_EQ] = ACTIONS(3056),
    [anon_sym_CARET_EQ] = ACTIONS(3056),
    [anon_sym_QMARK] = ACTIONS(3056),
    [anon_sym_DOT_DOT] = ACTIONS(3058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3056),
    [anon_sym_and] = ACTIONS(3056),
    [anon_sym_or] = ACTIONS(3056),
    [anon_sym_PIPE_PIPE] = ACTIONS(3058),
    [anon_sym_AMP_AMP] = ACTIONS(3058),
    [anon_sym_LT_LT] = ACTIONS(3058),
    [anon_sym_GT_GT] = ACTIONS(3058),
    [anon_sym_EQ_EQ] = ACTIONS(3058),
    [anon_sym_BANG_EQ] = ACTIONS(3056),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3056),
    [anon_sym_LT_EQ_GT] = ACTIONS(3056),
    [anon_sym_EQ_TILDE] = ACTIONS(3056),
    [anon_sym_BANG_TILDE] = ACTIONS(3056),
    [anon_sym_LT_EQ] = ACTIONS(3058),
    [anon_sym_GT] = ACTIONS(3058),
    [anon_sym_GT_EQ] = ACTIONS(3056),
    [anon_sym_CARET] = ACTIONS(3058),
    [anon_sym_PLUS] = ACTIONS(3058),
    [anon_sym_SLASH] = ACTIONS(3058),
    [anon_sym_PERCENT] = ACTIONS(3058),
    [sym_comment] = ACTIONS(87),
  },
  [6270] = {
    [sym__string_end] = ACTIONS(12209),
    [sym_comment] = ACTIONS(87),
  },
  [6271] = {
    [aux_sym_string_array_repeat1] = STATE(8595),
    [sym__string_end] = ACTIONS(12211),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(12213),
  },
  [6272] = {
    [sym__line_break] = ACTIONS(3066),
    [sym__heredoc_body_start] = ACTIONS(3066),
    [sym__binary_minus] = ACTIONS(3066),
    [sym__binary_star] = ACTIONS(3066),
    [ts_builtin_sym_end] = ACTIONS(3066),
    [anon_sym___END__] = ACTIONS(3066),
    [anon_sym_LBRACE] = ACTIONS(3066),
    [anon_sym_RBRACE] = ACTIONS(3066),
    [anon_sym_RPAREN] = ACTIONS(3066),
    [anon_sym_DOT] = ACTIONS(3068),
    [anon_sym_COMMA] = ACTIONS(3066),
    [anon_sym_PIPE] = ACTIONS(3068),
    [anon_sym_SEMI] = ACTIONS(3066),
    [anon_sym_STAR_STAR] = ACTIONS(3068),
    [anon_sym_AMP] = ACTIONS(3068),
    [anon_sym_EQ] = ACTIONS(3068),
    [anon_sym_LT] = ACTIONS(3068),
    [anon_sym_end] = ACTIONS(3066),
    [anon_sym_if] = ACTIONS(3066),
    [anon_sym_unless] = ACTIONS(3066),
    [anon_sym_while] = ACTIONS(3066),
    [anon_sym_until] = ACTIONS(3066),
    [anon_sym_rescue] = ACTIONS(3066),
    [anon_sym_do] = ACTIONS(3066),
    [anon_sym_when] = ACTIONS(3066),
    [anon_sym_elsif] = ACTIONS(3066),
    [anon_sym_else] = ACTIONS(3066),
    [anon_sym_then] = ACTIONS(3066),
    [anon_sym_ensure] = ACTIONS(3066),
    [anon_sym_LBRACK] = ACTIONS(3066),
    [anon_sym_COLON_COLON2] = ACTIONS(3066),
    [anon_sym_AMP_DOT] = ACTIONS(3066),
    [anon_sym_PLUS_EQ] = ACTIONS(3066),
    [anon_sym_DASH_EQ] = ACTIONS(3066),
    [anon_sym_STAR_EQ] = ACTIONS(3066),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3066),
    [anon_sym_SLASH_EQ] = ACTIONS(3066),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3066),
    [anon_sym_PIPE_EQ] = ACTIONS(3066),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3066),
    [anon_sym_AMP_EQ] = ACTIONS(3066),
    [anon_sym_PERCENT_EQ] = ACTIONS(3066),
    [anon_sym_GT_GT_EQ] = ACTIONS(3066),
    [anon_sym_LT_LT_EQ] = ACTIONS(3066),
    [anon_sym_CARET_EQ] = ACTIONS(3066),
    [anon_sym_QMARK] = ACTIONS(3066),
    [anon_sym_DOT_DOT] = ACTIONS(3068),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3066),
    [anon_sym_and] = ACTIONS(3066),
    [anon_sym_or] = ACTIONS(3066),
    [anon_sym_PIPE_PIPE] = ACTIONS(3068),
    [anon_sym_AMP_AMP] = ACTIONS(3068),
    [anon_sym_LT_LT] = ACTIONS(3068),
    [anon_sym_GT_GT] = ACTIONS(3068),
    [anon_sym_EQ_EQ] = ACTIONS(3068),
    [anon_sym_BANG_EQ] = ACTIONS(3066),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3066),
    [anon_sym_LT_EQ_GT] = ACTIONS(3066),
    [anon_sym_EQ_TILDE] = ACTIONS(3066),
    [anon_sym_BANG_TILDE] = ACTIONS(3066),
    [anon_sym_LT_EQ] = ACTIONS(3068),
    [anon_sym_GT] = ACTIONS(3068),
    [anon_sym_GT_EQ] = ACTIONS(3066),
    [anon_sym_CARET] = ACTIONS(3068),
    [anon_sym_PLUS] = ACTIONS(3068),
    [anon_sym_SLASH] = ACTIONS(3068),
    [anon_sym_PERCENT] = ACTIONS(3068),
    [sym_comment] = ACTIONS(87),
  },
  [6273] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1697),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(12215),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [6274] = {
    [aux_sym_string_array_repeat1] = STATE(1699),
    [sym__string_end] = ACTIONS(12215),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(12217),
  },
  [6275] = {
    [sym__line_break] = ACTIONS(3085),
    [sym__heredoc_body_start] = ACTIONS(3085),
    [sym__binary_minus] = ACTIONS(3085),
    [sym__binary_star] = ACTIONS(3085),
    [ts_builtin_sym_end] = ACTIONS(3085),
    [anon_sym___END__] = ACTIONS(3085),
    [anon_sym_LBRACE] = ACTIONS(3085),
    [anon_sym_RBRACE] = ACTIONS(3085),
    [anon_sym_RPAREN] = ACTIONS(3085),
    [anon_sym_DOT] = ACTIONS(3087),
    [anon_sym_COMMA] = ACTIONS(3085),
    [anon_sym_PIPE] = ACTIONS(3087),
    [anon_sym_SEMI] = ACTIONS(3085),
    [anon_sym_STAR_STAR] = ACTIONS(3087),
    [anon_sym_AMP] = ACTIONS(3087),
    [anon_sym_EQ] = ACTIONS(3087),
    [anon_sym_LT] = ACTIONS(3087),
    [anon_sym_end] = ACTIONS(3085),
    [anon_sym_if] = ACTIONS(3085),
    [anon_sym_unless] = ACTIONS(3085),
    [anon_sym_while] = ACTIONS(3085),
    [anon_sym_until] = ACTIONS(3085),
    [anon_sym_rescue] = ACTIONS(3085),
    [anon_sym_do] = ACTIONS(3085),
    [anon_sym_when] = ACTIONS(3085),
    [anon_sym_elsif] = ACTIONS(3085),
    [anon_sym_else] = ACTIONS(3085),
    [anon_sym_then] = ACTIONS(3085),
    [anon_sym_ensure] = ACTIONS(3085),
    [anon_sym_LBRACK] = ACTIONS(3085),
    [anon_sym_COLON_COLON2] = ACTIONS(3085),
    [anon_sym_AMP_DOT] = ACTIONS(3085),
    [anon_sym_PLUS_EQ] = ACTIONS(3085),
    [anon_sym_DASH_EQ] = ACTIONS(3085),
    [anon_sym_STAR_EQ] = ACTIONS(3085),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3085),
    [anon_sym_SLASH_EQ] = ACTIONS(3085),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3085),
    [anon_sym_PIPE_EQ] = ACTIONS(3085),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3085),
    [anon_sym_AMP_EQ] = ACTIONS(3085),
    [anon_sym_PERCENT_EQ] = ACTIONS(3085),
    [anon_sym_GT_GT_EQ] = ACTIONS(3085),
    [anon_sym_LT_LT_EQ] = ACTIONS(3085),
    [anon_sym_CARET_EQ] = ACTIONS(3085),
    [anon_sym_QMARK] = ACTIONS(3085),
    [anon_sym_DOT_DOT] = ACTIONS(3087),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3085),
    [anon_sym_and] = ACTIONS(3085),
    [anon_sym_or] = ACTIONS(3085),
    [anon_sym_PIPE_PIPE] = ACTIONS(3087),
    [anon_sym_AMP_AMP] = ACTIONS(3087),
    [anon_sym_LT_LT] = ACTIONS(3087),
    [anon_sym_GT_GT] = ACTIONS(3087),
    [anon_sym_EQ_EQ] = ACTIONS(3087),
    [anon_sym_BANG_EQ] = ACTIONS(3085),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3085),
    [anon_sym_LT_EQ_GT] = ACTIONS(3085),
    [anon_sym_EQ_TILDE] = ACTIONS(3085),
    [anon_sym_BANG_TILDE] = ACTIONS(3085),
    [anon_sym_LT_EQ] = ACTIONS(3087),
    [anon_sym_GT] = ACTIONS(3087),
    [anon_sym_GT_EQ] = ACTIONS(3085),
    [anon_sym_CARET] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3087),
    [anon_sym_SLASH] = ACTIONS(3087),
    [anon_sym_PERCENT] = ACTIONS(3087),
    [sym_comment] = ACTIONS(87),
  },
  [6276] = {
    [sym__string_end] = ACTIONS(12219),
    [sym_comment] = ACTIONS(87),
  },
  [6277] = {
    [aux_sym_symbol_array_repeat1] = STATE(8601),
    [sym__string_end] = ACTIONS(12221),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(12223),
  },
  [6278] = {
    [sym__line_break] = ACTIONS(3095),
    [sym__heredoc_body_start] = ACTIONS(3095),
    [sym__binary_minus] = ACTIONS(3095),
    [sym__binary_star] = ACTIONS(3095),
    [ts_builtin_sym_end] = ACTIONS(3095),
    [anon_sym___END__] = ACTIONS(3095),
    [anon_sym_LBRACE] = ACTIONS(3095),
    [anon_sym_RBRACE] = ACTIONS(3095),
    [anon_sym_RPAREN] = ACTIONS(3095),
    [anon_sym_DOT] = ACTIONS(3097),
    [anon_sym_COMMA] = ACTIONS(3095),
    [anon_sym_PIPE] = ACTIONS(3097),
    [anon_sym_SEMI] = ACTIONS(3095),
    [anon_sym_STAR_STAR] = ACTIONS(3097),
    [anon_sym_AMP] = ACTIONS(3097),
    [anon_sym_EQ] = ACTIONS(3097),
    [anon_sym_LT] = ACTIONS(3097),
    [anon_sym_end] = ACTIONS(3095),
    [anon_sym_if] = ACTIONS(3095),
    [anon_sym_unless] = ACTIONS(3095),
    [anon_sym_while] = ACTIONS(3095),
    [anon_sym_until] = ACTIONS(3095),
    [anon_sym_rescue] = ACTIONS(3095),
    [anon_sym_do] = ACTIONS(3095),
    [anon_sym_when] = ACTIONS(3095),
    [anon_sym_elsif] = ACTIONS(3095),
    [anon_sym_else] = ACTIONS(3095),
    [anon_sym_then] = ACTIONS(3095),
    [anon_sym_ensure] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3095),
    [anon_sym_COLON_COLON2] = ACTIONS(3095),
    [anon_sym_AMP_DOT] = ACTIONS(3095),
    [anon_sym_PLUS_EQ] = ACTIONS(3095),
    [anon_sym_DASH_EQ] = ACTIONS(3095),
    [anon_sym_STAR_EQ] = ACTIONS(3095),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3095),
    [anon_sym_SLASH_EQ] = ACTIONS(3095),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3095),
    [anon_sym_PIPE_EQ] = ACTIONS(3095),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3095),
    [anon_sym_AMP_EQ] = ACTIONS(3095),
    [anon_sym_PERCENT_EQ] = ACTIONS(3095),
    [anon_sym_GT_GT_EQ] = ACTIONS(3095),
    [anon_sym_LT_LT_EQ] = ACTIONS(3095),
    [anon_sym_CARET_EQ] = ACTIONS(3095),
    [anon_sym_QMARK] = ACTIONS(3095),
    [anon_sym_DOT_DOT] = ACTIONS(3097),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3095),
    [anon_sym_and] = ACTIONS(3095),
    [anon_sym_or] = ACTIONS(3095),
    [anon_sym_PIPE_PIPE] = ACTIONS(3097),
    [anon_sym_AMP_AMP] = ACTIONS(3097),
    [anon_sym_LT_LT] = ACTIONS(3097),
    [anon_sym_GT_GT] = ACTIONS(3097),
    [anon_sym_EQ_EQ] = ACTIONS(3097),
    [anon_sym_BANG_EQ] = ACTIONS(3095),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3095),
    [anon_sym_LT_EQ_GT] = ACTIONS(3095),
    [anon_sym_EQ_TILDE] = ACTIONS(3095),
    [anon_sym_BANG_TILDE] = ACTIONS(3095),
    [anon_sym_LT_EQ] = ACTIONS(3097),
    [anon_sym_GT] = ACTIONS(3097),
    [anon_sym_GT_EQ] = ACTIONS(3095),
    [anon_sym_CARET] = ACTIONS(3097),
    [anon_sym_PLUS] = ACTIONS(3097),
    [anon_sym_SLASH] = ACTIONS(3097),
    [anon_sym_PERCENT] = ACTIONS(3097),
    [sym_comment] = ACTIONS(87),
  },
  [6279] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1705),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(12225),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [6280] = {
    [aux_sym_symbol_array_repeat1] = STATE(1707),
    [sym__string_end] = ACTIONS(12225),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(12227),
  },
  [6281] = {
    [sym__line_break] = ACTIONS(3575),
    [sym__heredoc_body_start] = ACTIONS(3575),
    [sym__binary_minus] = ACTIONS(3575),
    [sym__binary_star] = ACTIONS(3575),
    [ts_builtin_sym_end] = ACTIONS(3575),
    [anon_sym___END__] = ACTIONS(3575),
    [anon_sym_LBRACE] = ACTIONS(3575),
    [anon_sym_RBRACE] = ACTIONS(3575),
    [anon_sym_RPAREN] = ACTIONS(3575),
    [anon_sym_DOT] = ACTIONS(3577),
    [anon_sym_COMMA] = ACTIONS(3575),
    [anon_sym_PIPE] = ACTIONS(3577),
    [anon_sym_SEMI] = ACTIONS(3575),
    [anon_sym_STAR_STAR] = ACTIONS(3577),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_EQ] = ACTIONS(3577),
    [anon_sym_LT] = ACTIONS(3577),
    [anon_sym_end] = ACTIONS(3575),
    [anon_sym_if] = ACTIONS(3575),
    [anon_sym_unless] = ACTIONS(3575),
    [anon_sym_while] = ACTIONS(3575),
    [anon_sym_until] = ACTIONS(3575),
    [anon_sym_rescue] = ACTIONS(3575),
    [anon_sym_do] = ACTIONS(3575),
    [anon_sym_when] = ACTIONS(3575),
    [anon_sym_elsif] = ACTIONS(3575),
    [anon_sym_else] = ACTIONS(3575),
    [anon_sym_then] = ACTIONS(3575),
    [anon_sym_ensure] = ACTIONS(3575),
    [anon_sym_LBRACK] = ACTIONS(3575),
    [anon_sym_COLON_COLON2] = ACTIONS(3575),
    [anon_sym_AMP_DOT] = ACTIONS(3575),
    [anon_sym_PLUS_EQ] = ACTIONS(3575),
    [anon_sym_DASH_EQ] = ACTIONS(3575),
    [anon_sym_STAR_EQ] = ACTIONS(3575),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3575),
    [anon_sym_SLASH_EQ] = ACTIONS(3575),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3575),
    [anon_sym_PIPE_EQ] = ACTIONS(3575),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3575),
    [anon_sym_AMP_EQ] = ACTIONS(3575),
    [anon_sym_PERCENT_EQ] = ACTIONS(3575),
    [anon_sym_GT_GT_EQ] = ACTIONS(3575),
    [anon_sym_LT_LT_EQ] = ACTIONS(3575),
    [anon_sym_CARET_EQ] = ACTIONS(3575),
    [anon_sym_QMARK] = ACTIONS(3575),
    [anon_sym_DOT_DOT] = ACTIONS(3577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3575),
    [anon_sym_and] = ACTIONS(3575),
    [anon_sym_or] = ACTIONS(3575),
    [anon_sym_PIPE_PIPE] = ACTIONS(3577),
    [anon_sym_AMP_AMP] = ACTIONS(3577),
    [anon_sym_LT_LT] = ACTIONS(3577),
    [anon_sym_GT_GT] = ACTIONS(3577),
    [anon_sym_EQ_EQ] = ACTIONS(3577),
    [anon_sym_BANG_EQ] = ACTIONS(3575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3575),
    [anon_sym_LT_EQ_GT] = ACTIONS(3575),
    [anon_sym_EQ_TILDE] = ACTIONS(3575),
    [anon_sym_BANG_TILDE] = ACTIONS(3575),
    [anon_sym_LT_EQ] = ACTIONS(3577),
    [anon_sym_GT] = ACTIONS(3577),
    [anon_sym_GT_EQ] = ACTIONS(3575),
    [anon_sym_CARET] = ACTIONS(3577),
    [anon_sym_PLUS] = ACTIONS(3577),
    [anon_sym_SLASH] = ACTIONS(3577),
    [anon_sym_PERCENT] = ACTIONS(3577),
    [sym_comment] = ACTIONS(87),
  },
  [6282] = {
    [anon_sym_RBRACE] = ACTIONS(12229),
    [sym_comment] = ACTIONS(87),
  },
  [6283] = {
    [sym__binary_minus] = ACTIONS(3609),
    [sym__binary_star] = ACTIONS(3611),
    [anon_sym_RPAREN] = ACTIONS(12231),
    [anon_sym_PIPE] = ACTIONS(3615),
    [anon_sym_STAR_STAR] = ACTIONS(3611),
    [anon_sym_AMP] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3619),
    [anon_sym_QMARK] = ACTIONS(3621),
    [anon_sym_DOT_DOT] = ACTIONS(3623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3625),
    [anon_sym_and] = ACTIONS(3627),
    [anon_sym_or] = ACTIONS(3627),
    [anon_sym_PIPE_PIPE] = ACTIONS(3629),
    [anon_sym_AMP_AMP] = ACTIONS(3629),
    [anon_sym_LT_LT] = ACTIONS(3631),
    [anon_sym_GT_GT] = ACTIONS(3631),
    [anon_sym_EQ_EQ] = ACTIONS(3633),
    [anon_sym_BANG_EQ] = ACTIONS(3629),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3629),
    [anon_sym_LT_EQ_GT] = ACTIONS(3629),
    [anon_sym_EQ_TILDE] = ACTIONS(3629),
    [anon_sym_BANG_TILDE] = ACTIONS(3629),
    [anon_sym_LT_EQ] = ACTIONS(3619),
    [anon_sym_GT] = ACTIONS(3619),
    [anon_sym_GT_EQ] = ACTIONS(3635),
    [anon_sym_CARET] = ACTIONS(3637),
    [anon_sym_PLUS] = ACTIONS(3609),
    [anon_sym_SLASH] = ACTIONS(3611),
    [anon_sym_PERCENT] = ACTIONS(3611),
    [sym_comment] = ACTIONS(87),
  },
  [6284] = {
    [sym__method_rest] = STATE(8606),
    [sym_operator] = STATE(3602),
    [sym__method_name] = STATE(3602),
    [sym_setter] = STATE(3602),
    [sym_symbol] = STATE(3602),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(12233),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(12233),
    [sym_class_variable] = ACTIONS(12233),
    [sym_global_variable] = ACTIONS(12233),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [6285] = {
    [sym__statements] = STATE(3621),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(3622),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(3623),
    [sym_rescue] = STATE(3624),
    [sym__body_statement] = STATE(8607),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12235),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6286] = {
    [sym__line_break] = ACTIONS(3805),
    [sym__heredoc_body_start] = ACTIONS(3805),
    [sym__binary_minus] = ACTIONS(3805),
    [sym__binary_star] = ACTIONS(3805),
    [ts_builtin_sym_end] = ACTIONS(3805),
    [anon_sym___END__] = ACTIONS(3805),
    [anon_sym_LBRACE] = ACTIONS(3805),
    [anon_sym_RBRACE] = ACTIONS(3805),
    [anon_sym_RPAREN] = ACTIONS(3805),
    [anon_sym_DOT] = ACTIONS(3807),
    [anon_sym_COMMA] = ACTIONS(3805),
    [anon_sym_PIPE] = ACTIONS(3807),
    [anon_sym_SEMI] = ACTIONS(3805),
    [anon_sym_STAR_STAR] = ACTIONS(3807),
    [anon_sym_AMP] = ACTIONS(3807),
    [anon_sym_EQ] = ACTIONS(3807),
    [anon_sym_LT] = ACTIONS(3807),
    [anon_sym_end] = ACTIONS(3805),
    [anon_sym_if] = ACTIONS(3805),
    [anon_sym_unless] = ACTIONS(3805),
    [anon_sym_while] = ACTIONS(3805),
    [anon_sym_until] = ACTIONS(3805),
    [anon_sym_rescue] = ACTIONS(3805),
    [anon_sym_do] = ACTIONS(3805),
    [anon_sym_when] = ACTIONS(3805),
    [anon_sym_elsif] = ACTIONS(3805),
    [anon_sym_else] = ACTIONS(3805),
    [anon_sym_then] = ACTIONS(3805),
    [anon_sym_ensure] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(3805),
    [anon_sym_COLON_COLON2] = ACTIONS(3805),
    [anon_sym_AMP_DOT] = ACTIONS(3805),
    [anon_sym_PLUS_EQ] = ACTIONS(3805),
    [anon_sym_DASH_EQ] = ACTIONS(3805),
    [anon_sym_STAR_EQ] = ACTIONS(3805),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3805),
    [anon_sym_SLASH_EQ] = ACTIONS(3805),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3805),
    [anon_sym_PIPE_EQ] = ACTIONS(3805),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3805),
    [anon_sym_AMP_EQ] = ACTIONS(3805),
    [anon_sym_PERCENT_EQ] = ACTIONS(3805),
    [anon_sym_GT_GT_EQ] = ACTIONS(3805),
    [anon_sym_LT_LT_EQ] = ACTIONS(3805),
    [anon_sym_CARET_EQ] = ACTIONS(3805),
    [anon_sym_QMARK] = ACTIONS(3805),
    [anon_sym_DOT_DOT] = ACTIONS(3807),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3805),
    [anon_sym_and] = ACTIONS(3805),
    [anon_sym_or] = ACTIONS(3805),
    [anon_sym_PIPE_PIPE] = ACTIONS(3807),
    [anon_sym_AMP_AMP] = ACTIONS(3807),
    [anon_sym_LT_LT] = ACTIONS(3807),
    [anon_sym_GT_GT] = ACTIONS(3807),
    [anon_sym_EQ_EQ] = ACTIONS(3807),
    [anon_sym_BANG_EQ] = ACTIONS(3805),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3805),
    [anon_sym_LT_EQ_GT] = ACTIONS(3805),
    [anon_sym_EQ_TILDE] = ACTIONS(3805),
    [anon_sym_BANG_TILDE] = ACTIONS(3805),
    [anon_sym_LT_EQ] = ACTIONS(3807),
    [anon_sym_GT] = ACTIONS(3807),
    [anon_sym_GT_EQ] = ACTIONS(3805),
    [anon_sym_CARET] = ACTIONS(3807),
    [anon_sym_PLUS] = ACTIONS(3807),
    [anon_sym_SLASH] = ACTIONS(3807),
    [anon_sym_PERCENT] = ACTIONS(3807),
    [sym_comment] = ACTIONS(87),
  },
  [6287] = {
    [sym_heredoc_body] = STATE(8608),
    [sym__terminator] = STATE(8608),
    [sym__line_break] = ACTIONS(12237),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym__binary_minus] = ACTIONS(2001),
    [sym__binary_star] = ACTIONS(2003),
    [anon_sym_PIPE] = ACTIONS(2005),
    [anon_sym_SEMI] = ACTIONS(12237),
    [anon_sym_STAR_STAR] = ACTIONS(2003),
    [anon_sym_AMP] = ACTIONS(2007),
    [anon_sym_LT] = ACTIONS(2009),
    [anon_sym_QMARK] = ACTIONS(2011),
    [anon_sym_DOT_DOT] = ACTIONS(2013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2015),
    [anon_sym_and] = ACTIONS(2017),
    [anon_sym_or] = ACTIONS(2017),
    [anon_sym_PIPE_PIPE] = ACTIONS(2019),
    [anon_sym_AMP_AMP] = ACTIONS(2019),
    [anon_sym_LT_LT] = ACTIONS(2021),
    [anon_sym_GT_GT] = ACTIONS(2021),
    [anon_sym_EQ_EQ] = ACTIONS(2023),
    [anon_sym_BANG_EQ] = ACTIONS(2019),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2019),
    [anon_sym_LT_EQ_GT] = ACTIONS(2019),
    [anon_sym_EQ_TILDE] = ACTIONS(2019),
    [anon_sym_BANG_TILDE] = ACTIONS(2019),
    [anon_sym_LT_EQ] = ACTIONS(2009),
    [anon_sym_GT] = ACTIONS(2009),
    [anon_sym_GT_EQ] = ACTIONS(2025),
    [anon_sym_CARET] = ACTIONS(2027),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_SLASH] = ACTIONS(2003),
    [anon_sym_PERCENT] = ACTIONS(2003),
    [sym_comment] = ACTIONS(87),
  },
  [6288] = {
    [sym_heredoc_body] = STATE(8609),
    [sym__terminator] = STATE(8609),
    [sym__line_break] = ACTIONS(12239),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(12239),
    [sym_comment] = ACTIONS(87),
  },
  [6289] = {
    [sym__statements] = STATE(3621),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(3622),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(3623),
    [sym_rescue] = STATE(3624),
    [sym__body_statement] = STATE(8610),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12241),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6290] = {
    [sym__line_break] = ACTIONS(4205),
    [sym__heredoc_body_start] = ACTIONS(4205),
    [sym__binary_minus] = ACTIONS(4205),
    [sym__binary_star] = ACTIONS(4205),
    [ts_builtin_sym_end] = ACTIONS(4205),
    [anon_sym___END__] = ACTIONS(4205),
    [anon_sym_LBRACE] = ACTIONS(4205),
    [anon_sym_RBRACE] = ACTIONS(4205),
    [anon_sym_RPAREN] = ACTIONS(4205),
    [anon_sym_DOT] = ACTIONS(4207),
    [anon_sym_COMMA] = ACTIONS(4205),
    [anon_sym_PIPE] = ACTIONS(4207),
    [anon_sym_SEMI] = ACTIONS(4205),
    [anon_sym_STAR_STAR] = ACTIONS(4207),
    [anon_sym_AMP] = ACTIONS(4207),
    [anon_sym_EQ] = ACTIONS(4207),
    [anon_sym_LT] = ACTIONS(4207),
    [anon_sym_end] = ACTIONS(4205),
    [anon_sym_if] = ACTIONS(4205),
    [anon_sym_unless] = ACTIONS(4205),
    [anon_sym_while] = ACTIONS(4205),
    [anon_sym_until] = ACTIONS(4205),
    [anon_sym_rescue] = ACTIONS(4205),
    [anon_sym_do] = ACTIONS(4205),
    [anon_sym_when] = ACTIONS(4205),
    [anon_sym_elsif] = ACTIONS(4205),
    [anon_sym_else] = ACTIONS(4205),
    [anon_sym_then] = ACTIONS(4205),
    [anon_sym_ensure] = ACTIONS(4205),
    [anon_sym_LBRACK] = ACTIONS(4205),
    [anon_sym_COLON_COLON2] = ACTIONS(4205),
    [anon_sym_AMP_DOT] = ACTIONS(4205),
    [anon_sym_PLUS_EQ] = ACTIONS(4205),
    [anon_sym_DASH_EQ] = ACTIONS(4205),
    [anon_sym_STAR_EQ] = ACTIONS(4205),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4205),
    [anon_sym_SLASH_EQ] = ACTIONS(4205),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4205),
    [anon_sym_PIPE_EQ] = ACTIONS(4205),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4205),
    [anon_sym_AMP_EQ] = ACTIONS(4205),
    [anon_sym_PERCENT_EQ] = ACTIONS(4205),
    [anon_sym_GT_GT_EQ] = ACTIONS(4205),
    [anon_sym_LT_LT_EQ] = ACTIONS(4205),
    [anon_sym_CARET_EQ] = ACTIONS(4205),
    [anon_sym_QMARK] = ACTIONS(4205),
    [anon_sym_DOT_DOT] = ACTIONS(4207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4205),
    [anon_sym_and] = ACTIONS(4205),
    [anon_sym_or] = ACTIONS(4205),
    [anon_sym_PIPE_PIPE] = ACTIONS(4207),
    [anon_sym_AMP_AMP] = ACTIONS(4207),
    [anon_sym_LT_LT] = ACTIONS(4207),
    [anon_sym_GT_GT] = ACTIONS(4207),
    [anon_sym_EQ_EQ] = ACTIONS(4207),
    [anon_sym_BANG_EQ] = ACTIONS(4205),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4205),
    [anon_sym_LT_EQ_GT] = ACTIONS(4205),
    [anon_sym_EQ_TILDE] = ACTIONS(4205),
    [anon_sym_BANG_TILDE] = ACTIONS(4205),
    [anon_sym_LT_EQ] = ACTIONS(4207),
    [anon_sym_GT] = ACTIONS(4207),
    [anon_sym_GT_EQ] = ACTIONS(4205),
    [anon_sym_CARET] = ACTIONS(4207),
    [anon_sym_PLUS] = ACTIONS(4207),
    [anon_sym_SLASH] = ACTIONS(4207),
    [anon_sym_PERCENT] = ACTIONS(4207),
    [sym_comment] = ACTIONS(87),
  },
  [6291] = {
    [sym__statements] = STATE(3621),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(3622),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(3623),
    [sym_rescue] = STATE(3624),
    [sym__body_statement] = STATE(8611),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12243),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6292] = {
    [sym_elsif] = STATE(8613),
    [sym_else] = STATE(8613),
    [anon_sym_end] = ACTIONS(12245),
    [anon_sym_elsif] = ACTIONS(4495),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [6293] = {
    [sym__statements] = STATE(2640),
    [sym_begin_block] = STATE(2641),
    [sym_end_block] = STATE(2641),
    [sym__statement] = STATE(2641),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(2641),
    [sym_unless_modifier] = STATE(2641),
    [sym_while_modifier] = STATE(2641),
    [sym_until_modifier] = STATE(2641),
    [sym_rescue_modifier] = STATE(2641),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_elsif] = STATE(8613),
    [sym_else] = STATE(8613),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2642),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2645),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(2645),
    [sym_assignment] = STATE(2642),
    [sym_operator_assignment] = STATE(2642),
    [sym_conditional] = STATE(2642),
    [sym_range] = STATE(2642),
    [sym_binary] = STATE(2642),
    [sym_unary] = STATE(2642),
    [sym_left_assignment_list] = STATE(2644),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2645),
    [sym__variable] = STATE(2643),
    [sym_undef] = STATE(2641),
    [sym_alias] = STATE(2641),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2645),
    [sym_false] = STATE(2645),
    [sym_nil] = STATE(2645),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2646),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(2647),
    [aux_sym__statements_repeat1] = STATE(2647),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4467),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12247),
    [anon_sym_return] = ACTIONS(4471),
    [anon_sym_yield] = ACTIONS(4473),
    [anon_sym_break] = ACTIONS(4475),
    [anon_sym_next] = ACTIONS(4477),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(4499),
    [anon_sym_else] = ACTIONS(4501),
    [anon_sym_then] = ACTIONS(4503),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4479),
    [anon_sym_defined_QMARK] = ACTIONS(4481),
    [anon_sym_not] = ACTIONS(4483),
    [anon_sym_BANG] = ACTIONS(4485),
    [anon_sym_TILDE] = ACTIONS(4485),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [anon_sym_undef] = ACTIONS(4491),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6294] = {
    [sym_else] = STATE(8615),
    [anon_sym_end] = ACTIONS(12249),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [6295] = {
    [sym__statements] = STATE(2640),
    [sym_begin_block] = STATE(2715),
    [sym_end_block] = STATE(2715),
    [sym__statement] = STATE(2715),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(2715),
    [sym_unless_modifier] = STATE(2715),
    [sym_while_modifier] = STATE(2715),
    [sym_until_modifier] = STATE(2715),
    [sym_rescue_modifier] = STATE(2715),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(8615),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2716),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2719),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(2719),
    [sym_assignment] = STATE(2716),
    [sym_operator_assignment] = STATE(2716),
    [sym_conditional] = STATE(2716),
    [sym_range] = STATE(2716),
    [sym_binary] = STATE(2716),
    [sym_unary] = STATE(2716),
    [sym_left_assignment_list] = STATE(2718),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2719),
    [sym__variable] = STATE(2717),
    [sym_undef] = STATE(2715),
    [sym_alias] = STATE(2715),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2719),
    [sym_false] = STATE(2719),
    [sym_nil] = STATE(2719),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2720),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(2721),
    [aux_sym__statements_repeat1] = STATE(2721),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4583),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12251),
    [anon_sym_return] = ACTIONS(4585),
    [anon_sym_yield] = ACTIONS(4587),
    [anon_sym_break] = ACTIONS(4589),
    [anon_sym_next] = ACTIONS(4591),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(4501),
    [anon_sym_then] = ACTIONS(4611),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4593),
    [anon_sym_defined_QMARK] = ACTIONS(4595),
    [anon_sym_not] = ACTIONS(4597),
    [anon_sym_BANG] = ACTIONS(4599),
    [anon_sym_TILDE] = ACTIONS(4599),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [anon_sym_undef] = ACTIONS(4605),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6296] = {
    [sym__statements] = STATE(8617),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12253),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6297] = {
    [sym__statements] = STATE(8619),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12255),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6298] = {
    [sym__do] = STATE(8620),
    [sym_heredoc_body] = STATE(8620),
    [sym__terminator] = STATE(8620),
    [sym__line_break] = ACTIONS(12257),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(12257),
    [anon_sym_do] = ACTIONS(12257),
    [sym_comment] = ACTIONS(87),
  },
  [6299] = {
    [sym_when] = STATE(8624),
    [sym_else] = STATE(8622),
    [aux_sym_case_repeat1] = STATE(8623),
    [aux_sym_case_repeat2] = STATE(8624),
    [anon_sym_SEMI] = ACTIONS(12259),
    [anon_sym_end] = ACTIONS(12261),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [6300] = {
    [sym__line_break] = ACTIONS(4965),
    [sym__heredoc_body_start] = ACTIONS(4965),
    [sym__binary_minus] = ACTIONS(4965),
    [sym__binary_star] = ACTIONS(4965),
    [ts_builtin_sym_end] = ACTIONS(4965),
    [anon_sym___END__] = ACTIONS(4965),
    [anon_sym_LBRACE] = ACTIONS(4965),
    [anon_sym_RBRACE] = ACTIONS(4965),
    [anon_sym_RPAREN] = ACTIONS(4965),
    [anon_sym_DOT] = ACTIONS(4967),
    [anon_sym_COMMA] = ACTIONS(4965),
    [anon_sym_PIPE] = ACTIONS(4967),
    [anon_sym_SEMI] = ACTIONS(4965),
    [anon_sym_STAR_STAR] = ACTIONS(4967),
    [anon_sym_AMP] = ACTIONS(4967),
    [anon_sym_EQ] = ACTIONS(4967),
    [anon_sym_LT] = ACTIONS(4967),
    [anon_sym_end] = ACTIONS(4965),
    [anon_sym_if] = ACTIONS(4965),
    [anon_sym_unless] = ACTIONS(4965),
    [anon_sym_while] = ACTIONS(4965),
    [anon_sym_until] = ACTIONS(4965),
    [anon_sym_rescue] = ACTIONS(4965),
    [anon_sym_do] = ACTIONS(4965),
    [anon_sym_when] = ACTIONS(4965),
    [anon_sym_elsif] = ACTIONS(4965),
    [anon_sym_else] = ACTIONS(4965),
    [anon_sym_then] = ACTIONS(4965),
    [anon_sym_ensure] = ACTIONS(4965),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym_COLON_COLON2] = ACTIONS(4965),
    [anon_sym_AMP_DOT] = ACTIONS(4965),
    [anon_sym_PLUS_EQ] = ACTIONS(4965),
    [anon_sym_DASH_EQ] = ACTIONS(4965),
    [anon_sym_STAR_EQ] = ACTIONS(4965),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4965),
    [anon_sym_SLASH_EQ] = ACTIONS(4965),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4965),
    [anon_sym_PIPE_EQ] = ACTIONS(4965),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4965),
    [anon_sym_AMP_EQ] = ACTIONS(4965),
    [anon_sym_PERCENT_EQ] = ACTIONS(4965),
    [anon_sym_GT_GT_EQ] = ACTIONS(4965),
    [anon_sym_LT_LT_EQ] = ACTIONS(4965),
    [anon_sym_CARET_EQ] = ACTIONS(4965),
    [anon_sym_QMARK] = ACTIONS(4965),
    [anon_sym_DOT_DOT] = ACTIONS(4967),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4965),
    [anon_sym_and] = ACTIONS(4965),
    [anon_sym_or] = ACTIONS(4965),
    [anon_sym_PIPE_PIPE] = ACTIONS(4967),
    [anon_sym_AMP_AMP] = ACTIONS(4967),
    [anon_sym_LT_LT] = ACTIONS(4967),
    [anon_sym_GT_GT] = ACTIONS(4967),
    [anon_sym_EQ_EQ] = ACTIONS(4967),
    [anon_sym_BANG_EQ] = ACTIONS(4965),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4965),
    [anon_sym_LT_EQ_GT] = ACTIONS(4965),
    [anon_sym_EQ_TILDE] = ACTIONS(4965),
    [anon_sym_BANG_TILDE] = ACTIONS(4965),
    [anon_sym_LT_EQ] = ACTIONS(4967),
    [anon_sym_GT] = ACTIONS(4967),
    [anon_sym_GT_EQ] = ACTIONS(4965),
    [anon_sym_CARET] = ACTIONS(4967),
    [anon_sym_PLUS] = ACTIONS(4967),
    [anon_sym_SLASH] = ACTIONS(4967),
    [anon_sym_PERCENT] = ACTIONS(4967),
    [sym_comment] = ACTIONS(87),
  },
  [6301] = {
    [anon_sym_end] = ACTIONS(12261),
    [sym_comment] = ACTIONS(87),
  },
  [6302] = {
    [sym_when] = STATE(8624),
    [sym_else] = STATE(8622),
    [aux_sym_case_repeat1] = STATE(2987),
    [aux_sym_case_repeat2] = STATE(8624),
    [anon_sym_SEMI] = ACTIONS(4995),
    [anon_sym_end] = ACTIONS(12261),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [6303] = {
    [sym_when] = STATE(2988),
    [sym_else] = STATE(8622),
    [aux_sym_case_repeat2] = STATE(2988),
    [anon_sym_end] = ACTIONS(12261),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [6304] = {
    [sym__line_break] = ACTIONS(5407),
    [sym__heredoc_body_start] = ACTIONS(5407),
    [sym__binary_minus] = ACTIONS(5407),
    [sym__binary_star] = ACTIONS(5407),
    [ts_builtin_sym_end] = ACTIONS(5407),
    [anon_sym___END__] = ACTIONS(5407),
    [anon_sym_LBRACE] = ACTIONS(5407),
    [anon_sym_RBRACE] = ACTIONS(5407),
    [anon_sym_RPAREN] = ACTIONS(5407),
    [anon_sym_DOT] = ACTIONS(5409),
    [anon_sym_COMMA] = ACTIONS(5407),
    [anon_sym_PIPE] = ACTIONS(5409),
    [anon_sym_SEMI] = ACTIONS(5407),
    [anon_sym_STAR_STAR] = ACTIONS(5409),
    [anon_sym_AMP] = ACTIONS(5409),
    [anon_sym_EQ] = ACTIONS(5409),
    [anon_sym_LT] = ACTIONS(5409),
    [anon_sym_end] = ACTIONS(5407),
    [anon_sym_if] = ACTIONS(5407),
    [anon_sym_unless] = ACTIONS(5407),
    [anon_sym_while] = ACTIONS(5407),
    [anon_sym_until] = ACTIONS(5407),
    [anon_sym_rescue] = ACTIONS(5407),
    [anon_sym_do] = ACTIONS(5407),
    [anon_sym_when] = ACTIONS(5407),
    [anon_sym_elsif] = ACTIONS(5407),
    [anon_sym_else] = ACTIONS(5407),
    [anon_sym_then] = ACTIONS(5407),
    [anon_sym_ensure] = ACTIONS(5407),
    [anon_sym_LBRACK] = ACTIONS(5407),
    [anon_sym_COLON_COLON2] = ACTIONS(5407),
    [anon_sym_AMP_DOT] = ACTIONS(5407),
    [anon_sym_PLUS_EQ] = ACTIONS(5407),
    [anon_sym_DASH_EQ] = ACTIONS(5407),
    [anon_sym_STAR_EQ] = ACTIONS(5407),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5407),
    [anon_sym_SLASH_EQ] = ACTIONS(5407),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5407),
    [anon_sym_PIPE_EQ] = ACTIONS(5407),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5407),
    [anon_sym_AMP_EQ] = ACTIONS(5407),
    [anon_sym_PERCENT_EQ] = ACTIONS(5407),
    [anon_sym_GT_GT_EQ] = ACTIONS(5407),
    [anon_sym_LT_LT_EQ] = ACTIONS(5407),
    [anon_sym_CARET_EQ] = ACTIONS(5407),
    [anon_sym_QMARK] = ACTIONS(5407),
    [anon_sym_DOT_DOT] = ACTIONS(5409),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5407),
    [anon_sym_and] = ACTIONS(5407),
    [anon_sym_or] = ACTIONS(5407),
    [anon_sym_PIPE_PIPE] = ACTIONS(5409),
    [anon_sym_AMP_AMP] = ACTIONS(5409),
    [anon_sym_LT_LT] = ACTIONS(5409),
    [anon_sym_GT_GT] = ACTIONS(5409),
    [anon_sym_EQ_EQ] = ACTIONS(5409),
    [anon_sym_BANG_EQ] = ACTIONS(5407),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5407),
    [anon_sym_LT_EQ_GT] = ACTIONS(5407),
    [anon_sym_EQ_TILDE] = ACTIONS(5407),
    [anon_sym_BANG_TILDE] = ACTIONS(5407),
    [anon_sym_LT_EQ] = ACTIONS(5409),
    [anon_sym_GT] = ACTIONS(5409),
    [anon_sym_GT_EQ] = ACTIONS(5407),
    [anon_sym_CARET] = ACTIONS(5409),
    [anon_sym_PLUS] = ACTIONS(5409),
    [anon_sym_SLASH] = ACTIONS(5409),
    [anon_sym_PERCENT] = ACTIONS(5409),
    [sym_comment] = ACTIONS(87),
  },
  [6305] = {
    [sym_ensure] = STATE(8626),
    [anon_sym_end] = ACTIONS(12263),
    [anon_sym_ensure] = ACTIONS(2169),
    [sym_comment] = ACTIONS(87),
  },
  [6306] = {
    [anon_sym_end] = ACTIONS(12263),
    [sym_comment] = ACTIONS(87),
  },
  [6307] = {
    [sym_else] = STATE(8627),
    [sym_ensure] = STATE(8626),
    [anon_sym_end] = ACTIONS(12263),
    [anon_sym_else] = ACTIONS(2167),
    [anon_sym_ensure] = ACTIONS(2169),
    [sym_comment] = ACTIONS(87),
  },
  [6308] = {
    [sym__line_break] = ACTIONS(5491),
    [sym__heredoc_body_start] = ACTIONS(5491),
    [sym__binary_minus] = ACTIONS(5491),
    [sym__binary_star] = ACTIONS(5491),
    [ts_builtin_sym_end] = ACTIONS(5491),
    [anon_sym___END__] = ACTIONS(5491),
    [anon_sym_LBRACE] = ACTIONS(5491),
    [anon_sym_RBRACE] = ACTIONS(5491),
    [anon_sym_RPAREN] = ACTIONS(5491),
    [anon_sym_DOT] = ACTIONS(5493),
    [anon_sym_COMMA] = ACTIONS(5491),
    [anon_sym_PIPE] = ACTIONS(5493),
    [anon_sym_SEMI] = ACTIONS(5491),
    [anon_sym_STAR_STAR] = ACTIONS(5493),
    [anon_sym_AMP] = ACTIONS(5493),
    [anon_sym_EQ] = ACTIONS(5493),
    [anon_sym_LT] = ACTIONS(5493),
    [anon_sym_end] = ACTIONS(5491),
    [anon_sym_if] = ACTIONS(5491),
    [anon_sym_unless] = ACTIONS(5491),
    [anon_sym_while] = ACTIONS(5491),
    [anon_sym_until] = ACTIONS(5491),
    [anon_sym_rescue] = ACTIONS(5491),
    [anon_sym_do] = ACTIONS(5491),
    [anon_sym_when] = ACTIONS(5491),
    [anon_sym_elsif] = ACTIONS(5491),
    [anon_sym_else] = ACTIONS(5491),
    [anon_sym_then] = ACTIONS(5491),
    [anon_sym_ensure] = ACTIONS(5491),
    [anon_sym_LBRACK] = ACTIONS(5491),
    [anon_sym_COLON_COLON2] = ACTIONS(5491),
    [anon_sym_AMP_DOT] = ACTIONS(5491),
    [anon_sym_PLUS_EQ] = ACTIONS(5491),
    [anon_sym_DASH_EQ] = ACTIONS(5491),
    [anon_sym_STAR_EQ] = ACTIONS(5491),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5491),
    [anon_sym_SLASH_EQ] = ACTIONS(5491),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5491),
    [anon_sym_PIPE_EQ] = ACTIONS(5491),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5491),
    [anon_sym_AMP_EQ] = ACTIONS(5491),
    [anon_sym_PERCENT_EQ] = ACTIONS(5491),
    [anon_sym_GT_GT_EQ] = ACTIONS(5491),
    [anon_sym_LT_LT_EQ] = ACTIONS(5491),
    [anon_sym_CARET_EQ] = ACTIONS(5491),
    [anon_sym_QMARK] = ACTIONS(5491),
    [anon_sym_DOT_DOT] = ACTIONS(5493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5491),
    [anon_sym_and] = ACTIONS(5491),
    [anon_sym_or] = ACTIONS(5491),
    [anon_sym_PIPE_PIPE] = ACTIONS(5493),
    [anon_sym_AMP_AMP] = ACTIONS(5493),
    [anon_sym_LT_LT] = ACTIONS(5493),
    [anon_sym_GT_GT] = ACTIONS(5493),
    [anon_sym_EQ_EQ] = ACTIONS(5493),
    [anon_sym_BANG_EQ] = ACTIONS(5491),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5491),
    [anon_sym_LT_EQ_GT] = ACTIONS(5491),
    [anon_sym_EQ_TILDE] = ACTIONS(5491),
    [anon_sym_BANG_TILDE] = ACTIONS(5491),
    [anon_sym_LT_EQ] = ACTIONS(5493),
    [anon_sym_GT] = ACTIONS(5493),
    [anon_sym_GT_EQ] = ACTIONS(5491),
    [anon_sym_CARET] = ACTIONS(5493),
    [anon_sym_PLUS] = ACTIONS(5493),
    [anon_sym_SLASH] = ACTIONS(5493),
    [anon_sym_PERCENT] = ACTIONS(5493),
    [sym_comment] = ACTIONS(87),
  },
  [6309] = {
    [sym__line_break] = ACTIONS(5725),
    [sym__heredoc_body_start] = ACTIONS(5725),
    [sym__binary_minus] = ACTIONS(5725),
    [sym__binary_star] = ACTIONS(5725),
    [ts_builtin_sym_end] = ACTIONS(5725),
    [anon_sym___END__] = ACTIONS(5725),
    [anon_sym_LBRACE] = ACTIONS(5725),
    [anon_sym_RBRACE] = ACTIONS(5725),
    [anon_sym_RPAREN] = ACTIONS(5725),
    [anon_sym_DOT] = ACTIONS(5727),
    [anon_sym_COMMA] = ACTIONS(5725),
    [anon_sym_PIPE] = ACTIONS(5727),
    [anon_sym_SEMI] = ACTIONS(5725),
    [anon_sym_STAR_STAR] = ACTIONS(5727),
    [anon_sym_AMP] = ACTIONS(5727),
    [anon_sym_EQ] = ACTIONS(5727),
    [anon_sym_LT] = ACTIONS(5727),
    [anon_sym_end] = ACTIONS(5725),
    [anon_sym_if] = ACTIONS(5725),
    [anon_sym_unless] = ACTIONS(5725),
    [anon_sym_while] = ACTIONS(5725),
    [anon_sym_until] = ACTIONS(5725),
    [anon_sym_rescue] = ACTIONS(5725),
    [anon_sym_do] = ACTIONS(5725),
    [anon_sym_when] = ACTIONS(5725),
    [anon_sym_elsif] = ACTIONS(5725),
    [anon_sym_else] = ACTIONS(5725),
    [anon_sym_then] = ACTIONS(5725),
    [anon_sym_ensure] = ACTIONS(5725),
    [anon_sym_LBRACK] = ACTIONS(5725),
    [anon_sym_COLON_COLON2] = ACTIONS(5725),
    [anon_sym_AMP_DOT] = ACTIONS(5725),
    [anon_sym_PLUS_EQ] = ACTIONS(5725),
    [anon_sym_DASH_EQ] = ACTIONS(5725),
    [anon_sym_STAR_EQ] = ACTIONS(5725),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5725),
    [anon_sym_SLASH_EQ] = ACTIONS(5725),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5725),
    [anon_sym_PIPE_EQ] = ACTIONS(5725),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5725),
    [anon_sym_AMP_EQ] = ACTIONS(5725),
    [anon_sym_PERCENT_EQ] = ACTIONS(5725),
    [anon_sym_GT_GT_EQ] = ACTIONS(5725),
    [anon_sym_LT_LT_EQ] = ACTIONS(5725),
    [anon_sym_CARET_EQ] = ACTIONS(5725),
    [anon_sym_QMARK] = ACTIONS(5725),
    [anon_sym_DOT_DOT] = ACTIONS(5727),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5725),
    [anon_sym_and] = ACTIONS(5725),
    [anon_sym_or] = ACTIONS(5725),
    [anon_sym_PIPE_PIPE] = ACTIONS(5727),
    [anon_sym_AMP_AMP] = ACTIONS(5727),
    [anon_sym_LT_LT] = ACTIONS(5727),
    [anon_sym_GT_GT] = ACTIONS(5727),
    [anon_sym_EQ_EQ] = ACTIONS(5727),
    [anon_sym_BANG_EQ] = ACTIONS(5725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5725),
    [anon_sym_LT_EQ_GT] = ACTIONS(5725),
    [anon_sym_EQ_TILDE] = ACTIONS(5725),
    [anon_sym_BANG_TILDE] = ACTIONS(5725),
    [anon_sym_LT_EQ] = ACTIONS(5727),
    [anon_sym_GT] = ACTIONS(5727),
    [anon_sym_GT_EQ] = ACTIONS(5725),
    [anon_sym_CARET] = ACTIONS(5727),
    [anon_sym_PLUS] = ACTIONS(5727),
    [anon_sym_SLASH] = ACTIONS(5727),
    [anon_sym_PERCENT] = ACTIONS(5727),
    [sym_comment] = ACTIONS(87),
  },
  [6310] = {
    [sym__line_break] = ACTIONS(5807),
    [sym__heredoc_body_start] = ACTIONS(5807),
    [sym__binary_minus] = ACTIONS(5807),
    [sym__binary_star] = ACTIONS(5807),
    [ts_builtin_sym_end] = ACTIONS(5807),
    [anon_sym___END__] = ACTIONS(5807),
    [anon_sym_LBRACE] = ACTIONS(5807),
    [anon_sym_RBRACE] = ACTIONS(5807),
    [anon_sym_RPAREN] = ACTIONS(5807),
    [anon_sym_DOT] = ACTIONS(5809),
    [anon_sym_COMMA] = ACTIONS(5807),
    [anon_sym_PIPE] = ACTIONS(5809),
    [anon_sym_SEMI] = ACTIONS(5807),
    [anon_sym_STAR_STAR] = ACTIONS(5809),
    [anon_sym_AMP] = ACTIONS(5809),
    [anon_sym_EQ] = ACTIONS(5809),
    [anon_sym_LT] = ACTIONS(5809),
    [anon_sym_end] = ACTIONS(5807),
    [anon_sym_if] = ACTIONS(5807),
    [anon_sym_unless] = ACTIONS(5807),
    [anon_sym_while] = ACTIONS(5807),
    [anon_sym_until] = ACTIONS(5807),
    [anon_sym_rescue] = ACTIONS(5807),
    [anon_sym_do] = ACTIONS(5807),
    [anon_sym_when] = ACTIONS(5807),
    [anon_sym_elsif] = ACTIONS(5807),
    [anon_sym_else] = ACTIONS(5807),
    [anon_sym_then] = ACTIONS(5807),
    [anon_sym_ensure] = ACTIONS(5807),
    [anon_sym_LBRACK] = ACTIONS(5807),
    [anon_sym_COLON_COLON2] = ACTIONS(5807),
    [anon_sym_AMP_DOT] = ACTIONS(5807),
    [anon_sym_PLUS_EQ] = ACTIONS(5807),
    [anon_sym_DASH_EQ] = ACTIONS(5807),
    [anon_sym_STAR_EQ] = ACTIONS(5807),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5807),
    [anon_sym_SLASH_EQ] = ACTIONS(5807),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5807),
    [anon_sym_PIPE_EQ] = ACTIONS(5807),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5807),
    [anon_sym_AMP_EQ] = ACTIONS(5807),
    [anon_sym_PERCENT_EQ] = ACTIONS(5807),
    [anon_sym_GT_GT_EQ] = ACTIONS(5807),
    [anon_sym_LT_LT_EQ] = ACTIONS(5807),
    [anon_sym_CARET_EQ] = ACTIONS(5807),
    [anon_sym_QMARK] = ACTIONS(5807),
    [anon_sym_DOT_DOT] = ACTIONS(5809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5807),
    [anon_sym_and] = ACTIONS(5807),
    [anon_sym_or] = ACTIONS(5807),
    [anon_sym_PIPE_PIPE] = ACTIONS(5809),
    [anon_sym_AMP_AMP] = ACTIONS(5809),
    [anon_sym_LT_LT] = ACTIONS(5809),
    [anon_sym_GT_GT] = ACTIONS(5809),
    [anon_sym_EQ_EQ] = ACTIONS(5809),
    [anon_sym_BANG_EQ] = ACTIONS(5807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5807),
    [anon_sym_LT_EQ_GT] = ACTIONS(5807),
    [anon_sym_EQ_TILDE] = ACTIONS(5807),
    [anon_sym_BANG_TILDE] = ACTIONS(5807),
    [anon_sym_LT_EQ] = ACTIONS(5809),
    [anon_sym_GT] = ACTIONS(5809),
    [anon_sym_GT_EQ] = ACTIONS(5807),
    [anon_sym_CARET] = ACTIONS(5809),
    [anon_sym_PLUS] = ACTIONS(5809),
    [anon_sym_SLASH] = ACTIONS(5809),
    [anon_sym_PERCENT] = ACTIONS(5809),
    [sym_comment] = ACTIONS(87),
  },
  [6311] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(6021),
    [ts_builtin_sym_end] = ACTIONS(5825),
    [anon_sym___END__] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(6025),
    [anon_sym_PERCENT] = ACTIONS(6025),
    [sym_comment] = ACTIONS(87),
  },
  [6312] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [ts_builtin_sym_end] = ACTIONS(5825),
    [anon_sym___END__] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(5827),
    [anon_sym_PERCENT] = ACTIONS(5827),
    [sym_comment] = ACTIONS(87),
  },
  [6313] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6019),
    [sym__binary_star] = ACTIONS(6021),
    [ts_builtin_sym_end] = ACTIONS(5825),
    [anon_sym___END__] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_AMP] = ACTIONS(6027),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(6039),
    [anon_sym_GT_GT] = ACTIONS(6039),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(6045),
    [anon_sym_SLASH] = ACTIONS(6025),
    [anon_sym_PERCENT] = ACTIONS(6025),
    [sym_comment] = ACTIONS(87),
  },
  [6314] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6019),
    [sym__binary_star] = ACTIONS(6021),
    [ts_builtin_sym_end] = ACTIONS(5825),
    [anon_sym___END__] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(6039),
    [anon_sym_GT_GT] = ACTIONS(6039),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(6045),
    [anon_sym_SLASH] = ACTIONS(6025),
    [anon_sym_PERCENT] = ACTIONS(6025),
    [sym_comment] = ACTIONS(87),
  },
  [6315] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6019),
    [sym__binary_star] = ACTIONS(6021),
    [ts_builtin_sym_end] = ACTIONS(5825),
    [anon_sym___END__] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(6023),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_AMP] = ACTIONS(6027),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(6039),
    [anon_sym_GT_GT] = ACTIONS(6039),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(6023),
    [anon_sym_PLUS] = ACTIONS(6045),
    [anon_sym_SLASH] = ACTIONS(6025),
    [anon_sym_PERCENT] = ACTIONS(6025),
    [sym_comment] = ACTIONS(87),
  },
  [6316] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(12265),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [6317] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(6019),
    [sym__binary_star] = ACTIONS(6021),
    [ts_builtin_sym_end] = ACTIONS(5927),
    [anon_sym___END__] = ACTIONS(5927),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(6023),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_AMP] = ACTIONS(6027),
    [anon_sym_EQ] = ACTIONS(7888),
    [anon_sym_LT] = ACTIONS(6029),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_PLUS_EQ] = ACTIONS(5927),
    [anon_sym_DASH_EQ] = ACTIONS(5927),
    [anon_sym_STAR_EQ] = ACTIONS(5927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5927),
    [anon_sym_SLASH_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5927),
    [anon_sym_AMP_EQ] = ACTIONS(5927),
    [anon_sym_PERCENT_EQ] = ACTIONS(5927),
    [anon_sym_GT_GT_EQ] = ACTIONS(5927),
    [anon_sym_LT_LT_EQ] = ACTIONS(5927),
    [anon_sym_CARET_EQ] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(6033),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6035),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(6037),
    [anon_sym_AMP_AMP] = ACTIONS(6037),
    [anon_sym_LT_LT] = ACTIONS(6039),
    [anon_sym_GT_GT] = ACTIONS(6039),
    [anon_sym_EQ_EQ] = ACTIONS(6037),
    [anon_sym_BANG_EQ] = ACTIONS(6041),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6041),
    [anon_sym_LT_EQ_GT] = ACTIONS(6041),
    [anon_sym_EQ_TILDE] = ACTIONS(6041),
    [anon_sym_BANG_TILDE] = ACTIONS(6041),
    [anon_sym_LT_EQ] = ACTIONS(6029),
    [anon_sym_GT] = ACTIONS(6029),
    [anon_sym_GT_EQ] = ACTIONS(6043),
    [anon_sym_CARET] = ACTIONS(6023),
    [anon_sym_PLUS] = ACTIONS(6045),
    [anon_sym_SLASH] = ACTIONS(6025),
    [anon_sym_PERCENT] = ACTIONS(6025),
    [sym_comment] = ACTIONS(87),
  },
  [6318] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6019),
    [sym__binary_star] = ACTIONS(6021),
    [ts_builtin_sym_end] = ACTIONS(5825),
    [anon_sym___END__] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(6023),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_AMP] = ACTIONS(6027),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(6029),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(6031),
    [anon_sym_DOT_DOT] = ACTIONS(6033),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6035),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(6037),
    [anon_sym_AMP_AMP] = ACTIONS(6037),
    [anon_sym_LT_LT] = ACTIONS(6039),
    [anon_sym_GT_GT] = ACTIONS(6039),
    [anon_sym_EQ_EQ] = ACTIONS(6037),
    [anon_sym_BANG_EQ] = ACTIONS(6041),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6041),
    [anon_sym_LT_EQ_GT] = ACTIONS(6041),
    [anon_sym_EQ_TILDE] = ACTIONS(6041),
    [anon_sym_BANG_TILDE] = ACTIONS(6041),
    [anon_sym_LT_EQ] = ACTIONS(6029),
    [anon_sym_GT] = ACTIONS(6029),
    [anon_sym_GT_EQ] = ACTIONS(6043),
    [anon_sym_CARET] = ACTIONS(6023),
    [anon_sym_PLUS] = ACTIONS(6045),
    [anon_sym_SLASH] = ACTIONS(6025),
    [anon_sym_PERCENT] = ACTIONS(6025),
    [sym_comment] = ACTIONS(87),
  },
  [6319] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6019),
    [sym__binary_star] = ACTIONS(6021),
    [ts_builtin_sym_end] = ACTIONS(5825),
    [anon_sym___END__] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(6023),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_AMP] = ACTIONS(6027),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(6029),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(6039),
    [anon_sym_GT_GT] = ACTIONS(6039),
    [anon_sym_EQ_EQ] = ACTIONS(6037),
    [anon_sym_BANG_EQ] = ACTIONS(6041),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6041),
    [anon_sym_LT_EQ_GT] = ACTIONS(6041),
    [anon_sym_EQ_TILDE] = ACTIONS(6041),
    [anon_sym_BANG_TILDE] = ACTIONS(6041),
    [anon_sym_LT_EQ] = ACTIONS(6029),
    [anon_sym_GT] = ACTIONS(6029),
    [anon_sym_GT_EQ] = ACTIONS(6043),
    [anon_sym_CARET] = ACTIONS(6023),
    [anon_sym_PLUS] = ACTIONS(6045),
    [anon_sym_SLASH] = ACTIONS(6025),
    [anon_sym_PERCENT] = ACTIONS(6025),
    [sym_comment] = ACTIONS(87),
  },
  [6320] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6019),
    [sym__binary_star] = ACTIONS(6021),
    [ts_builtin_sym_end] = ACTIONS(5825),
    [anon_sym___END__] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(6045),
    [anon_sym_SLASH] = ACTIONS(6025),
    [anon_sym_PERCENT] = ACTIONS(6025),
    [sym_comment] = ACTIONS(87),
  },
  [6321] = {
    [sym__line_break] = ACTIONS(5735),
    [sym__heredoc_body_start] = ACTIONS(5735),
    [sym__binary_minus] = ACTIONS(5735),
    [sym__binary_star] = ACTIONS(5735),
    [ts_builtin_sym_end] = ACTIONS(5735),
    [anon_sym___END__] = ACTIONS(5735),
    [anon_sym_LBRACE] = ACTIONS(5735),
    [anon_sym_RBRACE] = ACTIONS(5735),
    [anon_sym_RPAREN] = ACTIONS(5735),
    [anon_sym_DOT] = ACTIONS(5737),
    [anon_sym_COMMA] = ACTIONS(5735),
    [anon_sym_PIPE] = ACTIONS(5737),
    [anon_sym_SEMI] = ACTIONS(5735),
    [anon_sym_STAR_STAR] = ACTIONS(5737),
    [anon_sym_AMP] = ACTIONS(5737),
    [anon_sym_EQ] = ACTIONS(5737),
    [anon_sym_LT] = ACTIONS(5737),
    [anon_sym_end] = ACTIONS(5735),
    [anon_sym_if] = ACTIONS(5735),
    [anon_sym_unless] = ACTIONS(5735),
    [anon_sym_while] = ACTIONS(5735),
    [anon_sym_until] = ACTIONS(5735),
    [anon_sym_rescue] = ACTIONS(5735),
    [anon_sym_do] = ACTIONS(5735),
    [anon_sym_when] = ACTIONS(5735),
    [anon_sym_elsif] = ACTIONS(5735),
    [anon_sym_else] = ACTIONS(5735),
    [anon_sym_then] = ACTIONS(5735),
    [anon_sym_ensure] = ACTIONS(5735),
    [anon_sym_EQ_GT] = ACTIONS(993),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_COLON_COLON2] = ACTIONS(5735),
    [anon_sym_AMP_DOT] = ACTIONS(5735),
    [anon_sym_PLUS_EQ] = ACTIONS(5735),
    [anon_sym_DASH_EQ] = ACTIONS(5735),
    [anon_sym_STAR_EQ] = ACTIONS(5735),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5735),
    [anon_sym_SLASH_EQ] = ACTIONS(5735),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5735),
    [anon_sym_PIPE_EQ] = ACTIONS(5735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5735),
    [anon_sym_AMP_EQ] = ACTIONS(5735),
    [anon_sym_PERCENT_EQ] = ACTIONS(5735),
    [anon_sym_GT_GT_EQ] = ACTIONS(5735),
    [anon_sym_LT_LT_EQ] = ACTIONS(5735),
    [anon_sym_CARET_EQ] = ACTIONS(5735),
    [anon_sym_QMARK] = ACTIONS(5735),
    [anon_sym_DOT_DOT] = ACTIONS(5737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5735),
    [anon_sym_and] = ACTIONS(5735),
    [anon_sym_or] = ACTIONS(5735),
    [anon_sym_PIPE_PIPE] = ACTIONS(5737),
    [anon_sym_AMP_AMP] = ACTIONS(5737),
    [anon_sym_LT_LT] = ACTIONS(5737),
    [anon_sym_GT_GT] = ACTIONS(5737),
    [anon_sym_EQ_EQ] = ACTIONS(5737),
    [anon_sym_BANG_EQ] = ACTIONS(5735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5735),
    [anon_sym_LT_EQ_GT] = ACTIONS(5735),
    [anon_sym_EQ_TILDE] = ACTIONS(5735),
    [anon_sym_BANG_TILDE] = ACTIONS(5735),
    [anon_sym_LT_EQ] = ACTIONS(5737),
    [anon_sym_GT] = ACTIONS(5737),
    [anon_sym_GT_EQ] = ACTIONS(5735),
    [anon_sym_CARET] = ACTIONS(5737),
    [anon_sym_PLUS] = ACTIONS(5737),
    [anon_sym_SLASH] = ACTIONS(5737),
    [anon_sym_PERCENT] = ACTIONS(5737),
    [sym_comment] = ACTIONS(87),
  },
  [6322] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(6019),
    [sym__binary_star] = ACTIONS(6021),
    [ts_builtin_sym_end] = ACTIONS(5115),
    [anon_sym___END__] = ACTIONS(5115),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(6023),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_AMP] = ACTIONS(6027),
    [anon_sym_EQ] = ACTIONS(7936),
    [anon_sym_LT] = ACTIONS(6029),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_PLUS_EQ] = ACTIONS(5115),
    [anon_sym_DASH_EQ] = ACTIONS(5115),
    [anon_sym_STAR_EQ] = ACTIONS(5115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5115),
    [anon_sym_SLASH_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5115),
    [anon_sym_AMP_EQ] = ACTIONS(5115),
    [anon_sym_PERCENT_EQ] = ACTIONS(5115),
    [anon_sym_GT_GT_EQ] = ACTIONS(5115),
    [anon_sym_LT_LT_EQ] = ACTIONS(5115),
    [anon_sym_CARET_EQ] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(6031),
    [anon_sym_DOT_DOT] = ACTIONS(6033),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6035),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(6037),
    [anon_sym_AMP_AMP] = ACTIONS(6037),
    [anon_sym_LT_LT] = ACTIONS(6039),
    [anon_sym_GT_GT] = ACTIONS(6039),
    [anon_sym_EQ_EQ] = ACTIONS(6037),
    [anon_sym_BANG_EQ] = ACTIONS(6041),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6041),
    [anon_sym_LT_EQ_GT] = ACTIONS(6041),
    [anon_sym_EQ_TILDE] = ACTIONS(6041),
    [anon_sym_BANG_TILDE] = ACTIONS(6041),
    [anon_sym_LT_EQ] = ACTIONS(6029),
    [anon_sym_GT] = ACTIONS(6029),
    [anon_sym_GT_EQ] = ACTIONS(6043),
    [anon_sym_CARET] = ACTIONS(6023),
    [anon_sym_PLUS] = ACTIONS(6045),
    [anon_sym_SLASH] = ACTIONS(6025),
    [anon_sym_PERCENT] = ACTIONS(6025),
    [sym_comment] = ACTIONS(87),
  },
  [6323] = {
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [ts_builtin_sym_end] = ACTIONS(6191),
    [anon_sym___END__] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_RBRACE] = ACTIONS(6191),
    [anon_sym_RPAREN] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6193),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_end] = ACTIONS(6191),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_when] = ACTIONS(6191),
    [anon_sym_elsif] = ACTIONS(6191),
    [anon_sym_else] = ACTIONS(6191),
    [anon_sym_then] = ACTIONS(6191),
    [anon_sym_ensure] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_PLUS_EQ] = ACTIONS(6191),
    [anon_sym_DASH_EQ] = ACTIONS(6191),
    [anon_sym_STAR_EQ] = ACTIONS(6191),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6191),
    [anon_sym_SLASH_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6191),
    [anon_sym_AMP_EQ] = ACTIONS(6191),
    [anon_sym_PERCENT_EQ] = ACTIONS(6191),
    [anon_sym_GT_GT_EQ] = ACTIONS(6191),
    [anon_sym_LT_LT_EQ] = ACTIONS(6191),
    [anon_sym_CARET_EQ] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6193),
    [anon_sym_AMP_AMP] = ACTIONS(6193),
    [anon_sym_LT_LT] = ACTIONS(6193),
    [anon_sym_GT_GT] = ACTIONS(6193),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6193),
    [anon_sym_PLUS] = ACTIONS(6193),
    [anon_sym_SLASH] = ACTIONS(6193),
    [anon_sym_PERCENT] = ACTIONS(6193),
    [sym_comment] = ACTIONS(87),
  },
  [6324] = {
    [aux_sym_exceptions_repeat1] = STATE(8630),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [ts_builtin_sym_end] = ACTIONS(6191),
    [anon_sym___END__] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6193),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_PLUS_EQ] = ACTIONS(6191),
    [anon_sym_DASH_EQ] = ACTIONS(6191),
    [anon_sym_STAR_EQ] = ACTIONS(6191),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6191),
    [anon_sym_SLASH_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6191),
    [anon_sym_AMP_EQ] = ACTIONS(6191),
    [anon_sym_PERCENT_EQ] = ACTIONS(6191),
    [anon_sym_GT_GT_EQ] = ACTIONS(6191),
    [anon_sym_LT_LT_EQ] = ACTIONS(6191),
    [anon_sym_CARET_EQ] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6193),
    [anon_sym_AMP_AMP] = ACTIONS(6193),
    [anon_sym_LT_LT] = ACTIONS(6193),
    [anon_sym_GT_GT] = ACTIONS(6193),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6193),
    [anon_sym_PLUS] = ACTIONS(6193),
    [anon_sym_SLASH] = ACTIONS(6193),
    [anon_sym_PERCENT] = ACTIONS(6193),
    [sym_comment] = ACTIONS(87),
  },
  [6325] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(6019),
    [sym__binary_star] = ACTIONS(6021),
    [ts_builtin_sym_end] = ACTIONS(6210),
    [anon_sym___END__] = ACTIONS(6210),
    [anon_sym_LBRACE] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(6023),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_AMP] = ACTIONS(6027),
    [anon_sym_EQ] = ACTIONS(7938),
    [anon_sym_LT] = ACTIONS(6029),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_PLUS_EQ] = ACTIONS(6210),
    [anon_sym_DASH_EQ] = ACTIONS(6210),
    [anon_sym_STAR_EQ] = ACTIONS(6210),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6210),
    [anon_sym_SLASH_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6210),
    [anon_sym_AMP_EQ] = ACTIONS(6210),
    [anon_sym_PERCENT_EQ] = ACTIONS(6210),
    [anon_sym_GT_GT_EQ] = ACTIONS(6210),
    [anon_sym_LT_LT_EQ] = ACTIONS(6210),
    [anon_sym_CARET_EQ] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(6031),
    [anon_sym_DOT_DOT] = ACTIONS(6033),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6035),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(6037),
    [anon_sym_AMP_AMP] = ACTIONS(6037),
    [anon_sym_LT_LT] = ACTIONS(6039),
    [anon_sym_GT_GT] = ACTIONS(6039),
    [anon_sym_EQ_EQ] = ACTIONS(6037),
    [anon_sym_BANG_EQ] = ACTIONS(6041),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6041),
    [anon_sym_LT_EQ_GT] = ACTIONS(6041),
    [anon_sym_EQ_TILDE] = ACTIONS(6041),
    [anon_sym_BANG_TILDE] = ACTIONS(6041),
    [anon_sym_LT_EQ] = ACTIONS(6029),
    [anon_sym_GT] = ACTIONS(6029),
    [anon_sym_GT_EQ] = ACTIONS(6043),
    [anon_sym_CARET] = ACTIONS(6023),
    [anon_sym_PLUS] = ACTIONS(6045),
    [anon_sym_SLASH] = ACTIONS(6025),
    [anon_sym_PERCENT] = ACTIONS(6025),
    [sym_comment] = ACTIONS(87),
  },
  [6326] = {
    [sym_string] = STATE(6326),
    [aux_sym_chained_string_repeat1] = STATE(6326),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(12267),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [ts_builtin_sym_end] = ACTIONS(6212),
    [anon_sym___END__] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6217),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_EQ] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_do] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_PLUS_EQ] = ACTIONS(6212),
    [anon_sym_DASH_EQ] = ACTIONS(6212),
    [anon_sym_STAR_EQ] = ACTIONS(6212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6212),
    [anon_sym_SLASH_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6212),
    [anon_sym_AMP_EQ] = ACTIONS(6212),
    [anon_sym_PERCENT_EQ] = ACTIONS(6212),
    [anon_sym_GT_GT_EQ] = ACTIONS(6212),
    [anon_sym_LT_LT_EQ] = ACTIONS(6212),
    [anon_sym_CARET_EQ] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6217),
    [anon_sym_AMP_AMP] = ACTIONS(6217),
    [anon_sym_LT_LT] = ACTIONS(6217),
    [anon_sym_GT_GT] = ACTIONS(6217),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6217),
    [anon_sym_PLUS] = ACTIONS(6217),
    [anon_sym_SLASH] = ACTIONS(6217),
    [anon_sym_PERCENT] = ACTIONS(6217),
    [sym_comment] = ACTIONS(87),
  },
  [6327] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(6675),
    [sym__binary_star] = ACTIONS(6677),
    [anon_sym_RBRACE] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(6679),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(6677),
    [anon_sym_AMP] = ACTIONS(6681),
    [anon_sym_LT] = ACTIONS(6683),
    [anon_sym_if] = ACTIONS(4211),
    [anon_sym_unless] = ACTIONS(4211),
    [anon_sym_while] = ACTIONS(4211),
    [anon_sym_until] = ACTIONS(4211),
    [anon_sym_rescue] = ACTIONS(4211),
    [anon_sym_EQ_GT] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(6685),
    [anon_sym_DOT_DOT] = ACTIONS(6687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6689),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(6691),
    [anon_sym_AMP_AMP] = ACTIONS(6691),
    [anon_sym_LT_LT] = ACTIONS(6693),
    [anon_sym_GT_GT] = ACTIONS(6693),
    [anon_sym_EQ_EQ] = ACTIONS(6695),
    [anon_sym_BANG_EQ] = ACTIONS(6691),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6691),
    [anon_sym_LT_EQ_GT] = ACTIONS(6691),
    [anon_sym_EQ_TILDE] = ACTIONS(6691),
    [anon_sym_BANG_TILDE] = ACTIONS(6691),
    [anon_sym_LT_EQ] = ACTIONS(6683),
    [anon_sym_GT] = ACTIONS(6683),
    [anon_sym_GT_EQ] = ACTIONS(6697),
    [anon_sym_CARET] = ACTIONS(6699),
    [anon_sym_PLUS] = ACTIONS(6675),
    [anon_sym_SLASH] = ACTIONS(6677),
    [anon_sym_PERCENT] = ACTIONS(6677),
    [sym_comment] = ACTIONS(87),
  },
  [6328] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(6675),
    [sym__binary_star] = ACTIONS(6677),
    [anon_sym_RBRACE] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(6679),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(6677),
    [anon_sym_AMP] = ACTIONS(6681),
    [anon_sym_LT] = ACTIONS(6683),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_EQ_GT] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(6685),
    [anon_sym_DOT_DOT] = ACTIONS(6687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6689),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(6691),
    [anon_sym_AMP_AMP] = ACTIONS(6691),
    [anon_sym_LT_LT] = ACTIONS(6693),
    [anon_sym_GT_GT] = ACTIONS(6693),
    [anon_sym_EQ_EQ] = ACTIONS(6695),
    [anon_sym_BANG_EQ] = ACTIONS(6691),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6691),
    [anon_sym_LT_EQ_GT] = ACTIONS(6691),
    [anon_sym_EQ_TILDE] = ACTIONS(6691),
    [anon_sym_BANG_TILDE] = ACTIONS(6691),
    [anon_sym_LT_EQ] = ACTIONS(6683),
    [anon_sym_GT] = ACTIONS(6683),
    [anon_sym_GT_EQ] = ACTIONS(6697),
    [anon_sym_CARET] = ACTIONS(6699),
    [anon_sym_PLUS] = ACTIONS(6675),
    [anon_sym_SLASH] = ACTIONS(6677),
    [anon_sym_PERCENT] = ACTIONS(6677),
    [sym_comment] = ACTIONS(87),
  },
  [6329] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8631),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1725),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1725),
    [sym_assignment] = STATE(8631),
    [sym_operator_assignment] = STATE(8631),
    [sym_conditional] = STATE(8631),
    [sym_range] = STATE(8631),
    [sym_binary] = STATE(8631),
    [sym_unary] = STATE(8631),
    [sym_left_assignment_list] = STATE(1724),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1725),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1725),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(4013),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(3111),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6669),
    [anon_sym_defined_QMARK] = ACTIONS(3123),
    [anon_sym_not] = ACTIONS(3125),
    [anon_sym_BANG] = ACTIONS(3129),
    [anon_sym_TILDE] = ACTIONS(3129),
    [sym_constant] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6330] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(6675),
    [sym__binary_star] = ACTIONS(6677),
    [anon_sym_RBRACE] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(6679),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(6677),
    [anon_sym_AMP] = ACTIONS(6681),
    [anon_sym_LT] = ACTIONS(6683),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_unless] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_until] = ACTIONS(3281),
    [anon_sym_rescue] = ACTIONS(3281),
    [anon_sym_EQ_GT] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(6685),
    [anon_sym_DOT_DOT] = ACTIONS(6687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6689),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(6691),
    [anon_sym_AMP_AMP] = ACTIONS(6691),
    [anon_sym_LT_LT] = ACTIONS(6693),
    [anon_sym_GT_GT] = ACTIONS(6693),
    [anon_sym_EQ_EQ] = ACTIONS(6695),
    [anon_sym_BANG_EQ] = ACTIONS(6691),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6691),
    [anon_sym_LT_EQ_GT] = ACTIONS(6691),
    [anon_sym_EQ_TILDE] = ACTIONS(6691),
    [anon_sym_BANG_TILDE] = ACTIONS(6691),
    [anon_sym_LT_EQ] = ACTIONS(6683),
    [anon_sym_GT] = ACTIONS(6683),
    [anon_sym_GT_EQ] = ACTIONS(6697),
    [anon_sym_CARET] = ACTIONS(6699),
    [anon_sym_PLUS] = ACTIONS(6675),
    [anon_sym_SLASH] = ACTIONS(6677),
    [anon_sym_PERCENT] = ACTIONS(6677),
    [sym_comment] = ACTIONS(87),
  },
  [6331] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8632),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1725),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1725),
    [sym_assignment] = STATE(8632),
    [sym_operator_assignment] = STATE(8632),
    [sym_conditional] = STATE(8632),
    [sym_range] = STATE(8632),
    [sym_binary] = STATE(8632),
    [sym_unary] = STATE(8632),
    [sym_left_assignment_list] = STATE(1724),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1725),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1725),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(4013),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(3111),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6669),
    [anon_sym_defined_QMARK] = ACTIONS(3123),
    [anon_sym_not] = ACTIONS(3125),
    [anon_sym_BANG] = ACTIONS(3129),
    [anon_sym_TILDE] = ACTIONS(3129),
    [sym_constant] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6332] = {
    [sym_heredoc_body] = STATE(8633),
    [aux_sym_call_repeat1] = STATE(8633),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_RBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [6333] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3657),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1725),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1725),
    [sym__argument] = STATE(2565),
    [sym_splat_argument] = STATE(2565),
    [sym_hash_splat_argument] = STATE(2565),
    [sym_block_argument] = STATE(2565),
    [sym_assignment] = STATE(3657),
    [sym_operator_assignment] = STATE(3657),
    [sym_conditional] = STATE(3657),
    [sym_range] = STATE(3657),
    [sym_binary] = STATE(3657),
    [sym_unary] = STATE(3657),
    [sym_left_assignment_list] = STATE(1724),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1725),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1725),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3660),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(8634),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2565),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(6057),
    [sym__splat_star] = ACTIONS(6059),
    [sym__unary_minus] = ACTIONS(3111),
    [sym__identifier_hash_key] = ACTIONS(6061),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12270),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6669),
    [anon_sym_defined_QMARK] = ACTIONS(3123),
    [anon_sym_not] = ACTIONS(3125),
    [anon_sym_BANG] = ACTIONS(3129),
    [anon_sym_TILDE] = ACTIONS(3129),
    [sym_constant] = ACTIONS(6063),
    [sym_identifier] = ACTIONS(6063),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6334] = {
    [sym_heredoc_body] = STATE(8635),
    [aux_sym_call_repeat1] = STATE(8635),
    [aux_sym_argument_list_repeat1] = STATE(8636),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_RBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [6335] = {
    [sym__line_break] = ACTIONS(12029),
    [sym__heredoc_body_start] = ACTIONS(12029),
    [sym__binary_minus] = ACTIONS(12029),
    [sym__binary_star] = ACTIONS(12029),
    [ts_builtin_sym_end] = ACTIONS(12029),
    [anon_sym___END__] = ACTIONS(12029),
    [anon_sym_LBRACE] = ACTIONS(12029),
    [anon_sym_RBRACE] = ACTIONS(12029),
    [anon_sym_RPAREN] = ACTIONS(12029),
    [anon_sym_DOT] = ACTIONS(12031),
    [anon_sym_COMMA] = ACTIONS(12029),
    [anon_sym_PIPE] = ACTIONS(12031),
    [anon_sym_SEMI] = ACTIONS(12029),
    [anon_sym_STAR_STAR] = ACTIONS(12031),
    [anon_sym_AMP] = ACTIONS(12031),
    [anon_sym_EQ] = ACTIONS(12031),
    [anon_sym_LT] = ACTIONS(12031),
    [anon_sym_end] = ACTIONS(12029),
    [anon_sym_if] = ACTIONS(12029),
    [anon_sym_unless] = ACTIONS(12029),
    [anon_sym_while] = ACTIONS(12029),
    [anon_sym_until] = ACTIONS(12029),
    [anon_sym_rescue] = ACTIONS(12029),
    [anon_sym_do] = ACTIONS(12029),
    [anon_sym_when] = ACTIONS(12029),
    [anon_sym_elsif] = ACTIONS(12029),
    [anon_sym_else] = ACTIONS(12029),
    [anon_sym_then] = ACTIONS(12029),
    [anon_sym_ensure] = ACTIONS(12029),
    [anon_sym_LBRACK] = ACTIONS(12029),
    [anon_sym_COLON_COLON2] = ACTIONS(12029),
    [anon_sym_AMP_DOT] = ACTIONS(12029),
    [anon_sym_PLUS_EQ] = ACTIONS(12029),
    [anon_sym_DASH_EQ] = ACTIONS(12029),
    [anon_sym_STAR_EQ] = ACTIONS(12029),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12029),
    [anon_sym_SLASH_EQ] = ACTIONS(12029),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12029),
    [anon_sym_PIPE_EQ] = ACTIONS(12029),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12029),
    [anon_sym_AMP_EQ] = ACTIONS(12029),
    [anon_sym_PERCENT_EQ] = ACTIONS(12029),
    [anon_sym_GT_GT_EQ] = ACTIONS(12029),
    [anon_sym_LT_LT_EQ] = ACTIONS(12029),
    [anon_sym_CARET_EQ] = ACTIONS(12029),
    [anon_sym_QMARK] = ACTIONS(12029),
    [anon_sym_DOT_DOT] = ACTIONS(12031),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12029),
    [anon_sym_and] = ACTIONS(12029),
    [anon_sym_or] = ACTIONS(12029),
    [anon_sym_PIPE_PIPE] = ACTIONS(12031),
    [anon_sym_AMP_AMP] = ACTIONS(12031),
    [anon_sym_LT_LT] = ACTIONS(12031),
    [anon_sym_GT_GT] = ACTIONS(12031),
    [anon_sym_EQ_EQ] = ACTIONS(12031),
    [anon_sym_BANG_EQ] = ACTIONS(12029),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12029),
    [anon_sym_LT_EQ_GT] = ACTIONS(12029),
    [anon_sym_EQ_TILDE] = ACTIONS(12029),
    [anon_sym_BANG_TILDE] = ACTIONS(12029),
    [anon_sym_LT_EQ] = ACTIONS(12031),
    [anon_sym_GT] = ACTIONS(12031),
    [anon_sym_GT_EQ] = ACTIONS(12029),
    [anon_sym_CARET] = ACTIONS(12031),
    [anon_sym_PLUS] = ACTIONS(12031),
    [anon_sym_SLASH] = ACTIONS(12031),
    [anon_sym_PERCENT] = ACTIONS(12031),
    [sym_comment] = ACTIONS(87),
  },
  [6336] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(6069),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(6069),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(6069),
    [anon_sym_PERCENT] = ACTIONS(6069),
    [sym_comment] = ACTIONS(87),
  },
  [6337] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(6069),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [6338] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6067),
    [sym__binary_star] = ACTIONS(6069),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(6069),
    [anon_sym_AMP] = ACTIONS(6073),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(6087),
    [anon_sym_GT_GT] = ACTIONS(6087),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(6067),
    [anon_sym_SLASH] = ACTIONS(6069),
    [anon_sym_PERCENT] = ACTIONS(6069),
    [sym_comment] = ACTIONS(87),
  },
  [6339] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6067),
    [sym__binary_star] = ACTIONS(6069),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(6069),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(6087),
    [anon_sym_GT_GT] = ACTIONS(6087),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(6067),
    [anon_sym_SLASH] = ACTIONS(6069),
    [anon_sym_PERCENT] = ACTIONS(6069),
    [sym_comment] = ACTIONS(87),
  },
  [6340] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6067),
    [sym__binary_star] = ACTIONS(6069),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(6071),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(6069),
    [anon_sym_AMP] = ACTIONS(6073),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(6087),
    [anon_sym_GT_GT] = ACTIONS(6087),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(6093),
    [anon_sym_PLUS] = ACTIONS(6067),
    [anon_sym_SLASH] = ACTIONS(6069),
    [anon_sym_PERCENT] = ACTIONS(6069),
    [sym_comment] = ACTIONS(87),
  },
  [6341] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(12272),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [6342] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(6067),
    [sym__binary_star] = ACTIONS(6069),
    [anon_sym_RBRACE] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(6071),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(6069),
    [anon_sym_AMP] = ACTIONS(6073),
    [anon_sym_LT] = ACTIONS(6075),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_EQ_GT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(6079),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6081),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(6085),
    [anon_sym_AMP_AMP] = ACTIONS(6085),
    [anon_sym_LT_LT] = ACTIONS(6087),
    [anon_sym_GT_GT] = ACTIONS(6087),
    [anon_sym_EQ_EQ] = ACTIONS(6089),
    [anon_sym_BANG_EQ] = ACTIONS(6085),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6085),
    [anon_sym_LT_EQ_GT] = ACTIONS(6085),
    [anon_sym_EQ_TILDE] = ACTIONS(6085),
    [anon_sym_BANG_TILDE] = ACTIONS(6085),
    [anon_sym_LT_EQ] = ACTIONS(6075),
    [anon_sym_GT] = ACTIONS(6075),
    [anon_sym_GT_EQ] = ACTIONS(6091),
    [anon_sym_CARET] = ACTIONS(6093),
    [anon_sym_PLUS] = ACTIONS(6067),
    [anon_sym_SLASH] = ACTIONS(6069),
    [anon_sym_PERCENT] = ACTIONS(6069),
    [sym_comment] = ACTIONS(87),
  },
  [6343] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6067),
    [sym__binary_star] = ACTIONS(6069),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(6071),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(6069),
    [anon_sym_AMP] = ACTIONS(6073),
    [anon_sym_LT] = ACTIONS(6075),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(6077),
    [anon_sym_DOT_DOT] = ACTIONS(6079),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6081),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(6085),
    [anon_sym_AMP_AMP] = ACTIONS(6085),
    [anon_sym_LT_LT] = ACTIONS(6087),
    [anon_sym_GT_GT] = ACTIONS(6087),
    [anon_sym_EQ_EQ] = ACTIONS(6089),
    [anon_sym_BANG_EQ] = ACTIONS(6085),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6085),
    [anon_sym_LT_EQ_GT] = ACTIONS(6085),
    [anon_sym_EQ_TILDE] = ACTIONS(6085),
    [anon_sym_BANG_TILDE] = ACTIONS(6085),
    [anon_sym_LT_EQ] = ACTIONS(6075),
    [anon_sym_GT] = ACTIONS(6075),
    [anon_sym_GT_EQ] = ACTIONS(6091),
    [anon_sym_CARET] = ACTIONS(6093),
    [anon_sym_PLUS] = ACTIONS(6067),
    [anon_sym_SLASH] = ACTIONS(6069),
    [anon_sym_PERCENT] = ACTIONS(6069),
    [sym_comment] = ACTIONS(87),
  },
  [6344] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6067),
    [sym__binary_star] = ACTIONS(6069),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(6071),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(6069),
    [anon_sym_AMP] = ACTIONS(6073),
    [anon_sym_LT] = ACTIONS(6075),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(6087),
    [anon_sym_GT_GT] = ACTIONS(6087),
    [anon_sym_EQ_EQ] = ACTIONS(6089),
    [anon_sym_BANG_EQ] = ACTIONS(6085),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6085),
    [anon_sym_LT_EQ_GT] = ACTIONS(6085),
    [anon_sym_EQ_TILDE] = ACTIONS(6085),
    [anon_sym_BANG_TILDE] = ACTIONS(6085),
    [anon_sym_LT_EQ] = ACTIONS(6075),
    [anon_sym_GT] = ACTIONS(6075),
    [anon_sym_GT_EQ] = ACTIONS(6091),
    [anon_sym_CARET] = ACTIONS(6093),
    [anon_sym_PLUS] = ACTIONS(6067),
    [anon_sym_SLASH] = ACTIONS(6069),
    [anon_sym_PERCENT] = ACTIONS(6069),
    [sym_comment] = ACTIONS(87),
  },
  [6345] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6067),
    [sym__binary_star] = ACTIONS(6069),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(6069),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(6067),
    [anon_sym_SLASH] = ACTIONS(6069),
    [anon_sym_PERCENT] = ACTIONS(6069),
    [sym_comment] = ACTIONS(87),
  },
  [6346] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(6741),
    [sym__binary_star] = ACTIONS(6743),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_RBRACE] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(6747),
    [anon_sym_AMP] = ACTIONS(6749),
    [anon_sym_EQ] = ACTIONS(4217),
    [anon_sym_LT] = ACTIONS(6751),
    [anon_sym_if] = ACTIONS(4211),
    [anon_sym_unless] = ACTIONS(4211),
    [anon_sym_while] = ACTIONS(4211),
    [anon_sym_until] = ACTIONS(4211),
    [anon_sym_rescue] = ACTIONS(4211),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_EQ_GT] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_PLUS_EQ] = ACTIONS(4211),
    [anon_sym_DASH_EQ] = ACTIONS(4211),
    [anon_sym_STAR_EQ] = ACTIONS(4211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4211),
    [anon_sym_SLASH_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4211),
    [anon_sym_AMP_EQ] = ACTIONS(4211),
    [anon_sym_PERCENT_EQ] = ACTIONS(4211),
    [anon_sym_GT_GT_EQ] = ACTIONS(4211),
    [anon_sym_LT_LT_EQ] = ACTIONS(4211),
    [anon_sym_CARET_EQ] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(6753),
    [anon_sym_DOT_DOT] = ACTIONS(6755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6757),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(6759),
    [anon_sym_AMP_AMP] = ACTIONS(6759),
    [anon_sym_LT_LT] = ACTIONS(6761),
    [anon_sym_GT_GT] = ACTIONS(6761),
    [anon_sym_EQ_EQ] = ACTIONS(6759),
    [anon_sym_BANG_EQ] = ACTIONS(6763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6763),
    [anon_sym_LT_EQ_GT] = ACTIONS(6763),
    [anon_sym_EQ_TILDE] = ACTIONS(6763),
    [anon_sym_BANG_TILDE] = ACTIONS(6763),
    [anon_sym_LT_EQ] = ACTIONS(6751),
    [anon_sym_GT] = ACTIONS(6751),
    [anon_sym_GT_EQ] = ACTIONS(6765),
    [anon_sym_CARET] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6767),
    [anon_sym_SLASH] = ACTIONS(6747),
    [anon_sym_PERCENT] = ACTIONS(6747),
    [sym_comment] = ACTIONS(87),
  },
  [6347] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(6741),
    [sym__binary_star] = ACTIONS(6743),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_RBRACE] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(6747),
    [anon_sym_AMP] = ACTIONS(6749),
    [anon_sym_EQ] = ACTIONS(4249),
    [anon_sym_LT] = ACTIONS(6751),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_EQ_GT] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_PLUS_EQ] = ACTIONS(4247),
    [anon_sym_DASH_EQ] = ACTIONS(4247),
    [anon_sym_STAR_EQ] = ACTIONS(4247),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4247),
    [anon_sym_SLASH_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4247),
    [anon_sym_AMP_EQ] = ACTIONS(4247),
    [anon_sym_PERCENT_EQ] = ACTIONS(4247),
    [anon_sym_GT_GT_EQ] = ACTIONS(4247),
    [anon_sym_LT_LT_EQ] = ACTIONS(4247),
    [anon_sym_CARET_EQ] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(6753),
    [anon_sym_DOT_DOT] = ACTIONS(6755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6757),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(6759),
    [anon_sym_AMP_AMP] = ACTIONS(6759),
    [anon_sym_LT_LT] = ACTIONS(6761),
    [anon_sym_GT_GT] = ACTIONS(6761),
    [anon_sym_EQ_EQ] = ACTIONS(6759),
    [anon_sym_BANG_EQ] = ACTIONS(6763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6763),
    [anon_sym_LT_EQ_GT] = ACTIONS(6763),
    [anon_sym_EQ_TILDE] = ACTIONS(6763),
    [anon_sym_BANG_TILDE] = ACTIONS(6763),
    [anon_sym_LT_EQ] = ACTIONS(6751),
    [anon_sym_GT] = ACTIONS(6751),
    [anon_sym_GT_EQ] = ACTIONS(6765),
    [anon_sym_CARET] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6767),
    [anon_sym_SLASH] = ACTIONS(6747),
    [anon_sym_PERCENT] = ACTIONS(6747),
    [sym_comment] = ACTIONS(87),
  },
  [6348] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8638),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1762),
    [sym_scope_resolution] = STATE(1758),
    [sym_call] = STATE(1758),
    [sym_method_call] = STATE(1762),
    [sym_assignment] = STATE(8638),
    [sym_operator_assignment] = STATE(8638),
    [sym_conditional] = STATE(8638),
    [sym_range] = STATE(8638),
    [sym_binary] = STATE(8638),
    [sym_unary] = STATE(8638),
    [sym_left_assignment_list] = STATE(1761),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1762),
    [sym__variable] = STATE(1758),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1762),
    [sym_false] = STATE(1762),
    [sym_nil] = STATE(1762),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(4066),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(3179),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(3183),
    [anon_sym_yield] = ACTIONS(3185),
    [anon_sym_break] = ACTIONS(3187),
    [anon_sym_next] = ACTIONS(3189),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(6735),
    [anon_sym_defined_QMARK] = ACTIONS(3191),
    [anon_sym_not] = ACTIONS(3193),
    [anon_sym_BANG] = ACTIONS(3197),
    [anon_sym_TILDE] = ACTIONS(3197),
    [sym_constant] = ACTIONS(3203),
    [sym_identifier] = ACTIONS(3203),
    [sym_instance_variable] = ACTIONS(3201),
    [sym_class_variable] = ACTIONS(3201),
    [sym_global_variable] = ACTIONS(3201),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(3203),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(3203),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [6349] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(6741),
    [sym__binary_star] = ACTIONS(6743),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_RBRACE] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(6747),
    [anon_sym_AMP] = ACTIONS(6749),
    [anon_sym_EQ] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(6751),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_unless] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_until] = ACTIONS(3281),
    [anon_sym_rescue] = ACTIONS(3281),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_EQ_GT] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_PLUS_EQ] = ACTIONS(3281),
    [anon_sym_DASH_EQ] = ACTIONS(3281),
    [anon_sym_STAR_EQ] = ACTIONS(3281),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3281),
    [anon_sym_SLASH_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3281),
    [anon_sym_AMP_EQ] = ACTIONS(3281),
    [anon_sym_PERCENT_EQ] = ACTIONS(3281),
    [anon_sym_GT_GT_EQ] = ACTIONS(3281),
    [anon_sym_LT_LT_EQ] = ACTIONS(3281),
    [anon_sym_CARET_EQ] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(6753),
    [anon_sym_DOT_DOT] = ACTIONS(6755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6757),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(6759),
    [anon_sym_AMP_AMP] = ACTIONS(6759),
    [anon_sym_LT_LT] = ACTIONS(6761),
    [anon_sym_GT_GT] = ACTIONS(6761),
    [anon_sym_EQ_EQ] = ACTIONS(6759),
    [anon_sym_BANG_EQ] = ACTIONS(6763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6763),
    [anon_sym_LT_EQ_GT] = ACTIONS(6763),
    [anon_sym_EQ_TILDE] = ACTIONS(6763),
    [anon_sym_BANG_TILDE] = ACTIONS(6763),
    [anon_sym_LT_EQ] = ACTIONS(6751),
    [anon_sym_GT] = ACTIONS(6751),
    [anon_sym_GT_EQ] = ACTIONS(6765),
    [anon_sym_CARET] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6767),
    [anon_sym_SLASH] = ACTIONS(6747),
    [anon_sym_PERCENT] = ACTIONS(6747),
    [sym_comment] = ACTIONS(87),
  },
  [6350] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8639),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1762),
    [sym_scope_resolution] = STATE(1758),
    [sym_call] = STATE(1758),
    [sym_method_call] = STATE(1762),
    [sym_assignment] = STATE(8639),
    [sym_operator_assignment] = STATE(8639),
    [sym_conditional] = STATE(8639),
    [sym_range] = STATE(8639),
    [sym_binary] = STATE(8639),
    [sym_unary] = STATE(8639),
    [sym_left_assignment_list] = STATE(1761),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1762),
    [sym__variable] = STATE(1758),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1762),
    [sym_false] = STATE(1762),
    [sym_nil] = STATE(1762),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(4066),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(3179),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(3183),
    [anon_sym_yield] = ACTIONS(3185),
    [anon_sym_break] = ACTIONS(3187),
    [anon_sym_next] = ACTIONS(3189),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(6735),
    [anon_sym_defined_QMARK] = ACTIONS(3191),
    [anon_sym_not] = ACTIONS(3193),
    [anon_sym_BANG] = ACTIONS(3197),
    [anon_sym_TILDE] = ACTIONS(3197),
    [sym_constant] = ACTIONS(3203),
    [sym_identifier] = ACTIONS(3203),
    [sym_instance_variable] = ACTIONS(3201),
    [sym_class_variable] = ACTIONS(3201),
    [sym_global_variable] = ACTIONS(3201),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(3203),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(3203),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [6351] = {
    [sym_heredoc_body] = STATE(8640),
    [aux_sym_call_repeat1] = STATE(8640),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_RBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [6352] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3679),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1762),
    [sym_scope_resolution] = STATE(1758),
    [sym_call] = STATE(1758),
    [sym_method_call] = STATE(1762),
    [sym__argument] = STATE(4979),
    [sym_splat_argument] = STATE(4979),
    [sym_hash_splat_argument] = STATE(4979),
    [sym_block_argument] = STATE(4979),
    [sym_assignment] = STATE(3679),
    [sym_operator_assignment] = STATE(3679),
    [sym_conditional] = STATE(3679),
    [sym_range] = STATE(3679),
    [sym_binary] = STATE(3679),
    [sym_unary] = STATE(3679),
    [sym_left_assignment_list] = STATE(1761),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1762),
    [sym__variable] = STATE(1758),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1762),
    [sym_false] = STATE(1762),
    [sym_nil] = STATE(1762),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3682),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_heredoc_body] = STATE(8641),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(4979),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(6095),
    [sym__splat_star] = ACTIONS(6097),
    [sym__unary_minus] = ACTIONS(3179),
    [sym__identifier_hash_key] = ACTIONS(6099),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12274),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(3183),
    [anon_sym_yield] = ACTIONS(3185),
    [anon_sym_break] = ACTIONS(3187),
    [anon_sym_next] = ACTIONS(3189),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(6735),
    [anon_sym_defined_QMARK] = ACTIONS(3191),
    [anon_sym_not] = ACTIONS(3193),
    [anon_sym_BANG] = ACTIONS(3197),
    [anon_sym_TILDE] = ACTIONS(3197),
    [sym_constant] = ACTIONS(6101),
    [sym_identifier] = ACTIONS(6101),
    [sym_instance_variable] = ACTIONS(3201),
    [sym_class_variable] = ACTIONS(3201),
    [sym_global_variable] = ACTIONS(3201),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(3203),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(3203),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [6353] = {
    [sym_heredoc_body] = STATE(8642),
    [aux_sym_call_repeat1] = STATE(8642),
    [aux_sym_argument_list_repeat1] = STATE(8643),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_RBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(9784),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [6354] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8644),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(6361),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(6361),
    [sym_assignment] = STATE(8644),
    [sym_operator_assignment] = STATE(8644),
    [sym_conditional] = STATE(8644),
    [sym_range] = STATE(8644),
    [sym_binary] = STATE(8644),
    [sym_unary] = STATE(8644),
    [sym_left_assignment_list] = STATE(6360),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6361),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(6361),
    [sym_false] = STATE(6361),
    [sym_nil] = STATE(6361),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(4013),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(9790),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9792),
    [anon_sym_defined_QMARK] = ACTIONS(9794),
    [anon_sym_not] = ACTIONS(9796),
    [anon_sym_BANG] = ACTIONS(9798),
    [anon_sym_TILDE] = ACTIONS(9798),
    [sym_constant] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6355] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8645),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(6361),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(6361),
    [sym_assignment] = STATE(8645),
    [sym_operator_assignment] = STATE(8645),
    [sym_conditional] = STATE(8645),
    [sym_range] = STATE(8645),
    [sym_binary] = STATE(8645),
    [sym_unary] = STATE(8645),
    [sym_left_assignment_list] = STATE(6360),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6361),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(6361),
    [sym_false] = STATE(6361),
    [sym_nil] = STATE(6361),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(4013),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(9790),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9792),
    [anon_sym_defined_QMARK] = ACTIONS(9794),
    [anon_sym_not] = ACTIONS(9796),
    [anon_sym_BANG] = ACTIONS(9798),
    [anon_sym_TILDE] = ACTIONS(9798),
    [sym_constant] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6356] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8646),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(6361),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(6361),
    [sym_assignment] = STATE(8646),
    [sym_operator_assignment] = STATE(8646),
    [sym_conditional] = STATE(8646),
    [sym_range] = STATE(8646),
    [sym_binary] = STATE(8646),
    [sym_unary] = STATE(8646),
    [sym_left_assignment_list] = STATE(6360),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6361),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(6361),
    [sym_false] = STATE(6361),
    [sym_nil] = STATE(6361),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(4013),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(9790),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9792),
    [anon_sym_defined_QMARK] = ACTIONS(9794),
    [anon_sym_not] = ACTIONS(9796),
    [anon_sym_BANG] = ACTIONS(9798),
    [anon_sym_TILDE] = ACTIONS(9798),
    [sym_constant] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6357] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(298),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(6361),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(6361),
    [sym_assignment] = STATE(298),
    [sym_operator_assignment] = STATE(298),
    [sym_conditional] = STATE(298),
    [sym_range] = STATE(298),
    [sym_binary] = STATE(298),
    [sym_unary] = STATE(298),
    [sym_left_assignment_list] = STATE(6360),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6361),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(6361),
    [sym_false] = STATE(6361),
    [sym_nil] = STATE(6361),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(4013),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(9790),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9792),
    [anon_sym_defined_QMARK] = ACTIONS(9794),
    [anon_sym_not] = ACTIONS(9796),
    [anon_sym_BANG] = ACTIONS(9798),
    [anon_sym_TILDE] = ACTIONS(9798),
    [sym_constant] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6358] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(12276),
    [sym__binary_star] = ACTIONS(12278),
    [anon_sym_RBRACE] = ACTIONS(5115),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(12280),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(12278),
    [anon_sym_AMP] = ACTIONS(12282),
    [anon_sym_LT] = ACTIONS(12284),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_EQ_GT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(12286),
    [anon_sym_DOT_DOT] = ACTIONS(12288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12290),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(12292),
    [anon_sym_AMP_AMP] = ACTIONS(12292),
    [anon_sym_LT_LT] = ACTIONS(12294),
    [anon_sym_GT_GT] = ACTIONS(12294),
    [anon_sym_EQ_EQ] = ACTIONS(12296),
    [anon_sym_BANG_EQ] = ACTIONS(12292),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12292),
    [anon_sym_LT_EQ_GT] = ACTIONS(12292),
    [anon_sym_EQ_TILDE] = ACTIONS(12292),
    [anon_sym_BANG_TILDE] = ACTIONS(12292),
    [anon_sym_LT_EQ] = ACTIONS(12284),
    [anon_sym_GT] = ACTIONS(12284),
    [anon_sym_GT_EQ] = ACTIONS(12298),
    [anon_sym_CARET] = ACTIONS(12300),
    [anon_sym_PLUS] = ACTIONS(12276),
    [anon_sym_SLASH] = ACTIONS(12278),
    [anon_sym_PERCENT] = ACTIONS(12278),
    [sym_comment] = ACTIONS(87),
  },
  [6359] = {
    [aux_sym_exceptions_repeat1] = STATE(8658),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_RBRACE] = ACTIONS(6191),
    [anon_sym_COMMA] = ACTIONS(12302),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [6360] = {
    [anon_sym_EQ] = ACTIONS(12304),
    [sym_comment] = ACTIONS(87),
  },
  [6361] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(12306),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(12308),
    [anon_sym_DASH_EQ] = ACTIONS(12308),
    [anon_sym_STAR_EQ] = ACTIONS(12308),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12308),
    [anon_sym_SLASH_EQ] = ACTIONS(12308),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12308),
    [anon_sym_PIPE_EQ] = ACTIONS(12308),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12308),
    [anon_sym_AMP_EQ] = ACTIONS(12308),
    [anon_sym_PERCENT_EQ] = ACTIONS(12308),
    [anon_sym_GT_GT_EQ] = ACTIONS(12308),
    [anon_sym_LT_LT_EQ] = ACTIONS(12308),
    [anon_sym_CARET_EQ] = ACTIONS(12308),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [6362] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(6067),
    [sym__binary_star] = ACTIONS(6069),
    [anon_sym_RBRACE] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(6071),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(6069),
    [anon_sym_AMP] = ACTIONS(6073),
    [anon_sym_LT] = ACTIONS(6075),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_EQ_GT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(6077),
    [anon_sym_DOT_DOT] = ACTIONS(6079),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6081),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(6085),
    [anon_sym_AMP_AMP] = ACTIONS(6085),
    [anon_sym_LT_LT] = ACTIONS(6087),
    [anon_sym_GT_GT] = ACTIONS(6087),
    [anon_sym_EQ_EQ] = ACTIONS(6089),
    [anon_sym_BANG_EQ] = ACTIONS(6085),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6085),
    [anon_sym_LT_EQ_GT] = ACTIONS(6085),
    [anon_sym_EQ_TILDE] = ACTIONS(6085),
    [anon_sym_BANG_TILDE] = ACTIONS(6085),
    [anon_sym_LT_EQ] = ACTIONS(6075),
    [anon_sym_GT] = ACTIONS(6075),
    [anon_sym_GT_EQ] = ACTIONS(6091),
    [anon_sym_CARET] = ACTIONS(6093),
    [anon_sym_PLUS] = ACTIONS(6067),
    [anon_sym_SLASH] = ACTIONS(6069),
    [anon_sym_PERCENT] = ACTIONS(6069),
    [sym_comment] = ACTIONS(87),
  },
  [6363] = {
    [sym_string] = STATE(6363),
    [aux_sym_chained_string_repeat1] = STATE(6363),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(6214),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_RBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_EQ_GT] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [6364] = {
    [sym__line_break] = ACTIONS(7162),
    [sym__heredoc_body_start] = ACTIONS(7162),
    [sym__binary_minus] = ACTIONS(7162),
    [sym__binary_star] = ACTIONS(7162),
    [ts_builtin_sym_end] = ACTIONS(7162),
    [anon_sym___END__] = ACTIONS(7162),
    [anon_sym_LBRACE] = ACTIONS(7162),
    [anon_sym_RBRACE] = ACTIONS(7162),
    [anon_sym_RPAREN] = ACTIONS(7162),
    [anon_sym_DOT] = ACTIONS(7164),
    [anon_sym_COMMA] = ACTIONS(7162),
    [anon_sym_PIPE] = ACTIONS(7164),
    [anon_sym_SEMI] = ACTIONS(7162),
    [anon_sym_STAR_STAR] = ACTIONS(7164),
    [anon_sym_AMP] = ACTIONS(7164),
    [anon_sym_EQ] = ACTIONS(7164),
    [anon_sym_LT] = ACTIONS(7164),
    [anon_sym_end] = ACTIONS(7162),
    [anon_sym_if] = ACTIONS(7162),
    [anon_sym_unless] = ACTIONS(7162),
    [anon_sym_while] = ACTIONS(7162),
    [anon_sym_until] = ACTIONS(7162),
    [anon_sym_rescue] = ACTIONS(7162),
    [anon_sym_do] = ACTIONS(7162),
    [anon_sym_when] = ACTIONS(7162),
    [anon_sym_elsif] = ACTIONS(7162),
    [anon_sym_else] = ACTIONS(7162),
    [anon_sym_then] = ACTIONS(7162),
    [anon_sym_ensure] = ACTIONS(7162),
    [anon_sym_EQ_GT] = ACTIONS(7162),
    [anon_sym_LBRACK] = ACTIONS(7162),
    [anon_sym_COLON_COLON2] = ACTIONS(7162),
    [anon_sym_AMP_DOT] = ACTIONS(7162),
    [anon_sym_PLUS_EQ] = ACTIONS(7162),
    [anon_sym_DASH_EQ] = ACTIONS(7162),
    [anon_sym_STAR_EQ] = ACTIONS(7162),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7162),
    [anon_sym_SLASH_EQ] = ACTIONS(7162),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7162),
    [anon_sym_PIPE_EQ] = ACTIONS(7162),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7162),
    [anon_sym_AMP_EQ] = ACTIONS(7162),
    [anon_sym_PERCENT_EQ] = ACTIONS(7162),
    [anon_sym_GT_GT_EQ] = ACTIONS(7162),
    [anon_sym_LT_LT_EQ] = ACTIONS(7162),
    [anon_sym_CARET_EQ] = ACTIONS(7162),
    [anon_sym_QMARK] = ACTIONS(7162),
    [anon_sym_DOT_DOT] = ACTIONS(7164),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7162),
    [anon_sym_and] = ACTIONS(7162),
    [anon_sym_or] = ACTIONS(7162),
    [anon_sym_PIPE_PIPE] = ACTIONS(7164),
    [anon_sym_AMP_AMP] = ACTIONS(7164),
    [anon_sym_LT_LT] = ACTIONS(7164),
    [anon_sym_GT_GT] = ACTIONS(7164),
    [anon_sym_EQ_EQ] = ACTIONS(7164),
    [anon_sym_BANG_EQ] = ACTIONS(7162),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7162),
    [anon_sym_LT_EQ_GT] = ACTIONS(7162),
    [anon_sym_EQ_TILDE] = ACTIONS(7162),
    [anon_sym_BANG_TILDE] = ACTIONS(7162),
    [anon_sym_LT_EQ] = ACTIONS(7164),
    [anon_sym_GT] = ACTIONS(7164),
    [anon_sym_GT_EQ] = ACTIONS(7162),
    [anon_sym_CARET] = ACTIONS(7164),
    [anon_sym_PLUS] = ACTIONS(7164),
    [anon_sym_SLASH] = ACTIONS(7164),
    [anon_sym_PERCENT] = ACTIONS(7164),
    [sym_comment] = ACTIONS(87),
  },
  [6365] = {
    [anon_sym_DOT] = ACTIONS(12310),
    [anon_sym_COLON_COLON] = ACTIONS(12310),
    [sym_comment] = ACTIONS(87),
  },
  [6366] = {
    [sym__line_break] = ACTIONS(7314),
    [sym__heredoc_body_start] = ACTIONS(7314),
    [sym__binary_minus] = ACTIONS(7314),
    [sym__binary_star] = ACTIONS(7314),
    [ts_builtin_sym_end] = ACTIONS(7314),
    [anon_sym___END__] = ACTIONS(7314),
    [anon_sym_LBRACE] = ACTIONS(7314),
    [anon_sym_RBRACE] = ACTIONS(7314),
    [anon_sym_RPAREN] = ACTIONS(7314),
    [anon_sym_DOT] = ACTIONS(7316),
    [anon_sym_COMMA] = ACTIONS(7314),
    [anon_sym_PIPE] = ACTIONS(7316),
    [anon_sym_SEMI] = ACTIONS(7314),
    [anon_sym_STAR_STAR] = ACTIONS(7316),
    [anon_sym_AMP] = ACTIONS(7316),
    [anon_sym_EQ] = ACTIONS(7316),
    [anon_sym_LT] = ACTIONS(7316),
    [anon_sym_end] = ACTIONS(7314),
    [anon_sym_if] = ACTIONS(7314),
    [anon_sym_unless] = ACTIONS(7314),
    [anon_sym_while] = ACTIONS(7314),
    [anon_sym_until] = ACTIONS(7314),
    [anon_sym_rescue] = ACTIONS(7314),
    [anon_sym_do] = ACTIONS(7314),
    [anon_sym_when] = ACTIONS(7314),
    [anon_sym_elsif] = ACTIONS(7314),
    [anon_sym_else] = ACTIONS(7314),
    [anon_sym_then] = ACTIONS(7314),
    [anon_sym_ensure] = ACTIONS(7314),
    [anon_sym_EQ_GT] = ACTIONS(7314),
    [anon_sym_LBRACK] = ACTIONS(7314),
    [anon_sym_COLON_COLON2] = ACTIONS(7314),
    [anon_sym_AMP_DOT] = ACTIONS(7314),
    [anon_sym_PLUS_EQ] = ACTIONS(7314),
    [anon_sym_DASH_EQ] = ACTIONS(7314),
    [anon_sym_STAR_EQ] = ACTIONS(7314),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7314),
    [anon_sym_SLASH_EQ] = ACTIONS(7314),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7314),
    [anon_sym_PIPE_EQ] = ACTIONS(7314),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7314),
    [anon_sym_AMP_EQ] = ACTIONS(7314),
    [anon_sym_PERCENT_EQ] = ACTIONS(7314),
    [anon_sym_GT_GT_EQ] = ACTIONS(7314),
    [anon_sym_LT_LT_EQ] = ACTIONS(7314),
    [anon_sym_CARET_EQ] = ACTIONS(7314),
    [anon_sym_QMARK] = ACTIONS(7314),
    [anon_sym_DOT_DOT] = ACTIONS(7316),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7314),
    [anon_sym_and] = ACTIONS(7314),
    [anon_sym_or] = ACTIONS(7314),
    [anon_sym_PIPE_PIPE] = ACTIONS(7316),
    [anon_sym_AMP_AMP] = ACTIONS(7316),
    [anon_sym_LT_LT] = ACTIONS(7316),
    [anon_sym_GT_GT] = ACTIONS(7316),
    [anon_sym_EQ_EQ] = ACTIONS(7316),
    [anon_sym_BANG_EQ] = ACTIONS(7314),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7314),
    [anon_sym_LT_EQ_GT] = ACTIONS(7314),
    [anon_sym_EQ_TILDE] = ACTIONS(7314),
    [anon_sym_BANG_TILDE] = ACTIONS(7314),
    [anon_sym_LT_EQ] = ACTIONS(7316),
    [anon_sym_GT] = ACTIONS(7316),
    [anon_sym_GT_EQ] = ACTIONS(7314),
    [anon_sym_CARET] = ACTIONS(7316),
    [anon_sym_PLUS] = ACTIONS(7316),
    [anon_sym_SLASH] = ACTIONS(7316),
    [anon_sym_PERCENT] = ACTIONS(7316),
    [sym_comment] = ACTIONS(87),
  },
  [6367] = {
    [sym__line_break] = ACTIONS(7330),
    [sym__heredoc_body_start] = ACTIONS(7330),
    [sym__binary_minus] = ACTIONS(7330),
    [sym__binary_star] = ACTIONS(7330),
    [ts_builtin_sym_end] = ACTIONS(7330),
    [anon_sym___END__] = ACTIONS(7330),
    [anon_sym_LBRACE] = ACTIONS(7330),
    [anon_sym_RBRACE] = ACTIONS(7330),
    [anon_sym_RPAREN] = ACTIONS(7330),
    [anon_sym_DOT] = ACTIONS(7332),
    [anon_sym_COMMA] = ACTIONS(7330),
    [anon_sym_PIPE] = ACTIONS(7332),
    [anon_sym_SEMI] = ACTIONS(7330),
    [anon_sym_STAR_STAR] = ACTIONS(7332),
    [anon_sym_AMP] = ACTIONS(7332),
    [anon_sym_EQ] = ACTIONS(7332),
    [anon_sym_LT] = ACTIONS(7332),
    [anon_sym_end] = ACTIONS(7330),
    [anon_sym_if] = ACTIONS(7330),
    [anon_sym_unless] = ACTIONS(7330),
    [anon_sym_while] = ACTIONS(7330),
    [anon_sym_until] = ACTIONS(7330),
    [anon_sym_rescue] = ACTIONS(7330),
    [anon_sym_do] = ACTIONS(7330),
    [anon_sym_when] = ACTIONS(7330),
    [anon_sym_elsif] = ACTIONS(7330),
    [anon_sym_else] = ACTIONS(7330),
    [anon_sym_then] = ACTIONS(7330),
    [anon_sym_ensure] = ACTIONS(7330),
    [anon_sym_EQ_GT] = ACTIONS(7330),
    [anon_sym_LBRACK] = ACTIONS(7330),
    [anon_sym_COLON_COLON2] = ACTIONS(7330),
    [anon_sym_AMP_DOT] = ACTIONS(7330),
    [anon_sym_PLUS_EQ] = ACTIONS(7330),
    [anon_sym_DASH_EQ] = ACTIONS(7330),
    [anon_sym_STAR_EQ] = ACTIONS(7330),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7330),
    [anon_sym_SLASH_EQ] = ACTIONS(7330),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7330),
    [anon_sym_PIPE_EQ] = ACTIONS(7330),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7330),
    [anon_sym_AMP_EQ] = ACTIONS(7330),
    [anon_sym_PERCENT_EQ] = ACTIONS(7330),
    [anon_sym_GT_GT_EQ] = ACTIONS(7330),
    [anon_sym_LT_LT_EQ] = ACTIONS(7330),
    [anon_sym_CARET_EQ] = ACTIONS(7330),
    [anon_sym_QMARK] = ACTIONS(7330),
    [anon_sym_DOT_DOT] = ACTIONS(7332),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7330),
    [anon_sym_and] = ACTIONS(7330),
    [anon_sym_or] = ACTIONS(7330),
    [anon_sym_PIPE_PIPE] = ACTIONS(7332),
    [anon_sym_AMP_AMP] = ACTIONS(7332),
    [anon_sym_LT_LT] = ACTIONS(7332),
    [anon_sym_GT_GT] = ACTIONS(7332),
    [anon_sym_EQ_EQ] = ACTIONS(7332),
    [anon_sym_BANG_EQ] = ACTIONS(7330),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7330),
    [anon_sym_LT_EQ_GT] = ACTIONS(7330),
    [anon_sym_EQ_TILDE] = ACTIONS(7330),
    [anon_sym_BANG_TILDE] = ACTIONS(7330),
    [anon_sym_LT_EQ] = ACTIONS(7332),
    [anon_sym_GT] = ACTIONS(7332),
    [anon_sym_GT_EQ] = ACTIONS(7330),
    [anon_sym_CARET] = ACTIONS(7332),
    [anon_sym_PLUS] = ACTIONS(7332),
    [anon_sym_SLASH] = ACTIONS(7332),
    [anon_sym_PERCENT] = ACTIONS(7332),
    [sym_comment] = ACTIONS(87),
  },
  [6368] = {
    [sym__statements] = STATE(1550),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(1551),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(1552),
    [sym_rescue] = STATE(1553),
    [sym__body_statement] = STATE(8662),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12312),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6369] = {
    [sym__statements] = STATE(1550),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(1551),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(1552),
    [sym_rescue] = STATE(1553),
    [sym__body_statement] = STATE(8663),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12314),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6370] = {
    [sym__line_break] = ACTIONS(7764),
    [sym__heredoc_body_start] = ACTIONS(7764),
    [sym__binary_minus] = ACTIONS(7764),
    [sym__binary_star] = ACTIONS(7764),
    [ts_builtin_sym_end] = ACTIONS(7764),
    [anon_sym___END__] = ACTIONS(7764),
    [anon_sym_LBRACE] = ACTIONS(7764),
    [anon_sym_RBRACE] = ACTIONS(7764),
    [anon_sym_RPAREN] = ACTIONS(7764),
    [anon_sym_DOT] = ACTIONS(7766),
    [anon_sym_COMMA] = ACTIONS(7764),
    [anon_sym_PIPE] = ACTIONS(7766),
    [anon_sym_SEMI] = ACTIONS(7764),
    [anon_sym_STAR_STAR] = ACTIONS(7766),
    [anon_sym_AMP] = ACTIONS(7766),
    [anon_sym_EQ] = ACTIONS(7766),
    [anon_sym_LT] = ACTIONS(7766),
    [anon_sym_end] = ACTIONS(7764),
    [anon_sym_if] = ACTIONS(7764),
    [anon_sym_unless] = ACTIONS(7764),
    [anon_sym_while] = ACTIONS(7764),
    [anon_sym_until] = ACTIONS(7764),
    [anon_sym_rescue] = ACTIONS(7764),
    [anon_sym_do] = ACTIONS(7764),
    [anon_sym_when] = ACTIONS(7764),
    [anon_sym_elsif] = ACTIONS(7764),
    [anon_sym_else] = ACTIONS(7764),
    [anon_sym_then] = ACTIONS(7764),
    [anon_sym_ensure] = ACTIONS(7764),
    [anon_sym_EQ_GT] = ACTIONS(7764),
    [anon_sym_LBRACK] = ACTIONS(7764),
    [anon_sym_COLON_COLON2] = ACTIONS(7764),
    [anon_sym_AMP_DOT] = ACTIONS(7764),
    [anon_sym_PLUS_EQ] = ACTIONS(7764),
    [anon_sym_DASH_EQ] = ACTIONS(7764),
    [anon_sym_STAR_EQ] = ACTIONS(7764),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7764),
    [anon_sym_SLASH_EQ] = ACTIONS(7764),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7764),
    [anon_sym_PIPE_EQ] = ACTIONS(7764),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7764),
    [anon_sym_AMP_EQ] = ACTIONS(7764),
    [anon_sym_PERCENT_EQ] = ACTIONS(7764),
    [anon_sym_GT_GT_EQ] = ACTIONS(7764),
    [anon_sym_LT_LT_EQ] = ACTIONS(7764),
    [anon_sym_CARET_EQ] = ACTIONS(7764),
    [anon_sym_QMARK] = ACTIONS(7764),
    [anon_sym_DOT_DOT] = ACTIONS(7766),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7764),
    [anon_sym_and] = ACTIONS(7764),
    [anon_sym_or] = ACTIONS(7764),
    [anon_sym_PIPE_PIPE] = ACTIONS(7766),
    [anon_sym_AMP_AMP] = ACTIONS(7766),
    [anon_sym_LT_LT] = ACTIONS(7766),
    [anon_sym_GT_GT] = ACTIONS(7766),
    [anon_sym_EQ_EQ] = ACTIONS(7766),
    [anon_sym_BANG_EQ] = ACTIONS(7764),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7764),
    [anon_sym_LT_EQ_GT] = ACTIONS(7764),
    [anon_sym_EQ_TILDE] = ACTIONS(7764),
    [anon_sym_BANG_TILDE] = ACTIONS(7764),
    [anon_sym_LT_EQ] = ACTIONS(7766),
    [anon_sym_GT] = ACTIONS(7766),
    [anon_sym_GT_EQ] = ACTIONS(7764),
    [anon_sym_CARET] = ACTIONS(7766),
    [anon_sym_PLUS] = ACTIONS(7766),
    [anon_sym_SLASH] = ACTIONS(7766),
    [anon_sym_PERCENT] = ACTIONS(7766),
    [sym_comment] = ACTIONS(87),
  },
  [6371] = {
    [sym__line_break] = ACTIONS(7818),
    [sym__heredoc_body_start] = ACTIONS(7818),
    [sym__binary_minus] = ACTIONS(7818),
    [sym__binary_star] = ACTIONS(7818),
    [ts_builtin_sym_end] = ACTIONS(7818),
    [anon_sym___END__] = ACTIONS(7818),
    [anon_sym_LBRACE] = ACTIONS(7818),
    [anon_sym_RBRACE] = ACTIONS(7818),
    [anon_sym_RPAREN] = ACTIONS(7818),
    [anon_sym_DOT] = ACTIONS(7820),
    [anon_sym_COMMA] = ACTIONS(7818),
    [anon_sym_PIPE] = ACTIONS(7820),
    [anon_sym_SEMI] = ACTIONS(7818),
    [anon_sym_STAR_STAR] = ACTIONS(7820),
    [anon_sym_AMP] = ACTIONS(7820),
    [anon_sym_EQ] = ACTIONS(7820),
    [anon_sym_LT] = ACTIONS(7820),
    [anon_sym_end] = ACTIONS(7818),
    [anon_sym_if] = ACTIONS(7818),
    [anon_sym_unless] = ACTIONS(7818),
    [anon_sym_while] = ACTIONS(7818),
    [anon_sym_until] = ACTIONS(7818),
    [anon_sym_rescue] = ACTIONS(7818),
    [anon_sym_do] = ACTIONS(7818),
    [anon_sym_when] = ACTIONS(7818),
    [anon_sym_elsif] = ACTIONS(7818),
    [anon_sym_else] = ACTIONS(7818),
    [anon_sym_then] = ACTIONS(7818),
    [anon_sym_ensure] = ACTIONS(7818),
    [anon_sym_EQ_GT] = ACTIONS(7818),
    [anon_sym_LBRACK] = ACTIONS(7818),
    [anon_sym_COLON_COLON2] = ACTIONS(7818),
    [anon_sym_AMP_DOT] = ACTIONS(7818),
    [anon_sym_PLUS_EQ] = ACTIONS(7818),
    [anon_sym_DASH_EQ] = ACTIONS(7818),
    [anon_sym_STAR_EQ] = ACTIONS(7818),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7818),
    [anon_sym_SLASH_EQ] = ACTIONS(7818),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7818),
    [anon_sym_PIPE_EQ] = ACTIONS(7818),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7818),
    [anon_sym_AMP_EQ] = ACTIONS(7818),
    [anon_sym_PERCENT_EQ] = ACTIONS(7818),
    [anon_sym_GT_GT_EQ] = ACTIONS(7818),
    [anon_sym_LT_LT_EQ] = ACTIONS(7818),
    [anon_sym_CARET_EQ] = ACTIONS(7818),
    [anon_sym_QMARK] = ACTIONS(7818),
    [anon_sym_DOT_DOT] = ACTIONS(7820),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7818),
    [anon_sym_and] = ACTIONS(7818),
    [anon_sym_or] = ACTIONS(7818),
    [anon_sym_PIPE_PIPE] = ACTIONS(7820),
    [anon_sym_AMP_AMP] = ACTIONS(7820),
    [anon_sym_LT_LT] = ACTIONS(7820),
    [anon_sym_GT_GT] = ACTIONS(7820),
    [anon_sym_EQ_EQ] = ACTIONS(7820),
    [anon_sym_BANG_EQ] = ACTIONS(7818),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7818),
    [anon_sym_LT_EQ_GT] = ACTIONS(7818),
    [anon_sym_EQ_TILDE] = ACTIONS(7818),
    [anon_sym_BANG_TILDE] = ACTIONS(7818),
    [anon_sym_LT_EQ] = ACTIONS(7820),
    [anon_sym_GT] = ACTIONS(7820),
    [anon_sym_GT_EQ] = ACTIONS(7818),
    [anon_sym_CARET] = ACTIONS(7820),
    [anon_sym_PLUS] = ACTIONS(7820),
    [anon_sym_SLASH] = ACTIONS(7820),
    [anon_sym_PERCENT] = ACTIONS(7820),
    [sym_comment] = ACTIONS(87),
  },
  [6372] = {
    [sym__line_break] = ACTIONS(8098),
    [sym__heredoc_body_start] = ACTIONS(8098),
    [sym__binary_minus] = ACTIONS(8098),
    [sym__binary_star] = ACTIONS(8098),
    [ts_builtin_sym_end] = ACTIONS(8098),
    [anon_sym___END__] = ACTIONS(8098),
    [anon_sym_LBRACE] = ACTIONS(8098),
    [anon_sym_RBRACE] = ACTIONS(8098),
    [anon_sym_RPAREN] = ACTIONS(8098),
    [anon_sym_DOT] = ACTIONS(8100),
    [anon_sym_COMMA] = ACTIONS(8098),
    [anon_sym_PIPE] = ACTIONS(8100),
    [anon_sym_SEMI] = ACTIONS(8098),
    [anon_sym_STAR_STAR] = ACTIONS(8100),
    [anon_sym_AMP] = ACTIONS(8100),
    [anon_sym_EQ] = ACTIONS(8100),
    [anon_sym_LT] = ACTIONS(8100),
    [anon_sym_end] = ACTIONS(8098),
    [anon_sym_if] = ACTIONS(8098),
    [anon_sym_unless] = ACTIONS(8098),
    [anon_sym_while] = ACTIONS(8098),
    [anon_sym_until] = ACTIONS(8098),
    [anon_sym_rescue] = ACTIONS(8098),
    [anon_sym_do] = ACTIONS(8098),
    [anon_sym_when] = ACTIONS(8098),
    [anon_sym_elsif] = ACTIONS(8098),
    [anon_sym_else] = ACTIONS(8098),
    [anon_sym_then] = ACTIONS(8098),
    [anon_sym_ensure] = ACTIONS(8098),
    [anon_sym_EQ_GT] = ACTIONS(8098),
    [anon_sym_LBRACK] = ACTIONS(8098),
    [anon_sym_COLON_COLON2] = ACTIONS(8098),
    [anon_sym_AMP_DOT] = ACTIONS(8098),
    [anon_sym_PLUS_EQ] = ACTIONS(8098),
    [anon_sym_DASH_EQ] = ACTIONS(8098),
    [anon_sym_STAR_EQ] = ACTIONS(8098),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8098),
    [anon_sym_SLASH_EQ] = ACTIONS(8098),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8098),
    [anon_sym_PIPE_EQ] = ACTIONS(8098),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8098),
    [anon_sym_AMP_EQ] = ACTIONS(8098),
    [anon_sym_PERCENT_EQ] = ACTIONS(8098),
    [anon_sym_GT_GT_EQ] = ACTIONS(8098),
    [anon_sym_LT_LT_EQ] = ACTIONS(8098),
    [anon_sym_CARET_EQ] = ACTIONS(8098),
    [anon_sym_QMARK] = ACTIONS(8098),
    [anon_sym_DOT_DOT] = ACTIONS(8100),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8098),
    [anon_sym_and] = ACTIONS(8098),
    [anon_sym_or] = ACTIONS(8098),
    [anon_sym_PIPE_PIPE] = ACTIONS(8100),
    [anon_sym_AMP_AMP] = ACTIONS(8100),
    [anon_sym_LT_LT] = ACTIONS(8100),
    [anon_sym_GT_GT] = ACTIONS(8100),
    [anon_sym_EQ_EQ] = ACTIONS(8100),
    [anon_sym_BANG_EQ] = ACTIONS(8098),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8098),
    [anon_sym_LT_EQ_GT] = ACTIONS(8098),
    [anon_sym_EQ_TILDE] = ACTIONS(8098),
    [anon_sym_BANG_TILDE] = ACTIONS(8098),
    [anon_sym_LT_EQ] = ACTIONS(8100),
    [anon_sym_GT] = ACTIONS(8100),
    [anon_sym_GT_EQ] = ACTIONS(8098),
    [anon_sym_CARET] = ACTIONS(8100),
    [anon_sym_PLUS] = ACTIONS(8100),
    [anon_sym_SLASH] = ACTIONS(8100),
    [anon_sym_PERCENT] = ACTIONS(8100),
    [sym_comment] = ACTIONS(87),
  },
  [6373] = {
    [anon_sym_end] = ACTIONS(12316),
    [sym_comment] = ACTIONS(87),
  },
  [6374] = {
    [sym__line_break] = ACTIONS(8284),
    [sym__heredoc_body_start] = ACTIONS(8284),
    [sym__binary_minus] = ACTIONS(8284),
    [sym__binary_star] = ACTIONS(8284),
    [ts_builtin_sym_end] = ACTIONS(8284),
    [anon_sym___END__] = ACTIONS(8284),
    [anon_sym_LBRACE] = ACTIONS(8284),
    [anon_sym_RBRACE] = ACTIONS(8284),
    [anon_sym_RPAREN] = ACTIONS(8284),
    [anon_sym_DOT] = ACTIONS(8286),
    [anon_sym_COMMA] = ACTIONS(8284),
    [anon_sym_PIPE] = ACTIONS(8286),
    [anon_sym_SEMI] = ACTIONS(8284),
    [anon_sym_STAR_STAR] = ACTIONS(8286),
    [anon_sym_AMP] = ACTIONS(8286),
    [anon_sym_EQ] = ACTIONS(8286),
    [anon_sym_LT] = ACTIONS(8286),
    [anon_sym_end] = ACTIONS(8284),
    [anon_sym_if] = ACTIONS(8284),
    [anon_sym_unless] = ACTIONS(8284),
    [anon_sym_while] = ACTIONS(8284),
    [anon_sym_until] = ACTIONS(8284),
    [anon_sym_rescue] = ACTIONS(8284),
    [anon_sym_do] = ACTIONS(8284),
    [anon_sym_when] = ACTIONS(8284),
    [anon_sym_elsif] = ACTIONS(8284),
    [anon_sym_else] = ACTIONS(8284),
    [anon_sym_then] = ACTIONS(8284),
    [anon_sym_ensure] = ACTIONS(8284),
    [anon_sym_EQ_GT] = ACTIONS(8284),
    [anon_sym_LBRACK] = ACTIONS(8284),
    [anon_sym_COLON_COLON2] = ACTIONS(8284),
    [anon_sym_AMP_DOT] = ACTIONS(8284),
    [anon_sym_PLUS_EQ] = ACTIONS(8284),
    [anon_sym_DASH_EQ] = ACTIONS(8284),
    [anon_sym_STAR_EQ] = ACTIONS(8284),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8284),
    [anon_sym_SLASH_EQ] = ACTIONS(8284),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8284),
    [anon_sym_PIPE_EQ] = ACTIONS(8284),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8284),
    [anon_sym_AMP_EQ] = ACTIONS(8284),
    [anon_sym_PERCENT_EQ] = ACTIONS(8284),
    [anon_sym_GT_GT_EQ] = ACTIONS(8284),
    [anon_sym_LT_LT_EQ] = ACTIONS(8284),
    [anon_sym_CARET_EQ] = ACTIONS(8284),
    [anon_sym_QMARK] = ACTIONS(8284),
    [anon_sym_DOT_DOT] = ACTIONS(8286),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8284),
    [anon_sym_and] = ACTIONS(8284),
    [anon_sym_or] = ACTIONS(8284),
    [anon_sym_PIPE_PIPE] = ACTIONS(8286),
    [anon_sym_AMP_AMP] = ACTIONS(8286),
    [anon_sym_LT_LT] = ACTIONS(8286),
    [anon_sym_GT_GT] = ACTIONS(8286),
    [anon_sym_EQ_EQ] = ACTIONS(8286),
    [anon_sym_BANG_EQ] = ACTIONS(8284),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8284),
    [anon_sym_LT_EQ_GT] = ACTIONS(8284),
    [anon_sym_EQ_TILDE] = ACTIONS(8284),
    [anon_sym_BANG_TILDE] = ACTIONS(8284),
    [anon_sym_LT_EQ] = ACTIONS(8286),
    [anon_sym_GT] = ACTIONS(8286),
    [anon_sym_GT_EQ] = ACTIONS(8284),
    [anon_sym_CARET] = ACTIONS(8286),
    [anon_sym_PLUS] = ACTIONS(8286),
    [anon_sym_SLASH] = ACTIONS(8286),
    [anon_sym_PERCENT] = ACTIONS(8286),
    [sym_comment] = ACTIONS(87),
  },
  [6375] = {
    [anon_sym_end] = ACTIONS(12318),
    [sym_comment] = ACTIONS(87),
  },
  [6376] = {
    [sym__line_break] = ACTIONS(8344),
    [sym__heredoc_body_start] = ACTIONS(8344),
    [sym__binary_minus] = ACTIONS(8344),
    [sym__binary_star] = ACTIONS(8344),
    [ts_builtin_sym_end] = ACTIONS(8344),
    [anon_sym___END__] = ACTIONS(8344),
    [anon_sym_LBRACE] = ACTIONS(8344),
    [anon_sym_RBRACE] = ACTIONS(8344),
    [anon_sym_RPAREN] = ACTIONS(8344),
    [anon_sym_DOT] = ACTIONS(8346),
    [anon_sym_COMMA] = ACTIONS(8344),
    [anon_sym_PIPE] = ACTIONS(8346),
    [anon_sym_SEMI] = ACTIONS(8344),
    [anon_sym_STAR_STAR] = ACTIONS(8346),
    [anon_sym_AMP] = ACTIONS(8346),
    [anon_sym_EQ] = ACTIONS(8346),
    [anon_sym_LT] = ACTIONS(8346),
    [anon_sym_end] = ACTIONS(8344),
    [anon_sym_if] = ACTIONS(8344),
    [anon_sym_unless] = ACTIONS(8344),
    [anon_sym_while] = ACTIONS(8344),
    [anon_sym_until] = ACTIONS(8344),
    [anon_sym_rescue] = ACTIONS(8344),
    [anon_sym_do] = ACTIONS(8344),
    [anon_sym_when] = ACTIONS(8344),
    [anon_sym_elsif] = ACTIONS(8344),
    [anon_sym_else] = ACTIONS(8344),
    [anon_sym_then] = ACTIONS(8344),
    [anon_sym_ensure] = ACTIONS(8344),
    [anon_sym_EQ_GT] = ACTIONS(8344),
    [anon_sym_LBRACK] = ACTIONS(8344),
    [anon_sym_COLON_COLON2] = ACTIONS(8344),
    [anon_sym_AMP_DOT] = ACTIONS(8344),
    [anon_sym_PLUS_EQ] = ACTIONS(8344),
    [anon_sym_DASH_EQ] = ACTIONS(8344),
    [anon_sym_STAR_EQ] = ACTIONS(8344),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8344),
    [anon_sym_SLASH_EQ] = ACTIONS(8344),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8344),
    [anon_sym_PIPE_EQ] = ACTIONS(8344),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8344),
    [anon_sym_AMP_EQ] = ACTIONS(8344),
    [anon_sym_PERCENT_EQ] = ACTIONS(8344),
    [anon_sym_GT_GT_EQ] = ACTIONS(8344),
    [anon_sym_LT_LT_EQ] = ACTIONS(8344),
    [anon_sym_CARET_EQ] = ACTIONS(8344),
    [anon_sym_QMARK] = ACTIONS(8344),
    [anon_sym_DOT_DOT] = ACTIONS(8346),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8344),
    [anon_sym_and] = ACTIONS(8344),
    [anon_sym_or] = ACTIONS(8344),
    [anon_sym_PIPE_PIPE] = ACTIONS(8346),
    [anon_sym_AMP_AMP] = ACTIONS(8346),
    [anon_sym_LT_LT] = ACTIONS(8346),
    [anon_sym_GT_GT] = ACTIONS(8346),
    [anon_sym_EQ_EQ] = ACTIONS(8346),
    [anon_sym_BANG_EQ] = ACTIONS(8344),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8344),
    [anon_sym_LT_EQ_GT] = ACTIONS(8344),
    [anon_sym_EQ_TILDE] = ACTIONS(8344),
    [anon_sym_BANG_TILDE] = ACTIONS(8344),
    [anon_sym_LT_EQ] = ACTIONS(8346),
    [anon_sym_GT] = ACTIONS(8346),
    [anon_sym_GT_EQ] = ACTIONS(8344),
    [anon_sym_CARET] = ACTIONS(8346),
    [anon_sym_PLUS] = ACTIONS(8346),
    [anon_sym_SLASH] = ACTIONS(8346),
    [anon_sym_PERCENT] = ACTIONS(8346),
    [sym_comment] = ACTIONS(87),
  },
  [6377] = {
    [anon_sym_end] = ACTIONS(12320),
    [sym_comment] = ACTIONS(87),
  },
  [6378] = {
    [sym__line_break] = ACTIONS(8420),
    [sym__heredoc_body_start] = ACTIONS(8420),
    [sym__binary_minus] = ACTIONS(8420),
    [sym__binary_star] = ACTIONS(8420),
    [ts_builtin_sym_end] = ACTIONS(8420),
    [anon_sym___END__] = ACTIONS(8420),
    [anon_sym_LBRACE] = ACTIONS(8420),
    [anon_sym_RBRACE] = ACTIONS(8420),
    [anon_sym_RPAREN] = ACTIONS(8420),
    [anon_sym_DOT] = ACTIONS(8422),
    [anon_sym_COMMA] = ACTIONS(8420),
    [anon_sym_PIPE] = ACTIONS(8422),
    [anon_sym_SEMI] = ACTIONS(8420),
    [anon_sym_STAR_STAR] = ACTIONS(8422),
    [anon_sym_AMP] = ACTIONS(8422),
    [anon_sym_EQ] = ACTIONS(8422),
    [anon_sym_LT] = ACTIONS(8422),
    [anon_sym_end] = ACTIONS(8420),
    [anon_sym_if] = ACTIONS(8420),
    [anon_sym_unless] = ACTIONS(8420),
    [anon_sym_while] = ACTIONS(8420),
    [anon_sym_until] = ACTIONS(8420),
    [anon_sym_rescue] = ACTIONS(8420),
    [anon_sym_do] = ACTIONS(8420),
    [anon_sym_when] = ACTIONS(8420),
    [anon_sym_elsif] = ACTIONS(8420),
    [anon_sym_else] = ACTIONS(8420),
    [anon_sym_then] = ACTIONS(8420),
    [anon_sym_ensure] = ACTIONS(8420),
    [anon_sym_EQ_GT] = ACTIONS(8420),
    [anon_sym_LBRACK] = ACTIONS(8420),
    [anon_sym_COLON_COLON2] = ACTIONS(8420),
    [anon_sym_AMP_DOT] = ACTIONS(8420),
    [anon_sym_PLUS_EQ] = ACTIONS(8420),
    [anon_sym_DASH_EQ] = ACTIONS(8420),
    [anon_sym_STAR_EQ] = ACTIONS(8420),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8420),
    [anon_sym_SLASH_EQ] = ACTIONS(8420),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8420),
    [anon_sym_PIPE_EQ] = ACTIONS(8420),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8420),
    [anon_sym_AMP_EQ] = ACTIONS(8420),
    [anon_sym_PERCENT_EQ] = ACTIONS(8420),
    [anon_sym_GT_GT_EQ] = ACTIONS(8420),
    [anon_sym_LT_LT_EQ] = ACTIONS(8420),
    [anon_sym_CARET_EQ] = ACTIONS(8420),
    [anon_sym_QMARK] = ACTIONS(8420),
    [anon_sym_DOT_DOT] = ACTIONS(8422),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8420),
    [anon_sym_and] = ACTIONS(8420),
    [anon_sym_or] = ACTIONS(8420),
    [anon_sym_PIPE_PIPE] = ACTIONS(8422),
    [anon_sym_AMP_AMP] = ACTIONS(8422),
    [anon_sym_LT_LT] = ACTIONS(8422),
    [anon_sym_GT_GT] = ACTIONS(8422),
    [anon_sym_EQ_EQ] = ACTIONS(8422),
    [anon_sym_BANG_EQ] = ACTIONS(8420),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8420),
    [anon_sym_LT_EQ_GT] = ACTIONS(8420),
    [anon_sym_EQ_TILDE] = ACTIONS(8420),
    [anon_sym_BANG_TILDE] = ACTIONS(8420),
    [anon_sym_LT_EQ] = ACTIONS(8422),
    [anon_sym_GT] = ACTIONS(8422),
    [anon_sym_GT_EQ] = ACTIONS(8420),
    [anon_sym_CARET] = ACTIONS(8422),
    [anon_sym_PLUS] = ACTIONS(8422),
    [anon_sym_SLASH] = ACTIONS(8422),
    [anon_sym_PERCENT] = ACTIONS(8422),
    [sym_comment] = ACTIONS(87),
  },
  [6379] = {
    [anon_sym_end] = ACTIONS(12322),
    [sym_comment] = ACTIONS(87),
  },
  [6380] = {
    [sym__statements] = STATE(8669),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12324),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6381] = {
    [sym__line_break] = ACTIONS(12054),
    [sym__heredoc_body_start] = ACTIONS(12054),
    [sym__binary_minus] = ACTIONS(12054),
    [sym__binary_star] = ACTIONS(12054),
    [ts_builtin_sym_end] = ACTIONS(12054),
    [anon_sym___END__] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_RBRACE] = ACTIONS(12054),
    [anon_sym_RPAREN] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12056),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_PIPE] = ACTIONS(12056),
    [anon_sym_SEMI] = ACTIONS(12054),
    [anon_sym_STAR_STAR] = ACTIONS(12056),
    [anon_sym_AMP] = ACTIONS(12056),
    [anon_sym_EQ] = ACTIONS(12056),
    [anon_sym_LT] = ACTIONS(12056),
    [anon_sym_end] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_unless] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [anon_sym_until] = ACTIONS(12054),
    [anon_sym_rescue] = ACTIONS(12054),
    [anon_sym_do] = ACTIONS(12054),
    [anon_sym_when] = ACTIONS(12054),
    [anon_sym_elsif] = ACTIONS(12054),
    [anon_sym_else] = ACTIONS(12054),
    [anon_sym_then] = ACTIONS(12054),
    [anon_sym_ensure] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_COLON_COLON2] = ACTIONS(12054),
    [anon_sym_AMP_DOT] = ACTIONS(12054),
    [anon_sym_PLUS_EQ] = ACTIONS(12054),
    [anon_sym_DASH_EQ] = ACTIONS(12054),
    [anon_sym_STAR_EQ] = ACTIONS(12054),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12054),
    [anon_sym_SLASH_EQ] = ACTIONS(12054),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12054),
    [anon_sym_PIPE_EQ] = ACTIONS(12054),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12054),
    [anon_sym_AMP_EQ] = ACTIONS(12054),
    [anon_sym_PERCENT_EQ] = ACTIONS(12054),
    [anon_sym_GT_GT_EQ] = ACTIONS(12054),
    [anon_sym_LT_LT_EQ] = ACTIONS(12054),
    [anon_sym_CARET_EQ] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_DOT_DOT] = ACTIONS(12056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_and] = ACTIONS(12054),
    [anon_sym_or] = ACTIONS(12054),
    [anon_sym_PIPE_PIPE] = ACTIONS(12056),
    [anon_sym_AMP_AMP] = ACTIONS(12056),
    [anon_sym_LT_LT] = ACTIONS(12056),
    [anon_sym_GT_GT] = ACTIONS(12056),
    [anon_sym_EQ_EQ] = ACTIONS(12056),
    [anon_sym_BANG_EQ] = ACTIONS(12054),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12054),
    [anon_sym_LT_EQ_GT] = ACTIONS(12054),
    [anon_sym_EQ_TILDE] = ACTIONS(12054),
    [anon_sym_BANG_TILDE] = ACTIONS(12054),
    [anon_sym_LT_EQ] = ACTIONS(12056),
    [anon_sym_GT] = ACTIONS(12056),
    [anon_sym_GT_EQ] = ACTIONS(12054),
    [anon_sym_CARET] = ACTIONS(12056),
    [anon_sym_PLUS] = ACTIONS(12056),
    [anon_sym_SLASH] = ACTIONS(12056),
    [anon_sym_PERCENT] = ACTIONS(12056),
    [sym_comment] = ACTIONS(87),
  },
  [6382] = {
    [anon_sym_end] = ACTIONS(12326),
    [sym_comment] = ACTIONS(87),
  },
  [6383] = {
    [sym__statements] = STATE(8671),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12328),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6384] = {
    [sym__line_break] = ACTIONS(8581),
    [sym__heredoc_body_start] = ACTIONS(8581),
    [sym__binary_minus] = ACTIONS(8581),
    [sym__binary_star] = ACTIONS(8581),
    [ts_builtin_sym_end] = ACTIONS(8581),
    [anon_sym___END__] = ACTIONS(8581),
    [anon_sym_LBRACE] = ACTIONS(8581),
    [anon_sym_RBRACE] = ACTIONS(8581),
    [anon_sym_RPAREN] = ACTIONS(8581),
    [anon_sym_DOT] = ACTIONS(8583),
    [anon_sym_COMMA] = ACTIONS(8581),
    [anon_sym_PIPE] = ACTIONS(8583),
    [anon_sym_SEMI] = ACTIONS(8581),
    [anon_sym_STAR_STAR] = ACTIONS(8583),
    [anon_sym_AMP] = ACTIONS(8583),
    [anon_sym_EQ] = ACTIONS(8583),
    [anon_sym_LT] = ACTIONS(8583),
    [anon_sym_end] = ACTIONS(8581),
    [anon_sym_if] = ACTIONS(8581),
    [anon_sym_unless] = ACTIONS(8581),
    [anon_sym_while] = ACTIONS(8581),
    [anon_sym_until] = ACTIONS(8581),
    [anon_sym_rescue] = ACTIONS(8581),
    [anon_sym_do] = ACTIONS(8581),
    [anon_sym_when] = ACTIONS(8581),
    [anon_sym_elsif] = ACTIONS(8581),
    [anon_sym_else] = ACTIONS(8581),
    [anon_sym_then] = ACTIONS(8581),
    [anon_sym_ensure] = ACTIONS(8581),
    [anon_sym_EQ_GT] = ACTIONS(8581),
    [anon_sym_LBRACK] = ACTIONS(8581),
    [anon_sym_COLON_COLON2] = ACTIONS(8581),
    [anon_sym_AMP_DOT] = ACTIONS(8581),
    [anon_sym_PLUS_EQ] = ACTIONS(8581),
    [anon_sym_DASH_EQ] = ACTIONS(8581),
    [anon_sym_STAR_EQ] = ACTIONS(8581),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8581),
    [anon_sym_SLASH_EQ] = ACTIONS(8581),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8581),
    [anon_sym_PIPE_EQ] = ACTIONS(8581),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8581),
    [anon_sym_AMP_EQ] = ACTIONS(8581),
    [anon_sym_PERCENT_EQ] = ACTIONS(8581),
    [anon_sym_GT_GT_EQ] = ACTIONS(8581),
    [anon_sym_LT_LT_EQ] = ACTIONS(8581),
    [anon_sym_CARET_EQ] = ACTIONS(8581),
    [anon_sym_QMARK] = ACTIONS(8581),
    [anon_sym_DOT_DOT] = ACTIONS(8583),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8581),
    [anon_sym_and] = ACTIONS(8581),
    [anon_sym_or] = ACTIONS(8581),
    [anon_sym_PIPE_PIPE] = ACTIONS(8583),
    [anon_sym_AMP_AMP] = ACTIONS(8583),
    [anon_sym_LT_LT] = ACTIONS(8583),
    [anon_sym_GT_GT] = ACTIONS(8583),
    [anon_sym_EQ_EQ] = ACTIONS(8583),
    [anon_sym_BANG_EQ] = ACTIONS(8581),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8581),
    [anon_sym_LT_EQ_GT] = ACTIONS(8581),
    [anon_sym_EQ_TILDE] = ACTIONS(8581),
    [anon_sym_BANG_TILDE] = ACTIONS(8581),
    [anon_sym_LT_EQ] = ACTIONS(8583),
    [anon_sym_GT] = ACTIONS(8583),
    [anon_sym_GT_EQ] = ACTIONS(8581),
    [anon_sym_CARET] = ACTIONS(8583),
    [anon_sym_PLUS] = ACTIONS(8583),
    [anon_sym_SLASH] = ACTIONS(8583),
    [anon_sym_PERCENT] = ACTIONS(8583),
    [sym_comment] = ACTIONS(87),
  },
  [6385] = {
    [anon_sym_end] = ACTIONS(12330),
    [sym_comment] = ACTIONS(87),
  },
  [6386] = {
    [sym_when] = STATE(8674),
    [sym_else] = STATE(8673),
    [aux_sym_case_repeat1] = STATE(2987),
    [aux_sym_case_repeat2] = STATE(8674),
    [anon_sym_SEMI] = ACTIONS(4995),
    [anon_sym_end] = ACTIONS(12330),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [6387] = {
    [sym_when] = STATE(2988),
    [sym_else] = STATE(8673),
    [aux_sym_case_repeat2] = STATE(2988),
    [anon_sym_end] = ACTIONS(12330),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [6388] = {
    [sym__line_break] = ACTIONS(9185),
    [sym__heredoc_body_start] = ACTIONS(9185),
    [sym__binary_minus] = ACTIONS(9185),
    [sym__binary_star] = ACTIONS(9185),
    [ts_builtin_sym_end] = ACTIONS(9185),
    [anon_sym___END__] = ACTIONS(9185),
    [anon_sym_LBRACE] = ACTIONS(9185),
    [anon_sym_RBRACE] = ACTIONS(9185),
    [anon_sym_RPAREN] = ACTIONS(9185),
    [anon_sym_DOT] = ACTIONS(9187),
    [anon_sym_COMMA] = ACTIONS(9185),
    [anon_sym_PIPE] = ACTIONS(9187),
    [anon_sym_SEMI] = ACTIONS(9185),
    [anon_sym_STAR_STAR] = ACTIONS(9187),
    [anon_sym_AMP] = ACTIONS(9187),
    [anon_sym_EQ] = ACTIONS(9187),
    [anon_sym_LT] = ACTIONS(9187),
    [anon_sym_end] = ACTIONS(9185),
    [anon_sym_if] = ACTIONS(9185),
    [anon_sym_unless] = ACTIONS(9185),
    [anon_sym_while] = ACTIONS(9185),
    [anon_sym_until] = ACTIONS(9185),
    [anon_sym_rescue] = ACTIONS(9185),
    [anon_sym_do] = ACTIONS(9185),
    [anon_sym_when] = ACTIONS(9185),
    [anon_sym_elsif] = ACTIONS(9185),
    [anon_sym_else] = ACTIONS(9185),
    [anon_sym_then] = ACTIONS(9185),
    [anon_sym_ensure] = ACTIONS(9185),
    [anon_sym_EQ_GT] = ACTIONS(9185),
    [anon_sym_LBRACK] = ACTIONS(9185),
    [anon_sym_COLON_COLON2] = ACTIONS(9185),
    [anon_sym_AMP_DOT] = ACTIONS(9185),
    [anon_sym_PLUS_EQ] = ACTIONS(9185),
    [anon_sym_DASH_EQ] = ACTIONS(9185),
    [anon_sym_STAR_EQ] = ACTIONS(9185),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9185),
    [anon_sym_SLASH_EQ] = ACTIONS(9185),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9185),
    [anon_sym_PIPE_EQ] = ACTIONS(9185),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9185),
    [anon_sym_AMP_EQ] = ACTIONS(9185),
    [anon_sym_PERCENT_EQ] = ACTIONS(9185),
    [anon_sym_GT_GT_EQ] = ACTIONS(9185),
    [anon_sym_LT_LT_EQ] = ACTIONS(9185),
    [anon_sym_CARET_EQ] = ACTIONS(9185),
    [anon_sym_QMARK] = ACTIONS(9185),
    [anon_sym_DOT_DOT] = ACTIONS(9187),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9185),
    [anon_sym_and] = ACTIONS(9185),
    [anon_sym_or] = ACTIONS(9185),
    [anon_sym_PIPE_PIPE] = ACTIONS(9187),
    [anon_sym_AMP_AMP] = ACTIONS(9187),
    [anon_sym_LT_LT] = ACTIONS(9187),
    [anon_sym_GT_GT] = ACTIONS(9187),
    [anon_sym_EQ_EQ] = ACTIONS(9187),
    [anon_sym_BANG_EQ] = ACTIONS(9185),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9185),
    [anon_sym_LT_EQ_GT] = ACTIONS(9185),
    [anon_sym_EQ_TILDE] = ACTIONS(9185),
    [anon_sym_BANG_TILDE] = ACTIONS(9185),
    [anon_sym_LT_EQ] = ACTIONS(9187),
    [anon_sym_GT] = ACTIONS(9187),
    [anon_sym_GT_EQ] = ACTIONS(9185),
    [anon_sym_CARET] = ACTIONS(9187),
    [anon_sym_PLUS] = ACTIONS(9187),
    [anon_sym_SLASH] = ACTIONS(9187),
    [anon_sym_PERCENT] = ACTIONS(9187),
    [sym_comment] = ACTIONS(87),
  },
  [6389] = {
    [anon_sym_end] = ACTIONS(12332),
    [sym_comment] = ACTIONS(87),
  },
  [6390] = {
    [sym_ensure] = STATE(8676),
    [anon_sym_end] = ACTIONS(12332),
    [anon_sym_ensure] = ACTIONS(2169),
    [sym_comment] = ACTIONS(87),
  },
  [6391] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8677),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(428),
    [sym_scope_resolution] = STATE(422),
    [sym_call] = STATE(422),
    [sym_method_call] = STATE(428),
    [sym_assignment] = STATE(8677),
    [sym_operator_assignment] = STATE(8677),
    [sym_conditional] = STATE(8677),
    [sym_range] = STATE(8677),
    [sym_binary] = STATE(8677),
    [sym_unary] = STATE(8677),
    [sym_left_assignment_list] = STATE(427),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(428),
    [sym__variable] = STATE(422),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(428),
    [sym_false] = STATE(428),
    [sym_nil] = STATE(428),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(1503),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(781),
    [anon_sym_yield] = ACTIONS(783),
    [anon_sym_break] = ACTIONS(785),
    [anon_sym_next] = ACTIONS(787),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(2623),
    [anon_sym_defined_QMARK] = ACTIONS(801),
    [anon_sym_not] = ACTIONS(803),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_TILDE] = ACTIONS(807),
    [sym_constant] = ACTIONS(815),
    [sym_identifier] = ACTIONS(815),
    [sym_instance_variable] = ACTIONS(811),
    [sym_class_variable] = ACTIONS(811),
    [sym_global_variable] = ACTIONS(811),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(815),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(815),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [6392] = {
    [sym__line_break] = ACTIONS(6813),
    [sym__heredoc_body_start] = ACTIONS(6813),
    [sym__binary_minus] = ACTIONS(6813),
    [sym__binary_star] = ACTIONS(6813),
    [ts_builtin_sym_end] = ACTIONS(6813),
    [anon_sym___END__] = ACTIONS(6813),
    [anon_sym_LBRACE] = ACTIONS(6813),
    [anon_sym_RBRACE] = ACTIONS(6813),
    [anon_sym_RPAREN] = ACTIONS(6813),
    [anon_sym_DOT] = ACTIONS(8689),
    [anon_sym_COMMA] = ACTIONS(6813),
    [anon_sym_PIPE] = ACTIONS(8689),
    [anon_sym_SEMI] = ACTIONS(6813),
    [anon_sym_STAR_STAR] = ACTIONS(8689),
    [anon_sym_AMP] = ACTIONS(8689),
    [anon_sym_EQ] = ACTIONS(8689),
    [anon_sym_LT] = ACTIONS(8689),
    [anon_sym_end] = ACTIONS(6813),
    [anon_sym_if] = ACTIONS(6813),
    [anon_sym_unless] = ACTIONS(6813),
    [anon_sym_while] = ACTIONS(6813),
    [anon_sym_until] = ACTIONS(6813),
    [anon_sym_rescue] = ACTIONS(6813),
    [anon_sym_do] = ACTIONS(6813),
    [anon_sym_when] = ACTIONS(6813),
    [anon_sym_elsif] = ACTIONS(6813),
    [anon_sym_else] = ACTIONS(6813),
    [anon_sym_then] = ACTIONS(6813),
    [anon_sym_ensure] = ACTIONS(6813),
    [anon_sym_LBRACK] = ACTIONS(6813),
    [anon_sym_COLON_COLON2] = ACTIONS(6813),
    [anon_sym_AMP_DOT] = ACTIONS(6813),
    [anon_sym_PLUS_EQ] = ACTIONS(6813),
    [anon_sym_DASH_EQ] = ACTIONS(6813),
    [anon_sym_STAR_EQ] = ACTIONS(6813),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6813),
    [anon_sym_SLASH_EQ] = ACTIONS(6813),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6813),
    [anon_sym_PIPE_EQ] = ACTIONS(6813),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6813),
    [anon_sym_AMP_EQ] = ACTIONS(6813),
    [anon_sym_PERCENT_EQ] = ACTIONS(6813),
    [anon_sym_GT_GT_EQ] = ACTIONS(6813),
    [anon_sym_LT_LT_EQ] = ACTIONS(6813),
    [anon_sym_CARET_EQ] = ACTIONS(6813),
    [anon_sym_QMARK] = ACTIONS(6813),
    [anon_sym_DOT_DOT] = ACTIONS(8689),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6813),
    [anon_sym_and] = ACTIONS(6813),
    [anon_sym_or] = ACTIONS(6813),
    [anon_sym_PIPE_PIPE] = ACTIONS(8689),
    [anon_sym_AMP_AMP] = ACTIONS(8689),
    [anon_sym_LT_LT] = ACTIONS(8689),
    [anon_sym_GT_GT] = ACTIONS(8689),
    [anon_sym_EQ_EQ] = ACTIONS(8689),
    [anon_sym_BANG_EQ] = ACTIONS(6813),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6813),
    [anon_sym_LT_EQ_GT] = ACTIONS(6813),
    [anon_sym_EQ_TILDE] = ACTIONS(6813),
    [anon_sym_BANG_TILDE] = ACTIONS(6813),
    [anon_sym_LT_EQ] = ACTIONS(8689),
    [anon_sym_GT] = ACTIONS(8689),
    [anon_sym_GT_EQ] = ACTIONS(6813),
    [anon_sym_CARET] = ACTIONS(8689),
    [anon_sym_PLUS] = ACTIONS(8689),
    [anon_sym_SLASH] = ACTIONS(8689),
    [anon_sym_PERCENT] = ACTIONS(8689),
    [sym_comment] = ACTIONS(87),
  },
  [6393] = {
    [sym__line_break] = ACTIONS(10986),
    [sym__heredoc_body_start] = ACTIONS(10986),
    [sym__binary_minus] = ACTIONS(10986),
    [sym__binary_star] = ACTIONS(10986),
    [ts_builtin_sym_end] = ACTIONS(10986),
    [anon_sym___END__] = ACTIONS(10986),
    [anon_sym_LBRACE] = ACTIONS(10986),
    [anon_sym_RBRACE] = ACTIONS(10986),
    [anon_sym_RPAREN] = ACTIONS(10986),
    [anon_sym_DOT] = ACTIONS(10988),
    [anon_sym_COMMA] = ACTIONS(10986),
    [anon_sym_PIPE] = ACTIONS(10988),
    [anon_sym_SEMI] = ACTIONS(10986),
    [anon_sym_STAR_STAR] = ACTIONS(10988),
    [anon_sym_AMP] = ACTIONS(10988),
    [anon_sym_EQ] = ACTIONS(10988),
    [anon_sym_LT] = ACTIONS(10988),
    [anon_sym_end] = ACTIONS(10986),
    [anon_sym_if] = ACTIONS(10986),
    [anon_sym_unless] = ACTIONS(10986),
    [anon_sym_while] = ACTIONS(10986),
    [anon_sym_until] = ACTIONS(10986),
    [anon_sym_rescue] = ACTIONS(10986),
    [anon_sym_do] = ACTIONS(10986),
    [anon_sym_when] = ACTIONS(10986),
    [anon_sym_elsif] = ACTIONS(10986),
    [anon_sym_else] = ACTIONS(10986),
    [anon_sym_then] = ACTIONS(10986),
    [anon_sym_ensure] = ACTIONS(10986),
    [anon_sym_LBRACK] = ACTIONS(10986),
    [anon_sym_COLON_COLON2] = ACTIONS(10986),
    [anon_sym_AMP_DOT] = ACTIONS(10986),
    [anon_sym_PLUS_EQ] = ACTIONS(10986),
    [anon_sym_DASH_EQ] = ACTIONS(10986),
    [anon_sym_STAR_EQ] = ACTIONS(10986),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10986),
    [anon_sym_SLASH_EQ] = ACTIONS(10986),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10986),
    [anon_sym_PIPE_EQ] = ACTIONS(10986),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10986),
    [anon_sym_AMP_EQ] = ACTIONS(10986),
    [anon_sym_PERCENT_EQ] = ACTIONS(10986),
    [anon_sym_GT_GT_EQ] = ACTIONS(10986),
    [anon_sym_LT_LT_EQ] = ACTIONS(10986),
    [anon_sym_CARET_EQ] = ACTIONS(10986),
    [anon_sym_QMARK] = ACTIONS(10986),
    [anon_sym_DOT_DOT] = ACTIONS(10988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10986),
    [anon_sym_and] = ACTIONS(10986),
    [anon_sym_or] = ACTIONS(10986),
    [anon_sym_PIPE_PIPE] = ACTIONS(10988),
    [anon_sym_AMP_AMP] = ACTIONS(10988),
    [anon_sym_LT_LT] = ACTIONS(10988),
    [anon_sym_GT_GT] = ACTIONS(10988),
    [anon_sym_EQ_EQ] = ACTIONS(10988),
    [anon_sym_BANG_EQ] = ACTIONS(10986),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10986),
    [anon_sym_LT_EQ_GT] = ACTIONS(10986),
    [anon_sym_EQ_TILDE] = ACTIONS(10986),
    [anon_sym_BANG_TILDE] = ACTIONS(10986),
    [anon_sym_LT_EQ] = ACTIONS(10988),
    [anon_sym_GT] = ACTIONS(10988),
    [anon_sym_GT_EQ] = ACTIONS(10986),
    [anon_sym_CARET] = ACTIONS(10988),
    [anon_sym_PLUS] = ACTIONS(10988),
    [anon_sym_SLASH] = ACTIONS(10988),
    [anon_sym_PERCENT] = ACTIONS(10988),
    [sym_comment] = ACTIONS(87),
  },
  [6394] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3741),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(428),
    [sym_scope_resolution] = STATE(422),
    [sym_call] = STATE(422),
    [sym_method_call] = STATE(428),
    [sym_splat_argument] = STATE(8678),
    [sym_assignment] = STATE(3741),
    [sym_operator_assignment] = STATE(3741),
    [sym_conditional] = STATE(3741),
    [sym_range] = STATE(3741),
    [sym_binary] = STATE(3741),
    [sym_unary] = STATE(3741),
    [sym__arg_or_splat_arg] = STATE(8678),
    [sym_left_assignment_list] = STATE(427),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(428),
    [sym__variable] = STATE(422),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(428),
    [sym_false] = STATE(428),
    [sym_nil] = STATE(428),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(1503),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__splat_star] = ACTIONS(1665),
    [sym__unary_minus] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(781),
    [anon_sym_yield] = ACTIONS(783),
    [anon_sym_break] = ACTIONS(785),
    [anon_sym_next] = ACTIONS(787),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(2623),
    [anon_sym_defined_QMARK] = ACTIONS(801),
    [anon_sym_not] = ACTIONS(803),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_TILDE] = ACTIONS(807),
    [sym_constant] = ACTIONS(815),
    [sym_identifier] = ACTIONS(815),
    [sym_instance_variable] = ACTIONS(811),
    [sym_class_variable] = ACTIONS(811),
    [sym_global_variable] = ACTIONS(811),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(815),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(815),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [6395] = {
    [aux_sym_exceptions_repeat1] = STATE(8679),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [ts_builtin_sym_end] = ACTIONS(9855),
    [anon_sym___END__] = ACTIONS(9855),
    [anon_sym_LBRACE] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(12334),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9857),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_EQ] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_do] = ACTIONS(9855),
    [anon_sym_EQ_GT] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_PLUS_EQ] = ACTIONS(9855),
    [anon_sym_DASH_EQ] = ACTIONS(9855),
    [anon_sym_STAR_EQ] = ACTIONS(9855),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9855),
    [anon_sym_SLASH_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9855),
    [anon_sym_AMP_EQ] = ACTIONS(9855),
    [anon_sym_PERCENT_EQ] = ACTIONS(9855),
    [anon_sym_GT_GT_EQ] = ACTIONS(9855),
    [anon_sym_LT_LT_EQ] = ACTIONS(9855),
    [anon_sym_CARET_EQ] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9857),
    [anon_sym_AMP_AMP] = ACTIONS(9857),
    [anon_sym_LT_LT] = ACTIONS(9857),
    [anon_sym_GT_GT] = ACTIONS(9857),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9857),
    [anon_sym_PLUS] = ACTIONS(9857),
    [anon_sym_SLASH] = ACTIONS(9857),
    [anon_sym_PERCENT] = ACTIONS(9857),
    [sym_comment] = ACTIONS(87),
  },
  [6396] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(6167),
    [ts_builtin_sym_end] = ACTIONS(5825),
    [anon_sym___END__] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(6167),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(6167),
    [anon_sym_PERCENT] = ACTIONS(6167),
    [sym_comment] = ACTIONS(87),
  },
  [6397] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [ts_builtin_sym_end] = ACTIONS(5825),
    [anon_sym___END__] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(6167),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [6398] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6165),
    [sym__binary_star] = ACTIONS(6167),
    [ts_builtin_sym_end] = ACTIONS(5825),
    [anon_sym___END__] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(6167),
    [anon_sym_AMP] = ACTIONS(6171),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(6183),
    [anon_sym_GT_GT] = ACTIONS(6183),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(6165),
    [anon_sym_SLASH] = ACTIONS(6167),
    [anon_sym_PERCENT] = ACTIONS(6167),
    [sym_comment] = ACTIONS(87),
  },
  [6399] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6165),
    [sym__binary_star] = ACTIONS(6167),
    [ts_builtin_sym_end] = ACTIONS(5825),
    [anon_sym___END__] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(6167),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(6183),
    [anon_sym_GT_GT] = ACTIONS(6183),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(6165),
    [anon_sym_SLASH] = ACTIONS(6167),
    [anon_sym_PERCENT] = ACTIONS(6167),
    [sym_comment] = ACTIONS(87),
  },
  [6400] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6165),
    [sym__binary_star] = ACTIONS(6167),
    [ts_builtin_sym_end] = ACTIONS(5825),
    [anon_sym___END__] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(6169),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(6167),
    [anon_sym_AMP] = ACTIONS(6171),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(6183),
    [anon_sym_GT_GT] = ACTIONS(6183),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_PLUS] = ACTIONS(6165),
    [anon_sym_SLASH] = ACTIONS(6167),
    [anon_sym_PERCENT] = ACTIONS(6167),
    [sym_comment] = ACTIONS(87),
  },
  [6401] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(12336),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [6402] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(6165),
    [sym__binary_star] = ACTIONS(6167),
    [ts_builtin_sym_end] = ACTIONS(5927),
    [anon_sym___END__] = ACTIONS(5927),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(6169),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(6167),
    [anon_sym_AMP] = ACTIONS(6171),
    [anon_sym_LT] = ACTIONS(6173),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(6177),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6179),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(6181),
    [anon_sym_AMP_AMP] = ACTIONS(6181),
    [anon_sym_LT_LT] = ACTIONS(6183),
    [anon_sym_GT_GT] = ACTIONS(6183),
    [anon_sym_EQ_EQ] = ACTIONS(6185),
    [anon_sym_BANG_EQ] = ACTIONS(6181),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6181),
    [anon_sym_LT_EQ_GT] = ACTIONS(6181),
    [anon_sym_EQ_TILDE] = ACTIONS(6181),
    [anon_sym_BANG_TILDE] = ACTIONS(6181),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6173),
    [anon_sym_GT_EQ] = ACTIONS(6187),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_PLUS] = ACTIONS(6165),
    [anon_sym_SLASH] = ACTIONS(6167),
    [anon_sym_PERCENT] = ACTIONS(6167),
    [sym_comment] = ACTIONS(87),
  },
  [6403] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6165),
    [sym__binary_star] = ACTIONS(6167),
    [ts_builtin_sym_end] = ACTIONS(5825),
    [anon_sym___END__] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(6169),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(6167),
    [anon_sym_AMP] = ACTIONS(6171),
    [anon_sym_LT] = ACTIONS(6173),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(6175),
    [anon_sym_DOT_DOT] = ACTIONS(6177),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6179),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(6181),
    [anon_sym_AMP_AMP] = ACTIONS(6181),
    [anon_sym_LT_LT] = ACTIONS(6183),
    [anon_sym_GT_GT] = ACTIONS(6183),
    [anon_sym_EQ_EQ] = ACTIONS(6185),
    [anon_sym_BANG_EQ] = ACTIONS(6181),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6181),
    [anon_sym_LT_EQ_GT] = ACTIONS(6181),
    [anon_sym_EQ_TILDE] = ACTIONS(6181),
    [anon_sym_BANG_TILDE] = ACTIONS(6181),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6173),
    [anon_sym_GT_EQ] = ACTIONS(6187),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_PLUS] = ACTIONS(6165),
    [anon_sym_SLASH] = ACTIONS(6167),
    [anon_sym_PERCENT] = ACTIONS(6167),
    [sym_comment] = ACTIONS(87),
  },
  [6404] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6165),
    [sym__binary_star] = ACTIONS(6167),
    [ts_builtin_sym_end] = ACTIONS(5825),
    [anon_sym___END__] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(6169),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(6167),
    [anon_sym_AMP] = ACTIONS(6171),
    [anon_sym_LT] = ACTIONS(6173),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(6183),
    [anon_sym_GT_GT] = ACTIONS(6183),
    [anon_sym_EQ_EQ] = ACTIONS(6185),
    [anon_sym_BANG_EQ] = ACTIONS(6181),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6181),
    [anon_sym_LT_EQ_GT] = ACTIONS(6181),
    [anon_sym_EQ_TILDE] = ACTIONS(6181),
    [anon_sym_BANG_TILDE] = ACTIONS(6181),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6173),
    [anon_sym_GT_EQ] = ACTIONS(6187),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_PLUS] = ACTIONS(6165),
    [anon_sym_SLASH] = ACTIONS(6167),
    [anon_sym_PERCENT] = ACTIONS(6167),
    [sym_comment] = ACTIONS(87),
  },
  [6405] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6165),
    [sym__binary_star] = ACTIONS(6167),
    [ts_builtin_sym_end] = ACTIONS(5825),
    [anon_sym___END__] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(6167),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(6165),
    [anon_sym_SLASH] = ACTIONS(6167),
    [anon_sym_PERCENT] = ACTIONS(6167),
    [sym_comment] = ACTIONS(87),
  },
  [6406] = {
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [ts_builtin_sym_end] = ACTIONS(11597),
    [anon_sym___END__] = ACTIONS(11597),
    [anon_sym_RBRACE] = ACTIONS(11597),
    [anon_sym_RPAREN] = ACTIONS(11597),
    [anon_sym_COMMA] = ACTIONS(11597),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_end] = ACTIONS(11597),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_when] = ACTIONS(11597),
    [anon_sym_elsif] = ACTIONS(11597),
    [anon_sym_else] = ACTIONS(11597),
    [anon_sym_then] = ACTIONS(11597),
    [anon_sym_ensure] = ACTIONS(11597),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [6407] = {
    [aux_sym_exceptions_repeat1] = STATE(6407),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [ts_builtin_sym_end] = ACTIONS(11597),
    [anon_sym___END__] = ACTIONS(11597),
    [anon_sym_COMMA] = ACTIONS(12340),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [6408] = {
    [aux_sym_exceptions_repeat1] = STATE(3760),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [ts_builtin_sym_end] = ACTIONS(6191),
    [anon_sym___END__] = ACTIONS(6191),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [6409] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(6165),
    [sym__binary_star] = ACTIONS(6167),
    [ts_builtin_sym_end] = ACTIONS(6210),
    [anon_sym___END__] = ACTIONS(6210),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(6169),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(6167),
    [anon_sym_AMP] = ACTIONS(6171),
    [anon_sym_LT] = ACTIONS(6173),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(6175),
    [anon_sym_DOT_DOT] = ACTIONS(6177),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6179),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(6181),
    [anon_sym_AMP_AMP] = ACTIONS(6181),
    [anon_sym_LT_LT] = ACTIONS(6183),
    [anon_sym_GT_GT] = ACTIONS(6183),
    [anon_sym_EQ_EQ] = ACTIONS(6185),
    [anon_sym_BANG_EQ] = ACTIONS(6181),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6181),
    [anon_sym_LT_EQ_GT] = ACTIONS(6181),
    [anon_sym_EQ_TILDE] = ACTIONS(6181),
    [anon_sym_BANG_TILDE] = ACTIONS(6181),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6173),
    [anon_sym_GT_EQ] = ACTIONS(6187),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_PLUS] = ACTIONS(6165),
    [anon_sym_SLASH] = ACTIONS(6167),
    [anon_sym_PERCENT] = ACTIONS(6167),
    [sym_comment] = ACTIONS(87),
  },
  [6410] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8681),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(6419),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(6419),
    [sym_assignment] = STATE(8681),
    [sym_operator_assignment] = STATE(8681),
    [sym_conditional] = STATE(8681),
    [sym_range] = STATE(8681),
    [sym_binary] = STATE(8681),
    [sym_unary] = STATE(8681),
    [sym_left_assignment_list] = STATE(6418),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6419),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(6419),
    [sym_false] = STATE(6419),
    [sym_nil] = STATE(6419),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(6420),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9859),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9861),
    [anon_sym_yield] = ACTIONS(9863),
    [anon_sym_break] = ACTIONS(9865),
    [anon_sym_next] = ACTIONS(9867),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9869),
    [anon_sym_defined_QMARK] = ACTIONS(9871),
    [anon_sym_not] = ACTIONS(9873),
    [anon_sym_BANG] = ACTIONS(9875),
    [anon_sym_TILDE] = ACTIONS(9875),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6411] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3777),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3782),
    [sym_scope_resolution] = STATE(3778),
    [sym_call] = STATE(3778),
    [sym_method_call] = STATE(3782),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(8682),
    [sym__argument] = STATE(8683),
    [sym_splat_argument] = STATE(8683),
    [sym_hash_splat_argument] = STATE(8683),
    [sym_block_argument] = STATE(8683),
    [sym_assignment] = STATE(3777),
    [sym_operator_assignment] = STATE(3777),
    [sym_conditional] = STATE(3777),
    [sym_range] = STATE(3777),
    [sym_binary] = STATE(3777),
    [sym_unary] = STATE(3777),
    [sym_left_assignment_list] = STATE(3781),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3782),
    [sym__variable] = STATE(3778),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3782),
    [sym_false] = STATE(3782),
    [sym_nil] = STATE(3782),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3783),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(8683),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(6241),
    [sym__splat_star] = ACTIONS(6243),
    [sym__unary_minus] = ACTIONS(6245),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(6247),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6249),
    [anon_sym_yield] = ACTIONS(6251),
    [anon_sym_break] = ACTIONS(6253),
    [anon_sym_next] = ACTIONS(6255),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(6257),
    [anon_sym_not] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(6261),
    [anon_sym_TILDE] = ACTIONS(6263),
    [sym_constant] = ACTIONS(6265),
    [sym_identifier] = ACTIONS(6265),
    [sym_instance_variable] = ACTIONS(6267),
    [sym_class_variable] = ACTIONS(6267),
    [sym_global_variable] = ACTIONS(6267),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(6269),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6269),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6412] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3777),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3782),
    [sym_scope_resolution] = STATE(3778),
    [sym_call] = STATE(3778),
    [sym_method_call] = STATE(3782),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(8682),
    [sym__argument] = STATE(8683),
    [sym_splat_argument] = STATE(8683),
    [sym_hash_splat_argument] = STATE(8683),
    [sym_block_argument] = STATE(8683),
    [sym_assignment] = STATE(3777),
    [sym_operator_assignment] = STATE(3777),
    [sym_conditional] = STATE(3777),
    [sym_range] = STATE(3777),
    [sym_binary] = STATE(3777),
    [sym_unary] = STATE(3777),
    [sym_left_assignment_list] = STATE(3781),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3782),
    [sym__variable] = STATE(3778),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3782),
    [sym_false] = STATE(3782),
    [sym_nil] = STATE(3782),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3783),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(8683),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(6241),
    [sym__splat_star] = ACTIONS(6243),
    [sym__unary_minus] = ACTIONS(6245),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(6247),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6249),
    [anon_sym_yield] = ACTIONS(6251),
    [anon_sym_break] = ACTIONS(6253),
    [anon_sym_next] = ACTIONS(6255),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(6257),
    [anon_sym_not] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(6261),
    [anon_sym_TILDE] = ACTIONS(6263),
    [sym_constant] = ACTIONS(6265),
    [sym_identifier] = ACTIONS(6265),
    [sym_instance_variable] = ACTIONS(6267),
    [sym_class_variable] = ACTIONS(6267),
    [sym_global_variable] = ACTIONS(6267),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(6269),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6269),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6413] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3777),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3782),
    [sym_scope_resolution] = STATE(3778),
    [sym_call] = STATE(3778),
    [sym_method_call] = STATE(3782),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(8682),
    [sym__argument] = STATE(8683),
    [sym_splat_argument] = STATE(8683),
    [sym_hash_splat_argument] = STATE(8683),
    [sym_block_argument] = STATE(8683),
    [sym_assignment] = STATE(3777),
    [sym_operator_assignment] = STATE(3777),
    [sym_conditional] = STATE(3777),
    [sym_range] = STATE(3777),
    [sym_binary] = STATE(3777),
    [sym_unary] = STATE(3777),
    [sym_left_assignment_list] = STATE(3781),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3782),
    [sym__variable] = STATE(3778),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3782),
    [sym_false] = STATE(3782),
    [sym_nil] = STATE(3782),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3783),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(8683),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(6241),
    [sym__splat_star] = ACTIONS(6243),
    [sym__unary_minus] = ACTIONS(6245),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(6247),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6249),
    [anon_sym_yield] = ACTIONS(6251),
    [anon_sym_break] = ACTIONS(6253),
    [anon_sym_next] = ACTIONS(6255),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(6257),
    [anon_sym_not] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(6261),
    [anon_sym_TILDE] = ACTIONS(6263),
    [sym_constant] = ACTIONS(6265),
    [sym_identifier] = ACTIONS(6265),
    [sym_instance_variable] = ACTIONS(6267),
    [sym_class_variable] = ACTIONS(6267),
    [sym_global_variable] = ACTIONS(6267),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(6269),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6269),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6414] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3777),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3782),
    [sym_scope_resolution] = STATE(3778),
    [sym_call] = STATE(3778),
    [sym_method_call] = STATE(3782),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(8682),
    [sym__argument] = STATE(8683),
    [sym_splat_argument] = STATE(8683),
    [sym_hash_splat_argument] = STATE(8683),
    [sym_block_argument] = STATE(8683),
    [sym_assignment] = STATE(3777),
    [sym_operator_assignment] = STATE(3777),
    [sym_conditional] = STATE(3777),
    [sym_range] = STATE(3777),
    [sym_binary] = STATE(3777),
    [sym_unary] = STATE(3777),
    [sym_left_assignment_list] = STATE(3781),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3782),
    [sym__variable] = STATE(3778),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3782),
    [sym_false] = STATE(3782),
    [sym_nil] = STATE(3782),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3783),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(8683),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(6241),
    [sym__splat_star] = ACTIONS(6243),
    [sym__unary_minus] = ACTIONS(6245),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(6247),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6249),
    [anon_sym_yield] = ACTIONS(6251),
    [anon_sym_break] = ACTIONS(6253),
    [anon_sym_next] = ACTIONS(6255),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(6257),
    [anon_sym_not] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(6261),
    [anon_sym_TILDE] = ACTIONS(6263),
    [sym_constant] = ACTIONS(6265),
    [sym_identifier] = ACTIONS(6265),
    [sym_instance_variable] = ACTIONS(6267),
    [sym_class_variable] = ACTIONS(6267),
    [sym_global_variable] = ACTIONS(6267),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(6269),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6269),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6415] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8684),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(6419),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(6419),
    [sym_assignment] = STATE(8684),
    [sym_operator_assignment] = STATE(8684),
    [sym_conditional] = STATE(8684),
    [sym_range] = STATE(8684),
    [sym_binary] = STATE(8684),
    [sym_unary] = STATE(8684),
    [sym_left_assignment_list] = STATE(6418),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6419),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(6419),
    [sym_false] = STATE(6419),
    [sym_nil] = STATE(6419),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(6420),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9859),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9861),
    [anon_sym_yield] = ACTIONS(9863),
    [anon_sym_break] = ACTIONS(9865),
    [anon_sym_next] = ACTIONS(9867),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9869),
    [anon_sym_defined_QMARK] = ACTIONS(9871),
    [anon_sym_not] = ACTIONS(9873),
    [anon_sym_BANG] = ACTIONS(9875),
    [anon_sym_TILDE] = ACTIONS(9875),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6416] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(6419),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(6419),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(6418),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6419),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(6419),
    [sym_false] = STATE(6419),
    [sym_nil] = STATE(6419),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(6420),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9859),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9861),
    [anon_sym_yield] = ACTIONS(9863),
    [anon_sym_break] = ACTIONS(9865),
    [anon_sym_next] = ACTIONS(9867),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9869),
    [anon_sym_defined_QMARK] = ACTIONS(9871),
    [anon_sym_not] = ACTIONS(9873),
    [anon_sym_BANG] = ACTIONS(9875),
    [anon_sym_TILDE] = ACTIONS(9875),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6417] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(12343),
    [sym__binary_star] = ACTIONS(12345),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(12347),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(12345),
    [anon_sym_AMP] = ACTIONS(12349),
    [anon_sym_LT] = ACTIONS(12351),
    [anon_sym_if] = ACTIONS(4211),
    [anon_sym_unless] = ACTIONS(4211),
    [anon_sym_while] = ACTIONS(4211),
    [anon_sym_until] = ACTIONS(4211),
    [anon_sym_rescue] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(12353),
    [anon_sym_DOT_DOT] = ACTIONS(12355),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12357),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(12359),
    [anon_sym_AMP_AMP] = ACTIONS(12359),
    [anon_sym_LT_LT] = ACTIONS(12361),
    [anon_sym_GT_GT] = ACTIONS(12361),
    [anon_sym_EQ_EQ] = ACTIONS(12363),
    [anon_sym_BANG_EQ] = ACTIONS(12359),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12359),
    [anon_sym_LT_EQ_GT] = ACTIONS(12359),
    [anon_sym_EQ_TILDE] = ACTIONS(12359),
    [anon_sym_BANG_TILDE] = ACTIONS(12359),
    [anon_sym_LT_EQ] = ACTIONS(12351),
    [anon_sym_GT] = ACTIONS(12351),
    [anon_sym_GT_EQ] = ACTIONS(12365),
    [anon_sym_CARET] = ACTIONS(12367),
    [anon_sym_PLUS] = ACTIONS(12343),
    [anon_sym_SLASH] = ACTIONS(12345),
    [anon_sym_PERCENT] = ACTIONS(12345),
    [sym_comment] = ACTIONS(87),
  },
  [6418] = {
    [anon_sym_EQ] = ACTIONS(12369),
    [sym_comment] = ACTIONS(87),
  },
  [6419] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(12371),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(12373),
    [anon_sym_DASH_EQ] = ACTIONS(12373),
    [anon_sym_STAR_EQ] = ACTIONS(12373),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12373),
    [anon_sym_SLASH_EQ] = ACTIONS(12373),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12373),
    [anon_sym_PIPE_EQ] = ACTIONS(12373),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12373),
    [anon_sym_AMP_EQ] = ACTIONS(12373),
    [anon_sym_PERCENT_EQ] = ACTIONS(12373),
    [anon_sym_GT_GT_EQ] = ACTIONS(12373),
    [anon_sym_LT_LT_EQ] = ACTIONS(12373),
    [anon_sym_CARET_EQ] = ACTIONS(12373),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [6420] = {
    [sym_string] = STATE(8697),
    [aux_sym_chained_string_repeat1] = STATE(8697),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [6421] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(12343),
    [sym__binary_star] = ACTIONS(12345),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(12347),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(12345),
    [anon_sym_AMP] = ACTIONS(12349),
    [anon_sym_LT] = ACTIONS(12351),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(12353),
    [anon_sym_DOT_DOT] = ACTIONS(12355),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12357),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(12359),
    [anon_sym_AMP_AMP] = ACTIONS(12359),
    [anon_sym_LT_LT] = ACTIONS(12361),
    [anon_sym_GT_GT] = ACTIONS(12361),
    [anon_sym_EQ_EQ] = ACTIONS(12363),
    [anon_sym_BANG_EQ] = ACTIONS(12359),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12359),
    [anon_sym_LT_EQ_GT] = ACTIONS(12359),
    [anon_sym_EQ_TILDE] = ACTIONS(12359),
    [anon_sym_BANG_TILDE] = ACTIONS(12359),
    [anon_sym_LT_EQ] = ACTIONS(12351),
    [anon_sym_GT] = ACTIONS(12351),
    [anon_sym_GT_EQ] = ACTIONS(12365),
    [anon_sym_CARET] = ACTIONS(12367),
    [anon_sym_PLUS] = ACTIONS(12343),
    [anon_sym_SLASH] = ACTIONS(12345),
    [anon_sym_PERCENT] = ACTIONS(12345),
    [sym_comment] = ACTIONS(87),
  },
  [6422] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(9893),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [6423] = {
    [sym_string] = STATE(6461),
    [aux_sym_chained_string_repeat1] = STATE(6461),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [6424] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8698),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(6419),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(6419),
    [sym_assignment] = STATE(8698),
    [sym_operator_assignment] = STATE(8698),
    [sym_conditional] = STATE(8698),
    [sym_range] = STATE(8698),
    [sym_binary] = STATE(8698),
    [sym_unary] = STATE(8698),
    [sym_left_assignment_list] = STATE(6418),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6419),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(6419),
    [sym_false] = STATE(6419),
    [sym_nil] = STATE(6419),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(6420),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9859),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9861),
    [anon_sym_yield] = ACTIONS(9863),
    [anon_sym_break] = ACTIONS(9865),
    [anon_sym_next] = ACTIONS(9867),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9869),
    [anon_sym_defined_QMARK] = ACTIONS(9871),
    [anon_sym_not] = ACTIONS(9873),
    [anon_sym_BANG] = ACTIONS(9875),
    [anon_sym_TILDE] = ACTIONS(9875),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6425] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(12343),
    [sym__binary_star] = ACTIONS(12345),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(12347),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(12345),
    [anon_sym_AMP] = ACTIONS(12349),
    [anon_sym_LT] = ACTIONS(12351),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_unless] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_until] = ACTIONS(3281),
    [anon_sym_rescue] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(12353),
    [anon_sym_DOT_DOT] = ACTIONS(12355),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12357),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(12359),
    [anon_sym_AMP_AMP] = ACTIONS(12359),
    [anon_sym_LT_LT] = ACTIONS(12361),
    [anon_sym_GT_GT] = ACTIONS(12361),
    [anon_sym_EQ_EQ] = ACTIONS(12363),
    [anon_sym_BANG_EQ] = ACTIONS(12359),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12359),
    [anon_sym_LT_EQ_GT] = ACTIONS(12359),
    [anon_sym_EQ_TILDE] = ACTIONS(12359),
    [anon_sym_BANG_TILDE] = ACTIONS(12359),
    [anon_sym_LT_EQ] = ACTIONS(12351),
    [anon_sym_GT] = ACTIONS(12351),
    [anon_sym_GT_EQ] = ACTIONS(12365),
    [anon_sym_CARET] = ACTIONS(12367),
    [anon_sym_PLUS] = ACTIONS(12343),
    [anon_sym_SLASH] = ACTIONS(12345),
    [anon_sym_PERCENT] = ACTIONS(12345),
    [sym_comment] = ACTIONS(87),
  },
  [6426] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8699),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3782),
    [sym_scope_resolution] = STATE(3778),
    [sym_call] = STATE(3778),
    [sym_method_call] = STATE(3782),
    [sym_assignment] = STATE(8699),
    [sym_operator_assignment] = STATE(8699),
    [sym_conditional] = STATE(8699),
    [sym_range] = STATE(8699),
    [sym_binary] = STATE(8699),
    [sym_unary] = STATE(8699),
    [sym_left_assignment_list] = STATE(3781),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3782),
    [sym__variable] = STATE(3778),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3782),
    [sym_false] = STATE(3782),
    [sym_nil] = STATE(3782),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(6423),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(6245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6249),
    [anon_sym_yield] = ACTIONS(6251),
    [anon_sym_break] = ACTIONS(6253),
    [anon_sym_next] = ACTIONS(6255),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9877),
    [anon_sym_defined_QMARK] = ACTIONS(6257),
    [anon_sym_not] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(6263),
    [anon_sym_TILDE] = ACTIONS(6263),
    [sym_constant] = ACTIONS(6269),
    [sym_identifier] = ACTIONS(6269),
    [sym_instance_variable] = ACTIONS(6267),
    [sym_class_variable] = ACTIONS(6267),
    [sym_global_variable] = ACTIONS(6267),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(6269),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6269),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6427] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8700),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3782),
    [sym_scope_resolution] = STATE(3778),
    [sym_call] = STATE(3778),
    [sym_method_call] = STATE(3782),
    [sym_assignment] = STATE(8700),
    [sym_operator_assignment] = STATE(8700),
    [sym_conditional] = STATE(8700),
    [sym_range] = STATE(8700),
    [sym_binary] = STATE(8700),
    [sym_unary] = STATE(8700),
    [sym_left_assignment_list] = STATE(3781),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3782),
    [sym__variable] = STATE(3778),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3782),
    [sym_false] = STATE(3782),
    [sym_nil] = STATE(3782),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(6423),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(6245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6249),
    [anon_sym_yield] = ACTIONS(6251),
    [anon_sym_break] = ACTIONS(6253),
    [anon_sym_next] = ACTIONS(6255),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9877),
    [anon_sym_defined_QMARK] = ACTIONS(6257),
    [anon_sym_not] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(6263),
    [anon_sym_TILDE] = ACTIONS(6263),
    [sym_constant] = ACTIONS(6269),
    [sym_identifier] = ACTIONS(6269),
    [sym_instance_variable] = ACTIONS(6267),
    [sym_class_variable] = ACTIONS(6267),
    [sym_global_variable] = ACTIONS(6267),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(6269),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6269),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6428] = {
    [anon_sym_COLON] = ACTIONS(12375),
    [sym_comment] = ACTIONS(87),
  },
  [6429] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8702),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3782),
    [sym_scope_resolution] = STATE(3778),
    [sym_call] = STATE(3778),
    [sym_method_call] = STATE(3782),
    [sym_assignment] = STATE(8702),
    [sym_operator_assignment] = STATE(8702),
    [sym_conditional] = STATE(8702),
    [sym_range] = STATE(8702),
    [sym_binary] = STATE(8702),
    [sym_unary] = STATE(8702),
    [sym_left_assignment_list] = STATE(3781),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3782),
    [sym__variable] = STATE(3778),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3782),
    [sym_false] = STATE(3782),
    [sym_nil] = STATE(3782),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(6423),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(6245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6249),
    [anon_sym_yield] = ACTIONS(6251),
    [anon_sym_break] = ACTIONS(6253),
    [anon_sym_next] = ACTIONS(6255),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9877),
    [anon_sym_defined_QMARK] = ACTIONS(6257),
    [anon_sym_not] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(6263),
    [anon_sym_TILDE] = ACTIONS(6263),
    [sym_constant] = ACTIONS(6269),
    [sym_identifier] = ACTIONS(6269),
    [sym_instance_variable] = ACTIONS(6267),
    [sym_class_variable] = ACTIONS(6267),
    [sym_global_variable] = ACTIONS(6267),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(6269),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6269),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6430] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(12377),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [6431] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(9891),
    [sym__binary_star] = ACTIONS(9893),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(9895),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(9893),
    [anon_sym_AMP] = ACTIONS(9897),
    [anon_sym_LT] = ACTIONS(9899),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_unless] = ACTIONS(1625),
    [anon_sym_while] = ACTIONS(1625),
    [anon_sym_until] = ACTIONS(1625),
    [anon_sym_rescue] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(1625),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(9901),
    [anon_sym_DOT_DOT] = ACTIONS(9903),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9905),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(9907),
    [anon_sym_AMP_AMP] = ACTIONS(9907),
    [anon_sym_LT_LT] = ACTIONS(9909),
    [anon_sym_GT_GT] = ACTIONS(9909),
    [anon_sym_EQ_EQ] = ACTIONS(9911),
    [anon_sym_BANG_EQ] = ACTIONS(9907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9907),
    [anon_sym_LT_EQ_GT] = ACTIONS(9907),
    [anon_sym_EQ_TILDE] = ACTIONS(9907),
    [anon_sym_BANG_TILDE] = ACTIONS(9907),
    [anon_sym_LT_EQ] = ACTIONS(9899),
    [anon_sym_GT] = ACTIONS(9899),
    [anon_sym_GT_EQ] = ACTIONS(9913),
    [anon_sym_CARET] = ACTIONS(9915),
    [anon_sym_PLUS] = ACTIONS(9891),
    [anon_sym_SLASH] = ACTIONS(9893),
    [anon_sym_PERCENT] = ACTIONS(9893),
    [sym_comment] = ACTIONS(87),
  },
  [6432] = {
    [sym_heredoc_body] = STATE(8704),
    [aux_sym_call_repeat1] = STATE(8704),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [6433] = {
    [sym_heredoc_body] = STATE(8704),
    [aux_sym_call_repeat1] = STATE(8704),
    [aux_sym_argument_list_repeat1] = STATE(8706),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(12379),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [6434] = {
    [sym_string] = STATE(6461),
    [aux_sym_chained_string_repeat1] = STATE(6461),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(12381),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [6435] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(9891),
    [sym__binary_star] = ACTIONS(9893),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(9895),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(9893),
    [anon_sym_AMP] = ACTIONS(9897),
    [anon_sym_LT] = ACTIONS(9899),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(9901),
    [anon_sym_DOT_DOT] = ACTIONS(9903),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9905),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(9907),
    [anon_sym_AMP_AMP] = ACTIONS(9907),
    [anon_sym_LT_LT] = ACTIONS(9909),
    [anon_sym_GT_GT] = ACTIONS(9909),
    [anon_sym_EQ_EQ] = ACTIONS(9911),
    [anon_sym_BANG_EQ] = ACTIONS(9907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9907),
    [anon_sym_LT_EQ_GT] = ACTIONS(9907),
    [anon_sym_EQ_TILDE] = ACTIONS(9907),
    [anon_sym_BANG_TILDE] = ACTIONS(9907),
    [anon_sym_LT_EQ] = ACTIONS(9899),
    [anon_sym_GT] = ACTIONS(9899),
    [anon_sym_GT_EQ] = ACTIONS(9913),
    [anon_sym_CARET] = ACTIONS(9915),
    [anon_sym_PLUS] = ACTIONS(9891),
    [anon_sym_SLASH] = ACTIONS(9893),
    [anon_sym_PERCENT] = ACTIONS(9893),
    [sym_comment] = ACTIONS(87),
  },
  [6436] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8707),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(6419),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(6419),
    [sym_assignment] = STATE(8707),
    [sym_operator_assignment] = STATE(8707),
    [sym_conditional] = STATE(8707),
    [sym_range] = STATE(8707),
    [sym_binary] = STATE(8707),
    [sym_unary] = STATE(8707),
    [sym_left_assignment_list] = STATE(6418),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6419),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(6419),
    [sym_false] = STATE(6419),
    [sym_nil] = STATE(6419),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(6420),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9859),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9861),
    [anon_sym_yield] = ACTIONS(9863),
    [anon_sym_break] = ACTIONS(9865),
    [anon_sym_next] = ACTIONS(9867),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9869),
    [anon_sym_defined_QMARK] = ACTIONS(9871),
    [anon_sym_not] = ACTIONS(9873),
    [anon_sym_BANG] = ACTIONS(9875),
    [anon_sym_TILDE] = ACTIONS(9875),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6437] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8708),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3782),
    [sym_scope_resolution] = STATE(3778),
    [sym_call] = STATE(3778),
    [sym_method_call] = STATE(3782),
    [sym_assignment] = STATE(8708),
    [sym_operator_assignment] = STATE(8708),
    [sym_conditional] = STATE(8708),
    [sym_range] = STATE(8708),
    [sym_binary] = STATE(8708),
    [sym_unary] = STATE(8708),
    [sym_left_assignment_list] = STATE(3781),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3782),
    [sym__variable] = STATE(3778),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3782),
    [sym_false] = STATE(3782),
    [sym_nil] = STATE(3782),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(6423),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(6245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6249),
    [anon_sym_yield] = ACTIONS(6251),
    [anon_sym_break] = ACTIONS(6253),
    [anon_sym_next] = ACTIONS(6255),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9877),
    [anon_sym_defined_QMARK] = ACTIONS(6257),
    [anon_sym_not] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(6263),
    [anon_sym_TILDE] = ACTIONS(6263),
    [sym_constant] = ACTIONS(6269),
    [sym_identifier] = ACTIONS(6269),
    [sym_instance_variable] = ACTIONS(6267),
    [sym_class_variable] = ACTIONS(6267),
    [sym_global_variable] = ACTIONS(6267),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(6269),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6269),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6438] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8709),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3782),
    [sym_scope_resolution] = STATE(3778),
    [sym_call] = STATE(3778),
    [sym_method_call] = STATE(3782),
    [sym_assignment] = STATE(8709),
    [sym_operator_assignment] = STATE(8709),
    [sym_conditional] = STATE(8709),
    [sym_range] = STATE(8709),
    [sym_binary] = STATE(8709),
    [sym_unary] = STATE(8709),
    [sym_left_assignment_list] = STATE(3781),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3782),
    [sym__variable] = STATE(3778),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3782),
    [sym_false] = STATE(3782),
    [sym_nil] = STATE(3782),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(6423),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(6245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6249),
    [anon_sym_yield] = ACTIONS(6251),
    [anon_sym_break] = ACTIONS(6253),
    [anon_sym_next] = ACTIONS(6255),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9877),
    [anon_sym_defined_QMARK] = ACTIONS(6257),
    [anon_sym_not] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(6263),
    [anon_sym_TILDE] = ACTIONS(6263),
    [sym_constant] = ACTIONS(6269),
    [sym_identifier] = ACTIONS(6269),
    [sym_instance_variable] = ACTIONS(6267),
    [sym_class_variable] = ACTIONS(6267),
    [sym_global_variable] = ACTIONS(6267),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(6269),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6269),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6439] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8710),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3782),
    [sym_scope_resolution] = STATE(3778),
    [sym_call] = STATE(3778),
    [sym_method_call] = STATE(3782),
    [sym_assignment] = STATE(8710),
    [sym_operator_assignment] = STATE(8710),
    [sym_conditional] = STATE(8710),
    [sym_range] = STATE(8710),
    [sym_binary] = STATE(8710),
    [sym_unary] = STATE(8710),
    [sym_left_assignment_list] = STATE(3781),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3782),
    [sym__variable] = STATE(3778),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3782),
    [sym_false] = STATE(3782),
    [sym_nil] = STATE(3782),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(6423),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(6245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6249),
    [anon_sym_yield] = ACTIONS(6251),
    [anon_sym_break] = ACTIONS(6253),
    [anon_sym_next] = ACTIONS(6255),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9877),
    [anon_sym_defined_QMARK] = ACTIONS(6257),
    [anon_sym_not] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(6263),
    [anon_sym_TILDE] = ACTIONS(6263),
    [sym_constant] = ACTIONS(6269),
    [sym_identifier] = ACTIONS(6269),
    [sym_instance_variable] = ACTIONS(6267),
    [sym_class_variable] = ACTIONS(6267),
    [sym_global_variable] = ACTIONS(6267),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(6269),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6269),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6440] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8711),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3782),
    [sym_scope_resolution] = STATE(3778),
    [sym_call] = STATE(3778),
    [sym_method_call] = STATE(3782),
    [sym_assignment] = STATE(8711),
    [sym_operator_assignment] = STATE(8711),
    [sym_conditional] = STATE(8711),
    [sym_range] = STATE(8711),
    [sym_binary] = STATE(8711),
    [sym_unary] = STATE(8711),
    [sym_left_assignment_list] = STATE(3781),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3782),
    [sym__variable] = STATE(3778),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3782),
    [sym_false] = STATE(3782),
    [sym_nil] = STATE(3782),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(6423),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(6245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6249),
    [anon_sym_yield] = ACTIONS(6251),
    [anon_sym_break] = ACTIONS(6253),
    [anon_sym_next] = ACTIONS(6255),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9877),
    [anon_sym_defined_QMARK] = ACTIONS(6257),
    [anon_sym_not] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(6263),
    [anon_sym_TILDE] = ACTIONS(6263),
    [sym_constant] = ACTIONS(6269),
    [sym_identifier] = ACTIONS(6269),
    [sym_instance_variable] = ACTIONS(6267),
    [sym_class_variable] = ACTIONS(6267),
    [sym_global_variable] = ACTIONS(6267),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(6269),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6269),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6441] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8712),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3782),
    [sym_scope_resolution] = STATE(3778),
    [sym_call] = STATE(3778),
    [sym_method_call] = STATE(3782),
    [sym_assignment] = STATE(8712),
    [sym_operator_assignment] = STATE(8712),
    [sym_conditional] = STATE(8712),
    [sym_range] = STATE(8712),
    [sym_binary] = STATE(8712),
    [sym_unary] = STATE(8712),
    [sym_left_assignment_list] = STATE(3781),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3782),
    [sym__variable] = STATE(3778),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3782),
    [sym_false] = STATE(3782),
    [sym_nil] = STATE(3782),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(6423),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(6245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6249),
    [anon_sym_yield] = ACTIONS(6251),
    [anon_sym_break] = ACTIONS(6253),
    [anon_sym_next] = ACTIONS(6255),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9877),
    [anon_sym_defined_QMARK] = ACTIONS(6257),
    [anon_sym_not] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(6263),
    [anon_sym_TILDE] = ACTIONS(6263),
    [sym_constant] = ACTIONS(6269),
    [sym_identifier] = ACTIONS(6269),
    [sym_instance_variable] = ACTIONS(6267),
    [sym_class_variable] = ACTIONS(6267),
    [sym_global_variable] = ACTIONS(6267),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(6269),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6269),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6442] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(8713),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(8713),
    [sym_operator_assignment] = STATE(8713),
    [sym_conditional] = STATE(8713),
    [sym_range] = STATE(8713),
    [sym_binary] = STATE(8713),
    [sym_unary] = STATE(8713),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6443] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8714),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3782),
    [sym_scope_resolution] = STATE(3778),
    [sym_call] = STATE(3778),
    [sym_method_call] = STATE(3782),
    [sym_assignment] = STATE(8714),
    [sym_operator_assignment] = STATE(8714),
    [sym_conditional] = STATE(8714),
    [sym_range] = STATE(8714),
    [sym_binary] = STATE(8714),
    [sym_unary] = STATE(8714),
    [sym_left_assignment_list] = STATE(3781),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3782),
    [sym__variable] = STATE(3778),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3782),
    [sym_false] = STATE(3782),
    [sym_nil] = STATE(3782),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(6423),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(6245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6249),
    [anon_sym_yield] = ACTIONS(6251),
    [anon_sym_break] = ACTIONS(6253),
    [anon_sym_next] = ACTIONS(6255),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9877),
    [anon_sym_defined_QMARK] = ACTIONS(6257),
    [anon_sym_not] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(6263),
    [anon_sym_TILDE] = ACTIONS(6263),
    [sym_constant] = ACTIONS(6269),
    [sym_identifier] = ACTIONS(6269),
    [sym_instance_variable] = ACTIONS(6267),
    [sym_class_variable] = ACTIONS(6267),
    [sym_global_variable] = ACTIONS(6267),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(6269),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6269),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6444] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8715),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3782),
    [sym_scope_resolution] = STATE(3778),
    [sym_call] = STATE(3778),
    [sym_method_call] = STATE(3782),
    [sym_assignment] = STATE(8715),
    [sym_operator_assignment] = STATE(8715),
    [sym_conditional] = STATE(8715),
    [sym_range] = STATE(8715),
    [sym_binary] = STATE(8715),
    [sym_unary] = STATE(8715),
    [sym_left_assignment_list] = STATE(3781),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3782),
    [sym__variable] = STATE(3778),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3782),
    [sym_false] = STATE(3782),
    [sym_nil] = STATE(3782),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(6423),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(6245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6249),
    [anon_sym_yield] = ACTIONS(6251),
    [anon_sym_break] = ACTIONS(6253),
    [anon_sym_next] = ACTIONS(6255),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9877),
    [anon_sym_defined_QMARK] = ACTIONS(6257),
    [anon_sym_not] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(6263),
    [anon_sym_TILDE] = ACTIONS(6263),
    [sym_constant] = ACTIONS(6269),
    [sym_identifier] = ACTIONS(6269),
    [sym_instance_variable] = ACTIONS(6267),
    [sym_class_variable] = ACTIONS(6267),
    [sym_global_variable] = ACTIONS(6267),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(6269),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6269),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6445] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8716),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3782),
    [sym_scope_resolution] = STATE(3778),
    [sym_call] = STATE(3778),
    [sym_method_call] = STATE(3782),
    [sym_assignment] = STATE(8716),
    [sym_operator_assignment] = STATE(8716),
    [sym_conditional] = STATE(8716),
    [sym_range] = STATE(8716),
    [sym_binary] = STATE(8716),
    [sym_unary] = STATE(8716),
    [sym_left_assignment_list] = STATE(3781),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3782),
    [sym__variable] = STATE(3778),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3782),
    [sym_false] = STATE(3782),
    [sym_nil] = STATE(3782),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(6423),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(6245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6249),
    [anon_sym_yield] = ACTIONS(6251),
    [anon_sym_break] = ACTIONS(6253),
    [anon_sym_next] = ACTIONS(6255),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9877),
    [anon_sym_defined_QMARK] = ACTIONS(6257),
    [anon_sym_not] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(6263),
    [anon_sym_TILDE] = ACTIONS(6263),
    [sym_constant] = ACTIONS(6269),
    [sym_identifier] = ACTIONS(6269),
    [sym_instance_variable] = ACTIONS(6267),
    [sym_class_variable] = ACTIONS(6267),
    [sym_global_variable] = ACTIONS(6267),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(6269),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6269),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6446] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8717),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3782),
    [sym_scope_resolution] = STATE(3778),
    [sym_call] = STATE(3778),
    [sym_method_call] = STATE(3782),
    [sym_assignment] = STATE(8717),
    [sym_operator_assignment] = STATE(8717),
    [sym_conditional] = STATE(8717),
    [sym_range] = STATE(8717),
    [sym_binary] = STATE(8717),
    [sym_unary] = STATE(8717),
    [sym_left_assignment_list] = STATE(3781),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3782),
    [sym__variable] = STATE(3778),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3782),
    [sym_false] = STATE(3782),
    [sym_nil] = STATE(3782),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(6423),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(6245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6249),
    [anon_sym_yield] = ACTIONS(6251),
    [anon_sym_break] = ACTIONS(6253),
    [anon_sym_next] = ACTIONS(6255),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9877),
    [anon_sym_defined_QMARK] = ACTIONS(6257),
    [anon_sym_not] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(6263),
    [anon_sym_TILDE] = ACTIONS(6263),
    [sym_constant] = ACTIONS(6269),
    [sym_identifier] = ACTIONS(6269),
    [sym_instance_variable] = ACTIONS(6267),
    [sym_class_variable] = ACTIONS(6267),
    [sym_global_variable] = ACTIONS(6267),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(6269),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6269),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6447] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8718),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3818),
    [sym_scope_resolution] = STATE(3814),
    [sym_call] = STATE(3814),
    [sym_method_call] = STATE(3818),
    [sym_assignment] = STATE(8718),
    [sym_operator_assignment] = STATE(8718),
    [sym_conditional] = STATE(8718),
    [sym_range] = STATE(8718),
    [sym_binary] = STATE(8718),
    [sym_unary] = STATE(8718),
    [sym_left_assignment_list] = STATE(3817),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3818),
    [sym__variable] = STATE(3814),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3818),
    [sym_false] = STATE(3818),
    [sym_nil] = STATE(3818),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(6492),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(6319),
    [anon_sym_yield] = ACTIONS(6321),
    [anon_sym_break] = ACTIONS(6323),
    [anon_sym_next] = ACTIONS(6325),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(9957),
    [anon_sym_defined_QMARK] = ACTIONS(6327),
    [anon_sym_not] = ACTIONS(6329),
    [anon_sym_BANG] = ACTIONS(6333),
    [anon_sym_TILDE] = ACTIONS(6333),
    [sym_constant] = ACTIONS(6339),
    [sym_identifier] = ACTIONS(6339),
    [sym_instance_variable] = ACTIONS(6337),
    [sym_class_variable] = ACTIONS(6337),
    [sym_global_variable] = ACTIONS(6337),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(6339),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6339),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [6448] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8719),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3818),
    [sym_scope_resolution] = STATE(3814),
    [sym_call] = STATE(3814),
    [sym_method_call] = STATE(3818),
    [sym_assignment] = STATE(8719),
    [sym_operator_assignment] = STATE(8719),
    [sym_conditional] = STATE(8719),
    [sym_range] = STATE(8719),
    [sym_binary] = STATE(8719),
    [sym_unary] = STATE(8719),
    [sym_left_assignment_list] = STATE(3817),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3818),
    [sym__variable] = STATE(3814),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3818),
    [sym_false] = STATE(3818),
    [sym_nil] = STATE(3818),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(6492),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(6319),
    [anon_sym_yield] = ACTIONS(6321),
    [anon_sym_break] = ACTIONS(6323),
    [anon_sym_next] = ACTIONS(6325),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(9957),
    [anon_sym_defined_QMARK] = ACTIONS(6327),
    [anon_sym_not] = ACTIONS(6329),
    [anon_sym_BANG] = ACTIONS(6333),
    [anon_sym_TILDE] = ACTIONS(6333),
    [sym_constant] = ACTIONS(6339),
    [sym_identifier] = ACTIONS(6339),
    [sym_instance_variable] = ACTIONS(6337),
    [sym_class_variable] = ACTIONS(6337),
    [sym_global_variable] = ACTIONS(6337),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(6339),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6339),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [6449] = {
    [anon_sym_COLON] = ACTIONS(12383),
    [sym_comment] = ACTIONS(87),
  },
  [6450] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8721),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3818),
    [sym_scope_resolution] = STATE(3814),
    [sym_call] = STATE(3814),
    [sym_method_call] = STATE(3818),
    [sym_assignment] = STATE(8721),
    [sym_operator_assignment] = STATE(8721),
    [sym_conditional] = STATE(8721),
    [sym_range] = STATE(8721),
    [sym_binary] = STATE(8721),
    [sym_unary] = STATE(8721),
    [sym_left_assignment_list] = STATE(3817),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3818),
    [sym__variable] = STATE(3814),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3818),
    [sym_false] = STATE(3818),
    [sym_nil] = STATE(3818),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(6492),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(6319),
    [anon_sym_yield] = ACTIONS(6321),
    [anon_sym_break] = ACTIONS(6323),
    [anon_sym_next] = ACTIONS(6325),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(9957),
    [anon_sym_defined_QMARK] = ACTIONS(6327),
    [anon_sym_not] = ACTIONS(6329),
    [anon_sym_BANG] = ACTIONS(6333),
    [anon_sym_TILDE] = ACTIONS(6333),
    [sym_constant] = ACTIONS(6339),
    [sym_identifier] = ACTIONS(6339),
    [sym_instance_variable] = ACTIONS(6337),
    [sym_class_variable] = ACTIONS(6337),
    [sym_global_variable] = ACTIONS(6337),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(6339),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6339),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [6451] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(12385),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [6452] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(9963),
    [sym__binary_star] = ACTIONS(9965),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(9967),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(9969),
    [anon_sym_AMP] = ACTIONS(9971),
    [anon_sym_EQ] = ACTIONS(1631),
    [anon_sym_LT] = ACTIONS(9973),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_unless] = ACTIONS(1625),
    [anon_sym_while] = ACTIONS(1625),
    [anon_sym_until] = ACTIONS(1625),
    [anon_sym_rescue] = ACTIONS(1625),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(1625),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_PLUS_EQ] = ACTIONS(1625),
    [anon_sym_DASH_EQ] = ACTIONS(1625),
    [anon_sym_STAR_EQ] = ACTIONS(1625),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1625),
    [anon_sym_SLASH_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1625),
    [anon_sym_AMP_EQ] = ACTIONS(1625),
    [anon_sym_PERCENT_EQ] = ACTIONS(1625),
    [anon_sym_GT_GT_EQ] = ACTIONS(1625),
    [anon_sym_LT_LT_EQ] = ACTIONS(1625),
    [anon_sym_CARET_EQ] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(9975),
    [anon_sym_DOT_DOT] = ACTIONS(9977),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9979),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(9981),
    [anon_sym_AMP_AMP] = ACTIONS(9981),
    [anon_sym_LT_LT] = ACTIONS(9983),
    [anon_sym_GT_GT] = ACTIONS(9983),
    [anon_sym_EQ_EQ] = ACTIONS(9981),
    [anon_sym_BANG_EQ] = ACTIONS(9985),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9985),
    [anon_sym_LT_EQ_GT] = ACTIONS(9985),
    [anon_sym_EQ_TILDE] = ACTIONS(9985),
    [anon_sym_BANG_TILDE] = ACTIONS(9985),
    [anon_sym_LT_EQ] = ACTIONS(9973),
    [anon_sym_GT] = ACTIONS(9973),
    [anon_sym_GT_EQ] = ACTIONS(9987),
    [anon_sym_CARET] = ACTIONS(9967),
    [anon_sym_PLUS] = ACTIONS(9989),
    [anon_sym_SLASH] = ACTIONS(9969),
    [anon_sym_PERCENT] = ACTIONS(9969),
    [sym_comment] = ACTIONS(87),
  },
  [6453] = {
    [sym_heredoc_body] = STATE(8723),
    [aux_sym_call_repeat1] = STATE(8723),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [6454] = {
    [sym_heredoc_body] = STATE(8723),
    [aux_sym_call_repeat1] = STATE(8723),
    [aux_sym_argument_list_repeat1] = STATE(8725),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(12387),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [6455] = {
    [sym_string] = STATE(6512),
    [aux_sym_chained_string_repeat1] = STATE(6512),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(747),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(12389),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [6456] = {
    [sym_heredoc_body] = STATE(8726),
    [aux_sym_call_repeat1] = STATE(8726),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [6457] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3777),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3782),
    [sym_scope_resolution] = STATE(3778),
    [sym_call] = STATE(3778),
    [sym_method_call] = STATE(3782),
    [sym__argument] = STATE(2565),
    [sym_splat_argument] = STATE(2565),
    [sym_hash_splat_argument] = STATE(2565),
    [sym_block_argument] = STATE(2565),
    [sym_assignment] = STATE(3777),
    [sym_operator_assignment] = STATE(3777),
    [sym_conditional] = STATE(3777),
    [sym_range] = STATE(3777),
    [sym_binary] = STATE(3777),
    [sym_unary] = STATE(3777),
    [sym_left_assignment_list] = STATE(3781),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3782),
    [sym__variable] = STATE(3778),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3782),
    [sym_false] = STATE(3782),
    [sym_nil] = STATE(3782),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3783),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(8727),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2565),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(6241),
    [sym__splat_star] = ACTIONS(6243),
    [sym__unary_minus] = ACTIONS(6245),
    [sym__identifier_hash_key] = ACTIONS(6247),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12391),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6249),
    [anon_sym_yield] = ACTIONS(6251),
    [anon_sym_break] = ACTIONS(6253),
    [anon_sym_next] = ACTIONS(6255),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9877),
    [anon_sym_defined_QMARK] = ACTIONS(6257),
    [anon_sym_not] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(6263),
    [anon_sym_TILDE] = ACTIONS(6263),
    [sym_constant] = ACTIONS(6265),
    [sym_identifier] = ACTIONS(6265),
    [sym_instance_variable] = ACTIONS(6267),
    [sym_class_variable] = ACTIONS(6267),
    [sym_global_variable] = ACTIONS(6267),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(6269),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6269),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6458] = {
    [sym_heredoc_body] = STATE(8728),
    [aux_sym_call_repeat1] = STATE(8728),
    [aux_sym_argument_list_repeat1] = STATE(8729),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(9925),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [6459] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8730),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3782),
    [sym_scope_resolution] = STATE(3778),
    [sym_call] = STATE(3778),
    [sym_method_call] = STATE(3782),
    [sym_splat_argument] = STATE(8731),
    [sym_assignment] = STATE(8730),
    [sym_operator_assignment] = STATE(8730),
    [sym_conditional] = STATE(8730),
    [sym_range] = STATE(8730),
    [sym_binary] = STATE(8730),
    [sym_unary] = STATE(8730),
    [sym_right_assignment_list] = STATE(2570),
    [sym__arg_or_splat_arg] = STATE(8731),
    [sym_left_assignment_list] = STATE(3781),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3782),
    [sym__variable] = STATE(3778),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3782),
    [sym_false] = STATE(3782),
    [sym_nil] = STATE(3782),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(6423),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__splat_star] = ACTIONS(9883),
    [sym__unary_minus] = ACTIONS(6245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6249),
    [anon_sym_yield] = ACTIONS(6251),
    [anon_sym_break] = ACTIONS(6253),
    [anon_sym_next] = ACTIONS(6255),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9877),
    [anon_sym_defined_QMARK] = ACTIONS(6257),
    [anon_sym_not] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(6263),
    [anon_sym_TILDE] = ACTIONS(6263),
    [sym_constant] = ACTIONS(6269),
    [sym_identifier] = ACTIONS(6269),
    [sym_instance_variable] = ACTIONS(6267),
    [sym_class_variable] = ACTIONS(6267),
    [sym_global_variable] = ACTIONS(6267),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(6269),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6269),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6460] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8732),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3782),
    [sym_scope_resolution] = STATE(3778),
    [sym_call] = STATE(3778),
    [sym_method_call] = STATE(3782),
    [sym_assignment] = STATE(8732),
    [sym_operator_assignment] = STATE(8732),
    [sym_conditional] = STATE(8732),
    [sym_range] = STATE(8732),
    [sym_binary] = STATE(8732),
    [sym_unary] = STATE(8732),
    [sym_left_assignment_list] = STATE(3781),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3782),
    [sym__variable] = STATE(3778),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3782),
    [sym_false] = STATE(3782),
    [sym_nil] = STATE(3782),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(6423),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(6245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6249),
    [anon_sym_yield] = ACTIONS(6251),
    [anon_sym_break] = ACTIONS(6253),
    [anon_sym_next] = ACTIONS(6255),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9877),
    [anon_sym_defined_QMARK] = ACTIONS(6257),
    [anon_sym_not] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(6263),
    [anon_sym_TILDE] = ACTIONS(6263),
    [sym_constant] = ACTIONS(6269),
    [sym_identifier] = ACTIONS(6269),
    [sym_instance_variable] = ACTIONS(6267),
    [sym_class_variable] = ACTIONS(6267),
    [sym_global_variable] = ACTIONS(6267),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(6269),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6269),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6461] = {
    [sym_string] = STATE(8733),
    [aux_sym_chained_string_repeat1] = STATE(8733),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_EQ_GT] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [6462] = {
    [aux_sym_undef_repeat1] = STATE(8734),
    [sym__line_break] = ACTIONS(5497),
    [sym__heredoc_body_start] = ACTIONS(5497),
    [anon_sym_COMMA] = ACTIONS(2253),
    [anon_sym_SEMI] = ACTIONS(5497),
    [anon_sym_if] = ACTIONS(5497),
    [anon_sym_unless] = ACTIONS(5497),
    [anon_sym_while] = ACTIONS(5497),
    [anon_sym_until] = ACTIONS(5497),
    [anon_sym_rescue] = ACTIONS(5497),
    [sym_comment] = ACTIONS(87),
  },
  [6463] = {
    [sym__line_break] = ACTIONS(5815),
    [sym__heredoc_body_start] = ACTIONS(5815),
    [sym__binary_minus] = ACTIONS(6283),
    [sym__binary_star] = ACTIONS(6285),
    [anon_sym_PIPE] = ACTIONS(6287),
    [anon_sym_SEMI] = ACTIONS(5815),
    [anon_sym_STAR_STAR] = ACTIONS(6285),
    [anon_sym_AMP] = ACTIONS(6289),
    [anon_sym_LT] = ACTIONS(6291),
    [anon_sym_if] = ACTIONS(5815),
    [anon_sym_unless] = ACTIONS(5815),
    [anon_sym_while] = ACTIONS(5815),
    [anon_sym_until] = ACTIONS(5815),
    [anon_sym_rescue] = ACTIONS(5815),
    [anon_sym_QMARK] = ACTIONS(6293),
    [anon_sym_DOT_DOT] = ACTIONS(6295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6297),
    [anon_sym_and] = ACTIONS(6299),
    [anon_sym_or] = ACTIONS(6299),
    [anon_sym_PIPE_PIPE] = ACTIONS(6301),
    [anon_sym_AMP_AMP] = ACTIONS(6301),
    [anon_sym_LT_LT] = ACTIONS(6303),
    [anon_sym_GT_GT] = ACTIONS(6303),
    [anon_sym_EQ_EQ] = ACTIONS(6305),
    [anon_sym_BANG_EQ] = ACTIONS(6301),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6301),
    [anon_sym_LT_EQ_GT] = ACTIONS(6301),
    [anon_sym_EQ_TILDE] = ACTIONS(6301),
    [anon_sym_BANG_TILDE] = ACTIONS(6301),
    [anon_sym_LT_EQ] = ACTIONS(6291),
    [anon_sym_GT] = ACTIONS(6291),
    [anon_sym_GT_EQ] = ACTIONS(6307),
    [anon_sym_CARET] = ACTIONS(6309),
    [anon_sym_PLUS] = ACTIONS(6283),
    [anon_sym_SLASH] = ACTIONS(6285),
    [anon_sym_PERCENT] = ACTIONS(6285),
    [sym_comment] = ACTIONS(87),
  },
  [6464] = {
    [sym__line_break] = ACTIONS(5817),
    [sym__heredoc_body_start] = ACTIONS(5817),
    [sym__binary_minus] = ACTIONS(6283),
    [sym__binary_star] = ACTIONS(6285),
    [anon_sym_PIPE] = ACTIONS(6287),
    [anon_sym_SEMI] = ACTIONS(5817),
    [anon_sym_STAR_STAR] = ACTIONS(6285),
    [anon_sym_AMP] = ACTIONS(6289),
    [anon_sym_LT] = ACTIONS(6291),
    [anon_sym_if] = ACTIONS(5817),
    [anon_sym_unless] = ACTIONS(5817),
    [anon_sym_while] = ACTIONS(5817),
    [anon_sym_until] = ACTIONS(5817),
    [anon_sym_rescue] = ACTIONS(5817),
    [anon_sym_QMARK] = ACTIONS(6293),
    [anon_sym_DOT_DOT] = ACTIONS(6295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6297),
    [anon_sym_and] = ACTIONS(6299),
    [anon_sym_or] = ACTIONS(6299),
    [anon_sym_PIPE_PIPE] = ACTIONS(6301),
    [anon_sym_AMP_AMP] = ACTIONS(6301),
    [anon_sym_LT_LT] = ACTIONS(6303),
    [anon_sym_GT_GT] = ACTIONS(6303),
    [anon_sym_EQ_EQ] = ACTIONS(6305),
    [anon_sym_BANG_EQ] = ACTIONS(6301),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6301),
    [anon_sym_LT_EQ_GT] = ACTIONS(6301),
    [anon_sym_EQ_TILDE] = ACTIONS(6301),
    [anon_sym_BANG_TILDE] = ACTIONS(6301),
    [anon_sym_LT_EQ] = ACTIONS(6291),
    [anon_sym_GT] = ACTIONS(6291),
    [anon_sym_GT_EQ] = ACTIONS(6307),
    [anon_sym_CARET] = ACTIONS(6309),
    [anon_sym_PLUS] = ACTIONS(6283),
    [anon_sym_SLASH] = ACTIONS(6285),
    [anon_sym_PERCENT] = ACTIONS(6285),
    [sym_comment] = ACTIONS(87),
  },
  [6465] = {
    [sym__line_break] = ACTIONS(5819),
    [sym__heredoc_body_start] = ACTIONS(5819),
    [sym__binary_minus] = ACTIONS(6283),
    [sym__binary_star] = ACTIONS(6285),
    [anon_sym_PIPE] = ACTIONS(6287),
    [anon_sym_SEMI] = ACTIONS(5819),
    [anon_sym_STAR_STAR] = ACTIONS(6285),
    [anon_sym_AMP] = ACTIONS(6289),
    [anon_sym_LT] = ACTIONS(6291),
    [anon_sym_if] = ACTIONS(5819),
    [anon_sym_unless] = ACTIONS(5819),
    [anon_sym_while] = ACTIONS(5819),
    [anon_sym_until] = ACTIONS(5819),
    [anon_sym_rescue] = ACTIONS(5819),
    [anon_sym_QMARK] = ACTIONS(6293),
    [anon_sym_DOT_DOT] = ACTIONS(6295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6297),
    [anon_sym_and] = ACTIONS(6299),
    [anon_sym_or] = ACTIONS(6299),
    [anon_sym_PIPE_PIPE] = ACTIONS(6301),
    [anon_sym_AMP_AMP] = ACTIONS(6301),
    [anon_sym_LT_LT] = ACTIONS(6303),
    [anon_sym_GT_GT] = ACTIONS(6303),
    [anon_sym_EQ_EQ] = ACTIONS(6305),
    [anon_sym_BANG_EQ] = ACTIONS(6301),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6301),
    [anon_sym_LT_EQ_GT] = ACTIONS(6301),
    [anon_sym_EQ_TILDE] = ACTIONS(6301),
    [anon_sym_BANG_TILDE] = ACTIONS(6301),
    [anon_sym_LT_EQ] = ACTIONS(6291),
    [anon_sym_GT] = ACTIONS(6291),
    [anon_sym_GT_EQ] = ACTIONS(6307),
    [anon_sym_CARET] = ACTIONS(6309),
    [anon_sym_PLUS] = ACTIONS(6283),
    [anon_sym_SLASH] = ACTIONS(6285),
    [anon_sym_PERCENT] = ACTIONS(6285),
    [sym_comment] = ACTIONS(87),
  },
  [6466] = {
    [sym__line_break] = ACTIONS(5821),
    [sym__heredoc_body_start] = ACTIONS(5821),
    [sym__binary_minus] = ACTIONS(6283),
    [sym__binary_star] = ACTIONS(6285),
    [anon_sym_PIPE] = ACTIONS(6287),
    [anon_sym_SEMI] = ACTIONS(5821),
    [anon_sym_STAR_STAR] = ACTIONS(6285),
    [anon_sym_AMP] = ACTIONS(6289),
    [anon_sym_LT] = ACTIONS(6291),
    [anon_sym_if] = ACTIONS(5821),
    [anon_sym_unless] = ACTIONS(5821),
    [anon_sym_while] = ACTIONS(5821),
    [anon_sym_until] = ACTIONS(5821),
    [anon_sym_rescue] = ACTIONS(5821),
    [anon_sym_QMARK] = ACTIONS(6293),
    [anon_sym_DOT_DOT] = ACTIONS(6295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6297),
    [anon_sym_and] = ACTIONS(6299),
    [anon_sym_or] = ACTIONS(6299),
    [anon_sym_PIPE_PIPE] = ACTIONS(6301),
    [anon_sym_AMP_AMP] = ACTIONS(6301),
    [anon_sym_LT_LT] = ACTIONS(6303),
    [anon_sym_GT_GT] = ACTIONS(6303),
    [anon_sym_EQ_EQ] = ACTIONS(6305),
    [anon_sym_BANG_EQ] = ACTIONS(6301),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6301),
    [anon_sym_LT_EQ_GT] = ACTIONS(6301),
    [anon_sym_EQ_TILDE] = ACTIONS(6301),
    [anon_sym_BANG_TILDE] = ACTIONS(6301),
    [anon_sym_LT_EQ] = ACTIONS(6291),
    [anon_sym_GT] = ACTIONS(6291),
    [anon_sym_GT_EQ] = ACTIONS(6307),
    [anon_sym_CARET] = ACTIONS(6309),
    [anon_sym_PLUS] = ACTIONS(6283),
    [anon_sym_SLASH] = ACTIONS(6285),
    [anon_sym_PERCENT] = ACTIONS(6285),
    [sym_comment] = ACTIONS(87),
  },
  [6467] = {
    [sym__line_break] = ACTIONS(5823),
    [sym__heredoc_body_start] = ACTIONS(5823),
    [sym__binary_minus] = ACTIONS(6283),
    [sym__binary_star] = ACTIONS(6285),
    [anon_sym_PIPE] = ACTIONS(6287),
    [anon_sym_SEMI] = ACTIONS(5823),
    [anon_sym_STAR_STAR] = ACTIONS(6285),
    [anon_sym_AMP] = ACTIONS(6289),
    [anon_sym_LT] = ACTIONS(6291),
    [anon_sym_if] = ACTIONS(5823),
    [anon_sym_unless] = ACTIONS(5823),
    [anon_sym_while] = ACTIONS(5823),
    [anon_sym_until] = ACTIONS(5823),
    [anon_sym_rescue] = ACTIONS(5823),
    [anon_sym_QMARK] = ACTIONS(6293),
    [anon_sym_DOT_DOT] = ACTIONS(6295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6297),
    [anon_sym_and] = ACTIONS(6299),
    [anon_sym_or] = ACTIONS(6299),
    [anon_sym_PIPE_PIPE] = ACTIONS(6301),
    [anon_sym_AMP_AMP] = ACTIONS(6301),
    [anon_sym_LT_LT] = ACTIONS(6303),
    [anon_sym_GT_GT] = ACTIONS(6303),
    [anon_sym_EQ_EQ] = ACTIONS(6305),
    [anon_sym_BANG_EQ] = ACTIONS(6301),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6301),
    [anon_sym_LT_EQ_GT] = ACTIONS(6301),
    [anon_sym_EQ_TILDE] = ACTIONS(6301),
    [anon_sym_BANG_TILDE] = ACTIONS(6301),
    [anon_sym_LT_EQ] = ACTIONS(6291),
    [anon_sym_GT] = ACTIONS(6291),
    [anon_sym_GT_EQ] = ACTIONS(6307),
    [anon_sym_CARET] = ACTIONS(6309),
    [anon_sym_PLUS] = ACTIONS(6283),
    [anon_sym_SLASH] = ACTIONS(6285),
    [anon_sym_PERCENT] = ACTIONS(6285),
    [sym_comment] = ACTIONS(87),
  },
  [6468] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(6285),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(6285),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(6285),
    [anon_sym_PERCENT] = ACTIONS(6285),
    [sym_comment] = ACTIONS(87),
  },
  [6469] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(6285),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [6470] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6283),
    [sym__binary_star] = ACTIONS(6285),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(6285),
    [anon_sym_AMP] = ACTIONS(6289),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(6303),
    [anon_sym_GT_GT] = ACTIONS(6303),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(6283),
    [anon_sym_SLASH] = ACTIONS(6285),
    [anon_sym_PERCENT] = ACTIONS(6285),
    [sym_comment] = ACTIONS(87),
  },
  [6471] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6283),
    [sym__binary_star] = ACTIONS(6285),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(6285),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(6303),
    [anon_sym_GT_GT] = ACTIONS(6303),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(6283),
    [anon_sym_SLASH] = ACTIONS(6285),
    [anon_sym_PERCENT] = ACTIONS(6285),
    [sym_comment] = ACTIONS(87),
  },
  [6472] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6283),
    [sym__binary_star] = ACTIONS(6285),
    [anon_sym_PIPE] = ACTIONS(6287),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(6285),
    [anon_sym_AMP] = ACTIONS(6289),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(6303),
    [anon_sym_GT_GT] = ACTIONS(6303),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(6309),
    [anon_sym_PLUS] = ACTIONS(6283),
    [anon_sym_SLASH] = ACTIONS(6285),
    [anon_sym_PERCENT] = ACTIONS(6285),
    [sym_comment] = ACTIONS(87),
  },
  [6473] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(12393),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [6474] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(6283),
    [sym__binary_star] = ACTIONS(6285),
    [anon_sym_PIPE] = ACTIONS(6287),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(6285),
    [anon_sym_AMP] = ACTIONS(6289),
    [anon_sym_LT] = ACTIONS(6291),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(6295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6297),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(6301),
    [anon_sym_AMP_AMP] = ACTIONS(6301),
    [anon_sym_LT_LT] = ACTIONS(6303),
    [anon_sym_GT_GT] = ACTIONS(6303),
    [anon_sym_EQ_EQ] = ACTIONS(6305),
    [anon_sym_BANG_EQ] = ACTIONS(6301),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6301),
    [anon_sym_LT_EQ_GT] = ACTIONS(6301),
    [anon_sym_EQ_TILDE] = ACTIONS(6301),
    [anon_sym_BANG_TILDE] = ACTIONS(6301),
    [anon_sym_LT_EQ] = ACTIONS(6291),
    [anon_sym_GT] = ACTIONS(6291),
    [anon_sym_GT_EQ] = ACTIONS(6307),
    [anon_sym_CARET] = ACTIONS(6309),
    [anon_sym_PLUS] = ACTIONS(6283),
    [anon_sym_SLASH] = ACTIONS(6285),
    [anon_sym_PERCENT] = ACTIONS(6285),
    [sym_comment] = ACTIONS(87),
  },
  [6475] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6283),
    [sym__binary_star] = ACTIONS(6285),
    [anon_sym_PIPE] = ACTIONS(6287),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(6285),
    [anon_sym_AMP] = ACTIONS(6289),
    [anon_sym_LT] = ACTIONS(6291),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(6293),
    [anon_sym_DOT_DOT] = ACTIONS(6295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6297),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(6301),
    [anon_sym_AMP_AMP] = ACTIONS(6301),
    [anon_sym_LT_LT] = ACTIONS(6303),
    [anon_sym_GT_GT] = ACTIONS(6303),
    [anon_sym_EQ_EQ] = ACTIONS(6305),
    [anon_sym_BANG_EQ] = ACTIONS(6301),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6301),
    [anon_sym_LT_EQ_GT] = ACTIONS(6301),
    [anon_sym_EQ_TILDE] = ACTIONS(6301),
    [anon_sym_BANG_TILDE] = ACTIONS(6301),
    [anon_sym_LT_EQ] = ACTIONS(6291),
    [anon_sym_GT] = ACTIONS(6291),
    [anon_sym_GT_EQ] = ACTIONS(6307),
    [anon_sym_CARET] = ACTIONS(6309),
    [anon_sym_PLUS] = ACTIONS(6283),
    [anon_sym_SLASH] = ACTIONS(6285),
    [anon_sym_PERCENT] = ACTIONS(6285),
    [sym_comment] = ACTIONS(87),
  },
  [6476] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6283),
    [sym__binary_star] = ACTIONS(6285),
    [anon_sym_PIPE] = ACTIONS(6287),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(6285),
    [anon_sym_AMP] = ACTIONS(6289),
    [anon_sym_LT] = ACTIONS(6291),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(6303),
    [anon_sym_GT_GT] = ACTIONS(6303),
    [anon_sym_EQ_EQ] = ACTIONS(6305),
    [anon_sym_BANG_EQ] = ACTIONS(6301),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6301),
    [anon_sym_LT_EQ_GT] = ACTIONS(6301),
    [anon_sym_EQ_TILDE] = ACTIONS(6301),
    [anon_sym_BANG_TILDE] = ACTIONS(6301),
    [anon_sym_LT_EQ] = ACTIONS(6291),
    [anon_sym_GT] = ACTIONS(6291),
    [anon_sym_GT_EQ] = ACTIONS(6307),
    [anon_sym_CARET] = ACTIONS(6309),
    [anon_sym_PLUS] = ACTIONS(6283),
    [anon_sym_SLASH] = ACTIONS(6285),
    [anon_sym_PERCENT] = ACTIONS(6285),
    [sym_comment] = ACTIONS(87),
  },
  [6477] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6283),
    [sym__binary_star] = ACTIONS(6285),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(6285),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(6283),
    [anon_sym_SLASH] = ACTIONS(6285),
    [anon_sym_PERCENT] = ACTIONS(6285),
    [sym_comment] = ACTIONS(87),
  },
  [6478] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(8736),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(6488),
    [sym_scope_resolution] = STATE(6486),
    [sym_call] = STATE(6486),
    [sym_method_call] = STATE(6488),
    [sym_assignment] = STATE(8736),
    [sym_operator_assignment] = STATE(8736),
    [sym_conditional] = STATE(8736),
    [sym_range] = STATE(8736),
    [sym_binary] = STATE(8736),
    [sym_unary] = STATE(8736),
    [sym_left_assignment_list] = STATE(6487),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6488),
    [sym__variable] = STATE(6486),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(6488),
    [sym_false] = STATE(6488),
    [sym_nil] = STATE(6488),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(6489),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(9935),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(9937),
    [anon_sym_yield] = ACTIONS(9939),
    [anon_sym_break] = ACTIONS(9941),
    [anon_sym_next] = ACTIONS(9943),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(9945),
    [anon_sym_defined_QMARK] = ACTIONS(9947),
    [anon_sym_not] = ACTIONS(9949),
    [anon_sym_BANG] = ACTIONS(9951),
    [anon_sym_TILDE] = ACTIONS(9951),
    [sym_constant] = ACTIONS(9953),
    [sym_identifier] = ACTIONS(9953),
    [sym_instance_variable] = ACTIONS(9955),
    [sym_class_variable] = ACTIONS(9955),
    [sym_global_variable] = ACTIONS(9955),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(9953),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9953),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [6479] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3813),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3818),
    [sym_scope_resolution] = STATE(3814),
    [sym_call] = STATE(3814),
    [sym_method_call] = STATE(3818),
    [sym_argument_list] = STATE(3610),
    [sym__argument_list_with_parens] = STATE(3815),
    [sym__argument] = STATE(3816),
    [sym_splat_argument] = STATE(3816),
    [sym_hash_splat_argument] = STATE(3816),
    [sym_block_argument] = STATE(3816),
    [sym_assignment] = STATE(3813),
    [sym_operator_assignment] = STATE(3813),
    [sym_conditional] = STATE(3813),
    [sym_range] = STATE(3813),
    [sym_binary] = STATE(3813),
    [sym_unary] = STATE(3813),
    [sym_left_assignment_list] = STATE(3817),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3818),
    [sym__variable] = STATE(3814),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3818),
    [sym_false] = STATE(3818),
    [sym_nil] = STATE(3818),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3819),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(3816),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(6311),
    [sym__splat_star] = ACTIONS(6313),
    [sym__unary_minus] = ACTIONS(6315),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(6317),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(6319),
    [anon_sym_yield] = ACTIONS(6321),
    [anon_sym_break] = ACTIONS(6323),
    [anon_sym_next] = ACTIONS(6325),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(365),
    [anon_sym_DASH_EQ] = ACTIONS(365),
    [anon_sym_STAR_EQ] = ACTIONS(365),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(365),
    [anon_sym_SLASH_EQ] = ACTIONS(365),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(365),
    [anon_sym_PIPE_EQ] = ACTIONS(365),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(365),
    [anon_sym_AMP_EQ] = ACTIONS(365),
    [anon_sym_PERCENT_EQ] = ACTIONS(365),
    [anon_sym_GT_GT_EQ] = ACTIONS(365),
    [anon_sym_LT_LT_EQ] = ACTIONS(365),
    [anon_sym_CARET_EQ] = ACTIONS(365),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_PERCENT] = ACTIONS(377),
    [anon_sym_defined_QMARK] = ACTIONS(6327),
    [anon_sym_not] = ACTIONS(6329),
    [anon_sym_BANG] = ACTIONS(6331),
    [anon_sym_TILDE] = ACTIONS(6333),
    [sym_constant] = ACTIONS(6335),
    [sym_identifier] = ACTIONS(6335),
    [sym_instance_variable] = ACTIONS(6337),
    [sym_class_variable] = ACTIONS(6337),
    [sym_global_variable] = ACTIONS(6337),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(6339),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6339),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [6480] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3813),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3818),
    [sym_scope_resolution] = STATE(3814),
    [sym_call] = STATE(3814),
    [sym_method_call] = STATE(3818),
    [sym_argument_list] = STATE(3611),
    [sym__argument_list_with_parens] = STATE(3815),
    [sym__argument] = STATE(3816),
    [sym_splat_argument] = STATE(3816),
    [sym_hash_splat_argument] = STATE(3816),
    [sym_block_argument] = STATE(3816),
    [sym_assignment] = STATE(3813),
    [sym_operator_assignment] = STATE(3813),
    [sym_conditional] = STATE(3813),
    [sym_range] = STATE(3813),
    [sym_binary] = STATE(3813),
    [sym_unary] = STATE(3813),
    [sym_left_assignment_list] = STATE(3817),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3818),
    [sym__variable] = STATE(3814),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3818),
    [sym_false] = STATE(3818),
    [sym_nil] = STATE(3818),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3819),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(3816),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(6311),
    [sym__splat_star] = ACTIONS(6313),
    [sym__unary_minus] = ACTIONS(6315),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(6317),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_EQ] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(6319),
    [anon_sym_yield] = ACTIONS(6321),
    [anon_sym_break] = ACTIONS(6323),
    [anon_sym_next] = ACTIONS(6325),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(417),
    [anon_sym_DASH_EQ] = ACTIONS(417),
    [anon_sym_STAR_EQ] = ACTIONS(417),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(417),
    [anon_sym_SLASH_EQ] = ACTIONS(417),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(417),
    [anon_sym_PIPE_EQ] = ACTIONS(417),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(417),
    [anon_sym_AMP_EQ] = ACTIONS(417),
    [anon_sym_PERCENT_EQ] = ACTIONS(417),
    [anon_sym_GT_GT_EQ] = ACTIONS(417),
    [anon_sym_LT_LT_EQ] = ACTIONS(417),
    [anon_sym_CARET_EQ] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(6327),
    [anon_sym_not] = ACTIONS(6329),
    [anon_sym_BANG] = ACTIONS(6331),
    [anon_sym_TILDE] = ACTIONS(6333),
    [sym_constant] = ACTIONS(6335),
    [sym_identifier] = ACTIONS(6335),
    [sym_instance_variable] = ACTIONS(6337),
    [sym_class_variable] = ACTIONS(6337),
    [sym_global_variable] = ACTIONS(6337),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(6339),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6339),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [6481] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3813),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3818),
    [sym_scope_resolution] = STATE(3814),
    [sym_call] = STATE(3814),
    [sym_method_call] = STATE(3818),
    [sym_argument_list] = STATE(3612),
    [sym__argument_list_with_parens] = STATE(3815),
    [sym__argument] = STATE(3816),
    [sym_splat_argument] = STATE(3816),
    [sym_hash_splat_argument] = STATE(3816),
    [sym_block_argument] = STATE(3816),
    [sym_assignment] = STATE(3813),
    [sym_operator_assignment] = STATE(3813),
    [sym_conditional] = STATE(3813),
    [sym_range] = STATE(3813),
    [sym_binary] = STATE(3813),
    [sym_unary] = STATE(3813),
    [sym_left_assignment_list] = STATE(3817),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3818),
    [sym__variable] = STATE(3814),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3818),
    [sym_false] = STATE(3818),
    [sym_nil] = STATE(3818),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3819),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(3816),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(6311),
    [sym__splat_star] = ACTIONS(6313),
    [sym__unary_minus] = ACTIONS(6315),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(6317),
    [anon_sym_LBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_EQ] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(6319),
    [anon_sym_yield] = ACTIONS(6321),
    [anon_sym_break] = ACTIONS(6323),
    [anon_sym_next] = ACTIONS(6325),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(421),
    [anon_sym_DASH_EQ] = ACTIONS(421),
    [anon_sym_STAR_EQ] = ACTIONS(421),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(421),
    [anon_sym_SLASH_EQ] = ACTIONS(421),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(421),
    [anon_sym_PIPE_EQ] = ACTIONS(421),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(421),
    [anon_sym_AMP_EQ] = ACTIONS(421),
    [anon_sym_PERCENT_EQ] = ACTIONS(421),
    [anon_sym_GT_GT_EQ] = ACTIONS(421),
    [anon_sym_LT_LT_EQ] = ACTIONS(421),
    [anon_sym_CARET_EQ] = ACTIONS(421),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(6327),
    [anon_sym_not] = ACTIONS(6329),
    [anon_sym_BANG] = ACTIONS(6331),
    [anon_sym_TILDE] = ACTIONS(6333),
    [sym_constant] = ACTIONS(6335),
    [sym_identifier] = ACTIONS(6335),
    [sym_instance_variable] = ACTIONS(6337),
    [sym_class_variable] = ACTIONS(6337),
    [sym_global_variable] = ACTIONS(6337),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(6339),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6339),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [6482] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3813),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3818),
    [sym_scope_resolution] = STATE(3814),
    [sym_call] = STATE(3814),
    [sym_method_call] = STATE(3818),
    [sym_argument_list] = STATE(3613),
    [sym__argument_list_with_parens] = STATE(3815),
    [sym__argument] = STATE(3816),
    [sym_splat_argument] = STATE(3816),
    [sym_hash_splat_argument] = STATE(3816),
    [sym_block_argument] = STATE(3816),
    [sym_assignment] = STATE(3813),
    [sym_operator_assignment] = STATE(3813),
    [sym_conditional] = STATE(3813),
    [sym_range] = STATE(3813),
    [sym_binary] = STATE(3813),
    [sym_unary] = STATE(3813),
    [sym_left_assignment_list] = STATE(3817),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3818),
    [sym__variable] = STATE(3814),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3818),
    [sym_false] = STATE(3818),
    [sym_nil] = STATE(3818),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3819),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(3816),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(6311),
    [sym__splat_star] = ACTIONS(6313),
    [sym__unary_minus] = ACTIONS(6315),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(6317),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(427),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(6319),
    [anon_sym_yield] = ACTIONS(6321),
    [anon_sym_break] = ACTIONS(6323),
    [anon_sym_next] = ACTIONS(6325),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(425),
    [anon_sym_DASH_EQ] = ACTIONS(425),
    [anon_sym_STAR_EQ] = ACTIONS(425),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(425),
    [anon_sym_SLASH_EQ] = ACTIONS(425),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(425),
    [anon_sym_PIPE_EQ] = ACTIONS(425),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(425),
    [anon_sym_AMP_EQ] = ACTIONS(425),
    [anon_sym_PERCENT_EQ] = ACTIONS(425),
    [anon_sym_GT_GT_EQ] = ACTIONS(425),
    [anon_sym_LT_LT_EQ] = ACTIONS(425),
    [anon_sym_CARET_EQ] = ACTIONS(425),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(6327),
    [anon_sym_not] = ACTIONS(6329),
    [anon_sym_BANG] = ACTIONS(6331),
    [anon_sym_TILDE] = ACTIONS(6333),
    [sym_constant] = ACTIONS(6335),
    [sym_identifier] = ACTIONS(6335),
    [sym_instance_variable] = ACTIONS(6337),
    [sym_class_variable] = ACTIONS(6337),
    [sym_global_variable] = ACTIONS(6337),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(6339),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6339),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [6483] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(8737),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(6488),
    [sym_scope_resolution] = STATE(6486),
    [sym_call] = STATE(6486),
    [sym_method_call] = STATE(6488),
    [sym_assignment] = STATE(8737),
    [sym_operator_assignment] = STATE(8737),
    [sym_conditional] = STATE(8737),
    [sym_range] = STATE(8737),
    [sym_binary] = STATE(8737),
    [sym_unary] = STATE(8737),
    [sym_left_assignment_list] = STATE(6487),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6488),
    [sym__variable] = STATE(6486),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(6488),
    [sym_false] = STATE(6488),
    [sym_nil] = STATE(6488),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(6489),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(9935),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(9937),
    [anon_sym_yield] = ACTIONS(9939),
    [anon_sym_break] = ACTIONS(9941),
    [anon_sym_next] = ACTIONS(9943),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(9945),
    [anon_sym_defined_QMARK] = ACTIONS(9947),
    [anon_sym_not] = ACTIONS(9949),
    [anon_sym_BANG] = ACTIONS(9951),
    [anon_sym_TILDE] = ACTIONS(9951),
    [sym_constant] = ACTIONS(9953),
    [sym_identifier] = ACTIONS(9953),
    [sym_instance_variable] = ACTIONS(9955),
    [sym_class_variable] = ACTIONS(9955),
    [sym_global_variable] = ACTIONS(9955),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(9953),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9953),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [6484] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(3628),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(6488),
    [sym_scope_resolution] = STATE(6486),
    [sym_call] = STATE(6486),
    [sym_method_call] = STATE(6488),
    [sym_assignment] = STATE(3628),
    [sym_operator_assignment] = STATE(3628),
    [sym_conditional] = STATE(3628),
    [sym_range] = STATE(3628),
    [sym_binary] = STATE(3628),
    [sym_unary] = STATE(3628),
    [sym_left_assignment_list] = STATE(6487),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6488),
    [sym__variable] = STATE(6486),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(6488),
    [sym_false] = STATE(6488),
    [sym_nil] = STATE(6488),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(6489),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(9935),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(9937),
    [anon_sym_yield] = ACTIONS(9939),
    [anon_sym_break] = ACTIONS(9941),
    [anon_sym_next] = ACTIONS(9943),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(9945),
    [anon_sym_defined_QMARK] = ACTIONS(9947),
    [anon_sym_not] = ACTIONS(9949),
    [anon_sym_BANG] = ACTIONS(9951),
    [anon_sym_TILDE] = ACTIONS(9951),
    [sym_constant] = ACTIONS(9953),
    [sym_identifier] = ACTIONS(9953),
    [sym_instance_variable] = ACTIONS(9955),
    [sym_class_variable] = ACTIONS(9955),
    [sym_global_variable] = ACTIONS(9955),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(9953),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9953),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [6485] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(12395),
    [sym__binary_star] = ACTIONS(12397),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(12399),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(12401),
    [anon_sym_AMP] = ACTIONS(12403),
    [anon_sym_EQ] = ACTIONS(4217),
    [anon_sym_LT] = ACTIONS(12405),
    [anon_sym_if] = ACTIONS(4211),
    [anon_sym_unless] = ACTIONS(4211),
    [anon_sym_while] = ACTIONS(4211),
    [anon_sym_until] = ACTIONS(4211),
    [anon_sym_rescue] = ACTIONS(4211),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_PLUS_EQ] = ACTIONS(4211),
    [anon_sym_DASH_EQ] = ACTIONS(4211),
    [anon_sym_STAR_EQ] = ACTIONS(4211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4211),
    [anon_sym_SLASH_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4211),
    [anon_sym_AMP_EQ] = ACTIONS(4211),
    [anon_sym_PERCENT_EQ] = ACTIONS(4211),
    [anon_sym_GT_GT_EQ] = ACTIONS(4211),
    [anon_sym_LT_LT_EQ] = ACTIONS(4211),
    [anon_sym_CARET_EQ] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(12407),
    [anon_sym_DOT_DOT] = ACTIONS(12409),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12411),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(12413),
    [anon_sym_AMP_AMP] = ACTIONS(12413),
    [anon_sym_LT_LT] = ACTIONS(12415),
    [anon_sym_GT_GT] = ACTIONS(12415),
    [anon_sym_EQ_EQ] = ACTIONS(12413),
    [anon_sym_BANG_EQ] = ACTIONS(12417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12417),
    [anon_sym_LT_EQ_GT] = ACTIONS(12417),
    [anon_sym_EQ_TILDE] = ACTIONS(12417),
    [anon_sym_BANG_TILDE] = ACTIONS(12417),
    [anon_sym_LT_EQ] = ACTIONS(12405),
    [anon_sym_GT] = ACTIONS(12405),
    [anon_sym_GT_EQ] = ACTIONS(12419),
    [anon_sym_CARET] = ACTIONS(12399),
    [anon_sym_PLUS] = ACTIONS(12421),
    [anon_sym_SLASH] = ACTIONS(12401),
    [anon_sym_PERCENT] = ACTIONS(12401),
    [sym_comment] = ACTIONS(87),
  },
  [6486] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3813),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3818),
    [sym_scope_resolution] = STATE(3814),
    [sym_call] = STATE(3814),
    [sym_method_call] = STATE(3818),
    [sym_argument_list] = STATE(1062),
    [sym__argument_list_with_parens] = STATE(3815),
    [sym__argument] = STATE(3816),
    [sym_splat_argument] = STATE(3816),
    [sym_hash_splat_argument] = STATE(3816),
    [sym_block_argument] = STATE(3816),
    [sym_do_block] = STATE(426),
    [sym_block] = STATE(426),
    [sym_assignment] = STATE(3813),
    [sym_operator_assignment] = STATE(3813),
    [sym_conditional] = STATE(3813),
    [sym_range] = STATE(3813),
    [sym_binary] = STATE(3813),
    [sym_unary] = STATE(3813),
    [sym_left_assignment_list] = STATE(3817),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3818),
    [sym__variable] = STATE(3814),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3818),
    [sym_false] = STATE(3818),
    [sym_nil] = STATE(3818),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3819),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(3816),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(743),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(6311),
    [sym__splat_star] = ACTIONS(6313),
    [sym__unary_minus] = ACTIONS(6315),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(6317),
    [anon_sym_LBRACE] = ACTIONS(6047),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(6319),
    [anon_sym_yield] = ACTIONS(6321),
    [anon_sym_break] = ACTIONS(6323),
    [anon_sym_next] = ACTIONS(6325),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(769),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(769),
    [anon_sym_until] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(769),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(769),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(6327),
    [anon_sym_not] = ACTIONS(6329),
    [anon_sym_BANG] = ACTIONS(6331),
    [anon_sym_TILDE] = ACTIONS(6333),
    [sym_constant] = ACTIONS(6335),
    [sym_identifier] = ACTIONS(6335),
    [sym_instance_variable] = ACTIONS(6337),
    [sym_class_variable] = ACTIONS(6337),
    [sym_global_variable] = ACTIONS(6337),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(6339),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6339),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [6487] = {
    [anon_sym_EQ] = ACTIONS(12423),
    [sym_comment] = ACTIONS(87),
  },
  [6488] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(12425),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(12427),
    [anon_sym_DASH_EQ] = ACTIONS(12427),
    [anon_sym_STAR_EQ] = ACTIONS(12427),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12427),
    [anon_sym_SLASH_EQ] = ACTIONS(12427),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12427),
    [anon_sym_PIPE_EQ] = ACTIONS(12427),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12427),
    [anon_sym_AMP_EQ] = ACTIONS(12427),
    [anon_sym_PERCENT_EQ] = ACTIONS(12427),
    [anon_sym_GT_GT_EQ] = ACTIONS(12427),
    [anon_sym_LT_LT_EQ] = ACTIONS(12427),
    [anon_sym_CARET_EQ] = ACTIONS(12427),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [6489] = {
    [sym_string] = STATE(8750),
    [aux_sym_chained_string_repeat1] = STATE(8750),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(2551),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [6490] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(12395),
    [sym__binary_star] = ACTIONS(12397),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(12399),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(12401),
    [anon_sym_AMP] = ACTIONS(12403),
    [anon_sym_EQ] = ACTIONS(4249),
    [anon_sym_LT] = ACTIONS(12405),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_PLUS_EQ] = ACTIONS(4247),
    [anon_sym_DASH_EQ] = ACTIONS(4247),
    [anon_sym_STAR_EQ] = ACTIONS(4247),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4247),
    [anon_sym_SLASH_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4247),
    [anon_sym_AMP_EQ] = ACTIONS(4247),
    [anon_sym_PERCENT_EQ] = ACTIONS(4247),
    [anon_sym_GT_GT_EQ] = ACTIONS(4247),
    [anon_sym_LT_LT_EQ] = ACTIONS(4247),
    [anon_sym_CARET_EQ] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(12407),
    [anon_sym_DOT_DOT] = ACTIONS(12409),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12411),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(12413),
    [anon_sym_AMP_AMP] = ACTIONS(12413),
    [anon_sym_LT_LT] = ACTIONS(12415),
    [anon_sym_GT_GT] = ACTIONS(12415),
    [anon_sym_EQ_EQ] = ACTIONS(12413),
    [anon_sym_BANG_EQ] = ACTIONS(12417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12417),
    [anon_sym_LT_EQ_GT] = ACTIONS(12417),
    [anon_sym_EQ_TILDE] = ACTIONS(12417),
    [anon_sym_BANG_TILDE] = ACTIONS(12417),
    [anon_sym_LT_EQ] = ACTIONS(12405),
    [anon_sym_GT] = ACTIONS(12405),
    [anon_sym_GT_EQ] = ACTIONS(12419),
    [anon_sym_CARET] = ACTIONS(12399),
    [anon_sym_PLUS] = ACTIONS(12421),
    [anon_sym_SLASH] = ACTIONS(12401),
    [anon_sym_PERCENT] = ACTIONS(12401),
    [sym_comment] = ACTIONS(87),
  },
  [6491] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(9969),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [6492] = {
    [sym_string] = STATE(6512),
    [aux_sym_chained_string_repeat1] = STATE(6512),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(747),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [6493] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(8751),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(6488),
    [sym_scope_resolution] = STATE(6486),
    [sym_call] = STATE(6486),
    [sym_method_call] = STATE(6488),
    [sym_assignment] = STATE(8751),
    [sym_operator_assignment] = STATE(8751),
    [sym_conditional] = STATE(8751),
    [sym_range] = STATE(8751),
    [sym_binary] = STATE(8751),
    [sym_unary] = STATE(8751),
    [sym_left_assignment_list] = STATE(6487),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6488),
    [sym__variable] = STATE(6486),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(6488),
    [sym_false] = STATE(6488),
    [sym_nil] = STATE(6488),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(6489),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(9935),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(9937),
    [anon_sym_yield] = ACTIONS(9939),
    [anon_sym_break] = ACTIONS(9941),
    [anon_sym_next] = ACTIONS(9943),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(9945),
    [anon_sym_defined_QMARK] = ACTIONS(9947),
    [anon_sym_not] = ACTIONS(9949),
    [anon_sym_BANG] = ACTIONS(9951),
    [anon_sym_TILDE] = ACTIONS(9951),
    [sym_constant] = ACTIONS(9953),
    [sym_identifier] = ACTIONS(9953),
    [sym_instance_variable] = ACTIONS(9955),
    [sym_class_variable] = ACTIONS(9955),
    [sym_global_variable] = ACTIONS(9955),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(9953),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9953),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [6494] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(12395),
    [sym__binary_star] = ACTIONS(12397),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(12399),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(12401),
    [anon_sym_AMP] = ACTIONS(12403),
    [anon_sym_EQ] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(12405),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_unless] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_until] = ACTIONS(3281),
    [anon_sym_rescue] = ACTIONS(3281),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_PLUS_EQ] = ACTIONS(3281),
    [anon_sym_DASH_EQ] = ACTIONS(3281),
    [anon_sym_STAR_EQ] = ACTIONS(3281),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3281),
    [anon_sym_SLASH_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3281),
    [anon_sym_AMP_EQ] = ACTIONS(3281),
    [anon_sym_PERCENT_EQ] = ACTIONS(3281),
    [anon_sym_GT_GT_EQ] = ACTIONS(3281),
    [anon_sym_LT_LT_EQ] = ACTIONS(3281),
    [anon_sym_CARET_EQ] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(12407),
    [anon_sym_DOT_DOT] = ACTIONS(12409),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12411),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(12413),
    [anon_sym_AMP_AMP] = ACTIONS(12413),
    [anon_sym_LT_LT] = ACTIONS(12415),
    [anon_sym_GT_GT] = ACTIONS(12415),
    [anon_sym_EQ_EQ] = ACTIONS(12413),
    [anon_sym_BANG_EQ] = ACTIONS(12417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12417),
    [anon_sym_LT_EQ_GT] = ACTIONS(12417),
    [anon_sym_EQ_TILDE] = ACTIONS(12417),
    [anon_sym_BANG_TILDE] = ACTIONS(12417),
    [anon_sym_LT_EQ] = ACTIONS(12405),
    [anon_sym_GT] = ACTIONS(12405),
    [anon_sym_GT_EQ] = ACTIONS(12419),
    [anon_sym_CARET] = ACTIONS(12399),
    [anon_sym_PLUS] = ACTIONS(12421),
    [anon_sym_SLASH] = ACTIONS(12401),
    [anon_sym_PERCENT] = ACTIONS(12401),
    [sym_comment] = ACTIONS(87),
  },
  [6495] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(9963),
    [sym__binary_star] = ACTIONS(9965),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(9967),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(9969),
    [anon_sym_AMP] = ACTIONS(9971),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(9973),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(9975),
    [anon_sym_DOT_DOT] = ACTIONS(9977),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9979),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(9981),
    [anon_sym_AMP_AMP] = ACTIONS(9981),
    [anon_sym_LT_LT] = ACTIONS(9983),
    [anon_sym_GT_GT] = ACTIONS(9983),
    [anon_sym_EQ_EQ] = ACTIONS(9981),
    [anon_sym_BANG_EQ] = ACTIONS(9985),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9985),
    [anon_sym_LT_EQ_GT] = ACTIONS(9985),
    [anon_sym_EQ_TILDE] = ACTIONS(9985),
    [anon_sym_BANG_TILDE] = ACTIONS(9985),
    [anon_sym_LT_EQ] = ACTIONS(9973),
    [anon_sym_GT] = ACTIONS(9973),
    [anon_sym_GT_EQ] = ACTIONS(9987),
    [anon_sym_CARET] = ACTIONS(9967),
    [anon_sym_PLUS] = ACTIONS(9989),
    [anon_sym_SLASH] = ACTIONS(9969),
    [anon_sym_PERCENT] = ACTIONS(9969),
    [sym_comment] = ACTIONS(87),
  },
  [6496] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(8752),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(6488),
    [sym_scope_resolution] = STATE(6486),
    [sym_call] = STATE(6486),
    [sym_method_call] = STATE(6488),
    [sym_assignment] = STATE(8752),
    [sym_operator_assignment] = STATE(8752),
    [sym_conditional] = STATE(8752),
    [sym_range] = STATE(8752),
    [sym_binary] = STATE(8752),
    [sym_unary] = STATE(8752),
    [sym_left_assignment_list] = STATE(6487),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6488),
    [sym__variable] = STATE(6486),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(6488),
    [sym_false] = STATE(6488),
    [sym_nil] = STATE(6488),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(6489),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(9935),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(9937),
    [anon_sym_yield] = ACTIONS(9939),
    [anon_sym_break] = ACTIONS(9941),
    [anon_sym_next] = ACTIONS(9943),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(9945),
    [anon_sym_defined_QMARK] = ACTIONS(9947),
    [anon_sym_not] = ACTIONS(9949),
    [anon_sym_BANG] = ACTIONS(9951),
    [anon_sym_TILDE] = ACTIONS(9951),
    [sym_constant] = ACTIONS(9953),
    [sym_identifier] = ACTIONS(9953),
    [sym_instance_variable] = ACTIONS(9955),
    [sym_class_variable] = ACTIONS(9955),
    [sym_global_variable] = ACTIONS(9955),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(9953),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9953),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [6497] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8753),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3818),
    [sym_scope_resolution] = STATE(3814),
    [sym_call] = STATE(3814),
    [sym_method_call] = STATE(3818),
    [sym_assignment] = STATE(8753),
    [sym_operator_assignment] = STATE(8753),
    [sym_conditional] = STATE(8753),
    [sym_range] = STATE(8753),
    [sym_binary] = STATE(8753),
    [sym_unary] = STATE(8753),
    [sym_left_assignment_list] = STATE(3817),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3818),
    [sym__variable] = STATE(3814),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3818),
    [sym_false] = STATE(3818),
    [sym_nil] = STATE(3818),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(6492),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(6319),
    [anon_sym_yield] = ACTIONS(6321),
    [anon_sym_break] = ACTIONS(6323),
    [anon_sym_next] = ACTIONS(6325),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(9957),
    [anon_sym_defined_QMARK] = ACTIONS(6327),
    [anon_sym_not] = ACTIONS(6329),
    [anon_sym_BANG] = ACTIONS(6333),
    [anon_sym_TILDE] = ACTIONS(6333),
    [sym_constant] = ACTIONS(6339),
    [sym_identifier] = ACTIONS(6339),
    [sym_instance_variable] = ACTIONS(6337),
    [sym_class_variable] = ACTIONS(6337),
    [sym_global_variable] = ACTIONS(6337),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(6339),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6339),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [6498] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8754),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3818),
    [sym_scope_resolution] = STATE(3814),
    [sym_call] = STATE(3814),
    [sym_method_call] = STATE(3818),
    [sym_assignment] = STATE(8754),
    [sym_operator_assignment] = STATE(8754),
    [sym_conditional] = STATE(8754),
    [sym_range] = STATE(8754),
    [sym_binary] = STATE(8754),
    [sym_unary] = STATE(8754),
    [sym_left_assignment_list] = STATE(3817),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3818),
    [sym__variable] = STATE(3814),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3818),
    [sym_false] = STATE(3818),
    [sym_nil] = STATE(3818),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(6492),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(6319),
    [anon_sym_yield] = ACTIONS(6321),
    [anon_sym_break] = ACTIONS(6323),
    [anon_sym_next] = ACTIONS(6325),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(9957),
    [anon_sym_defined_QMARK] = ACTIONS(6327),
    [anon_sym_not] = ACTIONS(6329),
    [anon_sym_BANG] = ACTIONS(6333),
    [anon_sym_TILDE] = ACTIONS(6333),
    [sym_constant] = ACTIONS(6339),
    [sym_identifier] = ACTIONS(6339),
    [sym_instance_variable] = ACTIONS(6337),
    [sym_class_variable] = ACTIONS(6337),
    [sym_global_variable] = ACTIONS(6337),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(6339),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6339),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [6499] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8755),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3818),
    [sym_scope_resolution] = STATE(3814),
    [sym_call] = STATE(3814),
    [sym_method_call] = STATE(3818),
    [sym_assignment] = STATE(8755),
    [sym_operator_assignment] = STATE(8755),
    [sym_conditional] = STATE(8755),
    [sym_range] = STATE(8755),
    [sym_binary] = STATE(8755),
    [sym_unary] = STATE(8755),
    [sym_left_assignment_list] = STATE(3817),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3818),
    [sym__variable] = STATE(3814),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3818),
    [sym_false] = STATE(3818),
    [sym_nil] = STATE(3818),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(6492),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(6319),
    [anon_sym_yield] = ACTIONS(6321),
    [anon_sym_break] = ACTIONS(6323),
    [anon_sym_next] = ACTIONS(6325),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(9957),
    [anon_sym_defined_QMARK] = ACTIONS(6327),
    [anon_sym_not] = ACTIONS(6329),
    [anon_sym_BANG] = ACTIONS(6333),
    [anon_sym_TILDE] = ACTIONS(6333),
    [sym_constant] = ACTIONS(6339),
    [sym_identifier] = ACTIONS(6339),
    [sym_instance_variable] = ACTIONS(6337),
    [sym_class_variable] = ACTIONS(6337),
    [sym_global_variable] = ACTIONS(6337),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(6339),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6339),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [6500] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8756),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3818),
    [sym_scope_resolution] = STATE(3814),
    [sym_call] = STATE(3814),
    [sym_method_call] = STATE(3818),
    [sym_assignment] = STATE(8756),
    [sym_operator_assignment] = STATE(8756),
    [sym_conditional] = STATE(8756),
    [sym_range] = STATE(8756),
    [sym_binary] = STATE(8756),
    [sym_unary] = STATE(8756),
    [sym_left_assignment_list] = STATE(3817),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3818),
    [sym__variable] = STATE(3814),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3818),
    [sym_false] = STATE(3818),
    [sym_nil] = STATE(3818),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(6492),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(6319),
    [anon_sym_yield] = ACTIONS(6321),
    [anon_sym_break] = ACTIONS(6323),
    [anon_sym_next] = ACTIONS(6325),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(9957),
    [anon_sym_defined_QMARK] = ACTIONS(6327),
    [anon_sym_not] = ACTIONS(6329),
    [anon_sym_BANG] = ACTIONS(6333),
    [anon_sym_TILDE] = ACTIONS(6333),
    [sym_constant] = ACTIONS(6339),
    [sym_identifier] = ACTIONS(6339),
    [sym_instance_variable] = ACTIONS(6337),
    [sym_class_variable] = ACTIONS(6337),
    [sym_global_variable] = ACTIONS(6337),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(6339),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6339),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [6501] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8757),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3818),
    [sym_scope_resolution] = STATE(3814),
    [sym_call] = STATE(3814),
    [sym_method_call] = STATE(3818),
    [sym_assignment] = STATE(8757),
    [sym_operator_assignment] = STATE(8757),
    [sym_conditional] = STATE(8757),
    [sym_range] = STATE(8757),
    [sym_binary] = STATE(8757),
    [sym_unary] = STATE(8757),
    [sym_left_assignment_list] = STATE(3817),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3818),
    [sym__variable] = STATE(3814),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3818),
    [sym_false] = STATE(3818),
    [sym_nil] = STATE(3818),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(6492),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(6319),
    [anon_sym_yield] = ACTIONS(6321),
    [anon_sym_break] = ACTIONS(6323),
    [anon_sym_next] = ACTIONS(6325),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(9957),
    [anon_sym_defined_QMARK] = ACTIONS(6327),
    [anon_sym_not] = ACTIONS(6329),
    [anon_sym_BANG] = ACTIONS(6333),
    [anon_sym_TILDE] = ACTIONS(6333),
    [sym_constant] = ACTIONS(6339),
    [sym_identifier] = ACTIONS(6339),
    [sym_instance_variable] = ACTIONS(6337),
    [sym_class_variable] = ACTIONS(6337),
    [sym_global_variable] = ACTIONS(6337),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(6339),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6339),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [6502] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(8758),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(8758),
    [sym_operator_assignment] = STATE(8758),
    [sym_conditional] = STATE(8758),
    [sym_range] = STATE(8758),
    [sym_binary] = STATE(8758),
    [sym_unary] = STATE(8758),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6503] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8759),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3818),
    [sym_scope_resolution] = STATE(3814),
    [sym_call] = STATE(3814),
    [sym_method_call] = STATE(3818),
    [sym_assignment] = STATE(8759),
    [sym_operator_assignment] = STATE(8759),
    [sym_conditional] = STATE(8759),
    [sym_range] = STATE(8759),
    [sym_binary] = STATE(8759),
    [sym_unary] = STATE(8759),
    [sym_left_assignment_list] = STATE(3817),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3818),
    [sym__variable] = STATE(3814),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3818),
    [sym_false] = STATE(3818),
    [sym_nil] = STATE(3818),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(6492),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(6319),
    [anon_sym_yield] = ACTIONS(6321),
    [anon_sym_break] = ACTIONS(6323),
    [anon_sym_next] = ACTIONS(6325),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(9957),
    [anon_sym_defined_QMARK] = ACTIONS(6327),
    [anon_sym_not] = ACTIONS(6329),
    [anon_sym_BANG] = ACTIONS(6333),
    [anon_sym_TILDE] = ACTIONS(6333),
    [sym_constant] = ACTIONS(6339),
    [sym_identifier] = ACTIONS(6339),
    [sym_instance_variable] = ACTIONS(6337),
    [sym_class_variable] = ACTIONS(6337),
    [sym_global_variable] = ACTIONS(6337),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(6339),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6339),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [6504] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8760),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3818),
    [sym_scope_resolution] = STATE(3814),
    [sym_call] = STATE(3814),
    [sym_method_call] = STATE(3818),
    [sym_assignment] = STATE(8760),
    [sym_operator_assignment] = STATE(8760),
    [sym_conditional] = STATE(8760),
    [sym_range] = STATE(8760),
    [sym_binary] = STATE(8760),
    [sym_unary] = STATE(8760),
    [sym_left_assignment_list] = STATE(3817),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3818),
    [sym__variable] = STATE(3814),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3818),
    [sym_false] = STATE(3818),
    [sym_nil] = STATE(3818),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(6492),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(6319),
    [anon_sym_yield] = ACTIONS(6321),
    [anon_sym_break] = ACTIONS(6323),
    [anon_sym_next] = ACTIONS(6325),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(9957),
    [anon_sym_defined_QMARK] = ACTIONS(6327),
    [anon_sym_not] = ACTIONS(6329),
    [anon_sym_BANG] = ACTIONS(6333),
    [anon_sym_TILDE] = ACTIONS(6333),
    [sym_constant] = ACTIONS(6339),
    [sym_identifier] = ACTIONS(6339),
    [sym_instance_variable] = ACTIONS(6337),
    [sym_class_variable] = ACTIONS(6337),
    [sym_global_variable] = ACTIONS(6337),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(6339),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6339),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [6505] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8761),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3818),
    [sym_scope_resolution] = STATE(3814),
    [sym_call] = STATE(3814),
    [sym_method_call] = STATE(3818),
    [sym_assignment] = STATE(8761),
    [sym_operator_assignment] = STATE(8761),
    [sym_conditional] = STATE(8761),
    [sym_range] = STATE(8761),
    [sym_binary] = STATE(8761),
    [sym_unary] = STATE(8761),
    [sym_left_assignment_list] = STATE(3817),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3818),
    [sym__variable] = STATE(3814),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3818),
    [sym_false] = STATE(3818),
    [sym_nil] = STATE(3818),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(6492),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(6319),
    [anon_sym_yield] = ACTIONS(6321),
    [anon_sym_break] = ACTIONS(6323),
    [anon_sym_next] = ACTIONS(6325),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(9957),
    [anon_sym_defined_QMARK] = ACTIONS(6327),
    [anon_sym_not] = ACTIONS(6329),
    [anon_sym_BANG] = ACTIONS(6333),
    [anon_sym_TILDE] = ACTIONS(6333),
    [sym_constant] = ACTIONS(6339),
    [sym_identifier] = ACTIONS(6339),
    [sym_instance_variable] = ACTIONS(6337),
    [sym_class_variable] = ACTIONS(6337),
    [sym_global_variable] = ACTIONS(6337),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(6339),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6339),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [6506] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8762),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3818),
    [sym_scope_resolution] = STATE(3814),
    [sym_call] = STATE(3814),
    [sym_method_call] = STATE(3818),
    [sym_assignment] = STATE(8762),
    [sym_operator_assignment] = STATE(8762),
    [sym_conditional] = STATE(8762),
    [sym_range] = STATE(8762),
    [sym_binary] = STATE(8762),
    [sym_unary] = STATE(8762),
    [sym_left_assignment_list] = STATE(3817),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3818),
    [sym__variable] = STATE(3814),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3818),
    [sym_false] = STATE(3818),
    [sym_nil] = STATE(3818),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(6492),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(6319),
    [anon_sym_yield] = ACTIONS(6321),
    [anon_sym_break] = ACTIONS(6323),
    [anon_sym_next] = ACTIONS(6325),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(9957),
    [anon_sym_defined_QMARK] = ACTIONS(6327),
    [anon_sym_not] = ACTIONS(6329),
    [anon_sym_BANG] = ACTIONS(6333),
    [anon_sym_TILDE] = ACTIONS(6333),
    [sym_constant] = ACTIONS(6339),
    [sym_identifier] = ACTIONS(6339),
    [sym_instance_variable] = ACTIONS(6337),
    [sym_class_variable] = ACTIONS(6337),
    [sym_global_variable] = ACTIONS(6337),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(6339),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6339),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [6507] = {
    [sym_heredoc_body] = STATE(8763),
    [aux_sym_call_repeat1] = STATE(8763),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [6508] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3813),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3818),
    [sym_scope_resolution] = STATE(3814),
    [sym_call] = STATE(3814),
    [sym_method_call] = STATE(3818),
    [sym__argument] = STATE(3737),
    [sym_splat_argument] = STATE(3737),
    [sym_hash_splat_argument] = STATE(3737),
    [sym_block_argument] = STATE(3737),
    [sym_assignment] = STATE(3813),
    [sym_operator_assignment] = STATE(3813),
    [sym_conditional] = STATE(3813),
    [sym_range] = STATE(3813),
    [sym_binary] = STATE(3813),
    [sym_unary] = STATE(3813),
    [sym_left_assignment_list] = STATE(3817),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3818),
    [sym__variable] = STATE(3814),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3818),
    [sym_false] = STATE(3818),
    [sym_nil] = STATE(3818),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3819),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_heredoc_body] = STATE(8764),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(3737),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(6311),
    [sym__splat_star] = ACTIONS(6313),
    [sym__unary_minus] = ACTIONS(6315),
    [sym__identifier_hash_key] = ACTIONS(6317),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12429),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(6319),
    [anon_sym_yield] = ACTIONS(6321),
    [anon_sym_break] = ACTIONS(6323),
    [anon_sym_next] = ACTIONS(6325),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(9957),
    [anon_sym_defined_QMARK] = ACTIONS(6327),
    [anon_sym_not] = ACTIONS(6329),
    [anon_sym_BANG] = ACTIONS(6333),
    [anon_sym_TILDE] = ACTIONS(6333),
    [sym_constant] = ACTIONS(6335),
    [sym_identifier] = ACTIONS(6335),
    [sym_instance_variable] = ACTIONS(6337),
    [sym_class_variable] = ACTIONS(6337),
    [sym_global_variable] = ACTIONS(6337),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(6339),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6339),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [6509] = {
    [sym_heredoc_body] = STATE(8765),
    [aux_sym_call_repeat1] = STATE(8765),
    [aux_sym_argument_list_repeat1] = STATE(8766),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(9991),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [6510] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8767),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3818),
    [sym_scope_resolution] = STATE(3814),
    [sym_call] = STATE(3814),
    [sym_method_call] = STATE(3818),
    [sym_splat_argument] = STATE(8768),
    [sym_assignment] = STATE(8767),
    [sym_operator_assignment] = STATE(8767),
    [sym_conditional] = STATE(8767),
    [sym_range] = STATE(8767),
    [sym_binary] = STATE(8767),
    [sym_unary] = STATE(8767),
    [sym_right_assignment_list] = STATE(3742),
    [sym__arg_or_splat_arg] = STATE(8768),
    [sym_left_assignment_list] = STATE(3817),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3818),
    [sym__variable] = STATE(3814),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3818),
    [sym_false] = STATE(3818),
    [sym_nil] = STATE(3818),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(6492),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__splat_star] = ACTIONS(9919),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(6319),
    [anon_sym_yield] = ACTIONS(6321),
    [anon_sym_break] = ACTIONS(6323),
    [anon_sym_next] = ACTIONS(6325),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(9957),
    [anon_sym_defined_QMARK] = ACTIONS(6327),
    [anon_sym_not] = ACTIONS(6329),
    [anon_sym_BANG] = ACTIONS(6333),
    [anon_sym_TILDE] = ACTIONS(6333),
    [sym_constant] = ACTIONS(6339),
    [sym_identifier] = ACTIONS(6339),
    [sym_instance_variable] = ACTIONS(6337),
    [sym_class_variable] = ACTIONS(6337),
    [sym_global_variable] = ACTIONS(6337),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(6339),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6339),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [6511] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8769),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3818),
    [sym_scope_resolution] = STATE(3814),
    [sym_call] = STATE(3814),
    [sym_method_call] = STATE(3818),
    [sym_assignment] = STATE(8769),
    [sym_operator_assignment] = STATE(8769),
    [sym_conditional] = STATE(8769),
    [sym_range] = STATE(8769),
    [sym_binary] = STATE(8769),
    [sym_unary] = STATE(8769),
    [sym_left_assignment_list] = STATE(3817),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3818),
    [sym__variable] = STATE(3814),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3818),
    [sym_false] = STATE(3818),
    [sym_nil] = STATE(3818),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(6492),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(6319),
    [anon_sym_yield] = ACTIONS(6321),
    [anon_sym_break] = ACTIONS(6323),
    [anon_sym_next] = ACTIONS(6325),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(9957),
    [anon_sym_defined_QMARK] = ACTIONS(6327),
    [anon_sym_not] = ACTIONS(6329),
    [anon_sym_BANG] = ACTIONS(6333),
    [anon_sym_TILDE] = ACTIONS(6333),
    [sym_constant] = ACTIONS(6339),
    [sym_identifier] = ACTIONS(6339),
    [sym_instance_variable] = ACTIONS(6337),
    [sym_class_variable] = ACTIONS(6337),
    [sym_global_variable] = ACTIONS(6337),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(6339),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6339),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [6512] = {
    [sym_string] = STATE(8770),
    [aux_sym_chained_string_repeat1] = STATE(8770),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(747),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2755),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_EQ] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_EQ_GT] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_PLUS_EQ] = ACTIONS(2753),
    [anon_sym_DASH_EQ] = ACTIONS(2753),
    [anon_sym_STAR_EQ] = ACTIONS(2753),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2753),
    [anon_sym_SLASH_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2753),
    [anon_sym_AMP_EQ] = ACTIONS(2753),
    [anon_sym_PERCENT_EQ] = ACTIONS(2753),
    [anon_sym_GT_GT_EQ] = ACTIONS(2753),
    [anon_sym_LT_LT_EQ] = ACTIONS(2753),
    [anon_sym_CARET_EQ] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2755),
    [anon_sym_AMP_AMP] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2755),
    [anon_sym_GT_GT] = ACTIONS(2755),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_SLASH] = ACTIONS(2755),
    [anon_sym_PERCENT] = ACTIONS(2755),
    [sym_comment] = ACTIONS(87),
  },
  [6513] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8771),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(6520),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(6520),
    [sym_assignment] = STATE(8771),
    [sym_operator_assignment] = STATE(8771),
    [sym_conditional] = STATE(8771),
    [sym_range] = STATE(8771),
    [sym_binary] = STATE(8771),
    [sym_unary] = STATE(8771),
    [sym_left_assignment_list] = STATE(6519),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6520),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(6520),
    [sym_false] = STATE(6520),
    [sym_nil] = STATE(6520),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(6420),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10003),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9861),
    [anon_sym_yield] = ACTIONS(9863),
    [anon_sym_break] = ACTIONS(9865),
    [anon_sym_next] = ACTIONS(9867),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10005),
    [anon_sym_defined_QMARK] = ACTIONS(10007),
    [anon_sym_not] = ACTIONS(10009),
    [anon_sym_BANG] = ACTIONS(10011),
    [anon_sym_TILDE] = ACTIONS(10011),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6514] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8772),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(6520),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(6520),
    [sym_assignment] = STATE(8772),
    [sym_operator_assignment] = STATE(8772),
    [sym_conditional] = STATE(8772),
    [sym_range] = STATE(8772),
    [sym_binary] = STATE(8772),
    [sym_unary] = STATE(8772),
    [sym_left_assignment_list] = STATE(6519),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6520),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(6520),
    [sym_false] = STATE(6520),
    [sym_nil] = STATE(6520),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(6420),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10003),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9861),
    [anon_sym_yield] = ACTIONS(9863),
    [anon_sym_break] = ACTIONS(9865),
    [anon_sym_next] = ACTIONS(9867),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10005),
    [anon_sym_defined_QMARK] = ACTIONS(10007),
    [anon_sym_not] = ACTIONS(10009),
    [anon_sym_BANG] = ACTIONS(10011),
    [anon_sym_TILDE] = ACTIONS(10011),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6515] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8773),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(6520),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(6520),
    [sym_assignment] = STATE(8773),
    [sym_operator_assignment] = STATE(8773),
    [sym_conditional] = STATE(8773),
    [sym_range] = STATE(8773),
    [sym_binary] = STATE(8773),
    [sym_unary] = STATE(8773),
    [sym_left_assignment_list] = STATE(6519),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6520),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(6520),
    [sym_false] = STATE(6520),
    [sym_nil] = STATE(6520),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(6420),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10003),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9861),
    [anon_sym_yield] = ACTIONS(9863),
    [anon_sym_break] = ACTIONS(9865),
    [anon_sym_next] = ACTIONS(9867),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10005),
    [anon_sym_defined_QMARK] = ACTIONS(10007),
    [anon_sym_not] = ACTIONS(10009),
    [anon_sym_BANG] = ACTIONS(10011),
    [anon_sym_TILDE] = ACTIONS(10011),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6516] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(298),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(6520),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(6520),
    [sym_assignment] = STATE(298),
    [sym_operator_assignment] = STATE(298),
    [sym_conditional] = STATE(298),
    [sym_range] = STATE(298),
    [sym_binary] = STATE(298),
    [sym_unary] = STATE(298),
    [sym_left_assignment_list] = STATE(6519),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6520),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(6520),
    [sym_false] = STATE(6520),
    [sym_nil] = STATE(6520),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(6420),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10003),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9861),
    [anon_sym_yield] = ACTIONS(9863),
    [anon_sym_break] = ACTIONS(9865),
    [anon_sym_next] = ACTIONS(9867),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10005),
    [anon_sym_defined_QMARK] = ACTIONS(10007),
    [anon_sym_not] = ACTIONS(10009),
    [anon_sym_BANG] = ACTIONS(10011),
    [anon_sym_TILDE] = ACTIONS(10011),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6517] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(12431),
    [sym__binary_star] = ACTIONS(12433),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(12435),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(12433),
    [anon_sym_AMP] = ACTIONS(12437),
    [anon_sym_LT] = ACTIONS(12439),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(12441),
    [anon_sym_DOT_DOT] = ACTIONS(12443),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12445),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(12447),
    [anon_sym_AMP_AMP] = ACTIONS(12447),
    [anon_sym_LT_LT] = ACTIONS(12449),
    [anon_sym_GT_GT] = ACTIONS(12449),
    [anon_sym_EQ_EQ] = ACTIONS(12451),
    [anon_sym_BANG_EQ] = ACTIONS(12447),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12447),
    [anon_sym_LT_EQ_GT] = ACTIONS(12447),
    [anon_sym_EQ_TILDE] = ACTIONS(12447),
    [anon_sym_BANG_TILDE] = ACTIONS(12447),
    [anon_sym_LT_EQ] = ACTIONS(12439),
    [anon_sym_GT] = ACTIONS(12439),
    [anon_sym_GT_EQ] = ACTIONS(12453),
    [anon_sym_CARET] = ACTIONS(12455),
    [anon_sym_PLUS] = ACTIONS(12431),
    [anon_sym_SLASH] = ACTIONS(12433),
    [anon_sym_PERCENT] = ACTIONS(12433),
    [sym_comment] = ACTIONS(87),
  },
  [6518] = {
    [aux_sym_exceptions_repeat1] = STATE(8785),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_COMMA] = ACTIONS(12457),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [6519] = {
    [anon_sym_EQ] = ACTIONS(12459),
    [sym_comment] = ACTIONS(87),
  },
  [6520] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(12461),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(12463),
    [anon_sym_DASH_EQ] = ACTIONS(12463),
    [anon_sym_STAR_EQ] = ACTIONS(12463),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12463),
    [anon_sym_SLASH_EQ] = ACTIONS(12463),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12463),
    [anon_sym_PIPE_EQ] = ACTIONS(12463),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12463),
    [anon_sym_AMP_EQ] = ACTIONS(12463),
    [anon_sym_PERCENT_EQ] = ACTIONS(12463),
    [anon_sym_GT_GT_EQ] = ACTIONS(12463),
    [anon_sym_LT_LT_EQ] = ACTIONS(12463),
    [anon_sym_CARET_EQ] = ACTIONS(12463),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [6521] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(6283),
    [sym__binary_star] = ACTIONS(6285),
    [anon_sym_PIPE] = ACTIONS(6287),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(6285),
    [anon_sym_AMP] = ACTIONS(6289),
    [anon_sym_LT] = ACTIONS(6291),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(6293),
    [anon_sym_DOT_DOT] = ACTIONS(6295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6297),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(6301),
    [anon_sym_AMP_AMP] = ACTIONS(6301),
    [anon_sym_LT_LT] = ACTIONS(6303),
    [anon_sym_GT_GT] = ACTIONS(6303),
    [anon_sym_EQ_EQ] = ACTIONS(6305),
    [anon_sym_BANG_EQ] = ACTIONS(6301),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6301),
    [anon_sym_LT_EQ_GT] = ACTIONS(6301),
    [anon_sym_EQ_TILDE] = ACTIONS(6301),
    [anon_sym_BANG_TILDE] = ACTIONS(6301),
    [anon_sym_LT_EQ] = ACTIONS(6291),
    [anon_sym_GT] = ACTIONS(6291),
    [anon_sym_GT_EQ] = ACTIONS(6307),
    [anon_sym_CARET] = ACTIONS(6309),
    [anon_sym_PLUS] = ACTIONS(6283),
    [anon_sym_SLASH] = ACTIONS(6285),
    [anon_sym_PERCENT] = ACTIONS(6285),
    [sym_comment] = ACTIONS(87),
  },
  [6522] = {
    [sym_string] = STATE(6522),
    [aux_sym_chained_string_repeat1] = STATE(6522),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(6214),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [6523] = {
    [anon_sym_RBRACE] = ACTIONS(6711),
    [anon_sym_if] = ACTIONS(6711),
    [anon_sym_unless] = ACTIONS(6711),
    [anon_sym_while] = ACTIONS(6711),
    [anon_sym_until] = ACTIONS(6711),
    [anon_sym_rescue] = ACTIONS(6711),
    [sym_comment] = ACTIONS(87),
  },
  [6524] = {
    [anon_sym_RBRACE] = ACTIONS(7172),
    [anon_sym_if] = ACTIONS(7172),
    [anon_sym_unless] = ACTIONS(7172),
    [anon_sym_while] = ACTIONS(7172),
    [anon_sym_until] = ACTIONS(7172),
    [anon_sym_rescue] = ACTIONS(7172),
    [sym_comment] = ACTIONS(87),
  },
  [6525] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(10019),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [6526] = {
    [sym_heredoc_body] = STATE(8788),
    [aux_sym_call_repeat1] = STATE(8788),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_RBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [6527] = {
    [sym_heredoc_body] = STATE(8788),
    [aux_sym_call_repeat1] = STATE(8788),
    [aux_sym_argument_list_repeat1] = STATE(8789),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_RBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(6421),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [6528] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(10017),
    [sym__binary_star] = ACTIONS(10019),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(10021),
    [anon_sym_STAR_STAR] = ACTIONS(10019),
    [anon_sym_AMP] = ACTIONS(10023),
    [anon_sym_LT] = ACTIONS(10025),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(10027),
    [anon_sym_DOT_DOT] = ACTIONS(10029),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10031),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(10033),
    [anon_sym_AMP_AMP] = ACTIONS(10033),
    [anon_sym_LT_LT] = ACTIONS(10035),
    [anon_sym_GT_GT] = ACTIONS(10035),
    [anon_sym_EQ_EQ] = ACTIONS(10037),
    [anon_sym_BANG_EQ] = ACTIONS(10033),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10033),
    [anon_sym_LT_EQ_GT] = ACTIONS(10033),
    [anon_sym_EQ_TILDE] = ACTIONS(10033),
    [anon_sym_BANG_TILDE] = ACTIONS(10033),
    [anon_sym_LT_EQ] = ACTIONS(10025),
    [anon_sym_GT] = ACTIONS(10025),
    [anon_sym_GT_EQ] = ACTIONS(10039),
    [anon_sym_CARET] = ACTIONS(10041),
    [anon_sym_PLUS] = ACTIONS(10017),
    [anon_sym_SLASH] = ACTIONS(10019),
    [anon_sym_PERCENT] = ACTIONS(10019),
    [sym_comment] = ACTIONS(87),
  },
  [6529] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(8790),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(3837),
    [sym_scope_resolution] = STATE(3835),
    [sym_call] = STATE(3835),
    [sym_method_call] = STATE(3837),
    [sym_assignment] = STATE(8790),
    [sym_operator_assignment] = STATE(8790),
    [sym_conditional] = STATE(8790),
    [sym_range] = STATE(8790),
    [sym_binary] = STATE(8790),
    [sym_unary] = STATE(8790),
    [sym_left_assignment_list] = STATE(3836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3837),
    [sym__variable] = STATE(3835),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(3837),
    [sym_false] = STATE(3837),
    [sym_nil] = STATE(3837),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(3838),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6351),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6353),
    [anon_sym_yield] = ACTIONS(6355),
    [anon_sym_break] = ACTIONS(6357),
    [anon_sym_next] = ACTIONS(6359),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6361),
    [anon_sym_defined_QMARK] = ACTIONS(6363),
    [anon_sym_not] = ACTIONS(6365),
    [anon_sym_BANG] = ACTIONS(6367),
    [anon_sym_TILDE] = ACTIONS(6367),
    [sym_constant] = ACTIONS(6369),
    [sym_identifier] = ACTIONS(6369),
    [sym_instance_variable] = ACTIONS(6371),
    [sym_class_variable] = ACTIONS(6371),
    [sym_global_variable] = ACTIONS(6371),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6369),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6369),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6530] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(8791),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(3837),
    [sym_scope_resolution] = STATE(3835),
    [sym_call] = STATE(3835),
    [sym_method_call] = STATE(3837),
    [sym_assignment] = STATE(8791),
    [sym_operator_assignment] = STATE(8791),
    [sym_conditional] = STATE(8791),
    [sym_range] = STATE(8791),
    [sym_binary] = STATE(8791),
    [sym_unary] = STATE(8791),
    [sym_left_assignment_list] = STATE(3836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3837),
    [sym__variable] = STATE(3835),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(3837),
    [sym_false] = STATE(3837),
    [sym_nil] = STATE(3837),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(3838),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6351),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6353),
    [anon_sym_yield] = ACTIONS(6355),
    [anon_sym_break] = ACTIONS(6357),
    [anon_sym_next] = ACTIONS(6359),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6361),
    [anon_sym_defined_QMARK] = ACTIONS(6363),
    [anon_sym_not] = ACTIONS(6365),
    [anon_sym_BANG] = ACTIONS(6367),
    [anon_sym_TILDE] = ACTIONS(6367),
    [sym_constant] = ACTIONS(6369),
    [sym_identifier] = ACTIONS(6369),
    [sym_instance_variable] = ACTIONS(6371),
    [sym_class_variable] = ACTIONS(6371),
    [sym_global_variable] = ACTIONS(6371),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6369),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6369),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6531] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(8792),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(3837),
    [sym_scope_resolution] = STATE(3835),
    [sym_call] = STATE(3835),
    [sym_method_call] = STATE(3837),
    [sym_assignment] = STATE(8792),
    [sym_operator_assignment] = STATE(8792),
    [sym_conditional] = STATE(8792),
    [sym_range] = STATE(8792),
    [sym_binary] = STATE(8792),
    [sym_unary] = STATE(8792),
    [sym_left_assignment_list] = STATE(3836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3837),
    [sym__variable] = STATE(3835),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(3837),
    [sym_false] = STATE(3837),
    [sym_nil] = STATE(3837),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(3838),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6351),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6353),
    [anon_sym_yield] = ACTIONS(6355),
    [anon_sym_break] = ACTIONS(6357),
    [anon_sym_next] = ACTIONS(6359),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6361),
    [anon_sym_defined_QMARK] = ACTIONS(6363),
    [anon_sym_not] = ACTIONS(6365),
    [anon_sym_BANG] = ACTIONS(6367),
    [anon_sym_TILDE] = ACTIONS(6367),
    [sym_constant] = ACTIONS(6369),
    [sym_identifier] = ACTIONS(6369),
    [sym_instance_variable] = ACTIONS(6371),
    [sym_class_variable] = ACTIONS(6371),
    [sym_global_variable] = ACTIONS(6371),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6369),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6369),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6532] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(8793),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(3837),
    [sym_scope_resolution] = STATE(3835),
    [sym_call] = STATE(3835),
    [sym_method_call] = STATE(3837),
    [sym_assignment] = STATE(8793),
    [sym_operator_assignment] = STATE(8793),
    [sym_conditional] = STATE(8793),
    [sym_range] = STATE(8793),
    [sym_binary] = STATE(8793),
    [sym_unary] = STATE(8793),
    [sym_left_assignment_list] = STATE(3836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3837),
    [sym__variable] = STATE(3835),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(3837),
    [sym_false] = STATE(3837),
    [sym_nil] = STATE(3837),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(3838),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6351),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6353),
    [anon_sym_yield] = ACTIONS(6355),
    [anon_sym_break] = ACTIONS(6357),
    [anon_sym_next] = ACTIONS(6359),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6361),
    [anon_sym_defined_QMARK] = ACTIONS(6363),
    [anon_sym_not] = ACTIONS(6365),
    [anon_sym_BANG] = ACTIONS(6367),
    [anon_sym_TILDE] = ACTIONS(6367),
    [sym_constant] = ACTIONS(6369),
    [sym_identifier] = ACTIONS(6369),
    [sym_instance_variable] = ACTIONS(6371),
    [sym_class_variable] = ACTIONS(6371),
    [sym_global_variable] = ACTIONS(6371),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6369),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6369),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6533] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(8794),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(3837),
    [sym_scope_resolution] = STATE(3835),
    [sym_call] = STATE(3835),
    [sym_method_call] = STATE(3837),
    [sym_assignment] = STATE(8794),
    [sym_operator_assignment] = STATE(8794),
    [sym_conditional] = STATE(8794),
    [sym_range] = STATE(8794),
    [sym_binary] = STATE(8794),
    [sym_unary] = STATE(8794),
    [sym_left_assignment_list] = STATE(3836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3837),
    [sym__variable] = STATE(3835),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(3837),
    [sym_false] = STATE(3837),
    [sym_nil] = STATE(3837),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(3838),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6351),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6353),
    [anon_sym_yield] = ACTIONS(6355),
    [anon_sym_break] = ACTIONS(6357),
    [anon_sym_next] = ACTIONS(6359),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6361),
    [anon_sym_defined_QMARK] = ACTIONS(6363),
    [anon_sym_not] = ACTIONS(6365),
    [anon_sym_BANG] = ACTIONS(6367),
    [anon_sym_TILDE] = ACTIONS(6367),
    [sym_constant] = ACTIONS(6369),
    [sym_identifier] = ACTIONS(6369),
    [sym_instance_variable] = ACTIONS(6371),
    [sym_class_variable] = ACTIONS(6371),
    [sym_global_variable] = ACTIONS(6371),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6369),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6369),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6534] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(8795),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(8795),
    [sym_operator_assignment] = STATE(8795),
    [sym_conditional] = STATE(8795),
    [sym_range] = STATE(8795),
    [sym_binary] = STATE(8795),
    [sym_unary] = STATE(8795),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6535] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(8796),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(3837),
    [sym_scope_resolution] = STATE(3835),
    [sym_call] = STATE(3835),
    [sym_method_call] = STATE(3837),
    [sym_assignment] = STATE(8796),
    [sym_operator_assignment] = STATE(8796),
    [sym_conditional] = STATE(8796),
    [sym_range] = STATE(8796),
    [sym_binary] = STATE(8796),
    [sym_unary] = STATE(8796),
    [sym_left_assignment_list] = STATE(3836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3837),
    [sym__variable] = STATE(3835),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(3837),
    [sym_false] = STATE(3837),
    [sym_nil] = STATE(3837),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(3838),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6351),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6353),
    [anon_sym_yield] = ACTIONS(6355),
    [anon_sym_break] = ACTIONS(6357),
    [anon_sym_next] = ACTIONS(6359),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6361),
    [anon_sym_defined_QMARK] = ACTIONS(6363),
    [anon_sym_not] = ACTIONS(6365),
    [anon_sym_BANG] = ACTIONS(6367),
    [anon_sym_TILDE] = ACTIONS(6367),
    [sym_constant] = ACTIONS(6369),
    [sym_identifier] = ACTIONS(6369),
    [sym_instance_variable] = ACTIONS(6371),
    [sym_class_variable] = ACTIONS(6371),
    [sym_global_variable] = ACTIONS(6371),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6369),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6369),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6536] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(8797),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(3837),
    [sym_scope_resolution] = STATE(3835),
    [sym_call] = STATE(3835),
    [sym_method_call] = STATE(3837),
    [sym_assignment] = STATE(8797),
    [sym_operator_assignment] = STATE(8797),
    [sym_conditional] = STATE(8797),
    [sym_range] = STATE(8797),
    [sym_binary] = STATE(8797),
    [sym_unary] = STATE(8797),
    [sym_left_assignment_list] = STATE(3836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3837),
    [sym__variable] = STATE(3835),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(3837),
    [sym_false] = STATE(3837),
    [sym_nil] = STATE(3837),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(3838),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6351),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6353),
    [anon_sym_yield] = ACTIONS(6355),
    [anon_sym_break] = ACTIONS(6357),
    [anon_sym_next] = ACTIONS(6359),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6361),
    [anon_sym_defined_QMARK] = ACTIONS(6363),
    [anon_sym_not] = ACTIONS(6365),
    [anon_sym_BANG] = ACTIONS(6367),
    [anon_sym_TILDE] = ACTIONS(6367),
    [sym_constant] = ACTIONS(6369),
    [sym_identifier] = ACTIONS(6369),
    [sym_instance_variable] = ACTIONS(6371),
    [sym_class_variable] = ACTIONS(6371),
    [sym_global_variable] = ACTIONS(6371),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6369),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6369),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6537] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(8798),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(3837),
    [sym_scope_resolution] = STATE(3835),
    [sym_call] = STATE(3835),
    [sym_method_call] = STATE(3837),
    [sym_assignment] = STATE(8798),
    [sym_operator_assignment] = STATE(8798),
    [sym_conditional] = STATE(8798),
    [sym_range] = STATE(8798),
    [sym_binary] = STATE(8798),
    [sym_unary] = STATE(8798),
    [sym_left_assignment_list] = STATE(3836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3837),
    [sym__variable] = STATE(3835),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(3837),
    [sym_false] = STATE(3837),
    [sym_nil] = STATE(3837),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(3838),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6351),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6353),
    [anon_sym_yield] = ACTIONS(6355),
    [anon_sym_break] = ACTIONS(6357),
    [anon_sym_next] = ACTIONS(6359),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6361),
    [anon_sym_defined_QMARK] = ACTIONS(6363),
    [anon_sym_not] = ACTIONS(6365),
    [anon_sym_BANG] = ACTIONS(6367),
    [anon_sym_TILDE] = ACTIONS(6367),
    [sym_constant] = ACTIONS(6369),
    [sym_identifier] = ACTIONS(6369),
    [sym_instance_variable] = ACTIONS(6371),
    [sym_class_variable] = ACTIONS(6371),
    [sym_global_variable] = ACTIONS(6371),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6369),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6369),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6538] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(8799),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(3837),
    [sym_scope_resolution] = STATE(3835),
    [sym_call] = STATE(3835),
    [sym_method_call] = STATE(3837),
    [sym_assignment] = STATE(8799),
    [sym_operator_assignment] = STATE(8799),
    [sym_conditional] = STATE(8799),
    [sym_range] = STATE(8799),
    [sym_binary] = STATE(8799),
    [sym_unary] = STATE(8799),
    [sym_left_assignment_list] = STATE(3836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3837),
    [sym__variable] = STATE(3835),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(3837),
    [sym_false] = STATE(3837),
    [sym_nil] = STATE(3837),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(3838),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6351),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6353),
    [anon_sym_yield] = ACTIONS(6355),
    [anon_sym_break] = ACTIONS(6357),
    [anon_sym_next] = ACTIONS(6359),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6361),
    [anon_sym_defined_QMARK] = ACTIONS(6363),
    [anon_sym_not] = ACTIONS(6365),
    [anon_sym_BANG] = ACTIONS(6367),
    [anon_sym_TILDE] = ACTIONS(6367),
    [sym_constant] = ACTIONS(6369),
    [sym_identifier] = ACTIONS(6369),
    [sym_instance_variable] = ACTIONS(6371),
    [sym_class_variable] = ACTIONS(6371),
    [sym_global_variable] = ACTIONS(6371),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6369),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6369),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6539] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(8800),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(3837),
    [sym_scope_resolution] = STATE(3835),
    [sym_call] = STATE(3835),
    [sym_method_call] = STATE(3837),
    [sym_splat_argument] = STATE(8801),
    [sym_assignment] = STATE(8800),
    [sym_operator_assignment] = STATE(8800),
    [sym_conditional] = STATE(8800),
    [sym_range] = STATE(8800),
    [sym_binary] = STATE(8800),
    [sym_unary] = STATE(8800),
    [sym_right_assignment_list] = STATE(4255),
    [sym__arg_or_splat_arg] = STATE(8801),
    [sym_left_assignment_list] = STATE(3836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3837),
    [sym__variable] = STATE(3835),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(3837),
    [sym_false] = STATE(3837),
    [sym_nil] = STATE(3837),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(3838),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(2902),
    [sym__unary_minus] = ACTIONS(6351),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6353),
    [anon_sym_yield] = ACTIONS(6355),
    [anon_sym_break] = ACTIONS(6357),
    [anon_sym_next] = ACTIONS(6359),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6361),
    [anon_sym_defined_QMARK] = ACTIONS(6363),
    [anon_sym_not] = ACTIONS(6365),
    [anon_sym_BANG] = ACTIONS(6367),
    [anon_sym_TILDE] = ACTIONS(6367),
    [sym_constant] = ACTIONS(6369),
    [sym_identifier] = ACTIONS(6369),
    [sym_instance_variable] = ACTIONS(6371),
    [sym_class_variable] = ACTIONS(6371),
    [sym_global_variable] = ACTIONS(6371),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6369),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6369),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6540] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(8802),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(3837),
    [sym_scope_resolution] = STATE(3835),
    [sym_call] = STATE(3835),
    [sym_method_call] = STATE(3837),
    [sym_assignment] = STATE(8802),
    [sym_operator_assignment] = STATE(8802),
    [sym_conditional] = STATE(8802),
    [sym_range] = STATE(8802),
    [sym_binary] = STATE(8802),
    [sym_unary] = STATE(8802),
    [sym_left_assignment_list] = STATE(3836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3837),
    [sym__variable] = STATE(3835),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(3837),
    [sym_false] = STATE(3837),
    [sym_nil] = STATE(3837),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(3838),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6351),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6353),
    [anon_sym_yield] = ACTIONS(6355),
    [anon_sym_break] = ACTIONS(6357),
    [anon_sym_next] = ACTIONS(6359),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6361),
    [anon_sym_defined_QMARK] = ACTIONS(6363),
    [anon_sym_not] = ACTIONS(6365),
    [anon_sym_BANG] = ACTIONS(6367),
    [anon_sym_TILDE] = ACTIONS(6367),
    [sym_constant] = ACTIONS(6369),
    [sym_identifier] = ACTIONS(6369),
    [sym_instance_variable] = ACTIONS(6371),
    [sym_class_variable] = ACTIONS(6371),
    [sym_global_variable] = ACTIONS(6371),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6369),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6369),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6541] = {
    [sym_string] = STATE(8803),
    [aux_sym_chained_string_repeat1] = STATE(8803),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_RBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [6542] = {
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(10017),
    [sym__binary_star] = ACTIONS(10019),
    [anon_sym_RBRACE] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(10021),
    [anon_sym_STAR_STAR] = ACTIONS(10019),
    [anon_sym_AMP] = ACTIONS(10023),
    [anon_sym_LT] = ACTIONS(10025),
    [anon_sym_if] = ACTIONS(6823),
    [anon_sym_unless] = ACTIONS(6823),
    [anon_sym_while] = ACTIONS(6823),
    [anon_sym_until] = ACTIONS(6823),
    [anon_sym_rescue] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(10027),
    [anon_sym_DOT_DOT] = ACTIONS(10029),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10031),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(10033),
    [anon_sym_AMP_AMP] = ACTIONS(10033),
    [anon_sym_LT_LT] = ACTIONS(10035),
    [anon_sym_GT_GT] = ACTIONS(10035),
    [anon_sym_EQ_EQ] = ACTIONS(10037),
    [anon_sym_BANG_EQ] = ACTIONS(10033),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10033),
    [anon_sym_LT_EQ_GT] = ACTIONS(10033),
    [anon_sym_EQ_TILDE] = ACTIONS(10033),
    [anon_sym_BANG_TILDE] = ACTIONS(10033),
    [anon_sym_LT_EQ] = ACTIONS(10025),
    [anon_sym_GT] = ACTIONS(10025),
    [anon_sym_GT_EQ] = ACTIONS(10039),
    [anon_sym_CARET] = ACTIONS(10041),
    [anon_sym_PLUS] = ACTIONS(10017),
    [anon_sym_SLASH] = ACTIONS(10019),
    [anon_sym_PERCENT] = ACTIONS(10019),
    [sym_comment] = ACTIONS(87),
  },
  [6543] = {
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(6387),
    [sym__binary_star] = ACTIONS(6389),
    [anon_sym_RBRACE] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(6391),
    [anon_sym_STAR_STAR] = ACTIONS(6389),
    [anon_sym_AMP] = ACTIONS(6393),
    [anon_sym_LT] = ACTIONS(6395),
    [anon_sym_if] = ACTIONS(4211),
    [anon_sym_unless] = ACTIONS(4211),
    [anon_sym_while] = ACTIONS(4211),
    [anon_sym_until] = ACTIONS(4211),
    [anon_sym_rescue] = ACTIONS(4211),
    [anon_sym_EQ_GT] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(6397),
    [anon_sym_DOT_DOT] = ACTIONS(6399),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6401),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(6403),
    [anon_sym_AMP_AMP] = ACTIONS(6403),
    [anon_sym_LT_LT] = ACTIONS(6405),
    [anon_sym_GT_GT] = ACTIONS(6405),
    [anon_sym_EQ_EQ] = ACTIONS(6407),
    [anon_sym_BANG_EQ] = ACTIONS(6403),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6403),
    [anon_sym_LT_EQ_GT] = ACTIONS(6403),
    [anon_sym_EQ_TILDE] = ACTIONS(6403),
    [anon_sym_BANG_TILDE] = ACTIONS(6403),
    [anon_sym_LT_EQ] = ACTIONS(6395),
    [anon_sym_GT] = ACTIONS(6395),
    [anon_sym_GT_EQ] = ACTIONS(6409),
    [anon_sym_CARET] = ACTIONS(6411),
    [anon_sym_PLUS] = ACTIONS(6387),
    [anon_sym_SLASH] = ACTIONS(6389),
    [anon_sym_PERCENT] = ACTIONS(6389),
    [sym_comment] = ACTIONS(87),
  },
  [6544] = {
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(6387),
    [sym__binary_star] = ACTIONS(6389),
    [anon_sym_RBRACE] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(6391),
    [anon_sym_STAR_STAR] = ACTIONS(6389),
    [anon_sym_AMP] = ACTIONS(6393),
    [anon_sym_LT] = ACTIONS(6395),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_EQ_GT] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(6397),
    [anon_sym_DOT_DOT] = ACTIONS(6399),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6401),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(6403),
    [anon_sym_AMP_AMP] = ACTIONS(6403),
    [anon_sym_LT_LT] = ACTIONS(6405),
    [anon_sym_GT_GT] = ACTIONS(6405),
    [anon_sym_EQ_EQ] = ACTIONS(6407),
    [anon_sym_BANG_EQ] = ACTIONS(6403),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6403),
    [anon_sym_LT_EQ_GT] = ACTIONS(6403),
    [anon_sym_EQ_TILDE] = ACTIONS(6403),
    [anon_sym_BANG_TILDE] = ACTIONS(6403),
    [anon_sym_LT_EQ] = ACTIONS(6395),
    [anon_sym_GT] = ACTIONS(6395),
    [anon_sym_GT_EQ] = ACTIONS(6409),
    [anon_sym_CARET] = ACTIONS(6411),
    [anon_sym_PLUS] = ACTIONS(6387),
    [anon_sym_SLASH] = ACTIONS(6389),
    [anon_sym_PERCENT] = ACTIONS(6389),
    [sym_comment] = ACTIONS(87),
  },
  [6545] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(8804),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1638),
    [sym_scope_resolution] = STATE(1634),
    [sym_call] = STATE(1634),
    [sym_method_call] = STATE(1638),
    [sym_assignment] = STATE(8804),
    [sym_operator_assignment] = STATE(8804),
    [sym_conditional] = STATE(8804),
    [sym_range] = STATE(8804),
    [sym_binary] = STATE(8804),
    [sym_unary] = STATE(8804),
    [sym_left_assignment_list] = STATE(1637),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1638),
    [sym__variable] = STATE(1634),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1638),
    [sym_false] = STATE(1638),
    [sym_nil] = STATE(1638),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(3841),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(2910),
    [anon_sym_break] = ACTIONS(2912),
    [anon_sym_next] = ACTIONS(2914),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6373),
    [anon_sym_defined_QMARK] = ACTIONS(2916),
    [anon_sym_not] = ACTIONS(2918),
    [anon_sym_BANG] = ACTIONS(2922),
    [anon_sym_TILDE] = ACTIONS(2922),
    [sym_constant] = ACTIONS(2928),
    [sym_identifier] = ACTIONS(2928),
    [sym_instance_variable] = ACTIONS(2926),
    [sym_class_variable] = ACTIONS(2926),
    [sym_global_variable] = ACTIONS(2926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2928),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2928),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6546] = {
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(6387),
    [sym__binary_star] = ACTIONS(6389),
    [anon_sym_RBRACE] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(6391),
    [anon_sym_STAR_STAR] = ACTIONS(6389),
    [anon_sym_AMP] = ACTIONS(6393),
    [anon_sym_LT] = ACTIONS(6395),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_unless] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_until] = ACTIONS(3281),
    [anon_sym_rescue] = ACTIONS(3281),
    [anon_sym_EQ_GT] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(6397),
    [anon_sym_DOT_DOT] = ACTIONS(6399),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6401),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(6403),
    [anon_sym_AMP_AMP] = ACTIONS(6403),
    [anon_sym_LT_LT] = ACTIONS(6405),
    [anon_sym_GT_GT] = ACTIONS(6405),
    [anon_sym_EQ_EQ] = ACTIONS(6407),
    [anon_sym_BANG_EQ] = ACTIONS(6403),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6403),
    [anon_sym_LT_EQ_GT] = ACTIONS(6403),
    [anon_sym_EQ_TILDE] = ACTIONS(6403),
    [anon_sym_BANG_TILDE] = ACTIONS(6403),
    [anon_sym_LT_EQ] = ACTIONS(6395),
    [anon_sym_GT] = ACTIONS(6395),
    [anon_sym_GT_EQ] = ACTIONS(6409),
    [anon_sym_CARET] = ACTIONS(6411),
    [anon_sym_PLUS] = ACTIONS(6387),
    [anon_sym_SLASH] = ACTIONS(6389),
    [anon_sym_PERCENT] = ACTIONS(6389),
    [sym_comment] = ACTIONS(87),
  },
  [6547] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(8805),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1638),
    [sym_scope_resolution] = STATE(1634),
    [sym_call] = STATE(1634),
    [sym_method_call] = STATE(1638),
    [sym_assignment] = STATE(8805),
    [sym_operator_assignment] = STATE(8805),
    [sym_conditional] = STATE(8805),
    [sym_range] = STATE(8805),
    [sym_binary] = STATE(8805),
    [sym_unary] = STATE(8805),
    [sym_left_assignment_list] = STATE(1637),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1638),
    [sym__variable] = STATE(1634),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1638),
    [sym_false] = STATE(1638),
    [sym_nil] = STATE(1638),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(3841),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(2910),
    [anon_sym_break] = ACTIONS(2912),
    [anon_sym_next] = ACTIONS(2914),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6373),
    [anon_sym_defined_QMARK] = ACTIONS(2916),
    [anon_sym_not] = ACTIONS(2918),
    [anon_sym_BANG] = ACTIONS(2922),
    [anon_sym_TILDE] = ACTIONS(2922),
    [sym_constant] = ACTIONS(2928),
    [sym_identifier] = ACTIONS(2928),
    [sym_instance_variable] = ACTIONS(2926),
    [sym_class_variable] = ACTIONS(2926),
    [sym_global_variable] = ACTIONS(2926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2928),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2928),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6548] = {
    [sym_heredoc_body] = STATE(8806),
    [aux_sym_call_repeat1] = STATE(8806),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_RBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [6549] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(3849),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1638),
    [sym_scope_resolution] = STATE(1634),
    [sym_call] = STATE(1634),
    [sym_method_call] = STATE(1638),
    [sym__argument] = STATE(4250),
    [sym_splat_argument] = STATE(4250),
    [sym_hash_splat_argument] = STATE(4250),
    [sym_block_argument] = STATE(4250),
    [sym_assignment] = STATE(3849),
    [sym_operator_assignment] = STATE(3849),
    [sym_conditional] = STATE(3849),
    [sym_range] = STATE(3849),
    [sym_binary] = STATE(3849),
    [sym_unary] = STATE(3849),
    [sym_left_assignment_list] = STATE(1637),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1638),
    [sym__variable] = STATE(1634),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1638),
    [sym_false] = STATE(1638),
    [sym_nil] = STATE(1638),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(3852),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_heredoc_body] = STATE(8807),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(4250),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(6377),
    [sym__splat_star] = ACTIONS(6379),
    [sym__unary_minus] = ACTIONS(2904),
    [sym__identifier_hash_key] = ACTIONS(6381),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12465),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(2910),
    [anon_sym_break] = ACTIONS(2912),
    [anon_sym_next] = ACTIONS(2914),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6373),
    [anon_sym_defined_QMARK] = ACTIONS(2916),
    [anon_sym_not] = ACTIONS(2918),
    [anon_sym_BANG] = ACTIONS(2922),
    [anon_sym_TILDE] = ACTIONS(2922),
    [sym_constant] = ACTIONS(6383),
    [sym_identifier] = ACTIONS(6383),
    [sym_instance_variable] = ACTIONS(2926),
    [sym_class_variable] = ACTIONS(2926),
    [sym_global_variable] = ACTIONS(2926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2928),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2928),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6550] = {
    [sym_heredoc_body] = STATE(8808),
    [aux_sym_call_repeat1] = STATE(8808),
    [aux_sym_argument_list_repeat1] = STATE(8809),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_RBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(10053),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [6551] = {
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(10017),
    [sym__binary_star] = ACTIONS(10019),
    [anon_sym_RBRACE] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(10021),
    [anon_sym_STAR_STAR] = ACTIONS(10019),
    [anon_sym_AMP] = ACTIONS(10023),
    [anon_sym_LT] = ACTIONS(10025),
    [anon_sym_if] = ACTIONS(7027),
    [anon_sym_unless] = ACTIONS(7027),
    [anon_sym_while] = ACTIONS(7027),
    [anon_sym_until] = ACTIONS(7027),
    [anon_sym_rescue] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(10027),
    [anon_sym_DOT_DOT] = ACTIONS(10029),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10031),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(10033),
    [anon_sym_AMP_AMP] = ACTIONS(10033),
    [anon_sym_LT_LT] = ACTIONS(10035),
    [anon_sym_GT_GT] = ACTIONS(10035),
    [anon_sym_EQ_EQ] = ACTIONS(10037),
    [anon_sym_BANG_EQ] = ACTIONS(10033),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10033),
    [anon_sym_LT_EQ_GT] = ACTIONS(10033),
    [anon_sym_EQ_TILDE] = ACTIONS(10033),
    [anon_sym_BANG_TILDE] = ACTIONS(10033),
    [anon_sym_LT_EQ] = ACTIONS(10025),
    [anon_sym_GT] = ACTIONS(10025),
    [anon_sym_GT_EQ] = ACTIONS(10039),
    [anon_sym_CARET] = ACTIONS(10041),
    [anon_sym_PLUS] = ACTIONS(10017),
    [anon_sym_SLASH] = ACTIONS(10019),
    [anon_sym_PERCENT] = ACTIONS(10019),
    [sym_comment] = ACTIONS(87),
  },
  [6552] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(6389),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(6389),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(6389),
    [anon_sym_PERCENT] = ACTIONS(6389),
    [sym_comment] = ACTIONS(87),
  },
  [6553] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(6389),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [6554] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6387),
    [sym__binary_star] = ACTIONS(6389),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(6389),
    [anon_sym_AMP] = ACTIONS(6393),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(6405),
    [anon_sym_GT_GT] = ACTIONS(6405),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(6387),
    [anon_sym_SLASH] = ACTIONS(6389),
    [anon_sym_PERCENT] = ACTIONS(6389),
    [sym_comment] = ACTIONS(87),
  },
  [6555] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6387),
    [sym__binary_star] = ACTIONS(6389),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(6389),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(6405),
    [anon_sym_GT_GT] = ACTIONS(6405),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(6387),
    [anon_sym_SLASH] = ACTIONS(6389),
    [anon_sym_PERCENT] = ACTIONS(6389),
    [sym_comment] = ACTIONS(87),
  },
  [6556] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6387),
    [sym__binary_star] = ACTIONS(6389),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(6391),
    [anon_sym_STAR_STAR] = ACTIONS(6389),
    [anon_sym_AMP] = ACTIONS(6393),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(6405),
    [anon_sym_GT_GT] = ACTIONS(6405),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(6411),
    [anon_sym_PLUS] = ACTIONS(6387),
    [anon_sym_SLASH] = ACTIONS(6389),
    [anon_sym_PERCENT] = ACTIONS(6389),
    [sym_comment] = ACTIONS(87),
  },
  [6557] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(12467),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [6558] = {
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(6387),
    [sym__binary_star] = ACTIONS(6389),
    [anon_sym_RBRACE] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(6391),
    [anon_sym_STAR_STAR] = ACTIONS(6389),
    [anon_sym_AMP] = ACTIONS(6393),
    [anon_sym_LT] = ACTIONS(6395),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_EQ_GT] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(6399),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6401),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(6403),
    [anon_sym_AMP_AMP] = ACTIONS(6403),
    [anon_sym_LT_LT] = ACTIONS(6405),
    [anon_sym_GT_GT] = ACTIONS(6405),
    [anon_sym_EQ_EQ] = ACTIONS(6407),
    [anon_sym_BANG_EQ] = ACTIONS(6403),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6403),
    [anon_sym_LT_EQ_GT] = ACTIONS(6403),
    [anon_sym_EQ_TILDE] = ACTIONS(6403),
    [anon_sym_BANG_TILDE] = ACTIONS(6403),
    [anon_sym_LT_EQ] = ACTIONS(6395),
    [anon_sym_GT] = ACTIONS(6395),
    [anon_sym_GT_EQ] = ACTIONS(6409),
    [anon_sym_CARET] = ACTIONS(6411),
    [anon_sym_PLUS] = ACTIONS(6387),
    [anon_sym_SLASH] = ACTIONS(6389),
    [anon_sym_PERCENT] = ACTIONS(6389),
    [sym_comment] = ACTIONS(87),
  },
  [6559] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6387),
    [sym__binary_star] = ACTIONS(6389),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(6391),
    [anon_sym_STAR_STAR] = ACTIONS(6389),
    [anon_sym_AMP] = ACTIONS(6393),
    [anon_sym_LT] = ACTIONS(6395),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(6397),
    [anon_sym_DOT_DOT] = ACTIONS(6399),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6401),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(6403),
    [anon_sym_AMP_AMP] = ACTIONS(6403),
    [anon_sym_LT_LT] = ACTIONS(6405),
    [anon_sym_GT_GT] = ACTIONS(6405),
    [anon_sym_EQ_EQ] = ACTIONS(6407),
    [anon_sym_BANG_EQ] = ACTIONS(6403),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6403),
    [anon_sym_LT_EQ_GT] = ACTIONS(6403),
    [anon_sym_EQ_TILDE] = ACTIONS(6403),
    [anon_sym_BANG_TILDE] = ACTIONS(6403),
    [anon_sym_LT_EQ] = ACTIONS(6395),
    [anon_sym_GT] = ACTIONS(6395),
    [anon_sym_GT_EQ] = ACTIONS(6409),
    [anon_sym_CARET] = ACTIONS(6411),
    [anon_sym_PLUS] = ACTIONS(6387),
    [anon_sym_SLASH] = ACTIONS(6389),
    [anon_sym_PERCENT] = ACTIONS(6389),
    [sym_comment] = ACTIONS(87),
  },
  [6560] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6387),
    [sym__binary_star] = ACTIONS(6389),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(6391),
    [anon_sym_STAR_STAR] = ACTIONS(6389),
    [anon_sym_AMP] = ACTIONS(6393),
    [anon_sym_LT] = ACTIONS(6395),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(6405),
    [anon_sym_GT_GT] = ACTIONS(6405),
    [anon_sym_EQ_EQ] = ACTIONS(6407),
    [anon_sym_BANG_EQ] = ACTIONS(6403),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6403),
    [anon_sym_LT_EQ_GT] = ACTIONS(6403),
    [anon_sym_EQ_TILDE] = ACTIONS(6403),
    [anon_sym_BANG_TILDE] = ACTIONS(6403),
    [anon_sym_LT_EQ] = ACTIONS(6395),
    [anon_sym_GT] = ACTIONS(6395),
    [anon_sym_GT_EQ] = ACTIONS(6409),
    [anon_sym_CARET] = ACTIONS(6411),
    [anon_sym_PLUS] = ACTIONS(6387),
    [anon_sym_SLASH] = ACTIONS(6389),
    [anon_sym_PERCENT] = ACTIONS(6389),
    [sym_comment] = ACTIONS(87),
  },
  [6561] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6387),
    [sym__binary_star] = ACTIONS(6389),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(6389),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(6387),
    [anon_sym_SLASH] = ACTIONS(6389),
    [anon_sym_PERCENT] = ACTIONS(6389),
    [sym_comment] = ACTIONS(87),
  },
  [6562] = {
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(6537),
    [sym__binary_star] = ACTIONS(6539),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_RBRACE] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(6541),
    [anon_sym_STAR_STAR] = ACTIONS(6543),
    [anon_sym_AMP] = ACTIONS(6545),
    [anon_sym_EQ] = ACTIONS(4217),
    [anon_sym_LT] = ACTIONS(6547),
    [anon_sym_if] = ACTIONS(4211),
    [anon_sym_unless] = ACTIONS(4211),
    [anon_sym_while] = ACTIONS(4211),
    [anon_sym_until] = ACTIONS(4211),
    [anon_sym_rescue] = ACTIONS(4211),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_EQ_GT] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_PLUS_EQ] = ACTIONS(4211),
    [anon_sym_DASH_EQ] = ACTIONS(4211),
    [anon_sym_STAR_EQ] = ACTIONS(4211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4211),
    [anon_sym_SLASH_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4211),
    [anon_sym_AMP_EQ] = ACTIONS(4211),
    [anon_sym_PERCENT_EQ] = ACTIONS(4211),
    [anon_sym_GT_GT_EQ] = ACTIONS(4211),
    [anon_sym_LT_LT_EQ] = ACTIONS(4211),
    [anon_sym_CARET_EQ] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(6549),
    [anon_sym_DOT_DOT] = ACTIONS(6551),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6553),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(6555),
    [anon_sym_AMP_AMP] = ACTIONS(6555),
    [anon_sym_LT_LT] = ACTIONS(6557),
    [anon_sym_GT_GT] = ACTIONS(6557),
    [anon_sym_EQ_EQ] = ACTIONS(6555),
    [anon_sym_BANG_EQ] = ACTIONS(6559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6559),
    [anon_sym_LT_EQ_GT] = ACTIONS(6559),
    [anon_sym_EQ_TILDE] = ACTIONS(6559),
    [anon_sym_BANG_TILDE] = ACTIONS(6559),
    [anon_sym_LT_EQ] = ACTIONS(6547),
    [anon_sym_GT] = ACTIONS(6547),
    [anon_sym_GT_EQ] = ACTIONS(6561),
    [anon_sym_CARET] = ACTIONS(6541),
    [anon_sym_PLUS] = ACTIONS(6563),
    [anon_sym_SLASH] = ACTIONS(6543),
    [anon_sym_PERCENT] = ACTIONS(6543),
    [sym_comment] = ACTIONS(87),
  },
  [6563] = {
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(6537),
    [sym__binary_star] = ACTIONS(6539),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_RBRACE] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(6541),
    [anon_sym_STAR_STAR] = ACTIONS(6543),
    [anon_sym_AMP] = ACTIONS(6545),
    [anon_sym_EQ] = ACTIONS(4249),
    [anon_sym_LT] = ACTIONS(6547),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_EQ_GT] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_PLUS_EQ] = ACTIONS(4247),
    [anon_sym_DASH_EQ] = ACTIONS(4247),
    [anon_sym_STAR_EQ] = ACTIONS(4247),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4247),
    [anon_sym_SLASH_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4247),
    [anon_sym_AMP_EQ] = ACTIONS(4247),
    [anon_sym_PERCENT_EQ] = ACTIONS(4247),
    [anon_sym_GT_GT_EQ] = ACTIONS(4247),
    [anon_sym_LT_LT_EQ] = ACTIONS(4247),
    [anon_sym_CARET_EQ] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(6549),
    [anon_sym_DOT_DOT] = ACTIONS(6551),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6553),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(6555),
    [anon_sym_AMP_AMP] = ACTIONS(6555),
    [anon_sym_LT_LT] = ACTIONS(6557),
    [anon_sym_GT_GT] = ACTIONS(6557),
    [anon_sym_EQ_EQ] = ACTIONS(6555),
    [anon_sym_BANG_EQ] = ACTIONS(6559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6559),
    [anon_sym_LT_EQ_GT] = ACTIONS(6559),
    [anon_sym_EQ_TILDE] = ACTIONS(6559),
    [anon_sym_BANG_TILDE] = ACTIONS(6559),
    [anon_sym_LT_EQ] = ACTIONS(6547),
    [anon_sym_GT] = ACTIONS(6547),
    [anon_sym_GT_EQ] = ACTIONS(6561),
    [anon_sym_CARET] = ACTIONS(6541),
    [anon_sym_PLUS] = ACTIONS(6563),
    [anon_sym_SLASH] = ACTIONS(6543),
    [anon_sym_PERCENT] = ACTIONS(6543),
    [sym_comment] = ACTIONS(87),
  },
  [6564] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(8811),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1686),
    [sym_scope_resolution] = STATE(1680),
    [sym_call] = STATE(1680),
    [sym_method_call] = STATE(1686),
    [sym_assignment] = STATE(8811),
    [sym_operator_assignment] = STATE(8811),
    [sym_conditional] = STATE(8811),
    [sym_range] = STATE(8811),
    [sym_binary] = STATE(8811),
    [sym_unary] = STATE(8811),
    [sym_left_assignment_list] = STATE(1685),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1686),
    [sym__variable] = STATE(1680),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1686),
    [sym_false] = STATE(1686),
    [sym_nil] = STATE(1686),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3944),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2992),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2998),
    [anon_sym_yield] = ACTIONS(3000),
    [anon_sym_break] = ACTIONS(3002),
    [anon_sym_next] = ACTIONS(3004),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6523),
    [anon_sym_defined_QMARK] = ACTIONS(3010),
    [anon_sym_not] = ACTIONS(3012),
    [anon_sym_BANG] = ACTIONS(3016),
    [anon_sym_TILDE] = ACTIONS(3016),
    [sym_constant] = ACTIONS(3022),
    [sym_identifier] = ACTIONS(3022),
    [sym_instance_variable] = ACTIONS(3020),
    [sym_class_variable] = ACTIONS(3020),
    [sym_global_variable] = ACTIONS(3020),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3022),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3022),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6565] = {
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(6537),
    [sym__binary_star] = ACTIONS(6539),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_RBRACE] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(6541),
    [anon_sym_STAR_STAR] = ACTIONS(6543),
    [anon_sym_AMP] = ACTIONS(6545),
    [anon_sym_EQ] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(6547),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_unless] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_until] = ACTIONS(3281),
    [anon_sym_rescue] = ACTIONS(3281),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_EQ_GT] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_PLUS_EQ] = ACTIONS(3281),
    [anon_sym_DASH_EQ] = ACTIONS(3281),
    [anon_sym_STAR_EQ] = ACTIONS(3281),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3281),
    [anon_sym_SLASH_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3281),
    [anon_sym_AMP_EQ] = ACTIONS(3281),
    [anon_sym_PERCENT_EQ] = ACTIONS(3281),
    [anon_sym_GT_GT_EQ] = ACTIONS(3281),
    [anon_sym_LT_LT_EQ] = ACTIONS(3281),
    [anon_sym_CARET_EQ] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(6549),
    [anon_sym_DOT_DOT] = ACTIONS(6551),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6553),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(6555),
    [anon_sym_AMP_AMP] = ACTIONS(6555),
    [anon_sym_LT_LT] = ACTIONS(6557),
    [anon_sym_GT_GT] = ACTIONS(6557),
    [anon_sym_EQ_EQ] = ACTIONS(6555),
    [anon_sym_BANG_EQ] = ACTIONS(6559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6559),
    [anon_sym_LT_EQ_GT] = ACTIONS(6559),
    [anon_sym_EQ_TILDE] = ACTIONS(6559),
    [anon_sym_BANG_TILDE] = ACTIONS(6559),
    [anon_sym_LT_EQ] = ACTIONS(6547),
    [anon_sym_GT] = ACTIONS(6547),
    [anon_sym_GT_EQ] = ACTIONS(6561),
    [anon_sym_CARET] = ACTIONS(6541),
    [anon_sym_PLUS] = ACTIONS(6563),
    [anon_sym_SLASH] = ACTIONS(6543),
    [anon_sym_PERCENT] = ACTIONS(6543),
    [sym_comment] = ACTIONS(87),
  },
  [6566] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(8812),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1686),
    [sym_scope_resolution] = STATE(1680),
    [sym_call] = STATE(1680),
    [sym_method_call] = STATE(1686),
    [sym_assignment] = STATE(8812),
    [sym_operator_assignment] = STATE(8812),
    [sym_conditional] = STATE(8812),
    [sym_range] = STATE(8812),
    [sym_binary] = STATE(8812),
    [sym_unary] = STATE(8812),
    [sym_left_assignment_list] = STATE(1685),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1686),
    [sym__variable] = STATE(1680),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1686),
    [sym_false] = STATE(1686),
    [sym_nil] = STATE(1686),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3944),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2992),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2998),
    [anon_sym_yield] = ACTIONS(3000),
    [anon_sym_break] = ACTIONS(3002),
    [anon_sym_next] = ACTIONS(3004),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6523),
    [anon_sym_defined_QMARK] = ACTIONS(3010),
    [anon_sym_not] = ACTIONS(3012),
    [anon_sym_BANG] = ACTIONS(3016),
    [anon_sym_TILDE] = ACTIONS(3016),
    [sym_constant] = ACTIONS(3022),
    [sym_identifier] = ACTIONS(3022),
    [sym_instance_variable] = ACTIONS(3020),
    [sym_class_variable] = ACTIONS(3020),
    [sym_global_variable] = ACTIONS(3020),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3022),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3022),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6567] = {
    [sym_heredoc_body] = STATE(8813),
    [aux_sym_call_repeat1] = STATE(8813),
    [sym__heredoc_body_start] = ACTIONS(3543),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_RBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [6568] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3870),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1686),
    [sym_scope_resolution] = STATE(1680),
    [sym_call] = STATE(1680),
    [sym_method_call] = STATE(1686),
    [sym__argument] = STATE(4357),
    [sym_splat_argument] = STATE(4357),
    [sym_hash_splat_argument] = STATE(4357),
    [sym_block_argument] = STATE(4357),
    [sym_assignment] = STATE(3870),
    [sym_operator_assignment] = STATE(3870),
    [sym_conditional] = STATE(3870),
    [sym_range] = STATE(3870),
    [sym_binary] = STATE(3870),
    [sym_unary] = STATE(3870),
    [sym_left_assignment_list] = STATE(1685),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1686),
    [sym__variable] = STATE(1680),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1686),
    [sym_false] = STATE(1686),
    [sym_nil] = STATE(1686),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3873),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_heredoc_body] = STATE(8814),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(4357),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(6413),
    [sym__splat_star] = ACTIONS(6415),
    [sym__unary_minus] = ACTIONS(2992),
    [sym__identifier_hash_key] = ACTIONS(6417),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12469),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2998),
    [anon_sym_yield] = ACTIONS(3000),
    [anon_sym_break] = ACTIONS(3002),
    [anon_sym_next] = ACTIONS(3004),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6523),
    [anon_sym_defined_QMARK] = ACTIONS(3010),
    [anon_sym_not] = ACTIONS(3012),
    [anon_sym_BANG] = ACTIONS(3016),
    [anon_sym_TILDE] = ACTIONS(3016),
    [sym_constant] = ACTIONS(6419),
    [sym_identifier] = ACTIONS(6419),
    [sym_instance_variable] = ACTIONS(3020),
    [sym_class_variable] = ACTIONS(3020),
    [sym_global_variable] = ACTIONS(3020),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3022),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3022),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6569] = {
    [sym_heredoc_body] = STATE(8815),
    [aux_sym_call_repeat1] = STATE(8815),
    [aux_sym_argument_list_repeat1] = STATE(8816),
    [sym__heredoc_body_start] = ACTIONS(3543),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_RBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(10061),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [6570] = {
    [sym_heredoc_body] = STATE(6570),
    [aux_sym_call_repeat1] = STATE(6570),
    [sym__heredoc_body_start] = ACTIONS(10455),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_RBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [6571] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(1633),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1638),
    [sym_scope_resolution] = STATE(1634),
    [sym_call] = STATE(1634),
    [sym_method_call] = STATE(1638),
    [sym__argument] = STATE(6908),
    [sym_splat_argument] = STATE(6908),
    [sym_hash_splat_argument] = STATE(6908),
    [sym_block_argument] = STATE(6908),
    [sym_assignment] = STATE(1633),
    [sym_operator_assignment] = STATE(1633),
    [sym_conditional] = STATE(1633),
    [sym_range] = STATE(1633),
    [sym_binary] = STATE(1633),
    [sym_unary] = STATE(1633),
    [sym_left_assignment_list] = STATE(1637),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1638),
    [sym__variable] = STATE(1634),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1638),
    [sym_false] = STATE(1638),
    [sym_nil] = STATE(1638),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1639),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(6908),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(2900),
    [sym__splat_star] = ACTIONS(2902),
    [sym__unary_minus] = ACTIONS(2904),
    [sym__identifier_hash_key] = ACTIONS(2906),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10065),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(2910),
    [anon_sym_break] = ACTIONS(2912),
    [anon_sym_next] = ACTIONS(2914),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6373),
    [anon_sym_defined_QMARK] = ACTIONS(2916),
    [anon_sym_not] = ACTIONS(2918),
    [anon_sym_BANG] = ACTIONS(2922),
    [anon_sym_TILDE] = ACTIONS(2922),
    [sym_constant] = ACTIONS(2924),
    [sym_identifier] = ACTIONS(2924),
    [sym_instance_variable] = ACTIONS(2926),
    [sym_class_variable] = ACTIONS(2926),
    [sym_global_variable] = ACTIONS(2926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2928),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2928),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6572] = {
    [sym_heredoc_body] = STATE(6570),
    [aux_sym_call_repeat1] = STATE(6570),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_RBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [6573] = {
    [aux_sym_argument_list_repeat1] = STATE(6573),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_RBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(12471),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_STAR_STAR] = ACTIONS(7925),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_if] = ACTIONS(7925),
    [anon_sym_unless] = ACTIONS(7925),
    [anon_sym_while] = ACTIONS(7925),
    [anon_sym_until] = ACTIONS(7925),
    [anon_sym_rescue] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7925),
    [anon_sym_AMP_AMP] = ACTIONS(7925),
    [anon_sym_LT_LT] = ACTIONS(7925),
    [anon_sym_GT_GT] = ACTIONS(7925),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7925),
    [anon_sym_PLUS] = ACTIONS(7925),
    [anon_sym_SLASH] = ACTIONS(7925),
    [anon_sym_PERCENT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [6574] = {
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(6387),
    [sym__binary_star] = ACTIONS(6389),
    [anon_sym_RBRACE] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(6391),
    [anon_sym_STAR_STAR] = ACTIONS(6389),
    [anon_sym_AMP] = ACTIONS(6393),
    [anon_sym_LT] = ACTIONS(6395),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_EQ_GT] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(6397),
    [anon_sym_DOT_DOT] = ACTIONS(6399),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6401),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(6403),
    [anon_sym_AMP_AMP] = ACTIONS(6403),
    [anon_sym_LT_LT] = ACTIONS(6405),
    [anon_sym_GT_GT] = ACTIONS(6405),
    [anon_sym_EQ_EQ] = ACTIONS(6407),
    [anon_sym_BANG_EQ] = ACTIONS(6403),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6403),
    [anon_sym_LT_EQ_GT] = ACTIONS(6403),
    [anon_sym_EQ_TILDE] = ACTIONS(6403),
    [anon_sym_BANG_TILDE] = ACTIONS(6403),
    [anon_sym_LT_EQ] = ACTIONS(6395),
    [anon_sym_GT] = ACTIONS(6395),
    [anon_sym_GT_EQ] = ACTIONS(6409),
    [anon_sym_CARET] = ACTIONS(6411),
    [anon_sym_PLUS] = ACTIONS(6387),
    [anon_sym_SLASH] = ACTIONS(6389),
    [anon_sym_PERCENT] = ACTIONS(6389),
    [sym_comment] = ACTIONS(87),
  },
  [6575] = {
    [aux_sym_exceptions_repeat1] = STATE(8818),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_RBRACE] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [6576] = {
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(6387),
    [sym__binary_star] = ACTIONS(6389),
    [anon_sym_RBRACE] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(6391),
    [anon_sym_STAR_STAR] = ACTIONS(6389),
    [anon_sym_AMP] = ACTIONS(6393),
    [anon_sym_LT] = ACTIONS(6395),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_EQ_GT] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(6397),
    [anon_sym_DOT_DOT] = ACTIONS(6399),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6401),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(6403),
    [anon_sym_AMP_AMP] = ACTIONS(6403),
    [anon_sym_LT_LT] = ACTIONS(6405),
    [anon_sym_GT_GT] = ACTIONS(6405),
    [anon_sym_EQ_EQ] = ACTIONS(6407),
    [anon_sym_BANG_EQ] = ACTIONS(6403),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6403),
    [anon_sym_LT_EQ_GT] = ACTIONS(6403),
    [anon_sym_EQ_TILDE] = ACTIONS(6403),
    [anon_sym_BANG_TILDE] = ACTIONS(6403),
    [anon_sym_LT_EQ] = ACTIONS(6395),
    [anon_sym_GT] = ACTIONS(6395),
    [anon_sym_GT_EQ] = ACTIONS(6409),
    [anon_sym_CARET] = ACTIONS(6411),
    [anon_sym_PLUS] = ACTIONS(6387),
    [anon_sym_SLASH] = ACTIONS(6389),
    [anon_sym_PERCENT] = ACTIONS(6389),
    [sym_comment] = ACTIONS(87),
  },
  [6577] = {
    [sym_string] = STATE(6577),
    [aux_sym_chained_string_repeat1] = STATE(6577),
    [sym__string_start] = ACTIONS(9407),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_RBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_EQ_GT] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [6578] = {
    [anon_sym_RBRACE] = ACTIONS(9263),
    [anon_sym_COMMA] = ACTIONS(9263),
    [anon_sym_if] = ACTIONS(9263),
    [anon_sym_unless] = ACTIONS(9263),
    [anon_sym_while] = ACTIONS(9263),
    [anon_sym_until] = ACTIONS(9263),
    [anon_sym_rescue] = ACTIONS(9263),
    [sym_comment] = ACTIONS(87),
  },
  [6579] = {
    [aux_sym_undef_repeat1] = STATE(6579),
    [anon_sym_RBRACE] = ACTIONS(9263),
    [anon_sym_COMMA] = ACTIONS(12474),
    [anon_sym_if] = ACTIONS(9263),
    [anon_sym_unless] = ACTIONS(9263),
    [anon_sym_while] = ACTIONS(9263),
    [anon_sym_until] = ACTIONS(9263),
    [anon_sym_rescue] = ACTIONS(9263),
    [sym_comment] = ACTIONS(87),
  },
  [6580] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(8819),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(457),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym_method_call] = STATE(457),
    [sym_assignment] = STATE(8819),
    [sym_operator_assignment] = STATE(8819),
    [sym_conditional] = STATE(8819),
    [sym_range] = STATE(8819),
    [sym_binary] = STATE(8819),
    [sym_unary] = STATE(8819),
    [sym_left_assignment_list] = STATE(456),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(457),
    [sym__variable] = STATE(455),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(457),
    [sym_false] = STATE(457),
    [sym_nil] = STATE(457),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(458),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(841),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_yield] = ACTIONS(851),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_next] = ACTIONS(855),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6581] = {
    [sym__simple_symbol] = ACTIONS(4285),
    [sym__string_start] = ACTIONS(4285),
    [sym__symbol_start] = ACTIONS(4285),
    [sym__subshell_start] = ACTIONS(4285),
    [sym__regex_start] = ACTIONS(4285),
    [sym__string_array_start] = ACTIONS(4285),
    [sym__symbol_array_start] = ACTIONS(4285),
    [sym_heredoc_beginning] = ACTIONS(4285),
    [sym__block_ampersand] = ACTIONS(4285),
    [sym__splat_star] = ACTIONS(4285),
    [sym__unary_minus] = ACTIONS(4285),
    [sym__binary_minus] = ACTIONS(4285),
    [sym__binary_star] = ACTIONS(4285),
    [sym__identifier_hash_key] = ACTIONS(4285),
    [anon_sym_LBRACE] = ACTIONS(4285),
    [anon_sym_RBRACE] = ACTIONS(4285),
    [anon_sym_def] = ACTIONS(4287),
    [anon_sym_LPAREN] = ACTIONS(4287),
    [anon_sym_RPAREN] = ACTIONS(4285),
    [anon_sym_DOT] = ACTIONS(4287),
    [anon_sym_COLON_COLON] = ACTIONS(4287),
    [anon_sym_COMMA] = ACTIONS(4285),
    [anon_sym_PIPE] = ACTIONS(4287),
    [anon_sym_SEMI] = ACTIONS(4285),
    [anon_sym_STAR] = ACTIONS(4287),
    [anon_sym_STAR_STAR] = ACTIONS(4287),
    [anon_sym_AMP] = ACTIONS(4287),
    [anon_sym_EQ] = ACTIONS(4287),
    [anon_sym_class] = ACTIONS(4287),
    [anon_sym_LT] = ACTIONS(4287),
    [anon_sym_module] = ACTIONS(4287),
    [anon_sym_return] = ACTIONS(4287),
    [anon_sym_yield] = ACTIONS(4287),
    [anon_sym_break] = ACTIONS(4287),
    [anon_sym_next] = ACTIONS(4287),
    [sym_redo] = ACTIONS(4287),
    [sym_retry] = ACTIONS(4287),
    [anon_sym_if] = ACTIONS(4287),
    [anon_sym_unless] = ACTIONS(4287),
    [anon_sym_while] = ACTIONS(4287),
    [anon_sym_until] = ACTIONS(4287),
    [anon_sym_rescue] = ACTIONS(4287),
    [anon_sym_for] = ACTIONS(4287),
    [anon_sym_do] = ACTIONS(4287),
    [anon_sym_case] = ACTIONS(4287),
    [anon_sym_begin] = ACTIONS(4287),
    [anon_sym_LBRACK] = ACTIONS(4285),
    [anon_sym_COLON_COLON2] = ACTIONS(4285),
    [anon_sym_AMP_DOT] = ACTIONS(4285),
    [anon_sym_LPAREN2] = ACTIONS(4285),
    [anon_sym_PLUS_EQ] = ACTIONS(4285),
    [anon_sym_DASH_EQ] = ACTIONS(4285),
    [anon_sym_STAR_EQ] = ACTIONS(4285),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4285),
    [anon_sym_SLASH_EQ] = ACTIONS(4285),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4285),
    [anon_sym_PIPE_EQ] = ACTIONS(4285),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4285),
    [anon_sym_AMP_EQ] = ACTIONS(4285),
    [anon_sym_PERCENT_EQ] = ACTIONS(4285),
    [anon_sym_GT_GT_EQ] = ACTIONS(4285),
    [anon_sym_LT_LT_EQ] = ACTIONS(4285),
    [anon_sym_CARET_EQ] = ACTIONS(4285),
    [anon_sym_QMARK] = ACTIONS(4287),
    [anon_sym_COLON2] = ACTIONS(4287),
    [anon_sym_DOT_DOT] = ACTIONS(4287),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4285),
    [anon_sym_and] = ACTIONS(4287),
    [anon_sym_or] = ACTIONS(4287),
    [anon_sym_PIPE_PIPE] = ACTIONS(4287),
    [anon_sym_AMP_AMP] = ACTIONS(4287),
    [anon_sym_LT_LT] = ACTIONS(4287),
    [anon_sym_GT_GT] = ACTIONS(4287),
    [anon_sym_EQ_EQ] = ACTIONS(4287),
    [anon_sym_BANG_EQ] = ACTIONS(4285),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4285),
    [anon_sym_LT_EQ_GT] = ACTIONS(4285),
    [anon_sym_EQ_TILDE] = ACTIONS(4285),
    [anon_sym_BANG_TILDE] = ACTIONS(4285),
    [anon_sym_LT_EQ] = ACTIONS(4287),
    [anon_sym_GT] = ACTIONS(4287),
    [anon_sym_GT_EQ] = ACTIONS(4285),
    [anon_sym_CARET] = ACTIONS(4287),
    [anon_sym_PLUS] = ACTIONS(4287),
    [anon_sym_SLASH] = ACTIONS(4287),
    [anon_sym_PERCENT] = ACTIONS(4287),
    [anon_sym_defined_QMARK] = ACTIONS(4285),
    [anon_sym_not] = ACTIONS(4287),
    [anon_sym_BANG] = ACTIONS(4287),
    [anon_sym_TILDE] = ACTIONS(4285),
    [sym_constant] = ACTIONS(4287),
    [sym_identifier] = ACTIONS(4287),
    [sym_instance_variable] = ACTIONS(4285),
    [sym_class_variable] = ACTIONS(4285),
    [sym_global_variable] = ACTIONS(4285),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4287),
    [sym_float] = ACTIONS(4287),
    [sym_complex] = ACTIONS(4285),
    [sym_super] = ACTIONS(4287),
    [anon_sym_true] = ACTIONS(4287),
    [anon_sym_TRUE] = ACTIONS(4287),
    [anon_sym_false] = ACTIONS(4287),
    [anon_sym_FALSE] = ACTIONS(4287),
    [sym_self] = ACTIONS(4287),
    [anon_sym_nil] = ACTIONS(4287),
    [anon_sym_NIL] = ACTIONS(4287),
    [sym_character] = ACTIONS(4285),
    [anon_sym_LBRACK2] = ACTIONS(4287),
    [anon_sym_DASH_GT] = ACTIONS(4285),
  },
  [6582] = {
    [anon_sym_RPAREN] = ACTIONS(12477),
    [sym_comment] = ACTIONS(87),
  },
  [6583] = {
    [sym__simple_symbol] = ACTIONS(9679),
    [sym__string_start] = ACTIONS(9679),
    [sym__symbol_start] = ACTIONS(9679),
    [sym__subshell_start] = ACTIONS(9679),
    [sym__regex_start] = ACTIONS(9679),
    [sym__string_array_start] = ACTIONS(9679),
    [sym__symbol_array_start] = ACTIONS(9679),
    [sym_heredoc_beginning] = ACTIONS(9679),
    [sym__block_ampersand] = ACTIONS(9679),
    [sym__splat_star] = ACTIONS(9679),
    [sym__unary_minus] = ACTIONS(9679),
    [sym__binary_minus] = ACTIONS(9679),
    [sym__binary_star] = ACTIONS(9679),
    [sym__identifier_hash_key] = ACTIONS(9679),
    [anon_sym_LBRACE] = ACTIONS(9679),
    [anon_sym_RBRACE] = ACTIONS(9679),
    [anon_sym_def] = ACTIONS(9681),
    [anon_sym_LPAREN] = ACTIONS(9681),
    [anon_sym_RPAREN] = ACTIONS(9679),
    [anon_sym_DOT] = ACTIONS(9681),
    [anon_sym_COLON_COLON] = ACTIONS(9681),
    [anon_sym_COMMA] = ACTIONS(9679),
    [anon_sym_PIPE] = ACTIONS(9681),
    [anon_sym_SEMI] = ACTIONS(9679),
    [anon_sym_STAR] = ACTIONS(9681),
    [anon_sym_STAR_STAR] = ACTIONS(9681),
    [anon_sym_AMP] = ACTIONS(9681),
    [anon_sym_EQ] = ACTIONS(9681),
    [anon_sym_class] = ACTIONS(9681),
    [anon_sym_LT] = ACTIONS(9681),
    [anon_sym_module] = ACTIONS(9681),
    [anon_sym_return] = ACTIONS(9681),
    [anon_sym_yield] = ACTIONS(9681),
    [anon_sym_break] = ACTIONS(9681),
    [anon_sym_next] = ACTIONS(9681),
    [sym_redo] = ACTIONS(9681),
    [sym_retry] = ACTIONS(9681),
    [anon_sym_if] = ACTIONS(9681),
    [anon_sym_unless] = ACTIONS(9681),
    [anon_sym_while] = ACTIONS(9681),
    [anon_sym_until] = ACTIONS(9681),
    [anon_sym_rescue] = ACTIONS(9681),
    [anon_sym_for] = ACTIONS(9681),
    [anon_sym_do] = ACTIONS(9681),
    [anon_sym_case] = ACTIONS(9681),
    [anon_sym_begin] = ACTIONS(9681),
    [anon_sym_LBRACK] = ACTIONS(9679),
    [anon_sym_COLON_COLON2] = ACTIONS(9679),
    [anon_sym_AMP_DOT] = ACTIONS(9679),
    [anon_sym_LPAREN2] = ACTIONS(9679),
    [anon_sym_PLUS_EQ] = ACTIONS(9679),
    [anon_sym_DASH_EQ] = ACTIONS(9679),
    [anon_sym_STAR_EQ] = ACTIONS(9679),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9679),
    [anon_sym_SLASH_EQ] = ACTIONS(9679),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9679),
    [anon_sym_PIPE_EQ] = ACTIONS(9679),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9679),
    [anon_sym_AMP_EQ] = ACTIONS(9679),
    [anon_sym_PERCENT_EQ] = ACTIONS(9679),
    [anon_sym_GT_GT_EQ] = ACTIONS(9679),
    [anon_sym_LT_LT_EQ] = ACTIONS(9679),
    [anon_sym_CARET_EQ] = ACTIONS(9679),
    [anon_sym_QMARK] = ACTIONS(9681),
    [anon_sym_COLON2] = ACTIONS(9681),
    [anon_sym_DOT_DOT] = ACTIONS(9681),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9679),
    [anon_sym_and] = ACTIONS(9681),
    [anon_sym_or] = ACTIONS(9681),
    [anon_sym_PIPE_PIPE] = ACTIONS(9681),
    [anon_sym_AMP_AMP] = ACTIONS(9681),
    [anon_sym_LT_LT] = ACTIONS(9681),
    [anon_sym_GT_GT] = ACTIONS(9681),
    [anon_sym_EQ_EQ] = ACTIONS(9681),
    [anon_sym_BANG_EQ] = ACTIONS(9679),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9679),
    [anon_sym_LT_EQ_GT] = ACTIONS(9679),
    [anon_sym_EQ_TILDE] = ACTIONS(9679),
    [anon_sym_BANG_TILDE] = ACTIONS(9679),
    [anon_sym_LT_EQ] = ACTIONS(9681),
    [anon_sym_GT] = ACTIONS(9681),
    [anon_sym_GT_EQ] = ACTIONS(9679),
    [anon_sym_CARET] = ACTIONS(9681),
    [anon_sym_PLUS] = ACTIONS(9681),
    [anon_sym_SLASH] = ACTIONS(9681),
    [anon_sym_PERCENT] = ACTIONS(9681),
    [anon_sym_defined_QMARK] = ACTIONS(9679),
    [anon_sym_not] = ACTIONS(9681),
    [anon_sym_BANG] = ACTIONS(9681),
    [anon_sym_TILDE] = ACTIONS(9679),
    [sym_constant] = ACTIONS(9681),
    [sym_identifier] = ACTIONS(9681),
    [sym_instance_variable] = ACTIONS(9679),
    [sym_class_variable] = ACTIONS(9679),
    [sym_global_variable] = ACTIONS(9679),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(9681),
    [sym_float] = ACTIONS(9681),
    [sym_complex] = ACTIONS(9679),
    [sym_super] = ACTIONS(9681),
    [anon_sym_true] = ACTIONS(9681),
    [anon_sym_TRUE] = ACTIONS(9681),
    [anon_sym_false] = ACTIONS(9681),
    [anon_sym_FALSE] = ACTIONS(9681),
    [sym_self] = ACTIONS(9681),
    [anon_sym_nil] = ACTIONS(9681),
    [anon_sym_NIL] = ACTIONS(9681),
    [sym_character] = ACTIONS(9679),
    [anon_sym_LBRACK2] = ACTIONS(9681),
    [anon_sym_DASH_GT] = ACTIONS(9679),
  },
  [6584] = {
    [sym__binary_minus] = ACTIONS(9686),
    [sym__binary_star] = ACTIONS(9686),
    [anon_sym_LBRACE] = ACTIONS(9686),
    [anon_sym_RBRACE] = ACTIONS(9686),
    [anon_sym_RPAREN] = ACTIONS(9686),
    [anon_sym_DOT] = ACTIONS(9688),
    [anon_sym_COMMA] = ACTIONS(9686),
    [anon_sym_PIPE] = ACTIONS(9688),
    [anon_sym_SEMI] = ACTIONS(9686),
    [anon_sym_STAR_STAR] = ACTIONS(9688),
    [anon_sym_AMP] = ACTIONS(9688),
    [anon_sym_EQ] = ACTIONS(9688),
    [anon_sym_LT] = ACTIONS(9688),
    [anon_sym_if] = ACTIONS(9686),
    [anon_sym_unless] = ACTIONS(9686),
    [anon_sym_while] = ACTIONS(9686),
    [anon_sym_until] = ACTIONS(9686),
    [anon_sym_rescue] = ACTIONS(9686),
    [anon_sym_do] = ACTIONS(9686),
    [anon_sym_LBRACK] = ACTIONS(9686),
    [anon_sym_COLON_COLON2] = ACTIONS(9686),
    [anon_sym_AMP_DOT] = ACTIONS(9686),
    [anon_sym_PLUS_EQ] = ACTIONS(9686),
    [anon_sym_DASH_EQ] = ACTIONS(9686),
    [anon_sym_STAR_EQ] = ACTIONS(9686),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9686),
    [anon_sym_SLASH_EQ] = ACTIONS(9686),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9686),
    [anon_sym_PIPE_EQ] = ACTIONS(9686),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9686),
    [anon_sym_AMP_EQ] = ACTIONS(9686),
    [anon_sym_PERCENT_EQ] = ACTIONS(9686),
    [anon_sym_GT_GT_EQ] = ACTIONS(9686),
    [anon_sym_LT_LT_EQ] = ACTIONS(9686),
    [anon_sym_CARET_EQ] = ACTIONS(9686),
    [anon_sym_QMARK] = ACTIONS(9686),
    [anon_sym_COLON2] = ACTIONS(9688),
    [anon_sym_DOT_DOT] = ACTIONS(9688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9686),
    [anon_sym_and] = ACTIONS(9686),
    [anon_sym_or] = ACTIONS(9686),
    [anon_sym_PIPE_PIPE] = ACTIONS(9688),
    [anon_sym_AMP_AMP] = ACTIONS(9688),
    [anon_sym_LT_LT] = ACTIONS(9688),
    [anon_sym_GT_GT] = ACTIONS(9688),
    [anon_sym_EQ_EQ] = ACTIONS(9688),
    [anon_sym_BANG_EQ] = ACTIONS(9686),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9686),
    [anon_sym_LT_EQ_GT] = ACTIONS(9686),
    [anon_sym_EQ_TILDE] = ACTIONS(9686),
    [anon_sym_BANG_TILDE] = ACTIONS(9686),
    [anon_sym_LT_EQ] = ACTIONS(9688),
    [anon_sym_GT] = ACTIONS(9688),
    [anon_sym_GT_EQ] = ACTIONS(9686),
    [anon_sym_CARET] = ACTIONS(9688),
    [anon_sym_PLUS] = ACTIONS(9688),
    [anon_sym_SLASH] = ACTIONS(9688),
    [anon_sym_PERCENT] = ACTIONS(9688),
    [sym_comment] = ACTIONS(87),
  },
  [6585] = {
    [sym__string_start] = ACTIONS(835),
    [sym__heredoc_body_start] = ACTIONS(835),
    [sym__binary_minus] = ACTIONS(835),
    [sym__binary_star] = ACTIONS(835),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_RBRACE] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(835),
    [anon_sym_DOT] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(835),
    [anon_sym_PIPE] = ACTIONS(837),
    [anon_sym_SEMI] = ACTIONS(835),
    [anon_sym_STAR_STAR] = ACTIONS(837),
    [anon_sym_AMP] = ACTIONS(837),
    [anon_sym_EQ] = ACTIONS(837),
    [anon_sym_LT] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_unless] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_until] = ACTIONS(835),
    [anon_sym_rescue] = ACTIONS(835),
    [anon_sym_in] = ACTIONS(835),
    [anon_sym_do] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_RBRACK] = ACTIONS(835),
    [anon_sym_COLON_COLON2] = ACTIONS(835),
    [anon_sym_AMP_DOT] = ACTIONS(835),
    [anon_sym_PLUS_EQ] = ACTIONS(835),
    [anon_sym_DASH_EQ] = ACTIONS(835),
    [anon_sym_STAR_EQ] = ACTIONS(835),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(835),
    [anon_sym_SLASH_EQ] = ACTIONS(835),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(835),
    [anon_sym_PIPE_EQ] = ACTIONS(835),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(835),
    [anon_sym_AMP_EQ] = ACTIONS(835),
    [anon_sym_PERCENT_EQ] = ACTIONS(835),
    [anon_sym_GT_GT_EQ] = ACTIONS(835),
    [anon_sym_LT_LT_EQ] = ACTIONS(835),
    [anon_sym_CARET_EQ] = ACTIONS(835),
    [anon_sym_QMARK] = ACTIONS(835),
    [anon_sym_COLON2] = ACTIONS(837),
    [anon_sym_DOT_DOT] = ACTIONS(837),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(835),
    [anon_sym_and] = ACTIONS(835),
    [anon_sym_or] = ACTIONS(835),
    [anon_sym_PIPE_PIPE] = ACTIONS(837),
    [anon_sym_AMP_AMP] = ACTIONS(837),
    [anon_sym_LT_LT] = ACTIONS(837),
    [anon_sym_GT_GT] = ACTIONS(837),
    [anon_sym_EQ_EQ] = ACTIONS(837),
    [anon_sym_BANG_EQ] = ACTIONS(835),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(835),
    [anon_sym_LT_EQ_GT] = ACTIONS(835),
    [anon_sym_EQ_TILDE] = ACTIONS(835),
    [anon_sym_BANG_TILDE] = ACTIONS(835),
    [anon_sym_LT_EQ] = ACTIONS(837),
    [anon_sym_GT] = ACTIONS(837),
    [anon_sym_GT_EQ] = ACTIONS(835),
    [anon_sym_CARET] = ACTIONS(837),
    [anon_sym_PLUS] = ACTIONS(837),
    [anon_sym_SLASH] = ACTIONS(837),
    [anon_sym_PERCENT] = ACTIONS(837),
    [sym_comment] = ACTIONS(87),
  },
  [6586] = {
    [sym__string_end] = ACTIONS(12479),
    [sym_comment] = ACTIONS(87),
  },
  [6587] = {
    [sym__heredoc_body_start] = ACTIONS(887),
    [sym__binary_minus] = ACTIONS(887),
    [sym__binary_star] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(887),
    [anon_sym_RBRACE] = ACTIONS(887),
    [anon_sym_RPAREN] = ACTIONS(887),
    [anon_sym_DOT] = ACTIONS(889),
    [anon_sym_COMMA] = ACTIONS(887),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI] = ACTIONS(887),
    [anon_sym_STAR_STAR] = ACTIONS(889),
    [anon_sym_AMP] = ACTIONS(889),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_LT] = ACTIONS(889),
    [anon_sym_if] = ACTIONS(887),
    [anon_sym_unless] = ACTIONS(887),
    [anon_sym_while] = ACTIONS(887),
    [anon_sym_until] = ACTIONS(887),
    [anon_sym_rescue] = ACTIONS(887),
    [anon_sym_in] = ACTIONS(887),
    [anon_sym_do] = ACTIONS(887),
    [anon_sym_LBRACK] = ACTIONS(887),
    [anon_sym_RBRACK] = ACTIONS(887),
    [anon_sym_COLON_COLON2] = ACTIONS(887),
    [anon_sym_AMP_DOT] = ACTIONS(887),
    [anon_sym_PLUS_EQ] = ACTIONS(887),
    [anon_sym_DASH_EQ] = ACTIONS(887),
    [anon_sym_STAR_EQ] = ACTIONS(887),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(887),
    [anon_sym_SLASH_EQ] = ACTIONS(887),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(887),
    [anon_sym_PIPE_EQ] = ACTIONS(887),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(887),
    [anon_sym_AMP_EQ] = ACTIONS(887),
    [anon_sym_PERCENT_EQ] = ACTIONS(887),
    [anon_sym_GT_GT_EQ] = ACTIONS(887),
    [anon_sym_LT_LT_EQ] = ACTIONS(887),
    [anon_sym_CARET_EQ] = ACTIONS(887),
    [anon_sym_QMARK] = ACTIONS(887),
    [anon_sym_COLON2] = ACTIONS(889),
    [anon_sym_DOT_DOT] = ACTIONS(889),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(887),
    [anon_sym_and] = ACTIONS(887),
    [anon_sym_or] = ACTIONS(887),
    [anon_sym_PIPE_PIPE] = ACTIONS(889),
    [anon_sym_AMP_AMP] = ACTIONS(889),
    [anon_sym_LT_LT] = ACTIONS(889),
    [anon_sym_GT_GT] = ACTIONS(889),
    [anon_sym_EQ_EQ] = ACTIONS(889),
    [anon_sym_BANG_EQ] = ACTIONS(887),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(887),
    [anon_sym_LT_EQ_GT] = ACTIONS(887),
    [anon_sym_EQ_TILDE] = ACTIONS(887),
    [anon_sym_BANG_TILDE] = ACTIONS(887),
    [anon_sym_LT_EQ] = ACTIONS(889),
    [anon_sym_GT] = ACTIONS(889),
    [anon_sym_GT_EQ] = ACTIONS(887),
    [anon_sym_CARET] = ACTIONS(889),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_SLASH] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [sym_comment] = ACTIONS(87),
  },
  [6588] = {
    [sym__string_end] = ACTIONS(12481),
    [sym_comment] = ACTIONS(87),
  },
  [6589] = {
    [sym__heredoc_body_start] = ACTIONS(893),
    [sym__binary_minus] = ACTIONS(893),
    [sym__binary_star] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(893),
    [anon_sym_RBRACE] = ACTIONS(893),
    [anon_sym_RPAREN] = ACTIONS(893),
    [anon_sym_DOT] = ACTIONS(895),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_PIPE] = ACTIONS(895),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_STAR_STAR] = ACTIONS(895),
    [anon_sym_AMP] = ACTIONS(895),
    [anon_sym_EQ] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(895),
    [anon_sym_if] = ACTIONS(893),
    [anon_sym_unless] = ACTIONS(893),
    [anon_sym_while] = ACTIONS(893),
    [anon_sym_until] = ACTIONS(893),
    [anon_sym_rescue] = ACTIONS(893),
    [anon_sym_in] = ACTIONS(893),
    [anon_sym_do] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(893),
    [anon_sym_RBRACK] = ACTIONS(893),
    [anon_sym_COLON_COLON2] = ACTIONS(893),
    [anon_sym_AMP_DOT] = ACTIONS(893),
    [anon_sym_PLUS_EQ] = ACTIONS(893),
    [anon_sym_DASH_EQ] = ACTIONS(893),
    [anon_sym_STAR_EQ] = ACTIONS(893),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(893),
    [anon_sym_SLASH_EQ] = ACTIONS(893),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(893),
    [anon_sym_PIPE_EQ] = ACTIONS(893),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(893),
    [anon_sym_AMP_EQ] = ACTIONS(893),
    [anon_sym_PERCENT_EQ] = ACTIONS(893),
    [anon_sym_GT_GT_EQ] = ACTIONS(893),
    [anon_sym_LT_LT_EQ] = ACTIONS(893),
    [anon_sym_CARET_EQ] = ACTIONS(893),
    [anon_sym_QMARK] = ACTIONS(893),
    [anon_sym_COLON2] = ACTIONS(895),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(893),
    [anon_sym_and] = ACTIONS(893),
    [anon_sym_or] = ACTIONS(893),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_LT_LT] = ACTIONS(895),
    [anon_sym_GT_GT] = ACTIONS(895),
    [anon_sym_EQ_EQ] = ACTIONS(895),
    [anon_sym_BANG_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_LT_EQ_GT] = ACTIONS(893),
    [anon_sym_EQ_TILDE] = ACTIONS(893),
    [anon_sym_BANG_TILDE] = ACTIONS(893),
    [anon_sym_LT_EQ] = ACTIONS(895),
    [anon_sym_GT] = ACTIONS(895),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_CARET] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(895),
    [anon_sym_SLASH] = ACTIONS(895),
    [anon_sym_PERCENT] = ACTIONS(895),
    [sym_comment] = ACTIONS(87),
  },
  [6590] = {
    [sym__string_end] = ACTIONS(12483),
    [sym_comment] = ACTIONS(87),
  },
  [6591] = {
    [sym__heredoc_body_start] = ACTIONS(899),
    [sym__binary_minus] = ACTIONS(899),
    [sym__binary_star] = ACTIONS(899),
    [anon_sym_LBRACE] = ACTIONS(899),
    [anon_sym_RBRACE] = ACTIONS(899),
    [anon_sym_RPAREN] = ACTIONS(899),
    [anon_sym_DOT] = ACTIONS(901),
    [anon_sym_COMMA] = ACTIONS(899),
    [anon_sym_PIPE] = ACTIONS(901),
    [anon_sym_SEMI] = ACTIONS(899),
    [anon_sym_STAR_STAR] = ACTIONS(901),
    [anon_sym_AMP] = ACTIONS(901),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_LT] = ACTIONS(901),
    [anon_sym_if] = ACTIONS(899),
    [anon_sym_unless] = ACTIONS(899),
    [anon_sym_while] = ACTIONS(899),
    [anon_sym_until] = ACTIONS(899),
    [anon_sym_rescue] = ACTIONS(899),
    [anon_sym_in] = ACTIONS(899),
    [anon_sym_do] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(899),
    [anon_sym_RBRACK] = ACTIONS(899),
    [anon_sym_COLON_COLON2] = ACTIONS(899),
    [anon_sym_AMP_DOT] = ACTIONS(899),
    [anon_sym_PLUS_EQ] = ACTIONS(899),
    [anon_sym_DASH_EQ] = ACTIONS(899),
    [anon_sym_STAR_EQ] = ACTIONS(899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(899),
    [anon_sym_SLASH_EQ] = ACTIONS(899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(899),
    [anon_sym_PIPE_EQ] = ACTIONS(899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(899),
    [anon_sym_AMP_EQ] = ACTIONS(899),
    [anon_sym_PERCENT_EQ] = ACTIONS(899),
    [anon_sym_GT_GT_EQ] = ACTIONS(899),
    [anon_sym_LT_LT_EQ] = ACTIONS(899),
    [anon_sym_CARET_EQ] = ACTIONS(899),
    [anon_sym_QMARK] = ACTIONS(899),
    [anon_sym_COLON2] = ACTIONS(901),
    [anon_sym_DOT_DOT] = ACTIONS(901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(899),
    [anon_sym_and] = ACTIONS(899),
    [anon_sym_or] = ACTIONS(899),
    [anon_sym_PIPE_PIPE] = ACTIONS(901),
    [anon_sym_AMP_AMP] = ACTIONS(901),
    [anon_sym_LT_LT] = ACTIONS(901),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_EQ_EQ] = ACTIONS(901),
    [anon_sym_BANG_EQ] = ACTIONS(899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(899),
    [anon_sym_LT_EQ_GT] = ACTIONS(899),
    [anon_sym_EQ_TILDE] = ACTIONS(899),
    [anon_sym_BANG_TILDE] = ACTIONS(899),
    [anon_sym_LT_EQ] = ACTIONS(901),
    [anon_sym_GT] = ACTIONS(901),
    [anon_sym_GT_EQ] = ACTIONS(899),
    [anon_sym_CARET] = ACTIONS(901),
    [anon_sym_PLUS] = ACTIONS(901),
    [anon_sym_SLASH] = ACTIONS(901),
    [anon_sym_PERCENT] = ACTIONS(901),
    [sym_comment] = ACTIONS(87),
  },
  [6592] = {
    [sym__string_end] = ACTIONS(12485),
    [sym_comment] = ACTIONS(87),
  },
  [6593] = {
    [sym__heredoc_body_start] = ACTIONS(905),
    [sym__binary_minus] = ACTIONS(905),
    [sym__binary_star] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(905),
    [anon_sym_RBRACE] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(905),
    [anon_sym_DOT] = ACTIONS(907),
    [anon_sym_COMMA] = ACTIONS(905),
    [anon_sym_PIPE] = ACTIONS(907),
    [anon_sym_SEMI] = ACTIONS(905),
    [anon_sym_STAR_STAR] = ACTIONS(907),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(907),
    [anon_sym_LT] = ACTIONS(907),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_unless] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_until] = ACTIONS(905),
    [anon_sym_rescue] = ACTIONS(905),
    [anon_sym_in] = ACTIONS(905),
    [anon_sym_do] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_RBRACK] = ACTIONS(905),
    [anon_sym_COLON_COLON2] = ACTIONS(905),
    [anon_sym_AMP_DOT] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_QMARK] = ACTIONS(905),
    [anon_sym_COLON2] = ACTIONS(907),
    [anon_sym_DOT_DOT] = ACTIONS(907),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(905),
    [anon_sym_and] = ACTIONS(905),
    [anon_sym_or] = ACTIONS(905),
    [anon_sym_PIPE_PIPE] = ACTIONS(907),
    [anon_sym_AMP_AMP] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(907),
    [anon_sym_GT_GT] = ACTIONS(907),
    [anon_sym_EQ_EQ] = ACTIONS(907),
    [anon_sym_BANG_EQ] = ACTIONS(905),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(905),
    [anon_sym_LT_EQ_GT] = ACTIONS(905),
    [anon_sym_EQ_TILDE] = ACTIONS(905),
    [anon_sym_BANG_TILDE] = ACTIONS(905),
    [anon_sym_LT_EQ] = ACTIONS(907),
    [anon_sym_GT] = ACTIONS(907),
    [anon_sym_GT_EQ] = ACTIONS(905),
    [anon_sym_CARET] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(907),
    [anon_sym_SLASH] = ACTIONS(907),
    [anon_sym_PERCENT] = ACTIONS(907),
    [sym_comment] = ACTIONS(87),
  },
  [6594] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(8827),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(12487),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(12489),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [6595] = {
    [aux_sym_string_array_repeat1] = STATE(8830),
    [sym__string_end] = ACTIONS(12491),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(12493),
  },
  [6596] = {
    [sym__heredoc_body_start] = ACTIONS(923),
    [sym__binary_minus] = ACTIONS(923),
    [sym__binary_star] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(923),
    [anon_sym_RBRACE] = ACTIONS(923),
    [anon_sym_RPAREN] = ACTIONS(923),
    [anon_sym_DOT] = ACTIONS(925),
    [anon_sym_COMMA] = ACTIONS(923),
    [anon_sym_PIPE] = ACTIONS(925),
    [anon_sym_SEMI] = ACTIONS(923),
    [anon_sym_STAR_STAR] = ACTIONS(925),
    [anon_sym_AMP] = ACTIONS(925),
    [anon_sym_EQ] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(925),
    [anon_sym_if] = ACTIONS(923),
    [anon_sym_unless] = ACTIONS(923),
    [anon_sym_while] = ACTIONS(923),
    [anon_sym_until] = ACTIONS(923),
    [anon_sym_rescue] = ACTIONS(923),
    [anon_sym_in] = ACTIONS(923),
    [anon_sym_do] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(923),
    [anon_sym_RBRACK] = ACTIONS(923),
    [anon_sym_COLON_COLON2] = ACTIONS(923),
    [anon_sym_AMP_DOT] = ACTIONS(923),
    [anon_sym_PLUS_EQ] = ACTIONS(923),
    [anon_sym_DASH_EQ] = ACTIONS(923),
    [anon_sym_STAR_EQ] = ACTIONS(923),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(923),
    [anon_sym_SLASH_EQ] = ACTIONS(923),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(923),
    [anon_sym_PIPE_EQ] = ACTIONS(923),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(923),
    [anon_sym_AMP_EQ] = ACTIONS(923),
    [anon_sym_PERCENT_EQ] = ACTIONS(923),
    [anon_sym_GT_GT_EQ] = ACTIONS(923),
    [anon_sym_LT_LT_EQ] = ACTIONS(923),
    [anon_sym_CARET_EQ] = ACTIONS(923),
    [anon_sym_QMARK] = ACTIONS(923),
    [anon_sym_COLON2] = ACTIONS(925),
    [anon_sym_DOT_DOT] = ACTIONS(925),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(923),
    [anon_sym_and] = ACTIONS(923),
    [anon_sym_or] = ACTIONS(923),
    [anon_sym_PIPE_PIPE] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(925),
    [anon_sym_LT_LT] = ACTIONS(925),
    [anon_sym_GT_GT] = ACTIONS(925),
    [anon_sym_EQ_EQ] = ACTIONS(925),
    [anon_sym_BANG_EQ] = ACTIONS(923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(923),
    [anon_sym_LT_EQ_GT] = ACTIONS(923),
    [anon_sym_EQ_TILDE] = ACTIONS(923),
    [anon_sym_BANG_TILDE] = ACTIONS(923),
    [anon_sym_LT_EQ] = ACTIONS(925),
    [anon_sym_GT] = ACTIONS(925),
    [anon_sym_GT_EQ] = ACTIONS(923),
    [anon_sym_CARET] = ACTIONS(925),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(925),
    [anon_sym_PERCENT] = ACTIONS(925),
    [sym_comment] = ACTIONS(87),
  },
  [6597] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(8833),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(12495),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(12497),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [6598] = {
    [aux_sym_symbol_array_repeat1] = STATE(8836),
    [sym__string_end] = ACTIONS(12499),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(12501),
  },
  [6599] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(10123),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [6600] = {
    [sym__heredoc_body_start] = ACTIONS(993),
    [sym__binary_minus] = ACTIONS(993),
    [sym__binary_star] = ACTIONS(993),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_RBRACE] = ACTIONS(993),
    [anon_sym_RPAREN] = ACTIONS(993),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(993),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_SEMI] = ACTIONS(993),
    [anon_sym_STAR_STAR] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_EQ] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(995),
    [anon_sym_if] = ACTIONS(993),
    [anon_sym_unless] = ACTIONS(993),
    [anon_sym_while] = ACTIONS(993),
    [anon_sym_until] = ACTIONS(993),
    [anon_sym_rescue] = ACTIONS(993),
    [anon_sym_in] = ACTIONS(993),
    [anon_sym_do] = ACTIONS(993),
    [anon_sym_LBRACK] = ACTIONS(993),
    [anon_sym_RBRACK] = ACTIONS(993),
    [anon_sym_COLON_COLON2] = ACTIONS(993),
    [anon_sym_AMP_DOT] = ACTIONS(993),
    [anon_sym_PLUS_EQ] = ACTIONS(993),
    [anon_sym_DASH_EQ] = ACTIONS(993),
    [anon_sym_STAR_EQ] = ACTIONS(993),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(993),
    [anon_sym_SLASH_EQ] = ACTIONS(993),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(993),
    [anon_sym_PIPE_EQ] = ACTIONS(993),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(993),
    [anon_sym_AMP_EQ] = ACTIONS(993),
    [anon_sym_PERCENT_EQ] = ACTIONS(993),
    [anon_sym_GT_GT_EQ] = ACTIONS(993),
    [anon_sym_LT_LT_EQ] = ACTIONS(993),
    [anon_sym_CARET_EQ] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(993),
    [anon_sym_COLON2] = ACTIONS(995),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(993),
    [anon_sym_and] = ACTIONS(993),
    [anon_sym_or] = ACTIONS(993),
    [anon_sym_PIPE_PIPE] = ACTIONS(995),
    [anon_sym_AMP_AMP] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(995),
    [anon_sym_GT_GT] = ACTIONS(995),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(993),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(993),
    [anon_sym_LT_EQ_GT] = ACTIONS(993),
    [anon_sym_EQ_TILDE] = ACTIONS(993),
    [anon_sym_BANG_TILDE] = ACTIONS(993),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(993),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_PLUS] = ACTIONS(995),
    [anon_sym_SLASH] = ACTIONS(995),
    [anon_sym_PERCENT] = ACTIONS(995),
    [sym_comment] = ACTIONS(87),
  },
  [6601] = {
    [anon_sym_RBRACE] = ACTIONS(12503),
    [sym_comment] = ACTIONS(87),
  },
  [6602] = {
    [sym_heredoc_body] = STATE(8838),
    [sym__heredoc_body_start] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(12503),
    [sym_comment] = ACTIONS(87),
  },
  [6603] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(8839),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(674),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(674),
    [sym_assignment] = STATE(8839),
    [sym_operator_assignment] = STATE(8839),
    [sym_conditional] = STATE(8839),
    [sym_range] = STATE(8839),
    [sym_binary] = STATE(8839),
    [sym_unary] = STATE(8839),
    [sym_left_assignment_list] = STATE(673),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(674),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(674),
    [sym_false] = STATE(674),
    [sym_nil] = STATE(674),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(675),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1243),
    [anon_sym_yield] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1247),
    [anon_sym_next] = ACTIONS(1249),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6604] = {
    [sym__heredoc_body_start] = ACTIONS(1273),
    [sym__binary_minus] = ACTIONS(1273),
    [sym__binary_star] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_RBRACE] = ACTIONS(1273),
    [anon_sym_RPAREN] = ACTIONS(1273),
    [anon_sym_DOT] = ACTIONS(1275),
    [anon_sym_COMMA] = ACTIONS(1273),
    [anon_sym_PIPE] = ACTIONS(1275),
    [anon_sym_SEMI] = ACTIONS(1273),
    [anon_sym_STAR_STAR] = ACTIONS(1275),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_EQ] = ACTIONS(1275),
    [anon_sym_LT] = ACTIONS(1275),
    [anon_sym_if] = ACTIONS(1273),
    [anon_sym_unless] = ACTIONS(1273),
    [anon_sym_while] = ACTIONS(1273),
    [anon_sym_until] = ACTIONS(1273),
    [anon_sym_rescue] = ACTIONS(1273),
    [anon_sym_in] = ACTIONS(1273),
    [anon_sym_do] = ACTIONS(1273),
    [anon_sym_LBRACK] = ACTIONS(1273),
    [anon_sym_RBRACK] = ACTIONS(1273),
    [anon_sym_COLON_COLON2] = ACTIONS(1273),
    [anon_sym_AMP_DOT] = ACTIONS(1273),
    [anon_sym_PLUS_EQ] = ACTIONS(1273),
    [anon_sym_DASH_EQ] = ACTIONS(1273),
    [anon_sym_STAR_EQ] = ACTIONS(1273),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1273),
    [anon_sym_SLASH_EQ] = ACTIONS(1273),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1273),
    [anon_sym_PIPE_EQ] = ACTIONS(1273),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1273),
    [anon_sym_AMP_EQ] = ACTIONS(1273),
    [anon_sym_PERCENT_EQ] = ACTIONS(1273),
    [anon_sym_GT_GT_EQ] = ACTIONS(1273),
    [anon_sym_LT_LT_EQ] = ACTIONS(1273),
    [anon_sym_CARET_EQ] = ACTIONS(1273),
    [anon_sym_QMARK] = ACTIONS(1273),
    [anon_sym_COLON2] = ACTIONS(1275),
    [anon_sym_DOT_DOT] = ACTIONS(1275),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_and] = ACTIONS(1273),
    [anon_sym_or] = ACTIONS(1273),
    [anon_sym_PIPE_PIPE] = ACTIONS(1275),
    [anon_sym_AMP_AMP] = ACTIONS(1275),
    [anon_sym_LT_LT] = ACTIONS(1275),
    [anon_sym_GT_GT] = ACTIONS(1275),
    [anon_sym_EQ_EQ] = ACTIONS(1275),
    [anon_sym_BANG_EQ] = ACTIONS(1273),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1273),
    [anon_sym_LT_EQ_GT] = ACTIONS(1273),
    [anon_sym_EQ_TILDE] = ACTIONS(1273),
    [anon_sym_BANG_TILDE] = ACTIONS(1273),
    [anon_sym_LT_EQ] = ACTIONS(1275),
    [anon_sym_GT] = ACTIONS(1275),
    [anon_sym_GT_EQ] = ACTIONS(1273),
    [anon_sym_CARET] = ACTIONS(1275),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_SLASH] = ACTIONS(1275),
    [anon_sym_PERCENT] = ACTIONS(1275),
    [sym_comment] = ACTIONS(87),
  },
  [6605] = {
    [anon_sym_DOT] = ACTIONS(12505),
    [anon_sym_COLON_COLON] = ACTIONS(12505),
    [sym_comment] = ACTIONS(87),
  },
  [6606] = {
    [sym_method_parameters] = STATE(8841),
    [sym__simple_formal_parameter] = STATE(684),
    [sym_splat_parameter] = STATE(684),
    [sym_hash_splat_parameter] = STATE(684),
    [sym_block_parameter] = STATE(684),
    [sym_keyword_parameter] = STATE(684),
    [sym_optional_parameter] = STATE(684),
    [sym_heredoc_body] = STATE(8841),
    [sym__terminator] = STATE(8841),
    [sym__line_break] = ACTIONS(12507),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_SEMI] = ACTIONS(12507),
    [anon_sym_STAR] = ACTIONS(1283),
    [anon_sym_STAR_STAR] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1287),
    [sym_identifier] = ACTIONS(1289),
    [sym_comment] = ACTIONS(87),
  },
  [6607] = {
    [sym__heredoc_body_start] = ACTIONS(1291),
    [sym__binary_minus] = ACTIONS(1291),
    [sym__binary_star] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1291),
    [anon_sym_RBRACE] = ACTIONS(1291),
    [anon_sym_RPAREN] = ACTIONS(1291),
    [anon_sym_DOT] = ACTIONS(1293),
    [anon_sym_COMMA] = ACTIONS(1291),
    [anon_sym_PIPE] = ACTIONS(1293),
    [anon_sym_SEMI] = ACTIONS(1291),
    [anon_sym_STAR_STAR] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1293),
    [anon_sym_EQ] = ACTIONS(1293),
    [anon_sym_LT] = ACTIONS(1293),
    [anon_sym_if] = ACTIONS(1291),
    [anon_sym_unless] = ACTIONS(1291),
    [anon_sym_while] = ACTIONS(1291),
    [anon_sym_until] = ACTIONS(1291),
    [anon_sym_rescue] = ACTIONS(1291),
    [anon_sym_in] = ACTIONS(1291),
    [anon_sym_do] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_RBRACK] = ACTIONS(1291),
    [anon_sym_COLON_COLON2] = ACTIONS(1291),
    [anon_sym_AMP_DOT] = ACTIONS(1291),
    [anon_sym_PLUS_EQ] = ACTIONS(1291),
    [anon_sym_DASH_EQ] = ACTIONS(1291),
    [anon_sym_STAR_EQ] = ACTIONS(1291),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1291),
    [anon_sym_SLASH_EQ] = ACTIONS(1291),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1291),
    [anon_sym_PIPE_EQ] = ACTIONS(1291),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1291),
    [anon_sym_AMP_EQ] = ACTIONS(1291),
    [anon_sym_PERCENT_EQ] = ACTIONS(1291),
    [anon_sym_GT_GT_EQ] = ACTIONS(1291),
    [anon_sym_LT_LT_EQ] = ACTIONS(1291),
    [anon_sym_CARET_EQ] = ACTIONS(1291),
    [anon_sym_QMARK] = ACTIONS(1291),
    [anon_sym_COLON2] = ACTIONS(1293),
    [anon_sym_DOT_DOT] = ACTIONS(1293),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1291),
    [anon_sym_and] = ACTIONS(1291),
    [anon_sym_or] = ACTIONS(1291),
    [anon_sym_PIPE_PIPE] = ACTIONS(1293),
    [anon_sym_AMP_AMP] = ACTIONS(1293),
    [anon_sym_LT_LT] = ACTIONS(1293),
    [anon_sym_GT_GT] = ACTIONS(1293),
    [anon_sym_EQ_EQ] = ACTIONS(1293),
    [anon_sym_BANG_EQ] = ACTIONS(1291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1291),
    [anon_sym_LT_EQ_GT] = ACTIONS(1291),
    [anon_sym_EQ_TILDE] = ACTIONS(1291),
    [anon_sym_BANG_TILDE] = ACTIONS(1291),
    [anon_sym_LT_EQ] = ACTIONS(1293),
    [anon_sym_GT] = ACTIONS(1293),
    [anon_sym_GT_EQ] = ACTIONS(1291),
    [anon_sym_CARET] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1293),
    [anon_sym_SLASH] = ACTIONS(1293),
    [anon_sym_PERCENT] = ACTIONS(1293),
    [sym_comment] = ACTIONS(87),
  },
  [6608] = {
    [anon_sym_RPAREN] = ACTIONS(12509),
    [sym_comment] = ACTIONS(87),
  },
  [6609] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8843),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(8843),
    [sym_operator_assignment] = STATE(8843),
    [sym_conditional] = STATE(8843),
    [sym_range] = STATE(8843),
    [sym_binary] = STATE(8843),
    [sym_unary] = STATE(8843),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(485),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(495),
    [anon_sym_defined_QMARK] = ACTIONS(497),
    [anon_sym_not] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(501),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6610] = {
    [sym_superclass] = STATE(8844),
    [sym_heredoc_body] = STATE(8845),
    [sym__terminator] = STATE(8845),
    [sym__line_break] = ACTIONS(12511),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1089),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(12511),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1089),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1517),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1089),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [6611] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_superclass] = STATE(8844),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(859),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym_argument_list] = STATE(832),
    [sym__argument_list_with_parens] = STATE(860),
    [sym__argument] = STATE(861),
    [sym_splat_argument] = STATE(861),
    [sym_hash_splat_argument] = STATE(861),
    [sym_block_argument] = STATE(861),
    [sym_do_block] = STATE(835),
    [sym_block] = STATE(835),
    [sym_assignment] = STATE(859),
    [sym_operator_assignment] = STATE(859),
    [sym_conditional] = STATE(859),
    [sym_range] = STATE(859),
    [sym_binary] = STATE(859),
    [sym_unary] = STATE(859),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(864),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_heredoc_body] = STATE(8845),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(861),
    [sym_lambda] = STATE(347),
    [sym__terminator] = STATE(8845),
    [sym__line_break] = ACTIONS(12511),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1521),
    [sym__splat_star] = ACTIONS(1523),
    [sym__unary_minus] = ACTIONS(1525),
    [sym__identifier_hash_key] = ACTIONS(1527),
    [anon_sym_LBRACE] = ACTIONS(1529),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(743),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(12511),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1531),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(1517),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1473),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(1549),
    [sym_identifier] = ACTIONS(1549),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6612] = {
    [sym_heredoc_body] = STATE(8847),
    [sym__terminator] = STATE(8847),
    [sym__line_break] = ACTIONS(12513),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1089),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(12513),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1089),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(12515),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1089),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [6613] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(859),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym_argument_list] = STATE(832),
    [sym__argument_list_with_parens] = STATE(860),
    [sym__argument] = STATE(861),
    [sym_splat_argument] = STATE(861),
    [sym_hash_splat_argument] = STATE(861),
    [sym_block_argument] = STATE(861),
    [sym_do_block] = STATE(835),
    [sym_block] = STATE(835),
    [sym_assignment] = STATE(859),
    [sym_operator_assignment] = STATE(859),
    [sym_conditional] = STATE(859),
    [sym_range] = STATE(859),
    [sym_binary] = STATE(859),
    [sym_unary] = STATE(859),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(864),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_heredoc_body] = STATE(8847),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(861),
    [sym_lambda] = STATE(347),
    [sym__terminator] = STATE(8847),
    [sym__line_break] = ACTIONS(12513),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1521),
    [sym__splat_star] = ACTIONS(1523),
    [sym__unary_minus] = ACTIONS(1525),
    [sym__identifier_hash_key] = ACTIONS(1527),
    [anon_sym_LBRACE] = ACTIONS(1529),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(743),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(12513),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1531),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_end] = ACTIONS(12515),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1473),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(1549),
    [sym_identifier] = ACTIONS(1549),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6614] = {
    [sym__heredoc_body_start] = ACTIONS(1677),
    [sym__binary_minus] = ACTIONS(1677),
    [sym__binary_star] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1677),
    [anon_sym_RBRACE] = ACTIONS(1677),
    [anon_sym_RPAREN] = ACTIONS(1677),
    [anon_sym_DOT] = ACTIONS(1679),
    [anon_sym_COMMA] = ACTIONS(1677),
    [anon_sym_PIPE] = ACTIONS(1679),
    [anon_sym_SEMI] = ACTIONS(1677),
    [anon_sym_STAR_STAR] = ACTIONS(1679),
    [anon_sym_AMP] = ACTIONS(1679),
    [anon_sym_EQ] = ACTIONS(1679),
    [anon_sym_LT] = ACTIONS(1679),
    [anon_sym_if] = ACTIONS(1677),
    [anon_sym_unless] = ACTIONS(1677),
    [anon_sym_while] = ACTIONS(1677),
    [anon_sym_until] = ACTIONS(1677),
    [anon_sym_rescue] = ACTIONS(1677),
    [anon_sym_in] = ACTIONS(1677),
    [anon_sym_do] = ACTIONS(1677),
    [anon_sym_LBRACK] = ACTIONS(1677),
    [anon_sym_RBRACK] = ACTIONS(1677),
    [anon_sym_COLON_COLON2] = ACTIONS(1677),
    [anon_sym_AMP_DOT] = ACTIONS(1677),
    [anon_sym_PLUS_EQ] = ACTIONS(1677),
    [anon_sym_DASH_EQ] = ACTIONS(1677),
    [anon_sym_STAR_EQ] = ACTIONS(1677),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1677),
    [anon_sym_SLASH_EQ] = ACTIONS(1677),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1677),
    [anon_sym_PIPE_EQ] = ACTIONS(1677),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1677),
    [anon_sym_AMP_EQ] = ACTIONS(1677),
    [anon_sym_PERCENT_EQ] = ACTIONS(1677),
    [anon_sym_GT_GT_EQ] = ACTIONS(1677),
    [anon_sym_LT_LT_EQ] = ACTIONS(1677),
    [anon_sym_CARET_EQ] = ACTIONS(1677),
    [anon_sym_QMARK] = ACTIONS(1677),
    [anon_sym_COLON2] = ACTIONS(1679),
    [anon_sym_DOT_DOT] = ACTIONS(1679),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1677),
    [anon_sym_and] = ACTIONS(1677),
    [anon_sym_or] = ACTIONS(1677),
    [anon_sym_PIPE_PIPE] = ACTIONS(1679),
    [anon_sym_AMP_AMP] = ACTIONS(1679),
    [anon_sym_LT_LT] = ACTIONS(1679),
    [anon_sym_GT_GT] = ACTIONS(1679),
    [anon_sym_EQ_EQ] = ACTIONS(1679),
    [anon_sym_BANG_EQ] = ACTIONS(1677),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1677),
    [anon_sym_LT_EQ_GT] = ACTIONS(1677),
    [anon_sym_EQ_TILDE] = ACTIONS(1677),
    [anon_sym_BANG_TILDE] = ACTIONS(1677),
    [anon_sym_LT_EQ] = ACTIONS(1679),
    [anon_sym_GT] = ACTIONS(1679),
    [anon_sym_GT_EQ] = ACTIONS(1677),
    [anon_sym_CARET] = ACTIONS(1679),
    [anon_sym_PLUS] = ACTIONS(1679),
    [anon_sym_SLASH] = ACTIONS(1679),
    [anon_sym_PERCENT] = ACTIONS(1679),
    [sym_comment] = ACTIONS(87),
  },
  [6615] = {
    [sym__heredoc_body_start] = ACTIONS(1697),
    [sym__binary_minus] = ACTIONS(1697),
    [sym__binary_star] = ACTIONS(1697),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_RBRACE] = ACTIONS(1697),
    [anon_sym_RPAREN] = ACTIONS(1697),
    [anon_sym_DOT] = ACTIONS(1699),
    [anon_sym_COMMA] = ACTIONS(1697),
    [anon_sym_PIPE] = ACTIONS(1699),
    [anon_sym_SEMI] = ACTIONS(1697),
    [anon_sym_STAR_STAR] = ACTIONS(1699),
    [anon_sym_AMP] = ACTIONS(1699),
    [anon_sym_EQ] = ACTIONS(1699),
    [anon_sym_LT] = ACTIONS(1699),
    [anon_sym_if] = ACTIONS(1697),
    [anon_sym_unless] = ACTIONS(1697),
    [anon_sym_while] = ACTIONS(1697),
    [anon_sym_until] = ACTIONS(1697),
    [anon_sym_rescue] = ACTIONS(1697),
    [anon_sym_in] = ACTIONS(1697),
    [anon_sym_do] = ACTIONS(1697),
    [anon_sym_LBRACK] = ACTIONS(1697),
    [anon_sym_RBRACK] = ACTIONS(1697),
    [anon_sym_COLON_COLON2] = ACTIONS(1697),
    [anon_sym_AMP_DOT] = ACTIONS(1697),
    [anon_sym_PLUS_EQ] = ACTIONS(1697),
    [anon_sym_DASH_EQ] = ACTIONS(1697),
    [anon_sym_STAR_EQ] = ACTIONS(1697),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1697),
    [anon_sym_SLASH_EQ] = ACTIONS(1697),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1697),
    [anon_sym_PIPE_EQ] = ACTIONS(1697),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1697),
    [anon_sym_AMP_EQ] = ACTIONS(1697),
    [anon_sym_PERCENT_EQ] = ACTIONS(1697),
    [anon_sym_GT_GT_EQ] = ACTIONS(1697),
    [anon_sym_LT_LT_EQ] = ACTIONS(1697),
    [anon_sym_CARET_EQ] = ACTIONS(1697),
    [anon_sym_QMARK] = ACTIONS(1697),
    [anon_sym_COLON2] = ACTIONS(1699),
    [anon_sym_DOT_DOT] = ACTIONS(1699),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1697),
    [anon_sym_and] = ACTIONS(1697),
    [anon_sym_or] = ACTIONS(1697),
    [anon_sym_PIPE_PIPE] = ACTIONS(1699),
    [anon_sym_AMP_AMP] = ACTIONS(1699),
    [anon_sym_LT_LT] = ACTIONS(1699),
    [anon_sym_GT_GT] = ACTIONS(1699),
    [anon_sym_EQ_EQ] = ACTIONS(1699),
    [anon_sym_BANG_EQ] = ACTIONS(1697),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1697),
    [anon_sym_LT_EQ_GT] = ACTIONS(1697),
    [anon_sym_EQ_TILDE] = ACTIONS(1697),
    [anon_sym_BANG_TILDE] = ACTIONS(1697),
    [anon_sym_LT_EQ] = ACTIONS(1699),
    [anon_sym_GT] = ACTIONS(1699),
    [anon_sym_GT_EQ] = ACTIONS(1697),
    [anon_sym_CARET] = ACTIONS(1699),
    [anon_sym_PLUS] = ACTIONS(1699),
    [anon_sym_SLASH] = ACTIONS(1699),
    [anon_sym_PERCENT] = ACTIONS(1699),
    [sym_comment] = ACTIONS(87),
  },
  [6616] = {
    [sym__heredoc_body_start] = ACTIONS(1701),
    [sym__binary_minus] = ACTIONS(1701),
    [sym__binary_star] = ACTIONS(1701),
    [anon_sym_LBRACE] = ACTIONS(1701),
    [anon_sym_RBRACE] = ACTIONS(1701),
    [anon_sym_RPAREN] = ACTIONS(1701),
    [anon_sym_DOT] = ACTIONS(1703),
    [anon_sym_COMMA] = ACTIONS(1701),
    [anon_sym_PIPE] = ACTIONS(1703),
    [anon_sym_SEMI] = ACTIONS(1701),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1703),
    [anon_sym_EQ] = ACTIONS(1703),
    [anon_sym_LT] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1701),
    [anon_sym_unless] = ACTIONS(1701),
    [anon_sym_while] = ACTIONS(1701),
    [anon_sym_until] = ACTIONS(1701),
    [anon_sym_rescue] = ACTIONS(1701),
    [anon_sym_in] = ACTIONS(1701),
    [anon_sym_do] = ACTIONS(1701),
    [anon_sym_LBRACK] = ACTIONS(1701),
    [anon_sym_RBRACK] = ACTIONS(1701),
    [anon_sym_COLON_COLON2] = ACTIONS(1701),
    [anon_sym_AMP_DOT] = ACTIONS(1701),
    [anon_sym_PLUS_EQ] = ACTIONS(1701),
    [anon_sym_DASH_EQ] = ACTIONS(1701),
    [anon_sym_STAR_EQ] = ACTIONS(1701),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1701),
    [anon_sym_SLASH_EQ] = ACTIONS(1701),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1701),
    [anon_sym_PIPE_EQ] = ACTIONS(1701),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1701),
    [anon_sym_AMP_EQ] = ACTIONS(1701),
    [anon_sym_PERCENT_EQ] = ACTIONS(1701),
    [anon_sym_GT_GT_EQ] = ACTIONS(1701),
    [anon_sym_LT_LT_EQ] = ACTIONS(1701),
    [anon_sym_CARET_EQ] = ACTIONS(1701),
    [anon_sym_QMARK] = ACTIONS(1701),
    [anon_sym_COLON2] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1703),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1701),
    [anon_sym_and] = ACTIONS(1701),
    [anon_sym_or] = ACTIONS(1701),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1703),
    [anon_sym_BANG_EQ] = ACTIONS(1701),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1701),
    [anon_sym_LT_EQ_GT] = ACTIONS(1701),
    [anon_sym_EQ_TILDE] = ACTIONS(1701),
    [anon_sym_BANG_TILDE] = ACTIONS(1701),
    [anon_sym_LT_EQ] = ACTIONS(1703),
    [anon_sym_GT] = ACTIONS(1703),
    [anon_sym_GT_EQ] = ACTIONS(1701),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [6617] = {
    [sym__heredoc_body_start] = ACTIONS(1705),
    [sym__binary_minus] = ACTIONS(1705),
    [sym__binary_star] = ACTIONS(1705),
    [anon_sym_LBRACE] = ACTIONS(1705),
    [anon_sym_RBRACE] = ACTIONS(1705),
    [anon_sym_RPAREN] = ACTIONS(1705),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1705),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1705),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1705),
    [anon_sym_unless] = ACTIONS(1705),
    [anon_sym_while] = ACTIONS(1705),
    [anon_sym_until] = ACTIONS(1705),
    [anon_sym_rescue] = ACTIONS(1705),
    [anon_sym_in] = ACTIONS(1705),
    [anon_sym_do] = ACTIONS(1705),
    [anon_sym_LBRACK] = ACTIONS(1705),
    [anon_sym_RBRACK] = ACTIONS(1705),
    [anon_sym_COLON_COLON2] = ACTIONS(1705),
    [anon_sym_AMP_DOT] = ACTIONS(1705),
    [anon_sym_PLUS_EQ] = ACTIONS(1705),
    [anon_sym_DASH_EQ] = ACTIONS(1705),
    [anon_sym_STAR_EQ] = ACTIONS(1705),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1705),
    [anon_sym_SLASH_EQ] = ACTIONS(1705),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1705),
    [anon_sym_PIPE_EQ] = ACTIONS(1705),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1705),
    [anon_sym_AMP_EQ] = ACTIONS(1705),
    [anon_sym_PERCENT_EQ] = ACTIONS(1705),
    [anon_sym_GT_GT_EQ] = ACTIONS(1705),
    [anon_sym_LT_LT_EQ] = ACTIONS(1705),
    [anon_sym_CARET_EQ] = ACTIONS(1705),
    [anon_sym_QMARK] = ACTIONS(1705),
    [anon_sym_COLON2] = ACTIONS(1707),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1705),
    [anon_sym_and] = ACTIONS(1705),
    [anon_sym_or] = ACTIONS(1705),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1705),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1705),
    [anon_sym_LT_EQ_GT] = ACTIONS(1705),
    [anon_sym_EQ_TILDE] = ACTIONS(1705),
    [anon_sym_BANG_TILDE] = ACTIONS(1705),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1705),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [6618] = {
    [sym_then] = STATE(8848),
    [sym_heredoc_body] = STATE(8849),
    [sym__terminator] = STATE(8849),
    [sym__line_break] = ACTIONS(12517),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(12517),
    [anon_sym_if] = ACTIONS(1743),
    [anon_sym_unless] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1747),
    [anon_sym_until] = ACTIONS(1749),
    [anon_sym_rescue] = ACTIONS(1751),
    [anon_sym_then] = ACTIONS(1753),
    [sym_comment] = ACTIONS(87),
  },
  [6619] = {
    [sym_then] = STATE(8850),
    [sym_heredoc_body] = STATE(8851),
    [sym__terminator] = STATE(8851),
    [sym__line_break] = ACTIONS(12519),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(12519),
    [anon_sym_if] = ACTIONS(1743),
    [anon_sym_unless] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1747),
    [anon_sym_until] = ACTIONS(1749),
    [anon_sym_rescue] = ACTIONS(1751),
    [anon_sym_then] = ACTIONS(1821),
    [sym_comment] = ACTIONS(87),
  },
  [6620] = {
    [sym__do] = STATE(8852),
    [sym_heredoc_body] = STATE(8852),
    [sym__terminator] = STATE(8852),
    [sym__line_break] = ACTIONS(12521),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym__binary_minus] = ACTIONS(1855),
    [sym__binary_star] = ACTIONS(1857),
    [anon_sym_PIPE] = ACTIONS(1859),
    [anon_sym_SEMI] = ACTIONS(12521),
    [anon_sym_STAR_STAR] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_LT] = ACTIONS(1863),
    [anon_sym_do] = ACTIONS(12521),
    [anon_sym_QMARK] = ACTIONS(1865),
    [anon_sym_DOT_DOT] = ACTIONS(1867),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1869),
    [anon_sym_and] = ACTIONS(1871),
    [anon_sym_or] = ACTIONS(1871),
    [anon_sym_PIPE_PIPE] = ACTIONS(1873),
    [anon_sym_AMP_AMP] = ACTIONS(1873),
    [anon_sym_LT_LT] = ACTIONS(1875),
    [anon_sym_GT_GT] = ACTIONS(1875),
    [anon_sym_EQ_EQ] = ACTIONS(1877),
    [anon_sym_BANG_EQ] = ACTIONS(1873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1873),
    [anon_sym_LT_EQ_GT] = ACTIONS(1873),
    [anon_sym_EQ_TILDE] = ACTIONS(1873),
    [anon_sym_BANG_TILDE] = ACTIONS(1873),
    [anon_sym_LT_EQ] = ACTIONS(1863),
    [anon_sym_GT] = ACTIONS(1863),
    [anon_sym_GT_EQ] = ACTIONS(1879),
    [anon_sym_CARET] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_SLASH] = ACTIONS(1857),
    [anon_sym_PERCENT] = ACTIONS(1857),
    [sym_comment] = ACTIONS(87),
  },
  [6621] = {
    [sym__do] = STATE(8853),
    [sym_heredoc_body] = STATE(8853),
    [sym__terminator] = STATE(8853),
    [sym__line_break] = ACTIONS(12523),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym__binary_minus] = ACTIONS(1855),
    [sym__binary_star] = ACTIONS(1857),
    [anon_sym_PIPE] = ACTIONS(1859),
    [anon_sym_SEMI] = ACTIONS(12523),
    [anon_sym_STAR_STAR] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_LT] = ACTIONS(1863),
    [anon_sym_do] = ACTIONS(12523),
    [anon_sym_QMARK] = ACTIONS(1865),
    [anon_sym_DOT_DOT] = ACTIONS(1867),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1869),
    [anon_sym_and] = ACTIONS(1871),
    [anon_sym_or] = ACTIONS(1871),
    [anon_sym_PIPE_PIPE] = ACTIONS(1873),
    [anon_sym_AMP_AMP] = ACTIONS(1873),
    [anon_sym_LT_LT] = ACTIONS(1875),
    [anon_sym_GT_GT] = ACTIONS(1875),
    [anon_sym_EQ_EQ] = ACTIONS(1877),
    [anon_sym_BANG_EQ] = ACTIONS(1873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1873),
    [anon_sym_LT_EQ_GT] = ACTIONS(1873),
    [anon_sym_EQ_TILDE] = ACTIONS(1873),
    [anon_sym_BANG_TILDE] = ACTIONS(1873),
    [anon_sym_LT_EQ] = ACTIONS(1863),
    [anon_sym_GT] = ACTIONS(1863),
    [anon_sym_GT_EQ] = ACTIONS(1879),
    [anon_sym_CARET] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_SLASH] = ACTIONS(1857),
    [anon_sym_PERCENT] = ACTIONS(1857),
    [sym_comment] = ACTIONS(87),
  },
  [6622] = {
    [sym_in] = STATE(8854),
    [anon_sym_in] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
  },
  [6623] = {
    [sym_heredoc_body] = STATE(8855),
    [sym__terminator] = STATE(8855),
    [sym__line_break] = ACTIONS(12525),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym__binary_minus] = ACTIONS(2001),
    [sym__binary_star] = ACTIONS(2003),
    [anon_sym_PIPE] = ACTIONS(2005),
    [anon_sym_SEMI] = ACTIONS(12525),
    [anon_sym_STAR_STAR] = ACTIONS(2003),
    [anon_sym_AMP] = ACTIONS(2007),
    [anon_sym_LT] = ACTIONS(2009),
    [anon_sym_QMARK] = ACTIONS(2011),
    [anon_sym_DOT_DOT] = ACTIONS(2013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2015),
    [anon_sym_and] = ACTIONS(2017),
    [anon_sym_or] = ACTIONS(2017),
    [anon_sym_PIPE_PIPE] = ACTIONS(2019),
    [anon_sym_AMP_AMP] = ACTIONS(2019),
    [anon_sym_LT_LT] = ACTIONS(2021),
    [anon_sym_GT_GT] = ACTIONS(2021),
    [anon_sym_EQ_EQ] = ACTIONS(2023),
    [anon_sym_BANG_EQ] = ACTIONS(2019),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2019),
    [anon_sym_LT_EQ_GT] = ACTIONS(2019),
    [anon_sym_EQ_TILDE] = ACTIONS(2019),
    [anon_sym_BANG_TILDE] = ACTIONS(2019),
    [anon_sym_LT_EQ] = ACTIONS(2009),
    [anon_sym_GT] = ACTIONS(2009),
    [anon_sym_GT_EQ] = ACTIONS(2025),
    [anon_sym_CARET] = ACTIONS(2027),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_SLASH] = ACTIONS(2003),
    [anon_sym_PERCENT] = ACTIONS(2003),
    [sym_comment] = ACTIONS(87),
  },
  [6624] = {
    [sym_when] = STATE(8859),
    [sym_else] = STATE(8857),
    [aux_sym_case_repeat1] = STATE(8858),
    [aux_sym_case_repeat2] = STATE(8859),
    [anon_sym_SEMI] = ACTIONS(12527),
    [anon_sym_end] = ACTIONS(12529),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [6625] = {
    [sym_else] = STATE(8861),
    [sym_ensure] = STATE(8862),
    [sym_rescue] = STATE(8863),
    [anon_sym_end] = ACTIONS(12531),
    [anon_sym_rescue] = ACTIONS(2165),
    [anon_sym_else] = ACTIONS(2167),
    [anon_sym_ensure] = ACTIONS(2169),
    [sym_comment] = ACTIONS(87),
  },
  [6626] = {
    [sym_ensure] = STATE(8862),
    [anon_sym_end] = ACTIONS(12531),
    [anon_sym_ensure] = ACTIONS(2169),
    [sym_comment] = ACTIONS(87),
  },
  [6627] = {
    [anon_sym_end] = ACTIONS(12531),
    [sym_comment] = ACTIONS(87),
  },
  [6628] = {
    [sym_else] = STATE(8861),
    [sym_ensure] = STATE(8862),
    [anon_sym_end] = ACTIONS(12531),
    [anon_sym_else] = ACTIONS(2167),
    [anon_sym_ensure] = ACTIONS(2169),
    [sym_comment] = ACTIONS(87),
  },
  [6629] = {
    [sym__heredoc_body_start] = ACTIONS(2181),
    [sym__binary_minus] = ACTIONS(2181),
    [sym__binary_star] = ACTIONS(2181),
    [anon_sym_LBRACE] = ACTIONS(2181),
    [anon_sym_RBRACE] = ACTIONS(2181),
    [anon_sym_RPAREN] = ACTIONS(2181),
    [anon_sym_DOT] = ACTIONS(2183),
    [anon_sym_COMMA] = ACTIONS(2181),
    [anon_sym_PIPE] = ACTIONS(2183),
    [anon_sym_SEMI] = ACTIONS(2181),
    [anon_sym_STAR_STAR] = ACTIONS(2183),
    [anon_sym_AMP] = ACTIONS(2183),
    [anon_sym_EQ] = ACTIONS(2183),
    [anon_sym_LT] = ACTIONS(2183),
    [anon_sym_if] = ACTIONS(2181),
    [anon_sym_unless] = ACTIONS(2181),
    [anon_sym_while] = ACTIONS(2181),
    [anon_sym_until] = ACTIONS(2181),
    [anon_sym_rescue] = ACTIONS(2181),
    [anon_sym_in] = ACTIONS(2181),
    [anon_sym_do] = ACTIONS(2181),
    [anon_sym_LBRACK] = ACTIONS(2181),
    [anon_sym_RBRACK] = ACTIONS(2181),
    [anon_sym_COLON_COLON2] = ACTIONS(2181),
    [anon_sym_AMP_DOT] = ACTIONS(2181),
    [anon_sym_PLUS_EQ] = ACTIONS(2181),
    [anon_sym_DASH_EQ] = ACTIONS(2181),
    [anon_sym_STAR_EQ] = ACTIONS(2181),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2181),
    [anon_sym_SLASH_EQ] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2181),
    [anon_sym_PIPE_EQ] = ACTIONS(2181),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2181),
    [anon_sym_AMP_EQ] = ACTIONS(2181),
    [anon_sym_PERCENT_EQ] = ACTIONS(2181),
    [anon_sym_GT_GT_EQ] = ACTIONS(2181),
    [anon_sym_LT_LT_EQ] = ACTIONS(2181),
    [anon_sym_CARET_EQ] = ACTIONS(2181),
    [anon_sym_QMARK] = ACTIONS(2181),
    [anon_sym_COLON2] = ACTIONS(2183),
    [anon_sym_DOT_DOT] = ACTIONS(2183),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2183),
    [anon_sym_AMP_AMP] = ACTIONS(2183),
    [anon_sym_LT_LT] = ACTIONS(2183),
    [anon_sym_GT_GT] = ACTIONS(2183),
    [anon_sym_EQ_EQ] = ACTIONS(2183),
    [anon_sym_BANG_EQ] = ACTIONS(2181),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2181),
    [anon_sym_LT_EQ_GT] = ACTIONS(2181),
    [anon_sym_EQ_TILDE] = ACTIONS(2181),
    [anon_sym_BANG_TILDE] = ACTIONS(2181),
    [anon_sym_LT_EQ] = ACTIONS(2183),
    [anon_sym_GT] = ACTIONS(2183),
    [anon_sym_GT_EQ] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2183),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_SLASH] = ACTIONS(2183),
    [anon_sym_PERCENT] = ACTIONS(2183),
    [sym_comment] = ACTIONS(87),
  },
  [6630] = {
    [sym__statements] = STATE(6625),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(6626),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(6627),
    [sym_rescue] = STATE(6628),
    [sym__body_statement] = STATE(8864),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12533),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6631] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(10117),
    [sym__binary_star] = ACTIONS(10119),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(10121),
    [anon_sym_STAR_STAR] = ACTIONS(10123),
    [anon_sym_AMP] = ACTIONS(10125),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(10127),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(10129),
    [anon_sym_DOT_DOT] = ACTIONS(10131),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10133),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(10135),
    [anon_sym_AMP_AMP] = ACTIONS(10135),
    [anon_sym_LT_LT] = ACTIONS(10137),
    [anon_sym_GT_GT] = ACTIONS(10137),
    [anon_sym_EQ_EQ] = ACTIONS(10135),
    [anon_sym_BANG_EQ] = ACTIONS(10139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10139),
    [anon_sym_LT_EQ_GT] = ACTIONS(10139),
    [anon_sym_EQ_TILDE] = ACTIONS(10139),
    [anon_sym_BANG_TILDE] = ACTIONS(10139),
    [anon_sym_LT_EQ] = ACTIONS(10127),
    [anon_sym_GT] = ACTIONS(10127),
    [anon_sym_GT_EQ] = ACTIONS(10141),
    [anon_sym_CARET] = ACTIONS(10121),
    [anon_sym_PLUS] = ACTIONS(10143),
    [anon_sym_SLASH] = ACTIONS(10123),
    [anon_sym_PERCENT] = ACTIONS(10123),
    [sym_comment] = ACTIONS(87),
  },
  [6632] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(937),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_in] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_RBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_COLON2] = ACTIONS(937),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [6633] = {
    [sym__heredoc_body_start] = ACTIONS(2261),
    [sym__binary_minus] = ACTIONS(2261),
    [sym__binary_star] = ACTIONS(2261),
    [anon_sym_LBRACE] = ACTIONS(2261),
    [anon_sym_RBRACE] = ACTIONS(2261),
    [anon_sym_RPAREN] = ACTIONS(2261),
    [anon_sym_DOT] = ACTIONS(2263),
    [anon_sym_COMMA] = ACTIONS(2261),
    [anon_sym_PIPE] = ACTIONS(2263),
    [anon_sym_SEMI] = ACTIONS(2261),
    [anon_sym_STAR_STAR] = ACTIONS(2263),
    [anon_sym_AMP] = ACTIONS(2263),
    [anon_sym_EQ] = ACTIONS(2263),
    [anon_sym_LT] = ACTIONS(2263),
    [anon_sym_if] = ACTIONS(2261),
    [anon_sym_unless] = ACTIONS(2261),
    [anon_sym_while] = ACTIONS(2261),
    [anon_sym_until] = ACTIONS(2261),
    [anon_sym_rescue] = ACTIONS(2261),
    [anon_sym_in] = ACTIONS(2261),
    [anon_sym_do] = ACTIONS(2261),
    [anon_sym_LBRACK] = ACTIONS(2261),
    [anon_sym_RBRACK] = ACTIONS(2261),
    [anon_sym_COLON_COLON2] = ACTIONS(2261),
    [anon_sym_AMP_DOT] = ACTIONS(2261),
    [anon_sym_PLUS_EQ] = ACTIONS(2261),
    [anon_sym_DASH_EQ] = ACTIONS(2261),
    [anon_sym_STAR_EQ] = ACTIONS(2261),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2261),
    [anon_sym_SLASH_EQ] = ACTIONS(2261),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2261),
    [anon_sym_PIPE_EQ] = ACTIONS(2261),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2261),
    [anon_sym_AMP_EQ] = ACTIONS(2261),
    [anon_sym_PERCENT_EQ] = ACTIONS(2261),
    [anon_sym_GT_GT_EQ] = ACTIONS(2261),
    [anon_sym_LT_LT_EQ] = ACTIONS(2261),
    [anon_sym_CARET_EQ] = ACTIONS(2261),
    [anon_sym_QMARK] = ACTIONS(2261),
    [anon_sym_COLON2] = ACTIONS(2263),
    [anon_sym_DOT_DOT] = ACTIONS(2263),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2261),
    [anon_sym_and] = ACTIONS(2261),
    [anon_sym_or] = ACTIONS(2261),
    [anon_sym_PIPE_PIPE] = ACTIONS(2263),
    [anon_sym_AMP_AMP] = ACTIONS(2263),
    [anon_sym_LT_LT] = ACTIONS(2263),
    [anon_sym_GT_GT] = ACTIONS(2263),
    [anon_sym_EQ_EQ] = ACTIONS(2263),
    [anon_sym_BANG_EQ] = ACTIONS(2261),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2261),
    [anon_sym_LT_EQ_GT] = ACTIONS(2261),
    [anon_sym_EQ_TILDE] = ACTIONS(2261),
    [anon_sym_BANG_TILDE] = ACTIONS(2261),
    [anon_sym_LT_EQ] = ACTIONS(2263),
    [anon_sym_GT] = ACTIONS(2263),
    [anon_sym_GT_EQ] = ACTIONS(2261),
    [anon_sym_CARET] = ACTIONS(2263),
    [anon_sym_PLUS] = ACTIONS(2263),
    [anon_sym_SLASH] = ACTIONS(2263),
    [anon_sym_PERCENT] = ACTIONS(2263),
    [sym_comment] = ACTIONS(87),
  },
  [6634] = {
    [sym__heredoc_body_start] = ACTIONS(2345),
    [sym__binary_minus] = ACTIONS(2345),
    [sym__binary_star] = ACTIONS(2345),
    [anon_sym_LBRACE] = ACTIONS(2345),
    [anon_sym_RBRACE] = ACTIONS(2345),
    [anon_sym_RPAREN] = ACTIONS(2345),
    [anon_sym_DOT] = ACTIONS(2347),
    [anon_sym_COMMA] = ACTIONS(2345),
    [anon_sym_PIPE] = ACTIONS(2347),
    [anon_sym_SEMI] = ACTIONS(2345),
    [anon_sym_STAR_STAR] = ACTIONS(2347),
    [anon_sym_AMP] = ACTIONS(2347),
    [anon_sym_EQ] = ACTIONS(2347),
    [anon_sym_LT] = ACTIONS(2347),
    [anon_sym_if] = ACTIONS(2345),
    [anon_sym_unless] = ACTIONS(2345),
    [anon_sym_while] = ACTIONS(2345),
    [anon_sym_until] = ACTIONS(2345),
    [anon_sym_rescue] = ACTIONS(2345),
    [anon_sym_in] = ACTIONS(2345),
    [anon_sym_do] = ACTIONS(2345),
    [anon_sym_LBRACK] = ACTIONS(2345),
    [anon_sym_RBRACK] = ACTIONS(2345),
    [anon_sym_COLON_COLON2] = ACTIONS(2345),
    [anon_sym_AMP_DOT] = ACTIONS(2345),
    [anon_sym_PLUS_EQ] = ACTIONS(2345),
    [anon_sym_DASH_EQ] = ACTIONS(2345),
    [anon_sym_STAR_EQ] = ACTIONS(2345),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2345),
    [anon_sym_SLASH_EQ] = ACTIONS(2345),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2345),
    [anon_sym_PIPE_EQ] = ACTIONS(2345),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2345),
    [anon_sym_AMP_EQ] = ACTIONS(2345),
    [anon_sym_PERCENT_EQ] = ACTIONS(2345),
    [anon_sym_GT_GT_EQ] = ACTIONS(2345),
    [anon_sym_LT_LT_EQ] = ACTIONS(2345),
    [anon_sym_CARET_EQ] = ACTIONS(2345),
    [anon_sym_QMARK] = ACTIONS(2345),
    [anon_sym_COLON2] = ACTIONS(2347),
    [anon_sym_DOT_DOT] = ACTIONS(2347),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2345),
    [anon_sym_and] = ACTIONS(2345),
    [anon_sym_or] = ACTIONS(2345),
    [anon_sym_PIPE_PIPE] = ACTIONS(2347),
    [anon_sym_AMP_AMP] = ACTIONS(2347),
    [anon_sym_LT_LT] = ACTIONS(2347),
    [anon_sym_GT_GT] = ACTIONS(2347),
    [anon_sym_EQ_EQ] = ACTIONS(2347),
    [anon_sym_BANG_EQ] = ACTIONS(2345),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2345),
    [anon_sym_LT_EQ_GT] = ACTIONS(2345),
    [anon_sym_EQ_TILDE] = ACTIONS(2345),
    [anon_sym_BANG_TILDE] = ACTIONS(2345),
    [anon_sym_LT_EQ] = ACTIONS(2347),
    [anon_sym_GT] = ACTIONS(2347),
    [anon_sym_GT_EQ] = ACTIONS(2345),
    [anon_sym_CARET] = ACTIONS(2347),
    [anon_sym_PLUS] = ACTIONS(2347),
    [anon_sym_SLASH] = ACTIONS(2347),
    [anon_sym_PERCENT] = ACTIONS(2347),
    [sym_comment] = ACTIONS(87),
  },
  [6635] = {
    [anon_sym_RBRACK] = ACTIONS(12535),
    [sym_comment] = ACTIONS(87),
  },
  [6636] = {
    [sym_do_block] = STATE(8866),
    [sym_block] = STATE(8866),
    [anon_sym_LBRACE] = ACTIONS(6975),
    [anon_sym_do] = ACTIONS(6977),
    [sym_comment] = ACTIONS(87),
  },
  [6637] = {
    [sym__heredoc_body_start] = ACTIONS(2485),
    [sym__binary_minus] = ACTIONS(2485),
    [sym__binary_star] = ACTIONS(2485),
    [anon_sym_LBRACE] = ACTIONS(2485),
    [anon_sym_RBRACE] = ACTIONS(2485),
    [anon_sym_RPAREN] = ACTIONS(2485),
    [anon_sym_DOT] = ACTIONS(2487),
    [anon_sym_COMMA] = ACTIONS(2485),
    [anon_sym_PIPE] = ACTIONS(2487),
    [anon_sym_SEMI] = ACTIONS(2485),
    [anon_sym_STAR_STAR] = ACTIONS(2487),
    [anon_sym_AMP] = ACTIONS(2487),
    [anon_sym_EQ] = ACTIONS(2487),
    [anon_sym_LT] = ACTIONS(2487),
    [anon_sym_if] = ACTIONS(2485),
    [anon_sym_unless] = ACTIONS(2485),
    [anon_sym_while] = ACTIONS(2485),
    [anon_sym_until] = ACTIONS(2485),
    [anon_sym_rescue] = ACTIONS(2485),
    [anon_sym_in] = ACTIONS(2485),
    [anon_sym_do] = ACTIONS(2485),
    [anon_sym_LBRACK] = ACTIONS(2485),
    [anon_sym_RBRACK] = ACTIONS(2485),
    [anon_sym_COLON_COLON2] = ACTIONS(2485),
    [anon_sym_AMP_DOT] = ACTIONS(2485),
    [anon_sym_PLUS_EQ] = ACTIONS(2485),
    [anon_sym_DASH_EQ] = ACTIONS(2485),
    [anon_sym_STAR_EQ] = ACTIONS(2485),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2485),
    [anon_sym_SLASH_EQ] = ACTIONS(2485),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2485),
    [anon_sym_PIPE_EQ] = ACTIONS(2485),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2485),
    [anon_sym_AMP_EQ] = ACTIONS(2485),
    [anon_sym_PERCENT_EQ] = ACTIONS(2485),
    [anon_sym_GT_GT_EQ] = ACTIONS(2485),
    [anon_sym_LT_LT_EQ] = ACTIONS(2485),
    [anon_sym_CARET_EQ] = ACTIONS(2485),
    [anon_sym_QMARK] = ACTIONS(2485),
    [anon_sym_COLON2] = ACTIONS(2487),
    [anon_sym_DOT_DOT] = ACTIONS(2487),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2485),
    [anon_sym_and] = ACTIONS(2485),
    [anon_sym_or] = ACTIONS(2485),
    [anon_sym_PIPE_PIPE] = ACTIONS(2487),
    [anon_sym_AMP_AMP] = ACTIONS(2487),
    [anon_sym_LT_LT] = ACTIONS(2487),
    [anon_sym_GT_GT] = ACTIONS(2487),
    [anon_sym_EQ_EQ] = ACTIONS(2487),
    [anon_sym_BANG_EQ] = ACTIONS(2485),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2485),
    [anon_sym_LT_EQ_GT] = ACTIONS(2485),
    [anon_sym_EQ_TILDE] = ACTIONS(2485),
    [anon_sym_BANG_TILDE] = ACTIONS(2485),
    [anon_sym_LT_EQ] = ACTIONS(2487),
    [anon_sym_GT] = ACTIONS(2487),
    [anon_sym_GT_EQ] = ACTIONS(2485),
    [anon_sym_CARET] = ACTIONS(2487),
    [anon_sym_PLUS] = ACTIONS(2487),
    [anon_sym_SLASH] = ACTIONS(2487),
    [anon_sym_PERCENT] = ACTIONS(2487),
    [sym_comment] = ACTIONS(87),
  },
  [6638] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(8867),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(3940),
    [sym_scope_resolution] = STATE(3938),
    [sym_call] = STATE(3938),
    [sym_method_call] = STATE(3940),
    [sym_assignment] = STATE(8867),
    [sym_operator_assignment] = STATE(8867),
    [sym_conditional] = STATE(8867),
    [sym_range] = STATE(8867),
    [sym_binary] = STATE(8867),
    [sym_unary] = STATE(8867),
    [sym_left_assignment_list] = STATE(3939),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3940),
    [sym__variable] = STATE(3938),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(3940),
    [sym_false] = STATE(3940),
    [sym_nil] = STATE(3940),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(3941),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(6469),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(6481),
    [anon_sym_yield] = ACTIONS(6483),
    [anon_sym_break] = ACTIONS(6485),
    [anon_sym_next] = ACTIONS(6487),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(6505),
    [anon_sym_defined_QMARK] = ACTIONS(6507),
    [anon_sym_not] = ACTIONS(6509),
    [anon_sym_BANG] = ACTIONS(6511),
    [anon_sym_TILDE] = ACTIONS(6511),
    [sym_constant] = ACTIONS(6513),
    [sym_identifier] = ACTIONS(6513),
    [sym_instance_variable] = ACTIONS(6515),
    [sym_class_variable] = ACTIONS(6515),
    [sym_global_variable] = ACTIONS(6515),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(6513),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6513),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [6639] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(8868),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(3940),
    [sym_scope_resolution] = STATE(3938),
    [sym_call] = STATE(3938),
    [sym_method_call] = STATE(3940),
    [sym_assignment] = STATE(8868),
    [sym_operator_assignment] = STATE(8868),
    [sym_conditional] = STATE(8868),
    [sym_range] = STATE(8868),
    [sym_binary] = STATE(8868),
    [sym_unary] = STATE(8868),
    [sym_left_assignment_list] = STATE(3939),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3940),
    [sym__variable] = STATE(3938),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(3940),
    [sym_false] = STATE(3940),
    [sym_nil] = STATE(3940),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(3941),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(6469),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(6481),
    [anon_sym_yield] = ACTIONS(6483),
    [anon_sym_break] = ACTIONS(6485),
    [anon_sym_next] = ACTIONS(6487),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(6505),
    [anon_sym_defined_QMARK] = ACTIONS(6507),
    [anon_sym_not] = ACTIONS(6509),
    [anon_sym_BANG] = ACTIONS(6511),
    [anon_sym_TILDE] = ACTIONS(6511),
    [sym_constant] = ACTIONS(6513),
    [sym_identifier] = ACTIONS(6513),
    [sym_instance_variable] = ACTIONS(6515),
    [sym_class_variable] = ACTIONS(6515),
    [sym_global_variable] = ACTIONS(6515),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(6513),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6513),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [6640] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(8869),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(3940),
    [sym_scope_resolution] = STATE(3938),
    [sym_call] = STATE(3938),
    [sym_method_call] = STATE(3940),
    [sym_assignment] = STATE(8869),
    [sym_operator_assignment] = STATE(8869),
    [sym_conditional] = STATE(8869),
    [sym_range] = STATE(8869),
    [sym_binary] = STATE(8869),
    [sym_unary] = STATE(8869),
    [sym_left_assignment_list] = STATE(3939),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3940),
    [sym__variable] = STATE(3938),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(3940),
    [sym_false] = STATE(3940),
    [sym_nil] = STATE(3940),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(3941),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(6469),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(6481),
    [anon_sym_yield] = ACTIONS(6483),
    [anon_sym_break] = ACTIONS(6485),
    [anon_sym_next] = ACTIONS(6487),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(6505),
    [anon_sym_defined_QMARK] = ACTIONS(6507),
    [anon_sym_not] = ACTIONS(6509),
    [anon_sym_BANG] = ACTIONS(6511),
    [anon_sym_TILDE] = ACTIONS(6511),
    [sym_constant] = ACTIONS(6513),
    [sym_identifier] = ACTIONS(6513),
    [sym_instance_variable] = ACTIONS(6515),
    [sym_class_variable] = ACTIONS(6515),
    [sym_global_variable] = ACTIONS(6515),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(6513),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6513),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [6641] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(8870),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(3940),
    [sym_scope_resolution] = STATE(3938),
    [sym_call] = STATE(3938),
    [sym_method_call] = STATE(3940),
    [sym_assignment] = STATE(8870),
    [sym_operator_assignment] = STATE(8870),
    [sym_conditional] = STATE(8870),
    [sym_range] = STATE(8870),
    [sym_binary] = STATE(8870),
    [sym_unary] = STATE(8870),
    [sym_left_assignment_list] = STATE(3939),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3940),
    [sym__variable] = STATE(3938),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(3940),
    [sym_false] = STATE(3940),
    [sym_nil] = STATE(3940),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(3941),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(6469),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(6481),
    [anon_sym_yield] = ACTIONS(6483),
    [anon_sym_break] = ACTIONS(6485),
    [anon_sym_next] = ACTIONS(6487),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(6505),
    [anon_sym_defined_QMARK] = ACTIONS(6507),
    [anon_sym_not] = ACTIONS(6509),
    [anon_sym_BANG] = ACTIONS(6511),
    [anon_sym_TILDE] = ACTIONS(6511),
    [sym_constant] = ACTIONS(6513),
    [sym_identifier] = ACTIONS(6513),
    [sym_instance_variable] = ACTIONS(6515),
    [sym_class_variable] = ACTIONS(6515),
    [sym_global_variable] = ACTIONS(6515),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(6513),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6513),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [6642] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(8871),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(3940),
    [sym_scope_resolution] = STATE(3938),
    [sym_call] = STATE(3938),
    [sym_method_call] = STATE(3940),
    [sym_assignment] = STATE(8871),
    [sym_operator_assignment] = STATE(8871),
    [sym_conditional] = STATE(8871),
    [sym_range] = STATE(8871),
    [sym_binary] = STATE(8871),
    [sym_unary] = STATE(8871),
    [sym_left_assignment_list] = STATE(3939),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3940),
    [sym__variable] = STATE(3938),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(3940),
    [sym_false] = STATE(3940),
    [sym_nil] = STATE(3940),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(3941),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(6469),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(6481),
    [anon_sym_yield] = ACTIONS(6483),
    [anon_sym_break] = ACTIONS(6485),
    [anon_sym_next] = ACTIONS(6487),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(6505),
    [anon_sym_defined_QMARK] = ACTIONS(6507),
    [anon_sym_not] = ACTIONS(6509),
    [anon_sym_BANG] = ACTIONS(6511),
    [anon_sym_TILDE] = ACTIONS(6511),
    [sym_constant] = ACTIONS(6513),
    [sym_identifier] = ACTIONS(6513),
    [sym_instance_variable] = ACTIONS(6515),
    [sym_class_variable] = ACTIONS(6515),
    [sym_global_variable] = ACTIONS(6515),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(6513),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6513),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [6643] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(8872),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(8872),
    [sym_operator_assignment] = STATE(8872),
    [sym_conditional] = STATE(8872),
    [sym_range] = STATE(8872),
    [sym_binary] = STATE(8872),
    [sym_unary] = STATE(8872),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6644] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(8873),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(3940),
    [sym_scope_resolution] = STATE(3938),
    [sym_call] = STATE(3938),
    [sym_method_call] = STATE(3940),
    [sym_assignment] = STATE(8873),
    [sym_operator_assignment] = STATE(8873),
    [sym_conditional] = STATE(8873),
    [sym_range] = STATE(8873),
    [sym_binary] = STATE(8873),
    [sym_unary] = STATE(8873),
    [sym_left_assignment_list] = STATE(3939),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3940),
    [sym__variable] = STATE(3938),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(3940),
    [sym_false] = STATE(3940),
    [sym_nil] = STATE(3940),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(3941),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(6469),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(6481),
    [anon_sym_yield] = ACTIONS(6483),
    [anon_sym_break] = ACTIONS(6485),
    [anon_sym_next] = ACTIONS(6487),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(6505),
    [anon_sym_defined_QMARK] = ACTIONS(6507),
    [anon_sym_not] = ACTIONS(6509),
    [anon_sym_BANG] = ACTIONS(6511),
    [anon_sym_TILDE] = ACTIONS(6511),
    [sym_constant] = ACTIONS(6513),
    [sym_identifier] = ACTIONS(6513),
    [sym_instance_variable] = ACTIONS(6515),
    [sym_class_variable] = ACTIONS(6515),
    [sym_global_variable] = ACTIONS(6515),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(6513),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6513),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [6645] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(8874),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(3940),
    [sym_scope_resolution] = STATE(3938),
    [sym_call] = STATE(3938),
    [sym_method_call] = STATE(3940),
    [sym_assignment] = STATE(8874),
    [sym_operator_assignment] = STATE(8874),
    [sym_conditional] = STATE(8874),
    [sym_range] = STATE(8874),
    [sym_binary] = STATE(8874),
    [sym_unary] = STATE(8874),
    [sym_left_assignment_list] = STATE(3939),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3940),
    [sym__variable] = STATE(3938),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(3940),
    [sym_false] = STATE(3940),
    [sym_nil] = STATE(3940),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(3941),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(6469),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(6481),
    [anon_sym_yield] = ACTIONS(6483),
    [anon_sym_break] = ACTIONS(6485),
    [anon_sym_next] = ACTIONS(6487),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(6505),
    [anon_sym_defined_QMARK] = ACTIONS(6507),
    [anon_sym_not] = ACTIONS(6509),
    [anon_sym_BANG] = ACTIONS(6511),
    [anon_sym_TILDE] = ACTIONS(6511),
    [sym_constant] = ACTIONS(6513),
    [sym_identifier] = ACTIONS(6513),
    [sym_instance_variable] = ACTIONS(6515),
    [sym_class_variable] = ACTIONS(6515),
    [sym_global_variable] = ACTIONS(6515),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(6513),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6513),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [6646] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(8875),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(3940),
    [sym_scope_resolution] = STATE(3938),
    [sym_call] = STATE(3938),
    [sym_method_call] = STATE(3940),
    [sym_assignment] = STATE(8875),
    [sym_operator_assignment] = STATE(8875),
    [sym_conditional] = STATE(8875),
    [sym_range] = STATE(8875),
    [sym_binary] = STATE(8875),
    [sym_unary] = STATE(8875),
    [sym_left_assignment_list] = STATE(3939),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3940),
    [sym__variable] = STATE(3938),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(3940),
    [sym_false] = STATE(3940),
    [sym_nil] = STATE(3940),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(3941),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(6469),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(6481),
    [anon_sym_yield] = ACTIONS(6483),
    [anon_sym_break] = ACTIONS(6485),
    [anon_sym_next] = ACTIONS(6487),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(6505),
    [anon_sym_defined_QMARK] = ACTIONS(6507),
    [anon_sym_not] = ACTIONS(6509),
    [anon_sym_BANG] = ACTIONS(6511),
    [anon_sym_TILDE] = ACTIONS(6511),
    [sym_constant] = ACTIONS(6513),
    [sym_identifier] = ACTIONS(6513),
    [sym_instance_variable] = ACTIONS(6515),
    [sym_class_variable] = ACTIONS(6515),
    [sym_global_variable] = ACTIONS(6515),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(6513),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6513),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [6647] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(8876),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(3940),
    [sym_scope_resolution] = STATE(3938),
    [sym_call] = STATE(3938),
    [sym_method_call] = STATE(3940),
    [sym_assignment] = STATE(8876),
    [sym_operator_assignment] = STATE(8876),
    [sym_conditional] = STATE(8876),
    [sym_range] = STATE(8876),
    [sym_binary] = STATE(8876),
    [sym_unary] = STATE(8876),
    [sym_left_assignment_list] = STATE(3939),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3940),
    [sym__variable] = STATE(3938),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(3940),
    [sym_false] = STATE(3940),
    [sym_nil] = STATE(3940),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(3941),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(6469),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(6481),
    [anon_sym_yield] = ACTIONS(6483),
    [anon_sym_break] = ACTIONS(6485),
    [anon_sym_next] = ACTIONS(6487),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(6505),
    [anon_sym_defined_QMARK] = ACTIONS(6507),
    [anon_sym_not] = ACTIONS(6509),
    [anon_sym_BANG] = ACTIONS(6511),
    [anon_sym_TILDE] = ACTIONS(6511),
    [sym_constant] = ACTIONS(6513),
    [sym_identifier] = ACTIONS(6513),
    [sym_instance_variable] = ACTIONS(6515),
    [sym_class_variable] = ACTIONS(6515),
    [sym_global_variable] = ACTIONS(6515),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(6513),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6513),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [6648] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(8877),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(3940),
    [sym_scope_resolution] = STATE(3938),
    [sym_call] = STATE(3938),
    [sym_method_call] = STATE(3940),
    [sym_splat_argument] = STATE(8879),
    [sym_assignment] = STATE(8877),
    [sym_operator_assignment] = STATE(8877),
    [sym_conditional] = STATE(8877),
    [sym_range] = STATE(8877),
    [sym_binary] = STATE(8877),
    [sym_unary] = STATE(8877),
    [sym_right_assignment_list] = STATE(8878),
    [sym__arg_or_splat_arg] = STATE(8879),
    [sym_left_assignment_list] = STATE(3939),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3940),
    [sym__variable] = STATE(3938),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(3940),
    [sym_false] = STATE(3940),
    [sym_nil] = STATE(3940),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(3941),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__splat_star] = ACTIONS(2990),
    [sym__unary_minus] = ACTIONS(6469),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(6481),
    [anon_sym_yield] = ACTIONS(6483),
    [anon_sym_break] = ACTIONS(6485),
    [anon_sym_next] = ACTIONS(6487),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(6505),
    [anon_sym_defined_QMARK] = ACTIONS(6507),
    [anon_sym_not] = ACTIONS(6509),
    [anon_sym_BANG] = ACTIONS(6511),
    [anon_sym_TILDE] = ACTIONS(6511),
    [sym_constant] = ACTIONS(6513),
    [sym_identifier] = ACTIONS(6513),
    [sym_instance_variable] = ACTIONS(6515),
    [sym_class_variable] = ACTIONS(6515),
    [sym_global_variable] = ACTIONS(6515),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(6513),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6513),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [6649] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(8880),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(3940),
    [sym_scope_resolution] = STATE(3938),
    [sym_call] = STATE(3938),
    [sym_method_call] = STATE(3940),
    [sym_assignment] = STATE(8880),
    [sym_operator_assignment] = STATE(8880),
    [sym_conditional] = STATE(8880),
    [sym_range] = STATE(8880),
    [sym_binary] = STATE(8880),
    [sym_unary] = STATE(8880),
    [sym_left_assignment_list] = STATE(3939),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3940),
    [sym__variable] = STATE(3938),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(3940),
    [sym_false] = STATE(3940),
    [sym_nil] = STATE(3940),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(3941),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(6469),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(6481),
    [anon_sym_yield] = ACTIONS(6483),
    [anon_sym_break] = ACTIONS(6485),
    [anon_sym_next] = ACTIONS(6487),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(6505),
    [anon_sym_defined_QMARK] = ACTIONS(6507),
    [anon_sym_not] = ACTIONS(6509),
    [anon_sym_BANG] = ACTIONS(6511),
    [anon_sym_TILDE] = ACTIONS(6511),
    [sym_constant] = ACTIONS(6513),
    [sym_identifier] = ACTIONS(6513),
    [sym_instance_variable] = ACTIONS(6515),
    [sym_class_variable] = ACTIONS(6515),
    [sym_global_variable] = ACTIONS(6515),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(6513),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6513),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [6650] = {
    [sym_string] = STATE(8881),
    [aux_sym_chained_string_repeat1] = STATE(8881),
    [sym__string_start] = ACTIONS(6455),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_RBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_STAR_STAR] = ACTIONS(2755),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_EQ] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_PLUS_EQ] = ACTIONS(2753),
    [anon_sym_DASH_EQ] = ACTIONS(2753),
    [anon_sym_STAR_EQ] = ACTIONS(2753),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2753),
    [anon_sym_SLASH_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2753),
    [anon_sym_AMP_EQ] = ACTIONS(2753),
    [anon_sym_PERCENT_EQ] = ACTIONS(2753),
    [anon_sym_GT_GT_EQ] = ACTIONS(2753),
    [anon_sym_LT_LT_EQ] = ACTIONS(2753),
    [anon_sym_CARET_EQ] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2755),
    [anon_sym_AMP_AMP] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2755),
    [anon_sym_GT_GT] = ACTIONS(2755),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_SLASH] = ACTIONS(2755),
    [anon_sym_PERCENT] = ACTIONS(2755),
    [sym_comment] = ACTIONS(87),
  },
  [6651] = {
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(10117),
    [sym__binary_star] = ACTIONS(10119),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_RBRACE] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(10121),
    [anon_sym_STAR_STAR] = ACTIONS(10123),
    [anon_sym_AMP] = ACTIONS(10125),
    [anon_sym_EQ] = ACTIONS(7822),
    [anon_sym_LT] = ACTIONS(10127),
    [anon_sym_if] = ACTIONS(6823),
    [anon_sym_unless] = ACTIONS(6823),
    [anon_sym_while] = ACTIONS(6823),
    [anon_sym_until] = ACTIONS(6823),
    [anon_sym_rescue] = ACTIONS(6823),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_PLUS_EQ] = ACTIONS(6823),
    [anon_sym_DASH_EQ] = ACTIONS(6823),
    [anon_sym_STAR_EQ] = ACTIONS(6823),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6823),
    [anon_sym_SLASH_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6823),
    [anon_sym_AMP_EQ] = ACTIONS(6823),
    [anon_sym_PERCENT_EQ] = ACTIONS(6823),
    [anon_sym_GT_GT_EQ] = ACTIONS(6823),
    [anon_sym_LT_LT_EQ] = ACTIONS(6823),
    [anon_sym_CARET_EQ] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(10129),
    [anon_sym_DOT_DOT] = ACTIONS(10131),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10133),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(10135),
    [anon_sym_AMP_AMP] = ACTIONS(10135),
    [anon_sym_LT_LT] = ACTIONS(10137),
    [anon_sym_GT_GT] = ACTIONS(10137),
    [anon_sym_EQ_EQ] = ACTIONS(10135),
    [anon_sym_BANG_EQ] = ACTIONS(10139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10139),
    [anon_sym_LT_EQ_GT] = ACTIONS(10139),
    [anon_sym_EQ_TILDE] = ACTIONS(10139),
    [anon_sym_BANG_TILDE] = ACTIONS(10139),
    [anon_sym_LT_EQ] = ACTIONS(10127),
    [anon_sym_GT] = ACTIONS(10127),
    [anon_sym_GT_EQ] = ACTIONS(10141),
    [anon_sym_CARET] = ACTIONS(10121),
    [anon_sym_PLUS] = ACTIONS(10143),
    [anon_sym_SLASH] = ACTIONS(10123),
    [anon_sym_PERCENT] = ACTIONS(10123),
    [sym_comment] = ACTIONS(87),
  },
  [6652] = {
    [sym__binary_minus] = ACTIONS(9426),
    [sym__binary_star] = ACTIONS(9426),
    [anon_sym_LBRACE] = ACTIONS(9426),
    [anon_sym_RBRACE] = ACTIONS(9426),
    [anon_sym_RPAREN] = ACTIONS(9426),
    [anon_sym_DOT] = ACTIONS(9428),
    [anon_sym_COMMA] = ACTIONS(9426),
    [anon_sym_PIPE] = ACTIONS(9428),
    [anon_sym_SEMI] = ACTIONS(9426),
    [anon_sym_STAR_STAR] = ACTIONS(9428),
    [anon_sym_AMP] = ACTIONS(9428),
    [anon_sym_EQ] = ACTIONS(9428),
    [anon_sym_LT] = ACTIONS(9428),
    [anon_sym_if] = ACTIONS(9426),
    [anon_sym_unless] = ACTIONS(9426),
    [anon_sym_while] = ACTIONS(9426),
    [anon_sym_until] = ACTIONS(9426),
    [anon_sym_rescue] = ACTIONS(9426),
    [anon_sym_do] = ACTIONS(9426),
    [anon_sym_LBRACK] = ACTIONS(9426),
    [anon_sym_COLON_COLON2] = ACTIONS(9426),
    [anon_sym_AMP_DOT] = ACTIONS(9426),
    [anon_sym_PLUS_EQ] = ACTIONS(9426),
    [anon_sym_DASH_EQ] = ACTIONS(9426),
    [anon_sym_STAR_EQ] = ACTIONS(9426),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9426),
    [anon_sym_SLASH_EQ] = ACTIONS(9426),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9426),
    [anon_sym_PIPE_EQ] = ACTIONS(9426),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9426),
    [anon_sym_AMP_EQ] = ACTIONS(9426),
    [anon_sym_PERCENT_EQ] = ACTIONS(9426),
    [anon_sym_GT_GT_EQ] = ACTIONS(9426),
    [anon_sym_LT_LT_EQ] = ACTIONS(9426),
    [anon_sym_CARET_EQ] = ACTIONS(9426),
    [anon_sym_QMARK] = ACTIONS(9426),
    [anon_sym_COLON2] = ACTIONS(9428),
    [anon_sym_DOT_DOT] = ACTIONS(9428),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9426),
    [anon_sym_and] = ACTIONS(9426),
    [anon_sym_or] = ACTIONS(9426),
    [anon_sym_PIPE_PIPE] = ACTIONS(9428),
    [anon_sym_AMP_AMP] = ACTIONS(9428),
    [anon_sym_LT_LT] = ACTIONS(9428),
    [anon_sym_GT_GT] = ACTIONS(9428),
    [anon_sym_EQ_EQ] = ACTIONS(9428),
    [anon_sym_BANG_EQ] = ACTIONS(9426),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9426),
    [anon_sym_LT_EQ_GT] = ACTIONS(9426),
    [anon_sym_EQ_TILDE] = ACTIONS(9426),
    [anon_sym_BANG_TILDE] = ACTIONS(9426),
    [anon_sym_LT_EQ] = ACTIONS(9428),
    [anon_sym_GT] = ACTIONS(9428),
    [anon_sym_GT_EQ] = ACTIONS(9426),
    [anon_sym_CARET] = ACTIONS(9428),
    [anon_sym_PLUS] = ACTIONS(9428),
    [anon_sym_SLASH] = ACTIONS(9428),
    [anon_sym_PERCENT] = ACTIONS(9428),
    [sym_comment] = ACTIONS(87),
  },
  [6653] = {
    [anon_sym_RBRACE] = ACTIONS(12537),
    [sym_comment] = ACTIONS(87),
  },
  [6654] = {
    [sym__binary_minus] = ACTIONS(9446),
    [sym__binary_star] = ACTIONS(9446),
    [anon_sym_LBRACE] = ACTIONS(9446),
    [anon_sym_RBRACE] = ACTIONS(9446),
    [anon_sym_RPAREN] = ACTIONS(9446),
    [anon_sym_DOT] = ACTIONS(9448),
    [anon_sym_COMMA] = ACTIONS(9446),
    [anon_sym_PIPE] = ACTIONS(9448),
    [anon_sym_SEMI] = ACTIONS(9446),
    [anon_sym_STAR_STAR] = ACTIONS(9448),
    [anon_sym_AMP] = ACTIONS(9448),
    [anon_sym_EQ] = ACTIONS(9448),
    [anon_sym_LT] = ACTIONS(9448),
    [anon_sym_if] = ACTIONS(9446),
    [anon_sym_unless] = ACTIONS(9446),
    [anon_sym_while] = ACTIONS(9446),
    [anon_sym_until] = ACTIONS(9446),
    [anon_sym_rescue] = ACTIONS(9446),
    [anon_sym_do] = ACTIONS(9446),
    [anon_sym_LBRACK] = ACTIONS(9446),
    [anon_sym_COLON_COLON2] = ACTIONS(9446),
    [anon_sym_AMP_DOT] = ACTIONS(9446),
    [anon_sym_PLUS_EQ] = ACTIONS(9446),
    [anon_sym_DASH_EQ] = ACTIONS(9446),
    [anon_sym_STAR_EQ] = ACTIONS(9446),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9446),
    [anon_sym_SLASH_EQ] = ACTIONS(9446),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9446),
    [anon_sym_PIPE_EQ] = ACTIONS(9446),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9446),
    [anon_sym_AMP_EQ] = ACTIONS(9446),
    [anon_sym_PERCENT_EQ] = ACTIONS(9446),
    [anon_sym_GT_GT_EQ] = ACTIONS(9446),
    [anon_sym_LT_LT_EQ] = ACTIONS(9446),
    [anon_sym_CARET_EQ] = ACTIONS(9446),
    [anon_sym_QMARK] = ACTIONS(9446),
    [anon_sym_COLON2] = ACTIONS(9448),
    [anon_sym_DOT_DOT] = ACTIONS(9448),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9446),
    [anon_sym_and] = ACTIONS(9446),
    [anon_sym_or] = ACTIONS(9446),
    [anon_sym_PIPE_PIPE] = ACTIONS(9448),
    [anon_sym_AMP_AMP] = ACTIONS(9448),
    [anon_sym_LT_LT] = ACTIONS(9448),
    [anon_sym_GT_GT] = ACTIONS(9448),
    [anon_sym_EQ_EQ] = ACTIONS(9448),
    [anon_sym_BANG_EQ] = ACTIONS(9446),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9446),
    [anon_sym_LT_EQ_GT] = ACTIONS(9446),
    [anon_sym_EQ_TILDE] = ACTIONS(9446),
    [anon_sym_BANG_TILDE] = ACTIONS(9446),
    [anon_sym_LT_EQ] = ACTIONS(9448),
    [anon_sym_GT] = ACTIONS(9448),
    [anon_sym_GT_EQ] = ACTIONS(9446),
    [anon_sym_CARET] = ACTIONS(9448),
    [anon_sym_PLUS] = ACTIONS(9448),
    [anon_sym_SLASH] = ACTIONS(9448),
    [anon_sym_PERCENT] = ACTIONS(9448),
    [sym_comment] = ACTIONS(87),
  },
  [6655] = {
    [anon_sym_end] = ACTIONS(12539),
    [sym_comment] = ACTIONS(87),
  },
  [6656] = {
    [sym__statements] = STATE(8884),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12541),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6657] = {
    [sym__statements] = STATE(8884),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_heredoc_body] = STATE(8885),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [sym__terminator] = STATE(8885),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__line_break] = ACTIONS(12543),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(12543),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12541),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6658] = {
    [sym__heredoc_body_start] = ACTIONS(7876),
    [sym__binary_minus] = ACTIONS(7876),
    [sym__binary_star] = ACTIONS(7876),
    [anon_sym_LBRACE] = ACTIONS(7876),
    [anon_sym_RBRACE] = ACTIONS(7876),
    [anon_sym_RPAREN] = ACTIONS(7876),
    [anon_sym_DOT] = ACTIONS(7878),
    [anon_sym_COMMA] = ACTIONS(7876),
    [anon_sym_PIPE] = ACTIONS(7878),
    [anon_sym_SEMI] = ACTIONS(7876),
    [anon_sym_STAR_STAR] = ACTIONS(7878),
    [anon_sym_AMP] = ACTIONS(7878),
    [anon_sym_EQ] = ACTIONS(7878),
    [anon_sym_LT] = ACTIONS(7878),
    [anon_sym_if] = ACTIONS(7876),
    [anon_sym_unless] = ACTIONS(7876),
    [anon_sym_while] = ACTIONS(7876),
    [anon_sym_until] = ACTIONS(7876),
    [anon_sym_rescue] = ACTIONS(7876),
    [anon_sym_in] = ACTIONS(7876),
    [anon_sym_do] = ACTIONS(7876),
    [anon_sym_LBRACK] = ACTIONS(7876),
    [anon_sym_RBRACK] = ACTIONS(7876),
    [anon_sym_COLON_COLON2] = ACTIONS(7876),
    [anon_sym_AMP_DOT] = ACTIONS(7876),
    [anon_sym_PLUS_EQ] = ACTIONS(7876),
    [anon_sym_DASH_EQ] = ACTIONS(7876),
    [anon_sym_STAR_EQ] = ACTIONS(7876),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7876),
    [anon_sym_SLASH_EQ] = ACTIONS(7876),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7876),
    [anon_sym_PIPE_EQ] = ACTIONS(7876),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7876),
    [anon_sym_AMP_EQ] = ACTIONS(7876),
    [anon_sym_PERCENT_EQ] = ACTIONS(7876),
    [anon_sym_GT_GT_EQ] = ACTIONS(7876),
    [anon_sym_LT_LT_EQ] = ACTIONS(7876),
    [anon_sym_CARET_EQ] = ACTIONS(7876),
    [anon_sym_QMARK] = ACTIONS(7876),
    [anon_sym_COLON2] = ACTIONS(7878),
    [anon_sym_DOT_DOT] = ACTIONS(7878),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7876),
    [anon_sym_and] = ACTIONS(7876),
    [anon_sym_or] = ACTIONS(7876),
    [anon_sym_PIPE_PIPE] = ACTIONS(7878),
    [anon_sym_AMP_AMP] = ACTIONS(7878),
    [anon_sym_LT_LT] = ACTIONS(7878),
    [anon_sym_GT_GT] = ACTIONS(7878),
    [anon_sym_EQ_EQ] = ACTIONS(7878),
    [anon_sym_BANG_EQ] = ACTIONS(7876),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7876),
    [anon_sym_LT_EQ_GT] = ACTIONS(7876),
    [anon_sym_EQ_TILDE] = ACTIONS(7876),
    [anon_sym_BANG_TILDE] = ACTIONS(7876),
    [anon_sym_LT_EQ] = ACTIONS(7878),
    [anon_sym_GT] = ACTIONS(7878),
    [anon_sym_GT_EQ] = ACTIONS(7876),
    [anon_sym_CARET] = ACTIONS(7878),
    [anon_sym_PLUS] = ACTIONS(7878),
    [anon_sym_SLASH] = ACTIONS(7878),
    [anon_sym_PERCENT] = ACTIONS(7878),
    [sym_comment] = ACTIONS(87),
  },
  [6659] = {
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(10117),
    [sym__binary_star] = ACTIONS(10119),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_RBRACE] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(10121),
    [anon_sym_STAR_STAR] = ACTIONS(10123),
    [anon_sym_AMP] = ACTIONS(10125),
    [anon_sym_EQ] = ACTIONS(7884),
    [anon_sym_LT] = ACTIONS(10127),
    [anon_sym_if] = ACTIONS(7027),
    [anon_sym_unless] = ACTIONS(7027),
    [anon_sym_while] = ACTIONS(7027),
    [anon_sym_until] = ACTIONS(7027),
    [anon_sym_rescue] = ACTIONS(7027),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_PLUS_EQ] = ACTIONS(7027),
    [anon_sym_DASH_EQ] = ACTIONS(7027),
    [anon_sym_STAR_EQ] = ACTIONS(7027),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7027),
    [anon_sym_SLASH_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7027),
    [anon_sym_AMP_EQ] = ACTIONS(7027),
    [anon_sym_PERCENT_EQ] = ACTIONS(7027),
    [anon_sym_GT_GT_EQ] = ACTIONS(7027),
    [anon_sym_LT_LT_EQ] = ACTIONS(7027),
    [anon_sym_CARET_EQ] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(10129),
    [anon_sym_DOT_DOT] = ACTIONS(10131),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10133),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(10135),
    [anon_sym_AMP_AMP] = ACTIONS(10135),
    [anon_sym_LT_LT] = ACTIONS(10137),
    [anon_sym_GT_GT] = ACTIONS(10137),
    [anon_sym_EQ_EQ] = ACTIONS(10135),
    [anon_sym_BANG_EQ] = ACTIONS(10139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10139),
    [anon_sym_LT_EQ_GT] = ACTIONS(10139),
    [anon_sym_EQ_TILDE] = ACTIONS(10139),
    [anon_sym_BANG_TILDE] = ACTIONS(10139),
    [anon_sym_LT_EQ] = ACTIONS(10127),
    [anon_sym_GT] = ACTIONS(10127),
    [anon_sym_GT_EQ] = ACTIONS(10141),
    [anon_sym_CARET] = ACTIONS(10121),
    [anon_sym_PLUS] = ACTIONS(10143),
    [anon_sym_SLASH] = ACTIONS(10123),
    [anon_sym_PERCENT] = ACTIONS(10123),
    [sym_comment] = ACTIONS(87),
  },
  [6660] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(6539),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(6543),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(6543),
    [anon_sym_PERCENT] = ACTIONS(6543),
    [sym_comment] = ACTIONS(87),
  },
  [6661] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(6543),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(5827),
    [anon_sym_PERCENT] = ACTIONS(5827),
    [sym_comment] = ACTIONS(87),
  },
  [6662] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6537),
    [sym__binary_star] = ACTIONS(6539),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(6543),
    [anon_sym_AMP] = ACTIONS(6545),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(6557),
    [anon_sym_GT_GT] = ACTIONS(6557),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(6563),
    [anon_sym_SLASH] = ACTIONS(6543),
    [anon_sym_PERCENT] = ACTIONS(6543),
    [sym_comment] = ACTIONS(87),
  },
  [6663] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6537),
    [sym__binary_star] = ACTIONS(6539),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(6543),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(6557),
    [anon_sym_GT_GT] = ACTIONS(6557),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(6563),
    [anon_sym_SLASH] = ACTIONS(6543),
    [anon_sym_PERCENT] = ACTIONS(6543),
    [sym_comment] = ACTIONS(87),
  },
  [6664] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6537),
    [sym__binary_star] = ACTIONS(6539),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(6541),
    [anon_sym_STAR_STAR] = ACTIONS(6543),
    [anon_sym_AMP] = ACTIONS(6545),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(6557),
    [anon_sym_GT_GT] = ACTIONS(6557),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(6541),
    [anon_sym_PLUS] = ACTIONS(6563),
    [anon_sym_SLASH] = ACTIONS(6543),
    [anon_sym_PERCENT] = ACTIONS(6543),
    [sym_comment] = ACTIONS(87),
  },
  [6665] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(12545),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [6666] = {
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(6537),
    [sym__binary_star] = ACTIONS(6539),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_RBRACE] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(6541),
    [anon_sym_STAR_STAR] = ACTIONS(6543),
    [anon_sym_AMP] = ACTIONS(6545),
    [anon_sym_EQ] = ACTIONS(7888),
    [anon_sym_LT] = ACTIONS(6547),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_EQ_GT] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_PLUS_EQ] = ACTIONS(5927),
    [anon_sym_DASH_EQ] = ACTIONS(5927),
    [anon_sym_STAR_EQ] = ACTIONS(5927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5927),
    [anon_sym_SLASH_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5927),
    [anon_sym_AMP_EQ] = ACTIONS(5927),
    [anon_sym_PERCENT_EQ] = ACTIONS(5927),
    [anon_sym_GT_GT_EQ] = ACTIONS(5927),
    [anon_sym_LT_LT_EQ] = ACTIONS(5927),
    [anon_sym_CARET_EQ] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(6551),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6553),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(6555),
    [anon_sym_AMP_AMP] = ACTIONS(6555),
    [anon_sym_LT_LT] = ACTIONS(6557),
    [anon_sym_GT_GT] = ACTIONS(6557),
    [anon_sym_EQ_EQ] = ACTIONS(6555),
    [anon_sym_BANG_EQ] = ACTIONS(6559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6559),
    [anon_sym_LT_EQ_GT] = ACTIONS(6559),
    [anon_sym_EQ_TILDE] = ACTIONS(6559),
    [anon_sym_BANG_TILDE] = ACTIONS(6559),
    [anon_sym_LT_EQ] = ACTIONS(6547),
    [anon_sym_GT] = ACTIONS(6547),
    [anon_sym_GT_EQ] = ACTIONS(6561),
    [anon_sym_CARET] = ACTIONS(6541),
    [anon_sym_PLUS] = ACTIONS(6563),
    [anon_sym_SLASH] = ACTIONS(6543),
    [anon_sym_PERCENT] = ACTIONS(6543),
    [sym_comment] = ACTIONS(87),
  },
  [6667] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6537),
    [sym__binary_star] = ACTIONS(6539),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(6541),
    [anon_sym_STAR_STAR] = ACTIONS(6543),
    [anon_sym_AMP] = ACTIONS(6545),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(6547),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(6549),
    [anon_sym_DOT_DOT] = ACTIONS(6551),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6553),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(6555),
    [anon_sym_AMP_AMP] = ACTIONS(6555),
    [anon_sym_LT_LT] = ACTIONS(6557),
    [anon_sym_GT_GT] = ACTIONS(6557),
    [anon_sym_EQ_EQ] = ACTIONS(6555),
    [anon_sym_BANG_EQ] = ACTIONS(6559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6559),
    [anon_sym_LT_EQ_GT] = ACTIONS(6559),
    [anon_sym_EQ_TILDE] = ACTIONS(6559),
    [anon_sym_BANG_TILDE] = ACTIONS(6559),
    [anon_sym_LT_EQ] = ACTIONS(6547),
    [anon_sym_GT] = ACTIONS(6547),
    [anon_sym_GT_EQ] = ACTIONS(6561),
    [anon_sym_CARET] = ACTIONS(6541),
    [anon_sym_PLUS] = ACTIONS(6563),
    [anon_sym_SLASH] = ACTIONS(6543),
    [anon_sym_PERCENT] = ACTIONS(6543),
    [sym_comment] = ACTIONS(87),
  },
  [6668] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6537),
    [sym__binary_star] = ACTIONS(6539),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(6541),
    [anon_sym_STAR_STAR] = ACTIONS(6543),
    [anon_sym_AMP] = ACTIONS(6545),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(6547),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(6557),
    [anon_sym_GT_GT] = ACTIONS(6557),
    [anon_sym_EQ_EQ] = ACTIONS(6555),
    [anon_sym_BANG_EQ] = ACTIONS(6559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6559),
    [anon_sym_LT_EQ_GT] = ACTIONS(6559),
    [anon_sym_EQ_TILDE] = ACTIONS(6559),
    [anon_sym_BANG_TILDE] = ACTIONS(6559),
    [anon_sym_LT_EQ] = ACTIONS(6547),
    [anon_sym_GT] = ACTIONS(6547),
    [anon_sym_GT_EQ] = ACTIONS(6561),
    [anon_sym_CARET] = ACTIONS(6541),
    [anon_sym_PLUS] = ACTIONS(6563),
    [anon_sym_SLASH] = ACTIONS(6543),
    [anon_sym_PERCENT] = ACTIONS(6543),
    [sym_comment] = ACTIONS(87),
  },
  [6669] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6537),
    [sym__binary_star] = ACTIONS(6539),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(6543),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(6563),
    [anon_sym_SLASH] = ACTIONS(6543),
    [anon_sym_PERCENT] = ACTIONS(6543),
    [sym_comment] = ACTIONS(87),
  },
  [6670] = {
    [sym__binary_minus] = ACTIONS(5735),
    [sym__binary_star] = ACTIONS(5735),
    [anon_sym_LBRACE] = ACTIONS(5735),
    [anon_sym_RBRACE] = ACTIONS(5735),
    [anon_sym_RPAREN] = ACTIONS(5735),
    [anon_sym_DOT] = ACTIONS(5737),
    [anon_sym_COMMA] = ACTIONS(5735),
    [anon_sym_PIPE] = ACTIONS(5737),
    [anon_sym_SEMI] = ACTIONS(5735),
    [anon_sym_STAR_STAR] = ACTIONS(5737),
    [anon_sym_AMP] = ACTIONS(5737),
    [anon_sym_EQ] = ACTIONS(5737),
    [anon_sym_LT] = ACTIONS(5737),
    [anon_sym_if] = ACTIONS(5735),
    [anon_sym_unless] = ACTIONS(5735),
    [anon_sym_while] = ACTIONS(5735),
    [anon_sym_until] = ACTIONS(5735),
    [anon_sym_rescue] = ACTIONS(5735),
    [anon_sym_do] = ACTIONS(5735),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_COLON_COLON2] = ACTIONS(5735),
    [anon_sym_AMP_DOT] = ACTIONS(5735),
    [anon_sym_PLUS_EQ] = ACTIONS(5735),
    [anon_sym_DASH_EQ] = ACTIONS(5735),
    [anon_sym_STAR_EQ] = ACTIONS(5735),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5735),
    [anon_sym_SLASH_EQ] = ACTIONS(5735),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5735),
    [anon_sym_PIPE_EQ] = ACTIONS(5735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5735),
    [anon_sym_AMP_EQ] = ACTIONS(5735),
    [anon_sym_PERCENT_EQ] = ACTIONS(5735),
    [anon_sym_GT_GT_EQ] = ACTIONS(5735),
    [anon_sym_LT_LT_EQ] = ACTIONS(5735),
    [anon_sym_CARET_EQ] = ACTIONS(5735),
    [anon_sym_QMARK] = ACTIONS(5735),
    [anon_sym_COLON2] = ACTIONS(5737),
    [anon_sym_DOT_DOT] = ACTIONS(5737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5735),
    [anon_sym_and] = ACTIONS(5735),
    [anon_sym_or] = ACTIONS(5735),
    [anon_sym_PIPE_PIPE] = ACTIONS(5737),
    [anon_sym_AMP_AMP] = ACTIONS(5737),
    [anon_sym_LT_LT] = ACTIONS(5737),
    [anon_sym_GT_GT] = ACTIONS(5737),
    [anon_sym_EQ_EQ] = ACTIONS(5737),
    [anon_sym_BANG_EQ] = ACTIONS(5735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5735),
    [anon_sym_LT_EQ_GT] = ACTIONS(5735),
    [anon_sym_EQ_TILDE] = ACTIONS(5735),
    [anon_sym_BANG_TILDE] = ACTIONS(5735),
    [anon_sym_LT_EQ] = ACTIONS(5737),
    [anon_sym_GT] = ACTIONS(5737),
    [anon_sym_GT_EQ] = ACTIONS(5735),
    [anon_sym_CARET] = ACTIONS(5737),
    [anon_sym_PLUS] = ACTIONS(5737),
    [anon_sym_SLASH] = ACTIONS(5737),
    [anon_sym_PERCENT] = ACTIONS(5737),
    [sym_comment] = ACTIONS(87),
  },
  [6671] = {
    [sym__heredoc_body_start] = ACTIONS(3235),
    [sym__binary_minus] = ACTIONS(3235),
    [sym__binary_star] = ACTIONS(3235),
    [anon_sym_LBRACE] = ACTIONS(3235),
    [anon_sym_RBRACE] = ACTIONS(3235),
    [anon_sym_RPAREN] = ACTIONS(3235),
    [anon_sym_DOT] = ACTIONS(4997),
    [anon_sym_COMMA] = ACTIONS(3235),
    [anon_sym_PIPE] = ACTIONS(4997),
    [anon_sym_SEMI] = ACTIONS(3235),
    [anon_sym_STAR_STAR] = ACTIONS(4997),
    [anon_sym_AMP] = ACTIONS(4997),
    [anon_sym_EQ] = ACTIONS(4997),
    [anon_sym_LT] = ACTIONS(4997),
    [anon_sym_if] = ACTIONS(3235),
    [anon_sym_unless] = ACTIONS(3235),
    [anon_sym_while] = ACTIONS(3235),
    [anon_sym_until] = ACTIONS(3235),
    [anon_sym_rescue] = ACTIONS(3235),
    [anon_sym_in] = ACTIONS(3235),
    [anon_sym_do] = ACTIONS(3235),
    [anon_sym_LBRACK] = ACTIONS(3235),
    [anon_sym_RBRACK] = ACTIONS(3235),
    [anon_sym_COLON_COLON2] = ACTIONS(3235),
    [anon_sym_AMP_DOT] = ACTIONS(3235),
    [anon_sym_PLUS_EQ] = ACTIONS(3235),
    [anon_sym_DASH_EQ] = ACTIONS(3235),
    [anon_sym_STAR_EQ] = ACTIONS(3235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3235),
    [anon_sym_SLASH_EQ] = ACTIONS(3235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3235),
    [anon_sym_PIPE_EQ] = ACTIONS(3235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3235),
    [anon_sym_AMP_EQ] = ACTIONS(3235),
    [anon_sym_PERCENT_EQ] = ACTIONS(3235),
    [anon_sym_GT_GT_EQ] = ACTIONS(3235),
    [anon_sym_LT_LT_EQ] = ACTIONS(3235),
    [anon_sym_CARET_EQ] = ACTIONS(3235),
    [anon_sym_QMARK] = ACTIONS(3235),
    [anon_sym_COLON2] = ACTIONS(4997),
    [anon_sym_DOT_DOT] = ACTIONS(4997),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3235),
    [anon_sym_and] = ACTIONS(3235),
    [anon_sym_or] = ACTIONS(3235),
    [anon_sym_PIPE_PIPE] = ACTIONS(4997),
    [anon_sym_AMP_AMP] = ACTIONS(4997),
    [anon_sym_LT_LT] = ACTIONS(4997),
    [anon_sym_GT_GT] = ACTIONS(4997),
    [anon_sym_EQ_EQ] = ACTIONS(4997),
    [anon_sym_BANG_EQ] = ACTIONS(3235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3235),
    [anon_sym_LT_EQ_GT] = ACTIONS(3235),
    [anon_sym_EQ_TILDE] = ACTIONS(3235),
    [anon_sym_BANG_TILDE] = ACTIONS(3235),
    [anon_sym_LT_EQ] = ACTIONS(4997),
    [anon_sym_GT] = ACTIONS(4997),
    [anon_sym_GT_EQ] = ACTIONS(3235),
    [anon_sym_CARET] = ACTIONS(4997),
    [anon_sym_PLUS] = ACTIONS(4997),
    [anon_sym_SLASH] = ACTIONS(4997),
    [anon_sym_PERCENT] = ACTIONS(4997),
    [sym_comment] = ACTIONS(87),
  },
  [6672] = {
    [sym_interpolation] = STATE(1787),
    [aux_sym_heredoc_body_repeat1] = STATE(1787),
    [sym__heredoc_content] = ACTIONS(3237),
    [sym_heredoc_end] = ACTIONS(12547),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(3237),
  },
  [6673] = {
    [sym_heredoc_body] = STATE(6673),
    [aux_sym_call_repeat1] = STATE(6673),
    [sym__heredoc_body_start] = ACTIONS(12549),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_RBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_STAR_STAR] = ACTIONS(7919),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_EQ] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_PLUS_EQ] = ACTIONS(7914),
    [anon_sym_DASH_EQ] = ACTIONS(7914),
    [anon_sym_STAR_EQ] = ACTIONS(7914),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7914),
    [anon_sym_SLASH_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7914),
    [anon_sym_AMP_EQ] = ACTIONS(7914),
    [anon_sym_PERCENT_EQ] = ACTIONS(7914),
    [anon_sym_GT_GT_EQ] = ACTIONS(7914),
    [anon_sym_LT_LT_EQ] = ACTIONS(7914),
    [anon_sym_CARET_EQ] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7919),
    [anon_sym_AMP_AMP] = ACTIONS(7919),
    [anon_sym_LT_LT] = ACTIONS(7919),
    [anon_sym_GT_GT] = ACTIONS(7919),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7919),
    [anon_sym_PLUS] = ACTIONS(7919),
    [anon_sym_SLASH] = ACTIONS(7919),
    [anon_sym_PERCENT] = ACTIONS(7919),
    [sym_comment] = ACTIONS(87),
  },
  [6674] = {
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_RBRACE] = ACTIONS(7925),
    [anon_sym_RPAREN] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(7925),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7927),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_EQ] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_if] = ACTIONS(7925),
    [anon_sym_unless] = ACTIONS(7925),
    [anon_sym_while] = ACTIONS(7925),
    [anon_sym_until] = ACTIONS(7925),
    [anon_sym_rescue] = ACTIONS(7925),
    [anon_sym_in] = ACTIONS(7925),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_RBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_PLUS_EQ] = ACTIONS(7925),
    [anon_sym_DASH_EQ] = ACTIONS(7925),
    [anon_sym_STAR_EQ] = ACTIONS(7925),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7925),
    [anon_sym_SLASH_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7925),
    [anon_sym_AMP_EQ] = ACTIONS(7925),
    [anon_sym_PERCENT_EQ] = ACTIONS(7925),
    [anon_sym_GT_GT_EQ] = ACTIONS(7925),
    [anon_sym_LT_LT_EQ] = ACTIONS(7925),
    [anon_sym_CARET_EQ] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_COLON2] = ACTIONS(7927),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7927),
    [anon_sym_AMP_AMP] = ACTIONS(7927),
    [anon_sym_LT_LT] = ACTIONS(7927),
    [anon_sym_GT_GT] = ACTIONS(7927),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7927),
    [anon_sym_PLUS] = ACTIONS(7927),
    [anon_sym_SLASH] = ACTIONS(7927),
    [anon_sym_PERCENT] = ACTIONS(7927),
    [sym_comment] = ACTIONS(87),
  },
  [6675] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1679),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1686),
    [sym_scope_resolution] = STATE(1680),
    [sym_call] = STATE(1680),
    [sym_method_call] = STATE(1686),
    [sym__argument] = STATE(8888),
    [sym_splat_argument] = STATE(8888),
    [sym_hash_splat_argument] = STATE(8888),
    [sym_block_argument] = STATE(8888),
    [sym_assignment] = STATE(1679),
    [sym_operator_assignment] = STATE(1679),
    [sym_conditional] = STATE(1679),
    [sym_range] = STATE(1679),
    [sym_binary] = STATE(1679),
    [sym_unary] = STATE(1679),
    [sym_left_assignment_list] = STATE(1685),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1686),
    [sym__variable] = STATE(1680),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1686),
    [sym_false] = STATE(1686),
    [sym_nil] = STATE(1686),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1687),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(8888),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(2988),
    [sym__splat_star] = ACTIONS(2990),
    [sym__unary_minus] = ACTIONS(2992),
    [sym__identifier_hash_key] = ACTIONS(2994),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10167),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2998),
    [anon_sym_yield] = ACTIONS(3000),
    [anon_sym_break] = ACTIONS(3002),
    [anon_sym_next] = ACTIONS(3004),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6523),
    [anon_sym_defined_QMARK] = ACTIONS(3010),
    [anon_sym_not] = ACTIONS(3012),
    [anon_sym_BANG] = ACTIONS(3016),
    [anon_sym_TILDE] = ACTIONS(3016),
    [sym_constant] = ACTIONS(3018),
    [sym_identifier] = ACTIONS(3018),
    [sym_instance_variable] = ACTIONS(3020),
    [sym_class_variable] = ACTIONS(3020),
    [sym_global_variable] = ACTIONS(3020),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3022),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3022),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6676] = {
    [sym_heredoc_body] = STATE(6673),
    [aux_sym_call_repeat1] = STATE(6673),
    [sym__heredoc_body_start] = ACTIONS(6569),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_RBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_STAR_STAR] = ACTIONS(7931),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_EQ] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_PLUS_EQ] = ACTIONS(7929),
    [anon_sym_DASH_EQ] = ACTIONS(7929),
    [anon_sym_STAR_EQ] = ACTIONS(7929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7929),
    [anon_sym_SLASH_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7929),
    [anon_sym_AMP_EQ] = ACTIONS(7929),
    [anon_sym_PERCENT_EQ] = ACTIONS(7929),
    [anon_sym_GT_GT_EQ] = ACTIONS(7929),
    [anon_sym_LT_LT_EQ] = ACTIONS(7929),
    [anon_sym_CARET_EQ] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7931),
    [anon_sym_AMP_AMP] = ACTIONS(7931),
    [anon_sym_LT_LT] = ACTIONS(7931),
    [anon_sym_GT_GT] = ACTIONS(7931),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7931),
    [anon_sym_PLUS] = ACTIONS(7931),
    [anon_sym_SLASH] = ACTIONS(7931),
    [anon_sym_PERCENT] = ACTIONS(7931),
    [sym_comment] = ACTIONS(87),
  },
  [6677] = {
    [aux_sym_argument_list_repeat1] = STATE(6677),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_RBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(12552),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_STAR_STAR] = ACTIONS(7927),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_EQ] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_if] = ACTIONS(7925),
    [anon_sym_unless] = ACTIONS(7925),
    [anon_sym_while] = ACTIONS(7925),
    [anon_sym_until] = ACTIONS(7925),
    [anon_sym_rescue] = ACTIONS(7925),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_PLUS_EQ] = ACTIONS(7925),
    [anon_sym_DASH_EQ] = ACTIONS(7925),
    [anon_sym_STAR_EQ] = ACTIONS(7925),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7925),
    [anon_sym_SLASH_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7925),
    [anon_sym_AMP_EQ] = ACTIONS(7925),
    [anon_sym_PERCENT_EQ] = ACTIONS(7925),
    [anon_sym_GT_GT_EQ] = ACTIONS(7925),
    [anon_sym_LT_LT_EQ] = ACTIONS(7925),
    [anon_sym_CARET_EQ] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7927),
    [anon_sym_AMP_AMP] = ACTIONS(7927),
    [anon_sym_LT_LT] = ACTIONS(7927),
    [anon_sym_GT_GT] = ACTIONS(7927),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7927),
    [anon_sym_PLUS] = ACTIONS(7927),
    [anon_sym_SLASH] = ACTIONS(7927),
    [anon_sym_PERCENT] = ACTIONS(7927),
    [sym_comment] = ACTIONS(87),
  },
  [6678] = {
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(6537),
    [sym__binary_star] = ACTIONS(6539),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_RBRACE] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(6541),
    [anon_sym_STAR_STAR] = ACTIONS(6543),
    [anon_sym_AMP] = ACTIONS(6545),
    [anon_sym_EQ] = ACTIONS(7936),
    [anon_sym_LT] = ACTIONS(6547),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_EQ_GT] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_PLUS_EQ] = ACTIONS(5115),
    [anon_sym_DASH_EQ] = ACTIONS(5115),
    [anon_sym_STAR_EQ] = ACTIONS(5115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5115),
    [anon_sym_SLASH_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5115),
    [anon_sym_AMP_EQ] = ACTIONS(5115),
    [anon_sym_PERCENT_EQ] = ACTIONS(5115),
    [anon_sym_GT_GT_EQ] = ACTIONS(5115),
    [anon_sym_LT_LT_EQ] = ACTIONS(5115),
    [anon_sym_CARET_EQ] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(6549),
    [anon_sym_DOT_DOT] = ACTIONS(6551),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6553),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(6555),
    [anon_sym_AMP_AMP] = ACTIONS(6555),
    [anon_sym_LT_LT] = ACTIONS(6557),
    [anon_sym_GT_GT] = ACTIONS(6557),
    [anon_sym_EQ_EQ] = ACTIONS(6555),
    [anon_sym_BANG_EQ] = ACTIONS(6559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6559),
    [anon_sym_LT_EQ_GT] = ACTIONS(6559),
    [anon_sym_EQ_TILDE] = ACTIONS(6559),
    [anon_sym_BANG_TILDE] = ACTIONS(6559),
    [anon_sym_LT_EQ] = ACTIONS(6547),
    [anon_sym_GT] = ACTIONS(6547),
    [anon_sym_GT_EQ] = ACTIONS(6561),
    [anon_sym_CARET] = ACTIONS(6541),
    [anon_sym_PLUS] = ACTIONS(6563),
    [anon_sym_SLASH] = ACTIONS(6543),
    [anon_sym_PERCENT] = ACTIONS(6543),
    [sym_comment] = ACTIONS(87),
  },
  [6679] = {
    [aux_sym_exceptions_repeat1] = STATE(8890),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_RBRACE] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_STAR_STAR] = ACTIONS(6193),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_PLUS_EQ] = ACTIONS(6191),
    [anon_sym_DASH_EQ] = ACTIONS(6191),
    [anon_sym_STAR_EQ] = ACTIONS(6191),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6191),
    [anon_sym_SLASH_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6191),
    [anon_sym_AMP_EQ] = ACTIONS(6191),
    [anon_sym_PERCENT_EQ] = ACTIONS(6191),
    [anon_sym_GT_GT_EQ] = ACTIONS(6191),
    [anon_sym_LT_LT_EQ] = ACTIONS(6191),
    [anon_sym_CARET_EQ] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6193),
    [anon_sym_AMP_AMP] = ACTIONS(6193),
    [anon_sym_LT_LT] = ACTIONS(6193),
    [anon_sym_GT_GT] = ACTIONS(6193),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6193),
    [anon_sym_PLUS] = ACTIONS(6193),
    [anon_sym_SLASH] = ACTIONS(6193),
    [anon_sym_PERCENT] = ACTIONS(6193),
    [sym_comment] = ACTIONS(87),
  },
  [6680] = {
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(6537),
    [sym__binary_star] = ACTIONS(6539),
    [anon_sym_LBRACE] = ACTIONS(6210),
    [anon_sym_RBRACE] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(6541),
    [anon_sym_STAR_STAR] = ACTIONS(6543),
    [anon_sym_AMP] = ACTIONS(6545),
    [anon_sym_EQ] = ACTIONS(7938),
    [anon_sym_LT] = ACTIONS(6547),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_EQ_GT] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_PLUS_EQ] = ACTIONS(6210),
    [anon_sym_DASH_EQ] = ACTIONS(6210),
    [anon_sym_STAR_EQ] = ACTIONS(6210),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6210),
    [anon_sym_SLASH_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6210),
    [anon_sym_AMP_EQ] = ACTIONS(6210),
    [anon_sym_PERCENT_EQ] = ACTIONS(6210),
    [anon_sym_GT_GT_EQ] = ACTIONS(6210),
    [anon_sym_LT_LT_EQ] = ACTIONS(6210),
    [anon_sym_CARET_EQ] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(6549),
    [anon_sym_DOT_DOT] = ACTIONS(6551),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6553),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(6555),
    [anon_sym_AMP_AMP] = ACTIONS(6555),
    [anon_sym_LT_LT] = ACTIONS(6557),
    [anon_sym_GT_GT] = ACTIONS(6557),
    [anon_sym_EQ_EQ] = ACTIONS(6555),
    [anon_sym_BANG_EQ] = ACTIONS(6559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6559),
    [anon_sym_LT_EQ_GT] = ACTIONS(6559),
    [anon_sym_EQ_TILDE] = ACTIONS(6559),
    [anon_sym_BANG_TILDE] = ACTIONS(6559),
    [anon_sym_LT_EQ] = ACTIONS(6547),
    [anon_sym_GT] = ACTIONS(6547),
    [anon_sym_GT_EQ] = ACTIONS(6561),
    [anon_sym_CARET] = ACTIONS(6541),
    [anon_sym_PLUS] = ACTIONS(6563),
    [anon_sym_SLASH] = ACTIONS(6543),
    [anon_sym_PERCENT] = ACTIONS(6543),
    [sym_comment] = ACTIONS(87),
  },
  [6681] = {
    [sym_string] = STATE(6681),
    [aux_sym_chained_string_repeat1] = STATE(6681),
    [sym__string_start] = ACTIONS(10559),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_RBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_STAR_STAR] = ACTIONS(6217),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_EQ] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_do] = ACTIONS(6212),
    [anon_sym_EQ_GT] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_PLUS_EQ] = ACTIONS(6212),
    [anon_sym_DASH_EQ] = ACTIONS(6212),
    [anon_sym_STAR_EQ] = ACTIONS(6212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6212),
    [anon_sym_SLASH_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6212),
    [anon_sym_AMP_EQ] = ACTIONS(6212),
    [anon_sym_PERCENT_EQ] = ACTIONS(6212),
    [anon_sym_GT_GT_EQ] = ACTIONS(6212),
    [anon_sym_LT_LT_EQ] = ACTIONS(6212),
    [anon_sym_CARET_EQ] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6217),
    [anon_sym_AMP_AMP] = ACTIONS(6217),
    [anon_sym_LT_LT] = ACTIONS(6217),
    [anon_sym_GT_GT] = ACTIONS(6217),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6217),
    [anon_sym_PLUS] = ACTIONS(6217),
    [anon_sym_SLASH] = ACTIONS(6217),
    [anon_sym_PERCENT] = ACTIONS(6217),
    [sym_comment] = ACTIONS(87),
  },
  [6682] = {
    [sym__binary_minus] = ACTIONS(10169),
    [sym__binary_star] = ACTIONS(10171),
    [anon_sym_RBRACE] = ACTIONS(4247),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(10173),
    [anon_sym_STAR_STAR] = ACTIONS(10171),
    [anon_sym_AMP] = ACTIONS(10175),
    [anon_sym_LT] = ACTIONS(10177),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(10179),
    [anon_sym_DOT_DOT] = ACTIONS(10181),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10183),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(10185),
    [anon_sym_AMP_AMP] = ACTIONS(10185),
    [anon_sym_LT_LT] = ACTIONS(10187),
    [anon_sym_GT_GT] = ACTIONS(10187),
    [anon_sym_EQ_EQ] = ACTIONS(10189),
    [anon_sym_BANG_EQ] = ACTIONS(10185),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10185),
    [anon_sym_LT_EQ_GT] = ACTIONS(10185),
    [anon_sym_EQ_TILDE] = ACTIONS(10185),
    [anon_sym_BANG_TILDE] = ACTIONS(10185),
    [anon_sym_LT_EQ] = ACTIONS(10177),
    [anon_sym_GT] = ACTIONS(10177),
    [anon_sym_GT_EQ] = ACTIONS(10191),
    [anon_sym_CARET] = ACTIONS(10193),
    [anon_sym_PLUS] = ACTIONS(10169),
    [anon_sym_SLASH] = ACTIONS(10171),
    [anon_sym_PERCENT] = ACTIONS(10171),
    [sym_comment] = ACTIONS(87),
  },
  [6683] = {
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(10171),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [6684] = {
    [sym__binary_minus] = ACTIONS(10169),
    [sym__binary_star] = ACTIONS(10171),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(10173),
    [anon_sym_STAR_STAR] = ACTIONS(10171),
    [anon_sym_AMP] = ACTIONS(10175),
    [anon_sym_LT] = ACTIONS(10177),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(10179),
    [anon_sym_DOT_DOT] = ACTIONS(10181),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10183),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(10185),
    [anon_sym_AMP_AMP] = ACTIONS(10185),
    [anon_sym_LT_LT] = ACTIONS(10187),
    [anon_sym_GT_GT] = ACTIONS(10187),
    [anon_sym_EQ_EQ] = ACTIONS(10189),
    [anon_sym_BANG_EQ] = ACTIONS(10185),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10185),
    [anon_sym_LT_EQ_GT] = ACTIONS(10185),
    [anon_sym_EQ_TILDE] = ACTIONS(10185),
    [anon_sym_BANG_TILDE] = ACTIONS(10185),
    [anon_sym_LT_EQ] = ACTIONS(10177),
    [anon_sym_GT] = ACTIONS(10177),
    [anon_sym_GT_EQ] = ACTIONS(10191),
    [anon_sym_CARET] = ACTIONS(10193),
    [anon_sym_PLUS] = ACTIONS(10169),
    [anon_sym_SLASH] = ACTIONS(10171),
    [anon_sym_PERCENT] = ACTIONS(10171),
    [sym_comment] = ACTIONS(87),
  },
  [6685] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(8891),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(3988),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym_method_call] = STATE(3988),
    [sym_assignment] = STATE(8891),
    [sym_operator_assignment] = STATE(8891),
    [sym_conditional] = STATE(8891),
    [sym_range] = STATE(8891),
    [sym_binary] = STATE(8891),
    [sym_unary] = STATE(8891),
    [sym_left_assignment_list] = STATE(3987),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3988),
    [sym__variable] = STATE(455),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(3988),
    [sym_false] = STATE(3988),
    [sym_nil] = STATE(3988),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(3989),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(6583),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6585),
    [anon_sym_yield] = ACTIONS(6587),
    [anon_sym_break] = ACTIONS(6589),
    [anon_sym_next] = ACTIONS(6591),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6593),
    [anon_sym_defined_QMARK] = ACTIONS(6595),
    [anon_sym_not] = ACTIONS(6597),
    [anon_sym_BANG] = ACTIONS(6599),
    [anon_sym_TILDE] = ACTIONS(6599),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6686] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(8892),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(3988),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym_method_call] = STATE(3988),
    [sym_assignment] = STATE(8892),
    [sym_operator_assignment] = STATE(8892),
    [sym_conditional] = STATE(8892),
    [sym_range] = STATE(8892),
    [sym_binary] = STATE(8892),
    [sym_unary] = STATE(8892),
    [sym_left_assignment_list] = STATE(3987),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3988),
    [sym__variable] = STATE(455),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(3988),
    [sym_false] = STATE(3988),
    [sym_nil] = STATE(3988),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(3989),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(6583),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6585),
    [anon_sym_yield] = ACTIONS(6587),
    [anon_sym_break] = ACTIONS(6589),
    [anon_sym_next] = ACTIONS(6591),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6593),
    [anon_sym_defined_QMARK] = ACTIONS(6595),
    [anon_sym_not] = ACTIONS(6597),
    [anon_sym_BANG] = ACTIONS(6599),
    [anon_sym_TILDE] = ACTIONS(6599),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6687] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(8893),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(3988),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym_method_call] = STATE(3988),
    [sym_assignment] = STATE(8893),
    [sym_operator_assignment] = STATE(8893),
    [sym_conditional] = STATE(8893),
    [sym_range] = STATE(8893),
    [sym_binary] = STATE(8893),
    [sym_unary] = STATE(8893),
    [sym_left_assignment_list] = STATE(3987),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3988),
    [sym__variable] = STATE(455),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(3988),
    [sym_false] = STATE(3988),
    [sym_nil] = STATE(3988),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(3989),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(6583),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6585),
    [anon_sym_yield] = ACTIONS(6587),
    [anon_sym_break] = ACTIONS(6589),
    [anon_sym_next] = ACTIONS(6591),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6593),
    [anon_sym_defined_QMARK] = ACTIONS(6595),
    [anon_sym_not] = ACTIONS(6597),
    [anon_sym_BANG] = ACTIONS(6599),
    [anon_sym_TILDE] = ACTIONS(6599),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6688] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(8894),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(3988),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym_method_call] = STATE(3988),
    [sym_assignment] = STATE(8894),
    [sym_operator_assignment] = STATE(8894),
    [sym_conditional] = STATE(8894),
    [sym_range] = STATE(8894),
    [sym_binary] = STATE(8894),
    [sym_unary] = STATE(8894),
    [sym_left_assignment_list] = STATE(3987),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3988),
    [sym__variable] = STATE(455),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(3988),
    [sym_false] = STATE(3988),
    [sym_nil] = STATE(3988),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(3989),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(6583),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6585),
    [anon_sym_yield] = ACTIONS(6587),
    [anon_sym_break] = ACTIONS(6589),
    [anon_sym_next] = ACTIONS(6591),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6593),
    [anon_sym_defined_QMARK] = ACTIONS(6595),
    [anon_sym_not] = ACTIONS(6597),
    [anon_sym_BANG] = ACTIONS(6599),
    [anon_sym_TILDE] = ACTIONS(6599),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6689] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(8895),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(3988),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym_method_call] = STATE(3988),
    [sym_assignment] = STATE(8895),
    [sym_operator_assignment] = STATE(8895),
    [sym_conditional] = STATE(8895),
    [sym_range] = STATE(8895),
    [sym_binary] = STATE(8895),
    [sym_unary] = STATE(8895),
    [sym_left_assignment_list] = STATE(3987),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3988),
    [sym__variable] = STATE(455),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(3988),
    [sym_false] = STATE(3988),
    [sym_nil] = STATE(3988),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(3989),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(6583),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6585),
    [anon_sym_yield] = ACTIONS(6587),
    [anon_sym_break] = ACTIONS(6589),
    [anon_sym_next] = ACTIONS(6591),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6593),
    [anon_sym_defined_QMARK] = ACTIONS(6595),
    [anon_sym_not] = ACTIONS(6597),
    [anon_sym_BANG] = ACTIONS(6599),
    [anon_sym_TILDE] = ACTIONS(6599),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6690] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(8896),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(8896),
    [sym_operator_assignment] = STATE(8896),
    [sym_conditional] = STATE(8896),
    [sym_range] = STATE(8896),
    [sym_binary] = STATE(8896),
    [sym_unary] = STATE(8896),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6691] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(8897),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(3988),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym_method_call] = STATE(3988),
    [sym_assignment] = STATE(8897),
    [sym_operator_assignment] = STATE(8897),
    [sym_conditional] = STATE(8897),
    [sym_range] = STATE(8897),
    [sym_binary] = STATE(8897),
    [sym_unary] = STATE(8897),
    [sym_left_assignment_list] = STATE(3987),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3988),
    [sym__variable] = STATE(455),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(3988),
    [sym_false] = STATE(3988),
    [sym_nil] = STATE(3988),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(3989),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(6583),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6585),
    [anon_sym_yield] = ACTIONS(6587),
    [anon_sym_break] = ACTIONS(6589),
    [anon_sym_next] = ACTIONS(6591),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6593),
    [anon_sym_defined_QMARK] = ACTIONS(6595),
    [anon_sym_not] = ACTIONS(6597),
    [anon_sym_BANG] = ACTIONS(6599),
    [anon_sym_TILDE] = ACTIONS(6599),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6692] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(8898),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(3988),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym_method_call] = STATE(3988),
    [sym_assignment] = STATE(8898),
    [sym_operator_assignment] = STATE(8898),
    [sym_conditional] = STATE(8898),
    [sym_range] = STATE(8898),
    [sym_binary] = STATE(8898),
    [sym_unary] = STATE(8898),
    [sym_left_assignment_list] = STATE(3987),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3988),
    [sym__variable] = STATE(455),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(3988),
    [sym_false] = STATE(3988),
    [sym_nil] = STATE(3988),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(3989),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(6583),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6585),
    [anon_sym_yield] = ACTIONS(6587),
    [anon_sym_break] = ACTIONS(6589),
    [anon_sym_next] = ACTIONS(6591),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6593),
    [anon_sym_defined_QMARK] = ACTIONS(6595),
    [anon_sym_not] = ACTIONS(6597),
    [anon_sym_BANG] = ACTIONS(6599),
    [anon_sym_TILDE] = ACTIONS(6599),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6693] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(8899),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(3988),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym_method_call] = STATE(3988),
    [sym_assignment] = STATE(8899),
    [sym_operator_assignment] = STATE(8899),
    [sym_conditional] = STATE(8899),
    [sym_range] = STATE(8899),
    [sym_binary] = STATE(8899),
    [sym_unary] = STATE(8899),
    [sym_left_assignment_list] = STATE(3987),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3988),
    [sym__variable] = STATE(455),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(3988),
    [sym_false] = STATE(3988),
    [sym_nil] = STATE(3988),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(3989),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(6583),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6585),
    [anon_sym_yield] = ACTIONS(6587),
    [anon_sym_break] = ACTIONS(6589),
    [anon_sym_next] = ACTIONS(6591),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6593),
    [anon_sym_defined_QMARK] = ACTIONS(6595),
    [anon_sym_not] = ACTIONS(6597),
    [anon_sym_BANG] = ACTIONS(6599),
    [anon_sym_TILDE] = ACTIONS(6599),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6694] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(8900),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(3988),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym_method_call] = STATE(3988),
    [sym_assignment] = STATE(8900),
    [sym_operator_assignment] = STATE(8900),
    [sym_conditional] = STATE(8900),
    [sym_range] = STATE(8900),
    [sym_binary] = STATE(8900),
    [sym_unary] = STATE(8900),
    [sym_left_assignment_list] = STATE(3987),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3988),
    [sym__variable] = STATE(455),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(3988),
    [sym_false] = STATE(3988),
    [sym_nil] = STATE(3988),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(3989),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(6583),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6585),
    [anon_sym_yield] = ACTIONS(6587),
    [anon_sym_break] = ACTIONS(6589),
    [anon_sym_next] = ACTIONS(6591),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6593),
    [anon_sym_defined_QMARK] = ACTIONS(6595),
    [anon_sym_not] = ACTIONS(6597),
    [anon_sym_BANG] = ACTIONS(6599),
    [anon_sym_TILDE] = ACTIONS(6599),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6695] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(3985),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(3988),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym_method_call] = STATE(3988),
    [sym_splat_argument] = STATE(6983),
    [sym_assignment] = STATE(3985),
    [sym_operator_assignment] = STATE(3985),
    [sym_conditional] = STATE(3985),
    [sym_range] = STATE(3985),
    [sym_binary] = STATE(3985),
    [sym_unary] = STATE(3985),
    [sym__arg_or_splat_arg] = STATE(6983),
    [sym_left_assignment_list] = STATE(3987),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3988),
    [sym__variable] = STATE(455),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(3988),
    [sym_false] = STATE(3988),
    [sym_nil] = STATE(3988),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(3989),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__splat_star] = ACTIONS(6581),
    [sym__unary_minus] = ACTIONS(6583),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6585),
    [anon_sym_yield] = ACTIONS(6587),
    [anon_sym_break] = ACTIONS(6589),
    [anon_sym_next] = ACTIONS(6591),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6593),
    [anon_sym_defined_QMARK] = ACTIONS(6595),
    [anon_sym_not] = ACTIONS(6597),
    [anon_sym_BANG] = ACTIONS(6599),
    [anon_sym_TILDE] = ACTIONS(6599),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6696] = {
    [aux_sym_exceptions_repeat1] = STATE(8901),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_RBRACE] = ACTIONS(9855),
    [anon_sym_COMMA] = ACTIONS(10195),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [6697] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(3985),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(3988),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym_method_call] = STATE(3988),
    [sym_splat_argument] = STATE(8902),
    [sym_assignment] = STATE(3985),
    [sym_operator_assignment] = STATE(3985),
    [sym_conditional] = STATE(3985),
    [sym_range] = STATE(3985),
    [sym_binary] = STATE(3985),
    [sym_unary] = STATE(3985),
    [sym_right_assignment_list] = STATE(2035),
    [sym__arg_or_splat_arg] = STATE(8902),
    [sym_left_assignment_list] = STATE(3987),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3988),
    [sym__variable] = STATE(455),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(3988),
    [sym_false] = STATE(3988),
    [sym_nil] = STATE(3988),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(3989),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__splat_star] = ACTIONS(6581),
    [sym__unary_minus] = ACTIONS(6583),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6585),
    [anon_sym_yield] = ACTIONS(6587),
    [anon_sym_break] = ACTIONS(6589),
    [anon_sym_next] = ACTIONS(6591),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6593),
    [anon_sym_defined_QMARK] = ACTIONS(6595),
    [anon_sym_not] = ACTIONS(6597),
    [anon_sym_BANG] = ACTIONS(6599),
    [anon_sym_TILDE] = ACTIONS(6599),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6698] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(8903),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(3988),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym_method_call] = STATE(3988),
    [sym_assignment] = STATE(8903),
    [sym_operator_assignment] = STATE(8903),
    [sym_conditional] = STATE(8903),
    [sym_range] = STATE(8903),
    [sym_binary] = STATE(8903),
    [sym_unary] = STATE(8903),
    [sym_left_assignment_list] = STATE(3987),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3988),
    [sym__variable] = STATE(455),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(3988),
    [sym_false] = STATE(3988),
    [sym_nil] = STATE(3988),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(3989),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(6583),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6585),
    [anon_sym_yield] = ACTIONS(6587),
    [anon_sym_break] = ACTIONS(6589),
    [anon_sym_next] = ACTIONS(6591),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6593),
    [anon_sym_defined_QMARK] = ACTIONS(6595),
    [anon_sym_not] = ACTIONS(6597),
    [anon_sym_BANG] = ACTIONS(6599),
    [anon_sym_TILDE] = ACTIONS(6599),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6699] = {
    [sym_string] = STATE(8904),
    [aux_sym_chained_string_repeat1] = STATE(8904),
    [sym__string_start] = ACTIONS(139),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_RBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [6700] = {
    [sym__line_break] = ACTIONS(12555),
    [sym__heredoc_body_start] = ACTIONS(12555),
    [sym__binary_minus] = ACTIONS(12555),
    [sym__binary_star] = ACTIONS(12555),
    [ts_builtin_sym_end] = ACTIONS(12555),
    [anon_sym___END__] = ACTIONS(12555),
    [anon_sym_LBRACE] = ACTIONS(12555),
    [anon_sym_RBRACE] = ACTIONS(12555),
    [anon_sym_RPAREN] = ACTIONS(12555),
    [anon_sym_DOT] = ACTIONS(12557),
    [anon_sym_COMMA] = ACTIONS(12555),
    [anon_sym_PIPE] = ACTIONS(12557),
    [anon_sym_SEMI] = ACTIONS(12555),
    [anon_sym_STAR_STAR] = ACTIONS(12555),
    [anon_sym_AMP] = ACTIONS(12557),
    [anon_sym_LT] = ACTIONS(12557),
    [anon_sym_end] = ACTIONS(12555),
    [anon_sym_if] = ACTIONS(12555),
    [anon_sym_unless] = ACTIONS(12555),
    [anon_sym_while] = ACTIONS(12555),
    [anon_sym_until] = ACTIONS(12555),
    [anon_sym_rescue] = ACTIONS(12555),
    [anon_sym_do] = ACTIONS(12555),
    [anon_sym_when] = ACTIONS(12555),
    [anon_sym_elsif] = ACTIONS(12555),
    [anon_sym_else] = ACTIONS(12555),
    [anon_sym_then] = ACTIONS(12555),
    [anon_sym_ensure] = ACTIONS(12555),
    [anon_sym_EQ_GT] = ACTIONS(12555),
    [anon_sym_LBRACK] = ACTIONS(12555),
    [anon_sym_COLON_COLON2] = ACTIONS(12555),
    [anon_sym_AMP_DOT] = ACTIONS(12555),
    [anon_sym_QMARK] = ACTIONS(12555),
    [anon_sym_DOT_DOT] = ACTIONS(12557),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12555),
    [anon_sym_and] = ACTIONS(12555),
    [anon_sym_or] = ACTIONS(12555),
    [anon_sym_PIPE_PIPE] = ACTIONS(12555),
    [anon_sym_AMP_AMP] = ACTIONS(12555),
    [anon_sym_LT_LT] = ACTIONS(12555),
    [anon_sym_GT_GT] = ACTIONS(12555),
    [anon_sym_EQ_EQ] = ACTIONS(12557),
    [anon_sym_BANG_EQ] = ACTIONS(12555),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12555),
    [anon_sym_LT_EQ_GT] = ACTIONS(12555),
    [anon_sym_EQ_TILDE] = ACTIONS(12555),
    [anon_sym_BANG_TILDE] = ACTIONS(12555),
    [anon_sym_LT_EQ] = ACTIONS(12557),
    [anon_sym_GT] = ACTIONS(12557),
    [anon_sym_GT_EQ] = ACTIONS(12555),
    [anon_sym_CARET] = ACTIONS(12555),
    [anon_sym_PLUS] = ACTIONS(12555),
    [anon_sym_SLASH] = ACTIONS(12555),
    [anon_sym_PERCENT] = ACTIONS(12555),
    [sym_comment] = ACTIONS(87),
  },
  [6701] = {
    [sym__line_break] = ACTIONS(12559),
    [sym__heredoc_body_start] = ACTIONS(12559),
    [sym__binary_minus] = ACTIONS(12559),
    [sym__binary_star] = ACTIONS(12559),
    [ts_builtin_sym_end] = ACTIONS(12559),
    [anon_sym___END__] = ACTIONS(12559),
    [anon_sym_LBRACE] = ACTIONS(12559),
    [anon_sym_RBRACE] = ACTIONS(12559),
    [anon_sym_RPAREN] = ACTIONS(12559),
    [anon_sym_DOT] = ACTIONS(12561),
    [anon_sym_COMMA] = ACTIONS(12559),
    [anon_sym_PIPE] = ACTIONS(12561),
    [anon_sym_SEMI] = ACTIONS(12559),
    [anon_sym_STAR_STAR] = ACTIONS(12559),
    [anon_sym_AMP] = ACTIONS(12561),
    [anon_sym_LT] = ACTIONS(12561),
    [anon_sym_end] = ACTIONS(12559),
    [anon_sym_if] = ACTIONS(12559),
    [anon_sym_unless] = ACTIONS(12559),
    [anon_sym_while] = ACTIONS(12559),
    [anon_sym_until] = ACTIONS(12559),
    [anon_sym_rescue] = ACTIONS(12559),
    [anon_sym_do] = ACTIONS(12559),
    [anon_sym_when] = ACTIONS(12559),
    [anon_sym_elsif] = ACTIONS(12559),
    [anon_sym_else] = ACTIONS(12559),
    [anon_sym_then] = ACTIONS(12559),
    [anon_sym_ensure] = ACTIONS(12559),
    [anon_sym_EQ_GT] = ACTIONS(12559),
    [anon_sym_LBRACK] = ACTIONS(12559),
    [anon_sym_COLON_COLON2] = ACTIONS(12559),
    [anon_sym_AMP_DOT] = ACTIONS(12559),
    [anon_sym_QMARK] = ACTIONS(12559),
    [anon_sym_DOT_DOT] = ACTIONS(12561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12559),
    [anon_sym_and] = ACTIONS(12559),
    [anon_sym_or] = ACTIONS(12559),
    [anon_sym_PIPE_PIPE] = ACTIONS(12559),
    [anon_sym_AMP_AMP] = ACTIONS(12559),
    [anon_sym_LT_LT] = ACTIONS(12559),
    [anon_sym_GT_GT] = ACTIONS(12559),
    [anon_sym_EQ_EQ] = ACTIONS(12561),
    [anon_sym_BANG_EQ] = ACTIONS(12559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12559),
    [anon_sym_LT_EQ_GT] = ACTIONS(12559),
    [anon_sym_EQ_TILDE] = ACTIONS(12559),
    [anon_sym_BANG_TILDE] = ACTIONS(12559),
    [anon_sym_LT_EQ] = ACTIONS(12561),
    [anon_sym_GT] = ACTIONS(12561),
    [anon_sym_GT_EQ] = ACTIONS(12559),
    [anon_sym_CARET] = ACTIONS(12559),
    [anon_sym_PLUS] = ACTIONS(12559),
    [anon_sym_SLASH] = ACTIONS(12559),
    [anon_sym_PERCENT] = ACTIONS(12559),
    [sym_comment] = ACTIONS(87),
  },
  [6702] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(10225),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [6703] = {
    [sym_heredoc_body] = STATE(8905),
    [aux_sym_call_repeat1] = STATE(8905),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_RBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [6704] = {
    [sym_heredoc_body] = STATE(8905),
    [aux_sym_call_repeat1] = STATE(8905),
    [aux_sym_argument_list_repeat1] = STATE(8906),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_RBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(6701),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [6705] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(10223),
    [sym__binary_star] = ACTIONS(10225),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(10227),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(10225),
    [anon_sym_AMP] = ACTIONS(10229),
    [anon_sym_LT] = ACTIONS(10231),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(10233),
    [anon_sym_DOT_DOT] = ACTIONS(10235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10237),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(10239),
    [anon_sym_AMP_AMP] = ACTIONS(10239),
    [anon_sym_LT_LT] = ACTIONS(10241),
    [anon_sym_GT_GT] = ACTIONS(10241),
    [anon_sym_EQ_EQ] = ACTIONS(10243),
    [anon_sym_BANG_EQ] = ACTIONS(10239),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10239),
    [anon_sym_LT_EQ_GT] = ACTIONS(10239),
    [anon_sym_EQ_TILDE] = ACTIONS(10239),
    [anon_sym_BANG_TILDE] = ACTIONS(10239),
    [anon_sym_LT_EQ] = ACTIONS(10231),
    [anon_sym_GT] = ACTIONS(10231),
    [anon_sym_GT_EQ] = ACTIONS(10245),
    [anon_sym_CARET] = ACTIONS(10247),
    [anon_sym_PLUS] = ACTIONS(10223),
    [anon_sym_SLASH] = ACTIONS(10225),
    [anon_sym_PERCENT] = ACTIONS(10225),
    [sym_comment] = ACTIONS(87),
  },
  [6706] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8907),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(4009),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4009),
    [sym_assignment] = STATE(8907),
    [sym_operator_assignment] = STATE(8907),
    [sym_conditional] = STATE(8907),
    [sym_range] = STATE(8907),
    [sym_binary] = STATE(8907),
    [sym_unary] = STATE(8907),
    [sym_left_assignment_list] = STATE(4008),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4009),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(4009),
    [sym_false] = STATE(4009),
    [sym_nil] = STATE(4009),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(4010),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6651),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6653),
    [anon_sym_yield] = ACTIONS(6655),
    [anon_sym_break] = ACTIONS(6657),
    [anon_sym_next] = ACTIONS(6659),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6661),
    [anon_sym_defined_QMARK] = ACTIONS(6663),
    [anon_sym_not] = ACTIONS(6665),
    [anon_sym_BANG] = ACTIONS(6667),
    [anon_sym_TILDE] = ACTIONS(6667),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6707] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8908),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(4009),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4009),
    [sym_assignment] = STATE(8908),
    [sym_operator_assignment] = STATE(8908),
    [sym_conditional] = STATE(8908),
    [sym_range] = STATE(8908),
    [sym_binary] = STATE(8908),
    [sym_unary] = STATE(8908),
    [sym_left_assignment_list] = STATE(4008),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4009),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(4009),
    [sym_false] = STATE(4009),
    [sym_nil] = STATE(4009),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(4010),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6651),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6653),
    [anon_sym_yield] = ACTIONS(6655),
    [anon_sym_break] = ACTIONS(6657),
    [anon_sym_next] = ACTIONS(6659),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6661),
    [anon_sym_defined_QMARK] = ACTIONS(6663),
    [anon_sym_not] = ACTIONS(6665),
    [anon_sym_BANG] = ACTIONS(6667),
    [anon_sym_TILDE] = ACTIONS(6667),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6708] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8909),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(4009),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4009),
    [sym_assignment] = STATE(8909),
    [sym_operator_assignment] = STATE(8909),
    [sym_conditional] = STATE(8909),
    [sym_range] = STATE(8909),
    [sym_binary] = STATE(8909),
    [sym_unary] = STATE(8909),
    [sym_left_assignment_list] = STATE(4008),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4009),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(4009),
    [sym_false] = STATE(4009),
    [sym_nil] = STATE(4009),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(4010),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6651),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6653),
    [anon_sym_yield] = ACTIONS(6655),
    [anon_sym_break] = ACTIONS(6657),
    [anon_sym_next] = ACTIONS(6659),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6661),
    [anon_sym_defined_QMARK] = ACTIONS(6663),
    [anon_sym_not] = ACTIONS(6665),
    [anon_sym_BANG] = ACTIONS(6667),
    [anon_sym_TILDE] = ACTIONS(6667),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6709] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8910),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(4009),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4009),
    [sym_assignment] = STATE(8910),
    [sym_operator_assignment] = STATE(8910),
    [sym_conditional] = STATE(8910),
    [sym_range] = STATE(8910),
    [sym_binary] = STATE(8910),
    [sym_unary] = STATE(8910),
    [sym_left_assignment_list] = STATE(4008),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4009),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(4009),
    [sym_false] = STATE(4009),
    [sym_nil] = STATE(4009),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(4010),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6651),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6653),
    [anon_sym_yield] = ACTIONS(6655),
    [anon_sym_break] = ACTIONS(6657),
    [anon_sym_next] = ACTIONS(6659),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6661),
    [anon_sym_defined_QMARK] = ACTIONS(6663),
    [anon_sym_not] = ACTIONS(6665),
    [anon_sym_BANG] = ACTIONS(6667),
    [anon_sym_TILDE] = ACTIONS(6667),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6710] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8911),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(4009),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4009),
    [sym_assignment] = STATE(8911),
    [sym_operator_assignment] = STATE(8911),
    [sym_conditional] = STATE(8911),
    [sym_range] = STATE(8911),
    [sym_binary] = STATE(8911),
    [sym_unary] = STATE(8911),
    [sym_left_assignment_list] = STATE(4008),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4009),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(4009),
    [sym_false] = STATE(4009),
    [sym_nil] = STATE(4009),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(4010),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6651),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6653),
    [anon_sym_yield] = ACTIONS(6655),
    [anon_sym_break] = ACTIONS(6657),
    [anon_sym_next] = ACTIONS(6659),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6661),
    [anon_sym_defined_QMARK] = ACTIONS(6663),
    [anon_sym_not] = ACTIONS(6665),
    [anon_sym_BANG] = ACTIONS(6667),
    [anon_sym_TILDE] = ACTIONS(6667),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6711] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(8912),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(8912),
    [sym_operator_assignment] = STATE(8912),
    [sym_conditional] = STATE(8912),
    [sym_range] = STATE(8912),
    [sym_binary] = STATE(8912),
    [sym_unary] = STATE(8912),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6712] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8913),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(4009),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4009),
    [sym_assignment] = STATE(8913),
    [sym_operator_assignment] = STATE(8913),
    [sym_conditional] = STATE(8913),
    [sym_range] = STATE(8913),
    [sym_binary] = STATE(8913),
    [sym_unary] = STATE(8913),
    [sym_left_assignment_list] = STATE(4008),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4009),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(4009),
    [sym_false] = STATE(4009),
    [sym_nil] = STATE(4009),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(4010),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6651),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6653),
    [anon_sym_yield] = ACTIONS(6655),
    [anon_sym_break] = ACTIONS(6657),
    [anon_sym_next] = ACTIONS(6659),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6661),
    [anon_sym_defined_QMARK] = ACTIONS(6663),
    [anon_sym_not] = ACTIONS(6665),
    [anon_sym_BANG] = ACTIONS(6667),
    [anon_sym_TILDE] = ACTIONS(6667),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6713] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8914),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(4009),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4009),
    [sym_assignment] = STATE(8914),
    [sym_operator_assignment] = STATE(8914),
    [sym_conditional] = STATE(8914),
    [sym_range] = STATE(8914),
    [sym_binary] = STATE(8914),
    [sym_unary] = STATE(8914),
    [sym_left_assignment_list] = STATE(4008),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4009),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(4009),
    [sym_false] = STATE(4009),
    [sym_nil] = STATE(4009),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(4010),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6651),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6653),
    [anon_sym_yield] = ACTIONS(6655),
    [anon_sym_break] = ACTIONS(6657),
    [anon_sym_next] = ACTIONS(6659),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6661),
    [anon_sym_defined_QMARK] = ACTIONS(6663),
    [anon_sym_not] = ACTIONS(6665),
    [anon_sym_BANG] = ACTIONS(6667),
    [anon_sym_TILDE] = ACTIONS(6667),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6714] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8915),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(4009),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4009),
    [sym_assignment] = STATE(8915),
    [sym_operator_assignment] = STATE(8915),
    [sym_conditional] = STATE(8915),
    [sym_range] = STATE(8915),
    [sym_binary] = STATE(8915),
    [sym_unary] = STATE(8915),
    [sym_left_assignment_list] = STATE(4008),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4009),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(4009),
    [sym_false] = STATE(4009),
    [sym_nil] = STATE(4009),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(4010),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6651),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6653),
    [anon_sym_yield] = ACTIONS(6655),
    [anon_sym_break] = ACTIONS(6657),
    [anon_sym_next] = ACTIONS(6659),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6661),
    [anon_sym_defined_QMARK] = ACTIONS(6663),
    [anon_sym_not] = ACTIONS(6665),
    [anon_sym_BANG] = ACTIONS(6667),
    [anon_sym_TILDE] = ACTIONS(6667),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6715] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8916),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(4009),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4009),
    [sym_assignment] = STATE(8916),
    [sym_operator_assignment] = STATE(8916),
    [sym_conditional] = STATE(8916),
    [sym_range] = STATE(8916),
    [sym_binary] = STATE(8916),
    [sym_unary] = STATE(8916),
    [sym_left_assignment_list] = STATE(4008),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4009),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(4009),
    [sym_false] = STATE(4009),
    [sym_nil] = STATE(4009),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(4010),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6651),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6653),
    [anon_sym_yield] = ACTIONS(6655),
    [anon_sym_break] = ACTIONS(6657),
    [anon_sym_next] = ACTIONS(6659),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6661),
    [anon_sym_defined_QMARK] = ACTIONS(6663),
    [anon_sym_not] = ACTIONS(6665),
    [anon_sym_BANG] = ACTIONS(6667),
    [anon_sym_TILDE] = ACTIONS(6667),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6716] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8917),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(4009),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4009),
    [sym_splat_argument] = STATE(8918),
    [sym_assignment] = STATE(8917),
    [sym_operator_assignment] = STATE(8917),
    [sym_conditional] = STATE(8917),
    [sym_range] = STATE(8917),
    [sym_binary] = STATE(8917),
    [sym_unary] = STATE(8917),
    [sym_right_assignment_list] = STATE(2570),
    [sym__arg_or_splat_arg] = STATE(8918),
    [sym_left_assignment_list] = STATE(4008),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4009),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(4009),
    [sym_false] = STATE(4009),
    [sym_nil] = STATE(4009),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(4010),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(3109),
    [sym__unary_minus] = ACTIONS(6651),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6653),
    [anon_sym_yield] = ACTIONS(6655),
    [anon_sym_break] = ACTIONS(6657),
    [anon_sym_next] = ACTIONS(6659),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6661),
    [anon_sym_defined_QMARK] = ACTIONS(6663),
    [anon_sym_not] = ACTIONS(6665),
    [anon_sym_BANG] = ACTIONS(6667),
    [anon_sym_TILDE] = ACTIONS(6667),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6717] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8919),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(4009),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4009),
    [sym_assignment] = STATE(8919),
    [sym_operator_assignment] = STATE(8919),
    [sym_conditional] = STATE(8919),
    [sym_range] = STATE(8919),
    [sym_binary] = STATE(8919),
    [sym_unary] = STATE(8919),
    [sym_left_assignment_list] = STATE(4008),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4009),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(4009),
    [sym_false] = STATE(4009),
    [sym_nil] = STATE(4009),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(4010),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6651),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6653),
    [anon_sym_yield] = ACTIONS(6655),
    [anon_sym_break] = ACTIONS(6657),
    [anon_sym_next] = ACTIONS(6659),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6661),
    [anon_sym_defined_QMARK] = ACTIONS(6663),
    [anon_sym_not] = ACTIONS(6665),
    [anon_sym_BANG] = ACTIONS(6667),
    [anon_sym_TILDE] = ACTIONS(6667),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6718] = {
    [sym_string] = STATE(8920),
    [aux_sym_chained_string_repeat1] = STATE(8920),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_RBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [6719] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(10223),
    [sym__binary_star] = ACTIONS(10225),
    [anon_sym_RBRACE] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(10227),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(10225),
    [anon_sym_AMP] = ACTIONS(10229),
    [anon_sym_LT] = ACTIONS(10231),
    [anon_sym_if] = ACTIONS(6823),
    [anon_sym_unless] = ACTIONS(6823),
    [anon_sym_while] = ACTIONS(6823),
    [anon_sym_until] = ACTIONS(6823),
    [anon_sym_rescue] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(10233),
    [anon_sym_DOT_DOT] = ACTIONS(10235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10237),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(10239),
    [anon_sym_AMP_AMP] = ACTIONS(10239),
    [anon_sym_LT_LT] = ACTIONS(10241),
    [anon_sym_GT_GT] = ACTIONS(10241),
    [anon_sym_EQ_EQ] = ACTIONS(10243),
    [anon_sym_BANG_EQ] = ACTIONS(10239),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10239),
    [anon_sym_LT_EQ_GT] = ACTIONS(10239),
    [anon_sym_EQ_TILDE] = ACTIONS(10239),
    [anon_sym_BANG_TILDE] = ACTIONS(10239),
    [anon_sym_LT_EQ] = ACTIONS(10231),
    [anon_sym_GT] = ACTIONS(10231),
    [anon_sym_GT_EQ] = ACTIONS(10245),
    [anon_sym_CARET] = ACTIONS(10247),
    [anon_sym_PLUS] = ACTIONS(10223),
    [anon_sym_SLASH] = ACTIONS(10225),
    [anon_sym_PERCENT] = ACTIONS(10225),
    [sym_comment] = ACTIONS(87),
  },
  [6720] = {
    [sym_heredoc_body] = STATE(8921),
    [aux_sym_call_repeat1] = STATE(8921),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_RBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [6721] = {
    [sym_heredoc_body] = STATE(8922),
    [aux_sym_call_repeat1] = STATE(8922),
    [aux_sym_argument_list_repeat1] = STATE(8636),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_RBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [6722] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(10223),
    [sym__binary_star] = ACTIONS(10225),
    [anon_sym_RBRACE] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(10227),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(10225),
    [anon_sym_AMP] = ACTIONS(10229),
    [anon_sym_LT] = ACTIONS(10231),
    [anon_sym_if] = ACTIONS(7027),
    [anon_sym_unless] = ACTIONS(7027),
    [anon_sym_while] = ACTIONS(7027),
    [anon_sym_until] = ACTIONS(7027),
    [anon_sym_rescue] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(10233),
    [anon_sym_DOT_DOT] = ACTIONS(10235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10237),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(10239),
    [anon_sym_AMP_AMP] = ACTIONS(10239),
    [anon_sym_LT_LT] = ACTIONS(10241),
    [anon_sym_GT_GT] = ACTIONS(10241),
    [anon_sym_EQ_EQ] = ACTIONS(10243),
    [anon_sym_BANG_EQ] = ACTIONS(10239),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10239),
    [anon_sym_LT_EQ_GT] = ACTIONS(10239),
    [anon_sym_EQ_TILDE] = ACTIONS(10239),
    [anon_sym_BANG_TILDE] = ACTIONS(10239),
    [anon_sym_LT_EQ] = ACTIONS(10231),
    [anon_sym_GT] = ACTIONS(10231),
    [anon_sym_GT_EQ] = ACTIONS(10245),
    [anon_sym_CARET] = ACTIONS(10247),
    [anon_sym_PLUS] = ACTIONS(10223),
    [anon_sym_SLASH] = ACTIONS(10225),
    [anon_sym_PERCENT] = ACTIONS(10225),
    [sym_comment] = ACTIONS(87),
  },
  [6723] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(6677),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(6677),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(6677),
    [anon_sym_PERCENT] = ACTIONS(6677),
    [sym_comment] = ACTIONS(87),
  },
  [6724] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(6677),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [6725] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6675),
    [sym__binary_star] = ACTIONS(6677),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(6677),
    [anon_sym_AMP] = ACTIONS(6681),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(6693),
    [anon_sym_GT_GT] = ACTIONS(6693),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(6675),
    [anon_sym_SLASH] = ACTIONS(6677),
    [anon_sym_PERCENT] = ACTIONS(6677),
    [sym_comment] = ACTIONS(87),
  },
  [6726] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6675),
    [sym__binary_star] = ACTIONS(6677),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(6677),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(6693),
    [anon_sym_GT_GT] = ACTIONS(6693),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(6675),
    [anon_sym_SLASH] = ACTIONS(6677),
    [anon_sym_PERCENT] = ACTIONS(6677),
    [sym_comment] = ACTIONS(87),
  },
  [6727] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6675),
    [sym__binary_star] = ACTIONS(6677),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(6679),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(6677),
    [anon_sym_AMP] = ACTIONS(6681),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(6693),
    [anon_sym_GT_GT] = ACTIONS(6693),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(6699),
    [anon_sym_PLUS] = ACTIONS(6675),
    [anon_sym_SLASH] = ACTIONS(6677),
    [anon_sym_PERCENT] = ACTIONS(6677),
    [sym_comment] = ACTIONS(87),
  },
  [6728] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(12563),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [6729] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(6675),
    [sym__binary_star] = ACTIONS(6677),
    [anon_sym_RBRACE] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(6679),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(6677),
    [anon_sym_AMP] = ACTIONS(6681),
    [anon_sym_LT] = ACTIONS(6683),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_EQ_GT] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(6687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6689),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(6691),
    [anon_sym_AMP_AMP] = ACTIONS(6691),
    [anon_sym_LT_LT] = ACTIONS(6693),
    [anon_sym_GT_GT] = ACTIONS(6693),
    [anon_sym_EQ_EQ] = ACTIONS(6695),
    [anon_sym_BANG_EQ] = ACTIONS(6691),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6691),
    [anon_sym_LT_EQ_GT] = ACTIONS(6691),
    [anon_sym_EQ_TILDE] = ACTIONS(6691),
    [anon_sym_BANG_TILDE] = ACTIONS(6691),
    [anon_sym_LT_EQ] = ACTIONS(6683),
    [anon_sym_GT] = ACTIONS(6683),
    [anon_sym_GT_EQ] = ACTIONS(6697),
    [anon_sym_CARET] = ACTIONS(6699),
    [anon_sym_PLUS] = ACTIONS(6675),
    [anon_sym_SLASH] = ACTIONS(6677),
    [anon_sym_PERCENT] = ACTIONS(6677),
    [sym_comment] = ACTIONS(87),
  },
  [6730] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6675),
    [sym__binary_star] = ACTIONS(6677),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(6679),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(6677),
    [anon_sym_AMP] = ACTIONS(6681),
    [anon_sym_LT] = ACTIONS(6683),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(6685),
    [anon_sym_DOT_DOT] = ACTIONS(6687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6689),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(6691),
    [anon_sym_AMP_AMP] = ACTIONS(6691),
    [anon_sym_LT_LT] = ACTIONS(6693),
    [anon_sym_GT_GT] = ACTIONS(6693),
    [anon_sym_EQ_EQ] = ACTIONS(6695),
    [anon_sym_BANG_EQ] = ACTIONS(6691),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6691),
    [anon_sym_LT_EQ_GT] = ACTIONS(6691),
    [anon_sym_EQ_TILDE] = ACTIONS(6691),
    [anon_sym_BANG_TILDE] = ACTIONS(6691),
    [anon_sym_LT_EQ] = ACTIONS(6683),
    [anon_sym_GT] = ACTIONS(6683),
    [anon_sym_GT_EQ] = ACTIONS(6697),
    [anon_sym_CARET] = ACTIONS(6699),
    [anon_sym_PLUS] = ACTIONS(6675),
    [anon_sym_SLASH] = ACTIONS(6677),
    [anon_sym_PERCENT] = ACTIONS(6677),
    [sym_comment] = ACTIONS(87),
  },
  [6731] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6675),
    [sym__binary_star] = ACTIONS(6677),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(6679),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(6677),
    [anon_sym_AMP] = ACTIONS(6681),
    [anon_sym_LT] = ACTIONS(6683),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(6693),
    [anon_sym_GT_GT] = ACTIONS(6693),
    [anon_sym_EQ_EQ] = ACTIONS(6695),
    [anon_sym_BANG_EQ] = ACTIONS(6691),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6691),
    [anon_sym_LT_EQ_GT] = ACTIONS(6691),
    [anon_sym_EQ_TILDE] = ACTIONS(6691),
    [anon_sym_BANG_TILDE] = ACTIONS(6691),
    [anon_sym_LT_EQ] = ACTIONS(6683),
    [anon_sym_GT] = ACTIONS(6683),
    [anon_sym_GT_EQ] = ACTIONS(6697),
    [anon_sym_CARET] = ACTIONS(6699),
    [anon_sym_PLUS] = ACTIONS(6675),
    [anon_sym_SLASH] = ACTIONS(6677),
    [anon_sym_PERCENT] = ACTIONS(6677),
    [sym_comment] = ACTIONS(87),
  },
  [6732] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6675),
    [sym__binary_star] = ACTIONS(6677),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(6677),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(6675),
    [anon_sym_SLASH] = ACTIONS(6677),
    [anon_sym_PERCENT] = ACTIONS(6677),
    [sym_comment] = ACTIONS(87),
  },
  [6733] = {
    [sym_heredoc_body] = STATE(6733),
    [aux_sym_call_repeat1] = STATE(6733),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(7916),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_RBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [6734] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1721),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1725),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1725),
    [sym__argument] = STATE(4986),
    [sym_splat_argument] = STATE(4986),
    [sym_hash_splat_argument] = STATE(4986),
    [sym_block_argument] = STATE(4986),
    [sym_assignment] = STATE(1721),
    [sym_operator_assignment] = STATE(1721),
    [sym_conditional] = STATE(1721),
    [sym_range] = STATE(1721),
    [sym_binary] = STATE(1721),
    [sym_unary] = STATE(1721),
    [sym_left_assignment_list] = STATE(1724),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1725),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1725),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1726),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4986),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(3107),
    [sym__splat_star] = ACTIONS(3109),
    [sym__unary_minus] = ACTIONS(3111),
    [sym__identifier_hash_key] = ACTIONS(3113),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10255),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6669),
    [anon_sym_defined_QMARK] = ACTIONS(3123),
    [anon_sym_not] = ACTIONS(3125),
    [anon_sym_BANG] = ACTIONS(3129),
    [anon_sym_TILDE] = ACTIONS(3129),
    [sym_constant] = ACTIONS(3131),
    [sym_identifier] = ACTIONS(3131),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6735] = {
    [sym_heredoc_body] = STATE(6733),
    [aux_sym_call_repeat1] = STATE(6733),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_RBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [6736] = {
    [aux_sym_argument_list_repeat1] = STATE(6736),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_RBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(12565),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7925),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_if] = ACTIONS(7925),
    [anon_sym_unless] = ACTIONS(7925),
    [anon_sym_while] = ACTIONS(7925),
    [anon_sym_until] = ACTIONS(7925),
    [anon_sym_rescue] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7925),
    [anon_sym_AMP_AMP] = ACTIONS(7925),
    [anon_sym_LT_LT] = ACTIONS(7925),
    [anon_sym_GT_GT] = ACTIONS(7925),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7925),
    [anon_sym_PLUS] = ACTIONS(7925),
    [anon_sym_SLASH] = ACTIONS(7925),
    [anon_sym_PERCENT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [6737] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(6675),
    [sym__binary_star] = ACTIONS(6677),
    [anon_sym_RBRACE] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(6679),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(6677),
    [anon_sym_AMP] = ACTIONS(6681),
    [anon_sym_LT] = ACTIONS(6683),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_EQ_GT] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(6685),
    [anon_sym_DOT_DOT] = ACTIONS(6687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6689),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(6691),
    [anon_sym_AMP_AMP] = ACTIONS(6691),
    [anon_sym_LT_LT] = ACTIONS(6693),
    [anon_sym_GT_GT] = ACTIONS(6693),
    [anon_sym_EQ_EQ] = ACTIONS(6695),
    [anon_sym_BANG_EQ] = ACTIONS(6691),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6691),
    [anon_sym_LT_EQ_GT] = ACTIONS(6691),
    [anon_sym_EQ_TILDE] = ACTIONS(6691),
    [anon_sym_BANG_TILDE] = ACTIONS(6691),
    [anon_sym_LT_EQ] = ACTIONS(6683),
    [anon_sym_GT] = ACTIONS(6683),
    [anon_sym_GT_EQ] = ACTIONS(6697),
    [anon_sym_CARET] = ACTIONS(6699),
    [anon_sym_PLUS] = ACTIONS(6675),
    [anon_sym_SLASH] = ACTIONS(6677),
    [anon_sym_PERCENT] = ACTIONS(6677),
    [sym_comment] = ACTIONS(87),
  },
  [6738] = {
    [aux_sym_exceptions_repeat1] = STATE(8925),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_RBRACE] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [6739] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(6675),
    [sym__binary_star] = ACTIONS(6677),
    [anon_sym_RBRACE] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(6679),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(6677),
    [anon_sym_AMP] = ACTIONS(6681),
    [anon_sym_LT] = ACTIONS(6683),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_EQ_GT] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(6685),
    [anon_sym_DOT_DOT] = ACTIONS(6687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6689),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(6691),
    [anon_sym_AMP_AMP] = ACTIONS(6691),
    [anon_sym_LT_LT] = ACTIONS(6693),
    [anon_sym_GT_GT] = ACTIONS(6693),
    [anon_sym_EQ_EQ] = ACTIONS(6695),
    [anon_sym_BANG_EQ] = ACTIONS(6691),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6691),
    [anon_sym_LT_EQ_GT] = ACTIONS(6691),
    [anon_sym_EQ_TILDE] = ACTIONS(6691),
    [anon_sym_BANG_TILDE] = ACTIONS(6691),
    [anon_sym_LT_EQ] = ACTIONS(6683),
    [anon_sym_GT] = ACTIONS(6683),
    [anon_sym_GT_EQ] = ACTIONS(6697),
    [anon_sym_CARET] = ACTIONS(6699),
    [anon_sym_PLUS] = ACTIONS(6675),
    [anon_sym_SLASH] = ACTIONS(6677),
    [anon_sym_PERCENT] = ACTIONS(6677),
    [sym_comment] = ACTIONS(87),
  },
  [6740] = {
    [sym_string] = STATE(6740),
    [aux_sym_chained_string_repeat1] = STATE(6740),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(6214),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_RBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_EQ_GT] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [6741] = {
    [aux_sym_undef_repeat1] = STATE(6741),
    [sym__line_break] = ACTIONS(9263),
    [sym__heredoc_body_start] = ACTIONS(9263),
    [anon_sym_RBRACE] = ACTIONS(9263),
    [anon_sym_COMMA] = ACTIONS(9265),
    [anon_sym_SEMI] = ACTIONS(9263),
    [anon_sym_if] = ACTIONS(9263),
    [anon_sym_unless] = ACTIONS(9263),
    [anon_sym_while] = ACTIONS(9263),
    [anon_sym_until] = ACTIONS(9263),
    [anon_sym_rescue] = ACTIONS(9263),
    [sym_comment] = ACTIONS(87),
  },
  [6742] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8926),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(8926),
    [sym_operator_assignment] = STATE(8926),
    [sym_conditional] = STATE(8926),
    [sym_range] = STATE(8926),
    [sym_binary] = STATE(8926),
    [sym_unary] = STATE(8926),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6743] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(10265),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [6744] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(10259),
    [sym__binary_star] = ACTIONS(10261),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(10263),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(10265),
    [anon_sym_AMP] = ACTIONS(10267),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(10269),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(10271),
    [anon_sym_DOT_DOT] = ACTIONS(10273),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10275),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(10277),
    [anon_sym_AMP_AMP] = ACTIONS(10277),
    [anon_sym_LT_LT] = ACTIONS(10279),
    [anon_sym_GT_GT] = ACTIONS(10279),
    [anon_sym_EQ_EQ] = ACTIONS(10277),
    [anon_sym_BANG_EQ] = ACTIONS(10281),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10281),
    [anon_sym_LT_EQ_GT] = ACTIONS(10281),
    [anon_sym_EQ_TILDE] = ACTIONS(10281),
    [anon_sym_BANG_TILDE] = ACTIONS(10281),
    [anon_sym_LT_EQ] = ACTIONS(10269),
    [anon_sym_GT] = ACTIONS(10269),
    [anon_sym_GT_EQ] = ACTIONS(10283),
    [anon_sym_CARET] = ACTIONS(10263),
    [anon_sym_PLUS] = ACTIONS(10285),
    [anon_sym_SLASH] = ACTIONS(10265),
    [anon_sym_PERCENT] = ACTIONS(10265),
    [sym_comment] = ACTIONS(87),
  },
  [6745] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(8927),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(4062),
    [sym_scope_resolution] = STATE(4060),
    [sym_call] = STATE(4060),
    [sym_method_call] = STATE(4062),
    [sym_assignment] = STATE(8927),
    [sym_operator_assignment] = STATE(8927),
    [sym_conditional] = STATE(8927),
    [sym_range] = STATE(8927),
    [sym_binary] = STATE(8927),
    [sym_unary] = STATE(8927),
    [sym_left_assignment_list] = STATE(4061),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4062),
    [sym__variable] = STATE(4060),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(4062),
    [sym_false] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(4063),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(6713),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(6715),
    [anon_sym_yield] = ACTIONS(6717),
    [anon_sym_break] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6721),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(6723),
    [anon_sym_defined_QMARK] = ACTIONS(6725),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6731),
    [sym_identifier] = ACTIONS(6731),
    [sym_instance_variable] = ACTIONS(6733),
    [sym_class_variable] = ACTIONS(6733),
    [sym_global_variable] = ACTIONS(6733),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(6731),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6731),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [6746] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(8928),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(4062),
    [sym_scope_resolution] = STATE(4060),
    [sym_call] = STATE(4060),
    [sym_method_call] = STATE(4062),
    [sym_assignment] = STATE(8928),
    [sym_operator_assignment] = STATE(8928),
    [sym_conditional] = STATE(8928),
    [sym_range] = STATE(8928),
    [sym_binary] = STATE(8928),
    [sym_unary] = STATE(8928),
    [sym_left_assignment_list] = STATE(4061),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4062),
    [sym__variable] = STATE(4060),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(4062),
    [sym_false] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(4063),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(6713),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(6715),
    [anon_sym_yield] = ACTIONS(6717),
    [anon_sym_break] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6721),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(6723),
    [anon_sym_defined_QMARK] = ACTIONS(6725),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6731),
    [sym_identifier] = ACTIONS(6731),
    [sym_instance_variable] = ACTIONS(6733),
    [sym_class_variable] = ACTIONS(6733),
    [sym_global_variable] = ACTIONS(6733),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(6731),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6731),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [6747] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(8929),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(4062),
    [sym_scope_resolution] = STATE(4060),
    [sym_call] = STATE(4060),
    [sym_method_call] = STATE(4062),
    [sym_assignment] = STATE(8929),
    [sym_operator_assignment] = STATE(8929),
    [sym_conditional] = STATE(8929),
    [sym_range] = STATE(8929),
    [sym_binary] = STATE(8929),
    [sym_unary] = STATE(8929),
    [sym_left_assignment_list] = STATE(4061),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4062),
    [sym__variable] = STATE(4060),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(4062),
    [sym_false] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(4063),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(6713),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(6715),
    [anon_sym_yield] = ACTIONS(6717),
    [anon_sym_break] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6721),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(6723),
    [anon_sym_defined_QMARK] = ACTIONS(6725),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6731),
    [sym_identifier] = ACTIONS(6731),
    [sym_instance_variable] = ACTIONS(6733),
    [sym_class_variable] = ACTIONS(6733),
    [sym_global_variable] = ACTIONS(6733),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(6731),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6731),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [6748] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(8930),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(4062),
    [sym_scope_resolution] = STATE(4060),
    [sym_call] = STATE(4060),
    [sym_method_call] = STATE(4062),
    [sym_assignment] = STATE(8930),
    [sym_operator_assignment] = STATE(8930),
    [sym_conditional] = STATE(8930),
    [sym_range] = STATE(8930),
    [sym_binary] = STATE(8930),
    [sym_unary] = STATE(8930),
    [sym_left_assignment_list] = STATE(4061),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4062),
    [sym__variable] = STATE(4060),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(4062),
    [sym_false] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(4063),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(6713),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(6715),
    [anon_sym_yield] = ACTIONS(6717),
    [anon_sym_break] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6721),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(6723),
    [anon_sym_defined_QMARK] = ACTIONS(6725),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6731),
    [sym_identifier] = ACTIONS(6731),
    [sym_instance_variable] = ACTIONS(6733),
    [sym_class_variable] = ACTIONS(6733),
    [sym_global_variable] = ACTIONS(6733),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(6731),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6731),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [6749] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(8931),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(4062),
    [sym_scope_resolution] = STATE(4060),
    [sym_call] = STATE(4060),
    [sym_method_call] = STATE(4062),
    [sym_assignment] = STATE(8931),
    [sym_operator_assignment] = STATE(8931),
    [sym_conditional] = STATE(8931),
    [sym_range] = STATE(8931),
    [sym_binary] = STATE(8931),
    [sym_unary] = STATE(8931),
    [sym_left_assignment_list] = STATE(4061),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4062),
    [sym__variable] = STATE(4060),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(4062),
    [sym_false] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(4063),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(6713),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(6715),
    [anon_sym_yield] = ACTIONS(6717),
    [anon_sym_break] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6721),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(6723),
    [anon_sym_defined_QMARK] = ACTIONS(6725),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6731),
    [sym_identifier] = ACTIONS(6731),
    [sym_instance_variable] = ACTIONS(6733),
    [sym_class_variable] = ACTIONS(6733),
    [sym_global_variable] = ACTIONS(6733),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(6731),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6731),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [6750] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(8932),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(8932),
    [sym_operator_assignment] = STATE(8932),
    [sym_conditional] = STATE(8932),
    [sym_range] = STATE(8932),
    [sym_binary] = STATE(8932),
    [sym_unary] = STATE(8932),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6751] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(8933),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(4062),
    [sym_scope_resolution] = STATE(4060),
    [sym_call] = STATE(4060),
    [sym_method_call] = STATE(4062),
    [sym_assignment] = STATE(8933),
    [sym_operator_assignment] = STATE(8933),
    [sym_conditional] = STATE(8933),
    [sym_range] = STATE(8933),
    [sym_binary] = STATE(8933),
    [sym_unary] = STATE(8933),
    [sym_left_assignment_list] = STATE(4061),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4062),
    [sym__variable] = STATE(4060),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(4062),
    [sym_false] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(4063),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(6713),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(6715),
    [anon_sym_yield] = ACTIONS(6717),
    [anon_sym_break] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6721),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(6723),
    [anon_sym_defined_QMARK] = ACTIONS(6725),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6731),
    [sym_identifier] = ACTIONS(6731),
    [sym_instance_variable] = ACTIONS(6733),
    [sym_class_variable] = ACTIONS(6733),
    [sym_global_variable] = ACTIONS(6733),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(6731),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6731),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [6752] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(8934),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(4062),
    [sym_scope_resolution] = STATE(4060),
    [sym_call] = STATE(4060),
    [sym_method_call] = STATE(4062),
    [sym_assignment] = STATE(8934),
    [sym_operator_assignment] = STATE(8934),
    [sym_conditional] = STATE(8934),
    [sym_range] = STATE(8934),
    [sym_binary] = STATE(8934),
    [sym_unary] = STATE(8934),
    [sym_left_assignment_list] = STATE(4061),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4062),
    [sym__variable] = STATE(4060),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(4062),
    [sym_false] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(4063),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(6713),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(6715),
    [anon_sym_yield] = ACTIONS(6717),
    [anon_sym_break] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6721),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(6723),
    [anon_sym_defined_QMARK] = ACTIONS(6725),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6731),
    [sym_identifier] = ACTIONS(6731),
    [sym_instance_variable] = ACTIONS(6733),
    [sym_class_variable] = ACTIONS(6733),
    [sym_global_variable] = ACTIONS(6733),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(6731),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6731),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [6753] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(8935),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(4062),
    [sym_scope_resolution] = STATE(4060),
    [sym_call] = STATE(4060),
    [sym_method_call] = STATE(4062),
    [sym_assignment] = STATE(8935),
    [sym_operator_assignment] = STATE(8935),
    [sym_conditional] = STATE(8935),
    [sym_range] = STATE(8935),
    [sym_binary] = STATE(8935),
    [sym_unary] = STATE(8935),
    [sym_left_assignment_list] = STATE(4061),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4062),
    [sym__variable] = STATE(4060),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(4062),
    [sym_false] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(4063),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(6713),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(6715),
    [anon_sym_yield] = ACTIONS(6717),
    [anon_sym_break] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6721),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(6723),
    [anon_sym_defined_QMARK] = ACTIONS(6725),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6731),
    [sym_identifier] = ACTIONS(6731),
    [sym_instance_variable] = ACTIONS(6733),
    [sym_class_variable] = ACTIONS(6733),
    [sym_global_variable] = ACTIONS(6733),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(6731),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6731),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [6754] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(8936),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(4062),
    [sym_scope_resolution] = STATE(4060),
    [sym_call] = STATE(4060),
    [sym_method_call] = STATE(4062),
    [sym_assignment] = STATE(8936),
    [sym_operator_assignment] = STATE(8936),
    [sym_conditional] = STATE(8936),
    [sym_range] = STATE(8936),
    [sym_binary] = STATE(8936),
    [sym_unary] = STATE(8936),
    [sym_left_assignment_list] = STATE(4061),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4062),
    [sym__variable] = STATE(4060),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(4062),
    [sym_false] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(4063),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(6713),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(6715),
    [anon_sym_yield] = ACTIONS(6717),
    [anon_sym_break] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6721),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(6723),
    [anon_sym_defined_QMARK] = ACTIONS(6725),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6731),
    [sym_identifier] = ACTIONS(6731),
    [sym_instance_variable] = ACTIONS(6733),
    [sym_class_variable] = ACTIONS(6733),
    [sym_global_variable] = ACTIONS(6733),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(6731),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6731),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [6755] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(8937),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(4062),
    [sym_scope_resolution] = STATE(4060),
    [sym_call] = STATE(4060),
    [sym_method_call] = STATE(4062),
    [sym_splat_argument] = STATE(8938),
    [sym_assignment] = STATE(8937),
    [sym_operator_assignment] = STATE(8937),
    [sym_conditional] = STATE(8937),
    [sym_range] = STATE(8937),
    [sym_binary] = STATE(8937),
    [sym_unary] = STATE(8937),
    [sym_right_assignment_list] = STATE(6323),
    [sym__arg_or_splat_arg] = STATE(8938),
    [sym_left_assignment_list] = STATE(4061),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4062),
    [sym__variable] = STATE(4060),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(4062),
    [sym_false] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(4063),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__splat_star] = ACTIONS(3177),
    [sym__unary_minus] = ACTIONS(6713),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(6715),
    [anon_sym_yield] = ACTIONS(6717),
    [anon_sym_break] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6721),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(6723),
    [anon_sym_defined_QMARK] = ACTIONS(6725),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6731),
    [sym_identifier] = ACTIONS(6731),
    [sym_instance_variable] = ACTIONS(6733),
    [sym_class_variable] = ACTIONS(6733),
    [sym_global_variable] = ACTIONS(6733),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(6731),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6731),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [6756] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(8939),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(4062),
    [sym_scope_resolution] = STATE(4060),
    [sym_call] = STATE(4060),
    [sym_method_call] = STATE(4062),
    [sym_assignment] = STATE(8939),
    [sym_operator_assignment] = STATE(8939),
    [sym_conditional] = STATE(8939),
    [sym_range] = STATE(8939),
    [sym_binary] = STATE(8939),
    [sym_unary] = STATE(8939),
    [sym_left_assignment_list] = STATE(4061),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4062),
    [sym__variable] = STATE(4060),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(4062),
    [sym_false] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(4063),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(6713),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(6715),
    [anon_sym_yield] = ACTIONS(6717),
    [anon_sym_break] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6721),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(6723),
    [anon_sym_defined_QMARK] = ACTIONS(6725),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6731),
    [sym_identifier] = ACTIONS(6731),
    [sym_instance_variable] = ACTIONS(6733),
    [sym_class_variable] = ACTIONS(6733),
    [sym_global_variable] = ACTIONS(6733),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(6731),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6731),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [6757] = {
    [sym_string] = STATE(8940),
    [aux_sym_chained_string_repeat1] = STATE(8940),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(2551),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_RBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2755),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_EQ] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_PLUS_EQ] = ACTIONS(2753),
    [anon_sym_DASH_EQ] = ACTIONS(2753),
    [anon_sym_STAR_EQ] = ACTIONS(2753),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2753),
    [anon_sym_SLASH_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2753),
    [anon_sym_AMP_EQ] = ACTIONS(2753),
    [anon_sym_PERCENT_EQ] = ACTIONS(2753),
    [anon_sym_GT_GT_EQ] = ACTIONS(2753),
    [anon_sym_LT_LT_EQ] = ACTIONS(2753),
    [anon_sym_CARET_EQ] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2755),
    [anon_sym_AMP_AMP] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2755),
    [anon_sym_GT_GT] = ACTIONS(2755),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_SLASH] = ACTIONS(2755),
    [anon_sym_PERCENT] = ACTIONS(2755),
    [sym_comment] = ACTIONS(87),
  },
  [6758] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(10259),
    [sym__binary_star] = ACTIONS(10261),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_RBRACE] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(10263),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(10265),
    [anon_sym_AMP] = ACTIONS(10267),
    [anon_sym_EQ] = ACTIONS(7822),
    [anon_sym_LT] = ACTIONS(10269),
    [anon_sym_if] = ACTIONS(6823),
    [anon_sym_unless] = ACTIONS(6823),
    [anon_sym_while] = ACTIONS(6823),
    [anon_sym_until] = ACTIONS(6823),
    [anon_sym_rescue] = ACTIONS(6823),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_PLUS_EQ] = ACTIONS(6823),
    [anon_sym_DASH_EQ] = ACTIONS(6823),
    [anon_sym_STAR_EQ] = ACTIONS(6823),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6823),
    [anon_sym_SLASH_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6823),
    [anon_sym_AMP_EQ] = ACTIONS(6823),
    [anon_sym_PERCENT_EQ] = ACTIONS(6823),
    [anon_sym_GT_GT_EQ] = ACTIONS(6823),
    [anon_sym_LT_LT_EQ] = ACTIONS(6823),
    [anon_sym_CARET_EQ] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(10271),
    [anon_sym_DOT_DOT] = ACTIONS(10273),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10275),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(10277),
    [anon_sym_AMP_AMP] = ACTIONS(10277),
    [anon_sym_LT_LT] = ACTIONS(10279),
    [anon_sym_GT_GT] = ACTIONS(10279),
    [anon_sym_EQ_EQ] = ACTIONS(10277),
    [anon_sym_BANG_EQ] = ACTIONS(10281),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10281),
    [anon_sym_LT_EQ_GT] = ACTIONS(10281),
    [anon_sym_EQ_TILDE] = ACTIONS(10281),
    [anon_sym_BANG_TILDE] = ACTIONS(10281),
    [anon_sym_LT_EQ] = ACTIONS(10269),
    [anon_sym_GT] = ACTIONS(10269),
    [anon_sym_GT_EQ] = ACTIONS(10283),
    [anon_sym_CARET] = ACTIONS(10263),
    [anon_sym_PLUS] = ACTIONS(10285),
    [anon_sym_SLASH] = ACTIONS(10265),
    [anon_sym_PERCENT] = ACTIONS(10265),
    [sym_comment] = ACTIONS(87),
  },
  [6759] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(10259),
    [sym__binary_star] = ACTIONS(10261),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_RBRACE] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(10263),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(10265),
    [anon_sym_AMP] = ACTIONS(10267),
    [anon_sym_EQ] = ACTIONS(7884),
    [anon_sym_LT] = ACTIONS(10269),
    [anon_sym_if] = ACTIONS(7027),
    [anon_sym_unless] = ACTIONS(7027),
    [anon_sym_while] = ACTIONS(7027),
    [anon_sym_until] = ACTIONS(7027),
    [anon_sym_rescue] = ACTIONS(7027),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_PLUS_EQ] = ACTIONS(7027),
    [anon_sym_DASH_EQ] = ACTIONS(7027),
    [anon_sym_STAR_EQ] = ACTIONS(7027),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7027),
    [anon_sym_SLASH_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7027),
    [anon_sym_AMP_EQ] = ACTIONS(7027),
    [anon_sym_PERCENT_EQ] = ACTIONS(7027),
    [anon_sym_GT_GT_EQ] = ACTIONS(7027),
    [anon_sym_LT_LT_EQ] = ACTIONS(7027),
    [anon_sym_CARET_EQ] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(10271),
    [anon_sym_DOT_DOT] = ACTIONS(10273),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10275),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(10277),
    [anon_sym_AMP_AMP] = ACTIONS(10277),
    [anon_sym_LT_LT] = ACTIONS(10279),
    [anon_sym_GT_GT] = ACTIONS(10279),
    [anon_sym_EQ_EQ] = ACTIONS(10277),
    [anon_sym_BANG_EQ] = ACTIONS(10281),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10281),
    [anon_sym_LT_EQ_GT] = ACTIONS(10281),
    [anon_sym_EQ_TILDE] = ACTIONS(10281),
    [anon_sym_BANG_TILDE] = ACTIONS(10281),
    [anon_sym_LT_EQ] = ACTIONS(10269),
    [anon_sym_GT] = ACTIONS(10269),
    [anon_sym_GT_EQ] = ACTIONS(10283),
    [anon_sym_CARET] = ACTIONS(10263),
    [anon_sym_PLUS] = ACTIONS(10285),
    [anon_sym_SLASH] = ACTIONS(10265),
    [anon_sym_PERCENT] = ACTIONS(10265),
    [sym_comment] = ACTIONS(87),
  },
  [6760] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(6743),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(6747),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(6747),
    [anon_sym_PERCENT] = ACTIONS(6747),
    [sym_comment] = ACTIONS(87),
  },
  [6761] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(6747),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(5827),
    [anon_sym_PERCENT] = ACTIONS(5827),
    [sym_comment] = ACTIONS(87),
  },
  [6762] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6741),
    [sym__binary_star] = ACTIONS(6743),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(6747),
    [anon_sym_AMP] = ACTIONS(6749),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(6761),
    [anon_sym_GT_GT] = ACTIONS(6761),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(6767),
    [anon_sym_SLASH] = ACTIONS(6747),
    [anon_sym_PERCENT] = ACTIONS(6747),
    [sym_comment] = ACTIONS(87),
  },
  [6763] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6741),
    [sym__binary_star] = ACTIONS(6743),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(6747),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(6761),
    [anon_sym_GT_GT] = ACTIONS(6761),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(6767),
    [anon_sym_SLASH] = ACTIONS(6747),
    [anon_sym_PERCENT] = ACTIONS(6747),
    [sym_comment] = ACTIONS(87),
  },
  [6764] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6741),
    [sym__binary_star] = ACTIONS(6743),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(6747),
    [anon_sym_AMP] = ACTIONS(6749),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(6761),
    [anon_sym_GT_GT] = ACTIONS(6761),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6767),
    [anon_sym_SLASH] = ACTIONS(6747),
    [anon_sym_PERCENT] = ACTIONS(6747),
    [sym_comment] = ACTIONS(87),
  },
  [6765] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(12568),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [6766] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(6741),
    [sym__binary_star] = ACTIONS(6743),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_RBRACE] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(6747),
    [anon_sym_AMP] = ACTIONS(6749),
    [anon_sym_EQ] = ACTIONS(7888),
    [anon_sym_LT] = ACTIONS(6751),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_EQ_GT] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_PLUS_EQ] = ACTIONS(5927),
    [anon_sym_DASH_EQ] = ACTIONS(5927),
    [anon_sym_STAR_EQ] = ACTIONS(5927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5927),
    [anon_sym_SLASH_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5927),
    [anon_sym_AMP_EQ] = ACTIONS(5927),
    [anon_sym_PERCENT_EQ] = ACTIONS(5927),
    [anon_sym_GT_GT_EQ] = ACTIONS(5927),
    [anon_sym_LT_LT_EQ] = ACTIONS(5927),
    [anon_sym_CARET_EQ] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(6755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6757),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(6759),
    [anon_sym_AMP_AMP] = ACTIONS(6759),
    [anon_sym_LT_LT] = ACTIONS(6761),
    [anon_sym_GT_GT] = ACTIONS(6761),
    [anon_sym_EQ_EQ] = ACTIONS(6759),
    [anon_sym_BANG_EQ] = ACTIONS(6763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6763),
    [anon_sym_LT_EQ_GT] = ACTIONS(6763),
    [anon_sym_EQ_TILDE] = ACTIONS(6763),
    [anon_sym_BANG_TILDE] = ACTIONS(6763),
    [anon_sym_LT_EQ] = ACTIONS(6751),
    [anon_sym_GT] = ACTIONS(6751),
    [anon_sym_GT_EQ] = ACTIONS(6765),
    [anon_sym_CARET] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6767),
    [anon_sym_SLASH] = ACTIONS(6747),
    [anon_sym_PERCENT] = ACTIONS(6747),
    [sym_comment] = ACTIONS(87),
  },
  [6767] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6741),
    [sym__binary_star] = ACTIONS(6743),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(6747),
    [anon_sym_AMP] = ACTIONS(6749),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(6751),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(6753),
    [anon_sym_DOT_DOT] = ACTIONS(6755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6757),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(6759),
    [anon_sym_AMP_AMP] = ACTIONS(6759),
    [anon_sym_LT_LT] = ACTIONS(6761),
    [anon_sym_GT_GT] = ACTIONS(6761),
    [anon_sym_EQ_EQ] = ACTIONS(6759),
    [anon_sym_BANG_EQ] = ACTIONS(6763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6763),
    [anon_sym_LT_EQ_GT] = ACTIONS(6763),
    [anon_sym_EQ_TILDE] = ACTIONS(6763),
    [anon_sym_BANG_TILDE] = ACTIONS(6763),
    [anon_sym_LT_EQ] = ACTIONS(6751),
    [anon_sym_GT] = ACTIONS(6751),
    [anon_sym_GT_EQ] = ACTIONS(6765),
    [anon_sym_CARET] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6767),
    [anon_sym_SLASH] = ACTIONS(6747),
    [anon_sym_PERCENT] = ACTIONS(6747),
    [sym_comment] = ACTIONS(87),
  },
  [6768] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6741),
    [sym__binary_star] = ACTIONS(6743),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(6747),
    [anon_sym_AMP] = ACTIONS(6749),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(6751),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(6761),
    [anon_sym_GT_GT] = ACTIONS(6761),
    [anon_sym_EQ_EQ] = ACTIONS(6759),
    [anon_sym_BANG_EQ] = ACTIONS(6763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6763),
    [anon_sym_LT_EQ_GT] = ACTIONS(6763),
    [anon_sym_EQ_TILDE] = ACTIONS(6763),
    [anon_sym_BANG_TILDE] = ACTIONS(6763),
    [anon_sym_LT_EQ] = ACTIONS(6751),
    [anon_sym_GT] = ACTIONS(6751),
    [anon_sym_GT_EQ] = ACTIONS(6765),
    [anon_sym_CARET] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6767),
    [anon_sym_SLASH] = ACTIONS(6747),
    [anon_sym_PERCENT] = ACTIONS(6747),
    [sym_comment] = ACTIONS(87),
  },
  [6769] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6741),
    [sym__binary_star] = ACTIONS(6743),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(6747),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(6767),
    [anon_sym_SLASH] = ACTIONS(6747),
    [anon_sym_PERCENT] = ACTIONS(6747),
    [sym_comment] = ACTIONS(87),
  },
  [6770] = {
    [sym_heredoc_body] = STATE(6770),
    [aux_sym_call_repeat1] = STATE(6770),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(9846),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_RBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7919),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_EQ] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_PLUS_EQ] = ACTIONS(7914),
    [anon_sym_DASH_EQ] = ACTIONS(7914),
    [anon_sym_STAR_EQ] = ACTIONS(7914),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7914),
    [anon_sym_SLASH_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7914),
    [anon_sym_AMP_EQ] = ACTIONS(7914),
    [anon_sym_PERCENT_EQ] = ACTIONS(7914),
    [anon_sym_GT_GT_EQ] = ACTIONS(7914),
    [anon_sym_LT_LT_EQ] = ACTIONS(7914),
    [anon_sym_CARET_EQ] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7919),
    [anon_sym_AMP_AMP] = ACTIONS(7919),
    [anon_sym_LT_LT] = ACTIONS(7919),
    [anon_sym_GT_GT] = ACTIONS(7919),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7919),
    [anon_sym_PLUS] = ACTIONS(7919),
    [anon_sym_SLASH] = ACTIONS(7919),
    [anon_sym_PERCENT] = ACTIONS(7919),
    [sym_comment] = ACTIONS(87),
  },
  [6771] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(1757),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1762),
    [sym_scope_resolution] = STATE(1758),
    [sym_call] = STATE(1758),
    [sym_method_call] = STATE(1762),
    [sym__argument] = STATE(6393),
    [sym_splat_argument] = STATE(6393),
    [sym_hash_splat_argument] = STATE(6393),
    [sym_block_argument] = STATE(6393),
    [sym_assignment] = STATE(1757),
    [sym_operator_assignment] = STATE(1757),
    [sym_conditional] = STATE(1757),
    [sym_range] = STATE(1757),
    [sym_binary] = STATE(1757),
    [sym_unary] = STATE(1757),
    [sym_left_assignment_list] = STATE(1761),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1762),
    [sym__variable] = STATE(1758),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1762),
    [sym_false] = STATE(1762),
    [sym_nil] = STATE(1762),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(1763),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(6393),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(3175),
    [sym__splat_star] = ACTIONS(3177),
    [sym__unary_minus] = ACTIONS(3179),
    [sym__identifier_hash_key] = ACTIONS(3181),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10293),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(3183),
    [anon_sym_yield] = ACTIONS(3185),
    [anon_sym_break] = ACTIONS(3187),
    [anon_sym_next] = ACTIONS(3189),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(6735),
    [anon_sym_defined_QMARK] = ACTIONS(3191),
    [anon_sym_not] = ACTIONS(3193),
    [anon_sym_BANG] = ACTIONS(3197),
    [anon_sym_TILDE] = ACTIONS(3197),
    [sym_constant] = ACTIONS(3199),
    [sym_identifier] = ACTIONS(3199),
    [sym_instance_variable] = ACTIONS(3201),
    [sym_class_variable] = ACTIONS(3201),
    [sym_global_variable] = ACTIONS(3201),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(3203),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(3203),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [6772] = {
    [sym_heredoc_body] = STATE(6770),
    [aux_sym_call_repeat1] = STATE(6770),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_RBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7931),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_EQ] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_PLUS_EQ] = ACTIONS(7929),
    [anon_sym_DASH_EQ] = ACTIONS(7929),
    [anon_sym_STAR_EQ] = ACTIONS(7929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7929),
    [anon_sym_SLASH_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7929),
    [anon_sym_AMP_EQ] = ACTIONS(7929),
    [anon_sym_PERCENT_EQ] = ACTIONS(7929),
    [anon_sym_GT_GT_EQ] = ACTIONS(7929),
    [anon_sym_LT_LT_EQ] = ACTIONS(7929),
    [anon_sym_CARET_EQ] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7931),
    [anon_sym_AMP_AMP] = ACTIONS(7931),
    [anon_sym_LT_LT] = ACTIONS(7931),
    [anon_sym_GT_GT] = ACTIONS(7931),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7931),
    [anon_sym_PLUS] = ACTIONS(7931),
    [anon_sym_SLASH] = ACTIONS(7931),
    [anon_sym_PERCENT] = ACTIONS(7931),
    [sym_comment] = ACTIONS(87),
  },
  [6773] = {
    [aux_sym_argument_list_repeat1] = STATE(6773),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_RBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(12570),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7927),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_EQ] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_if] = ACTIONS(7925),
    [anon_sym_unless] = ACTIONS(7925),
    [anon_sym_while] = ACTIONS(7925),
    [anon_sym_until] = ACTIONS(7925),
    [anon_sym_rescue] = ACTIONS(7925),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_PLUS_EQ] = ACTIONS(7925),
    [anon_sym_DASH_EQ] = ACTIONS(7925),
    [anon_sym_STAR_EQ] = ACTIONS(7925),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7925),
    [anon_sym_SLASH_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7925),
    [anon_sym_AMP_EQ] = ACTIONS(7925),
    [anon_sym_PERCENT_EQ] = ACTIONS(7925),
    [anon_sym_GT_GT_EQ] = ACTIONS(7925),
    [anon_sym_LT_LT_EQ] = ACTIONS(7925),
    [anon_sym_CARET_EQ] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7927),
    [anon_sym_AMP_AMP] = ACTIONS(7927),
    [anon_sym_LT_LT] = ACTIONS(7927),
    [anon_sym_GT_GT] = ACTIONS(7927),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7927),
    [anon_sym_PLUS] = ACTIONS(7927),
    [anon_sym_SLASH] = ACTIONS(7927),
    [anon_sym_PERCENT] = ACTIONS(7927),
    [sym_comment] = ACTIONS(87),
  },
  [6774] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(6741),
    [sym__binary_star] = ACTIONS(6743),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_RBRACE] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(6747),
    [anon_sym_AMP] = ACTIONS(6749),
    [anon_sym_EQ] = ACTIONS(7936),
    [anon_sym_LT] = ACTIONS(6751),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_EQ_GT] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_PLUS_EQ] = ACTIONS(5115),
    [anon_sym_DASH_EQ] = ACTIONS(5115),
    [anon_sym_STAR_EQ] = ACTIONS(5115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5115),
    [anon_sym_SLASH_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5115),
    [anon_sym_AMP_EQ] = ACTIONS(5115),
    [anon_sym_PERCENT_EQ] = ACTIONS(5115),
    [anon_sym_GT_GT_EQ] = ACTIONS(5115),
    [anon_sym_LT_LT_EQ] = ACTIONS(5115),
    [anon_sym_CARET_EQ] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(6753),
    [anon_sym_DOT_DOT] = ACTIONS(6755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6757),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(6759),
    [anon_sym_AMP_AMP] = ACTIONS(6759),
    [anon_sym_LT_LT] = ACTIONS(6761),
    [anon_sym_GT_GT] = ACTIONS(6761),
    [anon_sym_EQ_EQ] = ACTIONS(6759),
    [anon_sym_BANG_EQ] = ACTIONS(6763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6763),
    [anon_sym_LT_EQ_GT] = ACTIONS(6763),
    [anon_sym_EQ_TILDE] = ACTIONS(6763),
    [anon_sym_BANG_TILDE] = ACTIONS(6763),
    [anon_sym_LT_EQ] = ACTIONS(6751),
    [anon_sym_GT] = ACTIONS(6751),
    [anon_sym_GT_EQ] = ACTIONS(6765),
    [anon_sym_CARET] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6767),
    [anon_sym_SLASH] = ACTIONS(6747),
    [anon_sym_PERCENT] = ACTIONS(6747),
    [sym_comment] = ACTIONS(87),
  },
  [6775] = {
    [aux_sym_exceptions_repeat1] = STATE(8943),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_RBRACE] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6193),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_PLUS_EQ] = ACTIONS(6191),
    [anon_sym_DASH_EQ] = ACTIONS(6191),
    [anon_sym_STAR_EQ] = ACTIONS(6191),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6191),
    [anon_sym_SLASH_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6191),
    [anon_sym_AMP_EQ] = ACTIONS(6191),
    [anon_sym_PERCENT_EQ] = ACTIONS(6191),
    [anon_sym_GT_GT_EQ] = ACTIONS(6191),
    [anon_sym_LT_LT_EQ] = ACTIONS(6191),
    [anon_sym_CARET_EQ] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6193),
    [anon_sym_AMP_AMP] = ACTIONS(6193),
    [anon_sym_LT_LT] = ACTIONS(6193),
    [anon_sym_GT_GT] = ACTIONS(6193),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6193),
    [anon_sym_PLUS] = ACTIONS(6193),
    [anon_sym_SLASH] = ACTIONS(6193),
    [anon_sym_PERCENT] = ACTIONS(6193),
    [sym_comment] = ACTIONS(87),
  },
  [6776] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(6741),
    [sym__binary_star] = ACTIONS(6743),
    [anon_sym_LBRACE] = ACTIONS(6210),
    [anon_sym_RBRACE] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(6747),
    [anon_sym_AMP] = ACTIONS(6749),
    [anon_sym_EQ] = ACTIONS(7938),
    [anon_sym_LT] = ACTIONS(6751),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_EQ_GT] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_PLUS_EQ] = ACTIONS(6210),
    [anon_sym_DASH_EQ] = ACTIONS(6210),
    [anon_sym_STAR_EQ] = ACTIONS(6210),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6210),
    [anon_sym_SLASH_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6210),
    [anon_sym_AMP_EQ] = ACTIONS(6210),
    [anon_sym_PERCENT_EQ] = ACTIONS(6210),
    [anon_sym_GT_GT_EQ] = ACTIONS(6210),
    [anon_sym_LT_LT_EQ] = ACTIONS(6210),
    [anon_sym_CARET_EQ] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(6753),
    [anon_sym_DOT_DOT] = ACTIONS(6755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6757),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(6759),
    [anon_sym_AMP_AMP] = ACTIONS(6759),
    [anon_sym_LT_LT] = ACTIONS(6761),
    [anon_sym_GT_GT] = ACTIONS(6761),
    [anon_sym_EQ_EQ] = ACTIONS(6759),
    [anon_sym_BANG_EQ] = ACTIONS(6763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6763),
    [anon_sym_LT_EQ_GT] = ACTIONS(6763),
    [anon_sym_EQ_TILDE] = ACTIONS(6763),
    [anon_sym_BANG_TILDE] = ACTIONS(6763),
    [anon_sym_LT_EQ] = ACTIONS(6751),
    [anon_sym_GT] = ACTIONS(6751),
    [anon_sym_GT_EQ] = ACTIONS(6765),
    [anon_sym_CARET] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6767),
    [anon_sym_SLASH] = ACTIONS(6747),
    [anon_sym_PERCENT] = ACTIONS(6747),
    [sym_comment] = ACTIONS(87),
  },
  [6777] = {
    [sym_string] = STATE(6777),
    [aux_sym_chained_string_repeat1] = STATE(6777),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(9852),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_RBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6217),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_EQ] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_do] = ACTIONS(6212),
    [anon_sym_EQ_GT] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_PLUS_EQ] = ACTIONS(6212),
    [anon_sym_DASH_EQ] = ACTIONS(6212),
    [anon_sym_STAR_EQ] = ACTIONS(6212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6212),
    [anon_sym_SLASH_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6212),
    [anon_sym_AMP_EQ] = ACTIONS(6212),
    [anon_sym_PERCENT_EQ] = ACTIONS(6212),
    [anon_sym_GT_GT_EQ] = ACTIONS(6212),
    [anon_sym_LT_LT_EQ] = ACTIONS(6212),
    [anon_sym_CARET_EQ] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6217),
    [anon_sym_AMP_AMP] = ACTIONS(6217),
    [anon_sym_LT_LT] = ACTIONS(6217),
    [anon_sym_GT_GT] = ACTIONS(6217),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6217),
    [anon_sym_PLUS] = ACTIONS(6217),
    [anon_sym_SLASH] = ACTIONS(6217),
    [anon_sym_PERCENT] = ACTIONS(6217),
    [sym_comment] = ACTIONS(87),
  },
  [6778] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(10295),
    [sym__binary_star] = ACTIONS(10297),
    [anon_sym_RBRACE] = ACTIONS(4247),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(10299),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(10297),
    [anon_sym_AMP] = ACTIONS(10301),
    [anon_sym_LT] = ACTIONS(10303),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(10305),
    [anon_sym_DOT_DOT] = ACTIONS(10307),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10309),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(10311),
    [anon_sym_AMP_AMP] = ACTIONS(10311),
    [anon_sym_LT_LT] = ACTIONS(10313),
    [anon_sym_GT_GT] = ACTIONS(10313),
    [anon_sym_EQ_EQ] = ACTIONS(10315),
    [anon_sym_BANG_EQ] = ACTIONS(10311),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10311),
    [anon_sym_LT_EQ_GT] = ACTIONS(10311),
    [anon_sym_EQ_TILDE] = ACTIONS(10311),
    [anon_sym_BANG_TILDE] = ACTIONS(10311),
    [anon_sym_LT_EQ] = ACTIONS(10303),
    [anon_sym_GT] = ACTIONS(10303),
    [anon_sym_GT_EQ] = ACTIONS(10317),
    [anon_sym_CARET] = ACTIONS(10319),
    [anon_sym_PLUS] = ACTIONS(10295),
    [anon_sym_SLASH] = ACTIONS(10297),
    [anon_sym_PERCENT] = ACTIONS(10297),
    [sym_comment] = ACTIONS(87),
  },
  [6779] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(10297),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [6780] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(10295),
    [sym__binary_star] = ACTIONS(10297),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(10299),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(10297),
    [anon_sym_AMP] = ACTIONS(10301),
    [anon_sym_LT] = ACTIONS(10303),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(10305),
    [anon_sym_DOT_DOT] = ACTIONS(10307),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10309),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(10311),
    [anon_sym_AMP_AMP] = ACTIONS(10311),
    [anon_sym_LT_LT] = ACTIONS(10313),
    [anon_sym_GT_GT] = ACTIONS(10313),
    [anon_sym_EQ_EQ] = ACTIONS(10315),
    [anon_sym_BANG_EQ] = ACTIONS(10311),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10311),
    [anon_sym_LT_EQ_GT] = ACTIONS(10311),
    [anon_sym_EQ_TILDE] = ACTIONS(10311),
    [anon_sym_BANG_TILDE] = ACTIONS(10311),
    [anon_sym_LT_EQ] = ACTIONS(10303),
    [anon_sym_GT] = ACTIONS(10303),
    [anon_sym_GT_EQ] = ACTIONS(10317),
    [anon_sym_CARET] = ACTIONS(10319),
    [anon_sym_PLUS] = ACTIONS(10295),
    [anon_sym_SLASH] = ACTIONS(10297),
    [anon_sym_PERCENT] = ACTIONS(10297),
    [sym_comment] = ACTIONS(87),
  },
  [6781] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8944),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(4094),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4094),
    [sym_assignment] = STATE(8944),
    [sym_operator_assignment] = STATE(8944),
    [sym_conditional] = STATE(8944),
    [sym_range] = STATE(8944),
    [sym_binary] = STATE(8944),
    [sym_unary] = STATE(8944),
    [sym_left_assignment_list] = STATE(4093),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4094),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(4094),
    [sym_false] = STATE(4094),
    [sym_nil] = STATE(4094),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(4010),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6781),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6653),
    [anon_sym_yield] = ACTIONS(6655),
    [anon_sym_break] = ACTIONS(6657),
    [anon_sym_next] = ACTIONS(6659),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6783),
    [anon_sym_defined_QMARK] = ACTIONS(6785),
    [anon_sym_not] = ACTIONS(6787),
    [anon_sym_BANG] = ACTIONS(6789),
    [anon_sym_TILDE] = ACTIONS(6789),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6782] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8945),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(4094),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4094),
    [sym_assignment] = STATE(8945),
    [sym_operator_assignment] = STATE(8945),
    [sym_conditional] = STATE(8945),
    [sym_range] = STATE(8945),
    [sym_binary] = STATE(8945),
    [sym_unary] = STATE(8945),
    [sym_left_assignment_list] = STATE(4093),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4094),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(4094),
    [sym_false] = STATE(4094),
    [sym_nil] = STATE(4094),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(4010),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6781),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6653),
    [anon_sym_yield] = ACTIONS(6655),
    [anon_sym_break] = ACTIONS(6657),
    [anon_sym_next] = ACTIONS(6659),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6783),
    [anon_sym_defined_QMARK] = ACTIONS(6785),
    [anon_sym_not] = ACTIONS(6787),
    [anon_sym_BANG] = ACTIONS(6789),
    [anon_sym_TILDE] = ACTIONS(6789),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6783] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8946),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(4094),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4094),
    [sym_assignment] = STATE(8946),
    [sym_operator_assignment] = STATE(8946),
    [sym_conditional] = STATE(8946),
    [sym_range] = STATE(8946),
    [sym_binary] = STATE(8946),
    [sym_unary] = STATE(8946),
    [sym_left_assignment_list] = STATE(4093),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4094),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(4094),
    [sym_false] = STATE(4094),
    [sym_nil] = STATE(4094),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(4010),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6781),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6653),
    [anon_sym_yield] = ACTIONS(6655),
    [anon_sym_break] = ACTIONS(6657),
    [anon_sym_next] = ACTIONS(6659),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6783),
    [anon_sym_defined_QMARK] = ACTIONS(6785),
    [anon_sym_not] = ACTIONS(6787),
    [anon_sym_BANG] = ACTIONS(6789),
    [anon_sym_TILDE] = ACTIONS(6789),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6784] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8947),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(4094),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4094),
    [sym_assignment] = STATE(8947),
    [sym_operator_assignment] = STATE(8947),
    [sym_conditional] = STATE(8947),
    [sym_range] = STATE(8947),
    [sym_binary] = STATE(8947),
    [sym_unary] = STATE(8947),
    [sym_left_assignment_list] = STATE(4093),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4094),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(4094),
    [sym_false] = STATE(4094),
    [sym_nil] = STATE(4094),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(4010),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6781),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6653),
    [anon_sym_yield] = ACTIONS(6655),
    [anon_sym_break] = ACTIONS(6657),
    [anon_sym_next] = ACTIONS(6659),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6783),
    [anon_sym_defined_QMARK] = ACTIONS(6785),
    [anon_sym_not] = ACTIONS(6787),
    [anon_sym_BANG] = ACTIONS(6789),
    [anon_sym_TILDE] = ACTIONS(6789),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6785] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8948),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(4094),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4094),
    [sym_assignment] = STATE(8948),
    [sym_operator_assignment] = STATE(8948),
    [sym_conditional] = STATE(8948),
    [sym_range] = STATE(8948),
    [sym_binary] = STATE(8948),
    [sym_unary] = STATE(8948),
    [sym_left_assignment_list] = STATE(4093),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4094),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(4094),
    [sym_false] = STATE(4094),
    [sym_nil] = STATE(4094),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(4010),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6781),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6653),
    [anon_sym_yield] = ACTIONS(6655),
    [anon_sym_break] = ACTIONS(6657),
    [anon_sym_next] = ACTIONS(6659),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6783),
    [anon_sym_defined_QMARK] = ACTIONS(6785),
    [anon_sym_not] = ACTIONS(6787),
    [anon_sym_BANG] = ACTIONS(6789),
    [anon_sym_TILDE] = ACTIONS(6789),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6786] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(8949),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(8949),
    [sym_operator_assignment] = STATE(8949),
    [sym_conditional] = STATE(8949),
    [sym_range] = STATE(8949),
    [sym_binary] = STATE(8949),
    [sym_unary] = STATE(8949),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6787] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8950),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(4094),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4094),
    [sym_assignment] = STATE(8950),
    [sym_operator_assignment] = STATE(8950),
    [sym_conditional] = STATE(8950),
    [sym_range] = STATE(8950),
    [sym_binary] = STATE(8950),
    [sym_unary] = STATE(8950),
    [sym_left_assignment_list] = STATE(4093),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4094),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(4094),
    [sym_false] = STATE(4094),
    [sym_nil] = STATE(4094),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(4010),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6781),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6653),
    [anon_sym_yield] = ACTIONS(6655),
    [anon_sym_break] = ACTIONS(6657),
    [anon_sym_next] = ACTIONS(6659),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6783),
    [anon_sym_defined_QMARK] = ACTIONS(6785),
    [anon_sym_not] = ACTIONS(6787),
    [anon_sym_BANG] = ACTIONS(6789),
    [anon_sym_TILDE] = ACTIONS(6789),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6788] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8951),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(4094),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4094),
    [sym_assignment] = STATE(8951),
    [sym_operator_assignment] = STATE(8951),
    [sym_conditional] = STATE(8951),
    [sym_range] = STATE(8951),
    [sym_binary] = STATE(8951),
    [sym_unary] = STATE(8951),
    [sym_left_assignment_list] = STATE(4093),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4094),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(4094),
    [sym_false] = STATE(4094),
    [sym_nil] = STATE(4094),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(4010),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6781),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6653),
    [anon_sym_yield] = ACTIONS(6655),
    [anon_sym_break] = ACTIONS(6657),
    [anon_sym_next] = ACTIONS(6659),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6783),
    [anon_sym_defined_QMARK] = ACTIONS(6785),
    [anon_sym_not] = ACTIONS(6787),
    [anon_sym_BANG] = ACTIONS(6789),
    [anon_sym_TILDE] = ACTIONS(6789),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6789] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8952),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(4094),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4094),
    [sym_assignment] = STATE(8952),
    [sym_operator_assignment] = STATE(8952),
    [sym_conditional] = STATE(8952),
    [sym_range] = STATE(8952),
    [sym_binary] = STATE(8952),
    [sym_unary] = STATE(8952),
    [sym_left_assignment_list] = STATE(4093),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4094),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(4094),
    [sym_false] = STATE(4094),
    [sym_nil] = STATE(4094),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(4010),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6781),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6653),
    [anon_sym_yield] = ACTIONS(6655),
    [anon_sym_break] = ACTIONS(6657),
    [anon_sym_next] = ACTIONS(6659),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6783),
    [anon_sym_defined_QMARK] = ACTIONS(6785),
    [anon_sym_not] = ACTIONS(6787),
    [anon_sym_BANG] = ACTIONS(6789),
    [anon_sym_TILDE] = ACTIONS(6789),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6790] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8953),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(4094),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4094),
    [sym_assignment] = STATE(8953),
    [sym_operator_assignment] = STATE(8953),
    [sym_conditional] = STATE(8953),
    [sym_range] = STATE(8953),
    [sym_binary] = STATE(8953),
    [sym_unary] = STATE(8953),
    [sym_left_assignment_list] = STATE(4093),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4094),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(4094),
    [sym_false] = STATE(4094),
    [sym_nil] = STATE(4094),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(4010),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6781),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6653),
    [anon_sym_yield] = ACTIONS(6655),
    [anon_sym_break] = ACTIONS(6657),
    [anon_sym_next] = ACTIONS(6659),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6783),
    [anon_sym_defined_QMARK] = ACTIONS(6785),
    [anon_sym_not] = ACTIONS(6787),
    [anon_sym_BANG] = ACTIONS(6789),
    [anon_sym_TILDE] = ACTIONS(6789),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6791] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(4091),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(4094),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4094),
    [sym_splat_argument] = STATE(6406),
    [sym_assignment] = STATE(4091),
    [sym_operator_assignment] = STATE(4091),
    [sym_conditional] = STATE(4091),
    [sym_range] = STATE(4091),
    [sym_binary] = STATE(4091),
    [sym_unary] = STATE(4091),
    [sym__arg_or_splat_arg] = STATE(6406),
    [sym_left_assignment_list] = STATE(4093),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4094),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(4094),
    [sym_false] = STATE(4094),
    [sym_nil] = STATE(4094),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(4010),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(6779),
    [sym__unary_minus] = ACTIONS(6781),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6653),
    [anon_sym_yield] = ACTIONS(6655),
    [anon_sym_break] = ACTIONS(6657),
    [anon_sym_next] = ACTIONS(6659),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6783),
    [anon_sym_defined_QMARK] = ACTIONS(6785),
    [anon_sym_not] = ACTIONS(6787),
    [anon_sym_BANG] = ACTIONS(6789),
    [anon_sym_TILDE] = ACTIONS(6789),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6792] = {
    [aux_sym_exceptions_repeat1] = STATE(8954),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_RBRACE] = ACTIONS(9855),
    [anon_sym_COMMA] = ACTIONS(10321),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [6793] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(4091),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(4094),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4094),
    [sym_splat_argument] = STATE(8955),
    [sym_assignment] = STATE(4091),
    [sym_operator_assignment] = STATE(4091),
    [sym_conditional] = STATE(4091),
    [sym_range] = STATE(4091),
    [sym_binary] = STATE(4091),
    [sym_unary] = STATE(4091),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(8955),
    [sym_left_assignment_list] = STATE(4093),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4094),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(4094),
    [sym_false] = STATE(4094),
    [sym_nil] = STATE(4094),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(4010),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(6779),
    [sym__unary_minus] = ACTIONS(6781),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6653),
    [anon_sym_yield] = ACTIONS(6655),
    [anon_sym_break] = ACTIONS(6657),
    [anon_sym_next] = ACTIONS(6659),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6783),
    [anon_sym_defined_QMARK] = ACTIONS(6785),
    [anon_sym_not] = ACTIONS(6787),
    [anon_sym_BANG] = ACTIONS(6789),
    [anon_sym_TILDE] = ACTIONS(6789),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6794] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8956),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(4094),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4094),
    [sym_assignment] = STATE(8956),
    [sym_operator_assignment] = STATE(8956),
    [sym_conditional] = STATE(8956),
    [sym_range] = STATE(8956),
    [sym_binary] = STATE(8956),
    [sym_unary] = STATE(8956),
    [sym_left_assignment_list] = STATE(4093),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4094),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(4094),
    [sym_false] = STATE(4094),
    [sym_nil] = STATE(4094),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(4010),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6781),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6653),
    [anon_sym_yield] = ACTIONS(6655),
    [anon_sym_break] = ACTIONS(6657),
    [anon_sym_next] = ACTIONS(6659),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6783),
    [anon_sym_defined_QMARK] = ACTIONS(6785),
    [anon_sym_not] = ACTIONS(6787),
    [anon_sym_BANG] = ACTIONS(6789),
    [anon_sym_TILDE] = ACTIONS(6789),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6795] = {
    [sym__binary_minus] = ACTIONS(10203),
    [sym__binary_star] = ACTIONS(10203),
    [anon_sym_LBRACE] = ACTIONS(10203),
    [anon_sym_RBRACE] = ACTIONS(10203),
    [anon_sym_RPAREN] = ACTIONS(10203),
    [anon_sym_DOT] = ACTIONS(10205),
    [anon_sym_COMMA] = ACTIONS(10203),
    [anon_sym_PIPE] = ACTIONS(10205),
    [anon_sym_SEMI] = ACTIONS(10203),
    [anon_sym_STAR_STAR] = ACTIONS(10203),
    [anon_sym_AMP] = ACTIONS(10205),
    [anon_sym_LT] = ACTIONS(10205),
    [anon_sym_if] = ACTIONS(10203),
    [anon_sym_unless] = ACTIONS(10203),
    [anon_sym_while] = ACTIONS(10203),
    [anon_sym_until] = ACTIONS(10203),
    [anon_sym_rescue] = ACTIONS(10203),
    [anon_sym_do] = ACTIONS(10203),
    [anon_sym_EQ_GT] = ACTIONS(10203),
    [anon_sym_LBRACK] = ACTIONS(10203),
    [anon_sym_COLON_COLON2] = ACTIONS(10203),
    [anon_sym_AMP_DOT] = ACTIONS(10203),
    [anon_sym_QMARK] = ACTIONS(10203),
    [anon_sym_COLON2] = ACTIONS(10205),
    [anon_sym_DOT_DOT] = ACTIONS(10205),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10203),
    [anon_sym_and] = ACTIONS(10203),
    [anon_sym_or] = ACTIONS(10203),
    [anon_sym_PIPE_PIPE] = ACTIONS(10203),
    [anon_sym_AMP_AMP] = ACTIONS(10203),
    [anon_sym_LT_LT] = ACTIONS(10203),
    [anon_sym_GT_GT] = ACTIONS(10203),
    [anon_sym_EQ_EQ] = ACTIONS(10205),
    [anon_sym_BANG_EQ] = ACTIONS(10203),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10203),
    [anon_sym_LT_EQ_GT] = ACTIONS(10203),
    [anon_sym_EQ_TILDE] = ACTIONS(10203),
    [anon_sym_BANG_TILDE] = ACTIONS(10203),
    [anon_sym_LT_EQ] = ACTIONS(10205),
    [anon_sym_GT] = ACTIONS(10205),
    [anon_sym_GT_EQ] = ACTIONS(10203),
    [anon_sym_CARET] = ACTIONS(10203),
    [anon_sym_PLUS] = ACTIONS(10203),
    [anon_sym_SLASH] = ACTIONS(10203),
    [anon_sym_PERCENT] = ACTIONS(10203),
    [sym_comment] = ACTIONS(87),
  },
  [6796] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1697),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(12573),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [6797] = {
    [sym__binary_minus] = ACTIONS(10209),
    [sym__binary_star] = ACTIONS(10209),
    [anon_sym_LBRACE] = ACTIONS(10209),
    [anon_sym_RBRACE] = ACTIONS(10209),
    [anon_sym_RPAREN] = ACTIONS(10209),
    [anon_sym_DOT] = ACTIONS(10211),
    [anon_sym_COMMA] = ACTIONS(10209),
    [anon_sym_PIPE] = ACTIONS(10211),
    [anon_sym_SEMI] = ACTIONS(10209),
    [anon_sym_STAR_STAR] = ACTIONS(10209),
    [anon_sym_AMP] = ACTIONS(10211),
    [anon_sym_LT] = ACTIONS(10211),
    [anon_sym_if] = ACTIONS(10209),
    [anon_sym_unless] = ACTIONS(10209),
    [anon_sym_while] = ACTIONS(10209),
    [anon_sym_until] = ACTIONS(10209),
    [anon_sym_rescue] = ACTIONS(10209),
    [anon_sym_do] = ACTIONS(10209),
    [anon_sym_EQ_GT] = ACTIONS(10209),
    [anon_sym_LBRACK] = ACTIONS(10209),
    [anon_sym_COLON_COLON2] = ACTIONS(10209),
    [anon_sym_AMP_DOT] = ACTIONS(10209),
    [anon_sym_QMARK] = ACTIONS(10209),
    [anon_sym_COLON2] = ACTIONS(10211),
    [anon_sym_DOT_DOT] = ACTIONS(10211),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10209),
    [anon_sym_and] = ACTIONS(10209),
    [anon_sym_or] = ACTIONS(10209),
    [anon_sym_PIPE_PIPE] = ACTIONS(10209),
    [anon_sym_AMP_AMP] = ACTIONS(10209),
    [anon_sym_LT_LT] = ACTIONS(10209),
    [anon_sym_GT_GT] = ACTIONS(10209),
    [anon_sym_EQ_EQ] = ACTIONS(10211),
    [anon_sym_BANG_EQ] = ACTIONS(10209),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10209),
    [anon_sym_LT_EQ_GT] = ACTIONS(10209),
    [anon_sym_EQ_TILDE] = ACTIONS(10209),
    [anon_sym_BANG_TILDE] = ACTIONS(10209),
    [anon_sym_LT_EQ] = ACTIONS(10211),
    [anon_sym_GT] = ACTIONS(10211),
    [anon_sym_GT_EQ] = ACTIONS(10209),
    [anon_sym_CARET] = ACTIONS(10209),
    [anon_sym_PLUS] = ACTIONS(10209),
    [anon_sym_SLASH] = ACTIONS(10209),
    [anon_sym_PERCENT] = ACTIONS(10209),
    [sym_comment] = ACTIONS(87),
  },
  [6798] = {
    [sym__binary_minus] = ACTIONS(10213),
    [sym__binary_star] = ACTIONS(10213),
    [anon_sym_LBRACE] = ACTIONS(10213),
    [anon_sym_RBRACE] = ACTIONS(10213),
    [anon_sym_RPAREN] = ACTIONS(10213),
    [anon_sym_DOT] = ACTIONS(10215),
    [anon_sym_COMMA] = ACTIONS(10213),
    [anon_sym_PIPE] = ACTIONS(10215),
    [anon_sym_SEMI] = ACTIONS(10213),
    [anon_sym_STAR_STAR] = ACTIONS(10213),
    [anon_sym_AMP] = ACTIONS(10215),
    [anon_sym_LT] = ACTIONS(10215),
    [anon_sym_if] = ACTIONS(10213),
    [anon_sym_unless] = ACTIONS(10213),
    [anon_sym_while] = ACTIONS(10213),
    [anon_sym_until] = ACTIONS(10213),
    [anon_sym_rescue] = ACTIONS(10213),
    [anon_sym_do] = ACTIONS(10213),
    [anon_sym_EQ_GT] = ACTIONS(10213),
    [anon_sym_LBRACK] = ACTIONS(10213),
    [anon_sym_COLON_COLON2] = ACTIONS(10213),
    [anon_sym_AMP_DOT] = ACTIONS(10213),
    [anon_sym_QMARK] = ACTIONS(10213),
    [anon_sym_COLON2] = ACTIONS(10215),
    [anon_sym_DOT_DOT] = ACTIONS(10215),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10213),
    [anon_sym_and] = ACTIONS(10213),
    [anon_sym_or] = ACTIONS(10213),
    [anon_sym_PIPE_PIPE] = ACTIONS(10213),
    [anon_sym_AMP_AMP] = ACTIONS(10213),
    [anon_sym_LT_LT] = ACTIONS(10213),
    [anon_sym_GT_GT] = ACTIONS(10213),
    [anon_sym_EQ_EQ] = ACTIONS(10215),
    [anon_sym_BANG_EQ] = ACTIONS(10213),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10213),
    [anon_sym_LT_EQ_GT] = ACTIONS(10213),
    [anon_sym_EQ_TILDE] = ACTIONS(10213),
    [anon_sym_BANG_TILDE] = ACTIONS(10213),
    [anon_sym_LT_EQ] = ACTIONS(10215),
    [anon_sym_GT] = ACTIONS(10215),
    [anon_sym_GT_EQ] = ACTIONS(10213),
    [anon_sym_CARET] = ACTIONS(10213),
    [anon_sym_PLUS] = ACTIONS(10213),
    [anon_sym_SLASH] = ACTIONS(10213),
    [anon_sym_PERCENT] = ACTIONS(10213),
    [sym_comment] = ACTIONS(87),
  },
  [6799] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1705),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(12575),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [6800] = {
    [sym__binary_minus] = ACTIONS(10219),
    [sym__binary_star] = ACTIONS(10219),
    [anon_sym_LBRACE] = ACTIONS(10219),
    [anon_sym_RBRACE] = ACTIONS(10219),
    [anon_sym_RPAREN] = ACTIONS(10219),
    [anon_sym_DOT] = ACTIONS(10221),
    [anon_sym_COMMA] = ACTIONS(10219),
    [anon_sym_PIPE] = ACTIONS(10221),
    [anon_sym_SEMI] = ACTIONS(10219),
    [anon_sym_STAR_STAR] = ACTIONS(10219),
    [anon_sym_AMP] = ACTIONS(10221),
    [anon_sym_LT] = ACTIONS(10221),
    [anon_sym_if] = ACTIONS(10219),
    [anon_sym_unless] = ACTIONS(10219),
    [anon_sym_while] = ACTIONS(10219),
    [anon_sym_until] = ACTIONS(10219),
    [anon_sym_rescue] = ACTIONS(10219),
    [anon_sym_do] = ACTIONS(10219),
    [anon_sym_EQ_GT] = ACTIONS(10219),
    [anon_sym_LBRACK] = ACTIONS(10219),
    [anon_sym_COLON_COLON2] = ACTIONS(10219),
    [anon_sym_AMP_DOT] = ACTIONS(10219),
    [anon_sym_QMARK] = ACTIONS(10219),
    [anon_sym_COLON2] = ACTIONS(10221),
    [anon_sym_DOT_DOT] = ACTIONS(10221),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10219),
    [anon_sym_and] = ACTIONS(10219),
    [anon_sym_or] = ACTIONS(10219),
    [anon_sym_PIPE_PIPE] = ACTIONS(10219),
    [anon_sym_AMP_AMP] = ACTIONS(10219),
    [anon_sym_LT_LT] = ACTIONS(10219),
    [anon_sym_GT_GT] = ACTIONS(10219),
    [anon_sym_EQ_EQ] = ACTIONS(10221),
    [anon_sym_BANG_EQ] = ACTIONS(10219),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10219),
    [anon_sym_LT_EQ_GT] = ACTIONS(10219),
    [anon_sym_EQ_TILDE] = ACTIONS(10219),
    [anon_sym_BANG_TILDE] = ACTIONS(10219),
    [anon_sym_LT_EQ] = ACTIONS(10221),
    [anon_sym_GT] = ACTIONS(10221),
    [anon_sym_GT_EQ] = ACTIONS(10219),
    [anon_sym_CARET] = ACTIONS(10219),
    [anon_sym_PLUS] = ACTIONS(10219),
    [anon_sym_SLASH] = ACTIONS(10219),
    [anon_sym_PERCENT] = ACTIONS(10219),
    [sym_comment] = ACTIONS(87),
  },
  [6801] = {
    [sym__method_rest] = STATE(8959),
    [sym_operator] = STATE(522),
    [sym__method_name] = STATE(522),
    [sym_setter] = STATE(522),
    [sym_symbol] = STATE(522),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(6829),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(6829),
    [sym_class_variable] = ACTIONS(6829),
    [sym_global_variable] = ACTIONS(6829),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [6802] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(10345),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [6803] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(10343),
    [sym__binary_star] = ACTIONS(10345),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(10347),
    [anon_sym_STAR_STAR] = ACTIONS(10345),
    [anon_sym_AMP] = ACTIONS(10349),
    [anon_sym_LT] = ACTIONS(10351),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(10353),
    [anon_sym_DOT_DOT] = ACTIONS(10355),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10357),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(10359),
    [anon_sym_AMP_AMP] = ACTIONS(10359),
    [anon_sym_LT_LT] = ACTIONS(10361),
    [anon_sym_GT_GT] = ACTIONS(10361),
    [anon_sym_EQ_EQ] = ACTIONS(10363),
    [anon_sym_BANG_EQ] = ACTIONS(10359),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10359),
    [anon_sym_LT_EQ_GT] = ACTIONS(10359),
    [anon_sym_EQ_TILDE] = ACTIONS(10359),
    [anon_sym_BANG_TILDE] = ACTIONS(10359),
    [anon_sym_LT_EQ] = ACTIONS(10351),
    [anon_sym_GT] = ACTIONS(10351),
    [anon_sym_GT_EQ] = ACTIONS(10365),
    [anon_sym_CARET] = ACTIONS(10367),
    [anon_sym_PLUS] = ACTIONS(10343),
    [anon_sym_SLASH] = ACTIONS(10345),
    [anon_sym_PERCENT] = ACTIONS(10345),
    [sym_comment] = ACTIONS(87),
  },
  [6804] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(8960),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4119),
    [sym_scope_resolution] = STATE(539),
    [sym_call] = STATE(539),
    [sym_method_call] = STATE(4119),
    [sym_assignment] = STATE(8960),
    [sym_operator_assignment] = STATE(8960),
    [sym_conditional] = STATE(8960),
    [sym_range] = STATE(8960),
    [sym_binary] = STATE(8960),
    [sym_unary] = STATE(8960),
    [sym_left_assignment_list] = STATE(4118),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4119),
    [sym__variable] = STATE(539),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4119),
    [sym_false] = STATE(4119),
    [sym_nil] = STATE(4119),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(542),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6833),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6835),
    [anon_sym_defined_QMARK] = ACTIONS(6837),
    [anon_sym_not] = ACTIONS(6839),
    [anon_sym_BANG] = ACTIONS(6841),
    [anon_sym_TILDE] = ACTIONS(6841),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6805] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(8961),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4119),
    [sym_scope_resolution] = STATE(539),
    [sym_call] = STATE(539),
    [sym_method_call] = STATE(4119),
    [sym_assignment] = STATE(8961),
    [sym_operator_assignment] = STATE(8961),
    [sym_conditional] = STATE(8961),
    [sym_range] = STATE(8961),
    [sym_binary] = STATE(8961),
    [sym_unary] = STATE(8961),
    [sym_left_assignment_list] = STATE(4118),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4119),
    [sym__variable] = STATE(539),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4119),
    [sym_false] = STATE(4119),
    [sym_nil] = STATE(4119),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(542),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6833),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6835),
    [anon_sym_defined_QMARK] = ACTIONS(6837),
    [anon_sym_not] = ACTIONS(6839),
    [anon_sym_BANG] = ACTIONS(6841),
    [anon_sym_TILDE] = ACTIONS(6841),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6806] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(8962),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4119),
    [sym_scope_resolution] = STATE(539),
    [sym_call] = STATE(539),
    [sym_method_call] = STATE(4119),
    [sym_assignment] = STATE(8962),
    [sym_operator_assignment] = STATE(8962),
    [sym_conditional] = STATE(8962),
    [sym_range] = STATE(8962),
    [sym_binary] = STATE(8962),
    [sym_unary] = STATE(8962),
    [sym_left_assignment_list] = STATE(4118),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4119),
    [sym__variable] = STATE(539),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4119),
    [sym_false] = STATE(4119),
    [sym_nil] = STATE(4119),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(542),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6833),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6835),
    [anon_sym_defined_QMARK] = ACTIONS(6837),
    [anon_sym_not] = ACTIONS(6839),
    [anon_sym_BANG] = ACTIONS(6841),
    [anon_sym_TILDE] = ACTIONS(6841),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6807] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(8963),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4119),
    [sym_scope_resolution] = STATE(539),
    [sym_call] = STATE(539),
    [sym_method_call] = STATE(4119),
    [sym_assignment] = STATE(8963),
    [sym_operator_assignment] = STATE(8963),
    [sym_conditional] = STATE(8963),
    [sym_range] = STATE(8963),
    [sym_binary] = STATE(8963),
    [sym_unary] = STATE(8963),
    [sym_left_assignment_list] = STATE(4118),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4119),
    [sym__variable] = STATE(539),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4119),
    [sym_false] = STATE(4119),
    [sym_nil] = STATE(4119),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(542),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6833),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6835),
    [anon_sym_defined_QMARK] = ACTIONS(6837),
    [anon_sym_not] = ACTIONS(6839),
    [anon_sym_BANG] = ACTIONS(6841),
    [anon_sym_TILDE] = ACTIONS(6841),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6808] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(8964),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4119),
    [sym_scope_resolution] = STATE(539),
    [sym_call] = STATE(539),
    [sym_method_call] = STATE(4119),
    [sym_assignment] = STATE(8964),
    [sym_operator_assignment] = STATE(8964),
    [sym_conditional] = STATE(8964),
    [sym_range] = STATE(8964),
    [sym_binary] = STATE(8964),
    [sym_unary] = STATE(8964),
    [sym_left_assignment_list] = STATE(4118),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4119),
    [sym__variable] = STATE(539),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4119),
    [sym_false] = STATE(4119),
    [sym_nil] = STATE(4119),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(542),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6833),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6835),
    [anon_sym_defined_QMARK] = ACTIONS(6837),
    [anon_sym_not] = ACTIONS(6839),
    [anon_sym_BANG] = ACTIONS(6841),
    [anon_sym_TILDE] = ACTIONS(6841),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6809] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(8965),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(8965),
    [sym_operator_assignment] = STATE(8965),
    [sym_conditional] = STATE(8965),
    [sym_range] = STATE(8965),
    [sym_binary] = STATE(8965),
    [sym_unary] = STATE(8965),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6810] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(8966),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4119),
    [sym_scope_resolution] = STATE(539),
    [sym_call] = STATE(539),
    [sym_method_call] = STATE(4119),
    [sym_assignment] = STATE(8966),
    [sym_operator_assignment] = STATE(8966),
    [sym_conditional] = STATE(8966),
    [sym_range] = STATE(8966),
    [sym_binary] = STATE(8966),
    [sym_unary] = STATE(8966),
    [sym_left_assignment_list] = STATE(4118),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4119),
    [sym__variable] = STATE(539),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4119),
    [sym_false] = STATE(4119),
    [sym_nil] = STATE(4119),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(542),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6833),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6835),
    [anon_sym_defined_QMARK] = ACTIONS(6837),
    [anon_sym_not] = ACTIONS(6839),
    [anon_sym_BANG] = ACTIONS(6841),
    [anon_sym_TILDE] = ACTIONS(6841),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6811] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(8967),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4119),
    [sym_scope_resolution] = STATE(539),
    [sym_call] = STATE(539),
    [sym_method_call] = STATE(4119),
    [sym_assignment] = STATE(8967),
    [sym_operator_assignment] = STATE(8967),
    [sym_conditional] = STATE(8967),
    [sym_range] = STATE(8967),
    [sym_binary] = STATE(8967),
    [sym_unary] = STATE(8967),
    [sym_left_assignment_list] = STATE(4118),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4119),
    [sym__variable] = STATE(539),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4119),
    [sym_false] = STATE(4119),
    [sym_nil] = STATE(4119),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(542),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6833),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6835),
    [anon_sym_defined_QMARK] = ACTIONS(6837),
    [anon_sym_not] = ACTIONS(6839),
    [anon_sym_BANG] = ACTIONS(6841),
    [anon_sym_TILDE] = ACTIONS(6841),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6812] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(8968),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4119),
    [sym_scope_resolution] = STATE(539),
    [sym_call] = STATE(539),
    [sym_method_call] = STATE(4119),
    [sym_assignment] = STATE(8968),
    [sym_operator_assignment] = STATE(8968),
    [sym_conditional] = STATE(8968),
    [sym_range] = STATE(8968),
    [sym_binary] = STATE(8968),
    [sym_unary] = STATE(8968),
    [sym_left_assignment_list] = STATE(4118),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4119),
    [sym__variable] = STATE(539),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4119),
    [sym_false] = STATE(4119),
    [sym_nil] = STATE(4119),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(542),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6833),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6835),
    [anon_sym_defined_QMARK] = ACTIONS(6837),
    [anon_sym_not] = ACTIONS(6839),
    [anon_sym_BANG] = ACTIONS(6841),
    [anon_sym_TILDE] = ACTIONS(6841),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6813] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(8969),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4119),
    [sym_scope_resolution] = STATE(539),
    [sym_call] = STATE(539),
    [sym_method_call] = STATE(4119),
    [sym_assignment] = STATE(8969),
    [sym_operator_assignment] = STATE(8969),
    [sym_conditional] = STATE(8969),
    [sym_range] = STATE(8969),
    [sym_binary] = STATE(8969),
    [sym_unary] = STATE(8969),
    [sym_left_assignment_list] = STATE(4118),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4119),
    [sym__variable] = STATE(539),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4119),
    [sym_false] = STATE(4119),
    [sym_nil] = STATE(4119),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(542),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6833),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6835),
    [anon_sym_defined_QMARK] = ACTIONS(6837),
    [anon_sym_not] = ACTIONS(6839),
    [anon_sym_BANG] = ACTIONS(6841),
    [anon_sym_TILDE] = ACTIONS(6841),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6814] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(8970),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4119),
    [sym_scope_resolution] = STATE(539),
    [sym_call] = STATE(539),
    [sym_method_call] = STATE(4119),
    [sym_splat_argument] = STATE(8971),
    [sym_assignment] = STATE(8970),
    [sym_operator_assignment] = STATE(8970),
    [sym_conditional] = STATE(8970),
    [sym_range] = STATE(8970),
    [sym_binary] = STATE(8970),
    [sym_unary] = STATE(8970),
    [sym_right_assignment_list] = STATE(4255),
    [sym__arg_or_splat_arg] = STATE(8971),
    [sym_left_assignment_list] = STATE(4118),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4119),
    [sym__variable] = STATE(539),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4119),
    [sym_false] = STATE(4119),
    [sym_nil] = STATE(4119),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(542),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(3253),
    [sym__unary_minus] = ACTIONS(6833),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6835),
    [anon_sym_defined_QMARK] = ACTIONS(6837),
    [anon_sym_not] = ACTIONS(6839),
    [anon_sym_BANG] = ACTIONS(6841),
    [anon_sym_TILDE] = ACTIONS(6841),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6815] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(8972),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4119),
    [sym_scope_resolution] = STATE(539),
    [sym_call] = STATE(539),
    [sym_method_call] = STATE(4119),
    [sym_assignment] = STATE(8972),
    [sym_operator_assignment] = STATE(8972),
    [sym_conditional] = STATE(8972),
    [sym_range] = STATE(8972),
    [sym_binary] = STATE(8972),
    [sym_unary] = STATE(8972),
    [sym_left_assignment_list] = STATE(4118),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4119),
    [sym__variable] = STATE(539),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4119),
    [sym_false] = STATE(4119),
    [sym_nil] = STATE(4119),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(542),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6833),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6835),
    [anon_sym_defined_QMARK] = ACTIONS(6837),
    [anon_sym_not] = ACTIONS(6839),
    [anon_sym_BANG] = ACTIONS(6841),
    [anon_sym_TILDE] = ACTIONS(6841),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6816] = {
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(10343),
    [sym__binary_star] = ACTIONS(10345),
    [anon_sym_RBRACE] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(10347),
    [anon_sym_STAR_STAR] = ACTIONS(10345),
    [anon_sym_AMP] = ACTIONS(10349),
    [anon_sym_LT] = ACTIONS(10351),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(10353),
    [anon_sym_DOT_DOT] = ACTIONS(10355),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10357),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(10359),
    [anon_sym_AMP_AMP] = ACTIONS(10359),
    [anon_sym_LT_LT] = ACTIONS(10361),
    [anon_sym_GT_GT] = ACTIONS(10361),
    [anon_sym_EQ_EQ] = ACTIONS(10363),
    [anon_sym_BANG_EQ] = ACTIONS(10359),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10359),
    [anon_sym_LT_EQ_GT] = ACTIONS(10359),
    [anon_sym_EQ_TILDE] = ACTIONS(10359),
    [anon_sym_BANG_TILDE] = ACTIONS(10359),
    [anon_sym_LT_EQ] = ACTIONS(10351),
    [anon_sym_GT] = ACTIONS(10351),
    [anon_sym_GT_EQ] = ACTIONS(10365),
    [anon_sym_CARET] = ACTIONS(10367),
    [anon_sym_PLUS] = ACTIONS(10343),
    [anon_sym_SLASH] = ACTIONS(10345),
    [anon_sym_PERCENT] = ACTIONS(10345),
    [sym_comment] = ACTIONS(87),
  },
  [6817] = {
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(6857),
    [sym__binary_star] = ACTIONS(6859),
    [anon_sym_RBRACE] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(6861),
    [anon_sym_STAR_STAR] = ACTIONS(6859),
    [anon_sym_AMP] = ACTIONS(6863),
    [anon_sym_LT] = ACTIONS(6865),
    [anon_sym_EQ_GT] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(6867),
    [anon_sym_DOT_DOT] = ACTIONS(6869),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6871),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(6873),
    [anon_sym_AMP_AMP] = ACTIONS(6873),
    [anon_sym_LT_LT] = ACTIONS(6875),
    [anon_sym_GT_GT] = ACTIONS(6875),
    [anon_sym_EQ_EQ] = ACTIONS(6877),
    [anon_sym_BANG_EQ] = ACTIONS(6873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6873),
    [anon_sym_LT_EQ_GT] = ACTIONS(6873),
    [anon_sym_EQ_TILDE] = ACTIONS(6873),
    [anon_sym_BANG_TILDE] = ACTIONS(6873),
    [anon_sym_LT_EQ] = ACTIONS(6865),
    [anon_sym_GT] = ACTIONS(6865),
    [anon_sym_GT_EQ] = ACTIONS(6879),
    [anon_sym_CARET] = ACTIONS(6881),
    [anon_sym_PLUS] = ACTIONS(6857),
    [anon_sym_SLASH] = ACTIONS(6859),
    [anon_sym_PERCENT] = ACTIONS(6859),
    [sym_comment] = ACTIONS(87),
  },
  [6818] = {
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(6857),
    [sym__binary_star] = ACTIONS(6859),
    [anon_sym_RBRACE] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(6861),
    [anon_sym_STAR_STAR] = ACTIONS(6859),
    [anon_sym_AMP] = ACTIONS(6863),
    [anon_sym_LT] = ACTIONS(6865),
    [anon_sym_EQ_GT] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(6867),
    [anon_sym_DOT_DOT] = ACTIONS(6869),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6871),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(6873),
    [anon_sym_AMP_AMP] = ACTIONS(6873),
    [anon_sym_LT_LT] = ACTIONS(6875),
    [anon_sym_GT_GT] = ACTIONS(6875),
    [anon_sym_EQ_EQ] = ACTIONS(6877),
    [anon_sym_BANG_EQ] = ACTIONS(6873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6873),
    [anon_sym_LT_EQ_GT] = ACTIONS(6873),
    [anon_sym_EQ_TILDE] = ACTIONS(6873),
    [anon_sym_BANG_TILDE] = ACTIONS(6873),
    [anon_sym_LT_EQ] = ACTIONS(6865),
    [anon_sym_GT] = ACTIONS(6865),
    [anon_sym_GT_EQ] = ACTIONS(6879),
    [anon_sym_CARET] = ACTIONS(6881),
    [anon_sym_PLUS] = ACTIONS(6857),
    [anon_sym_SLASH] = ACTIONS(6859),
    [anon_sym_PERCENT] = ACTIONS(6859),
    [sym_comment] = ACTIONS(87),
  },
  [6819] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(8973),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1814),
    [sym_scope_resolution] = STATE(1810),
    [sym_call] = STATE(1810),
    [sym_method_call] = STATE(1814),
    [sym_assignment] = STATE(8973),
    [sym_operator_assignment] = STATE(8973),
    [sym_conditional] = STATE(8973),
    [sym_range] = STATE(8973),
    [sym_binary] = STATE(8973),
    [sym_unary] = STATE(8973),
    [sym_left_assignment_list] = STATE(1813),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1814),
    [sym__variable] = STATE(1810),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1814),
    [sym_false] = STATE(1814),
    [sym_nil] = STATE(1814),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4122),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_break] = ACTIONS(3263),
    [anon_sym_next] = ACTIONS(3265),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6843),
    [anon_sym_defined_QMARK] = ACTIONS(3267),
    [anon_sym_not] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3273),
    [anon_sym_TILDE] = ACTIONS(3273),
    [sym_constant] = ACTIONS(3279),
    [sym_identifier] = ACTIONS(3279),
    [sym_instance_variable] = ACTIONS(3277),
    [sym_class_variable] = ACTIONS(3277),
    [sym_global_variable] = ACTIONS(3277),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3279),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3279),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6820] = {
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(6857),
    [sym__binary_star] = ACTIONS(6859),
    [anon_sym_RBRACE] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(6861),
    [anon_sym_STAR_STAR] = ACTIONS(6859),
    [anon_sym_AMP] = ACTIONS(6863),
    [anon_sym_LT] = ACTIONS(6865),
    [anon_sym_EQ_GT] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(6867),
    [anon_sym_DOT_DOT] = ACTIONS(6869),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6871),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(6873),
    [anon_sym_AMP_AMP] = ACTIONS(6873),
    [anon_sym_LT_LT] = ACTIONS(6875),
    [anon_sym_GT_GT] = ACTIONS(6875),
    [anon_sym_EQ_EQ] = ACTIONS(6877),
    [anon_sym_BANG_EQ] = ACTIONS(6873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6873),
    [anon_sym_LT_EQ_GT] = ACTIONS(6873),
    [anon_sym_EQ_TILDE] = ACTIONS(6873),
    [anon_sym_BANG_TILDE] = ACTIONS(6873),
    [anon_sym_LT_EQ] = ACTIONS(6865),
    [anon_sym_GT] = ACTIONS(6865),
    [anon_sym_GT_EQ] = ACTIONS(6879),
    [anon_sym_CARET] = ACTIONS(6881),
    [anon_sym_PLUS] = ACTIONS(6857),
    [anon_sym_SLASH] = ACTIONS(6859),
    [anon_sym_PERCENT] = ACTIONS(6859),
    [sym_comment] = ACTIONS(87),
  },
  [6821] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(8974),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1814),
    [sym_scope_resolution] = STATE(1810),
    [sym_call] = STATE(1810),
    [sym_method_call] = STATE(1814),
    [sym_assignment] = STATE(8974),
    [sym_operator_assignment] = STATE(8974),
    [sym_conditional] = STATE(8974),
    [sym_range] = STATE(8974),
    [sym_binary] = STATE(8974),
    [sym_unary] = STATE(8974),
    [sym_left_assignment_list] = STATE(1813),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1814),
    [sym__variable] = STATE(1810),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1814),
    [sym_false] = STATE(1814),
    [sym_nil] = STATE(1814),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4122),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_break] = ACTIONS(3263),
    [anon_sym_next] = ACTIONS(3265),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6843),
    [anon_sym_defined_QMARK] = ACTIONS(3267),
    [anon_sym_not] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3273),
    [anon_sym_TILDE] = ACTIONS(3273),
    [sym_constant] = ACTIONS(3279),
    [sym_identifier] = ACTIONS(3279),
    [sym_instance_variable] = ACTIONS(3277),
    [sym_class_variable] = ACTIONS(3277),
    [sym_global_variable] = ACTIONS(3277),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3279),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3279),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6822] = {
    [sym_heredoc_body] = STATE(8975),
    [aux_sym_call_repeat1] = STATE(8975),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_RBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [6823] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4130),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1814),
    [sym_scope_resolution] = STATE(1810),
    [sym_call] = STATE(1810),
    [sym_method_call] = STATE(1814),
    [sym__argument] = STATE(4250),
    [sym_splat_argument] = STATE(4250),
    [sym_hash_splat_argument] = STATE(4250),
    [sym_block_argument] = STATE(4250),
    [sym_assignment] = STATE(4130),
    [sym_operator_assignment] = STATE(4130),
    [sym_conditional] = STATE(4130),
    [sym_range] = STATE(4130),
    [sym_binary] = STATE(4130),
    [sym_unary] = STATE(4130),
    [sym_left_assignment_list] = STATE(1813),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1814),
    [sym__variable] = STATE(1810),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1814),
    [sym_false] = STATE(1814),
    [sym_nil] = STATE(1814),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4133),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_heredoc_body] = STATE(8976),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(4250),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(6847),
    [sym__splat_star] = ACTIONS(6849),
    [sym__unary_minus] = ACTIONS(3255),
    [sym__identifier_hash_key] = ACTIONS(6851),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12577),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_break] = ACTIONS(3263),
    [anon_sym_next] = ACTIONS(3265),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6843),
    [anon_sym_defined_QMARK] = ACTIONS(3267),
    [anon_sym_not] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3273),
    [anon_sym_TILDE] = ACTIONS(3273),
    [sym_constant] = ACTIONS(6853),
    [sym_identifier] = ACTIONS(6853),
    [sym_instance_variable] = ACTIONS(3277),
    [sym_class_variable] = ACTIONS(3277),
    [sym_global_variable] = ACTIONS(3277),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3279),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3279),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6824] = {
    [sym_heredoc_body] = STATE(8977),
    [aux_sym_call_repeat1] = STATE(8977),
    [aux_sym_argument_list_repeat1] = STATE(8978),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_RBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(10379),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [6825] = {
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(10343),
    [sym__binary_star] = ACTIONS(10345),
    [anon_sym_RBRACE] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(10347),
    [anon_sym_STAR_STAR] = ACTIONS(10345),
    [anon_sym_AMP] = ACTIONS(10349),
    [anon_sym_LT] = ACTIONS(10351),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(10353),
    [anon_sym_DOT_DOT] = ACTIONS(10355),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10357),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(10359),
    [anon_sym_AMP_AMP] = ACTIONS(10359),
    [anon_sym_LT_LT] = ACTIONS(10361),
    [anon_sym_GT_GT] = ACTIONS(10361),
    [anon_sym_EQ_EQ] = ACTIONS(10363),
    [anon_sym_BANG_EQ] = ACTIONS(10359),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10359),
    [anon_sym_LT_EQ_GT] = ACTIONS(10359),
    [anon_sym_EQ_TILDE] = ACTIONS(10359),
    [anon_sym_BANG_TILDE] = ACTIONS(10359),
    [anon_sym_LT_EQ] = ACTIONS(10351),
    [anon_sym_GT] = ACTIONS(10351),
    [anon_sym_GT_EQ] = ACTIONS(10365),
    [anon_sym_CARET] = ACTIONS(10367),
    [anon_sym_PLUS] = ACTIONS(10343),
    [anon_sym_SLASH] = ACTIONS(10345),
    [anon_sym_PERCENT] = ACTIONS(10345),
    [sym_comment] = ACTIONS(87),
  },
  [6826] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(6859),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(6859),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(6859),
    [anon_sym_PERCENT] = ACTIONS(6859),
    [sym_comment] = ACTIONS(87),
  },
  [6827] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(6859),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [6828] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6857),
    [sym__binary_star] = ACTIONS(6859),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(6859),
    [anon_sym_AMP] = ACTIONS(6863),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(6875),
    [anon_sym_GT_GT] = ACTIONS(6875),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(6857),
    [anon_sym_SLASH] = ACTIONS(6859),
    [anon_sym_PERCENT] = ACTIONS(6859),
    [sym_comment] = ACTIONS(87),
  },
  [6829] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6857),
    [sym__binary_star] = ACTIONS(6859),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(6859),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(6875),
    [anon_sym_GT_GT] = ACTIONS(6875),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(6857),
    [anon_sym_SLASH] = ACTIONS(6859),
    [anon_sym_PERCENT] = ACTIONS(6859),
    [sym_comment] = ACTIONS(87),
  },
  [6830] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6857),
    [sym__binary_star] = ACTIONS(6859),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(6861),
    [anon_sym_STAR_STAR] = ACTIONS(6859),
    [anon_sym_AMP] = ACTIONS(6863),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(6875),
    [anon_sym_GT_GT] = ACTIONS(6875),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(6881),
    [anon_sym_PLUS] = ACTIONS(6857),
    [anon_sym_SLASH] = ACTIONS(6859),
    [anon_sym_PERCENT] = ACTIONS(6859),
    [sym_comment] = ACTIONS(87),
  },
  [6831] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(12579),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [6832] = {
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(6857),
    [sym__binary_star] = ACTIONS(6859),
    [anon_sym_RBRACE] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(6861),
    [anon_sym_STAR_STAR] = ACTIONS(6859),
    [anon_sym_AMP] = ACTIONS(6863),
    [anon_sym_LT] = ACTIONS(6865),
    [anon_sym_EQ_GT] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(6869),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6871),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(6873),
    [anon_sym_AMP_AMP] = ACTIONS(6873),
    [anon_sym_LT_LT] = ACTIONS(6875),
    [anon_sym_GT_GT] = ACTIONS(6875),
    [anon_sym_EQ_EQ] = ACTIONS(6877),
    [anon_sym_BANG_EQ] = ACTIONS(6873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6873),
    [anon_sym_LT_EQ_GT] = ACTIONS(6873),
    [anon_sym_EQ_TILDE] = ACTIONS(6873),
    [anon_sym_BANG_TILDE] = ACTIONS(6873),
    [anon_sym_LT_EQ] = ACTIONS(6865),
    [anon_sym_GT] = ACTIONS(6865),
    [anon_sym_GT_EQ] = ACTIONS(6879),
    [anon_sym_CARET] = ACTIONS(6881),
    [anon_sym_PLUS] = ACTIONS(6857),
    [anon_sym_SLASH] = ACTIONS(6859),
    [anon_sym_PERCENT] = ACTIONS(6859),
    [sym_comment] = ACTIONS(87),
  },
  [6833] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6857),
    [sym__binary_star] = ACTIONS(6859),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(6861),
    [anon_sym_STAR_STAR] = ACTIONS(6859),
    [anon_sym_AMP] = ACTIONS(6863),
    [anon_sym_LT] = ACTIONS(6865),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(6867),
    [anon_sym_DOT_DOT] = ACTIONS(6869),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6871),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(6873),
    [anon_sym_AMP_AMP] = ACTIONS(6873),
    [anon_sym_LT_LT] = ACTIONS(6875),
    [anon_sym_GT_GT] = ACTIONS(6875),
    [anon_sym_EQ_EQ] = ACTIONS(6877),
    [anon_sym_BANG_EQ] = ACTIONS(6873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6873),
    [anon_sym_LT_EQ_GT] = ACTIONS(6873),
    [anon_sym_EQ_TILDE] = ACTIONS(6873),
    [anon_sym_BANG_TILDE] = ACTIONS(6873),
    [anon_sym_LT_EQ] = ACTIONS(6865),
    [anon_sym_GT] = ACTIONS(6865),
    [anon_sym_GT_EQ] = ACTIONS(6879),
    [anon_sym_CARET] = ACTIONS(6881),
    [anon_sym_PLUS] = ACTIONS(6857),
    [anon_sym_SLASH] = ACTIONS(6859),
    [anon_sym_PERCENT] = ACTIONS(6859),
    [sym_comment] = ACTIONS(87),
  },
  [6834] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6857),
    [sym__binary_star] = ACTIONS(6859),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(6861),
    [anon_sym_STAR_STAR] = ACTIONS(6859),
    [anon_sym_AMP] = ACTIONS(6863),
    [anon_sym_LT] = ACTIONS(6865),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(6875),
    [anon_sym_GT_GT] = ACTIONS(6875),
    [anon_sym_EQ_EQ] = ACTIONS(6877),
    [anon_sym_BANG_EQ] = ACTIONS(6873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6873),
    [anon_sym_LT_EQ_GT] = ACTIONS(6873),
    [anon_sym_EQ_TILDE] = ACTIONS(6873),
    [anon_sym_BANG_TILDE] = ACTIONS(6873),
    [anon_sym_LT_EQ] = ACTIONS(6865),
    [anon_sym_GT] = ACTIONS(6865),
    [anon_sym_GT_EQ] = ACTIONS(6879),
    [anon_sym_CARET] = ACTIONS(6881),
    [anon_sym_PLUS] = ACTIONS(6857),
    [anon_sym_SLASH] = ACTIONS(6859),
    [anon_sym_PERCENT] = ACTIONS(6859),
    [sym_comment] = ACTIONS(87),
  },
  [6835] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6857),
    [sym__binary_star] = ACTIONS(6859),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(6859),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(6857),
    [anon_sym_SLASH] = ACTIONS(6859),
    [anon_sym_PERCENT] = ACTIONS(6859),
    [sym_comment] = ACTIONS(87),
  },
  [6836] = {
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(6947),
    [sym__binary_star] = ACTIONS(6949),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_RBRACE] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(6951),
    [anon_sym_STAR_STAR] = ACTIONS(6953),
    [anon_sym_AMP] = ACTIONS(6955),
    [anon_sym_EQ] = ACTIONS(4217),
    [anon_sym_LT] = ACTIONS(6957),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_EQ_GT] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_PLUS_EQ] = ACTIONS(4211),
    [anon_sym_DASH_EQ] = ACTIONS(4211),
    [anon_sym_STAR_EQ] = ACTIONS(4211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4211),
    [anon_sym_SLASH_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4211),
    [anon_sym_AMP_EQ] = ACTIONS(4211),
    [anon_sym_PERCENT_EQ] = ACTIONS(4211),
    [anon_sym_GT_GT_EQ] = ACTIONS(4211),
    [anon_sym_LT_LT_EQ] = ACTIONS(4211),
    [anon_sym_CARET_EQ] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(6959),
    [anon_sym_DOT_DOT] = ACTIONS(6961),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6963),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(6965),
    [anon_sym_AMP_AMP] = ACTIONS(6965),
    [anon_sym_LT_LT] = ACTIONS(6967),
    [anon_sym_GT_GT] = ACTIONS(6967),
    [anon_sym_EQ_EQ] = ACTIONS(6965),
    [anon_sym_BANG_EQ] = ACTIONS(6969),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6969),
    [anon_sym_LT_EQ_GT] = ACTIONS(6969),
    [anon_sym_EQ_TILDE] = ACTIONS(6969),
    [anon_sym_BANG_TILDE] = ACTIONS(6969),
    [anon_sym_LT_EQ] = ACTIONS(6957),
    [anon_sym_GT] = ACTIONS(6957),
    [anon_sym_GT_EQ] = ACTIONS(6971),
    [anon_sym_CARET] = ACTIONS(6951),
    [anon_sym_PLUS] = ACTIONS(6973),
    [anon_sym_SLASH] = ACTIONS(6953),
    [anon_sym_PERCENT] = ACTIONS(6953),
    [sym_comment] = ACTIONS(87),
  },
  [6837] = {
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(6947),
    [sym__binary_star] = ACTIONS(6949),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_RBRACE] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(6951),
    [anon_sym_STAR_STAR] = ACTIONS(6953),
    [anon_sym_AMP] = ACTIONS(6955),
    [anon_sym_EQ] = ACTIONS(4249),
    [anon_sym_LT] = ACTIONS(6957),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_EQ_GT] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_PLUS_EQ] = ACTIONS(4247),
    [anon_sym_DASH_EQ] = ACTIONS(4247),
    [anon_sym_STAR_EQ] = ACTIONS(4247),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4247),
    [anon_sym_SLASH_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4247),
    [anon_sym_AMP_EQ] = ACTIONS(4247),
    [anon_sym_PERCENT_EQ] = ACTIONS(4247),
    [anon_sym_GT_GT_EQ] = ACTIONS(4247),
    [anon_sym_LT_LT_EQ] = ACTIONS(4247),
    [anon_sym_CARET_EQ] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(6959),
    [anon_sym_DOT_DOT] = ACTIONS(6961),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6963),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(6965),
    [anon_sym_AMP_AMP] = ACTIONS(6965),
    [anon_sym_LT_LT] = ACTIONS(6967),
    [anon_sym_GT_GT] = ACTIONS(6967),
    [anon_sym_EQ_EQ] = ACTIONS(6965),
    [anon_sym_BANG_EQ] = ACTIONS(6969),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6969),
    [anon_sym_LT_EQ_GT] = ACTIONS(6969),
    [anon_sym_EQ_TILDE] = ACTIONS(6969),
    [anon_sym_BANG_TILDE] = ACTIONS(6969),
    [anon_sym_LT_EQ] = ACTIONS(6957),
    [anon_sym_GT] = ACTIONS(6957),
    [anon_sym_GT_EQ] = ACTIONS(6971),
    [anon_sym_CARET] = ACTIONS(6951),
    [anon_sym_PLUS] = ACTIONS(6973),
    [anon_sym_SLASH] = ACTIONS(6953),
    [anon_sym_PERCENT] = ACTIONS(6953),
    [sym_comment] = ACTIONS(87),
  },
  [6838] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(8980),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1851),
    [sym_scope_resolution] = STATE(1845),
    [sym_call] = STATE(1845),
    [sym_method_call] = STATE(1851),
    [sym_assignment] = STATE(8980),
    [sym_operator_assignment] = STATE(8980),
    [sym_conditional] = STATE(8980),
    [sym_range] = STATE(8980),
    [sym_binary] = STATE(8980),
    [sym_unary] = STATE(8980),
    [sym_left_assignment_list] = STATE(1850),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1851),
    [sym__variable] = STATE(1845),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1851),
    [sym_false] = STATE(1851),
    [sym_nil] = STATE(1851),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4193),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3323),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3329),
    [anon_sym_yield] = ACTIONS(3331),
    [anon_sym_break] = ACTIONS(3333),
    [anon_sym_next] = ACTIONS(3335),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6935),
    [anon_sym_defined_QMARK] = ACTIONS(3339),
    [anon_sym_not] = ACTIONS(3341),
    [anon_sym_BANG] = ACTIONS(3345),
    [anon_sym_TILDE] = ACTIONS(3345),
    [sym_constant] = ACTIONS(3351),
    [sym_identifier] = ACTIONS(3351),
    [sym_instance_variable] = ACTIONS(3349),
    [sym_class_variable] = ACTIONS(3349),
    [sym_global_variable] = ACTIONS(3349),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3351),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3351),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6839] = {
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(6947),
    [sym__binary_star] = ACTIONS(6949),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_RBRACE] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(6951),
    [anon_sym_STAR_STAR] = ACTIONS(6953),
    [anon_sym_AMP] = ACTIONS(6955),
    [anon_sym_EQ] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(6957),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_EQ_GT] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_PLUS_EQ] = ACTIONS(3281),
    [anon_sym_DASH_EQ] = ACTIONS(3281),
    [anon_sym_STAR_EQ] = ACTIONS(3281),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3281),
    [anon_sym_SLASH_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3281),
    [anon_sym_AMP_EQ] = ACTIONS(3281),
    [anon_sym_PERCENT_EQ] = ACTIONS(3281),
    [anon_sym_GT_GT_EQ] = ACTIONS(3281),
    [anon_sym_LT_LT_EQ] = ACTIONS(3281),
    [anon_sym_CARET_EQ] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(6959),
    [anon_sym_DOT_DOT] = ACTIONS(6961),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6963),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(6965),
    [anon_sym_AMP_AMP] = ACTIONS(6965),
    [anon_sym_LT_LT] = ACTIONS(6967),
    [anon_sym_GT_GT] = ACTIONS(6967),
    [anon_sym_EQ_EQ] = ACTIONS(6965),
    [anon_sym_BANG_EQ] = ACTIONS(6969),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6969),
    [anon_sym_LT_EQ_GT] = ACTIONS(6969),
    [anon_sym_EQ_TILDE] = ACTIONS(6969),
    [anon_sym_BANG_TILDE] = ACTIONS(6969),
    [anon_sym_LT_EQ] = ACTIONS(6957),
    [anon_sym_GT] = ACTIONS(6957),
    [anon_sym_GT_EQ] = ACTIONS(6971),
    [anon_sym_CARET] = ACTIONS(6951),
    [anon_sym_PLUS] = ACTIONS(6973),
    [anon_sym_SLASH] = ACTIONS(6953),
    [anon_sym_PERCENT] = ACTIONS(6953),
    [sym_comment] = ACTIONS(87),
  },
  [6840] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(8981),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1851),
    [sym_scope_resolution] = STATE(1845),
    [sym_call] = STATE(1845),
    [sym_method_call] = STATE(1851),
    [sym_assignment] = STATE(8981),
    [sym_operator_assignment] = STATE(8981),
    [sym_conditional] = STATE(8981),
    [sym_range] = STATE(8981),
    [sym_binary] = STATE(8981),
    [sym_unary] = STATE(8981),
    [sym_left_assignment_list] = STATE(1850),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1851),
    [sym__variable] = STATE(1845),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1851),
    [sym_false] = STATE(1851),
    [sym_nil] = STATE(1851),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4193),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3323),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3329),
    [anon_sym_yield] = ACTIONS(3331),
    [anon_sym_break] = ACTIONS(3333),
    [anon_sym_next] = ACTIONS(3335),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6935),
    [anon_sym_defined_QMARK] = ACTIONS(3339),
    [anon_sym_not] = ACTIONS(3341),
    [anon_sym_BANG] = ACTIONS(3345),
    [anon_sym_TILDE] = ACTIONS(3345),
    [sym_constant] = ACTIONS(3351),
    [sym_identifier] = ACTIONS(3351),
    [sym_instance_variable] = ACTIONS(3349),
    [sym_class_variable] = ACTIONS(3349),
    [sym_global_variable] = ACTIONS(3349),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3351),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3351),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6841] = {
    [sym_heredoc_body] = STATE(8982),
    [aux_sym_call_repeat1] = STATE(8982),
    [sym__heredoc_body_start] = ACTIONS(3543),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_RBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [6842] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4151),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1851),
    [sym_scope_resolution] = STATE(1845),
    [sym_call] = STATE(1845),
    [sym_method_call] = STATE(1851),
    [sym__argument] = STATE(4357),
    [sym_splat_argument] = STATE(4357),
    [sym_hash_splat_argument] = STATE(4357),
    [sym_block_argument] = STATE(4357),
    [sym_assignment] = STATE(4151),
    [sym_operator_assignment] = STATE(4151),
    [sym_conditional] = STATE(4151),
    [sym_range] = STATE(4151),
    [sym_binary] = STATE(4151),
    [sym_unary] = STATE(4151),
    [sym_left_assignment_list] = STATE(1850),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1851),
    [sym__variable] = STATE(1845),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1851),
    [sym_false] = STATE(1851),
    [sym_nil] = STATE(1851),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4154),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_heredoc_body] = STATE(8983),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(4357),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(6883),
    [sym__splat_star] = ACTIONS(6885),
    [sym__unary_minus] = ACTIONS(3323),
    [sym__identifier_hash_key] = ACTIONS(6887),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12581),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3329),
    [anon_sym_yield] = ACTIONS(3331),
    [anon_sym_break] = ACTIONS(3333),
    [anon_sym_next] = ACTIONS(3335),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6935),
    [anon_sym_defined_QMARK] = ACTIONS(3339),
    [anon_sym_not] = ACTIONS(3341),
    [anon_sym_BANG] = ACTIONS(3345),
    [anon_sym_TILDE] = ACTIONS(3345),
    [sym_constant] = ACTIONS(6889),
    [sym_identifier] = ACTIONS(6889),
    [sym_instance_variable] = ACTIONS(3349),
    [sym_class_variable] = ACTIONS(3349),
    [sym_global_variable] = ACTIONS(3349),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3351),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3351),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6843] = {
    [sym_heredoc_body] = STATE(8984),
    [aux_sym_call_repeat1] = STATE(8984),
    [aux_sym_argument_list_repeat1] = STATE(8985),
    [sym__heredoc_body_start] = ACTIONS(3543),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_RBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(10387),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [6844] = {
    [sym_heredoc_body] = STATE(6844),
    [aux_sym_call_repeat1] = STATE(6844),
    [sym__heredoc_body_start] = ACTIONS(10455),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_RBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [6845] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(1809),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1814),
    [sym_scope_resolution] = STATE(1810),
    [sym_call] = STATE(1810),
    [sym_method_call] = STATE(1814),
    [sym__argument] = STATE(6908),
    [sym_splat_argument] = STATE(6908),
    [sym_hash_splat_argument] = STATE(6908),
    [sym_block_argument] = STATE(6908),
    [sym_assignment] = STATE(1809),
    [sym_operator_assignment] = STATE(1809),
    [sym_conditional] = STATE(1809),
    [sym_range] = STATE(1809),
    [sym_binary] = STATE(1809),
    [sym_unary] = STATE(1809),
    [sym_left_assignment_list] = STATE(1813),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1814),
    [sym__variable] = STATE(1810),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1814),
    [sym_false] = STATE(1814),
    [sym_nil] = STATE(1814),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1815),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(6908),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(3251),
    [sym__splat_star] = ACTIONS(3253),
    [sym__unary_minus] = ACTIONS(3255),
    [sym__identifier_hash_key] = ACTIONS(3257),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10391),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_break] = ACTIONS(3263),
    [anon_sym_next] = ACTIONS(3265),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6843),
    [anon_sym_defined_QMARK] = ACTIONS(3267),
    [anon_sym_not] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3273),
    [anon_sym_TILDE] = ACTIONS(3273),
    [sym_constant] = ACTIONS(3275),
    [sym_identifier] = ACTIONS(3275),
    [sym_instance_variable] = ACTIONS(3277),
    [sym_class_variable] = ACTIONS(3277),
    [sym_global_variable] = ACTIONS(3277),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3279),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3279),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6846] = {
    [sym_heredoc_body] = STATE(6844),
    [aux_sym_call_repeat1] = STATE(6844),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_RBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [6847] = {
    [aux_sym_argument_list_repeat1] = STATE(6847),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_RBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(12583),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_STAR_STAR] = ACTIONS(7925),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7925),
    [anon_sym_AMP_AMP] = ACTIONS(7925),
    [anon_sym_LT_LT] = ACTIONS(7925),
    [anon_sym_GT_GT] = ACTIONS(7925),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7925),
    [anon_sym_PLUS] = ACTIONS(7925),
    [anon_sym_SLASH] = ACTIONS(7925),
    [anon_sym_PERCENT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [6848] = {
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(6857),
    [sym__binary_star] = ACTIONS(6859),
    [anon_sym_RBRACE] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(6861),
    [anon_sym_STAR_STAR] = ACTIONS(6859),
    [anon_sym_AMP] = ACTIONS(6863),
    [anon_sym_LT] = ACTIONS(6865),
    [anon_sym_EQ_GT] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(6867),
    [anon_sym_DOT_DOT] = ACTIONS(6869),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6871),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(6873),
    [anon_sym_AMP_AMP] = ACTIONS(6873),
    [anon_sym_LT_LT] = ACTIONS(6875),
    [anon_sym_GT_GT] = ACTIONS(6875),
    [anon_sym_EQ_EQ] = ACTIONS(6877),
    [anon_sym_BANG_EQ] = ACTIONS(6873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6873),
    [anon_sym_LT_EQ_GT] = ACTIONS(6873),
    [anon_sym_EQ_TILDE] = ACTIONS(6873),
    [anon_sym_BANG_TILDE] = ACTIONS(6873),
    [anon_sym_LT_EQ] = ACTIONS(6865),
    [anon_sym_GT] = ACTIONS(6865),
    [anon_sym_GT_EQ] = ACTIONS(6879),
    [anon_sym_CARET] = ACTIONS(6881),
    [anon_sym_PLUS] = ACTIONS(6857),
    [anon_sym_SLASH] = ACTIONS(6859),
    [anon_sym_PERCENT] = ACTIONS(6859),
    [sym_comment] = ACTIONS(87),
  },
  [6849] = {
    [aux_sym_exceptions_repeat1] = STATE(8987),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_RBRACE] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [6850] = {
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(6857),
    [sym__binary_star] = ACTIONS(6859),
    [anon_sym_RBRACE] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(6861),
    [anon_sym_STAR_STAR] = ACTIONS(6859),
    [anon_sym_AMP] = ACTIONS(6863),
    [anon_sym_LT] = ACTIONS(6865),
    [anon_sym_EQ_GT] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(6867),
    [anon_sym_DOT_DOT] = ACTIONS(6869),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6871),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(6873),
    [anon_sym_AMP_AMP] = ACTIONS(6873),
    [anon_sym_LT_LT] = ACTIONS(6875),
    [anon_sym_GT_GT] = ACTIONS(6875),
    [anon_sym_EQ_EQ] = ACTIONS(6877),
    [anon_sym_BANG_EQ] = ACTIONS(6873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6873),
    [anon_sym_LT_EQ_GT] = ACTIONS(6873),
    [anon_sym_EQ_TILDE] = ACTIONS(6873),
    [anon_sym_BANG_TILDE] = ACTIONS(6873),
    [anon_sym_LT_EQ] = ACTIONS(6865),
    [anon_sym_GT] = ACTIONS(6865),
    [anon_sym_GT_EQ] = ACTIONS(6879),
    [anon_sym_CARET] = ACTIONS(6881),
    [anon_sym_PLUS] = ACTIONS(6857),
    [anon_sym_SLASH] = ACTIONS(6859),
    [anon_sym_PERCENT] = ACTIONS(6859),
    [sym_comment] = ACTIONS(87),
  },
  [6851] = {
    [sym_string] = STATE(6851),
    [aux_sym_chained_string_repeat1] = STATE(6851),
    [sym__string_start] = ACTIONS(9407),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_RBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_EQ_GT] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [6852] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(8988),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(541),
    [sym_scope_resolution] = STATE(539),
    [sym_call] = STATE(539),
    [sym_method_call] = STATE(541),
    [sym_assignment] = STATE(8988),
    [sym_operator_assignment] = STATE(8988),
    [sym_conditional] = STATE(8988),
    [sym_range] = STATE(8988),
    [sym_binary] = STATE(8988),
    [sym_unary] = STATE(8988),
    [sym_left_assignment_list] = STATE(540),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(541),
    [sym__variable] = STATE(539),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(541),
    [sym_false] = STATE(541),
    [sym_nil] = STATE(541),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(542),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1021),
    [anon_sym_defined_QMARK] = ACTIONS(1023),
    [anon_sym_not] = ACTIONS(1025),
    [anon_sym_BANG] = ACTIONS(1027),
    [anon_sym_TILDE] = ACTIONS(1027),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6853] = {
    [sym__simple_symbol] = ACTIONS(4285),
    [sym__string_start] = ACTIONS(4285),
    [sym__symbol_start] = ACTIONS(4285),
    [sym__subshell_start] = ACTIONS(4285),
    [sym__regex_start] = ACTIONS(4285),
    [sym__string_array_start] = ACTIONS(4285),
    [sym__symbol_array_start] = ACTIONS(4285),
    [sym__heredoc_body_start] = ACTIONS(4285),
    [sym_heredoc_beginning] = ACTIONS(4285),
    [sym__block_ampersand] = ACTIONS(4285),
    [sym__splat_star] = ACTIONS(4285),
    [sym__unary_minus] = ACTIONS(4285),
    [sym__binary_minus] = ACTIONS(4285),
    [sym__binary_star] = ACTIONS(4285),
    [sym__identifier_hash_key] = ACTIONS(4285),
    [anon_sym_LBRACE] = ACTIONS(4285),
    [anon_sym_RBRACE] = ACTIONS(4285),
    [anon_sym_def] = ACTIONS(4287),
    [anon_sym_LPAREN] = ACTIONS(4287),
    [anon_sym_RPAREN] = ACTIONS(4285),
    [anon_sym_DOT] = ACTIONS(4287),
    [anon_sym_COLON_COLON] = ACTIONS(4287),
    [anon_sym_COMMA] = ACTIONS(4285),
    [anon_sym_PIPE] = ACTIONS(4287),
    [anon_sym_SEMI] = ACTIONS(4285),
    [anon_sym_STAR] = ACTIONS(4287),
    [anon_sym_STAR_STAR] = ACTIONS(4287),
    [anon_sym_AMP] = ACTIONS(4287),
    [anon_sym_EQ] = ACTIONS(4287),
    [anon_sym_class] = ACTIONS(4287),
    [anon_sym_LT] = ACTIONS(4287),
    [anon_sym_module] = ACTIONS(4287),
    [anon_sym_return] = ACTIONS(4287),
    [anon_sym_yield] = ACTIONS(4287),
    [anon_sym_break] = ACTIONS(4287),
    [anon_sym_next] = ACTIONS(4287),
    [sym_redo] = ACTIONS(4287),
    [sym_retry] = ACTIONS(4287),
    [anon_sym_if] = ACTIONS(4287),
    [anon_sym_unless] = ACTIONS(4287),
    [anon_sym_while] = ACTIONS(4287),
    [anon_sym_until] = ACTIONS(4287),
    [anon_sym_rescue] = ACTIONS(4287),
    [anon_sym_for] = ACTIONS(4287),
    [anon_sym_in] = ACTIONS(4287),
    [anon_sym_do] = ACTIONS(4287),
    [anon_sym_case] = ACTIONS(4287),
    [anon_sym_begin] = ACTIONS(4287),
    [anon_sym_LBRACK] = ACTIONS(4285),
    [anon_sym_RBRACK] = ACTIONS(4285),
    [anon_sym_COLON_COLON2] = ACTIONS(4285),
    [anon_sym_AMP_DOT] = ACTIONS(4285),
    [anon_sym_LPAREN2] = ACTIONS(4285),
    [anon_sym_PLUS_EQ] = ACTIONS(4285),
    [anon_sym_DASH_EQ] = ACTIONS(4285),
    [anon_sym_STAR_EQ] = ACTIONS(4285),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4285),
    [anon_sym_SLASH_EQ] = ACTIONS(4285),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4285),
    [anon_sym_PIPE_EQ] = ACTIONS(4285),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4285),
    [anon_sym_AMP_EQ] = ACTIONS(4285),
    [anon_sym_PERCENT_EQ] = ACTIONS(4285),
    [anon_sym_GT_GT_EQ] = ACTIONS(4285),
    [anon_sym_LT_LT_EQ] = ACTIONS(4285),
    [anon_sym_CARET_EQ] = ACTIONS(4285),
    [anon_sym_QMARK] = ACTIONS(4287),
    [anon_sym_COLON2] = ACTIONS(4287),
    [anon_sym_DOT_DOT] = ACTIONS(4287),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4285),
    [anon_sym_and] = ACTIONS(4287),
    [anon_sym_or] = ACTIONS(4287),
    [anon_sym_PIPE_PIPE] = ACTIONS(4287),
    [anon_sym_AMP_AMP] = ACTIONS(4287),
    [anon_sym_LT_LT] = ACTIONS(4287),
    [anon_sym_GT_GT] = ACTIONS(4287),
    [anon_sym_EQ_EQ] = ACTIONS(4287),
    [anon_sym_BANG_EQ] = ACTIONS(4285),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4285),
    [anon_sym_LT_EQ_GT] = ACTIONS(4285),
    [anon_sym_EQ_TILDE] = ACTIONS(4285),
    [anon_sym_BANG_TILDE] = ACTIONS(4285),
    [anon_sym_LT_EQ] = ACTIONS(4287),
    [anon_sym_GT] = ACTIONS(4287),
    [anon_sym_GT_EQ] = ACTIONS(4285),
    [anon_sym_CARET] = ACTIONS(4287),
    [anon_sym_PLUS] = ACTIONS(4287),
    [anon_sym_SLASH] = ACTIONS(4287),
    [anon_sym_PERCENT] = ACTIONS(4287),
    [anon_sym_defined_QMARK] = ACTIONS(4285),
    [anon_sym_not] = ACTIONS(4287),
    [anon_sym_BANG] = ACTIONS(4287),
    [anon_sym_TILDE] = ACTIONS(4285),
    [sym_constant] = ACTIONS(4287),
    [sym_identifier] = ACTIONS(4287),
    [sym_instance_variable] = ACTIONS(4285),
    [sym_class_variable] = ACTIONS(4285),
    [sym_global_variable] = ACTIONS(4285),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4287),
    [sym_float] = ACTIONS(4287),
    [sym_complex] = ACTIONS(4285),
    [sym_super] = ACTIONS(4287),
    [anon_sym_true] = ACTIONS(4287),
    [anon_sym_TRUE] = ACTIONS(4287),
    [anon_sym_false] = ACTIONS(4287),
    [anon_sym_FALSE] = ACTIONS(4287),
    [sym_self] = ACTIONS(4287),
    [anon_sym_nil] = ACTIONS(4287),
    [anon_sym_NIL] = ACTIONS(4287),
    [sym_character] = ACTIONS(4285),
    [anon_sym_LBRACK2] = ACTIONS(4287),
    [anon_sym_DASH_GT] = ACTIONS(4285),
  },
  [6854] = {
    [anon_sym_RPAREN] = ACTIONS(12586),
    [sym_comment] = ACTIONS(87),
  },
  [6855] = {
    [sym__simple_symbol] = ACTIONS(9679),
    [sym__string_start] = ACTIONS(9679),
    [sym__symbol_start] = ACTIONS(9679),
    [sym__subshell_start] = ACTIONS(9679),
    [sym__regex_start] = ACTIONS(9679),
    [sym__string_array_start] = ACTIONS(9679),
    [sym__symbol_array_start] = ACTIONS(9679),
    [sym__heredoc_body_start] = ACTIONS(9679),
    [sym_heredoc_beginning] = ACTIONS(9679),
    [sym__block_ampersand] = ACTIONS(9679),
    [sym__splat_star] = ACTIONS(9679),
    [sym__unary_minus] = ACTIONS(9679),
    [sym__binary_minus] = ACTIONS(9679),
    [sym__binary_star] = ACTIONS(9679),
    [sym__identifier_hash_key] = ACTIONS(9679),
    [anon_sym_LBRACE] = ACTIONS(9679),
    [anon_sym_RBRACE] = ACTIONS(9679),
    [anon_sym_def] = ACTIONS(9681),
    [anon_sym_LPAREN] = ACTIONS(9681),
    [anon_sym_RPAREN] = ACTIONS(9679),
    [anon_sym_DOT] = ACTIONS(9681),
    [anon_sym_COLON_COLON] = ACTIONS(9681),
    [anon_sym_COMMA] = ACTIONS(9679),
    [anon_sym_PIPE] = ACTIONS(9681),
    [anon_sym_SEMI] = ACTIONS(9679),
    [anon_sym_STAR] = ACTIONS(9681),
    [anon_sym_STAR_STAR] = ACTIONS(9681),
    [anon_sym_AMP] = ACTIONS(9681),
    [anon_sym_EQ] = ACTIONS(9681),
    [anon_sym_class] = ACTIONS(9681),
    [anon_sym_LT] = ACTIONS(9681),
    [anon_sym_module] = ACTIONS(9681),
    [anon_sym_return] = ACTIONS(9681),
    [anon_sym_yield] = ACTIONS(9681),
    [anon_sym_break] = ACTIONS(9681),
    [anon_sym_next] = ACTIONS(9681),
    [sym_redo] = ACTIONS(9681),
    [sym_retry] = ACTIONS(9681),
    [anon_sym_if] = ACTIONS(9681),
    [anon_sym_unless] = ACTIONS(9681),
    [anon_sym_while] = ACTIONS(9681),
    [anon_sym_until] = ACTIONS(9681),
    [anon_sym_rescue] = ACTIONS(9681),
    [anon_sym_for] = ACTIONS(9681),
    [anon_sym_in] = ACTIONS(9681),
    [anon_sym_do] = ACTIONS(9681),
    [anon_sym_case] = ACTIONS(9681),
    [anon_sym_begin] = ACTIONS(9681),
    [anon_sym_LBRACK] = ACTIONS(9679),
    [anon_sym_RBRACK] = ACTIONS(9679),
    [anon_sym_COLON_COLON2] = ACTIONS(9679),
    [anon_sym_AMP_DOT] = ACTIONS(9679),
    [anon_sym_LPAREN2] = ACTIONS(9679),
    [anon_sym_PLUS_EQ] = ACTIONS(9679),
    [anon_sym_DASH_EQ] = ACTIONS(9679),
    [anon_sym_STAR_EQ] = ACTIONS(9679),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9679),
    [anon_sym_SLASH_EQ] = ACTIONS(9679),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9679),
    [anon_sym_PIPE_EQ] = ACTIONS(9679),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9679),
    [anon_sym_AMP_EQ] = ACTIONS(9679),
    [anon_sym_PERCENT_EQ] = ACTIONS(9679),
    [anon_sym_GT_GT_EQ] = ACTIONS(9679),
    [anon_sym_LT_LT_EQ] = ACTIONS(9679),
    [anon_sym_CARET_EQ] = ACTIONS(9679),
    [anon_sym_QMARK] = ACTIONS(9681),
    [anon_sym_COLON2] = ACTIONS(9681),
    [anon_sym_DOT_DOT] = ACTIONS(9681),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9679),
    [anon_sym_and] = ACTIONS(9681),
    [anon_sym_or] = ACTIONS(9681),
    [anon_sym_PIPE_PIPE] = ACTIONS(9681),
    [anon_sym_AMP_AMP] = ACTIONS(9681),
    [anon_sym_LT_LT] = ACTIONS(9681),
    [anon_sym_GT_GT] = ACTIONS(9681),
    [anon_sym_EQ_EQ] = ACTIONS(9681),
    [anon_sym_BANG_EQ] = ACTIONS(9679),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9679),
    [anon_sym_LT_EQ_GT] = ACTIONS(9679),
    [anon_sym_EQ_TILDE] = ACTIONS(9679),
    [anon_sym_BANG_TILDE] = ACTIONS(9679),
    [anon_sym_LT_EQ] = ACTIONS(9681),
    [anon_sym_GT] = ACTIONS(9681),
    [anon_sym_GT_EQ] = ACTIONS(9679),
    [anon_sym_CARET] = ACTIONS(9681),
    [anon_sym_PLUS] = ACTIONS(9681),
    [anon_sym_SLASH] = ACTIONS(9681),
    [anon_sym_PERCENT] = ACTIONS(9681),
    [anon_sym_defined_QMARK] = ACTIONS(9679),
    [anon_sym_not] = ACTIONS(9681),
    [anon_sym_BANG] = ACTIONS(9681),
    [anon_sym_TILDE] = ACTIONS(9679),
    [sym_constant] = ACTIONS(9681),
    [sym_identifier] = ACTIONS(9681),
    [sym_instance_variable] = ACTIONS(9679),
    [sym_class_variable] = ACTIONS(9679),
    [sym_global_variable] = ACTIONS(9679),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(9681),
    [sym_float] = ACTIONS(9681),
    [sym_complex] = ACTIONS(9679),
    [sym_super] = ACTIONS(9681),
    [anon_sym_true] = ACTIONS(9681),
    [anon_sym_TRUE] = ACTIONS(9681),
    [anon_sym_false] = ACTIONS(9681),
    [anon_sym_FALSE] = ACTIONS(9681),
    [sym_self] = ACTIONS(9681),
    [anon_sym_nil] = ACTIONS(9681),
    [anon_sym_NIL] = ACTIONS(9681),
    [sym_character] = ACTIONS(9679),
    [anon_sym_LBRACK2] = ACTIONS(9681),
    [anon_sym_DASH_GT] = ACTIONS(9679),
  },
  [6856] = {
    [sym__heredoc_body_start] = ACTIONS(9686),
    [sym__binary_minus] = ACTIONS(9686),
    [sym__binary_star] = ACTIONS(9686),
    [anon_sym_LBRACE] = ACTIONS(9686),
    [anon_sym_RBRACE] = ACTIONS(9686),
    [anon_sym_RPAREN] = ACTIONS(9686),
    [anon_sym_DOT] = ACTIONS(9688),
    [anon_sym_COMMA] = ACTIONS(9686),
    [anon_sym_PIPE] = ACTIONS(9688),
    [anon_sym_SEMI] = ACTIONS(9686),
    [anon_sym_STAR_STAR] = ACTIONS(9688),
    [anon_sym_AMP] = ACTIONS(9688),
    [anon_sym_EQ] = ACTIONS(9688),
    [anon_sym_LT] = ACTIONS(9688),
    [anon_sym_if] = ACTIONS(9686),
    [anon_sym_unless] = ACTIONS(9686),
    [anon_sym_while] = ACTIONS(9686),
    [anon_sym_until] = ACTIONS(9686),
    [anon_sym_rescue] = ACTIONS(9686),
    [anon_sym_in] = ACTIONS(9686),
    [anon_sym_do] = ACTIONS(9686),
    [anon_sym_LBRACK] = ACTIONS(9686),
    [anon_sym_RBRACK] = ACTIONS(9686),
    [anon_sym_COLON_COLON2] = ACTIONS(9686),
    [anon_sym_AMP_DOT] = ACTIONS(9686),
    [anon_sym_PLUS_EQ] = ACTIONS(9686),
    [anon_sym_DASH_EQ] = ACTIONS(9686),
    [anon_sym_STAR_EQ] = ACTIONS(9686),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9686),
    [anon_sym_SLASH_EQ] = ACTIONS(9686),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9686),
    [anon_sym_PIPE_EQ] = ACTIONS(9686),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9686),
    [anon_sym_AMP_EQ] = ACTIONS(9686),
    [anon_sym_PERCENT_EQ] = ACTIONS(9686),
    [anon_sym_GT_GT_EQ] = ACTIONS(9686),
    [anon_sym_LT_LT_EQ] = ACTIONS(9686),
    [anon_sym_CARET_EQ] = ACTIONS(9686),
    [anon_sym_QMARK] = ACTIONS(9686),
    [anon_sym_COLON2] = ACTIONS(9688),
    [anon_sym_DOT_DOT] = ACTIONS(9688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9686),
    [anon_sym_and] = ACTIONS(9686),
    [anon_sym_or] = ACTIONS(9686),
    [anon_sym_PIPE_PIPE] = ACTIONS(9688),
    [anon_sym_AMP_AMP] = ACTIONS(9688),
    [anon_sym_LT_LT] = ACTIONS(9688),
    [anon_sym_GT_GT] = ACTIONS(9688),
    [anon_sym_EQ_EQ] = ACTIONS(9688),
    [anon_sym_BANG_EQ] = ACTIONS(9686),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9686),
    [anon_sym_LT_EQ_GT] = ACTIONS(9686),
    [anon_sym_EQ_TILDE] = ACTIONS(9686),
    [anon_sym_BANG_TILDE] = ACTIONS(9686),
    [anon_sym_LT_EQ] = ACTIONS(9688),
    [anon_sym_GT] = ACTIONS(9688),
    [anon_sym_GT_EQ] = ACTIONS(9686),
    [anon_sym_CARET] = ACTIONS(9688),
    [anon_sym_PLUS] = ACTIONS(9688),
    [anon_sym_SLASH] = ACTIONS(9688),
    [anon_sym_PERCENT] = ACTIONS(9688),
    [sym_comment] = ACTIONS(87),
  },
  [6857] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(10407),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [6858] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(10401),
    [sym__binary_star] = ACTIONS(10403),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(10405),
    [anon_sym_STAR_STAR] = ACTIONS(10407),
    [anon_sym_AMP] = ACTIONS(10409),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(10411),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(10413),
    [anon_sym_DOT_DOT] = ACTIONS(10415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10417),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(10419),
    [anon_sym_AMP_AMP] = ACTIONS(10419),
    [anon_sym_LT_LT] = ACTIONS(10421),
    [anon_sym_GT_GT] = ACTIONS(10421),
    [anon_sym_EQ_EQ] = ACTIONS(10419),
    [anon_sym_BANG_EQ] = ACTIONS(10423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10423),
    [anon_sym_LT_EQ_GT] = ACTIONS(10423),
    [anon_sym_EQ_TILDE] = ACTIONS(10423),
    [anon_sym_BANG_TILDE] = ACTIONS(10423),
    [anon_sym_LT_EQ] = ACTIONS(10411),
    [anon_sym_GT] = ACTIONS(10411),
    [anon_sym_GT_EQ] = ACTIONS(10425),
    [anon_sym_CARET] = ACTIONS(10405),
    [anon_sym_PLUS] = ACTIONS(10427),
    [anon_sym_SLASH] = ACTIONS(10407),
    [anon_sym_PERCENT] = ACTIONS(10407),
    [sym_comment] = ACTIONS(87),
  },
  [6859] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(8990),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(4189),
    [sym_scope_resolution] = STATE(4187),
    [sym_call] = STATE(4187),
    [sym_method_call] = STATE(4189),
    [sym_assignment] = STATE(8990),
    [sym_operator_assignment] = STATE(8990),
    [sym_conditional] = STATE(8990),
    [sym_range] = STATE(8990),
    [sym_binary] = STATE(8990),
    [sym_unary] = STATE(8990),
    [sym_left_assignment_list] = STATE(4188),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4189),
    [sym__variable] = STATE(4187),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(4189),
    [sym_false] = STATE(4189),
    [sym_nil] = STATE(4189),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(4190),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(6913),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(6915),
    [anon_sym_yield] = ACTIONS(6917),
    [anon_sym_break] = ACTIONS(6919),
    [anon_sym_next] = ACTIONS(6921),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_defined_QMARK] = ACTIONS(6925),
    [anon_sym_not] = ACTIONS(6927),
    [anon_sym_BANG] = ACTIONS(6929),
    [anon_sym_TILDE] = ACTIONS(6929),
    [sym_constant] = ACTIONS(6931),
    [sym_identifier] = ACTIONS(6931),
    [sym_instance_variable] = ACTIONS(6933),
    [sym_class_variable] = ACTIONS(6933),
    [sym_global_variable] = ACTIONS(6933),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(6931),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6931),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [6860] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(8991),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(4189),
    [sym_scope_resolution] = STATE(4187),
    [sym_call] = STATE(4187),
    [sym_method_call] = STATE(4189),
    [sym_assignment] = STATE(8991),
    [sym_operator_assignment] = STATE(8991),
    [sym_conditional] = STATE(8991),
    [sym_range] = STATE(8991),
    [sym_binary] = STATE(8991),
    [sym_unary] = STATE(8991),
    [sym_left_assignment_list] = STATE(4188),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4189),
    [sym__variable] = STATE(4187),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(4189),
    [sym_false] = STATE(4189),
    [sym_nil] = STATE(4189),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(4190),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(6913),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(6915),
    [anon_sym_yield] = ACTIONS(6917),
    [anon_sym_break] = ACTIONS(6919),
    [anon_sym_next] = ACTIONS(6921),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_defined_QMARK] = ACTIONS(6925),
    [anon_sym_not] = ACTIONS(6927),
    [anon_sym_BANG] = ACTIONS(6929),
    [anon_sym_TILDE] = ACTIONS(6929),
    [sym_constant] = ACTIONS(6931),
    [sym_identifier] = ACTIONS(6931),
    [sym_instance_variable] = ACTIONS(6933),
    [sym_class_variable] = ACTIONS(6933),
    [sym_global_variable] = ACTIONS(6933),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(6931),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6931),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [6861] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(8992),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(4189),
    [sym_scope_resolution] = STATE(4187),
    [sym_call] = STATE(4187),
    [sym_method_call] = STATE(4189),
    [sym_assignment] = STATE(8992),
    [sym_operator_assignment] = STATE(8992),
    [sym_conditional] = STATE(8992),
    [sym_range] = STATE(8992),
    [sym_binary] = STATE(8992),
    [sym_unary] = STATE(8992),
    [sym_left_assignment_list] = STATE(4188),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4189),
    [sym__variable] = STATE(4187),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(4189),
    [sym_false] = STATE(4189),
    [sym_nil] = STATE(4189),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(4190),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(6913),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(6915),
    [anon_sym_yield] = ACTIONS(6917),
    [anon_sym_break] = ACTIONS(6919),
    [anon_sym_next] = ACTIONS(6921),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_defined_QMARK] = ACTIONS(6925),
    [anon_sym_not] = ACTIONS(6927),
    [anon_sym_BANG] = ACTIONS(6929),
    [anon_sym_TILDE] = ACTIONS(6929),
    [sym_constant] = ACTIONS(6931),
    [sym_identifier] = ACTIONS(6931),
    [sym_instance_variable] = ACTIONS(6933),
    [sym_class_variable] = ACTIONS(6933),
    [sym_global_variable] = ACTIONS(6933),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(6931),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6931),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [6862] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(8993),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(4189),
    [sym_scope_resolution] = STATE(4187),
    [sym_call] = STATE(4187),
    [sym_method_call] = STATE(4189),
    [sym_assignment] = STATE(8993),
    [sym_operator_assignment] = STATE(8993),
    [sym_conditional] = STATE(8993),
    [sym_range] = STATE(8993),
    [sym_binary] = STATE(8993),
    [sym_unary] = STATE(8993),
    [sym_left_assignment_list] = STATE(4188),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4189),
    [sym__variable] = STATE(4187),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(4189),
    [sym_false] = STATE(4189),
    [sym_nil] = STATE(4189),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(4190),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(6913),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(6915),
    [anon_sym_yield] = ACTIONS(6917),
    [anon_sym_break] = ACTIONS(6919),
    [anon_sym_next] = ACTIONS(6921),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_defined_QMARK] = ACTIONS(6925),
    [anon_sym_not] = ACTIONS(6927),
    [anon_sym_BANG] = ACTIONS(6929),
    [anon_sym_TILDE] = ACTIONS(6929),
    [sym_constant] = ACTIONS(6931),
    [sym_identifier] = ACTIONS(6931),
    [sym_instance_variable] = ACTIONS(6933),
    [sym_class_variable] = ACTIONS(6933),
    [sym_global_variable] = ACTIONS(6933),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(6931),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6931),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [6863] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(8994),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(4189),
    [sym_scope_resolution] = STATE(4187),
    [sym_call] = STATE(4187),
    [sym_method_call] = STATE(4189),
    [sym_assignment] = STATE(8994),
    [sym_operator_assignment] = STATE(8994),
    [sym_conditional] = STATE(8994),
    [sym_range] = STATE(8994),
    [sym_binary] = STATE(8994),
    [sym_unary] = STATE(8994),
    [sym_left_assignment_list] = STATE(4188),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4189),
    [sym__variable] = STATE(4187),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(4189),
    [sym_false] = STATE(4189),
    [sym_nil] = STATE(4189),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(4190),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(6913),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(6915),
    [anon_sym_yield] = ACTIONS(6917),
    [anon_sym_break] = ACTIONS(6919),
    [anon_sym_next] = ACTIONS(6921),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_defined_QMARK] = ACTIONS(6925),
    [anon_sym_not] = ACTIONS(6927),
    [anon_sym_BANG] = ACTIONS(6929),
    [anon_sym_TILDE] = ACTIONS(6929),
    [sym_constant] = ACTIONS(6931),
    [sym_identifier] = ACTIONS(6931),
    [sym_instance_variable] = ACTIONS(6933),
    [sym_class_variable] = ACTIONS(6933),
    [sym_global_variable] = ACTIONS(6933),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(6931),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6931),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [6864] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(8995),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(8995),
    [sym_operator_assignment] = STATE(8995),
    [sym_conditional] = STATE(8995),
    [sym_range] = STATE(8995),
    [sym_binary] = STATE(8995),
    [sym_unary] = STATE(8995),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6865] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(8996),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(4189),
    [sym_scope_resolution] = STATE(4187),
    [sym_call] = STATE(4187),
    [sym_method_call] = STATE(4189),
    [sym_assignment] = STATE(8996),
    [sym_operator_assignment] = STATE(8996),
    [sym_conditional] = STATE(8996),
    [sym_range] = STATE(8996),
    [sym_binary] = STATE(8996),
    [sym_unary] = STATE(8996),
    [sym_left_assignment_list] = STATE(4188),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4189),
    [sym__variable] = STATE(4187),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(4189),
    [sym_false] = STATE(4189),
    [sym_nil] = STATE(4189),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(4190),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(6913),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(6915),
    [anon_sym_yield] = ACTIONS(6917),
    [anon_sym_break] = ACTIONS(6919),
    [anon_sym_next] = ACTIONS(6921),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_defined_QMARK] = ACTIONS(6925),
    [anon_sym_not] = ACTIONS(6927),
    [anon_sym_BANG] = ACTIONS(6929),
    [anon_sym_TILDE] = ACTIONS(6929),
    [sym_constant] = ACTIONS(6931),
    [sym_identifier] = ACTIONS(6931),
    [sym_instance_variable] = ACTIONS(6933),
    [sym_class_variable] = ACTIONS(6933),
    [sym_global_variable] = ACTIONS(6933),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(6931),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6931),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [6866] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(8997),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(4189),
    [sym_scope_resolution] = STATE(4187),
    [sym_call] = STATE(4187),
    [sym_method_call] = STATE(4189),
    [sym_assignment] = STATE(8997),
    [sym_operator_assignment] = STATE(8997),
    [sym_conditional] = STATE(8997),
    [sym_range] = STATE(8997),
    [sym_binary] = STATE(8997),
    [sym_unary] = STATE(8997),
    [sym_left_assignment_list] = STATE(4188),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4189),
    [sym__variable] = STATE(4187),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(4189),
    [sym_false] = STATE(4189),
    [sym_nil] = STATE(4189),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(4190),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(6913),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(6915),
    [anon_sym_yield] = ACTIONS(6917),
    [anon_sym_break] = ACTIONS(6919),
    [anon_sym_next] = ACTIONS(6921),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_defined_QMARK] = ACTIONS(6925),
    [anon_sym_not] = ACTIONS(6927),
    [anon_sym_BANG] = ACTIONS(6929),
    [anon_sym_TILDE] = ACTIONS(6929),
    [sym_constant] = ACTIONS(6931),
    [sym_identifier] = ACTIONS(6931),
    [sym_instance_variable] = ACTIONS(6933),
    [sym_class_variable] = ACTIONS(6933),
    [sym_global_variable] = ACTIONS(6933),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(6931),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6931),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [6867] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(8998),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(4189),
    [sym_scope_resolution] = STATE(4187),
    [sym_call] = STATE(4187),
    [sym_method_call] = STATE(4189),
    [sym_assignment] = STATE(8998),
    [sym_operator_assignment] = STATE(8998),
    [sym_conditional] = STATE(8998),
    [sym_range] = STATE(8998),
    [sym_binary] = STATE(8998),
    [sym_unary] = STATE(8998),
    [sym_left_assignment_list] = STATE(4188),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4189),
    [sym__variable] = STATE(4187),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(4189),
    [sym_false] = STATE(4189),
    [sym_nil] = STATE(4189),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(4190),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(6913),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(6915),
    [anon_sym_yield] = ACTIONS(6917),
    [anon_sym_break] = ACTIONS(6919),
    [anon_sym_next] = ACTIONS(6921),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_defined_QMARK] = ACTIONS(6925),
    [anon_sym_not] = ACTIONS(6927),
    [anon_sym_BANG] = ACTIONS(6929),
    [anon_sym_TILDE] = ACTIONS(6929),
    [sym_constant] = ACTIONS(6931),
    [sym_identifier] = ACTIONS(6931),
    [sym_instance_variable] = ACTIONS(6933),
    [sym_class_variable] = ACTIONS(6933),
    [sym_global_variable] = ACTIONS(6933),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(6931),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6931),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [6868] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(8999),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(4189),
    [sym_scope_resolution] = STATE(4187),
    [sym_call] = STATE(4187),
    [sym_method_call] = STATE(4189),
    [sym_assignment] = STATE(8999),
    [sym_operator_assignment] = STATE(8999),
    [sym_conditional] = STATE(8999),
    [sym_range] = STATE(8999),
    [sym_binary] = STATE(8999),
    [sym_unary] = STATE(8999),
    [sym_left_assignment_list] = STATE(4188),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4189),
    [sym__variable] = STATE(4187),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(4189),
    [sym_false] = STATE(4189),
    [sym_nil] = STATE(4189),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(4190),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(6913),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(6915),
    [anon_sym_yield] = ACTIONS(6917),
    [anon_sym_break] = ACTIONS(6919),
    [anon_sym_next] = ACTIONS(6921),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_defined_QMARK] = ACTIONS(6925),
    [anon_sym_not] = ACTIONS(6927),
    [anon_sym_BANG] = ACTIONS(6929),
    [anon_sym_TILDE] = ACTIONS(6929),
    [sym_constant] = ACTIONS(6931),
    [sym_identifier] = ACTIONS(6931),
    [sym_instance_variable] = ACTIONS(6933),
    [sym_class_variable] = ACTIONS(6933),
    [sym_global_variable] = ACTIONS(6933),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(6931),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6931),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [6869] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(9000),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(4189),
    [sym_scope_resolution] = STATE(4187),
    [sym_call] = STATE(4187),
    [sym_method_call] = STATE(4189),
    [sym_splat_argument] = STATE(9001),
    [sym_assignment] = STATE(9000),
    [sym_operator_assignment] = STATE(9000),
    [sym_conditional] = STATE(9000),
    [sym_range] = STATE(9000),
    [sym_binary] = STATE(9000),
    [sym_unary] = STATE(9000),
    [sym_right_assignment_list] = STATE(8878),
    [sym__arg_or_splat_arg] = STATE(9001),
    [sym_left_assignment_list] = STATE(4188),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4189),
    [sym__variable] = STATE(4187),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(4189),
    [sym_false] = STATE(4189),
    [sym_nil] = STATE(4189),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(4190),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__splat_star] = ACTIONS(3321),
    [sym__unary_minus] = ACTIONS(6913),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(6915),
    [anon_sym_yield] = ACTIONS(6917),
    [anon_sym_break] = ACTIONS(6919),
    [anon_sym_next] = ACTIONS(6921),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_defined_QMARK] = ACTIONS(6925),
    [anon_sym_not] = ACTIONS(6927),
    [anon_sym_BANG] = ACTIONS(6929),
    [anon_sym_TILDE] = ACTIONS(6929),
    [sym_constant] = ACTIONS(6931),
    [sym_identifier] = ACTIONS(6931),
    [sym_instance_variable] = ACTIONS(6933),
    [sym_class_variable] = ACTIONS(6933),
    [sym_global_variable] = ACTIONS(6933),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(6931),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6931),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [6870] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(9002),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(4189),
    [sym_scope_resolution] = STATE(4187),
    [sym_call] = STATE(4187),
    [sym_method_call] = STATE(4189),
    [sym_assignment] = STATE(9002),
    [sym_operator_assignment] = STATE(9002),
    [sym_conditional] = STATE(9002),
    [sym_range] = STATE(9002),
    [sym_binary] = STATE(9002),
    [sym_unary] = STATE(9002),
    [sym_left_assignment_list] = STATE(4188),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4189),
    [sym__variable] = STATE(4187),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(4189),
    [sym_false] = STATE(4189),
    [sym_nil] = STATE(4189),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(4190),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(6913),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(6915),
    [anon_sym_yield] = ACTIONS(6917),
    [anon_sym_break] = ACTIONS(6919),
    [anon_sym_next] = ACTIONS(6921),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_defined_QMARK] = ACTIONS(6925),
    [anon_sym_not] = ACTIONS(6927),
    [anon_sym_BANG] = ACTIONS(6929),
    [anon_sym_TILDE] = ACTIONS(6929),
    [sym_constant] = ACTIONS(6931),
    [sym_identifier] = ACTIONS(6931),
    [sym_instance_variable] = ACTIONS(6933),
    [sym_class_variable] = ACTIONS(6933),
    [sym_global_variable] = ACTIONS(6933),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(6931),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6931),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [6871] = {
    [sym_string] = STATE(9003),
    [aux_sym_chained_string_repeat1] = STATE(9003),
    [sym__string_start] = ACTIONS(6455),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_RBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_STAR_STAR] = ACTIONS(2755),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_EQ] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_PLUS_EQ] = ACTIONS(2753),
    [anon_sym_DASH_EQ] = ACTIONS(2753),
    [anon_sym_STAR_EQ] = ACTIONS(2753),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2753),
    [anon_sym_SLASH_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2753),
    [anon_sym_AMP_EQ] = ACTIONS(2753),
    [anon_sym_PERCENT_EQ] = ACTIONS(2753),
    [anon_sym_GT_GT_EQ] = ACTIONS(2753),
    [anon_sym_LT_LT_EQ] = ACTIONS(2753),
    [anon_sym_CARET_EQ] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2755),
    [anon_sym_AMP_AMP] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2755),
    [anon_sym_GT_GT] = ACTIONS(2755),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_SLASH] = ACTIONS(2755),
    [anon_sym_PERCENT] = ACTIONS(2755),
    [sym_comment] = ACTIONS(87),
  },
  [6872] = {
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(10401),
    [sym__binary_star] = ACTIONS(10403),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_RBRACE] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(10405),
    [anon_sym_STAR_STAR] = ACTIONS(10407),
    [anon_sym_AMP] = ACTIONS(10409),
    [anon_sym_EQ] = ACTIONS(7822),
    [anon_sym_LT] = ACTIONS(10411),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_PLUS_EQ] = ACTIONS(6823),
    [anon_sym_DASH_EQ] = ACTIONS(6823),
    [anon_sym_STAR_EQ] = ACTIONS(6823),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6823),
    [anon_sym_SLASH_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6823),
    [anon_sym_AMP_EQ] = ACTIONS(6823),
    [anon_sym_PERCENT_EQ] = ACTIONS(6823),
    [anon_sym_GT_GT_EQ] = ACTIONS(6823),
    [anon_sym_LT_LT_EQ] = ACTIONS(6823),
    [anon_sym_CARET_EQ] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(10413),
    [anon_sym_DOT_DOT] = ACTIONS(10415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10417),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(10419),
    [anon_sym_AMP_AMP] = ACTIONS(10419),
    [anon_sym_LT_LT] = ACTIONS(10421),
    [anon_sym_GT_GT] = ACTIONS(10421),
    [anon_sym_EQ_EQ] = ACTIONS(10419),
    [anon_sym_BANG_EQ] = ACTIONS(10423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10423),
    [anon_sym_LT_EQ_GT] = ACTIONS(10423),
    [anon_sym_EQ_TILDE] = ACTIONS(10423),
    [anon_sym_BANG_TILDE] = ACTIONS(10423),
    [anon_sym_LT_EQ] = ACTIONS(10411),
    [anon_sym_GT] = ACTIONS(10411),
    [anon_sym_GT_EQ] = ACTIONS(10425),
    [anon_sym_CARET] = ACTIONS(10405),
    [anon_sym_PLUS] = ACTIONS(10427),
    [anon_sym_SLASH] = ACTIONS(10407),
    [anon_sym_PERCENT] = ACTIONS(10407),
    [sym_comment] = ACTIONS(87),
  },
  [6873] = {
    [sym__heredoc_body_start] = ACTIONS(9426),
    [sym__binary_minus] = ACTIONS(9426),
    [sym__binary_star] = ACTIONS(9426),
    [anon_sym_LBRACE] = ACTIONS(9426),
    [anon_sym_RBRACE] = ACTIONS(9426),
    [anon_sym_RPAREN] = ACTIONS(9426),
    [anon_sym_DOT] = ACTIONS(9428),
    [anon_sym_COMMA] = ACTIONS(9426),
    [anon_sym_PIPE] = ACTIONS(9428),
    [anon_sym_SEMI] = ACTIONS(9426),
    [anon_sym_STAR_STAR] = ACTIONS(9428),
    [anon_sym_AMP] = ACTIONS(9428),
    [anon_sym_EQ] = ACTIONS(9428),
    [anon_sym_LT] = ACTIONS(9428),
    [anon_sym_if] = ACTIONS(9426),
    [anon_sym_unless] = ACTIONS(9426),
    [anon_sym_while] = ACTIONS(9426),
    [anon_sym_until] = ACTIONS(9426),
    [anon_sym_rescue] = ACTIONS(9426),
    [anon_sym_in] = ACTIONS(9426),
    [anon_sym_do] = ACTIONS(9426),
    [anon_sym_LBRACK] = ACTIONS(9426),
    [anon_sym_RBRACK] = ACTIONS(9426),
    [anon_sym_COLON_COLON2] = ACTIONS(9426),
    [anon_sym_AMP_DOT] = ACTIONS(9426),
    [anon_sym_PLUS_EQ] = ACTIONS(9426),
    [anon_sym_DASH_EQ] = ACTIONS(9426),
    [anon_sym_STAR_EQ] = ACTIONS(9426),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9426),
    [anon_sym_SLASH_EQ] = ACTIONS(9426),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9426),
    [anon_sym_PIPE_EQ] = ACTIONS(9426),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9426),
    [anon_sym_AMP_EQ] = ACTIONS(9426),
    [anon_sym_PERCENT_EQ] = ACTIONS(9426),
    [anon_sym_GT_GT_EQ] = ACTIONS(9426),
    [anon_sym_LT_LT_EQ] = ACTIONS(9426),
    [anon_sym_CARET_EQ] = ACTIONS(9426),
    [anon_sym_QMARK] = ACTIONS(9426),
    [anon_sym_COLON2] = ACTIONS(9428),
    [anon_sym_DOT_DOT] = ACTIONS(9428),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9426),
    [anon_sym_and] = ACTIONS(9426),
    [anon_sym_or] = ACTIONS(9426),
    [anon_sym_PIPE_PIPE] = ACTIONS(9428),
    [anon_sym_AMP_AMP] = ACTIONS(9428),
    [anon_sym_LT_LT] = ACTIONS(9428),
    [anon_sym_GT_GT] = ACTIONS(9428),
    [anon_sym_EQ_EQ] = ACTIONS(9428),
    [anon_sym_BANG_EQ] = ACTIONS(9426),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9426),
    [anon_sym_LT_EQ_GT] = ACTIONS(9426),
    [anon_sym_EQ_TILDE] = ACTIONS(9426),
    [anon_sym_BANG_TILDE] = ACTIONS(9426),
    [anon_sym_LT_EQ] = ACTIONS(9428),
    [anon_sym_GT] = ACTIONS(9428),
    [anon_sym_GT_EQ] = ACTIONS(9426),
    [anon_sym_CARET] = ACTIONS(9428),
    [anon_sym_PLUS] = ACTIONS(9428),
    [anon_sym_SLASH] = ACTIONS(9428),
    [anon_sym_PERCENT] = ACTIONS(9428),
    [sym_comment] = ACTIONS(87),
  },
  [6874] = {
    [anon_sym_RBRACE] = ACTIONS(12588),
    [sym_comment] = ACTIONS(87),
  },
  [6875] = {
    [sym__heredoc_body_start] = ACTIONS(9446),
    [sym__binary_minus] = ACTIONS(9446),
    [sym__binary_star] = ACTIONS(9446),
    [anon_sym_LBRACE] = ACTIONS(9446),
    [anon_sym_RBRACE] = ACTIONS(9446),
    [anon_sym_RPAREN] = ACTIONS(9446),
    [anon_sym_DOT] = ACTIONS(9448),
    [anon_sym_COMMA] = ACTIONS(9446),
    [anon_sym_PIPE] = ACTIONS(9448),
    [anon_sym_SEMI] = ACTIONS(9446),
    [anon_sym_STAR_STAR] = ACTIONS(9448),
    [anon_sym_AMP] = ACTIONS(9448),
    [anon_sym_EQ] = ACTIONS(9448),
    [anon_sym_LT] = ACTIONS(9448),
    [anon_sym_if] = ACTIONS(9446),
    [anon_sym_unless] = ACTIONS(9446),
    [anon_sym_while] = ACTIONS(9446),
    [anon_sym_until] = ACTIONS(9446),
    [anon_sym_rescue] = ACTIONS(9446),
    [anon_sym_in] = ACTIONS(9446),
    [anon_sym_do] = ACTIONS(9446),
    [anon_sym_LBRACK] = ACTIONS(9446),
    [anon_sym_RBRACK] = ACTIONS(9446),
    [anon_sym_COLON_COLON2] = ACTIONS(9446),
    [anon_sym_AMP_DOT] = ACTIONS(9446),
    [anon_sym_PLUS_EQ] = ACTIONS(9446),
    [anon_sym_DASH_EQ] = ACTIONS(9446),
    [anon_sym_STAR_EQ] = ACTIONS(9446),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9446),
    [anon_sym_SLASH_EQ] = ACTIONS(9446),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9446),
    [anon_sym_PIPE_EQ] = ACTIONS(9446),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9446),
    [anon_sym_AMP_EQ] = ACTIONS(9446),
    [anon_sym_PERCENT_EQ] = ACTIONS(9446),
    [anon_sym_GT_GT_EQ] = ACTIONS(9446),
    [anon_sym_LT_LT_EQ] = ACTIONS(9446),
    [anon_sym_CARET_EQ] = ACTIONS(9446),
    [anon_sym_QMARK] = ACTIONS(9446),
    [anon_sym_COLON2] = ACTIONS(9448),
    [anon_sym_DOT_DOT] = ACTIONS(9448),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9446),
    [anon_sym_and] = ACTIONS(9446),
    [anon_sym_or] = ACTIONS(9446),
    [anon_sym_PIPE_PIPE] = ACTIONS(9448),
    [anon_sym_AMP_AMP] = ACTIONS(9448),
    [anon_sym_LT_LT] = ACTIONS(9448),
    [anon_sym_GT_GT] = ACTIONS(9448),
    [anon_sym_EQ_EQ] = ACTIONS(9448),
    [anon_sym_BANG_EQ] = ACTIONS(9446),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9446),
    [anon_sym_LT_EQ_GT] = ACTIONS(9446),
    [anon_sym_EQ_TILDE] = ACTIONS(9446),
    [anon_sym_BANG_TILDE] = ACTIONS(9446),
    [anon_sym_LT_EQ] = ACTIONS(9448),
    [anon_sym_GT] = ACTIONS(9448),
    [anon_sym_GT_EQ] = ACTIONS(9446),
    [anon_sym_CARET] = ACTIONS(9448),
    [anon_sym_PLUS] = ACTIONS(9448),
    [anon_sym_SLASH] = ACTIONS(9448),
    [anon_sym_PERCENT] = ACTIONS(9448),
    [sym_comment] = ACTIONS(87),
  },
  [6876] = {
    [anon_sym_end] = ACTIONS(12590),
    [sym_comment] = ACTIONS(87),
  },
  [6877] = {
    [sym__statements] = STATE(9006),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12592),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6878] = {
    [sym__statements] = STATE(9006),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_heredoc_body] = STATE(9007),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [sym__terminator] = STATE(9007),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__line_break] = ACTIONS(12594),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(12594),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12592),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6879] = {
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(10401),
    [sym__binary_star] = ACTIONS(10403),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_RBRACE] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(10405),
    [anon_sym_STAR_STAR] = ACTIONS(10407),
    [anon_sym_AMP] = ACTIONS(10409),
    [anon_sym_EQ] = ACTIONS(7884),
    [anon_sym_LT] = ACTIONS(10411),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_PLUS_EQ] = ACTIONS(7027),
    [anon_sym_DASH_EQ] = ACTIONS(7027),
    [anon_sym_STAR_EQ] = ACTIONS(7027),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7027),
    [anon_sym_SLASH_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7027),
    [anon_sym_AMP_EQ] = ACTIONS(7027),
    [anon_sym_PERCENT_EQ] = ACTIONS(7027),
    [anon_sym_GT_GT_EQ] = ACTIONS(7027),
    [anon_sym_LT_LT_EQ] = ACTIONS(7027),
    [anon_sym_CARET_EQ] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(10413),
    [anon_sym_DOT_DOT] = ACTIONS(10415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10417),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(10419),
    [anon_sym_AMP_AMP] = ACTIONS(10419),
    [anon_sym_LT_LT] = ACTIONS(10421),
    [anon_sym_GT_GT] = ACTIONS(10421),
    [anon_sym_EQ_EQ] = ACTIONS(10419),
    [anon_sym_BANG_EQ] = ACTIONS(10423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10423),
    [anon_sym_LT_EQ_GT] = ACTIONS(10423),
    [anon_sym_EQ_TILDE] = ACTIONS(10423),
    [anon_sym_BANG_TILDE] = ACTIONS(10423),
    [anon_sym_LT_EQ] = ACTIONS(10411),
    [anon_sym_GT] = ACTIONS(10411),
    [anon_sym_GT_EQ] = ACTIONS(10425),
    [anon_sym_CARET] = ACTIONS(10405),
    [anon_sym_PLUS] = ACTIONS(10427),
    [anon_sym_SLASH] = ACTIONS(10407),
    [anon_sym_PERCENT] = ACTIONS(10407),
    [sym_comment] = ACTIONS(87),
  },
  [6880] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(6949),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(6953),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(6953),
    [anon_sym_PERCENT] = ACTIONS(6953),
    [sym_comment] = ACTIONS(87),
  },
  [6881] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(6953),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(5827),
    [anon_sym_PERCENT] = ACTIONS(5827),
    [sym_comment] = ACTIONS(87),
  },
  [6882] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6947),
    [sym__binary_star] = ACTIONS(6949),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(6953),
    [anon_sym_AMP] = ACTIONS(6955),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(6967),
    [anon_sym_GT_GT] = ACTIONS(6967),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(6973),
    [anon_sym_SLASH] = ACTIONS(6953),
    [anon_sym_PERCENT] = ACTIONS(6953),
    [sym_comment] = ACTIONS(87),
  },
  [6883] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6947),
    [sym__binary_star] = ACTIONS(6949),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(6953),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(6967),
    [anon_sym_GT_GT] = ACTIONS(6967),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(6973),
    [anon_sym_SLASH] = ACTIONS(6953),
    [anon_sym_PERCENT] = ACTIONS(6953),
    [sym_comment] = ACTIONS(87),
  },
  [6884] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6947),
    [sym__binary_star] = ACTIONS(6949),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(6951),
    [anon_sym_STAR_STAR] = ACTIONS(6953),
    [anon_sym_AMP] = ACTIONS(6955),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(6967),
    [anon_sym_GT_GT] = ACTIONS(6967),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(6951),
    [anon_sym_PLUS] = ACTIONS(6973),
    [anon_sym_SLASH] = ACTIONS(6953),
    [anon_sym_PERCENT] = ACTIONS(6953),
    [sym_comment] = ACTIONS(87),
  },
  [6885] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(12596),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [6886] = {
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(6947),
    [sym__binary_star] = ACTIONS(6949),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_RBRACE] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(6951),
    [anon_sym_STAR_STAR] = ACTIONS(6953),
    [anon_sym_AMP] = ACTIONS(6955),
    [anon_sym_EQ] = ACTIONS(7888),
    [anon_sym_LT] = ACTIONS(6957),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_EQ_GT] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_PLUS_EQ] = ACTIONS(5927),
    [anon_sym_DASH_EQ] = ACTIONS(5927),
    [anon_sym_STAR_EQ] = ACTIONS(5927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5927),
    [anon_sym_SLASH_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5927),
    [anon_sym_AMP_EQ] = ACTIONS(5927),
    [anon_sym_PERCENT_EQ] = ACTIONS(5927),
    [anon_sym_GT_GT_EQ] = ACTIONS(5927),
    [anon_sym_LT_LT_EQ] = ACTIONS(5927),
    [anon_sym_CARET_EQ] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(6961),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6963),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(6965),
    [anon_sym_AMP_AMP] = ACTIONS(6965),
    [anon_sym_LT_LT] = ACTIONS(6967),
    [anon_sym_GT_GT] = ACTIONS(6967),
    [anon_sym_EQ_EQ] = ACTIONS(6965),
    [anon_sym_BANG_EQ] = ACTIONS(6969),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6969),
    [anon_sym_LT_EQ_GT] = ACTIONS(6969),
    [anon_sym_EQ_TILDE] = ACTIONS(6969),
    [anon_sym_BANG_TILDE] = ACTIONS(6969),
    [anon_sym_LT_EQ] = ACTIONS(6957),
    [anon_sym_GT] = ACTIONS(6957),
    [anon_sym_GT_EQ] = ACTIONS(6971),
    [anon_sym_CARET] = ACTIONS(6951),
    [anon_sym_PLUS] = ACTIONS(6973),
    [anon_sym_SLASH] = ACTIONS(6953),
    [anon_sym_PERCENT] = ACTIONS(6953),
    [sym_comment] = ACTIONS(87),
  },
  [6887] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6947),
    [sym__binary_star] = ACTIONS(6949),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(6951),
    [anon_sym_STAR_STAR] = ACTIONS(6953),
    [anon_sym_AMP] = ACTIONS(6955),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(6957),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(6959),
    [anon_sym_DOT_DOT] = ACTIONS(6961),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6963),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(6965),
    [anon_sym_AMP_AMP] = ACTIONS(6965),
    [anon_sym_LT_LT] = ACTIONS(6967),
    [anon_sym_GT_GT] = ACTIONS(6967),
    [anon_sym_EQ_EQ] = ACTIONS(6965),
    [anon_sym_BANG_EQ] = ACTIONS(6969),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6969),
    [anon_sym_LT_EQ_GT] = ACTIONS(6969),
    [anon_sym_EQ_TILDE] = ACTIONS(6969),
    [anon_sym_BANG_TILDE] = ACTIONS(6969),
    [anon_sym_LT_EQ] = ACTIONS(6957),
    [anon_sym_GT] = ACTIONS(6957),
    [anon_sym_GT_EQ] = ACTIONS(6971),
    [anon_sym_CARET] = ACTIONS(6951),
    [anon_sym_PLUS] = ACTIONS(6973),
    [anon_sym_SLASH] = ACTIONS(6953),
    [anon_sym_PERCENT] = ACTIONS(6953),
    [sym_comment] = ACTIONS(87),
  },
  [6888] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6947),
    [sym__binary_star] = ACTIONS(6949),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(6951),
    [anon_sym_STAR_STAR] = ACTIONS(6953),
    [anon_sym_AMP] = ACTIONS(6955),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(6957),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(6967),
    [anon_sym_GT_GT] = ACTIONS(6967),
    [anon_sym_EQ_EQ] = ACTIONS(6965),
    [anon_sym_BANG_EQ] = ACTIONS(6969),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6969),
    [anon_sym_LT_EQ_GT] = ACTIONS(6969),
    [anon_sym_EQ_TILDE] = ACTIONS(6969),
    [anon_sym_BANG_TILDE] = ACTIONS(6969),
    [anon_sym_LT_EQ] = ACTIONS(6957),
    [anon_sym_GT] = ACTIONS(6957),
    [anon_sym_GT_EQ] = ACTIONS(6971),
    [anon_sym_CARET] = ACTIONS(6951),
    [anon_sym_PLUS] = ACTIONS(6973),
    [anon_sym_SLASH] = ACTIONS(6953),
    [anon_sym_PERCENT] = ACTIONS(6953),
    [sym_comment] = ACTIONS(87),
  },
  [6889] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(6947),
    [sym__binary_star] = ACTIONS(6949),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(6953),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(6973),
    [anon_sym_SLASH] = ACTIONS(6953),
    [anon_sym_PERCENT] = ACTIONS(6953),
    [sym_comment] = ACTIONS(87),
  },
  [6890] = {
    [sym__heredoc_body_start] = ACTIONS(5735),
    [sym__binary_minus] = ACTIONS(5735),
    [sym__binary_star] = ACTIONS(5735),
    [anon_sym_LBRACE] = ACTIONS(5735),
    [anon_sym_RBRACE] = ACTIONS(5735),
    [anon_sym_RPAREN] = ACTIONS(5735),
    [anon_sym_DOT] = ACTIONS(5737),
    [anon_sym_COMMA] = ACTIONS(5735),
    [anon_sym_PIPE] = ACTIONS(5737),
    [anon_sym_SEMI] = ACTIONS(5735),
    [anon_sym_STAR_STAR] = ACTIONS(5737),
    [anon_sym_AMP] = ACTIONS(5737),
    [anon_sym_EQ] = ACTIONS(5737),
    [anon_sym_LT] = ACTIONS(5737),
    [anon_sym_if] = ACTIONS(5735),
    [anon_sym_unless] = ACTIONS(5735),
    [anon_sym_while] = ACTIONS(5735),
    [anon_sym_until] = ACTIONS(5735),
    [anon_sym_rescue] = ACTIONS(5735),
    [anon_sym_in] = ACTIONS(5735),
    [anon_sym_do] = ACTIONS(5735),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_RBRACK] = ACTIONS(5735),
    [anon_sym_COLON_COLON2] = ACTIONS(5735),
    [anon_sym_AMP_DOT] = ACTIONS(5735),
    [anon_sym_PLUS_EQ] = ACTIONS(5735),
    [anon_sym_DASH_EQ] = ACTIONS(5735),
    [anon_sym_STAR_EQ] = ACTIONS(5735),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5735),
    [anon_sym_SLASH_EQ] = ACTIONS(5735),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5735),
    [anon_sym_PIPE_EQ] = ACTIONS(5735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5735),
    [anon_sym_AMP_EQ] = ACTIONS(5735),
    [anon_sym_PERCENT_EQ] = ACTIONS(5735),
    [anon_sym_GT_GT_EQ] = ACTIONS(5735),
    [anon_sym_LT_LT_EQ] = ACTIONS(5735),
    [anon_sym_CARET_EQ] = ACTIONS(5735),
    [anon_sym_QMARK] = ACTIONS(5735),
    [anon_sym_COLON2] = ACTIONS(5737),
    [anon_sym_DOT_DOT] = ACTIONS(5737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5735),
    [anon_sym_and] = ACTIONS(5735),
    [anon_sym_or] = ACTIONS(5735),
    [anon_sym_PIPE_PIPE] = ACTIONS(5737),
    [anon_sym_AMP_AMP] = ACTIONS(5737),
    [anon_sym_LT_LT] = ACTIONS(5737),
    [anon_sym_GT_GT] = ACTIONS(5737),
    [anon_sym_EQ_EQ] = ACTIONS(5737),
    [anon_sym_BANG_EQ] = ACTIONS(5735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5735),
    [anon_sym_LT_EQ_GT] = ACTIONS(5735),
    [anon_sym_EQ_TILDE] = ACTIONS(5735),
    [anon_sym_BANG_TILDE] = ACTIONS(5735),
    [anon_sym_LT_EQ] = ACTIONS(5737),
    [anon_sym_GT] = ACTIONS(5737),
    [anon_sym_GT_EQ] = ACTIONS(5735),
    [anon_sym_CARET] = ACTIONS(5737),
    [anon_sym_PLUS] = ACTIONS(5737),
    [anon_sym_SLASH] = ACTIONS(5737),
    [anon_sym_PERCENT] = ACTIONS(5737),
    [sym_comment] = ACTIONS(87),
  },
  [6891] = {
    [sym_heredoc_body] = STATE(6891),
    [aux_sym_call_repeat1] = STATE(6891),
    [sym__heredoc_body_start] = ACTIONS(12549),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_RBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_STAR_STAR] = ACTIONS(7919),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_EQ] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_PLUS_EQ] = ACTIONS(7914),
    [anon_sym_DASH_EQ] = ACTIONS(7914),
    [anon_sym_STAR_EQ] = ACTIONS(7914),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7914),
    [anon_sym_SLASH_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7914),
    [anon_sym_AMP_EQ] = ACTIONS(7914),
    [anon_sym_PERCENT_EQ] = ACTIONS(7914),
    [anon_sym_GT_GT_EQ] = ACTIONS(7914),
    [anon_sym_LT_LT_EQ] = ACTIONS(7914),
    [anon_sym_CARET_EQ] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7919),
    [anon_sym_AMP_AMP] = ACTIONS(7919),
    [anon_sym_LT_LT] = ACTIONS(7919),
    [anon_sym_GT_GT] = ACTIONS(7919),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7919),
    [anon_sym_PLUS] = ACTIONS(7919),
    [anon_sym_SLASH] = ACTIONS(7919),
    [anon_sym_PERCENT] = ACTIONS(7919),
    [sym_comment] = ACTIONS(87),
  },
  [6892] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1844),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1851),
    [sym_scope_resolution] = STATE(1845),
    [sym_call] = STATE(1845),
    [sym_method_call] = STATE(1851),
    [sym__argument] = STATE(8888),
    [sym_splat_argument] = STATE(8888),
    [sym_hash_splat_argument] = STATE(8888),
    [sym_block_argument] = STATE(8888),
    [sym_assignment] = STATE(1844),
    [sym_operator_assignment] = STATE(1844),
    [sym_conditional] = STATE(1844),
    [sym_range] = STATE(1844),
    [sym_binary] = STATE(1844),
    [sym_unary] = STATE(1844),
    [sym_left_assignment_list] = STATE(1850),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1851),
    [sym__variable] = STATE(1845),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1851),
    [sym_false] = STATE(1851),
    [sym_nil] = STATE(1851),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1852),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(8888),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(3319),
    [sym__splat_star] = ACTIONS(3321),
    [sym__unary_minus] = ACTIONS(3323),
    [sym__identifier_hash_key] = ACTIONS(3325),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10445),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3329),
    [anon_sym_yield] = ACTIONS(3331),
    [anon_sym_break] = ACTIONS(3333),
    [anon_sym_next] = ACTIONS(3335),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6935),
    [anon_sym_defined_QMARK] = ACTIONS(3339),
    [anon_sym_not] = ACTIONS(3341),
    [anon_sym_BANG] = ACTIONS(3345),
    [anon_sym_TILDE] = ACTIONS(3345),
    [sym_constant] = ACTIONS(3347),
    [sym_identifier] = ACTIONS(3347),
    [sym_instance_variable] = ACTIONS(3349),
    [sym_class_variable] = ACTIONS(3349),
    [sym_global_variable] = ACTIONS(3349),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3351),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3351),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6893] = {
    [sym_heredoc_body] = STATE(6891),
    [aux_sym_call_repeat1] = STATE(6891),
    [sym__heredoc_body_start] = ACTIONS(6569),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_RBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_STAR_STAR] = ACTIONS(7931),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_EQ] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_PLUS_EQ] = ACTIONS(7929),
    [anon_sym_DASH_EQ] = ACTIONS(7929),
    [anon_sym_STAR_EQ] = ACTIONS(7929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7929),
    [anon_sym_SLASH_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7929),
    [anon_sym_AMP_EQ] = ACTIONS(7929),
    [anon_sym_PERCENT_EQ] = ACTIONS(7929),
    [anon_sym_GT_GT_EQ] = ACTIONS(7929),
    [anon_sym_LT_LT_EQ] = ACTIONS(7929),
    [anon_sym_CARET_EQ] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7931),
    [anon_sym_AMP_AMP] = ACTIONS(7931),
    [anon_sym_LT_LT] = ACTIONS(7931),
    [anon_sym_GT_GT] = ACTIONS(7931),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7931),
    [anon_sym_PLUS] = ACTIONS(7931),
    [anon_sym_SLASH] = ACTIONS(7931),
    [anon_sym_PERCENT] = ACTIONS(7931),
    [sym_comment] = ACTIONS(87),
  },
  [6894] = {
    [aux_sym_argument_list_repeat1] = STATE(6894),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_RBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(12598),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_STAR_STAR] = ACTIONS(7927),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_EQ] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_PLUS_EQ] = ACTIONS(7925),
    [anon_sym_DASH_EQ] = ACTIONS(7925),
    [anon_sym_STAR_EQ] = ACTIONS(7925),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7925),
    [anon_sym_SLASH_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7925),
    [anon_sym_AMP_EQ] = ACTIONS(7925),
    [anon_sym_PERCENT_EQ] = ACTIONS(7925),
    [anon_sym_GT_GT_EQ] = ACTIONS(7925),
    [anon_sym_LT_LT_EQ] = ACTIONS(7925),
    [anon_sym_CARET_EQ] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7927),
    [anon_sym_AMP_AMP] = ACTIONS(7927),
    [anon_sym_LT_LT] = ACTIONS(7927),
    [anon_sym_GT_GT] = ACTIONS(7927),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7927),
    [anon_sym_PLUS] = ACTIONS(7927),
    [anon_sym_SLASH] = ACTIONS(7927),
    [anon_sym_PERCENT] = ACTIONS(7927),
    [sym_comment] = ACTIONS(87),
  },
  [6895] = {
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(6947),
    [sym__binary_star] = ACTIONS(6949),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_RBRACE] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(6951),
    [anon_sym_STAR_STAR] = ACTIONS(6953),
    [anon_sym_AMP] = ACTIONS(6955),
    [anon_sym_EQ] = ACTIONS(7936),
    [anon_sym_LT] = ACTIONS(6957),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_EQ_GT] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_PLUS_EQ] = ACTIONS(5115),
    [anon_sym_DASH_EQ] = ACTIONS(5115),
    [anon_sym_STAR_EQ] = ACTIONS(5115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5115),
    [anon_sym_SLASH_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5115),
    [anon_sym_AMP_EQ] = ACTIONS(5115),
    [anon_sym_PERCENT_EQ] = ACTIONS(5115),
    [anon_sym_GT_GT_EQ] = ACTIONS(5115),
    [anon_sym_LT_LT_EQ] = ACTIONS(5115),
    [anon_sym_CARET_EQ] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(6959),
    [anon_sym_DOT_DOT] = ACTIONS(6961),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6963),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(6965),
    [anon_sym_AMP_AMP] = ACTIONS(6965),
    [anon_sym_LT_LT] = ACTIONS(6967),
    [anon_sym_GT_GT] = ACTIONS(6967),
    [anon_sym_EQ_EQ] = ACTIONS(6965),
    [anon_sym_BANG_EQ] = ACTIONS(6969),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6969),
    [anon_sym_LT_EQ_GT] = ACTIONS(6969),
    [anon_sym_EQ_TILDE] = ACTIONS(6969),
    [anon_sym_BANG_TILDE] = ACTIONS(6969),
    [anon_sym_LT_EQ] = ACTIONS(6957),
    [anon_sym_GT] = ACTIONS(6957),
    [anon_sym_GT_EQ] = ACTIONS(6971),
    [anon_sym_CARET] = ACTIONS(6951),
    [anon_sym_PLUS] = ACTIONS(6973),
    [anon_sym_SLASH] = ACTIONS(6953),
    [anon_sym_PERCENT] = ACTIONS(6953),
    [sym_comment] = ACTIONS(87),
  },
  [6896] = {
    [aux_sym_exceptions_repeat1] = STATE(9010),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_RBRACE] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_STAR_STAR] = ACTIONS(6193),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_PLUS_EQ] = ACTIONS(6191),
    [anon_sym_DASH_EQ] = ACTIONS(6191),
    [anon_sym_STAR_EQ] = ACTIONS(6191),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6191),
    [anon_sym_SLASH_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6191),
    [anon_sym_AMP_EQ] = ACTIONS(6191),
    [anon_sym_PERCENT_EQ] = ACTIONS(6191),
    [anon_sym_GT_GT_EQ] = ACTIONS(6191),
    [anon_sym_LT_LT_EQ] = ACTIONS(6191),
    [anon_sym_CARET_EQ] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6193),
    [anon_sym_AMP_AMP] = ACTIONS(6193),
    [anon_sym_LT_LT] = ACTIONS(6193),
    [anon_sym_GT_GT] = ACTIONS(6193),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6193),
    [anon_sym_PLUS] = ACTIONS(6193),
    [anon_sym_SLASH] = ACTIONS(6193),
    [anon_sym_PERCENT] = ACTIONS(6193),
    [sym_comment] = ACTIONS(87),
  },
  [6897] = {
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(6947),
    [sym__binary_star] = ACTIONS(6949),
    [anon_sym_LBRACE] = ACTIONS(6210),
    [anon_sym_RBRACE] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(6951),
    [anon_sym_STAR_STAR] = ACTIONS(6953),
    [anon_sym_AMP] = ACTIONS(6955),
    [anon_sym_EQ] = ACTIONS(7938),
    [anon_sym_LT] = ACTIONS(6957),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_EQ_GT] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_PLUS_EQ] = ACTIONS(6210),
    [anon_sym_DASH_EQ] = ACTIONS(6210),
    [anon_sym_STAR_EQ] = ACTIONS(6210),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6210),
    [anon_sym_SLASH_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6210),
    [anon_sym_AMP_EQ] = ACTIONS(6210),
    [anon_sym_PERCENT_EQ] = ACTIONS(6210),
    [anon_sym_GT_GT_EQ] = ACTIONS(6210),
    [anon_sym_LT_LT_EQ] = ACTIONS(6210),
    [anon_sym_CARET_EQ] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(6959),
    [anon_sym_DOT_DOT] = ACTIONS(6961),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6963),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(6965),
    [anon_sym_AMP_AMP] = ACTIONS(6965),
    [anon_sym_LT_LT] = ACTIONS(6967),
    [anon_sym_GT_GT] = ACTIONS(6967),
    [anon_sym_EQ_EQ] = ACTIONS(6965),
    [anon_sym_BANG_EQ] = ACTIONS(6969),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6969),
    [anon_sym_LT_EQ_GT] = ACTIONS(6969),
    [anon_sym_EQ_TILDE] = ACTIONS(6969),
    [anon_sym_BANG_TILDE] = ACTIONS(6969),
    [anon_sym_LT_EQ] = ACTIONS(6957),
    [anon_sym_GT] = ACTIONS(6957),
    [anon_sym_GT_EQ] = ACTIONS(6971),
    [anon_sym_CARET] = ACTIONS(6951),
    [anon_sym_PLUS] = ACTIONS(6973),
    [anon_sym_SLASH] = ACTIONS(6953),
    [anon_sym_PERCENT] = ACTIONS(6953),
    [sym_comment] = ACTIONS(87),
  },
  [6898] = {
    [sym_string] = STATE(6898),
    [aux_sym_chained_string_repeat1] = STATE(6898),
    [sym__string_start] = ACTIONS(10559),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_RBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_STAR_STAR] = ACTIONS(6217),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_EQ] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_do] = ACTIONS(6212),
    [anon_sym_EQ_GT] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_PLUS_EQ] = ACTIONS(6212),
    [anon_sym_DASH_EQ] = ACTIONS(6212),
    [anon_sym_STAR_EQ] = ACTIONS(6212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6212),
    [anon_sym_SLASH_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6212),
    [anon_sym_AMP_EQ] = ACTIONS(6212),
    [anon_sym_PERCENT_EQ] = ACTIONS(6212),
    [anon_sym_GT_GT_EQ] = ACTIONS(6212),
    [anon_sym_LT_LT_EQ] = ACTIONS(6212),
    [anon_sym_CARET_EQ] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6217),
    [anon_sym_AMP_AMP] = ACTIONS(6217),
    [anon_sym_LT_LT] = ACTIONS(6217),
    [anon_sym_GT_GT] = ACTIONS(6217),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6217),
    [anon_sym_PLUS] = ACTIONS(6217),
    [anon_sym_SLASH] = ACTIONS(6217),
    [anon_sym_PERCENT] = ACTIONS(6217),
    [sym_comment] = ACTIONS(87),
  },
  [6899] = {
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(3283),
    [sym__binary_star] = ACTIONS(3285),
    [anon_sym_RBRACE] = ACTIONS(4247),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(3287),
    [anon_sym_STAR_STAR] = ACTIONS(3285),
    [anon_sym_AMP] = ACTIONS(3289),
    [anon_sym_LT] = ACTIONS(3291),
    [anon_sym_QMARK] = ACTIONS(3293),
    [anon_sym_DOT_DOT] = ACTIONS(3295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3297),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(3301),
    [anon_sym_AMP_AMP] = ACTIONS(3301),
    [anon_sym_LT_LT] = ACTIONS(3303),
    [anon_sym_GT_GT] = ACTIONS(3303),
    [anon_sym_EQ_EQ] = ACTIONS(3305),
    [anon_sym_BANG_EQ] = ACTIONS(3301),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3301),
    [anon_sym_LT_EQ_GT] = ACTIONS(3301),
    [anon_sym_EQ_TILDE] = ACTIONS(3301),
    [anon_sym_BANG_TILDE] = ACTIONS(3301),
    [anon_sym_LT_EQ] = ACTIONS(3291),
    [anon_sym_GT] = ACTIONS(3291),
    [anon_sym_GT_EQ] = ACTIONS(3307),
    [anon_sym_CARET] = ACTIONS(3309),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_SLASH] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [sym_comment] = ACTIONS(87),
  },
  [6900] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(4224),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(541),
    [sym_scope_resolution] = STATE(539),
    [sym_call] = STATE(539),
    [sym_method_call] = STATE(541),
    [sym_splat_argument] = STATE(8429),
    [sym_assignment] = STATE(4224),
    [sym_operator_assignment] = STATE(4224),
    [sym_conditional] = STATE(4224),
    [sym_range] = STATE(4224),
    [sym_binary] = STATE(4224),
    [sym_unary] = STATE(4224),
    [sym__arg_or_splat_arg] = STATE(8429),
    [sym_left_assignment_list] = STATE(540),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(541),
    [sym__variable] = STATE(539),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(541),
    [sym_false] = STATE(541),
    [sym_nil] = STATE(541),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(542),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(6989),
    [sym__unary_minus] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1021),
    [anon_sym_defined_QMARK] = ACTIONS(1023),
    [anon_sym_not] = ACTIONS(1025),
    [anon_sym_BANG] = ACTIONS(1027),
    [anon_sym_TILDE] = ACTIONS(1027),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6901] = {
    [aux_sym_exceptions_repeat1] = STATE(9011),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_RBRACE] = ACTIONS(9855),
    [anon_sym_COMMA] = ACTIONS(12601),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [6902] = {
    [sym__binary_minus] = ACTIONS(10927),
    [sym__binary_star] = ACTIONS(10927),
    [anon_sym_LBRACE] = ACTIONS(10927),
    [anon_sym_RBRACE] = ACTIONS(10927),
    [anon_sym_RPAREN] = ACTIONS(10927),
    [anon_sym_DOT] = ACTIONS(10929),
    [anon_sym_COMMA] = ACTIONS(10927),
    [anon_sym_PIPE] = ACTIONS(10929),
    [anon_sym_SEMI] = ACTIONS(10927),
    [anon_sym_STAR_STAR] = ACTIONS(10927),
    [anon_sym_AMP] = ACTIONS(10929),
    [anon_sym_LT] = ACTIONS(10929),
    [anon_sym_if] = ACTIONS(10927),
    [anon_sym_unless] = ACTIONS(10927),
    [anon_sym_while] = ACTIONS(10927),
    [anon_sym_until] = ACTIONS(10927),
    [anon_sym_rescue] = ACTIONS(10927),
    [anon_sym_do] = ACTIONS(10927),
    [anon_sym_EQ_GT] = ACTIONS(10927),
    [anon_sym_LBRACK] = ACTIONS(10927),
    [anon_sym_COLON_COLON2] = ACTIONS(10927),
    [anon_sym_AMP_DOT] = ACTIONS(10927),
    [anon_sym_QMARK] = ACTIONS(10927),
    [anon_sym_COLON2] = ACTIONS(10929),
    [anon_sym_DOT_DOT] = ACTIONS(10929),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10927),
    [anon_sym_and] = ACTIONS(10927),
    [anon_sym_or] = ACTIONS(10927),
    [anon_sym_PIPE_PIPE] = ACTIONS(10927),
    [anon_sym_AMP_AMP] = ACTIONS(10927),
    [anon_sym_LT_LT] = ACTIONS(10927),
    [anon_sym_GT_GT] = ACTIONS(10927),
    [anon_sym_EQ_EQ] = ACTIONS(10929),
    [anon_sym_BANG_EQ] = ACTIONS(10927),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10927),
    [anon_sym_LT_EQ_GT] = ACTIONS(10927),
    [anon_sym_EQ_TILDE] = ACTIONS(10927),
    [anon_sym_BANG_TILDE] = ACTIONS(10927),
    [anon_sym_LT_EQ] = ACTIONS(10929),
    [anon_sym_GT] = ACTIONS(10929),
    [anon_sym_GT_EQ] = ACTIONS(10927),
    [anon_sym_CARET] = ACTIONS(10927),
    [anon_sym_PLUS] = ACTIONS(10927),
    [anon_sym_SLASH] = ACTIONS(10927),
    [anon_sym_PERCENT] = ACTIONS(10927),
    [sym_comment] = ACTIONS(87),
  },
  [6903] = {
    [sym__binary_minus] = ACTIONS(10931),
    [sym__binary_star] = ACTIONS(10931),
    [anon_sym_LBRACE] = ACTIONS(10931),
    [anon_sym_RBRACE] = ACTIONS(10931),
    [anon_sym_RPAREN] = ACTIONS(10931),
    [anon_sym_DOT] = ACTIONS(10933),
    [anon_sym_COMMA] = ACTIONS(10931),
    [anon_sym_PIPE] = ACTIONS(10933),
    [anon_sym_SEMI] = ACTIONS(10931),
    [anon_sym_STAR_STAR] = ACTIONS(10931),
    [anon_sym_AMP] = ACTIONS(10933),
    [anon_sym_LT] = ACTIONS(10933),
    [anon_sym_if] = ACTIONS(10931),
    [anon_sym_unless] = ACTIONS(10931),
    [anon_sym_while] = ACTIONS(10931),
    [anon_sym_until] = ACTIONS(10931),
    [anon_sym_rescue] = ACTIONS(10931),
    [anon_sym_do] = ACTIONS(10931),
    [anon_sym_EQ_GT] = ACTIONS(10931),
    [anon_sym_LBRACK] = ACTIONS(10931),
    [anon_sym_COLON_COLON2] = ACTIONS(10931),
    [anon_sym_AMP_DOT] = ACTIONS(10931),
    [anon_sym_QMARK] = ACTIONS(10931),
    [anon_sym_COLON2] = ACTIONS(10933),
    [anon_sym_DOT_DOT] = ACTIONS(10933),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10931),
    [anon_sym_and] = ACTIONS(10931),
    [anon_sym_or] = ACTIONS(10931),
    [anon_sym_PIPE_PIPE] = ACTIONS(10931),
    [anon_sym_AMP_AMP] = ACTIONS(10931),
    [anon_sym_LT_LT] = ACTIONS(10931),
    [anon_sym_GT_GT] = ACTIONS(10931),
    [anon_sym_EQ_EQ] = ACTIONS(10933),
    [anon_sym_BANG_EQ] = ACTIONS(10931),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10931),
    [anon_sym_LT_EQ_GT] = ACTIONS(10931),
    [anon_sym_EQ_TILDE] = ACTIONS(10931),
    [anon_sym_BANG_TILDE] = ACTIONS(10931),
    [anon_sym_LT_EQ] = ACTIONS(10933),
    [anon_sym_GT] = ACTIONS(10933),
    [anon_sym_GT_EQ] = ACTIONS(10931),
    [anon_sym_CARET] = ACTIONS(10931),
    [anon_sym_PLUS] = ACTIONS(10931),
    [anon_sym_SLASH] = ACTIONS(10931),
    [anon_sym_PERCENT] = ACTIONS(10931),
    [sym_comment] = ACTIONS(87),
  },
  [6904] = {
    [sym_heredoc_body] = STATE(6904),
    [aux_sym_call_repeat1] = STATE(6904),
    [sym__heredoc_body_start] = ACTIONS(10455),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_EQ_GT] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [6905] = {
    [sym_heredoc_body] = STATE(6904),
    [aux_sym_call_repeat1] = STATE(6904),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_EQ_GT] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [6906] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(9012),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(567),
    [sym_scope_resolution] = STATE(562),
    [sym_call] = STATE(562),
    [sym_method_call] = STATE(567),
    [sym_assignment] = STATE(9012),
    [sym_operator_assignment] = STATE(9012),
    [sym_conditional] = STATE(9012),
    [sym_range] = STATE(9012),
    [sym_binary] = STATE(9012),
    [sym_unary] = STATE(9012),
    [sym_left_assignment_list] = STATE(566),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(567),
    [sym__variable] = STATE(562),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(567),
    [sym_false] = STATE(567),
    [sym_nil] = STATE(567),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1862),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1049),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1079),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6907] = {
    [sym__heredoc_body_start] = ACTIONS(6813),
    [sym__binary_minus] = ACTIONS(6813),
    [sym__binary_star] = ACTIONS(6813),
    [anon_sym_LBRACE] = ACTIONS(6813),
    [anon_sym_RBRACE] = ACTIONS(6813),
    [anon_sym_RPAREN] = ACTIONS(6813),
    [anon_sym_DOT] = ACTIONS(8689),
    [anon_sym_COMMA] = ACTIONS(6813),
    [anon_sym_PIPE] = ACTIONS(8689),
    [anon_sym_SEMI] = ACTIONS(6813),
    [anon_sym_STAR_STAR] = ACTIONS(6813),
    [anon_sym_AMP] = ACTIONS(8689),
    [anon_sym_EQ] = ACTIONS(8689),
    [anon_sym_LT] = ACTIONS(8689),
    [anon_sym_if] = ACTIONS(6813),
    [anon_sym_unless] = ACTIONS(6813),
    [anon_sym_while] = ACTIONS(6813),
    [anon_sym_until] = ACTIONS(6813),
    [anon_sym_rescue] = ACTIONS(6813),
    [anon_sym_in] = ACTIONS(6813),
    [anon_sym_do] = ACTIONS(6813),
    [anon_sym_EQ_GT] = ACTIONS(6813),
    [anon_sym_LBRACK] = ACTIONS(6813),
    [anon_sym_RBRACK] = ACTIONS(6813),
    [anon_sym_COLON_COLON2] = ACTIONS(6813),
    [anon_sym_AMP_DOT] = ACTIONS(6813),
    [anon_sym_QMARK] = ACTIONS(6813),
    [anon_sym_COLON2] = ACTIONS(8689),
    [anon_sym_DOT_DOT] = ACTIONS(8689),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6813),
    [anon_sym_and] = ACTIONS(6813),
    [anon_sym_or] = ACTIONS(6813),
    [anon_sym_PIPE_PIPE] = ACTIONS(6813),
    [anon_sym_AMP_AMP] = ACTIONS(6813),
    [anon_sym_LT_LT] = ACTIONS(6813),
    [anon_sym_GT_GT] = ACTIONS(6813),
    [anon_sym_EQ_EQ] = ACTIONS(8689),
    [anon_sym_BANG_EQ] = ACTIONS(6813),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6813),
    [anon_sym_LT_EQ_GT] = ACTIONS(6813),
    [anon_sym_EQ_TILDE] = ACTIONS(6813),
    [anon_sym_BANG_TILDE] = ACTIONS(6813),
    [anon_sym_LT_EQ] = ACTIONS(8689),
    [anon_sym_GT] = ACTIONS(8689),
    [anon_sym_GT_EQ] = ACTIONS(6813),
    [anon_sym_CARET] = ACTIONS(6813),
    [anon_sym_PLUS] = ACTIONS(6813),
    [anon_sym_SLASH] = ACTIONS(6813),
    [anon_sym_PERCENT] = ACTIONS(6813),
    [sym_comment] = ACTIONS(87),
  },
  [6908] = {
    [sym__heredoc_body_start] = ACTIONS(10986),
    [sym__binary_minus] = ACTIONS(10986),
    [sym__binary_star] = ACTIONS(10986),
    [anon_sym_LBRACE] = ACTIONS(10986),
    [anon_sym_RBRACE] = ACTIONS(10986),
    [anon_sym_RPAREN] = ACTIONS(10986),
    [anon_sym_DOT] = ACTIONS(10988),
    [anon_sym_COMMA] = ACTIONS(10986),
    [anon_sym_PIPE] = ACTIONS(10988),
    [anon_sym_SEMI] = ACTIONS(10986),
    [anon_sym_STAR_STAR] = ACTIONS(10986),
    [anon_sym_AMP] = ACTIONS(10988),
    [anon_sym_EQ] = ACTIONS(10988),
    [anon_sym_LT] = ACTIONS(10988),
    [anon_sym_if] = ACTIONS(10986),
    [anon_sym_unless] = ACTIONS(10986),
    [anon_sym_while] = ACTIONS(10986),
    [anon_sym_until] = ACTIONS(10986),
    [anon_sym_rescue] = ACTIONS(10986),
    [anon_sym_in] = ACTIONS(10986),
    [anon_sym_do] = ACTIONS(10986),
    [anon_sym_EQ_GT] = ACTIONS(10986),
    [anon_sym_LBRACK] = ACTIONS(10986),
    [anon_sym_RBRACK] = ACTIONS(10986),
    [anon_sym_COLON_COLON2] = ACTIONS(10986),
    [anon_sym_AMP_DOT] = ACTIONS(10986),
    [anon_sym_QMARK] = ACTIONS(10986),
    [anon_sym_COLON2] = ACTIONS(10988),
    [anon_sym_DOT_DOT] = ACTIONS(10988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10986),
    [anon_sym_and] = ACTIONS(10986),
    [anon_sym_or] = ACTIONS(10986),
    [anon_sym_PIPE_PIPE] = ACTIONS(10986),
    [anon_sym_AMP_AMP] = ACTIONS(10986),
    [anon_sym_LT_LT] = ACTIONS(10986),
    [anon_sym_GT_GT] = ACTIONS(10986),
    [anon_sym_EQ_EQ] = ACTIONS(10988),
    [anon_sym_BANG_EQ] = ACTIONS(10986),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10986),
    [anon_sym_LT_EQ_GT] = ACTIONS(10986),
    [anon_sym_EQ_TILDE] = ACTIONS(10986),
    [anon_sym_BANG_TILDE] = ACTIONS(10986),
    [anon_sym_LT_EQ] = ACTIONS(10988),
    [anon_sym_GT] = ACTIONS(10988),
    [anon_sym_GT_EQ] = ACTIONS(10986),
    [anon_sym_CARET] = ACTIONS(10986),
    [anon_sym_PLUS] = ACTIONS(10986),
    [anon_sym_SLASH] = ACTIONS(10986),
    [anon_sym_PERCENT] = ACTIONS(10986),
    [sym_comment] = ACTIONS(87),
  },
  [6909] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4254),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(567),
    [sym_scope_resolution] = STATE(562),
    [sym_call] = STATE(562),
    [sym_method_call] = STATE(567),
    [sym_splat_argument] = STATE(9013),
    [sym_assignment] = STATE(4254),
    [sym_operator_assignment] = STATE(4254),
    [sym_conditional] = STATE(4254),
    [sym_range] = STATE(4254),
    [sym_binary] = STATE(4254),
    [sym_unary] = STATE(4254),
    [sym__arg_or_splat_arg] = STATE(9013),
    [sym_left_assignment_list] = STATE(566),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(567),
    [sym__variable] = STATE(562),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(567),
    [sym_false] = STATE(567),
    [sym_nil] = STATE(567),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1862),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(1047),
    [sym__unary_minus] = ACTIONS(1049),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1079),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6910] = {
    [aux_sym_exceptions_repeat1] = STATE(9014),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(12603),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_EQ_GT] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [6911] = {
    [sym__binary_minus] = ACTIONS(11157),
    [sym__binary_star] = ACTIONS(11157),
    [anon_sym_LBRACE] = ACTIONS(11157),
    [anon_sym_RBRACE] = ACTIONS(11157),
    [anon_sym_RPAREN] = ACTIONS(11157),
    [anon_sym_DOT] = ACTIONS(11159),
    [anon_sym_COMMA] = ACTIONS(11157),
    [anon_sym_PIPE] = ACTIONS(11159),
    [anon_sym_SEMI] = ACTIONS(11157),
    [anon_sym_STAR_STAR] = ACTIONS(11157),
    [anon_sym_AMP] = ACTIONS(11159),
    [anon_sym_LT] = ACTIONS(11159),
    [anon_sym_if] = ACTIONS(11157),
    [anon_sym_unless] = ACTIONS(11157),
    [anon_sym_while] = ACTIONS(11157),
    [anon_sym_until] = ACTIONS(11157),
    [anon_sym_rescue] = ACTIONS(11157),
    [anon_sym_do] = ACTIONS(11157),
    [anon_sym_EQ_GT] = ACTIONS(11157),
    [anon_sym_LBRACK] = ACTIONS(11157),
    [anon_sym_COLON_COLON2] = ACTIONS(11157),
    [anon_sym_AMP_DOT] = ACTIONS(11157),
    [anon_sym_QMARK] = ACTIONS(11157),
    [anon_sym_COLON2] = ACTIONS(11159),
    [anon_sym_DOT_DOT] = ACTIONS(11159),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11157),
    [anon_sym_and] = ACTIONS(11157),
    [anon_sym_or] = ACTIONS(11157),
    [anon_sym_PIPE_PIPE] = ACTIONS(11157),
    [anon_sym_AMP_AMP] = ACTIONS(11157),
    [anon_sym_LT_LT] = ACTIONS(11157),
    [anon_sym_GT_GT] = ACTIONS(11157),
    [anon_sym_EQ_EQ] = ACTIONS(11159),
    [anon_sym_BANG_EQ] = ACTIONS(11157),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11157),
    [anon_sym_LT_EQ_GT] = ACTIONS(11157),
    [anon_sym_EQ_TILDE] = ACTIONS(11157),
    [anon_sym_BANG_TILDE] = ACTIONS(11157),
    [anon_sym_LT_EQ] = ACTIONS(11159),
    [anon_sym_GT] = ACTIONS(11159),
    [anon_sym_GT_EQ] = ACTIONS(11157),
    [anon_sym_CARET] = ACTIONS(11157),
    [anon_sym_PLUS] = ACTIONS(11157),
    [anon_sym_SLASH] = ACTIONS(11157),
    [anon_sym_PERCENT] = ACTIONS(11157),
    [sym_comment] = ACTIONS(87),
  },
  [6912] = {
    [sym__binary_minus] = ACTIONS(11322),
    [sym__binary_star] = ACTIONS(11322),
    [anon_sym_LBRACE] = ACTIONS(11322),
    [anon_sym_RBRACE] = ACTIONS(11322),
    [anon_sym_RPAREN] = ACTIONS(11322),
    [anon_sym_DOT] = ACTIONS(11324),
    [anon_sym_COMMA] = ACTIONS(11322),
    [anon_sym_PIPE] = ACTIONS(11324),
    [anon_sym_SEMI] = ACTIONS(11322),
    [anon_sym_STAR_STAR] = ACTIONS(11322),
    [anon_sym_AMP] = ACTIONS(11324),
    [anon_sym_LT] = ACTIONS(11324),
    [anon_sym_if] = ACTIONS(11322),
    [anon_sym_unless] = ACTIONS(11322),
    [anon_sym_while] = ACTIONS(11322),
    [anon_sym_until] = ACTIONS(11322),
    [anon_sym_rescue] = ACTIONS(11322),
    [anon_sym_do] = ACTIONS(11322),
    [anon_sym_EQ_GT] = ACTIONS(11322),
    [anon_sym_LBRACK] = ACTIONS(11322),
    [anon_sym_COLON_COLON2] = ACTIONS(11322),
    [anon_sym_AMP_DOT] = ACTIONS(11322),
    [anon_sym_QMARK] = ACTIONS(11322),
    [anon_sym_COLON2] = ACTIONS(11324),
    [anon_sym_DOT_DOT] = ACTIONS(11324),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11322),
    [anon_sym_and] = ACTIONS(11322),
    [anon_sym_or] = ACTIONS(11322),
    [anon_sym_PIPE_PIPE] = ACTIONS(11322),
    [anon_sym_AMP_AMP] = ACTIONS(11322),
    [anon_sym_LT_LT] = ACTIONS(11322),
    [anon_sym_GT_GT] = ACTIONS(11322),
    [anon_sym_EQ_EQ] = ACTIONS(11324),
    [anon_sym_BANG_EQ] = ACTIONS(11322),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11322),
    [anon_sym_LT_EQ_GT] = ACTIONS(11322),
    [anon_sym_EQ_TILDE] = ACTIONS(11322),
    [anon_sym_BANG_TILDE] = ACTIONS(11322),
    [anon_sym_LT_EQ] = ACTIONS(11324),
    [anon_sym_GT] = ACTIONS(11324),
    [anon_sym_GT_EQ] = ACTIONS(11322),
    [anon_sym_CARET] = ACTIONS(11322),
    [anon_sym_PLUS] = ACTIONS(11322),
    [anon_sym_SLASH] = ACTIONS(11322),
    [anon_sym_PERCENT] = ACTIONS(11322),
    [sym_comment] = ACTIONS(87),
  },
  [6913] = {
    [sym__binary_minus] = ACTIONS(11335),
    [sym__binary_star] = ACTIONS(11335),
    [anon_sym_LBRACE] = ACTIONS(11335),
    [anon_sym_RBRACE] = ACTIONS(11335),
    [anon_sym_RPAREN] = ACTIONS(11335),
    [anon_sym_DOT] = ACTIONS(11337),
    [anon_sym_COMMA] = ACTIONS(11335),
    [anon_sym_PIPE] = ACTIONS(11337),
    [anon_sym_SEMI] = ACTIONS(11335),
    [anon_sym_STAR_STAR] = ACTIONS(11335),
    [anon_sym_AMP] = ACTIONS(11337),
    [anon_sym_LT] = ACTIONS(11337),
    [anon_sym_if] = ACTIONS(11335),
    [anon_sym_unless] = ACTIONS(11335),
    [anon_sym_while] = ACTIONS(11335),
    [anon_sym_until] = ACTIONS(11335),
    [anon_sym_rescue] = ACTIONS(11335),
    [anon_sym_do] = ACTIONS(11335),
    [anon_sym_EQ_GT] = ACTIONS(11335),
    [anon_sym_LBRACK] = ACTIONS(11335),
    [anon_sym_COLON_COLON2] = ACTIONS(11335),
    [anon_sym_AMP_DOT] = ACTIONS(11335),
    [anon_sym_QMARK] = ACTIONS(11335),
    [anon_sym_COLON2] = ACTIONS(11337),
    [anon_sym_DOT_DOT] = ACTIONS(11337),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11335),
    [anon_sym_and] = ACTIONS(11335),
    [anon_sym_or] = ACTIONS(11335),
    [anon_sym_PIPE_PIPE] = ACTIONS(11335),
    [anon_sym_AMP_AMP] = ACTIONS(11335),
    [anon_sym_LT_LT] = ACTIONS(11335),
    [anon_sym_GT_GT] = ACTIONS(11335),
    [anon_sym_EQ_EQ] = ACTIONS(11337),
    [anon_sym_BANG_EQ] = ACTIONS(11335),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11335),
    [anon_sym_LT_EQ_GT] = ACTIONS(11335),
    [anon_sym_EQ_TILDE] = ACTIONS(11335),
    [anon_sym_BANG_TILDE] = ACTIONS(11335),
    [anon_sym_LT_EQ] = ACTIONS(11337),
    [anon_sym_GT] = ACTIONS(11337),
    [anon_sym_GT_EQ] = ACTIONS(11335),
    [anon_sym_CARET] = ACTIONS(11335),
    [anon_sym_PLUS] = ACTIONS(11335),
    [anon_sym_SLASH] = ACTIONS(11335),
    [anon_sym_PERCENT] = ACTIONS(11335),
    [sym_comment] = ACTIONS(87),
  },
  [6914] = {
    [sym__binary_minus] = ACTIONS(11344),
    [sym__binary_star] = ACTIONS(11344),
    [anon_sym_LBRACE] = ACTIONS(11344),
    [anon_sym_RBRACE] = ACTIONS(11344),
    [anon_sym_RPAREN] = ACTIONS(11344),
    [anon_sym_DOT] = ACTIONS(11346),
    [anon_sym_COMMA] = ACTIONS(11344),
    [anon_sym_PIPE] = ACTIONS(11346),
    [anon_sym_SEMI] = ACTIONS(11344),
    [anon_sym_STAR_STAR] = ACTIONS(11344),
    [anon_sym_AMP] = ACTIONS(11346),
    [anon_sym_LT] = ACTIONS(11346),
    [anon_sym_if] = ACTIONS(11344),
    [anon_sym_unless] = ACTIONS(11344),
    [anon_sym_while] = ACTIONS(11344),
    [anon_sym_until] = ACTIONS(11344),
    [anon_sym_rescue] = ACTIONS(11344),
    [anon_sym_do] = ACTIONS(11344),
    [anon_sym_EQ_GT] = ACTIONS(11344),
    [anon_sym_LBRACK] = ACTIONS(11344),
    [anon_sym_COLON_COLON2] = ACTIONS(11344),
    [anon_sym_AMP_DOT] = ACTIONS(11344),
    [anon_sym_QMARK] = ACTIONS(11344),
    [anon_sym_COLON2] = ACTIONS(11346),
    [anon_sym_DOT_DOT] = ACTIONS(11346),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11344),
    [anon_sym_and] = ACTIONS(11344),
    [anon_sym_or] = ACTIONS(11344),
    [anon_sym_PIPE_PIPE] = ACTIONS(11344),
    [anon_sym_AMP_AMP] = ACTIONS(11344),
    [anon_sym_LT_LT] = ACTIONS(11344),
    [anon_sym_GT_GT] = ACTIONS(11344),
    [anon_sym_EQ_EQ] = ACTIONS(11346),
    [anon_sym_BANG_EQ] = ACTIONS(11344),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11344),
    [anon_sym_LT_EQ_GT] = ACTIONS(11344),
    [anon_sym_EQ_TILDE] = ACTIONS(11344),
    [anon_sym_BANG_TILDE] = ACTIONS(11344),
    [anon_sym_LT_EQ] = ACTIONS(11346),
    [anon_sym_GT] = ACTIONS(11346),
    [anon_sym_GT_EQ] = ACTIONS(11344),
    [anon_sym_CARET] = ACTIONS(11344),
    [anon_sym_PLUS] = ACTIONS(11344),
    [anon_sym_SLASH] = ACTIONS(11344),
    [anon_sym_PERCENT] = ACTIONS(11344),
    [sym_comment] = ACTIONS(87),
  },
  [6915] = {
    [sym__binary_minus] = ACTIONS(11391),
    [sym__binary_star] = ACTIONS(11391),
    [anon_sym_LBRACE] = ACTIONS(11391),
    [anon_sym_RBRACE] = ACTIONS(11391),
    [anon_sym_RPAREN] = ACTIONS(11391),
    [anon_sym_DOT] = ACTIONS(11393),
    [anon_sym_COMMA] = ACTIONS(11391),
    [anon_sym_PIPE] = ACTIONS(11393),
    [anon_sym_SEMI] = ACTIONS(11391),
    [anon_sym_STAR_STAR] = ACTIONS(11391),
    [anon_sym_AMP] = ACTIONS(11393),
    [anon_sym_LT] = ACTIONS(11393),
    [anon_sym_if] = ACTIONS(11391),
    [anon_sym_unless] = ACTIONS(11391),
    [anon_sym_while] = ACTIONS(11391),
    [anon_sym_until] = ACTIONS(11391),
    [anon_sym_rescue] = ACTIONS(11391),
    [anon_sym_do] = ACTIONS(11391),
    [anon_sym_EQ_GT] = ACTIONS(11391),
    [anon_sym_LBRACK] = ACTIONS(11391),
    [anon_sym_COLON_COLON2] = ACTIONS(11391),
    [anon_sym_AMP_DOT] = ACTIONS(11391),
    [anon_sym_QMARK] = ACTIONS(11391),
    [anon_sym_COLON2] = ACTIONS(11393),
    [anon_sym_DOT_DOT] = ACTIONS(11393),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11391),
    [anon_sym_and] = ACTIONS(11391),
    [anon_sym_or] = ACTIONS(11391),
    [anon_sym_PIPE_PIPE] = ACTIONS(11391),
    [anon_sym_AMP_AMP] = ACTIONS(11391),
    [anon_sym_LT_LT] = ACTIONS(11391),
    [anon_sym_GT_GT] = ACTIONS(11391),
    [anon_sym_EQ_EQ] = ACTIONS(11393),
    [anon_sym_BANG_EQ] = ACTIONS(11391),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11391),
    [anon_sym_LT_EQ_GT] = ACTIONS(11391),
    [anon_sym_EQ_TILDE] = ACTIONS(11391),
    [anon_sym_BANG_TILDE] = ACTIONS(11391),
    [anon_sym_LT_EQ] = ACTIONS(11393),
    [anon_sym_GT] = ACTIONS(11393),
    [anon_sym_GT_EQ] = ACTIONS(11391),
    [anon_sym_CARET] = ACTIONS(11391),
    [anon_sym_PLUS] = ACTIONS(11391),
    [anon_sym_SLASH] = ACTIONS(11391),
    [anon_sym_PERCENT] = ACTIONS(11391),
    [sym_comment] = ACTIONS(87),
  },
  [6916] = {
    [anon_sym_end] = ACTIONS(12605),
    [sym_comment] = ACTIONS(87),
  },
  [6917] = {
    [sym__binary_minus] = ACTIONS(11404),
    [sym__binary_star] = ACTIONS(11404),
    [anon_sym_LBRACE] = ACTIONS(11404),
    [anon_sym_RBRACE] = ACTIONS(11404),
    [anon_sym_RPAREN] = ACTIONS(11404),
    [anon_sym_DOT] = ACTIONS(11406),
    [anon_sym_COMMA] = ACTIONS(11404),
    [anon_sym_PIPE] = ACTIONS(11406),
    [anon_sym_SEMI] = ACTIONS(11404),
    [anon_sym_STAR_STAR] = ACTIONS(11404),
    [anon_sym_AMP] = ACTIONS(11406),
    [anon_sym_LT] = ACTIONS(11406),
    [anon_sym_if] = ACTIONS(11404),
    [anon_sym_unless] = ACTIONS(11404),
    [anon_sym_while] = ACTIONS(11404),
    [anon_sym_until] = ACTIONS(11404),
    [anon_sym_rescue] = ACTIONS(11404),
    [anon_sym_do] = ACTIONS(11404),
    [anon_sym_EQ_GT] = ACTIONS(11404),
    [anon_sym_LBRACK] = ACTIONS(11404),
    [anon_sym_COLON_COLON2] = ACTIONS(11404),
    [anon_sym_AMP_DOT] = ACTIONS(11404),
    [anon_sym_QMARK] = ACTIONS(11404),
    [anon_sym_COLON2] = ACTIONS(11406),
    [anon_sym_DOT_DOT] = ACTIONS(11406),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11404),
    [anon_sym_and] = ACTIONS(11404),
    [anon_sym_or] = ACTIONS(11404),
    [anon_sym_PIPE_PIPE] = ACTIONS(11404),
    [anon_sym_AMP_AMP] = ACTIONS(11404),
    [anon_sym_LT_LT] = ACTIONS(11404),
    [anon_sym_GT_GT] = ACTIONS(11404),
    [anon_sym_EQ_EQ] = ACTIONS(11406),
    [anon_sym_BANG_EQ] = ACTIONS(11404),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11404),
    [anon_sym_LT_EQ_GT] = ACTIONS(11404),
    [anon_sym_EQ_TILDE] = ACTIONS(11404),
    [anon_sym_BANG_TILDE] = ACTIONS(11404),
    [anon_sym_LT_EQ] = ACTIONS(11406),
    [anon_sym_GT] = ACTIONS(11406),
    [anon_sym_GT_EQ] = ACTIONS(11404),
    [anon_sym_CARET] = ACTIONS(11404),
    [anon_sym_PLUS] = ACTIONS(11404),
    [anon_sym_SLASH] = ACTIONS(11404),
    [anon_sym_PERCENT] = ACTIONS(11404),
    [sym_comment] = ACTIONS(87),
  },
  [6918] = {
    [anon_sym_end] = ACTIONS(12607),
    [sym_comment] = ACTIONS(87),
  },
  [6919] = {
    [sym_when] = STATE(2988),
    [sym_else] = STATE(9017),
    [aux_sym_case_repeat2] = STATE(2988),
    [anon_sym_end] = ACTIONS(12607),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [6920] = {
    [sym__binary_minus] = ACTIONS(11846),
    [sym__binary_star] = ACTIONS(11846),
    [anon_sym_LBRACE] = ACTIONS(11846),
    [anon_sym_RBRACE] = ACTIONS(11846),
    [anon_sym_RPAREN] = ACTIONS(11846),
    [anon_sym_DOT] = ACTIONS(11848),
    [anon_sym_COMMA] = ACTIONS(11846),
    [anon_sym_PIPE] = ACTIONS(11848),
    [anon_sym_SEMI] = ACTIONS(11846),
    [anon_sym_STAR_STAR] = ACTIONS(11846),
    [anon_sym_AMP] = ACTIONS(11848),
    [anon_sym_LT] = ACTIONS(11848),
    [anon_sym_if] = ACTIONS(11846),
    [anon_sym_unless] = ACTIONS(11846),
    [anon_sym_while] = ACTIONS(11846),
    [anon_sym_until] = ACTIONS(11846),
    [anon_sym_rescue] = ACTIONS(11846),
    [anon_sym_do] = ACTIONS(11846),
    [anon_sym_EQ_GT] = ACTIONS(11846),
    [anon_sym_LBRACK] = ACTIONS(11846),
    [anon_sym_COLON_COLON2] = ACTIONS(11846),
    [anon_sym_AMP_DOT] = ACTIONS(11846),
    [anon_sym_QMARK] = ACTIONS(11846),
    [anon_sym_COLON2] = ACTIONS(11848),
    [anon_sym_DOT_DOT] = ACTIONS(11848),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11846),
    [anon_sym_and] = ACTIONS(11846),
    [anon_sym_or] = ACTIONS(11846),
    [anon_sym_PIPE_PIPE] = ACTIONS(11846),
    [anon_sym_AMP_AMP] = ACTIONS(11846),
    [anon_sym_LT_LT] = ACTIONS(11846),
    [anon_sym_GT_GT] = ACTIONS(11846),
    [anon_sym_EQ_EQ] = ACTIONS(11848),
    [anon_sym_BANG_EQ] = ACTIONS(11846),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11846),
    [anon_sym_LT_EQ_GT] = ACTIONS(11846),
    [anon_sym_EQ_TILDE] = ACTIONS(11846),
    [anon_sym_BANG_TILDE] = ACTIONS(11846),
    [anon_sym_LT_EQ] = ACTIONS(11848),
    [anon_sym_GT] = ACTIONS(11848),
    [anon_sym_GT_EQ] = ACTIONS(11846),
    [anon_sym_CARET] = ACTIONS(11846),
    [anon_sym_PLUS] = ACTIONS(11846),
    [anon_sym_SLASH] = ACTIONS(11846),
    [anon_sym_PERCENT] = ACTIONS(11846),
    [sym_comment] = ACTIONS(87),
  },
  [6921] = {
    [anon_sym_end] = ACTIONS(12609),
    [sym_comment] = ACTIONS(87),
  },
  [6922] = {
    [sym__binary_minus] = ACTIONS(12029),
    [sym__binary_star] = ACTIONS(12029),
    [anon_sym_LBRACE] = ACTIONS(12029),
    [anon_sym_RBRACE] = ACTIONS(12029),
    [anon_sym_RPAREN] = ACTIONS(12029),
    [anon_sym_DOT] = ACTIONS(12031),
    [anon_sym_COMMA] = ACTIONS(12029),
    [anon_sym_PIPE] = ACTIONS(12031),
    [anon_sym_SEMI] = ACTIONS(12029),
    [anon_sym_STAR_STAR] = ACTIONS(12029),
    [anon_sym_AMP] = ACTIONS(12031),
    [anon_sym_LT] = ACTIONS(12031),
    [anon_sym_if] = ACTIONS(12029),
    [anon_sym_unless] = ACTIONS(12029),
    [anon_sym_while] = ACTIONS(12029),
    [anon_sym_until] = ACTIONS(12029),
    [anon_sym_rescue] = ACTIONS(12029),
    [anon_sym_do] = ACTIONS(12029),
    [anon_sym_EQ_GT] = ACTIONS(12029),
    [anon_sym_LBRACK] = ACTIONS(12029),
    [anon_sym_COLON_COLON2] = ACTIONS(12029),
    [anon_sym_AMP_DOT] = ACTIONS(12029),
    [anon_sym_QMARK] = ACTIONS(12029),
    [anon_sym_COLON2] = ACTIONS(12031),
    [anon_sym_DOT_DOT] = ACTIONS(12031),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12029),
    [anon_sym_and] = ACTIONS(12029),
    [anon_sym_or] = ACTIONS(12029),
    [anon_sym_PIPE_PIPE] = ACTIONS(12029),
    [anon_sym_AMP_AMP] = ACTIONS(12029),
    [anon_sym_LT_LT] = ACTIONS(12029),
    [anon_sym_GT_GT] = ACTIONS(12029),
    [anon_sym_EQ_EQ] = ACTIONS(12031),
    [anon_sym_BANG_EQ] = ACTIONS(12029),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12029),
    [anon_sym_LT_EQ_GT] = ACTIONS(12029),
    [anon_sym_EQ_TILDE] = ACTIONS(12029),
    [anon_sym_BANG_TILDE] = ACTIONS(12029),
    [anon_sym_LT_EQ] = ACTIONS(12031),
    [anon_sym_GT] = ACTIONS(12031),
    [anon_sym_GT_EQ] = ACTIONS(12029),
    [anon_sym_CARET] = ACTIONS(12029),
    [anon_sym_PLUS] = ACTIONS(12029),
    [anon_sym_SLASH] = ACTIONS(12029),
    [anon_sym_PERCENT] = ACTIONS(12029),
    [sym_comment] = ACTIONS(87),
  },
  [6923] = {
    [sym__binary_minus] = ACTIONS(12054),
    [sym__binary_star] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_RBRACE] = ACTIONS(12054),
    [anon_sym_RPAREN] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12056),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_PIPE] = ACTIONS(12056),
    [anon_sym_SEMI] = ACTIONS(12054),
    [anon_sym_STAR_STAR] = ACTIONS(12054),
    [anon_sym_AMP] = ACTIONS(12056),
    [anon_sym_LT] = ACTIONS(12056),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_unless] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [anon_sym_until] = ACTIONS(12054),
    [anon_sym_rescue] = ACTIONS(12054),
    [anon_sym_do] = ACTIONS(12054),
    [anon_sym_EQ_GT] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_COLON_COLON2] = ACTIONS(12054),
    [anon_sym_AMP_DOT] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_COLON2] = ACTIONS(12056),
    [anon_sym_DOT_DOT] = ACTIONS(12056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_and] = ACTIONS(12054),
    [anon_sym_or] = ACTIONS(12054),
    [anon_sym_PIPE_PIPE] = ACTIONS(12054),
    [anon_sym_AMP_AMP] = ACTIONS(12054),
    [anon_sym_LT_LT] = ACTIONS(12054),
    [anon_sym_GT_GT] = ACTIONS(12054),
    [anon_sym_EQ_EQ] = ACTIONS(12056),
    [anon_sym_BANG_EQ] = ACTIONS(12054),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12054),
    [anon_sym_LT_EQ_GT] = ACTIONS(12054),
    [anon_sym_EQ_TILDE] = ACTIONS(12054),
    [anon_sym_BANG_TILDE] = ACTIONS(12054),
    [anon_sym_LT_EQ] = ACTIONS(12056),
    [anon_sym_GT] = ACTIONS(12056),
    [anon_sym_GT_EQ] = ACTIONS(12054),
    [anon_sym_CARET] = ACTIONS(12054),
    [anon_sym_PLUS] = ACTIONS(12054),
    [anon_sym_SLASH] = ACTIONS(12054),
    [anon_sym_PERCENT] = ACTIONS(12054),
    [sym_comment] = ACTIONS(87),
  },
  [6924] = {
    [anon_sym_end] = ACTIONS(12611),
    [sym_comment] = ACTIONS(87),
  },
  [6925] = {
    [sym__statements] = STATE(9020),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12613),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6926] = {
    [sym__binary_minus] = ACTIONS(1103),
    [sym__binary_star] = ACTIONS(1105),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_STAR_STAR] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(1111),
    [anon_sym_EQ_GT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(1113),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1117),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(1121),
    [anon_sym_AMP_AMP] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1125),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1121),
    [anon_sym_LT_EQ_GT] = ACTIONS(1121),
    [anon_sym_EQ_TILDE] = ACTIONS(1121),
    [anon_sym_BANG_TILDE] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1111),
    [anon_sym_GT] = ACTIONS(1111),
    [anon_sym_GT_EQ] = ACTIONS(1127),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1103),
    [anon_sym_SLASH] = ACTIONS(1105),
    [anon_sym_PERCENT] = ACTIONS(1105),
    [sym_comment] = ACTIONS(87),
  },
  [6927] = {
    [sym__simple_symbol] = ACTIONS(7876),
    [sym__string_start] = ACTIONS(7876),
    [sym__symbol_start] = ACTIONS(7876),
    [sym__subshell_start] = ACTIONS(7876),
    [sym__regex_start] = ACTIONS(7876),
    [sym__string_array_start] = ACTIONS(7876),
    [sym__symbol_array_start] = ACTIONS(7876),
    [sym_heredoc_beginning] = ACTIONS(7876),
    [sym__block_ampersand] = ACTIONS(7876),
    [sym__splat_star] = ACTIONS(7876),
    [sym__unary_minus] = ACTIONS(7876),
    [sym__binary_minus] = ACTIONS(7876),
    [sym__binary_star] = ACTIONS(7876),
    [sym__identifier_hash_key] = ACTIONS(7876),
    [anon_sym_LBRACE] = ACTIONS(7876),
    [anon_sym_def] = ACTIONS(7878),
    [anon_sym_LPAREN] = ACTIONS(7878),
    [anon_sym_DOT] = ACTIONS(7878),
    [anon_sym_COLON_COLON] = ACTIONS(7878),
    [anon_sym_COMMA] = ACTIONS(7876),
    [anon_sym_PIPE] = ACTIONS(7878),
    [anon_sym_STAR] = ACTIONS(7878),
    [anon_sym_STAR_STAR] = ACTIONS(7878),
    [anon_sym_AMP] = ACTIONS(7878),
    [anon_sym_EQ] = ACTIONS(7878),
    [anon_sym_class] = ACTIONS(7878),
    [anon_sym_LT] = ACTIONS(7878),
    [anon_sym_module] = ACTIONS(7878),
    [anon_sym_return] = ACTIONS(7878),
    [anon_sym_yield] = ACTIONS(7878),
    [anon_sym_break] = ACTIONS(7878),
    [anon_sym_next] = ACTIONS(7878),
    [sym_redo] = ACTIONS(7878),
    [sym_retry] = ACTIONS(7878),
    [anon_sym_if] = ACTIONS(7878),
    [anon_sym_unless] = ACTIONS(7878),
    [anon_sym_while] = ACTIONS(7878),
    [anon_sym_until] = ACTIONS(7878),
    [anon_sym_for] = ACTIONS(7878),
    [anon_sym_do] = ACTIONS(7878),
    [anon_sym_case] = ACTIONS(7878),
    [anon_sym_begin] = ACTIONS(7878),
    [anon_sym_EQ_GT] = ACTIONS(7876),
    [anon_sym_LBRACK] = ACTIONS(7876),
    [anon_sym_COLON_COLON2] = ACTIONS(7876),
    [anon_sym_AMP_DOT] = ACTIONS(7876),
    [anon_sym_LPAREN2] = ACTIONS(7876),
    [anon_sym_PLUS_EQ] = ACTIONS(7876),
    [anon_sym_DASH_EQ] = ACTIONS(7876),
    [anon_sym_STAR_EQ] = ACTIONS(7876),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7876),
    [anon_sym_SLASH_EQ] = ACTIONS(7876),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7876),
    [anon_sym_PIPE_EQ] = ACTIONS(7876),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7876),
    [anon_sym_AMP_EQ] = ACTIONS(7876),
    [anon_sym_PERCENT_EQ] = ACTIONS(7876),
    [anon_sym_GT_GT_EQ] = ACTIONS(7876),
    [anon_sym_LT_LT_EQ] = ACTIONS(7876),
    [anon_sym_CARET_EQ] = ACTIONS(7876),
    [anon_sym_QMARK] = ACTIONS(7878),
    [anon_sym_DOT_DOT] = ACTIONS(7878),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7876),
    [anon_sym_and] = ACTIONS(7878),
    [anon_sym_or] = ACTIONS(7878),
    [anon_sym_PIPE_PIPE] = ACTIONS(7878),
    [anon_sym_AMP_AMP] = ACTIONS(7878),
    [anon_sym_LT_LT] = ACTIONS(7878),
    [anon_sym_GT_GT] = ACTIONS(7878),
    [anon_sym_EQ_EQ] = ACTIONS(7878),
    [anon_sym_BANG_EQ] = ACTIONS(7876),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7876),
    [anon_sym_LT_EQ_GT] = ACTIONS(7876),
    [anon_sym_EQ_TILDE] = ACTIONS(7876),
    [anon_sym_BANG_TILDE] = ACTIONS(7876),
    [anon_sym_LT_EQ] = ACTIONS(7878),
    [anon_sym_GT] = ACTIONS(7878),
    [anon_sym_GT_EQ] = ACTIONS(7876),
    [anon_sym_CARET] = ACTIONS(7878),
    [anon_sym_PLUS] = ACTIONS(7878),
    [anon_sym_SLASH] = ACTIONS(7878),
    [anon_sym_PERCENT] = ACTIONS(7878),
    [anon_sym_defined_QMARK] = ACTIONS(7876),
    [anon_sym_not] = ACTIONS(7878),
    [anon_sym_BANG] = ACTIONS(7878),
    [anon_sym_TILDE] = ACTIONS(7876),
    [sym_constant] = ACTIONS(7878),
    [sym_identifier] = ACTIONS(7878),
    [sym_instance_variable] = ACTIONS(7876),
    [sym_class_variable] = ACTIONS(7876),
    [sym_global_variable] = ACTIONS(7876),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(7878),
    [sym_float] = ACTIONS(7878),
    [sym_complex] = ACTIONS(7876),
    [sym_super] = ACTIONS(7878),
    [anon_sym_true] = ACTIONS(7878),
    [anon_sym_TRUE] = ACTIONS(7878),
    [anon_sym_false] = ACTIONS(7878),
    [anon_sym_FALSE] = ACTIONS(7878),
    [sym_self] = ACTIONS(7878),
    [anon_sym_nil] = ACTIONS(7878),
    [anon_sym_NIL] = ACTIONS(7878),
    [sym_character] = ACTIONS(7876),
    [anon_sym_LBRACK2] = ACTIONS(7878),
    [anon_sym_DASH_GT] = ACTIONS(7876),
  },
  [6928] = {
    [sym__heredoc_body_start] = ACTIONS(6601),
    [sym__binary_minus] = ACTIONS(6601),
    [sym__binary_star] = ACTIONS(6601),
    [anon_sym_LBRACE] = ACTIONS(6601),
    [anon_sym_RBRACE] = ACTIONS(6601),
    [anon_sym_RPAREN] = ACTIONS(6601),
    [anon_sym_DOT] = ACTIONS(6603),
    [anon_sym_COMMA] = ACTIONS(6601),
    [anon_sym_PIPE] = ACTIONS(6603),
    [anon_sym_SEMI] = ACTIONS(6601),
    [anon_sym_STAR_STAR] = ACTIONS(6603),
    [anon_sym_AMP] = ACTIONS(6603),
    [anon_sym_EQ] = ACTIONS(6603),
    [anon_sym_LT] = ACTIONS(6603),
    [anon_sym_if] = ACTIONS(6601),
    [anon_sym_unless] = ACTIONS(6601),
    [anon_sym_while] = ACTIONS(6601),
    [anon_sym_until] = ACTIONS(6601),
    [anon_sym_rescue] = ACTIONS(6601),
    [anon_sym_in] = ACTIONS(6601),
    [anon_sym_do] = ACTIONS(6601),
    [anon_sym_EQ_GT] = ACTIONS(6601),
    [anon_sym_LBRACK] = ACTIONS(6601),
    [anon_sym_RBRACK] = ACTIONS(6601),
    [anon_sym_COLON_COLON2] = ACTIONS(6601),
    [anon_sym_AMP_DOT] = ACTIONS(6601),
    [anon_sym_PLUS_EQ] = ACTIONS(6601),
    [anon_sym_DASH_EQ] = ACTIONS(6601),
    [anon_sym_STAR_EQ] = ACTIONS(6601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6601),
    [anon_sym_SLASH_EQ] = ACTIONS(6601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6601),
    [anon_sym_PIPE_EQ] = ACTIONS(6601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6601),
    [anon_sym_AMP_EQ] = ACTIONS(6601),
    [anon_sym_PERCENT_EQ] = ACTIONS(6601),
    [anon_sym_GT_GT_EQ] = ACTIONS(6601),
    [anon_sym_LT_LT_EQ] = ACTIONS(6601),
    [anon_sym_CARET_EQ] = ACTIONS(6601),
    [anon_sym_QMARK] = ACTIONS(6601),
    [anon_sym_COLON2] = ACTIONS(6603),
    [anon_sym_DOT_DOT] = ACTIONS(6603),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6601),
    [anon_sym_and] = ACTIONS(6601),
    [anon_sym_or] = ACTIONS(6601),
    [anon_sym_PIPE_PIPE] = ACTIONS(6603),
    [anon_sym_AMP_AMP] = ACTIONS(6603),
    [anon_sym_LT_LT] = ACTIONS(6603),
    [anon_sym_GT_GT] = ACTIONS(6603),
    [anon_sym_EQ_EQ] = ACTIONS(6603),
    [anon_sym_BANG_EQ] = ACTIONS(6601),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6601),
    [anon_sym_LT_EQ_GT] = ACTIONS(6601),
    [anon_sym_EQ_TILDE] = ACTIONS(6601),
    [anon_sym_BANG_TILDE] = ACTIONS(6601),
    [anon_sym_LT_EQ] = ACTIONS(6603),
    [anon_sym_GT] = ACTIONS(6603),
    [anon_sym_GT_EQ] = ACTIONS(6601),
    [anon_sym_CARET] = ACTIONS(6603),
    [anon_sym_PLUS] = ACTIONS(6603),
    [anon_sym_SLASH] = ACTIONS(6603),
    [anon_sym_PERCENT] = ACTIONS(6603),
    [sym_comment] = ACTIONS(87),
  },
  [6929] = {
    [sym__heredoc_body_start] = ACTIONS(6605),
    [sym__binary_minus] = ACTIONS(6605),
    [sym__binary_star] = ACTIONS(6605),
    [anon_sym_LBRACE] = ACTIONS(6605),
    [anon_sym_RBRACE] = ACTIONS(6605),
    [anon_sym_RPAREN] = ACTIONS(6605),
    [anon_sym_DOT] = ACTIONS(6607),
    [anon_sym_COMMA] = ACTIONS(6605),
    [anon_sym_PIPE] = ACTIONS(6607),
    [anon_sym_SEMI] = ACTIONS(6605),
    [anon_sym_STAR_STAR] = ACTIONS(6607),
    [anon_sym_AMP] = ACTIONS(6607),
    [anon_sym_EQ] = ACTIONS(6607),
    [anon_sym_LT] = ACTIONS(6607),
    [anon_sym_if] = ACTIONS(6605),
    [anon_sym_unless] = ACTIONS(6605),
    [anon_sym_while] = ACTIONS(6605),
    [anon_sym_until] = ACTIONS(6605),
    [anon_sym_rescue] = ACTIONS(6605),
    [anon_sym_in] = ACTIONS(6605),
    [anon_sym_do] = ACTIONS(6605),
    [anon_sym_EQ_GT] = ACTIONS(6605),
    [anon_sym_LBRACK] = ACTIONS(6605),
    [anon_sym_RBRACK] = ACTIONS(6605),
    [anon_sym_COLON_COLON2] = ACTIONS(6605),
    [anon_sym_AMP_DOT] = ACTIONS(6605),
    [anon_sym_PLUS_EQ] = ACTIONS(6605),
    [anon_sym_DASH_EQ] = ACTIONS(6605),
    [anon_sym_STAR_EQ] = ACTIONS(6605),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6605),
    [anon_sym_SLASH_EQ] = ACTIONS(6605),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6605),
    [anon_sym_PIPE_EQ] = ACTIONS(6605),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6605),
    [anon_sym_AMP_EQ] = ACTIONS(6605),
    [anon_sym_PERCENT_EQ] = ACTIONS(6605),
    [anon_sym_GT_GT_EQ] = ACTIONS(6605),
    [anon_sym_LT_LT_EQ] = ACTIONS(6605),
    [anon_sym_CARET_EQ] = ACTIONS(6605),
    [anon_sym_QMARK] = ACTIONS(6605),
    [anon_sym_COLON2] = ACTIONS(6607),
    [anon_sym_DOT_DOT] = ACTIONS(6607),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6605),
    [anon_sym_and] = ACTIONS(6605),
    [anon_sym_or] = ACTIONS(6605),
    [anon_sym_PIPE_PIPE] = ACTIONS(6607),
    [anon_sym_AMP_AMP] = ACTIONS(6607),
    [anon_sym_LT_LT] = ACTIONS(6607),
    [anon_sym_GT_GT] = ACTIONS(6607),
    [anon_sym_EQ_EQ] = ACTIONS(6607),
    [anon_sym_BANG_EQ] = ACTIONS(6605),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6605),
    [anon_sym_LT_EQ_GT] = ACTIONS(6605),
    [anon_sym_EQ_TILDE] = ACTIONS(6605),
    [anon_sym_BANG_TILDE] = ACTIONS(6605),
    [anon_sym_LT_EQ] = ACTIONS(6607),
    [anon_sym_GT] = ACTIONS(6607),
    [anon_sym_GT_EQ] = ACTIONS(6605),
    [anon_sym_CARET] = ACTIONS(6607),
    [anon_sym_PLUS] = ACTIONS(6607),
    [anon_sym_SLASH] = ACTIONS(6607),
    [anon_sym_PERCENT] = ACTIONS(6607),
    [sym_comment] = ACTIONS(87),
  },
  [6930] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1697),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(12615),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [6931] = {
    [aux_sym_string_array_repeat1] = STATE(1699),
    [sym__string_end] = ACTIONS(12615),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(12617),
  },
  [6932] = {
    [sym__heredoc_body_start] = ACTIONS(6613),
    [sym__binary_minus] = ACTIONS(6613),
    [sym__binary_star] = ACTIONS(6613),
    [anon_sym_LBRACE] = ACTIONS(6613),
    [anon_sym_RBRACE] = ACTIONS(6613),
    [anon_sym_RPAREN] = ACTIONS(6613),
    [anon_sym_DOT] = ACTIONS(6615),
    [anon_sym_COMMA] = ACTIONS(6613),
    [anon_sym_PIPE] = ACTIONS(6615),
    [anon_sym_SEMI] = ACTIONS(6613),
    [anon_sym_STAR_STAR] = ACTIONS(6615),
    [anon_sym_AMP] = ACTIONS(6615),
    [anon_sym_EQ] = ACTIONS(6615),
    [anon_sym_LT] = ACTIONS(6615),
    [anon_sym_if] = ACTIONS(6613),
    [anon_sym_unless] = ACTIONS(6613),
    [anon_sym_while] = ACTIONS(6613),
    [anon_sym_until] = ACTIONS(6613),
    [anon_sym_rescue] = ACTIONS(6613),
    [anon_sym_in] = ACTIONS(6613),
    [anon_sym_do] = ACTIONS(6613),
    [anon_sym_EQ_GT] = ACTIONS(6613),
    [anon_sym_LBRACK] = ACTIONS(6613),
    [anon_sym_RBRACK] = ACTIONS(6613),
    [anon_sym_COLON_COLON2] = ACTIONS(6613),
    [anon_sym_AMP_DOT] = ACTIONS(6613),
    [anon_sym_PLUS_EQ] = ACTIONS(6613),
    [anon_sym_DASH_EQ] = ACTIONS(6613),
    [anon_sym_STAR_EQ] = ACTIONS(6613),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6613),
    [anon_sym_SLASH_EQ] = ACTIONS(6613),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6613),
    [anon_sym_PIPE_EQ] = ACTIONS(6613),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6613),
    [anon_sym_AMP_EQ] = ACTIONS(6613),
    [anon_sym_PERCENT_EQ] = ACTIONS(6613),
    [anon_sym_GT_GT_EQ] = ACTIONS(6613),
    [anon_sym_LT_LT_EQ] = ACTIONS(6613),
    [anon_sym_CARET_EQ] = ACTIONS(6613),
    [anon_sym_QMARK] = ACTIONS(6613),
    [anon_sym_COLON2] = ACTIONS(6615),
    [anon_sym_DOT_DOT] = ACTIONS(6615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6613),
    [anon_sym_and] = ACTIONS(6613),
    [anon_sym_or] = ACTIONS(6613),
    [anon_sym_PIPE_PIPE] = ACTIONS(6615),
    [anon_sym_AMP_AMP] = ACTIONS(6615),
    [anon_sym_LT_LT] = ACTIONS(6615),
    [anon_sym_GT_GT] = ACTIONS(6615),
    [anon_sym_EQ_EQ] = ACTIONS(6615),
    [anon_sym_BANG_EQ] = ACTIONS(6613),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6613),
    [anon_sym_LT_EQ_GT] = ACTIONS(6613),
    [anon_sym_EQ_TILDE] = ACTIONS(6613),
    [anon_sym_BANG_TILDE] = ACTIONS(6613),
    [anon_sym_LT_EQ] = ACTIONS(6615),
    [anon_sym_GT] = ACTIONS(6615),
    [anon_sym_GT_EQ] = ACTIONS(6613),
    [anon_sym_CARET] = ACTIONS(6615),
    [anon_sym_PLUS] = ACTIONS(6615),
    [anon_sym_SLASH] = ACTIONS(6615),
    [anon_sym_PERCENT] = ACTIONS(6615),
    [sym_comment] = ACTIONS(87),
  },
  [6933] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1697),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(12619),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [6934] = {
    [sym__heredoc_body_start] = ACTIONS(6626),
    [sym__binary_minus] = ACTIONS(6626),
    [sym__binary_star] = ACTIONS(6626),
    [anon_sym_LBRACE] = ACTIONS(6626),
    [anon_sym_RBRACE] = ACTIONS(6626),
    [anon_sym_RPAREN] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(6628),
    [anon_sym_COMMA] = ACTIONS(6626),
    [anon_sym_PIPE] = ACTIONS(6628),
    [anon_sym_SEMI] = ACTIONS(6626),
    [anon_sym_STAR_STAR] = ACTIONS(6628),
    [anon_sym_AMP] = ACTIONS(6628),
    [anon_sym_EQ] = ACTIONS(6628),
    [anon_sym_LT] = ACTIONS(6628),
    [anon_sym_if] = ACTIONS(6626),
    [anon_sym_unless] = ACTIONS(6626),
    [anon_sym_while] = ACTIONS(6626),
    [anon_sym_until] = ACTIONS(6626),
    [anon_sym_rescue] = ACTIONS(6626),
    [anon_sym_in] = ACTIONS(6626),
    [anon_sym_do] = ACTIONS(6626),
    [anon_sym_EQ_GT] = ACTIONS(6626),
    [anon_sym_LBRACK] = ACTIONS(6626),
    [anon_sym_RBRACK] = ACTIONS(6626),
    [anon_sym_COLON_COLON2] = ACTIONS(6626),
    [anon_sym_AMP_DOT] = ACTIONS(6626),
    [anon_sym_PLUS_EQ] = ACTIONS(6626),
    [anon_sym_DASH_EQ] = ACTIONS(6626),
    [anon_sym_STAR_EQ] = ACTIONS(6626),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6626),
    [anon_sym_SLASH_EQ] = ACTIONS(6626),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6626),
    [anon_sym_PIPE_EQ] = ACTIONS(6626),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6626),
    [anon_sym_AMP_EQ] = ACTIONS(6626),
    [anon_sym_PERCENT_EQ] = ACTIONS(6626),
    [anon_sym_GT_GT_EQ] = ACTIONS(6626),
    [anon_sym_LT_LT_EQ] = ACTIONS(6626),
    [anon_sym_CARET_EQ] = ACTIONS(6626),
    [anon_sym_QMARK] = ACTIONS(6626),
    [anon_sym_COLON2] = ACTIONS(6628),
    [anon_sym_DOT_DOT] = ACTIONS(6628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6626),
    [anon_sym_and] = ACTIONS(6626),
    [anon_sym_or] = ACTIONS(6626),
    [anon_sym_PIPE_PIPE] = ACTIONS(6628),
    [anon_sym_AMP_AMP] = ACTIONS(6628),
    [anon_sym_LT_LT] = ACTIONS(6628),
    [anon_sym_GT_GT] = ACTIONS(6628),
    [anon_sym_EQ_EQ] = ACTIONS(6628),
    [anon_sym_BANG_EQ] = ACTIONS(6626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6626),
    [anon_sym_LT_EQ_GT] = ACTIONS(6626),
    [anon_sym_EQ_TILDE] = ACTIONS(6626),
    [anon_sym_BANG_TILDE] = ACTIONS(6626),
    [anon_sym_LT_EQ] = ACTIONS(6628),
    [anon_sym_GT] = ACTIONS(6628),
    [anon_sym_GT_EQ] = ACTIONS(6626),
    [anon_sym_CARET] = ACTIONS(6628),
    [anon_sym_PLUS] = ACTIONS(6628),
    [anon_sym_SLASH] = ACTIONS(6628),
    [anon_sym_PERCENT] = ACTIONS(6628),
    [sym_comment] = ACTIONS(87),
  },
  [6935] = {
    [sym__heredoc_body_start] = ACTIONS(6630),
    [sym__binary_minus] = ACTIONS(6630),
    [sym__binary_star] = ACTIONS(6630),
    [anon_sym_LBRACE] = ACTIONS(6630),
    [anon_sym_RBRACE] = ACTIONS(6630),
    [anon_sym_RPAREN] = ACTIONS(6630),
    [anon_sym_DOT] = ACTIONS(6632),
    [anon_sym_COMMA] = ACTIONS(6630),
    [anon_sym_PIPE] = ACTIONS(6632),
    [anon_sym_SEMI] = ACTIONS(6630),
    [anon_sym_STAR_STAR] = ACTIONS(6632),
    [anon_sym_AMP] = ACTIONS(6632),
    [anon_sym_EQ] = ACTIONS(6632),
    [anon_sym_LT] = ACTIONS(6632),
    [anon_sym_if] = ACTIONS(6630),
    [anon_sym_unless] = ACTIONS(6630),
    [anon_sym_while] = ACTIONS(6630),
    [anon_sym_until] = ACTIONS(6630),
    [anon_sym_rescue] = ACTIONS(6630),
    [anon_sym_in] = ACTIONS(6630),
    [anon_sym_do] = ACTIONS(6630),
    [anon_sym_EQ_GT] = ACTIONS(6630),
    [anon_sym_LBRACK] = ACTIONS(6630),
    [anon_sym_RBRACK] = ACTIONS(6630),
    [anon_sym_COLON_COLON2] = ACTIONS(6630),
    [anon_sym_AMP_DOT] = ACTIONS(6630),
    [anon_sym_PLUS_EQ] = ACTIONS(6630),
    [anon_sym_DASH_EQ] = ACTIONS(6630),
    [anon_sym_STAR_EQ] = ACTIONS(6630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6630),
    [anon_sym_SLASH_EQ] = ACTIONS(6630),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6630),
    [anon_sym_PIPE_EQ] = ACTIONS(6630),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6630),
    [anon_sym_AMP_EQ] = ACTIONS(6630),
    [anon_sym_PERCENT_EQ] = ACTIONS(6630),
    [anon_sym_GT_GT_EQ] = ACTIONS(6630),
    [anon_sym_LT_LT_EQ] = ACTIONS(6630),
    [anon_sym_CARET_EQ] = ACTIONS(6630),
    [anon_sym_QMARK] = ACTIONS(6630),
    [anon_sym_COLON2] = ACTIONS(6632),
    [anon_sym_DOT_DOT] = ACTIONS(6632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6630),
    [anon_sym_and] = ACTIONS(6630),
    [anon_sym_or] = ACTIONS(6630),
    [anon_sym_PIPE_PIPE] = ACTIONS(6632),
    [anon_sym_AMP_AMP] = ACTIONS(6632),
    [anon_sym_LT_LT] = ACTIONS(6632),
    [anon_sym_GT_GT] = ACTIONS(6632),
    [anon_sym_EQ_EQ] = ACTIONS(6632),
    [anon_sym_BANG_EQ] = ACTIONS(6630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6630),
    [anon_sym_LT_EQ_GT] = ACTIONS(6630),
    [anon_sym_EQ_TILDE] = ACTIONS(6630),
    [anon_sym_BANG_TILDE] = ACTIONS(6630),
    [anon_sym_LT_EQ] = ACTIONS(6632),
    [anon_sym_GT] = ACTIONS(6632),
    [anon_sym_GT_EQ] = ACTIONS(6630),
    [anon_sym_CARET] = ACTIONS(6632),
    [anon_sym_PLUS] = ACTIONS(6632),
    [anon_sym_SLASH] = ACTIONS(6632),
    [anon_sym_PERCENT] = ACTIONS(6632),
    [sym_comment] = ACTIONS(87),
  },
  [6936] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1705),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(12621),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [6937] = {
    [aux_sym_symbol_array_repeat1] = STATE(1707),
    [sym__string_end] = ACTIONS(12621),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(12623),
  },
  [6938] = {
    [sym__heredoc_body_start] = ACTIONS(6638),
    [sym__binary_minus] = ACTIONS(6638),
    [sym__binary_star] = ACTIONS(6638),
    [anon_sym_LBRACE] = ACTIONS(6638),
    [anon_sym_RBRACE] = ACTIONS(6638),
    [anon_sym_RPAREN] = ACTIONS(6638),
    [anon_sym_DOT] = ACTIONS(6640),
    [anon_sym_COMMA] = ACTIONS(6638),
    [anon_sym_PIPE] = ACTIONS(6640),
    [anon_sym_SEMI] = ACTIONS(6638),
    [anon_sym_STAR_STAR] = ACTIONS(6640),
    [anon_sym_AMP] = ACTIONS(6640),
    [anon_sym_EQ] = ACTIONS(6640),
    [anon_sym_LT] = ACTIONS(6640),
    [anon_sym_if] = ACTIONS(6638),
    [anon_sym_unless] = ACTIONS(6638),
    [anon_sym_while] = ACTIONS(6638),
    [anon_sym_until] = ACTIONS(6638),
    [anon_sym_rescue] = ACTIONS(6638),
    [anon_sym_in] = ACTIONS(6638),
    [anon_sym_do] = ACTIONS(6638),
    [anon_sym_EQ_GT] = ACTIONS(6638),
    [anon_sym_LBRACK] = ACTIONS(6638),
    [anon_sym_RBRACK] = ACTIONS(6638),
    [anon_sym_COLON_COLON2] = ACTIONS(6638),
    [anon_sym_AMP_DOT] = ACTIONS(6638),
    [anon_sym_PLUS_EQ] = ACTIONS(6638),
    [anon_sym_DASH_EQ] = ACTIONS(6638),
    [anon_sym_STAR_EQ] = ACTIONS(6638),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6638),
    [anon_sym_SLASH_EQ] = ACTIONS(6638),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6638),
    [anon_sym_PIPE_EQ] = ACTIONS(6638),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6638),
    [anon_sym_AMP_EQ] = ACTIONS(6638),
    [anon_sym_PERCENT_EQ] = ACTIONS(6638),
    [anon_sym_GT_GT_EQ] = ACTIONS(6638),
    [anon_sym_LT_LT_EQ] = ACTIONS(6638),
    [anon_sym_CARET_EQ] = ACTIONS(6638),
    [anon_sym_QMARK] = ACTIONS(6638),
    [anon_sym_COLON2] = ACTIONS(6640),
    [anon_sym_DOT_DOT] = ACTIONS(6640),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6638),
    [anon_sym_and] = ACTIONS(6638),
    [anon_sym_or] = ACTIONS(6638),
    [anon_sym_PIPE_PIPE] = ACTIONS(6640),
    [anon_sym_AMP_AMP] = ACTIONS(6640),
    [anon_sym_LT_LT] = ACTIONS(6640),
    [anon_sym_GT_GT] = ACTIONS(6640),
    [anon_sym_EQ_EQ] = ACTIONS(6640),
    [anon_sym_BANG_EQ] = ACTIONS(6638),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6638),
    [anon_sym_LT_EQ_GT] = ACTIONS(6638),
    [anon_sym_EQ_TILDE] = ACTIONS(6638),
    [anon_sym_BANG_TILDE] = ACTIONS(6638),
    [anon_sym_LT_EQ] = ACTIONS(6640),
    [anon_sym_GT] = ACTIONS(6640),
    [anon_sym_GT_EQ] = ACTIONS(6638),
    [anon_sym_CARET] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(6640),
    [anon_sym_SLASH] = ACTIONS(6640),
    [anon_sym_PERCENT] = ACTIONS(6640),
    [sym_comment] = ACTIONS(87),
  },
  [6939] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1705),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(12625),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [6940] = {
    [sym__binary_minus] = ACTIONS(12029),
    [sym__binary_star] = ACTIONS(12029),
    [anon_sym_DOT] = ACTIONS(12031),
    [anon_sym_COMMA] = ACTIONS(12029),
    [anon_sym_PIPE] = ACTIONS(12031),
    [anon_sym_STAR_STAR] = ACTIONS(12031),
    [anon_sym_AMP] = ACTIONS(12031),
    [anon_sym_EQ] = ACTIONS(12031),
    [anon_sym_LT] = ACTIONS(12031),
    [anon_sym_EQ_GT] = ACTIONS(12029),
    [anon_sym_LBRACK] = ACTIONS(12029),
    [anon_sym_COLON_COLON2] = ACTIONS(12029),
    [anon_sym_AMP_DOT] = ACTIONS(12029),
    [anon_sym_PLUS_EQ] = ACTIONS(12029),
    [anon_sym_DASH_EQ] = ACTIONS(12029),
    [anon_sym_STAR_EQ] = ACTIONS(12029),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12029),
    [anon_sym_SLASH_EQ] = ACTIONS(12029),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12029),
    [anon_sym_PIPE_EQ] = ACTIONS(12029),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12029),
    [anon_sym_AMP_EQ] = ACTIONS(12029),
    [anon_sym_PERCENT_EQ] = ACTIONS(12029),
    [anon_sym_GT_GT_EQ] = ACTIONS(12029),
    [anon_sym_LT_LT_EQ] = ACTIONS(12029),
    [anon_sym_CARET_EQ] = ACTIONS(12029),
    [anon_sym_QMARK] = ACTIONS(12029),
    [anon_sym_DOT_DOT] = ACTIONS(12031),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12029),
    [anon_sym_and] = ACTIONS(12029),
    [anon_sym_or] = ACTIONS(12029),
    [anon_sym_PIPE_PIPE] = ACTIONS(12031),
    [anon_sym_AMP_AMP] = ACTIONS(12031),
    [anon_sym_LT_LT] = ACTIONS(12031),
    [anon_sym_GT_GT] = ACTIONS(12031),
    [anon_sym_EQ_EQ] = ACTIONS(12031),
    [anon_sym_BANG_EQ] = ACTIONS(12029),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12029),
    [anon_sym_LT_EQ_GT] = ACTIONS(12029),
    [anon_sym_EQ_TILDE] = ACTIONS(12029),
    [anon_sym_BANG_TILDE] = ACTIONS(12029),
    [anon_sym_LT_EQ] = ACTIONS(12031),
    [anon_sym_GT] = ACTIONS(12031),
    [anon_sym_GT_EQ] = ACTIONS(12029),
    [anon_sym_CARET] = ACTIONS(12031),
    [anon_sym_PLUS] = ACTIONS(12031),
    [anon_sym_SLASH] = ACTIONS(12031),
    [anon_sym_PERCENT] = ACTIONS(12031),
    [sym_comment] = ACTIONS(87),
  },
  [6941] = {
    [sym__heredoc_body_start] = ACTIONS(7162),
    [sym__binary_minus] = ACTIONS(7162),
    [sym__binary_star] = ACTIONS(7162),
    [anon_sym_LBRACE] = ACTIONS(7162),
    [anon_sym_RBRACE] = ACTIONS(7162),
    [anon_sym_RPAREN] = ACTIONS(7162),
    [anon_sym_DOT] = ACTIONS(7164),
    [anon_sym_COMMA] = ACTIONS(7162),
    [anon_sym_PIPE] = ACTIONS(7164),
    [anon_sym_SEMI] = ACTIONS(7162),
    [anon_sym_STAR_STAR] = ACTIONS(7164),
    [anon_sym_AMP] = ACTIONS(7164),
    [anon_sym_EQ] = ACTIONS(7164),
    [anon_sym_LT] = ACTIONS(7164),
    [anon_sym_if] = ACTIONS(7162),
    [anon_sym_unless] = ACTIONS(7162),
    [anon_sym_while] = ACTIONS(7162),
    [anon_sym_until] = ACTIONS(7162),
    [anon_sym_rescue] = ACTIONS(7162),
    [anon_sym_in] = ACTIONS(7162),
    [anon_sym_do] = ACTIONS(7162),
    [anon_sym_EQ_GT] = ACTIONS(7162),
    [anon_sym_LBRACK] = ACTIONS(7162),
    [anon_sym_RBRACK] = ACTIONS(7162),
    [anon_sym_COLON_COLON2] = ACTIONS(7162),
    [anon_sym_AMP_DOT] = ACTIONS(7162),
    [anon_sym_PLUS_EQ] = ACTIONS(7162),
    [anon_sym_DASH_EQ] = ACTIONS(7162),
    [anon_sym_STAR_EQ] = ACTIONS(7162),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7162),
    [anon_sym_SLASH_EQ] = ACTIONS(7162),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7162),
    [anon_sym_PIPE_EQ] = ACTIONS(7162),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7162),
    [anon_sym_AMP_EQ] = ACTIONS(7162),
    [anon_sym_PERCENT_EQ] = ACTIONS(7162),
    [anon_sym_GT_GT_EQ] = ACTIONS(7162),
    [anon_sym_LT_LT_EQ] = ACTIONS(7162),
    [anon_sym_CARET_EQ] = ACTIONS(7162),
    [anon_sym_QMARK] = ACTIONS(7162),
    [anon_sym_COLON2] = ACTIONS(7164),
    [anon_sym_DOT_DOT] = ACTIONS(7164),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7162),
    [anon_sym_and] = ACTIONS(7162),
    [anon_sym_or] = ACTIONS(7162),
    [anon_sym_PIPE_PIPE] = ACTIONS(7164),
    [anon_sym_AMP_AMP] = ACTIONS(7164),
    [anon_sym_LT_LT] = ACTIONS(7164),
    [anon_sym_GT_GT] = ACTIONS(7164),
    [anon_sym_EQ_EQ] = ACTIONS(7164),
    [anon_sym_BANG_EQ] = ACTIONS(7162),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7162),
    [anon_sym_LT_EQ_GT] = ACTIONS(7162),
    [anon_sym_EQ_TILDE] = ACTIONS(7162),
    [anon_sym_BANG_TILDE] = ACTIONS(7162),
    [anon_sym_LT_EQ] = ACTIONS(7164),
    [anon_sym_GT] = ACTIONS(7164),
    [anon_sym_GT_EQ] = ACTIONS(7162),
    [anon_sym_CARET] = ACTIONS(7164),
    [anon_sym_PLUS] = ACTIONS(7164),
    [anon_sym_SLASH] = ACTIONS(7164),
    [anon_sym_PERCENT] = ACTIONS(7164),
    [sym_comment] = ACTIONS(87),
  },
  [6942] = {
    [anon_sym_DOT] = ACTIONS(12627),
    [anon_sym_COLON_COLON] = ACTIONS(12627),
    [sym_comment] = ACTIONS(87),
  },
  [6943] = {
    [sym__heredoc_body_start] = ACTIONS(7314),
    [sym__binary_minus] = ACTIONS(7314),
    [sym__binary_star] = ACTIONS(7314),
    [anon_sym_LBRACE] = ACTIONS(7314),
    [anon_sym_RBRACE] = ACTIONS(7314),
    [anon_sym_RPAREN] = ACTIONS(7314),
    [anon_sym_DOT] = ACTIONS(7316),
    [anon_sym_COMMA] = ACTIONS(7314),
    [anon_sym_PIPE] = ACTIONS(7316),
    [anon_sym_SEMI] = ACTIONS(7314),
    [anon_sym_STAR_STAR] = ACTIONS(7316),
    [anon_sym_AMP] = ACTIONS(7316),
    [anon_sym_EQ] = ACTIONS(7316),
    [anon_sym_LT] = ACTIONS(7316),
    [anon_sym_if] = ACTIONS(7314),
    [anon_sym_unless] = ACTIONS(7314),
    [anon_sym_while] = ACTIONS(7314),
    [anon_sym_until] = ACTIONS(7314),
    [anon_sym_rescue] = ACTIONS(7314),
    [anon_sym_in] = ACTIONS(7314),
    [anon_sym_do] = ACTIONS(7314),
    [anon_sym_EQ_GT] = ACTIONS(7314),
    [anon_sym_LBRACK] = ACTIONS(7314),
    [anon_sym_RBRACK] = ACTIONS(7314),
    [anon_sym_COLON_COLON2] = ACTIONS(7314),
    [anon_sym_AMP_DOT] = ACTIONS(7314),
    [anon_sym_PLUS_EQ] = ACTIONS(7314),
    [anon_sym_DASH_EQ] = ACTIONS(7314),
    [anon_sym_STAR_EQ] = ACTIONS(7314),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7314),
    [anon_sym_SLASH_EQ] = ACTIONS(7314),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7314),
    [anon_sym_PIPE_EQ] = ACTIONS(7314),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7314),
    [anon_sym_AMP_EQ] = ACTIONS(7314),
    [anon_sym_PERCENT_EQ] = ACTIONS(7314),
    [anon_sym_GT_GT_EQ] = ACTIONS(7314),
    [anon_sym_LT_LT_EQ] = ACTIONS(7314),
    [anon_sym_CARET_EQ] = ACTIONS(7314),
    [anon_sym_QMARK] = ACTIONS(7314),
    [anon_sym_COLON2] = ACTIONS(7316),
    [anon_sym_DOT_DOT] = ACTIONS(7316),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7314),
    [anon_sym_and] = ACTIONS(7314),
    [anon_sym_or] = ACTIONS(7314),
    [anon_sym_PIPE_PIPE] = ACTIONS(7316),
    [anon_sym_AMP_AMP] = ACTIONS(7316),
    [anon_sym_LT_LT] = ACTIONS(7316),
    [anon_sym_GT_GT] = ACTIONS(7316),
    [anon_sym_EQ_EQ] = ACTIONS(7316),
    [anon_sym_BANG_EQ] = ACTIONS(7314),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7314),
    [anon_sym_LT_EQ_GT] = ACTIONS(7314),
    [anon_sym_EQ_TILDE] = ACTIONS(7314),
    [anon_sym_BANG_TILDE] = ACTIONS(7314),
    [anon_sym_LT_EQ] = ACTIONS(7316),
    [anon_sym_GT] = ACTIONS(7316),
    [anon_sym_GT_EQ] = ACTIONS(7314),
    [anon_sym_CARET] = ACTIONS(7316),
    [anon_sym_PLUS] = ACTIONS(7316),
    [anon_sym_SLASH] = ACTIONS(7316),
    [anon_sym_PERCENT] = ACTIONS(7316),
    [sym_comment] = ACTIONS(87),
  },
  [6944] = {
    [sym__heredoc_body_start] = ACTIONS(7330),
    [sym__binary_minus] = ACTIONS(7330),
    [sym__binary_star] = ACTIONS(7330),
    [anon_sym_LBRACE] = ACTIONS(7330),
    [anon_sym_RBRACE] = ACTIONS(7330),
    [anon_sym_RPAREN] = ACTIONS(7330),
    [anon_sym_DOT] = ACTIONS(7332),
    [anon_sym_COMMA] = ACTIONS(7330),
    [anon_sym_PIPE] = ACTIONS(7332),
    [anon_sym_SEMI] = ACTIONS(7330),
    [anon_sym_STAR_STAR] = ACTIONS(7332),
    [anon_sym_AMP] = ACTIONS(7332),
    [anon_sym_EQ] = ACTIONS(7332),
    [anon_sym_LT] = ACTIONS(7332),
    [anon_sym_if] = ACTIONS(7330),
    [anon_sym_unless] = ACTIONS(7330),
    [anon_sym_while] = ACTIONS(7330),
    [anon_sym_until] = ACTIONS(7330),
    [anon_sym_rescue] = ACTIONS(7330),
    [anon_sym_in] = ACTIONS(7330),
    [anon_sym_do] = ACTIONS(7330),
    [anon_sym_EQ_GT] = ACTIONS(7330),
    [anon_sym_LBRACK] = ACTIONS(7330),
    [anon_sym_RBRACK] = ACTIONS(7330),
    [anon_sym_COLON_COLON2] = ACTIONS(7330),
    [anon_sym_AMP_DOT] = ACTIONS(7330),
    [anon_sym_PLUS_EQ] = ACTIONS(7330),
    [anon_sym_DASH_EQ] = ACTIONS(7330),
    [anon_sym_STAR_EQ] = ACTIONS(7330),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7330),
    [anon_sym_SLASH_EQ] = ACTIONS(7330),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7330),
    [anon_sym_PIPE_EQ] = ACTIONS(7330),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7330),
    [anon_sym_AMP_EQ] = ACTIONS(7330),
    [anon_sym_PERCENT_EQ] = ACTIONS(7330),
    [anon_sym_GT_GT_EQ] = ACTIONS(7330),
    [anon_sym_LT_LT_EQ] = ACTIONS(7330),
    [anon_sym_CARET_EQ] = ACTIONS(7330),
    [anon_sym_QMARK] = ACTIONS(7330),
    [anon_sym_COLON2] = ACTIONS(7332),
    [anon_sym_DOT_DOT] = ACTIONS(7332),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7330),
    [anon_sym_and] = ACTIONS(7330),
    [anon_sym_or] = ACTIONS(7330),
    [anon_sym_PIPE_PIPE] = ACTIONS(7332),
    [anon_sym_AMP_AMP] = ACTIONS(7332),
    [anon_sym_LT_LT] = ACTIONS(7332),
    [anon_sym_GT_GT] = ACTIONS(7332),
    [anon_sym_EQ_EQ] = ACTIONS(7332),
    [anon_sym_BANG_EQ] = ACTIONS(7330),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7330),
    [anon_sym_LT_EQ_GT] = ACTIONS(7330),
    [anon_sym_EQ_TILDE] = ACTIONS(7330),
    [anon_sym_BANG_TILDE] = ACTIONS(7330),
    [anon_sym_LT_EQ] = ACTIONS(7332),
    [anon_sym_GT] = ACTIONS(7332),
    [anon_sym_GT_EQ] = ACTIONS(7330),
    [anon_sym_CARET] = ACTIONS(7332),
    [anon_sym_PLUS] = ACTIONS(7332),
    [anon_sym_SLASH] = ACTIONS(7332),
    [anon_sym_PERCENT] = ACTIONS(7332),
    [sym_comment] = ACTIONS(87),
  },
  [6945] = {
    [sym__statements] = STATE(1988),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(1989),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(1990),
    [sym_rescue] = STATE(1991),
    [sym__body_statement] = STATE(9028),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12629),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6946] = {
    [sym__statements] = STATE(1988),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(1989),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(1990),
    [sym_rescue] = STATE(1991),
    [sym__body_statement] = STATE(9029),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12631),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6947] = {
    [sym__heredoc_body_start] = ACTIONS(7764),
    [sym__binary_minus] = ACTIONS(7764),
    [sym__binary_star] = ACTIONS(7764),
    [anon_sym_LBRACE] = ACTIONS(7764),
    [anon_sym_RBRACE] = ACTIONS(7764),
    [anon_sym_RPAREN] = ACTIONS(7764),
    [anon_sym_DOT] = ACTIONS(7766),
    [anon_sym_COMMA] = ACTIONS(7764),
    [anon_sym_PIPE] = ACTIONS(7766),
    [anon_sym_SEMI] = ACTIONS(7764),
    [anon_sym_STAR_STAR] = ACTIONS(7766),
    [anon_sym_AMP] = ACTIONS(7766),
    [anon_sym_EQ] = ACTIONS(7766),
    [anon_sym_LT] = ACTIONS(7766),
    [anon_sym_if] = ACTIONS(7764),
    [anon_sym_unless] = ACTIONS(7764),
    [anon_sym_while] = ACTIONS(7764),
    [anon_sym_until] = ACTIONS(7764),
    [anon_sym_rescue] = ACTIONS(7764),
    [anon_sym_in] = ACTIONS(7764),
    [anon_sym_do] = ACTIONS(7764),
    [anon_sym_EQ_GT] = ACTIONS(7764),
    [anon_sym_LBRACK] = ACTIONS(7764),
    [anon_sym_RBRACK] = ACTIONS(7764),
    [anon_sym_COLON_COLON2] = ACTIONS(7764),
    [anon_sym_AMP_DOT] = ACTIONS(7764),
    [anon_sym_PLUS_EQ] = ACTIONS(7764),
    [anon_sym_DASH_EQ] = ACTIONS(7764),
    [anon_sym_STAR_EQ] = ACTIONS(7764),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7764),
    [anon_sym_SLASH_EQ] = ACTIONS(7764),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7764),
    [anon_sym_PIPE_EQ] = ACTIONS(7764),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7764),
    [anon_sym_AMP_EQ] = ACTIONS(7764),
    [anon_sym_PERCENT_EQ] = ACTIONS(7764),
    [anon_sym_GT_GT_EQ] = ACTIONS(7764),
    [anon_sym_LT_LT_EQ] = ACTIONS(7764),
    [anon_sym_CARET_EQ] = ACTIONS(7764),
    [anon_sym_QMARK] = ACTIONS(7764),
    [anon_sym_COLON2] = ACTIONS(7766),
    [anon_sym_DOT_DOT] = ACTIONS(7766),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7764),
    [anon_sym_and] = ACTIONS(7764),
    [anon_sym_or] = ACTIONS(7764),
    [anon_sym_PIPE_PIPE] = ACTIONS(7766),
    [anon_sym_AMP_AMP] = ACTIONS(7766),
    [anon_sym_LT_LT] = ACTIONS(7766),
    [anon_sym_GT_GT] = ACTIONS(7766),
    [anon_sym_EQ_EQ] = ACTIONS(7766),
    [anon_sym_BANG_EQ] = ACTIONS(7764),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7764),
    [anon_sym_LT_EQ_GT] = ACTIONS(7764),
    [anon_sym_EQ_TILDE] = ACTIONS(7764),
    [anon_sym_BANG_TILDE] = ACTIONS(7764),
    [anon_sym_LT_EQ] = ACTIONS(7766),
    [anon_sym_GT] = ACTIONS(7766),
    [anon_sym_GT_EQ] = ACTIONS(7764),
    [anon_sym_CARET] = ACTIONS(7766),
    [anon_sym_PLUS] = ACTIONS(7766),
    [anon_sym_SLASH] = ACTIONS(7766),
    [anon_sym_PERCENT] = ACTIONS(7766),
    [sym_comment] = ACTIONS(87),
  },
  [6948] = {
    [sym__heredoc_body_start] = ACTIONS(7818),
    [sym__binary_minus] = ACTIONS(7818),
    [sym__binary_star] = ACTIONS(7818),
    [anon_sym_LBRACE] = ACTIONS(7818),
    [anon_sym_RBRACE] = ACTIONS(7818),
    [anon_sym_RPAREN] = ACTIONS(7818),
    [anon_sym_DOT] = ACTIONS(7820),
    [anon_sym_COMMA] = ACTIONS(7818),
    [anon_sym_PIPE] = ACTIONS(7820),
    [anon_sym_SEMI] = ACTIONS(7818),
    [anon_sym_STAR_STAR] = ACTIONS(7820),
    [anon_sym_AMP] = ACTIONS(7820),
    [anon_sym_EQ] = ACTIONS(7820),
    [anon_sym_LT] = ACTIONS(7820),
    [anon_sym_if] = ACTIONS(7818),
    [anon_sym_unless] = ACTIONS(7818),
    [anon_sym_while] = ACTIONS(7818),
    [anon_sym_until] = ACTIONS(7818),
    [anon_sym_rescue] = ACTIONS(7818),
    [anon_sym_in] = ACTIONS(7818),
    [anon_sym_do] = ACTIONS(7818),
    [anon_sym_EQ_GT] = ACTIONS(7818),
    [anon_sym_LBRACK] = ACTIONS(7818),
    [anon_sym_RBRACK] = ACTIONS(7818),
    [anon_sym_COLON_COLON2] = ACTIONS(7818),
    [anon_sym_AMP_DOT] = ACTIONS(7818),
    [anon_sym_PLUS_EQ] = ACTIONS(7818),
    [anon_sym_DASH_EQ] = ACTIONS(7818),
    [anon_sym_STAR_EQ] = ACTIONS(7818),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7818),
    [anon_sym_SLASH_EQ] = ACTIONS(7818),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7818),
    [anon_sym_PIPE_EQ] = ACTIONS(7818),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7818),
    [anon_sym_AMP_EQ] = ACTIONS(7818),
    [anon_sym_PERCENT_EQ] = ACTIONS(7818),
    [anon_sym_GT_GT_EQ] = ACTIONS(7818),
    [anon_sym_LT_LT_EQ] = ACTIONS(7818),
    [anon_sym_CARET_EQ] = ACTIONS(7818),
    [anon_sym_QMARK] = ACTIONS(7818),
    [anon_sym_COLON2] = ACTIONS(7820),
    [anon_sym_DOT_DOT] = ACTIONS(7820),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7818),
    [anon_sym_and] = ACTIONS(7818),
    [anon_sym_or] = ACTIONS(7818),
    [anon_sym_PIPE_PIPE] = ACTIONS(7820),
    [anon_sym_AMP_AMP] = ACTIONS(7820),
    [anon_sym_LT_LT] = ACTIONS(7820),
    [anon_sym_GT_GT] = ACTIONS(7820),
    [anon_sym_EQ_EQ] = ACTIONS(7820),
    [anon_sym_BANG_EQ] = ACTIONS(7818),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7818),
    [anon_sym_LT_EQ_GT] = ACTIONS(7818),
    [anon_sym_EQ_TILDE] = ACTIONS(7818),
    [anon_sym_BANG_TILDE] = ACTIONS(7818),
    [anon_sym_LT_EQ] = ACTIONS(7820),
    [anon_sym_GT] = ACTIONS(7820),
    [anon_sym_GT_EQ] = ACTIONS(7818),
    [anon_sym_CARET] = ACTIONS(7820),
    [anon_sym_PLUS] = ACTIONS(7820),
    [anon_sym_SLASH] = ACTIONS(7820),
    [anon_sym_PERCENT] = ACTIONS(7820),
    [sym_comment] = ACTIONS(87),
  },
  [6949] = {
    [sym__heredoc_body_start] = ACTIONS(8098),
    [sym__binary_minus] = ACTIONS(8098),
    [sym__binary_star] = ACTIONS(8098),
    [anon_sym_LBRACE] = ACTIONS(8098),
    [anon_sym_RBRACE] = ACTIONS(8098),
    [anon_sym_RPAREN] = ACTIONS(8098),
    [anon_sym_DOT] = ACTIONS(8100),
    [anon_sym_COMMA] = ACTIONS(8098),
    [anon_sym_PIPE] = ACTIONS(8100),
    [anon_sym_SEMI] = ACTIONS(8098),
    [anon_sym_STAR_STAR] = ACTIONS(8100),
    [anon_sym_AMP] = ACTIONS(8100),
    [anon_sym_EQ] = ACTIONS(8100),
    [anon_sym_LT] = ACTIONS(8100),
    [anon_sym_if] = ACTIONS(8098),
    [anon_sym_unless] = ACTIONS(8098),
    [anon_sym_while] = ACTIONS(8098),
    [anon_sym_until] = ACTIONS(8098),
    [anon_sym_rescue] = ACTIONS(8098),
    [anon_sym_in] = ACTIONS(8098),
    [anon_sym_do] = ACTIONS(8098),
    [anon_sym_EQ_GT] = ACTIONS(8098),
    [anon_sym_LBRACK] = ACTIONS(8098),
    [anon_sym_RBRACK] = ACTIONS(8098),
    [anon_sym_COLON_COLON2] = ACTIONS(8098),
    [anon_sym_AMP_DOT] = ACTIONS(8098),
    [anon_sym_PLUS_EQ] = ACTIONS(8098),
    [anon_sym_DASH_EQ] = ACTIONS(8098),
    [anon_sym_STAR_EQ] = ACTIONS(8098),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8098),
    [anon_sym_SLASH_EQ] = ACTIONS(8098),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8098),
    [anon_sym_PIPE_EQ] = ACTIONS(8098),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8098),
    [anon_sym_AMP_EQ] = ACTIONS(8098),
    [anon_sym_PERCENT_EQ] = ACTIONS(8098),
    [anon_sym_GT_GT_EQ] = ACTIONS(8098),
    [anon_sym_LT_LT_EQ] = ACTIONS(8098),
    [anon_sym_CARET_EQ] = ACTIONS(8098),
    [anon_sym_QMARK] = ACTIONS(8098),
    [anon_sym_COLON2] = ACTIONS(8100),
    [anon_sym_DOT_DOT] = ACTIONS(8100),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8098),
    [anon_sym_and] = ACTIONS(8098),
    [anon_sym_or] = ACTIONS(8098),
    [anon_sym_PIPE_PIPE] = ACTIONS(8100),
    [anon_sym_AMP_AMP] = ACTIONS(8100),
    [anon_sym_LT_LT] = ACTIONS(8100),
    [anon_sym_GT_GT] = ACTIONS(8100),
    [anon_sym_EQ_EQ] = ACTIONS(8100),
    [anon_sym_BANG_EQ] = ACTIONS(8098),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8098),
    [anon_sym_LT_EQ_GT] = ACTIONS(8098),
    [anon_sym_EQ_TILDE] = ACTIONS(8098),
    [anon_sym_BANG_TILDE] = ACTIONS(8098),
    [anon_sym_LT_EQ] = ACTIONS(8100),
    [anon_sym_GT] = ACTIONS(8100),
    [anon_sym_GT_EQ] = ACTIONS(8098),
    [anon_sym_CARET] = ACTIONS(8100),
    [anon_sym_PLUS] = ACTIONS(8100),
    [anon_sym_SLASH] = ACTIONS(8100),
    [anon_sym_PERCENT] = ACTIONS(8100),
    [sym_comment] = ACTIONS(87),
  },
  [6950] = {
    [anon_sym_end] = ACTIONS(12633),
    [sym_comment] = ACTIONS(87),
  },
  [6951] = {
    [sym__heredoc_body_start] = ACTIONS(8284),
    [sym__binary_minus] = ACTIONS(8284),
    [sym__binary_star] = ACTIONS(8284),
    [anon_sym_LBRACE] = ACTIONS(8284),
    [anon_sym_RBRACE] = ACTIONS(8284),
    [anon_sym_RPAREN] = ACTIONS(8284),
    [anon_sym_DOT] = ACTIONS(8286),
    [anon_sym_COMMA] = ACTIONS(8284),
    [anon_sym_PIPE] = ACTIONS(8286),
    [anon_sym_SEMI] = ACTIONS(8284),
    [anon_sym_STAR_STAR] = ACTIONS(8286),
    [anon_sym_AMP] = ACTIONS(8286),
    [anon_sym_EQ] = ACTIONS(8286),
    [anon_sym_LT] = ACTIONS(8286),
    [anon_sym_if] = ACTIONS(8284),
    [anon_sym_unless] = ACTIONS(8284),
    [anon_sym_while] = ACTIONS(8284),
    [anon_sym_until] = ACTIONS(8284),
    [anon_sym_rescue] = ACTIONS(8284),
    [anon_sym_in] = ACTIONS(8284),
    [anon_sym_do] = ACTIONS(8284),
    [anon_sym_EQ_GT] = ACTIONS(8284),
    [anon_sym_LBRACK] = ACTIONS(8284),
    [anon_sym_RBRACK] = ACTIONS(8284),
    [anon_sym_COLON_COLON2] = ACTIONS(8284),
    [anon_sym_AMP_DOT] = ACTIONS(8284),
    [anon_sym_PLUS_EQ] = ACTIONS(8284),
    [anon_sym_DASH_EQ] = ACTIONS(8284),
    [anon_sym_STAR_EQ] = ACTIONS(8284),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8284),
    [anon_sym_SLASH_EQ] = ACTIONS(8284),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8284),
    [anon_sym_PIPE_EQ] = ACTIONS(8284),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8284),
    [anon_sym_AMP_EQ] = ACTIONS(8284),
    [anon_sym_PERCENT_EQ] = ACTIONS(8284),
    [anon_sym_GT_GT_EQ] = ACTIONS(8284),
    [anon_sym_LT_LT_EQ] = ACTIONS(8284),
    [anon_sym_CARET_EQ] = ACTIONS(8284),
    [anon_sym_QMARK] = ACTIONS(8284),
    [anon_sym_COLON2] = ACTIONS(8286),
    [anon_sym_DOT_DOT] = ACTIONS(8286),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8284),
    [anon_sym_and] = ACTIONS(8284),
    [anon_sym_or] = ACTIONS(8284),
    [anon_sym_PIPE_PIPE] = ACTIONS(8286),
    [anon_sym_AMP_AMP] = ACTIONS(8286),
    [anon_sym_LT_LT] = ACTIONS(8286),
    [anon_sym_GT_GT] = ACTIONS(8286),
    [anon_sym_EQ_EQ] = ACTIONS(8286),
    [anon_sym_BANG_EQ] = ACTIONS(8284),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8284),
    [anon_sym_LT_EQ_GT] = ACTIONS(8284),
    [anon_sym_EQ_TILDE] = ACTIONS(8284),
    [anon_sym_BANG_TILDE] = ACTIONS(8284),
    [anon_sym_LT_EQ] = ACTIONS(8286),
    [anon_sym_GT] = ACTIONS(8286),
    [anon_sym_GT_EQ] = ACTIONS(8284),
    [anon_sym_CARET] = ACTIONS(8286),
    [anon_sym_PLUS] = ACTIONS(8286),
    [anon_sym_SLASH] = ACTIONS(8286),
    [anon_sym_PERCENT] = ACTIONS(8286),
    [sym_comment] = ACTIONS(87),
  },
  [6952] = {
    [anon_sym_end] = ACTIONS(12635),
    [sym_comment] = ACTIONS(87),
  },
  [6953] = {
    [sym__heredoc_body_start] = ACTIONS(8344),
    [sym__binary_minus] = ACTIONS(8344),
    [sym__binary_star] = ACTIONS(8344),
    [anon_sym_LBRACE] = ACTIONS(8344),
    [anon_sym_RBRACE] = ACTIONS(8344),
    [anon_sym_RPAREN] = ACTIONS(8344),
    [anon_sym_DOT] = ACTIONS(8346),
    [anon_sym_COMMA] = ACTIONS(8344),
    [anon_sym_PIPE] = ACTIONS(8346),
    [anon_sym_SEMI] = ACTIONS(8344),
    [anon_sym_STAR_STAR] = ACTIONS(8346),
    [anon_sym_AMP] = ACTIONS(8346),
    [anon_sym_EQ] = ACTIONS(8346),
    [anon_sym_LT] = ACTIONS(8346),
    [anon_sym_if] = ACTIONS(8344),
    [anon_sym_unless] = ACTIONS(8344),
    [anon_sym_while] = ACTIONS(8344),
    [anon_sym_until] = ACTIONS(8344),
    [anon_sym_rescue] = ACTIONS(8344),
    [anon_sym_in] = ACTIONS(8344),
    [anon_sym_do] = ACTIONS(8344),
    [anon_sym_EQ_GT] = ACTIONS(8344),
    [anon_sym_LBRACK] = ACTIONS(8344),
    [anon_sym_RBRACK] = ACTIONS(8344),
    [anon_sym_COLON_COLON2] = ACTIONS(8344),
    [anon_sym_AMP_DOT] = ACTIONS(8344),
    [anon_sym_PLUS_EQ] = ACTIONS(8344),
    [anon_sym_DASH_EQ] = ACTIONS(8344),
    [anon_sym_STAR_EQ] = ACTIONS(8344),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8344),
    [anon_sym_SLASH_EQ] = ACTIONS(8344),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8344),
    [anon_sym_PIPE_EQ] = ACTIONS(8344),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8344),
    [anon_sym_AMP_EQ] = ACTIONS(8344),
    [anon_sym_PERCENT_EQ] = ACTIONS(8344),
    [anon_sym_GT_GT_EQ] = ACTIONS(8344),
    [anon_sym_LT_LT_EQ] = ACTIONS(8344),
    [anon_sym_CARET_EQ] = ACTIONS(8344),
    [anon_sym_QMARK] = ACTIONS(8344),
    [anon_sym_COLON2] = ACTIONS(8346),
    [anon_sym_DOT_DOT] = ACTIONS(8346),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8344),
    [anon_sym_and] = ACTIONS(8344),
    [anon_sym_or] = ACTIONS(8344),
    [anon_sym_PIPE_PIPE] = ACTIONS(8346),
    [anon_sym_AMP_AMP] = ACTIONS(8346),
    [anon_sym_LT_LT] = ACTIONS(8346),
    [anon_sym_GT_GT] = ACTIONS(8346),
    [anon_sym_EQ_EQ] = ACTIONS(8346),
    [anon_sym_BANG_EQ] = ACTIONS(8344),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8344),
    [anon_sym_LT_EQ_GT] = ACTIONS(8344),
    [anon_sym_EQ_TILDE] = ACTIONS(8344),
    [anon_sym_BANG_TILDE] = ACTIONS(8344),
    [anon_sym_LT_EQ] = ACTIONS(8346),
    [anon_sym_GT] = ACTIONS(8346),
    [anon_sym_GT_EQ] = ACTIONS(8344),
    [anon_sym_CARET] = ACTIONS(8346),
    [anon_sym_PLUS] = ACTIONS(8346),
    [anon_sym_SLASH] = ACTIONS(8346),
    [anon_sym_PERCENT] = ACTIONS(8346),
    [sym_comment] = ACTIONS(87),
  },
  [6954] = {
    [anon_sym_end] = ACTIONS(12637),
    [sym_comment] = ACTIONS(87),
  },
  [6955] = {
    [sym__heredoc_body_start] = ACTIONS(8420),
    [sym__binary_minus] = ACTIONS(8420),
    [sym__binary_star] = ACTIONS(8420),
    [anon_sym_LBRACE] = ACTIONS(8420),
    [anon_sym_RBRACE] = ACTIONS(8420),
    [anon_sym_RPAREN] = ACTIONS(8420),
    [anon_sym_DOT] = ACTIONS(8422),
    [anon_sym_COMMA] = ACTIONS(8420),
    [anon_sym_PIPE] = ACTIONS(8422),
    [anon_sym_SEMI] = ACTIONS(8420),
    [anon_sym_STAR_STAR] = ACTIONS(8422),
    [anon_sym_AMP] = ACTIONS(8422),
    [anon_sym_EQ] = ACTIONS(8422),
    [anon_sym_LT] = ACTIONS(8422),
    [anon_sym_if] = ACTIONS(8420),
    [anon_sym_unless] = ACTIONS(8420),
    [anon_sym_while] = ACTIONS(8420),
    [anon_sym_until] = ACTIONS(8420),
    [anon_sym_rescue] = ACTIONS(8420),
    [anon_sym_in] = ACTIONS(8420),
    [anon_sym_do] = ACTIONS(8420),
    [anon_sym_EQ_GT] = ACTIONS(8420),
    [anon_sym_LBRACK] = ACTIONS(8420),
    [anon_sym_RBRACK] = ACTIONS(8420),
    [anon_sym_COLON_COLON2] = ACTIONS(8420),
    [anon_sym_AMP_DOT] = ACTIONS(8420),
    [anon_sym_PLUS_EQ] = ACTIONS(8420),
    [anon_sym_DASH_EQ] = ACTIONS(8420),
    [anon_sym_STAR_EQ] = ACTIONS(8420),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8420),
    [anon_sym_SLASH_EQ] = ACTIONS(8420),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8420),
    [anon_sym_PIPE_EQ] = ACTIONS(8420),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8420),
    [anon_sym_AMP_EQ] = ACTIONS(8420),
    [anon_sym_PERCENT_EQ] = ACTIONS(8420),
    [anon_sym_GT_GT_EQ] = ACTIONS(8420),
    [anon_sym_LT_LT_EQ] = ACTIONS(8420),
    [anon_sym_CARET_EQ] = ACTIONS(8420),
    [anon_sym_QMARK] = ACTIONS(8420),
    [anon_sym_COLON2] = ACTIONS(8422),
    [anon_sym_DOT_DOT] = ACTIONS(8422),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8420),
    [anon_sym_and] = ACTIONS(8420),
    [anon_sym_or] = ACTIONS(8420),
    [anon_sym_PIPE_PIPE] = ACTIONS(8422),
    [anon_sym_AMP_AMP] = ACTIONS(8422),
    [anon_sym_LT_LT] = ACTIONS(8422),
    [anon_sym_GT_GT] = ACTIONS(8422),
    [anon_sym_EQ_EQ] = ACTIONS(8422),
    [anon_sym_BANG_EQ] = ACTIONS(8420),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8420),
    [anon_sym_LT_EQ_GT] = ACTIONS(8420),
    [anon_sym_EQ_TILDE] = ACTIONS(8420),
    [anon_sym_BANG_TILDE] = ACTIONS(8420),
    [anon_sym_LT_EQ] = ACTIONS(8422),
    [anon_sym_GT] = ACTIONS(8422),
    [anon_sym_GT_EQ] = ACTIONS(8420),
    [anon_sym_CARET] = ACTIONS(8422),
    [anon_sym_PLUS] = ACTIONS(8422),
    [anon_sym_SLASH] = ACTIONS(8422),
    [anon_sym_PERCENT] = ACTIONS(8422),
    [sym_comment] = ACTIONS(87),
  },
  [6956] = {
    [anon_sym_end] = ACTIONS(12639),
    [sym_comment] = ACTIONS(87),
  },
  [6957] = {
    [sym__statements] = STATE(9035),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12641),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6958] = {
    [sym__binary_minus] = ACTIONS(12054),
    [sym__binary_star] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12056),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_PIPE] = ACTIONS(12056),
    [anon_sym_STAR_STAR] = ACTIONS(12056),
    [anon_sym_AMP] = ACTIONS(12056),
    [anon_sym_EQ] = ACTIONS(12056),
    [anon_sym_LT] = ACTIONS(12056),
    [anon_sym_EQ_GT] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_COLON_COLON2] = ACTIONS(12054),
    [anon_sym_AMP_DOT] = ACTIONS(12054),
    [anon_sym_PLUS_EQ] = ACTIONS(12054),
    [anon_sym_DASH_EQ] = ACTIONS(12054),
    [anon_sym_STAR_EQ] = ACTIONS(12054),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12054),
    [anon_sym_SLASH_EQ] = ACTIONS(12054),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12054),
    [anon_sym_PIPE_EQ] = ACTIONS(12054),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12054),
    [anon_sym_AMP_EQ] = ACTIONS(12054),
    [anon_sym_PERCENT_EQ] = ACTIONS(12054),
    [anon_sym_GT_GT_EQ] = ACTIONS(12054),
    [anon_sym_LT_LT_EQ] = ACTIONS(12054),
    [anon_sym_CARET_EQ] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_DOT_DOT] = ACTIONS(12056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_and] = ACTIONS(12054),
    [anon_sym_or] = ACTIONS(12054),
    [anon_sym_PIPE_PIPE] = ACTIONS(12056),
    [anon_sym_AMP_AMP] = ACTIONS(12056),
    [anon_sym_LT_LT] = ACTIONS(12056),
    [anon_sym_GT_GT] = ACTIONS(12056),
    [anon_sym_EQ_EQ] = ACTIONS(12056),
    [anon_sym_BANG_EQ] = ACTIONS(12054),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12054),
    [anon_sym_LT_EQ_GT] = ACTIONS(12054),
    [anon_sym_EQ_TILDE] = ACTIONS(12054),
    [anon_sym_BANG_TILDE] = ACTIONS(12054),
    [anon_sym_LT_EQ] = ACTIONS(12056),
    [anon_sym_GT] = ACTIONS(12056),
    [anon_sym_GT_EQ] = ACTIONS(12054),
    [anon_sym_CARET] = ACTIONS(12056),
    [anon_sym_PLUS] = ACTIONS(12056),
    [anon_sym_SLASH] = ACTIONS(12056),
    [anon_sym_PERCENT] = ACTIONS(12056),
    [sym_comment] = ACTIONS(87),
  },
  [6959] = {
    [anon_sym_end] = ACTIONS(12643),
    [sym_comment] = ACTIONS(87),
  },
  [6960] = {
    [sym__statements] = STATE(9037),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12645),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6961] = {
    [sym__heredoc_body_start] = ACTIONS(8581),
    [sym__binary_minus] = ACTIONS(8581),
    [sym__binary_star] = ACTIONS(8581),
    [anon_sym_LBRACE] = ACTIONS(8581),
    [anon_sym_RBRACE] = ACTIONS(8581),
    [anon_sym_RPAREN] = ACTIONS(8581),
    [anon_sym_DOT] = ACTIONS(8583),
    [anon_sym_COMMA] = ACTIONS(8581),
    [anon_sym_PIPE] = ACTIONS(8583),
    [anon_sym_SEMI] = ACTIONS(8581),
    [anon_sym_STAR_STAR] = ACTIONS(8583),
    [anon_sym_AMP] = ACTIONS(8583),
    [anon_sym_EQ] = ACTIONS(8583),
    [anon_sym_LT] = ACTIONS(8583),
    [anon_sym_if] = ACTIONS(8581),
    [anon_sym_unless] = ACTIONS(8581),
    [anon_sym_while] = ACTIONS(8581),
    [anon_sym_until] = ACTIONS(8581),
    [anon_sym_rescue] = ACTIONS(8581),
    [anon_sym_in] = ACTIONS(8581),
    [anon_sym_do] = ACTIONS(8581),
    [anon_sym_EQ_GT] = ACTIONS(8581),
    [anon_sym_LBRACK] = ACTIONS(8581),
    [anon_sym_RBRACK] = ACTIONS(8581),
    [anon_sym_COLON_COLON2] = ACTIONS(8581),
    [anon_sym_AMP_DOT] = ACTIONS(8581),
    [anon_sym_PLUS_EQ] = ACTIONS(8581),
    [anon_sym_DASH_EQ] = ACTIONS(8581),
    [anon_sym_STAR_EQ] = ACTIONS(8581),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8581),
    [anon_sym_SLASH_EQ] = ACTIONS(8581),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8581),
    [anon_sym_PIPE_EQ] = ACTIONS(8581),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8581),
    [anon_sym_AMP_EQ] = ACTIONS(8581),
    [anon_sym_PERCENT_EQ] = ACTIONS(8581),
    [anon_sym_GT_GT_EQ] = ACTIONS(8581),
    [anon_sym_LT_LT_EQ] = ACTIONS(8581),
    [anon_sym_CARET_EQ] = ACTIONS(8581),
    [anon_sym_QMARK] = ACTIONS(8581),
    [anon_sym_COLON2] = ACTIONS(8583),
    [anon_sym_DOT_DOT] = ACTIONS(8583),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8581),
    [anon_sym_and] = ACTIONS(8581),
    [anon_sym_or] = ACTIONS(8581),
    [anon_sym_PIPE_PIPE] = ACTIONS(8583),
    [anon_sym_AMP_AMP] = ACTIONS(8583),
    [anon_sym_LT_LT] = ACTIONS(8583),
    [anon_sym_GT_GT] = ACTIONS(8583),
    [anon_sym_EQ_EQ] = ACTIONS(8583),
    [anon_sym_BANG_EQ] = ACTIONS(8581),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8581),
    [anon_sym_LT_EQ_GT] = ACTIONS(8581),
    [anon_sym_EQ_TILDE] = ACTIONS(8581),
    [anon_sym_BANG_TILDE] = ACTIONS(8581),
    [anon_sym_LT_EQ] = ACTIONS(8583),
    [anon_sym_GT] = ACTIONS(8583),
    [anon_sym_GT_EQ] = ACTIONS(8581),
    [anon_sym_CARET] = ACTIONS(8583),
    [anon_sym_PLUS] = ACTIONS(8583),
    [anon_sym_SLASH] = ACTIONS(8583),
    [anon_sym_PERCENT] = ACTIONS(8583),
    [sym_comment] = ACTIONS(87),
  },
  [6962] = {
    [anon_sym_end] = ACTIONS(12647),
    [sym_comment] = ACTIONS(87),
  },
  [6963] = {
    [sym_when] = STATE(9040),
    [sym_else] = STATE(9039),
    [aux_sym_case_repeat1] = STATE(2987),
    [aux_sym_case_repeat2] = STATE(9040),
    [anon_sym_SEMI] = ACTIONS(4995),
    [anon_sym_end] = ACTIONS(12647),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [6964] = {
    [sym_when] = STATE(2988),
    [sym_else] = STATE(9039),
    [aux_sym_case_repeat2] = STATE(2988),
    [anon_sym_end] = ACTIONS(12647),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [6965] = {
    [sym__heredoc_body_start] = ACTIONS(9185),
    [sym__binary_minus] = ACTIONS(9185),
    [sym__binary_star] = ACTIONS(9185),
    [anon_sym_LBRACE] = ACTIONS(9185),
    [anon_sym_RBRACE] = ACTIONS(9185),
    [anon_sym_RPAREN] = ACTIONS(9185),
    [anon_sym_DOT] = ACTIONS(9187),
    [anon_sym_COMMA] = ACTIONS(9185),
    [anon_sym_PIPE] = ACTIONS(9187),
    [anon_sym_SEMI] = ACTIONS(9185),
    [anon_sym_STAR_STAR] = ACTIONS(9187),
    [anon_sym_AMP] = ACTIONS(9187),
    [anon_sym_EQ] = ACTIONS(9187),
    [anon_sym_LT] = ACTIONS(9187),
    [anon_sym_if] = ACTIONS(9185),
    [anon_sym_unless] = ACTIONS(9185),
    [anon_sym_while] = ACTIONS(9185),
    [anon_sym_until] = ACTIONS(9185),
    [anon_sym_rescue] = ACTIONS(9185),
    [anon_sym_in] = ACTIONS(9185),
    [anon_sym_do] = ACTIONS(9185),
    [anon_sym_EQ_GT] = ACTIONS(9185),
    [anon_sym_LBRACK] = ACTIONS(9185),
    [anon_sym_RBRACK] = ACTIONS(9185),
    [anon_sym_COLON_COLON2] = ACTIONS(9185),
    [anon_sym_AMP_DOT] = ACTIONS(9185),
    [anon_sym_PLUS_EQ] = ACTIONS(9185),
    [anon_sym_DASH_EQ] = ACTIONS(9185),
    [anon_sym_STAR_EQ] = ACTIONS(9185),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9185),
    [anon_sym_SLASH_EQ] = ACTIONS(9185),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9185),
    [anon_sym_PIPE_EQ] = ACTIONS(9185),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9185),
    [anon_sym_AMP_EQ] = ACTIONS(9185),
    [anon_sym_PERCENT_EQ] = ACTIONS(9185),
    [anon_sym_GT_GT_EQ] = ACTIONS(9185),
    [anon_sym_LT_LT_EQ] = ACTIONS(9185),
    [anon_sym_CARET_EQ] = ACTIONS(9185),
    [anon_sym_QMARK] = ACTIONS(9185),
    [anon_sym_COLON2] = ACTIONS(9187),
    [anon_sym_DOT_DOT] = ACTIONS(9187),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9185),
    [anon_sym_and] = ACTIONS(9185),
    [anon_sym_or] = ACTIONS(9185),
    [anon_sym_PIPE_PIPE] = ACTIONS(9187),
    [anon_sym_AMP_AMP] = ACTIONS(9187),
    [anon_sym_LT_LT] = ACTIONS(9187),
    [anon_sym_GT_GT] = ACTIONS(9187),
    [anon_sym_EQ_EQ] = ACTIONS(9187),
    [anon_sym_BANG_EQ] = ACTIONS(9185),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9185),
    [anon_sym_LT_EQ_GT] = ACTIONS(9185),
    [anon_sym_EQ_TILDE] = ACTIONS(9185),
    [anon_sym_BANG_TILDE] = ACTIONS(9185),
    [anon_sym_LT_EQ] = ACTIONS(9187),
    [anon_sym_GT] = ACTIONS(9187),
    [anon_sym_GT_EQ] = ACTIONS(9185),
    [anon_sym_CARET] = ACTIONS(9187),
    [anon_sym_PLUS] = ACTIONS(9187),
    [anon_sym_SLASH] = ACTIONS(9187),
    [anon_sym_PERCENT] = ACTIONS(9187),
    [sym_comment] = ACTIONS(87),
  },
  [6966] = {
    [anon_sym_end] = ACTIONS(12649),
    [sym_comment] = ACTIONS(87),
  },
  [6967] = {
    [sym_ensure] = STATE(9042),
    [anon_sym_end] = ACTIONS(12649),
    [anon_sym_ensure] = ACTIONS(2169),
    [sym_comment] = ACTIONS(87),
  },
  [6968] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(9043),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_assignment] = STATE(9043),
    [sym_operator_assignment] = STATE(9043),
    [sym_conditional] = STATE(9043),
    [sym_range] = STATE(9043),
    [sym_binary] = STATE(9043),
    [sym_unary] = STATE(9043),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1952),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(3469),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6969] = {
    [sym__heredoc_body_start] = ACTIONS(6813),
    [sym__binary_minus] = ACTIONS(6813),
    [sym__binary_star] = ACTIONS(6813),
    [anon_sym_LBRACE] = ACTIONS(6813),
    [anon_sym_RBRACE] = ACTIONS(6813),
    [anon_sym_RPAREN] = ACTIONS(6813),
    [anon_sym_DOT] = ACTIONS(8689),
    [anon_sym_COMMA] = ACTIONS(6813),
    [anon_sym_PIPE] = ACTIONS(8689),
    [anon_sym_SEMI] = ACTIONS(6813),
    [anon_sym_STAR_STAR] = ACTIONS(8689),
    [anon_sym_AMP] = ACTIONS(8689),
    [anon_sym_EQ] = ACTIONS(8689),
    [anon_sym_LT] = ACTIONS(8689),
    [anon_sym_if] = ACTIONS(6813),
    [anon_sym_unless] = ACTIONS(6813),
    [anon_sym_while] = ACTIONS(6813),
    [anon_sym_until] = ACTIONS(6813),
    [anon_sym_rescue] = ACTIONS(6813),
    [anon_sym_in] = ACTIONS(6813),
    [anon_sym_do] = ACTIONS(6813),
    [anon_sym_EQ_GT] = ACTIONS(6813),
    [anon_sym_LBRACK] = ACTIONS(6813),
    [anon_sym_RBRACK] = ACTIONS(6813),
    [anon_sym_COLON_COLON2] = ACTIONS(6813),
    [anon_sym_AMP_DOT] = ACTIONS(6813),
    [anon_sym_PLUS_EQ] = ACTIONS(6813),
    [anon_sym_DASH_EQ] = ACTIONS(6813),
    [anon_sym_STAR_EQ] = ACTIONS(6813),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6813),
    [anon_sym_SLASH_EQ] = ACTIONS(6813),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6813),
    [anon_sym_PIPE_EQ] = ACTIONS(6813),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6813),
    [anon_sym_AMP_EQ] = ACTIONS(6813),
    [anon_sym_PERCENT_EQ] = ACTIONS(6813),
    [anon_sym_GT_GT_EQ] = ACTIONS(6813),
    [anon_sym_LT_LT_EQ] = ACTIONS(6813),
    [anon_sym_CARET_EQ] = ACTIONS(6813),
    [anon_sym_QMARK] = ACTIONS(6813),
    [anon_sym_COLON2] = ACTIONS(8689),
    [anon_sym_DOT_DOT] = ACTIONS(8689),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6813),
    [anon_sym_and] = ACTIONS(6813),
    [anon_sym_or] = ACTIONS(6813),
    [anon_sym_PIPE_PIPE] = ACTIONS(8689),
    [anon_sym_AMP_AMP] = ACTIONS(8689),
    [anon_sym_LT_LT] = ACTIONS(8689),
    [anon_sym_GT_GT] = ACTIONS(8689),
    [anon_sym_EQ_EQ] = ACTIONS(8689),
    [anon_sym_BANG_EQ] = ACTIONS(6813),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6813),
    [anon_sym_LT_EQ_GT] = ACTIONS(6813),
    [anon_sym_EQ_TILDE] = ACTIONS(6813),
    [anon_sym_BANG_TILDE] = ACTIONS(6813),
    [anon_sym_LT_EQ] = ACTIONS(8689),
    [anon_sym_GT] = ACTIONS(8689),
    [anon_sym_GT_EQ] = ACTIONS(6813),
    [anon_sym_CARET] = ACTIONS(8689),
    [anon_sym_PLUS] = ACTIONS(8689),
    [anon_sym_SLASH] = ACTIONS(8689),
    [anon_sym_PERCENT] = ACTIONS(8689),
    [sym_comment] = ACTIONS(87),
  },
  [6970] = {
    [sym__heredoc_body_start] = ACTIONS(10986),
    [sym__binary_minus] = ACTIONS(10986),
    [sym__binary_star] = ACTIONS(10986),
    [anon_sym_LBRACE] = ACTIONS(10986),
    [anon_sym_RBRACE] = ACTIONS(10986),
    [anon_sym_RPAREN] = ACTIONS(10986),
    [anon_sym_DOT] = ACTIONS(10988),
    [anon_sym_COMMA] = ACTIONS(10986),
    [anon_sym_PIPE] = ACTIONS(10988),
    [anon_sym_SEMI] = ACTIONS(10986),
    [anon_sym_STAR_STAR] = ACTIONS(10988),
    [anon_sym_AMP] = ACTIONS(10988),
    [anon_sym_EQ] = ACTIONS(10988),
    [anon_sym_LT] = ACTIONS(10988),
    [anon_sym_if] = ACTIONS(10986),
    [anon_sym_unless] = ACTIONS(10986),
    [anon_sym_while] = ACTIONS(10986),
    [anon_sym_until] = ACTIONS(10986),
    [anon_sym_rescue] = ACTIONS(10986),
    [anon_sym_in] = ACTIONS(10986),
    [anon_sym_do] = ACTIONS(10986),
    [anon_sym_EQ_GT] = ACTIONS(10986),
    [anon_sym_LBRACK] = ACTIONS(10986),
    [anon_sym_RBRACK] = ACTIONS(10986),
    [anon_sym_COLON_COLON2] = ACTIONS(10986),
    [anon_sym_AMP_DOT] = ACTIONS(10986),
    [anon_sym_PLUS_EQ] = ACTIONS(10986),
    [anon_sym_DASH_EQ] = ACTIONS(10986),
    [anon_sym_STAR_EQ] = ACTIONS(10986),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10986),
    [anon_sym_SLASH_EQ] = ACTIONS(10986),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10986),
    [anon_sym_PIPE_EQ] = ACTIONS(10986),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10986),
    [anon_sym_AMP_EQ] = ACTIONS(10986),
    [anon_sym_PERCENT_EQ] = ACTIONS(10986),
    [anon_sym_GT_GT_EQ] = ACTIONS(10986),
    [anon_sym_LT_LT_EQ] = ACTIONS(10986),
    [anon_sym_CARET_EQ] = ACTIONS(10986),
    [anon_sym_QMARK] = ACTIONS(10986),
    [anon_sym_COLON2] = ACTIONS(10988),
    [anon_sym_DOT_DOT] = ACTIONS(10988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10986),
    [anon_sym_and] = ACTIONS(10986),
    [anon_sym_or] = ACTIONS(10986),
    [anon_sym_PIPE_PIPE] = ACTIONS(10988),
    [anon_sym_AMP_AMP] = ACTIONS(10988),
    [anon_sym_LT_LT] = ACTIONS(10988),
    [anon_sym_GT_GT] = ACTIONS(10988),
    [anon_sym_EQ_EQ] = ACTIONS(10988),
    [anon_sym_BANG_EQ] = ACTIONS(10986),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10986),
    [anon_sym_LT_EQ_GT] = ACTIONS(10986),
    [anon_sym_EQ_TILDE] = ACTIONS(10986),
    [anon_sym_BANG_TILDE] = ACTIONS(10986),
    [anon_sym_LT_EQ] = ACTIONS(10988),
    [anon_sym_GT] = ACTIONS(10988),
    [anon_sym_GT_EQ] = ACTIONS(10986),
    [anon_sym_CARET] = ACTIONS(10988),
    [anon_sym_PLUS] = ACTIONS(10988),
    [anon_sym_SLASH] = ACTIONS(10988),
    [anon_sym_PERCENT] = ACTIONS(10988),
    [sym_comment] = ACTIONS(87),
  },
  [6971] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4361),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_splat_argument] = STATE(9044),
    [sym_assignment] = STATE(4361),
    [sym_operator_assignment] = STATE(4361),
    [sym_conditional] = STATE(4361),
    [sym_range] = STATE(4361),
    [sym_binary] = STATE(4361),
    [sym_unary] = STATE(4361),
    [sym__arg_or_splat_arg] = STATE(9044),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1952),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__splat_star] = ACTIONS(1157),
    [sym__unary_minus] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(3469),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6972] = {
    [aux_sym_exceptions_repeat1] = STATE(9045),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_LBRACE] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(12651),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_STAR_STAR] = ACTIONS(9857),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_EQ] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_do] = ACTIONS(9855),
    [anon_sym_EQ_GT] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_PLUS_EQ] = ACTIONS(9855),
    [anon_sym_DASH_EQ] = ACTIONS(9855),
    [anon_sym_STAR_EQ] = ACTIONS(9855),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9855),
    [anon_sym_SLASH_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9855),
    [anon_sym_AMP_EQ] = ACTIONS(9855),
    [anon_sym_PERCENT_EQ] = ACTIONS(9855),
    [anon_sym_GT_GT_EQ] = ACTIONS(9855),
    [anon_sym_LT_LT_EQ] = ACTIONS(9855),
    [anon_sym_CARET_EQ] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9857),
    [anon_sym_AMP_AMP] = ACTIONS(9857),
    [anon_sym_LT_LT] = ACTIONS(9857),
    [anon_sym_GT_GT] = ACTIONS(9857),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9857),
    [anon_sym_PLUS] = ACTIONS(9857),
    [anon_sym_SLASH] = ACTIONS(9857),
    [anon_sym_PERCENT] = ACTIONS(9857),
    [sym_comment] = ACTIONS(87),
  },
  [6973] = {
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(7127),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(7127),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(7127),
    [anon_sym_PERCENT] = ACTIONS(7127),
    [sym_comment] = ACTIONS(87),
  },
  [6974] = {
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(7127),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [6975] = {
    [sym__binary_minus] = ACTIONS(7125),
    [sym__binary_star] = ACTIONS(7127),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(7127),
    [anon_sym_AMP] = ACTIONS(7131),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(7143),
    [anon_sym_GT_GT] = ACTIONS(7143),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(7125),
    [anon_sym_SLASH] = ACTIONS(7127),
    [anon_sym_PERCENT] = ACTIONS(7127),
    [sym_comment] = ACTIONS(87),
  },
  [6976] = {
    [sym__binary_minus] = ACTIONS(7125),
    [sym__binary_star] = ACTIONS(7127),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(7127),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(7143),
    [anon_sym_GT_GT] = ACTIONS(7143),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(7125),
    [anon_sym_SLASH] = ACTIONS(7127),
    [anon_sym_PERCENT] = ACTIONS(7127),
    [sym_comment] = ACTIONS(87),
  },
  [6977] = {
    [sym__binary_minus] = ACTIONS(7125),
    [sym__binary_star] = ACTIONS(7127),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(7129),
    [anon_sym_STAR_STAR] = ACTIONS(7127),
    [anon_sym_AMP] = ACTIONS(7131),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(7143),
    [anon_sym_GT_GT] = ACTIONS(7143),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(7149),
    [anon_sym_PLUS] = ACTIONS(7125),
    [anon_sym_SLASH] = ACTIONS(7127),
    [anon_sym_PERCENT] = ACTIONS(7127),
    [sym_comment] = ACTIONS(87),
  },
  [6978] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(12653),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [6979] = {
    [sym__binary_minus] = ACTIONS(7125),
    [sym__binary_star] = ACTIONS(7127),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(7129),
    [anon_sym_STAR_STAR] = ACTIONS(7127),
    [anon_sym_AMP] = ACTIONS(7131),
    [anon_sym_LT] = ACTIONS(7133),
    [anon_sym_EQ_GT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(7137),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7139),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(7141),
    [anon_sym_AMP_AMP] = ACTIONS(7141),
    [anon_sym_LT_LT] = ACTIONS(7143),
    [anon_sym_GT_GT] = ACTIONS(7143),
    [anon_sym_EQ_EQ] = ACTIONS(7145),
    [anon_sym_BANG_EQ] = ACTIONS(7141),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7141),
    [anon_sym_LT_EQ_GT] = ACTIONS(7141),
    [anon_sym_EQ_TILDE] = ACTIONS(7141),
    [anon_sym_BANG_TILDE] = ACTIONS(7141),
    [anon_sym_LT_EQ] = ACTIONS(7133),
    [anon_sym_GT] = ACTIONS(7133),
    [anon_sym_GT_EQ] = ACTIONS(7147),
    [anon_sym_CARET] = ACTIONS(7149),
    [anon_sym_PLUS] = ACTIONS(7125),
    [anon_sym_SLASH] = ACTIONS(7127),
    [anon_sym_PERCENT] = ACTIONS(7127),
    [sym_comment] = ACTIONS(87),
  },
  [6980] = {
    [sym__binary_minus] = ACTIONS(7125),
    [sym__binary_star] = ACTIONS(7127),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(7129),
    [anon_sym_STAR_STAR] = ACTIONS(7127),
    [anon_sym_AMP] = ACTIONS(7131),
    [anon_sym_LT] = ACTIONS(7133),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(7135),
    [anon_sym_DOT_DOT] = ACTIONS(7137),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7139),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(7141),
    [anon_sym_AMP_AMP] = ACTIONS(7141),
    [anon_sym_LT_LT] = ACTIONS(7143),
    [anon_sym_GT_GT] = ACTIONS(7143),
    [anon_sym_EQ_EQ] = ACTIONS(7145),
    [anon_sym_BANG_EQ] = ACTIONS(7141),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7141),
    [anon_sym_LT_EQ_GT] = ACTIONS(7141),
    [anon_sym_EQ_TILDE] = ACTIONS(7141),
    [anon_sym_BANG_TILDE] = ACTIONS(7141),
    [anon_sym_LT_EQ] = ACTIONS(7133),
    [anon_sym_GT] = ACTIONS(7133),
    [anon_sym_GT_EQ] = ACTIONS(7147),
    [anon_sym_CARET] = ACTIONS(7149),
    [anon_sym_PLUS] = ACTIONS(7125),
    [anon_sym_SLASH] = ACTIONS(7127),
    [anon_sym_PERCENT] = ACTIONS(7127),
    [sym_comment] = ACTIONS(87),
  },
  [6981] = {
    [sym__binary_minus] = ACTIONS(7125),
    [sym__binary_star] = ACTIONS(7127),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(7129),
    [anon_sym_STAR_STAR] = ACTIONS(7127),
    [anon_sym_AMP] = ACTIONS(7131),
    [anon_sym_LT] = ACTIONS(7133),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(7143),
    [anon_sym_GT_GT] = ACTIONS(7143),
    [anon_sym_EQ_EQ] = ACTIONS(7145),
    [anon_sym_BANG_EQ] = ACTIONS(7141),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7141),
    [anon_sym_LT_EQ_GT] = ACTIONS(7141),
    [anon_sym_EQ_TILDE] = ACTIONS(7141),
    [anon_sym_BANG_TILDE] = ACTIONS(7141),
    [anon_sym_LT_EQ] = ACTIONS(7133),
    [anon_sym_GT] = ACTIONS(7133),
    [anon_sym_GT_EQ] = ACTIONS(7147),
    [anon_sym_CARET] = ACTIONS(7149),
    [anon_sym_PLUS] = ACTIONS(7125),
    [anon_sym_SLASH] = ACTIONS(7127),
    [anon_sym_PERCENT] = ACTIONS(7127),
    [sym_comment] = ACTIONS(87),
  },
  [6982] = {
    [sym__binary_minus] = ACTIONS(7125),
    [sym__binary_star] = ACTIONS(7127),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(7127),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(7125),
    [anon_sym_SLASH] = ACTIONS(7127),
    [anon_sym_PERCENT] = ACTIONS(7127),
    [sym_comment] = ACTIONS(87),
  },
  [6983] = {
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_RBRACE] = ACTIONS(11597),
    [anon_sym_RPAREN] = ACTIONS(11597),
    [anon_sym_COMMA] = ACTIONS(11597),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_COLON2] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [6984] = {
    [aux_sym_exceptions_repeat1] = STATE(6984),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_COMMA] = ACTIONS(12655),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [6985] = {
    [aux_sym_exceptions_repeat1] = STATE(4380),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [6986] = {
    [sym__binary_minus] = ACTIONS(7125),
    [sym__binary_star] = ACTIONS(7127),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(7129),
    [anon_sym_STAR_STAR] = ACTIONS(7127),
    [anon_sym_AMP] = ACTIONS(7131),
    [anon_sym_LT] = ACTIONS(7133),
    [anon_sym_EQ_GT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(7135),
    [anon_sym_DOT_DOT] = ACTIONS(7137),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7139),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(7141),
    [anon_sym_AMP_AMP] = ACTIONS(7141),
    [anon_sym_LT_LT] = ACTIONS(7143),
    [anon_sym_GT_GT] = ACTIONS(7143),
    [anon_sym_EQ_EQ] = ACTIONS(7145),
    [anon_sym_BANG_EQ] = ACTIONS(7141),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7141),
    [anon_sym_LT_EQ_GT] = ACTIONS(7141),
    [anon_sym_EQ_TILDE] = ACTIONS(7141),
    [anon_sym_BANG_TILDE] = ACTIONS(7141),
    [anon_sym_LT_EQ] = ACTIONS(7133),
    [anon_sym_GT] = ACTIONS(7133),
    [anon_sym_GT_EQ] = ACTIONS(7147),
    [anon_sym_CARET] = ACTIONS(7149),
    [anon_sym_PLUS] = ACTIONS(7125),
    [anon_sym_SLASH] = ACTIONS(7127),
    [anon_sym_PERCENT] = ACTIONS(7127),
    [sym_comment] = ACTIONS(87),
  },
  [6987] = {
    [sym_string] = STATE(6987),
    [aux_sym_chained_string_repeat1] = STATE(6987),
    [sym__string_start] = ACTIONS(7159),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_EQ_GT] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [6988] = {
    [sym__simple_symbol] = ACTIONS(6813),
    [sym__string_start] = ACTIONS(6813),
    [sym__symbol_start] = ACTIONS(6813),
    [sym__subshell_start] = ACTIONS(6813),
    [sym__regex_start] = ACTIONS(6813),
    [sym__string_array_start] = ACTIONS(6813),
    [sym__symbol_array_start] = ACTIONS(6813),
    [sym__heredoc_body_start] = ACTIONS(6813),
    [sym_heredoc_beginning] = ACTIONS(6813),
    [sym__unary_minus] = ACTIONS(6813),
    [sym__identifier_hash_key] = ACTIONS(6813),
    [anon_sym_LBRACE] = ACTIONS(6813),
    [anon_sym_RBRACE] = ACTIONS(6813),
    [anon_sym_def] = ACTIONS(8689),
    [anon_sym_LPAREN] = ACTIONS(6813),
    [anon_sym_COLON_COLON] = ACTIONS(6813),
    [anon_sym_STAR] = ACTIONS(8689),
    [anon_sym_STAR_STAR] = ACTIONS(6813),
    [anon_sym_class] = ACTIONS(8689),
    [anon_sym_module] = ACTIONS(8689),
    [anon_sym_return] = ACTIONS(8689),
    [anon_sym_yield] = ACTIONS(8689),
    [anon_sym_break] = ACTIONS(8689),
    [anon_sym_next] = ACTIONS(8689),
    [sym_redo] = ACTIONS(8689),
    [sym_retry] = ACTIONS(8689),
    [anon_sym_if] = ACTIONS(8689),
    [anon_sym_unless] = ACTIONS(8689),
    [anon_sym_while] = ACTIONS(8689),
    [anon_sym_until] = ACTIONS(8689),
    [anon_sym_for] = ACTIONS(8689),
    [anon_sym_case] = ACTIONS(8689),
    [anon_sym_begin] = ACTIONS(8689),
    [anon_sym_PLUS] = ACTIONS(8689),
    [anon_sym_defined_QMARK] = ACTIONS(6813),
    [anon_sym_not] = ACTIONS(8689),
    [anon_sym_BANG] = ACTIONS(6813),
    [anon_sym_TILDE] = ACTIONS(6813),
    [sym_constant] = ACTIONS(8689),
    [sym_identifier] = ACTIONS(8689),
    [sym_instance_variable] = ACTIONS(6813),
    [sym_class_variable] = ACTIONS(6813),
    [sym_global_variable] = ACTIONS(6813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(8689),
    [sym_float] = ACTIONS(8689),
    [sym_complex] = ACTIONS(6813),
    [sym_super] = ACTIONS(8689),
    [anon_sym_true] = ACTIONS(8689),
    [anon_sym_TRUE] = ACTIONS(8689),
    [anon_sym_false] = ACTIONS(8689),
    [anon_sym_FALSE] = ACTIONS(8689),
    [sym_self] = ACTIONS(8689),
    [anon_sym_nil] = ACTIONS(8689),
    [anon_sym_NIL] = ACTIONS(8689),
    [sym_character] = ACTIONS(6813),
    [anon_sym_LBRACK2] = ACTIONS(6813),
    [anon_sym_DASH_GT] = ACTIONS(6813),
  },
  [6989] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(10568),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [6990] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(10566),
    [sym__binary_star] = ACTIONS(10568),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(10570),
    [anon_sym_STAR_STAR] = ACTIONS(10568),
    [anon_sym_AMP] = ACTIONS(10572),
    [anon_sym_LT] = ACTIONS(10574),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(10576),
    [anon_sym_DOT_DOT] = ACTIONS(10578),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10580),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(10582),
    [anon_sym_AMP_AMP] = ACTIONS(10582),
    [anon_sym_LT_LT] = ACTIONS(10584),
    [anon_sym_GT_GT] = ACTIONS(10584),
    [anon_sym_EQ_EQ] = ACTIONS(10586),
    [anon_sym_BANG_EQ] = ACTIONS(10582),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10582),
    [anon_sym_LT_EQ_GT] = ACTIONS(10582),
    [anon_sym_EQ_TILDE] = ACTIONS(10582),
    [anon_sym_BANG_TILDE] = ACTIONS(10582),
    [anon_sym_LT_EQ] = ACTIONS(10574),
    [anon_sym_GT] = ACTIONS(10574),
    [anon_sym_GT_EQ] = ACTIONS(10588),
    [anon_sym_CARET] = ACTIONS(10590),
    [anon_sym_PLUS] = ACTIONS(10566),
    [anon_sym_SLASH] = ACTIONS(10568),
    [anon_sym_PERCENT] = ACTIONS(10568),
    [sym_comment] = ACTIONS(87),
  },
  [6991] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9047),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4392),
    [sym_scope_resolution] = STATE(2478),
    [sym_call] = STATE(2478),
    [sym_method_call] = STATE(4392),
    [sym_assignment] = STATE(9047),
    [sym_operator_assignment] = STATE(9047),
    [sym_conditional] = STATE(9047),
    [sym_range] = STATE(9047),
    [sym_binary] = STATE(9047),
    [sym_unary] = STATE(9047),
    [sym_left_assignment_list] = STATE(4391),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4392),
    [sym__variable] = STATE(2478),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4392),
    [sym_false] = STATE(4392),
    [sym_nil] = STATE(4392),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2481),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7174),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4263),
    [anon_sym_yield] = ACTIONS(4265),
    [anon_sym_break] = ACTIONS(4267),
    [anon_sym_next] = ACTIONS(4269),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7176),
    [anon_sym_defined_QMARK] = ACTIONS(7178),
    [anon_sym_not] = ACTIONS(7180),
    [anon_sym_BANG] = ACTIONS(7182),
    [anon_sym_TILDE] = ACTIONS(7182),
    [sym_constant] = ACTIONS(4279),
    [sym_identifier] = ACTIONS(4279),
    [sym_instance_variable] = ACTIONS(4281),
    [sym_class_variable] = ACTIONS(4281),
    [sym_global_variable] = ACTIONS(4281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4279),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4279),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6992] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9048),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4392),
    [sym_scope_resolution] = STATE(2478),
    [sym_call] = STATE(2478),
    [sym_method_call] = STATE(4392),
    [sym_assignment] = STATE(9048),
    [sym_operator_assignment] = STATE(9048),
    [sym_conditional] = STATE(9048),
    [sym_range] = STATE(9048),
    [sym_binary] = STATE(9048),
    [sym_unary] = STATE(9048),
    [sym_left_assignment_list] = STATE(4391),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4392),
    [sym__variable] = STATE(2478),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4392),
    [sym_false] = STATE(4392),
    [sym_nil] = STATE(4392),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2481),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7174),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4263),
    [anon_sym_yield] = ACTIONS(4265),
    [anon_sym_break] = ACTIONS(4267),
    [anon_sym_next] = ACTIONS(4269),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7176),
    [anon_sym_defined_QMARK] = ACTIONS(7178),
    [anon_sym_not] = ACTIONS(7180),
    [anon_sym_BANG] = ACTIONS(7182),
    [anon_sym_TILDE] = ACTIONS(7182),
    [sym_constant] = ACTIONS(4279),
    [sym_identifier] = ACTIONS(4279),
    [sym_instance_variable] = ACTIONS(4281),
    [sym_class_variable] = ACTIONS(4281),
    [sym_global_variable] = ACTIONS(4281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4279),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4279),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6993] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9049),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4392),
    [sym_scope_resolution] = STATE(2478),
    [sym_call] = STATE(2478),
    [sym_method_call] = STATE(4392),
    [sym_assignment] = STATE(9049),
    [sym_operator_assignment] = STATE(9049),
    [sym_conditional] = STATE(9049),
    [sym_range] = STATE(9049),
    [sym_binary] = STATE(9049),
    [sym_unary] = STATE(9049),
    [sym_left_assignment_list] = STATE(4391),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4392),
    [sym__variable] = STATE(2478),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4392),
    [sym_false] = STATE(4392),
    [sym_nil] = STATE(4392),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2481),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7174),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4263),
    [anon_sym_yield] = ACTIONS(4265),
    [anon_sym_break] = ACTIONS(4267),
    [anon_sym_next] = ACTIONS(4269),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7176),
    [anon_sym_defined_QMARK] = ACTIONS(7178),
    [anon_sym_not] = ACTIONS(7180),
    [anon_sym_BANG] = ACTIONS(7182),
    [anon_sym_TILDE] = ACTIONS(7182),
    [sym_constant] = ACTIONS(4279),
    [sym_identifier] = ACTIONS(4279),
    [sym_instance_variable] = ACTIONS(4281),
    [sym_class_variable] = ACTIONS(4281),
    [sym_global_variable] = ACTIONS(4281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4279),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4279),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6994] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9050),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4392),
    [sym_scope_resolution] = STATE(2478),
    [sym_call] = STATE(2478),
    [sym_method_call] = STATE(4392),
    [sym_assignment] = STATE(9050),
    [sym_operator_assignment] = STATE(9050),
    [sym_conditional] = STATE(9050),
    [sym_range] = STATE(9050),
    [sym_binary] = STATE(9050),
    [sym_unary] = STATE(9050),
    [sym_left_assignment_list] = STATE(4391),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4392),
    [sym__variable] = STATE(2478),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4392),
    [sym_false] = STATE(4392),
    [sym_nil] = STATE(4392),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2481),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7174),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4263),
    [anon_sym_yield] = ACTIONS(4265),
    [anon_sym_break] = ACTIONS(4267),
    [anon_sym_next] = ACTIONS(4269),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7176),
    [anon_sym_defined_QMARK] = ACTIONS(7178),
    [anon_sym_not] = ACTIONS(7180),
    [anon_sym_BANG] = ACTIONS(7182),
    [anon_sym_TILDE] = ACTIONS(7182),
    [sym_constant] = ACTIONS(4279),
    [sym_identifier] = ACTIONS(4279),
    [sym_instance_variable] = ACTIONS(4281),
    [sym_class_variable] = ACTIONS(4281),
    [sym_global_variable] = ACTIONS(4281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4279),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4279),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6995] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9051),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4392),
    [sym_scope_resolution] = STATE(2478),
    [sym_call] = STATE(2478),
    [sym_method_call] = STATE(4392),
    [sym_assignment] = STATE(9051),
    [sym_operator_assignment] = STATE(9051),
    [sym_conditional] = STATE(9051),
    [sym_range] = STATE(9051),
    [sym_binary] = STATE(9051),
    [sym_unary] = STATE(9051),
    [sym_left_assignment_list] = STATE(4391),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4392),
    [sym__variable] = STATE(2478),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4392),
    [sym_false] = STATE(4392),
    [sym_nil] = STATE(4392),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2481),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7174),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4263),
    [anon_sym_yield] = ACTIONS(4265),
    [anon_sym_break] = ACTIONS(4267),
    [anon_sym_next] = ACTIONS(4269),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7176),
    [anon_sym_defined_QMARK] = ACTIONS(7178),
    [anon_sym_not] = ACTIONS(7180),
    [anon_sym_BANG] = ACTIONS(7182),
    [anon_sym_TILDE] = ACTIONS(7182),
    [sym_constant] = ACTIONS(4279),
    [sym_identifier] = ACTIONS(4279),
    [sym_instance_variable] = ACTIONS(4281),
    [sym_class_variable] = ACTIONS(4281),
    [sym_global_variable] = ACTIONS(4281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4279),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4279),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6996] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(9052),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(9052),
    [sym_operator_assignment] = STATE(9052),
    [sym_conditional] = STATE(9052),
    [sym_range] = STATE(9052),
    [sym_binary] = STATE(9052),
    [sym_unary] = STATE(9052),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6997] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9053),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4392),
    [sym_scope_resolution] = STATE(2478),
    [sym_call] = STATE(2478),
    [sym_method_call] = STATE(4392),
    [sym_assignment] = STATE(9053),
    [sym_operator_assignment] = STATE(9053),
    [sym_conditional] = STATE(9053),
    [sym_range] = STATE(9053),
    [sym_binary] = STATE(9053),
    [sym_unary] = STATE(9053),
    [sym_left_assignment_list] = STATE(4391),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4392),
    [sym__variable] = STATE(2478),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4392),
    [sym_false] = STATE(4392),
    [sym_nil] = STATE(4392),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2481),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7174),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4263),
    [anon_sym_yield] = ACTIONS(4265),
    [anon_sym_break] = ACTIONS(4267),
    [anon_sym_next] = ACTIONS(4269),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7176),
    [anon_sym_defined_QMARK] = ACTIONS(7178),
    [anon_sym_not] = ACTIONS(7180),
    [anon_sym_BANG] = ACTIONS(7182),
    [anon_sym_TILDE] = ACTIONS(7182),
    [sym_constant] = ACTIONS(4279),
    [sym_identifier] = ACTIONS(4279),
    [sym_instance_variable] = ACTIONS(4281),
    [sym_class_variable] = ACTIONS(4281),
    [sym_global_variable] = ACTIONS(4281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4279),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4279),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6998] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9054),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4392),
    [sym_scope_resolution] = STATE(2478),
    [sym_call] = STATE(2478),
    [sym_method_call] = STATE(4392),
    [sym_assignment] = STATE(9054),
    [sym_operator_assignment] = STATE(9054),
    [sym_conditional] = STATE(9054),
    [sym_range] = STATE(9054),
    [sym_binary] = STATE(9054),
    [sym_unary] = STATE(9054),
    [sym_left_assignment_list] = STATE(4391),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4392),
    [sym__variable] = STATE(2478),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4392),
    [sym_false] = STATE(4392),
    [sym_nil] = STATE(4392),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2481),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7174),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4263),
    [anon_sym_yield] = ACTIONS(4265),
    [anon_sym_break] = ACTIONS(4267),
    [anon_sym_next] = ACTIONS(4269),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7176),
    [anon_sym_defined_QMARK] = ACTIONS(7178),
    [anon_sym_not] = ACTIONS(7180),
    [anon_sym_BANG] = ACTIONS(7182),
    [anon_sym_TILDE] = ACTIONS(7182),
    [sym_constant] = ACTIONS(4279),
    [sym_identifier] = ACTIONS(4279),
    [sym_instance_variable] = ACTIONS(4281),
    [sym_class_variable] = ACTIONS(4281),
    [sym_global_variable] = ACTIONS(4281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4279),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4279),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6999] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9055),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4392),
    [sym_scope_resolution] = STATE(2478),
    [sym_call] = STATE(2478),
    [sym_method_call] = STATE(4392),
    [sym_assignment] = STATE(9055),
    [sym_operator_assignment] = STATE(9055),
    [sym_conditional] = STATE(9055),
    [sym_range] = STATE(9055),
    [sym_binary] = STATE(9055),
    [sym_unary] = STATE(9055),
    [sym_left_assignment_list] = STATE(4391),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4392),
    [sym__variable] = STATE(2478),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4392),
    [sym_false] = STATE(4392),
    [sym_nil] = STATE(4392),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2481),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7174),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4263),
    [anon_sym_yield] = ACTIONS(4265),
    [anon_sym_break] = ACTIONS(4267),
    [anon_sym_next] = ACTIONS(4269),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7176),
    [anon_sym_defined_QMARK] = ACTIONS(7178),
    [anon_sym_not] = ACTIONS(7180),
    [anon_sym_BANG] = ACTIONS(7182),
    [anon_sym_TILDE] = ACTIONS(7182),
    [sym_constant] = ACTIONS(4279),
    [sym_identifier] = ACTIONS(4279),
    [sym_instance_variable] = ACTIONS(4281),
    [sym_class_variable] = ACTIONS(4281),
    [sym_global_variable] = ACTIONS(4281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4279),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4279),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7000] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9056),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4392),
    [sym_scope_resolution] = STATE(2478),
    [sym_call] = STATE(2478),
    [sym_method_call] = STATE(4392),
    [sym_assignment] = STATE(9056),
    [sym_operator_assignment] = STATE(9056),
    [sym_conditional] = STATE(9056),
    [sym_range] = STATE(9056),
    [sym_binary] = STATE(9056),
    [sym_unary] = STATE(9056),
    [sym_left_assignment_list] = STATE(4391),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4392),
    [sym__variable] = STATE(2478),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4392),
    [sym_false] = STATE(4392),
    [sym_nil] = STATE(4392),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2481),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7174),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4263),
    [anon_sym_yield] = ACTIONS(4265),
    [anon_sym_break] = ACTIONS(4267),
    [anon_sym_next] = ACTIONS(4269),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7176),
    [anon_sym_defined_QMARK] = ACTIONS(7178),
    [anon_sym_not] = ACTIONS(7180),
    [anon_sym_BANG] = ACTIONS(7182),
    [anon_sym_TILDE] = ACTIONS(7182),
    [sym_constant] = ACTIONS(4279),
    [sym_identifier] = ACTIONS(4279),
    [sym_instance_variable] = ACTIONS(4281),
    [sym_class_variable] = ACTIONS(4281),
    [sym_global_variable] = ACTIONS(4281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4279),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4279),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7001] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9057),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4392),
    [sym_scope_resolution] = STATE(2478),
    [sym_call] = STATE(2478),
    [sym_method_call] = STATE(4392),
    [sym_splat_argument] = STATE(9058),
    [sym_assignment] = STATE(9057),
    [sym_operator_assignment] = STATE(9057),
    [sym_conditional] = STATE(9057),
    [sym_range] = STATE(9057),
    [sym_binary] = STATE(9057),
    [sym_unary] = STATE(9057),
    [sym_right_assignment_list] = STATE(4255),
    [sym__arg_or_splat_arg] = STATE(9058),
    [sym_left_assignment_list] = STATE(4391),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4392),
    [sym__variable] = STATE(2478),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4392),
    [sym_false] = STATE(4392),
    [sym_nil] = STATE(4392),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2481),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(3593),
    [sym__unary_minus] = ACTIONS(7174),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4263),
    [anon_sym_yield] = ACTIONS(4265),
    [anon_sym_break] = ACTIONS(4267),
    [anon_sym_next] = ACTIONS(4269),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7176),
    [anon_sym_defined_QMARK] = ACTIONS(7178),
    [anon_sym_not] = ACTIONS(7180),
    [anon_sym_BANG] = ACTIONS(7182),
    [anon_sym_TILDE] = ACTIONS(7182),
    [sym_constant] = ACTIONS(4279),
    [sym_identifier] = ACTIONS(4279),
    [sym_instance_variable] = ACTIONS(4281),
    [sym_class_variable] = ACTIONS(4281),
    [sym_global_variable] = ACTIONS(4281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4279),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4279),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7002] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9059),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4392),
    [sym_scope_resolution] = STATE(2478),
    [sym_call] = STATE(2478),
    [sym_method_call] = STATE(4392),
    [sym_assignment] = STATE(9059),
    [sym_operator_assignment] = STATE(9059),
    [sym_conditional] = STATE(9059),
    [sym_range] = STATE(9059),
    [sym_binary] = STATE(9059),
    [sym_unary] = STATE(9059),
    [sym_left_assignment_list] = STATE(4391),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4392),
    [sym__variable] = STATE(2478),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4392),
    [sym_false] = STATE(4392),
    [sym_nil] = STATE(4392),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2481),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7174),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4263),
    [anon_sym_yield] = ACTIONS(4265),
    [anon_sym_break] = ACTIONS(4267),
    [anon_sym_next] = ACTIONS(4269),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7176),
    [anon_sym_defined_QMARK] = ACTIONS(7178),
    [anon_sym_not] = ACTIONS(7180),
    [anon_sym_BANG] = ACTIONS(7182),
    [anon_sym_TILDE] = ACTIONS(7182),
    [sym_constant] = ACTIONS(4279),
    [sym_identifier] = ACTIONS(4279),
    [sym_instance_variable] = ACTIONS(4281),
    [sym_class_variable] = ACTIONS(4281),
    [sym_global_variable] = ACTIONS(4281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4279),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4279),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7003] = {
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(10566),
    [sym__binary_star] = ACTIONS(10568),
    [anon_sym_RPAREN] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(10570),
    [anon_sym_STAR_STAR] = ACTIONS(10568),
    [anon_sym_AMP] = ACTIONS(10572),
    [anon_sym_LT] = ACTIONS(10574),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(10576),
    [anon_sym_DOT_DOT] = ACTIONS(10578),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10580),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(10582),
    [anon_sym_AMP_AMP] = ACTIONS(10582),
    [anon_sym_LT_LT] = ACTIONS(10584),
    [anon_sym_GT_GT] = ACTIONS(10584),
    [anon_sym_EQ_EQ] = ACTIONS(10586),
    [anon_sym_BANG_EQ] = ACTIONS(10582),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10582),
    [anon_sym_LT_EQ_GT] = ACTIONS(10582),
    [anon_sym_EQ_TILDE] = ACTIONS(10582),
    [anon_sym_BANG_TILDE] = ACTIONS(10582),
    [anon_sym_LT_EQ] = ACTIONS(10574),
    [anon_sym_GT] = ACTIONS(10574),
    [anon_sym_GT_EQ] = ACTIONS(10588),
    [anon_sym_CARET] = ACTIONS(10590),
    [anon_sym_PLUS] = ACTIONS(10566),
    [anon_sym_SLASH] = ACTIONS(10568),
    [anon_sym_PERCENT] = ACTIONS(10568),
    [sym_comment] = ACTIONS(87),
  },
  [7004] = {
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(10566),
    [sym__binary_star] = ACTIONS(10568),
    [anon_sym_RPAREN] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(10570),
    [anon_sym_STAR_STAR] = ACTIONS(10568),
    [anon_sym_AMP] = ACTIONS(10572),
    [anon_sym_LT] = ACTIONS(10574),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(10576),
    [anon_sym_DOT_DOT] = ACTIONS(10578),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10580),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(10582),
    [anon_sym_AMP_AMP] = ACTIONS(10582),
    [anon_sym_LT_LT] = ACTIONS(10584),
    [anon_sym_GT_GT] = ACTIONS(10584),
    [anon_sym_EQ_EQ] = ACTIONS(10586),
    [anon_sym_BANG_EQ] = ACTIONS(10582),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10582),
    [anon_sym_LT_EQ_GT] = ACTIONS(10582),
    [anon_sym_EQ_TILDE] = ACTIONS(10582),
    [anon_sym_BANG_TILDE] = ACTIONS(10582),
    [anon_sym_LT_EQ] = ACTIONS(10574),
    [anon_sym_GT] = ACTIONS(10574),
    [anon_sym_GT_EQ] = ACTIONS(10588),
    [anon_sym_CARET] = ACTIONS(10590),
    [anon_sym_PLUS] = ACTIONS(10566),
    [anon_sym_SLASH] = ACTIONS(10568),
    [anon_sym_PERCENT] = ACTIONS(10568),
    [sym_comment] = ACTIONS(87),
  },
  [7005] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(7192),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(7192),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(7192),
    [anon_sym_PERCENT] = ACTIONS(7192),
    [sym_comment] = ACTIONS(87),
  },
  [7006] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(7192),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [7007] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7190),
    [sym__binary_star] = ACTIONS(7192),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(7192),
    [anon_sym_AMP] = ACTIONS(7196),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7208),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(7190),
    [anon_sym_SLASH] = ACTIONS(7192),
    [anon_sym_PERCENT] = ACTIONS(7192),
    [sym_comment] = ACTIONS(87),
  },
  [7008] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7190),
    [sym__binary_star] = ACTIONS(7192),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(7192),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7208),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(7190),
    [anon_sym_SLASH] = ACTIONS(7192),
    [anon_sym_PERCENT] = ACTIONS(7192),
    [sym_comment] = ACTIONS(87),
  },
  [7009] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7190),
    [sym__binary_star] = ACTIONS(7192),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(7194),
    [anon_sym_STAR_STAR] = ACTIONS(7192),
    [anon_sym_AMP] = ACTIONS(7196),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7208),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(7214),
    [anon_sym_PLUS] = ACTIONS(7190),
    [anon_sym_SLASH] = ACTIONS(7192),
    [anon_sym_PERCENT] = ACTIONS(7192),
    [sym_comment] = ACTIONS(87),
  },
  [7010] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(12658),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [7011] = {
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(7190),
    [sym__binary_star] = ACTIONS(7192),
    [anon_sym_RPAREN] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(7194),
    [anon_sym_STAR_STAR] = ACTIONS(7192),
    [anon_sym_AMP] = ACTIONS(7196),
    [anon_sym_LT] = ACTIONS(7198),
    [anon_sym_EQ_GT] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(7202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7204),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(7206),
    [anon_sym_AMP_AMP] = ACTIONS(7206),
    [anon_sym_LT_LT] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7208),
    [anon_sym_EQ_EQ] = ACTIONS(7210),
    [anon_sym_BANG_EQ] = ACTIONS(7206),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7206),
    [anon_sym_LT_EQ_GT] = ACTIONS(7206),
    [anon_sym_EQ_TILDE] = ACTIONS(7206),
    [anon_sym_BANG_TILDE] = ACTIONS(7206),
    [anon_sym_LT_EQ] = ACTIONS(7198),
    [anon_sym_GT] = ACTIONS(7198),
    [anon_sym_GT_EQ] = ACTIONS(7212),
    [anon_sym_CARET] = ACTIONS(7214),
    [anon_sym_PLUS] = ACTIONS(7190),
    [anon_sym_SLASH] = ACTIONS(7192),
    [anon_sym_PERCENT] = ACTIONS(7192),
    [sym_comment] = ACTIONS(87),
  },
  [7012] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7190),
    [sym__binary_star] = ACTIONS(7192),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(7194),
    [anon_sym_STAR_STAR] = ACTIONS(7192),
    [anon_sym_AMP] = ACTIONS(7196),
    [anon_sym_LT] = ACTIONS(7198),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(7200),
    [anon_sym_DOT_DOT] = ACTIONS(7202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7204),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(7206),
    [anon_sym_AMP_AMP] = ACTIONS(7206),
    [anon_sym_LT_LT] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7208),
    [anon_sym_EQ_EQ] = ACTIONS(7210),
    [anon_sym_BANG_EQ] = ACTIONS(7206),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7206),
    [anon_sym_LT_EQ_GT] = ACTIONS(7206),
    [anon_sym_EQ_TILDE] = ACTIONS(7206),
    [anon_sym_BANG_TILDE] = ACTIONS(7206),
    [anon_sym_LT_EQ] = ACTIONS(7198),
    [anon_sym_GT] = ACTIONS(7198),
    [anon_sym_GT_EQ] = ACTIONS(7212),
    [anon_sym_CARET] = ACTIONS(7214),
    [anon_sym_PLUS] = ACTIONS(7190),
    [anon_sym_SLASH] = ACTIONS(7192),
    [anon_sym_PERCENT] = ACTIONS(7192),
    [sym_comment] = ACTIONS(87),
  },
  [7013] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7190),
    [sym__binary_star] = ACTIONS(7192),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(7194),
    [anon_sym_STAR_STAR] = ACTIONS(7192),
    [anon_sym_AMP] = ACTIONS(7196),
    [anon_sym_LT] = ACTIONS(7198),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7208),
    [anon_sym_EQ_EQ] = ACTIONS(7210),
    [anon_sym_BANG_EQ] = ACTIONS(7206),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7206),
    [anon_sym_LT_EQ_GT] = ACTIONS(7206),
    [anon_sym_EQ_TILDE] = ACTIONS(7206),
    [anon_sym_BANG_TILDE] = ACTIONS(7206),
    [anon_sym_LT_EQ] = ACTIONS(7198),
    [anon_sym_GT] = ACTIONS(7198),
    [anon_sym_GT_EQ] = ACTIONS(7212),
    [anon_sym_CARET] = ACTIONS(7214),
    [anon_sym_PLUS] = ACTIONS(7190),
    [anon_sym_SLASH] = ACTIONS(7192),
    [anon_sym_PERCENT] = ACTIONS(7192),
    [sym_comment] = ACTIONS(87),
  },
  [7014] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7190),
    [sym__binary_star] = ACTIONS(7192),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(7192),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(7190),
    [anon_sym_SLASH] = ACTIONS(7192),
    [anon_sym_PERCENT] = ACTIONS(7192),
    [sym_comment] = ACTIONS(87),
  },
  [7015] = {
    [sym_heredoc_body] = STATE(7015),
    [aux_sym_call_repeat1] = STATE(7015),
    [sym__heredoc_body_start] = ACTIONS(10455),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_RPAREN] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [7016] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(2057),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2061),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(2061),
    [sym__argument] = STATE(6908),
    [sym_splat_argument] = STATE(6908),
    [sym_hash_splat_argument] = STATE(6908),
    [sym_block_argument] = STATE(6908),
    [sym_assignment] = STATE(2057),
    [sym_operator_assignment] = STATE(2057),
    [sym_conditional] = STATE(2057),
    [sym_range] = STATE(2057),
    [sym_binary] = STATE(2057),
    [sym_unary] = STATE(2057),
    [sym_left_assignment_list] = STATE(2060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2061),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2061),
    [sym_false] = STATE(2061),
    [sym_nil] = STATE(2061),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2062),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(6908),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(3591),
    [sym__splat_star] = ACTIONS(3593),
    [sym__unary_minus] = ACTIONS(3595),
    [sym__identifier_hash_key] = ACTIONS(3597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10598),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7184),
    [anon_sym_defined_QMARK] = ACTIONS(3599),
    [anon_sym_not] = ACTIONS(3601),
    [anon_sym_BANG] = ACTIONS(3605),
    [anon_sym_TILDE] = ACTIONS(3605),
    [sym_constant] = ACTIONS(3607),
    [sym_identifier] = ACTIONS(3607),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7017] = {
    [sym_heredoc_body] = STATE(7015),
    [aux_sym_call_repeat1] = STATE(7015),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_RPAREN] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [7018] = {
    [aux_sym_argument_list_repeat1] = STATE(7018),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_RPAREN] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(12660),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_STAR_STAR] = ACTIONS(7925),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7925),
    [anon_sym_AMP_AMP] = ACTIONS(7925),
    [anon_sym_LT_LT] = ACTIONS(7925),
    [anon_sym_GT_GT] = ACTIONS(7925),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7925),
    [anon_sym_PLUS] = ACTIONS(7925),
    [anon_sym_SLASH] = ACTIONS(7925),
    [anon_sym_PERCENT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [7019] = {
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(7190),
    [sym__binary_star] = ACTIONS(7192),
    [anon_sym_RPAREN] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(7194),
    [anon_sym_STAR_STAR] = ACTIONS(7192),
    [anon_sym_AMP] = ACTIONS(7196),
    [anon_sym_LT] = ACTIONS(7198),
    [anon_sym_EQ_GT] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(7200),
    [anon_sym_DOT_DOT] = ACTIONS(7202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7204),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7206),
    [anon_sym_AMP_AMP] = ACTIONS(7206),
    [anon_sym_LT_LT] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7208),
    [anon_sym_EQ_EQ] = ACTIONS(7210),
    [anon_sym_BANG_EQ] = ACTIONS(7206),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7206),
    [anon_sym_LT_EQ_GT] = ACTIONS(7206),
    [anon_sym_EQ_TILDE] = ACTIONS(7206),
    [anon_sym_BANG_TILDE] = ACTIONS(7206),
    [anon_sym_LT_EQ] = ACTIONS(7198),
    [anon_sym_GT] = ACTIONS(7198),
    [anon_sym_GT_EQ] = ACTIONS(7212),
    [anon_sym_CARET] = ACTIONS(7214),
    [anon_sym_PLUS] = ACTIONS(7190),
    [anon_sym_SLASH] = ACTIONS(7192),
    [anon_sym_PERCENT] = ACTIONS(7192),
    [sym_comment] = ACTIONS(87),
  },
  [7020] = {
    [aux_sym_exceptions_repeat1] = STATE(9062),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_RPAREN] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [7021] = {
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(7190),
    [sym__binary_star] = ACTIONS(7192),
    [anon_sym_RPAREN] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(7194),
    [anon_sym_STAR_STAR] = ACTIONS(7192),
    [anon_sym_AMP] = ACTIONS(7196),
    [anon_sym_LT] = ACTIONS(7198),
    [anon_sym_EQ_GT] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(7200),
    [anon_sym_DOT_DOT] = ACTIONS(7202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7204),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(7206),
    [anon_sym_AMP_AMP] = ACTIONS(7206),
    [anon_sym_LT_LT] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7208),
    [anon_sym_EQ_EQ] = ACTIONS(7210),
    [anon_sym_BANG_EQ] = ACTIONS(7206),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7206),
    [anon_sym_LT_EQ_GT] = ACTIONS(7206),
    [anon_sym_EQ_TILDE] = ACTIONS(7206),
    [anon_sym_BANG_TILDE] = ACTIONS(7206),
    [anon_sym_LT_EQ] = ACTIONS(7198),
    [anon_sym_GT] = ACTIONS(7198),
    [anon_sym_GT_EQ] = ACTIONS(7212),
    [anon_sym_CARET] = ACTIONS(7214),
    [anon_sym_PLUS] = ACTIONS(7190),
    [anon_sym_SLASH] = ACTIONS(7192),
    [anon_sym_PERCENT] = ACTIONS(7192),
    [sym_comment] = ACTIONS(87),
  },
  [7022] = {
    [sym__line_break] = ACTIONS(12663),
    [sym__heredoc_body_start] = ACTIONS(12663),
    [sym__binary_minus] = ACTIONS(12663),
    [sym__binary_star] = ACTIONS(12663),
    [ts_builtin_sym_end] = ACTIONS(12663),
    [anon_sym___END__] = ACTIONS(12663),
    [anon_sym_LBRACE] = ACTIONS(12663),
    [anon_sym_RBRACE] = ACTIONS(12663),
    [anon_sym_RPAREN] = ACTIONS(12663),
    [anon_sym_DOT] = ACTIONS(12665),
    [anon_sym_COMMA] = ACTIONS(12663),
    [anon_sym_PIPE] = ACTIONS(12665),
    [anon_sym_SEMI] = ACTIONS(12663),
    [anon_sym_STAR_STAR] = ACTIONS(12663),
    [anon_sym_AMP] = ACTIONS(12665),
    [anon_sym_LT] = ACTIONS(12665),
    [anon_sym_end] = ACTIONS(12663),
    [anon_sym_if] = ACTIONS(12663),
    [anon_sym_unless] = ACTIONS(12663),
    [anon_sym_while] = ACTIONS(12663),
    [anon_sym_until] = ACTIONS(12663),
    [anon_sym_rescue] = ACTIONS(12663),
    [anon_sym_do] = ACTIONS(12663),
    [anon_sym_when] = ACTIONS(12663),
    [anon_sym_elsif] = ACTIONS(12663),
    [anon_sym_else] = ACTIONS(12663),
    [anon_sym_then] = ACTIONS(12663),
    [anon_sym_ensure] = ACTIONS(12663),
    [anon_sym_EQ_GT] = ACTIONS(12663),
    [anon_sym_LBRACK] = ACTIONS(12663),
    [anon_sym_COLON_COLON2] = ACTIONS(12663),
    [anon_sym_AMP_DOT] = ACTIONS(12663),
    [anon_sym_QMARK] = ACTIONS(12663),
    [anon_sym_DOT_DOT] = ACTIONS(12665),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12663),
    [anon_sym_and] = ACTIONS(12663),
    [anon_sym_or] = ACTIONS(12663),
    [anon_sym_PIPE_PIPE] = ACTIONS(12663),
    [anon_sym_AMP_AMP] = ACTIONS(12663),
    [anon_sym_LT_LT] = ACTIONS(12663),
    [anon_sym_GT_GT] = ACTIONS(12663),
    [anon_sym_EQ_EQ] = ACTIONS(12665),
    [anon_sym_BANG_EQ] = ACTIONS(12663),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12663),
    [anon_sym_LT_EQ_GT] = ACTIONS(12663),
    [anon_sym_EQ_TILDE] = ACTIONS(12663),
    [anon_sym_BANG_TILDE] = ACTIONS(12663),
    [anon_sym_LT_EQ] = ACTIONS(12665),
    [anon_sym_GT] = ACTIONS(12665),
    [anon_sym_GT_EQ] = ACTIONS(12663),
    [anon_sym_CARET] = ACTIONS(12663),
    [anon_sym_PLUS] = ACTIONS(12663),
    [anon_sym_SLASH] = ACTIONS(12663),
    [anon_sym_PERCENT] = ACTIONS(12663),
    [sym_comment] = ACTIONS(87),
  },
  [7023] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(9063),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(674),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(674),
    [sym_assignment] = STATE(9063),
    [sym_operator_assignment] = STATE(9063),
    [sym_conditional] = STATE(9063),
    [sym_range] = STATE(9063),
    [sym_binary] = STATE(9063),
    [sym_unary] = STATE(9063),
    [sym_left_assignment_list] = STATE(673),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(674),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(674),
    [sym_false] = STATE(674),
    [sym_nil] = STATE(674),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(675),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1243),
    [anon_sym_yield] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1247),
    [anon_sym_next] = ACTIONS(1249),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [7024] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(10608),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [7025] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(10602),
    [sym__binary_star] = ACTIONS(10604),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(10606),
    [anon_sym_STAR_STAR] = ACTIONS(10608),
    [anon_sym_AMP] = ACTIONS(10610),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(10612),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(10614),
    [anon_sym_DOT_DOT] = ACTIONS(10616),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10618),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(10620),
    [anon_sym_AMP_AMP] = ACTIONS(10620),
    [anon_sym_LT_LT] = ACTIONS(10622),
    [anon_sym_GT_GT] = ACTIONS(10622),
    [anon_sym_EQ_EQ] = ACTIONS(10620),
    [anon_sym_BANG_EQ] = ACTIONS(10624),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10624),
    [anon_sym_LT_EQ_GT] = ACTIONS(10624),
    [anon_sym_EQ_TILDE] = ACTIONS(10624),
    [anon_sym_BANG_TILDE] = ACTIONS(10624),
    [anon_sym_LT_EQ] = ACTIONS(10612),
    [anon_sym_GT] = ACTIONS(10612),
    [anon_sym_GT_EQ] = ACTIONS(10626),
    [anon_sym_CARET] = ACTIONS(10606),
    [anon_sym_PLUS] = ACTIONS(10628),
    [anon_sym_SLASH] = ACTIONS(10608),
    [anon_sym_PERCENT] = ACTIONS(10608),
    [sym_comment] = ACTIONS(87),
  },
  [7026] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(9064),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(4435),
    [sym_scope_resolution] = STATE(4433),
    [sym_call] = STATE(4433),
    [sym_method_call] = STATE(4435),
    [sym_assignment] = STATE(9064),
    [sym_operator_assignment] = STATE(9064),
    [sym_conditional] = STATE(9064),
    [sym_range] = STATE(9064),
    [sym_binary] = STATE(9064),
    [sym_unary] = STATE(9064),
    [sym_left_assignment_list] = STATE(4434),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4435),
    [sym__variable] = STATE(4433),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(4435),
    [sym_false] = STATE(4435),
    [sym_nil] = STATE(4435),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(4436),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(7228),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(7230),
    [anon_sym_yield] = ACTIONS(7232),
    [anon_sym_break] = ACTIONS(7234),
    [anon_sym_next] = ACTIONS(7236),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(7238),
    [anon_sym_defined_QMARK] = ACTIONS(7240),
    [anon_sym_not] = ACTIONS(7242),
    [anon_sym_BANG] = ACTIONS(7244),
    [anon_sym_TILDE] = ACTIONS(7244),
    [sym_constant] = ACTIONS(7246),
    [sym_identifier] = ACTIONS(7246),
    [sym_instance_variable] = ACTIONS(7248),
    [sym_class_variable] = ACTIONS(7248),
    [sym_global_variable] = ACTIONS(7248),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(7246),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(7246),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [7027] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(9065),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(4435),
    [sym_scope_resolution] = STATE(4433),
    [sym_call] = STATE(4433),
    [sym_method_call] = STATE(4435),
    [sym_assignment] = STATE(9065),
    [sym_operator_assignment] = STATE(9065),
    [sym_conditional] = STATE(9065),
    [sym_range] = STATE(9065),
    [sym_binary] = STATE(9065),
    [sym_unary] = STATE(9065),
    [sym_left_assignment_list] = STATE(4434),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4435),
    [sym__variable] = STATE(4433),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(4435),
    [sym_false] = STATE(4435),
    [sym_nil] = STATE(4435),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(4436),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(7228),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(7230),
    [anon_sym_yield] = ACTIONS(7232),
    [anon_sym_break] = ACTIONS(7234),
    [anon_sym_next] = ACTIONS(7236),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(7238),
    [anon_sym_defined_QMARK] = ACTIONS(7240),
    [anon_sym_not] = ACTIONS(7242),
    [anon_sym_BANG] = ACTIONS(7244),
    [anon_sym_TILDE] = ACTIONS(7244),
    [sym_constant] = ACTIONS(7246),
    [sym_identifier] = ACTIONS(7246),
    [sym_instance_variable] = ACTIONS(7248),
    [sym_class_variable] = ACTIONS(7248),
    [sym_global_variable] = ACTIONS(7248),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(7246),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(7246),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [7028] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(9066),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(4435),
    [sym_scope_resolution] = STATE(4433),
    [sym_call] = STATE(4433),
    [sym_method_call] = STATE(4435),
    [sym_assignment] = STATE(9066),
    [sym_operator_assignment] = STATE(9066),
    [sym_conditional] = STATE(9066),
    [sym_range] = STATE(9066),
    [sym_binary] = STATE(9066),
    [sym_unary] = STATE(9066),
    [sym_left_assignment_list] = STATE(4434),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4435),
    [sym__variable] = STATE(4433),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(4435),
    [sym_false] = STATE(4435),
    [sym_nil] = STATE(4435),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(4436),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(7228),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(7230),
    [anon_sym_yield] = ACTIONS(7232),
    [anon_sym_break] = ACTIONS(7234),
    [anon_sym_next] = ACTIONS(7236),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(7238),
    [anon_sym_defined_QMARK] = ACTIONS(7240),
    [anon_sym_not] = ACTIONS(7242),
    [anon_sym_BANG] = ACTIONS(7244),
    [anon_sym_TILDE] = ACTIONS(7244),
    [sym_constant] = ACTIONS(7246),
    [sym_identifier] = ACTIONS(7246),
    [sym_instance_variable] = ACTIONS(7248),
    [sym_class_variable] = ACTIONS(7248),
    [sym_global_variable] = ACTIONS(7248),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(7246),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(7246),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [7029] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(9067),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(4435),
    [sym_scope_resolution] = STATE(4433),
    [sym_call] = STATE(4433),
    [sym_method_call] = STATE(4435),
    [sym_assignment] = STATE(9067),
    [sym_operator_assignment] = STATE(9067),
    [sym_conditional] = STATE(9067),
    [sym_range] = STATE(9067),
    [sym_binary] = STATE(9067),
    [sym_unary] = STATE(9067),
    [sym_left_assignment_list] = STATE(4434),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4435),
    [sym__variable] = STATE(4433),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(4435),
    [sym_false] = STATE(4435),
    [sym_nil] = STATE(4435),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(4436),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(7228),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(7230),
    [anon_sym_yield] = ACTIONS(7232),
    [anon_sym_break] = ACTIONS(7234),
    [anon_sym_next] = ACTIONS(7236),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(7238),
    [anon_sym_defined_QMARK] = ACTIONS(7240),
    [anon_sym_not] = ACTIONS(7242),
    [anon_sym_BANG] = ACTIONS(7244),
    [anon_sym_TILDE] = ACTIONS(7244),
    [sym_constant] = ACTIONS(7246),
    [sym_identifier] = ACTIONS(7246),
    [sym_instance_variable] = ACTIONS(7248),
    [sym_class_variable] = ACTIONS(7248),
    [sym_global_variable] = ACTIONS(7248),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(7246),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(7246),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [7030] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(9068),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(4435),
    [sym_scope_resolution] = STATE(4433),
    [sym_call] = STATE(4433),
    [sym_method_call] = STATE(4435),
    [sym_assignment] = STATE(9068),
    [sym_operator_assignment] = STATE(9068),
    [sym_conditional] = STATE(9068),
    [sym_range] = STATE(9068),
    [sym_binary] = STATE(9068),
    [sym_unary] = STATE(9068),
    [sym_left_assignment_list] = STATE(4434),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4435),
    [sym__variable] = STATE(4433),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(4435),
    [sym_false] = STATE(4435),
    [sym_nil] = STATE(4435),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(4436),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(7228),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(7230),
    [anon_sym_yield] = ACTIONS(7232),
    [anon_sym_break] = ACTIONS(7234),
    [anon_sym_next] = ACTIONS(7236),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(7238),
    [anon_sym_defined_QMARK] = ACTIONS(7240),
    [anon_sym_not] = ACTIONS(7242),
    [anon_sym_BANG] = ACTIONS(7244),
    [anon_sym_TILDE] = ACTIONS(7244),
    [sym_constant] = ACTIONS(7246),
    [sym_identifier] = ACTIONS(7246),
    [sym_instance_variable] = ACTIONS(7248),
    [sym_class_variable] = ACTIONS(7248),
    [sym_global_variable] = ACTIONS(7248),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(7246),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(7246),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [7031] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(9069),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(9069),
    [sym_operator_assignment] = STATE(9069),
    [sym_conditional] = STATE(9069),
    [sym_range] = STATE(9069),
    [sym_binary] = STATE(9069),
    [sym_unary] = STATE(9069),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [7032] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(9070),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(4435),
    [sym_scope_resolution] = STATE(4433),
    [sym_call] = STATE(4433),
    [sym_method_call] = STATE(4435),
    [sym_assignment] = STATE(9070),
    [sym_operator_assignment] = STATE(9070),
    [sym_conditional] = STATE(9070),
    [sym_range] = STATE(9070),
    [sym_binary] = STATE(9070),
    [sym_unary] = STATE(9070),
    [sym_left_assignment_list] = STATE(4434),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4435),
    [sym__variable] = STATE(4433),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(4435),
    [sym_false] = STATE(4435),
    [sym_nil] = STATE(4435),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(4436),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(7228),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(7230),
    [anon_sym_yield] = ACTIONS(7232),
    [anon_sym_break] = ACTIONS(7234),
    [anon_sym_next] = ACTIONS(7236),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(7238),
    [anon_sym_defined_QMARK] = ACTIONS(7240),
    [anon_sym_not] = ACTIONS(7242),
    [anon_sym_BANG] = ACTIONS(7244),
    [anon_sym_TILDE] = ACTIONS(7244),
    [sym_constant] = ACTIONS(7246),
    [sym_identifier] = ACTIONS(7246),
    [sym_instance_variable] = ACTIONS(7248),
    [sym_class_variable] = ACTIONS(7248),
    [sym_global_variable] = ACTIONS(7248),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(7246),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(7246),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [7033] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(9071),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(4435),
    [sym_scope_resolution] = STATE(4433),
    [sym_call] = STATE(4433),
    [sym_method_call] = STATE(4435),
    [sym_assignment] = STATE(9071),
    [sym_operator_assignment] = STATE(9071),
    [sym_conditional] = STATE(9071),
    [sym_range] = STATE(9071),
    [sym_binary] = STATE(9071),
    [sym_unary] = STATE(9071),
    [sym_left_assignment_list] = STATE(4434),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4435),
    [sym__variable] = STATE(4433),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(4435),
    [sym_false] = STATE(4435),
    [sym_nil] = STATE(4435),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(4436),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(7228),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(7230),
    [anon_sym_yield] = ACTIONS(7232),
    [anon_sym_break] = ACTIONS(7234),
    [anon_sym_next] = ACTIONS(7236),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(7238),
    [anon_sym_defined_QMARK] = ACTIONS(7240),
    [anon_sym_not] = ACTIONS(7242),
    [anon_sym_BANG] = ACTIONS(7244),
    [anon_sym_TILDE] = ACTIONS(7244),
    [sym_constant] = ACTIONS(7246),
    [sym_identifier] = ACTIONS(7246),
    [sym_instance_variable] = ACTIONS(7248),
    [sym_class_variable] = ACTIONS(7248),
    [sym_global_variable] = ACTIONS(7248),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(7246),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(7246),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [7034] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(9072),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(4435),
    [sym_scope_resolution] = STATE(4433),
    [sym_call] = STATE(4433),
    [sym_method_call] = STATE(4435),
    [sym_assignment] = STATE(9072),
    [sym_operator_assignment] = STATE(9072),
    [sym_conditional] = STATE(9072),
    [sym_range] = STATE(9072),
    [sym_binary] = STATE(9072),
    [sym_unary] = STATE(9072),
    [sym_left_assignment_list] = STATE(4434),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4435),
    [sym__variable] = STATE(4433),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(4435),
    [sym_false] = STATE(4435),
    [sym_nil] = STATE(4435),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(4436),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(7228),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(7230),
    [anon_sym_yield] = ACTIONS(7232),
    [anon_sym_break] = ACTIONS(7234),
    [anon_sym_next] = ACTIONS(7236),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(7238),
    [anon_sym_defined_QMARK] = ACTIONS(7240),
    [anon_sym_not] = ACTIONS(7242),
    [anon_sym_BANG] = ACTIONS(7244),
    [anon_sym_TILDE] = ACTIONS(7244),
    [sym_constant] = ACTIONS(7246),
    [sym_identifier] = ACTIONS(7246),
    [sym_instance_variable] = ACTIONS(7248),
    [sym_class_variable] = ACTIONS(7248),
    [sym_global_variable] = ACTIONS(7248),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(7246),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(7246),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [7035] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(9073),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(4435),
    [sym_scope_resolution] = STATE(4433),
    [sym_call] = STATE(4433),
    [sym_method_call] = STATE(4435),
    [sym_assignment] = STATE(9073),
    [sym_operator_assignment] = STATE(9073),
    [sym_conditional] = STATE(9073),
    [sym_range] = STATE(9073),
    [sym_binary] = STATE(9073),
    [sym_unary] = STATE(9073),
    [sym_left_assignment_list] = STATE(4434),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4435),
    [sym__variable] = STATE(4433),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(4435),
    [sym_false] = STATE(4435),
    [sym_nil] = STATE(4435),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(4436),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(7228),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(7230),
    [anon_sym_yield] = ACTIONS(7232),
    [anon_sym_break] = ACTIONS(7234),
    [anon_sym_next] = ACTIONS(7236),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(7238),
    [anon_sym_defined_QMARK] = ACTIONS(7240),
    [anon_sym_not] = ACTIONS(7242),
    [anon_sym_BANG] = ACTIONS(7244),
    [anon_sym_TILDE] = ACTIONS(7244),
    [sym_constant] = ACTIONS(7246),
    [sym_identifier] = ACTIONS(7246),
    [sym_instance_variable] = ACTIONS(7248),
    [sym_class_variable] = ACTIONS(7248),
    [sym_global_variable] = ACTIONS(7248),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(7246),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(7246),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [7036] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(9074),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(4435),
    [sym_scope_resolution] = STATE(4433),
    [sym_call] = STATE(4433),
    [sym_method_call] = STATE(4435),
    [sym_splat_argument] = STATE(9075),
    [sym_assignment] = STATE(9074),
    [sym_operator_assignment] = STATE(9074),
    [sym_conditional] = STATE(9074),
    [sym_range] = STATE(9074),
    [sym_binary] = STATE(9074),
    [sym_unary] = STATE(9074),
    [sym_right_assignment_list] = STATE(8878),
    [sym__arg_or_splat_arg] = STATE(9075),
    [sym_left_assignment_list] = STATE(4434),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4435),
    [sym__variable] = STATE(4433),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(4435),
    [sym_false] = STATE(4435),
    [sym_nil] = STATE(4435),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(4436),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__splat_star] = ACTIONS(3641),
    [sym__unary_minus] = ACTIONS(7228),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(7230),
    [anon_sym_yield] = ACTIONS(7232),
    [anon_sym_break] = ACTIONS(7234),
    [anon_sym_next] = ACTIONS(7236),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(7238),
    [anon_sym_defined_QMARK] = ACTIONS(7240),
    [anon_sym_not] = ACTIONS(7242),
    [anon_sym_BANG] = ACTIONS(7244),
    [anon_sym_TILDE] = ACTIONS(7244),
    [sym_constant] = ACTIONS(7246),
    [sym_identifier] = ACTIONS(7246),
    [sym_instance_variable] = ACTIONS(7248),
    [sym_class_variable] = ACTIONS(7248),
    [sym_global_variable] = ACTIONS(7248),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(7246),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(7246),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [7037] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(9076),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(4435),
    [sym_scope_resolution] = STATE(4433),
    [sym_call] = STATE(4433),
    [sym_method_call] = STATE(4435),
    [sym_assignment] = STATE(9076),
    [sym_operator_assignment] = STATE(9076),
    [sym_conditional] = STATE(9076),
    [sym_range] = STATE(9076),
    [sym_binary] = STATE(9076),
    [sym_unary] = STATE(9076),
    [sym_left_assignment_list] = STATE(4434),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4435),
    [sym__variable] = STATE(4433),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(4435),
    [sym_false] = STATE(4435),
    [sym_nil] = STATE(4435),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(4436),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(7228),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(7230),
    [anon_sym_yield] = ACTIONS(7232),
    [anon_sym_break] = ACTIONS(7234),
    [anon_sym_next] = ACTIONS(7236),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(7238),
    [anon_sym_defined_QMARK] = ACTIONS(7240),
    [anon_sym_not] = ACTIONS(7242),
    [anon_sym_BANG] = ACTIONS(7244),
    [anon_sym_TILDE] = ACTIONS(7244),
    [sym_constant] = ACTIONS(7246),
    [sym_identifier] = ACTIONS(7246),
    [sym_instance_variable] = ACTIONS(7248),
    [sym_class_variable] = ACTIONS(7248),
    [sym_global_variable] = ACTIONS(7248),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(7246),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(7246),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [7038] = {
    [sym_string] = STATE(9077),
    [aux_sym_chained_string_repeat1] = STATE(9077),
    [sym__string_start] = ACTIONS(6455),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_RPAREN] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_STAR_STAR] = ACTIONS(2755),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_EQ] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_PLUS_EQ] = ACTIONS(2753),
    [anon_sym_DASH_EQ] = ACTIONS(2753),
    [anon_sym_STAR_EQ] = ACTIONS(2753),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2753),
    [anon_sym_SLASH_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2753),
    [anon_sym_AMP_EQ] = ACTIONS(2753),
    [anon_sym_PERCENT_EQ] = ACTIONS(2753),
    [anon_sym_GT_GT_EQ] = ACTIONS(2753),
    [anon_sym_LT_LT_EQ] = ACTIONS(2753),
    [anon_sym_CARET_EQ] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2755),
    [anon_sym_AMP_AMP] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2755),
    [anon_sym_GT_GT] = ACTIONS(2755),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_SLASH] = ACTIONS(2755),
    [anon_sym_PERCENT] = ACTIONS(2755),
    [sym_comment] = ACTIONS(87),
  },
  [7039] = {
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(10602),
    [sym__binary_star] = ACTIONS(10604),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_RPAREN] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(10606),
    [anon_sym_STAR_STAR] = ACTIONS(10608),
    [anon_sym_AMP] = ACTIONS(10610),
    [anon_sym_EQ] = ACTIONS(7822),
    [anon_sym_LT] = ACTIONS(10612),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_PLUS_EQ] = ACTIONS(6823),
    [anon_sym_DASH_EQ] = ACTIONS(6823),
    [anon_sym_STAR_EQ] = ACTIONS(6823),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6823),
    [anon_sym_SLASH_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6823),
    [anon_sym_AMP_EQ] = ACTIONS(6823),
    [anon_sym_PERCENT_EQ] = ACTIONS(6823),
    [anon_sym_GT_GT_EQ] = ACTIONS(6823),
    [anon_sym_LT_LT_EQ] = ACTIONS(6823),
    [anon_sym_CARET_EQ] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(10614),
    [anon_sym_DOT_DOT] = ACTIONS(10616),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10618),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(10620),
    [anon_sym_AMP_AMP] = ACTIONS(10620),
    [anon_sym_LT_LT] = ACTIONS(10622),
    [anon_sym_GT_GT] = ACTIONS(10622),
    [anon_sym_EQ_EQ] = ACTIONS(10620),
    [anon_sym_BANG_EQ] = ACTIONS(10624),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10624),
    [anon_sym_LT_EQ_GT] = ACTIONS(10624),
    [anon_sym_EQ_TILDE] = ACTIONS(10624),
    [anon_sym_BANG_TILDE] = ACTIONS(10624),
    [anon_sym_LT_EQ] = ACTIONS(10612),
    [anon_sym_GT] = ACTIONS(10612),
    [anon_sym_GT_EQ] = ACTIONS(10626),
    [anon_sym_CARET] = ACTIONS(10606),
    [anon_sym_PLUS] = ACTIONS(10628),
    [anon_sym_SLASH] = ACTIONS(10608),
    [anon_sym_PERCENT] = ACTIONS(10608),
    [sym_comment] = ACTIONS(87),
  },
  [7040] = {
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(10602),
    [sym__binary_star] = ACTIONS(10604),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_RPAREN] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(10606),
    [anon_sym_STAR_STAR] = ACTIONS(10608),
    [anon_sym_AMP] = ACTIONS(10610),
    [anon_sym_EQ] = ACTIONS(7884),
    [anon_sym_LT] = ACTIONS(10612),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_PLUS_EQ] = ACTIONS(7027),
    [anon_sym_DASH_EQ] = ACTIONS(7027),
    [anon_sym_STAR_EQ] = ACTIONS(7027),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7027),
    [anon_sym_SLASH_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7027),
    [anon_sym_AMP_EQ] = ACTIONS(7027),
    [anon_sym_PERCENT_EQ] = ACTIONS(7027),
    [anon_sym_GT_GT_EQ] = ACTIONS(7027),
    [anon_sym_LT_LT_EQ] = ACTIONS(7027),
    [anon_sym_CARET_EQ] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(10614),
    [anon_sym_DOT_DOT] = ACTIONS(10616),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10618),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(10620),
    [anon_sym_AMP_AMP] = ACTIONS(10620),
    [anon_sym_LT_LT] = ACTIONS(10622),
    [anon_sym_GT_GT] = ACTIONS(10622),
    [anon_sym_EQ_EQ] = ACTIONS(10620),
    [anon_sym_BANG_EQ] = ACTIONS(10624),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10624),
    [anon_sym_LT_EQ_GT] = ACTIONS(10624),
    [anon_sym_EQ_TILDE] = ACTIONS(10624),
    [anon_sym_BANG_TILDE] = ACTIONS(10624),
    [anon_sym_LT_EQ] = ACTIONS(10612),
    [anon_sym_GT] = ACTIONS(10612),
    [anon_sym_GT_EQ] = ACTIONS(10626),
    [anon_sym_CARET] = ACTIONS(10606),
    [anon_sym_PLUS] = ACTIONS(10628),
    [anon_sym_SLASH] = ACTIONS(10608),
    [anon_sym_PERCENT] = ACTIONS(10608),
    [sym_comment] = ACTIONS(87),
  },
  [7041] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(7258),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(7262),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(7262),
    [anon_sym_PERCENT] = ACTIONS(7262),
    [sym_comment] = ACTIONS(87),
  },
  [7042] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(7262),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(5827),
    [anon_sym_PERCENT] = ACTIONS(5827),
    [sym_comment] = ACTIONS(87),
  },
  [7043] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7256),
    [sym__binary_star] = ACTIONS(7258),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(7262),
    [anon_sym_AMP] = ACTIONS(7264),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(7276),
    [anon_sym_GT_GT] = ACTIONS(7276),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(7282),
    [anon_sym_SLASH] = ACTIONS(7262),
    [anon_sym_PERCENT] = ACTIONS(7262),
    [sym_comment] = ACTIONS(87),
  },
  [7044] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7256),
    [sym__binary_star] = ACTIONS(7258),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(7262),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(7276),
    [anon_sym_GT_GT] = ACTIONS(7276),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(7282),
    [anon_sym_SLASH] = ACTIONS(7262),
    [anon_sym_PERCENT] = ACTIONS(7262),
    [sym_comment] = ACTIONS(87),
  },
  [7045] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7256),
    [sym__binary_star] = ACTIONS(7258),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(7260),
    [anon_sym_STAR_STAR] = ACTIONS(7262),
    [anon_sym_AMP] = ACTIONS(7264),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(7276),
    [anon_sym_GT_GT] = ACTIONS(7276),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(7260),
    [anon_sym_PLUS] = ACTIONS(7282),
    [anon_sym_SLASH] = ACTIONS(7262),
    [anon_sym_PERCENT] = ACTIONS(7262),
    [sym_comment] = ACTIONS(87),
  },
  [7046] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(12667),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [7047] = {
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(7256),
    [sym__binary_star] = ACTIONS(7258),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_RPAREN] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(7260),
    [anon_sym_STAR_STAR] = ACTIONS(7262),
    [anon_sym_AMP] = ACTIONS(7264),
    [anon_sym_EQ] = ACTIONS(7888),
    [anon_sym_LT] = ACTIONS(7266),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_EQ_GT] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_PLUS_EQ] = ACTIONS(5927),
    [anon_sym_DASH_EQ] = ACTIONS(5927),
    [anon_sym_STAR_EQ] = ACTIONS(5927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5927),
    [anon_sym_SLASH_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5927),
    [anon_sym_AMP_EQ] = ACTIONS(5927),
    [anon_sym_PERCENT_EQ] = ACTIONS(5927),
    [anon_sym_GT_GT_EQ] = ACTIONS(5927),
    [anon_sym_LT_LT_EQ] = ACTIONS(5927),
    [anon_sym_CARET_EQ] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(7270),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7272),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(7274),
    [anon_sym_AMP_AMP] = ACTIONS(7274),
    [anon_sym_LT_LT] = ACTIONS(7276),
    [anon_sym_GT_GT] = ACTIONS(7276),
    [anon_sym_EQ_EQ] = ACTIONS(7274),
    [anon_sym_BANG_EQ] = ACTIONS(7278),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7278),
    [anon_sym_LT_EQ_GT] = ACTIONS(7278),
    [anon_sym_EQ_TILDE] = ACTIONS(7278),
    [anon_sym_BANG_TILDE] = ACTIONS(7278),
    [anon_sym_LT_EQ] = ACTIONS(7266),
    [anon_sym_GT] = ACTIONS(7266),
    [anon_sym_GT_EQ] = ACTIONS(7280),
    [anon_sym_CARET] = ACTIONS(7260),
    [anon_sym_PLUS] = ACTIONS(7282),
    [anon_sym_SLASH] = ACTIONS(7262),
    [anon_sym_PERCENT] = ACTIONS(7262),
    [sym_comment] = ACTIONS(87),
  },
  [7048] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7256),
    [sym__binary_star] = ACTIONS(7258),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(7260),
    [anon_sym_STAR_STAR] = ACTIONS(7262),
    [anon_sym_AMP] = ACTIONS(7264),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(7266),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(7268),
    [anon_sym_DOT_DOT] = ACTIONS(7270),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7272),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(7274),
    [anon_sym_AMP_AMP] = ACTIONS(7274),
    [anon_sym_LT_LT] = ACTIONS(7276),
    [anon_sym_GT_GT] = ACTIONS(7276),
    [anon_sym_EQ_EQ] = ACTIONS(7274),
    [anon_sym_BANG_EQ] = ACTIONS(7278),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7278),
    [anon_sym_LT_EQ_GT] = ACTIONS(7278),
    [anon_sym_EQ_TILDE] = ACTIONS(7278),
    [anon_sym_BANG_TILDE] = ACTIONS(7278),
    [anon_sym_LT_EQ] = ACTIONS(7266),
    [anon_sym_GT] = ACTIONS(7266),
    [anon_sym_GT_EQ] = ACTIONS(7280),
    [anon_sym_CARET] = ACTIONS(7260),
    [anon_sym_PLUS] = ACTIONS(7282),
    [anon_sym_SLASH] = ACTIONS(7262),
    [anon_sym_PERCENT] = ACTIONS(7262),
    [sym_comment] = ACTIONS(87),
  },
  [7049] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7256),
    [sym__binary_star] = ACTIONS(7258),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(7260),
    [anon_sym_STAR_STAR] = ACTIONS(7262),
    [anon_sym_AMP] = ACTIONS(7264),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(7266),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(7276),
    [anon_sym_GT_GT] = ACTIONS(7276),
    [anon_sym_EQ_EQ] = ACTIONS(7274),
    [anon_sym_BANG_EQ] = ACTIONS(7278),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7278),
    [anon_sym_LT_EQ_GT] = ACTIONS(7278),
    [anon_sym_EQ_TILDE] = ACTIONS(7278),
    [anon_sym_BANG_TILDE] = ACTIONS(7278),
    [anon_sym_LT_EQ] = ACTIONS(7266),
    [anon_sym_GT] = ACTIONS(7266),
    [anon_sym_GT_EQ] = ACTIONS(7280),
    [anon_sym_CARET] = ACTIONS(7260),
    [anon_sym_PLUS] = ACTIONS(7282),
    [anon_sym_SLASH] = ACTIONS(7262),
    [anon_sym_PERCENT] = ACTIONS(7262),
    [sym_comment] = ACTIONS(87),
  },
  [7050] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7256),
    [sym__binary_star] = ACTIONS(7258),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(7262),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(7282),
    [anon_sym_SLASH] = ACTIONS(7262),
    [anon_sym_PERCENT] = ACTIONS(7262),
    [sym_comment] = ACTIONS(87),
  },
  [7051] = {
    [sym_heredoc_body] = STATE(7051),
    [aux_sym_call_repeat1] = STATE(7051),
    [sym__heredoc_body_start] = ACTIONS(12549),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_RPAREN] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_STAR_STAR] = ACTIONS(7919),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_EQ] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_PLUS_EQ] = ACTIONS(7914),
    [anon_sym_DASH_EQ] = ACTIONS(7914),
    [anon_sym_STAR_EQ] = ACTIONS(7914),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7914),
    [anon_sym_SLASH_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7914),
    [anon_sym_AMP_EQ] = ACTIONS(7914),
    [anon_sym_PERCENT_EQ] = ACTIONS(7914),
    [anon_sym_GT_GT_EQ] = ACTIONS(7914),
    [anon_sym_LT_LT_EQ] = ACTIONS(7914),
    [anon_sym_CARET_EQ] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7919),
    [anon_sym_AMP_AMP] = ACTIONS(7919),
    [anon_sym_LT_LT] = ACTIONS(7919),
    [anon_sym_GT_GT] = ACTIONS(7919),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7919),
    [anon_sym_PLUS] = ACTIONS(7919),
    [anon_sym_SLASH] = ACTIONS(7919),
    [anon_sym_PERCENT] = ACTIONS(7919),
    [sym_comment] = ACTIONS(87),
  },
  [7052] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(2087),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2092),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2092),
    [sym__argument] = STATE(8888),
    [sym_splat_argument] = STATE(8888),
    [sym_hash_splat_argument] = STATE(8888),
    [sym_block_argument] = STATE(8888),
    [sym_assignment] = STATE(2087),
    [sym_operator_assignment] = STATE(2087),
    [sym_conditional] = STATE(2087),
    [sym_range] = STATE(2087),
    [sym_binary] = STATE(2087),
    [sym_unary] = STATE(2087),
    [sym_left_assignment_list] = STATE(2091),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2092),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2092),
    [sym_false] = STATE(2092),
    [sym_nil] = STATE(2092),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(2093),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(8888),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(3639),
    [sym__splat_star] = ACTIONS(3641),
    [sym__unary_minus] = ACTIONS(3643),
    [sym__identifier_hash_key] = ACTIONS(3645),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10636),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3647),
    [anon_sym_yield] = ACTIONS(3649),
    [anon_sym_break] = ACTIONS(3651),
    [anon_sym_next] = ACTIONS(3653),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(7250),
    [anon_sym_defined_QMARK] = ACTIONS(3655),
    [anon_sym_not] = ACTIONS(3657),
    [anon_sym_BANG] = ACTIONS(3661),
    [anon_sym_TILDE] = ACTIONS(3661),
    [sym_constant] = ACTIONS(3663),
    [sym_identifier] = ACTIONS(3663),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [7053] = {
    [sym_heredoc_body] = STATE(7051),
    [aux_sym_call_repeat1] = STATE(7051),
    [sym__heredoc_body_start] = ACTIONS(6569),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_RPAREN] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_STAR_STAR] = ACTIONS(7931),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_EQ] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_PLUS_EQ] = ACTIONS(7929),
    [anon_sym_DASH_EQ] = ACTIONS(7929),
    [anon_sym_STAR_EQ] = ACTIONS(7929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7929),
    [anon_sym_SLASH_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7929),
    [anon_sym_AMP_EQ] = ACTIONS(7929),
    [anon_sym_PERCENT_EQ] = ACTIONS(7929),
    [anon_sym_GT_GT_EQ] = ACTIONS(7929),
    [anon_sym_LT_LT_EQ] = ACTIONS(7929),
    [anon_sym_CARET_EQ] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7931),
    [anon_sym_AMP_AMP] = ACTIONS(7931),
    [anon_sym_LT_LT] = ACTIONS(7931),
    [anon_sym_GT_GT] = ACTIONS(7931),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7931),
    [anon_sym_PLUS] = ACTIONS(7931),
    [anon_sym_SLASH] = ACTIONS(7931),
    [anon_sym_PERCENT] = ACTIONS(7931),
    [sym_comment] = ACTIONS(87),
  },
  [7054] = {
    [aux_sym_argument_list_repeat1] = STATE(7054),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_RPAREN] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(12669),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_STAR_STAR] = ACTIONS(7927),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_EQ] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_PLUS_EQ] = ACTIONS(7925),
    [anon_sym_DASH_EQ] = ACTIONS(7925),
    [anon_sym_STAR_EQ] = ACTIONS(7925),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7925),
    [anon_sym_SLASH_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7925),
    [anon_sym_AMP_EQ] = ACTIONS(7925),
    [anon_sym_PERCENT_EQ] = ACTIONS(7925),
    [anon_sym_GT_GT_EQ] = ACTIONS(7925),
    [anon_sym_LT_LT_EQ] = ACTIONS(7925),
    [anon_sym_CARET_EQ] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7927),
    [anon_sym_AMP_AMP] = ACTIONS(7927),
    [anon_sym_LT_LT] = ACTIONS(7927),
    [anon_sym_GT_GT] = ACTIONS(7927),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7927),
    [anon_sym_PLUS] = ACTIONS(7927),
    [anon_sym_SLASH] = ACTIONS(7927),
    [anon_sym_PERCENT] = ACTIONS(7927),
    [sym_comment] = ACTIONS(87),
  },
  [7055] = {
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(7256),
    [sym__binary_star] = ACTIONS(7258),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_RPAREN] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(7260),
    [anon_sym_STAR_STAR] = ACTIONS(7262),
    [anon_sym_AMP] = ACTIONS(7264),
    [anon_sym_EQ] = ACTIONS(7936),
    [anon_sym_LT] = ACTIONS(7266),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_EQ_GT] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_PLUS_EQ] = ACTIONS(5115),
    [anon_sym_DASH_EQ] = ACTIONS(5115),
    [anon_sym_STAR_EQ] = ACTIONS(5115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5115),
    [anon_sym_SLASH_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5115),
    [anon_sym_AMP_EQ] = ACTIONS(5115),
    [anon_sym_PERCENT_EQ] = ACTIONS(5115),
    [anon_sym_GT_GT_EQ] = ACTIONS(5115),
    [anon_sym_LT_LT_EQ] = ACTIONS(5115),
    [anon_sym_CARET_EQ] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(7268),
    [anon_sym_DOT_DOT] = ACTIONS(7270),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7272),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7274),
    [anon_sym_AMP_AMP] = ACTIONS(7274),
    [anon_sym_LT_LT] = ACTIONS(7276),
    [anon_sym_GT_GT] = ACTIONS(7276),
    [anon_sym_EQ_EQ] = ACTIONS(7274),
    [anon_sym_BANG_EQ] = ACTIONS(7278),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7278),
    [anon_sym_LT_EQ_GT] = ACTIONS(7278),
    [anon_sym_EQ_TILDE] = ACTIONS(7278),
    [anon_sym_BANG_TILDE] = ACTIONS(7278),
    [anon_sym_LT_EQ] = ACTIONS(7266),
    [anon_sym_GT] = ACTIONS(7266),
    [anon_sym_GT_EQ] = ACTIONS(7280),
    [anon_sym_CARET] = ACTIONS(7260),
    [anon_sym_PLUS] = ACTIONS(7282),
    [anon_sym_SLASH] = ACTIONS(7262),
    [anon_sym_PERCENT] = ACTIONS(7262),
    [sym_comment] = ACTIONS(87),
  },
  [7056] = {
    [aux_sym_exceptions_repeat1] = STATE(9080),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_RPAREN] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_STAR_STAR] = ACTIONS(6193),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_PLUS_EQ] = ACTIONS(6191),
    [anon_sym_DASH_EQ] = ACTIONS(6191),
    [anon_sym_STAR_EQ] = ACTIONS(6191),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6191),
    [anon_sym_SLASH_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6191),
    [anon_sym_AMP_EQ] = ACTIONS(6191),
    [anon_sym_PERCENT_EQ] = ACTIONS(6191),
    [anon_sym_GT_GT_EQ] = ACTIONS(6191),
    [anon_sym_LT_LT_EQ] = ACTIONS(6191),
    [anon_sym_CARET_EQ] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6193),
    [anon_sym_AMP_AMP] = ACTIONS(6193),
    [anon_sym_LT_LT] = ACTIONS(6193),
    [anon_sym_GT_GT] = ACTIONS(6193),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6193),
    [anon_sym_PLUS] = ACTIONS(6193),
    [anon_sym_SLASH] = ACTIONS(6193),
    [anon_sym_PERCENT] = ACTIONS(6193),
    [sym_comment] = ACTIONS(87),
  },
  [7057] = {
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(7256),
    [sym__binary_star] = ACTIONS(7258),
    [anon_sym_LBRACE] = ACTIONS(6210),
    [anon_sym_RPAREN] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(7260),
    [anon_sym_STAR_STAR] = ACTIONS(7262),
    [anon_sym_AMP] = ACTIONS(7264),
    [anon_sym_EQ] = ACTIONS(7938),
    [anon_sym_LT] = ACTIONS(7266),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_EQ_GT] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_PLUS_EQ] = ACTIONS(6210),
    [anon_sym_DASH_EQ] = ACTIONS(6210),
    [anon_sym_STAR_EQ] = ACTIONS(6210),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6210),
    [anon_sym_SLASH_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6210),
    [anon_sym_AMP_EQ] = ACTIONS(6210),
    [anon_sym_PERCENT_EQ] = ACTIONS(6210),
    [anon_sym_GT_GT_EQ] = ACTIONS(6210),
    [anon_sym_LT_LT_EQ] = ACTIONS(6210),
    [anon_sym_CARET_EQ] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(7268),
    [anon_sym_DOT_DOT] = ACTIONS(7270),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7272),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(7274),
    [anon_sym_AMP_AMP] = ACTIONS(7274),
    [anon_sym_LT_LT] = ACTIONS(7276),
    [anon_sym_GT_GT] = ACTIONS(7276),
    [anon_sym_EQ_EQ] = ACTIONS(7274),
    [anon_sym_BANG_EQ] = ACTIONS(7278),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7278),
    [anon_sym_LT_EQ_GT] = ACTIONS(7278),
    [anon_sym_EQ_TILDE] = ACTIONS(7278),
    [anon_sym_BANG_TILDE] = ACTIONS(7278),
    [anon_sym_LT_EQ] = ACTIONS(7266),
    [anon_sym_GT] = ACTIONS(7266),
    [anon_sym_GT_EQ] = ACTIONS(7280),
    [anon_sym_CARET] = ACTIONS(7260),
    [anon_sym_PLUS] = ACTIONS(7282),
    [anon_sym_SLASH] = ACTIONS(7262),
    [anon_sym_PERCENT] = ACTIONS(7262),
    [sym_comment] = ACTIONS(87),
  },
  [7058] = {
    [sym_string] = STATE(7058),
    [aux_sym_chained_string_repeat1] = STATE(7058),
    [sym__string_start] = ACTIONS(10559),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_RPAREN] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_STAR_STAR] = ACTIONS(6217),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_EQ] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_do] = ACTIONS(6212),
    [anon_sym_EQ_GT] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_PLUS_EQ] = ACTIONS(6212),
    [anon_sym_DASH_EQ] = ACTIONS(6212),
    [anon_sym_STAR_EQ] = ACTIONS(6212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6212),
    [anon_sym_SLASH_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6212),
    [anon_sym_AMP_EQ] = ACTIONS(6212),
    [anon_sym_PERCENT_EQ] = ACTIONS(6212),
    [anon_sym_GT_GT_EQ] = ACTIONS(6212),
    [anon_sym_LT_LT_EQ] = ACTIONS(6212),
    [anon_sym_CARET_EQ] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6217),
    [anon_sym_AMP_AMP] = ACTIONS(6217),
    [anon_sym_LT_LT] = ACTIONS(6217),
    [anon_sym_GT_GT] = ACTIONS(6217),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6217),
    [anon_sym_PLUS] = ACTIONS(6217),
    [anon_sym_SLASH] = ACTIONS(6217),
    [anon_sym_PERCENT] = ACTIONS(6217),
    [sym_comment] = ACTIONS(87),
  },
  [7059] = {
    [sym__binary_minus] = ACTIONS(10638),
    [sym__binary_star] = ACTIONS(10640),
    [anon_sym_RPAREN] = ACTIONS(4247),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(10642),
    [anon_sym_STAR_STAR] = ACTIONS(10640),
    [anon_sym_AMP] = ACTIONS(10644),
    [anon_sym_LT] = ACTIONS(10646),
    [anon_sym_QMARK] = ACTIONS(10648),
    [anon_sym_DOT_DOT] = ACTIONS(10650),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10652),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(10654),
    [anon_sym_AMP_AMP] = ACTIONS(10654),
    [anon_sym_LT_LT] = ACTIONS(10656),
    [anon_sym_GT_GT] = ACTIONS(10656),
    [anon_sym_EQ_EQ] = ACTIONS(10658),
    [anon_sym_BANG_EQ] = ACTIONS(10654),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10654),
    [anon_sym_LT_EQ_GT] = ACTIONS(10654),
    [anon_sym_EQ_TILDE] = ACTIONS(10654),
    [anon_sym_BANG_TILDE] = ACTIONS(10654),
    [anon_sym_LT_EQ] = ACTIONS(10646),
    [anon_sym_GT] = ACTIONS(10646),
    [anon_sym_GT_EQ] = ACTIONS(10660),
    [anon_sym_CARET] = ACTIONS(10662),
    [anon_sym_PLUS] = ACTIONS(10638),
    [anon_sym_SLASH] = ACTIONS(10640),
    [anon_sym_PERCENT] = ACTIONS(10640),
    [sym_comment] = ACTIONS(87),
  },
  [7060] = {
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(10640),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [7061] = {
    [sym__binary_minus] = ACTIONS(10638),
    [sym__binary_star] = ACTIONS(10640),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(10642),
    [anon_sym_STAR_STAR] = ACTIONS(10640),
    [anon_sym_AMP] = ACTIONS(10644),
    [anon_sym_LT] = ACTIONS(10646),
    [anon_sym_QMARK] = ACTIONS(10648),
    [anon_sym_DOT_DOT] = ACTIONS(10650),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10652),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(10654),
    [anon_sym_AMP_AMP] = ACTIONS(10654),
    [anon_sym_LT_LT] = ACTIONS(10656),
    [anon_sym_GT_GT] = ACTIONS(10656),
    [anon_sym_EQ_EQ] = ACTIONS(10658),
    [anon_sym_BANG_EQ] = ACTIONS(10654),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10654),
    [anon_sym_LT_EQ_GT] = ACTIONS(10654),
    [anon_sym_EQ_TILDE] = ACTIONS(10654),
    [anon_sym_BANG_TILDE] = ACTIONS(10654),
    [anon_sym_LT_EQ] = ACTIONS(10646),
    [anon_sym_GT] = ACTIONS(10646),
    [anon_sym_GT_EQ] = ACTIONS(10660),
    [anon_sym_CARET] = ACTIONS(10662),
    [anon_sym_PLUS] = ACTIONS(10638),
    [anon_sym_SLASH] = ACTIONS(10640),
    [anon_sym_PERCENT] = ACTIONS(10640),
    [sym_comment] = ACTIONS(87),
  },
  [7062] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(9081),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(4471),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(4471),
    [sym_assignment] = STATE(9081),
    [sym_operator_assignment] = STATE(9081),
    [sym_conditional] = STATE(9081),
    [sym_range] = STATE(9081),
    [sym_binary] = STATE(9081),
    [sym_unary] = STATE(9081),
    [sym_left_assignment_list] = STATE(4470),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4471),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(4471),
    [sym_false] = STATE(4471),
    [sym_nil] = STATE(4471),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(4472),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(7296),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7298),
    [anon_sym_yield] = ACTIONS(7300),
    [anon_sym_break] = ACTIONS(7302),
    [anon_sym_next] = ACTIONS(7304),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7306),
    [anon_sym_defined_QMARK] = ACTIONS(7308),
    [anon_sym_not] = ACTIONS(7310),
    [anon_sym_BANG] = ACTIONS(7312),
    [anon_sym_TILDE] = ACTIONS(7312),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [7063] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(9082),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(4471),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(4471),
    [sym_assignment] = STATE(9082),
    [sym_operator_assignment] = STATE(9082),
    [sym_conditional] = STATE(9082),
    [sym_range] = STATE(9082),
    [sym_binary] = STATE(9082),
    [sym_unary] = STATE(9082),
    [sym_left_assignment_list] = STATE(4470),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4471),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(4471),
    [sym_false] = STATE(4471),
    [sym_nil] = STATE(4471),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(4472),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(7296),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7298),
    [anon_sym_yield] = ACTIONS(7300),
    [anon_sym_break] = ACTIONS(7302),
    [anon_sym_next] = ACTIONS(7304),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7306),
    [anon_sym_defined_QMARK] = ACTIONS(7308),
    [anon_sym_not] = ACTIONS(7310),
    [anon_sym_BANG] = ACTIONS(7312),
    [anon_sym_TILDE] = ACTIONS(7312),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [7064] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(9083),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(4471),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(4471),
    [sym_assignment] = STATE(9083),
    [sym_operator_assignment] = STATE(9083),
    [sym_conditional] = STATE(9083),
    [sym_range] = STATE(9083),
    [sym_binary] = STATE(9083),
    [sym_unary] = STATE(9083),
    [sym_left_assignment_list] = STATE(4470),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4471),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(4471),
    [sym_false] = STATE(4471),
    [sym_nil] = STATE(4471),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(4472),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(7296),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7298),
    [anon_sym_yield] = ACTIONS(7300),
    [anon_sym_break] = ACTIONS(7302),
    [anon_sym_next] = ACTIONS(7304),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7306),
    [anon_sym_defined_QMARK] = ACTIONS(7308),
    [anon_sym_not] = ACTIONS(7310),
    [anon_sym_BANG] = ACTIONS(7312),
    [anon_sym_TILDE] = ACTIONS(7312),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [7065] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(9084),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(4471),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(4471),
    [sym_assignment] = STATE(9084),
    [sym_operator_assignment] = STATE(9084),
    [sym_conditional] = STATE(9084),
    [sym_range] = STATE(9084),
    [sym_binary] = STATE(9084),
    [sym_unary] = STATE(9084),
    [sym_left_assignment_list] = STATE(4470),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4471),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(4471),
    [sym_false] = STATE(4471),
    [sym_nil] = STATE(4471),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(4472),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(7296),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7298),
    [anon_sym_yield] = ACTIONS(7300),
    [anon_sym_break] = ACTIONS(7302),
    [anon_sym_next] = ACTIONS(7304),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7306),
    [anon_sym_defined_QMARK] = ACTIONS(7308),
    [anon_sym_not] = ACTIONS(7310),
    [anon_sym_BANG] = ACTIONS(7312),
    [anon_sym_TILDE] = ACTIONS(7312),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [7066] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(9085),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(4471),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(4471),
    [sym_assignment] = STATE(9085),
    [sym_operator_assignment] = STATE(9085),
    [sym_conditional] = STATE(9085),
    [sym_range] = STATE(9085),
    [sym_binary] = STATE(9085),
    [sym_unary] = STATE(9085),
    [sym_left_assignment_list] = STATE(4470),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4471),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(4471),
    [sym_false] = STATE(4471),
    [sym_nil] = STATE(4471),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(4472),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(7296),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7298),
    [anon_sym_yield] = ACTIONS(7300),
    [anon_sym_break] = ACTIONS(7302),
    [anon_sym_next] = ACTIONS(7304),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7306),
    [anon_sym_defined_QMARK] = ACTIONS(7308),
    [anon_sym_not] = ACTIONS(7310),
    [anon_sym_BANG] = ACTIONS(7312),
    [anon_sym_TILDE] = ACTIONS(7312),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [7067] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(9086),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(9086),
    [sym_operator_assignment] = STATE(9086),
    [sym_conditional] = STATE(9086),
    [sym_range] = STATE(9086),
    [sym_binary] = STATE(9086),
    [sym_unary] = STATE(9086),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [7068] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(9087),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(4471),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(4471),
    [sym_assignment] = STATE(9087),
    [sym_operator_assignment] = STATE(9087),
    [sym_conditional] = STATE(9087),
    [sym_range] = STATE(9087),
    [sym_binary] = STATE(9087),
    [sym_unary] = STATE(9087),
    [sym_left_assignment_list] = STATE(4470),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4471),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(4471),
    [sym_false] = STATE(4471),
    [sym_nil] = STATE(4471),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(4472),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(7296),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7298),
    [anon_sym_yield] = ACTIONS(7300),
    [anon_sym_break] = ACTIONS(7302),
    [anon_sym_next] = ACTIONS(7304),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7306),
    [anon_sym_defined_QMARK] = ACTIONS(7308),
    [anon_sym_not] = ACTIONS(7310),
    [anon_sym_BANG] = ACTIONS(7312),
    [anon_sym_TILDE] = ACTIONS(7312),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [7069] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(9088),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(4471),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(4471),
    [sym_assignment] = STATE(9088),
    [sym_operator_assignment] = STATE(9088),
    [sym_conditional] = STATE(9088),
    [sym_range] = STATE(9088),
    [sym_binary] = STATE(9088),
    [sym_unary] = STATE(9088),
    [sym_left_assignment_list] = STATE(4470),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4471),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(4471),
    [sym_false] = STATE(4471),
    [sym_nil] = STATE(4471),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(4472),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(7296),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7298),
    [anon_sym_yield] = ACTIONS(7300),
    [anon_sym_break] = ACTIONS(7302),
    [anon_sym_next] = ACTIONS(7304),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7306),
    [anon_sym_defined_QMARK] = ACTIONS(7308),
    [anon_sym_not] = ACTIONS(7310),
    [anon_sym_BANG] = ACTIONS(7312),
    [anon_sym_TILDE] = ACTIONS(7312),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [7070] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(9089),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(4471),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(4471),
    [sym_assignment] = STATE(9089),
    [sym_operator_assignment] = STATE(9089),
    [sym_conditional] = STATE(9089),
    [sym_range] = STATE(9089),
    [sym_binary] = STATE(9089),
    [sym_unary] = STATE(9089),
    [sym_left_assignment_list] = STATE(4470),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4471),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(4471),
    [sym_false] = STATE(4471),
    [sym_nil] = STATE(4471),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(4472),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(7296),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7298),
    [anon_sym_yield] = ACTIONS(7300),
    [anon_sym_break] = ACTIONS(7302),
    [anon_sym_next] = ACTIONS(7304),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7306),
    [anon_sym_defined_QMARK] = ACTIONS(7308),
    [anon_sym_not] = ACTIONS(7310),
    [anon_sym_BANG] = ACTIONS(7312),
    [anon_sym_TILDE] = ACTIONS(7312),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [7071] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(9090),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(4471),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(4471),
    [sym_assignment] = STATE(9090),
    [sym_operator_assignment] = STATE(9090),
    [sym_conditional] = STATE(9090),
    [sym_range] = STATE(9090),
    [sym_binary] = STATE(9090),
    [sym_unary] = STATE(9090),
    [sym_left_assignment_list] = STATE(4470),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4471),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(4471),
    [sym_false] = STATE(4471),
    [sym_nil] = STATE(4471),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(4472),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(7296),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7298),
    [anon_sym_yield] = ACTIONS(7300),
    [anon_sym_break] = ACTIONS(7302),
    [anon_sym_next] = ACTIONS(7304),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7306),
    [anon_sym_defined_QMARK] = ACTIONS(7308),
    [anon_sym_not] = ACTIONS(7310),
    [anon_sym_BANG] = ACTIONS(7312),
    [anon_sym_TILDE] = ACTIONS(7312),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [7072] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(4468),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(4471),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(4471),
    [sym_splat_argument] = STATE(6983),
    [sym_assignment] = STATE(4468),
    [sym_operator_assignment] = STATE(4468),
    [sym_conditional] = STATE(4468),
    [sym_range] = STATE(4468),
    [sym_binary] = STATE(4468),
    [sym_unary] = STATE(4468),
    [sym__arg_or_splat_arg] = STATE(6983),
    [sym_left_assignment_list] = STATE(4470),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4471),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(4471),
    [sym_false] = STATE(4471),
    [sym_nil] = STATE(4471),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(4472),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__splat_star] = ACTIONS(7294),
    [sym__unary_minus] = ACTIONS(7296),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7298),
    [anon_sym_yield] = ACTIONS(7300),
    [anon_sym_break] = ACTIONS(7302),
    [anon_sym_next] = ACTIONS(7304),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7306),
    [anon_sym_defined_QMARK] = ACTIONS(7308),
    [anon_sym_not] = ACTIONS(7310),
    [anon_sym_BANG] = ACTIONS(7312),
    [anon_sym_TILDE] = ACTIONS(7312),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [7073] = {
    [aux_sym_exceptions_repeat1] = STATE(9091),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_RPAREN] = ACTIONS(9855),
    [anon_sym_COMMA] = ACTIONS(10664),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [7074] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(4468),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(4471),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(4471),
    [sym_splat_argument] = STATE(9092),
    [sym_assignment] = STATE(4468),
    [sym_operator_assignment] = STATE(4468),
    [sym_conditional] = STATE(4468),
    [sym_range] = STATE(4468),
    [sym_binary] = STATE(4468),
    [sym_unary] = STATE(4468),
    [sym_right_assignment_list] = STATE(2035),
    [sym__arg_or_splat_arg] = STATE(9092),
    [sym_left_assignment_list] = STATE(4470),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4471),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(4471),
    [sym_false] = STATE(4471),
    [sym_nil] = STATE(4471),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(4472),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__splat_star] = ACTIONS(7294),
    [sym__unary_minus] = ACTIONS(7296),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7298),
    [anon_sym_yield] = ACTIONS(7300),
    [anon_sym_break] = ACTIONS(7302),
    [anon_sym_next] = ACTIONS(7304),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7306),
    [anon_sym_defined_QMARK] = ACTIONS(7308),
    [anon_sym_not] = ACTIONS(7310),
    [anon_sym_BANG] = ACTIONS(7312),
    [anon_sym_TILDE] = ACTIONS(7312),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [7075] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(9093),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(4471),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(4471),
    [sym_assignment] = STATE(9093),
    [sym_operator_assignment] = STATE(9093),
    [sym_conditional] = STATE(9093),
    [sym_range] = STATE(9093),
    [sym_binary] = STATE(9093),
    [sym_unary] = STATE(9093),
    [sym_left_assignment_list] = STATE(4470),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4471),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(4471),
    [sym_false] = STATE(4471),
    [sym_nil] = STATE(4471),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(4472),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(7296),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7298),
    [anon_sym_yield] = ACTIONS(7300),
    [anon_sym_break] = ACTIONS(7302),
    [anon_sym_next] = ACTIONS(7304),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7306),
    [anon_sym_defined_QMARK] = ACTIONS(7308),
    [anon_sym_not] = ACTIONS(7310),
    [anon_sym_BANG] = ACTIONS(7312),
    [anon_sym_TILDE] = ACTIONS(7312),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [7076] = {
    [sym_string] = STATE(9094),
    [aux_sym_chained_string_repeat1] = STATE(9094),
    [sym__string_start] = ACTIONS(139),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_RPAREN] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [7077] = {
    [sym__simple_symbol] = ACTIONS(12672),
    [sym__string_start] = ACTIONS(12672),
    [sym__symbol_start] = ACTIONS(12672),
    [sym__subshell_start] = ACTIONS(12672),
    [sym__regex_start] = ACTIONS(12672),
    [sym__string_array_start] = ACTIONS(12672),
    [sym__symbol_array_start] = ACTIONS(12672),
    [sym_heredoc_beginning] = ACTIONS(12672),
    [sym__unary_minus] = ACTIONS(12672),
    [anon_sym_BEGIN] = ACTIONS(12674),
    [anon_sym_LBRACE] = ACTIONS(12672),
    [anon_sym_END] = ACTIONS(12674),
    [anon_sym_def] = ACTIONS(12674),
    [anon_sym_LPAREN] = ACTIONS(12672),
    [anon_sym_COLON_COLON] = ACTIONS(12672),
    [anon_sym_SEMI] = ACTIONS(12672),
    [anon_sym_STAR] = ACTIONS(12672),
    [anon_sym_class] = ACTIONS(12674),
    [anon_sym_module] = ACTIONS(12674),
    [anon_sym_end] = ACTIONS(12674),
    [anon_sym_return] = ACTIONS(12674),
    [anon_sym_yield] = ACTIONS(12674),
    [anon_sym_break] = ACTIONS(12674),
    [anon_sym_next] = ACTIONS(12674),
    [sym_redo] = ACTIONS(12674),
    [sym_retry] = ACTIONS(12674),
    [anon_sym_if] = ACTIONS(12674),
    [anon_sym_unless] = ACTIONS(12674),
    [anon_sym_while] = ACTIONS(12674),
    [anon_sym_until] = ACTIONS(12674),
    [anon_sym_rescue] = ACTIONS(12674),
    [anon_sym_for] = ACTIONS(12674),
    [anon_sym_case] = ACTIONS(12674),
    [anon_sym_else] = ACTIONS(12674),
    [anon_sym_begin] = ACTIONS(12674),
    [anon_sym_ensure] = ACTIONS(12674),
    [anon_sym_PLUS] = ACTIONS(12674),
    [anon_sym_defined_QMARK] = ACTIONS(12672),
    [anon_sym_not] = ACTIONS(12674),
    [anon_sym_BANG] = ACTIONS(12672),
    [anon_sym_TILDE] = ACTIONS(12672),
    [sym_constant] = ACTIONS(12674),
    [sym_identifier] = ACTIONS(12674),
    [sym_instance_variable] = ACTIONS(12672),
    [sym_class_variable] = ACTIONS(12672),
    [sym_global_variable] = ACTIONS(12672),
    [anon_sym_undef] = ACTIONS(12674),
    [anon_sym_alias] = ACTIONS(12674),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(12674),
    [sym_float] = ACTIONS(12674),
    [sym_complex] = ACTIONS(12672),
    [sym_super] = ACTIONS(12674),
    [anon_sym_true] = ACTIONS(12674),
    [anon_sym_TRUE] = ACTIONS(12674),
    [anon_sym_false] = ACTIONS(12674),
    [anon_sym_FALSE] = ACTIONS(12674),
    [sym_self] = ACTIONS(12674),
    [anon_sym_nil] = ACTIONS(12674),
    [anon_sym_NIL] = ACTIONS(12674),
    [sym_character] = ACTIONS(12672),
    [anon_sym_LBRACK2] = ACTIONS(12672),
    [anon_sym_DASH_GT] = ACTIONS(12672),
  },
  [7078] = {
    [sym_heredoc_body] = STATE(9095),
    [sym__terminator] = STATE(9095),
    [sym__line_break] = ACTIONS(12676),
    [sym__simple_symbol] = ACTIONS(12672),
    [sym__string_start] = ACTIONS(12672),
    [sym__symbol_start] = ACTIONS(12672),
    [sym__subshell_start] = ACTIONS(12672),
    [sym__regex_start] = ACTIONS(12672),
    [sym__string_array_start] = ACTIONS(12672),
    [sym__symbol_array_start] = ACTIONS(12672),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(12672),
    [sym__unary_minus] = ACTIONS(12672),
    [anon_sym_BEGIN] = ACTIONS(12674),
    [anon_sym_LBRACE] = ACTIONS(12672),
    [anon_sym_END] = ACTIONS(12674),
    [anon_sym_def] = ACTIONS(12674),
    [anon_sym_LPAREN] = ACTIONS(12672),
    [anon_sym_COLON_COLON] = ACTIONS(12672),
    [anon_sym_SEMI] = ACTIONS(12676),
    [anon_sym_STAR] = ACTIONS(12672),
    [anon_sym_class] = ACTIONS(12674),
    [anon_sym_module] = ACTIONS(12674),
    [anon_sym_end] = ACTIONS(12674),
    [anon_sym_return] = ACTIONS(12674),
    [anon_sym_yield] = ACTIONS(12674),
    [anon_sym_break] = ACTIONS(12674),
    [anon_sym_next] = ACTIONS(12674),
    [sym_redo] = ACTIONS(12674),
    [sym_retry] = ACTIONS(12674),
    [anon_sym_if] = ACTIONS(12674),
    [anon_sym_unless] = ACTIONS(12674),
    [anon_sym_while] = ACTIONS(12674),
    [anon_sym_until] = ACTIONS(12674),
    [anon_sym_rescue] = ACTIONS(12674),
    [anon_sym_for] = ACTIONS(12674),
    [anon_sym_case] = ACTIONS(12674),
    [anon_sym_else] = ACTIONS(12674),
    [anon_sym_begin] = ACTIONS(12674),
    [anon_sym_ensure] = ACTIONS(12674),
    [anon_sym_PLUS] = ACTIONS(12674),
    [anon_sym_defined_QMARK] = ACTIONS(12672),
    [anon_sym_not] = ACTIONS(12674),
    [anon_sym_BANG] = ACTIONS(12672),
    [anon_sym_TILDE] = ACTIONS(12672),
    [sym_constant] = ACTIONS(12674),
    [sym_identifier] = ACTIONS(12674),
    [sym_instance_variable] = ACTIONS(12672),
    [sym_class_variable] = ACTIONS(12672),
    [sym_global_variable] = ACTIONS(12672),
    [anon_sym_undef] = ACTIONS(12674),
    [anon_sym_alias] = ACTIONS(12674),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(12674),
    [sym_float] = ACTIONS(12674),
    [sym_complex] = ACTIONS(12672),
    [sym_super] = ACTIONS(12674),
    [anon_sym_true] = ACTIONS(12674),
    [anon_sym_TRUE] = ACTIONS(12674),
    [anon_sym_false] = ACTIONS(12674),
    [anon_sym_FALSE] = ACTIONS(12674),
    [sym_self] = ACTIONS(12674),
    [anon_sym_nil] = ACTIONS(12674),
    [anon_sym_NIL] = ACTIONS(12674),
    [sym_character] = ACTIONS(12672),
    [anon_sym_LBRACK2] = ACTIONS(12672),
    [anon_sym_DASH_GT] = ACTIONS(12672),
  },
  [7079] = {
    [sym__line_break] = ACTIONS(5735),
    [sym__heredoc_body_start] = ACTIONS(5735),
    [anon_sym_DOT] = ACTIONS(5735),
    [anon_sym_COMMA] = ACTIONS(5735),
    [anon_sym_SEMI] = ACTIONS(5735),
    [anon_sym_then] = ACTIONS(5735),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_COLON_COLON2] = ACTIONS(5735),
    [anon_sym_AMP_DOT] = ACTIONS(5735),
    [sym_comment] = ACTIONS(87),
  },
  [7080] = {
    [anon_sym_RBRACE] = ACTIONS(12678),
    [sym_comment] = ACTIONS(87),
  },
  [7081] = {
    [sym__statements] = STATE(9097),
    [sym_begin_block] = STATE(489),
    [sym_end_block] = STATE(489),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(495),
    [aux_sym__statements_repeat1] = STATE(495),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(12678),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7082] = {
    [sym__line_break] = ACTIONS(5771),
    [sym__heredoc_body_start] = ACTIONS(5771),
    [anon_sym_DOT] = ACTIONS(5771),
    [anon_sym_COMMA] = ACTIONS(5771),
    [anon_sym_SEMI] = ACTIONS(5771),
    [anon_sym_then] = ACTIONS(5771),
    [anon_sym_LBRACK] = ACTIONS(5771),
    [anon_sym_COLON_COLON2] = ACTIONS(5771),
    [anon_sym_AMP_DOT] = ACTIONS(5771),
    [sym_comment] = ACTIONS(87),
  },
  [7083] = {
    [anon_sym_end] = ACTIONS(12680),
    [sym_comment] = ACTIONS(87),
  },
  [7084] = {
    [sym__statements] = STATE(9099),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_heredoc_body] = STATE(9100),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [sym__terminator] = STATE(9100),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__line_break] = ACTIONS(12682),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(12682),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12684),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7085] = {
    [sym__statements] = STATE(9099),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_block_parameters] = STATE(9101),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12684),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7086] = {
    [sym__line_break] = ACTIONS(5807),
    [sym__heredoc_body_start] = ACTIONS(5807),
    [anon_sym_COMMA] = ACTIONS(5807),
    [anon_sym_SEMI] = ACTIONS(5807),
    [sym_comment] = ACTIONS(87),
  },
  [7087] = {
    [aux_sym_method_parameters_repeat1] = STATE(9103),
    [anon_sym_RPAREN] = ACTIONS(12686),
    [anon_sym_COMMA] = ACTIONS(5757),
    [sym_comment] = ACTIONS(87),
  },
  [7088] = {
    [sym__formal_parameter] = STATE(9104),
    [sym__simple_formal_parameter] = STATE(9104),
    [sym_destructured_parameter] = STATE(9104),
    [sym_splat_parameter] = STATE(9104),
    [sym_hash_splat_parameter] = STATE(9104),
    [sym_block_parameter] = STATE(9104),
    [sym_keyword_parameter] = STATE(9104),
    [sym_optional_parameter] = STATE(9104),
    [anon_sym_LPAREN] = ACTIONS(7334),
    [anon_sym_STAR] = ACTIONS(1283),
    [anon_sym_STAR_STAR] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1287),
    [sym_identifier] = ACTIONS(1289),
    [sym_comment] = ACTIONS(87),
  },
  [7089] = {
    [sym_heredoc_body] = STATE(9095),
    [sym__terminator] = STATE(9095),
    [aux_sym_method_parameters_repeat1] = STATE(9105),
    [sym__line_break] = ACTIONS(12676),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_COMMA] = ACTIONS(10690),
    [anon_sym_SEMI] = ACTIONS(12676),
    [sym_comment] = ACTIONS(87),
  },
  [7090] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(10702),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [7091] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9106),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4495),
    [sym_scope_resolution] = STATE(4433),
    [sym_call] = STATE(4433),
    [sym_method_call] = STATE(4495),
    [sym_assignment] = STATE(9106),
    [sym_operator_assignment] = STATE(9106),
    [sym_conditional] = STATE(9106),
    [sym_range] = STATE(9106),
    [sym_binary] = STATE(9106),
    [sym_unary] = STATE(9106),
    [sym_left_assignment_list] = STATE(4494),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4495),
    [sym__variable] = STATE(4433),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4495),
    [sym_false] = STATE(4495),
    [sym_nil] = STATE(4495),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(4496),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(4005),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(4009),
    [sym__subshell_start] = ACTIONS(4011),
    [sym__regex_start] = ACTIONS(4013),
    [sym__string_array_start] = ACTIONS(4015),
    [sym__symbol_array_start] = ACTIONS(4017),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7336),
    [anon_sym_LBRACE] = ACTIONS(4021),
    [anon_sym_def] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4025),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(4027),
    [anon_sym_module] = ACTIONS(4029),
    [anon_sym_return] = ACTIONS(7338),
    [anon_sym_yield] = ACTIONS(7340),
    [anon_sym_break] = ACTIONS(7342),
    [anon_sym_next] = ACTIONS(7344),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(4039),
    [anon_sym_unless] = ACTIONS(4041),
    [anon_sym_while] = ACTIONS(4043),
    [anon_sym_until] = ACTIONS(4045),
    [anon_sym_for] = ACTIONS(4047),
    [anon_sym_case] = ACTIONS(4049),
    [anon_sym_begin] = ACTIONS(4051),
    [anon_sym_PLUS] = ACTIONS(7346),
    [anon_sym_defined_QMARK] = ACTIONS(7348),
    [anon_sym_not] = ACTIONS(7350),
    [anon_sym_BANG] = ACTIONS(7352),
    [anon_sym_TILDE] = ACTIONS(7352),
    [sym_constant] = ACTIONS(7246),
    [sym_identifier] = ACTIONS(7246),
    [sym_instance_variable] = ACTIONS(7248),
    [sym_class_variable] = ACTIONS(7248),
    [sym_global_variable] = ACTIONS(7248),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4065),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(7246),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(7246),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(4067),
    [anon_sym_DASH_GT] = ACTIONS(4069),
  },
  [7092] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9107),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4495),
    [sym_scope_resolution] = STATE(4433),
    [sym_call] = STATE(4433),
    [sym_method_call] = STATE(4495),
    [sym_assignment] = STATE(9107),
    [sym_operator_assignment] = STATE(9107),
    [sym_conditional] = STATE(9107),
    [sym_range] = STATE(9107),
    [sym_binary] = STATE(9107),
    [sym_unary] = STATE(9107),
    [sym_left_assignment_list] = STATE(4494),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4495),
    [sym__variable] = STATE(4433),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4495),
    [sym_false] = STATE(4495),
    [sym_nil] = STATE(4495),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(4496),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(4005),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(4009),
    [sym__subshell_start] = ACTIONS(4011),
    [sym__regex_start] = ACTIONS(4013),
    [sym__string_array_start] = ACTIONS(4015),
    [sym__symbol_array_start] = ACTIONS(4017),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7336),
    [anon_sym_LBRACE] = ACTIONS(4021),
    [anon_sym_def] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4025),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(4027),
    [anon_sym_module] = ACTIONS(4029),
    [anon_sym_return] = ACTIONS(7338),
    [anon_sym_yield] = ACTIONS(7340),
    [anon_sym_break] = ACTIONS(7342),
    [anon_sym_next] = ACTIONS(7344),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(4039),
    [anon_sym_unless] = ACTIONS(4041),
    [anon_sym_while] = ACTIONS(4043),
    [anon_sym_until] = ACTIONS(4045),
    [anon_sym_for] = ACTIONS(4047),
    [anon_sym_case] = ACTIONS(4049),
    [anon_sym_begin] = ACTIONS(4051),
    [anon_sym_PLUS] = ACTIONS(7346),
    [anon_sym_defined_QMARK] = ACTIONS(7348),
    [anon_sym_not] = ACTIONS(7350),
    [anon_sym_BANG] = ACTIONS(7352),
    [anon_sym_TILDE] = ACTIONS(7352),
    [sym_constant] = ACTIONS(7246),
    [sym_identifier] = ACTIONS(7246),
    [sym_instance_variable] = ACTIONS(7248),
    [sym_class_variable] = ACTIONS(7248),
    [sym_global_variable] = ACTIONS(7248),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4065),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(7246),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(7246),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(4067),
    [anon_sym_DASH_GT] = ACTIONS(4069),
  },
  [7093] = {
    [anon_sym_COLON] = ACTIONS(12688),
    [sym_comment] = ACTIONS(87),
  },
  [7094] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9109),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4495),
    [sym_scope_resolution] = STATE(4433),
    [sym_call] = STATE(4433),
    [sym_method_call] = STATE(4495),
    [sym_assignment] = STATE(9109),
    [sym_operator_assignment] = STATE(9109),
    [sym_conditional] = STATE(9109),
    [sym_range] = STATE(9109),
    [sym_binary] = STATE(9109),
    [sym_unary] = STATE(9109),
    [sym_left_assignment_list] = STATE(4494),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4495),
    [sym__variable] = STATE(4433),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4495),
    [sym_false] = STATE(4495),
    [sym_nil] = STATE(4495),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(4496),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(4005),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(4009),
    [sym__subshell_start] = ACTIONS(4011),
    [sym__regex_start] = ACTIONS(4013),
    [sym__string_array_start] = ACTIONS(4015),
    [sym__symbol_array_start] = ACTIONS(4017),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7336),
    [anon_sym_LBRACE] = ACTIONS(4021),
    [anon_sym_def] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4025),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(4027),
    [anon_sym_module] = ACTIONS(4029),
    [anon_sym_return] = ACTIONS(7338),
    [anon_sym_yield] = ACTIONS(7340),
    [anon_sym_break] = ACTIONS(7342),
    [anon_sym_next] = ACTIONS(7344),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(4039),
    [anon_sym_unless] = ACTIONS(4041),
    [anon_sym_while] = ACTIONS(4043),
    [anon_sym_until] = ACTIONS(4045),
    [anon_sym_for] = ACTIONS(4047),
    [anon_sym_case] = ACTIONS(4049),
    [anon_sym_begin] = ACTIONS(4051),
    [anon_sym_PLUS] = ACTIONS(7346),
    [anon_sym_defined_QMARK] = ACTIONS(7348),
    [anon_sym_not] = ACTIONS(7350),
    [anon_sym_BANG] = ACTIONS(7352),
    [anon_sym_TILDE] = ACTIONS(7352),
    [sym_constant] = ACTIONS(7246),
    [sym_identifier] = ACTIONS(7246),
    [sym_instance_variable] = ACTIONS(7248),
    [sym_class_variable] = ACTIONS(7248),
    [sym_global_variable] = ACTIONS(7248),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4065),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(7246),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(7246),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(4067),
    [anon_sym_DASH_GT] = ACTIONS(4069),
  },
  [7095] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(12690),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [7096] = {
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(7368),
    [sym__binary_star] = ACTIONS(7370),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_RPAREN] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(7372),
    [anon_sym_STAR_STAR] = ACTIONS(7370),
    [anon_sym_AMP] = ACTIONS(7374),
    [anon_sym_EQ] = ACTIONS(1631),
    [anon_sym_LT] = ACTIONS(7376),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(12688),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(7378),
    [anon_sym_DOT_DOT] = ACTIONS(7380),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7382),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(7386),
    [anon_sym_AMP_AMP] = ACTIONS(7386),
    [anon_sym_LT_LT] = ACTIONS(7388),
    [anon_sym_GT_GT] = ACTIONS(7388),
    [anon_sym_EQ_EQ] = ACTIONS(7390),
    [anon_sym_BANG_EQ] = ACTIONS(7386),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7386),
    [anon_sym_LT_EQ_GT] = ACTIONS(7386),
    [anon_sym_EQ_TILDE] = ACTIONS(7386),
    [anon_sym_BANG_TILDE] = ACTIONS(7386),
    [anon_sym_LT_EQ] = ACTIONS(7376),
    [anon_sym_GT] = ACTIONS(7376),
    [anon_sym_GT_EQ] = ACTIONS(7392),
    [anon_sym_CARET] = ACTIONS(7394),
    [anon_sym_PLUS] = ACTIONS(7368),
    [anon_sym_SLASH] = ACTIONS(7370),
    [anon_sym_PERCENT] = ACTIONS(7370),
    [sym_comment] = ACTIONS(87),
  },
  [7097] = {
    [sym_heredoc_body] = STATE(9111),
    [aux_sym_call_repeat1] = STATE(9111),
    [sym__heredoc_body_start] = ACTIONS(10884),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [7098] = {
    [sym_heredoc_body] = STATE(9111),
    [aux_sym_call_repeat1] = STATE(9111),
    [aux_sym_argument_list_repeat1] = STATE(9113),
    [sym__heredoc_body_start] = ACTIONS(10884),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(12692),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [7099] = {
    [sym_string] = STATE(4528),
    [aux_sym_chained_string_repeat1] = STATE(4528),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(12694),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [7100] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(10700),
    [sym__binary_star] = ACTIONS(10702),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(10704),
    [anon_sym_STAR_STAR] = ACTIONS(10702),
    [anon_sym_AMP] = ACTIONS(10706),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(10708),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(10710),
    [anon_sym_DOT_DOT] = ACTIONS(10712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10714),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(10718),
    [anon_sym_AMP_AMP] = ACTIONS(10718),
    [anon_sym_LT_LT] = ACTIONS(10720),
    [anon_sym_GT_GT] = ACTIONS(10720),
    [anon_sym_EQ_EQ] = ACTIONS(10722),
    [anon_sym_BANG_EQ] = ACTIONS(10718),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10718),
    [anon_sym_LT_EQ_GT] = ACTIONS(10718),
    [anon_sym_EQ_TILDE] = ACTIONS(10718),
    [anon_sym_BANG_TILDE] = ACTIONS(10718),
    [anon_sym_LT_EQ] = ACTIONS(10708),
    [anon_sym_GT] = ACTIONS(10708),
    [anon_sym_GT_EQ] = ACTIONS(10724),
    [anon_sym_CARET] = ACTIONS(10726),
    [anon_sym_PLUS] = ACTIONS(10700),
    [anon_sym_SLASH] = ACTIONS(10702),
    [anon_sym_PERCENT] = ACTIONS(10702),
    [sym_comment] = ACTIONS(87),
  },
  [7101] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9114),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4495),
    [sym_scope_resolution] = STATE(4433),
    [sym_call] = STATE(4433),
    [sym_method_call] = STATE(4495),
    [sym_assignment] = STATE(9114),
    [sym_operator_assignment] = STATE(9114),
    [sym_conditional] = STATE(9114),
    [sym_range] = STATE(9114),
    [sym_binary] = STATE(9114),
    [sym_unary] = STATE(9114),
    [sym_left_assignment_list] = STATE(4494),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4495),
    [sym__variable] = STATE(4433),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4495),
    [sym_false] = STATE(4495),
    [sym_nil] = STATE(4495),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(4496),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(4005),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(4009),
    [sym__subshell_start] = ACTIONS(4011),
    [sym__regex_start] = ACTIONS(4013),
    [sym__string_array_start] = ACTIONS(4015),
    [sym__symbol_array_start] = ACTIONS(4017),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7336),
    [anon_sym_LBRACE] = ACTIONS(4021),
    [anon_sym_def] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4025),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(4027),
    [anon_sym_module] = ACTIONS(4029),
    [anon_sym_return] = ACTIONS(7338),
    [anon_sym_yield] = ACTIONS(7340),
    [anon_sym_break] = ACTIONS(7342),
    [anon_sym_next] = ACTIONS(7344),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(4039),
    [anon_sym_unless] = ACTIONS(4041),
    [anon_sym_while] = ACTIONS(4043),
    [anon_sym_until] = ACTIONS(4045),
    [anon_sym_for] = ACTIONS(4047),
    [anon_sym_case] = ACTIONS(4049),
    [anon_sym_begin] = ACTIONS(4051),
    [anon_sym_PLUS] = ACTIONS(7346),
    [anon_sym_defined_QMARK] = ACTIONS(7348),
    [anon_sym_not] = ACTIONS(7350),
    [anon_sym_BANG] = ACTIONS(7352),
    [anon_sym_TILDE] = ACTIONS(7352),
    [sym_constant] = ACTIONS(7246),
    [sym_identifier] = ACTIONS(7246),
    [sym_instance_variable] = ACTIONS(7248),
    [sym_class_variable] = ACTIONS(7248),
    [sym_global_variable] = ACTIONS(7248),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4065),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(7246),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(7246),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(4067),
    [anon_sym_DASH_GT] = ACTIONS(4069),
  },
  [7102] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9115),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4495),
    [sym_scope_resolution] = STATE(4433),
    [sym_call] = STATE(4433),
    [sym_method_call] = STATE(4495),
    [sym_assignment] = STATE(9115),
    [sym_operator_assignment] = STATE(9115),
    [sym_conditional] = STATE(9115),
    [sym_range] = STATE(9115),
    [sym_binary] = STATE(9115),
    [sym_unary] = STATE(9115),
    [sym_left_assignment_list] = STATE(4494),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4495),
    [sym__variable] = STATE(4433),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4495),
    [sym_false] = STATE(4495),
    [sym_nil] = STATE(4495),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(4496),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(4005),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(4009),
    [sym__subshell_start] = ACTIONS(4011),
    [sym__regex_start] = ACTIONS(4013),
    [sym__string_array_start] = ACTIONS(4015),
    [sym__symbol_array_start] = ACTIONS(4017),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7336),
    [anon_sym_LBRACE] = ACTIONS(4021),
    [anon_sym_def] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4025),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(4027),
    [anon_sym_module] = ACTIONS(4029),
    [anon_sym_return] = ACTIONS(7338),
    [anon_sym_yield] = ACTIONS(7340),
    [anon_sym_break] = ACTIONS(7342),
    [anon_sym_next] = ACTIONS(7344),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(4039),
    [anon_sym_unless] = ACTIONS(4041),
    [anon_sym_while] = ACTIONS(4043),
    [anon_sym_until] = ACTIONS(4045),
    [anon_sym_for] = ACTIONS(4047),
    [anon_sym_case] = ACTIONS(4049),
    [anon_sym_begin] = ACTIONS(4051),
    [anon_sym_PLUS] = ACTIONS(7346),
    [anon_sym_defined_QMARK] = ACTIONS(7348),
    [anon_sym_not] = ACTIONS(7350),
    [anon_sym_BANG] = ACTIONS(7352),
    [anon_sym_TILDE] = ACTIONS(7352),
    [sym_constant] = ACTIONS(7246),
    [sym_identifier] = ACTIONS(7246),
    [sym_instance_variable] = ACTIONS(7248),
    [sym_class_variable] = ACTIONS(7248),
    [sym_global_variable] = ACTIONS(7248),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4065),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(7246),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(7246),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(4067),
    [anon_sym_DASH_GT] = ACTIONS(4069),
  },
  [7103] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9116),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4495),
    [sym_scope_resolution] = STATE(4433),
    [sym_call] = STATE(4433),
    [sym_method_call] = STATE(4495),
    [sym_assignment] = STATE(9116),
    [sym_operator_assignment] = STATE(9116),
    [sym_conditional] = STATE(9116),
    [sym_range] = STATE(9116),
    [sym_binary] = STATE(9116),
    [sym_unary] = STATE(9116),
    [sym_left_assignment_list] = STATE(4494),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4495),
    [sym__variable] = STATE(4433),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4495),
    [sym_false] = STATE(4495),
    [sym_nil] = STATE(4495),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(4496),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(4005),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(4009),
    [sym__subshell_start] = ACTIONS(4011),
    [sym__regex_start] = ACTIONS(4013),
    [sym__string_array_start] = ACTIONS(4015),
    [sym__symbol_array_start] = ACTIONS(4017),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7336),
    [anon_sym_LBRACE] = ACTIONS(4021),
    [anon_sym_def] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4025),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(4027),
    [anon_sym_module] = ACTIONS(4029),
    [anon_sym_return] = ACTIONS(7338),
    [anon_sym_yield] = ACTIONS(7340),
    [anon_sym_break] = ACTIONS(7342),
    [anon_sym_next] = ACTIONS(7344),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(4039),
    [anon_sym_unless] = ACTIONS(4041),
    [anon_sym_while] = ACTIONS(4043),
    [anon_sym_until] = ACTIONS(4045),
    [anon_sym_for] = ACTIONS(4047),
    [anon_sym_case] = ACTIONS(4049),
    [anon_sym_begin] = ACTIONS(4051),
    [anon_sym_PLUS] = ACTIONS(7346),
    [anon_sym_defined_QMARK] = ACTIONS(7348),
    [anon_sym_not] = ACTIONS(7350),
    [anon_sym_BANG] = ACTIONS(7352),
    [anon_sym_TILDE] = ACTIONS(7352),
    [sym_constant] = ACTIONS(7246),
    [sym_identifier] = ACTIONS(7246),
    [sym_instance_variable] = ACTIONS(7248),
    [sym_class_variable] = ACTIONS(7248),
    [sym_global_variable] = ACTIONS(7248),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4065),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(7246),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(7246),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(4067),
    [anon_sym_DASH_GT] = ACTIONS(4069),
  },
  [7104] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9117),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4495),
    [sym_scope_resolution] = STATE(4433),
    [sym_call] = STATE(4433),
    [sym_method_call] = STATE(4495),
    [sym_assignment] = STATE(9117),
    [sym_operator_assignment] = STATE(9117),
    [sym_conditional] = STATE(9117),
    [sym_range] = STATE(9117),
    [sym_binary] = STATE(9117),
    [sym_unary] = STATE(9117),
    [sym_left_assignment_list] = STATE(4494),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4495),
    [sym__variable] = STATE(4433),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4495),
    [sym_false] = STATE(4495),
    [sym_nil] = STATE(4495),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(4496),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(4005),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(4009),
    [sym__subshell_start] = ACTIONS(4011),
    [sym__regex_start] = ACTIONS(4013),
    [sym__string_array_start] = ACTIONS(4015),
    [sym__symbol_array_start] = ACTIONS(4017),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7336),
    [anon_sym_LBRACE] = ACTIONS(4021),
    [anon_sym_def] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4025),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(4027),
    [anon_sym_module] = ACTIONS(4029),
    [anon_sym_return] = ACTIONS(7338),
    [anon_sym_yield] = ACTIONS(7340),
    [anon_sym_break] = ACTIONS(7342),
    [anon_sym_next] = ACTIONS(7344),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(4039),
    [anon_sym_unless] = ACTIONS(4041),
    [anon_sym_while] = ACTIONS(4043),
    [anon_sym_until] = ACTIONS(4045),
    [anon_sym_for] = ACTIONS(4047),
    [anon_sym_case] = ACTIONS(4049),
    [anon_sym_begin] = ACTIONS(4051),
    [anon_sym_PLUS] = ACTIONS(7346),
    [anon_sym_defined_QMARK] = ACTIONS(7348),
    [anon_sym_not] = ACTIONS(7350),
    [anon_sym_BANG] = ACTIONS(7352),
    [anon_sym_TILDE] = ACTIONS(7352),
    [sym_constant] = ACTIONS(7246),
    [sym_identifier] = ACTIONS(7246),
    [sym_instance_variable] = ACTIONS(7248),
    [sym_class_variable] = ACTIONS(7248),
    [sym_global_variable] = ACTIONS(7248),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4065),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(7246),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(7246),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(4067),
    [anon_sym_DASH_GT] = ACTIONS(4069),
  },
  [7105] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9118),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4495),
    [sym_scope_resolution] = STATE(4433),
    [sym_call] = STATE(4433),
    [sym_method_call] = STATE(4495),
    [sym_assignment] = STATE(9118),
    [sym_operator_assignment] = STATE(9118),
    [sym_conditional] = STATE(9118),
    [sym_range] = STATE(9118),
    [sym_binary] = STATE(9118),
    [sym_unary] = STATE(9118),
    [sym_left_assignment_list] = STATE(4494),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4495),
    [sym__variable] = STATE(4433),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4495),
    [sym_false] = STATE(4495),
    [sym_nil] = STATE(4495),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(4496),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(4005),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(4009),
    [sym__subshell_start] = ACTIONS(4011),
    [sym__regex_start] = ACTIONS(4013),
    [sym__string_array_start] = ACTIONS(4015),
    [sym__symbol_array_start] = ACTIONS(4017),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7336),
    [anon_sym_LBRACE] = ACTIONS(4021),
    [anon_sym_def] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4025),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(4027),
    [anon_sym_module] = ACTIONS(4029),
    [anon_sym_return] = ACTIONS(7338),
    [anon_sym_yield] = ACTIONS(7340),
    [anon_sym_break] = ACTIONS(7342),
    [anon_sym_next] = ACTIONS(7344),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(4039),
    [anon_sym_unless] = ACTIONS(4041),
    [anon_sym_while] = ACTIONS(4043),
    [anon_sym_until] = ACTIONS(4045),
    [anon_sym_for] = ACTIONS(4047),
    [anon_sym_case] = ACTIONS(4049),
    [anon_sym_begin] = ACTIONS(4051),
    [anon_sym_PLUS] = ACTIONS(7346),
    [anon_sym_defined_QMARK] = ACTIONS(7348),
    [anon_sym_not] = ACTIONS(7350),
    [anon_sym_BANG] = ACTIONS(7352),
    [anon_sym_TILDE] = ACTIONS(7352),
    [sym_constant] = ACTIONS(7246),
    [sym_identifier] = ACTIONS(7246),
    [sym_instance_variable] = ACTIONS(7248),
    [sym_class_variable] = ACTIONS(7248),
    [sym_global_variable] = ACTIONS(7248),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4065),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(7246),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(7246),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(4067),
    [anon_sym_DASH_GT] = ACTIONS(4069),
  },
  [7106] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(9119),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(9119),
    [sym_operator_assignment] = STATE(9119),
    [sym_conditional] = STATE(9119),
    [sym_range] = STATE(9119),
    [sym_binary] = STATE(9119),
    [sym_unary] = STATE(9119),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [7107] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9120),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4495),
    [sym_scope_resolution] = STATE(4433),
    [sym_call] = STATE(4433),
    [sym_method_call] = STATE(4495),
    [sym_assignment] = STATE(9120),
    [sym_operator_assignment] = STATE(9120),
    [sym_conditional] = STATE(9120),
    [sym_range] = STATE(9120),
    [sym_binary] = STATE(9120),
    [sym_unary] = STATE(9120),
    [sym_left_assignment_list] = STATE(4494),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4495),
    [sym__variable] = STATE(4433),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4495),
    [sym_false] = STATE(4495),
    [sym_nil] = STATE(4495),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(4496),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(4005),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(4009),
    [sym__subshell_start] = ACTIONS(4011),
    [sym__regex_start] = ACTIONS(4013),
    [sym__string_array_start] = ACTIONS(4015),
    [sym__symbol_array_start] = ACTIONS(4017),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7336),
    [anon_sym_LBRACE] = ACTIONS(4021),
    [anon_sym_def] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4025),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(4027),
    [anon_sym_module] = ACTIONS(4029),
    [anon_sym_return] = ACTIONS(7338),
    [anon_sym_yield] = ACTIONS(7340),
    [anon_sym_break] = ACTIONS(7342),
    [anon_sym_next] = ACTIONS(7344),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(4039),
    [anon_sym_unless] = ACTIONS(4041),
    [anon_sym_while] = ACTIONS(4043),
    [anon_sym_until] = ACTIONS(4045),
    [anon_sym_for] = ACTIONS(4047),
    [anon_sym_case] = ACTIONS(4049),
    [anon_sym_begin] = ACTIONS(4051),
    [anon_sym_PLUS] = ACTIONS(7346),
    [anon_sym_defined_QMARK] = ACTIONS(7348),
    [anon_sym_not] = ACTIONS(7350),
    [anon_sym_BANG] = ACTIONS(7352),
    [anon_sym_TILDE] = ACTIONS(7352),
    [sym_constant] = ACTIONS(7246),
    [sym_identifier] = ACTIONS(7246),
    [sym_instance_variable] = ACTIONS(7248),
    [sym_class_variable] = ACTIONS(7248),
    [sym_global_variable] = ACTIONS(7248),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4065),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(7246),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(7246),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(4067),
    [anon_sym_DASH_GT] = ACTIONS(4069),
  },
  [7108] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9121),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4495),
    [sym_scope_resolution] = STATE(4433),
    [sym_call] = STATE(4433),
    [sym_method_call] = STATE(4495),
    [sym_assignment] = STATE(9121),
    [sym_operator_assignment] = STATE(9121),
    [sym_conditional] = STATE(9121),
    [sym_range] = STATE(9121),
    [sym_binary] = STATE(9121),
    [sym_unary] = STATE(9121),
    [sym_left_assignment_list] = STATE(4494),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4495),
    [sym__variable] = STATE(4433),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4495),
    [sym_false] = STATE(4495),
    [sym_nil] = STATE(4495),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(4496),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(4005),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(4009),
    [sym__subshell_start] = ACTIONS(4011),
    [sym__regex_start] = ACTIONS(4013),
    [sym__string_array_start] = ACTIONS(4015),
    [sym__symbol_array_start] = ACTIONS(4017),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7336),
    [anon_sym_LBRACE] = ACTIONS(4021),
    [anon_sym_def] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4025),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(4027),
    [anon_sym_module] = ACTIONS(4029),
    [anon_sym_return] = ACTIONS(7338),
    [anon_sym_yield] = ACTIONS(7340),
    [anon_sym_break] = ACTIONS(7342),
    [anon_sym_next] = ACTIONS(7344),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(4039),
    [anon_sym_unless] = ACTIONS(4041),
    [anon_sym_while] = ACTIONS(4043),
    [anon_sym_until] = ACTIONS(4045),
    [anon_sym_for] = ACTIONS(4047),
    [anon_sym_case] = ACTIONS(4049),
    [anon_sym_begin] = ACTIONS(4051),
    [anon_sym_PLUS] = ACTIONS(7346),
    [anon_sym_defined_QMARK] = ACTIONS(7348),
    [anon_sym_not] = ACTIONS(7350),
    [anon_sym_BANG] = ACTIONS(7352),
    [anon_sym_TILDE] = ACTIONS(7352),
    [sym_constant] = ACTIONS(7246),
    [sym_identifier] = ACTIONS(7246),
    [sym_instance_variable] = ACTIONS(7248),
    [sym_class_variable] = ACTIONS(7248),
    [sym_global_variable] = ACTIONS(7248),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4065),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(7246),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(7246),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(4067),
    [anon_sym_DASH_GT] = ACTIONS(4069),
  },
  [7109] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9122),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4495),
    [sym_scope_resolution] = STATE(4433),
    [sym_call] = STATE(4433),
    [sym_method_call] = STATE(4495),
    [sym_assignment] = STATE(9122),
    [sym_operator_assignment] = STATE(9122),
    [sym_conditional] = STATE(9122),
    [sym_range] = STATE(9122),
    [sym_binary] = STATE(9122),
    [sym_unary] = STATE(9122),
    [sym_left_assignment_list] = STATE(4494),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4495),
    [sym__variable] = STATE(4433),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4495),
    [sym_false] = STATE(4495),
    [sym_nil] = STATE(4495),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(4496),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(4005),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(4009),
    [sym__subshell_start] = ACTIONS(4011),
    [sym__regex_start] = ACTIONS(4013),
    [sym__string_array_start] = ACTIONS(4015),
    [sym__symbol_array_start] = ACTIONS(4017),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7336),
    [anon_sym_LBRACE] = ACTIONS(4021),
    [anon_sym_def] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4025),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(4027),
    [anon_sym_module] = ACTIONS(4029),
    [anon_sym_return] = ACTIONS(7338),
    [anon_sym_yield] = ACTIONS(7340),
    [anon_sym_break] = ACTIONS(7342),
    [anon_sym_next] = ACTIONS(7344),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(4039),
    [anon_sym_unless] = ACTIONS(4041),
    [anon_sym_while] = ACTIONS(4043),
    [anon_sym_until] = ACTIONS(4045),
    [anon_sym_for] = ACTIONS(4047),
    [anon_sym_case] = ACTIONS(4049),
    [anon_sym_begin] = ACTIONS(4051),
    [anon_sym_PLUS] = ACTIONS(7346),
    [anon_sym_defined_QMARK] = ACTIONS(7348),
    [anon_sym_not] = ACTIONS(7350),
    [anon_sym_BANG] = ACTIONS(7352),
    [anon_sym_TILDE] = ACTIONS(7352),
    [sym_constant] = ACTIONS(7246),
    [sym_identifier] = ACTIONS(7246),
    [sym_instance_variable] = ACTIONS(7248),
    [sym_class_variable] = ACTIONS(7248),
    [sym_global_variable] = ACTIONS(7248),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4065),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(7246),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(7246),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(4067),
    [anon_sym_DASH_GT] = ACTIONS(4069),
  },
  [7110] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9123),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4495),
    [sym_scope_resolution] = STATE(4433),
    [sym_call] = STATE(4433),
    [sym_method_call] = STATE(4495),
    [sym_assignment] = STATE(9123),
    [sym_operator_assignment] = STATE(9123),
    [sym_conditional] = STATE(9123),
    [sym_range] = STATE(9123),
    [sym_binary] = STATE(9123),
    [sym_unary] = STATE(9123),
    [sym_left_assignment_list] = STATE(4494),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4495),
    [sym__variable] = STATE(4433),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4495),
    [sym_false] = STATE(4495),
    [sym_nil] = STATE(4495),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(4496),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(4005),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(4009),
    [sym__subshell_start] = ACTIONS(4011),
    [sym__regex_start] = ACTIONS(4013),
    [sym__string_array_start] = ACTIONS(4015),
    [sym__symbol_array_start] = ACTIONS(4017),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7336),
    [anon_sym_LBRACE] = ACTIONS(4021),
    [anon_sym_def] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4025),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(4027),
    [anon_sym_module] = ACTIONS(4029),
    [anon_sym_return] = ACTIONS(7338),
    [anon_sym_yield] = ACTIONS(7340),
    [anon_sym_break] = ACTIONS(7342),
    [anon_sym_next] = ACTIONS(7344),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(4039),
    [anon_sym_unless] = ACTIONS(4041),
    [anon_sym_while] = ACTIONS(4043),
    [anon_sym_until] = ACTIONS(4045),
    [anon_sym_for] = ACTIONS(4047),
    [anon_sym_case] = ACTIONS(4049),
    [anon_sym_begin] = ACTIONS(4051),
    [anon_sym_PLUS] = ACTIONS(7346),
    [anon_sym_defined_QMARK] = ACTIONS(7348),
    [anon_sym_not] = ACTIONS(7350),
    [anon_sym_BANG] = ACTIONS(7352),
    [anon_sym_TILDE] = ACTIONS(7352),
    [sym_constant] = ACTIONS(7246),
    [sym_identifier] = ACTIONS(7246),
    [sym_instance_variable] = ACTIONS(7248),
    [sym_class_variable] = ACTIONS(7248),
    [sym_global_variable] = ACTIONS(7248),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4065),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(7246),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(7246),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(4067),
    [anon_sym_DASH_GT] = ACTIONS(4069),
  },
  [7111] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9124),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4495),
    [sym_scope_resolution] = STATE(4433),
    [sym_call] = STATE(4433),
    [sym_method_call] = STATE(4495),
    [sym_splat_argument] = STATE(9125),
    [sym_assignment] = STATE(9124),
    [sym_operator_assignment] = STATE(9124),
    [sym_conditional] = STATE(9124),
    [sym_range] = STATE(9124),
    [sym_binary] = STATE(9124),
    [sym_unary] = STATE(9124),
    [sym_right_assignment_list] = STATE(7346),
    [sym__arg_or_splat_arg] = STATE(9125),
    [sym_left_assignment_list] = STATE(4494),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4495),
    [sym__variable] = STATE(4433),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4495),
    [sym_false] = STATE(4495),
    [sym_nil] = STATE(4495),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(4496),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(4005),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(4009),
    [sym__subshell_start] = ACTIONS(4011),
    [sym__regex_start] = ACTIONS(4013),
    [sym__string_array_start] = ACTIONS(4015),
    [sym__symbol_array_start] = ACTIONS(4017),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(10694),
    [sym__unary_minus] = ACTIONS(7336),
    [anon_sym_LBRACE] = ACTIONS(4021),
    [anon_sym_def] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4025),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(4027),
    [anon_sym_module] = ACTIONS(4029),
    [anon_sym_return] = ACTIONS(7338),
    [anon_sym_yield] = ACTIONS(7340),
    [anon_sym_break] = ACTIONS(7342),
    [anon_sym_next] = ACTIONS(7344),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(4039),
    [anon_sym_unless] = ACTIONS(4041),
    [anon_sym_while] = ACTIONS(4043),
    [anon_sym_until] = ACTIONS(4045),
    [anon_sym_for] = ACTIONS(4047),
    [anon_sym_case] = ACTIONS(4049),
    [anon_sym_begin] = ACTIONS(4051),
    [anon_sym_PLUS] = ACTIONS(7346),
    [anon_sym_defined_QMARK] = ACTIONS(7348),
    [anon_sym_not] = ACTIONS(7350),
    [anon_sym_BANG] = ACTIONS(7352),
    [anon_sym_TILDE] = ACTIONS(7352),
    [sym_constant] = ACTIONS(7246),
    [sym_identifier] = ACTIONS(7246),
    [sym_instance_variable] = ACTIONS(7248),
    [sym_class_variable] = ACTIONS(7248),
    [sym_global_variable] = ACTIONS(7248),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4065),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(7246),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(7246),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(4067),
    [anon_sym_DASH_GT] = ACTIONS(4069),
  },
  [7112] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9126),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4495),
    [sym_scope_resolution] = STATE(4433),
    [sym_call] = STATE(4433),
    [sym_method_call] = STATE(4495),
    [sym_assignment] = STATE(9126),
    [sym_operator_assignment] = STATE(9126),
    [sym_conditional] = STATE(9126),
    [sym_range] = STATE(9126),
    [sym_binary] = STATE(9126),
    [sym_unary] = STATE(9126),
    [sym_left_assignment_list] = STATE(4494),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4495),
    [sym__variable] = STATE(4433),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4495),
    [sym_false] = STATE(4495),
    [sym_nil] = STATE(4495),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(4496),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(4005),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(4009),
    [sym__subshell_start] = ACTIONS(4011),
    [sym__regex_start] = ACTIONS(4013),
    [sym__string_array_start] = ACTIONS(4015),
    [sym__symbol_array_start] = ACTIONS(4017),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7336),
    [anon_sym_LBRACE] = ACTIONS(4021),
    [anon_sym_def] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4025),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(4027),
    [anon_sym_module] = ACTIONS(4029),
    [anon_sym_return] = ACTIONS(7338),
    [anon_sym_yield] = ACTIONS(7340),
    [anon_sym_break] = ACTIONS(7342),
    [anon_sym_next] = ACTIONS(7344),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(4039),
    [anon_sym_unless] = ACTIONS(4041),
    [anon_sym_while] = ACTIONS(4043),
    [anon_sym_until] = ACTIONS(4045),
    [anon_sym_for] = ACTIONS(4047),
    [anon_sym_case] = ACTIONS(4049),
    [anon_sym_begin] = ACTIONS(4051),
    [anon_sym_PLUS] = ACTIONS(7346),
    [anon_sym_defined_QMARK] = ACTIONS(7348),
    [anon_sym_not] = ACTIONS(7350),
    [anon_sym_BANG] = ACTIONS(7352),
    [anon_sym_TILDE] = ACTIONS(7352),
    [sym_constant] = ACTIONS(7246),
    [sym_identifier] = ACTIONS(7246),
    [sym_instance_variable] = ACTIONS(7248),
    [sym_class_variable] = ACTIONS(7248),
    [sym_global_variable] = ACTIONS(7248),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4065),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(7246),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(7246),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(4067),
    [anon_sym_DASH_GT] = ACTIONS(4069),
  },
  [7113] = {
    [sym_string] = STATE(9127),
    [aux_sym_chained_string_repeat1] = STATE(9127),
    [sym__string_start] = ACTIONS(4007),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_RPAREN] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_EQ] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [7114] = {
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(10700),
    [sym__binary_star] = ACTIONS(10702),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_RPAREN] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(10704),
    [anon_sym_STAR_STAR] = ACTIONS(10702),
    [anon_sym_AMP] = ACTIONS(10706),
    [anon_sym_EQ] = ACTIONS(7822),
    [anon_sym_LT] = ACTIONS(10708),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(10710),
    [anon_sym_DOT_DOT] = ACTIONS(10712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10714),
    [anon_sym_and] = ACTIONS(10716),
    [anon_sym_or] = ACTIONS(10716),
    [anon_sym_PIPE_PIPE] = ACTIONS(10718),
    [anon_sym_AMP_AMP] = ACTIONS(10718),
    [anon_sym_LT_LT] = ACTIONS(10720),
    [anon_sym_GT_GT] = ACTIONS(10720),
    [anon_sym_EQ_EQ] = ACTIONS(10722),
    [anon_sym_BANG_EQ] = ACTIONS(10718),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10718),
    [anon_sym_LT_EQ_GT] = ACTIONS(10718),
    [anon_sym_EQ_TILDE] = ACTIONS(10718),
    [anon_sym_BANG_TILDE] = ACTIONS(10718),
    [anon_sym_LT_EQ] = ACTIONS(10708),
    [anon_sym_GT] = ACTIONS(10708),
    [anon_sym_GT_EQ] = ACTIONS(10724),
    [anon_sym_CARET] = ACTIONS(10726),
    [anon_sym_PLUS] = ACTIONS(10700),
    [anon_sym_SLASH] = ACTIONS(10702),
    [anon_sym_PERCENT] = ACTIONS(10702),
    [sym_comment] = ACTIONS(87),
  },
  [7115] = {
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(7368),
    [sym__binary_star] = ACTIONS(7370),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_RPAREN] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(7372),
    [anon_sym_STAR_STAR] = ACTIONS(7370),
    [anon_sym_AMP] = ACTIONS(7374),
    [anon_sym_EQ] = ACTIONS(4217),
    [anon_sym_LT] = ACTIONS(7376),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_EQ_GT] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(7378),
    [anon_sym_DOT_DOT] = ACTIONS(7380),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7382),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(7386),
    [anon_sym_AMP_AMP] = ACTIONS(7386),
    [anon_sym_LT_LT] = ACTIONS(7388),
    [anon_sym_GT_GT] = ACTIONS(7388),
    [anon_sym_EQ_EQ] = ACTIONS(7390),
    [anon_sym_BANG_EQ] = ACTIONS(7386),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7386),
    [anon_sym_LT_EQ_GT] = ACTIONS(7386),
    [anon_sym_EQ_TILDE] = ACTIONS(7386),
    [anon_sym_BANG_TILDE] = ACTIONS(7386),
    [anon_sym_LT_EQ] = ACTIONS(7376),
    [anon_sym_GT] = ACTIONS(7376),
    [anon_sym_GT_EQ] = ACTIONS(7392),
    [anon_sym_CARET] = ACTIONS(7394),
    [anon_sym_PLUS] = ACTIONS(7368),
    [anon_sym_SLASH] = ACTIONS(7370),
    [anon_sym_PERCENT] = ACTIONS(7370),
    [sym_comment] = ACTIONS(87),
  },
  [7116] = {
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(7368),
    [sym__binary_star] = ACTIONS(7370),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_RPAREN] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(7372),
    [anon_sym_STAR_STAR] = ACTIONS(7370),
    [anon_sym_AMP] = ACTIONS(7374),
    [anon_sym_EQ] = ACTIONS(4249),
    [anon_sym_LT] = ACTIONS(7376),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_EQ_GT] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(7378),
    [anon_sym_DOT_DOT] = ACTIONS(7380),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7382),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(7386),
    [anon_sym_AMP_AMP] = ACTIONS(7386),
    [anon_sym_LT_LT] = ACTIONS(7388),
    [anon_sym_GT_GT] = ACTIONS(7388),
    [anon_sym_EQ_EQ] = ACTIONS(7390),
    [anon_sym_BANG_EQ] = ACTIONS(7386),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7386),
    [anon_sym_LT_EQ_GT] = ACTIONS(7386),
    [anon_sym_EQ_TILDE] = ACTIONS(7386),
    [anon_sym_BANG_TILDE] = ACTIONS(7386),
    [anon_sym_LT_EQ] = ACTIONS(7376),
    [anon_sym_GT] = ACTIONS(7376),
    [anon_sym_GT_EQ] = ACTIONS(7392),
    [anon_sym_CARET] = ACTIONS(7394),
    [anon_sym_PLUS] = ACTIONS(7368),
    [anon_sym_SLASH] = ACTIONS(7370),
    [anon_sym_PERCENT] = ACTIONS(7370),
    [sym_comment] = ACTIONS(87),
  },
  [7117] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(9128),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2125),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2125),
    [sym_assignment] = STATE(9128),
    [sym_operator_assignment] = STATE(9128),
    [sym_conditional] = STATE(9128),
    [sym_range] = STATE(9128),
    [sym_binary] = STATE(9128),
    [sym_unary] = STATE(9128),
    [sym_left_assignment_list] = STATE(2124),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2125),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2125),
    [sym_false] = STATE(2125),
    [sym_nil] = STATE(2125),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4499),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3705),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3713),
    [anon_sym_break] = ACTIONS(3715),
    [anon_sym_next] = ACTIONS(3717),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3719),
    [anon_sym_defined_QMARK] = ACTIONS(3721),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [sym_constant] = ACTIONS(3667),
    [sym_identifier] = ACTIONS(3667),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7118] = {
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(7368),
    [sym__binary_star] = ACTIONS(7370),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_RPAREN] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(7372),
    [anon_sym_STAR_STAR] = ACTIONS(7370),
    [anon_sym_AMP] = ACTIONS(7374),
    [anon_sym_EQ] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(7376),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_EQ_GT] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(7378),
    [anon_sym_DOT_DOT] = ACTIONS(7380),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7382),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(7386),
    [anon_sym_AMP_AMP] = ACTIONS(7386),
    [anon_sym_LT_LT] = ACTIONS(7388),
    [anon_sym_GT_GT] = ACTIONS(7388),
    [anon_sym_EQ_EQ] = ACTIONS(7390),
    [anon_sym_BANG_EQ] = ACTIONS(7386),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7386),
    [anon_sym_LT_EQ_GT] = ACTIONS(7386),
    [anon_sym_EQ_TILDE] = ACTIONS(7386),
    [anon_sym_BANG_TILDE] = ACTIONS(7386),
    [anon_sym_LT_EQ] = ACTIONS(7376),
    [anon_sym_GT] = ACTIONS(7376),
    [anon_sym_GT_EQ] = ACTIONS(7392),
    [anon_sym_CARET] = ACTIONS(7394),
    [anon_sym_PLUS] = ACTIONS(7368),
    [anon_sym_SLASH] = ACTIONS(7370),
    [anon_sym_PERCENT] = ACTIONS(7370),
    [sym_comment] = ACTIONS(87),
  },
  [7119] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(9129),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2125),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2125),
    [sym_assignment] = STATE(9129),
    [sym_operator_assignment] = STATE(9129),
    [sym_conditional] = STATE(9129),
    [sym_range] = STATE(9129),
    [sym_binary] = STATE(9129),
    [sym_unary] = STATE(9129),
    [sym_left_assignment_list] = STATE(2124),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2125),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2125),
    [sym_false] = STATE(2125),
    [sym_nil] = STATE(2125),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4499),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3705),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3713),
    [anon_sym_break] = ACTIONS(3715),
    [anon_sym_next] = ACTIONS(3717),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3719),
    [anon_sym_defined_QMARK] = ACTIONS(3721),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [sym_constant] = ACTIONS(3667),
    [sym_identifier] = ACTIONS(3667),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7120] = {
    [sym_heredoc_body] = STATE(9130),
    [aux_sym_call_repeat1] = STATE(9130),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_RPAREN] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [7121] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4507),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2125),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2125),
    [sym__argument] = STATE(4250),
    [sym_splat_argument] = STATE(4250),
    [sym_hash_splat_argument] = STATE(4250),
    [sym_block_argument] = STATE(4250),
    [sym_assignment] = STATE(4507),
    [sym_operator_assignment] = STATE(4507),
    [sym_conditional] = STATE(4507),
    [sym_range] = STATE(4507),
    [sym_binary] = STATE(4507),
    [sym_unary] = STATE(4507),
    [sym_left_assignment_list] = STATE(2124),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2125),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2125),
    [sym_false] = STATE(2125),
    [sym_nil] = STATE(2125),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4510),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_heredoc_body] = STATE(9131),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(4250),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(7356),
    [sym__splat_star] = ACTIONS(7358),
    [sym__unary_minus] = ACTIONS(3705),
    [sym__identifier_hash_key] = ACTIONS(7360),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12696),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3713),
    [anon_sym_break] = ACTIONS(3715),
    [anon_sym_next] = ACTIONS(3717),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3719),
    [anon_sym_defined_QMARK] = ACTIONS(3721),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [sym_constant] = ACTIONS(7364),
    [sym_identifier] = ACTIONS(7364),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7122] = {
    [sym_heredoc_body] = STATE(9132),
    [aux_sym_call_repeat1] = STATE(9132),
    [aux_sym_argument_list_repeat1] = STATE(9133),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_RPAREN] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(10738),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [7123] = {
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(10700),
    [sym__binary_star] = ACTIONS(10702),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_RPAREN] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(10704),
    [anon_sym_STAR_STAR] = ACTIONS(10702),
    [anon_sym_AMP] = ACTIONS(10706),
    [anon_sym_EQ] = ACTIONS(7884),
    [anon_sym_LT] = ACTIONS(10708),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(10710),
    [anon_sym_DOT_DOT] = ACTIONS(10712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10714),
    [anon_sym_and] = ACTIONS(10716),
    [anon_sym_or] = ACTIONS(10716),
    [anon_sym_PIPE_PIPE] = ACTIONS(10718),
    [anon_sym_AMP_AMP] = ACTIONS(10718),
    [anon_sym_LT_LT] = ACTIONS(10720),
    [anon_sym_GT_GT] = ACTIONS(10720),
    [anon_sym_EQ_EQ] = ACTIONS(10722),
    [anon_sym_BANG_EQ] = ACTIONS(10718),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10718),
    [anon_sym_LT_EQ_GT] = ACTIONS(10718),
    [anon_sym_EQ_TILDE] = ACTIONS(10718),
    [anon_sym_BANG_TILDE] = ACTIONS(10718),
    [anon_sym_LT_EQ] = ACTIONS(10708),
    [anon_sym_GT] = ACTIONS(10708),
    [anon_sym_GT_EQ] = ACTIONS(10724),
    [anon_sym_CARET] = ACTIONS(10726),
    [anon_sym_PLUS] = ACTIONS(10700),
    [anon_sym_SLASH] = ACTIONS(10702),
    [anon_sym_PERCENT] = ACTIONS(10702),
    [sym_comment] = ACTIONS(87),
  },
  [7124] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(7370),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(7370),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(7370),
    [anon_sym_PERCENT] = ACTIONS(7370),
    [sym_comment] = ACTIONS(87),
  },
  [7125] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(7370),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [7126] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7368),
    [sym__binary_star] = ACTIONS(7370),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(7370),
    [anon_sym_AMP] = ACTIONS(7374),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(7388),
    [anon_sym_GT_GT] = ACTIONS(7388),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(7368),
    [anon_sym_SLASH] = ACTIONS(7370),
    [anon_sym_PERCENT] = ACTIONS(7370),
    [sym_comment] = ACTIONS(87),
  },
  [7127] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7368),
    [sym__binary_star] = ACTIONS(7370),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(7370),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(7388),
    [anon_sym_GT_GT] = ACTIONS(7388),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(7368),
    [anon_sym_SLASH] = ACTIONS(7370),
    [anon_sym_PERCENT] = ACTIONS(7370),
    [sym_comment] = ACTIONS(87),
  },
  [7128] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7368),
    [sym__binary_star] = ACTIONS(7370),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(7372),
    [anon_sym_STAR_STAR] = ACTIONS(7370),
    [anon_sym_AMP] = ACTIONS(7374),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(7388),
    [anon_sym_GT_GT] = ACTIONS(7388),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(7394),
    [anon_sym_PLUS] = ACTIONS(7368),
    [anon_sym_SLASH] = ACTIONS(7370),
    [anon_sym_PERCENT] = ACTIONS(7370),
    [sym_comment] = ACTIONS(87),
  },
  [7129] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(12698),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [7130] = {
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(7368),
    [sym__binary_star] = ACTIONS(7370),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_RPAREN] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(7372),
    [anon_sym_STAR_STAR] = ACTIONS(7370),
    [anon_sym_AMP] = ACTIONS(7374),
    [anon_sym_EQ] = ACTIONS(7888),
    [anon_sym_LT] = ACTIONS(7376),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_EQ_GT] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(7380),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7382),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(7386),
    [anon_sym_AMP_AMP] = ACTIONS(7386),
    [anon_sym_LT_LT] = ACTIONS(7388),
    [anon_sym_GT_GT] = ACTIONS(7388),
    [anon_sym_EQ_EQ] = ACTIONS(7390),
    [anon_sym_BANG_EQ] = ACTIONS(7386),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7386),
    [anon_sym_LT_EQ_GT] = ACTIONS(7386),
    [anon_sym_EQ_TILDE] = ACTIONS(7386),
    [anon_sym_BANG_TILDE] = ACTIONS(7386),
    [anon_sym_LT_EQ] = ACTIONS(7376),
    [anon_sym_GT] = ACTIONS(7376),
    [anon_sym_GT_EQ] = ACTIONS(7392),
    [anon_sym_CARET] = ACTIONS(7394),
    [anon_sym_PLUS] = ACTIONS(7368),
    [anon_sym_SLASH] = ACTIONS(7370),
    [anon_sym_PERCENT] = ACTIONS(7370),
    [sym_comment] = ACTIONS(87),
  },
  [7131] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7368),
    [sym__binary_star] = ACTIONS(7370),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(7372),
    [anon_sym_STAR_STAR] = ACTIONS(7370),
    [anon_sym_AMP] = ACTIONS(7374),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(7376),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(7378),
    [anon_sym_DOT_DOT] = ACTIONS(7380),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7382),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(7386),
    [anon_sym_AMP_AMP] = ACTIONS(7386),
    [anon_sym_LT_LT] = ACTIONS(7388),
    [anon_sym_GT_GT] = ACTIONS(7388),
    [anon_sym_EQ_EQ] = ACTIONS(7390),
    [anon_sym_BANG_EQ] = ACTIONS(7386),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7386),
    [anon_sym_LT_EQ_GT] = ACTIONS(7386),
    [anon_sym_EQ_TILDE] = ACTIONS(7386),
    [anon_sym_BANG_TILDE] = ACTIONS(7386),
    [anon_sym_LT_EQ] = ACTIONS(7376),
    [anon_sym_GT] = ACTIONS(7376),
    [anon_sym_GT_EQ] = ACTIONS(7392),
    [anon_sym_CARET] = ACTIONS(7394),
    [anon_sym_PLUS] = ACTIONS(7368),
    [anon_sym_SLASH] = ACTIONS(7370),
    [anon_sym_PERCENT] = ACTIONS(7370),
    [sym_comment] = ACTIONS(87),
  },
  [7132] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7368),
    [sym__binary_star] = ACTIONS(7370),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(7372),
    [anon_sym_STAR_STAR] = ACTIONS(7370),
    [anon_sym_AMP] = ACTIONS(7374),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(7376),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(7388),
    [anon_sym_GT_GT] = ACTIONS(7388),
    [anon_sym_EQ_EQ] = ACTIONS(7390),
    [anon_sym_BANG_EQ] = ACTIONS(7386),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7386),
    [anon_sym_LT_EQ_GT] = ACTIONS(7386),
    [anon_sym_EQ_TILDE] = ACTIONS(7386),
    [anon_sym_BANG_TILDE] = ACTIONS(7386),
    [anon_sym_LT_EQ] = ACTIONS(7376),
    [anon_sym_GT] = ACTIONS(7376),
    [anon_sym_GT_EQ] = ACTIONS(7392),
    [anon_sym_CARET] = ACTIONS(7394),
    [anon_sym_PLUS] = ACTIONS(7368),
    [anon_sym_SLASH] = ACTIONS(7370),
    [anon_sym_PERCENT] = ACTIONS(7370),
    [sym_comment] = ACTIONS(87),
  },
  [7133] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7368),
    [sym__binary_star] = ACTIONS(7370),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(7370),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(7368),
    [anon_sym_SLASH] = ACTIONS(7370),
    [anon_sym_PERCENT] = ACTIONS(7370),
    [sym_comment] = ACTIONS(87),
  },
  [7134] = {
    [sym_heredoc_body] = STATE(7134),
    [aux_sym_call_repeat1] = STATE(7134),
    [sym__heredoc_body_start] = ACTIONS(10810),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_RPAREN] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7914),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_EQ] = ACTIONS(7914),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [7135] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(2121),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2125),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2125),
    [sym__argument] = STATE(6088),
    [sym_splat_argument] = STATE(6088),
    [sym_hash_splat_argument] = STATE(6088),
    [sym_block_argument] = STATE(6088),
    [sym_assignment] = STATE(2121),
    [sym_operator_assignment] = STATE(2121),
    [sym_conditional] = STATE(2121),
    [sym_range] = STATE(2121),
    [sym_binary] = STATE(2121),
    [sym_unary] = STATE(2121),
    [sym_left_assignment_list] = STATE(2124),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2125),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2125),
    [sym_false] = STATE(2125),
    [sym_nil] = STATE(2125),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2126),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(6088),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(3701),
    [sym__splat_star] = ACTIONS(3703),
    [sym__unary_minus] = ACTIONS(3705),
    [sym__identifier_hash_key] = ACTIONS(3707),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(3709),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3713),
    [anon_sym_break] = ACTIONS(3715),
    [anon_sym_next] = ACTIONS(3717),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3719),
    [anon_sym_defined_QMARK] = ACTIONS(3721),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [sym_constant] = ACTIONS(3727),
    [sym_identifier] = ACTIONS(3727),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7136] = {
    [sym_heredoc_body] = STATE(7134),
    [aux_sym_call_repeat1] = STATE(7134),
    [sym__heredoc_body_start] = ACTIONS(3959),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_RPAREN] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7929),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_EQ] = ACTIONS(7929),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [7137] = {
    [aux_sym_argument_list_repeat1] = STATE(7137),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_RPAREN] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7925),
    [anon_sym_COMMA] = ACTIONS(12700),
    [anon_sym_EQ] = ACTIONS(7925),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [7138] = {
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(7368),
    [sym__binary_star] = ACTIONS(7370),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_RPAREN] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(7372),
    [anon_sym_STAR_STAR] = ACTIONS(7370),
    [anon_sym_AMP] = ACTIONS(7374),
    [anon_sym_EQ] = ACTIONS(7936),
    [anon_sym_LT] = ACTIONS(7376),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_EQ_GT] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(7378),
    [anon_sym_DOT_DOT] = ACTIONS(7380),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7382),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7386),
    [anon_sym_AMP_AMP] = ACTIONS(7386),
    [anon_sym_LT_LT] = ACTIONS(7388),
    [anon_sym_GT_GT] = ACTIONS(7388),
    [anon_sym_EQ_EQ] = ACTIONS(7390),
    [anon_sym_BANG_EQ] = ACTIONS(7386),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7386),
    [anon_sym_LT_EQ_GT] = ACTIONS(7386),
    [anon_sym_EQ_TILDE] = ACTIONS(7386),
    [anon_sym_BANG_TILDE] = ACTIONS(7386),
    [anon_sym_LT_EQ] = ACTIONS(7376),
    [anon_sym_GT] = ACTIONS(7376),
    [anon_sym_GT_EQ] = ACTIONS(7392),
    [anon_sym_CARET] = ACTIONS(7394),
    [anon_sym_PLUS] = ACTIONS(7368),
    [anon_sym_SLASH] = ACTIONS(7370),
    [anon_sym_PERCENT] = ACTIONS(7370),
    [sym_comment] = ACTIONS(87),
  },
  [7139] = {
    [aux_sym_exceptions_repeat1] = STATE(9136),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_RPAREN] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [7140] = {
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(7368),
    [sym__binary_star] = ACTIONS(7370),
    [anon_sym_LBRACE] = ACTIONS(6210),
    [anon_sym_RPAREN] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(7372),
    [anon_sym_STAR_STAR] = ACTIONS(7370),
    [anon_sym_AMP] = ACTIONS(7374),
    [anon_sym_EQ] = ACTIONS(7938),
    [anon_sym_LT] = ACTIONS(7376),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_EQ_GT] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(7378),
    [anon_sym_DOT_DOT] = ACTIONS(7380),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7382),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(7386),
    [anon_sym_AMP_AMP] = ACTIONS(7386),
    [anon_sym_LT_LT] = ACTIONS(7388),
    [anon_sym_GT_GT] = ACTIONS(7388),
    [anon_sym_EQ_EQ] = ACTIONS(7390),
    [anon_sym_BANG_EQ] = ACTIONS(7386),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7386),
    [anon_sym_LT_EQ_GT] = ACTIONS(7386),
    [anon_sym_EQ_TILDE] = ACTIONS(7386),
    [anon_sym_BANG_TILDE] = ACTIONS(7386),
    [anon_sym_LT_EQ] = ACTIONS(7376),
    [anon_sym_GT] = ACTIONS(7376),
    [anon_sym_GT_EQ] = ACTIONS(7392),
    [anon_sym_CARET] = ACTIONS(7394),
    [anon_sym_PLUS] = ACTIONS(7368),
    [anon_sym_SLASH] = ACTIONS(7370),
    [anon_sym_PERCENT] = ACTIONS(7370),
    [sym_comment] = ACTIONS(87),
  },
  [7141] = {
    [sym_string] = STATE(7141),
    [aux_sym_chained_string_repeat1] = STATE(7141),
    [sym__string_start] = ACTIONS(9407),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_RPAREN] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_EQ] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_do] = ACTIONS(6212),
    [anon_sym_EQ_GT] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [7142] = {
    [sym_heredoc_body] = STATE(9137),
    [aux_sym_call_repeat1] = STATE(9137),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_RPAREN] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [7143] = {
    [sym_heredoc_body] = STATE(9138),
    [aux_sym_call_repeat1] = STATE(9138),
    [aux_sym_argument_list_repeat1] = STATE(4577),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_RPAREN] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(3795),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [7144] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(7408),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(7408),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(7408),
    [anon_sym_PERCENT] = ACTIONS(7408),
    [sym_comment] = ACTIONS(87),
  },
  [7145] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(7408),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [7146] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7406),
    [sym__binary_star] = ACTIONS(7408),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(7408),
    [anon_sym_AMP] = ACTIONS(7412),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(7424),
    [anon_sym_GT_GT] = ACTIONS(7424),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(7406),
    [anon_sym_SLASH] = ACTIONS(7408),
    [anon_sym_PERCENT] = ACTIONS(7408),
    [sym_comment] = ACTIONS(87),
  },
  [7147] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7406),
    [sym__binary_star] = ACTIONS(7408),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(7408),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(7424),
    [anon_sym_GT_GT] = ACTIONS(7424),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(7406),
    [anon_sym_SLASH] = ACTIONS(7408),
    [anon_sym_PERCENT] = ACTIONS(7408),
    [sym_comment] = ACTIONS(87),
  },
  [7148] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7406),
    [sym__binary_star] = ACTIONS(7408),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(7410),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(7408),
    [anon_sym_AMP] = ACTIONS(7412),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(7424),
    [anon_sym_GT_GT] = ACTIONS(7424),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(7430),
    [anon_sym_PLUS] = ACTIONS(7406),
    [anon_sym_SLASH] = ACTIONS(7408),
    [anon_sym_PERCENT] = ACTIONS(7408),
    [sym_comment] = ACTIONS(87),
  },
  [7149] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(12703),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [7150] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(7406),
    [sym__binary_star] = ACTIONS(7408),
    [anon_sym_RPAREN] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(7410),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(7408),
    [anon_sym_AMP] = ACTIONS(7412),
    [anon_sym_LT] = ACTIONS(7414),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(7418),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7420),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(7422),
    [anon_sym_AMP_AMP] = ACTIONS(7422),
    [anon_sym_LT_LT] = ACTIONS(7424),
    [anon_sym_GT_GT] = ACTIONS(7424),
    [anon_sym_EQ_EQ] = ACTIONS(7426),
    [anon_sym_BANG_EQ] = ACTIONS(7422),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7422),
    [anon_sym_LT_EQ_GT] = ACTIONS(7422),
    [anon_sym_EQ_TILDE] = ACTIONS(7422),
    [anon_sym_BANG_TILDE] = ACTIONS(7422),
    [anon_sym_LT_EQ] = ACTIONS(7414),
    [anon_sym_GT] = ACTIONS(7414),
    [anon_sym_GT_EQ] = ACTIONS(7428),
    [anon_sym_CARET] = ACTIONS(7430),
    [anon_sym_PLUS] = ACTIONS(7406),
    [anon_sym_SLASH] = ACTIONS(7408),
    [anon_sym_PERCENT] = ACTIONS(7408),
    [sym_comment] = ACTIONS(87),
  },
  [7151] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7406),
    [sym__binary_star] = ACTIONS(7408),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(7410),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(7408),
    [anon_sym_AMP] = ACTIONS(7412),
    [anon_sym_LT] = ACTIONS(7414),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(7416),
    [anon_sym_DOT_DOT] = ACTIONS(7418),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7420),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(7422),
    [anon_sym_AMP_AMP] = ACTIONS(7422),
    [anon_sym_LT_LT] = ACTIONS(7424),
    [anon_sym_GT_GT] = ACTIONS(7424),
    [anon_sym_EQ_EQ] = ACTIONS(7426),
    [anon_sym_BANG_EQ] = ACTIONS(7422),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7422),
    [anon_sym_LT_EQ_GT] = ACTIONS(7422),
    [anon_sym_EQ_TILDE] = ACTIONS(7422),
    [anon_sym_BANG_TILDE] = ACTIONS(7422),
    [anon_sym_LT_EQ] = ACTIONS(7414),
    [anon_sym_GT] = ACTIONS(7414),
    [anon_sym_GT_EQ] = ACTIONS(7428),
    [anon_sym_CARET] = ACTIONS(7430),
    [anon_sym_PLUS] = ACTIONS(7406),
    [anon_sym_SLASH] = ACTIONS(7408),
    [anon_sym_PERCENT] = ACTIONS(7408),
    [sym_comment] = ACTIONS(87),
  },
  [7152] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7406),
    [sym__binary_star] = ACTIONS(7408),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(7410),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(7408),
    [anon_sym_AMP] = ACTIONS(7412),
    [anon_sym_LT] = ACTIONS(7414),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(7424),
    [anon_sym_GT_GT] = ACTIONS(7424),
    [anon_sym_EQ_EQ] = ACTIONS(7426),
    [anon_sym_BANG_EQ] = ACTIONS(7422),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7422),
    [anon_sym_LT_EQ_GT] = ACTIONS(7422),
    [anon_sym_EQ_TILDE] = ACTIONS(7422),
    [anon_sym_BANG_TILDE] = ACTIONS(7422),
    [anon_sym_LT_EQ] = ACTIONS(7414),
    [anon_sym_GT] = ACTIONS(7414),
    [anon_sym_GT_EQ] = ACTIONS(7428),
    [anon_sym_CARET] = ACTIONS(7430),
    [anon_sym_PLUS] = ACTIONS(7406),
    [anon_sym_SLASH] = ACTIONS(7408),
    [anon_sym_PERCENT] = ACTIONS(7408),
    [sym_comment] = ACTIONS(87),
  },
  [7153] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7406),
    [sym__binary_star] = ACTIONS(7408),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(7408),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(7406),
    [anon_sym_SLASH] = ACTIONS(7408),
    [anon_sym_PERCENT] = ACTIONS(7408),
    [sym_comment] = ACTIONS(87),
  },
  [7154] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(7406),
    [sym__binary_star] = ACTIONS(7408),
    [anon_sym_RPAREN] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(7410),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(7408),
    [anon_sym_AMP] = ACTIONS(7412),
    [anon_sym_LT] = ACTIONS(7414),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(7416),
    [anon_sym_DOT_DOT] = ACTIONS(7418),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7420),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7422),
    [anon_sym_AMP_AMP] = ACTIONS(7422),
    [anon_sym_LT_LT] = ACTIONS(7424),
    [anon_sym_GT_GT] = ACTIONS(7424),
    [anon_sym_EQ_EQ] = ACTIONS(7426),
    [anon_sym_BANG_EQ] = ACTIONS(7422),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7422),
    [anon_sym_LT_EQ_GT] = ACTIONS(7422),
    [anon_sym_EQ_TILDE] = ACTIONS(7422),
    [anon_sym_BANG_TILDE] = ACTIONS(7422),
    [anon_sym_LT_EQ] = ACTIONS(7414),
    [anon_sym_GT] = ACTIONS(7414),
    [anon_sym_GT_EQ] = ACTIONS(7428),
    [anon_sym_CARET] = ACTIONS(7430),
    [anon_sym_PLUS] = ACTIONS(7406),
    [anon_sym_SLASH] = ACTIONS(7408),
    [anon_sym_PERCENT] = ACTIONS(7408),
    [sym_comment] = ACTIONS(87),
  },
  [7155] = {
    [aux_sym_exceptions_repeat1] = STATE(9141),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_RPAREN] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [7156] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(7406),
    [sym__binary_star] = ACTIONS(7408),
    [anon_sym_RPAREN] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(7410),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(7408),
    [anon_sym_AMP] = ACTIONS(7412),
    [anon_sym_LT] = ACTIONS(7414),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(7416),
    [anon_sym_DOT_DOT] = ACTIONS(7418),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7420),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(7422),
    [anon_sym_AMP_AMP] = ACTIONS(7422),
    [anon_sym_LT_LT] = ACTIONS(7424),
    [anon_sym_GT_GT] = ACTIONS(7424),
    [anon_sym_EQ_EQ] = ACTIONS(7426),
    [anon_sym_BANG_EQ] = ACTIONS(7422),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7422),
    [anon_sym_LT_EQ_GT] = ACTIONS(7422),
    [anon_sym_EQ_TILDE] = ACTIONS(7422),
    [anon_sym_BANG_TILDE] = ACTIONS(7422),
    [anon_sym_LT_EQ] = ACTIONS(7414),
    [anon_sym_GT] = ACTIONS(7414),
    [anon_sym_GT_EQ] = ACTIONS(7428),
    [anon_sym_CARET] = ACTIONS(7430),
    [anon_sym_PLUS] = ACTIONS(7406),
    [anon_sym_SLASH] = ACTIONS(7408),
    [anon_sym_PERCENT] = ACTIONS(7408),
    [sym_comment] = ACTIONS(87),
  },
  [7157] = {
    [sym_string] = STATE(7157),
    [aux_sym_chained_string_repeat1] = STATE(7157),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(6214),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_RPAREN] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [7158] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(3761),
    [sym__binary_star] = ACTIONS(3763),
    [anon_sym_RPAREN] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(3765),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(3763),
    [anon_sym_AMP] = ACTIONS(3767),
    [anon_sym_LT] = ACTIONS(3769),
    [anon_sym_if] = ACTIONS(6823),
    [anon_sym_unless] = ACTIONS(6823),
    [anon_sym_while] = ACTIONS(6823),
    [anon_sym_until] = ACTIONS(6823),
    [anon_sym_rescue] = ACTIONS(6823),
    [anon_sym_EQ_GT] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(3771),
    [anon_sym_DOT_DOT] = ACTIONS(3773),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3775),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(3777),
    [anon_sym_AMP_AMP] = ACTIONS(3777),
    [anon_sym_LT_LT] = ACTIONS(3779),
    [anon_sym_GT_GT] = ACTIONS(3779),
    [anon_sym_EQ_EQ] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3777),
    [anon_sym_LT_EQ_GT] = ACTIONS(3777),
    [anon_sym_EQ_TILDE] = ACTIONS(3777),
    [anon_sym_BANG_TILDE] = ACTIONS(3777),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3783),
    [anon_sym_CARET] = ACTIONS(3785),
    [anon_sym_PLUS] = ACTIONS(3761),
    [anon_sym_SLASH] = ACTIONS(3763),
    [anon_sym_PERCENT] = ACTIONS(3763),
    [sym_comment] = ACTIONS(87),
  },
  [7159] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(3761),
    [sym__binary_star] = ACTIONS(3763),
    [anon_sym_RPAREN] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(3765),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(3763),
    [anon_sym_AMP] = ACTIONS(3767),
    [anon_sym_LT] = ACTIONS(3769),
    [anon_sym_if] = ACTIONS(7027),
    [anon_sym_unless] = ACTIONS(7027),
    [anon_sym_while] = ACTIONS(7027),
    [anon_sym_until] = ACTIONS(7027),
    [anon_sym_rescue] = ACTIONS(7027),
    [anon_sym_EQ_GT] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(3771),
    [anon_sym_DOT_DOT] = ACTIONS(3773),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3775),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(3777),
    [anon_sym_AMP_AMP] = ACTIONS(3777),
    [anon_sym_LT_LT] = ACTIONS(3779),
    [anon_sym_GT_GT] = ACTIONS(3779),
    [anon_sym_EQ_EQ] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3777),
    [anon_sym_LT_EQ_GT] = ACTIONS(3777),
    [anon_sym_EQ_TILDE] = ACTIONS(3777),
    [anon_sym_BANG_TILDE] = ACTIONS(3777),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3783),
    [anon_sym_CARET] = ACTIONS(3785),
    [anon_sym_PLUS] = ACTIONS(3761),
    [anon_sym_SLASH] = ACTIONS(3763),
    [anon_sym_PERCENT] = ACTIONS(3763),
    [sym_comment] = ACTIONS(87),
  },
  [7160] = {
    [sym_heredoc_body] = STATE(7160),
    [aux_sym_call_repeat1] = STATE(7160),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(7916),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_RPAREN] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_EQ_GT] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [7161] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2148),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(705),
    [sym_scope_resolution] = STATE(701),
    [sym_call] = STATE(701),
    [sym_method_call] = STATE(705),
    [sym__argument] = STATE(4986),
    [sym_splat_argument] = STATE(4986),
    [sym_hash_splat_argument] = STATE(4986),
    [sym_block_argument] = STATE(4986),
    [sym_assignment] = STATE(2148),
    [sym_operator_assignment] = STATE(2148),
    [sym_conditional] = STATE(2148),
    [sym_range] = STATE(2148),
    [sym_binary] = STATE(2148),
    [sym_unary] = STATE(2148),
    [sym_left_assignment_list] = STATE(704),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(705),
    [sym__variable] = STATE(701),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(705),
    [sym_false] = STATE(705),
    [sym_nil] = STATE(705),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2151),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4986),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(3751),
    [sym__splat_star] = ACTIONS(3753),
    [sym__unary_minus] = ACTIONS(1303),
    [sym__identifier_hash_key] = ACTIONS(3755),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10742),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3747),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(3757),
    [sym_identifier] = ACTIONS(3757),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7162] = {
    [sym_heredoc_body] = STATE(7160),
    [aux_sym_call_repeat1] = STATE(7160),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_RPAREN] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_EQ_GT] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [7163] = {
    [aux_sym_argument_list_repeat1] = STATE(7163),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_RPAREN] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(12705),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7925),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_if] = ACTIONS(7925),
    [anon_sym_unless] = ACTIONS(7925),
    [anon_sym_while] = ACTIONS(7925),
    [anon_sym_until] = ACTIONS(7925),
    [anon_sym_rescue] = ACTIONS(7925),
    [anon_sym_EQ_GT] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7925),
    [anon_sym_AMP_AMP] = ACTIONS(7925),
    [anon_sym_LT_LT] = ACTIONS(7925),
    [anon_sym_GT_GT] = ACTIONS(7925),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7925),
    [anon_sym_PLUS] = ACTIONS(7925),
    [anon_sym_SLASH] = ACTIONS(7925),
    [anon_sym_PERCENT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [7164] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9142),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(705),
    [sym_scope_resolution] = STATE(701),
    [sym_call] = STATE(701),
    [sym_method_call] = STATE(705),
    [sym_assignment] = STATE(9142),
    [sym_operator_assignment] = STATE(9142),
    [sym_conditional] = STATE(9142),
    [sym_range] = STATE(9142),
    [sym_binary] = STATE(9142),
    [sym_unary] = STATE(9142),
    [sym_left_assignment_list] = STATE(704),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(705),
    [sym__variable] = STATE(701),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(705),
    [sym_false] = STATE(705),
    [sym_nil] = STATE(705),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2140),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3747),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7165] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(3837),
    [sym__binary_star] = ACTIONS(3839),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_RPAREN] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(3841),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(3843),
    [anon_sym_AMP] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(7822),
    [anon_sym_LT] = ACTIONS(3847),
    [anon_sym_if] = ACTIONS(6823),
    [anon_sym_unless] = ACTIONS(6823),
    [anon_sym_while] = ACTIONS(6823),
    [anon_sym_until] = ACTIONS(6823),
    [anon_sym_rescue] = ACTIONS(6823),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_EQ_GT] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_PLUS_EQ] = ACTIONS(6823),
    [anon_sym_DASH_EQ] = ACTIONS(6823),
    [anon_sym_STAR_EQ] = ACTIONS(6823),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6823),
    [anon_sym_SLASH_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6823),
    [anon_sym_AMP_EQ] = ACTIONS(6823),
    [anon_sym_PERCENT_EQ] = ACTIONS(6823),
    [anon_sym_GT_GT_EQ] = ACTIONS(6823),
    [anon_sym_LT_LT_EQ] = ACTIONS(6823),
    [anon_sym_CARET_EQ] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(3849),
    [anon_sym_DOT_DOT] = ACTIONS(3851),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3853),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(3855),
    [anon_sym_AMP_AMP] = ACTIONS(3855),
    [anon_sym_LT_LT] = ACTIONS(3857),
    [anon_sym_GT_GT] = ACTIONS(3857),
    [anon_sym_EQ_EQ] = ACTIONS(3855),
    [anon_sym_BANG_EQ] = ACTIONS(3859),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3859),
    [anon_sym_LT_EQ_GT] = ACTIONS(3859),
    [anon_sym_EQ_TILDE] = ACTIONS(3859),
    [anon_sym_BANG_TILDE] = ACTIONS(3859),
    [anon_sym_LT_EQ] = ACTIONS(3847),
    [anon_sym_GT] = ACTIONS(3847),
    [anon_sym_GT_EQ] = ACTIONS(3861),
    [anon_sym_CARET] = ACTIONS(3841),
    [anon_sym_PLUS] = ACTIONS(3863),
    [anon_sym_SLASH] = ACTIONS(3843),
    [anon_sym_PERCENT] = ACTIONS(3843),
    [sym_comment] = ACTIONS(87),
  },
  [7166] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(3837),
    [sym__binary_star] = ACTIONS(3839),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_RPAREN] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(3841),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(3843),
    [anon_sym_AMP] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(7884),
    [anon_sym_LT] = ACTIONS(3847),
    [anon_sym_if] = ACTIONS(7027),
    [anon_sym_unless] = ACTIONS(7027),
    [anon_sym_while] = ACTIONS(7027),
    [anon_sym_until] = ACTIONS(7027),
    [anon_sym_rescue] = ACTIONS(7027),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_EQ_GT] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_PLUS_EQ] = ACTIONS(7027),
    [anon_sym_DASH_EQ] = ACTIONS(7027),
    [anon_sym_STAR_EQ] = ACTIONS(7027),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7027),
    [anon_sym_SLASH_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7027),
    [anon_sym_AMP_EQ] = ACTIONS(7027),
    [anon_sym_PERCENT_EQ] = ACTIONS(7027),
    [anon_sym_GT_GT_EQ] = ACTIONS(7027),
    [anon_sym_LT_LT_EQ] = ACTIONS(7027),
    [anon_sym_CARET_EQ] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(3849),
    [anon_sym_DOT_DOT] = ACTIONS(3851),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3853),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(3855),
    [anon_sym_AMP_AMP] = ACTIONS(3855),
    [anon_sym_LT_LT] = ACTIONS(3857),
    [anon_sym_GT_GT] = ACTIONS(3857),
    [anon_sym_EQ_EQ] = ACTIONS(3855),
    [anon_sym_BANG_EQ] = ACTIONS(3859),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3859),
    [anon_sym_LT_EQ_GT] = ACTIONS(3859),
    [anon_sym_EQ_TILDE] = ACTIONS(3859),
    [anon_sym_BANG_TILDE] = ACTIONS(3859),
    [anon_sym_LT_EQ] = ACTIONS(3847),
    [anon_sym_GT] = ACTIONS(3847),
    [anon_sym_GT_EQ] = ACTIONS(3861),
    [anon_sym_CARET] = ACTIONS(3841),
    [anon_sym_PLUS] = ACTIONS(3863),
    [anon_sym_SLASH] = ACTIONS(3843),
    [anon_sym_PERCENT] = ACTIONS(3843),
    [sym_comment] = ACTIONS(87),
  },
  [7167] = {
    [sym_heredoc_body] = STATE(7167),
    [aux_sym_call_repeat1] = STATE(7167),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(10978),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_RPAREN] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7919),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_EQ] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_EQ_GT] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_PLUS_EQ] = ACTIONS(7914),
    [anon_sym_DASH_EQ] = ACTIONS(7914),
    [anon_sym_STAR_EQ] = ACTIONS(7914),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7914),
    [anon_sym_SLASH_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7914),
    [anon_sym_AMP_EQ] = ACTIONS(7914),
    [anon_sym_PERCENT_EQ] = ACTIONS(7914),
    [anon_sym_GT_GT_EQ] = ACTIONS(7914),
    [anon_sym_LT_LT_EQ] = ACTIONS(7914),
    [anon_sym_CARET_EQ] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7919),
    [anon_sym_AMP_AMP] = ACTIONS(7919),
    [anon_sym_LT_LT] = ACTIONS(7919),
    [anon_sym_GT_GT] = ACTIONS(7919),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7919),
    [anon_sym_PLUS] = ACTIONS(7919),
    [anon_sym_SLASH] = ACTIONS(7919),
    [anon_sym_PERCENT] = ACTIONS(7919),
    [sym_comment] = ACTIONS(87),
  },
  [7168] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(2169),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(742),
    [sym_scope_resolution] = STATE(738),
    [sym_call] = STATE(738),
    [sym_method_call] = STATE(742),
    [sym__argument] = STATE(7437),
    [sym_splat_argument] = STATE(7437),
    [sym_hash_splat_argument] = STATE(7437),
    [sym_block_argument] = STATE(7437),
    [sym_assignment] = STATE(2169),
    [sym_operator_assignment] = STATE(2169),
    [sym_conditional] = STATE(2169),
    [sym_range] = STATE(2169),
    [sym_binary] = STATE(2169),
    [sym_unary] = STATE(2169),
    [sym_left_assignment_list] = STATE(741),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(742),
    [sym__variable] = STATE(738),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(742),
    [sym_false] = STATE(742),
    [sym_nil] = STATE(742),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2172),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(7437),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(3787),
    [sym__splat_star] = ACTIONS(3789),
    [sym__unary_minus] = ACTIONS(1375),
    [sym__identifier_hash_key] = ACTIONS(3791),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10746),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1381),
    [anon_sym_break] = ACTIONS(1383),
    [anon_sym_next] = ACTIONS(1385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(3831),
    [anon_sym_defined_QMARK] = ACTIONS(1387),
    [anon_sym_not] = ACTIONS(1389),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_TILDE] = ACTIONS(1393),
    [sym_constant] = ACTIONS(3793),
    [sym_identifier] = ACTIONS(3793),
    [sym_instance_variable] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1397),
    [sym_global_variable] = ACTIONS(1397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7169] = {
    [sym_heredoc_body] = STATE(7167),
    [aux_sym_call_repeat1] = STATE(7167),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_RPAREN] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7931),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_EQ] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_EQ_GT] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_PLUS_EQ] = ACTIONS(7929),
    [anon_sym_DASH_EQ] = ACTIONS(7929),
    [anon_sym_STAR_EQ] = ACTIONS(7929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7929),
    [anon_sym_SLASH_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7929),
    [anon_sym_AMP_EQ] = ACTIONS(7929),
    [anon_sym_PERCENT_EQ] = ACTIONS(7929),
    [anon_sym_GT_GT_EQ] = ACTIONS(7929),
    [anon_sym_LT_LT_EQ] = ACTIONS(7929),
    [anon_sym_CARET_EQ] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7931),
    [anon_sym_AMP_AMP] = ACTIONS(7931),
    [anon_sym_LT_LT] = ACTIONS(7931),
    [anon_sym_GT_GT] = ACTIONS(7931),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7931),
    [anon_sym_PLUS] = ACTIONS(7931),
    [anon_sym_SLASH] = ACTIONS(7931),
    [anon_sym_PERCENT] = ACTIONS(7931),
    [sym_comment] = ACTIONS(87),
  },
  [7170] = {
    [aux_sym_argument_list_repeat1] = STATE(7170),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_RPAREN] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(12708),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7927),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_EQ] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_if] = ACTIONS(7925),
    [anon_sym_unless] = ACTIONS(7925),
    [anon_sym_while] = ACTIONS(7925),
    [anon_sym_until] = ACTIONS(7925),
    [anon_sym_rescue] = ACTIONS(7925),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_EQ_GT] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_PLUS_EQ] = ACTIONS(7925),
    [anon_sym_DASH_EQ] = ACTIONS(7925),
    [anon_sym_STAR_EQ] = ACTIONS(7925),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7925),
    [anon_sym_SLASH_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7925),
    [anon_sym_AMP_EQ] = ACTIONS(7925),
    [anon_sym_PERCENT_EQ] = ACTIONS(7925),
    [anon_sym_GT_GT_EQ] = ACTIONS(7925),
    [anon_sym_LT_LT_EQ] = ACTIONS(7925),
    [anon_sym_CARET_EQ] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7927),
    [anon_sym_AMP_AMP] = ACTIONS(7927),
    [anon_sym_LT_LT] = ACTIONS(7927),
    [anon_sym_GT_GT] = ACTIONS(7927),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7927),
    [anon_sym_PLUS] = ACTIONS(7927),
    [anon_sym_SLASH] = ACTIONS(7927),
    [anon_sym_PERCENT] = ACTIONS(7927),
    [sym_comment] = ACTIONS(87),
  },
  [7171] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4578),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(705),
    [sym_scope_resolution] = STATE(701),
    [sym_call] = STATE(701),
    [sym_method_call] = STATE(705),
    [sym_splat_argument] = STATE(7439),
    [sym_assignment] = STATE(4578),
    [sym_operator_assignment] = STATE(4578),
    [sym_conditional] = STATE(4578),
    [sym_range] = STATE(4578),
    [sym_binary] = STATE(4578),
    [sym_unary] = STATE(4578),
    [sym__arg_or_splat_arg] = STATE(7439),
    [sym_left_assignment_list] = STATE(704),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(705),
    [sym__variable] = STATE(701),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(705),
    [sym_false] = STATE(705),
    [sym_nil] = STATE(705),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2140),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__splat_star] = ACTIONS(3753),
    [sym__unary_minus] = ACTIONS(1303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3747),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7172] = {
    [aux_sym_exceptions_repeat1] = STATE(9143),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_RPAREN] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(12711),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_EQ_GT] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [7173] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(1343),
    [sym__binary_star] = ACTIONS(1345),
    [anon_sym_RPAREN] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(1345),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_DOT_DOT] = ACTIONS(1355),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1357),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(1361),
    [anon_sym_AMP_AMP] = ACTIONS(1361),
    [anon_sym_LT_LT] = ACTIONS(1363),
    [anon_sym_GT_GT] = ACTIONS(1363),
    [anon_sym_EQ_EQ] = ACTIONS(1365),
    [anon_sym_BANG_EQ] = ACTIONS(1361),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1361),
    [anon_sym_LT_EQ_GT] = ACTIONS(1361),
    [anon_sym_EQ_TILDE] = ACTIONS(1361),
    [anon_sym_BANG_TILDE] = ACTIONS(1361),
    [anon_sym_LT_EQ] = ACTIONS(1351),
    [anon_sym_GT] = ACTIONS(1351),
    [anon_sym_GT_EQ] = ACTIONS(1367),
    [anon_sym_CARET] = ACTIONS(1369),
    [anon_sym_PLUS] = ACTIONS(1343),
    [anon_sym_SLASH] = ACTIONS(1345),
    [anon_sym_PERCENT] = ACTIONS(1345),
    [sym_comment] = ACTIONS(87),
  },
  [7174] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(7460),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(7464),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(7464),
    [anon_sym_PERCENT] = ACTIONS(7464),
    [sym_comment] = ACTIONS(87),
  },
  [7175] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(7464),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(5827),
    [anon_sym_PERCENT] = ACTIONS(5827),
    [sym_comment] = ACTIONS(87),
  },
  [7176] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7458),
    [sym__binary_star] = ACTIONS(7460),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(7464),
    [anon_sym_AMP] = ACTIONS(7466),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(7478),
    [anon_sym_GT_GT] = ACTIONS(7478),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(7484),
    [anon_sym_SLASH] = ACTIONS(7464),
    [anon_sym_PERCENT] = ACTIONS(7464),
    [sym_comment] = ACTIONS(87),
  },
  [7177] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7458),
    [sym__binary_star] = ACTIONS(7460),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(7464),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(7478),
    [anon_sym_GT_GT] = ACTIONS(7478),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(7484),
    [anon_sym_SLASH] = ACTIONS(7464),
    [anon_sym_PERCENT] = ACTIONS(7464),
    [sym_comment] = ACTIONS(87),
  },
  [7178] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7458),
    [sym__binary_star] = ACTIONS(7460),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(7462),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(7464),
    [anon_sym_AMP] = ACTIONS(7466),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(7478),
    [anon_sym_GT_GT] = ACTIONS(7478),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(7462),
    [anon_sym_PLUS] = ACTIONS(7484),
    [anon_sym_SLASH] = ACTIONS(7464),
    [anon_sym_PERCENT] = ACTIONS(7464),
    [sym_comment] = ACTIONS(87),
  },
  [7179] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(12713),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [7180] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(7458),
    [sym__binary_star] = ACTIONS(7460),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_RPAREN] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(7462),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(7464),
    [anon_sym_AMP] = ACTIONS(7466),
    [anon_sym_EQ] = ACTIONS(7888),
    [anon_sym_LT] = ACTIONS(7468),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_PLUS_EQ] = ACTIONS(5927),
    [anon_sym_DASH_EQ] = ACTIONS(5927),
    [anon_sym_STAR_EQ] = ACTIONS(5927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5927),
    [anon_sym_SLASH_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5927),
    [anon_sym_AMP_EQ] = ACTIONS(5927),
    [anon_sym_PERCENT_EQ] = ACTIONS(5927),
    [anon_sym_GT_GT_EQ] = ACTIONS(5927),
    [anon_sym_LT_LT_EQ] = ACTIONS(5927),
    [anon_sym_CARET_EQ] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(7472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7474),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(7476),
    [anon_sym_AMP_AMP] = ACTIONS(7476),
    [anon_sym_LT_LT] = ACTIONS(7478),
    [anon_sym_GT_GT] = ACTIONS(7478),
    [anon_sym_EQ_EQ] = ACTIONS(7476),
    [anon_sym_BANG_EQ] = ACTIONS(7480),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7480),
    [anon_sym_LT_EQ_GT] = ACTIONS(7480),
    [anon_sym_EQ_TILDE] = ACTIONS(7480),
    [anon_sym_BANG_TILDE] = ACTIONS(7480),
    [anon_sym_LT_EQ] = ACTIONS(7468),
    [anon_sym_GT] = ACTIONS(7468),
    [anon_sym_GT_EQ] = ACTIONS(7482),
    [anon_sym_CARET] = ACTIONS(7462),
    [anon_sym_PLUS] = ACTIONS(7484),
    [anon_sym_SLASH] = ACTIONS(7464),
    [anon_sym_PERCENT] = ACTIONS(7464),
    [sym_comment] = ACTIONS(87),
  },
  [7181] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7458),
    [sym__binary_star] = ACTIONS(7460),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(7462),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(7464),
    [anon_sym_AMP] = ACTIONS(7466),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(7468),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(7470),
    [anon_sym_DOT_DOT] = ACTIONS(7472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7474),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(7476),
    [anon_sym_AMP_AMP] = ACTIONS(7476),
    [anon_sym_LT_LT] = ACTIONS(7478),
    [anon_sym_GT_GT] = ACTIONS(7478),
    [anon_sym_EQ_EQ] = ACTIONS(7476),
    [anon_sym_BANG_EQ] = ACTIONS(7480),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7480),
    [anon_sym_LT_EQ_GT] = ACTIONS(7480),
    [anon_sym_EQ_TILDE] = ACTIONS(7480),
    [anon_sym_BANG_TILDE] = ACTIONS(7480),
    [anon_sym_LT_EQ] = ACTIONS(7468),
    [anon_sym_GT] = ACTIONS(7468),
    [anon_sym_GT_EQ] = ACTIONS(7482),
    [anon_sym_CARET] = ACTIONS(7462),
    [anon_sym_PLUS] = ACTIONS(7484),
    [anon_sym_SLASH] = ACTIONS(7464),
    [anon_sym_PERCENT] = ACTIONS(7464),
    [sym_comment] = ACTIONS(87),
  },
  [7182] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7458),
    [sym__binary_star] = ACTIONS(7460),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(7462),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(7464),
    [anon_sym_AMP] = ACTIONS(7466),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(7468),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(7478),
    [anon_sym_GT_GT] = ACTIONS(7478),
    [anon_sym_EQ_EQ] = ACTIONS(7476),
    [anon_sym_BANG_EQ] = ACTIONS(7480),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7480),
    [anon_sym_LT_EQ_GT] = ACTIONS(7480),
    [anon_sym_EQ_TILDE] = ACTIONS(7480),
    [anon_sym_BANG_TILDE] = ACTIONS(7480),
    [anon_sym_LT_EQ] = ACTIONS(7468),
    [anon_sym_GT] = ACTIONS(7468),
    [anon_sym_GT_EQ] = ACTIONS(7482),
    [anon_sym_CARET] = ACTIONS(7462),
    [anon_sym_PLUS] = ACTIONS(7484),
    [anon_sym_SLASH] = ACTIONS(7464),
    [anon_sym_PERCENT] = ACTIONS(7464),
    [sym_comment] = ACTIONS(87),
  },
  [7183] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7458),
    [sym__binary_star] = ACTIONS(7460),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(7464),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(7484),
    [anon_sym_SLASH] = ACTIONS(7464),
    [anon_sym_PERCENT] = ACTIONS(7464),
    [sym_comment] = ACTIONS(87),
  },
  [7184] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(7458),
    [sym__binary_star] = ACTIONS(7460),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_RPAREN] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(7462),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(7464),
    [anon_sym_AMP] = ACTIONS(7466),
    [anon_sym_EQ] = ACTIONS(7936),
    [anon_sym_LT] = ACTIONS(7468),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_PLUS_EQ] = ACTIONS(5115),
    [anon_sym_DASH_EQ] = ACTIONS(5115),
    [anon_sym_STAR_EQ] = ACTIONS(5115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5115),
    [anon_sym_SLASH_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5115),
    [anon_sym_AMP_EQ] = ACTIONS(5115),
    [anon_sym_PERCENT_EQ] = ACTIONS(5115),
    [anon_sym_GT_GT_EQ] = ACTIONS(5115),
    [anon_sym_LT_LT_EQ] = ACTIONS(5115),
    [anon_sym_CARET_EQ] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(7470),
    [anon_sym_DOT_DOT] = ACTIONS(7472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7474),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7476),
    [anon_sym_AMP_AMP] = ACTIONS(7476),
    [anon_sym_LT_LT] = ACTIONS(7478),
    [anon_sym_GT_GT] = ACTIONS(7478),
    [anon_sym_EQ_EQ] = ACTIONS(7476),
    [anon_sym_BANG_EQ] = ACTIONS(7480),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7480),
    [anon_sym_LT_EQ_GT] = ACTIONS(7480),
    [anon_sym_EQ_TILDE] = ACTIONS(7480),
    [anon_sym_BANG_TILDE] = ACTIONS(7480),
    [anon_sym_LT_EQ] = ACTIONS(7468),
    [anon_sym_GT] = ACTIONS(7468),
    [anon_sym_GT_EQ] = ACTIONS(7482),
    [anon_sym_CARET] = ACTIONS(7462),
    [anon_sym_PLUS] = ACTIONS(7484),
    [anon_sym_SLASH] = ACTIONS(7464),
    [anon_sym_PERCENT] = ACTIONS(7464),
    [sym_comment] = ACTIONS(87),
  },
  [7185] = {
    [aux_sym_exceptions_repeat1] = STATE(9146),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_RPAREN] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6193),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_PLUS_EQ] = ACTIONS(6191),
    [anon_sym_DASH_EQ] = ACTIONS(6191),
    [anon_sym_STAR_EQ] = ACTIONS(6191),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6191),
    [anon_sym_SLASH_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6191),
    [anon_sym_AMP_EQ] = ACTIONS(6191),
    [anon_sym_PERCENT_EQ] = ACTIONS(6191),
    [anon_sym_GT_GT_EQ] = ACTIONS(6191),
    [anon_sym_LT_LT_EQ] = ACTIONS(6191),
    [anon_sym_CARET_EQ] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6193),
    [anon_sym_AMP_AMP] = ACTIONS(6193),
    [anon_sym_LT_LT] = ACTIONS(6193),
    [anon_sym_GT_GT] = ACTIONS(6193),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6193),
    [anon_sym_PLUS] = ACTIONS(6193),
    [anon_sym_SLASH] = ACTIONS(6193),
    [anon_sym_PERCENT] = ACTIONS(6193),
    [sym_comment] = ACTIONS(87),
  },
  [7186] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(7458),
    [sym__binary_star] = ACTIONS(7460),
    [anon_sym_LBRACE] = ACTIONS(6210),
    [anon_sym_RPAREN] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(7462),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(7464),
    [anon_sym_AMP] = ACTIONS(7466),
    [anon_sym_EQ] = ACTIONS(7938),
    [anon_sym_LT] = ACTIONS(7468),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_PLUS_EQ] = ACTIONS(6210),
    [anon_sym_DASH_EQ] = ACTIONS(6210),
    [anon_sym_STAR_EQ] = ACTIONS(6210),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6210),
    [anon_sym_SLASH_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6210),
    [anon_sym_AMP_EQ] = ACTIONS(6210),
    [anon_sym_PERCENT_EQ] = ACTIONS(6210),
    [anon_sym_GT_GT_EQ] = ACTIONS(6210),
    [anon_sym_LT_LT_EQ] = ACTIONS(6210),
    [anon_sym_CARET_EQ] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(7470),
    [anon_sym_DOT_DOT] = ACTIONS(7472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7474),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(7476),
    [anon_sym_AMP_AMP] = ACTIONS(7476),
    [anon_sym_LT_LT] = ACTIONS(7478),
    [anon_sym_GT_GT] = ACTIONS(7478),
    [anon_sym_EQ_EQ] = ACTIONS(7476),
    [anon_sym_BANG_EQ] = ACTIONS(7480),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7480),
    [anon_sym_LT_EQ_GT] = ACTIONS(7480),
    [anon_sym_EQ_TILDE] = ACTIONS(7480),
    [anon_sym_BANG_TILDE] = ACTIONS(7480),
    [anon_sym_LT_EQ] = ACTIONS(7468),
    [anon_sym_GT] = ACTIONS(7468),
    [anon_sym_GT_EQ] = ACTIONS(7482),
    [anon_sym_CARET] = ACTIONS(7462),
    [anon_sym_PLUS] = ACTIONS(7484),
    [anon_sym_SLASH] = ACTIONS(7464),
    [anon_sym_PERCENT] = ACTIONS(7464),
    [sym_comment] = ACTIONS(87),
  },
  [7187] = {
    [sym_string] = STATE(7187),
    [aux_sym_chained_string_repeat1] = STATE(7187),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(12267),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_RPAREN] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6217),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_EQ] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_do] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_PLUS_EQ] = ACTIONS(6212),
    [anon_sym_DASH_EQ] = ACTIONS(6212),
    [anon_sym_STAR_EQ] = ACTIONS(6212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6212),
    [anon_sym_SLASH_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6212),
    [anon_sym_AMP_EQ] = ACTIONS(6212),
    [anon_sym_PERCENT_EQ] = ACTIONS(6212),
    [anon_sym_GT_GT_EQ] = ACTIONS(6212),
    [anon_sym_LT_LT_EQ] = ACTIONS(6212),
    [anon_sym_CARET_EQ] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6217),
    [anon_sym_AMP_AMP] = ACTIONS(6217),
    [anon_sym_LT_LT] = ACTIONS(6217),
    [anon_sym_GT_GT] = ACTIONS(6217),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6217),
    [anon_sym_PLUS] = ACTIONS(6217),
    [anon_sym_SLASH] = ACTIONS(6217),
    [anon_sym_PERCENT] = ACTIONS(6217),
    [sym_comment] = ACTIONS(87),
  },
  [7188] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(9147),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(742),
    [sym_scope_resolution] = STATE(738),
    [sym_call] = STATE(738),
    [sym_method_call] = STATE(742),
    [sym_assignment] = STATE(9147),
    [sym_operator_assignment] = STATE(9147),
    [sym_conditional] = STATE(9147),
    [sym_range] = STATE(9147),
    [sym_binary] = STATE(9147),
    [sym_unary] = STATE(9147),
    [sym_left_assignment_list] = STATE(741),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(742),
    [sym__variable] = STATE(738),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(742),
    [sym_false] = STATE(742),
    [sym_nil] = STATE(742),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2209),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1381),
    [anon_sym_break] = ACTIONS(1383),
    [anon_sym_next] = ACTIONS(1385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(3831),
    [anon_sym_defined_QMARK] = ACTIONS(1387),
    [anon_sym_not] = ACTIONS(1389),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_TILDE] = ACTIONS(1393),
    [sym_constant] = ACTIONS(1399),
    [sym_identifier] = ACTIONS(1399),
    [sym_instance_variable] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1397),
    [sym_global_variable] = ACTIONS(1397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7189] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(4615),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(742),
    [sym_scope_resolution] = STATE(738),
    [sym_call] = STATE(738),
    [sym_method_call] = STATE(742),
    [sym_splat_argument] = STATE(8678),
    [sym_assignment] = STATE(4615),
    [sym_operator_assignment] = STATE(4615),
    [sym_conditional] = STATE(4615),
    [sym_range] = STATE(4615),
    [sym_binary] = STATE(4615),
    [sym_unary] = STATE(4615),
    [sym__arg_or_splat_arg] = STATE(8678),
    [sym_left_assignment_list] = STATE(741),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(742),
    [sym__variable] = STATE(738),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(742),
    [sym_false] = STATE(742),
    [sym_nil] = STATE(742),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2209),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__splat_star] = ACTIONS(3789),
    [sym__unary_minus] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1381),
    [anon_sym_break] = ACTIONS(1383),
    [anon_sym_next] = ACTIONS(1385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(3831),
    [anon_sym_defined_QMARK] = ACTIONS(1387),
    [anon_sym_not] = ACTIONS(1389),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_TILDE] = ACTIONS(1393),
    [sym_constant] = ACTIONS(1399),
    [sym_identifier] = ACTIONS(1399),
    [sym_instance_variable] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1397),
    [sym_global_variable] = ACTIONS(1397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7190] = {
    [aux_sym_exceptions_repeat1] = STATE(9148),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_LBRACE] = ACTIONS(9855),
    [anon_sym_RPAREN] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(12715),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9857),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_EQ] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_do] = ACTIONS(9855),
    [anon_sym_EQ_GT] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_PLUS_EQ] = ACTIONS(9855),
    [anon_sym_DASH_EQ] = ACTIONS(9855),
    [anon_sym_STAR_EQ] = ACTIONS(9855),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9855),
    [anon_sym_SLASH_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9855),
    [anon_sym_AMP_EQ] = ACTIONS(9855),
    [anon_sym_PERCENT_EQ] = ACTIONS(9855),
    [anon_sym_GT_GT_EQ] = ACTIONS(9855),
    [anon_sym_LT_LT_EQ] = ACTIONS(9855),
    [anon_sym_CARET_EQ] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9857),
    [anon_sym_AMP_AMP] = ACTIONS(9857),
    [anon_sym_LT_LT] = ACTIONS(9857),
    [anon_sym_GT_GT] = ACTIONS(9857),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9857),
    [anon_sym_PLUS] = ACTIONS(9857),
    [anon_sym_SLASH] = ACTIONS(9857),
    [anon_sym_PERCENT] = ACTIONS(9857),
    [sym_comment] = ACTIONS(87),
  },
  [7191] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(7496),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(7496),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(7496),
    [anon_sym_PERCENT] = ACTIONS(7496),
    [sym_comment] = ACTIONS(87),
  },
  [7192] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(7496),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [7193] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7494),
    [sym__binary_star] = ACTIONS(7496),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(7496),
    [anon_sym_AMP] = ACTIONS(7500),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(7512),
    [anon_sym_GT_GT] = ACTIONS(7512),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(7494),
    [anon_sym_SLASH] = ACTIONS(7496),
    [anon_sym_PERCENT] = ACTIONS(7496),
    [sym_comment] = ACTIONS(87),
  },
  [7194] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7494),
    [sym__binary_star] = ACTIONS(7496),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(7496),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(7512),
    [anon_sym_GT_GT] = ACTIONS(7512),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(7494),
    [anon_sym_SLASH] = ACTIONS(7496),
    [anon_sym_PERCENT] = ACTIONS(7496),
    [sym_comment] = ACTIONS(87),
  },
  [7195] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7494),
    [sym__binary_star] = ACTIONS(7496),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(7498),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(7496),
    [anon_sym_AMP] = ACTIONS(7500),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(7512),
    [anon_sym_GT_GT] = ACTIONS(7512),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(7518),
    [anon_sym_PLUS] = ACTIONS(7494),
    [anon_sym_SLASH] = ACTIONS(7496),
    [anon_sym_PERCENT] = ACTIONS(7496),
    [sym_comment] = ACTIONS(87),
  },
  [7196] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(12717),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [7197] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(7494),
    [sym__binary_star] = ACTIONS(7496),
    [anon_sym_RPAREN] = ACTIONS(5927),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(7498),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(7496),
    [anon_sym_AMP] = ACTIONS(7500),
    [anon_sym_LT] = ACTIONS(7502),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(7506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7508),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(7510),
    [anon_sym_AMP_AMP] = ACTIONS(7510),
    [anon_sym_LT_LT] = ACTIONS(7512),
    [anon_sym_GT_GT] = ACTIONS(7512),
    [anon_sym_EQ_EQ] = ACTIONS(7514),
    [anon_sym_BANG_EQ] = ACTIONS(7510),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7510),
    [anon_sym_LT_EQ_GT] = ACTIONS(7510),
    [anon_sym_EQ_TILDE] = ACTIONS(7510),
    [anon_sym_BANG_TILDE] = ACTIONS(7510),
    [anon_sym_LT_EQ] = ACTIONS(7502),
    [anon_sym_GT] = ACTIONS(7502),
    [anon_sym_GT_EQ] = ACTIONS(7516),
    [anon_sym_CARET] = ACTIONS(7518),
    [anon_sym_PLUS] = ACTIONS(7494),
    [anon_sym_SLASH] = ACTIONS(7496),
    [anon_sym_PERCENT] = ACTIONS(7496),
    [sym_comment] = ACTIONS(87),
  },
  [7198] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7494),
    [sym__binary_star] = ACTIONS(7496),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(7498),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(7496),
    [anon_sym_AMP] = ACTIONS(7500),
    [anon_sym_LT] = ACTIONS(7502),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(7504),
    [anon_sym_DOT_DOT] = ACTIONS(7506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7508),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(7510),
    [anon_sym_AMP_AMP] = ACTIONS(7510),
    [anon_sym_LT_LT] = ACTIONS(7512),
    [anon_sym_GT_GT] = ACTIONS(7512),
    [anon_sym_EQ_EQ] = ACTIONS(7514),
    [anon_sym_BANG_EQ] = ACTIONS(7510),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7510),
    [anon_sym_LT_EQ_GT] = ACTIONS(7510),
    [anon_sym_EQ_TILDE] = ACTIONS(7510),
    [anon_sym_BANG_TILDE] = ACTIONS(7510),
    [anon_sym_LT_EQ] = ACTIONS(7502),
    [anon_sym_GT] = ACTIONS(7502),
    [anon_sym_GT_EQ] = ACTIONS(7516),
    [anon_sym_CARET] = ACTIONS(7518),
    [anon_sym_PLUS] = ACTIONS(7494),
    [anon_sym_SLASH] = ACTIONS(7496),
    [anon_sym_PERCENT] = ACTIONS(7496),
    [sym_comment] = ACTIONS(87),
  },
  [7199] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7494),
    [sym__binary_star] = ACTIONS(7496),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(7498),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(7496),
    [anon_sym_AMP] = ACTIONS(7500),
    [anon_sym_LT] = ACTIONS(7502),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(7512),
    [anon_sym_GT_GT] = ACTIONS(7512),
    [anon_sym_EQ_EQ] = ACTIONS(7514),
    [anon_sym_BANG_EQ] = ACTIONS(7510),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7510),
    [anon_sym_LT_EQ_GT] = ACTIONS(7510),
    [anon_sym_EQ_TILDE] = ACTIONS(7510),
    [anon_sym_BANG_TILDE] = ACTIONS(7510),
    [anon_sym_LT_EQ] = ACTIONS(7502),
    [anon_sym_GT] = ACTIONS(7502),
    [anon_sym_GT_EQ] = ACTIONS(7516),
    [anon_sym_CARET] = ACTIONS(7518),
    [anon_sym_PLUS] = ACTIONS(7494),
    [anon_sym_SLASH] = ACTIONS(7496),
    [anon_sym_PERCENT] = ACTIONS(7496),
    [sym_comment] = ACTIONS(87),
  },
  [7200] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7494),
    [sym__binary_star] = ACTIONS(7496),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(7496),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(7494),
    [anon_sym_SLASH] = ACTIONS(7496),
    [anon_sym_PERCENT] = ACTIONS(7496),
    [sym_comment] = ACTIONS(87),
  },
  [7201] = {
    [aux_sym_exceptions_repeat1] = STATE(7201),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_RPAREN] = ACTIONS(11597),
    [anon_sym_COMMA] = ACTIONS(12719),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [7202] = {
    [aux_sym_exceptions_repeat1] = STATE(4633),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_RPAREN] = ACTIONS(6191),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [7203] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(7494),
    [sym__binary_star] = ACTIONS(7496),
    [anon_sym_RPAREN] = ACTIONS(6210),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(7498),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(7496),
    [anon_sym_AMP] = ACTIONS(7500),
    [anon_sym_LT] = ACTIONS(7502),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(7504),
    [anon_sym_DOT_DOT] = ACTIONS(7506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7508),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(7510),
    [anon_sym_AMP_AMP] = ACTIONS(7510),
    [anon_sym_LT_LT] = ACTIONS(7512),
    [anon_sym_GT_GT] = ACTIONS(7512),
    [anon_sym_EQ_EQ] = ACTIONS(7514),
    [anon_sym_BANG_EQ] = ACTIONS(7510),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7510),
    [anon_sym_LT_EQ_GT] = ACTIONS(7510),
    [anon_sym_EQ_TILDE] = ACTIONS(7510),
    [anon_sym_BANG_TILDE] = ACTIONS(7510),
    [anon_sym_LT_EQ] = ACTIONS(7502),
    [anon_sym_GT] = ACTIONS(7502),
    [anon_sym_GT_EQ] = ACTIONS(7516),
    [anon_sym_CARET] = ACTIONS(7518),
    [anon_sym_PLUS] = ACTIONS(7494),
    [anon_sym_SLASH] = ACTIONS(7496),
    [anon_sym_PERCENT] = ACTIONS(7496),
    [sym_comment] = ACTIONS(87),
  },
  [7204] = {
    [anon_sym_DOT] = ACTIONS(10203),
    [anon_sym_LBRACK] = ACTIONS(10203),
    [anon_sym_COLON_COLON2] = ACTIONS(10203),
    [anon_sym_AMP_DOT] = ACTIONS(10203),
    [sym_comment] = ACTIONS(87),
  },
  [7205] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1697),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(12722),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [7206] = {
    [anon_sym_DOT] = ACTIONS(10209),
    [anon_sym_LBRACK] = ACTIONS(10209),
    [anon_sym_COLON_COLON2] = ACTIONS(10209),
    [anon_sym_AMP_DOT] = ACTIONS(10209),
    [sym_comment] = ACTIONS(87),
  },
  [7207] = {
    [anon_sym_DOT] = ACTIONS(10213),
    [anon_sym_LBRACK] = ACTIONS(10213),
    [anon_sym_COLON_COLON2] = ACTIONS(10213),
    [anon_sym_AMP_DOT] = ACTIONS(10213),
    [sym_comment] = ACTIONS(87),
  },
  [7208] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1705),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(12724),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [7209] = {
    [anon_sym_DOT] = ACTIONS(10219),
    [anon_sym_LBRACK] = ACTIONS(10219),
    [anon_sym_COLON_COLON2] = ACTIONS(10219),
    [anon_sym_AMP_DOT] = ACTIONS(10219),
    [sym_comment] = ACTIONS(87),
  },
  [7210] = {
    [sym__method_rest] = STATE(9152),
    [sym_operator] = STATE(772),
    [sym__method_name] = STATE(772),
    [sym_setter] = STATE(772),
    [sym_symbol] = STATE(772),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(7555),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(7555),
    [sym_class_variable] = ACTIONS(7555),
    [sym_global_variable] = ACTIONS(7555),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [7211] = {
    [anon_sym_DOT] = ACTIONS(10927),
    [anon_sym_LBRACK] = ACTIONS(10927),
    [anon_sym_COLON_COLON2] = ACTIONS(10927),
    [anon_sym_AMP_DOT] = ACTIONS(10927),
    [sym_comment] = ACTIONS(87),
  },
  [7212] = {
    [anon_sym_DOT] = ACTIONS(10931),
    [anon_sym_LBRACK] = ACTIONS(10931),
    [anon_sym_COLON_COLON2] = ACTIONS(10931),
    [anon_sym_AMP_DOT] = ACTIONS(10931),
    [sym_comment] = ACTIONS(87),
  },
  [7213] = {
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(7575),
    [sym__binary_star] = ACTIONS(7577),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(7579),
    [anon_sym_STAR_STAR] = ACTIONS(7577),
    [anon_sym_AMP] = ACTIONS(7581),
    [anon_sym_LT] = ACTIONS(7583),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(7585),
    [anon_sym_DOT_DOT] = ACTIONS(7587),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7589),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(7593),
    [anon_sym_AMP_AMP] = ACTIONS(7593),
    [anon_sym_LT_LT] = ACTIONS(7595),
    [anon_sym_GT_GT] = ACTIONS(7595),
    [anon_sym_EQ_EQ] = ACTIONS(7597),
    [anon_sym_BANG_EQ] = ACTIONS(7593),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7593),
    [anon_sym_LT_EQ_GT] = ACTIONS(7593),
    [anon_sym_EQ_TILDE] = ACTIONS(7593),
    [anon_sym_BANG_TILDE] = ACTIONS(7593),
    [anon_sym_LT_EQ] = ACTIONS(7583),
    [anon_sym_GT] = ACTIONS(7583),
    [anon_sym_GT_EQ] = ACTIONS(7599),
    [anon_sym_CARET] = ACTIONS(7601),
    [anon_sym_PLUS] = ACTIONS(7575),
    [anon_sym_SLASH] = ACTIONS(7577),
    [anon_sym_PERCENT] = ACTIONS(7577),
    [sym_comment] = ACTIONS(87),
  },
  [7214] = {
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(7575),
    [sym__binary_star] = ACTIONS(7577),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(7579),
    [anon_sym_STAR_STAR] = ACTIONS(7577),
    [anon_sym_AMP] = ACTIONS(7581),
    [anon_sym_LT] = ACTIONS(7583),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(7585),
    [anon_sym_DOT_DOT] = ACTIONS(7587),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7589),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(7593),
    [anon_sym_AMP_AMP] = ACTIONS(7593),
    [anon_sym_LT_LT] = ACTIONS(7595),
    [anon_sym_GT_GT] = ACTIONS(7595),
    [anon_sym_EQ_EQ] = ACTIONS(7597),
    [anon_sym_BANG_EQ] = ACTIONS(7593),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7593),
    [anon_sym_LT_EQ_GT] = ACTIONS(7593),
    [anon_sym_EQ_TILDE] = ACTIONS(7593),
    [anon_sym_BANG_TILDE] = ACTIONS(7593),
    [anon_sym_LT_EQ] = ACTIONS(7583),
    [anon_sym_GT] = ACTIONS(7583),
    [anon_sym_GT_EQ] = ACTIONS(7599),
    [anon_sym_CARET] = ACTIONS(7601),
    [anon_sym_PLUS] = ACTIONS(7575),
    [anon_sym_SLASH] = ACTIONS(7577),
    [anon_sym_PERCENT] = ACTIONS(7577),
    [sym_comment] = ACTIONS(87),
  },
  [7215] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9153),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2279),
    [sym_scope_resolution] = STATE(2277),
    [sym_call] = STATE(2277),
    [sym_method_call] = STATE(2279),
    [sym_assignment] = STATE(9153),
    [sym_operator_assignment] = STATE(9153),
    [sym_conditional] = STATE(9153),
    [sym_range] = STATE(9153),
    [sym_binary] = STATE(9153),
    [sym_unary] = STATE(9153),
    [sym_left_assignment_list] = STATE(2278),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2277),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2279),
    [sym_false] = STATE(2279),
    [sym_nil] = STATE(2279),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2280),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3931),
    [anon_sym_yield] = ACTIONS(3933),
    [anon_sym_break] = ACTIONS(3935),
    [anon_sym_next] = ACTIONS(3937),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3939),
    [anon_sym_defined_QMARK] = ACTIONS(3941),
    [anon_sym_not] = ACTIONS(3943),
    [anon_sym_BANG] = ACTIONS(3945),
    [anon_sym_TILDE] = ACTIONS(3945),
    [sym_constant] = ACTIONS(3947),
    [sym_identifier] = ACTIONS(3947),
    [sym_instance_variable] = ACTIONS(3949),
    [sym_class_variable] = ACTIONS(3949),
    [sym_global_variable] = ACTIONS(3949),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3947),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3947),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7216] = {
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(7575),
    [sym__binary_star] = ACTIONS(7577),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(7579),
    [anon_sym_STAR_STAR] = ACTIONS(7577),
    [anon_sym_AMP] = ACTIONS(7581),
    [anon_sym_LT] = ACTIONS(7583),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(7585),
    [anon_sym_DOT_DOT] = ACTIONS(7587),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7589),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(7593),
    [anon_sym_AMP_AMP] = ACTIONS(7593),
    [anon_sym_LT_LT] = ACTIONS(7595),
    [anon_sym_GT_GT] = ACTIONS(7595),
    [anon_sym_EQ_EQ] = ACTIONS(7597),
    [anon_sym_BANG_EQ] = ACTIONS(7593),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7593),
    [anon_sym_LT_EQ_GT] = ACTIONS(7593),
    [anon_sym_EQ_TILDE] = ACTIONS(7593),
    [anon_sym_BANG_TILDE] = ACTIONS(7593),
    [anon_sym_LT_EQ] = ACTIONS(7583),
    [anon_sym_GT] = ACTIONS(7583),
    [anon_sym_GT_EQ] = ACTIONS(7599),
    [anon_sym_CARET] = ACTIONS(7601),
    [anon_sym_PLUS] = ACTIONS(7575),
    [anon_sym_SLASH] = ACTIONS(7577),
    [anon_sym_PERCENT] = ACTIONS(7577),
    [sym_comment] = ACTIONS(87),
  },
  [7217] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9154),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2279),
    [sym_scope_resolution] = STATE(2277),
    [sym_call] = STATE(2277),
    [sym_method_call] = STATE(2279),
    [sym_assignment] = STATE(9154),
    [sym_operator_assignment] = STATE(9154),
    [sym_conditional] = STATE(9154),
    [sym_range] = STATE(9154),
    [sym_binary] = STATE(9154),
    [sym_unary] = STATE(9154),
    [sym_left_assignment_list] = STATE(2278),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2277),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2279),
    [sym_false] = STATE(2279),
    [sym_nil] = STATE(2279),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2280),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3931),
    [anon_sym_yield] = ACTIONS(3933),
    [anon_sym_break] = ACTIONS(3935),
    [anon_sym_next] = ACTIONS(3937),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3939),
    [anon_sym_defined_QMARK] = ACTIONS(3941),
    [anon_sym_not] = ACTIONS(3943),
    [anon_sym_BANG] = ACTIONS(3945),
    [anon_sym_TILDE] = ACTIONS(3945),
    [sym_constant] = ACTIONS(3947),
    [sym_identifier] = ACTIONS(3947),
    [sym_instance_variable] = ACTIONS(3949),
    [sym_class_variable] = ACTIONS(3949),
    [sym_global_variable] = ACTIONS(3949),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3947),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3947),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7218] = {
    [sym_heredoc_body] = STATE(9155),
    [aux_sym_call_repeat1] = STATE(9155),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [7219] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4663),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(567),
    [sym_scope_resolution] = STATE(562),
    [sym_call] = STATE(562),
    [sym_method_call] = STATE(567),
    [sym__argument] = STATE(4250),
    [sym_splat_argument] = STATE(4250),
    [sym_hash_splat_argument] = STATE(4250),
    [sym_block_argument] = STATE(4250),
    [sym_assignment] = STATE(4663),
    [sym_operator_assignment] = STATE(4663),
    [sym_conditional] = STATE(4663),
    [sym_range] = STATE(4663),
    [sym_binary] = STATE(4663),
    [sym_unary] = STATE(4663),
    [sym_left_assignment_list] = STATE(566),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(567),
    [sym__variable] = STATE(562),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(567),
    [sym_false] = STATE(567),
    [sym_nil] = STATE(567),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4666),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_heredoc_body] = STATE(9156),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(4250),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(7567),
    [sym__splat_star] = ACTIONS(7569),
    [sym__unary_minus] = ACTIONS(1049),
    [sym__identifier_hash_key] = ACTIONS(7571),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12726),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(7573),
    [sym_identifier] = ACTIONS(7573),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7220] = {
    [sym_heredoc_body] = STATE(9157),
    [aux_sym_call_repeat1] = STATE(9157),
    [aux_sym_argument_list_repeat1] = STATE(9158),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(10778),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [7221] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(7577),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(7577),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(7577),
    [anon_sym_PERCENT] = ACTIONS(7577),
    [sym_comment] = ACTIONS(87),
  },
  [7222] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(7577),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [7223] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7575),
    [sym__binary_star] = ACTIONS(7577),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(7577),
    [anon_sym_AMP] = ACTIONS(7581),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(7595),
    [anon_sym_GT_GT] = ACTIONS(7595),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(7575),
    [anon_sym_SLASH] = ACTIONS(7577),
    [anon_sym_PERCENT] = ACTIONS(7577),
    [sym_comment] = ACTIONS(87),
  },
  [7224] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7575),
    [sym__binary_star] = ACTIONS(7577),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(7577),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(7595),
    [anon_sym_GT_GT] = ACTIONS(7595),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(7575),
    [anon_sym_SLASH] = ACTIONS(7577),
    [anon_sym_PERCENT] = ACTIONS(7577),
    [sym_comment] = ACTIONS(87),
  },
  [7225] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7575),
    [sym__binary_star] = ACTIONS(7577),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(7579),
    [anon_sym_STAR_STAR] = ACTIONS(7577),
    [anon_sym_AMP] = ACTIONS(7581),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(7595),
    [anon_sym_GT_GT] = ACTIONS(7595),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(7601),
    [anon_sym_PLUS] = ACTIONS(7575),
    [anon_sym_SLASH] = ACTIONS(7577),
    [anon_sym_PERCENT] = ACTIONS(7577),
    [sym_comment] = ACTIONS(87),
  },
  [7226] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(12728),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [7227] = {
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(7575),
    [sym__binary_star] = ACTIONS(7577),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(7579),
    [anon_sym_STAR_STAR] = ACTIONS(7577),
    [anon_sym_AMP] = ACTIONS(7581),
    [anon_sym_LT] = ACTIONS(7583),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(7587),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7589),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(7593),
    [anon_sym_AMP_AMP] = ACTIONS(7593),
    [anon_sym_LT_LT] = ACTIONS(7595),
    [anon_sym_GT_GT] = ACTIONS(7595),
    [anon_sym_EQ_EQ] = ACTIONS(7597),
    [anon_sym_BANG_EQ] = ACTIONS(7593),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7593),
    [anon_sym_LT_EQ_GT] = ACTIONS(7593),
    [anon_sym_EQ_TILDE] = ACTIONS(7593),
    [anon_sym_BANG_TILDE] = ACTIONS(7593),
    [anon_sym_LT_EQ] = ACTIONS(7583),
    [anon_sym_GT] = ACTIONS(7583),
    [anon_sym_GT_EQ] = ACTIONS(7599),
    [anon_sym_CARET] = ACTIONS(7601),
    [anon_sym_PLUS] = ACTIONS(7575),
    [anon_sym_SLASH] = ACTIONS(7577),
    [anon_sym_PERCENT] = ACTIONS(7577),
    [sym_comment] = ACTIONS(87),
  },
  [7228] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7575),
    [sym__binary_star] = ACTIONS(7577),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(7579),
    [anon_sym_STAR_STAR] = ACTIONS(7577),
    [anon_sym_AMP] = ACTIONS(7581),
    [anon_sym_LT] = ACTIONS(7583),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(7585),
    [anon_sym_DOT_DOT] = ACTIONS(7587),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7589),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(7593),
    [anon_sym_AMP_AMP] = ACTIONS(7593),
    [anon_sym_LT_LT] = ACTIONS(7595),
    [anon_sym_GT_GT] = ACTIONS(7595),
    [anon_sym_EQ_EQ] = ACTIONS(7597),
    [anon_sym_BANG_EQ] = ACTIONS(7593),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7593),
    [anon_sym_LT_EQ_GT] = ACTIONS(7593),
    [anon_sym_EQ_TILDE] = ACTIONS(7593),
    [anon_sym_BANG_TILDE] = ACTIONS(7593),
    [anon_sym_LT_EQ] = ACTIONS(7583),
    [anon_sym_GT] = ACTIONS(7583),
    [anon_sym_GT_EQ] = ACTIONS(7599),
    [anon_sym_CARET] = ACTIONS(7601),
    [anon_sym_PLUS] = ACTIONS(7575),
    [anon_sym_SLASH] = ACTIONS(7577),
    [anon_sym_PERCENT] = ACTIONS(7577),
    [sym_comment] = ACTIONS(87),
  },
  [7229] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7575),
    [sym__binary_star] = ACTIONS(7577),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(7579),
    [anon_sym_STAR_STAR] = ACTIONS(7577),
    [anon_sym_AMP] = ACTIONS(7581),
    [anon_sym_LT] = ACTIONS(7583),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(7595),
    [anon_sym_GT_GT] = ACTIONS(7595),
    [anon_sym_EQ_EQ] = ACTIONS(7597),
    [anon_sym_BANG_EQ] = ACTIONS(7593),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7593),
    [anon_sym_LT_EQ_GT] = ACTIONS(7593),
    [anon_sym_EQ_TILDE] = ACTIONS(7593),
    [anon_sym_BANG_TILDE] = ACTIONS(7593),
    [anon_sym_LT_EQ] = ACTIONS(7583),
    [anon_sym_GT] = ACTIONS(7583),
    [anon_sym_GT_EQ] = ACTIONS(7599),
    [anon_sym_CARET] = ACTIONS(7601),
    [anon_sym_PLUS] = ACTIONS(7575),
    [anon_sym_SLASH] = ACTIONS(7577),
    [anon_sym_PERCENT] = ACTIONS(7577),
    [sym_comment] = ACTIONS(87),
  },
  [7230] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7575),
    [sym__binary_star] = ACTIONS(7577),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(7577),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(7575),
    [anon_sym_SLASH] = ACTIONS(7577),
    [anon_sym_PERCENT] = ACTIONS(7577),
    [sym_comment] = ACTIONS(87),
  },
  [7231] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(9160),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(7240),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(7240),
    [sym_assignment] = STATE(9160),
    [sym_operator_assignment] = STATE(9160),
    [sym_conditional] = STATE(9160),
    [sym_range] = STATE(9160),
    [sym_binary] = STATE(9160),
    [sym_unary] = STATE(9160),
    [sym_left_assignment_list] = STATE(7239),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7240),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(7240),
    [sym_false] = STATE(7240),
    [sym_nil] = STATE(7240),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(7241),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(10782),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(10784),
    [anon_sym_yield] = ACTIONS(10786),
    [anon_sym_break] = ACTIONS(10788),
    [anon_sym_next] = ACTIONS(10790),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(10792),
    [anon_sym_defined_QMARK] = ACTIONS(10794),
    [anon_sym_not] = ACTIONS(10796),
    [anon_sym_BANG] = ACTIONS(10798),
    [anon_sym_TILDE] = ACTIONS(10798),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [7232] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4683),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_argument_list] = STATE(6614),
    [sym__argument_list_with_parens] = STATE(4684),
    [sym__argument] = STATE(4685),
    [sym_splat_argument] = STATE(4685),
    [sym_hash_splat_argument] = STATE(4685),
    [sym_block_argument] = STATE(4685),
    [sym_assignment] = STATE(4683),
    [sym_operator_assignment] = STATE(4683),
    [sym_conditional] = STATE(4683),
    [sym_range] = STATE(4683),
    [sym_binary] = STATE(4683),
    [sym_unary] = STATE(4683),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4686),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(4685),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(7603),
    [sym__splat_star] = ACTIONS(7605),
    [sym__unary_minus] = ACTIONS(1159),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(7607),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_PLUS_EQ] = ACTIONS(365),
    [anon_sym_DASH_EQ] = ACTIONS(365),
    [anon_sym_STAR_EQ] = ACTIONS(365),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(365),
    [anon_sym_SLASH_EQ] = ACTIONS(365),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(365),
    [anon_sym_PIPE_EQ] = ACTIONS(365),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(365),
    [anon_sym_AMP_EQ] = ACTIONS(365),
    [anon_sym_PERCENT_EQ] = ACTIONS(365),
    [anon_sym_GT_GT_EQ] = ACTIONS(365),
    [anon_sym_LT_LT_EQ] = ACTIONS(365),
    [anon_sym_CARET_EQ] = ACTIONS(365),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_PERCENT] = ACTIONS(377),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1205),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(7609),
    [sym_identifier] = ACTIONS(7609),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [7233] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4683),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_argument_list] = STATE(6615),
    [sym__argument_list_with_parens] = STATE(4684),
    [sym__argument] = STATE(4685),
    [sym_splat_argument] = STATE(4685),
    [sym_hash_splat_argument] = STATE(4685),
    [sym_block_argument] = STATE(4685),
    [sym_assignment] = STATE(4683),
    [sym_operator_assignment] = STATE(4683),
    [sym_conditional] = STATE(4683),
    [sym_range] = STATE(4683),
    [sym_binary] = STATE(4683),
    [sym_unary] = STATE(4683),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4686),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(4685),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(7603),
    [sym__splat_star] = ACTIONS(7605),
    [sym__unary_minus] = ACTIONS(1159),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(7607),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_EQ] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_PLUS_EQ] = ACTIONS(417),
    [anon_sym_DASH_EQ] = ACTIONS(417),
    [anon_sym_STAR_EQ] = ACTIONS(417),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(417),
    [anon_sym_SLASH_EQ] = ACTIONS(417),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(417),
    [anon_sym_PIPE_EQ] = ACTIONS(417),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(417),
    [anon_sym_AMP_EQ] = ACTIONS(417),
    [anon_sym_PERCENT_EQ] = ACTIONS(417),
    [anon_sym_GT_GT_EQ] = ACTIONS(417),
    [anon_sym_LT_LT_EQ] = ACTIONS(417),
    [anon_sym_CARET_EQ] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1205),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(7609),
    [sym_identifier] = ACTIONS(7609),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [7234] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4683),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_argument_list] = STATE(6616),
    [sym__argument_list_with_parens] = STATE(4684),
    [sym__argument] = STATE(4685),
    [sym_splat_argument] = STATE(4685),
    [sym_hash_splat_argument] = STATE(4685),
    [sym_block_argument] = STATE(4685),
    [sym_assignment] = STATE(4683),
    [sym_operator_assignment] = STATE(4683),
    [sym_conditional] = STATE(4683),
    [sym_range] = STATE(4683),
    [sym_binary] = STATE(4683),
    [sym_unary] = STATE(4683),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4686),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(4685),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(7603),
    [sym__splat_star] = ACTIONS(7605),
    [sym__unary_minus] = ACTIONS(1159),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(7607),
    [anon_sym_LBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_EQ] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_PLUS_EQ] = ACTIONS(421),
    [anon_sym_DASH_EQ] = ACTIONS(421),
    [anon_sym_STAR_EQ] = ACTIONS(421),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(421),
    [anon_sym_SLASH_EQ] = ACTIONS(421),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(421),
    [anon_sym_PIPE_EQ] = ACTIONS(421),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(421),
    [anon_sym_AMP_EQ] = ACTIONS(421),
    [anon_sym_PERCENT_EQ] = ACTIONS(421),
    [anon_sym_GT_GT_EQ] = ACTIONS(421),
    [anon_sym_LT_LT_EQ] = ACTIONS(421),
    [anon_sym_CARET_EQ] = ACTIONS(421),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1205),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(7609),
    [sym_identifier] = ACTIONS(7609),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [7235] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4683),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_argument_list] = STATE(6617),
    [sym__argument_list_with_parens] = STATE(4684),
    [sym__argument] = STATE(4685),
    [sym_splat_argument] = STATE(4685),
    [sym_hash_splat_argument] = STATE(4685),
    [sym_block_argument] = STATE(4685),
    [sym_assignment] = STATE(4683),
    [sym_operator_assignment] = STATE(4683),
    [sym_conditional] = STATE(4683),
    [sym_range] = STATE(4683),
    [sym_binary] = STATE(4683),
    [sym_unary] = STATE(4683),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4686),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(4685),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(7603),
    [sym__splat_star] = ACTIONS(7605),
    [sym__unary_minus] = ACTIONS(1159),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(7607),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(427),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_PLUS_EQ] = ACTIONS(425),
    [anon_sym_DASH_EQ] = ACTIONS(425),
    [anon_sym_STAR_EQ] = ACTIONS(425),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(425),
    [anon_sym_SLASH_EQ] = ACTIONS(425),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(425),
    [anon_sym_PIPE_EQ] = ACTIONS(425),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(425),
    [anon_sym_AMP_EQ] = ACTIONS(425),
    [anon_sym_PERCENT_EQ] = ACTIONS(425),
    [anon_sym_GT_GT_EQ] = ACTIONS(425),
    [anon_sym_LT_LT_EQ] = ACTIONS(425),
    [anon_sym_CARET_EQ] = ACTIONS(425),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1205),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(7609),
    [sym_identifier] = ACTIONS(7609),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [7236] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(9161),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(7240),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(7240),
    [sym_assignment] = STATE(9161),
    [sym_operator_assignment] = STATE(9161),
    [sym_conditional] = STATE(9161),
    [sym_range] = STATE(9161),
    [sym_binary] = STATE(9161),
    [sym_unary] = STATE(9161),
    [sym_left_assignment_list] = STATE(7239),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7240),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(7240),
    [sym_false] = STATE(7240),
    [sym_nil] = STATE(7240),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(7241),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(10782),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(10784),
    [anon_sym_yield] = ACTIONS(10786),
    [anon_sym_break] = ACTIONS(10788),
    [anon_sym_next] = ACTIONS(10790),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(10792),
    [anon_sym_defined_QMARK] = ACTIONS(10794),
    [anon_sym_not] = ACTIONS(10796),
    [anon_sym_BANG] = ACTIONS(10798),
    [anon_sym_TILDE] = ACTIONS(10798),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [7237] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(6632),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(7240),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(7240),
    [sym_assignment] = STATE(6632),
    [sym_operator_assignment] = STATE(6632),
    [sym_conditional] = STATE(6632),
    [sym_range] = STATE(6632),
    [sym_binary] = STATE(6632),
    [sym_unary] = STATE(6632),
    [sym_left_assignment_list] = STATE(7239),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7240),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(7240),
    [sym_false] = STATE(7240),
    [sym_nil] = STATE(7240),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(7241),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(10782),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(10784),
    [anon_sym_yield] = ACTIONS(10786),
    [anon_sym_break] = ACTIONS(10788),
    [anon_sym_next] = ACTIONS(10790),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(10792),
    [anon_sym_defined_QMARK] = ACTIONS(10794),
    [anon_sym_not] = ACTIONS(10796),
    [anon_sym_BANG] = ACTIONS(10798),
    [anon_sym_TILDE] = ACTIONS(10798),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [7238] = {
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(12730),
    [sym__binary_star] = ACTIONS(12732),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(12734),
    [anon_sym_STAR_STAR] = ACTIONS(12736),
    [anon_sym_AMP] = ACTIONS(12738),
    [anon_sym_EQ] = ACTIONS(4217),
    [anon_sym_LT] = ACTIONS(12740),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_PLUS_EQ] = ACTIONS(4211),
    [anon_sym_DASH_EQ] = ACTIONS(4211),
    [anon_sym_STAR_EQ] = ACTIONS(4211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4211),
    [anon_sym_SLASH_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4211),
    [anon_sym_AMP_EQ] = ACTIONS(4211),
    [anon_sym_PERCENT_EQ] = ACTIONS(4211),
    [anon_sym_GT_GT_EQ] = ACTIONS(4211),
    [anon_sym_LT_LT_EQ] = ACTIONS(4211),
    [anon_sym_CARET_EQ] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(12742),
    [anon_sym_DOT_DOT] = ACTIONS(12744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12746),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(12748),
    [anon_sym_AMP_AMP] = ACTIONS(12748),
    [anon_sym_LT_LT] = ACTIONS(12750),
    [anon_sym_GT_GT] = ACTIONS(12750),
    [anon_sym_EQ_EQ] = ACTIONS(12748),
    [anon_sym_BANG_EQ] = ACTIONS(12752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12752),
    [anon_sym_LT_EQ_GT] = ACTIONS(12752),
    [anon_sym_EQ_TILDE] = ACTIONS(12752),
    [anon_sym_BANG_TILDE] = ACTIONS(12752),
    [anon_sym_LT_EQ] = ACTIONS(12740),
    [anon_sym_GT] = ACTIONS(12740),
    [anon_sym_GT_EQ] = ACTIONS(12754),
    [anon_sym_CARET] = ACTIONS(12734),
    [anon_sym_PLUS] = ACTIONS(12756),
    [anon_sym_SLASH] = ACTIONS(12736),
    [anon_sym_PERCENT] = ACTIONS(12736),
    [sym_comment] = ACTIONS(87),
  },
  [7239] = {
    [anon_sym_EQ] = ACTIONS(12758),
    [sym_comment] = ACTIONS(87),
  },
  [7240] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(12760),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(12762),
    [anon_sym_DASH_EQ] = ACTIONS(12762),
    [anon_sym_STAR_EQ] = ACTIONS(12762),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12762),
    [anon_sym_SLASH_EQ] = ACTIONS(12762),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12762),
    [anon_sym_PIPE_EQ] = ACTIONS(12762),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12762),
    [anon_sym_AMP_EQ] = ACTIONS(12762),
    [anon_sym_PERCENT_EQ] = ACTIONS(12762),
    [anon_sym_GT_GT_EQ] = ACTIONS(12762),
    [anon_sym_LT_LT_EQ] = ACTIONS(12762),
    [anon_sym_CARET_EQ] = ACTIONS(12762),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [7241] = {
    [sym_string] = STATE(9174),
    [aux_sym_chained_string_repeat1] = STATE(9174),
    [sym__string_start] = ACTIONS(6455),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [7242] = {
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(12730),
    [sym__binary_star] = ACTIONS(12732),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(12734),
    [anon_sym_STAR_STAR] = ACTIONS(12736),
    [anon_sym_AMP] = ACTIONS(12738),
    [anon_sym_EQ] = ACTIONS(4249),
    [anon_sym_LT] = ACTIONS(12740),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_PLUS_EQ] = ACTIONS(4247),
    [anon_sym_DASH_EQ] = ACTIONS(4247),
    [anon_sym_STAR_EQ] = ACTIONS(4247),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4247),
    [anon_sym_SLASH_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4247),
    [anon_sym_AMP_EQ] = ACTIONS(4247),
    [anon_sym_PERCENT_EQ] = ACTIONS(4247),
    [anon_sym_GT_GT_EQ] = ACTIONS(4247),
    [anon_sym_LT_LT_EQ] = ACTIONS(4247),
    [anon_sym_CARET_EQ] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(12742),
    [anon_sym_DOT_DOT] = ACTIONS(12744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12746),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(12748),
    [anon_sym_AMP_AMP] = ACTIONS(12748),
    [anon_sym_LT_LT] = ACTIONS(12750),
    [anon_sym_GT_GT] = ACTIONS(12750),
    [anon_sym_EQ_EQ] = ACTIONS(12748),
    [anon_sym_BANG_EQ] = ACTIONS(12752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12752),
    [anon_sym_LT_EQ_GT] = ACTIONS(12752),
    [anon_sym_EQ_TILDE] = ACTIONS(12752),
    [anon_sym_BANG_TILDE] = ACTIONS(12752),
    [anon_sym_LT_EQ] = ACTIONS(12740),
    [anon_sym_GT] = ACTIONS(12740),
    [anon_sym_GT_EQ] = ACTIONS(12754),
    [anon_sym_CARET] = ACTIONS(12734),
    [anon_sym_PLUS] = ACTIONS(12756),
    [anon_sym_SLASH] = ACTIONS(12736),
    [anon_sym_PERCENT] = ACTIONS(12736),
    [sym_comment] = ACTIONS(87),
  },
  [7243] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(9175),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(7240),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(7240),
    [sym_assignment] = STATE(9175),
    [sym_operator_assignment] = STATE(9175),
    [sym_conditional] = STATE(9175),
    [sym_range] = STATE(9175),
    [sym_binary] = STATE(9175),
    [sym_unary] = STATE(9175),
    [sym_left_assignment_list] = STATE(7239),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7240),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(7240),
    [sym_false] = STATE(7240),
    [sym_nil] = STATE(7240),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(7241),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(10782),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(10784),
    [anon_sym_yield] = ACTIONS(10786),
    [anon_sym_break] = ACTIONS(10788),
    [anon_sym_next] = ACTIONS(10790),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(10792),
    [anon_sym_defined_QMARK] = ACTIONS(10794),
    [anon_sym_not] = ACTIONS(10796),
    [anon_sym_BANG] = ACTIONS(10798),
    [anon_sym_TILDE] = ACTIONS(10798),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [7244] = {
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(12730),
    [sym__binary_star] = ACTIONS(12732),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(12734),
    [anon_sym_STAR_STAR] = ACTIONS(12736),
    [anon_sym_AMP] = ACTIONS(12738),
    [anon_sym_EQ] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(12740),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_PLUS_EQ] = ACTIONS(3281),
    [anon_sym_DASH_EQ] = ACTIONS(3281),
    [anon_sym_STAR_EQ] = ACTIONS(3281),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3281),
    [anon_sym_SLASH_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3281),
    [anon_sym_AMP_EQ] = ACTIONS(3281),
    [anon_sym_PERCENT_EQ] = ACTIONS(3281),
    [anon_sym_GT_GT_EQ] = ACTIONS(3281),
    [anon_sym_LT_LT_EQ] = ACTIONS(3281),
    [anon_sym_CARET_EQ] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(12742),
    [anon_sym_DOT_DOT] = ACTIONS(12744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12746),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(12748),
    [anon_sym_AMP_AMP] = ACTIONS(12748),
    [anon_sym_LT_LT] = ACTIONS(12750),
    [anon_sym_GT_GT] = ACTIONS(12750),
    [anon_sym_EQ_EQ] = ACTIONS(12748),
    [anon_sym_BANG_EQ] = ACTIONS(12752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12752),
    [anon_sym_LT_EQ_GT] = ACTIONS(12752),
    [anon_sym_EQ_TILDE] = ACTIONS(12752),
    [anon_sym_BANG_TILDE] = ACTIONS(12752),
    [anon_sym_LT_EQ] = ACTIONS(12740),
    [anon_sym_GT] = ACTIONS(12740),
    [anon_sym_GT_EQ] = ACTIONS(12754),
    [anon_sym_CARET] = ACTIONS(12734),
    [anon_sym_PLUS] = ACTIONS(12756),
    [anon_sym_SLASH] = ACTIONS(12736),
    [anon_sym_PERCENT] = ACTIONS(12736),
    [sym_comment] = ACTIONS(87),
  },
  [7245] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(9176),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(7240),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(7240),
    [sym_assignment] = STATE(9176),
    [sym_operator_assignment] = STATE(9176),
    [sym_conditional] = STATE(9176),
    [sym_range] = STATE(9176),
    [sym_binary] = STATE(9176),
    [sym_unary] = STATE(9176),
    [sym_left_assignment_list] = STATE(7239),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7240),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(7240),
    [sym_false] = STATE(7240),
    [sym_nil] = STATE(7240),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(7241),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(10782),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(10784),
    [anon_sym_yield] = ACTIONS(10786),
    [anon_sym_break] = ACTIONS(10788),
    [anon_sym_next] = ACTIONS(10790),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(10792),
    [anon_sym_defined_QMARK] = ACTIONS(10794),
    [anon_sym_not] = ACTIONS(10796),
    [anon_sym_BANG] = ACTIONS(10798),
    [anon_sym_TILDE] = ACTIONS(10798),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [7246] = {
    [sym_heredoc_body] = STATE(9177),
    [aux_sym_call_repeat1] = STATE(9177),
    [sym__heredoc_body_start] = ACTIONS(6569),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [7247] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4683),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym__argument] = STATE(6674),
    [sym_splat_argument] = STATE(6674),
    [sym_hash_splat_argument] = STATE(6674),
    [sym_block_argument] = STATE(6674),
    [sym_assignment] = STATE(4683),
    [sym_operator_assignment] = STATE(4683),
    [sym_conditional] = STATE(4683),
    [sym_range] = STATE(4683),
    [sym_binary] = STATE(4683),
    [sym_unary] = STATE(4683),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4686),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_heredoc_body] = STATE(9178),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(6674),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(7603),
    [sym__splat_star] = ACTIONS(7605),
    [sym__unary_minus] = ACTIONS(1159),
    [sym__identifier_hash_key] = ACTIONS(7607),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12764),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(3469),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(7609),
    [sym_identifier] = ACTIONS(7609),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [7248] = {
    [sym_heredoc_body] = STATE(9179),
    [aux_sym_call_repeat1] = STATE(9179),
    [aux_sym_argument_list_repeat1] = STATE(9180),
    [sym__heredoc_body_start] = ACTIONS(6569),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(10804),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [7249] = {
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(7575),
    [sym__binary_star] = ACTIONS(7577),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(7579),
    [anon_sym_STAR_STAR] = ACTIONS(7577),
    [anon_sym_AMP] = ACTIONS(7581),
    [anon_sym_LT] = ACTIONS(7583),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(7585),
    [anon_sym_DOT_DOT] = ACTIONS(7587),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7589),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7593),
    [anon_sym_AMP_AMP] = ACTIONS(7593),
    [anon_sym_LT_LT] = ACTIONS(7595),
    [anon_sym_GT_GT] = ACTIONS(7595),
    [anon_sym_EQ_EQ] = ACTIONS(7597),
    [anon_sym_BANG_EQ] = ACTIONS(7593),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7593),
    [anon_sym_LT_EQ_GT] = ACTIONS(7593),
    [anon_sym_EQ_TILDE] = ACTIONS(7593),
    [anon_sym_BANG_TILDE] = ACTIONS(7593),
    [anon_sym_LT_EQ] = ACTIONS(7583),
    [anon_sym_GT] = ACTIONS(7583),
    [anon_sym_GT_EQ] = ACTIONS(7599),
    [anon_sym_CARET] = ACTIONS(7601),
    [anon_sym_PLUS] = ACTIONS(7575),
    [anon_sym_SLASH] = ACTIONS(7577),
    [anon_sym_PERCENT] = ACTIONS(7577),
    [sym_comment] = ACTIONS(87),
  },
  [7250] = {
    [aux_sym_exceptions_repeat1] = STATE(9182),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [7251] = {
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(7575),
    [sym__binary_star] = ACTIONS(7577),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(7579),
    [anon_sym_STAR_STAR] = ACTIONS(7577),
    [anon_sym_AMP] = ACTIONS(7581),
    [anon_sym_LT] = ACTIONS(7583),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(7585),
    [anon_sym_DOT_DOT] = ACTIONS(7587),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7589),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(7593),
    [anon_sym_AMP_AMP] = ACTIONS(7593),
    [anon_sym_LT_LT] = ACTIONS(7595),
    [anon_sym_GT_GT] = ACTIONS(7595),
    [anon_sym_EQ_EQ] = ACTIONS(7597),
    [anon_sym_BANG_EQ] = ACTIONS(7593),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7593),
    [anon_sym_LT_EQ_GT] = ACTIONS(7593),
    [anon_sym_EQ_TILDE] = ACTIONS(7593),
    [anon_sym_BANG_TILDE] = ACTIONS(7593),
    [anon_sym_LT_EQ] = ACTIONS(7583),
    [anon_sym_GT] = ACTIONS(7583),
    [anon_sym_GT_EQ] = ACTIONS(7599),
    [anon_sym_CARET] = ACTIONS(7601),
    [anon_sym_PLUS] = ACTIONS(7575),
    [anon_sym_SLASH] = ACTIONS(7577),
    [anon_sym_PERCENT] = ACTIONS(7577),
    [sym_comment] = ACTIONS(87),
  },
  [7252] = {
    [sym_string] = STATE(7252),
    [aux_sym_chained_string_repeat1] = STATE(7252),
    [sym__string_start] = ACTIONS(9407),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [7253] = {
    [sym__heredoc_body_start] = ACTIONS(6813),
    [anon_sym_LBRACE] = ACTIONS(6813),
    [anon_sym_RPAREN] = ACTIONS(6813),
    [anon_sym_DOT] = ACTIONS(6813),
    [anon_sym_COMMA] = ACTIONS(6813),
    [anon_sym_EQ] = ACTIONS(6813),
    [anon_sym_in] = ACTIONS(6813),
    [anon_sym_do] = ACTIONS(6813),
    [anon_sym_LBRACK] = ACTIONS(6813),
    [anon_sym_COLON_COLON2] = ACTIONS(6813),
    [anon_sym_AMP_DOT] = ACTIONS(6813),
    [sym_comment] = ACTIONS(87),
  },
  [7254] = {
    [anon_sym_DOT] = ACTIONS(11157),
    [anon_sym_LBRACK] = ACTIONS(11157),
    [anon_sym_COLON_COLON2] = ACTIONS(11157),
    [anon_sym_AMP_DOT] = ACTIONS(11157),
    [sym_comment] = ACTIONS(87),
  },
  [7255] = {
    [anon_sym_DOT] = ACTIONS(11322),
    [anon_sym_LBRACK] = ACTIONS(11322),
    [anon_sym_COLON_COLON2] = ACTIONS(11322),
    [anon_sym_AMP_DOT] = ACTIONS(11322),
    [sym_comment] = ACTIONS(87),
  },
  [7256] = {
    [anon_sym_DOT] = ACTIONS(11335),
    [anon_sym_LBRACK] = ACTIONS(11335),
    [anon_sym_COLON_COLON2] = ACTIONS(11335),
    [anon_sym_AMP_DOT] = ACTIONS(11335),
    [sym_comment] = ACTIONS(87),
  },
  [7257] = {
    [anon_sym_DOT] = ACTIONS(11344),
    [anon_sym_LBRACK] = ACTIONS(11344),
    [anon_sym_COLON_COLON2] = ACTIONS(11344),
    [anon_sym_AMP_DOT] = ACTIONS(11344),
    [sym_comment] = ACTIONS(87),
  },
  [7258] = {
    [anon_sym_DOT] = ACTIONS(11391),
    [anon_sym_LBRACK] = ACTIONS(11391),
    [anon_sym_COLON_COLON2] = ACTIONS(11391),
    [anon_sym_AMP_DOT] = ACTIONS(11391),
    [sym_comment] = ACTIONS(87),
  },
  [7259] = {
    [anon_sym_end] = ACTIONS(12766),
    [sym_comment] = ACTIONS(87),
  },
  [7260] = {
    [anon_sym_DOT] = ACTIONS(11404),
    [anon_sym_LBRACK] = ACTIONS(11404),
    [anon_sym_COLON_COLON2] = ACTIONS(11404),
    [anon_sym_AMP_DOT] = ACTIONS(11404),
    [sym_comment] = ACTIONS(87),
  },
  [7261] = {
    [anon_sym_end] = ACTIONS(12768),
    [sym_comment] = ACTIONS(87),
  },
  [7262] = {
    [sym_when] = STATE(2988),
    [sym_else] = STATE(9185),
    [aux_sym_case_repeat2] = STATE(2988),
    [anon_sym_end] = ACTIONS(12768),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [7263] = {
    [anon_sym_DOT] = ACTIONS(11846),
    [anon_sym_LBRACK] = ACTIONS(11846),
    [anon_sym_COLON_COLON2] = ACTIONS(11846),
    [anon_sym_AMP_DOT] = ACTIONS(11846),
    [sym_comment] = ACTIONS(87),
  },
  [7264] = {
    [anon_sym_end] = ACTIONS(12770),
    [sym_comment] = ACTIONS(87),
  },
  [7265] = {
    [anon_sym_LBRACE] = ACTIONS(12029),
    [anon_sym_RPAREN] = ACTIONS(12029),
    [anon_sym_DOT] = ACTIONS(12029),
    [anon_sym_COMMA] = ACTIONS(12029),
    [anon_sym_PIPE] = ACTIONS(12029),
    [anon_sym_SEMI] = ACTIONS(12029),
    [anon_sym_EQ] = ACTIONS(12029),
    [anon_sym_in] = ACTIONS(12029),
    [anon_sym_do] = ACTIONS(12029),
    [anon_sym_LBRACK] = ACTIONS(12029),
    [anon_sym_COLON_COLON2] = ACTIONS(12029),
    [anon_sym_AMP_DOT] = ACTIONS(12029),
    [sym_comment] = ACTIONS(87),
  },
  [7266] = {
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_RPAREN] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_PIPE] = ACTIONS(12054),
    [anon_sym_SEMI] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12054),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_do] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_COLON_COLON2] = ACTIONS(12054),
    [anon_sym_AMP_DOT] = ACTIONS(12054),
    [sym_comment] = ACTIONS(87),
  },
  [7267] = {
    [anon_sym_end] = ACTIONS(12772),
    [sym_comment] = ACTIONS(87),
  },
  [7268] = {
    [sym__statements] = STATE(9188),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12774),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7269] = {
    [sym__simple_symbol] = ACTIONS(7876),
    [sym__string_start] = ACTIONS(7876),
    [sym__symbol_start] = ACTIONS(7876),
    [sym__subshell_start] = ACTIONS(7876),
    [sym__regex_start] = ACTIONS(7876),
    [sym__string_array_start] = ACTIONS(7876),
    [sym__symbol_array_start] = ACTIONS(7876),
    [sym_heredoc_beginning] = ACTIONS(7876),
    [sym__block_ampersand] = ACTIONS(7876),
    [sym__splat_star] = ACTIONS(7876),
    [sym__unary_minus] = ACTIONS(7876),
    [sym__identifier_hash_key] = ACTIONS(7876),
    [anon_sym_LBRACE] = ACTIONS(7876),
    [anon_sym_def] = ACTIONS(7878),
    [anon_sym_LPAREN] = ACTIONS(7878),
    [anon_sym_RPAREN] = ACTIONS(7876),
    [anon_sym_DOT] = ACTIONS(7876),
    [anon_sym_COLON_COLON] = ACTIONS(7878),
    [anon_sym_COMMA] = ACTIONS(7876),
    [anon_sym_STAR] = ACTIONS(7878),
    [anon_sym_STAR_STAR] = ACTIONS(7876),
    [anon_sym_EQ] = ACTIONS(7876),
    [anon_sym_class] = ACTIONS(7878),
    [anon_sym_module] = ACTIONS(7878),
    [anon_sym_return] = ACTIONS(7878),
    [anon_sym_yield] = ACTIONS(7878),
    [anon_sym_break] = ACTIONS(7878),
    [anon_sym_next] = ACTIONS(7878),
    [sym_redo] = ACTIONS(7878),
    [sym_retry] = ACTIONS(7878),
    [anon_sym_if] = ACTIONS(7878),
    [anon_sym_unless] = ACTIONS(7878),
    [anon_sym_while] = ACTIONS(7878),
    [anon_sym_until] = ACTIONS(7878),
    [anon_sym_for] = ACTIONS(7878),
    [anon_sym_in] = ACTIONS(7878),
    [anon_sym_do] = ACTIONS(7878),
    [anon_sym_case] = ACTIONS(7878),
    [anon_sym_begin] = ACTIONS(7878),
    [anon_sym_LBRACK] = ACTIONS(7876),
    [anon_sym_COLON_COLON2] = ACTIONS(7876),
    [anon_sym_AMP_DOT] = ACTIONS(7876),
    [anon_sym_LPAREN2] = ACTIONS(7876),
    [anon_sym_PLUS] = ACTIONS(7878),
    [anon_sym_defined_QMARK] = ACTIONS(7876),
    [anon_sym_not] = ACTIONS(7878),
    [anon_sym_BANG] = ACTIONS(7876),
    [anon_sym_TILDE] = ACTIONS(7876),
    [sym_constant] = ACTIONS(7878),
    [sym_identifier] = ACTIONS(7878),
    [sym_instance_variable] = ACTIONS(7876),
    [sym_class_variable] = ACTIONS(7876),
    [sym_global_variable] = ACTIONS(7876),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(7878),
    [sym_float] = ACTIONS(7878),
    [sym_complex] = ACTIONS(7876),
    [sym_super] = ACTIONS(7878),
    [anon_sym_true] = ACTIONS(7878),
    [anon_sym_TRUE] = ACTIONS(7878),
    [anon_sym_false] = ACTIONS(7878),
    [anon_sym_FALSE] = ACTIONS(7878),
    [sym_self] = ACTIONS(7878),
    [anon_sym_nil] = ACTIONS(7878),
    [anon_sym_NIL] = ACTIONS(7878),
    [sym_character] = ACTIONS(7876),
    [anon_sym_LBRACK2] = ACTIONS(7878),
    [anon_sym_DASH_GT] = ACTIONS(7876),
  },
  [7270] = {
    [sym__string_start] = ACTIONS(3030),
    [sym__heredoc_body_start] = ACTIONS(3030),
    [sym__binary_minus] = ACTIONS(3030),
    [sym__binary_star] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3030),
    [anon_sym_RPAREN] = ACTIONS(3030),
    [anon_sym_DOT] = ACTIONS(3032),
    [anon_sym_COMMA] = ACTIONS(3030),
    [anon_sym_PIPE] = ACTIONS(3032),
    [anon_sym_STAR_STAR] = ACTIONS(3030),
    [anon_sym_AMP] = ACTIONS(3032),
    [anon_sym_EQ] = ACTIONS(3032),
    [anon_sym_LT] = ACTIONS(3032),
    [anon_sym_do] = ACTIONS(3030),
    [anon_sym_LBRACK] = ACTIONS(3030),
    [anon_sym_COLON_COLON2] = ACTIONS(3030),
    [anon_sym_AMP_DOT] = ACTIONS(3030),
    [anon_sym_QMARK] = ACTIONS(3030),
    [anon_sym_COLON2] = ACTIONS(3032),
    [anon_sym_DOT_DOT] = ACTIONS(3032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3030),
    [anon_sym_and] = ACTIONS(3030),
    [anon_sym_or] = ACTIONS(3030),
    [anon_sym_PIPE_PIPE] = ACTIONS(3030),
    [anon_sym_AMP_AMP] = ACTIONS(3030),
    [anon_sym_LT_LT] = ACTIONS(3030),
    [anon_sym_GT_GT] = ACTIONS(3030),
    [anon_sym_EQ_EQ] = ACTIONS(3032),
    [anon_sym_BANG_EQ] = ACTIONS(3030),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3030),
    [anon_sym_LT_EQ_GT] = ACTIONS(3030),
    [anon_sym_EQ_TILDE] = ACTIONS(3030),
    [anon_sym_BANG_TILDE] = ACTIONS(3030),
    [anon_sym_LT_EQ] = ACTIONS(3032),
    [anon_sym_GT] = ACTIONS(3032),
    [anon_sym_GT_EQ] = ACTIONS(3030),
    [anon_sym_CARET] = ACTIONS(3030),
    [anon_sym_PLUS] = ACTIONS(3030),
    [anon_sym_SLASH] = ACTIONS(3030),
    [anon_sym_PERCENT] = ACTIONS(3030),
    [sym_comment] = ACTIONS(87),
  },
  [7271] = {
    [sym__heredoc_body_start] = ACTIONS(3042),
    [sym__binary_minus] = ACTIONS(3042),
    [sym__binary_star] = ACTIONS(3042),
    [anon_sym_LBRACE] = ACTIONS(3042),
    [anon_sym_RPAREN] = ACTIONS(3042),
    [anon_sym_DOT] = ACTIONS(3044),
    [anon_sym_COMMA] = ACTIONS(3042),
    [anon_sym_PIPE] = ACTIONS(3044),
    [anon_sym_STAR_STAR] = ACTIONS(3042),
    [anon_sym_AMP] = ACTIONS(3044),
    [anon_sym_EQ] = ACTIONS(3044),
    [anon_sym_LT] = ACTIONS(3044),
    [anon_sym_do] = ACTIONS(3042),
    [anon_sym_LBRACK] = ACTIONS(3042),
    [anon_sym_COLON_COLON2] = ACTIONS(3042),
    [anon_sym_AMP_DOT] = ACTIONS(3042),
    [anon_sym_QMARK] = ACTIONS(3042),
    [anon_sym_DOT_DOT] = ACTIONS(3044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3042),
    [anon_sym_and] = ACTIONS(3042),
    [anon_sym_or] = ACTIONS(3042),
    [anon_sym_PIPE_PIPE] = ACTIONS(3042),
    [anon_sym_AMP_AMP] = ACTIONS(3042),
    [anon_sym_LT_LT] = ACTIONS(3042),
    [anon_sym_GT_GT] = ACTIONS(3042),
    [anon_sym_EQ_EQ] = ACTIONS(3044),
    [anon_sym_BANG_EQ] = ACTIONS(3042),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3042),
    [anon_sym_LT_EQ_GT] = ACTIONS(3042),
    [anon_sym_EQ_TILDE] = ACTIONS(3042),
    [anon_sym_BANG_TILDE] = ACTIONS(3042),
    [anon_sym_LT_EQ] = ACTIONS(3044),
    [anon_sym_GT] = ACTIONS(3044),
    [anon_sym_GT_EQ] = ACTIONS(3042),
    [anon_sym_CARET] = ACTIONS(3042),
    [anon_sym_PLUS] = ACTIONS(3042),
    [anon_sym_SLASH] = ACTIONS(3042),
    [anon_sym_PERCENT] = ACTIONS(3042),
    [sym_comment] = ACTIONS(87),
  },
  [7272] = {
    [sym__heredoc_body_start] = ACTIONS(3046),
    [sym__binary_minus] = ACTIONS(3046),
    [sym__binary_star] = ACTIONS(3046),
    [anon_sym_LBRACE] = ACTIONS(3046),
    [anon_sym_RPAREN] = ACTIONS(3046),
    [anon_sym_DOT] = ACTIONS(3048),
    [anon_sym_COMMA] = ACTIONS(3046),
    [anon_sym_PIPE] = ACTIONS(3048),
    [anon_sym_STAR_STAR] = ACTIONS(3046),
    [anon_sym_AMP] = ACTIONS(3048),
    [anon_sym_EQ] = ACTIONS(3048),
    [anon_sym_LT] = ACTIONS(3048),
    [anon_sym_do] = ACTIONS(3046),
    [anon_sym_LBRACK] = ACTIONS(3046),
    [anon_sym_COLON_COLON2] = ACTIONS(3046),
    [anon_sym_AMP_DOT] = ACTIONS(3046),
    [anon_sym_QMARK] = ACTIONS(3046),
    [anon_sym_DOT_DOT] = ACTIONS(3048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3046),
    [anon_sym_and] = ACTIONS(3046),
    [anon_sym_or] = ACTIONS(3046),
    [anon_sym_PIPE_PIPE] = ACTIONS(3046),
    [anon_sym_AMP_AMP] = ACTIONS(3046),
    [anon_sym_LT_LT] = ACTIONS(3046),
    [anon_sym_GT_GT] = ACTIONS(3046),
    [anon_sym_EQ_EQ] = ACTIONS(3048),
    [anon_sym_BANG_EQ] = ACTIONS(3046),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3046),
    [anon_sym_LT_EQ_GT] = ACTIONS(3046),
    [anon_sym_EQ_TILDE] = ACTIONS(3046),
    [anon_sym_BANG_TILDE] = ACTIONS(3046),
    [anon_sym_LT_EQ] = ACTIONS(3048),
    [anon_sym_GT] = ACTIONS(3048),
    [anon_sym_GT_EQ] = ACTIONS(3046),
    [anon_sym_CARET] = ACTIONS(3046),
    [anon_sym_PLUS] = ACTIONS(3046),
    [anon_sym_SLASH] = ACTIONS(3046),
    [anon_sym_PERCENT] = ACTIONS(3046),
    [sym_comment] = ACTIONS(87),
  },
  [7273] = {
    [sym__heredoc_body_start] = ACTIONS(3050),
    [sym__binary_minus] = ACTIONS(3050),
    [sym__binary_star] = ACTIONS(3050),
    [anon_sym_LBRACE] = ACTIONS(3050),
    [anon_sym_RPAREN] = ACTIONS(3050),
    [anon_sym_DOT] = ACTIONS(3052),
    [anon_sym_COMMA] = ACTIONS(3050),
    [anon_sym_PIPE] = ACTIONS(3052),
    [anon_sym_STAR_STAR] = ACTIONS(3050),
    [anon_sym_AMP] = ACTIONS(3052),
    [anon_sym_EQ] = ACTIONS(3052),
    [anon_sym_LT] = ACTIONS(3052),
    [anon_sym_do] = ACTIONS(3050),
    [anon_sym_LBRACK] = ACTIONS(3050),
    [anon_sym_COLON_COLON2] = ACTIONS(3050),
    [anon_sym_AMP_DOT] = ACTIONS(3050),
    [anon_sym_QMARK] = ACTIONS(3050),
    [anon_sym_DOT_DOT] = ACTIONS(3052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3050),
    [anon_sym_and] = ACTIONS(3050),
    [anon_sym_or] = ACTIONS(3050),
    [anon_sym_PIPE_PIPE] = ACTIONS(3050),
    [anon_sym_AMP_AMP] = ACTIONS(3050),
    [anon_sym_LT_LT] = ACTIONS(3050),
    [anon_sym_GT_GT] = ACTIONS(3050),
    [anon_sym_EQ_EQ] = ACTIONS(3052),
    [anon_sym_BANG_EQ] = ACTIONS(3050),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3050),
    [anon_sym_LT_EQ_GT] = ACTIONS(3050),
    [anon_sym_EQ_TILDE] = ACTIONS(3050),
    [anon_sym_BANG_TILDE] = ACTIONS(3050),
    [anon_sym_LT_EQ] = ACTIONS(3052),
    [anon_sym_GT] = ACTIONS(3052),
    [anon_sym_GT_EQ] = ACTIONS(3050),
    [anon_sym_CARET] = ACTIONS(3050),
    [anon_sym_PLUS] = ACTIONS(3050),
    [anon_sym_SLASH] = ACTIONS(3050),
    [anon_sym_PERCENT] = ACTIONS(3050),
    [sym_comment] = ACTIONS(87),
  },
  [7274] = {
    [sym__heredoc_body_start] = ACTIONS(3056),
    [sym__binary_minus] = ACTIONS(3056),
    [sym__binary_star] = ACTIONS(3056),
    [anon_sym_LBRACE] = ACTIONS(3056),
    [anon_sym_RPAREN] = ACTIONS(3056),
    [anon_sym_DOT] = ACTIONS(3058),
    [anon_sym_COMMA] = ACTIONS(3056),
    [anon_sym_PIPE] = ACTIONS(3058),
    [anon_sym_STAR_STAR] = ACTIONS(3056),
    [anon_sym_AMP] = ACTIONS(3058),
    [anon_sym_EQ] = ACTIONS(3058),
    [anon_sym_LT] = ACTIONS(3058),
    [anon_sym_do] = ACTIONS(3056),
    [anon_sym_LBRACK] = ACTIONS(3056),
    [anon_sym_COLON_COLON2] = ACTIONS(3056),
    [anon_sym_AMP_DOT] = ACTIONS(3056),
    [anon_sym_QMARK] = ACTIONS(3056),
    [anon_sym_DOT_DOT] = ACTIONS(3058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3056),
    [anon_sym_and] = ACTIONS(3056),
    [anon_sym_or] = ACTIONS(3056),
    [anon_sym_PIPE_PIPE] = ACTIONS(3056),
    [anon_sym_AMP_AMP] = ACTIONS(3056),
    [anon_sym_LT_LT] = ACTIONS(3056),
    [anon_sym_GT_GT] = ACTIONS(3056),
    [anon_sym_EQ_EQ] = ACTIONS(3058),
    [anon_sym_BANG_EQ] = ACTIONS(3056),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3056),
    [anon_sym_LT_EQ_GT] = ACTIONS(3056),
    [anon_sym_EQ_TILDE] = ACTIONS(3056),
    [anon_sym_BANG_TILDE] = ACTIONS(3056),
    [anon_sym_LT_EQ] = ACTIONS(3058),
    [anon_sym_GT] = ACTIONS(3058),
    [anon_sym_GT_EQ] = ACTIONS(3056),
    [anon_sym_CARET] = ACTIONS(3056),
    [anon_sym_PLUS] = ACTIONS(3056),
    [anon_sym_SLASH] = ACTIONS(3056),
    [anon_sym_PERCENT] = ACTIONS(3056),
    [sym_comment] = ACTIONS(87),
  },
  [7275] = {
    [sym__string_end] = ACTIONS(12776),
    [sym_comment] = ACTIONS(87),
  },
  [7276] = {
    [aux_sym_string_array_repeat1] = STATE(9192),
    [sym__string_end] = ACTIONS(12778),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(12780),
  },
  [7277] = {
    [sym__heredoc_body_start] = ACTIONS(3066),
    [sym__binary_minus] = ACTIONS(3066),
    [sym__binary_star] = ACTIONS(3066),
    [anon_sym_LBRACE] = ACTIONS(3066),
    [anon_sym_RPAREN] = ACTIONS(3066),
    [anon_sym_DOT] = ACTIONS(3068),
    [anon_sym_COMMA] = ACTIONS(3066),
    [anon_sym_PIPE] = ACTIONS(3068),
    [anon_sym_STAR_STAR] = ACTIONS(3066),
    [anon_sym_AMP] = ACTIONS(3068),
    [anon_sym_EQ] = ACTIONS(3068),
    [anon_sym_LT] = ACTIONS(3068),
    [anon_sym_do] = ACTIONS(3066),
    [anon_sym_LBRACK] = ACTIONS(3066),
    [anon_sym_COLON_COLON2] = ACTIONS(3066),
    [anon_sym_AMP_DOT] = ACTIONS(3066),
    [anon_sym_QMARK] = ACTIONS(3066),
    [anon_sym_DOT_DOT] = ACTIONS(3068),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3066),
    [anon_sym_and] = ACTIONS(3066),
    [anon_sym_or] = ACTIONS(3066),
    [anon_sym_PIPE_PIPE] = ACTIONS(3066),
    [anon_sym_AMP_AMP] = ACTIONS(3066),
    [anon_sym_LT_LT] = ACTIONS(3066),
    [anon_sym_GT_GT] = ACTIONS(3066),
    [anon_sym_EQ_EQ] = ACTIONS(3068),
    [anon_sym_BANG_EQ] = ACTIONS(3066),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3066),
    [anon_sym_LT_EQ_GT] = ACTIONS(3066),
    [anon_sym_EQ_TILDE] = ACTIONS(3066),
    [anon_sym_BANG_TILDE] = ACTIONS(3066),
    [anon_sym_LT_EQ] = ACTIONS(3068),
    [anon_sym_GT] = ACTIONS(3068),
    [anon_sym_GT_EQ] = ACTIONS(3066),
    [anon_sym_CARET] = ACTIONS(3066),
    [anon_sym_PLUS] = ACTIONS(3066),
    [anon_sym_SLASH] = ACTIONS(3066),
    [anon_sym_PERCENT] = ACTIONS(3066),
    [sym_comment] = ACTIONS(87),
  },
  [7278] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1697),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(12782),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [7279] = {
    [aux_sym_string_array_repeat1] = STATE(1699),
    [sym__string_end] = ACTIONS(12782),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(12784),
  },
  [7280] = {
    [sym__heredoc_body_start] = ACTIONS(3085),
    [sym__binary_minus] = ACTIONS(3085),
    [sym__binary_star] = ACTIONS(3085),
    [anon_sym_LBRACE] = ACTIONS(3085),
    [anon_sym_RPAREN] = ACTIONS(3085),
    [anon_sym_DOT] = ACTIONS(3087),
    [anon_sym_COMMA] = ACTIONS(3085),
    [anon_sym_PIPE] = ACTIONS(3087),
    [anon_sym_STAR_STAR] = ACTIONS(3085),
    [anon_sym_AMP] = ACTIONS(3087),
    [anon_sym_EQ] = ACTIONS(3087),
    [anon_sym_LT] = ACTIONS(3087),
    [anon_sym_do] = ACTIONS(3085),
    [anon_sym_LBRACK] = ACTIONS(3085),
    [anon_sym_COLON_COLON2] = ACTIONS(3085),
    [anon_sym_AMP_DOT] = ACTIONS(3085),
    [anon_sym_QMARK] = ACTIONS(3085),
    [anon_sym_DOT_DOT] = ACTIONS(3087),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3085),
    [anon_sym_and] = ACTIONS(3085),
    [anon_sym_or] = ACTIONS(3085),
    [anon_sym_PIPE_PIPE] = ACTIONS(3085),
    [anon_sym_AMP_AMP] = ACTIONS(3085),
    [anon_sym_LT_LT] = ACTIONS(3085),
    [anon_sym_GT_GT] = ACTIONS(3085),
    [anon_sym_EQ_EQ] = ACTIONS(3087),
    [anon_sym_BANG_EQ] = ACTIONS(3085),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3085),
    [anon_sym_LT_EQ_GT] = ACTIONS(3085),
    [anon_sym_EQ_TILDE] = ACTIONS(3085),
    [anon_sym_BANG_TILDE] = ACTIONS(3085),
    [anon_sym_LT_EQ] = ACTIONS(3087),
    [anon_sym_GT] = ACTIONS(3087),
    [anon_sym_GT_EQ] = ACTIONS(3085),
    [anon_sym_CARET] = ACTIONS(3085),
    [anon_sym_PLUS] = ACTIONS(3085),
    [anon_sym_SLASH] = ACTIONS(3085),
    [anon_sym_PERCENT] = ACTIONS(3085),
    [sym_comment] = ACTIONS(87),
  },
  [7281] = {
    [sym__string_end] = ACTIONS(12786),
    [sym_comment] = ACTIONS(87),
  },
  [7282] = {
    [aux_sym_symbol_array_repeat1] = STATE(9198),
    [sym__string_end] = ACTIONS(12788),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(12790),
  },
  [7283] = {
    [sym__heredoc_body_start] = ACTIONS(3095),
    [sym__binary_minus] = ACTIONS(3095),
    [sym__binary_star] = ACTIONS(3095),
    [anon_sym_LBRACE] = ACTIONS(3095),
    [anon_sym_RPAREN] = ACTIONS(3095),
    [anon_sym_DOT] = ACTIONS(3097),
    [anon_sym_COMMA] = ACTIONS(3095),
    [anon_sym_PIPE] = ACTIONS(3097),
    [anon_sym_STAR_STAR] = ACTIONS(3095),
    [anon_sym_AMP] = ACTIONS(3097),
    [anon_sym_EQ] = ACTIONS(3097),
    [anon_sym_LT] = ACTIONS(3097),
    [anon_sym_do] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3095),
    [anon_sym_COLON_COLON2] = ACTIONS(3095),
    [anon_sym_AMP_DOT] = ACTIONS(3095),
    [anon_sym_QMARK] = ACTIONS(3095),
    [anon_sym_DOT_DOT] = ACTIONS(3097),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3095),
    [anon_sym_and] = ACTIONS(3095),
    [anon_sym_or] = ACTIONS(3095),
    [anon_sym_PIPE_PIPE] = ACTIONS(3095),
    [anon_sym_AMP_AMP] = ACTIONS(3095),
    [anon_sym_LT_LT] = ACTIONS(3095),
    [anon_sym_GT_GT] = ACTIONS(3095),
    [anon_sym_EQ_EQ] = ACTIONS(3097),
    [anon_sym_BANG_EQ] = ACTIONS(3095),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3095),
    [anon_sym_LT_EQ_GT] = ACTIONS(3095),
    [anon_sym_EQ_TILDE] = ACTIONS(3095),
    [anon_sym_BANG_TILDE] = ACTIONS(3095),
    [anon_sym_LT_EQ] = ACTIONS(3097),
    [anon_sym_GT] = ACTIONS(3097),
    [anon_sym_GT_EQ] = ACTIONS(3095),
    [anon_sym_CARET] = ACTIONS(3095),
    [anon_sym_PLUS] = ACTIONS(3095),
    [anon_sym_SLASH] = ACTIONS(3095),
    [anon_sym_PERCENT] = ACTIONS(3095),
    [sym_comment] = ACTIONS(87),
  },
  [7284] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1705),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(12792),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [7285] = {
    [aux_sym_symbol_array_repeat1] = STATE(1707),
    [sym__string_end] = ACTIONS(12792),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(12794),
  },
  [7286] = {
    [sym__heredoc_body_start] = ACTIONS(3575),
    [sym__binary_minus] = ACTIONS(3575),
    [sym__binary_star] = ACTIONS(3575),
    [anon_sym_LBRACE] = ACTIONS(3575),
    [anon_sym_RPAREN] = ACTIONS(3575),
    [anon_sym_DOT] = ACTIONS(3577),
    [anon_sym_COMMA] = ACTIONS(3575),
    [anon_sym_PIPE] = ACTIONS(3577),
    [anon_sym_STAR_STAR] = ACTIONS(3575),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_EQ] = ACTIONS(3577),
    [anon_sym_LT] = ACTIONS(3577),
    [anon_sym_do] = ACTIONS(3575),
    [anon_sym_LBRACK] = ACTIONS(3575),
    [anon_sym_COLON_COLON2] = ACTIONS(3575),
    [anon_sym_AMP_DOT] = ACTIONS(3575),
    [anon_sym_QMARK] = ACTIONS(3575),
    [anon_sym_DOT_DOT] = ACTIONS(3577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3575),
    [anon_sym_and] = ACTIONS(3575),
    [anon_sym_or] = ACTIONS(3575),
    [anon_sym_PIPE_PIPE] = ACTIONS(3575),
    [anon_sym_AMP_AMP] = ACTIONS(3575),
    [anon_sym_LT_LT] = ACTIONS(3575),
    [anon_sym_GT_GT] = ACTIONS(3575),
    [anon_sym_EQ_EQ] = ACTIONS(3577),
    [anon_sym_BANG_EQ] = ACTIONS(3575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3575),
    [anon_sym_LT_EQ_GT] = ACTIONS(3575),
    [anon_sym_EQ_TILDE] = ACTIONS(3575),
    [anon_sym_BANG_TILDE] = ACTIONS(3575),
    [anon_sym_LT_EQ] = ACTIONS(3577),
    [anon_sym_GT] = ACTIONS(3577),
    [anon_sym_GT_EQ] = ACTIONS(3575),
    [anon_sym_CARET] = ACTIONS(3575),
    [anon_sym_PLUS] = ACTIONS(3575),
    [anon_sym_SLASH] = ACTIONS(3575),
    [anon_sym_PERCENT] = ACTIONS(3575),
    [sym_comment] = ACTIONS(87),
  },
  [7287] = {
    [anon_sym_RBRACE] = ACTIONS(12796),
    [sym_comment] = ACTIONS(87),
  },
  [7288] = {
    [sym__binary_minus] = ACTIONS(3609),
    [sym__binary_star] = ACTIONS(3611),
    [anon_sym_RPAREN] = ACTIONS(12798),
    [anon_sym_PIPE] = ACTIONS(3615),
    [anon_sym_STAR_STAR] = ACTIONS(3611),
    [anon_sym_AMP] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3619),
    [anon_sym_QMARK] = ACTIONS(3621),
    [anon_sym_DOT_DOT] = ACTIONS(3623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3625),
    [anon_sym_and] = ACTIONS(3627),
    [anon_sym_or] = ACTIONS(3627),
    [anon_sym_PIPE_PIPE] = ACTIONS(3629),
    [anon_sym_AMP_AMP] = ACTIONS(3629),
    [anon_sym_LT_LT] = ACTIONS(3631),
    [anon_sym_GT_GT] = ACTIONS(3631),
    [anon_sym_EQ_EQ] = ACTIONS(3633),
    [anon_sym_BANG_EQ] = ACTIONS(3629),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3629),
    [anon_sym_LT_EQ_GT] = ACTIONS(3629),
    [anon_sym_EQ_TILDE] = ACTIONS(3629),
    [anon_sym_BANG_TILDE] = ACTIONS(3629),
    [anon_sym_LT_EQ] = ACTIONS(3619),
    [anon_sym_GT] = ACTIONS(3619),
    [anon_sym_GT_EQ] = ACTIONS(3635),
    [anon_sym_CARET] = ACTIONS(3637),
    [anon_sym_PLUS] = ACTIONS(3609),
    [anon_sym_SLASH] = ACTIONS(3611),
    [anon_sym_PERCENT] = ACTIONS(3611),
    [sym_comment] = ACTIONS(87),
  },
  [7289] = {
    [sym__method_rest] = STATE(9203),
    [sym_operator] = STATE(4746),
    [sym__method_name] = STATE(4746),
    [sym_setter] = STATE(4746),
    [sym_symbol] = STATE(4746),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(12800),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(12800),
    [sym_class_variable] = ACTIONS(12800),
    [sym_global_variable] = ACTIONS(12800),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [7290] = {
    [sym__statements] = STATE(4775),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(4776),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(4777),
    [sym_rescue] = STATE(4778),
    [sym__body_statement] = STATE(9204),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12802),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7291] = {
    [sym__heredoc_body_start] = ACTIONS(3805),
    [sym__binary_minus] = ACTIONS(3805),
    [sym__binary_star] = ACTIONS(3805),
    [anon_sym_LBRACE] = ACTIONS(3805),
    [anon_sym_RPAREN] = ACTIONS(3805),
    [anon_sym_DOT] = ACTIONS(3807),
    [anon_sym_COMMA] = ACTIONS(3805),
    [anon_sym_PIPE] = ACTIONS(3807),
    [anon_sym_STAR_STAR] = ACTIONS(3805),
    [anon_sym_AMP] = ACTIONS(3807),
    [anon_sym_EQ] = ACTIONS(3807),
    [anon_sym_LT] = ACTIONS(3807),
    [anon_sym_do] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(3805),
    [anon_sym_COLON_COLON2] = ACTIONS(3805),
    [anon_sym_AMP_DOT] = ACTIONS(3805),
    [anon_sym_QMARK] = ACTIONS(3805),
    [anon_sym_DOT_DOT] = ACTIONS(3807),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3805),
    [anon_sym_and] = ACTIONS(3805),
    [anon_sym_or] = ACTIONS(3805),
    [anon_sym_PIPE_PIPE] = ACTIONS(3805),
    [anon_sym_AMP_AMP] = ACTIONS(3805),
    [anon_sym_LT_LT] = ACTIONS(3805),
    [anon_sym_GT_GT] = ACTIONS(3805),
    [anon_sym_EQ_EQ] = ACTIONS(3807),
    [anon_sym_BANG_EQ] = ACTIONS(3805),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3805),
    [anon_sym_LT_EQ_GT] = ACTIONS(3805),
    [anon_sym_EQ_TILDE] = ACTIONS(3805),
    [anon_sym_BANG_TILDE] = ACTIONS(3805),
    [anon_sym_LT_EQ] = ACTIONS(3807),
    [anon_sym_GT] = ACTIONS(3807),
    [anon_sym_GT_EQ] = ACTIONS(3805),
    [anon_sym_CARET] = ACTIONS(3805),
    [anon_sym_PLUS] = ACTIONS(3805),
    [anon_sym_SLASH] = ACTIONS(3805),
    [anon_sym_PERCENT] = ACTIONS(3805),
    [sym_comment] = ACTIONS(87),
  },
  [7292] = {
    [sym_heredoc_body] = STATE(9205),
    [sym__terminator] = STATE(9205),
    [sym__line_break] = ACTIONS(12804),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym__binary_minus] = ACTIONS(2001),
    [sym__binary_star] = ACTIONS(2003),
    [anon_sym_PIPE] = ACTIONS(2005),
    [anon_sym_SEMI] = ACTIONS(12804),
    [anon_sym_STAR_STAR] = ACTIONS(2003),
    [anon_sym_AMP] = ACTIONS(2007),
    [anon_sym_LT] = ACTIONS(2009),
    [anon_sym_QMARK] = ACTIONS(2011),
    [anon_sym_DOT_DOT] = ACTIONS(2013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2015),
    [anon_sym_and] = ACTIONS(2017),
    [anon_sym_or] = ACTIONS(2017),
    [anon_sym_PIPE_PIPE] = ACTIONS(2019),
    [anon_sym_AMP_AMP] = ACTIONS(2019),
    [anon_sym_LT_LT] = ACTIONS(2021),
    [anon_sym_GT_GT] = ACTIONS(2021),
    [anon_sym_EQ_EQ] = ACTIONS(2023),
    [anon_sym_BANG_EQ] = ACTIONS(2019),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2019),
    [anon_sym_LT_EQ_GT] = ACTIONS(2019),
    [anon_sym_EQ_TILDE] = ACTIONS(2019),
    [anon_sym_BANG_TILDE] = ACTIONS(2019),
    [anon_sym_LT_EQ] = ACTIONS(2009),
    [anon_sym_GT] = ACTIONS(2009),
    [anon_sym_GT_EQ] = ACTIONS(2025),
    [anon_sym_CARET] = ACTIONS(2027),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_SLASH] = ACTIONS(2003),
    [anon_sym_PERCENT] = ACTIONS(2003),
    [sym_comment] = ACTIONS(87),
  },
  [7293] = {
    [sym_heredoc_body] = STATE(9206),
    [sym__terminator] = STATE(9206),
    [sym__line_break] = ACTIONS(12806),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(12806),
    [sym_comment] = ACTIONS(87),
  },
  [7294] = {
    [sym__statements] = STATE(4775),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(4776),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(4777),
    [sym_rescue] = STATE(4778),
    [sym__body_statement] = STATE(9207),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12808),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7295] = {
    [sym__heredoc_body_start] = ACTIONS(4205),
    [sym__binary_minus] = ACTIONS(4205),
    [sym__binary_star] = ACTIONS(4205),
    [anon_sym_LBRACE] = ACTIONS(4205),
    [anon_sym_RPAREN] = ACTIONS(4205),
    [anon_sym_DOT] = ACTIONS(4207),
    [anon_sym_COMMA] = ACTIONS(4205),
    [anon_sym_PIPE] = ACTIONS(4207),
    [anon_sym_STAR_STAR] = ACTIONS(4205),
    [anon_sym_AMP] = ACTIONS(4207),
    [anon_sym_EQ] = ACTIONS(4207),
    [anon_sym_LT] = ACTIONS(4207),
    [anon_sym_do] = ACTIONS(4205),
    [anon_sym_LBRACK] = ACTIONS(4205),
    [anon_sym_COLON_COLON2] = ACTIONS(4205),
    [anon_sym_AMP_DOT] = ACTIONS(4205),
    [anon_sym_QMARK] = ACTIONS(4205),
    [anon_sym_DOT_DOT] = ACTIONS(4207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4205),
    [anon_sym_and] = ACTIONS(4205),
    [anon_sym_or] = ACTIONS(4205),
    [anon_sym_PIPE_PIPE] = ACTIONS(4205),
    [anon_sym_AMP_AMP] = ACTIONS(4205),
    [anon_sym_LT_LT] = ACTIONS(4205),
    [anon_sym_GT_GT] = ACTIONS(4205),
    [anon_sym_EQ_EQ] = ACTIONS(4207),
    [anon_sym_BANG_EQ] = ACTIONS(4205),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4205),
    [anon_sym_LT_EQ_GT] = ACTIONS(4205),
    [anon_sym_EQ_TILDE] = ACTIONS(4205),
    [anon_sym_BANG_TILDE] = ACTIONS(4205),
    [anon_sym_LT_EQ] = ACTIONS(4207),
    [anon_sym_GT] = ACTIONS(4207),
    [anon_sym_GT_EQ] = ACTIONS(4205),
    [anon_sym_CARET] = ACTIONS(4205),
    [anon_sym_PLUS] = ACTIONS(4205),
    [anon_sym_SLASH] = ACTIONS(4205),
    [anon_sym_PERCENT] = ACTIONS(4205),
    [sym_comment] = ACTIONS(87),
  },
  [7296] = {
    [sym__statements] = STATE(4775),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(4776),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(4777),
    [sym_rescue] = STATE(4778),
    [sym__body_statement] = STATE(9208),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12810),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7297] = {
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(7711),
    [sym__binary_star] = ACTIONS(7713),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(7715),
    [anon_sym_STAR_STAR] = ACTIONS(7713),
    [anon_sym_AMP] = ACTIONS(7717),
    [anon_sym_EQ] = ACTIONS(4217),
    [anon_sym_LT] = ACTIONS(7719),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(7721),
    [anon_sym_DOT_DOT] = ACTIONS(7723),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7725),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(7729),
    [anon_sym_AMP_AMP] = ACTIONS(7729),
    [anon_sym_LT_LT] = ACTIONS(7731),
    [anon_sym_GT_GT] = ACTIONS(7731),
    [anon_sym_EQ_EQ] = ACTIONS(7733),
    [anon_sym_BANG_EQ] = ACTIONS(7729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7729),
    [anon_sym_LT_EQ_GT] = ACTIONS(7729),
    [anon_sym_EQ_TILDE] = ACTIONS(7729),
    [anon_sym_BANG_TILDE] = ACTIONS(7729),
    [anon_sym_LT_EQ] = ACTIONS(7719),
    [anon_sym_GT] = ACTIONS(7719),
    [anon_sym_GT_EQ] = ACTIONS(7735),
    [anon_sym_CARET] = ACTIONS(7737),
    [anon_sym_PLUS] = ACTIONS(7711),
    [anon_sym_SLASH] = ACTIONS(7713),
    [anon_sym_PERCENT] = ACTIONS(7713),
    [sym_comment] = ACTIONS(87),
  },
  [7298] = {
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(7711),
    [sym__binary_star] = ACTIONS(7713),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(7715),
    [anon_sym_STAR_STAR] = ACTIONS(7713),
    [anon_sym_AMP] = ACTIONS(7717),
    [anon_sym_EQ] = ACTIONS(4249),
    [anon_sym_LT] = ACTIONS(7719),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(7721),
    [anon_sym_DOT_DOT] = ACTIONS(7723),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7725),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(7729),
    [anon_sym_AMP_AMP] = ACTIONS(7729),
    [anon_sym_LT_LT] = ACTIONS(7731),
    [anon_sym_GT_GT] = ACTIONS(7731),
    [anon_sym_EQ_EQ] = ACTIONS(7733),
    [anon_sym_BANG_EQ] = ACTIONS(7729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7729),
    [anon_sym_LT_EQ_GT] = ACTIONS(7729),
    [anon_sym_EQ_TILDE] = ACTIONS(7729),
    [anon_sym_BANG_TILDE] = ACTIONS(7729),
    [anon_sym_LT_EQ] = ACTIONS(7719),
    [anon_sym_GT] = ACTIONS(7719),
    [anon_sym_GT_EQ] = ACTIONS(7735),
    [anon_sym_CARET] = ACTIONS(7737),
    [anon_sym_PLUS] = ACTIONS(7711),
    [anon_sym_SLASH] = ACTIONS(7713),
    [anon_sym_PERCENT] = ACTIONS(7713),
    [sym_comment] = ACTIONS(87),
  },
  [7299] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9209),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2357),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(2357),
    [sym_assignment] = STATE(9209),
    [sym_operator_assignment] = STATE(9209),
    [sym_conditional] = STATE(9209),
    [sym_range] = STATE(9209),
    [sym_binary] = STATE(9209),
    [sym_unary] = STATE(9209),
    [sym_left_assignment_list] = STATE(2356),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2357),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2357),
    [sym_false] = STATE(2357),
    [sym_nil] = STATE(2357),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2358),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(4005),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(4009),
    [sym__subshell_start] = ACTIONS(4011),
    [sym__regex_start] = ACTIONS(4013),
    [sym__string_array_start] = ACTIONS(4015),
    [sym__symbol_array_start] = ACTIONS(4017),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4019),
    [anon_sym_LBRACE] = ACTIONS(4021),
    [anon_sym_def] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4025),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(4027),
    [anon_sym_module] = ACTIONS(4029),
    [anon_sym_return] = ACTIONS(4031),
    [anon_sym_yield] = ACTIONS(4033),
    [anon_sym_break] = ACTIONS(4035),
    [anon_sym_next] = ACTIONS(4037),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(4039),
    [anon_sym_unless] = ACTIONS(4041),
    [anon_sym_while] = ACTIONS(4043),
    [anon_sym_until] = ACTIONS(4045),
    [anon_sym_for] = ACTIONS(4047),
    [anon_sym_case] = ACTIONS(4049),
    [anon_sym_begin] = ACTIONS(4051),
    [anon_sym_PLUS] = ACTIONS(4053),
    [anon_sym_defined_QMARK] = ACTIONS(4055),
    [anon_sym_not] = ACTIONS(4057),
    [anon_sym_BANG] = ACTIONS(4059),
    [anon_sym_TILDE] = ACTIONS(4059),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4065),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(4067),
    [anon_sym_DASH_GT] = ACTIONS(4069),
  },
  [7300] = {
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(7711),
    [sym__binary_star] = ACTIONS(7713),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(7715),
    [anon_sym_STAR_STAR] = ACTIONS(7713),
    [anon_sym_AMP] = ACTIONS(7717),
    [anon_sym_EQ] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(7719),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(7721),
    [anon_sym_DOT_DOT] = ACTIONS(7723),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7725),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(7729),
    [anon_sym_AMP_AMP] = ACTIONS(7729),
    [anon_sym_LT_LT] = ACTIONS(7731),
    [anon_sym_GT_GT] = ACTIONS(7731),
    [anon_sym_EQ_EQ] = ACTIONS(7733),
    [anon_sym_BANG_EQ] = ACTIONS(7729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7729),
    [anon_sym_LT_EQ_GT] = ACTIONS(7729),
    [anon_sym_EQ_TILDE] = ACTIONS(7729),
    [anon_sym_BANG_TILDE] = ACTIONS(7729),
    [anon_sym_LT_EQ] = ACTIONS(7719),
    [anon_sym_GT] = ACTIONS(7719),
    [anon_sym_GT_EQ] = ACTIONS(7735),
    [anon_sym_CARET] = ACTIONS(7737),
    [anon_sym_PLUS] = ACTIONS(7711),
    [anon_sym_SLASH] = ACTIONS(7713),
    [anon_sym_PERCENT] = ACTIONS(7713),
    [sym_comment] = ACTIONS(87),
  },
  [7301] = {
    [sym__heredoc_body_start] = ACTIONS(4285),
    [sym__binary_minus] = ACTIONS(4285),
    [sym__binary_star] = ACTIONS(4285),
    [anon_sym_LBRACE] = ACTIONS(4285),
    [anon_sym_RPAREN] = ACTIONS(4285),
    [anon_sym_DOT] = ACTIONS(4287),
    [anon_sym_COMMA] = ACTIONS(4285),
    [anon_sym_PIPE] = ACTIONS(4287),
    [anon_sym_STAR_STAR] = ACTIONS(4285),
    [anon_sym_AMP] = ACTIONS(4287),
    [anon_sym_EQ] = ACTIONS(4287),
    [anon_sym_LT] = ACTIONS(4287),
    [anon_sym_do] = ACTIONS(4285),
    [anon_sym_LBRACK] = ACTIONS(4285),
    [anon_sym_COLON_COLON2] = ACTIONS(4285),
    [anon_sym_AMP_DOT] = ACTIONS(4285),
    [anon_sym_QMARK] = ACTIONS(4285),
    [anon_sym_DOT_DOT] = ACTIONS(4287),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4285),
    [anon_sym_and] = ACTIONS(4285),
    [anon_sym_or] = ACTIONS(4285),
    [anon_sym_PIPE_PIPE] = ACTIONS(4285),
    [anon_sym_AMP_AMP] = ACTIONS(4285),
    [anon_sym_LT_LT] = ACTIONS(4285),
    [anon_sym_GT_GT] = ACTIONS(4285),
    [anon_sym_EQ_EQ] = ACTIONS(4287),
    [anon_sym_BANG_EQ] = ACTIONS(4285),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4285),
    [anon_sym_LT_EQ_GT] = ACTIONS(4285),
    [anon_sym_EQ_TILDE] = ACTIONS(4285),
    [anon_sym_BANG_TILDE] = ACTIONS(4285),
    [anon_sym_LT_EQ] = ACTIONS(4287),
    [anon_sym_GT] = ACTIONS(4287),
    [anon_sym_GT_EQ] = ACTIONS(4285),
    [anon_sym_CARET] = ACTIONS(4285),
    [anon_sym_PLUS] = ACTIONS(4285),
    [anon_sym_SLASH] = ACTIONS(4285),
    [anon_sym_PERCENT] = ACTIONS(4285),
    [sym_comment] = ACTIONS(87),
  },
  [7302] = {
    [anon_sym_RPAREN] = ACTIONS(12812),
    [sym_comment] = ACTIONS(87),
  },
  [7303] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9211),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2357),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(2357),
    [sym_assignment] = STATE(9211),
    [sym_operator_assignment] = STATE(9211),
    [sym_conditional] = STATE(9211),
    [sym_range] = STATE(9211),
    [sym_binary] = STATE(9211),
    [sym_unary] = STATE(9211),
    [sym_left_assignment_list] = STATE(2356),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2357),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2357),
    [sym_false] = STATE(2357),
    [sym_nil] = STATE(2357),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2358),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(4005),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(4009),
    [sym__subshell_start] = ACTIONS(4011),
    [sym__regex_start] = ACTIONS(4013),
    [sym__string_array_start] = ACTIONS(4015),
    [sym__symbol_array_start] = ACTIONS(4017),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4019),
    [anon_sym_LBRACE] = ACTIONS(4021),
    [anon_sym_def] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4025),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(4027),
    [anon_sym_module] = ACTIONS(4029),
    [anon_sym_return] = ACTIONS(4031),
    [anon_sym_yield] = ACTIONS(4033),
    [anon_sym_break] = ACTIONS(4035),
    [anon_sym_next] = ACTIONS(4037),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(4039),
    [anon_sym_unless] = ACTIONS(4041),
    [anon_sym_while] = ACTIONS(4043),
    [anon_sym_until] = ACTIONS(4045),
    [anon_sym_for] = ACTIONS(4047),
    [anon_sym_case] = ACTIONS(4049),
    [anon_sym_begin] = ACTIONS(4051),
    [anon_sym_PLUS] = ACTIONS(4053),
    [anon_sym_defined_QMARK] = ACTIONS(4055),
    [anon_sym_not] = ACTIONS(4057),
    [anon_sym_BANG] = ACTIONS(4059),
    [anon_sym_TILDE] = ACTIONS(4059),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4065),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(4067),
    [anon_sym_DASH_GT] = ACTIONS(4069),
  },
  [7304] = {
    [sym_interpolation] = STATE(9213),
    [aux_sym_heredoc_body_repeat1] = STATE(9213),
    [sym__heredoc_content] = ACTIONS(12814),
    [sym_heredoc_end] = ACTIONS(12816),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(12814),
  },
  [7305] = {
    [sym_heredoc_body] = STATE(9214),
    [aux_sym_call_repeat1] = STATE(9214),
    [sym__heredoc_body_start] = ACTIONS(10884),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [7306] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4760),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(837),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(837),
    [sym__argument] = STATE(9215),
    [sym_splat_argument] = STATE(9215),
    [sym_hash_splat_argument] = STATE(9215),
    [sym_block_argument] = STATE(9215),
    [sym_assignment] = STATE(4760),
    [sym_operator_assignment] = STATE(4760),
    [sym_conditional] = STATE(4760),
    [sym_range] = STATE(4760),
    [sym_binary] = STATE(4760),
    [sym_unary] = STATE(4760),
    [sym_left_assignment_list] = STATE(836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(837),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(837),
    [sym_false] = STATE(837),
    [sym_nil] = STATE(837),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4764),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_heredoc_body] = STATE(9216),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(9215),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(7687),
    [sym__splat_star] = ACTIONS(7689),
    [sym__unary_minus] = ACTIONS(1485),
    [sym__identifier_hash_key] = ACTIONS(7691),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12818),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1493),
    [anon_sym_yield] = ACTIONS(1495),
    [anon_sym_break] = ACTIONS(1497),
    [anon_sym_next] = ACTIONS(1499),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1507),
    [anon_sym_TILDE] = ACTIONS(1507),
    [sym_constant] = ACTIONS(7695),
    [sym_identifier] = ACTIONS(7695),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7307] = {
    [sym_heredoc_body] = STATE(9217),
    [aux_sym_call_repeat1] = STATE(9217),
    [aux_sym_argument_list_repeat1] = STATE(9218),
    [sym__heredoc_body_start] = ACTIONS(10884),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(10886),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [7308] = {
    [sym_elsif] = STATE(9220),
    [sym_else] = STATE(9220),
    [anon_sym_end] = ACTIONS(12820),
    [anon_sym_elsif] = ACTIONS(4495),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [7309] = {
    [sym__statements] = STATE(2640),
    [sym_begin_block] = STATE(2641),
    [sym_end_block] = STATE(2641),
    [sym__statement] = STATE(2641),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(2641),
    [sym_unless_modifier] = STATE(2641),
    [sym_while_modifier] = STATE(2641),
    [sym_until_modifier] = STATE(2641),
    [sym_rescue_modifier] = STATE(2641),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_elsif] = STATE(9220),
    [sym_else] = STATE(9220),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2642),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2645),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(2645),
    [sym_assignment] = STATE(2642),
    [sym_operator_assignment] = STATE(2642),
    [sym_conditional] = STATE(2642),
    [sym_range] = STATE(2642),
    [sym_binary] = STATE(2642),
    [sym_unary] = STATE(2642),
    [sym_left_assignment_list] = STATE(2644),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2645),
    [sym__variable] = STATE(2643),
    [sym_undef] = STATE(2641),
    [sym_alias] = STATE(2641),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2645),
    [sym_false] = STATE(2645),
    [sym_nil] = STATE(2645),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2646),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(2647),
    [aux_sym__statements_repeat1] = STATE(2647),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4467),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12822),
    [anon_sym_return] = ACTIONS(4471),
    [anon_sym_yield] = ACTIONS(4473),
    [anon_sym_break] = ACTIONS(4475),
    [anon_sym_next] = ACTIONS(4477),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(4499),
    [anon_sym_else] = ACTIONS(4501),
    [anon_sym_then] = ACTIONS(4503),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4479),
    [anon_sym_defined_QMARK] = ACTIONS(4481),
    [anon_sym_not] = ACTIONS(4483),
    [anon_sym_BANG] = ACTIONS(4485),
    [anon_sym_TILDE] = ACTIONS(4485),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [anon_sym_undef] = ACTIONS(4491),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7310] = {
    [sym_else] = STATE(9222),
    [anon_sym_end] = ACTIONS(12824),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [7311] = {
    [sym__statements] = STATE(2640),
    [sym_begin_block] = STATE(2715),
    [sym_end_block] = STATE(2715),
    [sym__statement] = STATE(2715),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(2715),
    [sym_unless_modifier] = STATE(2715),
    [sym_while_modifier] = STATE(2715),
    [sym_until_modifier] = STATE(2715),
    [sym_rescue_modifier] = STATE(2715),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(9222),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2716),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2719),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(2719),
    [sym_assignment] = STATE(2716),
    [sym_operator_assignment] = STATE(2716),
    [sym_conditional] = STATE(2716),
    [sym_range] = STATE(2716),
    [sym_binary] = STATE(2716),
    [sym_unary] = STATE(2716),
    [sym_left_assignment_list] = STATE(2718),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2719),
    [sym__variable] = STATE(2717),
    [sym_undef] = STATE(2715),
    [sym_alias] = STATE(2715),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2719),
    [sym_false] = STATE(2719),
    [sym_nil] = STATE(2719),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2720),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(2721),
    [aux_sym__statements_repeat1] = STATE(2721),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4583),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12826),
    [anon_sym_return] = ACTIONS(4585),
    [anon_sym_yield] = ACTIONS(4587),
    [anon_sym_break] = ACTIONS(4589),
    [anon_sym_next] = ACTIONS(4591),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(4501),
    [anon_sym_then] = ACTIONS(4611),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4593),
    [anon_sym_defined_QMARK] = ACTIONS(4595),
    [anon_sym_not] = ACTIONS(4597),
    [anon_sym_BANG] = ACTIONS(4599),
    [anon_sym_TILDE] = ACTIONS(4599),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [anon_sym_undef] = ACTIONS(4605),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7312] = {
    [sym__statements] = STATE(9224),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12828),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7313] = {
    [sym__statements] = STATE(9226),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12830),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7314] = {
    [sym__do] = STATE(9227),
    [sym_heredoc_body] = STATE(9227),
    [sym__terminator] = STATE(9227),
    [sym__line_break] = ACTIONS(12832),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(12832),
    [anon_sym_do] = ACTIONS(12832),
    [sym_comment] = ACTIONS(87),
  },
  [7315] = {
    [sym_when] = STATE(9231),
    [sym_else] = STATE(9229),
    [aux_sym_case_repeat1] = STATE(9230),
    [aux_sym_case_repeat2] = STATE(9231),
    [anon_sym_SEMI] = ACTIONS(12834),
    [anon_sym_end] = ACTIONS(12836),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [7316] = {
    [sym__heredoc_body_start] = ACTIONS(4965),
    [sym__binary_minus] = ACTIONS(4965),
    [sym__binary_star] = ACTIONS(4965),
    [anon_sym_LBRACE] = ACTIONS(4965),
    [anon_sym_RPAREN] = ACTIONS(4965),
    [anon_sym_DOT] = ACTIONS(4967),
    [anon_sym_COMMA] = ACTIONS(4965),
    [anon_sym_PIPE] = ACTIONS(4967),
    [anon_sym_STAR_STAR] = ACTIONS(4965),
    [anon_sym_AMP] = ACTIONS(4967),
    [anon_sym_EQ] = ACTIONS(4967),
    [anon_sym_LT] = ACTIONS(4967),
    [anon_sym_do] = ACTIONS(4965),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym_COLON_COLON2] = ACTIONS(4965),
    [anon_sym_AMP_DOT] = ACTIONS(4965),
    [anon_sym_QMARK] = ACTIONS(4965),
    [anon_sym_DOT_DOT] = ACTIONS(4967),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4965),
    [anon_sym_and] = ACTIONS(4965),
    [anon_sym_or] = ACTIONS(4965),
    [anon_sym_PIPE_PIPE] = ACTIONS(4965),
    [anon_sym_AMP_AMP] = ACTIONS(4965),
    [anon_sym_LT_LT] = ACTIONS(4965),
    [anon_sym_GT_GT] = ACTIONS(4965),
    [anon_sym_EQ_EQ] = ACTIONS(4967),
    [anon_sym_BANG_EQ] = ACTIONS(4965),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4965),
    [anon_sym_LT_EQ_GT] = ACTIONS(4965),
    [anon_sym_EQ_TILDE] = ACTIONS(4965),
    [anon_sym_BANG_TILDE] = ACTIONS(4965),
    [anon_sym_LT_EQ] = ACTIONS(4967),
    [anon_sym_GT] = ACTIONS(4967),
    [anon_sym_GT_EQ] = ACTIONS(4965),
    [anon_sym_CARET] = ACTIONS(4965),
    [anon_sym_PLUS] = ACTIONS(4965),
    [anon_sym_SLASH] = ACTIONS(4965),
    [anon_sym_PERCENT] = ACTIONS(4965),
    [sym_comment] = ACTIONS(87),
  },
  [7317] = {
    [anon_sym_end] = ACTIONS(12836),
    [sym_comment] = ACTIONS(87),
  },
  [7318] = {
    [sym_when] = STATE(9231),
    [sym_else] = STATE(9229),
    [aux_sym_case_repeat1] = STATE(2987),
    [aux_sym_case_repeat2] = STATE(9231),
    [anon_sym_SEMI] = ACTIONS(4995),
    [anon_sym_end] = ACTIONS(12836),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [7319] = {
    [sym_when] = STATE(2988),
    [sym_else] = STATE(9229),
    [aux_sym_case_repeat2] = STATE(2988),
    [anon_sym_end] = ACTIONS(12836),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [7320] = {
    [sym__heredoc_body_start] = ACTIONS(5407),
    [sym__binary_minus] = ACTIONS(5407),
    [sym__binary_star] = ACTIONS(5407),
    [anon_sym_LBRACE] = ACTIONS(5407),
    [anon_sym_RPAREN] = ACTIONS(5407),
    [anon_sym_DOT] = ACTIONS(5409),
    [anon_sym_COMMA] = ACTIONS(5407),
    [anon_sym_PIPE] = ACTIONS(5409),
    [anon_sym_STAR_STAR] = ACTIONS(5407),
    [anon_sym_AMP] = ACTIONS(5409),
    [anon_sym_EQ] = ACTIONS(5409),
    [anon_sym_LT] = ACTIONS(5409),
    [anon_sym_do] = ACTIONS(5407),
    [anon_sym_LBRACK] = ACTIONS(5407),
    [anon_sym_COLON_COLON2] = ACTIONS(5407),
    [anon_sym_AMP_DOT] = ACTIONS(5407),
    [anon_sym_QMARK] = ACTIONS(5407),
    [anon_sym_DOT_DOT] = ACTIONS(5409),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5407),
    [anon_sym_and] = ACTIONS(5407),
    [anon_sym_or] = ACTIONS(5407),
    [anon_sym_PIPE_PIPE] = ACTIONS(5407),
    [anon_sym_AMP_AMP] = ACTIONS(5407),
    [anon_sym_LT_LT] = ACTIONS(5407),
    [anon_sym_GT_GT] = ACTIONS(5407),
    [anon_sym_EQ_EQ] = ACTIONS(5409),
    [anon_sym_BANG_EQ] = ACTIONS(5407),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5407),
    [anon_sym_LT_EQ_GT] = ACTIONS(5407),
    [anon_sym_EQ_TILDE] = ACTIONS(5407),
    [anon_sym_BANG_TILDE] = ACTIONS(5407),
    [anon_sym_LT_EQ] = ACTIONS(5409),
    [anon_sym_GT] = ACTIONS(5409),
    [anon_sym_GT_EQ] = ACTIONS(5407),
    [anon_sym_CARET] = ACTIONS(5407),
    [anon_sym_PLUS] = ACTIONS(5407),
    [anon_sym_SLASH] = ACTIONS(5407),
    [anon_sym_PERCENT] = ACTIONS(5407),
    [sym_comment] = ACTIONS(87),
  },
  [7321] = {
    [sym_ensure] = STATE(9233),
    [anon_sym_end] = ACTIONS(12838),
    [anon_sym_ensure] = ACTIONS(2169),
    [sym_comment] = ACTIONS(87),
  },
  [7322] = {
    [anon_sym_end] = ACTIONS(12838),
    [sym_comment] = ACTIONS(87),
  },
  [7323] = {
    [sym_else] = STATE(9234),
    [sym_ensure] = STATE(9233),
    [anon_sym_end] = ACTIONS(12838),
    [anon_sym_else] = ACTIONS(2167),
    [anon_sym_ensure] = ACTIONS(2169),
    [sym_comment] = ACTIONS(87),
  },
  [7324] = {
    [sym__heredoc_body_start] = ACTIONS(5491),
    [sym__binary_minus] = ACTIONS(5491),
    [sym__binary_star] = ACTIONS(5491),
    [anon_sym_LBRACE] = ACTIONS(5491),
    [anon_sym_RPAREN] = ACTIONS(5491),
    [anon_sym_DOT] = ACTIONS(5493),
    [anon_sym_COMMA] = ACTIONS(5491),
    [anon_sym_PIPE] = ACTIONS(5493),
    [anon_sym_STAR_STAR] = ACTIONS(5491),
    [anon_sym_AMP] = ACTIONS(5493),
    [anon_sym_EQ] = ACTIONS(5493),
    [anon_sym_LT] = ACTIONS(5493),
    [anon_sym_do] = ACTIONS(5491),
    [anon_sym_LBRACK] = ACTIONS(5491),
    [anon_sym_COLON_COLON2] = ACTIONS(5491),
    [anon_sym_AMP_DOT] = ACTIONS(5491),
    [anon_sym_QMARK] = ACTIONS(5491),
    [anon_sym_DOT_DOT] = ACTIONS(5493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5491),
    [anon_sym_and] = ACTIONS(5491),
    [anon_sym_or] = ACTIONS(5491),
    [anon_sym_PIPE_PIPE] = ACTIONS(5491),
    [anon_sym_AMP_AMP] = ACTIONS(5491),
    [anon_sym_LT_LT] = ACTIONS(5491),
    [anon_sym_GT_GT] = ACTIONS(5491),
    [anon_sym_EQ_EQ] = ACTIONS(5493),
    [anon_sym_BANG_EQ] = ACTIONS(5491),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5491),
    [anon_sym_LT_EQ_GT] = ACTIONS(5491),
    [anon_sym_EQ_TILDE] = ACTIONS(5491),
    [anon_sym_BANG_TILDE] = ACTIONS(5491),
    [anon_sym_LT_EQ] = ACTIONS(5493),
    [anon_sym_GT] = ACTIONS(5493),
    [anon_sym_GT_EQ] = ACTIONS(5491),
    [anon_sym_CARET] = ACTIONS(5491),
    [anon_sym_PLUS] = ACTIONS(5491),
    [anon_sym_SLASH] = ACTIONS(5491),
    [anon_sym_PERCENT] = ACTIONS(5491),
    [sym_comment] = ACTIONS(87),
  },
  [7325] = {
    [sym__heredoc_body_start] = ACTIONS(5725),
    [sym__binary_minus] = ACTIONS(5725),
    [sym__binary_star] = ACTIONS(5725),
    [anon_sym_LBRACE] = ACTIONS(5725),
    [anon_sym_RPAREN] = ACTIONS(5725),
    [anon_sym_DOT] = ACTIONS(5727),
    [anon_sym_COMMA] = ACTIONS(5725),
    [anon_sym_PIPE] = ACTIONS(5727),
    [anon_sym_STAR_STAR] = ACTIONS(5725),
    [anon_sym_AMP] = ACTIONS(5727),
    [anon_sym_EQ] = ACTIONS(5727),
    [anon_sym_LT] = ACTIONS(5727),
    [anon_sym_do] = ACTIONS(5725),
    [anon_sym_LBRACK] = ACTIONS(5725),
    [anon_sym_COLON_COLON2] = ACTIONS(5725),
    [anon_sym_AMP_DOT] = ACTIONS(5725),
    [anon_sym_QMARK] = ACTIONS(5725),
    [anon_sym_DOT_DOT] = ACTIONS(5727),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5725),
    [anon_sym_and] = ACTIONS(5725),
    [anon_sym_or] = ACTIONS(5725),
    [anon_sym_PIPE_PIPE] = ACTIONS(5725),
    [anon_sym_AMP_AMP] = ACTIONS(5725),
    [anon_sym_LT_LT] = ACTIONS(5725),
    [anon_sym_GT_GT] = ACTIONS(5725),
    [anon_sym_EQ_EQ] = ACTIONS(5727),
    [anon_sym_BANG_EQ] = ACTIONS(5725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5725),
    [anon_sym_LT_EQ_GT] = ACTIONS(5725),
    [anon_sym_EQ_TILDE] = ACTIONS(5725),
    [anon_sym_BANG_TILDE] = ACTIONS(5725),
    [anon_sym_LT_EQ] = ACTIONS(5727),
    [anon_sym_GT] = ACTIONS(5727),
    [anon_sym_GT_EQ] = ACTIONS(5725),
    [anon_sym_CARET] = ACTIONS(5725),
    [anon_sym_PLUS] = ACTIONS(5725),
    [anon_sym_SLASH] = ACTIONS(5725),
    [anon_sym_PERCENT] = ACTIONS(5725),
    [sym_comment] = ACTIONS(87),
  },
  [7326] = {
    [sym__heredoc_body_start] = ACTIONS(5735),
    [sym__binary_minus] = ACTIONS(5735),
    [sym__binary_star] = ACTIONS(5735),
    [anon_sym_LBRACE] = ACTIONS(5735),
    [anon_sym_RPAREN] = ACTIONS(5735),
    [anon_sym_DOT] = ACTIONS(5737),
    [anon_sym_COMMA] = ACTIONS(5735),
    [anon_sym_PIPE] = ACTIONS(5737),
    [anon_sym_STAR_STAR] = ACTIONS(5735),
    [anon_sym_AMP] = ACTIONS(5737),
    [anon_sym_EQ] = ACTIONS(5737),
    [anon_sym_LT] = ACTIONS(5737),
    [anon_sym_do] = ACTIONS(5735),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_COLON_COLON2] = ACTIONS(5735),
    [anon_sym_AMP_DOT] = ACTIONS(5735),
    [anon_sym_QMARK] = ACTIONS(5735),
    [anon_sym_DOT_DOT] = ACTIONS(5737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5735),
    [anon_sym_and] = ACTIONS(5735),
    [anon_sym_or] = ACTIONS(5735),
    [anon_sym_PIPE_PIPE] = ACTIONS(5735),
    [anon_sym_AMP_AMP] = ACTIONS(5735),
    [anon_sym_LT_LT] = ACTIONS(5735),
    [anon_sym_GT_GT] = ACTIONS(5735),
    [anon_sym_EQ_EQ] = ACTIONS(5737),
    [anon_sym_BANG_EQ] = ACTIONS(5735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5735),
    [anon_sym_LT_EQ_GT] = ACTIONS(5735),
    [anon_sym_EQ_TILDE] = ACTIONS(5735),
    [anon_sym_BANG_TILDE] = ACTIONS(5735),
    [anon_sym_LT_EQ] = ACTIONS(5737),
    [anon_sym_GT] = ACTIONS(5737),
    [anon_sym_GT_EQ] = ACTIONS(5735),
    [anon_sym_CARET] = ACTIONS(5735),
    [anon_sym_PLUS] = ACTIONS(5735),
    [anon_sym_SLASH] = ACTIONS(5735),
    [anon_sym_PERCENT] = ACTIONS(5735),
    [sym_comment] = ACTIONS(87),
  },
  [7327] = {
    [anon_sym_RBRACE] = ACTIONS(12840),
    [sym_comment] = ACTIONS(87),
  },
  [7328] = {
    [sym__statements] = STATE(9236),
    [sym_begin_block] = STATE(489),
    [sym_end_block] = STATE(489),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(495),
    [aux_sym__statements_repeat1] = STATE(495),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(12840),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7329] = {
    [sym__heredoc_body_start] = ACTIONS(5771),
    [sym__binary_minus] = ACTIONS(5771),
    [sym__binary_star] = ACTIONS(5771),
    [anon_sym_LBRACE] = ACTIONS(5771),
    [anon_sym_RPAREN] = ACTIONS(5771),
    [anon_sym_DOT] = ACTIONS(5773),
    [anon_sym_COMMA] = ACTIONS(5771),
    [anon_sym_PIPE] = ACTIONS(5773),
    [anon_sym_STAR_STAR] = ACTIONS(5771),
    [anon_sym_AMP] = ACTIONS(5773),
    [anon_sym_EQ] = ACTIONS(5773),
    [anon_sym_LT] = ACTIONS(5773),
    [anon_sym_do] = ACTIONS(5771),
    [anon_sym_LBRACK] = ACTIONS(5771),
    [anon_sym_COLON_COLON2] = ACTIONS(5771),
    [anon_sym_AMP_DOT] = ACTIONS(5771),
    [anon_sym_QMARK] = ACTIONS(5771),
    [anon_sym_DOT_DOT] = ACTIONS(5773),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5771),
    [anon_sym_and] = ACTIONS(5771),
    [anon_sym_or] = ACTIONS(5771),
    [anon_sym_PIPE_PIPE] = ACTIONS(5771),
    [anon_sym_AMP_AMP] = ACTIONS(5771),
    [anon_sym_LT_LT] = ACTIONS(5771),
    [anon_sym_GT_GT] = ACTIONS(5771),
    [anon_sym_EQ_EQ] = ACTIONS(5773),
    [anon_sym_BANG_EQ] = ACTIONS(5771),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5771),
    [anon_sym_LT_EQ_GT] = ACTIONS(5771),
    [anon_sym_EQ_TILDE] = ACTIONS(5771),
    [anon_sym_BANG_TILDE] = ACTIONS(5771),
    [anon_sym_LT_EQ] = ACTIONS(5773),
    [anon_sym_GT] = ACTIONS(5773),
    [anon_sym_GT_EQ] = ACTIONS(5771),
    [anon_sym_CARET] = ACTIONS(5771),
    [anon_sym_PLUS] = ACTIONS(5771),
    [anon_sym_SLASH] = ACTIONS(5771),
    [anon_sym_PERCENT] = ACTIONS(5771),
    [sym_comment] = ACTIONS(87),
  },
  [7330] = {
    [anon_sym_end] = ACTIONS(12842),
    [sym_comment] = ACTIONS(87),
  },
  [7331] = {
    [sym__statements] = STATE(9238),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_heredoc_body] = STATE(9239),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [sym__terminator] = STATE(9239),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__line_break] = ACTIONS(12844),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(12844),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12846),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7332] = {
    [sym__statements] = STATE(9238),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_block_parameters] = STATE(9240),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12846),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7333] = {
    [sym__heredoc_body_start] = ACTIONS(5807),
    [sym__binary_minus] = ACTIONS(5807),
    [sym__binary_star] = ACTIONS(5807),
    [anon_sym_LBRACE] = ACTIONS(5807),
    [anon_sym_RPAREN] = ACTIONS(5807),
    [anon_sym_DOT] = ACTIONS(5809),
    [anon_sym_COMMA] = ACTIONS(5807),
    [anon_sym_PIPE] = ACTIONS(5809),
    [anon_sym_STAR_STAR] = ACTIONS(5807),
    [anon_sym_AMP] = ACTIONS(5809),
    [anon_sym_EQ] = ACTIONS(5809),
    [anon_sym_LT] = ACTIONS(5809),
    [anon_sym_do] = ACTIONS(5807),
    [anon_sym_LBRACK] = ACTIONS(5807),
    [anon_sym_COLON_COLON2] = ACTIONS(5807),
    [anon_sym_AMP_DOT] = ACTIONS(5807),
    [anon_sym_QMARK] = ACTIONS(5807),
    [anon_sym_DOT_DOT] = ACTIONS(5809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5807),
    [anon_sym_and] = ACTIONS(5807),
    [anon_sym_or] = ACTIONS(5807),
    [anon_sym_PIPE_PIPE] = ACTIONS(5807),
    [anon_sym_AMP_AMP] = ACTIONS(5807),
    [anon_sym_LT_LT] = ACTIONS(5807),
    [anon_sym_GT_GT] = ACTIONS(5807),
    [anon_sym_EQ_EQ] = ACTIONS(5809),
    [anon_sym_BANG_EQ] = ACTIONS(5807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5807),
    [anon_sym_LT_EQ_GT] = ACTIONS(5807),
    [anon_sym_EQ_TILDE] = ACTIONS(5807),
    [anon_sym_BANG_TILDE] = ACTIONS(5807),
    [anon_sym_LT_EQ] = ACTIONS(5809),
    [anon_sym_GT] = ACTIONS(5809),
    [anon_sym_GT_EQ] = ACTIONS(5807),
    [anon_sym_CARET] = ACTIONS(5807),
    [anon_sym_PLUS] = ACTIONS(5807),
    [anon_sym_SLASH] = ACTIONS(5807),
    [anon_sym_PERCENT] = ACTIONS(5807),
    [sym_comment] = ACTIONS(87),
  },
  [7334] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(7713),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(7713),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(7713),
    [anon_sym_PERCENT] = ACTIONS(7713),
    [sym_comment] = ACTIONS(87),
  },
  [7335] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(7713),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [7336] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7711),
    [sym__binary_star] = ACTIONS(7713),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(7713),
    [anon_sym_AMP] = ACTIONS(7717),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(7731),
    [anon_sym_GT_GT] = ACTIONS(7731),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(7711),
    [anon_sym_SLASH] = ACTIONS(7713),
    [anon_sym_PERCENT] = ACTIONS(7713),
    [sym_comment] = ACTIONS(87),
  },
  [7337] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7711),
    [sym__binary_star] = ACTIONS(7713),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(7713),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(7731),
    [anon_sym_GT_GT] = ACTIONS(7731),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(7711),
    [anon_sym_SLASH] = ACTIONS(7713),
    [anon_sym_PERCENT] = ACTIONS(7713),
    [sym_comment] = ACTIONS(87),
  },
  [7338] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7711),
    [sym__binary_star] = ACTIONS(7713),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(7715),
    [anon_sym_STAR_STAR] = ACTIONS(7713),
    [anon_sym_AMP] = ACTIONS(7717),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(7731),
    [anon_sym_GT_GT] = ACTIONS(7731),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(7737),
    [anon_sym_PLUS] = ACTIONS(7711),
    [anon_sym_SLASH] = ACTIONS(7713),
    [anon_sym_PERCENT] = ACTIONS(7713),
    [sym_comment] = ACTIONS(87),
  },
  [7339] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(12848),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [7340] = {
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(7711),
    [sym__binary_star] = ACTIONS(7713),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(7715),
    [anon_sym_STAR_STAR] = ACTIONS(7713),
    [anon_sym_AMP] = ACTIONS(7717),
    [anon_sym_EQ] = ACTIONS(7888),
    [anon_sym_LT] = ACTIONS(7719),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(7723),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7725),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(7729),
    [anon_sym_AMP_AMP] = ACTIONS(7729),
    [anon_sym_LT_LT] = ACTIONS(7731),
    [anon_sym_GT_GT] = ACTIONS(7731),
    [anon_sym_EQ_EQ] = ACTIONS(7733),
    [anon_sym_BANG_EQ] = ACTIONS(7729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7729),
    [anon_sym_LT_EQ_GT] = ACTIONS(7729),
    [anon_sym_EQ_TILDE] = ACTIONS(7729),
    [anon_sym_BANG_TILDE] = ACTIONS(7729),
    [anon_sym_LT_EQ] = ACTIONS(7719),
    [anon_sym_GT] = ACTIONS(7719),
    [anon_sym_GT_EQ] = ACTIONS(7735),
    [anon_sym_CARET] = ACTIONS(7737),
    [anon_sym_PLUS] = ACTIONS(7711),
    [anon_sym_SLASH] = ACTIONS(7713),
    [anon_sym_PERCENT] = ACTIONS(7713),
    [sym_comment] = ACTIONS(87),
  },
  [7341] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7711),
    [sym__binary_star] = ACTIONS(7713),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(7715),
    [anon_sym_STAR_STAR] = ACTIONS(7713),
    [anon_sym_AMP] = ACTIONS(7717),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(7719),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(7721),
    [anon_sym_DOT_DOT] = ACTIONS(7723),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7725),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(7729),
    [anon_sym_AMP_AMP] = ACTIONS(7729),
    [anon_sym_LT_LT] = ACTIONS(7731),
    [anon_sym_GT_GT] = ACTIONS(7731),
    [anon_sym_EQ_EQ] = ACTIONS(7733),
    [anon_sym_BANG_EQ] = ACTIONS(7729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7729),
    [anon_sym_LT_EQ_GT] = ACTIONS(7729),
    [anon_sym_EQ_TILDE] = ACTIONS(7729),
    [anon_sym_BANG_TILDE] = ACTIONS(7729),
    [anon_sym_LT_EQ] = ACTIONS(7719),
    [anon_sym_GT] = ACTIONS(7719),
    [anon_sym_GT_EQ] = ACTIONS(7735),
    [anon_sym_CARET] = ACTIONS(7737),
    [anon_sym_PLUS] = ACTIONS(7711),
    [anon_sym_SLASH] = ACTIONS(7713),
    [anon_sym_PERCENT] = ACTIONS(7713),
    [sym_comment] = ACTIONS(87),
  },
  [7342] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7711),
    [sym__binary_star] = ACTIONS(7713),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(7715),
    [anon_sym_STAR_STAR] = ACTIONS(7713),
    [anon_sym_AMP] = ACTIONS(7717),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(7719),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(7731),
    [anon_sym_GT_GT] = ACTIONS(7731),
    [anon_sym_EQ_EQ] = ACTIONS(7733),
    [anon_sym_BANG_EQ] = ACTIONS(7729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7729),
    [anon_sym_LT_EQ_GT] = ACTIONS(7729),
    [anon_sym_EQ_TILDE] = ACTIONS(7729),
    [anon_sym_BANG_TILDE] = ACTIONS(7729),
    [anon_sym_LT_EQ] = ACTIONS(7719),
    [anon_sym_GT] = ACTIONS(7719),
    [anon_sym_GT_EQ] = ACTIONS(7735),
    [anon_sym_CARET] = ACTIONS(7737),
    [anon_sym_PLUS] = ACTIONS(7711),
    [anon_sym_SLASH] = ACTIONS(7713),
    [anon_sym_PERCENT] = ACTIONS(7713),
    [sym_comment] = ACTIONS(87),
  },
  [7343] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7711),
    [sym__binary_star] = ACTIONS(7713),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(7713),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(7711),
    [anon_sym_SLASH] = ACTIONS(7713),
    [anon_sym_PERCENT] = ACTIONS(7713),
    [sym_comment] = ACTIONS(87),
  },
  [7344] = {
    [sym__heredoc_body_start] = ACTIONS(5735),
    [sym__binary_minus] = ACTIONS(5735),
    [sym__binary_star] = ACTIONS(5735),
    [anon_sym_LBRACE] = ACTIONS(5735),
    [anon_sym_RBRACE] = ACTIONS(5735),
    [anon_sym_RPAREN] = ACTIONS(5735),
    [anon_sym_DOT] = ACTIONS(5737),
    [anon_sym_COMMA] = ACTIONS(5735),
    [anon_sym_PIPE] = ACTIONS(5737),
    [anon_sym_SEMI] = ACTIONS(5735),
    [anon_sym_STAR_STAR] = ACTIONS(5737),
    [anon_sym_AMP] = ACTIONS(5737),
    [anon_sym_EQ] = ACTIONS(5737),
    [anon_sym_LT] = ACTIONS(5737),
    [anon_sym_if] = ACTIONS(5735),
    [anon_sym_unless] = ACTIONS(5735),
    [anon_sym_while] = ACTIONS(5735),
    [anon_sym_until] = ACTIONS(5735),
    [anon_sym_rescue] = ACTIONS(5735),
    [anon_sym_in] = ACTIONS(5735),
    [anon_sym_do] = ACTIONS(5735),
    [anon_sym_EQ_GT] = ACTIONS(993),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_RBRACK] = ACTIONS(5735),
    [anon_sym_COLON_COLON2] = ACTIONS(5735),
    [anon_sym_AMP_DOT] = ACTIONS(5735),
    [anon_sym_PLUS_EQ] = ACTIONS(5735),
    [anon_sym_DASH_EQ] = ACTIONS(5735),
    [anon_sym_STAR_EQ] = ACTIONS(5735),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5735),
    [anon_sym_SLASH_EQ] = ACTIONS(5735),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5735),
    [anon_sym_PIPE_EQ] = ACTIONS(5735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5735),
    [anon_sym_AMP_EQ] = ACTIONS(5735),
    [anon_sym_PERCENT_EQ] = ACTIONS(5735),
    [anon_sym_GT_GT_EQ] = ACTIONS(5735),
    [anon_sym_LT_LT_EQ] = ACTIONS(5735),
    [anon_sym_CARET_EQ] = ACTIONS(5735),
    [anon_sym_QMARK] = ACTIONS(5735),
    [anon_sym_COLON2] = ACTIONS(5737),
    [anon_sym_DOT_DOT] = ACTIONS(5737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5735),
    [anon_sym_and] = ACTIONS(5735),
    [anon_sym_or] = ACTIONS(5735),
    [anon_sym_PIPE_PIPE] = ACTIONS(5737),
    [anon_sym_AMP_AMP] = ACTIONS(5737),
    [anon_sym_LT_LT] = ACTIONS(5737),
    [anon_sym_GT_GT] = ACTIONS(5737),
    [anon_sym_EQ_EQ] = ACTIONS(5737),
    [anon_sym_BANG_EQ] = ACTIONS(5735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5735),
    [anon_sym_LT_EQ_GT] = ACTIONS(5735),
    [anon_sym_EQ_TILDE] = ACTIONS(5735),
    [anon_sym_BANG_TILDE] = ACTIONS(5735),
    [anon_sym_LT_EQ] = ACTIONS(5737),
    [anon_sym_GT] = ACTIONS(5737),
    [anon_sym_GT_EQ] = ACTIONS(5735),
    [anon_sym_CARET] = ACTIONS(5737),
    [anon_sym_PLUS] = ACTIONS(5737),
    [anon_sym_SLASH] = ACTIONS(5737),
    [anon_sym_PERCENT] = ACTIONS(5737),
    [sym_comment] = ACTIONS(87),
  },
  [7345] = {
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(7711),
    [sym__binary_star] = ACTIONS(7713),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(7715),
    [anon_sym_STAR_STAR] = ACTIONS(7713),
    [anon_sym_AMP] = ACTIONS(7717),
    [anon_sym_EQ] = ACTIONS(7936),
    [anon_sym_LT] = ACTIONS(7719),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(7721),
    [anon_sym_DOT_DOT] = ACTIONS(7723),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7725),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7729),
    [anon_sym_AMP_AMP] = ACTIONS(7729),
    [anon_sym_LT_LT] = ACTIONS(7731),
    [anon_sym_GT_GT] = ACTIONS(7731),
    [anon_sym_EQ_EQ] = ACTIONS(7733),
    [anon_sym_BANG_EQ] = ACTIONS(7729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7729),
    [anon_sym_LT_EQ_GT] = ACTIONS(7729),
    [anon_sym_EQ_TILDE] = ACTIONS(7729),
    [anon_sym_BANG_TILDE] = ACTIONS(7729),
    [anon_sym_LT_EQ] = ACTIONS(7719),
    [anon_sym_GT] = ACTIONS(7719),
    [anon_sym_GT_EQ] = ACTIONS(7735),
    [anon_sym_CARET] = ACTIONS(7737),
    [anon_sym_PLUS] = ACTIONS(7711),
    [anon_sym_SLASH] = ACTIONS(7713),
    [anon_sym_PERCENT] = ACTIONS(7713),
    [sym_comment] = ACTIONS(87),
  },
  [7346] = {
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_RPAREN] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [7347] = {
    [aux_sym_exceptions_repeat1] = STATE(9243),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [7348] = {
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(7711),
    [sym__binary_star] = ACTIONS(7713),
    [anon_sym_LBRACE] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(7715),
    [anon_sym_STAR_STAR] = ACTIONS(7713),
    [anon_sym_AMP] = ACTIONS(7717),
    [anon_sym_EQ] = ACTIONS(7938),
    [anon_sym_LT] = ACTIONS(7719),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(7721),
    [anon_sym_DOT_DOT] = ACTIONS(7723),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7725),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(7729),
    [anon_sym_AMP_AMP] = ACTIONS(7729),
    [anon_sym_LT_LT] = ACTIONS(7731),
    [anon_sym_GT_GT] = ACTIONS(7731),
    [anon_sym_EQ_EQ] = ACTIONS(7733),
    [anon_sym_BANG_EQ] = ACTIONS(7729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7729),
    [anon_sym_LT_EQ_GT] = ACTIONS(7729),
    [anon_sym_EQ_TILDE] = ACTIONS(7729),
    [anon_sym_BANG_TILDE] = ACTIONS(7729),
    [anon_sym_LT_EQ] = ACTIONS(7719),
    [anon_sym_GT] = ACTIONS(7719),
    [anon_sym_GT_EQ] = ACTIONS(7735),
    [anon_sym_CARET] = ACTIONS(7737),
    [anon_sym_PLUS] = ACTIONS(7711),
    [anon_sym_SLASH] = ACTIONS(7713),
    [anon_sym_PERCENT] = ACTIONS(7713),
    [sym_comment] = ACTIONS(87),
  },
  [7349] = {
    [sym_string] = STATE(7349),
    [aux_sym_chained_string_repeat1] = STATE(7349),
    [sym__string_start] = ACTIONS(12850),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_EQ] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_do] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [7350] = {
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(4087),
    [sym__binary_star] = ACTIONS(4089),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(4091),
    [anon_sym_STAR_STAR] = ACTIONS(4089),
    [anon_sym_AMP] = ACTIONS(4093),
    [anon_sym_EQ] = ACTIONS(7822),
    [anon_sym_LT] = ACTIONS(4095),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_EQ_GT] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(4097),
    [anon_sym_DOT_DOT] = ACTIONS(4099),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4101),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(4105),
    [anon_sym_AMP_AMP] = ACTIONS(4105),
    [anon_sym_LT_LT] = ACTIONS(4107),
    [anon_sym_GT_GT] = ACTIONS(4107),
    [anon_sym_EQ_EQ] = ACTIONS(4109),
    [anon_sym_BANG_EQ] = ACTIONS(4105),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4105),
    [anon_sym_LT_EQ_GT] = ACTIONS(4105),
    [anon_sym_EQ_TILDE] = ACTIONS(4105),
    [anon_sym_BANG_TILDE] = ACTIONS(4105),
    [anon_sym_LT_EQ] = ACTIONS(4095),
    [anon_sym_GT] = ACTIONS(4095),
    [anon_sym_GT_EQ] = ACTIONS(4111),
    [anon_sym_CARET] = ACTIONS(4113),
    [anon_sym_PLUS] = ACTIONS(4087),
    [anon_sym_SLASH] = ACTIONS(4089),
    [anon_sym_PERCENT] = ACTIONS(4089),
    [sym_comment] = ACTIONS(87),
  },
  [7351] = {
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(4087),
    [sym__binary_star] = ACTIONS(4089),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(4091),
    [anon_sym_STAR_STAR] = ACTIONS(4089),
    [anon_sym_AMP] = ACTIONS(4093),
    [anon_sym_EQ] = ACTIONS(7884),
    [anon_sym_LT] = ACTIONS(4095),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_EQ_GT] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(4097),
    [anon_sym_DOT_DOT] = ACTIONS(4099),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4101),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(4105),
    [anon_sym_AMP_AMP] = ACTIONS(4105),
    [anon_sym_LT_LT] = ACTIONS(4107),
    [anon_sym_GT_GT] = ACTIONS(4107),
    [anon_sym_EQ_EQ] = ACTIONS(4109),
    [anon_sym_BANG_EQ] = ACTIONS(4105),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4105),
    [anon_sym_LT_EQ_GT] = ACTIONS(4105),
    [anon_sym_EQ_TILDE] = ACTIONS(4105),
    [anon_sym_BANG_TILDE] = ACTIONS(4105),
    [anon_sym_LT_EQ] = ACTIONS(4095),
    [anon_sym_GT] = ACTIONS(4095),
    [anon_sym_GT_EQ] = ACTIONS(4111),
    [anon_sym_CARET] = ACTIONS(4113),
    [anon_sym_PLUS] = ACTIONS(4087),
    [anon_sym_SLASH] = ACTIONS(4089),
    [anon_sym_PERCENT] = ACTIONS(4089),
    [sym_comment] = ACTIONS(87),
  },
  [7352] = {
    [sym_heredoc_body] = STATE(7352),
    [aux_sym_call_repeat1] = STATE(7352),
    [sym__heredoc_body_start] = ACTIONS(10455),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_EQ] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_EQ_GT] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [7353] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(2370),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(837),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(837),
    [sym__argument] = STATE(6908),
    [sym_splat_argument] = STATE(6908),
    [sym_hash_splat_argument] = STATE(6908),
    [sym_block_argument] = STATE(6908),
    [sym_assignment] = STATE(2370),
    [sym_operator_assignment] = STATE(2370),
    [sym_conditional] = STATE(2370),
    [sym_range] = STATE(2370),
    [sym_binary] = STATE(2370),
    [sym_unary] = STATE(2370),
    [sym_left_assignment_list] = STATE(836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(837),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(837),
    [sym_false] = STATE(837),
    [sym_nil] = STATE(837),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2373),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(6908),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(4075),
    [sym__splat_star] = ACTIONS(4077),
    [sym__unary_minus] = ACTIONS(1485),
    [sym__identifier_hash_key] = ACTIONS(4079),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10920),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1493),
    [anon_sym_yield] = ACTIONS(1495),
    [anon_sym_break] = ACTIONS(1497),
    [anon_sym_next] = ACTIONS(1499),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1507),
    [anon_sym_TILDE] = ACTIONS(1507),
    [sym_constant] = ACTIONS(4083),
    [sym_identifier] = ACTIONS(4083),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7354] = {
    [sym_heredoc_body] = STATE(7352),
    [aux_sym_call_repeat1] = STATE(7352),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_EQ] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_EQ_GT] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [7355] = {
    [aux_sym_argument_list_repeat1] = STATE(7355),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(12853),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_STAR_STAR] = ACTIONS(7925),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_EQ] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_EQ_GT] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7925),
    [anon_sym_AMP_AMP] = ACTIONS(7925),
    [anon_sym_LT_LT] = ACTIONS(7925),
    [anon_sym_GT_GT] = ACTIONS(7925),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7925),
    [anon_sym_PLUS] = ACTIONS(7925),
    [anon_sym_SLASH] = ACTIONS(7925),
    [anon_sym_PERCENT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [7356] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(9244),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(837),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(837),
    [sym_assignment] = STATE(9244),
    [sym_operator_assignment] = STATE(9244),
    [sym_conditional] = STATE(9244),
    [sym_range] = STATE(9244),
    [sym_binary] = STATE(9244),
    [sym_unary] = STATE(9244),
    [sym_left_assignment_list] = STATE(836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(837),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(837),
    [sym_false] = STATE(837),
    [sym_nil] = STATE(837),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2361),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1485),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1493),
    [anon_sym_yield] = ACTIONS(1495),
    [anon_sym_break] = ACTIONS(1497),
    [anon_sym_next] = ACTIONS(1499),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1507),
    [anon_sym_TILDE] = ACTIONS(1507),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7357] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4829),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(837),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(837),
    [sym_splat_argument] = STATE(9013),
    [sym_assignment] = STATE(4829),
    [sym_operator_assignment] = STATE(4829),
    [sym_conditional] = STATE(4829),
    [sym_range] = STATE(4829),
    [sym_binary] = STATE(4829),
    [sym_unary] = STATE(4829),
    [sym__arg_or_splat_arg] = STATE(9013),
    [sym_left_assignment_list] = STATE(836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(837),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(837),
    [sym_false] = STATE(837),
    [sym_nil] = STATE(837),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2361),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(4077),
    [sym__unary_minus] = ACTIONS(1485),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1493),
    [anon_sym_yield] = ACTIONS(1495),
    [anon_sym_break] = ACTIONS(1497),
    [anon_sym_next] = ACTIONS(1499),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1507),
    [anon_sym_TILDE] = ACTIONS(1507),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7358] = {
    [aux_sym_exceptions_repeat1] = STATE(9245),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_LBRACE] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(12856),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_EQ] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_do] = ACTIONS(9855),
    [anon_sym_EQ_GT] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [7359] = {
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(7776),
    [sym__binary_star] = ACTIONS(7778),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(7780),
    [anon_sym_STAR_STAR] = ACTIONS(7778),
    [anon_sym_AMP] = ACTIONS(7782),
    [anon_sym_LT] = ACTIONS(7784),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(7786),
    [anon_sym_DOT_DOT] = ACTIONS(7788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7790),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(7794),
    [anon_sym_AMP_AMP] = ACTIONS(7794),
    [anon_sym_LT_LT] = ACTIONS(7796),
    [anon_sym_GT_GT] = ACTIONS(7796),
    [anon_sym_EQ_EQ] = ACTIONS(7798),
    [anon_sym_BANG_EQ] = ACTIONS(7794),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7794),
    [anon_sym_LT_EQ_GT] = ACTIONS(7794),
    [anon_sym_EQ_TILDE] = ACTIONS(7794),
    [anon_sym_BANG_TILDE] = ACTIONS(7794),
    [anon_sym_LT_EQ] = ACTIONS(7784),
    [anon_sym_GT] = ACTIONS(7784),
    [anon_sym_GT_EQ] = ACTIONS(7800),
    [anon_sym_CARET] = ACTIONS(7802),
    [anon_sym_PLUS] = ACTIONS(7776),
    [anon_sym_SLASH] = ACTIONS(7778),
    [anon_sym_PERCENT] = ACTIONS(7778),
    [sym_comment] = ACTIONS(87),
  },
  [7360] = {
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(7776),
    [sym__binary_star] = ACTIONS(7778),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(7780),
    [anon_sym_STAR_STAR] = ACTIONS(7778),
    [anon_sym_AMP] = ACTIONS(7782),
    [anon_sym_LT] = ACTIONS(7784),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(7786),
    [anon_sym_DOT_DOT] = ACTIONS(7788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7790),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(7794),
    [anon_sym_AMP_AMP] = ACTIONS(7794),
    [anon_sym_LT_LT] = ACTIONS(7796),
    [anon_sym_GT_GT] = ACTIONS(7796),
    [anon_sym_EQ_EQ] = ACTIONS(7798),
    [anon_sym_BANG_EQ] = ACTIONS(7794),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7794),
    [anon_sym_LT_EQ_GT] = ACTIONS(7794),
    [anon_sym_EQ_TILDE] = ACTIONS(7794),
    [anon_sym_BANG_TILDE] = ACTIONS(7794),
    [anon_sym_LT_EQ] = ACTIONS(7784),
    [anon_sym_GT] = ACTIONS(7784),
    [anon_sym_GT_EQ] = ACTIONS(7800),
    [anon_sym_CARET] = ACTIONS(7802),
    [anon_sym_PLUS] = ACTIONS(7776),
    [anon_sym_SLASH] = ACTIONS(7778),
    [anon_sym_PERCENT] = ACTIONS(7778),
    [sym_comment] = ACTIONS(87),
  },
  [7361] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9246),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2408),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(2408),
    [sym_assignment] = STATE(9246),
    [sym_operator_assignment] = STATE(9246),
    [sym_conditional] = STATE(9246),
    [sym_range] = STATE(9246),
    [sym_binary] = STATE(9246),
    [sym_unary] = STATE(9246),
    [sym_left_assignment_list] = STATE(2407),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2408),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2408),
    [sym_false] = STATE(2408),
    [sym_nil] = STATE(2408),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2409),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4133),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4135),
    [anon_sym_yield] = ACTIONS(4137),
    [anon_sym_break] = ACTIONS(4139),
    [anon_sym_next] = ACTIONS(4141),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4143),
    [anon_sym_defined_QMARK] = ACTIONS(4145),
    [anon_sym_not] = ACTIONS(4147),
    [anon_sym_BANG] = ACTIONS(4149),
    [anon_sym_TILDE] = ACTIONS(4149),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7362] = {
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(7776),
    [sym__binary_star] = ACTIONS(7778),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(7780),
    [anon_sym_STAR_STAR] = ACTIONS(7778),
    [anon_sym_AMP] = ACTIONS(7782),
    [anon_sym_LT] = ACTIONS(7784),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(7786),
    [anon_sym_DOT_DOT] = ACTIONS(7788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7790),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(7794),
    [anon_sym_AMP_AMP] = ACTIONS(7794),
    [anon_sym_LT_LT] = ACTIONS(7796),
    [anon_sym_GT_GT] = ACTIONS(7796),
    [anon_sym_EQ_EQ] = ACTIONS(7798),
    [anon_sym_BANG_EQ] = ACTIONS(7794),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7794),
    [anon_sym_LT_EQ_GT] = ACTIONS(7794),
    [anon_sym_EQ_TILDE] = ACTIONS(7794),
    [anon_sym_BANG_TILDE] = ACTIONS(7794),
    [anon_sym_LT_EQ] = ACTIONS(7784),
    [anon_sym_GT] = ACTIONS(7784),
    [anon_sym_GT_EQ] = ACTIONS(7800),
    [anon_sym_CARET] = ACTIONS(7802),
    [anon_sym_PLUS] = ACTIONS(7776),
    [anon_sym_SLASH] = ACTIONS(7778),
    [anon_sym_PERCENT] = ACTIONS(7778),
    [sym_comment] = ACTIONS(87),
  },
  [7363] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9247),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2408),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(2408),
    [sym_assignment] = STATE(9247),
    [sym_operator_assignment] = STATE(9247),
    [sym_conditional] = STATE(9247),
    [sym_range] = STATE(9247),
    [sym_binary] = STATE(9247),
    [sym_unary] = STATE(9247),
    [sym_left_assignment_list] = STATE(2407),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2408),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2408),
    [sym_false] = STATE(2408),
    [sym_nil] = STATE(2408),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2409),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4133),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4135),
    [anon_sym_yield] = ACTIONS(4137),
    [anon_sym_break] = ACTIONS(4139),
    [anon_sym_next] = ACTIONS(4141),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4143),
    [anon_sym_defined_QMARK] = ACTIONS(4145),
    [anon_sym_not] = ACTIONS(4147),
    [anon_sym_BANG] = ACTIONS(4149),
    [anon_sym_TILDE] = ACTIONS(4149),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7364] = {
    [sym_heredoc_body] = STATE(9248),
    [aux_sym_call_repeat1] = STATE(9248),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [7365] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4841),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym__argument] = STATE(4250),
    [sym_splat_argument] = STATE(4250),
    [sym_hash_splat_argument] = STATE(4250),
    [sym_block_argument] = STATE(4250),
    [sym_assignment] = STATE(4841),
    [sym_operator_assignment] = STATE(4841),
    [sym_conditional] = STATE(4841),
    [sym_range] = STATE(4841),
    [sym_binary] = STATE(4841),
    [sym_unary] = STATE(4841),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4844),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_heredoc_body] = STATE(9249),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(4250),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(7768),
    [sym__splat_star] = ACTIONS(7770),
    [sym__unary_minus] = ACTIONS(1525),
    [sym__identifier_hash_key] = ACTIONS(7772),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12858),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(7774),
    [sym_identifier] = ACTIONS(7774),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7366] = {
    [sym_heredoc_body] = STATE(9250),
    [aux_sym_call_repeat1] = STATE(9250),
    [aux_sym_argument_list_repeat1] = STATE(9251),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(10939),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [7367] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(7778),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(7778),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(7778),
    [anon_sym_PERCENT] = ACTIONS(7778),
    [sym_comment] = ACTIONS(87),
  },
  [7368] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(7778),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [7369] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7776),
    [sym__binary_star] = ACTIONS(7778),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(7778),
    [anon_sym_AMP] = ACTIONS(7782),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(7796),
    [anon_sym_GT_GT] = ACTIONS(7796),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(7776),
    [anon_sym_SLASH] = ACTIONS(7778),
    [anon_sym_PERCENT] = ACTIONS(7778),
    [sym_comment] = ACTIONS(87),
  },
  [7370] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7776),
    [sym__binary_star] = ACTIONS(7778),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(7778),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(7796),
    [anon_sym_GT_GT] = ACTIONS(7796),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(7776),
    [anon_sym_SLASH] = ACTIONS(7778),
    [anon_sym_PERCENT] = ACTIONS(7778),
    [sym_comment] = ACTIONS(87),
  },
  [7371] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7776),
    [sym__binary_star] = ACTIONS(7778),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(7780),
    [anon_sym_STAR_STAR] = ACTIONS(7778),
    [anon_sym_AMP] = ACTIONS(7782),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(7796),
    [anon_sym_GT_GT] = ACTIONS(7796),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(7802),
    [anon_sym_PLUS] = ACTIONS(7776),
    [anon_sym_SLASH] = ACTIONS(7778),
    [anon_sym_PERCENT] = ACTIONS(7778),
    [sym_comment] = ACTIONS(87),
  },
  [7372] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(12860),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [7373] = {
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(7776),
    [sym__binary_star] = ACTIONS(7778),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(7780),
    [anon_sym_STAR_STAR] = ACTIONS(7778),
    [anon_sym_AMP] = ACTIONS(7782),
    [anon_sym_LT] = ACTIONS(7784),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(7788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7790),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(7794),
    [anon_sym_AMP_AMP] = ACTIONS(7794),
    [anon_sym_LT_LT] = ACTIONS(7796),
    [anon_sym_GT_GT] = ACTIONS(7796),
    [anon_sym_EQ_EQ] = ACTIONS(7798),
    [anon_sym_BANG_EQ] = ACTIONS(7794),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7794),
    [anon_sym_LT_EQ_GT] = ACTIONS(7794),
    [anon_sym_EQ_TILDE] = ACTIONS(7794),
    [anon_sym_BANG_TILDE] = ACTIONS(7794),
    [anon_sym_LT_EQ] = ACTIONS(7784),
    [anon_sym_GT] = ACTIONS(7784),
    [anon_sym_GT_EQ] = ACTIONS(7800),
    [anon_sym_CARET] = ACTIONS(7802),
    [anon_sym_PLUS] = ACTIONS(7776),
    [anon_sym_SLASH] = ACTIONS(7778),
    [anon_sym_PERCENT] = ACTIONS(7778),
    [sym_comment] = ACTIONS(87),
  },
  [7374] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7776),
    [sym__binary_star] = ACTIONS(7778),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(7780),
    [anon_sym_STAR_STAR] = ACTIONS(7778),
    [anon_sym_AMP] = ACTIONS(7782),
    [anon_sym_LT] = ACTIONS(7784),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(7786),
    [anon_sym_DOT_DOT] = ACTIONS(7788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7790),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(7794),
    [anon_sym_AMP_AMP] = ACTIONS(7794),
    [anon_sym_LT_LT] = ACTIONS(7796),
    [anon_sym_GT_GT] = ACTIONS(7796),
    [anon_sym_EQ_EQ] = ACTIONS(7798),
    [anon_sym_BANG_EQ] = ACTIONS(7794),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7794),
    [anon_sym_LT_EQ_GT] = ACTIONS(7794),
    [anon_sym_EQ_TILDE] = ACTIONS(7794),
    [anon_sym_BANG_TILDE] = ACTIONS(7794),
    [anon_sym_LT_EQ] = ACTIONS(7784),
    [anon_sym_GT] = ACTIONS(7784),
    [anon_sym_GT_EQ] = ACTIONS(7800),
    [anon_sym_CARET] = ACTIONS(7802),
    [anon_sym_PLUS] = ACTIONS(7776),
    [anon_sym_SLASH] = ACTIONS(7778),
    [anon_sym_PERCENT] = ACTIONS(7778),
    [sym_comment] = ACTIONS(87),
  },
  [7375] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7776),
    [sym__binary_star] = ACTIONS(7778),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(7780),
    [anon_sym_STAR_STAR] = ACTIONS(7778),
    [anon_sym_AMP] = ACTIONS(7782),
    [anon_sym_LT] = ACTIONS(7784),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(7796),
    [anon_sym_GT_GT] = ACTIONS(7796),
    [anon_sym_EQ_EQ] = ACTIONS(7798),
    [anon_sym_BANG_EQ] = ACTIONS(7794),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7794),
    [anon_sym_LT_EQ_GT] = ACTIONS(7794),
    [anon_sym_EQ_TILDE] = ACTIONS(7794),
    [anon_sym_BANG_TILDE] = ACTIONS(7794),
    [anon_sym_LT_EQ] = ACTIONS(7784),
    [anon_sym_GT] = ACTIONS(7784),
    [anon_sym_GT_EQ] = ACTIONS(7800),
    [anon_sym_CARET] = ACTIONS(7802),
    [anon_sym_PLUS] = ACTIONS(7776),
    [anon_sym_SLASH] = ACTIONS(7778),
    [anon_sym_PERCENT] = ACTIONS(7778),
    [sym_comment] = ACTIONS(87),
  },
  [7376] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7776),
    [sym__binary_star] = ACTIONS(7778),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(7778),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(7776),
    [anon_sym_SLASH] = ACTIONS(7778),
    [anon_sym_PERCENT] = ACTIONS(7778),
    [sym_comment] = ACTIONS(87),
  },
  [7377] = {
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(7776),
    [sym__binary_star] = ACTIONS(7778),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(7780),
    [anon_sym_STAR_STAR] = ACTIONS(7778),
    [anon_sym_AMP] = ACTIONS(7782),
    [anon_sym_LT] = ACTIONS(7784),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(7786),
    [anon_sym_DOT_DOT] = ACTIONS(7788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7790),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7794),
    [anon_sym_AMP_AMP] = ACTIONS(7794),
    [anon_sym_LT_LT] = ACTIONS(7796),
    [anon_sym_GT_GT] = ACTIONS(7796),
    [anon_sym_EQ_EQ] = ACTIONS(7798),
    [anon_sym_BANG_EQ] = ACTIONS(7794),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7794),
    [anon_sym_LT_EQ_GT] = ACTIONS(7794),
    [anon_sym_EQ_TILDE] = ACTIONS(7794),
    [anon_sym_BANG_TILDE] = ACTIONS(7794),
    [anon_sym_LT_EQ] = ACTIONS(7784),
    [anon_sym_GT] = ACTIONS(7784),
    [anon_sym_GT_EQ] = ACTIONS(7800),
    [anon_sym_CARET] = ACTIONS(7802),
    [anon_sym_PLUS] = ACTIONS(7776),
    [anon_sym_SLASH] = ACTIONS(7778),
    [anon_sym_PERCENT] = ACTIONS(7778),
    [sym_comment] = ACTIONS(87),
  },
  [7378] = {
    [aux_sym_exceptions_repeat1] = STATE(9254),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [7379] = {
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(7776),
    [sym__binary_star] = ACTIONS(7778),
    [anon_sym_LBRACE] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(7780),
    [anon_sym_STAR_STAR] = ACTIONS(7778),
    [anon_sym_AMP] = ACTIONS(7782),
    [anon_sym_LT] = ACTIONS(7784),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(7786),
    [anon_sym_DOT_DOT] = ACTIONS(7788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7790),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(7794),
    [anon_sym_AMP_AMP] = ACTIONS(7794),
    [anon_sym_LT_LT] = ACTIONS(7796),
    [anon_sym_GT_GT] = ACTIONS(7796),
    [anon_sym_EQ_EQ] = ACTIONS(7798),
    [anon_sym_BANG_EQ] = ACTIONS(7794),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7794),
    [anon_sym_LT_EQ_GT] = ACTIONS(7794),
    [anon_sym_EQ_TILDE] = ACTIONS(7794),
    [anon_sym_BANG_TILDE] = ACTIONS(7794),
    [anon_sym_LT_EQ] = ACTIONS(7784),
    [anon_sym_GT] = ACTIONS(7784),
    [anon_sym_GT_EQ] = ACTIONS(7800),
    [anon_sym_CARET] = ACTIONS(7802),
    [anon_sym_PLUS] = ACTIONS(7776),
    [anon_sym_SLASH] = ACTIONS(7778),
    [anon_sym_PERCENT] = ACTIONS(7778),
    [sym_comment] = ACTIONS(87),
  },
  [7380] = {
    [sym_string] = STATE(7380),
    [aux_sym_chained_string_repeat1] = STATE(7380),
    [sym__string_start] = ACTIONS(9407),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_do] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [7381] = {
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(4167),
    [sym__binary_star] = ACTIONS(4169),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(4171),
    [anon_sym_STAR_STAR] = ACTIONS(4169),
    [anon_sym_AMP] = ACTIONS(4173),
    [anon_sym_LT] = ACTIONS(4175),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_EQ_GT] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_DOT_DOT] = ACTIONS(4179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4181),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(4185),
    [anon_sym_AMP_AMP] = ACTIONS(4185),
    [anon_sym_LT_LT] = ACTIONS(4187),
    [anon_sym_GT_GT] = ACTIONS(4187),
    [anon_sym_EQ_EQ] = ACTIONS(4189),
    [anon_sym_BANG_EQ] = ACTIONS(4185),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4185),
    [anon_sym_LT_EQ_GT] = ACTIONS(4185),
    [anon_sym_EQ_TILDE] = ACTIONS(4185),
    [anon_sym_BANG_TILDE] = ACTIONS(4185),
    [anon_sym_LT_EQ] = ACTIONS(4175),
    [anon_sym_GT] = ACTIONS(4175),
    [anon_sym_GT_EQ] = ACTIONS(4191),
    [anon_sym_CARET] = ACTIONS(4193),
    [anon_sym_PLUS] = ACTIONS(4167),
    [anon_sym_SLASH] = ACTIONS(4169),
    [anon_sym_PERCENT] = ACTIONS(4169),
    [sym_comment] = ACTIONS(87),
  },
  [7382] = {
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(4167),
    [sym__binary_star] = ACTIONS(4169),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(4171),
    [anon_sym_STAR_STAR] = ACTIONS(4169),
    [anon_sym_AMP] = ACTIONS(4173),
    [anon_sym_LT] = ACTIONS(4175),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_EQ_GT] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_DOT_DOT] = ACTIONS(4179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4181),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(4185),
    [anon_sym_AMP_AMP] = ACTIONS(4185),
    [anon_sym_LT_LT] = ACTIONS(4187),
    [anon_sym_GT_GT] = ACTIONS(4187),
    [anon_sym_EQ_EQ] = ACTIONS(4189),
    [anon_sym_BANG_EQ] = ACTIONS(4185),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4185),
    [anon_sym_LT_EQ_GT] = ACTIONS(4185),
    [anon_sym_EQ_TILDE] = ACTIONS(4185),
    [anon_sym_BANG_TILDE] = ACTIONS(4185),
    [anon_sym_LT_EQ] = ACTIONS(4175),
    [anon_sym_GT] = ACTIONS(4175),
    [anon_sym_GT_EQ] = ACTIONS(4191),
    [anon_sym_CARET] = ACTIONS(4193),
    [anon_sym_PLUS] = ACTIONS(4167),
    [anon_sym_SLASH] = ACTIONS(4169),
    [anon_sym_PERCENT] = ACTIONS(4169),
    [sym_comment] = ACTIONS(87),
  },
  [7383] = {
    [sym_heredoc_body] = STATE(7383),
    [aux_sym_call_repeat1] = STATE(7383),
    [sym__heredoc_body_start] = ACTIONS(10455),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_EQ_GT] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [7384] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(2421),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym__argument] = STATE(6908),
    [sym_splat_argument] = STATE(6908),
    [sym_hash_splat_argument] = STATE(6908),
    [sym_block_argument] = STATE(6908),
    [sym_assignment] = STATE(2421),
    [sym_operator_assignment] = STATE(2421),
    [sym_conditional] = STATE(2421),
    [sym_range] = STATE(2421),
    [sym_binary] = STATE(2421),
    [sym_unary] = STATE(2421),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2424),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(6908),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(4155),
    [sym__splat_star] = ACTIONS(4157),
    [sym__unary_minus] = ACTIONS(1525),
    [sym__identifier_hash_key] = ACTIONS(4159),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10943),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(4163),
    [sym_identifier] = ACTIONS(4163),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7385] = {
    [sym_heredoc_body] = STATE(7383),
    [aux_sym_call_repeat1] = STATE(7383),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_EQ_GT] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [7386] = {
    [aux_sym_argument_list_repeat1] = STATE(7386),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(12862),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_STAR_STAR] = ACTIONS(7925),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_EQ_GT] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7925),
    [anon_sym_AMP_AMP] = ACTIONS(7925),
    [anon_sym_LT_LT] = ACTIONS(7925),
    [anon_sym_GT_GT] = ACTIONS(7925),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7925),
    [anon_sym_PLUS] = ACTIONS(7925),
    [anon_sym_SLASH] = ACTIONS(7925),
    [anon_sym_PERCENT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [7387] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(9255),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym_assignment] = STATE(9255),
    [sym_operator_assignment] = STATE(9255),
    [sym_conditional] = STATE(9255),
    [sym_range] = STATE(9255),
    [sym_binary] = STATE(9255),
    [sym_unary] = STATE(9255),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2412),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7388] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4883),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym_splat_argument] = STATE(9013),
    [sym_assignment] = STATE(4883),
    [sym_operator_assignment] = STATE(4883),
    [sym_conditional] = STATE(4883),
    [sym_range] = STATE(4883),
    [sym_binary] = STATE(4883),
    [sym_unary] = STATE(4883),
    [sym__arg_or_splat_arg] = STATE(9013),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2412),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(4157),
    [sym__unary_minus] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7389] = {
    [aux_sym_exceptions_repeat1] = STATE(9256),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_LBRACE] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(12865),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_do] = ACTIONS(9855),
    [anon_sym_EQ_GT] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [7390] = {
    [sym_heredoc_body] = STATE(7390),
    [aux_sym_call_repeat1] = STATE(7390),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(7916),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [ts_builtin_sym_end] = ACTIONS(7914),
    [anon_sym___END__] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [7391] = {
    [sym_heredoc_body] = STATE(7390),
    [aux_sym_call_repeat1] = STATE(7390),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [ts_builtin_sym_end] = ACTIONS(7929),
    [anon_sym___END__] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [7392] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9257),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(876),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(876),
    [sym_assignment] = STATE(9257),
    [sym_operator_assignment] = STATE(9257),
    [sym_conditional] = STATE(9257),
    [sym_range] = STATE(9257),
    [sym_binary] = STATE(9257),
    [sym_unary] = STATE(9257),
    [sym_left_assignment_list] = STATE(875),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(876),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(876),
    [sym_false] = STATE(876),
    [sym_nil] = STATE(876),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(877),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(1555),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1557),
    [anon_sym_yield] = ACTIONS(1559),
    [anon_sym_break] = ACTIONS(1561),
    [anon_sym_next] = ACTIONS(1563),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_defined_QMARK] = ACTIONS(1567),
    [anon_sym_not] = ACTIONS(1569),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_TILDE] = ACTIONS(1571),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7393] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(4899),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(876),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(876),
    [sym_splat_argument] = STATE(7439),
    [sym_assignment] = STATE(4899),
    [sym_operator_assignment] = STATE(4899),
    [sym_conditional] = STATE(4899),
    [sym_range] = STATE(4899),
    [sym_binary] = STATE(4899),
    [sym_unary] = STATE(4899),
    [sym__arg_or_splat_arg] = STATE(7439),
    [sym_left_assignment_list] = STATE(875),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(876),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(876),
    [sym_false] = STATE(876),
    [sym_nil] = STATE(876),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(877),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(371),
    [sym__unary_minus] = ACTIONS(1555),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1557),
    [anon_sym_yield] = ACTIONS(1559),
    [anon_sym_break] = ACTIONS(1561),
    [anon_sym_next] = ACTIONS(1563),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_defined_QMARK] = ACTIONS(1567),
    [anon_sym_not] = ACTIONS(1569),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_TILDE] = ACTIONS(1571),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7394] = {
    [aux_sym_exceptions_repeat1] = STATE(9258),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [ts_builtin_sym_end] = ACTIONS(9855),
    [anon_sym___END__] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(12867),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [7395] = {
    [sym_heredoc_body] = STATE(9259),
    [aux_sym_call_repeat1] = STATE(9259),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_RPAREN] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [7396] = {
    [sym_heredoc_body] = STATE(9260),
    [aux_sym_call_repeat1] = STATE(9260),
    [aux_sym_argument_list_repeat1] = STATE(7018),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_RPAREN] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(7216),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [7397] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(7828),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(7828),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(7828),
    [anon_sym_PERCENT] = ACTIONS(7828),
    [sym_comment] = ACTIONS(87),
  },
  [7398] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(7828),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [7399] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7826),
    [sym__binary_star] = ACTIONS(7828),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(7828),
    [anon_sym_AMP] = ACTIONS(7832),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(7846),
    [anon_sym_GT_GT] = ACTIONS(7846),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(7826),
    [anon_sym_SLASH] = ACTIONS(7828),
    [anon_sym_PERCENT] = ACTIONS(7828),
    [sym_comment] = ACTIONS(87),
  },
  [7400] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7826),
    [sym__binary_star] = ACTIONS(7828),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(7828),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(7846),
    [anon_sym_GT_GT] = ACTIONS(7846),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(7826),
    [anon_sym_SLASH] = ACTIONS(7828),
    [anon_sym_PERCENT] = ACTIONS(7828),
    [sym_comment] = ACTIONS(87),
  },
  [7401] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7826),
    [sym__binary_star] = ACTIONS(7828),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(7830),
    [anon_sym_STAR_STAR] = ACTIONS(7828),
    [anon_sym_AMP] = ACTIONS(7832),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(7846),
    [anon_sym_GT_GT] = ACTIONS(7846),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(7852),
    [anon_sym_PLUS] = ACTIONS(7826),
    [anon_sym_SLASH] = ACTIONS(7828),
    [anon_sym_PERCENT] = ACTIONS(7828),
    [sym_comment] = ACTIONS(87),
  },
  [7402] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(12869),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [7403] = {
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(7826),
    [sym__binary_star] = ACTIONS(7828),
    [anon_sym_RPAREN] = ACTIONS(5927),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(7830),
    [anon_sym_STAR_STAR] = ACTIONS(7828),
    [anon_sym_AMP] = ACTIONS(7832),
    [anon_sym_LT] = ACTIONS(7834),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(7838),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7840),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(7844),
    [anon_sym_AMP_AMP] = ACTIONS(7844),
    [anon_sym_LT_LT] = ACTIONS(7846),
    [anon_sym_GT_GT] = ACTIONS(7846),
    [anon_sym_EQ_EQ] = ACTIONS(7848),
    [anon_sym_BANG_EQ] = ACTIONS(7844),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7844),
    [anon_sym_LT_EQ_GT] = ACTIONS(7844),
    [anon_sym_EQ_TILDE] = ACTIONS(7844),
    [anon_sym_BANG_TILDE] = ACTIONS(7844),
    [anon_sym_LT_EQ] = ACTIONS(7834),
    [anon_sym_GT] = ACTIONS(7834),
    [anon_sym_GT_EQ] = ACTIONS(7850),
    [anon_sym_CARET] = ACTIONS(7852),
    [anon_sym_PLUS] = ACTIONS(7826),
    [anon_sym_SLASH] = ACTIONS(7828),
    [anon_sym_PERCENT] = ACTIONS(7828),
    [sym_comment] = ACTIONS(87),
  },
  [7404] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7826),
    [sym__binary_star] = ACTIONS(7828),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(7830),
    [anon_sym_STAR_STAR] = ACTIONS(7828),
    [anon_sym_AMP] = ACTIONS(7832),
    [anon_sym_LT] = ACTIONS(7834),
    [anon_sym_QMARK] = ACTIONS(7836),
    [anon_sym_DOT_DOT] = ACTIONS(7838),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7840),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(7844),
    [anon_sym_AMP_AMP] = ACTIONS(7844),
    [anon_sym_LT_LT] = ACTIONS(7846),
    [anon_sym_GT_GT] = ACTIONS(7846),
    [anon_sym_EQ_EQ] = ACTIONS(7848),
    [anon_sym_BANG_EQ] = ACTIONS(7844),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7844),
    [anon_sym_LT_EQ_GT] = ACTIONS(7844),
    [anon_sym_EQ_TILDE] = ACTIONS(7844),
    [anon_sym_BANG_TILDE] = ACTIONS(7844),
    [anon_sym_LT_EQ] = ACTIONS(7834),
    [anon_sym_GT] = ACTIONS(7834),
    [anon_sym_GT_EQ] = ACTIONS(7850),
    [anon_sym_CARET] = ACTIONS(7852),
    [anon_sym_PLUS] = ACTIONS(7826),
    [anon_sym_SLASH] = ACTIONS(7828),
    [anon_sym_PERCENT] = ACTIONS(7828),
    [sym_comment] = ACTIONS(87),
  },
  [7405] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7826),
    [sym__binary_star] = ACTIONS(7828),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(7830),
    [anon_sym_STAR_STAR] = ACTIONS(7828),
    [anon_sym_AMP] = ACTIONS(7832),
    [anon_sym_LT] = ACTIONS(7834),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(7846),
    [anon_sym_GT_GT] = ACTIONS(7846),
    [anon_sym_EQ_EQ] = ACTIONS(7848),
    [anon_sym_BANG_EQ] = ACTIONS(7844),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7844),
    [anon_sym_LT_EQ_GT] = ACTIONS(7844),
    [anon_sym_EQ_TILDE] = ACTIONS(7844),
    [anon_sym_BANG_TILDE] = ACTIONS(7844),
    [anon_sym_LT_EQ] = ACTIONS(7834),
    [anon_sym_GT] = ACTIONS(7834),
    [anon_sym_GT_EQ] = ACTIONS(7850),
    [anon_sym_CARET] = ACTIONS(7852),
    [anon_sym_PLUS] = ACTIONS(7826),
    [anon_sym_SLASH] = ACTIONS(7828),
    [anon_sym_PERCENT] = ACTIONS(7828),
    [sym_comment] = ACTIONS(87),
  },
  [7406] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7826),
    [sym__binary_star] = ACTIONS(7828),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(7828),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(7826),
    [anon_sym_SLASH] = ACTIONS(7828),
    [anon_sym_PERCENT] = ACTIONS(7828),
    [sym_comment] = ACTIONS(87),
  },
  [7407] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9262),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2480),
    [sym_scope_resolution] = STATE(2478),
    [sym_call] = STATE(2478),
    [sym_method_call] = STATE(2480),
    [sym_assignment] = STATE(9262),
    [sym_operator_assignment] = STATE(9262),
    [sym_conditional] = STATE(9262),
    [sym_range] = STATE(9262),
    [sym_binary] = STATE(9262),
    [sym_unary] = STATE(9262),
    [sym_left_assignment_list] = STATE(2479),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2480),
    [sym__variable] = STATE(2478),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2480),
    [sym_false] = STATE(2480),
    [sym_nil] = STATE(2480),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2481),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4261),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4263),
    [anon_sym_yield] = ACTIONS(4265),
    [anon_sym_break] = ACTIONS(4267),
    [anon_sym_next] = ACTIONS(4269),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4271),
    [anon_sym_defined_QMARK] = ACTIONS(4273),
    [anon_sym_not] = ACTIONS(4275),
    [anon_sym_BANG] = ACTIONS(4277),
    [anon_sym_TILDE] = ACTIONS(4277),
    [sym_constant] = ACTIONS(4279),
    [sym_identifier] = ACTIONS(4279),
    [sym_instance_variable] = ACTIONS(4281),
    [sym_class_variable] = ACTIONS(4281),
    [sym_global_variable] = ACTIONS(4281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4279),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4279),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7408] = {
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(7826),
    [sym__binary_star] = ACTIONS(7828),
    [anon_sym_RPAREN] = ACTIONS(5115),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(7830),
    [anon_sym_STAR_STAR] = ACTIONS(7828),
    [anon_sym_AMP] = ACTIONS(7832),
    [anon_sym_LT] = ACTIONS(7834),
    [anon_sym_QMARK] = ACTIONS(7836),
    [anon_sym_DOT_DOT] = ACTIONS(7838),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7840),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7844),
    [anon_sym_AMP_AMP] = ACTIONS(7844),
    [anon_sym_LT_LT] = ACTIONS(7846),
    [anon_sym_GT_GT] = ACTIONS(7846),
    [anon_sym_EQ_EQ] = ACTIONS(7848),
    [anon_sym_BANG_EQ] = ACTIONS(7844),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7844),
    [anon_sym_LT_EQ_GT] = ACTIONS(7844),
    [anon_sym_EQ_TILDE] = ACTIONS(7844),
    [anon_sym_BANG_TILDE] = ACTIONS(7844),
    [anon_sym_LT_EQ] = ACTIONS(7834),
    [anon_sym_GT] = ACTIONS(7834),
    [anon_sym_GT_EQ] = ACTIONS(7850),
    [anon_sym_CARET] = ACTIONS(7852),
    [anon_sym_PLUS] = ACTIONS(7826),
    [anon_sym_SLASH] = ACTIONS(7828),
    [anon_sym_PERCENT] = ACTIONS(7828),
    [sym_comment] = ACTIONS(87),
  },
  [7409] = {
    [aux_sym_exceptions_repeat1] = STATE(9264),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_RPAREN] = ACTIONS(6191),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [7410] = {
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(7826),
    [sym__binary_star] = ACTIONS(7828),
    [anon_sym_RPAREN] = ACTIONS(6210),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(7830),
    [anon_sym_STAR_STAR] = ACTIONS(7828),
    [anon_sym_AMP] = ACTIONS(7832),
    [anon_sym_LT] = ACTIONS(7834),
    [anon_sym_QMARK] = ACTIONS(7836),
    [anon_sym_DOT_DOT] = ACTIONS(7838),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7840),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(7844),
    [anon_sym_AMP_AMP] = ACTIONS(7844),
    [anon_sym_LT_LT] = ACTIONS(7846),
    [anon_sym_GT_GT] = ACTIONS(7846),
    [anon_sym_EQ_EQ] = ACTIONS(7848),
    [anon_sym_BANG_EQ] = ACTIONS(7844),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7844),
    [anon_sym_LT_EQ_GT] = ACTIONS(7844),
    [anon_sym_EQ_TILDE] = ACTIONS(7844),
    [anon_sym_BANG_TILDE] = ACTIONS(7844),
    [anon_sym_LT_EQ] = ACTIONS(7834),
    [anon_sym_GT] = ACTIONS(7834),
    [anon_sym_GT_EQ] = ACTIONS(7850),
    [anon_sym_CARET] = ACTIONS(7852),
    [anon_sym_PLUS] = ACTIONS(7826),
    [anon_sym_SLASH] = ACTIONS(7828),
    [anon_sym_PERCENT] = ACTIONS(7828),
    [sym_comment] = ACTIONS(87),
  },
  [7411] = {
    [sym_string] = STATE(7411),
    [aux_sym_chained_string_repeat1] = STATE(7411),
    [sym__string_start] = ACTIONS(9407),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_RPAREN] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [7412] = {
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(7190),
    [sym__binary_star] = ACTIONS(7192),
    [anon_sym_RPAREN] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(7194),
    [anon_sym_STAR_STAR] = ACTIONS(7192),
    [anon_sym_AMP] = ACTIONS(7196),
    [anon_sym_LT] = ACTIONS(7198),
    [anon_sym_EQ_GT] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(7200),
    [anon_sym_DOT_DOT] = ACTIONS(7202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7204),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(7206),
    [anon_sym_AMP_AMP] = ACTIONS(7206),
    [anon_sym_LT_LT] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7208),
    [anon_sym_EQ_EQ] = ACTIONS(7210),
    [anon_sym_BANG_EQ] = ACTIONS(7206),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7206),
    [anon_sym_LT_EQ_GT] = ACTIONS(7206),
    [anon_sym_EQ_TILDE] = ACTIONS(7206),
    [anon_sym_BANG_TILDE] = ACTIONS(7206),
    [anon_sym_LT_EQ] = ACTIONS(7198),
    [anon_sym_GT] = ACTIONS(7198),
    [anon_sym_GT_EQ] = ACTIONS(7212),
    [anon_sym_CARET] = ACTIONS(7214),
    [anon_sym_PLUS] = ACTIONS(7190),
    [anon_sym_SLASH] = ACTIONS(7192),
    [anon_sym_PERCENT] = ACTIONS(7192),
    [sym_comment] = ACTIONS(87),
  },
  [7413] = {
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(7190),
    [sym__binary_star] = ACTIONS(7192),
    [anon_sym_RPAREN] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(7194),
    [anon_sym_STAR_STAR] = ACTIONS(7192),
    [anon_sym_AMP] = ACTIONS(7196),
    [anon_sym_LT] = ACTIONS(7198),
    [anon_sym_EQ_GT] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(7200),
    [anon_sym_DOT_DOT] = ACTIONS(7202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7204),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(7206),
    [anon_sym_AMP_AMP] = ACTIONS(7206),
    [anon_sym_LT_LT] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7208),
    [anon_sym_EQ_EQ] = ACTIONS(7210),
    [anon_sym_BANG_EQ] = ACTIONS(7206),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7206),
    [anon_sym_LT_EQ_GT] = ACTIONS(7206),
    [anon_sym_EQ_TILDE] = ACTIONS(7206),
    [anon_sym_BANG_TILDE] = ACTIONS(7206),
    [anon_sym_LT_EQ] = ACTIONS(7198),
    [anon_sym_GT] = ACTIONS(7198),
    [anon_sym_GT_EQ] = ACTIONS(7212),
    [anon_sym_CARET] = ACTIONS(7214),
    [anon_sym_PLUS] = ACTIONS(7190),
    [anon_sym_SLASH] = ACTIONS(7192),
    [anon_sym_PERCENT] = ACTIONS(7192),
    [sym_comment] = ACTIONS(87),
  },
  [7414] = {
    [sym_heredoc_body] = STATE(7414),
    [aux_sym_call_repeat1] = STATE(7414),
    [sym__heredoc_body_start] = ACTIONS(10455),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_RPAREN] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_EQ_GT] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [7415] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(2492),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2061),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(2061),
    [sym__argument] = STATE(6908),
    [sym_splat_argument] = STATE(6908),
    [sym_hash_splat_argument] = STATE(6908),
    [sym_block_argument] = STATE(6908),
    [sym_assignment] = STATE(2492),
    [sym_operator_assignment] = STATE(2492),
    [sym_conditional] = STATE(2492),
    [sym_range] = STATE(2492),
    [sym_binary] = STATE(2492),
    [sym_unary] = STATE(2492),
    [sym_left_assignment_list] = STATE(2060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2061),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2061),
    [sym_false] = STATE(2061),
    [sym_nil] = STATE(2061),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2495),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(6908),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(4289),
    [sym__splat_star] = ACTIONS(4291),
    [sym__unary_minus] = ACTIONS(3595),
    [sym__identifier_hash_key] = ACTIONS(4293),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10957),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7184),
    [anon_sym_defined_QMARK] = ACTIONS(3599),
    [anon_sym_not] = ACTIONS(3601),
    [anon_sym_BANG] = ACTIONS(3605),
    [anon_sym_TILDE] = ACTIONS(3605),
    [sym_constant] = ACTIONS(4295),
    [sym_identifier] = ACTIONS(4295),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7416] = {
    [sym_heredoc_body] = STATE(7414),
    [aux_sym_call_repeat1] = STATE(7414),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_RPAREN] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_EQ_GT] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [7417] = {
    [aux_sym_argument_list_repeat1] = STATE(7417),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_RPAREN] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(12871),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_STAR_STAR] = ACTIONS(7925),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_EQ_GT] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7925),
    [anon_sym_AMP_AMP] = ACTIONS(7925),
    [anon_sym_LT_LT] = ACTIONS(7925),
    [anon_sym_GT_GT] = ACTIONS(7925),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7925),
    [anon_sym_PLUS] = ACTIONS(7925),
    [anon_sym_SLASH] = ACTIONS(7925),
    [anon_sym_PERCENT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [7418] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(9265),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(911),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(911),
    [sym_assignment] = STATE(9265),
    [sym_operator_assignment] = STATE(9265),
    [sym_conditional] = STATE(9265),
    [sym_range] = STATE(9265),
    [sym_binary] = STATE(9265),
    [sym_unary] = STATE(9265),
    [sym_left_assignment_list] = STATE(910),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(911),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(911),
    [sym_false] = STATE(911),
    [sym_nil] = STATE(911),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2484),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1593),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_defined_QMARK] = ACTIONS(1611),
    [anon_sym_not] = ACTIONS(1613),
    [anon_sym_BANG] = ACTIONS(1615),
    [anon_sym_TILDE] = ACTIONS(1615),
    [sym_constant] = ACTIONS(1621),
    [sym_identifier] = ACTIONS(1621),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7419] = {
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(7256),
    [sym__binary_star] = ACTIONS(7258),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_RPAREN] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(7260),
    [anon_sym_STAR_STAR] = ACTIONS(7262),
    [anon_sym_AMP] = ACTIONS(7264),
    [anon_sym_EQ] = ACTIONS(7822),
    [anon_sym_LT] = ACTIONS(7266),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_EQ_GT] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_PLUS_EQ] = ACTIONS(6823),
    [anon_sym_DASH_EQ] = ACTIONS(6823),
    [anon_sym_STAR_EQ] = ACTIONS(6823),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6823),
    [anon_sym_SLASH_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6823),
    [anon_sym_AMP_EQ] = ACTIONS(6823),
    [anon_sym_PERCENT_EQ] = ACTIONS(6823),
    [anon_sym_GT_GT_EQ] = ACTIONS(6823),
    [anon_sym_LT_LT_EQ] = ACTIONS(6823),
    [anon_sym_CARET_EQ] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(7268),
    [anon_sym_DOT_DOT] = ACTIONS(7270),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7272),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(7274),
    [anon_sym_AMP_AMP] = ACTIONS(7274),
    [anon_sym_LT_LT] = ACTIONS(7276),
    [anon_sym_GT_GT] = ACTIONS(7276),
    [anon_sym_EQ_EQ] = ACTIONS(7274),
    [anon_sym_BANG_EQ] = ACTIONS(7278),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7278),
    [anon_sym_LT_EQ_GT] = ACTIONS(7278),
    [anon_sym_EQ_TILDE] = ACTIONS(7278),
    [anon_sym_BANG_TILDE] = ACTIONS(7278),
    [anon_sym_LT_EQ] = ACTIONS(7266),
    [anon_sym_GT] = ACTIONS(7266),
    [anon_sym_GT_EQ] = ACTIONS(7280),
    [anon_sym_CARET] = ACTIONS(7260),
    [anon_sym_PLUS] = ACTIONS(7282),
    [anon_sym_SLASH] = ACTIONS(7262),
    [anon_sym_PERCENT] = ACTIONS(7262),
    [sym_comment] = ACTIONS(87),
  },
  [7420] = {
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(7256),
    [sym__binary_star] = ACTIONS(7258),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_RPAREN] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(7260),
    [anon_sym_STAR_STAR] = ACTIONS(7262),
    [anon_sym_AMP] = ACTIONS(7264),
    [anon_sym_EQ] = ACTIONS(7884),
    [anon_sym_LT] = ACTIONS(7266),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_EQ_GT] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_PLUS_EQ] = ACTIONS(7027),
    [anon_sym_DASH_EQ] = ACTIONS(7027),
    [anon_sym_STAR_EQ] = ACTIONS(7027),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7027),
    [anon_sym_SLASH_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7027),
    [anon_sym_AMP_EQ] = ACTIONS(7027),
    [anon_sym_PERCENT_EQ] = ACTIONS(7027),
    [anon_sym_GT_GT_EQ] = ACTIONS(7027),
    [anon_sym_LT_LT_EQ] = ACTIONS(7027),
    [anon_sym_CARET_EQ] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(7268),
    [anon_sym_DOT_DOT] = ACTIONS(7270),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7272),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(7274),
    [anon_sym_AMP_AMP] = ACTIONS(7274),
    [anon_sym_LT_LT] = ACTIONS(7276),
    [anon_sym_GT_GT] = ACTIONS(7276),
    [anon_sym_EQ_EQ] = ACTIONS(7274),
    [anon_sym_BANG_EQ] = ACTIONS(7278),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7278),
    [anon_sym_LT_EQ_GT] = ACTIONS(7278),
    [anon_sym_EQ_TILDE] = ACTIONS(7278),
    [anon_sym_BANG_TILDE] = ACTIONS(7278),
    [anon_sym_LT_EQ] = ACTIONS(7266),
    [anon_sym_GT] = ACTIONS(7266),
    [anon_sym_GT_EQ] = ACTIONS(7280),
    [anon_sym_CARET] = ACTIONS(7260),
    [anon_sym_PLUS] = ACTIONS(7282),
    [anon_sym_SLASH] = ACTIONS(7262),
    [anon_sym_PERCENT] = ACTIONS(7262),
    [sym_comment] = ACTIONS(87),
  },
  [7421] = {
    [sym_heredoc_body] = STATE(7421),
    [aux_sym_call_repeat1] = STATE(7421),
    [sym__heredoc_body_start] = ACTIONS(10553),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_RPAREN] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_STAR_STAR] = ACTIONS(7919),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_EQ] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_EQ_GT] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_PLUS_EQ] = ACTIONS(7914),
    [anon_sym_DASH_EQ] = ACTIONS(7914),
    [anon_sym_STAR_EQ] = ACTIONS(7914),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7914),
    [anon_sym_SLASH_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7914),
    [anon_sym_AMP_EQ] = ACTIONS(7914),
    [anon_sym_PERCENT_EQ] = ACTIONS(7914),
    [anon_sym_GT_GT_EQ] = ACTIONS(7914),
    [anon_sym_LT_LT_EQ] = ACTIONS(7914),
    [anon_sym_CARET_EQ] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7919),
    [anon_sym_AMP_AMP] = ACTIONS(7919),
    [anon_sym_LT_LT] = ACTIONS(7919),
    [anon_sym_GT_GT] = ACTIONS(7919),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7919),
    [anon_sym_PLUS] = ACTIONS(7919),
    [anon_sym_SLASH] = ACTIONS(7919),
    [anon_sym_PERCENT] = ACTIONS(7919),
    [sym_comment] = ACTIONS(87),
  },
  [7422] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(2513),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2092),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2092),
    [sym__argument] = STATE(6970),
    [sym_splat_argument] = STATE(6970),
    [sym_hash_splat_argument] = STATE(6970),
    [sym_block_argument] = STATE(6970),
    [sym_assignment] = STATE(2513),
    [sym_operator_assignment] = STATE(2513),
    [sym_conditional] = STATE(2513),
    [sym_range] = STATE(2513),
    [sym_binary] = STATE(2513),
    [sym_unary] = STATE(2513),
    [sym_left_assignment_list] = STATE(2091),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2092),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2092),
    [sym_false] = STATE(2092),
    [sym_nil] = STATE(2092),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(2516),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(6970),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(4327),
    [sym__splat_star] = ACTIONS(4329),
    [sym__unary_minus] = ACTIONS(3643),
    [sym__identifier_hash_key] = ACTIONS(4331),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10961),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3647),
    [anon_sym_yield] = ACTIONS(3649),
    [anon_sym_break] = ACTIONS(3651),
    [anon_sym_next] = ACTIONS(3653),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(7250),
    [anon_sym_defined_QMARK] = ACTIONS(3655),
    [anon_sym_not] = ACTIONS(3657),
    [anon_sym_BANG] = ACTIONS(3661),
    [anon_sym_TILDE] = ACTIONS(3661),
    [sym_constant] = ACTIONS(4333),
    [sym_identifier] = ACTIONS(4333),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [7423] = {
    [sym_heredoc_body] = STATE(7421),
    [aux_sym_call_repeat1] = STATE(7421),
    [sym__heredoc_body_start] = ACTIONS(3543),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_RPAREN] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_STAR_STAR] = ACTIONS(7931),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_EQ] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_EQ_GT] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_PLUS_EQ] = ACTIONS(7929),
    [anon_sym_DASH_EQ] = ACTIONS(7929),
    [anon_sym_STAR_EQ] = ACTIONS(7929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7929),
    [anon_sym_SLASH_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7929),
    [anon_sym_AMP_EQ] = ACTIONS(7929),
    [anon_sym_PERCENT_EQ] = ACTIONS(7929),
    [anon_sym_GT_GT_EQ] = ACTIONS(7929),
    [anon_sym_LT_LT_EQ] = ACTIONS(7929),
    [anon_sym_CARET_EQ] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7931),
    [anon_sym_AMP_AMP] = ACTIONS(7931),
    [anon_sym_LT_LT] = ACTIONS(7931),
    [anon_sym_GT_GT] = ACTIONS(7931),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7931),
    [anon_sym_PLUS] = ACTIONS(7931),
    [anon_sym_SLASH] = ACTIONS(7931),
    [anon_sym_PERCENT] = ACTIONS(7931),
    [sym_comment] = ACTIONS(87),
  },
  [7424] = {
    [aux_sym_argument_list_repeat1] = STATE(7424),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_RPAREN] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(12874),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_STAR_STAR] = ACTIONS(7927),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_EQ] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_EQ_GT] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_PLUS_EQ] = ACTIONS(7925),
    [anon_sym_DASH_EQ] = ACTIONS(7925),
    [anon_sym_STAR_EQ] = ACTIONS(7925),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7925),
    [anon_sym_SLASH_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7925),
    [anon_sym_AMP_EQ] = ACTIONS(7925),
    [anon_sym_PERCENT_EQ] = ACTIONS(7925),
    [anon_sym_GT_GT_EQ] = ACTIONS(7925),
    [anon_sym_LT_LT_EQ] = ACTIONS(7925),
    [anon_sym_CARET_EQ] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7927),
    [anon_sym_AMP_AMP] = ACTIONS(7927),
    [anon_sym_LT_LT] = ACTIONS(7927),
    [anon_sym_GT_GT] = ACTIONS(7927),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7927),
    [anon_sym_PLUS] = ACTIONS(7927),
    [anon_sym_SLASH] = ACTIONS(7927),
    [anon_sym_PERCENT] = ACTIONS(7927),
    [sym_comment] = ACTIONS(87),
  },
  [7425] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(906),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(911),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(911),
    [sym__argument] = STATE(6088),
    [sym_splat_argument] = STATE(6088),
    [sym_hash_splat_argument] = STATE(6088),
    [sym_block_argument] = STATE(6088),
    [sym_assignment] = STATE(906),
    [sym_operator_assignment] = STATE(906),
    [sym_conditional] = STATE(906),
    [sym_range] = STATE(906),
    [sym_binary] = STATE(906),
    [sym_unary] = STATE(906),
    [sym_left_assignment_list] = STATE(910),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(911),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(911),
    [sym_false] = STATE(911),
    [sym_nil] = STATE(911),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(912),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(6088),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1589),
    [sym__splat_star] = ACTIONS(1591),
    [sym__unary_minus] = ACTIONS(1593),
    [sym__identifier_hash_key] = ACTIONS(1595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(11989),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1599),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_defined_QMARK] = ACTIONS(1611),
    [anon_sym_not] = ACTIONS(1613),
    [anon_sym_BANG] = ACTIONS(1615),
    [anon_sym_TILDE] = ACTIONS(1615),
    [sym_constant] = ACTIONS(1617),
    [sym_identifier] = ACTIONS(1617),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7426] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(906),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(911),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(911),
    [sym__argument] = STATE(3454),
    [sym_splat_argument] = STATE(3454),
    [sym_hash_splat_argument] = STATE(3454),
    [sym_block_argument] = STATE(3454),
    [sym_assignment] = STATE(906),
    [sym_operator_assignment] = STATE(906),
    [sym_conditional] = STATE(906),
    [sym_range] = STATE(906),
    [sym_binary] = STATE(906),
    [sym_unary] = STATE(906),
    [sym_left_assignment_list] = STATE(910),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(911),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(911),
    [sym_false] = STATE(911),
    [sym_nil] = STATE(911),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(912),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_heredoc_body] = STATE(9266),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(3454),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1589),
    [sym__splat_star] = ACTIONS(1591),
    [sym__unary_minus] = ACTIONS(1593),
    [sym__identifier_hash_key] = ACTIONS(1595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1599),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_defined_QMARK] = ACTIONS(1611),
    [anon_sym_not] = ACTIONS(1613),
    [anon_sym_BANG] = ACTIONS(1615),
    [anon_sym_TILDE] = ACTIONS(1615),
    [sym_constant] = ACTIONS(1617),
    [sym_identifier] = ACTIONS(1617),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7427] = {
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(4299),
    [sym__binary_star] = ACTIONS(4301),
    [anon_sym_RPAREN] = ACTIONS(4247),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(4303),
    [anon_sym_STAR_STAR] = ACTIONS(4301),
    [anon_sym_AMP] = ACTIONS(4305),
    [anon_sym_LT] = ACTIONS(4307),
    [anon_sym_EQ_GT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(4309),
    [anon_sym_DOT_DOT] = ACTIONS(4311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4313),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(4317),
    [anon_sym_AMP_AMP] = ACTIONS(4317),
    [anon_sym_LT_LT] = ACTIONS(4319),
    [anon_sym_GT_GT] = ACTIONS(4319),
    [anon_sym_EQ_EQ] = ACTIONS(4321),
    [anon_sym_BANG_EQ] = ACTIONS(4317),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4317),
    [anon_sym_LT_EQ_GT] = ACTIONS(4317),
    [anon_sym_EQ_TILDE] = ACTIONS(4317),
    [anon_sym_BANG_TILDE] = ACTIONS(4317),
    [anon_sym_LT_EQ] = ACTIONS(4307),
    [anon_sym_GT] = ACTIONS(4307),
    [anon_sym_GT_EQ] = ACTIONS(4323),
    [anon_sym_CARET] = ACTIONS(4325),
    [anon_sym_PLUS] = ACTIONS(4299),
    [anon_sym_SLASH] = ACTIONS(4301),
    [anon_sym_PERCENT] = ACTIONS(4301),
    [sym_comment] = ACTIONS(87),
  },
  [7428] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4958),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(911),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(911),
    [sym_splat_argument] = STATE(8429),
    [sym_assignment] = STATE(4958),
    [sym_operator_assignment] = STATE(4958),
    [sym_conditional] = STATE(4958),
    [sym_range] = STATE(4958),
    [sym_binary] = STATE(4958),
    [sym_unary] = STATE(4958),
    [sym__arg_or_splat_arg] = STATE(8429),
    [sym_left_assignment_list] = STATE(910),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(911),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(911),
    [sym_false] = STATE(911),
    [sym_nil] = STATE(911),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2484),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(7882),
    [sym__unary_minus] = ACTIONS(1593),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_defined_QMARK] = ACTIONS(1611),
    [anon_sym_not] = ACTIONS(1613),
    [anon_sym_BANG] = ACTIONS(1615),
    [anon_sym_TILDE] = ACTIONS(1615),
    [sym_constant] = ACTIONS(1621),
    [sym_identifier] = ACTIONS(1621),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7429] = {
    [aux_sym_exceptions_repeat1] = STATE(9267),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_RPAREN] = ACTIONS(9855),
    [anon_sym_COMMA] = ACTIONS(12877),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_EQ_GT] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [7430] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(1627),
    [sym__binary_star] = ACTIONS(1629),
    [ts_builtin_sym_end] = ACTIONS(12120),
    [anon_sym___END__] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(1633),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(1629),
    [anon_sym_AMP] = ACTIONS(1635),
    [anon_sym_LT] = ACTIONS(1637),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_EQ_GT] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(1639),
    [anon_sym_DOT_DOT] = ACTIONS(1641),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1643),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(1645),
    [anon_sym_AMP_AMP] = ACTIONS(1645),
    [anon_sym_LT_LT] = ACTIONS(1647),
    [anon_sym_GT_GT] = ACTIONS(1647),
    [anon_sym_EQ_EQ] = ACTIONS(1649),
    [anon_sym_BANG_EQ] = ACTIONS(1645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1645),
    [anon_sym_LT_EQ_GT] = ACTIONS(1645),
    [anon_sym_EQ_TILDE] = ACTIONS(1645),
    [anon_sym_BANG_TILDE] = ACTIONS(1645),
    [anon_sym_LT_EQ] = ACTIONS(1637),
    [anon_sym_GT] = ACTIONS(1637),
    [anon_sym_GT_EQ] = ACTIONS(1651),
    [anon_sym_CARET] = ACTIONS(1653),
    [anon_sym_PLUS] = ACTIONS(1627),
    [anon_sym_SLASH] = ACTIONS(1629),
    [anon_sym_PERCENT] = ACTIONS(1629),
    [sym_comment] = ACTIONS(87),
  },
  [7431] = {
    [sym__line_break] = ACTIONS(7876),
    [sym__simple_symbol] = ACTIONS(7876),
    [sym__string_start] = ACTIONS(7876),
    [sym__symbol_start] = ACTIONS(7876),
    [sym__subshell_start] = ACTIONS(7876),
    [sym__regex_start] = ACTIONS(7876),
    [sym__string_array_start] = ACTIONS(7876),
    [sym__symbol_array_start] = ACTIONS(7876),
    [sym__heredoc_body_start] = ACTIONS(7876),
    [sym_heredoc_beginning] = ACTIONS(7876),
    [sym__block_ampersand] = ACTIONS(7876),
    [sym__splat_star] = ACTIONS(7876),
    [sym__unary_minus] = ACTIONS(7876),
    [sym__binary_minus] = ACTIONS(7876),
    [sym__binary_star] = ACTIONS(7876),
    [sym__identifier_hash_key] = ACTIONS(7876),
    [ts_builtin_sym_end] = ACTIONS(7876),
    [anon_sym___END__] = ACTIONS(7878),
    [anon_sym_LBRACE] = ACTIONS(7876),
    [anon_sym_RBRACE] = ACTIONS(7876),
    [anon_sym_def] = ACTIONS(7878),
    [anon_sym_LPAREN] = ACTIONS(7878),
    [anon_sym_RPAREN] = ACTIONS(7876),
    [anon_sym_DOT] = ACTIONS(7878),
    [anon_sym_COLON_COLON] = ACTIONS(7878),
    [anon_sym_COMMA] = ACTIONS(7876),
    [anon_sym_PIPE] = ACTIONS(7878),
    [anon_sym_SEMI] = ACTIONS(7876),
    [anon_sym_STAR] = ACTIONS(7878),
    [anon_sym_STAR_STAR] = ACTIONS(7878),
    [anon_sym_AMP] = ACTIONS(7878),
    [anon_sym_EQ] = ACTIONS(7878),
    [anon_sym_class] = ACTIONS(7878),
    [anon_sym_LT] = ACTIONS(7878),
    [anon_sym_module] = ACTIONS(7878),
    [anon_sym_end] = ACTIONS(7878),
    [anon_sym_return] = ACTIONS(7878),
    [anon_sym_yield] = ACTIONS(7878),
    [anon_sym_break] = ACTIONS(7878),
    [anon_sym_next] = ACTIONS(7878),
    [sym_redo] = ACTIONS(7878),
    [sym_retry] = ACTIONS(7878),
    [anon_sym_if] = ACTIONS(7878),
    [anon_sym_unless] = ACTIONS(7878),
    [anon_sym_while] = ACTIONS(7878),
    [anon_sym_until] = ACTIONS(7878),
    [anon_sym_rescue] = ACTIONS(7878),
    [anon_sym_for] = ACTIONS(7878),
    [anon_sym_do] = ACTIONS(7878),
    [anon_sym_case] = ACTIONS(7878),
    [anon_sym_when] = ACTIONS(7878),
    [anon_sym_elsif] = ACTIONS(7878),
    [anon_sym_else] = ACTIONS(7878),
    [anon_sym_then] = ACTIONS(7878),
    [anon_sym_begin] = ACTIONS(7878),
    [anon_sym_ensure] = ACTIONS(7878),
    [anon_sym_EQ_GT] = ACTIONS(7876),
    [anon_sym_LBRACK] = ACTIONS(7876),
    [anon_sym_COLON_COLON2] = ACTIONS(7876),
    [anon_sym_AMP_DOT] = ACTIONS(7876),
    [anon_sym_LPAREN2] = ACTIONS(7876),
    [anon_sym_PLUS_EQ] = ACTIONS(7876),
    [anon_sym_DASH_EQ] = ACTIONS(7876),
    [anon_sym_STAR_EQ] = ACTIONS(7876),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7876),
    [anon_sym_SLASH_EQ] = ACTIONS(7876),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7876),
    [anon_sym_PIPE_EQ] = ACTIONS(7876),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7876),
    [anon_sym_AMP_EQ] = ACTIONS(7876),
    [anon_sym_PERCENT_EQ] = ACTIONS(7876),
    [anon_sym_GT_GT_EQ] = ACTIONS(7876),
    [anon_sym_LT_LT_EQ] = ACTIONS(7876),
    [anon_sym_CARET_EQ] = ACTIONS(7876),
    [anon_sym_QMARK] = ACTIONS(7878),
    [anon_sym_DOT_DOT] = ACTIONS(7878),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7876),
    [anon_sym_and] = ACTIONS(7878),
    [anon_sym_or] = ACTIONS(7878),
    [anon_sym_PIPE_PIPE] = ACTIONS(7878),
    [anon_sym_AMP_AMP] = ACTIONS(7878),
    [anon_sym_LT_LT] = ACTIONS(7878),
    [anon_sym_GT_GT] = ACTIONS(7878),
    [anon_sym_EQ_EQ] = ACTIONS(7878),
    [anon_sym_BANG_EQ] = ACTIONS(7876),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7876),
    [anon_sym_LT_EQ_GT] = ACTIONS(7876),
    [anon_sym_EQ_TILDE] = ACTIONS(7876),
    [anon_sym_BANG_TILDE] = ACTIONS(7876),
    [anon_sym_LT_EQ] = ACTIONS(7878),
    [anon_sym_GT] = ACTIONS(7878),
    [anon_sym_GT_EQ] = ACTIONS(7876),
    [anon_sym_CARET] = ACTIONS(7878),
    [anon_sym_PLUS] = ACTIONS(7878),
    [anon_sym_SLASH] = ACTIONS(7878),
    [anon_sym_PERCENT] = ACTIONS(7878),
    [anon_sym_defined_QMARK] = ACTIONS(7876),
    [anon_sym_not] = ACTIONS(7878),
    [anon_sym_BANG] = ACTIONS(7878),
    [anon_sym_TILDE] = ACTIONS(7876),
    [sym_constant] = ACTIONS(7878),
    [sym_identifier] = ACTIONS(7878),
    [sym_instance_variable] = ACTIONS(7876),
    [sym_class_variable] = ACTIONS(7876),
    [sym_global_variable] = ACTIONS(7876),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(7878),
    [sym_float] = ACTIONS(7878),
    [sym_complex] = ACTIONS(7876),
    [sym_super] = ACTIONS(7878),
    [anon_sym_true] = ACTIONS(7878),
    [anon_sym_TRUE] = ACTIONS(7878),
    [anon_sym_false] = ACTIONS(7878),
    [anon_sym_FALSE] = ACTIONS(7878),
    [sym_self] = ACTIONS(7878),
    [anon_sym_nil] = ACTIONS(7878),
    [anon_sym_NIL] = ACTIONS(7878),
    [sym_character] = ACTIONS(7876),
    [anon_sym_LBRACK2] = ACTIONS(7878),
    [anon_sym_DASH_GT] = ACTIONS(7876),
  },
  [7432] = {
    [sym__line_break] = ACTIONS(12029),
    [sym__heredoc_body_start] = ACTIONS(12029),
    [sym__binary_minus] = ACTIONS(12029),
    [sym__binary_star] = ACTIONS(12029),
    [ts_builtin_sym_end] = ACTIONS(12029),
    [anon_sym___END__] = ACTIONS(12029),
    [anon_sym_LBRACE] = ACTIONS(12029),
    [anon_sym_RBRACE] = ACTIONS(12029),
    [anon_sym_RPAREN] = ACTIONS(12029),
    [anon_sym_DOT] = ACTIONS(12031),
    [anon_sym_COMMA] = ACTIONS(12029),
    [anon_sym_PIPE] = ACTIONS(12031),
    [anon_sym_SEMI] = ACTIONS(12029),
    [anon_sym_STAR_STAR] = ACTIONS(12031),
    [anon_sym_AMP] = ACTIONS(12031),
    [anon_sym_EQ] = ACTIONS(12031),
    [anon_sym_LT] = ACTIONS(12031),
    [anon_sym_end] = ACTIONS(12029),
    [anon_sym_if] = ACTIONS(12029),
    [anon_sym_unless] = ACTIONS(12029),
    [anon_sym_while] = ACTIONS(12029),
    [anon_sym_until] = ACTIONS(12029),
    [anon_sym_rescue] = ACTIONS(12029),
    [anon_sym_do] = ACTIONS(12029),
    [anon_sym_when] = ACTIONS(12029),
    [anon_sym_elsif] = ACTIONS(12029),
    [anon_sym_else] = ACTIONS(12029),
    [anon_sym_then] = ACTIONS(12029),
    [anon_sym_ensure] = ACTIONS(12029),
    [anon_sym_EQ_GT] = ACTIONS(12029),
    [anon_sym_LBRACK] = ACTIONS(12029),
    [anon_sym_COLON_COLON2] = ACTIONS(12029),
    [anon_sym_AMP_DOT] = ACTIONS(12029),
    [anon_sym_PLUS_EQ] = ACTIONS(12029),
    [anon_sym_DASH_EQ] = ACTIONS(12029),
    [anon_sym_STAR_EQ] = ACTIONS(12029),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12029),
    [anon_sym_SLASH_EQ] = ACTIONS(12029),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12029),
    [anon_sym_PIPE_EQ] = ACTIONS(12029),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12029),
    [anon_sym_AMP_EQ] = ACTIONS(12029),
    [anon_sym_PERCENT_EQ] = ACTIONS(12029),
    [anon_sym_GT_GT_EQ] = ACTIONS(12029),
    [anon_sym_LT_LT_EQ] = ACTIONS(12029),
    [anon_sym_CARET_EQ] = ACTIONS(12029),
    [anon_sym_QMARK] = ACTIONS(12029),
    [anon_sym_DOT_DOT] = ACTIONS(12031),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12029),
    [anon_sym_and] = ACTIONS(12029),
    [anon_sym_or] = ACTIONS(12029),
    [anon_sym_PIPE_PIPE] = ACTIONS(12031),
    [anon_sym_AMP_AMP] = ACTIONS(12031),
    [anon_sym_LT_LT] = ACTIONS(12031),
    [anon_sym_GT_GT] = ACTIONS(12031),
    [anon_sym_EQ_EQ] = ACTIONS(12031),
    [anon_sym_BANG_EQ] = ACTIONS(12029),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12029),
    [anon_sym_LT_EQ_GT] = ACTIONS(12029),
    [anon_sym_EQ_TILDE] = ACTIONS(12029),
    [anon_sym_BANG_TILDE] = ACTIONS(12029),
    [anon_sym_LT_EQ] = ACTIONS(12031),
    [anon_sym_GT] = ACTIONS(12031),
    [anon_sym_GT_EQ] = ACTIONS(12029),
    [anon_sym_CARET] = ACTIONS(12031),
    [anon_sym_PLUS] = ACTIONS(12031),
    [anon_sym_SLASH] = ACTIONS(12031),
    [anon_sym_PERCENT] = ACTIONS(12031),
    [sym_comment] = ACTIONS(87),
  },
  [7433] = {
    [sym__line_break] = ACTIONS(12054),
    [sym__heredoc_body_start] = ACTIONS(12054),
    [sym__binary_minus] = ACTIONS(12054),
    [sym__binary_star] = ACTIONS(12054),
    [ts_builtin_sym_end] = ACTIONS(12054),
    [anon_sym___END__] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_RBRACE] = ACTIONS(12054),
    [anon_sym_RPAREN] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12056),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_PIPE] = ACTIONS(12056),
    [anon_sym_SEMI] = ACTIONS(12054),
    [anon_sym_STAR_STAR] = ACTIONS(12056),
    [anon_sym_AMP] = ACTIONS(12056),
    [anon_sym_EQ] = ACTIONS(12056),
    [anon_sym_LT] = ACTIONS(12056),
    [anon_sym_end] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_unless] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [anon_sym_until] = ACTIONS(12054),
    [anon_sym_rescue] = ACTIONS(12054),
    [anon_sym_do] = ACTIONS(12054),
    [anon_sym_when] = ACTIONS(12054),
    [anon_sym_elsif] = ACTIONS(12054),
    [anon_sym_else] = ACTIONS(12054),
    [anon_sym_then] = ACTIONS(12054),
    [anon_sym_ensure] = ACTIONS(12054),
    [anon_sym_EQ_GT] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_COLON_COLON2] = ACTIONS(12054),
    [anon_sym_AMP_DOT] = ACTIONS(12054),
    [anon_sym_PLUS_EQ] = ACTIONS(12054),
    [anon_sym_DASH_EQ] = ACTIONS(12054),
    [anon_sym_STAR_EQ] = ACTIONS(12054),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12054),
    [anon_sym_SLASH_EQ] = ACTIONS(12054),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12054),
    [anon_sym_PIPE_EQ] = ACTIONS(12054),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12054),
    [anon_sym_AMP_EQ] = ACTIONS(12054),
    [anon_sym_PERCENT_EQ] = ACTIONS(12054),
    [anon_sym_GT_GT_EQ] = ACTIONS(12054),
    [anon_sym_LT_LT_EQ] = ACTIONS(12054),
    [anon_sym_CARET_EQ] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_DOT_DOT] = ACTIONS(12056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_and] = ACTIONS(12054),
    [anon_sym_or] = ACTIONS(12054),
    [anon_sym_PIPE_PIPE] = ACTIONS(12056),
    [anon_sym_AMP_AMP] = ACTIONS(12056),
    [anon_sym_LT_LT] = ACTIONS(12056),
    [anon_sym_GT_GT] = ACTIONS(12056),
    [anon_sym_EQ_EQ] = ACTIONS(12056),
    [anon_sym_BANG_EQ] = ACTIONS(12054),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12054),
    [anon_sym_LT_EQ_GT] = ACTIONS(12054),
    [anon_sym_EQ_TILDE] = ACTIONS(12054),
    [anon_sym_BANG_TILDE] = ACTIONS(12054),
    [anon_sym_LT_EQ] = ACTIONS(12056),
    [anon_sym_GT] = ACTIONS(12056),
    [anon_sym_GT_EQ] = ACTIONS(12054),
    [anon_sym_CARET] = ACTIONS(12056),
    [anon_sym_PLUS] = ACTIONS(12056),
    [anon_sym_SLASH] = ACTIONS(12056),
    [anon_sym_PERCENT] = ACTIONS(12056),
    [sym_comment] = ACTIONS(87),
  },
  [7434] = {
    [anon_sym_end] = ACTIONS(12881),
    [sym_comment] = ACTIONS(87),
  },
  [7435] = {
    [sym__statements] = STATE(9269),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12883),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7436] = {
    [sym__line_break] = ACTIONS(6813),
    [sym__heredoc_body_start] = ACTIONS(6813),
    [sym__binary_minus] = ACTIONS(6813),
    [sym__binary_star] = ACTIONS(6813),
    [ts_builtin_sym_end] = ACTIONS(6813),
    [anon_sym___END__] = ACTIONS(6813),
    [anon_sym_LBRACE] = ACTIONS(6813),
    [anon_sym_RBRACE] = ACTIONS(6813),
    [anon_sym_RPAREN] = ACTIONS(6813),
    [anon_sym_DOT] = ACTIONS(8689),
    [anon_sym_COMMA] = ACTIONS(6813),
    [anon_sym_PIPE] = ACTIONS(8689),
    [anon_sym_SEMI] = ACTIONS(6813),
    [anon_sym_STAR_STAR] = ACTIONS(8689),
    [anon_sym_AMP] = ACTIONS(8689),
    [anon_sym_EQ] = ACTIONS(8689),
    [anon_sym_LT] = ACTIONS(8689),
    [anon_sym_end] = ACTIONS(6813),
    [anon_sym_if] = ACTIONS(6813),
    [anon_sym_unless] = ACTIONS(6813),
    [anon_sym_while] = ACTIONS(6813),
    [anon_sym_until] = ACTIONS(6813),
    [anon_sym_rescue] = ACTIONS(6813),
    [anon_sym_do] = ACTIONS(6813),
    [anon_sym_when] = ACTIONS(6813),
    [anon_sym_elsif] = ACTIONS(6813),
    [anon_sym_else] = ACTIONS(6813),
    [anon_sym_then] = ACTIONS(6813),
    [anon_sym_ensure] = ACTIONS(6813),
    [anon_sym_EQ_GT] = ACTIONS(6813),
    [anon_sym_LBRACK] = ACTIONS(6813),
    [anon_sym_COLON_COLON2] = ACTIONS(6813),
    [anon_sym_AMP_DOT] = ACTIONS(6813),
    [anon_sym_PLUS_EQ] = ACTIONS(6813),
    [anon_sym_DASH_EQ] = ACTIONS(6813),
    [anon_sym_STAR_EQ] = ACTIONS(6813),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6813),
    [anon_sym_SLASH_EQ] = ACTIONS(6813),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6813),
    [anon_sym_PIPE_EQ] = ACTIONS(6813),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6813),
    [anon_sym_AMP_EQ] = ACTIONS(6813),
    [anon_sym_PERCENT_EQ] = ACTIONS(6813),
    [anon_sym_GT_GT_EQ] = ACTIONS(6813),
    [anon_sym_LT_LT_EQ] = ACTIONS(6813),
    [anon_sym_CARET_EQ] = ACTIONS(6813),
    [anon_sym_QMARK] = ACTIONS(6813),
    [anon_sym_DOT_DOT] = ACTIONS(8689),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6813),
    [anon_sym_and] = ACTIONS(6813),
    [anon_sym_or] = ACTIONS(6813),
    [anon_sym_PIPE_PIPE] = ACTIONS(8689),
    [anon_sym_AMP_AMP] = ACTIONS(8689),
    [anon_sym_LT_LT] = ACTIONS(8689),
    [anon_sym_GT_GT] = ACTIONS(8689),
    [anon_sym_EQ_EQ] = ACTIONS(8689),
    [anon_sym_BANG_EQ] = ACTIONS(6813),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6813),
    [anon_sym_LT_EQ_GT] = ACTIONS(6813),
    [anon_sym_EQ_TILDE] = ACTIONS(6813),
    [anon_sym_BANG_TILDE] = ACTIONS(6813),
    [anon_sym_LT_EQ] = ACTIONS(8689),
    [anon_sym_GT] = ACTIONS(8689),
    [anon_sym_GT_EQ] = ACTIONS(6813),
    [anon_sym_CARET] = ACTIONS(8689),
    [anon_sym_PLUS] = ACTIONS(8689),
    [anon_sym_SLASH] = ACTIONS(8689),
    [anon_sym_PERCENT] = ACTIONS(8689),
    [sym_comment] = ACTIONS(87),
  },
  [7437] = {
    [sym__line_break] = ACTIONS(10986),
    [sym__heredoc_body_start] = ACTIONS(10986),
    [sym__binary_minus] = ACTIONS(10986),
    [sym__binary_star] = ACTIONS(10986),
    [ts_builtin_sym_end] = ACTIONS(10986),
    [anon_sym___END__] = ACTIONS(10986),
    [anon_sym_LBRACE] = ACTIONS(10986),
    [anon_sym_RBRACE] = ACTIONS(10986),
    [anon_sym_RPAREN] = ACTIONS(10986),
    [anon_sym_DOT] = ACTIONS(10988),
    [anon_sym_COMMA] = ACTIONS(10986),
    [anon_sym_PIPE] = ACTIONS(10988),
    [anon_sym_SEMI] = ACTIONS(10986),
    [anon_sym_STAR_STAR] = ACTIONS(10988),
    [anon_sym_AMP] = ACTIONS(10988),
    [anon_sym_EQ] = ACTIONS(10988),
    [anon_sym_LT] = ACTIONS(10988),
    [anon_sym_end] = ACTIONS(10986),
    [anon_sym_if] = ACTIONS(10986),
    [anon_sym_unless] = ACTIONS(10986),
    [anon_sym_while] = ACTIONS(10986),
    [anon_sym_until] = ACTIONS(10986),
    [anon_sym_rescue] = ACTIONS(10986),
    [anon_sym_do] = ACTIONS(10986),
    [anon_sym_when] = ACTIONS(10986),
    [anon_sym_elsif] = ACTIONS(10986),
    [anon_sym_else] = ACTIONS(10986),
    [anon_sym_then] = ACTIONS(10986),
    [anon_sym_ensure] = ACTIONS(10986),
    [anon_sym_EQ_GT] = ACTIONS(10986),
    [anon_sym_LBRACK] = ACTIONS(10986),
    [anon_sym_COLON_COLON2] = ACTIONS(10986),
    [anon_sym_AMP_DOT] = ACTIONS(10986),
    [anon_sym_PLUS_EQ] = ACTIONS(10986),
    [anon_sym_DASH_EQ] = ACTIONS(10986),
    [anon_sym_STAR_EQ] = ACTIONS(10986),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10986),
    [anon_sym_SLASH_EQ] = ACTIONS(10986),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10986),
    [anon_sym_PIPE_EQ] = ACTIONS(10986),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10986),
    [anon_sym_AMP_EQ] = ACTIONS(10986),
    [anon_sym_PERCENT_EQ] = ACTIONS(10986),
    [anon_sym_GT_GT_EQ] = ACTIONS(10986),
    [anon_sym_LT_LT_EQ] = ACTIONS(10986),
    [anon_sym_CARET_EQ] = ACTIONS(10986),
    [anon_sym_QMARK] = ACTIONS(10986),
    [anon_sym_DOT_DOT] = ACTIONS(10988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10986),
    [anon_sym_and] = ACTIONS(10986),
    [anon_sym_or] = ACTIONS(10986),
    [anon_sym_PIPE_PIPE] = ACTIONS(10988),
    [anon_sym_AMP_AMP] = ACTIONS(10988),
    [anon_sym_LT_LT] = ACTIONS(10988),
    [anon_sym_GT_GT] = ACTIONS(10988),
    [anon_sym_EQ_EQ] = ACTIONS(10988),
    [anon_sym_BANG_EQ] = ACTIONS(10986),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10986),
    [anon_sym_LT_EQ_GT] = ACTIONS(10986),
    [anon_sym_EQ_TILDE] = ACTIONS(10986),
    [anon_sym_BANG_TILDE] = ACTIONS(10986),
    [anon_sym_LT_EQ] = ACTIONS(10988),
    [anon_sym_GT] = ACTIONS(10988),
    [anon_sym_GT_EQ] = ACTIONS(10986),
    [anon_sym_CARET] = ACTIONS(10988),
    [anon_sym_PLUS] = ACTIONS(10988),
    [anon_sym_SLASH] = ACTIONS(10988),
    [anon_sym_PERCENT] = ACTIONS(10988),
    [sym_comment] = ACTIONS(87),
  },
  [7438] = {
    [sym__simple_symbol] = ACTIONS(6813),
    [sym__string_start] = ACTIONS(6813),
    [sym__symbol_start] = ACTIONS(6813),
    [sym__subshell_start] = ACTIONS(6813),
    [sym__regex_start] = ACTIONS(6813),
    [sym__string_array_start] = ACTIONS(6813),
    [sym__symbol_array_start] = ACTIONS(6813),
    [sym_heredoc_beginning] = ACTIONS(6813),
    [sym__block_ampersand] = ACTIONS(6813),
    [sym__splat_star] = ACTIONS(6813),
    [sym__unary_minus] = ACTIONS(6813),
    [sym__identifier_hash_key] = ACTIONS(6813),
    [anon_sym_LBRACE] = ACTIONS(6813),
    [anon_sym_def] = ACTIONS(8689),
    [anon_sym_LPAREN] = ACTIONS(6813),
    [anon_sym_RPAREN] = ACTIONS(6813),
    [anon_sym_COLON_COLON] = ACTIONS(6813),
    [anon_sym_STAR] = ACTIONS(8689),
    [anon_sym_STAR_STAR] = ACTIONS(6813),
    [anon_sym_class] = ACTIONS(8689),
    [anon_sym_module] = ACTIONS(8689),
    [anon_sym_return] = ACTIONS(8689),
    [anon_sym_yield] = ACTIONS(8689),
    [anon_sym_break] = ACTIONS(8689),
    [anon_sym_next] = ACTIONS(8689),
    [sym_redo] = ACTIONS(8689),
    [sym_retry] = ACTIONS(8689),
    [anon_sym_if] = ACTIONS(8689),
    [anon_sym_unless] = ACTIONS(8689),
    [anon_sym_while] = ACTIONS(8689),
    [anon_sym_until] = ACTIONS(8689),
    [anon_sym_for] = ACTIONS(8689),
    [anon_sym_case] = ACTIONS(8689),
    [anon_sym_begin] = ACTIONS(8689),
    [anon_sym_RBRACK] = ACTIONS(6813),
    [anon_sym_PLUS] = ACTIONS(8689),
    [anon_sym_defined_QMARK] = ACTIONS(6813),
    [anon_sym_not] = ACTIONS(8689),
    [anon_sym_BANG] = ACTIONS(6813),
    [anon_sym_TILDE] = ACTIONS(6813),
    [sym_constant] = ACTIONS(8689),
    [sym_identifier] = ACTIONS(8689),
    [sym_instance_variable] = ACTIONS(6813),
    [sym_class_variable] = ACTIONS(6813),
    [sym_global_variable] = ACTIONS(6813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(8689),
    [sym_float] = ACTIONS(8689),
    [sym_complex] = ACTIONS(6813),
    [sym_super] = ACTIONS(8689),
    [anon_sym_true] = ACTIONS(8689),
    [anon_sym_TRUE] = ACTIONS(8689),
    [anon_sym_false] = ACTIONS(8689),
    [anon_sym_FALSE] = ACTIONS(8689),
    [sym_self] = ACTIONS(8689),
    [anon_sym_nil] = ACTIONS(8689),
    [anon_sym_NIL] = ACTIONS(8689),
    [sym_character] = ACTIONS(6813),
    [anon_sym_LBRACK2] = ACTIONS(6813),
    [anon_sym_DASH_GT] = ACTIONS(6813),
  },
  [7439] = {
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [ts_builtin_sym_end] = ACTIONS(11597),
    [anon_sym___END__] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_RBRACE] = ACTIONS(11597),
    [anon_sym_RPAREN] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(11597),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_end] = ACTIONS(11597),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_when] = ACTIONS(11597),
    [anon_sym_elsif] = ACTIONS(11597),
    [anon_sym_else] = ACTIONS(11597),
    [anon_sym_then] = ACTIONS(11597),
    [anon_sym_ensure] = ACTIONS(11597),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [7440] = {
    [aux_sym_exceptions_repeat1] = STATE(7440),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [ts_builtin_sym_end] = ACTIONS(11597),
    [anon_sym___END__] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(12885),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [7441] = {
    [sym_heredoc_body] = STATE(9270),
    [aux_sym_call_repeat1] = STATE(9270),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_then] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [7442] = {
    [sym_heredoc_body] = STATE(9271),
    [aux_sym_call_repeat1] = STATE(9271),
    [aux_sym_argument_list_repeat1] = STATE(5037),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4457),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_then] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [7443] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(7942),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(7942),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(7942),
    [anon_sym_PERCENT] = ACTIONS(7942),
    [sym_comment] = ACTIONS(87),
  },
  [7444] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(7942),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [7445] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7940),
    [sym__binary_star] = ACTIONS(7942),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(7942),
    [anon_sym_AMP] = ACTIONS(7946),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(7958),
    [anon_sym_GT_GT] = ACTIONS(7958),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(7940),
    [anon_sym_SLASH] = ACTIONS(7942),
    [anon_sym_PERCENT] = ACTIONS(7942),
    [sym_comment] = ACTIONS(87),
  },
  [7446] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7940),
    [sym__binary_star] = ACTIONS(7942),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(7942),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(7958),
    [anon_sym_GT_GT] = ACTIONS(7958),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(7940),
    [anon_sym_SLASH] = ACTIONS(7942),
    [anon_sym_PERCENT] = ACTIONS(7942),
    [sym_comment] = ACTIONS(87),
  },
  [7447] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7940),
    [sym__binary_star] = ACTIONS(7942),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(7944),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(7942),
    [anon_sym_AMP] = ACTIONS(7946),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(7958),
    [anon_sym_GT_GT] = ACTIONS(7958),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(7964),
    [anon_sym_PLUS] = ACTIONS(7940),
    [anon_sym_SLASH] = ACTIONS(7942),
    [anon_sym_PERCENT] = ACTIONS(7942),
    [sym_comment] = ACTIONS(87),
  },
  [7448] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(12888),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [7449] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(7940),
    [sym__binary_star] = ACTIONS(7942),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(7944),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(7942),
    [anon_sym_AMP] = ACTIONS(7946),
    [anon_sym_LT] = ACTIONS(7948),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_then] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(7952),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7954),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(7956),
    [anon_sym_AMP_AMP] = ACTIONS(7956),
    [anon_sym_LT_LT] = ACTIONS(7958),
    [anon_sym_GT_GT] = ACTIONS(7958),
    [anon_sym_EQ_EQ] = ACTIONS(7960),
    [anon_sym_BANG_EQ] = ACTIONS(7956),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7956),
    [anon_sym_LT_EQ_GT] = ACTIONS(7956),
    [anon_sym_EQ_TILDE] = ACTIONS(7956),
    [anon_sym_BANG_TILDE] = ACTIONS(7956),
    [anon_sym_LT_EQ] = ACTIONS(7948),
    [anon_sym_GT] = ACTIONS(7948),
    [anon_sym_GT_EQ] = ACTIONS(7962),
    [anon_sym_CARET] = ACTIONS(7964),
    [anon_sym_PLUS] = ACTIONS(7940),
    [anon_sym_SLASH] = ACTIONS(7942),
    [anon_sym_PERCENT] = ACTIONS(7942),
    [sym_comment] = ACTIONS(87),
  },
  [7450] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7940),
    [sym__binary_star] = ACTIONS(7942),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(7944),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(7942),
    [anon_sym_AMP] = ACTIONS(7946),
    [anon_sym_LT] = ACTIONS(7948),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(7950),
    [anon_sym_DOT_DOT] = ACTIONS(7952),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7954),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(7956),
    [anon_sym_AMP_AMP] = ACTIONS(7956),
    [anon_sym_LT_LT] = ACTIONS(7958),
    [anon_sym_GT_GT] = ACTIONS(7958),
    [anon_sym_EQ_EQ] = ACTIONS(7960),
    [anon_sym_BANG_EQ] = ACTIONS(7956),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7956),
    [anon_sym_LT_EQ_GT] = ACTIONS(7956),
    [anon_sym_EQ_TILDE] = ACTIONS(7956),
    [anon_sym_BANG_TILDE] = ACTIONS(7956),
    [anon_sym_LT_EQ] = ACTIONS(7948),
    [anon_sym_GT] = ACTIONS(7948),
    [anon_sym_GT_EQ] = ACTIONS(7962),
    [anon_sym_CARET] = ACTIONS(7964),
    [anon_sym_PLUS] = ACTIONS(7940),
    [anon_sym_SLASH] = ACTIONS(7942),
    [anon_sym_PERCENT] = ACTIONS(7942),
    [sym_comment] = ACTIONS(87),
  },
  [7451] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7940),
    [sym__binary_star] = ACTIONS(7942),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(7944),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(7942),
    [anon_sym_AMP] = ACTIONS(7946),
    [anon_sym_LT] = ACTIONS(7948),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(7958),
    [anon_sym_GT_GT] = ACTIONS(7958),
    [anon_sym_EQ_EQ] = ACTIONS(7960),
    [anon_sym_BANG_EQ] = ACTIONS(7956),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7956),
    [anon_sym_LT_EQ_GT] = ACTIONS(7956),
    [anon_sym_EQ_TILDE] = ACTIONS(7956),
    [anon_sym_BANG_TILDE] = ACTIONS(7956),
    [anon_sym_LT_EQ] = ACTIONS(7948),
    [anon_sym_GT] = ACTIONS(7948),
    [anon_sym_GT_EQ] = ACTIONS(7962),
    [anon_sym_CARET] = ACTIONS(7964),
    [anon_sym_PLUS] = ACTIONS(7940),
    [anon_sym_SLASH] = ACTIONS(7942),
    [anon_sym_PERCENT] = ACTIONS(7942),
    [sym_comment] = ACTIONS(87),
  },
  [7452] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(7940),
    [sym__binary_star] = ACTIONS(7942),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(7942),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(7940),
    [anon_sym_SLASH] = ACTIONS(7942),
    [anon_sym_PERCENT] = ACTIONS(7942),
    [sym_comment] = ACTIONS(87),
  },
  [7453] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(7940),
    [sym__binary_star] = ACTIONS(7942),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(7944),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(7942),
    [anon_sym_AMP] = ACTIONS(7946),
    [anon_sym_LT] = ACTIONS(7948),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_then] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(7950),
    [anon_sym_DOT_DOT] = ACTIONS(7952),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7954),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7956),
    [anon_sym_AMP_AMP] = ACTIONS(7956),
    [anon_sym_LT_LT] = ACTIONS(7958),
    [anon_sym_GT_GT] = ACTIONS(7958),
    [anon_sym_EQ_EQ] = ACTIONS(7960),
    [anon_sym_BANG_EQ] = ACTIONS(7956),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7956),
    [anon_sym_LT_EQ_GT] = ACTIONS(7956),
    [anon_sym_EQ_TILDE] = ACTIONS(7956),
    [anon_sym_BANG_TILDE] = ACTIONS(7956),
    [anon_sym_LT_EQ] = ACTIONS(7948),
    [anon_sym_GT] = ACTIONS(7948),
    [anon_sym_GT_EQ] = ACTIONS(7962),
    [anon_sym_CARET] = ACTIONS(7964),
    [anon_sym_PLUS] = ACTIONS(7940),
    [anon_sym_SLASH] = ACTIONS(7942),
    [anon_sym_PERCENT] = ACTIONS(7942),
    [sym_comment] = ACTIONS(87),
  },
  [7454] = {
    [aux_sym_exceptions_repeat1] = STATE(9274),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_then] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [7455] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(7940),
    [sym__binary_star] = ACTIONS(7942),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(7944),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(7942),
    [anon_sym_AMP] = ACTIONS(7946),
    [anon_sym_LT] = ACTIONS(7948),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_then] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(7950),
    [anon_sym_DOT_DOT] = ACTIONS(7952),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7954),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(7956),
    [anon_sym_AMP_AMP] = ACTIONS(7956),
    [anon_sym_LT_LT] = ACTIONS(7958),
    [anon_sym_GT_GT] = ACTIONS(7958),
    [anon_sym_EQ_EQ] = ACTIONS(7960),
    [anon_sym_BANG_EQ] = ACTIONS(7956),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7956),
    [anon_sym_LT_EQ_GT] = ACTIONS(7956),
    [anon_sym_EQ_TILDE] = ACTIONS(7956),
    [anon_sym_BANG_TILDE] = ACTIONS(7956),
    [anon_sym_LT_EQ] = ACTIONS(7948),
    [anon_sym_GT] = ACTIONS(7948),
    [anon_sym_GT_EQ] = ACTIONS(7962),
    [anon_sym_CARET] = ACTIONS(7964),
    [anon_sym_PLUS] = ACTIONS(7940),
    [anon_sym_SLASH] = ACTIONS(7942),
    [anon_sym_PERCENT] = ACTIONS(7942),
    [sym_comment] = ACTIONS(87),
  },
  [7456] = {
    [sym_string] = STATE(7456),
    [aux_sym_chained_string_repeat1] = STATE(7456),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(6214),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_then] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [7457] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(4423),
    [sym__binary_star] = ACTIONS(4425),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(4427),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(4425),
    [anon_sym_AMP] = ACTIONS(4429),
    [anon_sym_LT] = ACTIONS(4431),
    [anon_sym_if] = ACTIONS(6823),
    [anon_sym_unless] = ACTIONS(6823),
    [anon_sym_while] = ACTIONS(6823),
    [anon_sym_until] = ACTIONS(6823),
    [anon_sym_rescue] = ACTIONS(6823),
    [anon_sym_then] = ACTIONS(6823),
    [anon_sym_EQ_GT] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(4433),
    [anon_sym_DOT_DOT] = ACTIONS(4435),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4437),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(4439),
    [anon_sym_AMP_AMP] = ACTIONS(4439),
    [anon_sym_LT_LT] = ACTIONS(4441),
    [anon_sym_GT_GT] = ACTIONS(4441),
    [anon_sym_EQ_EQ] = ACTIONS(4443),
    [anon_sym_BANG_EQ] = ACTIONS(4439),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4439),
    [anon_sym_LT_EQ_GT] = ACTIONS(4439),
    [anon_sym_EQ_TILDE] = ACTIONS(4439),
    [anon_sym_BANG_TILDE] = ACTIONS(4439),
    [anon_sym_LT_EQ] = ACTIONS(4431),
    [anon_sym_GT] = ACTIONS(4431),
    [anon_sym_GT_EQ] = ACTIONS(4445),
    [anon_sym_CARET] = ACTIONS(4447),
    [anon_sym_PLUS] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(4425),
    [anon_sym_PERCENT] = ACTIONS(4425),
    [sym_comment] = ACTIONS(87),
  },
  [7458] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(4423),
    [sym__binary_star] = ACTIONS(4425),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(4427),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(4425),
    [anon_sym_AMP] = ACTIONS(4429),
    [anon_sym_LT] = ACTIONS(4431),
    [anon_sym_if] = ACTIONS(7027),
    [anon_sym_unless] = ACTIONS(7027),
    [anon_sym_while] = ACTIONS(7027),
    [anon_sym_until] = ACTIONS(7027),
    [anon_sym_rescue] = ACTIONS(7027),
    [anon_sym_then] = ACTIONS(7027),
    [anon_sym_EQ_GT] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(4433),
    [anon_sym_DOT_DOT] = ACTIONS(4435),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4437),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(4439),
    [anon_sym_AMP_AMP] = ACTIONS(4439),
    [anon_sym_LT_LT] = ACTIONS(4441),
    [anon_sym_GT_GT] = ACTIONS(4441),
    [anon_sym_EQ_EQ] = ACTIONS(4443),
    [anon_sym_BANG_EQ] = ACTIONS(4439),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4439),
    [anon_sym_LT_EQ_GT] = ACTIONS(4439),
    [anon_sym_EQ_TILDE] = ACTIONS(4439),
    [anon_sym_BANG_TILDE] = ACTIONS(4439),
    [anon_sym_LT_EQ] = ACTIONS(4431),
    [anon_sym_GT] = ACTIONS(4431),
    [anon_sym_GT_EQ] = ACTIONS(4445),
    [anon_sym_CARET] = ACTIONS(4447),
    [anon_sym_PLUS] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(4425),
    [anon_sym_PERCENT] = ACTIONS(4425),
    [sym_comment] = ACTIONS(87),
  },
  [7459] = {
    [sym_heredoc_body] = STATE(7459),
    [aux_sym_call_repeat1] = STATE(7459),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(7916),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_then] = ACTIONS(7914),
    [anon_sym_EQ_GT] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [7460] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2595),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym__argument] = STATE(4986),
    [sym_splat_argument] = STATE(4986),
    [sym_hash_splat_argument] = STATE(4986),
    [sym_block_argument] = STATE(4986),
    [sym_assignment] = STATE(2595),
    [sym_operator_assignment] = STATE(2595),
    [sym_conditional] = STATE(2595),
    [sym_range] = STATE(2595),
    [sym_binary] = STATE(2595),
    [sym_unary] = STATE(2595),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2598),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4986),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(4413),
    [sym__splat_star] = ACTIONS(4415),
    [sym__unary_minus] = ACTIONS(1713),
    [sym__identifier_hash_key] = ACTIONS(4417),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10992),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1717),
    [anon_sym_yield] = ACTIONS(1719),
    [anon_sym_break] = ACTIONS(1721),
    [anon_sym_next] = ACTIONS(1723),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4409),
    [anon_sym_defined_QMARK] = ACTIONS(1725),
    [anon_sym_not] = ACTIONS(1727),
    [anon_sym_BANG] = ACTIONS(1731),
    [anon_sym_TILDE] = ACTIONS(1731),
    [sym_constant] = ACTIONS(4419),
    [sym_identifier] = ACTIONS(4419),
    [sym_instance_variable] = ACTIONS(1735),
    [sym_class_variable] = ACTIONS(1735),
    [sym_global_variable] = ACTIONS(1735),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1737),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1737),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7461] = {
    [sym_heredoc_body] = STATE(7459),
    [aux_sym_call_repeat1] = STATE(7459),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_then] = ACTIONS(7929),
    [anon_sym_EQ_GT] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [7462] = {
    [aux_sym_argument_list_repeat1] = STATE(7462),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(12890),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7925),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_if] = ACTIONS(7925),
    [anon_sym_unless] = ACTIONS(7925),
    [anon_sym_while] = ACTIONS(7925),
    [anon_sym_until] = ACTIONS(7925),
    [anon_sym_rescue] = ACTIONS(7925),
    [anon_sym_then] = ACTIONS(7925),
    [anon_sym_EQ_GT] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7925),
    [anon_sym_AMP_AMP] = ACTIONS(7925),
    [anon_sym_LT_LT] = ACTIONS(7925),
    [anon_sym_GT_GT] = ACTIONS(7925),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7925),
    [anon_sym_PLUS] = ACTIONS(7925),
    [anon_sym_SLASH] = ACTIONS(7925),
    [anon_sym_PERCENT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [7463] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9275),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_assignment] = STATE(9275),
    [sym_operator_assignment] = STATE(9275),
    [sym_conditional] = STATE(9275),
    [sym_range] = STATE(9275),
    [sym_binary] = STATE(9275),
    [sym_unary] = STATE(9275),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2587),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1713),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1717),
    [anon_sym_yield] = ACTIONS(1719),
    [anon_sym_break] = ACTIONS(1721),
    [anon_sym_next] = ACTIONS(1723),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4409),
    [anon_sym_defined_QMARK] = ACTIONS(1725),
    [anon_sym_not] = ACTIONS(1727),
    [anon_sym_BANG] = ACTIONS(1731),
    [anon_sym_TILDE] = ACTIONS(1731),
    [sym_constant] = ACTIONS(1737),
    [sym_identifier] = ACTIONS(1737),
    [sym_instance_variable] = ACTIONS(1735),
    [sym_class_variable] = ACTIONS(1735),
    [sym_global_variable] = ACTIONS(1735),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1737),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1737),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7464] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(4533),
    [sym__binary_star] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(4537),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(4539),
    [anon_sym_AMP] = ACTIONS(4541),
    [anon_sym_EQ] = ACTIONS(7822),
    [anon_sym_LT] = ACTIONS(4543),
    [anon_sym_if] = ACTIONS(6823),
    [anon_sym_unless] = ACTIONS(6823),
    [anon_sym_while] = ACTIONS(6823),
    [anon_sym_until] = ACTIONS(6823),
    [anon_sym_rescue] = ACTIONS(6823),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_then] = ACTIONS(6823),
    [anon_sym_EQ_GT] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_PLUS_EQ] = ACTIONS(6823),
    [anon_sym_DASH_EQ] = ACTIONS(6823),
    [anon_sym_STAR_EQ] = ACTIONS(6823),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6823),
    [anon_sym_SLASH_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6823),
    [anon_sym_AMP_EQ] = ACTIONS(6823),
    [anon_sym_PERCENT_EQ] = ACTIONS(6823),
    [anon_sym_GT_GT_EQ] = ACTIONS(6823),
    [anon_sym_LT_LT_EQ] = ACTIONS(6823),
    [anon_sym_CARET_EQ] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(4545),
    [anon_sym_DOT_DOT] = ACTIONS(4547),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4549),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(4551),
    [anon_sym_AMP_AMP] = ACTIONS(4551),
    [anon_sym_LT_LT] = ACTIONS(4553),
    [anon_sym_GT_GT] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4551),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4555),
    [anon_sym_LT_EQ_GT] = ACTIONS(4555),
    [anon_sym_EQ_TILDE] = ACTIONS(4555),
    [anon_sym_BANG_TILDE] = ACTIONS(4555),
    [anon_sym_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT] = ACTIONS(4543),
    [anon_sym_GT_EQ] = ACTIONS(4557),
    [anon_sym_CARET] = ACTIONS(4537),
    [anon_sym_PLUS] = ACTIONS(4559),
    [anon_sym_SLASH] = ACTIONS(4539),
    [anon_sym_PERCENT] = ACTIONS(4539),
    [sym_comment] = ACTIONS(87),
  },
  [7465] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(4533),
    [sym__binary_star] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(4537),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(4539),
    [anon_sym_AMP] = ACTIONS(4541),
    [anon_sym_EQ] = ACTIONS(7884),
    [anon_sym_LT] = ACTIONS(4543),
    [anon_sym_if] = ACTIONS(7027),
    [anon_sym_unless] = ACTIONS(7027),
    [anon_sym_while] = ACTIONS(7027),
    [anon_sym_until] = ACTIONS(7027),
    [anon_sym_rescue] = ACTIONS(7027),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_then] = ACTIONS(7027),
    [anon_sym_EQ_GT] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_PLUS_EQ] = ACTIONS(7027),
    [anon_sym_DASH_EQ] = ACTIONS(7027),
    [anon_sym_STAR_EQ] = ACTIONS(7027),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7027),
    [anon_sym_SLASH_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7027),
    [anon_sym_AMP_EQ] = ACTIONS(7027),
    [anon_sym_PERCENT_EQ] = ACTIONS(7027),
    [anon_sym_GT_GT_EQ] = ACTIONS(7027),
    [anon_sym_LT_LT_EQ] = ACTIONS(7027),
    [anon_sym_CARET_EQ] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(4545),
    [anon_sym_DOT_DOT] = ACTIONS(4547),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4549),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(4551),
    [anon_sym_AMP_AMP] = ACTIONS(4551),
    [anon_sym_LT_LT] = ACTIONS(4553),
    [anon_sym_GT_GT] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4551),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4555),
    [anon_sym_LT_EQ_GT] = ACTIONS(4555),
    [anon_sym_EQ_TILDE] = ACTIONS(4555),
    [anon_sym_BANG_TILDE] = ACTIONS(4555),
    [anon_sym_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT] = ACTIONS(4543),
    [anon_sym_GT_EQ] = ACTIONS(4557),
    [anon_sym_CARET] = ACTIONS(4537),
    [anon_sym_PLUS] = ACTIONS(4559),
    [anon_sym_SLASH] = ACTIONS(4539),
    [anon_sym_PERCENT] = ACTIONS(4539),
    [sym_comment] = ACTIONS(87),
  },
  [7466] = {
    [sym_heredoc_body] = STATE(7466),
    [aux_sym_call_repeat1] = STATE(7466),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(10978),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7919),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_EQ] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_then] = ACTIONS(7914),
    [anon_sym_EQ_GT] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_PLUS_EQ] = ACTIONS(7914),
    [anon_sym_DASH_EQ] = ACTIONS(7914),
    [anon_sym_STAR_EQ] = ACTIONS(7914),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7914),
    [anon_sym_SLASH_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7914),
    [anon_sym_AMP_EQ] = ACTIONS(7914),
    [anon_sym_PERCENT_EQ] = ACTIONS(7914),
    [anon_sym_GT_GT_EQ] = ACTIONS(7914),
    [anon_sym_LT_LT_EQ] = ACTIONS(7914),
    [anon_sym_CARET_EQ] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7919),
    [anon_sym_AMP_AMP] = ACTIONS(7919),
    [anon_sym_LT_LT] = ACTIONS(7919),
    [anon_sym_GT_GT] = ACTIONS(7919),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7919),
    [anon_sym_PLUS] = ACTIONS(7919),
    [anon_sym_SLASH] = ACTIONS(7919),
    [anon_sym_PERCENT] = ACTIONS(7919),
    [sym_comment] = ACTIONS(87),
  },
  [7467] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(2616),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym__argument] = STATE(7437),
    [sym_splat_argument] = STATE(7437),
    [sym_hash_splat_argument] = STATE(7437),
    [sym_block_argument] = STATE(7437),
    [sym_assignment] = STATE(2616),
    [sym_operator_assignment] = STATE(2616),
    [sym_conditional] = STATE(2616),
    [sym_range] = STATE(2616),
    [sym_binary] = STATE(2616),
    [sym_unary] = STATE(2616),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2619),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(7437),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(4449),
    [sym__splat_star] = ACTIONS(4451),
    [sym__unary_minus] = ACTIONS(1787),
    [sym__identifier_hash_key] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10996),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1791),
    [anon_sym_yield] = ACTIONS(1793),
    [anon_sym_break] = ACTIONS(1795),
    [anon_sym_next] = ACTIONS(1797),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(4527),
    [anon_sym_defined_QMARK] = ACTIONS(1799),
    [anon_sym_not] = ACTIONS(1801),
    [anon_sym_BANG] = ACTIONS(1805),
    [anon_sym_TILDE] = ACTIONS(1805),
    [sym_constant] = ACTIONS(4455),
    [sym_identifier] = ACTIONS(4455),
    [sym_instance_variable] = ACTIONS(1809),
    [sym_class_variable] = ACTIONS(1809),
    [sym_global_variable] = ACTIONS(1809),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1811),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1811),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7468] = {
    [sym_heredoc_body] = STATE(7466),
    [aux_sym_call_repeat1] = STATE(7466),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7931),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_EQ] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_then] = ACTIONS(7929),
    [anon_sym_EQ_GT] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_PLUS_EQ] = ACTIONS(7929),
    [anon_sym_DASH_EQ] = ACTIONS(7929),
    [anon_sym_STAR_EQ] = ACTIONS(7929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7929),
    [anon_sym_SLASH_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7929),
    [anon_sym_AMP_EQ] = ACTIONS(7929),
    [anon_sym_PERCENT_EQ] = ACTIONS(7929),
    [anon_sym_GT_GT_EQ] = ACTIONS(7929),
    [anon_sym_LT_LT_EQ] = ACTIONS(7929),
    [anon_sym_CARET_EQ] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7931),
    [anon_sym_AMP_AMP] = ACTIONS(7931),
    [anon_sym_LT_LT] = ACTIONS(7931),
    [anon_sym_GT_GT] = ACTIONS(7931),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7931),
    [anon_sym_PLUS] = ACTIONS(7931),
    [anon_sym_SLASH] = ACTIONS(7931),
    [anon_sym_PERCENT] = ACTIONS(7931),
    [sym_comment] = ACTIONS(87),
  },
  [7469] = {
    [aux_sym_argument_list_repeat1] = STATE(7469),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(12893),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7927),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_EQ] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_if] = ACTIONS(7925),
    [anon_sym_unless] = ACTIONS(7925),
    [anon_sym_while] = ACTIONS(7925),
    [anon_sym_until] = ACTIONS(7925),
    [anon_sym_rescue] = ACTIONS(7925),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_then] = ACTIONS(7925),
    [anon_sym_EQ_GT] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_PLUS_EQ] = ACTIONS(7925),
    [anon_sym_DASH_EQ] = ACTIONS(7925),
    [anon_sym_STAR_EQ] = ACTIONS(7925),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7925),
    [anon_sym_SLASH_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7925),
    [anon_sym_AMP_EQ] = ACTIONS(7925),
    [anon_sym_PERCENT_EQ] = ACTIONS(7925),
    [anon_sym_GT_GT_EQ] = ACTIONS(7925),
    [anon_sym_LT_LT_EQ] = ACTIONS(7925),
    [anon_sym_CARET_EQ] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7927),
    [anon_sym_AMP_AMP] = ACTIONS(7927),
    [anon_sym_LT_LT] = ACTIONS(7927),
    [anon_sym_GT_GT] = ACTIONS(7927),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7927),
    [anon_sym_PLUS] = ACTIONS(7927),
    [anon_sym_SLASH] = ACTIONS(7927),
    [anon_sym_PERCENT] = ACTIONS(7927),
    [sym_comment] = ACTIONS(87),
  },
  [7470] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5038),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_splat_argument] = STATE(7439),
    [sym_assignment] = STATE(5038),
    [sym_operator_assignment] = STATE(5038),
    [sym_conditional] = STATE(5038),
    [sym_range] = STATE(5038),
    [sym_binary] = STATE(5038),
    [sym_unary] = STATE(5038),
    [sym__arg_or_splat_arg] = STATE(7439),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2587),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__splat_star] = ACTIONS(4415),
    [sym__unary_minus] = ACTIONS(1713),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1717),
    [anon_sym_yield] = ACTIONS(1719),
    [anon_sym_break] = ACTIONS(1721),
    [anon_sym_next] = ACTIONS(1723),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4409),
    [anon_sym_defined_QMARK] = ACTIONS(1725),
    [anon_sym_not] = ACTIONS(1727),
    [anon_sym_BANG] = ACTIONS(1731),
    [anon_sym_TILDE] = ACTIONS(1731),
    [sym_constant] = ACTIONS(1737),
    [sym_identifier] = ACTIONS(1737),
    [sym_instance_variable] = ACTIONS(1735),
    [sym_class_variable] = ACTIONS(1735),
    [sym_global_variable] = ACTIONS(1735),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1737),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1737),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7471] = {
    [aux_sym_exceptions_repeat1] = STATE(9276),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(12896),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_then] = ACTIONS(9855),
    [anon_sym_EQ_GT] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [7472] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9277),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7481),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(7481),
    [sym_assignment] = STATE(9277),
    [sym_operator_assignment] = STATE(9277),
    [sym_conditional] = STATE(9277),
    [sym_range] = STATE(9277),
    [sym_binary] = STATE(9277),
    [sym_unary] = STATE(9277),
    [sym_left_assignment_list] = STATE(7480),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7481),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7481),
    [sym_false] = STATE(7481),
    [sym_nil] = STATE(7481),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7482),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11001),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11003),
    [anon_sym_yield] = ACTIONS(11005),
    [anon_sym_break] = ACTIONS(11007),
    [anon_sym_next] = ACTIONS(11009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11011),
    [anon_sym_defined_QMARK] = ACTIONS(11013),
    [anon_sym_not] = ACTIONS(11015),
    [anon_sym_BANG] = ACTIONS(11017),
    [anon_sym_TILDE] = ACTIONS(11017),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7473] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5056),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5061),
    [sym_scope_resolution] = STATE(5057),
    [sym_call] = STATE(5057),
    [sym_method_call] = STATE(5061),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(9278),
    [sym__argument] = STATE(9279),
    [sym_splat_argument] = STATE(9279),
    [sym_hash_splat_argument] = STATE(9279),
    [sym_block_argument] = STATE(9279),
    [sym_assignment] = STATE(5056),
    [sym_operator_assignment] = STATE(5056),
    [sym_conditional] = STATE(5056),
    [sym_range] = STATE(5056),
    [sym_binary] = STATE(5056),
    [sym_unary] = STATE(5056),
    [sym_left_assignment_list] = STATE(5060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5061),
    [sym__variable] = STATE(5057),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5061),
    [sym_false] = STATE(5061),
    [sym_nil] = STATE(5061),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5062),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(9279),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(7990),
    [sym__splat_star] = ACTIONS(7992),
    [sym__unary_minus] = ACTIONS(7994),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(7996),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(7998),
    [anon_sym_yield] = ACTIONS(8000),
    [anon_sym_break] = ACTIONS(8002),
    [anon_sym_next] = ACTIONS(8004),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(377),
    [anon_sym_else] = ACTIONS(377),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(8006),
    [anon_sym_not] = ACTIONS(8008),
    [anon_sym_BANG] = ACTIONS(8010),
    [anon_sym_TILDE] = ACTIONS(8012),
    [sym_constant] = ACTIONS(8014),
    [sym_identifier] = ACTIONS(8014),
    [sym_instance_variable] = ACTIONS(8016),
    [sym_class_variable] = ACTIONS(8016),
    [sym_global_variable] = ACTIONS(8016),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8018),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8018),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7474] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5056),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5061),
    [sym_scope_resolution] = STATE(5057),
    [sym_call] = STATE(5057),
    [sym_method_call] = STATE(5061),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(9278),
    [sym__argument] = STATE(9279),
    [sym_splat_argument] = STATE(9279),
    [sym_hash_splat_argument] = STATE(9279),
    [sym_block_argument] = STATE(9279),
    [sym_assignment] = STATE(5056),
    [sym_operator_assignment] = STATE(5056),
    [sym_conditional] = STATE(5056),
    [sym_range] = STATE(5056),
    [sym_binary] = STATE(5056),
    [sym_unary] = STATE(5056),
    [sym_left_assignment_list] = STATE(5060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5061),
    [sym__variable] = STATE(5057),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5061),
    [sym_false] = STATE(5061),
    [sym_nil] = STATE(5061),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5062),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(9279),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(7990),
    [sym__splat_star] = ACTIONS(7992),
    [sym__unary_minus] = ACTIONS(7994),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(7996),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(7998),
    [anon_sym_yield] = ACTIONS(8000),
    [anon_sym_break] = ACTIONS(8002),
    [anon_sym_next] = ACTIONS(8004),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(419),
    [anon_sym_else] = ACTIONS(419),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(8006),
    [anon_sym_not] = ACTIONS(8008),
    [anon_sym_BANG] = ACTIONS(8010),
    [anon_sym_TILDE] = ACTIONS(8012),
    [sym_constant] = ACTIONS(8014),
    [sym_identifier] = ACTIONS(8014),
    [sym_instance_variable] = ACTIONS(8016),
    [sym_class_variable] = ACTIONS(8016),
    [sym_global_variable] = ACTIONS(8016),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8018),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8018),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7475] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5056),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5061),
    [sym_scope_resolution] = STATE(5057),
    [sym_call] = STATE(5057),
    [sym_method_call] = STATE(5061),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(9278),
    [sym__argument] = STATE(9279),
    [sym_splat_argument] = STATE(9279),
    [sym_hash_splat_argument] = STATE(9279),
    [sym_block_argument] = STATE(9279),
    [sym_assignment] = STATE(5056),
    [sym_operator_assignment] = STATE(5056),
    [sym_conditional] = STATE(5056),
    [sym_range] = STATE(5056),
    [sym_binary] = STATE(5056),
    [sym_unary] = STATE(5056),
    [sym_left_assignment_list] = STATE(5060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5061),
    [sym__variable] = STATE(5057),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5061),
    [sym_false] = STATE(5061),
    [sym_nil] = STATE(5061),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5062),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(9279),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(7990),
    [sym__splat_star] = ACTIONS(7992),
    [sym__unary_minus] = ACTIONS(7994),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(7996),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(423),
    [anon_sym_return] = ACTIONS(7998),
    [anon_sym_yield] = ACTIONS(8000),
    [anon_sym_break] = ACTIONS(8002),
    [anon_sym_next] = ACTIONS(8004),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(423),
    [anon_sym_else] = ACTIONS(423),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(8006),
    [anon_sym_not] = ACTIONS(8008),
    [anon_sym_BANG] = ACTIONS(8010),
    [anon_sym_TILDE] = ACTIONS(8012),
    [sym_constant] = ACTIONS(8014),
    [sym_identifier] = ACTIONS(8014),
    [sym_instance_variable] = ACTIONS(8016),
    [sym_class_variable] = ACTIONS(8016),
    [sym_global_variable] = ACTIONS(8016),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8018),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8018),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7476] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5056),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5061),
    [sym_scope_resolution] = STATE(5057),
    [sym_call] = STATE(5057),
    [sym_method_call] = STATE(5061),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(9278),
    [sym__argument] = STATE(9279),
    [sym_splat_argument] = STATE(9279),
    [sym_hash_splat_argument] = STATE(9279),
    [sym_block_argument] = STATE(9279),
    [sym_assignment] = STATE(5056),
    [sym_operator_assignment] = STATE(5056),
    [sym_conditional] = STATE(5056),
    [sym_range] = STATE(5056),
    [sym_binary] = STATE(5056),
    [sym_unary] = STATE(5056),
    [sym_left_assignment_list] = STATE(5060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5061),
    [sym__variable] = STATE(5057),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5061),
    [sym_false] = STATE(5061),
    [sym_nil] = STATE(5061),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5062),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(9279),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(7990),
    [sym__splat_star] = ACTIONS(7992),
    [sym__unary_minus] = ACTIONS(7994),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(7996),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(427),
    [anon_sym_return] = ACTIONS(7998),
    [anon_sym_yield] = ACTIONS(8000),
    [anon_sym_break] = ACTIONS(8002),
    [anon_sym_next] = ACTIONS(8004),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(427),
    [anon_sym_else] = ACTIONS(427),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(8006),
    [anon_sym_not] = ACTIONS(8008),
    [anon_sym_BANG] = ACTIONS(8010),
    [anon_sym_TILDE] = ACTIONS(8012),
    [sym_constant] = ACTIONS(8014),
    [sym_identifier] = ACTIONS(8014),
    [sym_instance_variable] = ACTIONS(8016),
    [sym_class_variable] = ACTIONS(8016),
    [sym_global_variable] = ACTIONS(8016),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8018),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8018),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7477] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9280),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7481),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(7481),
    [sym_assignment] = STATE(9280),
    [sym_operator_assignment] = STATE(9280),
    [sym_conditional] = STATE(9280),
    [sym_range] = STATE(9280),
    [sym_binary] = STATE(9280),
    [sym_unary] = STATE(9280),
    [sym_left_assignment_list] = STATE(7480),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7481),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7481),
    [sym_false] = STATE(7481),
    [sym_nil] = STATE(7481),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7482),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11001),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11003),
    [anon_sym_yield] = ACTIONS(11005),
    [anon_sym_break] = ACTIONS(11007),
    [anon_sym_next] = ACTIONS(11009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11011),
    [anon_sym_defined_QMARK] = ACTIONS(11013),
    [anon_sym_not] = ACTIONS(11015),
    [anon_sym_BANG] = ACTIONS(11017),
    [anon_sym_TILDE] = ACTIONS(11017),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7478] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7481),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(7481),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(7480),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7481),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7481),
    [sym_false] = STATE(7481),
    [sym_nil] = STATE(7481),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7482),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11001),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11003),
    [anon_sym_yield] = ACTIONS(11005),
    [anon_sym_break] = ACTIONS(11007),
    [anon_sym_next] = ACTIONS(11009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11011),
    [anon_sym_defined_QMARK] = ACTIONS(11013),
    [anon_sym_not] = ACTIONS(11015),
    [anon_sym_BANG] = ACTIONS(11017),
    [anon_sym_TILDE] = ACTIONS(11017),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7479] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(12898),
    [sym__binary_star] = ACTIONS(12900),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(12902),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(12900),
    [anon_sym_AMP] = ACTIONS(12904),
    [anon_sym_LT] = ACTIONS(12906),
    [anon_sym_end] = ACTIONS(4211),
    [anon_sym_if] = ACTIONS(4211),
    [anon_sym_unless] = ACTIONS(4211),
    [anon_sym_while] = ACTIONS(4211),
    [anon_sym_until] = ACTIONS(4211),
    [anon_sym_rescue] = ACTIONS(4211),
    [anon_sym_elsif] = ACTIONS(4211),
    [anon_sym_else] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(12908),
    [anon_sym_DOT_DOT] = ACTIONS(12910),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12912),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(12914),
    [anon_sym_AMP_AMP] = ACTIONS(12914),
    [anon_sym_LT_LT] = ACTIONS(12916),
    [anon_sym_GT_GT] = ACTIONS(12916),
    [anon_sym_EQ_EQ] = ACTIONS(12918),
    [anon_sym_BANG_EQ] = ACTIONS(12914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12914),
    [anon_sym_LT_EQ_GT] = ACTIONS(12914),
    [anon_sym_EQ_TILDE] = ACTIONS(12914),
    [anon_sym_BANG_TILDE] = ACTIONS(12914),
    [anon_sym_LT_EQ] = ACTIONS(12906),
    [anon_sym_GT] = ACTIONS(12906),
    [anon_sym_GT_EQ] = ACTIONS(12920),
    [anon_sym_CARET] = ACTIONS(12922),
    [anon_sym_PLUS] = ACTIONS(12898),
    [anon_sym_SLASH] = ACTIONS(12900),
    [anon_sym_PERCENT] = ACTIONS(12900),
    [sym_comment] = ACTIONS(87),
  },
  [7480] = {
    [anon_sym_EQ] = ACTIONS(12924),
    [sym_comment] = ACTIONS(87),
  },
  [7481] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(12926),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_elsif] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(12928),
    [anon_sym_DASH_EQ] = ACTIONS(12928),
    [anon_sym_STAR_EQ] = ACTIONS(12928),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12928),
    [anon_sym_SLASH_EQ] = ACTIONS(12928),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12928),
    [anon_sym_PIPE_EQ] = ACTIONS(12928),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12928),
    [anon_sym_AMP_EQ] = ACTIONS(12928),
    [anon_sym_PERCENT_EQ] = ACTIONS(12928),
    [anon_sym_GT_GT_EQ] = ACTIONS(12928),
    [anon_sym_LT_LT_EQ] = ACTIONS(12928),
    [anon_sym_CARET_EQ] = ACTIONS(12928),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [7482] = {
    [sym_string] = STATE(9293),
    [aux_sym_chained_string_repeat1] = STATE(9293),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_elsif] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [7483] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(12898),
    [sym__binary_star] = ACTIONS(12900),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(12902),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(12900),
    [anon_sym_AMP] = ACTIONS(12904),
    [anon_sym_LT] = ACTIONS(12906),
    [anon_sym_end] = ACTIONS(4247),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_elsif] = ACTIONS(4247),
    [anon_sym_else] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(12908),
    [anon_sym_DOT_DOT] = ACTIONS(12910),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12912),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(12914),
    [anon_sym_AMP_AMP] = ACTIONS(12914),
    [anon_sym_LT_LT] = ACTIONS(12916),
    [anon_sym_GT_GT] = ACTIONS(12916),
    [anon_sym_EQ_EQ] = ACTIONS(12918),
    [anon_sym_BANG_EQ] = ACTIONS(12914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12914),
    [anon_sym_LT_EQ_GT] = ACTIONS(12914),
    [anon_sym_EQ_TILDE] = ACTIONS(12914),
    [anon_sym_BANG_TILDE] = ACTIONS(12914),
    [anon_sym_LT_EQ] = ACTIONS(12906),
    [anon_sym_GT] = ACTIONS(12906),
    [anon_sym_GT_EQ] = ACTIONS(12920),
    [anon_sym_CARET] = ACTIONS(12922),
    [anon_sym_PLUS] = ACTIONS(12898),
    [anon_sym_SLASH] = ACTIONS(12900),
    [anon_sym_PERCENT] = ACTIONS(12900),
    [sym_comment] = ACTIONS(87),
  },
  [7484] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(11035),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_elsif] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [7485] = {
    [sym_string] = STATE(7523),
    [aux_sym_chained_string_repeat1] = STATE(7523),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_elsif] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [7486] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9294),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7481),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(7481),
    [sym_assignment] = STATE(9294),
    [sym_operator_assignment] = STATE(9294),
    [sym_conditional] = STATE(9294),
    [sym_range] = STATE(9294),
    [sym_binary] = STATE(9294),
    [sym_unary] = STATE(9294),
    [sym_left_assignment_list] = STATE(7480),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7481),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7481),
    [sym_false] = STATE(7481),
    [sym_nil] = STATE(7481),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7482),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11001),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11003),
    [anon_sym_yield] = ACTIONS(11005),
    [anon_sym_break] = ACTIONS(11007),
    [anon_sym_next] = ACTIONS(11009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11011),
    [anon_sym_defined_QMARK] = ACTIONS(11013),
    [anon_sym_not] = ACTIONS(11015),
    [anon_sym_BANG] = ACTIONS(11017),
    [anon_sym_TILDE] = ACTIONS(11017),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7487] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(12898),
    [sym__binary_star] = ACTIONS(12900),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(12902),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(12900),
    [anon_sym_AMP] = ACTIONS(12904),
    [anon_sym_LT] = ACTIONS(12906),
    [anon_sym_end] = ACTIONS(3281),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_unless] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_until] = ACTIONS(3281),
    [anon_sym_rescue] = ACTIONS(3281),
    [anon_sym_elsif] = ACTIONS(3281),
    [anon_sym_else] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(12908),
    [anon_sym_DOT_DOT] = ACTIONS(12910),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12912),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(12914),
    [anon_sym_AMP_AMP] = ACTIONS(12914),
    [anon_sym_LT_LT] = ACTIONS(12916),
    [anon_sym_GT_GT] = ACTIONS(12916),
    [anon_sym_EQ_EQ] = ACTIONS(12918),
    [anon_sym_BANG_EQ] = ACTIONS(12914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12914),
    [anon_sym_LT_EQ_GT] = ACTIONS(12914),
    [anon_sym_EQ_TILDE] = ACTIONS(12914),
    [anon_sym_BANG_TILDE] = ACTIONS(12914),
    [anon_sym_LT_EQ] = ACTIONS(12906),
    [anon_sym_GT] = ACTIONS(12906),
    [anon_sym_GT_EQ] = ACTIONS(12920),
    [anon_sym_CARET] = ACTIONS(12922),
    [anon_sym_PLUS] = ACTIONS(12898),
    [anon_sym_SLASH] = ACTIONS(12900),
    [anon_sym_PERCENT] = ACTIONS(12900),
    [sym_comment] = ACTIONS(87),
  },
  [7488] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9295),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5061),
    [sym_scope_resolution] = STATE(5057),
    [sym_call] = STATE(5057),
    [sym_method_call] = STATE(5061),
    [sym_assignment] = STATE(9295),
    [sym_operator_assignment] = STATE(9295),
    [sym_conditional] = STATE(9295),
    [sym_range] = STATE(9295),
    [sym_binary] = STATE(9295),
    [sym_unary] = STATE(9295),
    [sym_left_assignment_list] = STATE(5060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5061),
    [sym__variable] = STATE(5057),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5061),
    [sym_false] = STATE(5061),
    [sym_nil] = STATE(5061),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7485),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(7994),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7998),
    [anon_sym_yield] = ACTIONS(8000),
    [anon_sym_break] = ACTIONS(8002),
    [anon_sym_next] = ACTIONS(8004),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11019),
    [anon_sym_defined_QMARK] = ACTIONS(8006),
    [anon_sym_not] = ACTIONS(8008),
    [anon_sym_BANG] = ACTIONS(8012),
    [anon_sym_TILDE] = ACTIONS(8012),
    [sym_constant] = ACTIONS(8018),
    [sym_identifier] = ACTIONS(8018),
    [sym_instance_variable] = ACTIONS(8016),
    [sym_class_variable] = ACTIONS(8016),
    [sym_global_variable] = ACTIONS(8016),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8018),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8018),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7489] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9296),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5061),
    [sym_scope_resolution] = STATE(5057),
    [sym_call] = STATE(5057),
    [sym_method_call] = STATE(5061),
    [sym_assignment] = STATE(9296),
    [sym_operator_assignment] = STATE(9296),
    [sym_conditional] = STATE(9296),
    [sym_range] = STATE(9296),
    [sym_binary] = STATE(9296),
    [sym_unary] = STATE(9296),
    [sym_left_assignment_list] = STATE(5060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5061),
    [sym__variable] = STATE(5057),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5061),
    [sym_false] = STATE(5061),
    [sym_nil] = STATE(5061),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7485),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(7994),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7998),
    [anon_sym_yield] = ACTIONS(8000),
    [anon_sym_break] = ACTIONS(8002),
    [anon_sym_next] = ACTIONS(8004),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11019),
    [anon_sym_defined_QMARK] = ACTIONS(8006),
    [anon_sym_not] = ACTIONS(8008),
    [anon_sym_BANG] = ACTIONS(8012),
    [anon_sym_TILDE] = ACTIONS(8012),
    [sym_constant] = ACTIONS(8018),
    [sym_identifier] = ACTIONS(8018),
    [sym_instance_variable] = ACTIONS(8016),
    [sym_class_variable] = ACTIONS(8016),
    [sym_global_variable] = ACTIONS(8016),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8018),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8018),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7490] = {
    [anon_sym_COLON] = ACTIONS(12930),
    [sym_comment] = ACTIONS(87),
  },
  [7491] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9298),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5061),
    [sym_scope_resolution] = STATE(5057),
    [sym_call] = STATE(5057),
    [sym_method_call] = STATE(5061),
    [sym_assignment] = STATE(9298),
    [sym_operator_assignment] = STATE(9298),
    [sym_conditional] = STATE(9298),
    [sym_range] = STATE(9298),
    [sym_binary] = STATE(9298),
    [sym_unary] = STATE(9298),
    [sym_left_assignment_list] = STATE(5060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5061),
    [sym__variable] = STATE(5057),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5061),
    [sym_false] = STATE(5061),
    [sym_nil] = STATE(5061),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7485),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(7994),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7998),
    [anon_sym_yield] = ACTIONS(8000),
    [anon_sym_break] = ACTIONS(8002),
    [anon_sym_next] = ACTIONS(8004),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11019),
    [anon_sym_defined_QMARK] = ACTIONS(8006),
    [anon_sym_not] = ACTIONS(8008),
    [anon_sym_BANG] = ACTIONS(8012),
    [anon_sym_TILDE] = ACTIONS(8012),
    [sym_constant] = ACTIONS(8018),
    [sym_identifier] = ACTIONS(8018),
    [sym_instance_variable] = ACTIONS(8016),
    [sym_class_variable] = ACTIONS(8016),
    [sym_global_variable] = ACTIONS(8016),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8018),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8018),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7492] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(12932),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_elsif] = ACTIONS(1091),
    [anon_sym_else] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [7493] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(11033),
    [sym__binary_star] = ACTIONS(11035),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(11037),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(11035),
    [anon_sym_AMP] = ACTIONS(11039),
    [anon_sym_LT] = ACTIONS(11041),
    [anon_sym_end] = ACTIONS(1625),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_unless] = ACTIONS(1625),
    [anon_sym_while] = ACTIONS(1625),
    [anon_sym_until] = ACTIONS(1625),
    [anon_sym_rescue] = ACTIONS(1625),
    [anon_sym_elsif] = ACTIONS(1625),
    [anon_sym_else] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(1625),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(11043),
    [anon_sym_DOT_DOT] = ACTIONS(11045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11047),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(11049),
    [anon_sym_AMP_AMP] = ACTIONS(11049),
    [anon_sym_LT_LT] = ACTIONS(11051),
    [anon_sym_GT_GT] = ACTIONS(11051),
    [anon_sym_EQ_EQ] = ACTIONS(11053),
    [anon_sym_BANG_EQ] = ACTIONS(11049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11049),
    [anon_sym_LT_EQ_GT] = ACTIONS(11049),
    [anon_sym_EQ_TILDE] = ACTIONS(11049),
    [anon_sym_BANG_TILDE] = ACTIONS(11049),
    [anon_sym_LT_EQ] = ACTIONS(11041),
    [anon_sym_GT] = ACTIONS(11041),
    [anon_sym_GT_EQ] = ACTIONS(11055),
    [anon_sym_CARET] = ACTIONS(11057),
    [anon_sym_PLUS] = ACTIONS(11033),
    [anon_sym_SLASH] = ACTIONS(11035),
    [anon_sym_PERCENT] = ACTIONS(11035),
    [sym_comment] = ACTIONS(87),
  },
  [7494] = {
    [sym_heredoc_body] = STATE(9300),
    [aux_sym_call_repeat1] = STATE(9300),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_elsif] = ACTIONS(1681),
    [anon_sym_else] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [7495] = {
    [sym_heredoc_body] = STATE(9300),
    [aux_sym_call_repeat1] = STATE(9300),
    [aux_sym_argument_list_repeat1] = STATE(9302),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(12934),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_elsif] = ACTIONS(1681),
    [anon_sym_else] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [7496] = {
    [sym_string] = STATE(7523),
    [aux_sym_chained_string_repeat1] = STATE(7523),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(12936),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_elsif] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [7497] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(11033),
    [sym__binary_star] = ACTIONS(11035),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(11037),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(11035),
    [anon_sym_AMP] = ACTIONS(11039),
    [anon_sym_LT] = ACTIONS(11041),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_elsif] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(11043),
    [anon_sym_DOT_DOT] = ACTIONS(11045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11047),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(11049),
    [anon_sym_AMP_AMP] = ACTIONS(11049),
    [anon_sym_LT_LT] = ACTIONS(11051),
    [anon_sym_GT_GT] = ACTIONS(11051),
    [anon_sym_EQ_EQ] = ACTIONS(11053),
    [anon_sym_BANG_EQ] = ACTIONS(11049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11049),
    [anon_sym_LT_EQ_GT] = ACTIONS(11049),
    [anon_sym_EQ_TILDE] = ACTIONS(11049),
    [anon_sym_BANG_TILDE] = ACTIONS(11049),
    [anon_sym_LT_EQ] = ACTIONS(11041),
    [anon_sym_GT] = ACTIONS(11041),
    [anon_sym_GT_EQ] = ACTIONS(11055),
    [anon_sym_CARET] = ACTIONS(11057),
    [anon_sym_PLUS] = ACTIONS(11033),
    [anon_sym_SLASH] = ACTIONS(11035),
    [anon_sym_PERCENT] = ACTIONS(11035),
    [sym_comment] = ACTIONS(87),
  },
  [7498] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9303),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7481),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(7481),
    [sym_assignment] = STATE(9303),
    [sym_operator_assignment] = STATE(9303),
    [sym_conditional] = STATE(9303),
    [sym_range] = STATE(9303),
    [sym_binary] = STATE(9303),
    [sym_unary] = STATE(9303),
    [sym_left_assignment_list] = STATE(7480),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7481),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7481),
    [sym_false] = STATE(7481),
    [sym_nil] = STATE(7481),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7482),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11001),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11003),
    [anon_sym_yield] = ACTIONS(11005),
    [anon_sym_break] = ACTIONS(11007),
    [anon_sym_next] = ACTIONS(11009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11011),
    [anon_sym_defined_QMARK] = ACTIONS(11013),
    [anon_sym_not] = ACTIONS(11015),
    [anon_sym_BANG] = ACTIONS(11017),
    [anon_sym_TILDE] = ACTIONS(11017),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7499] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9304),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5061),
    [sym_scope_resolution] = STATE(5057),
    [sym_call] = STATE(5057),
    [sym_method_call] = STATE(5061),
    [sym_assignment] = STATE(9304),
    [sym_operator_assignment] = STATE(9304),
    [sym_conditional] = STATE(9304),
    [sym_range] = STATE(9304),
    [sym_binary] = STATE(9304),
    [sym_unary] = STATE(9304),
    [sym_left_assignment_list] = STATE(5060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5061),
    [sym__variable] = STATE(5057),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5061),
    [sym_false] = STATE(5061),
    [sym_nil] = STATE(5061),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7485),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(7994),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7998),
    [anon_sym_yield] = ACTIONS(8000),
    [anon_sym_break] = ACTIONS(8002),
    [anon_sym_next] = ACTIONS(8004),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11019),
    [anon_sym_defined_QMARK] = ACTIONS(8006),
    [anon_sym_not] = ACTIONS(8008),
    [anon_sym_BANG] = ACTIONS(8012),
    [anon_sym_TILDE] = ACTIONS(8012),
    [sym_constant] = ACTIONS(8018),
    [sym_identifier] = ACTIONS(8018),
    [sym_instance_variable] = ACTIONS(8016),
    [sym_class_variable] = ACTIONS(8016),
    [sym_global_variable] = ACTIONS(8016),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8018),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8018),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7500] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9305),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5061),
    [sym_scope_resolution] = STATE(5057),
    [sym_call] = STATE(5057),
    [sym_method_call] = STATE(5061),
    [sym_assignment] = STATE(9305),
    [sym_operator_assignment] = STATE(9305),
    [sym_conditional] = STATE(9305),
    [sym_range] = STATE(9305),
    [sym_binary] = STATE(9305),
    [sym_unary] = STATE(9305),
    [sym_left_assignment_list] = STATE(5060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5061),
    [sym__variable] = STATE(5057),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5061),
    [sym_false] = STATE(5061),
    [sym_nil] = STATE(5061),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7485),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(7994),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7998),
    [anon_sym_yield] = ACTIONS(8000),
    [anon_sym_break] = ACTIONS(8002),
    [anon_sym_next] = ACTIONS(8004),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11019),
    [anon_sym_defined_QMARK] = ACTIONS(8006),
    [anon_sym_not] = ACTIONS(8008),
    [anon_sym_BANG] = ACTIONS(8012),
    [anon_sym_TILDE] = ACTIONS(8012),
    [sym_constant] = ACTIONS(8018),
    [sym_identifier] = ACTIONS(8018),
    [sym_instance_variable] = ACTIONS(8016),
    [sym_class_variable] = ACTIONS(8016),
    [sym_global_variable] = ACTIONS(8016),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8018),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8018),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7501] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9306),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5061),
    [sym_scope_resolution] = STATE(5057),
    [sym_call] = STATE(5057),
    [sym_method_call] = STATE(5061),
    [sym_assignment] = STATE(9306),
    [sym_operator_assignment] = STATE(9306),
    [sym_conditional] = STATE(9306),
    [sym_range] = STATE(9306),
    [sym_binary] = STATE(9306),
    [sym_unary] = STATE(9306),
    [sym_left_assignment_list] = STATE(5060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5061),
    [sym__variable] = STATE(5057),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5061),
    [sym_false] = STATE(5061),
    [sym_nil] = STATE(5061),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7485),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(7994),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7998),
    [anon_sym_yield] = ACTIONS(8000),
    [anon_sym_break] = ACTIONS(8002),
    [anon_sym_next] = ACTIONS(8004),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11019),
    [anon_sym_defined_QMARK] = ACTIONS(8006),
    [anon_sym_not] = ACTIONS(8008),
    [anon_sym_BANG] = ACTIONS(8012),
    [anon_sym_TILDE] = ACTIONS(8012),
    [sym_constant] = ACTIONS(8018),
    [sym_identifier] = ACTIONS(8018),
    [sym_instance_variable] = ACTIONS(8016),
    [sym_class_variable] = ACTIONS(8016),
    [sym_global_variable] = ACTIONS(8016),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8018),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8018),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7502] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9307),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5061),
    [sym_scope_resolution] = STATE(5057),
    [sym_call] = STATE(5057),
    [sym_method_call] = STATE(5061),
    [sym_assignment] = STATE(9307),
    [sym_operator_assignment] = STATE(9307),
    [sym_conditional] = STATE(9307),
    [sym_range] = STATE(9307),
    [sym_binary] = STATE(9307),
    [sym_unary] = STATE(9307),
    [sym_left_assignment_list] = STATE(5060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5061),
    [sym__variable] = STATE(5057),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5061),
    [sym_false] = STATE(5061),
    [sym_nil] = STATE(5061),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7485),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(7994),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7998),
    [anon_sym_yield] = ACTIONS(8000),
    [anon_sym_break] = ACTIONS(8002),
    [anon_sym_next] = ACTIONS(8004),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11019),
    [anon_sym_defined_QMARK] = ACTIONS(8006),
    [anon_sym_not] = ACTIONS(8008),
    [anon_sym_BANG] = ACTIONS(8012),
    [anon_sym_TILDE] = ACTIONS(8012),
    [sym_constant] = ACTIONS(8018),
    [sym_identifier] = ACTIONS(8018),
    [sym_instance_variable] = ACTIONS(8016),
    [sym_class_variable] = ACTIONS(8016),
    [sym_global_variable] = ACTIONS(8016),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8018),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8018),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7503] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9308),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5061),
    [sym_scope_resolution] = STATE(5057),
    [sym_call] = STATE(5057),
    [sym_method_call] = STATE(5061),
    [sym_assignment] = STATE(9308),
    [sym_operator_assignment] = STATE(9308),
    [sym_conditional] = STATE(9308),
    [sym_range] = STATE(9308),
    [sym_binary] = STATE(9308),
    [sym_unary] = STATE(9308),
    [sym_left_assignment_list] = STATE(5060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5061),
    [sym__variable] = STATE(5057),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5061),
    [sym_false] = STATE(5061),
    [sym_nil] = STATE(5061),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7485),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(7994),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7998),
    [anon_sym_yield] = ACTIONS(8000),
    [anon_sym_break] = ACTIONS(8002),
    [anon_sym_next] = ACTIONS(8004),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11019),
    [anon_sym_defined_QMARK] = ACTIONS(8006),
    [anon_sym_not] = ACTIONS(8008),
    [anon_sym_BANG] = ACTIONS(8012),
    [anon_sym_TILDE] = ACTIONS(8012),
    [sym_constant] = ACTIONS(8018),
    [sym_identifier] = ACTIONS(8018),
    [sym_instance_variable] = ACTIONS(8016),
    [sym_class_variable] = ACTIONS(8016),
    [sym_global_variable] = ACTIONS(8016),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8018),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8018),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7504] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(9309),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(9309),
    [sym_operator_assignment] = STATE(9309),
    [sym_conditional] = STATE(9309),
    [sym_range] = STATE(9309),
    [sym_binary] = STATE(9309),
    [sym_unary] = STATE(9309),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [7505] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9310),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5061),
    [sym_scope_resolution] = STATE(5057),
    [sym_call] = STATE(5057),
    [sym_method_call] = STATE(5061),
    [sym_assignment] = STATE(9310),
    [sym_operator_assignment] = STATE(9310),
    [sym_conditional] = STATE(9310),
    [sym_range] = STATE(9310),
    [sym_binary] = STATE(9310),
    [sym_unary] = STATE(9310),
    [sym_left_assignment_list] = STATE(5060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5061),
    [sym__variable] = STATE(5057),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5061),
    [sym_false] = STATE(5061),
    [sym_nil] = STATE(5061),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7485),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(7994),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7998),
    [anon_sym_yield] = ACTIONS(8000),
    [anon_sym_break] = ACTIONS(8002),
    [anon_sym_next] = ACTIONS(8004),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11019),
    [anon_sym_defined_QMARK] = ACTIONS(8006),
    [anon_sym_not] = ACTIONS(8008),
    [anon_sym_BANG] = ACTIONS(8012),
    [anon_sym_TILDE] = ACTIONS(8012),
    [sym_constant] = ACTIONS(8018),
    [sym_identifier] = ACTIONS(8018),
    [sym_instance_variable] = ACTIONS(8016),
    [sym_class_variable] = ACTIONS(8016),
    [sym_global_variable] = ACTIONS(8016),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8018),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8018),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7506] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9311),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5061),
    [sym_scope_resolution] = STATE(5057),
    [sym_call] = STATE(5057),
    [sym_method_call] = STATE(5061),
    [sym_assignment] = STATE(9311),
    [sym_operator_assignment] = STATE(9311),
    [sym_conditional] = STATE(9311),
    [sym_range] = STATE(9311),
    [sym_binary] = STATE(9311),
    [sym_unary] = STATE(9311),
    [sym_left_assignment_list] = STATE(5060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5061),
    [sym__variable] = STATE(5057),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5061),
    [sym_false] = STATE(5061),
    [sym_nil] = STATE(5061),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7485),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(7994),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7998),
    [anon_sym_yield] = ACTIONS(8000),
    [anon_sym_break] = ACTIONS(8002),
    [anon_sym_next] = ACTIONS(8004),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11019),
    [anon_sym_defined_QMARK] = ACTIONS(8006),
    [anon_sym_not] = ACTIONS(8008),
    [anon_sym_BANG] = ACTIONS(8012),
    [anon_sym_TILDE] = ACTIONS(8012),
    [sym_constant] = ACTIONS(8018),
    [sym_identifier] = ACTIONS(8018),
    [sym_instance_variable] = ACTIONS(8016),
    [sym_class_variable] = ACTIONS(8016),
    [sym_global_variable] = ACTIONS(8016),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8018),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8018),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7507] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9312),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5061),
    [sym_scope_resolution] = STATE(5057),
    [sym_call] = STATE(5057),
    [sym_method_call] = STATE(5061),
    [sym_assignment] = STATE(9312),
    [sym_operator_assignment] = STATE(9312),
    [sym_conditional] = STATE(9312),
    [sym_range] = STATE(9312),
    [sym_binary] = STATE(9312),
    [sym_unary] = STATE(9312),
    [sym_left_assignment_list] = STATE(5060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5061),
    [sym__variable] = STATE(5057),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5061),
    [sym_false] = STATE(5061),
    [sym_nil] = STATE(5061),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7485),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(7994),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7998),
    [anon_sym_yield] = ACTIONS(8000),
    [anon_sym_break] = ACTIONS(8002),
    [anon_sym_next] = ACTIONS(8004),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11019),
    [anon_sym_defined_QMARK] = ACTIONS(8006),
    [anon_sym_not] = ACTIONS(8008),
    [anon_sym_BANG] = ACTIONS(8012),
    [anon_sym_TILDE] = ACTIONS(8012),
    [sym_constant] = ACTIONS(8018),
    [sym_identifier] = ACTIONS(8018),
    [sym_instance_variable] = ACTIONS(8016),
    [sym_class_variable] = ACTIONS(8016),
    [sym_global_variable] = ACTIONS(8016),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8018),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8018),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7508] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9313),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5061),
    [sym_scope_resolution] = STATE(5057),
    [sym_call] = STATE(5057),
    [sym_method_call] = STATE(5061),
    [sym_assignment] = STATE(9313),
    [sym_operator_assignment] = STATE(9313),
    [sym_conditional] = STATE(9313),
    [sym_range] = STATE(9313),
    [sym_binary] = STATE(9313),
    [sym_unary] = STATE(9313),
    [sym_left_assignment_list] = STATE(5060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5061),
    [sym__variable] = STATE(5057),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5061),
    [sym_false] = STATE(5061),
    [sym_nil] = STATE(5061),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7485),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(7994),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7998),
    [anon_sym_yield] = ACTIONS(8000),
    [anon_sym_break] = ACTIONS(8002),
    [anon_sym_next] = ACTIONS(8004),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11019),
    [anon_sym_defined_QMARK] = ACTIONS(8006),
    [anon_sym_not] = ACTIONS(8008),
    [anon_sym_BANG] = ACTIONS(8012),
    [anon_sym_TILDE] = ACTIONS(8012),
    [sym_constant] = ACTIONS(8018),
    [sym_identifier] = ACTIONS(8018),
    [sym_instance_variable] = ACTIONS(8016),
    [sym_class_variable] = ACTIONS(8016),
    [sym_global_variable] = ACTIONS(8016),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8018),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8018),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7509] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(9314),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5097),
    [sym_scope_resolution] = STATE(5093),
    [sym_call] = STATE(5093),
    [sym_method_call] = STATE(5097),
    [sym_assignment] = STATE(9314),
    [sym_operator_assignment] = STATE(9314),
    [sym_conditional] = STATE(9314),
    [sym_range] = STATE(9314),
    [sym_binary] = STATE(9314),
    [sym_unary] = STATE(9314),
    [sym_left_assignment_list] = STATE(5096),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5097),
    [sym__variable] = STATE(5093),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5097),
    [sym_false] = STATE(5097),
    [sym_nil] = STATE(5097),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7554),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(8066),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(8070),
    [anon_sym_yield] = ACTIONS(8072),
    [anon_sym_break] = ACTIONS(8074),
    [anon_sym_next] = ACTIONS(8076),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(11099),
    [anon_sym_defined_QMARK] = ACTIONS(8078),
    [anon_sym_not] = ACTIONS(8080),
    [anon_sym_BANG] = ACTIONS(8084),
    [anon_sym_TILDE] = ACTIONS(8084),
    [sym_constant] = ACTIONS(8090),
    [sym_identifier] = ACTIONS(8090),
    [sym_instance_variable] = ACTIONS(8088),
    [sym_class_variable] = ACTIONS(8088),
    [sym_global_variable] = ACTIONS(8088),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8090),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8090),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7510] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(9315),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5097),
    [sym_scope_resolution] = STATE(5093),
    [sym_call] = STATE(5093),
    [sym_method_call] = STATE(5097),
    [sym_assignment] = STATE(9315),
    [sym_operator_assignment] = STATE(9315),
    [sym_conditional] = STATE(9315),
    [sym_range] = STATE(9315),
    [sym_binary] = STATE(9315),
    [sym_unary] = STATE(9315),
    [sym_left_assignment_list] = STATE(5096),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5097),
    [sym__variable] = STATE(5093),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5097),
    [sym_false] = STATE(5097),
    [sym_nil] = STATE(5097),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7554),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(8066),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(8070),
    [anon_sym_yield] = ACTIONS(8072),
    [anon_sym_break] = ACTIONS(8074),
    [anon_sym_next] = ACTIONS(8076),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(11099),
    [anon_sym_defined_QMARK] = ACTIONS(8078),
    [anon_sym_not] = ACTIONS(8080),
    [anon_sym_BANG] = ACTIONS(8084),
    [anon_sym_TILDE] = ACTIONS(8084),
    [sym_constant] = ACTIONS(8090),
    [sym_identifier] = ACTIONS(8090),
    [sym_instance_variable] = ACTIONS(8088),
    [sym_class_variable] = ACTIONS(8088),
    [sym_global_variable] = ACTIONS(8088),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8090),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8090),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7511] = {
    [anon_sym_COLON] = ACTIONS(12938),
    [sym_comment] = ACTIONS(87),
  },
  [7512] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(9317),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5097),
    [sym_scope_resolution] = STATE(5093),
    [sym_call] = STATE(5093),
    [sym_method_call] = STATE(5097),
    [sym_assignment] = STATE(9317),
    [sym_operator_assignment] = STATE(9317),
    [sym_conditional] = STATE(9317),
    [sym_range] = STATE(9317),
    [sym_binary] = STATE(9317),
    [sym_unary] = STATE(9317),
    [sym_left_assignment_list] = STATE(5096),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5097),
    [sym__variable] = STATE(5093),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5097),
    [sym_false] = STATE(5097),
    [sym_nil] = STATE(5097),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7554),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(8066),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(8070),
    [anon_sym_yield] = ACTIONS(8072),
    [anon_sym_break] = ACTIONS(8074),
    [anon_sym_next] = ACTIONS(8076),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(11099),
    [anon_sym_defined_QMARK] = ACTIONS(8078),
    [anon_sym_not] = ACTIONS(8080),
    [anon_sym_BANG] = ACTIONS(8084),
    [anon_sym_TILDE] = ACTIONS(8084),
    [sym_constant] = ACTIONS(8090),
    [sym_identifier] = ACTIONS(8090),
    [sym_instance_variable] = ACTIONS(8088),
    [sym_class_variable] = ACTIONS(8088),
    [sym_global_variable] = ACTIONS(8088),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8090),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8090),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7513] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(12940),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_elsif] = ACTIONS(1091),
    [anon_sym_else] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [7514] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(11105),
    [sym__binary_star] = ACTIONS(11107),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(11109),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(11111),
    [anon_sym_AMP] = ACTIONS(11113),
    [anon_sym_EQ] = ACTIONS(1631),
    [anon_sym_LT] = ACTIONS(11115),
    [anon_sym_end] = ACTIONS(1625),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_unless] = ACTIONS(1625),
    [anon_sym_while] = ACTIONS(1625),
    [anon_sym_until] = ACTIONS(1625),
    [anon_sym_rescue] = ACTIONS(1625),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_elsif] = ACTIONS(1625),
    [anon_sym_else] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(1625),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_PLUS_EQ] = ACTIONS(1625),
    [anon_sym_DASH_EQ] = ACTIONS(1625),
    [anon_sym_STAR_EQ] = ACTIONS(1625),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1625),
    [anon_sym_SLASH_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1625),
    [anon_sym_AMP_EQ] = ACTIONS(1625),
    [anon_sym_PERCENT_EQ] = ACTIONS(1625),
    [anon_sym_GT_GT_EQ] = ACTIONS(1625),
    [anon_sym_LT_LT_EQ] = ACTIONS(1625),
    [anon_sym_CARET_EQ] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(11117),
    [anon_sym_DOT_DOT] = ACTIONS(11119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11121),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(11123),
    [anon_sym_AMP_AMP] = ACTIONS(11123),
    [anon_sym_LT_LT] = ACTIONS(11125),
    [anon_sym_GT_GT] = ACTIONS(11125),
    [anon_sym_EQ_EQ] = ACTIONS(11123),
    [anon_sym_BANG_EQ] = ACTIONS(11127),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11127),
    [anon_sym_LT_EQ_GT] = ACTIONS(11127),
    [anon_sym_EQ_TILDE] = ACTIONS(11127),
    [anon_sym_BANG_TILDE] = ACTIONS(11127),
    [anon_sym_LT_EQ] = ACTIONS(11115),
    [anon_sym_GT] = ACTIONS(11115),
    [anon_sym_GT_EQ] = ACTIONS(11129),
    [anon_sym_CARET] = ACTIONS(11109),
    [anon_sym_PLUS] = ACTIONS(11131),
    [anon_sym_SLASH] = ACTIONS(11111),
    [anon_sym_PERCENT] = ACTIONS(11111),
    [sym_comment] = ACTIONS(87),
  },
  [7515] = {
    [sym_heredoc_body] = STATE(9319),
    [aux_sym_call_repeat1] = STATE(9319),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_elsif] = ACTIONS(1681),
    [anon_sym_else] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [7516] = {
    [sym_heredoc_body] = STATE(9319),
    [aux_sym_call_repeat1] = STATE(9319),
    [aux_sym_argument_list_repeat1] = STATE(9321),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(12942),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_elsif] = ACTIONS(1681),
    [anon_sym_else] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [7517] = {
    [sym_string] = STATE(7574),
    [aux_sym_chained_string_repeat1] = STATE(7574),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(747),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(12944),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_elsif] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [7518] = {
    [sym_heredoc_body] = STATE(9322),
    [aux_sym_call_repeat1] = STATE(9322),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_elsif] = ACTIONS(4383),
    [anon_sym_else] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [7519] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5056),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5061),
    [sym_scope_resolution] = STATE(5057),
    [sym_call] = STATE(5057),
    [sym_method_call] = STATE(5061),
    [sym__argument] = STATE(2565),
    [sym_splat_argument] = STATE(2565),
    [sym_hash_splat_argument] = STATE(2565),
    [sym_block_argument] = STATE(2565),
    [sym_assignment] = STATE(5056),
    [sym_operator_assignment] = STATE(5056),
    [sym_conditional] = STATE(5056),
    [sym_range] = STATE(5056),
    [sym_binary] = STATE(5056),
    [sym_unary] = STATE(5056),
    [sym_left_assignment_list] = STATE(5060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5061),
    [sym__variable] = STATE(5057),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5061),
    [sym_false] = STATE(5061),
    [sym_nil] = STATE(5061),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5062),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(9323),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2565),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(7990),
    [sym__splat_star] = ACTIONS(7992),
    [sym__unary_minus] = ACTIONS(7994),
    [sym__identifier_hash_key] = ACTIONS(7996),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12946),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7998),
    [anon_sym_yield] = ACTIONS(8000),
    [anon_sym_break] = ACTIONS(8002),
    [anon_sym_next] = ACTIONS(8004),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11019),
    [anon_sym_defined_QMARK] = ACTIONS(8006),
    [anon_sym_not] = ACTIONS(8008),
    [anon_sym_BANG] = ACTIONS(8012),
    [anon_sym_TILDE] = ACTIONS(8012),
    [sym_constant] = ACTIONS(8014),
    [sym_identifier] = ACTIONS(8014),
    [sym_instance_variable] = ACTIONS(8016),
    [sym_class_variable] = ACTIONS(8016),
    [sym_global_variable] = ACTIONS(8016),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8018),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8018),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7520] = {
    [sym_heredoc_body] = STATE(9324),
    [aux_sym_call_repeat1] = STATE(9324),
    [aux_sym_argument_list_repeat1] = STATE(9325),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(11067),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_elsif] = ACTIONS(4383),
    [anon_sym_else] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [7521] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9326),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5061),
    [sym_scope_resolution] = STATE(5057),
    [sym_call] = STATE(5057),
    [sym_method_call] = STATE(5061),
    [sym_splat_argument] = STATE(9327),
    [sym_assignment] = STATE(9326),
    [sym_operator_assignment] = STATE(9326),
    [sym_conditional] = STATE(9326),
    [sym_range] = STATE(9326),
    [sym_binary] = STATE(9326),
    [sym_unary] = STATE(9326),
    [sym_right_assignment_list] = STATE(2570),
    [sym__arg_or_splat_arg] = STATE(9327),
    [sym_left_assignment_list] = STATE(5060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5061),
    [sym__variable] = STATE(5057),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5061),
    [sym_false] = STATE(5061),
    [sym_nil] = STATE(5061),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7485),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__splat_star] = ACTIONS(11025),
    [sym__unary_minus] = ACTIONS(7994),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7998),
    [anon_sym_yield] = ACTIONS(8000),
    [anon_sym_break] = ACTIONS(8002),
    [anon_sym_next] = ACTIONS(8004),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11019),
    [anon_sym_defined_QMARK] = ACTIONS(8006),
    [anon_sym_not] = ACTIONS(8008),
    [anon_sym_BANG] = ACTIONS(8012),
    [anon_sym_TILDE] = ACTIONS(8012),
    [sym_constant] = ACTIONS(8018),
    [sym_identifier] = ACTIONS(8018),
    [sym_instance_variable] = ACTIONS(8016),
    [sym_class_variable] = ACTIONS(8016),
    [sym_global_variable] = ACTIONS(8016),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8018),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8018),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7522] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9328),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5061),
    [sym_scope_resolution] = STATE(5057),
    [sym_call] = STATE(5057),
    [sym_method_call] = STATE(5061),
    [sym_assignment] = STATE(9328),
    [sym_operator_assignment] = STATE(9328),
    [sym_conditional] = STATE(9328),
    [sym_range] = STATE(9328),
    [sym_binary] = STATE(9328),
    [sym_unary] = STATE(9328),
    [sym_left_assignment_list] = STATE(5060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5061),
    [sym__variable] = STATE(5057),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5061),
    [sym_false] = STATE(5061),
    [sym_nil] = STATE(5061),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7485),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(7994),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7998),
    [anon_sym_yield] = ACTIONS(8000),
    [anon_sym_break] = ACTIONS(8002),
    [anon_sym_next] = ACTIONS(8004),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11019),
    [anon_sym_defined_QMARK] = ACTIONS(8006),
    [anon_sym_not] = ACTIONS(8008),
    [anon_sym_BANG] = ACTIONS(8012),
    [anon_sym_TILDE] = ACTIONS(8012),
    [sym_constant] = ACTIONS(8018),
    [sym_identifier] = ACTIONS(8018),
    [sym_instance_variable] = ACTIONS(8016),
    [sym_class_variable] = ACTIONS(8016),
    [sym_global_variable] = ACTIONS(8016),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8018),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8018),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7523] = {
    [sym_string] = STATE(9329),
    [aux_sym_chained_string_repeat1] = STATE(9329),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_end] = ACTIONS(2753),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_elsif] = ACTIONS(2753),
    [anon_sym_else] = ACTIONS(2753),
    [anon_sym_EQ_GT] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [7524] = {
    [aux_sym_undef_repeat1] = STATE(9330),
    [sym__line_break] = ACTIONS(5497),
    [sym__heredoc_body_start] = ACTIONS(5497),
    [anon_sym_COMMA] = ACTIONS(2253),
    [anon_sym_SEMI] = ACTIONS(5497),
    [anon_sym_end] = ACTIONS(5497),
    [anon_sym_if] = ACTIONS(5497),
    [anon_sym_unless] = ACTIONS(5497),
    [anon_sym_while] = ACTIONS(5497),
    [anon_sym_until] = ACTIONS(5497),
    [anon_sym_rescue] = ACTIONS(5497),
    [anon_sym_elsif] = ACTIONS(5497),
    [anon_sym_else] = ACTIONS(5497),
    [sym_comment] = ACTIONS(87),
  },
  [7525] = {
    [sym__line_break] = ACTIONS(5815),
    [sym__heredoc_body_start] = ACTIONS(5815),
    [sym__binary_minus] = ACTIONS(8034),
    [sym__binary_star] = ACTIONS(8036),
    [anon_sym_PIPE] = ACTIONS(8038),
    [anon_sym_SEMI] = ACTIONS(5815),
    [anon_sym_STAR_STAR] = ACTIONS(8036),
    [anon_sym_AMP] = ACTIONS(8040),
    [anon_sym_LT] = ACTIONS(8042),
    [anon_sym_end] = ACTIONS(5815),
    [anon_sym_if] = ACTIONS(5815),
    [anon_sym_unless] = ACTIONS(5815),
    [anon_sym_while] = ACTIONS(5815),
    [anon_sym_until] = ACTIONS(5815),
    [anon_sym_rescue] = ACTIONS(5815),
    [anon_sym_elsif] = ACTIONS(5815),
    [anon_sym_else] = ACTIONS(5815),
    [anon_sym_QMARK] = ACTIONS(8044),
    [anon_sym_DOT_DOT] = ACTIONS(8046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8048),
    [anon_sym_and] = ACTIONS(8050),
    [anon_sym_or] = ACTIONS(8050),
    [anon_sym_PIPE_PIPE] = ACTIONS(8052),
    [anon_sym_AMP_AMP] = ACTIONS(8052),
    [anon_sym_LT_LT] = ACTIONS(8054),
    [anon_sym_GT_GT] = ACTIONS(8054),
    [anon_sym_EQ_EQ] = ACTIONS(8056),
    [anon_sym_BANG_EQ] = ACTIONS(8052),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8052),
    [anon_sym_LT_EQ_GT] = ACTIONS(8052),
    [anon_sym_EQ_TILDE] = ACTIONS(8052),
    [anon_sym_BANG_TILDE] = ACTIONS(8052),
    [anon_sym_LT_EQ] = ACTIONS(8042),
    [anon_sym_GT] = ACTIONS(8042),
    [anon_sym_GT_EQ] = ACTIONS(8058),
    [anon_sym_CARET] = ACTIONS(8060),
    [anon_sym_PLUS] = ACTIONS(8034),
    [anon_sym_SLASH] = ACTIONS(8036),
    [anon_sym_PERCENT] = ACTIONS(8036),
    [sym_comment] = ACTIONS(87),
  },
  [7526] = {
    [sym__line_break] = ACTIONS(5817),
    [sym__heredoc_body_start] = ACTIONS(5817),
    [sym__binary_minus] = ACTIONS(8034),
    [sym__binary_star] = ACTIONS(8036),
    [anon_sym_PIPE] = ACTIONS(8038),
    [anon_sym_SEMI] = ACTIONS(5817),
    [anon_sym_STAR_STAR] = ACTIONS(8036),
    [anon_sym_AMP] = ACTIONS(8040),
    [anon_sym_LT] = ACTIONS(8042),
    [anon_sym_end] = ACTIONS(5817),
    [anon_sym_if] = ACTIONS(5817),
    [anon_sym_unless] = ACTIONS(5817),
    [anon_sym_while] = ACTIONS(5817),
    [anon_sym_until] = ACTIONS(5817),
    [anon_sym_rescue] = ACTIONS(5817),
    [anon_sym_elsif] = ACTIONS(5817),
    [anon_sym_else] = ACTIONS(5817),
    [anon_sym_QMARK] = ACTIONS(8044),
    [anon_sym_DOT_DOT] = ACTIONS(8046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8048),
    [anon_sym_and] = ACTIONS(8050),
    [anon_sym_or] = ACTIONS(8050),
    [anon_sym_PIPE_PIPE] = ACTIONS(8052),
    [anon_sym_AMP_AMP] = ACTIONS(8052),
    [anon_sym_LT_LT] = ACTIONS(8054),
    [anon_sym_GT_GT] = ACTIONS(8054),
    [anon_sym_EQ_EQ] = ACTIONS(8056),
    [anon_sym_BANG_EQ] = ACTIONS(8052),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8052),
    [anon_sym_LT_EQ_GT] = ACTIONS(8052),
    [anon_sym_EQ_TILDE] = ACTIONS(8052),
    [anon_sym_BANG_TILDE] = ACTIONS(8052),
    [anon_sym_LT_EQ] = ACTIONS(8042),
    [anon_sym_GT] = ACTIONS(8042),
    [anon_sym_GT_EQ] = ACTIONS(8058),
    [anon_sym_CARET] = ACTIONS(8060),
    [anon_sym_PLUS] = ACTIONS(8034),
    [anon_sym_SLASH] = ACTIONS(8036),
    [anon_sym_PERCENT] = ACTIONS(8036),
    [sym_comment] = ACTIONS(87),
  },
  [7527] = {
    [sym__line_break] = ACTIONS(5819),
    [sym__heredoc_body_start] = ACTIONS(5819),
    [sym__binary_minus] = ACTIONS(8034),
    [sym__binary_star] = ACTIONS(8036),
    [anon_sym_PIPE] = ACTIONS(8038),
    [anon_sym_SEMI] = ACTIONS(5819),
    [anon_sym_STAR_STAR] = ACTIONS(8036),
    [anon_sym_AMP] = ACTIONS(8040),
    [anon_sym_LT] = ACTIONS(8042),
    [anon_sym_end] = ACTIONS(5819),
    [anon_sym_if] = ACTIONS(5819),
    [anon_sym_unless] = ACTIONS(5819),
    [anon_sym_while] = ACTIONS(5819),
    [anon_sym_until] = ACTIONS(5819),
    [anon_sym_rescue] = ACTIONS(5819),
    [anon_sym_elsif] = ACTIONS(5819),
    [anon_sym_else] = ACTIONS(5819),
    [anon_sym_QMARK] = ACTIONS(8044),
    [anon_sym_DOT_DOT] = ACTIONS(8046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8048),
    [anon_sym_and] = ACTIONS(8050),
    [anon_sym_or] = ACTIONS(8050),
    [anon_sym_PIPE_PIPE] = ACTIONS(8052),
    [anon_sym_AMP_AMP] = ACTIONS(8052),
    [anon_sym_LT_LT] = ACTIONS(8054),
    [anon_sym_GT_GT] = ACTIONS(8054),
    [anon_sym_EQ_EQ] = ACTIONS(8056),
    [anon_sym_BANG_EQ] = ACTIONS(8052),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8052),
    [anon_sym_LT_EQ_GT] = ACTIONS(8052),
    [anon_sym_EQ_TILDE] = ACTIONS(8052),
    [anon_sym_BANG_TILDE] = ACTIONS(8052),
    [anon_sym_LT_EQ] = ACTIONS(8042),
    [anon_sym_GT] = ACTIONS(8042),
    [anon_sym_GT_EQ] = ACTIONS(8058),
    [anon_sym_CARET] = ACTIONS(8060),
    [anon_sym_PLUS] = ACTIONS(8034),
    [anon_sym_SLASH] = ACTIONS(8036),
    [anon_sym_PERCENT] = ACTIONS(8036),
    [sym_comment] = ACTIONS(87),
  },
  [7528] = {
    [sym__line_break] = ACTIONS(5821),
    [sym__heredoc_body_start] = ACTIONS(5821),
    [sym__binary_minus] = ACTIONS(8034),
    [sym__binary_star] = ACTIONS(8036),
    [anon_sym_PIPE] = ACTIONS(8038),
    [anon_sym_SEMI] = ACTIONS(5821),
    [anon_sym_STAR_STAR] = ACTIONS(8036),
    [anon_sym_AMP] = ACTIONS(8040),
    [anon_sym_LT] = ACTIONS(8042),
    [anon_sym_end] = ACTIONS(5821),
    [anon_sym_if] = ACTIONS(5821),
    [anon_sym_unless] = ACTIONS(5821),
    [anon_sym_while] = ACTIONS(5821),
    [anon_sym_until] = ACTIONS(5821),
    [anon_sym_rescue] = ACTIONS(5821),
    [anon_sym_elsif] = ACTIONS(5821),
    [anon_sym_else] = ACTIONS(5821),
    [anon_sym_QMARK] = ACTIONS(8044),
    [anon_sym_DOT_DOT] = ACTIONS(8046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8048),
    [anon_sym_and] = ACTIONS(8050),
    [anon_sym_or] = ACTIONS(8050),
    [anon_sym_PIPE_PIPE] = ACTIONS(8052),
    [anon_sym_AMP_AMP] = ACTIONS(8052),
    [anon_sym_LT_LT] = ACTIONS(8054),
    [anon_sym_GT_GT] = ACTIONS(8054),
    [anon_sym_EQ_EQ] = ACTIONS(8056),
    [anon_sym_BANG_EQ] = ACTIONS(8052),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8052),
    [anon_sym_LT_EQ_GT] = ACTIONS(8052),
    [anon_sym_EQ_TILDE] = ACTIONS(8052),
    [anon_sym_BANG_TILDE] = ACTIONS(8052),
    [anon_sym_LT_EQ] = ACTIONS(8042),
    [anon_sym_GT] = ACTIONS(8042),
    [anon_sym_GT_EQ] = ACTIONS(8058),
    [anon_sym_CARET] = ACTIONS(8060),
    [anon_sym_PLUS] = ACTIONS(8034),
    [anon_sym_SLASH] = ACTIONS(8036),
    [anon_sym_PERCENT] = ACTIONS(8036),
    [sym_comment] = ACTIONS(87),
  },
  [7529] = {
    [sym__line_break] = ACTIONS(5823),
    [sym__heredoc_body_start] = ACTIONS(5823),
    [sym__binary_minus] = ACTIONS(8034),
    [sym__binary_star] = ACTIONS(8036),
    [anon_sym_PIPE] = ACTIONS(8038),
    [anon_sym_SEMI] = ACTIONS(5823),
    [anon_sym_STAR_STAR] = ACTIONS(8036),
    [anon_sym_AMP] = ACTIONS(8040),
    [anon_sym_LT] = ACTIONS(8042),
    [anon_sym_end] = ACTIONS(5823),
    [anon_sym_if] = ACTIONS(5823),
    [anon_sym_unless] = ACTIONS(5823),
    [anon_sym_while] = ACTIONS(5823),
    [anon_sym_until] = ACTIONS(5823),
    [anon_sym_rescue] = ACTIONS(5823),
    [anon_sym_elsif] = ACTIONS(5823),
    [anon_sym_else] = ACTIONS(5823),
    [anon_sym_QMARK] = ACTIONS(8044),
    [anon_sym_DOT_DOT] = ACTIONS(8046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8048),
    [anon_sym_and] = ACTIONS(8050),
    [anon_sym_or] = ACTIONS(8050),
    [anon_sym_PIPE_PIPE] = ACTIONS(8052),
    [anon_sym_AMP_AMP] = ACTIONS(8052),
    [anon_sym_LT_LT] = ACTIONS(8054),
    [anon_sym_GT_GT] = ACTIONS(8054),
    [anon_sym_EQ_EQ] = ACTIONS(8056),
    [anon_sym_BANG_EQ] = ACTIONS(8052),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8052),
    [anon_sym_LT_EQ_GT] = ACTIONS(8052),
    [anon_sym_EQ_TILDE] = ACTIONS(8052),
    [anon_sym_BANG_TILDE] = ACTIONS(8052),
    [anon_sym_LT_EQ] = ACTIONS(8042),
    [anon_sym_GT] = ACTIONS(8042),
    [anon_sym_GT_EQ] = ACTIONS(8058),
    [anon_sym_CARET] = ACTIONS(8060),
    [anon_sym_PLUS] = ACTIONS(8034),
    [anon_sym_SLASH] = ACTIONS(8036),
    [anon_sym_PERCENT] = ACTIONS(8036),
    [sym_comment] = ACTIONS(87),
  },
  [7530] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(8036),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8036),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_elsif] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(8036),
    [anon_sym_PERCENT] = ACTIONS(8036),
    [sym_comment] = ACTIONS(87),
  },
  [7531] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8036),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_elsif] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [7532] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8034),
    [sym__binary_star] = ACTIONS(8036),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8036),
    [anon_sym_AMP] = ACTIONS(8040),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_elsif] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(8054),
    [anon_sym_GT_GT] = ACTIONS(8054),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(8034),
    [anon_sym_SLASH] = ACTIONS(8036),
    [anon_sym_PERCENT] = ACTIONS(8036),
    [sym_comment] = ACTIONS(87),
  },
  [7533] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8034),
    [sym__binary_star] = ACTIONS(8036),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8036),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_elsif] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(8054),
    [anon_sym_GT_GT] = ACTIONS(8054),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(8034),
    [anon_sym_SLASH] = ACTIONS(8036),
    [anon_sym_PERCENT] = ACTIONS(8036),
    [sym_comment] = ACTIONS(87),
  },
  [7534] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8034),
    [sym__binary_star] = ACTIONS(8036),
    [anon_sym_PIPE] = ACTIONS(8038),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8036),
    [anon_sym_AMP] = ACTIONS(8040),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_elsif] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(8054),
    [anon_sym_GT_GT] = ACTIONS(8054),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(8060),
    [anon_sym_PLUS] = ACTIONS(8034),
    [anon_sym_SLASH] = ACTIONS(8036),
    [anon_sym_PERCENT] = ACTIONS(8036),
    [sym_comment] = ACTIONS(87),
  },
  [7535] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(12948),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [7536] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(8034),
    [sym__binary_star] = ACTIONS(8036),
    [anon_sym_PIPE] = ACTIONS(8038),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(8036),
    [anon_sym_AMP] = ACTIONS(8040),
    [anon_sym_LT] = ACTIONS(8042),
    [anon_sym_end] = ACTIONS(5927),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_elsif] = ACTIONS(5927),
    [anon_sym_else] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(8046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8048),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(8052),
    [anon_sym_AMP_AMP] = ACTIONS(8052),
    [anon_sym_LT_LT] = ACTIONS(8054),
    [anon_sym_GT_GT] = ACTIONS(8054),
    [anon_sym_EQ_EQ] = ACTIONS(8056),
    [anon_sym_BANG_EQ] = ACTIONS(8052),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8052),
    [anon_sym_LT_EQ_GT] = ACTIONS(8052),
    [anon_sym_EQ_TILDE] = ACTIONS(8052),
    [anon_sym_BANG_TILDE] = ACTIONS(8052),
    [anon_sym_LT_EQ] = ACTIONS(8042),
    [anon_sym_GT] = ACTIONS(8042),
    [anon_sym_GT_EQ] = ACTIONS(8058),
    [anon_sym_CARET] = ACTIONS(8060),
    [anon_sym_PLUS] = ACTIONS(8034),
    [anon_sym_SLASH] = ACTIONS(8036),
    [anon_sym_PERCENT] = ACTIONS(8036),
    [sym_comment] = ACTIONS(87),
  },
  [7537] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8034),
    [sym__binary_star] = ACTIONS(8036),
    [anon_sym_PIPE] = ACTIONS(8038),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8036),
    [anon_sym_AMP] = ACTIONS(8040),
    [anon_sym_LT] = ACTIONS(8042),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_elsif] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(8044),
    [anon_sym_DOT_DOT] = ACTIONS(8046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8048),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(8052),
    [anon_sym_AMP_AMP] = ACTIONS(8052),
    [anon_sym_LT_LT] = ACTIONS(8054),
    [anon_sym_GT_GT] = ACTIONS(8054),
    [anon_sym_EQ_EQ] = ACTIONS(8056),
    [anon_sym_BANG_EQ] = ACTIONS(8052),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8052),
    [anon_sym_LT_EQ_GT] = ACTIONS(8052),
    [anon_sym_EQ_TILDE] = ACTIONS(8052),
    [anon_sym_BANG_TILDE] = ACTIONS(8052),
    [anon_sym_LT_EQ] = ACTIONS(8042),
    [anon_sym_GT] = ACTIONS(8042),
    [anon_sym_GT_EQ] = ACTIONS(8058),
    [anon_sym_CARET] = ACTIONS(8060),
    [anon_sym_PLUS] = ACTIONS(8034),
    [anon_sym_SLASH] = ACTIONS(8036),
    [anon_sym_PERCENT] = ACTIONS(8036),
    [sym_comment] = ACTIONS(87),
  },
  [7538] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8034),
    [sym__binary_star] = ACTIONS(8036),
    [anon_sym_PIPE] = ACTIONS(8038),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8036),
    [anon_sym_AMP] = ACTIONS(8040),
    [anon_sym_LT] = ACTIONS(8042),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_elsif] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(8054),
    [anon_sym_GT_GT] = ACTIONS(8054),
    [anon_sym_EQ_EQ] = ACTIONS(8056),
    [anon_sym_BANG_EQ] = ACTIONS(8052),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8052),
    [anon_sym_LT_EQ_GT] = ACTIONS(8052),
    [anon_sym_EQ_TILDE] = ACTIONS(8052),
    [anon_sym_BANG_TILDE] = ACTIONS(8052),
    [anon_sym_LT_EQ] = ACTIONS(8042),
    [anon_sym_GT] = ACTIONS(8042),
    [anon_sym_GT_EQ] = ACTIONS(8058),
    [anon_sym_CARET] = ACTIONS(8060),
    [anon_sym_PLUS] = ACTIONS(8034),
    [anon_sym_SLASH] = ACTIONS(8036),
    [anon_sym_PERCENT] = ACTIONS(8036),
    [sym_comment] = ACTIONS(87),
  },
  [7539] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8034),
    [sym__binary_star] = ACTIONS(8036),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8036),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_elsif] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(8034),
    [anon_sym_SLASH] = ACTIONS(8036),
    [anon_sym_PERCENT] = ACTIONS(8036),
    [sym_comment] = ACTIONS(87),
  },
  [7540] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(9332),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7550),
    [sym_scope_resolution] = STATE(7548),
    [sym_call] = STATE(7548),
    [sym_method_call] = STATE(7550),
    [sym_assignment] = STATE(9332),
    [sym_operator_assignment] = STATE(9332),
    [sym_conditional] = STATE(9332),
    [sym_range] = STATE(9332),
    [sym_binary] = STATE(9332),
    [sym_unary] = STATE(9332),
    [sym_left_assignment_list] = STATE(7549),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7550),
    [sym__variable] = STATE(7548),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7550),
    [sym_false] = STATE(7550),
    [sym_nil] = STATE(7550),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7551),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11077),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11079),
    [anon_sym_yield] = ACTIONS(11081),
    [anon_sym_break] = ACTIONS(11083),
    [anon_sym_next] = ACTIONS(11085),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11087),
    [anon_sym_defined_QMARK] = ACTIONS(11089),
    [anon_sym_not] = ACTIONS(11091),
    [anon_sym_BANG] = ACTIONS(11093),
    [anon_sym_TILDE] = ACTIONS(11093),
    [sym_constant] = ACTIONS(11095),
    [sym_identifier] = ACTIONS(11095),
    [sym_instance_variable] = ACTIONS(11097),
    [sym_class_variable] = ACTIONS(11097),
    [sym_global_variable] = ACTIONS(11097),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11095),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11095),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [7541] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5092),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5097),
    [sym_scope_resolution] = STATE(5093),
    [sym_call] = STATE(5093),
    [sym_method_call] = STATE(5097),
    [sym_argument_list] = STATE(3610),
    [sym__argument_list_with_parens] = STATE(5094),
    [sym__argument] = STATE(5095),
    [sym_splat_argument] = STATE(5095),
    [sym_hash_splat_argument] = STATE(5095),
    [sym_block_argument] = STATE(5095),
    [sym_assignment] = STATE(5092),
    [sym_operator_assignment] = STATE(5092),
    [sym_conditional] = STATE(5092),
    [sym_range] = STATE(5092),
    [sym_binary] = STATE(5092),
    [sym_unary] = STATE(5092),
    [sym_left_assignment_list] = STATE(5096),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5097),
    [sym__variable] = STATE(5093),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5097),
    [sym_false] = STATE(5097),
    [sym_nil] = STATE(5097),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5098),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(5095),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(8062),
    [sym__splat_star] = ACTIONS(8064),
    [sym__unary_minus] = ACTIONS(8066),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(8068),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(8070),
    [anon_sym_yield] = ACTIONS(8072),
    [anon_sym_break] = ACTIONS(8074),
    [anon_sym_next] = ACTIONS(8076),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_elsif] = ACTIONS(377),
    [anon_sym_else] = ACTIONS(377),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(365),
    [anon_sym_DASH_EQ] = ACTIONS(365),
    [anon_sym_STAR_EQ] = ACTIONS(365),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(365),
    [anon_sym_SLASH_EQ] = ACTIONS(365),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(365),
    [anon_sym_PIPE_EQ] = ACTIONS(365),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(365),
    [anon_sym_AMP_EQ] = ACTIONS(365),
    [anon_sym_PERCENT_EQ] = ACTIONS(365),
    [anon_sym_GT_GT_EQ] = ACTIONS(365),
    [anon_sym_LT_LT_EQ] = ACTIONS(365),
    [anon_sym_CARET_EQ] = ACTIONS(365),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_PERCENT] = ACTIONS(377),
    [anon_sym_defined_QMARK] = ACTIONS(8078),
    [anon_sym_not] = ACTIONS(8080),
    [anon_sym_BANG] = ACTIONS(8082),
    [anon_sym_TILDE] = ACTIONS(8084),
    [sym_constant] = ACTIONS(8086),
    [sym_identifier] = ACTIONS(8086),
    [sym_instance_variable] = ACTIONS(8088),
    [sym_class_variable] = ACTIONS(8088),
    [sym_global_variable] = ACTIONS(8088),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8090),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8090),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7542] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5092),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5097),
    [sym_scope_resolution] = STATE(5093),
    [sym_call] = STATE(5093),
    [sym_method_call] = STATE(5097),
    [sym_argument_list] = STATE(3611),
    [sym__argument_list_with_parens] = STATE(5094),
    [sym__argument] = STATE(5095),
    [sym_splat_argument] = STATE(5095),
    [sym_hash_splat_argument] = STATE(5095),
    [sym_block_argument] = STATE(5095),
    [sym_assignment] = STATE(5092),
    [sym_operator_assignment] = STATE(5092),
    [sym_conditional] = STATE(5092),
    [sym_range] = STATE(5092),
    [sym_binary] = STATE(5092),
    [sym_unary] = STATE(5092),
    [sym_left_assignment_list] = STATE(5096),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5097),
    [sym__variable] = STATE(5093),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5097),
    [sym_false] = STATE(5097),
    [sym_nil] = STATE(5097),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5098),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(5095),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(8062),
    [sym__splat_star] = ACTIONS(8064),
    [sym__unary_minus] = ACTIONS(8066),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(8068),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_EQ] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(8070),
    [anon_sym_yield] = ACTIONS(8072),
    [anon_sym_break] = ACTIONS(8074),
    [anon_sym_next] = ACTIONS(8076),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_elsif] = ACTIONS(419),
    [anon_sym_else] = ACTIONS(419),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(417),
    [anon_sym_DASH_EQ] = ACTIONS(417),
    [anon_sym_STAR_EQ] = ACTIONS(417),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(417),
    [anon_sym_SLASH_EQ] = ACTIONS(417),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(417),
    [anon_sym_PIPE_EQ] = ACTIONS(417),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(417),
    [anon_sym_AMP_EQ] = ACTIONS(417),
    [anon_sym_PERCENT_EQ] = ACTIONS(417),
    [anon_sym_GT_GT_EQ] = ACTIONS(417),
    [anon_sym_LT_LT_EQ] = ACTIONS(417),
    [anon_sym_CARET_EQ] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(8078),
    [anon_sym_not] = ACTIONS(8080),
    [anon_sym_BANG] = ACTIONS(8082),
    [anon_sym_TILDE] = ACTIONS(8084),
    [sym_constant] = ACTIONS(8086),
    [sym_identifier] = ACTIONS(8086),
    [sym_instance_variable] = ACTIONS(8088),
    [sym_class_variable] = ACTIONS(8088),
    [sym_global_variable] = ACTIONS(8088),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8090),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8090),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7543] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5092),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5097),
    [sym_scope_resolution] = STATE(5093),
    [sym_call] = STATE(5093),
    [sym_method_call] = STATE(5097),
    [sym_argument_list] = STATE(3612),
    [sym__argument_list_with_parens] = STATE(5094),
    [sym__argument] = STATE(5095),
    [sym_splat_argument] = STATE(5095),
    [sym_hash_splat_argument] = STATE(5095),
    [sym_block_argument] = STATE(5095),
    [sym_assignment] = STATE(5092),
    [sym_operator_assignment] = STATE(5092),
    [sym_conditional] = STATE(5092),
    [sym_range] = STATE(5092),
    [sym_binary] = STATE(5092),
    [sym_unary] = STATE(5092),
    [sym_left_assignment_list] = STATE(5096),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5097),
    [sym__variable] = STATE(5093),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5097),
    [sym_false] = STATE(5097),
    [sym_nil] = STATE(5097),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5098),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(5095),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(8062),
    [sym__splat_star] = ACTIONS(8064),
    [sym__unary_minus] = ACTIONS(8066),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(8068),
    [anon_sym_LBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_EQ] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(423),
    [anon_sym_return] = ACTIONS(8070),
    [anon_sym_yield] = ACTIONS(8072),
    [anon_sym_break] = ACTIONS(8074),
    [anon_sym_next] = ACTIONS(8076),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_elsif] = ACTIONS(423),
    [anon_sym_else] = ACTIONS(423),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(421),
    [anon_sym_DASH_EQ] = ACTIONS(421),
    [anon_sym_STAR_EQ] = ACTIONS(421),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(421),
    [anon_sym_SLASH_EQ] = ACTIONS(421),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(421),
    [anon_sym_PIPE_EQ] = ACTIONS(421),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(421),
    [anon_sym_AMP_EQ] = ACTIONS(421),
    [anon_sym_PERCENT_EQ] = ACTIONS(421),
    [anon_sym_GT_GT_EQ] = ACTIONS(421),
    [anon_sym_LT_LT_EQ] = ACTIONS(421),
    [anon_sym_CARET_EQ] = ACTIONS(421),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(8078),
    [anon_sym_not] = ACTIONS(8080),
    [anon_sym_BANG] = ACTIONS(8082),
    [anon_sym_TILDE] = ACTIONS(8084),
    [sym_constant] = ACTIONS(8086),
    [sym_identifier] = ACTIONS(8086),
    [sym_instance_variable] = ACTIONS(8088),
    [sym_class_variable] = ACTIONS(8088),
    [sym_global_variable] = ACTIONS(8088),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8090),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8090),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7544] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5092),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5097),
    [sym_scope_resolution] = STATE(5093),
    [sym_call] = STATE(5093),
    [sym_method_call] = STATE(5097),
    [sym_argument_list] = STATE(3613),
    [sym__argument_list_with_parens] = STATE(5094),
    [sym__argument] = STATE(5095),
    [sym_splat_argument] = STATE(5095),
    [sym_hash_splat_argument] = STATE(5095),
    [sym_block_argument] = STATE(5095),
    [sym_assignment] = STATE(5092),
    [sym_operator_assignment] = STATE(5092),
    [sym_conditional] = STATE(5092),
    [sym_range] = STATE(5092),
    [sym_binary] = STATE(5092),
    [sym_unary] = STATE(5092),
    [sym_left_assignment_list] = STATE(5096),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5097),
    [sym__variable] = STATE(5093),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5097),
    [sym_false] = STATE(5097),
    [sym_nil] = STATE(5097),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5098),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(5095),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(8062),
    [sym__splat_star] = ACTIONS(8064),
    [sym__unary_minus] = ACTIONS(8066),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(8068),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(427),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(427),
    [anon_sym_return] = ACTIONS(8070),
    [anon_sym_yield] = ACTIONS(8072),
    [anon_sym_break] = ACTIONS(8074),
    [anon_sym_next] = ACTIONS(8076),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_elsif] = ACTIONS(427),
    [anon_sym_else] = ACTIONS(427),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(425),
    [anon_sym_DASH_EQ] = ACTIONS(425),
    [anon_sym_STAR_EQ] = ACTIONS(425),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(425),
    [anon_sym_SLASH_EQ] = ACTIONS(425),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(425),
    [anon_sym_PIPE_EQ] = ACTIONS(425),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(425),
    [anon_sym_AMP_EQ] = ACTIONS(425),
    [anon_sym_PERCENT_EQ] = ACTIONS(425),
    [anon_sym_GT_GT_EQ] = ACTIONS(425),
    [anon_sym_LT_LT_EQ] = ACTIONS(425),
    [anon_sym_CARET_EQ] = ACTIONS(425),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(8078),
    [anon_sym_not] = ACTIONS(8080),
    [anon_sym_BANG] = ACTIONS(8082),
    [anon_sym_TILDE] = ACTIONS(8084),
    [sym_constant] = ACTIONS(8086),
    [sym_identifier] = ACTIONS(8086),
    [sym_instance_variable] = ACTIONS(8088),
    [sym_class_variable] = ACTIONS(8088),
    [sym_global_variable] = ACTIONS(8088),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8090),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8090),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7545] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(9333),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7550),
    [sym_scope_resolution] = STATE(7548),
    [sym_call] = STATE(7548),
    [sym_method_call] = STATE(7550),
    [sym_assignment] = STATE(9333),
    [sym_operator_assignment] = STATE(9333),
    [sym_conditional] = STATE(9333),
    [sym_range] = STATE(9333),
    [sym_binary] = STATE(9333),
    [sym_unary] = STATE(9333),
    [sym_left_assignment_list] = STATE(7549),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7550),
    [sym__variable] = STATE(7548),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7550),
    [sym_false] = STATE(7550),
    [sym_nil] = STATE(7550),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7551),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11077),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11079),
    [anon_sym_yield] = ACTIONS(11081),
    [anon_sym_break] = ACTIONS(11083),
    [anon_sym_next] = ACTIONS(11085),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11087),
    [anon_sym_defined_QMARK] = ACTIONS(11089),
    [anon_sym_not] = ACTIONS(11091),
    [anon_sym_BANG] = ACTIONS(11093),
    [anon_sym_TILDE] = ACTIONS(11093),
    [sym_constant] = ACTIONS(11095),
    [sym_identifier] = ACTIONS(11095),
    [sym_instance_variable] = ACTIONS(11097),
    [sym_class_variable] = ACTIONS(11097),
    [sym_global_variable] = ACTIONS(11097),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11095),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11095),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [7546] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(3628),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7550),
    [sym_scope_resolution] = STATE(7548),
    [sym_call] = STATE(7548),
    [sym_method_call] = STATE(7550),
    [sym_assignment] = STATE(3628),
    [sym_operator_assignment] = STATE(3628),
    [sym_conditional] = STATE(3628),
    [sym_range] = STATE(3628),
    [sym_binary] = STATE(3628),
    [sym_unary] = STATE(3628),
    [sym_left_assignment_list] = STATE(7549),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7550),
    [sym__variable] = STATE(7548),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7550),
    [sym_false] = STATE(7550),
    [sym_nil] = STATE(7550),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7551),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11077),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11079),
    [anon_sym_yield] = ACTIONS(11081),
    [anon_sym_break] = ACTIONS(11083),
    [anon_sym_next] = ACTIONS(11085),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11087),
    [anon_sym_defined_QMARK] = ACTIONS(11089),
    [anon_sym_not] = ACTIONS(11091),
    [anon_sym_BANG] = ACTIONS(11093),
    [anon_sym_TILDE] = ACTIONS(11093),
    [sym_constant] = ACTIONS(11095),
    [sym_identifier] = ACTIONS(11095),
    [sym_instance_variable] = ACTIONS(11097),
    [sym_class_variable] = ACTIONS(11097),
    [sym_global_variable] = ACTIONS(11097),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11095),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11095),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [7547] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(12950),
    [sym__binary_star] = ACTIONS(12952),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(12954),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(12956),
    [anon_sym_AMP] = ACTIONS(12958),
    [anon_sym_EQ] = ACTIONS(4217),
    [anon_sym_LT] = ACTIONS(12960),
    [anon_sym_end] = ACTIONS(4211),
    [anon_sym_if] = ACTIONS(4211),
    [anon_sym_unless] = ACTIONS(4211),
    [anon_sym_while] = ACTIONS(4211),
    [anon_sym_until] = ACTIONS(4211),
    [anon_sym_rescue] = ACTIONS(4211),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_elsif] = ACTIONS(4211),
    [anon_sym_else] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_PLUS_EQ] = ACTIONS(4211),
    [anon_sym_DASH_EQ] = ACTIONS(4211),
    [anon_sym_STAR_EQ] = ACTIONS(4211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4211),
    [anon_sym_SLASH_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4211),
    [anon_sym_AMP_EQ] = ACTIONS(4211),
    [anon_sym_PERCENT_EQ] = ACTIONS(4211),
    [anon_sym_GT_GT_EQ] = ACTIONS(4211),
    [anon_sym_LT_LT_EQ] = ACTIONS(4211),
    [anon_sym_CARET_EQ] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(12962),
    [anon_sym_DOT_DOT] = ACTIONS(12964),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12966),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(12968),
    [anon_sym_AMP_AMP] = ACTIONS(12968),
    [anon_sym_LT_LT] = ACTIONS(12970),
    [anon_sym_GT_GT] = ACTIONS(12970),
    [anon_sym_EQ_EQ] = ACTIONS(12968),
    [anon_sym_BANG_EQ] = ACTIONS(12972),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12972),
    [anon_sym_LT_EQ_GT] = ACTIONS(12972),
    [anon_sym_EQ_TILDE] = ACTIONS(12972),
    [anon_sym_BANG_TILDE] = ACTIONS(12972),
    [anon_sym_LT_EQ] = ACTIONS(12960),
    [anon_sym_GT] = ACTIONS(12960),
    [anon_sym_GT_EQ] = ACTIONS(12974),
    [anon_sym_CARET] = ACTIONS(12954),
    [anon_sym_PLUS] = ACTIONS(12976),
    [anon_sym_SLASH] = ACTIONS(12956),
    [anon_sym_PERCENT] = ACTIONS(12956),
    [sym_comment] = ACTIONS(87),
  },
  [7548] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5092),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5097),
    [sym_scope_resolution] = STATE(5093),
    [sym_call] = STATE(5093),
    [sym_method_call] = STATE(5097),
    [sym_argument_list] = STATE(1062),
    [sym__argument_list_with_parens] = STATE(5094),
    [sym__argument] = STATE(5095),
    [sym_splat_argument] = STATE(5095),
    [sym_hash_splat_argument] = STATE(5095),
    [sym_block_argument] = STATE(5095),
    [sym_do_block] = STATE(426),
    [sym_block] = STATE(426),
    [sym_assignment] = STATE(5092),
    [sym_operator_assignment] = STATE(5092),
    [sym_conditional] = STATE(5092),
    [sym_range] = STATE(5092),
    [sym_binary] = STATE(5092),
    [sym_unary] = STATE(5092),
    [sym_left_assignment_list] = STATE(5096),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5097),
    [sym__variable] = STATE(5093),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5097),
    [sym_false] = STATE(5097),
    [sym_nil] = STATE(5097),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5098),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(5095),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(743),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(8062),
    [sym__splat_star] = ACTIONS(8064),
    [sym__unary_minus] = ACTIONS(8066),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(8068),
    [anon_sym_LBRACE] = ACTIONS(6047),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(769),
    [anon_sym_return] = ACTIONS(8070),
    [anon_sym_yield] = ACTIONS(8072),
    [anon_sym_break] = ACTIONS(8074),
    [anon_sym_next] = ACTIONS(8076),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(769),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(769),
    [anon_sym_until] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(769),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(769),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_elsif] = ACTIONS(769),
    [anon_sym_else] = ACTIONS(769),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(8078),
    [anon_sym_not] = ACTIONS(8080),
    [anon_sym_BANG] = ACTIONS(8082),
    [anon_sym_TILDE] = ACTIONS(8084),
    [sym_constant] = ACTIONS(8086),
    [sym_identifier] = ACTIONS(8086),
    [sym_instance_variable] = ACTIONS(8088),
    [sym_class_variable] = ACTIONS(8088),
    [sym_global_variable] = ACTIONS(8088),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8090),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8090),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7549] = {
    [anon_sym_EQ] = ACTIONS(12978),
    [sym_comment] = ACTIONS(87),
  },
  [7550] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(12980),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_elsif] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(12982),
    [anon_sym_DASH_EQ] = ACTIONS(12982),
    [anon_sym_STAR_EQ] = ACTIONS(12982),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12982),
    [anon_sym_SLASH_EQ] = ACTIONS(12982),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12982),
    [anon_sym_PIPE_EQ] = ACTIONS(12982),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12982),
    [anon_sym_AMP_EQ] = ACTIONS(12982),
    [anon_sym_PERCENT_EQ] = ACTIONS(12982),
    [anon_sym_GT_GT_EQ] = ACTIONS(12982),
    [anon_sym_LT_LT_EQ] = ACTIONS(12982),
    [anon_sym_CARET_EQ] = ACTIONS(12982),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [7551] = {
    [sym_string] = STATE(9346),
    [aux_sym_chained_string_repeat1] = STATE(9346),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(2551),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_elsif] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [7552] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(12950),
    [sym__binary_star] = ACTIONS(12952),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(12954),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(12956),
    [anon_sym_AMP] = ACTIONS(12958),
    [anon_sym_EQ] = ACTIONS(4249),
    [anon_sym_LT] = ACTIONS(12960),
    [anon_sym_end] = ACTIONS(4247),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_elsif] = ACTIONS(4247),
    [anon_sym_else] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_PLUS_EQ] = ACTIONS(4247),
    [anon_sym_DASH_EQ] = ACTIONS(4247),
    [anon_sym_STAR_EQ] = ACTIONS(4247),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4247),
    [anon_sym_SLASH_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4247),
    [anon_sym_AMP_EQ] = ACTIONS(4247),
    [anon_sym_PERCENT_EQ] = ACTIONS(4247),
    [anon_sym_GT_GT_EQ] = ACTIONS(4247),
    [anon_sym_LT_LT_EQ] = ACTIONS(4247),
    [anon_sym_CARET_EQ] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(12962),
    [anon_sym_DOT_DOT] = ACTIONS(12964),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12966),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(12968),
    [anon_sym_AMP_AMP] = ACTIONS(12968),
    [anon_sym_LT_LT] = ACTIONS(12970),
    [anon_sym_GT_GT] = ACTIONS(12970),
    [anon_sym_EQ_EQ] = ACTIONS(12968),
    [anon_sym_BANG_EQ] = ACTIONS(12972),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12972),
    [anon_sym_LT_EQ_GT] = ACTIONS(12972),
    [anon_sym_EQ_TILDE] = ACTIONS(12972),
    [anon_sym_BANG_TILDE] = ACTIONS(12972),
    [anon_sym_LT_EQ] = ACTIONS(12960),
    [anon_sym_GT] = ACTIONS(12960),
    [anon_sym_GT_EQ] = ACTIONS(12974),
    [anon_sym_CARET] = ACTIONS(12954),
    [anon_sym_PLUS] = ACTIONS(12976),
    [anon_sym_SLASH] = ACTIONS(12956),
    [anon_sym_PERCENT] = ACTIONS(12956),
    [sym_comment] = ACTIONS(87),
  },
  [7553] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(11111),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_elsif] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [7554] = {
    [sym_string] = STATE(7574),
    [aux_sym_chained_string_repeat1] = STATE(7574),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(747),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_elsif] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [7555] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(9347),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7550),
    [sym_scope_resolution] = STATE(7548),
    [sym_call] = STATE(7548),
    [sym_method_call] = STATE(7550),
    [sym_assignment] = STATE(9347),
    [sym_operator_assignment] = STATE(9347),
    [sym_conditional] = STATE(9347),
    [sym_range] = STATE(9347),
    [sym_binary] = STATE(9347),
    [sym_unary] = STATE(9347),
    [sym_left_assignment_list] = STATE(7549),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7550),
    [sym__variable] = STATE(7548),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7550),
    [sym_false] = STATE(7550),
    [sym_nil] = STATE(7550),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7551),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11077),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11079),
    [anon_sym_yield] = ACTIONS(11081),
    [anon_sym_break] = ACTIONS(11083),
    [anon_sym_next] = ACTIONS(11085),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11087),
    [anon_sym_defined_QMARK] = ACTIONS(11089),
    [anon_sym_not] = ACTIONS(11091),
    [anon_sym_BANG] = ACTIONS(11093),
    [anon_sym_TILDE] = ACTIONS(11093),
    [sym_constant] = ACTIONS(11095),
    [sym_identifier] = ACTIONS(11095),
    [sym_instance_variable] = ACTIONS(11097),
    [sym_class_variable] = ACTIONS(11097),
    [sym_global_variable] = ACTIONS(11097),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11095),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11095),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [7556] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(12950),
    [sym__binary_star] = ACTIONS(12952),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(12954),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(12956),
    [anon_sym_AMP] = ACTIONS(12958),
    [anon_sym_EQ] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(12960),
    [anon_sym_end] = ACTIONS(3281),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_unless] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_until] = ACTIONS(3281),
    [anon_sym_rescue] = ACTIONS(3281),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_elsif] = ACTIONS(3281),
    [anon_sym_else] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_PLUS_EQ] = ACTIONS(3281),
    [anon_sym_DASH_EQ] = ACTIONS(3281),
    [anon_sym_STAR_EQ] = ACTIONS(3281),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3281),
    [anon_sym_SLASH_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3281),
    [anon_sym_AMP_EQ] = ACTIONS(3281),
    [anon_sym_PERCENT_EQ] = ACTIONS(3281),
    [anon_sym_GT_GT_EQ] = ACTIONS(3281),
    [anon_sym_LT_LT_EQ] = ACTIONS(3281),
    [anon_sym_CARET_EQ] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(12962),
    [anon_sym_DOT_DOT] = ACTIONS(12964),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12966),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(12968),
    [anon_sym_AMP_AMP] = ACTIONS(12968),
    [anon_sym_LT_LT] = ACTIONS(12970),
    [anon_sym_GT_GT] = ACTIONS(12970),
    [anon_sym_EQ_EQ] = ACTIONS(12968),
    [anon_sym_BANG_EQ] = ACTIONS(12972),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12972),
    [anon_sym_LT_EQ_GT] = ACTIONS(12972),
    [anon_sym_EQ_TILDE] = ACTIONS(12972),
    [anon_sym_BANG_TILDE] = ACTIONS(12972),
    [anon_sym_LT_EQ] = ACTIONS(12960),
    [anon_sym_GT] = ACTIONS(12960),
    [anon_sym_GT_EQ] = ACTIONS(12974),
    [anon_sym_CARET] = ACTIONS(12954),
    [anon_sym_PLUS] = ACTIONS(12976),
    [anon_sym_SLASH] = ACTIONS(12956),
    [anon_sym_PERCENT] = ACTIONS(12956),
    [sym_comment] = ACTIONS(87),
  },
  [7557] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(11105),
    [sym__binary_star] = ACTIONS(11107),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(11109),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(11111),
    [anon_sym_AMP] = ACTIONS(11113),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(11115),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_elsif] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(11117),
    [anon_sym_DOT_DOT] = ACTIONS(11119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11121),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(11123),
    [anon_sym_AMP_AMP] = ACTIONS(11123),
    [anon_sym_LT_LT] = ACTIONS(11125),
    [anon_sym_GT_GT] = ACTIONS(11125),
    [anon_sym_EQ_EQ] = ACTIONS(11123),
    [anon_sym_BANG_EQ] = ACTIONS(11127),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11127),
    [anon_sym_LT_EQ_GT] = ACTIONS(11127),
    [anon_sym_EQ_TILDE] = ACTIONS(11127),
    [anon_sym_BANG_TILDE] = ACTIONS(11127),
    [anon_sym_LT_EQ] = ACTIONS(11115),
    [anon_sym_GT] = ACTIONS(11115),
    [anon_sym_GT_EQ] = ACTIONS(11129),
    [anon_sym_CARET] = ACTIONS(11109),
    [anon_sym_PLUS] = ACTIONS(11131),
    [anon_sym_SLASH] = ACTIONS(11111),
    [anon_sym_PERCENT] = ACTIONS(11111),
    [sym_comment] = ACTIONS(87),
  },
  [7558] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(9348),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7550),
    [sym_scope_resolution] = STATE(7548),
    [sym_call] = STATE(7548),
    [sym_method_call] = STATE(7550),
    [sym_assignment] = STATE(9348),
    [sym_operator_assignment] = STATE(9348),
    [sym_conditional] = STATE(9348),
    [sym_range] = STATE(9348),
    [sym_binary] = STATE(9348),
    [sym_unary] = STATE(9348),
    [sym_left_assignment_list] = STATE(7549),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7550),
    [sym__variable] = STATE(7548),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7550),
    [sym_false] = STATE(7550),
    [sym_nil] = STATE(7550),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7551),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11077),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11079),
    [anon_sym_yield] = ACTIONS(11081),
    [anon_sym_break] = ACTIONS(11083),
    [anon_sym_next] = ACTIONS(11085),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11087),
    [anon_sym_defined_QMARK] = ACTIONS(11089),
    [anon_sym_not] = ACTIONS(11091),
    [anon_sym_BANG] = ACTIONS(11093),
    [anon_sym_TILDE] = ACTIONS(11093),
    [sym_constant] = ACTIONS(11095),
    [sym_identifier] = ACTIONS(11095),
    [sym_instance_variable] = ACTIONS(11097),
    [sym_class_variable] = ACTIONS(11097),
    [sym_global_variable] = ACTIONS(11097),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11095),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11095),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [7559] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(9349),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5097),
    [sym_scope_resolution] = STATE(5093),
    [sym_call] = STATE(5093),
    [sym_method_call] = STATE(5097),
    [sym_assignment] = STATE(9349),
    [sym_operator_assignment] = STATE(9349),
    [sym_conditional] = STATE(9349),
    [sym_range] = STATE(9349),
    [sym_binary] = STATE(9349),
    [sym_unary] = STATE(9349),
    [sym_left_assignment_list] = STATE(5096),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5097),
    [sym__variable] = STATE(5093),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5097),
    [sym_false] = STATE(5097),
    [sym_nil] = STATE(5097),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7554),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(8066),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(8070),
    [anon_sym_yield] = ACTIONS(8072),
    [anon_sym_break] = ACTIONS(8074),
    [anon_sym_next] = ACTIONS(8076),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(11099),
    [anon_sym_defined_QMARK] = ACTIONS(8078),
    [anon_sym_not] = ACTIONS(8080),
    [anon_sym_BANG] = ACTIONS(8084),
    [anon_sym_TILDE] = ACTIONS(8084),
    [sym_constant] = ACTIONS(8090),
    [sym_identifier] = ACTIONS(8090),
    [sym_instance_variable] = ACTIONS(8088),
    [sym_class_variable] = ACTIONS(8088),
    [sym_global_variable] = ACTIONS(8088),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8090),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8090),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7560] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(9350),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5097),
    [sym_scope_resolution] = STATE(5093),
    [sym_call] = STATE(5093),
    [sym_method_call] = STATE(5097),
    [sym_assignment] = STATE(9350),
    [sym_operator_assignment] = STATE(9350),
    [sym_conditional] = STATE(9350),
    [sym_range] = STATE(9350),
    [sym_binary] = STATE(9350),
    [sym_unary] = STATE(9350),
    [sym_left_assignment_list] = STATE(5096),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5097),
    [sym__variable] = STATE(5093),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5097),
    [sym_false] = STATE(5097),
    [sym_nil] = STATE(5097),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7554),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(8066),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(8070),
    [anon_sym_yield] = ACTIONS(8072),
    [anon_sym_break] = ACTIONS(8074),
    [anon_sym_next] = ACTIONS(8076),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(11099),
    [anon_sym_defined_QMARK] = ACTIONS(8078),
    [anon_sym_not] = ACTIONS(8080),
    [anon_sym_BANG] = ACTIONS(8084),
    [anon_sym_TILDE] = ACTIONS(8084),
    [sym_constant] = ACTIONS(8090),
    [sym_identifier] = ACTIONS(8090),
    [sym_instance_variable] = ACTIONS(8088),
    [sym_class_variable] = ACTIONS(8088),
    [sym_global_variable] = ACTIONS(8088),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8090),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8090),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7561] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(9351),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5097),
    [sym_scope_resolution] = STATE(5093),
    [sym_call] = STATE(5093),
    [sym_method_call] = STATE(5097),
    [sym_assignment] = STATE(9351),
    [sym_operator_assignment] = STATE(9351),
    [sym_conditional] = STATE(9351),
    [sym_range] = STATE(9351),
    [sym_binary] = STATE(9351),
    [sym_unary] = STATE(9351),
    [sym_left_assignment_list] = STATE(5096),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5097),
    [sym__variable] = STATE(5093),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5097),
    [sym_false] = STATE(5097),
    [sym_nil] = STATE(5097),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7554),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(8066),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(8070),
    [anon_sym_yield] = ACTIONS(8072),
    [anon_sym_break] = ACTIONS(8074),
    [anon_sym_next] = ACTIONS(8076),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(11099),
    [anon_sym_defined_QMARK] = ACTIONS(8078),
    [anon_sym_not] = ACTIONS(8080),
    [anon_sym_BANG] = ACTIONS(8084),
    [anon_sym_TILDE] = ACTIONS(8084),
    [sym_constant] = ACTIONS(8090),
    [sym_identifier] = ACTIONS(8090),
    [sym_instance_variable] = ACTIONS(8088),
    [sym_class_variable] = ACTIONS(8088),
    [sym_global_variable] = ACTIONS(8088),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8090),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8090),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7562] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(9352),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5097),
    [sym_scope_resolution] = STATE(5093),
    [sym_call] = STATE(5093),
    [sym_method_call] = STATE(5097),
    [sym_assignment] = STATE(9352),
    [sym_operator_assignment] = STATE(9352),
    [sym_conditional] = STATE(9352),
    [sym_range] = STATE(9352),
    [sym_binary] = STATE(9352),
    [sym_unary] = STATE(9352),
    [sym_left_assignment_list] = STATE(5096),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5097),
    [sym__variable] = STATE(5093),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5097),
    [sym_false] = STATE(5097),
    [sym_nil] = STATE(5097),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7554),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(8066),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(8070),
    [anon_sym_yield] = ACTIONS(8072),
    [anon_sym_break] = ACTIONS(8074),
    [anon_sym_next] = ACTIONS(8076),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(11099),
    [anon_sym_defined_QMARK] = ACTIONS(8078),
    [anon_sym_not] = ACTIONS(8080),
    [anon_sym_BANG] = ACTIONS(8084),
    [anon_sym_TILDE] = ACTIONS(8084),
    [sym_constant] = ACTIONS(8090),
    [sym_identifier] = ACTIONS(8090),
    [sym_instance_variable] = ACTIONS(8088),
    [sym_class_variable] = ACTIONS(8088),
    [sym_global_variable] = ACTIONS(8088),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8090),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8090),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7563] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(9353),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5097),
    [sym_scope_resolution] = STATE(5093),
    [sym_call] = STATE(5093),
    [sym_method_call] = STATE(5097),
    [sym_assignment] = STATE(9353),
    [sym_operator_assignment] = STATE(9353),
    [sym_conditional] = STATE(9353),
    [sym_range] = STATE(9353),
    [sym_binary] = STATE(9353),
    [sym_unary] = STATE(9353),
    [sym_left_assignment_list] = STATE(5096),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5097),
    [sym__variable] = STATE(5093),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5097),
    [sym_false] = STATE(5097),
    [sym_nil] = STATE(5097),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7554),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(8066),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(8070),
    [anon_sym_yield] = ACTIONS(8072),
    [anon_sym_break] = ACTIONS(8074),
    [anon_sym_next] = ACTIONS(8076),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(11099),
    [anon_sym_defined_QMARK] = ACTIONS(8078),
    [anon_sym_not] = ACTIONS(8080),
    [anon_sym_BANG] = ACTIONS(8084),
    [anon_sym_TILDE] = ACTIONS(8084),
    [sym_constant] = ACTIONS(8090),
    [sym_identifier] = ACTIONS(8090),
    [sym_instance_variable] = ACTIONS(8088),
    [sym_class_variable] = ACTIONS(8088),
    [sym_global_variable] = ACTIONS(8088),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8090),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8090),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7564] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(9354),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(9354),
    [sym_operator_assignment] = STATE(9354),
    [sym_conditional] = STATE(9354),
    [sym_range] = STATE(9354),
    [sym_binary] = STATE(9354),
    [sym_unary] = STATE(9354),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [7565] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(9355),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5097),
    [sym_scope_resolution] = STATE(5093),
    [sym_call] = STATE(5093),
    [sym_method_call] = STATE(5097),
    [sym_assignment] = STATE(9355),
    [sym_operator_assignment] = STATE(9355),
    [sym_conditional] = STATE(9355),
    [sym_range] = STATE(9355),
    [sym_binary] = STATE(9355),
    [sym_unary] = STATE(9355),
    [sym_left_assignment_list] = STATE(5096),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5097),
    [sym__variable] = STATE(5093),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5097),
    [sym_false] = STATE(5097),
    [sym_nil] = STATE(5097),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7554),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(8066),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(8070),
    [anon_sym_yield] = ACTIONS(8072),
    [anon_sym_break] = ACTIONS(8074),
    [anon_sym_next] = ACTIONS(8076),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(11099),
    [anon_sym_defined_QMARK] = ACTIONS(8078),
    [anon_sym_not] = ACTIONS(8080),
    [anon_sym_BANG] = ACTIONS(8084),
    [anon_sym_TILDE] = ACTIONS(8084),
    [sym_constant] = ACTIONS(8090),
    [sym_identifier] = ACTIONS(8090),
    [sym_instance_variable] = ACTIONS(8088),
    [sym_class_variable] = ACTIONS(8088),
    [sym_global_variable] = ACTIONS(8088),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8090),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8090),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7566] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(9356),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5097),
    [sym_scope_resolution] = STATE(5093),
    [sym_call] = STATE(5093),
    [sym_method_call] = STATE(5097),
    [sym_assignment] = STATE(9356),
    [sym_operator_assignment] = STATE(9356),
    [sym_conditional] = STATE(9356),
    [sym_range] = STATE(9356),
    [sym_binary] = STATE(9356),
    [sym_unary] = STATE(9356),
    [sym_left_assignment_list] = STATE(5096),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5097),
    [sym__variable] = STATE(5093),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5097),
    [sym_false] = STATE(5097),
    [sym_nil] = STATE(5097),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7554),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(8066),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(8070),
    [anon_sym_yield] = ACTIONS(8072),
    [anon_sym_break] = ACTIONS(8074),
    [anon_sym_next] = ACTIONS(8076),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(11099),
    [anon_sym_defined_QMARK] = ACTIONS(8078),
    [anon_sym_not] = ACTIONS(8080),
    [anon_sym_BANG] = ACTIONS(8084),
    [anon_sym_TILDE] = ACTIONS(8084),
    [sym_constant] = ACTIONS(8090),
    [sym_identifier] = ACTIONS(8090),
    [sym_instance_variable] = ACTIONS(8088),
    [sym_class_variable] = ACTIONS(8088),
    [sym_global_variable] = ACTIONS(8088),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8090),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8090),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7567] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(9357),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5097),
    [sym_scope_resolution] = STATE(5093),
    [sym_call] = STATE(5093),
    [sym_method_call] = STATE(5097),
    [sym_assignment] = STATE(9357),
    [sym_operator_assignment] = STATE(9357),
    [sym_conditional] = STATE(9357),
    [sym_range] = STATE(9357),
    [sym_binary] = STATE(9357),
    [sym_unary] = STATE(9357),
    [sym_left_assignment_list] = STATE(5096),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5097),
    [sym__variable] = STATE(5093),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5097),
    [sym_false] = STATE(5097),
    [sym_nil] = STATE(5097),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7554),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(8066),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(8070),
    [anon_sym_yield] = ACTIONS(8072),
    [anon_sym_break] = ACTIONS(8074),
    [anon_sym_next] = ACTIONS(8076),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(11099),
    [anon_sym_defined_QMARK] = ACTIONS(8078),
    [anon_sym_not] = ACTIONS(8080),
    [anon_sym_BANG] = ACTIONS(8084),
    [anon_sym_TILDE] = ACTIONS(8084),
    [sym_constant] = ACTIONS(8090),
    [sym_identifier] = ACTIONS(8090),
    [sym_instance_variable] = ACTIONS(8088),
    [sym_class_variable] = ACTIONS(8088),
    [sym_global_variable] = ACTIONS(8088),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8090),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8090),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7568] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(9358),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5097),
    [sym_scope_resolution] = STATE(5093),
    [sym_call] = STATE(5093),
    [sym_method_call] = STATE(5097),
    [sym_assignment] = STATE(9358),
    [sym_operator_assignment] = STATE(9358),
    [sym_conditional] = STATE(9358),
    [sym_range] = STATE(9358),
    [sym_binary] = STATE(9358),
    [sym_unary] = STATE(9358),
    [sym_left_assignment_list] = STATE(5096),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5097),
    [sym__variable] = STATE(5093),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5097),
    [sym_false] = STATE(5097),
    [sym_nil] = STATE(5097),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7554),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(8066),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(8070),
    [anon_sym_yield] = ACTIONS(8072),
    [anon_sym_break] = ACTIONS(8074),
    [anon_sym_next] = ACTIONS(8076),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(11099),
    [anon_sym_defined_QMARK] = ACTIONS(8078),
    [anon_sym_not] = ACTIONS(8080),
    [anon_sym_BANG] = ACTIONS(8084),
    [anon_sym_TILDE] = ACTIONS(8084),
    [sym_constant] = ACTIONS(8090),
    [sym_identifier] = ACTIONS(8090),
    [sym_instance_variable] = ACTIONS(8088),
    [sym_class_variable] = ACTIONS(8088),
    [sym_global_variable] = ACTIONS(8088),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8090),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8090),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7569] = {
    [sym_heredoc_body] = STATE(9359),
    [aux_sym_call_repeat1] = STATE(9359),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_elsif] = ACTIONS(4383),
    [anon_sym_else] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [7570] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5092),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5097),
    [sym_scope_resolution] = STATE(5093),
    [sym_call] = STATE(5093),
    [sym_method_call] = STATE(5097),
    [sym__argument] = STATE(3737),
    [sym_splat_argument] = STATE(3737),
    [sym_hash_splat_argument] = STATE(3737),
    [sym_block_argument] = STATE(3737),
    [sym_assignment] = STATE(5092),
    [sym_operator_assignment] = STATE(5092),
    [sym_conditional] = STATE(5092),
    [sym_range] = STATE(5092),
    [sym_binary] = STATE(5092),
    [sym_unary] = STATE(5092),
    [sym_left_assignment_list] = STATE(5096),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5097),
    [sym__variable] = STATE(5093),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5097),
    [sym_false] = STATE(5097),
    [sym_nil] = STATE(5097),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5098),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_heredoc_body] = STATE(9360),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(3737),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(8062),
    [sym__splat_star] = ACTIONS(8064),
    [sym__unary_minus] = ACTIONS(8066),
    [sym__identifier_hash_key] = ACTIONS(8068),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12984),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(8070),
    [anon_sym_yield] = ACTIONS(8072),
    [anon_sym_break] = ACTIONS(8074),
    [anon_sym_next] = ACTIONS(8076),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(11099),
    [anon_sym_defined_QMARK] = ACTIONS(8078),
    [anon_sym_not] = ACTIONS(8080),
    [anon_sym_BANG] = ACTIONS(8084),
    [anon_sym_TILDE] = ACTIONS(8084),
    [sym_constant] = ACTIONS(8086),
    [sym_identifier] = ACTIONS(8086),
    [sym_instance_variable] = ACTIONS(8088),
    [sym_class_variable] = ACTIONS(8088),
    [sym_global_variable] = ACTIONS(8088),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8090),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8090),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7571] = {
    [sym_heredoc_body] = STATE(9361),
    [aux_sym_call_repeat1] = STATE(9361),
    [aux_sym_argument_list_repeat1] = STATE(9362),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(11133),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_elsif] = ACTIONS(4383),
    [anon_sym_else] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [7572] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(9363),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5097),
    [sym_scope_resolution] = STATE(5093),
    [sym_call] = STATE(5093),
    [sym_method_call] = STATE(5097),
    [sym_splat_argument] = STATE(9364),
    [sym_assignment] = STATE(9363),
    [sym_operator_assignment] = STATE(9363),
    [sym_conditional] = STATE(9363),
    [sym_range] = STATE(9363),
    [sym_binary] = STATE(9363),
    [sym_unary] = STATE(9363),
    [sym_right_assignment_list] = STATE(3742),
    [sym__arg_or_splat_arg] = STATE(9364),
    [sym_left_assignment_list] = STATE(5096),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5097),
    [sym__variable] = STATE(5093),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5097),
    [sym_false] = STATE(5097),
    [sym_nil] = STATE(5097),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7554),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__splat_star] = ACTIONS(11061),
    [sym__unary_minus] = ACTIONS(8066),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(8070),
    [anon_sym_yield] = ACTIONS(8072),
    [anon_sym_break] = ACTIONS(8074),
    [anon_sym_next] = ACTIONS(8076),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(11099),
    [anon_sym_defined_QMARK] = ACTIONS(8078),
    [anon_sym_not] = ACTIONS(8080),
    [anon_sym_BANG] = ACTIONS(8084),
    [anon_sym_TILDE] = ACTIONS(8084),
    [sym_constant] = ACTIONS(8090),
    [sym_identifier] = ACTIONS(8090),
    [sym_instance_variable] = ACTIONS(8088),
    [sym_class_variable] = ACTIONS(8088),
    [sym_global_variable] = ACTIONS(8088),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8090),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8090),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7573] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(9365),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5097),
    [sym_scope_resolution] = STATE(5093),
    [sym_call] = STATE(5093),
    [sym_method_call] = STATE(5097),
    [sym_assignment] = STATE(9365),
    [sym_operator_assignment] = STATE(9365),
    [sym_conditional] = STATE(9365),
    [sym_range] = STATE(9365),
    [sym_binary] = STATE(9365),
    [sym_unary] = STATE(9365),
    [sym_left_assignment_list] = STATE(5096),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5097),
    [sym__variable] = STATE(5093),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5097),
    [sym_false] = STATE(5097),
    [sym_nil] = STATE(5097),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7554),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(8066),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(8070),
    [anon_sym_yield] = ACTIONS(8072),
    [anon_sym_break] = ACTIONS(8074),
    [anon_sym_next] = ACTIONS(8076),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(11099),
    [anon_sym_defined_QMARK] = ACTIONS(8078),
    [anon_sym_not] = ACTIONS(8080),
    [anon_sym_BANG] = ACTIONS(8084),
    [anon_sym_TILDE] = ACTIONS(8084),
    [sym_constant] = ACTIONS(8090),
    [sym_identifier] = ACTIONS(8090),
    [sym_instance_variable] = ACTIONS(8088),
    [sym_class_variable] = ACTIONS(8088),
    [sym_global_variable] = ACTIONS(8088),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8090),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8090),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7574] = {
    [sym_string] = STATE(9366),
    [aux_sym_chained_string_repeat1] = STATE(9366),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(747),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2755),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_EQ] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_end] = ACTIONS(2753),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_elsif] = ACTIONS(2753),
    [anon_sym_else] = ACTIONS(2753),
    [anon_sym_EQ_GT] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_PLUS_EQ] = ACTIONS(2753),
    [anon_sym_DASH_EQ] = ACTIONS(2753),
    [anon_sym_STAR_EQ] = ACTIONS(2753),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2753),
    [anon_sym_SLASH_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2753),
    [anon_sym_AMP_EQ] = ACTIONS(2753),
    [anon_sym_PERCENT_EQ] = ACTIONS(2753),
    [anon_sym_GT_GT_EQ] = ACTIONS(2753),
    [anon_sym_LT_LT_EQ] = ACTIONS(2753),
    [anon_sym_CARET_EQ] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2755),
    [anon_sym_AMP_AMP] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2755),
    [anon_sym_GT_GT] = ACTIONS(2755),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_SLASH] = ACTIONS(2755),
    [anon_sym_PERCENT] = ACTIONS(2755),
    [sym_comment] = ACTIONS(87),
  },
  [7575] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9367),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7582),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(7582),
    [sym_assignment] = STATE(9367),
    [sym_operator_assignment] = STATE(9367),
    [sym_conditional] = STATE(9367),
    [sym_range] = STATE(9367),
    [sym_binary] = STATE(9367),
    [sym_unary] = STATE(9367),
    [sym_left_assignment_list] = STATE(7581),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7582),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7582),
    [sym_false] = STATE(7582),
    [sym_nil] = STATE(7582),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7482),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11145),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11003),
    [anon_sym_yield] = ACTIONS(11005),
    [anon_sym_break] = ACTIONS(11007),
    [anon_sym_next] = ACTIONS(11009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11147),
    [anon_sym_defined_QMARK] = ACTIONS(11149),
    [anon_sym_not] = ACTIONS(11151),
    [anon_sym_BANG] = ACTIONS(11153),
    [anon_sym_TILDE] = ACTIONS(11153),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7576] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9368),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7582),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(7582),
    [sym_assignment] = STATE(9368),
    [sym_operator_assignment] = STATE(9368),
    [sym_conditional] = STATE(9368),
    [sym_range] = STATE(9368),
    [sym_binary] = STATE(9368),
    [sym_unary] = STATE(9368),
    [sym_left_assignment_list] = STATE(7581),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7582),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7582),
    [sym_false] = STATE(7582),
    [sym_nil] = STATE(7582),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7482),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11145),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11003),
    [anon_sym_yield] = ACTIONS(11005),
    [anon_sym_break] = ACTIONS(11007),
    [anon_sym_next] = ACTIONS(11009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11147),
    [anon_sym_defined_QMARK] = ACTIONS(11149),
    [anon_sym_not] = ACTIONS(11151),
    [anon_sym_BANG] = ACTIONS(11153),
    [anon_sym_TILDE] = ACTIONS(11153),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7577] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9369),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7582),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(7582),
    [sym_assignment] = STATE(9369),
    [sym_operator_assignment] = STATE(9369),
    [sym_conditional] = STATE(9369),
    [sym_range] = STATE(9369),
    [sym_binary] = STATE(9369),
    [sym_unary] = STATE(9369),
    [sym_left_assignment_list] = STATE(7581),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7582),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7582),
    [sym_false] = STATE(7582),
    [sym_nil] = STATE(7582),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7482),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11145),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11003),
    [anon_sym_yield] = ACTIONS(11005),
    [anon_sym_break] = ACTIONS(11007),
    [anon_sym_next] = ACTIONS(11009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11147),
    [anon_sym_defined_QMARK] = ACTIONS(11149),
    [anon_sym_not] = ACTIONS(11151),
    [anon_sym_BANG] = ACTIONS(11153),
    [anon_sym_TILDE] = ACTIONS(11153),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7578] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(298),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7582),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(7582),
    [sym_assignment] = STATE(298),
    [sym_operator_assignment] = STATE(298),
    [sym_conditional] = STATE(298),
    [sym_range] = STATE(298),
    [sym_binary] = STATE(298),
    [sym_unary] = STATE(298),
    [sym_left_assignment_list] = STATE(7581),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7582),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7582),
    [sym_false] = STATE(7582),
    [sym_nil] = STATE(7582),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7482),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11145),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11003),
    [anon_sym_yield] = ACTIONS(11005),
    [anon_sym_break] = ACTIONS(11007),
    [anon_sym_next] = ACTIONS(11009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11147),
    [anon_sym_defined_QMARK] = ACTIONS(11149),
    [anon_sym_not] = ACTIONS(11151),
    [anon_sym_BANG] = ACTIONS(11153),
    [anon_sym_TILDE] = ACTIONS(11153),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7579] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(12986),
    [sym__binary_star] = ACTIONS(12988),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(12990),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(12988),
    [anon_sym_AMP] = ACTIONS(12992),
    [anon_sym_LT] = ACTIONS(12994),
    [anon_sym_end] = ACTIONS(5115),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_elsif] = ACTIONS(5115),
    [anon_sym_else] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(12996),
    [anon_sym_DOT_DOT] = ACTIONS(12998),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13000),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(13002),
    [anon_sym_AMP_AMP] = ACTIONS(13002),
    [anon_sym_LT_LT] = ACTIONS(13004),
    [anon_sym_GT_GT] = ACTIONS(13004),
    [anon_sym_EQ_EQ] = ACTIONS(13006),
    [anon_sym_BANG_EQ] = ACTIONS(13002),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13002),
    [anon_sym_LT_EQ_GT] = ACTIONS(13002),
    [anon_sym_EQ_TILDE] = ACTIONS(13002),
    [anon_sym_BANG_TILDE] = ACTIONS(13002),
    [anon_sym_LT_EQ] = ACTIONS(12994),
    [anon_sym_GT] = ACTIONS(12994),
    [anon_sym_GT_EQ] = ACTIONS(13008),
    [anon_sym_CARET] = ACTIONS(13010),
    [anon_sym_PLUS] = ACTIONS(12986),
    [anon_sym_SLASH] = ACTIONS(12988),
    [anon_sym_PERCENT] = ACTIONS(12988),
    [sym_comment] = ACTIONS(87),
  },
  [7580] = {
    [aux_sym_exceptions_repeat1] = STATE(9381),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_COMMA] = ACTIONS(13012),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_end] = ACTIONS(6191),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_elsif] = ACTIONS(6191),
    [anon_sym_else] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [7581] = {
    [anon_sym_EQ] = ACTIONS(13014),
    [sym_comment] = ACTIONS(87),
  },
  [7582] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(13016),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_elsif] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(13018),
    [anon_sym_DASH_EQ] = ACTIONS(13018),
    [anon_sym_STAR_EQ] = ACTIONS(13018),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13018),
    [anon_sym_SLASH_EQ] = ACTIONS(13018),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13018),
    [anon_sym_PIPE_EQ] = ACTIONS(13018),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13018),
    [anon_sym_AMP_EQ] = ACTIONS(13018),
    [anon_sym_PERCENT_EQ] = ACTIONS(13018),
    [anon_sym_GT_GT_EQ] = ACTIONS(13018),
    [anon_sym_LT_LT_EQ] = ACTIONS(13018),
    [anon_sym_CARET_EQ] = ACTIONS(13018),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [7583] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(8034),
    [sym__binary_star] = ACTIONS(8036),
    [anon_sym_PIPE] = ACTIONS(8038),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(8036),
    [anon_sym_AMP] = ACTIONS(8040),
    [anon_sym_LT] = ACTIONS(8042),
    [anon_sym_end] = ACTIONS(6210),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_elsif] = ACTIONS(6210),
    [anon_sym_else] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(8044),
    [anon_sym_DOT_DOT] = ACTIONS(8046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8048),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(8052),
    [anon_sym_AMP_AMP] = ACTIONS(8052),
    [anon_sym_LT_LT] = ACTIONS(8054),
    [anon_sym_GT_GT] = ACTIONS(8054),
    [anon_sym_EQ_EQ] = ACTIONS(8056),
    [anon_sym_BANG_EQ] = ACTIONS(8052),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8052),
    [anon_sym_LT_EQ_GT] = ACTIONS(8052),
    [anon_sym_EQ_TILDE] = ACTIONS(8052),
    [anon_sym_BANG_TILDE] = ACTIONS(8052),
    [anon_sym_LT_EQ] = ACTIONS(8042),
    [anon_sym_GT] = ACTIONS(8042),
    [anon_sym_GT_EQ] = ACTIONS(8058),
    [anon_sym_CARET] = ACTIONS(8060),
    [anon_sym_PLUS] = ACTIONS(8034),
    [anon_sym_SLASH] = ACTIONS(8036),
    [anon_sym_PERCENT] = ACTIONS(8036),
    [sym_comment] = ACTIONS(87),
  },
  [7584] = {
    [sym_string] = STATE(7584),
    [aux_sym_chained_string_repeat1] = STATE(7584),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(6214),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_end] = ACTIONS(6212),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_elsif] = ACTIONS(6212),
    [anon_sym_else] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [7585] = {
    [sym_elsif] = STATE(9384),
    [sym_else] = STATE(9384),
    [anon_sym_end] = ACTIONS(13020),
    [anon_sym_elsif] = ACTIONS(4495),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [7586] = {
    [sym__statements] = STATE(2640),
    [sym_begin_block] = STATE(2641),
    [sym_end_block] = STATE(2641),
    [sym__statement] = STATE(2641),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(2641),
    [sym_unless_modifier] = STATE(2641),
    [sym_while_modifier] = STATE(2641),
    [sym_until_modifier] = STATE(2641),
    [sym_rescue_modifier] = STATE(2641),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_elsif] = STATE(9384),
    [sym_else] = STATE(9384),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2642),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2645),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(2645),
    [sym_assignment] = STATE(2642),
    [sym_operator_assignment] = STATE(2642),
    [sym_conditional] = STATE(2642),
    [sym_range] = STATE(2642),
    [sym_binary] = STATE(2642),
    [sym_unary] = STATE(2642),
    [sym_left_assignment_list] = STATE(2644),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2645),
    [sym__variable] = STATE(2643),
    [sym_undef] = STATE(2641),
    [sym_alias] = STATE(2641),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2645),
    [sym_false] = STATE(2645),
    [sym_nil] = STATE(2645),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2646),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(2647),
    [aux_sym__statements_repeat1] = STATE(2647),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4467),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13022),
    [anon_sym_return] = ACTIONS(4471),
    [anon_sym_yield] = ACTIONS(4473),
    [anon_sym_break] = ACTIONS(4475),
    [anon_sym_next] = ACTIONS(4477),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(4499),
    [anon_sym_else] = ACTIONS(4501),
    [anon_sym_then] = ACTIONS(4503),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4479),
    [anon_sym_defined_QMARK] = ACTIONS(4481),
    [anon_sym_not] = ACTIONS(4483),
    [anon_sym_BANG] = ACTIONS(4485),
    [anon_sym_TILDE] = ACTIONS(4485),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [anon_sym_undef] = ACTIONS(4491),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7587] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(1755),
    [sym__binary_star] = ACTIONS(1757),
    [anon_sym_PIPE] = ACTIONS(1759),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(1757),
    [anon_sym_AMP] = ACTIONS(1761),
    [anon_sym_LT] = ACTIONS(1763),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_then] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(1765),
    [anon_sym_DOT_DOT] = ACTIONS(1767),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1769),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(1773),
    [anon_sym_AMP_AMP] = ACTIONS(1773),
    [anon_sym_LT_LT] = ACTIONS(1775),
    [anon_sym_GT_GT] = ACTIONS(1775),
    [anon_sym_EQ_EQ] = ACTIONS(1777),
    [anon_sym_BANG_EQ] = ACTIONS(1773),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1773),
    [anon_sym_LT_EQ_GT] = ACTIONS(1773),
    [anon_sym_EQ_TILDE] = ACTIONS(1773),
    [anon_sym_BANG_TILDE] = ACTIONS(1773),
    [anon_sym_LT_EQ] = ACTIONS(1763),
    [anon_sym_GT] = ACTIONS(1763),
    [anon_sym_GT_EQ] = ACTIONS(1779),
    [anon_sym_CARET] = ACTIONS(1781),
    [anon_sym_PLUS] = ACTIONS(1755),
    [anon_sym_SLASH] = ACTIONS(1757),
    [anon_sym_PERCENT] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
  },
  [7588] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(8110),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8114),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(8114),
    [anon_sym_PERCENT] = ACTIONS(8114),
    [sym_comment] = ACTIONS(87),
  },
  [7589] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8114),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(5827),
    [anon_sym_PERCENT] = ACTIONS(5827),
    [sym_comment] = ACTIONS(87),
  },
  [7590] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8108),
    [sym__binary_star] = ACTIONS(8110),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8114),
    [anon_sym_AMP] = ACTIONS(8116),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(8128),
    [anon_sym_GT_GT] = ACTIONS(8128),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(8134),
    [anon_sym_SLASH] = ACTIONS(8114),
    [anon_sym_PERCENT] = ACTIONS(8114),
    [sym_comment] = ACTIONS(87),
  },
  [7591] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8108),
    [sym__binary_star] = ACTIONS(8110),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8114),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(8128),
    [anon_sym_GT_GT] = ACTIONS(8128),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(8134),
    [anon_sym_SLASH] = ACTIONS(8114),
    [anon_sym_PERCENT] = ACTIONS(8114),
    [sym_comment] = ACTIONS(87),
  },
  [7592] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8108),
    [sym__binary_star] = ACTIONS(8110),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(8112),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8114),
    [anon_sym_AMP] = ACTIONS(8116),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(8128),
    [anon_sym_GT_GT] = ACTIONS(8128),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(8112),
    [anon_sym_PLUS] = ACTIONS(8134),
    [anon_sym_SLASH] = ACTIONS(8114),
    [anon_sym_PERCENT] = ACTIONS(8114),
    [sym_comment] = ACTIONS(87),
  },
  [7593] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(13024),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [7594] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(8108),
    [sym__binary_star] = ACTIONS(8110),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(8112),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(8114),
    [anon_sym_AMP] = ACTIONS(8116),
    [anon_sym_EQ] = ACTIONS(7888),
    [anon_sym_LT] = ACTIONS(8118),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_then] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_PLUS_EQ] = ACTIONS(5927),
    [anon_sym_DASH_EQ] = ACTIONS(5927),
    [anon_sym_STAR_EQ] = ACTIONS(5927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5927),
    [anon_sym_SLASH_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5927),
    [anon_sym_AMP_EQ] = ACTIONS(5927),
    [anon_sym_PERCENT_EQ] = ACTIONS(5927),
    [anon_sym_GT_GT_EQ] = ACTIONS(5927),
    [anon_sym_LT_LT_EQ] = ACTIONS(5927),
    [anon_sym_CARET_EQ] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(8122),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8124),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(8126),
    [anon_sym_AMP_AMP] = ACTIONS(8126),
    [anon_sym_LT_LT] = ACTIONS(8128),
    [anon_sym_GT_GT] = ACTIONS(8128),
    [anon_sym_EQ_EQ] = ACTIONS(8126),
    [anon_sym_BANG_EQ] = ACTIONS(8130),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8130),
    [anon_sym_LT_EQ_GT] = ACTIONS(8130),
    [anon_sym_EQ_TILDE] = ACTIONS(8130),
    [anon_sym_BANG_TILDE] = ACTIONS(8130),
    [anon_sym_LT_EQ] = ACTIONS(8118),
    [anon_sym_GT] = ACTIONS(8118),
    [anon_sym_GT_EQ] = ACTIONS(8132),
    [anon_sym_CARET] = ACTIONS(8112),
    [anon_sym_PLUS] = ACTIONS(8134),
    [anon_sym_SLASH] = ACTIONS(8114),
    [anon_sym_PERCENT] = ACTIONS(8114),
    [sym_comment] = ACTIONS(87),
  },
  [7595] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8108),
    [sym__binary_star] = ACTIONS(8110),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(8112),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8114),
    [anon_sym_AMP] = ACTIONS(8116),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(8118),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(8120),
    [anon_sym_DOT_DOT] = ACTIONS(8122),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8124),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(8126),
    [anon_sym_AMP_AMP] = ACTIONS(8126),
    [anon_sym_LT_LT] = ACTIONS(8128),
    [anon_sym_GT_GT] = ACTIONS(8128),
    [anon_sym_EQ_EQ] = ACTIONS(8126),
    [anon_sym_BANG_EQ] = ACTIONS(8130),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8130),
    [anon_sym_LT_EQ_GT] = ACTIONS(8130),
    [anon_sym_EQ_TILDE] = ACTIONS(8130),
    [anon_sym_BANG_TILDE] = ACTIONS(8130),
    [anon_sym_LT_EQ] = ACTIONS(8118),
    [anon_sym_GT] = ACTIONS(8118),
    [anon_sym_GT_EQ] = ACTIONS(8132),
    [anon_sym_CARET] = ACTIONS(8112),
    [anon_sym_PLUS] = ACTIONS(8134),
    [anon_sym_SLASH] = ACTIONS(8114),
    [anon_sym_PERCENT] = ACTIONS(8114),
    [sym_comment] = ACTIONS(87),
  },
  [7596] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8108),
    [sym__binary_star] = ACTIONS(8110),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(8112),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8114),
    [anon_sym_AMP] = ACTIONS(8116),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(8118),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(8128),
    [anon_sym_GT_GT] = ACTIONS(8128),
    [anon_sym_EQ_EQ] = ACTIONS(8126),
    [anon_sym_BANG_EQ] = ACTIONS(8130),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8130),
    [anon_sym_LT_EQ_GT] = ACTIONS(8130),
    [anon_sym_EQ_TILDE] = ACTIONS(8130),
    [anon_sym_BANG_TILDE] = ACTIONS(8130),
    [anon_sym_LT_EQ] = ACTIONS(8118),
    [anon_sym_GT] = ACTIONS(8118),
    [anon_sym_GT_EQ] = ACTIONS(8132),
    [anon_sym_CARET] = ACTIONS(8112),
    [anon_sym_PLUS] = ACTIONS(8134),
    [anon_sym_SLASH] = ACTIONS(8114),
    [anon_sym_PERCENT] = ACTIONS(8114),
    [sym_comment] = ACTIONS(87),
  },
  [7597] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8108),
    [sym__binary_star] = ACTIONS(8110),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8114),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(8134),
    [anon_sym_SLASH] = ACTIONS(8114),
    [anon_sym_PERCENT] = ACTIONS(8114),
    [sym_comment] = ACTIONS(87),
  },
  [7598] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(8108),
    [sym__binary_star] = ACTIONS(8110),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(8112),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(8114),
    [anon_sym_AMP] = ACTIONS(8116),
    [anon_sym_EQ] = ACTIONS(7936),
    [anon_sym_LT] = ACTIONS(8118),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_then] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_PLUS_EQ] = ACTIONS(5115),
    [anon_sym_DASH_EQ] = ACTIONS(5115),
    [anon_sym_STAR_EQ] = ACTIONS(5115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5115),
    [anon_sym_SLASH_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5115),
    [anon_sym_AMP_EQ] = ACTIONS(5115),
    [anon_sym_PERCENT_EQ] = ACTIONS(5115),
    [anon_sym_GT_GT_EQ] = ACTIONS(5115),
    [anon_sym_LT_LT_EQ] = ACTIONS(5115),
    [anon_sym_CARET_EQ] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(8120),
    [anon_sym_DOT_DOT] = ACTIONS(8122),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8124),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(8126),
    [anon_sym_AMP_AMP] = ACTIONS(8126),
    [anon_sym_LT_LT] = ACTIONS(8128),
    [anon_sym_GT_GT] = ACTIONS(8128),
    [anon_sym_EQ_EQ] = ACTIONS(8126),
    [anon_sym_BANG_EQ] = ACTIONS(8130),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8130),
    [anon_sym_LT_EQ_GT] = ACTIONS(8130),
    [anon_sym_EQ_TILDE] = ACTIONS(8130),
    [anon_sym_BANG_TILDE] = ACTIONS(8130),
    [anon_sym_LT_EQ] = ACTIONS(8118),
    [anon_sym_GT] = ACTIONS(8118),
    [anon_sym_GT_EQ] = ACTIONS(8132),
    [anon_sym_CARET] = ACTIONS(8112),
    [anon_sym_PLUS] = ACTIONS(8134),
    [anon_sym_SLASH] = ACTIONS(8114),
    [anon_sym_PERCENT] = ACTIONS(8114),
    [sym_comment] = ACTIONS(87),
  },
  [7599] = {
    [aux_sym_exceptions_repeat1] = STATE(9387),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6193),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_then] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_PLUS_EQ] = ACTIONS(6191),
    [anon_sym_DASH_EQ] = ACTIONS(6191),
    [anon_sym_STAR_EQ] = ACTIONS(6191),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6191),
    [anon_sym_SLASH_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6191),
    [anon_sym_AMP_EQ] = ACTIONS(6191),
    [anon_sym_PERCENT_EQ] = ACTIONS(6191),
    [anon_sym_GT_GT_EQ] = ACTIONS(6191),
    [anon_sym_LT_LT_EQ] = ACTIONS(6191),
    [anon_sym_CARET_EQ] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6193),
    [anon_sym_AMP_AMP] = ACTIONS(6193),
    [anon_sym_LT_LT] = ACTIONS(6193),
    [anon_sym_GT_GT] = ACTIONS(6193),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6193),
    [anon_sym_PLUS] = ACTIONS(6193),
    [anon_sym_SLASH] = ACTIONS(6193),
    [anon_sym_PERCENT] = ACTIONS(6193),
    [sym_comment] = ACTIONS(87),
  },
  [7600] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(8108),
    [sym__binary_star] = ACTIONS(8110),
    [anon_sym_LBRACE] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(8112),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(8114),
    [anon_sym_AMP] = ACTIONS(8116),
    [anon_sym_EQ] = ACTIONS(7938),
    [anon_sym_LT] = ACTIONS(8118),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_then] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_PLUS_EQ] = ACTIONS(6210),
    [anon_sym_DASH_EQ] = ACTIONS(6210),
    [anon_sym_STAR_EQ] = ACTIONS(6210),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6210),
    [anon_sym_SLASH_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6210),
    [anon_sym_AMP_EQ] = ACTIONS(6210),
    [anon_sym_PERCENT_EQ] = ACTIONS(6210),
    [anon_sym_GT_GT_EQ] = ACTIONS(6210),
    [anon_sym_LT_LT_EQ] = ACTIONS(6210),
    [anon_sym_CARET_EQ] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(8120),
    [anon_sym_DOT_DOT] = ACTIONS(8122),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8124),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(8126),
    [anon_sym_AMP_AMP] = ACTIONS(8126),
    [anon_sym_LT_LT] = ACTIONS(8128),
    [anon_sym_GT_GT] = ACTIONS(8128),
    [anon_sym_EQ_EQ] = ACTIONS(8126),
    [anon_sym_BANG_EQ] = ACTIONS(8130),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8130),
    [anon_sym_LT_EQ_GT] = ACTIONS(8130),
    [anon_sym_EQ_TILDE] = ACTIONS(8130),
    [anon_sym_BANG_TILDE] = ACTIONS(8130),
    [anon_sym_LT_EQ] = ACTIONS(8118),
    [anon_sym_GT] = ACTIONS(8118),
    [anon_sym_GT_EQ] = ACTIONS(8132),
    [anon_sym_CARET] = ACTIONS(8112),
    [anon_sym_PLUS] = ACTIONS(8134),
    [anon_sym_SLASH] = ACTIONS(8114),
    [anon_sym_PERCENT] = ACTIONS(8114),
    [sym_comment] = ACTIONS(87),
  },
  [7601] = {
    [sym_string] = STATE(7601),
    [aux_sym_chained_string_repeat1] = STATE(7601),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(12267),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6217),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_EQ] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_do] = ACTIONS(6212),
    [anon_sym_then] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_PLUS_EQ] = ACTIONS(6212),
    [anon_sym_DASH_EQ] = ACTIONS(6212),
    [anon_sym_STAR_EQ] = ACTIONS(6212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6212),
    [anon_sym_SLASH_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6212),
    [anon_sym_AMP_EQ] = ACTIONS(6212),
    [anon_sym_PERCENT_EQ] = ACTIONS(6212),
    [anon_sym_GT_GT_EQ] = ACTIONS(6212),
    [anon_sym_LT_LT_EQ] = ACTIONS(6212),
    [anon_sym_CARET_EQ] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6217),
    [anon_sym_AMP_AMP] = ACTIONS(6217),
    [anon_sym_LT_LT] = ACTIONS(6217),
    [anon_sym_GT_GT] = ACTIONS(6217),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6217),
    [anon_sym_PLUS] = ACTIONS(6217),
    [anon_sym_SLASH] = ACTIONS(6217),
    [anon_sym_PERCENT] = ACTIONS(6217),
    [sym_comment] = ACTIONS(87),
  },
  [7602] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(9388),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_assignment] = STATE(9388),
    [sym_operator_assignment] = STATE(9388),
    [sym_conditional] = STATE(9388),
    [sym_range] = STATE(9388),
    [sym_binary] = STATE(9388),
    [sym_unary] = STATE(9388),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2676),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1787),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1791),
    [anon_sym_yield] = ACTIONS(1793),
    [anon_sym_break] = ACTIONS(1795),
    [anon_sym_next] = ACTIONS(1797),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(4527),
    [anon_sym_defined_QMARK] = ACTIONS(1799),
    [anon_sym_not] = ACTIONS(1801),
    [anon_sym_BANG] = ACTIONS(1805),
    [anon_sym_TILDE] = ACTIONS(1805),
    [sym_constant] = ACTIONS(1811),
    [sym_identifier] = ACTIONS(1811),
    [sym_instance_variable] = ACTIONS(1809),
    [sym_class_variable] = ACTIONS(1809),
    [sym_global_variable] = ACTIONS(1809),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1811),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1811),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7603] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5139),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_splat_argument] = STATE(8678),
    [sym_assignment] = STATE(5139),
    [sym_operator_assignment] = STATE(5139),
    [sym_conditional] = STATE(5139),
    [sym_range] = STATE(5139),
    [sym_binary] = STATE(5139),
    [sym_unary] = STATE(5139),
    [sym__arg_or_splat_arg] = STATE(8678),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2676),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__splat_star] = ACTIONS(4451),
    [sym__unary_minus] = ACTIONS(1787),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1791),
    [anon_sym_yield] = ACTIONS(1793),
    [anon_sym_break] = ACTIONS(1795),
    [anon_sym_next] = ACTIONS(1797),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(4527),
    [anon_sym_defined_QMARK] = ACTIONS(1799),
    [anon_sym_not] = ACTIONS(1801),
    [anon_sym_BANG] = ACTIONS(1805),
    [anon_sym_TILDE] = ACTIONS(1805),
    [sym_constant] = ACTIONS(1811),
    [sym_identifier] = ACTIONS(1811),
    [sym_instance_variable] = ACTIONS(1809),
    [sym_class_variable] = ACTIONS(1809),
    [sym_global_variable] = ACTIONS(1809),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1811),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1811),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7604] = {
    [aux_sym_exceptions_repeat1] = STATE(9389),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_LBRACE] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(13026),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9857),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_EQ] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_do] = ACTIONS(9855),
    [anon_sym_then] = ACTIONS(9855),
    [anon_sym_EQ_GT] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_PLUS_EQ] = ACTIONS(9855),
    [anon_sym_DASH_EQ] = ACTIONS(9855),
    [anon_sym_STAR_EQ] = ACTIONS(9855),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9855),
    [anon_sym_SLASH_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9855),
    [anon_sym_AMP_EQ] = ACTIONS(9855),
    [anon_sym_PERCENT_EQ] = ACTIONS(9855),
    [anon_sym_GT_GT_EQ] = ACTIONS(9855),
    [anon_sym_LT_LT_EQ] = ACTIONS(9855),
    [anon_sym_CARET_EQ] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9857),
    [anon_sym_AMP_AMP] = ACTIONS(9857),
    [anon_sym_LT_LT] = ACTIONS(9857),
    [anon_sym_GT_GT] = ACTIONS(9857),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9857),
    [anon_sym_PLUS] = ACTIONS(9857),
    [anon_sym_SLASH] = ACTIONS(9857),
    [anon_sym_PERCENT] = ACTIONS(9857),
    [sym_comment] = ACTIONS(87),
  },
  [7605] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(8146),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8146),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(8146),
    [anon_sym_PERCENT] = ACTIONS(8146),
    [sym_comment] = ACTIONS(87),
  },
  [7606] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8146),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [7607] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8144),
    [sym__binary_star] = ACTIONS(8146),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8146),
    [anon_sym_AMP] = ACTIONS(8150),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(8162),
    [anon_sym_GT_GT] = ACTIONS(8162),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(8144),
    [anon_sym_SLASH] = ACTIONS(8146),
    [anon_sym_PERCENT] = ACTIONS(8146),
    [sym_comment] = ACTIONS(87),
  },
  [7608] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8144),
    [sym__binary_star] = ACTIONS(8146),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8146),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(8162),
    [anon_sym_GT_GT] = ACTIONS(8162),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(8144),
    [anon_sym_SLASH] = ACTIONS(8146),
    [anon_sym_PERCENT] = ACTIONS(8146),
    [sym_comment] = ACTIONS(87),
  },
  [7609] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8144),
    [sym__binary_star] = ACTIONS(8146),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(8148),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8146),
    [anon_sym_AMP] = ACTIONS(8150),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(8162),
    [anon_sym_GT_GT] = ACTIONS(8162),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(8168),
    [anon_sym_PLUS] = ACTIONS(8144),
    [anon_sym_SLASH] = ACTIONS(8146),
    [anon_sym_PERCENT] = ACTIONS(8146),
    [sym_comment] = ACTIONS(87),
  },
  [7610] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(13028),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [7611] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(8144),
    [sym__binary_star] = ACTIONS(8146),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(8148),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(8146),
    [anon_sym_AMP] = ACTIONS(8150),
    [anon_sym_LT] = ACTIONS(8152),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_then] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(8156),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8158),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(8160),
    [anon_sym_AMP_AMP] = ACTIONS(8160),
    [anon_sym_LT_LT] = ACTIONS(8162),
    [anon_sym_GT_GT] = ACTIONS(8162),
    [anon_sym_EQ_EQ] = ACTIONS(8164),
    [anon_sym_BANG_EQ] = ACTIONS(8160),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8160),
    [anon_sym_LT_EQ_GT] = ACTIONS(8160),
    [anon_sym_EQ_TILDE] = ACTIONS(8160),
    [anon_sym_BANG_TILDE] = ACTIONS(8160),
    [anon_sym_LT_EQ] = ACTIONS(8152),
    [anon_sym_GT] = ACTIONS(8152),
    [anon_sym_GT_EQ] = ACTIONS(8166),
    [anon_sym_CARET] = ACTIONS(8168),
    [anon_sym_PLUS] = ACTIONS(8144),
    [anon_sym_SLASH] = ACTIONS(8146),
    [anon_sym_PERCENT] = ACTIONS(8146),
    [sym_comment] = ACTIONS(87),
  },
  [7612] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8144),
    [sym__binary_star] = ACTIONS(8146),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(8148),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8146),
    [anon_sym_AMP] = ACTIONS(8150),
    [anon_sym_LT] = ACTIONS(8152),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(8154),
    [anon_sym_DOT_DOT] = ACTIONS(8156),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8158),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(8160),
    [anon_sym_AMP_AMP] = ACTIONS(8160),
    [anon_sym_LT_LT] = ACTIONS(8162),
    [anon_sym_GT_GT] = ACTIONS(8162),
    [anon_sym_EQ_EQ] = ACTIONS(8164),
    [anon_sym_BANG_EQ] = ACTIONS(8160),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8160),
    [anon_sym_LT_EQ_GT] = ACTIONS(8160),
    [anon_sym_EQ_TILDE] = ACTIONS(8160),
    [anon_sym_BANG_TILDE] = ACTIONS(8160),
    [anon_sym_LT_EQ] = ACTIONS(8152),
    [anon_sym_GT] = ACTIONS(8152),
    [anon_sym_GT_EQ] = ACTIONS(8166),
    [anon_sym_CARET] = ACTIONS(8168),
    [anon_sym_PLUS] = ACTIONS(8144),
    [anon_sym_SLASH] = ACTIONS(8146),
    [anon_sym_PERCENT] = ACTIONS(8146),
    [sym_comment] = ACTIONS(87),
  },
  [7613] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8144),
    [sym__binary_star] = ACTIONS(8146),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(8148),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8146),
    [anon_sym_AMP] = ACTIONS(8150),
    [anon_sym_LT] = ACTIONS(8152),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(8162),
    [anon_sym_GT_GT] = ACTIONS(8162),
    [anon_sym_EQ_EQ] = ACTIONS(8164),
    [anon_sym_BANG_EQ] = ACTIONS(8160),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8160),
    [anon_sym_LT_EQ_GT] = ACTIONS(8160),
    [anon_sym_EQ_TILDE] = ACTIONS(8160),
    [anon_sym_BANG_TILDE] = ACTIONS(8160),
    [anon_sym_LT_EQ] = ACTIONS(8152),
    [anon_sym_GT] = ACTIONS(8152),
    [anon_sym_GT_EQ] = ACTIONS(8166),
    [anon_sym_CARET] = ACTIONS(8168),
    [anon_sym_PLUS] = ACTIONS(8144),
    [anon_sym_SLASH] = ACTIONS(8146),
    [anon_sym_PERCENT] = ACTIONS(8146),
    [sym_comment] = ACTIONS(87),
  },
  [7614] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8144),
    [sym__binary_star] = ACTIONS(8146),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8146),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(8144),
    [anon_sym_SLASH] = ACTIONS(8146),
    [anon_sym_PERCENT] = ACTIONS(8146),
    [sym_comment] = ACTIONS(87),
  },
  [7615] = {
    [aux_sym_exceptions_repeat1] = STATE(7615),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_COMMA] = ACTIONS(13030),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_then] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [7616] = {
    [aux_sym_exceptions_repeat1] = STATE(5157),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_then] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [7617] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(8144),
    [sym__binary_star] = ACTIONS(8146),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(8148),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(8146),
    [anon_sym_AMP] = ACTIONS(8150),
    [anon_sym_LT] = ACTIONS(8152),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_then] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(8154),
    [anon_sym_DOT_DOT] = ACTIONS(8156),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8158),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(8160),
    [anon_sym_AMP_AMP] = ACTIONS(8160),
    [anon_sym_LT_LT] = ACTIONS(8162),
    [anon_sym_GT_GT] = ACTIONS(8162),
    [anon_sym_EQ_EQ] = ACTIONS(8164),
    [anon_sym_BANG_EQ] = ACTIONS(8160),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8160),
    [anon_sym_LT_EQ_GT] = ACTIONS(8160),
    [anon_sym_EQ_TILDE] = ACTIONS(8160),
    [anon_sym_BANG_TILDE] = ACTIONS(8160),
    [anon_sym_LT_EQ] = ACTIONS(8152),
    [anon_sym_GT] = ACTIONS(8152),
    [anon_sym_GT_EQ] = ACTIONS(8166),
    [anon_sym_CARET] = ACTIONS(8168),
    [anon_sym_PLUS] = ACTIONS(8144),
    [anon_sym_SLASH] = ACTIONS(8146),
    [anon_sym_PERCENT] = ACTIONS(8146),
    [sym_comment] = ACTIONS(87),
  },
  [7618] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9391),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7627),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(7627),
    [sym_assignment] = STATE(9391),
    [sym_operator_assignment] = STATE(9391),
    [sym_conditional] = STATE(9391),
    [sym_range] = STATE(9391),
    [sym_binary] = STATE(9391),
    [sym_unary] = STATE(9391),
    [sym_left_assignment_list] = STATE(7626),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7627),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7627),
    [sym_false] = STATE(7627),
    [sym_nil] = STATE(7627),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7628),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11168),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11170),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_break] = ACTIONS(11174),
    [anon_sym_next] = ACTIONS(11176),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11178),
    [anon_sym_defined_QMARK] = ACTIONS(11180),
    [anon_sym_not] = ACTIONS(11182),
    [anon_sym_BANG] = ACTIONS(11184),
    [anon_sym_TILDE] = ACTIONS(11184),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7619] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5173),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5178),
    [sym_scope_resolution] = STATE(5174),
    [sym_call] = STATE(5174),
    [sym_method_call] = STATE(5178),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(9392),
    [sym__argument] = STATE(9393),
    [sym_splat_argument] = STATE(9393),
    [sym_hash_splat_argument] = STATE(9393),
    [sym_block_argument] = STATE(9393),
    [sym_assignment] = STATE(5173),
    [sym_operator_assignment] = STATE(5173),
    [sym_conditional] = STATE(5173),
    [sym_range] = STATE(5173),
    [sym_binary] = STATE(5173),
    [sym_unary] = STATE(5173),
    [sym_left_assignment_list] = STATE(5177),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5178),
    [sym__variable] = STATE(5174),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5178),
    [sym_false] = STATE(5178),
    [sym_nil] = STATE(5178),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5179),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(9393),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(8178),
    [sym__splat_star] = ACTIONS(8180),
    [sym__unary_minus] = ACTIONS(8182),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(8184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(8186),
    [anon_sym_yield] = ACTIONS(8188),
    [anon_sym_break] = ACTIONS(8190),
    [anon_sym_next] = ACTIONS(8192),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(377),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(8194),
    [anon_sym_not] = ACTIONS(8196),
    [anon_sym_BANG] = ACTIONS(8198),
    [anon_sym_TILDE] = ACTIONS(8200),
    [sym_constant] = ACTIONS(8202),
    [sym_identifier] = ACTIONS(8202),
    [sym_instance_variable] = ACTIONS(8204),
    [sym_class_variable] = ACTIONS(8204),
    [sym_global_variable] = ACTIONS(8204),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8206),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8206),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7620] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5173),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5178),
    [sym_scope_resolution] = STATE(5174),
    [sym_call] = STATE(5174),
    [sym_method_call] = STATE(5178),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(9392),
    [sym__argument] = STATE(9393),
    [sym_splat_argument] = STATE(9393),
    [sym_hash_splat_argument] = STATE(9393),
    [sym_block_argument] = STATE(9393),
    [sym_assignment] = STATE(5173),
    [sym_operator_assignment] = STATE(5173),
    [sym_conditional] = STATE(5173),
    [sym_range] = STATE(5173),
    [sym_binary] = STATE(5173),
    [sym_unary] = STATE(5173),
    [sym_left_assignment_list] = STATE(5177),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5178),
    [sym__variable] = STATE(5174),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5178),
    [sym_false] = STATE(5178),
    [sym_nil] = STATE(5178),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5179),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(9393),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(8178),
    [sym__splat_star] = ACTIONS(8180),
    [sym__unary_minus] = ACTIONS(8182),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(8184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(8186),
    [anon_sym_yield] = ACTIONS(8188),
    [anon_sym_break] = ACTIONS(8190),
    [anon_sym_next] = ACTIONS(8192),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(419),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(8194),
    [anon_sym_not] = ACTIONS(8196),
    [anon_sym_BANG] = ACTIONS(8198),
    [anon_sym_TILDE] = ACTIONS(8200),
    [sym_constant] = ACTIONS(8202),
    [sym_identifier] = ACTIONS(8202),
    [sym_instance_variable] = ACTIONS(8204),
    [sym_class_variable] = ACTIONS(8204),
    [sym_global_variable] = ACTIONS(8204),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8206),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8206),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7621] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5173),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5178),
    [sym_scope_resolution] = STATE(5174),
    [sym_call] = STATE(5174),
    [sym_method_call] = STATE(5178),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(9392),
    [sym__argument] = STATE(9393),
    [sym_splat_argument] = STATE(9393),
    [sym_hash_splat_argument] = STATE(9393),
    [sym_block_argument] = STATE(9393),
    [sym_assignment] = STATE(5173),
    [sym_operator_assignment] = STATE(5173),
    [sym_conditional] = STATE(5173),
    [sym_range] = STATE(5173),
    [sym_binary] = STATE(5173),
    [sym_unary] = STATE(5173),
    [sym_left_assignment_list] = STATE(5177),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5178),
    [sym__variable] = STATE(5174),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5178),
    [sym_false] = STATE(5178),
    [sym_nil] = STATE(5178),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5179),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(9393),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(8178),
    [sym__splat_star] = ACTIONS(8180),
    [sym__unary_minus] = ACTIONS(8182),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(8184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(423),
    [anon_sym_return] = ACTIONS(8186),
    [anon_sym_yield] = ACTIONS(8188),
    [anon_sym_break] = ACTIONS(8190),
    [anon_sym_next] = ACTIONS(8192),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(423),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(8194),
    [anon_sym_not] = ACTIONS(8196),
    [anon_sym_BANG] = ACTIONS(8198),
    [anon_sym_TILDE] = ACTIONS(8200),
    [sym_constant] = ACTIONS(8202),
    [sym_identifier] = ACTIONS(8202),
    [sym_instance_variable] = ACTIONS(8204),
    [sym_class_variable] = ACTIONS(8204),
    [sym_global_variable] = ACTIONS(8204),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8206),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8206),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7622] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5173),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5178),
    [sym_scope_resolution] = STATE(5174),
    [sym_call] = STATE(5174),
    [sym_method_call] = STATE(5178),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(9392),
    [sym__argument] = STATE(9393),
    [sym_splat_argument] = STATE(9393),
    [sym_hash_splat_argument] = STATE(9393),
    [sym_block_argument] = STATE(9393),
    [sym_assignment] = STATE(5173),
    [sym_operator_assignment] = STATE(5173),
    [sym_conditional] = STATE(5173),
    [sym_range] = STATE(5173),
    [sym_binary] = STATE(5173),
    [sym_unary] = STATE(5173),
    [sym_left_assignment_list] = STATE(5177),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5178),
    [sym__variable] = STATE(5174),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5178),
    [sym_false] = STATE(5178),
    [sym_nil] = STATE(5178),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5179),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(9393),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(8178),
    [sym__splat_star] = ACTIONS(8180),
    [sym__unary_minus] = ACTIONS(8182),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(8184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(427),
    [anon_sym_return] = ACTIONS(8186),
    [anon_sym_yield] = ACTIONS(8188),
    [anon_sym_break] = ACTIONS(8190),
    [anon_sym_next] = ACTIONS(8192),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(427),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(8194),
    [anon_sym_not] = ACTIONS(8196),
    [anon_sym_BANG] = ACTIONS(8198),
    [anon_sym_TILDE] = ACTIONS(8200),
    [sym_constant] = ACTIONS(8202),
    [sym_identifier] = ACTIONS(8202),
    [sym_instance_variable] = ACTIONS(8204),
    [sym_class_variable] = ACTIONS(8204),
    [sym_global_variable] = ACTIONS(8204),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8206),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8206),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7623] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9394),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7627),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(7627),
    [sym_assignment] = STATE(9394),
    [sym_operator_assignment] = STATE(9394),
    [sym_conditional] = STATE(9394),
    [sym_range] = STATE(9394),
    [sym_binary] = STATE(9394),
    [sym_unary] = STATE(9394),
    [sym_left_assignment_list] = STATE(7626),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7627),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7627),
    [sym_false] = STATE(7627),
    [sym_nil] = STATE(7627),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7628),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11168),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11170),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_break] = ACTIONS(11174),
    [anon_sym_next] = ACTIONS(11176),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11178),
    [anon_sym_defined_QMARK] = ACTIONS(11180),
    [anon_sym_not] = ACTIONS(11182),
    [anon_sym_BANG] = ACTIONS(11184),
    [anon_sym_TILDE] = ACTIONS(11184),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7624] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7627),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(7627),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(7626),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7627),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7627),
    [sym_false] = STATE(7627),
    [sym_nil] = STATE(7627),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7628),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11168),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11170),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_break] = ACTIONS(11174),
    [anon_sym_next] = ACTIONS(11176),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11178),
    [anon_sym_defined_QMARK] = ACTIONS(11180),
    [anon_sym_not] = ACTIONS(11182),
    [anon_sym_BANG] = ACTIONS(11184),
    [anon_sym_TILDE] = ACTIONS(11184),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7625] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(13033),
    [sym__binary_star] = ACTIONS(13035),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(13037),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(13035),
    [anon_sym_AMP] = ACTIONS(13039),
    [anon_sym_LT] = ACTIONS(13041),
    [anon_sym_end] = ACTIONS(4211),
    [anon_sym_if] = ACTIONS(4211),
    [anon_sym_unless] = ACTIONS(4211),
    [anon_sym_while] = ACTIONS(4211),
    [anon_sym_until] = ACTIONS(4211),
    [anon_sym_rescue] = ACTIONS(4211),
    [anon_sym_else] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(13043),
    [anon_sym_DOT_DOT] = ACTIONS(13045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13047),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(13049),
    [anon_sym_AMP_AMP] = ACTIONS(13049),
    [anon_sym_LT_LT] = ACTIONS(13051),
    [anon_sym_GT_GT] = ACTIONS(13051),
    [anon_sym_EQ_EQ] = ACTIONS(13053),
    [anon_sym_BANG_EQ] = ACTIONS(13049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13049),
    [anon_sym_LT_EQ_GT] = ACTIONS(13049),
    [anon_sym_EQ_TILDE] = ACTIONS(13049),
    [anon_sym_BANG_TILDE] = ACTIONS(13049),
    [anon_sym_LT_EQ] = ACTIONS(13041),
    [anon_sym_GT] = ACTIONS(13041),
    [anon_sym_GT_EQ] = ACTIONS(13055),
    [anon_sym_CARET] = ACTIONS(13057),
    [anon_sym_PLUS] = ACTIONS(13033),
    [anon_sym_SLASH] = ACTIONS(13035),
    [anon_sym_PERCENT] = ACTIONS(13035),
    [sym_comment] = ACTIONS(87),
  },
  [7626] = {
    [anon_sym_EQ] = ACTIONS(13059),
    [sym_comment] = ACTIONS(87),
  },
  [7627] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(13061),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(13063),
    [anon_sym_DASH_EQ] = ACTIONS(13063),
    [anon_sym_STAR_EQ] = ACTIONS(13063),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13063),
    [anon_sym_SLASH_EQ] = ACTIONS(13063),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13063),
    [anon_sym_PIPE_EQ] = ACTIONS(13063),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13063),
    [anon_sym_AMP_EQ] = ACTIONS(13063),
    [anon_sym_PERCENT_EQ] = ACTIONS(13063),
    [anon_sym_GT_GT_EQ] = ACTIONS(13063),
    [anon_sym_LT_LT_EQ] = ACTIONS(13063),
    [anon_sym_CARET_EQ] = ACTIONS(13063),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [7628] = {
    [sym_string] = STATE(9407),
    [aux_sym_chained_string_repeat1] = STATE(9407),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [7629] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(13033),
    [sym__binary_star] = ACTIONS(13035),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(13037),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(13035),
    [anon_sym_AMP] = ACTIONS(13039),
    [anon_sym_LT] = ACTIONS(13041),
    [anon_sym_end] = ACTIONS(4247),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_else] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(13043),
    [anon_sym_DOT_DOT] = ACTIONS(13045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13047),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(13049),
    [anon_sym_AMP_AMP] = ACTIONS(13049),
    [anon_sym_LT_LT] = ACTIONS(13051),
    [anon_sym_GT_GT] = ACTIONS(13051),
    [anon_sym_EQ_EQ] = ACTIONS(13053),
    [anon_sym_BANG_EQ] = ACTIONS(13049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13049),
    [anon_sym_LT_EQ_GT] = ACTIONS(13049),
    [anon_sym_EQ_TILDE] = ACTIONS(13049),
    [anon_sym_BANG_TILDE] = ACTIONS(13049),
    [anon_sym_LT_EQ] = ACTIONS(13041),
    [anon_sym_GT] = ACTIONS(13041),
    [anon_sym_GT_EQ] = ACTIONS(13055),
    [anon_sym_CARET] = ACTIONS(13057),
    [anon_sym_PLUS] = ACTIONS(13033),
    [anon_sym_SLASH] = ACTIONS(13035),
    [anon_sym_PERCENT] = ACTIONS(13035),
    [sym_comment] = ACTIONS(87),
  },
  [7630] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(11202),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [7631] = {
    [sym_string] = STATE(7669),
    [aux_sym_chained_string_repeat1] = STATE(7669),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [7632] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9408),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7627),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(7627),
    [sym_assignment] = STATE(9408),
    [sym_operator_assignment] = STATE(9408),
    [sym_conditional] = STATE(9408),
    [sym_range] = STATE(9408),
    [sym_binary] = STATE(9408),
    [sym_unary] = STATE(9408),
    [sym_left_assignment_list] = STATE(7626),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7627),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7627),
    [sym_false] = STATE(7627),
    [sym_nil] = STATE(7627),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7628),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11168),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11170),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_break] = ACTIONS(11174),
    [anon_sym_next] = ACTIONS(11176),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11178),
    [anon_sym_defined_QMARK] = ACTIONS(11180),
    [anon_sym_not] = ACTIONS(11182),
    [anon_sym_BANG] = ACTIONS(11184),
    [anon_sym_TILDE] = ACTIONS(11184),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7633] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(13033),
    [sym__binary_star] = ACTIONS(13035),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(13037),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(13035),
    [anon_sym_AMP] = ACTIONS(13039),
    [anon_sym_LT] = ACTIONS(13041),
    [anon_sym_end] = ACTIONS(3281),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_unless] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_until] = ACTIONS(3281),
    [anon_sym_rescue] = ACTIONS(3281),
    [anon_sym_else] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(13043),
    [anon_sym_DOT_DOT] = ACTIONS(13045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13047),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(13049),
    [anon_sym_AMP_AMP] = ACTIONS(13049),
    [anon_sym_LT_LT] = ACTIONS(13051),
    [anon_sym_GT_GT] = ACTIONS(13051),
    [anon_sym_EQ_EQ] = ACTIONS(13053),
    [anon_sym_BANG_EQ] = ACTIONS(13049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13049),
    [anon_sym_LT_EQ_GT] = ACTIONS(13049),
    [anon_sym_EQ_TILDE] = ACTIONS(13049),
    [anon_sym_BANG_TILDE] = ACTIONS(13049),
    [anon_sym_LT_EQ] = ACTIONS(13041),
    [anon_sym_GT] = ACTIONS(13041),
    [anon_sym_GT_EQ] = ACTIONS(13055),
    [anon_sym_CARET] = ACTIONS(13057),
    [anon_sym_PLUS] = ACTIONS(13033),
    [anon_sym_SLASH] = ACTIONS(13035),
    [anon_sym_PERCENT] = ACTIONS(13035),
    [sym_comment] = ACTIONS(87),
  },
  [7634] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9409),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5178),
    [sym_scope_resolution] = STATE(5174),
    [sym_call] = STATE(5174),
    [sym_method_call] = STATE(5178),
    [sym_assignment] = STATE(9409),
    [sym_operator_assignment] = STATE(9409),
    [sym_conditional] = STATE(9409),
    [sym_range] = STATE(9409),
    [sym_binary] = STATE(9409),
    [sym_unary] = STATE(9409),
    [sym_left_assignment_list] = STATE(5177),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5178),
    [sym__variable] = STATE(5174),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5178),
    [sym_false] = STATE(5178),
    [sym_nil] = STATE(5178),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7631),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8186),
    [anon_sym_yield] = ACTIONS(8188),
    [anon_sym_break] = ACTIONS(8190),
    [anon_sym_next] = ACTIONS(8192),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11186),
    [anon_sym_defined_QMARK] = ACTIONS(8194),
    [anon_sym_not] = ACTIONS(8196),
    [anon_sym_BANG] = ACTIONS(8200),
    [anon_sym_TILDE] = ACTIONS(8200),
    [sym_constant] = ACTIONS(8206),
    [sym_identifier] = ACTIONS(8206),
    [sym_instance_variable] = ACTIONS(8204),
    [sym_class_variable] = ACTIONS(8204),
    [sym_global_variable] = ACTIONS(8204),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8206),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8206),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7635] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9410),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5178),
    [sym_scope_resolution] = STATE(5174),
    [sym_call] = STATE(5174),
    [sym_method_call] = STATE(5178),
    [sym_assignment] = STATE(9410),
    [sym_operator_assignment] = STATE(9410),
    [sym_conditional] = STATE(9410),
    [sym_range] = STATE(9410),
    [sym_binary] = STATE(9410),
    [sym_unary] = STATE(9410),
    [sym_left_assignment_list] = STATE(5177),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5178),
    [sym__variable] = STATE(5174),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5178),
    [sym_false] = STATE(5178),
    [sym_nil] = STATE(5178),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7631),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8186),
    [anon_sym_yield] = ACTIONS(8188),
    [anon_sym_break] = ACTIONS(8190),
    [anon_sym_next] = ACTIONS(8192),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11186),
    [anon_sym_defined_QMARK] = ACTIONS(8194),
    [anon_sym_not] = ACTIONS(8196),
    [anon_sym_BANG] = ACTIONS(8200),
    [anon_sym_TILDE] = ACTIONS(8200),
    [sym_constant] = ACTIONS(8206),
    [sym_identifier] = ACTIONS(8206),
    [sym_instance_variable] = ACTIONS(8204),
    [sym_class_variable] = ACTIONS(8204),
    [sym_global_variable] = ACTIONS(8204),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8206),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8206),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7636] = {
    [anon_sym_COLON] = ACTIONS(13065),
    [sym_comment] = ACTIONS(87),
  },
  [7637] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9412),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5178),
    [sym_scope_resolution] = STATE(5174),
    [sym_call] = STATE(5174),
    [sym_method_call] = STATE(5178),
    [sym_assignment] = STATE(9412),
    [sym_operator_assignment] = STATE(9412),
    [sym_conditional] = STATE(9412),
    [sym_range] = STATE(9412),
    [sym_binary] = STATE(9412),
    [sym_unary] = STATE(9412),
    [sym_left_assignment_list] = STATE(5177),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5178),
    [sym__variable] = STATE(5174),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5178),
    [sym_false] = STATE(5178),
    [sym_nil] = STATE(5178),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7631),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8186),
    [anon_sym_yield] = ACTIONS(8188),
    [anon_sym_break] = ACTIONS(8190),
    [anon_sym_next] = ACTIONS(8192),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11186),
    [anon_sym_defined_QMARK] = ACTIONS(8194),
    [anon_sym_not] = ACTIONS(8196),
    [anon_sym_BANG] = ACTIONS(8200),
    [anon_sym_TILDE] = ACTIONS(8200),
    [sym_constant] = ACTIONS(8206),
    [sym_identifier] = ACTIONS(8206),
    [sym_instance_variable] = ACTIONS(8204),
    [sym_class_variable] = ACTIONS(8204),
    [sym_global_variable] = ACTIONS(8204),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8206),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8206),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7638] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(13067),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_else] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [7639] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(11200),
    [sym__binary_star] = ACTIONS(11202),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(11204),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(11202),
    [anon_sym_AMP] = ACTIONS(11206),
    [anon_sym_LT] = ACTIONS(11208),
    [anon_sym_end] = ACTIONS(1625),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_unless] = ACTIONS(1625),
    [anon_sym_while] = ACTIONS(1625),
    [anon_sym_until] = ACTIONS(1625),
    [anon_sym_rescue] = ACTIONS(1625),
    [anon_sym_else] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(1625),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(11210),
    [anon_sym_DOT_DOT] = ACTIONS(11212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11214),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(11216),
    [anon_sym_AMP_AMP] = ACTIONS(11216),
    [anon_sym_LT_LT] = ACTIONS(11218),
    [anon_sym_GT_GT] = ACTIONS(11218),
    [anon_sym_EQ_EQ] = ACTIONS(11220),
    [anon_sym_BANG_EQ] = ACTIONS(11216),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11216),
    [anon_sym_LT_EQ_GT] = ACTIONS(11216),
    [anon_sym_EQ_TILDE] = ACTIONS(11216),
    [anon_sym_BANG_TILDE] = ACTIONS(11216),
    [anon_sym_LT_EQ] = ACTIONS(11208),
    [anon_sym_GT] = ACTIONS(11208),
    [anon_sym_GT_EQ] = ACTIONS(11222),
    [anon_sym_CARET] = ACTIONS(11224),
    [anon_sym_PLUS] = ACTIONS(11200),
    [anon_sym_SLASH] = ACTIONS(11202),
    [anon_sym_PERCENT] = ACTIONS(11202),
    [sym_comment] = ACTIONS(87),
  },
  [7640] = {
    [sym_heredoc_body] = STATE(9414),
    [aux_sym_call_repeat1] = STATE(9414),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_else] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [7641] = {
    [sym_heredoc_body] = STATE(9414),
    [aux_sym_call_repeat1] = STATE(9414),
    [aux_sym_argument_list_repeat1] = STATE(9416),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(13069),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_else] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [7642] = {
    [sym_string] = STATE(7669),
    [aux_sym_chained_string_repeat1] = STATE(7669),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(13071),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [7643] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(11200),
    [sym__binary_star] = ACTIONS(11202),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(11204),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(11202),
    [anon_sym_AMP] = ACTIONS(11206),
    [anon_sym_LT] = ACTIONS(11208),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(11210),
    [anon_sym_DOT_DOT] = ACTIONS(11212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11214),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(11216),
    [anon_sym_AMP_AMP] = ACTIONS(11216),
    [anon_sym_LT_LT] = ACTIONS(11218),
    [anon_sym_GT_GT] = ACTIONS(11218),
    [anon_sym_EQ_EQ] = ACTIONS(11220),
    [anon_sym_BANG_EQ] = ACTIONS(11216),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11216),
    [anon_sym_LT_EQ_GT] = ACTIONS(11216),
    [anon_sym_EQ_TILDE] = ACTIONS(11216),
    [anon_sym_BANG_TILDE] = ACTIONS(11216),
    [anon_sym_LT_EQ] = ACTIONS(11208),
    [anon_sym_GT] = ACTIONS(11208),
    [anon_sym_GT_EQ] = ACTIONS(11222),
    [anon_sym_CARET] = ACTIONS(11224),
    [anon_sym_PLUS] = ACTIONS(11200),
    [anon_sym_SLASH] = ACTIONS(11202),
    [anon_sym_PERCENT] = ACTIONS(11202),
    [sym_comment] = ACTIONS(87),
  },
  [7644] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9417),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7627),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(7627),
    [sym_assignment] = STATE(9417),
    [sym_operator_assignment] = STATE(9417),
    [sym_conditional] = STATE(9417),
    [sym_range] = STATE(9417),
    [sym_binary] = STATE(9417),
    [sym_unary] = STATE(9417),
    [sym_left_assignment_list] = STATE(7626),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7627),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7627),
    [sym_false] = STATE(7627),
    [sym_nil] = STATE(7627),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7628),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11168),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11170),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_break] = ACTIONS(11174),
    [anon_sym_next] = ACTIONS(11176),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11178),
    [anon_sym_defined_QMARK] = ACTIONS(11180),
    [anon_sym_not] = ACTIONS(11182),
    [anon_sym_BANG] = ACTIONS(11184),
    [anon_sym_TILDE] = ACTIONS(11184),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7645] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9418),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5178),
    [sym_scope_resolution] = STATE(5174),
    [sym_call] = STATE(5174),
    [sym_method_call] = STATE(5178),
    [sym_assignment] = STATE(9418),
    [sym_operator_assignment] = STATE(9418),
    [sym_conditional] = STATE(9418),
    [sym_range] = STATE(9418),
    [sym_binary] = STATE(9418),
    [sym_unary] = STATE(9418),
    [sym_left_assignment_list] = STATE(5177),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5178),
    [sym__variable] = STATE(5174),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5178),
    [sym_false] = STATE(5178),
    [sym_nil] = STATE(5178),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7631),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8186),
    [anon_sym_yield] = ACTIONS(8188),
    [anon_sym_break] = ACTIONS(8190),
    [anon_sym_next] = ACTIONS(8192),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11186),
    [anon_sym_defined_QMARK] = ACTIONS(8194),
    [anon_sym_not] = ACTIONS(8196),
    [anon_sym_BANG] = ACTIONS(8200),
    [anon_sym_TILDE] = ACTIONS(8200),
    [sym_constant] = ACTIONS(8206),
    [sym_identifier] = ACTIONS(8206),
    [sym_instance_variable] = ACTIONS(8204),
    [sym_class_variable] = ACTIONS(8204),
    [sym_global_variable] = ACTIONS(8204),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8206),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8206),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7646] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9419),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5178),
    [sym_scope_resolution] = STATE(5174),
    [sym_call] = STATE(5174),
    [sym_method_call] = STATE(5178),
    [sym_assignment] = STATE(9419),
    [sym_operator_assignment] = STATE(9419),
    [sym_conditional] = STATE(9419),
    [sym_range] = STATE(9419),
    [sym_binary] = STATE(9419),
    [sym_unary] = STATE(9419),
    [sym_left_assignment_list] = STATE(5177),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5178),
    [sym__variable] = STATE(5174),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5178),
    [sym_false] = STATE(5178),
    [sym_nil] = STATE(5178),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7631),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8186),
    [anon_sym_yield] = ACTIONS(8188),
    [anon_sym_break] = ACTIONS(8190),
    [anon_sym_next] = ACTIONS(8192),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11186),
    [anon_sym_defined_QMARK] = ACTIONS(8194),
    [anon_sym_not] = ACTIONS(8196),
    [anon_sym_BANG] = ACTIONS(8200),
    [anon_sym_TILDE] = ACTIONS(8200),
    [sym_constant] = ACTIONS(8206),
    [sym_identifier] = ACTIONS(8206),
    [sym_instance_variable] = ACTIONS(8204),
    [sym_class_variable] = ACTIONS(8204),
    [sym_global_variable] = ACTIONS(8204),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8206),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8206),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7647] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9420),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5178),
    [sym_scope_resolution] = STATE(5174),
    [sym_call] = STATE(5174),
    [sym_method_call] = STATE(5178),
    [sym_assignment] = STATE(9420),
    [sym_operator_assignment] = STATE(9420),
    [sym_conditional] = STATE(9420),
    [sym_range] = STATE(9420),
    [sym_binary] = STATE(9420),
    [sym_unary] = STATE(9420),
    [sym_left_assignment_list] = STATE(5177),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5178),
    [sym__variable] = STATE(5174),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5178),
    [sym_false] = STATE(5178),
    [sym_nil] = STATE(5178),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7631),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8186),
    [anon_sym_yield] = ACTIONS(8188),
    [anon_sym_break] = ACTIONS(8190),
    [anon_sym_next] = ACTIONS(8192),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11186),
    [anon_sym_defined_QMARK] = ACTIONS(8194),
    [anon_sym_not] = ACTIONS(8196),
    [anon_sym_BANG] = ACTIONS(8200),
    [anon_sym_TILDE] = ACTIONS(8200),
    [sym_constant] = ACTIONS(8206),
    [sym_identifier] = ACTIONS(8206),
    [sym_instance_variable] = ACTIONS(8204),
    [sym_class_variable] = ACTIONS(8204),
    [sym_global_variable] = ACTIONS(8204),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8206),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8206),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7648] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9421),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5178),
    [sym_scope_resolution] = STATE(5174),
    [sym_call] = STATE(5174),
    [sym_method_call] = STATE(5178),
    [sym_assignment] = STATE(9421),
    [sym_operator_assignment] = STATE(9421),
    [sym_conditional] = STATE(9421),
    [sym_range] = STATE(9421),
    [sym_binary] = STATE(9421),
    [sym_unary] = STATE(9421),
    [sym_left_assignment_list] = STATE(5177),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5178),
    [sym__variable] = STATE(5174),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5178),
    [sym_false] = STATE(5178),
    [sym_nil] = STATE(5178),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7631),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8186),
    [anon_sym_yield] = ACTIONS(8188),
    [anon_sym_break] = ACTIONS(8190),
    [anon_sym_next] = ACTIONS(8192),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11186),
    [anon_sym_defined_QMARK] = ACTIONS(8194),
    [anon_sym_not] = ACTIONS(8196),
    [anon_sym_BANG] = ACTIONS(8200),
    [anon_sym_TILDE] = ACTIONS(8200),
    [sym_constant] = ACTIONS(8206),
    [sym_identifier] = ACTIONS(8206),
    [sym_instance_variable] = ACTIONS(8204),
    [sym_class_variable] = ACTIONS(8204),
    [sym_global_variable] = ACTIONS(8204),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8206),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8206),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7649] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9422),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5178),
    [sym_scope_resolution] = STATE(5174),
    [sym_call] = STATE(5174),
    [sym_method_call] = STATE(5178),
    [sym_assignment] = STATE(9422),
    [sym_operator_assignment] = STATE(9422),
    [sym_conditional] = STATE(9422),
    [sym_range] = STATE(9422),
    [sym_binary] = STATE(9422),
    [sym_unary] = STATE(9422),
    [sym_left_assignment_list] = STATE(5177),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5178),
    [sym__variable] = STATE(5174),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5178),
    [sym_false] = STATE(5178),
    [sym_nil] = STATE(5178),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7631),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8186),
    [anon_sym_yield] = ACTIONS(8188),
    [anon_sym_break] = ACTIONS(8190),
    [anon_sym_next] = ACTIONS(8192),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11186),
    [anon_sym_defined_QMARK] = ACTIONS(8194),
    [anon_sym_not] = ACTIONS(8196),
    [anon_sym_BANG] = ACTIONS(8200),
    [anon_sym_TILDE] = ACTIONS(8200),
    [sym_constant] = ACTIONS(8206),
    [sym_identifier] = ACTIONS(8206),
    [sym_instance_variable] = ACTIONS(8204),
    [sym_class_variable] = ACTIONS(8204),
    [sym_global_variable] = ACTIONS(8204),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8206),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8206),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7650] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(9423),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(9423),
    [sym_operator_assignment] = STATE(9423),
    [sym_conditional] = STATE(9423),
    [sym_range] = STATE(9423),
    [sym_binary] = STATE(9423),
    [sym_unary] = STATE(9423),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [7651] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9424),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5178),
    [sym_scope_resolution] = STATE(5174),
    [sym_call] = STATE(5174),
    [sym_method_call] = STATE(5178),
    [sym_assignment] = STATE(9424),
    [sym_operator_assignment] = STATE(9424),
    [sym_conditional] = STATE(9424),
    [sym_range] = STATE(9424),
    [sym_binary] = STATE(9424),
    [sym_unary] = STATE(9424),
    [sym_left_assignment_list] = STATE(5177),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5178),
    [sym__variable] = STATE(5174),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5178),
    [sym_false] = STATE(5178),
    [sym_nil] = STATE(5178),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7631),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8186),
    [anon_sym_yield] = ACTIONS(8188),
    [anon_sym_break] = ACTIONS(8190),
    [anon_sym_next] = ACTIONS(8192),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11186),
    [anon_sym_defined_QMARK] = ACTIONS(8194),
    [anon_sym_not] = ACTIONS(8196),
    [anon_sym_BANG] = ACTIONS(8200),
    [anon_sym_TILDE] = ACTIONS(8200),
    [sym_constant] = ACTIONS(8206),
    [sym_identifier] = ACTIONS(8206),
    [sym_instance_variable] = ACTIONS(8204),
    [sym_class_variable] = ACTIONS(8204),
    [sym_global_variable] = ACTIONS(8204),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8206),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8206),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7652] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9425),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5178),
    [sym_scope_resolution] = STATE(5174),
    [sym_call] = STATE(5174),
    [sym_method_call] = STATE(5178),
    [sym_assignment] = STATE(9425),
    [sym_operator_assignment] = STATE(9425),
    [sym_conditional] = STATE(9425),
    [sym_range] = STATE(9425),
    [sym_binary] = STATE(9425),
    [sym_unary] = STATE(9425),
    [sym_left_assignment_list] = STATE(5177),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5178),
    [sym__variable] = STATE(5174),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5178),
    [sym_false] = STATE(5178),
    [sym_nil] = STATE(5178),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7631),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8186),
    [anon_sym_yield] = ACTIONS(8188),
    [anon_sym_break] = ACTIONS(8190),
    [anon_sym_next] = ACTIONS(8192),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11186),
    [anon_sym_defined_QMARK] = ACTIONS(8194),
    [anon_sym_not] = ACTIONS(8196),
    [anon_sym_BANG] = ACTIONS(8200),
    [anon_sym_TILDE] = ACTIONS(8200),
    [sym_constant] = ACTIONS(8206),
    [sym_identifier] = ACTIONS(8206),
    [sym_instance_variable] = ACTIONS(8204),
    [sym_class_variable] = ACTIONS(8204),
    [sym_global_variable] = ACTIONS(8204),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8206),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8206),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7653] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9426),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5178),
    [sym_scope_resolution] = STATE(5174),
    [sym_call] = STATE(5174),
    [sym_method_call] = STATE(5178),
    [sym_assignment] = STATE(9426),
    [sym_operator_assignment] = STATE(9426),
    [sym_conditional] = STATE(9426),
    [sym_range] = STATE(9426),
    [sym_binary] = STATE(9426),
    [sym_unary] = STATE(9426),
    [sym_left_assignment_list] = STATE(5177),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5178),
    [sym__variable] = STATE(5174),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5178),
    [sym_false] = STATE(5178),
    [sym_nil] = STATE(5178),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7631),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8186),
    [anon_sym_yield] = ACTIONS(8188),
    [anon_sym_break] = ACTIONS(8190),
    [anon_sym_next] = ACTIONS(8192),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11186),
    [anon_sym_defined_QMARK] = ACTIONS(8194),
    [anon_sym_not] = ACTIONS(8196),
    [anon_sym_BANG] = ACTIONS(8200),
    [anon_sym_TILDE] = ACTIONS(8200),
    [sym_constant] = ACTIONS(8206),
    [sym_identifier] = ACTIONS(8206),
    [sym_instance_variable] = ACTIONS(8204),
    [sym_class_variable] = ACTIONS(8204),
    [sym_global_variable] = ACTIONS(8204),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8206),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8206),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7654] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9427),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5178),
    [sym_scope_resolution] = STATE(5174),
    [sym_call] = STATE(5174),
    [sym_method_call] = STATE(5178),
    [sym_assignment] = STATE(9427),
    [sym_operator_assignment] = STATE(9427),
    [sym_conditional] = STATE(9427),
    [sym_range] = STATE(9427),
    [sym_binary] = STATE(9427),
    [sym_unary] = STATE(9427),
    [sym_left_assignment_list] = STATE(5177),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5178),
    [sym__variable] = STATE(5174),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5178),
    [sym_false] = STATE(5178),
    [sym_nil] = STATE(5178),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7631),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8186),
    [anon_sym_yield] = ACTIONS(8188),
    [anon_sym_break] = ACTIONS(8190),
    [anon_sym_next] = ACTIONS(8192),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11186),
    [anon_sym_defined_QMARK] = ACTIONS(8194),
    [anon_sym_not] = ACTIONS(8196),
    [anon_sym_BANG] = ACTIONS(8200),
    [anon_sym_TILDE] = ACTIONS(8200),
    [sym_constant] = ACTIONS(8206),
    [sym_identifier] = ACTIONS(8206),
    [sym_instance_variable] = ACTIONS(8204),
    [sym_class_variable] = ACTIONS(8204),
    [sym_global_variable] = ACTIONS(8204),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8206),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8206),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7655] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(9428),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5214),
    [sym_scope_resolution] = STATE(5210),
    [sym_call] = STATE(5210),
    [sym_method_call] = STATE(5214),
    [sym_assignment] = STATE(9428),
    [sym_operator_assignment] = STATE(9428),
    [sym_conditional] = STATE(9428),
    [sym_range] = STATE(9428),
    [sym_binary] = STATE(9428),
    [sym_unary] = STATE(9428),
    [sym_left_assignment_list] = STATE(5213),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5214),
    [sym__variable] = STATE(5210),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5214),
    [sym_false] = STATE(5214),
    [sym_nil] = STATE(5214),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7700),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(8252),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(8256),
    [anon_sym_yield] = ACTIONS(8258),
    [anon_sym_break] = ACTIONS(8260),
    [anon_sym_next] = ACTIONS(8262),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(11266),
    [anon_sym_defined_QMARK] = ACTIONS(8264),
    [anon_sym_not] = ACTIONS(8266),
    [anon_sym_BANG] = ACTIONS(8270),
    [anon_sym_TILDE] = ACTIONS(8270),
    [sym_constant] = ACTIONS(8276),
    [sym_identifier] = ACTIONS(8276),
    [sym_instance_variable] = ACTIONS(8274),
    [sym_class_variable] = ACTIONS(8274),
    [sym_global_variable] = ACTIONS(8274),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8276),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8276),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7656] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(9429),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5214),
    [sym_scope_resolution] = STATE(5210),
    [sym_call] = STATE(5210),
    [sym_method_call] = STATE(5214),
    [sym_assignment] = STATE(9429),
    [sym_operator_assignment] = STATE(9429),
    [sym_conditional] = STATE(9429),
    [sym_range] = STATE(9429),
    [sym_binary] = STATE(9429),
    [sym_unary] = STATE(9429),
    [sym_left_assignment_list] = STATE(5213),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5214),
    [sym__variable] = STATE(5210),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5214),
    [sym_false] = STATE(5214),
    [sym_nil] = STATE(5214),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7700),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(8252),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(8256),
    [anon_sym_yield] = ACTIONS(8258),
    [anon_sym_break] = ACTIONS(8260),
    [anon_sym_next] = ACTIONS(8262),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(11266),
    [anon_sym_defined_QMARK] = ACTIONS(8264),
    [anon_sym_not] = ACTIONS(8266),
    [anon_sym_BANG] = ACTIONS(8270),
    [anon_sym_TILDE] = ACTIONS(8270),
    [sym_constant] = ACTIONS(8276),
    [sym_identifier] = ACTIONS(8276),
    [sym_instance_variable] = ACTIONS(8274),
    [sym_class_variable] = ACTIONS(8274),
    [sym_global_variable] = ACTIONS(8274),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8276),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8276),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7657] = {
    [anon_sym_COLON] = ACTIONS(13073),
    [sym_comment] = ACTIONS(87),
  },
  [7658] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(9431),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5214),
    [sym_scope_resolution] = STATE(5210),
    [sym_call] = STATE(5210),
    [sym_method_call] = STATE(5214),
    [sym_assignment] = STATE(9431),
    [sym_operator_assignment] = STATE(9431),
    [sym_conditional] = STATE(9431),
    [sym_range] = STATE(9431),
    [sym_binary] = STATE(9431),
    [sym_unary] = STATE(9431),
    [sym_left_assignment_list] = STATE(5213),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5214),
    [sym__variable] = STATE(5210),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5214),
    [sym_false] = STATE(5214),
    [sym_nil] = STATE(5214),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7700),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(8252),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(8256),
    [anon_sym_yield] = ACTIONS(8258),
    [anon_sym_break] = ACTIONS(8260),
    [anon_sym_next] = ACTIONS(8262),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(11266),
    [anon_sym_defined_QMARK] = ACTIONS(8264),
    [anon_sym_not] = ACTIONS(8266),
    [anon_sym_BANG] = ACTIONS(8270),
    [anon_sym_TILDE] = ACTIONS(8270),
    [sym_constant] = ACTIONS(8276),
    [sym_identifier] = ACTIONS(8276),
    [sym_instance_variable] = ACTIONS(8274),
    [sym_class_variable] = ACTIONS(8274),
    [sym_global_variable] = ACTIONS(8274),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8276),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8276),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7659] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(13075),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_else] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [7660] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(11272),
    [sym__binary_star] = ACTIONS(11274),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(11276),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(11278),
    [anon_sym_AMP] = ACTIONS(11280),
    [anon_sym_EQ] = ACTIONS(1631),
    [anon_sym_LT] = ACTIONS(11282),
    [anon_sym_end] = ACTIONS(1625),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_unless] = ACTIONS(1625),
    [anon_sym_while] = ACTIONS(1625),
    [anon_sym_until] = ACTIONS(1625),
    [anon_sym_rescue] = ACTIONS(1625),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_else] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(1625),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_PLUS_EQ] = ACTIONS(1625),
    [anon_sym_DASH_EQ] = ACTIONS(1625),
    [anon_sym_STAR_EQ] = ACTIONS(1625),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1625),
    [anon_sym_SLASH_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1625),
    [anon_sym_AMP_EQ] = ACTIONS(1625),
    [anon_sym_PERCENT_EQ] = ACTIONS(1625),
    [anon_sym_GT_GT_EQ] = ACTIONS(1625),
    [anon_sym_LT_LT_EQ] = ACTIONS(1625),
    [anon_sym_CARET_EQ] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(11284),
    [anon_sym_DOT_DOT] = ACTIONS(11286),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11288),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(11290),
    [anon_sym_AMP_AMP] = ACTIONS(11290),
    [anon_sym_LT_LT] = ACTIONS(11292),
    [anon_sym_GT_GT] = ACTIONS(11292),
    [anon_sym_EQ_EQ] = ACTIONS(11290),
    [anon_sym_BANG_EQ] = ACTIONS(11294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11294),
    [anon_sym_LT_EQ_GT] = ACTIONS(11294),
    [anon_sym_EQ_TILDE] = ACTIONS(11294),
    [anon_sym_BANG_TILDE] = ACTIONS(11294),
    [anon_sym_LT_EQ] = ACTIONS(11282),
    [anon_sym_GT] = ACTIONS(11282),
    [anon_sym_GT_EQ] = ACTIONS(11296),
    [anon_sym_CARET] = ACTIONS(11276),
    [anon_sym_PLUS] = ACTIONS(11298),
    [anon_sym_SLASH] = ACTIONS(11278),
    [anon_sym_PERCENT] = ACTIONS(11278),
    [sym_comment] = ACTIONS(87),
  },
  [7661] = {
    [sym_heredoc_body] = STATE(9433),
    [aux_sym_call_repeat1] = STATE(9433),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_else] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [7662] = {
    [sym_heredoc_body] = STATE(9433),
    [aux_sym_call_repeat1] = STATE(9433),
    [aux_sym_argument_list_repeat1] = STATE(9435),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(13077),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_else] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [7663] = {
    [sym_string] = STATE(7720),
    [aux_sym_chained_string_repeat1] = STATE(7720),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(747),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(13079),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [7664] = {
    [sym_heredoc_body] = STATE(9436),
    [aux_sym_call_repeat1] = STATE(9436),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_else] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [7665] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5173),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5178),
    [sym_scope_resolution] = STATE(5174),
    [sym_call] = STATE(5174),
    [sym_method_call] = STATE(5178),
    [sym__argument] = STATE(2565),
    [sym_splat_argument] = STATE(2565),
    [sym_hash_splat_argument] = STATE(2565),
    [sym_block_argument] = STATE(2565),
    [sym_assignment] = STATE(5173),
    [sym_operator_assignment] = STATE(5173),
    [sym_conditional] = STATE(5173),
    [sym_range] = STATE(5173),
    [sym_binary] = STATE(5173),
    [sym_unary] = STATE(5173),
    [sym_left_assignment_list] = STATE(5177),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5178),
    [sym__variable] = STATE(5174),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5178),
    [sym_false] = STATE(5178),
    [sym_nil] = STATE(5178),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5179),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(9437),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2565),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(8178),
    [sym__splat_star] = ACTIONS(8180),
    [sym__unary_minus] = ACTIONS(8182),
    [sym__identifier_hash_key] = ACTIONS(8184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13081),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8186),
    [anon_sym_yield] = ACTIONS(8188),
    [anon_sym_break] = ACTIONS(8190),
    [anon_sym_next] = ACTIONS(8192),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11186),
    [anon_sym_defined_QMARK] = ACTIONS(8194),
    [anon_sym_not] = ACTIONS(8196),
    [anon_sym_BANG] = ACTIONS(8200),
    [anon_sym_TILDE] = ACTIONS(8200),
    [sym_constant] = ACTIONS(8202),
    [sym_identifier] = ACTIONS(8202),
    [sym_instance_variable] = ACTIONS(8204),
    [sym_class_variable] = ACTIONS(8204),
    [sym_global_variable] = ACTIONS(8204),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8206),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8206),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7666] = {
    [sym_heredoc_body] = STATE(9438),
    [aux_sym_call_repeat1] = STATE(9438),
    [aux_sym_argument_list_repeat1] = STATE(9439),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(11234),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_else] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [7667] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9440),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5178),
    [sym_scope_resolution] = STATE(5174),
    [sym_call] = STATE(5174),
    [sym_method_call] = STATE(5178),
    [sym_splat_argument] = STATE(9441),
    [sym_assignment] = STATE(9440),
    [sym_operator_assignment] = STATE(9440),
    [sym_conditional] = STATE(9440),
    [sym_range] = STATE(9440),
    [sym_binary] = STATE(9440),
    [sym_unary] = STATE(9440),
    [sym_right_assignment_list] = STATE(2570),
    [sym__arg_or_splat_arg] = STATE(9441),
    [sym_left_assignment_list] = STATE(5177),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5178),
    [sym__variable] = STATE(5174),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5178),
    [sym_false] = STATE(5178),
    [sym_nil] = STATE(5178),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7631),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__splat_star] = ACTIONS(11192),
    [sym__unary_minus] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8186),
    [anon_sym_yield] = ACTIONS(8188),
    [anon_sym_break] = ACTIONS(8190),
    [anon_sym_next] = ACTIONS(8192),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11186),
    [anon_sym_defined_QMARK] = ACTIONS(8194),
    [anon_sym_not] = ACTIONS(8196),
    [anon_sym_BANG] = ACTIONS(8200),
    [anon_sym_TILDE] = ACTIONS(8200),
    [sym_constant] = ACTIONS(8206),
    [sym_identifier] = ACTIONS(8206),
    [sym_instance_variable] = ACTIONS(8204),
    [sym_class_variable] = ACTIONS(8204),
    [sym_global_variable] = ACTIONS(8204),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8206),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8206),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7668] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9442),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5178),
    [sym_scope_resolution] = STATE(5174),
    [sym_call] = STATE(5174),
    [sym_method_call] = STATE(5178),
    [sym_assignment] = STATE(9442),
    [sym_operator_assignment] = STATE(9442),
    [sym_conditional] = STATE(9442),
    [sym_range] = STATE(9442),
    [sym_binary] = STATE(9442),
    [sym_unary] = STATE(9442),
    [sym_left_assignment_list] = STATE(5177),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5178),
    [sym__variable] = STATE(5174),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5178),
    [sym_false] = STATE(5178),
    [sym_nil] = STATE(5178),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7631),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8186),
    [anon_sym_yield] = ACTIONS(8188),
    [anon_sym_break] = ACTIONS(8190),
    [anon_sym_next] = ACTIONS(8192),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11186),
    [anon_sym_defined_QMARK] = ACTIONS(8194),
    [anon_sym_not] = ACTIONS(8196),
    [anon_sym_BANG] = ACTIONS(8200),
    [anon_sym_TILDE] = ACTIONS(8200),
    [sym_constant] = ACTIONS(8206),
    [sym_identifier] = ACTIONS(8206),
    [sym_instance_variable] = ACTIONS(8204),
    [sym_class_variable] = ACTIONS(8204),
    [sym_global_variable] = ACTIONS(8204),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8206),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8206),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7669] = {
    [sym_string] = STATE(9443),
    [aux_sym_chained_string_repeat1] = STATE(9443),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_end] = ACTIONS(2753),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_else] = ACTIONS(2753),
    [anon_sym_EQ_GT] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [7670] = {
    [aux_sym_undef_repeat1] = STATE(9444),
    [sym__line_break] = ACTIONS(5497),
    [sym__heredoc_body_start] = ACTIONS(5497),
    [anon_sym_COMMA] = ACTIONS(2253),
    [anon_sym_SEMI] = ACTIONS(5497),
    [anon_sym_end] = ACTIONS(5497),
    [anon_sym_if] = ACTIONS(5497),
    [anon_sym_unless] = ACTIONS(5497),
    [anon_sym_while] = ACTIONS(5497),
    [anon_sym_until] = ACTIONS(5497),
    [anon_sym_rescue] = ACTIONS(5497),
    [anon_sym_else] = ACTIONS(5497),
    [sym_comment] = ACTIONS(87),
  },
  [7671] = {
    [sym__line_break] = ACTIONS(5815),
    [sym__heredoc_body_start] = ACTIONS(5815),
    [sym__binary_minus] = ACTIONS(8220),
    [sym__binary_star] = ACTIONS(8222),
    [anon_sym_PIPE] = ACTIONS(8224),
    [anon_sym_SEMI] = ACTIONS(5815),
    [anon_sym_STAR_STAR] = ACTIONS(8222),
    [anon_sym_AMP] = ACTIONS(8226),
    [anon_sym_LT] = ACTIONS(8228),
    [anon_sym_end] = ACTIONS(5815),
    [anon_sym_if] = ACTIONS(5815),
    [anon_sym_unless] = ACTIONS(5815),
    [anon_sym_while] = ACTIONS(5815),
    [anon_sym_until] = ACTIONS(5815),
    [anon_sym_rescue] = ACTIONS(5815),
    [anon_sym_else] = ACTIONS(5815),
    [anon_sym_QMARK] = ACTIONS(8230),
    [anon_sym_DOT_DOT] = ACTIONS(8232),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8234),
    [anon_sym_and] = ACTIONS(8236),
    [anon_sym_or] = ACTIONS(8236),
    [anon_sym_PIPE_PIPE] = ACTIONS(8238),
    [anon_sym_AMP_AMP] = ACTIONS(8238),
    [anon_sym_LT_LT] = ACTIONS(8240),
    [anon_sym_GT_GT] = ACTIONS(8240),
    [anon_sym_EQ_EQ] = ACTIONS(8242),
    [anon_sym_BANG_EQ] = ACTIONS(8238),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8238),
    [anon_sym_LT_EQ_GT] = ACTIONS(8238),
    [anon_sym_EQ_TILDE] = ACTIONS(8238),
    [anon_sym_BANG_TILDE] = ACTIONS(8238),
    [anon_sym_LT_EQ] = ACTIONS(8228),
    [anon_sym_GT] = ACTIONS(8228),
    [anon_sym_GT_EQ] = ACTIONS(8244),
    [anon_sym_CARET] = ACTIONS(8246),
    [anon_sym_PLUS] = ACTIONS(8220),
    [anon_sym_SLASH] = ACTIONS(8222),
    [anon_sym_PERCENT] = ACTIONS(8222),
    [sym_comment] = ACTIONS(87),
  },
  [7672] = {
    [sym__line_break] = ACTIONS(5817),
    [sym__heredoc_body_start] = ACTIONS(5817),
    [sym__binary_minus] = ACTIONS(8220),
    [sym__binary_star] = ACTIONS(8222),
    [anon_sym_PIPE] = ACTIONS(8224),
    [anon_sym_SEMI] = ACTIONS(5817),
    [anon_sym_STAR_STAR] = ACTIONS(8222),
    [anon_sym_AMP] = ACTIONS(8226),
    [anon_sym_LT] = ACTIONS(8228),
    [anon_sym_end] = ACTIONS(5817),
    [anon_sym_if] = ACTIONS(5817),
    [anon_sym_unless] = ACTIONS(5817),
    [anon_sym_while] = ACTIONS(5817),
    [anon_sym_until] = ACTIONS(5817),
    [anon_sym_rescue] = ACTIONS(5817),
    [anon_sym_else] = ACTIONS(5817),
    [anon_sym_QMARK] = ACTIONS(8230),
    [anon_sym_DOT_DOT] = ACTIONS(8232),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8234),
    [anon_sym_and] = ACTIONS(8236),
    [anon_sym_or] = ACTIONS(8236),
    [anon_sym_PIPE_PIPE] = ACTIONS(8238),
    [anon_sym_AMP_AMP] = ACTIONS(8238),
    [anon_sym_LT_LT] = ACTIONS(8240),
    [anon_sym_GT_GT] = ACTIONS(8240),
    [anon_sym_EQ_EQ] = ACTIONS(8242),
    [anon_sym_BANG_EQ] = ACTIONS(8238),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8238),
    [anon_sym_LT_EQ_GT] = ACTIONS(8238),
    [anon_sym_EQ_TILDE] = ACTIONS(8238),
    [anon_sym_BANG_TILDE] = ACTIONS(8238),
    [anon_sym_LT_EQ] = ACTIONS(8228),
    [anon_sym_GT] = ACTIONS(8228),
    [anon_sym_GT_EQ] = ACTIONS(8244),
    [anon_sym_CARET] = ACTIONS(8246),
    [anon_sym_PLUS] = ACTIONS(8220),
    [anon_sym_SLASH] = ACTIONS(8222),
    [anon_sym_PERCENT] = ACTIONS(8222),
    [sym_comment] = ACTIONS(87),
  },
  [7673] = {
    [sym__line_break] = ACTIONS(5819),
    [sym__heredoc_body_start] = ACTIONS(5819),
    [sym__binary_minus] = ACTIONS(8220),
    [sym__binary_star] = ACTIONS(8222),
    [anon_sym_PIPE] = ACTIONS(8224),
    [anon_sym_SEMI] = ACTIONS(5819),
    [anon_sym_STAR_STAR] = ACTIONS(8222),
    [anon_sym_AMP] = ACTIONS(8226),
    [anon_sym_LT] = ACTIONS(8228),
    [anon_sym_end] = ACTIONS(5819),
    [anon_sym_if] = ACTIONS(5819),
    [anon_sym_unless] = ACTIONS(5819),
    [anon_sym_while] = ACTIONS(5819),
    [anon_sym_until] = ACTIONS(5819),
    [anon_sym_rescue] = ACTIONS(5819),
    [anon_sym_else] = ACTIONS(5819),
    [anon_sym_QMARK] = ACTIONS(8230),
    [anon_sym_DOT_DOT] = ACTIONS(8232),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8234),
    [anon_sym_and] = ACTIONS(8236),
    [anon_sym_or] = ACTIONS(8236),
    [anon_sym_PIPE_PIPE] = ACTIONS(8238),
    [anon_sym_AMP_AMP] = ACTIONS(8238),
    [anon_sym_LT_LT] = ACTIONS(8240),
    [anon_sym_GT_GT] = ACTIONS(8240),
    [anon_sym_EQ_EQ] = ACTIONS(8242),
    [anon_sym_BANG_EQ] = ACTIONS(8238),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8238),
    [anon_sym_LT_EQ_GT] = ACTIONS(8238),
    [anon_sym_EQ_TILDE] = ACTIONS(8238),
    [anon_sym_BANG_TILDE] = ACTIONS(8238),
    [anon_sym_LT_EQ] = ACTIONS(8228),
    [anon_sym_GT] = ACTIONS(8228),
    [anon_sym_GT_EQ] = ACTIONS(8244),
    [anon_sym_CARET] = ACTIONS(8246),
    [anon_sym_PLUS] = ACTIONS(8220),
    [anon_sym_SLASH] = ACTIONS(8222),
    [anon_sym_PERCENT] = ACTIONS(8222),
    [sym_comment] = ACTIONS(87),
  },
  [7674] = {
    [sym__line_break] = ACTIONS(5821),
    [sym__heredoc_body_start] = ACTIONS(5821),
    [sym__binary_minus] = ACTIONS(8220),
    [sym__binary_star] = ACTIONS(8222),
    [anon_sym_PIPE] = ACTIONS(8224),
    [anon_sym_SEMI] = ACTIONS(5821),
    [anon_sym_STAR_STAR] = ACTIONS(8222),
    [anon_sym_AMP] = ACTIONS(8226),
    [anon_sym_LT] = ACTIONS(8228),
    [anon_sym_end] = ACTIONS(5821),
    [anon_sym_if] = ACTIONS(5821),
    [anon_sym_unless] = ACTIONS(5821),
    [anon_sym_while] = ACTIONS(5821),
    [anon_sym_until] = ACTIONS(5821),
    [anon_sym_rescue] = ACTIONS(5821),
    [anon_sym_else] = ACTIONS(5821),
    [anon_sym_QMARK] = ACTIONS(8230),
    [anon_sym_DOT_DOT] = ACTIONS(8232),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8234),
    [anon_sym_and] = ACTIONS(8236),
    [anon_sym_or] = ACTIONS(8236),
    [anon_sym_PIPE_PIPE] = ACTIONS(8238),
    [anon_sym_AMP_AMP] = ACTIONS(8238),
    [anon_sym_LT_LT] = ACTIONS(8240),
    [anon_sym_GT_GT] = ACTIONS(8240),
    [anon_sym_EQ_EQ] = ACTIONS(8242),
    [anon_sym_BANG_EQ] = ACTIONS(8238),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8238),
    [anon_sym_LT_EQ_GT] = ACTIONS(8238),
    [anon_sym_EQ_TILDE] = ACTIONS(8238),
    [anon_sym_BANG_TILDE] = ACTIONS(8238),
    [anon_sym_LT_EQ] = ACTIONS(8228),
    [anon_sym_GT] = ACTIONS(8228),
    [anon_sym_GT_EQ] = ACTIONS(8244),
    [anon_sym_CARET] = ACTIONS(8246),
    [anon_sym_PLUS] = ACTIONS(8220),
    [anon_sym_SLASH] = ACTIONS(8222),
    [anon_sym_PERCENT] = ACTIONS(8222),
    [sym_comment] = ACTIONS(87),
  },
  [7675] = {
    [sym__line_break] = ACTIONS(5823),
    [sym__heredoc_body_start] = ACTIONS(5823),
    [sym__binary_minus] = ACTIONS(8220),
    [sym__binary_star] = ACTIONS(8222),
    [anon_sym_PIPE] = ACTIONS(8224),
    [anon_sym_SEMI] = ACTIONS(5823),
    [anon_sym_STAR_STAR] = ACTIONS(8222),
    [anon_sym_AMP] = ACTIONS(8226),
    [anon_sym_LT] = ACTIONS(8228),
    [anon_sym_end] = ACTIONS(5823),
    [anon_sym_if] = ACTIONS(5823),
    [anon_sym_unless] = ACTIONS(5823),
    [anon_sym_while] = ACTIONS(5823),
    [anon_sym_until] = ACTIONS(5823),
    [anon_sym_rescue] = ACTIONS(5823),
    [anon_sym_else] = ACTIONS(5823),
    [anon_sym_QMARK] = ACTIONS(8230),
    [anon_sym_DOT_DOT] = ACTIONS(8232),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8234),
    [anon_sym_and] = ACTIONS(8236),
    [anon_sym_or] = ACTIONS(8236),
    [anon_sym_PIPE_PIPE] = ACTIONS(8238),
    [anon_sym_AMP_AMP] = ACTIONS(8238),
    [anon_sym_LT_LT] = ACTIONS(8240),
    [anon_sym_GT_GT] = ACTIONS(8240),
    [anon_sym_EQ_EQ] = ACTIONS(8242),
    [anon_sym_BANG_EQ] = ACTIONS(8238),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8238),
    [anon_sym_LT_EQ_GT] = ACTIONS(8238),
    [anon_sym_EQ_TILDE] = ACTIONS(8238),
    [anon_sym_BANG_TILDE] = ACTIONS(8238),
    [anon_sym_LT_EQ] = ACTIONS(8228),
    [anon_sym_GT] = ACTIONS(8228),
    [anon_sym_GT_EQ] = ACTIONS(8244),
    [anon_sym_CARET] = ACTIONS(8246),
    [anon_sym_PLUS] = ACTIONS(8220),
    [anon_sym_SLASH] = ACTIONS(8222),
    [anon_sym_PERCENT] = ACTIONS(8222),
    [sym_comment] = ACTIONS(87),
  },
  [7676] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(8222),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8222),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(8222),
    [anon_sym_PERCENT] = ACTIONS(8222),
    [sym_comment] = ACTIONS(87),
  },
  [7677] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8222),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [7678] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8220),
    [sym__binary_star] = ACTIONS(8222),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8222),
    [anon_sym_AMP] = ACTIONS(8226),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(8240),
    [anon_sym_GT_GT] = ACTIONS(8240),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(8220),
    [anon_sym_SLASH] = ACTIONS(8222),
    [anon_sym_PERCENT] = ACTIONS(8222),
    [sym_comment] = ACTIONS(87),
  },
  [7679] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8220),
    [sym__binary_star] = ACTIONS(8222),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8222),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(8240),
    [anon_sym_GT_GT] = ACTIONS(8240),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(8220),
    [anon_sym_SLASH] = ACTIONS(8222),
    [anon_sym_PERCENT] = ACTIONS(8222),
    [sym_comment] = ACTIONS(87),
  },
  [7680] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8220),
    [sym__binary_star] = ACTIONS(8222),
    [anon_sym_PIPE] = ACTIONS(8224),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8222),
    [anon_sym_AMP] = ACTIONS(8226),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(8240),
    [anon_sym_GT_GT] = ACTIONS(8240),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(8246),
    [anon_sym_PLUS] = ACTIONS(8220),
    [anon_sym_SLASH] = ACTIONS(8222),
    [anon_sym_PERCENT] = ACTIONS(8222),
    [sym_comment] = ACTIONS(87),
  },
  [7681] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(13083),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [7682] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(8220),
    [sym__binary_star] = ACTIONS(8222),
    [anon_sym_PIPE] = ACTIONS(8224),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(8222),
    [anon_sym_AMP] = ACTIONS(8226),
    [anon_sym_LT] = ACTIONS(8228),
    [anon_sym_end] = ACTIONS(5927),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_else] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(8232),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8234),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(8238),
    [anon_sym_AMP_AMP] = ACTIONS(8238),
    [anon_sym_LT_LT] = ACTIONS(8240),
    [anon_sym_GT_GT] = ACTIONS(8240),
    [anon_sym_EQ_EQ] = ACTIONS(8242),
    [anon_sym_BANG_EQ] = ACTIONS(8238),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8238),
    [anon_sym_LT_EQ_GT] = ACTIONS(8238),
    [anon_sym_EQ_TILDE] = ACTIONS(8238),
    [anon_sym_BANG_TILDE] = ACTIONS(8238),
    [anon_sym_LT_EQ] = ACTIONS(8228),
    [anon_sym_GT] = ACTIONS(8228),
    [anon_sym_GT_EQ] = ACTIONS(8244),
    [anon_sym_CARET] = ACTIONS(8246),
    [anon_sym_PLUS] = ACTIONS(8220),
    [anon_sym_SLASH] = ACTIONS(8222),
    [anon_sym_PERCENT] = ACTIONS(8222),
    [sym_comment] = ACTIONS(87),
  },
  [7683] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8220),
    [sym__binary_star] = ACTIONS(8222),
    [anon_sym_PIPE] = ACTIONS(8224),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8222),
    [anon_sym_AMP] = ACTIONS(8226),
    [anon_sym_LT] = ACTIONS(8228),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(8230),
    [anon_sym_DOT_DOT] = ACTIONS(8232),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8234),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(8238),
    [anon_sym_AMP_AMP] = ACTIONS(8238),
    [anon_sym_LT_LT] = ACTIONS(8240),
    [anon_sym_GT_GT] = ACTIONS(8240),
    [anon_sym_EQ_EQ] = ACTIONS(8242),
    [anon_sym_BANG_EQ] = ACTIONS(8238),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8238),
    [anon_sym_LT_EQ_GT] = ACTIONS(8238),
    [anon_sym_EQ_TILDE] = ACTIONS(8238),
    [anon_sym_BANG_TILDE] = ACTIONS(8238),
    [anon_sym_LT_EQ] = ACTIONS(8228),
    [anon_sym_GT] = ACTIONS(8228),
    [anon_sym_GT_EQ] = ACTIONS(8244),
    [anon_sym_CARET] = ACTIONS(8246),
    [anon_sym_PLUS] = ACTIONS(8220),
    [anon_sym_SLASH] = ACTIONS(8222),
    [anon_sym_PERCENT] = ACTIONS(8222),
    [sym_comment] = ACTIONS(87),
  },
  [7684] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8220),
    [sym__binary_star] = ACTIONS(8222),
    [anon_sym_PIPE] = ACTIONS(8224),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8222),
    [anon_sym_AMP] = ACTIONS(8226),
    [anon_sym_LT] = ACTIONS(8228),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(8240),
    [anon_sym_GT_GT] = ACTIONS(8240),
    [anon_sym_EQ_EQ] = ACTIONS(8242),
    [anon_sym_BANG_EQ] = ACTIONS(8238),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8238),
    [anon_sym_LT_EQ_GT] = ACTIONS(8238),
    [anon_sym_EQ_TILDE] = ACTIONS(8238),
    [anon_sym_BANG_TILDE] = ACTIONS(8238),
    [anon_sym_LT_EQ] = ACTIONS(8228),
    [anon_sym_GT] = ACTIONS(8228),
    [anon_sym_GT_EQ] = ACTIONS(8244),
    [anon_sym_CARET] = ACTIONS(8246),
    [anon_sym_PLUS] = ACTIONS(8220),
    [anon_sym_SLASH] = ACTIONS(8222),
    [anon_sym_PERCENT] = ACTIONS(8222),
    [sym_comment] = ACTIONS(87),
  },
  [7685] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8220),
    [sym__binary_star] = ACTIONS(8222),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8222),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(8220),
    [anon_sym_SLASH] = ACTIONS(8222),
    [anon_sym_PERCENT] = ACTIONS(8222),
    [sym_comment] = ACTIONS(87),
  },
  [7686] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(9446),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7696),
    [sym_scope_resolution] = STATE(7694),
    [sym_call] = STATE(7694),
    [sym_method_call] = STATE(7696),
    [sym_assignment] = STATE(9446),
    [sym_operator_assignment] = STATE(9446),
    [sym_conditional] = STATE(9446),
    [sym_range] = STATE(9446),
    [sym_binary] = STATE(9446),
    [sym_unary] = STATE(9446),
    [sym_left_assignment_list] = STATE(7695),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7696),
    [sym__variable] = STATE(7694),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7696),
    [sym_false] = STATE(7696),
    [sym_nil] = STATE(7696),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7697),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11244),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11246),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_break] = ACTIONS(11250),
    [anon_sym_next] = ACTIONS(11252),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11254),
    [anon_sym_defined_QMARK] = ACTIONS(11256),
    [anon_sym_not] = ACTIONS(11258),
    [anon_sym_BANG] = ACTIONS(11260),
    [anon_sym_TILDE] = ACTIONS(11260),
    [sym_constant] = ACTIONS(11262),
    [sym_identifier] = ACTIONS(11262),
    [sym_instance_variable] = ACTIONS(11264),
    [sym_class_variable] = ACTIONS(11264),
    [sym_global_variable] = ACTIONS(11264),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11262),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11262),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [7687] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5209),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5214),
    [sym_scope_resolution] = STATE(5210),
    [sym_call] = STATE(5210),
    [sym_method_call] = STATE(5214),
    [sym_argument_list] = STATE(3610),
    [sym__argument_list_with_parens] = STATE(5211),
    [sym__argument] = STATE(5212),
    [sym_splat_argument] = STATE(5212),
    [sym_hash_splat_argument] = STATE(5212),
    [sym_block_argument] = STATE(5212),
    [sym_assignment] = STATE(5209),
    [sym_operator_assignment] = STATE(5209),
    [sym_conditional] = STATE(5209),
    [sym_range] = STATE(5209),
    [sym_binary] = STATE(5209),
    [sym_unary] = STATE(5209),
    [sym_left_assignment_list] = STATE(5213),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5214),
    [sym__variable] = STATE(5210),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5214),
    [sym_false] = STATE(5214),
    [sym_nil] = STATE(5214),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5215),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(5212),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(8248),
    [sym__splat_star] = ACTIONS(8250),
    [sym__unary_minus] = ACTIONS(8252),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(8254),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(8256),
    [anon_sym_yield] = ACTIONS(8258),
    [anon_sym_break] = ACTIONS(8260),
    [anon_sym_next] = ACTIONS(8262),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_else] = ACTIONS(377),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(365),
    [anon_sym_DASH_EQ] = ACTIONS(365),
    [anon_sym_STAR_EQ] = ACTIONS(365),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(365),
    [anon_sym_SLASH_EQ] = ACTIONS(365),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(365),
    [anon_sym_PIPE_EQ] = ACTIONS(365),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(365),
    [anon_sym_AMP_EQ] = ACTIONS(365),
    [anon_sym_PERCENT_EQ] = ACTIONS(365),
    [anon_sym_GT_GT_EQ] = ACTIONS(365),
    [anon_sym_LT_LT_EQ] = ACTIONS(365),
    [anon_sym_CARET_EQ] = ACTIONS(365),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_PERCENT] = ACTIONS(377),
    [anon_sym_defined_QMARK] = ACTIONS(8264),
    [anon_sym_not] = ACTIONS(8266),
    [anon_sym_BANG] = ACTIONS(8268),
    [anon_sym_TILDE] = ACTIONS(8270),
    [sym_constant] = ACTIONS(8272),
    [sym_identifier] = ACTIONS(8272),
    [sym_instance_variable] = ACTIONS(8274),
    [sym_class_variable] = ACTIONS(8274),
    [sym_global_variable] = ACTIONS(8274),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8276),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8276),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7688] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5209),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5214),
    [sym_scope_resolution] = STATE(5210),
    [sym_call] = STATE(5210),
    [sym_method_call] = STATE(5214),
    [sym_argument_list] = STATE(3611),
    [sym__argument_list_with_parens] = STATE(5211),
    [sym__argument] = STATE(5212),
    [sym_splat_argument] = STATE(5212),
    [sym_hash_splat_argument] = STATE(5212),
    [sym_block_argument] = STATE(5212),
    [sym_assignment] = STATE(5209),
    [sym_operator_assignment] = STATE(5209),
    [sym_conditional] = STATE(5209),
    [sym_range] = STATE(5209),
    [sym_binary] = STATE(5209),
    [sym_unary] = STATE(5209),
    [sym_left_assignment_list] = STATE(5213),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5214),
    [sym__variable] = STATE(5210),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5214),
    [sym_false] = STATE(5214),
    [sym_nil] = STATE(5214),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5215),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(5212),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(8248),
    [sym__splat_star] = ACTIONS(8250),
    [sym__unary_minus] = ACTIONS(8252),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(8254),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_EQ] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(8256),
    [anon_sym_yield] = ACTIONS(8258),
    [anon_sym_break] = ACTIONS(8260),
    [anon_sym_next] = ACTIONS(8262),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_else] = ACTIONS(419),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(417),
    [anon_sym_DASH_EQ] = ACTIONS(417),
    [anon_sym_STAR_EQ] = ACTIONS(417),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(417),
    [anon_sym_SLASH_EQ] = ACTIONS(417),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(417),
    [anon_sym_PIPE_EQ] = ACTIONS(417),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(417),
    [anon_sym_AMP_EQ] = ACTIONS(417),
    [anon_sym_PERCENT_EQ] = ACTIONS(417),
    [anon_sym_GT_GT_EQ] = ACTIONS(417),
    [anon_sym_LT_LT_EQ] = ACTIONS(417),
    [anon_sym_CARET_EQ] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(8264),
    [anon_sym_not] = ACTIONS(8266),
    [anon_sym_BANG] = ACTIONS(8268),
    [anon_sym_TILDE] = ACTIONS(8270),
    [sym_constant] = ACTIONS(8272),
    [sym_identifier] = ACTIONS(8272),
    [sym_instance_variable] = ACTIONS(8274),
    [sym_class_variable] = ACTIONS(8274),
    [sym_global_variable] = ACTIONS(8274),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8276),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8276),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7689] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5209),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5214),
    [sym_scope_resolution] = STATE(5210),
    [sym_call] = STATE(5210),
    [sym_method_call] = STATE(5214),
    [sym_argument_list] = STATE(3612),
    [sym__argument_list_with_parens] = STATE(5211),
    [sym__argument] = STATE(5212),
    [sym_splat_argument] = STATE(5212),
    [sym_hash_splat_argument] = STATE(5212),
    [sym_block_argument] = STATE(5212),
    [sym_assignment] = STATE(5209),
    [sym_operator_assignment] = STATE(5209),
    [sym_conditional] = STATE(5209),
    [sym_range] = STATE(5209),
    [sym_binary] = STATE(5209),
    [sym_unary] = STATE(5209),
    [sym_left_assignment_list] = STATE(5213),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5214),
    [sym__variable] = STATE(5210),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5214),
    [sym_false] = STATE(5214),
    [sym_nil] = STATE(5214),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5215),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(5212),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(8248),
    [sym__splat_star] = ACTIONS(8250),
    [sym__unary_minus] = ACTIONS(8252),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(8254),
    [anon_sym_LBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_EQ] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(423),
    [anon_sym_return] = ACTIONS(8256),
    [anon_sym_yield] = ACTIONS(8258),
    [anon_sym_break] = ACTIONS(8260),
    [anon_sym_next] = ACTIONS(8262),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_else] = ACTIONS(423),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(421),
    [anon_sym_DASH_EQ] = ACTIONS(421),
    [anon_sym_STAR_EQ] = ACTIONS(421),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(421),
    [anon_sym_SLASH_EQ] = ACTIONS(421),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(421),
    [anon_sym_PIPE_EQ] = ACTIONS(421),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(421),
    [anon_sym_AMP_EQ] = ACTIONS(421),
    [anon_sym_PERCENT_EQ] = ACTIONS(421),
    [anon_sym_GT_GT_EQ] = ACTIONS(421),
    [anon_sym_LT_LT_EQ] = ACTIONS(421),
    [anon_sym_CARET_EQ] = ACTIONS(421),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(8264),
    [anon_sym_not] = ACTIONS(8266),
    [anon_sym_BANG] = ACTIONS(8268),
    [anon_sym_TILDE] = ACTIONS(8270),
    [sym_constant] = ACTIONS(8272),
    [sym_identifier] = ACTIONS(8272),
    [sym_instance_variable] = ACTIONS(8274),
    [sym_class_variable] = ACTIONS(8274),
    [sym_global_variable] = ACTIONS(8274),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8276),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8276),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7690] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5209),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5214),
    [sym_scope_resolution] = STATE(5210),
    [sym_call] = STATE(5210),
    [sym_method_call] = STATE(5214),
    [sym_argument_list] = STATE(3613),
    [sym__argument_list_with_parens] = STATE(5211),
    [sym__argument] = STATE(5212),
    [sym_splat_argument] = STATE(5212),
    [sym_hash_splat_argument] = STATE(5212),
    [sym_block_argument] = STATE(5212),
    [sym_assignment] = STATE(5209),
    [sym_operator_assignment] = STATE(5209),
    [sym_conditional] = STATE(5209),
    [sym_range] = STATE(5209),
    [sym_binary] = STATE(5209),
    [sym_unary] = STATE(5209),
    [sym_left_assignment_list] = STATE(5213),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5214),
    [sym__variable] = STATE(5210),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5214),
    [sym_false] = STATE(5214),
    [sym_nil] = STATE(5214),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5215),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(5212),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(8248),
    [sym__splat_star] = ACTIONS(8250),
    [sym__unary_minus] = ACTIONS(8252),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(8254),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(427),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(427),
    [anon_sym_return] = ACTIONS(8256),
    [anon_sym_yield] = ACTIONS(8258),
    [anon_sym_break] = ACTIONS(8260),
    [anon_sym_next] = ACTIONS(8262),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_else] = ACTIONS(427),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(425),
    [anon_sym_DASH_EQ] = ACTIONS(425),
    [anon_sym_STAR_EQ] = ACTIONS(425),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(425),
    [anon_sym_SLASH_EQ] = ACTIONS(425),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(425),
    [anon_sym_PIPE_EQ] = ACTIONS(425),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(425),
    [anon_sym_AMP_EQ] = ACTIONS(425),
    [anon_sym_PERCENT_EQ] = ACTIONS(425),
    [anon_sym_GT_GT_EQ] = ACTIONS(425),
    [anon_sym_LT_LT_EQ] = ACTIONS(425),
    [anon_sym_CARET_EQ] = ACTIONS(425),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(8264),
    [anon_sym_not] = ACTIONS(8266),
    [anon_sym_BANG] = ACTIONS(8268),
    [anon_sym_TILDE] = ACTIONS(8270),
    [sym_constant] = ACTIONS(8272),
    [sym_identifier] = ACTIONS(8272),
    [sym_instance_variable] = ACTIONS(8274),
    [sym_class_variable] = ACTIONS(8274),
    [sym_global_variable] = ACTIONS(8274),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8276),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8276),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7691] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(9447),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7696),
    [sym_scope_resolution] = STATE(7694),
    [sym_call] = STATE(7694),
    [sym_method_call] = STATE(7696),
    [sym_assignment] = STATE(9447),
    [sym_operator_assignment] = STATE(9447),
    [sym_conditional] = STATE(9447),
    [sym_range] = STATE(9447),
    [sym_binary] = STATE(9447),
    [sym_unary] = STATE(9447),
    [sym_left_assignment_list] = STATE(7695),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7696),
    [sym__variable] = STATE(7694),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7696),
    [sym_false] = STATE(7696),
    [sym_nil] = STATE(7696),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7697),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11244),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11246),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_break] = ACTIONS(11250),
    [anon_sym_next] = ACTIONS(11252),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11254),
    [anon_sym_defined_QMARK] = ACTIONS(11256),
    [anon_sym_not] = ACTIONS(11258),
    [anon_sym_BANG] = ACTIONS(11260),
    [anon_sym_TILDE] = ACTIONS(11260),
    [sym_constant] = ACTIONS(11262),
    [sym_identifier] = ACTIONS(11262),
    [sym_instance_variable] = ACTIONS(11264),
    [sym_class_variable] = ACTIONS(11264),
    [sym_global_variable] = ACTIONS(11264),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11262),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11262),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [7692] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(3628),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7696),
    [sym_scope_resolution] = STATE(7694),
    [sym_call] = STATE(7694),
    [sym_method_call] = STATE(7696),
    [sym_assignment] = STATE(3628),
    [sym_operator_assignment] = STATE(3628),
    [sym_conditional] = STATE(3628),
    [sym_range] = STATE(3628),
    [sym_binary] = STATE(3628),
    [sym_unary] = STATE(3628),
    [sym_left_assignment_list] = STATE(7695),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7696),
    [sym__variable] = STATE(7694),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7696),
    [sym_false] = STATE(7696),
    [sym_nil] = STATE(7696),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7697),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11244),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11246),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_break] = ACTIONS(11250),
    [anon_sym_next] = ACTIONS(11252),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11254),
    [anon_sym_defined_QMARK] = ACTIONS(11256),
    [anon_sym_not] = ACTIONS(11258),
    [anon_sym_BANG] = ACTIONS(11260),
    [anon_sym_TILDE] = ACTIONS(11260),
    [sym_constant] = ACTIONS(11262),
    [sym_identifier] = ACTIONS(11262),
    [sym_instance_variable] = ACTIONS(11264),
    [sym_class_variable] = ACTIONS(11264),
    [sym_global_variable] = ACTIONS(11264),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11262),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11262),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [7693] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(13085),
    [sym__binary_star] = ACTIONS(13087),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(13089),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(13091),
    [anon_sym_AMP] = ACTIONS(13093),
    [anon_sym_EQ] = ACTIONS(4217),
    [anon_sym_LT] = ACTIONS(13095),
    [anon_sym_end] = ACTIONS(4211),
    [anon_sym_if] = ACTIONS(4211),
    [anon_sym_unless] = ACTIONS(4211),
    [anon_sym_while] = ACTIONS(4211),
    [anon_sym_until] = ACTIONS(4211),
    [anon_sym_rescue] = ACTIONS(4211),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_else] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_PLUS_EQ] = ACTIONS(4211),
    [anon_sym_DASH_EQ] = ACTIONS(4211),
    [anon_sym_STAR_EQ] = ACTIONS(4211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4211),
    [anon_sym_SLASH_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4211),
    [anon_sym_AMP_EQ] = ACTIONS(4211),
    [anon_sym_PERCENT_EQ] = ACTIONS(4211),
    [anon_sym_GT_GT_EQ] = ACTIONS(4211),
    [anon_sym_LT_LT_EQ] = ACTIONS(4211),
    [anon_sym_CARET_EQ] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(13097),
    [anon_sym_DOT_DOT] = ACTIONS(13099),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13101),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(13103),
    [anon_sym_AMP_AMP] = ACTIONS(13103),
    [anon_sym_LT_LT] = ACTIONS(13105),
    [anon_sym_GT_GT] = ACTIONS(13105),
    [anon_sym_EQ_EQ] = ACTIONS(13103),
    [anon_sym_BANG_EQ] = ACTIONS(13107),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13107),
    [anon_sym_LT_EQ_GT] = ACTIONS(13107),
    [anon_sym_EQ_TILDE] = ACTIONS(13107),
    [anon_sym_BANG_TILDE] = ACTIONS(13107),
    [anon_sym_LT_EQ] = ACTIONS(13095),
    [anon_sym_GT] = ACTIONS(13095),
    [anon_sym_GT_EQ] = ACTIONS(13109),
    [anon_sym_CARET] = ACTIONS(13089),
    [anon_sym_PLUS] = ACTIONS(13111),
    [anon_sym_SLASH] = ACTIONS(13091),
    [anon_sym_PERCENT] = ACTIONS(13091),
    [sym_comment] = ACTIONS(87),
  },
  [7694] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5209),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5214),
    [sym_scope_resolution] = STATE(5210),
    [sym_call] = STATE(5210),
    [sym_method_call] = STATE(5214),
    [sym_argument_list] = STATE(1062),
    [sym__argument_list_with_parens] = STATE(5211),
    [sym__argument] = STATE(5212),
    [sym_splat_argument] = STATE(5212),
    [sym_hash_splat_argument] = STATE(5212),
    [sym_block_argument] = STATE(5212),
    [sym_do_block] = STATE(426),
    [sym_block] = STATE(426),
    [sym_assignment] = STATE(5209),
    [sym_operator_assignment] = STATE(5209),
    [sym_conditional] = STATE(5209),
    [sym_range] = STATE(5209),
    [sym_binary] = STATE(5209),
    [sym_unary] = STATE(5209),
    [sym_left_assignment_list] = STATE(5213),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5214),
    [sym__variable] = STATE(5210),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5214),
    [sym_false] = STATE(5214),
    [sym_nil] = STATE(5214),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5215),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(5212),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(743),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(8248),
    [sym__splat_star] = ACTIONS(8250),
    [sym__unary_minus] = ACTIONS(8252),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(8254),
    [anon_sym_LBRACE] = ACTIONS(6047),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(769),
    [anon_sym_return] = ACTIONS(8256),
    [anon_sym_yield] = ACTIONS(8258),
    [anon_sym_break] = ACTIONS(8260),
    [anon_sym_next] = ACTIONS(8262),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(769),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(769),
    [anon_sym_until] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(769),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(769),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_else] = ACTIONS(769),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(8264),
    [anon_sym_not] = ACTIONS(8266),
    [anon_sym_BANG] = ACTIONS(8268),
    [anon_sym_TILDE] = ACTIONS(8270),
    [sym_constant] = ACTIONS(8272),
    [sym_identifier] = ACTIONS(8272),
    [sym_instance_variable] = ACTIONS(8274),
    [sym_class_variable] = ACTIONS(8274),
    [sym_global_variable] = ACTIONS(8274),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8276),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8276),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7695] = {
    [anon_sym_EQ] = ACTIONS(13113),
    [sym_comment] = ACTIONS(87),
  },
  [7696] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(13115),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(13117),
    [anon_sym_DASH_EQ] = ACTIONS(13117),
    [anon_sym_STAR_EQ] = ACTIONS(13117),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13117),
    [anon_sym_SLASH_EQ] = ACTIONS(13117),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13117),
    [anon_sym_PIPE_EQ] = ACTIONS(13117),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13117),
    [anon_sym_AMP_EQ] = ACTIONS(13117),
    [anon_sym_PERCENT_EQ] = ACTIONS(13117),
    [anon_sym_GT_GT_EQ] = ACTIONS(13117),
    [anon_sym_LT_LT_EQ] = ACTIONS(13117),
    [anon_sym_CARET_EQ] = ACTIONS(13117),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [7697] = {
    [sym_string] = STATE(9460),
    [aux_sym_chained_string_repeat1] = STATE(9460),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(2551),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [7698] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(13085),
    [sym__binary_star] = ACTIONS(13087),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(13089),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(13091),
    [anon_sym_AMP] = ACTIONS(13093),
    [anon_sym_EQ] = ACTIONS(4249),
    [anon_sym_LT] = ACTIONS(13095),
    [anon_sym_end] = ACTIONS(4247),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_else] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_PLUS_EQ] = ACTIONS(4247),
    [anon_sym_DASH_EQ] = ACTIONS(4247),
    [anon_sym_STAR_EQ] = ACTIONS(4247),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4247),
    [anon_sym_SLASH_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4247),
    [anon_sym_AMP_EQ] = ACTIONS(4247),
    [anon_sym_PERCENT_EQ] = ACTIONS(4247),
    [anon_sym_GT_GT_EQ] = ACTIONS(4247),
    [anon_sym_LT_LT_EQ] = ACTIONS(4247),
    [anon_sym_CARET_EQ] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(13097),
    [anon_sym_DOT_DOT] = ACTIONS(13099),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13101),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(13103),
    [anon_sym_AMP_AMP] = ACTIONS(13103),
    [anon_sym_LT_LT] = ACTIONS(13105),
    [anon_sym_GT_GT] = ACTIONS(13105),
    [anon_sym_EQ_EQ] = ACTIONS(13103),
    [anon_sym_BANG_EQ] = ACTIONS(13107),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13107),
    [anon_sym_LT_EQ_GT] = ACTIONS(13107),
    [anon_sym_EQ_TILDE] = ACTIONS(13107),
    [anon_sym_BANG_TILDE] = ACTIONS(13107),
    [anon_sym_LT_EQ] = ACTIONS(13095),
    [anon_sym_GT] = ACTIONS(13095),
    [anon_sym_GT_EQ] = ACTIONS(13109),
    [anon_sym_CARET] = ACTIONS(13089),
    [anon_sym_PLUS] = ACTIONS(13111),
    [anon_sym_SLASH] = ACTIONS(13091),
    [anon_sym_PERCENT] = ACTIONS(13091),
    [sym_comment] = ACTIONS(87),
  },
  [7699] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(11278),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [7700] = {
    [sym_string] = STATE(7720),
    [aux_sym_chained_string_repeat1] = STATE(7720),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(747),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [7701] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(9461),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7696),
    [sym_scope_resolution] = STATE(7694),
    [sym_call] = STATE(7694),
    [sym_method_call] = STATE(7696),
    [sym_assignment] = STATE(9461),
    [sym_operator_assignment] = STATE(9461),
    [sym_conditional] = STATE(9461),
    [sym_range] = STATE(9461),
    [sym_binary] = STATE(9461),
    [sym_unary] = STATE(9461),
    [sym_left_assignment_list] = STATE(7695),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7696),
    [sym__variable] = STATE(7694),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7696),
    [sym_false] = STATE(7696),
    [sym_nil] = STATE(7696),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7697),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11244),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11246),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_break] = ACTIONS(11250),
    [anon_sym_next] = ACTIONS(11252),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11254),
    [anon_sym_defined_QMARK] = ACTIONS(11256),
    [anon_sym_not] = ACTIONS(11258),
    [anon_sym_BANG] = ACTIONS(11260),
    [anon_sym_TILDE] = ACTIONS(11260),
    [sym_constant] = ACTIONS(11262),
    [sym_identifier] = ACTIONS(11262),
    [sym_instance_variable] = ACTIONS(11264),
    [sym_class_variable] = ACTIONS(11264),
    [sym_global_variable] = ACTIONS(11264),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11262),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11262),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [7702] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(13085),
    [sym__binary_star] = ACTIONS(13087),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(13089),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(13091),
    [anon_sym_AMP] = ACTIONS(13093),
    [anon_sym_EQ] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(13095),
    [anon_sym_end] = ACTIONS(3281),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_unless] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_until] = ACTIONS(3281),
    [anon_sym_rescue] = ACTIONS(3281),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_else] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_PLUS_EQ] = ACTIONS(3281),
    [anon_sym_DASH_EQ] = ACTIONS(3281),
    [anon_sym_STAR_EQ] = ACTIONS(3281),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3281),
    [anon_sym_SLASH_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3281),
    [anon_sym_AMP_EQ] = ACTIONS(3281),
    [anon_sym_PERCENT_EQ] = ACTIONS(3281),
    [anon_sym_GT_GT_EQ] = ACTIONS(3281),
    [anon_sym_LT_LT_EQ] = ACTIONS(3281),
    [anon_sym_CARET_EQ] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(13097),
    [anon_sym_DOT_DOT] = ACTIONS(13099),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13101),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(13103),
    [anon_sym_AMP_AMP] = ACTIONS(13103),
    [anon_sym_LT_LT] = ACTIONS(13105),
    [anon_sym_GT_GT] = ACTIONS(13105),
    [anon_sym_EQ_EQ] = ACTIONS(13103),
    [anon_sym_BANG_EQ] = ACTIONS(13107),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13107),
    [anon_sym_LT_EQ_GT] = ACTIONS(13107),
    [anon_sym_EQ_TILDE] = ACTIONS(13107),
    [anon_sym_BANG_TILDE] = ACTIONS(13107),
    [anon_sym_LT_EQ] = ACTIONS(13095),
    [anon_sym_GT] = ACTIONS(13095),
    [anon_sym_GT_EQ] = ACTIONS(13109),
    [anon_sym_CARET] = ACTIONS(13089),
    [anon_sym_PLUS] = ACTIONS(13111),
    [anon_sym_SLASH] = ACTIONS(13091),
    [anon_sym_PERCENT] = ACTIONS(13091),
    [sym_comment] = ACTIONS(87),
  },
  [7703] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(11272),
    [sym__binary_star] = ACTIONS(11274),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(11276),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(11278),
    [anon_sym_AMP] = ACTIONS(11280),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(11282),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(11284),
    [anon_sym_DOT_DOT] = ACTIONS(11286),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11288),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(11290),
    [anon_sym_AMP_AMP] = ACTIONS(11290),
    [anon_sym_LT_LT] = ACTIONS(11292),
    [anon_sym_GT_GT] = ACTIONS(11292),
    [anon_sym_EQ_EQ] = ACTIONS(11290),
    [anon_sym_BANG_EQ] = ACTIONS(11294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11294),
    [anon_sym_LT_EQ_GT] = ACTIONS(11294),
    [anon_sym_EQ_TILDE] = ACTIONS(11294),
    [anon_sym_BANG_TILDE] = ACTIONS(11294),
    [anon_sym_LT_EQ] = ACTIONS(11282),
    [anon_sym_GT] = ACTIONS(11282),
    [anon_sym_GT_EQ] = ACTIONS(11296),
    [anon_sym_CARET] = ACTIONS(11276),
    [anon_sym_PLUS] = ACTIONS(11298),
    [anon_sym_SLASH] = ACTIONS(11278),
    [anon_sym_PERCENT] = ACTIONS(11278),
    [sym_comment] = ACTIONS(87),
  },
  [7704] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(9462),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7696),
    [sym_scope_resolution] = STATE(7694),
    [sym_call] = STATE(7694),
    [sym_method_call] = STATE(7696),
    [sym_assignment] = STATE(9462),
    [sym_operator_assignment] = STATE(9462),
    [sym_conditional] = STATE(9462),
    [sym_range] = STATE(9462),
    [sym_binary] = STATE(9462),
    [sym_unary] = STATE(9462),
    [sym_left_assignment_list] = STATE(7695),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7696),
    [sym__variable] = STATE(7694),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7696),
    [sym_false] = STATE(7696),
    [sym_nil] = STATE(7696),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7697),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11244),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11246),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_break] = ACTIONS(11250),
    [anon_sym_next] = ACTIONS(11252),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11254),
    [anon_sym_defined_QMARK] = ACTIONS(11256),
    [anon_sym_not] = ACTIONS(11258),
    [anon_sym_BANG] = ACTIONS(11260),
    [anon_sym_TILDE] = ACTIONS(11260),
    [sym_constant] = ACTIONS(11262),
    [sym_identifier] = ACTIONS(11262),
    [sym_instance_variable] = ACTIONS(11264),
    [sym_class_variable] = ACTIONS(11264),
    [sym_global_variable] = ACTIONS(11264),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11262),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11262),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [7705] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(9463),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5214),
    [sym_scope_resolution] = STATE(5210),
    [sym_call] = STATE(5210),
    [sym_method_call] = STATE(5214),
    [sym_assignment] = STATE(9463),
    [sym_operator_assignment] = STATE(9463),
    [sym_conditional] = STATE(9463),
    [sym_range] = STATE(9463),
    [sym_binary] = STATE(9463),
    [sym_unary] = STATE(9463),
    [sym_left_assignment_list] = STATE(5213),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5214),
    [sym__variable] = STATE(5210),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5214),
    [sym_false] = STATE(5214),
    [sym_nil] = STATE(5214),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7700),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(8252),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(8256),
    [anon_sym_yield] = ACTIONS(8258),
    [anon_sym_break] = ACTIONS(8260),
    [anon_sym_next] = ACTIONS(8262),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(11266),
    [anon_sym_defined_QMARK] = ACTIONS(8264),
    [anon_sym_not] = ACTIONS(8266),
    [anon_sym_BANG] = ACTIONS(8270),
    [anon_sym_TILDE] = ACTIONS(8270),
    [sym_constant] = ACTIONS(8276),
    [sym_identifier] = ACTIONS(8276),
    [sym_instance_variable] = ACTIONS(8274),
    [sym_class_variable] = ACTIONS(8274),
    [sym_global_variable] = ACTIONS(8274),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8276),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8276),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7706] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(9464),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5214),
    [sym_scope_resolution] = STATE(5210),
    [sym_call] = STATE(5210),
    [sym_method_call] = STATE(5214),
    [sym_assignment] = STATE(9464),
    [sym_operator_assignment] = STATE(9464),
    [sym_conditional] = STATE(9464),
    [sym_range] = STATE(9464),
    [sym_binary] = STATE(9464),
    [sym_unary] = STATE(9464),
    [sym_left_assignment_list] = STATE(5213),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5214),
    [sym__variable] = STATE(5210),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5214),
    [sym_false] = STATE(5214),
    [sym_nil] = STATE(5214),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7700),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(8252),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(8256),
    [anon_sym_yield] = ACTIONS(8258),
    [anon_sym_break] = ACTIONS(8260),
    [anon_sym_next] = ACTIONS(8262),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(11266),
    [anon_sym_defined_QMARK] = ACTIONS(8264),
    [anon_sym_not] = ACTIONS(8266),
    [anon_sym_BANG] = ACTIONS(8270),
    [anon_sym_TILDE] = ACTIONS(8270),
    [sym_constant] = ACTIONS(8276),
    [sym_identifier] = ACTIONS(8276),
    [sym_instance_variable] = ACTIONS(8274),
    [sym_class_variable] = ACTIONS(8274),
    [sym_global_variable] = ACTIONS(8274),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8276),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8276),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7707] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(9465),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5214),
    [sym_scope_resolution] = STATE(5210),
    [sym_call] = STATE(5210),
    [sym_method_call] = STATE(5214),
    [sym_assignment] = STATE(9465),
    [sym_operator_assignment] = STATE(9465),
    [sym_conditional] = STATE(9465),
    [sym_range] = STATE(9465),
    [sym_binary] = STATE(9465),
    [sym_unary] = STATE(9465),
    [sym_left_assignment_list] = STATE(5213),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5214),
    [sym__variable] = STATE(5210),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5214),
    [sym_false] = STATE(5214),
    [sym_nil] = STATE(5214),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7700),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(8252),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(8256),
    [anon_sym_yield] = ACTIONS(8258),
    [anon_sym_break] = ACTIONS(8260),
    [anon_sym_next] = ACTIONS(8262),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(11266),
    [anon_sym_defined_QMARK] = ACTIONS(8264),
    [anon_sym_not] = ACTIONS(8266),
    [anon_sym_BANG] = ACTIONS(8270),
    [anon_sym_TILDE] = ACTIONS(8270),
    [sym_constant] = ACTIONS(8276),
    [sym_identifier] = ACTIONS(8276),
    [sym_instance_variable] = ACTIONS(8274),
    [sym_class_variable] = ACTIONS(8274),
    [sym_global_variable] = ACTIONS(8274),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8276),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8276),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7708] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(9466),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5214),
    [sym_scope_resolution] = STATE(5210),
    [sym_call] = STATE(5210),
    [sym_method_call] = STATE(5214),
    [sym_assignment] = STATE(9466),
    [sym_operator_assignment] = STATE(9466),
    [sym_conditional] = STATE(9466),
    [sym_range] = STATE(9466),
    [sym_binary] = STATE(9466),
    [sym_unary] = STATE(9466),
    [sym_left_assignment_list] = STATE(5213),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5214),
    [sym__variable] = STATE(5210),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5214),
    [sym_false] = STATE(5214),
    [sym_nil] = STATE(5214),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7700),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(8252),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(8256),
    [anon_sym_yield] = ACTIONS(8258),
    [anon_sym_break] = ACTIONS(8260),
    [anon_sym_next] = ACTIONS(8262),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(11266),
    [anon_sym_defined_QMARK] = ACTIONS(8264),
    [anon_sym_not] = ACTIONS(8266),
    [anon_sym_BANG] = ACTIONS(8270),
    [anon_sym_TILDE] = ACTIONS(8270),
    [sym_constant] = ACTIONS(8276),
    [sym_identifier] = ACTIONS(8276),
    [sym_instance_variable] = ACTIONS(8274),
    [sym_class_variable] = ACTIONS(8274),
    [sym_global_variable] = ACTIONS(8274),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8276),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8276),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7709] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(9467),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5214),
    [sym_scope_resolution] = STATE(5210),
    [sym_call] = STATE(5210),
    [sym_method_call] = STATE(5214),
    [sym_assignment] = STATE(9467),
    [sym_operator_assignment] = STATE(9467),
    [sym_conditional] = STATE(9467),
    [sym_range] = STATE(9467),
    [sym_binary] = STATE(9467),
    [sym_unary] = STATE(9467),
    [sym_left_assignment_list] = STATE(5213),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5214),
    [sym__variable] = STATE(5210),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5214),
    [sym_false] = STATE(5214),
    [sym_nil] = STATE(5214),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7700),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(8252),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(8256),
    [anon_sym_yield] = ACTIONS(8258),
    [anon_sym_break] = ACTIONS(8260),
    [anon_sym_next] = ACTIONS(8262),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(11266),
    [anon_sym_defined_QMARK] = ACTIONS(8264),
    [anon_sym_not] = ACTIONS(8266),
    [anon_sym_BANG] = ACTIONS(8270),
    [anon_sym_TILDE] = ACTIONS(8270),
    [sym_constant] = ACTIONS(8276),
    [sym_identifier] = ACTIONS(8276),
    [sym_instance_variable] = ACTIONS(8274),
    [sym_class_variable] = ACTIONS(8274),
    [sym_global_variable] = ACTIONS(8274),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8276),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8276),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7710] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(9468),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(9468),
    [sym_operator_assignment] = STATE(9468),
    [sym_conditional] = STATE(9468),
    [sym_range] = STATE(9468),
    [sym_binary] = STATE(9468),
    [sym_unary] = STATE(9468),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [7711] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(9469),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5214),
    [sym_scope_resolution] = STATE(5210),
    [sym_call] = STATE(5210),
    [sym_method_call] = STATE(5214),
    [sym_assignment] = STATE(9469),
    [sym_operator_assignment] = STATE(9469),
    [sym_conditional] = STATE(9469),
    [sym_range] = STATE(9469),
    [sym_binary] = STATE(9469),
    [sym_unary] = STATE(9469),
    [sym_left_assignment_list] = STATE(5213),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5214),
    [sym__variable] = STATE(5210),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5214),
    [sym_false] = STATE(5214),
    [sym_nil] = STATE(5214),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7700),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(8252),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(8256),
    [anon_sym_yield] = ACTIONS(8258),
    [anon_sym_break] = ACTIONS(8260),
    [anon_sym_next] = ACTIONS(8262),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(11266),
    [anon_sym_defined_QMARK] = ACTIONS(8264),
    [anon_sym_not] = ACTIONS(8266),
    [anon_sym_BANG] = ACTIONS(8270),
    [anon_sym_TILDE] = ACTIONS(8270),
    [sym_constant] = ACTIONS(8276),
    [sym_identifier] = ACTIONS(8276),
    [sym_instance_variable] = ACTIONS(8274),
    [sym_class_variable] = ACTIONS(8274),
    [sym_global_variable] = ACTIONS(8274),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8276),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8276),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7712] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(9470),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5214),
    [sym_scope_resolution] = STATE(5210),
    [sym_call] = STATE(5210),
    [sym_method_call] = STATE(5214),
    [sym_assignment] = STATE(9470),
    [sym_operator_assignment] = STATE(9470),
    [sym_conditional] = STATE(9470),
    [sym_range] = STATE(9470),
    [sym_binary] = STATE(9470),
    [sym_unary] = STATE(9470),
    [sym_left_assignment_list] = STATE(5213),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5214),
    [sym__variable] = STATE(5210),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5214),
    [sym_false] = STATE(5214),
    [sym_nil] = STATE(5214),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7700),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(8252),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(8256),
    [anon_sym_yield] = ACTIONS(8258),
    [anon_sym_break] = ACTIONS(8260),
    [anon_sym_next] = ACTIONS(8262),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(11266),
    [anon_sym_defined_QMARK] = ACTIONS(8264),
    [anon_sym_not] = ACTIONS(8266),
    [anon_sym_BANG] = ACTIONS(8270),
    [anon_sym_TILDE] = ACTIONS(8270),
    [sym_constant] = ACTIONS(8276),
    [sym_identifier] = ACTIONS(8276),
    [sym_instance_variable] = ACTIONS(8274),
    [sym_class_variable] = ACTIONS(8274),
    [sym_global_variable] = ACTIONS(8274),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8276),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8276),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7713] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(9471),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5214),
    [sym_scope_resolution] = STATE(5210),
    [sym_call] = STATE(5210),
    [sym_method_call] = STATE(5214),
    [sym_assignment] = STATE(9471),
    [sym_operator_assignment] = STATE(9471),
    [sym_conditional] = STATE(9471),
    [sym_range] = STATE(9471),
    [sym_binary] = STATE(9471),
    [sym_unary] = STATE(9471),
    [sym_left_assignment_list] = STATE(5213),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5214),
    [sym__variable] = STATE(5210),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5214),
    [sym_false] = STATE(5214),
    [sym_nil] = STATE(5214),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7700),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(8252),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(8256),
    [anon_sym_yield] = ACTIONS(8258),
    [anon_sym_break] = ACTIONS(8260),
    [anon_sym_next] = ACTIONS(8262),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(11266),
    [anon_sym_defined_QMARK] = ACTIONS(8264),
    [anon_sym_not] = ACTIONS(8266),
    [anon_sym_BANG] = ACTIONS(8270),
    [anon_sym_TILDE] = ACTIONS(8270),
    [sym_constant] = ACTIONS(8276),
    [sym_identifier] = ACTIONS(8276),
    [sym_instance_variable] = ACTIONS(8274),
    [sym_class_variable] = ACTIONS(8274),
    [sym_global_variable] = ACTIONS(8274),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8276),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8276),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7714] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(9472),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5214),
    [sym_scope_resolution] = STATE(5210),
    [sym_call] = STATE(5210),
    [sym_method_call] = STATE(5214),
    [sym_assignment] = STATE(9472),
    [sym_operator_assignment] = STATE(9472),
    [sym_conditional] = STATE(9472),
    [sym_range] = STATE(9472),
    [sym_binary] = STATE(9472),
    [sym_unary] = STATE(9472),
    [sym_left_assignment_list] = STATE(5213),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5214),
    [sym__variable] = STATE(5210),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5214),
    [sym_false] = STATE(5214),
    [sym_nil] = STATE(5214),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7700),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(8252),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(8256),
    [anon_sym_yield] = ACTIONS(8258),
    [anon_sym_break] = ACTIONS(8260),
    [anon_sym_next] = ACTIONS(8262),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(11266),
    [anon_sym_defined_QMARK] = ACTIONS(8264),
    [anon_sym_not] = ACTIONS(8266),
    [anon_sym_BANG] = ACTIONS(8270),
    [anon_sym_TILDE] = ACTIONS(8270),
    [sym_constant] = ACTIONS(8276),
    [sym_identifier] = ACTIONS(8276),
    [sym_instance_variable] = ACTIONS(8274),
    [sym_class_variable] = ACTIONS(8274),
    [sym_global_variable] = ACTIONS(8274),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8276),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8276),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7715] = {
    [sym_heredoc_body] = STATE(9473),
    [aux_sym_call_repeat1] = STATE(9473),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_else] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [7716] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5209),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5214),
    [sym_scope_resolution] = STATE(5210),
    [sym_call] = STATE(5210),
    [sym_method_call] = STATE(5214),
    [sym__argument] = STATE(3737),
    [sym_splat_argument] = STATE(3737),
    [sym_hash_splat_argument] = STATE(3737),
    [sym_block_argument] = STATE(3737),
    [sym_assignment] = STATE(5209),
    [sym_operator_assignment] = STATE(5209),
    [sym_conditional] = STATE(5209),
    [sym_range] = STATE(5209),
    [sym_binary] = STATE(5209),
    [sym_unary] = STATE(5209),
    [sym_left_assignment_list] = STATE(5213),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5214),
    [sym__variable] = STATE(5210),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5214),
    [sym_false] = STATE(5214),
    [sym_nil] = STATE(5214),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5215),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_heredoc_body] = STATE(9474),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(3737),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(8248),
    [sym__splat_star] = ACTIONS(8250),
    [sym__unary_minus] = ACTIONS(8252),
    [sym__identifier_hash_key] = ACTIONS(8254),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13119),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(8256),
    [anon_sym_yield] = ACTIONS(8258),
    [anon_sym_break] = ACTIONS(8260),
    [anon_sym_next] = ACTIONS(8262),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(11266),
    [anon_sym_defined_QMARK] = ACTIONS(8264),
    [anon_sym_not] = ACTIONS(8266),
    [anon_sym_BANG] = ACTIONS(8270),
    [anon_sym_TILDE] = ACTIONS(8270),
    [sym_constant] = ACTIONS(8272),
    [sym_identifier] = ACTIONS(8272),
    [sym_instance_variable] = ACTIONS(8274),
    [sym_class_variable] = ACTIONS(8274),
    [sym_global_variable] = ACTIONS(8274),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8276),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8276),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7717] = {
    [sym_heredoc_body] = STATE(9475),
    [aux_sym_call_repeat1] = STATE(9475),
    [aux_sym_argument_list_repeat1] = STATE(9476),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(11300),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_else] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [7718] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(9477),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5214),
    [sym_scope_resolution] = STATE(5210),
    [sym_call] = STATE(5210),
    [sym_method_call] = STATE(5214),
    [sym_splat_argument] = STATE(9478),
    [sym_assignment] = STATE(9477),
    [sym_operator_assignment] = STATE(9477),
    [sym_conditional] = STATE(9477),
    [sym_range] = STATE(9477),
    [sym_binary] = STATE(9477),
    [sym_unary] = STATE(9477),
    [sym_right_assignment_list] = STATE(3742),
    [sym__arg_or_splat_arg] = STATE(9478),
    [sym_left_assignment_list] = STATE(5213),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5214),
    [sym__variable] = STATE(5210),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5214),
    [sym_false] = STATE(5214),
    [sym_nil] = STATE(5214),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7700),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__splat_star] = ACTIONS(11228),
    [sym__unary_minus] = ACTIONS(8252),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(8256),
    [anon_sym_yield] = ACTIONS(8258),
    [anon_sym_break] = ACTIONS(8260),
    [anon_sym_next] = ACTIONS(8262),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(11266),
    [anon_sym_defined_QMARK] = ACTIONS(8264),
    [anon_sym_not] = ACTIONS(8266),
    [anon_sym_BANG] = ACTIONS(8270),
    [anon_sym_TILDE] = ACTIONS(8270),
    [sym_constant] = ACTIONS(8276),
    [sym_identifier] = ACTIONS(8276),
    [sym_instance_variable] = ACTIONS(8274),
    [sym_class_variable] = ACTIONS(8274),
    [sym_global_variable] = ACTIONS(8274),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8276),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8276),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7719] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(9479),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5214),
    [sym_scope_resolution] = STATE(5210),
    [sym_call] = STATE(5210),
    [sym_method_call] = STATE(5214),
    [sym_assignment] = STATE(9479),
    [sym_operator_assignment] = STATE(9479),
    [sym_conditional] = STATE(9479),
    [sym_range] = STATE(9479),
    [sym_binary] = STATE(9479),
    [sym_unary] = STATE(9479),
    [sym_left_assignment_list] = STATE(5213),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5214),
    [sym__variable] = STATE(5210),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5214),
    [sym_false] = STATE(5214),
    [sym_nil] = STATE(5214),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7700),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(8252),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(8256),
    [anon_sym_yield] = ACTIONS(8258),
    [anon_sym_break] = ACTIONS(8260),
    [anon_sym_next] = ACTIONS(8262),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(11266),
    [anon_sym_defined_QMARK] = ACTIONS(8264),
    [anon_sym_not] = ACTIONS(8266),
    [anon_sym_BANG] = ACTIONS(8270),
    [anon_sym_TILDE] = ACTIONS(8270),
    [sym_constant] = ACTIONS(8276),
    [sym_identifier] = ACTIONS(8276),
    [sym_instance_variable] = ACTIONS(8274),
    [sym_class_variable] = ACTIONS(8274),
    [sym_global_variable] = ACTIONS(8274),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8276),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8276),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7720] = {
    [sym_string] = STATE(9480),
    [aux_sym_chained_string_repeat1] = STATE(9480),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(747),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2755),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_EQ] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_end] = ACTIONS(2753),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_else] = ACTIONS(2753),
    [anon_sym_EQ_GT] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_PLUS_EQ] = ACTIONS(2753),
    [anon_sym_DASH_EQ] = ACTIONS(2753),
    [anon_sym_STAR_EQ] = ACTIONS(2753),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2753),
    [anon_sym_SLASH_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2753),
    [anon_sym_AMP_EQ] = ACTIONS(2753),
    [anon_sym_PERCENT_EQ] = ACTIONS(2753),
    [anon_sym_GT_GT_EQ] = ACTIONS(2753),
    [anon_sym_LT_LT_EQ] = ACTIONS(2753),
    [anon_sym_CARET_EQ] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2755),
    [anon_sym_AMP_AMP] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2755),
    [anon_sym_GT_GT] = ACTIONS(2755),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_SLASH] = ACTIONS(2755),
    [anon_sym_PERCENT] = ACTIONS(2755),
    [sym_comment] = ACTIONS(87),
  },
  [7721] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9481),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7728),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(7728),
    [sym_assignment] = STATE(9481),
    [sym_operator_assignment] = STATE(9481),
    [sym_conditional] = STATE(9481),
    [sym_range] = STATE(9481),
    [sym_binary] = STATE(9481),
    [sym_unary] = STATE(9481),
    [sym_left_assignment_list] = STATE(7727),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7728),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7728),
    [sym_false] = STATE(7728),
    [sym_nil] = STATE(7728),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7628),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11312),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11170),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_break] = ACTIONS(11174),
    [anon_sym_next] = ACTIONS(11176),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11314),
    [anon_sym_defined_QMARK] = ACTIONS(11316),
    [anon_sym_not] = ACTIONS(11318),
    [anon_sym_BANG] = ACTIONS(11320),
    [anon_sym_TILDE] = ACTIONS(11320),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7722] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9482),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7728),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(7728),
    [sym_assignment] = STATE(9482),
    [sym_operator_assignment] = STATE(9482),
    [sym_conditional] = STATE(9482),
    [sym_range] = STATE(9482),
    [sym_binary] = STATE(9482),
    [sym_unary] = STATE(9482),
    [sym_left_assignment_list] = STATE(7727),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7728),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7728),
    [sym_false] = STATE(7728),
    [sym_nil] = STATE(7728),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7628),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11312),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11170),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_break] = ACTIONS(11174),
    [anon_sym_next] = ACTIONS(11176),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11314),
    [anon_sym_defined_QMARK] = ACTIONS(11316),
    [anon_sym_not] = ACTIONS(11318),
    [anon_sym_BANG] = ACTIONS(11320),
    [anon_sym_TILDE] = ACTIONS(11320),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7723] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9483),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7728),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(7728),
    [sym_assignment] = STATE(9483),
    [sym_operator_assignment] = STATE(9483),
    [sym_conditional] = STATE(9483),
    [sym_range] = STATE(9483),
    [sym_binary] = STATE(9483),
    [sym_unary] = STATE(9483),
    [sym_left_assignment_list] = STATE(7727),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7728),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7728),
    [sym_false] = STATE(7728),
    [sym_nil] = STATE(7728),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7628),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11312),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11170),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_break] = ACTIONS(11174),
    [anon_sym_next] = ACTIONS(11176),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11314),
    [anon_sym_defined_QMARK] = ACTIONS(11316),
    [anon_sym_not] = ACTIONS(11318),
    [anon_sym_BANG] = ACTIONS(11320),
    [anon_sym_TILDE] = ACTIONS(11320),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7724] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(298),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7728),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(7728),
    [sym_assignment] = STATE(298),
    [sym_operator_assignment] = STATE(298),
    [sym_conditional] = STATE(298),
    [sym_range] = STATE(298),
    [sym_binary] = STATE(298),
    [sym_unary] = STATE(298),
    [sym_left_assignment_list] = STATE(7727),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7728),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7728),
    [sym_false] = STATE(7728),
    [sym_nil] = STATE(7728),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7628),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11312),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11170),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_break] = ACTIONS(11174),
    [anon_sym_next] = ACTIONS(11176),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11314),
    [anon_sym_defined_QMARK] = ACTIONS(11316),
    [anon_sym_not] = ACTIONS(11318),
    [anon_sym_BANG] = ACTIONS(11320),
    [anon_sym_TILDE] = ACTIONS(11320),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7725] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(13121),
    [sym__binary_star] = ACTIONS(13123),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(13125),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(13123),
    [anon_sym_AMP] = ACTIONS(13127),
    [anon_sym_LT] = ACTIONS(13129),
    [anon_sym_end] = ACTIONS(5115),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_else] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(13131),
    [anon_sym_DOT_DOT] = ACTIONS(13133),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13135),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(13137),
    [anon_sym_AMP_AMP] = ACTIONS(13137),
    [anon_sym_LT_LT] = ACTIONS(13139),
    [anon_sym_GT_GT] = ACTIONS(13139),
    [anon_sym_EQ_EQ] = ACTIONS(13141),
    [anon_sym_BANG_EQ] = ACTIONS(13137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13137),
    [anon_sym_LT_EQ_GT] = ACTIONS(13137),
    [anon_sym_EQ_TILDE] = ACTIONS(13137),
    [anon_sym_BANG_TILDE] = ACTIONS(13137),
    [anon_sym_LT_EQ] = ACTIONS(13129),
    [anon_sym_GT] = ACTIONS(13129),
    [anon_sym_GT_EQ] = ACTIONS(13143),
    [anon_sym_CARET] = ACTIONS(13145),
    [anon_sym_PLUS] = ACTIONS(13121),
    [anon_sym_SLASH] = ACTIONS(13123),
    [anon_sym_PERCENT] = ACTIONS(13123),
    [sym_comment] = ACTIONS(87),
  },
  [7726] = {
    [aux_sym_exceptions_repeat1] = STATE(9495),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_COMMA] = ACTIONS(13147),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_end] = ACTIONS(6191),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_else] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [7727] = {
    [anon_sym_EQ] = ACTIONS(13149),
    [sym_comment] = ACTIONS(87),
  },
  [7728] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(13151),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(13153),
    [anon_sym_DASH_EQ] = ACTIONS(13153),
    [anon_sym_STAR_EQ] = ACTIONS(13153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13153),
    [anon_sym_SLASH_EQ] = ACTIONS(13153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13153),
    [anon_sym_PIPE_EQ] = ACTIONS(13153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13153),
    [anon_sym_AMP_EQ] = ACTIONS(13153),
    [anon_sym_PERCENT_EQ] = ACTIONS(13153),
    [anon_sym_GT_GT_EQ] = ACTIONS(13153),
    [anon_sym_LT_LT_EQ] = ACTIONS(13153),
    [anon_sym_CARET_EQ] = ACTIONS(13153),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [7729] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(8220),
    [sym__binary_star] = ACTIONS(8222),
    [anon_sym_PIPE] = ACTIONS(8224),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(8222),
    [anon_sym_AMP] = ACTIONS(8226),
    [anon_sym_LT] = ACTIONS(8228),
    [anon_sym_end] = ACTIONS(6210),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_else] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(8230),
    [anon_sym_DOT_DOT] = ACTIONS(8232),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8234),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(8238),
    [anon_sym_AMP_AMP] = ACTIONS(8238),
    [anon_sym_LT_LT] = ACTIONS(8240),
    [anon_sym_GT_GT] = ACTIONS(8240),
    [anon_sym_EQ_EQ] = ACTIONS(8242),
    [anon_sym_BANG_EQ] = ACTIONS(8238),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8238),
    [anon_sym_LT_EQ_GT] = ACTIONS(8238),
    [anon_sym_EQ_TILDE] = ACTIONS(8238),
    [anon_sym_BANG_TILDE] = ACTIONS(8238),
    [anon_sym_LT_EQ] = ACTIONS(8228),
    [anon_sym_GT] = ACTIONS(8228),
    [anon_sym_GT_EQ] = ACTIONS(8244),
    [anon_sym_CARET] = ACTIONS(8246),
    [anon_sym_PLUS] = ACTIONS(8220),
    [anon_sym_SLASH] = ACTIONS(8222),
    [anon_sym_PERCENT] = ACTIONS(8222),
    [sym_comment] = ACTIONS(87),
  },
  [7730] = {
    [sym_string] = STATE(7730),
    [aux_sym_chained_string_repeat1] = STATE(7730),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(6214),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_end] = ACTIONS(6212),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_else] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [7731] = {
    [sym_heredoc_body] = STATE(9498),
    [aux_sym_call_repeat1] = STATE(9498),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [7732] = {
    [sym_heredoc_body] = STATE(9499),
    [aux_sym_call_repeat1] = STATE(9499),
    [aux_sym_argument_list_repeat1] = STATE(5271),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4681),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [7733] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(8292),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8292),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(8292),
    [anon_sym_PERCENT] = ACTIONS(8292),
    [sym_comment] = ACTIONS(87),
  },
  [7734] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8292),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [7735] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8290),
    [sym__binary_star] = ACTIONS(8292),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8292),
    [anon_sym_AMP] = ACTIONS(8296),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(8308),
    [anon_sym_GT_GT] = ACTIONS(8308),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(8290),
    [anon_sym_SLASH] = ACTIONS(8292),
    [anon_sym_PERCENT] = ACTIONS(8292),
    [sym_comment] = ACTIONS(87),
  },
  [7736] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8290),
    [sym__binary_star] = ACTIONS(8292),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8292),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(8308),
    [anon_sym_GT_GT] = ACTIONS(8308),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(8290),
    [anon_sym_SLASH] = ACTIONS(8292),
    [anon_sym_PERCENT] = ACTIONS(8292),
    [sym_comment] = ACTIONS(87),
  },
  [7737] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8290),
    [sym__binary_star] = ACTIONS(8292),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(8294),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8292),
    [anon_sym_AMP] = ACTIONS(8296),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(8308),
    [anon_sym_GT_GT] = ACTIONS(8308),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(8314),
    [anon_sym_PLUS] = ACTIONS(8290),
    [anon_sym_SLASH] = ACTIONS(8292),
    [anon_sym_PERCENT] = ACTIONS(8292),
    [sym_comment] = ACTIONS(87),
  },
  [7738] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(13155),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [7739] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(8290),
    [sym__binary_star] = ACTIONS(8292),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(8294),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(8292),
    [anon_sym_AMP] = ACTIONS(8296),
    [anon_sym_LT] = ACTIONS(8298),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(8302),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8304),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(8306),
    [anon_sym_AMP_AMP] = ACTIONS(8306),
    [anon_sym_LT_LT] = ACTIONS(8308),
    [anon_sym_GT_GT] = ACTIONS(8308),
    [anon_sym_EQ_EQ] = ACTIONS(8310),
    [anon_sym_BANG_EQ] = ACTIONS(8306),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8306),
    [anon_sym_LT_EQ_GT] = ACTIONS(8306),
    [anon_sym_EQ_TILDE] = ACTIONS(8306),
    [anon_sym_BANG_TILDE] = ACTIONS(8306),
    [anon_sym_LT_EQ] = ACTIONS(8298),
    [anon_sym_GT] = ACTIONS(8298),
    [anon_sym_GT_EQ] = ACTIONS(8312),
    [anon_sym_CARET] = ACTIONS(8314),
    [anon_sym_PLUS] = ACTIONS(8290),
    [anon_sym_SLASH] = ACTIONS(8292),
    [anon_sym_PERCENT] = ACTIONS(8292),
    [sym_comment] = ACTIONS(87),
  },
  [7740] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8290),
    [sym__binary_star] = ACTIONS(8292),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(8294),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8292),
    [anon_sym_AMP] = ACTIONS(8296),
    [anon_sym_LT] = ACTIONS(8298),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(8300),
    [anon_sym_DOT_DOT] = ACTIONS(8302),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8304),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(8306),
    [anon_sym_AMP_AMP] = ACTIONS(8306),
    [anon_sym_LT_LT] = ACTIONS(8308),
    [anon_sym_GT_GT] = ACTIONS(8308),
    [anon_sym_EQ_EQ] = ACTIONS(8310),
    [anon_sym_BANG_EQ] = ACTIONS(8306),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8306),
    [anon_sym_LT_EQ_GT] = ACTIONS(8306),
    [anon_sym_EQ_TILDE] = ACTIONS(8306),
    [anon_sym_BANG_TILDE] = ACTIONS(8306),
    [anon_sym_LT_EQ] = ACTIONS(8298),
    [anon_sym_GT] = ACTIONS(8298),
    [anon_sym_GT_EQ] = ACTIONS(8312),
    [anon_sym_CARET] = ACTIONS(8314),
    [anon_sym_PLUS] = ACTIONS(8290),
    [anon_sym_SLASH] = ACTIONS(8292),
    [anon_sym_PERCENT] = ACTIONS(8292),
    [sym_comment] = ACTIONS(87),
  },
  [7741] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8290),
    [sym__binary_star] = ACTIONS(8292),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(8294),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8292),
    [anon_sym_AMP] = ACTIONS(8296),
    [anon_sym_LT] = ACTIONS(8298),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(8308),
    [anon_sym_GT_GT] = ACTIONS(8308),
    [anon_sym_EQ_EQ] = ACTIONS(8310),
    [anon_sym_BANG_EQ] = ACTIONS(8306),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8306),
    [anon_sym_LT_EQ_GT] = ACTIONS(8306),
    [anon_sym_EQ_TILDE] = ACTIONS(8306),
    [anon_sym_BANG_TILDE] = ACTIONS(8306),
    [anon_sym_LT_EQ] = ACTIONS(8298),
    [anon_sym_GT] = ACTIONS(8298),
    [anon_sym_GT_EQ] = ACTIONS(8312),
    [anon_sym_CARET] = ACTIONS(8314),
    [anon_sym_PLUS] = ACTIONS(8290),
    [anon_sym_SLASH] = ACTIONS(8292),
    [anon_sym_PERCENT] = ACTIONS(8292),
    [sym_comment] = ACTIONS(87),
  },
  [7742] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8290),
    [sym__binary_star] = ACTIONS(8292),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8292),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(8290),
    [anon_sym_SLASH] = ACTIONS(8292),
    [anon_sym_PERCENT] = ACTIONS(8292),
    [sym_comment] = ACTIONS(87),
  },
  [7743] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(8290),
    [sym__binary_star] = ACTIONS(8292),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(8294),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(8292),
    [anon_sym_AMP] = ACTIONS(8296),
    [anon_sym_LT] = ACTIONS(8298),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(8300),
    [anon_sym_DOT_DOT] = ACTIONS(8302),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8304),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(8306),
    [anon_sym_AMP_AMP] = ACTIONS(8306),
    [anon_sym_LT_LT] = ACTIONS(8308),
    [anon_sym_GT_GT] = ACTIONS(8308),
    [anon_sym_EQ_EQ] = ACTIONS(8310),
    [anon_sym_BANG_EQ] = ACTIONS(8306),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8306),
    [anon_sym_LT_EQ_GT] = ACTIONS(8306),
    [anon_sym_EQ_TILDE] = ACTIONS(8306),
    [anon_sym_BANG_TILDE] = ACTIONS(8306),
    [anon_sym_LT_EQ] = ACTIONS(8298),
    [anon_sym_GT] = ACTIONS(8298),
    [anon_sym_GT_EQ] = ACTIONS(8312),
    [anon_sym_CARET] = ACTIONS(8314),
    [anon_sym_PLUS] = ACTIONS(8290),
    [anon_sym_SLASH] = ACTIONS(8292),
    [anon_sym_PERCENT] = ACTIONS(8292),
    [sym_comment] = ACTIONS(87),
  },
  [7744] = {
    [aux_sym_exceptions_repeat1] = STATE(9502),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [7745] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(8290),
    [sym__binary_star] = ACTIONS(8292),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(8294),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(8292),
    [anon_sym_AMP] = ACTIONS(8296),
    [anon_sym_LT] = ACTIONS(8298),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(8300),
    [anon_sym_DOT_DOT] = ACTIONS(8302),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8304),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(8306),
    [anon_sym_AMP_AMP] = ACTIONS(8306),
    [anon_sym_LT_LT] = ACTIONS(8308),
    [anon_sym_GT_GT] = ACTIONS(8308),
    [anon_sym_EQ_EQ] = ACTIONS(8310),
    [anon_sym_BANG_EQ] = ACTIONS(8306),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8306),
    [anon_sym_LT_EQ_GT] = ACTIONS(8306),
    [anon_sym_EQ_TILDE] = ACTIONS(8306),
    [anon_sym_BANG_TILDE] = ACTIONS(8306),
    [anon_sym_LT_EQ] = ACTIONS(8298),
    [anon_sym_GT] = ACTIONS(8298),
    [anon_sym_GT_EQ] = ACTIONS(8312),
    [anon_sym_CARET] = ACTIONS(8314),
    [anon_sym_PLUS] = ACTIONS(8290),
    [anon_sym_SLASH] = ACTIONS(8292),
    [anon_sym_PERCENT] = ACTIONS(8292),
    [sym_comment] = ACTIONS(87),
  },
  [7746] = {
    [sym_string] = STATE(7746),
    [aux_sym_chained_string_repeat1] = STATE(7746),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(6214),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_do] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [7747] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(4645),
    [sym__binary_star] = ACTIONS(4647),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(4649),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(4647),
    [anon_sym_AMP] = ACTIONS(4651),
    [anon_sym_LT] = ACTIONS(4653),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_EQ_GT] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(4655),
    [anon_sym_DOT_DOT] = ACTIONS(4657),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4659),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(4661),
    [anon_sym_AMP_AMP] = ACTIONS(4661),
    [anon_sym_LT_LT] = ACTIONS(4663),
    [anon_sym_GT_GT] = ACTIONS(4663),
    [anon_sym_EQ_EQ] = ACTIONS(4665),
    [anon_sym_BANG_EQ] = ACTIONS(4661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4661),
    [anon_sym_LT_EQ_GT] = ACTIONS(4661),
    [anon_sym_EQ_TILDE] = ACTIONS(4661),
    [anon_sym_BANG_TILDE] = ACTIONS(4661),
    [anon_sym_LT_EQ] = ACTIONS(4653),
    [anon_sym_GT] = ACTIONS(4653),
    [anon_sym_GT_EQ] = ACTIONS(4667),
    [anon_sym_CARET] = ACTIONS(4669),
    [anon_sym_PLUS] = ACTIONS(4645),
    [anon_sym_SLASH] = ACTIONS(4647),
    [anon_sym_PERCENT] = ACTIONS(4647),
    [sym_comment] = ACTIONS(87),
  },
  [7748] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(4645),
    [sym__binary_star] = ACTIONS(4647),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(4649),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(4647),
    [anon_sym_AMP] = ACTIONS(4651),
    [anon_sym_LT] = ACTIONS(4653),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_EQ_GT] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(4655),
    [anon_sym_DOT_DOT] = ACTIONS(4657),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4659),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(4661),
    [anon_sym_AMP_AMP] = ACTIONS(4661),
    [anon_sym_LT_LT] = ACTIONS(4663),
    [anon_sym_GT_GT] = ACTIONS(4663),
    [anon_sym_EQ_EQ] = ACTIONS(4665),
    [anon_sym_BANG_EQ] = ACTIONS(4661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4661),
    [anon_sym_LT_EQ_GT] = ACTIONS(4661),
    [anon_sym_EQ_TILDE] = ACTIONS(4661),
    [anon_sym_BANG_TILDE] = ACTIONS(4661),
    [anon_sym_LT_EQ] = ACTIONS(4653),
    [anon_sym_GT] = ACTIONS(4653),
    [anon_sym_GT_EQ] = ACTIONS(4667),
    [anon_sym_CARET] = ACTIONS(4669),
    [anon_sym_PLUS] = ACTIONS(4645),
    [anon_sym_SLASH] = ACTIONS(4647),
    [anon_sym_PERCENT] = ACTIONS(4647),
    [sym_comment] = ACTIONS(87),
  },
  [7749] = {
    [sym_heredoc_body] = STATE(7749),
    [aux_sym_call_repeat1] = STATE(7749),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(7916),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_EQ_GT] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [7750] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2746),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1033),
    [sym_scope_resolution] = STATE(1029),
    [sym_call] = STATE(1029),
    [sym_method_call] = STATE(1033),
    [sym__argument] = STATE(4986),
    [sym_splat_argument] = STATE(4986),
    [sym_hash_splat_argument] = STATE(4986),
    [sym_block_argument] = STATE(4986),
    [sym_assignment] = STATE(2746),
    [sym_operator_assignment] = STATE(2746),
    [sym_conditional] = STATE(2746),
    [sym_range] = STATE(2746),
    [sym_binary] = STATE(2746),
    [sym_unary] = STATE(2746),
    [sym_left_assignment_list] = STATE(1032),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1033),
    [sym__variable] = STATE(1029),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1033),
    [sym_false] = STATE(1033),
    [sym_nil] = STATE(1033),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2749),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4986),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(4635),
    [sym__splat_star] = ACTIONS(4637),
    [sym__unary_minus] = ACTIONS(1827),
    [sym__identifier_hash_key] = ACTIONS(4639),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11326),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1831),
    [anon_sym_yield] = ACTIONS(1833),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_next] = ACTIONS(1837),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4631),
    [anon_sym_defined_QMARK] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1845),
    [anon_sym_TILDE] = ACTIONS(1845),
    [sym_constant] = ACTIONS(4641),
    [sym_identifier] = ACTIONS(4641),
    [sym_instance_variable] = ACTIONS(1849),
    [sym_class_variable] = ACTIONS(1849),
    [sym_global_variable] = ACTIONS(1849),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1851),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1851),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7751] = {
    [sym_heredoc_body] = STATE(7749),
    [aux_sym_call_repeat1] = STATE(7749),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_EQ_GT] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [7752] = {
    [aux_sym_argument_list_repeat1] = STATE(7752),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(13157),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7925),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_EQ_GT] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7925),
    [anon_sym_AMP_AMP] = ACTIONS(7925),
    [anon_sym_LT_LT] = ACTIONS(7925),
    [anon_sym_GT_GT] = ACTIONS(7925),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7925),
    [anon_sym_PLUS] = ACTIONS(7925),
    [anon_sym_SLASH] = ACTIONS(7925),
    [anon_sym_PERCENT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [7753] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9503),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1033),
    [sym_scope_resolution] = STATE(1029),
    [sym_call] = STATE(1029),
    [sym_method_call] = STATE(1033),
    [sym_assignment] = STATE(9503),
    [sym_operator_assignment] = STATE(9503),
    [sym_conditional] = STATE(9503),
    [sym_range] = STATE(9503),
    [sym_binary] = STATE(9503),
    [sym_unary] = STATE(9503),
    [sym_left_assignment_list] = STATE(1032),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1033),
    [sym__variable] = STATE(1029),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1033),
    [sym_false] = STATE(1033),
    [sym_nil] = STATE(1033),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2738),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1827),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1831),
    [anon_sym_yield] = ACTIONS(1833),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_next] = ACTIONS(1837),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4631),
    [anon_sym_defined_QMARK] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1845),
    [anon_sym_TILDE] = ACTIONS(1845),
    [sym_constant] = ACTIONS(1851),
    [sym_identifier] = ACTIONS(1851),
    [sym_instance_variable] = ACTIONS(1849),
    [sym_class_variable] = ACTIONS(1849),
    [sym_global_variable] = ACTIONS(1849),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1851),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1851),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7754] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(4723),
    [sym__binary_star] = ACTIONS(4725),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(4727),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(4729),
    [anon_sym_AMP] = ACTIONS(4731),
    [anon_sym_EQ] = ACTIONS(7822),
    [anon_sym_LT] = ACTIONS(4733),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_EQ_GT] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_PLUS_EQ] = ACTIONS(6823),
    [anon_sym_DASH_EQ] = ACTIONS(6823),
    [anon_sym_STAR_EQ] = ACTIONS(6823),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6823),
    [anon_sym_SLASH_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6823),
    [anon_sym_AMP_EQ] = ACTIONS(6823),
    [anon_sym_PERCENT_EQ] = ACTIONS(6823),
    [anon_sym_GT_GT_EQ] = ACTIONS(6823),
    [anon_sym_LT_LT_EQ] = ACTIONS(6823),
    [anon_sym_CARET_EQ] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(4735),
    [anon_sym_DOT_DOT] = ACTIONS(4737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4739),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(4741),
    [anon_sym_AMP_AMP] = ACTIONS(4741),
    [anon_sym_LT_LT] = ACTIONS(4743),
    [anon_sym_GT_GT] = ACTIONS(4743),
    [anon_sym_EQ_EQ] = ACTIONS(4741),
    [anon_sym_BANG_EQ] = ACTIONS(4745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4745),
    [anon_sym_LT_EQ_GT] = ACTIONS(4745),
    [anon_sym_EQ_TILDE] = ACTIONS(4745),
    [anon_sym_BANG_TILDE] = ACTIONS(4745),
    [anon_sym_LT_EQ] = ACTIONS(4733),
    [anon_sym_GT] = ACTIONS(4733),
    [anon_sym_GT_EQ] = ACTIONS(4747),
    [anon_sym_CARET] = ACTIONS(4727),
    [anon_sym_PLUS] = ACTIONS(4749),
    [anon_sym_SLASH] = ACTIONS(4729),
    [anon_sym_PERCENT] = ACTIONS(4729),
    [sym_comment] = ACTIONS(87),
  },
  [7755] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(4723),
    [sym__binary_star] = ACTIONS(4725),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(4727),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(4729),
    [anon_sym_AMP] = ACTIONS(4731),
    [anon_sym_EQ] = ACTIONS(7884),
    [anon_sym_LT] = ACTIONS(4733),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_EQ_GT] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_PLUS_EQ] = ACTIONS(7027),
    [anon_sym_DASH_EQ] = ACTIONS(7027),
    [anon_sym_STAR_EQ] = ACTIONS(7027),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7027),
    [anon_sym_SLASH_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7027),
    [anon_sym_AMP_EQ] = ACTIONS(7027),
    [anon_sym_PERCENT_EQ] = ACTIONS(7027),
    [anon_sym_GT_GT_EQ] = ACTIONS(7027),
    [anon_sym_LT_LT_EQ] = ACTIONS(7027),
    [anon_sym_CARET_EQ] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(4735),
    [anon_sym_DOT_DOT] = ACTIONS(4737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4739),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(4741),
    [anon_sym_AMP_AMP] = ACTIONS(4741),
    [anon_sym_LT_LT] = ACTIONS(4743),
    [anon_sym_GT_GT] = ACTIONS(4743),
    [anon_sym_EQ_EQ] = ACTIONS(4741),
    [anon_sym_BANG_EQ] = ACTIONS(4745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4745),
    [anon_sym_LT_EQ_GT] = ACTIONS(4745),
    [anon_sym_EQ_TILDE] = ACTIONS(4745),
    [anon_sym_BANG_TILDE] = ACTIONS(4745),
    [anon_sym_LT_EQ] = ACTIONS(4733),
    [anon_sym_GT] = ACTIONS(4733),
    [anon_sym_GT_EQ] = ACTIONS(4747),
    [anon_sym_CARET] = ACTIONS(4727),
    [anon_sym_PLUS] = ACTIONS(4749),
    [anon_sym_SLASH] = ACTIONS(4729),
    [anon_sym_PERCENT] = ACTIONS(4729),
    [sym_comment] = ACTIONS(87),
  },
  [7756] = {
    [sym_heredoc_body] = STATE(7756),
    [aux_sym_call_repeat1] = STATE(7756),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(10978),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7919),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_EQ] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_EQ_GT] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_PLUS_EQ] = ACTIONS(7914),
    [anon_sym_DASH_EQ] = ACTIONS(7914),
    [anon_sym_STAR_EQ] = ACTIONS(7914),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7914),
    [anon_sym_SLASH_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7914),
    [anon_sym_AMP_EQ] = ACTIONS(7914),
    [anon_sym_PERCENT_EQ] = ACTIONS(7914),
    [anon_sym_GT_GT_EQ] = ACTIONS(7914),
    [anon_sym_LT_LT_EQ] = ACTIONS(7914),
    [anon_sym_CARET_EQ] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7919),
    [anon_sym_AMP_AMP] = ACTIONS(7919),
    [anon_sym_LT_LT] = ACTIONS(7919),
    [anon_sym_GT_GT] = ACTIONS(7919),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7919),
    [anon_sym_PLUS] = ACTIONS(7919),
    [anon_sym_SLASH] = ACTIONS(7919),
    [anon_sym_PERCENT] = ACTIONS(7919),
    [sym_comment] = ACTIONS(87),
  },
  [7757] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(2768),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1066),
    [sym_scope_resolution] = STATE(1061),
    [sym_call] = STATE(1061),
    [sym_method_call] = STATE(1066),
    [sym__argument] = STATE(7437),
    [sym_splat_argument] = STATE(7437),
    [sym_hash_splat_argument] = STATE(7437),
    [sym_block_argument] = STATE(7437),
    [sym_assignment] = STATE(2768),
    [sym_operator_assignment] = STATE(2768),
    [sym_conditional] = STATE(2768),
    [sym_range] = STATE(2768),
    [sym_binary] = STATE(2768),
    [sym_unary] = STATE(2768),
    [sym_left_assignment_list] = STATE(1065),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1066),
    [sym__variable] = STATE(1061),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1066),
    [sym_false] = STATE(1066),
    [sym_nil] = STATE(1066),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2771),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(7437),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(4671),
    [sym__splat_star] = ACTIONS(4673),
    [sym__unary_minus] = ACTIONS(1887),
    [sym__identifier_hash_key] = ACTIONS(4675),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11330),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1895),
    [anon_sym_break] = ACTIONS(1897),
    [anon_sym_next] = ACTIONS(1899),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(4715),
    [anon_sym_defined_QMARK] = ACTIONS(1909),
    [anon_sym_not] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1915),
    [anon_sym_TILDE] = ACTIONS(1915),
    [sym_constant] = ACTIONS(4679),
    [sym_identifier] = ACTIONS(4679),
    [sym_instance_variable] = ACTIONS(1919),
    [sym_class_variable] = ACTIONS(1919),
    [sym_global_variable] = ACTIONS(1919),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1921),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1921),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7758] = {
    [sym_heredoc_body] = STATE(7756),
    [aux_sym_call_repeat1] = STATE(7756),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7931),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_EQ] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_EQ_GT] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_PLUS_EQ] = ACTIONS(7929),
    [anon_sym_DASH_EQ] = ACTIONS(7929),
    [anon_sym_STAR_EQ] = ACTIONS(7929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7929),
    [anon_sym_SLASH_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7929),
    [anon_sym_AMP_EQ] = ACTIONS(7929),
    [anon_sym_PERCENT_EQ] = ACTIONS(7929),
    [anon_sym_GT_GT_EQ] = ACTIONS(7929),
    [anon_sym_LT_LT_EQ] = ACTIONS(7929),
    [anon_sym_CARET_EQ] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7931),
    [anon_sym_AMP_AMP] = ACTIONS(7931),
    [anon_sym_LT_LT] = ACTIONS(7931),
    [anon_sym_GT_GT] = ACTIONS(7931),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7931),
    [anon_sym_PLUS] = ACTIONS(7931),
    [anon_sym_SLASH] = ACTIONS(7931),
    [anon_sym_PERCENT] = ACTIONS(7931),
    [sym_comment] = ACTIONS(87),
  },
  [7759] = {
    [aux_sym_argument_list_repeat1] = STATE(7759),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(13160),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7927),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_EQ] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_EQ_GT] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_PLUS_EQ] = ACTIONS(7925),
    [anon_sym_DASH_EQ] = ACTIONS(7925),
    [anon_sym_STAR_EQ] = ACTIONS(7925),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7925),
    [anon_sym_SLASH_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7925),
    [anon_sym_AMP_EQ] = ACTIONS(7925),
    [anon_sym_PERCENT_EQ] = ACTIONS(7925),
    [anon_sym_GT_GT_EQ] = ACTIONS(7925),
    [anon_sym_LT_LT_EQ] = ACTIONS(7925),
    [anon_sym_CARET_EQ] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7927),
    [anon_sym_AMP_AMP] = ACTIONS(7927),
    [anon_sym_LT_LT] = ACTIONS(7927),
    [anon_sym_GT_GT] = ACTIONS(7927),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7927),
    [anon_sym_PLUS] = ACTIONS(7927),
    [anon_sym_SLASH] = ACTIONS(7927),
    [anon_sym_PERCENT] = ACTIONS(7927),
    [sym_comment] = ACTIONS(87),
  },
  [7760] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5272),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1033),
    [sym_scope_resolution] = STATE(1029),
    [sym_call] = STATE(1029),
    [sym_method_call] = STATE(1033),
    [sym_splat_argument] = STATE(7439),
    [sym_assignment] = STATE(5272),
    [sym_operator_assignment] = STATE(5272),
    [sym_conditional] = STATE(5272),
    [sym_range] = STATE(5272),
    [sym_binary] = STATE(5272),
    [sym_unary] = STATE(5272),
    [sym__arg_or_splat_arg] = STATE(7439),
    [sym_left_assignment_list] = STATE(1032),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1033),
    [sym__variable] = STATE(1029),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1033),
    [sym_false] = STATE(1033),
    [sym_nil] = STATE(1033),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2738),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__splat_star] = ACTIONS(4637),
    [sym__unary_minus] = ACTIONS(1827),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1831),
    [anon_sym_yield] = ACTIONS(1833),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_next] = ACTIONS(1837),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4631),
    [anon_sym_defined_QMARK] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1845),
    [anon_sym_TILDE] = ACTIONS(1845),
    [sym_constant] = ACTIONS(1851),
    [sym_identifier] = ACTIONS(1851),
    [sym_instance_variable] = ACTIONS(1849),
    [sym_class_variable] = ACTIONS(1849),
    [sym_global_variable] = ACTIONS(1849),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1851),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1851),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7761] = {
    [aux_sym_exceptions_repeat1] = STATE(9504),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(13163),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_do] = ACTIONS(9855),
    [anon_sym_EQ_GT] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [7762] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(1855),
    [sym__binary_star] = ACTIONS(1857),
    [anon_sym_PIPE] = ACTIONS(1859),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_LT] = ACTIONS(1863),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(1865),
    [anon_sym_DOT_DOT] = ACTIONS(1867),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1869),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(1873),
    [anon_sym_AMP_AMP] = ACTIONS(1873),
    [anon_sym_LT_LT] = ACTIONS(1875),
    [anon_sym_GT_GT] = ACTIONS(1875),
    [anon_sym_EQ_EQ] = ACTIONS(1877),
    [anon_sym_BANG_EQ] = ACTIONS(1873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1873),
    [anon_sym_LT_EQ_GT] = ACTIONS(1873),
    [anon_sym_EQ_TILDE] = ACTIONS(1873),
    [anon_sym_BANG_TILDE] = ACTIONS(1873),
    [anon_sym_LT_EQ] = ACTIONS(1863),
    [anon_sym_GT] = ACTIONS(1863),
    [anon_sym_GT_EQ] = ACTIONS(1879),
    [anon_sym_CARET] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_SLASH] = ACTIONS(1857),
    [anon_sym_PERCENT] = ACTIONS(1857),
    [sym_comment] = ACTIONS(87),
  },
  [7763] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(8352),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8356),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(8356),
    [anon_sym_PERCENT] = ACTIONS(8356),
    [sym_comment] = ACTIONS(87),
  },
  [7764] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8356),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(5827),
    [anon_sym_PERCENT] = ACTIONS(5827),
    [sym_comment] = ACTIONS(87),
  },
  [7765] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8350),
    [sym__binary_star] = ACTIONS(8352),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8356),
    [anon_sym_AMP] = ACTIONS(8358),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(8370),
    [anon_sym_GT_GT] = ACTIONS(8370),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(8376),
    [anon_sym_SLASH] = ACTIONS(8356),
    [anon_sym_PERCENT] = ACTIONS(8356),
    [sym_comment] = ACTIONS(87),
  },
  [7766] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8350),
    [sym__binary_star] = ACTIONS(8352),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8356),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(8370),
    [anon_sym_GT_GT] = ACTIONS(8370),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(8376),
    [anon_sym_SLASH] = ACTIONS(8356),
    [anon_sym_PERCENT] = ACTIONS(8356),
    [sym_comment] = ACTIONS(87),
  },
  [7767] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8350),
    [sym__binary_star] = ACTIONS(8352),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(8354),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8356),
    [anon_sym_AMP] = ACTIONS(8358),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(8370),
    [anon_sym_GT_GT] = ACTIONS(8370),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(8354),
    [anon_sym_PLUS] = ACTIONS(8376),
    [anon_sym_SLASH] = ACTIONS(8356),
    [anon_sym_PERCENT] = ACTIONS(8356),
    [sym_comment] = ACTIONS(87),
  },
  [7768] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(13165),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [7769] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(8350),
    [sym__binary_star] = ACTIONS(8352),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(8354),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(8356),
    [anon_sym_AMP] = ACTIONS(8358),
    [anon_sym_EQ] = ACTIONS(7888),
    [anon_sym_LT] = ACTIONS(8360),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_PLUS_EQ] = ACTIONS(5927),
    [anon_sym_DASH_EQ] = ACTIONS(5927),
    [anon_sym_STAR_EQ] = ACTIONS(5927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5927),
    [anon_sym_SLASH_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5927),
    [anon_sym_AMP_EQ] = ACTIONS(5927),
    [anon_sym_PERCENT_EQ] = ACTIONS(5927),
    [anon_sym_GT_GT_EQ] = ACTIONS(5927),
    [anon_sym_LT_LT_EQ] = ACTIONS(5927),
    [anon_sym_CARET_EQ] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(8364),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8366),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(8368),
    [anon_sym_AMP_AMP] = ACTIONS(8368),
    [anon_sym_LT_LT] = ACTIONS(8370),
    [anon_sym_GT_GT] = ACTIONS(8370),
    [anon_sym_EQ_EQ] = ACTIONS(8368),
    [anon_sym_BANG_EQ] = ACTIONS(8372),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8372),
    [anon_sym_LT_EQ_GT] = ACTIONS(8372),
    [anon_sym_EQ_TILDE] = ACTIONS(8372),
    [anon_sym_BANG_TILDE] = ACTIONS(8372),
    [anon_sym_LT_EQ] = ACTIONS(8360),
    [anon_sym_GT] = ACTIONS(8360),
    [anon_sym_GT_EQ] = ACTIONS(8374),
    [anon_sym_CARET] = ACTIONS(8354),
    [anon_sym_PLUS] = ACTIONS(8376),
    [anon_sym_SLASH] = ACTIONS(8356),
    [anon_sym_PERCENT] = ACTIONS(8356),
    [sym_comment] = ACTIONS(87),
  },
  [7770] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8350),
    [sym__binary_star] = ACTIONS(8352),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(8354),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8356),
    [anon_sym_AMP] = ACTIONS(8358),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(8360),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(8362),
    [anon_sym_DOT_DOT] = ACTIONS(8364),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8366),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(8368),
    [anon_sym_AMP_AMP] = ACTIONS(8368),
    [anon_sym_LT_LT] = ACTIONS(8370),
    [anon_sym_GT_GT] = ACTIONS(8370),
    [anon_sym_EQ_EQ] = ACTIONS(8368),
    [anon_sym_BANG_EQ] = ACTIONS(8372),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8372),
    [anon_sym_LT_EQ_GT] = ACTIONS(8372),
    [anon_sym_EQ_TILDE] = ACTIONS(8372),
    [anon_sym_BANG_TILDE] = ACTIONS(8372),
    [anon_sym_LT_EQ] = ACTIONS(8360),
    [anon_sym_GT] = ACTIONS(8360),
    [anon_sym_GT_EQ] = ACTIONS(8374),
    [anon_sym_CARET] = ACTIONS(8354),
    [anon_sym_PLUS] = ACTIONS(8376),
    [anon_sym_SLASH] = ACTIONS(8356),
    [anon_sym_PERCENT] = ACTIONS(8356),
    [sym_comment] = ACTIONS(87),
  },
  [7771] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8350),
    [sym__binary_star] = ACTIONS(8352),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(8354),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8356),
    [anon_sym_AMP] = ACTIONS(8358),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(8360),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(8370),
    [anon_sym_GT_GT] = ACTIONS(8370),
    [anon_sym_EQ_EQ] = ACTIONS(8368),
    [anon_sym_BANG_EQ] = ACTIONS(8372),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8372),
    [anon_sym_LT_EQ_GT] = ACTIONS(8372),
    [anon_sym_EQ_TILDE] = ACTIONS(8372),
    [anon_sym_BANG_TILDE] = ACTIONS(8372),
    [anon_sym_LT_EQ] = ACTIONS(8360),
    [anon_sym_GT] = ACTIONS(8360),
    [anon_sym_GT_EQ] = ACTIONS(8374),
    [anon_sym_CARET] = ACTIONS(8354),
    [anon_sym_PLUS] = ACTIONS(8376),
    [anon_sym_SLASH] = ACTIONS(8356),
    [anon_sym_PERCENT] = ACTIONS(8356),
    [sym_comment] = ACTIONS(87),
  },
  [7772] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8350),
    [sym__binary_star] = ACTIONS(8352),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8356),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(8376),
    [anon_sym_SLASH] = ACTIONS(8356),
    [anon_sym_PERCENT] = ACTIONS(8356),
    [sym_comment] = ACTIONS(87),
  },
  [7773] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(8350),
    [sym__binary_star] = ACTIONS(8352),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(8354),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(8356),
    [anon_sym_AMP] = ACTIONS(8358),
    [anon_sym_EQ] = ACTIONS(7936),
    [anon_sym_LT] = ACTIONS(8360),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_PLUS_EQ] = ACTIONS(5115),
    [anon_sym_DASH_EQ] = ACTIONS(5115),
    [anon_sym_STAR_EQ] = ACTIONS(5115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5115),
    [anon_sym_SLASH_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5115),
    [anon_sym_AMP_EQ] = ACTIONS(5115),
    [anon_sym_PERCENT_EQ] = ACTIONS(5115),
    [anon_sym_GT_GT_EQ] = ACTIONS(5115),
    [anon_sym_LT_LT_EQ] = ACTIONS(5115),
    [anon_sym_CARET_EQ] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(8362),
    [anon_sym_DOT_DOT] = ACTIONS(8364),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8366),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(8368),
    [anon_sym_AMP_AMP] = ACTIONS(8368),
    [anon_sym_LT_LT] = ACTIONS(8370),
    [anon_sym_GT_GT] = ACTIONS(8370),
    [anon_sym_EQ_EQ] = ACTIONS(8368),
    [anon_sym_BANG_EQ] = ACTIONS(8372),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8372),
    [anon_sym_LT_EQ_GT] = ACTIONS(8372),
    [anon_sym_EQ_TILDE] = ACTIONS(8372),
    [anon_sym_BANG_TILDE] = ACTIONS(8372),
    [anon_sym_LT_EQ] = ACTIONS(8360),
    [anon_sym_GT] = ACTIONS(8360),
    [anon_sym_GT_EQ] = ACTIONS(8374),
    [anon_sym_CARET] = ACTIONS(8354),
    [anon_sym_PLUS] = ACTIONS(8376),
    [anon_sym_SLASH] = ACTIONS(8356),
    [anon_sym_PERCENT] = ACTIONS(8356),
    [sym_comment] = ACTIONS(87),
  },
  [7774] = {
    [aux_sym_exceptions_repeat1] = STATE(9507),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6193),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_PLUS_EQ] = ACTIONS(6191),
    [anon_sym_DASH_EQ] = ACTIONS(6191),
    [anon_sym_STAR_EQ] = ACTIONS(6191),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6191),
    [anon_sym_SLASH_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6191),
    [anon_sym_AMP_EQ] = ACTIONS(6191),
    [anon_sym_PERCENT_EQ] = ACTIONS(6191),
    [anon_sym_GT_GT_EQ] = ACTIONS(6191),
    [anon_sym_LT_LT_EQ] = ACTIONS(6191),
    [anon_sym_CARET_EQ] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6193),
    [anon_sym_AMP_AMP] = ACTIONS(6193),
    [anon_sym_LT_LT] = ACTIONS(6193),
    [anon_sym_GT_GT] = ACTIONS(6193),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6193),
    [anon_sym_PLUS] = ACTIONS(6193),
    [anon_sym_SLASH] = ACTIONS(6193),
    [anon_sym_PERCENT] = ACTIONS(6193),
    [sym_comment] = ACTIONS(87),
  },
  [7775] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(8350),
    [sym__binary_star] = ACTIONS(8352),
    [anon_sym_LBRACE] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(8354),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(8356),
    [anon_sym_AMP] = ACTIONS(8358),
    [anon_sym_EQ] = ACTIONS(7938),
    [anon_sym_LT] = ACTIONS(8360),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_PLUS_EQ] = ACTIONS(6210),
    [anon_sym_DASH_EQ] = ACTIONS(6210),
    [anon_sym_STAR_EQ] = ACTIONS(6210),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6210),
    [anon_sym_SLASH_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6210),
    [anon_sym_AMP_EQ] = ACTIONS(6210),
    [anon_sym_PERCENT_EQ] = ACTIONS(6210),
    [anon_sym_GT_GT_EQ] = ACTIONS(6210),
    [anon_sym_LT_LT_EQ] = ACTIONS(6210),
    [anon_sym_CARET_EQ] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(8362),
    [anon_sym_DOT_DOT] = ACTIONS(8364),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8366),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(8368),
    [anon_sym_AMP_AMP] = ACTIONS(8368),
    [anon_sym_LT_LT] = ACTIONS(8370),
    [anon_sym_GT_GT] = ACTIONS(8370),
    [anon_sym_EQ_EQ] = ACTIONS(8368),
    [anon_sym_BANG_EQ] = ACTIONS(8372),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8372),
    [anon_sym_LT_EQ_GT] = ACTIONS(8372),
    [anon_sym_EQ_TILDE] = ACTIONS(8372),
    [anon_sym_BANG_TILDE] = ACTIONS(8372),
    [anon_sym_LT_EQ] = ACTIONS(8360),
    [anon_sym_GT] = ACTIONS(8360),
    [anon_sym_GT_EQ] = ACTIONS(8374),
    [anon_sym_CARET] = ACTIONS(8354),
    [anon_sym_PLUS] = ACTIONS(8376),
    [anon_sym_SLASH] = ACTIONS(8356),
    [anon_sym_PERCENT] = ACTIONS(8356),
    [sym_comment] = ACTIONS(87),
  },
  [7776] = {
    [sym_string] = STATE(7776),
    [aux_sym_chained_string_repeat1] = STATE(7776),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(12267),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6217),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_EQ] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_do] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_PLUS_EQ] = ACTIONS(6212),
    [anon_sym_DASH_EQ] = ACTIONS(6212),
    [anon_sym_STAR_EQ] = ACTIONS(6212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6212),
    [anon_sym_SLASH_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6212),
    [anon_sym_AMP_EQ] = ACTIONS(6212),
    [anon_sym_PERCENT_EQ] = ACTIONS(6212),
    [anon_sym_GT_GT_EQ] = ACTIONS(6212),
    [anon_sym_LT_LT_EQ] = ACTIONS(6212),
    [anon_sym_CARET_EQ] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6217),
    [anon_sym_AMP_AMP] = ACTIONS(6217),
    [anon_sym_LT_LT] = ACTIONS(6217),
    [anon_sym_GT_GT] = ACTIONS(6217),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6217),
    [anon_sym_PLUS] = ACTIONS(6217),
    [anon_sym_SLASH] = ACTIONS(6217),
    [anon_sym_PERCENT] = ACTIONS(6217),
    [sym_comment] = ACTIONS(87),
  },
  [7777] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(9508),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1066),
    [sym_scope_resolution] = STATE(1061),
    [sym_call] = STATE(1061),
    [sym_method_call] = STATE(1066),
    [sym_assignment] = STATE(9508),
    [sym_operator_assignment] = STATE(9508),
    [sym_conditional] = STATE(9508),
    [sym_range] = STATE(9508),
    [sym_binary] = STATE(9508),
    [sym_unary] = STATE(9508),
    [sym_left_assignment_list] = STATE(1065),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1066),
    [sym__variable] = STATE(1061),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1066),
    [sym_false] = STATE(1066),
    [sym_nil] = STATE(1066),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2804),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1895),
    [anon_sym_break] = ACTIONS(1897),
    [anon_sym_next] = ACTIONS(1899),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(4715),
    [anon_sym_defined_QMARK] = ACTIONS(1909),
    [anon_sym_not] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1915),
    [anon_sym_TILDE] = ACTIONS(1915),
    [sym_constant] = ACTIONS(1921),
    [sym_identifier] = ACTIONS(1921),
    [sym_instance_variable] = ACTIONS(1919),
    [sym_class_variable] = ACTIONS(1919),
    [sym_global_variable] = ACTIONS(1919),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1921),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1921),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7778] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5309),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1066),
    [sym_scope_resolution] = STATE(1061),
    [sym_call] = STATE(1061),
    [sym_method_call] = STATE(1066),
    [sym_splat_argument] = STATE(8678),
    [sym_assignment] = STATE(5309),
    [sym_operator_assignment] = STATE(5309),
    [sym_conditional] = STATE(5309),
    [sym_range] = STATE(5309),
    [sym_binary] = STATE(5309),
    [sym_unary] = STATE(5309),
    [sym__arg_or_splat_arg] = STATE(8678),
    [sym_left_assignment_list] = STATE(1065),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1066),
    [sym__variable] = STATE(1061),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1066),
    [sym_false] = STATE(1066),
    [sym_nil] = STATE(1066),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(2804),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__splat_star] = ACTIONS(4673),
    [sym__unary_minus] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1895),
    [anon_sym_break] = ACTIONS(1897),
    [anon_sym_next] = ACTIONS(1899),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(4715),
    [anon_sym_defined_QMARK] = ACTIONS(1909),
    [anon_sym_not] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1915),
    [anon_sym_TILDE] = ACTIONS(1915),
    [sym_constant] = ACTIONS(1921),
    [sym_identifier] = ACTIONS(1921),
    [sym_instance_variable] = ACTIONS(1919),
    [sym_class_variable] = ACTIONS(1919),
    [sym_global_variable] = ACTIONS(1919),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(1921),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1921),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7779] = {
    [aux_sym_exceptions_repeat1] = STATE(9509),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_LBRACE] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(13167),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9857),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_EQ] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_do] = ACTIONS(9855),
    [anon_sym_EQ_GT] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_PLUS_EQ] = ACTIONS(9855),
    [anon_sym_DASH_EQ] = ACTIONS(9855),
    [anon_sym_STAR_EQ] = ACTIONS(9855),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9855),
    [anon_sym_SLASH_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9855),
    [anon_sym_AMP_EQ] = ACTIONS(9855),
    [anon_sym_PERCENT_EQ] = ACTIONS(9855),
    [anon_sym_GT_GT_EQ] = ACTIONS(9855),
    [anon_sym_LT_LT_EQ] = ACTIONS(9855),
    [anon_sym_CARET_EQ] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9857),
    [anon_sym_AMP_AMP] = ACTIONS(9857),
    [anon_sym_LT_LT] = ACTIONS(9857),
    [anon_sym_GT_GT] = ACTIONS(9857),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9857),
    [anon_sym_PLUS] = ACTIONS(9857),
    [anon_sym_SLASH] = ACTIONS(9857),
    [anon_sym_PERCENT] = ACTIONS(9857),
    [sym_comment] = ACTIONS(87),
  },
  [7780] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(8388),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8388),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(8388),
    [anon_sym_PERCENT] = ACTIONS(8388),
    [sym_comment] = ACTIONS(87),
  },
  [7781] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8388),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [7782] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8386),
    [sym__binary_star] = ACTIONS(8388),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8388),
    [anon_sym_AMP] = ACTIONS(8392),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(8404),
    [anon_sym_GT_GT] = ACTIONS(8404),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(8386),
    [anon_sym_SLASH] = ACTIONS(8388),
    [anon_sym_PERCENT] = ACTIONS(8388),
    [sym_comment] = ACTIONS(87),
  },
  [7783] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8386),
    [sym__binary_star] = ACTIONS(8388),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8388),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(8404),
    [anon_sym_GT_GT] = ACTIONS(8404),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(8386),
    [anon_sym_SLASH] = ACTIONS(8388),
    [anon_sym_PERCENT] = ACTIONS(8388),
    [sym_comment] = ACTIONS(87),
  },
  [7784] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8386),
    [sym__binary_star] = ACTIONS(8388),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(8390),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8388),
    [anon_sym_AMP] = ACTIONS(8392),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(8404),
    [anon_sym_GT_GT] = ACTIONS(8404),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(8410),
    [anon_sym_PLUS] = ACTIONS(8386),
    [anon_sym_SLASH] = ACTIONS(8388),
    [anon_sym_PERCENT] = ACTIONS(8388),
    [sym_comment] = ACTIONS(87),
  },
  [7785] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(13169),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [7786] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(8386),
    [sym__binary_star] = ACTIONS(8388),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(8390),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(8388),
    [anon_sym_AMP] = ACTIONS(8392),
    [anon_sym_LT] = ACTIONS(8394),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(8398),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8400),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(8402),
    [anon_sym_AMP_AMP] = ACTIONS(8402),
    [anon_sym_LT_LT] = ACTIONS(8404),
    [anon_sym_GT_GT] = ACTIONS(8404),
    [anon_sym_EQ_EQ] = ACTIONS(8406),
    [anon_sym_BANG_EQ] = ACTIONS(8402),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8402),
    [anon_sym_LT_EQ_GT] = ACTIONS(8402),
    [anon_sym_EQ_TILDE] = ACTIONS(8402),
    [anon_sym_BANG_TILDE] = ACTIONS(8402),
    [anon_sym_LT_EQ] = ACTIONS(8394),
    [anon_sym_GT] = ACTIONS(8394),
    [anon_sym_GT_EQ] = ACTIONS(8408),
    [anon_sym_CARET] = ACTIONS(8410),
    [anon_sym_PLUS] = ACTIONS(8386),
    [anon_sym_SLASH] = ACTIONS(8388),
    [anon_sym_PERCENT] = ACTIONS(8388),
    [sym_comment] = ACTIONS(87),
  },
  [7787] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8386),
    [sym__binary_star] = ACTIONS(8388),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(8390),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8388),
    [anon_sym_AMP] = ACTIONS(8392),
    [anon_sym_LT] = ACTIONS(8394),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(8396),
    [anon_sym_DOT_DOT] = ACTIONS(8398),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8400),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(8402),
    [anon_sym_AMP_AMP] = ACTIONS(8402),
    [anon_sym_LT_LT] = ACTIONS(8404),
    [anon_sym_GT_GT] = ACTIONS(8404),
    [anon_sym_EQ_EQ] = ACTIONS(8406),
    [anon_sym_BANG_EQ] = ACTIONS(8402),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8402),
    [anon_sym_LT_EQ_GT] = ACTIONS(8402),
    [anon_sym_EQ_TILDE] = ACTIONS(8402),
    [anon_sym_BANG_TILDE] = ACTIONS(8402),
    [anon_sym_LT_EQ] = ACTIONS(8394),
    [anon_sym_GT] = ACTIONS(8394),
    [anon_sym_GT_EQ] = ACTIONS(8408),
    [anon_sym_CARET] = ACTIONS(8410),
    [anon_sym_PLUS] = ACTIONS(8386),
    [anon_sym_SLASH] = ACTIONS(8388),
    [anon_sym_PERCENT] = ACTIONS(8388),
    [sym_comment] = ACTIONS(87),
  },
  [7788] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8386),
    [sym__binary_star] = ACTIONS(8388),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(8390),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8388),
    [anon_sym_AMP] = ACTIONS(8392),
    [anon_sym_LT] = ACTIONS(8394),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(8404),
    [anon_sym_GT_GT] = ACTIONS(8404),
    [anon_sym_EQ_EQ] = ACTIONS(8406),
    [anon_sym_BANG_EQ] = ACTIONS(8402),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8402),
    [anon_sym_LT_EQ_GT] = ACTIONS(8402),
    [anon_sym_EQ_TILDE] = ACTIONS(8402),
    [anon_sym_BANG_TILDE] = ACTIONS(8402),
    [anon_sym_LT_EQ] = ACTIONS(8394),
    [anon_sym_GT] = ACTIONS(8394),
    [anon_sym_GT_EQ] = ACTIONS(8408),
    [anon_sym_CARET] = ACTIONS(8410),
    [anon_sym_PLUS] = ACTIONS(8386),
    [anon_sym_SLASH] = ACTIONS(8388),
    [anon_sym_PERCENT] = ACTIONS(8388),
    [sym_comment] = ACTIONS(87),
  },
  [7789] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8386),
    [sym__binary_star] = ACTIONS(8388),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8388),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(8386),
    [anon_sym_SLASH] = ACTIONS(8388),
    [anon_sym_PERCENT] = ACTIONS(8388),
    [sym_comment] = ACTIONS(87),
  },
  [7790] = {
    [aux_sym_exceptions_repeat1] = STATE(7790),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_COMMA] = ACTIONS(13171),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [7791] = {
    [aux_sym_exceptions_repeat1] = STATE(5327),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [7792] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(8386),
    [sym__binary_star] = ACTIONS(8388),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(8390),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(8388),
    [anon_sym_AMP] = ACTIONS(8392),
    [anon_sym_LT] = ACTIONS(8394),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(8396),
    [anon_sym_DOT_DOT] = ACTIONS(8398),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8400),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(8402),
    [anon_sym_AMP_AMP] = ACTIONS(8402),
    [anon_sym_LT_LT] = ACTIONS(8404),
    [anon_sym_GT_GT] = ACTIONS(8404),
    [anon_sym_EQ_EQ] = ACTIONS(8406),
    [anon_sym_BANG_EQ] = ACTIONS(8402),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8402),
    [anon_sym_LT_EQ_GT] = ACTIONS(8402),
    [anon_sym_EQ_TILDE] = ACTIONS(8402),
    [anon_sym_BANG_TILDE] = ACTIONS(8402),
    [anon_sym_LT_EQ] = ACTIONS(8394),
    [anon_sym_GT] = ACTIONS(8394),
    [anon_sym_GT_EQ] = ACTIONS(8408),
    [anon_sym_CARET] = ACTIONS(8410),
    [anon_sym_PLUS] = ACTIONS(8386),
    [anon_sym_SLASH] = ACTIONS(8388),
    [anon_sym_PERCENT] = ACTIONS(8388),
    [sym_comment] = ACTIONS(87),
  },
  [7793] = {
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(8434),
    [sym__binary_star] = ACTIONS(8436),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(8438),
    [anon_sym_STAR_STAR] = ACTIONS(8436),
    [anon_sym_AMP] = ACTIONS(8440),
    [anon_sym_LT] = ACTIONS(8442),
    [anon_sym_in] = ACTIONS(4211),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(8444),
    [anon_sym_DOT_DOT] = ACTIONS(8446),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8448),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(8452),
    [anon_sym_AMP_AMP] = ACTIONS(8452),
    [anon_sym_LT_LT] = ACTIONS(8454),
    [anon_sym_GT_GT] = ACTIONS(8454),
    [anon_sym_EQ_EQ] = ACTIONS(8456),
    [anon_sym_BANG_EQ] = ACTIONS(8452),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8452),
    [anon_sym_LT_EQ_GT] = ACTIONS(8452),
    [anon_sym_EQ_TILDE] = ACTIONS(8452),
    [anon_sym_BANG_TILDE] = ACTIONS(8452),
    [anon_sym_LT_EQ] = ACTIONS(8442),
    [anon_sym_GT] = ACTIONS(8442),
    [anon_sym_GT_EQ] = ACTIONS(8458),
    [anon_sym_CARET] = ACTIONS(8460),
    [anon_sym_PLUS] = ACTIONS(8434),
    [anon_sym_SLASH] = ACTIONS(8436),
    [anon_sym_PERCENT] = ACTIONS(8436),
    [sym_comment] = ACTIONS(87),
  },
  [7794] = {
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(8434),
    [sym__binary_star] = ACTIONS(8436),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(8438),
    [anon_sym_STAR_STAR] = ACTIONS(8436),
    [anon_sym_AMP] = ACTIONS(8440),
    [anon_sym_LT] = ACTIONS(8442),
    [anon_sym_in] = ACTIONS(4247),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(8444),
    [anon_sym_DOT_DOT] = ACTIONS(8446),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8448),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(8452),
    [anon_sym_AMP_AMP] = ACTIONS(8452),
    [anon_sym_LT_LT] = ACTIONS(8454),
    [anon_sym_GT_GT] = ACTIONS(8454),
    [anon_sym_EQ_EQ] = ACTIONS(8456),
    [anon_sym_BANG_EQ] = ACTIONS(8452),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8452),
    [anon_sym_LT_EQ_GT] = ACTIONS(8452),
    [anon_sym_EQ_TILDE] = ACTIONS(8452),
    [anon_sym_BANG_TILDE] = ACTIONS(8452),
    [anon_sym_LT_EQ] = ACTIONS(8442),
    [anon_sym_GT] = ACTIONS(8442),
    [anon_sym_GT_EQ] = ACTIONS(8458),
    [anon_sym_CARET] = ACTIONS(8460),
    [anon_sym_PLUS] = ACTIONS(8434),
    [anon_sym_SLASH] = ACTIONS(8436),
    [anon_sym_PERCENT] = ACTIONS(8436),
    [sym_comment] = ACTIONS(87),
  },
  [7795] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9511),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2848),
    [sym_scope_resolution] = STATE(2846),
    [sym_call] = STATE(2846),
    [sym_method_call] = STATE(2848),
    [sym_assignment] = STATE(9511),
    [sym_operator_assignment] = STATE(9511),
    [sym_conditional] = STATE(9511),
    [sym_range] = STATE(9511),
    [sym_binary] = STATE(9511),
    [sym_unary] = STATE(9511),
    [sym_left_assignment_list] = STATE(2847),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2848),
    [sym__variable] = STATE(2846),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2848),
    [sym_false] = STATE(2848),
    [sym_nil] = STATE(2848),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2849),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4775),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4777),
    [anon_sym_yield] = ACTIONS(4779),
    [anon_sym_break] = ACTIONS(4781),
    [anon_sym_next] = ACTIONS(4783),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4785),
    [anon_sym_defined_QMARK] = ACTIONS(4787),
    [anon_sym_not] = ACTIONS(4789),
    [anon_sym_BANG] = ACTIONS(4791),
    [anon_sym_TILDE] = ACTIONS(4791),
    [sym_constant] = ACTIONS(4793),
    [sym_identifier] = ACTIONS(4793),
    [sym_instance_variable] = ACTIONS(4795),
    [sym_class_variable] = ACTIONS(4795),
    [sym_global_variable] = ACTIONS(4795),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4793),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4793),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7796] = {
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(8434),
    [sym__binary_star] = ACTIONS(8436),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(8438),
    [anon_sym_STAR_STAR] = ACTIONS(8436),
    [anon_sym_AMP] = ACTIONS(8440),
    [anon_sym_LT] = ACTIONS(8442),
    [anon_sym_in] = ACTIONS(3281),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(8444),
    [anon_sym_DOT_DOT] = ACTIONS(8446),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8448),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(8452),
    [anon_sym_AMP_AMP] = ACTIONS(8452),
    [anon_sym_LT_LT] = ACTIONS(8454),
    [anon_sym_GT_GT] = ACTIONS(8454),
    [anon_sym_EQ_EQ] = ACTIONS(8456),
    [anon_sym_BANG_EQ] = ACTIONS(8452),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8452),
    [anon_sym_LT_EQ_GT] = ACTIONS(8452),
    [anon_sym_EQ_TILDE] = ACTIONS(8452),
    [anon_sym_BANG_TILDE] = ACTIONS(8452),
    [anon_sym_LT_EQ] = ACTIONS(8442),
    [anon_sym_GT] = ACTIONS(8442),
    [anon_sym_GT_EQ] = ACTIONS(8458),
    [anon_sym_CARET] = ACTIONS(8460),
    [anon_sym_PLUS] = ACTIONS(8434),
    [anon_sym_SLASH] = ACTIONS(8436),
    [anon_sym_PERCENT] = ACTIONS(8436),
    [sym_comment] = ACTIONS(87),
  },
  [7797] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9512),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2848),
    [sym_scope_resolution] = STATE(2846),
    [sym_call] = STATE(2846),
    [sym_method_call] = STATE(2848),
    [sym_assignment] = STATE(9512),
    [sym_operator_assignment] = STATE(9512),
    [sym_conditional] = STATE(9512),
    [sym_range] = STATE(9512),
    [sym_binary] = STATE(9512),
    [sym_unary] = STATE(9512),
    [sym_left_assignment_list] = STATE(2847),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2848),
    [sym__variable] = STATE(2846),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2848),
    [sym_false] = STATE(2848),
    [sym_nil] = STATE(2848),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2849),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4775),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4777),
    [anon_sym_yield] = ACTIONS(4779),
    [anon_sym_break] = ACTIONS(4781),
    [anon_sym_next] = ACTIONS(4783),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4785),
    [anon_sym_defined_QMARK] = ACTIONS(4787),
    [anon_sym_not] = ACTIONS(4789),
    [anon_sym_BANG] = ACTIONS(4791),
    [anon_sym_TILDE] = ACTIONS(4791),
    [sym_constant] = ACTIONS(4793),
    [sym_identifier] = ACTIONS(4793),
    [sym_instance_variable] = ACTIONS(4795),
    [sym_class_variable] = ACTIONS(4795),
    [sym_global_variable] = ACTIONS(4795),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4793),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4793),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7798] = {
    [sym_heredoc_body] = STATE(9513),
    [aux_sym_call_repeat1] = STATE(9513),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_in] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [7799] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(5337),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1089),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(1089),
    [sym__argument] = STATE(4250),
    [sym_splat_argument] = STATE(4250),
    [sym_hash_splat_argument] = STATE(4250),
    [sym_block_argument] = STATE(4250),
    [sym_assignment] = STATE(5337),
    [sym_operator_assignment] = STATE(5337),
    [sym_conditional] = STATE(5337),
    [sym_range] = STATE(5337),
    [sym_binary] = STATE(5337),
    [sym_unary] = STATE(5337),
    [sym_left_assignment_list] = STATE(1088),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1089),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1089),
    [sym_false] = STATE(1089),
    [sym_nil] = STATE(1089),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(5340),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_heredoc_body] = STATE(9514),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(4250),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(8426),
    [sym__splat_star] = ACTIONS(8428),
    [sym__unary_minus] = ACTIONS(1937),
    [sym__identifier_hash_key] = ACTIONS(8430),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13174),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1943),
    [anon_sym_yield] = ACTIONS(1945),
    [anon_sym_break] = ACTIONS(1947),
    [anon_sym_next] = ACTIONS(1949),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1951),
    [anon_sym_defined_QMARK] = ACTIONS(1953),
    [anon_sym_not] = ACTIONS(1955),
    [anon_sym_BANG] = ACTIONS(1957),
    [anon_sym_TILDE] = ACTIONS(1957),
    [sym_constant] = ACTIONS(8432),
    [sym_identifier] = ACTIONS(8432),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7800] = {
    [sym_heredoc_body] = STATE(9515),
    [aux_sym_call_repeat1] = STATE(9515),
    [aux_sym_argument_list_repeat1] = STATE(9516),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(11352),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_in] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [7801] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(8436),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(8436),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_in] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(8436),
    [anon_sym_PERCENT] = ACTIONS(8436),
    [sym_comment] = ACTIONS(87),
  },
  [7802] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(8436),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_in] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [7803] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8434),
    [sym__binary_star] = ACTIONS(8436),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(8436),
    [anon_sym_AMP] = ACTIONS(8440),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_in] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(8454),
    [anon_sym_GT_GT] = ACTIONS(8454),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(8434),
    [anon_sym_SLASH] = ACTIONS(8436),
    [anon_sym_PERCENT] = ACTIONS(8436),
    [sym_comment] = ACTIONS(87),
  },
  [7804] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8434),
    [sym__binary_star] = ACTIONS(8436),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(8436),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_in] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(8454),
    [anon_sym_GT_GT] = ACTIONS(8454),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(8434),
    [anon_sym_SLASH] = ACTIONS(8436),
    [anon_sym_PERCENT] = ACTIONS(8436),
    [sym_comment] = ACTIONS(87),
  },
  [7805] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8434),
    [sym__binary_star] = ACTIONS(8436),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(8438),
    [anon_sym_STAR_STAR] = ACTIONS(8436),
    [anon_sym_AMP] = ACTIONS(8440),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_in] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(8454),
    [anon_sym_GT_GT] = ACTIONS(8454),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(8460),
    [anon_sym_PLUS] = ACTIONS(8434),
    [anon_sym_SLASH] = ACTIONS(8436),
    [anon_sym_PERCENT] = ACTIONS(8436),
    [sym_comment] = ACTIONS(87),
  },
  [7806] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(13176),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [7807] = {
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(8434),
    [sym__binary_star] = ACTIONS(8436),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(8438),
    [anon_sym_STAR_STAR] = ACTIONS(8436),
    [anon_sym_AMP] = ACTIONS(8440),
    [anon_sym_LT] = ACTIONS(8442),
    [anon_sym_in] = ACTIONS(5927),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(8446),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8448),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(8452),
    [anon_sym_AMP_AMP] = ACTIONS(8452),
    [anon_sym_LT_LT] = ACTIONS(8454),
    [anon_sym_GT_GT] = ACTIONS(8454),
    [anon_sym_EQ_EQ] = ACTIONS(8456),
    [anon_sym_BANG_EQ] = ACTIONS(8452),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8452),
    [anon_sym_LT_EQ_GT] = ACTIONS(8452),
    [anon_sym_EQ_TILDE] = ACTIONS(8452),
    [anon_sym_BANG_TILDE] = ACTIONS(8452),
    [anon_sym_LT_EQ] = ACTIONS(8442),
    [anon_sym_GT] = ACTIONS(8442),
    [anon_sym_GT_EQ] = ACTIONS(8458),
    [anon_sym_CARET] = ACTIONS(8460),
    [anon_sym_PLUS] = ACTIONS(8434),
    [anon_sym_SLASH] = ACTIONS(8436),
    [anon_sym_PERCENT] = ACTIONS(8436),
    [sym_comment] = ACTIONS(87),
  },
  [7808] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8434),
    [sym__binary_star] = ACTIONS(8436),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(8438),
    [anon_sym_STAR_STAR] = ACTIONS(8436),
    [anon_sym_AMP] = ACTIONS(8440),
    [anon_sym_LT] = ACTIONS(8442),
    [anon_sym_in] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(8444),
    [anon_sym_DOT_DOT] = ACTIONS(8446),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8448),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(8452),
    [anon_sym_AMP_AMP] = ACTIONS(8452),
    [anon_sym_LT_LT] = ACTIONS(8454),
    [anon_sym_GT_GT] = ACTIONS(8454),
    [anon_sym_EQ_EQ] = ACTIONS(8456),
    [anon_sym_BANG_EQ] = ACTIONS(8452),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8452),
    [anon_sym_LT_EQ_GT] = ACTIONS(8452),
    [anon_sym_EQ_TILDE] = ACTIONS(8452),
    [anon_sym_BANG_TILDE] = ACTIONS(8452),
    [anon_sym_LT_EQ] = ACTIONS(8442),
    [anon_sym_GT] = ACTIONS(8442),
    [anon_sym_GT_EQ] = ACTIONS(8458),
    [anon_sym_CARET] = ACTIONS(8460),
    [anon_sym_PLUS] = ACTIONS(8434),
    [anon_sym_SLASH] = ACTIONS(8436),
    [anon_sym_PERCENT] = ACTIONS(8436),
    [sym_comment] = ACTIONS(87),
  },
  [7809] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8434),
    [sym__binary_star] = ACTIONS(8436),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(8438),
    [anon_sym_STAR_STAR] = ACTIONS(8436),
    [anon_sym_AMP] = ACTIONS(8440),
    [anon_sym_LT] = ACTIONS(8442),
    [anon_sym_in] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(8454),
    [anon_sym_GT_GT] = ACTIONS(8454),
    [anon_sym_EQ_EQ] = ACTIONS(8456),
    [anon_sym_BANG_EQ] = ACTIONS(8452),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8452),
    [anon_sym_LT_EQ_GT] = ACTIONS(8452),
    [anon_sym_EQ_TILDE] = ACTIONS(8452),
    [anon_sym_BANG_TILDE] = ACTIONS(8452),
    [anon_sym_LT_EQ] = ACTIONS(8442),
    [anon_sym_GT] = ACTIONS(8442),
    [anon_sym_GT_EQ] = ACTIONS(8458),
    [anon_sym_CARET] = ACTIONS(8460),
    [anon_sym_PLUS] = ACTIONS(8434),
    [anon_sym_SLASH] = ACTIONS(8436),
    [anon_sym_PERCENT] = ACTIONS(8436),
    [sym_comment] = ACTIONS(87),
  },
  [7810] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8434),
    [sym__binary_star] = ACTIONS(8436),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(8436),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_in] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(8434),
    [anon_sym_SLASH] = ACTIONS(8436),
    [anon_sym_PERCENT] = ACTIONS(8436),
    [sym_comment] = ACTIONS(87),
  },
  [7811] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(9518),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(7820),
    [sym_scope_resolution] = STATE(2846),
    [sym_call] = STATE(2846),
    [sym_method_call] = STATE(7820),
    [sym_assignment] = STATE(9518),
    [sym_operator_assignment] = STATE(9518),
    [sym_conditional] = STATE(9518),
    [sym_range] = STATE(9518),
    [sym_binary] = STATE(9518),
    [sym_unary] = STATE(9518),
    [sym_left_assignment_list] = STATE(7819),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7820),
    [sym__variable] = STATE(2846),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(7820),
    [sym_false] = STATE(7820),
    [sym_nil] = STATE(7820),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(7821),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(11356),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(11358),
    [anon_sym_yield] = ACTIONS(11360),
    [anon_sym_break] = ACTIONS(11362),
    [anon_sym_next] = ACTIONS(11364),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(11366),
    [anon_sym_defined_QMARK] = ACTIONS(11368),
    [anon_sym_not] = ACTIONS(11370),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_TILDE] = ACTIONS(11372),
    [sym_constant] = ACTIONS(4793),
    [sym_identifier] = ACTIONS(4793),
    [sym_instance_variable] = ACTIONS(4795),
    [sym_class_variable] = ACTIONS(4795),
    [sym_global_variable] = ACTIONS(4795),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(4793),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4793),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [7812] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(5357),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2892),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(2892),
    [sym_argument_list] = STATE(6614),
    [sym__argument_list_with_parens] = STATE(5358),
    [sym__argument] = STATE(5359),
    [sym_splat_argument] = STATE(5359),
    [sym_hash_splat_argument] = STATE(5359),
    [sym_block_argument] = STATE(5359),
    [sym_assignment] = STATE(5357),
    [sym_operator_assignment] = STATE(5357),
    [sym_conditional] = STATE(5357),
    [sym_range] = STATE(5357),
    [sym_binary] = STATE(5357),
    [sym_unary] = STATE(5357),
    [sym_left_assignment_list] = STATE(2891),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2892),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2892),
    [sym_false] = STATE(2892),
    [sym_nil] = STATE(2892),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(5360),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(5359),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(8462),
    [sym__splat_star] = ACTIONS(8464),
    [sym__unary_minus] = ACTIONS(4843),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(8466),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4847),
    [anon_sym_yield] = ACTIONS(4849),
    [anon_sym_break] = ACTIONS(4851),
    [anon_sym_next] = ACTIONS(4853),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_in] = ACTIONS(377),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_PLUS_EQ] = ACTIONS(365),
    [anon_sym_DASH_EQ] = ACTIONS(365),
    [anon_sym_STAR_EQ] = ACTIONS(365),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(365),
    [anon_sym_SLASH_EQ] = ACTIONS(365),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(365),
    [anon_sym_PIPE_EQ] = ACTIONS(365),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(365),
    [anon_sym_AMP_EQ] = ACTIONS(365),
    [anon_sym_PERCENT_EQ] = ACTIONS(365),
    [anon_sym_GT_GT_EQ] = ACTIONS(365),
    [anon_sym_LT_LT_EQ] = ACTIONS(365),
    [anon_sym_CARET_EQ] = ACTIONS(365),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_PERCENT] = ACTIONS(377),
    [anon_sym_defined_QMARK] = ACTIONS(4855),
    [anon_sym_not] = ACTIONS(4857),
    [anon_sym_BANG] = ACTIONS(4859),
    [anon_sym_TILDE] = ACTIONS(4861),
    [sym_constant] = ACTIONS(8468),
    [sym_identifier] = ACTIONS(8468),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [7813] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(5357),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2892),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(2892),
    [sym_argument_list] = STATE(6615),
    [sym__argument_list_with_parens] = STATE(5358),
    [sym__argument] = STATE(5359),
    [sym_splat_argument] = STATE(5359),
    [sym_hash_splat_argument] = STATE(5359),
    [sym_block_argument] = STATE(5359),
    [sym_assignment] = STATE(5357),
    [sym_operator_assignment] = STATE(5357),
    [sym_conditional] = STATE(5357),
    [sym_range] = STATE(5357),
    [sym_binary] = STATE(5357),
    [sym_unary] = STATE(5357),
    [sym_left_assignment_list] = STATE(2891),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2892),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2892),
    [sym_false] = STATE(2892),
    [sym_nil] = STATE(2892),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(5360),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(5359),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(8462),
    [sym__splat_star] = ACTIONS(8464),
    [sym__unary_minus] = ACTIONS(4843),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(8466),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_EQ] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4847),
    [anon_sym_yield] = ACTIONS(4849),
    [anon_sym_break] = ACTIONS(4851),
    [anon_sym_next] = ACTIONS(4853),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_in] = ACTIONS(419),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_PLUS_EQ] = ACTIONS(417),
    [anon_sym_DASH_EQ] = ACTIONS(417),
    [anon_sym_STAR_EQ] = ACTIONS(417),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(417),
    [anon_sym_SLASH_EQ] = ACTIONS(417),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(417),
    [anon_sym_PIPE_EQ] = ACTIONS(417),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(417),
    [anon_sym_AMP_EQ] = ACTIONS(417),
    [anon_sym_PERCENT_EQ] = ACTIONS(417),
    [anon_sym_GT_GT_EQ] = ACTIONS(417),
    [anon_sym_LT_LT_EQ] = ACTIONS(417),
    [anon_sym_CARET_EQ] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(4855),
    [anon_sym_not] = ACTIONS(4857),
    [anon_sym_BANG] = ACTIONS(4859),
    [anon_sym_TILDE] = ACTIONS(4861),
    [sym_constant] = ACTIONS(8468),
    [sym_identifier] = ACTIONS(8468),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [7814] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(5357),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2892),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(2892),
    [sym_argument_list] = STATE(6616),
    [sym__argument_list_with_parens] = STATE(5358),
    [sym__argument] = STATE(5359),
    [sym_splat_argument] = STATE(5359),
    [sym_hash_splat_argument] = STATE(5359),
    [sym_block_argument] = STATE(5359),
    [sym_assignment] = STATE(5357),
    [sym_operator_assignment] = STATE(5357),
    [sym_conditional] = STATE(5357),
    [sym_range] = STATE(5357),
    [sym_binary] = STATE(5357),
    [sym_unary] = STATE(5357),
    [sym_left_assignment_list] = STATE(2891),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2892),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2892),
    [sym_false] = STATE(2892),
    [sym_nil] = STATE(2892),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(5360),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(5359),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(8462),
    [sym__splat_star] = ACTIONS(8464),
    [sym__unary_minus] = ACTIONS(4843),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(8466),
    [anon_sym_LBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_EQ] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4847),
    [anon_sym_yield] = ACTIONS(4849),
    [anon_sym_break] = ACTIONS(4851),
    [anon_sym_next] = ACTIONS(4853),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_in] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_PLUS_EQ] = ACTIONS(421),
    [anon_sym_DASH_EQ] = ACTIONS(421),
    [anon_sym_STAR_EQ] = ACTIONS(421),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(421),
    [anon_sym_SLASH_EQ] = ACTIONS(421),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(421),
    [anon_sym_PIPE_EQ] = ACTIONS(421),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(421),
    [anon_sym_AMP_EQ] = ACTIONS(421),
    [anon_sym_PERCENT_EQ] = ACTIONS(421),
    [anon_sym_GT_GT_EQ] = ACTIONS(421),
    [anon_sym_LT_LT_EQ] = ACTIONS(421),
    [anon_sym_CARET_EQ] = ACTIONS(421),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(4855),
    [anon_sym_not] = ACTIONS(4857),
    [anon_sym_BANG] = ACTIONS(4859),
    [anon_sym_TILDE] = ACTIONS(4861),
    [sym_constant] = ACTIONS(8468),
    [sym_identifier] = ACTIONS(8468),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [7815] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(5357),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2892),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(2892),
    [sym_argument_list] = STATE(6617),
    [sym__argument_list_with_parens] = STATE(5358),
    [sym__argument] = STATE(5359),
    [sym_splat_argument] = STATE(5359),
    [sym_hash_splat_argument] = STATE(5359),
    [sym_block_argument] = STATE(5359),
    [sym_assignment] = STATE(5357),
    [sym_operator_assignment] = STATE(5357),
    [sym_conditional] = STATE(5357),
    [sym_range] = STATE(5357),
    [sym_binary] = STATE(5357),
    [sym_unary] = STATE(5357),
    [sym_left_assignment_list] = STATE(2891),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2892),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2892),
    [sym_false] = STATE(2892),
    [sym_nil] = STATE(2892),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(5360),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(5359),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(8462),
    [sym__splat_star] = ACTIONS(8464),
    [sym__unary_minus] = ACTIONS(4843),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(8466),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(427),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4847),
    [anon_sym_yield] = ACTIONS(4849),
    [anon_sym_break] = ACTIONS(4851),
    [anon_sym_next] = ACTIONS(4853),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_in] = ACTIONS(427),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_PLUS_EQ] = ACTIONS(425),
    [anon_sym_DASH_EQ] = ACTIONS(425),
    [anon_sym_STAR_EQ] = ACTIONS(425),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(425),
    [anon_sym_SLASH_EQ] = ACTIONS(425),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(425),
    [anon_sym_PIPE_EQ] = ACTIONS(425),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(425),
    [anon_sym_AMP_EQ] = ACTIONS(425),
    [anon_sym_PERCENT_EQ] = ACTIONS(425),
    [anon_sym_GT_GT_EQ] = ACTIONS(425),
    [anon_sym_LT_LT_EQ] = ACTIONS(425),
    [anon_sym_CARET_EQ] = ACTIONS(425),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(4855),
    [anon_sym_not] = ACTIONS(4857),
    [anon_sym_BANG] = ACTIONS(4859),
    [anon_sym_TILDE] = ACTIONS(4861),
    [sym_constant] = ACTIONS(8468),
    [sym_identifier] = ACTIONS(8468),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [7816] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(9519),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(7820),
    [sym_scope_resolution] = STATE(2846),
    [sym_call] = STATE(2846),
    [sym_method_call] = STATE(7820),
    [sym_assignment] = STATE(9519),
    [sym_operator_assignment] = STATE(9519),
    [sym_conditional] = STATE(9519),
    [sym_range] = STATE(9519),
    [sym_binary] = STATE(9519),
    [sym_unary] = STATE(9519),
    [sym_left_assignment_list] = STATE(7819),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7820),
    [sym__variable] = STATE(2846),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(7820),
    [sym_false] = STATE(7820),
    [sym_nil] = STATE(7820),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(7821),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(11356),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(11358),
    [anon_sym_yield] = ACTIONS(11360),
    [anon_sym_break] = ACTIONS(11362),
    [anon_sym_next] = ACTIONS(11364),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(11366),
    [anon_sym_defined_QMARK] = ACTIONS(11368),
    [anon_sym_not] = ACTIONS(11370),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_TILDE] = ACTIONS(11372),
    [sym_constant] = ACTIONS(4793),
    [sym_identifier] = ACTIONS(4793),
    [sym_instance_variable] = ACTIONS(4795),
    [sym_class_variable] = ACTIONS(4795),
    [sym_global_variable] = ACTIONS(4795),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(4793),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4793),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [7817] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(6632),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(7820),
    [sym_scope_resolution] = STATE(2846),
    [sym_call] = STATE(2846),
    [sym_method_call] = STATE(7820),
    [sym_assignment] = STATE(6632),
    [sym_operator_assignment] = STATE(6632),
    [sym_conditional] = STATE(6632),
    [sym_range] = STATE(6632),
    [sym_binary] = STATE(6632),
    [sym_unary] = STATE(6632),
    [sym_left_assignment_list] = STATE(7819),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7820),
    [sym__variable] = STATE(2846),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(7820),
    [sym_false] = STATE(7820),
    [sym_nil] = STATE(7820),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(7821),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(11356),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(11358),
    [anon_sym_yield] = ACTIONS(11360),
    [anon_sym_break] = ACTIONS(11362),
    [anon_sym_next] = ACTIONS(11364),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(11366),
    [anon_sym_defined_QMARK] = ACTIONS(11368),
    [anon_sym_not] = ACTIONS(11370),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_TILDE] = ACTIONS(11372),
    [sym_constant] = ACTIONS(4793),
    [sym_identifier] = ACTIONS(4793),
    [sym_instance_variable] = ACTIONS(4795),
    [sym_class_variable] = ACTIONS(4795),
    [sym_global_variable] = ACTIONS(4795),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(4793),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4793),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [7818] = {
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(13178),
    [sym__binary_star] = ACTIONS(13180),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(13182),
    [anon_sym_STAR_STAR] = ACTIONS(13184),
    [anon_sym_AMP] = ACTIONS(13186),
    [anon_sym_EQ] = ACTIONS(4217),
    [anon_sym_LT] = ACTIONS(13188),
    [anon_sym_in] = ACTIONS(4211),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_PLUS_EQ] = ACTIONS(4211),
    [anon_sym_DASH_EQ] = ACTIONS(4211),
    [anon_sym_STAR_EQ] = ACTIONS(4211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4211),
    [anon_sym_SLASH_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4211),
    [anon_sym_AMP_EQ] = ACTIONS(4211),
    [anon_sym_PERCENT_EQ] = ACTIONS(4211),
    [anon_sym_GT_GT_EQ] = ACTIONS(4211),
    [anon_sym_LT_LT_EQ] = ACTIONS(4211),
    [anon_sym_CARET_EQ] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(13190),
    [anon_sym_DOT_DOT] = ACTIONS(13192),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13194),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(13196),
    [anon_sym_AMP_AMP] = ACTIONS(13196),
    [anon_sym_LT_LT] = ACTIONS(13198),
    [anon_sym_GT_GT] = ACTIONS(13198),
    [anon_sym_EQ_EQ] = ACTIONS(13196),
    [anon_sym_BANG_EQ] = ACTIONS(13200),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13200),
    [anon_sym_LT_EQ_GT] = ACTIONS(13200),
    [anon_sym_EQ_TILDE] = ACTIONS(13200),
    [anon_sym_BANG_TILDE] = ACTIONS(13200),
    [anon_sym_LT_EQ] = ACTIONS(13188),
    [anon_sym_GT] = ACTIONS(13188),
    [anon_sym_GT_EQ] = ACTIONS(13202),
    [anon_sym_CARET] = ACTIONS(13182),
    [anon_sym_PLUS] = ACTIONS(13204),
    [anon_sym_SLASH] = ACTIONS(13184),
    [anon_sym_PERCENT] = ACTIONS(13184),
    [sym_comment] = ACTIONS(87),
  },
  [7819] = {
    [anon_sym_EQ] = ACTIONS(13206),
    [sym_comment] = ACTIONS(87),
  },
  [7820] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(13208),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_in] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(13210),
    [anon_sym_DASH_EQ] = ACTIONS(13210),
    [anon_sym_STAR_EQ] = ACTIONS(13210),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13210),
    [anon_sym_SLASH_EQ] = ACTIONS(13210),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13210),
    [anon_sym_PIPE_EQ] = ACTIONS(13210),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13210),
    [anon_sym_AMP_EQ] = ACTIONS(13210),
    [anon_sym_PERCENT_EQ] = ACTIONS(13210),
    [anon_sym_GT_GT_EQ] = ACTIONS(13210),
    [anon_sym_LT_LT_EQ] = ACTIONS(13210),
    [anon_sym_CARET_EQ] = ACTIONS(13210),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [7821] = {
    [sym_string] = STATE(9532),
    [aux_sym_chained_string_repeat1] = STATE(9532),
    [sym__string_start] = ACTIONS(6455),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_in] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [7822] = {
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(13178),
    [sym__binary_star] = ACTIONS(13180),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(13182),
    [anon_sym_STAR_STAR] = ACTIONS(13184),
    [anon_sym_AMP] = ACTIONS(13186),
    [anon_sym_EQ] = ACTIONS(4249),
    [anon_sym_LT] = ACTIONS(13188),
    [anon_sym_in] = ACTIONS(4247),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_PLUS_EQ] = ACTIONS(4247),
    [anon_sym_DASH_EQ] = ACTIONS(4247),
    [anon_sym_STAR_EQ] = ACTIONS(4247),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4247),
    [anon_sym_SLASH_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4247),
    [anon_sym_AMP_EQ] = ACTIONS(4247),
    [anon_sym_PERCENT_EQ] = ACTIONS(4247),
    [anon_sym_GT_GT_EQ] = ACTIONS(4247),
    [anon_sym_LT_LT_EQ] = ACTIONS(4247),
    [anon_sym_CARET_EQ] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(13190),
    [anon_sym_DOT_DOT] = ACTIONS(13192),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13194),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(13196),
    [anon_sym_AMP_AMP] = ACTIONS(13196),
    [anon_sym_LT_LT] = ACTIONS(13198),
    [anon_sym_GT_GT] = ACTIONS(13198),
    [anon_sym_EQ_EQ] = ACTIONS(13196),
    [anon_sym_BANG_EQ] = ACTIONS(13200),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13200),
    [anon_sym_LT_EQ_GT] = ACTIONS(13200),
    [anon_sym_EQ_TILDE] = ACTIONS(13200),
    [anon_sym_BANG_TILDE] = ACTIONS(13200),
    [anon_sym_LT_EQ] = ACTIONS(13188),
    [anon_sym_GT] = ACTIONS(13188),
    [anon_sym_GT_EQ] = ACTIONS(13202),
    [anon_sym_CARET] = ACTIONS(13182),
    [anon_sym_PLUS] = ACTIONS(13204),
    [anon_sym_SLASH] = ACTIONS(13184),
    [anon_sym_PERCENT] = ACTIONS(13184),
    [sym_comment] = ACTIONS(87),
  },
  [7823] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(9533),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(7820),
    [sym_scope_resolution] = STATE(2846),
    [sym_call] = STATE(2846),
    [sym_method_call] = STATE(7820),
    [sym_assignment] = STATE(9533),
    [sym_operator_assignment] = STATE(9533),
    [sym_conditional] = STATE(9533),
    [sym_range] = STATE(9533),
    [sym_binary] = STATE(9533),
    [sym_unary] = STATE(9533),
    [sym_left_assignment_list] = STATE(7819),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7820),
    [sym__variable] = STATE(2846),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(7820),
    [sym_false] = STATE(7820),
    [sym_nil] = STATE(7820),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(7821),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(11356),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(11358),
    [anon_sym_yield] = ACTIONS(11360),
    [anon_sym_break] = ACTIONS(11362),
    [anon_sym_next] = ACTIONS(11364),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(11366),
    [anon_sym_defined_QMARK] = ACTIONS(11368),
    [anon_sym_not] = ACTIONS(11370),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_TILDE] = ACTIONS(11372),
    [sym_constant] = ACTIONS(4793),
    [sym_identifier] = ACTIONS(4793),
    [sym_instance_variable] = ACTIONS(4795),
    [sym_class_variable] = ACTIONS(4795),
    [sym_global_variable] = ACTIONS(4795),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(4793),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4793),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [7824] = {
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(13178),
    [sym__binary_star] = ACTIONS(13180),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(13182),
    [anon_sym_STAR_STAR] = ACTIONS(13184),
    [anon_sym_AMP] = ACTIONS(13186),
    [anon_sym_EQ] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(13188),
    [anon_sym_in] = ACTIONS(3281),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_PLUS_EQ] = ACTIONS(3281),
    [anon_sym_DASH_EQ] = ACTIONS(3281),
    [anon_sym_STAR_EQ] = ACTIONS(3281),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3281),
    [anon_sym_SLASH_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3281),
    [anon_sym_AMP_EQ] = ACTIONS(3281),
    [anon_sym_PERCENT_EQ] = ACTIONS(3281),
    [anon_sym_GT_GT_EQ] = ACTIONS(3281),
    [anon_sym_LT_LT_EQ] = ACTIONS(3281),
    [anon_sym_CARET_EQ] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(13190),
    [anon_sym_DOT_DOT] = ACTIONS(13192),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13194),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(13196),
    [anon_sym_AMP_AMP] = ACTIONS(13196),
    [anon_sym_LT_LT] = ACTIONS(13198),
    [anon_sym_GT_GT] = ACTIONS(13198),
    [anon_sym_EQ_EQ] = ACTIONS(13196),
    [anon_sym_BANG_EQ] = ACTIONS(13200),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13200),
    [anon_sym_LT_EQ_GT] = ACTIONS(13200),
    [anon_sym_EQ_TILDE] = ACTIONS(13200),
    [anon_sym_BANG_TILDE] = ACTIONS(13200),
    [anon_sym_LT_EQ] = ACTIONS(13188),
    [anon_sym_GT] = ACTIONS(13188),
    [anon_sym_GT_EQ] = ACTIONS(13202),
    [anon_sym_CARET] = ACTIONS(13182),
    [anon_sym_PLUS] = ACTIONS(13204),
    [anon_sym_SLASH] = ACTIONS(13184),
    [anon_sym_PERCENT] = ACTIONS(13184),
    [sym_comment] = ACTIONS(87),
  },
  [7825] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(9534),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(7820),
    [sym_scope_resolution] = STATE(2846),
    [sym_call] = STATE(2846),
    [sym_method_call] = STATE(7820),
    [sym_assignment] = STATE(9534),
    [sym_operator_assignment] = STATE(9534),
    [sym_conditional] = STATE(9534),
    [sym_range] = STATE(9534),
    [sym_binary] = STATE(9534),
    [sym_unary] = STATE(9534),
    [sym_left_assignment_list] = STATE(7819),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7820),
    [sym__variable] = STATE(2846),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(7820),
    [sym_false] = STATE(7820),
    [sym_nil] = STATE(7820),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(7821),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(11356),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(11358),
    [anon_sym_yield] = ACTIONS(11360),
    [anon_sym_break] = ACTIONS(11362),
    [anon_sym_next] = ACTIONS(11364),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(11366),
    [anon_sym_defined_QMARK] = ACTIONS(11368),
    [anon_sym_not] = ACTIONS(11370),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_TILDE] = ACTIONS(11372),
    [sym_constant] = ACTIONS(4793),
    [sym_identifier] = ACTIONS(4793),
    [sym_instance_variable] = ACTIONS(4795),
    [sym_class_variable] = ACTIONS(4795),
    [sym_global_variable] = ACTIONS(4795),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(4793),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4793),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [7826] = {
    [sym_heredoc_body] = STATE(9535),
    [aux_sym_call_repeat1] = STATE(9535),
    [sym__heredoc_body_start] = ACTIONS(6569),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_in] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [7827] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(5357),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2892),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(2892),
    [sym__argument] = STATE(6674),
    [sym_splat_argument] = STATE(6674),
    [sym_hash_splat_argument] = STATE(6674),
    [sym_block_argument] = STATE(6674),
    [sym_assignment] = STATE(5357),
    [sym_operator_assignment] = STATE(5357),
    [sym_conditional] = STATE(5357),
    [sym_range] = STATE(5357),
    [sym_binary] = STATE(5357),
    [sym_unary] = STATE(5357),
    [sym_left_assignment_list] = STATE(2891),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2892),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2892),
    [sym_false] = STATE(2892),
    [sym_nil] = STATE(2892),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(5360),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_heredoc_body] = STATE(9536),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(6674),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(8462),
    [sym__splat_star] = ACTIONS(8464),
    [sym__unary_minus] = ACTIONS(4843),
    [sym__identifier_hash_key] = ACTIONS(8466),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13212),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4847),
    [anon_sym_yield] = ACTIONS(4849),
    [anon_sym_break] = ACTIONS(4851),
    [anon_sym_next] = ACTIONS(4853),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(8484),
    [anon_sym_defined_QMARK] = ACTIONS(4855),
    [anon_sym_not] = ACTIONS(4857),
    [anon_sym_BANG] = ACTIONS(4861),
    [anon_sym_TILDE] = ACTIONS(4861),
    [sym_constant] = ACTIONS(8468),
    [sym_identifier] = ACTIONS(8468),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [7828] = {
    [sym_heredoc_body] = STATE(9537),
    [aux_sym_call_repeat1] = STATE(9537),
    [aux_sym_argument_list_repeat1] = STATE(9538),
    [sym__heredoc_body_start] = ACTIONS(6569),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(11378),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_in] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [7829] = {
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(8434),
    [sym__binary_star] = ACTIONS(8436),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(8438),
    [anon_sym_STAR_STAR] = ACTIONS(8436),
    [anon_sym_AMP] = ACTIONS(8440),
    [anon_sym_LT] = ACTIONS(8442),
    [anon_sym_in] = ACTIONS(5115),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(8444),
    [anon_sym_DOT_DOT] = ACTIONS(8446),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8448),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(8452),
    [anon_sym_AMP_AMP] = ACTIONS(8452),
    [anon_sym_LT_LT] = ACTIONS(8454),
    [anon_sym_GT_GT] = ACTIONS(8454),
    [anon_sym_EQ_EQ] = ACTIONS(8456),
    [anon_sym_BANG_EQ] = ACTIONS(8452),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8452),
    [anon_sym_LT_EQ_GT] = ACTIONS(8452),
    [anon_sym_EQ_TILDE] = ACTIONS(8452),
    [anon_sym_BANG_TILDE] = ACTIONS(8452),
    [anon_sym_LT_EQ] = ACTIONS(8442),
    [anon_sym_GT] = ACTIONS(8442),
    [anon_sym_GT_EQ] = ACTIONS(8458),
    [anon_sym_CARET] = ACTIONS(8460),
    [anon_sym_PLUS] = ACTIONS(8434),
    [anon_sym_SLASH] = ACTIONS(8436),
    [anon_sym_PERCENT] = ACTIONS(8436),
    [sym_comment] = ACTIONS(87),
  },
  [7830] = {
    [aux_sym_exceptions_repeat1] = STATE(9540),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_in] = ACTIONS(6191),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [7831] = {
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(8434),
    [sym__binary_star] = ACTIONS(8436),
    [anon_sym_LBRACE] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(8438),
    [anon_sym_STAR_STAR] = ACTIONS(8436),
    [anon_sym_AMP] = ACTIONS(8440),
    [anon_sym_LT] = ACTIONS(8442),
    [anon_sym_in] = ACTIONS(6210),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(8444),
    [anon_sym_DOT_DOT] = ACTIONS(8446),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8448),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(8452),
    [anon_sym_AMP_AMP] = ACTIONS(8452),
    [anon_sym_LT_LT] = ACTIONS(8454),
    [anon_sym_GT_GT] = ACTIONS(8454),
    [anon_sym_EQ_EQ] = ACTIONS(8456),
    [anon_sym_BANG_EQ] = ACTIONS(8452),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8452),
    [anon_sym_LT_EQ_GT] = ACTIONS(8452),
    [anon_sym_EQ_TILDE] = ACTIONS(8452),
    [anon_sym_BANG_TILDE] = ACTIONS(8452),
    [anon_sym_LT_EQ] = ACTIONS(8442),
    [anon_sym_GT] = ACTIONS(8442),
    [anon_sym_GT_EQ] = ACTIONS(8458),
    [anon_sym_CARET] = ACTIONS(8460),
    [anon_sym_PLUS] = ACTIONS(8434),
    [anon_sym_SLASH] = ACTIONS(8436),
    [anon_sym_PERCENT] = ACTIONS(8436),
    [sym_comment] = ACTIONS(87),
  },
  [7832] = {
    [sym_string] = STATE(7832),
    [aux_sym_chained_string_repeat1] = STATE(7832),
    [sym__string_start] = ACTIONS(9407),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_in] = ACTIONS(6212),
    [anon_sym_do] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [7833] = {
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(4811),
    [sym__binary_star] = ACTIONS(4813),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(4815),
    [anon_sym_STAR_STAR] = ACTIONS(4813),
    [anon_sym_AMP] = ACTIONS(4817),
    [anon_sym_LT] = ACTIONS(4819),
    [anon_sym_in] = ACTIONS(6823),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_EQ_GT] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(4821),
    [anon_sym_DOT_DOT] = ACTIONS(4823),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4825),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(4829),
    [anon_sym_AMP_AMP] = ACTIONS(4829),
    [anon_sym_LT_LT] = ACTIONS(4831),
    [anon_sym_GT_GT] = ACTIONS(4831),
    [anon_sym_EQ_EQ] = ACTIONS(4833),
    [anon_sym_BANG_EQ] = ACTIONS(4829),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4829),
    [anon_sym_LT_EQ_GT] = ACTIONS(4829),
    [anon_sym_EQ_TILDE] = ACTIONS(4829),
    [anon_sym_BANG_TILDE] = ACTIONS(4829),
    [anon_sym_LT_EQ] = ACTIONS(4819),
    [anon_sym_GT] = ACTIONS(4819),
    [anon_sym_GT_EQ] = ACTIONS(4835),
    [anon_sym_CARET] = ACTIONS(4837),
    [anon_sym_PLUS] = ACTIONS(4811),
    [anon_sym_SLASH] = ACTIONS(4813),
    [anon_sym_PERCENT] = ACTIONS(4813),
    [sym_comment] = ACTIONS(87),
  },
  [7834] = {
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(4811),
    [sym__binary_star] = ACTIONS(4813),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(4815),
    [anon_sym_STAR_STAR] = ACTIONS(4813),
    [anon_sym_AMP] = ACTIONS(4817),
    [anon_sym_LT] = ACTIONS(4819),
    [anon_sym_in] = ACTIONS(7027),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_EQ_GT] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(4821),
    [anon_sym_DOT_DOT] = ACTIONS(4823),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4825),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(4829),
    [anon_sym_AMP_AMP] = ACTIONS(4829),
    [anon_sym_LT_LT] = ACTIONS(4831),
    [anon_sym_GT_GT] = ACTIONS(4831),
    [anon_sym_EQ_EQ] = ACTIONS(4833),
    [anon_sym_BANG_EQ] = ACTIONS(4829),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4829),
    [anon_sym_LT_EQ_GT] = ACTIONS(4829),
    [anon_sym_EQ_TILDE] = ACTIONS(4829),
    [anon_sym_BANG_TILDE] = ACTIONS(4829),
    [anon_sym_LT_EQ] = ACTIONS(4819),
    [anon_sym_GT] = ACTIONS(4819),
    [anon_sym_GT_EQ] = ACTIONS(4835),
    [anon_sym_CARET] = ACTIONS(4837),
    [anon_sym_PLUS] = ACTIONS(4811),
    [anon_sym_SLASH] = ACTIONS(4813),
    [anon_sym_PERCENT] = ACTIONS(4813),
    [sym_comment] = ACTIONS(87),
  },
  [7835] = {
    [sym_heredoc_body] = STATE(7835),
    [aux_sym_call_repeat1] = STATE(7835),
    [sym__heredoc_body_start] = ACTIONS(10455),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_in] = ACTIONS(7914),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_EQ_GT] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [7836] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(2860),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1089),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(1089),
    [sym__argument] = STATE(6908),
    [sym_splat_argument] = STATE(6908),
    [sym_hash_splat_argument] = STATE(6908),
    [sym_block_argument] = STATE(6908),
    [sym_assignment] = STATE(2860),
    [sym_operator_assignment] = STATE(2860),
    [sym_conditional] = STATE(2860),
    [sym_range] = STATE(2860),
    [sym_binary] = STATE(2860),
    [sym_unary] = STATE(2860),
    [sym_left_assignment_list] = STATE(1088),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1089),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1089),
    [sym_false] = STATE(1089),
    [sym_nil] = STATE(1089),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2863),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(6908),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(4799),
    [sym__splat_star] = ACTIONS(4801),
    [sym__unary_minus] = ACTIONS(1937),
    [sym__identifier_hash_key] = ACTIONS(4803),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11382),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1943),
    [anon_sym_yield] = ACTIONS(1945),
    [anon_sym_break] = ACTIONS(1947),
    [anon_sym_next] = ACTIONS(1949),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1951),
    [anon_sym_defined_QMARK] = ACTIONS(1953),
    [anon_sym_not] = ACTIONS(1955),
    [anon_sym_BANG] = ACTIONS(1957),
    [anon_sym_TILDE] = ACTIONS(1957),
    [sym_constant] = ACTIONS(4807),
    [sym_identifier] = ACTIONS(4807),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7837] = {
    [sym_heredoc_body] = STATE(7835),
    [aux_sym_call_repeat1] = STATE(7835),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_in] = ACTIONS(7929),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_EQ_GT] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [7838] = {
    [aux_sym_argument_list_repeat1] = STATE(7838),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(13214),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_STAR_STAR] = ACTIONS(7925),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_in] = ACTIONS(7925),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_EQ_GT] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7925),
    [anon_sym_AMP_AMP] = ACTIONS(7925),
    [anon_sym_LT_LT] = ACTIONS(7925),
    [anon_sym_GT_GT] = ACTIONS(7925),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7925),
    [anon_sym_PLUS] = ACTIONS(7925),
    [anon_sym_SLASH] = ACTIONS(7925),
    [anon_sym_PERCENT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [7839] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(9541),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1089),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(1089),
    [sym_assignment] = STATE(9541),
    [sym_operator_assignment] = STATE(9541),
    [sym_conditional] = STATE(9541),
    [sym_range] = STATE(9541),
    [sym_binary] = STATE(9541),
    [sym_unary] = STATE(9541),
    [sym_left_assignment_list] = STATE(1088),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1089),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1089),
    [sym_false] = STATE(1089),
    [sym_nil] = STATE(1089),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1937),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1943),
    [anon_sym_yield] = ACTIONS(1945),
    [anon_sym_break] = ACTIONS(1947),
    [anon_sym_next] = ACTIONS(1949),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1951),
    [anon_sym_defined_QMARK] = ACTIONS(1953),
    [anon_sym_not] = ACTIONS(1955),
    [anon_sym_BANG] = ACTIONS(1957),
    [anon_sym_TILDE] = ACTIONS(1957),
    [sym_constant] = ACTIONS(1963),
    [sym_identifier] = ACTIONS(1963),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7840] = {
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(8490),
    [sym__binary_star] = ACTIONS(8492),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(8494),
    [anon_sym_STAR_STAR] = ACTIONS(8496),
    [anon_sym_AMP] = ACTIONS(8498),
    [anon_sym_EQ] = ACTIONS(7822),
    [anon_sym_LT] = ACTIONS(8500),
    [anon_sym_in] = ACTIONS(6823),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_EQ_GT] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_PLUS_EQ] = ACTIONS(6823),
    [anon_sym_DASH_EQ] = ACTIONS(6823),
    [anon_sym_STAR_EQ] = ACTIONS(6823),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6823),
    [anon_sym_SLASH_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6823),
    [anon_sym_AMP_EQ] = ACTIONS(6823),
    [anon_sym_PERCENT_EQ] = ACTIONS(6823),
    [anon_sym_GT_GT_EQ] = ACTIONS(6823),
    [anon_sym_LT_LT_EQ] = ACTIONS(6823),
    [anon_sym_CARET_EQ] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(8502),
    [anon_sym_DOT_DOT] = ACTIONS(8504),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8506),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(8508),
    [anon_sym_AMP_AMP] = ACTIONS(8508),
    [anon_sym_LT_LT] = ACTIONS(8510),
    [anon_sym_GT_GT] = ACTIONS(8510),
    [anon_sym_EQ_EQ] = ACTIONS(8508),
    [anon_sym_BANG_EQ] = ACTIONS(8512),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8512),
    [anon_sym_LT_EQ_GT] = ACTIONS(8512),
    [anon_sym_EQ_TILDE] = ACTIONS(8512),
    [anon_sym_BANG_TILDE] = ACTIONS(8512),
    [anon_sym_LT_EQ] = ACTIONS(8500),
    [anon_sym_GT] = ACTIONS(8500),
    [anon_sym_GT_EQ] = ACTIONS(8514),
    [anon_sym_CARET] = ACTIONS(8494),
    [anon_sym_PLUS] = ACTIONS(8516),
    [anon_sym_SLASH] = ACTIONS(8496),
    [anon_sym_PERCENT] = ACTIONS(8496),
    [sym_comment] = ACTIONS(87),
  },
  [7841] = {
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(8490),
    [sym__binary_star] = ACTIONS(8492),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(8494),
    [anon_sym_STAR_STAR] = ACTIONS(8496),
    [anon_sym_AMP] = ACTIONS(8498),
    [anon_sym_EQ] = ACTIONS(7884),
    [anon_sym_LT] = ACTIONS(8500),
    [anon_sym_in] = ACTIONS(7027),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_EQ_GT] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_PLUS_EQ] = ACTIONS(7027),
    [anon_sym_DASH_EQ] = ACTIONS(7027),
    [anon_sym_STAR_EQ] = ACTIONS(7027),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7027),
    [anon_sym_SLASH_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7027),
    [anon_sym_AMP_EQ] = ACTIONS(7027),
    [anon_sym_PERCENT_EQ] = ACTIONS(7027),
    [anon_sym_GT_GT_EQ] = ACTIONS(7027),
    [anon_sym_LT_LT_EQ] = ACTIONS(7027),
    [anon_sym_CARET_EQ] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(8502),
    [anon_sym_DOT_DOT] = ACTIONS(8504),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8506),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(8508),
    [anon_sym_AMP_AMP] = ACTIONS(8508),
    [anon_sym_LT_LT] = ACTIONS(8510),
    [anon_sym_GT_GT] = ACTIONS(8510),
    [anon_sym_EQ_EQ] = ACTIONS(8508),
    [anon_sym_BANG_EQ] = ACTIONS(8512),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8512),
    [anon_sym_LT_EQ_GT] = ACTIONS(8512),
    [anon_sym_EQ_TILDE] = ACTIONS(8512),
    [anon_sym_BANG_TILDE] = ACTIONS(8512),
    [anon_sym_LT_EQ] = ACTIONS(8500),
    [anon_sym_GT] = ACTIONS(8500),
    [anon_sym_GT_EQ] = ACTIONS(8514),
    [anon_sym_CARET] = ACTIONS(8494),
    [anon_sym_PLUS] = ACTIONS(8516),
    [anon_sym_SLASH] = ACTIONS(8496),
    [anon_sym_PERCENT] = ACTIONS(8496),
    [sym_comment] = ACTIONS(87),
  },
  [7842] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(8492),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(8496),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_in] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(8496),
    [anon_sym_PERCENT] = ACTIONS(8496),
    [sym_comment] = ACTIONS(87),
  },
  [7843] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(8496),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_in] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(5827),
    [anon_sym_PERCENT] = ACTIONS(5827),
    [sym_comment] = ACTIONS(87),
  },
  [7844] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8490),
    [sym__binary_star] = ACTIONS(8492),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(8496),
    [anon_sym_AMP] = ACTIONS(8498),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_in] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(8510),
    [anon_sym_GT_GT] = ACTIONS(8510),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(8516),
    [anon_sym_SLASH] = ACTIONS(8496),
    [anon_sym_PERCENT] = ACTIONS(8496),
    [sym_comment] = ACTIONS(87),
  },
  [7845] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8490),
    [sym__binary_star] = ACTIONS(8492),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(8496),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_in] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(8510),
    [anon_sym_GT_GT] = ACTIONS(8510),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(8516),
    [anon_sym_SLASH] = ACTIONS(8496),
    [anon_sym_PERCENT] = ACTIONS(8496),
    [sym_comment] = ACTIONS(87),
  },
  [7846] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8490),
    [sym__binary_star] = ACTIONS(8492),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(8494),
    [anon_sym_STAR_STAR] = ACTIONS(8496),
    [anon_sym_AMP] = ACTIONS(8498),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_in] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(8510),
    [anon_sym_GT_GT] = ACTIONS(8510),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(8494),
    [anon_sym_PLUS] = ACTIONS(8516),
    [anon_sym_SLASH] = ACTIONS(8496),
    [anon_sym_PERCENT] = ACTIONS(8496),
    [sym_comment] = ACTIONS(87),
  },
  [7847] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(13217),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [7848] = {
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(8490),
    [sym__binary_star] = ACTIONS(8492),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(8494),
    [anon_sym_STAR_STAR] = ACTIONS(8496),
    [anon_sym_AMP] = ACTIONS(8498),
    [anon_sym_EQ] = ACTIONS(7888),
    [anon_sym_LT] = ACTIONS(8500),
    [anon_sym_in] = ACTIONS(5927),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_EQ_GT] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_PLUS_EQ] = ACTIONS(5927),
    [anon_sym_DASH_EQ] = ACTIONS(5927),
    [anon_sym_STAR_EQ] = ACTIONS(5927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5927),
    [anon_sym_SLASH_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5927),
    [anon_sym_AMP_EQ] = ACTIONS(5927),
    [anon_sym_PERCENT_EQ] = ACTIONS(5927),
    [anon_sym_GT_GT_EQ] = ACTIONS(5927),
    [anon_sym_LT_LT_EQ] = ACTIONS(5927),
    [anon_sym_CARET_EQ] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(8504),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8506),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(8508),
    [anon_sym_AMP_AMP] = ACTIONS(8508),
    [anon_sym_LT_LT] = ACTIONS(8510),
    [anon_sym_GT_GT] = ACTIONS(8510),
    [anon_sym_EQ_EQ] = ACTIONS(8508),
    [anon_sym_BANG_EQ] = ACTIONS(8512),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8512),
    [anon_sym_LT_EQ_GT] = ACTIONS(8512),
    [anon_sym_EQ_TILDE] = ACTIONS(8512),
    [anon_sym_BANG_TILDE] = ACTIONS(8512),
    [anon_sym_LT_EQ] = ACTIONS(8500),
    [anon_sym_GT] = ACTIONS(8500),
    [anon_sym_GT_EQ] = ACTIONS(8514),
    [anon_sym_CARET] = ACTIONS(8494),
    [anon_sym_PLUS] = ACTIONS(8516),
    [anon_sym_SLASH] = ACTIONS(8496),
    [anon_sym_PERCENT] = ACTIONS(8496),
    [sym_comment] = ACTIONS(87),
  },
  [7849] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8490),
    [sym__binary_star] = ACTIONS(8492),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(8494),
    [anon_sym_STAR_STAR] = ACTIONS(8496),
    [anon_sym_AMP] = ACTIONS(8498),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(8500),
    [anon_sym_in] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(8502),
    [anon_sym_DOT_DOT] = ACTIONS(8504),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8506),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(8508),
    [anon_sym_AMP_AMP] = ACTIONS(8508),
    [anon_sym_LT_LT] = ACTIONS(8510),
    [anon_sym_GT_GT] = ACTIONS(8510),
    [anon_sym_EQ_EQ] = ACTIONS(8508),
    [anon_sym_BANG_EQ] = ACTIONS(8512),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8512),
    [anon_sym_LT_EQ_GT] = ACTIONS(8512),
    [anon_sym_EQ_TILDE] = ACTIONS(8512),
    [anon_sym_BANG_TILDE] = ACTIONS(8512),
    [anon_sym_LT_EQ] = ACTIONS(8500),
    [anon_sym_GT] = ACTIONS(8500),
    [anon_sym_GT_EQ] = ACTIONS(8514),
    [anon_sym_CARET] = ACTIONS(8494),
    [anon_sym_PLUS] = ACTIONS(8516),
    [anon_sym_SLASH] = ACTIONS(8496),
    [anon_sym_PERCENT] = ACTIONS(8496),
    [sym_comment] = ACTIONS(87),
  },
  [7850] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8490),
    [sym__binary_star] = ACTIONS(8492),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(8494),
    [anon_sym_STAR_STAR] = ACTIONS(8496),
    [anon_sym_AMP] = ACTIONS(8498),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(8500),
    [anon_sym_in] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(8510),
    [anon_sym_GT_GT] = ACTIONS(8510),
    [anon_sym_EQ_EQ] = ACTIONS(8508),
    [anon_sym_BANG_EQ] = ACTIONS(8512),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8512),
    [anon_sym_LT_EQ_GT] = ACTIONS(8512),
    [anon_sym_EQ_TILDE] = ACTIONS(8512),
    [anon_sym_BANG_TILDE] = ACTIONS(8512),
    [anon_sym_LT_EQ] = ACTIONS(8500),
    [anon_sym_GT] = ACTIONS(8500),
    [anon_sym_GT_EQ] = ACTIONS(8514),
    [anon_sym_CARET] = ACTIONS(8494),
    [anon_sym_PLUS] = ACTIONS(8516),
    [anon_sym_SLASH] = ACTIONS(8496),
    [anon_sym_PERCENT] = ACTIONS(8496),
    [sym_comment] = ACTIONS(87),
  },
  [7851] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8490),
    [sym__binary_star] = ACTIONS(8492),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(8496),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_in] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(8516),
    [anon_sym_SLASH] = ACTIONS(8496),
    [anon_sym_PERCENT] = ACTIONS(8496),
    [sym_comment] = ACTIONS(87),
  },
  [7852] = {
    [sym_heredoc_body] = STATE(7852),
    [aux_sym_call_repeat1] = STATE(7852),
    [sym__heredoc_body_start] = ACTIONS(10553),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_STAR_STAR] = ACTIONS(7919),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_EQ] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_in] = ACTIONS(7914),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_EQ_GT] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_PLUS_EQ] = ACTIONS(7914),
    [anon_sym_DASH_EQ] = ACTIONS(7914),
    [anon_sym_STAR_EQ] = ACTIONS(7914),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7914),
    [anon_sym_SLASH_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7914),
    [anon_sym_AMP_EQ] = ACTIONS(7914),
    [anon_sym_PERCENT_EQ] = ACTIONS(7914),
    [anon_sym_GT_GT_EQ] = ACTIONS(7914),
    [anon_sym_LT_LT_EQ] = ACTIONS(7914),
    [anon_sym_CARET_EQ] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7919),
    [anon_sym_AMP_AMP] = ACTIONS(7919),
    [anon_sym_LT_LT] = ACTIONS(7919),
    [anon_sym_GT_GT] = ACTIONS(7919),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7919),
    [anon_sym_PLUS] = ACTIONS(7919),
    [anon_sym_SLASH] = ACTIONS(7919),
    [anon_sym_PERCENT] = ACTIONS(7919),
    [sym_comment] = ACTIONS(87),
  },
  [7853] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(2888),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2892),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(2892),
    [sym__argument] = STATE(6970),
    [sym_splat_argument] = STATE(6970),
    [sym_hash_splat_argument] = STATE(6970),
    [sym_block_argument] = STATE(6970),
    [sym_assignment] = STATE(2888),
    [sym_operator_assignment] = STATE(2888),
    [sym_conditional] = STATE(2888),
    [sym_range] = STATE(2888),
    [sym_binary] = STATE(2888),
    [sym_unary] = STATE(2888),
    [sym_left_assignment_list] = STATE(2891),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2892),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2892),
    [sym_false] = STATE(2892),
    [sym_nil] = STATE(2892),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(2893),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(6970),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(4839),
    [sym__splat_star] = ACTIONS(4841),
    [sym__unary_minus] = ACTIONS(4843),
    [sym__identifier_hash_key] = ACTIONS(4845),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11386),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4847),
    [anon_sym_yield] = ACTIONS(4849),
    [anon_sym_break] = ACTIONS(4851),
    [anon_sym_next] = ACTIONS(4853),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(8484),
    [anon_sym_defined_QMARK] = ACTIONS(4855),
    [anon_sym_not] = ACTIONS(4857),
    [anon_sym_BANG] = ACTIONS(4861),
    [anon_sym_TILDE] = ACTIONS(4861),
    [sym_constant] = ACTIONS(4863),
    [sym_identifier] = ACTIONS(4863),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [7854] = {
    [sym_heredoc_body] = STATE(7852),
    [aux_sym_call_repeat1] = STATE(7852),
    [sym__heredoc_body_start] = ACTIONS(3543),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_STAR_STAR] = ACTIONS(7931),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_EQ] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_in] = ACTIONS(7929),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_EQ_GT] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_PLUS_EQ] = ACTIONS(7929),
    [anon_sym_DASH_EQ] = ACTIONS(7929),
    [anon_sym_STAR_EQ] = ACTIONS(7929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7929),
    [anon_sym_SLASH_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7929),
    [anon_sym_AMP_EQ] = ACTIONS(7929),
    [anon_sym_PERCENT_EQ] = ACTIONS(7929),
    [anon_sym_GT_GT_EQ] = ACTIONS(7929),
    [anon_sym_LT_LT_EQ] = ACTIONS(7929),
    [anon_sym_CARET_EQ] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7931),
    [anon_sym_AMP_AMP] = ACTIONS(7931),
    [anon_sym_LT_LT] = ACTIONS(7931),
    [anon_sym_GT_GT] = ACTIONS(7931),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7931),
    [anon_sym_PLUS] = ACTIONS(7931),
    [anon_sym_SLASH] = ACTIONS(7931),
    [anon_sym_PERCENT] = ACTIONS(7931),
    [sym_comment] = ACTIONS(87),
  },
  [7855] = {
    [aux_sym_argument_list_repeat1] = STATE(7855),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(13219),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_STAR_STAR] = ACTIONS(7927),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_EQ] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_in] = ACTIONS(7925),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_EQ_GT] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_PLUS_EQ] = ACTIONS(7925),
    [anon_sym_DASH_EQ] = ACTIONS(7925),
    [anon_sym_STAR_EQ] = ACTIONS(7925),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7925),
    [anon_sym_SLASH_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7925),
    [anon_sym_AMP_EQ] = ACTIONS(7925),
    [anon_sym_PERCENT_EQ] = ACTIONS(7925),
    [anon_sym_GT_GT_EQ] = ACTIONS(7925),
    [anon_sym_LT_LT_EQ] = ACTIONS(7925),
    [anon_sym_CARET_EQ] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7927),
    [anon_sym_AMP_AMP] = ACTIONS(7927),
    [anon_sym_LT_LT] = ACTIONS(7927),
    [anon_sym_GT_GT] = ACTIONS(7927),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7927),
    [anon_sym_PLUS] = ACTIONS(7927),
    [anon_sym_SLASH] = ACTIONS(7927),
    [anon_sym_PERCENT] = ACTIONS(7927),
    [sym_comment] = ACTIONS(87),
  },
  [7856] = {
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(8490),
    [sym__binary_star] = ACTIONS(8492),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(8494),
    [anon_sym_STAR_STAR] = ACTIONS(8496),
    [anon_sym_AMP] = ACTIONS(8498),
    [anon_sym_EQ] = ACTIONS(7936),
    [anon_sym_LT] = ACTIONS(8500),
    [anon_sym_in] = ACTIONS(5115),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_EQ_GT] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_PLUS_EQ] = ACTIONS(5115),
    [anon_sym_DASH_EQ] = ACTIONS(5115),
    [anon_sym_STAR_EQ] = ACTIONS(5115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5115),
    [anon_sym_SLASH_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5115),
    [anon_sym_AMP_EQ] = ACTIONS(5115),
    [anon_sym_PERCENT_EQ] = ACTIONS(5115),
    [anon_sym_GT_GT_EQ] = ACTIONS(5115),
    [anon_sym_LT_LT_EQ] = ACTIONS(5115),
    [anon_sym_CARET_EQ] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(8502),
    [anon_sym_DOT_DOT] = ACTIONS(8504),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8506),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(8508),
    [anon_sym_AMP_AMP] = ACTIONS(8508),
    [anon_sym_LT_LT] = ACTIONS(8510),
    [anon_sym_GT_GT] = ACTIONS(8510),
    [anon_sym_EQ_EQ] = ACTIONS(8508),
    [anon_sym_BANG_EQ] = ACTIONS(8512),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8512),
    [anon_sym_LT_EQ_GT] = ACTIONS(8512),
    [anon_sym_EQ_TILDE] = ACTIONS(8512),
    [anon_sym_BANG_TILDE] = ACTIONS(8512),
    [anon_sym_LT_EQ] = ACTIONS(8500),
    [anon_sym_GT] = ACTIONS(8500),
    [anon_sym_GT_EQ] = ACTIONS(8514),
    [anon_sym_CARET] = ACTIONS(8494),
    [anon_sym_PLUS] = ACTIONS(8516),
    [anon_sym_SLASH] = ACTIONS(8496),
    [anon_sym_PERCENT] = ACTIONS(8496),
    [sym_comment] = ACTIONS(87),
  },
  [7857] = {
    [aux_sym_exceptions_repeat1] = STATE(9544),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_STAR_STAR] = ACTIONS(6193),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_in] = ACTIONS(6191),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_PLUS_EQ] = ACTIONS(6191),
    [anon_sym_DASH_EQ] = ACTIONS(6191),
    [anon_sym_STAR_EQ] = ACTIONS(6191),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6191),
    [anon_sym_SLASH_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6191),
    [anon_sym_AMP_EQ] = ACTIONS(6191),
    [anon_sym_PERCENT_EQ] = ACTIONS(6191),
    [anon_sym_GT_GT_EQ] = ACTIONS(6191),
    [anon_sym_LT_LT_EQ] = ACTIONS(6191),
    [anon_sym_CARET_EQ] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6193),
    [anon_sym_AMP_AMP] = ACTIONS(6193),
    [anon_sym_LT_LT] = ACTIONS(6193),
    [anon_sym_GT_GT] = ACTIONS(6193),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6193),
    [anon_sym_PLUS] = ACTIONS(6193),
    [anon_sym_SLASH] = ACTIONS(6193),
    [anon_sym_PERCENT] = ACTIONS(6193),
    [sym_comment] = ACTIONS(87),
  },
  [7858] = {
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(8490),
    [sym__binary_star] = ACTIONS(8492),
    [anon_sym_LBRACE] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(8494),
    [anon_sym_STAR_STAR] = ACTIONS(8496),
    [anon_sym_AMP] = ACTIONS(8498),
    [anon_sym_EQ] = ACTIONS(7938),
    [anon_sym_LT] = ACTIONS(8500),
    [anon_sym_in] = ACTIONS(6210),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_EQ_GT] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_PLUS_EQ] = ACTIONS(6210),
    [anon_sym_DASH_EQ] = ACTIONS(6210),
    [anon_sym_STAR_EQ] = ACTIONS(6210),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6210),
    [anon_sym_SLASH_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6210),
    [anon_sym_AMP_EQ] = ACTIONS(6210),
    [anon_sym_PERCENT_EQ] = ACTIONS(6210),
    [anon_sym_GT_GT_EQ] = ACTIONS(6210),
    [anon_sym_LT_LT_EQ] = ACTIONS(6210),
    [anon_sym_CARET_EQ] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(8502),
    [anon_sym_DOT_DOT] = ACTIONS(8504),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8506),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(8508),
    [anon_sym_AMP_AMP] = ACTIONS(8508),
    [anon_sym_LT_LT] = ACTIONS(8510),
    [anon_sym_GT_GT] = ACTIONS(8510),
    [anon_sym_EQ_EQ] = ACTIONS(8508),
    [anon_sym_BANG_EQ] = ACTIONS(8512),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8512),
    [anon_sym_LT_EQ_GT] = ACTIONS(8512),
    [anon_sym_EQ_TILDE] = ACTIONS(8512),
    [anon_sym_BANG_TILDE] = ACTIONS(8512),
    [anon_sym_LT_EQ] = ACTIONS(8500),
    [anon_sym_GT] = ACTIONS(8500),
    [anon_sym_GT_EQ] = ACTIONS(8514),
    [anon_sym_CARET] = ACTIONS(8494),
    [anon_sym_PLUS] = ACTIONS(8516),
    [anon_sym_SLASH] = ACTIONS(8496),
    [anon_sym_PERCENT] = ACTIONS(8496),
    [sym_comment] = ACTIONS(87),
  },
  [7859] = {
    [sym_string] = STATE(7859),
    [aux_sym_chained_string_repeat1] = STATE(7859),
    [sym__string_start] = ACTIONS(10559),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_STAR_STAR] = ACTIONS(6217),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_EQ] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_in] = ACTIONS(6212),
    [anon_sym_do] = ACTIONS(6212),
    [anon_sym_EQ_GT] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_PLUS_EQ] = ACTIONS(6212),
    [anon_sym_DASH_EQ] = ACTIONS(6212),
    [anon_sym_STAR_EQ] = ACTIONS(6212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6212),
    [anon_sym_SLASH_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6212),
    [anon_sym_AMP_EQ] = ACTIONS(6212),
    [anon_sym_PERCENT_EQ] = ACTIONS(6212),
    [anon_sym_GT_GT_EQ] = ACTIONS(6212),
    [anon_sym_LT_LT_EQ] = ACTIONS(6212),
    [anon_sym_CARET_EQ] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6217),
    [anon_sym_AMP_AMP] = ACTIONS(6217),
    [anon_sym_LT_LT] = ACTIONS(6217),
    [anon_sym_GT_GT] = ACTIONS(6217),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6217),
    [anon_sym_PLUS] = ACTIONS(6217),
    [anon_sym_SLASH] = ACTIONS(6217),
    [anon_sym_PERCENT] = ACTIONS(6217),
    [sym_comment] = ACTIONS(87),
  },
  [7860] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(5412),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1089),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(1089),
    [sym_splat_argument] = STATE(9013),
    [sym_assignment] = STATE(5412),
    [sym_operator_assignment] = STATE(5412),
    [sym_conditional] = STATE(5412),
    [sym_range] = STATE(5412),
    [sym_binary] = STATE(5412),
    [sym_unary] = STATE(5412),
    [sym__arg_or_splat_arg] = STATE(9013),
    [sym_left_assignment_list] = STATE(1088),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1089),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1089),
    [sym_false] = STATE(1089),
    [sym_nil] = STATE(1089),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(4801),
    [sym__unary_minus] = ACTIONS(1937),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1943),
    [anon_sym_yield] = ACTIONS(1945),
    [anon_sym_break] = ACTIONS(1947),
    [anon_sym_next] = ACTIONS(1949),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1951),
    [anon_sym_defined_QMARK] = ACTIONS(1953),
    [anon_sym_not] = ACTIONS(1955),
    [anon_sym_BANG] = ACTIONS(1957),
    [anon_sym_TILDE] = ACTIONS(1957),
    [sym_constant] = ACTIONS(1963),
    [sym_identifier] = ACTIONS(1963),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7861] = {
    [aux_sym_exceptions_repeat1] = STATE(9545),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_LBRACE] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(13222),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_in] = ACTIONS(9855),
    [anon_sym_do] = ACTIONS(9855),
    [anon_sym_EQ_GT] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [7862] = {
    [sym__line_break] = ACTIONS(13224),
    [sym__heredoc_body_start] = ACTIONS(13224),
    [sym__binary_minus] = ACTIONS(13224),
    [sym__binary_star] = ACTIONS(13224),
    [ts_builtin_sym_end] = ACTIONS(13224),
    [anon_sym___END__] = ACTIONS(13224),
    [anon_sym_LBRACE] = ACTIONS(13224),
    [anon_sym_RBRACE] = ACTIONS(13224),
    [anon_sym_RPAREN] = ACTIONS(13224),
    [anon_sym_DOT] = ACTIONS(13226),
    [anon_sym_COMMA] = ACTIONS(13224),
    [anon_sym_PIPE] = ACTIONS(13226),
    [anon_sym_SEMI] = ACTIONS(13224),
    [anon_sym_STAR_STAR] = ACTIONS(13224),
    [anon_sym_AMP] = ACTIONS(13226),
    [anon_sym_LT] = ACTIONS(13226),
    [anon_sym_end] = ACTIONS(13224),
    [anon_sym_if] = ACTIONS(13224),
    [anon_sym_unless] = ACTIONS(13224),
    [anon_sym_while] = ACTIONS(13224),
    [anon_sym_until] = ACTIONS(13224),
    [anon_sym_rescue] = ACTIONS(13224),
    [anon_sym_do] = ACTIONS(13224),
    [anon_sym_when] = ACTIONS(13224),
    [anon_sym_elsif] = ACTIONS(13224),
    [anon_sym_else] = ACTIONS(13224),
    [anon_sym_then] = ACTIONS(13224),
    [anon_sym_ensure] = ACTIONS(13224),
    [anon_sym_EQ_GT] = ACTIONS(13224),
    [anon_sym_LBRACK] = ACTIONS(13224),
    [anon_sym_COLON_COLON2] = ACTIONS(13224),
    [anon_sym_AMP_DOT] = ACTIONS(13224),
    [anon_sym_QMARK] = ACTIONS(13224),
    [anon_sym_DOT_DOT] = ACTIONS(13226),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13224),
    [anon_sym_and] = ACTIONS(13224),
    [anon_sym_or] = ACTIONS(13224),
    [anon_sym_PIPE_PIPE] = ACTIONS(13224),
    [anon_sym_AMP_AMP] = ACTIONS(13224),
    [anon_sym_LT_LT] = ACTIONS(13224),
    [anon_sym_GT_GT] = ACTIONS(13224),
    [anon_sym_EQ_EQ] = ACTIONS(13226),
    [anon_sym_BANG_EQ] = ACTIONS(13224),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13224),
    [anon_sym_LT_EQ_GT] = ACTIONS(13224),
    [anon_sym_EQ_TILDE] = ACTIONS(13224),
    [anon_sym_BANG_TILDE] = ACTIONS(13224),
    [anon_sym_LT_EQ] = ACTIONS(13226),
    [anon_sym_GT] = ACTIONS(13226),
    [anon_sym_GT_EQ] = ACTIONS(13224),
    [anon_sym_CARET] = ACTIONS(13224),
    [anon_sym_PLUS] = ACTIONS(13224),
    [anon_sym_SLASH] = ACTIONS(13224),
    [anon_sym_PERCENT] = ACTIONS(13224),
    [sym_comment] = ACTIONS(87),
  },
  [7863] = {
    [sym_heredoc_body] = STATE(9546),
    [aux_sym_call_repeat1] = STATE(9546),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [7864] = {
    [sym_heredoc_body] = STATE(9547),
    [aux_sym_call_repeat1] = STATE(9547),
    [aux_sym_argument_list_repeat1] = STATE(5459),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4939),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [7865] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(8539),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8539),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(8539),
    [anon_sym_PERCENT] = ACTIONS(8539),
    [sym_comment] = ACTIONS(87),
  },
  [7866] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8539),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [7867] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8537),
    [sym__binary_star] = ACTIONS(8539),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8539),
    [anon_sym_AMP] = ACTIONS(8543),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(8555),
    [anon_sym_GT_GT] = ACTIONS(8555),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(8537),
    [anon_sym_SLASH] = ACTIONS(8539),
    [anon_sym_PERCENT] = ACTIONS(8539),
    [sym_comment] = ACTIONS(87),
  },
  [7868] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8537),
    [sym__binary_star] = ACTIONS(8539),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8539),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(8555),
    [anon_sym_GT_GT] = ACTIONS(8555),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(8537),
    [anon_sym_SLASH] = ACTIONS(8539),
    [anon_sym_PERCENT] = ACTIONS(8539),
    [sym_comment] = ACTIONS(87),
  },
  [7869] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8537),
    [sym__binary_star] = ACTIONS(8539),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(8541),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8539),
    [anon_sym_AMP] = ACTIONS(8543),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(8555),
    [anon_sym_GT_GT] = ACTIONS(8555),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(8561),
    [anon_sym_PLUS] = ACTIONS(8537),
    [anon_sym_SLASH] = ACTIONS(8539),
    [anon_sym_PERCENT] = ACTIONS(8539),
    [sym_comment] = ACTIONS(87),
  },
  [7870] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(13228),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [7871] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(8537),
    [sym__binary_star] = ACTIONS(8539),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(8541),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(8539),
    [anon_sym_AMP] = ACTIONS(8543),
    [anon_sym_LT] = ACTIONS(8545),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(8549),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8551),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(8553),
    [anon_sym_AMP_AMP] = ACTIONS(8553),
    [anon_sym_LT_LT] = ACTIONS(8555),
    [anon_sym_GT_GT] = ACTIONS(8555),
    [anon_sym_EQ_EQ] = ACTIONS(8557),
    [anon_sym_BANG_EQ] = ACTIONS(8553),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8553),
    [anon_sym_LT_EQ_GT] = ACTIONS(8553),
    [anon_sym_EQ_TILDE] = ACTIONS(8553),
    [anon_sym_BANG_TILDE] = ACTIONS(8553),
    [anon_sym_LT_EQ] = ACTIONS(8545),
    [anon_sym_GT] = ACTIONS(8545),
    [anon_sym_GT_EQ] = ACTIONS(8559),
    [anon_sym_CARET] = ACTIONS(8561),
    [anon_sym_PLUS] = ACTIONS(8537),
    [anon_sym_SLASH] = ACTIONS(8539),
    [anon_sym_PERCENT] = ACTIONS(8539),
    [sym_comment] = ACTIONS(87),
  },
  [7872] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8537),
    [sym__binary_star] = ACTIONS(8539),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(8541),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8539),
    [anon_sym_AMP] = ACTIONS(8543),
    [anon_sym_LT] = ACTIONS(8545),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(8547),
    [anon_sym_DOT_DOT] = ACTIONS(8549),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8551),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(8553),
    [anon_sym_AMP_AMP] = ACTIONS(8553),
    [anon_sym_LT_LT] = ACTIONS(8555),
    [anon_sym_GT_GT] = ACTIONS(8555),
    [anon_sym_EQ_EQ] = ACTIONS(8557),
    [anon_sym_BANG_EQ] = ACTIONS(8553),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8553),
    [anon_sym_LT_EQ_GT] = ACTIONS(8553),
    [anon_sym_EQ_TILDE] = ACTIONS(8553),
    [anon_sym_BANG_TILDE] = ACTIONS(8553),
    [anon_sym_LT_EQ] = ACTIONS(8545),
    [anon_sym_GT] = ACTIONS(8545),
    [anon_sym_GT_EQ] = ACTIONS(8559),
    [anon_sym_CARET] = ACTIONS(8561),
    [anon_sym_PLUS] = ACTIONS(8537),
    [anon_sym_SLASH] = ACTIONS(8539),
    [anon_sym_PERCENT] = ACTIONS(8539),
    [sym_comment] = ACTIONS(87),
  },
  [7873] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8537),
    [sym__binary_star] = ACTIONS(8539),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(8541),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8539),
    [anon_sym_AMP] = ACTIONS(8543),
    [anon_sym_LT] = ACTIONS(8545),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(8555),
    [anon_sym_GT_GT] = ACTIONS(8555),
    [anon_sym_EQ_EQ] = ACTIONS(8557),
    [anon_sym_BANG_EQ] = ACTIONS(8553),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8553),
    [anon_sym_LT_EQ_GT] = ACTIONS(8553),
    [anon_sym_EQ_TILDE] = ACTIONS(8553),
    [anon_sym_BANG_TILDE] = ACTIONS(8553),
    [anon_sym_LT_EQ] = ACTIONS(8545),
    [anon_sym_GT] = ACTIONS(8545),
    [anon_sym_GT_EQ] = ACTIONS(8559),
    [anon_sym_CARET] = ACTIONS(8561),
    [anon_sym_PLUS] = ACTIONS(8537),
    [anon_sym_SLASH] = ACTIONS(8539),
    [anon_sym_PERCENT] = ACTIONS(8539),
    [sym_comment] = ACTIONS(87),
  },
  [7874] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8537),
    [sym__binary_star] = ACTIONS(8539),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8539),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(8537),
    [anon_sym_SLASH] = ACTIONS(8539),
    [anon_sym_PERCENT] = ACTIONS(8539),
    [sym_comment] = ACTIONS(87),
  },
  [7875] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(8537),
    [sym__binary_star] = ACTIONS(8539),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(8541),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(8539),
    [anon_sym_AMP] = ACTIONS(8543),
    [anon_sym_LT] = ACTIONS(8545),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(8547),
    [anon_sym_DOT_DOT] = ACTIONS(8549),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8551),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(8553),
    [anon_sym_AMP_AMP] = ACTIONS(8553),
    [anon_sym_LT_LT] = ACTIONS(8555),
    [anon_sym_GT_GT] = ACTIONS(8555),
    [anon_sym_EQ_EQ] = ACTIONS(8557),
    [anon_sym_BANG_EQ] = ACTIONS(8553),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8553),
    [anon_sym_LT_EQ_GT] = ACTIONS(8553),
    [anon_sym_EQ_TILDE] = ACTIONS(8553),
    [anon_sym_BANG_TILDE] = ACTIONS(8553),
    [anon_sym_LT_EQ] = ACTIONS(8545),
    [anon_sym_GT] = ACTIONS(8545),
    [anon_sym_GT_EQ] = ACTIONS(8559),
    [anon_sym_CARET] = ACTIONS(8561),
    [anon_sym_PLUS] = ACTIONS(8537),
    [anon_sym_SLASH] = ACTIONS(8539),
    [anon_sym_PERCENT] = ACTIONS(8539),
    [sym_comment] = ACTIONS(87),
  },
  [7876] = {
    [aux_sym_exceptions_repeat1] = STATE(9550),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [7877] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(8537),
    [sym__binary_star] = ACTIONS(8539),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(8541),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(8539),
    [anon_sym_AMP] = ACTIONS(8543),
    [anon_sym_LT] = ACTIONS(8545),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(8547),
    [anon_sym_DOT_DOT] = ACTIONS(8549),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8551),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(8553),
    [anon_sym_AMP_AMP] = ACTIONS(8553),
    [anon_sym_LT_LT] = ACTIONS(8555),
    [anon_sym_GT_GT] = ACTIONS(8555),
    [anon_sym_EQ_EQ] = ACTIONS(8557),
    [anon_sym_BANG_EQ] = ACTIONS(8553),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8553),
    [anon_sym_LT_EQ_GT] = ACTIONS(8553),
    [anon_sym_EQ_TILDE] = ACTIONS(8553),
    [anon_sym_BANG_TILDE] = ACTIONS(8553),
    [anon_sym_LT_EQ] = ACTIONS(8545),
    [anon_sym_GT] = ACTIONS(8545),
    [anon_sym_GT_EQ] = ACTIONS(8559),
    [anon_sym_CARET] = ACTIONS(8561),
    [anon_sym_PLUS] = ACTIONS(8537),
    [anon_sym_SLASH] = ACTIONS(8539),
    [anon_sym_PERCENT] = ACTIONS(8539),
    [sym_comment] = ACTIONS(87),
  },
  [7878] = {
    [sym_string] = STATE(7878),
    [aux_sym_chained_string_repeat1] = STATE(7878),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(6214),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [7879] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(4913),
    [sym__binary_star] = ACTIONS(4915),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(4917),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(4915),
    [anon_sym_AMP] = ACTIONS(4919),
    [anon_sym_LT] = ACTIONS(4921),
    [anon_sym_EQ_GT] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_DOT_DOT] = ACTIONS(4925),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4927),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(4929),
    [anon_sym_AMP_AMP] = ACTIONS(4929),
    [anon_sym_LT_LT] = ACTIONS(4931),
    [anon_sym_GT_GT] = ACTIONS(4931),
    [anon_sym_EQ_EQ] = ACTIONS(4933),
    [anon_sym_BANG_EQ] = ACTIONS(4929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4929),
    [anon_sym_LT_EQ_GT] = ACTIONS(4929),
    [anon_sym_EQ_TILDE] = ACTIONS(4929),
    [anon_sym_BANG_TILDE] = ACTIONS(4929),
    [anon_sym_LT_EQ] = ACTIONS(4921),
    [anon_sym_GT] = ACTIONS(4921),
    [anon_sym_GT_EQ] = ACTIONS(4935),
    [anon_sym_CARET] = ACTIONS(4937),
    [anon_sym_PLUS] = ACTIONS(4913),
    [anon_sym_SLASH] = ACTIONS(4915),
    [anon_sym_PERCENT] = ACTIONS(4915),
    [sym_comment] = ACTIONS(87),
  },
  [7880] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(4913),
    [sym__binary_star] = ACTIONS(4915),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(4917),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(4915),
    [anon_sym_AMP] = ACTIONS(4919),
    [anon_sym_LT] = ACTIONS(4921),
    [anon_sym_EQ_GT] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_DOT_DOT] = ACTIONS(4925),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4927),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(4929),
    [anon_sym_AMP_AMP] = ACTIONS(4929),
    [anon_sym_LT_LT] = ACTIONS(4931),
    [anon_sym_GT_GT] = ACTIONS(4931),
    [anon_sym_EQ_EQ] = ACTIONS(4933),
    [anon_sym_BANG_EQ] = ACTIONS(4929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4929),
    [anon_sym_LT_EQ_GT] = ACTIONS(4929),
    [anon_sym_EQ_TILDE] = ACTIONS(4929),
    [anon_sym_BANG_TILDE] = ACTIONS(4929),
    [anon_sym_LT_EQ] = ACTIONS(4921),
    [anon_sym_GT] = ACTIONS(4921),
    [anon_sym_GT_EQ] = ACTIONS(4935),
    [anon_sym_CARET] = ACTIONS(4937),
    [anon_sym_PLUS] = ACTIONS(4913),
    [anon_sym_SLASH] = ACTIONS(4915),
    [anon_sym_PERCENT] = ACTIONS(4915),
    [sym_comment] = ACTIONS(87),
  },
  [7881] = {
    [sym_heredoc_body] = STATE(7881),
    [aux_sym_call_repeat1] = STATE(7881),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(7916),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_EQ_GT] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [7882] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2925),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1113),
    [sym_scope_resolution] = STATE(1109),
    [sym_call] = STATE(1109),
    [sym_method_call] = STATE(1113),
    [sym__argument] = STATE(4986),
    [sym_splat_argument] = STATE(4986),
    [sym_hash_splat_argument] = STATE(4986),
    [sym_block_argument] = STATE(4986),
    [sym_assignment] = STATE(2925),
    [sym_operator_assignment] = STATE(2925),
    [sym_conditional] = STATE(2925),
    [sym_range] = STATE(2925),
    [sym_binary] = STATE(2925),
    [sym_unary] = STATE(2925),
    [sym_left_assignment_list] = STATE(1112),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1113),
    [sym__variable] = STATE(1109),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1113),
    [sym_false] = STATE(1113),
    [sym_nil] = STATE(1113),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2928),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4986),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(4903),
    [sym__splat_star] = ACTIONS(4905),
    [sym__unary_minus] = ACTIONS(1973),
    [sym__identifier_hash_key] = ACTIONS(4907),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11397),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1977),
    [anon_sym_yield] = ACTIONS(1979),
    [anon_sym_break] = ACTIONS(1981),
    [anon_sym_next] = ACTIONS(1983),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4899),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1991),
    [anon_sym_TILDE] = ACTIONS(1991),
    [sym_constant] = ACTIONS(4909),
    [sym_identifier] = ACTIONS(4909),
    [sym_instance_variable] = ACTIONS(1995),
    [sym_class_variable] = ACTIONS(1995),
    [sym_global_variable] = ACTIONS(1995),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1997),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1997),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7883] = {
    [sym_heredoc_body] = STATE(7881),
    [aux_sym_call_repeat1] = STATE(7881),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_EQ_GT] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [7884] = {
    [aux_sym_argument_list_repeat1] = STATE(7884),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(13230),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7925),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_EQ_GT] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7925),
    [anon_sym_AMP_AMP] = ACTIONS(7925),
    [anon_sym_LT_LT] = ACTIONS(7925),
    [anon_sym_GT_GT] = ACTIONS(7925),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7925),
    [anon_sym_PLUS] = ACTIONS(7925),
    [anon_sym_SLASH] = ACTIONS(7925),
    [anon_sym_PERCENT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [7885] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9551),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1113),
    [sym_scope_resolution] = STATE(1109),
    [sym_call] = STATE(1109),
    [sym_method_call] = STATE(1113),
    [sym_assignment] = STATE(9551),
    [sym_operator_assignment] = STATE(9551),
    [sym_conditional] = STATE(9551),
    [sym_range] = STATE(9551),
    [sym_binary] = STATE(9551),
    [sym_unary] = STATE(9551),
    [sym_left_assignment_list] = STATE(1112),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1113),
    [sym__variable] = STATE(1109),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1113),
    [sym_false] = STATE(1113),
    [sym_nil] = STATE(1113),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2917),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(1973),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1977),
    [anon_sym_yield] = ACTIONS(1979),
    [anon_sym_break] = ACTIONS(1981),
    [anon_sym_next] = ACTIONS(1983),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4899),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1991),
    [anon_sym_TILDE] = ACTIONS(1991),
    [sym_constant] = ACTIONS(1997),
    [sym_identifier] = ACTIONS(1997),
    [sym_instance_variable] = ACTIONS(1995),
    [sym_class_variable] = ACTIONS(1995),
    [sym_global_variable] = ACTIONS(1995),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1997),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1997),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7886] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5460),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1113),
    [sym_scope_resolution] = STATE(1109),
    [sym_call] = STATE(1109),
    [sym_method_call] = STATE(1113),
    [sym_splat_argument] = STATE(7439),
    [sym_assignment] = STATE(5460),
    [sym_operator_assignment] = STATE(5460),
    [sym_conditional] = STATE(5460),
    [sym_range] = STATE(5460),
    [sym_binary] = STATE(5460),
    [sym_unary] = STATE(5460),
    [sym__arg_or_splat_arg] = STATE(7439),
    [sym_left_assignment_list] = STATE(1112),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1113),
    [sym__variable] = STATE(1109),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1113),
    [sym_false] = STATE(1113),
    [sym_nil] = STATE(1113),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2917),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__splat_star] = ACTIONS(4905),
    [sym__unary_minus] = ACTIONS(1973),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1977),
    [anon_sym_yield] = ACTIONS(1979),
    [anon_sym_break] = ACTIONS(1981),
    [anon_sym_next] = ACTIONS(1983),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4899),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1991),
    [anon_sym_TILDE] = ACTIONS(1991),
    [sym_constant] = ACTIONS(1997),
    [sym_identifier] = ACTIONS(1997),
    [sym_instance_variable] = ACTIONS(1995),
    [sym_class_variable] = ACTIONS(1995),
    [sym_global_variable] = ACTIONS(1995),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(1997),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(1997),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7887] = {
    [aux_sym_exceptions_repeat1] = STATE(9552),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(13233),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_EQ_GT] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [7888] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(2001),
    [sym__binary_star] = ACTIONS(2003),
    [anon_sym_PIPE] = ACTIONS(2005),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(2003),
    [anon_sym_AMP] = ACTIONS(2007),
    [anon_sym_LT] = ACTIONS(2009),
    [anon_sym_QMARK] = ACTIONS(2011),
    [anon_sym_DOT_DOT] = ACTIONS(2013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2015),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(2019),
    [anon_sym_AMP_AMP] = ACTIONS(2019),
    [anon_sym_LT_LT] = ACTIONS(2021),
    [anon_sym_GT_GT] = ACTIONS(2021),
    [anon_sym_EQ_EQ] = ACTIONS(2023),
    [anon_sym_BANG_EQ] = ACTIONS(2019),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2019),
    [anon_sym_LT_EQ_GT] = ACTIONS(2019),
    [anon_sym_EQ_TILDE] = ACTIONS(2019),
    [anon_sym_BANG_TILDE] = ACTIONS(2019),
    [anon_sym_LT_EQ] = ACTIONS(2009),
    [anon_sym_GT] = ACTIONS(2009),
    [anon_sym_GT_EQ] = ACTIONS(2025),
    [anon_sym_CARET] = ACTIONS(2027),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_SLASH] = ACTIONS(2003),
    [anon_sym_PERCENT] = ACTIONS(2003),
    [sym_comment] = ACTIONS(87),
  },
  [7889] = {
    [sym__line_break] = ACTIONS(13235),
    [sym__heredoc_body_start] = ACTIONS(13235),
    [sym__binary_minus] = ACTIONS(13235),
    [sym__binary_star] = ACTIONS(13235),
    [ts_builtin_sym_end] = ACTIONS(13235),
    [anon_sym___END__] = ACTIONS(13235),
    [anon_sym_LBRACE] = ACTIONS(13235),
    [anon_sym_RBRACE] = ACTIONS(13235),
    [anon_sym_RPAREN] = ACTIONS(13235),
    [anon_sym_DOT] = ACTIONS(13237),
    [anon_sym_COMMA] = ACTIONS(13235),
    [anon_sym_PIPE] = ACTIONS(13237),
    [anon_sym_SEMI] = ACTIONS(13235),
    [anon_sym_STAR_STAR] = ACTIONS(13235),
    [anon_sym_AMP] = ACTIONS(13237),
    [anon_sym_LT] = ACTIONS(13237),
    [anon_sym_end] = ACTIONS(13235),
    [anon_sym_if] = ACTIONS(13235),
    [anon_sym_unless] = ACTIONS(13235),
    [anon_sym_while] = ACTIONS(13235),
    [anon_sym_until] = ACTIONS(13235),
    [anon_sym_rescue] = ACTIONS(13235),
    [anon_sym_do] = ACTIONS(13235),
    [anon_sym_when] = ACTIONS(13235),
    [anon_sym_elsif] = ACTIONS(13235),
    [anon_sym_else] = ACTIONS(13235),
    [anon_sym_then] = ACTIONS(13235),
    [anon_sym_ensure] = ACTIONS(13235),
    [anon_sym_EQ_GT] = ACTIONS(13235),
    [anon_sym_LBRACK] = ACTIONS(13235),
    [anon_sym_COLON_COLON2] = ACTIONS(13235),
    [anon_sym_AMP_DOT] = ACTIONS(13235),
    [anon_sym_QMARK] = ACTIONS(13235),
    [anon_sym_DOT_DOT] = ACTIONS(13237),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13235),
    [anon_sym_and] = ACTIONS(13235),
    [anon_sym_or] = ACTIONS(13235),
    [anon_sym_PIPE_PIPE] = ACTIONS(13235),
    [anon_sym_AMP_AMP] = ACTIONS(13235),
    [anon_sym_LT_LT] = ACTIONS(13235),
    [anon_sym_GT_GT] = ACTIONS(13235),
    [anon_sym_EQ_EQ] = ACTIONS(13237),
    [anon_sym_BANG_EQ] = ACTIONS(13235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13235),
    [anon_sym_LT_EQ_GT] = ACTIONS(13235),
    [anon_sym_EQ_TILDE] = ACTIONS(13235),
    [anon_sym_BANG_TILDE] = ACTIONS(13235),
    [anon_sym_LT_EQ] = ACTIONS(13237),
    [anon_sym_GT] = ACTIONS(13237),
    [anon_sym_GT_EQ] = ACTIONS(13235),
    [anon_sym_CARET] = ACTIONS(13235),
    [anon_sym_PLUS] = ACTIONS(13235),
    [anon_sym_SLASH] = ACTIONS(13235),
    [anon_sym_PERCENT] = ACTIONS(13235),
    [sym_comment] = ACTIONS(87),
  },
  [7890] = {
    [anon_sym_end] = ACTIONS(13239),
    [sym_comment] = ACTIONS(87),
  },
  [7891] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(8589),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8589),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(8589),
    [anon_sym_PERCENT] = ACTIONS(8589),
    [sym_comment] = ACTIONS(87),
  },
  [7892] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8589),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [7893] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8587),
    [sym__binary_star] = ACTIONS(8589),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8589),
    [anon_sym_AMP] = ACTIONS(8593),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(8605),
    [anon_sym_GT_GT] = ACTIONS(8605),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(8587),
    [anon_sym_SLASH] = ACTIONS(8589),
    [anon_sym_PERCENT] = ACTIONS(8589),
    [sym_comment] = ACTIONS(87),
  },
  [7894] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8587),
    [sym__binary_star] = ACTIONS(8589),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8589),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(8605),
    [anon_sym_GT_GT] = ACTIONS(8605),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(8587),
    [anon_sym_SLASH] = ACTIONS(8589),
    [anon_sym_PERCENT] = ACTIONS(8589),
    [sym_comment] = ACTIONS(87),
  },
  [7895] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8587),
    [sym__binary_star] = ACTIONS(8589),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(8591),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8589),
    [anon_sym_AMP] = ACTIONS(8593),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(8605),
    [anon_sym_GT_GT] = ACTIONS(8605),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(8611),
    [anon_sym_PLUS] = ACTIONS(8587),
    [anon_sym_SLASH] = ACTIONS(8589),
    [anon_sym_PERCENT] = ACTIONS(8589),
    [sym_comment] = ACTIONS(87),
  },
  [7896] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(13241),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [7897] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(8587),
    [sym__binary_star] = ACTIONS(8589),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(8591),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(8589),
    [anon_sym_AMP] = ACTIONS(8593),
    [anon_sym_LT] = ACTIONS(8595),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(8599),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8601),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(8603),
    [anon_sym_AMP_AMP] = ACTIONS(8603),
    [anon_sym_LT_LT] = ACTIONS(8605),
    [anon_sym_GT_GT] = ACTIONS(8605),
    [anon_sym_EQ_EQ] = ACTIONS(8607),
    [anon_sym_BANG_EQ] = ACTIONS(8603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8603),
    [anon_sym_LT_EQ_GT] = ACTIONS(8603),
    [anon_sym_EQ_TILDE] = ACTIONS(8603),
    [anon_sym_BANG_TILDE] = ACTIONS(8603),
    [anon_sym_LT_EQ] = ACTIONS(8595),
    [anon_sym_GT] = ACTIONS(8595),
    [anon_sym_GT_EQ] = ACTIONS(8609),
    [anon_sym_CARET] = ACTIONS(8611),
    [anon_sym_PLUS] = ACTIONS(8587),
    [anon_sym_SLASH] = ACTIONS(8589),
    [anon_sym_PERCENT] = ACTIONS(8589),
    [sym_comment] = ACTIONS(87),
  },
  [7898] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8587),
    [sym__binary_star] = ACTIONS(8589),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(8591),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8589),
    [anon_sym_AMP] = ACTIONS(8593),
    [anon_sym_LT] = ACTIONS(8595),
    [anon_sym_QMARK] = ACTIONS(8597),
    [anon_sym_DOT_DOT] = ACTIONS(8599),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8601),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(8603),
    [anon_sym_AMP_AMP] = ACTIONS(8603),
    [anon_sym_LT_LT] = ACTIONS(8605),
    [anon_sym_GT_GT] = ACTIONS(8605),
    [anon_sym_EQ_EQ] = ACTIONS(8607),
    [anon_sym_BANG_EQ] = ACTIONS(8603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8603),
    [anon_sym_LT_EQ_GT] = ACTIONS(8603),
    [anon_sym_EQ_TILDE] = ACTIONS(8603),
    [anon_sym_BANG_TILDE] = ACTIONS(8603),
    [anon_sym_LT_EQ] = ACTIONS(8595),
    [anon_sym_GT] = ACTIONS(8595),
    [anon_sym_GT_EQ] = ACTIONS(8609),
    [anon_sym_CARET] = ACTIONS(8611),
    [anon_sym_PLUS] = ACTIONS(8587),
    [anon_sym_SLASH] = ACTIONS(8589),
    [anon_sym_PERCENT] = ACTIONS(8589),
    [sym_comment] = ACTIONS(87),
  },
  [7899] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8587),
    [sym__binary_star] = ACTIONS(8589),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(8591),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8589),
    [anon_sym_AMP] = ACTIONS(8593),
    [anon_sym_LT] = ACTIONS(8595),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(8605),
    [anon_sym_GT_GT] = ACTIONS(8605),
    [anon_sym_EQ_EQ] = ACTIONS(8607),
    [anon_sym_BANG_EQ] = ACTIONS(8603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8603),
    [anon_sym_LT_EQ_GT] = ACTIONS(8603),
    [anon_sym_EQ_TILDE] = ACTIONS(8603),
    [anon_sym_BANG_TILDE] = ACTIONS(8603),
    [anon_sym_LT_EQ] = ACTIONS(8595),
    [anon_sym_GT] = ACTIONS(8595),
    [anon_sym_GT_EQ] = ACTIONS(8609),
    [anon_sym_CARET] = ACTIONS(8611),
    [anon_sym_PLUS] = ACTIONS(8587),
    [anon_sym_SLASH] = ACTIONS(8589),
    [anon_sym_PERCENT] = ACTIONS(8589),
    [sym_comment] = ACTIONS(87),
  },
  [7900] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8587),
    [sym__binary_star] = ACTIONS(8589),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8589),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(8587),
    [anon_sym_SLASH] = ACTIONS(8589),
    [anon_sym_PERCENT] = ACTIONS(8589),
    [sym_comment] = ACTIONS(87),
  },
  [7901] = {
    [aux_sym_exceptions_repeat1] = STATE(7901),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_COMMA] = ACTIONS(13243),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [7902] = {
    [aux_sym_exceptions_repeat1] = STATE(5482),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [7903] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(8587),
    [sym__binary_star] = ACTIONS(8589),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(8591),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(8589),
    [anon_sym_AMP] = ACTIONS(8593),
    [anon_sym_LT] = ACTIONS(8595),
    [anon_sym_QMARK] = ACTIONS(8597),
    [anon_sym_DOT_DOT] = ACTIONS(8599),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8601),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(8603),
    [anon_sym_AMP_AMP] = ACTIONS(8603),
    [anon_sym_LT_LT] = ACTIONS(8605),
    [anon_sym_GT_GT] = ACTIONS(8605),
    [anon_sym_EQ_EQ] = ACTIONS(8607),
    [anon_sym_BANG_EQ] = ACTIONS(8603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8603),
    [anon_sym_LT_EQ_GT] = ACTIONS(8603),
    [anon_sym_EQ_TILDE] = ACTIONS(8603),
    [anon_sym_BANG_TILDE] = ACTIONS(8603),
    [anon_sym_LT_EQ] = ACTIONS(8595),
    [anon_sym_GT] = ACTIONS(8595),
    [anon_sym_GT_EQ] = ACTIONS(8609),
    [anon_sym_CARET] = ACTIONS(8611),
    [anon_sym_PLUS] = ACTIONS(8587),
    [anon_sym_SLASH] = ACTIONS(8589),
    [anon_sym_PERCENT] = ACTIONS(8589),
    [sym_comment] = ACTIONS(87),
  },
  [7904] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9555),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7909),
    [sym_scope_resolution] = STATE(2981),
    [sym_call] = STATE(2981),
    [sym_method_call] = STATE(7909),
    [sym_assignment] = STATE(9555),
    [sym_operator_assignment] = STATE(9555),
    [sym_conditional] = STATE(9555),
    [sym_range] = STATE(9555),
    [sym_binary] = STATE(9555),
    [sym_unary] = STATE(9555),
    [sym_left_assignment_list] = STATE(7908),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7909),
    [sym__variable] = STATE(2981),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7909),
    [sym_false] = STATE(7909),
    [sym_nil] = STATE(7909),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2985),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11410),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4973),
    [anon_sym_yield] = ACTIONS(4975),
    [anon_sym_break] = ACTIONS(4977),
    [anon_sym_next] = ACTIONS(4979),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11412),
    [anon_sym_defined_QMARK] = ACTIONS(11414),
    [anon_sym_not] = ACTIONS(11416),
    [anon_sym_BANG] = ACTIONS(11418),
    [anon_sym_TILDE] = ACTIONS(11418),
    [sym_constant] = ACTIONS(4989),
    [sym_identifier] = ACTIONS(4989),
    [sym_instance_variable] = ACTIONS(4991),
    [sym_class_variable] = ACTIONS(4991),
    [sym_global_variable] = ACTIONS(4991),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4989),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4989),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7905] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9556),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7909),
    [sym_scope_resolution] = STATE(2981),
    [sym_call] = STATE(2981),
    [sym_method_call] = STATE(7909),
    [sym_assignment] = STATE(9556),
    [sym_operator_assignment] = STATE(9556),
    [sym_conditional] = STATE(9556),
    [sym_range] = STATE(9556),
    [sym_binary] = STATE(9556),
    [sym_unary] = STATE(9556),
    [sym_left_assignment_list] = STATE(7908),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7909),
    [sym__variable] = STATE(2981),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7909),
    [sym_false] = STATE(7909),
    [sym_nil] = STATE(7909),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2985),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11410),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4973),
    [anon_sym_yield] = ACTIONS(4975),
    [anon_sym_break] = ACTIONS(4977),
    [anon_sym_next] = ACTIONS(4979),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11412),
    [anon_sym_defined_QMARK] = ACTIONS(11414),
    [anon_sym_not] = ACTIONS(11416),
    [anon_sym_BANG] = ACTIONS(11418),
    [anon_sym_TILDE] = ACTIONS(11418),
    [sym_constant] = ACTIONS(4989),
    [sym_identifier] = ACTIONS(4989),
    [sym_instance_variable] = ACTIONS(4991),
    [sym_class_variable] = ACTIONS(4991),
    [sym_global_variable] = ACTIONS(4991),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4989),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4989),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7906] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7909),
    [sym_scope_resolution] = STATE(2981),
    [sym_call] = STATE(2981),
    [sym_method_call] = STATE(7909),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(7908),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7909),
    [sym__variable] = STATE(2981),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7909),
    [sym_false] = STATE(7909),
    [sym_nil] = STATE(7909),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2985),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11410),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4973),
    [anon_sym_yield] = ACTIONS(4975),
    [anon_sym_break] = ACTIONS(4977),
    [anon_sym_next] = ACTIONS(4979),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11412),
    [anon_sym_defined_QMARK] = ACTIONS(11414),
    [anon_sym_not] = ACTIONS(11416),
    [anon_sym_BANG] = ACTIONS(11418),
    [anon_sym_TILDE] = ACTIONS(11418),
    [sym_constant] = ACTIONS(4989),
    [sym_identifier] = ACTIONS(4989),
    [sym_instance_variable] = ACTIONS(4991),
    [sym_class_variable] = ACTIONS(4991),
    [sym_global_variable] = ACTIONS(4991),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4989),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4989),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7907] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(13246),
    [sym__binary_star] = ACTIONS(13248),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(13250),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(13248),
    [anon_sym_AMP] = ACTIONS(13252),
    [anon_sym_LT] = ACTIONS(13254),
    [anon_sym_then] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(13256),
    [anon_sym_DOT_DOT] = ACTIONS(13258),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13260),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(13262),
    [anon_sym_AMP_AMP] = ACTIONS(13262),
    [anon_sym_LT_LT] = ACTIONS(13264),
    [anon_sym_GT_GT] = ACTIONS(13264),
    [anon_sym_EQ_EQ] = ACTIONS(13266),
    [anon_sym_BANG_EQ] = ACTIONS(13262),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13262),
    [anon_sym_LT_EQ_GT] = ACTIONS(13262),
    [anon_sym_EQ_TILDE] = ACTIONS(13262),
    [anon_sym_BANG_TILDE] = ACTIONS(13262),
    [anon_sym_LT_EQ] = ACTIONS(13254),
    [anon_sym_GT] = ACTIONS(13254),
    [anon_sym_GT_EQ] = ACTIONS(13268),
    [anon_sym_CARET] = ACTIONS(13270),
    [anon_sym_PLUS] = ACTIONS(13246),
    [anon_sym_SLASH] = ACTIONS(13248),
    [anon_sym_PERCENT] = ACTIONS(13248),
    [sym_comment] = ACTIONS(87),
  },
  [7908] = {
    [anon_sym_EQ] = ACTIONS(13272),
    [sym_comment] = ACTIONS(87),
  },
  [7909] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(13274),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(13276),
    [anon_sym_DASH_EQ] = ACTIONS(13276),
    [anon_sym_STAR_EQ] = ACTIONS(13276),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13276),
    [anon_sym_SLASH_EQ] = ACTIONS(13276),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13276),
    [anon_sym_PIPE_EQ] = ACTIONS(13276),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13276),
    [anon_sym_AMP_EQ] = ACTIONS(13276),
    [anon_sym_PERCENT_EQ] = ACTIONS(13276),
    [anon_sym_GT_GT_EQ] = ACTIONS(13276),
    [anon_sym_LT_LT_EQ] = ACTIONS(13276),
    [anon_sym_CARET_EQ] = ACTIONS(13276),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [7910] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(13246),
    [sym__binary_star] = ACTIONS(13248),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(13250),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(13248),
    [anon_sym_AMP] = ACTIONS(13252),
    [anon_sym_LT] = ACTIONS(13254),
    [anon_sym_then] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(13256),
    [anon_sym_DOT_DOT] = ACTIONS(13258),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13260),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(13262),
    [anon_sym_AMP_AMP] = ACTIONS(13262),
    [anon_sym_LT_LT] = ACTIONS(13264),
    [anon_sym_GT_GT] = ACTIONS(13264),
    [anon_sym_EQ_EQ] = ACTIONS(13266),
    [anon_sym_BANG_EQ] = ACTIONS(13262),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13262),
    [anon_sym_LT_EQ_GT] = ACTIONS(13262),
    [anon_sym_EQ_TILDE] = ACTIONS(13262),
    [anon_sym_BANG_TILDE] = ACTIONS(13262),
    [anon_sym_LT_EQ] = ACTIONS(13254),
    [anon_sym_GT] = ACTIONS(13254),
    [anon_sym_GT_EQ] = ACTIONS(13268),
    [anon_sym_CARET] = ACTIONS(13270),
    [anon_sym_PLUS] = ACTIONS(13246),
    [anon_sym_SLASH] = ACTIONS(13248),
    [anon_sym_PERCENT] = ACTIONS(13248),
    [sym_comment] = ACTIONS(87),
  },
  [7911] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9569),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7909),
    [sym_scope_resolution] = STATE(2981),
    [sym_call] = STATE(2981),
    [sym_method_call] = STATE(7909),
    [sym_assignment] = STATE(9569),
    [sym_operator_assignment] = STATE(9569),
    [sym_conditional] = STATE(9569),
    [sym_range] = STATE(9569),
    [sym_binary] = STATE(9569),
    [sym_unary] = STATE(9569),
    [sym_left_assignment_list] = STATE(7908),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7909),
    [sym__variable] = STATE(2981),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7909),
    [sym_false] = STATE(7909),
    [sym_nil] = STATE(7909),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2985),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11410),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4973),
    [anon_sym_yield] = ACTIONS(4975),
    [anon_sym_break] = ACTIONS(4977),
    [anon_sym_next] = ACTIONS(4979),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11412),
    [anon_sym_defined_QMARK] = ACTIONS(11414),
    [anon_sym_not] = ACTIONS(11416),
    [anon_sym_BANG] = ACTIONS(11418),
    [anon_sym_TILDE] = ACTIONS(11418),
    [sym_constant] = ACTIONS(4989),
    [sym_identifier] = ACTIONS(4989),
    [sym_instance_variable] = ACTIONS(4991),
    [sym_class_variable] = ACTIONS(4991),
    [sym_global_variable] = ACTIONS(4991),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4989),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4989),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7912] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(13246),
    [sym__binary_star] = ACTIONS(13248),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(13250),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(13248),
    [anon_sym_AMP] = ACTIONS(13252),
    [anon_sym_LT] = ACTIONS(13254),
    [anon_sym_then] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(13256),
    [anon_sym_DOT_DOT] = ACTIONS(13258),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13260),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(13262),
    [anon_sym_AMP_AMP] = ACTIONS(13262),
    [anon_sym_LT_LT] = ACTIONS(13264),
    [anon_sym_GT_GT] = ACTIONS(13264),
    [anon_sym_EQ_EQ] = ACTIONS(13266),
    [anon_sym_BANG_EQ] = ACTIONS(13262),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13262),
    [anon_sym_LT_EQ_GT] = ACTIONS(13262),
    [anon_sym_EQ_TILDE] = ACTIONS(13262),
    [anon_sym_BANG_TILDE] = ACTIONS(13262),
    [anon_sym_LT_EQ] = ACTIONS(13254),
    [anon_sym_GT] = ACTIONS(13254),
    [anon_sym_GT_EQ] = ACTIONS(13268),
    [anon_sym_CARET] = ACTIONS(13270),
    [anon_sym_PLUS] = ACTIONS(13246),
    [anon_sym_SLASH] = ACTIONS(13248),
    [anon_sym_PERCENT] = ACTIONS(13248),
    [sym_comment] = ACTIONS(87),
  },
  [7913] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9570),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7909),
    [sym_scope_resolution] = STATE(2981),
    [sym_call] = STATE(2981),
    [sym_method_call] = STATE(7909),
    [sym_assignment] = STATE(9570),
    [sym_operator_assignment] = STATE(9570),
    [sym_conditional] = STATE(9570),
    [sym_range] = STATE(9570),
    [sym_binary] = STATE(9570),
    [sym_unary] = STATE(9570),
    [sym_left_assignment_list] = STATE(7908),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7909),
    [sym__variable] = STATE(2981),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7909),
    [sym_false] = STATE(7909),
    [sym_nil] = STATE(7909),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2985),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11410),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4973),
    [anon_sym_yield] = ACTIONS(4975),
    [anon_sym_break] = ACTIONS(4977),
    [anon_sym_next] = ACTIONS(4979),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11412),
    [anon_sym_defined_QMARK] = ACTIONS(11414),
    [anon_sym_not] = ACTIONS(11416),
    [anon_sym_BANG] = ACTIONS(11418),
    [anon_sym_TILDE] = ACTIONS(11418),
    [sym_constant] = ACTIONS(4989),
    [sym_identifier] = ACTIONS(4989),
    [sym_instance_variable] = ACTIONS(4991),
    [sym_class_variable] = ACTIONS(4991),
    [sym_global_variable] = ACTIONS(4991),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4989),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4989),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7914] = {
    [sym_heredoc_body] = STATE(9571),
    [aux_sym_call_repeat1] = STATE(9571),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_then] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [7915] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5492),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3056),
    [sym_scope_resolution] = STATE(1172),
    [sym_call] = STATE(1172),
    [sym_method_call] = STATE(3056),
    [sym__argument] = STATE(2565),
    [sym_splat_argument] = STATE(2565),
    [sym_hash_splat_argument] = STATE(2565),
    [sym_block_argument] = STATE(2565),
    [sym_assignment] = STATE(5492),
    [sym_operator_assignment] = STATE(5492),
    [sym_conditional] = STATE(5492),
    [sym_range] = STATE(5492),
    [sym_binary] = STATE(5492),
    [sym_unary] = STATE(5492),
    [sym_left_assignment_list] = STATE(3055),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3056),
    [sym__variable] = STATE(1172),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3056),
    [sym_false] = STATE(3056),
    [sym_nil] = STATE(3056),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5495),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(9572),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2565),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(8621),
    [sym__splat_star] = ACTIONS(8623),
    [sym__unary_minus] = ACTIONS(5081),
    [sym__identifier_hash_key] = ACTIONS(8625),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13278),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2085),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_next] = ACTIONS(2089),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8741),
    [anon_sym_defined_QMARK] = ACTIONS(5085),
    [anon_sym_not] = ACTIONS(5087),
    [anon_sym_BANG] = ACTIONS(5091),
    [anon_sym_TILDE] = ACTIONS(5091),
    [sym_constant] = ACTIONS(8627),
    [sym_identifier] = ACTIONS(8627),
    [sym_instance_variable] = ACTIONS(2105),
    [sym_class_variable] = ACTIONS(2105),
    [sym_global_variable] = ACTIONS(2105),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2103),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2103),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7916] = {
    [sym_heredoc_body] = STATE(9573),
    [aux_sym_call_repeat1] = STATE(9573),
    [aux_sym_argument_list_repeat1] = STATE(9574),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(11424),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_then] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [7917] = {
    [sym__line_break] = ACTIONS(13280),
    [sym__heredoc_body_start] = ACTIONS(13280),
    [anon_sym_COMMA] = ACTIONS(13280),
    [anon_sym_SEMI] = ACTIONS(13280),
    [anon_sym_then] = ACTIONS(13280),
    [sym_comment] = ACTIONS(87),
  },
  [7918] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9575),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7930),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(7930),
    [sym_assignment] = STATE(9575),
    [sym_operator_assignment] = STATE(9575),
    [sym_conditional] = STATE(9575),
    [sym_range] = STATE(9575),
    [sym_binary] = STATE(9575),
    [sym_unary] = STATE(9575),
    [sym_left_assignment_list] = STATE(7929),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7930),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7930),
    [sym_false] = STATE(7930),
    [sym_nil] = STATE(7930),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7931),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11428),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11430),
    [anon_sym_yield] = ACTIONS(11432),
    [anon_sym_break] = ACTIONS(11434),
    [anon_sym_next] = ACTIONS(11436),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11438),
    [anon_sym_defined_QMARK] = ACTIONS(11440),
    [anon_sym_not] = ACTIONS(11442),
    [anon_sym_BANG] = ACTIONS(11444),
    [anon_sym_TILDE] = ACTIONS(11444),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7919] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9588),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9593),
    [sym_scope_resolution] = STATE(9589),
    [sym_call] = STATE(9589),
    [sym_method_call] = STATE(9593),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(9590),
    [sym__argument] = STATE(9591),
    [sym_splat_argument] = STATE(9591),
    [sym_hash_splat_argument] = STATE(9591),
    [sym_block_argument] = STATE(9591),
    [sym_assignment] = STATE(9588),
    [sym_operator_assignment] = STATE(9588),
    [sym_conditional] = STATE(9588),
    [sym_range] = STATE(9588),
    [sym_binary] = STATE(9588),
    [sym_unary] = STATE(9588),
    [sym_left_assignment_list] = STATE(9592),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9593),
    [sym__variable] = STATE(9589),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9593),
    [sym_false] = STATE(9593),
    [sym_nil] = STATE(9593),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(9594),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(9591),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(13282),
    [sym__splat_star] = ACTIONS(13284),
    [sym__unary_minus] = ACTIONS(13286),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(13288),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(13290),
    [anon_sym_yield] = ACTIONS(13292),
    [anon_sym_break] = ACTIONS(13294),
    [anon_sym_next] = ACTIONS(13296),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_when] = ACTIONS(377),
    [anon_sym_else] = ACTIONS(377),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(13298),
    [anon_sym_not] = ACTIONS(13300),
    [anon_sym_BANG] = ACTIONS(13302),
    [anon_sym_TILDE] = ACTIONS(13304),
    [sym_constant] = ACTIONS(13306),
    [sym_identifier] = ACTIONS(13306),
    [sym_instance_variable] = ACTIONS(13308),
    [sym_class_variable] = ACTIONS(13308),
    [sym_global_variable] = ACTIONS(13308),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(13310),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13310),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7920] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9588),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9593),
    [sym_scope_resolution] = STATE(9589),
    [sym_call] = STATE(9589),
    [sym_method_call] = STATE(9593),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(9590),
    [sym__argument] = STATE(9591),
    [sym_splat_argument] = STATE(9591),
    [sym_hash_splat_argument] = STATE(9591),
    [sym_block_argument] = STATE(9591),
    [sym_assignment] = STATE(9588),
    [sym_operator_assignment] = STATE(9588),
    [sym_conditional] = STATE(9588),
    [sym_range] = STATE(9588),
    [sym_binary] = STATE(9588),
    [sym_unary] = STATE(9588),
    [sym_left_assignment_list] = STATE(9592),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9593),
    [sym__variable] = STATE(9589),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9593),
    [sym_false] = STATE(9593),
    [sym_nil] = STATE(9593),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(9594),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(9591),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(13282),
    [sym__splat_star] = ACTIONS(13284),
    [sym__unary_minus] = ACTIONS(13286),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(13288),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(13290),
    [anon_sym_yield] = ACTIONS(13292),
    [anon_sym_break] = ACTIONS(13294),
    [anon_sym_next] = ACTIONS(13296),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_when] = ACTIONS(419),
    [anon_sym_else] = ACTIONS(419),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(13298),
    [anon_sym_not] = ACTIONS(13300),
    [anon_sym_BANG] = ACTIONS(13302),
    [anon_sym_TILDE] = ACTIONS(13304),
    [sym_constant] = ACTIONS(13306),
    [sym_identifier] = ACTIONS(13306),
    [sym_instance_variable] = ACTIONS(13308),
    [sym_class_variable] = ACTIONS(13308),
    [sym_global_variable] = ACTIONS(13308),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(13310),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13310),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7921] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9588),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9593),
    [sym_scope_resolution] = STATE(9589),
    [sym_call] = STATE(9589),
    [sym_method_call] = STATE(9593),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(9590),
    [sym__argument] = STATE(9591),
    [sym_splat_argument] = STATE(9591),
    [sym_hash_splat_argument] = STATE(9591),
    [sym_block_argument] = STATE(9591),
    [sym_assignment] = STATE(9588),
    [sym_operator_assignment] = STATE(9588),
    [sym_conditional] = STATE(9588),
    [sym_range] = STATE(9588),
    [sym_binary] = STATE(9588),
    [sym_unary] = STATE(9588),
    [sym_left_assignment_list] = STATE(9592),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9593),
    [sym__variable] = STATE(9589),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9593),
    [sym_false] = STATE(9593),
    [sym_nil] = STATE(9593),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(9594),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(9591),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(13282),
    [sym__splat_star] = ACTIONS(13284),
    [sym__unary_minus] = ACTIONS(13286),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(13288),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(423),
    [anon_sym_return] = ACTIONS(13290),
    [anon_sym_yield] = ACTIONS(13292),
    [anon_sym_break] = ACTIONS(13294),
    [anon_sym_next] = ACTIONS(13296),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_when] = ACTIONS(423),
    [anon_sym_else] = ACTIONS(423),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(13298),
    [anon_sym_not] = ACTIONS(13300),
    [anon_sym_BANG] = ACTIONS(13302),
    [anon_sym_TILDE] = ACTIONS(13304),
    [sym_constant] = ACTIONS(13306),
    [sym_identifier] = ACTIONS(13306),
    [sym_instance_variable] = ACTIONS(13308),
    [sym_class_variable] = ACTIONS(13308),
    [sym_global_variable] = ACTIONS(13308),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(13310),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13310),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7922] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9588),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9593),
    [sym_scope_resolution] = STATE(9589),
    [sym_call] = STATE(9589),
    [sym_method_call] = STATE(9593),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(9590),
    [sym__argument] = STATE(9591),
    [sym_splat_argument] = STATE(9591),
    [sym_hash_splat_argument] = STATE(9591),
    [sym_block_argument] = STATE(9591),
    [sym_assignment] = STATE(9588),
    [sym_operator_assignment] = STATE(9588),
    [sym_conditional] = STATE(9588),
    [sym_range] = STATE(9588),
    [sym_binary] = STATE(9588),
    [sym_unary] = STATE(9588),
    [sym_left_assignment_list] = STATE(9592),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9593),
    [sym__variable] = STATE(9589),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9593),
    [sym_false] = STATE(9593),
    [sym_nil] = STATE(9593),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(9594),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(9591),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(13282),
    [sym__splat_star] = ACTIONS(13284),
    [sym__unary_minus] = ACTIONS(13286),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(13288),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(427),
    [anon_sym_return] = ACTIONS(13290),
    [anon_sym_yield] = ACTIONS(13292),
    [anon_sym_break] = ACTIONS(13294),
    [anon_sym_next] = ACTIONS(13296),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_when] = ACTIONS(427),
    [anon_sym_else] = ACTIONS(427),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(13298),
    [anon_sym_not] = ACTIONS(13300),
    [anon_sym_BANG] = ACTIONS(13302),
    [anon_sym_TILDE] = ACTIONS(13304),
    [sym_constant] = ACTIONS(13306),
    [sym_identifier] = ACTIONS(13306),
    [sym_instance_variable] = ACTIONS(13308),
    [sym_class_variable] = ACTIONS(13308),
    [sym_global_variable] = ACTIONS(13308),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(13310),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13310),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7923] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9595),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7930),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(7930),
    [sym_assignment] = STATE(9595),
    [sym_operator_assignment] = STATE(9595),
    [sym_conditional] = STATE(9595),
    [sym_range] = STATE(9595),
    [sym_binary] = STATE(9595),
    [sym_unary] = STATE(9595),
    [sym_left_assignment_list] = STATE(7929),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7930),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7930),
    [sym_false] = STATE(7930),
    [sym_nil] = STATE(7930),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7931),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11428),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11430),
    [anon_sym_yield] = ACTIONS(11432),
    [anon_sym_break] = ACTIONS(11434),
    [anon_sym_next] = ACTIONS(11436),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11438),
    [anon_sym_defined_QMARK] = ACTIONS(11440),
    [anon_sym_not] = ACTIONS(11442),
    [anon_sym_BANG] = ACTIONS(11444),
    [anon_sym_TILDE] = ACTIONS(11444),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7924] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(298),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7930),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(7930),
    [sym_assignment] = STATE(298),
    [sym_operator_assignment] = STATE(298),
    [sym_conditional] = STATE(298),
    [sym_range] = STATE(298),
    [sym_binary] = STATE(298),
    [sym_unary] = STATE(298),
    [sym_left_assignment_list] = STATE(7929),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7930),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7930),
    [sym_false] = STATE(7930),
    [sym_nil] = STATE(7930),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7931),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11428),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11430),
    [anon_sym_yield] = ACTIONS(11432),
    [anon_sym_break] = ACTIONS(11434),
    [anon_sym_next] = ACTIONS(11436),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11438),
    [anon_sym_defined_QMARK] = ACTIONS(11440),
    [anon_sym_not] = ACTIONS(11442),
    [anon_sym_BANG] = ACTIONS(11444),
    [anon_sym_TILDE] = ACTIONS(11444),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7925] = {
    [sym_operator] = STATE(9596),
    [sym__method_name] = STATE(9596),
    [sym_setter] = STATE(9596),
    [sym_symbol] = STATE(9596),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(13312),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(13312),
    [sym_class_variable] = ACTIONS(13312),
    [sym_global_variable] = ACTIONS(13312),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [7926] = {
    [sym_heredoc_body] = STATE(370),
    [sym__terminator] = STATE(370),
    [sym__line_break] = ACTIONS(687),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(687),
    [anon_sym_end] = ACTIONS(689),
    [anon_sym_if] = ACTIONS(13314),
    [anon_sym_unless] = ACTIONS(13316),
    [anon_sym_while] = ACTIONS(13318),
    [anon_sym_until] = ACTIONS(13320),
    [anon_sym_rescue] = ACTIONS(13322),
    [anon_sym_when] = ACTIONS(689),
    [anon_sym_else] = ACTIONS(689),
    [sym_comment] = ACTIONS(87),
  },
  [7927] = {
    [sym__line_break] = ACTIONS(701),
    [sym__heredoc_body_start] = ACTIONS(701),
    [sym__binary_minus] = ACTIONS(13324),
    [sym__binary_star] = ACTIONS(13326),
    [anon_sym_PIPE] = ACTIONS(13328),
    [anon_sym_SEMI] = ACTIONS(701),
    [anon_sym_STAR_STAR] = ACTIONS(13326),
    [anon_sym_AMP] = ACTIONS(13330),
    [anon_sym_LT] = ACTIONS(13332),
    [anon_sym_end] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_unless] = ACTIONS(701),
    [anon_sym_while] = ACTIONS(701),
    [anon_sym_until] = ACTIONS(701),
    [anon_sym_rescue] = ACTIONS(701),
    [anon_sym_when] = ACTIONS(701),
    [anon_sym_else] = ACTIONS(701),
    [anon_sym_QMARK] = ACTIONS(13334),
    [anon_sym_DOT_DOT] = ACTIONS(13336),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13338),
    [anon_sym_and] = ACTIONS(13340),
    [anon_sym_or] = ACTIONS(13340),
    [anon_sym_PIPE_PIPE] = ACTIONS(13342),
    [anon_sym_AMP_AMP] = ACTIONS(13342),
    [anon_sym_LT_LT] = ACTIONS(13344),
    [anon_sym_GT_GT] = ACTIONS(13344),
    [anon_sym_EQ_EQ] = ACTIONS(13346),
    [anon_sym_BANG_EQ] = ACTIONS(13342),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13342),
    [anon_sym_LT_EQ_GT] = ACTIONS(13342),
    [anon_sym_EQ_TILDE] = ACTIONS(13342),
    [anon_sym_BANG_TILDE] = ACTIONS(13342),
    [anon_sym_LT_EQ] = ACTIONS(13332),
    [anon_sym_GT] = ACTIONS(13332),
    [anon_sym_GT_EQ] = ACTIONS(13348),
    [anon_sym_CARET] = ACTIONS(13350),
    [anon_sym_PLUS] = ACTIONS(13324),
    [anon_sym_SLASH] = ACTIONS(13326),
    [anon_sym_PERCENT] = ACTIONS(13326),
    [sym_comment] = ACTIONS(87),
  },
  [7928] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(9624),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(9629),
    [sym_scope_resolution] = STATE(9625),
    [sym_call] = STATE(9625),
    [sym_method_call] = STATE(9629),
    [sym_argument_list] = STATE(423),
    [sym__argument_list_with_parens] = STATE(9626),
    [sym__argument] = STATE(9627),
    [sym_splat_argument] = STATE(9627),
    [sym_hash_splat_argument] = STATE(9627),
    [sym_block_argument] = STATE(9627),
    [sym_do_block] = STATE(426),
    [sym_block] = STATE(426),
    [sym_assignment] = STATE(9624),
    [sym_operator_assignment] = STATE(9624),
    [sym_conditional] = STATE(9624),
    [sym_range] = STATE(9624),
    [sym_binary] = STATE(9624),
    [sym_unary] = STATE(9624),
    [sym_left_assignment_list] = STATE(9628),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9629),
    [sym__variable] = STATE(9625),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(9629),
    [sym_false] = STATE(9629),
    [sym_nil] = STATE(9629),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(9630),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(9627),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(743),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(13352),
    [sym__splat_star] = ACTIONS(13354),
    [sym__unary_minus] = ACTIONS(13356),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(13358),
    [anon_sym_LBRACE] = ACTIONS(771),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(769),
    [anon_sym_return] = ACTIONS(13360),
    [anon_sym_yield] = ACTIONS(13362),
    [anon_sym_break] = ACTIONS(13364),
    [anon_sym_next] = ACTIONS(13366),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(769),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(769),
    [anon_sym_until] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(769),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_when] = ACTIONS(769),
    [anon_sym_else] = ACTIONS(769),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(13368),
    [anon_sym_not] = ACTIONS(13370),
    [anon_sym_BANG] = ACTIONS(13372),
    [anon_sym_TILDE] = ACTIONS(13374),
    [sym_constant] = ACTIONS(13376),
    [sym_identifier] = ACTIONS(13376),
    [sym_instance_variable] = ACTIONS(13378),
    [sym_class_variable] = ACTIONS(13378),
    [sym_global_variable] = ACTIONS(13378),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(13380),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13380),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7929] = {
    [anon_sym_EQ] = ACTIONS(13382),
    [sym_comment] = ACTIONS(87),
  },
  [7930] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(13384),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_when] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(13386),
    [anon_sym_DASH_EQ] = ACTIONS(13386),
    [anon_sym_STAR_EQ] = ACTIONS(13386),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13386),
    [anon_sym_SLASH_EQ] = ACTIONS(13386),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13386),
    [anon_sym_PIPE_EQ] = ACTIONS(13386),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13386),
    [anon_sym_AMP_EQ] = ACTIONS(13386),
    [anon_sym_PERCENT_EQ] = ACTIONS(13386),
    [anon_sym_GT_GT_EQ] = ACTIONS(13386),
    [anon_sym_LT_LT_EQ] = ACTIONS(13386),
    [anon_sym_CARET_EQ] = ACTIONS(13386),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [7931] = {
    [sym_string] = STATE(9633),
    [aux_sym_chained_string_repeat1] = STATE(9633),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_when] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [7932] = {
    [sym_begin_block] = STATE(9634),
    [sym_end_block] = STATE(9634),
    [sym__statement] = STATE(9634),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(9634),
    [sym_unless_modifier] = STATE(9634),
    [sym_while_modifier] = STATE(9634),
    [sym_until_modifier] = STATE(9634),
    [sym_rescue_modifier] = STATE(9634),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7927),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7930),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(7930),
    [sym_assignment] = STATE(7927),
    [sym_operator_assignment] = STATE(7927),
    [sym_conditional] = STATE(7927),
    [sym_range] = STATE(7927),
    [sym_binary] = STATE(7927),
    [sym_unary] = STATE(7927),
    [sym_left_assignment_list] = STATE(7929),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7930),
    [sym__variable] = STATE(7928),
    [sym_undef] = STATE(9634),
    [sym_alias] = STATE(9634),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7930),
    [sym_false] = STATE(7930),
    [sym_nil] = STATE(7930),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7931),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(9635),
    [aux_sym__statements_repeat1] = STATE(9635),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11428),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(833),
    [anon_sym_return] = ACTIONS(11430),
    [anon_sym_yield] = ACTIONS(11432),
    [anon_sym_break] = ACTIONS(11434),
    [anon_sym_next] = ACTIONS(11436),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_when] = ACTIONS(833),
    [anon_sym_else] = ACTIONS(833),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11438),
    [anon_sym_defined_QMARK] = ACTIONS(11440),
    [anon_sym_not] = ACTIONS(11442),
    [anon_sym_BANG] = ACTIONS(11444),
    [anon_sym_TILDE] = ACTIONS(11444),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [anon_sym_undef] = ACTIONS(11450),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7933] = {
    [sym__statements] = STATE(5106),
    [sym_begin_block] = STATE(7926),
    [sym_end_block] = STATE(7926),
    [sym__statement] = STATE(7926),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(7926),
    [sym_unless_modifier] = STATE(7926),
    [sym_while_modifier] = STATE(7926),
    [sym_until_modifier] = STATE(7926),
    [sym_rescue_modifier] = STATE(7926),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7927),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7930),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(7930),
    [sym_assignment] = STATE(7927),
    [sym_operator_assignment] = STATE(7927),
    [sym_conditional] = STATE(7927),
    [sym_range] = STATE(7927),
    [sym_binary] = STATE(7927),
    [sym_unary] = STATE(7927),
    [sym_left_assignment_list] = STATE(7929),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7930),
    [sym__variable] = STATE(7928),
    [sym_undef] = STATE(7926),
    [sym_alias] = STATE(7926),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7930),
    [sym_false] = STATE(7930),
    [sym_nil] = STATE(7930),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7931),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(7932),
    [aux_sym__statements_repeat1] = STATE(7932),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11428),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(8104),
    [anon_sym_return] = ACTIONS(11430),
    [anon_sym_yield] = ACTIONS(11432),
    [anon_sym_break] = ACTIONS(11434),
    [anon_sym_next] = ACTIONS(11436),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_when] = ACTIONS(8104),
    [anon_sym_else] = ACTIONS(8104),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11438),
    [anon_sym_defined_QMARK] = ACTIONS(11440),
    [anon_sym_not] = ACTIONS(11442),
    [anon_sym_BANG] = ACTIONS(11444),
    [anon_sym_TILDE] = ACTIONS(11444),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [anon_sym_undef] = ACTIONS(11450),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7934] = {
    [anon_sym_end] = ACTIONS(13388),
    [anon_sym_when] = ACTIONS(13388),
    [anon_sym_else] = ACTIONS(13388),
    [sym_comment] = ACTIONS(87),
  },
  [7935] = {
    [sym__statements] = STATE(2640),
    [sym_begin_block] = STATE(7926),
    [sym_end_block] = STATE(7926),
    [sym__statement] = STATE(7926),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(7926),
    [sym_unless_modifier] = STATE(7926),
    [sym_while_modifier] = STATE(7926),
    [sym_until_modifier] = STATE(7926),
    [sym_rescue_modifier] = STATE(7926),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7927),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7930),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(7930),
    [sym_assignment] = STATE(7927),
    [sym_operator_assignment] = STATE(7927),
    [sym_conditional] = STATE(7927),
    [sym_range] = STATE(7927),
    [sym_binary] = STATE(7927),
    [sym_unary] = STATE(7927),
    [sym_left_assignment_list] = STATE(7929),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7930),
    [sym__variable] = STATE(7928),
    [sym_undef] = STATE(7926),
    [sym_alias] = STATE(7926),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7930),
    [sym_false] = STATE(7930),
    [sym_nil] = STATE(7930),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7931),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(7932),
    [aux_sym__statements_repeat1] = STATE(7932),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11428),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13390),
    [anon_sym_return] = ACTIONS(11430),
    [anon_sym_yield] = ACTIONS(11432),
    [anon_sym_break] = ACTIONS(11434),
    [anon_sym_next] = ACTIONS(11436),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_when] = ACTIONS(13390),
    [anon_sym_else] = ACTIONS(13390),
    [anon_sym_then] = ACTIONS(11456),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11438),
    [anon_sym_defined_QMARK] = ACTIONS(11440),
    [anon_sym_not] = ACTIONS(11442),
    [anon_sym_BANG] = ACTIONS(11444),
    [anon_sym_TILDE] = ACTIONS(11444),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [anon_sym_undef] = ACTIONS(11450),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7936] = {
    [aux_sym_when_repeat1] = STATE(7936),
    [sym__line_break] = ACTIONS(13280),
    [sym__heredoc_body_start] = ACTIONS(13280),
    [anon_sym_COMMA] = ACTIONS(13392),
    [anon_sym_SEMI] = ACTIONS(13280),
    [anon_sym_then] = ACTIONS(13280),
    [sym_comment] = ACTIONS(87),
  },
  [7937] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(8639),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8639),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(8639),
    [anon_sym_PERCENT] = ACTIONS(8639),
    [sym_comment] = ACTIONS(87),
  },
  [7938] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8639),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [7939] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8637),
    [sym__binary_star] = ACTIONS(8639),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8639),
    [anon_sym_AMP] = ACTIONS(8643),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(8657),
    [anon_sym_GT_GT] = ACTIONS(8657),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(8637),
    [anon_sym_SLASH] = ACTIONS(8639),
    [anon_sym_PERCENT] = ACTIONS(8639),
    [sym_comment] = ACTIONS(87),
  },
  [7940] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8637),
    [sym__binary_star] = ACTIONS(8639),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8639),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(8657),
    [anon_sym_GT_GT] = ACTIONS(8657),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(8637),
    [anon_sym_SLASH] = ACTIONS(8639),
    [anon_sym_PERCENT] = ACTIONS(8639),
    [sym_comment] = ACTIONS(87),
  },
  [7941] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8637),
    [sym__binary_star] = ACTIONS(8639),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(8641),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8639),
    [anon_sym_AMP] = ACTIONS(8643),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(8657),
    [anon_sym_GT_GT] = ACTIONS(8657),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(8663),
    [anon_sym_PLUS] = ACTIONS(8637),
    [anon_sym_SLASH] = ACTIONS(8639),
    [anon_sym_PERCENT] = ACTIONS(8639),
    [sym_comment] = ACTIONS(87),
  },
  [7942] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(13395),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [7943] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(8637),
    [sym__binary_star] = ACTIONS(8639),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(8641),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(8639),
    [anon_sym_AMP] = ACTIONS(8643),
    [anon_sym_LT] = ACTIONS(8645),
    [anon_sym_then] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(8649),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8651),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(8655),
    [anon_sym_AMP_AMP] = ACTIONS(8655),
    [anon_sym_LT_LT] = ACTIONS(8657),
    [anon_sym_GT_GT] = ACTIONS(8657),
    [anon_sym_EQ_EQ] = ACTIONS(8659),
    [anon_sym_BANG_EQ] = ACTIONS(8655),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8655),
    [anon_sym_LT_EQ_GT] = ACTIONS(8655),
    [anon_sym_EQ_TILDE] = ACTIONS(8655),
    [anon_sym_BANG_TILDE] = ACTIONS(8655),
    [anon_sym_LT_EQ] = ACTIONS(8645),
    [anon_sym_GT] = ACTIONS(8645),
    [anon_sym_GT_EQ] = ACTIONS(8661),
    [anon_sym_CARET] = ACTIONS(8663),
    [anon_sym_PLUS] = ACTIONS(8637),
    [anon_sym_SLASH] = ACTIONS(8639),
    [anon_sym_PERCENT] = ACTIONS(8639),
    [sym_comment] = ACTIONS(87),
  },
  [7944] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8637),
    [sym__binary_star] = ACTIONS(8639),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(8641),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8639),
    [anon_sym_AMP] = ACTIONS(8643),
    [anon_sym_LT] = ACTIONS(8645),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(8647),
    [anon_sym_DOT_DOT] = ACTIONS(8649),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8651),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(8655),
    [anon_sym_AMP_AMP] = ACTIONS(8655),
    [anon_sym_LT_LT] = ACTIONS(8657),
    [anon_sym_GT_GT] = ACTIONS(8657),
    [anon_sym_EQ_EQ] = ACTIONS(8659),
    [anon_sym_BANG_EQ] = ACTIONS(8655),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8655),
    [anon_sym_LT_EQ_GT] = ACTIONS(8655),
    [anon_sym_EQ_TILDE] = ACTIONS(8655),
    [anon_sym_BANG_TILDE] = ACTIONS(8655),
    [anon_sym_LT_EQ] = ACTIONS(8645),
    [anon_sym_GT] = ACTIONS(8645),
    [anon_sym_GT_EQ] = ACTIONS(8661),
    [anon_sym_CARET] = ACTIONS(8663),
    [anon_sym_PLUS] = ACTIONS(8637),
    [anon_sym_SLASH] = ACTIONS(8639),
    [anon_sym_PERCENT] = ACTIONS(8639),
    [sym_comment] = ACTIONS(87),
  },
  [7945] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8637),
    [sym__binary_star] = ACTIONS(8639),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(8641),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8639),
    [anon_sym_AMP] = ACTIONS(8643),
    [anon_sym_LT] = ACTIONS(8645),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(8657),
    [anon_sym_GT_GT] = ACTIONS(8657),
    [anon_sym_EQ_EQ] = ACTIONS(8659),
    [anon_sym_BANG_EQ] = ACTIONS(8655),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8655),
    [anon_sym_LT_EQ_GT] = ACTIONS(8655),
    [anon_sym_EQ_TILDE] = ACTIONS(8655),
    [anon_sym_BANG_TILDE] = ACTIONS(8655),
    [anon_sym_LT_EQ] = ACTIONS(8645),
    [anon_sym_GT] = ACTIONS(8645),
    [anon_sym_GT_EQ] = ACTIONS(8661),
    [anon_sym_CARET] = ACTIONS(8663),
    [anon_sym_PLUS] = ACTIONS(8637),
    [anon_sym_SLASH] = ACTIONS(8639),
    [anon_sym_PERCENT] = ACTIONS(8639),
    [sym_comment] = ACTIONS(87),
  },
  [7946] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8637),
    [sym__binary_star] = ACTIONS(8639),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8639),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(8637),
    [anon_sym_SLASH] = ACTIONS(8639),
    [anon_sym_PERCENT] = ACTIONS(8639),
    [sym_comment] = ACTIONS(87),
  },
  [7947] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(9637),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7957),
    [sym_scope_resolution] = STATE(7955),
    [sym_call] = STATE(7955),
    [sym_method_call] = STATE(7957),
    [sym_assignment] = STATE(9637),
    [sym_operator_assignment] = STATE(9637),
    [sym_conditional] = STATE(9637),
    [sym_range] = STATE(9637),
    [sym_binary] = STATE(9637),
    [sym_unary] = STATE(9637),
    [sym_left_assignment_list] = STATE(7956),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7957),
    [sym__variable] = STATE(7955),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7957),
    [sym_false] = STATE(7957),
    [sym_nil] = STATE(7957),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7958),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11460),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11462),
    [anon_sym_yield] = ACTIONS(11464),
    [anon_sym_break] = ACTIONS(11466),
    [anon_sym_next] = ACTIONS(11468),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11470),
    [anon_sym_defined_QMARK] = ACTIONS(11472),
    [anon_sym_not] = ACTIONS(11474),
    [anon_sym_BANG] = ACTIONS(11476),
    [anon_sym_TILDE] = ACTIONS(11476),
    [sym_constant] = ACTIONS(11478),
    [sym_identifier] = ACTIONS(11478),
    [sym_instance_variable] = ACTIONS(11480),
    [sym_class_variable] = ACTIONS(11480),
    [sym_global_variable] = ACTIONS(11480),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11478),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11478),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [7948] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5517),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3096),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(3096),
    [sym_argument_list] = STATE(3610),
    [sym__argument_list_with_parens] = STATE(5518),
    [sym__argument] = STATE(5519),
    [sym_splat_argument] = STATE(5519),
    [sym_hash_splat_argument] = STATE(5519),
    [sym_block_argument] = STATE(5519),
    [sym_assignment] = STATE(5517),
    [sym_operator_assignment] = STATE(5517),
    [sym_conditional] = STATE(5517),
    [sym_range] = STATE(5517),
    [sym_binary] = STATE(5517),
    [sym_unary] = STATE(5517),
    [sym_left_assignment_list] = STATE(3095),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3096),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3096),
    [sym_false] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5520),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(5519),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(8665),
    [sym__splat_star] = ACTIONS(8667),
    [sym__unary_minus] = ACTIONS(5149),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(8669),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5153),
    [anon_sym_yield] = ACTIONS(5155),
    [anon_sym_break] = ACTIONS(5157),
    [anon_sym_next] = ACTIONS(5159),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_then] = ACTIONS(377),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(365),
    [anon_sym_DASH_EQ] = ACTIONS(365),
    [anon_sym_STAR_EQ] = ACTIONS(365),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(365),
    [anon_sym_SLASH_EQ] = ACTIONS(365),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(365),
    [anon_sym_PIPE_EQ] = ACTIONS(365),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(365),
    [anon_sym_AMP_EQ] = ACTIONS(365),
    [anon_sym_PERCENT_EQ] = ACTIONS(365),
    [anon_sym_GT_GT_EQ] = ACTIONS(365),
    [anon_sym_LT_LT_EQ] = ACTIONS(365),
    [anon_sym_CARET_EQ] = ACTIONS(365),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_PERCENT] = ACTIONS(377),
    [anon_sym_defined_QMARK] = ACTIONS(5161),
    [anon_sym_not] = ACTIONS(5163),
    [anon_sym_BANG] = ACTIONS(5165),
    [anon_sym_TILDE] = ACTIONS(5167),
    [sym_constant] = ACTIONS(8671),
    [sym_identifier] = ACTIONS(8671),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7949] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5517),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3096),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(3096),
    [sym_argument_list] = STATE(3611),
    [sym__argument_list_with_parens] = STATE(5518),
    [sym__argument] = STATE(5519),
    [sym_splat_argument] = STATE(5519),
    [sym_hash_splat_argument] = STATE(5519),
    [sym_block_argument] = STATE(5519),
    [sym_assignment] = STATE(5517),
    [sym_operator_assignment] = STATE(5517),
    [sym_conditional] = STATE(5517),
    [sym_range] = STATE(5517),
    [sym_binary] = STATE(5517),
    [sym_unary] = STATE(5517),
    [sym_left_assignment_list] = STATE(3095),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3096),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3096),
    [sym_false] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5520),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(5519),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(8665),
    [sym__splat_star] = ACTIONS(8667),
    [sym__unary_minus] = ACTIONS(5149),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(8669),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_EQ] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5153),
    [anon_sym_yield] = ACTIONS(5155),
    [anon_sym_break] = ACTIONS(5157),
    [anon_sym_next] = ACTIONS(5159),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_then] = ACTIONS(419),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(417),
    [anon_sym_DASH_EQ] = ACTIONS(417),
    [anon_sym_STAR_EQ] = ACTIONS(417),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(417),
    [anon_sym_SLASH_EQ] = ACTIONS(417),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(417),
    [anon_sym_PIPE_EQ] = ACTIONS(417),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(417),
    [anon_sym_AMP_EQ] = ACTIONS(417),
    [anon_sym_PERCENT_EQ] = ACTIONS(417),
    [anon_sym_GT_GT_EQ] = ACTIONS(417),
    [anon_sym_LT_LT_EQ] = ACTIONS(417),
    [anon_sym_CARET_EQ] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(5161),
    [anon_sym_not] = ACTIONS(5163),
    [anon_sym_BANG] = ACTIONS(5165),
    [anon_sym_TILDE] = ACTIONS(5167),
    [sym_constant] = ACTIONS(8671),
    [sym_identifier] = ACTIONS(8671),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7950] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5517),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3096),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(3096),
    [sym_argument_list] = STATE(3612),
    [sym__argument_list_with_parens] = STATE(5518),
    [sym__argument] = STATE(5519),
    [sym_splat_argument] = STATE(5519),
    [sym_hash_splat_argument] = STATE(5519),
    [sym_block_argument] = STATE(5519),
    [sym_assignment] = STATE(5517),
    [sym_operator_assignment] = STATE(5517),
    [sym_conditional] = STATE(5517),
    [sym_range] = STATE(5517),
    [sym_binary] = STATE(5517),
    [sym_unary] = STATE(5517),
    [sym_left_assignment_list] = STATE(3095),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3096),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3096),
    [sym_false] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5520),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(5519),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(8665),
    [sym__splat_star] = ACTIONS(8667),
    [sym__unary_minus] = ACTIONS(5149),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(8669),
    [anon_sym_LBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_EQ] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5153),
    [anon_sym_yield] = ACTIONS(5155),
    [anon_sym_break] = ACTIONS(5157),
    [anon_sym_next] = ACTIONS(5159),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_then] = ACTIONS(423),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(421),
    [anon_sym_DASH_EQ] = ACTIONS(421),
    [anon_sym_STAR_EQ] = ACTIONS(421),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(421),
    [anon_sym_SLASH_EQ] = ACTIONS(421),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(421),
    [anon_sym_PIPE_EQ] = ACTIONS(421),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(421),
    [anon_sym_AMP_EQ] = ACTIONS(421),
    [anon_sym_PERCENT_EQ] = ACTIONS(421),
    [anon_sym_GT_GT_EQ] = ACTIONS(421),
    [anon_sym_LT_LT_EQ] = ACTIONS(421),
    [anon_sym_CARET_EQ] = ACTIONS(421),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(5161),
    [anon_sym_not] = ACTIONS(5163),
    [anon_sym_BANG] = ACTIONS(5165),
    [anon_sym_TILDE] = ACTIONS(5167),
    [sym_constant] = ACTIONS(8671),
    [sym_identifier] = ACTIONS(8671),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7951] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5517),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3096),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(3096),
    [sym_argument_list] = STATE(3613),
    [sym__argument_list_with_parens] = STATE(5518),
    [sym__argument] = STATE(5519),
    [sym_splat_argument] = STATE(5519),
    [sym_hash_splat_argument] = STATE(5519),
    [sym_block_argument] = STATE(5519),
    [sym_assignment] = STATE(5517),
    [sym_operator_assignment] = STATE(5517),
    [sym_conditional] = STATE(5517),
    [sym_range] = STATE(5517),
    [sym_binary] = STATE(5517),
    [sym_unary] = STATE(5517),
    [sym_left_assignment_list] = STATE(3095),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3096),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3096),
    [sym_false] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5520),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(5519),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(8665),
    [sym__splat_star] = ACTIONS(8667),
    [sym__unary_minus] = ACTIONS(5149),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(8669),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(427),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5153),
    [anon_sym_yield] = ACTIONS(5155),
    [anon_sym_break] = ACTIONS(5157),
    [anon_sym_next] = ACTIONS(5159),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_then] = ACTIONS(427),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(425),
    [anon_sym_DASH_EQ] = ACTIONS(425),
    [anon_sym_STAR_EQ] = ACTIONS(425),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(425),
    [anon_sym_SLASH_EQ] = ACTIONS(425),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(425),
    [anon_sym_PIPE_EQ] = ACTIONS(425),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(425),
    [anon_sym_AMP_EQ] = ACTIONS(425),
    [anon_sym_PERCENT_EQ] = ACTIONS(425),
    [anon_sym_GT_GT_EQ] = ACTIONS(425),
    [anon_sym_LT_LT_EQ] = ACTIONS(425),
    [anon_sym_CARET_EQ] = ACTIONS(425),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(5161),
    [anon_sym_not] = ACTIONS(5163),
    [anon_sym_BANG] = ACTIONS(5165),
    [anon_sym_TILDE] = ACTIONS(5167),
    [sym_constant] = ACTIONS(8671),
    [sym_identifier] = ACTIONS(8671),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7952] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(9638),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7957),
    [sym_scope_resolution] = STATE(7955),
    [sym_call] = STATE(7955),
    [sym_method_call] = STATE(7957),
    [sym_assignment] = STATE(9638),
    [sym_operator_assignment] = STATE(9638),
    [sym_conditional] = STATE(9638),
    [sym_range] = STATE(9638),
    [sym_binary] = STATE(9638),
    [sym_unary] = STATE(9638),
    [sym_left_assignment_list] = STATE(7956),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7957),
    [sym__variable] = STATE(7955),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7957),
    [sym_false] = STATE(7957),
    [sym_nil] = STATE(7957),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7958),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11460),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11462),
    [anon_sym_yield] = ACTIONS(11464),
    [anon_sym_break] = ACTIONS(11466),
    [anon_sym_next] = ACTIONS(11468),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11470),
    [anon_sym_defined_QMARK] = ACTIONS(11472),
    [anon_sym_not] = ACTIONS(11474),
    [anon_sym_BANG] = ACTIONS(11476),
    [anon_sym_TILDE] = ACTIONS(11476),
    [sym_constant] = ACTIONS(11478),
    [sym_identifier] = ACTIONS(11478),
    [sym_instance_variable] = ACTIONS(11480),
    [sym_class_variable] = ACTIONS(11480),
    [sym_global_variable] = ACTIONS(11480),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11478),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11478),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [7953] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(3628),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7957),
    [sym_scope_resolution] = STATE(7955),
    [sym_call] = STATE(7955),
    [sym_method_call] = STATE(7957),
    [sym_assignment] = STATE(3628),
    [sym_operator_assignment] = STATE(3628),
    [sym_conditional] = STATE(3628),
    [sym_range] = STATE(3628),
    [sym_binary] = STATE(3628),
    [sym_unary] = STATE(3628),
    [sym_left_assignment_list] = STATE(7956),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7957),
    [sym__variable] = STATE(7955),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7957),
    [sym_false] = STATE(7957),
    [sym_nil] = STATE(7957),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7958),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11460),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11462),
    [anon_sym_yield] = ACTIONS(11464),
    [anon_sym_break] = ACTIONS(11466),
    [anon_sym_next] = ACTIONS(11468),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11470),
    [anon_sym_defined_QMARK] = ACTIONS(11472),
    [anon_sym_not] = ACTIONS(11474),
    [anon_sym_BANG] = ACTIONS(11476),
    [anon_sym_TILDE] = ACTIONS(11476),
    [sym_constant] = ACTIONS(11478),
    [sym_identifier] = ACTIONS(11478),
    [sym_instance_variable] = ACTIONS(11480),
    [sym_class_variable] = ACTIONS(11480),
    [sym_global_variable] = ACTIONS(11480),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11478),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11478),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [7954] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(13397),
    [sym__binary_star] = ACTIONS(13399),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(13401),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(13403),
    [anon_sym_AMP] = ACTIONS(13405),
    [anon_sym_EQ] = ACTIONS(4217),
    [anon_sym_LT] = ACTIONS(13407),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_then] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_PLUS_EQ] = ACTIONS(4211),
    [anon_sym_DASH_EQ] = ACTIONS(4211),
    [anon_sym_STAR_EQ] = ACTIONS(4211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4211),
    [anon_sym_SLASH_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4211),
    [anon_sym_AMP_EQ] = ACTIONS(4211),
    [anon_sym_PERCENT_EQ] = ACTIONS(4211),
    [anon_sym_GT_GT_EQ] = ACTIONS(4211),
    [anon_sym_LT_LT_EQ] = ACTIONS(4211),
    [anon_sym_CARET_EQ] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(13409),
    [anon_sym_DOT_DOT] = ACTIONS(13411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13413),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(13415),
    [anon_sym_AMP_AMP] = ACTIONS(13415),
    [anon_sym_LT_LT] = ACTIONS(13417),
    [anon_sym_GT_GT] = ACTIONS(13417),
    [anon_sym_EQ_EQ] = ACTIONS(13415),
    [anon_sym_BANG_EQ] = ACTIONS(13419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13419),
    [anon_sym_LT_EQ_GT] = ACTIONS(13419),
    [anon_sym_EQ_TILDE] = ACTIONS(13419),
    [anon_sym_BANG_TILDE] = ACTIONS(13419),
    [anon_sym_LT_EQ] = ACTIONS(13407),
    [anon_sym_GT] = ACTIONS(13407),
    [anon_sym_GT_EQ] = ACTIONS(13421),
    [anon_sym_CARET] = ACTIONS(13401),
    [anon_sym_PLUS] = ACTIONS(13423),
    [anon_sym_SLASH] = ACTIONS(13403),
    [anon_sym_PERCENT] = ACTIONS(13403),
    [sym_comment] = ACTIONS(87),
  },
  [7955] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5517),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3096),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(3096),
    [sym_argument_list] = STATE(1062),
    [sym__argument_list_with_parens] = STATE(5518),
    [sym__argument] = STATE(5519),
    [sym_splat_argument] = STATE(5519),
    [sym_hash_splat_argument] = STATE(5519),
    [sym_block_argument] = STATE(5519),
    [sym_do_block] = STATE(426),
    [sym_block] = STATE(426),
    [sym_assignment] = STATE(5517),
    [sym_operator_assignment] = STATE(5517),
    [sym_conditional] = STATE(5517),
    [sym_range] = STATE(5517),
    [sym_binary] = STATE(5517),
    [sym_unary] = STATE(5517),
    [sym_left_assignment_list] = STATE(3095),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3096),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3096),
    [sym_false] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5520),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(5519),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(743),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(8665),
    [sym__splat_star] = ACTIONS(8667),
    [sym__unary_minus] = ACTIONS(5149),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(8669),
    [anon_sym_LBRACE] = ACTIONS(6047),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5153),
    [anon_sym_yield] = ACTIONS(5155),
    [anon_sym_break] = ACTIONS(5157),
    [anon_sym_next] = ACTIONS(5159),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(769),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_then] = ACTIONS(769),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(5161),
    [anon_sym_not] = ACTIONS(5163),
    [anon_sym_BANG] = ACTIONS(5165),
    [anon_sym_TILDE] = ACTIONS(5167),
    [sym_constant] = ACTIONS(8671),
    [sym_identifier] = ACTIONS(8671),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7956] = {
    [anon_sym_EQ] = ACTIONS(13425),
    [sym_comment] = ACTIONS(87),
  },
  [7957] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(13427),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(13429),
    [anon_sym_DASH_EQ] = ACTIONS(13429),
    [anon_sym_STAR_EQ] = ACTIONS(13429),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13429),
    [anon_sym_SLASH_EQ] = ACTIONS(13429),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13429),
    [anon_sym_PIPE_EQ] = ACTIONS(13429),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13429),
    [anon_sym_AMP_EQ] = ACTIONS(13429),
    [anon_sym_PERCENT_EQ] = ACTIONS(13429),
    [anon_sym_GT_GT_EQ] = ACTIONS(13429),
    [anon_sym_LT_LT_EQ] = ACTIONS(13429),
    [anon_sym_CARET_EQ] = ACTIONS(13429),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [7958] = {
    [sym_string] = STATE(9651),
    [aux_sym_chained_string_repeat1] = STATE(9651),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(2551),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [7959] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(13397),
    [sym__binary_star] = ACTIONS(13399),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(13401),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(13403),
    [anon_sym_AMP] = ACTIONS(13405),
    [anon_sym_EQ] = ACTIONS(4249),
    [anon_sym_LT] = ACTIONS(13407),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_then] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_PLUS_EQ] = ACTIONS(4247),
    [anon_sym_DASH_EQ] = ACTIONS(4247),
    [anon_sym_STAR_EQ] = ACTIONS(4247),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4247),
    [anon_sym_SLASH_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4247),
    [anon_sym_AMP_EQ] = ACTIONS(4247),
    [anon_sym_PERCENT_EQ] = ACTIONS(4247),
    [anon_sym_GT_GT_EQ] = ACTIONS(4247),
    [anon_sym_LT_LT_EQ] = ACTIONS(4247),
    [anon_sym_CARET_EQ] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(13409),
    [anon_sym_DOT_DOT] = ACTIONS(13411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13413),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(13415),
    [anon_sym_AMP_AMP] = ACTIONS(13415),
    [anon_sym_LT_LT] = ACTIONS(13417),
    [anon_sym_GT_GT] = ACTIONS(13417),
    [anon_sym_EQ_EQ] = ACTIONS(13415),
    [anon_sym_BANG_EQ] = ACTIONS(13419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13419),
    [anon_sym_LT_EQ_GT] = ACTIONS(13419),
    [anon_sym_EQ_TILDE] = ACTIONS(13419),
    [anon_sym_BANG_TILDE] = ACTIONS(13419),
    [anon_sym_LT_EQ] = ACTIONS(13407),
    [anon_sym_GT] = ACTIONS(13407),
    [anon_sym_GT_EQ] = ACTIONS(13421),
    [anon_sym_CARET] = ACTIONS(13401),
    [anon_sym_PLUS] = ACTIONS(13423),
    [anon_sym_SLASH] = ACTIONS(13403),
    [anon_sym_PERCENT] = ACTIONS(13403),
    [sym_comment] = ACTIONS(87),
  },
  [7960] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(9652),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7957),
    [sym_scope_resolution] = STATE(7955),
    [sym_call] = STATE(7955),
    [sym_method_call] = STATE(7957),
    [sym_assignment] = STATE(9652),
    [sym_operator_assignment] = STATE(9652),
    [sym_conditional] = STATE(9652),
    [sym_range] = STATE(9652),
    [sym_binary] = STATE(9652),
    [sym_unary] = STATE(9652),
    [sym_left_assignment_list] = STATE(7956),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7957),
    [sym__variable] = STATE(7955),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7957),
    [sym_false] = STATE(7957),
    [sym_nil] = STATE(7957),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7958),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11460),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11462),
    [anon_sym_yield] = ACTIONS(11464),
    [anon_sym_break] = ACTIONS(11466),
    [anon_sym_next] = ACTIONS(11468),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11470),
    [anon_sym_defined_QMARK] = ACTIONS(11472),
    [anon_sym_not] = ACTIONS(11474),
    [anon_sym_BANG] = ACTIONS(11476),
    [anon_sym_TILDE] = ACTIONS(11476),
    [sym_constant] = ACTIONS(11478),
    [sym_identifier] = ACTIONS(11478),
    [sym_instance_variable] = ACTIONS(11480),
    [sym_class_variable] = ACTIONS(11480),
    [sym_global_variable] = ACTIONS(11480),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11478),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11478),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [7961] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(13397),
    [sym__binary_star] = ACTIONS(13399),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(13401),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(13403),
    [anon_sym_AMP] = ACTIONS(13405),
    [anon_sym_EQ] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(13407),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_then] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_PLUS_EQ] = ACTIONS(3281),
    [anon_sym_DASH_EQ] = ACTIONS(3281),
    [anon_sym_STAR_EQ] = ACTIONS(3281),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3281),
    [anon_sym_SLASH_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3281),
    [anon_sym_AMP_EQ] = ACTIONS(3281),
    [anon_sym_PERCENT_EQ] = ACTIONS(3281),
    [anon_sym_GT_GT_EQ] = ACTIONS(3281),
    [anon_sym_LT_LT_EQ] = ACTIONS(3281),
    [anon_sym_CARET_EQ] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(13409),
    [anon_sym_DOT_DOT] = ACTIONS(13411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13413),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(13415),
    [anon_sym_AMP_AMP] = ACTIONS(13415),
    [anon_sym_LT_LT] = ACTIONS(13417),
    [anon_sym_GT_GT] = ACTIONS(13417),
    [anon_sym_EQ_EQ] = ACTIONS(13415),
    [anon_sym_BANG_EQ] = ACTIONS(13419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13419),
    [anon_sym_LT_EQ_GT] = ACTIONS(13419),
    [anon_sym_EQ_TILDE] = ACTIONS(13419),
    [anon_sym_BANG_TILDE] = ACTIONS(13419),
    [anon_sym_LT_EQ] = ACTIONS(13407),
    [anon_sym_GT] = ACTIONS(13407),
    [anon_sym_GT_EQ] = ACTIONS(13421),
    [anon_sym_CARET] = ACTIONS(13401),
    [anon_sym_PLUS] = ACTIONS(13423),
    [anon_sym_SLASH] = ACTIONS(13403),
    [anon_sym_PERCENT] = ACTIONS(13403),
    [sym_comment] = ACTIONS(87),
  },
  [7962] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(9653),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7957),
    [sym_scope_resolution] = STATE(7955),
    [sym_call] = STATE(7955),
    [sym_method_call] = STATE(7957),
    [sym_assignment] = STATE(9653),
    [sym_operator_assignment] = STATE(9653),
    [sym_conditional] = STATE(9653),
    [sym_range] = STATE(9653),
    [sym_binary] = STATE(9653),
    [sym_unary] = STATE(9653),
    [sym_left_assignment_list] = STATE(7956),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7957),
    [sym__variable] = STATE(7955),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7957),
    [sym_false] = STATE(7957),
    [sym_nil] = STATE(7957),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7958),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11460),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11462),
    [anon_sym_yield] = ACTIONS(11464),
    [anon_sym_break] = ACTIONS(11466),
    [anon_sym_next] = ACTIONS(11468),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11470),
    [anon_sym_defined_QMARK] = ACTIONS(11472),
    [anon_sym_not] = ACTIONS(11474),
    [anon_sym_BANG] = ACTIONS(11476),
    [anon_sym_TILDE] = ACTIONS(11476),
    [sym_constant] = ACTIONS(11478),
    [sym_identifier] = ACTIONS(11478),
    [sym_instance_variable] = ACTIONS(11480),
    [sym_class_variable] = ACTIONS(11480),
    [sym_global_variable] = ACTIONS(11480),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11478),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11478),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [7963] = {
    [sym_heredoc_body] = STATE(9654),
    [aux_sym_call_repeat1] = STATE(9654),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_then] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [7964] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5517),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3096),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(3096),
    [sym__argument] = STATE(3737),
    [sym_splat_argument] = STATE(3737),
    [sym_hash_splat_argument] = STATE(3737),
    [sym_block_argument] = STATE(3737),
    [sym_assignment] = STATE(5517),
    [sym_operator_assignment] = STATE(5517),
    [sym_conditional] = STATE(5517),
    [sym_range] = STATE(5517),
    [sym_binary] = STATE(5517),
    [sym_unary] = STATE(5517),
    [sym_left_assignment_list] = STATE(3095),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3096),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3096),
    [sym_false] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5520),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_heredoc_body] = STATE(9655),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(3737),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(8665),
    [sym__splat_star] = ACTIONS(8667),
    [sym__unary_minus] = ACTIONS(5149),
    [sym__identifier_hash_key] = ACTIONS(8669),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13431),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5153),
    [anon_sym_yield] = ACTIONS(5155),
    [anon_sym_break] = ACTIONS(5157),
    [anon_sym_next] = ACTIONS(5159),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(8827),
    [anon_sym_defined_QMARK] = ACTIONS(5161),
    [anon_sym_not] = ACTIONS(5163),
    [anon_sym_BANG] = ACTIONS(5167),
    [anon_sym_TILDE] = ACTIONS(5167),
    [sym_constant] = ACTIONS(8671),
    [sym_identifier] = ACTIONS(8671),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7965] = {
    [sym_heredoc_body] = STATE(9656),
    [aux_sym_call_repeat1] = STATE(9656),
    [aux_sym_argument_list_repeat1] = STATE(9657),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(11486),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_then] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [7966] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9658),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2984),
    [sym_scope_resolution] = STATE(2981),
    [sym_call] = STATE(2981),
    [sym_method_call] = STATE(2984),
    [sym_assignment] = STATE(9658),
    [sym_operator_assignment] = STATE(9658),
    [sym_conditional] = STATE(9658),
    [sym_range] = STATE(9658),
    [sym_binary] = STATE(9658),
    [sym_unary] = STATE(9658),
    [sym_left_assignment_list] = STATE(2983),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2984),
    [sym__variable] = STATE(2981),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2984),
    [sym_false] = STATE(2984),
    [sym_nil] = STATE(2984),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2985),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4971),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4973),
    [anon_sym_yield] = ACTIONS(4975),
    [anon_sym_break] = ACTIONS(4977),
    [anon_sym_next] = ACTIONS(4979),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4981),
    [anon_sym_defined_QMARK] = ACTIONS(4983),
    [anon_sym_not] = ACTIONS(4985),
    [anon_sym_BANG] = ACTIONS(4987),
    [anon_sym_TILDE] = ACTIONS(4987),
    [sym_constant] = ACTIONS(4989),
    [sym_identifier] = ACTIONS(4989),
    [sym_instance_variable] = ACTIONS(4991),
    [sym_class_variable] = ACTIONS(4991),
    [sym_global_variable] = ACTIONS(4991),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4989),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4989),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7967] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(8637),
    [sym__binary_star] = ACTIONS(8639),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(8641),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(8639),
    [anon_sym_AMP] = ACTIONS(8643),
    [anon_sym_LT] = ACTIONS(8645),
    [anon_sym_then] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(8647),
    [anon_sym_DOT_DOT] = ACTIONS(8649),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8651),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(8655),
    [anon_sym_AMP_AMP] = ACTIONS(8655),
    [anon_sym_LT_LT] = ACTIONS(8657),
    [anon_sym_GT_GT] = ACTIONS(8657),
    [anon_sym_EQ_EQ] = ACTIONS(8659),
    [anon_sym_BANG_EQ] = ACTIONS(8655),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8655),
    [anon_sym_LT_EQ_GT] = ACTIONS(8655),
    [anon_sym_EQ_TILDE] = ACTIONS(8655),
    [anon_sym_BANG_TILDE] = ACTIONS(8655),
    [anon_sym_LT_EQ] = ACTIONS(8645),
    [anon_sym_GT] = ACTIONS(8645),
    [anon_sym_GT_EQ] = ACTIONS(8661),
    [anon_sym_CARET] = ACTIONS(8663),
    [anon_sym_PLUS] = ACTIONS(8637),
    [anon_sym_SLASH] = ACTIONS(8639),
    [anon_sym_PERCENT] = ACTIONS(8639),
    [sym_comment] = ACTIONS(87),
  },
  [7968] = {
    [aux_sym_exceptions_repeat1] = STATE(9660),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_then] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [7969] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(8637),
    [sym__binary_star] = ACTIONS(8639),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(8641),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(8639),
    [anon_sym_AMP] = ACTIONS(8643),
    [anon_sym_LT] = ACTIONS(8645),
    [anon_sym_then] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(8647),
    [anon_sym_DOT_DOT] = ACTIONS(8649),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8651),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(8655),
    [anon_sym_AMP_AMP] = ACTIONS(8655),
    [anon_sym_LT_LT] = ACTIONS(8657),
    [anon_sym_GT_GT] = ACTIONS(8657),
    [anon_sym_EQ_EQ] = ACTIONS(8659),
    [anon_sym_BANG_EQ] = ACTIONS(8655),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8655),
    [anon_sym_LT_EQ_GT] = ACTIONS(8655),
    [anon_sym_EQ_TILDE] = ACTIONS(8655),
    [anon_sym_BANG_TILDE] = ACTIONS(8655),
    [anon_sym_LT_EQ] = ACTIONS(8645),
    [anon_sym_GT] = ACTIONS(8645),
    [anon_sym_GT_EQ] = ACTIONS(8661),
    [anon_sym_CARET] = ACTIONS(8663),
    [anon_sym_PLUS] = ACTIONS(8637),
    [anon_sym_SLASH] = ACTIONS(8639),
    [anon_sym_PERCENT] = ACTIONS(8639),
    [sym_comment] = ACTIONS(87),
  },
  [7970] = {
    [sym_string] = STATE(7970),
    [aux_sym_chained_string_repeat1] = STATE(7970),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(6214),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_then] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [7971] = {
    [sym_heredoc_body] = STATE(9661),
    [aux_sym_call_repeat1] = STATE(9661),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_else] = ACTIONS(4383),
    [anon_sym_ensure] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [7972] = {
    [sym_heredoc_body] = STATE(9662),
    [aux_sym_call_repeat1] = STATE(9662),
    [aux_sym_argument_list_repeat1] = STATE(5572),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(5067),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_else] = ACTIONS(4383),
    [anon_sym_ensure] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [7973] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(8693),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8693),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(8693),
    [anon_sym_PERCENT] = ACTIONS(8693),
    [sym_comment] = ACTIONS(87),
  },
  [7974] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8693),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [7975] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8691),
    [sym__binary_star] = ACTIONS(8693),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8693),
    [anon_sym_AMP] = ACTIONS(8697),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(8709),
    [anon_sym_GT_GT] = ACTIONS(8709),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(8691),
    [anon_sym_SLASH] = ACTIONS(8693),
    [anon_sym_PERCENT] = ACTIONS(8693),
    [sym_comment] = ACTIONS(87),
  },
  [7976] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8691),
    [sym__binary_star] = ACTIONS(8693),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8693),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(8709),
    [anon_sym_GT_GT] = ACTIONS(8709),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(8691),
    [anon_sym_SLASH] = ACTIONS(8693),
    [anon_sym_PERCENT] = ACTIONS(8693),
    [sym_comment] = ACTIONS(87),
  },
  [7977] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8691),
    [sym__binary_star] = ACTIONS(8693),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(8695),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8693),
    [anon_sym_AMP] = ACTIONS(8697),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(8709),
    [anon_sym_GT_GT] = ACTIONS(8709),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(8715),
    [anon_sym_PLUS] = ACTIONS(8691),
    [anon_sym_SLASH] = ACTIONS(8693),
    [anon_sym_PERCENT] = ACTIONS(8693),
    [sym_comment] = ACTIONS(87),
  },
  [7978] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(13433),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [7979] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(8691),
    [sym__binary_star] = ACTIONS(8693),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(8695),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(8693),
    [anon_sym_AMP] = ACTIONS(8697),
    [anon_sym_LT] = ACTIONS(8699),
    [anon_sym_end] = ACTIONS(5927),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_else] = ACTIONS(5927),
    [anon_sym_ensure] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(8703),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8705),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(8707),
    [anon_sym_AMP_AMP] = ACTIONS(8707),
    [anon_sym_LT_LT] = ACTIONS(8709),
    [anon_sym_GT_GT] = ACTIONS(8709),
    [anon_sym_EQ_EQ] = ACTIONS(8711),
    [anon_sym_BANG_EQ] = ACTIONS(8707),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8707),
    [anon_sym_LT_EQ_GT] = ACTIONS(8707),
    [anon_sym_EQ_TILDE] = ACTIONS(8707),
    [anon_sym_BANG_TILDE] = ACTIONS(8707),
    [anon_sym_LT_EQ] = ACTIONS(8699),
    [anon_sym_GT] = ACTIONS(8699),
    [anon_sym_GT_EQ] = ACTIONS(8713),
    [anon_sym_CARET] = ACTIONS(8715),
    [anon_sym_PLUS] = ACTIONS(8691),
    [anon_sym_SLASH] = ACTIONS(8693),
    [anon_sym_PERCENT] = ACTIONS(8693),
    [sym_comment] = ACTIONS(87),
  },
  [7980] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8691),
    [sym__binary_star] = ACTIONS(8693),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(8695),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8693),
    [anon_sym_AMP] = ACTIONS(8697),
    [anon_sym_LT] = ACTIONS(8699),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(8701),
    [anon_sym_DOT_DOT] = ACTIONS(8703),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8705),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(8707),
    [anon_sym_AMP_AMP] = ACTIONS(8707),
    [anon_sym_LT_LT] = ACTIONS(8709),
    [anon_sym_GT_GT] = ACTIONS(8709),
    [anon_sym_EQ_EQ] = ACTIONS(8711),
    [anon_sym_BANG_EQ] = ACTIONS(8707),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8707),
    [anon_sym_LT_EQ_GT] = ACTIONS(8707),
    [anon_sym_EQ_TILDE] = ACTIONS(8707),
    [anon_sym_BANG_TILDE] = ACTIONS(8707),
    [anon_sym_LT_EQ] = ACTIONS(8699),
    [anon_sym_GT] = ACTIONS(8699),
    [anon_sym_GT_EQ] = ACTIONS(8713),
    [anon_sym_CARET] = ACTIONS(8715),
    [anon_sym_PLUS] = ACTIONS(8691),
    [anon_sym_SLASH] = ACTIONS(8693),
    [anon_sym_PERCENT] = ACTIONS(8693),
    [sym_comment] = ACTIONS(87),
  },
  [7981] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8691),
    [sym__binary_star] = ACTIONS(8693),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(8695),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8693),
    [anon_sym_AMP] = ACTIONS(8697),
    [anon_sym_LT] = ACTIONS(8699),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(8709),
    [anon_sym_GT_GT] = ACTIONS(8709),
    [anon_sym_EQ_EQ] = ACTIONS(8711),
    [anon_sym_BANG_EQ] = ACTIONS(8707),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8707),
    [anon_sym_LT_EQ_GT] = ACTIONS(8707),
    [anon_sym_EQ_TILDE] = ACTIONS(8707),
    [anon_sym_BANG_TILDE] = ACTIONS(8707),
    [anon_sym_LT_EQ] = ACTIONS(8699),
    [anon_sym_GT] = ACTIONS(8699),
    [anon_sym_GT_EQ] = ACTIONS(8713),
    [anon_sym_CARET] = ACTIONS(8715),
    [anon_sym_PLUS] = ACTIONS(8691),
    [anon_sym_SLASH] = ACTIONS(8693),
    [anon_sym_PERCENT] = ACTIONS(8693),
    [sym_comment] = ACTIONS(87),
  },
  [7982] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8691),
    [sym__binary_star] = ACTIONS(8693),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8693),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(8691),
    [anon_sym_SLASH] = ACTIONS(8693),
    [anon_sym_PERCENT] = ACTIONS(8693),
    [sym_comment] = ACTIONS(87),
  },
  [7983] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(8691),
    [sym__binary_star] = ACTIONS(8693),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(8695),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(8693),
    [anon_sym_AMP] = ACTIONS(8697),
    [anon_sym_LT] = ACTIONS(8699),
    [anon_sym_end] = ACTIONS(5115),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_else] = ACTIONS(5115),
    [anon_sym_ensure] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(8701),
    [anon_sym_DOT_DOT] = ACTIONS(8703),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8705),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(8707),
    [anon_sym_AMP_AMP] = ACTIONS(8707),
    [anon_sym_LT_LT] = ACTIONS(8709),
    [anon_sym_GT_GT] = ACTIONS(8709),
    [anon_sym_EQ_EQ] = ACTIONS(8711),
    [anon_sym_BANG_EQ] = ACTIONS(8707),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8707),
    [anon_sym_LT_EQ_GT] = ACTIONS(8707),
    [anon_sym_EQ_TILDE] = ACTIONS(8707),
    [anon_sym_BANG_TILDE] = ACTIONS(8707),
    [anon_sym_LT_EQ] = ACTIONS(8699),
    [anon_sym_GT] = ACTIONS(8699),
    [anon_sym_GT_EQ] = ACTIONS(8713),
    [anon_sym_CARET] = ACTIONS(8715),
    [anon_sym_PLUS] = ACTIONS(8691),
    [anon_sym_SLASH] = ACTIONS(8693),
    [anon_sym_PERCENT] = ACTIONS(8693),
    [sym_comment] = ACTIONS(87),
  },
  [7984] = {
    [aux_sym_exceptions_repeat1] = STATE(9665),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_end] = ACTIONS(6191),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_else] = ACTIONS(6191),
    [anon_sym_ensure] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [7985] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(8691),
    [sym__binary_star] = ACTIONS(8693),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(8695),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(8693),
    [anon_sym_AMP] = ACTIONS(8697),
    [anon_sym_LT] = ACTIONS(8699),
    [anon_sym_end] = ACTIONS(6210),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_else] = ACTIONS(6210),
    [anon_sym_ensure] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(8701),
    [anon_sym_DOT_DOT] = ACTIONS(8703),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8705),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(8707),
    [anon_sym_AMP_AMP] = ACTIONS(8707),
    [anon_sym_LT_LT] = ACTIONS(8709),
    [anon_sym_GT_GT] = ACTIONS(8709),
    [anon_sym_EQ_EQ] = ACTIONS(8711),
    [anon_sym_BANG_EQ] = ACTIONS(8707),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8707),
    [anon_sym_LT_EQ_GT] = ACTIONS(8707),
    [anon_sym_EQ_TILDE] = ACTIONS(8707),
    [anon_sym_BANG_TILDE] = ACTIONS(8707),
    [anon_sym_LT_EQ] = ACTIONS(8699),
    [anon_sym_GT] = ACTIONS(8699),
    [anon_sym_GT_EQ] = ACTIONS(8713),
    [anon_sym_CARET] = ACTIONS(8715),
    [anon_sym_PLUS] = ACTIONS(8691),
    [anon_sym_SLASH] = ACTIONS(8693),
    [anon_sym_PERCENT] = ACTIONS(8693),
    [sym_comment] = ACTIONS(87),
  },
  [7986] = {
    [sym_string] = STATE(7986),
    [aux_sym_chained_string_repeat1] = STATE(7986),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(6214),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_end] = ACTIONS(6212),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_else] = ACTIONS(6212),
    [anon_sym_ensure] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [7987] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(5033),
    [sym__binary_star] = ACTIONS(5035),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(5037),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(5035),
    [anon_sym_AMP] = ACTIONS(5039),
    [anon_sym_LT] = ACTIONS(5041),
    [anon_sym_end] = ACTIONS(6823),
    [anon_sym_if] = ACTIONS(6823),
    [anon_sym_unless] = ACTIONS(6823),
    [anon_sym_while] = ACTIONS(6823),
    [anon_sym_until] = ACTIONS(6823),
    [anon_sym_rescue] = ACTIONS(6823),
    [anon_sym_else] = ACTIONS(6823),
    [anon_sym_ensure] = ACTIONS(6823),
    [anon_sym_EQ_GT] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(5043),
    [anon_sym_DOT_DOT] = ACTIONS(5045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5047),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(5049),
    [anon_sym_AMP_AMP] = ACTIONS(5049),
    [anon_sym_LT_LT] = ACTIONS(5051),
    [anon_sym_GT_GT] = ACTIONS(5051),
    [anon_sym_EQ_EQ] = ACTIONS(5053),
    [anon_sym_BANG_EQ] = ACTIONS(5049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5049),
    [anon_sym_LT_EQ_GT] = ACTIONS(5049),
    [anon_sym_EQ_TILDE] = ACTIONS(5049),
    [anon_sym_BANG_TILDE] = ACTIONS(5049),
    [anon_sym_LT_EQ] = ACTIONS(5041),
    [anon_sym_GT] = ACTIONS(5041),
    [anon_sym_GT_EQ] = ACTIONS(5055),
    [anon_sym_CARET] = ACTIONS(5057),
    [anon_sym_PLUS] = ACTIONS(5033),
    [anon_sym_SLASH] = ACTIONS(5035),
    [anon_sym_PERCENT] = ACTIONS(5035),
    [sym_comment] = ACTIONS(87),
  },
  [7988] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(5033),
    [sym__binary_star] = ACTIONS(5035),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(5037),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(5035),
    [anon_sym_AMP] = ACTIONS(5039),
    [anon_sym_LT] = ACTIONS(5041),
    [anon_sym_end] = ACTIONS(7027),
    [anon_sym_if] = ACTIONS(7027),
    [anon_sym_unless] = ACTIONS(7027),
    [anon_sym_while] = ACTIONS(7027),
    [anon_sym_until] = ACTIONS(7027),
    [anon_sym_rescue] = ACTIONS(7027),
    [anon_sym_else] = ACTIONS(7027),
    [anon_sym_ensure] = ACTIONS(7027),
    [anon_sym_EQ_GT] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(5043),
    [anon_sym_DOT_DOT] = ACTIONS(5045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5047),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(5049),
    [anon_sym_AMP_AMP] = ACTIONS(5049),
    [anon_sym_LT_LT] = ACTIONS(5051),
    [anon_sym_GT_GT] = ACTIONS(5051),
    [anon_sym_EQ_EQ] = ACTIONS(5053),
    [anon_sym_BANG_EQ] = ACTIONS(5049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5049),
    [anon_sym_LT_EQ_GT] = ACTIONS(5049),
    [anon_sym_EQ_TILDE] = ACTIONS(5049),
    [anon_sym_BANG_TILDE] = ACTIONS(5049),
    [anon_sym_LT_EQ] = ACTIONS(5041),
    [anon_sym_GT] = ACTIONS(5041),
    [anon_sym_GT_EQ] = ACTIONS(5055),
    [anon_sym_CARET] = ACTIONS(5057),
    [anon_sym_PLUS] = ACTIONS(5033),
    [anon_sym_SLASH] = ACTIONS(5035),
    [anon_sym_PERCENT] = ACTIONS(5035),
    [sym_comment] = ACTIONS(87),
  },
  [7989] = {
    [sym_heredoc_body] = STATE(7989),
    [aux_sym_call_repeat1] = STATE(7989),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(7916),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_end] = ACTIONS(7914),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_else] = ACTIONS(7914),
    [anon_sym_ensure] = ACTIONS(7914),
    [anon_sym_EQ_GT] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [7990] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3011),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1156),
    [sym_scope_resolution] = STATE(1152),
    [sym_call] = STATE(1152),
    [sym_method_call] = STATE(1156),
    [sym__argument] = STATE(4986),
    [sym_splat_argument] = STATE(4986),
    [sym_hash_splat_argument] = STATE(4986),
    [sym_block_argument] = STATE(4986),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_left_assignment_list] = STATE(1155),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1156),
    [sym__variable] = STATE(1152),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1156),
    [sym_false] = STATE(1156),
    [sym_nil] = STATE(1156),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3014),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4986),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(5023),
    [sym__splat_star] = ACTIONS(5025),
    [sym__unary_minus] = ACTIONS(2051),
    [sym__identifier_hash_key] = ACTIONS(5027),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11492),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2055),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2059),
    [anon_sym_next] = ACTIONS(2061),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5019),
    [anon_sym_defined_QMARK] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [anon_sym_BANG] = ACTIONS(2069),
    [anon_sym_TILDE] = ACTIONS(2069),
    [sym_constant] = ACTIONS(5029),
    [sym_identifier] = ACTIONS(5029),
    [sym_instance_variable] = ACTIONS(2073),
    [sym_class_variable] = ACTIONS(2073),
    [sym_global_variable] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2075),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7991] = {
    [sym_heredoc_body] = STATE(7989),
    [aux_sym_call_repeat1] = STATE(7989),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_end] = ACTIONS(7929),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_else] = ACTIONS(7929),
    [anon_sym_ensure] = ACTIONS(7929),
    [anon_sym_EQ_GT] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [7992] = {
    [aux_sym_argument_list_repeat1] = STATE(7992),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(13435),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7925),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_end] = ACTIONS(7925),
    [anon_sym_if] = ACTIONS(7925),
    [anon_sym_unless] = ACTIONS(7925),
    [anon_sym_while] = ACTIONS(7925),
    [anon_sym_until] = ACTIONS(7925),
    [anon_sym_rescue] = ACTIONS(7925),
    [anon_sym_else] = ACTIONS(7925),
    [anon_sym_ensure] = ACTIONS(7925),
    [anon_sym_EQ_GT] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7925),
    [anon_sym_AMP_AMP] = ACTIONS(7925),
    [anon_sym_LT_LT] = ACTIONS(7925),
    [anon_sym_GT_GT] = ACTIONS(7925),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7925),
    [anon_sym_PLUS] = ACTIONS(7925),
    [anon_sym_SLASH] = ACTIONS(7925),
    [anon_sym_PERCENT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [7993] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9666),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1156),
    [sym_scope_resolution] = STATE(1152),
    [sym_call] = STATE(1152),
    [sym_method_call] = STATE(1156),
    [sym_assignment] = STATE(9666),
    [sym_operator_assignment] = STATE(9666),
    [sym_conditional] = STATE(9666),
    [sym_range] = STATE(9666),
    [sym_binary] = STATE(9666),
    [sym_unary] = STATE(9666),
    [sym_left_assignment_list] = STATE(1155),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1156),
    [sym__variable] = STATE(1152),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1156),
    [sym_false] = STATE(1156),
    [sym_nil] = STATE(1156),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3003),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2051),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2055),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2059),
    [anon_sym_next] = ACTIONS(2061),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5019),
    [anon_sym_defined_QMARK] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [anon_sym_BANG] = ACTIONS(2069),
    [anon_sym_TILDE] = ACTIONS(2069),
    [sym_constant] = ACTIONS(2075),
    [sym_identifier] = ACTIONS(2075),
    [sym_instance_variable] = ACTIONS(2073),
    [sym_class_variable] = ACTIONS(2073),
    [sym_global_variable] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2075),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7994] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(5441),
    [sym__binary_star] = ACTIONS(5443),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(5445),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(5447),
    [anon_sym_AMP] = ACTIONS(5449),
    [anon_sym_EQ] = ACTIONS(7822),
    [anon_sym_LT] = ACTIONS(5451),
    [anon_sym_end] = ACTIONS(6823),
    [anon_sym_if] = ACTIONS(6823),
    [anon_sym_unless] = ACTIONS(6823),
    [anon_sym_while] = ACTIONS(6823),
    [anon_sym_until] = ACTIONS(6823),
    [anon_sym_rescue] = ACTIONS(6823),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_else] = ACTIONS(6823),
    [anon_sym_ensure] = ACTIONS(6823),
    [anon_sym_EQ_GT] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_PLUS_EQ] = ACTIONS(6823),
    [anon_sym_DASH_EQ] = ACTIONS(6823),
    [anon_sym_STAR_EQ] = ACTIONS(6823),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6823),
    [anon_sym_SLASH_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6823),
    [anon_sym_AMP_EQ] = ACTIONS(6823),
    [anon_sym_PERCENT_EQ] = ACTIONS(6823),
    [anon_sym_GT_GT_EQ] = ACTIONS(6823),
    [anon_sym_LT_LT_EQ] = ACTIONS(6823),
    [anon_sym_CARET_EQ] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(5453),
    [anon_sym_DOT_DOT] = ACTIONS(5455),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5457),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(5459),
    [anon_sym_AMP_AMP] = ACTIONS(5459),
    [anon_sym_LT_LT] = ACTIONS(5461),
    [anon_sym_GT_GT] = ACTIONS(5461),
    [anon_sym_EQ_EQ] = ACTIONS(5459),
    [anon_sym_BANG_EQ] = ACTIONS(5463),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5463),
    [anon_sym_LT_EQ_GT] = ACTIONS(5463),
    [anon_sym_EQ_TILDE] = ACTIONS(5463),
    [anon_sym_BANG_TILDE] = ACTIONS(5463),
    [anon_sym_LT_EQ] = ACTIONS(5451),
    [anon_sym_GT] = ACTIONS(5451),
    [anon_sym_GT_EQ] = ACTIONS(5465),
    [anon_sym_CARET] = ACTIONS(5445),
    [anon_sym_PLUS] = ACTIONS(5467),
    [anon_sym_SLASH] = ACTIONS(5447),
    [anon_sym_PERCENT] = ACTIONS(5447),
    [sym_comment] = ACTIONS(87),
  },
  [7995] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(5441),
    [sym__binary_star] = ACTIONS(5443),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(5445),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(5447),
    [anon_sym_AMP] = ACTIONS(5449),
    [anon_sym_EQ] = ACTIONS(7884),
    [anon_sym_LT] = ACTIONS(5451),
    [anon_sym_end] = ACTIONS(7027),
    [anon_sym_if] = ACTIONS(7027),
    [anon_sym_unless] = ACTIONS(7027),
    [anon_sym_while] = ACTIONS(7027),
    [anon_sym_until] = ACTIONS(7027),
    [anon_sym_rescue] = ACTIONS(7027),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_else] = ACTIONS(7027),
    [anon_sym_ensure] = ACTIONS(7027),
    [anon_sym_EQ_GT] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_PLUS_EQ] = ACTIONS(7027),
    [anon_sym_DASH_EQ] = ACTIONS(7027),
    [anon_sym_STAR_EQ] = ACTIONS(7027),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7027),
    [anon_sym_SLASH_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7027),
    [anon_sym_AMP_EQ] = ACTIONS(7027),
    [anon_sym_PERCENT_EQ] = ACTIONS(7027),
    [anon_sym_GT_GT_EQ] = ACTIONS(7027),
    [anon_sym_LT_LT_EQ] = ACTIONS(7027),
    [anon_sym_CARET_EQ] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(5453),
    [anon_sym_DOT_DOT] = ACTIONS(5455),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5457),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(5459),
    [anon_sym_AMP_AMP] = ACTIONS(5459),
    [anon_sym_LT_LT] = ACTIONS(5461),
    [anon_sym_GT_GT] = ACTIONS(5461),
    [anon_sym_EQ_EQ] = ACTIONS(5459),
    [anon_sym_BANG_EQ] = ACTIONS(5463),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5463),
    [anon_sym_LT_EQ_GT] = ACTIONS(5463),
    [anon_sym_EQ_TILDE] = ACTIONS(5463),
    [anon_sym_BANG_TILDE] = ACTIONS(5463),
    [anon_sym_LT_EQ] = ACTIONS(5451),
    [anon_sym_GT] = ACTIONS(5451),
    [anon_sym_GT_EQ] = ACTIONS(5465),
    [anon_sym_CARET] = ACTIONS(5445),
    [anon_sym_PLUS] = ACTIONS(5467),
    [anon_sym_SLASH] = ACTIONS(5447),
    [anon_sym_PERCENT] = ACTIONS(5447),
    [sym_comment] = ACTIONS(87),
  },
  [7996] = {
    [sym_heredoc_body] = STATE(7996),
    [aux_sym_call_repeat1] = STATE(7996),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(10978),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7919),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_EQ] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_end] = ACTIONS(7914),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_else] = ACTIONS(7914),
    [anon_sym_ensure] = ACTIONS(7914),
    [anon_sym_EQ_GT] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_PLUS_EQ] = ACTIONS(7914),
    [anon_sym_DASH_EQ] = ACTIONS(7914),
    [anon_sym_STAR_EQ] = ACTIONS(7914),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7914),
    [anon_sym_SLASH_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7914),
    [anon_sym_AMP_EQ] = ACTIONS(7914),
    [anon_sym_PERCENT_EQ] = ACTIONS(7914),
    [anon_sym_GT_GT_EQ] = ACTIONS(7914),
    [anon_sym_LT_LT_EQ] = ACTIONS(7914),
    [anon_sym_CARET_EQ] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7919),
    [anon_sym_AMP_AMP] = ACTIONS(7919),
    [anon_sym_LT_LT] = ACTIONS(7919),
    [anon_sym_GT_GT] = ACTIONS(7919),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7919),
    [anon_sym_PLUS] = ACTIONS(7919),
    [anon_sym_SLASH] = ACTIONS(7919),
    [anon_sym_PERCENT] = ACTIONS(7919),
    [sym_comment] = ACTIONS(87),
  },
  [7997] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3032),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1249),
    [sym_scope_resolution] = STATE(1245),
    [sym_call] = STATE(1245),
    [sym_method_call] = STATE(1249),
    [sym__argument] = STATE(7437),
    [sym_splat_argument] = STATE(7437),
    [sym_hash_splat_argument] = STATE(7437),
    [sym_block_argument] = STATE(7437),
    [sym_assignment] = STATE(3032),
    [sym_operator_assignment] = STATE(3032),
    [sym_conditional] = STATE(3032),
    [sym_range] = STATE(3032),
    [sym_binary] = STATE(3032),
    [sym_unary] = STATE(3032),
    [sym_left_assignment_list] = STATE(1248),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(1245),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1249),
    [sym_false] = STATE(1249),
    [sym_nil] = STATE(1249),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3035),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(7437),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(5059),
    [sym__splat_star] = ACTIONS(5061),
    [sym__unary_minus] = ACTIONS(2217),
    [sym__identifier_hash_key] = ACTIONS(5063),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11496),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2223),
    [anon_sym_break] = ACTIONS(2225),
    [anon_sym_next] = ACTIONS(2227),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(5435),
    [anon_sym_defined_QMARK] = ACTIONS(2229),
    [anon_sym_not] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(2235),
    [anon_sym_TILDE] = ACTIONS(2235),
    [sym_constant] = ACTIONS(5065),
    [sym_identifier] = ACTIONS(5065),
    [sym_instance_variable] = ACTIONS(2239),
    [sym_class_variable] = ACTIONS(2239),
    [sym_global_variable] = ACTIONS(2239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(2241),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2241),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [7998] = {
    [sym_heredoc_body] = STATE(7996),
    [aux_sym_call_repeat1] = STATE(7996),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7931),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_EQ] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_end] = ACTIONS(7929),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_else] = ACTIONS(7929),
    [anon_sym_ensure] = ACTIONS(7929),
    [anon_sym_EQ_GT] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_PLUS_EQ] = ACTIONS(7929),
    [anon_sym_DASH_EQ] = ACTIONS(7929),
    [anon_sym_STAR_EQ] = ACTIONS(7929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7929),
    [anon_sym_SLASH_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7929),
    [anon_sym_AMP_EQ] = ACTIONS(7929),
    [anon_sym_PERCENT_EQ] = ACTIONS(7929),
    [anon_sym_GT_GT_EQ] = ACTIONS(7929),
    [anon_sym_LT_LT_EQ] = ACTIONS(7929),
    [anon_sym_CARET_EQ] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7931),
    [anon_sym_AMP_AMP] = ACTIONS(7931),
    [anon_sym_LT_LT] = ACTIONS(7931),
    [anon_sym_GT_GT] = ACTIONS(7931),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7931),
    [anon_sym_PLUS] = ACTIONS(7931),
    [anon_sym_SLASH] = ACTIONS(7931),
    [anon_sym_PERCENT] = ACTIONS(7931),
    [sym_comment] = ACTIONS(87),
  },
  [7999] = {
    [aux_sym_argument_list_repeat1] = STATE(7999),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(13438),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7927),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_EQ] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_end] = ACTIONS(7925),
    [anon_sym_if] = ACTIONS(7925),
    [anon_sym_unless] = ACTIONS(7925),
    [anon_sym_while] = ACTIONS(7925),
    [anon_sym_until] = ACTIONS(7925),
    [anon_sym_rescue] = ACTIONS(7925),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_else] = ACTIONS(7925),
    [anon_sym_ensure] = ACTIONS(7925),
    [anon_sym_EQ_GT] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_PLUS_EQ] = ACTIONS(7925),
    [anon_sym_DASH_EQ] = ACTIONS(7925),
    [anon_sym_STAR_EQ] = ACTIONS(7925),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7925),
    [anon_sym_SLASH_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7925),
    [anon_sym_AMP_EQ] = ACTIONS(7925),
    [anon_sym_PERCENT_EQ] = ACTIONS(7925),
    [anon_sym_GT_GT_EQ] = ACTIONS(7925),
    [anon_sym_LT_LT_EQ] = ACTIONS(7925),
    [anon_sym_CARET_EQ] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7927),
    [anon_sym_AMP_AMP] = ACTIONS(7927),
    [anon_sym_LT_LT] = ACTIONS(7927),
    [anon_sym_GT_GT] = ACTIONS(7927),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7927),
    [anon_sym_PLUS] = ACTIONS(7927),
    [anon_sym_SLASH] = ACTIONS(7927),
    [anon_sym_PERCENT] = ACTIONS(7927),
    [sym_comment] = ACTIONS(87),
  },
  [8000] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5573),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1156),
    [sym_scope_resolution] = STATE(1152),
    [sym_call] = STATE(1152),
    [sym_method_call] = STATE(1156),
    [sym_splat_argument] = STATE(7439),
    [sym_assignment] = STATE(5573),
    [sym_operator_assignment] = STATE(5573),
    [sym_conditional] = STATE(5573),
    [sym_range] = STATE(5573),
    [sym_binary] = STATE(5573),
    [sym_unary] = STATE(5573),
    [sym__arg_or_splat_arg] = STATE(7439),
    [sym_left_assignment_list] = STATE(1155),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1156),
    [sym__variable] = STATE(1152),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1156),
    [sym_false] = STATE(1156),
    [sym_nil] = STATE(1156),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3003),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__splat_star] = ACTIONS(5025),
    [sym__unary_minus] = ACTIONS(2051),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2055),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2059),
    [anon_sym_next] = ACTIONS(2061),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5019),
    [anon_sym_defined_QMARK] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [anon_sym_BANG] = ACTIONS(2069),
    [anon_sym_TILDE] = ACTIONS(2069),
    [sym_constant] = ACTIONS(2075),
    [sym_identifier] = ACTIONS(2075),
    [sym_instance_variable] = ACTIONS(2073),
    [sym_class_variable] = ACTIONS(2073),
    [sym_global_variable] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2075),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8001] = {
    [aux_sym_exceptions_repeat1] = STATE(9667),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(13441),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_end] = ACTIONS(9855),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_else] = ACTIONS(9855),
    [anon_sym_ensure] = ACTIONS(9855),
    [anon_sym_EQ_GT] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [8002] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(8747),
    [sym__binary_star] = ACTIONS(8749),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(8751),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(8749),
    [anon_sym_AMP] = ACTIONS(8753),
    [anon_sym_LT] = ACTIONS(8755),
    [anon_sym_then] = ACTIONS(6823),
    [anon_sym_EQ_GT] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(8757),
    [anon_sym_DOT_DOT] = ACTIONS(8759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8761),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(8763),
    [anon_sym_AMP_AMP] = ACTIONS(8763),
    [anon_sym_LT_LT] = ACTIONS(8765),
    [anon_sym_GT_GT] = ACTIONS(8765),
    [anon_sym_EQ_EQ] = ACTIONS(8767),
    [anon_sym_BANG_EQ] = ACTIONS(8763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8763),
    [anon_sym_LT_EQ_GT] = ACTIONS(8763),
    [anon_sym_EQ_TILDE] = ACTIONS(8763),
    [anon_sym_BANG_TILDE] = ACTIONS(8763),
    [anon_sym_LT_EQ] = ACTIONS(8755),
    [anon_sym_GT] = ACTIONS(8755),
    [anon_sym_GT_EQ] = ACTIONS(8769),
    [anon_sym_CARET] = ACTIONS(8771),
    [anon_sym_PLUS] = ACTIONS(8747),
    [anon_sym_SLASH] = ACTIONS(8749),
    [anon_sym_PERCENT] = ACTIONS(8749),
    [sym_comment] = ACTIONS(87),
  },
  [8003] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(8747),
    [sym__binary_star] = ACTIONS(8749),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(8751),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(8749),
    [anon_sym_AMP] = ACTIONS(8753),
    [anon_sym_LT] = ACTIONS(8755),
    [anon_sym_then] = ACTIONS(7027),
    [anon_sym_EQ_GT] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(8757),
    [anon_sym_DOT_DOT] = ACTIONS(8759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8761),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(8763),
    [anon_sym_AMP_AMP] = ACTIONS(8763),
    [anon_sym_LT_LT] = ACTIONS(8765),
    [anon_sym_GT_GT] = ACTIONS(8765),
    [anon_sym_EQ_EQ] = ACTIONS(8767),
    [anon_sym_BANG_EQ] = ACTIONS(8763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8763),
    [anon_sym_LT_EQ_GT] = ACTIONS(8763),
    [anon_sym_EQ_TILDE] = ACTIONS(8763),
    [anon_sym_BANG_TILDE] = ACTIONS(8763),
    [anon_sym_LT_EQ] = ACTIONS(8755),
    [anon_sym_GT] = ACTIONS(8755),
    [anon_sym_GT_EQ] = ACTIONS(8769),
    [anon_sym_CARET] = ACTIONS(8771),
    [anon_sym_PLUS] = ACTIONS(8747),
    [anon_sym_SLASH] = ACTIONS(8749),
    [anon_sym_PERCENT] = ACTIONS(8749),
    [sym_comment] = ACTIONS(87),
  },
  [8004] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(8749),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8749),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(8749),
    [anon_sym_PERCENT] = ACTIONS(8749),
    [sym_comment] = ACTIONS(87),
  },
  [8005] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8749),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [8006] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8747),
    [sym__binary_star] = ACTIONS(8749),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8749),
    [anon_sym_AMP] = ACTIONS(8753),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(8765),
    [anon_sym_GT_GT] = ACTIONS(8765),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(8747),
    [anon_sym_SLASH] = ACTIONS(8749),
    [anon_sym_PERCENT] = ACTIONS(8749),
    [sym_comment] = ACTIONS(87),
  },
  [8007] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8747),
    [sym__binary_star] = ACTIONS(8749),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8749),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(8765),
    [anon_sym_GT_GT] = ACTIONS(8765),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(8747),
    [anon_sym_SLASH] = ACTIONS(8749),
    [anon_sym_PERCENT] = ACTIONS(8749),
    [sym_comment] = ACTIONS(87),
  },
  [8008] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8747),
    [sym__binary_star] = ACTIONS(8749),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(8751),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8749),
    [anon_sym_AMP] = ACTIONS(8753),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(8765),
    [anon_sym_GT_GT] = ACTIONS(8765),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(8771),
    [anon_sym_PLUS] = ACTIONS(8747),
    [anon_sym_SLASH] = ACTIONS(8749),
    [anon_sym_PERCENT] = ACTIONS(8749),
    [sym_comment] = ACTIONS(87),
  },
  [8009] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(13443),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [8010] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(8747),
    [sym__binary_star] = ACTIONS(8749),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(8751),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(8749),
    [anon_sym_AMP] = ACTIONS(8753),
    [anon_sym_LT] = ACTIONS(8755),
    [anon_sym_then] = ACTIONS(5927),
    [anon_sym_EQ_GT] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(8759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8761),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(8763),
    [anon_sym_AMP_AMP] = ACTIONS(8763),
    [anon_sym_LT_LT] = ACTIONS(8765),
    [anon_sym_GT_GT] = ACTIONS(8765),
    [anon_sym_EQ_EQ] = ACTIONS(8767),
    [anon_sym_BANG_EQ] = ACTIONS(8763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8763),
    [anon_sym_LT_EQ_GT] = ACTIONS(8763),
    [anon_sym_EQ_TILDE] = ACTIONS(8763),
    [anon_sym_BANG_TILDE] = ACTIONS(8763),
    [anon_sym_LT_EQ] = ACTIONS(8755),
    [anon_sym_GT] = ACTIONS(8755),
    [anon_sym_GT_EQ] = ACTIONS(8769),
    [anon_sym_CARET] = ACTIONS(8771),
    [anon_sym_PLUS] = ACTIONS(8747),
    [anon_sym_SLASH] = ACTIONS(8749),
    [anon_sym_PERCENT] = ACTIONS(8749),
    [sym_comment] = ACTIONS(87),
  },
  [8011] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8747),
    [sym__binary_star] = ACTIONS(8749),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(8751),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8749),
    [anon_sym_AMP] = ACTIONS(8753),
    [anon_sym_LT] = ACTIONS(8755),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(8757),
    [anon_sym_DOT_DOT] = ACTIONS(8759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8761),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(8763),
    [anon_sym_AMP_AMP] = ACTIONS(8763),
    [anon_sym_LT_LT] = ACTIONS(8765),
    [anon_sym_GT_GT] = ACTIONS(8765),
    [anon_sym_EQ_EQ] = ACTIONS(8767),
    [anon_sym_BANG_EQ] = ACTIONS(8763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8763),
    [anon_sym_LT_EQ_GT] = ACTIONS(8763),
    [anon_sym_EQ_TILDE] = ACTIONS(8763),
    [anon_sym_BANG_TILDE] = ACTIONS(8763),
    [anon_sym_LT_EQ] = ACTIONS(8755),
    [anon_sym_GT] = ACTIONS(8755),
    [anon_sym_GT_EQ] = ACTIONS(8769),
    [anon_sym_CARET] = ACTIONS(8771),
    [anon_sym_PLUS] = ACTIONS(8747),
    [anon_sym_SLASH] = ACTIONS(8749),
    [anon_sym_PERCENT] = ACTIONS(8749),
    [sym_comment] = ACTIONS(87),
  },
  [8012] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8747),
    [sym__binary_star] = ACTIONS(8749),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(8751),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8749),
    [anon_sym_AMP] = ACTIONS(8753),
    [anon_sym_LT] = ACTIONS(8755),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(8765),
    [anon_sym_GT_GT] = ACTIONS(8765),
    [anon_sym_EQ_EQ] = ACTIONS(8767),
    [anon_sym_BANG_EQ] = ACTIONS(8763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8763),
    [anon_sym_LT_EQ_GT] = ACTIONS(8763),
    [anon_sym_EQ_TILDE] = ACTIONS(8763),
    [anon_sym_BANG_TILDE] = ACTIONS(8763),
    [anon_sym_LT_EQ] = ACTIONS(8755),
    [anon_sym_GT] = ACTIONS(8755),
    [anon_sym_GT_EQ] = ACTIONS(8769),
    [anon_sym_CARET] = ACTIONS(8771),
    [anon_sym_PLUS] = ACTIONS(8747),
    [anon_sym_SLASH] = ACTIONS(8749),
    [anon_sym_PERCENT] = ACTIONS(8749),
    [sym_comment] = ACTIONS(87),
  },
  [8013] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8747),
    [sym__binary_star] = ACTIONS(8749),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8749),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(8747),
    [anon_sym_SLASH] = ACTIONS(8749),
    [anon_sym_PERCENT] = ACTIONS(8749),
    [sym_comment] = ACTIONS(87),
  },
  [8014] = {
    [sym_heredoc_body] = STATE(8014),
    [aux_sym_call_repeat1] = STATE(8014),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(7916),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_then] = ACTIONS(7914),
    [anon_sym_EQ_GT] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [8015] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3052),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3056),
    [sym_scope_resolution] = STATE(1172),
    [sym_call] = STATE(1172),
    [sym_method_call] = STATE(3056),
    [sym__argument] = STATE(4986),
    [sym_splat_argument] = STATE(4986),
    [sym_hash_splat_argument] = STATE(4986),
    [sym_block_argument] = STATE(4986),
    [sym_assignment] = STATE(3052),
    [sym_operator_assignment] = STATE(3052),
    [sym_conditional] = STATE(3052),
    [sym_range] = STATE(3052),
    [sym_binary] = STATE(3052),
    [sym_unary] = STATE(3052),
    [sym_left_assignment_list] = STATE(3055),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3056),
    [sym__variable] = STATE(1172),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3056),
    [sym_false] = STATE(3056),
    [sym_nil] = STATE(3056),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3057),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4986),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(5077),
    [sym__splat_star] = ACTIONS(5079),
    [sym__unary_minus] = ACTIONS(5081),
    [sym__identifier_hash_key] = ACTIONS(5083),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11501),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2085),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_next] = ACTIONS(2089),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8741),
    [anon_sym_defined_QMARK] = ACTIONS(5085),
    [anon_sym_not] = ACTIONS(5087),
    [anon_sym_BANG] = ACTIONS(5091),
    [anon_sym_TILDE] = ACTIONS(5091),
    [sym_constant] = ACTIONS(5093),
    [sym_identifier] = ACTIONS(5093),
    [sym_instance_variable] = ACTIONS(2105),
    [sym_class_variable] = ACTIONS(2105),
    [sym_global_variable] = ACTIONS(2105),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2103),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2103),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8016] = {
    [sym_heredoc_body] = STATE(8014),
    [aux_sym_call_repeat1] = STATE(8014),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_then] = ACTIONS(7929),
    [anon_sym_EQ_GT] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [8017] = {
    [aux_sym_argument_list_repeat1] = STATE(8017),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(13445),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7925),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_then] = ACTIONS(7925),
    [anon_sym_EQ_GT] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7925),
    [anon_sym_AMP_AMP] = ACTIONS(7925),
    [anon_sym_LT_LT] = ACTIONS(7925),
    [anon_sym_GT_GT] = ACTIONS(7925),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7925),
    [anon_sym_PLUS] = ACTIONS(7925),
    [anon_sym_SLASH] = ACTIONS(7925),
    [anon_sym_PERCENT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [8018] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(8747),
    [sym__binary_star] = ACTIONS(8749),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(8751),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(8749),
    [anon_sym_AMP] = ACTIONS(8753),
    [anon_sym_LT] = ACTIONS(8755),
    [anon_sym_then] = ACTIONS(5115),
    [anon_sym_EQ_GT] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(8757),
    [anon_sym_DOT_DOT] = ACTIONS(8759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8761),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(8763),
    [anon_sym_AMP_AMP] = ACTIONS(8763),
    [anon_sym_LT_LT] = ACTIONS(8765),
    [anon_sym_GT_GT] = ACTIONS(8765),
    [anon_sym_EQ_EQ] = ACTIONS(8767),
    [anon_sym_BANG_EQ] = ACTIONS(8763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8763),
    [anon_sym_LT_EQ_GT] = ACTIONS(8763),
    [anon_sym_EQ_TILDE] = ACTIONS(8763),
    [anon_sym_BANG_TILDE] = ACTIONS(8763),
    [anon_sym_LT_EQ] = ACTIONS(8755),
    [anon_sym_GT] = ACTIONS(8755),
    [anon_sym_GT_EQ] = ACTIONS(8769),
    [anon_sym_CARET] = ACTIONS(8771),
    [anon_sym_PLUS] = ACTIONS(8747),
    [anon_sym_SLASH] = ACTIONS(8749),
    [anon_sym_PERCENT] = ACTIONS(8749),
    [sym_comment] = ACTIONS(87),
  },
  [8019] = {
    [aux_sym_exceptions_repeat1] = STATE(9670),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_then] = ACTIONS(6191),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [8020] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(8747),
    [sym__binary_star] = ACTIONS(8749),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(8751),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(8749),
    [anon_sym_AMP] = ACTIONS(8753),
    [anon_sym_LT] = ACTIONS(8755),
    [anon_sym_then] = ACTIONS(6210),
    [anon_sym_EQ_GT] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(8757),
    [anon_sym_DOT_DOT] = ACTIONS(8759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8761),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(8763),
    [anon_sym_AMP_AMP] = ACTIONS(8763),
    [anon_sym_LT_LT] = ACTIONS(8765),
    [anon_sym_GT_GT] = ACTIONS(8765),
    [anon_sym_EQ_EQ] = ACTIONS(8767),
    [anon_sym_BANG_EQ] = ACTIONS(8763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8763),
    [anon_sym_LT_EQ_GT] = ACTIONS(8763),
    [anon_sym_EQ_TILDE] = ACTIONS(8763),
    [anon_sym_BANG_TILDE] = ACTIONS(8763),
    [anon_sym_LT_EQ] = ACTIONS(8755),
    [anon_sym_GT] = ACTIONS(8755),
    [anon_sym_GT_EQ] = ACTIONS(8769),
    [anon_sym_CARET] = ACTIONS(8771),
    [anon_sym_PLUS] = ACTIONS(8747),
    [anon_sym_SLASH] = ACTIONS(8749),
    [anon_sym_PERCENT] = ACTIONS(8749),
    [sym_comment] = ACTIONS(87),
  },
  [8021] = {
    [sym__line_break] = ACTIONS(1263),
    [sym__simple_symbol] = ACTIONS(1263),
    [sym__string_start] = ACTIONS(1263),
    [sym__symbol_start] = ACTIONS(1263),
    [sym__subshell_start] = ACTIONS(1263),
    [sym__regex_start] = ACTIONS(1263),
    [sym__string_array_start] = ACTIONS(1263),
    [sym__symbol_array_start] = ACTIONS(1263),
    [sym__heredoc_body_start] = ACTIONS(1263),
    [sym_heredoc_beginning] = ACTIONS(1263),
    [sym__block_ampersand] = ACTIONS(1263),
    [sym__splat_star] = ACTIONS(1263),
    [sym__unary_minus] = ACTIONS(1263),
    [sym__identifier_hash_key] = ACTIONS(1263),
    [anon_sym_LBRACE] = ACTIONS(1263),
    [anon_sym_def] = ACTIONS(1265),
    [anon_sym_LPAREN] = ACTIONS(1265),
    [anon_sym_DOT] = ACTIONS(1263),
    [anon_sym_COLON_COLON] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_STAR_STAR] = ACTIONS(1263),
    [anon_sym_class] = ACTIONS(1265),
    [anon_sym_module] = ACTIONS(1265),
    [anon_sym_return] = ACTIONS(1265),
    [anon_sym_yield] = ACTIONS(1265),
    [anon_sym_break] = ACTIONS(1265),
    [anon_sym_next] = ACTIONS(1265),
    [sym_redo] = ACTIONS(1265),
    [sym_retry] = ACTIONS(1265),
    [anon_sym_if] = ACTIONS(1265),
    [anon_sym_unless] = ACTIONS(1265),
    [anon_sym_while] = ACTIONS(1265),
    [anon_sym_until] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1265),
    [anon_sym_do] = ACTIONS(1265),
    [anon_sym_case] = ACTIONS(1265),
    [anon_sym_then] = ACTIONS(1265),
    [anon_sym_begin] = ACTIONS(1265),
    [anon_sym_LBRACK] = ACTIONS(1263),
    [anon_sym_COLON_COLON2] = ACTIONS(1263),
    [anon_sym_AMP_DOT] = ACTIONS(1263),
    [anon_sym_LPAREN2] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1265),
    [anon_sym_defined_QMARK] = ACTIONS(1263),
    [anon_sym_not] = ACTIONS(1265),
    [anon_sym_BANG] = ACTIONS(1263),
    [anon_sym_TILDE] = ACTIONS(1263),
    [sym_constant] = ACTIONS(1265),
    [sym_identifier] = ACTIONS(1265),
    [sym_instance_variable] = ACTIONS(1263),
    [sym_class_variable] = ACTIONS(1263),
    [sym_global_variable] = ACTIONS(1263),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1265),
    [sym_float] = ACTIONS(1265),
    [sym_complex] = ACTIONS(1263),
    [sym_super] = ACTIONS(1265),
    [anon_sym_true] = ACTIONS(1265),
    [anon_sym_TRUE] = ACTIONS(1265),
    [anon_sym_false] = ACTIONS(1265),
    [anon_sym_FALSE] = ACTIONS(1265),
    [sym_self] = ACTIONS(1265),
    [anon_sym_nil] = ACTIONS(1265),
    [anon_sym_NIL] = ACTIONS(1265),
    [sym_character] = ACTIONS(1263),
    [anon_sym_LBRACK2] = ACTIONS(1265),
    [anon_sym_DASH_GT] = ACTIONS(1263),
  },
  [8022] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(906),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(911),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(911),
    [sym__argument_list_with_trailing_comma] = STATE(9672),
    [sym__argument] = STATE(909),
    [sym_splat_argument] = STATE(909),
    [sym_hash_splat_argument] = STATE(909),
    [sym_block_argument] = STATE(909),
    [sym_assignment] = STATE(906),
    [sym_operator_assignment] = STATE(906),
    [sym_conditional] = STATE(906),
    [sym_range] = STATE(906),
    [sym_binary] = STATE(906),
    [sym_unary] = STATE(906),
    [sym_left_assignment_list] = STATE(910),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(911),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(911),
    [sym_false] = STATE(911),
    [sym_nil] = STATE(911),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(912),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(909),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1589),
    [sym__splat_star] = ACTIONS(1591),
    [sym__unary_minus] = ACTIONS(1593),
    [sym__identifier_hash_key] = ACTIONS(1595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(13448),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1599),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_defined_QMARK] = ACTIONS(1611),
    [anon_sym_not] = ACTIONS(1613),
    [anon_sym_BANG] = ACTIONS(1615),
    [anon_sym_TILDE] = ACTIONS(1615),
    [sym_constant] = ACTIONS(1617),
    [sym_identifier] = ACTIONS(1617),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8023] = {
    [sym__line_break] = ACTIONS(5935),
    [sym__simple_symbol] = ACTIONS(5935),
    [sym__string_start] = ACTIONS(5935),
    [sym__symbol_start] = ACTIONS(5935),
    [sym__subshell_start] = ACTIONS(5935),
    [sym__regex_start] = ACTIONS(5935),
    [sym__string_array_start] = ACTIONS(5935),
    [sym__symbol_array_start] = ACTIONS(5935),
    [sym__heredoc_body_start] = ACTIONS(5935),
    [sym_heredoc_beginning] = ACTIONS(5935),
    [sym__block_ampersand] = ACTIONS(5935),
    [sym__splat_star] = ACTIONS(5935),
    [sym__unary_minus] = ACTIONS(5935),
    [sym__identifier_hash_key] = ACTIONS(5935),
    [anon_sym_LBRACE] = ACTIONS(5935),
    [anon_sym_def] = ACTIONS(5937),
    [anon_sym_LPAREN] = ACTIONS(5937),
    [anon_sym_DOT] = ACTIONS(5935),
    [anon_sym_COLON_COLON] = ACTIONS(5937),
    [anon_sym_SEMI] = ACTIONS(5935),
    [anon_sym_STAR] = ACTIONS(5937),
    [anon_sym_STAR_STAR] = ACTIONS(5935),
    [anon_sym_class] = ACTIONS(5937),
    [anon_sym_module] = ACTIONS(5937),
    [anon_sym_return] = ACTIONS(5937),
    [anon_sym_yield] = ACTIONS(5937),
    [anon_sym_break] = ACTIONS(5937),
    [anon_sym_next] = ACTIONS(5937),
    [sym_redo] = ACTIONS(5937),
    [sym_retry] = ACTIONS(5937),
    [anon_sym_if] = ACTIONS(5937),
    [anon_sym_unless] = ACTIONS(5937),
    [anon_sym_while] = ACTIONS(5937),
    [anon_sym_until] = ACTIONS(5937),
    [anon_sym_for] = ACTIONS(5937),
    [anon_sym_do] = ACTIONS(5937),
    [anon_sym_case] = ACTIONS(5937),
    [anon_sym_then] = ACTIONS(5937),
    [anon_sym_begin] = ACTIONS(5937),
    [anon_sym_LBRACK] = ACTIONS(5935),
    [anon_sym_COLON_COLON2] = ACTIONS(5935),
    [anon_sym_AMP_DOT] = ACTIONS(5935),
    [anon_sym_LPAREN2] = ACTIONS(5935),
    [anon_sym_PLUS] = ACTIONS(5937),
    [anon_sym_defined_QMARK] = ACTIONS(5935),
    [anon_sym_not] = ACTIONS(5937),
    [anon_sym_BANG] = ACTIONS(5935),
    [anon_sym_TILDE] = ACTIONS(5935),
    [sym_constant] = ACTIONS(5937),
    [sym_identifier] = ACTIONS(5937),
    [sym_instance_variable] = ACTIONS(5935),
    [sym_class_variable] = ACTIONS(5935),
    [sym_global_variable] = ACTIONS(5935),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5937),
    [sym_float] = ACTIONS(5937),
    [sym_complex] = ACTIONS(5935),
    [sym_super] = ACTIONS(5937),
    [anon_sym_true] = ACTIONS(5937),
    [anon_sym_TRUE] = ACTIONS(5937),
    [anon_sym_false] = ACTIONS(5937),
    [anon_sym_FALSE] = ACTIONS(5937),
    [sym_self] = ACTIONS(5937),
    [anon_sym_nil] = ACTIONS(5937),
    [anon_sym_NIL] = ACTIONS(5937),
    [sym_character] = ACTIONS(5935),
    [anon_sym_LBRACK2] = ACTIONS(5937),
    [anon_sym_DASH_GT] = ACTIONS(5935),
  },
  [8024] = {
    [sym__line_break] = ACTIONS(5939),
    [sym__simple_symbol] = ACTIONS(5939),
    [sym__string_start] = ACTIONS(5939),
    [sym__symbol_start] = ACTIONS(5939),
    [sym__subshell_start] = ACTIONS(5939),
    [sym__regex_start] = ACTIONS(5939),
    [sym__string_array_start] = ACTIONS(5939),
    [sym__symbol_array_start] = ACTIONS(5939),
    [sym__heredoc_body_start] = ACTIONS(5939),
    [sym_heredoc_beginning] = ACTIONS(5939),
    [sym__block_ampersand] = ACTIONS(5939),
    [sym__splat_star] = ACTIONS(5939),
    [sym__unary_minus] = ACTIONS(5939),
    [sym__identifier_hash_key] = ACTIONS(5939),
    [anon_sym_LBRACE] = ACTIONS(5939),
    [anon_sym_def] = ACTIONS(5941),
    [anon_sym_LPAREN] = ACTIONS(5941),
    [anon_sym_DOT] = ACTIONS(5939),
    [anon_sym_COLON_COLON] = ACTIONS(5941),
    [anon_sym_SEMI] = ACTIONS(5939),
    [anon_sym_STAR] = ACTIONS(5941),
    [anon_sym_STAR_STAR] = ACTIONS(5939),
    [anon_sym_class] = ACTIONS(5941),
    [anon_sym_module] = ACTIONS(5941),
    [anon_sym_return] = ACTIONS(5941),
    [anon_sym_yield] = ACTIONS(5941),
    [anon_sym_break] = ACTIONS(5941),
    [anon_sym_next] = ACTIONS(5941),
    [sym_redo] = ACTIONS(5941),
    [sym_retry] = ACTIONS(5941),
    [anon_sym_if] = ACTIONS(5941),
    [anon_sym_unless] = ACTIONS(5941),
    [anon_sym_while] = ACTIONS(5941),
    [anon_sym_until] = ACTIONS(5941),
    [anon_sym_for] = ACTIONS(5941),
    [anon_sym_do] = ACTIONS(5941),
    [anon_sym_case] = ACTIONS(5941),
    [anon_sym_then] = ACTIONS(5941),
    [anon_sym_begin] = ACTIONS(5941),
    [anon_sym_LBRACK] = ACTIONS(5939),
    [anon_sym_COLON_COLON2] = ACTIONS(5939),
    [anon_sym_AMP_DOT] = ACTIONS(5939),
    [anon_sym_LPAREN2] = ACTIONS(5939),
    [anon_sym_PLUS] = ACTIONS(5941),
    [anon_sym_defined_QMARK] = ACTIONS(5939),
    [anon_sym_not] = ACTIONS(5941),
    [anon_sym_BANG] = ACTIONS(5939),
    [anon_sym_TILDE] = ACTIONS(5939),
    [sym_constant] = ACTIONS(5941),
    [sym_identifier] = ACTIONS(5941),
    [sym_instance_variable] = ACTIONS(5939),
    [sym_class_variable] = ACTIONS(5939),
    [sym_global_variable] = ACTIONS(5939),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5941),
    [sym_float] = ACTIONS(5941),
    [sym_complex] = ACTIONS(5939),
    [sym_super] = ACTIONS(5941),
    [anon_sym_true] = ACTIONS(5941),
    [anon_sym_TRUE] = ACTIONS(5941),
    [anon_sym_false] = ACTIONS(5941),
    [anon_sym_FALSE] = ACTIONS(5941),
    [sym_self] = ACTIONS(5941),
    [anon_sym_nil] = ACTIONS(5941),
    [anon_sym_NIL] = ACTIONS(5941),
    [sym_character] = ACTIONS(5939),
    [anon_sym_LBRACK2] = ACTIONS(5941),
    [anon_sym_DASH_GT] = ACTIONS(5939),
  },
  [8025] = {
    [sym_argument_list_with_parens] = STATE(9673),
    [sym__argument_list_with_parens] = STATE(8024),
    [sym_operator] = STATE(9673),
    [sym_heredoc_body] = STATE(3563),
    [aux_sym_call_repeat1] = STATE(3563),
    [sym__heredoc_body_start] = ACTIONS(2519),
    [anon_sym_PIPE] = ACTIONS(11503),
    [anon_sym_STAR] = ACTIONS(11505),
    [anon_sym_STAR_STAR] = ACTIONS(11503),
    [anon_sym_AMP] = ACTIONS(11503),
    [anon_sym_LT] = ACTIONS(11505),
    [anon_sym_LPAREN2] = ACTIONS(11507),
    [anon_sym_DOT_DOT] = ACTIONS(11503),
    [anon_sym_LT_LT] = ACTIONS(11503),
    [anon_sym_GT_GT] = ACTIONS(11503),
    [anon_sym_EQ_EQ] = ACTIONS(11505),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11503),
    [anon_sym_LT_EQ_GT] = ACTIONS(11503),
    [anon_sym_EQ_TILDE] = ACTIONS(11503),
    [anon_sym_BANG_TILDE] = ACTIONS(11503),
    [anon_sym_LT_EQ] = ACTIONS(11505),
    [anon_sym_GT] = ACTIONS(11505),
    [anon_sym_GT_EQ] = ACTIONS(11503),
    [anon_sym_CARET] = ACTIONS(11503),
    [anon_sym_PLUS] = ACTIONS(11505),
    [anon_sym_SLASH] = ACTIONS(11503),
    [anon_sym_PERCENT] = ACTIONS(11503),
    [anon_sym_BANG] = ACTIONS(11505),
    [anon_sym_TILDE] = ACTIONS(11503),
    [sym_constant] = ACTIONS(13450),
    [sym_identifier] = ACTIONS(13450),
    [anon_sym_DASH] = ACTIONS(11505),
    [anon_sym_PLUS_AT] = ACTIONS(11503),
    [anon_sym_DASH_AT] = ACTIONS(11503),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11505),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(11503),
    [anon_sym_BQUOTE] = ACTIONS(11503),
    [sym_comment] = ACTIONS(87),
  },
  [8026] = {
    [sym__line_break] = ACTIONS(5945),
    [sym__heredoc_body_start] = ACTIONS(5945),
    [anon_sym_DOT] = ACTIONS(5945),
    [anon_sym_SEMI] = ACTIONS(5945),
    [anon_sym_then] = ACTIONS(5945),
    [anon_sym_LBRACK] = ACTIONS(5945),
    [anon_sym_COLON_COLON2] = ACTIONS(5945),
    [anon_sym_AMP_DOT] = ACTIONS(5945),
    [sym_comment] = ACTIONS(87),
  },
  [8027] = {
    [anon_sym_RBRACK] = ACTIONS(13452),
    [sym_comment] = ACTIONS(87),
  },
  [8028] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9675),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(8037),
    [sym_scope_resolution] = STATE(7955),
    [sym_call] = STATE(7955),
    [sym_method_call] = STATE(8037),
    [sym_assignment] = STATE(9675),
    [sym_operator_assignment] = STATE(9675),
    [sym_conditional] = STATE(9675),
    [sym_range] = STATE(9675),
    [sym_binary] = STATE(9675),
    [sym_unary] = STATE(9675),
    [sym_left_assignment_list] = STATE(8036),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(8037),
    [sym__variable] = STATE(7955),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(8037),
    [sym_false] = STATE(8037),
    [sym_nil] = STATE(8037),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(8038),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11513),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11515),
    [anon_sym_yield] = ACTIONS(11517),
    [anon_sym_break] = ACTIONS(11519),
    [anon_sym_next] = ACTIONS(11521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11523),
    [anon_sym_defined_QMARK] = ACTIONS(11525),
    [anon_sym_not] = ACTIONS(11527),
    [anon_sym_BANG] = ACTIONS(11529),
    [anon_sym_TILDE] = ACTIONS(11529),
    [sym_constant] = ACTIONS(11478),
    [sym_identifier] = ACTIONS(11478),
    [sym_instance_variable] = ACTIONS(11480),
    [sym_class_variable] = ACTIONS(11480),
    [sym_global_variable] = ACTIONS(11480),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11478),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11478),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8029] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9681),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5621),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(5621),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(9682),
    [sym__argument] = STATE(9683),
    [sym_splat_argument] = STATE(9683),
    [sym_hash_splat_argument] = STATE(9683),
    [sym_block_argument] = STATE(9683),
    [sym_assignment] = STATE(9681),
    [sym_operator_assignment] = STATE(9681),
    [sym_conditional] = STATE(9681),
    [sym_range] = STATE(9681),
    [sym_binary] = STATE(9681),
    [sym_unary] = STATE(9681),
    [sym_left_assignment_list] = STATE(5620),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5621),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5621),
    [sym_false] = STATE(5621),
    [sym_nil] = STATE(5621),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(9684),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(9683),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(13454),
    [sym__splat_star] = ACTIONS(13456),
    [sym__unary_minus] = ACTIONS(8791),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(13458),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8799),
    [anon_sym_yield] = ACTIONS(8801),
    [anon_sym_break] = ACTIONS(8803),
    [anon_sym_next] = ACTIONS(8805),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(377),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(8811),
    [anon_sym_not] = ACTIONS(8813),
    [anon_sym_BANG] = ACTIONS(11541),
    [anon_sym_TILDE] = ACTIONS(8815),
    [sym_constant] = ACTIONS(13460),
    [sym_identifier] = ACTIONS(13460),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8030] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9681),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5621),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(5621),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(9682),
    [sym__argument] = STATE(9683),
    [sym_splat_argument] = STATE(9683),
    [sym_hash_splat_argument] = STATE(9683),
    [sym_block_argument] = STATE(9683),
    [sym_assignment] = STATE(9681),
    [sym_operator_assignment] = STATE(9681),
    [sym_conditional] = STATE(9681),
    [sym_range] = STATE(9681),
    [sym_binary] = STATE(9681),
    [sym_unary] = STATE(9681),
    [sym_left_assignment_list] = STATE(5620),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5621),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5621),
    [sym_false] = STATE(5621),
    [sym_nil] = STATE(5621),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(9684),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(9683),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(13454),
    [sym__splat_star] = ACTIONS(13456),
    [sym__unary_minus] = ACTIONS(8791),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(13458),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8799),
    [anon_sym_yield] = ACTIONS(8801),
    [anon_sym_break] = ACTIONS(8803),
    [anon_sym_next] = ACTIONS(8805),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(419),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(8811),
    [anon_sym_not] = ACTIONS(8813),
    [anon_sym_BANG] = ACTIONS(11541),
    [anon_sym_TILDE] = ACTIONS(8815),
    [sym_constant] = ACTIONS(13460),
    [sym_identifier] = ACTIONS(13460),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8031] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9681),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5621),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(5621),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(9682),
    [sym__argument] = STATE(9683),
    [sym_splat_argument] = STATE(9683),
    [sym_hash_splat_argument] = STATE(9683),
    [sym_block_argument] = STATE(9683),
    [sym_assignment] = STATE(9681),
    [sym_operator_assignment] = STATE(9681),
    [sym_conditional] = STATE(9681),
    [sym_range] = STATE(9681),
    [sym_binary] = STATE(9681),
    [sym_unary] = STATE(9681),
    [sym_left_assignment_list] = STATE(5620),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5621),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5621),
    [sym_false] = STATE(5621),
    [sym_nil] = STATE(5621),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(9684),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(9683),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(13454),
    [sym__splat_star] = ACTIONS(13456),
    [sym__unary_minus] = ACTIONS(8791),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(13458),
    [anon_sym_LBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8799),
    [anon_sym_yield] = ACTIONS(8801),
    [anon_sym_break] = ACTIONS(8803),
    [anon_sym_next] = ACTIONS(8805),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(423),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(8811),
    [anon_sym_not] = ACTIONS(8813),
    [anon_sym_BANG] = ACTIONS(11541),
    [anon_sym_TILDE] = ACTIONS(8815),
    [sym_constant] = ACTIONS(13460),
    [sym_identifier] = ACTIONS(13460),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8032] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9681),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5621),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(5621),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(9682),
    [sym__argument] = STATE(9683),
    [sym_splat_argument] = STATE(9683),
    [sym_hash_splat_argument] = STATE(9683),
    [sym_block_argument] = STATE(9683),
    [sym_assignment] = STATE(9681),
    [sym_operator_assignment] = STATE(9681),
    [sym_conditional] = STATE(9681),
    [sym_range] = STATE(9681),
    [sym_binary] = STATE(9681),
    [sym_unary] = STATE(9681),
    [sym_left_assignment_list] = STATE(5620),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5621),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5621),
    [sym_false] = STATE(5621),
    [sym_nil] = STATE(5621),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(9684),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(9683),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(13454),
    [sym__splat_star] = ACTIONS(13456),
    [sym__unary_minus] = ACTIONS(8791),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(13458),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8799),
    [anon_sym_yield] = ACTIONS(8801),
    [anon_sym_break] = ACTIONS(8803),
    [anon_sym_next] = ACTIONS(8805),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(427),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(8811),
    [anon_sym_not] = ACTIONS(8813),
    [anon_sym_BANG] = ACTIONS(11541),
    [anon_sym_TILDE] = ACTIONS(8815),
    [sym_constant] = ACTIONS(13460),
    [sym_identifier] = ACTIONS(13460),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8033] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9685),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(8037),
    [sym_scope_resolution] = STATE(7955),
    [sym_call] = STATE(7955),
    [sym_method_call] = STATE(8037),
    [sym_assignment] = STATE(9685),
    [sym_operator_assignment] = STATE(9685),
    [sym_conditional] = STATE(9685),
    [sym_range] = STATE(9685),
    [sym_binary] = STATE(9685),
    [sym_unary] = STATE(9685),
    [sym_left_assignment_list] = STATE(8036),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(8037),
    [sym__variable] = STATE(7955),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(8037),
    [sym_false] = STATE(8037),
    [sym_nil] = STATE(8037),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(8038),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11513),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11515),
    [anon_sym_yield] = ACTIONS(11517),
    [anon_sym_break] = ACTIONS(11519),
    [anon_sym_next] = ACTIONS(11521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11523),
    [anon_sym_defined_QMARK] = ACTIONS(11525),
    [anon_sym_not] = ACTIONS(11527),
    [anon_sym_BANG] = ACTIONS(11529),
    [anon_sym_TILDE] = ACTIONS(11529),
    [sym_constant] = ACTIONS(11478),
    [sym_identifier] = ACTIONS(11478),
    [sym_instance_variable] = ACTIONS(11480),
    [sym_class_variable] = ACTIONS(11480),
    [sym_global_variable] = ACTIONS(11480),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11478),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11478),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8034] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(8037),
    [sym_scope_resolution] = STATE(7955),
    [sym_call] = STATE(7955),
    [sym_method_call] = STATE(8037),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(8036),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(8037),
    [sym__variable] = STATE(7955),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(8037),
    [sym_false] = STATE(8037),
    [sym_nil] = STATE(8037),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(8038),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11513),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11515),
    [anon_sym_yield] = ACTIONS(11517),
    [anon_sym_break] = ACTIONS(11519),
    [anon_sym_next] = ACTIONS(11521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11523),
    [anon_sym_defined_QMARK] = ACTIONS(11525),
    [anon_sym_not] = ACTIONS(11527),
    [anon_sym_BANG] = ACTIONS(11529),
    [anon_sym_TILDE] = ACTIONS(11529),
    [sym_constant] = ACTIONS(11478),
    [sym_identifier] = ACTIONS(11478),
    [sym_instance_variable] = ACTIONS(11480),
    [sym_class_variable] = ACTIONS(11480),
    [sym_global_variable] = ACTIONS(11480),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11478),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11478),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8035] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(13462),
    [sym__binary_star] = ACTIONS(13464),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(13466),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(13464),
    [anon_sym_AMP] = ACTIONS(13468),
    [anon_sym_LT] = ACTIONS(13470),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_then] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(13472),
    [anon_sym_DOT_DOT] = ACTIONS(13474),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13476),
    [anon_sym_and] = ACTIONS(13478),
    [anon_sym_or] = ACTIONS(13478),
    [anon_sym_PIPE_PIPE] = ACTIONS(13480),
    [anon_sym_AMP_AMP] = ACTIONS(13480),
    [anon_sym_LT_LT] = ACTIONS(13482),
    [anon_sym_GT_GT] = ACTIONS(13482),
    [anon_sym_EQ_EQ] = ACTIONS(13484),
    [anon_sym_BANG_EQ] = ACTIONS(13480),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13480),
    [anon_sym_LT_EQ_GT] = ACTIONS(13480),
    [anon_sym_EQ_TILDE] = ACTIONS(13480),
    [anon_sym_BANG_TILDE] = ACTIONS(13480),
    [anon_sym_LT_EQ] = ACTIONS(13470),
    [anon_sym_GT] = ACTIONS(13470),
    [anon_sym_GT_EQ] = ACTIONS(13486),
    [anon_sym_CARET] = ACTIONS(13488),
    [anon_sym_PLUS] = ACTIONS(13462),
    [anon_sym_SLASH] = ACTIONS(13464),
    [anon_sym_PERCENT] = ACTIONS(13464),
    [sym_comment] = ACTIONS(87),
  },
  [8036] = {
    [anon_sym_EQ] = ACTIONS(13490),
    [sym_comment] = ACTIONS(87),
  },
  [8037] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(13492),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(13494),
    [anon_sym_DASH_EQ] = ACTIONS(13494),
    [anon_sym_STAR_EQ] = ACTIONS(13494),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13494),
    [anon_sym_SLASH_EQ] = ACTIONS(13494),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13494),
    [anon_sym_PIPE_EQ] = ACTIONS(13494),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13494),
    [anon_sym_AMP_EQ] = ACTIONS(13494),
    [anon_sym_PERCENT_EQ] = ACTIONS(13494),
    [anon_sym_GT_GT_EQ] = ACTIONS(13494),
    [anon_sym_LT_LT_EQ] = ACTIONS(13494),
    [anon_sym_CARET_EQ] = ACTIONS(13494),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [8038] = {
    [sym_string] = STATE(9698),
    [aux_sym_chained_string_repeat1] = STATE(9698),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [8039] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(13462),
    [sym__binary_star] = ACTIONS(13464),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(13466),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(13464),
    [anon_sym_AMP] = ACTIONS(13468),
    [anon_sym_LT] = ACTIONS(13470),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_then] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(13472),
    [anon_sym_DOT_DOT] = ACTIONS(13474),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13476),
    [anon_sym_and] = ACTIONS(13478),
    [anon_sym_or] = ACTIONS(13478),
    [anon_sym_PIPE_PIPE] = ACTIONS(13480),
    [anon_sym_AMP_AMP] = ACTIONS(13480),
    [anon_sym_LT_LT] = ACTIONS(13482),
    [anon_sym_GT_GT] = ACTIONS(13482),
    [anon_sym_EQ_EQ] = ACTIONS(13484),
    [anon_sym_BANG_EQ] = ACTIONS(13480),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13480),
    [anon_sym_LT_EQ_GT] = ACTIONS(13480),
    [anon_sym_EQ_TILDE] = ACTIONS(13480),
    [anon_sym_BANG_TILDE] = ACTIONS(13480),
    [anon_sym_LT_EQ] = ACTIONS(13470),
    [anon_sym_GT] = ACTIONS(13470),
    [anon_sym_GT_EQ] = ACTIONS(13486),
    [anon_sym_CARET] = ACTIONS(13488),
    [anon_sym_PLUS] = ACTIONS(13462),
    [anon_sym_SLASH] = ACTIONS(13464),
    [anon_sym_PERCENT] = ACTIONS(13464),
    [sym_comment] = ACTIONS(87),
  },
  [8040] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(11551),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [8041] = {
    [sym_string] = STATE(8075),
    [aux_sym_chained_string_repeat1] = STATE(8075),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [8042] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9699),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(8037),
    [sym_scope_resolution] = STATE(7955),
    [sym_call] = STATE(7955),
    [sym_method_call] = STATE(8037),
    [sym_assignment] = STATE(9699),
    [sym_operator_assignment] = STATE(9699),
    [sym_conditional] = STATE(9699),
    [sym_range] = STATE(9699),
    [sym_binary] = STATE(9699),
    [sym_unary] = STATE(9699),
    [sym_left_assignment_list] = STATE(8036),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(8037),
    [sym__variable] = STATE(7955),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(8037),
    [sym_false] = STATE(8037),
    [sym_nil] = STATE(8037),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(8038),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11513),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11515),
    [anon_sym_yield] = ACTIONS(11517),
    [anon_sym_break] = ACTIONS(11519),
    [anon_sym_next] = ACTIONS(11521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11523),
    [anon_sym_defined_QMARK] = ACTIONS(11525),
    [anon_sym_not] = ACTIONS(11527),
    [anon_sym_BANG] = ACTIONS(11529),
    [anon_sym_TILDE] = ACTIONS(11529),
    [sym_constant] = ACTIONS(11478),
    [sym_identifier] = ACTIONS(11478),
    [sym_instance_variable] = ACTIONS(11480),
    [sym_class_variable] = ACTIONS(11480),
    [sym_global_variable] = ACTIONS(11480),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11478),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11478),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8043] = {
    [sym__line_break] = ACTIONS(5735),
    [sym__heredoc_body_start] = ACTIONS(5735),
    [sym__binary_minus] = ACTIONS(993),
    [sym__binary_star] = ACTIONS(993),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_DOT] = ACTIONS(5737),
    [anon_sym_COMMA] = ACTIONS(993),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_SEMI] = ACTIONS(5735),
    [anon_sym_STAR_STAR] = ACTIONS(993),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(995),
    [anon_sym_do] = ACTIONS(993),
    [anon_sym_then] = ACTIONS(5735),
    [anon_sym_EQ_GT] = ACTIONS(993),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_COLON_COLON2] = ACTIONS(5735),
    [anon_sym_AMP_DOT] = ACTIONS(5735),
    [anon_sym_QMARK] = ACTIONS(993),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(993),
    [anon_sym_and] = ACTIONS(993),
    [anon_sym_or] = ACTIONS(993),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_AMP_AMP] = ACTIONS(993),
    [anon_sym_LT_LT] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(993),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(993),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(993),
    [anon_sym_LT_EQ_GT] = ACTIONS(993),
    [anon_sym_EQ_TILDE] = ACTIONS(993),
    [anon_sym_BANG_TILDE] = ACTIONS(993),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(993),
    [anon_sym_CARET] = ACTIONS(993),
    [anon_sym_PLUS] = ACTIONS(993),
    [anon_sym_SLASH] = ACTIONS(993),
    [anon_sym_PERCENT] = ACTIONS(993),
    [sym_comment] = ACTIONS(87),
  },
  [8044] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(13462),
    [sym__binary_star] = ACTIONS(13464),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(13466),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(13464),
    [anon_sym_AMP] = ACTIONS(13468),
    [anon_sym_LT] = ACTIONS(13470),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_then] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(13472),
    [anon_sym_DOT_DOT] = ACTIONS(13474),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13476),
    [anon_sym_and] = ACTIONS(13478),
    [anon_sym_or] = ACTIONS(13478),
    [anon_sym_PIPE_PIPE] = ACTIONS(13480),
    [anon_sym_AMP_AMP] = ACTIONS(13480),
    [anon_sym_LT_LT] = ACTIONS(13482),
    [anon_sym_GT_GT] = ACTIONS(13482),
    [anon_sym_EQ_EQ] = ACTIONS(13484),
    [anon_sym_BANG_EQ] = ACTIONS(13480),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13480),
    [anon_sym_LT_EQ_GT] = ACTIONS(13480),
    [anon_sym_EQ_TILDE] = ACTIONS(13480),
    [anon_sym_BANG_TILDE] = ACTIONS(13480),
    [anon_sym_LT_EQ] = ACTIONS(13470),
    [anon_sym_GT] = ACTIONS(13470),
    [anon_sym_GT_EQ] = ACTIONS(13486),
    [anon_sym_CARET] = ACTIONS(13488),
    [anon_sym_PLUS] = ACTIONS(13462),
    [anon_sym_SLASH] = ACTIONS(13464),
    [anon_sym_PERCENT] = ACTIONS(13464),
    [sym_comment] = ACTIONS(87),
  },
  [8045] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9700),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5621),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(5621),
    [sym_assignment] = STATE(9700),
    [sym_operator_assignment] = STATE(9700),
    [sym_conditional] = STATE(9700),
    [sym_range] = STATE(9700),
    [sym_binary] = STATE(9700),
    [sym_unary] = STATE(9700),
    [sym_left_assignment_list] = STATE(5620),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5621),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5621),
    [sym_false] = STATE(5621),
    [sym_nil] = STATE(5621),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(8041),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(8791),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8799),
    [anon_sym_yield] = ACTIONS(8801),
    [anon_sym_break] = ACTIONS(8803),
    [anon_sym_next] = ACTIONS(8805),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8809),
    [anon_sym_defined_QMARK] = ACTIONS(8811),
    [anon_sym_not] = ACTIONS(8813),
    [anon_sym_BANG] = ACTIONS(8815),
    [anon_sym_TILDE] = ACTIONS(8815),
    [sym_constant] = ACTIONS(5173),
    [sym_identifier] = ACTIONS(5173),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8046] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9701),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5621),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(5621),
    [sym_assignment] = STATE(9701),
    [sym_operator_assignment] = STATE(9701),
    [sym_conditional] = STATE(9701),
    [sym_range] = STATE(9701),
    [sym_binary] = STATE(9701),
    [sym_unary] = STATE(9701),
    [sym_left_assignment_list] = STATE(5620),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5621),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5621),
    [sym_false] = STATE(5621),
    [sym_nil] = STATE(5621),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(8041),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(8791),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8799),
    [anon_sym_yield] = ACTIONS(8801),
    [anon_sym_break] = ACTIONS(8803),
    [anon_sym_next] = ACTIONS(8805),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8809),
    [anon_sym_defined_QMARK] = ACTIONS(8811),
    [anon_sym_not] = ACTIONS(8813),
    [anon_sym_BANG] = ACTIONS(8815),
    [anon_sym_TILDE] = ACTIONS(8815),
    [sym_constant] = ACTIONS(5173),
    [sym_identifier] = ACTIONS(5173),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8047] = {
    [anon_sym_COLON] = ACTIONS(13496),
    [sym_comment] = ACTIONS(87),
  },
  [8048] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9703),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5621),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(5621),
    [sym_assignment] = STATE(9703),
    [sym_operator_assignment] = STATE(9703),
    [sym_conditional] = STATE(9703),
    [sym_range] = STATE(9703),
    [sym_binary] = STATE(9703),
    [sym_unary] = STATE(9703),
    [sym_left_assignment_list] = STATE(5620),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5621),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5621),
    [sym_false] = STATE(5621),
    [sym_nil] = STATE(5621),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(8041),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(8791),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8799),
    [anon_sym_yield] = ACTIONS(8801),
    [anon_sym_break] = ACTIONS(8803),
    [anon_sym_next] = ACTIONS(8805),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8809),
    [anon_sym_defined_QMARK] = ACTIONS(8811),
    [anon_sym_not] = ACTIONS(8813),
    [anon_sym_BANG] = ACTIONS(8815),
    [anon_sym_TILDE] = ACTIONS(8815),
    [sym_constant] = ACTIONS(5173),
    [sym_identifier] = ACTIONS(5173),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8049] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(13498),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_then] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [8050] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(11549),
    [sym__binary_star] = ACTIONS(11551),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(11553),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(11551),
    [anon_sym_AMP] = ACTIONS(11555),
    [anon_sym_LT] = ACTIONS(11557),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_then] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(1625),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(11559),
    [anon_sym_DOT_DOT] = ACTIONS(11561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11563),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(11567),
    [anon_sym_AMP_AMP] = ACTIONS(11567),
    [anon_sym_LT_LT] = ACTIONS(11569),
    [anon_sym_GT_GT] = ACTIONS(11569),
    [anon_sym_EQ_EQ] = ACTIONS(11571),
    [anon_sym_BANG_EQ] = ACTIONS(11567),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11567),
    [anon_sym_LT_EQ_GT] = ACTIONS(11567),
    [anon_sym_EQ_TILDE] = ACTIONS(11567),
    [anon_sym_BANG_TILDE] = ACTIONS(11567),
    [anon_sym_LT_EQ] = ACTIONS(11557),
    [anon_sym_GT] = ACTIONS(11557),
    [anon_sym_GT_EQ] = ACTIONS(11573),
    [anon_sym_CARET] = ACTIONS(11575),
    [anon_sym_PLUS] = ACTIONS(11549),
    [anon_sym_SLASH] = ACTIONS(11551),
    [anon_sym_PERCENT] = ACTIONS(11551),
    [sym_comment] = ACTIONS(87),
  },
  [8051] = {
    [sym_heredoc_body] = STATE(9705),
    [aux_sym_call_repeat1] = STATE(9705),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_then] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [8052] = {
    [sym_heredoc_body] = STATE(9705),
    [aux_sym_call_repeat1] = STATE(9705),
    [aux_sym_argument_list_repeat1] = STATE(9707),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(13500),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_then] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [8053] = {
    [sym_string] = STATE(8075),
    [aux_sym_chained_string_repeat1] = STATE(8075),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(13502),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [8054] = {
    [sym__line_break] = ACTIONS(4285),
    [sym__heredoc_body_start] = ACTIONS(4285),
    [anon_sym_LBRACE] = ACTIONS(4285),
    [anon_sym_DOT] = ACTIONS(4285),
    [anon_sym_SEMI] = ACTIONS(4285),
    [anon_sym_do] = ACTIONS(4285),
    [anon_sym_then] = ACTIONS(4285),
    [anon_sym_LBRACK] = ACTIONS(4285),
    [anon_sym_COLON_COLON2] = ACTIONS(4285),
    [anon_sym_AMP_DOT] = ACTIONS(4285),
    [sym_comment] = ACTIONS(87),
  },
  [8055] = {
    [anon_sym_RPAREN] = ACTIONS(13504),
    [sym_comment] = ACTIONS(87),
  },
  [8056] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(11549),
    [sym__binary_star] = ACTIONS(11551),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(11553),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(11551),
    [anon_sym_AMP] = ACTIONS(11555),
    [anon_sym_LT] = ACTIONS(11557),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(11559),
    [anon_sym_DOT_DOT] = ACTIONS(11561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11563),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(11567),
    [anon_sym_AMP_AMP] = ACTIONS(11567),
    [anon_sym_LT_LT] = ACTIONS(11569),
    [anon_sym_GT_GT] = ACTIONS(11569),
    [anon_sym_EQ_EQ] = ACTIONS(11571),
    [anon_sym_BANG_EQ] = ACTIONS(11567),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11567),
    [anon_sym_LT_EQ_GT] = ACTIONS(11567),
    [anon_sym_EQ_TILDE] = ACTIONS(11567),
    [anon_sym_BANG_TILDE] = ACTIONS(11567),
    [anon_sym_LT_EQ] = ACTIONS(11557),
    [anon_sym_GT] = ACTIONS(11557),
    [anon_sym_GT_EQ] = ACTIONS(11573),
    [anon_sym_CARET] = ACTIONS(11575),
    [anon_sym_PLUS] = ACTIONS(11549),
    [anon_sym_SLASH] = ACTIONS(11551),
    [anon_sym_PERCENT] = ACTIONS(11551),
    [sym_comment] = ACTIONS(87),
  },
  [8057] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9709),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(8037),
    [sym_scope_resolution] = STATE(7955),
    [sym_call] = STATE(7955),
    [sym_method_call] = STATE(8037),
    [sym_assignment] = STATE(9709),
    [sym_operator_assignment] = STATE(9709),
    [sym_conditional] = STATE(9709),
    [sym_range] = STATE(9709),
    [sym_binary] = STATE(9709),
    [sym_unary] = STATE(9709),
    [sym_left_assignment_list] = STATE(8036),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(8037),
    [sym__variable] = STATE(7955),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(8037),
    [sym_false] = STATE(8037),
    [sym_nil] = STATE(8037),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(8038),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11513),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11515),
    [anon_sym_yield] = ACTIONS(11517),
    [anon_sym_break] = ACTIONS(11519),
    [anon_sym_next] = ACTIONS(11521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11523),
    [anon_sym_defined_QMARK] = ACTIONS(11525),
    [anon_sym_not] = ACTIONS(11527),
    [anon_sym_BANG] = ACTIONS(11529),
    [anon_sym_TILDE] = ACTIONS(11529),
    [sym_constant] = ACTIONS(11478),
    [sym_identifier] = ACTIONS(11478),
    [sym_instance_variable] = ACTIONS(11480),
    [sym_class_variable] = ACTIONS(11480),
    [sym_global_variable] = ACTIONS(11480),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11478),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11478),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8058] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9710),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5621),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(5621),
    [sym_assignment] = STATE(9710),
    [sym_operator_assignment] = STATE(9710),
    [sym_conditional] = STATE(9710),
    [sym_range] = STATE(9710),
    [sym_binary] = STATE(9710),
    [sym_unary] = STATE(9710),
    [sym_left_assignment_list] = STATE(5620),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5621),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5621),
    [sym_false] = STATE(5621),
    [sym_nil] = STATE(5621),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(8041),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(8791),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8799),
    [anon_sym_yield] = ACTIONS(8801),
    [anon_sym_break] = ACTIONS(8803),
    [anon_sym_next] = ACTIONS(8805),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8809),
    [anon_sym_defined_QMARK] = ACTIONS(8811),
    [anon_sym_not] = ACTIONS(8813),
    [anon_sym_BANG] = ACTIONS(8815),
    [anon_sym_TILDE] = ACTIONS(8815),
    [sym_constant] = ACTIONS(5173),
    [sym_identifier] = ACTIONS(5173),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8059] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9711),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5621),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(5621),
    [sym_assignment] = STATE(9711),
    [sym_operator_assignment] = STATE(9711),
    [sym_conditional] = STATE(9711),
    [sym_range] = STATE(9711),
    [sym_binary] = STATE(9711),
    [sym_unary] = STATE(9711),
    [sym_left_assignment_list] = STATE(5620),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5621),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5621),
    [sym_false] = STATE(5621),
    [sym_nil] = STATE(5621),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(8041),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(8791),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8799),
    [anon_sym_yield] = ACTIONS(8801),
    [anon_sym_break] = ACTIONS(8803),
    [anon_sym_next] = ACTIONS(8805),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8809),
    [anon_sym_defined_QMARK] = ACTIONS(8811),
    [anon_sym_not] = ACTIONS(8813),
    [anon_sym_BANG] = ACTIONS(8815),
    [anon_sym_TILDE] = ACTIONS(8815),
    [sym_constant] = ACTIONS(5173),
    [sym_identifier] = ACTIONS(5173),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8060] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9712),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5621),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(5621),
    [sym_assignment] = STATE(9712),
    [sym_operator_assignment] = STATE(9712),
    [sym_conditional] = STATE(9712),
    [sym_range] = STATE(9712),
    [sym_binary] = STATE(9712),
    [sym_unary] = STATE(9712),
    [sym_left_assignment_list] = STATE(5620),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5621),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5621),
    [sym_false] = STATE(5621),
    [sym_nil] = STATE(5621),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(8041),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(8791),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8799),
    [anon_sym_yield] = ACTIONS(8801),
    [anon_sym_break] = ACTIONS(8803),
    [anon_sym_next] = ACTIONS(8805),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8809),
    [anon_sym_defined_QMARK] = ACTIONS(8811),
    [anon_sym_not] = ACTIONS(8813),
    [anon_sym_BANG] = ACTIONS(8815),
    [anon_sym_TILDE] = ACTIONS(8815),
    [sym_constant] = ACTIONS(5173),
    [sym_identifier] = ACTIONS(5173),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8061] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9713),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5621),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(5621),
    [sym_assignment] = STATE(9713),
    [sym_operator_assignment] = STATE(9713),
    [sym_conditional] = STATE(9713),
    [sym_range] = STATE(9713),
    [sym_binary] = STATE(9713),
    [sym_unary] = STATE(9713),
    [sym_left_assignment_list] = STATE(5620),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5621),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5621),
    [sym_false] = STATE(5621),
    [sym_nil] = STATE(5621),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(8041),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(8791),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8799),
    [anon_sym_yield] = ACTIONS(8801),
    [anon_sym_break] = ACTIONS(8803),
    [anon_sym_next] = ACTIONS(8805),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8809),
    [anon_sym_defined_QMARK] = ACTIONS(8811),
    [anon_sym_not] = ACTIONS(8813),
    [anon_sym_BANG] = ACTIONS(8815),
    [anon_sym_TILDE] = ACTIONS(8815),
    [sym_constant] = ACTIONS(5173),
    [sym_identifier] = ACTIONS(5173),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8062] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9714),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5621),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(5621),
    [sym_assignment] = STATE(9714),
    [sym_operator_assignment] = STATE(9714),
    [sym_conditional] = STATE(9714),
    [sym_range] = STATE(9714),
    [sym_binary] = STATE(9714),
    [sym_unary] = STATE(9714),
    [sym_left_assignment_list] = STATE(5620),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5621),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5621),
    [sym_false] = STATE(5621),
    [sym_nil] = STATE(5621),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(8041),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(8791),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8799),
    [anon_sym_yield] = ACTIONS(8801),
    [anon_sym_break] = ACTIONS(8803),
    [anon_sym_next] = ACTIONS(8805),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8809),
    [anon_sym_defined_QMARK] = ACTIONS(8811),
    [anon_sym_not] = ACTIONS(8813),
    [anon_sym_BANG] = ACTIONS(8815),
    [anon_sym_TILDE] = ACTIONS(8815),
    [sym_constant] = ACTIONS(5173),
    [sym_identifier] = ACTIONS(5173),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8063] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(9715),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(9715),
    [sym_operator_assignment] = STATE(9715),
    [sym_conditional] = STATE(9715),
    [sym_range] = STATE(9715),
    [sym_binary] = STATE(9715),
    [sym_unary] = STATE(9715),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8064] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9716),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5621),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(5621),
    [sym_assignment] = STATE(9716),
    [sym_operator_assignment] = STATE(9716),
    [sym_conditional] = STATE(9716),
    [sym_range] = STATE(9716),
    [sym_binary] = STATE(9716),
    [sym_unary] = STATE(9716),
    [sym_left_assignment_list] = STATE(5620),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5621),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5621),
    [sym_false] = STATE(5621),
    [sym_nil] = STATE(5621),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(8041),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(8791),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8799),
    [anon_sym_yield] = ACTIONS(8801),
    [anon_sym_break] = ACTIONS(8803),
    [anon_sym_next] = ACTIONS(8805),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8809),
    [anon_sym_defined_QMARK] = ACTIONS(8811),
    [anon_sym_not] = ACTIONS(8813),
    [anon_sym_BANG] = ACTIONS(8815),
    [anon_sym_TILDE] = ACTIONS(8815),
    [sym_constant] = ACTIONS(5173),
    [sym_identifier] = ACTIONS(5173),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8065] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9717),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5621),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(5621),
    [sym_assignment] = STATE(9717),
    [sym_operator_assignment] = STATE(9717),
    [sym_conditional] = STATE(9717),
    [sym_range] = STATE(9717),
    [sym_binary] = STATE(9717),
    [sym_unary] = STATE(9717),
    [sym_left_assignment_list] = STATE(5620),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5621),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5621),
    [sym_false] = STATE(5621),
    [sym_nil] = STATE(5621),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(8041),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(8791),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8799),
    [anon_sym_yield] = ACTIONS(8801),
    [anon_sym_break] = ACTIONS(8803),
    [anon_sym_next] = ACTIONS(8805),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8809),
    [anon_sym_defined_QMARK] = ACTIONS(8811),
    [anon_sym_not] = ACTIONS(8813),
    [anon_sym_BANG] = ACTIONS(8815),
    [anon_sym_TILDE] = ACTIONS(8815),
    [sym_constant] = ACTIONS(5173),
    [sym_identifier] = ACTIONS(5173),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8066] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9718),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5621),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(5621),
    [sym_assignment] = STATE(9718),
    [sym_operator_assignment] = STATE(9718),
    [sym_conditional] = STATE(9718),
    [sym_range] = STATE(9718),
    [sym_binary] = STATE(9718),
    [sym_unary] = STATE(9718),
    [sym_left_assignment_list] = STATE(5620),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5621),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5621),
    [sym_false] = STATE(5621),
    [sym_nil] = STATE(5621),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(8041),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(8791),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8799),
    [anon_sym_yield] = ACTIONS(8801),
    [anon_sym_break] = ACTIONS(8803),
    [anon_sym_next] = ACTIONS(8805),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8809),
    [anon_sym_defined_QMARK] = ACTIONS(8811),
    [anon_sym_not] = ACTIONS(8813),
    [anon_sym_BANG] = ACTIONS(8815),
    [anon_sym_TILDE] = ACTIONS(8815),
    [sym_constant] = ACTIONS(5173),
    [sym_identifier] = ACTIONS(5173),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8067] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9719),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5621),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(5621),
    [sym_assignment] = STATE(9719),
    [sym_operator_assignment] = STATE(9719),
    [sym_conditional] = STATE(9719),
    [sym_range] = STATE(9719),
    [sym_binary] = STATE(9719),
    [sym_unary] = STATE(9719),
    [sym_left_assignment_list] = STATE(5620),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5621),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5621),
    [sym_false] = STATE(5621),
    [sym_nil] = STATE(5621),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(8041),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(8791),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8799),
    [anon_sym_yield] = ACTIONS(8801),
    [anon_sym_break] = ACTIONS(8803),
    [anon_sym_next] = ACTIONS(8805),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8809),
    [anon_sym_defined_QMARK] = ACTIONS(8811),
    [anon_sym_not] = ACTIONS(8813),
    [anon_sym_BANG] = ACTIONS(8815),
    [anon_sym_TILDE] = ACTIONS(8815),
    [sym_constant] = ACTIONS(5173),
    [sym_identifier] = ACTIONS(5173),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8068] = {
    [sym__line_break] = ACTIONS(6155),
    [sym__heredoc_body_start] = ACTIONS(6155),
    [anon_sym_DOT] = ACTIONS(6155),
    [anon_sym_SEMI] = ACTIONS(6155),
    [anon_sym_then] = ACTIONS(6155),
    [anon_sym_LBRACK] = ACTIONS(6155),
    [anon_sym_COLON_COLON2] = ACTIONS(6155),
    [anon_sym_AMP_DOT] = ACTIONS(6155),
    [sym_comment] = ACTIONS(87),
  },
  [8069] = {
    [sym_interpolation] = STATE(9721),
    [aux_sym_heredoc_body_repeat1] = STATE(9721),
    [sym__heredoc_content] = ACTIONS(13506),
    [sym_heredoc_end] = ACTIONS(13508),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(13506),
  },
  [8070] = {
    [sym_heredoc_body] = STATE(9722),
    [aux_sym_call_repeat1] = STATE(9722),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(11577),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4383),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_then] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [8071] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5615),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5621),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(5621),
    [sym__argument] = STATE(9723),
    [sym_splat_argument] = STATE(9723),
    [sym_hash_splat_argument] = STATE(9723),
    [sym_block_argument] = STATE(9723),
    [sym_assignment] = STATE(5615),
    [sym_operator_assignment] = STATE(5615),
    [sym_conditional] = STATE(5615),
    [sym_range] = STATE(5615),
    [sym_binary] = STATE(5615),
    [sym_unary] = STATE(5615),
    [sym_left_assignment_list] = STATE(5620),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5621),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5621),
    [sym_false] = STATE(5621),
    [sym_nil] = STATE(5621),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5622),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(9724),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(9723),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(8787),
    [sym__splat_star] = ACTIONS(8789),
    [sym__unary_minus] = ACTIONS(8791),
    [sym__identifier_hash_key] = ACTIONS(8793),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(8797),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8799),
    [anon_sym_yield] = ACTIONS(8801),
    [anon_sym_break] = ACTIONS(8803),
    [anon_sym_next] = ACTIONS(8805),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8809),
    [anon_sym_defined_QMARK] = ACTIONS(8811),
    [anon_sym_not] = ACTIONS(8813),
    [anon_sym_BANG] = ACTIONS(8815),
    [anon_sym_TILDE] = ACTIONS(8815),
    [sym_constant] = ACTIONS(8817),
    [sym_identifier] = ACTIONS(8817),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8072] = {
    [sym_heredoc_body] = STATE(9725),
    [aux_sym_call_repeat1] = STATE(9725),
    [aux_sym_argument_list_repeat1] = STATE(9726),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(11577),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4383),
    [anon_sym_COMMA] = ACTIONS(11579),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_then] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [8073] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9727),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5621),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(5621),
    [sym_splat_argument] = STATE(9728),
    [sym_assignment] = STATE(9727),
    [sym_operator_assignment] = STATE(9727),
    [sym_conditional] = STATE(9727),
    [sym_range] = STATE(9727),
    [sym_binary] = STATE(9727),
    [sym_unary] = STATE(9727),
    [sym_right_assignment_list] = STATE(2570),
    [sym__arg_or_splat_arg] = STATE(9728),
    [sym_left_assignment_list] = STATE(5620),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5621),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5621),
    [sym_false] = STATE(5621),
    [sym_nil] = STATE(5621),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(8041),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__splat_star] = ACTIONS(11537),
    [sym__unary_minus] = ACTIONS(8791),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8799),
    [anon_sym_yield] = ACTIONS(8801),
    [anon_sym_break] = ACTIONS(8803),
    [anon_sym_next] = ACTIONS(8805),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8809),
    [anon_sym_defined_QMARK] = ACTIONS(8811),
    [anon_sym_not] = ACTIONS(8813),
    [anon_sym_BANG] = ACTIONS(8815),
    [anon_sym_TILDE] = ACTIONS(8815),
    [sym_constant] = ACTIONS(5173),
    [sym_identifier] = ACTIONS(5173),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8074] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9729),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5621),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(5621),
    [sym_assignment] = STATE(9729),
    [sym_operator_assignment] = STATE(9729),
    [sym_conditional] = STATE(9729),
    [sym_range] = STATE(9729),
    [sym_binary] = STATE(9729),
    [sym_unary] = STATE(9729),
    [sym_left_assignment_list] = STATE(5620),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5621),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5621),
    [sym_false] = STATE(5621),
    [sym_nil] = STATE(5621),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(8041),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(8791),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8799),
    [anon_sym_yield] = ACTIONS(8801),
    [anon_sym_break] = ACTIONS(8803),
    [anon_sym_next] = ACTIONS(8805),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8809),
    [anon_sym_defined_QMARK] = ACTIONS(8811),
    [anon_sym_not] = ACTIONS(8813),
    [anon_sym_BANG] = ACTIONS(8815),
    [anon_sym_TILDE] = ACTIONS(8815),
    [sym_constant] = ACTIONS(5173),
    [sym_identifier] = ACTIONS(5173),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8075] = {
    [sym_string] = STATE(9730),
    [aux_sym_chained_string_repeat1] = STATE(9730),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_then] = ACTIONS(2753),
    [anon_sym_EQ_GT] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [8076] = {
    [anon_sym_end] = ACTIONS(13510),
    [anon_sym_else] = ACTIONS(13510),
    [anon_sym_ensure] = ACTIONS(13510),
    [sym_comment] = ACTIONS(87),
  },
  [8077] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9731),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1175),
    [sym_scope_resolution] = STATE(1172),
    [sym_call] = STATE(1172),
    [sym_method_call] = STATE(1175),
    [sym_assignment] = STATE(9731),
    [sym_operator_assignment] = STATE(9731),
    [sym_conditional] = STATE(9731),
    [sym_range] = STATE(9731),
    [sym_binary] = STATE(9731),
    [sym_unary] = STATE(9731),
    [sym_left_assignment_list] = STATE(1174),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1175),
    [sym__variable] = STATE(1172),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1175),
    [sym_false] = STATE(1175),
    [sym_nil] = STATE(1175),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1176),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2081),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2085),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_next] = ACTIONS(2089),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2095),
    [anon_sym_defined_QMARK] = ACTIONS(2097),
    [anon_sym_not] = ACTIONS(2099),
    [anon_sym_BANG] = ACTIONS(2101),
    [anon_sym_TILDE] = ACTIONS(2101),
    [sym_constant] = ACTIONS(2103),
    [sym_identifier] = ACTIONS(2103),
    [sym_instance_variable] = ACTIONS(2105),
    [sym_class_variable] = ACTIONS(2105),
    [sym_global_variable] = ACTIONS(2105),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2103),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2103),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8078] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(8833),
    [sym__binary_star] = ACTIONS(8835),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(8837),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(8839),
    [anon_sym_AMP] = ACTIONS(8841),
    [anon_sym_EQ] = ACTIONS(7822),
    [anon_sym_LT] = ACTIONS(8843),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_then] = ACTIONS(6823),
    [anon_sym_EQ_GT] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_PLUS_EQ] = ACTIONS(6823),
    [anon_sym_DASH_EQ] = ACTIONS(6823),
    [anon_sym_STAR_EQ] = ACTIONS(6823),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6823),
    [anon_sym_SLASH_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6823),
    [anon_sym_AMP_EQ] = ACTIONS(6823),
    [anon_sym_PERCENT_EQ] = ACTIONS(6823),
    [anon_sym_GT_GT_EQ] = ACTIONS(6823),
    [anon_sym_LT_LT_EQ] = ACTIONS(6823),
    [anon_sym_CARET_EQ] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(8845),
    [anon_sym_DOT_DOT] = ACTIONS(8847),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8849),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(8851),
    [anon_sym_AMP_AMP] = ACTIONS(8851),
    [anon_sym_LT_LT] = ACTIONS(8853),
    [anon_sym_GT_GT] = ACTIONS(8853),
    [anon_sym_EQ_EQ] = ACTIONS(8851),
    [anon_sym_BANG_EQ] = ACTIONS(8855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8855),
    [anon_sym_LT_EQ_GT] = ACTIONS(8855),
    [anon_sym_EQ_TILDE] = ACTIONS(8855),
    [anon_sym_BANG_TILDE] = ACTIONS(8855),
    [anon_sym_LT_EQ] = ACTIONS(8843),
    [anon_sym_GT] = ACTIONS(8843),
    [anon_sym_GT_EQ] = ACTIONS(8857),
    [anon_sym_CARET] = ACTIONS(8837),
    [anon_sym_PLUS] = ACTIONS(8859),
    [anon_sym_SLASH] = ACTIONS(8839),
    [anon_sym_PERCENT] = ACTIONS(8839),
    [sym_comment] = ACTIONS(87),
  },
  [8079] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(8833),
    [sym__binary_star] = ACTIONS(8835),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(8837),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(8839),
    [anon_sym_AMP] = ACTIONS(8841),
    [anon_sym_EQ] = ACTIONS(7884),
    [anon_sym_LT] = ACTIONS(8843),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_then] = ACTIONS(7027),
    [anon_sym_EQ_GT] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_PLUS_EQ] = ACTIONS(7027),
    [anon_sym_DASH_EQ] = ACTIONS(7027),
    [anon_sym_STAR_EQ] = ACTIONS(7027),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7027),
    [anon_sym_SLASH_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7027),
    [anon_sym_AMP_EQ] = ACTIONS(7027),
    [anon_sym_PERCENT_EQ] = ACTIONS(7027),
    [anon_sym_GT_GT_EQ] = ACTIONS(7027),
    [anon_sym_LT_LT_EQ] = ACTIONS(7027),
    [anon_sym_CARET_EQ] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(8845),
    [anon_sym_DOT_DOT] = ACTIONS(8847),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8849),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(8851),
    [anon_sym_AMP_AMP] = ACTIONS(8851),
    [anon_sym_LT_LT] = ACTIONS(8853),
    [anon_sym_GT_GT] = ACTIONS(8853),
    [anon_sym_EQ_EQ] = ACTIONS(8851),
    [anon_sym_BANG_EQ] = ACTIONS(8855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8855),
    [anon_sym_LT_EQ_GT] = ACTIONS(8855),
    [anon_sym_EQ_TILDE] = ACTIONS(8855),
    [anon_sym_BANG_TILDE] = ACTIONS(8855),
    [anon_sym_LT_EQ] = ACTIONS(8843),
    [anon_sym_GT] = ACTIONS(8843),
    [anon_sym_GT_EQ] = ACTIONS(8857),
    [anon_sym_CARET] = ACTIONS(8837),
    [anon_sym_PLUS] = ACTIONS(8859),
    [anon_sym_SLASH] = ACTIONS(8839),
    [anon_sym_PERCENT] = ACTIONS(8839),
    [sym_comment] = ACTIONS(87),
  },
  [8080] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(8835),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8839),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(8839),
    [anon_sym_PERCENT] = ACTIONS(8839),
    [sym_comment] = ACTIONS(87),
  },
  [8081] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8839),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(5827),
    [anon_sym_PERCENT] = ACTIONS(5827),
    [sym_comment] = ACTIONS(87),
  },
  [8082] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8833),
    [sym__binary_star] = ACTIONS(8835),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8839),
    [anon_sym_AMP] = ACTIONS(8841),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(8853),
    [anon_sym_GT_GT] = ACTIONS(8853),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(8859),
    [anon_sym_SLASH] = ACTIONS(8839),
    [anon_sym_PERCENT] = ACTIONS(8839),
    [sym_comment] = ACTIONS(87),
  },
  [8083] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8833),
    [sym__binary_star] = ACTIONS(8835),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8839),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(8853),
    [anon_sym_GT_GT] = ACTIONS(8853),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(8859),
    [anon_sym_SLASH] = ACTIONS(8839),
    [anon_sym_PERCENT] = ACTIONS(8839),
    [sym_comment] = ACTIONS(87),
  },
  [8084] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8833),
    [sym__binary_star] = ACTIONS(8835),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(8837),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8839),
    [anon_sym_AMP] = ACTIONS(8841),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(8853),
    [anon_sym_GT_GT] = ACTIONS(8853),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(8837),
    [anon_sym_PLUS] = ACTIONS(8859),
    [anon_sym_SLASH] = ACTIONS(8839),
    [anon_sym_PERCENT] = ACTIONS(8839),
    [sym_comment] = ACTIONS(87),
  },
  [8085] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(13512),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [8086] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(8833),
    [sym__binary_star] = ACTIONS(8835),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(8837),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(8839),
    [anon_sym_AMP] = ACTIONS(8841),
    [anon_sym_EQ] = ACTIONS(7888),
    [anon_sym_LT] = ACTIONS(8843),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_then] = ACTIONS(5927),
    [anon_sym_EQ_GT] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_PLUS_EQ] = ACTIONS(5927),
    [anon_sym_DASH_EQ] = ACTIONS(5927),
    [anon_sym_STAR_EQ] = ACTIONS(5927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5927),
    [anon_sym_SLASH_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5927),
    [anon_sym_AMP_EQ] = ACTIONS(5927),
    [anon_sym_PERCENT_EQ] = ACTIONS(5927),
    [anon_sym_GT_GT_EQ] = ACTIONS(5927),
    [anon_sym_LT_LT_EQ] = ACTIONS(5927),
    [anon_sym_CARET_EQ] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(8847),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8849),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(8851),
    [anon_sym_AMP_AMP] = ACTIONS(8851),
    [anon_sym_LT_LT] = ACTIONS(8853),
    [anon_sym_GT_GT] = ACTIONS(8853),
    [anon_sym_EQ_EQ] = ACTIONS(8851),
    [anon_sym_BANG_EQ] = ACTIONS(8855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8855),
    [anon_sym_LT_EQ_GT] = ACTIONS(8855),
    [anon_sym_EQ_TILDE] = ACTIONS(8855),
    [anon_sym_BANG_TILDE] = ACTIONS(8855),
    [anon_sym_LT_EQ] = ACTIONS(8843),
    [anon_sym_GT] = ACTIONS(8843),
    [anon_sym_GT_EQ] = ACTIONS(8857),
    [anon_sym_CARET] = ACTIONS(8837),
    [anon_sym_PLUS] = ACTIONS(8859),
    [anon_sym_SLASH] = ACTIONS(8839),
    [anon_sym_PERCENT] = ACTIONS(8839),
    [sym_comment] = ACTIONS(87),
  },
  [8087] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8833),
    [sym__binary_star] = ACTIONS(8835),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(8837),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8839),
    [anon_sym_AMP] = ACTIONS(8841),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(8843),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(8845),
    [anon_sym_DOT_DOT] = ACTIONS(8847),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8849),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(8851),
    [anon_sym_AMP_AMP] = ACTIONS(8851),
    [anon_sym_LT_LT] = ACTIONS(8853),
    [anon_sym_GT_GT] = ACTIONS(8853),
    [anon_sym_EQ_EQ] = ACTIONS(8851),
    [anon_sym_BANG_EQ] = ACTIONS(8855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8855),
    [anon_sym_LT_EQ_GT] = ACTIONS(8855),
    [anon_sym_EQ_TILDE] = ACTIONS(8855),
    [anon_sym_BANG_TILDE] = ACTIONS(8855),
    [anon_sym_LT_EQ] = ACTIONS(8843),
    [anon_sym_GT] = ACTIONS(8843),
    [anon_sym_GT_EQ] = ACTIONS(8857),
    [anon_sym_CARET] = ACTIONS(8837),
    [anon_sym_PLUS] = ACTIONS(8859),
    [anon_sym_SLASH] = ACTIONS(8839),
    [anon_sym_PERCENT] = ACTIONS(8839),
    [sym_comment] = ACTIONS(87),
  },
  [8088] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8833),
    [sym__binary_star] = ACTIONS(8835),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(8837),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8839),
    [anon_sym_AMP] = ACTIONS(8841),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(8843),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(8853),
    [anon_sym_GT_GT] = ACTIONS(8853),
    [anon_sym_EQ_EQ] = ACTIONS(8851),
    [anon_sym_BANG_EQ] = ACTIONS(8855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8855),
    [anon_sym_LT_EQ_GT] = ACTIONS(8855),
    [anon_sym_EQ_TILDE] = ACTIONS(8855),
    [anon_sym_BANG_TILDE] = ACTIONS(8855),
    [anon_sym_LT_EQ] = ACTIONS(8843),
    [anon_sym_GT] = ACTIONS(8843),
    [anon_sym_GT_EQ] = ACTIONS(8857),
    [anon_sym_CARET] = ACTIONS(8837),
    [anon_sym_PLUS] = ACTIONS(8859),
    [anon_sym_SLASH] = ACTIONS(8839),
    [anon_sym_PERCENT] = ACTIONS(8839),
    [sym_comment] = ACTIONS(87),
  },
  [8089] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8833),
    [sym__binary_star] = ACTIONS(8835),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8839),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(8859),
    [anon_sym_SLASH] = ACTIONS(8839),
    [anon_sym_PERCENT] = ACTIONS(8839),
    [sym_comment] = ACTIONS(87),
  },
  [8090] = {
    [sym_heredoc_body] = STATE(8090),
    [aux_sym_call_repeat1] = STATE(8090),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(10978),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7919),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_EQ] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_then] = ACTIONS(7914),
    [anon_sym_EQ_GT] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_PLUS_EQ] = ACTIONS(7914),
    [anon_sym_DASH_EQ] = ACTIONS(7914),
    [anon_sym_STAR_EQ] = ACTIONS(7914),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7914),
    [anon_sym_SLASH_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7914),
    [anon_sym_AMP_EQ] = ACTIONS(7914),
    [anon_sym_PERCENT_EQ] = ACTIONS(7914),
    [anon_sym_GT_GT_EQ] = ACTIONS(7914),
    [anon_sym_LT_LT_EQ] = ACTIONS(7914),
    [anon_sym_CARET_EQ] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7919),
    [anon_sym_AMP_AMP] = ACTIONS(7919),
    [anon_sym_LT_LT] = ACTIONS(7919),
    [anon_sym_GT_GT] = ACTIONS(7919),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7919),
    [anon_sym_PLUS] = ACTIONS(7919),
    [anon_sym_SLASH] = ACTIONS(7919),
    [anon_sym_PERCENT] = ACTIONS(7919),
    [sym_comment] = ACTIONS(87),
  },
  [8091] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3091),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3096),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(3096),
    [sym__argument] = STATE(7437),
    [sym_splat_argument] = STATE(7437),
    [sym_hash_splat_argument] = STATE(7437),
    [sym_block_argument] = STATE(7437),
    [sym_assignment] = STATE(3091),
    [sym_operator_assignment] = STATE(3091),
    [sym_conditional] = STATE(3091),
    [sym_range] = STATE(3091),
    [sym_binary] = STATE(3091),
    [sym_unary] = STATE(3091),
    [sym_left_assignment_list] = STATE(3095),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3096),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3096),
    [sym_false] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3097),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(7437),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(5145),
    [sym__splat_star] = ACTIONS(5147),
    [sym__unary_minus] = ACTIONS(5149),
    [sym__identifier_hash_key] = ACTIONS(5151),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11595),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5153),
    [anon_sym_yield] = ACTIONS(5155),
    [anon_sym_break] = ACTIONS(5157),
    [anon_sym_next] = ACTIONS(5159),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(8827),
    [anon_sym_defined_QMARK] = ACTIONS(5161),
    [anon_sym_not] = ACTIONS(5163),
    [anon_sym_BANG] = ACTIONS(5167),
    [anon_sym_TILDE] = ACTIONS(5167),
    [sym_constant] = ACTIONS(5169),
    [sym_identifier] = ACTIONS(5169),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [8092] = {
    [sym_heredoc_body] = STATE(8090),
    [aux_sym_call_repeat1] = STATE(8090),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7931),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_EQ] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_then] = ACTIONS(7929),
    [anon_sym_EQ_GT] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_PLUS_EQ] = ACTIONS(7929),
    [anon_sym_DASH_EQ] = ACTIONS(7929),
    [anon_sym_STAR_EQ] = ACTIONS(7929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7929),
    [anon_sym_SLASH_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7929),
    [anon_sym_AMP_EQ] = ACTIONS(7929),
    [anon_sym_PERCENT_EQ] = ACTIONS(7929),
    [anon_sym_GT_GT_EQ] = ACTIONS(7929),
    [anon_sym_LT_LT_EQ] = ACTIONS(7929),
    [anon_sym_CARET_EQ] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7931),
    [anon_sym_AMP_AMP] = ACTIONS(7931),
    [anon_sym_LT_LT] = ACTIONS(7931),
    [anon_sym_GT_GT] = ACTIONS(7931),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7931),
    [anon_sym_PLUS] = ACTIONS(7931),
    [anon_sym_SLASH] = ACTIONS(7931),
    [anon_sym_PERCENT] = ACTIONS(7931),
    [sym_comment] = ACTIONS(87),
  },
  [8093] = {
    [aux_sym_argument_list_repeat1] = STATE(8093),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(13514),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7927),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_EQ] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_then] = ACTIONS(7925),
    [anon_sym_EQ_GT] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_PLUS_EQ] = ACTIONS(7925),
    [anon_sym_DASH_EQ] = ACTIONS(7925),
    [anon_sym_STAR_EQ] = ACTIONS(7925),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7925),
    [anon_sym_SLASH_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7925),
    [anon_sym_AMP_EQ] = ACTIONS(7925),
    [anon_sym_PERCENT_EQ] = ACTIONS(7925),
    [anon_sym_GT_GT_EQ] = ACTIONS(7925),
    [anon_sym_LT_LT_EQ] = ACTIONS(7925),
    [anon_sym_CARET_EQ] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7927),
    [anon_sym_AMP_AMP] = ACTIONS(7927),
    [anon_sym_LT_LT] = ACTIONS(7927),
    [anon_sym_GT_GT] = ACTIONS(7927),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7927),
    [anon_sym_PLUS] = ACTIONS(7927),
    [anon_sym_SLASH] = ACTIONS(7927),
    [anon_sym_PERCENT] = ACTIONS(7927),
    [sym_comment] = ACTIONS(87),
  },
  [8094] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(8833),
    [sym__binary_star] = ACTIONS(8835),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(8837),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(8839),
    [anon_sym_AMP] = ACTIONS(8841),
    [anon_sym_EQ] = ACTIONS(7936),
    [anon_sym_LT] = ACTIONS(8843),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_then] = ACTIONS(5115),
    [anon_sym_EQ_GT] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_PLUS_EQ] = ACTIONS(5115),
    [anon_sym_DASH_EQ] = ACTIONS(5115),
    [anon_sym_STAR_EQ] = ACTIONS(5115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5115),
    [anon_sym_SLASH_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5115),
    [anon_sym_AMP_EQ] = ACTIONS(5115),
    [anon_sym_PERCENT_EQ] = ACTIONS(5115),
    [anon_sym_GT_GT_EQ] = ACTIONS(5115),
    [anon_sym_LT_LT_EQ] = ACTIONS(5115),
    [anon_sym_CARET_EQ] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(8845),
    [anon_sym_DOT_DOT] = ACTIONS(8847),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8849),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(8851),
    [anon_sym_AMP_AMP] = ACTIONS(8851),
    [anon_sym_LT_LT] = ACTIONS(8853),
    [anon_sym_GT_GT] = ACTIONS(8853),
    [anon_sym_EQ_EQ] = ACTIONS(8851),
    [anon_sym_BANG_EQ] = ACTIONS(8855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8855),
    [anon_sym_LT_EQ_GT] = ACTIONS(8855),
    [anon_sym_EQ_TILDE] = ACTIONS(8855),
    [anon_sym_BANG_TILDE] = ACTIONS(8855),
    [anon_sym_LT_EQ] = ACTIONS(8843),
    [anon_sym_GT] = ACTIONS(8843),
    [anon_sym_GT_EQ] = ACTIONS(8857),
    [anon_sym_CARET] = ACTIONS(8837),
    [anon_sym_PLUS] = ACTIONS(8859),
    [anon_sym_SLASH] = ACTIONS(8839),
    [anon_sym_PERCENT] = ACTIONS(8839),
    [sym_comment] = ACTIONS(87),
  },
  [8095] = {
    [aux_sym_exceptions_repeat1] = STATE(9734),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6193),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_then] = ACTIONS(6191),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_PLUS_EQ] = ACTIONS(6191),
    [anon_sym_DASH_EQ] = ACTIONS(6191),
    [anon_sym_STAR_EQ] = ACTIONS(6191),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6191),
    [anon_sym_SLASH_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6191),
    [anon_sym_AMP_EQ] = ACTIONS(6191),
    [anon_sym_PERCENT_EQ] = ACTIONS(6191),
    [anon_sym_GT_GT_EQ] = ACTIONS(6191),
    [anon_sym_LT_LT_EQ] = ACTIONS(6191),
    [anon_sym_CARET_EQ] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6193),
    [anon_sym_AMP_AMP] = ACTIONS(6193),
    [anon_sym_LT_LT] = ACTIONS(6193),
    [anon_sym_GT_GT] = ACTIONS(6193),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6193),
    [anon_sym_PLUS] = ACTIONS(6193),
    [anon_sym_SLASH] = ACTIONS(6193),
    [anon_sym_PERCENT] = ACTIONS(6193),
    [sym_comment] = ACTIONS(87),
  },
  [8096] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(8833),
    [sym__binary_star] = ACTIONS(8835),
    [anon_sym_LBRACE] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(8837),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(8839),
    [anon_sym_AMP] = ACTIONS(8841),
    [anon_sym_EQ] = ACTIONS(7938),
    [anon_sym_LT] = ACTIONS(8843),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_then] = ACTIONS(6210),
    [anon_sym_EQ_GT] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_PLUS_EQ] = ACTIONS(6210),
    [anon_sym_DASH_EQ] = ACTIONS(6210),
    [anon_sym_STAR_EQ] = ACTIONS(6210),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6210),
    [anon_sym_SLASH_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6210),
    [anon_sym_AMP_EQ] = ACTIONS(6210),
    [anon_sym_PERCENT_EQ] = ACTIONS(6210),
    [anon_sym_GT_GT_EQ] = ACTIONS(6210),
    [anon_sym_LT_LT_EQ] = ACTIONS(6210),
    [anon_sym_CARET_EQ] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(8845),
    [anon_sym_DOT_DOT] = ACTIONS(8847),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8849),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(8851),
    [anon_sym_AMP_AMP] = ACTIONS(8851),
    [anon_sym_LT_LT] = ACTIONS(8853),
    [anon_sym_GT_GT] = ACTIONS(8853),
    [anon_sym_EQ_EQ] = ACTIONS(8851),
    [anon_sym_BANG_EQ] = ACTIONS(8855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8855),
    [anon_sym_LT_EQ_GT] = ACTIONS(8855),
    [anon_sym_EQ_TILDE] = ACTIONS(8855),
    [anon_sym_BANG_TILDE] = ACTIONS(8855),
    [anon_sym_LT_EQ] = ACTIONS(8843),
    [anon_sym_GT] = ACTIONS(8843),
    [anon_sym_GT_EQ] = ACTIONS(8857),
    [anon_sym_CARET] = ACTIONS(8837),
    [anon_sym_PLUS] = ACTIONS(8859),
    [anon_sym_SLASH] = ACTIONS(8839),
    [anon_sym_PERCENT] = ACTIONS(8839),
    [sym_comment] = ACTIONS(87),
  },
  [8097] = {
    [sym_string] = STATE(8097),
    [aux_sym_chained_string_repeat1] = STATE(8097),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(9852),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6217),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_EQ] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_do] = ACTIONS(6212),
    [anon_sym_then] = ACTIONS(6212),
    [anon_sym_EQ_GT] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_PLUS_EQ] = ACTIONS(6212),
    [anon_sym_DASH_EQ] = ACTIONS(6212),
    [anon_sym_STAR_EQ] = ACTIONS(6212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6212),
    [anon_sym_SLASH_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6212),
    [anon_sym_AMP_EQ] = ACTIONS(6212),
    [anon_sym_PERCENT_EQ] = ACTIONS(6212),
    [anon_sym_GT_GT_EQ] = ACTIONS(6212),
    [anon_sym_LT_LT_EQ] = ACTIONS(6212),
    [anon_sym_CARET_EQ] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6217),
    [anon_sym_AMP_AMP] = ACTIONS(6217),
    [anon_sym_LT_LT] = ACTIONS(6217),
    [anon_sym_GT_GT] = ACTIONS(6217),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6217),
    [anon_sym_PLUS] = ACTIONS(6217),
    [anon_sym_SLASH] = ACTIONS(6217),
    [anon_sym_PERCENT] = ACTIONS(6217),
    [sym_comment] = ACTIONS(87),
  },
  [8098] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(5117),
    [sym__binary_star] = ACTIONS(5119),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(5121),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(5119),
    [anon_sym_AMP] = ACTIONS(5123),
    [anon_sym_LT] = ACTIONS(5125),
    [anon_sym_then] = ACTIONS(4247),
    [anon_sym_EQ_GT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(5127),
    [anon_sym_DOT_DOT] = ACTIONS(5129),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5131),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(5135),
    [anon_sym_AMP_AMP] = ACTIONS(5135),
    [anon_sym_LT_LT] = ACTIONS(5137),
    [anon_sym_GT_GT] = ACTIONS(5137),
    [anon_sym_EQ_EQ] = ACTIONS(5139),
    [anon_sym_BANG_EQ] = ACTIONS(5135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5135),
    [anon_sym_LT_EQ_GT] = ACTIONS(5135),
    [anon_sym_EQ_TILDE] = ACTIONS(5135),
    [anon_sym_BANG_TILDE] = ACTIONS(5135),
    [anon_sym_LT_EQ] = ACTIONS(5125),
    [anon_sym_GT] = ACTIONS(5125),
    [anon_sym_GT_EQ] = ACTIONS(5141),
    [anon_sym_CARET] = ACTIONS(5143),
    [anon_sym_PLUS] = ACTIONS(5117),
    [anon_sym_SLASH] = ACTIONS(5119),
    [anon_sym_PERCENT] = ACTIONS(5119),
    [sym_comment] = ACTIONS(87),
  },
  [8099] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5663),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1175),
    [sym_scope_resolution] = STATE(1172),
    [sym_call] = STATE(1172),
    [sym_method_call] = STATE(1175),
    [sym_splat_argument] = STATE(6406),
    [sym_assignment] = STATE(5663),
    [sym_operator_assignment] = STATE(5663),
    [sym_conditional] = STATE(5663),
    [sym_range] = STATE(5663),
    [sym_binary] = STATE(5663),
    [sym_unary] = STATE(5663),
    [sym__arg_or_splat_arg] = STATE(6406),
    [sym_left_assignment_list] = STATE(1174),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1175),
    [sym__variable] = STATE(1172),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1175),
    [sym_false] = STATE(1175),
    [sym_nil] = STATE(1175),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1176),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__splat_star] = ACTIONS(8873),
    [sym__unary_minus] = ACTIONS(2081),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2085),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_next] = ACTIONS(2089),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2095),
    [anon_sym_defined_QMARK] = ACTIONS(2097),
    [anon_sym_not] = ACTIONS(2099),
    [anon_sym_BANG] = ACTIONS(2101),
    [anon_sym_TILDE] = ACTIONS(2101),
    [sym_constant] = ACTIONS(2103),
    [sym_identifier] = ACTIONS(2103),
    [sym_instance_variable] = ACTIONS(2105),
    [sym_class_variable] = ACTIONS(2105),
    [sym_global_variable] = ACTIONS(2105),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2103),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2103),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8100] = {
    [aux_sym_exceptions_repeat1] = STATE(9735),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_COMMA] = ACTIONS(13517),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_then] = ACTIONS(9855),
    [anon_sym_EQ_GT] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [8101] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(11604),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_ensure] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [8102] = {
    [sym_heredoc_body] = STATE(9736),
    [aux_sym_call_repeat1] = STATE(9736),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_ensure] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [8103] = {
    [sym_heredoc_body] = STATE(9736),
    [aux_sym_call_repeat1] = STATE(9736),
    [aux_sym_argument_list_repeat1] = STATE(9737),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(8941),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_ensure] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [8104] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(11602),
    [sym__binary_star] = ACTIONS(11604),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(11606),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(11604),
    [anon_sym_AMP] = ACTIONS(11608),
    [anon_sym_LT] = ACTIONS(11610),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_ensure] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(11612),
    [anon_sym_DOT_DOT] = ACTIONS(11614),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11616),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(11618),
    [anon_sym_AMP_AMP] = ACTIONS(11618),
    [anon_sym_LT_LT] = ACTIONS(11620),
    [anon_sym_GT_GT] = ACTIONS(11620),
    [anon_sym_EQ_EQ] = ACTIONS(11622),
    [anon_sym_BANG_EQ] = ACTIONS(11618),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11618),
    [anon_sym_LT_EQ_GT] = ACTIONS(11618),
    [anon_sym_EQ_TILDE] = ACTIONS(11618),
    [anon_sym_BANG_TILDE] = ACTIONS(11618),
    [anon_sym_LT_EQ] = ACTIONS(11610),
    [anon_sym_GT] = ACTIONS(11610),
    [anon_sym_GT_EQ] = ACTIONS(11624),
    [anon_sym_CARET] = ACTIONS(11626),
    [anon_sym_PLUS] = ACTIONS(11602),
    [anon_sym_SLASH] = ACTIONS(11604),
    [anon_sym_PERCENT] = ACTIONS(11604),
    [sym_comment] = ACTIONS(87),
  },
  [8105] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9738),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5676),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(5676),
    [sym_assignment] = STATE(9738),
    [sym_operator_assignment] = STATE(9738),
    [sym_conditional] = STATE(9738),
    [sym_range] = STATE(9738),
    [sym_binary] = STATE(9738),
    [sym_unary] = STATE(9738),
    [sym_left_assignment_list] = STATE(5675),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5676),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5676),
    [sym_false] = STATE(5676),
    [sym_nil] = STATE(5676),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5677),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8875),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8877),
    [anon_sym_yield] = ACTIONS(8879),
    [anon_sym_break] = ACTIONS(8881),
    [anon_sym_next] = ACTIONS(8883),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8885),
    [anon_sym_defined_QMARK] = ACTIONS(8887),
    [anon_sym_not] = ACTIONS(8889),
    [anon_sym_BANG] = ACTIONS(8891),
    [anon_sym_TILDE] = ACTIONS(8891),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8106] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9739),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5676),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(5676),
    [sym_assignment] = STATE(9739),
    [sym_operator_assignment] = STATE(9739),
    [sym_conditional] = STATE(9739),
    [sym_range] = STATE(9739),
    [sym_binary] = STATE(9739),
    [sym_unary] = STATE(9739),
    [sym_left_assignment_list] = STATE(5675),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5676),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5676),
    [sym_false] = STATE(5676),
    [sym_nil] = STATE(5676),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5677),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8875),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8877),
    [anon_sym_yield] = ACTIONS(8879),
    [anon_sym_break] = ACTIONS(8881),
    [anon_sym_next] = ACTIONS(8883),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8885),
    [anon_sym_defined_QMARK] = ACTIONS(8887),
    [anon_sym_not] = ACTIONS(8889),
    [anon_sym_BANG] = ACTIONS(8891),
    [anon_sym_TILDE] = ACTIONS(8891),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8107] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9740),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5676),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(5676),
    [sym_assignment] = STATE(9740),
    [sym_operator_assignment] = STATE(9740),
    [sym_conditional] = STATE(9740),
    [sym_range] = STATE(9740),
    [sym_binary] = STATE(9740),
    [sym_unary] = STATE(9740),
    [sym_left_assignment_list] = STATE(5675),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5676),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5676),
    [sym_false] = STATE(5676),
    [sym_nil] = STATE(5676),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5677),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8875),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8877),
    [anon_sym_yield] = ACTIONS(8879),
    [anon_sym_break] = ACTIONS(8881),
    [anon_sym_next] = ACTIONS(8883),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8885),
    [anon_sym_defined_QMARK] = ACTIONS(8887),
    [anon_sym_not] = ACTIONS(8889),
    [anon_sym_BANG] = ACTIONS(8891),
    [anon_sym_TILDE] = ACTIONS(8891),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8108] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9741),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5676),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(5676),
    [sym_assignment] = STATE(9741),
    [sym_operator_assignment] = STATE(9741),
    [sym_conditional] = STATE(9741),
    [sym_range] = STATE(9741),
    [sym_binary] = STATE(9741),
    [sym_unary] = STATE(9741),
    [sym_left_assignment_list] = STATE(5675),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5676),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5676),
    [sym_false] = STATE(5676),
    [sym_nil] = STATE(5676),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5677),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8875),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8877),
    [anon_sym_yield] = ACTIONS(8879),
    [anon_sym_break] = ACTIONS(8881),
    [anon_sym_next] = ACTIONS(8883),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8885),
    [anon_sym_defined_QMARK] = ACTIONS(8887),
    [anon_sym_not] = ACTIONS(8889),
    [anon_sym_BANG] = ACTIONS(8891),
    [anon_sym_TILDE] = ACTIONS(8891),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8109] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9742),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5676),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(5676),
    [sym_assignment] = STATE(9742),
    [sym_operator_assignment] = STATE(9742),
    [sym_conditional] = STATE(9742),
    [sym_range] = STATE(9742),
    [sym_binary] = STATE(9742),
    [sym_unary] = STATE(9742),
    [sym_left_assignment_list] = STATE(5675),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5676),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5676),
    [sym_false] = STATE(5676),
    [sym_nil] = STATE(5676),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5677),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8875),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8877),
    [anon_sym_yield] = ACTIONS(8879),
    [anon_sym_break] = ACTIONS(8881),
    [anon_sym_next] = ACTIONS(8883),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8885),
    [anon_sym_defined_QMARK] = ACTIONS(8887),
    [anon_sym_not] = ACTIONS(8889),
    [anon_sym_BANG] = ACTIONS(8891),
    [anon_sym_TILDE] = ACTIONS(8891),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8110] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(9743),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(9743),
    [sym_operator_assignment] = STATE(9743),
    [sym_conditional] = STATE(9743),
    [sym_range] = STATE(9743),
    [sym_binary] = STATE(9743),
    [sym_unary] = STATE(9743),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8111] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9744),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5676),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(5676),
    [sym_assignment] = STATE(9744),
    [sym_operator_assignment] = STATE(9744),
    [sym_conditional] = STATE(9744),
    [sym_range] = STATE(9744),
    [sym_binary] = STATE(9744),
    [sym_unary] = STATE(9744),
    [sym_left_assignment_list] = STATE(5675),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5676),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5676),
    [sym_false] = STATE(5676),
    [sym_nil] = STATE(5676),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5677),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8875),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8877),
    [anon_sym_yield] = ACTIONS(8879),
    [anon_sym_break] = ACTIONS(8881),
    [anon_sym_next] = ACTIONS(8883),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8885),
    [anon_sym_defined_QMARK] = ACTIONS(8887),
    [anon_sym_not] = ACTIONS(8889),
    [anon_sym_BANG] = ACTIONS(8891),
    [anon_sym_TILDE] = ACTIONS(8891),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8112] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9745),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5676),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(5676),
    [sym_assignment] = STATE(9745),
    [sym_operator_assignment] = STATE(9745),
    [sym_conditional] = STATE(9745),
    [sym_range] = STATE(9745),
    [sym_binary] = STATE(9745),
    [sym_unary] = STATE(9745),
    [sym_left_assignment_list] = STATE(5675),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5676),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5676),
    [sym_false] = STATE(5676),
    [sym_nil] = STATE(5676),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5677),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8875),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8877),
    [anon_sym_yield] = ACTIONS(8879),
    [anon_sym_break] = ACTIONS(8881),
    [anon_sym_next] = ACTIONS(8883),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8885),
    [anon_sym_defined_QMARK] = ACTIONS(8887),
    [anon_sym_not] = ACTIONS(8889),
    [anon_sym_BANG] = ACTIONS(8891),
    [anon_sym_TILDE] = ACTIONS(8891),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8113] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9746),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5676),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(5676),
    [sym_assignment] = STATE(9746),
    [sym_operator_assignment] = STATE(9746),
    [sym_conditional] = STATE(9746),
    [sym_range] = STATE(9746),
    [sym_binary] = STATE(9746),
    [sym_unary] = STATE(9746),
    [sym_left_assignment_list] = STATE(5675),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5676),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5676),
    [sym_false] = STATE(5676),
    [sym_nil] = STATE(5676),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5677),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8875),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8877),
    [anon_sym_yield] = ACTIONS(8879),
    [anon_sym_break] = ACTIONS(8881),
    [anon_sym_next] = ACTIONS(8883),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8885),
    [anon_sym_defined_QMARK] = ACTIONS(8887),
    [anon_sym_not] = ACTIONS(8889),
    [anon_sym_BANG] = ACTIONS(8891),
    [anon_sym_TILDE] = ACTIONS(8891),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8114] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9747),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5676),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(5676),
    [sym_assignment] = STATE(9747),
    [sym_operator_assignment] = STATE(9747),
    [sym_conditional] = STATE(9747),
    [sym_range] = STATE(9747),
    [sym_binary] = STATE(9747),
    [sym_unary] = STATE(9747),
    [sym_left_assignment_list] = STATE(5675),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5676),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5676),
    [sym_false] = STATE(5676),
    [sym_nil] = STATE(5676),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5677),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8875),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8877),
    [anon_sym_yield] = ACTIONS(8879),
    [anon_sym_break] = ACTIONS(8881),
    [anon_sym_next] = ACTIONS(8883),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8885),
    [anon_sym_defined_QMARK] = ACTIONS(8887),
    [anon_sym_not] = ACTIONS(8889),
    [anon_sym_BANG] = ACTIONS(8891),
    [anon_sym_TILDE] = ACTIONS(8891),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8115] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9748),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5676),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(5676),
    [sym_splat_argument] = STATE(9749),
    [sym_assignment] = STATE(9748),
    [sym_operator_assignment] = STATE(9748),
    [sym_conditional] = STATE(9748),
    [sym_range] = STATE(9748),
    [sym_binary] = STATE(9748),
    [sym_unary] = STATE(9748),
    [sym_right_assignment_list] = STATE(2570),
    [sym__arg_or_splat_arg] = STATE(9749),
    [sym_left_assignment_list] = STATE(5675),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5676),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5676),
    [sym_false] = STATE(5676),
    [sym_nil] = STATE(5676),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5677),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(5191),
    [sym__unary_minus] = ACTIONS(8875),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8877),
    [anon_sym_yield] = ACTIONS(8879),
    [anon_sym_break] = ACTIONS(8881),
    [anon_sym_next] = ACTIONS(8883),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8885),
    [anon_sym_defined_QMARK] = ACTIONS(8887),
    [anon_sym_not] = ACTIONS(8889),
    [anon_sym_BANG] = ACTIONS(8891),
    [anon_sym_TILDE] = ACTIONS(8891),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8116] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9750),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5676),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(5676),
    [sym_assignment] = STATE(9750),
    [sym_operator_assignment] = STATE(9750),
    [sym_conditional] = STATE(9750),
    [sym_range] = STATE(9750),
    [sym_binary] = STATE(9750),
    [sym_unary] = STATE(9750),
    [sym_left_assignment_list] = STATE(5675),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5676),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5676),
    [sym_false] = STATE(5676),
    [sym_nil] = STATE(5676),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5677),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8875),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8877),
    [anon_sym_yield] = ACTIONS(8879),
    [anon_sym_break] = ACTIONS(8881),
    [anon_sym_next] = ACTIONS(8883),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8885),
    [anon_sym_defined_QMARK] = ACTIONS(8887),
    [anon_sym_not] = ACTIONS(8889),
    [anon_sym_BANG] = ACTIONS(8891),
    [anon_sym_TILDE] = ACTIONS(8891),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8117] = {
    [sym_string] = STATE(9751),
    [aux_sym_chained_string_repeat1] = STATE(9751),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_end] = ACTIONS(2753),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_ensure] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [8118] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(11602),
    [sym__binary_star] = ACTIONS(11604),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(11606),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(11604),
    [anon_sym_AMP] = ACTIONS(11608),
    [anon_sym_LT] = ACTIONS(11610),
    [anon_sym_end] = ACTIONS(6823),
    [anon_sym_if] = ACTIONS(6823),
    [anon_sym_unless] = ACTIONS(6823),
    [anon_sym_while] = ACTIONS(6823),
    [anon_sym_until] = ACTIONS(6823),
    [anon_sym_rescue] = ACTIONS(6823),
    [anon_sym_ensure] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(11612),
    [anon_sym_DOT_DOT] = ACTIONS(11614),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11616),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(11618),
    [anon_sym_AMP_AMP] = ACTIONS(11618),
    [anon_sym_LT_LT] = ACTIONS(11620),
    [anon_sym_GT_GT] = ACTIONS(11620),
    [anon_sym_EQ_EQ] = ACTIONS(11622),
    [anon_sym_BANG_EQ] = ACTIONS(11618),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11618),
    [anon_sym_LT_EQ_GT] = ACTIONS(11618),
    [anon_sym_EQ_TILDE] = ACTIONS(11618),
    [anon_sym_BANG_TILDE] = ACTIONS(11618),
    [anon_sym_LT_EQ] = ACTIONS(11610),
    [anon_sym_GT] = ACTIONS(11610),
    [anon_sym_GT_EQ] = ACTIONS(11624),
    [anon_sym_CARET] = ACTIONS(11626),
    [anon_sym_PLUS] = ACTIONS(11602),
    [anon_sym_SLASH] = ACTIONS(11604),
    [anon_sym_PERCENT] = ACTIONS(11604),
    [sym_comment] = ACTIONS(87),
  },
  [8119] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(8907),
    [sym__binary_star] = ACTIONS(8909),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(8911),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(8909),
    [anon_sym_AMP] = ACTIONS(8913),
    [anon_sym_LT] = ACTIONS(8915),
    [anon_sym_end] = ACTIONS(4211),
    [anon_sym_if] = ACTIONS(4211),
    [anon_sym_unless] = ACTIONS(4211),
    [anon_sym_while] = ACTIONS(4211),
    [anon_sym_until] = ACTIONS(4211),
    [anon_sym_rescue] = ACTIONS(4211),
    [anon_sym_ensure] = ACTIONS(4211),
    [anon_sym_EQ_GT] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(8917),
    [anon_sym_DOT_DOT] = ACTIONS(8919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8921),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(8923),
    [anon_sym_AMP_AMP] = ACTIONS(8923),
    [anon_sym_LT_LT] = ACTIONS(8925),
    [anon_sym_GT_GT] = ACTIONS(8925),
    [anon_sym_EQ_EQ] = ACTIONS(8927),
    [anon_sym_BANG_EQ] = ACTIONS(8923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8923),
    [anon_sym_LT_EQ_GT] = ACTIONS(8923),
    [anon_sym_EQ_TILDE] = ACTIONS(8923),
    [anon_sym_BANG_TILDE] = ACTIONS(8923),
    [anon_sym_LT_EQ] = ACTIONS(8915),
    [anon_sym_GT] = ACTIONS(8915),
    [anon_sym_GT_EQ] = ACTIONS(8929),
    [anon_sym_CARET] = ACTIONS(8931),
    [anon_sym_PLUS] = ACTIONS(8907),
    [anon_sym_SLASH] = ACTIONS(8909),
    [anon_sym_PERCENT] = ACTIONS(8909),
    [sym_comment] = ACTIONS(87),
  },
  [8120] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(8907),
    [sym__binary_star] = ACTIONS(8909),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(8911),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(8909),
    [anon_sym_AMP] = ACTIONS(8913),
    [anon_sym_LT] = ACTIONS(8915),
    [anon_sym_end] = ACTIONS(4247),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_ensure] = ACTIONS(4247),
    [anon_sym_EQ_GT] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(8917),
    [anon_sym_DOT_DOT] = ACTIONS(8919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8921),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(8923),
    [anon_sym_AMP_AMP] = ACTIONS(8923),
    [anon_sym_LT_LT] = ACTIONS(8925),
    [anon_sym_GT_GT] = ACTIONS(8925),
    [anon_sym_EQ_EQ] = ACTIONS(8927),
    [anon_sym_BANG_EQ] = ACTIONS(8923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8923),
    [anon_sym_LT_EQ_GT] = ACTIONS(8923),
    [anon_sym_EQ_TILDE] = ACTIONS(8923),
    [anon_sym_BANG_TILDE] = ACTIONS(8923),
    [anon_sym_LT_EQ] = ACTIONS(8915),
    [anon_sym_GT] = ACTIONS(8915),
    [anon_sym_GT_EQ] = ACTIONS(8929),
    [anon_sym_CARET] = ACTIONS(8931),
    [anon_sym_PLUS] = ACTIONS(8907),
    [anon_sym_SLASH] = ACTIONS(8909),
    [anon_sym_PERCENT] = ACTIONS(8909),
    [sym_comment] = ACTIONS(87),
  },
  [8121] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9752),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(3118),
    [sym_call] = STATE(3118),
    [sym_method_call] = STATE(3122),
    [sym_assignment] = STATE(9752),
    [sym_operator_assignment] = STATE(9752),
    [sym_conditional] = STATE(9752),
    [sym_range] = STATE(9752),
    [sym_binary] = STATE(9752),
    [sym_unary] = STATE(9752),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(3118),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5680),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5193),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5197),
    [anon_sym_yield] = ACTIONS(5199),
    [anon_sym_break] = ACTIONS(5201),
    [anon_sym_next] = ACTIONS(5203),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8893),
    [anon_sym_defined_QMARK] = ACTIONS(5205),
    [anon_sym_not] = ACTIONS(5207),
    [anon_sym_BANG] = ACTIONS(5211),
    [anon_sym_TILDE] = ACTIONS(5211),
    [sym_constant] = ACTIONS(5217),
    [sym_identifier] = ACTIONS(5217),
    [sym_instance_variable] = ACTIONS(5215),
    [sym_class_variable] = ACTIONS(5215),
    [sym_global_variable] = ACTIONS(5215),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5217),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5217),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8122] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(8907),
    [sym__binary_star] = ACTIONS(8909),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(8911),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(8909),
    [anon_sym_AMP] = ACTIONS(8913),
    [anon_sym_LT] = ACTIONS(8915),
    [anon_sym_end] = ACTIONS(3281),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_unless] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_until] = ACTIONS(3281),
    [anon_sym_rescue] = ACTIONS(3281),
    [anon_sym_ensure] = ACTIONS(3281),
    [anon_sym_EQ_GT] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(8917),
    [anon_sym_DOT_DOT] = ACTIONS(8919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8921),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(8923),
    [anon_sym_AMP_AMP] = ACTIONS(8923),
    [anon_sym_LT_LT] = ACTIONS(8925),
    [anon_sym_GT_GT] = ACTIONS(8925),
    [anon_sym_EQ_EQ] = ACTIONS(8927),
    [anon_sym_BANG_EQ] = ACTIONS(8923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8923),
    [anon_sym_LT_EQ_GT] = ACTIONS(8923),
    [anon_sym_EQ_TILDE] = ACTIONS(8923),
    [anon_sym_BANG_TILDE] = ACTIONS(8923),
    [anon_sym_LT_EQ] = ACTIONS(8915),
    [anon_sym_GT] = ACTIONS(8915),
    [anon_sym_GT_EQ] = ACTIONS(8929),
    [anon_sym_CARET] = ACTIONS(8931),
    [anon_sym_PLUS] = ACTIONS(8907),
    [anon_sym_SLASH] = ACTIONS(8909),
    [anon_sym_PERCENT] = ACTIONS(8909),
    [sym_comment] = ACTIONS(87),
  },
  [8123] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9753),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(3118),
    [sym_call] = STATE(3118),
    [sym_method_call] = STATE(3122),
    [sym_assignment] = STATE(9753),
    [sym_operator_assignment] = STATE(9753),
    [sym_conditional] = STATE(9753),
    [sym_range] = STATE(9753),
    [sym_binary] = STATE(9753),
    [sym_unary] = STATE(9753),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(3118),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5680),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5193),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5197),
    [anon_sym_yield] = ACTIONS(5199),
    [anon_sym_break] = ACTIONS(5201),
    [anon_sym_next] = ACTIONS(5203),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8893),
    [anon_sym_defined_QMARK] = ACTIONS(5205),
    [anon_sym_not] = ACTIONS(5207),
    [anon_sym_BANG] = ACTIONS(5211),
    [anon_sym_TILDE] = ACTIONS(5211),
    [sym_constant] = ACTIONS(5217),
    [sym_identifier] = ACTIONS(5217),
    [sym_instance_variable] = ACTIONS(5215),
    [sym_class_variable] = ACTIONS(5215),
    [sym_global_variable] = ACTIONS(5215),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5217),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5217),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8124] = {
    [sym_heredoc_body] = STATE(9754),
    [aux_sym_call_repeat1] = STATE(9754),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_ensure] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [8125] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5688),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(3118),
    [sym_call] = STATE(3118),
    [sym_method_call] = STATE(3122),
    [sym__argument] = STATE(2565),
    [sym_splat_argument] = STATE(2565),
    [sym_hash_splat_argument] = STATE(2565),
    [sym_block_argument] = STATE(2565),
    [sym_assignment] = STATE(5688),
    [sym_operator_assignment] = STATE(5688),
    [sym_conditional] = STATE(5688),
    [sym_range] = STATE(5688),
    [sym_binary] = STATE(5688),
    [sym_unary] = STATE(5688),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(3118),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5691),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(9755),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2565),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(8897),
    [sym__splat_star] = ACTIONS(8899),
    [sym__unary_minus] = ACTIONS(5193),
    [sym__identifier_hash_key] = ACTIONS(8901),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13519),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5197),
    [anon_sym_yield] = ACTIONS(5199),
    [anon_sym_break] = ACTIONS(5201),
    [anon_sym_next] = ACTIONS(5203),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8893),
    [anon_sym_defined_QMARK] = ACTIONS(5205),
    [anon_sym_not] = ACTIONS(5207),
    [anon_sym_BANG] = ACTIONS(5211),
    [anon_sym_TILDE] = ACTIONS(5211),
    [sym_constant] = ACTIONS(8903),
    [sym_identifier] = ACTIONS(8903),
    [sym_instance_variable] = ACTIONS(5215),
    [sym_class_variable] = ACTIONS(5215),
    [sym_global_variable] = ACTIONS(5215),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5217),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5217),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8126] = {
    [sym_heredoc_body] = STATE(9756),
    [aux_sym_call_repeat1] = STATE(9756),
    [aux_sym_argument_list_repeat1] = STATE(9757),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(11638),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_ensure] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [8127] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(11602),
    [sym__binary_star] = ACTIONS(11604),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(11606),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(11604),
    [anon_sym_AMP] = ACTIONS(11608),
    [anon_sym_LT] = ACTIONS(11610),
    [anon_sym_end] = ACTIONS(7027),
    [anon_sym_if] = ACTIONS(7027),
    [anon_sym_unless] = ACTIONS(7027),
    [anon_sym_while] = ACTIONS(7027),
    [anon_sym_until] = ACTIONS(7027),
    [anon_sym_rescue] = ACTIONS(7027),
    [anon_sym_ensure] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(11612),
    [anon_sym_DOT_DOT] = ACTIONS(11614),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11616),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(11618),
    [anon_sym_AMP_AMP] = ACTIONS(11618),
    [anon_sym_LT_LT] = ACTIONS(11620),
    [anon_sym_GT_GT] = ACTIONS(11620),
    [anon_sym_EQ_EQ] = ACTIONS(11622),
    [anon_sym_BANG_EQ] = ACTIONS(11618),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11618),
    [anon_sym_LT_EQ_GT] = ACTIONS(11618),
    [anon_sym_EQ_TILDE] = ACTIONS(11618),
    [anon_sym_BANG_TILDE] = ACTIONS(11618),
    [anon_sym_LT_EQ] = ACTIONS(11610),
    [anon_sym_GT] = ACTIONS(11610),
    [anon_sym_GT_EQ] = ACTIONS(11624),
    [anon_sym_CARET] = ACTIONS(11626),
    [anon_sym_PLUS] = ACTIONS(11602),
    [anon_sym_SLASH] = ACTIONS(11604),
    [anon_sym_PERCENT] = ACTIONS(11604),
    [sym_comment] = ACTIONS(87),
  },
  [8128] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(8909),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8909),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(8909),
    [anon_sym_PERCENT] = ACTIONS(8909),
    [sym_comment] = ACTIONS(87),
  },
  [8129] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8909),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [8130] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8907),
    [sym__binary_star] = ACTIONS(8909),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8909),
    [anon_sym_AMP] = ACTIONS(8913),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(8925),
    [anon_sym_GT_GT] = ACTIONS(8925),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(8907),
    [anon_sym_SLASH] = ACTIONS(8909),
    [anon_sym_PERCENT] = ACTIONS(8909),
    [sym_comment] = ACTIONS(87),
  },
  [8131] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8907),
    [sym__binary_star] = ACTIONS(8909),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8909),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(8925),
    [anon_sym_GT_GT] = ACTIONS(8925),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(8907),
    [anon_sym_SLASH] = ACTIONS(8909),
    [anon_sym_PERCENT] = ACTIONS(8909),
    [sym_comment] = ACTIONS(87),
  },
  [8132] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8907),
    [sym__binary_star] = ACTIONS(8909),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(8911),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8909),
    [anon_sym_AMP] = ACTIONS(8913),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(8925),
    [anon_sym_GT_GT] = ACTIONS(8925),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(8931),
    [anon_sym_PLUS] = ACTIONS(8907),
    [anon_sym_SLASH] = ACTIONS(8909),
    [anon_sym_PERCENT] = ACTIONS(8909),
    [sym_comment] = ACTIONS(87),
  },
  [8133] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(13521),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [8134] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(8907),
    [sym__binary_star] = ACTIONS(8909),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(8911),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(8909),
    [anon_sym_AMP] = ACTIONS(8913),
    [anon_sym_LT] = ACTIONS(8915),
    [anon_sym_end] = ACTIONS(5927),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_ensure] = ACTIONS(5927),
    [anon_sym_EQ_GT] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(8919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8921),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(8923),
    [anon_sym_AMP_AMP] = ACTIONS(8923),
    [anon_sym_LT_LT] = ACTIONS(8925),
    [anon_sym_GT_GT] = ACTIONS(8925),
    [anon_sym_EQ_EQ] = ACTIONS(8927),
    [anon_sym_BANG_EQ] = ACTIONS(8923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8923),
    [anon_sym_LT_EQ_GT] = ACTIONS(8923),
    [anon_sym_EQ_TILDE] = ACTIONS(8923),
    [anon_sym_BANG_TILDE] = ACTIONS(8923),
    [anon_sym_LT_EQ] = ACTIONS(8915),
    [anon_sym_GT] = ACTIONS(8915),
    [anon_sym_GT_EQ] = ACTIONS(8929),
    [anon_sym_CARET] = ACTIONS(8931),
    [anon_sym_PLUS] = ACTIONS(8907),
    [anon_sym_SLASH] = ACTIONS(8909),
    [anon_sym_PERCENT] = ACTIONS(8909),
    [sym_comment] = ACTIONS(87),
  },
  [8135] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8907),
    [sym__binary_star] = ACTIONS(8909),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(8911),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8909),
    [anon_sym_AMP] = ACTIONS(8913),
    [anon_sym_LT] = ACTIONS(8915),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(8917),
    [anon_sym_DOT_DOT] = ACTIONS(8919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8921),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(8923),
    [anon_sym_AMP_AMP] = ACTIONS(8923),
    [anon_sym_LT_LT] = ACTIONS(8925),
    [anon_sym_GT_GT] = ACTIONS(8925),
    [anon_sym_EQ_EQ] = ACTIONS(8927),
    [anon_sym_BANG_EQ] = ACTIONS(8923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8923),
    [anon_sym_LT_EQ_GT] = ACTIONS(8923),
    [anon_sym_EQ_TILDE] = ACTIONS(8923),
    [anon_sym_BANG_TILDE] = ACTIONS(8923),
    [anon_sym_LT_EQ] = ACTIONS(8915),
    [anon_sym_GT] = ACTIONS(8915),
    [anon_sym_GT_EQ] = ACTIONS(8929),
    [anon_sym_CARET] = ACTIONS(8931),
    [anon_sym_PLUS] = ACTIONS(8907),
    [anon_sym_SLASH] = ACTIONS(8909),
    [anon_sym_PERCENT] = ACTIONS(8909),
    [sym_comment] = ACTIONS(87),
  },
  [8136] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8907),
    [sym__binary_star] = ACTIONS(8909),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(8911),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8909),
    [anon_sym_AMP] = ACTIONS(8913),
    [anon_sym_LT] = ACTIONS(8915),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(8925),
    [anon_sym_GT_GT] = ACTIONS(8925),
    [anon_sym_EQ_EQ] = ACTIONS(8927),
    [anon_sym_BANG_EQ] = ACTIONS(8923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8923),
    [anon_sym_LT_EQ_GT] = ACTIONS(8923),
    [anon_sym_EQ_TILDE] = ACTIONS(8923),
    [anon_sym_BANG_TILDE] = ACTIONS(8923),
    [anon_sym_LT_EQ] = ACTIONS(8915),
    [anon_sym_GT] = ACTIONS(8915),
    [anon_sym_GT_EQ] = ACTIONS(8929),
    [anon_sym_CARET] = ACTIONS(8931),
    [anon_sym_PLUS] = ACTIONS(8907),
    [anon_sym_SLASH] = ACTIONS(8909),
    [anon_sym_PERCENT] = ACTIONS(8909),
    [sym_comment] = ACTIONS(87),
  },
  [8137] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8907),
    [sym__binary_star] = ACTIONS(8909),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8909),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(8907),
    [anon_sym_SLASH] = ACTIONS(8909),
    [anon_sym_PERCENT] = ACTIONS(8909),
    [sym_comment] = ACTIONS(87),
  },
  [8138] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(8979),
    [sym__binary_star] = ACTIONS(8981),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(8983),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(8985),
    [anon_sym_AMP] = ACTIONS(8987),
    [anon_sym_EQ] = ACTIONS(4217),
    [anon_sym_LT] = ACTIONS(8989),
    [anon_sym_end] = ACTIONS(4211),
    [anon_sym_if] = ACTIONS(4211),
    [anon_sym_unless] = ACTIONS(4211),
    [anon_sym_while] = ACTIONS(4211),
    [anon_sym_until] = ACTIONS(4211),
    [anon_sym_rescue] = ACTIONS(4211),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_ensure] = ACTIONS(4211),
    [anon_sym_EQ_GT] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_PLUS_EQ] = ACTIONS(4211),
    [anon_sym_DASH_EQ] = ACTIONS(4211),
    [anon_sym_STAR_EQ] = ACTIONS(4211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4211),
    [anon_sym_SLASH_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4211),
    [anon_sym_AMP_EQ] = ACTIONS(4211),
    [anon_sym_PERCENT_EQ] = ACTIONS(4211),
    [anon_sym_GT_GT_EQ] = ACTIONS(4211),
    [anon_sym_LT_LT_EQ] = ACTIONS(4211),
    [anon_sym_CARET_EQ] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(8991),
    [anon_sym_DOT_DOT] = ACTIONS(8993),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8995),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(8997),
    [anon_sym_AMP_AMP] = ACTIONS(8997),
    [anon_sym_LT_LT] = ACTIONS(8999),
    [anon_sym_GT_GT] = ACTIONS(8999),
    [anon_sym_EQ_EQ] = ACTIONS(8997),
    [anon_sym_BANG_EQ] = ACTIONS(9001),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9001),
    [anon_sym_LT_EQ_GT] = ACTIONS(9001),
    [anon_sym_EQ_TILDE] = ACTIONS(9001),
    [anon_sym_BANG_TILDE] = ACTIONS(9001),
    [anon_sym_LT_EQ] = ACTIONS(8989),
    [anon_sym_GT] = ACTIONS(8989),
    [anon_sym_GT_EQ] = ACTIONS(9003),
    [anon_sym_CARET] = ACTIONS(8983),
    [anon_sym_PLUS] = ACTIONS(9005),
    [anon_sym_SLASH] = ACTIONS(8985),
    [anon_sym_PERCENT] = ACTIONS(8985),
    [sym_comment] = ACTIONS(87),
  },
  [8139] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(8979),
    [sym__binary_star] = ACTIONS(8981),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(8983),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(8985),
    [anon_sym_AMP] = ACTIONS(8987),
    [anon_sym_EQ] = ACTIONS(4249),
    [anon_sym_LT] = ACTIONS(8989),
    [anon_sym_end] = ACTIONS(4247),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_ensure] = ACTIONS(4247),
    [anon_sym_EQ_GT] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_PLUS_EQ] = ACTIONS(4247),
    [anon_sym_DASH_EQ] = ACTIONS(4247),
    [anon_sym_STAR_EQ] = ACTIONS(4247),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4247),
    [anon_sym_SLASH_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4247),
    [anon_sym_AMP_EQ] = ACTIONS(4247),
    [anon_sym_PERCENT_EQ] = ACTIONS(4247),
    [anon_sym_GT_GT_EQ] = ACTIONS(4247),
    [anon_sym_LT_LT_EQ] = ACTIONS(4247),
    [anon_sym_CARET_EQ] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(8991),
    [anon_sym_DOT_DOT] = ACTIONS(8993),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8995),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(8997),
    [anon_sym_AMP_AMP] = ACTIONS(8997),
    [anon_sym_LT_LT] = ACTIONS(8999),
    [anon_sym_GT_GT] = ACTIONS(8999),
    [anon_sym_EQ_EQ] = ACTIONS(8997),
    [anon_sym_BANG_EQ] = ACTIONS(9001),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9001),
    [anon_sym_LT_EQ_GT] = ACTIONS(9001),
    [anon_sym_EQ_TILDE] = ACTIONS(9001),
    [anon_sym_BANG_TILDE] = ACTIONS(9001),
    [anon_sym_LT_EQ] = ACTIONS(8989),
    [anon_sym_GT] = ACTIONS(8989),
    [anon_sym_GT_EQ] = ACTIONS(9003),
    [anon_sym_CARET] = ACTIONS(8983),
    [anon_sym_PLUS] = ACTIONS(9005),
    [anon_sym_SLASH] = ACTIONS(8985),
    [anon_sym_PERCENT] = ACTIONS(8985),
    [sym_comment] = ACTIONS(87),
  },
  [8140] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(9759),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3158),
    [sym_scope_resolution] = STATE(3154),
    [sym_call] = STATE(3154),
    [sym_method_call] = STATE(3158),
    [sym_assignment] = STATE(9759),
    [sym_operator_assignment] = STATE(9759),
    [sym_conditional] = STATE(9759),
    [sym_range] = STATE(9759),
    [sym_binary] = STATE(9759),
    [sym_unary] = STATE(9759),
    [sym_left_assignment_list] = STATE(3157),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3158),
    [sym__variable] = STATE(3154),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3158),
    [sym_false] = STATE(3158),
    [sym_nil] = STATE(3158),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5749),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5265),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5269),
    [anon_sym_yield] = ACTIONS(5271),
    [anon_sym_break] = ACTIONS(5273),
    [anon_sym_next] = ACTIONS(5275),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(8973),
    [anon_sym_defined_QMARK] = ACTIONS(5277),
    [anon_sym_not] = ACTIONS(5279),
    [anon_sym_BANG] = ACTIONS(5283),
    [anon_sym_TILDE] = ACTIONS(5283),
    [sym_constant] = ACTIONS(5289),
    [sym_identifier] = ACTIONS(5289),
    [sym_instance_variable] = ACTIONS(5287),
    [sym_class_variable] = ACTIONS(5287),
    [sym_global_variable] = ACTIONS(5287),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5289),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5289),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [8141] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(8979),
    [sym__binary_star] = ACTIONS(8981),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(8983),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(8985),
    [anon_sym_AMP] = ACTIONS(8987),
    [anon_sym_EQ] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(8989),
    [anon_sym_end] = ACTIONS(3281),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_unless] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_until] = ACTIONS(3281),
    [anon_sym_rescue] = ACTIONS(3281),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_ensure] = ACTIONS(3281),
    [anon_sym_EQ_GT] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_PLUS_EQ] = ACTIONS(3281),
    [anon_sym_DASH_EQ] = ACTIONS(3281),
    [anon_sym_STAR_EQ] = ACTIONS(3281),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3281),
    [anon_sym_SLASH_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3281),
    [anon_sym_AMP_EQ] = ACTIONS(3281),
    [anon_sym_PERCENT_EQ] = ACTIONS(3281),
    [anon_sym_GT_GT_EQ] = ACTIONS(3281),
    [anon_sym_LT_LT_EQ] = ACTIONS(3281),
    [anon_sym_CARET_EQ] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(8991),
    [anon_sym_DOT_DOT] = ACTIONS(8993),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8995),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(8997),
    [anon_sym_AMP_AMP] = ACTIONS(8997),
    [anon_sym_LT_LT] = ACTIONS(8999),
    [anon_sym_GT_GT] = ACTIONS(8999),
    [anon_sym_EQ_EQ] = ACTIONS(8997),
    [anon_sym_BANG_EQ] = ACTIONS(9001),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9001),
    [anon_sym_LT_EQ_GT] = ACTIONS(9001),
    [anon_sym_EQ_TILDE] = ACTIONS(9001),
    [anon_sym_BANG_TILDE] = ACTIONS(9001),
    [anon_sym_LT_EQ] = ACTIONS(8989),
    [anon_sym_GT] = ACTIONS(8989),
    [anon_sym_GT_EQ] = ACTIONS(9003),
    [anon_sym_CARET] = ACTIONS(8983),
    [anon_sym_PLUS] = ACTIONS(9005),
    [anon_sym_SLASH] = ACTIONS(8985),
    [anon_sym_PERCENT] = ACTIONS(8985),
    [sym_comment] = ACTIONS(87),
  },
  [8142] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(9760),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3158),
    [sym_scope_resolution] = STATE(3154),
    [sym_call] = STATE(3154),
    [sym_method_call] = STATE(3158),
    [sym_assignment] = STATE(9760),
    [sym_operator_assignment] = STATE(9760),
    [sym_conditional] = STATE(9760),
    [sym_range] = STATE(9760),
    [sym_binary] = STATE(9760),
    [sym_unary] = STATE(9760),
    [sym_left_assignment_list] = STATE(3157),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3158),
    [sym__variable] = STATE(3154),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3158),
    [sym_false] = STATE(3158),
    [sym_nil] = STATE(3158),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5749),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5265),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5269),
    [anon_sym_yield] = ACTIONS(5271),
    [anon_sym_break] = ACTIONS(5273),
    [anon_sym_next] = ACTIONS(5275),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(8973),
    [anon_sym_defined_QMARK] = ACTIONS(5277),
    [anon_sym_not] = ACTIONS(5279),
    [anon_sym_BANG] = ACTIONS(5283),
    [anon_sym_TILDE] = ACTIONS(5283),
    [sym_constant] = ACTIONS(5289),
    [sym_identifier] = ACTIONS(5289),
    [sym_instance_variable] = ACTIONS(5287),
    [sym_class_variable] = ACTIONS(5287),
    [sym_global_variable] = ACTIONS(5287),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5289),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5289),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [8143] = {
    [sym_heredoc_body] = STATE(9761),
    [aux_sym_call_repeat1] = STATE(9761),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_ensure] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [8144] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5709),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3158),
    [sym_scope_resolution] = STATE(3154),
    [sym_call] = STATE(3154),
    [sym_method_call] = STATE(3158),
    [sym__argument] = STATE(4979),
    [sym_splat_argument] = STATE(4979),
    [sym_hash_splat_argument] = STATE(4979),
    [sym_block_argument] = STATE(4979),
    [sym_assignment] = STATE(5709),
    [sym_operator_assignment] = STATE(5709),
    [sym_conditional] = STATE(5709),
    [sym_range] = STATE(5709),
    [sym_binary] = STATE(5709),
    [sym_unary] = STATE(5709),
    [sym_left_assignment_list] = STATE(3157),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3158),
    [sym__variable] = STATE(3154),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3158),
    [sym_false] = STATE(3158),
    [sym_nil] = STATE(3158),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5712),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_heredoc_body] = STATE(9762),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(4979),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(8933),
    [sym__splat_star] = ACTIONS(8935),
    [sym__unary_minus] = ACTIONS(5265),
    [sym__identifier_hash_key] = ACTIONS(8937),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13523),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5269),
    [anon_sym_yield] = ACTIONS(5271),
    [anon_sym_break] = ACTIONS(5273),
    [anon_sym_next] = ACTIONS(5275),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(8973),
    [anon_sym_defined_QMARK] = ACTIONS(5277),
    [anon_sym_not] = ACTIONS(5279),
    [anon_sym_BANG] = ACTIONS(5283),
    [anon_sym_TILDE] = ACTIONS(5283),
    [sym_constant] = ACTIONS(8939),
    [sym_identifier] = ACTIONS(8939),
    [sym_instance_variable] = ACTIONS(5287),
    [sym_class_variable] = ACTIONS(5287),
    [sym_global_variable] = ACTIONS(5287),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5289),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5289),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [8145] = {
    [sym_heredoc_body] = STATE(9763),
    [aux_sym_call_repeat1] = STATE(9763),
    [aux_sym_argument_list_repeat1] = STATE(9764),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(11646),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_ensure] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [8146] = {
    [sym_heredoc_body] = STATE(8146),
    [aux_sym_call_repeat1] = STATE(8146),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(7916),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_end] = ACTIONS(7914),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_ensure] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [8147] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3117),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(3118),
    [sym_call] = STATE(3118),
    [sym_method_call] = STATE(3122),
    [sym__argument] = STATE(4986),
    [sym_splat_argument] = STATE(4986),
    [sym_hash_splat_argument] = STATE(4986),
    [sym_block_argument] = STATE(4986),
    [sym_assignment] = STATE(3117),
    [sym_operator_assignment] = STATE(3117),
    [sym_conditional] = STATE(3117),
    [sym_range] = STATE(3117),
    [sym_binary] = STATE(3117),
    [sym_unary] = STATE(3117),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(3118),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3123),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4986),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(5189),
    [sym__splat_star] = ACTIONS(5191),
    [sym__unary_minus] = ACTIONS(5193),
    [sym__identifier_hash_key] = ACTIONS(5195),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11650),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5197),
    [anon_sym_yield] = ACTIONS(5199),
    [anon_sym_break] = ACTIONS(5201),
    [anon_sym_next] = ACTIONS(5203),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8893),
    [anon_sym_defined_QMARK] = ACTIONS(5205),
    [anon_sym_not] = ACTIONS(5207),
    [anon_sym_BANG] = ACTIONS(5211),
    [anon_sym_TILDE] = ACTIONS(5211),
    [sym_constant] = ACTIONS(5213),
    [sym_identifier] = ACTIONS(5213),
    [sym_instance_variable] = ACTIONS(5215),
    [sym_class_variable] = ACTIONS(5215),
    [sym_global_variable] = ACTIONS(5215),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5217),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5217),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8148] = {
    [sym_heredoc_body] = STATE(8146),
    [aux_sym_call_repeat1] = STATE(8146),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_end] = ACTIONS(7929),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_ensure] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [8149] = {
    [aux_sym_argument_list_repeat1] = STATE(8149),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(13525),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7925),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_end] = ACTIONS(7925),
    [anon_sym_if] = ACTIONS(7925),
    [anon_sym_unless] = ACTIONS(7925),
    [anon_sym_while] = ACTIONS(7925),
    [anon_sym_until] = ACTIONS(7925),
    [anon_sym_rescue] = ACTIONS(7925),
    [anon_sym_ensure] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7925),
    [anon_sym_AMP_AMP] = ACTIONS(7925),
    [anon_sym_LT_LT] = ACTIONS(7925),
    [anon_sym_GT_GT] = ACTIONS(7925),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7925),
    [anon_sym_PLUS] = ACTIONS(7925),
    [anon_sym_SLASH] = ACTIONS(7925),
    [anon_sym_PERCENT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [8150] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(8907),
    [sym__binary_star] = ACTIONS(8909),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(8911),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(8909),
    [anon_sym_AMP] = ACTIONS(8913),
    [anon_sym_LT] = ACTIONS(8915),
    [anon_sym_end] = ACTIONS(5115),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_ensure] = ACTIONS(5115),
    [anon_sym_EQ_GT] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(8917),
    [anon_sym_DOT_DOT] = ACTIONS(8919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8921),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(8923),
    [anon_sym_AMP_AMP] = ACTIONS(8923),
    [anon_sym_LT_LT] = ACTIONS(8925),
    [anon_sym_GT_GT] = ACTIONS(8925),
    [anon_sym_EQ_EQ] = ACTIONS(8927),
    [anon_sym_BANG_EQ] = ACTIONS(8923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8923),
    [anon_sym_LT_EQ_GT] = ACTIONS(8923),
    [anon_sym_EQ_TILDE] = ACTIONS(8923),
    [anon_sym_BANG_TILDE] = ACTIONS(8923),
    [anon_sym_LT_EQ] = ACTIONS(8915),
    [anon_sym_GT] = ACTIONS(8915),
    [anon_sym_GT_EQ] = ACTIONS(8929),
    [anon_sym_CARET] = ACTIONS(8931),
    [anon_sym_PLUS] = ACTIONS(8907),
    [anon_sym_SLASH] = ACTIONS(8909),
    [anon_sym_PERCENT] = ACTIONS(8909),
    [sym_comment] = ACTIONS(87),
  },
  [8151] = {
    [aux_sym_exceptions_repeat1] = STATE(9766),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_end] = ACTIONS(6191),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_ensure] = ACTIONS(6191),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [8152] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(8907),
    [sym__binary_star] = ACTIONS(8909),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(8911),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(8909),
    [anon_sym_AMP] = ACTIONS(8913),
    [anon_sym_LT] = ACTIONS(8915),
    [anon_sym_end] = ACTIONS(6210),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_ensure] = ACTIONS(6210),
    [anon_sym_EQ_GT] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(8917),
    [anon_sym_DOT_DOT] = ACTIONS(8919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8921),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(8923),
    [anon_sym_AMP_AMP] = ACTIONS(8923),
    [anon_sym_LT_LT] = ACTIONS(8925),
    [anon_sym_GT_GT] = ACTIONS(8925),
    [anon_sym_EQ_EQ] = ACTIONS(8927),
    [anon_sym_BANG_EQ] = ACTIONS(8923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8923),
    [anon_sym_LT_EQ_GT] = ACTIONS(8923),
    [anon_sym_EQ_TILDE] = ACTIONS(8923),
    [anon_sym_BANG_TILDE] = ACTIONS(8923),
    [anon_sym_LT_EQ] = ACTIONS(8915),
    [anon_sym_GT] = ACTIONS(8915),
    [anon_sym_GT_EQ] = ACTIONS(8929),
    [anon_sym_CARET] = ACTIONS(8931),
    [anon_sym_PLUS] = ACTIONS(8907),
    [anon_sym_SLASH] = ACTIONS(8909),
    [anon_sym_PERCENT] = ACTIONS(8909),
    [sym_comment] = ACTIONS(87),
  },
  [8153] = {
    [sym_string] = STATE(8153),
    [aux_sym_chained_string_repeat1] = STATE(8153),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(6214),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_end] = ACTIONS(6212),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_ensure] = ACTIONS(6212),
    [anon_sym_EQ_GT] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [8154] = {
    [aux_sym_undef_repeat1] = STATE(8154),
    [sym__line_break] = ACTIONS(9263),
    [sym__heredoc_body_start] = ACTIONS(9263),
    [anon_sym_COMMA] = ACTIONS(9265),
    [anon_sym_SEMI] = ACTIONS(9263),
    [anon_sym_end] = ACTIONS(9263),
    [anon_sym_if] = ACTIONS(9263),
    [anon_sym_unless] = ACTIONS(9263),
    [anon_sym_while] = ACTIONS(9263),
    [anon_sym_until] = ACTIONS(9263),
    [anon_sym_rescue] = ACTIONS(9263),
    [anon_sym_ensure] = ACTIONS(9263),
    [sym_comment] = ACTIONS(87),
  },
  [8155] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9767),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1191),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(1191),
    [sym_assignment] = STATE(9767),
    [sym_operator_assignment] = STATE(9767),
    [sym_conditional] = STATE(9767),
    [sym_range] = STATE(9767),
    [sym_binary] = STATE(9767),
    [sym_unary] = STATE(9767),
    [sym_left_assignment_list] = STATE(1190),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1191),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1191),
    [sym_false] = STATE(1191),
    [sym_nil] = STATE(1191),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1192),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2113),
    [anon_sym_yield] = ACTIONS(2115),
    [anon_sym_break] = ACTIONS(2117),
    [anon_sym_next] = ACTIONS(2119),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_defined_QMARK] = ACTIONS(2123),
    [anon_sym_not] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2127),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8156] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(11660),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_ensure] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [8157] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(11654),
    [sym__binary_star] = ACTIONS(11656),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(11658),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(11660),
    [anon_sym_AMP] = ACTIONS(11662),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(11664),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_ensure] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(11666),
    [anon_sym_DOT_DOT] = ACTIONS(11668),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11670),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(11672),
    [anon_sym_AMP_AMP] = ACTIONS(11672),
    [anon_sym_LT_LT] = ACTIONS(11674),
    [anon_sym_GT_GT] = ACTIONS(11674),
    [anon_sym_EQ_EQ] = ACTIONS(11672),
    [anon_sym_BANG_EQ] = ACTIONS(11676),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11676),
    [anon_sym_LT_EQ_GT] = ACTIONS(11676),
    [anon_sym_EQ_TILDE] = ACTIONS(11676),
    [anon_sym_BANG_TILDE] = ACTIONS(11676),
    [anon_sym_LT_EQ] = ACTIONS(11664),
    [anon_sym_GT] = ACTIONS(11664),
    [anon_sym_GT_EQ] = ACTIONS(11678),
    [anon_sym_CARET] = ACTIONS(11658),
    [anon_sym_PLUS] = ACTIONS(11680),
    [anon_sym_SLASH] = ACTIONS(11660),
    [anon_sym_PERCENT] = ACTIONS(11660),
    [sym_comment] = ACTIONS(87),
  },
  [8158] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(9768),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(5745),
    [sym_scope_resolution] = STATE(5743),
    [sym_call] = STATE(5743),
    [sym_method_call] = STATE(5745),
    [sym_assignment] = STATE(9768),
    [sym_operator_assignment] = STATE(9768),
    [sym_conditional] = STATE(9768),
    [sym_range] = STATE(9768),
    [sym_binary] = STATE(9768),
    [sym_unary] = STATE(9768),
    [sym_left_assignment_list] = STATE(5744),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5745),
    [sym__variable] = STATE(5743),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(5745),
    [sym_false] = STATE(5745),
    [sym_nil] = STATE(5745),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(5746),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(8951),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(8953),
    [anon_sym_yield] = ACTIONS(8955),
    [anon_sym_break] = ACTIONS(8957),
    [anon_sym_next] = ACTIONS(8959),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(8961),
    [anon_sym_defined_QMARK] = ACTIONS(8963),
    [anon_sym_not] = ACTIONS(8965),
    [anon_sym_BANG] = ACTIONS(8967),
    [anon_sym_TILDE] = ACTIONS(8967),
    [sym_constant] = ACTIONS(8969),
    [sym_identifier] = ACTIONS(8969),
    [sym_instance_variable] = ACTIONS(8971),
    [sym_class_variable] = ACTIONS(8971),
    [sym_global_variable] = ACTIONS(8971),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(8969),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8969),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [8159] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(9769),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(5745),
    [sym_scope_resolution] = STATE(5743),
    [sym_call] = STATE(5743),
    [sym_method_call] = STATE(5745),
    [sym_assignment] = STATE(9769),
    [sym_operator_assignment] = STATE(9769),
    [sym_conditional] = STATE(9769),
    [sym_range] = STATE(9769),
    [sym_binary] = STATE(9769),
    [sym_unary] = STATE(9769),
    [sym_left_assignment_list] = STATE(5744),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5745),
    [sym__variable] = STATE(5743),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(5745),
    [sym_false] = STATE(5745),
    [sym_nil] = STATE(5745),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(5746),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(8951),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(8953),
    [anon_sym_yield] = ACTIONS(8955),
    [anon_sym_break] = ACTIONS(8957),
    [anon_sym_next] = ACTIONS(8959),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(8961),
    [anon_sym_defined_QMARK] = ACTIONS(8963),
    [anon_sym_not] = ACTIONS(8965),
    [anon_sym_BANG] = ACTIONS(8967),
    [anon_sym_TILDE] = ACTIONS(8967),
    [sym_constant] = ACTIONS(8969),
    [sym_identifier] = ACTIONS(8969),
    [sym_instance_variable] = ACTIONS(8971),
    [sym_class_variable] = ACTIONS(8971),
    [sym_global_variable] = ACTIONS(8971),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(8969),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8969),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [8160] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(9770),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(5745),
    [sym_scope_resolution] = STATE(5743),
    [sym_call] = STATE(5743),
    [sym_method_call] = STATE(5745),
    [sym_assignment] = STATE(9770),
    [sym_operator_assignment] = STATE(9770),
    [sym_conditional] = STATE(9770),
    [sym_range] = STATE(9770),
    [sym_binary] = STATE(9770),
    [sym_unary] = STATE(9770),
    [sym_left_assignment_list] = STATE(5744),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5745),
    [sym__variable] = STATE(5743),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(5745),
    [sym_false] = STATE(5745),
    [sym_nil] = STATE(5745),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(5746),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(8951),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(8953),
    [anon_sym_yield] = ACTIONS(8955),
    [anon_sym_break] = ACTIONS(8957),
    [anon_sym_next] = ACTIONS(8959),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(8961),
    [anon_sym_defined_QMARK] = ACTIONS(8963),
    [anon_sym_not] = ACTIONS(8965),
    [anon_sym_BANG] = ACTIONS(8967),
    [anon_sym_TILDE] = ACTIONS(8967),
    [sym_constant] = ACTIONS(8969),
    [sym_identifier] = ACTIONS(8969),
    [sym_instance_variable] = ACTIONS(8971),
    [sym_class_variable] = ACTIONS(8971),
    [sym_global_variable] = ACTIONS(8971),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(8969),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8969),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [8161] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(9771),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(5745),
    [sym_scope_resolution] = STATE(5743),
    [sym_call] = STATE(5743),
    [sym_method_call] = STATE(5745),
    [sym_assignment] = STATE(9771),
    [sym_operator_assignment] = STATE(9771),
    [sym_conditional] = STATE(9771),
    [sym_range] = STATE(9771),
    [sym_binary] = STATE(9771),
    [sym_unary] = STATE(9771),
    [sym_left_assignment_list] = STATE(5744),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5745),
    [sym__variable] = STATE(5743),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(5745),
    [sym_false] = STATE(5745),
    [sym_nil] = STATE(5745),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(5746),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(8951),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(8953),
    [anon_sym_yield] = ACTIONS(8955),
    [anon_sym_break] = ACTIONS(8957),
    [anon_sym_next] = ACTIONS(8959),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(8961),
    [anon_sym_defined_QMARK] = ACTIONS(8963),
    [anon_sym_not] = ACTIONS(8965),
    [anon_sym_BANG] = ACTIONS(8967),
    [anon_sym_TILDE] = ACTIONS(8967),
    [sym_constant] = ACTIONS(8969),
    [sym_identifier] = ACTIONS(8969),
    [sym_instance_variable] = ACTIONS(8971),
    [sym_class_variable] = ACTIONS(8971),
    [sym_global_variable] = ACTIONS(8971),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(8969),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8969),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [8162] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(9772),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(5745),
    [sym_scope_resolution] = STATE(5743),
    [sym_call] = STATE(5743),
    [sym_method_call] = STATE(5745),
    [sym_assignment] = STATE(9772),
    [sym_operator_assignment] = STATE(9772),
    [sym_conditional] = STATE(9772),
    [sym_range] = STATE(9772),
    [sym_binary] = STATE(9772),
    [sym_unary] = STATE(9772),
    [sym_left_assignment_list] = STATE(5744),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5745),
    [sym__variable] = STATE(5743),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(5745),
    [sym_false] = STATE(5745),
    [sym_nil] = STATE(5745),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(5746),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(8951),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(8953),
    [anon_sym_yield] = ACTIONS(8955),
    [anon_sym_break] = ACTIONS(8957),
    [anon_sym_next] = ACTIONS(8959),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(8961),
    [anon_sym_defined_QMARK] = ACTIONS(8963),
    [anon_sym_not] = ACTIONS(8965),
    [anon_sym_BANG] = ACTIONS(8967),
    [anon_sym_TILDE] = ACTIONS(8967),
    [sym_constant] = ACTIONS(8969),
    [sym_identifier] = ACTIONS(8969),
    [sym_instance_variable] = ACTIONS(8971),
    [sym_class_variable] = ACTIONS(8971),
    [sym_global_variable] = ACTIONS(8971),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(8969),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8969),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [8163] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(9773),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(9773),
    [sym_operator_assignment] = STATE(9773),
    [sym_conditional] = STATE(9773),
    [sym_range] = STATE(9773),
    [sym_binary] = STATE(9773),
    [sym_unary] = STATE(9773),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8164] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(9774),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(5745),
    [sym_scope_resolution] = STATE(5743),
    [sym_call] = STATE(5743),
    [sym_method_call] = STATE(5745),
    [sym_assignment] = STATE(9774),
    [sym_operator_assignment] = STATE(9774),
    [sym_conditional] = STATE(9774),
    [sym_range] = STATE(9774),
    [sym_binary] = STATE(9774),
    [sym_unary] = STATE(9774),
    [sym_left_assignment_list] = STATE(5744),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5745),
    [sym__variable] = STATE(5743),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(5745),
    [sym_false] = STATE(5745),
    [sym_nil] = STATE(5745),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(5746),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(8951),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(8953),
    [anon_sym_yield] = ACTIONS(8955),
    [anon_sym_break] = ACTIONS(8957),
    [anon_sym_next] = ACTIONS(8959),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(8961),
    [anon_sym_defined_QMARK] = ACTIONS(8963),
    [anon_sym_not] = ACTIONS(8965),
    [anon_sym_BANG] = ACTIONS(8967),
    [anon_sym_TILDE] = ACTIONS(8967),
    [sym_constant] = ACTIONS(8969),
    [sym_identifier] = ACTIONS(8969),
    [sym_instance_variable] = ACTIONS(8971),
    [sym_class_variable] = ACTIONS(8971),
    [sym_global_variable] = ACTIONS(8971),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(8969),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8969),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [8165] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(9775),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(5745),
    [sym_scope_resolution] = STATE(5743),
    [sym_call] = STATE(5743),
    [sym_method_call] = STATE(5745),
    [sym_assignment] = STATE(9775),
    [sym_operator_assignment] = STATE(9775),
    [sym_conditional] = STATE(9775),
    [sym_range] = STATE(9775),
    [sym_binary] = STATE(9775),
    [sym_unary] = STATE(9775),
    [sym_left_assignment_list] = STATE(5744),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5745),
    [sym__variable] = STATE(5743),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(5745),
    [sym_false] = STATE(5745),
    [sym_nil] = STATE(5745),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(5746),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(8951),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(8953),
    [anon_sym_yield] = ACTIONS(8955),
    [anon_sym_break] = ACTIONS(8957),
    [anon_sym_next] = ACTIONS(8959),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(8961),
    [anon_sym_defined_QMARK] = ACTIONS(8963),
    [anon_sym_not] = ACTIONS(8965),
    [anon_sym_BANG] = ACTIONS(8967),
    [anon_sym_TILDE] = ACTIONS(8967),
    [sym_constant] = ACTIONS(8969),
    [sym_identifier] = ACTIONS(8969),
    [sym_instance_variable] = ACTIONS(8971),
    [sym_class_variable] = ACTIONS(8971),
    [sym_global_variable] = ACTIONS(8971),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(8969),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8969),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [8166] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(9776),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(5745),
    [sym_scope_resolution] = STATE(5743),
    [sym_call] = STATE(5743),
    [sym_method_call] = STATE(5745),
    [sym_assignment] = STATE(9776),
    [sym_operator_assignment] = STATE(9776),
    [sym_conditional] = STATE(9776),
    [sym_range] = STATE(9776),
    [sym_binary] = STATE(9776),
    [sym_unary] = STATE(9776),
    [sym_left_assignment_list] = STATE(5744),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5745),
    [sym__variable] = STATE(5743),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(5745),
    [sym_false] = STATE(5745),
    [sym_nil] = STATE(5745),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(5746),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(8951),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(8953),
    [anon_sym_yield] = ACTIONS(8955),
    [anon_sym_break] = ACTIONS(8957),
    [anon_sym_next] = ACTIONS(8959),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(8961),
    [anon_sym_defined_QMARK] = ACTIONS(8963),
    [anon_sym_not] = ACTIONS(8965),
    [anon_sym_BANG] = ACTIONS(8967),
    [anon_sym_TILDE] = ACTIONS(8967),
    [sym_constant] = ACTIONS(8969),
    [sym_identifier] = ACTIONS(8969),
    [sym_instance_variable] = ACTIONS(8971),
    [sym_class_variable] = ACTIONS(8971),
    [sym_global_variable] = ACTIONS(8971),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(8969),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8969),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [8167] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(9777),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(5745),
    [sym_scope_resolution] = STATE(5743),
    [sym_call] = STATE(5743),
    [sym_method_call] = STATE(5745),
    [sym_assignment] = STATE(9777),
    [sym_operator_assignment] = STATE(9777),
    [sym_conditional] = STATE(9777),
    [sym_range] = STATE(9777),
    [sym_binary] = STATE(9777),
    [sym_unary] = STATE(9777),
    [sym_left_assignment_list] = STATE(5744),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5745),
    [sym__variable] = STATE(5743),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(5745),
    [sym_false] = STATE(5745),
    [sym_nil] = STATE(5745),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(5746),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(8951),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(8953),
    [anon_sym_yield] = ACTIONS(8955),
    [anon_sym_break] = ACTIONS(8957),
    [anon_sym_next] = ACTIONS(8959),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(8961),
    [anon_sym_defined_QMARK] = ACTIONS(8963),
    [anon_sym_not] = ACTIONS(8965),
    [anon_sym_BANG] = ACTIONS(8967),
    [anon_sym_TILDE] = ACTIONS(8967),
    [sym_constant] = ACTIONS(8969),
    [sym_identifier] = ACTIONS(8969),
    [sym_instance_variable] = ACTIONS(8971),
    [sym_class_variable] = ACTIONS(8971),
    [sym_global_variable] = ACTIONS(8971),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(8969),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8969),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [8168] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(9778),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(5745),
    [sym_scope_resolution] = STATE(5743),
    [sym_call] = STATE(5743),
    [sym_method_call] = STATE(5745),
    [sym_splat_argument] = STATE(9779),
    [sym_assignment] = STATE(9778),
    [sym_operator_assignment] = STATE(9778),
    [sym_conditional] = STATE(9778),
    [sym_range] = STATE(9778),
    [sym_binary] = STATE(9778),
    [sym_unary] = STATE(9778),
    [sym_right_assignment_list] = STATE(6323),
    [sym__arg_or_splat_arg] = STATE(9779),
    [sym_left_assignment_list] = STATE(5744),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5745),
    [sym__variable] = STATE(5743),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(5745),
    [sym_false] = STATE(5745),
    [sym_nil] = STATE(5745),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(5746),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__splat_star] = ACTIONS(5263),
    [sym__unary_minus] = ACTIONS(8951),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(8953),
    [anon_sym_yield] = ACTIONS(8955),
    [anon_sym_break] = ACTIONS(8957),
    [anon_sym_next] = ACTIONS(8959),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(8961),
    [anon_sym_defined_QMARK] = ACTIONS(8963),
    [anon_sym_not] = ACTIONS(8965),
    [anon_sym_BANG] = ACTIONS(8967),
    [anon_sym_TILDE] = ACTIONS(8967),
    [sym_constant] = ACTIONS(8969),
    [sym_identifier] = ACTIONS(8969),
    [sym_instance_variable] = ACTIONS(8971),
    [sym_class_variable] = ACTIONS(8971),
    [sym_global_variable] = ACTIONS(8971),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(8969),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8969),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [8169] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(9780),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(5745),
    [sym_scope_resolution] = STATE(5743),
    [sym_call] = STATE(5743),
    [sym_method_call] = STATE(5745),
    [sym_assignment] = STATE(9780),
    [sym_operator_assignment] = STATE(9780),
    [sym_conditional] = STATE(9780),
    [sym_range] = STATE(9780),
    [sym_binary] = STATE(9780),
    [sym_unary] = STATE(9780),
    [sym_left_assignment_list] = STATE(5744),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5745),
    [sym__variable] = STATE(5743),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(5745),
    [sym_false] = STATE(5745),
    [sym_nil] = STATE(5745),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(5746),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(8951),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(8953),
    [anon_sym_yield] = ACTIONS(8955),
    [anon_sym_break] = ACTIONS(8957),
    [anon_sym_next] = ACTIONS(8959),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(8961),
    [anon_sym_defined_QMARK] = ACTIONS(8963),
    [anon_sym_not] = ACTIONS(8965),
    [anon_sym_BANG] = ACTIONS(8967),
    [anon_sym_TILDE] = ACTIONS(8967),
    [sym_constant] = ACTIONS(8969),
    [sym_identifier] = ACTIONS(8969),
    [sym_instance_variable] = ACTIONS(8971),
    [sym_class_variable] = ACTIONS(8971),
    [sym_global_variable] = ACTIONS(8971),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(8969),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8969),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [8170] = {
    [sym_string] = STATE(9781),
    [aux_sym_chained_string_repeat1] = STATE(9781),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(2551),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2755),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_EQ] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_end] = ACTIONS(2753),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_ensure] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_PLUS_EQ] = ACTIONS(2753),
    [anon_sym_DASH_EQ] = ACTIONS(2753),
    [anon_sym_STAR_EQ] = ACTIONS(2753),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2753),
    [anon_sym_SLASH_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2753),
    [anon_sym_AMP_EQ] = ACTIONS(2753),
    [anon_sym_PERCENT_EQ] = ACTIONS(2753),
    [anon_sym_GT_GT_EQ] = ACTIONS(2753),
    [anon_sym_LT_LT_EQ] = ACTIONS(2753),
    [anon_sym_CARET_EQ] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2755),
    [anon_sym_AMP_AMP] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2755),
    [anon_sym_GT_GT] = ACTIONS(2755),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_SLASH] = ACTIONS(2755),
    [anon_sym_PERCENT] = ACTIONS(2755),
    [sym_comment] = ACTIONS(87),
  },
  [8171] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(11654),
    [sym__binary_star] = ACTIONS(11656),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(11658),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(11660),
    [anon_sym_AMP] = ACTIONS(11662),
    [anon_sym_EQ] = ACTIONS(7822),
    [anon_sym_LT] = ACTIONS(11664),
    [anon_sym_end] = ACTIONS(6823),
    [anon_sym_if] = ACTIONS(6823),
    [anon_sym_unless] = ACTIONS(6823),
    [anon_sym_while] = ACTIONS(6823),
    [anon_sym_until] = ACTIONS(6823),
    [anon_sym_rescue] = ACTIONS(6823),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_ensure] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_PLUS_EQ] = ACTIONS(6823),
    [anon_sym_DASH_EQ] = ACTIONS(6823),
    [anon_sym_STAR_EQ] = ACTIONS(6823),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6823),
    [anon_sym_SLASH_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6823),
    [anon_sym_AMP_EQ] = ACTIONS(6823),
    [anon_sym_PERCENT_EQ] = ACTIONS(6823),
    [anon_sym_GT_GT_EQ] = ACTIONS(6823),
    [anon_sym_LT_LT_EQ] = ACTIONS(6823),
    [anon_sym_CARET_EQ] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(11666),
    [anon_sym_DOT_DOT] = ACTIONS(11668),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11670),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(11672),
    [anon_sym_AMP_AMP] = ACTIONS(11672),
    [anon_sym_LT_LT] = ACTIONS(11674),
    [anon_sym_GT_GT] = ACTIONS(11674),
    [anon_sym_EQ_EQ] = ACTIONS(11672),
    [anon_sym_BANG_EQ] = ACTIONS(11676),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11676),
    [anon_sym_LT_EQ_GT] = ACTIONS(11676),
    [anon_sym_EQ_TILDE] = ACTIONS(11676),
    [anon_sym_BANG_TILDE] = ACTIONS(11676),
    [anon_sym_LT_EQ] = ACTIONS(11664),
    [anon_sym_GT] = ACTIONS(11664),
    [anon_sym_GT_EQ] = ACTIONS(11678),
    [anon_sym_CARET] = ACTIONS(11658),
    [anon_sym_PLUS] = ACTIONS(11680),
    [anon_sym_SLASH] = ACTIONS(11660),
    [anon_sym_PERCENT] = ACTIONS(11660),
    [sym_comment] = ACTIONS(87),
  },
  [8172] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(11654),
    [sym__binary_star] = ACTIONS(11656),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(11658),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(11660),
    [anon_sym_AMP] = ACTIONS(11662),
    [anon_sym_EQ] = ACTIONS(7884),
    [anon_sym_LT] = ACTIONS(11664),
    [anon_sym_end] = ACTIONS(7027),
    [anon_sym_if] = ACTIONS(7027),
    [anon_sym_unless] = ACTIONS(7027),
    [anon_sym_while] = ACTIONS(7027),
    [anon_sym_until] = ACTIONS(7027),
    [anon_sym_rescue] = ACTIONS(7027),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_ensure] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_PLUS_EQ] = ACTIONS(7027),
    [anon_sym_DASH_EQ] = ACTIONS(7027),
    [anon_sym_STAR_EQ] = ACTIONS(7027),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7027),
    [anon_sym_SLASH_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7027),
    [anon_sym_AMP_EQ] = ACTIONS(7027),
    [anon_sym_PERCENT_EQ] = ACTIONS(7027),
    [anon_sym_GT_GT_EQ] = ACTIONS(7027),
    [anon_sym_LT_LT_EQ] = ACTIONS(7027),
    [anon_sym_CARET_EQ] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(11666),
    [anon_sym_DOT_DOT] = ACTIONS(11668),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11670),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(11672),
    [anon_sym_AMP_AMP] = ACTIONS(11672),
    [anon_sym_LT_LT] = ACTIONS(11674),
    [anon_sym_GT_GT] = ACTIONS(11674),
    [anon_sym_EQ_EQ] = ACTIONS(11672),
    [anon_sym_BANG_EQ] = ACTIONS(11676),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11676),
    [anon_sym_LT_EQ_GT] = ACTIONS(11676),
    [anon_sym_EQ_TILDE] = ACTIONS(11676),
    [anon_sym_BANG_TILDE] = ACTIONS(11676),
    [anon_sym_LT_EQ] = ACTIONS(11664),
    [anon_sym_GT] = ACTIONS(11664),
    [anon_sym_GT_EQ] = ACTIONS(11678),
    [anon_sym_CARET] = ACTIONS(11658),
    [anon_sym_PLUS] = ACTIONS(11680),
    [anon_sym_SLASH] = ACTIONS(11660),
    [anon_sym_PERCENT] = ACTIONS(11660),
    [sym_comment] = ACTIONS(87),
  },
  [8173] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(8981),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8985),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(8985),
    [anon_sym_PERCENT] = ACTIONS(8985),
    [sym_comment] = ACTIONS(87),
  },
  [8174] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8985),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(5827),
    [anon_sym_PERCENT] = ACTIONS(5827),
    [sym_comment] = ACTIONS(87),
  },
  [8175] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8979),
    [sym__binary_star] = ACTIONS(8981),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8985),
    [anon_sym_AMP] = ACTIONS(8987),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(8999),
    [anon_sym_GT_GT] = ACTIONS(8999),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(9005),
    [anon_sym_SLASH] = ACTIONS(8985),
    [anon_sym_PERCENT] = ACTIONS(8985),
    [sym_comment] = ACTIONS(87),
  },
  [8176] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8979),
    [sym__binary_star] = ACTIONS(8981),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8985),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(8999),
    [anon_sym_GT_GT] = ACTIONS(8999),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(9005),
    [anon_sym_SLASH] = ACTIONS(8985),
    [anon_sym_PERCENT] = ACTIONS(8985),
    [sym_comment] = ACTIONS(87),
  },
  [8177] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8979),
    [sym__binary_star] = ACTIONS(8981),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(8983),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8985),
    [anon_sym_AMP] = ACTIONS(8987),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(8999),
    [anon_sym_GT_GT] = ACTIONS(8999),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(8983),
    [anon_sym_PLUS] = ACTIONS(9005),
    [anon_sym_SLASH] = ACTIONS(8985),
    [anon_sym_PERCENT] = ACTIONS(8985),
    [sym_comment] = ACTIONS(87),
  },
  [8178] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(13528),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [8179] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(8979),
    [sym__binary_star] = ACTIONS(8981),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(8983),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(8985),
    [anon_sym_AMP] = ACTIONS(8987),
    [anon_sym_EQ] = ACTIONS(7888),
    [anon_sym_LT] = ACTIONS(8989),
    [anon_sym_end] = ACTIONS(5927),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_ensure] = ACTIONS(5927),
    [anon_sym_EQ_GT] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_PLUS_EQ] = ACTIONS(5927),
    [anon_sym_DASH_EQ] = ACTIONS(5927),
    [anon_sym_STAR_EQ] = ACTIONS(5927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5927),
    [anon_sym_SLASH_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5927),
    [anon_sym_AMP_EQ] = ACTIONS(5927),
    [anon_sym_PERCENT_EQ] = ACTIONS(5927),
    [anon_sym_GT_GT_EQ] = ACTIONS(5927),
    [anon_sym_LT_LT_EQ] = ACTIONS(5927),
    [anon_sym_CARET_EQ] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(8993),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8995),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(8997),
    [anon_sym_AMP_AMP] = ACTIONS(8997),
    [anon_sym_LT_LT] = ACTIONS(8999),
    [anon_sym_GT_GT] = ACTIONS(8999),
    [anon_sym_EQ_EQ] = ACTIONS(8997),
    [anon_sym_BANG_EQ] = ACTIONS(9001),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9001),
    [anon_sym_LT_EQ_GT] = ACTIONS(9001),
    [anon_sym_EQ_TILDE] = ACTIONS(9001),
    [anon_sym_BANG_TILDE] = ACTIONS(9001),
    [anon_sym_LT_EQ] = ACTIONS(8989),
    [anon_sym_GT] = ACTIONS(8989),
    [anon_sym_GT_EQ] = ACTIONS(9003),
    [anon_sym_CARET] = ACTIONS(8983),
    [anon_sym_PLUS] = ACTIONS(9005),
    [anon_sym_SLASH] = ACTIONS(8985),
    [anon_sym_PERCENT] = ACTIONS(8985),
    [sym_comment] = ACTIONS(87),
  },
  [8180] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8979),
    [sym__binary_star] = ACTIONS(8981),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(8983),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8985),
    [anon_sym_AMP] = ACTIONS(8987),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(8989),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(8991),
    [anon_sym_DOT_DOT] = ACTIONS(8993),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8995),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(8997),
    [anon_sym_AMP_AMP] = ACTIONS(8997),
    [anon_sym_LT_LT] = ACTIONS(8999),
    [anon_sym_GT_GT] = ACTIONS(8999),
    [anon_sym_EQ_EQ] = ACTIONS(8997),
    [anon_sym_BANG_EQ] = ACTIONS(9001),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9001),
    [anon_sym_LT_EQ_GT] = ACTIONS(9001),
    [anon_sym_EQ_TILDE] = ACTIONS(9001),
    [anon_sym_BANG_TILDE] = ACTIONS(9001),
    [anon_sym_LT_EQ] = ACTIONS(8989),
    [anon_sym_GT] = ACTIONS(8989),
    [anon_sym_GT_EQ] = ACTIONS(9003),
    [anon_sym_CARET] = ACTIONS(8983),
    [anon_sym_PLUS] = ACTIONS(9005),
    [anon_sym_SLASH] = ACTIONS(8985),
    [anon_sym_PERCENT] = ACTIONS(8985),
    [sym_comment] = ACTIONS(87),
  },
  [8181] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8979),
    [sym__binary_star] = ACTIONS(8981),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(8983),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8985),
    [anon_sym_AMP] = ACTIONS(8987),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(8989),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(8999),
    [anon_sym_GT_GT] = ACTIONS(8999),
    [anon_sym_EQ_EQ] = ACTIONS(8997),
    [anon_sym_BANG_EQ] = ACTIONS(9001),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9001),
    [anon_sym_LT_EQ_GT] = ACTIONS(9001),
    [anon_sym_EQ_TILDE] = ACTIONS(9001),
    [anon_sym_BANG_TILDE] = ACTIONS(9001),
    [anon_sym_LT_EQ] = ACTIONS(8989),
    [anon_sym_GT] = ACTIONS(8989),
    [anon_sym_GT_EQ] = ACTIONS(9003),
    [anon_sym_CARET] = ACTIONS(8983),
    [anon_sym_PLUS] = ACTIONS(9005),
    [anon_sym_SLASH] = ACTIONS(8985),
    [anon_sym_PERCENT] = ACTIONS(8985),
    [sym_comment] = ACTIONS(87),
  },
  [8182] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(8979),
    [sym__binary_star] = ACTIONS(8981),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(8985),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(9005),
    [anon_sym_SLASH] = ACTIONS(8985),
    [anon_sym_PERCENT] = ACTIONS(8985),
    [sym_comment] = ACTIONS(87),
  },
  [8183] = {
    [sym_heredoc_body] = STATE(8183),
    [aux_sym_call_repeat1] = STATE(8183),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(9846),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7919),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_EQ] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_end] = ACTIONS(7914),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_ensure] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_PLUS_EQ] = ACTIONS(7914),
    [anon_sym_DASH_EQ] = ACTIONS(7914),
    [anon_sym_STAR_EQ] = ACTIONS(7914),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7914),
    [anon_sym_SLASH_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7914),
    [anon_sym_AMP_EQ] = ACTIONS(7914),
    [anon_sym_PERCENT_EQ] = ACTIONS(7914),
    [anon_sym_GT_GT_EQ] = ACTIONS(7914),
    [anon_sym_LT_LT_EQ] = ACTIONS(7914),
    [anon_sym_CARET_EQ] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7919),
    [anon_sym_AMP_AMP] = ACTIONS(7919),
    [anon_sym_LT_LT] = ACTIONS(7919),
    [anon_sym_GT_GT] = ACTIONS(7919),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7919),
    [anon_sym_PLUS] = ACTIONS(7919),
    [anon_sym_SLASH] = ACTIONS(7919),
    [anon_sym_PERCENT] = ACTIONS(7919),
    [sym_comment] = ACTIONS(87),
  },
  [8184] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3153),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3158),
    [sym_scope_resolution] = STATE(3154),
    [sym_call] = STATE(3154),
    [sym_method_call] = STATE(3158),
    [sym__argument] = STATE(6393),
    [sym_splat_argument] = STATE(6393),
    [sym_hash_splat_argument] = STATE(6393),
    [sym_block_argument] = STATE(6393),
    [sym_assignment] = STATE(3153),
    [sym_operator_assignment] = STATE(3153),
    [sym_conditional] = STATE(3153),
    [sym_range] = STATE(3153),
    [sym_binary] = STATE(3153),
    [sym_unary] = STATE(3153),
    [sym_left_assignment_list] = STATE(3157),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3158),
    [sym__variable] = STATE(3154),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3158),
    [sym_false] = STATE(3158),
    [sym_nil] = STATE(3158),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3159),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(6393),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(5261),
    [sym__splat_star] = ACTIONS(5263),
    [sym__unary_minus] = ACTIONS(5265),
    [sym__identifier_hash_key] = ACTIONS(5267),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11688),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5269),
    [anon_sym_yield] = ACTIONS(5271),
    [anon_sym_break] = ACTIONS(5273),
    [anon_sym_next] = ACTIONS(5275),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(8973),
    [anon_sym_defined_QMARK] = ACTIONS(5277),
    [anon_sym_not] = ACTIONS(5279),
    [anon_sym_BANG] = ACTIONS(5283),
    [anon_sym_TILDE] = ACTIONS(5283),
    [sym_constant] = ACTIONS(5285),
    [sym_identifier] = ACTIONS(5285),
    [sym_instance_variable] = ACTIONS(5287),
    [sym_class_variable] = ACTIONS(5287),
    [sym_global_variable] = ACTIONS(5287),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5289),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5289),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [8185] = {
    [sym_heredoc_body] = STATE(8183),
    [aux_sym_call_repeat1] = STATE(8183),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7931),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_EQ] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_end] = ACTIONS(7929),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_ensure] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_PLUS_EQ] = ACTIONS(7929),
    [anon_sym_DASH_EQ] = ACTIONS(7929),
    [anon_sym_STAR_EQ] = ACTIONS(7929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7929),
    [anon_sym_SLASH_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7929),
    [anon_sym_AMP_EQ] = ACTIONS(7929),
    [anon_sym_PERCENT_EQ] = ACTIONS(7929),
    [anon_sym_GT_GT_EQ] = ACTIONS(7929),
    [anon_sym_LT_LT_EQ] = ACTIONS(7929),
    [anon_sym_CARET_EQ] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7931),
    [anon_sym_AMP_AMP] = ACTIONS(7931),
    [anon_sym_LT_LT] = ACTIONS(7931),
    [anon_sym_GT_GT] = ACTIONS(7931),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7931),
    [anon_sym_PLUS] = ACTIONS(7931),
    [anon_sym_SLASH] = ACTIONS(7931),
    [anon_sym_PERCENT] = ACTIONS(7931),
    [sym_comment] = ACTIONS(87),
  },
  [8186] = {
    [aux_sym_argument_list_repeat1] = STATE(8186),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(13530),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7927),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_EQ] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_end] = ACTIONS(7925),
    [anon_sym_if] = ACTIONS(7925),
    [anon_sym_unless] = ACTIONS(7925),
    [anon_sym_while] = ACTIONS(7925),
    [anon_sym_until] = ACTIONS(7925),
    [anon_sym_rescue] = ACTIONS(7925),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_ensure] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_PLUS_EQ] = ACTIONS(7925),
    [anon_sym_DASH_EQ] = ACTIONS(7925),
    [anon_sym_STAR_EQ] = ACTIONS(7925),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7925),
    [anon_sym_SLASH_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7925),
    [anon_sym_AMP_EQ] = ACTIONS(7925),
    [anon_sym_PERCENT_EQ] = ACTIONS(7925),
    [anon_sym_GT_GT_EQ] = ACTIONS(7925),
    [anon_sym_LT_LT_EQ] = ACTIONS(7925),
    [anon_sym_CARET_EQ] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7927),
    [anon_sym_AMP_AMP] = ACTIONS(7927),
    [anon_sym_LT_LT] = ACTIONS(7927),
    [anon_sym_GT_GT] = ACTIONS(7927),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7927),
    [anon_sym_PLUS] = ACTIONS(7927),
    [anon_sym_SLASH] = ACTIONS(7927),
    [anon_sym_PERCENT] = ACTIONS(7927),
    [sym_comment] = ACTIONS(87),
  },
  [8187] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(8979),
    [sym__binary_star] = ACTIONS(8981),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(8983),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(8985),
    [anon_sym_AMP] = ACTIONS(8987),
    [anon_sym_EQ] = ACTIONS(7936),
    [anon_sym_LT] = ACTIONS(8989),
    [anon_sym_end] = ACTIONS(5115),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_ensure] = ACTIONS(5115),
    [anon_sym_EQ_GT] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_PLUS_EQ] = ACTIONS(5115),
    [anon_sym_DASH_EQ] = ACTIONS(5115),
    [anon_sym_STAR_EQ] = ACTIONS(5115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5115),
    [anon_sym_SLASH_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5115),
    [anon_sym_AMP_EQ] = ACTIONS(5115),
    [anon_sym_PERCENT_EQ] = ACTIONS(5115),
    [anon_sym_GT_GT_EQ] = ACTIONS(5115),
    [anon_sym_LT_LT_EQ] = ACTIONS(5115),
    [anon_sym_CARET_EQ] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(8991),
    [anon_sym_DOT_DOT] = ACTIONS(8993),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8995),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(8997),
    [anon_sym_AMP_AMP] = ACTIONS(8997),
    [anon_sym_LT_LT] = ACTIONS(8999),
    [anon_sym_GT_GT] = ACTIONS(8999),
    [anon_sym_EQ_EQ] = ACTIONS(8997),
    [anon_sym_BANG_EQ] = ACTIONS(9001),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9001),
    [anon_sym_LT_EQ_GT] = ACTIONS(9001),
    [anon_sym_EQ_TILDE] = ACTIONS(9001),
    [anon_sym_BANG_TILDE] = ACTIONS(9001),
    [anon_sym_LT_EQ] = ACTIONS(8989),
    [anon_sym_GT] = ACTIONS(8989),
    [anon_sym_GT_EQ] = ACTIONS(9003),
    [anon_sym_CARET] = ACTIONS(8983),
    [anon_sym_PLUS] = ACTIONS(9005),
    [anon_sym_SLASH] = ACTIONS(8985),
    [anon_sym_PERCENT] = ACTIONS(8985),
    [sym_comment] = ACTIONS(87),
  },
  [8188] = {
    [aux_sym_exceptions_repeat1] = STATE(9784),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6193),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_end] = ACTIONS(6191),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_ensure] = ACTIONS(6191),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_PLUS_EQ] = ACTIONS(6191),
    [anon_sym_DASH_EQ] = ACTIONS(6191),
    [anon_sym_STAR_EQ] = ACTIONS(6191),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6191),
    [anon_sym_SLASH_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6191),
    [anon_sym_AMP_EQ] = ACTIONS(6191),
    [anon_sym_PERCENT_EQ] = ACTIONS(6191),
    [anon_sym_GT_GT_EQ] = ACTIONS(6191),
    [anon_sym_LT_LT_EQ] = ACTIONS(6191),
    [anon_sym_CARET_EQ] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6193),
    [anon_sym_AMP_AMP] = ACTIONS(6193),
    [anon_sym_LT_LT] = ACTIONS(6193),
    [anon_sym_GT_GT] = ACTIONS(6193),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6193),
    [anon_sym_PLUS] = ACTIONS(6193),
    [anon_sym_SLASH] = ACTIONS(6193),
    [anon_sym_PERCENT] = ACTIONS(6193),
    [sym_comment] = ACTIONS(87),
  },
  [8189] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(8979),
    [sym__binary_star] = ACTIONS(8981),
    [anon_sym_LBRACE] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(8983),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(8985),
    [anon_sym_AMP] = ACTIONS(8987),
    [anon_sym_EQ] = ACTIONS(7938),
    [anon_sym_LT] = ACTIONS(8989),
    [anon_sym_end] = ACTIONS(6210),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_ensure] = ACTIONS(6210),
    [anon_sym_EQ_GT] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_PLUS_EQ] = ACTIONS(6210),
    [anon_sym_DASH_EQ] = ACTIONS(6210),
    [anon_sym_STAR_EQ] = ACTIONS(6210),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6210),
    [anon_sym_SLASH_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6210),
    [anon_sym_AMP_EQ] = ACTIONS(6210),
    [anon_sym_PERCENT_EQ] = ACTIONS(6210),
    [anon_sym_GT_GT_EQ] = ACTIONS(6210),
    [anon_sym_LT_LT_EQ] = ACTIONS(6210),
    [anon_sym_CARET_EQ] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(8991),
    [anon_sym_DOT_DOT] = ACTIONS(8993),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8995),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(8997),
    [anon_sym_AMP_AMP] = ACTIONS(8997),
    [anon_sym_LT_LT] = ACTIONS(8999),
    [anon_sym_GT_GT] = ACTIONS(8999),
    [anon_sym_EQ_EQ] = ACTIONS(8997),
    [anon_sym_BANG_EQ] = ACTIONS(9001),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9001),
    [anon_sym_LT_EQ_GT] = ACTIONS(9001),
    [anon_sym_EQ_TILDE] = ACTIONS(9001),
    [anon_sym_BANG_TILDE] = ACTIONS(9001),
    [anon_sym_LT_EQ] = ACTIONS(8989),
    [anon_sym_GT] = ACTIONS(8989),
    [anon_sym_GT_EQ] = ACTIONS(9003),
    [anon_sym_CARET] = ACTIONS(8983),
    [anon_sym_PLUS] = ACTIONS(9005),
    [anon_sym_SLASH] = ACTIONS(8985),
    [anon_sym_PERCENT] = ACTIONS(8985),
    [sym_comment] = ACTIONS(87),
  },
  [8190] = {
    [sym_string] = STATE(8190),
    [aux_sym_chained_string_repeat1] = STATE(8190),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(9852),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6217),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_EQ] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_end] = ACTIONS(6212),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_do] = ACTIONS(6212),
    [anon_sym_ensure] = ACTIONS(6212),
    [anon_sym_EQ_GT] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_PLUS_EQ] = ACTIONS(6212),
    [anon_sym_DASH_EQ] = ACTIONS(6212),
    [anon_sym_STAR_EQ] = ACTIONS(6212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6212),
    [anon_sym_SLASH_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6212),
    [anon_sym_AMP_EQ] = ACTIONS(6212),
    [anon_sym_PERCENT_EQ] = ACTIONS(6212),
    [anon_sym_GT_GT_EQ] = ACTIONS(6212),
    [anon_sym_LT_LT_EQ] = ACTIONS(6212),
    [anon_sym_CARET_EQ] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6217),
    [anon_sym_AMP_AMP] = ACTIONS(6217),
    [anon_sym_LT_LT] = ACTIONS(6217),
    [anon_sym_GT_GT] = ACTIONS(6217),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6217),
    [anon_sym_PLUS] = ACTIONS(6217),
    [anon_sym_SLASH] = ACTIONS(6217),
    [anon_sym_PERCENT] = ACTIONS(6217),
    [sym_comment] = ACTIONS(87),
  },
  [8191] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(11690),
    [sym__binary_star] = ACTIONS(11692),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(11694),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(11692),
    [anon_sym_AMP] = ACTIONS(11696),
    [anon_sym_LT] = ACTIONS(11698),
    [anon_sym_end] = ACTIONS(4247),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_ensure] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(11700),
    [anon_sym_DOT_DOT] = ACTIONS(11702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11704),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(11706),
    [anon_sym_AMP_AMP] = ACTIONS(11706),
    [anon_sym_LT_LT] = ACTIONS(11708),
    [anon_sym_GT_GT] = ACTIONS(11708),
    [anon_sym_EQ_EQ] = ACTIONS(11710),
    [anon_sym_BANG_EQ] = ACTIONS(11706),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11706),
    [anon_sym_LT_EQ_GT] = ACTIONS(11706),
    [anon_sym_EQ_TILDE] = ACTIONS(11706),
    [anon_sym_BANG_TILDE] = ACTIONS(11706),
    [anon_sym_LT_EQ] = ACTIONS(11698),
    [anon_sym_GT] = ACTIONS(11698),
    [anon_sym_GT_EQ] = ACTIONS(11712),
    [anon_sym_CARET] = ACTIONS(11714),
    [anon_sym_PLUS] = ACTIONS(11690),
    [anon_sym_SLASH] = ACTIONS(11692),
    [anon_sym_PERCENT] = ACTIONS(11692),
    [sym_comment] = ACTIONS(87),
  },
  [8192] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(11692),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_ensure] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [8193] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(11690),
    [sym__binary_star] = ACTIONS(11692),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(11694),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(11692),
    [anon_sym_AMP] = ACTIONS(11696),
    [anon_sym_LT] = ACTIONS(11698),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_ensure] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(11700),
    [anon_sym_DOT_DOT] = ACTIONS(11702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11704),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(11706),
    [anon_sym_AMP_AMP] = ACTIONS(11706),
    [anon_sym_LT_LT] = ACTIONS(11708),
    [anon_sym_GT_GT] = ACTIONS(11708),
    [anon_sym_EQ_EQ] = ACTIONS(11710),
    [anon_sym_BANG_EQ] = ACTIONS(11706),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11706),
    [anon_sym_LT_EQ_GT] = ACTIONS(11706),
    [anon_sym_EQ_TILDE] = ACTIONS(11706),
    [anon_sym_BANG_TILDE] = ACTIONS(11706),
    [anon_sym_LT_EQ] = ACTIONS(11698),
    [anon_sym_GT] = ACTIONS(11698),
    [anon_sym_GT_EQ] = ACTIONS(11712),
    [anon_sym_CARET] = ACTIONS(11714),
    [anon_sym_PLUS] = ACTIONS(11690),
    [anon_sym_SLASH] = ACTIONS(11692),
    [anon_sym_PERCENT] = ACTIONS(11692),
    [sym_comment] = ACTIONS(87),
  },
  [8194] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9785),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5777),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(5777),
    [sym_assignment] = STATE(9785),
    [sym_operator_assignment] = STATE(9785),
    [sym_conditional] = STATE(9785),
    [sym_range] = STATE(9785),
    [sym_binary] = STATE(9785),
    [sym_unary] = STATE(9785),
    [sym_left_assignment_list] = STATE(5776),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5777),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5777),
    [sym_false] = STATE(5777),
    [sym_nil] = STATE(5777),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5677),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9019),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8877),
    [anon_sym_yield] = ACTIONS(8879),
    [anon_sym_break] = ACTIONS(8881),
    [anon_sym_next] = ACTIONS(8883),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9021),
    [anon_sym_defined_QMARK] = ACTIONS(9023),
    [anon_sym_not] = ACTIONS(9025),
    [anon_sym_BANG] = ACTIONS(9027),
    [anon_sym_TILDE] = ACTIONS(9027),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8195] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9786),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5777),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(5777),
    [sym_assignment] = STATE(9786),
    [sym_operator_assignment] = STATE(9786),
    [sym_conditional] = STATE(9786),
    [sym_range] = STATE(9786),
    [sym_binary] = STATE(9786),
    [sym_unary] = STATE(9786),
    [sym_left_assignment_list] = STATE(5776),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5777),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5777),
    [sym_false] = STATE(5777),
    [sym_nil] = STATE(5777),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5677),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9019),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8877),
    [anon_sym_yield] = ACTIONS(8879),
    [anon_sym_break] = ACTIONS(8881),
    [anon_sym_next] = ACTIONS(8883),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9021),
    [anon_sym_defined_QMARK] = ACTIONS(9023),
    [anon_sym_not] = ACTIONS(9025),
    [anon_sym_BANG] = ACTIONS(9027),
    [anon_sym_TILDE] = ACTIONS(9027),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8196] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9787),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5777),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(5777),
    [sym_assignment] = STATE(9787),
    [sym_operator_assignment] = STATE(9787),
    [sym_conditional] = STATE(9787),
    [sym_range] = STATE(9787),
    [sym_binary] = STATE(9787),
    [sym_unary] = STATE(9787),
    [sym_left_assignment_list] = STATE(5776),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5777),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5777),
    [sym_false] = STATE(5777),
    [sym_nil] = STATE(5777),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5677),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9019),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8877),
    [anon_sym_yield] = ACTIONS(8879),
    [anon_sym_break] = ACTIONS(8881),
    [anon_sym_next] = ACTIONS(8883),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9021),
    [anon_sym_defined_QMARK] = ACTIONS(9023),
    [anon_sym_not] = ACTIONS(9025),
    [anon_sym_BANG] = ACTIONS(9027),
    [anon_sym_TILDE] = ACTIONS(9027),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8197] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9788),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5777),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(5777),
    [sym_assignment] = STATE(9788),
    [sym_operator_assignment] = STATE(9788),
    [sym_conditional] = STATE(9788),
    [sym_range] = STATE(9788),
    [sym_binary] = STATE(9788),
    [sym_unary] = STATE(9788),
    [sym_left_assignment_list] = STATE(5776),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5777),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5777),
    [sym_false] = STATE(5777),
    [sym_nil] = STATE(5777),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5677),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9019),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8877),
    [anon_sym_yield] = ACTIONS(8879),
    [anon_sym_break] = ACTIONS(8881),
    [anon_sym_next] = ACTIONS(8883),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9021),
    [anon_sym_defined_QMARK] = ACTIONS(9023),
    [anon_sym_not] = ACTIONS(9025),
    [anon_sym_BANG] = ACTIONS(9027),
    [anon_sym_TILDE] = ACTIONS(9027),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8198] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9789),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5777),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(5777),
    [sym_assignment] = STATE(9789),
    [sym_operator_assignment] = STATE(9789),
    [sym_conditional] = STATE(9789),
    [sym_range] = STATE(9789),
    [sym_binary] = STATE(9789),
    [sym_unary] = STATE(9789),
    [sym_left_assignment_list] = STATE(5776),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5777),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5777),
    [sym_false] = STATE(5777),
    [sym_nil] = STATE(5777),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5677),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9019),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8877),
    [anon_sym_yield] = ACTIONS(8879),
    [anon_sym_break] = ACTIONS(8881),
    [anon_sym_next] = ACTIONS(8883),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9021),
    [anon_sym_defined_QMARK] = ACTIONS(9023),
    [anon_sym_not] = ACTIONS(9025),
    [anon_sym_BANG] = ACTIONS(9027),
    [anon_sym_TILDE] = ACTIONS(9027),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8199] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(9790),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(9790),
    [sym_operator_assignment] = STATE(9790),
    [sym_conditional] = STATE(9790),
    [sym_range] = STATE(9790),
    [sym_binary] = STATE(9790),
    [sym_unary] = STATE(9790),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8200] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9791),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5777),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(5777),
    [sym_assignment] = STATE(9791),
    [sym_operator_assignment] = STATE(9791),
    [sym_conditional] = STATE(9791),
    [sym_range] = STATE(9791),
    [sym_binary] = STATE(9791),
    [sym_unary] = STATE(9791),
    [sym_left_assignment_list] = STATE(5776),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5777),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5777),
    [sym_false] = STATE(5777),
    [sym_nil] = STATE(5777),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5677),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9019),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8877),
    [anon_sym_yield] = ACTIONS(8879),
    [anon_sym_break] = ACTIONS(8881),
    [anon_sym_next] = ACTIONS(8883),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9021),
    [anon_sym_defined_QMARK] = ACTIONS(9023),
    [anon_sym_not] = ACTIONS(9025),
    [anon_sym_BANG] = ACTIONS(9027),
    [anon_sym_TILDE] = ACTIONS(9027),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8201] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9792),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5777),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(5777),
    [sym_assignment] = STATE(9792),
    [sym_operator_assignment] = STATE(9792),
    [sym_conditional] = STATE(9792),
    [sym_range] = STATE(9792),
    [sym_binary] = STATE(9792),
    [sym_unary] = STATE(9792),
    [sym_left_assignment_list] = STATE(5776),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5777),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5777),
    [sym_false] = STATE(5777),
    [sym_nil] = STATE(5777),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5677),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9019),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8877),
    [anon_sym_yield] = ACTIONS(8879),
    [anon_sym_break] = ACTIONS(8881),
    [anon_sym_next] = ACTIONS(8883),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9021),
    [anon_sym_defined_QMARK] = ACTIONS(9023),
    [anon_sym_not] = ACTIONS(9025),
    [anon_sym_BANG] = ACTIONS(9027),
    [anon_sym_TILDE] = ACTIONS(9027),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8202] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9793),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5777),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(5777),
    [sym_assignment] = STATE(9793),
    [sym_operator_assignment] = STATE(9793),
    [sym_conditional] = STATE(9793),
    [sym_range] = STATE(9793),
    [sym_binary] = STATE(9793),
    [sym_unary] = STATE(9793),
    [sym_left_assignment_list] = STATE(5776),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5777),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5777),
    [sym_false] = STATE(5777),
    [sym_nil] = STATE(5777),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5677),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9019),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8877),
    [anon_sym_yield] = ACTIONS(8879),
    [anon_sym_break] = ACTIONS(8881),
    [anon_sym_next] = ACTIONS(8883),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9021),
    [anon_sym_defined_QMARK] = ACTIONS(9023),
    [anon_sym_not] = ACTIONS(9025),
    [anon_sym_BANG] = ACTIONS(9027),
    [anon_sym_TILDE] = ACTIONS(9027),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8203] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9794),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5777),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(5777),
    [sym_assignment] = STATE(9794),
    [sym_operator_assignment] = STATE(9794),
    [sym_conditional] = STATE(9794),
    [sym_range] = STATE(9794),
    [sym_binary] = STATE(9794),
    [sym_unary] = STATE(9794),
    [sym_left_assignment_list] = STATE(5776),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5777),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5777),
    [sym_false] = STATE(5777),
    [sym_nil] = STATE(5777),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5677),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9019),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8877),
    [anon_sym_yield] = ACTIONS(8879),
    [anon_sym_break] = ACTIONS(8881),
    [anon_sym_next] = ACTIONS(8883),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9021),
    [anon_sym_defined_QMARK] = ACTIONS(9023),
    [anon_sym_not] = ACTIONS(9025),
    [anon_sym_BANG] = ACTIONS(9027),
    [anon_sym_TILDE] = ACTIONS(9027),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8204] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5774),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5777),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(5777),
    [sym_splat_argument] = STATE(6406),
    [sym_assignment] = STATE(5774),
    [sym_operator_assignment] = STATE(5774),
    [sym_conditional] = STATE(5774),
    [sym_range] = STATE(5774),
    [sym_binary] = STATE(5774),
    [sym_unary] = STATE(5774),
    [sym__arg_or_splat_arg] = STATE(6406),
    [sym_left_assignment_list] = STATE(5776),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5777),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5777),
    [sym_false] = STATE(5777),
    [sym_nil] = STATE(5777),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5677),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(9017),
    [sym__unary_minus] = ACTIONS(9019),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8877),
    [anon_sym_yield] = ACTIONS(8879),
    [anon_sym_break] = ACTIONS(8881),
    [anon_sym_next] = ACTIONS(8883),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9021),
    [anon_sym_defined_QMARK] = ACTIONS(9023),
    [anon_sym_not] = ACTIONS(9025),
    [anon_sym_BANG] = ACTIONS(9027),
    [anon_sym_TILDE] = ACTIONS(9027),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8205] = {
    [aux_sym_exceptions_repeat1] = STATE(9795),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_COMMA] = ACTIONS(11716),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_end] = ACTIONS(9855),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_ensure] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [8206] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5774),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5777),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(5777),
    [sym_splat_argument] = STATE(9796),
    [sym_assignment] = STATE(5774),
    [sym_operator_assignment] = STATE(5774),
    [sym_conditional] = STATE(5774),
    [sym_range] = STATE(5774),
    [sym_binary] = STATE(5774),
    [sym_unary] = STATE(5774),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(9796),
    [sym_left_assignment_list] = STATE(5776),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5777),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5777),
    [sym_false] = STATE(5777),
    [sym_nil] = STATE(5777),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5677),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(9017),
    [sym__unary_minus] = ACTIONS(9019),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8877),
    [anon_sym_yield] = ACTIONS(8879),
    [anon_sym_break] = ACTIONS(8881),
    [anon_sym_next] = ACTIONS(8883),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9021),
    [anon_sym_defined_QMARK] = ACTIONS(9023),
    [anon_sym_not] = ACTIONS(9025),
    [anon_sym_BANG] = ACTIONS(9027),
    [anon_sym_TILDE] = ACTIONS(9027),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8207] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9797),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5777),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(5777),
    [sym_assignment] = STATE(9797),
    [sym_operator_assignment] = STATE(9797),
    [sym_conditional] = STATE(9797),
    [sym_range] = STATE(9797),
    [sym_binary] = STATE(9797),
    [sym_unary] = STATE(9797),
    [sym_left_assignment_list] = STATE(5776),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5777),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5777),
    [sym_false] = STATE(5777),
    [sym_nil] = STATE(5777),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5677),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9019),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8877),
    [anon_sym_yield] = ACTIONS(8879),
    [anon_sym_break] = ACTIONS(8881),
    [anon_sym_next] = ACTIONS(8883),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9021),
    [anon_sym_defined_QMARK] = ACTIONS(9023),
    [anon_sym_not] = ACTIONS(9025),
    [anon_sym_BANG] = ACTIONS(9027),
    [anon_sym_TILDE] = ACTIONS(9027),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8208] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(11726),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [8209] = {
    [sym_heredoc_body] = STATE(9798),
    [aux_sym_call_repeat1] = STATE(9798),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [8210] = {
    [sym_heredoc_body] = STATE(9798),
    [aux_sym_call_repeat1] = STATE(9798),
    [aux_sym_argument_list_repeat1] = STATE(9799),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(9097),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [8211] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(11724),
    [sym__binary_star] = ACTIONS(11726),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(11728),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(11726),
    [anon_sym_AMP] = ACTIONS(11730),
    [anon_sym_LT] = ACTIONS(11732),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(11734),
    [anon_sym_DOT_DOT] = ACTIONS(11736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11738),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(11740),
    [anon_sym_AMP_AMP] = ACTIONS(11740),
    [anon_sym_LT_LT] = ACTIONS(11742),
    [anon_sym_GT_GT] = ACTIONS(11742),
    [anon_sym_EQ_EQ] = ACTIONS(11744),
    [anon_sym_BANG_EQ] = ACTIONS(11740),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11740),
    [anon_sym_LT_EQ_GT] = ACTIONS(11740),
    [anon_sym_EQ_TILDE] = ACTIONS(11740),
    [anon_sym_BANG_TILDE] = ACTIONS(11740),
    [anon_sym_LT_EQ] = ACTIONS(11732),
    [anon_sym_GT] = ACTIONS(11732),
    [anon_sym_GT_EQ] = ACTIONS(11746),
    [anon_sym_CARET] = ACTIONS(11748),
    [anon_sym_PLUS] = ACTIONS(11724),
    [anon_sym_SLASH] = ACTIONS(11726),
    [anon_sym_PERCENT] = ACTIONS(11726),
    [sym_comment] = ACTIONS(87),
  },
  [8212] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9800),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5789),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(5789),
    [sym_assignment] = STATE(9800),
    [sym_operator_assignment] = STATE(9800),
    [sym_conditional] = STATE(9800),
    [sym_range] = STATE(9800),
    [sym_binary] = STATE(9800),
    [sym_unary] = STATE(9800),
    [sym_left_assignment_list] = STATE(5788),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5789),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5789),
    [sym_false] = STATE(5789),
    [sym_nil] = STATE(5789),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5790),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9031),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9033),
    [anon_sym_yield] = ACTIONS(9035),
    [anon_sym_break] = ACTIONS(9037),
    [anon_sym_next] = ACTIONS(9039),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9041),
    [anon_sym_defined_QMARK] = ACTIONS(9043),
    [anon_sym_not] = ACTIONS(9045),
    [anon_sym_BANG] = ACTIONS(9047),
    [anon_sym_TILDE] = ACTIONS(9047),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8213] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9801),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5789),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(5789),
    [sym_assignment] = STATE(9801),
    [sym_operator_assignment] = STATE(9801),
    [sym_conditional] = STATE(9801),
    [sym_range] = STATE(9801),
    [sym_binary] = STATE(9801),
    [sym_unary] = STATE(9801),
    [sym_left_assignment_list] = STATE(5788),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5789),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5789),
    [sym_false] = STATE(5789),
    [sym_nil] = STATE(5789),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5790),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9031),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9033),
    [anon_sym_yield] = ACTIONS(9035),
    [anon_sym_break] = ACTIONS(9037),
    [anon_sym_next] = ACTIONS(9039),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9041),
    [anon_sym_defined_QMARK] = ACTIONS(9043),
    [anon_sym_not] = ACTIONS(9045),
    [anon_sym_BANG] = ACTIONS(9047),
    [anon_sym_TILDE] = ACTIONS(9047),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8214] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9802),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5789),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(5789),
    [sym_assignment] = STATE(9802),
    [sym_operator_assignment] = STATE(9802),
    [sym_conditional] = STATE(9802),
    [sym_range] = STATE(9802),
    [sym_binary] = STATE(9802),
    [sym_unary] = STATE(9802),
    [sym_left_assignment_list] = STATE(5788),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5789),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5789),
    [sym_false] = STATE(5789),
    [sym_nil] = STATE(5789),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5790),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9031),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9033),
    [anon_sym_yield] = ACTIONS(9035),
    [anon_sym_break] = ACTIONS(9037),
    [anon_sym_next] = ACTIONS(9039),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9041),
    [anon_sym_defined_QMARK] = ACTIONS(9043),
    [anon_sym_not] = ACTIONS(9045),
    [anon_sym_BANG] = ACTIONS(9047),
    [anon_sym_TILDE] = ACTIONS(9047),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8215] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9803),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5789),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(5789),
    [sym_assignment] = STATE(9803),
    [sym_operator_assignment] = STATE(9803),
    [sym_conditional] = STATE(9803),
    [sym_range] = STATE(9803),
    [sym_binary] = STATE(9803),
    [sym_unary] = STATE(9803),
    [sym_left_assignment_list] = STATE(5788),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5789),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5789),
    [sym_false] = STATE(5789),
    [sym_nil] = STATE(5789),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5790),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9031),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9033),
    [anon_sym_yield] = ACTIONS(9035),
    [anon_sym_break] = ACTIONS(9037),
    [anon_sym_next] = ACTIONS(9039),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9041),
    [anon_sym_defined_QMARK] = ACTIONS(9043),
    [anon_sym_not] = ACTIONS(9045),
    [anon_sym_BANG] = ACTIONS(9047),
    [anon_sym_TILDE] = ACTIONS(9047),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8216] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9804),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5789),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(5789),
    [sym_assignment] = STATE(9804),
    [sym_operator_assignment] = STATE(9804),
    [sym_conditional] = STATE(9804),
    [sym_range] = STATE(9804),
    [sym_binary] = STATE(9804),
    [sym_unary] = STATE(9804),
    [sym_left_assignment_list] = STATE(5788),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5789),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5789),
    [sym_false] = STATE(5789),
    [sym_nil] = STATE(5789),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5790),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9031),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9033),
    [anon_sym_yield] = ACTIONS(9035),
    [anon_sym_break] = ACTIONS(9037),
    [anon_sym_next] = ACTIONS(9039),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9041),
    [anon_sym_defined_QMARK] = ACTIONS(9043),
    [anon_sym_not] = ACTIONS(9045),
    [anon_sym_BANG] = ACTIONS(9047),
    [anon_sym_TILDE] = ACTIONS(9047),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8217] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(9805),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(9805),
    [sym_operator_assignment] = STATE(9805),
    [sym_conditional] = STATE(9805),
    [sym_range] = STATE(9805),
    [sym_binary] = STATE(9805),
    [sym_unary] = STATE(9805),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8218] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9806),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5789),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(5789),
    [sym_assignment] = STATE(9806),
    [sym_operator_assignment] = STATE(9806),
    [sym_conditional] = STATE(9806),
    [sym_range] = STATE(9806),
    [sym_binary] = STATE(9806),
    [sym_unary] = STATE(9806),
    [sym_left_assignment_list] = STATE(5788),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5789),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5789),
    [sym_false] = STATE(5789),
    [sym_nil] = STATE(5789),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5790),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9031),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9033),
    [anon_sym_yield] = ACTIONS(9035),
    [anon_sym_break] = ACTIONS(9037),
    [anon_sym_next] = ACTIONS(9039),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9041),
    [anon_sym_defined_QMARK] = ACTIONS(9043),
    [anon_sym_not] = ACTIONS(9045),
    [anon_sym_BANG] = ACTIONS(9047),
    [anon_sym_TILDE] = ACTIONS(9047),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8219] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9807),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5789),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(5789),
    [sym_assignment] = STATE(9807),
    [sym_operator_assignment] = STATE(9807),
    [sym_conditional] = STATE(9807),
    [sym_range] = STATE(9807),
    [sym_binary] = STATE(9807),
    [sym_unary] = STATE(9807),
    [sym_left_assignment_list] = STATE(5788),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5789),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5789),
    [sym_false] = STATE(5789),
    [sym_nil] = STATE(5789),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5790),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9031),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9033),
    [anon_sym_yield] = ACTIONS(9035),
    [anon_sym_break] = ACTIONS(9037),
    [anon_sym_next] = ACTIONS(9039),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9041),
    [anon_sym_defined_QMARK] = ACTIONS(9043),
    [anon_sym_not] = ACTIONS(9045),
    [anon_sym_BANG] = ACTIONS(9047),
    [anon_sym_TILDE] = ACTIONS(9047),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8220] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9808),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5789),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(5789),
    [sym_assignment] = STATE(9808),
    [sym_operator_assignment] = STATE(9808),
    [sym_conditional] = STATE(9808),
    [sym_range] = STATE(9808),
    [sym_binary] = STATE(9808),
    [sym_unary] = STATE(9808),
    [sym_left_assignment_list] = STATE(5788),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5789),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5789),
    [sym_false] = STATE(5789),
    [sym_nil] = STATE(5789),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5790),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9031),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9033),
    [anon_sym_yield] = ACTIONS(9035),
    [anon_sym_break] = ACTIONS(9037),
    [anon_sym_next] = ACTIONS(9039),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9041),
    [anon_sym_defined_QMARK] = ACTIONS(9043),
    [anon_sym_not] = ACTIONS(9045),
    [anon_sym_BANG] = ACTIONS(9047),
    [anon_sym_TILDE] = ACTIONS(9047),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8221] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9809),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5789),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(5789),
    [sym_assignment] = STATE(9809),
    [sym_operator_assignment] = STATE(9809),
    [sym_conditional] = STATE(9809),
    [sym_range] = STATE(9809),
    [sym_binary] = STATE(9809),
    [sym_unary] = STATE(9809),
    [sym_left_assignment_list] = STATE(5788),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5789),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5789),
    [sym_false] = STATE(5789),
    [sym_nil] = STATE(5789),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5790),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9031),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9033),
    [anon_sym_yield] = ACTIONS(9035),
    [anon_sym_break] = ACTIONS(9037),
    [anon_sym_next] = ACTIONS(9039),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9041),
    [anon_sym_defined_QMARK] = ACTIONS(9043),
    [anon_sym_not] = ACTIONS(9045),
    [anon_sym_BANG] = ACTIONS(9047),
    [anon_sym_TILDE] = ACTIONS(9047),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8222] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9810),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5789),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(5789),
    [sym_splat_argument] = STATE(9811),
    [sym_assignment] = STATE(9810),
    [sym_operator_assignment] = STATE(9810),
    [sym_conditional] = STATE(9810),
    [sym_range] = STATE(9810),
    [sym_binary] = STATE(9810),
    [sym_unary] = STATE(9810),
    [sym_right_assignment_list] = STATE(2570),
    [sym__arg_or_splat_arg] = STATE(9811),
    [sym_left_assignment_list] = STATE(5788),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5789),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5789),
    [sym_false] = STATE(5789),
    [sym_nil] = STATE(5789),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5790),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(5301),
    [sym__unary_minus] = ACTIONS(9031),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9033),
    [anon_sym_yield] = ACTIONS(9035),
    [anon_sym_break] = ACTIONS(9037),
    [anon_sym_next] = ACTIONS(9039),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9041),
    [anon_sym_defined_QMARK] = ACTIONS(9043),
    [anon_sym_not] = ACTIONS(9045),
    [anon_sym_BANG] = ACTIONS(9047),
    [anon_sym_TILDE] = ACTIONS(9047),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8223] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9812),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5789),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(5789),
    [sym_assignment] = STATE(9812),
    [sym_operator_assignment] = STATE(9812),
    [sym_conditional] = STATE(9812),
    [sym_range] = STATE(9812),
    [sym_binary] = STATE(9812),
    [sym_unary] = STATE(9812),
    [sym_left_assignment_list] = STATE(5788),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5789),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5789),
    [sym_false] = STATE(5789),
    [sym_nil] = STATE(5789),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5790),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9031),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9033),
    [anon_sym_yield] = ACTIONS(9035),
    [anon_sym_break] = ACTIONS(9037),
    [anon_sym_next] = ACTIONS(9039),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9041),
    [anon_sym_defined_QMARK] = ACTIONS(9043),
    [anon_sym_not] = ACTIONS(9045),
    [anon_sym_BANG] = ACTIONS(9047),
    [anon_sym_TILDE] = ACTIONS(9047),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8224] = {
    [sym_string] = STATE(9813),
    [aux_sym_chained_string_repeat1] = STATE(9813),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_end] = ACTIONS(2753),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [8225] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(11724),
    [sym__binary_star] = ACTIONS(11726),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(11728),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(11726),
    [anon_sym_AMP] = ACTIONS(11730),
    [anon_sym_LT] = ACTIONS(11732),
    [anon_sym_end] = ACTIONS(6823),
    [anon_sym_if] = ACTIONS(6823),
    [anon_sym_unless] = ACTIONS(6823),
    [anon_sym_while] = ACTIONS(6823),
    [anon_sym_until] = ACTIONS(6823),
    [anon_sym_rescue] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(11734),
    [anon_sym_DOT_DOT] = ACTIONS(11736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11738),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(11740),
    [anon_sym_AMP_AMP] = ACTIONS(11740),
    [anon_sym_LT_LT] = ACTIONS(11742),
    [anon_sym_GT_GT] = ACTIONS(11742),
    [anon_sym_EQ_EQ] = ACTIONS(11744),
    [anon_sym_BANG_EQ] = ACTIONS(11740),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11740),
    [anon_sym_LT_EQ_GT] = ACTIONS(11740),
    [anon_sym_EQ_TILDE] = ACTIONS(11740),
    [anon_sym_BANG_TILDE] = ACTIONS(11740),
    [anon_sym_LT_EQ] = ACTIONS(11732),
    [anon_sym_GT] = ACTIONS(11732),
    [anon_sym_GT_EQ] = ACTIONS(11746),
    [anon_sym_CARET] = ACTIONS(11748),
    [anon_sym_PLUS] = ACTIONS(11724),
    [anon_sym_SLASH] = ACTIONS(11726),
    [anon_sym_PERCENT] = ACTIONS(11726),
    [sym_comment] = ACTIONS(87),
  },
  [8226] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(9063),
    [sym__binary_star] = ACTIONS(9065),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(9067),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(9065),
    [anon_sym_AMP] = ACTIONS(9069),
    [anon_sym_LT] = ACTIONS(9071),
    [anon_sym_end] = ACTIONS(4211),
    [anon_sym_if] = ACTIONS(4211),
    [anon_sym_unless] = ACTIONS(4211),
    [anon_sym_while] = ACTIONS(4211),
    [anon_sym_until] = ACTIONS(4211),
    [anon_sym_rescue] = ACTIONS(4211),
    [anon_sym_EQ_GT] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(9073),
    [anon_sym_DOT_DOT] = ACTIONS(9075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9077),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(9079),
    [anon_sym_AMP_AMP] = ACTIONS(9079),
    [anon_sym_LT_LT] = ACTIONS(9081),
    [anon_sym_GT_GT] = ACTIONS(9081),
    [anon_sym_EQ_EQ] = ACTIONS(9083),
    [anon_sym_BANG_EQ] = ACTIONS(9079),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9079),
    [anon_sym_LT_EQ_GT] = ACTIONS(9079),
    [anon_sym_EQ_TILDE] = ACTIONS(9079),
    [anon_sym_BANG_TILDE] = ACTIONS(9079),
    [anon_sym_LT_EQ] = ACTIONS(9071),
    [anon_sym_GT] = ACTIONS(9071),
    [anon_sym_GT_EQ] = ACTIONS(9085),
    [anon_sym_CARET] = ACTIONS(9087),
    [anon_sym_PLUS] = ACTIONS(9063),
    [anon_sym_SLASH] = ACTIONS(9065),
    [anon_sym_PERCENT] = ACTIONS(9065),
    [sym_comment] = ACTIONS(87),
  },
  [8227] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(9063),
    [sym__binary_star] = ACTIONS(9065),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(9067),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(9065),
    [anon_sym_AMP] = ACTIONS(9069),
    [anon_sym_LT] = ACTIONS(9071),
    [anon_sym_end] = ACTIONS(4247),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_EQ_GT] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(9073),
    [anon_sym_DOT_DOT] = ACTIONS(9075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9077),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(9079),
    [anon_sym_AMP_AMP] = ACTIONS(9079),
    [anon_sym_LT_LT] = ACTIONS(9081),
    [anon_sym_GT_GT] = ACTIONS(9081),
    [anon_sym_EQ_EQ] = ACTIONS(9083),
    [anon_sym_BANG_EQ] = ACTIONS(9079),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9079),
    [anon_sym_LT_EQ_GT] = ACTIONS(9079),
    [anon_sym_EQ_TILDE] = ACTIONS(9079),
    [anon_sym_BANG_TILDE] = ACTIONS(9079),
    [anon_sym_LT_EQ] = ACTIONS(9071),
    [anon_sym_GT] = ACTIONS(9071),
    [anon_sym_GT_EQ] = ACTIONS(9085),
    [anon_sym_CARET] = ACTIONS(9087),
    [anon_sym_PLUS] = ACTIONS(9063),
    [anon_sym_SLASH] = ACTIONS(9065),
    [anon_sym_PERCENT] = ACTIONS(9065),
    [sym_comment] = ACTIONS(87),
  },
  [8228] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9814),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3184),
    [sym_scope_resolution] = STATE(3180),
    [sym_call] = STATE(3180),
    [sym_method_call] = STATE(3184),
    [sym_assignment] = STATE(9814),
    [sym_operator_assignment] = STATE(9814),
    [sym_conditional] = STATE(9814),
    [sym_range] = STATE(9814),
    [sym_binary] = STATE(9814),
    [sym_unary] = STATE(9814),
    [sym_left_assignment_list] = STATE(3183),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3184),
    [sym__variable] = STATE(3180),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3184),
    [sym_false] = STATE(3184),
    [sym_nil] = STATE(3184),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5793),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5307),
    [anon_sym_yield] = ACTIONS(5309),
    [anon_sym_break] = ACTIONS(5311),
    [anon_sym_next] = ACTIONS(5313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9049),
    [anon_sym_defined_QMARK] = ACTIONS(5315),
    [anon_sym_not] = ACTIONS(5317),
    [anon_sym_BANG] = ACTIONS(5321),
    [anon_sym_TILDE] = ACTIONS(5321),
    [sym_constant] = ACTIONS(5327),
    [sym_identifier] = ACTIONS(5327),
    [sym_instance_variable] = ACTIONS(5325),
    [sym_class_variable] = ACTIONS(5325),
    [sym_global_variable] = ACTIONS(5325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8229] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(9063),
    [sym__binary_star] = ACTIONS(9065),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(9067),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(9065),
    [anon_sym_AMP] = ACTIONS(9069),
    [anon_sym_LT] = ACTIONS(9071),
    [anon_sym_end] = ACTIONS(3281),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_unless] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_until] = ACTIONS(3281),
    [anon_sym_rescue] = ACTIONS(3281),
    [anon_sym_EQ_GT] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(9073),
    [anon_sym_DOT_DOT] = ACTIONS(9075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9077),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(9079),
    [anon_sym_AMP_AMP] = ACTIONS(9079),
    [anon_sym_LT_LT] = ACTIONS(9081),
    [anon_sym_GT_GT] = ACTIONS(9081),
    [anon_sym_EQ_EQ] = ACTIONS(9083),
    [anon_sym_BANG_EQ] = ACTIONS(9079),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9079),
    [anon_sym_LT_EQ_GT] = ACTIONS(9079),
    [anon_sym_EQ_TILDE] = ACTIONS(9079),
    [anon_sym_BANG_TILDE] = ACTIONS(9079),
    [anon_sym_LT_EQ] = ACTIONS(9071),
    [anon_sym_GT] = ACTIONS(9071),
    [anon_sym_GT_EQ] = ACTIONS(9085),
    [anon_sym_CARET] = ACTIONS(9087),
    [anon_sym_PLUS] = ACTIONS(9063),
    [anon_sym_SLASH] = ACTIONS(9065),
    [anon_sym_PERCENT] = ACTIONS(9065),
    [sym_comment] = ACTIONS(87),
  },
  [8230] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9815),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3184),
    [sym_scope_resolution] = STATE(3180),
    [sym_call] = STATE(3180),
    [sym_method_call] = STATE(3184),
    [sym_assignment] = STATE(9815),
    [sym_operator_assignment] = STATE(9815),
    [sym_conditional] = STATE(9815),
    [sym_range] = STATE(9815),
    [sym_binary] = STATE(9815),
    [sym_unary] = STATE(9815),
    [sym_left_assignment_list] = STATE(3183),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3184),
    [sym__variable] = STATE(3180),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3184),
    [sym_false] = STATE(3184),
    [sym_nil] = STATE(3184),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5793),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5307),
    [anon_sym_yield] = ACTIONS(5309),
    [anon_sym_break] = ACTIONS(5311),
    [anon_sym_next] = ACTIONS(5313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9049),
    [anon_sym_defined_QMARK] = ACTIONS(5315),
    [anon_sym_not] = ACTIONS(5317),
    [anon_sym_BANG] = ACTIONS(5321),
    [anon_sym_TILDE] = ACTIONS(5321),
    [sym_constant] = ACTIONS(5327),
    [sym_identifier] = ACTIONS(5327),
    [sym_instance_variable] = ACTIONS(5325),
    [sym_class_variable] = ACTIONS(5325),
    [sym_global_variable] = ACTIONS(5325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8231] = {
    [sym_heredoc_body] = STATE(9816),
    [aux_sym_call_repeat1] = STATE(9816),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [8232] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5801),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3184),
    [sym_scope_resolution] = STATE(3180),
    [sym_call] = STATE(3180),
    [sym_method_call] = STATE(3184),
    [sym__argument] = STATE(2565),
    [sym_splat_argument] = STATE(2565),
    [sym_hash_splat_argument] = STATE(2565),
    [sym_block_argument] = STATE(2565),
    [sym_assignment] = STATE(5801),
    [sym_operator_assignment] = STATE(5801),
    [sym_conditional] = STATE(5801),
    [sym_range] = STATE(5801),
    [sym_binary] = STATE(5801),
    [sym_unary] = STATE(5801),
    [sym_left_assignment_list] = STATE(3183),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3184),
    [sym__variable] = STATE(3180),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3184),
    [sym_false] = STATE(3184),
    [sym_nil] = STATE(3184),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5804),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(9817),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2565),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(9053),
    [sym__splat_star] = ACTIONS(9055),
    [sym__unary_minus] = ACTIONS(5303),
    [sym__identifier_hash_key] = ACTIONS(9057),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13533),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5307),
    [anon_sym_yield] = ACTIONS(5309),
    [anon_sym_break] = ACTIONS(5311),
    [anon_sym_next] = ACTIONS(5313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9049),
    [anon_sym_defined_QMARK] = ACTIONS(5315),
    [anon_sym_not] = ACTIONS(5317),
    [anon_sym_BANG] = ACTIONS(5321),
    [anon_sym_TILDE] = ACTIONS(5321),
    [sym_constant] = ACTIONS(9059),
    [sym_identifier] = ACTIONS(9059),
    [sym_instance_variable] = ACTIONS(5325),
    [sym_class_variable] = ACTIONS(5325),
    [sym_global_variable] = ACTIONS(5325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8233] = {
    [sym_heredoc_body] = STATE(9818),
    [aux_sym_call_repeat1] = STATE(9818),
    [aux_sym_argument_list_repeat1] = STATE(9819),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(11760),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [8234] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(11724),
    [sym__binary_star] = ACTIONS(11726),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(11728),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(11726),
    [anon_sym_AMP] = ACTIONS(11730),
    [anon_sym_LT] = ACTIONS(11732),
    [anon_sym_end] = ACTIONS(7027),
    [anon_sym_if] = ACTIONS(7027),
    [anon_sym_unless] = ACTIONS(7027),
    [anon_sym_while] = ACTIONS(7027),
    [anon_sym_until] = ACTIONS(7027),
    [anon_sym_rescue] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(11734),
    [anon_sym_DOT_DOT] = ACTIONS(11736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11738),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(11740),
    [anon_sym_AMP_AMP] = ACTIONS(11740),
    [anon_sym_LT_LT] = ACTIONS(11742),
    [anon_sym_GT_GT] = ACTIONS(11742),
    [anon_sym_EQ_EQ] = ACTIONS(11744),
    [anon_sym_BANG_EQ] = ACTIONS(11740),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11740),
    [anon_sym_LT_EQ_GT] = ACTIONS(11740),
    [anon_sym_EQ_TILDE] = ACTIONS(11740),
    [anon_sym_BANG_TILDE] = ACTIONS(11740),
    [anon_sym_LT_EQ] = ACTIONS(11732),
    [anon_sym_GT] = ACTIONS(11732),
    [anon_sym_GT_EQ] = ACTIONS(11746),
    [anon_sym_CARET] = ACTIONS(11748),
    [anon_sym_PLUS] = ACTIONS(11724),
    [anon_sym_SLASH] = ACTIONS(11726),
    [anon_sym_PERCENT] = ACTIONS(11726),
    [sym_comment] = ACTIONS(87),
  },
  [8235] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(9065),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(9065),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(9065),
    [anon_sym_PERCENT] = ACTIONS(9065),
    [sym_comment] = ACTIONS(87),
  },
  [8236] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(9065),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [8237] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(9063),
    [sym__binary_star] = ACTIONS(9065),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(9065),
    [anon_sym_AMP] = ACTIONS(9069),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(9081),
    [anon_sym_GT_GT] = ACTIONS(9081),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(9063),
    [anon_sym_SLASH] = ACTIONS(9065),
    [anon_sym_PERCENT] = ACTIONS(9065),
    [sym_comment] = ACTIONS(87),
  },
  [8238] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(9063),
    [sym__binary_star] = ACTIONS(9065),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(9065),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(9081),
    [anon_sym_GT_GT] = ACTIONS(9081),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(9063),
    [anon_sym_SLASH] = ACTIONS(9065),
    [anon_sym_PERCENT] = ACTIONS(9065),
    [sym_comment] = ACTIONS(87),
  },
  [8239] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(9063),
    [sym__binary_star] = ACTIONS(9065),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(9067),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(9065),
    [anon_sym_AMP] = ACTIONS(9069),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(9081),
    [anon_sym_GT_GT] = ACTIONS(9081),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(9087),
    [anon_sym_PLUS] = ACTIONS(9063),
    [anon_sym_SLASH] = ACTIONS(9065),
    [anon_sym_PERCENT] = ACTIONS(9065),
    [sym_comment] = ACTIONS(87),
  },
  [8240] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(13535),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [8241] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(9063),
    [sym__binary_star] = ACTIONS(9065),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(9067),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(9065),
    [anon_sym_AMP] = ACTIONS(9069),
    [anon_sym_LT] = ACTIONS(9071),
    [anon_sym_end] = ACTIONS(5927),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_EQ_GT] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(9075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9077),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(9079),
    [anon_sym_AMP_AMP] = ACTIONS(9079),
    [anon_sym_LT_LT] = ACTIONS(9081),
    [anon_sym_GT_GT] = ACTIONS(9081),
    [anon_sym_EQ_EQ] = ACTIONS(9083),
    [anon_sym_BANG_EQ] = ACTIONS(9079),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9079),
    [anon_sym_LT_EQ_GT] = ACTIONS(9079),
    [anon_sym_EQ_TILDE] = ACTIONS(9079),
    [anon_sym_BANG_TILDE] = ACTIONS(9079),
    [anon_sym_LT_EQ] = ACTIONS(9071),
    [anon_sym_GT] = ACTIONS(9071),
    [anon_sym_GT_EQ] = ACTIONS(9085),
    [anon_sym_CARET] = ACTIONS(9087),
    [anon_sym_PLUS] = ACTIONS(9063),
    [anon_sym_SLASH] = ACTIONS(9065),
    [anon_sym_PERCENT] = ACTIONS(9065),
    [sym_comment] = ACTIONS(87),
  },
  [8242] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(9063),
    [sym__binary_star] = ACTIONS(9065),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(9067),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(9065),
    [anon_sym_AMP] = ACTIONS(9069),
    [anon_sym_LT] = ACTIONS(9071),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(9073),
    [anon_sym_DOT_DOT] = ACTIONS(9075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9077),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(9079),
    [anon_sym_AMP_AMP] = ACTIONS(9079),
    [anon_sym_LT_LT] = ACTIONS(9081),
    [anon_sym_GT_GT] = ACTIONS(9081),
    [anon_sym_EQ_EQ] = ACTIONS(9083),
    [anon_sym_BANG_EQ] = ACTIONS(9079),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9079),
    [anon_sym_LT_EQ_GT] = ACTIONS(9079),
    [anon_sym_EQ_TILDE] = ACTIONS(9079),
    [anon_sym_BANG_TILDE] = ACTIONS(9079),
    [anon_sym_LT_EQ] = ACTIONS(9071),
    [anon_sym_GT] = ACTIONS(9071),
    [anon_sym_GT_EQ] = ACTIONS(9085),
    [anon_sym_CARET] = ACTIONS(9087),
    [anon_sym_PLUS] = ACTIONS(9063),
    [anon_sym_SLASH] = ACTIONS(9065),
    [anon_sym_PERCENT] = ACTIONS(9065),
    [sym_comment] = ACTIONS(87),
  },
  [8243] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(9063),
    [sym__binary_star] = ACTIONS(9065),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(9067),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(9065),
    [anon_sym_AMP] = ACTIONS(9069),
    [anon_sym_LT] = ACTIONS(9071),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(9081),
    [anon_sym_GT_GT] = ACTIONS(9081),
    [anon_sym_EQ_EQ] = ACTIONS(9083),
    [anon_sym_BANG_EQ] = ACTIONS(9079),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9079),
    [anon_sym_LT_EQ_GT] = ACTIONS(9079),
    [anon_sym_EQ_TILDE] = ACTIONS(9079),
    [anon_sym_BANG_TILDE] = ACTIONS(9079),
    [anon_sym_LT_EQ] = ACTIONS(9071),
    [anon_sym_GT] = ACTIONS(9071),
    [anon_sym_GT_EQ] = ACTIONS(9085),
    [anon_sym_CARET] = ACTIONS(9087),
    [anon_sym_PLUS] = ACTIONS(9063),
    [anon_sym_SLASH] = ACTIONS(9065),
    [anon_sym_PERCENT] = ACTIONS(9065),
    [sym_comment] = ACTIONS(87),
  },
  [8244] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(9063),
    [sym__binary_star] = ACTIONS(9065),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(9065),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(9063),
    [anon_sym_SLASH] = ACTIONS(9065),
    [anon_sym_PERCENT] = ACTIONS(9065),
    [sym_comment] = ACTIONS(87),
  },
  [8245] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(9135),
    [sym__binary_star] = ACTIONS(9137),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(9139),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(9141),
    [anon_sym_AMP] = ACTIONS(9143),
    [anon_sym_EQ] = ACTIONS(4217),
    [anon_sym_LT] = ACTIONS(9145),
    [anon_sym_end] = ACTIONS(4211),
    [anon_sym_if] = ACTIONS(4211),
    [anon_sym_unless] = ACTIONS(4211),
    [anon_sym_while] = ACTIONS(4211),
    [anon_sym_until] = ACTIONS(4211),
    [anon_sym_rescue] = ACTIONS(4211),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_EQ_GT] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_PLUS_EQ] = ACTIONS(4211),
    [anon_sym_DASH_EQ] = ACTIONS(4211),
    [anon_sym_STAR_EQ] = ACTIONS(4211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4211),
    [anon_sym_SLASH_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4211),
    [anon_sym_AMP_EQ] = ACTIONS(4211),
    [anon_sym_PERCENT_EQ] = ACTIONS(4211),
    [anon_sym_GT_GT_EQ] = ACTIONS(4211),
    [anon_sym_LT_LT_EQ] = ACTIONS(4211),
    [anon_sym_CARET_EQ] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(9147),
    [anon_sym_DOT_DOT] = ACTIONS(9149),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9151),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(9153),
    [anon_sym_AMP_AMP] = ACTIONS(9153),
    [anon_sym_LT_LT] = ACTIONS(9155),
    [anon_sym_GT_GT] = ACTIONS(9155),
    [anon_sym_EQ_EQ] = ACTIONS(9153),
    [anon_sym_BANG_EQ] = ACTIONS(9157),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9157),
    [anon_sym_LT_EQ_GT] = ACTIONS(9157),
    [anon_sym_EQ_TILDE] = ACTIONS(9157),
    [anon_sym_BANG_TILDE] = ACTIONS(9157),
    [anon_sym_LT_EQ] = ACTIONS(9145),
    [anon_sym_GT] = ACTIONS(9145),
    [anon_sym_GT_EQ] = ACTIONS(9159),
    [anon_sym_CARET] = ACTIONS(9139),
    [anon_sym_PLUS] = ACTIONS(9161),
    [anon_sym_SLASH] = ACTIONS(9141),
    [anon_sym_PERCENT] = ACTIONS(9141),
    [sym_comment] = ACTIONS(87),
  },
  [8246] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(9135),
    [sym__binary_star] = ACTIONS(9137),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(9139),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(9141),
    [anon_sym_AMP] = ACTIONS(9143),
    [anon_sym_EQ] = ACTIONS(4249),
    [anon_sym_LT] = ACTIONS(9145),
    [anon_sym_end] = ACTIONS(4247),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_EQ_GT] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_PLUS_EQ] = ACTIONS(4247),
    [anon_sym_DASH_EQ] = ACTIONS(4247),
    [anon_sym_STAR_EQ] = ACTIONS(4247),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4247),
    [anon_sym_SLASH_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4247),
    [anon_sym_AMP_EQ] = ACTIONS(4247),
    [anon_sym_PERCENT_EQ] = ACTIONS(4247),
    [anon_sym_GT_GT_EQ] = ACTIONS(4247),
    [anon_sym_LT_LT_EQ] = ACTIONS(4247),
    [anon_sym_CARET_EQ] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(9147),
    [anon_sym_DOT_DOT] = ACTIONS(9149),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9151),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(9153),
    [anon_sym_AMP_AMP] = ACTIONS(9153),
    [anon_sym_LT_LT] = ACTIONS(9155),
    [anon_sym_GT_GT] = ACTIONS(9155),
    [anon_sym_EQ_EQ] = ACTIONS(9153),
    [anon_sym_BANG_EQ] = ACTIONS(9157),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9157),
    [anon_sym_LT_EQ_GT] = ACTIONS(9157),
    [anon_sym_EQ_TILDE] = ACTIONS(9157),
    [anon_sym_BANG_TILDE] = ACTIONS(9157),
    [anon_sym_LT_EQ] = ACTIONS(9145),
    [anon_sym_GT] = ACTIONS(9145),
    [anon_sym_GT_EQ] = ACTIONS(9159),
    [anon_sym_CARET] = ACTIONS(9139),
    [anon_sym_PLUS] = ACTIONS(9161),
    [anon_sym_SLASH] = ACTIONS(9141),
    [anon_sym_PERCENT] = ACTIONS(9141),
    [sym_comment] = ACTIONS(87),
  },
  [8247] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(9821),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3220),
    [sym_scope_resolution] = STATE(3216),
    [sym_call] = STATE(3216),
    [sym_method_call] = STATE(3220),
    [sym_assignment] = STATE(9821),
    [sym_operator_assignment] = STATE(9821),
    [sym_conditional] = STATE(9821),
    [sym_range] = STATE(9821),
    [sym_binary] = STATE(9821),
    [sym_unary] = STATE(9821),
    [sym_left_assignment_list] = STATE(3219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3220),
    [sym__variable] = STATE(3216),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3220),
    [sym_false] = STATE(3220),
    [sym_nil] = STATE(3220),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5862),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5375),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5379),
    [anon_sym_yield] = ACTIONS(5381),
    [anon_sym_break] = ACTIONS(5383),
    [anon_sym_next] = ACTIONS(5385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(9129),
    [anon_sym_defined_QMARK] = ACTIONS(5387),
    [anon_sym_not] = ACTIONS(5389),
    [anon_sym_BANG] = ACTIONS(5393),
    [anon_sym_TILDE] = ACTIONS(5393),
    [sym_constant] = ACTIONS(5399),
    [sym_identifier] = ACTIONS(5399),
    [sym_instance_variable] = ACTIONS(5397),
    [sym_class_variable] = ACTIONS(5397),
    [sym_global_variable] = ACTIONS(5397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [8248] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(9135),
    [sym__binary_star] = ACTIONS(9137),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(9139),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(9141),
    [anon_sym_AMP] = ACTIONS(9143),
    [anon_sym_EQ] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(9145),
    [anon_sym_end] = ACTIONS(3281),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_unless] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_until] = ACTIONS(3281),
    [anon_sym_rescue] = ACTIONS(3281),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_EQ_GT] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_PLUS_EQ] = ACTIONS(3281),
    [anon_sym_DASH_EQ] = ACTIONS(3281),
    [anon_sym_STAR_EQ] = ACTIONS(3281),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3281),
    [anon_sym_SLASH_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3281),
    [anon_sym_AMP_EQ] = ACTIONS(3281),
    [anon_sym_PERCENT_EQ] = ACTIONS(3281),
    [anon_sym_GT_GT_EQ] = ACTIONS(3281),
    [anon_sym_LT_LT_EQ] = ACTIONS(3281),
    [anon_sym_CARET_EQ] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(9147),
    [anon_sym_DOT_DOT] = ACTIONS(9149),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9151),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(9153),
    [anon_sym_AMP_AMP] = ACTIONS(9153),
    [anon_sym_LT_LT] = ACTIONS(9155),
    [anon_sym_GT_GT] = ACTIONS(9155),
    [anon_sym_EQ_EQ] = ACTIONS(9153),
    [anon_sym_BANG_EQ] = ACTIONS(9157),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9157),
    [anon_sym_LT_EQ_GT] = ACTIONS(9157),
    [anon_sym_EQ_TILDE] = ACTIONS(9157),
    [anon_sym_BANG_TILDE] = ACTIONS(9157),
    [anon_sym_LT_EQ] = ACTIONS(9145),
    [anon_sym_GT] = ACTIONS(9145),
    [anon_sym_GT_EQ] = ACTIONS(9159),
    [anon_sym_CARET] = ACTIONS(9139),
    [anon_sym_PLUS] = ACTIONS(9161),
    [anon_sym_SLASH] = ACTIONS(9141),
    [anon_sym_PERCENT] = ACTIONS(9141),
    [sym_comment] = ACTIONS(87),
  },
  [8249] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(9822),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3220),
    [sym_scope_resolution] = STATE(3216),
    [sym_call] = STATE(3216),
    [sym_method_call] = STATE(3220),
    [sym_assignment] = STATE(9822),
    [sym_operator_assignment] = STATE(9822),
    [sym_conditional] = STATE(9822),
    [sym_range] = STATE(9822),
    [sym_binary] = STATE(9822),
    [sym_unary] = STATE(9822),
    [sym_left_assignment_list] = STATE(3219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3220),
    [sym__variable] = STATE(3216),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3220),
    [sym_false] = STATE(3220),
    [sym_nil] = STATE(3220),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5862),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5375),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5379),
    [anon_sym_yield] = ACTIONS(5381),
    [anon_sym_break] = ACTIONS(5383),
    [anon_sym_next] = ACTIONS(5385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(9129),
    [anon_sym_defined_QMARK] = ACTIONS(5387),
    [anon_sym_not] = ACTIONS(5389),
    [anon_sym_BANG] = ACTIONS(5393),
    [anon_sym_TILDE] = ACTIONS(5393),
    [sym_constant] = ACTIONS(5399),
    [sym_identifier] = ACTIONS(5399),
    [sym_instance_variable] = ACTIONS(5397),
    [sym_class_variable] = ACTIONS(5397),
    [sym_global_variable] = ACTIONS(5397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [8250] = {
    [sym_heredoc_body] = STATE(9823),
    [aux_sym_call_repeat1] = STATE(9823),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [8251] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5822),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3220),
    [sym_scope_resolution] = STATE(3216),
    [sym_call] = STATE(3216),
    [sym_method_call] = STATE(3220),
    [sym__argument] = STATE(4979),
    [sym_splat_argument] = STATE(4979),
    [sym_hash_splat_argument] = STATE(4979),
    [sym_block_argument] = STATE(4979),
    [sym_assignment] = STATE(5822),
    [sym_operator_assignment] = STATE(5822),
    [sym_conditional] = STATE(5822),
    [sym_range] = STATE(5822),
    [sym_binary] = STATE(5822),
    [sym_unary] = STATE(5822),
    [sym_left_assignment_list] = STATE(3219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3220),
    [sym__variable] = STATE(3216),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3220),
    [sym_false] = STATE(3220),
    [sym_nil] = STATE(3220),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5825),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_heredoc_body] = STATE(9824),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(4979),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(9089),
    [sym__splat_star] = ACTIONS(9091),
    [sym__unary_minus] = ACTIONS(5375),
    [sym__identifier_hash_key] = ACTIONS(9093),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13537),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5379),
    [anon_sym_yield] = ACTIONS(5381),
    [anon_sym_break] = ACTIONS(5383),
    [anon_sym_next] = ACTIONS(5385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(9129),
    [anon_sym_defined_QMARK] = ACTIONS(5387),
    [anon_sym_not] = ACTIONS(5389),
    [anon_sym_BANG] = ACTIONS(5393),
    [anon_sym_TILDE] = ACTIONS(5393),
    [sym_constant] = ACTIONS(9095),
    [sym_identifier] = ACTIONS(9095),
    [sym_instance_variable] = ACTIONS(5397),
    [sym_class_variable] = ACTIONS(5397),
    [sym_global_variable] = ACTIONS(5397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [8252] = {
    [sym_heredoc_body] = STATE(9825),
    [aux_sym_call_repeat1] = STATE(9825),
    [aux_sym_argument_list_repeat1] = STATE(9826),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(11768),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [8253] = {
    [sym_heredoc_body] = STATE(8253),
    [aux_sym_call_repeat1] = STATE(8253),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(7916),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_end] = ACTIONS(7914),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [8254] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3179),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3184),
    [sym_scope_resolution] = STATE(3180),
    [sym_call] = STATE(3180),
    [sym_method_call] = STATE(3184),
    [sym__argument] = STATE(4986),
    [sym_splat_argument] = STATE(4986),
    [sym_hash_splat_argument] = STATE(4986),
    [sym_block_argument] = STATE(4986),
    [sym_assignment] = STATE(3179),
    [sym_operator_assignment] = STATE(3179),
    [sym_conditional] = STATE(3179),
    [sym_range] = STATE(3179),
    [sym_binary] = STATE(3179),
    [sym_unary] = STATE(3179),
    [sym_left_assignment_list] = STATE(3183),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3184),
    [sym__variable] = STATE(3180),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3184),
    [sym_false] = STATE(3184),
    [sym_nil] = STATE(3184),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3185),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4986),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(5299),
    [sym__splat_star] = ACTIONS(5301),
    [sym__unary_minus] = ACTIONS(5303),
    [sym__identifier_hash_key] = ACTIONS(5305),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11772),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5307),
    [anon_sym_yield] = ACTIONS(5309),
    [anon_sym_break] = ACTIONS(5311),
    [anon_sym_next] = ACTIONS(5313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9049),
    [anon_sym_defined_QMARK] = ACTIONS(5315),
    [anon_sym_not] = ACTIONS(5317),
    [anon_sym_BANG] = ACTIONS(5321),
    [anon_sym_TILDE] = ACTIONS(5321),
    [sym_constant] = ACTIONS(5323),
    [sym_identifier] = ACTIONS(5323),
    [sym_instance_variable] = ACTIONS(5325),
    [sym_class_variable] = ACTIONS(5325),
    [sym_global_variable] = ACTIONS(5325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8255] = {
    [sym_heredoc_body] = STATE(8253),
    [aux_sym_call_repeat1] = STATE(8253),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_end] = ACTIONS(7929),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [8256] = {
    [aux_sym_argument_list_repeat1] = STATE(8256),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(13539),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7925),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_end] = ACTIONS(7925),
    [anon_sym_if] = ACTIONS(7925),
    [anon_sym_unless] = ACTIONS(7925),
    [anon_sym_while] = ACTIONS(7925),
    [anon_sym_until] = ACTIONS(7925),
    [anon_sym_rescue] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7925),
    [anon_sym_AMP_AMP] = ACTIONS(7925),
    [anon_sym_LT_LT] = ACTIONS(7925),
    [anon_sym_GT_GT] = ACTIONS(7925),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7925),
    [anon_sym_PLUS] = ACTIONS(7925),
    [anon_sym_SLASH] = ACTIONS(7925),
    [anon_sym_PERCENT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [8257] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(9063),
    [sym__binary_star] = ACTIONS(9065),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(9067),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(9065),
    [anon_sym_AMP] = ACTIONS(9069),
    [anon_sym_LT] = ACTIONS(9071),
    [anon_sym_end] = ACTIONS(5115),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_EQ_GT] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(9073),
    [anon_sym_DOT_DOT] = ACTIONS(9075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9077),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(9079),
    [anon_sym_AMP_AMP] = ACTIONS(9079),
    [anon_sym_LT_LT] = ACTIONS(9081),
    [anon_sym_GT_GT] = ACTIONS(9081),
    [anon_sym_EQ_EQ] = ACTIONS(9083),
    [anon_sym_BANG_EQ] = ACTIONS(9079),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9079),
    [anon_sym_LT_EQ_GT] = ACTIONS(9079),
    [anon_sym_EQ_TILDE] = ACTIONS(9079),
    [anon_sym_BANG_TILDE] = ACTIONS(9079),
    [anon_sym_LT_EQ] = ACTIONS(9071),
    [anon_sym_GT] = ACTIONS(9071),
    [anon_sym_GT_EQ] = ACTIONS(9085),
    [anon_sym_CARET] = ACTIONS(9087),
    [anon_sym_PLUS] = ACTIONS(9063),
    [anon_sym_SLASH] = ACTIONS(9065),
    [anon_sym_PERCENT] = ACTIONS(9065),
    [sym_comment] = ACTIONS(87),
  },
  [8258] = {
    [aux_sym_exceptions_repeat1] = STATE(9828),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_end] = ACTIONS(6191),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [8259] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(9063),
    [sym__binary_star] = ACTIONS(9065),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(9067),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(9065),
    [anon_sym_AMP] = ACTIONS(9069),
    [anon_sym_LT] = ACTIONS(9071),
    [anon_sym_end] = ACTIONS(6210),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_EQ_GT] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(9073),
    [anon_sym_DOT_DOT] = ACTIONS(9075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9077),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(9079),
    [anon_sym_AMP_AMP] = ACTIONS(9079),
    [anon_sym_LT_LT] = ACTIONS(9081),
    [anon_sym_GT_GT] = ACTIONS(9081),
    [anon_sym_EQ_EQ] = ACTIONS(9083),
    [anon_sym_BANG_EQ] = ACTIONS(9079),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9079),
    [anon_sym_LT_EQ_GT] = ACTIONS(9079),
    [anon_sym_EQ_TILDE] = ACTIONS(9079),
    [anon_sym_BANG_TILDE] = ACTIONS(9079),
    [anon_sym_LT_EQ] = ACTIONS(9071),
    [anon_sym_GT] = ACTIONS(9071),
    [anon_sym_GT_EQ] = ACTIONS(9085),
    [anon_sym_CARET] = ACTIONS(9087),
    [anon_sym_PLUS] = ACTIONS(9063),
    [anon_sym_SLASH] = ACTIONS(9065),
    [anon_sym_PERCENT] = ACTIONS(9065),
    [sym_comment] = ACTIONS(87),
  },
  [8260] = {
    [sym_string] = STATE(8260),
    [aux_sym_chained_string_repeat1] = STATE(8260),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(6214),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_end] = ACTIONS(6212),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_EQ_GT] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [8261] = {
    [aux_sym_undef_repeat1] = STATE(8261),
    [sym__line_break] = ACTIONS(9263),
    [sym__heredoc_body_start] = ACTIONS(9263),
    [anon_sym_COMMA] = ACTIONS(9265),
    [anon_sym_SEMI] = ACTIONS(9263),
    [anon_sym_end] = ACTIONS(9263),
    [anon_sym_if] = ACTIONS(9263),
    [anon_sym_unless] = ACTIONS(9263),
    [anon_sym_while] = ACTIONS(9263),
    [anon_sym_until] = ACTIONS(9263),
    [anon_sym_rescue] = ACTIONS(9263),
    [sym_comment] = ACTIONS(87),
  },
  [8262] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9829),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(9829),
    [sym_operator_assignment] = STATE(9829),
    [sym_conditional] = STATE(9829),
    [sym_range] = STATE(9829),
    [sym_binary] = STATE(9829),
    [sym_unary] = STATE(9829),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8263] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(11782),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [8264] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(11776),
    [sym__binary_star] = ACTIONS(11778),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(11780),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(11782),
    [anon_sym_AMP] = ACTIONS(11784),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(11786),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(11788),
    [anon_sym_DOT_DOT] = ACTIONS(11790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11792),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(11794),
    [anon_sym_AMP_AMP] = ACTIONS(11794),
    [anon_sym_LT_LT] = ACTIONS(11796),
    [anon_sym_GT_GT] = ACTIONS(11796),
    [anon_sym_EQ_EQ] = ACTIONS(11794),
    [anon_sym_BANG_EQ] = ACTIONS(11798),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11798),
    [anon_sym_LT_EQ_GT] = ACTIONS(11798),
    [anon_sym_EQ_TILDE] = ACTIONS(11798),
    [anon_sym_BANG_TILDE] = ACTIONS(11798),
    [anon_sym_LT_EQ] = ACTIONS(11786),
    [anon_sym_GT] = ACTIONS(11786),
    [anon_sym_GT_EQ] = ACTIONS(11800),
    [anon_sym_CARET] = ACTIONS(11780),
    [anon_sym_PLUS] = ACTIONS(11802),
    [anon_sym_SLASH] = ACTIONS(11782),
    [anon_sym_PERCENT] = ACTIONS(11782),
    [sym_comment] = ACTIONS(87),
  },
  [8265] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(9830),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(5858),
    [sym_scope_resolution] = STATE(5856),
    [sym_call] = STATE(5856),
    [sym_method_call] = STATE(5858),
    [sym_assignment] = STATE(9830),
    [sym_operator_assignment] = STATE(9830),
    [sym_conditional] = STATE(9830),
    [sym_range] = STATE(9830),
    [sym_binary] = STATE(9830),
    [sym_unary] = STATE(9830),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5858),
    [sym__variable] = STATE(5856),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(5858),
    [sym_false] = STATE(5858),
    [sym_nil] = STATE(5858),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(5859),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(9107),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(9109),
    [anon_sym_yield] = ACTIONS(9111),
    [anon_sym_break] = ACTIONS(9113),
    [anon_sym_next] = ACTIONS(9115),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(9117),
    [anon_sym_defined_QMARK] = ACTIONS(9119),
    [anon_sym_not] = ACTIONS(9121),
    [anon_sym_BANG] = ACTIONS(9123),
    [anon_sym_TILDE] = ACTIONS(9123),
    [sym_constant] = ACTIONS(9125),
    [sym_identifier] = ACTIONS(9125),
    [sym_instance_variable] = ACTIONS(9127),
    [sym_class_variable] = ACTIONS(9127),
    [sym_global_variable] = ACTIONS(9127),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(9125),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9125),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [8266] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(9831),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(5858),
    [sym_scope_resolution] = STATE(5856),
    [sym_call] = STATE(5856),
    [sym_method_call] = STATE(5858),
    [sym_assignment] = STATE(9831),
    [sym_operator_assignment] = STATE(9831),
    [sym_conditional] = STATE(9831),
    [sym_range] = STATE(9831),
    [sym_binary] = STATE(9831),
    [sym_unary] = STATE(9831),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5858),
    [sym__variable] = STATE(5856),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(5858),
    [sym_false] = STATE(5858),
    [sym_nil] = STATE(5858),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(5859),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(9107),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(9109),
    [anon_sym_yield] = ACTIONS(9111),
    [anon_sym_break] = ACTIONS(9113),
    [anon_sym_next] = ACTIONS(9115),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(9117),
    [anon_sym_defined_QMARK] = ACTIONS(9119),
    [anon_sym_not] = ACTIONS(9121),
    [anon_sym_BANG] = ACTIONS(9123),
    [anon_sym_TILDE] = ACTIONS(9123),
    [sym_constant] = ACTIONS(9125),
    [sym_identifier] = ACTIONS(9125),
    [sym_instance_variable] = ACTIONS(9127),
    [sym_class_variable] = ACTIONS(9127),
    [sym_global_variable] = ACTIONS(9127),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(9125),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9125),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [8267] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(9832),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(5858),
    [sym_scope_resolution] = STATE(5856),
    [sym_call] = STATE(5856),
    [sym_method_call] = STATE(5858),
    [sym_assignment] = STATE(9832),
    [sym_operator_assignment] = STATE(9832),
    [sym_conditional] = STATE(9832),
    [sym_range] = STATE(9832),
    [sym_binary] = STATE(9832),
    [sym_unary] = STATE(9832),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5858),
    [sym__variable] = STATE(5856),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(5858),
    [sym_false] = STATE(5858),
    [sym_nil] = STATE(5858),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(5859),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(9107),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(9109),
    [anon_sym_yield] = ACTIONS(9111),
    [anon_sym_break] = ACTIONS(9113),
    [anon_sym_next] = ACTIONS(9115),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(9117),
    [anon_sym_defined_QMARK] = ACTIONS(9119),
    [anon_sym_not] = ACTIONS(9121),
    [anon_sym_BANG] = ACTIONS(9123),
    [anon_sym_TILDE] = ACTIONS(9123),
    [sym_constant] = ACTIONS(9125),
    [sym_identifier] = ACTIONS(9125),
    [sym_instance_variable] = ACTIONS(9127),
    [sym_class_variable] = ACTIONS(9127),
    [sym_global_variable] = ACTIONS(9127),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(9125),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9125),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [8268] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(9833),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(5858),
    [sym_scope_resolution] = STATE(5856),
    [sym_call] = STATE(5856),
    [sym_method_call] = STATE(5858),
    [sym_assignment] = STATE(9833),
    [sym_operator_assignment] = STATE(9833),
    [sym_conditional] = STATE(9833),
    [sym_range] = STATE(9833),
    [sym_binary] = STATE(9833),
    [sym_unary] = STATE(9833),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5858),
    [sym__variable] = STATE(5856),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(5858),
    [sym_false] = STATE(5858),
    [sym_nil] = STATE(5858),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(5859),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(9107),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(9109),
    [anon_sym_yield] = ACTIONS(9111),
    [anon_sym_break] = ACTIONS(9113),
    [anon_sym_next] = ACTIONS(9115),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(9117),
    [anon_sym_defined_QMARK] = ACTIONS(9119),
    [anon_sym_not] = ACTIONS(9121),
    [anon_sym_BANG] = ACTIONS(9123),
    [anon_sym_TILDE] = ACTIONS(9123),
    [sym_constant] = ACTIONS(9125),
    [sym_identifier] = ACTIONS(9125),
    [sym_instance_variable] = ACTIONS(9127),
    [sym_class_variable] = ACTIONS(9127),
    [sym_global_variable] = ACTIONS(9127),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(9125),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9125),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [8269] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(9834),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(5858),
    [sym_scope_resolution] = STATE(5856),
    [sym_call] = STATE(5856),
    [sym_method_call] = STATE(5858),
    [sym_assignment] = STATE(9834),
    [sym_operator_assignment] = STATE(9834),
    [sym_conditional] = STATE(9834),
    [sym_range] = STATE(9834),
    [sym_binary] = STATE(9834),
    [sym_unary] = STATE(9834),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5858),
    [sym__variable] = STATE(5856),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(5858),
    [sym_false] = STATE(5858),
    [sym_nil] = STATE(5858),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(5859),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(9107),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(9109),
    [anon_sym_yield] = ACTIONS(9111),
    [anon_sym_break] = ACTIONS(9113),
    [anon_sym_next] = ACTIONS(9115),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(9117),
    [anon_sym_defined_QMARK] = ACTIONS(9119),
    [anon_sym_not] = ACTIONS(9121),
    [anon_sym_BANG] = ACTIONS(9123),
    [anon_sym_TILDE] = ACTIONS(9123),
    [sym_constant] = ACTIONS(9125),
    [sym_identifier] = ACTIONS(9125),
    [sym_instance_variable] = ACTIONS(9127),
    [sym_class_variable] = ACTIONS(9127),
    [sym_global_variable] = ACTIONS(9127),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(9125),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9125),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [8270] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(9835),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(9835),
    [sym_operator_assignment] = STATE(9835),
    [sym_conditional] = STATE(9835),
    [sym_range] = STATE(9835),
    [sym_binary] = STATE(9835),
    [sym_unary] = STATE(9835),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8271] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(9836),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(5858),
    [sym_scope_resolution] = STATE(5856),
    [sym_call] = STATE(5856),
    [sym_method_call] = STATE(5858),
    [sym_assignment] = STATE(9836),
    [sym_operator_assignment] = STATE(9836),
    [sym_conditional] = STATE(9836),
    [sym_range] = STATE(9836),
    [sym_binary] = STATE(9836),
    [sym_unary] = STATE(9836),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5858),
    [sym__variable] = STATE(5856),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(5858),
    [sym_false] = STATE(5858),
    [sym_nil] = STATE(5858),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(5859),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(9107),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(9109),
    [anon_sym_yield] = ACTIONS(9111),
    [anon_sym_break] = ACTIONS(9113),
    [anon_sym_next] = ACTIONS(9115),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(9117),
    [anon_sym_defined_QMARK] = ACTIONS(9119),
    [anon_sym_not] = ACTIONS(9121),
    [anon_sym_BANG] = ACTIONS(9123),
    [anon_sym_TILDE] = ACTIONS(9123),
    [sym_constant] = ACTIONS(9125),
    [sym_identifier] = ACTIONS(9125),
    [sym_instance_variable] = ACTIONS(9127),
    [sym_class_variable] = ACTIONS(9127),
    [sym_global_variable] = ACTIONS(9127),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(9125),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9125),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [8272] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(9837),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(5858),
    [sym_scope_resolution] = STATE(5856),
    [sym_call] = STATE(5856),
    [sym_method_call] = STATE(5858),
    [sym_assignment] = STATE(9837),
    [sym_operator_assignment] = STATE(9837),
    [sym_conditional] = STATE(9837),
    [sym_range] = STATE(9837),
    [sym_binary] = STATE(9837),
    [sym_unary] = STATE(9837),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5858),
    [sym__variable] = STATE(5856),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(5858),
    [sym_false] = STATE(5858),
    [sym_nil] = STATE(5858),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(5859),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(9107),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(9109),
    [anon_sym_yield] = ACTIONS(9111),
    [anon_sym_break] = ACTIONS(9113),
    [anon_sym_next] = ACTIONS(9115),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(9117),
    [anon_sym_defined_QMARK] = ACTIONS(9119),
    [anon_sym_not] = ACTIONS(9121),
    [anon_sym_BANG] = ACTIONS(9123),
    [anon_sym_TILDE] = ACTIONS(9123),
    [sym_constant] = ACTIONS(9125),
    [sym_identifier] = ACTIONS(9125),
    [sym_instance_variable] = ACTIONS(9127),
    [sym_class_variable] = ACTIONS(9127),
    [sym_global_variable] = ACTIONS(9127),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(9125),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9125),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [8273] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(9838),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(5858),
    [sym_scope_resolution] = STATE(5856),
    [sym_call] = STATE(5856),
    [sym_method_call] = STATE(5858),
    [sym_assignment] = STATE(9838),
    [sym_operator_assignment] = STATE(9838),
    [sym_conditional] = STATE(9838),
    [sym_range] = STATE(9838),
    [sym_binary] = STATE(9838),
    [sym_unary] = STATE(9838),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5858),
    [sym__variable] = STATE(5856),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(5858),
    [sym_false] = STATE(5858),
    [sym_nil] = STATE(5858),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(5859),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(9107),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(9109),
    [anon_sym_yield] = ACTIONS(9111),
    [anon_sym_break] = ACTIONS(9113),
    [anon_sym_next] = ACTIONS(9115),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(9117),
    [anon_sym_defined_QMARK] = ACTIONS(9119),
    [anon_sym_not] = ACTIONS(9121),
    [anon_sym_BANG] = ACTIONS(9123),
    [anon_sym_TILDE] = ACTIONS(9123),
    [sym_constant] = ACTIONS(9125),
    [sym_identifier] = ACTIONS(9125),
    [sym_instance_variable] = ACTIONS(9127),
    [sym_class_variable] = ACTIONS(9127),
    [sym_global_variable] = ACTIONS(9127),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(9125),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9125),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [8274] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(9839),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(5858),
    [sym_scope_resolution] = STATE(5856),
    [sym_call] = STATE(5856),
    [sym_method_call] = STATE(5858),
    [sym_assignment] = STATE(9839),
    [sym_operator_assignment] = STATE(9839),
    [sym_conditional] = STATE(9839),
    [sym_range] = STATE(9839),
    [sym_binary] = STATE(9839),
    [sym_unary] = STATE(9839),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5858),
    [sym__variable] = STATE(5856),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(5858),
    [sym_false] = STATE(5858),
    [sym_nil] = STATE(5858),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(5859),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(9107),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(9109),
    [anon_sym_yield] = ACTIONS(9111),
    [anon_sym_break] = ACTIONS(9113),
    [anon_sym_next] = ACTIONS(9115),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(9117),
    [anon_sym_defined_QMARK] = ACTIONS(9119),
    [anon_sym_not] = ACTIONS(9121),
    [anon_sym_BANG] = ACTIONS(9123),
    [anon_sym_TILDE] = ACTIONS(9123),
    [sym_constant] = ACTIONS(9125),
    [sym_identifier] = ACTIONS(9125),
    [sym_instance_variable] = ACTIONS(9127),
    [sym_class_variable] = ACTIONS(9127),
    [sym_global_variable] = ACTIONS(9127),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(9125),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9125),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [8275] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(9840),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(5858),
    [sym_scope_resolution] = STATE(5856),
    [sym_call] = STATE(5856),
    [sym_method_call] = STATE(5858),
    [sym_splat_argument] = STATE(9841),
    [sym_assignment] = STATE(9840),
    [sym_operator_assignment] = STATE(9840),
    [sym_conditional] = STATE(9840),
    [sym_range] = STATE(9840),
    [sym_binary] = STATE(9840),
    [sym_unary] = STATE(9840),
    [sym_right_assignment_list] = STATE(6323),
    [sym__arg_or_splat_arg] = STATE(9841),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5858),
    [sym__variable] = STATE(5856),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(5858),
    [sym_false] = STATE(5858),
    [sym_nil] = STATE(5858),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(5859),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__splat_star] = ACTIONS(5373),
    [sym__unary_minus] = ACTIONS(9107),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(9109),
    [anon_sym_yield] = ACTIONS(9111),
    [anon_sym_break] = ACTIONS(9113),
    [anon_sym_next] = ACTIONS(9115),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(9117),
    [anon_sym_defined_QMARK] = ACTIONS(9119),
    [anon_sym_not] = ACTIONS(9121),
    [anon_sym_BANG] = ACTIONS(9123),
    [anon_sym_TILDE] = ACTIONS(9123),
    [sym_constant] = ACTIONS(9125),
    [sym_identifier] = ACTIONS(9125),
    [sym_instance_variable] = ACTIONS(9127),
    [sym_class_variable] = ACTIONS(9127),
    [sym_global_variable] = ACTIONS(9127),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(9125),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9125),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [8276] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(9842),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(5858),
    [sym_scope_resolution] = STATE(5856),
    [sym_call] = STATE(5856),
    [sym_method_call] = STATE(5858),
    [sym_assignment] = STATE(9842),
    [sym_operator_assignment] = STATE(9842),
    [sym_conditional] = STATE(9842),
    [sym_range] = STATE(9842),
    [sym_binary] = STATE(9842),
    [sym_unary] = STATE(9842),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5858),
    [sym__variable] = STATE(5856),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(5858),
    [sym_false] = STATE(5858),
    [sym_nil] = STATE(5858),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(5859),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(9107),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(9109),
    [anon_sym_yield] = ACTIONS(9111),
    [anon_sym_break] = ACTIONS(9113),
    [anon_sym_next] = ACTIONS(9115),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(9117),
    [anon_sym_defined_QMARK] = ACTIONS(9119),
    [anon_sym_not] = ACTIONS(9121),
    [anon_sym_BANG] = ACTIONS(9123),
    [anon_sym_TILDE] = ACTIONS(9123),
    [sym_constant] = ACTIONS(9125),
    [sym_identifier] = ACTIONS(9125),
    [sym_instance_variable] = ACTIONS(9127),
    [sym_class_variable] = ACTIONS(9127),
    [sym_global_variable] = ACTIONS(9127),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(9125),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9125),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [8277] = {
    [sym_string] = STATE(9843),
    [aux_sym_chained_string_repeat1] = STATE(9843),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(2551),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2755),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_EQ] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_end] = ACTIONS(2753),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_PLUS_EQ] = ACTIONS(2753),
    [anon_sym_DASH_EQ] = ACTIONS(2753),
    [anon_sym_STAR_EQ] = ACTIONS(2753),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2753),
    [anon_sym_SLASH_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2753),
    [anon_sym_AMP_EQ] = ACTIONS(2753),
    [anon_sym_PERCENT_EQ] = ACTIONS(2753),
    [anon_sym_GT_GT_EQ] = ACTIONS(2753),
    [anon_sym_LT_LT_EQ] = ACTIONS(2753),
    [anon_sym_CARET_EQ] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2755),
    [anon_sym_AMP_AMP] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2755),
    [anon_sym_GT_GT] = ACTIONS(2755),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_SLASH] = ACTIONS(2755),
    [anon_sym_PERCENT] = ACTIONS(2755),
    [sym_comment] = ACTIONS(87),
  },
  [8278] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(11776),
    [sym__binary_star] = ACTIONS(11778),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(11780),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(11782),
    [anon_sym_AMP] = ACTIONS(11784),
    [anon_sym_EQ] = ACTIONS(7822),
    [anon_sym_LT] = ACTIONS(11786),
    [anon_sym_end] = ACTIONS(6823),
    [anon_sym_if] = ACTIONS(6823),
    [anon_sym_unless] = ACTIONS(6823),
    [anon_sym_while] = ACTIONS(6823),
    [anon_sym_until] = ACTIONS(6823),
    [anon_sym_rescue] = ACTIONS(6823),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_PLUS_EQ] = ACTIONS(6823),
    [anon_sym_DASH_EQ] = ACTIONS(6823),
    [anon_sym_STAR_EQ] = ACTIONS(6823),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6823),
    [anon_sym_SLASH_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6823),
    [anon_sym_AMP_EQ] = ACTIONS(6823),
    [anon_sym_PERCENT_EQ] = ACTIONS(6823),
    [anon_sym_GT_GT_EQ] = ACTIONS(6823),
    [anon_sym_LT_LT_EQ] = ACTIONS(6823),
    [anon_sym_CARET_EQ] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(11788),
    [anon_sym_DOT_DOT] = ACTIONS(11790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11792),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(11794),
    [anon_sym_AMP_AMP] = ACTIONS(11794),
    [anon_sym_LT_LT] = ACTIONS(11796),
    [anon_sym_GT_GT] = ACTIONS(11796),
    [anon_sym_EQ_EQ] = ACTIONS(11794),
    [anon_sym_BANG_EQ] = ACTIONS(11798),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11798),
    [anon_sym_LT_EQ_GT] = ACTIONS(11798),
    [anon_sym_EQ_TILDE] = ACTIONS(11798),
    [anon_sym_BANG_TILDE] = ACTIONS(11798),
    [anon_sym_LT_EQ] = ACTIONS(11786),
    [anon_sym_GT] = ACTIONS(11786),
    [anon_sym_GT_EQ] = ACTIONS(11800),
    [anon_sym_CARET] = ACTIONS(11780),
    [anon_sym_PLUS] = ACTIONS(11802),
    [anon_sym_SLASH] = ACTIONS(11782),
    [anon_sym_PERCENT] = ACTIONS(11782),
    [sym_comment] = ACTIONS(87),
  },
  [8279] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(11776),
    [sym__binary_star] = ACTIONS(11778),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(11780),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(11782),
    [anon_sym_AMP] = ACTIONS(11784),
    [anon_sym_EQ] = ACTIONS(7884),
    [anon_sym_LT] = ACTIONS(11786),
    [anon_sym_end] = ACTIONS(7027),
    [anon_sym_if] = ACTIONS(7027),
    [anon_sym_unless] = ACTIONS(7027),
    [anon_sym_while] = ACTIONS(7027),
    [anon_sym_until] = ACTIONS(7027),
    [anon_sym_rescue] = ACTIONS(7027),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_PLUS_EQ] = ACTIONS(7027),
    [anon_sym_DASH_EQ] = ACTIONS(7027),
    [anon_sym_STAR_EQ] = ACTIONS(7027),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7027),
    [anon_sym_SLASH_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7027),
    [anon_sym_AMP_EQ] = ACTIONS(7027),
    [anon_sym_PERCENT_EQ] = ACTIONS(7027),
    [anon_sym_GT_GT_EQ] = ACTIONS(7027),
    [anon_sym_LT_LT_EQ] = ACTIONS(7027),
    [anon_sym_CARET_EQ] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(11788),
    [anon_sym_DOT_DOT] = ACTIONS(11790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11792),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(11794),
    [anon_sym_AMP_AMP] = ACTIONS(11794),
    [anon_sym_LT_LT] = ACTIONS(11796),
    [anon_sym_GT_GT] = ACTIONS(11796),
    [anon_sym_EQ_EQ] = ACTIONS(11794),
    [anon_sym_BANG_EQ] = ACTIONS(11798),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11798),
    [anon_sym_LT_EQ_GT] = ACTIONS(11798),
    [anon_sym_EQ_TILDE] = ACTIONS(11798),
    [anon_sym_BANG_TILDE] = ACTIONS(11798),
    [anon_sym_LT_EQ] = ACTIONS(11786),
    [anon_sym_GT] = ACTIONS(11786),
    [anon_sym_GT_EQ] = ACTIONS(11800),
    [anon_sym_CARET] = ACTIONS(11780),
    [anon_sym_PLUS] = ACTIONS(11802),
    [anon_sym_SLASH] = ACTIONS(11782),
    [anon_sym_PERCENT] = ACTIONS(11782),
    [sym_comment] = ACTIONS(87),
  },
  [8280] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(9137),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(9141),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(9141),
    [anon_sym_PERCENT] = ACTIONS(9141),
    [sym_comment] = ACTIONS(87),
  },
  [8281] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(9141),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(5827),
    [anon_sym_PERCENT] = ACTIONS(5827),
    [sym_comment] = ACTIONS(87),
  },
  [8282] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(9135),
    [sym__binary_star] = ACTIONS(9137),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(9141),
    [anon_sym_AMP] = ACTIONS(9143),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(9155),
    [anon_sym_GT_GT] = ACTIONS(9155),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(9161),
    [anon_sym_SLASH] = ACTIONS(9141),
    [anon_sym_PERCENT] = ACTIONS(9141),
    [sym_comment] = ACTIONS(87),
  },
  [8283] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(9135),
    [sym__binary_star] = ACTIONS(9137),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(9141),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(9155),
    [anon_sym_GT_GT] = ACTIONS(9155),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(9161),
    [anon_sym_SLASH] = ACTIONS(9141),
    [anon_sym_PERCENT] = ACTIONS(9141),
    [sym_comment] = ACTIONS(87),
  },
  [8284] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(9135),
    [sym__binary_star] = ACTIONS(9137),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(9139),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(9141),
    [anon_sym_AMP] = ACTIONS(9143),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(9155),
    [anon_sym_GT_GT] = ACTIONS(9155),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(9139),
    [anon_sym_PLUS] = ACTIONS(9161),
    [anon_sym_SLASH] = ACTIONS(9141),
    [anon_sym_PERCENT] = ACTIONS(9141),
    [sym_comment] = ACTIONS(87),
  },
  [8285] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(13542),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [8286] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(9135),
    [sym__binary_star] = ACTIONS(9137),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(9139),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(9141),
    [anon_sym_AMP] = ACTIONS(9143),
    [anon_sym_EQ] = ACTIONS(7888),
    [anon_sym_LT] = ACTIONS(9145),
    [anon_sym_end] = ACTIONS(5927),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_EQ_GT] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_PLUS_EQ] = ACTIONS(5927),
    [anon_sym_DASH_EQ] = ACTIONS(5927),
    [anon_sym_STAR_EQ] = ACTIONS(5927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5927),
    [anon_sym_SLASH_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5927),
    [anon_sym_AMP_EQ] = ACTIONS(5927),
    [anon_sym_PERCENT_EQ] = ACTIONS(5927),
    [anon_sym_GT_GT_EQ] = ACTIONS(5927),
    [anon_sym_LT_LT_EQ] = ACTIONS(5927),
    [anon_sym_CARET_EQ] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(9149),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9151),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(9153),
    [anon_sym_AMP_AMP] = ACTIONS(9153),
    [anon_sym_LT_LT] = ACTIONS(9155),
    [anon_sym_GT_GT] = ACTIONS(9155),
    [anon_sym_EQ_EQ] = ACTIONS(9153),
    [anon_sym_BANG_EQ] = ACTIONS(9157),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9157),
    [anon_sym_LT_EQ_GT] = ACTIONS(9157),
    [anon_sym_EQ_TILDE] = ACTIONS(9157),
    [anon_sym_BANG_TILDE] = ACTIONS(9157),
    [anon_sym_LT_EQ] = ACTIONS(9145),
    [anon_sym_GT] = ACTIONS(9145),
    [anon_sym_GT_EQ] = ACTIONS(9159),
    [anon_sym_CARET] = ACTIONS(9139),
    [anon_sym_PLUS] = ACTIONS(9161),
    [anon_sym_SLASH] = ACTIONS(9141),
    [anon_sym_PERCENT] = ACTIONS(9141),
    [sym_comment] = ACTIONS(87),
  },
  [8287] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(9135),
    [sym__binary_star] = ACTIONS(9137),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(9139),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(9141),
    [anon_sym_AMP] = ACTIONS(9143),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(9145),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(9147),
    [anon_sym_DOT_DOT] = ACTIONS(9149),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9151),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(9153),
    [anon_sym_AMP_AMP] = ACTIONS(9153),
    [anon_sym_LT_LT] = ACTIONS(9155),
    [anon_sym_GT_GT] = ACTIONS(9155),
    [anon_sym_EQ_EQ] = ACTIONS(9153),
    [anon_sym_BANG_EQ] = ACTIONS(9157),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9157),
    [anon_sym_LT_EQ_GT] = ACTIONS(9157),
    [anon_sym_EQ_TILDE] = ACTIONS(9157),
    [anon_sym_BANG_TILDE] = ACTIONS(9157),
    [anon_sym_LT_EQ] = ACTIONS(9145),
    [anon_sym_GT] = ACTIONS(9145),
    [anon_sym_GT_EQ] = ACTIONS(9159),
    [anon_sym_CARET] = ACTIONS(9139),
    [anon_sym_PLUS] = ACTIONS(9161),
    [anon_sym_SLASH] = ACTIONS(9141),
    [anon_sym_PERCENT] = ACTIONS(9141),
    [sym_comment] = ACTIONS(87),
  },
  [8288] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(9135),
    [sym__binary_star] = ACTIONS(9137),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(9139),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(9141),
    [anon_sym_AMP] = ACTIONS(9143),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(9145),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(9155),
    [anon_sym_GT_GT] = ACTIONS(9155),
    [anon_sym_EQ_EQ] = ACTIONS(9153),
    [anon_sym_BANG_EQ] = ACTIONS(9157),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9157),
    [anon_sym_LT_EQ_GT] = ACTIONS(9157),
    [anon_sym_EQ_TILDE] = ACTIONS(9157),
    [anon_sym_BANG_TILDE] = ACTIONS(9157),
    [anon_sym_LT_EQ] = ACTIONS(9145),
    [anon_sym_GT] = ACTIONS(9145),
    [anon_sym_GT_EQ] = ACTIONS(9159),
    [anon_sym_CARET] = ACTIONS(9139),
    [anon_sym_PLUS] = ACTIONS(9161),
    [anon_sym_SLASH] = ACTIONS(9141),
    [anon_sym_PERCENT] = ACTIONS(9141),
    [sym_comment] = ACTIONS(87),
  },
  [8289] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(9135),
    [sym__binary_star] = ACTIONS(9137),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(9141),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(9161),
    [anon_sym_SLASH] = ACTIONS(9141),
    [anon_sym_PERCENT] = ACTIONS(9141),
    [sym_comment] = ACTIONS(87),
  },
  [8290] = {
    [sym_heredoc_body] = STATE(8290),
    [aux_sym_call_repeat1] = STATE(8290),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(9846),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7919),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_EQ] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_end] = ACTIONS(7914),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_PLUS_EQ] = ACTIONS(7914),
    [anon_sym_DASH_EQ] = ACTIONS(7914),
    [anon_sym_STAR_EQ] = ACTIONS(7914),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7914),
    [anon_sym_SLASH_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7914),
    [anon_sym_AMP_EQ] = ACTIONS(7914),
    [anon_sym_PERCENT_EQ] = ACTIONS(7914),
    [anon_sym_GT_GT_EQ] = ACTIONS(7914),
    [anon_sym_LT_LT_EQ] = ACTIONS(7914),
    [anon_sym_CARET_EQ] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7919),
    [anon_sym_AMP_AMP] = ACTIONS(7919),
    [anon_sym_LT_LT] = ACTIONS(7919),
    [anon_sym_GT_GT] = ACTIONS(7919),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7919),
    [anon_sym_PLUS] = ACTIONS(7919),
    [anon_sym_SLASH] = ACTIONS(7919),
    [anon_sym_PERCENT] = ACTIONS(7919),
    [sym_comment] = ACTIONS(87),
  },
  [8291] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3215),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3220),
    [sym_scope_resolution] = STATE(3216),
    [sym_call] = STATE(3216),
    [sym_method_call] = STATE(3220),
    [sym__argument] = STATE(6393),
    [sym_splat_argument] = STATE(6393),
    [sym_hash_splat_argument] = STATE(6393),
    [sym_block_argument] = STATE(6393),
    [sym_assignment] = STATE(3215),
    [sym_operator_assignment] = STATE(3215),
    [sym_conditional] = STATE(3215),
    [sym_range] = STATE(3215),
    [sym_binary] = STATE(3215),
    [sym_unary] = STATE(3215),
    [sym_left_assignment_list] = STATE(3219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3220),
    [sym__variable] = STATE(3216),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3220),
    [sym_false] = STATE(3220),
    [sym_nil] = STATE(3220),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3221),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(6393),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(5371),
    [sym__splat_star] = ACTIONS(5373),
    [sym__unary_minus] = ACTIONS(5375),
    [sym__identifier_hash_key] = ACTIONS(5377),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11810),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5379),
    [anon_sym_yield] = ACTIONS(5381),
    [anon_sym_break] = ACTIONS(5383),
    [anon_sym_next] = ACTIONS(5385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(9129),
    [anon_sym_defined_QMARK] = ACTIONS(5387),
    [anon_sym_not] = ACTIONS(5389),
    [anon_sym_BANG] = ACTIONS(5393),
    [anon_sym_TILDE] = ACTIONS(5393),
    [sym_constant] = ACTIONS(5395),
    [sym_identifier] = ACTIONS(5395),
    [sym_instance_variable] = ACTIONS(5397),
    [sym_class_variable] = ACTIONS(5397),
    [sym_global_variable] = ACTIONS(5397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [8292] = {
    [sym_heredoc_body] = STATE(8290),
    [aux_sym_call_repeat1] = STATE(8290),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7931),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_EQ] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_end] = ACTIONS(7929),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_PLUS_EQ] = ACTIONS(7929),
    [anon_sym_DASH_EQ] = ACTIONS(7929),
    [anon_sym_STAR_EQ] = ACTIONS(7929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7929),
    [anon_sym_SLASH_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7929),
    [anon_sym_AMP_EQ] = ACTIONS(7929),
    [anon_sym_PERCENT_EQ] = ACTIONS(7929),
    [anon_sym_GT_GT_EQ] = ACTIONS(7929),
    [anon_sym_LT_LT_EQ] = ACTIONS(7929),
    [anon_sym_CARET_EQ] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7931),
    [anon_sym_AMP_AMP] = ACTIONS(7931),
    [anon_sym_LT_LT] = ACTIONS(7931),
    [anon_sym_GT_GT] = ACTIONS(7931),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7931),
    [anon_sym_PLUS] = ACTIONS(7931),
    [anon_sym_SLASH] = ACTIONS(7931),
    [anon_sym_PERCENT] = ACTIONS(7931),
    [sym_comment] = ACTIONS(87),
  },
  [8293] = {
    [aux_sym_argument_list_repeat1] = STATE(8293),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(13544),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7927),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_EQ] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_end] = ACTIONS(7925),
    [anon_sym_if] = ACTIONS(7925),
    [anon_sym_unless] = ACTIONS(7925),
    [anon_sym_while] = ACTIONS(7925),
    [anon_sym_until] = ACTIONS(7925),
    [anon_sym_rescue] = ACTIONS(7925),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_PLUS_EQ] = ACTIONS(7925),
    [anon_sym_DASH_EQ] = ACTIONS(7925),
    [anon_sym_STAR_EQ] = ACTIONS(7925),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7925),
    [anon_sym_SLASH_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7925),
    [anon_sym_AMP_EQ] = ACTIONS(7925),
    [anon_sym_PERCENT_EQ] = ACTIONS(7925),
    [anon_sym_GT_GT_EQ] = ACTIONS(7925),
    [anon_sym_LT_LT_EQ] = ACTIONS(7925),
    [anon_sym_CARET_EQ] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7927),
    [anon_sym_AMP_AMP] = ACTIONS(7927),
    [anon_sym_LT_LT] = ACTIONS(7927),
    [anon_sym_GT_GT] = ACTIONS(7927),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7927),
    [anon_sym_PLUS] = ACTIONS(7927),
    [anon_sym_SLASH] = ACTIONS(7927),
    [anon_sym_PERCENT] = ACTIONS(7927),
    [sym_comment] = ACTIONS(87),
  },
  [8294] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(9135),
    [sym__binary_star] = ACTIONS(9137),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(9139),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(9141),
    [anon_sym_AMP] = ACTIONS(9143),
    [anon_sym_EQ] = ACTIONS(7936),
    [anon_sym_LT] = ACTIONS(9145),
    [anon_sym_end] = ACTIONS(5115),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_EQ_GT] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_PLUS_EQ] = ACTIONS(5115),
    [anon_sym_DASH_EQ] = ACTIONS(5115),
    [anon_sym_STAR_EQ] = ACTIONS(5115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5115),
    [anon_sym_SLASH_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5115),
    [anon_sym_AMP_EQ] = ACTIONS(5115),
    [anon_sym_PERCENT_EQ] = ACTIONS(5115),
    [anon_sym_GT_GT_EQ] = ACTIONS(5115),
    [anon_sym_LT_LT_EQ] = ACTIONS(5115),
    [anon_sym_CARET_EQ] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(9147),
    [anon_sym_DOT_DOT] = ACTIONS(9149),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9151),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(9153),
    [anon_sym_AMP_AMP] = ACTIONS(9153),
    [anon_sym_LT_LT] = ACTIONS(9155),
    [anon_sym_GT_GT] = ACTIONS(9155),
    [anon_sym_EQ_EQ] = ACTIONS(9153),
    [anon_sym_BANG_EQ] = ACTIONS(9157),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9157),
    [anon_sym_LT_EQ_GT] = ACTIONS(9157),
    [anon_sym_EQ_TILDE] = ACTIONS(9157),
    [anon_sym_BANG_TILDE] = ACTIONS(9157),
    [anon_sym_LT_EQ] = ACTIONS(9145),
    [anon_sym_GT] = ACTIONS(9145),
    [anon_sym_GT_EQ] = ACTIONS(9159),
    [anon_sym_CARET] = ACTIONS(9139),
    [anon_sym_PLUS] = ACTIONS(9161),
    [anon_sym_SLASH] = ACTIONS(9141),
    [anon_sym_PERCENT] = ACTIONS(9141),
    [sym_comment] = ACTIONS(87),
  },
  [8295] = {
    [aux_sym_exceptions_repeat1] = STATE(9846),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6193),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_end] = ACTIONS(6191),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_PLUS_EQ] = ACTIONS(6191),
    [anon_sym_DASH_EQ] = ACTIONS(6191),
    [anon_sym_STAR_EQ] = ACTIONS(6191),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6191),
    [anon_sym_SLASH_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6191),
    [anon_sym_AMP_EQ] = ACTIONS(6191),
    [anon_sym_PERCENT_EQ] = ACTIONS(6191),
    [anon_sym_GT_GT_EQ] = ACTIONS(6191),
    [anon_sym_LT_LT_EQ] = ACTIONS(6191),
    [anon_sym_CARET_EQ] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6193),
    [anon_sym_AMP_AMP] = ACTIONS(6193),
    [anon_sym_LT_LT] = ACTIONS(6193),
    [anon_sym_GT_GT] = ACTIONS(6193),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6193),
    [anon_sym_PLUS] = ACTIONS(6193),
    [anon_sym_SLASH] = ACTIONS(6193),
    [anon_sym_PERCENT] = ACTIONS(6193),
    [sym_comment] = ACTIONS(87),
  },
  [8296] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(9135),
    [sym__binary_star] = ACTIONS(9137),
    [anon_sym_LBRACE] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(9139),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(9141),
    [anon_sym_AMP] = ACTIONS(9143),
    [anon_sym_EQ] = ACTIONS(7938),
    [anon_sym_LT] = ACTIONS(9145),
    [anon_sym_end] = ACTIONS(6210),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_EQ_GT] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_PLUS_EQ] = ACTIONS(6210),
    [anon_sym_DASH_EQ] = ACTIONS(6210),
    [anon_sym_STAR_EQ] = ACTIONS(6210),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6210),
    [anon_sym_SLASH_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6210),
    [anon_sym_AMP_EQ] = ACTIONS(6210),
    [anon_sym_PERCENT_EQ] = ACTIONS(6210),
    [anon_sym_GT_GT_EQ] = ACTIONS(6210),
    [anon_sym_LT_LT_EQ] = ACTIONS(6210),
    [anon_sym_CARET_EQ] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(9147),
    [anon_sym_DOT_DOT] = ACTIONS(9149),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9151),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(9153),
    [anon_sym_AMP_AMP] = ACTIONS(9153),
    [anon_sym_LT_LT] = ACTIONS(9155),
    [anon_sym_GT_GT] = ACTIONS(9155),
    [anon_sym_EQ_EQ] = ACTIONS(9153),
    [anon_sym_BANG_EQ] = ACTIONS(9157),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9157),
    [anon_sym_LT_EQ_GT] = ACTIONS(9157),
    [anon_sym_EQ_TILDE] = ACTIONS(9157),
    [anon_sym_BANG_TILDE] = ACTIONS(9157),
    [anon_sym_LT_EQ] = ACTIONS(9145),
    [anon_sym_GT] = ACTIONS(9145),
    [anon_sym_GT_EQ] = ACTIONS(9159),
    [anon_sym_CARET] = ACTIONS(9139),
    [anon_sym_PLUS] = ACTIONS(9161),
    [anon_sym_SLASH] = ACTIONS(9141),
    [anon_sym_PERCENT] = ACTIONS(9141),
    [sym_comment] = ACTIONS(87),
  },
  [8297] = {
    [sym_string] = STATE(8297),
    [aux_sym_chained_string_repeat1] = STATE(8297),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(9852),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6217),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_EQ] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_end] = ACTIONS(6212),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_do] = ACTIONS(6212),
    [anon_sym_EQ_GT] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_PLUS_EQ] = ACTIONS(6212),
    [anon_sym_DASH_EQ] = ACTIONS(6212),
    [anon_sym_STAR_EQ] = ACTIONS(6212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6212),
    [anon_sym_SLASH_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6212),
    [anon_sym_AMP_EQ] = ACTIONS(6212),
    [anon_sym_PERCENT_EQ] = ACTIONS(6212),
    [anon_sym_GT_GT_EQ] = ACTIONS(6212),
    [anon_sym_LT_LT_EQ] = ACTIONS(6212),
    [anon_sym_CARET_EQ] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6217),
    [anon_sym_AMP_AMP] = ACTIONS(6217),
    [anon_sym_LT_LT] = ACTIONS(6217),
    [anon_sym_GT_GT] = ACTIONS(6217),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6217),
    [anon_sym_PLUS] = ACTIONS(6217),
    [anon_sym_SLASH] = ACTIONS(6217),
    [anon_sym_PERCENT] = ACTIONS(6217),
    [sym_comment] = ACTIONS(87),
  },
  [8298] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(11812),
    [sym__binary_star] = ACTIONS(11814),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(11816),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(11814),
    [anon_sym_AMP] = ACTIONS(11818),
    [anon_sym_LT] = ACTIONS(11820),
    [anon_sym_end] = ACTIONS(4247),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(11822),
    [anon_sym_DOT_DOT] = ACTIONS(11824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11826),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(11828),
    [anon_sym_AMP_AMP] = ACTIONS(11828),
    [anon_sym_LT_LT] = ACTIONS(11830),
    [anon_sym_GT_GT] = ACTIONS(11830),
    [anon_sym_EQ_EQ] = ACTIONS(11832),
    [anon_sym_BANG_EQ] = ACTIONS(11828),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11828),
    [anon_sym_LT_EQ_GT] = ACTIONS(11828),
    [anon_sym_EQ_TILDE] = ACTIONS(11828),
    [anon_sym_BANG_TILDE] = ACTIONS(11828),
    [anon_sym_LT_EQ] = ACTIONS(11820),
    [anon_sym_GT] = ACTIONS(11820),
    [anon_sym_GT_EQ] = ACTIONS(11834),
    [anon_sym_CARET] = ACTIONS(11836),
    [anon_sym_PLUS] = ACTIONS(11812),
    [anon_sym_SLASH] = ACTIONS(11814),
    [anon_sym_PERCENT] = ACTIONS(11814),
    [sym_comment] = ACTIONS(87),
  },
  [8299] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(11814),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [8300] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(11812),
    [sym__binary_star] = ACTIONS(11814),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(11816),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(11814),
    [anon_sym_AMP] = ACTIONS(11818),
    [anon_sym_LT] = ACTIONS(11820),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(11822),
    [anon_sym_DOT_DOT] = ACTIONS(11824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11826),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(11828),
    [anon_sym_AMP_AMP] = ACTIONS(11828),
    [anon_sym_LT_LT] = ACTIONS(11830),
    [anon_sym_GT_GT] = ACTIONS(11830),
    [anon_sym_EQ_EQ] = ACTIONS(11832),
    [anon_sym_BANG_EQ] = ACTIONS(11828),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11828),
    [anon_sym_LT_EQ_GT] = ACTIONS(11828),
    [anon_sym_EQ_TILDE] = ACTIONS(11828),
    [anon_sym_BANG_TILDE] = ACTIONS(11828),
    [anon_sym_LT_EQ] = ACTIONS(11820),
    [anon_sym_GT] = ACTIONS(11820),
    [anon_sym_GT_EQ] = ACTIONS(11834),
    [anon_sym_CARET] = ACTIONS(11836),
    [anon_sym_PLUS] = ACTIONS(11812),
    [anon_sym_SLASH] = ACTIONS(11814),
    [anon_sym_PERCENT] = ACTIONS(11814),
    [sym_comment] = ACTIONS(87),
  },
  [8301] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9847),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5890),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(5890),
    [sym_assignment] = STATE(9847),
    [sym_operator_assignment] = STATE(9847),
    [sym_conditional] = STATE(9847),
    [sym_range] = STATE(9847),
    [sym_binary] = STATE(9847),
    [sym_unary] = STATE(9847),
    [sym_left_assignment_list] = STATE(5889),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5890),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5890),
    [sym_false] = STATE(5890),
    [sym_nil] = STATE(5890),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5790),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9175),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9033),
    [anon_sym_yield] = ACTIONS(9035),
    [anon_sym_break] = ACTIONS(9037),
    [anon_sym_next] = ACTIONS(9039),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9177),
    [anon_sym_defined_QMARK] = ACTIONS(9179),
    [anon_sym_not] = ACTIONS(9181),
    [anon_sym_BANG] = ACTIONS(9183),
    [anon_sym_TILDE] = ACTIONS(9183),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8302] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9848),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5890),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(5890),
    [sym_assignment] = STATE(9848),
    [sym_operator_assignment] = STATE(9848),
    [sym_conditional] = STATE(9848),
    [sym_range] = STATE(9848),
    [sym_binary] = STATE(9848),
    [sym_unary] = STATE(9848),
    [sym_left_assignment_list] = STATE(5889),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5890),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5890),
    [sym_false] = STATE(5890),
    [sym_nil] = STATE(5890),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5790),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9175),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9033),
    [anon_sym_yield] = ACTIONS(9035),
    [anon_sym_break] = ACTIONS(9037),
    [anon_sym_next] = ACTIONS(9039),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9177),
    [anon_sym_defined_QMARK] = ACTIONS(9179),
    [anon_sym_not] = ACTIONS(9181),
    [anon_sym_BANG] = ACTIONS(9183),
    [anon_sym_TILDE] = ACTIONS(9183),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8303] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9849),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5890),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(5890),
    [sym_assignment] = STATE(9849),
    [sym_operator_assignment] = STATE(9849),
    [sym_conditional] = STATE(9849),
    [sym_range] = STATE(9849),
    [sym_binary] = STATE(9849),
    [sym_unary] = STATE(9849),
    [sym_left_assignment_list] = STATE(5889),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5890),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5890),
    [sym_false] = STATE(5890),
    [sym_nil] = STATE(5890),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5790),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9175),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9033),
    [anon_sym_yield] = ACTIONS(9035),
    [anon_sym_break] = ACTIONS(9037),
    [anon_sym_next] = ACTIONS(9039),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9177),
    [anon_sym_defined_QMARK] = ACTIONS(9179),
    [anon_sym_not] = ACTIONS(9181),
    [anon_sym_BANG] = ACTIONS(9183),
    [anon_sym_TILDE] = ACTIONS(9183),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8304] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9850),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5890),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(5890),
    [sym_assignment] = STATE(9850),
    [sym_operator_assignment] = STATE(9850),
    [sym_conditional] = STATE(9850),
    [sym_range] = STATE(9850),
    [sym_binary] = STATE(9850),
    [sym_unary] = STATE(9850),
    [sym_left_assignment_list] = STATE(5889),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5890),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5890),
    [sym_false] = STATE(5890),
    [sym_nil] = STATE(5890),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5790),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9175),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9033),
    [anon_sym_yield] = ACTIONS(9035),
    [anon_sym_break] = ACTIONS(9037),
    [anon_sym_next] = ACTIONS(9039),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9177),
    [anon_sym_defined_QMARK] = ACTIONS(9179),
    [anon_sym_not] = ACTIONS(9181),
    [anon_sym_BANG] = ACTIONS(9183),
    [anon_sym_TILDE] = ACTIONS(9183),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8305] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9851),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5890),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(5890),
    [sym_assignment] = STATE(9851),
    [sym_operator_assignment] = STATE(9851),
    [sym_conditional] = STATE(9851),
    [sym_range] = STATE(9851),
    [sym_binary] = STATE(9851),
    [sym_unary] = STATE(9851),
    [sym_left_assignment_list] = STATE(5889),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5890),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5890),
    [sym_false] = STATE(5890),
    [sym_nil] = STATE(5890),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5790),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9175),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9033),
    [anon_sym_yield] = ACTIONS(9035),
    [anon_sym_break] = ACTIONS(9037),
    [anon_sym_next] = ACTIONS(9039),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9177),
    [anon_sym_defined_QMARK] = ACTIONS(9179),
    [anon_sym_not] = ACTIONS(9181),
    [anon_sym_BANG] = ACTIONS(9183),
    [anon_sym_TILDE] = ACTIONS(9183),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8306] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(9852),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(9852),
    [sym_operator_assignment] = STATE(9852),
    [sym_conditional] = STATE(9852),
    [sym_range] = STATE(9852),
    [sym_binary] = STATE(9852),
    [sym_unary] = STATE(9852),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8307] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9853),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5890),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(5890),
    [sym_assignment] = STATE(9853),
    [sym_operator_assignment] = STATE(9853),
    [sym_conditional] = STATE(9853),
    [sym_range] = STATE(9853),
    [sym_binary] = STATE(9853),
    [sym_unary] = STATE(9853),
    [sym_left_assignment_list] = STATE(5889),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5890),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5890),
    [sym_false] = STATE(5890),
    [sym_nil] = STATE(5890),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5790),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9175),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9033),
    [anon_sym_yield] = ACTIONS(9035),
    [anon_sym_break] = ACTIONS(9037),
    [anon_sym_next] = ACTIONS(9039),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9177),
    [anon_sym_defined_QMARK] = ACTIONS(9179),
    [anon_sym_not] = ACTIONS(9181),
    [anon_sym_BANG] = ACTIONS(9183),
    [anon_sym_TILDE] = ACTIONS(9183),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8308] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9854),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5890),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(5890),
    [sym_assignment] = STATE(9854),
    [sym_operator_assignment] = STATE(9854),
    [sym_conditional] = STATE(9854),
    [sym_range] = STATE(9854),
    [sym_binary] = STATE(9854),
    [sym_unary] = STATE(9854),
    [sym_left_assignment_list] = STATE(5889),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5890),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5890),
    [sym_false] = STATE(5890),
    [sym_nil] = STATE(5890),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5790),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9175),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9033),
    [anon_sym_yield] = ACTIONS(9035),
    [anon_sym_break] = ACTIONS(9037),
    [anon_sym_next] = ACTIONS(9039),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9177),
    [anon_sym_defined_QMARK] = ACTIONS(9179),
    [anon_sym_not] = ACTIONS(9181),
    [anon_sym_BANG] = ACTIONS(9183),
    [anon_sym_TILDE] = ACTIONS(9183),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8309] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9855),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5890),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(5890),
    [sym_assignment] = STATE(9855),
    [sym_operator_assignment] = STATE(9855),
    [sym_conditional] = STATE(9855),
    [sym_range] = STATE(9855),
    [sym_binary] = STATE(9855),
    [sym_unary] = STATE(9855),
    [sym_left_assignment_list] = STATE(5889),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5890),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5890),
    [sym_false] = STATE(5890),
    [sym_nil] = STATE(5890),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5790),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9175),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9033),
    [anon_sym_yield] = ACTIONS(9035),
    [anon_sym_break] = ACTIONS(9037),
    [anon_sym_next] = ACTIONS(9039),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9177),
    [anon_sym_defined_QMARK] = ACTIONS(9179),
    [anon_sym_not] = ACTIONS(9181),
    [anon_sym_BANG] = ACTIONS(9183),
    [anon_sym_TILDE] = ACTIONS(9183),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8310] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9856),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5890),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(5890),
    [sym_assignment] = STATE(9856),
    [sym_operator_assignment] = STATE(9856),
    [sym_conditional] = STATE(9856),
    [sym_range] = STATE(9856),
    [sym_binary] = STATE(9856),
    [sym_unary] = STATE(9856),
    [sym_left_assignment_list] = STATE(5889),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5890),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5890),
    [sym_false] = STATE(5890),
    [sym_nil] = STATE(5890),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5790),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9175),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9033),
    [anon_sym_yield] = ACTIONS(9035),
    [anon_sym_break] = ACTIONS(9037),
    [anon_sym_next] = ACTIONS(9039),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9177),
    [anon_sym_defined_QMARK] = ACTIONS(9179),
    [anon_sym_not] = ACTIONS(9181),
    [anon_sym_BANG] = ACTIONS(9183),
    [anon_sym_TILDE] = ACTIONS(9183),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8311] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5887),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5890),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(5890),
    [sym_splat_argument] = STATE(6406),
    [sym_assignment] = STATE(5887),
    [sym_operator_assignment] = STATE(5887),
    [sym_conditional] = STATE(5887),
    [sym_range] = STATE(5887),
    [sym_binary] = STATE(5887),
    [sym_unary] = STATE(5887),
    [sym__arg_or_splat_arg] = STATE(6406),
    [sym_left_assignment_list] = STATE(5889),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5890),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5890),
    [sym_false] = STATE(5890),
    [sym_nil] = STATE(5890),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5790),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(9173),
    [sym__unary_minus] = ACTIONS(9175),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9033),
    [anon_sym_yield] = ACTIONS(9035),
    [anon_sym_break] = ACTIONS(9037),
    [anon_sym_next] = ACTIONS(9039),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9177),
    [anon_sym_defined_QMARK] = ACTIONS(9179),
    [anon_sym_not] = ACTIONS(9181),
    [anon_sym_BANG] = ACTIONS(9183),
    [anon_sym_TILDE] = ACTIONS(9183),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8312] = {
    [aux_sym_exceptions_repeat1] = STATE(9857),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_COMMA] = ACTIONS(11838),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_end] = ACTIONS(9855),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [8313] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(5887),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5890),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(5890),
    [sym_splat_argument] = STATE(9858),
    [sym_assignment] = STATE(5887),
    [sym_operator_assignment] = STATE(5887),
    [sym_conditional] = STATE(5887),
    [sym_range] = STATE(5887),
    [sym_binary] = STATE(5887),
    [sym_unary] = STATE(5887),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(9858),
    [sym_left_assignment_list] = STATE(5889),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5890),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5890),
    [sym_false] = STATE(5890),
    [sym_nil] = STATE(5890),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5790),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(9173),
    [sym__unary_minus] = ACTIONS(9175),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9033),
    [anon_sym_yield] = ACTIONS(9035),
    [anon_sym_break] = ACTIONS(9037),
    [anon_sym_next] = ACTIONS(9039),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9177),
    [anon_sym_defined_QMARK] = ACTIONS(9179),
    [anon_sym_not] = ACTIONS(9181),
    [anon_sym_BANG] = ACTIONS(9183),
    [anon_sym_TILDE] = ACTIONS(9183),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8314] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9859),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5890),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(5890),
    [sym_assignment] = STATE(9859),
    [sym_operator_assignment] = STATE(9859),
    [sym_conditional] = STATE(9859),
    [sym_range] = STATE(9859),
    [sym_binary] = STATE(9859),
    [sym_unary] = STATE(9859),
    [sym_left_assignment_list] = STATE(5889),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5890),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5890),
    [sym_false] = STATE(5890),
    [sym_nil] = STATE(5890),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5790),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9175),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9033),
    [anon_sym_yield] = ACTIONS(9035),
    [anon_sym_break] = ACTIONS(9037),
    [anon_sym_next] = ACTIONS(9039),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9177),
    [anon_sym_defined_QMARK] = ACTIONS(9179),
    [anon_sym_not] = ACTIONS(9181),
    [anon_sym_BANG] = ACTIONS(9183),
    [anon_sym_TILDE] = ACTIONS(9183),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8315] = {
    [sym__line_break] = ACTIONS(13547),
    [sym__heredoc_body_start] = ACTIONS(13547),
    [sym__binary_minus] = ACTIONS(13547),
    [sym__binary_star] = ACTIONS(13547),
    [ts_builtin_sym_end] = ACTIONS(13547),
    [anon_sym___END__] = ACTIONS(13547),
    [anon_sym_LBRACE] = ACTIONS(13547),
    [anon_sym_RBRACE] = ACTIONS(13547),
    [anon_sym_RPAREN] = ACTIONS(13547),
    [anon_sym_DOT] = ACTIONS(13549),
    [anon_sym_COMMA] = ACTIONS(13547),
    [anon_sym_PIPE] = ACTIONS(13549),
    [anon_sym_SEMI] = ACTIONS(13547),
    [anon_sym_STAR_STAR] = ACTIONS(13547),
    [anon_sym_AMP] = ACTIONS(13549),
    [anon_sym_LT] = ACTIONS(13549),
    [anon_sym_end] = ACTIONS(13547),
    [anon_sym_if] = ACTIONS(13547),
    [anon_sym_unless] = ACTIONS(13547),
    [anon_sym_while] = ACTIONS(13547),
    [anon_sym_until] = ACTIONS(13547),
    [anon_sym_rescue] = ACTIONS(13547),
    [anon_sym_do] = ACTIONS(13547),
    [anon_sym_when] = ACTIONS(13547),
    [anon_sym_elsif] = ACTIONS(13547),
    [anon_sym_else] = ACTIONS(13547),
    [anon_sym_then] = ACTIONS(13547),
    [anon_sym_ensure] = ACTIONS(13547),
    [anon_sym_EQ_GT] = ACTIONS(13547),
    [anon_sym_LBRACK] = ACTIONS(13547),
    [anon_sym_COLON_COLON2] = ACTIONS(13547),
    [anon_sym_AMP_DOT] = ACTIONS(13547),
    [anon_sym_QMARK] = ACTIONS(13547),
    [anon_sym_DOT_DOT] = ACTIONS(13549),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13547),
    [anon_sym_and] = ACTIONS(13547),
    [anon_sym_or] = ACTIONS(13547),
    [anon_sym_PIPE_PIPE] = ACTIONS(13547),
    [anon_sym_AMP_AMP] = ACTIONS(13547),
    [anon_sym_LT_LT] = ACTIONS(13547),
    [anon_sym_GT_GT] = ACTIONS(13547),
    [anon_sym_EQ_EQ] = ACTIONS(13549),
    [anon_sym_BANG_EQ] = ACTIONS(13547),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13547),
    [anon_sym_LT_EQ_GT] = ACTIONS(13547),
    [anon_sym_EQ_TILDE] = ACTIONS(13547),
    [anon_sym_BANG_TILDE] = ACTIONS(13547),
    [anon_sym_LT_EQ] = ACTIONS(13549),
    [anon_sym_GT] = ACTIONS(13549),
    [anon_sym_GT_EQ] = ACTIONS(13547),
    [anon_sym_CARET] = ACTIONS(13547),
    [anon_sym_PLUS] = ACTIONS(13547),
    [anon_sym_SLASH] = ACTIONS(13547),
    [anon_sym_PERCENT] = ACTIONS(13547),
    [sym_comment] = ACTIONS(87),
  },
  [8316] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(2185),
    [sym__binary_star] = ACTIONS(2187),
    [anon_sym_PIPE] = ACTIONS(2189),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2191),
    [anon_sym_LT] = ACTIONS(2193),
    [anon_sym_end] = ACTIONS(12120),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_else] = ACTIONS(12120),
    [anon_sym_ensure] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(2195),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2199),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(2203),
    [anon_sym_AMP_AMP] = ACTIONS(2203),
    [anon_sym_LT_LT] = ACTIONS(2205),
    [anon_sym_GT_GT] = ACTIONS(2205),
    [anon_sym_EQ_EQ] = ACTIONS(2207),
    [anon_sym_BANG_EQ] = ACTIONS(2203),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2203),
    [anon_sym_LT_EQ_GT] = ACTIONS(2203),
    [anon_sym_EQ_TILDE] = ACTIONS(2203),
    [anon_sym_BANG_TILDE] = ACTIONS(2203),
    [anon_sym_LT_EQ] = ACTIONS(2193),
    [anon_sym_GT] = ACTIONS(2193),
    [anon_sym_GT_EQ] = ACTIONS(2209),
    [anon_sym_CARET] = ACTIONS(2211),
    [anon_sym_PLUS] = ACTIONS(2185),
    [anon_sym_SLASH] = ACTIONS(2187),
    [anon_sym_PERCENT] = ACTIONS(2187),
    [sym_comment] = ACTIONS(87),
  },
  [8317] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(9195),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(9199),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(9199),
    [anon_sym_PERCENT] = ACTIONS(9199),
    [sym_comment] = ACTIONS(87),
  },
  [8318] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(9199),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(5827),
    [anon_sym_PERCENT] = ACTIONS(5827),
    [sym_comment] = ACTIONS(87),
  },
  [8319] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(9193),
    [sym__binary_star] = ACTIONS(9195),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(9199),
    [anon_sym_AMP] = ACTIONS(9201),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(9213),
    [anon_sym_GT_GT] = ACTIONS(9213),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(9219),
    [anon_sym_SLASH] = ACTIONS(9199),
    [anon_sym_PERCENT] = ACTIONS(9199),
    [sym_comment] = ACTIONS(87),
  },
  [8320] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(9193),
    [sym__binary_star] = ACTIONS(9195),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(9199),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(9213),
    [anon_sym_GT_GT] = ACTIONS(9213),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(9219),
    [anon_sym_SLASH] = ACTIONS(9199),
    [anon_sym_PERCENT] = ACTIONS(9199),
    [sym_comment] = ACTIONS(87),
  },
  [8321] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(9193),
    [sym__binary_star] = ACTIONS(9195),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(9197),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(9199),
    [anon_sym_AMP] = ACTIONS(9201),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(9213),
    [anon_sym_GT_GT] = ACTIONS(9213),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(9197),
    [anon_sym_PLUS] = ACTIONS(9219),
    [anon_sym_SLASH] = ACTIONS(9199),
    [anon_sym_PERCENT] = ACTIONS(9199),
    [sym_comment] = ACTIONS(87),
  },
  [8322] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(13551),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [8323] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(9193),
    [sym__binary_star] = ACTIONS(9195),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(9197),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(9199),
    [anon_sym_AMP] = ACTIONS(9201),
    [anon_sym_EQ] = ACTIONS(7888),
    [anon_sym_LT] = ACTIONS(9203),
    [anon_sym_end] = ACTIONS(5927),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_else] = ACTIONS(5927),
    [anon_sym_ensure] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_PLUS_EQ] = ACTIONS(5927),
    [anon_sym_DASH_EQ] = ACTIONS(5927),
    [anon_sym_STAR_EQ] = ACTIONS(5927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5927),
    [anon_sym_SLASH_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5927),
    [anon_sym_AMP_EQ] = ACTIONS(5927),
    [anon_sym_PERCENT_EQ] = ACTIONS(5927),
    [anon_sym_GT_GT_EQ] = ACTIONS(5927),
    [anon_sym_LT_LT_EQ] = ACTIONS(5927),
    [anon_sym_CARET_EQ] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(9207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9209),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(9211),
    [anon_sym_AMP_AMP] = ACTIONS(9211),
    [anon_sym_LT_LT] = ACTIONS(9213),
    [anon_sym_GT_GT] = ACTIONS(9213),
    [anon_sym_EQ_EQ] = ACTIONS(9211),
    [anon_sym_BANG_EQ] = ACTIONS(9215),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9215),
    [anon_sym_LT_EQ_GT] = ACTIONS(9215),
    [anon_sym_EQ_TILDE] = ACTIONS(9215),
    [anon_sym_BANG_TILDE] = ACTIONS(9215),
    [anon_sym_LT_EQ] = ACTIONS(9203),
    [anon_sym_GT] = ACTIONS(9203),
    [anon_sym_GT_EQ] = ACTIONS(9217),
    [anon_sym_CARET] = ACTIONS(9197),
    [anon_sym_PLUS] = ACTIONS(9219),
    [anon_sym_SLASH] = ACTIONS(9199),
    [anon_sym_PERCENT] = ACTIONS(9199),
    [sym_comment] = ACTIONS(87),
  },
  [8324] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(9193),
    [sym__binary_star] = ACTIONS(9195),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(9197),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(9199),
    [anon_sym_AMP] = ACTIONS(9201),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(9203),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(9205),
    [anon_sym_DOT_DOT] = ACTIONS(9207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9209),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(9211),
    [anon_sym_AMP_AMP] = ACTIONS(9211),
    [anon_sym_LT_LT] = ACTIONS(9213),
    [anon_sym_GT_GT] = ACTIONS(9213),
    [anon_sym_EQ_EQ] = ACTIONS(9211),
    [anon_sym_BANG_EQ] = ACTIONS(9215),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9215),
    [anon_sym_LT_EQ_GT] = ACTIONS(9215),
    [anon_sym_EQ_TILDE] = ACTIONS(9215),
    [anon_sym_BANG_TILDE] = ACTIONS(9215),
    [anon_sym_LT_EQ] = ACTIONS(9203),
    [anon_sym_GT] = ACTIONS(9203),
    [anon_sym_GT_EQ] = ACTIONS(9217),
    [anon_sym_CARET] = ACTIONS(9197),
    [anon_sym_PLUS] = ACTIONS(9219),
    [anon_sym_SLASH] = ACTIONS(9199),
    [anon_sym_PERCENT] = ACTIONS(9199),
    [sym_comment] = ACTIONS(87),
  },
  [8325] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(9193),
    [sym__binary_star] = ACTIONS(9195),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(9197),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(9199),
    [anon_sym_AMP] = ACTIONS(9201),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(9203),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(9213),
    [anon_sym_GT_GT] = ACTIONS(9213),
    [anon_sym_EQ_EQ] = ACTIONS(9211),
    [anon_sym_BANG_EQ] = ACTIONS(9215),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9215),
    [anon_sym_LT_EQ_GT] = ACTIONS(9215),
    [anon_sym_EQ_TILDE] = ACTIONS(9215),
    [anon_sym_BANG_TILDE] = ACTIONS(9215),
    [anon_sym_LT_EQ] = ACTIONS(9203),
    [anon_sym_GT] = ACTIONS(9203),
    [anon_sym_GT_EQ] = ACTIONS(9217),
    [anon_sym_CARET] = ACTIONS(9197),
    [anon_sym_PLUS] = ACTIONS(9219),
    [anon_sym_SLASH] = ACTIONS(9199),
    [anon_sym_PERCENT] = ACTIONS(9199),
    [sym_comment] = ACTIONS(87),
  },
  [8326] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(9193),
    [sym__binary_star] = ACTIONS(9195),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(9199),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(9219),
    [anon_sym_SLASH] = ACTIONS(9199),
    [anon_sym_PERCENT] = ACTIONS(9199),
    [sym_comment] = ACTIONS(87),
  },
  [8327] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(9193),
    [sym__binary_star] = ACTIONS(9195),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(9197),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(9199),
    [anon_sym_AMP] = ACTIONS(9201),
    [anon_sym_EQ] = ACTIONS(7936),
    [anon_sym_LT] = ACTIONS(9203),
    [anon_sym_end] = ACTIONS(5115),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_else] = ACTIONS(5115),
    [anon_sym_ensure] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_PLUS_EQ] = ACTIONS(5115),
    [anon_sym_DASH_EQ] = ACTIONS(5115),
    [anon_sym_STAR_EQ] = ACTIONS(5115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5115),
    [anon_sym_SLASH_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5115),
    [anon_sym_AMP_EQ] = ACTIONS(5115),
    [anon_sym_PERCENT_EQ] = ACTIONS(5115),
    [anon_sym_GT_GT_EQ] = ACTIONS(5115),
    [anon_sym_LT_LT_EQ] = ACTIONS(5115),
    [anon_sym_CARET_EQ] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(9205),
    [anon_sym_DOT_DOT] = ACTIONS(9207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9209),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(9211),
    [anon_sym_AMP_AMP] = ACTIONS(9211),
    [anon_sym_LT_LT] = ACTIONS(9213),
    [anon_sym_GT_GT] = ACTIONS(9213),
    [anon_sym_EQ_EQ] = ACTIONS(9211),
    [anon_sym_BANG_EQ] = ACTIONS(9215),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9215),
    [anon_sym_LT_EQ_GT] = ACTIONS(9215),
    [anon_sym_EQ_TILDE] = ACTIONS(9215),
    [anon_sym_BANG_TILDE] = ACTIONS(9215),
    [anon_sym_LT_EQ] = ACTIONS(9203),
    [anon_sym_GT] = ACTIONS(9203),
    [anon_sym_GT_EQ] = ACTIONS(9217),
    [anon_sym_CARET] = ACTIONS(9197),
    [anon_sym_PLUS] = ACTIONS(9219),
    [anon_sym_SLASH] = ACTIONS(9199),
    [anon_sym_PERCENT] = ACTIONS(9199),
    [sym_comment] = ACTIONS(87),
  },
  [8328] = {
    [aux_sym_exceptions_repeat1] = STATE(9862),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6193),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_end] = ACTIONS(6191),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_else] = ACTIONS(6191),
    [anon_sym_ensure] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_PLUS_EQ] = ACTIONS(6191),
    [anon_sym_DASH_EQ] = ACTIONS(6191),
    [anon_sym_STAR_EQ] = ACTIONS(6191),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6191),
    [anon_sym_SLASH_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6191),
    [anon_sym_AMP_EQ] = ACTIONS(6191),
    [anon_sym_PERCENT_EQ] = ACTIONS(6191),
    [anon_sym_GT_GT_EQ] = ACTIONS(6191),
    [anon_sym_LT_LT_EQ] = ACTIONS(6191),
    [anon_sym_CARET_EQ] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6193),
    [anon_sym_AMP_AMP] = ACTIONS(6193),
    [anon_sym_LT_LT] = ACTIONS(6193),
    [anon_sym_GT_GT] = ACTIONS(6193),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6193),
    [anon_sym_PLUS] = ACTIONS(6193),
    [anon_sym_SLASH] = ACTIONS(6193),
    [anon_sym_PERCENT] = ACTIONS(6193),
    [sym_comment] = ACTIONS(87),
  },
  [8329] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(9193),
    [sym__binary_star] = ACTIONS(9195),
    [anon_sym_LBRACE] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(9197),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(9199),
    [anon_sym_AMP] = ACTIONS(9201),
    [anon_sym_EQ] = ACTIONS(7938),
    [anon_sym_LT] = ACTIONS(9203),
    [anon_sym_end] = ACTIONS(6210),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_else] = ACTIONS(6210),
    [anon_sym_ensure] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_PLUS_EQ] = ACTIONS(6210),
    [anon_sym_DASH_EQ] = ACTIONS(6210),
    [anon_sym_STAR_EQ] = ACTIONS(6210),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6210),
    [anon_sym_SLASH_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6210),
    [anon_sym_AMP_EQ] = ACTIONS(6210),
    [anon_sym_PERCENT_EQ] = ACTIONS(6210),
    [anon_sym_GT_GT_EQ] = ACTIONS(6210),
    [anon_sym_LT_LT_EQ] = ACTIONS(6210),
    [anon_sym_CARET_EQ] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(9205),
    [anon_sym_DOT_DOT] = ACTIONS(9207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9209),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(9211),
    [anon_sym_AMP_AMP] = ACTIONS(9211),
    [anon_sym_LT_LT] = ACTIONS(9213),
    [anon_sym_GT_GT] = ACTIONS(9213),
    [anon_sym_EQ_EQ] = ACTIONS(9211),
    [anon_sym_BANG_EQ] = ACTIONS(9215),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9215),
    [anon_sym_LT_EQ_GT] = ACTIONS(9215),
    [anon_sym_EQ_TILDE] = ACTIONS(9215),
    [anon_sym_BANG_TILDE] = ACTIONS(9215),
    [anon_sym_LT_EQ] = ACTIONS(9203),
    [anon_sym_GT] = ACTIONS(9203),
    [anon_sym_GT_EQ] = ACTIONS(9217),
    [anon_sym_CARET] = ACTIONS(9197),
    [anon_sym_PLUS] = ACTIONS(9219),
    [anon_sym_SLASH] = ACTIONS(9199),
    [anon_sym_PERCENT] = ACTIONS(9199),
    [sym_comment] = ACTIONS(87),
  },
  [8330] = {
    [sym_string] = STATE(8330),
    [aux_sym_chained_string_repeat1] = STATE(8330),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(12267),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6217),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_EQ] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_end] = ACTIONS(6212),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_do] = ACTIONS(6212),
    [anon_sym_else] = ACTIONS(6212),
    [anon_sym_ensure] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_PLUS_EQ] = ACTIONS(6212),
    [anon_sym_DASH_EQ] = ACTIONS(6212),
    [anon_sym_STAR_EQ] = ACTIONS(6212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6212),
    [anon_sym_SLASH_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6212),
    [anon_sym_AMP_EQ] = ACTIONS(6212),
    [anon_sym_PERCENT_EQ] = ACTIONS(6212),
    [anon_sym_GT_GT_EQ] = ACTIONS(6212),
    [anon_sym_LT_LT_EQ] = ACTIONS(6212),
    [anon_sym_CARET_EQ] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6217),
    [anon_sym_AMP_AMP] = ACTIONS(6217),
    [anon_sym_LT_LT] = ACTIONS(6217),
    [anon_sym_GT_GT] = ACTIONS(6217),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6217),
    [anon_sym_PLUS] = ACTIONS(6217),
    [anon_sym_SLASH] = ACTIONS(6217),
    [anon_sym_PERCENT] = ACTIONS(6217),
    [sym_comment] = ACTIONS(87),
  },
  [8331] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(9863),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1249),
    [sym_scope_resolution] = STATE(1245),
    [sym_call] = STATE(1245),
    [sym_method_call] = STATE(1249),
    [sym_assignment] = STATE(9863),
    [sym_operator_assignment] = STATE(9863),
    [sym_conditional] = STATE(9863),
    [sym_range] = STATE(9863),
    [sym_binary] = STATE(9863),
    [sym_unary] = STATE(9863),
    [sym_left_assignment_list] = STATE(1248),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(1245),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1249),
    [sym_false] = STATE(1249),
    [sym_nil] = STATE(1249),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3260),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2223),
    [anon_sym_break] = ACTIONS(2225),
    [anon_sym_next] = ACTIONS(2227),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(5435),
    [anon_sym_defined_QMARK] = ACTIONS(2229),
    [anon_sym_not] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(2235),
    [anon_sym_TILDE] = ACTIONS(2235),
    [sym_constant] = ACTIONS(2241),
    [sym_identifier] = ACTIONS(2241),
    [sym_instance_variable] = ACTIONS(2239),
    [sym_class_variable] = ACTIONS(2239),
    [sym_global_variable] = ACTIONS(2239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(2241),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2241),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [8332] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5928),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1249),
    [sym_scope_resolution] = STATE(1245),
    [sym_call] = STATE(1245),
    [sym_method_call] = STATE(1249),
    [sym_splat_argument] = STATE(8678),
    [sym_assignment] = STATE(5928),
    [sym_operator_assignment] = STATE(5928),
    [sym_conditional] = STATE(5928),
    [sym_range] = STATE(5928),
    [sym_binary] = STATE(5928),
    [sym_unary] = STATE(5928),
    [sym__arg_or_splat_arg] = STATE(8678),
    [sym_left_assignment_list] = STATE(1248),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(1245),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1249),
    [sym_false] = STATE(1249),
    [sym_nil] = STATE(1249),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3260),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__splat_star] = ACTIONS(5061),
    [sym__unary_minus] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2223),
    [anon_sym_break] = ACTIONS(2225),
    [anon_sym_next] = ACTIONS(2227),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(5435),
    [anon_sym_defined_QMARK] = ACTIONS(2229),
    [anon_sym_not] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(2235),
    [anon_sym_TILDE] = ACTIONS(2235),
    [sym_constant] = ACTIONS(2241),
    [sym_identifier] = ACTIONS(2241),
    [sym_instance_variable] = ACTIONS(2239),
    [sym_class_variable] = ACTIONS(2239),
    [sym_global_variable] = ACTIONS(2239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(2241),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2241),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [8333] = {
    [aux_sym_exceptions_repeat1] = STATE(9864),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_LBRACE] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(13553),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9857),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_EQ] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_end] = ACTIONS(9855),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_do] = ACTIONS(9855),
    [anon_sym_else] = ACTIONS(9855),
    [anon_sym_ensure] = ACTIONS(9855),
    [anon_sym_EQ_GT] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_PLUS_EQ] = ACTIONS(9855),
    [anon_sym_DASH_EQ] = ACTIONS(9855),
    [anon_sym_STAR_EQ] = ACTIONS(9855),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9855),
    [anon_sym_SLASH_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9855),
    [anon_sym_AMP_EQ] = ACTIONS(9855),
    [anon_sym_PERCENT_EQ] = ACTIONS(9855),
    [anon_sym_GT_GT_EQ] = ACTIONS(9855),
    [anon_sym_LT_LT_EQ] = ACTIONS(9855),
    [anon_sym_CARET_EQ] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9857),
    [anon_sym_AMP_AMP] = ACTIONS(9857),
    [anon_sym_LT_LT] = ACTIONS(9857),
    [anon_sym_GT_GT] = ACTIONS(9857),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9857),
    [anon_sym_PLUS] = ACTIONS(9857),
    [anon_sym_SLASH] = ACTIONS(9857),
    [anon_sym_PERCENT] = ACTIONS(9857),
    [sym_comment] = ACTIONS(87),
  },
  [8334] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(9231),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(9231),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(9231),
    [anon_sym_PERCENT] = ACTIONS(9231),
    [sym_comment] = ACTIONS(87),
  },
  [8335] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(9231),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [8336] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(9229),
    [sym__binary_star] = ACTIONS(9231),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(9231),
    [anon_sym_AMP] = ACTIONS(9235),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(9247),
    [anon_sym_GT_GT] = ACTIONS(9247),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(9229),
    [anon_sym_SLASH] = ACTIONS(9231),
    [anon_sym_PERCENT] = ACTIONS(9231),
    [sym_comment] = ACTIONS(87),
  },
  [8337] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(9229),
    [sym__binary_star] = ACTIONS(9231),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(9231),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(9247),
    [anon_sym_GT_GT] = ACTIONS(9247),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(9229),
    [anon_sym_SLASH] = ACTIONS(9231),
    [anon_sym_PERCENT] = ACTIONS(9231),
    [sym_comment] = ACTIONS(87),
  },
  [8338] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(9229),
    [sym__binary_star] = ACTIONS(9231),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(9233),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(9231),
    [anon_sym_AMP] = ACTIONS(9235),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(9247),
    [anon_sym_GT_GT] = ACTIONS(9247),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(9253),
    [anon_sym_PLUS] = ACTIONS(9229),
    [anon_sym_SLASH] = ACTIONS(9231),
    [anon_sym_PERCENT] = ACTIONS(9231),
    [sym_comment] = ACTIONS(87),
  },
  [8339] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(13555),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [8340] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(9229),
    [sym__binary_star] = ACTIONS(9231),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(9233),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(9231),
    [anon_sym_AMP] = ACTIONS(9235),
    [anon_sym_LT] = ACTIONS(9237),
    [anon_sym_end] = ACTIONS(5927),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_else] = ACTIONS(5927),
    [anon_sym_ensure] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(9241),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9243),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(9245),
    [anon_sym_AMP_AMP] = ACTIONS(9245),
    [anon_sym_LT_LT] = ACTIONS(9247),
    [anon_sym_GT_GT] = ACTIONS(9247),
    [anon_sym_EQ_EQ] = ACTIONS(9249),
    [anon_sym_BANG_EQ] = ACTIONS(9245),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9245),
    [anon_sym_LT_EQ_GT] = ACTIONS(9245),
    [anon_sym_EQ_TILDE] = ACTIONS(9245),
    [anon_sym_BANG_TILDE] = ACTIONS(9245),
    [anon_sym_LT_EQ] = ACTIONS(9237),
    [anon_sym_GT] = ACTIONS(9237),
    [anon_sym_GT_EQ] = ACTIONS(9251),
    [anon_sym_CARET] = ACTIONS(9253),
    [anon_sym_PLUS] = ACTIONS(9229),
    [anon_sym_SLASH] = ACTIONS(9231),
    [anon_sym_PERCENT] = ACTIONS(9231),
    [sym_comment] = ACTIONS(87),
  },
  [8341] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(9229),
    [sym__binary_star] = ACTIONS(9231),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(9233),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(9231),
    [anon_sym_AMP] = ACTIONS(9235),
    [anon_sym_LT] = ACTIONS(9237),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(9239),
    [anon_sym_DOT_DOT] = ACTIONS(9241),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9243),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(9245),
    [anon_sym_AMP_AMP] = ACTIONS(9245),
    [anon_sym_LT_LT] = ACTIONS(9247),
    [anon_sym_GT_GT] = ACTIONS(9247),
    [anon_sym_EQ_EQ] = ACTIONS(9249),
    [anon_sym_BANG_EQ] = ACTIONS(9245),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9245),
    [anon_sym_LT_EQ_GT] = ACTIONS(9245),
    [anon_sym_EQ_TILDE] = ACTIONS(9245),
    [anon_sym_BANG_TILDE] = ACTIONS(9245),
    [anon_sym_LT_EQ] = ACTIONS(9237),
    [anon_sym_GT] = ACTIONS(9237),
    [anon_sym_GT_EQ] = ACTIONS(9251),
    [anon_sym_CARET] = ACTIONS(9253),
    [anon_sym_PLUS] = ACTIONS(9229),
    [anon_sym_SLASH] = ACTIONS(9231),
    [anon_sym_PERCENT] = ACTIONS(9231),
    [sym_comment] = ACTIONS(87),
  },
  [8342] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(9229),
    [sym__binary_star] = ACTIONS(9231),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(9233),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(9231),
    [anon_sym_AMP] = ACTIONS(9235),
    [anon_sym_LT] = ACTIONS(9237),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(9247),
    [anon_sym_GT_GT] = ACTIONS(9247),
    [anon_sym_EQ_EQ] = ACTIONS(9249),
    [anon_sym_BANG_EQ] = ACTIONS(9245),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9245),
    [anon_sym_LT_EQ_GT] = ACTIONS(9245),
    [anon_sym_EQ_TILDE] = ACTIONS(9245),
    [anon_sym_BANG_TILDE] = ACTIONS(9245),
    [anon_sym_LT_EQ] = ACTIONS(9237),
    [anon_sym_GT] = ACTIONS(9237),
    [anon_sym_GT_EQ] = ACTIONS(9251),
    [anon_sym_CARET] = ACTIONS(9253),
    [anon_sym_PLUS] = ACTIONS(9229),
    [anon_sym_SLASH] = ACTIONS(9231),
    [anon_sym_PERCENT] = ACTIONS(9231),
    [sym_comment] = ACTIONS(87),
  },
  [8343] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(9229),
    [sym__binary_star] = ACTIONS(9231),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(9231),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(9229),
    [anon_sym_SLASH] = ACTIONS(9231),
    [anon_sym_PERCENT] = ACTIONS(9231),
    [sym_comment] = ACTIONS(87),
  },
  [8344] = {
    [aux_sym_exceptions_repeat1] = STATE(8344),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_COMMA] = ACTIONS(13557),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_end] = ACTIONS(11597),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_else] = ACTIONS(11597),
    [anon_sym_ensure] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [8345] = {
    [aux_sym_exceptions_repeat1] = STATE(5946),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_end] = ACTIONS(6191),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_else] = ACTIONS(6191),
    [anon_sym_ensure] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [8346] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(9229),
    [sym__binary_star] = ACTIONS(9231),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(9233),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(9231),
    [anon_sym_AMP] = ACTIONS(9235),
    [anon_sym_LT] = ACTIONS(9237),
    [anon_sym_end] = ACTIONS(6210),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_else] = ACTIONS(6210),
    [anon_sym_ensure] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(9239),
    [anon_sym_DOT_DOT] = ACTIONS(9241),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9243),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(9245),
    [anon_sym_AMP_AMP] = ACTIONS(9245),
    [anon_sym_LT_LT] = ACTIONS(9247),
    [anon_sym_GT_GT] = ACTIONS(9247),
    [anon_sym_EQ_EQ] = ACTIONS(9249),
    [anon_sym_BANG_EQ] = ACTIONS(9245),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9245),
    [anon_sym_LT_EQ_GT] = ACTIONS(9245),
    [anon_sym_EQ_TILDE] = ACTIONS(9245),
    [anon_sym_BANG_TILDE] = ACTIONS(9245),
    [anon_sym_LT_EQ] = ACTIONS(9237),
    [anon_sym_GT] = ACTIONS(9237),
    [anon_sym_GT_EQ] = ACTIONS(9251),
    [anon_sym_CARET] = ACTIONS(9253),
    [anon_sym_PLUS] = ACTIONS(9229),
    [anon_sym_SLASH] = ACTIONS(9231),
    [anon_sym_PERCENT] = ACTIONS(9231),
    [sym_comment] = ACTIONS(87),
  },
  [8347] = {
    [sym__heredoc_body_start] = ACTIONS(10203),
    [sym__binary_minus] = ACTIONS(10203),
    [sym__binary_star] = ACTIONS(10203),
    [anon_sym_LBRACE] = ACTIONS(10203),
    [anon_sym_RBRACE] = ACTIONS(10203),
    [anon_sym_RPAREN] = ACTIONS(10203),
    [anon_sym_DOT] = ACTIONS(10205),
    [anon_sym_COMMA] = ACTIONS(10203),
    [anon_sym_PIPE] = ACTIONS(10205),
    [anon_sym_SEMI] = ACTIONS(10203),
    [anon_sym_STAR_STAR] = ACTIONS(10203),
    [anon_sym_AMP] = ACTIONS(10205),
    [anon_sym_EQ] = ACTIONS(10205),
    [anon_sym_LT] = ACTIONS(10205),
    [anon_sym_if] = ACTIONS(10203),
    [anon_sym_unless] = ACTIONS(10203),
    [anon_sym_while] = ACTIONS(10203),
    [anon_sym_until] = ACTIONS(10203),
    [anon_sym_rescue] = ACTIONS(10203),
    [anon_sym_in] = ACTIONS(10203),
    [anon_sym_do] = ACTIONS(10203),
    [anon_sym_EQ_GT] = ACTIONS(10203),
    [anon_sym_LBRACK] = ACTIONS(10203),
    [anon_sym_RBRACK] = ACTIONS(10203),
    [anon_sym_COLON_COLON2] = ACTIONS(10203),
    [anon_sym_AMP_DOT] = ACTIONS(10203),
    [anon_sym_QMARK] = ACTIONS(10203),
    [anon_sym_COLON2] = ACTIONS(10205),
    [anon_sym_DOT_DOT] = ACTIONS(10205),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10203),
    [anon_sym_and] = ACTIONS(10203),
    [anon_sym_or] = ACTIONS(10203),
    [anon_sym_PIPE_PIPE] = ACTIONS(10203),
    [anon_sym_AMP_AMP] = ACTIONS(10203),
    [anon_sym_LT_LT] = ACTIONS(10203),
    [anon_sym_GT_GT] = ACTIONS(10203),
    [anon_sym_EQ_EQ] = ACTIONS(10205),
    [anon_sym_BANG_EQ] = ACTIONS(10203),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10203),
    [anon_sym_LT_EQ_GT] = ACTIONS(10203),
    [anon_sym_EQ_TILDE] = ACTIONS(10203),
    [anon_sym_BANG_TILDE] = ACTIONS(10203),
    [anon_sym_LT_EQ] = ACTIONS(10205),
    [anon_sym_GT] = ACTIONS(10205),
    [anon_sym_GT_EQ] = ACTIONS(10203),
    [anon_sym_CARET] = ACTIONS(10203),
    [anon_sym_PLUS] = ACTIONS(10203),
    [anon_sym_SLASH] = ACTIONS(10203),
    [anon_sym_PERCENT] = ACTIONS(10203),
    [sym_comment] = ACTIONS(87),
  },
  [8348] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1697),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(13560),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [8349] = {
    [sym__heredoc_body_start] = ACTIONS(10209),
    [sym__binary_minus] = ACTIONS(10209),
    [sym__binary_star] = ACTIONS(10209),
    [anon_sym_LBRACE] = ACTIONS(10209),
    [anon_sym_RBRACE] = ACTIONS(10209),
    [anon_sym_RPAREN] = ACTIONS(10209),
    [anon_sym_DOT] = ACTIONS(10211),
    [anon_sym_COMMA] = ACTIONS(10209),
    [anon_sym_PIPE] = ACTIONS(10211),
    [anon_sym_SEMI] = ACTIONS(10209),
    [anon_sym_STAR_STAR] = ACTIONS(10209),
    [anon_sym_AMP] = ACTIONS(10211),
    [anon_sym_EQ] = ACTIONS(10211),
    [anon_sym_LT] = ACTIONS(10211),
    [anon_sym_if] = ACTIONS(10209),
    [anon_sym_unless] = ACTIONS(10209),
    [anon_sym_while] = ACTIONS(10209),
    [anon_sym_until] = ACTIONS(10209),
    [anon_sym_rescue] = ACTIONS(10209),
    [anon_sym_in] = ACTIONS(10209),
    [anon_sym_do] = ACTIONS(10209),
    [anon_sym_EQ_GT] = ACTIONS(10209),
    [anon_sym_LBRACK] = ACTIONS(10209),
    [anon_sym_RBRACK] = ACTIONS(10209),
    [anon_sym_COLON_COLON2] = ACTIONS(10209),
    [anon_sym_AMP_DOT] = ACTIONS(10209),
    [anon_sym_QMARK] = ACTIONS(10209),
    [anon_sym_COLON2] = ACTIONS(10211),
    [anon_sym_DOT_DOT] = ACTIONS(10211),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10209),
    [anon_sym_and] = ACTIONS(10209),
    [anon_sym_or] = ACTIONS(10209),
    [anon_sym_PIPE_PIPE] = ACTIONS(10209),
    [anon_sym_AMP_AMP] = ACTIONS(10209),
    [anon_sym_LT_LT] = ACTIONS(10209),
    [anon_sym_GT_GT] = ACTIONS(10209),
    [anon_sym_EQ_EQ] = ACTIONS(10211),
    [anon_sym_BANG_EQ] = ACTIONS(10209),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10209),
    [anon_sym_LT_EQ_GT] = ACTIONS(10209),
    [anon_sym_EQ_TILDE] = ACTIONS(10209),
    [anon_sym_BANG_TILDE] = ACTIONS(10209),
    [anon_sym_LT_EQ] = ACTIONS(10211),
    [anon_sym_GT] = ACTIONS(10211),
    [anon_sym_GT_EQ] = ACTIONS(10209),
    [anon_sym_CARET] = ACTIONS(10209),
    [anon_sym_PLUS] = ACTIONS(10209),
    [anon_sym_SLASH] = ACTIONS(10209),
    [anon_sym_PERCENT] = ACTIONS(10209),
    [sym_comment] = ACTIONS(87),
  },
  [8350] = {
    [sym__heredoc_body_start] = ACTIONS(10213),
    [sym__binary_minus] = ACTIONS(10213),
    [sym__binary_star] = ACTIONS(10213),
    [anon_sym_LBRACE] = ACTIONS(10213),
    [anon_sym_RBRACE] = ACTIONS(10213),
    [anon_sym_RPAREN] = ACTIONS(10213),
    [anon_sym_DOT] = ACTIONS(10215),
    [anon_sym_COMMA] = ACTIONS(10213),
    [anon_sym_PIPE] = ACTIONS(10215),
    [anon_sym_SEMI] = ACTIONS(10213),
    [anon_sym_STAR_STAR] = ACTIONS(10213),
    [anon_sym_AMP] = ACTIONS(10215),
    [anon_sym_EQ] = ACTIONS(10215),
    [anon_sym_LT] = ACTIONS(10215),
    [anon_sym_if] = ACTIONS(10213),
    [anon_sym_unless] = ACTIONS(10213),
    [anon_sym_while] = ACTIONS(10213),
    [anon_sym_until] = ACTIONS(10213),
    [anon_sym_rescue] = ACTIONS(10213),
    [anon_sym_in] = ACTIONS(10213),
    [anon_sym_do] = ACTIONS(10213),
    [anon_sym_EQ_GT] = ACTIONS(10213),
    [anon_sym_LBRACK] = ACTIONS(10213),
    [anon_sym_RBRACK] = ACTIONS(10213),
    [anon_sym_COLON_COLON2] = ACTIONS(10213),
    [anon_sym_AMP_DOT] = ACTIONS(10213),
    [anon_sym_QMARK] = ACTIONS(10213),
    [anon_sym_COLON2] = ACTIONS(10215),
    [anon_sym_DOT_DOT] = ACTIONS(10215),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10213),
    [anon_sym_and] = ACTIONS(10213),
    [anon_sym_or] = ACTIONS(10213),
    [anon_sym_PIPE_PIPE] = ACTIONS(10213),
    [anon_sym_AMP_AMP] = ACTIONS(10213),
    [anon_sym_LT_LT] = ACTIONS(10213),
    [anon_sym_GT_GT] = ACTIONS(10213),
    [anon_sym_EQ_EQ] = ACTIONS(10215),
    [anon_sym_BANG_EQ] = ACTIONS(10213),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10213),
    [anon_sym_LT_EQ_GT] = ACTIONS(10213),
    [anon_sym_EQ_TILDE] = ACTIONS(10213),
    [anon_sym_BANG_TILDE] = ACTIONS(10213),
    [anon_sym_LT_EQ] = ACTIONS(10215),
    [anon_sym_GT] = ACTIONS(10215),
    [anon_sym_GT_EQ] = ACTIONS(10213),
    [anon_sym_CARET] = ACTIONS(10213),
    [anon_sym_PLUS] = ACTIONS(10213),
    [anon_sym_SLASH] = ACTIONS(10213),
    [anon_sym_PERCENT] = ACTIONS(10213),
    [sym_comment] = ACTIONS(87),
  },
  [8351] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1705),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(13562),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [8352] = {
    [sym__heredoc_body_start] = ACTIONS(10219),
    [sym__binary_minus] = ACTIONS(10219),
    [sym__binary_star] = ACTIONS(10219),
    [anon_sym_LBRACE] = ACTIONS(10219),
    [anon_sym_RBRACE] = ACTIONS(10219),
    [anon_sym_RPAREN] = ACTIONS(10219),
    [anon_sym_DOT] = ACTIONS(10221),
    [anon_sym_COMMA] = ACTIONS(10219),
    [anon_sym_PIPE] = ACTIONS(10221),
    [anon_sym_SEMI] = ACTIONS(10219),
    [anon_sym_STAR_STAR] = ACTIONS(10219),
    [anon_sym_AMP] = ACTIONS(10221),
    [anon_sym_EQ] = ACTIONS(10221),
    [anon_sym_LT] = ACTIONS(10221),
    [anon_sym_if] = ACTIONS(10219),
    [anon_sym_unless] = ACTIONS(10219),
    [anon_sym_while] = ACTIONS(10219),
    [anon_sym_until] = ACTIONS(10219),
    [anon_sym_rescue] = ACTIONS(10219),
    [anon_sym_in] = ACTIONS(10219),
    [anon_sym_do] = ACTIONS(10219),
    [anon_sym_EQ_GT] = ACTIONS(10219),
    [anon_sym_LBRACK] = ACTIONS(10219),
    [anon_sym_RBRACK] = ACTIONS(10219),
    [anon_sym_COLON_COLON2] = ACTIONS(10219),
    [anon_sym_AMP_DOT] = ACTIONS(10219),
    [anon_sym_QMARK] = ACTIONS(10219),
    [anon_sym_COLON2] = ACTIONS(10221),
    [anon_sym_DOT_DOT] = ACTIONS(10221),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10219),
    [anon_sym_and] = ACTIONS(10219),
    [anon_sym_or] = ACTIONS(10219),
    [anon_sym_PIPE_PIPE] = ACTIONS(10219),
    [anon_sym_AMP_AMP] = ACTIONS(10219),
    [anon_sym_LT_LT] = ACTIONS(10219),
    [anon_sym_GT_GT] = ACTIONS(10219),
    [anon_sym_EQ_EQ] = ACTIONS(10221),
    [anon_sym_BANG_EQ] = ACTIONS(10219),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10219),
    [anon_sym_LT_EQ_GT] = ACTIONS(10219),
    [anon_sym_EQ_TILDE] = ACTIONS(10219),
    [anon_sym_BANG_TILDE] = ACTIONS(10219),
    [anon_sym_LT_EQ] = ACTIONS(10221),
    [anon_sym_GT] = ACTIONS(10221),
    [anon_sym_GT_EQ] = ACTIONS(10219),
    [anon_sym_CARET] = ACTIONS(10219),
    [anon_sym_PLUS] = ACTIONS(10219),
    [anon_sym_SLASH] = ACTIONS(10219),
    [anon_sym_PERCENT] = ACTIONS(10219),
    [sym_comment] = ACTIONS(87),
  },
  [8353] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(11871),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_RBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [8354] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(11869),
    [sym__binary_star] = ACTIONS(11871),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(11873),
    [anon_sym_STAR_STAR] = ACTIONS(11871),
    [anon_sym_AMP] = ACTIONS(11875),
    [anon_sym_LT] = ACTIONS(11877),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_RBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(11879),
    [anon_sym_DOT_DOT] = ACTIONS(11881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11883),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(11885),
    [anon_sym_AMP_AMP] = ACTIONS(11885),
    [anon_sym_LT_LT] = ACTIONS(11887),
    [anon_sym_GT_GT] = ACTIONS(11887),
    [anon_sym_EQ_EQ] = ACTIONS(11889),
    [anon_sym_BANG_EQ] = ACTIONS(11885),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11885),
    [anon_sym_LT_EQ_GT] = ACTIONS(11885),
    [anon_sym_EQ_TILDE] = ACTIONS(11885),
    [anon_sym_BANG_TILDE] = ACTIONS(11885),
    [anon_sym_LT_EQ] = ACTIONS(11877),
    [anon_sym_GT] = ACTIONS(11877),
    [anon_sym_GT_EQ] = ACTIONS(11891),
    [anon_sym_CARET] = ACTIONS(11893),
    [anon_sym_PLUS] = ACTIONS(11869),
    [anon_sym_SLASH] = ACTIONS(11871),
    [anon_sym_PERCENT] = ACTIONS(11871),
    [sym_comment] = ACTIONS(87),
  },
  [8355] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9868),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(5966),
    [sym_scope_resolution] = STATE(1285),
    [sym_call] = STATE(1285),
    [sym_method_call] = STATE(5966),
    [sym_assignment] = STATE(9868),
    [sym_operator_assignment] = STATE(9868),
    [sym_conditional] = STATE(9868),
    [sym_range] = STATE(9868),
    [sym_binary] = STATE(9868),
    [sym_unary] = STATE(9868),
    [sym_left_assignment_list] = STATE(5965),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5966),
    [sym__variable] = STATE(1285),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(5966),
    [sym_false] = STATE(5966),
    [sym_nil] = STATE(5966),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(1288),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9288),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2283),
    [anon_sym_yield] = ACTIONS(2285),
    [anon_sym_break] = ACTIONS(2287),
    [anon_sym_next] = ACTIONS(2289),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9290),
    [anon_sym_defined_QMARK] = ACTIONS(9292),
    [anon_sym_not] = ACTIONS(9294),
    [anon_sym_BANG] = ACTIONS(9296),
    [anon_sym_TILDE] = ACTIONS(9296),
    [sym_constant] = ACTIONS(2299),
    [sym_identifier] = ACTIONS(2299),
    [sym_instance_variable] = ACTIONS(2301),
    [sym_class_variable] = ACTIONS(2301),
    [sym_global_variable] = ACTIONS(2301),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2299),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2299),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8356] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9869),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(5966),
    [sym_scope_resolution] = STATE(1285),
    [sym_call] = STATE(1285),
    [sym_method_call] = STATE(5966),
    [sym_assignment] = STATE(9869),
    [sym_operator_assignment] = STATE(9869),
    [sym_conditional] = STATE(9869),
    [sym_range] = STATE(9869),
    [sym_binary] = STATE(9869),
    [sym_unary] = STATE(9869),
    [sym_left_assignment_list] = STATE(5965),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5966),
    [sym__variable] = STATE(1285),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(5966),
    [sym_false] = STATE(5966),
    [sym_nil] = STATE(5966),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(1288),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9288),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2283),
    [anon_sym_yield] = ACTIONS(2285),
    [anon_sym_break] = ACTIONS(2287),
    [anon_sym_next] = ACTIONS(2289),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9290),
    [anon_sym_defined_QMARK] = ACTIONS(9292),
    [anon_sym_not] = ACTIONS(9294),
    [anon_sym_BANG] = ACTIONS(9296),
    [anon_sym_TILDE] = ACTIONS(9296),
    [sym_constant] = ACTIONS(2299),
    [sym_identifier] = ACTIONS(2299),
    [sym_instance_variable] = ACTIONS(2301),
    [sym_class_variable] = ACTIONS(2301),
    [sym_global_variable] = ACTIONS(2301),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2299),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2299),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8357] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9870),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(5966),
    [sym_scope_resolution] = STATE(1285),
    [sym_call] = STATE(1285),
    [sym_method_call] = STATE(5966),
    [sym_assignment] = STATE(9870),
    [sym_operator_assignment] = STATE(9870),
    [sym_conditional] = STATE(9870),
    [sym_range] = STATE(9870),
    [sym_binary] = STATE(9870),
    [sym_unary] = STATE(9870),
    [sym_left_assignment_list] = STATE(5965),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5966),
    [sym__variable] = STATE(1285),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(5966),
    [sym_false] = STATE(5966),
    [sym_nil] = STATE(5966),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(1288),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9288),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2283),
    [anon_sym_yield] = ACTIONS(2285),
    [anon_sym_break] = ACTIONS(2287),
    [anon_sym_next] = ACTIONS(2289),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9290),
    [anon_sym_defined_QMARK] = ACTIONS(9292),
    [anon_sym_not] = ACTIONS(9294),
    [anon_sym_BANG] = ACTIONS(9296),
    [anon_sym_TILDE] = ACTIONS(9296),
    [sym_constant] = ACTIONS(2299),
    [sym_identifier] = ACTIONS(2299),
    [sym_instance_variable] = ACTIONS(2301),
    [sym_class_variable] = ACTIONS(2301),
    [sym_global_variable] = ACTIONS(2301),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2299),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2299),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8358] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9871),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(5966),
    [sym_scope_resolution] = STATE(1285),
    [sym_call] = STATE(1285),
    [sym_method_call] = STATE(5966),
    [sym_assignment] = STATE(9871),
    [sym_operator_assignment] = STATE(9871),
    [sym_conditional] = STATE(9871),
    [sym_range] = STATE(9871),
    [sym_binary] = STATE(9871),
    [sym_unary] = STATE(9871),
    [sym_left_assignment_list] = STATE(5965),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5966),
    [sym__variable] = STATE(1285),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(5966),
    [sym_false] = STATE(5966),
    [sym_nil] = STATE(5966),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(1288),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9288),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2283),
    [anon_sym_yield] = ACTIONS(2285),
    [anon_sym_break] = ACTIONS(2287),
    [anon_sym_next] = ACTIONS(2289),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9290),
    [anon_sym_defined_QMARK] = ACTIONS(9292),
    [anon_sym_not] = ACTIONS(9294),
    [anon_sym_BANG] = ACTIONS(9296),
    [anon_sym_TILDE] = ACTIONS(9296),
    [sym_constant] = ACTIONS(2299),
    [sym_identifier] = ACTIONS(2299),
    [sym_instance_variable] = ACTIONS(2301),
    [sym_class_variable] = ACTIONS(2301),
    [sym_global_variable] = ACTIONS(2301),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2299),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2299),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8359] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9872),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(5966),
    [sym_scope_resolution] = STATE(1285),
    [sym_call] = STATE(1285),
    [sym_method_call] = STATE(5966),
    [sym_assignment] = STATE(9872),
    [sym_operator_assignment] = STATE(9872),
    [sym_conditional] = STATE(9872),
    [sym_range] = STATE(9872),
    [sym_binary] = STATE(9872),
    [sym_unary] = STATE(9872),
    [sym_left_assignment_list] = STATE(5965),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5966),
    [sym__variable] = STATE(1285),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(5966),
    [sym_false] = STATE(5966),
    [sym_nil] = STATE(5966),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(1288),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9288),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2283),
    [anon_sym_yield] = ACTIONS(2285),
    [anon_sym_break] = ACTIONS(2287),
    [anon_sym_next] = ACTIONS(2289),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9290),
    [anon_sym_defined_QMARK] = ACTIONS(9292),
    [anon_sym_not] = ACTIONS(9294),
    [anon_sym_BANG] = ACTIONS(9296),
    [anon_sym_TILDE] = ACTIONS(9296),
    [sym_constant] = ACTIONS(2299),
    [sym_identifier] = ACTIONS(2299),
    [sym_instance_variable] = ACTIONS(2301),
    [sym_class_variable] = ACTIONS(2301),
    [sym_global_variable] = ACTIONS(2301),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2299),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2299),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8360] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(9873),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(9873),
    [sym_operator_assignment] = STATE(9873),
    [sym_conditional] = STATE(9873),
    [sym_range] = STATE(9873),
    [sym_binary] = STATE(9873),
    [sym_unary] = STATE(9873),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8361] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9874),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(5966),
    [sym_scope_resolution] = STATE(1285),
    [sym_call] = STATE(1285),
    [sym_method_call] = STATE(5966),
    [sym_assignment] = STATE(9874),
    [sym_operator_assignment] = STATE(9874),
    [sym_conditional] = STATE(9874),
    [sym_range] = STATE(9874),
    [sym_binary] = STATE(9874),
    [sym_unary] = STATE(9874),
    [sym_left_assignment_list] = STATE(5965),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5966),
    [sym__variable] = STATE(1285),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(5966),
    [sym_false] = STATE(5966),
    [sym_nil] = STATE(5966),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(1288),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9288),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2283),
    [anon_sym_yield] = ACTIONS(2285),
    [anon_sym_break] = ACTIONS(2287),
    [anon_sym_next] = ACTIONS(2289),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9290),
    [anon_sym_defined_QMARK] = ACTIONS(9292),
    [anon_sym_not] = ACTIONS(9294),
    [anon_sym_BANG] = ACTIONS(9296),
    [anon_sym_TILDE] = ACTIONS(9296),
    [sym_constant] = ACTIONS(2299),
    [sym_identifier] = ACTIONS(2299),
    [sym_instance_variable] = ACTIONS(2301),
    [sym_class_variable] = ACTIONS(2301),
    [sym_global_variable] = ACTIONS(2301),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2299),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2299),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8362] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9875),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(5966),
    [sym_scope_resolution] = STATE(1285),
    [sym_call] = STATE(1285),
    [sym_method_call] = STATE(5966),
    [sym_assignment] = STATE(9875),
    [sym_operator_assignment] = STATE(9875),
    [sym_conditional] = STATE(9875),
    [sym_range] = STATE(9875),
    [sym_binary] = STATE(9875),
    [sym_unary] = STATE(9875),
    [sym_left_assignment_list] = STATE(5965),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5966),
    [sym__variable] = STATE(1285),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(5966),
    [sym_false] = STATE(5966),
    [sym_nil] = STATE(5966),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(1288),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9288),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2283),
    [anon_sym_yield] = ACTIONS(2285),
    [anon_sym_break] = ACTIONS(2287),
    [anon_sym_next] = ACTIONS(2289),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9290),
    [anon_sym_defined_QMARK] = ACTIONS(9292),
    [anon_sym_not] = ACTIONS(9294),
    [anon_sym_BANG] = ACTIONS(9296),
    [anon_sym_TILDE] = ACTIONS(9296),
    [sym_constant] = ACTIONS(2299),
    [sym_identifier] = ACTIONS(2299),
    [sym_instance_variable] = ACTIONS(2301),
    [sym_class_variable] = ACTIONS(2301),
    [sym_global_variable] = ACTIONS(2301),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2299),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2299),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8363] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9876),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(5966),
    [sym_scope_resolution] = STATE(1285),
    [sym_call] = STATE(1285),
    [sym_method_call] = STATE(5966),
    [sym_assignment] = STATE(9876),
    [sym_operator_assignment] = STATE(9876),
    [sym_conditional] = STATE(9876),
    [sym_range] = STATE(9876),
    [sym_binary] = STATE(9876),
    [sym_unary] = STATE(9876),
    [sym_left_assignment_list] = STATE(5965),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5966),
    [sym__variable] = STATE(1285),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(5966),
    [sym_false] = STATE(5966),
    [sym_nil] = STATE(5966),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(1288),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9288),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2283),
    [anon_sym_yield] = ACTIONS(2285),
    [anon_sym_break] = ACTIONS(2287),
    [anon_sym_next] = ACTIONS(2289),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9290),
    [anon_sym_defined_QMARK] = ACTIONS(9292),
    [anon_sym_not] = ACTIONS(9294),
    [anon_sym_BANG] = ACTIONS(9296),
    [anon_sym_TILDE] = ACTIONS(9296),
    [sym_constant] = ACTIONS(2299),
    [sym_identifier] = ACTIONS(2299),
    [sym_instance_variable] = ACTIONS(2301),
    [sym_class_variable] = ACTIONS(2301),
    [sym_global_variable] = ACTIONS(2301),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2299),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2299),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8364] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9877),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(5966),
    [sym_scope_resolution] = STATE(1285),
    [sym_call] = STATE(1285),
    [sym_method_call] = STATE(5966),
    [sym_assignment] = STATE(9877),
    [sym_operator_assignment] = STATE(9877),
    [sym_conditional] = STATE(9877),
    [sym_range] = STATE(9877),
    [sym_binary] = STATE(9877),
    [sym_unary] = STATE(9877),
    [sym_left_assignment_list] = STATE(5965),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5966),
    [sym__variable] = STATE(1285),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(5966),
    [sym_false] = STATE(5966),
    [sym_nil] = STATE(5966),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(1288),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9288),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2283),
    [anon_sym_yield] = ACTIONS(2285),
    [anon_sym_break] = ACTIONS(2287),
    [anon_sym_next] = ACTIONS(2289),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9290),
    [anon_sym_defined_QMARK] = ACTIONS(9292),
    [anon_sym_not] = ACTIONS(9294),
    [anon_sym_BANG] = ACTIONS(9296),
    [anon_sym_TILDE] = ACTIONS(9296),
    [sym_constant] = ACTIONS(2299),
    [sym_identifier] = ACTIONS(2299),
    [sym_instance_variable] = ACTIONS(2301),
    [sym_class_variable] = ACTIONS(2301),
    [sym_global_variable] = ACTIONS(2301),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2299),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2299),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8365] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9878),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(5966),
    [sym_scope_resolution] = STATE(1285),
    [sym_call] = STATE(1285),
    [sym_method_call] = STATE(5966),
    [sym_splat_argument] = STATE(9879),
    [sym_assignment] = STATE(9878),
    [sym_operator_assignment] = STATE(9878),
    [sym_conditional] = STATE(9878),
    [sym_range] = STATE(9878),
    [sym_binary] = STATE(9878),
    [sym_unary] = STATE(9878),
    [sym_right_assignment_list] = STATE(4255),
    [sym__arg_or_splat_arg] = STATE(9879),
    [sym_left_assignment_list] = STATE(5965),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5966),
    [sym__variable] = STATE(1285),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(5966),
    [sym_false] = STATE(5966),
    [sym_nil] = STATE(5966),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(1288),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(5529),
    [sym__unary_minus] = ACTIONS(9288),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2283),
    [anon_sym_yield] = ACTIONS(2285),
    [anon_sym_break] = ACTIONS(2287),
    [anon_sym_next] = ACTIONS(2289),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9290),
    [anon_sym_defined_QMARK] = ACTIONS(9292),
    [anon_sym_not] = ACTIONS(9294),
    [anon_sym_BANG] = ACTIONS(9296),
    [anon_sym_TILDE] = ACTIONS(9296),
    [sym_constant] = ACTIONS(2299),
    [sym_identifier] = ACTIONS(2299),
    [sym_instance_variable] = ACTIONS(2301),
    [sym_class_variable] = ACTIONS(2301),
    [sym_global_variable] = ACTIONS(2301),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2299),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2299),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8366] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9880),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(5966),
    [sym_scope_resolution] = STATE(1285),
    [sym_call] = STATE(1285),
    [sym_method_call] = STATE(5966),
    [sym_assignment] = STATE(9880),
    [sym_operator_assignment] = STATE(9880),
    [sym_conditional] = STATE(9880),
    [sym_range] = STATE(9880),
    [sym_binary] = STATE(9880),
    [sym_unary] = STATE(9880),
    [sym_left_assignment_list] = STATE(5965),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5966),
    [sym__variable] = STATE(1285),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(5966),
    [sym_false] = STATE(5966),
    [sym_nil] = STATE(5966),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(1288),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9288),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2283),
    [anon_sym_yield] = ACTIONS(2285),
    [anon_sym_break] = ACTIONS(2287),
    [anon_sym_next] = ACTIONS(2289),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9290),
    [anon_sym_defined_QMARK] = ACTIONS(9292),
    [anon_sym_not] = ACTIONS(9294),
    [anon_sym_BANG] = ACTIONS(9296),
    [anon_sym_TILDE] = ACTIONS(9296),
    [sym_constant] = ACTIONS(2299),
    [sym_identifier] = ACTIONS(2299),
    [sym_instance_variable] = ACTIONS(2301),
    [sym_class_variable] = ACTIONS(2301),
    [sym_global_variable] = ACTIONS(2301),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2299),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2299),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8367] = {
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(11869),
    [sym__binary_star] = ACTIONS(11871),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(11873),
    [anon_sym_STAR_STAR] = ACTIONS(11871),
    [anon_sym_AMP] = ACTIONS(11875),
    [anon_sym_LT] = ACTIONS(11877),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_RBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(11879),
    [anon_sym_DOT_DOT] = ACTIONS(11881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11883),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(11885),
    [anon_sym_AMP_AMP] = ACTIONS(11885),
    [anon_sym_LT_LT] = ACTIONS(11887),
    [anon_sym_GT_GT] = ACTIONS(11887),
    [anon_sym_EQ_EQ] = ACTIONS(11889),
    [anon_sym_BANG_EQ] = ACTIONS(11885),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11885),
    [anon_sym_LT_EQ_GT] = ACTIONS(11885),
    [anon_sym_EQ_TILDE] = ACTIONS(11885),
    [anon_sym_BANG_TILDE] = ACTIONS(11885),
    [anon_sym_LT_EQ] = ACTIONS(11877),
    [anon_sym_GT] = ACTIONS(11877),
    [anon_sym_GT_EQ] = ACTIONS(11891),
    [anon_sym_CARET] = ACTIONS(11893),
    [anon_sym_PLUS] = ACTIONS(11869),
    [anon_sym_SLASH] = ACTIONS(11871),
    [anon_sym_PERCENT] = ACTIONS(11871),
    [sym_comment] = ACTIONS(87),
  },
  [8368] = {
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(11869),
    [sym__binary_star] = ACTIONS(11871),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(11873),
    [anon_sym_STAR_STAR] = ACTIONS(11871),
    [anon_sym_AMP] = ACTIONS(11875),
    [anon_sym_LT] = ACTIONS(11877),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_RBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(11879),
    [anon_sym_DOT_DOT] = ACTIONS(11881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11883),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(11885),
    [anon_sym_AMP_AMP] = ACTIONS(11885),
    [anon_sym_LT_LT] = ACTIONS(11887),
    [anon_sym_GT_GT] = ACTIONS(11887),
    [anon_sym_EQ_EQ] = ACTIONS(11889),
    [anon_sym_BANG_EQ] = ACTIONS(11885),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11885),
    [anon_sym_LT_EQ_GT] = ACTIONS(11885),
    [anon_sym_EQ_TILDE] = ACTIONS(11885),
    [anon_sym_BANG_TILDE] = ACTIONS(11885),
    [anon_sym_LT_EQ] = ACTIONS(11877),
    [anon_sym_GT] = ACTIONS(11877),
    [anon_sym_GT_EQ] = ACTIONS(11891),
    [anon_sym_CARET] = ACTIONS(11893),
    [anon_sym_PLUS] = ACTIONS(11869),
    [anon_sym_SLASH] = ACTIONS(11871),
    [anon_sym_PERCENT] = ACTIONS(11871),
    [sym_comment] = ACTIONS(87),
  },
  [8369] = {
    [sym_heredoc_body] = STATE(8369),
    [aux_sym_call_repeat1] = STATE(8369),
    [sym__heredoc_body_start] = ACTIONS(10455),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_RBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [8370] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(3316),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1322),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(1322),
    [sym__argument] = STATE(6908),
    [sym_splat_argument] = STATE(6908),
    [sym_hash_splat_argument] = STATE(6908),
    [sym_block_argument] = STATE(6908),
    [sym_assignment] = STATE(3316),
    [sym_operator_assignment] = STATE(3316),
    [sym_conditional] = STATE(3316),
    [sym_range] = STATE(3316),
    [sym_binary] = STATE(3316),
    [sym_unary] = STATE(3316),
    [sym_left_assignment_list] = STATE(1321),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1322),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1322),
    [sym_false] = STATE(1322),
    [sym_nil] = STATE(1322),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(3319),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(6908),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(5527),
    [sym__splat_star] = ACTIONS(5529),
    [sym__unary_minus] = ACTIONS(2325),
    [sym__identifier_hash_key] = ACTIONS(5531),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11901),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5591),
    [anon_sym_defined_QMARK] = ACTIONS(2329),
    [anon_sym_not] = ACTIONS(2331),
    [anon_sym_BANG] = ACTIONS(2335),
    [anon_sym_TILDE] = ACTIONS(2335),
    [sym_constant] = ACTIONS(5533),
    [sym_identifier] = ACTIONS(5533),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8371] = {
    [sym_heredoc_body] = STATE(8369),
    [aux_sym_call_repeat1] = STATE(8369),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_RBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [8372] = {
    [aux_sym_argument_list_repeat1] = STATE(8372),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(13564),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_STAR_STAR] = ACTIONS(7925),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_RBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7925),
    [anon_sym_AMP_AMP] = ACTIONS(7925),
    [anon_sym_LT_LT] = ACTIONS(7925),
    [anon_sym_GT_GT] = ACTIONS(7925),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7925),
    [anon_sym_PLUS] = ACTIONS(7925),
    [anon_sym_SLASH] = ACTIONS(7925),
    [anon_sym_PERCENT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [8373] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9881),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(1287),
    [sym_scope_resolution] = STATE(1285),
    [sym_call] = STATE(1285),
    [sym_method_call] = STATE(1287),
    [sym_assignment] = STATE(9881),
    [sym_operator_assignment] = STATE(9881),
    [sym_conditional] = STATE(9881),
    [sym_range] = STATE(9881),
    [sym_binary] = STATE(9881),
    [sym_unary] = STATE(9881),
    [sym_left_assignment_list] = STATE(1286),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1287),
    [sym__variable] = STATE(1285),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(1287),
    [sym_false] = STATE(1287),
    [sym_nil] = STATE(1287),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(1288),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(2281),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2283),
    [anon_sym_yield] = ACTIONS(2285),
    [anon_sym_break] = ACTIONS(2287),
    [anon_sym_next] = ACTIONS(2289),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2291),
    [anon_sym_defined_QMARK] = ACTIONS(2293),
    [anon_sym_not] = ACTIONS(2295),
    [anon_sym_BANG] = ACTIONS(2297),
    [anon_sym_TILDE] = ACTIONS(2297),
    [sym_constant] = ACTIONS(2299),
    [sym_identifier] = ACTIONS(2299),
    [sym_instance_variable] = ACTIONS(2301),
    [sym_class_variable] = ACTIONS(2301),
    [sym_global_variable] = ACTIONS(2301),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2299),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2299),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8374] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(11911),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_RBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [8375] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(11905),
    [sym__binary_star] = ACTIONS(11907),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(11909),
    [anon_sym_STAR_STAR] = ACTIONS(11911),
    [anon_sym_AMP] = ACTIONS(11913),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(11915),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_RBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(11917),
    [anon_sym_DOT_DOT] = ACTIONS(11919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11921),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(11923),
    [anon_sym_AMP_AMP] = ACTIONS(11923),
    [anon_sym_LT_LT] = ACTIONS(11925),
    [anon_sym_GT_GT] = ACTIONS(11925),
    [anon_sym_EQ_EQ] = ACTIONS(11923),
    [anon_sym_BANG_EQ] = ACTIONS(11927),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11927),
    [anon_sym_LT_EQ_GT] = ACTIONS(11927),
    [anon_sym_EQ_TILDE] = ACTIONS(11927),
    [anon_sym_BANG_TILDE] = ACTIONS(11927),
    [anon_sym_LT_EQ] = ACTIONS(11915),
    [anon_sym_GT] = ACTIONS(11915),
    [anon_sym_GT_EQ] = ACTIONS(11929),
    [anon_sym_CARET] = ACTIONS(11909),
    [anon_sym_PLUS] = ACTIONS(11931),
    [anon_sym_SLASH] = ACTIONS(11911),
    [anon_sym_PERCENT] = ACTIONS(11911),
    [sym_comment] = ACTIONS(87),
  },
  [8376] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(9882),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(5994),
    [sym_scope_resolution] = STATE(5992),
    [sym_call] = STATE(5992),
    [sym_method_call] = STATE(5994),
    [sym_assignment] = STATE(9882),
    [sym_operator_assignment] = STATE(9882),
    [sym_conditional] = STATE(9882),
    [sym_range] = STATE(9882),
    [sym_binary] = STATE(9882),
    [sym_unary] = STATE(9882),
    [sym_left_assignment_list] = STATE(5993),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5994),
    [sym__variable] = STATE(5992),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(5994),
    [sym_false] = STATE(5994),
    [sym_nil] = STATE(5994),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(5995),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(9306),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(9308),
    [anon_sym_yield] = ACTIONS(9310),
    [anon_sym_break] = ACTIONS(9312),
    [anon_sym_next] = ACTIONS(9314),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(9316),
    [anon_sym_defined_QMARK] = ACTIONS(9318),
    [anon_sym_not] = ACTIONS(9320),
    [anon_sym_BANG] = ACTIONS(9322),
    [anon_sym_TILDE] = ACTIONS(9322),
    [sym_constant] = ACTIONS(9324),
    [sym_identifier] = ACTIONS(9324),
    [sym_instance_variable] = ACTIONS(9326),
    [sym_class_variable] = ACTIONS(9326),
    [sym_global_variable] = ACTIONS(9326),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(9324),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9324),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [8377] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(9883),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(5994),
    [sym_scope_resolution] = STATE(5992),
    [sym_call] = STATE(5992),
    [sym_method_call] = STATE(5994),
    [sym_assignment] = STATE(9883),
    [sym_operator_assignment] = STATE(9883),
    [sym_conditional] = STATE(9883),
    [sym_range] = STATE(9883),
    [sym_binary] = STATE(9883),
    [sym_unary] = STATE(9883),
    [sym_left_assignment_list] = STATE(5993),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5994),
    [sym__variable] = STATE(5992),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(5994),
    [sym_false] = STATE(5994),
    [sym_nil] = STATE(5994),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(5995),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(9306),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(9308),
    [anon_sym_yield] = ACTIONS(9310),
    [anon_sym_break] = ACTIONS(9312),
    [anon_sym_next] = ACTIONS(9314),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(9316),
    [anon_sym_defined_QMARK] = ACTIONS(9318),
    [anon_sym_not] = ACTIONS(9320),
    [anon_sym_BANG] = ACTIONS(9322),
    [anon_sym_TILDE] = ACTIONS(9322),
    [sym_constant] = ACTIONS(9324),
    [sym_identifier] = ACTIONS(9324),
    [sym_instance_variable] = ACTIONS(9326),
    [sym_class_variable] = ACTIONS(9326),
    [sym_global_variable] = ACTIONS(9326),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(9324),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9324),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [8378] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(9884),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(5994),
    [sym_scope_resolution] = STATE(5992),
    [sym_call] = STATE(5992),
    [sym_method_call] = STATE(5994),
    [sym_assignment] = STATE(9884),
    [sym_operator_assignment] = STATE(9884),
    [sym_conditional] = STATE(9884),
    [sym_range] = STATE(9884),
    [sym_binary] = STATE(9884),
    [sym_unary] = STATE(9884),
    [sym_left_assignment_list] = STATE(5993),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5994),
    [sym__variable] = STATE(5992),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(5994),
    [sym_false] = STATE(5994),
    [sym_nil] = STATE(5994),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(5995),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(9306),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(9308),
    [anon_sym_yield] = ACTIONS(9310),
    [anon_sym_break] = ACTIONS(9312),
    [anon_sym_next] = ACTIONS(9314),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(9316),
    [anon_sym_defined_QMARK] = ACTIONS(9318),
    [anon_sym_not] = ACTIONS(9320),
    [anon_sym_BANG] = ACTIONS(9322),
    [anon_sym_TILDE] = ACTIONS(9322),
    [sym_constant] = ACTIONS(9324),
    [sym_identifier] = ACTIONS(9324),
    [sym_instance_variable] = ACTIONS(9326),
    [sym_class_variable] = ACTIONS(9326),
    [sym_global_variable] = ACTIONS(9326),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(9324),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9324),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [8379] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(9885),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(5994),
    [sym_scope_resolution] = STATE(5992),
    [sym_call] = STATE(5992),
    [sym_method_call] = STATE(5994),
    [sym_assignment] = STATE(9885),
    [sym_operator_assignment] = STATE(9885),
    [sym_conditional] = STATE(9885),
    [sym_range] = STATE(9885),
    [sym_binary] = STATE(9885),
    [sym_unary] = STATE(9885),
    [sym_left_assignment_list] = STATE(5993),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5994),
    [sym__variable] = STATE(5992),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(5994),
    [sym_false] = STATE(5994),
    [sym_nil] = STATE(5994),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(5995),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(9306),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(9308),
    [anon_sym_yield] = ACTIONS(9310),
    [anon_sym_break] = ACTIONS(9312),
    [anon_sym_next] = ACTIONS(9314),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(9316),
    [anon_sym_defined_QMARK] = ACTIONS(9318),
    [anon_sym_not] = ACTIONS(9320),
    [anon_sym_BANG] = ACTIONS(9322),
    [anon_sym_TILDE] = ACTIONS(9322),
    [sym_constant] = ACTIONS(9324),
    [sym_identifier] = ACTIONS(9324),
    [sym_instance_variable] = ACTIONS(9326),
    [sym_class_variable] = ACTIONS(9326),
    [sym_global_variable] = ACTIONS(9326),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(9324),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9324),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [8380] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(9886),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(5994),
    [sym_scope_resolution] = STATE(5992),
    [sym_call] = STATE(5992),
    [sym_method_call] = STATE(5994),
    [sym_assignment] = STATE(9886),
    [sym_operator_assignment] = STATE(9886),
    [sym_conditional] = STATE(9886),
    [sym_range] = STATE(9886),
    [sym_binary] = STATE(9886),
    [sym_unary] = STATE(9886),
    [sym_left_assignment_list] = STATE(5993),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5994),
    [sym__variable] = STATE(5992),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(5994),
    [sym_false] = STATE(5994),
    [sym_nil] = STATE(5994),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(5995),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(9306),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(9308),
    [anon_sym_yield] = ACTIONS(9310),
    [anon_sym_break] = ACTIONS(9312),
    [anon_sym_next] = ACTIONS(9314),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(9316),
    [anon_sym_defined_QMARK] = ACTIONS(9318),
    [anon_sym_not] = ACTIONS(9320),
    [anon_sym_BANG] = ACTIONS(9322),
    [anon_sym_TILDE] = ACTIONS(9322),
    [sym_constant] = ACTIONS(9324),
    [sym_identifier] = ACTIONS(9324),
    [sym_instance_variable] = ACTIONS(9326),
    [sym_class_variable] = ACTIONS(9326),
    [sym_global_variable] = ACTIONS(9326),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(9324),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9324),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [8381] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(9887),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(9887),
    [sym_operator_assignment] = STATE(9887),
    [sym_conditional] = STATE(9887),
    [sym_range] = STATE(9887),
    [sym_binary] = STATE(9887),
    [sym_unary] = STATE(9887),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8382] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(9888),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(5994),
    [sym_scope_resolution] = STATE(5992),
    [sym_call] = STATE(5992),
    [sym_method_call] = STATE(5994),
    [sym_assignment] = STATE(9888),
    [sym_operator_assignment] = STATE(9888),
    [sym_conditional] = STATE(9888),
    [sym_range] = STATE(9888),
    [sym_binary] = STATE(9888),
    [sym_unary] = STATE(9888),
    [sym_left_assignment_list] = STATE(5993),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5994),
    [sym__variable] = STATE(5992),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(5994),
    [sym_false] = STATE(5994),
    [sym_nil] = STATE(5994),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(5995),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(9306),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(9308),
    [anon_sym_yield] = ACTIONS(9310),
    [anon_sym_break] = ACTIONS(9312),
    [anon_sym_next] = ACTIONS(9314),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(9316),
    [anon_sym_defined_QMARK] = ACTIONS(9318),
    [anon_sym_not] = ACTIONS(9320),
    [anon_sym_BANG] = ACTIONS(9322),
    [anon_sym_TILDE] = ACTIONS(9322),
    [sym_constant] = ACTIONS(9324),
    [sym_identifier] = ACTIONS(9324),
    [sym_instance_variable] = ACTIONS(9326),
    [sym_class_variable] = ACTIONS(9326),
    [sym_global_variable] = ACTIONS(9326),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(9324),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9324),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [8383] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(9889),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(5994),
    [sym_scope_resolution] = STATE(5992),
    [sym_call] = STATE(5992),
    [sym_method_call] = STATE(5994),
    [sym_assignment] = STATE(9889),
    [sym_operator_assignment] = STATE(9889),
    [sym_conditional] = STATE(9889),
    [sym_range] = STATE(9889),
    [sym_binary] = STATE(9889),
    [sym_unary] = STATE(9889),
    [sym_left_assignment_list] = STATE(5993),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5994),
    [sym__variable] = STATE(5992),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(5994),
    [sym_false] = STATE(5994),
    [sym_nil] = STATE(5994),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(5995),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(9306),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(9308),
    [anon_sym_yield] = ACTIONS(9310),
    [anon_sym_break] = ACTIONS(9312),
    [anon_sym_next] = ACTIONS(9314),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(9316),
    [anon_sym_defined_QMARK] = ACTIONS(9318),
    [anon_sym_not] = ACTIONS(9320),
    [anon_sym_BANG] = ACTIONS(9322),
    [anon_sym_TILDE] = ACTIONS(9322),
    [sym_constant] = ACTIONS(9324),
    [sym_identifier] = ACTIONS(9324),
    [sym_instance_variable] = ACTIONS(9326),
    [sym_class_variable] = ACTIONS(9326),
    [sym_global_variable] = ACTIONS(9326),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(9324),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9324),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [8384] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(9890),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(5994),
    [sym_scope_resolution] = STATE(5992),
    [sym_call] = STATE(5992),
    [sym_method_call] = STATE(5994),
    [sym_assignment] = STATE(9890),
    [sym_operator_assignment] = STATE(9890),
    [sym_conditional] = STATE(9890),
    [sym_range] = STATE(9890),
    [sym_binary] = STATE(9890),
    [sym_unary] = STATE(9890),
    [sym_left_assignment_list] = STATE(5993),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5994),
    [sym__variable] = STATE(5992),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(5994),
    [sym_false] = STATE(5994),
    [sym_nil] = STATE(5994),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(5995),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(9306),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(9308),
    [anon_sym_yield] = ACTIONS(9310),
    [anon_sym_break] = ACTIONS(9312),
    [anon_sym_next] = ACTIONS(9314),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(9316),
    [anon_sym_defined_QMARK] = ACTIONS(9318),
    [anon_sym_not] = ACTIONS(9320),
    [anon_sym_BANG] = ACTIONS(9322),
    [anon_sym_TILDE] = ACTIONS(9322),
    [sym_constant] = ACTIONS(9324),
    [sym_identifier] = ACTIONS(9324),
    [sym_instance_variable] = ACTIONS(9326),
    [sym_class_variable] = ACTIONS(9326),
    [sym_global_variable] = ACTIONS(9326),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(9324),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9324),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [8385] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(9891),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(5994),
    [sym_scope_resolution] = STATE(5992),
    [sym_call] = STATE(5992),
    [sym_method_call] = STATE(5994),
    [sym_assignment] = STATE(9891),
    [sym_operator_assignment] = STATE(9891),
    [sym_conditional] = STATE(9891),
    [sym_range] = STATE(9891),
    [sym_binary] = STATE(9891),
    [sym_unary] = STATE(9891),
    [sym_left_assignment_list] = STATE(5993),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5994),
    [sym__variable] = STATE(5992),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(5994),
    [sym_false] = STATE(5994),
    [sym_nil] = STATE(5994),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(5995),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(9306),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(9308),
    [anon_sym_yield] = ACTIONS(9310),
    [anon_sym_break] = ACTIONS(9312),
    [anon_sym_next] = ACTIONS(9314),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(9316),
    [anon_sym_defined_QMARK] = ACTIONS(9318),
    [anon_sym_not] = ACTIONS(9320),
    [anon_sym_BANG] = ACTIONS(9322),
    [anon_sym_TILDE] = ACTIONS(9322),
    [sym_constant] = ACTIONS(9324),
    [sym_identifier] = ACTIONS(9324),
    [sym_instance_variable] = ACTIONS(9326),
    [sym_class_variable] = ACTIONS(9326),
    [sym_global_variable] = ACTIONS(9326),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(9324),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9324),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [8386] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(9892),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(5994),
    [sym_scope_resolution] = STATE(5992),
    [sym_call] = STATE(5992),
    [sym_method_call] = STATE(5994),
    [sym_splat_argument] = STATE(9893),
    [sym_assignment] = STATE(9892),
    [sym_operator_assignment] = STATE(9892),
    [sym_conditional] = STATE(9892),
    [sym_range] = STATE(9892),
    [sym_binary] = STATE(9892),
    [sym_unary] = STATE(9892),
    [sym_right_assignment_list] = STATE(8878),
    [sym__arg_or_splat_arg] = STATE(9893),
    [sym_left_assignment_list] = STATE(5993),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5994),
    [sym__variable] = STATE(5992),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(5994),
    [sym_false] = STATE(5994),
    [sym_nil] = STATE(5994),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(5995),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__splat_star] = ACTIONS(5565),
    [sym__unary_minus] = ACTIONS(9306),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(9308),
    [anon_sym_yield] = ACTIONS(9310),
    [anon_sym_break] = ACTIONS(9312),
    [anon_sym_next] = ACTIONS(9314),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(9316),
    [anon_sym_defined_QMARK] = ACTIONS(9318),
    [anon_sym_not] = ACTIONS(9320),
    [anon_sym_BANG] = ACTIONS(9322),
    [anon_sym_TILDE] = ACTIONS(9322),
    [sym_constant] = ACTIONS(9324),
    [sym_identifier] = ACTIONS(9324),
    [sym_instance_variable] = ACTIONS(9326),
    [sym_class_variable] = ACTIONS(9326),
    [sym_global_variable] = ACTIONS(9326),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(9324),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9324),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [8387] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(9894),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(5994),
    [sym_scope_resolution] = STATE(5992),
    [sym_call] = STATE(5992),
    [sym_method_call] = STATE(5994),
    [sym_assignment] = STATE(9894),
    [sym_operator_assignment] = STATE(9894),
    [sym_conditional] = STATE(9894),
    [sym_range] = STATE(9894),
    [sym_binary] = STATE(9894),
    [sym_unary] = STATE(9894),
    [sym_left_assignment_list] = STATE(5993),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5994),
    [sym__variable] = STATE(5992),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(5994),
    [sym_false] = STATE(5994),
    [sym_nil] = STATE(5994),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(5995),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(9306),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(9308),
    [anon_sym_yield] = ACTIONS(9310),
    [anon_sym_break] = ACTIONS(9312),
    [anon_sym_next] = ACTIONS(9314),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(9316),
    [anon_sym_defined_QMARK] = ACTIONS(9318),
    [anon_sym_not] = ACTIONS(9320),
    [anon_sym_BANG] = ACTIONS(9322),
    [anon_sym_TILDE] = ACTIONS(9322),
    [sym_constant] = ACTIONS(9324),
    [sym_identifier] = ACTIONS(9324),
    [sym_instance_variable] = ACTIONS(9326),
    [sym_class_variable] = ACTIONS(9326),
    [sym_global_variable] = ACTIONS(9326),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(9324),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9324),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [8388] = {
    [sym_string] = STATE(9895),
    [aux_sym_chained_string_repeat1] = STATE(9895),
    [sym__string_start] = ACTIONS(6455),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_STAR_STAR] = ACTIONS(2755),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_EQ] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_RBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_PLUS_EQ] = ACTIONS(2753),
    [anon_sym_DASH_EQ] = ACTIONS(2753),
    [anon_sym_STAR_EQ] = ACTIONS(2753),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2753),
    [anon_sym_SLASH_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2753),
    [anon_sym_AMP_EQ] = ACTIONS(2753),
    [anon_sym_PERCENT_EQ] = ACTIONS(2753),
    [anon_sym_GT_GT_EQ] = ACTIONS(2753),
    [anon_sym_LT_LT_EQ] = ACTIONS(2753),
    [anon_sym_CARET_EQ] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2755),
    [anon_sym_AMP_AMP] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2755),
    [anon_sym_GT_GT] = ACTIONS(2755),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_SLASH] = ACTIONS(2755),
    [anon_sym_PERCENT] = ACTIONS(2755),
    [sym_comment] = ACTIONS(87),
  },
  [8389] = {
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(11905),
    [sym__binary_star] = ACTIONS(11907),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(11909),
    [anon_sym_STAR_STAR] = ACTIONS(11911),
    [anon_sym_AMP] = ACTIONS(11913),
    [anon_sym_EQ] = ACTIONS(7822),
    [anon_sym_LT] = ACTIONS(11915),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_RBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_PLUS_EQ] = ACTIONS(6823),
    [anon_sym_DASH_EQ] = ACTIONS(6823),
    [anon_sym_STAR_EQ] = ACTIONS(6823),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6823),
    [anon_sym_SLASH_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6823),
    [anon_sym_AMP_EQ] = ACTIONS(6823),
    [anon_sym_PERCENT_EQ] = ACTIONS(6823),
    [anon_sym_GT_GT_EQ] = ACTIONS(6823),
    [anon_sym_LT_LT_EQ] = ACTIONS(6823),
    [anon_sym_CARET_EQ] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(11917),
    [anon_sym_DOT_DOT] = ACTIONS(11919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11921),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(11923),
    [anon_sym_AMP_AMP] = ACTIONS(11923),
    [anon_sym_LT_LT] = ACTIONS(11925),
    [anon_sym_GT_GT] = ACTIONS(11925),
    [anon_sym_EQ_EQ] = ACTIONS(11923),
    [anon_sym_BANG_EQ] = ACTIONS(11927),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11927),
    [anon_sym_LT_EQ_GT] = ACTIONS(11927),
    [anon_sym_EQ_TILDE] = ACTIONS(11927),
    [anon_sym_BANG_TILDE] = ACTIONS(11927),
    [anon_sym_LT_EQ] = ACTIONS(11915),
    [anon_sym_GT] = ACTIONS(11915),
    [anon_sym_GT_EQ] = ACTIONS(11929),
    [anon_sym_CARET] = ACTIONS(11909),
    [anon_sym_PLUS] = ACTIONS(11931),
    [anon_sym_SLASH] = ACTIONS(11911),
    [anon_sym_PERCENT] = ACTIONS(11911),
    [sym_comment] = ACTIONS(87),
  },
  [8390] = {
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(11905),
    [sym__binary_star] = ACTIONS(11907),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(11909),
    [anon_sym_STAR_STAR] = ACTIONS(11911),
    [anon_sym_AMP] = ACTIONS(11913),
    [anon_sym_EQ] = ACTIONS(7884),
    [anon_sym_LT] = ACTIONS(11915),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_RBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_PLUS_EQ] = ACTIONS(7027),
    [anon_sym_DASH_EQ] = ACTIONS(7027),
    [anon_sym_STAR_EQ] = ACTIONS(7027),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7027),
    [anon_sym_SLASH_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7027),
    [anon_sym_AMP_EQ] = ACTIONS(7027),
    [anon_sym_PERCENT_EQ] = ACTIONS(7027),
    [anon_sym_GT_GT_EQ] = ACTIONS(7027),
    [anon_sym_LT_LT_EQ] = ACTIONS(7027),
    [anon_sym_CARET_EQ] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(11917),
    [anon_sym_DOT_DOT] = ACTIONS(11919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11921),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(11923),
    [anon_sym_AMP_AMP] = ACTIONS(11923),
    [anon_sym_LT_LT] = ACTIONS(11925),
    [anon_sym_GT_GT] = ACTIONS(11925),
    [anon_sym_EQ_EQ] = ACTIONS(11923),
    [anon_sym_BANG_EQ] = ACTIONS(11927),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11927),
    [anon_sym_LT_EQ_GT] = ACTIONS(11927),
    [anon_sym_EQ_TILDE] = ACTIONS(11927),
    [anon_sym_BANG_TILDE] = ACTIONS(11927),
    [anon_sym_LT_EQ] = ACTIONS(11915),
    [anon_sym_GT] = ACTIONS(11915),
    [anon_sym_GT_EQ] = ACTIONS(11929),
    [anon_sym_CARET] = ACTIONS(11909),
    [anon_sym_PLUS] = ACTIONS(11931),
    [anon_sym_SLASH] = ACTIONS(11911),
    [anon_sym_PERCENT] = ACTIONS(11911),
    [sym_comment] = ACTIONS(87),
  },
  [8391] = {
    [sym_heredoc_body] = STATE(8391),
    [aux_sym_call_repeat1] = STATE(8391),
    [sym__heredoc_body_start] = ACTIONS(12549),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_STAR_STAR] = ACTIONS(7919),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_EQ] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_RBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_PLUS_EQ] = ACTIONS(7914),
    [anon_sym_DASH_EQ] = ACTIONS(7914),
    [anon_sym_STAR_EQ] = ACTIONS(7914),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7914),
    [anon_sym_SLASH_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7914),
    [anon_sym_AMP_EQ] = ACTIONS(7914),
    [anon_sym_PERCENT_EQ] = ACTIONS(7914),
    [anon_sym_GT_GT_EQ] = ACTIONS(7914),
    [anon_sym_LT_LT_EQ] = ACTIONS(7914),
    [anon_sym_CARET_EQ] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7919),
    [anon_sym_AMP_AMP] = ACTIONS(7919),
    [anon_sym_LT_LT] = ACTIONS(7919),
    [anon_sym_GT_GT] = ACTIONS(7919),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7919),
    [anon_sym_PLUS] = ACTIONS(7919),
    [anon_sym_SLASH] = ACTIONS(7919),
    [anon_sym_PERCENT] = ACTIONS(7919),
    [sym_comment] = ACTIONS(87),
  },
  [8392] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3336),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1384),
    [sym_scope_resolution] = STATE(1378),
    [sym_call] = STATE(1378),
    [sym_method_call] = STATE(1384),
    [sym__argument] = STATE(8888),
    [sym_splat_argument] = STATE(8888),
    [sym_hash_splat_argument] = STATE(8888),
    [sym_block_argument] = STATE(8888),
    [sym_assignment] = STATE(3336),
    [sym_operator_assignment] = STATE(3336),
    [sym_conditional] = STATE(3336),
    [sym_range] = STATE(3336),
    [sym_binary] = STATE(3336),
    [sym_unary] = STATE(3336),
    [sym_left_assignment_list] = STATE(1383),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1384),
    [sym__variable] = STATE(1378),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1384),
    [sym_false] = STATE(1384),
    [sym_nil] = STATE(1384),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3339),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(8888),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(5563),
    [sym__splat_star] = ACTIONS(5565),
    [sym__unary_minus] = ACTIONS(2399),
    [sym__identifier_hash_key] = ACTIONS(5567),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11939),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2405),
    [anon_sym_yield] = ACTIONS(2407),
    [anon_sym_break] = ACTIONS(2409),
    [anon_sym_next] = ACTIONS(2411),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(5673),
    [anon_sym_defined_QMARK] = ACTIONS(2415),
    [anon_sym_not] = ACTIONS(2417),
    [anon_sym_BANG] = ACTIONS(2421),
    [anon_sym_TILDE] = ACTIONS(2421),
    [sym_constant] = ACTIONS(5569),
    [sym_identifier] = ACTIONS(5569),
    [sym_instance_variable] = ACTIONS(2425),
    [sym_class_variable] = ACTIONS(2425),
    [sym_global_variable] = ACTIONS(2425),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2427),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2427),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [8393] = {
    [sym_heredoc_body] = STATE(8391),
    [aux_sym_call_repeat1] = STATE(8391),
    [sym__heredoc_body_start] = ACTIONS(6569),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_STAR_STAR] = ACTIONS(7931),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_EQ] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_RBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_PLUS_EQ] = ACTIONS(7929),
    [anon_sym_DASH_EQ] = ACTIONS(7929),
    [anon_sym_STAR_EQ] = ACTIONS(7929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7929),
    [anon_sym_SLASH_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7929),
    [anon_sym_AMP_EQ] = ACTIONS(7929),
    [anon_sym_PERCENT_EQ] = ACTIONS(7929),
    [anon_sym_GT_GT_EQ] = ACTIONS(7929),
    [anon_sym_LT_LT_EQ] = ACTIONS(7929),
    [anon_sym_CARET_EQ] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7931),
    [anon_sym_AMP_AMP] = ACTIONS(7931),
    [anon_sym_LT_LT] = ACTIONS(7931),
    [anon_sym_GT_GT] = ACTIONS(7931),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7931),
    [anon_sym_PLUS] = ACTIONS(7931),
    [anon_sym_SLASH] = ACTIONS(7931),
    [anon_sym_PERCENT] = ACTIONS(7931),
    [sym_comment] = ACTIONS(87),
  },
  [8394] = {
    [aux_sym_argument_list_repeat1] = STATE(8394),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(13567),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_STAR_STAR] = ACTIONS(7927),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_EQ] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_RBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_PLUS_EQ] = ACTIONS(7925),
    [anon_sym_DASH_EQ] = ACTIONS(7925),
    [anon_sym_STAR_EQ] = ACTIONS(7925),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7925),
    [anon_sym_SLASH_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7925),
    [anon_sym_AMP_EQ] = ACTIONS(7925),
    [anon_sym_PERCENT_EQ] = ACTIONS(7925),
    [anon_sym_GT_GT_EQ] = ACTIONS(7925),
    [anon_sym_LT_LT_EQ] = ACTIONS(7925),
    [anon_sym_CARET_EQ] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7927),
    [anon_sym_AMP_AMP] = ACTIONS(7927),
    [anon_sym_LT_LT] = ACTIONS(7927),
    [anon_sym_GT_GT] = ACTIONS(7927),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7927),
    [anon_sym_PLUS] = ACTIONS(7927),
    [anon_sym_SLASH] = ACTIONS(7927),
    [anon_sym_PERCENT] = ACTIONS(7927),
    [sym_comment] = ACTIONS(87),
  },
  [8395] = {
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(5535),
    [sym__binary_star] = ACTIONS(5537),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5537),
    [anon_sym_AMP] = ACTIONS(5541),
    [anon_sym_LT] = ACTIONS(5543),
    [anon_sym_RBRACK] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(5545),
    [anon_sym_DOT_DOT] = ACTIONS(5547),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5549),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(5553),
    [anon_sym_AMP_AMP] = ACTIONS(5553),
    [anon_sym_LT_LT] = ACTIONS(5555),
    [anon_sym_GT_GT] = ACTIONS(5555),
    [anon_sym_EQ_EQ] = ACTIONS(5557),
    [anon_sym_BANG_EQ] = ACTIONS(5553),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5553),
    [anon_sym_LT_EQ_GT] = ACTIONS(5553),
    [anon_sym_EQ_TILDE] = ACTIONS(5553),
    [anon_sym_BANG_TILDE] = ACTIONS(5553),
    [anon_sym_LT_EQ] = ACTIONS(5543),
    [anon_sym_GT] = ACTIONS(5543),
    [anon_sym_GT_EQ] = ACTIONS(5559),
    [anon_sym_CARET] = ACTIONS(5561),
    [anon_sym_PLUS] = ACTIONS(5535),
    [anon_sym_SLASH] = ACTIONS(5537),
    [anon_sym_PERCENT] = ACTIONS(5537),
    [sym_comment] = ACTIONS(87),
  },
  [8396] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(6004),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(1287),
    [sym_scope_resolution] = STATE(1285),
    [sym_call] = STATE(1285),
    [sym_method_call] = STATE(1287),
    [sym_splat_argument] = STATE(8429),
    [sym_assignment] = STATE(6004),
    [sym_operator_assignment] = STATE(6004),
    [sym_conditional] = STATE(6004),
    [sym_range] = STATE(6004),
    [sym_binary] = STATE(6004),
    [sym_unary] = STATE(6004),
    [sym__arg_or_splat_arg] = STATE(8429),
    [sym_left_assignment_list] = STATE(1286),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1287),
    [sym__variable] = STATE(1285),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(1287),
    [sym_false] = STATE(1287),
    [sym_nil] = STATE(1287),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(1288),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(9336),
    [sym__unary_minus] = ACTIONS(2281),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2283),
    [anon_sym_yield] = ACTIONS(2285),
    [anon_sym_break] = ACTIONS(2287),
    [anon_sym_next] = ACTIONS(2289),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2291),
    [anon_sym_defined_QMARK] = ACTIONS(2293),
    [anon_sym_not] = ACTIONS(2295),
    [anon_sym_BANG] = ACTIONS(2297),
    [anon_sym_TILDE] = ACTIONS(2297),
    [sym_constant] = ACTIONS(2299),
    [sym_identifier] = ACTIONS(2299),
    [sym_instance_variable] = ACTIONS(2301),
    [sym_class_variable] = ACTIONS(2301),
    [sym_global_variable] = ACTIONS(2301),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2299),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2299),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8397] = {
    [aux_sym_exceptions_repeat1] = STATE(9896),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_COMMA] = ACTIONS(13570),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_RBRACK] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [8398] = {
    [sym__method_rest] = STATE(9897),
    [sym_operator] = STATE(1299),
    [sym__method_name] = STATE(1299),
    [sym_setter] = STATE(1299),
    [sym_symbol] = STATE(1299),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(9342),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(9342),
    [sym_class_variable] = ACTIONS(9342),
    [sym_global_variable] = ACTIONS(9342),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [8399] = {
    [sym__heredoc_body_start] = ACTIONS(10927),
    [sym__binary_minus] = ACTIONS(10927),
    [sym__binary_star] = ACTIONS(10927),
    [anon_sym_LBRACE] = ACTIONS(10927),
    [anon_sym_RBRACE] = ACTIONS(10927),
    [anon_sym_RPAREN] = ACTIONS(10927),
    [anon_sym_DOT] = ACTIONS(10929),
    [anon_sym_COMMA] = ACTIONS(10927),
    [anon_sym_PIPE] = ACTIONS(10929),
    [anon_sym_SEMI] = ACTIONS(10927),
    [anon_sym_STAR_STAR] = ACTIONS(10927),
    [anon_sym_AMP] = ACTIONS(10929),
    [anon_sym_EQ] = ACTIONS(10929),
    [anon_sym_LT] = ACTIONS(10929),
    [anon_sym_if] = ACTIONS(10927),
    [anon_sym_unless] = ACTIONS(10927),
    [anon_sym_while] = ACTIONS(10927),
    [anon_sym_until] = ACTIONS(10927),
    [anon_sym_rescue] = ACTIONS(10927),
    [anon_sym_in] = ACTIONS(10927),
    [anon_sym_do] = ACTIONS(10927),
    [anon_sym_EQ_GT] = ACTIONS(10927),
    [anon_sym_LBRACK] = ACTIONS(10927),
    [anon_sym_RBRACK] = ACTIONS(10927),
    [anon_sym_COLON_COLON2] = ACTIONS(10927),
    [anon_sym_AMP_DOT] = ACTIONS(10927),
    [anon_sym_QMARK] = ACTIONS(10927),
    [anon_sym_COLON2] = ACTIONS(10929),
    [anon_sym_DOT_DOT] = ACTIONS(10929),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10927),
    [anon_sym_and] = ACTIONS(10927),
    [anon_sym_or] = ACTIONS(10927),
    [anon_sym_PIPE_PIPE] = ACTIONS(10927),
    [anon_sym_AMP_AMP] = ACTIONS(10927),
    [anon_sym_LT_LT] = ACTIONS(10927),
    [anon_sym_GT_GT] = ACTIONS(10927),
    [anon_sym_EQ_EQ] = ACTIONS(10929),
    [anon_sym_BANG_EQ] = ACTIONS(10927),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10927),
    [anon_sym_LT_EQ_GT] = ACTIONS(10927),
    [anon_sym_EQ_TILDE] = ACTIONS(10927),
    [anon_sym_BANG_TILDE] = ACTIONS(10927),
    [anon_sym_LT_EQ] = ACTIONS(10929),
    [anon_sym_GT] = ACTIONS(10929),
    [anon_sym_GT_EQ] = ACTIONS(10927),
    [anon_sym_CARET] = ACTIONS(10927),
    [anon_sym_PLUS] = ACTIONS(10927),
    [anon_sym_SLASH] = ACTIONS(10927),
    [anon_sym_PERCENT] = ACTIONS(10927),
    [sym_comment] = ACTIONS(87),
  },
  [8400] = {
    [sym__heredoc_body_start] = ACTIONS(10931),
    [sym__binary_minus] = ACTIONS(10931),
    [sym__binary_star] = ACTIONS(10931),
    [anon_sym_LBRACE] = ACTIONS(10931),
    [anon_sym_RBRACE] = ACTIONS(10931),
    [anon_sym_RPAREN] = ACTIONS(10931),
    [anon_sym_DOT] = ACTIONS(10933),
    [anon_sym_COMMA] = ACTIONS(10931),
    [anon_sym_PIPE] = ACTIONS(10933),
    [anon_sym_SEMI] = ACTIONS(10931),
    [anon_sym_STAR_STAR] = ACTIONS(10931),
    [anon_sym_AMP] = ACTIONS(10933),
    [anon_sym_EQ] = ACTIONS(10933),
    [anon_sym_LT] = ACTIONS(10933),
    [anon_sym_if] = ACTIONS(10931),
    [anon_sym_unless] = ACTIONS(10931),
    [anon_sym_while] = ACTIONS(10931),
    [anon_sym_until] = ACTIONS(10931),
    [anon_sym_rescue] = ACTIONS(10931),
    [anon_sym_in] = ACTIONS(10931),
    [anon_sym_do] = ACTIONS(10931),
    [anon_sym_EQ_GT] = ACTIONS(10931),
    [anon_sym_LBRACK] = ACTIONS(10931),
    [anon_sym_RBRACK] = ACTIONS(10931),
    [anon_sym_COLON_COLON2] = ACTIONS(10931),
    [anon_sym_AMP_DOT] = ACTIONS(10931),
    [anon_sym_QMARK] = ACTIONS(10931),
    [anon_sym_COLON2] = ACTIONS(10933),
    [anon_sym_DOT_DOT] = ACTIONS(10933),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10931),
    [anon_sym_and] = ACTIONS(10931),
    [anon_sym_or] = ACTIONS(10931),
    [anon_sym_PIPE_PIPE] = ACTIONS(10931),
    [anon_sym_AMP_AMP] = ACTIONS(10931),
    [anon_sym_LT_LT] = ACTIONS(10931),
    [anon_sym_GT_GT] = ACTIONS(10931),
    [anon_sym_EQ_EQ] = ACTIONS(10933),
    [anon_sym_BANG_EQ] = ACTIONS(10931),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10931),
    [anon_sym_LT_EQ_GT] = ACTIONS(10931),
    [anon_sym_EQ_TILDE] = ACTIONS(10931),
    [anon_sym_BANG_TILDE] = ACTIONS(10931),
    [anon_sym_LT_EQ] = ACTIONS(10933),
    [anon_sym_GT] = ACTIONS(10933),
    [anon_sym_GT_EQ] = ACTIONS(10931),
    [anon_sym_CARET] = ACTIONS(10931),
    [anon_sym_PLUS] = ACTIONS(10931),
    [anon_sym_SLASH] = ACTIONS(10931),
    [anon_sym_PERCENT] = ACTIONS(10931),
    [sym_comment] = ACTIONS(87),
  },
  [8401] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(9898),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1322),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(1322),
    [sym_assignment] = STATE(9898),
    [sym_operator_assignment] = STATE(9898),
    [sym_conditional] = STATE(9898),
    [sym_range] = STATE(9898),
    [sym_binary] = STATE(9898),
    [sym_unary] = STATE(9898),
    [sym_left_assignment_list] = STATE(1321),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1322),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1322),
    [sym_false] = STATE(1322),
    [sym_nil] = STATE(1322),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1291),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2325),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5591),
    [anon_sym_defined_QMARK] = ACTIONS(2329),
    [anon_sym_not] = ACTIONS(2331),
    [anon_sym_BANG] = ACTIONS(2335),
    [anon_sym_TILDE] = ACTIONS(2335),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8402] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(6032),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1322),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(1322),
    [sym_splat_argument] = STATE(9013),
    [sym_assignment] = STATE(6032),
    [sym_operator_assignment] = STATE(6032),
    [sym_conditional] = STATE(6032),
    [sym_range] = STATE(6032),
    [sym_binary] = STATE(6032),
    [sym_unary] = STATE(6032),
    [sym__arg_or_splat_arg] = STATE(9013),
    [sym_left_assignment_list] = STATE(1321),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1322),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1322),
    [sym_false] = STATE(1322),
    [sym_nil] = STATE(1322),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(1291),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(2323),
    [sym__unary_minus] = ACTIONS(2325),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5591),
    [anon_sym_defined_QMARK] = ACTIONS(2329),
    [anon_sym_not] = ACTIONS(2331),
    [anon_sym_BANG] = ACTIONS(2335),
    [anon_sym_TILDE] = ACTIONS(2335),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8403] = {
    [aux_sym_exceptions_repeat1] = STATE(9899),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(13572),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_EQ_GT] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_RBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [8404] = {
    [sym__heredoc_body_start] = ACTIONS(11157),
    [sym__binary_minus] = ACTIONS(11157),
    [sym__binary_star] = ACTIONS(11157),
    [anon_sym_LBRACE] = ACTIONS(11157),
    [anon_sym_RBRACE] = ACTIONS(11157),
    [anon_sym_RPAREN] = ACTIONS(11157),
    [anon_sym_DOT] = ACTIONS(11159),
    [anon_sym_COMMA] = ACTIONS(11157),
    [anon_sym_PIPE] = ACTIONS(11159),
    [anon_sym_SEMI] = ACTIONS(11157),
    [anon_sym_STAR_STAR] = ACTIONS(11157),
    [anon_sym_AMP] = ACTIONS(11159),
    [anon_sym_EQ] = ACTIONS(11159),
    [anon_sym_LT] = ACTIONS(11159),
    [anon_sym_if] = ACTIONS(11157),
    [anon_sym_unless] = ACTIONS(11157),
    [anon_sym_while] = ACTIONS(11157),
    [anon_sym_until] = ACTIONS(11157),
    [anon_sym_rescue] = ACTIONS(11157),
    [anon_sym_in] = ACTIONS(11157),
    [anon_sym_do] = ACTIONS(11157),
    [anon_sym_EQ_GT] = ACTIONS(11157),
    [anon_sym_LBRACK] = ACTIONS(11157),
    [anon_sym_RBRACK] = ACTIONS(11157),
    [anon_sym_COLON_COLON2] = ACTIONS(11157),
    [anon_sym_AMP_DOT] = ACTIONS(11157),
    [anon_sym_QMARK] = ACTIONS(11157),
    [anon_sym_COLON2] = ACTIONS(11159),
    [anon_sym_DOT_DOT] = ACTIONS(11159),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11157),
    [anon_sym_and] = ACTIONS(11157),
    [anon_sym_or] = ACTIONS(11157),
    [anon_sym_PIPE_PIPE] = ACTIONS(11157),
    [anon_sym_AMP_AMP] = ACTIONS(11157),
    [anon_sym_LT_LT] = ACTIONS(11157),
    [anon_sym_GT_GT] = ACTIONS(11157),
    [anon_sym_EQ_EQ] = ACTIONS(11159),
    [anon_sym_BANG_EQ] = ACTIONS(11157),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11157),
    [anon_sym_LT_EQ_GT] = ACTIONS(11157),
    [anon_sym_EQ_TILDE] = ACTIONS(11157),
    [anon_sym_BANG_TILDE] = ACTIONS(11157),
    [anon_sym_LT_EQ] = ACTIONS(11159),
    [anon_sym_GT] = ACTIONS(11159),
    [anon_sym_GT_EQ] = ACTIONS(11157),
    [anon_sym_CARET] = ACTIONS(11157),
    [anon_sym_PLUS] = ACTIONS(11157),
    [anon_sym_SLASH] = ACTIONS(11157),
    [anon_sym_PERCENT] = ACTIONS(11157),
    [sym_comment] = ACTIONS(87),
  },
  [8405] = {
    [sym__heredoc_body_start] = ACTIONS(11322),
    [sym__binary_minus] = ACTIONS(11322),
    [sym__binary_star] = ACTIONS(11322),
    [anon_sym_LBRACE] = ACTIONS(11322),
    [anon_sym_RBRACE] = ACTIONS(11322),
    [anon_sym_RPAREN] = ACTIONS(11322),
    [anon_sym_DOT] = ACTIONS(11324),
    [anon_sym_COMMA] = ACTIONS(11322),
    [anon_sym_PIPE] = ACTIONS(11324),
    [anon_sym_SEMI] = ACTIONS(11322),
    [anon_sym_STAR_STAR] = ACTIONS(11322),
    [anon_sym_AMP] = ACTIONS(11324),
    [anon_sym_EQ] = ACTIONS(11324),
    [anon_sym_LT] = ACTIONS(11324),
    [anon_sym_if] = ACTIONS(11322),
    [anon_sym_unless] = ACTIONS(11322),
    [anon_sym_while] = ACTIONS(11322),
    [anon_sym_until] = ACTIONS(11322),
    [anon_sym_rescue] = ACTIONS(11322),
    [anon_sym_in] = ACTIONS(11322),
    [anon_sym_do] = ACTIONS(11322),
    [anon_sym_EQ_GT] = ACTIONS(11322),
    [anon_sym_LBRACK] = ACTIONS(11322),
    [anon_sym_RBRACK] = ACTIONS(11322),
    [anon_sym_COLON_COLON2] = ACTIONS(11322),
    [anon_sym_AMP_DOT] = ACTIONS(11322),
    [anon_sym_QMARK] = ACTIONS(11322),
    [anon_sym_COLON2] = ACTIONS(11324),
    [anon_sym_DOT_DOT] = ACTIONS(11324),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11322),
    [anon_sym_and] = ACTIONS(11322),
    [anon_sym_or] = ACTIONS(11322),
    [anon_sym_PIPE_PIPE] = ACTIONS(11322),
    [anon_sym_AMP_AMP] = ACTIONS(11322),
    [anon_sym_LT_LT] = ACTIONS(11322),
    [anon_sym_GT_GT] = ACTIONS(11322),
    [anon_sym_EQ_EQ] = ACTIONS(11324),
    [anon_sym_BANG_EQ] = ACTIONS(11322),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11322),
    [anon_sym_LT_EQ_GT] = ACTIONS(11322),
    [anon_sym_EQ_TILDE] = ACTIONS(11322),
    [anon_sym_BANG_TILDE] = ACTIONS(11322),
    [anon_sym_LT_EQ] = ACTIONS(11324),
    [anon_sym_GT] = ACTIONS(11324),
    [anon_sym_GT_EQ] = ACTIONS(11322),
    [anon_sym_CARET] = ACTIONS(11322),
    [anon_sym_PLUS] = ACTIONS(11322),
    [anon_sym_SLASH] = ACTIONS(11322),
    [anon_sym_PERCENT] = ACTIONS(11322),
    [sym_comment] = ACTIONS(87),
  },
  [8406] = {
    [sym__heredoc_body_start] = ACTIONS(11335),
    [sym__binary_minus] = ACTIONS(11335),
    [sym__binary_star] = ACTIONS(11335),
    [anon_sym_LBRACE] = ACTIONS(11335),
    [anon_sym_RBRACE] = ACTIONS(11335),
    [anon_sym_RPAREN] = ACTIONS(11335),
    [anon_sym_DOT] = ACTIONS(11337),
    [anon_sym_COMMA] = ACTIONS(11335),
    [anon_sym_PIPE] = ACTIONS(11337),
    [anon_sym_SEMI] = ACTIONS(11335),
    [anon_sym_STAR_STAR] = ACTIONS(11335),
    [anon_sym_AMP] = ACTIONS(11337),
    [anon_sym_EQ] = ACTIONS(11337),
    [anon_sym_LT] = ACTIONS(11337),
    [anon_sym_if] = ACTIONS(11335),
    [anon_sym_unless] = ACTIONS(11335),
    [anon_sym_while] = ACTIONS(11335),
    [anon_sym_until] = ACTIONS(11335),
    [anon_sym_rescue] = ACTIONS(11335),
    [anon_sym_in] = ACTIONS(11335),
    [anon_sym_do] = ACTIONS(11335),
    [anon_sym_EQ_GT] = ACTIONS(11335),
    [anon_sym_LBRACK] = ACTIONS(11335),
    [anon_sym_RBRACK] = ACTIONS(11335),
    [anon_sym_COLON_COLON2] = ACTIONS(11335),
    [anon_sym_AMP_DOT] = ACTIONS(11335),
    [anon_sym_QMARK] = ACTIONS(11335),
    [anon_sym_COLON2] = ACTIONS(11337),
    [anon_sym_DOT_DOT] = ACTIONS(11337),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11335),
    [anon_sym_and] = ACTIONS(11335),
    [anon_sym_or] = ACTIONS(11335),
    [anon_sym_PIPE_PIPE] = ACTIONS(11335),
    [anon_sym_AMP_AMP] = ACTIONS(11335),
    [anon_sym_LT_LT] = ACTIONS(11335),
    [anon_sym_GT_GT] = ACTIONS(11335),
    [anon_sym_EQ_EQ] = ACTIONS(11337),
    [anon_sym_BANG_EQ] = ACTIONS(11335),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11335),
    [anon_sym_LT_EQ_GT] = ACTIONS(11335),
    [anon_sym_EQ_TILDE] = ACTIONS(11335),
    [anon_sym_BANG_TILDE] = ACTIONS(11335),
    [anon_sym_LT_EQ] = ACTIONS(11337),
    [anon_sym_GT] = ACTIONS(11337),
    [anon_sym_GT_EQ] = ACTIONS(11335),
    [anon_sym_CARET] = ACTIONS(11335),
    [anon_sym_PLUS] = ACTIONS(11335),
    [anon_sym_SLASH] = ACTIONS(11335),
    [anon_sym_PERCENT] = ACTIONS(11335),
    [sym_comment] = ACTIONS(87),
  },
  [8407] = {
    [sym__heredoc_body_start] = ACTIONS(11344),
    [sym__binary_minus] = ACTIONS(11344),
    [sym__binary_star] = ACTIONS(11344),
    [anon_sym_LBRACE] = ACTIONS(11344),
    [anon_sym_RBRACE] = ACTIONS(11344),
    [anon_sym_RPAREN] = ACTIONS(11344),
    [anon_sym_DOT] = ACTIONS(11346),
    [anon_sym_COMMA] = ACTIONS(11344),
    [anon_sym_PIPE] = ACTIONS(11346),
    [anon_sym_SEMI] = ACTIONS(11344),
    [anon_sym_STAR_STAR] = ACTIONS(11344),
    [anon_sym_AMP] = ACTIONS(11346),
    [anon_sym_EQ] = ACTIONS(11346),
    [anon_sym_LT] = ACTIONS(11346),
    [anon_sym_if] = ACTIONS(11344),
    [anon_sym_unless] = ACTIONS(11344),
    [anon_sym_while] = ACTIONS(11344),
    [anon_sym_until] = ACTIONS(11344),
    [anon_sym_rescue] = ACTIONS(11344),
    [anon_sym_in] = ACTIONS(11344),
    [anon_sym_do] = ACTIONS(11344),
    [anon_sym_EQ_GT] = ACTIONS(11344),
    [anon_sym_LBRACK] = ACTIONS(11344),
    [anon_sym_RBRACK] = ACTIONS(11344),
    [anon_sym_COLON_COLON2] = ACTIONS(11344),
    [anon_sym_AMP_DOT] = ACTIONS(11344),
    [anon_sym_QMARK] = ACTIONS(11344),
    [anon_sym_COLON2] = ACTIONS(11346),
    [anon_sym_DOT_DOT] = ACTIONS(11346),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11344),
    [anon_sym_and] = ACTIONS(11344),
    [anon_sym_or] = ACTIONS(11344),
    [anon_sym_PIPE_PIPE] = ACTIONS(11344),
    [anon_sym_AMP_AMP] = ACTIONS(11344),
    [anon_sym_LT_LT] = ACTIONS(11344),
    [anon_sym_GT_GT] = ACTIONS(11344),
    [anon_sym_EQ_EQ] = ACTIONS(11346),
    [anon_sym_BANG_EQ] = ACTIONS(11344),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11344),
    [anon_sym_LT_EQ_GT] = ACTIONS(11344),
    [anon_sym_EQ_TILDE] = ACTIONS(11344),
    [anon_sym_BANG_TILDE] = ACTIONS(11344),
    [anon_sym_LT_EQ] = ACTIONS(11346),
    [anon_sym_GT] = ACTIONS(11346),
    [anon_sym_GT_EQ] = ACTIONS(11344),
    [anon_sym_CARET] = ACTIONS(11344),
    [anon_sym_PLUS] = ACTIONS(11344),
    [anon_sym_SLASH] = ACTIONS(11344),
    [anon_sym_PERCENT] = ACTIONS(11344),
    [sym_comment] = ACTIONS(87),
  },
  [8408] = {
    [sym__heredoc_body_start] = ACTIONS(11391),
    [sym__binary_minus] = ACTIONS(11391),
    [sym__binary_star] = ACTIONS(11391),
    [anon_sym_LBRACE] = ACTIONS(11391),
    [anon_sym_RBRACE] = ACTIONS(11391),
    [anon_sym_RPAREN] = ACTIONS(11391),
    [anon_sym_DOT] = ACTIONS(11393),
    [anon_sym_COMMA] = ACTIONS(11391),
    [anon_sym_PIPE] = ACTIONS(11393),
    [anon_sym_SEMI] = ACTIONS(11391),
    [anon_sym_STAR_STAR] = ACTIONS(11391),
    [anon_sym_AMP] = ACTIONS(11393),
    [anon_sym_EQ] = ACTIONS(11393),
    [anon_sym_LT] = ACTIONS(11393),
    [anon_sym_if] = ACTIONS(11391),
    [anon_sym_unless] = ACTIONS(11391),
    [anon_sym_while] = ACTIONS(11391),
    [anon_sym_until] = ACTIONS(11391),
    [anon_sym_rescue] = ACTIONS(11391),
    [anon_sym_in] = ACTIONS(11391),
    [anon_sym_do] = ACTIONS(11391),
    [anon_sym_EQ_GT] = ACTIONS(11391),
    [anon_sym_LBRACK] = ACTIONS(11391),
    [anon_sym_RBRACK] = ACTIONS(11391),
    [anon_sym_COLON_COLON2] = ACTIONS(11391),
    [anon_sym_AMP_DOT] = ACTIONS(11391),
    [anon_sym_QMARK] = ACTIONS(11391),
    [anon_sym_COLON2] = ACTIONS(11393),
    [anon_sym_DOT_DOT] = ACTIONS(11393),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11391),
    [anon_sym_and] = ACTIONS(11391),
    [anon_sym_or] = ACTIONS(11391),
    [anon_sym_PIPE_PIPE] = ACTIONS(11391),
    [anon_sym_AMP_AMP] = ACTIONS(11391),
    [anon_sym_LT_LT] = ACTIONS(11391),
    [anon_sym_GT_GT] = ACTIONS(11391),
    [anon_sym_EQ_EQ] = ACTIONS(11393),
    [anon_sym_BANG_EQ] = ACTIONS(11391),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11391),
    [anon_sym_LT_EQ_GT] = ACTIONS(11391),
    [anon_sym_EQ_TILDE] = ACTIONS(11391),
    [anon_sym_BANG_TILDE] = ACTIONS(11391),
    [anon_sym_LT_EQ] = ACTIONS(11393),
    [anon_sym_GT] = ACTIONS(11393),
    [anon_sym_GT_EQ] = ACTIONS(11391),
    [anon_sym_CARET] = ACTIONS(11391),
    [anon_sym_PLUS] = ACTIONS(11391),
    [anon_sym_SLASH] = ACTIONS(11391),
    [anon_sym_PERCENT] = ACTIONS(11391),
    [sym_comment] = ACTIONS(87),
  },
  [8409] = {
    [anon_sym_end] = ACTIONS(13574),
    [sym_comment] = ACTIONS(87),
  },
  [8410] = {
    [sym__heredoc_body_start] = ACTIONS(11404),
    [sym__binary_minus] = ACTIONS(11404),
    [sym__binary_star] = ACTIONS(11404),
    [anon_sym_LBRACE] = ACTIONS(11404),
    [anon_sym_RBRACE] = ACTIONS(11404),
    [anon_sym_RPAREN] = ACTIONS(11404),
    [anon_sym_DOT] = ACTIONS(11406),
    [anon_sym_COMMA] = ACTIONS(11404),
    [anon_sym_PIPE] = ACTIONS(11406),
    [anon_sym_SEMI] = ACTIONS(11404),
    [anon_sym_STAR_STAR] = ACTIONS(11404),
    [anon_sym_AMP] = ACTIONS(11406),
    [anon_sym_EQ] = ACTIONS(11406),
    [anon_sym_LT] = ACTIONS(11406),
    [anon_sym_if] = ACTIONS(11404),
    [anon_sym_unless] = ACTIONS(11404),
    [anon_sym_while] = ACTIONS(11404),
    [anon_sym_until] = ACTIONS(11404),
    [anon_sym_rescue] = ACTIONS(11404),
    [anon_sym_in] = ACTIONS(11404),
    [anon_sym_do] = ACTIONS(11404),
    [anon_sym_EQ_GT] = ACTIONS(11404),
    [anon_sym_LBRACK] = ACTIONS(11404),
    [anon_sym_RBRACK] = ACTIONS(11404),
    [anon_sym_COLON_COLON2] = ACTIONS(11404),
    [anon_sym_AMP_DOT] = ACTIONS(11404),
    [anon_sym_QMARK] = ACTIONS(11404),
    [anon_sym_COLON2] = ACTIONS(11406),
    [anon_sym_DOT_DOT] = ACTIONS(11406),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11404),
    [anon_sym_and] = ACTIONS(11404),
    [anon_sym_or] = ACTIONS(11404),
    [anon_sym_PIPE_PIPE] = ACTIONS(11404),
    [anon_sym_AMP_AMP] = ACTIONS(11404),
    [anon_sym_LT_LT] = ACTIONS(11404),
    [anon_sym_GT_GT] = ACTIONS(11404),
    [anon_sym_EQ_EQ] = ACTIONS(11406),
    [anon_sym_BANG_EQ] = ACTIONS(11404),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11404),
    [anon_sym_LT_EQ_GT] = ACTIONS(11404),
    [anon_sym_EQ_TILDE] = ACTIONS(11404),
    [anon_sym_BANG_TILDE] = ACTIONS(11404),
    [anon_sym_LT_EQ] = ACTIONS(11406),
    [anon_sym_GT] = ACTIONS(11406),
    [anon_sym_GT_EQ] = ACTIONS(11404),
    [anon_sym_CARET] = ACTIONS(11404),
    [anon_sym_PLUS] = ACTIONS(11404),
    [anon_sym_SLASH] = ACTIONS(11404),
    [anon_sym_PERCENT] = ACTIONS(11404),
    [sym_comment] = ACTIONS(87),
  },
  [8411] = {
    [anon_sym_end] = ACTIONS(13576),
    [sym_comment] = ACTIONS(87),
  },
  [8412] = {
    [sym_when] = STATE(2988),
    [sym_else] = STATE(9902),
    [aux_sym_case_repeat2] = STATE(2988),
    [anon_sym_end] = ACTIONS(13576),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [8413] = {
    [sym__heredoc_body_start] = ACTIONS(11846),
    [sym__binary_minus] = ACTIONS(11846),
    [sym__binary_star] = ACTIONS(11846),
    [anon_sym_LBRACE] = ACTIONS(11846),
    [anon_sym_RBRACE] = ACTIONS(11846),
    [anon_sym_RPAREN] = ACTIONS(11846),
    [anon_sym_DOT] = ACTIONS(11848),
    [anon_sym_COMMA] = ACTIONS(11846),
    [anon_sym_PIPE] = ACTIONS(11848),
    [anon_sym_SEMI] = ACTIONS(11846),
    [anon_sym_STAR_STAR] = ACTIONS(11846),
    [anon_sym_AMP] = ACTIONS(11848),
    [anon_sym_EQ] = ACTIONS(11848),
    [anon_sym_LT] = ACTIONS(11848),
    [anon_sym_if] = ACTIONS(11846),
    [anon_sym_unless] = ACTIONS(11846),
    [anon_sym_while] = ACTIONS(11846),
    [anon_sym_until] = ACTIONS(11846),
    [anon_sym_rescue] = ACTIONS(11846),
    [anon_sym_in] = ACTIONS(11846),
    [anon_sym_do] = ACTIONS(11846),
    [anon_sym_EQ_GT] = ACTIONS(11846),
    [anon_sym_LBRACK] = ACTIONS(11846),
    [anon_sym_RBRACK] = ACTIONS(11846),
    [anon_sym_COLON_COLON2] = ACTIONS(11846),
    [anon_sym_AMP_DOT] = ACTIONS(11846),
    [anon_sym_QMARK] = ACTIONS(11846),
    [anon_sym_COLON2] = ACTIONS(11848),
    [anon_sym_DOT_DOT] = ACTIONS(11848),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11846),
    [anon_sym_and] = ACTIONS(11846),
    [anon_sym_or] = ACTIONS(11846),
    [anon_sym_PIPE_PIPE] = ACTIONS(11846),
    [anon_sym_AMP_AMP] = ACTIONS(11846),
    [anon_sym_LT_LT] = ACTIONS(11846),
    [anon_sym_GT_GT] = ACTIONS(11846),
    [anon_sym_EQ_EQ] = ACTIONS(11848),
    [anon_sym_BANG_EQ] = ACTIONS(11846),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11846),
    [anon_sym_LT_EQ_GT] = ACTIONS(11846),
    [anon_sym_EQ_TILDE] = ACTIONS(11846),
    [anon_sym_BANG_TILDE] = ACTIONS(11846),
    [anon_sym_LT_EQ] = ACTIONS(11848),
    [anon_sym_GT] = ACTIONS(11848),
    [anon_sym_GT_EQ] = ACTIONS(11846),
    [anon_sym_CARET] = ACTIONS(11846),
    [anon_sym_PLUS] = ACTIONS(11846),
    [anon_sym_SLASH] = ACTIONS(11846),
    [anon_sym_PERCENT] = ACTIONS(11846),
    [sym_comment] = ACTIONS(87),
  },
  [8414] = {
    [anon_sym_end] = ACTIONS(13578),
    [sym_comment] = ACTIONS(87),
  },
  [8415] = {
    [sym__heredoc_body_start] = ACTIONS(12029),
    [sym__binary_minus] = ACTIONS(12029),
    [sym__binary_star] = ACTIONS(12029),
    [anon_sym_LBRACE] = ACTIONS(12029),
    [anon_sym_RBRACE] = ACTIONS(12029),
    [anon_sym_RPAREN] = ACTIONS(12029),
    [anon_sym_DOT] = ACTIONS(12031),
    [anon_sym_COMMA] = ACTIONS(12029),
    [anon_sym_PIPE] = ACTIONS(12031),
    [anon_sym_SEMI] = ACTIONS(12029),
    [anon_sym_STAR_STAR] = ACTIONS(12029),
    [anon_sym_AMP] = ACTIONS(12031),
    [anon_sym_EQ] = ACTIONS(12031),
    [anon_sym_LT] = ACTIONS(12031),
    [anon_sym_if] = ACTIONS(12029),
    [anon_sym_unless] = ACTIONS(12029),
    [anon_sym_while] = ACTIONS(12029),
    [anon_sym_until] = ACTIONS(12029),
    [anon_sym_rescue] = ACTIONS(12029),
    [anon_sym_in] = ACTIONS(12029),
    [anon_sym_do] = ACTIONS(12029),
    [anon_sym_EQ_GT] = ACTIONS(12029),
    [anon_sym_LBRACK] = ACTIONS(12029),
    [anon_sym_RBRACK] = ACTIONS(12029),
    [anon_sym_COLON_COLON2] = ACTIONS(12029),
    [anon_sym_AMP_DOT] = ACTIONS(12029),
    [anon_sym_QMARK] = ACTIONS(12029),
    [anon_sym_COLON2] = ACTIONS(12031),
    [anon_sym_DOT_DOT] = ACTIONS(12031),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12029),
    [anon_sym_and] = ACTIONS(12029),
    [anon_sym_or] = ACTIONS(12029),
    [anon_sym_PIPE_PIPE] = ACTIONS(12029),
    [anon_sym_AMP_AMP] = ACTIONS(12029),
    [anon_sym_LT_LT] = ACTIONS(12029),
    [anon_sym_GT_GT] = ACTIONS(12029),
    [anon_sym_EQ_EQ] = ACTIONS(12031),
    [anon_sym_BANG_EQ] = ACTIONS(12029),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12029),
    [anon_sym_LT_EQ_GT] = ACTIONS(12029),
    [anon_sym_EQ_TILDE] = ACTIONS(12029),
    [anon_sym_BANG_TILDE] = ACTIONS(12029),
    [anon_sym_LT_EQ] = ACTIONS(12031),
    [anon_sym_GT] = ACTIONS(12031),
    [anon_sym_GT_EQ] = ACTIONS(12029),
    [anon_sym_CARET] = ACTIONS(12029),
    [anon_sym_PLUS] = ACTIONS(12029),
    [anon_sym_SLASH] = ACTIONS(12029),
    [anon_sym_PERCENT] = ACTIONS(12029),
    [sym_comment] = ACTIONS(87),
  },
  [8416] = {
    [sym__heredoc_body_start] = ACTIONS(12054),
    [sym__binary_minus] = ACTIONS(12054),
    [sym__binary_star] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_RBRACE] = ACTIONS(12054),
    [anon_sym_RPAREN] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12056),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_PIPE] = ACTIONS(12056),
    [anon_sym_SEMI] = ACTIONS(12054),
    [anon_sym_STAR_STAR] = ACTIONS(12054),
    [anon_sym_AMP] = ACTIONS(12056),
    [anon_sym_EQ] = ACTIONS(12056),
    [anon_sym_LT] = ACTIONS(12056),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_unless] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [anon_sym_until] = ACTIONS(12054),
    [anon_sym_rescue] = ACTIONS(12054),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_do] = ACTIONS(12054),
    [anon_sym_EQ_GT] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_RBRACK] = ACTIONS(12054),
    [anon_sym_COLON_COLON2] = ACTIONS(12054),
    [anon_sym_AMP_DOT] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_COLON2] = ACTIONS(12056),
    [anon_sym_DOT_DOT] = ACTIONS(12056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_and] = ACTIONS(12054),
    [anon_sym_or] = ACTIONS(12054),
    [anon_sym_PIPE_PIPE] = ACTIONS(12054),
    [anon_sym_AMP_AMP] = ACTIONS(12054),
    [anon_sym_LT_LT] = ACTIONS(12054),
    [anon_sym_GT_GT] = ACTIONS(12054),
    [anon_sym_EQ_EQ] = ACTIONS(12056),
    [anon_sym_BANG_EQ] = ACTIONS(12054),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12054),
    [anon_sym_LT_EQ_GT] = ACTIONS(12054),
    [anon_sym_EQ_TILDE] = ACTIONS(12054),
    [anon_sym_BANG_TILDE] = ACTIONS(12054),
    [anon_sym_LT_EQ] = ACTIONS(12056),
    [anon_sym_GT] = ACTIONS(12056),
    [anon_sym_GT_EQ] = ACTIONS(12054),
    [anon_sym_CARET] = ACTIONS(12054),
    [anon_sym_PLUS] = ACTIONS(12054),
    [anon_sym_SLASH] = ACTIONS(12054),
    [anon_sym_PERCENT] = ACTIONS(12054),
    [sym_comment] = ACTIONS(87),
  },
  [8417] = {
    [anon_sym_end] = ACTIONS(13580),
    [sym_comment] = ACTIONS(87),
  },
  [8418] = {
    [sym__statements] = STATE(9905),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13582),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8419] = {
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(2359),
    [sym__binary_star] = ACTIONS(2361),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(2363),
    [anon_sym_STAR_STAR] = ACTIONS(2361),
    [anon_sym_AMP] = ACTIONS(2365),
    [anon_sym_LT] = ACTIONS(2367),
    [anon_sym_EQ_GT] = ACTIONS(12120),
    [anon_sym_RBRACK] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(2369),
    [anon_sym_DOT_DOT] = ACTIONS(2371),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2373),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(2377),
    [anon_sym_AMP_AMP] = ACTIONS(2377),
    [anon_sym_LT_LT] = ACTIONS(2379),
    [anon_sym_GT_GT] = ACTIONS(2379),
    [anon_sym_EQ_EQ] = ACTIONS(2381),
    [anon_sym_BANG_EQ] = ACTIONS(2377),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2377),
    [anon_sym_LT_EQ_GT] = ACTIONS(2377),
    [anon_sym_EQ_TILDE] = ACTIONS(2377),
    [anon_sym_BANG_TILDE] = ACTIONS(2377),
    [anon_sym_LT_EQ] = ACTIONS(2367),
    [anon_sym_GT] = ACTIONS(2367),
    [anon_sym_GT_EQ] = ACTIONS(2383),
    [anon_sym_CARET] = ACTIONS(2385),
    [anon_sym_PLUS] = ACTIONS(2359),
    [anon_sym_SLASH] = ACTIONS(2361),
    [anon_sym_PERCENT] = ACTIONS(2361),
    [sym_comment] = ACTIONS(87),
  },
  [8420] = {
    [sym__simple_symbol] = ACTIONS(7876),
    [sym__string_start] = ACTIONS(7876),
    [sym__symbol_start] = ACTIONS(7876),
    [sym__subshell_start] = ACTIONS(7876),
    [sym__regex_start] = ACTIONS(7876),
    [sym__string_array_start] = ACTIONS(7876),
    [sym__symbol_array_start] = ACTIONS(7876),
    [sym__heredoc_body_start] = ACTIONS(7876),
    [sym_heredoc_beginning] = ACTIONS(7876),
    [sym__block_ampersand] = ACTIONS(7876),
    [sym__splat_star] = ACTIONS(7876),
    [sym__unary_minus] = ACTIONS(7876),
    [sym__binary_minus] = ACTIONS(7876),
    [sym__binary_star] = ACTIONS(7876),
    [sym__identifier_hash_key] = ACTIONS(7876),
    [anon_sym_LBRACE] = ACTIONS(7876),
    [anon_sym_RBRACE] = ACTIONS(7876),
    [anon_sym_def] = ACTIONS(7878),
    [anon_sym_LPAREN] = ACTIONS(7878),
    [anon_sym_RPAREN] = ACTIONS(7876),
    [anon_sym_DOT] = ACTIONS(7878),
    [anon_sym_COLON_COLON] = ACTIONS(7878),
    [anon_sym_COMMA] = ACTIONS(7876),
    [anon_sym_PIPE] = ACTIONS(7878),
    [anon_sym_SEMI] = ACTIONS(7876),
    [anon_sym_STAR] = ACTIONS(7878),
    [anon_sym_STAR_STAR] = ACTIONS(7878),
    [anon_sym_AMP] = ACTIONS(7878),
    [anon_sym_EQ] = ACTIONS(7878),
    [anon_sym_class] = ACTIONS(7878),
    [anon_sym_LT] = ACTIONS(7878),
    [anon_sym_module] = ACTIONS(7878),
    [anon_sym_return] = ACTIONS(7878),
    [anon_sym_yield] = ACTIONS(7878),
    [anon_sym_break] = ACTIONS(7878),
    [anon_sym_next] = ACTIONS(7878),
    [sym_redo] = ACTIONS(7878),
    [sym_retry] = ACTIONS(7878),
    [anon_sym_if] = ACTIONS(7878),
    [anon_sym_unless] = ACTIONS(7878),
    [anon_sym_while] = ACTIONS(7878),
    [anon_sym_until] = ACTIONS(7878),
    [anon_sym_rescue] = ACTIONS(7878),
    [anon_sym_for] = ACTIONS(7878),
    [anon_sym_in] = ACTIONS(7878),
    [anon_sym_do] = ACTIONS(7878),
    [anon_sym_case] = ACTIONS(7878),
    [anon_sym_begin] = ACTIONS(7878),
    [anon_sym_EQ_GT] = ACTIONS(7876),
    [anon_sym_LBRACK] = ACTIONS(7876),
    [anon_sym_RBRACK] = ACTIONS(7876),
    [anon_sym_COLON_COLON2] = ACTIONS(7876),
    [anon_sym_AMP_DOT] = ACTIONS(7876),
    [anon_sym_LPAREN2] = ACTIONS(7876),
    [anon_sym_PLUS_EQ] = ACTIONS(7876),
    [anon_sym_DASH_EQ] = ACTIONS(7876),
    [anon_sym_STAR_EQ] = ACTIONS(7876),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7876),
    [anon_sym_SLASH_EQ] = ACTIONS(7876),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7876),
    [anon_sym_PIPE_EQ] = ACTIONS(7876),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7876),
    [anon_sym_AMP_EQ] = ACTIONS(7876),
    [anon_sym_PERCENT_EQ] = ACTIONS(7876),
    [anon_sym_GT_GT_EQ] = ACTIONS(7876),
    [anon_sym_LT_LT_EQ] = ACTIONS(7876),
    [anon_sym_CARET_EQ] = ACTIONS(7876),
    [anon_sym_QMARK] = ACTIONS(7878),
    [anon_sym_COLON2] = ACTIONS(7878),
    [anon_sym_DOT_DOT] = ACTIONS(7878),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7876),
    [anon_sym_and] = ACTIONS(7878),
    [anon_sym_or] = ACTIONS(7878),
    [anon_sym_PIPE_PIPE] = ACTIONS(7878),
    [anon_sym_AMP_AMP] = ACTIONS(7878),
    [anon_sym_LT_LT] = ACTIONS(7878),
    [anon_sym_GT_GT] = ACTIONS(7878),
    [anon_sym_EQ_EQ] = ACTIONS(7878),
    [anon_sym_BANG_EQ] = ACTIONS(7876),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7876),
    [anon_sym_LT_EQ_GT] = ACTIONS(7876),
    [anon_sym_EQ_TILDE] = ACTIONS(7876),
    [anon_sym_BANG_TILDE] = ACTIONS(7876),
    [anon_sym_LT_EQ] = ACTIONS(7878),
    [anon_sym_GT] = ACTIONS(7878),
    [anon_sym_GT_EQ] = ACTIONS(7876),
    [anon_sym_CARET] = ACTIONS(7878),
    [anon_sym_PLUS] = ACTIONS(7878),
    [anon_sym_SLASH] = ACTIONS(7878),
    [anon_sym_PERCENT] = ACTIONS(7878),
    [anon_sym_defined_QMARK] = ACTIONS(7876),
    [anon_sym_not] = ACTIONS(7878),
    [anon_sym_BANG] = ACTIONS(7878),
    [anon_sym_TILDE] = ACTIONS(7876),
    [sym_constant] = ACTIONS(7878),
    [sym_identifier] = ACTIONS(7878),
    [sym_instance_variable] = ACTIONS(7876),
    [sym_class_variable] = ACTIONS(7876),
    [sym_global_variable] = ACTIONS(7876),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(7878),
    [sym_float] = ACTIONS(7878),
    [sym_complex] = ACTIONS(7876),
    [sym_super] = ACTIONS(7878),
    [anon_sym_true] = ACTIONS(7878),
    [anon_sym_TRUE] = ACTIONS(7878),
    [anon_sym_false] = ACTIONS(7878),
    [anon_sym_FALSE] = ACTIONS(7878),
    [sym_self] = ACTIONS(7878),
    [anon_sym_nil] = ACTIONS(7878),
    [anon_sym_NIL] = ACTIONS(7878),
    [sym_character] = ACTIONS(7876),
    [anon_sym_LBRACK2] = ACTIONS(7878),
    [anon_sym_DASH_GT] = ACTIONS(7876),
  },
  [8421] = {
    [sym__heredoc_body_start] = ACTIONS(12029),
    [sym__binary_minus] = ACTIONS(12029),
    [sym__binary_star] = ACTIONS(12029),
    [anon_sym_LBRACE] = ACTIONS(12029),
    [anon_sym_RBRACE] = ACTIONS(12029),
    [anon_sym_RPAREN] = ACTIONS(12029),
    [anon_sym_DOT] = ACTIONS(12031),
    [anon_sym_COMMA] = ACTIONS(12029),
    [anon_sym_PIPE] = ACTIONS(12031),
    [anon_sym_SEMI] = ACTIONS(12029),
    [anon_sym_STAR_STAR] = ACTIONS(12031),
    [anon_sym_AMP] = ACTIONS(12031),
    [anon_sym_EQ] = ACTIONS(12031),
    [anon_sym_LT] = ACTIONS(12031),
    [anon_sym_if] = ACTIONS(12029),
    [anon_sym_unless] = ACTIONS(12029),
    [anon_sym_while] = ACTIONS(12029),
    [anon_sym_until] = ACTIONS(12029),
    [anon_sym_rescue] = ACTIONS(12029),
    [anon_sym_in] = ACTIONS(12029),
    [anon_sym_do] = ACTIONS(12029),
    [anon_sym_EQ_GT] = ACTIONS(12029),
    [anon_sym_LBRACK] = ACTIONS(12029),
    [anon_sym_RBRACK] = ACTIONS(12029),
    [anon_sym_COLON_COLON2] = ACTIONS(12029),
    [anon_sym_AMP_DOT] = ACTIONS(12029),
    [anon_sym_PLUS_EQ] = ACTIONS(12029),
    [anon_sym_DASH_EQ] = ACTIONS(12029),
    [anon_sym_STAR_EQ] = ACTIONS(12029),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12029),
    [anon_sym_SLASH_EQ] = ACTIONS(12029),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12029),
    [anon_sym_PIPE_EQ] = ACTIONS(12029),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12029),
    [anon_sym_AMP_EQ] = ACTIONS(12029),
    [anon_sym_PERCENT_EQ] = ACTIONS(12029),
    [anon_sym_GT_GT_EQ] = ACTIONS(12029),
    [anon_sym_LT_LT_EQ] = ACTIONS(12029),
    [anon_sym_CARET_EQ] = ACTIONS(12029),
    [anon_sym_QMARK] = ACTIONS(12029),
    [anon_sym_COLON2] = ACTIONS(12031),
    [anon_sym_DOT_DOT] = ACTIONS(12031),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12029),
    [anon_sym_and] = ACTIONS(12029),
    [anon_sym_or] = ACTIONS(12029),
    [anon_sym_PIPE_PIPE] = ACTIONS(12031),
    [anon_sym_AMP_AMP] = ACTIONS(12031),
    [anon_sym_LT_LT] = ACTIONS(12031),
    [anon_sym_GT_GT] = ACTIONS(12031),
    [anon_sym_EQ_EQ] = ACTIONS(12031),
    [anon_sym_BANG_EQ] = ACTIONS(12029),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12029),
    [anon_sym_LT_EQ_GT] = ACTIONS(12029),
    [anon_sym_EQ_TILDE] = ACTIONS(12029),
    [anon_sym_BANG_TILDE] = ACTIONS(12029),
    [anon_sym_LT_EQ] = ACTIONS(12031),
    [anon_sym_GT] = ACTIONS(12031),
    [anon_sym_GT_EQ] = ACTIONS(12029),
    [anon_sym_CARET] = ACTIONS(12031),
    [anon_sym_PLUS] = ACTIONS(12031),
    [anon_sym_SLASH] = ACTIONS(12031),
    [anon_sym_PERCENT] = ACTIONS(12031),
    [sym_comment] = ACTIONS(87),
  },
  [8422] = {
    [sym__heredoc_body_start] = ACTIONS(12054),
    [sym__binary_minus] = ACTIONS(12054),
    [sym__binary_star] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_RBRACE] = ACTIONS(12054),
    [anon_sym_RPAREN] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12056),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_PIPE] = ACTIONS(12056),
    [anon_sym_SEMI] = ACTIONS(12054),
    [anon_sym_STAR_STAR] = ACTIONS(12056),
    [anon_sym_AMP] = ACTIONS(12056),
    [anon_sym_EQ] = ACTIONS(12056),
    [anon_sym_LT] = ACTIONS(12056),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_unless] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [anon_sym_until] = ACTIONS(12054),
    [anon_sym_rescue] = ACTIONS(12054),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_do] = ACTIONS(12054),
    [anon_sym_EQ_GT] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_RBRACK] = ACTIONS(12054),
    [anon_sym_COLON_COLON2] = ACTIONS(12054),
    [anon_sym_AMP_DOT] = ACTIONS(12054),
    [anon_sym_PLUS_EQ] = ACTIONS(12054),
    [anon_sym_DASH_EQ] = ACTIONS(12054),
    [anon_sym_STAR_EQ] = ACTIONS(12054),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12054),
    [anon_sym_SLASH_EQ] = ACTIONS(12054),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12054),
    [anon_sym_PIPE_EQ] = ACTIONS(12054),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12054),
    [anon_sym_AMP_EQ] = ACTIONS(12054),
    [anon_sym_PERCENT_EQ] = ACTIONS(12054),
    [anon_sym_GT_GT_EQ] = ACTIONS(12054),
    [anon_sym_LT_LT_EQ] = ACTIONS(12054),
    [anon_sym_CARET_EQ] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_COLON2] = ACTIONS(12056),
    [anon_sym_DOT_DOT] = ACTIONS(12056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_and] = ACTIONS(12054),
    [anon_sym_or] = ACTIONS(12054),
    [anon_sym_PIPE_PIPE] = ACTIONS(12056),
    [anon_sym_AMP_AMP] = ACTIONS(12056),
    [anon_sym_LT_LT] = ACTIONS(12056),
    [anon_sym_GT_GT] = ACTIONS(12056),
    [anon_sym_EQ_EQ] = ACTIONS(12056),
    [anon_sym_BANG_EQ] = ACTIONS(12054),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12054),
    [anon_sym_LT_EQ_GT] = ACTIONS(12054),
    [anon_sym_EQ_TILDE] = ACTIONS(12054),
    [anon_sym_BANG_TILDE] = ACTIONS(12054),
    [anon_sym_LT_EQ] = ACTIONS(12056),
    [anon_sym_GT] = ACTIONS(12056),
    [anon_sym_GT_EQ] = ACTIONS(12054),
    [anon_sym_CARET] = ACTIONS(12056),
    [anon_sym_PLUS] = ACTIONS(12056),
    [anon_sym_SLASH] = ACTIONS(12056),
    [anon_sym_PERCENT] = ACTIONS(12056),
    [sym_comment] = ACTIONS(87),
  },
  [8423] = {
    [anon_sym_end] = ACTIONS(13584),
    [sym_comment] = ACTIONS(87),
  },
  [8424] = {
    [sym__statements] = STATE(9907),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13586),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8425] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(9908),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1384),
    [sym_scope_resolution] = STATE(1378),
    [sym_call] = STATE(1378),
    [sym_method_call] = STATE(1384),
    [sym_assignment] = STATE(9908),
    [sym_operator_assignment] = STATE(9908),
    [sym_conditional] = STATE(9908),
    [sym_range] = STATE(9908),
    [sym_binary] = STATE(9908),
    [sym_unary] = STATE(9908),
    [sym_left_assignment_list] = STATE(1383),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1384),
    [sym__variable] = STATE(1378),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1384),
    [sym_false] = STATE(1384),
    [sym_nil] = STATE(1384),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3423),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2399),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2405),
    [anon_sym_yield] = ACTIONS(2407),
    [anon_sym_break] = ACTIONS(2409),
    [anon_sym_next] = ACTIONS(2411),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(5673),
    [anon_sym_defined_QMARK] = ACTIONS(2415),
    [anon_sym_not] = ACTIONS(2417),
    [anon_sym_BANG] = ACTIONS(2421),
    [anon_sym_TILDE] = ACTIONS(2421),
    [sym_constant] = ACTIONS(2427),
    [sym_identifier] = ACTIONS(2427),
    [sym_instance_variable] = ACTIONS(2425),
    [sym_class_variable] = ACTIONS(2425),
    [sym_global_variable] = ACTIONS(2425),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2427),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2427),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [8426] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6084),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1384),
    [sym_scope_resolution] = STATE(1378),
    [sym_call] = STATE(1378),
    [sym_method_call] = STATE(1384),
    [sym_splat_argument] = STATE(9044),
    [sym_assignment] = STATE(6084),
    [sym_operator_assignment] = STATE(6084),
    [sym_conditional] = STATE(6084),
    [sym_range] = STATE(6084),
    [sym_binary] = STATE(6084),
    [sym_unary] = STATE(6084),
    [sym__arg_or_splat_arg] = STATE(9044),
    [sym_left_assignment_list] = STATE(1383),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1384),
    [sym__variable] = STATE(1378),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1384),
    [sym_false] = STATE(1384),
    [sym_nil] = STATE(1384),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3423),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__splat_star] = ACTIONS(2397),
    [sym__unary_minus] = ACTIONS(2399),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2405),
    [anon_sym_yield] = ACTIONS(2407),
    [anon_sym_break] = ACTIONS(2409),
    [anon_sym_next] = ACTIONS(2411),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(5673),
    [anon_sym_defined_QMARK] = ACTIONS(2415),
    [anon_sym_not] = ACTIONS(2417),
    [anon_sym_BANG] = ACTIONS(2421),
    [anon_sym_TILDE] = ACTIONS(2421),
    [sym_constant] = ACTIONS(2427),
    [sym_identifier] = ACTIONS(2427),
    [sym_instance_variable] = ACTIONS(2425),
    [sym_class_variable] = ACTIONS(2425),
    [sym_global_variable] = ACTIONS(2425),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2427),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2427),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [8427] = {
    [aux_sym_exceptions_repeat1] = STATE(9909),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_LBRACE] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(13588),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_STAR_STAR] = ACTIONS(9857),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_EQ] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_do] = ACTIONS(9855),
    [anon_sym_EQ_GT] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_RBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_PLUS_EQ] = ACTIONS(9855),
    [anon_sym_DASH_EQ] = ACTIONS(9855),
    [anon_sym_STAR_EQ] = ACTIONS(9855),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9855),
    [anon_sym_SLASH_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9855),
    [anon_sym_AMP_EQ] = ACTIONS(9855),
    [anon_sym_PERCENT_EQ] = ACTIONS(9855),
    [anon_sym_GT_GT_EQ] = ACTIONS(9855),
    [anon_sym_LT_LT_EQ] = ACTIONS(9855),
    [anon_sym_CARET_EQ] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9857),
    [anon_sym_AMP_AMP] = ACTIONS(9857),
    [anon_sym_LT_LT] = ACTIONS(9857),
    [anon_sym_GT_GT] = ACTIONS(9857),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9857),
    [anon_sym_PLUS] = ACTIONS(9857),
    [anon_sym_SLASH] = ACTIONS(9857),
    [anon_sym_PERCENT] = ACTIONS(9857),
    [sym_comment] = ACTIONS(87),
  },
  [8428] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(346),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(352),
    [sym_scope_resolution] = STATE(348),
    [sym_call] = STATE(348),
    [sym_method_call] = STATE(352),
    [sym__argument] = STATE(6088),
    [sym_splat_argument] = STATE(6088),
    [sym_hash_splat_argument] = STATE(6088),
    [sym_block_argument] = STATE(6088),
    [sym_assignment] = STATE(346),
    [sym_operator_assignment] = STATE(346),
    [sym_conditional] = STATE(346),
    [sym_range] = STATE(346),
    [sym_binary] = STATE(346),
    [sym_unary] = STATE(346),
    [sym_left_assignment_list] = STATE(351),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(352),
    [sym__variable] = STATE(348),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(352),
    [sym_false] = STATE(352),
    [sym_nil] = STATE(352),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(353),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(6088),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(593),
    [sym__splat_star] = ACTIONS(595),
    [sym__unary_minus] = ACTIONS(597),
    [sym__identifier_hash_key] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8429] = {
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_RBRACE] = ACTIONS(11597),
    [anon_sym_RPAREN] = ACTIONS(11597),
    [anon_sym_COMMA] = ACTIONS(11597),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_RBRACK] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [8430] = {
    [aux_sym_exceptions_repeat1] = STATE(8430),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_COMMA] = ACTIONS(13590),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_RBRACK] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [8431] = {
    [aux_sym_block_parameters_repeat1] = STATE(9911),
    [anon_sym_COMMA] = ACTIONS(11999),
    [anon_sym_PIPE] = ACTIONS(13593),
    [sym_comment] = ACTIONS(87),
  },
  [8432] = {
    [sym_identifier] = ACTIONS(13595),
    [sym_comment] = ACTIONS(87),
  },
  [8433] = {
    [sym__simple_symbol] = ACTIONS(13597),
    [sym__string_start] = ACTIONS(13597),
    [sym__symbol_start] = ACTIONS(13597),
    [sym__subshell_start] = ACTIONS(13597),
    [sym__regex_start] = ACTIONS(13597),
    [sym__string_array_start] = ACTIONS(13597),
    [sym__symbol_array_start] = ACTIONS(13597),
    [sym_heredoc_beginning] = ACTIONS(13597),
    [sym__unary_minus] = ACTIONS(13597),
    [anon_sym_BEGIN] = ACTIONS(13599),
    [anon_sym_LBRACE] = ACTIONS(13597),
    [anon_sym_RBRACE] = ACTIONS(13597),
    [anon_sym_END] = ACTIONS(13599),
    [anon_sym_def] = ACTIONS(13599),
    [anon_sym_LPAREN] = ACTIONS(13597),
    [anon_sym_COLON_COLON] = ACTIONS(13597),
    [anon_sym_SEMI] = ACTIONS(13597),
    [anon_sym_STAR] = ACTIONS(13597),
    [anon_sym_class] = ACTIONS(13599),
    [anon_sym_module] = ACTIONS(13599),
    [anon_sym_return] = ACTIONS(13599),
    [anon_sym_yield] = ACTIONS(13599),
    [anon_sym_break] = ACTIONS(13599),
    [anon_sym_next] = ACTIONS(13599),
    [sym_redo] = ACTIONS(13599),
    [sym_retry] = ACTIONS(13599),
    [anon_sym_if] = ACTIONS(13599),
    [anon_sym_unless] = ACTIONS(13599),
    [anon_sym_while] = ACTIONS(13599),
    [anon_sym_until] = ACTIONS(13599),
    [anon_sym_for] = ACTIONS(13599),
    [anon_sym_case] = ACTIONS(13599),
    [anon_sym_begin] = ACTIONS(13599),
    [anon_sym_PLUS] = ACTIONS(13599),
    [anon_sym_defined_QMARK] = ACTIONS(13597),
    [anon_sym_not] = ACTIONS(13599),
    [anon_sym_BANG] = ACTIONS(13597),
    [anon_sym_TILDE] = ACTIONS(13597),
    [sym_constant] = ACTIONS(13599),
    [sym_identifier] = ACTIONS(13599),
    [sym_instance_variable] = ACTIONS(13597),
    [sym_class_variable] = ACTIONS(13597),
    [sym_global_variable] = ACTIONS(13597),
    [anon_sym_undef] = ACTIONS(13599),
    [anon_sym_alias] = ACTIONS(13599),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(13599),
    [sym_float] = ACTIONS(13599),
    [sym_complex] = ACTIONS(13597),
    [sym_super] = ACTIONS(13599),
    [anon_sym_true] = ACTIONS(13599),
    [anon_sym_TRUE] = ACTIONS(13599),
    [anon_sym_false] = ACTIONS(13599),
    [anon_sym_FALSE] = ACTIONS(13599),
    [sym_self] = ACTIONS(13599),
    [anon_sym_nil] = ACTIONS(13599),
    [anon_sym_NIL] = ACTIONS(13599),
    [sym_character] = ACTIONS(13597),
    [anon_sym_LBRACK2] = ACTIONS(13597),
    [anon_sym_DASH_GT] = ACTIONS(13597),
  },
  [8434] = {
    [aux_sym_block_parameters_repeat1] = STATE(9913),
    [anon_sym_COMMA] = ACTIONS(11999),
    [anon_sym_PIPE] = ACTIONS(13593),
    [sym_comment] = ACTIONS(87),
  },
  [8435] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(9914),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(8445),
    [sym_scope_resolution] = STATE(8443),
    [sym_call] = STATE(8443),
    [sym_method_call] = STATE(8445),
    [sym_assignment] = STATE(9914),
    [sym_operator_assignment] = STATE(9914),
    [sym_conditional] = STATE(9914),
    [sym_range] = STATE(9914),
    [sym_binary] = STATE(9914),
    [sym_unary] = STATE(9914),
    [sym_left_assignment_list] = STATE(8444),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(8445),
    [sym__variable] = STATE(8443),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(8445),
    [sym_false] = STATE(8445),
    [sym_nil] = STATE(8445),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(8446),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(12003),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(12005),
    [anon_sym_yield] = ACTIONS(12007),
    [anon_sym_break] = ACTIONS(12009),
    [anon_sym_next] = ACTIONS(12011),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(12013),
    [anon_sym_defined_QMARK] = ACTIONS(12015),
    [anon_sym_not] = ACTIONS(12017),
    [anon_sym_BANG] = ACTIONS(12019),
    [anon_sym_TILDE] = ACTIONS(12019),
    [sym_constant] = ACTIONS(12021),
    [sym_identifier] = ACTIONS(12021),
    [sym_instance_variable] = ACTIONS(12023),
    [sym_class_variable] = ACTIONS(12023),
    [sym_global_variable] = ACTIONS(12023),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(12021),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(12021),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8436] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(9927),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(9932),
    [sym_scope_resolution] = STATE(9928),
    [sym_call] = STATE(9928),
    [sym_method_call] = STATE(9932),
    [sym_argument_list] = STATE(563),
    [sym__argument_list_with_parens] = STATE(9929),
    [sym__argument] = STATE(9930),
    [sym_splat_argument] = STATE(9930),
    [sym_hash_splat_argument] = STATE(9930),
    [sym_block_argument] = STATE(9930),
    [sym_assignment] = STATE(9927),
    [sym_operator_assignment] = STATE(9927),
    [sym_conditional] = STATE(9927),
    [sym_range] = STATE(9927),
    [sym_binary] = STATE(9927),
    [sym_unary] = STATE(9927),
    [sym_left_assignment_list] = STATE(9931),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9932),
    [sym__variable] = STATE(9928),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(9932),
    [sym_false] = STATE(9932),
    [sym_nil] = STATE(9932),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(9933),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(9930),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(13601),
    [sym__splat_star] = ACTIONS(13603),
    [sym__unary_minus] = ACTIONS(13605),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(13607),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13609),
    [anon_sym_yield] = ACTIONS(13611),
    [anon_sym_break] = ACTIONS(13613),
    [anon_sym_next] = ACTIONS(13615),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(13617),
    [anon_sym_not] = ACTIONS(13619),
    [anon_sym_BANG] = ACTIONS(13621),
    [anon_sym_TILDE] = ACTIONS(13623),
    [sym_constant] = ACTIONS(13625),
    [sym_identifier] = ACTIONS(13625),
    [sym_instance_variable] = ACTIONS(13627),
    [sym_class_variable] = ACTIONS(13627),
    [sym_global_variable] = ACTIONS(13627),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13629),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13629),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8437] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(9927),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(9932),
    [sym_scope_resolution] = STATE(9928),
    [sym_call] = STATE(9928),
    [sym_method_call] = STATE(9932),
    [sym_argument_list] = STATE(569),
    [sym__argument_list_with_parens] = STATE(9929),
    [sym__argument] = STATE(9930),
    [sym_splat_argument] = STATE(9930),
    [sym_hash_splat_argument] = STATE(9930),
    [sym_block_argument] = STATE(9930),
    [sym_assignment] = STATE(9927),
    [sym_operator_assignment] = STATE(9927),
    [sym_conditional] = STATE(9927),
    [sym_range] = STATE(9927),
    [sym_binary] = STATE(9927),
    [sym_unary] = STATE(9927),
    [sym_left_assignment_list] = STATE(9931),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9932),
    [sym__variable] = STATE(9928),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(9932),
    [sym_false] = STATE(9932),
    [sym_nil] = STATE(9932),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(9933),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(9930),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(13601),
    [sym__splat_star] = ACTIONS(13603),
    [sym__unary_minus] = ACTIONS(13605),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(13607),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13609),
    [anon_sym_yield] = ACTIONS(13611),
    [anon_sym_break] = ACTIONS(13613),
    [anon_sym_next] = ACTIONS(13615),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(13617),
    [anon_sym_not] = ACTIONS(13619),
    [anon_sym_BANG] = ACTIONS(13621),
    [anon_sym_TILDE] = ACTIONS(13623),
    [sym_constant] = ACTIONS(13625),
    [sym_identifier] = ACTIONS(13625),
    [sym_instance_variable] = ACTIONS(13627),
    [sym_class_variable] = ACTIONS(13627),
    [sym_global_variable] = ACTIONS(13627),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13629),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13629),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8438] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(9927),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(9932),
    [sym_scope_resolution] = STATE(9928),
    [sym_call] = STATE(9928),
    [sym_method_call] = STATE(9932),
    [sym_argument_list] = STATE(570),
    [sym__argument_list_with_parens] = STATE(9929),
    [sym__argument] = STATE(9930),
    [sym_splat_argument] = STATE(9930),
    [sym_hash_splat_argument] = STATE(9930),
    [sym_block_argument] = STATE(9930),
    [sym_assignment] = STATE(9927),
    [sym_operator_assignment] = STATE(9927),
    [sym_conditional] = STATE(9927),
    [sym_range] = STATE(9927),
    [sym_binary] = STATE(9927),
    [sym_unary] = STATE(9927),
    [sym_left_assignment_list] = STATE(9931),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9932),
    [sym__variable] = STATE(9928),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(9932),
    [sym_false] = STATE(9932),
    [sym_nil] = STATE(9932),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(9933),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(9930),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(13601),
    [sym__splat_star] = ACTIONS(13603),
    [sym__unary_minus] = ACTIONS(13605),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(13607),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13609),
    [anon_sym_yield] = ACTIONS(13611),
    [anon_sym_break] = ACTIONS(13613),
    [anon_sym_next] = ACTIONS(13615),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(13617),
    [anon_sym_not] = ACTIONS(13619),
    [anon_sym_BANG] = ACTIONS(13621),
    [anon_sym_TILDE] = ACTIONS(13623),
    [sym_constant] = ACTIONS(13625),
    [sym_identifier] = ACTIONS(13625),
    [sym_instance_variable] = ACTIONS(13627),
    [sym_class_variable] = ACTIONS(13627),
    [sym_global_variable] = ACTIONS(13627),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13629),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13629),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8439] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(9927),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(9932),
    [sym_scope_resolution] = STATE(9928),
    [sym_call] = STATE(9928),
    [sym_method_call] = STATE(9932),
    [sym_argument_list] = STATE(571),
    [sym__argument_list_with_parens] = STATE(9929),
    [sym__argument] = STATE(9930),
    [sym_splat_argument] = STATE(9930),
    [sym_hash_splat_argument] = STATE(9930),
    [sym_block_argument] = STATE(9930),
    [sym_assignment] = STATE(9927),
    [sym_operator_assignment] = STATE(9927),
    [sym_conditional] = STATE(9927),
    [sym_range] = STATE(9927),
    [sym_binary] = STATE(9927),
    [sym_unary] = STATE(9927),
    [sym_left_assignment_list] = STATE(9931),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9932),
    [sym__variable] = STATE(9928),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(9932),
    [sym_false] = STATE(9932),
    [sym_nil] = STATE(9932),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(9933),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(9930),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(13601),
    [sym__splat_star] = ACTIONS(13603),
    [sym__unary_minus] = ACTIONS(13605),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(13607),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13609),
    [anon_sym_yield] = ACTIONS(13611),
    [anon_sym_break] = ACTIONS(13613),
    [anon_sym_next] = ACTIONS(13615),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(13617),
    [anon_sym_not] = ACTIONS(13619),
    [anon_sym_BANG] = ACTIONS(13621),
    [anon_sym_TILDE] = ACTIONS(13623),
    [sym_constant] = ACTIONS(13625),
    [sym_identifier] = ACTIONS(13625),
    [sym_instance_variable] = ACTIONS(13627),
    [sym_class_variable] = ACTIONS(13627),
    [sym_global_variable] = ACTIONS(13627),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13629),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13629),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8440] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(9934),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(8445),
    [sym_scope_resolution] = STATE(8443),
    [sym_call] = STATE(8443),
    [sym_method_call] = STATE(8445),
    [sym_assignment] = STATE(9934),
    [sym_operator_assignment] = STATE(9934),
    [sym_conditional] = STATE(9934),
    [sym_range] = STATE(9934),
    [sym_binary] = STATE(9934),
    [sym_unary] = STATE(9934),
    [sym_left_assignment_list] = STATE(8444),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(8445),
    [sym__variable] = STATE(8443),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(8445),
    [sym_false] = STATE(8445),
    [sym_nil] = STATE(8445),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(8446),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(12003),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(12005),
    [anon_sym_yield] = ACTIONS(12007),
    [anon_sym_break] = ACTIONS(12009),
    [anon_sym_next] = ACTIONS(12011),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(12013),
    [anon_sym_defined_QMARK] = ACTIONS(12015),
    [anon_sym_not] = ACTIONS(12017),
    [anon_sym_BANG] = ACTIONS(12019),
    [anon_sym_TILDE] = ACTIONS(12019),
    [sym_constant] = ACTIONS(12021),
    [sym_identifier] = ACTIONS(12021),
    [sym_instance_variable] = ACTIONS(12023),
    [sym_class_variable] = ACTIONS(12023),
    [sym_global_variable] = ACTIONS(12023),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(12021),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(12021),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8441] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(586),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(8445),
    [sym_scope_resolution] = STATE(8443),
    [sym_call] = STATE(8443),
    [sym_method_call] = STATE(8445),
    [sym_assignment] = STATE(586),
    [sym_operator_assignment] = STATE(586),
    [sym_conditional] = STATE(586),
    [sym_range] = STATE(586),
    [sym_binary] = STATE(586),
    [sym_unary] = STATE(586),
    [sym_left_assignment_list] = STATE(8444),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(8445),
    [sym__variable] = STATE(8443),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(8445),
    [sym_false] = STATE(8445),
    [sym_nil] = STATE(8445),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(8446),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(12003),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(12005),
    [anon_sym_yield] = ACTIONS(12007),
    [anon_sym_break] = ACTIONS(12009),
    [anon_sym_next] = ACTIONS(12011),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(12013),
    [anon_sym_defined_QMARK] = ACTIONS(12015),
    [anon_sym_not] = ACTIONS(12017),
    [anon_sym_BANG] = ACTIONS(12019),
    [anon_sym_TILDE] = ACTIONS(12019),
    [sym_constant] = ACTIONS(12021),
    [sym_identifier] = ACTIONS(12021),
    [sym_instance_variable] = ACTIONS(12023),
    [sym_class_variable] = ACTIONS(12023),
    [sym_global_variable] = ACTIONS(12023),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(12021),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(12021),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8442] = {
    [sym__binary_minus] = ACTIONS(13631),
    [sym__binary_star] = ACTIONS(13633),
    [anon_sym_COMMA] = ACTIONS(9460),
    [anon_sym_PIPE] = ACTIONS(13635),
    [anon_sym_SEMI] = ACTIONS(9460),
    [anon_sym_STAR_STAR] = ACTIONS(13633),
    [anon_sym_AMP] = ACTIONS(13637),
    [anon_sym_LT] = ACTIONS(13639),
    [anon_sym_QMARK] = ACTIONS(13641),
    [anon_sym_DOT_DOT] = ACTIONS(13643),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13645),
    [anon_sym_and] = ACTIONS(13647),
    [anon_sym_or] = ACTIONS(13647),
    [anon_sym_PIPE_PIPE] = ACTIONS(13649),
    [anon_sym_AMP_AMP] = ACTIONS(13649),
    [anon_sym_LT_LT] = ACTIONS(13651),
    [anon_sym_GT_GT] = ACTIONS(13651),
    [anon_sym_EQ_EQ] = ACTIONS(13653),
    [anon_sym_BANG_EQ] = ACTIONS(13649),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13649),
    [anon_sym_LT_EQ_GT] = ACTIONS(13649),
    [anon_sym_EQ_TILDE] = ACTIONS(13649),
    [anon_sym_BANG_TILDE] = ACTIONS(13649),
    [anon_sym_LT_EQ] = ACTIONS(13639),
    [anon_sym_GT] = ACTIONS(13639),
    [anon_sym_GT_EQ] = ACTIONS(13655),
    [anon_sym_CARET] = ACTIONS(13657),
    [anon_sym_PLUS] = ACTIONS(13631),
    [anon_sym_SLASH] = ACTIONS(13633),
    [anon_sym_PERCENT] = ACTIONS(13633),
    [sym_comment] = ACTIONS(87),
  },
  [8443] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(9957),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9962),
    [sym_scope_resolution] = STATE(9958),
    [sym_call] = STATE(9958),
    [sym_method_call] = STATE(9962),
    [sym_argument_list] = STATE(1681),
    [sym__argument_list_with_parens] = STATE(9959),
    [sym__argument] = STATE(9960),
    [sym_splat_argument] = STATE(9960),
    [sym_hash_splat_argument] = STATE(9960),
    [sym_block_argument] = STATE(9960),
    [sym_do_block] = STATE(1684),
    [sym_block] = STATE(1684),
    [sym_assignment] = STATE(9957),
    [sym_operator_assignment] = STATE(9957),
    [sym_conditional] = STATE(9957),
    [sym_range] = STATE(9957),
    [sym_binary] = STATE(9957),
    [sym_unary] = STATE(9957),
    [sym_left_assignment_list] = STATE(9961),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9962),
    [sym__variable] = STATE(9958),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9962),
    [sym_false] = STATE(9962),
    [sym_nil] = STATE(9962),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(9963),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(9960),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(13659),
    [sym__splat_star] = ACTIONS(13661),
    [sym__unary_minus] = ACTIONS(13663),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(13665),
    [anon_sym_LBRACE] = ACTIONS(2996),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13667),
    [anon_sym_yield] = ACTIONS(13669),
    [anon_sym_break] = ACTIONS(13671),
    [anon_sym_next] = ACTIONS(13673),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(3006),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(13675),
    [anon_sym_not] = ACTIONS(13677),
    [anon_sym_BANG] = ACTIONS(13679),
    [anon_sym_TILDE] = ACTIONS(13681),
    [sym_constant] = ACTIONS(13683),
    [sym_identifier] = ACTIONS(13683),
    [sym_instance_variable] = ACTIONS(13685),
    [sym_class_variable] = ACTIONS(13685),
    [sym_global_variable] = ACTIONS(13685),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13687),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13687),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [8444] = {
    [anon_sym_EQ] = ACTIONS(13689),
    [sym_comment] = ACTIONS(87),
  },
  [8445] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(13691),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(13693),
    [anon_sym_DASH_EQ] = ACTIONS(13693),
    [anon_sym_STAR_EQ] = ACTIONS(13693),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13693),
    [anon_sym_SLASH_EQ] = ACTIONS(13693),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13693),
    [anon_sym_PIPE_EQ] = ACTIONS(13693),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13693),
    [anon_sym_AMP_EQ] = ACTIONS(13693),
    [anon_sym_PERCENT_EQ] = ACTIONS(13693),
    [anon_sym_GT_GT_EQ] = ACTIONS(13693),
    [anon_sym_LT_LT_EQ] = ACTIONS(13693),
    [anon_sym_CARET_EQ] = ACTIONS(13693),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [8446] = {
    [sym_string] = STATE(9966),
    [aux_sym_chained_string_repeat1] = STATE(9966),
    [sym__string_start] = ACTIONS(139),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [8447] = {
    [sym__binary_minus] = ACTIONS(13631),
    [sym__binary_star] = ACTIONS(13633),
    [anon_sym_COMMA] = ACTIONS(9494),
    [anon_sym_PIPE] = ACTIONS(13695),
    [anon_sym_SEMI] = ACTIONS(9494),
    [anon_sym_STAR_STAR] = ACTIONS(13633),
    [anon_sym_AMP] = ACTIONS(13637),
    [anon_sym_LT] = ACTIONS(13639),
    [anon_sym_QMARK] = ACTIONS(13641),
    [anon_sym_DOT_DOT] = ACTIONS(13643),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13645),
    [anon_sym_and] = ACTIONS(13647),
    [anon_sym_or] = ACTIONS(13647),
    [anon_sym_PIPE_PIPE] = ACTIONS(13649),
    [anon_sym_AMP_AMP] = ACTIONS(13649),
    [anon_sym_LT_LT] = ACTIONS(13651),
    [anon_sym_GT_GT] = ACTIONS(13651),
    [anon_sym_EQ_EQ] = ACTIONS(13653),
    [anon_sym_BANG_EQ] = ACTIONS(13649),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13649),
    [anon_sym_LT_EQ_GT] = ACTIONS(13649),
    [anon_sym_EQ_TILDE] = ACTIONS(13649),
    [anon_sym_BANG_TILDE] = ACTIONS(13649),
    [anon_sym_LT_EQ] = ACTIONS(13639),
    [anon_sym_GT] = ACTIONS(13639),
    [anon_sym_GT_EQ] = ACTIONS(13655),
    [anon_sym_CARET] = ACTIONS(13657),
    [anon_sym_PLUS] = ACTIONS(13631),
    [anon_sym_SLASH] = ACTIONS(13633),
    [anon_sym_PERCENT] = ACTIONS(13633),
    [sym_comment] = ACTIONS(87),
  },
  [8448] = {
    [sym_identifier] = ACTIONS(13697),
    [sym_comment] = ACTIONS(87),
  },
  [8449] = {
    [sym__formal_parameter] = STATE(6106),
    [sym__simple_formal_parameter] = STATE(6106),
    [sym_destructured_parameter] = STATE(6106),
    [sym_splat_parameter] = STATE(6106),
    [sym_hash_splat_parameter] = STATE(6106),
    [sym_block_parameter] = STATE(6106),
    [sym_keyword_parameter] = STATE(6106),
    [sym_optional_parameter] = STATE(6106),
    [anon_sym_LPAREN] = ACTIONS(2447),
    [anon_sym_PIPE] = ACTIONS(13593),
    [anon_sym_SEMI] = ACTIONS(13699),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [sym_identifier] = ACTIONS(5745),
    [sym_comment] = ACTIONS(87),
  },
  [8450] = {
    [aux_sym_method_parameters_repeat1] = STATE(8450),
    [anon_sym_COMMA] = ACTIONS(13701),
    [anon_sym_PIPE] = ACTIONS(12039),
    [anon_sym_SEMI] = ACTIONS(12039),
    [sym_comment] = ACTIONS(87),
  },
  [8451] = {
    [anon_sym_RPAREN] = ACTIONS(13704),
    [anon_sym_COMMA] = ACTIONS(13704),
    [anon_sym_PIPE] = ACTIONS(13704),
    [anon_sym_SEMI] = ACTIONS(13704),
    [sym_comment] = ACTIONS(87),
  },
  [8452] = {
    [aux_sym_block_parameters_repeat1] = STATE(9971),
    [anon_sym_COMMA] = ACTIONS(11999),
    [anon_sym_PIPE] = ACTIONS(13706),
    [sym_comment] = ACTIONS(87),
  },
  [8453] = {
    [sym__line_break] = ACTIONS(13597),
    [sym__simple_symbol] = ACTIONS(13597),
    [sym__string_start] = ACTIONS(13597),
    [sym__symbol_start] = ACTIONS(13597),
    [sym__subshell_start] = ACTIONS(13597),
    [sym__regex_start] = ACTIONS(13597),
    [sym__string_array_start] = ACTIONS(13597),
    [sym__symbol_array_start] = ACTIONS(13597),
    [sym__heredoc_body_start] = ACTIONS(13597),
    [sym_heredoc_beginning] = ACTIONS(13597),
    [sym__unary_minus] = ACTIONS(13597),
    [anon_sym_BEGIN] = ACTIONS(13599),
    [anon_sym_LBRACE] = ACTIONS(13597),
    [anon_sym_END] = ACTIONS(13599),
    [anon_sym_def] = ACTIONS(13599),
    [anon_sym_LPAREN] = ACTIONS(13597),
    [anon_sym_COLON_COLON] = ACTIONS(13597),
    [anon_sym_SEMI] = ACTIONS(13597),
    [anon_sym_STAR] = ACTIONS(13597),
    [anon_sym_class] = ACTIONS(13599),
    [anon_sym_module] = ACTIONS(13599),
    [anon_sym_end] = ACTIONS(13599),
    [anon_sym_return] = ACTIONS(13599),
    [anon_sym_yield] = ACTIONS(13599),
    [anon_sym_break] = ACTIONS(13599),
    [anon_sym_next] = ACTIONS(13599),
    [sym_redo] = ACTIONS(13599),
    [sym_retry] = ACTIONS(13599),
    [anon_sym_if] = ACTIONS(13599),
    [anon_sym_unless] = ACTIONS(13599),
    [anon_sym_while] = ACTIONS(13599),
    [anon_sym_until] = ACTIONS(13599),
    [anon_sym_for] = ACTIONS(13599),
    [anon_sym_case] = ACTIONS(13599),
    [anon_sym_begin] = ACTIONS(13599),
    [anon_sym_PLUS] = ACTIONS(13599),
    [anon_sym_defined_QMARK] = ACTIONS(13597),
    [anon_sym_not] = ACTIONS(13599),
    [anon_sym_BANG] = ACTIONS(13597),
    [anon_sym_TILDE] = ACTIONS(13597),
    [sym_constant] = ACTIONS(13599),
    [sym_identifier] = ACTIONS(13599),
    [sym_instance_variable] = ACTIONS(13597),
    [sym_class_variable] = ACTIONS(13597),
    [sym_global_variable] = ACTIONS(13597),
    [anon_sym_undef] = ACTIONS(13599),
    [anon_sym_alias] = ACTIONS(13599),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(13599),
    [sym_float] = ACTIONS(13599),
    [sym_complex] = ACTIONS(13597),
    [sym_super] = ACTIONS(13599),
    [anon_sym_true] = ACTIONS(13599),
    [anon_sym_TRUE] = ACTIONS(13599),
    [anon_sym_false] = ACTIONS(13599),
    [anon_sym_FALSE] = ACTIONS(13599),
    [sym_self] = ACTIONS(13599),
    [anon_sym_nil] = ACTIONS(13599),
    [anon_sym_NIL] = ACTIONS(13599),
    [sym_character] = ACTIONS(13597),
    [anon_sym_LBRACK2] = ACTIONS(13597),
    [anon_sym_DASH_GT] = ACTIONS(13597),
  },
  [8454] = {
    [aux_sym_block_parameters_repeat1] = STATE(9913),
    [anon_sym_COMMA] = ACTIONS(11999),
    [anon_sym_PIPE] = ACTIONS(13706),
    [sym_comment] = ACTIONS(87),
  },
  [8455] = {
    [sym_identifier] = ACTIONS(13708),
    [sym_comment] = ACTIONS(87),
  },
  [8456] = {
    [sym__formal_parameter] = STATE(6106),
    [sym__simple_formal_parameter] = STATE(6106),
    [sym_destructured_parameter] = STATE(6106),
    [sym_splat_parameter] = STATE(6106),
    [sym_hash_splat_parameter] = STATE(6106),
    [sym_block_parameter] = STATE(6106),
    [sym_keyword_parameter] = STATE(6106),
    [sym_optional_parameter] = STATE(6106),
    [anon_sym_LPAREN] = ACTIONS(2447),
    [anon_sym_PIPE] = ACTIONS(13706),
    [anon_sym_SEMI] = ACTIONS(13710),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [sym_identifier] = ACTIONS(5745),
    [sym_comment] = ACTIONS(87),
  },
  [8457] = {
    [sym__line_break] = ACTIONS(13712),
    [sym__heredoc_body_start] = ACTIONS(13712),
    [sym__binary_minus] = ACTIONS(13712),
    [sym__binary_star] = ACTIONS(13712),
    [ts_builtin_sym_end] = ACTIONS(13712),
    [anon_sym___END__] = ACTIONS(13712),
    [anon_sym_LBRACE] = ACTIONS(13712),
    [anon_sym_RBRACE] = ACTIONS(13712),
    [anon_sym_RPAREN] = ACTIONS(13712),
    [anon_sym_DOT] = ACTIONS(13714),
    [anon_sym_COMMA] = ACTIONS(13712),
    [anon_sym_PIPE] = ACTIONS(13714),
    [anon_sym_SEMI] = ACTIONS(13712),
    [anon_sym_STAR_STAR] = ACTIONS(13712),
    [anon_sym_AMP] = ACTIONS(13714),
    [anon_sym_LT] = ACTIONS(13714),
    [anon_sym_end] = ACTIONS(13712),
    [anon_sym_if] = ACTIONS(13712),
    [anon_sym_unless] = ACTIONS(13712),
    [anon_sym_while] = ACTIONS(13712),
    [anon_sym_until] = ACTIONS(13712),
    [anon_sym_rescue] = ACTIONS(13712),
    [anon_sym_do] = ACTIONS(13712),
    [anon_sym_when] = ACTIONS(13712),
    [anon_sym_elsif] = ACTIONS(13712),
    [anon_sym_else] = ACTIONS(13712),
    [anon_sym_then] = ACTIONS(13712),
    [anon_sym_ensure] = ACTIONS(13712),
    [anon_sym_EQ_GT] = ACTIONS(13712),
    [anon_sym_LBRACK] = ACTIONS(13712),
    [anon_sym_COLON_COLON2] = ACTIONS(13712),
    [anon_sym_AMP_DOT] = ACTIONS(13712),
    [anon_sym_QMARK] = ACTIONS(13712),
    [anon_sym_DOT_DOT] = ACTIONS(13714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13712),
    [anon_sym_and] = ACTIONS(13712),
    [anon_sym_or] = ACTIONS(13712),
    [anon_sym_PIPE_PIPE] = ACTIONS(13712),
    [anon_sym_AMP_AMP] = ACTIONS(13712),
    [anon_sym_LT_LT] = ACTIONS(13712),
    [anon_sym_GT_GT] = ACTIONS(13712),
    [anon_sym_EQ_EQ] = ACTIONS(13714),
    [anon_sym_BANG_EQ] = ACTIONS(13712),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13712),
    [anon_sym_LT_EQ_GT] = ACTIONS(13712),
    [anon_sym_EQ_TILDE] = ACTIONS(13712),
    [anon_sym_BANG_TILDE] = ACTIONS(13712),
    [anon_sym_LT_EQ] = ACTIONS(13714),
    [anon_sym_GT] = ACTIONS(13714),
    [anon_sym_GT_EQ] = ACTIONS(13712),
    [anon_sym_CARET] = ACTIONS(13712),
    [anon_sym_PLUS] = ACTIONS(13712),
    [anon_sym_SLASH] = ACTIONS(13712),
    [anon_sym_PERCENT] = ACTIONS(13712),
    [sym_comment] = ACTIONS(87),
  },
  [8458] = {
    [anon_sym_end] = ACTIONS(13716),
    [sym_comment] = ACTIONS(87),
  },
  [8459] = {
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(9458),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(9458),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(9458),
    [anon_sym_PERCENT] = ACTIONS(9458),
    [sym_comment] = ACTIONS(87),
  },
  [8460] = {
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(9458),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [8461] = {
    [sym__binary_minus] = ACTIONS(9456),
    [sym__binary_star] = ACTIONS(9458),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(9458),
    [anon_sym_AMP] = ACTIONS(9464),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(9478),
    [anon_sym_GT_GT] = ACTIONS(9478),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(9456),
    [anon_sym_SLASH] = ACTIONS(9458),
    [anon_sym_PERCENT] = ACTIONS(9458),
    [sym_comment] = ACTIONS(87),
  },
  [8462] = {
    [sym__binary_minus] = ACTIONS(9456),
    [sym__binary_star] = ACTIONS(9458),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(9458),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(9478),
    [anon_sym_GT_GT] = ACTIONS(9478),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(9456),
    [anon_sym_SLASH] = ACTIONS(9458),
    [anon_sym_PERCENT] = ACTIONS(9458),
    [sym_comment] = ACTIONS(87),
  },
  [8463] = {
    [sym__binary_minus] = ACTIONS(9456),
    [sym__binary_star] = ACTIONS(9458),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(9462),
    [anon_sym_STAR_STAR] = ACTIONS(9458),
    [anon_sym_AMP] = ACTIONS(9464),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(9478),
    [anon_sym_GT_GT] = ACTIONS(9478),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(9484),
    [anon_sym_PLUS] = ACTIONS(9456),
    [anon_sym_SLASH] = ACTIONS(9458),
    [anon_sym_PERCENT] = ACTIONS(9458),
    [sym_comment] = ACTIONS(87),
  },
  [8464] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(13718),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [8465] = {
    [sym__binary_minus] = ACTIONS(9456),
    [sym__binary_star] = ACTIONS(9458),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(9462),
    [anon_sym_STAR_STAR] = ACTIONS(9458),
    [anon_sym_AMP] = ACTIONS(9464),
    [anon_sym_LT] = ACTIONS(9466),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(9470),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9472),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(9476),
    [anon_sym_AMP_AMP] = ACTIONS(9476),
    [anon_sym_LT_LT] = ACTIONS(9478),
    [anon_sym_GT_GT] = ACTIONS(9478),
    [anon_sym_EQ_EQ] = ACTIONS(9480),
    [anon_sym_BANG_EQ] = ACTIONS(9476),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9476),
    [anon_sym_LT_EQ_GT] = ACTIONS(9476),
    [anon_sym_EQ_TILDE] = ACTIONS(9476),
    [anon_sym_BANG_TILDE] = ACTIONS(9476),
    [anon_sym_LT_EQ] = ACTIONS(9466),
    [anon_sym_GT] = ACTIONS(9466),
    [anon_sym_GT_EQ] = ACTIONS(9482),
    [anon_sym_CARET] = ACTIONS(9484),
    [anon_sym_PLUS] = ACTIONS(9456),
    [anon_sym_SLASH] = ACTIONS(9458),
    [anon_sym_PERCENT] = ACTIONS(9458),
    [sym_comment] = ACTIONS(87),
  },
  [8466] = {
    [sym__binary_minus] = ACTIONS(9456),
    [sym__binary_star] = ACTIONS(9458),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(9462),
    [anon_sym_STAR_STAR] = ACTIONS(9458),
    [anon_sym_AMP] = ACTIONS(9464),
    [anon_sym_LT] = ACTIONS(9466),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(9468),
    [anon_sym_DOT_DOT] = ACTIONS(9470),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9472),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(9476),
    [anon_sym_AMP_AMP] = ACTIONS(9476),
    [anon_sym_LT_LT] = ACTIONS(9478),
    [anon_sym_GT_GT] = ACTIONS(9478),
    [anon_sym_EQ_EQ] = ACTIONS(9480),
    [anon_sym_BANG_EQ] = ACTIONS(9476),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9476),
    [anon_sym_LT_EQ_GT] = ACTIONS(9476),
    [anon_sym_EQ_TILDE] = ACTIONS(9476),
    [anon_sym_BANG_TILDE] = ACTIONS(9476),
    [anon_sym_LT_EQ] = ACTIONS(9466),
    [anon_sym_GT] = ACTIONS(9466),
    [anon_sym_GT_EQ] = ACTIONS(9482),
    [anon_sym_CARET] = ACTIONS(9484),
    [anon_sym_PLUS] = ACTIONS(9456),
    [anon_sym_SLASH] = ACTIONS(9458),
    [anon_sym_PERCENT] = ACTIONS(9458),
    [sym_comment] = ACTIONS(87),
  },
  [8467] = {
    [sym__binary_minus] = ACTIONS(9456),
    [sym__binary_star] = ACTIONS(9458),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(9462),
    [anon_sym_STAR_STAR] = ACTIONS(9458),
    [anon_sym_AMP] = ACTIONS(9464),
    [anon_sym_LT] = ACTIONS(9466),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(9478),
    [anon_sym_GT_GT] = ACTIONS(9478),
    [anon_sym_EQ_EQ] = ACTIONS(9480),
    [anon_sym_BANG_EQ] = ACTIONS(9476),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9476),
    [anon_sym_LT_EQ_GT] = ACTIONS(9476),
    [anon_sym_EQ_TILDE] = ACTIONS(9476),
    [anon_sym_BANG_TILDE] = ACTIONS(9476),
    [anon_sym_LT_EQ] = ACTIONS(9466),
    [anon_sym_GT] = ACTIONS(9466),
    [anon_sym_GT_EQ] = ACTIONS(9482),
    [anon_sym_CARET] = ACTIONS(9484),
    [anon_sym_PLUS] = ACTIONS(9456),
    [anon_sym_SLASH] = ACTIONS(9458),
    [anon_sym_PERCENT] = ACTIONS(9458),
    [sym_comment] = ACTIONS(87),
  },
  [8468] = {
    [sym__binary_minus] = ACTIONS(9456),
    [sym__binary_star] = ACTIONS(9458),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(9458),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(9456),
    [anon_sym_SLASH] = ACTIONS(9458),
    [anon_sym_PERCENT] = ACTIONS(9458),
    [sym_comment] = ACTIONS(87),
  },
  [8469] = {
    [sym__heredoc_body_start] = ACTIONS(993),
    [sym__binary_minus] = ACTIONS(5735),
    [sym__binary_star] = ACTIONS(5735),
    [anon_sym_LBRACE] = ACTIONS(5735),
    [anon_sym_DOT] = ACTIONS(5737),
    [anon_sym_COMMA] = ACTIONS(5735),
    [anon_sym_PIPE] = ACTIONS(5737),
    [anon_sym_STAR_STAR] = ACTIONS(5737),
    [anon_sym_AMP] = ACTIONS(5737),
    [anon_sym_EQ] = ACTIONS(5737),
    [anon_sym_LT] = ACTIONS(5737),
    [anon_sym_do] = ACTIONS(5735),
    [anon_sym_EQ_GT] = ACTIONS(993),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_COLON_COLON2] = ACTIONS(5735),
    [anon_sym_AMP_DOT] = ACTIONS(5735),
    [anon_sym_PLUS_EQ] = ACTIONS(5735),
    [anon_sym_DASH_EQ] = ACTIONS(5735),
    [anon_sym_STAR_EQ] = ACTIONS(5735),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5735),
    [anon_sym_SLASH_EQ] = ACTIONS(5735),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5735),
    [anon_sym_PIPE_EQ] = ACTIONS(5735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5735),
    [anon_sym_AMP_EQ] = ACTIONS(5735),
    [anon_sym_PERCENT_EQ] = ACTIONS(5735),
    [anon_sym_GT_GT_EQ] = ACTIONS(5735),
    [anon_sym_LT_LT_EQ] = ACTIONS(5735),
    [anon_sym_CARET_EQ] = ACTIONS(5735),
    [anon_sym_QMARK] = ACTIONS(5735),
    [anon_sym_DOT_DOT] = ACTIONS(5737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5735),
    [anon_sym_and] = ACTIONS(5735),
    [anon_sym_or] = ACTIONS(5735),
    [anon_sym_PIPE_PIPE] = ACTIONS(5737),
    [anon_sym_AMP_AMP] = ACTIONS(5737),
    [anon_sym_LT_LT] = ACTIONS(5737),
    [anon_sym_GT_GT] = ACTIONS(5737),
    [anon_sym_EQ_EQ] = ACTIONS(5737),
    [anon_sym_BANG_EQ] = ACTIONS(5735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5735),
    [anon_sym_LT_EQ_GT] = ACTIONS(5735),
    [anon_sym_EQ_TILDE] = ACTIONS(5735),
    [anon_sym_BANG_TILDE] = ACTIONS(5735),
    [anon_sym_LT_EQ] = ACTIONS(5737),
    [anon_sym_GT] = ACTIONS(5737),
    [anon_sym_GT_EQ] = ACTIONS(5735),
    [anon_sym_CARET] = ACTIONS(5737),
    [anon_sym_PLUS] = ACTIONS(5737),
    [anon_sym_SLASH] = ACTIONS(5737),
    [anon_sym_PERCENT] = ACTIONS(5737),
    [sym_comment] = ACTIONS(87),
  },
  [8470] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(9976),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(3496),
    [sym_scope_resolution] = STATE(3494),
    [sym_call] = STATE(3494),
    [sym_method_call] = STATE(3496),
    [sym_assignment] = STATE(9976),
    [sym_operator_assignment] = STATE(9976),
    [sym_conditional] = STATE(9976),
    [sym_range] = STATE(9976),
    [sym_binary] = STATE(9976),
    [sym_unary] = STATE(9976),
    [sym_left_assignment_list] = STATE(3495),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3496),
    [sym__variable] = STATE(3494),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(3496),
    [sym_false] = STATE(3496),
    [sym_nil] = STATE(3496),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(5781),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5785),
    [anon_sym_yield] = ACTIONS(5787),
    [anon_sym_break] = ACTIONS(5789),
    [anon_sym_next] = ACTIONS(5791),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5795),
    [anon_sym_defined_QMARK] = ACTIONS(5797),
    [anon_sym_not] = ACTIONS(5799),
    [anon_sym_BANG] = ACTIONS(5801),
    [anon_sym_TILDE] = ACTIONS(5801),
    [sym_constant] = ACTIONS(5803),
    [sym_identifier] = ACTIONS(5803),
    [sym_instance_variable] = ACTIONS(5805),
    [sym_class_variable] = ACTIONS(5805),
    [sym_global_variable] = ACTIONS(5805),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(5803),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(5803),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8471] = {
    [sym__binary_minus] = ACTIONS(9456),
    [sym__binary_star] = ACTIONS(9458),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(9462),
    [anon_sym_STAR_STAR] = ACTIONS(9458),
    [anon_sym_AMP] = ACTIONS(9464),
    [anon_sym_LT] = ACTIONS(9466),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(9468),
    [anon_sym_DOT_DOT] = ACTIONS(9470),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9472),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(9476),
    [anon_sym_AMP_AMP] = ACTIONS(9476),
    [anon_sym_LT_LT] = ACTIONS(9478),
    [anon_sym_GT_GT] = ACTIONS(9478),
    [anon_sym_EQ_EQ] = ACTIONS(9480),
    [anon_sym_BANG_EQ] = ACTIONS(9476),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9476),
    [anon_sym_LT_EQ_GT] = ACTIONS(9476),
    [anon_sym_EQ_TILDE] = ACTIONS(9476),
    [anon_sym_BANG_TILDE] = ACTIONS(9476),
    [anon_sym_LT_EQ] = ACTIONS(9466),
    [anon_sym_GT] = ACTIONS(9466),
    [anon_sym_GT_EQ] = ACTIONS(9482),
    [anon_sym_CARET] = ACTIONS(9484),
    [anon_sym_PLUS] = ACTIONS(9456),
    [anon_sym_SLASH] = ACTIONS(9458),
    [anon_sym_PERCENT] = ACTIONS(9458),
    [sym_comment] = ACTIONS(87),
  },
  [8472] = {
    [aux_sym_exceptions_repeat1] = STATE(9978),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [8473] = {
    [sym__binary_minus] = ACTIONS(9456),
    [sym__binary_star] = ACTIONS(9458),
    [anon_sym_LBRACE] = ACTIONS(6210),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(9462),
    [anon_sym_STAR_STAR] = ACTIONS(9458),
    [anon_sym_AMP] = ACTIONS(9464),
    [anon_sym_LT] = ACTIONS(9466),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(9468),
    [anon_sym_DOT_DOT] = ACTIONS(9470),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9472),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(9476),
    [anon_sym_AMP_AMP] = ACTIONS(9476),
    [anon_sym_LT_LT] = ACTIONS(9478),
    [anon_sym_GT_GT] = ACTIONS(9478),
    [anon_sym_EQ_EQ] = ACTIONS(9480),
    [anon_sym_BANG_EQ] = ACTIONS(9476),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9476),
    [anon_sym_LT_EQ_GT] = ACTIONS(9476),
    [anon_sym_EQ_TILDE] = ACTIONS(9476),
    [anon_sym_BANG_TILDE] = ACTIONS(9476),
    [anon_sym_LT_EQ] = ACTIONS(9466),
    [anon_sym_GT] = ACTIONS(9466),
    [anon_sym_GT_EQ] = ACTIONS(9482),
    [anon_sym_CARET] = ACTIONS(9484),
    [anon_sym_PLUS] = ACTIONS(9456),
    [anon_sym_SLASH] = ACTIONS(9458),
    [anon_sym_PERCENT] = ACTIONS(9458),
    [sym_comment] = ACTIONS(87),
  },
  [8474] = {
    [sym_string] = STATE(8474),
    [aux_sym_chained_string_repeat1] = STATE(8474),
    [sym__string_start] = ACTIONS(7159),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_do] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [8475] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(12068),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_COLON2] = ACTIONS(937),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [8476] = {
    [sym_heredoc_body] = STATE(9979),
    [aux_sym_call_repeat1] = STATE(9979),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_COLON2] = ACTIONS(1685),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [8477] = {
    [sym_heredoc_body] = STATE(9979),
    [aux_sym_call_repeat1] = STATE(9979),
    [aux_sym_argument_list_repeat1] = STATE(9980),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(9577),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_COLON2] = ACTIONS(1685),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [8478] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(12066),
    [sym__binary_star] = ACTIONS(12068),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(12070),
    [anon_sym_STAR_STAR] = ACTIONS(12068),
    [anon_sym_AMP] = ACTIONS(12072),
    [anon_sym_LT] = ACTIONS(12074),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(12076),
    [anon_sym_COLON2] = ACTIONS(937),
    [anon_sym_DOT_DOT] = ACTIONS(12078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12080),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(12082),
    [anon_sym_AMP_AMP] = ACTIONS(12082),
    [anon_sym_LT_LT] = ACTIONS(12084),
    [anon_sym_GT_GT] = ACTIONS(12084),
    [anon_sym_EQ_EQ] = ACTIONS(12086),
    [anon_sym_BANG_EQ] = ACTIONS(12082),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12082),
    [anon_sym_LT_EQ_GT] = ACTIONS(12082),
    [anon_sym_EQ_TILDE] = ACTIONS(12082),
    [anon_sym_BANG_TILDE] = ACTIONS(12082),
    [anon_sym_LT_EQ] = ACTIONS(12074),
    [anon_sym_GT] = ACTIONS(12074),
    [anon_sym_GT_EQ] = ACTIONS(12088),
    [anon_sym_CARET] = ACTIONS(12090),
    [anon_sym_PLUS] = ACTIONS(12066),
    [anon_sym_SLASH] = ACTIONS(12068),
    [anon_sym_PERCENT] = ACTIONS(12068),
    [sym_comment] = ACTIONS(87),
  },
  [8479] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9981),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(6145),
    [sym_scope_resolution] = STATE(6143),
    [sym_call] = STATE(6143),
    [sym_method_call] = STATE(6145),
    [sym_assignment] = STATE(9981),
    [sym_operator_assignment] = STATE(9981),
    [sym_conditional] = STATE(9981),
    [sym_range] = STATE(9981),
    [sym_binary] = STATE(9981),
    [sym_unary] = STATE(9981),
    [sym_left_assignment_list] = STATE(6144),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6145),
    [sym__variable] = STATE(6143),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(6145),
    [sym_false] = STATE(6145),
    [sym_nil] = STATE(6145),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(6146),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9505),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9507),
    [anon_sym_yield] = ACTIONS(9509),
    [anon_sym_break] = ACTIONS(9511),
    [anon_sym_next] = ACTIONS(9513),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9515),
    [anon_sym_defined_QMARK] = ACTIONS(9517),
    [anon_sym_not] = ACTIONS(9519),
    [anon_sym_BANG] = ACTIONS(9521),
    [anon_sym_TILDE] = ACTIONS(9521),
    [sym_constant] = ACTIONS(9523),
    [sym_identifier] = ACTIONS(9523),
    [sym_instance_variable] = ACTIONS(9525),
    [sym_class_variable] = ACTIONS(9525),
    [sym_global_variable] = ACTIONS(9525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(9523),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9523),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8480] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9982),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(6145),
    [sym_scope_resolution] = STATE(6143),
    [sym_call] = STATE(6143),
    [sym_method_call] = STATE(6145),
    [sym_assignment] = STATE(9982),
    [sym_operator_assignment] = STATE(9982),
    [sym_conditional] = STATE(9982),
    [sym_range] = STATE(9982),
    [sym_binary] = STATE(9982),
    [sym_unary] = STATE(9982),
    [sym_left_assignment_list] = STATE(6144),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6145),
    [sym__variable] = STATE(6143),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(6145),
    [sym_false] = STATE(6145),
    [sym_nil] = STATE(6145),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(6146),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9505),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9507),
    [anon_sym_yield] = ACTIONS(9509),
    [anon_sym_break] = ACTIONS(9511),
    [anon_sym_next] = ACTIONS(9513),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9515),
    [anon_sym_defined_QMARK] = ACTIONS(9517),
    [anon_sym_not] = ACTIONS(9519),
    [anon_sym_BANG] = ACTIONS(9521),
    [anon_sym_TILDE] = ACTIONS(9521),
    [sym_constant] = ACTIONS(9523),
    [sym_identifier] = ACTIONS(9523),
    [sym_instance_variable] = ACTIONS(9525),
    [sym_class_variable] = ACTIONS(9525),
    [sym_global_variable] = ACTIONS(9525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(9523),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9523),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8481] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9983),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(6145),
    [sym_scope_resolution] = STATE(6143),
    [sym_call] = STATE(6143),
    [sym_method_call] = STATE(6145),
    [sym_assignment] = STATE(9983),
    [sym_operator_assignment] = STATE(9983),
    [sym_conditional] = STATE(9983),
    [sym_range] = STATE(9983),
    [sym_binary] = STATE(9983),
    [sym_unary] = STATE(9983),
    [sym_left_assignment_list] = STATE(6144),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6145),
    [sym__variable] = STATE(6143),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(6145),
    [sym_false] = STATE(6145),
    [sym_nil] = STATE(6145),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(6146),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9505),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9507),
    [anon_sym_yield] = ACTIONS(9509),
    [anon_sym_break] = ACTIONS(9511),
    [anon_sym_next] = ACTIONS(9513),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9515),
    [anon_sym_defined_QMARK] = ACTIONS(9517),
    [anon_sym_not] = ACTIONS(9519),
    [anon_sym_BANG] = ACTIONS(9521),
    [anon_sym_TILDE] = ACTIONS(9521),
    [sym_constant] = ACTIONS(9523),
    [sym_identifier] = ACTIONS(9523),
    [sym_instance_variable] = ACTIONS(9525),
    [sym_class_variable] = ACTIONS(9525),
    [sym_global_variable] = ACTIONS(9525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(9523),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9523),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8482] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9984),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(6145),
    [sym_scope_resolution] = STATE(6143),
    [sym_call] = STATE(6143),
    [sym_method_call] = STATE(6145),
    [sym_assignment] = STATE(9984),
    [sym_operator_assignment] = STATE(9984),
    [sym_conditional] = STATE(9984),
    [sym_range] = STATE(9984),
    [sym_binary] = STATE(9984),
    [sym_unary] = STATE(9984),
    [sym_left_assignment_list] = STATE(6144),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6145),
    [sym__variable] = STATE(6143),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(6145),
    [sym_false] = STATE(6145),
    [sym_nil] = STATE(6145),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(6146),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9505),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9507),
    [anon_sym_yield] = ACTIONS(9509),
    [anon_sym_break] = ACTIONS(9511),
    [anon_sym_next] = ACTIONS(9513),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9515),
    [anon_sym_defined_QMARK] = ACTIONS(9517),
    [anon_sym_not] = ACTIONS(9519),
    [anon_sym_BANG] = ACTIONS(9521),
    [anon_sym_TILDE] = ACTIONS(9521),
    [sym_constant] = ACTIONS(9523),
    [sym_identifier] = ACTIONS(9523),
    [sym_instance_variable] = ACTIONS(9525),
    [sym_class_variable] = ACTIONS(9525),
    [sym_global_variable] = ACTIONS(9525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(9523),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9523),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8483] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9985),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(6145),
    [sym_scope_resolution] = STATE(6143),
    [sym_call] = STATE(6143),
    [sym_method_call] = STATE(6145),
    [sym_assignment] = STATE(9985),
    [sym_operator_assignment] = STATE(9985),
    [sym_conditional] = STATE(9985),
    [sym_range] = STATE(9985),
    [sym_binary] = STATE(9985),
    [sym_unary] = STATE(9985),
    [sym_left_assignment_list] = STATE(6144),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6145),
    [sym__variable] = STATE(6143),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(6145),
    [sym_false] = STATE(6145),
    [sym_nil] = STATE(6145),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(6146),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9505),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9507),
    [anon_sym_yield] = ACTIONS(9509),
    [anon_sym_break] = ACTIONS(9511),
    [anon_sym_next] = ACTIONS(9513),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9515),
    [anon_sym_defined_QMARK] = ACTIONS(9517),
    [anon_sym_not] = ACTIONS(9519),
    [anon_sym_BANG] = ACTIONS(9521),
    [anon_sym_TILDE] = ACTIONS(9521),
    [sym_constant] = ACTIONS(9523),
    [sym_identifier] = ACTIONS(9523),
    [sym_instance_variable] = ACTIONS(9525),
    [sym_class_variable] = ACTIONS(9525),
    [sym_global_variable] = ACTIONS(9525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(9523),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9523),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8484] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(9986),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(9986),
    [sym_operator_assignment] = STATE(9986),
    [sym_conditional] = STATE(9986),
    [sym_range] = STATE(9986),
    [sym_binary] = STATE(9986),
    [sym_unary] = STATE(9986),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8485] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9987),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(6145),
    [sym_scope_resolution] = STATE(6143),
    [sym_call] = STATE(6143),
    [sym_method_call] = STATE(6145),
    [sym_assignment] = STATE(9987),
    [sym_operator_assignment] = STATE(9987),
    [sym_conditional] = STATE(9987),
    [sym_range] = STATE(9987),
    [sym_binary] = STATE(9987),
    [sym_unary] = STATE(9987),
    [sym_left_assignment_list] = STATE(6144),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6145),
    [sym__variable] = STATE(6143),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(6145),
    [sym_false] = STATE(6145),
    [sym_nil] = STATE(6145),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(6146),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9505),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9507),
    [anon_sym_yield] = ACTIONS(9509),
    [anon_sym_break] = ACTIONS(9511),
    [anon_sym_next] = ACTIONS(9513),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9515),
    [anon_sym_defined_QMARK] = ACTIONS(9517),
    [anon_sym_not] = ACTIONS(9519),
    [anon_sym_BANG] = ACTIONS(9521),
    [anon_sym_TILDE] = ACTIONS(9521),
    [sym_constant] = ACTIONS(9523),
    [sym_identifier] = ACTIONS(9523),
    [sym_instance_variable] = ACTIONS(9525),
    [sym_class_variable] = ACTIONS(9525),
    [sym_global_variable] = ACTIONS(9525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(9523),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9523),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8486] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9988),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(6145),
    [sym_scope_resolution] = STATE(6143),
    [sym_call] = STATE(6143),
    [sym_method_call] = STATE(6145),
    [sym_assignment] = STATE(9988),
    [sym_operator_assignment] = STATE(9988),
    [sym_conditional] = STATE(9988),
    [sym_range] = STATE(9988),
    [sym_binary] = STATE(9988),
    [sym_unary] = STATE(9988),
    [sym_left_assignment_list] = STATE(6144),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6145),
    [sym__variable] = STATE(6143),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(6145),
    [sym_false] = STATE(6145),
    [sym_nil] = STATE(6145),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(6146),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9505),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9507),
    [anon_sym_yield] = ACTIONS(9509),
    [anon_sym_break] = ACTIONS(9511),
    [anon_sym_next] = ACTIONS(9513),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9515),
    [anon_sym_defined_QMARK] = ACTIONS(9517),
    [anon_sym_not] = ACTIONS(9519),
    [anon_sym_BANG] = ACTIONS(9521),
    [anon_sym_TILDE] = ACTIONS(9521),
    [sym_constant] = ACTIONS(9523),
    [sym_identifier] = ACTIONS(9523),
    [sym_instance_variable] = ACTIONS(9525),
    [sym_class_variable] = ACTIONS(9525),
    [sym_global_variable] = ACTIONS(9525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(9523),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9523),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8487] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9989),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(6145),
    [sym_scope_resolution] = STATE(6143),
    [sym_call] = STATE(6143),
    [sym_method_call] = STATE(6145),
    [sym_assignment] = STATE(9989),
    [sym_operator_assignment] = STATE(9989),
    [sym_conditional] = STATE(9989),
    [sym_range] = STATE(9989),
    [sym_binary] = STATE(9989),
    [sym_unary] = STATE(9989),
    [sym_left_assignment_list] = STATE(6144),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6145),
    [sym__variable] = STATE(6143),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(6145),
    [sym_false] = STATE(6145),
    [sym_nil] = STATE(6145),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(6146),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9505),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9507),
    [anon_sym_yield] = ACTIONS(9509),
    [anon_sym_break] = ACTIONS(9511),
    [anon_sym_next] = ACTIONS(9513),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9515),
    [anon_sym_defined_QMARK] = ACTIONS(9517),
    [anon_sym_not] = ACTIONS(9519),
    [anon_sym_BANG] = ACTIONS(9521),
    [anon_sym_TILDE] = ACTIONS(9521),
    [sym_constant] = ACTIONS(9523),
    [sym_identifier] = ACTIONS(9523),
    [sym_instance_variable] = ACTIONS(9525),
    [sym_class_variable] = ACTIONS(9525),
    [sym_global_variable] = ACTIONS(9525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(9523),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9523),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8488] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9990),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(6145),
    [sym_scope_resolution] = STATE(6143),
    [sym_call] = STATE(6143),
    [sym_method_call] = STATE(6145),
    [sym_assignment] = STATE(9990),
    [sym_operator_assignment] = STATE(9990),
    [sym_conditional] = STATE(9990),
    [sym_range] = STATE(9990),
    [sym_binary] = STATE(9990),
    [sym_unary] = STATE(9990),
    [sym_left_assignment_list] = STATE(6144),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6145),
    [sym__variable] = STATE(6143),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(6145),
    [sym_false] = STATE(6145),
    [sym_nil] = STATE(6145),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(6146),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9505),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9507),
    [anon_sym_yield] = ACTIONS(9509),
    [anon_sym_break] = ACTIONS(9511),
    [anon_sym_next] = ACTIONS(9513),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9515),
    [anon_sym_defined_QMARK] = ACTIONS(9517),
    [anon_sym_not] = ACTIONS(9519),
    [anon_sym_BANG] = ACTIONS(9521),
    [anon_sym_TILDE] = ACTIONS(9521),
    [sym_constant] = ACTIONS(9523),
    [sym_identifier] = ACTIONS(9523),
    [sym_instance_variable] = ACTIONS(9525),
    [sym_class_variable] = ACTIONS(9525),
    [sym_global_variable] = ACTIONS(9525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(9523),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9523),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8489] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9991),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(6145),
    [sym_scope_resolution] = STATE(6143),
    [sym_call] = STATE(6143),
    [sym_method_call] = STATE(6145),
    [sym_splat_argument] = STATE(9992),
    [sym_assignment] = STATE(9991),
    [sym_operator_assignment] = STATE(9991),
    [sym_conditional] = STATE(9991),
    [sym_range] = STATE(9991),
    [sym_binary] = STATE(9991),
    [sym_unary] = STATE(9991),
    [sym_right_assignment_list] = STATE(4255),
    [sym__arg_or_splat_arg] = STATE(9992),
    [sym_left_assignment_list] = STATE(6144),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6145),
    [sym__variable] = STATE(6143),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(6145),
    [sym_false] = STATE(6145),
    [sym_nil] = STATE(6145),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(6146),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(5833),
    [sym__unary_minus] = ACTIONS(9505),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9507),
    [anon_sym_yield] = ACTIONS(9509),
    [anon_sym_break] = ACTIONS(9511),
    [anon_sym_next] = ACTIONS(9513),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9515),
    [anon_sym_defined_QMARK] = ACTIONS(9517),
    [anon_sym_not] = ACTIONS(9519),
    [anon_sym_BANG] = ACTIONS(9521),
    [anon_sym_TILDE] = ACTIONS(9521),
    [sym_constant] = ACTIONS(9523),
    [sym_identifier] = ACTIONS(9523),
    [sym_instance_variable] = ACTIONS(9525),
    [sym_class_variable] = ACTIONS(9525),
    [sym_global_variable] = ACTIONS(9525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(9523),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9523),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8490] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9993),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(6145),
    [sym_scope_resolution] = STATE(6143),
    [sym_call] = STATE(6143),
    [sym_method_call] = STATE(6145),
    [sym_assignment] = STATE(9993),
    [sym_operator_assignment] = STATE(9993),
    [sym_conditional] = STATE(9993),
    [sym_range] = STATE(9993),
    [sym_binary] = STATE(9993),
    [sym_unary] = STATE(9993),
    [sym_left_assignment_list] = STATE(6144),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6145),
    [sym__variable] = STATE(6143),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(6145),
    [sym_false] = STATE(6145),
    [sym_nil] = STATE(6145),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(6146),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9505),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9507),
    [anon_sym_yield] = ACTIONS(9509),
    [anon_sym_break] = ACTIONS(9511),
    [anon_sym_next] = ACTIONS(9513),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9515),
    [anon_sym_defined_QMARK] = ACTIONS(9517),
    [anon_sym_not] = ACTIONS(9519),
    [anon_sym_BANG] = ACTIONS(9521),
    [anon_sym_TILDE] = ACTIONS(9521),
    [sym_constant] = ACTIONS(9523),
    [sym_identifier] = ACTIONS(9523),
    [sym_instance_variable] = ACTIONS(9525),
    [sym_class_variable] = ACTIONS(9525),
    [sym_global_variable] = ACTIONS(9525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(9523),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9523),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8491] = {
    [sym_string] = STATE(9994),
    [aux_sym_chained_string_repeat1] = STATE(9994),
    [sym__string_start] = ACTIONS(4007),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_COLON2] = ACTIONS(2755),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [8492] = {
    [sym__string_start] = ACTIONS(835),
    [sym__heredoc_body_start] = ACTIONS(835),
    [sym__binary_minus] = ACTIONS(835),
    [sym__binary_star] = ACTIONS(835),
    [anon_sym_DOT] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(835),
    [anon_sym_PIPE] = ACTIONS(837),
    [anon_sym_STAR_STAR] = ACTIONS(835),
    [anon_sym_AMP] = ACTIONS(837),
    [anon_sym_LT] = ACTIONS(837),
    [anon_sym_EQ_GT] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_COLON_COLON2] = ACTIONS(835),
    [anon_sym_AMP_DOT] = ACTIONS(835),
    [anon_sym_QMARK] = ACTIONS(835),
    [anon_sym_COLON2] = ACTIONS(837),
    [anon_sym_DOT_DOT] = ACTIONS(837),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(835),
    [anon_sym_and] = ACTIONS(835),
    [anon_sym_or] = ACTIONS(835),
    [anon_sym_PIPE_PIPE] = ACTIONS(835),
    [anon_sym_AMP_AMP] = ACTIONS(835),
    [anon_sym_LT_LT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(835),
    [anon_sym_EQ_EQ] = ACTIONS(837),
    [anon_sym_BANG_EQ] = ACTIONS(835),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(835),
    [anon_sym_LT_EQ_GT] = ACTIONS(835),
    [anon_sym_EQ_TILDE] = ACTIONS(835),
    [anon_sym_BANG_TILDE] = ACTIONS(835),
    [anon_sym_LT_EQ] = ACTIONS(837),
    [anon_sym_GT] = ACTIONS(837),
    [anon_sym_GT_EQ] = ACTIONS(835),
    [anon_sym_CARET] = ACTIONS(835),
    [anon_sym_PLUS] = ACTIONS(835),
    [anon_sym_SLASH] = ACTIONS(835),
    [anon_sym_PERCENT] = ACTIONS(835),
    [sym_comment] = ACTIONS(87),
  },
  [8493] = {
    [sym__string_end] = ACTIONS(13720),
    [sym_comment] = ACTIONS(87),
  },
  [8494] = {
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(12066),
    [sym__binary_star] = ACTIONS(12068),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(12070),
    [anon_sym_STAR_STAR] = ACTIONS(12068),
    [anon_sym_AMP] = ACTIONS(12072),
    [anon_sym_LT] = ACTIONS(12074),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(12076),
    [anon_sym_COLON2] = ACTIONS(7822),
    [anon_sym_DOT_DOT] = ACTIONS(12078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12080),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(12082),
    [anon_sym_AMP_AMP] = ACTIONS(12082),
    [anon_sym_LT_LT] = ACTIONS(12084),
    [anon_sym_GT_GT] = ACTIONS(12084),
    [anon_sym_EQ_EQ] = ACTIONS(12086),
    [anon_sym_BANG_EQ] = ACTIONS(12082),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12082),
    [anon_sym_LT_EQ_GT] = ACTIONS(12082),
    [anon_sym_EQ_TILDE] = ACTIONS(12082),
    [anon_sym_BANG_TILDE] = ACTIONS(12082),
    [anon_sym_LT_EQ] = ACTIONS(12074),
    [anon_sym_GT] = ACTIONS(12074),
    [anon_sym_GT_EQ] = ACTIONS(12088),
    [anon_sym_CARET] = ACTIONS(12090),
    [anon_sym_PLUS] = ACTIONS(12066),
    [anon_sym_SLASH] = ACTIONS(12068),
    [anon_sym_PERCENT] = ACTIONS(12068),
    [sym_comment] = ACTIONS(87),
  },
  [8495] = {
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(9543),
    [sym__binary_star] = ACTIONS(9545),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(9547),
    [anon_sym_STAR_STAR] = ACTIONS(9545),
    [anon_sym_AMP] = ACTIONS(9549),
    [anon_sym_LT] = ACTIONS(9551),
    [anon_sym_EQ_GT] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(9553),
    [anon_sym_COLON2] = ACTIONS(4217),
    [anon_sym_DOT_DOT] = ACTIONS(9555),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9557),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(9559),
    [anon_sym_AMP_AMP] = ACTIONS(9559),
    [anon_sym_LT_LT] = ACTIONS(9561),
    [anon_sym_GT_GT] = ACTIONS(9561),
    [anon_sym_EQ_EQ] = ACTIONS(9563),
    [anon_sym_BANG_EQ] = ACTIONS(9559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9559),
    [anon_sym_LT_EQ_GT] = ACTIONS(9559),
    [anon_sym_EQ_TILDE] = ACTIONS(9559),
    [anon_sym_BANG_TILDE] = ACTIONS(9559),
    [anon_sym_LT_EQ] = ACTIONS(9551),
    [anon_sym_GT] = ACTIONS(9551),
    [anon_sym_GT_EQ] = ACTIONS(9565),
    [anon_sym_CARET] = ACTIONS(9567),
    [anon_sym_PLUS] = ACTIONS(9543),
    [anon_sym_SLASH] = ACTIONS(9545),
    [anon_sym_PERCENT] = ACTIONS(9545),
    [sym_comment] = ACTIONS(87),
  },
  [8496] = {
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(9543),
    [sym__binary_star] = ACTIONS(9545),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(9547),
    [anon_sym_STAR_STAR] = ACTIONS(9545),
    [anon_sym_AMP] = ACTIONS(9549),
    [anon_sym_LT] = ACTIONS(9551),
    [anon_sym_EQ_GT] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(9553),
    [anon_sym_COLON2] = ACTIONS(4249),
    [anon_sym_DOT_DOT] = ACTIONS(9555),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9557),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(9559),
    [anon_sym_AMP_AMP] = ACTIONS(9559),
    [anon_sym_LT_LT] = ACTIONS(9561),
    [anon_sym_GT_GT] = ACTIONS(9561),
    [anon_sym_EQ_EQ] = ACTIONS(9563),
    [anon_sym_BANG_EQ] = ACTIONS(9559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9559),
    [anon_sym_LT_EQ_GT] = ACTIONS(9559),
    [anon_sym_EQ_TILDE] = ACTIONS(9559),
    [anon_sym_BANG_TILDE] = ACTIONS(9559),
    [anon_sym_LT_EQ] = ACTIONS(9551),
    [anon_sym_GT] = ACTIONS(9551),
    [anon_sym_GT_EQ] = ACTIONS(9565),
    [anon_sym_CARET] = ACTIONS(9567),
    [anon_sym_PLUS] = ACTIONS(9543),
    [anon_sym_SLASH] = ACTIONS(9545),
    [anon_sym_PERCENT] = ACTIONS(9545),
    [sym_comment] = ACTIONS(87),
  },
  [8497] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(9996),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(3522),
    [sym_scope_resolution] = STATE(3518),
    [sym_call] = STATE(3518),
    [sym_method_call] = STATE(3522),
    [sym_assignment] = STATE(9996),
    [sym_operator_assignment] = STATE(9996),
    [sym_conditional] = STATE(9996),
    [sym_range] = STATE(9996),
    [sym_binary] = STATE(9996),
    [sym_unary] = STATE(9996),
    [sym_left_assignment_list] = STATE(3521),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3522),
    [sym__variable] = STATE(3518),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(3522),
    [sym_false] = STATE(3522),
    [sym_nil] = STATE(3522),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(6150),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(9527),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(5835),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5839),
    [anon_sym_yield] = ACTIONS(5841),
    [anon_sym_break] = ACTIONS(5843),
    [anon_sym_next] = ACTIONS(5845),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9529),
    [anon_sym_defined_QMARK] = ACTIONS(5847),
    [anon_sym_not] = ACTIONS(5849),
    [anon_sym_BANG] = ACTIONS(5853),
    [anon_sym_TILDE] = ACTIONS(5853),
    [sym_constant] = ACTIONS(5859),
    [sym_identifier] = ACTIONS(5859),
    [sym_instance_variable] = ACTIONS(5857),
    [sym_class_variable] = ACTIONS(5857),
    [sym_global_variable] = ACTIONS(5857),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5859),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5859),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8498] = {
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(9543),
    [sym__binary_star] = ACTIONS(9545),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(9547),
    [anon_sym_STAR_STAR] = ACTIONS(9545),
    [anon_sym_AMP] = ACTIONS(9549),
    [anon_sym_LT] = ACTIONS(9551),
    [anon_sym_EQ_GT] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(9553),
    [anon_sym_COLON2] = ACTIONS(4251),
    [anon_sym_DOT_DOT] = ACTIONS(9555),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9557),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(9559),
    [anon_sym_AMP_AMP] = ACTIONS(9559),
    [anon_sym_LT_LT] = ACTIONS(9561),
    [anon_sym_GT_GT] = ACTIONS(9561),
    [anon_sym_EQ_EQ] = ACTIONS(9563),
    [anon_sym_BANG_EQ] = ACTIONS(9559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9559),
    [anon_sym_LT_EQ_GT] = ACTIONS(9559),
    [anon_sym_EQ_TILDE] = ACTIONS(9559),
    [anon_sym_BANG_TILDE] = ACTIONS(9559),
    [anon_sym_LT_EQ] = ACTIONS(9551),
    [anon_sym_GT] = ACTIONS(9551),
    [anon_sym_GT_EQ] = ACTIONS(9565),
    [anon_sym_CARET] = ACTIONS(9567),
    [anon_sym_PLUS] = ACTIONS(9543),
    [anon_sym_SLASH] = ACTIONS(9545),
    [anon_sym_PERCENT] = ACTIONS(9545),
    [sym_comment] = ACTIONS(87),
  },
  [8499] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(9997),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(3522),
    [sym_scope_resolution] = STATE(3518),
    [sym_call] = STATE(3518),
    [sym_method_call] = STATE(3522),
    [sym_assignment] = STATE(9997),
    [sym_operator_assignment] = STATE(9997),
    [sym_conditional] = STATE(9997),
    [sym_range] = STATE(9997),
    [sym_binary] = STATE(9997),
    [sym_unary] = STATE(9997),
    [sym_left_assignment_list] = STATE(3521),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3522),
    [sym__variable] = STATE(3518),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(3522),
    [sym_false] = STATE(3522),
    [sym_nil] = STATE(3522),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(6150),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(9527),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(5835),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5839),
    [anon_sym_yield] = ACTIONS(5841),
    [anon_sym_break] = ACTIONS(5843),
    [anon_sym_next] = ACTIONS(5845),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9529),
    [anon_sym_defined_QMARK] = ACTIONS(5847),
    [anon_sym_not] = ACTIONS(5849),
    [anon_sym_BANG] = ACTIONS(5853),
    [anon_sym_TILDE] = ACTIONS(5853),
    [sym_constant] = ACTIONS(5859),
    [sym_identifier] = ACTIONS(5859),
    [sym_instance_variable] = ACTIONS(5857),
    [sym_class_variable] = ACTIONS(5857),
    [sym_global_variable] = ACTIONS(5857),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5859),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5859),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8500] = {
    [sym_heredoc_body] = STATE(9998),
    [aux_sym_call_repeat1] = STATE(9998),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_COLON2] = ACTIONS(4385),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [8501] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(6158),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(3522),
    [sym_scope_resolution] = STATE(3518),
    [sym_call] = STATE(3518),
    [sym_method_call] = STATE(3522),
    [sym__argument] = STATE(4250),
    [sym_splat_argument] = STATE(4250),
    [sym_hash_splat_argument] = STATE(4250),
    [sym_block_argument] = STATE(4250),
    [sym_assignment] = STATE(6158),
    [sym_operator_assignment] = STATE(6158),
    [sym_conditional] = STATE(6158),
    [sym_range] = STATE(6158),
    [sym_binary] = STATE(6158),
    [sym_unary] = STATE(6158),
    [sym_left_assignment_list] = STATE(3521),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3522),
    [sym__variable] = STATE(3518),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(3522),
    [sym_false] = STATE(3522),
    [sym_nil] = STATE(3522),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(6161),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_heredoc_body] = STATE(9999),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(4250),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(9533),
    [sym__splat_star] = ACTIONS(9535),
    [sym__unary_minus] = ACTIONS(5835),
    [sym__identifier_hash_key] = ACTIONS(9537),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13722),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5839),
    [anon_sym_yield] = ACTIONS(5841),
    [anon_sym_break] = ACTIONS(5843),
    [anon_sym_next] = ACTIONS(5845),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9529),
    [anon_sym_defined_QMARK] = ACTIONS(5847),
    [anon_sym_not] = ACTIONS(5849),
    [anon_sym_BANG] = ACTIONS(5853),
    [anon_sym_TILDE] = ACTIONS(5853),
    [sym_constant] = ACTIONS(9539),
    [sym_identifier] = ACTIONS(9539),
    [sym_instance_variable] = ACTIONS(5857),
    [sym_class_variable] = ACTIONS(5857),
    [sym_global_variable] = ACTIONS(5857),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5859),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5859),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8502] = {
    [sym_heredoc_body] = STATE(10000),
    [aux_sym_call_repeat1] = STATE(10000),
    [aux_sym_argument_list_repeat1] = STATE(10001),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(12104),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_COLON2] = ACTIONS(4385),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [8503] = {
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(12066),
    [sym__binary_star] = ACTIONS(12068),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(12070),
    [anon_sym_STAR_STAR] = ACTIONS(12068),
    [anon_sym_AMP] = ACTIONS(12072),
    [anon_sym_LT] = ACTIONS(12074),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(12076),
    [anon_sym_COLON2] = ACTIONS(7884),
    [anon_sym_DOT_DOT] = ACTIONS(12078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12080),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(12082),
    [anon_sym_AMP_AMP] = ACTIONS(12082),
    [anon_sym_LT_LT] = ACTIONS(12084),
    [anon_sym_GT_GT] = ACTIONS(12084),
    [anon_sym_EQ_EQ] = ACTIONS(12086),
    [anon_sym_BANG_EQ] = ACTIONS(12082),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12082),
    [anon_sym_LT_EQ_GT] = ACTIONS(12082),
    [anon_sym_EQ_TILDE] = ACTIONS(12082),
    [anon_sym_BANG_TILDE] = ACTIONS(12082),
    [anon_sym_LT_EQ] = ACTIONS(12074),
    [anon_sym_GT] = ACTIONS(12074),
    [anon_sym_GT_EQ] = ACTIONS(12088),
    [anon_sym_CARET] = ACTIONS(12090),
    [anon_sym_PLUS] = ACTIONS(12066),
    [anon_sym_SLASH] = ACTIONS(12068),
    [anon_sym_PERCENT] = ACTIONS(12068),
    [sym_comment] = ACTIONS(87),
  },
  [8504] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(9545),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(9545),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_COLON2] = ACTIONS(5827),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(9545),
    [anon_sym_PERCENT] = ACTIONS(9545),
    [sym_comment] = ACTIONS(87),
  },
  [8505] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(9545),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_COLON2] = ACTIONS(5827),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [8506] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(9543),
    [sym__binary_star] = ACTIONS(9545),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(9545),
    [anon_sym_AMP] = ACTIONS(9549),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_COLON2] = ACTIONS(5827),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(9561),
    [anon_sym_GT_GT] = ACTIONS(9561),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(9543),
    [anon_sym_SLASH] = ACTIONS(9545),
    [anon_sym_PERCENT] = ACTIONS(9545),
    [sym_comment] = ACTIONS(87),
  },
  [8507] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(9543),
    [sym__binary_star] = ACTIONS(9545),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(9545),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_COLON2] = ACTIONS(5827),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(9561),
    [anon_sym_GT_GT] = ACTIONS(9561),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(9543),
    [anon_sym_SLASH] = ACTIONS(9545),
    [anon_sym_PERCENT] = ACTIONS(9545),
    [sym_comment] = ACTIONS(87),
  },
  [8508] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(9543),
    [sym__binary_star] = ACTIONS(9545),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(9547),
    [anon_sym_STAR_STAR] = ACTIONS(9545),
    [anon_sym_AMP] = ACTIONS(9549),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_COLON2] = ACTIONS(5827),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(9561),
    [anon_sym_GT_GT] = ACTIONS(9561),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(9567),
    [anon_sym_PLUS] = ACTIONS(9543),
    [anon_sym_SLASH] = ACTIONS(9545),
    [anon_sym_PERCENT] = ACTIONS(9545),
    [sym_comment] = ACTIONS(87),
  },
  [8509] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(13724),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [8510] = {
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(9543),
    [sym__binary_star] = ACTIONS(9545),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(9547),
    [anon_sym_STAR_STAR] = ACTIONS(9545),
    [anon_sym_AMP] = ACTIONS(9549),
    [anon_sym_LT] = ACTIONS(9551),
    [anon_sym_EQ_GT] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_COLON2] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(9555),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9557),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(9559),
    [anon_sym_AMP_AMP] = ACTIONS(9559),
    [anon_sym_LT_LT] = ACTIONS(9561),
    [anon_sym_GT_GT] = ACTIONS(9561),
    [anon_sym_EQ_EQ] = ACTIONS(9563),
    [anon_sym_BANG_EQ] = ACTIONS(9559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9559),
    [anon_sym_LT_EQ_GT] = ACTIONS(9559),
    [anon_sym_EQ_TILDE] = ACTIONS(9559),
    [anon_sym_BANG_TILDE] = ACTIONS(9559),
    [anon_sym_LT_EQ] = ACTIONS(9551),
    [anon_sym_GT] = ACTIONS(9551),
    [anon_sym_GT_EQ] = ACTIONS(9565),
    [anon_sym_CARET] = ACTIONS(9567),
    [anon_sym_PLUS] = ACTIONS(9543),
    [anon_sym_SLASH] = ACTIONS(9545),
    [anon_sym_PERCENT] = ACTIONS(9545),
    [sym_comment] = ACTIONS(87),
  },
  [8511] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(9543),
    [sym__binary_star] = ACTIONS(9545),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(9547),
    [anon_sym_STAR_STAR] = ACTIONS(9545),
    [anon_sym_AMP] = ACTIONS(9549),
    [anon_sym_LT] = ACTIONS(9551),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(9553),
    [anon_sym_COLON2] = ACTIONS(5827),
    [anon_sym_DOT_DOT] = ACTIONS(9555),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9557),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(9559),
    [anon_sym_AMP_AMP] = ACTIONS(9559),
    [anon_sym_LT_LT] = ACTIONS(9561),
    [anon_sym_GT_GT] = ACTIONS(9561),
    [anon_sym_EQ_EQ] = ACTIONS(9563),
    [anon_sym_BANG_EQ] = ACTIONS(9559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9559),
    [anon_sym_LT_EQ_GT] = ACTIONS(9559),
    [anon_sym_EQ_TILDE] = ACTIONS(9559),
    [anon_sym_BANG_TILDE] = ACTIONS(9559),
    [anon_sym_LT_EQ] = ACTIONS(9551),
    [anon_sym_GT] = ACTIONS(9551),
    [anon_sym_GT_EQ] = ACTIONS(9565),
    [anon_sym_CARET] = ACTIONS(9567),
    [anon_sym_PLUS] = ACTIONS(9543),
    [anon_sym_SLASH] = ACTIONS(9545),
    [anon_sym_PERCENT] = ACTIONS(9545),
    [sym_comment] = ACTIONS(87),
  },
  [8512] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(9543),
    [sym__binary_star] = ACTIONS(9545),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(9547),
    [anon_sym_STAR_STAR] = ACTIONS(9545),
    [anon_sym_AMP] = ACTIONS(9549),
    [anon_sym_LT] = ACTIONS(9551),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_COLON2] = ACTIONS(5827),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(9561),
    [anon_sym_GT_GT] = ACTIONS(9561),
    [anon_sym_EQ_EQ] = ACTIONS(9563),
    [anon_sym_BANG_EQ] = ACTIONS(9559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9559),
    [anon_sym_LT_EQ_GT] = ACTIONS(9559),
    [anon_sym_EQ_TILDE] = ACTIONS(9559),
    [anon_sym_BANG_TILDE] = ACTIONS(9559),
    [anon_sym_LT_EQ] = ACTIONS(9551),
    [anon_sym_GT] = ACTIONS(9551),
    [anon_sym_GT_EQ] = ACTIONS(9565),
    [anon_sym_CARET] = ACTIONS(9567),
    [anon_sym_PLUS] = ACTIONS(9543),
    [anon_sym_SLASH] = ACTIONS(9545),
    [anon_sym_PERCENT] = ACTIONS(9545),
    [sym_comment] = ACTIONS(87),
  },
  [8513] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(9543),
    [sym__binary_star] = ACTIONS(9545),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(9545),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_COLON2] = ACTIONS(5827),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(9543),
    [anon_sym_SLASH] = ACTIONS(9545),
    [anon_sym_PERCENT] = ACTIONS(9545),
    [sym_comment] = ACTIONS(87),
  },
  [8514] = {
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(9617),
    [sym__binary_star] = ACTIONS(9619),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(9621),
    [anon_sym_STAR_STAR] = ACTIONS(9623),
    [anon_sym_AMP] = ACTIONS(9625),
    [anon_sym_EQ] = ACTIONS(4217),
    [anon_sym_LT] = ACTIONS(9627),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_EQ_GT] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_PLUS_EQ] = ACTIONS(4211),
    [anon_sym_DASH_EQ] = ACTIONS(4211),
    [anon_sym_STAR_EQ] = ACTIONS(4211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4211),
    [anon_sym_SLASH_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4211),
    [anon_sym_AMP_EQ] = ACTIONS(4211),
    [anon_sym_PERCENT_EQ] = ACTIONS(4211),
    [anon_sym_GT_GT_EQ] = ACTIONS(4211),
    [anon_sym_LT_LT_EQ] = ACTIONS(4211),
    [anon_sym_CARET_EQ] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(9629),
    [anon_sym_COLON2] = ACTIONS(4217),
    [anon_sym_DOT_DOT] = ACTIONS(9631),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9633),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(9635),
    [anon_sym_AMP_AMP] = ACTIONS(9635),
    [anon_sym_LT_LT] = ACTIONS(9637),
    [anon_sym_GT_GT] = ACTIONS(9637),
    [anon_sym_EQ_EQ] = ACTIONS(9635),
    [anon_sym_BANG_EQ] = ACTIONS(9639),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9639),
    [anon_sym_LT_EQ_GT] = ACTIONS(9639),
    [anon_sym_EQ_TILDE] = ACTIONS(9639),
    [anon_sym_BANG_TILDE] = ACTIONS(9639),
    [anon_sym_LT_EQ] = ACTIONS(9627),
    [anon_sym_GT] = ACTIONS(9627),
    [anon_sym_GT_EQ] = ACTIONS(9641),
    [anon_sym_CARET] = ACTIONS(9621),
    [anon_sym_PLUS] = ACTIONS(9643),
    [anon_sym_SLASH] = ACTIONS(9623),
    [anon_sym_PERCENT] = ACTIONS(9623),
    [sym_comment] = ACTIONS(87),
  },
  [8515] = {
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(9617),
    [sym__binary_star] = ACTIONS(9619),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(9621),
    [anon_sym_STAR_STAR] = ACTIONS(9623),
    [anon_sym_AMP] = ACTIONS(9625),
    [anon_sym_EQ] = ACTIONS(4249),
    [anon_sym_LT] = ACTIONS(9627),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_EQ_GT] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_PLUS_EQ] = ACTIONS(4247),
    [anon_sym_DASH_EQ] = ACTIONS(4247),
    [anon_sym_STAR_EQ] = ACTIONS(4247),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4247),
    [anon_sym_SLASH_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4247),
    [anon_sym_AMP_EQ] = ACTIONS(4247),
    [anon_sym_PERCENT_EQ] = ACTIONS(4247),
    [anon_sym_GT_GT_EQ] = ACTIONS(4247),
    [anon_sym_LT_LT_EQ] = ACTIONS(4247),
    [anon_sym_CARET_EQ] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(9629),
    [anon_sym_COLON2] = ACTIONS(4249),
    [anon_sym_DOT_DOT] = ACTIONS(9631),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9633),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(9635),
    [anon_sym_AMP_AMP] = ACTIONS(9635),
    [anon_sym_LT_LT] = ACTIONS(9637),
    [anon_sym_GT_GT] = ACTIONS(9637),
    [anon_sym_EQ_EQ] = ACTIONS(9635),
    [anon_sym_BANG_EQ] = ACTIONS(9639),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9639),
    [anon_sym_LT_EQ_GT] = ACTIONS(9639),
    [anon_sym_EQ_TILDE] = ACTIONS(9639),
    [anon_sym_BANG_TILDE] = ACTIONS(9639),
    [anon_sym_LT_EQ] = ACTIONS(9627),
    [anon_sym_GT] = ACTIONS(9627),
    [anon_sym_GT_EQ] = ACTIONS(9641),
    [anon_sym_CARET] = ACTIONS(9621),
    [anon_sym_PLUS] = ACTIONS(9643),
    [anon_sym_SLASH] = ACTIONS(9623),
    [anon_sym_PERCENT] = ACTIONS(9623),
    [sym_comment] = ACTIONS(87),
  },
  [8516] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(10003),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3553),
    [sym_scope_resolution] = STATE(3549),
    [sym_call] = STATE(3549),
    [sym_method_call] = STATE(3553),
    [sym_assignment] = STATE(10003),
    [sym_operator_assignment] = STATE(10003),
    [sym_conditional] = STATE(10003),
    [sym_range] = STATE(10003),
    [sym_binary] = STATE(10003),
    [sym_unary] = STATE(10003),
    [sym_left_assignment_list] = STATE(3552),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3553),
    [sym__variable] = STATE(3549),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3553),
    [sym_false] = STATE(3553),
    [sym_nil] = STATE(3553),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6215),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(9609),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(5895),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5899),
    [anon_sym_yield] = ACTIONS(5901),
    [anon_sym_break] = ACTIONS(5903),
    [anon_sym_next] = ACTIONS(5905),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(9611),
    [anon_sym_defined_QMARK] = ACTIONS(5907),
    [anon_sym_not] = ACTIONS(5909),
    [anon_sym_BANG] = ACTIONS(5913),
    [anon_sym_TILDE] = ACTIONS(5913),
    [sym_constant] = ACTIONS(5919),
    [sym_identifier] = ACTIONS(5919),
    [sym_instance_variable] = ACTIONS(5917),
    [sym_class_variable] = ACTIONS(5917),
    [sym_global_variable] = ACTIONS(5917),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5919),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5919),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [8517] = {
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(9617),
    [sym__binary_star] = ACTIONS(9619),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(9621),
    [anon_sym_STAR_STAR] = ACTIONS(9623),
    [anon_sym_AMP] = ACTIONS(9625),
    [anon_sym_EQ] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(9627),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_EQ_GT] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_PLUS_EQ] = ACTIONS(3281),
    [anon_sym_DASH_EQ] = ACTIONS(3281),
    [anon_sym_STAR_EQ] = ACTIONS(3281),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3281),
    [anon_sym_SLASH_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3281),
    [anon_sym_AMP_EQ] = ACTIONS(3281),
    [anon_sym_PERCENT_EQ] = ACTIONS(3281),
    [anon_sym_GT_GT_EQ] = ACTIONS(3281),
    [anon_sym_LT_LT_EQ] = ACTIONS(3281),
    [anon_sym_CARET_EQ] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(9629),
    [anon_sym_COLON2] = ACTIONS(4251),
    [anon_sym_DOT_DOT] = ACTIONS(9631),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9633),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(9635),
    [anon_sym_AMP_AMP] = ACTIONS(9635),
    [anon_sym_LT_LT] = ACTIONS(9637),
    [anon_sym_GT_GT] = ACTIONS(9637),
    [anon_sym_EQ_EQ] = ACTIONS(9635),
    [anon_sym_BANG_EQ] = ACTIONS(9639),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9639),
    [anon_sym_LT_EQ_GT] = ACTIONS(9639),
    [anon_sym_EQ_TILDE] = ACTIONS(9639),
    [anon_sym_BANG_TILDE] = ACTIONS(9639),
    [anon_sym_LT_EQ] = ACTIONS(9627),
    [anon_sym_GT] = ACTIONS(9627),
    [anon_sym_GT_EQ] = ACTIONS(9641),
    [anon_sym_CARET] = ACTIONS(9621),
    [anon_sym_PLUS] = ACTIONS(9643),
    [anon_sym_SLASH] = ACTIONS(9623),
    [anon_sym_PERCENT] = ACTIONS(9623),
    [sym_comment] = ACTIONS(87),
  },
  [8518] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(10004),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3553),
    [sym_scope_resolution] = STATE(3549),
    [sym_call] = STATE(3549),
    [sym_method_call] = STATE(3553),
    [sym_assignment] = STATE(10004),
    [sym_operator_assignment] = STATE(10004),
    [sym_conditional] = STATE(10004),
    [sym_range] = STATE(10004),
    [sym_binary] = STATE(10004),
    [sym_unary] = STATE(10004),
    [sym_left_assignment_list] = STATE(3552),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3553),
    [sym__variable] = STATE(3549),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3553),
    [sym_false] = STATE(3553),
    [sym_nil] = STATE(3553),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6215),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(9609),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(5895),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5899),
    [anon_sym_yield] = ACTIONS(5901),
    [anon_sym_break] = ACTIONS(5903),
    [anon_sym_next] = ACTIONS(5905),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(9611),
    [anon_sym_defined_QMARK] = ACTIONS(5907),
    [anon_sym_not] = ACTIONS(5909),
    [anon_sym_BANG] = ACTIONS(5913),
    [anon_sym_TILDE] = ACTIONS(5913),
    [sym_constant] = ACTIONS(5919),
    [sym_identifier] = ACTIONS(5919),
    [sym_instance_variable] = ACTIONS(5917),
    [sym_class_variable] = ACTIONS(5917),
    [sym_global_variable] = ACTIONS(5917),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5919),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5919),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [8519] = {
    [sym_heredoc_body] = STATE(10005),
    [aux_sym_call_repeat1] = STATE(10005),
    [sym__heredoc_body_start] = ACTIONS(3543),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_COLON2] = ACTIONS(4385),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [8520] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6179),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3553),
    [sym_scope_resolution] = STATE(3549),
    [sym_call] = STATE(3549),
    [sym_method_call] = STATE(3553),
    [sym__argument] = STATE(4357),
    [sym_splat_argument] = STATE(4357),
    [sym_hash_splat_argument] = STATE(4357),
    [sym_block_argument] = STATE(4357),
    [sym_assignment] = STATE(6179),
    [sym_operator_assignment] = STATE(6179),
    [sym_conditional] = STATE(6179),
    [sym_range] = STATE(6179),
    [sym_binary] = STATE(6179),
    [sym_unary] = STATE(6179),
    [sym_left_assignment_list] = STATE(3552),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3553),
    [sym__variable] = STATE(3549),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3553),
    [sym_false] = STATE(3553),
    [sym_nil] = STATE(3553),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6182),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_heredoc_body] = STATE(10006),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(4357),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(9569),
    [sym__splat_star] = ACTIONS(9571),
    [sym__unary_minus] = ACTIONS(5895),
    [sym__identifier_hash_key] = ACTIONS(9573),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13726),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5899),
    [anon_sym_yield] = ACTIONS(5901),
    [anon_sym_break] = ACTIONS(5903),
    [anon_sym_next] = ACTIONS(5905),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(9611),
    [anon_sym_defined_QMARK] = ACTIONS(5907),
    [anon_sym_not] = ACTIONS(5909),
    [anon_sym_BANG] = ACTIONS(5913),
    [anon_sym_TILDE] = ACTIONS(5913),
    [sym_constant] = ACTIONS(9575),
    [sym_identifier] = ACTIONS(9575),
    [sym_instance_variable] = ACTIONS(5917),
    [sym_class_variable] = ACTIONS(5917),
    [sym_global_variable] = ACTIONS(5917),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5919),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5919),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [8521] = {
    [sym_heredoc_body] = STATE(10007),
    [aux_sym_call_repeat1] = STATE(10007),
    [aux_sym_argument_list_repeat1] = STATE(10008),
    [sym__heredoc_body_start] = ACTIONS(3543),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(12112),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_COLON2] = ACTIONS(4385),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [8522] = {
    [sym_heredoc_body] = STATE(8522),
    [aux_sym_call_repeat1] = STATE(8522),
    [sym__heredoc_body_start] = ACTIONS(10455),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_COLON2] = ACTIONS(7919),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [8523] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(3517),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(3522),
    [sym_scope_resolution] = STATE(3518),
    [sym_call] = STATE(3518),
    [sym_method_call] = STATE(3522),
    [sym__argument] = STATE(6908),
    [sym_splat_argument] = STATE(6908),
    [sym_hash_splat_argument] = STATE(6908),
    [sym_block_argument] = STATE(6908),
    [sym_assignment] = STATE(3517),
    [sym_operator_assignment] = STATE(3517),
    [sym_conditional] = STATE(3517),
    [sym_range] = STATE(3517),
    [sym_binary] = STATE(3517),
    [sym_unary] = STATE(3517),
    [sym_left_assignment_list] = STATE(3521),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3522),
    [sym__variable] = STATE(3518),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(3522),
    [sym_false] = STATE(3522),
    [sym_nil] = STATE(3522),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(3523),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(6908),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(5831),
    [sym__splat_star] = ACTIONS(5833),
    [sym__unary_minus] = ACTIONS(5835),
    [sym__identifier_hash_key] = ACTIONS(5837),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12116),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5839),
    [anon_sym_yield] = ACTIONS(5841),
    [anon_sym_break] = ACTIONS(5843),
    [anon_sym_next] = ACTIONS(5845),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9529),
    [anon_sym_defined_QMARK] = ACTIONS(5847),
    [anon_sym_not] = ACTIONS(5849),
    [anon_sym_BANG] = ACTIONS(5853),
    [anon_sym_TILDE] = ACTIONS(5853),
    [sym_constant] = ACTIONS(5855),
    [sym_identifier] = ACTIONS(5855),
    [sym_instance_variable] = ACTIONS(5857),
    [sym_class_variable] = ACTIONS(5857),
    [sym_global_variable] = ACTIONS(5857),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5859),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5859),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8524] = {
    [sym_heredoc_body] = STATE(8522),
    [aux_sym_call_repeat1] = STATE(8522),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_COLON2] = ACTIONS(7931),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [8525] = {
    [aux_sym_argument_list_repeat1] = STATE(8525),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(13728),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_STAR_STAR] = ACTIONS(7925),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_COLON2] = ACTIONS(7927),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7925),
    [anon_sym_AMP_AMP] = ACTIONS(7925),
    [anon_sym_LT_LT] = ACTIONS(7925),
    [anon_sym_GT_GT] = ACTIONS(7925),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7925),
    [anon_sym_PLUS] = ACTIONS(7925),
    [anon_sym_SLASH] = ACTIONS(7925),
    [anon_sym_PERCENT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [8526] = {
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(9543),
    [sym__binary_star] = ACTIONS(9545),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(9547),
    [anon_sym_STAR_STAR] = ACTIONS(9545),
    [anon_sym_AMP] = ACTIONS(9549),
    [anon_sym_LT] = ACTIONS(9551),
    [anon_sym_EQ_GT] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(9553),
    [anon_sym_COLON2] = ACTIONS(7936),
    [anon_sym_DOT_DOT] = ACTIONS(9555),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9557),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(9559),
    [anon_sym_AMP_AMP] = ACTIONS(9559),
    [anon_sym_LT_LT] = ACTIONS(9561),
    [anon_sym_GT_GT] = ACTIONS(9561),
    [anon_sym_EQ_EQ] = ACTIONS(9563),
    [anon_sym_BANG_EQ] = ACTIONS(9559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9559),
    [anon_sym_LT_EQ_GT] = ACTIONS(9559),
    [anon_sym_EQ_TILDE] = ACTIONS(9559),
    [anon_sym_BANG_TILDE] = ACTIONS(9559),
    [anon_sym_LT_EQ] = ACTIONS(9551),
    [anon_sym_GT] = ACTIONS(9551),
    [anon_sym_GT_EQ] = ACTIONS(9565),
    [anon_sym_CARET] = ACTIONS(9567),
    [anon_sym_PLUS] = ACTIONS(9543),
    [anon_sym_SLASH] = ACTIONS(9545),
    [anon_sym_PERCENT] = ACTIONS(9545),
    [sym_comment] = ACTIONS(87),
  },
  [8527] = {
    [aux_sym_exceptions_repeat1] = STATE(10010),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_COLON2] = ACTIONS(6193),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [8528] = {
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(9543),
    [sym__binary_star] = ACTIONS(9545),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(9547),
    [anon_sym_STAR_STAR] = ACTIONS(9545),
    [anon_sym_AMP] = ACTIONS(9549),
    [anon_sym_LT] = ACTIONS(9551),
    [anon_sym_EQ_GT] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(9553),
    [anon_sym_COLON2] = ACTIONS(7938),
    [anon_sym_DOT_DOT] = ACTIONS(9555),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9557),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(9559),
    [anon_sym_AMP_AMP] = ACTIONS(9559),
    [anon_sym_LT_LT] = ACTIONS(9561),
    [anon_sym_GT_GT] = ACTIONS(9561),
    [anon_sym_EQ_EQ] = ACTIONS(9563),
    [anon_sym_BANG_EQ] = ACTIONS(9559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9559),
    [anon_sym_LT_EQ_GT] = ACTIONS(9559),
    [anon_sym_EQ_TILDE] = ACTIONS(9559),
    [anon_sym_BANG_TILDE] = ACTIONS(9559),
    [anon_sym_LT_EQ] = ACTIONS(9551),
    [anon_sym_GT] = ACTIONS(9551),
    [anon_sym_GT_EQ] = ACTIONS(9565),
    [anon_sym_CARET] = ACTIONS(9567),
    [anon_sym_PLUS] = ACTIONS(9543),
    [anon_sym_SLASH] = ACTIONS(9545),
    [anon_sym_PERCENT] = ACTIONS(9545),
    [sym_comment] = ACTIONS(87),
  },
  [8529] = {
    [sym_string] = STATE(8529),
    [aux_sym_chained_string_repeat1] = STATE(8529),
    [sym__string_start] = ACTIONS(13731),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_EQ_GT] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_COLON2] = ACTIONS(6217),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [8530] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(10011),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(10011),
    [sym_operator_assignment] = STATE(10011),
    [sym_conditional] = STATE(10011),
    [sym_range] = STATE(10011),
    [sym_binary] = STATE(10011),
    [sym_unary] = STATE(10011),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8531] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(12128),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_COLON2] = ACTIONS(937),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [8532] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(12122),
    [sym__binary_star] = ACTIONS(12124),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(12126),
    [anon_sym_STAR_STAR] = ACTIONS(12128),
    [anon_sym_AMP] = ACTIONS(12130),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(12132),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(12134),
    [anon_sym_COLON2] = ACTIONS(937),
    [anon_sym_DOT_DOT] = ACTIONS(12136),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12138),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(12140),
    [anon_sym_AMP_AMP] = ACTIONS(12140),
    [anon_sym_LT_LT] = ACTIONS(12142),
    [anon_sym_GT_GT] = ACTIONS(12142),
    [anon_sym_EQ_EQ] = ACTIONS(12140),
    [anon_sym_BANG_EQ] = ACTIONS(12144),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12144),
    [anon_sym_LT_EQ_GT] = ACTIONS(12144),
    [anon_sym_EQ_TILDE] = ACTIONS(12144),
    [anon_sym_BANG_TILDE] = ACTIONS(12144),
    [anon_sym_LT_EQ] = ACTIONS(12132),
    [anon_sym_GT] = ACTIONS(12132),
    [anon_sym_GT_EQ] = ACTIONS(12146),
    [anon_sym_CARET] = ACTIONS(12126),
    [anon_sym_PLUS] = ACTIONS(12148),
    [anon_sym_SLASH] = ACTIONS(12128),
    [anon_sym_PERCENT] = ACTIONS(12128),
    [sym_comment] = ACTIONS(87),
  },
  [8533] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(10012),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(6210),
    [sym_scope_resolution] = STATE(6208),
    [sym_call] = STATE(6208),
    [sym_method_call] = STATE(6210),
    [sym_assignment] = STATE(10012),
    [sym_operator_assignment] = STATE(10012),
    [sym_conditional] = STATE(10012),
    [sym_range] = STATE(10012),
    [sym_binary] = STATE(10012),
    [sym_unary] = STATE(10012),
    [sym_left_assignment_list] = STATE(6209),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6210),
    [sym__variable] = STATE(6208),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(6210),
    [sym_false] = STATE(6210),
    [sym_nil] = STATE(6210),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(6211),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(9587),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(9589),
    [anon_sym_yield] = ACTIONS(9591),
    [anon_sym_break] = ACTIONS(9593),
    [anon_sym_next] = ACTIONS(9595),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(9597),
    [anon_sym_defined_QMARK] = ACTIONS(9599),
    [anon_sym_not] = ACTIONS(9601),
    [anon_sym_BANG] = ACTIONS(9603),
    [anon_sym_TILDE] = ACTIONS(9603),
    [sym_constant] = ACTIONS(9605),
    [sym_identifier] = ACTIONS(9605),
    [sym_instance_variable] = ACTIONS(9607),
    [sym_class_variable] = ACTIONS(9607),
    [sym_global_variable] = ACTIONS(9607),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(9605),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9605),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [8534] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(10013),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(6210),
    [sym_scope_resolution] = STATE(6208),
    [sym_call] = STATE(6208),
    [sym_method_call] = STATE(6210),
    [sym_assignment] = STATE(10013),
    [sym_operator_assignment] = STATE(10013),
    [sym_conditional] = STATE(10013),
    [sym_range] = STATE(10013),
    [sym_binary] = STATE(10013),
    [sym_unary] = STATE(10013),
    [sym_left_assignment_list] = STATE(6209),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6210),
    [sym__variable] = STATE(6208),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(6210),
    [sym_false] = STATE(6210),
    [sym_nil] = STATE(6210),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(6211),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(9587),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(9589),
    [anon_sym_yield] = ACTIONS(9591),
    [anon_sym_break] = ACTIONS(9593),
    [anon_sym_next] = ACTIONS(9595),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(9597),
    [anon_sym_defined_QMARK] = ACTIONS(9599),
    [anon_sym_not] = ACTIONS(9601),
    [anon_sym_BANG] = ACTIONS(9603),
    [anon_sym_TILDE] = ACTIONS(9603),
    [sym_constant] = ACTIONS(9605),
    [sym_identifier] = ACTIONS(9605),
    [sym_instance_variable] = ACTIONS(9607),
    [sym_class_variable] = ACTIONS(9607),
    [sym_global_variable] = ACTIONS(9607),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(9605),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9605),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [8535] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(10014),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(6210),
    [sym_scope_resolution] = STATE(6208),
    [sym_call] = STATE(6208),
    [sym_method_call] = STATE(6210),
    [sym_assignment] = STATE(10014),
    [sym_operator_assignment] = STATE(10014),
    [sym_conditional] = STATE(10014),
    [sym_range] = STATE(10014),
    [sym_binary] = STATE(10014),
    [sym_unary] = STATE(10014),
    [sym_left_assignment_list] = STATE(6209),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6210),
    [sym__variable] = STATE(6208),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(6210),
    [sym_false] = STATE(6210),
    [sym_nil] = STATE(6210),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(6211),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(9587),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(9589),
    [anon_sym_yield] = ACTIONS(9591),
    [anon_sym_break] = ACTIONS(9593),
    [anon_sym_next] = ACTIONS(9595),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(9597),
    [anon_sym_defined_QMARK] = ACTIONS(9599),
    [anon_sym_not] = ACTIONS(9601),
    [anon_sym_BANG] = ACTIONS(9603),
    [anon_sym_TILDE] = ACTIONS(9603),
    [sym_constant] = ACTIONS(9605),
    [sym_identifier] = ACTIONS(9605),
    [sym_instance_variable] = ACTIONS(9607),
    [sym_class_variable] = ACTIONS(9607),
    [sym_global_variable] = ACTIONS(9607),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(9605),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9605),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [8536] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(10015),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(6210),
    [sym_scope_resolution] = STATE(6208),
    [sym_call] = STATE(6208),
    [sym_method_call] = STATE(6210),
    [sym_assignment] = STATE(10015),
    [sym_operator_assignment] = STATE(10015),
    [sym_conditional] = STATE(10015),
    [sym_range] = STATE(10015),
    [sym_binary] = STATE(10015),
    [sym_unary] = STATE(10015),
    [sym_left_assignment_list] = STATE(6209),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6210),
    [sym__variable] = STATE(6208),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(6210),
    [sym_false] = STATE(6210),
    [sym_nil] = STATE(6210),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(6211),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(9587),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(9589),
    [anon_sym_yield] = ACTIONS(9591),
    [anon_sym_break] = ACTIONS(9593),
    [anon_sym_next] = ACTIONS(9595),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(9597),
    [anon_sym_defined_QMARK] = ACTIONS(9599),
    [anon_sym_not] = ACTIONS(9601),
    [anon_sym_BANG] = ACTIONS(9603),
    [anon_sym_TILDE] = ACTIONS(9603),
    [sym_constant] = ACTIONS(9605),
    [sym_identifier] = ACTIONS(9605),
    [sym_instance_variable] = ACTIONS(9607),
    [sym_class_variable] = ACTIONS(9607),
    [sym_global_variable] = ACTIONS(9607),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(9605),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9605),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [8537] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(10016),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(6210),
    [sym_scope_resolution] = STATE(6208),
    [sym_call] = STATE(6208),
    [sym_method_call] = STATE(6210),
    [sym_assignment] = STATE(10016),
    [sym_operator_assignment] = STATE(10016),
    [sym_conditional] = STATE(10016),
    [sym_range] = STATE(10016),
    [sym_binary] = STATE(10016),
    [sym_unary] = STATE(10016),
    [sym_left_assignment_list] = STATE(6209),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6210),
    [sym__variable] = STATE(6208),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(6210),
    [sym_false] = STATE(6210),
    [sym_nil] = STATE(6210),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(6211),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(9587),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(9589),
    [anon_sym_yield] = ACTIONS(9591),
    [anon_sym_break] = ACTIONS(9593),
    [anon_sym_next] = ACTIONS(9595),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(9597),
    [anon_sym_defined_QMARK] = ACTIONS(9599),
    [anon_sym_not] = ACTIONS(9601),
    [anon_sym_BANG] = ACTIONS(9603),
    [anon_sym_TILDE] = ACTIONS(9603),
    [sym_constant] = ACTIONS(9605),
    [sym_identifier] = ACTIONS(9605),
    [sym_instance_variable] = ACTIONS(9607),
    [sym_class_variable] = ACTIONS(9607),
    [sym_global_variable] = ACTIONS(9607),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(9605),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9605),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [8538] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(10017),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(10017),
    [sym_operator_assignment] = STATE(10017),
    [sym_conditional] = STATE(10017),
    [sym_range] = STATE(10017),
    [sym_binary] = STATE(10017),
    [sym_unary] = STATE(10017),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8539] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(10018),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(6210),
    [sym_scope_resolution] = STATE(6208),
    [sym_call] = STATE(6208),
    [sym_method_call] = STATE(6210),
    [sym_assignment] = STATE(10018),
    [sym_operator_assignment] = STATE(10018),
    [sym_conditional] = STATE(10018),
    [sym_range] = STATE(10018),
    [sym_binary] = STATE(10018),
    [sym_unary] = STATE(10018),
    [sym_left_assignment_list] = STATE(6209),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6210),
    [sym__variable] = STATE(6208),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(6210),
    [sym_false] = STATE(6210),
    [sym_nil] = STATE(6210),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(6211),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(9587),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(9589),
    [anon_sym_yield] = ACTIONS(9591),
    [anon_sym_break] = ACTIONS(9593),
    [anon_sym_next] = ACTIONS(9595),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(9597),
    [anon_sym_defined_QMARK] = ACTIONS(9599),
    [anon_sym_not] = ACTIONS(9601),
    [anon_sym_BANG] = ACTIONS(9603),
    [anon_sym_TILDE] = ACTIONS(9603),
    [sym_constant] = ACTIONS(9605),
    [sym_identifier] = ACTIONS(9605),
    [sym_instance_variable] = ACTIONS(9607),
    [sym_class_variable] = ACTIONS(9607),
    [sym_global_variable] = ACTIONS(9607),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(9605),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9605),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [8540] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(10019),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(6210),
    [sym_scope_resolution] = STATE(6208),
    [sym_call] = STATE(6208),
    [sym_method_call] = STATE(6210),
    [sym_assignment] = STATE(10019),
    [sym_operator_assignment] = STATE(10019),
    [sym_conditional] = STATE(10019),
    [sym_range] = STATE(10019),
    [sym_binary] = STATE(10019),
    [sym_unary] = STATE(10019),
    [sym_left_assignment_list] = STATE(6209),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6210),
    [sym__variable] = STATE(6208),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(6210),
    [sym_false] = STATE(6210),
    [sym_nil] = STATE(6210),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(6211),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(9587),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(9589),
    [anon_sym_yield] = ACTIONS(9591),
    [anon_sym_break] = ACTIONS(9593),
    [anon_sym_next] = ACTIONS(9595),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(9597),
    [anon_sym_defined_QMARK] = ACTIONS(9599),
    [anon_sym_not] = ACTIONS(9601),
    [anon_sym_BANG] = ACTIONS(9603),
    [anon_sym_TILDE] = ACTIONS(9603),
    [sym_constant] = ACTIONS(9605),
    [sym_identifier] = ACTIONS(9605),
    [sym_instance_variable] = ACTIONS(9607),
    [sym_class_variable] = ACTIONS(9607),
    [sym_global_variable] = ACTIONS(9607),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(9605),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9605),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [8541] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(10020),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(6210),
    [sym_scope_resolution] = STATE(6208),
    [sym_call] = STATE(6208),
    [sym_method_call] = STATE(6210),
    [sym_assignment] = STATE(10020),
    [sym_operator_assignment] = STATE(10020),
    [sym_conditional] = STATE(10020),
    [sym_range] = STATE(10020),
    [sym_binary] = STATE(10020),
    [sym_unary] = STATE(10020),
    [sym_left_assignment_list] = STATE(6209),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6210),
    [sym__variable] = STATE(6208),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(6210),
    [sym_false] = STATE(6210),
    [sym_nil] = STATE(6210),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(6211),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(9587),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(9589),
    [anon_sym_yield] = ACTIONS(9591),
    [anon_sym_break] = ACTIONS(9593),
    [anon_sym_next] = ACTIONS(9595),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(9597),
    [anon_sym_defined_QMARK] = ACTIONS(9599),
    [anon_sym_not] = ACTIONS(9601),
    [anon_sym_BANG] = ACTIONS(9603),
    [anon_sym_TILDE] = ACTIONS(9603),
    [sym_constant] = ACTIONS(9605),
    [sym_identifier] = ACTIONS(9605),
    [sym_instance_variable] = ACTIONS(9607),
    [sym_class_variable] = ACTIONS(9607),
    [sym_global_variable] = ACTIONS(9607),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(9605),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9605),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [8542] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(10021),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(6210),
    [sym_scope_resolution] = STATE(6208),
    [sym_call] = STATE(6208),
    [sym_method_call] = STATE(6210),
    [sym_assignment] = STATE(10021),
    [sym_operator_assignment] = STATE(10021),
    [sym_conditional] = STATE(10021),
    [sym_range] = STATE(10021),
    [sym_binary] = STATE(10021),
    [sym_unary] = STATE(10021),
    [sym_left_assignment_list] = STATE(6209),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6210),
    [sym__variable] = STATE(6208),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(6210),
    [sym_false] = STATE(6210),
    [sym_nil] = STATE(6210),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(6211),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(9587),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(9589),
    [anon_sym_yield] = ACTIONS(9591),
    [anon_sym_break] = ACTIONS(9593),
    [anon_sym_next] = ACTIONS(9595),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(9597),
    [anon_sym_defined_QMARK] = ACTIONS(9599),
    [anon_sym_not] = ACTIONS(9601),
    [anon_sym_BANG] = ACTIONS(9603),
    [anon_sym_TILDE] = ACTIONS(9603),
    [sym_constant] = ACTIONS(9605),
    [sym_identifier] = ACTIONS(9605),
    [sym_instance_variable] = ACTIONS(9607),
    [sym_class_variable] = ACTIONS(9607),
    [sym_global_variable] = ACTIONS(9607),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(9605),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9605),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [8543] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(10022),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(6210),
    [sym_scope_resolution] = STATE(6208),
    [sym_call] = STATE(6208),
    [sym_method_call] = STATE(6210),
    [sym_splat_argument] = STATE(10023),
    [sym_assignment] = STATE(10022),
    [sym_operator_assignment] = STATE(10022),
    [sym_conditional] = STATE(10022),
    [sym_range] = STATE(10022),
    [sym_binary] = STATE(10022),
    [sym_unary] = STATE(10022),
    [sym_right_assignment_list] = STATE(8878),
    [sym__arg_or_splat_arg] = STATE(10023),
    [sym_left_assignment_list] = STATE(6209),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6210),
    [sym__variable] = STATE(6208),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(6210),
    [sym_false] = STATE(6210),
    [sym_nil] = STATE(6210),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(6211),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__splat_star] = ACTIONS(5893),
    [sym__unary_minus] = ACTIONS(9587),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(9589),
    [anon_sym_yield] = ACTIONS(9591),
    [anon_sym_break] = ACTIONS(9593),
    [anon_sym_next] = ACTIONS(9595),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(9597),
    [anon_sym_defined_QMARK] = ACTIONS(9599),
    [anon_sym_not] = ACTIONS(9601),
    [anon_sym_BANG] = ACTIONS(9603),
    [anon_sym_TILDE] = ACTIONS(9603),
    [sym_constant] = ACTIONS(9605),
    [sym_identifier] = ACTIONS(9605),
    [sym_instance_variable] = ACTIONS(9607),
    [sym_class_variable] = ACTIONS(9607),
    [sym_global_variable] = ACTIONS(9607),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(9605),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9605),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [8544] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(10024),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(6210),
    [sym_scope_resolution] = STATE(6208),
    [sym_call] = STATE(6208),
    [sym_method_call] = STATE(6210),
    [sym_assignment] = STATE(10024),
    [sym_operator_assignment] = STATE(10024),
    [sym_conditional] = STATE(10024),
    [sym_range] = STATE(10024),
    [sym_binary] = STATE(10024),
    [sym_unary] = STATE(10024),
    [sym_left_assignment_list] = STATE(6209),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6210),
    [sym__variable] = STATE(6208),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(6210),
    [sym_false] = STATE(6210),
    [sym_nil] = STATE(6210),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(6211),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(9587),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(9589),
    [anon_sym_yield] = ACTIONS(9591),
    [anon_sym_break] = ACTIONS(9593),
    [anon_sym_next] = ACTIONS(9595),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(9597),
    [anon_sym_defined_QMARK] = ACTIONS(9599),
    [anon_sym_not] = ACTIONS(9601),
    [anon_sym_BANG] = ACTIONS(9603),
    [anon_sym_TILDE] = ACTIONS(9603),
    [sym_constant] = ACTIONS(9605),
    [sym_identifier] = ACTIONS(9605),
    [sym_instance_variable] = ACTIONS(9607),
    [sym_class_variable] = ACTIONS(9607),
    [sym_global_variable] = ACTIONS(9607),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(9605),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9605),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [8545] = {
    [sym_string] = STATE(10025),
    [aux_sym_chained_string_repeat1] = STATE(10025),
    [sym__string_start] = ACTIONS(6455),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_STAR_STAR] = ACTIONS(2755),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_EQ] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_PLUS_EQ] = ACTIONS(2753),
    [anon_sym_DASH_EQ] = ACTIONS(2753),
    [anon_sym_STAR_EQ] = ACTIONS(2753),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2753),
    [anon_sym_SLASH_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2753),
    [anon_sym_AMP_EQ] = ACTIONS(2753),
    [anon_sym_PERCENT_EQ] = ACTIONS(2753),
    [anon_sym_GT_GT_EQ] = ACTIONS(2753),
    [anon_sym_LT_LT_EQ] = ACTIONS(2753),
    [anon_sym_CARET_EQ] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_COLON2] = ACTIONS(2755),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2755),
    [anon_sym_AMP_AMP] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2755),
    [anon_sym_GT_GT] = ACTIONS(2755),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_SLASH] = ACTIONS(2755),
    [anon_sym_PERCENT] = ACTIONS(2755),
    [sym_comment] = ACTIONS(87),
  },
  [8546] = {
    [sym__string_start] = ACTIONS(835),
    [sym__heredoc_body_start] = ACTIONS(835),
    [sym__binary_minus] = ACTIONS(835),
    [sym__binary_star] = ACTIONS(835),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_DOT] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(835),
    [anon_sym_PIPE] = ACTIONS(837),
    [anon_sym_STAR_STAR] = ACTIONS(837),
    [anon_sym_AMP] = ACTIONS(837),
    [anon_sym_EQ] = ACTIONS(837),
    [anon_sym_LT] = ACTIONS(837),
    [anon_sym_do] = ACTIONS(835),
    [anon_sym_EQ_GT] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_COLON_COLON2] = ACTIONS(835),
    [anon_sym_AMP_DOT] = ACTIONS(835),
    [anon_sym_PLUS_EQ] = ACTIONS(835),
    [anon_sym_DASH_EQ] = ACTIONS(835),
    [anon_sym_STAR_EQ] = ACTIONS(835),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(835),
    [anon_sym_SLASH_EQ] = ACTIONS(835),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(835),
    [anon_sym_PIPE_EQ] = ACTIONS(835),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(835),
    [anon_sym_AMP_EQ] = ACTIONS(835),
    [anon_sym_PERCENT_EQ] = ACTIONS(835),
    [anon_sym_GT_GT_EQ] = ACTIONS(835),
    [anon_sym_LT_LT_EQ] = ACTIONS(835),
    [anon_sym_CARET_EQ] = ACTIONS(835),
    [anon_sym_QMARK] = ACTIONS(835),
    [anon_sym_COLON2] = ACTIONS(837),
    [anon_sym_DOT_DOT] = ACTIONS(837),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(835),
    [anon_sym_and] = ACTIONS(835),
    [anon_sym_or] = ACTIONS(835),
    [anon_sym_PIPE_PIPE] = ACTIONS(837),
    [anon_sym_AMP_AMP] = ACTIONS(837),
    [anon_sym_LT_LT] = ACTIONS(837),
    [anon_sym_GT_GT] = ACTIONS(837),
    [anon_sym_EQ_EQ] = ACTIONS(837),
    [anon_sym_BANG_EQ] = ACTIONS(835),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(835),
    [anon_sym_LT_EQ_GT] = ACTIONS(835),
    [anon_sym_EQ_TILDE] = ACTIONS(835),
    [anon_sym_BANG_TILDE] = ACTIONS(835),
    [anon_sym_LT_EQ] = ACTIONS(837),
    [anon_sym_GT] = ACTIONS(837),
    [anon_sym_GT_EQ] = ACTIONS(835),
    [anon_sym_CARET] = ACTIONS(837),
    [anon_sym_PLUS] = ACTIONS(837),
    [anon_sym_SLASH] = ACTIONS(837),
    [anon_sym_PERCENT] = ACTIONS(837),
    [sym_comment] = ACTIONS(87),
  },
  [8547] = {
    [sym__string_end] = ACTIONS(13734),
    [sym_comment] = ACTIONS(87),
  },
  [8548] = {
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(12122),
    [sym__binary_star] = ACTIONS(12124),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(12126),
    [anon_sym_STAR_STAR] = ACTIONS(12128),
    [anon_sym_AMP] = ACTIONS(12130),
    [anon_sym_EQ] = ACTIONS(7822),
    [anon_sym_LT] = ACTIONS(12132),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_PLUS_EQ] = ACTIONS(6823),
    [anon_sym_DASH_EQ] = ACTIONS(6823),
    [anon_sym_STAR_EQ] = ACTIONS(6823),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6823),
    [anon_sym_SLASH_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6823),
    [anon_sym_AMP_EQ] = ACTIONS(6823),
    [anon_sym_PERCENT_EQ] = ACTIONS(6823),
    [anon_sym_GT_GT_EQ] = ACTIONS(6823),
    [anon_sym_LT_LT_EQ] = ACTIONS(6823),
    [anon_sym_CARET_EQ] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(12134),
    [anon_sym_COLON2] = ACTIONS(7822),
    [anon_sym_DOT_DOT] = ACTIONS(12136),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12138),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(12140),
    [anon_sym_AMP_AMP] = ACTIONS(12140),
    [anon_sym_LT_LT] = ACTIONS(12142),
    [anon_sym_GT_GT] = ACTIONS(12142),
    [anon_sym_EQ_EQ] = ACTIONS(12140),
    [anon_sym_BANG_EQ] = ACTIONS(12144),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12144),
    [anon_sym_LT_EQ_GT] = ACTIONS(12144),
    [anon_sym_EQ_TILDE] = ACTIONS(12144),
    [anon_sym_BANG_TILDE] = ACTIONS(12144),
    [anon_sym_LT_EQ] = ACTIONS(12132),
    [anon_sym_GT] = ACTIONS(12132),
    [anon_sym_GT_EQ] = ACTIONS(12146),
    [anon_sym_CARET] = ACTIONS(12126),
    [anon_sym_PLUS] = ACTIONS(12148),
    [anon_sym_SLASH] = ACTIONS(12128),
    [anon_sym_PERCENT] = ACTIONS(12128),
    [sym_comment] = ACTIONS(87),
  },
  [8549] = {
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(12122),
    [sym__binary_star] = ACTIONS(12124),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(12126),
    [anon_sym_STAR_STAR] = ACTIONS(12128),
    [anon_sym_AMP] = ACTIONS(12130),
    [anon_sym_EQ] = ACTIONS(7884),
    [anon_sym_LT] = ACTIONS(12132),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_PLUS_EQ] = ACTIONS(7027),
    [anon_sym_DASH_EQ] = ACTIONS(7027),
    [anon_sym_STAR_EQ] = ACTIONS(7027),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7027),
    [anon_sym_SLASH_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7027),
    [anon_sym_AMP_EQ] = ACTIONS(7027),
    [anon_sym_PERCENT_EQ] = ACTIONS(7027),
    [anon_sym_GT_GT_EQ] = ACTIONS(7027),
    [anon_sym_LT_LT_EQ] = ACTIONS(7027),
    [anon_sym_CARET_EQ] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(12134),
    [anon_sym_COLON2] = ACTIONS(7884),
    [anon_sym_DOT_DOT] = ACTIONS(12136),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12138),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(12140),
    [anon_sym_AMP_AMP] = ACTIONS(12140),
    [anon_sym_LT_LT] = ACTIONS(12142),
    [anon_sym_GT_GT] = ACTIONS(12142),
    [anon_sym_EQ_EQ] = ACTIONS(12140),
    [anon_sym_BANG_EQ] = ACTIONS(12144),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12144),
    [anon_sym_LT_EQ_GT] = ACTIONS(12144),
    [anon_sym_EQ_TILDE] = ACTIONS(12144),
    [anon_sym_BANG_TILDE] = ACTIONS(12144),
    [anon_sym_LT_EQ] = ACTIONS(12132),
    [anon_sym_GT] = ACTIONS(12132),
    [anon_sym_GT_EQ] = ACTIONS(12146),
    [anon_sym_CARET] = ACTIONS(12126),
    [anon_sym_PLUS] = ACTIONS(12148),
    [anon_sym_SLASH] = ACTIONS(12128),
    [anon_sym_PERCENT] = ACTIONS(12128),
    [sym_comment] = ACTIONS(87),
  },
  [8550] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(9619),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(9623),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_COLON2] = ACTIONS(5827),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(9623),
    [anon_sym_PERCENT] = ACTIONS(9623),
    [sym_comment] = ACTIONS(87),
  },
  [8551] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(9623),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_COLON2] = ACTIONS(5827),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(5827),
    [anon_sym_PERCENT] = ACTIONS(5827),
    [sym_comment] = ACTIONS(87),
  },
  [8552] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(9617),
    [sym__binary_star] = ACTIONS(9619),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(9623),
    [anon_sym_AMP] = ACTIONS(9625),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_COLON2] = ACTIONS(5827),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(9637),
    [anon_sym_GT_GT] = ACTIONS(9637),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(9643),
    [anon_sym_SLASH] = ACTIONS(9623),
    [anon_sym_PERCENT] = ACTIONS(9623),
    [sym_comment] = ACTIONS(87),
  },
  [8553] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(9617),
    [sym__binary_star] = ACTIONS(9619),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(9623),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_COLON2] = ACTIONS(5827),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(9637),
    [anon_sym_GT_GT] = ACTIONS(9637),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(9643),
    [anon_sym_SLASH] = ACTIONS(9623),
    [anon_sym_PERCENT] = ACTIONS(9623),
    [sym_comment] = ACTIONS(87),
  },
  [8554] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(9617),
    [sym__binary_star] = ACTIONS(9619),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(9621),
    [anon_sym_STAR_STAR] = ACTIONS(9623),
    [anon_sym_AMP] = ACTIONS(9625),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_COLON2] = ACTIONS(5827),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(9637),
    [anon_sym_GT_GT] = ACTIONS(9637),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(9621),
    [anon_sym_PLUS] = ACTIONS(9643),
    [anon_sym_SLASH] = ACTIONS(9623),
    [anon_sym_PERCENT] = ACTIONS(9623),
    [sym_comment] = ACTIONS(87),
  },
  [8555] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(13736),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [8556] = {
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(9617),
    [sym__binary_star] = ACTIONS(9619),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(9621),
    [anon_sym_STAR_STAR] = ACTIONS(9623),
    [anon_sym_AMP] = ACTIONS(9625),
    [anon_sym_EQ] = ACTIONS(7888),
    [anon_sym_LT] = ACTIONS(9627),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_EQ_GT] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_PLUS_EQ] = ACTIONS(5927),
    [anon_sym_DASH_EQ] = ACTIONS(5927),
    [anon_sym_STAR_EQ] = ACTIONS(5927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5927),
    [anon_sym_SLASH_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5927),
    [anon_sym_AMP_EQ] = ACTIONS(5927),
    [anon_sym_PERCENT_EQ] = ACTIONS(5927),
    [anon_sym_GT_GT_EQ] = ACTIONS(5927),
    [anon_sym_LT_LT_EQ] = ACTIONS(5927),
    [anon_sym_CARET_EQ] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_COLON2] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(9631),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9633),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(9635),
    [anon_sym_AMP_AMP] = ACTIONS(9635),
    [anon_sym_LT_LT] = ACTIONS(9637),
    [anon_sym_GT_GT] = ACTIONS(9637),
    [anon_sym_EQ_EQ] = ACTIONS(9635),
    [anon_sym_BANG_EQ] = ACTIONS(9639),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9639),
    [anon_sym_LT_EQ_GT] = ACTIONS(9639),
    [anon_sym_EQ_TILDE] = ACTIONS(9639),
    [anon_sym_BANG_TILDE] = ACTIONS(9639),
    [anon_sym_LT_EQ] = ACTIONS(9627),
    [anon_sym_GT] = ACTIONS(9627),
    [anon_sym_GT_EQ] = ACTIONS(9641),
    [anon_sym_CARET] = ACTIONS(9621),
    [anon_sym_PLUS] = ACTIONS(9643),
    [anon_sym_SLASH] = ACTIONS(9623),
    [anon_sym_PERCENT] = ACTIONS(9623),
    [sym_comment] = ACTIONS(87),
  },
  [8557] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(9617),
    [sym__binary_star] = ACTIONS(9619),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(9621),
    [anon_sym_STAR_STAR] = ACTIONS(9623),
    [anon_sym_AMP] = ACTIONS(9625),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(9627),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(9629),
    [anon_sym_COLON2] = ACTIONS(5827),
    [anon_sym_DOT_DOT] = ACTIONS(9631),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9633),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(9635),
    [anon_sym_AMP_AMP] = ACTIONS(9635),
    [anon_sym_LT_LT] = ACTIONS(9637),
    [anon_sym_GT_GT] = ACTIONS(9637),
    [anon_sym_EQ_EQ] = ACTIONS(9635),
    [anon_sym_BANG_EQ] = ACTIONS(9639),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9639),
    [anon_sym_LT_EQ_GT] = ACTIONS(9639),
    [anon_sym_EQ_TILDE] = ACTIONS(9639),
    [anon_sym_BANG_TILDE] = ACTIONS(9639),
    [anon_sym_LT_EQ] = ACTIONS(9627),
    [anon_sym_GT] = ACTIONS(9627),
    [anon_sym_GT_EQ] = ACTIONS(9641),
    [anon_sym_CARET] = ACTIONS(9621),
    [anon_sym_PLUS] = ACTIONS(9643),
    [anon_sym_SLASH] = ACTIONS(9623),
    [anon_sym_PERCENT] = ACTIONS(9623),
    [sym_comment] = ACTIONS(87),
  },
  [8558] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(9617),
    [sym__binary_star] = ACTIONS(9619),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(9621),
    [anon_sym_STAR_STAR] = ACTIONS(9623),
    [anon_sym_AMP] = ACTIONS(9625),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(9627),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_COLON2] = ACTIONS(5827),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(9637),
    [anon_sym_GT_GT] = ACTIONS(9637),
    [anon_sym_EQ_EQ] = ACTIONS(9635),
    [anon_sym_BANG_EQ] = ACTIONS(9639),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9639),
    [anon_sym_LT_EQ_GT] = ACTIONS(9639),
    [anon_sym_EQ_TILDE] = ACTIONS(9639),
    [anon_sym_BANG_TILDE] = ACTIONS(9639),
    [anon_sym_LT_EQ] = ACTIONS(9627),
    [anon_sym_GT] = ACTIONS(9627),
    [anon_sym_GT_EQ] = ACTIONS(9641),
    [anon_sym_CARET] = ACTIONS(9621),
    [anon_sym_PLUS] = ACTIONS(9643),
    [anon_sym_SLASH] = ACTIONS(9623),
    [anon_sym_PERCENT] = ACTIONS(9623),
    [sym_comment] = ACTIONS(87),
  },
  [8559] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(9617),
    [sym__binary_star] = ACTIONS(9619),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(9623),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_COLON2] = ACTIONS(5827),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(9643),
    [anon_sym_SLASH] = ACTIONS(9623),
    [anon_sym_PERCENT] = ACTIONS(9623),
    [sym_comment] = ACTIONS(87),
  },
  [8560] = {
    [sym_heredoc_body] = STATE(8560),
    [aux_sym_call_repeat1] = STATE(8560),
    [sym__heredoc_body_start] = ACTIONS(12549),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_STAR_STAR] = ACTIONS(7919),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_EQ] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_PLUS_EQ] = ACTIONS(7914),
    [anon_sym_DASH_EQ] = ACTIONS(7914),
    [anon_sym_STAR_EQ] = ACTIONS(7914),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7914),
    [anon_sym_SLASH_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7914),
    [anon_sym_AMP_EQ] = ACTIONS(7914),
    [anon_sym_PERCENT_EQ] = ACTIONS(7914),
    [anon_sym_GT_GT_EQ] = ACTIONS(7914),
    [anon_sym_LT_LT_EQ] = ACTIONS(7914),
    [anon_sym_CARET_EQ] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_COLON2] = ACTIONS(7919),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7919),
    [anon_sym_AMP_AMP] = ACTIONS(7919),
    [anon_sym_LT_LT] = ACTIONS(7919),
    [anon_sym_GT_GT] = ACTIONS(7919),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7919),
    [anon_sym_PLUS] = ACTIONS(7919),
    [anon_sym_SLASH] = ACTIONS(7919),
    [anon_sym_PERCENT] = ACTIONS(7919),
    [sym_comment] = ACTIONS(87),
  },
  [8561] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3548),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3553),
    [sym_scope_resolution] = STATE(3549),
    [sym_call] = STATE(3549),
    [sym_method_call] = STATE(3553),
    [sym__argument] = STATE(8888),
    [sym_splat_argument] = STATE(8888),
    [sym_hash_splat_argument] = STATE(8888),
    [sym_block_argument] = STATE(8888),
    [sym_assignment] = STATE(3548),
    [sym_operator_assignment] = STATE(3548),
    [sym_conditional] = STATE(3548),
    [sym_range] = STATE(3548),
    [sym_binary] = STATE(3548),
    [sym_unary] = STATE(3548),
    [sym_left_assignment_list] = STATE(3552),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3553),
    [sym__variable] = STATE(3549),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3553),
    [sym_false] = STATE(3553),
    [sym_nil] = STATE(3553),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3554),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(8888),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(5891),
    [sym__splat_star] = ACTIONS(5893),
    [sym__unary_minus] = ACTIONS(5895),
    [sym__identifier_hash_key] = ACTIONS(5897),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12158),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5899),
    [anon_sym_yield] = ACTIONS(5901),
    [anon_sym_break] = ACTIONS(5903),
    [anon_sym_next] = ACTIONS(5905),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(9611),
    [anon_sym_defined_QMARK] = ACTIONS(5907),
    [anon_sym_not] = ACTIONS(5909),
    [anon_sym_BANG] = ACTIONS(5913),
    [anon_sym_TILDE] = ACTIONS(5913),
    [sym_constant] = ACTIONS(5915),
    [sym_identifier] = ACTIONS(5915),
    [sym_instance_variable] = ACTIONS(5917),
    [sym_class_variable] = ACTIONS(5917),
    [sym_global_variable] = ACTIONS(5917),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5919),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5919),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [8562] = {
    [sym_heredoc_body] = STATE(8560),
    [aux_sym_call_repeat1] = STATE(8560),
    [sym__heredoc_body_start] = ACTIONS(6569),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_STAR_STAR] = ACTIONS(7931),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_EQ] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_PLUS_EQ] = ACTIONS(7929),
    [anon_sym_DASH_EQ] = ACTIONS(7929),
    [anon_sym_STAR_EQ] = ACTIONS(7929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7929),
    [anon_sym_SLASH_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7929),
    [anon_sym_AMP_EQ] = ACTIONS(7929),
    [anon_sym_PERCENT_EQ] = ACTIONS(7929),
    [anon_sym_GT_GT_EQ] = ACTIONS(7929),
    [anon_sym_LT_LT_EQ] = ACTIONS(7929),
    [anon_sym_CARET_EQ] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_COLON2] = ACTIONS(7931),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7931),
    [anon_sym_AMP_AMP] = ACTIONS(7931),
    [anon_sym_LT_LT] = ACTIONS(7931),
    [anon_sym_GT_GT] = ACTIONS(7931),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7931),
    [anon_sym_PLUS] = ACTIONS(7931),
    [anon_sym_SLASH] = ACTIONS(7931),
    [anon_sym_PERCENT] = ACTIONS(7931),
    [sym_comment] = ACTIONS(87),
  },
  [8563] = {
    [aux_sym_argument_list_repeat1] = STATE(8563),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(13738),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_STAR_STAR] = ACTIONS(7927),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_EQ] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_PLUS_EQ] = ACTIONS(7925),
    [anon_sym_DASH_EQ] = ACTIONS(7925),
    [anon_sym_STAR_EQ] = ACTIONS(7925),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7925),
    [anon_sym_SLASH_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7925),
    [anon_sym_AMP_EQ] = ACTIONS(7925),
    [anon_sym_PERCENT_EQ] = ACTIONS(7925),
    [anon_sym_GT_GT_EQ] = ACTIONS(7925),
    [anon_sym_LT_LT_EQ] = ACTIONS(7925),
    [anon_sym_CARET_EQ] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_COLON2] = ACTIONS(7927),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7927),
    [anon_sym_AMP_AMP] = ACTIONS(7927),
    [anon_sym_LT_LT] = ACTIONS(7927),
    [anon_sym_GT_GT] = ACTIONS(7927),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7927),
    [anon_sym_PLUS] = ACTIONS(7927),
    [anon_sym_SLASH] = ACTIONS(7927),
    [anon_sym_PERCENT] = ACTIONS(7927),
    [sym_comment] = ACTIONS(87),
  },
  [8564] = {
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(9617),
    [sym__binary_star] = ACTIONS(9619),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(9621),
    [anon_sym_STAR_STAR] = ACTIONS(9623),
    [anon_sym_AMP] = ACTIONS(9625),
    [anon_sym_EQ] = ACTIONS(7936),
    [anon_sym_LT] = ACTIONS(9627),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_EQ_GT] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_PLUS_EQ] = ACTIONS(5115),
    [anon_sym_DASH_EQ] = ACTIONS(5115),
    [anon_sym_STAR_EQ] = ACTIONS(5115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5115),
    [anon_sym_SLASH_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5115),
    [anon_sym_AMP_EQ] = ACTIONS(5115),
    [anon_sym_PERCENT_EQ] = ACTIONS(5115),
    [anon_sym_GT_GT_EQ] = ACTIONS(5115),
    [anon_sym_LT_LT_EQ] = ACTIONS(5115),
    [anon_sym_CARET_EQ] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(9629),
    [anon_sym_COLON2] = ACTIONS(7936),
    [anon_sym_DOT_DOT] = ACTIONS(9631),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9633),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(9635),
    [anon_sym_AMP_AMP] = ACTIONS(9635),
    [anon_sym_LT_LT] = ACTIONS(9637),
    [anon_sym_GT_GT] = ACTIONS(9637),
    [anon_sym_EQ_EQ] = ACTIONS(9635),
    [anon_sym_BANG_EQ] = ACTIONS(9639),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9639),
    [anon_sym_LT_EQ_GT] = ACTIONS(9639),
    [anon_sym_EQ_TILDE] = ACTIONS(9639),
    [anon_sym_BANG_TILDE] = ACTIONS(9639),
    [anon_sym_LT_EQ] = ACTIONS(9627),
    [anon_sym_GT] = ACTIONS(9627),
    [anon_sym_GT_EQ] = ACTIONS(9641),
    [anon_sym_CARET] = ACTIONS(9621),
    [anon_sym_PLUS] = ACTIONS(9643),
    [anon_sym_SLASH] = ACTIONS(9623),
    [anon_sym_PERCENT] = ACTIONS(9623),
    [sym_comment] = ACTIONS(87),
  },
  [8565] = {
    [aux_sym_exceptions_repeat1] = STATE(10029),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_STAR_STAR] = ACTIONS(6193),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_PLUS_EQ] = ACTIONS(6191),
    [anon_sym_DASH_EQ] = ACTIONS(6191),
    [anon_sym_STAR_EQ] = ACTIONS(6191),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6191),
    [anon_sym_SLASH_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6191),
    [anon_sym_AMP_EQ] = ACTIONS(6191),
    [anon_sym_PERCENT_EQ] = ACTIONS(6191),
    [anon_sym_GT_GT_EQ] = ACTIONS(6191),
    [anon_sym_LT_LT_EQ] = ACTIONS(6191),
    [anon_sym_CARET_EQ] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_COLON2] = ACTIONS(6193),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6193),
    [anon_sym_AMP_AMP] = ACTIONS(6193),
    [anon_sym_LT_LT] = ACTIONS(6193),
    [anon_sym_GT_GT] = ACTIONS(6193),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6193),
    [anon_sym_PLUS] = ACTIONS(6193),
    [anon_sym_SLASH] = ACTIONS(6193),
    [anon_sym_PERCENT] = ACTIONS(6193),
    [sym_comment] = ACTIONS(87),
  },
  [8566] = {
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(9617),
    [sym__binary_star] = ACTIONS(9619),
    [anon_sym_LBRACE] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(9621),
    [anon_sym_STAR_STAR] = ACTIONS(9623),
    [anon_sym_AMP] = ACTIONS(9625),
    [anon_sym_EQ] = ACTIONS(7938),
    [anon_sym_LT] = ACTIONS(9627),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_EQ_GT] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_PLUS_EQ] = ACTIONS(6210),
    [anon_sym_DASH_EQ] = ACTIONS(6210),
    [anon_sym_STAR_EQ] = ACTIONS(6210),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6210),
    [anon_sym_SLASH_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6210),
    [anon_sym_AMP_EQ] = ACTIONS(6210),
    [anon_sym_PERCENT_EQ] = ACTIONS(6210),
    [anon_sym_GT_GT_EQ] = ACTIONS(6210),
    [anon_sym_LT_LT_EQ] = ACTIONS(6210),
    [anon_sym_CARET_EQ] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(9629),
    [anon_sym_COLON2] = ACTIONS(7938),
    [anon_sym_DOT_DOT] = ACTIONS(9631),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9633),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(9635),
    [anon_sym_AMP_AMP] = ACTIONS(9635),
    [anon_sym_LT_LT] = ACTIONS(9637),
    [anon_sym_GT_GT] = ACTIONS(9637),
    [anon_sym_EQ_EQ] = ACTIONS(9635),
    [anon_sym_BANG_EQ] = ACTIONS(9639),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9639),
    [anon_sym_LT_EQ_GT] = ACTIONS(9639),
    [anon_sym_EQ_TILDE] = ACTIONS(9639),
    [anon_sym_BANG_TILDE] = ACTIONS(9639),
    [anon_sym_LT_EQ] = ACTIONS(9627),
    [anon_sym_GT] = ACTIONS(9627),
    [anon_sym_GT_EQ] = ACTIONS(9641),
    [anon_sym_CARET] = ACTIONS(9621),
    [anon_sym_PLUS] = ACTIONS(9643),
    [anon_sym_SLASH] = ACTIONS(9623),
    [anon_sym_PERCENT] = ACTIONS(9623),
    [sym_comment] = ACTIONS(87),
  },
  [8567] = {
    [sym_string] = STATE(8567),
    [aux_sym_chained_string_repeat1] = STATE(8567),
    [sym__string_start] = ACTIONS(13741),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_STAR_STAR] = ACTIONS(6217),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_EQ] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_do] = ACTIONS(6212),
    [anon_sym_EQ_GT] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_PLUS_EQ] = ACTIONS(6212),
    [anon_sym_DASH_EQ] = ACTIONS(6212),
    [anon_sym_STAR_EQ] = ACTIONS(6212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6212),
    [anon_sym_SLASH_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6212),
    [anon_sym_AMP_EQ] = ACTIONS(6212),
    [anon_sym_PERCENT_EQ] = ACTIONS(6212),
    [anon_sym_GT_GT_EQ] = ACTIONS(6212),
    [anon_sym_LT_LT_EQ] = ACTIONS(6212),
    [anon_sym_CARET_EQ] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_COLON2] = ACTIONS(6217),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6217),
    [anon_sym_AMP_AMP] = ACTIONS(6217),
    [anon_sym_LT_LT] = ACTIONS(6217),
    [anon_sym_GT_GT] = ACTIONS(6217),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6217),
    [anon_sym_PLUS] = ACTIONS(6217),
    [anon_sym_SLASH] = ACTIONS(6217),
    [anon_sym_PERCENT] = ACTIONS(6217),
    [sym_comment] = ACTIONS(87),
  },
  [8568] = {
    [sym__binary_minus] = ACTIONS(12160),
    [sym__binary_star] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(12164),
    [anon_sym_STAR_STAR] = ACTIONS(12162),
    [anon_sym_AMP] = ACTIONS(12166),
    [anon_sym_LT] = ACTIONS(12168),
    [anon_sym_QMARK] = ACTIONS(12170),
    [anon_sym_COLON2] = ACTIONS(4247),
    [anon_sym_DOT_DOT] = ACTIONS(12172),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12174),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(12176),
    [anon_sym_AMP_AMP] = ACTIONS(12176),
    [anon_sym_LT_LT] = ACTIONS(12178),
    [anon_sym_GT_GT] = ACTIONS(12178),
    [anon_sym_EQ_EQ] = ACTIONS(12180),
    [anon_sym_BANG_EQ] = ACTIONS(12176),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12176),
    [anon_sym_LT_EQ_GT] = ACTIONS(12176),
    [anon_sym_EQ_TILDE] = ACTIONS(12176),
    [anon_sym_BANG_TILDE] = ACTIONS(12176),
    [anon_sym_LT_EQ] = ACTIONS(12168),
    [anon_sym_GT] = ACTIONS(12168),
    [anon_sym_GT_EQ] = ACTIONS(12182),
    [anon_sym_CARET] = ACTIONS(12184),
    [anon_sym_PLUS] = ACTIONS(12160),
    [anon_sym_SLASH] = ACTIONS(12162),
    [anon_sym_PERCENT] = ACTIONS(12162),
    [sym_comment] = ACTIONS(87),
  },
  [8569] = {
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(12162),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_COLON2] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [8570] = {
    [sym__binary_minus] = ACTIONS(12160),
    [sym__binary_star] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(12164),
    [anon_sym_STAR_STAR] = ACTIONS(12162),
    [anon_sym_AMP] = ACTIONS(12166),
    [anon_sym_LT] = ACTIONS(12168),
    [anon_sym_QMARK] = ACTIONS(12170),
    [anon_sym_COLON2] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(12172),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12174),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(12176),
    [anon_sym_AMP_AMP] = ACTIONS(12176),
    [anon_sym_LT_LT] = ACTIONS(12178),
    [anon_sym_GT_GT] = ACTIONS(12178),
    [anon_sym_EQ_EQ] = ACTIONS(12180),
    [anon_sym_BANG_EQ] = ACTIONS(12176),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12176),
    [anon_sym_LT_EQ_GT] = ACTIONS(12176),
    [anon_sym_EQ_TILDE] = ACTIONS(12176),
    [anon_sym_BANG_TILDE] = ACTIONS(12176),
    [anon_sym_LT_EQ] = ACTIONS(12168),
    [anon_sym_GT] = ACTIONS(12168),
    [anon_sym_GT_EQ] = ACTIONS(12182),
    [anon_sym_CARET] = ACTIONS(12184),
    [anon_sym_PLUS] = ACTIONS(12160),
    [anon_sym_SLASH] = ACTIONS(12162),
    [anon_sym_PERCENT] = ACTIONS(12162),
    [sym_comment] = ACTIONS(87),
  },
  [8571] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(10030),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(6247),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(6247),
    [sym_assignment] = STATE(10030),
    [sym_operator_assignment] = STATE(10030),
    [sym_conditional] = STATE(10030),
    [sym_range] = STATE(10030),
    [sym_binary] = STATE(10030),
    [sym_unary] = STATE(10030),
    [sym_left_assignment_list] = STATE(6246),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6247),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(6247),
    [sym_false] = STATE(6247),
    [sym_nil] = STATE(6247),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(6248),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(9657),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9659),
    [anon_sym_yield] = ACTIONS(9661),
    [anon_sym_break] = ACTIONS(9663),
    [anon_sym_next] = ACTIONS(9665),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9667),
    [anon_sym_defined_QMARK] = ACTIONS(9669),
    [anon_sym_not] = ACTIONS(9671),
    [anon_sym_BANG] = ACTIONS(9673),
    [anon_sym_TILDE] = ACTIONS(9673),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8572] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(10031),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(6247),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(6247),
    [sym_assignment] = STATE(10031),
    [sym_operator_assignment] = STATE(10031),
    [sym_conditional] = STATE(10031),
    [sym_range] = STATE(10031),
    [sym_binary] = STATE(10031),
    [sym_unary] = STATE(10031),
    [sym_left_assignment_list] = STATE(6246),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6247),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(6247),
    [sym_false] = STATE(6247),
    [sym_nil] = STATE(6247),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(6248),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(9657),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9659),
    [anon_sym_yield] = ACTIONS(9661),
    [anon_sym_break] = ACTIONS(9663),
    [anon_sym_next] = ACTIONS(9665),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9667),
    [anon_sym_defined_QMARK] = ACTIONS(9669),
    [anon_sym_not] = ACTIONS(9671),
    [anon_sym_BANG] = ACTIONS(9673),
    [anon_sym_TILDE] = ACTIONS(9673),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8573] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(10032),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(6247),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(6247),
    [sym_assignment] = STATE(10032),
    [sym_operator_assignment] = STATE(10032),
    [sym_conditional] = STATE(10032),
    [sym_range] = STATE(10032),
    [sym_binary] = STATE(10032),
    [sym_unary] = STATE(10032),
    [sym_left_assignment_list] = STATE(6246),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6247),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(6247),
    [sym_false] = STATE(6247),
    [sym_nil] = STATE(6247),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(6248),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(9657),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9659),
    [anon_sym_yield] = ACTIONS(9661),
    [anon_sym_break] = ACTIONS(9663),
    [anon_sym_next] = ACTIONS(9665),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9667),
    [anon_sym_defined_QMARK] = ACTIONS(9669),
    [anon_sym_not] = ACTIONS(9671),
    [anon_sym_BANG] = ACTIONS(9673),
    [anon_sym_TILDE] = ACTIONS(9673),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8574] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(10033),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(6247),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(6247),
    [sym_assignment] = STATE(10033),
    [sym_operator_assignment] = STATE(10033),
    [sym_conditional] = STATE(10033),
    [sym_range] = STATE(10033),
    [sym_binary] = STATE(10033),
    [sym_unary] = STATE(10033),
    [sym_left_assignment_list] = STATE(6246),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6247),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(6247),
    [sym_false] = STATE(6247),
    [sym_nil] = STATE(6247),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(6248),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(9657),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9659),
    [anon_sym_yield] = ACTIONS(9661),
    [anon_sym_break] = ACTIONS(9663),
    [anon_sym_next] = ACTIONS(9665),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9667),
    [anon_sym_defined_QMARK] = ACTIONS(9669),
    [anon_sym_not] = ACTIONS(9671),
    [anon_sym_BANG] = ACTIONS(9673),
    [anon_sym_TILDE] = ACTIONS(9673),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8575] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(10034),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(6247),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(6247),
    [sym_assignment] = STATE(10034),
    [sym_operator_assignment] = STATE(10034),
    [sym_conditional] = STATE(10034),
    [sym_range] = STATE(10034),
    [sym_binary] = STATE(10034),
    [sym_unary] = STATE(10034),
    [sym_left_assignment_list] = STATE(6246),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6247),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(6247),
    [sym_false] = STATE(6247),
    [sym_nil] = STATE(6247),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(6248),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(9657),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9659),
    [anon_sym_yield] = ACTIONS(9661),
    [anon_sym_break] = ACTIONS(9663),
    [anon_sym_next] = ACTIONS(9665),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9667),
    [anon_sym_defined_QMARK] = ACTIONS(9669),
    [anon_sym_not] = ACTIONS(9671),
    [anon_sym_BANG] = ACTIONS(9673),
    [anon_sym_TILDE] = ACTIONS(9673),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8576] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(10035),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(10035),
    [sym_operator_assignment] = STATE(10035),
    [sym_conditional] = STATE(10035),
    [sym_range] = STATE(10035),
    [sym_binary] = STATE(10035),
    [sym_unary] = STATE(10035),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8577] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(10036),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(6247),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(6247),
    [sym_assignment] = STATE(10036),
    [sym_operator_assignment] = STATE(10036),
    [sym_conditional] = STATE(10036),
    [sym_range] = STATE(10036),
    [sym_binary] = STATE(10036),
    [sym_unary] = STATE(10036),
    [sym_left_assignment_list] = STATE(6246),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6247),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(6247),
    [sym_false] = STATE(6247),
    [sym_nil] = STATE(6247),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(6248),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(9657),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9659),
    [anon_sym_yield] = ACTIONS(9661),
    [anon_sym_break] = ACTIONS(9663),
    [anon_sym_next] = ACTIONS(9665),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9667),
    [anon_sym_defined_QMARK] = ACTIONS(9669),
    [anon_sym_not] = ACTIONS(9671),
    [anon_sym_BANG] = ACTIONS(9673),
    [anon_sym_TILDE] = ACTIONS(9673),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8578] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(10037),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(6247),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(6247),
    [sym_assignment] = STATE(10037),
    [sym_operator_assignment] = STATE(10037),
    [sym_conditional] = STATE(10037),
    [sym_range] = STATE(10037),
    [sym_binary] = STATE(10037),
    [sym_unary] = STATE(10037),
    [sym_left_assignment_list] = STATE(6246),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6247),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(6247),
    [sym_false] = STATE(6247),
    [sym_nil] = STATE(6247),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(6248),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(9657),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9659),
    [anon_sym_yield] = ACTIONS(9661),
    [anon_sym_break] = ACTIONS(9663),
    [anon_sym_next] = ACTIONS(9665),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9667),
    [anon_sym_defined_QMARK] = ACTIONS(9669),
    [anon_sym_not] = ACTIONS(9671),
    [anon_sym_BANG] = ACTIONS(9673),
    [anon_sym_TILDE] = ACTIONS(9673),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8579] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(10038),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(6247),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(6247),
    [sym_assignment] = STATE(10038),
    [sym_operator_assignment] = STATE(10038),
    [sym_conditional] = STATE(10038),
    [sym_range] = STATE(10038),
    [sym_binary] = STATE(10038),
    [sym_unary] = STATE(10038),
    [sym_left_assignment_list] = STATE(6246),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6247),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(6247),
    [sym_false] = STATE(6247),
    [sym_nil] = STATE(6247),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(6248),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(9657),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9659),
    [anon_sym_yield] = ACTIONS(9661),
    [anon_sym_break] = ACTIONS(9663),
    [anon_sym_next] = ACTIONS(9665),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9667),
    [anon_sym_defined_QMARK] = ACTIONS(9669),
    [anon_sym_not] = ACTIONS(9671),
    [anon_sym_BANG] = ACTIONS(9673),
    [anon_sym_TILDE] = ACTIONS(9673),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8580] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(10039),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(6247),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(6247),
    [sym_assignment] = STATE(10039),
    [sym_operator_assignment] = STATE(10039),
    [sym_conditional] = STATE(10039),
    [sym_range] = STATE(10039),
    [sym_binary] = STATE(10039),
    [sym_unary] = STATE(10039),
    [sym_left_assignment_list] = STATE(6246),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6247),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(6247),
    [sym_false] = STATE(6247),
    [sym_nil] = STATE(6247),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(6248),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(9657),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9659),
    [anon_sym_yield] = ACTIONS(9661),
    [anon_sym_break] = ACTIONS(9663),
    [anon_sym_next] = ACTIONS(9665),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9667),
    [anon_sym_defined_QMARK] = ACTIONS(9669),
    [anon_sym_not] = ACTIONS(9671),
    [anon_sym_BANG] = ACTIONS(9673),
    [anon_sym_TILDE] = ACTIONS(9673),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8581] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(6244),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(6247),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(6247),
    [sym_splat_argument] = STATE(6983),
    [sym_assignment] = STATE(6244),
    [sym_operator_assignment] = STATE(6244),
    [sym_conditional] = STATE(6244),
    [sym_range] = STATE(6244),
    [sym_binary] = STATE(6244),
    [sym_unary] = STATE(6244),
    [sym__arg_or_splat_arg] = STATE(6983),
    [sym_left_assignment_list] = STATE(6246),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6247),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(6247),
    [sym_false] = STATE(6247),
    [sym_nil] = STATE(6247),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(6248),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__splat_star] = ACTIONS(9655),
    [sym__unary_minus] = ACTIONS(9657),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9659),
    [anon_sym_yield] = ACTIONS(9661),
    [anon_sym_break] = ACTIONS(9663),
    [anon_sym_next] = ACTIONS(9665),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9667),
    [anon_sym_defined_QMARK] = ACTIONS(9669),
    [anon_sym_not] = ACTIONS(9671),
    [anon_sym_BANG] = ACTIONS(9673),
    [anon_sym_TILDE] = ACTIONS(9673),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8582] = {
    [aux_sym_exceptions_repeat1] = STATE(10040),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_COMMA] = ACTIONS(12186),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_COLON2] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [8583] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(6244),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(6247),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(6247),
    [sym_splat_argument] = STATE(10041),
    [sym_assignment] = STATE(6244),
    [sym_operator_assignment] = STATE(6244),
    [sym_conditional] = STATE(6244),
    [sym_range] = STATE(6244),
    [sym_binary] = STATE(6244),
    [sym_unary] = STATE(6244),
    [sym_right_assignment_list] = STATE(2035),
    [sym__arg_or_splat_arg] = STATE(10041),
    [sym_left_assignment_list] = STATE(6246),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6247),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(6247),
    [sym_false] = STATE(6247),
    [sym_nil] = STATE(6247),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(6248),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__splat_star] = ACTIONS(9655),
    [sym__unary_minus] = ACTIONS(9657),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9659),
    [anon_sym_yield] = ACTIONS(9661),
    [anon_sym_break] = ACTIONS(9663),
    [anon_sym_next] = ACTIONS(9665),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9667),
    [anon_sym_defined_QMARK] = ACTIONS(9669),
    [anon_sym_not] = ACTIONS(9671),
    [anon_sym_BANG] = ACTIONS(9673),
    [anon_sym_TILDE] = ACTIONS(9673),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8584] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(10042),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(6247),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(6247),
    [sym_assignment] = STATE(10042),
    [sym_operator_assignment] = STATE(10042),
    [sym_conditional] = STATE(10042),
    [sym_range] = STATE(10042),
    [sym_binary] = STATE(10042),
    [sym_unary] = STATE(10042),
    [sym_left_assignment_list] = STATE(6246),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6247),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(6247),
    [sym_false] = STATE(6247),
    [sym_nil] = STATE(6247),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(6248),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(9657),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9659),
    [anon_sym_yield] = ACTIONS(9661),
    [anon_sym_break] = ACTIONS(9663),
    [anon_sym_next] = ACTIONS(9665),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9667),
    [anon_sym_defined_QMARK] = ACTIONS(9669),
    [anon_sym_not] = ACTIONS(9671),
    [anon_sym_BANG] = ACTIONS(9673),
    [anon_sym_TILDE] = ACTIONS(9673),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8585] = {
    [sym_string] = STATE(10043),
    [aux_sym_chained_string_repeat1] = STATE(10043),
    [sym__string_start] = ACTIONS(2495),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_COLON2] = ACTIONS(2755),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [8586] = {
    [sym__line_break] = ACTIONS(10203),
    [sym__heredoc_body_start] = ACTIONS(10203),
    [sym__binary_minus] = ACTIONS(10203),
    [sym__binary_star] = ACTIONS(10203),
    [ts_builtin_sym_end] = ACTIONS(10203),
    [anon_sym___END__] = ACTIONS(10203),
    [anon_sym_LBRACE] = ACTIONS(10203),
    [anon_sym_RBRACE] = ACTIONS(10203),
    [anon_sym_RPAREN] = ACTIONS(10203),
    [anon_sym_DOT] = ACTIONS(10205),
    [anon_sym_COMMA] = ACTIONS(10203),
    [anon_sym_PIPE] = ACTIONS(10205),
    [anon_sym_SEMI] = ACTIONS(10203),
    [anon_sym_STAR_STAR] = ACTIONS(10205),
    [anon_sym_AMP] = ACTIONS(10205),
    [anon_sym_EQ] = ACTIONS(10205),
    [anon_sym_LT] = ACTIONS(10205),
    [anon_sym_end] = ACTIONS(10203),
    [anon_sym_if] = ACTIONS(10203),
    [anon_sym_unless] = ACTIONS(10203),
    [anon_sym_while] = ACTIONS(10203),
    [anon_sym_until] = ACTIONS(10203),
    [anon_sym_rescue] = ACTIONS(10203),
    [anon_sym_do] = ACTIONS(10203),
    [anon_sym_when] = ACTIONS(10203),
    [anon_sym_elsif] = ACTIONS(10203),
    [anon_sym_else] = ACTIONS(10203),
    [anon_sym_then] = ACTIONS(10203),
    [anon_sym_ensure] = ACTIONS(10203),
    [anon_sym_EQ_GT] = ACTIONS(10203),
    [anon_sym_LBRACK] = ACTIONS(10203),
    [anon_sym_COLON_COLON2] = ACTIONS(10203),
    [anon_sym_AMP_DOT] = ACTIONS(10203),
    [anon_sym_PLUS_EQ] = ACTIONS(10203),
    [anon_sym_DASH_EQ] = ACTIONS(10203),
    [anon_sym_STAR_EQ] = ACTIONS(10203),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10203),
    [anon_sym_SLASH_EQ] = ACTIONS(10203),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10203),
    [anon_sym_PIPE_EQ] = ACTIONS(10203),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10203),
    [anon_sym_AMP_EQ] = ACTIONS(10203),
    [anon_sym_PERCENT_EQ] = ACTIONS(10203),
    [anon_sym_GT_GT_EQ] = ACTIONS(10203),
    [anon_sym_LT_LT_EQ] = ACTIONS(10203),
    [anon_sym_CARET_EQ] = ACTIONS(10203),
    [anon_sym_QMARK] = ACTIONS(10203),
    [anon_sym_DOT_DOT] = ACTIONS(10205),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10203),
    [anon_sym_and] = ACTIONS(10203),
    [anon_sym_or] = ACTIONS(10203),
    [anon_sym_PIPE_PIPE] = ACTIONS(10205),
    [anon_sym_AMP_AMP] = ACTIONS(10205),
    [anon_sym_LT_LT] = ACTIONS(10205),
    [anon_sym_GT_GT] = ACTIONS(10205),
    [anon_sym_EQ_EQ] = ACTIONS(10205),
    [anon_sym_BANG_EQ] = ACTIONS(10203),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10203),
    [anon_sym_LT_EQ_GT] = ACTIONS(10203),
    [anon_sym_EQ_TILDE] = ACTIONS(10203),
    [anon_sym_BANG_TILDE] = ACTIONS(10203),
    [anon_sym_LT_EQ] = ACTIONS(10205),
    [anon_sym_GT] = ACTIONS(10205),
    [anon_sym_GT_EQ] = ACTIONS(10203),
    [anon_sym_CARET] = ACTIONS(10205),
    [anon_sym_PLUS] = ACTIONS(10205),
    [anon_sym_SLASH] = ACTIONS(10205),
    [anon_sym_PERCENT] = ACTIONS(10205),
    [sym_comment] = ACTIONS(87),
  },
  [8587] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1697),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(13744),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [8588] = {
    [sym__line_break] = ACTIONS(10209),
    [sym__heredoc_body_start] = ACTIONS(10209),
    [sym__binary_minus] = ACTIONS(10209),
    [sym__binary_star] = ACTIONS(10209),
    [ts_builtin_sym_end] = ACTIONS(10209),
    [anon_sym___END__] = ACTIONS(10209),
    [anon_sym_LBRACE] = ACTIONS(10209),
    [anon_sym_RBRACE] = ACTIONS(10209),
    [anon_sym_RPAREN] = ACTIONS(10209),
    [anon_sym_DOT] = ACTIONS(10211),
    [anon_sym_COMMA] = ACTIONS(10209),
    [anon_sym_PIPE] = ACTIONS(10211),
    [anon_sym_SEMI] = ACTIONS(10209),
    [anon_sym_STAR_STAR] = ACTIONS(10211),
    [anon_sym_AMP] = ACTIONS(10211),
    [anon_sym_EQ] = ACTIONS(10211),
    [anon_sym_LT] = ACTIONS(10211),
    [anon_sym_end] = ACTIONS(10209),
    [anon_sym_if] = ACTIONS(10209),
    [anon_sym_unless] = ACTIONS(10209),
    [anon_sym_while] = ACTIONS(10209),
    [anon_sym_until] = ACTIONS(10209),
    [anon_sym_rescue] = ACTIONS(10209),
    [anon_sym_do] = ACTIONS(10209),
    [anon_sym_when] = ACTIONS(10209),
    [anon_sym_elsif] = ACTIONS(10209),
    [anon_sym_else] = ACTIONS(10209),
    [anon_sym_then] = ACTIONS(10209),
    [anon_sym_ensure] = ACTIONS(10209),
    [anon_sym_EQ_GT] = ACTIONS(10209),
    [anon_sym_LBRACK] = ACTIONS(10209),
    [anon_sym_COLON_COLON2] = ACTIONS(10209),
    [anon_sym_AMP_DOT] = ACTIONS(10209),
    [anon_sym_PLUS_EQ] = ACTIONS(10209),
    [anon_sym_DASH_EQ] = ACTIONS(10209),
    [anon_sym_STAR_EQ] = ACTIONS(10209),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10209),
    [anon_sym_SLASH_EQ] = ACTIONS(10209),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10209),
    [anon_sym_PIPE_EQ] = ACTIONS(10209),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10209),
    [anon_sym_AMP_EQ] = ACTIONS(10209),
    [anon_sym_PERCENT_EQ] = ACTIONS(10209),
    [anon_sym_GT_GT_EQ] = ACTIONS(10209),
    [anon_sym_LT_LT_EQ] = ACTIONS(10209),
    [anon_sym_CARET_EQ] = ACTIONS(10209),
    [anon_sym_QMARK] = ACTIONS(10209),
    [anon_sym_DOT_DOT] = ACTIONS(10211),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10209),
    [anon_sym_and] = ACTIONS(10209),
    [anon_sym_or] = ACTIONS(10209),
    [anon_sym_PIPE_PIPE] = ACTIONS(10211),
    [anon_sym_AMP_AMP] = ACTIONS(10211),
    [anon_sym_LT_LT] = ACTIONS(10211),
    [anon_sym_GT_GT] = ACTIONS(10211),
    [anon_sym_EQ_EQ] = ACTIONS(10211),
    [anon_sym_BANG_EQ] = ACTIONS(10209),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10209),
    [anon_sym_LT_EQ_GT] = ACTIONS(10209),
    [anon_sym_EQ_TILDE] = ACTIONS(10209),
    [anon_sym_BANG_TILDE] = ACTIONS(10209),
    [anon_sym_LT_EQ] = ACTIONS(10211),
    [anon_sym_GT] = ACTIONS(10211),
    [anon_sym_GT_EQ] = ACTIONS(10209),
    [anon_sym_CARET] = ACTIONS(10211),
    [anon_sym_PLUS] = ACTIONS(10211),
    [anon_sym_SLASH] = ACTIONS(10211),
    [anon_sym_PERCENT] = ACTIONS(10211),
    [sym_comment] = ACTIONS(87),
  },
  [8589] = {
    [sym__line_break] = ACTIONS(10213),
    [sym__heredoc_body_start] = ACTIONS(10213),
    [sym__binary_minus] = ACTIONS(10213),
    [sym__binary_star] = ACTIONS(10213),
    [ts_builtin_sym_end] = ACTIONS(10213),
    [anon_sym___END__] = ACTIONS(10213),
    [anon_sym_LBRACE] = ACTIONS(10213),
    [anon_sym_RBRACE] = ACTIONS(10213),
    [anon_sym_RPAREN] = ACTIONS(10213),
    [anon_sym_DOT] = ACTIONS(10215),
    [anon_sym_COMMA] = ACTIONS(10213),
    [anon_sym_PIPE] = ACTIONS(10215),
    [anon_sym_SEMI] = ACTIONS(10213),
    [anon_sym_STAR_STAR] = ACTIONS(10215),
    [anon_sym_AMP] = ACTIONS(10215),
    [anon_sym_EQ] = ACTIONS(10215),
    [anon_sym_LT] = ACTIONS(10215),
    [anon_sym_end] = ACTIONS(10213),
    [anon_sym_if] = ACTIONS(10213),
    [anon_sym_unless] = ACTIONS(10213),
    [anon_sym_while] = ACTIONS(10213),
    [anon_sym_until] = ACTIONS(10213),
    [anon_sym_rescue] = ACTIONS(10213),
    [anon_sym_do] = ACTIONS(10213),
    [anon_sym_when] = ACTIONS(10213),
    [anon_sym_elsif] = ACTIONS(10213),
    [anon_sym_else] = ACTIONS(10213),
    [anon_sym_then] = ACTIONS(10213),
    [anon_sym_ensure] = ACTIONS(10213),
    [anon_sym_EQ_GT] = ACTIONS(10213),
    [anon_sym_LBRACK] = ACTIONS(10213),
    [anon_sym_COLON_COLON2] = ACTIONS(10213),
    [anon_sym_AMP_DOT] = ACTIONS(10213),
    [anon_sym_PLUS_EQ] = ACTIONS(10213),
    [anon_sym_DASH_EQ] = ACTIONS(10213),
    [anon_sym_STAR_EQ] = ACTIONS(10213),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10213),
    [anon_sym_SLASH_EQ] = ACTIONS(10213),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10213),
    [anon_sym_PIPE_EQ] = ACTIONS(10213),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10213),
    [anon_sym_AMP_EQ] = ACTIONS(10213),
    [anon_sym_PERCENT_EQ] = ACTIONS(10213),
    [anon_sym_GT_GT_EQ] = ACTIONS(10213),
    [anon_sym_LT_LT_EQ] = ACTIONS(10213),
    [anon_sym_CARET_EQ] = ACTIONS(10213),
    [anon_sym_QMARK] = ACTIONS(10213),
    [anon_sym_DOT_DOT] = ACTIONS(10215),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10213),
    [anon_sym_and] = ACTIONS(10213),
    [anon_sym_or] = ACTIONS(10213),
    [anon_sym_PIPE_PIPE] = ACTIONS(10215),
    [anon_sym_AMP_AMP] = ACTIONS(10215),
    [anon_sym_LT_LT] = ACTIONS(10215),
    [anon_sym_GT_GT] = ACTIONS(10215),
    [anon_sym_EQ_EQ] = ACTIONS(10215),
    [anon_sym_BANG_EQ] = ACTIONS(10213),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10213),
    [anon_sym_LT_EQ_GT] = ACTIONS(10213),
    [anon_sym_EQ_TILDE] = ACTIONS(10213),
    [anon_sym_BANG_TILDE] = ACTIONS(10213),
    [anon_sym_LT_EQ] = ACTIONS(10215),
    [anon_sym_GT] = ACTIONS(10215),
    [anon_sym_GT_EQ] = ACTIONS(10213),
    [anon_sym_CARET] = ACTIONS(10215),
    [anon_sym_PLUS] = ACTIONS(10215),
    [anon_sym_SLASH] = ACTIONS(10215),
    [anon_sym_PERCENT] = ACTIONS(10215),
    [sym_comment] = ACTIONS(87),
  },
  [8590] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1705),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(13746),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [8591] = {
    [sym__line_break] = ACTIONS(10219),
    [sym__heredoc_body_start] = ACTIONS(10219),
    [sym__binary_minus] = ACTIONS(10219),
    [sym__binary_star] = ACTIONS(10219),
    [ts_builtin_sym_end] = ACTIONS(10219),
    [anon_sym___END__] = ACTIONS(10219),
    [anon_sym_LBRACE] = ACTIONS(10219),
    [anon_sym_RBRACE] = ACTIONS(10219),
    [anon_sym_RPAREN] = ACTIONS(10219),
    [anon_sym_DOT] = ACTIONS(10221),
    [anon_sym_COMMA] = ACTIONS(10219),
    [anon_sym_PIPE] = ACTIONS(10221),
    [anon_sym_SEMI] = ACTIONS(10219),
    [anon_sym_STAR_STAR] = ACTIONS(10221),
    [anon_sym_AMP] = ACTIONS(10221),
    [anon_sym_EQ] = ACTIONS(10221),
    [anon_sym_LT] = ACTIONS(10221),
    [anon_sym_end] = ACTIONS(10219),
    [anon_sym_if] = ACTIONS(10219),
    [anon_sym_unless] = ACTIONS(10219),
    [anon_sym_while] = ACTIONS(10219),
    [anon_sym_until] = ACTIONS(10219),
    [anon_sym_rescue] = ACTIONS(10219),
    [anon_sym_do] = ACTIONS(10219),
    [anon_sym_when] = ACTIONS(10219),
    [anon_sym_elsif] = ACTIONS(10219),
    [anon_sym_else] = ACTIONS(10219),
    [anon_sym_then] = ACTIONS(10219),
    [anon_sym_ensure] = ACTIONS(10219),
    [anon_sym_EQ_GT] = ACTIONS(10219),
    [anon_sym_LBRACK] = ACTIONS(10219),
    [anon_sym_COLON_COLON2] = ACTIONS(10219),
    [anon_sym_AMP_DOT] = ACTIONS(10219),
    [anon_sym_PLUS_EQ] = ACTIONS(10219),
    [anon_sym_DASH_EQ] = ACTIONS(10219),
    [anon_sym_STAR_EQ] = ACTIONS(10219),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10219),
    [anon_sym_SLASH_EQ] = ACTIONS(10219),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10219),
    [anon_sym_PIPE_EQ] = ACTIONS(10219),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10219),
    [anon_sym_AMP_EQ] = ACTIONS(10219),
    [anon_sym_PERCENT_EQ] = ACTIONS(10219),
    [anon_sym_GT_GT_EQ] = ACTIONS(10219),
    [anon_sym_LT_LT_EQ] = ACTIONS(10219),
    [anon_sym_CARET_EQ] = ACTIONS(10219),
    [anon_sym_QMARK] = ACTIONS(10219),
    [anon_sym_DOT_DOT] = ACTIONS(10221),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10219),
    [anon_sym_and] = ACTIONS(10219),
    [anon_sym_or] = ACTIONS(10219),
    [anon_sym_PIPE_PIPE] = ACTIONS(10221),
    [anon_sym_AMP_AMP] = ACTIONS(10221),
    [anon_sym_LT_LT] = ACTIONS(10221),
    [anon_sym_GT_GT] = ACTIONS(10221),
    [anon_sym_EQ_EQ] = ACTIONS(10221),
    [anon_sym_BANG_EQ] = ACTIONS(10219),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10219),
    [anon_sym_LT_EQ_GT] = ACTIONS(10219),
    [anon_sym_EQ_TILDE] = ACTIONS(10219),
    [anon_sym_BANG_TILDE] = ACTIONS(10219),
    [anon_sym_LT_EQ] = ACTIONS(10221),
    [anon_sym_GT] = ACTIONS(10221),
    [anon_sym_GT_EQ] = ACTIONS(10219),
    [anon_sym_CARET] = ACTIONS(10221),
    [anon_sym_PLUS] = ACTIONS(10221),
    [anon_sym_SLASH] = ACTIONS(10221),
    [anon_sym_PERCENT] = ACTIONS(10221),
    [sym_comment] = ACTIONS(87),
  },
  [8592] = {
    [sym__line_break] = ACTIONS(6601),
    [sym__heredoc_body_start] = ACTIONS(6601),
    [sym__binary_minus] = ACTIONS(6601),
    [sym__binary_star] = ACTIONS(6601),
    [ts_builtin_sym_end] = ACTIONS(6601),
    [anon_sym___END__] = ACTIONS(6601),
    [anon_sym_LBRACE] = ACTIONS(6601),
    [anon_sym_RBRACE] = ACTIONS(6601),
    [anon_sym_RPAREN] = ACTIONS(6601),
    [anon_sym_DOT] = ACTIONS(6603),
    [anon_sym_COMMA] = ACTIONS(6601),
    [anon_sym_PIPE] = ACTIONS(6603),
    [anon_sym_SEMI] = ACTIONS(6601),
    [anon_sym_STAR_STAR] = ACTIONS(6603),
    [anon_sym_AMP] = ACTIONS(6603),
    [anon_sym_EQ] = ACTIONS(6603),
    [anon_sym_LT] = ACTIONS(6603),
    [anon_sym_end] = ACTIONS(6601),
    [anon_sym_if] = ACTIONS(6601),
    [anon_sym_unless] = ACTIONS(6601),
    [anon_sym_while] = ACTIONS(6601),
    [anon_sym_until] = ACTIONS(6601),
    [anon_sym_rescue] = ACTIONS(6601),
    [anon_sym_do] = ACTIONS(6601),
    [anon_sym_when] = ACTIONS(6601),
    [anon_sym_elsif] = ACTIONS(6601),
    [anon_sym_else] = ACTIONS(6601),
    [anon_sym_then] = ACTIONS(6601),
    [anon_sym_ensure] = ACTIONS(6601),
    [anon_sym_LBRACK] = ACTIONS(6601),
    [anon_sym_COLON_COLON2] = ACTIONS(6601),
    [anon_sym_AMP_DOT] = ACTIONS(6601),
    [anon_sym_PLUS_EQ] = ACTIONS(6601),
    [anon_sym_DASH_EQ] = ACTIONS(6601),
    [anon_sym_STAR_EQ] = ACTIONS(6601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6601),
    [anon_sym_SLASH_EQ] = ACTIONS(6601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6601),
    [anon_sym_PIPE_EQ] = ACTIONS(6601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6601),
    [anon_sym_AMP_EQ] = ACTIONS(6601),
    [anon_sym_PERCENT_EQ] = ACTIONS(6601),
    [anon_sym_GT_GT_EQ] = ACTIONS(6601),
    [anon_sym_LT_LT_EQ] = ACTIONS(6601),
    [anon_sym_CARET_EQ] = ACTIONS(6601),
    [anon_sym_QMARK] = ACTIONS(6601),
    [anon_sym_DOT_DOT] = ACTIONS(6603),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6601),
    [anon_sym_and] = ACTIONS(6601),
    [anon_sym_or] = ACTIONS(6601),
    [anon_sym_PIPE_PIPE] = ACTIONS(6603),
    [anon_sym_AMP_AMP] = ACTIONS(6603),
    [anon_sym_LT_LT] = ACTIONS(6603),
    [anon_sym_GT_GT] = ACTIONS(6603),
    [anon_sym_EQ_EQ] = ACTIONS(6603),
    [anon_sym_BANG_EQ] = ACTIONS(6601),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6601),
    [anon_sym_LT_EQ_GT] = ACTIONS(6601),
    [anon_sym_EQ_TILDE] = ACTIONS(6601),
    [anon_sym_BANG_TILDE] = ACTIONS(6601),
    [anon_sym_LT_EQ] = ACTIONS(6603),
    [anon_sym_GT] = ACTIONS(6603),
    [anon_sym_GT_EQ] = ACTIONS(6601),
    [anon_sym_CARET] = ACTIONS(6603),
    [anon_sym_PLUS] = ACTIONS(6603),
    [anon_sym_SLASH] = ACTIONS(6603),
    [anon_sym_PERCENT] = ACTIONS(6603),
    [sym_comment] = ACTIONS(87),
  },
  [8593] = {
    [sym__line_break] = ACTIONS(6605),
    [sym__heredoc_body_start] = ACTIONS(6605),
    [sym__binary_minus] = ACTIONS(6605),
    [sym__binary_star] = ACTIONS(6605),
    [ts_builtin_sym_end] = ACTIONS(6605),
    [anon_sym___END__] = ACTIONS(6605),
    [anon_sym_LBRACE] = ACTIONS(6605),
    [anon_sym_RBRACE] = ACTIONS(6605),
    [anon_sym_RPAREN] = ACTIONS(6605),
    [anon_sym_DOT] = ACTIONS(6607),
    [anon_sym_COMMA] = ACTIONS(6605),
    [anon_sym_PIPE] = ACTIONS(6607),
    [anon_sym_SEMI] = ACTIONS(6605),
    [anon_sym_STAR_STAR] = ACTIONS(6607),
    [anon_sym_AMP] = ACTIONS(6607),
    [anon_sym_EQ] = ACTIONS(6607),
    [anon_sym_LT] = ACTIONS(6607),
    [anon_sym_end] = ACTIONS(6605),
    [anon_sym_if] = ACTIONS(6605),
    [anon_sym_unless] = ACTIONS(6605),
    [anon_sym_while] = ACTIONS(6605),
    [anon_sym_until] = ACTIONS(6605),
    [anon_sym_rescue] = ACTIONS(6605),
    [anon_sym_do] = ACTIONS(6605),
    [anon_sym_when] = ACTIONS(6605),
    [anon_sym_elsif] = ACTIONS(6605),
    [anon_sym_else] = ACTIONS(6605),
    [anon_sym_then] = ACTIONS(6605),
    [anon_sym_ensure] = ACTIONS(6605),
    [anon_sym_LBRACK] = ACTIONS(6605),
    [anon_sym_COLON_COLON2] = ACTIONS(6605),
    [anon_sym_AMP_DOT] = ACTIONS(6605),
    [anon_sym_PLUS_EQ] = ACTIONS(6605),
    [anon_sym_DASH_EQ] = ACTIONS(6605),
    [anon_sym_STAR_EQ] = ACTIONS(6605),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6605),
    [anon_sym_SLASH_EQ] = ACTIONS(6605),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6605),
    [anon_sym_PIPE_EQ] = ACTIONS(6605),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6605),
    [anon_sym_AMP_EQ] = ACTIONS(6605),
    [anon_sym_PERCENT_EQ] = ACTIONS(6605),
    [anon_sym_GT_GT_EQ] = ACTIONS(6605),
    [anon_sym_LT_LT_EQ] = ACTIONS(6605),
    [anon_sym_CARET_EQ] = ACTIONS(6605),
    [anon_sym_QMARK] = ACTIONS(6605),
    [anon_sym_DOT_DOT] = ACTIONS(6607),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6605),
    [anon_sym_and] = ACTIONS(6605),
    [anon_sym_or] = ACTIONS(6605),
    [anon_sym_PIPE_PIPE] = ACTIONS(6607),
    [anon_sym_AMP_AMP] = ACTIONS(6607),
    [anon_sym_LT_LT] = ACTIONS(6607),
    [anon_sym_GT_GT] = ACTIONS(6607),
    [anon_sym_EQ_EQ] = ACTIONS(6607),
    [anon_sym_BANG_EQ] = ACTIONS(6605),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6605),
    [anon_sym_LT_EQ_GT] = ACTIONS(6605),
    [anon_sym_EQ_TILDE] = ACTIONS(6605),
    [anon_sym_BANG_TILDE] = ACTIONS(6605),
    [anon_sym_LT_EQ] = ACTIONS(6607),
    [anon_sym_GT] = ACTIONS(6607),
    [anon_sym_GT_EQ] = ACTIONS(6605),
    [anon_sym_CARET] = ACTIONS(6607),
    [anon_sym_PLUS] = ACTIONS(6607),
    [anon_sym_SLASH] = ACTIONS(6607),
    [anon_sym_PERCENT] = ACTIONS(6607),
    [sym_comment] = ACTIONS(87),
  },
  [8594] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1697),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(13748),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [8595] = {
    [aux_sym_string_array_repeat1] = STATE(1699),
    [sym__string_end] = ACTIONS(13748),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(13750),
  },
  [8596] = {
    [sym__line_break] = ACTIONS(6613),
    [sym__heredoc_body_start] = ACTIONS(6613),
    [sym__binary_minus] = ACTIONS(6613),
    [sym__binary_star] = ACTIONS(6613),
    [ts_builtin_sym_end] = ACTIONS(6613),
    [anon_sym___END__] = ACTIONS(6613),
    [anon_sym_LBRACE] = ACTIONS(6613),
    [anon_sym_RBRACE] = ACTIONS(6613),
    [anon_sym_RPAREN] = ACTIONS(6613),
    [anon_sym_DOT] = ACTIONS(6615),
    [anon_sym_COMMA] = ACTIONS(6613),
    [anon_sym_PIPE] = ACTIONS(6615),
    [anon_sym_SEMI] = ACTIONS(6613),
    [anon_sym_STAR_STAR] = ACTIONS(6615),
    [anon_sym_AMP] = ACTIONS(6615),
    [anon_sym_EQ] = ACTIONS(6615),
    [anon_sym_LT] = ACTIONS(6615),
    [anon_sym_end] = ACTIONS(6613),
    [anon_sym_if] = ACTIONS(6613),
    [anon_sym_unless] = ACTIONS(6613),
    [anon_sym_while] = ACTIONS(6613),
    [anon_sym_until] = ACTIONS(6613),
    [anon_sym_rescue] = ACTIONS(6613),
    [anon_sym_do] = ACTIONS(6613),
    [anon_sym_when] = ACTIONS(6613),
    [anon_sym_elsif] = ACTIONS(6613),
    [anon_sym_else] = ACTIONS(6613),
    [anon_sym_then] = ACTIONS(6613),
    [anon_sym_ensure] = ACTIONS(6613),
    [anon_sym_LBRACK] = ACTIONS(6613),
    [anon_sym_COLON_COLON2] = ACTIONS(6613),
    [anon_sym_AMP_DOT] = ACTIONS(6613),
    [anon_sym_PLUS_EQ] = ACTIONS(6613),
    [anon_sym_DASH_EQ] = ACTIONS(6613),
    [anon_sym_STAR_EQ] = ACTIONS(6613),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6613),
    [anon_sym_SLASH_EQ] = ACTIONS(6613),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6613),
    [anon_sym_PIPE_EQ] = ACTIONS(6613),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6613),
    [anon_sym_AMP_EQ] = ACTIONS(6613),
    [anon_sym_PERCENT_EQ] = ACTIONS(6613),
    [anon_sym_GT_GT_EQ] = ACTIONS(6613),
    [anon_sym_LT_LT_EQ] = ACTIONS(6613),
    [anon_sym_CARET_EQ] = ACTIONS(6613),
    [anon_sym_QMARK] = ACTIONS(6613),
    [anon_sym_DOT_DOT] = ACTIONS(6615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6613),
    [anon_sym_and] = ACTIONS(6613),
    [anon_sym_or] = ACTIONS(6613),
    [anon_sym_PIPE_PIPE] = ACTIONS(6615),
    [anon_sym_AMP_AMP] = ACTIONS(6615),
    [anon_sym_LT_LT] = ACTIONS(6615),
    [anon_sym_GT_GT] = ACTIONS(6615),
    [anon_sym_EQ_EQ] = ACTIONS(6615),
    [anon_sym_BANG_EQ] = ACTIONS(6613),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6613),
    [anon_sym_LT_EQ_GT] = ACTIONS(6613),
    [anon_sym_EQ_TILDE] = ACTIONS(6613),
    [anon_sym_BANG_TILDE] = ACTIONS(6613),
    [anon_sym_LT_EQ] = ACTIONS(6615),
    [anon_sym_GT] = ACTIONS(6615),
    [anon_sym_GT_EQ] = ACTIONS(6613),
    [anon_sym_CARET] = ACTIONS(6615),
    [anon_sym_PLUS] = ACTIONS(6615),
    [anon_sym_SLASH] = ACTIONS(6615),
    [anon_sym_PERCENT] = ACTIONS(6615),
    [sym_comment] = ACTIONS(87),
  },
  [8597] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1697),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(13752),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [8598] = {
    [sym__line_break] = ACTIONS(6626),
    [sym__heredoc_body_start] = ACTIONS(6626),
    [sym__binary_minus] = ACTIONS(6626),
    [sym__binary_star] = ACTIONS(6626),
    [ts_builtin_sym_end] = ACTIONS(6626),
    [anon_sym___END__] = ACTIONS(6626),
    [anon_sym_LBRACE] = ACTIONS(6626),
    [anon_sym_RBRACE] = ACTIONS(6626),
    [anon_sym_RPAREN] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(6628),
    [anon_sym_COMMA] = ACTIONS(6626),
    [anon_sym_PIPE] = ACTIONS(6628),
    [anon_sym_SEMI] = ACTIONS(6626),
    [anon_sym_STAR_STAR] = ACTIONS(6628),
    [anon_sym_AMP] = ACTIONS(6628),
    [anon_sym_EQ] = ACTIONS(6628),
    [anon_sym_LT] = ACTIONS(6628),
    [anon_sym_end] = ACTIONS(6626),
    [anon_sym_if] = ACTIONS(6626),
    [anon_sym_unless] = ACTIONS(6626),
    [anon_sym_while] = ACTIONS(6626),
    [anon_sym_until] = ACTIONS(6626),
    [anon_sym_rescue] = ACTIONS(6626),
    [anon_sym_do] = ACTIONS(6626),
    [anon_sym_when] = ACTIONS(6626),
    [anon_sym_elsif] = ACTIONS(6626),
    [anon_sym_else] = ACTIONS(6626),
    [anon_sym_then] = ACTIONS(6626),
    [anon_sym_ensure] = ACTIONS(6626),
    [anon_sym_LBRACK] = ACTIONS(6626),
    [anon_sym_COLON_COLON2] = ACTIONS(6626),
    [anon_sym_AMP_DOT] = ACTIONS(6626),
    [anon_sym_PLUS_EQ] = ACTIONS(6626),
    [anon_sym_DASH_EQ] = ACTIONS(6626),
    [anon_sym_STAR_EQ] = ACTIONS(6626),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6626),
    [anon_sym_SLASH_EQ] = ACTIONS(6626),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6626),
    [anon_sym_PIPE_EQ] = ACTIONS(6626),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6626),
    [anon_sym_AMP_EQ] = ACTIONS(6626),
    [anon_sym_PERCENT_EQ] = ACTIONS(6626),
    [anon_sym_GT_GT_EQ] = ACTIONS(6626),
    [anon_sym_LT_LT_EQ] = ACTIONS(6626),
    [anon_sym_CARET_EQ] = ACTIONS(6626),
    [anon_sym_QMARK] = ACTIONS(6626),
    [anon_sym_DOT_DOT] = ACTIONS(6628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6626),
    [anon_sym_and] = ACTIONS(6626),
    [anon_sym_or] = ACTIONS(6626),
    [anon_sym_PIPE_PIPE] = ACTIONS(6628),
    [anon_sym_AMP_AMP] = ACTIONS(6628),
    [anon_sym_LT_LT] = ACTIONS(6628),
    [anon_sym_GT_GT] = ACTIONS(6628),
    [anon_sym_EQ_EQ] = ACTIONS(6628),
    [anon_sym_BANG_EQ] = ACTIONS(6626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6626),
    [anon_sym_LT_EQ_GT] = ACTIONS(6626),
    [anon_sym_EQ_TILDE] = ACTIONS(6626),
    [anon_sym_BANG_TILDE] = ACTIONS(6626),
    [anon_sym_LT_EQ] = ACTIONS(6628),
    [anon_sym_GT] = ACTIONS(6628),
    [anon_sym_GT_EQ] = ACTIONS(6626),
    [anon_sym_CARET] = ACTIONS(6628),
    [anon_sym_PLUS] = ACTIONS(6628),
    [anon_sym_SLASH] = ACTIONS(6628),
    [anon_sym_PERCENT] = ACTIONS(6628),
    [sym_comment] = ACTIONS(87),
  },
  [8599] = {
    [sym__line_break] = ACTIONS(6630),
    [sym__heredoc_body_start] = ACTIONS(6630),
    [sym__binary_minus] = ACTIONS(6630),
    [sym__binary_star] = ACTIONS(6630),
    [ts_builtin_sym_end] = ACTIONS(6630),
    [anon_sym___END__] = ACTIONS(6630),
    [anon_sym_LBRACE] = ACTIONS(6630),
    [anon_sym_RBRACE] = ACTIONS(6630),
    [anon_sym_RPAREN] = ACTIONS(6630),
    [anon_sym_DOT] = ACTIONS(6632),
    [anon_sym_COMMA] = ACTIONS(6630),
    [anon_sym_PIPE] = ACTIONS(6632),
    [anon_sym_SEMI] = ACTIONS(6630),
    [anon_sym_STAR_STAR] = ACTIONS(6632),
    [anon_sym_AMP] = ACTIONS(6632),
    [anon_sym_EQ] = ACTIONS(6632),
    [anon_sym_LT] = ACTIONS(6632),
    [anon_sym_end] = ACTIONS(6630),
    [anon_sym_if] = ACTIONS(6630),
    [anon_sym_unless] = ACTIONS(6630),
    [anon_sym_while] = ACTIONS(6630),
    [anon_sym_until] = ACTIONS(6630),
    [anon_sym_rescue] = ACTIONS(6630),
    [anon_sym_do] = ACTIONS(6630),
    [anon_sym_when] = ACTIONS(6630),
    [anon_sym_elsif] = ACTIONS(6630),
    [anon_sym_else] = ACTIONS(6630),
    [anon_sym_then] = ACTIONS(6630),
    [anon_sym_ensure] = ACTIONS(6630),
    [anon_sym_LBRACK] = ACTIONS(6630),
    [anon_sym_COLON_COLON2] = ACTIONS(6630),
    [anon_sym_AMP_DOT] = ACTIONS(6630),
    [anon_sym_PLUS_EQ] = ACTIONS(6630),
    [anon_sym_DASH_EQ] = ACTIONS(6630),
    [anon_sym_STAR_EQ] = ACTIONS(6630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6630),
    [anon_sym_SLASH_EQ] = ACTIONS(6630),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6630),
    [anon_sym_PIPE_EQ] = ACTIONS(6630),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6630),
    [anon_sym_AMP_EQ] = ACTIONS(6630),
    [anon_sym_PERCENT_EQ] = ACTIONS(6630),
    [anon_sym_GT_GT_EQ] = ACTIONS(6630),
    [anon_sym_LT_LT_EQ] = ACTIONS(6630),
    [anon_sym_CARET_EQ] = ACTIONS(6630),
    [anon_sym_QMARK] = ACTIONS(6630),
    [anon_sym_DOT_DOT] = ACTIONS(6632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6630),
    [anon_sym_and] = ACTIONS(6630),
    [anon_sym_or] = ACTIONS(6630),
    [anon_sym_PIPE_PIPE] = ACTIONS(6632),
    [anon_sym_AMP_AMP] = ACTIONS(6632),
    [anon_sym_LT_LT] = ACTIONS(6632),
    [anon_sym_GT_GT] = ACTIONS(6632),
    [anon_sym_EQ_EQ] = ACTIONS(6632),
    [anon_sym_BANG_EQ] = ACTIONS(6630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6630),
    [anon_sym_LT_EQ_GT] = ACTIONS(6630),
    [anon_sym_EQ_TILDE] = ACTIONS(6630),
    [anon_sym_BANG_TILDE] = ACTIONS(6630),
    [anon_sym_LT_EQ] = ACTIONS(6632),
    [anon_sym_GT] = ACTIONS(6632),
    [anon_sym_GT_EQ] = ACTIONS(6630),
    [anon_sym_CARET] = ACTIONS(6632),
    [anon_sym_PLUS] = ACTIONS(6632),
    [anon_sym_SLASH] = ACTIONS(6632),
    [anon_sym_PERCENT] = ACTIONS(6632),
    [sym_comment] = ACTIONS(87),
  },
  [8600] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1705),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(13754),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [8601] = {
    [aux_sym_symbol_array_repeat1] = STATE(1707),
    [sym__string_end] = ACTIONS(13754),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(13756),
  },
  [8602] = {
    [sym__line_break] = ACTIONS(6638),
    [sym__heredoc_body_start] = ACTIONS(6638),
    [sym__binary_minus] = ACTIONS(6638),
    [sym__binary_star] = ACTIONS(6638),
    [ts_builtin_sym_end] = ACTIONS(6638),
    [anon_sym___END__] = ACTIONS(6638),
    [anon_sym_LBRACE] = ACTIONS(6638),
    [anon_sym_RBRACE] = ACTIONS(6638),
    [anon_sym_RPAREN] = ACTIONS(6638),
    [anon_sym_DOT] = ACTIONS(6640),
    [anon_sym_COMMA] = ACTIONS(6638),
    [anon_sym_PIPE] = ACTIONS(6640),
    [anon_sym_SEMI] = ACTIONS(6638),
    [anon_sym_STAR_STAR] = ACTIONS(6640),
    [anon_sym_AMP] = ACTIONS(6640),
    [anon_sym_EQ] = ACTIONS(6640),
    [anon_sym_LT] = ACTIONS(6640),
    [anon_sym_end] = ACTIONS(6638),
    [anon_sym_if] = ACTIONS(6638),
    [anon_sym_unless] = ACTIONS(6638),
    [anon_sym_while] = ACTIONS(6638),
    [anon_sym_until] = ACTIONS(6638),
    [anon_sym_rescue] = ACTIONS(6638),
    [anon_sym_do] = ACTIONS(6638),
    [anon_sym_when] = ACTIONS(6638),
    [anon_sym_elsif] = ACTIONS(6638),
    [anon_sym_else] = ACTIONS(6638),
    [anon_sym_then] = ACTIONS(6638),
    [anon_sym_ensure] = ACTIONS(6638),
    [anon_sym_LBRACK] = ACTIONS(6638),
    [anon_sym_COLON_COLON2] = ACTIONS(6638),
    [anon_sym_AMP_DOT] = ACTIONS(6638),
    [anon_sym_PLUS_EQ] = ACTIONS(6638),
    [anon_sym_DASH_EQ] = ACTIONS(6638),
    [anon_sym_STAR_EQ] = ACTIONS(6638),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6638),
    [anon_sym_SLASH_EQ] = ACTIONS(6638),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6638),
    [anon_sym_PIPE_EQ] = ACTIONS(6638),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6638),
    [anon_sym_AMP_EQ] = ACTIONS(6638),
    [anon_sym_PERCENT_EQ] = ACTIONS(6638),
    [anon_sym_GT_GT_EQ] = ACTIONS(6638),
    [anon_sym_LT_LT_EQ] = ACTIONS(6638),
    [anon_sym_CARET_EQ] = ACTIONS(6638),
    [anon_sym_QMARK] = ACTIONS(6638),
    [anon_sym_DOT_DOT] = ACTIONS(6640),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6638),
    [anon_sym_and] = ACTIONS(6638),
    [anon_sym_or] = ACTIONS(6638),
    [anon_sym_PIPE_PIPE] = ACTIONS(6640),
    [anon_sym_AMP_AMP] = ACTIONS(6640),
    [anon_sym_LT_LT] = ACTIONS(6640),
    [anon_sym_GT_GT] = ACTIONS(6640),
    [anon_sym_EQ_EQ] = ACTIONS(6640),
    [anon_sym_BANG_EQ] = ACTIONS(6638),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6638),
    [anon_sym_LT_EQ_GT] = ACTIONS(6638),
    [anon_sym_EQ_TILDE] = ACTIONS(6638),
    [anon_sym_BANG_TILDE] = ACTIONS(6638),
    [anon_sym_LT_EQ] = ACTIONS(6640),
    [anon_sym_GT] = ACTIONS(6640),
    [anon_sym_GT_EQ] = ACTIONS(6638),
    [anon_sym_CARET] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(6640),
    [anon_sym_SLASH] = ACTIONS(6640),
    [anon_sym_PERCENT] = ACTIONS(6640),
    [sym_comment] = ACTIONS(87),
  },
  [8603] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1705),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(13758),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [8604] = {
    [sym__line_break] = ACTIONS(7162),
    [sym__heredoc_body_start] = ACTIONS(7162),
    [sym__binary_minus] = ACTIONS(7162),
    [sym__binary_star] = ACTIONS(7162),
    [ts_builtin_sym_end] = ACTIONS(7162),
    [anon_sym___END__] = ACTIONS(7162),
    [anon_sym_LBRACE] = ACTIONS(7162),
    [anon_sym_RBRACE] = ACTIONS(7162),
    [anon_sym_RPAREN] = ACTIONS(7162),
    [anon_sym_DOT] = ACTIONS(7164),
    [anon_sym_COMMA] = ACTIONS(7162),
    [anon_sym_PIPE] = ACTIONS(7164),
    [anon_sym_SEMI] = ACTIONS(7162),
    [anon_sym_STAR_STAR] = ACTIONS(7164),
    [anon_sym_AMP] = ACTIONS(7164),
    [anon_sym_EQ] = ACTIONS(7164),
    [anon_sym_LT] = ACTIONS(7164),
    [anon_sym_end] = ACTIONS(7162),
    [anon_sym_if] = ACTIONS(7162),
    [anon_sym_unless] = ACTIONS(7162),
    [anon_sym_while] = ACTIONS(7162),
    [anon_sym_until] = ACTIONS(7162),
    [anon_sym_rescue] = ACTIONS(7162),
    [anon_sym_do] = ACTIONS(7162),
    [anon_sym_when] = ACTIONS(7162),
    [anon_sym_elsif] = ACTIONS(7162),
    [anon_sym_else] = ACTIONS(7162),
    [anon_sym_then] = ACTIONS(7162),
    [anon_sym_ensure] = ACTIONS(7162),
    [anon_sym_LBRACK] = ACTIONS(7162),
    [anon_sym_COLON_COLON2] = ACTIONS(7162),
    [anon_sym_AMP_DOT] = ACTIONS(7162),
    [anon_sym_PLUS_EQ] = ACTIONS(7162),
    [anon_sym_DASH_EQ] = ACTIONS(7162),
    [anon_sym_STAR_EQ] = ACTIONS(7162),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7162),
    [anon_sym_SLASH_EQ] = ACTIONS(7162),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7162),
    [anon_sym_PIPE_EQ] = ACTIONS(7162),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7162),
    [anon_sym_AMP_EQ] = ACTIONS(7162),
    [anon_sym_PERCENT_EQ] = ACTIONS(7162),
    [anon_sym_GT_GT_EQ] = ACTIONS(7162),
    [anon_sym_LT_LT_EQ] = ACTIONS(7162),
    [anon_sym_CARET_EQ] = ACTIONS(7162),
    [anon_sym_QMARK] = ACTIONS(7162),
    [anon_sym_DOT_DOT] = ACTIONS(7164),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7162),
    [anon_sym_and] = ACTIONS(7162),
    [anon_sym_or] = ACTIONS(7162),
    [anon_sym_PIPE_PIPE] = ACTIONS(7164),
    [anon_sym_AMP_AMP] = ACTIONS(7164),
    [anon_sym_LT_LT] = ACTIONS(7164),
    [anon_sym_GT_GT] = ACTIONS(7164),
    [anon_sym_EQ_EQ] = ACTIONS(7164),
    [anon_sym_BANG_EQ] = ACTIONS(7162),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7162),
    [anon_sym_LT_EQ_GT] = ACTIONS(7162),
    [anon_sym_EQ_TILDE] = ACTIONS(7162),
    [anon_sym_BANG_TILDE] = ACTIONS(7162),
    [anon_sym_LT_EQ] = ACTIONS(7164),
    [anon_sym_GT] = ACTIONS(7164),
    [anon_sym_GT_EQ] = ACTIONS(7162),
    [anon_sym_CARET] = ACTIONS(7164),
    [anon_sym_PLUS] = ACTIONS(7164),
    [anon_sym_SLASH] = ACTIONS(7164),
    [anon_sym_PERCENT] = ACTIONS(7164),
    [sym_comment] = ACTIONS(87),
  },
  [8605] = {
    [anon_sym_DOT] = ACTIONS(13760),
    [anon_sym_COLON_COLON] = ACTIONS(13760),
    [sym_comment] = ACTIONS(87),
  },
  [8606] = {
    [sym__line_break] = ACTIONS(7314),
    [sym__heredoc_body_start] = ACTIONS(7314),
    [sym__binary_minus] = ACTIONS(7314),
    [sym__binary_star] = ACTIONS(7314),
    [ts_builtin_sym_end] = ACTIONS(7314),
    [anon_sym___END__] = ACTIONS(7314),
    [anon_sym_LBRACE] = ACTIONS(7314),
    [anon_sym_RBRACE] = ACTIONS(7314),
    [anon_sym_RPAREN] = ACTIONS(7314),
    [anon_sym_DOT] = ACTIONS(7316),
    [anon_sym_COMMA] = ACTIONS(7314),
    [anon_sym_PIPE] = ACTIONS(7316),
    [anon_sym_SEMI] = ACTIONS(7314),
    [anon_sym_STAR_STAR] = ACTIONS(7316),
    [anon_sym_AMP] = ACTIONS(7316),
    [anon_sym_EQ] = ACTIONS(7316),
    [anon_sym_LT] = ACTIONS(7316),
    [anon_sym_end] = ACTIONS(7314),
    [anon_sym_if] = ACTIONS(7314),
    [anon_sym_unless] = ACTIONS(7314),
    [anon_sym_while] = ACTIONS(7314),
    [anon_sym_until] = ACTIONS(7314),
    [anon_sym_rescue] = ACTIONS(7314),
    [anon_sym_do] = ACTIONS(7314),
    [anon_sym_when] = ACTIONS(7314),
    [anon_sym_elsif] = ACTIONS(7314),
    [anon_sym_else] = ACTIONS(7314),
    [anon_sym_then] = ACTIONS(7314),
    [anon_sym_ensure] = ACTIONS(7314),
    [anon_sym_LBRACK] = ACTIONS(7314),
    [anon_sym_COLON_COLON2] = ACTIONS(7314),
    [anon_sym_AMP_DOT] = ACTIONS(7314),
    [anon_sym_PLUS_EQ] = ACTIONS(7314),
    [anon_sym_DASH_EQ] = ACTIONS(7314),
    [anon_sym_STAR_EQ] = ACTIONS(7314),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7314),
    [anon_sym_SLASH_EQ] = ACTIONS(7314),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7314),
    [anon_sym_PIPE_EQ] = ACTIONS(7314),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7314),
    [anon_sym_AMP_EQ] = ACTIONS(7314),
    [anon_sym_PERCENT_EQ] = ACTIONS(7314),
    [anon_sym_GT_GT_EQ] = ACTIONS(7314),
    [anon_sym_LT_LT_EQ] = ACTIONS(7314),
    [anon_sym_CARET_EQ] = ACTIONS(7314),
    [anon_sym_QMARK] = ACTIONS(7314),
    [anon_sym_DOT_DOT] = ACTIONS(7316),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7314),
    [anon_sym_and] = ACTIONS(7314),
    [anon_sym_or] = ACTIONS(7314),
    [anon_sym_PIPE_PIPE] = ACTIONS(7316),
    [anon_sym_AMP_AMP] = ACTIONS(7316),
    [anon_sym_LT_LT] = ACTIONS(7316),
    [anon_sym_GT_GT] = ACTIONS(7316),
    [anon_sym_EQ_EQ] = ACTIONS(7316),
    [anon_sym_BANG_EQ] = ACTIONS(7314),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7314),
    [anon_sym_LT_EQ_GT] = ACTIONS(7314),
    [anon_sym_EQ_TILDE] = ACTIONS(7314),
    [anon_sym_BANG_TILDE] = ACTIONS(7314),
    [anon_sym_LT_EQ] = ACTIONS(7316),
    [anon_sym_GT] = ACTIONS(7316),
    [anon_sym_GT_EQ] = ACTIONS(7314),
    [anon_sym_CARET] = ACTIONS(7316),
    [anon_sym_PLUS] = ACTIONS(7316),
    [anon_sym_SLASH] = ACTIONS(7316),
    [anon_sym_PERCENT] = ACTIONS(7316),
    [sym_comment] = ACTIONS(87),
  },
  [8607] = {
    [sym__line_break] = ACTIONS(7330),
    [sym__heredoc_body_start] = ACTIONS(7330),
    [sym__binary_minus] = ACTIONS(7330),
    [sym__binary_star] = ACTIONS(7330),
    [ts_builtin_sym_end] = ACTIONS(7330),
    [anon_sym___END__] = ACTIONS(7330),
    [anon_sym_LBRACE] = ACTIONS(7330),
    [anon_sym_RBRACE] = ACTIONS(7330),
    [anon_sym_RPAREN] = ACTIONS(7330),
    [anon_sym_DOT] = ACTIONS(7332),
    [anon_sym_COMMA] = ACTIONS(7330),
    [anon_sym_PIPE] = ACTIONS(7332),
    [anon_sym_SEMI] = ACTIONS(7330),
    [anon_sym_STAR_STAR] = ACTIONS(7332),
    [anon_sym_AMP] = ACTIONS(7332),
    [anon_sym_EQ] = ACTIONS(7332),
    [anon_sym_LT] = ACTIONS(7332),
    [anon_sym_end] = ACTIONS(7330),
    [anon_sym_if] = ACTIONS(7330),
    [anon_sym_unless] = ACTIONS(7330),
    [anon_sym_while] = ACTIONS(7330),
    [anon_sym_until] = ACTIONS(7330),
    [anon_sym_rescue] = ACTIONS(7330),
    [anon_sym_do] = ACTIONS(7330),
    [anon_sym_when] = ACTIONS(7330),
    [anon_sym_elsif] = ACTIONS(7330),
    [anon_sym_else] = ACTIONS(7330),
    [anon_sym_then] = ACTIONS(7330),
    [anon_sym_ensure] = ACTIONS(7330),
    [anon_sym_LBRACK] = ACTIONS(7330),
    [anon_sym_COLON_COLON2] = ACTIONS(7330),
    [anon_sym_AMP_DOT] = ACTIONS(7330),
    [anon_sym_PLUS_EQ] = ACTIONS(7330),
    [anon_sym_DASH_EQ] = ACTIONS(7330),
    [anon_sym_STAR_EQ] = ACTIONS(7330),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7330),
    [anon_sym_SLASH_EQ] = ACTIONS(7330),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7330),
    [anon_sym_PIPE_EQ] = ACTIONS(7330),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7330),
    [anon_sym_AMP_EQ] = ACTIONS(7330),
    [anon_sym_PERCENT_EQ] = ACTIONS(7330),
    [anon_sym_GT_GT_EQ] = ACTIONS(7330),
    [anon_sym_LT_LT_EQ] = ACTIONS(7330),
    [anon_sym_CARET_EQ] = ACTIONS(7330),
    [anon_sym_QMARK] = ACTIONS(7330),
    [anon_sym_DOT_DOT] = ACTIONS(7332),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7330),
    [anon_sym_and] = ACTIONS(7330),
    [anon_sym_or] = ACTIONS(7330),
    [anon_sym_PIPE_PIPE] = ACTIONS(7332),
    [anon_sym_AMP_AMP] = ACTIONS(7332),
    [anon_sym_LT_LT] = ACTIONS(7332),
    [anon_sym_GT_GT] = ACTIONS(7332),
    [anon_sym_EQ_EQ] = ACTIONS(7332),
    [anon_sym_BANG_EQ] = ACTIONS(7330),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7330),
    [anon_sym_LT_EQ_GT] = ACTIONS(7330),
    [anon_sym_EQ_TILDE] = ACTIONS(7330),
    [anon_sym_BANG_TILDE] = ACTIONS(7330),
    [anon_sym_LT_EQ] = ACTIONS(7332),
    [anon_sym_GT] = ACTIONS(7332),
    [anon_sym_GT_EQ] = ACTIONS(7330),
    [anon_sym_CARET] = ACTIONS(7332),
    [anon_sym_PLUS] = ACTIONS(7332),
    [anon_sym_SLASH] = ACTIONS(7332),
    [anon_sym_PERCENT] = ACTIONS(7332),
    [sym_comment] = ACTIONS(87),
  },
  [8608] = {
    [sym__statements] = STATE(3621),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(3622),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(3623),
    [sym_rescue] = STATE(3624),
    [sym__body_statement] = STATE(10053),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13762),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8609] = {
    [sym__statements] = STATE(3621),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(3622),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(3623),
    [sym_rescue] = STATE(3624),
    [sym__body_statement] = STATE(10054),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13764),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8610] = {
    [sym__line_break] = ACTIONS(7764),
    [sym__heredoc_body_start] = ACTIONS(7764),
    [sym__binary_minus] = ACTIONS(7764),
    [sym__binary_star] = ACTIONS(7764),
    [ts_builtin_sym_end] = ACTIONS(7764),
    [anon_sym___END__] = ACTIONS(7764),
    [anon_sym_LBRACE] = ACTIONS(7764),
    [anon_sym_RBRACE] = ACTIONS(7764),
    [anon_sym_RPAREN] = ACTIONS(7764),
    [anon_sym_DOT] = ACTIONS(7766),
    [anon_sym_COMMA] = ACTIONS(7764),
    [anon_sym_PIPE] = ACTIONS(7766),
    [anon_sym_SEMI] = ACTIONS(7764),
    [anon_sym_STAR_STAR] = ACTIONS(7766),
    [anon_sym_AMP] = ACTIONS(7766),
    [anon_sym_EQ] = ACTIONS(7766),
    [anon_sym_LT] = ACTIONS(7766),
    [anon_sym_end] = ACTIONS(7764),
    [anon_sym_if] = ACTIONS(7764),
    [anon_sym_unless] = ACTIONS(7764),
    [anon_sym_while] = ACTIONS(7764),
    [anon_sym_until] = ACTIONS(7764),
    [anon_sym_rescue] = ACTIONS(7764),
    [anon_sym_do] = ACTIONS(7764),
    [anon_sym_when] = ACTIONS(7764),
    [anon_sym_elsif] = ACTIONS(7764),
    [anon_sym_else] = ACTIONS(7764),
    [anon_sym_then] = ACTIONS(7764),
    [anon_sym_ensure] = ACTIONS(7764),
    [anon_sym_LBRACK] = ACTIONS(7764),
    [anon_sym_COLON_COLON2] = ACTIONS(7764),
    [anon_sym_AMP_DOT] = ACTIONS(7764),
    [anon_sym_PLUS_EQ] = ACTIONS(7764),
    [anon_sym_DASH_EQ] = ACTIONS(7764),
    [anon_sym_STAR_EQ] = ACTIONS(7764),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7764),
    [anon_sym_SLASH_EQ] = ACTIONS(7764),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7764),
    [anon_sym_PIPE_EQ] = ACTIONS(7764),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7764),
    [anon_sym_AMP_EQ] = ACTIONS(7764),
    [anon_sym_PERCENT_EQ] = ACTIONS(7764),
    [anon_sym_GT_GT_EQ] = ACTIONS(7764),
    [anon_sym_LT_LT_EQ] = ACTIONS(7764),
    [anon_sym_CARET_EQ] = ACTIONS(7764),
    [anon_sym_QMARK] = ACTIONS(7764),
    [anon_sym_DOT_DOT] = ACTIONS(7766),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7764),
    [anon_sym_and] = ACTIONS(7764),
    [anon_sym_or] = ACTIONS(7764),
    [anon_sym_PIPE_PIPE] = ACTIONS(7766),
    [anon_sym_AMP_AMP] = ACTIONS(7766),
    [anon_sym_LT_LT] = ACTIONS(7766),
    [anon_sym_GT_GT] = ACTIONS(7766),
    [anon_sym_EQ_EQ] = ACTIONS(7766),
    [anon_sym_BANG_EQ] = ACTIONS(7764),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7764),
    [anon_sym_LT_EQ_GT] = ACTIONS(7764),
    [anon_sym_EQ_TILDE] = ACTIONS(7764),
    [anon_sym_BANG_TILDE] = ACTIONS(7764),
    [anon_sym_LT_EQ] = ACTIONS(7766),
    [anon_sym_GT] = ACTIONS(7766),
    [anon_sym_GT_EQ] = ACTIONS(7764),
    [anon_sym_CARET] = ACTIONS(7766),
    [anon_sym_PLUS] = ACTIONS(7766),
    [anon_sym_SLASH] = ACTIONS(7766),
    [anon_sym_PERCENT] = ACTIONS(7766),
    [sym_comment] = ACTIONS(87),
  },
  [8611] = {
    [sym__line_break] = ACTIONS(7818),
    [sym__heredoc_body_start] = ACTIONS(7818),
    [sym__binary_minus] = ACTIONS(7818),
    [sym__binary_star] = ACTIONS(7818),
    [ts_builtin_sym_end] = ACTIONS(7818),
    [anon_sym___END__] = ACTIONS(7818),
    [anon_sym_LBRACE] = ACTIONS(7818),
    [anon_sym_RBRACE] = ACTIONS(7818),
    [anon_sym_RPAREN] = ACTIONS(7818),
    [anon_sym_DOT] = ACTIONS(7820),
    [anon_sym_COMMA] = ACTIONS(7818),
    [anon_sym_PIPE] = ACTIONS(7820),
    [anon_sym_SEMI] = ACTIONS(7818),
    [anon_sym_STAR_STAR] = ACTIONS(7820),
    [anon_sym_AMP] = ACTIONS(7820),
    [anon_sym_EQ] = ACTIONS(7820),
    [anon_sym_LT] = ACTIONS(7820),
    [anon_sym_end] = ACTIONS(7818),
    [anon_sym_if] = ACTIONS(7818),
    [anon_sym_unless] = ACTIONS(7818),
    [anon_sym_while] = ACTIONS(7818),
    [anon_sym_until] = ACTIONS(7818),
    [anon_sym_rescue] = ACTIONS(7818),
    [anon_sym_do] = ACTIONS(7818),
    [anon_sym_when] = ACTIONS(7818),
    [anon_sym_elsif] = ACTIONS(7818),
    [anon_sym_else] = ACTIONS(7818),
    [anon_sym_then] = ACTIONS(7818),
    [anon_sym_ensure] = ACTIONS(7818),
    [anon_sym_LBRACK] = ACTIONS(7818),
    [anon_sym_COLON_COLON2] = ACTIONS(7818),
    [anon_sym_AMP_DOT] = ACTIONS(7818),
    [anon_sym_PLUS_EQ] = ACTIONS(7818),
    [anon_sym_DASH_EQ] = ACTIONS(7818),
    [anon_sym_STAR_EQ] = ACTIONS(7818),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7818),
    [anon_sym_SLASH_EQ] = ACTIONS(7818),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7818),
    [anon_sym_PIPE_EQ] = ACTIONS(7818),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7818),
    [anon_sym_AMP_EQ] = ACTIONS(7818),
    [anon_sym_PERCENT_EQ] = ACTIONS(7818),
    [anon_sym_GT_GT_EQ] = ACTIONS(7818),
    [anon_sym_LT_LT_EQ] = ACTIONS(7818),
    [anon_sym_CARET_EQ] = ACTIONS(7818),
    [anon_sym_QMARK] = ACTIONS(7818),
    [anon_sym_DOT_DOT] = ACTIONS(7820),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7818),
    [anon_sym_and] = ACTIONS(7818),
    [anon_sym_or] = ACTIONS(7818),
    [anon_sym_PIPE_PIPE] = ACTIONS(7820),
    [anon_sym_AMP_AMP] = ACTIONS(7820),
    [anon_sym_LT_LT] = ACTIONS(7820),
    [anon_sym_GT_GT] = ACTIONS(7820),
    [anon_sym_EQ_EQ] = ACTIONS(7820),
    [anon_sym_BANG_EQ] = ACTIONS(7818),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7818),
    [anon_sym_LT_EQ_GT] = ACTIONS(7818),
    [anon_sym_EQ_TILDE] = ACTIONS(7818),
    [anon_sym_BANG_TILDE] = ACTIONS(7818),
    [anon_sym_LT_EQ] = ACTIONS(7820),
    [anon_sym_GT] = ACTIONS(7820),
    [anon_sym_GT_EQ] = ACTIONS(7818),
    [anon_sym_CARET] = ACTIONS(7820),
    [anon_sym_PLUS] = ACTIONS(7820),
    [anon_sym_SLASH] = ACTIONS(7820),
    [anon_sym_PERCENT] = ACTIONS(7820),
    [sym_comment] = ACTIONS(87),
  },
  [8612] = {
    [sym__line_break] = ACTIONS(8098),
    [sym__heredoc_body_start] = ACTIONS(8098),
    [sym__binary_minus] = ACTIONS(8098),
    [sym__binary_star] = ACTIONS(8098),
    [ts_builtin_sym_end] = ACTIONS(8098),
    [anon_sym___END__] = ACTIONS(8098),
    [anon_sym_LBRACE] = ACTIONS(8098),
    [anon_sym_RBRACE] = ACTIONS(8098),
    [anon_sym_RPAREN] = ACTIONS(8098),
    [anon_sym_DOT] = ACTIONS(8100),
    [anon_sym_COMMA] = ACTIONS(8098),
    [anon_sym_PIPE] = ACTIONS(8100),
    [anon_sym_SEMI] = ACTIONS(8098),
    [anon_sym_STAR_STAR] = ACTIONS(8100),
    [anon_sym_AMP] = ACTIONS(8100),
    [anon_sym_EQ] = ACTIONS(8100),
    [anon_sym_LT] = ACTIONS(8100),
    [anon_sym_end] = ACTIONS(8098),
    [anon_sym_if] = ACTIONS(8098),
    [anon_sym_unless] = ACTIONS(8098),
    [anon_sym_while] = ACTIONS(8098),
    [anon_sym_until] = ACTIONS(8098),
    [anon_sym_rescue] = ACTIONS(8098),
    [anon_sym_do] = ACTIONS(8098),
    [anon_sym_when] = ACTIONS(8098),
    [anon_sym_elsif] = ACTIONS(8098),
    [anon_sym_else] = ACTIONS(8098),
    [anon_sym_then] = ACTIONS(8098),
    [anon_sym_ensure] = ACTIONS(8098),
    [anon_sym_LBRACK] = ACTIONS(8098),
    [anon_sym_COLON_COLON2] = ACTIONS(8098),
    [anon_sym_AMP_DOT] = ACTIONS(8098),
    [anon_sym_PLUS_EQ] = ACTIONS(8098),
    [anon_sym_DASH_EQ] = ACTIONS(8098),
    [anon_sym_STAR_EQ] = ACTIONS(8098),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8098),
    [anon_sym_SLASH_EQ] = ACTIONS(8098),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8098),
    [anon_sym_PIPE_EQ] = ACTIONS(8098),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8098),
    [anon_sym_AMP_EQ] = ACTIONS(8098),
    [anon_sym_PERCENT_EQ] = ACTIONS(8098),
    [anon_sym_GT_GT_EQ] = ACTIONS(8098),
    [anon_sym_LT_LT_EQ] = ACTIONS(8098),
    [anon_sym_CARET_EQ] = ACTIONS(8098),
    [anon_sym_QMARK] = ACTIONS(8098),
    [anon_sym_DOT_DOT] = ACTIONS(8100),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8098),
    [anon_sym_and] = ACTIONS(8098),
    [anon_sym_or] = ACTIONS(8098),
    [anon_sym_PIPE_PIPE] = ACTIONS(8100),
    [anon_sym_AMP_AMP] = ACTIONS(8100),
    [anon_sym_LT_LT] = ACTIONS(8100),
    [anon_sym_GT_GT] = ACTIONS(8100),
    [anon_sym_EQ_EQ] = ACTIONS(8100),
    [anon_sym_BANG_EQ] = ACTIONS(8098),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8098),
    [anon_sym_LT_EQ_GT] = ACTIONS(8098),
    [anon_sym_EQ_TILDE] = ACTIONS(8098),
    [anon_sym_BANG_TILDE] = ACTIONS(8098),
    [anon_sym_LT_EQ] = ACTIONS(8100),
    [anon_sym_GT] = ACTIONS(8100),
    [anon_sym_GT_EQ] = ACTIONS(8098),
    [anon_sym_CARET] = ACTIONS(8100),
    [anon_sym_PLUS] = ACTIONS(8100),
    [anon_sym_SLASH] = ACTIONS(8100),
    [anon_sym_PERCENT] = ACTIONS(8100),
    [sym_comment] = ACTIONS(87),
  },
  [8613] = {
    [anon_sym_end] = ACTIONS(13766),
    [sym_comment] = ACTIONS(87),
  },
  [8614] = {
    [sym__line_break] = ACTIONS(8284),
    [sym__heredoc_body_start] = ACTIONS(8284),
    [sym__binary_minus] = ACTIONS(8284),
    [sym__binary_star] = ACTIONS(8284),
    [ts_builtin_sym_end] = ACTIONS(8284),
    [anon_sym___END__] = ACTIONS(8284),
    [anon_sym_LBRACE] = ACTIONS(8284),
    [anon_sym_RBRACE] = ACTIONS(8284),
    [anon_sym_RPAREN] = ACTIONS(8284),
    [anon_sym_DOT] = ACTIONS(8286),
    [anon_sym_COMMA] = ACTIONS(8284),
    [anon_sym_PIPE] = ACTIONS(8286),
    [anon_sym_SEMI] = ACTIONS(8284),
    [anon_sym_STAR_STAR] = ACTIONS(8286),
    [anon_sym_AMP] = ACTIONS(8286),
    [anon_sym_EQ] = ACTIONS(8286),
    [anon_sym_LT] = ACTIONS(8286),
    [anon_sym_end] = ACTIONS(8284),
    [anon_sym_if] = ACTIONS(8284),
    [anon_sym_unless] = ACTIONS(8284),
    [anon_sym_while] = ACTIONS(8284),
    [anon_sym_until] = ACTIONS(8284),
    [anon_sym_rescue] = ACTIONS(8284),
    [anon_sym_do] = ACTIONS(8284),
    [anon_sym_when] = ACTIONS(8284),
    [anon_sym_elsif] = ACTIONS(8284),
    [anon_sym_else] = ACTIONS(8284),
    [anon_sym_then] = ACTIONS(8284),
    [anon_sym_ensure] = ACTIONS(8284),
    [anon_sym_LBRACK] = ACTIONS(8284),
    [anon_sym_COLON_COLON2] = ACTIONS(8284),
    [anon_sym_AMP_DOT] = ACTIONS(8284),
    [anon_sym_PLUS_EQ] = ACTIONS(8284),
    [anon_sym_DASH_EQ] = ACTIONS(8284),
    [anon_sym_STAR_EQ] = ACTIONS(8284),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8284),
    [anon_sym_SLASH_EQ] = ACTIONS(8284),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8284),
    [anon_sym_PIPE_EQ] = ACTIONS(8284),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8284),
    [anon_sym_AMP_EQ] = ACTIONS(8284),
    [anon_sym_PERCENT_EQ] = ACTIONS(8284),
    [anon_sym_GT_GT_EQ] = ACTIONS(8284),
    [anon_sym_LT_LT_EQ] = ACTIONS(8284),
    [anon_sym_CARET_EQ] = ACTIONS(8284),
    [anon_sym_QMARK] = ACTIONS(8284),
    [anon_sym_DOT_DOT] = ACTIONS(8286),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8284),
    [anon_sym_and] = ACTIONS(8284),
    [anon_sym_or] = ACTIONS(8284),
    [anon_sym_PIPE_PIPE] = ACTIONS(8286),
    [anon_sym_AMP_AMP] = ACTIONS(8286),
    [anon_sym_LT_LT] = ACTIONS(8286),
    [anon_sym_GT_GT] = ACTIONS(8286),
    [anon_sym_EQ_EQ] = ACTIONS(8286),
    [anon_sym_BANG_EQ] = ACTIONS(8284),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8284),
    [anon_sym_LT_EQ_GT] = ACTIONS(8284),
    [anon_sym_EQ_TILDE] = ACTIONS(8284),
    [anon_sym_BANG_TILDE] = ACTIONS(8284),
    [anon_sym_LT_EQ] = ACTIONS(8286),
    [anon_sym_GT] = ACTIONS(8286),
    [anon_sym_GT_EQ] = ACTIONS(8284),
    [anon_sym_CARET] = ACTIONS(8286),
    [anon_sym_PLUS] = ACTIONS(8286),
    [anon_sym_SLASH] = ACTIONS(8286),
    [anon_sym_PERCENT] = ACTIONS(8286),
    [sym_comment] = ACTIONS(87),
  },
  [8615] = {
    [anon_sym_end] = ACTIONS(13768),
    [sym_comment] = ACTIONS(87),
  },
  [8616] = {
    [sym__line_break] = ACTIONS(8344),
    [sym__heredoc_body_start] = ACTIONS(8344),
    [sym__binary_minus] = ACTIONS(8344),
    [sym__binary_star] = ACTIONS(8344),
    [ts_builtin_sym_end] = ACTIONS(8344),
    [anon_sym___END__] = ACTIONS(8344),
    [anon_sym_LBRACE] = ACTIONS(8344),
    [anon_sym_RBRACE] = ACTIONS(8344),
    [anon_sym_RPAREN] = ACTIONS(8344),
    [anon_sym_DOT] = ACTIONS(8346),
    [anon_sym_COMMA] = ACTIONS(8344),
    [anon_sym_PIPE] = ACTIONS(8346),
    [anon_sym_SEMI] = ACTIONS(8344),
    [anon_sym_STAR_STAR] = ACTIONS(8346),
    [anon_sym_AMP] = ACTIONS(8346),
    [anon_sym_EQ] = ACTIONS(8346),
    [anon_sym_LT] = ACTIONS(8346),
    [anon_sym_end] = ACTIONS(8344),
    [anon_sym_if] = ACTIONS(8344),
    [anon_sym_unless] = ACTIONS(8344),
    [anon_sym_while] = ACTIONS(8344),
    [anon_sym_until] = ACTIONS(8344),
    [anon_sym_rescue] = ACTIONS(8344),
    [anon_sym_do] = ACTIONS(8344),
    [anon_sym_when] = ACTIONS(8344),
    [anon_sym_elsif] = ACTIONS(8344),
    [anon_sym_else] = ACTIONS(8344),
    [anon_sym_then] = ACTIONS(8344),
    [anon_sym_ensure] = ACTIONS(8344),
    [anon_sym_LBRACK] = ACTIONS(8344),
    [anon_sym_COLON_COLON2] = ACTIONS(8344),
    [anon_sym_AMP_DOT] = ACTIONS(8344),
    [anon_sym_PLUS_EQ] = ACTIONS(8344),
    [anon_sym_DASH_EQ] = ACTIONS(8344),
    [anon_sym_STAR_EQ] = ACTIONS(8344),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8344),
    [anon_sym_SLASH_EQ] = ACTIONS(8344),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8344),
    [anon_sym_PIPE_EQ] = ACTIONS(8344),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8344),
    [anon_sym_AMP_EQ] = ACTIONS(8344),
    [anon_sym_PERCENT_EQ] = ACTIONS(8344),
    [anon_sym_GT_GT_EQ] = ACTIONS(8344),
    [anon_sym_LT_LT_EQ] = ACTIONS(8344),
    [anon_sym_CARET_EQ] = ACTIONS(8344),
    [anon_sym_QMARK] = ACTIONS(8344),
    [anon_sym_DOT_DOT] = ACTIONS(8346),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8344),
    [anon_sym_and] = ACTIONS(8344),
    [anon_sym_or] = ACTIONS(8344),
    [anon_sym_PIPE_PIPE] = ACTIONS(8346),
    [anon_sym_AMP_AMP] = ACTIONS(8346),
    [anon_sym_LT_LT] = ACTIONS(8346),
    [anon_sym_GT_GT] = ACTIONS(8346),
    [anon_sym_EQ_EQ] = ACTIONS(8346),
    [anon_sym_BANG_EQ] = ACTIONS(8344),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8344),
    [anon_sym_LT_EQ_GT] = ACTIONS(8344),
    [anon_sym_EQ_TILDE] = ACTIONS(8344),
    [anon_sym_BANG_TILDE] = ACTIONS(8344),
    [anon_sym_LT_EQ] = ACTIONS(8346),
    [anon_sym_GT] = ACTIONS(8346),
    [anon_sym_GT_EQ] = ACTIONS(8344),
    [anon_sym_CARET] = ACTIONS(8346),
    [anon_sym_PLUS] = ACTIONS(8346),
    [anon_sym_SLASH] = ACTIONS(8346),
    [anon_sym_PERCENT] = ACTIONS(8346),
    [sym_comment] = ACTIONS(87),
  },
  [8617] = {
    [anon_sym_end] = ACTIONS(13770),
    [sym_comment] = ACTIONS(87),
  },
  [8618] = {
    [sym__line_break] = ACTIONS(8420),
    [sym__heredoc_body_start] = ACTIONS(8420),
    [sym__binary_minus] = ACTIONS(8420),
    [sym__binary_star] = ACTIONS(8420),
    [ts_builtin_sym_end] = ACTIONS(8420),
    [anon_sym___END__] = ACTIONS(8420),
    [anon_sym_LBRACE] = ACTIONS(8420),
    [anon_sym_RBRACE] = ACTIONS(8420),
    [anon_sym_RPAREN] = ACTIONS(8420),
    [anon_sym_DOT] = ACTIONS(8422),
    [anon_sym_COMMA] = ACTIONS(8420),
    [anon_sym_PIPE] = ACTIONS(8422),
    [anon_sym_SEMI] = ACTIONS(8420),
    [anon_sym_STAR_STAR] = ACTIONS(8422),
    [anon_sym_AMP] = ACTIONS(8422),
    [anon_sym_EQ] = ACTIONS(8422),
    [anon_sym_LT] = ACTIONS(8422),
    [anon_sym_end] = ACTIONS(8420),
    [anon_sym_if] = ACTIONS(8420),
    [anon_sym_unless] = ACTIONS(8420),
    [anon_sym_while] = ACTIONS(8420),
    [anon_sym_until] = ACTIONS(8420),
    [anon_sym_rescue] = ACTIONS(8420),
    [anon_sym_do] = ACTIONS(8420),
    [anon_sym_when] = ACTIONS(8420),
    [anon_sym_elsif] = ACTIONS(8420),
    [anon_sym_else] = ACTIONS(8420),
    [anon_sym_then] = ACTIONS(8420),
    [anon_sym_ensure] = ACTIONS(8420),
    [anon_sym_LBRACK] = ACTIONS(8420),
    [anon_sym_COLON_COLON2] = ACTIONS(8420),
    [anon_sym_AMP_DOT] = ACTIONS(8420),
    [anon_sym_PLUS_EQ] = ACTIONS(8420),
    [anon_sym_DASH_EQ] = ACTIONS(8420),
    [anon_sym_STAR_EQ] = ACTIONS(8420),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8420),
    [anon_sym_SLASH_EQ] = ACTIONS(8420),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8420),
    [anon_sym_PIPE_EQ] = ACTIONS(8420),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8420),
    [anon_sym_AMP_EQ] = ACTIONS(8420),
    [anon_sym_PERCENT_EQ] = ACTIONS(8420),
    [anon_sym_GT_GT_EQ] = ACTIONS(8420),
    [anon_sym_LT_LT_EQ] = ACTIONS(8420),
    [anon_sym_CARET_EQ] = ACTIONS(8420),
    [anon_sym_QMARK] = ACTIONS(8420),
    [anon_sym_DOT_DOT] = ACTIONS(8422),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8420),
    [anon_sym_and] = ACTIONS(8420),
    [anon_sym_or] = ACTIONS(8420),
    [anon_sym_PIPE_PIPE] = ACTIONS(8422),
    [anon_sym_AMP_AMP] = ACTIONS(8422),
    [anon_sym_LT_LT] = ACTIONS(8422),
    [anon_sym_GT_GT] = ACTIONS(8422),
    [anon_sym_EQ_EQ] = ACTIONS(8422),
    [anon_sym_BANG_EQ] = ACTIONS(8420),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8420),
    [anon_sym_LT_EQ_GT] = ACTIONS(8420),
    [anon_sym_EQ_TILDE] = ACTIONS(8420),
    [anon_sym_BANG_TILDE] = ACTIONS(8420),
    [anon_sym_LT_EQ] = ACTIONS(8422),
    [anon_sym_GT] = ACTIONS(8422),
    [anon_sym_GT_EQ] = ACTIONS(8420),
    [anon_sym_CARET] = ACTIONS(8422),
    [anon_sym_PLUS] = ACTIONS(8422),
    [anon_sym_SLASH] = ACTIONS(8422),
    [anon_sym_PERCENT] = ACTIONS(8422),
    [sym_comment] = ACTIONS(87),
  },
  [8619] = {
    [anon_sym_end] = ACTIONS(13772),
    [sym_comment] = ACTIONS(87),
  },
  [8620] = {
    [sym__statements] = STATE(10060),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13774),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8621] = {
    [sym__line_break] = ACTIONS(8581),
    [sym__heredoc_body_start] = ACTIONS(8581),
    [sym__binary_minus] = ACTIONS(8581),
    [sym__binary_star] = ACTIONS(8581),
    [ts_builtin_sym_end] = ACTIONS(8581),
    [anon_sym___END__] = ACTIONS(8581),
    [anon_sym_LBRACE] = ACTIONS(8581),
    [anon_sym_RBRACE] = ACTIONS(8581),
    [anon_sym_RPAREN] = ACTIONS(8581),
    [anon_sym_DOT] = ACTIONS(8583),
    [anon_sym_COMMA] = ACTIONS(8581),
    [anon_sym_PIPE] = ACTIONS(8583),
    [anon_sym_SEMI] = ACTIONS(8581),
    [anon_sym_STAR_STAR] = ACTIONS(8583),
    [anon_sym_AMP] = ACTIONS(8583),
    [anon_sym_EQ] = ACTIONS(8583),
    [anon_sym_LT] = ACTIONS(8583),
    [anon_sym_end] = ACTIONS(8581),
    [anon_sym_if] = ACTIONS(8581),
    [anon_sym_unless] = ACTIONS(8581),
    [anon_sym_while] = ACTIONS(8581),
    [anon_sym_until] = ACTIONS(8581),
    [anon_sym_rescue] = ACTIONS(8581),
    [anon_sym_do] = ACTIONS(8581),
    [anon_sym_when] = ACTIONS(8581),
    [anon_sym_elsif] = ACTIONS(8581),
    [anon_sym_else] = ACTIONS(8581),
    [anon_sym_then] = ACTIONS(8581),
    [anon_sym_ensure] = ACTIONS(8581),
    [anon_sym_LBRACK] = ACTIONS(8581),
    [anon_sym_COLON_COLON2] = ACTIONS(8581),
    [anon_sym_AMP_DOT] = ACTIONS(8581),
    [anon_sym_PLUS_EQ] = ACTIONS(8581),
    [anon_sym_DASH_EQ] = ACTIONS(8581),
    [anon_sym_STAR_EQ] = ACTIONS(8581),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8581),
    [anon_sym_SLASH_EQ] = ACTIONS(8581),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8581),
    [anon_sym_PIPE_EQ] = ACTIONS(8581),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8581),
    [anon_sym_AMP_EQ] = ACTIONS(8581),
    [anon_sym_PERCENT_EQ] = ACTIONS(8581),
    [anon_sym_GT_GT_EQ] = ACTIONS(8581),
    [anon_sym_LT_LT_EQ] = ACTIONS(8581),
    [anon_sym_CARET_EQ] = ACTIONS(8581),
    [anon_sym_QMARK] = ACTIONS(8581),
    [anon_sym_DOT_DOT] = ACTIONS(8583),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8581),
    [anon_sym_and] = ACTIONS(8581),
    [anon_sym_or] = ACTIONS(8581),
    [anon_sym_PIPE_PIPE] = ACTIONS(8583),
    [anon_sym_AMP_AMP] = ACTIONS(8583),
    [anon_sym_LT_LT] = ACTIONS(8583),
    [anon_sym_GT_GT] = ACTIONS(8583),
    [anon_sym_EQ_EQ] = ACTIONS(8583),
    [anon_sym_BANG_EQ] = ACTIONS(8581),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8581),
    [anon_sym_LT_EQ_GT] = ACTIONS(8581),
    [anon_sym_EQ_TILDE] = ACTIONS(8581),
    [anon_sym_BANG_TILDE] = ACTIONS(8581),
    [anon_sym_LT_EQ] = ACTIONS(8583),
    [anon_sym_GT] = ACTIONS(8583),
    [anon_sym_GT_EQ] = ACTIONS(8581),
    [anon_sym_CARET] = ACTIONS(8583),
    [anon_sym_PLUS] = ACTIONS(8583),
    [anon_sym_SLASH] = ACTIONS(8583),
    [anon_sym_PERCENT] = ACTIONS(8583),
    [sym_comment] = ACTIONS(87),
  },
  [8622] = {
    [anon_sym_end] = ACTIONS(13776),
    [sym_comment] = ACTIONS(87),
  },
  [8623] = {
    [sym_when] = STATE(10063),
    [sym_else] = STATE(10062),
    [aux_sym_case_repeat1] = STATE(2987),
    [aux_sym_case_repeat2] = STATE(10063),
    [anon_sym_SEMI] = ACTIONS(4995),
    [anon_sym_end] = ACTIONS(13776),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [8624] = {
    [sym_when] = STATE(2988),
    [sym_else] = STATE(10062),
    [aux_sym_case_repeat2] = STATE(2988),
    [anon_sym_end] = ACTIONS(13776),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [8625] = {
    [sym__line_break] = ACTIONS(9185),
    [sym__heredoc_body_start] = ACTIONS(9185),
    [sym__binary_minus] = ACTIONS(9185),
    [sym__binary_star] = ACTIONS(9185),
    [ts_builtin_sym_end] = ACTIONS(9185),
    [anon_sym___END__] = ACTIONS(9185),
    [anon_sym_LBRACE] = ACTIONS(9185),
    [anon_sym_RBRACE] = ACTIONS(9185),
    [anon_sym_RPAREN] = ACTIONS(9185),
    [anon_sym_DOT] = ACTIONS(9187),
    [anon_sym_COMMA] = ACTIONS(9185),
    [anon_sym_PIPE] = ACTIONS(9187),
    [anon_sym_SEMI] = ACTIONS(9185),
    [anon_sym_STAR_STAR] = ACTIONS(9187),
    [anon_sym_AMP] = ACTIONS(9187),
    [anon_sym_EQ] = ACTIONS(9187),
    [anon_sym_LT] = ACTIONS(9187),
    [anon_sym_end] = ACTIONS(9185),
    [anon_sym_if] = ACTIONS(9185),
    [anon_sym_unless] = ACTIONS(9185),
    [anon_sym_while] = ACTIONS(9185),
    [anon_sym_until] = ACTIONS(9185),
    [anon_sym_rescue] = ACTIONS(9185),
    [anon_sym_do] = ACTIONS(9185),
    [anon_sym_when] = ACTIONS(9185),
    [anon_sym_elsif] = ACTIONS(9185),
    [anon_sym_else] = ACTIONS(9185),
    [anon_sym_then] = ACTIONS(9185),
    [anon_sym_ensure] = ACTIONS(9185),
    [anon_sym_LBRACK] = ACTIONS(9185),
    [anon_sym_COLON_COLON2] = ACTIONS(9185),
    [anon_sym_AMP_DOT] = ACTIONS(9185),
    [anon_sym_PLUS_EQ] = ACTIONS(9185),
    [anon_sym_DASH_EQ] = ACTIONS(9185),
    [anon_sym_STAR_EQ] = ACTIONS(9185),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9185),
    [anon_sym_SLASH_EQ] = ACTIONS(9185),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9185),
    [anon_sym_PIPE_EQ] = ACTIONS(9185),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9185),
    [anon_sym_AMP_EQ] = ACTIONS(9185),
    [anon_sym_PERCENT_EQ] = ACTIONS(9185),
    [anon_sym_GT_GT_EQ] = ACTIONS(9185),
    [anon_sym_LT_LT_EQ] = ACTIONS(9185),
    [anon_sym_CARET_EQ] = ACTIONS(9185),
    [anon_sym_QMARK] = ACTIONS(9185),
    [anon_sym_DOT_DOT] = ACTIONS(9187),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9185),
    [anon_sym_and] = ACTIONS(9185),
    [anon_sym_or] = ACTIONS(9185),
    [anon_sym_PIPE_PIPE] = ACTIONS(9187),
    [anon_sym_AMP_AMP] = ACTIONS(9187),
    [anon_sym_LT_LT] = ACTIONS(9187),
    [anon_sym_GT_GT] = ACTIONS(9187),
    [anon_sym_EQ_EQ] = ACTIONS(9187),
    [anon_sym_BANG_EQ] = ACTIONS(9185),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9185),
    [anon_sym_LT_EQ_GT] = ACTIONS(9185),
    [anon_sym_EQ_TILDE] = ACTIONS(9185),
    [anon_sym_BANG_TILDE] = ACTIONS(9185),
    [anon_sym_LT_EQ] = ACTIONS(9187),
    [anon_sym_GT] = ACTIONS(9187),
    [anon_sym_GT_EQ] = ACTIONS(9185),
    [anon_sym_CARET] = ACTIONS(9187),
    [anon_sym_PLUS] = ACTIONS(9187),
    [anon_sym_SLASH] = ACTIONS(9187),
    [anon_sym_PERCENT] = ACTIONS(9187),
    [sym_comment] = ACTIONS(87),
  },
  [8626] = {
    [anon_sym_end] = ACTIONS(13778),
    [sym_comment] = ACTIONS(87),
  },
  [8627] = {
    [sym_ensure] = STATE(10065),
    [anon_sym_end] = ACTIONS(13778),
    [anon_sym_ensure] = ACTIONS(2169),
    [sym_comment] = ACTIONS(87),
  },
  [8628] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10066),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(1498),
    [sym_scope_resolution] = STATE(1496),
    [sym_call] = STATE(1496),
    [sym_method_call] = STATE(1498),
    [sym_assignment] = STATE(10066),
    [sym_operator_assignment] = STATE(10066),
    [sym_conditional] = STATE(10066),
    [sym_range] = STATE(10066),
    [sym_binary] = STATE(10066),
    [sym_unary] = STATE(10066),
    [sym_left_assignment_list] = STATE(1497),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1498),
    [sym__variable] = STATE(1496),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(1498),
    [sym_false] = STATE(1498),
    [sym_nil] = STATE(1498),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(1499),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(2565),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(2577),
    [anon_sym_yield] = ACTIONS(2579),
    [anon_sym_break] = ACTIONS(2581),
    [anon_sym_next] = ACTIONS(2583),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(2601),
    [anon_sym_defined_QMARK] = ACTIONS(2603),
    [anon_sym_not] = ACTIONS(2605),
    [anon_sym_BANG] = ACTIONS(2607),
    [anon_sym_TILDE] = ACTIONS(2607),
    [sym_constant] = ACTIONS(2609),
    [sym_identifier] = ACTIONS(2609),
    [sym_instance_variable] = ACTIONS(2611),
    [sym_class_variable] = ACTIONS(2611),
    [sym_global_variable] = ACTIONS(2611),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(2609),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2609),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [8629] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(6322),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(1498),
    [sym_scope_resolution] = STATE(1496),
    [sym_call] = STATE(1496),
    [sym_method_call] = STATE(1498),
    [sym_splat_argument] = STATE(10067),
    [sym_assignment] = STATE(6322),
    [sym_operator_assignment] = STATE(6322),
    [sym_conditional] = STATE(6322),
    [sym_range] = STATE(6322),
    [sym_binary] = STATE(6322),
    [sym_unary] = STATE(6322),
    [sym__arg_or_splat_arg] = STATE(10067),
    [sym_left_assignment_list] = STATE(1497),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1498),
    [sym__variable] = STATE(1496),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(1498),
    [sym_false] = STATE(1498),
    [sym_nil] = STATE(1498),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(1499),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__splat_star] = ACTIONS(763),
    [sym__unary_minus] = ACTIONS(2565),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(2577),
    [anon_sym_yield] = ACTIONS(2579),
    [anon_sym_break] = ACTIONS(2581),
    [anon_sym_next] = ACTIONS(2583),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(2601),
    [anon_sym_defined_QMARK] = ACTIONS(2603),
    [anon_sym_not] = ACTIONS(2605),
    [anon_sym_BANG] = ACTIONS(2607),
    [anon_sym_TILDE] = ACTIONS(2607),
    [sym_constant] = ACTIONS(2609),
    [sym_identifier] = ACTIONS(2609),
    [sym_instance_variable] = ACTIONS(2611),
    [sym_class_variable] = ACTIONS(2611),
    [sym_global_variable] = ACTIONS(2611),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(2609),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2609),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [8630] = {
    [aux_sym_exceptions_repeat1] = STATE(10068),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [ts_builtin_sym_end] = ACTIONS(9855),
    [anon_sym___END__] = ACTIONS(9855),
    [anon_sym_LBRACE] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(13780),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9857),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_EQ] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_do] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_PLUS_EQ] = ACTIONS(9855),
    [anon_sym_DASH_EQ] = ACTIONS(9855),
    [anon_sym_STAR_EQ] = ACTIONS(9855),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9855),
    [anon_sym_SLASH_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9855),
    [anon_sym_AMP_EQ] = ACTIONS(9855),
    [anon_sym_PERCENT_EQ] = ACTIONS(9855),
    [anon_sym_GT_GT_EQ] = ACTIONS(9855),
    [anon_sym_LT_LT_EQ] = ACTIONS(9855),
    [anon_sym_CARET_EQ] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9857),
    [anon_sym_AMP_AMP] = ACTIONS(9857),
    [anon_sym_LT_LT] = ACTIONS(9857),
    [anon_sym_GT_GT] = ACTIONS(9857),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9857),
    [anon_sym_PLUS] = ACTIONS(9857),
    [anon_sym_SLASH] = ACTIONS(9857),
    [anon_sym_PERCENT] = ACTIONS(9857),
    [sym_comment] = ACTIONS(87),
  },
  [8631] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(6675),
    [sym__binary_star] = ACTIONS(6677),
    [anon_sym_RBRACE] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(6679),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(6677),
    [anon_sym_AMP] = ACTIONS(6681),
    [anon_sym_LT] = ACTIONS(6683),
    [anon_sym_if] = ACTIONS(6823),
    [anon_sym_unless] = ACTIONS(6823),
    [anon_sym_while] = ACTIONS(6823),
    [anon_sym_until] = ACTIONS(6823),
    [anon_sym_rescue] = ACTIONS(6823),
    [anon_sym_EQ_GT] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(6685),
    [anon_sym_DOT_DOT] = ACTIONS(6687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6689),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(6691),
    [anon_sym_AMP_AMP] = ACTIONS(6691),
    [anon_sym_LT_LT] = ACTIONS(6693),
    [anon_sym_GT_GT] = ACTIONS(6693),
    [anon_sym_EQ_EQ] = ACTIONS(6695),
    [anon_sym_BANG_EQ] = ACTIONS(6691),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6691),
    [anon_sym_LT_EQ_GT] = ACTIONS(6691),
    [anon_sym_EQ_TILDE] = ACTIONS(6691),
    [anon_sym_BANG_TILDE] = ACTIONS(6691),
    [anon_sym_LT_EQ] = ACTIONS(6683),
    [anon_sym_GT] = ACTIONS(6683),
    [anon_sym_GT_EQ] = ACTIONS(6697),
    [anon_sym_CARET] = ACTIONS(6699),
    [anon_sym_PLUS] = ACTIONS(6675),
    [anon_sym_SLASH] = ACTIONS(6677),
    [anon_sym_PERCENT] = ACTIONS(6677),
    [sym_comment] = ACTIONS(87),
  },
  [8632] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(6675),
    [sym__binary_star] = ACTIONS(6677),
    [anon_sym_RBRACE] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(6679),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(6677),
    [anon_sym_AMP] = ACTIONS(6681),
    [anon_sym_LT] = ACTIONS(6683),
    [anon_sym_if] = ACTIONS(7027),
    [anon_sym_unless] = ACTIONS(7027),
    [anon_sym_while] = ACTIONS(7027),
    [anon_sym_until] = ACTIONS(7027),
    [anon_sym_rescue] = ACTIONS(7027),
    [anon_sym_EQ_GT] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(6685),
    [anon_sym_DOT_DOT] = ACTIONS(6687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6689),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(6691),
    [anon_sym_AMP_AMP] = ACTIONS(6691),
    [anon_sym_LT_LT] = ACTIONS(6693),
    [anon_sym_GT_GT] = ACTIONS(6693),
    [anon_sym_EQ_EQ] = ACTIONS(6695),
    [anon_sym_BANG_EQ] = ACTIONS(6691),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6691),
    [anon_sym_LT_EQ_GT] = ACTIONS(6691),
    [anon_sym_EQ_TILDE] = ACTIONS(6691),
    [anon_sym_BANG_TILDE] = ACTIONS(6691),
    [anon_sym_LT_EQ] = ACTIONS(6683),
    [anon_sym_GT] = ACTIONS(6683),
    [anon_sym_GT_EQ] = ACTIONS(6697),
    [anon_sym_CARET] = ACTIONS(6699),
    [anon_sym_PLUS] = ACTIONS(6675),
    [anon_sym_SLASH] = ACTIONS(6677),
    [anon_sym_PERCENT] = ACTIONS(6677),
    [sym_comment] = ACTIONS(87),
  },
  [8633] = {
    [sym_heredoc_body] = STATE(8633),
    [aux_sym_call_repeat1] = STATE(8633),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(7916),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_RBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_EQ_GT] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [8634] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3657),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1725),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1725),
    [sym__argument] = STATE(4986),
    [sym_splat_argument] = STATE(4986),
    [sym_hash_splat_argument] = STATE(4986),
    [sym_block_argument] = STATE(4986),
    [sym_assignment] = STATE(3657),
    [sym_operator_assignment] = STATE(3657),
    [sym_conditional] = STATE(3657),
    [sym_range] = STATE(3657),
    [sym_binary] = STATE(3657),
    [sym_unary] = STATE(3657),
    [sym_left_assignment_list] = STATE(1724),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1725),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1725),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3660),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4986),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(6057),
    [sym__splat_star] = ACTIONS(6059),
    [sym__unary_minus] = ACTIONS(3111),
    [sym__identifier_hash_key] = ACTIONS(6061),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12270),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6669),
    [anon_sym_defined_QMARK] = ACTIONS(3123),
    [anon_sym_not] = ACTIONS(3125),
    [anon_sym_BANG] = ACTIONS(3129),
    [anon_sym_TILDE] = ACTIONS(3129),
    [sym_constant] = ACTIONS(6063),
    [sym_identifier] = ACTIONS(6063),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8635] = {
    [sym_heredoc_body] = STATE(8633),
    [aux_sym_call_repeat1] = STATE(8633),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_RBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_EQ_GT] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [8636] = {
    [aux_sym_argument_list_repeat1] = STATE(8636),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_RBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(13782),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7925),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_if] = ACTIONS(7925),
    [anon_sym_unless] = ACTIONS(7925),
    [anon_sym_while] = ACTIONS(7925),
    [anon_sym_until] = ACTIONS(7925),
    [anon_sym_rescue] = ACTIONS(7925),
    [anon_sym_EQ_GT] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7925),
    [anon_sym_AMP_AMP] = ACTIONS(7925),
    [anon_sym_LT_LT] = ACTIONS(7925),
    [anon_sym_GT_GT] = ACTIONS(7925),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7925),
    [anon_sym_PLUS] = ACTIONS(7925),
    [anon_sym_SLASH] = ACTIONS(7925),
    [anon_sym_PERCENT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [8637] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10069),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1519),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1519),
    [sym_assignment] = STATE(10069),
    [sym_operator_assignment] = STATE(10069),
    [sym_conditional] = STATE(10069),
    [sym_range] = STATE(10069),
    [sym_binary] = STATE(10069),
    [sym_unary] = STATE(10069),
    [sym_left_assignment_list] = STATE(1518),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1519),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1519),
    [sym_false] = STATE(1519),
    [sym_nil] = STATE(1519),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3651),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(2629),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2633),
    [anon_sym_yield] = ACTIONS(2635),
    [anon_sym_break] = ACTIONS(2637),
    [anon_sym_next] = ACTIONS(2639),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2641),
    [anon_sym_defined_QMARK] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2647),
    [anon_sym_TILDE] = ACTIONS(2647),
    [sym_constant] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8638] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(6741),
    [sym__binary_star] = ACTIONS(6743),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_RBRACE] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(6747),
    [anon_sym_AMP] = ACTIONS(6749),
    [anon_sym_EQ] = ACTIONS(7822),
    [anon_sym_LT] = ACTIONS(6751),
    [anon_sym_if] = ACTIONS(6823),
    [anon_sym_unless] = ACTIONS(6823),
    [anon_sym_while] = ACTIONS(6823),
    [anon_sym_until] = ACTIONS(6823),
    [anon_sym_rescue] = ACTIONS(6823),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_EQ_GT] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_PLUS_EQ] = ACTIONS(6823),
    [anon_sym_DASH_EQ] = ACTIONS(6823),
    [anon_sym_STAR_EQ] = ACTIONS(6823),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6823),
    [anon_sym_SLASH_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6823),
    [anon_sym_AMP_EQ] = ACTIONS(6823),
    [anon_sym_PERCENT_EQ] = ACTIONS(6823),
    [anon_sym_GT_GT_EQ] = ACTIONS(6823),
    [anon_sym_LT_LT_EQ] = ACTIONS(6823),
    [anon_sym_CARET_EQ] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(6753),
    [anon_sym_DOT_DOT] = ACTIONS(6755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6757),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(6759),
    [anon_sym_AMP_AMP] = ACTIONS(6759),
    [anon_sym_LT_LT] = ACTIONS(6761),
    [anon_sym_GT_GT] = ACTIONS(6761),
    [anon_sym_EQ_EQ] = ACTIONS(6759),
    [anon_sym_BANG_EQ] = ACTIONS(6763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6763),
    [anon_sym_LT_EQ_GT] = ACTIONS(6763),
    [anon_sym_EQ_TILDE] = ACTIONS(6763),
    [anon_sym_BANG_TILDE] = ACTIONS(6763),
    [anon_sym_LT_EQ] = ACTIONS(6751),
    [anon_sym_GT] = ACTIONS(6751),
    [anon_sym_GT_EQ] = ACTIONS(6765),
    [anon_sym_CARET] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6767),
    [anon_sym_SLASH] = ACTIONS(6747),
    [anon_sym_PERCENT] = ACTIONS(6747),
    [sym_comment] = ACTIONS(87),
  },
  [8639] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(6741),
    [sym__binary_star] = ACTIONS(6743),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_RBRACE] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(6747),
    [anon_sym_AMP] = ACTIONS(6749),
    [anon_sym_EQ] = ACTIONS(7884),
    [anon_sym_LT] = ACTIONS(6751),
    [anon_sym_if] = ACTIONS(7027),
    [anon_sym_unless] = ACTIONS(7027),
    [anon_sym_while] = ACTIONS(7027),
    [anon_sym_until] = ACTIONS(7027),
    [anon_sym_rescue] = ACTIONS(7027),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_EQ_GT] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_PLUS_EQ] = ACTIONS(7027),
    [anon_sym_DASH_EQ] = ACTIONS(7027),
    [anon_sym_STAR_EQ] = ACTIONS(7027),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7027),
    [anon_sym_SLASH_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7027),
    [anon_sym_AMP_EQ] = ACTIONS(7027),
    [anon_sym_PERCENT_EQ] = ACTIONS(7027),
    [anon_sym_GT_GT_EQ] = ACTIONS(7027),
    [anon_sym_LT_LT_EQ] = ACTIONS(7027),
    [anon_sym_CARET_EQ] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(6753),
    [anon_sym_DOT_DOT] = ACTIONS(6755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6757),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(6759),
    [anon_sym_AMP_AMP] = ACTIONS(6759),
    [anon_sym_LT_LT] = ACTIONS(6761),
    [anon_sym_GT_GT] = ACTIONS(6761),
    [anon_sym_EQ_EQ] = ACTIONS(6759),
    [anon_sym_BANG_EQ] = ACTIONS(6763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6763),
    [anon_sym_LT_EQ_GT] = ACTIONS(6763),
    [anon_sym_EQ_TILDE] = ACTIONS(6763),
    [anon_sym_BANG_TILDE] = ACTIONS(6763),
    [anon_sym_LT_EQ] = ACTIONS(6751),
    [anon_sym_GT] = ACTIONS(6751),
    [anon_sym_GT_EQ] = ACTIONS(6765),
    [anon_sym_CARET] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6767),
    [anon_sym_SLASH] = ACTIONS(6747),
    [anon_sym_PERCENT] = ACTIONS(6747),
    [sym_comment] = ACTIONS(87),
  },
  [8640] = {
    [sym_heredoc_body] = STATE(8640),
    [aux_sym_call_repeat1] = STATE(8640),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(10978),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_RBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7919),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_EQ] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_EQ_GT] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_PLUS_EQ] = ACTIONS(7914),
    [anon_sym_DASH_EQ] = ACTIONS(7914),
    [anon_sym_STAR_EQ] = ACTIONS(7914),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7914),
    [anon_sym_SLASH_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7914),
    [anon_sym_AMP_EQ] = ACTIONS(7914),
    [anon_sym_PERCENT_EQ] = ACTIONS(7914),
    [anon_sym_GT_GT_EQ] = ACTIONS(7914),
    [anon_sym_LT_LT_EQ] = ACTIONS(7914),
    [anon_sym_CARET_EQ] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7919),
    [anon_sym_AMP_AMP] = ACTIONS(7919),
    [anon_sym_LT_LT] = ACTIONS(7919),
    [anon_sym_GT_GT] = ACTIONS(7919),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7919),
    [anon_sym_PLUS] = ACTIONS(7919),
    [anon_sym_SLASH] = ACTIONS(7919),
    [anon_sym_PERCENT] = ACTIONS(7919),
    [sym_comment] = ACTIONS(87),
  },
  [8641] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3679),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1762),
    [sym_scope_resolution] = STATE(1758),
    [sym_call] = STATE(1758),
    [sym_method_call] = STATE(1762),
    [sym__argument] = STATE(7437),
    [sym_splat_argument] = STATE(7437),
    [sym_hash_splat_argument] = STATE(7437),
    [sym_block_argument] = STATE(7437),
    [sym_assignment] = STATE(3679),
    [sym_operator_assignment] = STATE(3679),
    [sym_conditional] = STATE(3679),
    [sym_range] = STATE(3679),
    [sym_binary] = STATE(3679),
    [sym_unary] = STATE(3679),
    [sym_left_assignment_list] = STATE(1761),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1762),
    [sym__variable] = STATE(1758),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1762),
    [sym_false] = STATE(1762),
    [sym_nil] = STATE(1762),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3682),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(7437),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(6095),
    [sym__splat_star] = ACTIONS(6097),
    [sym__unary_minus] = ACTIONS(3179),
    [sym__identifier_hash_key] = ACTIONS(6099),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12274),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(3183),
    [anon_sym_yield] = ACTIONS(3185),
    [anon_sym_break] = ACTIONS(3187),
    [anon_sym_next] = ACTIONS(3189),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(6735),
    [anon_sym_defined_QMARK] = ACTIONS(3191),
    [anon_sym_not] = ACTIONS(3193),
    [anon_sym_BANG] = ACTIONS(3197),
    [anon_sym_TILDE] = ACTIONS(3197),
    [sym_constant] = ACTIONS(6101),
    [sym_identifier] = ACTIONS(6101),
    [sym_instance_variable] = ACTIONS(3201),
    [sym_class_variable] = ACTIONS(3201),
    [sym_global_variable] = ACTIONS(3201),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(3203),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(3203),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [8642] = {
    [sym_heredoc_body] = STATE(8640),
    [aux_sym_call_repeat1] = STATE(8640),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_RBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7931),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_EQ] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_EQ_GT] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_PLUS_EQ] = ACTIONS(7929),
    [anon_sym_DASH_EQ] = ACTIONS(7929),
    [anon_sym_STAR_EQ] = ACTIONS(7929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7929),
    [anon_sym_SLASH_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7929),
    [anon_sym_AMP_EQ] = ACTIONS(7929),
    [anon_sym_PERCENT_EQ] = ACTIONS(7929),
    [anon_sym_GT_GT_EQ] = ACTIONS(7929),
    [anon_sym_LT_LT_EQ] = ACTIONS(7929),
    [anon_sym_CARET_EQ] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7931),
    [anon_sym_AMP_AMP] = ACTIONS(7931),
    [anon_sym_LT_LT] = ACTIONS(7931),
    [anon_sym_GT_GT] = ACTIONS(7931),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7931),
    [anon_sym_PLUS] = ACTIONS(7931),
    [anon_sym_SLASH] = ACTIONS(7931),
    [anon_sym_PERCENT] = ACTIONS(7931),
    [sym_comment] = ACTIONS(87),
  },
  [8643] = {
    [aux_sym_argument_list_repeat1] = STATE(8643),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_RBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(13785),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7927),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_EQ] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_if] = ACTIONS(7925),
    [anon_sym_unless] = ACTIONS(7925),
    [anon_sym_while] = ACTIONS(7925),
    [anon_sym_until] = ACTIONS(7925),
    [anon_sym_rescue] = ACTIONS(7925),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_EQ_GT] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_PLUS_EQ] = ACTIONS(7925),
    [anon_sym_DASH_EQ] = ACTIONS(7925),
    [anon_sym_STAR_EQ] = ACTIONS(7925),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7925),
    [anon_sym_SLASH_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7925),
    [anon_sym_AMP_EQ] = ACTIONS(7925),
    [anon_sym_PERCENT_EQ] = ACTIONS(7925),
    [anon_sym_GT_GT_EQ] = ACTIONS(7925),
    [anon_sym_LT_LT_EQ] = ACTIONS(7925),
    [anon_sym_CARET_EQ] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7927),
    [anon_sym_AMP_AMP] = ACTIONS(7927),
    [anon_sym_LT_LT] = ACTIONS(7927),
    [anon_sym_GT_GT] = ACTIONS(7927),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7927),
    [anon_sym_PLUS] = ACTIONS(7927),
    [anon_sym_SLASH] = ACTIONS(7927),
    [anon_sym_PERCENT] = ACTIONS(7927),
    [sym_comment] = ACTIONS(87),
  },
  [8644] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(12276),
    [sym__binary_star] = ACTIONS(12278),
    [anon_sym_RBRACE] = ACTIONS(4247),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(12280),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(12278),
    [anon_sym_AMP] = ACTIONS(12282),
    [anon_sym_LT] = ACTIONS(12284),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_EQ_GT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(12286),
    [anon_sym_DOT_DOT] = ACTIONS(12288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12290),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(12292),
    [anon_sym_AMP_AMP] = ACTIONS(12292),
    [anon_sym_LT_LT] = ACTIONS(12294),
    [anon_sym_GT_GT] = ACTIONS(12294),
    [anon_sym_EQ_EQ] = ACTIONS(12296),
    [anon_sym_BANG_EQ] = ACTIONS(12292),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12292),
    [anon_sym_LT_EQ_GT] = ACTIONS(12292),
    [anon_sym_EQ_TILDE] = ACTIONS(12292),
    [anon_sym_BANG_TILDE] = ACTIONS(12292),
    [anon_sym_LT_EQ] = ACTIONS(12284),
    [anon_sym_GT] = ACTIONS(12284),
    [anon_sym_GT_EQ] = ACTIONS(12298),
    [anon_sym_CARET] = ACTIONS(12300),
    [anon_sym_PLUS] = ACTIONS(12276),
    [anon_sym_SLASH] = ACTIONS(12278),
    [anon_sym_PERCENT] = ACTIONS(12278),
    [sym_comment] = ACTIONS(87),
  },
  [8645] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(12278),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [8646] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(12276),
    [sym__binary_star] = ACTIONS(12278),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(12280),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(12278),
    [anon_sym_AMP] = ACTIONS(12282),
    [anon_sym_LT] = ACTIONS(12284),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(12286),
    [anon_sym_DOT_DOT] = ACTIONS(12288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12290),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(12292),
    [anon_sym_AMP_AMP] = ACTIONS(12292),
    [anon_sym_LT_LT] = ACTIONS(12294),
    [anon_sym_GT_GT] = ACTIONS(12294),
    [anon_sym_EQ_EQ] = ACTIONS(12296),
    [anon_sym_BANG_EQ] = ACTIONS(12292),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12292),
    [anon_sym_LT_EQ_GT] = ACTIONS(12292),
    [anon_sym_EQ_TILDE] = ACTIONS(12292),
    [anon_sym_BANG_TILDE] = ACTIONS(12292),
    [anon_sym_LT_EQ] = ACTIONS(12284),
    [anon_sym_GT] = ACTIONS(12284),
    [anon_sym_GT_EQ] = ACTIONS(12298),
    [anon_sym_CARET] = ACTIONS(12300),
    [anon_sym_PLUS] = ACTIONS(12276),
    [anon_sym_SLASH] = ACTIONS(12278),
    [anon_sym_PERCENT] = ACTIONS(12278),
    [sym_comment] = ACTIONS(87),
  },
  [8647] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10070),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(6361),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(6361),
    [sym_assignment] = STATE(10070),
    [sym_operator_assignment] = STATE(10070),
    [sym_conditional] = STATE(10070),
    [sym_range] = STATE(10070),
    [sym_binary] = STATE(10070),
    [sym_unary] = STATE(10070),
    [sym_left_assignment_list] = STATE(6360),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6361),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(6361),
    [sym_false] = STATE(6361),
    [sym_nil] = STATE(6361),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(4013),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(9790),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9792),
    [anon_sym_defined_QMARK] = ACTIONS(9794),
    [anon_sym_not] = ACTIONS(9796),
    [anon_sym_BANG] = ACTIONS(9798),
    [anon_sym_TILDE] = ACTIONS(9798),
    [sym_constant] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8648] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10071),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(6361),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(6361),
    [sym_assignment] = STATE(10071),
    [sym_operator_assignment] = STATE(10071),
    [sym_conditional] = STATE(10071),
    [sym_range] = STATE(10071),
    [sym_binary] = STATE(10071),
    [sym_unary] = STATE(10071),
    [sym_left_assignment_list] = STATE(6360),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6361),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(6361),
    [sym_false] = STATE(6361),
    [sym_nil] = STATE(6361),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(4013),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(9790),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9792),
    [anon_sym_defined_QMARK] = ACTIONS(9794),
    [anon_sym_not] = ACTIONS(9796),
    [anon_sym_BANG] = ACTIONS(9798),
    [anon_sym_TILDE] = ACTIONS(9798),
    [sym_constant] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8649] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10072),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(6361),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(6361),
    [sym_assignment] = STATE(10072),
    [sym_operator_assignment] = STATE(10072),
    [sym_conditional] = STATE(10072),
    [sym_range] = STATE(10072),
    [sym_binary] = STATE(10072),
    [sym_unary] = STATE(10072),
    [sym_left_assignment_list] = STATE(6360),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6361),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(6361),
    [sym_false] = STATE(6361),
    [sym_nil] = STATE(6361),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(4013),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(9790),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9792),
    [anon_sym_defined_QMARK] = ACTIONS(9794),
    [anon_sym_not] = ACTIONS(9796),
    [anon_sym_BANG] = ACTIONS(9798),
    [anon_sym_TILDE] = ACTIONS(9798),
    [sym_constant] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8650] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10073),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(6361),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(6361),
    [sym_assignment] = STATE(10073),
    [sym_operator_assignment] = STATE(10073),
    [sym_conditional] = STATE(10073),
    [sym_range] = STATE(10073),
    [sym_binary] = STATE(10073),
    [sym_unary] = STATE(10073),
    [sym_left_assignment_list] = STATE(6360),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6361),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(6361),
    [sym_false] = STATE(6361),
    [sym_nil] = STATE(6361),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(4013),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(9790),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9792),
    [anon_sym_defined_QMARK] = ACTIONS(9794),
    [anon_sym_not] = ACTIONS(9796),
    [anon_sym_BANG] = ACTIONS(9798),
    [anon_sym_TILDE] = ACTIONS(9798),
    [sym_constant] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8651] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10074),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(6361),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(6361),
    [sym_assignment] = STATE(10074),
    [sym_operator_assignment] = STATE(10074),
    [sym_conditional] = STATE(10074),
    [sym_range] = STATE(10074),
    [sym_binary] = STATE(10074),
    [sym_unary] = STATE(10074),
    [sym_left_assignment_list] = STATE(6360),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6361),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(6361),
    [sym_false] = STATE(6361),
    [sym_nil] = STATE(6361),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(4013),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(9790),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9792),
    [anon_sym_defined_QMARK] = ACTIONS(9794),
    [anon_sym_not] = ACTIONS(9796),
    [anon_sym_BANG] = ACTIONS(9798),
    [anon_sym_TILDE] = ACTIONS(9798),
    [sym_constant] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8652] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(10075),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(10075),
    [sym_operator_assignment] = STATE(10075),
    [sym_conditional] = STATE(10075),
    [sym_range] = STATE(10075),
    [sym_binary] = STATE(10075),
    [sym_unary] = STATE(10075),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8653] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10076),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(6361),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(6361),
    [sym_assignment] = STATE(10076),
    [sym_operator_assignment] = STATE(10076),
    [sym_conditional] = STATE(10076),
    [sym_range] = STATE(10076),
    [sym_binary] = STATE(10076),
    [sym_unary] = STATE(10076),
    [sym_left_assignment_list] = STATE(6360),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6361),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(6361),
    [sym_false] = STATE(6361),
    [sym_nil] = STATE(6361),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(4013),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(9790),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9792),
    [anon_sym_defined_QMARK] = ACTIONS(9794),
    [anon_sym_not] = ACTIONS(9796),
    [anon_sym_BANG] = ACTIONS(9798),
    [anon_sym_TILDE] = ACTIONS(9798),
    [sym_constant] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8654] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10077),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(6361),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(6361),
    [sym_assignment] = STATE(10077),
    [sym_operator_assignment] = STATE(10077),
    [sym_conditional] = STATE(10077),
    [sym_range] = STATE(10077),
    [sym_binary] = STATE(10077),
    [sym_unary] = STATE(10077),
    [sym_left_assignment_list] = STATE(6360),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6361),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(6361),
    [sym_false] = STATE(6361),
    [sym_nil] = STATE(6361),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(4013),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(9790),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9792),
    [anon_sym_defined_QMARK] = ACTIONS(9794),
    [anon_sym_not] = ACTIONS(9796),
    [anon_sym_BANG] = ACTIONS(9798),
    [anon_sym_TILDE] = ACTIONS(9798),
    [sym_constant] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8655] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10078),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(6361),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(6361),
    [sym_assignment] = STATE(10078),
    [sym_operator_assignment] = STATE(10078),
    [sym_conditional] = STATE(10078),
    [sym_range] = STATE(10078),
    [sym_binary] = STATE(10078),
    [sym_unary] = STATE(10078),
    [sym_left_assignment_list] = STATE(6360),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6361),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(6361),
    [sym_false] = STATE(6361),
    [sym_nil] = STATE(6361),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(4013),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(9790),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9792),
    [anon_sym_defined_QMARK] = ACTIONS(9794),
    [anon_sym_not] = ACTIONS(9796),
    [anon_sym_BANG] = ACTIONS(9798),
    [anon_sym_TILDE] = ACTIONS(9798),
    [sym_constant] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8656] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10079),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(6361),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(6361),
    [sym_assignment] = STATE(10079),
    [sym_operator_assignment] = STATE(10079),
    [sym_conditional] = STATE(10079),
    [sym_range] = STATE(10079),
    [sym_binary] = STATE(10079),
    [sym_unary] = STATE(10079),
    [sym_left_assignment_list] = STATE(6360),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6361),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(6361),
    [sym_false] = STATE(6361),
    [sym_nil] = STATE(6361),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(4013),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(9790),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9792),
    [anon_sym_defined_QMARK] = ACTIONS(9794),
    [anon_sym_not] = ACTIONS(9796),
    [anon_sym_BANG] = ACTIONS(9798),
    [anon_sym_TILDE] = ACTIONS(9798),
    [sym_constant] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8657] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6358),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(6361),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(6361),
    [sym_splat_argument] = STATE(6406),
    [sym_assignment] = STATE(6358),
    [sym_operator_assignment] = STATE(6358),
    [sym_conditional] = STATE(6358),
    [sym_range] = STATE(6358),
    [sym_binary] = STATE(6358),
    [sym_unary] = STATE(6358),
    [sym__arg_or_splat_arg] = STATE(6406),
    [sym_left_assignment_list] = STATE(6360),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6361),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(6361),
    [sym_false] = STATE(6361),
    [sym_nil] = STATE(6361),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(4013),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__splat_star] = ACTIONS(9788),
    [sym__unary_minus] = ACTIONS(9790),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9792),
    [anon_sym_defined_QMARK] = ACTIONS(9794),
    [anon_sym_not] = ACTIONS(9796),
    [anon_sym_BANG] = ACTIONS(9798),
    [anon_sym_TILDE] = ACTIONS(9798),
    [sym_constant] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8658] = {
    [aux_sym_exceptions_repeat1] = STATE(10080),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_RBRACE] = ACTIONS(9855),
    [anon_sym_COMMA] = ACTIONS(12302),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_EQ_GT] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [8659] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6358),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(6361),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(6361),
    [sym_splat_argument] = STATE(10081),
    [sym_assignment] = STATE(6358),
    [sym_operator_assignment] = STATE(6358),
    [sym_conditional] = STATE(6358),
    [sym_range] = STATE(6358),
    [sym_binary] = STATE(6358),
    [sym_unary] = STATE(6358),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(10081),
    [sym_left_assignment_list] = STATE(6360),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6361),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(6361),
    [sym_false] = STATE(6361),
    [sym_nil] = STATE(6361),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(4013),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__splat_star] = ACTIONS(9788),
    [sym__unary_minus] = ACTIONS(9790),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9792),
    [anon_sym_defined_QMARK] = ACTIONS(9794),
    [anon_sym_not] = ACTIONS(9796),
    [anon_sym_BANG] = ACTIONS(9798),
    [anon_sym_TILDE] = ACTIONS(9798),
    [sym_constant] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8660] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10082),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(6361),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(6361),
    [sym_assignment] = STATE(10082),
    [sym_operator_assignment] = STATE(10082),
    [sym_conditional] = STATE(10082),
    [sym_range] = STATE(10082),
    [sym_binary] = STATE(10082),
    [sym_unary] = STATE(10082),
    [sym_left_assignment_list] = STATE(6360),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6361),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(6361),
    [sym_false] = STATE(6361),
    [sym_nil] = STATE(6361),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(4013),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(9790),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9792),
    [anon_sym_defined_QMARK] = ACTIONS(9794),
    [anon_sym_not] = ACTIONS(9796),
    [anon_sym_BANG] = ACTIONS(9798),
    [anon_sym_TILDE] = ACTIONS(9798),
    [sym_constant] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8661] = {
    [sym__method_rest] = STATE(10083),
    [sym_operator] = STATE(1526),
    [sym__method_name] = STATE(1526),
    [sym_setter] = STATE(1526),
    [sym_symbol] = STATE(1526),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(9804),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(9804),
    [sym_class_variable] = ACTIONS(9804),
    [sym_global_variable] = ACTIONS(9804),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [8662] = {
    [sym__line_break] = ACTIONS(10927),
    [sym__heredoc_body_start] = ACTIONS(10927),
    [sym__binary_minus] = ACTIONS(10927),
    [sym__binary_star] = ACTIONS(10927),
    [ts_builtin_sym_end] = ACTIONS(10927),
    [anon_sym___END__] = ACTIONS(10927),
    [anon_sym_LBRACE] = ACTIONS(10927),
    [anon_sym_RBRACE] = ACTIONS(10927),
    [anon_sym_RPAREN] = ACTIONS(10927),
    [anon_sym_DOT] = ACTIONS(10929),
    [anon_sym_COMMA] = ACTIONS(10927),
    [anon_sym_PIPE] = ACTIONS(10929),
    [anon_sym_SEMI] = ACTIONS(10927),
    [anon_sym_STAR_STAR] = ACTIONS(10929),
    [anon_sym_AMP] = ACTIONS(10929),
    [anon_sym_EQ] = ACTIONS(10929),
    [anon_sym_LT] = ACTIONS(10929),
    [anon_sym_end] = ACTIONS(10927),
    [anon_sym_if] = ACTIONS(10927),
    [anon_sym_unless] = ACTIONS(10927),
    [anon_sym_while] = ACTIONS(10927),
    [anon_sym_until] = ACTIONS(10927),
    [anon_sym_rescue] = ACTIONS(10927),
    [anon_sym_do] = ACTIONS(10927),
    [anon_sym_when] = ACTIONS(10927),
    [anon_sym_elsif] = ACTIONS(10927),
    [anon_sym_else] = ACTIONS(10927),
    [anon_sym_then] = ACTIONS(10927),
    [anon_sym_ensure] = ACTIONS(10927),
    [anon_sym_EQ_GT] = ACTIONS(10927),
    [anon_sym_LBRACK] = ACTIONS(10927),
    [anon_sym_COLON_COLON2] = ACTIONS(10927),
    [anon_sym_AMP_DOT] = ACTIONS(10927),
    [anon_sym_PLUS_EQ] = ACTIONS(10927),
    [anon_sym_DASH_EQ] = ACTIONS(10927),
    [anon_sym_STAR_EQ] = ACTIONS(10927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10927),
    [anon_sym_SLASH_EQ] = ACTIONS(10927),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10927),
    [anon_sym_PIPE_EQ] = ACTIONS(10927),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10927),
    [anon_sym_AMP_EQ] = ACTIONS(10927),
    [anon_sym_PERCENT_EQ] = ACTIONS(10927),
    [anon_sym_GT_GT_EQ] = ACTIONS(10927),
    [anon_sym_LT_LT_EQ] = ACTIONS(10927),
    [anon_sym_CARET_EQ] = ACTIONS(10927),
    [anon_sym_QMARK] = ACTIONS(10927),
    [anon_sym_DOT_DOT] = ACTIONS(10929),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10927),
    [anon_sym_and] = ACTIONS(10927),
    [anon_sym_or] = ACTIONS(10927),
    [anon_sym_PIPE_PIPE] = ACTIONS(10929),
    [anon_sym_AMP_AMP] = ACTIONS(10929),
    [anon_sym_LT_LT] = ACTIONS(10929),
    [anon_sym_GT_GT] = ACTIONS(10929),
    [anon_sym_EQ_EQ] = ACTIONS(10929),
    [anon_sym_BANG_EQ] = ACTIONS(10927),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10927),
    [anon_sym_LT_EQ_GT] = ACTIONS(10927),
    [anon_sym_EQ_TILDE] = ACTIONS(10927),
    [anon_sym_BANG_TILDE] = ACTIONS(10927),
    [anon_sym_LT_EQ] = ACTIONS(10929),
    [anon_sym_GT] = ACTIONS(10929),
    [anon_sym_GT_EQ] = ACTIONS(10927),
    [anon_sym_CARET] = ACTIONS(10929),
    [anon_sym_PLUS] = ACTIONS(10929),
    [anon_sym_SLASH] = ACTIONS(10929),
    [anon_sym_PERCENT] = ACTIONS(10929),
    [sym_comment] = ACTIONS(87),
  },
  [8663] = {
    [sym__line_break] = ACTIONS(10931),
    [sym__heredoc_body_start] = ACTIONS(10931),
    [sym__binary_minus] = ACTIONS(10931),
    [sym__binary_star] = ACTIONS(10931),
    [ts_builtin_sym_end] = ACTIONS(10931),
    [anon_sym___END__] = ACTIONS(10931),
    [anon_sym_LBRACE] = ACTIONS(10931),
    [anon_sym_RBRACE] = ACTIONS(10931),
    [anon_sym_RPAREN] = ACTIONS(10931),
    [anon_sym_DOT] = ACTIONS(10933),
    [anon_sym_COMMA] = ACTIONS(10931),
    [anon_sym_PIPE] = ACTIONS(10933),
    [anon_sym_SEMI] = ACTIONS(10931),
    [anon_sym_STAR_STAR] = ACTIONS(10933),
    [anon_sym_AMP] = ACTIONS(10933),
    [anon_sym_EQ] = ACTIONS(10933),
    [anon_sym_LT] = ACTIONS(10933),
    [anon_sym_end] = ACTIONS(10931),
    [anon_sym_if] = ACTIONS(10931),
    [anon_sym_unless] = ACTIONS(10931),
    [anon_sym_while] = ACTIONS(10931),
    [anon_sym_until] = ACTIONS(10931),
    [anon_sym_rescue] = ACTIONS(10931),
    [anon_sym_do] = ACTIONS(10931),
    [anon_sym_when] = ACTIONS(10931),
    [anon_sym_elsif] = ACTIONS(10931),
    [anon_sym_else] = ACTIONS(10931),
    [anon_sym_then] = ACTIONS(10931),
    [anon_sym_ensure] = ACTIONS(10931),
    [anon_sym_EQ_GT] = ACTIONS(10931),
    [anon_sym_LBRACK] = ACTIONS(10931),
    [anon_sym_COLON_COLON2] = ACTIONS(10931),
    [anon_sym_AMP_DOT] = ACTIONS(10931),
    [anon_sym_PLUS_EQ] = ACTIONS(10931),
    [anon_sym_DASH_EQ] = ACTIONS(10931),
    [anon_sym_STAR_EQ] = ACTIONS(10931),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10931),
    [anon_sym_SLASH_EQ] = ACTIONS(10931),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10931),
    [anon_sym_PIPE_EQ] = ACTIONS(10931),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10931),
    [anon_sym_AMP_EQ] = ACTIONS(10931),
    [anon_sym_PERCENT_EQ] = ACTIONS(10931),
    [anon_sym_GT_GT_EQ] = ACTIONS(10931),
    [anon_sym_LT_LT_EQ] = ACTIONS(10931),
    [anon_sym_CARET_EQ] = ACTIONS(10931),
    [anon_sym_QMARK] = ACTIONS(10931),
    [anon_sym_DOT_DOT] = ACTIONS(10933),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10931),
    [anon_sym_and] = ACTIONS(10931),
    [anon_sym_or] = ACTIONS(10931),
    [anon_sym_PIPE_PIPE] = ACTIONS(10933),
    [anon_sym_AMP_AMP] = ACTIONS(10933),
    [anon_sym_LT_LT] = ACTIONS(10933),
    [anon_sym_GT_GT] = ACTIONS(10933),
    [anon_sym_EQ_EQ] = ACTIONS(10933),
    [anon_sym_BANG_EQ] = ACTIONS(10931),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10931),
    [anon_sym_LT_EQ_GT] = ACTIONS(10931),
    [anon_sym_EQ_TILDE] = ACTIONS(10931),
    [anon_sym_BANG_TILDE] = ACTIONS(10931),
    [anon_sym_LT_EQ] = ACTIONS(10933),
    [anon_sym_GT] = ACTIONS(10933),
    [anon_sym_GT_EQ] = ACTIONS(10931),
    [anon_sym_CARET] = ACTIONS(10933),
    [anon_sym_PLUS] = ACTIONS(10933),
    [anon_sym_SLASH] = ACTIONS(10933),
    [anon_sym_PERCENT] = ACTIONS(10933),
    [sym_comment] = ACTIONS(87),
  },
  [8664] = {
    [sym__line_break] = ACTIONS(11157),
    [sym__heredoc_body_start] = ACTIONS(11157),
    [sym__binary_minus] = ACTIONS(11157),
    [sym__binary_star] = ACTIONS(11157),
    [ts_builtin_sym_end] = ACTIONS(11157),
    [anon_sym___END__] = ACTIONS(11157),
    [anon_sym_LBRACE] = ACTIONS(11157),
    [anon_sym_RBRACE] = ACTIONS(11157),
    [anon_sym_RPAREN] = ACTIONS(11157),
    [anon_sym_DOT] = ACTIONS(11159),
    [anon_sym_COMMA] = ACTIONS(11157),
    [anon_sym_PIPE] = ACTIONS(11159),
    [anon_sym_SEMI] = ACTIONS(11157),
    [anon_sym_STAR_STAR] = ACTIONS(11159),
    [anon_sym_AMP] = ACTIONS(11159),
    [anon_sym_EQ] = ACTIONS(11159),
    [anon_sym_LT] = ACTIONS(11159),
    [anon_sym_end] = ACTIONS(11157),
    [anon_sym_if] = ACTIONS(11157),
    [anon_sym_unless] = ACTIONS(11157),
    [anon_sym_while] = ACTIONS(11157),
    [anon_sym_until] = ACTIONS(11157),
    [anon_sym_rescue] = ACTIONS(11157),
    [anon_sym_do] = ACTIONS(11157),
    [anon_sym_when] = ACTIONS(11157),
    [anon_sym_elsif] = ACTIONS(11157),
    [anon_sym_else] = ACTIONS(11157),
    [anon_sym_then] = ACTIONS(11157),
    [anon_sym_ensure] = ACTIONS(11157),
    [anon_sym_EQ_GT] = ACTIONS(11157),
    [anon_sym_LBRACK] = ACTIONS(11157),
    [anon_sym_COLON_COLON2] = ACTIONS(11157),
    [anon_sym_AMP_DOT] = ACTIONS(11157),
    [anon_sym_PLUS_EQ] = ACTIONS(11157),
    [anon_sym_DASH_EQ] = ACTIONS(11157),
    [anon_sym_STAR_EQ] = ACTIONS(11157),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11157),
    [anon_sym_SLASH_EQ] = ACTIONS(11157),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11157),
    [anon_sym_PIPE_EQ] = ACTIONS(11157),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11157),
    [anon_sym_AMP_EQ] = ACTIONS(11157),
    [anon_sym_PERCENT_EQ] = ACTIONS(11157),
    [anon_sym_GT_GT_EQ] = ACTIONS(11157),
    [anon_sym_LT_LT_EQ] = ACTIONS(11157),
    [anon_sym_CARET_EQ] = ACTIONS(11157),
    [anon_sym_QMARK] = ACTIONS(11157),
    [anon_sym_DOT_DOT] = ACTIONS(11159),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11157),
    [anon_sym_and] = ACTIONS(11157),
    [anon_sym_or] = ACTIONS(11157),
    [anon_sym_PIPE_PIPE] = ACTIONS(11159),
    [anon_sym_AMP_AMP] = ACTIONS(11159),
    [anon_sym_LT_LT] = ACTIONS(11159),
    [anon_sym_GT_GT] = ACTIONS(11159),
    [anon_sym_EQ_EQ] = ACTIONS(11159),
    [anon_sym_BANG_EQ] = ACTIONS(11157),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11157),
    [anon_sym_LT_EQ_GT] = ACTIONS(11157),
    [anon_sym_EQ_TILDE] = ACTIONS(11157),
    [anon_sym_BANG_TILDE] = ACTIONS(11157),
    [anon_sym_LT_EQ] = ACTIONS(11159),
    [anon_sym_GT] = ACTIONS(11159),
    [anon_sym_GT_EQ] = ACTIONS(11157),
    [anon_sym_CARET] = ACTIONS(11159),
    [anon_sym_PLUS] = ACTIONS(11159),
    [anon_sym_SLASH] = ACTIONS(11159),
    [anon_sym_PERCENT] = ACTIONS(11159),
    [sym_comment] = ACTIONS(87),
  },
  [8665] = {
    [sym__line_break] = ACTIONS(11322),
    [sym__heredoc_body_start] = ACTIONS(11322),
    [sym__binary_minus] = ACTIONS(11322),
    [sym__binary_star] = ACTIONS(11322),
    [ts_builtin_sym_end] = ACTIONS(11322),
    [anon_sym___END__] = ACTIONS(11322),
    [anon_sym_LBRACE] = ACTIONS(11322),
    [anon_sym_RBRACE] = ACTIONS(11322),
    [anon_sym_RPAREN] = ACTIONS(11322),
    [anon_sym_DOT] = ACTIONS(11324),
    [anon_sym_COMMA] = ACTIONS(11322),
    [anon_sym_PIPE] = ACTIONS(11324),
    [anon_sym_SEMI] = ACTIONS(11322),
    [anon_sym_STAR_STAR] = ACTIONS(11324),
    [anon_sym_AMP] = ACTIONS(11324),
    [anon_sym_EQ] = ACTIONS(11324),
    [anon_sym_LT] = ACTIONS(11324),
    [anon_sym_end] = ACTIONS(11322),
    [anon_sym_if] = ACTIONS(11322),
    [anon_sym_unless] = ACTIONS(11322),
    [anon_sym_while] = ACTIONS(11322),
    [anon_sym_until] = ACTIONS(11322),
    [anon_sym_rescue] = ACTIONS(11322),
    [anon_sym_do] = ACTIONS(11322),
    [anon_sym_when] = ACTIONS(11322),
    [anon_sym_elsif] = ACTIONS(11322),
    [anon_sym_else] = ACTIONS(11322),
    [anon_sym_then] = ACTIONS(11322),
    [anon_sym_ensure] = ACTIONS(11322),
    [anon_sym_EQ_GT] = ACTIONS(11322),
    [anon_sym_LBRACK] = ACTIONS(11322),
    [anon_sym_COLON_COLON2] = ACTIONS(11322),
    [anon_sym_AMP_DOT] = ACTIONS(11322),
    [anon_sym_PLUS_EQ] = ACTIONS(11322),
    [anon_sym_DASH_EQ] = ACTIONS(11322),
    [anon_sym_STAR_EQ] = ACTIONS(11322),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11322),
    [anon_sym_SLASH_EQ] = ACTIONS(11322),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11322),
    [anon_sym_PIPE_EQ] = ACTIONS(11322),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11322),
    [anon_sym_AMP_EQ] = ACTIONS(11322),
    [anon_sym_PERCENT_EQ] = ACTIONS(11322),
    [anon_sym_GT_GT_EQ] = ACTIONS(11322),
    [anon_sym_LT_LT_EQ] = ACTIONS(11322),
    [anon_sym_CARET_EQ] = ACTIONS(11322),
    [anon_sym_QMARK] = ACTIONS(11322),
    [anon_sym_DOT_DOT] = ACTIONS(11324),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11322),
    [anon_sym_and] = ACTIONS(11322),
    [anon_sym_or] = ACTIONS(11322),
    [anon_sym_PIPE_PIPE] = ACTIONS(11324),
    [anon_sym_AMP_AMP] = ACTIONS(11324),
    [anon_sym_LT_LT] = ACTIONS(11324),
    [anon_sym_GT_GT] = ACTIONS(11324),
    [anon_sym_EQ_EQ] = ACTIONS(11324),
    [anon_sym_BANG_EQ] = ACTIONS(11322),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11322),
    [anon_sym_LT_EQ_GT] = ACTIONS(11322),
    [anon_sym_EQ_TILDE] = ACTIONS(11322),
    [anon_sym_BANG_TILDE] = ACTIONS(11322),
    [anon_sym_LT_EQ] = ACTIONS(11324),
    [anon_sym_GT] = ACTIONS(11324),
    [anon_sym_GT_EQ] = ACTIONS(11322),
    [anon_sym_CARET] = ACTIONS(11324),
    [anon_sym_PLUS] = ACTIONS(11324),
    [anon_sym_SLASH] = ACTIONS(11324),
    [anon_sym_PERCENT] = ACTIONS(11324),
    [sym_comment] = ACTIONS(87),
  },
  [8666] = {
    [sym__line_break] = ACTIONS(11335),
    [sym__heredoc_body_start] = ACTIONS(11335),
    [sym__binary_minus] = ACTIONS(11335),
    [sym__binary_star] = ACTIONS(11335),
    [ts_builtin_sym_end] = ACTIONS(11335),
    [anon_sym___END__] = ACTIONS(11335),
    [anon_sym_LBRACE] = ACTIONS(11335),
    [anon_sym_RBRACE] = ACTIONS(11335),
    [anon_sym_RPAREN] = ACTIONS(11335),
    [anon_sym_DOT] = ACTIONS(11337),
    [anon_sym_COMMA] = ACTIONS(11335),
    [anon_sym_PIPE] = ACTIONS(11337),
    [anon_sym_SEMI] = ACTIONS(11335),
    [anon_sym_STAR_STAR] = ACTIONS(11337),
    [anon_sym_AMP] = ACTIONS(11337),
    [anon_sym_EQ] = ACTIONS(11337),
    [anon_sym_LT] = ACTIONS(11337),
    [anon_sym_end] = ACTIONS(11335),
    [anon_sym_if] = ACTIONS(11335),
    [anon_sym_unless] = ACTIONS(11335),
    [anon_sym_while] = ACTIONS(11335),
    [anon_sym_until] = ACTIONS(11335),
    [anon_sym_rescue] = ACTIONS(11335),
    [anon_sym_do] = ACTIONS(11335),
    [anon_sym_when] = ACTIONS(11335),
    [anon_sym_elsif] = ACTIONS(11335),
    [anon_sym_else] = ACTIONS(11335),
    [anon_sym_then] = ACTIONS(11335),
    [anon_sym_ensure] = ACTIONS(11335),
    [anon_sym_EQ_GT] = ACTIONS(11335),
    [anon_sym_LBRACK] = ACTIONS(11335),
    [anon_sym_COLON_COLON2] = ACTIONS(11335),
    [anon_sym_AMP_DOT] = ACTIONS(11335),
    [anon_sym_PLUS_EQ] = ACTIONS(11335),
    [anon_sym_DASH_EQ] = ACTIONS(11335),
    [anon_sym_STAR_EQ] = ACTIONS(11335),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11335),
    [anon_sym_SLASH_EQ] = ACTIONS(11335),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11335),
    [anon_sym_PIPE_EQ] = ACTIONS(11335),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11335),
    [anon_sym_AMP_EQ] = ACTIONS(11335),
    [anon_sym_PERCENT_EQ] = ACTIONS(11335),
    [anon_sym_GT_GT_EQ] = ACTIONS(11335),
    [anon_sym_LT_LT_EQ] = ACTIONS(11335),
    [anon_sym_CARET_EQ] = ACTIONS(11335),
    [anon_sym_QMARK] = ACTIONS(11335),
    [anon_sym_DOT_DOT] = ACTIONS(11337),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11335),
    [anon_sym_and] = ACTIONS(11335),
    [anon_sym_or] = ACTIONS(11335),
    [anon_sym_PIPE_PIPE] = ACTIONS(11337),
    [anon_sym_AMP_AMP] = ACTIONS(11337),
    [anon_sym_LT_LT] = ACTIONS(11337),
    [anon_sym_GT_GT] = ACTIONS(11337),
    [anon_sym_EQ_EQ] = ACTIONS(11337),
    [anon_sym_BANG_EQ] = ACTIONS(11335),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11335),
    [anon_sym_LT_EQ_GT] = ACTIONS(11335),
    [anon_sym_EQ_TILDE] = ACTIONS(11335),
    [anon_sym_BANG_TILDE] = ACTIONS(11335),
    [anon_sym_LT_EQ] = ACTIONS(11337),
    [anon_sym_GT] = ACTIONS(11337),
    [anon_sym_GT_EQ] = ACTIONS(11335),
    [anon_sym_CARET] = ACTIONS(11337),
    [anon_sym_PLUS] = ACTIONS(11337),
    [anon_sym_SLASH] = ACTIONS(11337),
    [anon_sym_PERCENT] = ACTIONS(11337),
    [sym_comment] = ACTIONS(87),
  },
  [8667] = {
    [sym__line_break] = ACTIONS(11344),
    [sym__heredoc_body_start] = ACTIONS(11344),
    [sym__binary_minus] = ACTIONS(11344),
    [sym__binary_star] = ACTIONS(11344),
    [ts_builtin_sym_end] = ACTIONS(11344),
    [anon_sym___END__] = ACTIONS(11344),
    [anon_sym_LBRACE] = ACTIONS(11344),
    [anon_sym_RBRACE] = ACTIONS(11344),
    [anon_sym_RPAREN] = ACTIONS(11344),
    [anon_sym_DOT] = ACTIONS(11346),
    [anon_sym_COMMA] = ACTIONS(11344),
    [anon_sym_PIPE] = ACTIONS(11346),
    [anon_sym_SEMI] = ACTIONS(11344),
    [anon_sym_STAR_STAR] = ACTIONS(11346),
    [anon_sym_AMP] = ACTIONS(11346),
    [anon_sym_EQ] = ACTIONS(11346),
    [anon_sym_LT] = ACTIONS(11346),
    [anon_sym_end] = ACTIONS(11344),
    [anon_sym_if] = ACTIONS(11344),
    [anon_sym_unless] = ACTIONS(11344),
    [anon_sym_while] = ACTIONS(11344),
    [anon_sym_until] = ACTIONS(11344),
    [anon_sym_rescue] = ACTIONS(11344),
    [anon_sym_do] = ACTIONS(11344),
    [anon_sym_when] = ACTIONS(11344),
    [anon_sym_elsif] = ACTIONS(11344),
    [anon_sym_else] = ACTIONS(11344),
    [anon_sym_then] = ACTIONS(11344),
    [anon_sym_ensure] = ACTIONS(11344),
    [anon_sym_EQ_GT] = ACTIONS(11344),
    [anon_sym_LBRACK] = ACTIONS(11344),
    [anon_sym_COLON_COLON2] = ACTIONS(11344),
    [anon_sym_AMP_DOT] = ACTIONS(11344),
    [anon_sym_PLUS_EQ] = ACTIONS(11344),
    [anon_sym_DASH_EQ] = ACTIONS(11344),
    [anon_sym_STAR_EQ] = ACTIONS(11344),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11344),
    [anon_sym_SLASH_EQ] = ACTIONS(11344),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11344),
    [anon_sym_PIPE_EQ] = ACTIONS(11344),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11344),
    [anon_sym_AMP_EQ] = ACTIONS(11344),
    [anon_sym_PERCENT_EQ] = ACTIONS(11344),
    [anon_sym_GT_GT_EQ] = ACTIONS(11344),
    [anon_sym_LT_LT_EQ] = ACTIONS(11344),
    [anon_sym_CARET_EQ] = ACTIONS(11344),
    [anon_sym_QMARK] = ACTIONS(11344),
    [anon_sym_DOT_DOT] = ACTIONS(11346),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11344),
    [anon_sym_and] = ACTIONS(11344),
    [anon_sym_or] = ACTIONS(11344),
    [anon_sym_PIPE_PIPE] = ACTIONS(11346),
    [anon_sym_AMP_AMP] = ACTIONS(11346),
    [anon_sym_LT_LT] = ACTIONS(11346),
    [anon_sym_GT_GT] = ACTIONS(11346),
    [anon_sym_EQ_EQ] = ACTIONS(11346),
    [anon_sym_BANG_EQ] = ACTIONS(11344),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11344),
    [anon_sym_LT_EQ_GT] = ACTIONS(11344),
    [anon_sym_EQ_TILDE] = ACTIONS(11344),
    [anon_sym_BANG_TILDE] = ACTIONS(11344),
    [anon_sym_LT_EQ] = ACTIONS(11346),
    [anon_sym_GT] = ACTIONS(11346),
    [anon_sym_GT_EQ] = ACTIONS(11344),
    [anon_sym_CARET] = ACTIONS(11346),
    [anon_sym_PLUS] = ACTIONS(11346),
    [anon_sym_SLASH] = ACTIONS(11346),
    [anon_sym_PERCENT] = ACTIONS(11346),
    [sym_comment] = ACTIONS(87),
  },
  [8668] = {
    [sym__line_break] = ACTIONS(11391),
    [sym__heredoc_body_start] = ACTIONS(11391),
    [sym__binary_minus] = ACTIONS(11391),
    [sym__binary_star] = ACTIONS(11391),
    [ts_builtin_sym_end] = ACTIONS(11391),
    [anon_sym___END__] = ACTIONS(11391),
    [anon_sym_LBRACE] = ACTIONS(11391),
    [anon_sym_RBRACE] = ACTIONS(11391),
    [anon_sym_RPAREN] = ACTIONS(11391),
    [anon_sym_DOT] = ACTIONS(11393),
    [anon_sym_COMMA] = ACTIONS(11391),
    [anon_sym_PIPE] = ACTIONS(11393),
    [anon_sym_SEMI] = ACTIONS(11391),
    [anon_sym_STAR_STAR] = ACTIONS(11393),
    [anon_sym_AMP] = ACTIONS(11393),
    [anon_sym_EQ] = ACTIONS(11393),
    [anon_sym_LT] = ACTIONS(11393),
    [anon_sym_end] = ACTIONS(11391),
    [anon_sym_if] = ACTIONS(11391),
    [anon_sym_unless] = ACTIONS(11391),
    [anon_sym_while] = ACTIONS(11391),
    [anon_sym_until] = ACTIONS(11391),
    [anon_sym_rescue] = ACTIONS(11391),
    [anon_sym_do] = ACTIONS(11391),
    [anon_sym_when] = ACTIONS(11391),
    [anon_sym_elsif] = ACTIONS(11391),
    [anon_sym_else] = ACTIONS(11391),
    [anon_sym_then] = ACTIONS(11391),
    [anon_sym_ensure] = ACTIONS(11391),
    [anon_sym_EQ_GT] = ACTIONS(11391),
    [anon_sym_LBRACK] = ACTIONS(11391),
    [anon_sym_COLON_COLON2] = ACTIONS(11391),
    [anon_sym_AMP_DOT] = ACTIONS(11391),
    [anon_sym_PLUS_EQ] = ACTIONS(11391),
    [anon_sym_DASH_EQ] = ACTIONS(11391),
    [anon_sym_STAR_EQ] = ACTIONS(11391),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11391),
    [anon_sym_SLASH_EQ] = ACTIONS(11391),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11391),
    [anon_sym_PIPE_EQ] = ACTIONS(11391),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11391),
    [anon_sym_AMP_EQ] = ACTIONS(11391),
    [anon_sym_PERCENT_EQ] = ACTIONS(11391),
    [anon_sym_GT_GT_EQ] = ACTIONS(11391),
    [anon_sym_LT_LT_EQ] = ACTIONS(11391),
    [anon_sym_CARET_EQ] = ACTIONS(11391),
    [anon_sym_QMARK] = ACTIONS(11391),
    [anon_sym_DOT_DOT] = ACTIONS(11393),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11391),
    [anon_sym_and] = ACTIONS(11391),
    [anon_sym_or] = ACTIONS(11391),
    [anon_sym_PIPE_PIPE] = ACTIONS(11393),
    [anon_sym_AMP_AMP] = ACTIONS(11393),
    [anon_sym_LT_LT] = ACTIONS(11393),
    [anon_sym_GT_GT] = ACTIONS(11393),
    [anon_sym_EQ_EQ] = ACTIONS(11393),
    [anon_sym_BANG_EQ] = ACTIONS(11391),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11391),
    [anon_sym_LT_EQ_GT] = ACTIONS(11391),
    [anon_sym_EQ_TILDE] = ACTIONS(11391),
    [anon_sym_BANG_TILDE] = ACTIONS(11391),
    [anon_sym_LT_EQ] = ACTIONS(11393),
    [anon_sym_GT] = ACTIONS(11393),
    [anon_sym_GT_EQ] = ACTIONS(11391),
    [anon_sym_CARET] = ACTIONS(11393),
    [anon_sym_PLUS] = ACTIONS(11393),
    [anon_sym_SLASH] = ACTIONS(11393),
    [anon_sym_PERCENT] = ACTIONS(11393),
    [sym_comment] = ACTIONS(87),
  },
  [8669] = {
    [anon_sym_end] = ACTIONS(13788),
    [sym_comment] = ACTIONS(87),
  },
  [8670] = {
    [sym__line_break] = ACTIONS(13712),
    [sym__heredoc_body_start] = ACTIONS(13712),
    [sym__binary_minus] = ACTIONS(13712),
    [sym__binary_star] = ACTIONS(13712),
    [ts_builtin_sym_end] = ACTIONS(13712),
    [anon_sym___END__] = ACTIONS(13712),
    [anon_sym_LBRACE] = ACTIONS(13712),
    [anon_sym_RBRACE] = ACTIONS(13712),
    [anon_sym_RPAREN] = ACTIONS(13712),
    [anon_sym_DOT] = ACTIONS(13714),
    [anon_sym_COMMA] = ACTIONS(13712),
    [anon_sym_PIPE] = ACTIONS(13714),
    [anon_sym_SEMI] = ACTIONS(13712),
    [anon_sym_STAR_STAR] = ACTIONS(13714),
    [anon_sym_AMP] = ACTIONS(13714),
    [anon_sym_EQ] = ACTIONS(13714),
    [anon_sym_LT] = ACTIONS(13714),
    [anon_sym_end] = ACTIONS(13712),
    [anon_sym_if] = ACTIONS(13712),
    [anon_sym_unless] = ACTIONS(13712),
    [anon_sym_while] = ACTIONS(13712),
    [anon_sym_until] = ACTIONS(13712),
    [anon_sym_rescue] = ACTIONS(13712),
    [anon_sym_do] = ACTIONS(13712),
    [anon_sym_when] = ACTIONS(13712),
    [anon_sym_elsif] = ACTIONS(13712),
    [anon_sym_else] = ACTIONS(13712),
    [anon_sym_then] = ACTIONS(13712),
    [anon_sym_ensure] = ACTIONS(13712),
    [anon_sym_LBRACK] = ACTIONS(13712),
    [anon_sym_COLON_COLON2] = ACTIONS(13712),
    [anon_sym_AMP_DOT] = ACTIONS(13712),
    [anon_sym_PLUS_EQ] = ACTIONS(13712),
    [anon_sym_DASH_EQ] = ACTIONS(13712),
    [anon_sym_STAR_EQ] = ACTIONS(13712),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13712),
    [anon_sym_SLASH_EQ] = ACTIONS(13712),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13712),
    [anon_sym_PIPE_EQ] = ACTIONS(13712),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13712),
    [anon_sym_AMP_EQ] = ACTIONS(13712),
    [anon_sym_PERCENT_EQ] = ACTIONS(13712),
    [anon_sym_GT_GT_EQ] = ACTIONS(13712),
    [anon_sym_LT_LT_EQ] = ACTIONS(13712),
    [anon_sym_CARET_EQ] = ACTIONS(13712),
    [anon_sym_QMARK] = ACTIONS(13712),
    [anon_sym_DOT_DOT] = ACTIONS(13714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13712),
    [anon_sym_and] = ACTIONS(13712),
    [anon_sym_or] = ACTIONS(13712),
    [anon_sym_PIPE_PIPE] = ACTIONS(13714),
    [anon_sym_AMP_AMP] = ACTIONS(13714),
    [anon_sym_LT_LT] = ACTIONS(13714),
    [anon_sym_GT_GT] = ACTIONS(13714),
    [anon_sym_EQ_EQ] = ACTIONS(13714),
    [anon_sym_BANG_EQ] = ACTIONS(13712),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13712),
    [anon_sym_LT_EQ_GT] = ACTIONS(13712),
    [anon_sym_EQ_TILDE] = ACTIONS(13712),
    [anon_sym_BANG_TILDE] = ACTIONS(13712),
    [anon_sym_LT_EQ] = ACTIONS(13714),
    [anon_sym_GT] = ACTIONS(13714),
    [anon_sym_GT_EQ] = ACTIONS(13712),
    [anon_sym_CARET] = ACTIONS(13714),
    [anon_sym_PLUS] = ACTIONS(13714),
    [anon_sym_SLASH] = ACTIONS(13714),
    [anon_sym_PERCENT] = ACTIONS(13714),
    [sym_comment] = ACTIONS(87),
  },
  [8671] = {
    [anon_sym_end] = ACTIONS(13790),
    [sym_comment] = ACTIONS(87),
  },
  [8672] = {
    [sym__line_break] = ACTIONS(11404),
    [sym__heredoc_body_start] = ACTIONS(11404),
    [sym__binary_minus] = ACTIONS(11404),
    [sym__binary_star] = ACTIONS(11404),
    [ts_builtin_sym_end] = ACTIONS(11404),
    [anon_sym___END__] = ACTIONS(11404),
    [anon_sym_LBRACE] = ACTIONS(11404),
    [anon_sym_RBRACE] = ACTIONS(11404),
    [anon_sym_RPAREN] = ACTIONS(11404),
    [anon_sym_DOT] = ACTIONS(11406),
    [anon_sym_COMMA] = ACTIONS(11404),
    [anon_sym_PIPE] = ACTIONS(11406),
    [anon_sym_SEMI] = ACTIONS(11404),
    [anon_sym_STAR_STAR] = ACTIONS(11406),
    [anon_sym_AMP] = ACTIONS(11406),
    [anon_sym_EQ] = ACTIONS(11406),
    [anon_sym_LT] = ACTIONS(11406),
    [anon_sym_end] = ACTIONS(11404),
    [anon_sym_if] = ACTIONS(11404),
    [anon_sym_unless] = ACTIONS(11404),
    [anon_sym_while] = ACTIONS(11404),
    [anon_sym_until] = ACTIONS(11404),
    [anon_sym_rescue] = ACTIONS(11404),
    [anon_sym_do] = ACTIONS(11404),
    [anon_sym_when] = ACTIONS(11404),
    [anon_sym_elsif] = ACTIONS(11404),
    [anon_sym_else] = ACTIONS(11404),
    [anon_sym_then] = ACTIONS(11404),
    [anon_sym_ensure] = ACTIONS(11404),
    [anon_sym_EQ_GT] = ACTIONS(11404),
    [anon_sym_LBRACK] = ACTIONS(11404),
    [anon_sym_COLON_COLON2] = ACTIONS(11404),
    [anon_sym_AMP_DOT] = ACTIONS(11404),
    [anon_sym_PLUS_EQ] = ACTIONS(11404),
    [anon_sym_DASH_EQ] = ACTIONS(11404),
    [anon_sym_STAR_EQ] = ACTIONS(11404),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11404),
    [anon_sym_SLASH_EQ] = ACTIONS(11404),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11404),
    [anon_sym_PIPE_EQ] = ACTIONS(11404),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11404),
    [anon_sym_AMP_EQ] = ACTIONS(11404),
    [anon_sym_PERCENT_EQ] = ACTIONS(11404),
    [anon_sym_GT_GT_EQ] = ACTIONS(11404),
    [anon_sym_LT_LT_EQ] = ACTIONS(11404),
    [anon_sym_CARET_EQ] = ACTIONS(11404),
    [anon_sym_QMARK] = ACTIONS(11404),
    [anon_sym_DOT_DOT] = ACTIONS(11406),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11404),
    [anon_sym_and] = ACTIONS(11404),
    [anon_sym_or] = ACTIONS(11404),
    [anon_sym_PIPE_PIPE] = ACTIONS(11406),
    [anon_sym_AMP_AMP] = ACTIONS(11406),
    [anon_sym_LT_LT] = ACTIONS(11406),
    [anon_sym_GT_GT] = ACTIONS(11406),
    [anon_sym_EQ_EQ] = ACTIONS(11406),
    [anon_sym_BANG_EQ] = ACTIONS(11404),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11404),
    [anon_sym_LT_EQ_GT] = ACTIONS(11404),
    [anon_sym_EQ_TILDE] = ACTIONS(11404),
    [anon_sym_BANG_TILDE] = ACTIONS(11404),
    [anon_sym_LT_EQ] = ACTIONS(11406),
    [anon_sym_GT] = ACTIONS(11406),
    [anon_sym_GT_EQ] = ACTIONS(11404),
    [anon_sym_CARET] = ACTIONS(11406),
    [anon_sym_PLUS] = ACTIONS(11406),
    [anon_sym_SLASH] = ACTIONS(11406),
    [anon_sym_PERCENT] = ACTIONS(11406),
    [sym_comment] = ACTIONS(87),
  },
  [8673] = {
    [anon_sym_end] = ACTIONS(13792),
    [sym_comment] = ACTIONS(87),
  },
  [8674] = {
    [sym_when] = STATE(2988),
    [sym_else] = STATE(10087),
    [aux_sym_case_repeat2] = STATE(2988),
    [anon_sym_end] = ACTIONS(13792),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [8675] = {
    [sym__line_break] = ACTIONS(11846),
    [sym__heredoc_body_start] = ACTIONS(11846),
    [sym__binary_minus] = ACTIONS(11846),
    [sym__binary_star] = ACTIONS(11846),
    [ts_builtin_sym_end] = ACTIONS(11846),
    [anon_sym___END__] = ACTIONS(11846),
    [anon_sym_LBRACE] = ACTIONS(11846),
    [anon_sym_RBRACE] = ACTIONS(11846),
    [anon_sym_RPAREN] = ACTIONS(11846),
    [anon_sym_DOT] = ACTIONS(11848),
    [anon_sym_COMMA] = ACTIONS(11846),
    [anon_sym_PIPE] = ACTIONS(11848),
    [anon_sym_SEMI] = ACTIONS(11846),
    [anon_sym_STAR_STAR] = ACTIONS(11848),
    [anon_sym_AMP] = ACTIONS(11848),
    [anon_sym_EQ] = ACTIONS(11848),
    [anon_sym_LT] = ACTIONS(11848),
    [anon_sym_end] = ACTIONS(11846),
    [anon_sym_if] = ACTIONS(11846),
    [anon_sym_unless] = ACTIONS(11846),
    [anon_sym_while] = ACTIONS(11846),
    [anon_sym_until] = ACTIONS(11846),
    [anon_sym_rescue] = ACTIONS(11846),
    [anon_sym_do] = ACTIONS(11846),
    [anon_sym_when] = ACTIONS(11846),
    [anon_sym_elsif] = ACTIONS(11846),
    [anon_sym_else] = ACTIONS(11846),
    [anon_sym_then] = ACTIONS(11846),
    [anon_sym_ensure] = ACTIONS(11846),
    [anon_sym_EQ_GT] = ACTIONS(11846),
    [anon_sym_LBRACK] = ACTIONS(11846),
    [anon_sym_COLON_COLON2] = ACTIONS(11846),
    [anon_sym_AMP_DOT] = ACTIONS(11846),
    [anon_sym_PLUS_EQ] = ACTIONS(11846),
    [anon_sym_DASH_EQ] = ACTIONS(11846),
    [anon_sym_STAR_EQ] = ACTIONS(11846),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11846),
    [anon_sym_SLASH_EQ] = ACTIONS(11846),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11846),
    [anon_sym_PIPE_EQ] = ACTIONS(11846),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11846),
    [anon_sym_AMP_EQ] = ACTIONS(11846),
    [anon_sym_PERCENT_EQ] = ACTIONS(11846),
    [anon_sym_GT_GT_EQ] = ACTIONS(11846),
    [anon_sym_LT_LT_EQ] = ACTIONS(11846),
    [anon_sym_CARET_EQ] = ACTIONS(11846),
    [anon_sym_QMARK] = ACTIONS(11846),
    [anon_sym_DOT_DOT] = ACTIONS(11848),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11846),
    [anon_sym_and] = ACTIONS(11846),
    [anon_sym_or] = ACTIONS(11846),
    [anon_sym_PIPE_PIPE] = ACTIONS(11848),
    [anon_sym_AMP_AMP] = ACTIONS(11848),
    [anon_sym_LT_LT] = ACTIONS(11848),
    [anon_sym_GT_GT] = ACTIONS(11848),
    [anon_sym_EQ_EQ] = ACTIONS(11848),
    [anon_sym_BANG_EQ] = ACTIONS(11846),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11846),
    [anon_sym_LT_EQ_GT] = ACTIONS(11846),
    [anon_sym_EQ_TILDE] = ACTIONS(11846),
    [anon_sym_BANG_TILDE] = ACTIONS(11846),
    [anon_sym_LT_EQ] = ACTIONS(11848),
    [anon_sym_GT] = ACTIONS(11848),
    [anon_sym_GT_EQ] = ACTIONS(11846),
    [anon_sym_CARET] = ACTIONS(11848),
    [anon_sym_PLUS] = ACTIONS(11848),
    [anon_sym_SLASH] = ACTIONS(11848),
    [anon_sym_PERCENT] = ACTIONS(11848),
    [sym_comment] = ACTIONS(87),
  },
  [8676] = {
    [anon_sym_end] = ACTIONS(13794),
    [sym_comment] = ACTIONS(87),
  },
  [8677] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(2687),
    [sym__binary_star] = ACTIONS(2689),
    [ts_builtin_sym_end] = ACTIONS(12120),
    [anon_sym___END__] = ACTIONS(12120),
    [anon_sym_LBRACE] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(2691),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(2693),
    [anon_sym_AMP] = ACTIONS(2695),
    [anon_sym_EQ] = ACTIONS(12879),
    [anon_sym_LT] = ACTIONS(2697),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_EQ_GT] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_PLUS_EQ] = ACTIONS(12120),
    [anon_sym_DASH_EQ] = ACTIONS(12120),
    [anon_sym_STAR_EQ] = ACTIONS(12120),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12120),
    [anon_sym_SLASH_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12120),
    [anon_sym_AMP_EQ] = ACTIONS(12120),
    [anon_sym_PERCENT_EQ] = ACTIONS(12120),
    [anon_sym_GT_GT_EQ] = ACTIONS(12120),
    [anon_sym_LT_LT_EQ] = ACTIONS(12120),
    [anon_sym_CARET_EQ] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(2699),
    [anon_sym_DOT_DOT] = ACTIONS(2701),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2703),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(2705),
    [anon_sym_AMP_AMP] = ACTIONS(2705),
    [anon_sym_LT_LT] = ACTIONS(2707),
    [anon_sym_GT_GT] = ACTIONS(2707),
    [anon_sym_EQ_EQ] = ACTIONS(2705),
    [anon_sym_BANG_EQ] = ACTIONS(2709),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2709),
    [anon_sym_LT_EQ_GT] = ACTIONS(2709),
    [anon_sym_EQ_TILDE] = ACTIONS(2709),
    [anon_sym_BANG_TILDE] = ACTIONS(2709),
    [anon_sym_LT_EQ] = ACTIONS(2697),
    [anon_sym_GT] = ACTIONS(2697),
    [anon_sym_GT_EQ] = ACTIONS(2711),
    [anon_sym_CARET] = ACTIONS(2691),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_SLASH] = ACTIONS(2693),
    [anon_sym_PERCENT] = ACTIONS(2693),
    [sym_comment] = ACTIONS(87),
  },
  [8678] = {
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [ts_builtin_sym_end] = ACTIONS(11597),
    [anon_sym___END__] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_RBRACE] = ACTIONS(11597),
    [anon_sym_RPAREN] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(11597),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_end] = ACTIONS(11597),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_when] = ACTIONS(11597),
    [anon_sym_elsif] = ACTIONS(11597),
    [anon_sym_else] = ACTIONS(11597),
    [anon_sym_then] = ACTIONS(11597),
    [anon_sym_ensure] = ACTIONS(11597),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_PLUS_EQ] = ACTIONS(11597),
    [anon_sym_DASH_EQ] = ACTIONS(11597),
    [anon_sym_STAR_EQ] = ACTIONS(11597),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11597),
    [anon_sym_SLASH_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11597),
    [anon_sym_AMP_EQ] = ACTIONS(11597),
    [anon_sym_PERCENT_EQ] = ACTIONS(11597),
    [anon_sym_GT_GT_EQ] = ACTIONS(11597),
    [anon_sym_LT_LT_EQ] = ACTIONS(11597),
    [anon_sym_CARET_EQ] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_LT] = ACTIONS(12338),
    [anon_sym_GT_GT] = ACTIONS(12338),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(12338),
    [anon_sym_PLUS] = ACTIONS(12338),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [8679] = {
    [aux_sym_exceptions_repeat1] = STATE(8679),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [ts_builtin_sym_end] = ACTIONS(11597),
    [anon_sym___END__] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(13796),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_PLUS_EQ] = ACTIONS(11597),
    [anon_sym_DASH_EQ] = ACTIONS(11597),
    [anon_sym_STAR_EQ] = ACTIONS(11597),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11597),
    [anon_sym_SLASH_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11597),
    [anon_sym_AMP_EQ] = ACTIONS(11597),
    [anon_sym_PERCENT_EQ] = ACTIONS(11597),
    [anon_sym_GT_GT_EQ] = ACTIONS(11597),
    [anon_sym_LT_LT_EQ] = ACTIONS(11597),
    [anon_sym_CARET_EQ] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_LT] = ACTIONS(12338),
    [anon_sym_GT_GT] = ACTIONS(12338),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(12338),
    [anon_sym_PLUS] = ACTIONS(12338),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [8680] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10089),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1596),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym_method_call] = STATE(1596),
    [sym_assignment] = STATE(10089),
    [sym_operator_assignment] = STATE(10089),
    [sym_conditional] = STATE(10089),
    [sym_range] = STATE(10089),
    [sym_binary] = STATE(10089),
    [sym_unary] = STATE(10089),
    [sym_left_assignment_list] = STATE(1595),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1596),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1596),
    [sym_false] = STATE(1596),
    [sym_nil] = STATE(1596),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(877),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2739),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1557),
    [anon_sym_yield] = ACTIONS(1559),
    [anon_sym_break] = ACTIONS(1561),
    [anon_sym_next] = ACTIONS(1563),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2741),
    [anon_sym_defined_QMARK] = ACTIONS(2743),
    [anon_sym_not] = ACTIONS(2745),
    [anon_sym_BANG] = ACTIONS(2747),
    [anon_sym_TILDE] = ACTIONS(2747),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8681] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(12345),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [8682] = {
    [sym_heredoc_body] = STATE(10090),
    [aux_sym_call_repeat1] = STATE(10090),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [8683] = {
    [sym_heredoc_body] = STATE(10090),
    [aux_sym_call_repeat1] = STATE(10090),
    [aux_sym_argument_list_repeat1] = STATE(10091),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(9925),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [8684] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(12343),
    [sym__binary_star] = ACTIONS(12345),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(12347),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(12345),
    [anon_sym_AMP] = ACTIONS(12349),
    [anon_sym_LT] = ACTIONS(12351),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(12353),
    [anon_sym_DOT_DOT] = ACTIONS(12355),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12357),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(12359),
    [anon_sym_AMP_AMP] = ACTIONS(12359),
    [anon_sym_LT_LT] = ACTIONS(12361),
    [anon_sym_GT_GT] = ACTIONS(12361),
    [anon_sym_EQ_EQ] = ACTIONS(12363),
    [anon_sym_BANG_EQ] = ACTIONS(12359),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12359),
    [anon_sym_LT_EQ_GT] = ACTIONS(12359),
    [anon_sym_EQ_TILDE] = ACTIONS(12359),
    [anon_sym_BANG_TILDE] = ACTIONS(12359),
    [anon_sym_LT_EQ] = ACTIONS(12351),
    [anon_sym_GT] = ACTIONS(12351),
    [anon_sym_GT_EQ] = ACTIONS(12365),
    [anon_sym_CARET] = ACTIONS(12367),
    [anon_sym_PLUS] = ACTIONS(12343),
    [anon_sym_SLASH] = ACTIONS(12345),
    [anon_sym_PERCENT] = ACTIONS(12345),
    [sym_comment] = ACTIONS(87),
  },
  [8685] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10092),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(6419),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(6419),
    [sym_assignment] = STATE(10092),
    [sym_operator_assignment] = STATE(10092),
    [sym_conditional] = STATE(10092),
    [sym_range] = STATE(10092),
    [sym_binary] = STATE(10092),
    [sym_unary] = STATE(10092),
    [sym_left_assignment_list] = STATE(6418),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6419),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(6419),
    [sym_false] = STATE(6419),
    [sym_nil] = STATE(6419),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(6420),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9859),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9861),
    [anon_sym_yield] = ACTIONS(9863),
    [anon_sym_break] = ACTIONS(9865),
    [anon_sym_next] = ACTIONS(9867),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9869),
    [anon_sym_defined_QMARK] = ACTIONS(9871),
    [anon_sym_not] = ACTIONS(9873),
    [anon_sym_BANG] = ACTIONS(9875),
    [anon_sym_TILDE] = ACTIONS(9875),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8686] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10093),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(6419),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(6419),
    [sym_assignment] = STATE(10093),
    [sym_operator_assignment] = STATE(10093),
    [sym_conditional] = STATE(10093),
    [sym_range] = STATE(10093),
    [sym_binary] = STATE(10093),
    [sym_unary] = STATE(10093),
    [sym_left_assignment_list] = STATE(6418),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6419),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(6419),
    [sym_false] = STATE(6419),
    [sym_nil] = STATE(6419),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(6420),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9859),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9861),
    [anon_sym_yield] = ACTIONS(9863),
    [anon_sym_break] = ACTIONS(9865),
    [anon_sym_next] = ACTIONS(9867),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9869),
    [anon_sym_defined_QMARK] = ACTIONS(9871),
    [anon_sym_not] = ACTIONS(9873),
    [anon_sym_BANG] = ACTIONS(9875),
    [anon_sym_TILDE] = ACTIONS(9875),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8687] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10094),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(6419),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(6419),
    [sym_assignment] = STATE(10094),
    [sym_operator_assignment] = STATE(10094),
    [sym_conditional] = STATE(10094),
    [sym_range] = STATE(10094),
    [sym_binary] = STATE(10094),
    [sym_unary] = STATE(10094),
    [sym_left_assignment_list] = STATE(6418),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6419),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(6419),
    [sym_false] = STATE(6419),
    [sym_nil] = STATE(6419),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(6420),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9859),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9861),
    [anon_sym_yield] = ACTIONS(9863),
    [anon_sym_break] = ACTIONS(9865),
    [anon_sym_next] = ACTIONS(9867),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9869),
    [anon_sym_defined_QMARK] = ACTIONS(9871),
    [anon_sym_not] = ACTIONS(9873),
    [anon_sym_BANG] = ACTIONS(9875),
    [anon_sym_TILDE] = ACTIONS(9875),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8688] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10095),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(6419),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(6419),
    [sym_assignment] = STATE(10095),
    [sym_operator_assignment] = STATE(10095),
    [sym_conditional] = STATE(10095),
    [sym_range] = STATE(10095),
    [sym_binary] = STATE(10095),
    [sym_unary] = STATE(10095),
    [sym_left_assignment_list] = STATE(6418),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6419),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(6419),
    [sym_false] = STATE(6419),
    [sym_nil] = STATE(6419),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(6420),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9859),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9861),
    [anon_sym_yield] = ACTIONS(9863),
    [anon_sym_break] = ACTIONS(9865),
    [anon_sym_next] = ACTIONS(9867),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9869),
    [anon_sym_defined_QMARK] = ACTIONS(9871),
    [anon_sym_not] = ACTIONS(9873),
    [anon_sym_BANG] = ACTIONS(9875),
    [anon_sym_TILDE] = ACTIONS(9875),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8689] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10096),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(6419),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(6419),
    [sym_assignment] = STATE(10096),
    [sym_operator_assignment] = STATE(10096),
    [sym_conditional] = STATE(10096),
    [sym_range] = STATE(10096),
    [sym_binary] = STATE(10096),
    [sym_unary] = STATE(10096),
    [sym_left_assignment_list] = STATE(6418),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6419),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(6419),
    [sym_false] = STATE(6419),
    [sym_nil] = STATE(6419),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(6420),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9859),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9861),
    [anon_sym_yield] = ACTIONS(9863),
    [anon_sym_break] = ACTIONS(9865),
    [anon_sym_next] = ACTIONS(9867),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9869),
    [anon_sym_defined_QMARK] = ACTIONS(9871),
    [anon_sym_not] = ACTIONS(9873),
    [anon_sym_BANG] = ACTIONS(9875),
    [anon_sym_TILDE] = ACTIONS(9875),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8690] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(10097),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(10097),
    [sym_operator_assignment] = STATE(10097),
    [sym_conditional] = STATE(10097),
    [sym_range] = STATE(10097),
    [sym_binary] = STATE(10097),
    [sym_unary] = STATE(10097),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8691] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10098),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(6419),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(6419),
    [sym_assignment] = STATE(10098),
    [sym_operator_assignment] = STATE(10098),
    [sym_conditional] = STATE(10098),
    [sym_range] = STATE(10098),
    [sym_binary] = STATE(10098),
    [sym_unary] = STATE(10098),
    [sym_left_assignment_list] = STATE(6418),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6419),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(6419),
    [sym_false] = STATE(6419),
    [sym_nil] = STATE(6419),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(6420),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9859),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9861),
    [anon_sym_yield] = ACTIONS(9863),
    [anon_sym_break] = ACTIONS(9865),
    [anon_sym_next] = ACTIONS(9867),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9869),
    [anon_sym_defined_QMARK] = ACTIONS(9871),
    [anon_sym_not] = ACTIONS(9873),
    [anon_sym_BANG] = ACTIONS(9875),
    [anon_sym_TILDE] = ACTIONS(9875),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8692] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10099),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(6419),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(6419),
    [sym_assignment] = STATE(10099),
    [sym_operator_assignment] = STATE(10099),
    [sym_conditional] = STATE(10099),
    [sym_range] = STATE(10099),
    [sym_binary] = STATE(10099),
    [sym_unary] = STATE(10099),
    [sym_left_assignment_list] = STATE(6418),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6419),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(6419),
    [sym_false] = STATE(6419),
    [sym_nil] = STATE(6419),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(6420),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9859),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9861),
    [anon_sym_yield] = ACTIONS(9863),
    [anon_sym_break] = ACTIONS(9865),
    [anon_sym_next] = ACTIONS(9867),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9869),
    [anon_sym_defined_QMARK] = ACTIONS(9871),
    [anon_sym_not] = ACTIONS(9873),
    [anon_sym_BANG] = ACTIONS(9875),
    [anon_sym_TILDE] = ACTIONS(9875),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8693] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10100),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(6419),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(6419),
    [sym_assignment] = STATE(10100),
    [sym_operator_assignment] = STATE(10100),
    [sym_conditional] = STATE(10100),
    [sym_range] = STATE(10100),
    [sym_binary] = STATE(10100),
    [sym_unary] = STATE(10100),
    [sym_left_assignment_list] = STATE(6418),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6419),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(6419),
    [sym_false] = STATE(6419),
    [sym_nil] = STATE(6419),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(6420),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9859),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9861),
    [anon_sym_yield] = ACTIONS(9863),
    [anon_sym_break] = ACTIONS(9865),
    [anon_sym_next] = ACTIONS(9867),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9869),
    [anon_sym_defined_QMARK] = ACTIONS(9871),
    [anon_sym_not] = ACTIONS(9873),
    [anon_sym_BANG] = ACTIONS(9875),
    [anon_sym_TILDE] = ACTIONS(9875),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8694] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10101),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(6419),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(6419),
    [sym_assignment] = STATE(10101),
    [sym_operator_assignment] = STATE(10101),
    [sym_conditional] = STATE(10101),
    [sym_range] = STATE(10101),
    [sym_binary] = STATE(10101),
    [sym_unary] = STATE(10101),
    [sym_left_assignment_list] = STATE(6418),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6419),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(6419),
    [sym_false] = STATE(6419),
    [sym_nil] = STATE(6419),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(6420),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9859),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9861),
    [anon_sym_yield] = ACTIONS(9863),
    [anon_sym_break] = ACTIONS(9865),
    [anon_sym_next] = ACTIONS(9867),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9869),
    [anon_sym_defined_QMARK] = ACTIONS(9871),
    [anon_sym_not] = ACTIONS(9873),
    [anon_sym_BANG] = ACTIONS(9875),
    [anon_sym_TILDE] = ACTIONS(9875),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8695] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10102),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(6419),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(6419),
    [sym_splat_argument] = STATE(10103),
    [sym_assignment] = STATE(10102),
    [sym_operator_assignment] = STATE(10102),
    [sym_conditional] = STATE(10102),
    [sym_range] = STATE(10102),
    [sym_binary] = STATE(10102),
    [sym_unary] = STATE(10102),
    [sym_right_assignment_list] = STATE(2570),
    [sym__arg_or_splat_arg] = STATE(10103),
    [sym_left_assignment_list] = STATE(6418),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6419),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(6419),
    [sym_false] = STATE(6419),
    [sym_nil] = STATE(6419),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(6420),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(6243),
    [sym__unary_minus] = ACTIONS(9859),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9861),
    [anon_sym_yield] = ACTIONS(9863),
    [anon_sym_break] = ACTIONS(9865),
    [anon_sym_next] = ACTIONS(9867),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9869),
    [anon_sym_defined_QMARK] = ACTIONS(9871),
    [anon_sym_not] = ACTIONS(9873),
    [anon_sym_BANG] = ACTIONS(9875),
    [anon_sym_TILDE] = ACTIONS(9875),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8696] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10104),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(6419),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(6419),
    [sym_assignment] = STATE(10104),
    [sym_operator_assignment] = STATE(10104),
    [sym_conditional] = STATE(10104),
    [sym_range] = STATE(10104),
    [sym_binary] = STATE(10104),
    [sym_unary] = STATE(10104),
    [sym_left_assignment_list] = STATE(6418),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6419),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(6419),
    [sym_false] = STATE(6419),
    [sym_nil] = STATE(6419),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(6420),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9859),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9861),
    [anon_sym_yield] = ACTIONS(9863),
    [anon_sym_break] = ACTIONS(9865),
    [anon_sym_next] = ACTIONS(9867),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9869),
    [anon_sym_defined_QMARK] = ACTIONS(9871),
    [anon_sym_not] = ACTIONS(9873),
    [anon_sym_BANG] = ACTIONS(9875),
    [anon_sym_TILDE] = ACTIONS(9875),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8697] = {
    [sym_string] = STATE(10105),
    [aux_sym_chained_string_repeat1] = STATE(10105),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [8698] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(12343),
    [sym__binary_star] = ACTIONS(12345),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(12347),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(12345),
    [anon_sym_AMP] = ACTIONS(12349),
    [anon_sym_LT] = ACTIONS(12351),
    [anon_sym_if] = ACTIONS(6823),
    [anon_sym_unless] = ACTIONS(6823),
    [anon_sym_while] = ACTIONS(6823),
    [anon_sym_until] = ACTIONS(6823),
    [anon_sym_rescue] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(12353),
    [anon_sym_DOT_DOT] = ACTIONS(12355),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12357),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(12359),
    [anon_sym_AMP_AMP] = ACTIONS(12359),
    [anon_sym_LT_LT] = ACTIONS(12361),
    [anon_sym_GT_GT] = ACTIONS(12361),
    [anon_sym_EQ_EQ] = ACTIONS(12363),
    [anon_sym_BANG_EQ] = ACTIONS(12359),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12359),
    [anon_sym_LT_EQ_GT] = ACTIONS(12359),
    [anon_sym_EQ_TILDE] = ACTIONS(12359),
    [anon_sym_BANG_TILDE] = ACTIONS(12359),
    [anon_sym_LT_EQ] = ACTIONS(12351),
    [anon_sym_GT] = ACTIONS(12351),
    [anon_sym_GT_EQ] = ACTIONS(12365),
    [anon_sym_CARET] = ACTIONS(12367),
    [anon_sym_PLUS] = ACTIONS(12343),
    [anon_sym_SLASH] = ACTIONS(12345),
    [anon_sym_PERCENT] = ACTIONS(12345),
    [sym_comment] = ACTIONS(87),
  },
  [8699] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(9891),
    [sym__binary_star] = ACTIONS(9893),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(9895),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(9893),
    [anon_sym_AMP] = ACTIONS(9897),
    [anon_sym_LT] = ACTIONS(9899),
    [anon_sym_if] = ACTIONS(4211),
    [anon_sym_unless] = ACTIONS(4211),
    [anon_sym_while] = ACTIONS(4211),
    [anon_sym_until] = ACTIONS(4211),
    [anon_sym_rescue] = ACTIONS(4211),
    [anon_sym_EQ_GT] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(9901),
    [anon_sym_DOT_DOT] = ACTIONS(9903),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9905),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(9907),
    [anon_sym_AMP_AMP] = ACTIONS(9907),
    [anon_sym_LT_LT] = ACTIONS(9909),
    [anon_sym_GT_GT] = ACTIONS(9909),
    [anon_sym_EQ_EQ] = ACTIONS(9911),
    [anon_sym_BANG_EQ] = ACTIONS(9907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9907),
    [anon_sym_LT_EQ_GT] = ACTIONS(9907),
    [anon_sym_EQ_TILDE] = ACTIONS(9907),
    [anon_sym_BANG_TILDE] = ACTIONS(9907),
    [anon_sym_LT_EQ] = ACTIONS(9899),
    [anon_sym_GT] = ACTIONS(9899),
    [anon_sym_GT_EQ] = ACTIONS(9913),
    [anon_sym_CARET] = ACTIONS(9915),
    [anon_sym_PLUS] = ACTIONS(9891),
    [anon_sym_SLASH] = ACTIONS(9893),
    [anon_sym_PERCENT] = ACTIONS(9893),
    [sym_comment] = ACTIONS(87),
  },
  [8700] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(9891),
    [sym__binary_star] = ACTIONS(9893),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(9895),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(9893),
    [anon_sym_AMP] = ACTIONS(9897),
    [anon_sym_LT] = ACTIONS(9899),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_EQ_GT] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(9901),
    [anon_sym_DOT_DOT] = ACTIONS(9903),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9905),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(9907),
    [anon_sym_AMP_AMP] = ACTIONS(9907),
    [anon_sym_LT_LT] = ACTIONS(9909),
    [anon_sym_GT_GT] = ACTIONS(9909),
    [anon_sym_EQ_EQ] = ACTIONS(9911),
    [anon_sym_BANG_EQ] = ACTIONS(9907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9907),
    [anon_sym_LT_EQ_GT] = ACTIONS(9907),
    [anon_sym_EQ_TILDE] = ACTIONS(9907),
    [anon_sym_BANG_TILDE] = ACTIONS(9907),
    [anon_sym_LT_EQ] = ACTIONS(9899),
    [anon_sym_GT] = ACTIONS(9899),
    [anon_sym_GT_EQ] = ACTIONS(9913),
    [anon_sym_CARET] = ACTIONS(9915),
    [anon_sym_PLUS] = ACTIONS(9891),
    [anon_sym_SLASH] = ACTIONS(9893),
    [anon_sym_PERCENT] = ACTIONS(9893),
    [sym_comment] = ACTIONS(87),
  },
  [8701] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10106),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3782),
    [sym_scope_resolution] = STATE(3778),
    [sym_call] = STATE(3778),
    [sym_method_call] = STATE(3782),
    [sym_assignment] = STATE(10106),
    [sym_operator_assignment] = STATE(10106),
    [sym_conditional] = STATE(10106),
    [sym_range] = STATE(10106),
    [sym_binary] = STATE(10106),
    [sym_unary] = STATE(10106),
    [sym_left_assignment_list] = STATE(3781),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3782),
    [sym__variable] = STATE(3778),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3782),
    [sym_false] = STATE(3782),
    [sym_nil] = STATE(3782),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(6423),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(6245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6249),
    [anon_sym_yield] = ACTIONS(6251),
    [anon_sym_break] = ACTIONS(6253),
    [anon_sym_next] = ACTIONS(6255),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9877),
    [anon_sym_defined_QMARK] = ACTIONS(6257),
    [anon_sym_not] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(6263),
    [anon_sym_TILDE] = ACTIONS(6263),
    [sym_constant] = ACTIONS(6269),
    [sym_identifier] = ACTIONS(6269),
    [sym_instance_variable] = ACTIONS(6267),
    [sym_class_variable] = ACTIONS(6267),
    [sym_global_variable] = ACTIONS(6267),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(6269),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6269),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8702] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(9891),
    [sym__binary_star] = ACTIONS(9893),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(9895),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(9893),
    [anon_sym_AMP] = ACTIONS(9897),
    [anon_sym_LT] = ACTIONS(9899),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_unless] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_until] = ACTIONS(3281),
    [anon_sym_rescue] = ACTIONS(3281),
    [anon_sym_EQ_GT] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(9901),
    [anon_sym_DOT_DOT] = ACTIONS(9903),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9905),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(9907),
    [anon_sym_AMP_AMP] = ACTIONS(9907),
    [anon_sym_LT_LT] = ACTIONS(9909),
    [anon_sym_GT_GT] = ACTIONS(9909),
    [anon_sym_EQ_EQ] = ACTIONS(9911),
    [anon_sym_BANG_EQ] = ACTIONS(9907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9907),
    [anon_sym_LT_EQ_GT] = ACTIONS(9907),
    [anon_sym_EQ_TILDE] = ACTIONS(9907),
    [anon_sym_BANG_TILDE] = ACTIONS(9907),
    [anon_sym_LT_EQ] = ACTIONS(9899),
    [anon_sym_GT] = ACTIONS(9899),
    [anon_sym_GT_EQ] = ACTIONS(9913),
    [anon_sym_CARET] = ACTIONS(9915),
    [anon_sym_PLUS] = ACTIONS(9891),
    [anon_sym_SLASH] = ACTIONS(9893),
    [anon_sym_PERCENT] = ACTIONS(9893),
    [sym_comment] = ACTIONS(87),
  },
  [8703] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10107),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3782),
    [sym_scope_resolution] = STATE(3778),
    [sym_call] = STATE(3778),
    [sym_method_call] = STATE(3782),
    [sym_assignment] = STATE(10107),
    [sym_operator_assignment] = STATE(10107),
    [sym_conditional] = STATE(10107),
    [sym_range] = STATE(10107),
    [sym_binary] = STATE(10107),
    [sym_unary] = STATE(10107),
    [sym_left_assignment_list] = STATE(3781),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3782),
    [sym__variable] = STATE(3778),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3782),
    [sym_false] = STATE(3782),
    [sym_nil] = STATE(3782),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(6423),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(6245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6249),
    [anon_sym_yield] = ACTIONS(6251),
    [anon_sym_break] = ACTIONS(6253),
    [anon_sym_next] = ACTIONS(6255),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9877),
    [anon_sym_defined_QMARK] = ACTIONS(6257),
    [anon_sym_not] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(6263),
    [anon_sym_TILDE] = ACTIONS(6263),
    [sym_constant] = ACTIONS(6269),
    [sym_identifier] = ACTIONS(6269),
    [sym_instance_variable] = ACTIONS(6267),
    [sym_class_variable] = ACTIONS(6267),
    [sym_global_variable] = ACTIONS(6267),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(6269),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6269),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8704] = {
    [sym_heredoc_body] = STATE(10108),
    [aux_sym_call_repeat1] = STATE(10108),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [8705] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6431),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3782),
    [sym_scope_resolution] = STATE(3778),
    [sym_call] = STATE(3778),
    [sym_method_call] = STATE(3782),
    [sym__argument] = STATE(2565),
    [sym_splat_argument] = STATE(2565),
    [sym_hash_splat_argument] = STATE(2565),
    [sym_block_argument] = STATE(2565),
    [sym_assignment] = STATE(6431),
    [sym_operator_assignment] = STATE(6431),
    [sym_conditional] = STATE(6431),
    [sym_range] = STATE(6431),
    [sym_binary] = STATE(6431),
    [sym_unary] = STATE(6431),
    [sym_left_assignment_list] = STATE(3781),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3782),
    [sym__variable] = STATE(3778),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3782),
    [sym_false] = STATE(3782),
    [sym_nil] = STATE(3782),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(6434),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(10109),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2565),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(9881),
    [sym__splat_star] = ACTIONS(9883),
    [sym__unary_minus] = ACTIONS(6245),
    [sym__identifier_hash_key] = ACTIONS(9885),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13799),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6249),
    [anon_sym_yield] = ACTIONS(6251),
    [anon_sym_break] = ACTIONS(6253),
    [anon_sym_next] = ACTIONS(6255),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9877),
    [anon_sym_defined_QMARK] = ACTIONS(6257),
    [anon_sym_not] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(6263),
    [anon_sym_TILDE] = ACTIONS(6263),
    [sym_constant] = ACTIONS(9887),
    [sym_identifier] = ACTIONS(9887),
    [sym_instance_variable] = ACTIONS(6267),
    [sym_class_variable] = ACTIONS(6267),
    [sym_global_variable] = ACTIONS(6267),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(6269),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6269),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8706] = {
    [sym_heredoc_body] = STATE(10110),
    [aux_sym_call_repeat1] = STATE(10110),
    [aux_sym_argument_list_repeat1] = STATE(10111),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(12379),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [8707] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(12343),
    [sym__binary_star] = ACTIONS(12345),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(12347),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(12345),
    [anon_sym_AMP] = ACTIONS(12349),
    [anon_sym_LT] = ACTIONS(12351),
    [anon_sym_if] = ACTIONS(7027),
    [anon_sym_unless] = ACTIONS(7027),
    [anon_sym_while] = ACTIONS(7027),
    [anon_sym_until] = ACTIONS(7027),
    [anon_sym_rescue] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(12353),
    [anon_sym_DOT_DOT] = ACTIONS(12355),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12357),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(12359),
    [anon_sym_AMP_AMP] = ACTIONS(12359),
    [anon_sym_LT_LT] = ACTIONS(12361),
    [anon_sym_GT_GT] = ACTIONS(12361),
    [anon_sym_EQ_EQ] = ACTIONS(12363),
    [anon_sym_BANG_EQ] = ACTIONS(12359),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12359),
    [anon_sym_LT_EQ_GT] = ACTIONS(12359),
    [anon_sym_EQ_TILDE] = ACTIONS(12359),
    [anon_sym_BANG_TILDE] = ACTIONS(12359),
    [anon_sym_LT_EQ] = ACTIONS(12351),
    [anon_sym_GT] = ACTIONS(12351),
    [anon_sym_GT_EQ] = ACTIONS(12365),
    [anon_sym_CARET] = ACTIONS(12367),
    [anon_sym_PLUS] = ACTIONS(12343),
    [anon_sym_SLASH] = ACTIONS(12345),
    [anon_sym_PERCENT] = ACTIONS(12345),
    [sym_comment] = ACTIONS(87),
  },
  [8708] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(9893),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(9893),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(9893),
    [anon_sym_PERCENT] = ACTIONS(9893),
    [sym_comment] = ACTIONS(87),
  },
  [8709] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(9893),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [8710] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(9891),
    [sym__binary_star] = ACTIONS(9893),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(9893),
    [anon_sym_AMP] = ACTIONS(9897),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(9909),
    [anon_sym_GT_GT] = ACTIONS(9909),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(9891),
    [anon_sym_SLASH] = ACTIONS(9893),
    [anon_sym_PERCENT] = ACTIONS(9893),
    [sym_comment] = ACTIONS(87),
  },
  [8711] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(9891),
    [sym__binary_star] = ACTIONS(9893),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(9893),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(9909),
    [anon_sym_GT_GT] = ACTIONS(9909),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(9891),
    [anon_sym_SLASH] = ACTIONS(9893),
    [anon_sym_PERCENT] = ACTIONS(9893),
    [sym_comment] = ACTIONS(87),
  },
  [8712] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(9891),
    [sym__binary_star] = ACTIONS(9893),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(9895),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(9893),
    [anon_sym_AMP] = ACTIONS(9897),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(9909),
    [anon_sym_GT_GT] = ACTIONS(9909),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(9915),
    [anon_sym_PLUS] = ACTIONS(9891),
    [anon_sym_SLASH] = ACTIONS(9893),
    [anon_sym_PERCENT] = ACTIONS(9893),
    [sym_comment] = ACTIONS(87),
  },
  [8713] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(13801),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [8714] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(9891),
    [sym__binary_star] = ACTIONS(9893),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(9895),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(9893),
    [anon_sym_AMP] = ACTIONS(9897),
    [anon_sym_LT] = ACTIONS(9899),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_EQ_GT] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(9903),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9905),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(9907),
    [anon_sym_AMP_AMP] = ACTIONS(9907),
    [anon_sym_LT_LT] = ACTIONS(9909),
    [anon_sym_GT_GT] = ACTIONS(9909),
    [anon_sym_EQ_EQ] = ACTIONS(9911),
    [anon_sym_BANG_EQ] = ACTIONS(9907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9907),
    [anon_sym_LT_EQ_GT] = ACTIONS(9907),
    [anon_sym_EQ_TILDE] = ACTIONS(9907),
    [anon_sym_BANG_TILDE] = ACTIONS(9907),
    [anon_sym_LT_EQ] = ACTIONS(9899),
    [anon_sym_GT] = ACTIONS(9899),
    [anon_sym_GT_EQ] = ACTIONS(9913),
    [anon_sym_CARET] = ACTIONS(9915),
    [anon_sym_PLUS] = ACTIONS(9891),
    [anon_sym_SLASH] = ACTIONS(9893),
    [anon_sym_PERCENT] = ACTIONS(9893),
    [sym_comment] = ACTIONS(87),
  },
  [8715] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(9891),
    [sym__binary_star] = ACTIONS(9893),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(9895),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(9893),
    [anon_sym_AMP] = ACTIONS(9897),
    [anon_sym_LT] = ACTIONS(9899),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(9901),
    [anon_sym_DOT_DOT] = ACTIONS(9903),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9905),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(9907),
    [anon_sym_AMP_AMP] = ACTIONS(9907),
    [anon_sym_LT_LT] = ACTIONS(9909),
    [anon_sym_GT_GT] = ACTIONS(9909),
    [anon_sym_EQ_EQ] = ACTIONS(9911),
    [anon_sym_BANG_EQ] = ACTIONS(9907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9907),
    [anon_sym_LT_EQ_GT] = ACTIONS(9907),
    [anon_sym_EQ_TILDE] = ACTIONS(9907),
    [anon_sym_BANG_TILDE] = ACTIONS(9907),
    [anon_sym_LT_EQ] = ACTIONS(9899),
    [anon_sym_GT] = ACTIONS(9899),
    [anon_sym_GT_EQ] = ACTIONS(9913),
    [anon_sym_CARET] = ACTIONS(9915),
    [anon_sym_PLUS] = ACTIONS(9891),
    [anon_sym_SLASH] = ACTIONS(9893),
    [anon_sym_PERCENT] = ACTIONS(9893),
    [sym_comment] = ACTIONS(87),
  },
  [8716] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(9891),
    [sym__binary_star] = ACTIONS(9893),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(9895),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(9893),
    [anon_sym_AMP] = ACTIONS(9897),
    [anon_sym_LT] = ACTIONS(9899),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(9909),
    [anon_sym_GT_GT] = ACTIONS(9909),
    [anon_sym_EQ_EQ] = ACTIONS(9911),
    [anon_sym_BANG_EQ] = ACTIONS(9907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9907),
    [anon_sym_LT_EQ_GT] = ACTIONS(9907),
    [anon_sym_EQ_TILDE] = ACTIONS(9907),
    [anon_sym_BANG_TILDE] = ACTIONS(9907),
    [anon_sym_LT_EQ] = ACTIONS(9899),
    [anon_sym_GT] = ACTIONS(9899),
    [anon_sym_GT_EQ] = ACTIONS(9913),
    [anon_sym_CARET] = ACTIONS(9915),
    [anon_sym_PLUS] = ACTIONS(9891),
    [anon_sym_SLASH] = ACTIONS(9893),
    [anon_sym_PERCENT] = ACTIONS(9893),
    [sym_comment] = ACTIONS(87),
  },
  [8717] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(9891),
    [sym__binary_star] = ACTIONS(9893),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(9893),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(9891),
    [anon_sym_SLASH] = ACTIONS(9893),
    [anon_sym_PERCENT] = ACTIONS(9893),
    [sym_comment] = ACTIONS(87),
  },
  [8718] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(9963),
    [sym__binary_star] = ACTIONS(9965),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(9967),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(9969),
    [anon_sym_AMP] = ACTIONS(9971),
    [anon_sym_EQ] = ACTIONS(4217),
    [anon_sym_LT] = ACTIONS(9973),
    [anon_sym_if] = ACTIONS(4211),
    [anon_sym_unless] = ACTIONS(4211),
    [anon_sym_while] = ACTIONS(4211),
    [anon_sym_until] = ACTIONS(4211),
    [anon_sym_rescue] = ACTIONS(4211),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_EQ_GT] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_PLUS_EQ] = ACTIONS(4211),
    [anon_sym_DASH_EQ] = ACTIONS(4211),
    [anon_sym_STAR_EQ] = ACTIONS(4211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4211),
    [anon_sym_SLASH_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4211),
    [anon_sym_AMP_EQ] = ACTIONS(4211),
    [anon_sym_PERCENT_EQ] = ACTIONS(4211),
    [anon_sym_GT_GT_EQ] = ACTIONS(4211),
    [anon_sym_LT_LT_EQ] = ACTIONS(4211),
    [anon_sym_CARET_EQ] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(9975),
    [anon_sym_DOT_DOT] = ACTIONS(9977),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9979),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(9981),
    [anon_sym_AMP_AMP] = ACTIONS(9981),
    [anon_sym_LT_LT] = ACTIONS(9983),
    [anon_sym_GT_GT] = ACTIONS(9983),
    [anon_sym_EQ_EQ] = ACTIONS(9981),
    [anon_sym_BANG_EQ] = ACTIONS(9985),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9985),
    [anon_sym_LT_EQ_GT] = ACTIONS(9985),
    [anon_sym_EQ_TILDE] = ACTIONS(9985),
    [anon_sym_BANG_TILDE] = ACTIONS(9985),
    [anon_sym_LT_EQ] = ACTIONS(9973),
    [anon_sym_GT] = ACTIONS(9973),
    [anon_sym_GT_EQ] = ACTIONS(9987),
    [anon_sym_CARET] = ACTIONS(9967),
    [anon_sym_PLUS] = ACTIONS(9989),
    [anon_sym_SLASH] = ACTIONS(9969),
    [anon_sym_PERCENT] = ACTIONS(9969),
    [sym_comment] = ACTIONS(87),
  },
  [8719] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(9963),
    [sym__binary_star] = ACTIONS(9965),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(9967),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(9969),
    [anon_sym_AMP] = ACTIONS(9971),
    [anon_sym_EQ] = ACTIONS(4249),
    [anon_sym_LT] = ACTIONS(9973),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_EQ_GT] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_PLUS_EQ] = ACTIONS(4247),
    [anon_sym_DASH_EQ] = ACTIONS(4247),
    [anon_sym_STAR_EQ] = ACTIONS(4247),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4247),
    [anon_sym_SLASH_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4247),
    [anon_sym_AMP_EQ] = ACTIONS(4247),
    [anon_sym_PERCENT_EQ] = ACTIONS(4247),
    [anon_sym_GT_GT_EQ] = ACTIONS(4247),
    [anon_sym_LT_LT_EQ] = ACTIONS(4247),
    [anon_sym_CARET_EQ] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(9975),
    [anon_sym_DOT_DOT] = ACTIONS(9977),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9979),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(9981),
    [anon_sym_AMP_AMP] = ACTIONS(9981),
    [anon_sym_LT_LT] = ACTIONS(9983),
    [anon_sym_GT_GT] = ACTIONS(9983),
    [anon_sym_EQ_EQ] = ACTIONS(9981),
    [anon_sym_BANG_EQ] = ACTIONS(9985),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9985),
    [anon_sym_LT_EQ_GT] = ACTIONS(9985),
    [anon_sym_EQ_TILDE] = ACTIONS(9985),
    [anon_sym_BANG_TILDE] = ACTIONS(9985),
    [anon_sym_LT_EQ] = ACTIONS(9973),
    [anon_sym_GT] = ACTIONS(9973),
    [anon_sym_GT_EQ] = ACTIONS(9987),
    [anon_sym_CARET] = ACTIONS(9967),
    [anon_sym_PLUS] = ACTIONS(9989),
    [anon_sym_SLASH] = ACTIONS(9969),
    [anon_sym_PERCENT] = ACTIONS(9969),
    [sym_comment] = ACTIONS(87),
  },
  [8720] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(10113),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3818),
    [sym_scope_resolution] = STATE(3814),
    [sym_call] = STATE(3814),
    [sym_method_call] = STATE(3818),
    [sym_assignment] = STATE(10113),
    [sym_operator_assignment] = STATE(10113),
    [sym_conditional] = STATE(10113),
    [sym_range] = STATE(10113),
    [sym_binary] = STATE(10113),
    [sym_unary] = STATE(10113),
    [sym_left_assignment_list] = STATE(3817),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3818),
    [sym__variable] = STATE(3814),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3818),
    [sym_false] = STATE(3818),
    [sym_nil] = STATE(3818),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(6492),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(6319),
    [anon_sym_yield] = ACTIONS(6321),
    [anon_sym_break] = ACTIONS(6323),
    [anon_sym_next] = ACTIONS(6325),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(9957),
    [anon_sym_defined_QMARK] = ACTIONS(6327),
    [anon_sym_not] = ACTIONS(6329),
    [anon_sym_BANG] = ACTIONS(6333),
    [anon_sym_TILDE] = ACTIONS(6333),
    [sym_constant] = ACTIONS(6339),
    [sym_identifier] = ACTIONS(6339),
    [sym_instance_variable] = ACTIONS(6337),
    [sym_class_variable] = ACTIONS(6337),
    [sym_global_variable] = ACTIONS(6337),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(6339),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6339),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [8721] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(9963),
    [sym__binary_star] = ACTIONS(9965),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(9967),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(9969),
    [anon_sym_AMP] = ACTIONS(9971),
    [anon_sym_EQ] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(9973),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_unless] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_until] = ACTIONS(3281),
    [anon_sym_rescue] = ACTIONS(3281),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_EQ_GT] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_PLUS_EQ] = ACTIONS(3281),
    [anon_sym_DASH_EQ] = ACTIONS(3281),
    [anon_sym_STAR_EQ] = ACTIONS(3281),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3281),
    [anon_sym_SLASH_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3281),
    [anon_sym_AMP_EQ] = ACTIONS(3281),
    [anon_sym_PERCENT_EQ] = ACTIONS(3281),
    [anon_sym_GT_GT_EQ] = ACTIONS(3281),
    [anon_sym_LT_LT_EQ] = ACTIONS(3281),
    [anon_sym_CARET_EQ] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(9975),
    [anon_sym_DOT_DOT] = ACTIONS(9977),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9979),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(9981),
    [anon_sym_AMP_AMP] = ACTIONS(9981),
    [anon_sym_LT_LT] = ACTIONS(9983),
    [anon_sym_GT_GT] = ACTIONS(9983),
    [anon_sym_EQ_EQ] = ACTIONS(9981),
    [anon_sym_BANG_EQ] = ACTIONS(9985),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9985),
    [anon_sym_LT_EQ_GT] = ACTIONS(9985),
    [anon_sym_EQ_TILDE] = ACTIONS(9985),
    [anon_sym_BANG_TILDE] = ACTIONS(9985),
    [anon_sym_LT_EQ] = ACTIONS(9973),
    [anon_sym_GT] = ACTIONS(9973),
    [anon_sym_GT_EQ] = ACTIONS(9987),
    [anon_sym_CARET] = ACTIONS(9967),
    [anon_sym_PLUS] = ACTIONS(9989),
    [anon_sym_SLASH] = ACTIONS(9969),
    [anon_sym_PERCENT] = ACTIONS(9969),
    [sym_comment] = ACTIONS(87),
  },
  [8722] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(10114),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3818),
    [sym_scope_resolution] = STATE(3814),
    [sym_call] = STATE(3814),
    [sym_method_call] = STATE(3818),
    [sym_assignment] = STATE(10114),
    [sym_operator_assignment] = STATE(10114),
    [sym_conditional] = STATE(10114),
    [sym_range] = STATE(10114),
    [sym_binary] = STATE(10114),
    [sym_unary] = STATE(10114),
    [sym_left_assignment_list] = STATE(3817),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3818),
    [sym__variable] = STATE(3814),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3818),
    [sym_false] = STATE(3818),
    [sym_nil] = STATE(3818),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(6492),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(6319),
    [anon_sym_yield] = ACTIONS(6321),
    [anon_sym_break] = ACTIONS(6323),
    [anon_sym_next] = ACTIONS(6325),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(9957),
    [anon_sym_defined_QMARK] = ACTIONS(6327),
    [anon_sym_not] = ACTIONS(6329),
    [anon_sym_BANG] = ACTIONS(6333),
    [anon_sym_TILDE] = ACTIONS(6333),
    [sym_constant] = ACTIONS(6339),
    [sym_identifier] = ACTIONS(6339),
    [sym_instance_variable] = ACTIONS(6337),
    [sym_class_variable] = ACTIONS(6337),
    [sym_global_variable] = ACTIONS(6337),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(6339),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6339),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [8723] = {
    [sym_heredoc_body] = STATE(10115),
    [aux_sym_call_repeat1] = STATE(10115),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [8724] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(6452),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3818),
    [sym_scope_resolution] = STATE(3814),
    [sym_call] = STATE(3814),
    [sym_method_call] = STATE(3818),
    [sym__argument] = STATE(4979),
    [sym_splat_argument] = STATE(4979),
    [sym_hash_splat_argument] = STATE(4979),
    [sym_block_argument] = STATE(4979),
    [sym_assignment] = STATE(6452),
    [sym_operator_assignment] = STATE(6452),
    [sym_conditional] = STATE(6452),
    [sym_range] = STATE(6452),
    [sym_binary] = STATE(6452),
    [sym_unary] = STATE(6452),
    [sym_left_assignment_list] = STATE(3817),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3818),
    [sym__variable] = STATE(3814),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3818),
    [sym_false] = STATE(3818),
    [sym_nil] = STATE(3818),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(6455),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_heredoc_body] = STATE(10116),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(4979),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(9917),
    [sym__splat_star] = ACTIONS(9919),
    [sym__unary_minus] = ACTIONS(6315),
    [sym__identifier_hash_key] = ACTIONS(9921),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13803),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(6319),
    [anon_sym_yield] = ACTIONS(6321),
    [anon_sym_break] = ACTIONS(6323),
    [anon_sym_next] = ACTIONS(6325),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(9957),
    [anon_sym_defined_QMARK] = ACTIONS(6327),
    [anon_sym_not] = ACTIONS(6329),
    [anon_sym_BANG] = ACTIONS(6333),
    [anon_sym_TILDE] = ACTIONS(6333),
    [sym_constant] = ACTIONS(9923),
    [sym_identifier] = ACTIONS(9923),
    [sym_instance_variable] = ACTIONS(6337),
    [sym_class_variable] = ACTIONS(6337),
    [sym_global_variable] = ACTIONS(6337),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(6339),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6339),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [8725] = {
    [sym_heredoc_body] = STATE(10117),
    [aux_sym_call_repeat1] = STATE(10117),
    [aux_sym_argument_list_repeat1] = STATE(10118),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(12387),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [8726] = {
    [sym_heredoc_body] = STATE(8726),
    [aux_sym_call_repeat1] = STATE(8726),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(7916),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [8727] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3777),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3782),
    [sym_scope_resolution] = STATE(3778),
    [sym_call] = STATE(3778),
    [sym_method_call] = STATE(3782),
    [sym__argument] = STATE(4986),
    [sym_splat_argument] = STATE(4986),
    [sym_hash_splat_argument] = STATE(4986),
    [sym_block_argument] = STATE(4986),
    [sym_assignment] = STATE(3777),
    [sym_operator_assignment] = STATE(3777),
    [sym_conditional] = STATE(3777),
    [sym_range] = STATE(3777),
    [sym_binary] = STATE(3777),
    [sym_unary] = STATE(3777),
    [sym_left_assignment_list] = STATE(3781),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3782),
    [sym__variable] = STATE(3778),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3782),
    [sym_false] = STATE(3782),
    [sym_nil] = STATE(3782),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3783),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4986),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(6241),
    [sym__splat_star] = ACTIONS(6243),
    [sym__unary_minus] = ACTIONS(6245),
    [sym__identifier_hash_key] = ACTIONS(6247),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12391),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6249),
    [anon_sym_yield] = ACTIONS(6251),
    [anon_sym_break] = ACTIONS(6253),
    [anon_sym_next] = ACTIONS(6255),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9877),
    [anon_sym_defined_QMARK] = ACTIONS(6257),
    [anon_sym_not] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(6263),
    [anon_sym_TILDE] = ACTIONS(6263),
    [sym_constant] = ACTIONS(6265),
    [sym_identifier] = ACTIONS(6265),
    [sym_instance_variable] = ACTIONS(6267),
    [sym_class_variable] = ACTIONS(6267),
    [sym_global_variable] = ACTIONS(6267),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(6269),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6269),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8728] = {
    [sym_heredoc_body] = STATE(8726),
    [aux_sym_call_repeat1] = STATE(8726),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [8729] = {
    [aux_sym_argument_list_repeat1] = STATE(8729),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(13805),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7925),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_if] = ACTIONS(7925),
    [anon_sym_unless] = ACTIONS(7925),
    [anon_sym_while] = ACTIONS(7925),
    [anon_sym_until] = ACTIONS(7925),
    [anon_sym_rescue] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7925),
    [anon_sym_AMP_AMP] = ACTIONS(7925),
    [anon_sym_LT_LT] = ACTIONS(7925),
    [anon_sym_GT_GT] = ACTIONS(7925),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7925),
    [anon_sym_PLUS] = ACTIONS(7925),
    [anon_sym_SLASH] = ACTIONS(7925),
    [anon_sym_PERCENT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [8730] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(9891),
    [sym__binary_star] = ACTIONS(9893),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(9895),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(9893),
    [anon_sym_AMP] = ACTIONS(9897),
    [anon_sym_LT] = ACTIONS(9899),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_EQ_GT] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(9901),
    [anon_sym_DOT_DOT] = ACTIONS(9903),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9905),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(9907),
    [anon_sym_AMP_AMP] = ACTIONS(9907),
    [anon_sym_LT_LT] = ACTIONS(9909),
    [anon_sym_GT_GT] = ACTIONS(9909),
    [anon_sym_EQ_EQ] = ACTIONS(9911),
    [anon_sym_BANG_EQ] = ACTIONS(9907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9907),
    [anon_sym_LT_EQ_GT] = ACTIONS(9907),
    [anon_sym_EQ_TILDE] = ACTIONS(9907),
    [anon_sym_BANG_TILDE] = ACTIONS(9907),
    [anon_sym_LT_EQ] = ACTIONS(9899),
    [anon_sym_GT] = ACTIONS(9899),
    [anon_sym_GT_EQ] = ACTIONS(9913),
    [anon_sym_CARET] = ACTIONS(9915),
    [anon_sym_PLUS] = ACTIONS(9891),
    [anon_sym_SLASH] = ACTIONS(9893),
    [anon_sym_PERCENT] = ACTIONS(9893),
    [sym_comment] = ACTIONS(87),
  },
  [8731] = {
    [aux_sym_exceptions_repeat1] = STATE(10120),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [8732] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(9891),
    [sym__binary_star] = ACTIONS(9893),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(9895),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(9893),
    [anon_sym_AMP] = ACTIONS(9897),
    [anon_sym_LT] = ACTIONS(9899),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_EQ_GT] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(9901),
    [anon_sym_DOT_DOT] = ACTIONS(9903),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9905),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(9907),
    [anon_sym_AMP_AMP] = ACTIONS(9907),
    [anon_sym_LT_LT] = ACTIONS(9909),
    [anon_sym_GT_GT] = ACTIONS(9909),
    [anon_sym_EQ_EQ] = ACTIONS(9911),
    [anon_sym_BANG_EQ] = ACTIONS(9907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9907),
    [anon_sym_LT_EQ_GT] = ACTIONS(9907),
    [anon_sym_EQ_TILDE] = ACTIONS(9907),
    [anon_sym_BANG_TILDE] = ACTIONS(9907),
    [anon_sym_LT_EQ] = ACTIONS(9899),
    [anon_sym_GT] = ACTIONS(9899),
    [anon_sym_GT_EQ] = ACTIONS(9913),
    [anon_sym_CARET] = ACTIONS(9915),
    [anon_sym_PLUS] = ACTIONS(9891),
    [anon_sym_SLASH] = ACTIONS(9893),
    [anon_sym_PERCENT] = ACTIONS(9893),
    [sym_comment] = ACTIONS(87),
  },
  [8733] = {
    [sym_string] = STATE(8733),
    [aux_sym_chained_string_repeat1] = STATE(8733),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(6214),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_EQ_GT] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [8734] = {
    [aux_sym_undef_repeat1] = STATE(8734),
    [sym__line_break] = ACTIONS(9263),
    [sym__heredoc_body_start] = ACTIONS(9263),
    [anon_sym_COMMA] = ACTIONS(9265),
    [anon_sym_SEMI] = ACTIONS(9263),
    [anon_sym_if] = ACTIONS(9263),
    [anon_sym_unless] = ACTIONS(9263),
    [anon_sym_while] = ACTIONS(9263),
    [anon_sym_until] = ACTIONS(9263),
    [anon_sym_rescue] = ACTIONS(9263),
    [sym_comment] = ACTIONS(87),
  },
  [8735] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10121),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1615),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(1615),
    [sym_assignment] = STATE(10121),
    [sym_operator_assignment] = STATE(10121),
    [sym_conditional] = STATE(10121),
    [sym_range] = STATE(10121),
    [sym_binary] = STATE(10121),
    [sym_unary] = STATE(10121),
    [sym_left_assignment_list] = STATE(1614),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1615),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1615),
    [sym_false] = STATE(1615),
    [sym_nil] = STATE(1615),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1616),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6219),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6221),
    [anon_sym_yield] = ACTIONS(6223),
    [anon_sym_break] = ACTIONS(6225),
    [anon_sym_next] = ACTIONS(6227),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6229),
    [anon_sym_defined_QMARK] = ACTIONS(6231),
    [anon_sym_not] = ACTIONS(6233),
    [anon_sym_BANG] = ACTIONS(6235),
    [anon_sym_TILDE] = ACTIONS(6235),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8736] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(12401),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [8737] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(12395),
    [sym__binary_star] = ACTIONS(12397),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(12399),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(12401),
    [anon_sym_AMP] = ACTIONS(12403),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(12405),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(12407),
    [anon_sym_DOT_DOT] = ACTIONS(12409),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12411),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(12413),
    [anon_sym_AMP_AMP] = ACTIONS(12413),
    [anon_sym_LT_LT] = ACTIONS(12415),
    [anon_sym_GT_GT] = ACTIONS(12415),
    [anon_sym_EQ_EQ] = ACTIONS(12413),
    [anon_sym_BANG_EQ] = ACTIONS(12417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12417),
    [anon_sym_LT_EQ_GT] = ACTIONS(12417),
    [anon_sym_EQ_TILDE] = ACTIONS(12417),
    [anon_sym_BANG_TILDE] = ACTIONS(12417),
    [anon_sym_LT_EQ] = ACTIONS(12405),
    [anon_sym_GT] = ACTIONS(12405),
    [anon_sym_GT_EQ] = ACTIONS(12419),
    [anon_sym_CARET] = ACTIONS(12399),
    [anon_sym_PLUS] = ACTIONS(12421),
    [anon_sym_SLASH] = ACTIONS(12401),
    [anon_sym_PERCENT] = ACTIONS(12401),
    [sym_comment] = ACTIONS(87),
  },
  [8738] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10122),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(6488),
    [sym_scope_resolution] = STATE(6486),
    [sym_call] = STATE(6486),
    [sym_method_call] = STATE(6488),
    [sym_assignment] = STATE(10122),
    [sym_operator_assignment] = STATE(10122),
    [sym_conditional] = STATE(10122),
    [sym_range] = STATE(10122),
    [sym_binary] = STATE(10122),
    [sym_unary] = STATE(10122),
    [sym_left_assignment_list] = STATE(6487),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6488),
    [sym__variable] = STATE(6486),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(6488),
    [sym_false] = STATE(6488),
    [sym_nil] = STATE(6488),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(6489),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(9935),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(9937),
    [anon_sym_yield] = ACTIONS(9939),
    [anon_sym_break] = ACTIONS(9941),
    [anon_sym_next] = ACTIONS(9943),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(9945),
    [anon_sym_defined_QMARK] = ACTIONS(9947),
    [anon_sym_not] = ACTIONS(9949),
    [anon_sym_BANG] = ACTIONS(9951),
    [anon_sym_TILDE] = ACTIONS(9951),
    [sym_constant] = ACTIONS(9953),
    [sym_identifier] = ACTIONS(9953),
    [sym_instance_variable] = ACTIONS(9955),
    [sym_class_variable] = ACTIONS(9955),
    [sym_global_variable] = ACTIONS(9955),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(9953),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9953),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [8739] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10123),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(6488),
    [sym_scope_resolution] = STATE(6486),
    [sym_call] = STATE(6486),
    [sym_method_call] = STATE(6488),
    [sym_assignment] = STATE(10123),
    [sym_operator_assignment] = STATE(10123),
    [sym_conditional] = STATE(10123),
    [sym_range] = STATE(10123),
    [sym_binary] = STATE(10123),
    [sym_unary] = STATE(10123),
    [sym_left_assignment_list] = STATE(6487),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6488),
    [sym__variable] = STATE(6486),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(6488),
    [sym_false] = STATE(6488),
    [sym_nil] = STATE(6488),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(6489),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(9935),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(9937),
    [anon_sym_yield] = ACTIONS(9939),
    [anon_sym_break] = ACTIONS(9941),
    [anon_sym_next] = ACTIONS(9943),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(9945),
    [anon_sym_defined_QMARK] = ACTIONS(9947),
    [anon_sym_not] = ACTIONS(9949),
    [anon_sym_BANG] = ACTIONS(9951),
    [anon_sym_TILDE] = ACTIONS(9951),
    [sym_constant] = ACTIONS(9953),
    [sym_identifier] = ACTIONS(9953),
    [sym_instance_variable] = ACTIONS(9955),
    [sym_class_variable] = ACTIONS(9955),
    [sym_global_variable] = ACTIONS(9955),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(9953),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9953),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [8740] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10124),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(6488),
    [sym_scope_resolution] = STATE(6486),
    [sym_call] = STATE(6486),
    [sym_method_call] = STATE(6488),
    [sym_assignment] = STATE(10124),
    [sym_operator_assignment] = STATE(10124),
    [sym_conditional] = STATE(10124),
    [sym_range] = STATE(10124),
    [sym_binary] = STATE(10124),
    [sym_unary] = STATE(10124),
    [sym_left_assignment_list] = STATE(6487),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6488),
    [sym__variable] = STATE(6486),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(6488),
    [sym_false] = STATE(6488),
    [sym_nil] = STATE(6488),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(6489),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(9935),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(9937),
    [anon_sym_yield] = ACTIONS(9939),
    [anon_sym_break] = ACTIONS(9941),
    [anon_sym_next] = ACTIONS(9943),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(9945),
    [anon_sym_defined_QMARK] = ACTIONS(9947),
    [anon_sym_not] = ACTIONS(9949),
    [anon_sym_BANG] = ACTIONS(9951),
    [anon_sym_TILDE] = ACTIONS(9951),
    [sym_constant] = ACTIONS(9953),
    [sym_identifier] = ACTIONS(9953),
    [sym_instance_variable] = ACTIONS(9955),
    [sym_class_variable] = ACTIONS(9955),
    [sym_global_variable] = ACTIONS(9955),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(9953),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9953),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [8741] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10125),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(6488),
    [sym_scope_resolution] = STATE(6486),
    [sym_call] = STATE(6486),
    [sym_method_call] = STATE(6488),
    [sym_assignment] = STATE(10125),
    [sym_operator_assignment] = STATE(10125),
    [sym_conditional] = STATE(10125),
    [sym_range] = STATE(10125),
    [sym_binary] = STATE(10125),
    [sym_unary] = STATE(10125),
    [sym_left_assignment_list] = STATE(6487),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6488),
    [sym__variable] = STATE(6486),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(6488),
    [sym_false] = STATE(6488),
    [sym_nil] = STATE(6488),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(6489),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(9935),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(9937),
    [anon_sym_yield] = ACTIONS(9939),
    [anon_sym_break] = ACTIONS(9941),
    [anon_sym_next] = ACTIONS(9943),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(9945),
    [anon_sym_defined_QMARK] = ACTIONS(9947),
    [anon_sym_not] = ACTIONS(9949),
    [anon_sym_BANG] = ACTIONS(9951),
    [anon_sym_TILDE] = ACTIONS(9951),
    [sym_constant] = ACTIONS(9953),
    [sym_identifier] = ACTIONS(9953),
    [sym_instance_variable] = ACTIONS(9955),
    [sym_class_variable] = ACTIONS(9955),
    [sym_global_variable] = ACTIONS(9955),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(9953),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9953),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [8742] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10126),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(6488),
    [sym_scope_resolution] = STATE(6486),
    [sym_call] = STATE(6486),
    [sym_method_call] = STATE(6488),
    [sym_assignment] = STATE(10126),
    [sym_operator_assignment] = STATE(10126),
    [sym_conditional] = STATE(10126),
    [sym_range] = STATE(10126),
    [sym_binary] = STATE(10126),
    [sym_unary] = STATE(10126),
    [sym_left_assignment_list] = STATE(6487),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6488),
    [sym__variable] = STATE(6486),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(6488),
    [sym_false] = STATE(6488),
    [sym_nil] = STATE(6488),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(6489),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(9935),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(9937),
    [anon_sym_yield] = ACTIONS(9939),
    [anon_sym_break] = ACTIONS(9941),
    [anon_sym_next] = ACTIONS(9943),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(9945),
    [anon_sym_defined_QMARK] = ACTIONS(9947),
    [anon_sym_not] = ACTIONS(9949),
    [anon_sym_BANG] = ACTIONS(9951),
    [anon_sym_TILDE] = ACTIONS(9951),
    [sym_constant] = ACTIONS(9953),
    [sym_identifier] = ACTIONS(9953),
    [sym_instance_variable] = ACTIONS(9955),
    [sym_class_variable] = ACTIONS(9955),
    [sym_global_variable] = ACTIONS(9955),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(9953),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9953),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [8743] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(10127),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(10127),
    [sym_operator_assignment] = STATE(10127),
    [sym_conditional] = STATE(10127),
    [sym_range] = STATE(10127),
    [sym_binary] = STATE(10127),
    [sym_unary] = STATE(10127),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8744] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10128),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(6488),
    [sym_scope_resolution] = STATE(6486),
    [sym_call] = STATE(6486),
    [sym_method_call] = STATE(6488),
    [sym_assignment] = STATE(10128),
    [sym_operator_assignment] = STATE(10128),
    [sym_conditional] = STATE(10128),
    [sym_range] = STATE(10128),
    [sym_binary] = STATE(10128),
    [sym_unary] = STATE(10128),
    [sym_left_assignment_list] = STATE(6487),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6488),
    [sym__variable] = STATE(6486),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(6488),
    [sym_false] = STATE(6488),
    [sym_nil] = STATE(6488),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(6489),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(9935),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(9937),
    [anon_sym_yield] = ACTIONS(9939),
    [anon_sym_break] = ACTIONS(9941),
    [anon_sym_next] = ACTIONS(9943),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(9945),
    [anon_sym_defined_QMARK] = ACTIONS(9947),
    [anon_sym_not] = ACTIONS(9949),
    [anon_sym_BANG] = ACTIONS(9951),
    [anon_sym_TILDE] = ACTIONS(9951),
    [sym_constant] = ACTIONS(9953),
    [sym_identifier] = ACTIONS(9953),
    [sym_instance_variable] = ACTIONS(9955),
    [sym_class_variable] = ACTIONS(9955),
    [sym_global_variable] = ACTIONS(9955),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(9953),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9953),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [8745] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10129),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(6488),
    [sym_scope_resolution] = STATE(6486),
    [sym_call] = STATE(6486),
    [sym_method_call] = STATE(6488),
    [sym_assignment] = STATE(10129),
    [sym_operator_assignment] = STATE(10129),
    [sym_conditional] = STATE(10129),
    [sym_range] = STATE(10129),
    [sym_binary] = STATE(10129),
    [sym_unary] = STATE(10129),
    [sym_left_assignment_list] = STATE(6487),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6488),
    [sym__variable] = STATE(6486),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(6488),
    [sym_false] = STATE(6488),
    [sym_nil] = STATE(6488),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(6489),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(9935),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(9937),
    [anon_sym_yield] = ACTIONS(9939),
    [anon_sym_break] = ACTIONS(9941),
    [anon_sym_next] = ACTIONS(9943),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(9945),
    [anon_sym_defined_QMARK] = ACTIONS(9947),
    [anon_sym_not] = ACTIONS(9949),
    [anon_sym_BANG] = ACTIONS(9951),
    [anon_sym_TILDE] = ACTIONS(9951),
    [sym_constant] = ACTIONS(9953),
    [sym_identifier] = ACTIONS(9953),
    [sym_instance_variable] = ACTIONS(9955),
    [sym_class_variable] = ACTIONS(9955),
    [sym_global_variable] = ACTIONS(9955),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(9953),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9953),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [8746] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10130),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(6488),
    [sym_scope_resolution] = STATE(6486),
    [sym_call] = STATE(6486),
    [sym_method_call] = STATE(6488),
    [sym_assignment] = STATE(10130),
    [sym_operator_assignment] = STATE(10130),
    [sym_conditional] = STATE(10130),
    [sym_range] = STATE(10130),
    [sym_binary] = STATE(10130),
    [sym_unary] = STATE(10130),
    [sym_left_assignment_list] = STATE(6487),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6488),
    [sym__variable] = STATE(6486),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(6488),
    [sym_false] = STATE(6488),
    [sym_nil] = STATE(6488),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(6489),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(9935),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(9937),
    [anon_sym_yield] = ACTIONS(9939),
    [anon_sym_break] = ACTIONS(9941),
    [anon_sym_next] = ACTIONS(9943),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(9945),
    [anon_sym_defined_QMARK] = ACTIONS(9947),
    [anon_sym_not] = ACTIONS(9949),
    [anon_sym_BANG] = ACTIONS(9951),
    [anon_sym_TILDE] = ACTIONS(9951),
    [sym_constant] = ACTIONS(9953),
    [sym_identifier] = ACTIONS(9953),
    [sym_instance_variable] = ACTIONS(9955),
    [sym_class_variable] = ACTIONS(9955),
    [sym_global_variable] = ACTIONS(9955),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(9953),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9953),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [8747] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10131),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(6488),
    [sym_scope_resolution] = STATE(6486),
    [sym_call] = STATE(6486),
    [sym_method_call] = STATE(6488),
    [sym_assignment] = STATE(10131),
    [sym_operator_assignment] = STATE(10131),
    [sym_conditional] = STATE(10131),
    [sym_range] = STATE(10131),
    [sym_binary] = STATE(10131),
    [sym_unary] = STATE(10131),
    [sym_left_assignment_list] = STATE(6487),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6488),
    [sym__variable] = STATE(6486),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(6488),
    [sym_false] = STATE(6488),
    [sym_nil] = STATE(6488),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(6489),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(9935),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(9937),
    [anon_sym_yield] = ACTIONS(9939),
    [anon_sym_break] = ACTIONS(9941),
    [anon_sym_next] = ACTIONS(9943),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(9945),
    [anon_sym_defined_QMARK] = ACTIONS(9947),
    [anon_sym_not] = ACTIONS(9949),
    [anon_sym_BANG] = ACTIONS(9951),
    [anon_sym_TILDE] = ACTIONS(9951),
    [sym_constant] = ACTIONS(9953),
    [sym_identifier] = ACTIONS(9953),
    [sym_instance_variable] = ACTIONS(9955),
    [sym_class_variable] = ACTIONS(9955),
    [sym_global_variable] = ACTIONS(9955),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(9953),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9953),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [8748] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10132),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(6488),
    [sym_scope_resolution] = STATE(6486),
    [sym_call] = STATE(6486),
    [sym_method_call] = STATE(6488),
    [sym_splat_argument] = STATE(10133),
    [sym_assignment] = STATE(10132),
    [sym_operator_assignment] = STATE(10132),
    [sym_conditional] = STATE(10132),
    [sym_range] = STATE(10132),
    [sym_binary] = STATE(10132),
    [sym_unary] = STATE(10132),
    [sym_right_assignment_list] = STATE(6323),
    [sym__arg_or_splat_arg] = STATE(10133),
    [sym_left_assignment_list] = STATE(6487),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6488),
    [sym__variable] = STATE(6486),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(6488),
    [sym_false] = STATE(6488),
    [sym_nil] = STATE(6488),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(6489),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__splat_star] = ACTIONS(6313),
    [sym__unary_minus] = ACTIONS(9935),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(9937),
    [anon_sym_yield] = ACTIONS(9939),
    [anon_sym_break] = ACTIONS(9941),
    [anon_sym_next] = ACTIONS(9943),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(9945),
    [anon_sym_defined_QMARK] = ACTIONS(9947),
    [anon_sym_not] = ACTIONS(9949),
    [anon_sym_BANG] = ACTIONS(9951),
    [anon_sym_TILDE] = ACTIONS(9951),
    [sym_constant] = ACTIONS(9953),
    [sym_identifier] = ACTIONS(9953),
    [sym_instance_variable] = ACTIONS(9955),
    [sym_class_variable] = ACTIONS(9955),
    [sym_global_variable] = ACTIONS(9955),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(9953),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9953),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [8749] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10134),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(6488),
    [sym_scope_resolution] = STATE(6486),
    [sym_call] = STATE(6486),
    [sym_method_call] = STATE(6488),
    [sym_assignment] = STATE(10134),
    [sym_operator_assignment] = STATE(10134),
    [sym_conditional] = STATE(10134),
    [sym_range] = STATE(10134),
    [sym_binary] = STATE(10134),
    [sym_unary] = STATE(10134),
    [sym_left_assignment_list] = STATE(6487),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6488),
    [sym__variable] = STATE(6486),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(6488),
    [sym_false] = STATE(6488),
    [sym_nil] = STATE(6488),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(6489),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(9935),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(9937),
    [anon_sym_yield] = ACTIONS(9939),
    [anon_sym_break] = ACTIONS(9941),
    [anon_sym_next] = ACTIONS(9943),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(9945),
    [anon_sym_defined_QMARK] = ACTIONS(9947),
    [anon_sym_not] = ACTIONS(9949),
    [anon_sym_BANG] = ACTIONS(9951),
    [anon_sym_TILDE] = ACTIONS(9951),
    [sym_constant] = ACTIONS(9953),
    [sym_identifier] = ACTIONS(9953),
    [sym_instance_variable] = ACTIONS(9955),
    [sym_class_variable] = ACTIONS(9955),
    [sym_global_variable] = ACTIONS(9955),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(9953),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9953),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [8750] = {
    [sym_string] = STATE(10135),
    [aux_sym_chained_string_repeat1] = STATE(10135),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(2551),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2755),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_EQ] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_PLUS_EQ] = ACTIONS(2753),
    [anon_sym_DASH_EQ] = ACTIONS(2753),
    [anon_sym_STAR_EQ] = ACTIONS(2753),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2753),
    [anon_sym_SLASH_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2753),
    [anon_sym_AMP_EQ] = ACTIONS(2753),
    [anon_sym_PERCENT_EQ] = ACTIONS(2753),
    [anon_sym_GT_GT_EQ] = ACTIONS(2753),
    [anon_sym_LT_LT_EQ] = ACTIONS(2753),
    [anon_sym_CARET_EQ] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2755),
    [anon_sym_AMP_AMP] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2755),
    [anon_sym_GT_GT] = ACTIONS(2755),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_SLASH] = ACTIONS(2755),
    [anon_sym_PERCENT] = ACTIONS(2755),
    [sym_comment] = ACTIONS(87),
  },
  [8751] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(12395),
    [sym__binary_star] = ACTIONS(12397),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(12399),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(12401),
    [anon_sym_AMP] = ACTIONS(12403),
    [anon_sym_EQ] = ACTIONS(7822),
    [anon_sym_LT] = ACTIONS(12405),
    [anon_sym_if] = ACTIONS(6823),
    [anon_sym_unless] = ACTIONS(6823),
    [anon_sym_while] = ACTIONS(6823),
    [anon_sym_until] = ACTIONS(6823),
    [anon_sym_rescue] = ACTIONS(6823),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_PLUS_EQ] = ACTIONS(6823),
    [anon_sym_DASH_EQ] = ACTIONS(6823),
    [anon_sym_STAR_EQ] = ACTIONS(6823),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6823),
    [anon_sym_SLASH_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6823),
    [anon_sym_AMP_EQ] = ACTIONS(6823),
    [anon_sym_PERCENT_EQ] = ACTIONS(6823),
    [anon_sym_GT_GT_EQ] = ACTIONS(6823),
    [anon_sym_LT_LT_EQ] = ACTIONS(6823),
    [anon_sym_CARET_EQ] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(12407),
    [anon_sym_DOT_DOT] = ACTIONS(12409),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12411),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(12413),
    [anon_sym_AMP_AMP] = ACTIONS(12413),
    [anon_sym_LT_LT] = ACTIONS(12415),
    [anon_sym_GT_GT] = ACTIONS(12415),
    [anon_sym_EQ_EQ] = ACTIONS(12413),
    [anon_sym_BANG_EQ] = ACTIONS(12417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12417),
    [anon_sym_LT_EQ_GT] = ACTIONS(12417),
    [anon_sym_EQ_TILDE] = ACTIONS(12417),
    [anon_sym_BANG_TILDE] = ACTIONS(12417),
    [anon_sym_LT_EQ] = ACTIONS(12405),
    [anon_sym_GT] = ACTIONS(12405),
    [anon_sym_GT_EQ] = ACTIONS(12419),
    [anon_sym_CARET] = ACTIONS(12399),
    [anon_sym_PLUS] = ACTIONS(12421),
    [anon_sym_SLASH] = ACTIONS(12401),
    [anon_sym_PERCENT] = ACTIONS(12401),
    [sym_comment] = ACTIONS(87),
  },
  [8752] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(12395),
    [sym__binary_star] = ACTIONS(12397),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(12399),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(12401),
    [anon_sym_AMP] = ACTIONS(12403),
    [anon_sym_EQ] = ACTIONS(7884),
    [anon_sym_LT] = ACTIONS(12405),
    [anon_sym_if] = ACTIONS(7027),
    [anon_sym_unless] = ACTIONS(7027),
    [anon_sym_while] = ACTIONS(7027),
    [anon_sym_until] = ACTIONS(7027),
    [anon_sym_rescue] = ACTIONS(7027),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_PLUS_EQ] = ACTIONS(7027),
    [anon_sym_DASH_EQ] = ACTIONS(7027),
    [anon_sym_STAR_EQ] = ACTIONS(7027),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7027),
    [anon_sym_SLASH_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7027),
    [anon_sym_AMP_EQ] = ACTIONS(7027),
    [anon_sym_PERCENT_EQ] = ACTIONS(7027),
    [anon_sym_GT_GT_EQ] = ACTIONS(7027),
    [anon_sym_LT_LT_EQ] = ACTIONS(7027),
    [anon_sym_CARET_EQ] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(12407),
    [anon_sym_DOT_DOT] = ACTIONS(12409),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12411),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(12413),
    [anon_sym_AMP_AMP] = ACTIONS(12413),
    [anon_sym_LT_LT] = ACTIONS(12415),
    [anon_sym_GT_GT] = ACTIONS(12415),
    [anon_sym_EQ_EQ] = ACTIONS(12413),
    [anon_sym_BANG_EQ] = ACTIONS(12417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12417),
    [anon_sym_LT_EQ_GT] = ACTIONS(12417),
    [anon_sym_EQ_TILDE] = ACTIONS(12417),
    [anon_sym_BANG_TILDE] = ACTIONS(12417),
    [anon_sym_LT_EQ] = ACTIONS(12405),
    [anon_sym_GT] = ACTIONS(12405),
    [anon_sym_GT_EQ] = ACTIONS(12419),
    [anon_sym_CARET] = ACTIONS(12399),
    [anon_sym_PLUS] = ACTIONS(12421),
    [anon_sym_SLASH] = ACTIONS(12401),
    [anon_sym_PERCENT] = ACTIONS(12401),
    [sym_comment] = ACTIONS(87),
  },
  [8753] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(9965),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(9969),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(9969),
    [anon_sym_PERCENT] = ACTIONS(9969),
    [sym_comment] = ACTIONS(87),
  },
  [8754] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(9969),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(5827),
    [anon_sym_PERCENT] = ACTIONS(5827),
    [sym_comment] = ACTIONS(87),
  },
  [8755] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(9963),
    [sym__binary_star] = ACTIONS(9965),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(9969),
    [anon_sym_AMP] = ACTIONS(9971),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(9983),
    [anon_sym_GT_GT] = ACTIONS(9983),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(9989),
    [anon_sym_SLASH] = ACTIONS(9969),
    [anon_sym_PERCENT] = ACTIONS(9969),
    [sym_comment] = ACTIONS(87),
  },
  [8756] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(9963),
    [sym__binary_star] = ACTIONS(9965),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(9969),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(9983),
    [anon_sym_GT_GT] = ACTIONS(9983),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(9989),
    [anon_sym_SLASH] = ACTIONS(9969),
    [anon_sym_PERCENT] = ACTIONS(9969),
    [sym_comment] = ACTIONS(87),
  },
  [8757] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(9963),
    [sym__binary_star] = ACTIONS(9965),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(9967),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(9969),
    [anon_sym_AMP] = ACTIONS(9971),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(9983),
    [anon_sym_GT_GT] = ACTIONS(9983),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(9967),
    [anon_sym_PLUS] = ACTIONS(9989),
    [anon_sym_SLASH] = ACTIONS(9969),
    [anon_sym_PERCENT] = ACTIONS(9969),
    [sym_comment] = ACTIONS(87),
  },
  [8758] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(13808),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [8759] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(9963),
    [sym__binary_star] = ACTIONS(9965),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(9967),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(9969),
    [anon_sym_AMP] = ACTIONS(9971),
    [anon_sym_EQ] = ACTIONS(7888),
    [anon_sym_LT] = ACTIONS(9973),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_EQ_GT] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_PLUS_EQ] = ACTIONS(5927),
    [anon_sym_DASH_EQ] = ACTIONS(5927),
    [anon_sym_STAR_EQ] = ACTIONS(5927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5927),
    [anon_sym_SLASH_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5927),
    [anon_sym_AMP_EQ] = ACTIONS(5927),
    [anon_sym_PERCENT_EQ] = ACTIONS(5927),
    [anon_sym_GT_GT_EQ] = ACTIONS(5927),
    [anon_sym_LT_LT_EQ] = ACTIONS(5927),
    [anon_sym_CARET_EQ] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(9977),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9979),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(9981),
    [anon_sym_AMP_AMP] = ACTIONS(9981),
    [anon_sym_LT_LT] = ACTIONS(9983),
    [anon_sym_GT_GT] = ACTIONS(9983),
    [anon_sym_EQ_EQ] = ACTIONS(9981),
    [anon_sym_BANG_EQ] = ACTIONS(9985),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9985),
    [anon_sym_LT_EQ_GT] = ACTIONS(9985),
    [anon_sym_EQ_TILDE] = ACTIONS(9985),
    [anon_sym_BANG_TILDE] = ACTIONS(9985),
    [anon_sym_LT_EQ] = ACTIONS(9973),
    [anon_sym_GT] = ACTIONS(9973),
    [anon_sym_GT_EQ] = ACTIONS(9987),
    [anon_sym_CARET] = ACTIONS(9967),
    [anon_sym_PLUS] = ACTIONS(9989),
    [anon_sym_SLASH] = ACTIONS(9969),
    [anon_sym_PERCENT] = ACTIONS(9969),
    [sym_comment] = ACTIONS(87),
  },
  [8760] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(9963),
    [sym__binary_star] = ACTIONS(9965),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(9967),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(9969),
    [anon_sym_AMP] = ACTIONS(9971),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(9973),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(9975),
    [anon_sym_DOT_DOT] = ACTIONS(9977),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9979),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(9981),
    [anon_sym_AMP_AMP] = ACTIONS(9981),
    [anon_sym_LT_LT] = ACTIONS(9983),
    [anon_sym_GT_GT] = ACTIONS(9983),
    [anon_sym_EQ_EQ] = ACTIONS(9981),
    [anon_sym_BANG_EQ] = ACTIONS(9985),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9985),
    [anon_sym_LT_EQ_GT] = ACTIONS(9985),
    [anon_sym_EQ_TILDE] = ACTIONS(9985),
    [anon_sym_BANG_TILDE] = ACTIONS(9985),
    [anon_sym_LT_EQ] = ACTIONS(9973),
    [anon_sym_GT] = ACTIONS(9973),
    [anon_sym_GT_EQ] = ACTIONS(9987),
    [anon_sym_CARET] = ACTIONS(9967),
    [anon_sym_PLUS] = ACTIONS(9989),
    [anon_sym_SLASH] = ACTIONS(9969),
    [anon_sym_PERCENT] = ACTIONS(9969),
    [sym_comment] = ACTIONS(87),
  },
  [8761] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(9963),
    [sym__binary_star] = ACTIONS(9965),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(9967),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(9969),
    [anon_sym_AMP] = ACTIONS(9971),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(9973),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(9983),
    [anon_sym_GT_GT] = ACTIONS(9983),
    [anon_sym_EQ_EQ] = ACTIONS(9981),
    [anon_sym_BANG_EQ] = ACTIONS(9985),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9985),
    [anon_sym_LT_EQ_GT] = ACTIONS(9985),
    [anon_sym_EQ_TILDE] = ACTIONS(9985),
    [anon_sym_BANG_TILDE] = ACTIONS(9985),
    [anon_sym_LT_EQ] = ACTIONS(9973),
    [anon_sym_GT] = ACTIONS(9973),
    [anon_sym_GT_EQ] = ACTIONS(9987),
    [anon_sym_CARET] = ACTIONS(9967),
    [anon_sym_PLUS] = ACTIONS(9989),
    [anon_sym_SLASH] = ACTIONS(9969),
    [anon_sym_PERCENT] = ACTIONS(9969),
    [sym_comment] = ACTIONS(87),
  },
  [8762] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(9963),
    [sym__binary_star] = ACTIONS(9965),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(9969),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(9989),
    [anon_sym_SLASH] = ACTIONS(9969),
    [anon_sym_PERCENT] = ACTIONS(9969),
    [sym_comment] = ACTIONS(87),
  },
  [8763] = {
    [sym_heredoc_body] = STATE(8763),
    [aux_sym_call_repeat1] = STATE(8763),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(9846),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7919),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_EQ] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_PLUS_EQ] = ACTIONS(7914),
    [anon_sym_DASH_EQ] = ACTIONS(7914),
    [anon_sym_STAR_EQ] = ACTIONS(7914),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7914),
    [anon_sym_SLASH_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7914),
    [anon_sym_AMP_EQ] = ACTIONS(7914),
    [anon_sym_PERCENT_EQ] = ACTIONS(7914),
    [anon_sym_GT_GT_EQ] = ACTIONS(7914),
    [anon_sym_LT_LT_EQ] = ACTIONS(7914),
    [anon_sym_CARET_EQ] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7919),
    [anon_sym_AMP_AMP] = ACTIONS(7919),
    [anon_sym_LT_LT] = ACTIONS(7919),
    [anon_sym_GT_GT] = ACTIONS(7919),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7919),
    [anon_sym_PLUS] = ACTIONS(7919),
    [anon_sym_SLASH] = ACTIONS(7919),
    [anon_sym_PERCENT] = ACTIONS(7919),
    [sym_comment] = ACTIONS(87),
  },
  [8764] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(3813),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3818),
    [sym_scope_resolution] = STATE(3814),
    [sym_call] = STATE(3814),
    [sym_method_call] = STATE(3818),
    [sym__argument] = STATE(6393),
    [sym_splat_argument] = STATE(6393),
    [sym_hash_splat_argument] = STATE(6393),
    [sym_block_argument] = STATE(6393),
    [sym_assignment] = STATE(3813),
    [sym_operator_assignment] = STATE(3813),
    [sym_conditional] = STATE(3813),
    [sym_range] = STATE(3813),
    [sym_binary] = STATE(3813),
    [sym_unary] = STATE(3813),
    [sym_left_assignment_list] = STATE(3817),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3818),
    [sym__variable] = STATE(3814),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3818),
    [sym_false] = STATE(3818),
    [sym_nil] = STATE(3818),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(3819),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(6393),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(6311),
    [sym__splat_star] = ACTIONS(6313),
    [sym__unary_minus] = ACTIONS(6315),
    [sym__identifier_hash_key] = ACTIONS(6317),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12429),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(6319),
    [anon_sym_yield] = ACTIONS(6321),
    [anon_sym_break] = ACTIONS(6323),
    [anon_sym_next] = ACTIONS(6325),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(9957),
    [anon_sym_defined_QMARK] = ACTIONS(6327),
    [anon_sym_not] = ACTIONS(6329),
    [anon_sym_BANG] = ACTIONS(6333),
    [anon_sym_TILDE] = ACTIONS(6333),
    [sym_constant] = ACTIONS(6335),
    [sym_identifier] = ACTIONS(6335),
    [sym_instance_variable] = ACTIONS(6337),
    [sym_class_variable] = ACTIONS(6337),
    [sym_global_variable] = ACTIONS(6337),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(6339),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6339),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [8765] = {
    [sym_heredoc_body] = STATE(8763),
    [aux_sym_call_repeat1] = STATE(8763),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7931),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_EQ] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_PLUS_EQ] = ACTIONS(7929),
    [anon_sym_DASH_EQ] = ACTIONS(7929),
    [anon_sym_STAR_EQ] = ACTIONS(7929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7929),
    [anon_sym_SLASH_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7929),
    [anon_sym_AMP_EQ] = ACTIONS(7929),
    [anon_sym_PERCENT_EQ] = ACTIONS(7929),
    [anon_sym_GT_GT_EQ] = ACTIONS(7929),
    [anon_sym_LT_LT_EQ] = ACTIONS(7929),
    [anon_sym_CARET_EQ] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7931),
    [anon_sym_AMP_AMP] = ACTIONS(7931),
    [anon_sym_LT_LT] = ACTIONS(7931),
    [anon_sym_GT_GT] = ACTIONS(7931),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7931),
    [anon_sym_PLUS] = ACTIONS(7931),
    [anon_sym_SLASH] = ACTIONS(7931),
    [anon_sym_PERCENT] = ACTIONS(7931),
    [sym_comment] = ACTIONS(87),
  },
  [8766] = {
    [aux_sym_argument_list_repeat1] = STATE(8766),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(13810),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7927),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_EQ] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_if] = ACTIONS(7925),
    [anon_sym_unless] = ACTIONS(7925),
    [anon_sym_while] = ACTIONS(7925),
    [anon_sym_until] = ACTIONS(7925),
    [anon_sym_rescue] = ACTIONS(7925),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_PLUS_EQ] = ACTIONS(7925),
    [anon_sym_DASH_EQ] = ACTIONS(7925),
    [anon_sym_STAR_EQ] = ACTIONS(7925),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7925),
    [anon_sym_SLASH_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7925),
    [anon_sym_AMP_EQ] = ACTIONS(7925),
    [anon_sym_PERCENT_EQ] = ACTIONS(7925),
    [anon_sym_GT_GT_EQ] = ACTIONS(7925),
    [anon_sym_LT_LT_EQ] = ACTIONS(7925),
    [anon_sym_CARET_EQ] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7927),
    [anon_sym_AMP_AMP] = ACTIONS(7927),
    [anon_sym_LT_LT] = ACTIONS(7927),
    [anon_sym_GT_GT] = ACTIONS(7927),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7927),
    [anon_sym_PLUS] = ACTIONS(7927),
    [anon_sym_SLASH] = ACTIONS(7927),
    [anon_sym_PERCENT] = ACTIONS(7927),
    [sym_comment] = ACTIONS(87),
  },
  [8767] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(9963),
    [sym__binary_star] = ACTIONS(9965),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(9967),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(9969),
    [anon_sym_AMP] = ACTIONS(9971),
    [anon_sym_EQ] = ACTIONS(7936),
    [anon_sym_LT] = ACTIONS(9973),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_EQ_GT] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_PLUS_EQ] = ACTIONS(5115),
    [anon_sym_DASH_EQ] = ACTIONS(5115),
    [anon_sym_STAR_EQ] = ACTIONS(5115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5115),
    [anon_sym_SLASH_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5115),
    [anon_sym_AMP_EQ] = ACTIONS(5115),
    [anon_sym_PERCENT_EQ] = ACTIONS(5115),
    [anon_sym_GT_GT_EQ] = ACTIONS(5115),
    [anon_sym_LT_LT_EQ] = ACTIONS(5115),
    [anon_sym_CARET_EQ] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(9975),
    [anon_sym_DOT_DOT] = ACTIONS(9977),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9979),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(9981),
    [anon_sym_AMP_AMP] = ACTIONS(9981),
    [anon_sym_LT_LT] = ACTIONS(9983),
    [anon_sym_GT_GT] = ACTIONS(9983),
    [anon_sym_EQ_EQ] = ACTIONS(9981),
    [anon_sym_BANG_EQ] = ACTIONS(9985),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9985),
    [anon_sym_LT_EQ_GT] = ACTIONS(9985),
    [anon_sym_EQ_TILDE] = ACTIONS(9985),
    [anon_sym_BANG_TILDE] = ACTIONS(9985),
    [anon_sym_LT_EQ] = ACTIONS(9973),
    [anon_sym_GT] = ACTIONS(9973),
    [anon_sym_GT_EQ] = ACTIONS(9987),
    [anon_sym_CARET] = ACTIONS(9967),
    [anon_sym_PLUS] = ACTIONS(9989),
    [anon_sym_SLASH] = ACTIONS(9969),
    [anon_sym_PERCENT] = ACTIONS(9969),
    [sym_comment] = ACTIONS(87),
  },
  [8768] = {
    [aux_sym_exceptions_repeat1] = STATE(10138),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6193),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_PLUS_EQ] = ACTIONS(6191),
    [anon_sym_DASH_EQ] = ACTIONS(6191),
    [anon_sym_STAR_EQ] = ACTIONS(6191),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6191),
    [anon_sym_SLASH_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6191),
    [anon_sym_AMP_EQ] = ACTIONS(6191),
    [anon_sym_PERCENT_EQ] = ACTIONS(6191),
    [anon_sym_GT_GT_EQ] = ACTIONS(6191),
    [anon_sym_LT_LT_EQ] = ACTIONS(6191),
    [anon_sym_CARET_EQ] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6193),
    [anon_sym_AMP_AMP] = ACTIONS(6193),
    [anon_sym_LT_LT] = ACTIONS(6193),
    [anon_sym_GT_GT] = ACTIONS(6193),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6193),
    [anon_sym_PLUS] = ACTIONS(6193),
    [anon_sym_SLASH] = ACTIONS(6193),
    [anon_sym_PERCENT] = ACTIONS(6193),
    [sym_comment] = ACTIONS(87),
  },
  [8769] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(9963),
    [sym__binary_star] = ACTIONS(9965),
    [anon_sym_LBRACE] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(9967),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(9969),
    [anon_sym_AMP] = ACTIONS(9971),
    [anon_sym_EQ] = ACTIONS(7938),
    [anon_sym_LT] = ACTIONS(9973),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_EQ_GT] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_PLUS_EQ] = ACTIONS(6210),
    [anon_sym_DASH_EQ] = ACTIONS(6210),
    [anon_sym_STAR_EQ] = ACTIONS(6210),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6210),
    [anon_sym_SLASH_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6210),
    [anon_sym_AMP_EQ] = ACTIONS(6210),
    [anon_sym_PERCENT_EQ] = ACTIONS(6210),
    [anon_sym_GT_GT_EQ] = ACTIONS(6210),
    [anon_sym_LT_LT_EQ] = ACTIONS(6210),
    [anon_sym_CARET_EQ] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(9975),
    [anon_sym_DOT_DOT] = ACTIONS(9977),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9979),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(9981),
    [anon_sym_AMP_AMP] = ACTIONS(9981),
    [anon_sym_LT_LT] = ACTIONS(9983),
    [anon_sym_GT_GT] = ACTIONS(9983),
    [anon_sym_EQ_EQ] = ACTIONS(9981),
    [anon_sym_BANG_EQ] = ACTIONS(9985),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9985),
    [anon_sym_LT_EQ_GT] = ACTIONS(9985),
    [anon_sym_EQ_TILDE] = ACTIONS(9985),
    [anon_sym_BANG_TILDE] = ACTIONS(9985),
    [anon_sym_LT_EQ] = ACTIONS(9973),
    [anon_sym_GT] = ACTIONS(9973),
    [anon_sym_GT_EQ] = ACTIONS(9987),
    [anon_sym_CARET] = ACTIONS(9967),
    [anon_sym_PLUS] = ACTIONS(9989),
    [anon_sym_SLASH] = ACTIONS(9969),
    [anon_sym_PERCENT] = ACTIONS(9969),
    [sym_comment] = ACTIONS(87),
  },
  [8770] = {
    [sym_string] = STATE(8770),
    [aux_sym_chained_string_repeat1] = STATE(8770),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(9852),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6217),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_EQ] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_do] = ACTIONS(6212),
    [anon_sym_EQ_GT] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_PLUS_EQ] = ACTIONS(6212),
    [anon_sym_DASH_EQ] = ACTIONS(6212),
    [anon_sym_STAR_EQ] = ACTIONS(6212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6212),
    [anon_sym_SLASH_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6212),
    [anon_sym_AMP_EQ] = ACTIONS(6212),
    [anon_sym_PERCENT_EQ] = ACTIONS(6212),
    [anon_sym_GT_GT_EQ] = ACTIONS(6212),
    [anon_sym_LT_LT_EQ] = ACTIONS(6212),
    [anon_sym_CARET_EQ] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6217),
    [anon_sym_AMP_AMP] = ACTIONS(6217),
    [anon_sym_LT_LT] = ACTIONS(6217),
    [anon_sym_GT_GT] = ACTIONS(6217),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6217),
    [anon_sym_PLUS] = ACTIONS(6217),
    [anon_sym_SLASH] = ACTIONS(6217),
    [anon_sym_PERCENT] = ACTIONS(6217),
    [sym_comment] = ACTIONS(87),
  },
  [8771] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(12431),
    [sym__binary_star] = ACTIONS(12433),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(12435),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(12433),
    [anon_sym_AMP] = ACTIONS(12437),
    [anon_sym_LT] = ACTIONS(12439),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(12441),
    [anon_sym_DOT_DOT] = ACTIONS(12443),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12445),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(12447),
    [anon_sym_AMP_AMP] = ACTIONS(12447),
    [anon_sym_LT_LT] = ACTIONS(12449),
    [anon_sym_GT_GT] = ACTIONS(12449),
    [anon_sym_EQ_EQ] = ACTIONS(12451),
    [anon_sym_BANG_EQ] = ACTIONS(12447),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12447),
    [anon_sym_LT_EQ_GT] = ACTIONS(12447),
    [anon_sym_EQ_TILDE] = ACTIONS(12447),
    [anon_sym_BANG_TILDE] = ACTIONS(12447),
    [anon_sym_LT_EQ] = ACTIONS(12439),
    [anon_sym_GT] = ACTIONS(12439),
    [anon_sym_GT_EQ] = ACTIONS(12453),
    [anon_sym_CARET] = ACTIONS(12455),
    [anon_sym_PLUS] = ACTIONS(12431),
    [anon_sym_SLASH] = ACTIONS(12433),
    [anon_sym_PERCENT] = ACTIONS(12433),
    [sym_comment] = ACTIONS(87),
  },
  [8772] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(12433),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [8773] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(12431),
    [sym__binary_star] = ACTIONS(12433),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(12435),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(12433),
    [anon_sym_AMP] = ACTIONS(12437),
    [anon_sym_LT] = ACTIONS(12439),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(12441),
    [anon_sym_DOT_DOT] = ACTIONS(12443),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12445),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(12447),
    [anon_sym_AMP_AMP] = ACTIONS(12447),
    [anon_sym_LT_LT] = ACTIONS(12449),
    [anon_sym_GT_GT] = ACTIONS(12449),
    [anon_sym_EQ_EQ] = ACTIONS(12451),
    [anon_sym_BANG_EQ] = ACTIONS(12447),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12447),
    [anon_sym_LT_EQ_GT] = ACTIONS(12447),
    [anon_sym_EQ_TILDE] = ACTIONS(12447),
    [anon_sym_BANG_TILDE] = ACTIONS(12447),
    [anon_sym_LT_EQ] = ACTIONS(12439),
    [anon_sym_GT] = ACTIONS(12439),
    [anon_sym_GT_EQ] = ACTIONS(12453),
    [anon_sym_CARET] = ACTIONS(12455),
    [anon_sym_PLUS] = ACTIONS(12431),
    [anon_sym_SLASH] = ACTIONS(12433),
    [anon_sym_PERCENT] = ACTIONS(12433),
    [sym_comment] = ACTIONS(87),
  },
  [8774] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10139),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(6520),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(6520),
    [sym_assignment] = STATE(10139),
    [sym_operator_assignment] = STATE(10139),
    [sym_conditional] = STATE(10139),
    [sym_range] = STATE(10139),
    [sym_binary] = STATE(10139),
    [sym_unary] = STATE(10139),
    [sym_left_assignment_list] = STATE(6519),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6520),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(6520),
    [sym_false] = STATE(6520),
    [sym_nil] = STATE(6520),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(6420),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10003),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9861),
    [anon_sym_yield] = ACTIONS(9863),
    [anon_sym_break] = ACTIONS(9865),
    [anon_sym_next] = ACTIONS(9867),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10005),
    [anon_sym_defined_QMARK] = ACTIONS(10007),
    [anon_sym_not] = ACTIONS(10009),
    [anon_sym_BANG] = ACTIONS(10011),
    [anon_sym_TILDE] = ACTIONS(10011),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8775] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10140),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(6520),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(6520),
    [sym_assignment] = STATE(10140),
    [sym_operator_assignment] = STATE(10140),
    [sym_conditional] = STATE(10140),
    [sym_range] = STATE(10140),
    [sym_binary] = STATE(10140),
    [sym_unary] = STATE(10140),
    [sym_left_assignment_list] = STATE(6519),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6520),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(6520),
    [sym_false] = STATE(6520),
    [sym_nil] = STATE(6520),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(6420),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10003),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9861),
    [anon_sym_yield] = ACTIONS(9863),
    [anon_sym_break] = ACTIONS(9865),
    [anon_sym_next] = ACTIONS(9867),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10005),
    [anon_sym_defined_QMARK] = ACTIONS(10007),
    [anon_sym_not] = ACTIONS(10009),
    [anon_sym_BANG] = ACTIONS(10011),
    [anon_sym_TILDE] = ACTIONS(10011),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8776] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10141),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(6520),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(6520),
    [sym_assignment] = STATE(10141),
    [sym_operator_assignment] = STATE(10141),
    [sym_conditional] = STATE(10141),
    [sym_range] = STATE(10141),
    [sym_binary] = STATE(10141),
    [sym_unary] = STATE(10141),
    [sym_left_assignment_list] = STATE(6519),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6520),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(6520),
    [sym_false] = STATE(6520),
    [sym_nil] = STATE(6520),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(6420),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10003),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9861),
    [anon_sym_yield] = ACTIONS(9863),
    [anon_sym_break] = ACTIONS(9865),
    [anon_sym_next] = ACTIONS(9867),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10005),
    [anon_sym_defined_QMARK] = ACTIONS(10007),
    [anon_sym_not] = ACTIONS(10009),
    [anon_sym_BANG] = ACTIONS(10011),
    [anon_sym_TILDE] = ACTIONS(10011),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8777] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10142),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(6520),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(6520),
    [sym_assignment] = STATE(10142),
    [sym_operator_assignment] = STATE(10142),
    [sym_conditional] = STATE(10142),
    [sym_range] = STATE(10142),
    [sym_binary] = STATE(10142),
    [sym_unary] = STATE(10142),
    [sym_left_assignment_list] = STATE(6519),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6520),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(6520),
    [sym_false] = STATE(6520),
    [sym_nil] = STATE(6520),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(6420),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10003),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9861),
    [anon_sym_yield] = ACTIONS(9863),
    [anon_sym_break] = ACTIONS(9865),
    [anon_sym_next] = ACTIONS(9867),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10005),
    [anon_sym_defined_QMARK] = ACTIONS(10007),
    [anon_sym_not] = ACTIONS(10009),
    [anon_sym_BANG] = ACTIONS(10011),
    [anon_sym_TILDE] = ACTIONS(10011),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8778] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10143),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(6520),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(6520),
    [sym_assignment] = STATE(10143),
    [sym_operator_assignment] = STATE(10143),
    [sym_conditional] = STATE(10143),
    [sym_range] = STATE(10143),
    [sym_binary] = STATE(10143),
    [sym_unary] = STATE(10143),
    [sym_left_assignment_list] = STATE(6519),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6520),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(6520),
    [sym_false] = STATE(6520),
    [sym_nil] = STATE(6520),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(6420),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10003),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9861),
    [anon_sym_yield] = ACTIONS(9863),
    [anon_sym_break] = ACTIONS(9865),
    [anon_sym_next] = ACTIONS(9867),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10005),
    [anon_sym_defined_QMARK] = ACTIONS(10007),
    [anon_sym_not] = ACTIONS(10009),
    [anon_sym_BANG] = ACTIONS(10011),
    [anon_sym_TILDE] = ACTIONS(10011),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8779] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(10144),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(10144),
    [sym_operator_assignment] = STATE(10144),
    [sym_conditional] = STATE(10144),
    [sym_range] = STATE(10144),
    [sym_binary] = STATE(10144),
    [sym_unary] = STATE(10144),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8780] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10145),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(6520),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(6520),
    [sym_assignment] = STATE(10145),
    [sym_operator_assignment] = STATE(10145),
    [sym_conditional] = STATE(10145),
    [sym_range] = STATE(10145),
    [sym_binary] = STATE(10145),
    [sym_unary] = STATE(10145),
    [sym_left_assignment_list] = STATE(6519),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6520),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(6520),
    [sym_false] = STATE(6520),
    [sym_nil] = STATE(6520),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(6420),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10003),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9861),
    [anon_sym_yield] = ACTIONS(9863),
    [anon_sym_break] = ACTIONS(9865),
    [anon_sym_next] = ACTIONS(9867),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10005),
    [anon_sym_defined_QMARK] = ACTIONS(10007),
    [anon_sym_not] = ACTIONS(10009),
    [anon_sym_BANG] = ACTIONS(10011),
    [anon_sym_TILDE] = ACTIONS(10011),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8781] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10146),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(6520),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(6520),
    [sym_assignment] = STATE(10146),
    [sym_operator_assignment] = STATE(10146),
    [sym_conditional] = STATE(10146),
    [sym_range] = STATE(10146),
    [sym_binary] = STATE(10146),
    [sym_unary] = STATE(10146),
    [sym_left_assignment_list] = STATE(6519),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6520),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(6520),
    [sym_false] = STATE(6520),
    [sym_nil] = STATE(6520),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(6420),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10003),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9861),
    [anon_sym_yield] = ACTIONS(9863),
    [anon_sym_break] = ACTIONS(9865),
    [anon_sym_next] = ACTIONS(9867),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10005),
    [anon_sym_defined_QMARK] = ACTIONS(10007),
    [anon_sym_not] = ACTIONS(10009),
    [anon_sym_BANG] = ACTIONS(10011),
    [anon_sym_TILDE] = ACTIONS(10011),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8782] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10147),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(6520),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(6520),
    [sym_assignment] = STATE(10147),
    [sym_operator_assignment] = STATE(10147),
    [sym_conditional] = STATE(10147),
    [sym_range] = STATE(10147),
    [sym_binary] = STATE(10147),
    [sym_unary] = STATE(10147),
    [sym_left_assignment_list] = STATE(6519),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6520),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(6520),
    [sym_false] = STATE(6520),
    [sym_nil] = STATE(6520),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(6420),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10003),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9861),
    [anon_sym_yield] = ACTIONS(9863),
    [anon_sym_break] = ACTIONS(9865),
    [anon_sym_next] = ACTIONS(9867),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10005),
    [anon_sym_defined_QMARK] = ACTIONS(10007),
    [anon_sym_not] = ACTIONS(10009),
    [anon_sym_BANG] = ACTIONS(10011),
    [anon_sym_TILDE] = ACTIONS(10011),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8783] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10148),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(6520),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(6520),
    [sym_assignment] = STATE(10148),
    [sym_operator_assignment] = STATE(10148),
    [sym_conditional] = STATE(10148),
    [sym_range] = STATE(10148),
    [sym_binary] = STATE(10148),
    [sym_unary] = STATE(10148),
    [sym_left_assignment_list] = STATE(6519),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6520),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(6520),
    [sym_false] = STATE(6520),
    [sym_nil] = STATE(6520),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(6420),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10003),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9861),
    [anon_sym_yield] = ACTIONS(9863),
    [anon_sym_break] = ACTIONS(9865),
    [anon_sym_next] = ACTIONS(9867),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10005),
    [anon_sym_defined_QMARK] = ACTIONS(10007),
    [anon_sym_not] = ACTIONS(10009),
    [anon_sym_BANG] = ACTIONS(10011),
    [anon_sym_TILDE] = ACTIONS(10011),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8784] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(6517),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(6520),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(6520),
    [sym_splat_argument] = STATE(6406),
    [sym_assignment] = STATE(6517),
    [sym_operator_assignment] = STATE(6517),
    [sym_conditional] = STATE(6517),
    [sym_range] = STATE(6517),
    [sym_binary] = STATE(6517),
    [sym_unary] = STATE(6517),
    [sym__arg_or_splat_arg] = STATE(6406),
    [sym_left_assignment_list] = STATE(6519),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6520),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(6520),
    [sym_false] = STATE(6520),
    [sym_nil] = STATE(6520),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(6420),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(10001),
    [sym__unary_minus] = ACTIONS(10003),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9861),
    [anon_sym_yield] = ACTIONS(9863),
    [anon_sym_break] = ACTIONS(9865),
    [anon_sym_next] = ACTIONS(9867),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10005),
    [anon_sym_defined_QMARK] = ACTIONS(10007),
    [anon_sym_not] = ACTIONS(10009),
    [anon_sym_BANG] = ACTIONS(10011),
    [anon_sym_TILDE] = ACTIONS(10011),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8785] = {
    [aux_sym_exceptions_repeat1] = STATE(10149),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_COMMA] = ACTIONS(12457),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [8786] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(6517),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(6520),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(6520),
    [sym_splat_argument] = STATE(10150),
    [sym_assignment] = STATE(6517),
    [sym_operator_assignment] = STATE(6517),
    [sym_conditional] = STATE(6517),
    [sym_range] = STATE(6517),
    [sym_binary] = STATE(6517),
    [sym_unary] = STATE(6517),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(10150),
    [sym_left_assignment_list] = STATE(6519),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6520),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(6520),
    [sym_false] = STATE(6520),
    [sym_nil] = STATE(6520),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(6420),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(10001),
    [sym__unary_minus] = ACTIONS(10003),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9861),
    [anon_sym_yield] = ACTIONS(9863),
    [anon_sym_break] = ACTIONS(9865),
    [anon_sym_next] = ACTIONS(9867),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10005),
    [anon_sym_defined_QMARK] = ACTIONS(10007),
    [anon_sym_not] = ACTIONS(10009),
    [anon_sym_BANG] = ACTIONS(10011),
    [anon_sym_TILDE] = ACTIONS(10011),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8787] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10151),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(6520),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(6520),
    [sym_assignment] = STATE(10151),
    [sym_operator_assignment] = STATE(10151),
    [sym_conditional] = STATE(10151),
    [sym_range] = STATE(10151),
    [sym_binary] = STATE(10151),
    [sym_unary] = STATE(10151),
    [sym_left_assignment_list] = STATE(6519),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6520),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(6520),
    [sym_false] = STATE(6520),
    [sym_nil] = STATE(6520),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(6420),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10003),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9861),
    [anon_sym_yield] = ACTIONS(9863),
    [anon_sym_break] = ACTIONS(9865),
    [anon_sym_next] = ACTIONS(9867),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10005),
    [anon_sym_defined_QMARK] = ACTIONS(10007),
    [anon_sym_not] = ACTIONS(10009),
    [anon_sym_BANG] = ACTIONS(10011),
    [anon_sym_TILDE] = ACTIONS(10011),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8788] = {
    [sym_heredoc_body] = STATE(10152),
    [aux_sym_call_repeat1] = STATE(10152),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_RBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [8789] = {
    [sym_heredoc_body] = STATE(10153),
    [aux_sym_call_repeat1] = STATE(10153),
    [aux_sym_argument_list_repeat1] = STATE(6573),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_RBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(6421),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [8790] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(10019),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(10019),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(10019),
    [anon_sym_PERCENT] = ACTIONS(10019),
    [sym_comment] = ACTIONS(87),
  },
  [8791] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(10019),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [8792] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10017),
    [sym__binary_star] = ACTIONS(10019),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(10019),
    [anon_sym_AMP] = ACTIONS(10023),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(10035),
    [anon_sym_GT_GT] = ACTIONS(10035),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(10017),
    [anon_sym_SLASH] = ACTIONS(10019),
    [anon_sym_PERCENT] = ACTIONS(10019),
    [sym_comment] = ACTIONS(87),
  },
  [8793] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10017),
    [sym__binary_star] = ACTIONS(10019),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(10019),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(10035),
    [anon_sym_GT_GT] = ACTIONS(10035),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(10017),
    [anon_sym_SLASH] = ACTIONS(10019),
    [anon_sym_PERCENT] = ACTIONS(10019),
    [sym_comment] = ACTIONS(87),
  },
  [8794] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10017),
    [sym__binary_star] = ACTIONS(10019),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(10021),
    [anon_sym_STAR_STAR] = ACTIONS(10019),
    [anon_sym_AMP] = ACTIONS(10023),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(10035),
    [anon_sym_GT_GT] = ACTIONS(10035),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(10041),
    [anon_sym_PLUS] = ACTIONS(10017),
    [anon_sym_SLASH] = ACTIONS(10019),
    [anon_sym_PERCENT] = ACTIONS(10019),
    [sym_comment] = ACTIONS(87),
  },
  [8795] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(13813),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [8796] = {
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(10017),
    [sym__binary_star] = ACTIONS(10019),
    [anon_sym_RBRACE] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(10021),
    [anon_sym_STAR_STAR] = ACTIONS(10019),
    [anon_sym_AMP] = ACTIONS(10023),
    [anon_sym_LT] = ACTIONS(10025),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(10029),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10031),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(10033),
    [anon_sym_AMP_AMP] = ACTIONS(10033),
    [anon_sym_LT_LT] = ACTIONS(10035),
    [anon_sym_GT_GT] = ACTIONS(10035),
    [anon_sym_EQ_EQ] = ACTIONS(10037),
    [anon_sym_BANG_EQ] = ACTIONS(10033),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10033),
    [anon_sym_LT_EQ_GT] = ACTIONS(10033),
    [anon_sym_EQ_TILDE] = ACTIONS(10033),
    [anon_sym_BANG_TILDE] = ACTIONS(10033),
    [anon_sym_LT_EQ] = ACTIONS(10025),
    [anon_sym_GT] = ACTIONS(10025),
    [anon_sym_GT_EQ] = ACTIONS(10039),
    [anon_sym_CARET] = ACTIONS(10041),
    [anon_sym_PLUS] = ACTIONS(10017),
    [anon_sym_SLASH] = ACTIONS(10019),
    [anon_sym_PERCENT] = ACTIONS(10019),
    [sym_comment] = ACTIONS(87),
  },
  [8797] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10017),
    [sym__binary_star] = ACTIONS(10019),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(10021),
    [anon_sym_STAR_STAR] = ACTIONS(10019),
    [anon_sym_AMP] = ACTIONS(10023),
    [anon_sym_LT] = ACTIONS(10025),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(10027),
    [anon_sym_DOT_DOT] = ACTIONS(10029),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10031),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(10033),
    [anon_sym_AMP_AMP] = ACTIONS(10033),
    [anon_sym_LT_LT] = ACTIONS(10035),
    [anon_sym_GT_GT] = ACTIONS(10035),
    [anon_sym_EQ_EQ] = ACTIONS(10037),
    [anon_sym_BANG_EQ] = ACTIONS(10033),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10033),
    [anon_sym_LT_EQ_GT] = ACTIONS(10033),
    [anon_sym_EQ_TILDE] = ACTIONS(10033),
    [anon_sym_BANG_TILDE] = ACTIONS(10033),
    [anon_sym_LT_EQ] = ACTIONS(10025),
    [anon_sym_GT] = ACTIONS(10025),
    [anon_sym_GT_EQ] = ACTIONS(10039),
    [anon_sym_CARET] = ACTIONS(10041),
    [anon_sym_PLUS] = ACTIONS(10017),
    [anon_sym_SLASH] = ACTIONS(10019),
    [anon_sym_PERCENT] = ACTIONS(10019),
    [sym_comment] = ACTIONS(87),
  },
  [8798] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10017),
    [sym__binary_star] = ACTIONS(10019),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(10021),
    [anon_sym_STAR_STAR] = ACTIONS(10019),
    [anon_sym_AMP] = ACTIONS(10023),
    [anon_sym_LT] = ACTIONS(10025),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(10035),
    [anon_sym_GT_GT] = ACTIONS(10035),
    [anon_sym_EQ_EQ] = ACTIONS(10037),
    [anon_sym_BANG_EQ] = ACTIONS(10033),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10033),
    [anon_sym_LT_EQ_GT] = ACTIONS(10033),
    [anon_sym_EQ_TILDE] = ACTIONS(10033),
    [anon_sym_BANG_TILDE] = ACTIONS(10033),
    [anon_sym_LT_EQ] = ACTIONS(10025),
    [anon_sym_GT] = ACTIONS(10025),
    [anon_sym_GT_EQ] = ACTIONS(10039),
    [anon_sym_CARET] = ACTIONS(10041),
    [anon_sym_PLUS] = ACTIONS(10017),
    [anon_sym_SLASH] = ACTIONS(10019),
    [anon_sym_PERCENT] = ACTIONS(10019),
    [sym_comment] = ACTIONS(87),
  },
  [8799] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10017),
    [sym__binary_star] = ACTIONS(10019),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(10019),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(10017),
    [anon_sym_SLASH] = ACTIONS(10019),
    [anon_sym_PERCENT] = ACTIONS(10019),
    [sym_comment] = ACTIONS(87),
  },
  [8800] = {
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(10017),
    [sym__binary_star] = ACTIONS(10019),
    [anon_sym_RBRACE] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(10021),
    [anon_sym_STAR_STAR] = ACTIONS(10019),
    [anon_sym_AMP] = ACTIONS(10023),
    [anon_sym_LT] = ACTIONS(10025),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(10027),
    [anon_sym_DOT_DOT] = ACTIONS(10029),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10031),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(10033),
    [anon_sym_AMP_AMP] = ACTIONS(10033),
    [anon_sym_LT_LT] = ACTIONS(10035),
    [anon_sym_GT_GT] = ACTIONS(10035),
    [anon_sym_EQ_EQ] = ACTIONS(10037),
    [anon_sym_BANG_EQ] = ACTIONS(10033),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10033),
    [anon_sym_LT_EQ_GT] = ACTIONS(10033),
    [anon_sym_EQ_TILDE] = ACTIONS(10033),
    [anon_sym_BANG_TILDE] = ACTIONS(10033),
    [anon_sym_LT_EQ] = ACTIONS(10025),
    [anon_sym_GT] = ACTIONS(10025),
    [anon_sym_GT_EQ] = ACTIONS(10039),
    [anon_sym_CARET] = ACTIONS(10041),
    [anon_sym_PLUS] = ACTIONS(10017),
    [anon_sym_SLASH] = ACTIONS(10019),
    [anon_sym_PERCENT] = ACTIONS(10019),
    [sym_comment] = ACTIONS(87),
  },
  [8801] = {
    [aux_sym_exceptions_repeat1] = STATE(10156),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_RBRACE] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [8802] = {
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(10017),
    [sym__binary_star] = ACTIONS(10019),
    [anon_sym_RBRACE] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(10021),
    [anon_sym_STAR_STAR] = ACTIONS(10019),
    [anon_sym_AMP] = ACTIONS(10023),
    [anon_sym_LT] = ACTIONS(10025),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(10027),
    [anon_sym_DOT_DOT] = ACTIONS(10029),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10031),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(10033),
    [anon_sym_AMP_AMP] = ACTIONS(10033),
    [anon_sym_LT_LT] = ACTIONS(10035),
    [anon_sym_GT_GT] = ACTIONS(10035),
    [anon_sym_EQ_EQ] = ACTIONS(10037),
    [anon_sym_BANG_EQ] = ACTIONS(10033),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10033),
    [anon_sym_LT_EQ_GT] = ACTIONS(10033),
    [anon_sym_EQ_TILDE] = ACTIONS(10033),
    [anon_sym_BANG_TILDE] = ACTIONS(10033),
    [anon_sym_LT_EQ] = ACTIONS(10025),
    [anon_sym_GT] = ACTIONS(10025),
    [anon_sym_GT_EQ] = ACTIONS(10039),
    [anon_sym_CARET] = ACTIONS(10041),
    [anon_sym_PLUS] = ACTIONS(10017),
    [anon_sym_SLASH] = ACTIONS(10019),
    [anon_sym_PERCENT] = ACTIONS(10019),
    [sym_comment] = ACTIONS(87),
  },
  [8803] = {
    [sym_string] = STATE(8803),
    [aux_sym_chained_string_repeat1] = STATE(8803),
    [sym__string_start] = ACTIONS(9407),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_RBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [8804] = {
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(6387),
    [sym__binary_star] = ACTIONS(6389),
    [anon_sym_RBRACE] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(6391),
    [anon_sym_STAR_STAR] = ACTIONS(6389),
    [anon_sym_AMP] = ACTIONS(6393),
    [anon_sym_LT] = ACTIONS(6395),
    [anon_sym_if] = ACTIONS(6823),
    [anon_sym_unless] = ACTIONS(6823),
    [anon_sym_while] = ACTIONS(6823),
    [anon_sym_until] = ACTIONS(6823),
    [anon_sym_rescue] = ACTIONS(6823),
    [anon_sym_EQ_GT] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(6397),
    [anon_sym_DOT_DOT] = ACTIONS(6399),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6401),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(6403),
    [anon_sym_AMP_AMP] = ACTIONS(6403),
    [anon_sym_LT_LT] = ACTIONS(6405),
    [anon_sym_GT_GT] = ACTIONS(6405),
    [anon_sym_EQ_EQ] = ACTIONS(6407),
    [anon_sym_BANG_EQ] = ACTIONS(6403),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6403),
    [anon_sym_LT_EQ_GT] = ACTIONS(6403),
    [anon_sym_EQ_TILDE] = ACTIONS(6403),
    [anon_sym_BANG_TILDE] = ACTIONS(6403),
    [anon_sym_LT_EQ] = ACTIONS(6395),
    [anon_sym_GT] = ACTIONS(6395),
    [anon_sym_GT_EQ] = ACTIONS(6409),
    [anon_sym_CARET] = ACTIONS(6411),
    [anon_sym_PLUS] = ACTIONS(6387),
    [anon_sym_SLASH] = ACTIONS(6389),
    [anon_sym_PERCENT] = ACTIONS(6389),
    [sym_comment] = ACTIONS(87),
  },
  [8805] = {
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(6387),
    [sym__binary_star] = ACTIONS(6389),
    [anon_sym_RBRACE] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(6391),
    [anon_sym_STAR_STAR] = ACTIONS(6389),
    [anon_sym_AMP] = ACTIONS(6393),
    [anon_sym_LT] = ACTIONS(6395),
    [anon_sym_if] = ACTIONS(7027),
    [anon_sym_unless] = ACTIONS(7027),
    [anon_sym_while] = ACTIONS(7027),
    [anon_sym_until] = ACTIONS(7027),
    [anon_sym_rescue] = ACTIONS(7027),
    [anon_sym_EQ_GT] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(6397),
    [anon_sym_DOT_DOT] = ACTIONS(6399),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6401),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(6403),
    [anon_sym_AMP_AMP] = ACTIONS(6403),
    [anon_sym_LT_LT] = ACTIONS(6405),
    [anon_sym_GT_GT] = ACTIONS(6405),
    [anon_sym_EQ_EQ] = ACTIONS(6407),
    [anon_sym_BANG_EQ] = ACTIONS(6403),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6403),
    [anon_sym_LT_EQ_GT] = ACTIONS(6403),
    [anon_sym_EQ_TILDE] = ACTIONS(6403),
    [anon_sym_BANG_TILDE] = ACTIONS(6403),
    [anon_sym_LT_EQ] = ACTIONS(6395),
    [anon_sym_GT] = ACTIONS(6395),
    [anon_sym_GT_EQ] = ACTIONS(6409),
    [anon_sym_CARET] = ACTIONS(6411),
    [anon_sym_PLUS] = ACTIONS(6387),
    [anon_sym_SLASH] = ACTIONS(6389),
    [anon_sym_PERCENT] = ACTIONS(6389),
    [sym_comment] = ACTIONS(87),
  },
  [8806] = {
    [sym_heredoc_body] = STATE(8806),
    [aux_sym_call_repeat1] = STATE(8806),
    [sym__heredoc_body_start] = ACTIONS(10455),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_RBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_EQ_GT] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [8807] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(3849),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1638),
    [sym_scope_resolution] = STATE(1634),
    [sym_call] = STATE(1634),
    [sym_method_call] = STATE(1638),
    [sym__argument] = STATE(6908),
    [sym_splat_argument] = STATE(6908),
    [sym_hash_splat_argument] = STATE(6908),
    [sym_block_argument] = STATE(6908),
    [sym_assignment] = STATE(3849),
    [sym_operator_assignment] = STATE(3849),
    [sym_conditional] = STATE(3849),
    [sym_range] = STATE(3849),
    [sym_binary] = STATE(3849),
    [sym_unary] = STATE(3849),
    [sym_left_assignment_list] = STATE(1637),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1638),
    [sym__variable] = STATE(1634),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1638),
    [sym_false] = STATE(1638),
    [sym_nil] = STATE(1638),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(3852),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(6908),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(6377),
    [sym__splat_star] = ACTIONS(6379),
    [sym__unary_minus] = ACTIONS(2904),
    [sym__identifier_hash_key] = ACTIONS(6381),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12465),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(2910),
    [anon_sym_break] = ACTIONS(2912),
    [anon_sym_next] = ACTIONS(2914),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6373),
    [anon_sym_defined_QMARK] = ACTIONS(2916),
    [anon_sym_not] = ACTIONS(2918),
    [anon_sym_BANG] = ACTIONS(2922),
    [anon_sym_TILDE] = ACTIONS(2922),
    [sym_constant] = ACTIONS(6383),
    [sym_identifier] = ACTIONS(6383),
    [sym_instance_variable] = ACTIONS(2926),
    [sym_class_variable] = ACTIONS(2926),
    [sym_global_variable] = ACTIONS(2926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2928),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2928),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8808] = {
    [sym_heredoc_body] = STATE(8806),
    [aux_sym_call_repeat1] = STATE(8806),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_RBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_EQ_GT] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [8809] = {
    [aux_sym_argument_list_repeat1] = STATE(8809),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_RBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(13815),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_STAR_STAR] = ACTIONS(7925),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_if] = ACTIONS(7925),
    [anon_sym_unless] = ACTIONS(7925),
    [anon_sym_while] = ACTIONS(7925),
    [anon_sym_until] = ACTIONS(7925),
    [anon_sym_rescue] = ACTIONS(7925),
    [anon_sym_EQ_GT] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7925),
    [anon_sym_AMP_AMP] = ACTIONS(7925),
    [anon_sym_LT_LT] = ACTIONS(7925),
    [anon_sym_GT_GT] = ACTIONS(7925),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7925),
    [anon_sym_PLUS] = ACTIONS(7925),
    [anon_sym_SLASH] = ACTIONS(7925),
    [anon_sym_PERCENT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [8810] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(10157),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1638),
    [sym_scope_resolution] = STATE(1634),
    [sym_call] = STATE(1634),
    [sym_method_call] = STATE(1638),
    [sym_assignment] = STATE(10157),
    [sym_operator_assignment] = STATE(10157),
    [sym_conditional] = STATE(10157),
    [sym_range] = STATE(10157),
    [sym_binary] = STATE(10157),
    [sym_unary] = STATE(10157),
    [sym_left_assignment_list] = STATE(1637),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1638),
    [sym__variable] = STATE(1634),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1638),
    [sym_false] = STATE(1638),
    [sym_nil] = STATE(1638),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(3841),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(2910),
    [anon_sym_break] = ACTIONS(2912),
    [anon_sym_next] = ACTIONS(2914),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6373),
    [anon_sym_defined_QMARK] = ACTIONS(2916),
    [anon_sym_not] = ACTIONS(2918),
    [anon_sym_BANG] = ACTIONS(2922),
    [anon_sym_TILDE] = ACTIONS(2922),
    [sym_constant] = ACTIONS(2928),
    [sym_identifier] = ACTIONS(2928),
    [sym_instance_variable] = ACTIONS(2926),
    [sym_class_variable] = ACTIONS(2926),
    [sym_global_variable] = ACTIONS(2926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2928),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2928),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8811] = {
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(6537),
    [sym__binary_star] = ACTIONS(6539),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_RBRACE] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(6541),
    [anon_sym_STAR_STAR] = ACTIONS(6543),
    [anon_sym_AMP] = ACTIONS(6545),
    [anon_sym_EQ] = ACTIONS(7822),
    [anon_sym_LT] = ACTIONS(6547),
    [anon_sym_if] = ACTIONS(6823),
    [anon_sym_unless] = ACTIONS(6823),
    [anon_sym_while] = ACTIONS(6823),
    [anon_sym_until] = ACTIONS(6823),
    [anon_sym_rescue] = ACTIONS(6823),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_EQ_GT] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_PLUS_EQ] = ACTIONS(6823),
    [anon_sym_DASH_EQ] = ACTIONS(6823),
    [anon_sym_STAR_EQ] = ACTIONS(6823),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6823),
    [anon_sym_SLASH_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6823),
    [anon_sym_AMP_EQ] = ACTIONS(6823),
    [anon_sym_PERCENT_EQ] = ACTIONS(6823),
    [anon_sym_GT_GT_EQ] = ACTIONS(6823),
    [anon_sym_LT_LT_EQ] = ACTIONS(6823),
    [anon_sym_CARET_EQ] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(6549),
    [anon_sym_DOT_DOT] = ACTIONS(6551),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6553),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(6555),
    [anon_sym_AMP_AMP] = ACTIONS(6555),
    [anon_sym_LT_LT] = ACTIONS(6557),
    [anon_sym_GT_GT] = ACTIONS(6557),
    [anon_sym_EQ_EQ] = ACTIONS(6555),
    [anon_sym_BANG_EQ] = ACTIONS(6559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6559),
    [anon_sym_LT_EQ_GT] = ACTIONS(6559),
    [anon_sym_EQ_TILDE] = ACTIONS(6559),
    [anon_sym_BANG_TILDE] = ACTIONS(6559),
    [anon_sym_LT_EQ] = ACTIONS(6547),
    [anon_sym_GT] = ACTIONS(6547),
    [anon_sym_GT_EQ] = ACTIONS(6561),
    [anon_sym_CARET] = ACTIONS(6541),
    [anon_sym_PLUS] = ACTIONS(6563),
    [anon_sym_SLASH] = ACTIONS(6543),
    [anon_sym_PERCENT] = ACTIONS(6543),
    [sym_comment] = ACTIONS(87),
  },
  [8812] = {
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(6537),
    [sym__binary_star] = ACTIONS(6539),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_RBRACE] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(6541),
    [anon_sym_STAR_STAR] = ACTIONS(6543),
    [anon_sym_AMP] = ACTIONS(6545),
    [anon_sym_EQ] = ACTIONS(7884),
    [anon_sym_LT] = ACTIONS(6547),
    [anon_sym_if] = ACTIONS(7027),
    [anon_sym_unless] = ACTIONS(7027),
    [anon_sym_while] = ACTIONS(7027),
    [anon_sym_until] = ACTIONS(7027),
    [anon_sym_rescue] = ACTIONS(7027),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_EQ_GT] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_PLUS_EQ] = ACTIONS(7027),
    [anon_sym_DASH_EQ] = ACTIONS(7027),
    [anon_sym_STAR_EQ] = ACTIONS(7027),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7027),
    [anon_sym_SLASH_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7027),
    [anon_sym_AMP_EQ] = ACTIONS(7027),
    [anon_sym_PERCENT_EQ] = ACTIONS(7027),
    [anon_sym_GT_GT_EQ] = ACTIONS(7027),
    [anon_sym_LT_LT_EQ] = ACTIONS(7027),
    [anon_sym_CARET_EQ] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(6549),
    [anon_sym_DOT_DOT] = ACTIONS(6551),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6553),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(6555),
    [anon_sym_AMP_AMP] = ACTIONS(6555),
    [anon_sym_LT_LT] = ACTIONS(6557),
    [anon_sym_GT_GT] = ACTIONS(6557),
    [anon_sym_EQ_EQ] = ACTIONS(6555),
    [anon_sym_BANG_EQ] = ACTIONS(6559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6559),
    [anon_sym_LT_EQ_GT] = ACTIONS(6559),
    [anon_sym_EQ_TILDE] = ACTIONS(6559),
    [anon_sym_BANG_TILDE] = ACTIONS(6559),
    [anon_sym_LT_EQ] = ACTIONS(6547),
    [anon_sym_GT] = ACTIONS(6547),
    [anon_sym_GT_EQ] = ACTIONS(6561),
    [anon_sym_CARET] = ACTIONS(6541),
    [anon_sym_PLUS] = ACTIONS(6563),
    [anon_sym_SLASH] = ACTIONS(6543),
    [anon_sym_PERCENT] = ACTIONS(6543),
    [sym_comment] = ACTIONS(87),
  },
  [8813] = {
    [sym_heredoc_body] = STATE(8813),
    [aux_sym_call_repeat1] = STATE(8813),
    [sym__heredoc_body_start] = ACTIONS(10553),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_RBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_STAR_STAR] = ACTIONS(7919),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_EQ] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_EQ_GT] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_PLUS_EQ] = ACTIONS(7914),
    [anon_sym_DASH_EQ] = ACTIONS(7914),
    [anon_sym_STAR_EQ] = ACTIONS(7914),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7914),
    [anon_sym_SLASH_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7914),
    [anon_sym_AMP_EQ] = ACTIONS(7914),
    [anon_sym_PERCENT_EQ] = ACTIONS(7914),
    [anon_sym_GT_GT_EQ] = ACTIONS(7914),
    [anon_sym_LT_LT_EQ] = ACTIONS(7914),
    [anon_sym_CARET_EQ] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7919),
    [anon_sym_AMP_AMP] = ACTIONS(7919),
    [anon_sym_LT_LT] = ACTIONS(7919),
    [anon_sym_GT_GT] = ACTIONS(7919),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7919),
    [anon_sym_PLUS] = ACTIONS(7919),
    [anon_sym_SLASH] = ACTIONS(7919),
    [anon_sym_PERCENT] = ACTIONS(7919),
    [sym_comment] = ACTIONS(87),
  },
  [8814] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3870),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1686),
    [sym_scope_resolution] = STATE(1680),
    [sym_call] = STATE(1680),
    [sym_method_call] = STATE(1686),
    [sym__argument] = STATE(6970),
    [sym_splat_argument] = STATE(6970),
    [sym_hash_splat_argument] = STATE(6970),
    [sym_block_argument] = STATE(6970),
    [sym_assignment] = STATE(3870),
    [sym_operator_assignment] = STATE(3870),
    [sym_conditional] = STATE(3870),
    [sym_range] = STATE(3870),
    [sym_binary] = STATE(3870),
    [sym_unary] = STATE(3870),
    [sym_left_assignment_list] = STATE(1685),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1686),
    [sym__variable] = STATE(1680),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1686),
    [sym_false] = STATE(1686),
    [sym_nil] = STATE(1686),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3873),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(6970),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(6413),
    [sym__splat_star] = ACTIONS(6415),
    [sym__unary_minus] = ACTIONS(2992),
    [sym__identifier_hash_key] = ACTIONS(6417),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12469),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2998),
    [anon_sym_yield] = ACTIONS(3000),
    [anon_sym_break] = ACTIONS(3002),
    [anon_sym_next] = ACTIONS(3004),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6523),
    [anon_sym_defined_QMARK] = ACTIONS(3010),
    [anon_sym_not] = ACTIONS(3012),
    [anon_sym_BANG] = ACTIONS(3016),
    [anon_sym_TILDE] = ACTIONS(3016),
    [sym_constant] = ACTIONS(6419),
    [sym_identifier] = ACTIONS(6419),
    [sym_instance_variable] = ACTIONS(3020),
    [sym_class_variable] = ACTIONS(3020),
    [sym_global_variable] = ACTIONS(3020),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3022),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3022),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [8815] = {
    [sym_heredoc_body] = STATE(8813),
    [aux_sym_call_repeat1] = STATE(8813),
    [sym__heredoc_body_start] = ACTIONS(3543),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_RBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_STAR_STAR] = ACTIONS(7931),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_EQ] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_EQ_GT] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_PLUS_EQ] = ACTIONS(7929),
    [anon_sym_DASH_EQ] = ACTIONS(7929),
    [anon_sym_STAR_EQ] = ACTIONS(7929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7929),
    [anon_sym_SLASH_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7929),
    [anon_sym_AMP_EQ] = ACTIONS(7929),
    [anon_sym_PERCENT_EQ] = ACTIONS(7929),
    [anon_sym_GT_GT_EQ] = ACTIONS(7929),
    [anon_sym_LT_LT_EQ] = ACTIONS(7929),
    [anon_sym_CARET_EQ] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7931),
    [anon_sym_AMP_AMP] = ACTIONS(7931),
    [anon_sym_LT_LT] = ACTIONS(7931),
    [anon_sym_GT_GT] = ACTIONS(7931),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7931),
    [anon_sym_PLUS] = ACTIONS(7931),
    [anon_sym_SLASH] = ACTIONS(7931),
    [anon_sym_PERCENT] = ACTIONS(7931),
    [sym_comment] = ACTIONS(87),
  },
  [8816] = {
    [aux_sym_argument_list_repeat1] = STATE(8816),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_RBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(13818),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_STAR_STAR] = ACTIONS(7927),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_EQ] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_if] = ACTIONS(7925),
    [anon_sym_unless] = ACTIONS(7925),
    [anon_sym_while] = ACTIONS(7925),
    [anon_sym_until] = ACTIONS(7925),
    [anon_sym_rescue] = ACTIONS(7925),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_EQ_GT] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_PLUS_EQ] = ACTIONS(7925),
    [anon_sym_DASH_EQ] = ACTIONS(7925),
    [anon_sym_STAR_EQ] = ACTIONS(7925),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7925),
    [anon_sym_SLASH_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7925),
    [anon_sym_AMP_EQ] = ACTIONS(7925),
    [anon_sym_PERCENT_EQ] = ACTIONS(7925),
    [anon_sym_GT_GT_EQ] = ACTIONS(7925),
    [anon_sym_LT_LT_EQ] = ACTIONS(7925),
    [anon_sym_CARET_EQ] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7927),
    [anon_sym_AMP_AMP] = ACTIONS(7927),
    [anon_sym_LT_LT] = ACTIONS(7927),
    [anon_sym_GT_GT] = ACTIONS(7927),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7927),
    [anon_sym_PLUS] = ACTIONS(7927),
    [anon_sym_SLASH] = ACTIONS(7927),
    [anon_sym_PERCENT] = ACTIONS(7927),
    [sym_comment] = ACTIONS(87),
  },
  [8817] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(6574),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1638),
    [sym_scope_resolution] = STATE(1634),
    [sym_call] = STATE(1634),
    [sym_method_call] = STATE(1638),
    [sym_splat_argument] = STATE(9013),
    [sym_assignment] = STATE(6574),
    [sym_operator_assignment] = STATE(6574),
    [sym_conditional] = STATE(6574),
    [sym_range] = STATE(6574),
    [sym_binary] = STATE(6574),
    [sym_unary] = STATE(6574),
    [sym__arg_or_splat_arg] = STATE(9013),
    [sym_left_assignment_list] = STATE(1637),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1638),
    [sym__variable] = STATE(1634),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1638),
    [sym_false] = STATE(1638),
    [sym_nil] = STATE(1638),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(3841),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(6379),
    [sym__unary_minus] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(2910),
    [anon_sym_break] = ACTIONS(2912),
    [anon_sym_next] = ACTIONS(2914),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6373),
    [anon_sym_defined_QMARK] = ACTIONS(2916),
    [anon_sym_not] = ACTIONS(2918),
    [anon_sym_BANG] = ACTIONS(2922),
    [anon_sym_TILDE] = ACTIONS(2922),
    [sym_constant] = ACTIONS(2928),
    [sym_identifier] = ACTIONS(2928),
    [sym_instance_variable] = ACTIONS(2926),
    [sym_class_variable] = ACTIONS(2926),
    [sym_global_variable] = ACTIONS(2926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2928),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2928),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8818] = {
    [aux_sym_exceptions_repeat1] = STATE(10158),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_RBRACE] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(13821),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_EQ_GT] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [8819] = {
    [sym__binary_minus] = ACTIONS(2952),
    [sym__binary_star] = ACTIONS(2954),
    [anon_sym_RBRACE] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(2956),
    [anon_sym_STAR_STAR] = ACTIONS(2954),
    [anon_sym_AMP] = ACTIONS(2958),
    [anon_sym_LT] = ACTIONS(2960),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(2962),
    [anon_sym_DOT_DOT] = ACTIONS(2964),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2966),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(2970),
    [anon_sym_AMP_AMP] = ACTIONS(2970),
    [anon_sym_LT_LT] = ACTIONS(2972),
    [anon_sym_GT_GT] = ACTIONS(2972),
    [anon_sym_EQ_EQ] = ACTIONS(2974),
    [anon_sym_BANG_EQ] = ACTIONS(2970),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2970),
    [anon_sym_LT_EQ_GT] = ACTIONS(2970),
    [anon_sym_EQ_TILDE] = ACTIONS(2970),
    [anon_sym_BANG_TILDE] = ACTIONS(2970),
    [anon_sym_LT_EQ] = ACTIONS(2960),
    [anon_sym_GT] = ACTIONS(2960),
    [anon_sym_GT_EQ] = ACTIONS(2976),
    [anon_sym_CARET] = ACTIONS(2978),
    [anon_sym_PLUS] = ACTIONS(2952),
    [anon_sym_SLASH] = ACTIONS(2954),
    [anon_sym_PERCENT] = ACTIONS(2954),
    [sym_comment] = ACTIONS(87),
  },
  [8820] = {
    [sym__simple_symbol] = ACTIONS(7876),
    [sym__string_start] = ACTIONS(7876),
    [sym__symbol_start] = ACTIONS(7876),
    [sym__subshell_start] = ACTIONS(7876),
    [sym__regex_start] = ACTIONS(7876),
    [sym__string_array_start] = ACTIONS(7876),
    [sym__symbol_array_start] = ACTIONS(7876),
    [sym_heredoc_beginning] = ACTIONS(7876),
    [sym__block_ampersand] = ACTIONS(7876),
    [sym__splat_star] = ACTIONS(7876),
    [sym__unary_minus] = ACTIONS(7876),
    [sym__binary_minus] = ACTIONS(7876),
    [sym__binary_star] = ACTIONS(7876),
    [sym__identifier_hash_key] = ACTIONS(7876),
    [anon_sym_LBRACE] = ACTIONS(7876),
    [anon_sym_RBRACE] = ACTIONS(7876),
    [anon_sym_def] = ACTIONS(7878),
    [anon_sym_LPAREN] = ACTIONS(7878),
    [anon_sym_RPAREN] = ACTIONS(7876),
    [anon_sym_DOT] = ACTIONS(7878),
    [anon_sym_COLON_COLON] = ACTIONS(7878),
    [anon_sym_COMMA] = ACTIONS(7876),
    [anon_sym_PIPE] = ACTIONS(7878),
    [anon_sym_SEMI] = ACTIONS(7876),
    [anon_sym_STAR] = ACTIONS(7878),
    [anon_sym_STAR_STAR] = ACTIONS(7878),
    [anon_sym_AMP] = ACTIONS(7878),
    [anon_sym_EQ] = ACTIONS(7878),
    [anon_sym_class] = ACTIONS(7878),
    [anon_sym_LT] = ACTIONS(7878),
    [anon_sym_module] = ACTIONS(7878),
    [anon_sym_return] = ACTIONS(7878),
    [anon_sym_yield] = ACTIONS(7878),
    [anon_sym_break] = ACTIONS(7878),
    [anon_sym_next] = ACTIONS(7878),
    [sym_redo] = ACTIONS(7878),
    [sym_retry] = ACTIONS(7878),
    [anon_sym_if] = ACTIONS(7878),
    [anon_sym_unless] = ACTIONS(7878),
    [anon_sym_while] = ACTIONS(7878),
    [anon_sym_until] = ACTIONS(7878),
    [anon_sym_rescue] = ACTIONS(7878),
    [anon_sym_for] = ACTIONS(7878),
    [anon_sym_do] = ACTIONS(7878),
    [anon_sym_case] = ACTIONS(7878),
    [anon_sym_begin] = ACTIONS(7878),
    [anon_sym_LBRACK] = ACTIONS(7876),
    [anon_sym_COLON_COLON2] = ACTIONS(7876),
    [anon_sym_AMP_DOT] = ACTIONS(7876),
    [anon_sym_LPAREN2] = ACTIONS(7876),
    [anon_sym_PLUS_EQ] = ACTIONS(7876),
    [anon_sym_DASH_EQ] = ACTIONS(7876),
    [anon_sym_STAR_EQ] = ACTIONS(7876),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7876),
    [anon_sym_SLASH_EQ] = ACTIONS(7876),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7876),
    [anon_sym_PIPE_EQ] = ACTIONS(7876),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7876),
    [anon_sym_AMP_EQ] = ACTIONS(7876),
    [anon_sym_PERCENT_EQ] = ACTIONS(7876),
    [anon_sym_GT_GT_EQ] = ACTIONS(7876),
    [anon_sym_LT_LT_EQ] = ACTIONS(7876),
    [anon_sym_CARET_EQ] = ACTIONS(7876),
    [anon_sym_QMARK] = ACTIONS(7878),
    [anon_sym_COLON2] = ACTIONS(7878),
    [anon_sym_DOT_DOT] = ACTIONS(7878),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7876),
    [anon_sym_and] = ACTIONS(7878),
    [anon_sym_or] = ACTIONS(7878),
    [anon_sym_PIPE_PIPE] = ACTIONS(7878),
    [anon_sym_AMP_AMP] = ACTIONS(7878),
    [anon_sym_LT_LT] = ACTIONS(7878),
    [anon_sym_GT_GT] = ACTIONS(7878),
    [anon_sym_EQ_EQ] = ACTIONS(7878),
    [anon_sym_BANG_EQ] = ACTIONS(7876),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7876),
    [anon_sym_LT_EQ_GT] = ACTIONS(7876),
    [anon_sym_EQ_TILDE] = ACTIONS(7876),
    [anon_sym_BANG_TILDE] = ACTIONS(7876),
    [anon_sym_LT_EQ] = ACTIONS(7878),
    [anon_sym_GT] = ACTIONS(7878),
    [anon_sym_GT_EQ] = ACTIONS(7876),
    [anon_sym_CARET] = ACTIONS(7878),
    [anon_sym_PLUS] = ACTIONS(7878),
    [anon_sym_SLASH] = ACTIONS(7878),
    [anon_sym_PERCENT] = ACTIONS(7878),
    [anon_sym_defined_QMARK] = ACTIONS(7876),
    [anon_sym_not] = ACTIONS(7878),
    [anon_sym_BANG] = ACTIONS(7878),
    [anon_sym_TILDE] = ACTIONS(7876),
    [sym_constant] = ACTIONS(7878),
    [sym_identifier] = ACTIONS(7878),
    [sym_instance_variable] = ACTIONS(7876),
    [sym_class_variable] = ACTIONS(7876),
    [sym_global_variable] = ACTIONS(7876),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(7878),
    [sym_float] = ACTIONS(7878),
    [sym_complex] = ACTIONS(7876),
    [sym_super] = ACTIONS(7878),
    [anon_sym_true] = ACTIONS(7878),
    [anon_sym_TRUE] = ACTIONS(7878),
    [anon_sym_false] = ACTIONS(7878),
    [anon_sym_FALSE] = ACTIONS(7878),
    [sym_self] = ACTIONS(7878),
    [anon_sym_nil] = ACTIONS(7878),
    [anon_sym_NIL] = ACTIONS(7878),
    [sym_character] = ACTIONS(7876),
    [anon_sym_LBRACK2] = ACTIONS(7878),
    [anon_sym_DASH_GT] = ACTIONS(7876),
  },
  [8821] = {
    [sym__string_start] = ACTIONS(3030),
    [sym__heredoc_body_start] = ACTIONS(3030),
    [sym__binary_minus] = ACTIONS(3030),
    [sym__binary_star] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3030),
    [anon_sym_RBRACE] = ACTIONS(3030),
    [anon_sym_RPAREN] = ACTIONS(3030),
    [anon_sym_DOT] = ACTIONS(3032),
    [anon_sym_COMMA] = ACTIONS(3030),
    [anon_sym_PIPE] = ACTIONS(3032),
    [anon_sym_SEMI] = ACTIONS(3030),
    [anon_sym_STAR_STAR] = ACTIONS(3032),
    [anon_sym_AMP] = ACTIONS(3032),
    [anon_sym_EQ] = ACTIONS(3032),
    [anon_sym_LT] = ACTIONS(3032),
    [anon_sym_if] = ACTIONS(3030),
    [anon_sym_unless] = ACTIONS(3030),
    [anon_sym_while] = ACTIONS(3030),
    [anon_sym_until] = ACTIONS(3030),
    [anon_sym_rescue] = ACTIONS(3030),
    [anon_sym_in] = ACTIONS(3030),
    [anon_sym_do] = ACTIONS(3030),
    [anon_sym_LBRACK] = ACTIONS(3030),
    [anon_sym_RBRACK] = ACTIONS(3030),
    [anon_sym_COLON_COLON2] = ACTIONS(3030),
    [anon_sym_AMP_DOT] = ACTIONS(3030),
    [anon_sym_PLUS_EQ] = ACTIONS(3030),
    [anon_sym_DASH_EQ] = ACTIONS(3030),
    [anon_sym_STAR_EQ] = ACTIONS(3030),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3030),
    [anon_sym_SLASH_EQ] = ACTIONS(3030),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3030),
    [anon_sym_PIPE_EQ] = ACTIONS(3030),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3030),
    [anon_sym_AMP_EQ] = ACTIONS(3030),
    [anon_sym_PERCENT_EQ] = ACTIONS(3030),
    [anon_sym_GT_GT_EQ] = ACTIONS(3030),
    [anon_sym_LT_LT_EQ] = ACTIONS(3030),
    [anon_sym_CARET_EQ] = ACTIONS(3030),
    [anon_sym_QMARK] = ACTIONS(3030),
    [anon_sym_COLON2] = ACTIONS(3032),
    [anon_sym_DOT_DOT] = ACTIONS(3032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3030),
    [anon_sym_and] = ACTIONS(3030),
    [anon_sym_or] = ACTIONS(3030),
    [anon_sym_PIPE_PIPE] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_LT_LT] = ACTIONS(3032),
    [anon_sym_GT_GT] = ACTIONS(3032),
    [anon_sym_EQ_EQ] = ACTIONS(3032),
    [anon_sym_BANG_EQ] = ACTIONS(3030),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3030),
    [anon_sym_LT_EQ_GT] = ACTIONS(3030),
    [anon_sym_EQ_TILDE] = ACTIONS(3030),
    [anon_sym_BANG_TILDE] = ACTIONS(3030),
    [anon_sym_LT_EQ] = ACTIONS(3032),
    [anon_sym_GT] = ACTIONS(3032),
    [anon_sym_GT_EQ] = ACTIONS(3030),
    [anon_sym_CARET] = ACTIONS(3032),
    [anon_sym_PLUS] = ACTIONS(3032),
    [anon_sym_SLASH] = ACTIONS(3032),
    [anon_sym_PERCENT] = ACTIONS(3032),
    [sym_comment] = ACTIONS(87),
  },
  [8822] = {
    [sym__heredoc_body_start] = ACTIONS(3042),
    [sym__binary_minus] = ACTIONS(3042),
    [sym__binary_star] = ACTIONS(3042),
    [anon_sym_LBRACE] = ACTIONS(3042),
    [anon_sym_RBRACE] = ACTIONS(3042),
    [anon_sym_RPAREN] = ACTIONS(3042),
    [anon_sym_DOT] = ACTIONS(3044),
    [anon_sym_COMMA] = ACTIONS(3042),
    [anon_sym_PIPE] = ACTIONS(3044),
    [anon_sym_SEMI] = ACTIONS(3042),
    [anon_sym_STAR_STAR] = ACTIONS(3044),
    [anon_sym_AMP] = ACTIONS(3044),
    [anon_sym_EQ] = ACTIONS(3044),
    [anon_sym_LT] = ACTIONS(3044),
    [anon_sym_if] = ACTIONS(3042),
    [anon_sym_unless] = ACTIONS(3042),
    [anon_sym_while] = ACTIONS(3042),
    [anon_sym_until] = ACTIONS(3042),
    [anon_sym_rescue] = ACTIONS(3042),
    [anon_sym_in] = ACTIONS(3042),
    [anon_sym_do] = ACTIONS(3042),
    [anon_sym_LBRACK] = ACTIONS(3042),
    [anon_sym_RBRACK] = ACTIONS(3042),
    [anon_sym_COLON_COLON2] = ACTIONS(3042),
    [anon_sym_AMP_DOT] = ACTIONS(3042),
    [anon_sym_PLUS_EQ] = ACTIONS(3042),
    [anon_sym_DASH_EQ] = ACTIONS(3042),
    [anon_sym_STAR_EQ] = ACTIONS(3042),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3042),
    [anon_sym_SLASH_EQ] = ACTIONS(3042),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3042),
    [anon_sym_PIPE_EQ] = ACTIONS(3042),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3042),
    [anon_sym_AMP_EQ] = ACTIONS(3042),
    [anon_sym_PERCENT_EQ] = ACTIONS(3042),
    [anon_sym_GT_GT_EQ] = ACTIONS(3042),
    [anon_sym_LT_LT_EQ] = ACTIONS(3042),
    [anon_sym_CARET_EQ] = ACTIONS(3042),
    [anon_sym_QMARK] = ACTIONS(3042),
    [anon_sym_COLON2] = ACTIONS(3044),
    [anon_sym_DOT_DOT] = ACTIONS(3044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3042),
    [anon_sym_and] = ACTIONS(3042),
    [anon_sym_or] = ACTIONS(3042),
    [anon_sym_PIPE_PIPE] = ACTIONS(3044),
    [anon_sym_AMP_AMP] = ACTIONS(3044),
    [anon_sym_LT_LT] = ACTIONS(3044),
    [anon_sym_GT_GT] = ACTIONS(3044),
    [anon_sym_EQ_EQ] = ACTIONS(3044),
    [anon_sym_BANG_EQ] = ACTIONS(3042),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3042),
    [anon_sym_LT_EQ_GT] = ACTIONS(3042),
    [anon_sym_EQ_TILDE] = ACTIONS(3042),
    [anon_sym_BANG_TILDE] = ACTIONS(3042),
    [anon_sym_LT_EQ] = ACTIONS(3044),
    [anon_sym_GT] = ACTIONS(3044),
    [anon_sym_GT_EQ] = ACTIONS(3042),
    [anon_sym_CARET] = ACTIONS(3044),
    [anon_sym_PLUS] = ACTIONS(3044),
    [anon_sym_SLASH] = ACTIONS(3044),
    [anon_sym_PERCENT] = ACTIONS(3044),
    [sym_comment] = ACTIONS(87),
  },
  [8823] = {
    [sym__heredoc_body_start] = ACTIONS(3046),
    [sym__binary_minus] = ACTIONS(3046),
    [sym__binary_star] = ACTIONS(3046),
    [anon_sym_LBRACE] = ACTIONS(3046),
    [anon_sym_RBRACE] = ACTIONS(3046),
    [anon_sym_RPAREN] = ACTIONS(3046),
    [anon_sym_DOT] = ACTIONS(3048),
    [anon_sym_COMMA] = ACTIONS(3046),
    [anon_sym_PIPE] = ACTIONS(3048),
    [anon_sym_SEMI] = ACTIONS(3046),
    [anon_sym_STAR_STAR] = ACTIONS(3048),
    [anon_sym_AMP] = ACTIONS(3048),
    [anon_sym_EQ] = ACTIONS(3048),
    [anon_sym_LT] = ACTIONS(3048),
    [anon_sym_if] = ACTIONS(3046),
    [anon_sym_unless] = ACTIONS(3046),
    [anon_sym_while] = ACTIONS(3046),
    [anon_sym_until] = ACTIONS(3046),
    [anon_sym_rescue] = ACTIONS(3046),
    [anon_sym_in] = ACTIONS(3046),
    [anon_sym_do] = ACTIONS(3046),
    [anon_sym_LBRACK] = ACTIONS(3046),
    [anon_sym_RBRACK] = ACTIONS(3046),
    [anon_sym_COLON_COLON2] = ACTIONS(3046),
    [anon_sym_AMP_DOT] = ACTIONS(3046),
    [anon_sym_PLUS_EQ] = ACTIONS(3046),
    [anon_sym_DASH_EQ] = ACTIONS(3046),
    [anon_sym_STAR_EQ] = ACTIONS(3046),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3046),
    [anon_sym_SLASH_EQ] = ACTIONS(3046),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3046),
    [anon_sym_PIPE_EQ] = ACTIONS(3046),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3046),
    [anon_sym_AMP_EQ] = ACTIONS(3046),
    [anon_sym_PERCENT_EQ] = ACTIONS(3046),
    [anon_sym_GT_GT_EQ] = ACTIONS(3046),
    [anon_sym_LT_LT_EQ] = ACTIONS(3046),
    [anon_sym_CARET_EQ] = ACTIONS(3046),
    [anon_sym_QMARK] = ACTIONS(3046),
    [anon_sym_COLON2] = ACTIONS(3048),
    [anon_sym_DOT_DOT] = ACTIONS(3048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3046),
    [anon_sym_and] = ACTIONS(3046),
    [anon_sym_or] = ACTIONS(3046),
    [anon_sym_PIPE_PIPE] = ACTIONS(3048),
    [anon_sym_AMP_AMP] = ACTIONS(3048),
    [anon_sym_LT_LT] = ACTIONS(3048),
    [anon_sym_GT_GT] = ACTIONS(3048),
    [anon_sym_EQ_EQ] = ACTIONS(3048),
    [anon_sym_BANG_EQ] = ACTIONS(3046),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3046),
    [anon_sym_LT_EQ_GT] = ACTIONS(3046),
    [anon_sym_EQ_TILDE] = ACTIONS(3046),
    [anon_sym_BANG_TILDE] = ACTIONS(3046),
    [anon_sym_LT_EQ] = ACTIONS(3048),
    [anon_sym_GT] = ACTIONS(3048),
    [anon_sym_GT_EQ] = ACTIONS(3046),
    [anon_sym_CARET] = ACTIONS(3048),
    [anon_sym_PLUS] = ACTIONS(3048),
    [anon_sym_SLASH] = ACTIONS(3048),
    [anon_sym_PERCENT] = ACTIONS(3048),
    [sym_comment] = ACTIONS(87),
  },
  [8824] = {
    [sym__heredoc_body_start] = ACTIONS(3050),
    [sym__binary_minus] = ACTIONS(3050),
    [sym__binary_star] = ACTIONS(3050),
    [anon_sym_LBRACE] = ACTIONS(3050),
    [anon_sym_RBRACE] = ACTIONS(3050),
    [anon_sym_RPAREN] = ACTIONS(3050),
    [anon_sym_DOT] = ACTIONS(3052),
    [anon_sym_COMMA] = ACTIONS(3050),
    [anon_sym_PIPE] = ACTIONS(3052),
    [anon_sym_SEMI] = ACTIONS(3050),
    [anon_sym_STAR_STAR] = ACTIONS(3052),
    [anon_sym_AMP] = ACTIONS(3052),
    [anon_sym_EQ] = ACTIONS(3052),
    [anon_sym_LT] = ACTIONS(3052),
    [anon_sym_if] = ACTIONS(3050),
    [anon_sym_unless] = ACTIONS(3050),
    [anon_sym_while] = ACTIONS(3050),
    [anon_sym_until] = ACTIONS(3050),
    [anon_sym_rescue] = ACTIONS(3050),
    [anon_sym_in] = ACTIONS(3050),
    [anon_sym_do] = ACTIONS(3050),
    [anon_sym_LBRACK] = ACTIONS(3050),
    [anon_sym_RBRACK] = ACTIONS(3050),
    [anon_sym_COLON_COLON2] = ACTIONS(3050),
    [anon_sym_AMP_DOT] = ACTIONS(3050),
    [anon_sym_PLUS_EQ] = ACTIONS(3050),
    [anon_sym_DASH_EQ] = ACTIONS(3050),
    [anon_sym_STAR_EQ] = ACTIONS(3050),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3050),
    [anon_sym_SLASH_EQ] = ACTIONS(3050),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3050),
    [anon_sym_PIPE_EQ] = ACTIONS(3050),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3050),
    [anon_sym_AMP_EQ] = ACTIONS(3050),
    [anon_sym_PERCENT_EQ] = ACTIONS(3050),
    [anon_sym_GT_GT_EQ] = ACTIONS(3050),
    [anon_sym_LT_LT_EQ] = ACTIONS(3050),
    [anon_sym_CARET_EQ] = ACTIONS(3050),
    [anon_sym_QMARK] = ACTIONS(3050),
    [anon_sym_COLON2] = ACTIONS(3052),
    [anon_sym_DOT_DOT] = ACTIONS(3052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3050),
    [anon_sym_and] = ACTIONS(3050),
    [anon_sym_or] = ACTIONS(3050),
    [anon_sym_PIPE_PIPE] = ACTIONS(3052),
    [anon_sym_AMP_AMP] = ACTIONS(3052),
    [anon_sym_LT_LT] = ACTIONS(3052),
    [anon_sym_GT_GT] = ACTIONS(3052),
    [anon_sym_EQ_EQ] = ACTIONS(3052),
    [anon_sym_BANG_EQ] = ACTIONS(3050),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3050),
    [anon_sym_LT_EQ_GT] = ACTIONS(3050),
    [anon_sym_EQ_TILDE] = ACTIONS(3050),
    [anon_sym_BANG_TILDE] = ACTIONS(3050),
    [anon_sym_LT_EQ] = ACTIONS(3052),
    [anon_sym_GT] = ACTIONS(3052),
    [anon_sym_GT_EQ] = ACTIONS(3050),
    [anon_sym_CARET] = ACTIONS(3052),
    [anon_sym_PLUS] = ACTIONS(3052),
    [anon_sym_SLASH] = ACTIONS(3052),
    [anon_sym_PERCENT] = ACTIONS(3052),
    [sym_comment] = ACTIONS(87),
  },
  [8825] = {
    [sym__heredoc_body_start] = ACTIONS(3056),
    [sym__binary_minus] = ACTIONS(3056),
    [sym__binary_star] = ACTIONS(3056),
    [anon_sym_LBRACE] = ACTIONS(3056),
    [anon_sym_RBRACE] = ACTIONS(3056),
    [anon_sym_RPAREN] = ACTIONS(3056),
    [anon_sym_DOT] = ACTIONS(3058),
    [anon_sym_COMMA] = ACTIONS(3056),
    [anon_sym_PIPE] = ACTIONS(3058),
    [anon_sym_SEMI] = ACTIONS(3056),
    [anon_sym_STAR_STAR] = ACTIONS(3058),
    [anon_sym_AMP] = ACTIONS(3058),
    [anon_sym_EQ] = ACTIONS(3058),
    [anon_sym_LT] = ACTIONS(3058),
    [anon_sym_if] = ACTIONS(3056),
    [anon_sym_unless] = ACTIONS(3056),
    [anon_sym_while] = ACTIONS(3056),
    [anon_sym_until] = ACTIONS(3056),
    [anon_sym_rescue] = ACTIONS(3056),
    [anon_sym_in] = ACTIONS(3056),
    [anon_sym_do] = ACTIONS(3056),
    [anon_sym_LBRACK] = ACTIONS(3056),
    [anon_sym_RBRACK] = ACTIONS(3056),
    [anon_sym_COLON_COLON2] = ACTIONS(3056),
    [anon_sym_AMP_DOT] = ACTIONS(3056),
    [anon_sym_PLUS_EQ] = ACTIONS(3056),
    [anon_sym_DASH_EQ] = ACTIONS(3056),
    [anon_sym_STAR_EQ] = ACTIONS(3056),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3056),
    [anon_sym_SLASH_EQ] = ACTIONS(3056),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3056),
    [anon_sym_PIPE_EQ] = ACTIONS(3056),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3056),
    [anon_sym_AMP_EQ] = ACTIONS(3056),
    [anon_sym_PERCENT_EQ] = ACTIONS(3056),
    [anon_sym_GT_GT_EQ] = ACTIONS(3056),
    [anon_sym_LT_LT_EQ] = ACTIONS(3056),
    [anon_sym_CARET_EQ] = ACTIONS(3056),
    [anon_sym_QMARK] = ACTIONS(3056),
    [anon_sym_COLON2] = ACTIONS(3058),
    [anon_sym_DOT_DOT] = ACTIONS(3058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3056),
    [anon_sym_and] = ACTIONS(3056),
    [anon_sym_or] = ACTIONS(3056),
    [anon_sym_PIPE_PIPE] = ACTIONS(3058),
    [anon_sym_AMP_AMP] = ACTIONS(3058),
    [anon_sym_LT_LT] = ACTIONS(3058),
    [anon_sym_GT_GT] = ACTIONS(3058),
    [anon_sym_EQ_EQ] = ACTIONS(3058),
    [anon_sym_BANG_EQ] = ACTIONS(3056),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3056),
    [anon_sym_LT_EQ_GT] = ACTIONS(3056),
    [anon_sym_EQ_TILDE] = ACTIONS(3056),
    [anon_sym_BANG_TILDE] = ACTIONS(3056),
    [anon_sym_LT_EQ] = ACTIONS(3058),
    [anon_sym_GT] = ACTIONS(3058),
    [anon_sym_GT_EQ] = ACTIONS(3056),
    [anon_sym_CARET] = ACTIONS(3058),
    [anon_sym_PLUS] = ACTIONS(3058),
    [anon_sym_SLASH] = ACTIONS(3058),
    [anon_sym_PERCENT] = ACTIONS(3058),
    [sym_comment] = ACTIONS(87),
  },
  [8826] = {
    [sym__string_end] = ACTIONS(13823),
    [sym_comment] = ACTIONS(87),
  },
  [8827] = {
    [aux_sym_string_array_repeat1] = STATE(10162),
    [sym__string_end] = ACTIONS(13825),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(13827),
  },
  [8828] = {
    [sym__heredoc_body_start] = ACTIONS(3066),
    [sym__binary_minus] = ACTIONS(3066),
    [sym__binary_star] = ACTIONS(3066),
    [anon_sym_LBRACE] = ACTIONS(3066),
    [anon_sym_RBRACE] = ACTIONS(3066),
    [anon_sym_RPAREN] = ACTIONS(3066),
    [anon_sym_DOT] = ACTIONS(3068),
    [anon_sym_COMMA] = ACTIONS(3066),
    [anon_sym_PIPE] = ACTIONS(3068),
    [anon_sym_SEMI] = ACTIONS(3066),
    [anon_sym_STAR_STAR] = ACTIONS(3068),
    [anon_sym_AMP] = ACTIONS(3068),
    [anon_sym_EQ] = ACTIONS(3068),
    [anon_sym_LT] = ACTIONS(3068),
    [anon_sym_if] = ACTIONS(3066),
    [anon_sym_unless] = ACTIONS(3066),
    [anon_sym_while] = ACTIONS(3066),
    [anon_sym_until] = ACTIONS(3066),
    [anon_sym_rescue] = ACTIONS(3066),
    [anon_sym_in] = ACTIONS(3066),
    [anon_sym_do] = ACTIONS(3066),
    [anon_sym_LBRACK] = ACTIONS(3066),
    [anon_sym_RBRACK] = ACTIONS(3066),
    [anon_sym_COLON_COLON2] = ACTIONS(3066),
    [anon_sym_AMP_DOT] = ACTIONS(3066),
    [anon_sym_PLUS_EQ] = ACTIONS(3066),
    [anon_sym_DASH_EQ] = ACTIONS(3066),
    [anon_sym_STAR_EQ] = ACTIONS(3066),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3066),
    [anon_sym_SLASH_EQ] = ACTIONS(3066),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3066),
    [anon_sym_PIPE_EQ] = ACTIONS(3066),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3066),
    [anon_sym_AMP_EQ] = ACTIONS(3066),
    [anon_sym_PERCENT_EQ] = ACTIONS(3066),
    [anon_sym_GT_GT_EQ] = ACTIONS(3066),
    [anon_sym_LT_LT_EQ] = ACTIONS(3066),
    [anon_sym_CARET_EQ] = ACTIONS(3066),
    [anon_sym_QMARK] = ACTIONS(3066),
    [anon_sym_COLON2] = ACTIONS(3068),
    [anon_sym_DOT_DOT] = ACTIONS(3068),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3066),
    [anon_sym_and] = ACTIONS(3066),
    [anon_sym_or] = ACTIONS(3066),
    [anon_sym_PIPE_PIPE] = ACTIONS(3068),
    [anon_sym_AMP_AMP] = ACTIONS(3068),
    [anon_sym_LT_LT] = ACTIONS(3068),
    [anon_sym_GT_GT] = ACTIONS(3068),
    [anon_sym_EQ_EQ] = ACTIONS(3068),
    [anon_sym_BANG_EQ] = ACTIONS(3066),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3066),
    [anon_sym_LT_EQ_GT] = ACTIONS(3066),
    [anon_sym_EQ_TILDE] = ACTIONS(3066),
    [anon_sym_BANG_TILDE] = ACTIONS(3066),
    [anon_sym_LT_EQ] = ACTIONS(3068),
    [anon_sym_GT] = ACTIONS(3068),
    [anon_sym_GT_EQ] = ACTIONS(3066),
    [anon_sym_CARET] = ACTIONS(3068),
    [anon_sym_PLUS] = ACTIONS(3068),
    [anon_sym_SLASH] = ACTIONS(3068),
    [anon_sym_PERCENT] = ACTIONS(3068),
    [sym_comment] = ACTIONS(87),
  },
  [8829] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1697),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(13829),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [8830] = {
    [aux_sym_string_array_repeat1] = STATE(1699),
    [sym__string_end] = ACTIONS(13829),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(13831),
  },
  [8831] = {
    [sym__heredoc_body_start] = ACTIONS(3085),
    [sym__binary_minus] = ACTIONS(3085),
    [sym__binary_star] = ACTIONS(3085),
    [anon_sym_LBRACE] = ACTIONS(3085),
    [anon_sym_RBRACE] = ACTIONS(3085),
    [anon_sym_RPAREN] = ACTIONS(3085),
    [anon_sym_DOT] = ACTIONS(3087),
    [anon_sym_COMMA] = ACTIONS(3085),
    [anon_sym_PIPE] = ACTIONS(3087),
    [anon_sym_SEMI] = ACTIONS(3085),
    [anon_sym_STAR_STAR] = ACTIONS(3087),
    [anon_sym_AMP] = ACTIONS(3087),
    [anon_sym_EQ] = ACTIONS(3087),
    [anon_sym_LT] = ACTIONS(3087),
    [anon_sym_if] = ACTIONS(3085),
    [anon_sym_unless] = ACTIONS(3085),
    [anon_sym_while] = ACTIONS(3085),
    [anon_sym_until] = ACTIONS(3085),
    [anon_sym_rescue] = ACTIONS(3085),
    [anon_sym_in] = ACTIONS(3085),
    [anon_sym_do] = ACTIONS(3085),
    [anon_sym_LBRACK] = ACTIONS(3085),
    [anon_sym_RBRACK] = ACTIONS(3085),
    [anon_sym_COLON_COLON2] = ACTIONS(3085),
    [anon_sym_AMP_DOT] = ACTIONS(3085),
    [anon_sym_PLUS_EQ] = ACTIONS(3085),
    [anon_sym_DASH_EQ] = ACTIONS(3085),
    [anon_sym_STAR_EQ] = ACTIONS(3085),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3085),
    [anon_sym_SLASH_EQ] = ACTIONS(3085),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3085),
    [anon_sym_PIPE_EQ] = ACTIONS(3085),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3085),
    [anon_sym_AMP_EQ] = ACTIONS(3085),
    [anon_sym_PERCENT_EQ] = ACTIONS(3085),
    [anon_sym_GT_GT_EQ] = ACTIONS(3085),
    [anon_sym_LT_LT_EQ] = ACTIONS(3085),
    [anon_sym_CARET_EQ] = ACTIONS(3085),
    [anon_sym_QMARK] = ACTIONS(3085),
    [anon_sym_COLON2] = ACTIONS(3087),
    [anon_sym_DOT_DOT] = ACTIONS(3087),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3085),
    [anon_sym_and] = ACTIONS(3085),
    [anon_sym_or] = ACTIONS(3085),
    [anon_sym_PIPE_PIPE] = ACTIONS(3087),
    [anon_sym_AMP_AMP] = ACTIONS(3087),
    [anon_sym_LT_LT] = ACTIONS(3087),
    [anon_sym_GT_GT] = ACTIONS(3087),
    [anon_sym_EQ_EQ] = ACTIONS(3087),
    [anon_sym_BANG_EQ] = ACTIONS(3085),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3085),
    [anon_sym_LT_EQ_GT] = ACTIONS(3085),
    [anon_sym_EQ_TILDE] = ACTIONS(3085),
    [anon_sym_BANG_TILDE] = ACTIONS(3085),
    [anon_sym_LT_EQ] = ACTIONS(3087),
    [anon_sym_GT] = ACTIONS(3087),
    [anon_sym_GT_EQ] = ACTIONS(3085),
    [anon_sym_CARET] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3087),
    [anon_sym_SLASH] = ACTIONS(3087),
    [anon_sym_PERCENT] = ACTIONS(3087),
    [sym_comment] = ACTIONS(87),
  },
  [8832] = {
    [sym__string_end] = ACTIONS(13833),
    [sym_comment] = ACTIONS(87),
  },
  [8833] = {
    [aux_sym_symbol_array_repeat1] = STATE(10168),
    [sym__string_end] = ACTIONS(13835),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(13837),
  },
  [8834] = {
    [sym__heredoc_body_start] = ACTIONS(3095),
    [sym__binary_minus] = ACTIONS(3095),
    [sym__binary_star] = ACTIONS(3095),
    [anon_sym_LBRACE] = ACTIONS(3095),
    [anon_sym_RBRACE] = ACTIONS(3095),
    [anon_sym_RPAREN] = ACTIONS(3095),
    [anon_sym_DOT] = ACTIONS(3097),
    [anon_sym_COMMA] = ACTIONS(3095),
    [anon_sym_PIPE] = ACTIONS(3097),
    [anon_sym_SEMI] = ACTIONS(3095),
    [anon_sym_STAR_STAR] = ACTIONS(3097),
    [anon_sym_AMP] = ACTIONS(3097),
    [anon_sym_EQ] = ACTIONS(3097),
    [anon_sym_LT] = ACTIONS(3097),
    [anon_sym_if] = ACTIONS(3095),
    [anon_sym_unless] = ACTIONS(3095),
    [anon_sym_while] = ACTIONS(3095),
    [anon_sym_until] = ACTIONS(3095),
    [anon_sym_rescue] = ACTIONS(3095),
    [anon_sym_in] = ACTIONS(3095),
    [anon_sym_do] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3095),
    [anon_sym_RBRACK] = ACTIONS(3095),
    [anon_sym_COLON_COLON2] = ACTIONS(3095),
    [anon_sym_AMP_DOT] = ACTIONS(3095),
    [anon_sym_PLUS_EQ] = ACTIONS(3095),
    [anon_sym_DASH_EQ] = ACTIONS(3095),
    [anon_sym_STAR_EQ] = ACTIONS(3095),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3095),
    [anon_sym_SLASH_EQ] = ACTIONS(3095),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3095),
    [anon_sym_PIPE_EQ] = ACTIONS(3095),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3095),
    [anon_sym_AMP_EQ] = ACTIONS(3095),
    [anon_sym_PERCENT_EQ] = ACTIONS(3095),
    [anon_sym_GT_GT_EQ] = ACTIONS(3095),
    [anon_sym_LT_LT_EQ] = ACTIONS(3095),
    [anon_sym_CARET_EQ] = ACTIONS(3095),
    [anon_sym_QMARK] = ACTIONS(3095),
    [anon_sym_COLON2] = ACTIONS(3097),
    [anon_sym_DOT_DOT] = ACTIONS(3097),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3095),
    [anon_sym_and] = ACTIONS(3095),
    [anon_sym_or] = ACTIONS(3095),
    [anon_sym_PIPE_PIPE] = ACTIONS(3097),
    [anon_sym_AMP_AMP] = ACTIONS(3097),
    [anon_sym_LT_LT] = ACTIONS(3097),
    [anon_sym_GT_GT] = ACTIONS(3097),
    [anon_sym_EQ_EQ] = ACTIONS(3097),
    [anon_sym_BANG_EQ] = ACTIONS(3095),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3095),
    [anon_sym_LT_EQ_GT] = ACTIONS(3095),
    [anon_sym_EQ_TILDE] = ACTIONS(3095),
    [anon_sym_BANG_TILDE] = ACTIONS(3095),
    [anon_sym_LT_EQ] = ACTIONS(3097),
    [anon_sym_GT] = ACTIONS(3097),
    [anon_sym_GT_EQ] = ACTIONS(3095),
    [anon_sym_CARET] = ACTIONS(3097),
    [anon_sym_PLUS] = ACTIONS(3097),
    [anon_sym_SLASH] = ACTIONS(3097),
    [anon_sym_PERCENT] = ACTIONS(3097),
    [sym_comment] = ACTIONS(87),
  },
  [8835] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1705),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(13839),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [8836] = {
    [aux_sym_symbol_array_repeat1] = STATE(1707),
    [sym__string_end] = ACTIONS(13839),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(13841),
  },
  [8837] = {
    [sym__heredoc_body_start] = ACTIONS(3575),
    [sym__binary_minus] = ACTIONS(3575),
    [sym__binary_star] = ACTIONS(3575),
    [anon_sym_LBRACE] = ACTIONS(3575),
    [anon_sym_RBRACE] = ACTIONS(3575),
    [anon_sym_RPAREN] = ACTIONS(3575),
    [anon_sym_DOT] = ACTIONS(3577),
    [anon_sym_COMMA] = ACTIONS(3575),
    [anon_sym_PIPE] = ACTIONS(3577),
    [anon_sym_SEMI] = ACTIONS(3575),
    [anon_sym_STAR_STAR] = ACTIONS(3577),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_EQ] = ACTIONS(3577),
    [anon_sym_LT] = ACTIONS(3577),
    [anon_sym_if] = ACTIONS(3575),
    [anon_sym_unless] = ACTIONS(3575),
    [anon_sym_while] = ACTIONS(3575),
    [anon_sym_until] = ACTIONS(3575),
    [anon_sym_rescue] = ACTIONS(3575),
    [anon_sym_in] = ACTIONS(3575),
    [anon_sym_do] = ACTIONS(3575),
    [anon_sym_LBRACK] = ACTIONS(3575),
    [anon_sym_RBRACK] = ACTIONS(3575),
    [anon_sym_COLON_COLON2] = ACTIONS(3575),
    [anon_sym_AMP_DOT] = ACTIONS(3575),
    [anon_sym_PLUS_EQ] = ACTIONS(3575),
    [anon_sym_DASH_EQ] = ACTIONS(3575),
    [anon_sym_STAR_EQ] = ACTIONS(3575),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3575),
    [anon_sym_SLASH_EQ] = ACTIONS(3575),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3575),
    [anon_sym_PIPE_EQ] = ACTIONS(3575),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3575),
    [anon_sym_AMP_EQ] = ACTIONS(3575),
    [anon_sym_PERCENT_EQ] = ACTIONS(3575),
    [anon_sym_GT_GT_EQ] = ACTIONS(3575),
    [anon_sym_LT_LT_EQ] = ACTIONS(3575),
    [anon_sym_CARET_EQ] = ACTIONS(3575),
    [anon_sym_QMARK] = ACTIONS(3575),
    [anon_sym_COLON2] = ACTIONS(3577),
    [anon_sym_DOT_DOT] = ACTIONS(3577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3575),
    [anon_sym_and] = ACTIONS(3575),
    [anon_sym_or] = ACTIONS(3575),
    [anon_sym_PIPE_PIPE] = ACTIONS(3577),
    [anon_sym_AMP_AMP] = ACTIONS(3577),
    [anon_sym_LT_LT] = ACTIONS(3577),
    [anon_sym_GT_GT] = ACTIONS(3577),
    [anon_sym_EQ_EQ] = ACTIONS(3577),
    [anon_sym_BANG_EQ] = ACTIONS(3575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3575),
    [anon_sym_LT_EQ_GT] = ACTIONS(3575),
    [anon_sym_EQ_TILDE] = ACTIONS(3575),
    [anon_sym_BANG_TILDE] = ACTIONS(3575),
    [anon_sym_LT_EQ] = ACTIONS(3577),
    [anon_sym_GT] = ACTIONS(3577),
    [anon_sym_GT_EQ] = ACTIONS(3575),
    [anon_sym_CARET] = ACTIONS(3577),
    [anon_sym_PLUS] = ACTIONS(3577),
    [anon_sym_SLASH] = ACTIONS(3577),
    [anon_sym_PERCENT] = ACTIONS(3577),
    [sym_comment] = ACTIONS(87),
  },
  [8838] = {
    [anon_sym_RBRACE] = ACTIONS(13843),
    [sym_comment] = ACTIONS(87),
  },
  [8839] = {
    [sym__binary_minus] = ACTIONS(3609),
    [sym__binary_star] = ACTIONS(3611),
    [anon_sym_RPAREN] = ACTIONS(13845),
    [anon_sym_PIPE] = ACTIONS(3615),
    [anon_sym_STAR_STAR] = ACTIONS(3611),
    [anon_sym_AMP] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3619),
    [anon_sym_QMARK] = ACTIONS(3621),
    [anon_sym_DOT_DOT] = ACTIONS(3623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3625),
    [anon_sym_and] = ACTIONS(3627),
    [anon_sym_or] = ACTIONS(3627),
    [anon_sym_PIPE_PIPE] = ACTIONS(3629),
    [anon_sym_AMP_AMP] = ACTIONS(3629),
    [anon_sym_LT_LT] = ACTIONS(3631),
    [anon_sym_GT_GT] = ACTIONS(3631),
    [anon_sym_EQ_EQ] = ACTIONS(3633),
    [anon_sym_BANG_EQ] = ACTIONS(3629),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3629),
    [anon_sym_LT_EQ_GT] = ACTIONS(3629),
    [anon_sym_EQ_TILDE] = ACTIONS(3629),
    [anon_sym_BANG_TILDE] = ACTIONS(3629),
    [anon_sym_LT_EQ] = ACTIONS(3619),
    [anon_sym_GT] = ACTIONS(3619),
    [anon_sym_GT_EQ] = ACTIONS(3635),
    [anon_sym_CARET] = ACTIONS(3637),
    [anon_sym_PLUS] = ACTIONS(3609),
    [anon_sym_SLASH] = ACTIONS(3611),
    [anon_sym_PERCENT] = ACTIONS(3611),
    [sym_comment] = ACTIONS(87),
  },
  [8840] = {
    [sym__method_rest] = STATE(10173),
    [sym_operator] = STATE(6606),
    [sym__method_name] = STATE(6606),
    [sym_setter] = STATE(6606),
    [sym_symbol] = STATE(6606),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(13847),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(13847),
    [sym_class_variable] = ACTIONS(13847),
    [sym_global_variable] = ACTIONS(13847),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [8841] = {
    [sym__statements] = STATE(6625),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(6626),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(6627),
    [sym_rescue] = STATE(6628),
    [sym__body_statement] = STATE(10174),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13849),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8842] = {
    [sym__heredoc_body_start] = ACTIONS(3805),
    [sym__binary_minus] = ACTIONS(3805),
    [sym__binary_star] = ACTIONS(3805),
    [anon_sym_LBRACE] = ACTIONS(3805),
    [anon_sym_RBRACE] = ACTIONS(3805),
    [anon_sym_RPAREN] = ACTIONS(3805),
    [anon_sym_DOT] = ACTIONS(3807),
    [anon_sym_COMMA] = ACTIONS(3805),
    [anon_sym_PIPE] = ACTIONS(3807),
    [anon_sym_SEMI] = ACTIONS(3805),
    [anon_sym_STAR_STAR] = ACTIONS(3807),
    [anon_sym_AMP] = ACTIONS(3807),
    [anon_sym_EQ] = ACTIONS(3807),
    [anon_sym_LT] = ACTIONS(3807),
    [anon_sym_if] = ACTIONS(3805),
    [anon_sym_unless] = ACTIONS(3805),
    [anon_sym_while] = ACTIONS(3805),
    [anon_sym_until] = ACTIONS(3805),
    [anon_sym_rescue] = ACTIONS(3805),
    [anon_sym_in] = ACTIONS(3805),
    [anon_sym_do] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(3805),
    [anon_sym_RBRACK] = ACTIONS(3805),
    [anon_sym_COLON_COLON2] = ACTIONS(3805),
    [anon_sym_AMP_DOT] = ACTIONS(3805),
    [anon_sym_PLUS_EQ] = ACTIONS(3805),
    [anon_sym_DASH_EQ] = ACTIONS(3805),
    [anon_sym_STAR_EQ] = ACTIONS(3805),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3805),
    [anon_sym_SLASH_EQ] = ACTIONS(3805),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3805),
    [anon_sym_PIPE_EQ] = ACTIONS(3805),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3805),
    [anon_sym_AMP_EQ] = ACTIONS(3805),
    [anon_sym_PERCENT_EQ] = ACTIONS(3805),
    [anon_sym_GT_GT_EQ] = ACTIONS(3805),
    [anon_sym_LT_LT_EQ] = ACTIONS(3805),
    [anon_sym_CARET_EQ] = ACTIONS(3805),
    [anon_sym_QMARK] = ACTIONS(3805),
    [anon_sym_COLON2] = ACTIONS(3807),
    [anon_sym_DOT_DOT] = ACTIONS(3807),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3805),
    [anon_sym_and] = ACTIONS(3805),
    [anon_sym_or] = ACTIONS(3805),
    [anon_sym_PIPE_PIPE] = ACTIONS(3807),
    [anon_sym_AMP_AMP] = ACTIONS(3807),
    [anon_sym_LT_LT] = ACTIONS(3807),
    [anon_sym_GT_GT] = ACTIONS(3807),
    [anon_sym_EQ_EQ] = ACTIONS(3807),
    [anon_sym_BANG_EQ] = ACTIONS(3805),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3805),
    [anon_sym_LT_EQ_GT] = ACTIONS(3805),
    [anon_sym_EQ_TILDE] = ACTIONS(3805),
    [anon_sym_BANG_TILDE] = ACTIONS(3805),
    [anon_sym_LT_EQ] = ACTIONS(3807),
    [anon_sym_GT] = ACTIONS(3807),
    [anon_sym_GT_EQ] = ACTIONS(3805),
    [anon_sym_CARET] = ACTIONS(3807),
    [anon_sym_PLUS] = ACTIONS(3807),
    [anon_sym_SLASH] = ACTIONS(3807),
    [anon_sym_PERCENT] = ACTIONS(3807),
    [sym_comment] = ACTIONS(87),
  },
  [8843] = {
    [sym_heredoc_body] = STATE(10175),
    [sym__terminator] = STATE(10175),
    [sym__line_break] = ACTIONS(13851),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym__binary_minus] = ACTIONS(2001),
    [sym__binary_star] = ACTIONS(2003),
    [anon_sym_PIPE] = ACTIONS(2005),
    [anon_sym_SEMI] = ACTIONS(13851),
    [anon_sym_STAR_STAR] = ACTIONS(2003),
    [anon_sym_AMP] = ACTIONS(2007),
    [anon_sym_LT] = ACTIONS(2009),
    [anon_sym_QMARK] = ACTIONS(2011),
    [anon_sym_DOT_DOT] = ACTIONS(2013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2015),
    [anon_sym_and] = ACTIONS(2017),
    [anon_sym_or] = ACTIONS(2017),
    [anon_sym_PIPE_PIPE] = ACTIONS(2019),
    [anon_sym_AMP_AMP] = ACTIONS(2019),
    [anon_sym_LT_LT] = ACTIONS(2021),
    [anon_sym_GT_GT] = ACTIONS(2021),
    [anon_sym_EQ_EQ] = ACTIONS(2023),
    [anon_sym_BANG_EQ] = ACTIONS(2019),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2019),
    [anon_sym_LT_EQ_GT] = ACTIONS(2019),
    [anon_sym_EQ_TILDE] = ACTIONS(2019),
    [anon_sym_BANG_TILDE] = ACTIONS(2019),
    [anon_sym_LT_EQ] = ACTIONS(2009),
    [anon_sym_GT] = ACTIONS(2009),
    [anon_sym_GT_EQ] = ACTIONS(2025),
    [anon_sym_CARET] = ACTIONS(2027),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_SLASH] = ACTIONS(2003),
    [anon_sym_PERCENT] = ACTIONS(2003),
    [sym_comment] = ACTIONS(87),
  },
  [8844] = {
    [sym_heredoc_body] = STATE(10176),
    [sym__terminator] = STATE(10176),
    [sym__line_break] = ACTIONS(13853),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(13853),
    [sym_comment] = ACTIONS(87),
  },
  [8845] = {
    [sym__statements] = STATE(6625),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(6626),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(6627),
    [sym_rescue] = STATE(6628),
    [sym__body_statement] = STATE(10177),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13855),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8846] = {
    [sym__heredoc_body_start] = ACTIONS(4205),
    [sym__binary_minus] = ACTIONS(4205),
    [sym__binary_star] = ACTIONS(4205),
    [anon_sym_LBRACE] = ACTIONS(4205),
    [anon_sym_RBRACE] = ACTIONS(4205),
    [anon_sym_RPAREN] = ACTIONS(4205),
    [anon_sym_DOT] = ACTIONS(4207),
    [anon_sym_COMMA] = ACTIONS(4205),
    [anon_sym_PIPE] = ACTIONS(4207),
    [anon_sym_SEMI] = ACTIONS(4205),
    [anon_sym_STAR_STAR] = ACTIONS(4207),
    [anon_sym_AMP] = ACTIONS(4207),
    [anon_sym_EQ] = ACTIONS(4207),
    [anon_sym_LT] = ACTIONS(4207),
    [anon_sym_if] = ACTIONS(4205),
    [anon_sym_unless] = ACTIONS(4205),
    [anon_sym_while] = ACTIONS(4205),
    [anon_sym_until] = ACTIONS(4205),
    [anon_sym_rescue] = ACTIONS(4205),
    [anon_sym_in] = ACTIONS(4205),
    [anon_sym_do] = ACTIONS(4205),
    [anon_sym_LBRACK] = ACTIONS(4205),
    [anon_sym_RBRACK] = ACTIONS(4205),
    [anon_sym_COLON_COLON2] = ACTIONS(4205),
    [anon_sym_AMP_DOT] = ACTIONS(4205),
    [anon_sym_PLUS_EQ] = ACTIONS(4205),
    [anon_sym_DASH_EQ] = ACTIONS(4205),
    [anon_sym_STAR_EQ] = ACTIONS(4205),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4205),
    [anon_sym_SLASH_EQ] = ACTIONS(4205),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4205),
    [anon_sym_PIPE_EQ] = ACTIONS(4205),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4205),
    [anon_sym_AMP_EQ] = ACTIONS(4205),
    [anon_sym_PERCENT_EQ] = ACTIONS(4205),
    [anon_sym_GT_GT_EQ] = ACTIONS(4205),
    [anon_sym_LT_LT_EQ] = ACTIONS(4205),
    [anon_sym_CARET_EQ] = ACTIONS(4205),
    [anon_sym_QMARK] = ACTIONS(4205),
    [anon_sym_COLON2] = ACTIONS(4207),
    [anon_sym_DOT_DOT] = ACTIONS(4207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4205),
    [anon_sym_and] = ACTIONS(4205),
    [anon_sym_or] = ACTIONS(4205),
    [anon_sym_PIPE_PIPE] = ACTIONS(4207),
    [anon_sym_AMP_AMP] = ACTIONS(4207),
    [anon_sym_LT_LT] = ACTIONS(4207),
    [anon_sym_GT_GT] = ACTIONS(4207),
    [anon_sym_EQ_EQ] = ACTIONS(4207),
    [anon_sym_BANG_EQ] = ACTIONS(4205),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4205),
    [anon_sym_LT_EQ_GT] = ACTIONS(4205),
    [anon_sym_EQ_TILDE] = ACTIONS(4205),
    [anon_sym_BANG_TILDE] = ACTIONS(4205),
    [anon_sym_LT_EQ] = ACTIONS(4207),
    [anon_sym_GT] = ACTIONS(4207),
    [anon_sym_GT_EQ] = ACTIONS(4205),
    [anon_sym_CARET] = ACTIONS(4207),
    [anon_sym_PLUS] = ACTIONS(4207),
    [anon_sym_SLASH] = ACTIONS(4207),
    [anon_sym_PERCENT] = ACTIONS(4207),
    [sym_comment] = ACTIONS(87),
  },
  [8847] = {
    [sym__statements] = STATE(6625),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(6626),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(6627),
    [sym_rescue] = STATE(6628),
    [sym__body_statement] = STATE(10178),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13857),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8848] = {
    [sym_elsif] = STATE(10180),
    [sym_else] = STATE(10180),
    [anon_sym_end] = ACTIONS(13859),
    [anon_sym_elsif] = ACTIONS(4495),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [8849] = {
    [sym__statements] = STATE(2640),
    [sym_begin_block] = STATE(2641),
    [sym_end_block] = STATE(2641),
    [sym__statement] = STATE(2641),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(2641),
    [sym_unless_modifier] = STATE(2641),
    [sym_while_modifier] = STATE(2641),
    [sym_until_modifier] = STATE(2641),
    [sym_rescue_modifier] = STATE(2641),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_elsif] = STATE(10180),
    [sym_else] = STATE(10180),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2642),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2645),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(2645),
    [sym_assignment] = STATE(2642),
    [sym_operator_assignment] = STATE(2642),
    [sym_conditional] = STATE(2642),
    [sym_range] = STATE(2642),
    [sym_binary] = STATE(2642),
    [sym_unary] = STATE(2642),
    [sym_left_assignment_list] = STATE(2644),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2645),
    [sym__variable] = STATE(2643),
    [sym_undef] = STATE(2641),
    [sym_alias] = STATE(2641),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2645),
    [sym_false] = STATE(2645),
    [sym_nil] = STATE(2645),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2646),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(2647),
    [aux_sym__statements_repeat1] = STATE(2647),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4467),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13861),
    [anon_sym_return] = ACTIONS(4471),
    [anon_sym_yield] = ACTIONS(4473),
    [anon_sym_break] = ACTIONS(4475),
    [anon_sym_next] = ACTIONS(4477),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(4499),
    [anon_sym_else] = ACTIONS(4501),
    [anon_sym_then] = ACTIONS(4503),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4479),
    [anon_sym_defined_QMARK] = ACTIONS(4481),
    [anon_sym_not] = ACTIONS(4483),
    [anon_sym_BANG] = ACTIONS(4485),
    [anon_sym_TILDE] = ACTIONS(4485),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [anon_sym_undef] = ACTIONS(4491),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8850] = {
    [sym_else] = STATE(10182),
    [anon_sym_end] = ACTIONS(13863),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [8851] = {
    [sym__statements] = STATE(2640),
    [sym_begin_block] = STATE(2715),
    [sym_end_block] = STATE(2715),
    [sym__statement] = STATE(2715),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(2715),
    [sym_unless_modifier] = STATE(2715),
    [sym_while_modifier] = STATE(2715),
    [sym_until_modifier] = STATE(2715),
    [sym_rescue_modifier] = STATE(2715),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(10182),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(2716),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2719),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(2719),
    [sym_assignment] = STATE(2716),
    [sym_operator_assignment] = STATE(2716),
    [sym_conditional] = STATE(2716),
    [sym_range] = STATE(2716),
    [sym_binary] = STATE(2716),
    [sym_unary] = STATE(2716),
    [sym_left_assignment_list] = STATE(2718),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2719),
    [sym__variable] = STATE(2717),
    [sym_undef] = STATE(2715),
    [sym_alias] = STATE(2715),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2719),
    [sym_false] = STATE(2719),
    [sym_nil] = STATE(2719),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2720),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(2721),
    [aux_sym__statements_repeat1] = STATE(2721),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4583),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13865),
    [anon_sym_return] = ACTIONS(4585),
    [anon_sym_yield] = ACTIONS(4587),
    [anon_sym_break] = ACTIONS(4589),
    [anon_sym_next] = ACTIONS(4591),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(4501),
    [anon_sym_then] = ACTIONS(4611),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4593),
    [anon_sym_defined_QMARK] = ACTIONS(4595),
    [anon_sym_not] = ACTIONS(4597),
    [anon_sym_BANG] = ACTIONS(4599),
    [anon_sym_TILDE] = ACTIONS(4599),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [anon_sym_undef] = ACTIONS(4605),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8852] = {
    [sym__statements] = STATE(10184),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13867),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8853] = {
    [sym__statements] = STATE(10186),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13869),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8854] = {
    [sym__do] = STATE(10187),
    [sym_heredoc_body] = STATE(10187),
    [sym__terminator] = STATE(10187),
    [sym__line_break] = ACTIONS(13871),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(13871),
    [anon_sym_do] = ACTIONS(13871),
    [sym_comment] = ACTIONS(87),
  },
  [8855] = {
    [sym_when] = STATE(10191),
    [sym_else] = STATE(10189),
    [aux_sym_case_repeat1] = STATE(10190),
    [aux_sym_case_repeat2] = STATE(10191),
    [anon_sym_SEMI] = ACTIONS(13873),
    [anon_sym_end] = ACTIONS(13875),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [8856] = {
    [sym__heredoc_body_start] = ACTIONS(4965),
    [sym__binary_minus] = ACTIONS(4965),
    [sym__binary_star] = ACTIONS(4965),
    [anon_sym_LBRACE] = ACTIONS(4965),
    [anon_sym_RBRACE] = ACTIONS(4965),
    [anon_sym_RPAREN] = ACTIONS(4965),
    [anon_sym_DOT] = ACTIONS(4967),
    [anon_sym_COMMA] = ACTIONS(4965),
    [anon_sym_PIPE] = ACTIONS(4967),
    [anon_sym_SEMI] = ACTIONS(4965),
    [anon_sym_STAR_STAR] = ACTIONS(4967),
    [anon_sym_AMP] = ACTIONS(4967),
    [anon_sym_EQ] = ACTIONS(4967),
    [anon_sym_LT] = ACTIONS(4967),
    [anon_sym_if] = ACTIONS(4965),
    [anon_sym_unless] = ACTIONS(4965),
    [anon_sym_while] = ACTIONS(4965),
    [anon_sym_until] = ACTIONS(4965),
    [anon_sym_rescue] = ACTIONS(4965),
    [anon_sym_in] = ACTIONS(4965),
    [anon_sym_do] = ACTIONS(4965),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym_RBRACK] = ACTIONS(4965),
    [anon_sym_COLON_COLON2] = ACTIONS(4965),
    [anon_sym_AMP_DOT] = ACTIONS(4965),
    [anon_sym_PLUS_EQ] = ACTIONS(4965),
    [anon_sym_DASH_EQ] = ACTIONS(4965),
    [anon_sym_STAR_EQ] = ACTIONS(4965),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4965),
    [anon_sym_SLASH_EQ] = ACTIONS(4965),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4965),
    [anon_sym_PIPE_EQ] = ACTIONS(4965),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4965),
    [anon_sym_AMP_EQ] = ACTIONS(4965),
    [anon_sym_PERCENT_EQ] = ACTIONS(4965),
    [anon_sym_GT_GT_EQ] = ACTIONS(4965),
    [anon_sym_LT_LT_EQ] = ACTIONS(4965),
    [anon_sym_CARET_EQ] = ACTIONS(4965),
    [anon_sym_QMARK] = ACTIONS(4965),
    [anon_sym_COLON2] = ACTIONS(4967),
    [anon_sym_DOT_DOT] = ACTIONS(4967),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4965),
    [anon_sym_and] = ACTIONS(4965),
    [anon_sym_or] = ACTIONS(4965),
    [anon_sym_PIPE_PIPE] = ACTIONS(4967),
    [anon_sym_AMP_AMP] = ACTIONS(4967),
    [anon_sym_LT_LT] = ACTIONS(4967),
    [anon_sym_GT_GT] = ACTIONS(4967),
    [anon_sym_EQ_EQ] = ACTIONS(4967),
    [anon_sym_BANG_EQ] = ACTIONS(4965),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4965),
    [anon_sym_LT_EQ_GT] = ACTIONS(4965),
    [anon_sym_EQ_TILDE] = ACTIONS(4965),
    [anon_sym_BANG_TILDE] = ACTIONS(4965),
    [anon_sym_LT_EQ] = ACTIONS(4967),
    [anon_sym_GT] = ACTIONS(4967),
    [anon_sym_GT_EQ] = ACTIONS(4965),
    [anon_sym_CARET] = ACTIONS(4967),
    [anon_sym_PLUS] = ACTIONS(4967),
    [anon_sym_SLASH] = ACTIONS(4967),
    [anon_sym_PERCENT] = ACTIONS(4967),
    [sym_comment] = ACTIONS(87),
  },
  [8857] = {
    [anon_sym_end] = ACTIONS(13875),
    [sym_comment] = ACTIONS(87),
  },
  [8858] = {
    [sym_when] = STATE(10191),
    [sym_else] = STATE(10189),
    [aux_sym_case_repeat1] = STATE(2987),
    [aux_sym_case_repeat2] = STATE(10191),
    [anon_sym_SEMI] = ACTIONS(4995),
    [anon_sym_end] = ACTIONS(13875),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [8859] = {
    [sym_when] = STATE(2988),
    [sym_else] = STATE(10189),
    [aux_sym_case_repeat2] = STATE(2988),
    [anon_sym_end] = ACTIONS(13875),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [8860] = {
    [sym__heredoc_body_start] = ACTIONS(5407),
    [sym__binary_minus] = ACTIONS(5407),
    [sym__binary_star] = ACTIONS(5407),
    [anon_sym_LBRACE] = ACTIONS(5407),
    [anon_sym_RBRACE] = ACTIONS(5407),
    [anon_sym_RPAREN] = ACTIONS(5407),
    [anon_sym_DOT] = ACTIONS(5409),
    [anon_sym_COMMA] = ACTIONS(5407),
    [anon_sym_PIPE] = ACTIONS(5409),
    [anon_sym_SEMI] = ACTIONS(5407),
    [anon_sym_STAR_STAR] = ACTIONS(5409),
    [anon_sym_AMP] = ACTIONS(5409),
    [anon_sym_EQ] = ACTIONS(5409),
    [anon_sym_LT] = ACTIONS(5409),
    [anon_sym_if] = ACTIONS(5407),
    [anon_sym_unless] = ACTIONS(5407),
    [anon_sym_while] = ACTIONS(5407),
    [anon_sym_until] = ACTIONS(5407),
    [anon_sym_rescue] = ACTIONS(5407),
    [anon_sym_in] = ACTIONS(5407),
    [anon_sym_do] = ACTIONS(5407),
    [anon_sym_LBRACK] = ACTIONS(5407),
    [anon_sym_RBRACK] = ACTIONS(5407),
    [anon_sym_COLON_COLON2] = ACTIONS(5407),
    [anon_sym_AMP_DOT] = ACTIONS(5407),
    [anon_sym_PLUS_EQ] = ACTIONS(5407),
    [anon_sym_DASH_EQ] = ACTIONS(5407),
    [anon_sym_STAR_EQ] = ACTIONS(5407),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5407),
    [anon_sym_SLASH_EQ] = ACTIONS(5407),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5407),
    [anon_sym_PIPE_EQ] = ACTIONS(5407),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5407),
    [anon_sym_AMP_EQ] = ACTIONS(5407),
    [anon_sym_PERCENT_EQ] = ACTIONS(5407),
    [anon_sym_GT_GT_EQ] = ACTIONS(5407),
    [anon_sym_LT_LT_EQ] = ACTIONS(5407),
    [anon_sym_CARET_EQ] = ACTIONS(5407),
    [anon_sym_QMARK] = ACTIONS(5407),
    [anon_sym_COLON2] = ACTIONS(5409),
    [anon_sym_DOT_DOT] = ACTIONS(5409),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5407),
    [anon_sym_and] = ACTIONS(5407),
    [anon_sym_or] = ACTIONS(5407),
    [anon_sym_PIPE_PIPE] = ACTIONS(5409),
    [anon_sym_AMP_AMP] = ACTIONS(5409),
    [anon_sym_LT_LT] = ACTIONS(5409),
    [anon_sym_GT_GT] = ACTIONS(5409),
    [anon_sym_EQ_EQ] = ACTIONS(5409),
    [anon_sym_BANG_EQ] = ACTIONS(5407),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5407),
    [anon_sym_LT_EQ_GT] = ACTIONS(5407),
    [anon_sym_EQ_TILDE] = ACTIONS(5407),
    [anon_sym_BANG_TILDE] = ACTIONS(5407),
    [anon_sym_LT_EQ] = ACTIONS(5409),
    [anon_sym_GT] = ACTIONS(5409),
    [anon_sym_GT_EQ] = ACTIONS(5407),
    [anon_sym_CARET] = ACTIONS(5409),
    [anon_sym_PLUS] = ACTIONS(5409),
    [anon_sym_SLASH] = ACTIONS(5409),
    [anon_sym_PERCENT] = ACTIONS(5409),
    [sym_comment] = ACTIONS(87),
  },
  [8861] = {
    [sym_ensure] = STATE(10193),
    [anon_sym_end] = ACTIONS(13877),
    [anon_sym_ensure] = ACTIONS(2169),
    [sym_comment] = ACTIONS(87),
  },
  [8862] = {
    [anon_sym_end] = ACTIONS(13877),
    [sym_comment] = ACTIONS(87),
  },
  [8863] = {
    [sym_else] = STATE(10194),
    [sym_ensure] = STATE(10193),
    [anon_sym_end] = ACTIONS(13877),
    [anon_sym_else] = ACTIONS(2167),
    [anon_sym_ensure] = ACTIONS(2169),
    [sym_comment] = ACTIONS(87),
  },
  [8864] = {
    [sym__heredoc_body_start] = ACTIONS(5491),
    [sym__binary_minus] = ACTIONS(5491),
    [sym__binary_star] = ACTIONS(5491),
    [anon_sym_LBRACE] = ACTIONS(5491),
    [anon_sym_RBRACE] = ACTIONS(5491),
    [anon_sym_RPAREN] = ACTIONS(5491),
    [anon_sym_DOT] = ACTIONS(5493),
    [anon_sym_COMMA] = ACTIONS(5491),
    [anon_sym_PIPE] = ACTIONS(5493),
    [anon_sym_SEMI] = ACTIONS(5491),
    [anon_sym_STAR_STAR] = ACTIONS(5493),
    [anon_sym_AMP] = ACTIONS(5493),
    [anon_sym_EQ] = ACTIONS(5493),
    [anon_sym_LT] = ACTIONS(5493),
    [anon_sym_if] = ACTIONS(5491),
    [anon_sym_unless] = ACTIONS(5491),
    [anon_sym_while] = ACTIONS(5491),
    [anon_sym_until] = ACTIONS(5491),
    [anon_sym_rescue] = ACTIONS(5491),
    [anon_sym_in] = ACTIONS(5491),
    [anon_sym_do] = ACTIONS(5491),
    [anon_sym_LBRACK] = ACTIONS(5491),
    [anon_sym_RBRACK] = ACTIONS(5491),
    [anon_sym_COLON_COLON2] = ACTIONS(5491),
    [anon_sym_AMP_DOT] = ACTIONS(5491),
    [anon_sym_PLUS_EQ] = ACTIONS(5491),
    [anon_sym_DASH_EQ] = ACTIONS(5491),
    [anon_sym_STAR_EQ] = ACTIONS(5491),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5491),
    [anon_sym_SLASH_EQ] = ACTIONS(5491),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5491),
    [anon_sym_PIPE_EQ] = ACTIONS(5491),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5491),
    [anon_sym_AMP_EQ] = ACTIONS(5491),
    [anon_sym_PERCENT_EQ] = ACTIONS(5491),
    [anon_sym_GT_GT_EQ] = ACTIONS(5491),
    [anon_sym_LT_LT_EQ] = ACTIONS(5491),
    [anon_sym_CARET_EQ] = ACTIONS(5491),
    [anon_sym_QMARK] = ACTIONS(5491),
    [anon_sym_COLON2] = ACTIONS(5493),
    [anon_sym_DOT_DOT] = ACTIONS(5493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5491),
    [anon_sym_and] = ACTIONS(5491),
    [anon_sym_or] = ACTIONS(5491),
    [anon_sym_PIPE_PIPE] = ACTIONS(5493),
    [anon_sym_AMP_AMP] = ACTIONS(5493),
    [anon_sym_LT_LT] = ACTIONS(5493),
    [anon_sym_GT_GT] = ACTIONS(5493),
    [anon_sym_EQ_EQ] = ACTIONS(5493),
    [anon_sym_BANG_EQ] = ACTIONS(5491),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5491),
    [anon_sym_LT_EQ_GT] = ACTIONS(5491),
    [anon_sym_EQ_TILDE] = ACTIONS(5491),
    [anon_sym_BANG_TILDE] = ACTIONS(5491),
    [anon_sym_LT_EQ] = ACTIONS(5493),
    [anon_sym_GT] = ACTIONS(5493),
    [anon_sym_GT_EQ] = ACTIONS(5491),
    [anon_sym_CARET] = ACTIONS(5493),
    [anon_sym_PLUS] = ACTIONS(5493),
    [anon_sym_SLASH] = ACTIONS(5493),
    [anon_sym_PERCENT] = ACTIONS(5493),
    [sym_comment] = ACTIONS(87),
  },
  [8865] = {
    [sym__heredoc_body_start] = ACTIONS(5725),
    [sym__binary_minus] = ACTIONS(5725),
    [sym__binary_star] = ACTIONS(5725),
    [anon_sym_LBRACE] = ACTIONS(5725),
    [anon_sym_RBRACE] = ACTIONS(5725),
    [anon_sym_RPAREN] = ACTIONS(5725),
    [anon_sym_DOT] = ACTIONS(5727),
    [anon_sym_COMMA] = ACTIONS(5725),
    [anon_sym_PIPE] = ACTIONS(5727),
    [anon_sym_SEMI] = ACTIONS(5725),
    [anon_sym_STAR_STAR] = ACTIONS(5727),
    [anon_sym_AMP] = ACTIONS(5727),
    [anon_sym_EQ] = ACTIONS(5727),
    [anon_sym_LT] = ACTIONS(5727),
    [anon_sym_if] = ACTIONS(5725),
    [anon_sym_unless] = ACTIONS(5725),
    [anon_sym_while] = ACTIONS(5725),
    [anon_sym_until] = ACTIONS(5725),
    [anon_sym_rescue] = ACTIONS(5725),
    [anon_sym_in] = ACTIONS(5725),
    [anon_sym_do] = ACTIONS(5725),
    [anon_sym_LBRACK] = ACTIONS(5725),
    [anon_sym_RBRACK] = ACTIONS(5725),
    [anon_sym_COLON_COLON2] = ACTIONS(5725),
    [anon_sym_AMP_DOT] = ACTIONS(5725),
    [anon_sym_PLUS_EQ] = ACTIONS(5725),
    [anon_sym_DASH_EQ] = ACTIONS(5725),
    [anon_sym_STAR_EQ] = ACTIONS(5725),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5725),
    [anon_sym_SLASH_EQ] = ACTIONS(5725),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5725),
    [anon_sym_PIPE_EQ] = ACTIONS(5725),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5725),
    [anon_sym_AMP_EQ] = ACTIONS(5725),
    [anon_sym_PERCENT_EQ] = ACTIONS(5725),
    [anon_sym_GT_GT_EQ] = ACTIONS(5725),
    [anon_sym_LT_LT_EQ] = ACTIONS(5725),
    [anon_sym_CARET_EQ] = ACTIONS(5725),
    [anon_sym_QMARK] = ACTIONS(5725),
    [anon_sym_COLON2] = ACTIONS(5727),
    [anon_sym_DOT_DOT] = ACTIONS(5727),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5725),
    [anon_sym_and] = ACTIONS(5725),
    [anon_sym_or] = ACTIONS(5725),
    [anon_sym_PIPE_PIPE] = ACTIONS(5727),
    [anon_sym_AMP_AMP] = ACTIONS(5727),
    [anon_sym_LT_LT] = ACTIONS(5727),
    [anon_sym_GT_GT] = ACTIONS(5727),
    [anon_sym_EQ_EQ] = ACTIONS(5727),
    [anon_sym_BANG_EQ] = ACTIONS(5725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5725),
    [anon_sym_LT_EQ_GT] = ACTIONS(5725),
    [anon_sym_EQ_TILDE] = ACTIONS(5725),
    [anon_sym_BANG_TILDE] = ACTIONS(5725),
    [anon_sym_LT_EQ] = ACTIONS(5727),
    [anon_sym_GT] = ACTIONS(5727),
    [anon_sym_GT_EQ] = ACTIONS(5725),
    [anon_sym_CARET] = ACTIONS(5727),
    [anon_sym_PLUS] = ACTIONS(5727),
    [anon_sym_SLASH] = ACTIONS(5727),
    [anon_sym_PERCENT] = ACTIONS(5727),
    [sym_comment] = ACTIONS(87),
  },
  [8866] = {
    [sym__heredoc_body_start] = ACTIONS(5807),
    [sym__binary_minus] = ACTIONS(5807),
    [sym__binary_star] = ACTIONS(5807),
    [anon_sym_LBRACE] = ACTIONS(5807),
    [anon_sym_RBRACE] = ACTIONS(5807),
    [anon_sym_RPAREN] = ACTIONS(5807),
    [anon_sym_DOT] = ACTIONS(5809),
    [anon_sym_COMMA] = ACTIONS(5807),
    [anon_sym_PIPE] = ACTIONS(5809),
    [anon_sym_SEMI] = ACTIONS(5807),
    [anon_sym_STAR_STAR] = ACTIONS(5809),
    [anon_sym_AMP] = ACTIONS(5809),
    [anon_sym_EQ] = ACTIONS(5809),
    [anon_sym_LT] = ACTIONS(5809),
    [anon_sym_if] = ACTIONS(5807),
    [anon_sym_unless] = ACTIONS(5807),
    [anon_sym_while] = ACTIONS(5807),
    [anon_sym_until] = ACTIONS(5807),
    [anon_sym_rescue] = ACTIONS(5807),
    [anon_sym_in] = ACTIONS(5807),
    [anon_sym_do] = ACTIONS(5807),
    [anon_sym_LBRACK] = ACTIONS(5807),
    [anon_sym_RBRACK] = ACTIONS(5807),
    [anon_sym_COLON_COLON2] = ACTIONS(5807),
    [anon_sym_AMP_DOT] = ACTIONS(5807),
    [anon_sym_PLUS_EQ] = ACTIONS(5807),
    [anon_sym_DASH_EQ] = ACTIONS(5807),
    [anon_sym_STAR_EQ] = ACTIONS(5807),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5807),
    [anon_sym_SLASH_EQ] = ACTIONS(5807),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5807),
    [anon_sym_PIPE_EQ] = ACTIONS(5807),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5807),
    [anon_sym_AMP_EQ] = ACTIONS(5807),
    [anon_sym_PERCENT_EQ] = ACTIONS(5807),
    [anon_sym_GT_GT_EQ] = ACTIONS(5807),
    [anon_sym_LT_LT_EQ] = ACTIONS(5807),
    [anon_sym_CARET_EQ] = ACTIONS(5807),
    [anon_sym_QMARK] = ACTIONS(5807),
    [anon_sym_COLON2] = ACTIONS(5809),
    [anon_sym_DOT_DOT] = ACTIONS(5809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5807),
    [anon_sym_and] = ACTIONS(5807),
    [anon_sym_or] = ACTIONS(5807),
    [anon_sym_PIPE_PIPE] = ACTIONS(5809),
    [anon_sym_AMP_AMP] = ACTIONS(5809),
    [anon_sym_LT_LT] = ACTIONS(5809),
    [anon_sym_GT_GT] = ACTIONS(5809),
    [anon_sym_EQ_EQ] = ACTIONS(5809),
    [anon_sym_BANG_EQ] = ACTIONS(5807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5807),
    [anon_sym_LT_EQ_GT] = ACTIONS(5807),
    [anon_sym_EQ_TILDE] = ACTIONS(5807),
    [anon_sym_BANG_TILDE] = ACTIONS(5807),
    [anon_sym_LT_EQ] = ACTIONS(5809),
    [anon_sym_GT] = ACTIONS(5809),
    [anon_sym_GT_EQ] = ACTIONS(5807),
    [anon_sym_CARET] = ACTIONS(5809),
    [anon_sym_PLUS] = ACTIONS(5809),
    [anon_sym_SLASH] = ACTIONS(5809),
    [anon_sym_PERCENT] = ACTIONS(5809),
    [sym_comment] = ACTIONS(87),
  },
  [8867] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(10119),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(10123),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(10123),
    [anon_sym_PERCENT] = ACTIONS(10123),
    [sym_comment] = ACTIONS(87),
  },
  [8868] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(10123),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(5827),
    [anon_sym_PERCENT] = ACTIONS(5827),
    [sym_comment] = ACTIONS(87),
  },
  [8869] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10117),
    [sym__binary_star] = ACTIONS(10119),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(10123),
    [anon_sym_AMP] = ACTIONS(10125),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(10137),
    [anon_sym_GT_GT] = ACTIONS(10137),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(10143),
    [anon_sym_SLASH] = ACTIONS(10123),
    [anon_sym_PERCENT] = ACTIONS(10123),
    [sym_comment] = ACTIONS(87),
  },
  [8870] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10117),
    [sym__binary_star] = ACTIONS(10119),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(10123),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(10137),
    [anon_sym_GT_GT] = ACTIONS(10137),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(10143),
    [anon_sym_SLASH] = ACTIONS(10123),
    [anon_sym_PERCENT] = ACTIONS(10123),
    [sym_comment] = ACTIONS(87),
  },
  [8871] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10117),
    [sym__binary_star] = ACTIONS(10119),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(10121),
    [anon_sym_STAR_STAR] = ACTIONS(10123),
    [anon_sym_AMP] = ACTIONS(10125),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(10137),
    [anon_sym_GT_GT] = ACTIONS(10137),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(10121),
    [anon_sym_PLUS] = ACTIONS(10143),
    [anon_sym_SLASH] = ACTIONS(10123),
    [anon_sym_PERCENT] = ACTIONS(10123),
    [sym_comment] = ACTIONS(87),
  },
  [8872] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(13879),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [8873] = {
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(10117),
    [sym__binary_star] = ACTIONS(10119),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_RBRACE] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(10121),
    [anon_sym_STAR_STAR] = ACTIONS(10123),
    [anon_sym_AMP] = ACTIONS(10125),
    [anon_sym_EQ] = ACTIONS(7888),
    [anon_sym_LT] = ACTIONS(10127),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_PLUS_EQ] = ACTIONS(5927),
    [anon_sym_DASH_EQ] = ACTIONS(5927),
    [anon_sym_STAR_EQ] = ACTIONS(5927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5927),
    [anon_sym_SLASH_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5927),
    [anon_sym_AMP_EQ] = ACTIONS(5927),
    [anon_sym_PERCENT_EQ] = ACTIONS(5927),
    [anon_sym_GT_GT_EQ] = ACTIONS(5927),
    [anon_sym_LT_LT_EQ] = ACTIONS(5927),
    [anon_sym_CARET_EQ] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(10131),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10133),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(10135),
    [anon_sym_AMP_AMP] = ACTIONS(10135),
    [anon_sym_LT_LT] = ACTIONS(10137),
    [anon_sym_GT_GT] = ACTIONS(10137),
    [anon_sym_EQ_EQ] = ACTIONS(10135),
    [anon_sym_BANG_EQ] = ACTIONS(10139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10139),
    [anon_sym_LT_EQ_GT] = ACTIONS(10139),
    [anon_sym_EQ_TILDE] = ACTIONS(10139),
    [anon_sym_BANG_TILDE] = ACTIONS(10139),
    [anon_sym_LT_EQ] = ACTIONS(10127),
    [anon_sym_GT] = ACTIONS(10127),
    [anon_sym_GT_EQ] = ACTIONS(10141),
    [anon_sym_CARET] = ACTIONS(10121),
    [anon_sym_PLUS] = ACTIONS(10143),
    [anon_sym_SLASH] = ACTIONS(10123),
    [anon_sym_PERCENT] = ACTIONS(10123),
    [sym_comment] = ACTIONS(87),
  },
  [8874] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10117),
    [sym__binary_star] = ACTIONS(10119),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(10121),
    [anon_sym_STAR_STAR] = ACTIONS(10123),
    [anon_sym_AMP] = ACTIONS(10125),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(10127),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(10129),
    [anon_sym_DOT_DOT] = ACTIONS(10131),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10133),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(10135),
    [anon_sym_AMP_AMP] = ACTIONS(10135),
    [anon_sym_LT_LT] = ACTIONS(10137),
    [anon_sym_GT_GT] = ACTIONS(10137),
    [anon_sym_EQ_EQ] = ACTIONS(10135),
    [anon_sym_BANG_EQ] = ACTIONS(10139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10139),
    [anon_sym_LT_EQ_GT] = ACTIONS(10139),
    [anon_sym_EQ_TILDE] = ACTIONS(10139),
    [anon_sym_BANG_TILDE] = ACTIONS(10139),
    [anon_sym_LT_EQ] = ACTIONS(10127),
    [anon_sym_GT] = ACTIONS(10127),
    [anon_sym_GT_EQ] = ACTIONS(10141),
    [anon_sym_CARET] = ACTIONS(10121),
    [anon_sym_PLUS] = ACTIONS(10143),
    [anon_sym_SLASH] = ACTIONS(10123),
    [anon_sym_PERCENT] = ACTIONS(10123),
    [sym_comment] = ACTIONS(87),
  },
  [8875] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10117),
    [sym__binary_star] = ACTIONS(10119),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(10121),
    [anon_sym_STAR_STAR] = ACTIONS(10123),
    [anon_sym_AMP] = ACTIONS(10125),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(10127),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(10137),
    [anon_sym_GT_GT] = ACTIONS(10137),
    [anon_sym_EQ_EQ] = ACTIONS(10135),
    [anon_sym_BANG_EQ] = ACTIONS(10139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10139),
    [anon_sym_LT_EQ_GT] = ACTIONS(10139),
    [anon_sym_EQ_TILDE] = ACTIONS(10139),
    [anon_sym_BANG_TILDE] = ACTIONS(10139),
    [anon_sym_LT_EQ] = ACTIONS(10127),
    [anon_sym_GT] = ACTIONS(10127),
    [anon_sym_GT_EQ] = ACTIONS(10141),
    [anon_sym_CARET] = ACTIONS(10121),
    [anon_sym_PLUS] = ACTIONS(10143),
    [anon_sym_SLASH] = ACTIONS(10123),
    [anon_sym_PERCENT] = ACTIONS(10123),
    [sym_comment] = ACTIONS(87),
  },
  [8876] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10117),
    [sym__binary_star] = ACTIONS(10119),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(10123),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(10143),
    [anon_sym_SLASH] = ACTIONS(10123),
    [anon_sym_PERCENT] = ACTIONS(10123),
    [sym_comment] = ACTIONS(87),
  },
  [8877] = {
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(10117),
    [sym__binary_star] = ACTIONS(10119),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_RBRACE] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(10121),
    [anon_sym_STAR_STAR] = ACTIONS(10123),
    [anon_sym_AMP] = ACTIONS(10125),
    [anon_sym_EQ] = ACTIONS(7936),
    [anon_sym_LT] = ACTIONS(10127),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_PLUS_EQ] = ACTIONS(5115),
    [anon_sym_DASH_EQ] = ACTIONS(5115),
    [anon_sym_STAR_EQ] = ACTIONS(5115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5115),
    [anon_sym_SLASH_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5115),
    [anon_sym_AMP_EQ] = ACTIONS(5115),
    [anon_sym_PERCENT_EQ] = ACTIONS(5115),
    [anon_sym_GT_GT_EQ] = ACTIONS(5115),
    [anon_sym_LT_LT_EQ] = ACTIONS(5115),
    [anon_sym_CARET_EQ] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(10129),
    [anon_sym_DOT_DOT] = ACTIONS(10131),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10133),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(10135),
    [anon_sym_AMP_AMP] = ACTIONS(10135),
    [anon_sym_LT_LT] = ACTIONS(10137),
    [anon_sym_GT_GT] = ACTIONS(10137),
    [anon_sym_EQ_EQ] = ACTIONS(10135),
    [anon_sym_BANG_EQ] = ACTIONS(10139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10139),
    [anon_sym_LT_EQ_GT] = ACTIONS(10139),
    [anon_sym_EQ_TILDE] = ACTIONS(10139),
    [anon_sym_BANG_TILDE] = ACTIONS(10139),
    [anon_sym_LT_EQ] = ACTIONS(10127),
    [anon_sym_GT] = ACTIONS(10127),
    [anon_sym_GT_EQ] = ACTIONS(10141),
    [anon_sym_CARET] = ACTIONS(10121),
    [anon_sym_PLUS] = ACTIONS(10143),
    [anon_sym_SLASH] = ACTIONS(10123),
    [anon_sym_PERCENT] = ACTIONS(10123),
    [sym_comment] = ACTIONS(87),
  },
  [8878] = {
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_RBRACE] = ACTIONS(6191),
    [anon_sym_RPAREN] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6193),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_in] = ACTIONS(6191),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_RBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_PLUS_EQ] = ACTIONS(6191),
    [anon_sym_DASH_EQ] = ACTIONS(6191),
    [anon_sym_STAR_EQ] = ACTIONS(6191),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6191),
    [anon_sym_SLASH_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6191),
    [anon_sym_AMP_EQ] = ACTIONS(6191),
    [anon_sym_PERCENT_EQ] = ACTIONS(6191),
    [anon_sym_GT_GT_EQ] = ACTIONS(6191),
    [anon_sym_LT_LT_EQ] = ACTIONS(6191),
    [anon_sym_CARET_EQ] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_COLON2] = ACTIONS(6193),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6193),
    [anon_sym_AMP_AMP] = ACTIONS(6193),
    [anon_sym_LT_LT] = ACTIONS(6193),
    [anon_sym_GT_GT] = ACTIONS(6193),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6193),
    [anon_sym_PLUS] = ACTIONS(6193),
    [anon_sym_SLASH] = ACTIONS(6193),
    [anon_sym_PERCENT] = ACTIONS(6193),
    [sym_comment] = ACTIONS(87),
  },
  [8879] = {
    [aux_sym_exceptions_repeat1] = STATE(10197),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_RBRACE] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_STAR_STAR] = ACTIONS(6193),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_PLUS_EQ] = ACTIONS(6191),
    [anon_sym_DASH_EQ] = ACTIONS(6191),
    [anon_sym_STAR_EQ] = ACTIONS(6191),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6191),
    [anon_sym_SLASH_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6191),
    [anon_sym_AMP_EQ] = ACTIONS(6191),
    [anon_sym_PERCENT_EQ] = ACTIONS(6191),
    [anon_sym_GT_GT_EQ] = ACTIONS(6191),
    [anon_sym_LT_LT_EQ] = ACTIONS(6191),
    [anon_sym_CARET_EQ] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6193),
    [anon_sym_AMP_AMP] = ACTIONS(6193),
    [anon_sym_LT_LT] = ACTIONS(6193),
    [anon_sym_GT_GT] = ACTIONS(6193),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6193),
    [anon_sym_PLUS] = ACTIONS(6193),
    [anon_sym_SLASH] = ACTIONS(6193),
    [anon_sym_PERCENT] = ACTIONS(6193),
    [sym_comment] = ACTIONS(87),
  },
  [8880] = {
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(10117),
    [sym__binary_star] = ACTIONS(10119),
    [anon_sym_LBRACE] = ACTIONS(6210),
    [anon_sym_RBRACE] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(10121),
    [anon_sym_STAR_STAR] = ACTIONS(10123),
    [anon_sym_AMP] = ACTIONS(10125),
    [anon_sym_EQ] = ACTIONS(7938),
    [anon_sym_LT] = ACTIONS(10127),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_PLUS_EQ] = ACTIONS(6210),
    [anon_sym_DASH_EQ] = ACTIONS(6210),
    [anon_sym_STAR_EQ] = ACTIONS(6210),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6210),
    [anon_sym_SLASH_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6210),
    [anon_sym_AMP_EQ] = ACTIONS(6210),
    [anon_sym_PERCENT_EQ] = ACTIONS(6210),
    [anon_sym_GT_GT_EQ] = ACTIONS(6210),
    [anon_sym_LT_LT_EQ] = ACTIONS(6210),
    [anon_sym_CARET_EQ] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(10129),
    [anon_sym_DOT_DOT] = ACTIONS(10131),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10133),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(10135),
    [anon_sym_AMP_AMP] = ACTIONS(10135),
    [anon_sym_LT_LT] = ACTIONS(10137),
    [anon_sym_GT_GT] = ACTIONS(10137),
    [anon_sym_EQ_EQ] = ACTIONS(10135),
    [anon_sym_BANG_EQ] = ACTIONS(10139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10139),
    [anon_sym_LT_EQ_GT] = ACTIONS(10139),
    [anon_sym_EQ_TILDE] = ACTIONS(10139),
    [anon_sym_BANG_TILDE] = ACTIONS(10139),
    [anon_sym_LT_EQ] = ACTIONS(10127),
    [anon_sym_GT] = ACTIONS(10127),
    [anon_sym_GT_EQ] = ACTIONS(10141),
    [anon_sym_CARET] = ACTIONS(10121),
    [anon_sym_PLUS] = ACTIONS(10143),
    [anon_sym_SLASH] = ACTIONS(10123),
    [anon_sym_PERCENT] = ACTIONS(10123),
    [sym_comment] = ACTIONS(87),
  },
  [8881] = {
    [sym_string] = STATE(8881),
    [aux_sym_chained_string_repeat1] = STATE(8881),
    [sym__string_start] = ACTIONS(13881),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_RBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_STAR_STAR] = ACTIONS(6217),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_EQ] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_do] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_PLUS_EQ] = ACTIONS(6212),
    [anon_sym_DASH_EQ] = ACTIONS(6212),
    [anon_sym_STAR_EQ] = ACTIONS(6212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6212),
    [anon_sym_SLASH_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6212),
    [anon_sym_AMP_EQ] = ACTIONS(6212),
    [anon_sym_PERCENT_EQ] = ACTIONS(6212),
    [anon_sym_GT_GT_EQ] = ACTIONS(6212),
    [anon_sym_LT_LT_EQ] = ACTIONS(6212),
    [anon_sym_CARET_EQ] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6217),
    [anon_sym_AMP_AMP] = ACTIONS(6217),
    [anon_sym_LT_LT] = ACTIONS(6217),
    [anon_sym_GT_GT] = ACTIONS(6217),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6217),
    [anon_sym_PLUS] = ACTIONS(6217),
    [anon_sym_SLASH] = ACTIONS(6217),
    [anon_sym_PERCENT] = ACTIONS(6217),
    [sym_comment] = ACTIONS(87),
  },
  [8882] = {
    [sym__binary_minus] = ACTIONS(12029),
    [sym__binary_star] = ACTIONS(12029),
    [anon_sym_LBRACE] = ACTIONS(12029),
    [anon_sym_RBRACE] = ACTIONS(12029),
    [anon_sym_RPAREN] = ACTIONS(12029),
    [anon_sym_DOT] = ACTIONS(12031),
    [anon_sym_COMMA] = ACTIONS(12029),
    [anon_sym_PIPE] = ACTIONS(12031),
    [anon_sym_SEMI] = ACTIONS(12029),
    [anon_sym_STAR_STAR] = ACTIONS(12031),
    [anon_sym_AMP] = ACTIONS(12031),
    [anon_sym_EQ] = ACTIONS(12031),
    [anon_sym_LT] = ACTIONS(12031),
    [anon_sym_if] = ACTIONS(12029),
    [anon_sym_unless] = ACTIONS(12029),
    [anon_sym_while] = ACTIONS(12029),
    [anon_sym_until] = ACTIONS(12029),
    [anon_sym_rescue] = ACTIONS(12029),
    [anon_sym_do] = ACTIONS(12029),
    [anon_sym_LBRACK] = ACTIONS(12029),
    [anon_sym_COLON_COLON2] = ACTIONS(12029),
    [anon_sym_AMP_DOT] = ACTIONS(12029),
    [anon_sym_PLUS_EQ] = ACTIONS(12029),
    [anon_sym_DASH_EQ] = ACTIONS(12029),
    [anon_sym_STAR_EQ] = ACTIONS(12029),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12029),
    [anon_sym_SLASH_EQ] = ACTIONS(12029),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12029),
    [anon_sym_PIPE_EQ] = ACTIONS(12029),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12029),
    [anon_sym_AMP_EQ] = ACTIONS(12029),
    [anon_sym_PERCENT_EQ] = ACTIONS(12029),
    [anon_sym_GT_GT_EQ] = ACTIONS(12029),
    [anon_sym_LT_LT_EQ] = ACTIONS(12029),
    [anon_sym_CARET_EQ] = ACTIONS(12029),
    [anon_sym_QMARK] = ACTIONS(12029),
    [anon_sym_COLON2] = ACTIONS(12031),
    [anon_sym_DOT_DOT] = ACTIONS(12031),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12029),
    [anon_sym_and] = ACTIONS(12029),
    [anon_sym_or] = ACTIONS(12029),
    [anon_sym_PIPE_PIPE] = ACTIONS(12031),
    [anon_sym_AMP_AMP] = ACTIONS(12031),
    [anon_sym_LT_LT] = ACTIONS(12031),
    [anon_sym_GT_GT] = ACTIONS(12031),
    [anon_sym_EQ_EQ] = ACTIONS(12031),
    [anon_sym_BANG_EQ] = ACTIONS(12029),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12029),
    [anon_sym_LT_EQ_GT] = ACTIONS(12029),
    [anon_sym_EQ_TILDE] = ACTIONS(12029),
    [anon_sym_BANG_TILDE] = ACTIONS(12029),
    [anon_sym_LT_EQ] = ACTIONS(12031),
    [anon_sym_GT] = ACTIONS(12031),
    [anon_sym_GT_EQ] = ACTIONS(12029),
    [anon_sym_CARET] = ACTIONS(12031),
    [anon_sym_PLUS] = ACTIONS(12031),
    [anon_sym_SLASH] = ACTIONS(12031),
    [anon_sym_PERCENT] = ACTIONS(12031),
    [sym_comment] = ACTIONS(87),
  },
  [8883] = {
    [sym__binary_minus] = ACTIONS(12054),
    [sym__binary_star] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_RBRACE] = ACTIONS(12054),
    [anon_sym_RPAREN] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12056),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_PIPE] = ACTIONS(12056),
    [anon_sym_SEMI] = ACTIONS(12054),
    [anon_sym_STAR_STAR] = ACTIONS(12056),
    [anon_sym_AMP] = ACTIONS(12056),
    [anon_sym_EQ] = ACTIONS(12056),
    [anon_sym_LT] = ACTIONS(12056),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_unless] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [anon_sym_until] = ACTIONS(12054),
    [anon_sym_rescue] = ACTIONS(12054),
    [anon_sym_do] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_COLON_COLON2] = ACTIONS(12054),
    [anon_sym_AMP_DOT] = ACTIONS(12054),
    [anon_sym_PLUS_EQ] = ACTIONS(12054),
    [anon_sym_DASH_EQ] = ACTIONS(12054),
    [anon_sym_STAR_EQ] = ACTIONS(12054),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12054),
    [anon_sym_SLASH_EQ] = ACTIONS(12054),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12054),
    [anon_sym_PIPE_EQ] = ACTIONS(12054),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12054),
    [anon_sym_AMP_EQ] = ACTIONS(12054),
    [anon_sym_PERCENT_EQ] = ACTIONS(12054),
    [anon_sym_GT_GT_EQ] = ACTIONS(12054),
    [anon_sym_LT_LT_EQ] = ACTIONS(12054),
    [anon_sym_CARET_EQ] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_COLON2] = ACTIONS(12056),
    [anon_sym_DOT_DOT] = ACTIONS(12056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_and] = ACTIONS(12054),
    [anon_sym_or] = ACTIONS(12054),
    [anon_sym_PIPE_PIPE] = ACTIONS(12056),
    [anon_sym_AMP_AMP] = ACTIONS(12056),
    [anon_sym_LT_LT] = ACTIONS(12056),
    [anon_sym_GT_GT] = ACTIONS(12056),
    [anon_sym_EQ_EQ] = ACTIONS(12056),
    [anon_sym_BANG_EQ] = ACTIONS(12054),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12054),
    [anon_sym_LT_EQ_GT] = ACTIONS(12054),
    [anon_sym_EQ_TILDE] = ACTIONS(12054),
    [anon_sym_BANG_TILDE] = ACTIONS(12054),
    [anon_sym_LT_EQ] = ACTIONS(12056),
    [anon_sym_GT] = ACTIONS(12056),
    [anon_sym_GT_EQ] = ACTIONS(12054),
    [anon_sym_CARET] = ACTIONS(12056),
    [anon_sym_PLUS] = ACTIONS(12056),
    [anon_sym_SLASH] = ACTIONS(12056),
    [anon_sym_PERCENT] = ACTIONS(12056),
    [sym_comment] = ACTIONS(87),
  },
  [8884] = {
    [anon_sym_end] = ACTIONS(13884),
    [sym_comment] = ACTIONS(87),
  },
  [8885] = {
    [sym__statements] = STATE(10199),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13886),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8886] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(10200),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1686),
    [sym_scope_resolution] = STATE(1680),
    [sym_call] = STATE(1680),
    [sym_method_call] = STATE(1686),
    [sym_assignment] = STATE(10200),
    [sym_operator_assignment] = STATE(10200),
    [sym_conditional] = STATE(10200),
    [sym_range] = STATE(10200),
    [sym_binary] = STATE(10200),
    [sym_unary] = STATE(10200),
    [sym_left_assignment_list] = STATE(1685),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1686),
    [sym__variable] = STATE(1680),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1686),
    [sym_false] = STATE(1686),
    [sym_nil] = STATE(1686),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3944),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2992),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2998),
    [anon_sym_yield] = ACTIONS(3000),
    [anon_sym_break] = ACTIONS(3002),
    [anon_sym_next] = ACTIONS(3004),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6523),
    [anon_sym_defined_QMARK] = ACTIONS(3010),
    [anon_sym_not] = ACTIONS(3012),
    [anon_sym_BANG] = ACTIONS(3016),
    [anon_sym_TILDE] = ACTIONS(3016),
    [sym_constant] = ACTIONS(3022),
    [sym_identifier] = ACTIONS(3022),
    [sym_instance_variable] = ACTIONS(3020),
    [sym_class_variable] = ACTIONS(3020),
    [sym_global_variable] = ACTIONS(3020),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3022),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3022),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [8887] = {
    [sym__heredoc_body_start] = ACTIONS(6813),
    [sym__binary_minus] = ACTIONS(6813),
    [sym__binary_star] = ACTIONS(6813),
    [anon_sym_LBRACE] = ACTIONS(6813),
    [anon_sym_RBRACE] = ACTIONS(6813),
    [anon_sym_RPAREN] = ACTIONS(6813),
    [anon_sym_DOT] = ACTIONS(8689),
    [anon_sym_COMMA] = ACTIONS(6813),
    [anon_sym_PIPE] = ACTIONS(8689),
    [anon_sym_SEMI] = ACTIONS(6813),
    [anon_sym_STAR_STAR] = ACTIONS(8689),
    [anon_sym_AMP] = ACTIONS(8689),
    [anon_sym_EQ] = ACTIONS(8689),
    [anon_sym_LT] = ACTIONS(8689),
    [anon_sym_if] = ACTIONS(6813),
    [anon_sym_unless] = ACTIONS(6813),
    [anon_sym_while] = ACTIONS(6813),
    [anon_sym_until] = ACTIONS(6813),
    [anon_sym_rescue] = ACTIONS(6813),
    [anon_sym_in] = ACTIONS(6813),
    [anon_sym_do] = ACTIONS(6813),
    [anon_sym_LBRACK] = ACTIONS(6813),
    [anon_sym_RBRACK] = ACTIONS(6813),
    [anon_sym_COLON_COLON2] = ACTIONS(6813),
    [anon_sym_AMP_DOT] = ACTIONS(6813),
    [anon_sym_PLUS_EQ] = ACTIONS(6813),
    [anon_sym_DASH_EQ] = ACTIONS(6813),
    [anon_sym_STAR_EQ] = ACTIONS(6813),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6813),
    [anon_sym_SLASH_EQ] = ACTIONS(6813),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6813),
    [anon_sym_PIPE_EQ] = ACTIONS(6813),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6813),
    [anon_sym_AMP_EQ] = ACTIONS(6813),
    [anon_sym_PERCENT_EQ] = ACTIONS(6813),
    [anon_sym_GT_GT_EQ] = ACTIONS(6813),
    [anon_sym_LT_LT_EQ] = ACTIONS(6813),
    [anon_sym_CARET_EQ] = ACTIONS(6813),
    [anon_sym_QMARK] = ACTIONS(6813),
    [anon_sym_COLON2] = ACTIONS(8689),
    [anon_sym_DOT_DOT] = ACTIONS(8689),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6813),
    [anon_sym_and] = ACTIONS(6813),
    [anon_sym_or] = ACTIONS(6813),
    [anon_sym_PIPE_PIPE] = ACTIONS(8689),
    [anon_sym_AMP_AMP] = ACTIONS(8689),
    [anon_sym_LT_LT] = ACTIONS(8689),
    [anon_sym_GT_GT] = ACTIONS(8689),
    [anon_sym_EQ_EQ] = ACTIONS(8689),
    [anon_sym_BANG_EQ] = ACTIONS(6813),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6813),
    [anon_sym_LT_EQ_GT] = ACTIONS(6813),
    [anon_sym_EQ_TILDE] = ACTIONS(6813),
    [anon_sym_BANG_TILDE] = ACTIONS(6813),
    [anon_sym_LT_EQ] = ACTIONS(8689),
    [anon_sym_GT] = ACTIONS(8689),
    [anon_sym_GT_EQ] = ACTIONS(6813),
    [anon_sym_CARET] = ACTIONS(8689),
    [anon_sym_PLUS] = ACTIONS(8689),
    [anon_sym_SLASH] = ACTIONS(8689),
    [anon_sym_PERCENT] = ACTIONS(8689),
    [sym_comment] = ACTIONS(87),
  },
  [8888] = {
    [sym__heredoc_body_start] = ACTIONS(10986),
    [sym__binary_minus] = ACTIONS(10986),
    [sym__binary_star] = ACTIONS(10986),
    [anon_sym_LBRACE] = ACTIONS(10986),
    [anon_sym_RBRACE] = ACTIONS(10986),
    [anon_sym_RPAREN] = ACTIONS(10986),
    [anon_sym_DOT] = ACTIONS(10988),
    [anon_sym_COMMA] = ACTIONS(10986),
    [anon_sym_PIPE] = ACTIONS(10988),
    [anon_sym_SEMI] = ACTIONS(10986),
    [anon_sym_STAR_STAR] = ACTIONS(10988),
    [anon_sym_AMP] = ACTIONS(10988),
    [anon_sym_EQ] = ACTIONS(10988),
    [anon_sym_LT] = ACTIONS(10988),
    [anon_sym_if] = ACTIONS(10986),
    [anon_sym_unless] = ACTIONS(10986),
    [anon_sym_while] = ACTIONS(10986),
    [anon_sym_until] = ACTIONS(10986),
    [anon_sym_rescue] = ACTIONS(10986),
    [anon_sym_in] = ACTIONS(10986),
    [anon_sym_do] = ACTIONS(10986),
    [anon_sym_LBRACK] = ACTIONS(10986),
    [anon_sym_RBRACK] = ACTIONS(10986),
    [anon_sym_COLON_COLON2] = ACTIONS(10986),
    [anon_sym_AMP_DOT] = ACTIONS(10986),
    [anon_sym_PLUS_EQ] = ACTIONS(10986),
    [anon_sym_DASH_EQ] = ACTIONS(10986),
    [anon_sym_STAR_EQ] = ACTIONS(10986),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10986),
    [anon_sym_SLASH_EQ] = ACTIONS(10986),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10986),
    [anon_sym_PIPE_EQ] = ACTIONS(10986),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10986),
    [anon_sym_AMP_EQ] = ACTIONS(10986),
    [anon_sym_PERCENT_EQ] = ACTIONS(10986),
    [anon_sym_GT_GT_EQ] = ACTIONS(10986),
    [anon_sym_LT_LT_EQ] = ACTIONS(10986),
    [anon_sym_CARET_EQ] = ACTIONS(10986),
    [anon_sym_QMARK] = ACTIONS(10986),
    [anon_sym_COLON2] = ACTIONS(10988),
    [anon_sym_DOT_DOT] = ACTIONS(10988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10986),
    [anon_sym_and] = ACTIONS(10986),
    [anon_sym_or] = ACTIONS(10986),
    [anon_sym_PIPE_PIPE] = ACTIONS(10988),
    [anon_sym_AMP_AMP] = ACTIONS(10988),
    [anon_sym_LT_LT] = ACTIONS(10988),
    [anon_sym_GT_GT] = ACTIONS(10988),
    [anon_sym_EQ_EQ] = ACTIONS(10988),
    [anon_sym_BANG_EQ] = ACTIONS(10986),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10986),
    [anon_sym_LT_EQ_GT] = ACTIONS(10986),
    [anon_sym_EQ_TILDE] = ACTIONS(10986),
    [anon_sym_BANG_TILDE] = ACTIONS(10986),
    [anon_sym_LT_EQ] = ACTIONS(10988),
    [anon_sym_GT] = ACTIONS(10988),
    [anon_sym_GT_EQ] = ACTIONS(10986),
    [anon_sym_CARET] = ACTIONS(10988),
    [anon_sym_PLUS] = ACTIONS(10988),
    [anon_sym_SLASH] = ACTIONS(10988),
    [anon_sym_PERCENT] = ACTIONS(10988),
    [sym_comment] = ACTIONS(87),
  },
  [8889] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6678),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1686),
    [sym_scope_resolution] = STATE(1680),
    [sym_call] = STATE(1680),
    [sym_method_call] = STATE(1686),
    [sym_splat_argument] = STATE(9044),
    [sym_assignment] = STATE(6678),
    [sym_operator_assignment] = STATE(6678),
    [sym_conditional] = STATE(6678),
    [sym_range] = STATE(6678),
    [sym_binary] = STATE(6678),
    [sym_unary] = STATE(6678),
    [sym__arg_or_splat_arg] = STATE(9044),
    [sym_left_assignment_list] = STATE(1685),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1686),
    [sym__variable] = STATE(1680),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1686),
    [sym_false] = STATE(1686),
    [sym_nil] = STATE(1686),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3944),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__splat_star] = ACTIONS(6415),
    [sym__unary_minus] = ACTIONS(2992),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2998),
    [anon_sym_yield] = ACTIONS(3000),
    [anon_sym_break] = ACTIONS(3002),
    [anon_sym_next] = ACTIONS(3004),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6523),
    [anon_sym_defined_QMARK] = ACTIONS(3010),
    [anon_sym_not] = ACTIONS(3012),
    [anon_sym_BANG] = ACTIONS(3016),
    [anon_sym_TILDE] = ACTIONS(3016),
    [sym_constant] = ACTIONS(3022),
    [sym_identifier] = ACTIONS(3022),
    [sym_instance_variable] = ACTIONS(3020),
    [sym_class_variable] = ACTIONS(3020),
    [sym_global_variable] = ACTIONS(3020),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3022),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3022),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [8890] = {
    [aux_sym_exceptions_repeat1] = STATE(10201),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_LBRACE] = ACTIONS(9855),
    [anon_sym_RBRACE] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(13888),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_STAR_STAR] = ACTIONS(9857),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_EQ] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_do] = ACTIONS(9855),
    [anon_sym_EQ_GT] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_PLUS_EQ] = ACTIONS(9855),
    [anon_sym_DASH_EQ] = ACTIONS(9855),
    [anon_sym_STAR_EQ] = ACTIONS(9855),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9855),
    [anon_sym_SLASH_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9855),
    [anon_sym_AMP_EQ] = ACTIONS(9855),
    [anon_sym_PERCENT_EQ] = ACTIONS(9855),
    [anon_sym_GT_GT_EQ] = ACTIONS(9855),
    [anon_sym_LT_LT_EQ] = ACTIONS(9855),
    [anon_sym_CARET_EQ] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9857),
    [anon_sym_AMP_AMP] = ACTIONS(9857),
    [anon_sym_LT_LT] = ACTIONS(9857),
    [anon_sym_GT_GT] = ACTIONS(9857),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9857),
    [anon_sym_PLUS] = ACTIONS(9857),
    [anon_sym_SLASH] = ACTIONS(9857),
    [anon_sym_PERCENT] = ACTIONS(9857),
    [sym_comment] = ACTIONS(87),
  },
  [8891] = {
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(10171),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(10171),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(10171),
    [anon_sym_PERCENT] = ACTIONS(10171),
    [sym_comment] = ACTIONS(87),
  },
  [8892] = {
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(10171),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [8893] = {
    [sym__binary_minus] = ACTIONS(10169),
    [sym__binary_star] = ACTIONS(10171),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(10171),
    [anon_sym_AMP] = ACTIONS(10175),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(10187),
    [anon_sym_GT_GT] = ACTIONS(10187),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(10169),
    [anon_sym_SLASH] = ACTIONS(10171),
    [anon_sym_PERCENT] = ACTIONS(10171),
    [sym_comment] = ACTIONS(87),
  },
  [8894] = {
    [sym__binary_minus] = ACTIONS(10169),
    [sym__binary_star] = ACTIONS(10171),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(10171),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(10187),
    [anon_sym_GT_GT] = ACTIONS(10187),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(10169),
    [anon_sym_SLASH] = ACTIONS(10171),
    [anon_sym_PERCENT] = ACTIONS(10171),
    [sym_comment] = ACTIONS(87),
  },
  [8895] = {
    [sym__binary_minus] = ACTIONS(10169),
    [sym__binary_star] = ACTIONS(10171),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(10173),
    [anon_sym_STAR_STAR] = ACTIONS(10171),
    [anon_sym_AMP] = ACTIONS(10175),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(10187),
    [anon_sym_GT_GT] = ACTIONS(10187),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(10193),
    [anon_sym_PLUS] = ACTIONS(10169),
    [anon_sym_SLASH] = ACTIONS(10171),
    [anon_sym_PERCENT] = ACTIONS(10171),
    [sym_comment] = ACTIONS(87),
  },
  [8896] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(13890),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [8897] = {
    [sym__binary_minus] = ACTIONS(10169),
    [sym__binary_star] = ACTIONS(10171),
    [anon_sym_RBRACE] = ACTIONS(5927),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(10173),
    [anon_sym_STAR_STAR] = ACTIONS(10171),
    [anon_sym_AMP] = ACTIONS(10175),
    [anon_sym_LT] = ACTIONS(10177),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(10181),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10183),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(10185),
    [anon_sym_AMP_AMP] = ACTIONS(10185),
    [anon_sym_LT_LT] = ACTIONS(10187),
    [anon_sym_GT_GT] = ACTIONS(10187),
    [anon_sym_EQ_EQ] = ACTIONS(10189),
    [anon_sym_BANG_EQ] = ACTIONS(10185),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10185),
    [anon_sym_LT_EQ_GT] = ACTIONS(10185),
    [anon_sym_EQ_TILDE] = ACTIONS(10185),
    [anon_sym_BANG_TILDE] = ACTIONS(10185),
    [anon_sym_LT_EQ] = ACTIONS(10177),
    [anon_sym_GT] = ACTIONS(10177),
    [anon_sym_GT_EQ] = ACTIONS(10191),
    [anon_sym_CARET] = ACTIONS(10193),
    [anon_sym_PLUS] = ACTIONS(10169),
    [anon_sym_SLASH] = ACTIONS(10171),
    [anon_sym_PERCENT] = ACTIONS(10171),
    [sym_comment] = ACTIONS(87),
  },
  [8898] = {
    [sym__binary_minus] = ACTIONS(10169),
    [sym__binary_star] = ACTIONS(10171),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(10173),
    [anon_sym_STAR_STAR] = ACTIONS(10171),
    [anon_sym_AMP] = ACTIONS(10175),
    [anon_sym_LT] = ACTIONS(10177),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(10179),
    [anon_sym_DOT_DOT] = ACTIONS(10181),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10183),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(10185),
    [anon_sym_AMP_AMP] = ACTIONS(10185),
    [anon_sym_LT_LT] = ACTIONS(10187),
    [anon_sym_GT_GT] = ACTIONS(10187),
    [anon_sym_EQ_EQ] = ACTIONS(10189),
    [anon_sym_BANG_EQ] = ACTIONS(10185),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10185),
    [anon_sym_LT_EQ_GT] = ACTIONS(10185),
    [anon_sym_EQ_TILDE] = ACTIONS(10185),
    [anon_sym_BANG_TILDE] = ACTIONS(10185),
    [anon_sym_LT_EQ] = ACTIONS(10177),
    [anon_sym_GT] = ACTIONS(10177),
    [anon_sym_GT_EQ] = ACTIONS(10191),
    [anon_sym_CARET] = ACTIONS(10193),
    [anon_sym_PLUS] = ACTIONS(10169),
    [anon_sym_SLASH] = ACTIONS(10171),
    [anon_sym_PERCENT] = ACTIONS(10171),
    [sym_comment] = ACTIONS(87),
  },
  [8899] = {
    [sym__binary_minus] = ACTIONS(10169),
    [sym__binary_star] = ACTIONS(10171),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(10173),
    [anon_sym_STAR_STAR] = ACTIONS(10171),
    [anon_sym_AMP] = ACTIONS(10175),
    [anon_sym_LT] = ACTIONS(10177),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(10187),
    [anon_sym_GT_GT] = ACTIONS(10187),
    [anon_sym_EQ_EQ] = ACTIONS(10189),
    [anon_sym_BANG_EQ] = ACTIONS(10185),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10185),
    [anon_sym_LT_EQ_GT] = ACTIONS(10185),
    [anon_sym_EQ_TILDE] = ACTIONS(10185),
    [anon_sym_BANG_TILDE] = ACTIONS(10185),
    [anon_sym_LT_EQ] = ACTIONS(10177),
    [anon_sym_GT] = ACTIONS(10177),
    [anon_sym_GT_EQ] = ACTIONS(10191),
    [anon_sym_CARET] = ACTIONS(10193),
    [anon_sym_PLUS] = ACTIONS(10169),
    [anon_sym_SLASH] = ACTIONS(10171),
    [anon_sym_PERCENT] = ACTIONS(10171),
    [sym_comment] = ACTIONS(87),
  },
  [8900] = {
    [sym__binary_minus] = ACTIONS(10169),
    [sym__binary_star] = ACTIONS(10171),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(10171),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(10169),
    [anon_sym_SLASH] = ACTIONS(10171),
    [anon_sym_PERCENT] = ACTIONS(10171),
    [sym_comment] = ACTIONS(87),
  },
  [8901] = {
    [aux_sym_exceptions_repeat1] = STATE(8901),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_RBRACE] = ACTIONS(11597),
    [anon_sym_COMMA] = ACTIONS(13892),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [8902] = {
    [aux_sym_exceptions_repeat1] = STATE(6696),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_RBRACE] = ACTIONS(6191),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [8903] = {
    [sym__binary_minus] = ACTIONS(10169),
    [sym__binary_star] = ACTIONS(10171),
    [anon_sym_RBRACE] = ACTIONS(6210),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(10173),
    [anon_sym_STAR_STAR] = ACTIONS(10171),
    [anon_sym_AMP] = ACTIONS(10175),
    [anon_sym_LT] = ACTIONS(10177),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(10179),
    [anon_sym_DOT_DOT] = ACTIONS(10181),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10183),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(10185),
    [anon_sym_AMP_AMP] = ACTIONS(10185),
    [anon_sym_LT_LT] = ACTIONS(10187),
    [anon_sym_GT_GT] = ACTIONS(10187),
    [anon_sym_EQ_EQ] = ACTIONS(10189),
    [anon_sym_BANG_EQ] = ACTIONS(10185),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10185),
    [anon_sym_LT_EQ_GT] = ACTIONS(10185),
    [anon_sym_EQ_TILDE] = ACTIONS(10185),
    [anon_sym_BANG_TILDE] = ACTIONS(10185),
    [anon_sym_LT_EQ] = ACTIONS(10177),
    [anon_sym_GT] = ACTIONS(10177),
    [anon_sym_GT_EQ] = ACTIONS(10191),
    [anon_sym_CARET] = ACTIONS(10193),
    [anon_sym_PLUS] = ACTIONS(10169),
    [anon_sym_SLASH] = ACTIONS(10171),
    [anon_sym_PERCENT] = ACTIONS(10171),
    [sym_comment] = ACTIONS(87),
  },
  [8904] = {
    [sym_string] = STATE(8904),
    [aux_sym_chained_string_repeat1] = STATE(8904),
    [sym__string_start] = ACTIONS(7159),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_RBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [8905] = {
    [sym_heredoc_body] = STATE(10203),
    [aux_sym_call_repeat1] = STATE(10203),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_RBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [8906] = {
    [sym_heredoc_body] = STATE(10204),
    [aux_sym_call_repeat1] = STATE(10204),
    [aux_sym_argument_list_repeat1] = STATE(6736),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_RBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(6701),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [8907] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(10225),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(10225),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(10225),
    [anon_sym_PERCENT] = ACTIONS(10225),
    [sym_comment] = ACTIONS(87),
  },
  [8908] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(10225),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [8909] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10223),
    [sym__binary_star] = ACTIONS(10225),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(10225),
    [anon_sym_AMP] = ACTIONS(10229),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(10241),
    [anon_sym_GT_GT] = ACTIONS(10241),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(10223),
    [anon_sym_SLASH] = ACTIONS(10225),
    [anon_sym_PERCENT] = ACTIONS(10225),
    [sym_comment] = ACTIONS(87),
  },
  [8910] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10223),
    [sym__binary_star] = ACTIONS(10225),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(10225),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(10241),
    [anon_sym_GT_GT] = ACTIONS(10241),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(10223),
    [anon_sym_SLASH] = ACTIONS(10225),
    [anon_sym_PERCENT] = ACTIONS(10225),
    [sym_comment] = ACTIONS(87),
  },
  [8911] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10223),
    [sym__binary_star] = ACTIONS(10225),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(10227),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(10225),
    [anon_sym_AMP] = ACTIONS(10229),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(10241),
    [anon_sym_GT_GT] = ACTIONS(10241),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(10247),
    [anon_sym_PLUS] = ACTIONS(10223),
    [anon_sym_SLASH] = ACTIONS(10225),
    [anon_sym_PERCENT] = ACTIONS(10225),
    [sym_comment] = ACTIONS(87),
  },
  [8912] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(13895),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [8913] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(10223),
    [sym__binary_star] = ACTIONS(10225),
    [anon_sym_RBRACE] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(10227),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(10225),
    [anon_sym_AMP] = ACTIONS(10229),
    [anon_sym_LT] = ACTIONS(10231),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(10235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10237),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(10239),
    [anon_sym_AMP_AMP] = ACTIONS(10239),
    [anon_sym_LT_LT] = ACTIONS(10241),
    [anon_sym_GT_GT] = ACTIONS(10241),
    [anon_sym_EQ_EQ] = ACTIONS(10243),
    [anon_sym_BANG_EQ] = ACTIONS(10239),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10239),
    [anon_sym_LT_EQ_GT] = ACTIONS(10239),
    [anon_sym_EQ_TILDE] = ACTIONS(10239),
    [anon_sym_BANG_TILDE] = ACTIONS(10239),
    [anon_sym_LT_EQ] = ACTIONS(10231),
    [anon_sym_GT] = ACTIONS(10231),
    [anon_sym_GT_EQ] = ACTIONS(10245),
    [anon_sym_CARET] = ACTIONS(10247),
    [anon_sym_PLUS] = ACTIONS(10223),
    [anon_sym_SLASH] = ACTIONS(10225),
    [anon_sym_PERCENT] = ACTIONS(10225),
    [sym_comment] = ACTIONS(87),
  },
  [8914] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10223),
    [sym__binary_star] = ACTIONS(10225),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(10227),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(10225),
    [anon_sym_AMP] = ACTIONS(10229),
    [anon_sym_LT] = ACTIONS(10231),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(10233),
    [anon_sym_DOT_DOT] = ACTIONS(10235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10237),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(10239),
    [anon_sym_AMP_AMP] = ACTIONS(10239),
    [anon_sym_LT_LT] = ACTIONS(10241),
    [anon_sym_GT_GT] = ACTIONS(10241),
    [anon_sym_EQ_EQ] = ACTIONS(10243),
    [anon_sym_BANG_EQ] = ACTIONS(10239),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10239),
    [anon_sym_LT_EQ_GT] = ACTIONS(10239),
    [anon_sym_EQ_TILDE] = ACTIONS(10239),
    [anon_sym_BANG_TILDE] = ACTIONS(10239),
    [anon_sym_LT_EQ] = ACTIONS(10231),
    [anon_sym_GT] = ACTIONS(10231),
    [anon_sym_GT_EQ] = ACTIONS(10245),
    [anon_sym_CARET] = ACTIONS(10247),
    [anon_sym_PLUS] = ACTIONS(10223),
    [anon_sym_SLASH] = ACTIONS(10225),
    [anon_sym_PERCENT] = ACTIONS(10225),
    [sym_comment] = ACTIONS(87),
  },
  [8915] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10223),
    [sym__binary_star] = ACTIONS(10225),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(10227),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(10225),
    [anon_sym_AMP] = ACTIONS(10229),
    [anon_sym_LT] = ACTIONS(10231),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(10241),
    [anon_sym_GT_GT] = ACTIONS(10241),
    [anon_sym_EQ_EQ] = ACTIONS(10243),
    [anon_sym_BANG_EQ] = ACTIONS(10239),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10239),
    [anon_sym_LT_EQ_GT] = ACTIONS(10239),
    [anon_sym_EQ_TILDE] = ACTIONS(10239),
    [anon_sym_BANG_TILDE] = ACTIONS(10239),
    [anon_sym_LT_EQ] = ACTIONS(10231),
    [anon_sym_GT] = ACTIONS(10231),
    [anon_sym_GT_EQ] = ACTIONS(10245),
    [anon_sym_CARET] = ACTIONS(10247),
    [anon_sym_PLUS] = ACTIONS(10223),
    [anon_sym_SLASH] = ACTIONS(10225),
    [anon_sym_PERCENT] = ACTIONS(10225),
    [sym_comment] = ACTIONS(87),
  },
  [8916] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10223),
    [sym__binary_star] = ACTIONS(10225),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(10225),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(10223),
    [anon_sym_SLASH] = ACTIONS(10225),
    [anon_sym_PERCENT] = ACTIONS(10225),
    [sym_comment] = ACTIONS(87),
  },
  [8917] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(10223),
    [sym__binary_star] = ACTIONS(10225),
    [anon_sym_RBRACE] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(10227),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(10225),
    [anon_sym_AMP] = ACTIONS(10229),
    [anon_sym_LT] = ACTIONS(10231),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(10233),
    [anon_sym_DOT_DOT] = ACTIONS(10235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10237),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(10239),
    [anon_sym_AMP_AMP] = ACTIONS(10239),
    [anon_sym_LT_LT] = ACTIONS(10241),
    [anon_sym_GT_GT] = ACTIONS(10241),
    [anon_sym_EQ_EQ] = ACTIONS(10243),
    [anon_sym_BANG_EQ] = ACTIONS(10239),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10239),
    [anon_sym_LT_EQ_GT] = ACTIONS(10239),
    [anon_sym_EQ_TILDE] = ACTIONS(10239),
    [anon_sym_BANG_TILDE] = ACTIONS(10239),
    [anon_sym_LT_EQ] = ACTIONS(10231),
    [anon_sym_GT] = ACTIONS(10231),
    [anon_sym_GT_EQ] = ACTIONS(10245),
    [anon_sym_CARET] = ACTIONS(10247),
    [anon_sym_PLUS] = ACTIONS(10223),
    [anon_sym_SLASH] = ACTIONS(10225),
    [anon_sym_PERCENT] = ACTIONS(10225),
    [sym_comment] = ACTIONS(87),
  },
  [8918] = {
    [aux_sym_exceptions_repeat1] = STATE(10207),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_RBRACE] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [8919] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(10223),
    [sym__binary_star] = ACTIONS(10225),
    [anon_sym_RBRACE] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(10227),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(10225),
    [anon_sym_AMP] = ACTIONS(10229),
    [anon_sym_LT] = ACTIONS(10231),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(10233),
    [anon_sym_DOT_DOT] = ACTIONS(10235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10237),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(10239),
    [anon_sym_AMP_AMP] = ACTIONS(10239),
    [anon_sym_LT_LT] = ACTIONS(10241),
    [anon_sym_GT_GT] = ACTIONS(10241),
    [anon_sym_EQ_EQ] = ACTIONS(10243),
    [anon_sym_BANG_EQ] = ACTIONS(10239),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10239),
    [anon_sym_LT_EQ_GT] = ACTIONS(10239),
    [anon_sym_EQ_TILDE] = ACTIONS(10239),
    [anon_sym_BANG_TILDE] = ACTIONS(10239),
    [anon_sym_LT_EQ] = ACTIONS(10231),
    [anon_sym_GT] = ACTIONS(10231),
    [anon_sym_GT_EQ] = ACTIONS(10245),
    [anon_sym_CARET] = ACTIONS(10247),
    [anon_sym_PLUS] = ACTIONS(10223),
    [anon_sym_SLASH] = ACTIONS(10225),
    [anon_sym_PERCENT] = ACTIONS(10225),
    [sym_comment] = ACTIONS(87),
  },
  [8920] = {
    [sym_string] = STATE(8920),
    [aux_sym_chained_string_repeat1] = STATE(8920),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(6214),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_RBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [8921] = {
    [sym_heredoc_body] = STATE(8921),
    [aux_sym_call_repeat1] = STATE(8921),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(7916),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_RBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_EQ_GT] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [8922] = {
    [sym_heredoc_body] = STATE(8921),
    [aux_sym_call_repeat1] = STATE(8921),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_RBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_EQ_GT] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [8923] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10208),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1725),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1725),
    [sym_assignment] = STATE(10208),
    [sym_operator_assignment] = STATE(10208),
    [sym_conditional] = STATE(10208),
    [sym_range] = STATE(10208),
    [sym_binary] = STATE(10208),
    [sym_unary] = STATE(10208),
    [sym_left_assignment_list] = STATE(1724),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1725),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1725),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(4013),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(3111),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6669),
    [anon_sym_defined_QMARK] = ACTIONS(3123),
    [anon_sym_not] = ACTIONS(3125),
    [anon_sym_BANG] = ACTIONS(3129),
    [anon_sym_TILDE] = ACTIONS(3129),
    [sym_constant] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8924] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6737),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1725),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(1725),
    [sym_splat_argument] = STATE(7439),
    [sym_assignment] = STATE(6737),
    [sym_operator_assignment] = STATE(6737),
    [sym_conditional] = STATE(6737),
    [sym_range] = STATE(6737),
    [sym_binary] = STATE(6737),
    [sym_unary] = STATE(6737),
    [sym__arg_or_splat_arg] = STATE(7439),
    [sym_left_assignment_list] = STATE(1724),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1725),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1725),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(4013),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__splat_star] = ACTIONS(6059),
    [sym__unary_minus] = ACTIONS(3111),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6669),
    [anon_sym_defined_QMARK] = ACTIONS(3123),
    [anon_sym_not] = ACTIONS(3125),
    [anon_sym_BANG] = ACTIONS(3129),
    [anon_sym_TILDE] = ACTIONS(3129),
    [sym_constant] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8925] = {
    [aux_sym_exceptions_repeat1] = STATE(10209),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_RBRACE] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(13897),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_EQ_GT] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [8926] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(3147),
    [sym__binary_star] = ACTIONS(3149),
    [anon_sym_RBRACE] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(3151),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(3149),
    [anon_sym_AMP] = ACTIONS(3153),
    [anon_sym_LT] = ACTIONS(3155),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(3157),
    [anon_sym_DOT_DOT] = ACTIONS(3159),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3161),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3167),
    [anon_sym_GT_GT] = ACTIONS(3167),
    [anon_sym_EQ_EQ] = ACTIONS(3169),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3155),
    [anon_sym_GT] = ACTIONS(3155),
    [anon_sym_GT_EQ] = ACTIONS(3171),
    [anon_sym_CARET] = ACTIONS(3173),
    [anon_sym_PLUS] = ACTIONS(3147),
    [anon_sym_SLASH] = ACTIONS(3149),
    [anon_sym_PERCENT] = ACTIONS(3149),
    [sym_comment] = ACTIONS(87),
  },
  [8927] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(10261),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(10265),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(10265),
    [anon_sym_PERCENT] = ACTIONS(10265),
    [sym_comment] = ACTIONS(87),
  },
  [8928] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(10265),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(5827),
    [anon_sym_PERCENT] = ACTIONS(5827),
    [sym_comment] = ACTIONS(87),
  },
  [8929] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10259),
    [sym__binary_star] = ACTIONS(10261),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(10265),
    [anon_sym_AMP] = ACTIONS(10267),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(10279),
    [anon_sym_GT_GT] = ACTIONS(10279),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(10285),
    [anon_sym_SLASH] = ACTIONS(10265),
    [anon_sym_PERCENT] = ACTIONS(10265),
    [sym_comment] = ACTIONS(87),
  },
  [8930] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10259),
    [sym__binary_star] = ACTIONS(10261),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(10265),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(10279),
    [anon_sym_GT_GT] = ACTIONS(10279),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(10285),
    [anon_sym_SLASH] = ACTIONS(10265),
    [anon_sym_PERCENT] = ACTIONS(10265),
    [sym_comment] = ACTIONS(87),
  },
  [8931] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10259),
    [sym__binary_star] = ACTIONS(10261),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(10263),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(10265),
    [anon_sym_AMP] = ACTIONS(10267),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(10279),
    [anon_sym_GT_GT] = ACTIONS(10279),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(10263),
    [anon_sym_PLUS] = ACTIONS(10285),
    [anon_sym_SLASH] = ACTIONS(10265),
    [anon_sym_PERCENT] = ACTIONS(10265),
    [sym_comment] = ACTIONS(87),
  },
  [8932] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(13899),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [8933] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(10259),
    [sym__binary_star] = ACTIONS(10261),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_RBRACE] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(10263),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(10265),
    [anon_sym_AMP] = ACTIONS(10267),
    [anon_sym_EQ] = ACTIONS(7888),
    [anon_sym_LT] = ACTIONS(10269),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_PLUS_EQ] = ACTIONS(5927),
    [anon_sym_DASH_EQ] = ACTIONS(5927),
    [anon_sym_STAR_EQ] = ACTIONS(5927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5927),
    [anon_sym_SLASH_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5927),
    [anon_sym_AMP_EQ] = ACTIONS(5927),
    [anon_sym_PERCENT_EQ] = ACTIONS(5927),
    [anon_sym_GT_GT_EQ] = ACTIONS(5927),
    [anon_sym_LT_LT_EQ] = ACTIONS(5927),
    [anon_sym_CARET_EQ] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(10273),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10275),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(10277),
    [anon_sym_AMP_AMP] = ACTIONS(10277),
    [anon_sym_LT_LT] = ACTIONS(10279),
    [anon_sym_GT_GT] = ACTIONS(10279),
    [anon_sym_EQ_EQ] = ACTIONS(10277),
    [anon_sym_BANG_EQ] = ACTIONS(10281),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10281),
    [anon_sym_LT_EQ_GT] = ACTIONS(10281),
    [anon_sym_EQ_TILDE] = ACTIONS(10281),
    [anon_sym_BANG_TILDE] = ACTIONS(10281),
    [anon_sym_LT_EQ] = ACTIONS(10269),
    [anon_sym_GT] = ACTIONS(10269),
    [anon_sym_GT_EQ] = ACTIONS(10283),
    [anon_sym_CARET] = ACTIONS(10263),
    [anon_sym_PLUS] = ACTIONS(10285),
    [anon_sym_SLASH] = ACTIONS(10265),
    [anon_sym_PERCENT] = ACTIONS(10265),
    [sym_comment] = ACTIONS(87),
  },
  [8934] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10259),
    [sym__binary_star] = ACTIONS(10261),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(10263),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(10265),
    [anon_sym_AMP] = ACTIONS(10267),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(10269),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(10271),
    [anon_sym_DOT_DOT] = ACTIONS(10273),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10275),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(10277),
    [anon_sym_AMP_AMP] = ACTIONS(10277),
    [anon_sym_LT_LT] = ACTIONS(10279),
    [anon_sym_GT_GT] = ACTIONS(10279),
    [anon_sym_EQ_EQ] = ACTIONS(10277),
    [anon_sym_BANG_EQ] = ACTIONS(10281),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10281),
    [anon_sym_LT_EQ_GT] = ACTIONS(10281),
    [anon_sym_EQ_TILDE] = ACTIONS(10281),
    [anon_sym_BANG_TILDE] = ACTIONS(10281),
    [anon_sym_LT_EQ] = ACTIONS(10269),
    [anon_sym_GT] = ACTIONS(10269),
    [anon_sym_GT_EQ] = ACTIONS(10283),
    [anon_sym_CARET] = ACTIONS(10263),
    [anon_sym_PLUS] = ACTIONS(10285),
    [anon_sym_SLASH] = ACTIONS(10265),
    [anon_sym_PERCENT] = ACTIONS(10265),
    [sym_comment] = ACTIONS(87),
  },
  [8935] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10259),
    [sym__binary_star] = ACTIONS(10261),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(10263),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(10265),
    [anon_sym_AMP] = ACTIONS(10267),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(10269),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(10279),
    [anon_sym_GT_GT] = ACTIONS(10279),
    [anon_sym_EQ_EQ] = ACTIONS(10277),
    [anon_sym_BANG_EQ] = ACTIONS(10281),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10281),
    [anon_sym_LT_EQ_GT] = ACTIONS(10281),
    [anon_sym_EQ_TILDE] = ACTIONS(10281),
    [anon_sym_BANG_TILDE] = ACTIONS(10281),
    [anon_sym_LT_EQ] = ACTIONS(10269),
    [anon_sym_GT] = ACTIONS(10269),
    [anon_sym_GT_EQ] = ACTIONS(10283),
    [anon_sym_CARET] = ACTIONS(10263),
    [anon_sym_PLUS] = ACTIONS(10285),
    [anon_sym_SLASH] = ACTIONS(10265),
    [anon_sym_PERCENT] = ACTIONS(10265),
    [sym_comment] = ACTIONS(87),
  },
  [8936] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10259),
    [sym__binary_star] = ACTIONS(10261),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(10265),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(10285),
    [anon_sym_SLASH] = ACTIONS(10265),
    [anon_sym_PERCENT] = ACTIONS(10265),
    [sym_comment] = ACTIONS(87),
  },
  [8937] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(10259),
    [sym__binary_star] = ACTIONS(10261),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_RBRACE] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(10263),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(10265),
    [anon_sym_AMP] = ACTIONS(10267),
    [anon_sym_EQ] = ACTIONS(7936),
    [anon_sym_LT] = ACTIONS(10269),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_PLUS_EQ] = ACTIONS(5115),
    [anon_sym_DASH_EQ] = ACTIONS(5115),
    [anon_sym_STAR_EQ] = ACTIONS(5115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5115),
    [anon_sym_SLASH_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5115),
    [anon_sym_AMP_EQ] = ACTIONS(5115),
    [anon_sym_PERCENT_EQ] = ACTIONS(5115),
    [anon_sym_GT_GT_EQ] = ACTIONS(5115),
    [anon_sym_LT_LT_EQ] = ACTIONS(5115),
    [anon_sym_CARET_EQ] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(10271),
    [anon_sym_DOT_DOT] = ACTIONS(10273),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10275),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(10277),
    [anon_sym_AMP_AMP] = ACTIONS(10277),
    [anon_sym_LT_LT] = ACTIONS(10279),
    [anon_sym_GT_GT] = ACTIONS(10279),
    [anon_sym_EQ_EQ] = ACTIONS(10277),
    [anon_sym_BANG_EQ] = ACTIONS(10281),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10281),
    [anon_sym_LT_EQ_GT] = ACTIONS(10281),
    [anon_sym_EQ_TILDE] = ACTIONS(10281),
    [anon_sym_BANG_TILDE] = ACTIONS(10281),
    [anon_sym_LT_EQ] = ACTIONS(10269),
    [anon_sym_GT] = ACTIONS(10269),
    [anon_sym_GT_EQ] = ACTIONS(10283),
    [anon_sym_CARET] = ACTIONS(10263),
    [anon_sym_PLUS] = ACTIONS(10285),
    [anon_sym_SLASH] = ACTIONS(10265),
    [anon_sym_PERCENT] = ACTIONS(10265),
    [sym_comment] = ACTIONS(87),
  },
  [8938] = {
    [aux_sym_exceptions_repeat1] = STATE(10212),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_RBRACE] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6193),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_PLUS_EQ] = ACTIONS(6191),
    [anon_sym_DASH_EQ] = ACTIONS(6191),
    [anon_sym_STAR_EQ] = ACTIONS(6191),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6191),
    [anon_sym_SLASH_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6191),
    [anon_sym_AMP_EQ] = ACTIONS(6191),
    [anon_sym_PERCENT_EQ] = ACTIONS(6191),
    [anon_sym_GT_GT_EQ] = ACTIONS(6191),
    [anon_sym_LT_LT_EQ] = ACTIONS(6191),
    [anon_sym_CARET_EQ] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6193),
    [anon_sym_AMP_AMP] = ACTIONS(6193),
    [anon_sym_LT_LT] = ACTIONS(6193),
    [anon_sym_GT_GT] = ACTIONS(6193),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6193),
    [anon_sym_PLUS] = ACTIONS(6193),
    [anon_sym_SLASH] = ACTIONS(6193),
    [anon_sym_PERCENT] = ACTIONS(6193),
    [sym_comment] = ACTIONS(87),
  },
  [8939] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(10259),
    [sym__binary_star] = ACTIONS(10261),
    [anon_sym_LBRACE] = ACTIONS(6210),
    [anon_sym_RBRACE] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(10263),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(10265),
    [anon_sym_AMP] = ACTIONS(10267),
    [anon_sym_EQ] = ACTIONS(7938),
    [anon_sym_LT] = ACTIONS(10269),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_PLUS_EQ] = ACTIONS(6210),
    [anon_sym_DASH_EQ] = ACTIONS(6210),
    [anon_sym_STAR_EQ] = ACTIONS(6210),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6210),
    [anon_sym_SLASH_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6210),
    [anon_sym_AMP_EQ] = ACTIONS(6210),
    [anon_sym_PERCENT_EQ] = ACTIONS(6210),
    [anon_sym_GT_GT_EQ] = ACTIONS(6210),
    [anon_sym_LT_LT_EQ] = ACTIONS(6210),
    [anon_sym_CARET_EQ] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(10271),
    [anon_sym_DOT_DOT] = ACTIONS(10273),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10275),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(10277),
    [anon_sym_AMP_AMP] = ACTIONS(10277),
    [anon_sym_LT_LT] = ACTIONS(10279),
    [anon_sym_GT_GT] = ACTIONS(10279),
    [anon_sym_EQ_EQ] = ACTIONS(10277),
    [anon_sym_BANG_EQ] = ACTIONS(10281),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10281),
    [anon_sym_LT_EQ_GT] = ACTIONS(10281),
    [anon_sym_EQ_TILDE] = ACTIONS(10281),
    [anon_sym_BANG_TILDE] = ACTIONS(10281),
    [anon_sym_LT_EQ] = ACTIONS(10269),
    [anon_sym_GT] = ACTIONS(10269),
    [anon_sym_GT_EQ] = ACTIONS(10283),
    [anon_sym_CARET] = ACTIONS(10263),
    [anon_sym_PLUS] = ACTIONS(10285),
    [anon_sym_SLASH] = ACTIONS(10265),
    [anon_sym_PERCENT] = ACTIONS(10265),
    [sym_comment] = ACTIONS(87),
  },
  [8940] = {
    [sym_string] = STATE(8940),
    [aux_sym_chained_string_repeat1] = STATE(8940),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(12267),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_RBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6217),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_EQ] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_do] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_PLUS_EQ] = ACTIONS(6212),
    [anon_sym_DASH_EQ] = ACTIONS(6212),
    [anon_sym_STAR_EQ] = ACTIONS(6212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6212),
    [anon_sym_SLASH_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6212),
    [anon_sym_AMP_EQ] = ACTIONS(6212),
    [anon_sym_PERCENT_EQ] = ACTIONS(6212),
    [anon_sym_GT_GT_EQ] = ACTIONS(6212),
    [anon_sym_LT_LT_EQ] = ACTIONS(6212),
    [anon_sym_CARET_EQ] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6217),
    [anon_sym_AMP_AMP] = ACTIONS(6217),
    [anon_sym_LT_LT] = ACTIONS(6217),
    [anon_sym_GT_GT] = ACTIONS(6217),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6217),
    [anon_sym_PLUS] = ACTIONS(6217),
    [anon_sym_SLASH] = ACTIONS(6217),
    [anon_sym_PERCENT] = ACTIONS(6217),
    [sym_comment] = ACTIONS(87),
  },
  [8941] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(10213),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1762),
    [sym_scope_resolution] = STATE(1758),
    [sym_call] = STATE(1758),
    [sym_method_call] = STATE(1762),
    [sym_assignment] = STATE(10213),
    [sym_operator_assignment] = STATE(10213),
    [sym_conditional] = STATE(10213),
    [sym_range] = STATE(10213),
    [sym_binary] = STATE(10213),
    [sym_unary] = STATE(10213),
    [sym_left_assignment_list] = STATE(1761),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1762),
    [sym__variable] = STATE(1758),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1762),
    [sym_false] = STATE(1762),
    [sym_nil] = STATE(1762),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(4066),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(3179),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(3183),
    [anon_sym_yield] = ACTIONS(3185),
    [anon_sym_break] = ACTIONS(3187),
    [anon_sym_next] = ACTIONS(3189),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(6735),
    [anon_sym_defined_QMARK] = ACTIONS(3191),
    [anon_sym_not] = ACTIONS(3193),
    [anon_sym_BANG] = ACTIONS(3197),
    [anon_sym_TILDE] = ACTIONS(3197),
    [sym_constant] = ACTIONS(3203),
    [sym_identifier] = ACTIONS(3203),
    [sym_instance_variable] = ACTIONS(3201),
    [sym_class_variable] = ACTIONS(3201),
    [sym_global_variable] = ACTIONS(3201),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(3203),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(3203),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [8942] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(6774),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(1762),
    [sym_scope_resolution] = STATE(1758),
    [sym_call] = STATE(1758),
    [sym_method_call] = STATE(1762),
    [sym_splat_argument] = STATE(8678),
    [sym_assignment] = STATE(6774),
    [sym_operator_assignment] = STATE(6774),
    [sym_conditional] = STATE(6774),
    [sym_range] = STATE(6774),
    [sym_binary] = STATE(6774),
    [sym_unary] = STATE(6774),
    [sym__arg_or_splat_arg] = STATE(8678),
    [sym_left_assignment_list] = STATE(1761),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1762),
    [sym__variable] = STATE(1758),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(1762),
    [sym_false] = STATE(1762),
    [sym_nil] = STATE(1762),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(4066),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__splat_star] = ACTIONS(6097),
    [sym__unary_minus] = ACTIONS(3179),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(3183),
    [anon_sym_yield] = ACTIONS(3185),
    [anon_sym_break] = ACTIONS(3187),
    [anon_sym_next] = ACTIONS(3189),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(6735),
    [anon_sym_defined_QMARK] = ACTIONS(3191),
    [anon_sym_not] = ACTIONS(3193),
    [anon_sym_BANG] = ACTIONS(3197),
    [anon_sym_TILDE] = ACTIONS(3197),
    [sym_constant] = ACTIONS(3203),
    [sym_identifier] = ACTIONS(3203),
    [sym_instance_variable] = ACTIONS(3201),
    [sym_class_variable] = ACTIONS(3201),
    [sym_global_variable] = ACTIONS(3201),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(3203),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(3203),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [8943] = {
    [aux_sym_exceptions_repeat1] = STATE(10214),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_LBRACE] = ACTIONS(9855),
    [anon_sym_RBRACE] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(13901),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9857),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_EQ] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_do] = ACTIONS(9855),
    [anon_sym_EQ_GT] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_PLUS_EQ] = ACTIONS(9855),
    [anon_sym_DASH_EQ] = ACTIONS(9855),
    [anon_sym_STAR_EQ] = ACTIONS(9855),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9855),
    [anon_sym_SLASH_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9855),
    [anon_sym_AMP_EQ] = ACTIONS(9855),
    [anon_sym_PERCENT_EQ] = ACTIONS(9855),
    [anon_sym_GT_GT_EQ] = ACTIONS(9855),
    [anon_sym_LT_LT_EQ] = ACTIONS(9855),
    [anon_sym_CARET_EQ] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9857),
    [anon_sym_AMP_AMP] = ACTIONS(9857),
    [anon_sym_LT_LT] = ACTIONS(9857),
    [anon_sym_GT_GT] = ACTIONS(9857),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9857),
    [anon_sym_PLUS] = ACTIONS(9857),
    [anon_sym_SLASH] = ACTIONS(9857),
    [anon_sym_PERCENT] = ACTIONS(9857),
    [sym_comment] = ACTIONS(87),
  },
  [8944] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(10297),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(10297),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(10297),
    [anon_sym_PERCENT] = ACTIONS(10297),
    [sym_comment] = ACTIONS(87),
  },
  [8945] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(10297),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [8946] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10295),
    [sym__binary_star] = ACTIONS(10297),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(10297),
    [anon_sym_AMP] = ACTIONS(10301),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(10313),
    [anon_sym_GT_GT] = ACTIONS(10313),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(10295),
    [anon_sym_SLASH] = ACTIONS(10297),
    [anon_sym_PERCENT] = ACTIONS(10297),
    [sym_comment] = ACTIONS(87),
  },
  [8947] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10295),
    [sym__binary_star] = ACTIONS(10297),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(10297),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(10313),
    [anon_sym_GT_GT] = ACTIONS(10313),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(10295),
    [anon_sym_SLASH] = ACTIONS(10297),
    [anon_sym_PERCENT] = ACTIONS(10297),
    [sym_comment] = ACTIONS(87),
  },
  [8948] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10295),
    [sym__binary_star] = ACTIONS(10297),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(10299),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(10297),
    [anon_sym_AMP] = ACTIONS(10301),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(10313),
    [anon_sym_GT_GT] = ACTIONS(10313),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(10319),
    [anon_sym_PLUS] = ACTIONS(10295),
    [anon_sym_SLASH] = ACTIONS(10297),
    [anon_sym_PERCENT] = ACTIONS(10297),
    [sym_comment] = ACTIONS(87),
  },
  [8949] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(13903),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [8950] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(10295),
    [sym__binary_star] = ACTIONS(10297),
    [anon_sym_RBRACE] = ACTIONS(5927),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(10299),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(10297),
    [anon_sym_AMP] = ACTIONS(10301),
    [anon_sym_LT] = ACTIONS(10303),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(10307),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10309),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(10311),
    [anon_sym_AMP_AMP] = ACTIONS(10311),
    [anon_sym_LT_LT] = ACTIONS(10313),
    [anon_sym_GT_GT] = ACTIONS(10313),
    [anon_sym_EQ_EQ] = ACTIONS(10315),
    [anon_sym_BANG_EQ] = ACTIONS(10311),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10311),
    [anon_sym_LT_EQ_GT] = ACTIONS(10311),
    [anon_sym_EQ_TILDE] = ACTIONS(10311),
    [anon_sym_BANG_TILDE] = ACTIONS(10311),
    [anon_sym_LT_EQ] = ACTIONS(10303),
    [anon_sym_GT] = ACTIONS(10303),
    [anon_sym_GT_EQ] = ACTIONS(10317),
    [anon_sym_CARET] = ACTIONS(10319),
    [anon_sym_PLUS] = ACTIONS(10295),
    [anon_sym_SLASH] = ACTIONS(10297),
    [anon_sym_PERCENT] = ACTIONS(10297),
    [sym_comment] = ACTIONS(87),
  },
  [8951] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10295),
    [sym__binary_star] = ACTIONS(10297),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(10299),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(10297),
    [anon_sym_AMP] = ACTIONS(10301),
    [anon_sym_LT] = ACTIONS(10303),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(10305),
    [anon_sym_DOT_DOT] = ACTIONS(10307),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10309),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(10311),
    [anon_sym_AMP_AMP] = ACTIONS(10311),
    [anon_sym_LT_LT] = ACTIONS(10313),
    [anon_sym_GT_GT] = ACTIONS(10313),
    [anon_sym_EQ_EQ] = ACTIONS(10315),
    [anon_sym_BANG_EQ] = ACTIONS(10311),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10311),
    [anon_sym_LT_EQ_GT] = ACTIONS(10311),
    [anon_sym_EQ_TILDE] = ACTIONS(10311),
    [anon_sym_BANG_TILDE] = ACTIONS(10311),
    [anon_sym_LT_EQ] = ACTIONS(10303),
    [anon_sym_GT] = ACTIONS(10303),
    [anon_sym_GT_EQ] = ACTIONS(10317),
    [anon_sym_CARET] = ACTIONS(10319),
    [anon_sym_PLUS] = ACTIONS(10295),
    [anon_sym_SLASH] = ACTIONS(10297),
    [anon_sym_PERCENT] = ACTIONS(10297),
    [sym_comment] = ACTIONS(87),
  },
  [8952] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10295),
    [sym__binary_star] = ACTIONS(10297),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(10299),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(10297),
    [anon_sym_AMP] = ACTIONS(10301),
    [anon_sym_LT] = ACTIONS(10303),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(10313),
    [anon_sym_GT_GT] = ACTIONS(10313),
    [anon_sym_EQ_EQ] = ACTIONS(10315),
    [anon_sym_BANG_EQ] = ACTIONS(10311),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10311),
    [anon_sym_LT_EQ_GT] = ACTIONS(10311),
    [anon_sym_EQ_TILDE] = ACTIONS(10311),
    [anon_sym_BANG_TILDE] = ACTIONS(10311),
    [anon_sym_LT_EQ] = ACTIONS(10303),
    [anon_sym_GT] = ACTIONS(10303),
    [anon_sym_GT_EQ] = ACTIONS(10317),
    [anon_sym_CARET] = ACTIONS(10319),
    [anon_sym_PLUS] = ACTIONS(10295),
    [anon_sym_SLASH] = ACTIONS(10297),
    [anon_sym_PERCENT] = ACTIONS(10297),
    [sym_comment] = ACTIONS(87),
  },
  [8953] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10295),
    [sym__binary_star] = ACTIONS(10297),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(10297),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(10295),
    [anon_sym_SLASH] = ACTIONS(10297),
    [anon_sym_PERCENT] = ACTIONS(10297),
    [sym_comment] = ACTIONS(87),
  },
  [8954] = {
    [aux_sym_exceptions_repeat1] = STATE(8954),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_RBRACE] = ACTIONS(11597),
    [anon_sym_COMMA] = ACTIONS(13905),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [8955] = {
    [aux_sym_exceptions_repeat1] = STATE(6792),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_RBRACE] = ACTIONS(6191),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [8956] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(10295),
    [sym__binary_star] = ACTIONS(10297),
    [anon_sym_RBRACE] = ACTIONS(6210),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(10299),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(10297),
    [anon_sym_AMP] = ACTIONS(10301),
    [anon_sym_LT] = ACTIONS(10303),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(10305),
    [anon_sym_DOT_DOT] = ACTIONS(10307),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10309),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(10311),
    [anon_sym_AMP_AMP] = ACTIONS(10311),
    [anon_sym_LT_LT] = ACTIONS(10313),
    [anon_sym_GT_GT] = ACTIONS(10313),
    [anon_sym_EQ_EQ] = ACTIONS(10315),
    [anon_sym_BANG_EQ] = ACTIONS(10311),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10311),
    [anon_sym_LT_EQ_GT] = ACTIONS(10311),
    [anon_sym_EQ_TILDE] = ACTIONS(10311),
    [anon_sym_BANG_TILDE] = ACTIONS(10311),
    [anon_sym_LT_EQ] = ACTIONS(10303),
    [anon_sym_GT] = ACTIONS(10303),
    [anon_sym_GT_EQ] = ACTIONS(10317),
    [anon_sym_CARET] = ACTIONS(10319),
    [anon_sym_PLUS] = ACTIONS(10295),
    [anon_sym_SLASH] = ACTIONS(10297),
    [anon_sym_PERCENT] = ACTIONS(10297),
    [sym_comment] = ACTIONS(87),
  },
  [8957] = {
    [sym__binary_minus] = ACTIONS(12555),
    [sym__binary_star] = ACTIONS(12555),
    [anon_sym_LBRACE] = ACTIONS(12555),
    [anon_sym_RBRACE] = ACTIONS(12555),
    [anon_sym_RPAREN] = ACTIONS(12555),
    [anon_sym_DOT] = ACTIONS(12557),
    [anon_sym_COMMA] = ACTIONS(12555),
    [anon_sym_PIPE] = ACTIONS(12557),
    [anon_sym_SEMI] = ACTIONS(12555),
    [anon_sym_STAR_STAR] = ACTIONS(12555),
    [anon_sym_AMP] = ACTIONS(12557),
    [anon_sym_LT] = ACTIONS(12557),
    [anon_sym_if] = ACTIONS(12555),
    [anon_sym_unless] = ACTIONS(12555),
    [anon_sym_while] = ACTIONS(12555),
    [anon_sym_until] = ACTIONS(12555),
    [anon_sym_rescue] = ACTIONS(12555),
    [anon_sym_do] = ACTIONS(12555),
    [anon_sym_EQ_GT] = ACTIONS(12555),
    [anon_sym_LBRACK] = ACTIONS(12555),
    [anon_sym_COLON_COLON2] = ACTIONS(12555),
    [anon_sym_AMP_DOT] = ACTIONS(12555),
    [anon_sym_QMARK] = ACTIONS(12555),
    [anon_sym_COLON2] = ACTIONS(12557),
    [anon_sym_DOT_DOT] = ACTIONS(12557),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12555),
    [anon_sym_and] = ACTIONS(12555),
    [anon_sym_or] = ACTIONS(12555),
    [anon_sym_PIPE_PIPE] = ACTIONS(12555),
    [anon_sym_AMP_AMP] = ACTIONS(12555),
    [anon_sym_LT_LT] = ACTIONS(12555),
    [anon_sym_GT_GT] = ACTIONS(12555),
    [anon_sym_EQ_EQ] = ACTIONS(12557),
    [anon_sym_BANG_EQ] = ACTIONS(12555),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12555),
    [anon_sym_LT_EQ_GT] = ACTIONS(12555),
    [anon_sym_EQ_TILDE] = ACTIONS(12555),
    [anon_sym_BANG_TILDE] = ACTIONS(12555),
    [anon_sym_LT_EQ] = ACTIONS(12557),
    [anon_sym_GT] = ACTIONS(12557),
    [anon_sym_GT_EQ] = ACTIONS(12555),
    [anon_sym_CARET] = ACTIONS(12555),
    [anon_sym_PLUS] = ACTIONS(12555),
    [anon_sym_SLASH] = ACTIONS(12555),
    [anon_sym_PERCENT] = ACTIONS(12555),
    [sym_comment] = ACTIONS(87),
  },
  [8958] = {
    [sym__binary_minus] = ACTIONS(12559),
    [sym__binary_star] = ACTIONS(12559),
    [anon_sym_LBRACE] = ACTIONS(12559),
    [anon_sym_RBRACE] = ACTIONS(12559),
    [anon_sym_RPAREN] = ACTIONS(12559),
    [anon_sym_DOT] = ACTIONS(12561),
    [anon_sym_COMMA] = ACTIONS(12559),
    [anon_sym_PIPE] = ACTIONS(12561),
    [anon_sym_SEMI] = ACTIONS(12559),
    [anon_sym_STAR_STAR] = ACTIONS(12559),
    [anon_sym_AMP] = ACTIONS(12561),
    [anon_sym_LT] = ACTIONS(12561),
    [anon_sym_if] = ACTIONS(12559),
    [anon_sym_unless] = ACTIONS(12559),
    [anon_sym_while] = ACTIONS(12559),
    [anon_sym_until] = ACTIONS(12559),
    [anon_sym_rescue] = ACTIONS(12559),
    [anon_sym_do] = ACTIONS(12559),
    [anon_sym_EQ_GT] = ACTIONS(12559),
    [anon_sym_LBRACK] = ACTIONS(12559),
    [anon_sym_COLON_COLON2] = ACTIONS(12559),
    [anon_sym_AMP_DOT] = ACTIONS(12559),
    [anon_sym_QMARK] = ACTIONS(12559),
    [anon_sym_COLON2] = ACTIONS(12561),
    [anon_sym_DOT_DOT] = ACTIONS(12561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12559),
    [anon_sym_and] = ACTIONS(12559),
    [anon_sym_or] = ACTIONS(12559),
    [anon_sym_PIPE_PIPE] = ACTIONS(12559),
    [anon_sym_AMP_AMP] = ACTIONS(12559),
    [anon_sym_LT_LT] = ACTIONS(12559),
    [anon_sym_GT_GT] = ACTIONS(12559),
    [anon_sym_EQ_EQ] = ACTIONS(12561),
    [anon_sym_BANG_EQ] = ACTIONS(12559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12559),
    [anon_sym_LT_EQ_GT] = ACTIONS(12559),
    [anon_sym_EQ_TILDE] = ACTIONS(12559),
    [anon_sym_BANG_TILDE] = ACTIONS(12559),
    [anon_sym_LT_EQ] = ACTIONS(12561),
    [anon_sym_GT] = ACTIONS(12561),
    [anon_sym_GT_EQ] = ACTIONS(12559),
    [anon_sym_CARET] = ACTIONS(12559),
    [anon_sym_PLUS] = ACTIONS(12559),
    [anon_sym_SLASH] = ACTIONS(12559),
    [anon_sym_PERCENT] = ACTIONS(12559),
    [sym_comment] = ACTIONS(87),
  },
  [8959] = {
    [sym__binary_minus] = ACTIONS(12663),
    [sym__binary_star] = ACTIONS(12663),
    [anon_sym_LBRACE] = ACTIONS(12663),
    [anon_sym_RBRACE] = ACTIONS(12663),
    [anon_sym_RPAREN] = ACTIONS(12663),
    [anon_sym_DOT] = ACTIONS(12665),
    [anon_sym_COMMA] = ACTIONS(12663),
    [anon_sym_PIPE] = ACTIONS(12665),
    [anon_sym_SEMI] = ACTIONS(12663),
    [anon_sym_STAR_STAR] = ACTIONS(12663),
    [anon_sym_AMP] = ACTIONS(12665),
    [anon_sym_LT] = ACTIONS(12665),
    [anon_sym_if] = ACTIONS(12663),
    [anon_sym_unless] = ACTIONS(12663),
    [anon_sym_while] = ACTIONS(12663),
    [anon_sym_until] = ACTIONS(12663),
    [anon_sym_rescue] = ACTIONS(12663),
    [anon_sym_do] = ACTIONS(12663),
    [anon_sym_EQ_GT] = ACTIONS(12663),
    [anon_sym_LBRACK] = ACTIONS(12663),
    [anon_sym_COLON_COLON2] = ACTIONS(12663),
    [anon_sym_AMP_DOT] = ACTIONS(12663),
    [anon_sym_QMARK] = ACTIONS(12663),
    [anon_sym_COLON2] = ACTIONS(12665),
    [anon_sym_DOT_DOT] = ACTIONS(12665),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12663),
    [anon_sym_and] = ACTIONS(12663),
    [anon_sym_or] = ACTIONS(12663),
    [anon_sym_PIPE_PIPE] = ACTIONS(12663),
    [anon_sym_AMP_AMP] = ACTIONS(12663),
    [anon_sym_LT_LT] = ACTIONS(12663),
    [anon_sym_GT_GT] = ACTIONS(12663),
    [anon_sym_EQ_EQ] = ACTIONS(12665),
    [anon_sym_BANG_EQ] = ACTIONS(12663),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12663),
    [anon_sym_LT_EQ_GT] = ACTIONS(12663),
    [anon_sym_EQ_TILDE] = ACTIONS(12663),
    [anon_sym_BANG_TILDE] = ACTIONS(12663),
    [anon_sym_LT_EQ] = ACTIONS(12665),
    [anon_sym_GT] = ACTIONS(12665),
    [anon_sym_GT_EQ] = ACTIONS(12663),
    [anon_sym_CARET] = ACTIONS(12663),
    [anon_sym_PLUS] = ACTIONS(12663),
    [anon_sym_SLASH] = ACTIONS(12663),
    [anon_sym_PERCENT] = ACTIONS(12663),
    [sym_comment] = ACTIONS(87),
  },
  [8960] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(10345),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(10345),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(10345),
    [anon_sym_PERCENT] = ACTIONS(10345),
    [sym_comment] = ACTIONS(87),
  },
  [8961] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(10345),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [8962] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10343),
    [sym__binary_star] = ACTIONS(10345),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(10345),
    [anon_sym_AMP] = ACTIONS(10349),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(10361),
    [anon_sym_GT_GT] = ACTIONS(10361),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(10343),
    [anon_sym_SLASH] = ACTIONS(10345),
    [anon_sym_PERCENT] = ACTIONS(10345),
    [sym_comment] = ACTIONS(87),
  },
  [8963] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10343),
    [sym__binary_star] = ACTIONS(10345),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(10345),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(10361),
    [anon_sym_GT_GT] = ACTIONS(10361),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(10343),
    [anon_sym_SLASH] = ACTIONS(10345),
    [anon_sym_PERCENT] = ACTIONS(10345),
    [sym_comment] = ACTIONS(87),
  },
  [8964] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10343),
    [sym__binary_star] = ACTIONS(10345),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(10347),
    [anon_sym_STAR_STAR] = ACTIONS(10345),
    [anon_sym_AMP] = ACTIONS(10349),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(10361),
    [anon_sym_GT_GT] = ACTIONS(10361),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(10367),
    [anon_sym_PLUS] = ACTIONS(10343),
    [anon_sym_SLASH] = ACTIONS(10345),
    [anon_sym_PERCENT] = ACTIONS(10345),
    [sym_comment] = ACTIONS(87),
  },
  [8965] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(13908),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [8966] = {
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(10343),
    [sym__binary_star] = ACTIONS(10345),
    [anon_sym_RBRACE] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(10347),
    [anon_sym_STAR_STAR] = ACTIONS(10345),
    [anon_sym_AMP] = ACTIONS(10349),
    [anon_sym_LT] = ACTIONS(10351),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(10355),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10357),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(10359),
    [anon_sym_AMP_AMP] = ACTIONS(10359),
    [anon_sym_LT_LT] = ACTIONS(10361),
    [anon_sym_GT_GT] = ACTIONS(10361),
    [anon_sym_EQ_EQ] = ACTIONS(10363),
    [anon_sym_BANG_EQ] = ACTIONS(10359),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10359),
    [anon_sym_LT_EQ_GT] = ACTIONS(10359),
    [anon_sym_EQ_TILDE] = ACTIONS(10359),
    [anon_sym_BANG_TILDE] = ACTIONS(10359),
    [anon_sym_LT_EQ] = ACTIONS(10351),
    [anon_sym_GT] = ACTIONS(10351),
    [anon_sym_GT_EQ] = ACTIONS(10365),
    [anon_sym_CARET] = ACTIONS(10367),
    [anon_sym_PLUS] = ACTIONS(10343),
    [anon_sym_SLASH] = ACTIONS(10345),
    [anon_sym_PERCENT] = ACTIONS(10345),
    [sym_comment] = ACTIONS(87),
  },
  [8967] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10343),
    [sym__binary_star] = ACTIONS(10345),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(10347),
    [anon_sym_STAR_STAR] = ACTIONS(10345),
    [anon_sym_AMP] = ACTIONS(10349),
    [anon_sym_LT] = ACTIONS(10351),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(10353),
    [anon_sym_DOT_DOT] = ACTIONS(10355),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10357),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(10359),
    [anon_sym_AMP_AMP] = ACTIONS(10359),
    [anon_sym_LT_LT] = ACTIONS(10361),
    [anon_sym_GT_GT] = ACTIONS(10361),
    [anon_sym_EQ_EQ] = ACTIONS(10363),
    [anon_sym_BANG_EQ] = ACTIONS(10359),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10359),
    [anon_sym_LT_EQ_GT] = ACTIONS(10359),
    [anon_sym_EQ_TILDE] = ACTIONS(10359),
    [anon_sym_BANG_TILDE] = ACTIONS(10359),
    [anon_sym_LT_EQ] = ACTIONS(10351),
    [anon_sym_GT] = ACTIONS(10351),
    [anon_sym_GT_EQ] = ACTIONS(10365),
    [anon_sym_CARET] = ACTIONS(10367),
    [anon_sym_PLUS] = ACTIONS(10343),
    [anon_sym_SLASH] = ACTIONS(10345),
    [anon_sym_PERCENT] = ACTIONS(10345),
    [sym_comment] = ACTIONS(87),
  },
  [8968] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10343),
    [sym__binary_star] = ACTIONS(10345),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(10347),
    [anon_sym_STAR_STAR] = ACTIONS(10345),
    [anon_sym_AMP] = ACTIONS(10349),
    [anon_sym_LT] = ACTIONS(10351),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(10361),
    [anon_sym_GT_GT] = ACTIONS(10361),
    [anon_sym_EQ_EQ] = ACTIONS(10363),
    [anon_sym_BANG_EQ] = ACTIONS(10359),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10359),
    [anon_sym_LT_EQ_GT] = ACTIONS(10359),
    [anon_sym_EQ_TILDE] = ACTIONS(10359),
    [anon_sym_BANG_TILDE] = ACTIONS(10359),
    [anon_sym_LT_EQ] = ACTIONS(10351),
    [anon_sym_GT] = ACTIONS(10351),
    [anon_sym_GT_EQ] = ACTIONS(10365),
    [anon_sym_CARET] = ACTIONS(10367),
    [anon_sym_PLUS] = ACTIONS(10343),
    [anon_sym_SLASH] = ACTIONS(10345),
    [anon_sym_PERCENT] = ACTIONS(10345),
    [sym_comment] = ACTIONS(87),
  },
  [8969] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10343),
    [sym__binary_star] = ACTIONS(10345),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(10345),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(10343),
    [anon_sym_SLASH] = ACTIONS(10345),
    [anon_sym_PERCENT] = ACTIONS(10345),
    [sym_comment] = ACTIONS(87),
  },
  [8970] = {
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(10343),
    [sym__binary_star] = ACTIONS(10345),
    [anon_sym_RBRACE] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(10347),
    [anon_sym_STAR_STAR] = ACTIONS(10345),
    [anon_sym_AMP] = ACTIONS(10349),
    [anon_sym_LT] = ACTIONS(10351),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(10353),
    [anon_sym_DOT_DOT] = ACTIONS(10355),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10357),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(10359),
    [anon_sym_AMP_AMP] = ACTIONS(10359),
    [anon_sym_LT_LT] = ACTIONS(10361),
    [anon_sym_GT_GT] = ACTIONS(10361),
    [anon_sym_EQ_EQ] = ACTIONS(10363),
    [anon_sym_BANG_EQ] = ACTIONS(10359),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10359),
    [anon_sym_LT_EQ_GT] = ACTIONS(10359),
    [anon_sym_EQ_TILDE] = ACTIONS(10359),
    [anon_sym_BANG_TILDE] = ACTIONS(10359),
    [anon_sym_LT_EQ] = ACTIONS(10351),
    [anon_sym_GT] = ACTIONS(10351),
    [anon_sym_GT_EQ] = ACTIONS(10365),
    [anon_sym_CARET] = ACTIONS(10367),
    [anon_sym_PLUS] = ACTIONS(10343),
    [anon_sym_SLASH] = ACTIONS(10345),
    [anon_sym_PERCENT] = ACTIONS(10345),
    [sym_comment] = ACTIONS(87),
  },
  [8971] = {
    [aux_sym_exceptions_repeat1] = STATE(10218),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_RBRACE] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [8972] = {
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(10343),
    [sym__binary_star] = ACTIONS(10345),
    [anon_sym_RBRACE] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(10347),
    [anon_sym_STAR_STAR] = ACTIONS(10345),
    [anon_sym_AMP] = ACTIONS(10349),
    [anon_sym_LT] = ACTIONS(10351),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(10353),
    [anon_sym_DOT_DOT] = ACTIONS(10355),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10357),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(10359),
    [anon_sym_AMP_AMP] = ACTIONS(10359),
    [anon_sym_LT_LT] = ACTIONS(10361),
    [anon_sym_GT_GT] = ACTIONS(10361),
    [anon_sym_EQ_EQ] = ACTIONS(10363),
    [anon_sym_BANG_EQ] = ACTIONS(10359),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10359),
    [anon_sym_LT_EQ_GT] = ACTIONS(10359),
    [anon_sym_EQ_TILDE] = ACTIONS(10359),
    [anon_sym_BANG_TILDE] = ACTIONS(10359),
    [anon_sym_LT_EQ] = ACTIONS(10351),
    [anon_sym_GT] = ACTIONS(10351),
    [anon_sym_GT_EQ] = ACTIONS(10365),
    [anon_sym_CARET] = ACTIONS(10367),
    [anon_sym_PLUS] = ACTIONS(10343),
    [anon_sym_SLASH] = ACTIONS(10345),
    [anon_sym_PERCENT] = ACTIONS(10345),
    [sym_comment] = ACTIONS(87),
  },
  [8973] = {
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(6857),
    [sym__binary_star] = ACTIONS(6859),
    [anon_sym_RBRACE] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(6861),
    [anon_sym_STAR_STAR] = ACTIONS(6859),
    [anon_sym_AMP] = ACTIONS(6863),
    [anon_sym_LT] = ACTIONS(6865),
    [anon_sym_EQ_GT] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(6867),
    [anon_sym_DOT_DOT] = ACTIONS(6869),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6871),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(6873),
    [anon_sym_AMP_AMP] = ACTIONS(6873),
    [anon_sym_LT_LT] = ACTIONS(6875),
    [anon_sym_GT_GT] = ACTIONS(6875),
    [anon_sym_EQ_EQ] = ACTIONS(6877),
    [anon_sym_BANG_EQ] = ACTIONS(6873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6873),
    [anon_sym_LT_EQ_GT] = ACTIONS(6873),
    [anon_sym_EQ_TILDE] = ACTIONS(6873),
    [anon_sym_BANG_TILDE] = ACTIONS(6873),
    [anon_sym_LT_EQ] = ACTIONS(6865),
    [anon_sym_GT] = ACTIONS(6865),
    [anon_sym_GT_EQ] = ACTIONS(6879),
    [anon_sym_CARET] = ACTIONS(6881),
    [anon_sym_PLUS] = ACTIONS(6857),
    [anon_sym_SLASH] = ACTIONS(6859),
    [anon_sym_PERCENT] = ACTIONS(6859),
    [sym_comment] = ACTIONS(87),
  },
  [8974] = {
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(6857),
    [sym__binary_star] = ACTIONS(6859),
    [anon_sym_RBRACE] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(6861),
    [anon_sym_STAR_STAR] = ACTIONS(6859),
    [anon_sym_AMP] = ACTIONS(6863),
    [anon_sym_LT] = ACTIONS(6865),
    [anon_sym_EQ_GT] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(6867),
    [anon_sym_DOT_DOT] = ACTIONS(6869),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6871),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(6873),
    [anon_sym_AMP_AMP] = ACTIONS(6873),
    [anon_sym_LT_LT] = ACTIONS(6875),
    [anon_sym_GT_GT] = ACTIONS(6875),
    [anon_sym_EQ_EQ] = ACTIONS(6877),
    [anon_sym_BANG_EQ] = ACTIONS(6873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6873),
    [anon_sym_LT_EQ_GT] = ACTIONS(6873),
    [anon_sym_EQ_TILDE] = ACTIONS(6873),
    [anon_sym_BANG_TILDE] = ACTIONS(6873),
    [anon_sym_LT_EQ] = ACTIONS(6865),
    [anon_sym_GT] = ACTIONS(6865),
    [anon_sym_GT_EQ] = ACTIONS(6879),
    [anon_sym_CARET] = ACTIONS(6881),
    [anon_sym_PLUS] = ACTIONS(6857),
    [anon_sym_SLASH] = ACTIONS(6859),
    [anon_sym_PERCENT] = ACTIONS(6859),
    [sym_comment] = ACTIONS(87),
  },
  [8975] = {
    [sym_heredoc_body] = STATE(8975),
    [aux_sym_call_repeat1] = STATE(8975),
    [sym__heredoc_body_start] = ACTIONS(10455),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_RBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_EQ_GT] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [8976] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4130),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1814),
    [sym_scope_resolution] = STATE(1810),
    [sym_call] = STATE(1810),
    [sym_method_call] = STATE(1814),
    [sym__argument] = STATE(6908),
    [sym_splat_argument] = STATE(6908),
    [sym_hash_splat_argument] = STATE(6908),
    [sym_block_argument] = STATE(6908),
    [sym_assignment] = STATE(4130),
    [sym_operator_assignment] = STATE(4130),
    [sym_conditional] = STATE(4130),
    [sym_range] = STATE(4130),
    [sym_binary] = STATE(4130),
    [sym_unary] = STATE(4130),
    [sym_left_assignment_list] = STATE(1813),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1814),
    [sym__variable] = STATE(1810),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1814),
    [sym_false] = STATE(1814),
    [sym_nil] = STATE(1814),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4133),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(6908),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(6847),
    [sym__splat_star] = ACTIONS(6849),
    [sym__unary_minus] = ACTIONS(3255),
    [sym__identifier_hash_key] = ACTIONS(6851),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12577),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_break] = ACTIONS(3263),
    [anon_sym_next] = ACTIONS(3265),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6843),
    [anon_sym_defined_QMARK] = ACTIONS(3267),
    [anon_sym_not] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3273),
    [anon_sym_TILDE] = ACTIONS(3273),
    [sym_constant] = ACTIONS(6853),
    [sym_identifier] = ACTIONS(6853),
    [sym_instance_variable] = ACTIONS(3277),
    [sym_class_variable] = ACTIONS(3277),
    [sym_global_variable] = ACTIONS(3277),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3279),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3279),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8977] = {
    [sym_heredoc_body] = STATE(8975),
    [aux_sym_call_repeat1] = STATE(8975),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_RBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_EQ_GT] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [8978] = {
    [aux_sym_argument_list_repeat1] = STATE(8978),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_RBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(13910),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_STAR_STAR] = ACTIONS(7925),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_EQ_GT] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7925),
    [anon_sym_AMP_AMP] = ACTIONS(7925),
    [anon_sym_LT_LT] = ACTIONS(7925),
    [anon_sym_GT_GT] = ACTIONS(7925),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7925),
    [anon_sym_PLUS] = ACTIONS(7925),
    [anon_sym_SLASH] = ACTIONS(7925),
    [anon_sym_PERCENT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [8979] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(10219),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1814),
    [sym_scope_resolution] = STATE(1810),
    [sym_call] = STATE(1810),
    [sym_method_call] = STATE(1814),
    [sym_assignment] = STATE(10219),
    [sym_operator_assignment] = STATE(10219),
    [sym_conditional] = STATE(10219),
    [sym_range] = STATE(10219),
    [sym_binary] = STATE(10219),
    [sym_unary] = STATE(10219),
    [sym_left_assignment_list] = STATE(1813),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1814),
    [sym__variable] = STATE(1810),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1814),
    [sym_false] = STATE(1814),
    [sym_nil] = STATE(1814),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4122),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_break] = ACTIONS(3263),
    [anon_sym_next] = ACTIONS(3265),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6843),
    [anon_sym_defined_QMARK] = ACTIONS(3267),
    [anon_sym_not] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3273),
    [anon_sym_TILDE] = ACTIONS(3273),
    [sym_constant] = ACTIONS(3279),
    [sym_identifier] = ACTIONS(3279),
    [sym_instance_variable] = ACTIONS(3277),
    [sym_class_variable] = ACTIONS(3277),
    [sym_global_variable] = ACTIONS(3277),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3279),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3279),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8980] = {
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(6947),
    [sym__binary_star] = ACTIONS(6949),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_RBRACE] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(6951),
    [anon_sym_STAR_STAR] = ACTIONS(6953),
    [anon_sym_AMP] = ACTIONS(6955),
    [anon_sym_EQ] = ACTIONS(7822),
    [anon_sym_LT] = ACTIONS(6957),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_EQ_GT] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_PLUS_EQ] = ACTIONS(6823),
    [anon_sym_DASH_EQ] = ACTIONS(6823),
    [anon_sym_STAR_EQ] = ACTIONS(6823),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6823),
    [anon_sym_SLASH_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6823),
    [anon_sym_AMP_EQ] = ACTIONS(6823),
    [anon_sym_PERCENT_EQ] = ACTIONS(6823),
    [anon_sym_GT_GT_EQ] = ACTIONS(6823),
    [anon_sym_LT_LT_EQ] = ACTIONS(6823),
    [anon_sym_CARET_EQ] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(6959),
    [anon_sym_DOT_DOT] = ACTIONS(6961),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6963),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(6965),
    [anon_sym_AMP_AMP] = ACTIONS(6965),
    [anon_sym_LT_LT] = ACTIONS(6967),
    [anon_sym_GT_GT] = ACTIONS(6967),
    [anon_sym_EQ_EQ] = ACTIONS(6965),
    [anon_sym_BANG_EQ] = ACTIONS(6969),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6969),
    [anon_sym_LT_EQ_GT] = ACTIONS(6969),
    [anon_sym_EQ_TILDE] = ACTIONS(6969),
    [anon_sym_BANG_TILDE] = ACTIONS(6969),
    [anon_sym_LT_EQ] = ACTIONS(6957),
    [anon_sym_GT] = ACTIONS(6957),
    [anon_sym_GT_EQ] = ACTIONS(6971),
    [anon_sym_CARET] = ACTIONS(6951),
    [anon_sym_PLUS] = ACTIONS(6973),
    [anon_sym_SLASH] = ACTIONS(6953),
    [anon_sym_PERCENT] = ACTIONS(6953),
    [sym_comment] = ACTIONS(87),
  },
  [8981] = {
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(6947),
    [sym__binary_star] = ACTIONS(6949),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_RBRACE] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(6951),
    [anon_sym_STAR_STAR] = ACTIONS(6953),
    [anon_sym_AMP] = ACTIONS(6955),
    [anon_sym_EQ] = ACTIONS(7884),
    [anon_sym_LT] = ACTIONS(6957),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_EQ_GT] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_PLUS_EQ] = ACTIONS(7027),
    [anon_sym_DASH_EQ] = ACTIONS(7027),
    [anon_sym_STAR_EQ] = ACTIONS(7027),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7027),
    [anon_sym_SLASH_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7027),
    [anon_sym_AMP_EQ] = ACTIONS(7027),
    [anon_sym_PERCENT_EQ] = ACTIONS(7027),
    [anon_sym_GT_GT_EQ] = ACTIONS(7027),
    [anon_sym_LT_LT_EQ] = ACTIONS(7027),
    [anon_sym_CARET_EQ] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(6959),
    [anon_sym_DOT_DOT] = ACTIONS(6961),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6963),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(6965),
    [anon_sym_AMP_AMP] = ACTIONS(6965),
    [anon_sym_LT_LT] = ACTIONS(6967),
    [anon_sym_GT_GT] = ACTIONS(6967),
    [anon_sym_EQ_EQ] = ACTIONS(6965),
    [anon_sym_BANG_EQ] = ACTIONS(6969),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6969),
    [anon_sym_LT_EQ_GT] = ACTIONS(6969),
    [anon_sym_EQ_TILDE] = ACTIONS(6969),
    [anon_sym_BANG_TILDE] = ACTIONS(6969),
    [anon_sym_LT_EQ] = ACTIONS(6957),
    [anon_sym_GT] = ACTIONS(6957),
    [anon_sym_GT_EQ] = ACTIONS(6971),
    [anon_sym_CARET] = ACTIONS(6951),
    [anon_sym_PLUS] = ACTIONS(6973),
    [anon_sym_SLASH] = ACTIONS(6953),
    [anon_sym_PERCENT] = ACTIONS(6953),
    [sym_comment] = ACTIONS(87),
  },
  [8982] = {
    [sym_heredoc_body] = STATE(8982),
    [aux_sym_call_repeat1] = STATE(8982),
    [sym__heredoc_body_start] = ACTIONS(10553),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_RBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_STAR_STAR] = ACTIONS(7919),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_EQ] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_EQ_GT] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_PLUS_EQ] = ACTIONS(7914),
    [anon_sym_DASH_EQ] = ACTIONS(7914),
    [anon_sym_STAR_EQ] = ACTIONS(7914),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7914),
    [anon_sym_SLASH_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7914),
    [anon_sym_AMP_EQ] = ACTIONS(7914),
    [anon_sym_PERCENT_EQ] = ACTIONS(7914),
    [anon_sym_GT_GT_EQ] = ACTIONS(7914),
    [anon_sym_LT_LT_EQ] = ACTIONS(7914),
    [anon_sym_CARET_EQ] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7919),
    [anon_sym_AMP_AMP] = ACTIONS(7919),
    [anon_sym_LT_LT] = ACTIONS(7919),
    [anon_sym_GT_GT] = ACTIONS(7919),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7919),
    [anon_sym_PLUS] = ACTIONS(7919),
    [anon_sym_SLASH] = ACTIONS(7919),
    [anon_sym_PERCENT] = ACTIONS(7919),
    [sym_comment] = ACTIONS(87),
  },
  [8983] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4151),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1851),
    [sym_scope_resolution] = STATE(1845),
    [sym_call] = STATE(1845),
    [sym_method_call] = STATE(1851),
    [sym__argument] = STATE(6970),
    [sym_splat_argument] = STATE(6970),
    [sym_hash_splat_argument] = STATE(6970),
    [sym_block_argument] = STATE(6970),
    [sym_assignment] = STATE(4151),
    [sym_operator_assignment] = STATE(4151),
    [sym_conditional] = STATE(4151),
    [sym_range] = STATE(4151),
    [sym_binary] = STATE(4151),
    [sym_unary] = STATE(4151),
    [sym_left_assignment_list] = STATE(1850),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1851),
    [sym__variable] = STATE(1845),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1851),
    [sym_false] = STATE(1851),
    [sym_nil] = STATE(1851),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4154),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(6970),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(6883),
    [sym__splat_star] = ACTIONS(6885),
    [sym__unary_minus] = ACTIONS(3323),
    [sym__identifier_hash_key] = ACTIONS(6887),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12581),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3329),
    [anon_sym_yield] = ACTIONS(3331),
    [anon_sym_break] = ACTIONS(3333),
    [anon_sym_next] = ACTIONS(3335),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6935),
    [anon_sym_defined_QMARK] = ACTIONS(3339),
    [anon_sym_not] = ACTIONS(3341),
    [anon_sym_BANG] = ACTIONS(3345),
    [anon_sym_TILDE] = ACTIONS(3345),
    [sym_constant] = ACTIONS(6889),
    [sym_identifier] = ACTIONS(6889),
    [sym_instance_variable] = ACTIONS(3349),
    [sym_class_variable] = ACTIONS(3349),
    [sym_global_variable] = ACTIONS(3349),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3351),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3351),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [8984] = {
    [sym_heredoc_body] = STATE(8982),
    [aux_sym_call_repeat1] = STATE(8982),
    [sym__heredoc_body_start] = ACTIONS(3543),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_RBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_STAR_STAR] = ACTIONS(7931),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_EQ] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_EQ_GT] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_PLUS_EQ] = ACTIONS(7929),
    [anon_sym_DASH_EQ] = ACTIONS(7929),
    [anon_sym_STAR_EQ] = ACTIONS(7929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7929),
    [anon_sym_SLASH_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7929),
    [anon_sym_AMP_EQ] = ACTIONS(7929),
    [anon_sym_PERCENT_EQ] = ACTIONS(7929),
    [anon_sym_GT_GT_EQ] = ACTIONS(7929),
    [anon_sym_LT_LT_EQ] = ACTIONS(7929),
    [anon_sym_CARET_EQ] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7931),
    [anon_sym_AMP_AMP] = ACTIONS(7931),
    [anon_sym_LT_LT] = ACTIONS(7931),
    [anon_sym_GT_GT] = ACTIONS(7931),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7931),
    [anon_sym_PLUS] = ACTIONS(7931),
    [anon_sym_SLASH] = ACTIONS(7931),
    [anon_sym_PERCENT] = ACTIONS(7931),
    [sym_comment] = ACTIONS(87),
  },
  [8985] = {
    [aux_sym_argument_list_repeat1] = STATE(8985),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_RBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(13913),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_STAR_STAR] = ACTIONS(7927),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_EQ] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_EQ_GT] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_PLUS_EQ] = ACTIONS(7925),
    [anon_sym_DASH_EQ] = ACTIONS(7925),
    [anon_sym_STAR_EQ] = ACTIONS(7925),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7925),
    [anon_sym_SLASH_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7925),
    [anon_sym_AMP_EQ] = ACTIONS(7925),
    [anon_sym_PERCENT_EQ] = ACTIONS(7925),
    [anon_sym_GT_GT_EQ] = ACTIONS(7925),
    [anon_sym_LT_LT_EQ] = ACTIONS(7925),
    [anon_sym_CARET_EQ] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7927),
    [anon_sym_AMP_AMP] = ACTIONS(7927),
    [anon_sym_LT_LT] = ACTIONS(7927),
    [anon_sym_GT_GT] = ACTIONS(7927),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7927),
    [anon_sym_PLUS] = ACTIONS(7927),
    [anon_sym_SLASH] = ACTIONS(7927),
    [anon_sym_PERCENT] = ACTIONS(7927),
    [sym_comment] = ACTIONS(87),
  },
  [8986] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(6848),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1814),
    [sym_scope_resolution] = STATE(1810),
    [sym_call] = STATE(1810),
    [sym_method_call] = STATE(1814),
    [sym_splat_argument] = STATE(9013),
    [sym_assignment] = STATE(6848),
    [sym_operator_assignment] = STATE(6848),
    [sym_conditional] = STATE(6848),
    [sym_range] = STATE(6848),
    [sym_binary] = STATE(6848),
    [sym_unary] = STATE(6848),
    [sym__arg_or_splat_arg] = STATE(9013),
    [sym_left_assignment_list] = STATE(1813),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1814),
    [sym__variable] = STATE(1810),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1814),
    [sym_false] = STATE(1814),
    [sym_nil] = STATE(1814),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4122),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(6849),
    [sym__unary_minus] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_break] = ACTIONS(3263),
    [anon_sym_next] = ACTIONS(3265),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6843),
    [anon_sym_defined_QMARK] = ACTIONS(3267),
    [anon_sym_not] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3273),
    [anon_sym_TILDE] = ACTIONS(3273),
    [sym_constant] = ACTIONS(3279),
    [sym_identifier] = ACTIONS(3279),
    [sym_instance_variable] = ACTIONS(3277),
    [sym_class_variable] = ACTIONS(3277),
    [sym_global_variable] = ACTIONS(3277),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3279),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3279),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8987] = {
    [aux_sym_exceptions_repeat1] = STATE(10220),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_RBRACE] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(13916),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_EQ_GT] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [8988] = {
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(3283),
    [sym__binary_star] = ACTIONS(3285),
    [anon_sym_RBRACE] = ACTIONS(12120),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(3287),
    [anon_sym_STAR_STAR] = ACTIONS(3285),
    [anon_sym_AMP] = ACTIONS(3289),
    [anon_sym_LT] = ACTIONS(3291),
    [anon_sym_QMARK] = ACTIONS(3293),
    [anon_sym_DOT_DOT] = ACTIONS(3295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3297),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(3301),
    [anon_sym_AMP_AMP] = ACTIONS(3301),
    [anon_sym_LT_LT] = ACTIONS(3303),
    [anon_sym_GT_GT] = ACTIONS(3303),
    [anon_sym_EQ_EQ] = ACTIONS(3305),
    [anon_sym_BANG_EQ] = ACTIONS(3301),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3301),
    [anon_sym_LT_EQ_GT] = ACTIONS(3301),
    [anon_sym_EQ_TILDE] = ACTIONS(3301),
    [anon_sym_BANG_TILDE] = ACTIONS(3301),
    [anon_sym_LT_EQ] = ACTIONS(3291),
    [anon_sym_GT] = ACTIONS(3291),
    [anon_sym_GT_EQ] = ACTIONS(3307),
    [anon_sym_CARET] = ACTIONS(3309),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_SLASH] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [sym_comment] = ACTIONS(87),
  },
  [8989] = {
    [sym__simple_symbol] = ACTIONS(7876),
    [sym__string_start] = ACTIONS(7876),
    [sym__symbol_start] = ACTIONS(7876),
    [sym__subshell_start] = ACTIONS(7876),
    [sym__regex_start] = ACTIONS(7876),
    [sym__string_array_start] = ACTIONS(7876),
    [sym__symbol_array_start] = ACTIONS(7876),
    [sym__heredoc_body_start] = ACTIONS(7876),
    [sym_heredoc_beginning] = ACTIONS(7876),
    [sym__block_ampersand] = ACTIONS(7876),
    [sym__splat_star] = ACTIONS(7876),
    [sym__unary_minus] = ACTIONS(7876),
    [sym__binary_minus] = ACTIONS(7876),
    [sym__binary_star] = ACTIONS(7876),
    [sym__identifier_hash_key] = ACTIONS(7876),
    [anon_sym_LBRACE] = ACTIONS(7876),
    [anon_sym_RBRACE] = ACTIONS(7876),
    [anon_sym_def] = ACTIONS(7878),
    [anon_sym_LPAREN] = ACTIONS(7878),
    [anon_sym_RPAREN] = ACTIONS(7876),
    [anon_sym_DOT] = ACTIONS(7878),
    [anon_sym_COLON_COLON] = ACTIONS(7878),
    [anon_sym_COMMA] = ACTIONS(7876),
    [anon_sym_PIPE] = ACTIONS(7878),
    [anon_sym_SEMI] = ACTIONS(7876),
    [anon_sym_STAR] = ACTIONS(7878),
    [anon_sym_STAR_STAR] = ACTIONS(7878),
    [anon_sym_AMP] = ACTIONS(7878),
    [anon_sym_EQ] = ACTIONS(7878),
    [anon_sym_class] = ACTIONS(7878),
    [anon_sym_LT] = ACTIONS(7878),
    [anon_sym_module] = ACTIONS(7878),
    [anon_sym_return] = ACTIONS(7878),
    [anon_sym_yield] = ACTIONS(7878),
    [anon_sym_break] = ACTIONS(7878),
    [anon_sym_next] = ACTIONS(7878),
    [sym_redo] = ACTIONS(7878),
    [sym_retry] = ACTIONS(7878),
    [anon_sym_if] = ACTIONS(7878),
    [anon_sym_unless] = ACTIONS(7878),
    [anon_sym_while] = ACTIONS(7878),
    [anon_sym_until] = ACTIONS(7878),
    [anon_sym_rescue] = ACTIONS(7878),
    [anon_sym_for] = ACTIONS(7878),
    [anon_sym_in] = ACTIONS(7878),
    [anon_sym_do] = ACTIONS(7878),
    [anon_sym_case] = ACTIONS(7878),
    [anon_sym_begin] = ACTIONS(7878),
    [anon_sym_LBRACK] = ACTIONS(7876),
    [anon_sym_RBRACK] = ACTIONS(7876),
    [anon_sym_COLON_COLON2] = ACTIONS(7876),
    [anon_sym_AMP_DOT] = ACTIONS(7876),
    [anon_sym_LPAREN2] = ACTIONS(7876),
    [anon_sym_PLUS_EQ] = ACTIONS(7876),
    [anon_sym_DASH_EQ] = ACTIONS(7876),
    [anon_sym_STAR_EQ] = ACTIONS(7876),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7876),
    [anon_sym_SLASH_EQ] = ACTIONS(7876),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7876),
    [anon_sym_PIPE_EQ] = ACTIONS(7876),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7876),
    [anon_sym_AMP_EQ] = ACTIONS(7876),
    [anon_sym_PERCENT_EQ] = ACTIONS(7876),
    [anon_sym_GT_GT_EQ] = ACTIONS(7876),
    [anon_sym_LT_LT_EQ] = ACTIONS(7876),
    [anon_sym_CARET_EQ] = ACTIONS(7876),
    [anon_sym_QMARK] = ACTIONS(7878),
    [anon_sym_COLON2] = ACTIONS(7878),
    [anon_sym_DOT_DOT] = ACTIONS(7878),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7876),
    [anon_sym_and] = ACTIONS(7878),
    [anon_sym_or] = ACTIONS(7878),
    [anon_sym_PIPE_PIPE] = ACTIONS(7878),
    [anon_sym_AMP_AMP] = ACTIONS(7878),
    [anon_sym_LT_LT] = ACTIONS(7878),
    [anon_sym_GT_GT] = ACTIONS(7878),
    [anon_sym_EQ_EQ] = ACTIONS(7878),
    [anon_sym_BANG_EQ] = ACTIONS(7876),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7876),
    [anon_sym_LT_EQ_GT] = ACTIONS(7876),
    [anon_sym_EQ_TILDE] = ACTIONS(7876),
    [anon_sym_BANG_TILDE] = ACTIONS(7876),
    [anon_sym_LT_EQ] = ACTIONS(7878),
    [anon_sym_GT] = ACTIONS(7878),
    [anon_sym_GT_EQ] = ACTIONS(7876),
    [anon_sym_CARET] = ACTIONS(7878),
    [anon_sym_PLUS] = ACTIONS(7878),
    [anon_sym_SLASH] = ACTIONS(7878),
    [anon_sym_PERCENT] = ACTIONS(7878),
    [anon_sym_defined_QMARK] = ACTIONS(7876),
    [anon_sym_not] = ACTIONS(7878),
    [anon_sym_BANG] = ACTIONS(7878),
    [anon_sym_TILDE] = ACTIONS(7876),
    [sym_constant] = ACTIONS(7878),
    [sym_identifier] = ACTIONS(7878),
    [sym_instance_variable] = ACTIONS(7876),
    [sym_class_variable] = ACTIONS(7876),
    [sym_global_variable] = ACTIONS(7876),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(7878),
    [sym_float] = ACTIONS(7878),
    [sym_complex] = ACTIONS(7876),
    [sym_super] = ACTIONS(7878),
    [anon_sym_true] = ACTIONS(7878),
    [anon_sym_TRUE] = ACTIONS(7878),
    [anon_sym_false] = ACTIONS(7878),
    [anon_sym_FALSE] = ACTIONS(7878),
    [sym_self] = ACTIONS(7878),
    [anon_sym_nil] = ACTIONS(7878),
    [anon_sym_NIL] = ACTIONS(7878),
    [sym_character] = ACTIONS(7876),
    [anon_sym_LBRACK2] = ACTIONS(7878),
    [anon_sym_DASH_GT] = ACTIONS(7876),
  },
  [8990] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(10403),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(10407),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(10407),
    [anon_sym_PERCENT] = ACTIONS(10407),
    [sym_comment] = ACTIONS(87),
  },
  [8991] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(10407),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(5827),
    [anon_sym_PERCENT] = ACTIONS(5827),
    [sym_comment] = ACTIONS(87),
  },
  [8992] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10401),
    [sym__binary_star] = ACTIONS(10403),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(10407),
    [anon_sym_AMP] = ACTIONS(10409),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(10421),
    [anon_sym_GT_GT] = ACTIONS(10421),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(10427),
    [anon_sym_SLASH] = ACTIONS(10407),
    [anon_sym_PERCENT] = ACTIONS(10407),
    [sym_comment] = ACTIONS(87),
  },
  [8993] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10401),
    [sym__binary_star] = ACTIONS(10403),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(10407),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(10421),
    [anon_sym_GT_GT] = ACTIONS(10421),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(10427),
    [anon_sym_SLASH] = ACTIONS(10407),
    [anon_sym_PERCENT] = ACTIONS(10407),
    [sym_comment] = ACTIONS(87),
  },
  [8994] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10401),
    [sym__binary_star] = ACTIONS(10403),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(10405),
    [anon_sym_STAR_STAR] = ACTIONS(10407),
    [anon_sym_AMP] = ACTIONS(10409),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(10421),
    [anon_sym_GT_GT] = ACTIONS(10421),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(10405),
    [anon_sym_PLUS] = ACTIONS(10427),
    [anon_sym_SLASH] = ACTIONS(10407),
    [anon_sym_PERCENT] = ACTIONS(10407),
    [sym_comment] = ACTIONS(87),
  },
  [8995] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(13918),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [8996] = {
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(10401),
    [sym__binary_star] = ACTIONS(10403),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_RBRACE] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(10405),
    [anon_sym_STAR_STAR] = ACTIONS(10407),
    [anon_sym_AMP] = ACTIONS(10409),
    [anon_sym_EQ] = ACTIONS(7888),
    [anon_sym_LT] = ACTIONS(10411),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_PLUS_EQ] = ACTIONS(5927),
    [anon_sym_DASH_EQ] = ACTIONS(5927),
    [anon_sym_STAR_EQ] = ACTIONS(5927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5927),
    [anon_sym_SLASH_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5927),
    [anon_sym_AMP_EQ] = ACTIONS(5927),
    [anon_sym_PERCENT_EQ] = ACTIONS(5927),
    [anon_sym_GT_GT_EQ] = ACTIONS(5927),
    [anon_sym_LT_LT_EQ] = ACTIONS(5927),
    [anon_sym_CARET_EQ] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(10415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10417),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(10419),
    [anon_sym_AMP_AMP] = ACTIONS(10419),
    [anon_sym_LT_LT] = ACTIONS(10421),
    [anon_sym_GT_GT] = ACTIONS(10421),
    [anon_sym_EQ_EQ] = ACTIONS(10419),
    [anon_sym_BANG_EQ] = ACTIONS(10423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10423),
    [anon_sym_LT_EQ_GT] = ACTIONS(10423),
    [anon_sym_EQ_TILDE] = ACTIONS(10423),
    [anon_sym_BANG_TILDE] = ACTIONS(10423),
    [anon_sym_LT_EQ] = ACTIONS(10411),
    [anon_sym_GT] = ACTIONS(10411),
    [anon_sym_GT_EQ] = ACTIONS(10425),
    [anon_sym_CARET] = ACTIONS(10405),
    [anon_sym_PLUS] = ACTIONS(10427),
    [anon_sym_SLASH] = ACTIONS(10407),
    [anon_sym_PERCENT] = ACTIONS(10407),
    [sym_comment] = ACTIONS(87),
  },
  [8997] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10401),
    [sym__binary_star] = ACTIONS(10403),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(10405),
    [anon_sym_STAR_STAR] = ACTIONS(10407),
    [anon_sym_AMP] = ACTIONS(10409),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(10411),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(10413),
    [anon_sym_DOT_DOT] = ACTIONS(10415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10417),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(10419),
    [anon_sym_AMP_AMP] = ACTIONS(10419),
    [anon_sym_LT_LT] = ACTIONS(10421),
    [anon_sym_GT_GT] = ACTIONS(10421),
    [anon_sym_EQ_EQ] = ACTIONS(10419),
    [anon_sym_BANG_EQ] = ACTIONS(10423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10423),
    [anon_sym_LT_EQ_GT] = ACTIONS(10423),
    [anon_sym_EQ_TILDE] = ACTIONS(10423),
    [anon_sym_BANG_TILDE] = ACTIONS(10423),
    [anon_sym_LT_EQ] = ACTIONS(10411),
    [anon_sym_GT] = ACTIONS(10411),
    [anon_sym_GT_EQ] = ACTIONS(10425),
    [anon_sym_CARET] = ACTIONS(10405),
    [anon_sym_PLUS] = ACTIONS(10427),
    [anon_sym_SLASH] = ACTIONS(10407),
    [anon_sym_PERCENT] = ACTIONS(10407),
    [sym_comment] = ACTIONS(87),
  },
  [8998] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10401),
    [sym__binary_star] = ACTIONS(10403),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(10405),
    [anon_sym_STAR_STAR] = ACTIONS(10407),
    [anon_sym_AMP] = ACTIONS(10409),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(10411),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(10421),
    [anon_sym_GT_GT] = ACTIONS(10421),
    [anon_sym_EQ_EQ] = ACTIONS(10419),
    [anon_sym_BANG_EQ] = ACTIONS(10423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10423),
    [anon_sym_LT_EQ_GT] = ACTIONS(10423),
    [anon_sym_EQ_TILDE] = ACTIONS(10423),
    [anon_sym_BANG_TILDE] = ACTIONS(10423),
    [anon_sym_LT_EQ] = ACTIONS(10411),
    [anon_sym_GT] = ACTIONS(10411),
    [anon_sym_GT_EQ] = ACTIONS(10425),
    [anon_sym_CARET] = ACTIONS(10405),
    [anon_sym_PLUS] = ACTIONS(10427),
    [anon_sym_SLASH] = ACTIONS(10407),
    [anon_sym_PERCENT] = ACTIONS(10407),
    [sym_comment] = ACTIONS(87),
  },
  [8999] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10401),
    [sym__binary_star] = ACTIONS(10403),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(10407),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(10427),
    [anon_sym_SLASH] = ACTIONS(10407),
    [anon_sym_PERCENT] = ACTIONS(10407),
    [sym_comment] = ACTIONS(87),
  },
  [9000] = {
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(10401),
    [sym__binary_star] = ACTIONS(10403),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_RBRACE] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(10405),
    [anon_sym_STAR_STAR] = ACTIONS(10407),
    [anon_sym_AMP] = ACTIONS(10409),
    [anon_sym_EQ] = ACTIONS(7936),
    [anon_sym_LT] = ACTIONS(10411),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_PLUS_EQ] = ACTIONS(5115),
    [anon_sym_DASH_EQ] = ACTIONS(5115),
    [anon_sym_STAR_EQ] = ACTIONS(5115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5115),
    [anon_sym_SLASH_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5115),
    [anon_sym_AMP_EQ] = ACTIONS(5115),
    [anon_sym_PERCENT_EQ] = ACTIONS(5115),
    [anon_sym_GT_GT_EQ] = ACTIONS(5115),
    [anon_sym_LT_LT_EQ] = ACTIONS(5115),
    [anon_sym_CARET_EQ] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(10413),
    [anon_sym_DOT_DOT] = ACTIONS(10415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10417),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(10419),
    [anon_sym_AMP_AMP] = ACTIONS(10419),
    [anon_sym_LT_LT] = ACTIONS(10421),
    [anon_sym_GT_GT] = ACTIONS(10421),
    [anon_sym_EQ_EQ] = ACTIONS(10419),
    [anon_sym_BANG_EQ] = ACTIONS(10423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10423),
    [anon_sym_LT_EQ_GT] = ACTIONS(10423),
    [anon_sym_EQ_TILDE] = ACTIONS(10423),
    [anon_sym_BANG_TILDE] = ACTIONS(10423),
    [anon_sym_LT_EQ] = ACTIONS(10411),
    [anon_sym_GT] = ACTIONS(10411),
    [anon_sym_GT_EQ] = ACTIONS(10425),
    [anon_sym_CARET] = ACTIONS(10405),
    [anon_sym_PLUS] = ACTIONS(10427),
    [anon_sym_SLASH] = ACTIONS(10407),
    [anon_sym_PERCENT] = ACTIONS(10407),
    [sym_comment] = ACTIONS(87),
  },
  [9001] = {
    [aux_sym_exceptions_repeat1] = STATE(10223),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_RBRACE] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_STAR_STAR] = ACTIONS(6193),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_PLUS_EQ] = ACTIONS(6191),
    [anon_sym_DASH_EQ] = ACTIONS(6191),
    [anon_sym_STAR_EQ] = ACTIONS(6191),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6191),
    [anon_sym_SLASH_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6191),
    [anon_sym_AMP_EQ] = ACTIONS(6191),
    [anon_sym_PERCENT_EQ] = ACTIONS(6191),
    [anon_sym_GT_GT_EQ] = ACTIONS(6191),
    [anon_sym_LT_LT_EQ] = ACTIONS(6191),
    [anon_sym_CARET_EQ] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6193),
    [anon_sym_AMP_AMP] = ACTIONS(6193),
    [anon_sym_LT_LT] = ACTIONS(6193),
    [anon_sym_GT_GT] = ACTIONS(6193),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6193),
    [anon_sym_PLUS] = ACTIONS(6193),
    [anon_sym_SLASH] = ACTIONS(6193),
    [anon_sym_PERCENT] = ACTIONS(6193),
    [sym_comment] = ACTIONS(87),
  },
  [9002] = {
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(10401),
    [sym__binary_star] = ACTIONS(10403),
    [anon_sym_LBRACE] = ACTIONS(6210),
    [anon_sym_RBRACE] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(10405),
    [anon_sym_STAR_STAR] = ACTIONS(10407),
    [anon_sym_AMP] = ACTIONS(10409),
    [anon_sym_EQ] = ACTIONS(7938),
    [anon_sym_LT] = ACTIONS(10411),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_PLUS_EQ] = ACTIONS(6210),
    [anon_sym_DASH_EQ] = ACTIONS(6210),
    [anon_sym_STAR_EQ] = ACTIONS(6210),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6210),
    [anon_sym_SLASH_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6210),
    [anon_sym_AMP_EQ] = ACTIONS(6210),
    [anon_sym_PERCENT_EQ] = ACTIONS(6210),
    [anon_sym_GT_GT_EQ] = ACTIONS(6210),
    [anon_sym_LT_LT_EQ] = ACTIONS(6210),
    [anon_sym_CARET_EQ] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(10413),
    [anon_sym_DOT_DOT] = ACTIONS(10415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10417),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(10419),
    [anon_sym_AMP_AMP] = ACTIONS(10419),
    [anon_sym_LT_LT] = ACTIONS(10421),
    [anon_sym_GT_GT] = ACTIONS(10421),
    [anon_sym_EQ_EQ] = ACTIONS(10419),
    [anon_sym_BANG_EQ] = ACTIONS(10423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10423),
    [anon_sym_LT_EQ_GT] = ACTIONS(10423),
    [anon_sym_EQ_TILDE] = ACTIONS(10423),
    [anon_sym_BANG_TILDE] = ACTIONS(10423),
    [anon_sym_LT_EQ] = ACTIONS(10411),
    [anon_sym_GT] = ACTIONS(10411),
    [anon_sym_GT_EQ] = ACTIONS(10425),
    [anon_sym_CARET] = ACTIONS(10405),
    [anon_sym_PLUS] = ACTIONS(10427),
    [anon_sym_SLASH] = ACTIONS(10407),
    [anon_sym_PERCENT] = ACTIONS(10407),
    [sym_comment] = ACTIONS(87),
  },
  [9003] = {
    [sym_string] = STATE(9003),
    [aux_sym_chained_string_repeat1] = STATE(9003),
    [sym__string_start] = ACTIONS(13881),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_RBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_STAR_STAR] = ACTIONS(6217),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_EQ] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_do] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_PLUS_EQ] = ACTIONS(6212),
    [anon_sym_DASH_EQ] = ACTIONS(6212),
    [anon_sym_STAR_EQ] = ACTIONS(6212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6212),
    [anon_sym_SLASH_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6212),
    [anon_sym_AMP_EQ] = ACTIONS(6212),
    [anon_sym_PERCENT_EQ] = ACTIONS(6212),
    [anon_sym_GT_GT_EQ] = ACTIONS(6212),
    [anon_sym_LT_LT_EQ] = ACTIONS(6212),
    [anon_sym_CARET_EQ] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6217),
    [anon_sym_AMP_AMP] = ACTIONS(6217),
    [anon_sym_LT_LT] = ACTIONS(6217),
    [anon_sym_GT_GT] = ACTIONS(6217),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6217),
    [anon_sym_PLUS] = ACTIONS(6217),
    [anon_sym_SLASH] = ACTIONS(6217),
    [anon_sym_PERCENT] = ACTIONS(6217),
    [sym_comment] = ACTIONS(87),
  },
  [9004] = {
    [sym__heredoc_body_start] = ACTIONS(12029),
    [sym__binary_minus] = ACTIONS(12029),
    [sym__binary_star] = ACTIONS(12029),
    [anon_sym_LBRACE] = ACTIONS(12029),
    [anon_sym_RBRACE] = ACTIONS(12029),
    [anon_sym_RPAREN] = ACTIONS(12029),
    [anon_sym_DOT] = ACTIONS(12031),
    [anon_sym_COMMA] = ACTIONS(12029),
    [anon_sym_PIPE] = ACTIONS(12031),
    [anon_sym_SEMI] = ACTIONS(12029),
    [anon_sym_STAR_STAR] = ACTIONS(12031),
    [anon_sym_AMP] = ACTIONS(12031),
    [anon_sym_EQ] = ACTIONS(12031),
    [anon_sym_LT] = ACTIONS(12031),
    [anon_sym_if] = ACTIONS(12029),
    [anon_sym_unless] = ACTIONS(12029),
    [anon_sym_while] = ACTIONS(12029),
    [anon_sym_until] = ACTIONS(12029),
    [anon_sym_rescue] = ACTIONS(12029),
    [anon_sym_in] = ACTIONS(12029),
    [anon_sym_do] = ACTIONS(12029),
    [anon_sym_LBRACK] = ACTIONS(12029),
    [anon_sym_RBRACK] = ACTIONS(12029),
    [anon_sym_COLON_COLON2] = ACTIONS(12029),
    [anon_sym_AMP_DOT] = ACTIONS(12029),
    [anon_sym_PLUS_EQ] = ACTIONS(12029),
    [anon_sym_DASH_EQ] = ACTIONS(12029),
    [anon_sym_STAR_EQ] = ACTIONS(12029),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12029),
    [anon_sym_SLASH_EQ] = ACTIONS(12029),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12029),
    [anon_sym_PIPE_EQ] = ACTIONS(12029),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12029),
    [anon_sym_AMP_EQ] = ACTIONS(12029),
    [anon_sym_PERCENT_EQ] = ACTIONS(12029),
    [anon_sym_GT_GT_EQ] = ACTIONS(12029),
    [anon_sym_LT_LT_EQ] = ACTIONS(12029),
    [anon_sym_CARET_EQ] = ACTIONS(12029),
    [anon_sym_QMARK] = ACTIONS(12029),
    [anon_sym_COLON2] = ACTIONS(12031),
    [anon_sym_DOT_DOT] = ACTIONS(12031),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12029),
    [anon_sym_and] = ACTIONS(12029),
    [anon_sym_or] = ACTIONS(12029),
    [anon_sym_PIPE_PIPE] = ACTIONS(12031),
    [anon_sym_AMP_AMP] = ACTIONS(12031),
    [anon_sym_LT_LT] = ACTIONS(12031),
    [anon_sym_GT_GT] = ACTIONS(12031),
    [anon_sym_EQ_EQ] = ACTIONS(12031),
    [anon_sym_BANG_EQ] = ACTIONS(12029),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12029),
    [anon_sym_LT_EQ_GT] = ACTIONS(12029),
    [anon_sym_EQ_TILDE] = ACTIONS(12029),
    [anon_sym_BANG_TILDE] = ACTIONS(12029),
    [anon_sym_LT_EQ] = ACTIONS(12031),
    [anon_sym_GT] = ACTIONS(12031),
    [anon_sym_GT_EQ] = ACTIONS(12029),
    [anon_sym_CARET] = ACTIONS(12031),
    [anon_sym_PLUS] = ACTIONS(12031),
    [anon_sym_SLASH] = ACTIONS(12031),
    [anon_sym_PERCENT] = ACTIONS(12031),
    [sym_comment] = ACTIONS(87),
  },
  [9005] = {
    [sym__heredoc_body_start] = ACTIONS(12054),
    [sym__binary_minus] = ACTIONS(12054),
    [sym__binary_star] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_RBRACE] = ACTIONS(12054),
    [anon_sym_RPAREN] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12056),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_PIPE] = ACTIONS(12056),
    [anon_sym_SEMI] = ACTIONS(12054),
    [anon_sym_STAR_STAR] = ACTIONS(12056),
    [anon_sym_AMP] = ACTIONS(12056),
    [anon_sym_EQ] = ACTIONS(12056),
    [anon_sym_LT] = ACTIONS(12056),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_unless] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [anon_sym_until] = ACTIONS(12054),
    [anon_sym_rescue] = ACTIONS(12054),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_do] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_RBRACK] = ACTIONS(12054),
    [anon_sym_COLON_COLON2] = ACTIONS(12054),
    [anon_sym_AMP_DOT] = ACTIONS(12054),
    [anon_sym_PLUS_EQ] = ACTIONS(12054),
    [anon_sym_DASH_EQ] = ACTIONS(12054),
    [anon_sym_STAR_EQ] = ACTIONS(12054),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12054),
    [anon_sym_SLASH_EQ] = ACTIONS(12054),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12054),
    [anon_sym_PIPE_EQ] = ACTIONS(12054),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12054),
    [anon_sym_AMP_EQ] = ACTIONS(12054),
    [anon_sym_PERCENT_EQ] = ACTIONS(12054),
    [anon_sym_GT_GT_EQ] = ACTIONS(12054),
    [anon_sym_LT_LT_EQ] = ACTIONS(12054),
    [anon_sym_CARET_EQ] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_COLON2] = ACTIONS(12056),
    [anon_sym_DOT_DOT] = ACTIONS(12056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_and] = ACTIONS(12054),
    [anon_sym_or] = ACTIONS(12054),
    [anon_sym_PIPE_PIPE] = ACTIONS(12056),
    [anon_sym_AMP_AMP] = ACTIONS(12056),
    [anon_sym_LT_LT] = ACTIONS(12056),
    [anon_sym_GT_GT] = ACTIONS(12056),
    [anon_sym_EQ_EQ] = ACTIONS(12056),
    [anon_sym_BANG_EQ] = ACTIONS(12054),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12054),
    [anon_sym_LT_EQ_GT] = ACTIONS(12054),
    [anon_sym_EQ_TILDE] = ACTIONS(12054),
    [anon_sym_BANG_TILDE] = ACTIONS(12054),
    [anon_sym_LT_EQ] = ACTIONS(12056),
    [anon_sym_GT] = ACTIONS(12056),
    [anon_sym_GT_EQ] = ACTIONS(12054),
    [anon_sym_CARET] = ACTIONS(12056),
    [anon_sym_PLUS] = ACTIONS(12056),
    [anon_sym_SLASH] = ACTIONS(12056),
    [anon_sym_PERCENT] = ACTIONS(12056),
    [sym_comment] = ACTIONS(87),
  },
  [9006] = {
    [anon_sym_end] = ACTIONS(13920),
    [sym_comment] = ACTIONS(87),
  },
  [9007] = {
    [sym__statements] = STATE(10225),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13922),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9008] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(10226),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1851),
    [sym_scope_resolution] = STATE(1845),
    [sym_call] = STATE(1845),
    [sym_method_call] = STATE(1851),
    [sym_assignment] = STATE(10226),
    [sym_operator_assignment] = STATE(10226),
    [sym_conditional] = STATE(10226),
    [sym_range] = STATE(10226),
    [sym_binary] = STATE(10226),
    [sym_unary] = STATE(10226),
    [sym_left_assignment_list] = STATE(1850),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1851),
    [sym__variable] = STATE(1845),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1851),
    [sym_false] = STATE(1851),
    [sym_nil] = STATE(1851),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4193),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3323),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3329),
    [anon_sym_yield] = ACTIONS(3331),
    [anon_sym_break] = ACTIONS(3333),
    [anon_sym_next] = ACTIONS(3335),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6935),
    [anon_sym_defined_QMARK] = ACTIONS(3339),
    [anon_sym_not] = ACTIONS(3341),
    [anon_sym_BANG] = ACTIONS(3345),
    [anon_sym_TILDE] = ACTIONS(3345),
    [sym_constant] = ACTIONS(3351),
    [sym_identifier] = ACTIONS(3351),
    [sym_instance_variable] = ACTIONS(3349),
    [sym_class_variable] = ACTIONS(3349),
    [sym_global_variable] = ACTIONS(3349),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3351),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3351),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [9009] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6895),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1851),
    [sym_scope_resolution] = STATE(1845),
    [sym_call] = STATE(1845),
    [sym_method_call] = STATE(1851),
    [sym_splat_argument] = STATE(9044),
    [sym_assignment] = STATE(6895),
    [sym_operator_assignment] = STATE(6895),
    [sym_conditional] = STATE(6895),
    [sym_range] = STATE(6895),
    [sym_binary] = STATE(6895),
    [sym_unary] = STATE(6895),
    [sym__arg_or_splat_arg] = STATE(9044),
    [sym_left_assignment_list] = STATE(1850),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1851),
    [sym__variable] = STATE(1845),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1851),
    [sym_false] = STATE(1851),
    [sym_nil] = STATE(1851),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4193),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__splat_star] = ACTIONS(6885),
    [sym__unary_minus] = ACTIONS(3323),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3329),
    [anon_sym_yield] = ACTIONS(3331),
    [anon_sym_break] = ACTIONS(3333),
    [anon_sym_next] = ACTIONS(3335),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6935),
    [anon_sym_defined_QMARK] = ACTIONS(3339),
    [anon_sym_not] = ACTIONS(3341),
    [anon_sym_BANG] = ACTIONS(3345),
    [anon_sym_TILDE] = ACTIONS(3345),
    [sym_constant] = ACTIONS(3351),
    [sym_identifier] = ACTIONS(3351),
    [sym_instance_variable] = ACTIONS(3349),
    [sym_class_variable] = ACTIONS(3349),
    [sym_global_variable] = ACTIONS(3349),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3351),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3351),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [9010] = {
    [aux_sym_exceptions_repeat1] = STATE(10227),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_LBRACE] = ACTIONS(9855),
    [anon_sym_RBRACE] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(13924),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_STAR_STAR] = ACTIONS(9857),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_EQ] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_do] = ACTIONS(9855),
    [anon_sym_EQ_GT] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_PLUS_EQ] = ACTIONS(9855),
    [anon_sym_DASH_EQ] = ACTIONS(9855),
    [anon_sym_STAR_EQ] = ACTIONS(9855),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9855),
    [anon_sym_SLASH_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9855),
    [anon_sym_AMP_EQ] = ACTIONS(9855),
    [anon_sym_PERCENT_EQ] = ACTIONS(9855),
    [anon_sym_GT_GT_EQ] = ACTIONS(9855),
    [anon_sym_LT_LT_EQ] = ACTIONS(9855),
    [anon_sym_CARET_EQ] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9857),
    [anon_sym_AMP_AMP] = ACTIONS(9857),
    [anon_sym_LT_LT] = ACTIONS(9857),
    [anon_sym_GT_GT] = ACTIONS(9857),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9857),
    [anon_sym_PLUS] = ACTIONS(9857),
    [anon_sym_SLASH] = ACTIONS(9857),
    [anon_sym_PERCENT] = ACTIONS(9857),
    [sym_comment] = ACTIONS(87),
  },
  [9011] = {
    [aux_sym_exceptions_repeat1] = STATE(9011),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_RBRACE] = ACTIONS(11597),
    [anon_sym_COMMA] = ACTIONS(13926),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [9012] = {
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(3371),
    [sym__binary_star] = ACTIONS(3373),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(3375),
    [anon_sym_STAR_STAR] = ACTIONS(3373),
    [anon_sym_AMP] = ACTIONS(3377),
    [anon_sym_LT] = ACTIONS(3379),
    [anon_sym_EQ_GT] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(3381),
    [anon_sym_DOT_DOT] = ACTIONS(3383),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3385),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(3387),
    [anon_sym_AMP_AMP] = ACTIONS(3387),
    [anon_sym_LT_LT] = ACTIONS(3389),
    [anon_sym_GT_GT] = ACTIONS(3389),
    [anon_sym_EQ_EQ] = ACTIONS(3391),
    [anon_sym_BANG_EQ] = ACTIONS(3387),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3387),
    [anon_sym_LT_EQ_GT] = ACTIONS(3387),
    [anon_sym_EQ_TILDE] = ACTIONS(3387),
    [anon_sym_BANG_TILDE] = ACTIONS(3387),
    [anon_sym_LT_EQ] = ACTIONS(3379),
    [anon_sym_GT] = ACTIONS(3379),
    [anon_sym_GT_EQ] = ACTIONS(3393),
    [anon_sym_CARET] = ACTIONS(3395),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_SLASH] = ACTIONS(3373),
    [anon_sym_PERCENT] = ACTIONS(3373),
    [sym_comment] = ACTIONS(87),
  },
  [9013] = {
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_RBRACE] = ACTIONS(11597),
    [anon_sym_RPAREN] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(11597),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_in] = ACTIONS(11597),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_RBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_COLON2] = ACTIONS(12338),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [9014] = {
    [aux_sym_exceptions_repeat1] = STATE(9014),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(13929),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [9015] = {
    [sym__binary_minus] = ACTIONS(13224),
    [sym__binary_star] = ACTIONS(13224),
    [anon_sym_LBRACE] = ACTIONS(13224),
    [anon_sym_RBRACE] = ACTIONS(13224),
    [anon_sym_RPAREN] = ACTIONS(13224),
    [anon_sym_DOT] = ACTIONS(13226),
    [anon_sym_COMMA] = ACTIONS(13224),
    [anon_sym_PIPE] = ACTIONS(13226),
    [anon_sym_SEMI] = ACTIONS(13224),
    [anon_sym_STAR_STAR] = ACTIONS(13224),
    [anon_sym_AMP] = ACTIONS(13226),
    [anon_sym_LT] = ACTIONS(13226),
    [anon_sym_if] = ACTIONS(13224),
    [anon_sym_unless] = ACTIONS(13224),
    [anon_sym_while] = ACTIONS(13224),
    [anon_sym_until] = ACTIONS(13224),
    [anon_sym_rescue] = ACTIONS(13224),
    [anon_sym_do] = ACTIONS(13224),
    [anon_sym_EQ_GT] = ACTIONS(13224),
    [anon_sym_LBRACK] = ACTIONS(13224),
    [anon_sym_COLON_COLON2] = ACTIONS(13224),
    [anon_sym_AMP_DOT] = ACTIONS(13224),
    [anon_sym_QMARK] = ACTIONS(13224),
    [anon_sym_COLON2] = ACTIONS(13226),
    [anon_sym_DOT_DOT] = ACTIONS(13226),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13224),
    [anon_sym_and] = ACTIONS(13224),
    [anon_sym_or] = ACTIONS(13224),
    [anon_sym_PIPE_PIPE] = ACTIONS(13224),
    [anon_sym_AMP_AMP] = ACTIONS(13224),
    [anon_sym_LT_LT] = ACTIONS(13224),
    [anon_sym_GT_GT] = ACTIONS(13224),
    [anon_sym_EQ_EQ] = ACTIONS(13226),
    [anon_sym_BANG_EQ] = ACTIONS(13224),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13224),
    [anon_sym_LT_EQ_GT] = ACTIONS(13224),
    [anon_sym_EQ_TILDE] = ACTIONS(13224),
    [anon_sym_BANG_TILDE] = ACTIONS(13224),
    [anon_sym_LT_EQ] = ACTIONS(13226),
    [anon_sym_GT] = ACTIONS(13226),
    [anon_sym_GT_EQ] = ACTIONS(13224),
    [anon_sym_CARET] = ACTIONS(13224),
    [anon_sym_PLUS] = ACTIONS(13224),
    [anon_sym_SLASH] = ACTIONS(13224),
    [anon_sym_PERCENT] = ACTIONS(13224),
    [sym_comment] = ACTIONS(87),
  },
  [9016] = {
    [sym__binary_minus] = ACTIONS(13235),
    [sym__binary_star] = ACTIONS(13235),
    [anon_sym_LBRACE] = ACTIONS(13235),
    [anon_sym_RBRACE] = ACTIONS(13235),
    [anon_sym_RPAREN] = ACTIONS(13235),
    [anon_sym_DOT] = ACTIONS(13237),
    [anon_sym_COMMA] = ACTIONS(13235),
    [anon_sym_PIPE] = ACTIONS(13237),
    [anon_sym_SEMI] = ACTIONS(13235),
    [anon_sym_STAR_STAR] = ACTIONS(13235),
    [anon_sym_AMP] = ACTIONS(13237),
    [anon_sym_LT] = ACTIONS(13237),
    [anon_sym_if] = ACTIONS(13235),
    [anon_sym_unless] = ACTIONS(13235),
    [anon_sym_while] = ACTIONS(13235),
    [anon_sym_until] = ACTIONS(13235),
    [anon_sym_rescue] = ACTIONS(13235),
    [anon_sym_do] = ACTIONS(13235),
    [anon_sym_EQ_GT] = ACTIONS(13235),
    [anon_sym_LBRACK] = ACTIONS(13235),
    [anon_sym_COLON_COLON2] = ACTIONS(13235),
    [anon_sym_AMP_DOT] = ACTIONS(13235),
    [anon_sym_QMARK] = ACTIONS(13235),
    [anon_sym_COLON2] = ACTIONS(13237),
    [anon_sym_DOT_DOT] = ACTIONS(13237),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13235),
    [anon_sym_and] = ACTIONS(13235),
    [anon_sym_or] = ACTIONS(13235),
    [anon_sym_PIPE_PIPE] = ACTIONS(13235),
    [anon_sym_AMP_AMP] = ACTIONS(13235),
    [anon_sym_LT_LT] = ACTIONS(13235),
    [anon_sym_GT_GT] = ACTIONS(13235),
    [anon_sym_EQ_EQ] = ACTIONS(13237),
    [anon_sym_BANG_EQ] = ACTIONS(13235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13235),
    [anon_sym_LT_EQ_GT] = ACTIONS(13235),
    [anon_sym_EQ_TILDE] = ACTIONS(13235),
    [anon_sym_BANG_TILDE] = ACTIONS(13235),
    [anon_sym_LT_EQ] = ACTIONS(13237),
    [anon_sym_GT] = ACTIONS(13237),
    [anon_sym_GT_EQ] = ACTIONS(13235),
    [anon_sym_CARET] = ACTIONS(13235),
    [anon_sym_PLUS] = ACTIONS(13235),
    [anon_sym_SLASH] = ACTIONS(13235),
    [anon_sym_PERCENT] = ACTIONS(13235),
    [sym_comment] = ACTIONS(87),
  },
  [9017] = {
    [anon_sym_end] = ACTIONS(13932),
    [sym_comment] = ACTIONS(87),
  },
  [9018] = {
    [sym__binary_minus] = ACTIONS(13547),
    [sym__binary_star] = ACTIONS(13547),
    [anon_sym_LBRACE] = ACTIONS(13547),
    [anon_sym_RBRACE] = ACTIONS(13547),
    [anon_sym_RPAREN] = ACTIONS(13547),
    [anon_sym_DOT] = ACTIONS(13549),
    [anon_sym_COMMA] = ACTIONS(13547),
    [anon_sym_PIPE] = ACTIONS(13549),
    [anon_sym_SEMI] = ACTIONS(13547),
    [anon_sym_STAR_STAR] = ACTIONS(13547),
    [anon_sym_AMP] = ACTIONS(13549),
    [anon_sym_LT] = ACTIONS(13549),
    [anon_sym_if] = ACTIONS(13547),
    [anon_sym_unless] = ACTIONS(13547),
    [anon_sym_while] = ACTIONS(13547),
    [anon_sym_until] = ACTIONS(13547),
    [anon_sym_rescue] = ACTIONS(13547),
    [anon_sym_do] = ACTIONS(13547),
    [anon_sym_EQ_GT] = ACTIONS(13547),
    [anon_sym_LBRACK] = ACTIONS(13547),
    [anon_sym_COLON_COLON2] = ACTIONS(13547),
    [anon_sym_AMP_DOT] = ACTIONS(13547),
    [anon_sym_QMARK] = ACTIONS(13547),
    [anon_sym_COLON2] = ACTIONS(13549),
    [anon_sym_DOT_DOT] = ACTIONS(13549),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13547),
    [anon_sym_and] = ACTIONS(13547),
    [anon_sym_or] = ACTIONS(13547),
    [anon_sym_PIPE_PIPE] = ACTIONS(13547),
    [anon_sym_AMP_AMP] = ACTIONS(13547),
    [anon_sym_LT_LT] = ACTIONS(13547),
    [anon_sym_GT_GT] = ACTIONS(13547),
    [anon_sym_EQ_EQ] = ACTIONS(13549),
    [anon_sym_BANG_EQ] = ACTIONS(13547),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13547),
    [anon_sym_LT_EQ_GT] = ACTIONS(13547),
    [anon_sym_EQ_TILDE] = ACTIONS(13547),
    [anon_sym_BANG_TILDE] = ACTIONS(13547),
    [anon_sym_LT_EQ] = ACTIONS(13549),
    [anon_sym_GT] = ACTIONS(13549),
    [anon_sym_GT_EQ] = ACTIONS(13547),
    [anon_sym_CARET] = ACTIONS(13547),
    [anon_sym_PLUS] = ACTIONS(13547),
    [anon_sym_SLASH] = ACTIONS(13547),
    [anon_sym_PERCENT] = ACTIONS(13547),
    [sym_comment] = ACTIONS(87),
  },
  [9019] = {
    [sym__binary_minus] = ACTIONS(13712),
    [sym__binary_star] = ACTIONS(13712),
    [anon_sym_LBRACE] = ACTIONS(13712),
    [anon_sym_RBRACE] = ACTIONS(13712),
    [anon_sym_RPAREN] = ACTIONS(13712),
    [anon_sym_DOT] = ACTIONS(13714),
    [anon_sym_COMMA] = ACTIONS(13712),
    [anon_sym_PIPE] = ACTIONS(13714),
    [anon_sym_SEMI] = ACTIONS(13712),
    [anon_sym_STAR_STAR] = ACTIONS(13712),
    [anon_sym_AMP] = ACTIONS(13714),
    [anon_sym_LT] = ACTIONS(13714),
    [anon_sym_if] = ACTIONS(13712),
    [anon_sym_unless] = ACTIONS(13712),
    [anon_sym_while] = ACTIONS(13712),
    [anon_sym_until] = ACTIONS(13712),
    [anon_sym_rescue] = ACTIONS(13712),
    [anon_sym_do] = ACTIONS(13712),
    [anon_sym_EQ_GT] = ACTIONS(13712),
    [anon_sym_LBRACK] = ACTIONS(13712),
    [anon_sym_COLON_COLON2] = ACTIONS(13712),
    [anon_sym_AMP_DOT] = ACTIONS(13712),
    [anon_sym_QMARK] = ACTIONS(13712),
    [anon_sym_COLON2] = ACTIONS(13714),
    [anon_sym_DOT_DOT] = ACTIONS(13714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13712),
    [anon_sym_and] = ACTIONS(13712),
    [anon_sym_or] = ACTIONS(13712),
    [anon_sym_PIPE_PIPE] = ACTIONS(13712),
    [anon_sym_AMP_AMP] = ACTIONS(13712),
    [anon_sym_LT_LT] = ACTIONS(13712),
    [anon_sym_GT_GT] = ACTIONS(13712),
    [anon_sym_EQ_EQ] = ACTIONS(13714),
    [anon_sym_BANG_EQ] = ACTIONS(13712),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13712),
    [anon_sym_LT_EQ_GT] = ACTIONS(13712),
    [anon_sym_EQ_TILDE] = ACTIONS(13712),
    [anon_sym_BANG_TILDE] = ACTIONS(13712),
    [anon_sym_LT_EQ] = ACTIONS(13714),
    [anon_sym_GT] = ACTIONS(13714),
    [anon_sym_GT_EQ] = ACTIONS(13712),
    [anon_sym_CARET] = ACTIONS(13712),
    [anon_sym_PLUS] = ACTIONS(13712),
    [anon_sym_SLASH] = ACTIONS(13712),
    [anon_sym_PERCENT] = ACTIONS(13712),
    [sym_comment] = ACTIONS(87),
  },
  [9020] = {
    [anon_sym_end] = ACTIONS(13934),
    [sym_comment] = ACTIONS(87),
  },
  [9021] = {
    [sym__heredoc_body_start] = ACTIONS(10203),
    [sym__binary_minus] = ACTIONS(10203),
    [sym__binary_star] = ACTIONS(10203),
    [anon_sym_LBRACE] = ACTIONS(10203),
    [anon_sym_RBRACE] = ACTIONS(10203),
    [anon_sym_RPAREN] = ACTIONS(10203),
    [anon_sym_DOT] = ACTIONS(10205),
    [anon_sym_COMMA] = ACTIONS(10203),
    [anon_sym_PIPE] = ACTIONS(10205),
    [anon_sym_SEMI] = ACTIONS(10203),
    [anon_sym_STAR_STAR] = ACTIONS(10205),
    [anon_sym_AMP] = ACTIONS(10205),
    [anon_sym_EQ] = ACTIONS(10205),
    [anon_sym_LT] = ACTIONS(10205),
    [anon_sym_if] = ACTIONS(10203),
    [anon_sym_unless] = ACTIONS(10203),
    [anon_sym_while] = ACTIONS(10203),
    [anon_sym_until] = ACTIONS(10203),
    [anon_sym_rescue] = ACTIONS(10203),
    [anon_sym_in] = ACTIONS(10203),
    [anon_sym_do] = ACTIONS(10203),
    [anon_sym_EQ_GT] = ACTIONS(10203),
    [anon_sym_LBRACK] = ACTIONS(10203),
    [anon_sym_RBRACK] = ACTIONS(10203),
    [anon_sym_COLON_COLON2] = ACTIONS(10203),
    [anon_sym_AMP_DOT] = ACTIONS(10203),
    [anon_sym_PLUS_EQ] = ACTIONS(10203),
    [anon_sym_DASH_EQ] = ACTIONS(10203),
    [anon_sym_STAR_EQ] = ACTIONS(10203),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10203),
    [anon_sym_SLASH_EQ] = ACTIONS(10203),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10203),
    [anon_sym_PIPE_EQ] = ACTIONS(10203),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10203),
    [anon_sym_AMP_EQ] = ACTIONS(10203),
    [anon_sym_PERCENT_EQ] = ACTIONS(10203),
    [anon_sym_GT_GT_EQ] = ACTIONS(10203),
    [anon_sym_LT_LT_EQ] = ACTIONS(10203),
    [anon_sym_CARET_EQ] = ACTIONS(10203),
    [anon_sym_QMARK] = ACTIONS(10203),
    [anon_sym_COLON2] = ACTIONS(10205),
    [anon_sym_DOT_DOT] = ACTIONS(10205),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10203),
    [anon_sym_and] = ACTIONS(10203),
    [anon_sym_or] = ACTIONS(10203),
    [anon_sym_PIPE_PIPE] = ACTIONS(10205),
    [anon_sym_AMP_AMP] = ACTIONS(10205),
    [anon_sym_LT_LT] = ACTIONS(10205),
    [anon_sym_GT_GT] = ACTIONS(10205),
    [anon_sym_EQ_EQ] = ACTIONS(10205),
    [anon_sym_BANG_EQ] = ACTIONS(10203),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10203),
    [anon_sym_LT_EQ_GT] = ACTIONS(10203),
    [anon_sym_EQ_TILDE] = ACTIONS(10203),
    [anon_sym_BANG_TILDE] = ACTIONS(10203),
    [anon_sym_LT_EQ] = ACTIONS(10205),
    [anon_sym_GT] = ACTIONS(10205),
    [anon_sym_GT_EQ] = ACTIONS(10203),
    [anon_sym_CARET] = ACTIONS(10205),
    [anon_sym_PLUS] = ACTIONS(10205),
    [anon_sym_SLASH] = ACTIONS(10205),
    [anon_sym_PERCENT] = ACTIONS(10205),
    [sym_comment] = ACTIONS(87),
  },
  [9022] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1697),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(13936),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [9023] = {
    [sym__heredoc_body_start] = ACTIONS(10209),
    [sym__binary_minus] = ACTIONS(10209),
    [sym__binary_star] = ACTIONS(10209),
    [anon_sym_LBRACE] = ACTIONS(10209),
    [anon_sym_RBRACE] = ACTIONS(10209),
    [anon_sym_RPAREN] = ACTIONS(10209),
    [anon_sym_DOT] = ACTIONS(10211),
    [anon_sym_COMMA] = ACTIONS(10209),
    [anon_sym_PIPE] = ACTIONS(10211),
    [anon_sym_SEMI] = ACTIONS(10209),
    [anon_sym_STAR_STAR] = ACTIONS(10211),
    [anon_sym_AMP] = ACTIONS(10211),
    [anon_sym_EQ] = ACTIONS(10211),
    [anon_sym_LT] = ACTIONS(10211),
    [anon_sym_if] = ACTIONS(10209),
    [anon_sym_unless] = ACTIONS(10209),
    [anon_sym_while] = ACTIONS(10209),
    [anon_sym_until] = ACTIONS(10209),
    [anon_sym_rescue] = ACTIONS(10209),
    [anon_sym_in] = ACTIONS(10209),
    [anon_sym_do] = ACTIONS(10209),
    [anon_sym_EQ_GT] = ACTIONS(10209),
    [anon_sym_LBRACK] = ACTIONS(10209),
    [anon_sym_RBRACK] = ACTIONS(10209),
    [anon_sym_COLON_COLON2] = ACTIONS(10209),
    [anon_sym_AMP_DOT] = ACTIONS(10209),
    [anon_sym_PLUS_EQ] = ACTIONS(10209),
    [anon_sym_DASH_EQ] = ACTIONS(10209),
    [anon_sym_STAR_EQ] = ACTIONS(10209),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10209),
    [anon_sym_SLASH_EQ] = ACTIONS(10209),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10209),
    [anon_sym_PIPE_EQ] = ACTIONS(10209),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10209),
    [anon_sym_AMP_EQ] = ACTIONS(10209),
    [anon_sym_PERCENT_EQ] = ACTIONS(10209),
    [anon_sym_GT_GT_EQ] = ACTIONS(10209),
    [anon_sym_LT_LT_EQ] = ACTIONS(10209),
    [anon_sym_CARET_EQ] = ACTIONS(10209),
    [anon_sym_QMARK] = ACTIONS(10209),
    [anon_sym_COLON2] = ACTIONS(10211),
    [anon_sym_DOT_DOT] = ACTIONS(10211),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10209),
    [anon_sym_and] = ACTIONS(10209),
    [anon_sym_or] = ACTIONS(10209),
    [anon_sym_PIPE_PIPE] = ACTIONS(10211),
    [anon_sym_AMP_AMP] = ACTIONS(10211),
    [anon_sym_LT_LT] = ACTIONS(10211),
    [anon_sym_GT_GT] = ACTIONS(10211),
    [anon_sym_EQ_EQ] = ACTIONS(10211),
    [anon_sym_BANG_EQ] = ACTIONS(10209),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10209),
    [anon_sym_LT_EQ_GT] = ACTIONS(10209),
    [anon_sym_EQ_TILDE] = ACTIONS(10209),
    [anon_sym_BANG_TILDE] = ACTIONS(10209),
    [anon_sym_LT_EQ] = ACTIONS(10211),
    [anon_sym_GT] = ACTIONS(10211),
    [anon_sym_GT_EQ] = ACTIONS(10209),
    [anon_sym_CARET] = ACTIONS(10211),
    [anon_sym_PLUS] = ACTIONS(10211),
    [anon_sym_SLASH] = ACTIONS(10211),
    [anon_sym_PERCENT] = ACTIONS(10211),
    [sym_comment] = ACTIONS(87),
  },
  [9024] = {
    [sym__heredoc_body_start] = ACTIONS(10213),
    [sym__binary_minus] = ACTIONS(10213),
    [sym__binary_star] = ACTIONS(10213),
    [anon_sym_LBRACE] = ACTIONS(10213),
    [anon_sym_RBRACE] = ACTIONS(10213),
    [anon_sym_RPAREN] = ACTIONS(10213),
    [anon_sym_DOT] = ACTIONS(10215),
    [anon_sym_COMMA] = ACTIONS(10213),
    [anon_sym_PIPE] = ACTIONS(10215),
    [anon_sym_SEMI] = ACTIONS(10213),
    [anon_sym_STAR_STAR] = ACTIONS(10215),
    [anon_sym_AMP] = ACTIONS(10215),
    [anon_sym_EQ] = ACTIONS(10215),
    [anon_sym_LT] = ACTIONS(10215),
    [anon_sym_if] = ACTIONS(10213),
    [anon_sym_unless] = ACTIONS(10213),
    [anon_sym_while] = ACTIONS(10213),
    [anon_sym_until] = ACTIONS(10213),
    [anon_sym_rescue] = ACTIONS(10213),
    [anon_sym_in] = ACTIONS(10213),
    [anon_sym_do] = ACTIONS(10213),
    [anon_sym_EQ_GT] = ACTIONS(10213),
    [anon_sym_LBRACK] = ACTIONS(10213),
    [anon_sym_RBRACK] = ACTIONS(10213),
    [anon_sym_COLON_COLON2] = ACTIONS(10213),
    [anon_sym_AMP_DOT] = ACTIONS(10213),
    [anon_sym_PLUS_EQ] = ACTIONS(10213),
    [anon_sym_DASH_EQ] = ACTIONS(10213),
    [anon_sym_STAR_EQ] = ACTIONS(10213),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10213),
    [anon_sym_SLASH_EQ] = ACTIONS(10213),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10213),
    [anon_sym_PIPE_EQ] = ACTIONS(10213),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10213),
    [anon_sym_AMP_EQ] = ACTIONS(10213),
    [anon_sym_PERCENT_EQ] = ACTIONS(10213),
    [anon_sym_GT_GT_EQ] = ACTIONS(10213),
    [anon_sym_LT_LT_EQ] = ACTIONS(10213),
    [anon_sym_CARET_EQ] = ACTIONS(10213),
    [anon_sym_QMARK] = ACTIONS(10213),
    [anon_sym_COLON2] = ACTIONS(10215),
    [anon_sym_DOT_DOT] = ACTIONS(10215),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10213),
    [anon_sym_and] = ACTIONS(10213),
    [anon_sym_or] = ACTIONS(10213),
    [anon_sym_PIPE_PIPE] = ACTIONS(10215),
    [anon_sym_AMP_AMP] = ACTIONS(10215),
    [anon_sym_LT_LT] = ACTIONS(10215),
    [anon_sym_GT_GT] = ACTIONS(10215),
    [anon_sym_EQ_EQ] = ACTIONS(10215),
    [anon_sym_BANG_EQ] = ACTIONS(10213),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10213),
    [anon_sym_LT_EQ_GT] = ACTIONS(10213),
    [anon_sym_EQ_TILDE] = ACTIONS(10213),
    [anon_sym_BANG_TILDE] = ACTIONS(10213),
    [anon_sym_LT_EQ] = ACTIONS(10215),
    [anon_sym_GT] = ACTIONS(10215),
    [anon_sym_GT_EQ] = ACTIONS(10213),
    [anon_sym_CARET] = ACTIONS(10215),
    [anon_sym_PLUS] = ACTIONS(10215),
    [anon_sym_SLASH] = ACTIONS(10215),
    [anon_sym_PERCENT] = ACTIONS(10215),
    [sym_comment] = ACTIONS(87),
  },
  [9025] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1705),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(13938),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [9026] = {
    [sym__heredoc_body_start] = ACTIONS(10219),
    [sym__binary_minus] = ACTIONS(10219),
    [sym__binary_star] = ACTIONS(10219),
    [anon_sym_LBRACE] = ACTIONS(10219),
    [anon_sym_RBRACE] = ACTIONS(10219),
    [anon_sym_RPAREN] = ACTIONS(10219),
    [anon_sym_DOT] = ACTIONS(10221),
    [anon_sym_COMMA] = ACTIONS(10219),
    [anon_sym_PIPE] = ACTIONS(10221),
    [anon_sym_SEMI] = ACTIONS(10219),
    [anon_sym_STAR_STAR] = ACTIONS(10221),
    [anon_sym_AMP] = ACTIONS(10221),
    [anon_sym_EQ] = ACTIONS(10221),
    [anon_sym_LT] = ACTIONS(10221),
    [anon_sym_if] = ACTIONS(10219),
    [anon_sym_unless] = ACTIONS(10219),
    [anon_sym_while] = ACTIONS(10219),
    [anon_sym_until] = ACTIONS(10219),
    [anon_sym_rescue] = ACTIONS(10219),
    [anon_sym_in] = ACTIONS(10219),
    [anon_sym_do] = ACTIONS(10219),
    [anon_sym_EQ_GT] = ACTIONS(10219),
    [anon_sym_LBRACK] = ACTIONS(10219),
    [anon_sym_RBRACK] = ACTIONS(10219),
    [anon_sym_COLON_COLON2] = ACTIONS(10219),
    [anon_sym_AMP_DOT] = ACTIONS(10219),
    [anon_sym_PLUS_EQ] = ACTIONS(10219),
    [anon_sym_DASH_EQ] = ACTIONS(10219),
    [anon_sym_STAR_EQ] = ACTIONS(10219),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10219),
    [anon_sym_SLASH_EQ] = ACTIONS(10219),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10219),
    [anon_sym_PIPE_EQ] = ACTIONS(10219),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10219),
    [anon_sym_AMP_EQ] = ACTIONS(10219),
    [anon_sym_PERCENT_EQ] = ACTIONS(10219),
    [anon_sym_GT_GT_EQ] = ACTIONS(10219),
    [anon_sym_LT_LT_EQ] = ACTIONS(10219),
    [anon_sym_CARET_EQ] = ACTIONS(10219),
    [anon_sym_QMARK] = ACTIONS(10219),
    [anon_sym_COLON2] = ACTIONS(10221),
    [anon_sym_DOT_DOT] = ACTIONS(10221),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10219),
    [anon_sym_and] = ACTIONS(10219),
    [anon_sym_or] = ACTIONS(10219),
    [anon_sym_PIPE_PIPE] = ACTIONS(10221),
    [anon_sym_AMP_AMP] = ACTIONS(10221),
    [anon_sym_LT_LT] = ACTIONS(10221),
    [anon_sym_GT_GT] = ACTIONS(10221),
    [anon_sym_EQ_EQ] = ACTIONS(10221),
    [anon_sym_BANG_EQ] = ACTIONS(10219),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10219),
    [anon_sym_LT_EQ_GT] = ACTIONS(10219),
    [anon_sym_EQ_TILDE] = ACTIONS(10219),
    [anon_sym_BANG_TILDE] = ACTIONS(10219),
    [anon_sym_LT_EQ] = ACTIONS(10221),
    [anon_sym_GT] = ACTIONS(10221),
    [anon_sym_GT_EQ] = ACTIONS(10219),
    [anon_sym_CARET] = ACTIONS(10221),
    [anon_sym_PLUS] = ACTIONS(10221),
    [anon_sym_SLASH] = ACTIONS(10221),
    [anon_sym_PERCENT] = ACTIONS(10221),
    [sym_comment] = ACTIONS(87),
  },
  [9027] = {
    [sym__method_rest] = STATE(10232),
    [sym_operator] = STATE(1964),
    [sym__method_name] = STATE(1964),
    [sym_setter] = STATE(1964),
    [sym_symbol] = STATE(1964),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(10511),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(10511),
    [sym_class_variable] = ACTIONS(10511),
    [sym_global_variable] = ACTIONS(10511),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [9028] = {
    [sym__heredoc_body_start] = ACTIONS(10927),
    [sym__binary_minus] = ACTIONS(10927),
    [sym__binary_star] = ACTIONS(10927),
    [anon_sym_LBRACE] = ACTIONS(10927),
    [anon_sym_RBRACE] = ACTIONS(10927),
    [anon_sym_RPAREN] = ACTIONS(10927),
    [anon_sym_DOT] = ACTIONS(10929),
    [anon_sym_COMMA] = ACTIONS(10927),
    [anon_sym_PIPE] = ACTIONS(10929),
    [anon_sym_SEMI] = ACTIONS(10927),
    [anon_sym_STAR_STAR] = ACTIONS(10929),
    [anon_sym_AMP] = ACTIONS(10929),
    [anon_sym_EQ] = ACTIONS(10929),
    [anon_sym_LT] = ACTIONS(10929),
    [anon_sym_if] = ACTIONS(10927),
    [anon_sym_unless] = ACTIONS(10927),
    [anon_sym_while] = ACTIONS(10927),
    [anon_sym_until] = ACTIONS(10927),
    [anon_sym_rescue] = ACTIONS(10927),
    [anon_sym_in] = ACTIONS(10927),
    [anon_sym_do] = ACTIONS(10927),
    [anon_sym_EQ_GT] = ACTIONS(10927),
    [anon_sym_LBRACK] = ACTIONS(10927),
    [anon_sym_RBRACK] = ACTIONS(10927),
    [anon_sym_COLON_COLON2] = ACTIONS(10927),
    [anon_sym_AMP_DOT] = ACTIONS(10927),
    [anon_sym_PLUS_EQ] = ACTIONS(10927),
    [anon_sym_DASH_EQ] = ACTIONS(10927),
    [anon_sym_STAR_EQ] = ACTIONS(10927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10927),
    [anon_sym_SLASH_EQ] = ACTIONS(10927),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10927),
    [anon_sym_PIPE_EQ] = ACTIONS(10927),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10927),
    [anon_sym_AMP_EQ] = ACTIONS(10927),
    [anon_sym_PERCENT_EQ] = ACTIONS(10927),
    [anon_sym_GT_GT_EQ] = ACTIONS(10927),
    [anon_sym_LT_LT_EQ] = ACTIONS(10927),
    [anon_sym_CARET_EQ] = ACTIONS(10927),
    [anon_sym_QMARK] = ACTIONS(10927),
    [anon_sym_COLON2] = ACTIONS(10929),
    [anon_sym_DOT_DOT] = ACTIONS(10929),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10927),
    [anon_sym_and] = ACTIONS(10927),
    [anon_sym_or] = ACTIONS(10927),
    [anon_sym_PIPE_PIPE] = ACTIONS(10929),
    [anon_sym_AMP_AMP] = ACTIONS(10929),
    [anon_sym_LT_LT] = ACTIONS(10929),
    [anon_sym_GT_GT] = ACTIONS(10929),
    [anon_sym_EQ_EQ] = ACTIONS(10929),
    [anon_sym_BANG_EQ] = ACTIONS(10927),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10927),
    [anon_sym_LT_EQ_GT] = ACTIONS(10927),
    [anon_sym_EQ_TILDE] = ACTIONS(10927),
    [anon_sym_BANG_TILDE] = ACTIONS(10927),
    [anon_sym_LT_EQ] = ACTIONS(10929),
    [anon_sym_GT] = ACTIONS(10929),
    [anon_sym_GT_EQ] = ACTIONS(10927),
    [anon_sym_CARET] = ACTIONS(10929),
    [anon_sym_PLUS] = ACTIONS(10929),
    [anon_sym_SLASH] = ACTIONS(10929),
    [anon_sym_PERCENT] = ACTIONS(10929),
    [sym_comment] = ACTIONS(87),
  },
  [9029] = {
    [sym__heredoc_body_start] = ACTIONS(10931),
    [sym__binary_minus] = ACTIONS(10931),
    [sym__binary_star] = ACTIONS(10931),
    [anon_sym_LBRACE] = ACTIONS(10931),
    [anon_sym_RBRACE] = ACTIONS(10931),
    [anon_sym_RPAREN] = ACTIONS(10931),
    [anon_sym_DOT] = ACTIONS(10933),
    [anon_sym_COMMA] = ACTIONS(10931),
    [anon_sym_PIPE] = ACTIONS(10933),
    [anon_sym_SEMI] = ACTIONS(10931),
    [anon_sym_STAR_STAR] = ACTIONS(10933),
    [anon_sym_AMP] = ACTIONS(10933),
    [anon_sym_EQ] = ACTIONS(10933),
    [anon_sym_LT] = ACTIONS(10933),
    [anon_sym_if] = ACTIONS(10931),
    [anon_sym_unless] = ACTIONS(10931),
    [anon_sym_while] = ACTIONS(10931),
    [anon_sym_until] = ACTIONS(10931),
    [anon_sym_rescue] = ACTIONS(10931),
    [anon_sym_in] = ACTIONS(10931),
    [anon_sym_do] = ACTIONS(10931),
    [anon_sym_EQ_GT] = ACTIONS(10931),
    [anon_sym_LBRACK] = ACTIONS(10931),
    [anon_sym_RBRACK] = ACTIONS(10931),
    [anon_sym_COLON_COLON2] = ACTIONS(10931),
    [anon_sym_AMP_DOT] = ACTIONS(10931),
    [anon_sym_PLUS_EQ] = ACTIONS(10931),
    [anon_sym_DASH_EQ] = ACTIONS(10931),
    [anon_sym_STAR_EQ] = ACTIONS(10931),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10931),
    [anon_sym_SLASH_EQ] = ACTIONS(10931),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10931),
    [anon_sym_PIPE_EQ] = ACTIONS(10931),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10931),
    [anon_sym_AMP_EQ] = ACTIONS(10931),
    [anon_sym_PERCENT_EQ] = ACTIONS(10931),
    [anon_sym_GT_GT_EQ] = ACTIONS(10931),
    [anon_sym_LT_LT_EQ] = ACTIONS(10931),
    [anon_sym_CARET_EQ] = ACTIONS(10931),
    [anon_sym_QMARK] = ACTIONS(10931),
    [anon_sym_COLON2] = ACTIONS(10933),
    [anon_sym_DOT_DOT] = ACTIONS(10933),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10931),
    [anon_sym_and] = ACTIONS(10931),
    [anon_sym_or] = ACTIONS(10931),
    [anon_sym_PIPE_PIPE] = ACTIONS(10933),
    [anon_sym_AMP_AMP] = ACTIONS(10933),
    [anon_sym_LT_LT] = ACTIONS(10933),
    [anon_sym_GT_GT] = ACTIONS(10933),
    [anon_sym_EQ_EQ] = ACTIONS(10933),
    [anon_sym_BANG_EQ] = ACTIONS(10931),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10931),
    [anon_sym_LT_EQ_GT] = ACTIONS(10931),
    [anon_sym_EQ_TILDE] = ACTIONS(10931),
    [anon_sym_BANG_TILDE] = ACTIONS(10931),
    [anon_sym_LT_EQ] = ACTIONS(10933),
    [anon_sym_GT] = ACTIONS(10933),
    [anon_sym_GT_EQ] = ACTIONS(10931),
    [anon_sym_CARET] = ACTIONS(10933),
    [anon_sym_PLUS] = ACTIONS(10933),
    [anon_sym_SLASH] = ACTIONS(10933),
    [anon_sym_PERCENT] = ACTIONS(10933),
    [sym_comment] = ACTIONS(87),
  },
  [9030] = {
    [sym__heredoc_body_start] = ACTIONS(11157),
    [sym__binary_minus] = ACTIONS(11157),
    [sym__binary_star] = ACTIONS(11157),
    [anon_sym_LBRACE] = ACTIONS(11157),
    [anon_sym_RBRACE] = ACTIONS(11157),
    [anon_sym_RPAREN] = ACTIONS(11157),
    [anon_sym_DOT] = ACTIONS(11159),
    [anon_sym_COMMA] = ACTIONS(11157),
    [anon_sym_PIPE] = ACTIONS(11159),
    [anon_sym_SEMI] = ACTIONS(11157),
    [anon_sym_STAR_STAR] = ACTIONS(11159),
    [anon_sym_AMP] = ACTIONS(11159),
    [anon_sym_EQ] = ACTIONS(11159),
    [anon_sym_LT] = ACTIONS(11159),
    [anon_sym_if] = ACTIONS(11157),
    [anon_sym_unless] = ACTIONS(11157),
    [anon_sym_while] = ACTIONS(11157),
    [anon_sym_until] = ACTIONS(11157),
    [anon_sym_rescue] = ACTIONS(11157),
    [anon_sym_in] = ACTIONS(11157),
    [anon_sym_do] = ACTIONS(11157),
    [anon_sym_EQ_GT] = ACTIONS(11157),
    [anon_sym_LBRACK] = ACTIONS(11157),
    [anon_sym_RBRACK] = ACTIONS(11157),
    [anon_sym_COLON_COLON2] = ACTIONS(11157),
    [anon_sym_AMP_DOT] = ACTIONS(11157),
    [anon_sym_PLUS_EQ] = ACTIONS(11157),
    [anon_sym_DASH_EQ] = ACTIONS(11157),
    [anon_sym_STAR_EQ] = ACTIONS(11157),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11157),
    [anon_sym_SLASH_EQ] = ACTIONS(11157),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11157),
    [anon_sym_PIPE_EQ] = ACTIONS(11157),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11157),
    [anon_sym_AMP_EQ] = ACTIONS(11157),
    [anon_sym_PERCENT_EQ] = ACTIONS(11157),
    [anon_sym_GT_GT_EQ] = ACTIONS(11157),
    [anon_sym_LT_LT_EQ] = ACTIONS(11157),
    [anon_sym_CARET_EQ] = ACTIONS(11157),
    [anon_sym_QMARK] = ACTIONS(11157),
    [anon_sym_COLON2] = ACTIONS(11159),
    [anon_sym_DOT_DOT] = ACTIONS(11159),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11157),
    [anon_sym_and] = ACTIONS(11157),
    [anon_sym_or] = ACTIONS(11157),
    [anon_sym_PIPE_PIPE] = ACTIONS(11159),
    [anon_sym_AMP_AMP] = ACTIONS(11159),
    [anon_sym_LT_LT] = ACTIONS(11159),
    [anon_sym_GT_GT] = ACTIONS(11159),
    [anon_sym_EQ_EQ] = ACTIONS(11159),
    [anon_sym_BANG_EQ] = ACTIONS(11157),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11157),
    [anon_sym_LT_EQ_GT] = ACTIONS(11157),
    [anon_sym_EQ_TILDE] = ACTIONS(11157),
    [anon_sym_BANG_TILDE] = ACTIONS(11157),
    [anon_sym_LT_EQ] = ACTIONS(11159),
    [anon_sym_GT] = ACTIONS(11159),
    [anon_sym_GT_EQ] = ACTIONS(11157),
    [anon_sym_CARET] = ACTIONS(11159),
    [anon_sym_PLUS] = ACTIONS(11159),
    [anon_sym_SLASH] = ACTIONS(11159),
    [anon_sym_PERCENT] = ACTIONS(11159),
    [sym_comment] = ACTIONS(87),
  },
  [9031] = {
    [sym__heredoc_body_start] = ACTIONS(11322),
    [sym__binary_minus] = ACTIONS(11322),
    [sym__binary_star] = ACTIONS(11322),
    [anon_sym_LBRACE] = ACTIONS(11322),
    [anon_sym_RBRACE] = ACTIONS(11322),
    [anon_sym_RPAREN] = ACTIONS(11322),
    [anon_sym_DOT] = ACTIONS(11324),
    [anon_sym_COMMA] = ACTIONS(11322),
    [anon_sym_PIPE] = ACTIONS(11324),
    [anon_sym_SEMI] = ACTIONS(11322),
    [anon_sym_STAR_STAR] = ACTIONS(11324),
    [anon_sym_AMP] = ACTIONS(11324),
    [anon_sym_EQ] = ACTIONS(11324),
    [anon_sym_LT] = ACTIONS(11324),
    [anon_sym_if] = ACTIONS(11322),
    [anon_sym_unless] = ACTIONS(11322),
    [anon_sym_while] = ACTIONS(11322),
    [anon_sym_until] = ACTIONS(11322),
    [anon_sym_rescue] = ACTIONS(11322),
    [anon_sym_in] = ACTIONS(11322),
    [anon_sym_do] = ACTIONS(11322),
    [anon_sym_EQ_GT] = ACTIONS(11322),
    [anon_sym_LBRACK] = ACTIONS(11322),
    [anon_sym_RBRACK] = ACTIONS(11322),
    [anon_sym_COLON_COLON2] = ACTIONS(11322),
    [anon_sym_AMP_DOT] = ACTIONS(11322),
    [anon_sym_PLUS_EQ] = ACTIONS(11322),
    [anon_sym_DASH_EQ] = ACTIONS(11322),
    [anon_sym_STAR_EQ] = ACTIONS(11322),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11322),
    [anon_sym_SLASH_EQ] = ACTIONS(11322),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11322),
    [anon_sym_PIPE_EQ] = ACTIONS(11322),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11322),
    [anon_sym_AMP_EQ] = ACTIONS(11322),
    [anon_sym_PERCENT_EQ] = ACTIONS(11322),
    [anon_sym_GT_GT_EQ] = ACTIONS(11322),
    [anon_sym_LT_LT_EQ] = ACTIONS(11322),
    [anon_sym_CARET_EQ] = ACTIONS(11322),
    [anon_sym_QMARK] = ACTIONS(11322),
    [anon_sym_COLON2] = ACTIONS(11324),
    [anon_sym_DOT_DOT] = ACTIONS(11324),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11322),
    [anon_sym_and] = ACTIONS(11322),
    [anon_sym_or] = ACTIONS(11322),
    [anon_sym_PIPE_PIPE] = ACTIONS(11324),
    [anon_sym_AMP_AMP] = ACTIONS(11324),
    [anon_sym_LT_LT] = ACTIONS(11324),
    [anon_sym_GT_GT] = ACTIONS(11324),
    [anon_sym_EQ_EQ] = ACTIONS(11324),
    [anon_sym_BANG_EQ] = ACTIONS(11322),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11322),
    [anon_sym_LT_EQ_GT] = ACTIONS(11322),
    [anon_sym_EQ_TILDE] = ACTIONS(11322),
    [anon_sym_BANG_TILDE] = ACTIONS(11322),
    [anon_sym_LT_EQ] = ACTIONS(11324),
    [anon_sym_GT] = ACTIONS(11324),
    [anon_sym_GT_EQ] = ACTIONS(11322),
    [anon_sym_CARET] = ACTIONS(11324),
    [anon_sym_PLUS] = ACTIONS(11324),
    [anon_sym_SLASH] = ACTIONS(11324),
    [anon_sym_PERCENT] = ACTIONS(11324),
    [sym_comment] = ACTIONS(87),
  },
  [9032] = {
    [sym__heredoc_body_start] = ACTIONS(11335),
    [sym__binary_minus] = ACTIONS(11335),
    [sym__binary_star] = ACTIONS(11335),
    [anon_sym_LBRACE] = ACTIONS(11335),
    [anon_sym_RBRACE] = ACTIONS(11335),
    [anon_sym_RPAREN] = ACTIONS(11335),
    [anon_sym_DOT] = ACTIONS(11337),
    [anon_sym_COMMA] = ACTIONS(11335),
    [anon_sym_PIPE] = ACTIONS(11337),
    [anon_sym_SEMI] = ACTIONS(11335),
    [anon_sym_STAR_STAR] = ACTIONS(11337),
    [anon_sym_AMP] = ACTIONS(11337),
    [anon_sym_EQ] = ACTIONS(11337),
    [anon_sym_LT] = ACTIONS(11337),
    [anon_sym_if] = ACTIONS(11335),
    [anon_sym_unless] = ACTIONS(11335),
    [anon_sym_while] = ACTIONS(11335),
    [anon_sym_until] = ACTIONS(11335),
    [anon_sym_rescue] = ACTIONS(11335),
    [anon_sym_in] = ACTIONS(11335),
    [anon_sym_do] = ACTIONS(11335),
    [anon_sym_EQ_GT] = ACTIONS(11335),
    [anon_sym_LBRACK] = ACTIONS(11335),
    [anon_sym_RBRACK] = ACTIONS(11335),
    [anon_sym_COLON_COLON2] = ACTIONS(11335),
    [anon_sym_AMP_DOT] = ACTIONS(11335),
    [anon_sym_PLUS_EQ] = ACTIONS(11335),
    [anon_sym_DASH_EQ] = ACTIONS(11335),
    [anon_sym_STAR_EQ] = ACTIONS(11335),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11335),
    [anon_sym_SLASH_EQ] = ACTIONS(11335),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11335),
    [anon_sym_PIPE_EQ] = ACTIONS(11335),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11335),
    [anon_sym_AMP_EQ] = ACTIONS(11335),
    [anon_sym_PERCENT_EQ] = ACTIONS(11335),
    [anon_sym_GT_GT_EQ] = ACTIONS(11335),
    [anon_sym_LT_LT_EQ] = ACTIONS(11335),
    [anon_sym_CARET_EQ] = ACTIONS(11335),
    [anon_sym_QMARK] = ACTIONS(11335),
    [anon_sym_COLON2] = ACTIONS(11337),
    [anon_sym_DOT_DOT] = ACTIONS(11337),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11335),
    [anon_sym_and] = ACTIONS(11335),
    [anon_sym_or] = ACTIONS(11335),
    [anon_sym_PIPE_PIPE] = ACTIONS(11337),
    [anon_sym_AMP_AMP] = ACTIONS(11337),
    [anon_sym_LT_LT] = ACTIONS(11337),
    [anon_sym_GT_GT] = ACTIONS(11337),
    [anon_sym_EQ_EQ] = ACTIONS(11337),
    [anon_sym_BANG_EQ] = ACTIONS(11335),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11335),
    [anon_sym_LT_EQ_GT] = ACTIONS(11335),
    [anon_sym_EQ_TILDE] = ACTIONS(11335),
    [anon_sym_BANG_TILDE] = ACTIONS(11335),
    [anon_sym_LT_EQ] = ACTIONS(11337),
    [anon_sym_GT] = ACTIONS(11337),
    [anon_sym_GT_EQ] = ACTIONS(11335),
    [anon_sym_CARET] = ACTIONS(11337),
    [anon_sym_PLUS] = ACTIONS(11337),
    [anon_sym_SLASH] = ACTIONS(11337),
    [anon_sym_PERCENT] = ACTIONS(11337),
    [sym_comment] = ACTIONS(87),
  },
  [9033] = {
    [sym__heredoc_body_start] = ACTIONS(11344),
    [sym__binary_minus] = ACTIONS(11344),
    [sym__binary_star] = ACTIONS(11344),
    [anon_sym_LBRACE] = ACTIONS(11344),
    [anon_sym_RBRACE] = ACTIONS(11344),
    [anon_sym_RPAREN] = ACTIONS(11344),
    [anon_sym_DOT] = ACTIONS(11346),
    [anon_sym_COMMA] = ACTIONS(11344),
    [anon_sym_PIPE] = ACTIONS(11346),
    [anon_sym_SEMI] = ACTIONS(11344),
    [anon_sym_STAR_STAR] = ACTIONS(11346),
    [anon_sym_AMP] = ACTIONS(11346),
    [anon_sym_EQ] = ACTIONS(11346),
    [anon_sym_LT] = ACTIONS(11346),
    [anon_sym_if] = ACTIONS(11344),
    [anon_sym_unless] = ACTIONS(11344),
    [anon_sym_while] = ACTIONS(11344),
    [anon_sym_until] = ACTIONS(11344),
    [anon_sym_rescue] = ACTIONS(11344),
    [anon_sym_in] = ACTIONS(11344),
    [anon_sym_do] = ACTIONS(11344),
    [anon_sym_EQ_GT] = ACTIONS(11344),
    [anon_sym_LBRACK] = ACTIONS(11344),
    [anon_sym_RBRACK] = ACTIONS(11344),
    [anon_sym_COLON_COLON2] = ACTIONS(11344),
    [anon_sym_AMP_DOT] = ACTIONS(11344),
    [anon_sym_PLUS_EQ] = ACTIONS(11344),
    [anon_sym_DASH_EQ] = ACTIONS(11344),
    [anon_sym_STAR_EQ] = ACTIONS(11344),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11344),
    [anon_sym_SLASH_EQ] = ACTIONS(11344),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11344),
    [anon_sym_PIPE_EQ] = ACTIONS(11344),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11344),
    [anon_sym_AMP_EQ] = ACTIONS(11344),
    [anon_sym_PERCENT_EQ] = ACTIONS(11344),
    [anon_sym_GT_GT_EQ] = ACTIONS(11344),
    [anon_sym_LT_LT_EQ] = ACTIONS(11344),
    [anon_sym_CARET_EQ] = ACTIONS(11344),
    [anon_sym_QMARK] = ACTIONS(11344),
    [anon_sym_COLON2] = ACTIONS(11346),
    [anon_sym_DOT_DOT] = ACTIONS(11346),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11344),
    [anon_sym_and] = ACTIONS(11344),
    [anon_sym_or] = ACTIONS(11344),
    [anon_sym_PIPE_PIPE] = ACTIONS(11346),
    [anon_sym_AMP_AMP] = ACTIONS(11346),
    [anon_sym_LT_LT] = ACTIONS(11346),
    [anon_sym_GT_GT] = ACTIONS(11346),
    [anon_sym_EQ_EQ] = ACTIONS(11346),
    [anon_sym_BANG_EQ] = ACTIONS(11344),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11344),
    [anon_sym_LT_EQ_GT] = ACTIONS(11344),
    [anon_sym_EQ_TILDE] = ACTIONS(11344),
    [anon_sym_BANG_TILDE] = ACTIONS(11344),
    [anon_sym_LT_EQ] = ACTIONS(11346),
    [anon_sym_GT] = ACTIONS(11346),
    [anon_sym_GT_EQ] = ACTIONS(11344),
    [anon_sym_CARET] = ACTIONS(11346),
    [anon_sym_PLUS] = ACTIONS(11346),
    [anon_sym_SLASH] = ACTIONS(11346),
    [anon_sym_PERCENT] = ACTIONS(11346),
    [sym_comment] = ACTIONS(87),
  },
  [9034] = {
    [sym__heredoc_body_start] = ACTIONS(11391),
    [sym__binary_minus] = ACTIONS(11391),
    [sym__binary_star] = ACTIONS(11391),
    [anon_sym_LBRACE] = ACTIONS(11391),
    [anon_sym_RBRACE] = ACTIONS(11391),
    [anon_sym_RPAREN] = ACTIONS(11391),
    [anon_sym_DOT] = ACTIONS(11393),
    [anon_sym_COMMA] = ACTIONS(11391),
    [anon_sym_PIPE] = ACTIONS(11393),
    [anon_sym_SEMI] = ACTIONS(11391),
    [anon_sym_STAR_STAR] = ACTIONS(11393),
    [anon_sym_AMP] = ACTIONS(11393),
    [anon_sym_EQ] = ACTIONS(11393),
    [anon_sym_LT] = ACTIONS(11393),
    [anon_sym_if] = ACTIONS(11391),
    [anon_sym_unless] = ACTIONS(11391),
    [anon_sym_while] = ACTIONS(11391),
    [anon_sym_until] = ACTIONS(11391),
    [anon_sym_rescue] = ACTIONS(11391),
    [anon_sym_in] = ACTIONS(11391),
    [anon_sym_do] = ACTIONS(11391),
    [anon_sym_EQ_GT] = ACTIONS(11391),
    [anon_sym_LBRACK] = ACTIONS(11391),
    [anon_sym_RBRACK] = ACTIONS(11391),
    [anon_sym_COLON_COLON2] = ACTIONS(11391),
    [anon_sym_AMP_DOT] = ACTIONS(11391),
    [anon_sym_PLUS_EQ] = ACTIONS(11391),
    [anon_sym_DASH_EQ] = ACTIONS(11391),
    [anon_sym_STAR_EQ] = ACTIONS(11391),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11391),
    [anon_sym_SLASH_EQ] = ACTIONS(11391),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11391),
    [anon_sym_PIPE_EQ] = ACTIONS(11391),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11391),
    [anon_sym_AMP_EQ] = ACTIONS(11391),
    [anon_sym_PERCENT_EQ] = ACTIONS(11391),
    [anon_sym_GT_GT_EQ] = ACTIONS(11391),
    [anon_sym_LT_LT_EQ] = ACTIONS(11391),
    [anon_sym_CARET_EQ] = ACTIONS(11391),
    [anon_sym_QMARK] = ACTIONS(11391),
    [anon_sym_COLON2] = ACTIONS(11393),
    [anon_sym_DOT_DOT] = ACTIONS(11393),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11391),
    [anon_sym_and] = ACTIONS(11391),
    [anon_sym_or] = ACTIONS(11391),
    [anon_sym_PIPE_PIPE] = ACTIONS(11393),
    [anon_sym_AMP_AMP] = ACTIONS(11393),
    [anon_sym_LT_LT] = ACTIONS(11393),
    [anon_sym_GT_GT] = ACTIONS(11393),
    [anon_sym_EQ_EQ] = ACTIONS(11393),
    [anon_sym_BANG_EQ] = ACTIONS(11391),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11391),
    [anon_sym_LT_EQ_GT] = ACTIONS(11391),
    [anon_sym_EQ_TILDE] = ACTIONS(11391),
    [anon_sym_BANG_TILDE] = ACTIONS(11391),
    [anon_sym_LT_EQ] = ACTIONS(11393),
    [anon_sym_GT] = ACTIONS(11393),
    [anon_sym_GT_EQ] = ACTIONS(11391),
    [anon_sym_CARET] = ACTIONS(11393),
    [anon_sym_PLUS] = ACTIONS(11393),
    [anon_sym_SLASH] = ACTIONS(11393),
    [anon_sym_PERCENT] = ACTIONS(11393),
    [sym_comment] = ACTIONS(87),
  },
  [9035] = {
    [anon_sym_end] = ACTIONS(13940),
    [sym_comment] = ACTIONS(87),
  },
  [9036] = {
    [sym__binary_minus] = ACTIONS(13712),
    [sym__binary_star] = ACTIONS(13712),
    [anon_sym_DOT] = ACTIONS(13714),
    [anon_sym_COMMA] = ACTIONS(13712),
    [anon_sym_PIPE] = ACTIONS(13714),
    [anon_sym_STAR_STAR] = ACTIONS(13714),
    [anon_sym_AMP] = ACTIONS(13714),
    [anon_sym_EQ] = ACTIONS(13714),
    [anon_sym_LT] = ACTIONS(13714),
    [anon_sym_EQ_GT] = ACTIONS(13712),
    [anon_sym_LBRACK] = ACTIONS(13712),
    [anon_sym_COLON_COLON2] = ACTIONS(13712),
    [anon_sym_AMP_DOT] = ACTIONS(13712),
    [anon_sym_PLUS_EQ] = ACTIONS(13712),
    [anon_sym_DASH_EQ] = ACTIONS(13712),
    [anon_sym_STAR_EQ] = ACTIONS(13712),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13712),
    [anon_sym_SLASH_EQ] = ACTIONS(13712),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13712),
    [anon_sym_PIPE_EQ] = ACTIONS(13712),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13712),
    [anon_sym_AMP_EQ] = ACTIONS(13712),
    [anon_sym_PERCENT_EQ] = ACTIONS(13712),
    [anon_sym_GT_GT_EQ] = ACTIONS(13712),
    [anon_sym_LT_LT_EQ] = ACTIONS(13712),
    [anon_sym_CARET_EQ] = ACTIONS(13712),
    [anon_sym_QMARK] = ACTIONS(13712),
    [anon_sym_DOT_DOT] = ACTIONS(13714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13712),
    [anon_sym_and] = ACTIONS(13712),
    [anon_sym_or] = ACTIONS(13712),
    [anon_sym_PIPE_PIPE] = ACTIONS(13714),
    [anon_sym_AMP_AMP] = ACTIONS(13714),
    [anon_sym_LT_LT] = ACTIONS(13714),
    [anon_sym_GT_GT] = ACTIONS(13714),
    [anon_sym_EQ_EQ] = ACTIONS(13714),
    [anon_sym_BANG_EQ] = ACTIONS(13712),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13712),
    [anon_sym_LT_EQ_GT] = ACTIONS(13712),
    [anon_sym_EQ_TILDE] = ACTIONS(13712),
    [anon_sym_BANG_TILDE] = ACTIONS(13712),
    [anon_sym_LT_EQ] = ACTIONS(13714),
    [anon_sym_GT] = ACTIONS(13714),
    [anon_sym_GT_EQ] = ACTIONS(13712),
    [anon_sym_CARET] = ACTIONS(13714),
    [anon_sym_PLUS] = ACTIONS(13714),
    [anon_sym_SLASH] = ACTIONS(13714),
    [anon_sym_PERCENT] = ACTIONS(13714),
    [sym_comment] = ACTIONS(87),
  },
  [9037] = {
    [anon_sym_end] = ACTIONS(13942),
    [sym_comment] = ACTIONS(87),
  },
  [9038] = {
    [sym__heredoc_body_start] = ACTIONS(11404),
    [sym__binary_minus] = ACTIONS(11404),
    [sym__binary_star] = ACTIONS(11404),
    [anon_sym_LBRACE] = ACTIONS(11404),
    [anon_sym_RBRACE] = ACTIONS(11404),
    [anon_sym_RPAREN] = ACTIONS(11404),
    [anon_sym_DOT] = ACTIONS(11406),
    [anon_sym_COMMA] = ACTIONS(11404),
    [anon_sym_PIPE] = ACTIONS(11406),
    [anon_sym_SEMI] = ACTIONS(11404),
    [anon_sym_STAR_STAR] = ACTIONS(11406),
    [anon_sym_AMP] = ACTIONS(11406),
    [anon_sym_EQ] = ACTIONS(11406),
    [anon_sym_LT] = ACTIONS(11406),
    [anon_sym_if] = ACTIONS(11404),
    [anon_sym_unless] = ACTIONS(11404),
    [anon_sym_while] = ACTIONS(11404),
    [anon_sym_until] = ACTIONS(11404),
    [anon_sym_rescue] = ACTIONS(11404),
    [anon_sym_in] = ACTIONS(11404),
    [anon_sym_do] = ACTIONS(11404),
    [anon_sym_EQ_GT] = ACTIONS(11404),
    [anon_sym_LBRACK] = ACTIONS(11404),
    [anon_sym_RBRACK] = ACTIONS(11404),
    [anon_sym_COLON_COLON2] = ACTIONS(11404),
    [anon_sym_AMP_DOT] = ACTIONS(11404),
    [anon_sym_PLUS_EQ] = ACTIONS(11404),
    [anon_sym_DASH_EQ] = ACTIONS(11404),
    [anon_sym_STAR_EQ] = ACTIONS(11404),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11404),
    [anon_sym_SLASH_EQ] = ACTIONS(11404),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11404),
    [anon_sym_PIPE_EQ] = ACTIONS(11404),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11404),
    [anon_sym_AMP_EQ] = ACTIONS(11404),
    [anon_sym_PERCENT_EQ] = ACTIONS(11404),
    [anon_sym_GT_GT_EQ] = ACTIONS(11404),
    [anon_sym_LT_LT_EQ] = ACTIONS(11404),
    [anon_sym_CARET_EQ] = ACTIONS(11404),
    [anon_sym_QMARK] = ACTIONS(11404),
    [anon_sym_COLON2] = ACTIONS(11406),
    [anon_sym_DOT_DOT] = ACTIONS(11406),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11404),
    [anon_sym_and] = ACTIONS(11404),
    [anon_sym_or] = ACTIONS(11404),
    [anon_sym_PIPE_PIPE] = ACTIONS(11406),
    [anon_sym_AMP_AMP] = ACTIONS(11406),
    [anon_sym_LT_LT] = ACTIONS(11406),
    [anon_sym_GT_GT] = ACTIONS(11406),
    [anon_sym_EQ_EQ] = ACTIONS(11406),
    [anon_sym_BANG_EQ] = ACTIONS(11404),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11404),
    [anon_sym_LT_EQ_GT] = ACTIONS(11404),
    [anon_sym_EQ_TILDE] = ACTIONS(11404),
    [anon_sym_BANG_TILDE] = ACTIONS(11404),
    [anon_sym_LT_EQ] = ACTIONS(11406),
    [anon_sym_GT] = ACTIONS(11406),
    [anon_sym_GT_EQ] = ACTIONS(11404),
    [anon_sym_CARET] = ACTIONS(11406),
    [anon_sym_PLUS] = ACTIONS(11406),
    [anon_sym_SLASH] = ACTIONS(11406),
    [anon_sym_PERCENT] = ACTIONS(11406),
    [sym_comment] = ACTIONS(87),
  },
  [9039] = {
    [anon_sym_end] = ACTIONS(13944),
    [sym_comment] = ACTIONS(87),
  },
  [9040] = {
    [sym_when] = STATE(2988),
    [sym_else] = STATE(10236),
    [aux_sym_case_repeat2] = STATE(2988),
    [anon_sym_end] = ACTIONS(13944),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [9041] = {
    [sym__heredoc_body_start] = ACTIONS(11846),
    [sym__binary_minus] = ACTIONS(11846),
    [sym__binary_star] = ACTIONS(11846),
    [anon_sym_LBRACE] = ACTIONS(11846),
    [anon_sym_RBRACE] = ACTIONS(11846),
    [anon_sym_RPAREN] = ACTIONS(11846),
    [anon_sym_DOT] = ACTIONS(11848),
    [anon_sym_COMMA] = ACTIONS(11846),
    [anon_sym_PIPE] = ACTIONS(11848),
    [anon_sym_SEMI] = ACTIONS(11846),
    [anon_sym_STAR_STAR] = ACTIONS(11848),
    [anon_sym_AMP] = ACTIONS(11848),
    [anon_sym_EQ] = ACTIONS(11848),
    [anon_sym_LT] = ACTIONS(11848),
    [anon_sym_if] = ACTIONS(11846),
    [anon_sym_unless] = ACTIONS(11846),
    [anon_sym_while] = ACTIONS(11846),
    [anon_sym_until] = ACTIONS(11846),
    [anon_sym_rescue] = ACTIONS(11846),
    [anon_sym_in] = ACTIONS(11846),
    [anon_sym_do] = ACTIONS(11846),
    [anon_sym_EQ_GT] = ACTIONS(11846),
    [anon_sym_LBRACK] = ACTIONS(11846),
    [anon_sym_RBRACK] = ACTIONS(11846),
    [anon_sym_COLON_COLON2] = ACTIONS(11846),
    [anon_sym_AMP_DOT] = ACTIONS(11846),
    [anon_sym_PLUS_EQ] = ACTIONS(11846),
    [anon_sym_DASH_EQ] = ACTIONS(11846),
    [anon_sym_STAR_EQ] = ACTIONS(11846),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11846),
    [anon_sym_SLASH_EQ] = ACTIONS(11846),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11846),
    [anon_sym_PIPE_EQ] = ACTIONS(11846),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11846),
    [anon_sym_AMP_EQ] = ACTIONS(11846),
    [anon_sym_PERCENT_EQ] = ACTIONS(11846),
    [anon_sym_GT_GT_EQ] = ACTIONS(11846),
    [anon_sym_LT_LT_EQ] = ACTIONS(11846),
    [anon_sym_CARET_EQ] = ACTIONS(11846),
    [anon_sym_QMARK] = ACTIONS(11846),
    [anon_sym_COLON2] = ACTIONS(11848),
    [anon_sym_DOT_DOT] = ACTIONS(11848),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11846),
    [anon_sym_and] = ACTIONS(11846),
    [anon_sym_or] = ACTIONS(11846),
    [anon_sym_PIPE_PIPE] = ACTIONS(11848),
    [anon_sym_AMP_AMP] = ACTIONS(11848),
    [anon_sym_LT_LT] = ACTIONS(11848),
    [anon_sym_GT_GT] = ACTIONS(11848),
    [anon_sym_EQ_EQ] = ACTIONS(11848),
    [anon_sym_BANG_EQ] = ACTIONS(11846),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11846),
    [anon_sym_LT_EQ_GT] = ACTIONS(11846),
    [anon_sym_EQ_TILDE] = ACTIONS(11846),
    [anon_sym_BANG_TILDE] = ACTIONS(11846),
    [anon_sym_LT_EQ] = ACTIONS(11848),
    [anon_sym_GT] = ACTIONS(11848),
    [anon_sym_GT_EQ] = ACTIONS(11846),
    [anon_sym_CARET] = ACTIONS(11848),
    [anon_sym_PLUS] = ACTIONS(11848),
    [anon_sym_SLASH] = ACTIONS(11848),
    [anon_sym_PERCENT] = ACTIONS(11848),
    [sym_comment] = ACTIONS(87),
  },
  [9042] = {
    [anon_sym_end] = ACTIONS(13946),
    [sym_comment] = ACTIONS(87),
  },
  [9043] = {
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(3509),
    [sym__binary_star] = ACTIONS(3511),
    [anon_sym_LBRACE] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(3513),
    [anon_sym_STAR_STAR] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(3517),
    [anon_sym_EQ] = ACTIONS(12879),
    [anon_sym_LT] = ACTIONS(3519),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_EQ_GT] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_PLUS_EQ] = ACTIONS(12120),
    [anon_sym_DASH_EQ] = ACTIONS(12120),
    [anon_sym_STAR_EQ] = ACTIONS(12120),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12120),
    [anon_sym_SLASH_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12120),
    [anon_sym_AMP_EQ] = ACTIONS(12120),
    [anon_sym_PERCENT_EQ] = ACTIONS(12120),
    [anon_sym_GT_GT_EQ] = ACTIONS(12120),
    [anon_sym_LT_LT_EQ] = ACTIONS(12120),
    [anon_sym_CARET_EQ] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(3521),
    [anon_sym_DOT_DOT] = ACTIONS(3523),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3525),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(3527),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_LT_LT] = ACTIONS(3529),
    [anon_sym_GT_GT] = ACTIONS(3529),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ] = ACTIONS(3531),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3531),
    [anon_sym_LT_EQ_GT] = ACTIONS(3531),
    [anon_sym_EQ_TILDE] = ACTIONS(3531),
    [anon_sym_BANG_TILDE] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3519),
    [anon_sym_GT] = ACTIONS(3519),
    [anon_sym_GT_EQ] = ACTIONS(3533),
    [anon_sym_CARET] = ACTIONS(3513),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_SLASH] = ACTIONS(3515),
    [anon_sym_PERCENT] = ACTIONS(3515),
    [sym_comment] = ACTIONS(87),
  },
  [9044] = {
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_RBRACE] = ACTIONS(11597),
    [anon_sym_RPAREN] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(11597),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_in] = ACTIONS(11597),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_RBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_PLUS_EQ] = ACTIONS(11597),
    [anon_sym_DASH_EQ] = ACTIONS(11597),
    [anon_sym_STAR_EQ] = ACTIONS(11597),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11597),
    [anon_sym_SLASH_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11597),
    [anon_sym_AMP_EQ] = ACTIONS(11597),
    [anon_sym_PERCENT_EQ] = ACTIONS(11597),
    [anon_sym_GT_GT_EQ] = ACTIONS(11597),
    [anon_sym_LT_LT_EQ] = ACTIONS(11597),
    [anon_sym_CARET_EQ] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_COLON2] = ACTIONS(12338),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_LT] = ACTIONS(12338),
    [anon_sym_GT_GT] = ACTIONS(12338),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(12338),
    [anon_sym_PLUS] = ACTIONS(12338),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [9045] = {
    [aux_sym_exceptions_repeat1] = STATE(9045),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(13948),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_PLUS_EQ] = ACTIONS(11597),
    [anon_sym_DASH_EQ] = ACTIONS(11597),
    [anon_sym_STAR_EQ] = ACTIONS(11597),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11597),
    [anon_sym_SLASH_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11597),
    [anon_sym_AMP_EQ] = ACTIONS(11597),
    [anon_sym_PERCENT_EQ] = ACTIONS(11597),
    [anon_sym_GT_GT_EQ] = ACTIONS(11597),
    [anon_sym_LT_LT_EQ] = ACTIONS(11597),
    [anon_sym_CARET_EQ] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_LT] = ACTIONS(12338),
    [anon_sym_GT_GT] = ACTIONS(12338),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(12338),
    [anon_sym_PLUS] = ACTIONS(12338),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [9046] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(10238),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(2038),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(2038),
    [sym_assignment] = STATE(10238),
    [sym_operator_assignment] = STATE(10238),
    [sym_conditional] = STATE(10238),
    [sym_range] = STATE(10238),
    [sym_binary] = STATE(10238),
    [sym_unary] = STATE(10238),
    [sym_left_assignment_list] = STATE(2037),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2038),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(2038),
    [sym_false] = STATE(2038),
    [sym_nil] = STATE(2038),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(2039),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(3557),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3559),
    [anon_sym_yield] = ACTIONS(3561),
    [anon_sym_break] = ACTIONS(3563),
    [anon_sym_next] = ACTIONS(3565),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3567),
    [anon_sym_defined_QMARK] = ACTIONS(3569),
    [anon_sym_not] = ACTIONS(3571),
    [anon_sym_BANG] = ACTIONS(3573),
    [anon_sym_TILDE] = ACTIONS(3573),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9047] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(10568),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(10568),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(10568),
    [anon_sym_PERCENT] = ACTIONS(10568),
    [sym_comment] = ACTIONS(87),
  },
  [9048] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(10568),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [9049] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10566),
    [sym__binary_star] = ACTIONS(10568),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(10568),
    [anon_sym_AMP] = ACTIONS(10572),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(10584),
    [anon_sym_GT_GT] = ACTIONS(10584),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(10566),
    [anon_sym_SLASH] = ACTIONS(10568),
    [anon_sym_PERCENT] = ACTIONS(10568),
    [sym_comment] = ACTIONS(87),
  },
  [9050] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10566),
    [sym__binary_star] = ACTIONS(10568),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(10568),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(10584),
    [anon_sym_GT_GT] = ACTIONS(10584),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(10566),
    [anon_sym_SLASH] = ACTIONS(10568),
    [anon_sym_PERCENT] = ACTIONS(10568),
    [sym_comment] = ACTIONS(87),
  },
  [9051] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10566),
    [sym__binary_star] = ACTIONS(10568),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(10570),
    [anon_sym_STAR_STAR] = ACTIONS(10568),
    [anon_sym_AMP] = ACTIONS(10572),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(10584),
    [anon_sym_GT_GT] = ACTIONS(10584),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(10590),
    [anon_sym_PLUS] = ACTIONS(10566),
    [anon_sym_SLASH] = ACTIONS(10568),
    [anon_sym_PERCENT] = ACTIONS(10568),
    [sym_comment] = ACTIONS(87),
  },
  [9052] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(13951),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [9053] = {
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(10566),
    [sym__binary_star] = ACTIONS(10568),
    [anon_sym_RPAREN] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(10570),
    [anon_sym_STAR_STAR] = ACTIONS(10568),
    [anon_sym_AMP] = ACTIONS(10572),
    [anon_sym_LT] = ACTIONS(10574),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(10578),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10580),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(10582),
    [anon_sym_AMP_AMP] = ACTIONS(10582),
    [anon_sym_LT_LT] = ACTIONS(10584),
    [anon_sym_GT_GT] = ACTIONS(10584),
    [anon_sym_EQ_EQ] = ACTIONS(10586),
    [anon_sym_BANG_EQ] = ACTIONS(10582),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10582),
    [anon_sym_LT_EQ_GT] = ACTIONS(10582),
    [anon_sym_EQ_TILDE] = ACTIONS(10582),
    [anon_sym_BANG_TILDE] = ACTIONS(10582),
    [anon_sym_LT_EQ] = ACTIONS(10574),
    [anon_sym_GT] = ACTIONS(10574),
    [anon_sym_GT_EQ] = ACTIONS(10588),
    [anon_sym_CARET] = ACTIONS(10590),
    [anon_sym_PLUS] = ACTIONS(10566),
    [anon_sym_SLASH] = ACTIONS(10568),
    [anon_sym_PERCENT] = ACTIONS(10568),
    [sym_comment] = ACTIONS(87),
  },
  [9054] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10566),
    [sym__binary_star] = ACTIONS(10568),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(10570),
    [anon_sym_STAR_STAR] = ACTIONS(10568),
    [anon_sym_AMP] = ACTIONS(10572),
    [anon_sym_LT] = ACTIONS(10574),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(10576),
    [anon_sym_DOT_DOT] = ACTIONS(10578),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10580),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(10582),
    [anon_sym_AMP_AMP] = ACTIONS(10582),
    [anon_sym_LT_LT] = ACTIONS(10584),
    [anon_sym_GT_GT] = ACTIONS(10584),
    [anon_sym_EQ_EQ] = ACTIONS(10586),
    [anon_sym_BANG_EQ] = ACTIONS(10582),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10582),
    [anon_sym_LT_EQ_GT] = ACTIONS(10582),
    [anon_sym_EQ_TILDE] = ACTIONS(10582),
    [anon_sym_BANG_TILDE] = ACTIONS(10582),
    [anon_sym_LT_EQ] = ACTIONS(10574),
    [anon_sym_GT] = ACTIONS(10574),
    [anon_sym_GT_EQ] = ACTIONS(10588),
    [anon_sym_CARET] = ACTIONS(10590),
    [anon_sym_PLUS] = ACTIONS(10566),
    [anon_sym_SLASH] = ACTIONS(10568),
    [anon_sym_PERCENT] = ACTIONS(10568),
    [sym_comment] = ACTIONS(87),
  },
  [9055] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10566),
    [sym__binary_star] = ACTIONS(10568),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(10570),
    [anon_sym_STAR_STAR] = ACTIONS(10568),
    [anon_sym_AMP] = ACTIONS(10572),
    [anon_sym_LT] = ACTIONS(10574),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(10584),
    [anon_sym_GT_GT] = ACTIONS(10584),
    [anon_sym_EQ_EQ] = ACTIONS(10586),
    [anon_sym_BANG_EQ] = ACTIONS(10582),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10582),
    [anon_sym_LT_EQ_GT] = ACTIONS(10582),
    [anon_sym_EQ_TILDE] = ACTIONS(10582),
    [anon_sym_BANG_TILDE] = ACTIONS(10582),
    [anon_sym_LT_EQ] = ACTIONS(10574),
    [anon_sym_GT] = ACTIONS(10574),
    [anon_sym_GT_EQ] = ACTIONS(10588),
    [anon_sym_CARET] = ACTIONS(10590),
    [anon_sym_PLUS] = ACTIONS(10566),
    [anon_sym_SLASH] = ACTIONS(10568),
    [anon_sym_PERCENT] = ACTIONS(10568),
    [sym_comment] = ACTIONS(87),
  },
  [9056] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10566),
    [sym__binary_star] = ACTIONS(10568),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(10568),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(10566),
    [anon_sym_SLASH] = ACTIONS(10568),
    [anon_sym_PERCENT] = ACTIONS(10568),
    [sym_comment] = ACTIONS(87),
  },
  [9057] = {
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(10566),
    [sym__binary_star] = ACTIONS(10568),
    [anon_sym_RPAREN] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(10570),
    [anon_sym_STAR_STAR] = ACTIONS(10568),
    [anon_sym_AMP] = ACTIONS(10572),
    [anon_sym_LT] = ACTIONS(10574),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(10576),
    [anon_sym_DOT_DOT] = ACTIONS(10578),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10580),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(10582),
    [anon_sym_AMP_AMP] = ACTIONS(10582),
    [anon_sym_LT_LT] = ACTIONS(10584),
    [anon_sym_GT_GT] = ACTIONS(10584),
    [anon_sym_EQ_EQ] = ACTIONS(10586),
    [anon_sym_BANG_EQ] = ACTIONS(10582),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10582),
    [anon_sym_LT_EQ_GT] = ACTIONS(10582),
    [anon_sym_EQ_TILDE] = ACTIONS(10582),
    [anon_sym_BANG_TILDE] = ACTIONS(10582),
    [anon_sym_LT_EQ] = ACTIONS(10574),
    [anon_sym_GT] = ACTIONS(10574),
    [anon_sym_GT_EQ] = ACTIONS(10588),
    [anon_sym_CARET] = ACTIONS(10590),
    [anon_sym_PLUS] = ACTIONS(10566),
    [anon_sym_SLASH] = ACTIONS(10568),
    [anon_sym_PERCENT] = ACTIONS(10568),
    [sym_comment] = ACTIONS(87),
  },
  [9058] = {
    [aux_sym_exceptions_repeat1] = STATE(10241),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_RPAREN] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [9059] = {
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(10566),
    [sym__binary_star] = ACTIONS(10568),
    [anon_sym_RPAREN] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(10570),
    [anon_sym_STAR_STAR] = ACTIONS(10568),
    [anon_sym_AMP] = ACTIONS(10572),
    [anon_sym_LT] = ACTIONS(10574),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(10576),
    [anon_sym_DOT_DOT] = ACTIONS(10578),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10580),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(10582),
    [anon_sym_AMP_AMP] = ACTIONS(10582),
    [anon_sym_LT_LT] = ACTIONS(10584),
    [anon_sym_GT_GT] = ACTIONS(10584),
    [anon_sym_EQ_EQ] = ACTIONS(10586),
    [anon_sym_BANG_EQ] = ACTIONS(10582),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10582),
    [anon_sym_LT_EQ_GT] = ACTIONS(10582),
    [anon_sym_EQ_TILDE] = ACTIONS(10582),
    [anon_sym_BANG_TILDE] = ACTIONS(10582),
    [anon_sym_LT_EQ] = ACTIONS(10574),
    [anon_sym_GT] = ACTIONS(10574),
    [anon_sym_GT_EQ] = ACTIONS(10588),
    [anon_sym_CARET] = ACTIONS(10590),
    [anon_sym_PLUS] = ACTIONS(10566),
    [anon_sym_SLASH] = ACTIONS(10568),
    [anon_sym_PERCENT] = ACTIONS(10568),
    [sym_comment] = ACTIONS(87),
  },
  [9060] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(10242),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2061),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(2061),
    [sym_assignment] = STATE(10242),
    [sym_operator_assignment] = STATE(10242),
    [sym_conditional] = STATE(10242),
    [sym_range] = STATE(10242),
    [sym_binary] = STATE(10242),
    [sym_unary] = STATE(10242),
    [sym_left_assignment_list] = STATE(2060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2061),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2061),
    [sym_false] = STATE(2061),
    [sym_nil] = STATE(2061),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2484),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7184),
    [anon_sym_defined_QMARK] = ACTIONS(3599),
    [anon_sym_not] = ACTIONS(3601),
    [anon_sym_BANG] = ACTIONS(3605),
    [anon_sym_TILDE] = ACTIONS(3605),
    [sym_constant] = ACTIONS(1621),
    [sym_identifier] = ACTIONS(1621),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9061] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(7019),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2061),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(2061),
    [sym_splat_argument] = STATE(9013),
    [sym_assignment] = STATE(7019),
    [sym_operator_assignment] = STATE(7019),
    [sym_conditional] = STATE(7019),
    [sym_range] = STATE(7019),
    [sym_binary] = STATE(7019),
    [sym_unary] = STATE(7019),
    [sym__arg_or_splat_arg] = STATE(9013),
    [sym_left_assignment_list] = STATE(2060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2061),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2061),
    [sym_false] = STATE(2061),
    [sym_nil] = STATE(2061),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(2484),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(4291),
    [sym__unary_minus] = ACTIONS(3595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7184),
    [anon_sym_defined_QMARK] = ACTIONS(3599),
    [anon_sym_not] = ACTIONS(3601),
    [anon_sym_BANG] = ACTIONS(3605),
    [anon_sym_TILDE] = ACTIONS(3605),
    [sym_constant] = ACTIONS(1621),
    [sym_identifier] = ACTIONS(1621),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9062] = {
    [aux_sym_exceptions_repeat1] = STATE(10243),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_RPAREN] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(13953),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_EQ_GT] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [9063] = {
    [sym__binary_minus] = ACTIONS(3609),
    [sym__binary_star] = ACTIONS(3611),
    [anon_sym_RPAREN] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(3615),
    [anon_sym_STAR_STAR] = ACTIONS(3611),
    [anon_sym_AMP] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3619),
    [anon_sym_QMARK] = ACTIONS(3621),
    [anon_sym_DOT_DOT] = ACTIONS(3623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3625),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(3629),
    [anon_sym_AMP_AMP] = ACTIONS(3629),
    [anon_sym_LT_LT] = ACTIONS(3631),
    [anon_sym_GT_GT] = ACTIONS(3631),
    [anon_sym_EQ_EQ] = ACTIONS(3633),
    [anon_sym_BANG_EQ] = ACTIONS(3629),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3629),
    [anon_sym_LT_EQ_GT] = ACTIONS(3629),
    [anon_sym_EQ_TILDE] = ACTIONS(3629),
    [anon_sym_BANG_TILDE] = ACTIONS(3629),
    [anon_sym_LT_EQ] = ACTIONS(3619),
    [anon_sym_GT] = ACTIONS(3619),
    [anon_sym_GT_EQ] = ACTIONS(3635),
    [anon_sym_CARET] = ACTIONS(3637),
    [anon_sym_PLUS] = ACTIONS(3609),
    [anon_sym_SLASH] = ACTIONS(3611),
    [anon_sym_PERCENT] = ACTIONS(3611),
    [sym_comment] = ACTIONS(87),
  },
  [9064] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(10604),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(10608),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(10608),
    [anon_sym_PERCENT] = ACTIONS(10608),
    [sym_comment] = ACTIONS(87),
  },
  [9065] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(10608),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(5827),
    [anon_sym_PERCENT] = ACTIONS(5827),
    [sym_comment] = ACTIONS(87),
  },
  [9066] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10602),
    [sym__binary_star] = ACTIONS(10604),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(10608),
    [anon_sym_AMP] = ACTIONS(10610),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(10622),
    [anon_sym_GT_GT] = ACTIONS(10622),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(10628),
    [anon_sym_SLASH] = ACTIONS(10608),
    [anon_sym_PERCENT] = ACTIONS(10608),
    [sym_comment] = ACTIONS(87),
  },
  [9067] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10602),
    [sym__binary_star] = ACTIONS(10604),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(10608),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(10622),
    [anon_sym_GT_GT] = ACTIONS(10622),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(10628),
    [anon_sym_SLASH] = ACTIONS(10608),
    [anon_sym_PERCENT] = ACTIONS(10608),
    [sym_comment] = ACTIONS(87),
  },
  [9068] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10602),
    [sym__binary_star] = ACTIONS(10604),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(10606),
    [anon_sym_STAR_STAR] = ACTIONS(10608),
    [anon_sym_AMP] = ACTIONS(10610),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(10622),
    [anon_sym_GT_GT] = ACTIONS(10622),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(10606),
    [anon_sym_PLUS] = ACTIONS(10628),
    [anon_sym_SLASH] = ACTIONS(10608),
    [anon_sym_PERCENT] = ACTIONS(10608),
    [sym_comment] = ACTIONS(87),
  },
  [9069] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(13955),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [9070] = {
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(10602),
    [sym__binary_star] = ACTIONS(10604),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_RPAREN] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(10606),
    [anon_sym_STAR_STAR] = ACTIONS(10608),
    [anon_sym_AMP] = ACTIONS(10610),
    [anon_sym_EQ] = ACTIONS(7888),
    [anon_sym_LT] = ACTIONS(10612),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_PLUS_EQ] = ACTIONS(5927),
    [anon_sym_DASH_EQ] = ACTIONS(5927),
    [anon_sym_STAR_EQ] = ACTIONS(5927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5927),
    [anon_sym_SLASH_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5927),
    [anon_sym_AMP_EQ] = ACTIONS(5927),
    [anon_sym_PERCENT_EQ] = ACTIONS(5927),
    [anon_sym_GT_GT_EQ] = ACTIONS(5927),
    [anon_sym_LT_LT_EQ] = ACTIONS(5927),
    [anon_sym_CARET_EQ] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(10616),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10618),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(10620),
    [anon_sym_AMP_AMP] = ACTIONS(10620),
    [anon_sym_LT_LT] = ACTIONS(10622),
    [anon_sym_GT_GT] = ACTIONS(10622),
    [anon_sym_EQ_EQ] = ACTIONS(10620),
    [anon_sym_BANG_EQ] = ACTIONS(10624),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10624),
    [anon_sym_LT_EQ_GT] = ACTIONS(10624),
    [anon_sym_EQ_TILDE] = ACTIONS(10624),
    [anon_sym_BANG_TILDE] = ACTIONS(10624),
    [anon_sym_LT_EQ] = ACTIONS(10612),
    [anon_sym_GT] = ACTIONS(10612),
    [anon_sym_GT_EQ] = ACTIONS(10626),
    [anon_sym_CARET] = ACTIONS(10606),
    [anon_sym_PLUS] = ACTIONS(10628),
    [anon_sym_SLASH] = ACTIONS(10608),
    [anon_sym_PERCENT] = ACTIONS(10608),
    [sym_comment] = ACTIONS(87),
  },
  [9071] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10602),
    [sym__binary_star] = ACTIONS(10604),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(10606),
    [anon_sym_STAR_STAR] = ACTIONS(10608),
    [anon_sym_AMP] = ACTIONS(10610),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(10612),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(10614),
    [anon_sym_DOT_DOT] = ACTIONS(10616),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10618),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(10620),
    [anon_sym_AMP_AMP] = ACTIONS(10620),
    [anon_sym_LT_LT] = ACTIONS(10622),
    [anon_sym_GT_GT] = ACTIONS(10622),
    [anon_sym_EQ_EQ] = ACTIONS(10620),
    [anon_sym_BANG_EQ] = ACTIONS(10624),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10624),
    [anon_sym_LT_EQ_GT] = ACTIONS(10624),
    [anon_sym_EQ_TILDE] = ACTIONS(10624),
    [anon_sym_BANG_TILDE] = ACTIONS(10624),
    [anon_sym_LT_EQ] = ACTIONS(10612),
    [anon_sym_GT] = ACTIONS(10612),
    [anon_sym_GT_EQ] = ACTIONS(10626),
    [anon_sym_CARET] = ACTIONS(10606),
    [anon_sym_PLUS] = ACTIONS(10628),
    [anon_sym_SLASH] = ACTIONS(10608),
    [anon_sym_PERCENT] = ACTIONS(10608),
    [sym_comment] = ACTIONS(87),
  },
  [9072] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10602),
    [sym__binary_star] = ACTIONS(10604),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(10606),
    [anon_sym_STAR_STAR] = ACTIONS(10608),
    [anon_sym_AMP] = ACTIONS(10610),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(10612),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(10622),
    [anon_sym_GT_GT] = ACTIONS(10622),
    [anon_sym_EQ_EQ] = ACTIONS(10620),
    [anon_sym_BANG_EQ] = ACTIONS(10624),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10624),
    [anon_sym_LT_EQ_GT] = ACTIONS(10624),
    [anon_sym_EQ_TILDE] = ACTIONS(10624),
    [anon_sym_BANG_TILDE] = ACTIONS(10624),
    [anon_sym_LT_EQ] = ACTIONS(10612),
    [anon_sym_GT] = ACTIONS(10612),
    [anon_sym_GT_EQ] = ACTIONS(10626),
    [anon_sym_CARET] = ACTIONS(10606),
    [anon_sym_PLUS] = ACTIONS(10628),
    [anon_sym_SLASH] = ACTIONS(10608),
    [anon_sym_PERCENT] = ACTIONS(10608),
    [sym_comment] = ACTIONS(87),
  },
  [9073] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10602),
    [sym__binary_star] = ACTIONS(10604),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(10608),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(10628),
    [anon_sym_SLASH] = ACTIONS(10608),
    [anon_sym_PERCENT] = ACTIONS(10608),
    [sym_comment] = ACTIONS(87),
  },
  [9074] = {
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(10602),
    [sym__binary_star] = ACTIONS(10604),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_RPAREN] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(10606),
    [anon_sym_STAR_STAR] = ACTIONS(10608),
    [anon_sym_AMP] = ACTIONS(10610),
    [anon_sym_EQ] = ACTIONS(7936),
    [anon_sym_LT] = ACTIONS(10612),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_PLUS_EQ] = ACTIONS(5115),
    [anon_sym_DASH_EQ] = ACTIONS(5115),
    [anon_sym_STAR_EQ] = ACTIONS(5115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5115),
    [anon_sym_SLASH_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5115),
    [anon_sym_AMP_EQ] = ACTIONS(5115),
    [anon_sym_PERCENT_EQ] = ACTIONS(5115),
    [anon_sym_GT_GT_EQ] = ACTIONS(5115),
    [anon_sym_LT_LT_EQ] = ACTIONS(5115),
    [anon_sym_CARET_EQ] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(10614),
    [anon_sym_DOT_DOT] = ACTIONS(10616),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10618),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(10620),
    [anon_sym_AMP_AMP] = ACTIONS(10620),
    [anon_sym_LT_LT] = ACTIONS(10622),
    [anon_sym_GT_GT] = ACTIONS(10622),
    [anon_sym_EQ_EQ] = ACTIONS(10620),
    [anon_sym_BANG_EQ] = ACTIONS(10624),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10624),
    [anon_sym_LT_EQ_GT] = ACTIONS(10624),
    [anon_sym_EQ_TILDE] = ACTIONS(10624),
    [anon_sym_BANG_TILDE] = ACTIONS(10624),
    [anon_sym_LT_EQ] = ACTIONS(10612),
    [anon_sym_GT] = ACTIONS(10612),
    [anon_sym_GT_EQ] = ACTIONS(10626),
    [anon_sym_CARET] = ACTIONS(10606),
    [anon_sym_PLUS] = ACTIONS(10628),
    [anon_sym_SLASH] = ACTIONS(10608),
    [anon_sym_PERCENT] = ACTIONS(10608),
    [sym_comment] = ACTIONS(87),
  },
  [9075] = {
    [aux_sym_exceptions_repeat1] = STATE(10246),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_RPAREN] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_STAR_STAR] = ACTIONS(6193),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_PLUS_EQ] = ACTIONS(6191),
    [anon_sym_DASH_EQ] = ACTIONS(6191),
    [anon_sym_STAR_EQ] = ACTIONS(6191),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6191),
    [anon_sym_SLASH_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6191),
    [anon_sym_AMP_EQ] = ACTIONS(6191),
    [anon_sym_PERCENT_EQ] = ACTIONS(6191),
    [anon_sym_GT_GT_EQ] = ACTIONS(6191),
    [anon_sym_LT_LT_EQ] = ACTIONS(6191),
    [anon_sym_CARET_EQ] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6193),
    [anon_sym_AMP_AMP] = ACTIONS(6193),
    [anon_sym_LT_LT] = ACTIONS(6193),
    [anon_sym_GT_GT] = ACTIONS(6193),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6193),
    [anon_sym_PLUS] = ACTIONS(6193),
    [anon_sym_SLASH] = ACTIONS(6193),
    [anon_sym_PERCENT] = ACTIONS(6193),
    [sym_comment] = ACTIONS(87),
  },
  [9076] = {
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(10602),
    [sym__binary_star] = ACTIONS(10604),
    [anon_sym_LBRACE] = ACTIONS(6210),
    [anon_sym_RPAREN] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(10606),
    [anon_sym_STAR_STAR] = ACTIONS(10608),
    [anon_sym_AMP] = ACTIONS(10610),
    [anon_sym_EQ] = ACTIONS(7938),
    [anon_sym_LT] = ACTIONS(10612),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_PLUS_EQ] = ACTIONS(6210),
    [anon_sym_DASH_EQ] = ACTIONS(6210),
    [anon_sym_STAR_EQ] = ACTIONS(6210),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6210),
    [anon_sym_SLASH_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6210),
    [anon_sym_AMP_EQ] = ACTIONS(6210),
    [anon_sym_PERCENT_EQ] = ACTIONS(6210),
    [anon_sym_GT_GT_EQ] = ACTIONS(6210),
    [anon_sym_LT_LT_EQ] = ACTIONS(6210),
    [anon_sym_CARET_EQ] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(10614),
    [anon_sym_DOT_DOT] = ACTIONS(10616),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10618),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(10620),
    [anon_sym_AMP_AMP] = ACTIONS(10620),
    [anon_sym_LT_LT] = ACTIONS(10622),
    [anon_sym_GT_GT] = ACTIONS(10622),
    [anon_sym_EQ_EQ] = ACTIONS(10620),
    [anon_sym_BANG_EQ] = ACTIONS(10624),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10624),
    [anon_sym_LT_EQ_GT] = ACTIONS(10624),
    [anon_sym_EQ_TILDE] = ACTIONS(10624),
    [anon_sym_BANG_TILDE] = ACTIONS(10624),
    [anon_sym_LT_EQ] = ACTIONS(10612),
    [anon_sym_GT] = ACTIONS(10612),
    [anon_sym_GT_EQ] = ACTIONS(10626),
    [anon_sym_CARET] = ACTIONS(10606),
    [anon_sym_PLUS] = ACTIONS(10628),
    [anon_sym_SLASH] = ACTIONS(10608),
    [anon_sym_PERCENT] = ACTIONS(10608),
    [sym_comment] = ACTIONS(87),
  },
  [9077] = {
    [sym_string] = STATE(9077),
    [aux_sym_chained_string_repeat1] = STATE(9077),
    [sym__string_start] = ACTIONS(13881),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_RPAREN] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_STAR_STAR] = ACTIONS(6217),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_EQ] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_do] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_PLUS_EQ] = ACTIONS(6212),
    [anon_sym_DASH_EQ] = ACTIONS(6212),
    [anon_sym_STAR_EQ] = ACTIONS(6212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6212),
    [anon_sym_SLASH_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6212),
    [anon_sym_AMP_EQ] = ACTIONS(6212),
    [anon_sym_PERCENT_EQ] = ACTIONS(6212),
    [anon_sym_GT_GT_EQ] = ACTIONS(6212),
    [anon_sym_LT_LT_EQ] = ACTIONS(6212),
    [anon_sym_CARET_EQ] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6217),
    [anon_sym_AMP_AMP] = ACTIONS(6217),
    [anon_sym_LT_LT] = ACTIONS(6217),
    [anon_sym_GT_GT] = ACTIONS(6217),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6217),
    [anon_sym_PLUS] = ACTIONS(6217),
    [anon_sym_SLASH] = ACTIONS(6217),
    [anon_sym_PERCENT] = ACTIONS(6217),
    [sym_comment] = ACTIONS(87),
  },
  [9078] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(10247),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2092),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2092),
    [sym_assignment] = STATE(10247),
    [sym_operator_assignment] = STATE(10247),
    [sym_conditional] = STATE(10247),
    [sym_range] = STATE(10247),
    [sym_binary] = STATE(10247),
    [sym_unary] = STATE(10247),
    [sym_left_assignment_list] = STATE(2091),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2092),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2092),
    [sym_false] = STATE(2092),
    [sym_nil] = STATE(2092),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4439),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3643),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3647),
    [anon_sym_yield] = ACTIONS(3649),
    [anon_sym_break] = ACTIONS(3651),
    [anon_sym_next] = ACTIONS(3653),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(7250),
    [anon_sym_defined_QMARK] = ACTIONS(3655),
    [anon_sym_not] = ACTIONS(3657),
    [anon_sym_BANG] = ACTIONS(3661),
    [anon_sym_TILDE] = ACTIONS(3661),
    [sym_constant] = ACTIONS(3667),
    [sym_identifier] = ACTIONS(3667),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [9079] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(7055),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2092),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2092),
    [sym_splat_argument] = STATE(9044),
    [sym_assignment] = STATE(7055),
    [sym_operator_assignment] = STATE(7055),
    [sym_conditional] = STATE(7055),
    [sym_range] = STATE(7055),
    [sym_binary] = STATE(7055),
    [sym_unary] = STATE(7055),
    [sym__arg_or_splat_arg] = STATE(9044),
    [sym_left_assignment_list] = STATE(2091),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2092),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2092),
    [sym_false] = STATE(2092),
    [sym_nil] = STATE(2092),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4439),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__splat_star] = ACTIONS(4329),
    [sym__unary_minus] = ACTIONS(3643),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3647),
    [anon_sym_yield] = ACTIONS(3649),
    [anon_sym_break] = ACTIONS(3651),
    [anon_sym_next] = ACTIONS(3653),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(7250),
    [anon_sym_defined_QMARK] = ACTIONS(3655),
    [anon_sym_not] = ACTIONS(3657),
    [anon_sym_BANG] = ACTIONS(3661),
    [anon_sym_TILDE] = ACTIONS(3661),
    [sym_constant] = ACTIONS(3667),
    [sym_identifier] = ACTIONS(3667),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [9080] = {
    [aux_sym_exceptions_repeat1] = STATE(10248),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_LBRACE] = ACTIONS(9855),
    [anon_sym_RPAREN] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(13957),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_STAR_STAR] = ACTIONS(9857),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_EQ] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_do] = ACTIONS(9855),
    [anon_sym_EQ_GT] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_PLUS_EQ] = ACTIONS(9855),
    [anon_sym_DASH_EQ] = ACTIONS(9855),
    [anon_sym_STAR_EQ] = ACTIONS(9855),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9855),
    [anon_sym_SLASH_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9855),
    [anon_sym_AMP_EQ] = ACTIONS(9855),
    [anon_sym_PERCENT_EQ] = ACTIONS(9855),
    [anon_sym_GT_GT_EQ] = ACTIONS(9855),
    [anon_sym_LT_LT_EQ] = ACTIONS(9855),
    [anon_sym_CARET_EQ] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9857),
    [anon_sym_AMP_AMP] = ACTIONS(9857),
    [anon_sym_LT_LT] = ACTIONS(9857),
    [anon_sym_GT_GT] = ACTIONS(9857),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9857),
    [anon_sym_PLUS] = ACTIONS(9857),
    [anon_sym_SLASH] = ACTIONS(9857),
    [anon_sym_PERCENT] = ACTIONS(9857),
    [sym_comment] = ACTIONS(87),
  },
  [9081] = {
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(10640),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(10640),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(10640),
    [anon_sym_PERCENT] = ACTIONS(10640),
    [sym_comment] = ACTIONS(87),
  },
  [9082] = {
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(10640),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [9083] = {
    [sym__binary_minus] = ACTIONS(10638),
    [sym__binary_star] = ACTIONS(10640),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(10640),
    [anon_sym_AMP] = ACTIONS(10644),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(10656),
    [anon_sym_GT_GT] = ACTIONS(10656),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(10638),
    [anon_sym_SLASH] = ACTIONS(10640),
    [anon_sym_PERCENT] = ACTIONS(10640),
    [sym_comment] = ACTIONS(87),
  },
  [9084] = {
    [sym__binary_minus] = ACTIONS(10638),
    [sym__binary_star] = ACTIONS(10640),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(10640),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(10656),
    [anon_sym_GT_GT] = ACTIONS(10656),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(10638),
    [anon_sym_SLASH] = ACTIONS(10640),
    [anon_sym_PERCENT] = ACTIONS(10640),
    [sym_comment] = ACTIONS(87),
  },
  [9085] = {
    [sym__binary_minus] = ACTIONS(10638),
    [sym__binary_star] = ACTIONS(10640),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(10642),
    [anon_sym_STAR_STAR] = ACTIONS(10640),
    [anon_sym_AMP] = ACTIONS(10644),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(10656),
    [anon_sym_GT_GT] = ACTIONS(10656),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(10662),
    [anon_sym_PLUS] = ACTIONS(10638),
    [anon_sym_SLASH] = ACTIONS(10640),
    [anon_sym_PERCENT] = ACTIONS(10640),
    [sym_comment] = ACTIONS(87),
  },
  [9086] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(13959),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [9087] = {
    [sym__binary_minus] = ACTIONS(10638),
    [sym__binary_star] = ACTIONS(10640),
    [anon_sym_RPAREN] = ACTIONS(5927),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(10642),
    [anon_sym_STAR_STAR] = ACTIONS(10640),
    [anon_sym_AMP] = ACTIONS(10644),
    [anon_sym_LT] = ACTIONS(10646),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(10650),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10652),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(10654),
    [anon_sym_AMP_AMP] = ACTIONS(10654),
    [anon_sym_LT_LT] = ACTIONS(10656),
    [anon_sym_GT_GT] = ACTIONS(10656),
    [anon_sym_EQ_EQ] = ACTIONS(10658),
    [anon_sym_BANG_EQ] = ACTIONS(10654),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10654),
    [anon_sym_LT_EQ_GT] = ACTIONS(10654),
    [anon_sym_EQ_TILDE] = ACTIONS(10654),
    [anon_sym_BANG_TILDE] = ACTIONS(10654),
    [anon_sym_LT_EQ] = ACTIONS(10646),
    [anon_sym_GT] = ACTIONS(10646),
    [anon_sym_GT_EQ] = ACTIONS(10660),
    [anon_sym_CARET] = ACTIONS(10662),
    [anon_sym_PLUS] = ACTIONS(10638),
    [anon_sym_SLASH] = ACTIONS(10640),
    [anon_sym_PERCENT] = ACTIONS(10640),
    [sym_comment] = ACTIONS(87),
  },
  [9088] = {
    [sym__binary_minus] = ACTIONS(10638),
    [sym__binary_star] = ACTIONS(10640),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(10642),
    [anon_sym_STAR_STAR] = ACTIONS(10640),
    [anon_sym_AMP] = ACTIONS(10644),
    [anon_sym_LT] = ACTIONS(10646),
    [anon_sym_QMARK] = ACTIONS(10648),
    [anon_sym_DOT_DOT] = ACTIONS(10650),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10652),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(10654),
    [anon_sym_AMP_AMP] = ACTIONS(10654),
    [anon_sym_LT_LT] = ACTIONS(10656),
    [anon_sym_GT_GT] = ACTIONS(10656),
    [anon_sym_EQ_EQ] = ACTIONS(10658),
    [anon_sym_BANG_EQ] = ACTIONS(10654),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10654),
    [anon_sym_LT_EQ_GT] = ACTIONS(10654),
    [anon_sym_EQ_TILDE] = ACTIONS(10654),
    [anon_sym_BANG_TILDE] = ACTIONS(10654),
    [anon_sym_LT_EQ] = ACTIONS(10646),
    [anon_sym_GT] = ACTIONS(10646),
    [anon_sym_GT_EQ] = ACTIONS(10660),
    [anon_sym_CARET] = ACTIONS(10662),
    [anon_sym_PLUS] = ACTIONS(10638),
    [anon_sym_SLASH] = ACTIONS(10640),
    [anon_sym_PERCENT] = ACTIONS(10640),
    [sym_comment] = ACTIONS(87),
  },
  [9089] = {
    [sym__binary_minus] = ACTIONS(10638),
    [sym__binary_star] = ACTIONS(10640),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(10642),
    [anon_sym_STAR_STAR] = ACTIONS(10640),
    [anon_sym_AMP] = ACTIONS(10644),
    [anon_sym_LT] = ACTIONS(10646),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(10656),
    [anon_sym_GT_GT] = ACTIONS(10656),
    [anon_sym_EQ_EQ] = ACTIONS(10658),
    [anon_sym_BANG_EQ] = ACTIONS(10654),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10654),
    [anon_sym_LT_EQ_GT] = ACTIONS(10654),
    [anon_sym_EQ_TILDE] = ACTIONS(10654),
    [anon_sym_BANG_TILDE] = ACTIONS(10654),
    [anon_sym_LT_EQ] = ACTIONS(10646),
    [anon_sym_GT] = ACTIONS(10646),
    [anon_sym_GT_EQ] = ACTIONS(10660),
    [anon_sym_CARET] = ACTIONS(10662),
    [anon_sym_PLUS] = ACTIONS(10638),
    [anon_sym_SLASH] = ACTIONS(10640),
    [anon_sym_PERCENT] = ACTIONS(10640),
    [sym_comment] = ACTIONS(87),
  },
  [9090] = {
    [sym__binary_minus] = ACTIONS(10638),
    [sym__binary_star] = ACTIONS(10640),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(10640),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(10638),
    [anon_sym_SLASH] = ACTIONS(10640),
    [anon_sym_PERCENT] = ACTIONS(10640),
    [sym_comment] = ACTIONS(87),
  },
  [9091] = {
    [aux_sym_exceptions_repeat1] = STATE(9091),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_RPAREN] = ACTIONS(11597),
    [anon_sym_COMMA] = ACTIONS(13961),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [9092] = {
    [aux_sym_exceptions_repeat1] = STATE(7073),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_RPAREN] = ACTIONS(6191),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [9093] = {
    [sym__binary_minus] = ACTIONS(10638),
    [sym__binary_star] = ACTIONS(10640),
    [anon_sym_RPAREN] = ACTIONS(6210),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(10642),
    [anon_sym_STAR_STAR] = ACTIONS(10640),
    [anon_sym_AMP] = ACTIONS(10644),
    [anon_sym_LT] = ACTIONS(10646),
    [anon_sym_QMARK] = ACTIONS(10648),
    [anon_sym_DOT_DOT] = ACTIONS(10650),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10652),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(10654),
    [anon_sym_AMP_AMP] = ACTIONS(10654),
    [anon_sym_LT_LT] = ACTIONS(10656),
    [anon_sym_GT_GT] = ACTIONS(10656),
    [anon_sym_EQ_EQ] = ACTIONS(10658),
    [anon_sym_BANG_EQ] = ACTIONS(10654),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10654),
    [anon_sym_LT_EQ_GT] = ACTIONS(10654),
    [anon_sym_EQ_TILDE] = ACTIONS(10654),
    [anon_sym_BANG_TILDE] = ACTIONS(10654),
    [anon_sym_LT_EQ] = ACTIONS(10646),
    [anon_sym_GT] = ACTIONS(10646),
    [anon_sym_GT_EQ] = ACTIONS(10660),
    [anon_sym_CARET] = ACTIONS(10662),
    [anon_sym_PLUS] = ACTIONS(10638),
    [anon_sym_SLASH] = ACTIONS(10640),
    [anon_sym_PERCENT] = ACTIONS(10640),
    [sym_comment] = ACTIONS(87),
  },
  [9094] = {
    [sym_string] = STATE(9094),
    [aux_sym_chained_string_repeat1] = STATE(9094),
    [sym__string_start] = ACTIONS(7159),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_RPAREN] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [9095] = {
    [sym__simple_symbol] = ACTIONS(13964),
    [sym__string_start] = ACTIONS(13964),
    [sym__symbol_start] = ACTIONS(13964),
    [sym__subshell_start] = ACTIONS(13964),
    [sym__regex_start] = ACTIONS(13964),
    [sym__string_array_start] = ACTIONS(13964),
    [sym__symbol_array_start] = ACTIONS(13964),
    [sym_heredoc_beginning] = ACTIONS(13964),
    [sym__unary_minus] = ACTIONS(13964),
    [anon_sym_BEGIN] = ACTIONS(13966),
    [anon_sym_LBRACE] = ACTIONS(13964),
    [anon_sym_END] = ACTIONS(13966),
    [anon_sym_def] = ACTIONS(13966),
    [anon_sym_LPAREN] = ACTIONS(13964),
    [anon_sym_COLON_COLON] = ACTIONS(13964),
    [anon_sym_SEMI] = ACTIONS(13964),
    [anon_sym_STAR] = ACTIONS(13964),
    [anon_sym_class] = ACTIONS(13966),
    [anon_sym_module] = ACTIONS(13966),
    [anon_sym_end] = ACTIONS(13966),
    [anon_sym_return] = ACTIONS(13966),
    [anon_sym_yield] = ACTIONS(13966),
    [anon_sym_break] = ACTIONS(13966),
    [anon_sym_next] = ACTIONS(13966),
    [sym_redo] = ACTIONS(13966),
    [sym_retry] = ACTIONS(13966),
    [anon_sym_if] = ACTIONS(13966),
    [anon_sym_unless] = ACTIONS(13966),
    [anon_sym_while] = ACTIONS(13966),
    [anon_sym_until] = ACTIONS(13966),
    [anon_sym_rescue] = ACTIONS(13966),
    [anon_sym_for] = ACTIONS(13966),
    [anon_sym_case] = ACTIONS(13966),
    [anon_sym_else] = ACTIONS(13966),
    [anon_sym_begin] = ACTIONS(13966),
    [anon_sym_ensure] = ACTIONS(13966),
    [anon_sym_PLUS] = ACTIONS(13966),
    [anon_sym_defined_QMARK] = ACTIONS(13964),
    [anon_sym_not] = ACTIONS(13966),
    [anon_sym_BANG] = ACTIONS(13964),
    [anon_sym_TILDE] = ACTIONS(13964),
    [sym_constant] = ACTIONS(13966),
    [sym_identifier] = ACTIONS(13966),
    [sym_instance_variable] = ACTIONS(13964),
    [sym_class_variable] = ACTIONS(13964),
    [sym_global_variable] = ACTIONS(13964),
    [anon_sym_undef] = ACTIONS(13966),
    [anon_sym_alias] = ACTIONS(13966),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(13966),
    [sym_float] = ACTIONS(13966),
    [sym_complex] = ACTIONS(13964),
    [sym_super] = ACTIONS(13966),
    [anon_sym_true] = ACTIONS(13966),
    [anon_sym_TRUE] = ACTIONS(13966),
    [anon_sym_false] = ACTIONS(13966),
    [anon_sym_FALSE] = ACTIONS(13966),
    [sym_self] = ACTIONS(13966),
    [anon_sym_nil] = ACTIONS(13966),
    [anon_sym_NIL] = ACTIONS(13966),
    [sym_character] = ACTIONS(13964),
    [anon_sym_LBRACK2] = ACTIONS(13964),
    [anon_sym_DASH_GT] = ACTIONS(13964),
  },
  [9096] = {
    [sym__line_break] = ACTIONS(9426),
    [sym__heredoc_body_start] = ACTIONS(9426),
    [anon_sym_DOT] = ACTIONS(9426),
    [anon_sym_COMMA] = ACTIONS(9426),
    [anon_sym_SEMI] = ACTIONS(9426),
    [anon_sym_then] = ACTIONS(9426),
    [anon_sym_LBRACK] = ACTIONS(9426),
    [anon_sym_COLON_COLON2] = ACTIONS(9426),
    [anon_sym_AMP_DOT] = ACTIONS(9426),
    [sym_comment] = ACTIONS(87),
  },
  [9097] = {
    [anon_sym_RBRACE] = ACTIONS(13968),
    [sym_comment] = ACTIONS(87),
  },
  [9098] = {
    [sym__line_break] = ACTIONS(9446),
    [sym__heredoc_body_start] = ACTIONS(9446),
    [anon_sym_DOT] = ACTIONS(9446),
    [anon_sym_COMMA] = ACTIONS(9446),
    [anon_sym_SEMI] = ACTIONS(9446),
    [anon_sym_then] = ACTIONS(9446),
    [anon_sym_LBRACK] = ACTIONS(9446),
    [anon_sym_COLON_COLON2] = ACTIONS(9446),
    [anon_sym_AMP_DOT] = ACTIONS(9446),
    [sym_comment] = ACTIONS(87),
  },
  [9099] = {
    [anon_sym_end] = ACTIONS(13970),
    [sym_comment] = ACTIONS(87),
  },
  [9100] = {
    [sym__statements] = STATE(10252),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13972),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9101] = {
    [sym__statements] = STATE(10252),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_heredoc_body] = STATE(10253),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [sym__terminator] = STATE(10253),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__line_break] = ACTIONS(13974),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(13974),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13972),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9102] = {
    [sym__line_break] = ACTIONS(12033),
    [sym__heredoc_body_start] = ACTIONS(12033),
    [anon_sym_COMMA] = ACTIONS(12033),
    [anon_sym_SEMI] = ACTIONS(12033),
    [sym_comment] = ACTIONS(87),
  },
  [9103] = {
    [aux_sym_method_parameters_repeat1] = STATE(6108),
    [anon_sym_RPAREN] = ACTIONS(13976),
    [anon_sym_COMMA] = ACTIONS(5757),
    [sym_comment] = ACTIONS(87),
  },
  [9104] = {
    [sym__line_break] = ACTIONS(12039),
    [sym__heredoc_body_start] = ACTIONS(12039),
    [anon_sym_COMMA] = ACTIONS(12039),
    [anon_sym_SEMI] = ACTIONS(12039),
    [sym_comment] = ACTIONS(87),
  },
  [9105] = {
    [aux_sym_method_parameters_repeat1] = STATE(9105),
    [sym__line_break] = ACTIONS(12039),
    [sym__heredoc_body_start] = ACTIONS(12039),
    [anon_sym_COMMA] = ACTIONS(13978),
    [anon_sym_SEMI] = ACTIONS(12039),
    [sym_comment] = ACTIONS(87),
  },
  [9106] = {
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(10700),
    [sym__binary_star] = ACTIONS(10702),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_RPAREN] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(10704),
    [anon_sym_STAR_STAR] = ACTIONS(10702),
    [anon_sym_AMP] = ACTIONS(10706),
    [anon_sym_EQ] = ACTIONS(4217),
    [anon_sym_LT] = ACTIONS(10708),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(10710),
    [anon_sym_DOT_DOT] = ACTIONS(10712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10714),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(10718),
    [anon_sym_AMP_AMP] = ACTIONS(10718),
    [anon_sym_LT_LT] = ACTIONS(10720),
    [anon_sym_GT_GT] = ACTIONS(10720),
    [anon_sym_EQ_EQ] = ACTIONS(10722),
    [anon_sym_BANG_EQ] = ACTIONS(10718),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10718),
    [anon_sym_LT_EQ_GT] = ACTIONS(10718),
    [anon_sym_EQ_TILDE] = ACTIONS(10718),
    [anon_sym_BANG_TILDE] = ACTIONS(10718),
    [anon_sym_LT_EQ] = ACTIONS(10708),
    [anon_sym_GT] = ACTIONS(10708),
    [anon_sym_GT_EQ] = ACTIONS(10724),
    [anon_sym_CARET] = ACTIONS(10726),
    [anon_sym_PLUS] = ACTIONS(10700),
    [anon_sym_SLASH] = ACTIONS(10702),
    [anon_sym_PERCENT] = ACTIONS(10702),
    [sym_comment] = ACTIONS(87),
  },
  [9107] = {
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(10700),
    [sym__binary_star] = ACTIONS(10702),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_RPAREN] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(10704),
    [anon_sym_STAR_STAR] = ACTIONS(10702),
    [anon_sym_AMP] = ACTIONS(10706),
    [anon_sym_EQ] = ACTIONS(4249),
    [anon_sym_LT] = ACTIONS(10708),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(10710),
    [anon_sym_DOT_DOT] = ACTIONS(10712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10714),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(10718),
    [anon_sym_AMP_AMP] = ACTIONS(10718),
    [anon_sym_LT_LT] = ACTIONS(10720),
    [anon_sym_GT_GT] = ACTIONS(10720),
    [anon_sym_EQ_EQ] = ACTIONS(10722),
    [anon_sym_BANG_EQ] = ACTIONS(10718),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10718),
    [anon_sym_LT_EQ_GT] = ACTIONS(10718),
    [anon_sym_EQ_TILDE] = ACTIONS(10718),
    [anon_sym_BANG_TILDE] = ACTIONS(10718),
    [anon_sym_LT_EQ] = ACTIONS(10708),
    [anon_sym_GT] = ACTIONS(10708),
    [anon_sym_GT_EQ] = ACTIONS(10724),
    [anon_sym_CARET] = ACTIONS(10726),
    [anon_sym_PLUS] = ACTIONS(10700),
    [anon_sym_SLASH] = ACTIONS(10702),
    [anon_sym_PERCENT] = ACTIONS(10702),
    [sym_comment] = ACTIONS(87),
  },
  [9108] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(10255),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4495),
    [sym_scope_resolution] = STATE(4433),
    [sym_call] = STATE(4433),
    [sym_method_call] = STATE(4495),
    [sym_assignment] = STATE(10255),
    [sym_operator_assignment] = STATE(10255),
    [sym_conditional] = STATE(10255),
    [sym_range] = STATE(10255),
    [sym_binary] = STATE(10255),
    [sym_unary] = STATE(10255),
    [sym_left_assignment_list] = STATE(4494),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4495),
    [sym__variable] = STATE(4433),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4495),
    [sym_false] = STATE(4495),
    [sym_nil] = STATE(4495),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(4496),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(4005),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(4009),
    [sym__subshell_start] = ACTIONS(4011),
    [sym__regex_start] = ACTIONS(4013),
    [sym__string_array_start] = ACTIONS(4015),
    [sym__symbol_array_start] = ACTIONS(4017),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7336),
    [anon_sym_LBRACE] = ACTIONS(4021),
    [anon_sym_def] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4025),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(4027),
    [anon_sym_module] = ACTIONS(4029),
    [anon_sym_return] = ACTIONS(7338),
    [anon_sym_yield] = ACTIONS(7340),
    [anon_sym_break] = ACTIONS(7342),
    [anon_sym_next] = ACTIONS(7344),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(4039),
    [anon_sym_unless] = ACTIONS(4041),
    [anon_sym_while] = ACTIONS(4043),
    [anon_sym_until] = ACTIONS(4045),
    [anon_sym_for] = ACTIONS(4047),
    [anon_sym_case] = ACTIONS(4049),
    [anon_sym_begin] = ACTIONS(4051),
    [anon_sym_PLUS] = ACTIONS(7346),
    [anon_sym_defined_QMARK] = ACTIONS(7348),
    [anon_sym_not] = ACTIONS(7350),
    [anon_sym_BANG] = ACTIONS(7352),
    [anon_sym_TILDE] = ACTIONS(7352),
    [sym_constant] = ACTIONS(7246),
    [sym_identifier] = ACTIONS(7246),
    [sym_instance_variable] = ACTIONS(7248),
    [sym_class_variable] = ACTIONS(7248),
    [sym_global_variable] = ACTIONS(7248),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4065),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(7246),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(7246),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(4067),
    [anon_sym_DASH_GT] = ACTIONS(4069),
  },
  [9109] = {
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(10700),
    [sym__binary_star] = ACTIONS(10702),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_RPAREN] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(10704),
    [anon_sym_STAR_STAR] = ACTIONS(10702),
    [anon_sym_AMP] = ACTIONS(10706),
    [anon_sym_EQ] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(10708),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(10710),
    [anon_sym_DOT_DOT] = ACTIONS(10712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10714),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(10718),
    [anon_sym_AMP_AMP] = ACTIONS(10718),
    [anon_sym_LT_LT] = ACTIONS(10720),
    [anon_sym_GT_GT] = ACTIONS(10720),
    [anon_sym_EQ_EQ] = ACTIONS(10722),
    [anon_sym_BANG_EQ] = ACTIONS(10718),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10718),
    [anon_sym_LT_EQ_GT] = ACTIONS(10718),
    [anon_sym_EQ_TILDE] = ACTIONS(10718),
    [anon_sym_BANG_TILDE] = ACTIONS(10718),
    [anon_sym_LT_EQ] = ACTIONS(10708),
    [anon_sym_GT] = ACTIONS(10708),
    [anon_sym_GT_EQ] = ACTIONS(10724),
    [anon_sym_CARET] = ACTIONS(10726),
    [anon_sym_PLUS] = ACTIONS(10700),
    [anon_sym_SLASH] = ACTIONS(10702),
    [anon_sym_PERCENT] = ACTIONS(10702),
    [sym_comment] = ACTIONS(87),
  },
  [9110] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(10256),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4495),
    [sym_scope_resolution] = STATE(4433),
    [sym_call] = STATE(4433),
    [sym_method_call] = STATE(4495),
    [sym_assignment] = STATE(10256),
    [sym_operator_assignment] = STATE(10256),
    [sym_conditional] = STATE(10256),
    [sym_range] = STATE(10256),
    [sym_binary] = STATE(10256),
    [sym_unary] = STATE(10256),
    [sym_left_assignment_list] = STATE(4494),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4495),
    [sym__variable] = STATE(4433),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4495),
    [sym_false] = STATE(4495),
    [sym_nil] = STATE(4495),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(4496),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(4005),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(4009),
    [sym__subshell_start] = ACTIONS(4011),
    [sym__regex_start] = ACTIONS(4013),
    [sym__string_array_start] = ACTIONS(4015),
    [sym__symbol_array_start] = ACTIONS(4017),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7336),
    [anon_sym_LBRACE] = ACTIONS(4021),
    [anon_sym_def] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4025),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(4027),
    [anon_sym_module] = ACTIONS(4029),
    [anon_sym_return] = ACTIONS(7338),
    [anon_sym_yield] = ACTIONS(7340),
    [anon_sym_break] = ACTIONS(7342),
    [anon_sym_next] = ACTIONS(7344),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(4039),
    [anon_sym_unless] = ACTIONS(4041),
    [anon_sym_while] = ACTIONS(4043),
    [anon_sym_until] = ACTIONS(4045),
    [anon_sym_for] = ACTIONS(4047),
    [anon_sym_case] = ACTIONS(4049),
    [anon_sym_begin] = ACTIONS(4051),
    [anon_sym_PLUS] = ACTIONS(7346),
    [anon_sym_defined_QMARK] = ACTIONS(7348),
    [anon_sym_not] = ACTIONS(7350),
    [anon_sym_BANG] = ACTIONS(7352),
    [anon_sym_TILDE] = ACTIONS(7352),
    [sym_constant] = ACTIONS(7246),
    [sym_identifier] = ACTIONS(7246),
    [sym_instance_variable] = ACTIONS(7248),
    [sym_class_variable] = ACTIONS(7248),
    [sym_global_variable] = ACTIONS(7248),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4065),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(7246),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(7246),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(4067),
    [anon_sym_DASH_GT] = ACTIONS(4069),
  },
  [9111] = {
    [sym_heredoc_body] = STATE(10257),
    [aux_sym_call_repeat1] = STATE(10257),
    [sym__heredoc_body_start] = ACTIONS(10884),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_RPAREN] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [9112] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(7096),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2125),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2125),
    [sym__argument] = STATE(9215),
    [sym_splat_argument] = STATE(9215),
    [sym_hash_splat_argument] = STATE(9215),
    [sym_block_argument] = STATE(9215),
    [sym_assignment] = STATE(7096),
    [sym_operator_assignment] = STATE(7096),
    [sym_conditional] = STATE(7096),
    [sym_range] = STATE(7096),
    [sym_binary] = STATE(7096),
    [sym_unary] = STATE(7096),
    [sym_left_assignment_list] = STATE(2124),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2125),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2125),
    [sym_false] = STATE(2125),
    [sym_nil] = STATE(2125),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(7099),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_heredoc_body] = STATE(10258),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(9215),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(10692),
    [sym__splat_star] = ACTIONS(10694),
    [sym__unary_minus] = ACTIONS(3705),
    [sym__identifier_hash_key] = ACTIONS(10696),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13981),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3713),
    [anon_sym_break] = ACTIONS(3715),
    [anon_sym_next] = ACTIONS(3717),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3719),
    [anon_sym_defined_QMARK] = ACTIONS(3721),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [sym_constant] = ACTIONS(10698),
    [sym_identifier] = ACTIONS(10698),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9113] = {
    [sym_heredoc_body] = STATE(10259),
    [aux_sym_call_repeat1] = STATE(10259),
    [aux_sym_argument_list_repeat1] = STATE(10260),
    [sym__heredoc_body_start] = ACTIONS(10884),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_RPAREN] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(12692),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [9114] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(10702),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(10702),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(10702),
    [anon_sym_PERCENT] = ACTIONS(10702),
    [sym_comment] = ACTIONS(87),
  },
  [9115] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(10702),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [9116] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10700),
    [sym__binary_star] = ACTIONS(10702),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(10702),
    [anon_sym_AMP] = ACTIONS(10706),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(10720),
    [anon_sym_GT_GT] = ACTIONS(10720),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(10700),
    [anon_sym_SLASH] = ACTIONS(10702),
    [anon_sym_PERCENT] = ACTIONS(10702),
    [sym_comment] = ACTIONS(87),
  },
  [9117] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10700),
    [sym__binary_star] = ACTIONS(10702),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(10702),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(10720),
    [anon_sym_GT_GT] = ACTIONS(10720),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(10700),
    [anon_sym_SLASH] = ACTIONS(10702),
    [anon_sym_PERCENT] = ACTIONS(10702),
    [sym_comment] = ACTIONS(87),
  },
  [9118] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10700),
    [sym__binary_star] = ACTIONS(10702),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(10704),
    [anon_sym_STAR_STAR] = ACTIONS(10702),
    [anon_sym_AMP] = ACTIONS(10706),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(10720),
    [anon_sym_GT_GT] = ACTIONS(10720),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(10726),
    [anon_sym_PLUS] = ACTIONS(10700),
    [anon_sym_SLASH] = ACTIONS(10702),
    [anon_sym_PERCENT] = ACTIONS(10702),
    [sym_comment] = ACTIONS(87),
  },
  [9119] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(13983),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [9120] = {
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(10700),
    [sym__binary_star] = ACTIONS(10702),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_RPAREN] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(10704),
    [anon_sym_STAR_STAR] = ACTIONS(10702),
    [anon_sym_AMP] = ACTIONS(10706),
    [anon_sym_EQ] = ACTIONS(7888),
    [anon_sym_LT] = ACTIONS(10708),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(10712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10714),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(10718),
    [anon_sym_AMP_AMP] = ACTIONS(10718),
    [anon_sym_LT_LT] = ACTIONS(10720),
    [anon_sym_GT_GT] = ACTIONS(10720),
    [anon_sym_EQ_EQ] = ACTIONS(10722),
    [anon_sym_BANG_EQ] = ACTIONS(10718),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10718),
    [anon_sym_LT_EQ_GT] = ACTIONS(10718),
    [anon_sym_EQ_TILDE] = ACTIONS(10718),
    [anon_sym_BANG_TILDE] = ACTIONS(10718),
    [anon_sym_LT_EQ] = ACTIONS(10708),
    [anon_sym_GT] = ACTIONS(10708),
    [anon_sym_GT_EQ] = ACTIONS(10724),
    [anon_sym_CARET] = ACTIONS(10726),
    [anon_sym_PLUS] = ACTIONS(10700),
    [anon_sym_SLASH] = ACTIONS(10702),
    [anon_sym_PERCENT] = ACTIONS(10702),
    [sym_comment] = ACTIONS(87),
  },
  [9121] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10700),
    [sym__binary_star] = ACTIONS(10702),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(10704),
    [anon_sym_STAR_STAR] = ACTIONS(10702),
    [anon_sym_AMP] = ACTIONS(10706),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(10708),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(10710),
    [anon_sym_DOT_DOT] = ACTIONS(10712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10714),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(10718),
    [anon_sym_AMP_AMP] = ACTIONS(10718),
    [anon_sym_LT_LT] = ACTIONS(10720),
    [anon_sym_GT_GT] = ACTIONS(10720),
    [anon_sym_EQ_EQ] = ACTIONS(10722),
    [anon_sym_BANG_EQ] = ACTIONS(10718),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10718),
    [anon_sym_LT_EQ_GT] = ACTIONS(10718),
    [anon_sym_EQ_TILDE] = ACTIONS(10718),
    [anon_sym_BANG_TILDE] = ACTIONS(10718),
    [anon_sym_LT_EQ] = ACTIONS(10708),
    [anon_sym_GT] = ACTIONS(10708),
    [anon_sym_GT_EQ] = ACTIONS(10724),
    [anon_sym_CARET] = ACTIONS(10726),
    [anon_sym_PLUS] = ACTIONS(10700),
    [anon_sym_SLASH] = ACTIONS(10702),
    [anon_sym_PERCENT] = ACTIONS(10702),
    [sym_comment] = ACTIONS(87),
  },
  [9122] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10700),
    [sym__binary_star] = ACTIONS(10702),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(10704),
    [anon_sym_STAR_STAR] = ACTIONS(10702),
    [anon_sym_AMP] = ACTIONS(10706),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(10708),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(10720),
    [anon_sym_GT_GT] = ACTIONS(10720),
    [anon_sym_EQ_EQ] = ACTIONS(10722),
    [anon_sym_BANG_EQ] = ACTIONS(10718),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10718),
    [anon_sym_LT_EQ_GT] = ACTIONS(10718),
    [anon_sym_EQ_TILDE] = ACTIONS(10718),
    [anon_sym_BANG_TILDE] = ACTIONS(10718),
    [anon_sym_LT_EQ] = ACTIONS(10708),
    [anon_sym_GT] = ACTIONS(10708),
    [anon_sym_GT_EQ] = ACTIONS(10724),
    [anon_sym_CARET] = ACTIONS(10726),
    [anon_sym_PLUS] = ACTIONS(10700),
    [anon_sym_SLASH] = ACTIONS(10702),
    [anon_sym_PERCENT] = ACTIONS(10702),
    [sym_comment] = ACTIONS(87),
  },
  [9123] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(10700),
    [sym__binary_star] = ACTIONS(10702),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(10702),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(10700),
    [anon_sym_SLASH] = ACTIONS(10702),
    [anon_sym_PERCENT] = ACTIONS(10702),
    [sym_comment] = ACTIONS(87),
  },
  [9124] = {
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(10700),
    [sym__binary_star] = ACTIONS(10702),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_RPAREN] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(10704),
    [anon_sym_STAR_STAR] = ACTIONS(10702),
    [anon_sym_AMP] = ACTIONS(10706),
    [anon_sym_EQ] = ACTIONS(7936),
    [anon_sym_LT] = ACTIONS(10708),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(10710),
    [anon_sym_DOT_DOT] = ACTIONS(10712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10714),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(10718),
    [anon_sym_AMP_AMP] = ACTIONS(10718),
    [anon_sym_LT_LT] = ACTIONS(10720),
    [anon_sym_GT_GT] = ACTIONS(10720),
    [anon_sym_EQ_EQ] = ACTIONS(10722),
    [anon_sym_BANG_EQ] = ACTIONS(10718),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10718),
    [anon_sym_LT_EQ_GT] = ACTIONS(10718),
    [anon_sym_EQ_TILDE] = ACTIONS(10718),
    [anon_sym_BANG_TILDE] = ACTIONS(10718),
    [anon_sym_LT_EQ] = ACTIONS(10708),
    [anon_sym_GT] = ACTIONS(10708),
    [anon_sym_GT_EQ] = ACTIONS(10724),
    [anon_sym_CARET] = ACTIONS(10726),
    [anon_sym_PLUS] = ACTIONS(10700),
    [anon_sym_SLASH] = ACTIONS(10702),
    [anon_sym_PERCENT] = ACTIONS(10702),
    [sym_comment] = ACTIONS(87),
  },
  [9125] = {
    [aux_sym_exceptions_repeat1] = STATE(10263),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_RPAREN] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [9126] = {
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(10700),
    [sym__binary_star] = ACTIONS(10702),
    [anon_sym_LBRACE] = ACTIONS(6210),
    [anon_sym_RPAREN] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(10704),
    [anon_sym_STAR_STAR] = ACTIONS(10702),
    [anon_sym_AMP] = ACTIONS(10706),
    [anon_sym_EQ] = ACTIONS(7938),
    [anon_sym_LT] = ACTIONS(10708),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(10710),
    [anon_sym_DOT_DOT] = ACTIONS(10712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10714),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(10718),
    [anon_sym_AMP_AMP] = ACTIONS(10718),
    [anon_sym_LT_LT] = ACTIONS(10720),
    [anon_sym_GT_GT] = ACTIONS(10720),
    [anon_sym_EQ_EQ] = ACTIONS(10722),
    [anon_sym_BANG_EQ] = ACTIONS(10718),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10718),
    [anon_sym_LT_EQ_GT] = ACTIONS(10718),
    [anon_sym_EQ_TILDE] = ACTIONS(10718),
    [anon_sym_BANG_TILDE] = ACTIONS(10718),
    [anon_sym_LT_EQ] = ACTIONS(10708),
    [anon_sym_GT] = ACTIONS(10708),
    [anon_sym_GT_EQ] = ACTIONS(10724),
    [anon_sym_CARET] = ACTIONS(10726),
    [anon_sym_PLUS] = ACTIONS(10700),
    [anon_sym_SLASH] = ACTIONS(10702),
    [anon_sym_PERCENT] = ACTIONS(10702),
    [sym_comment] = ACTIONS(87),
  },
  [9127] = {
    [sym_string] = STATE(9127),
    [aux_sym_chained_string_repeat1] = STATE(9127),
    [sym__string_start] = ACTIONS(12850),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_RPAREN] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_EQ] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_do] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [9128] = {
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(7368),
    [sym__binary_star] = ACTIONS(7370),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_RPAREN] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(7372),
    [anon_sym_STAR_STAR] = ACTIONS(7370),
    [anon_sym_AMP] = ACTIONS(7374),
    [anon_sym_EQ] = ACTIONS(7822),
    [anon_sym_LT] = ACTIONS(7376),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_EQ_GT] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(7378),
    [anon_sym_DOT_DOT] = ACTIONS(7380),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7382),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(7386),
    [anon_sym_AMP_AMP] = ACTIONS(7386),
    [anon_sym_LT_LT] = ACTIONS(7388),
    [anon_sym_GT_GT] = ACTIONS(7388),
    [anon_sym_EQ_EQ] = ACTIONS(7390),
    [anon_sym_BANG_EQ] = ACTIONS(7386),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7386),
    [anon_sym_LT_EQ_GT] = ACTIONS(7386),
    [anon_sym_EQ_TILDE] = ACTIONS(7386),
    [anon_sym_BANG_TILDE] = ACTIONS(7386),
    [anon_sym_LT_EQ] = ACTIONS(7376),
    [anon_sym_GT] = ACTIONS(7376),
    [anon_sym_GT_EQ] = ACTIONS(7392),
    [anon_sym_CARET] = ACTIONS(7394),
    [anon_sym_PLUS] = ACTIONS(7368),
    [anon_sym_SLASH] = ACTIONS(7370),
    [anon_sym_PERCENT] = ACTIONS(7370),
    [sym_comment] = ACTIONS(87),
  },
  [9129] = {
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(7368),
    [sym__binary_star] = ACTIONS(7370),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_RPAREN] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(7372),
    [anon_sym_STAR_STAR] = ACTIONS(7370),
    [anon_sym_AMP] = ACTIONS(7374),
    [anon_sym_EQ] = ACTIONS(7884),
    [anon_sym_LT] = ACTIONS(7376),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_EQ_GT] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(7378),
    [anon_sym_DOT_DOT] = ACTIONS(7380),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7382),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(7386),
    [anon_sym_AMP_AMP] = ACTIONS(7386),
    [anon_sym_LT_LT] = ACTIONS(7388),
    [anon_sym_GT_GT] = ACTIONS(7388),
    [anon_sym_EQ_EQ] = ACTIONS(7390),
    [anon_sym_BANG_EQ] = ACTIONS(7386),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7386),
    [anon_sym_LT_EQ_GT] = ACTIONS(7386),
    [anon_sym_EQ_TILDE] = ACTIONS(7386),
    [anon_sym_BANG_TILDE] = ACTIONS(7386),
    [anon_sym_LT_EQ] = ACTIONS(7376),
    [anon_sym_GT] = ACTIONS(7376),
    [anon_sym_GT_EQ] = ACTIONS(7392),
    [anon_sym_CARET] = ACTIONS(7394),
    [anon_sym_PLUS] = ACTIONS(7368),
    [anon_sym_SLASH] = ACTIONS(7370),
    [anon_sym_PERCENT] = ACTIONS(7370),
    [sym_comment] = ACTIONS(87),
  },
  [9130] = {
    [sym_heredoc_body] = STATE(9130),
    [aux_sym_call_repeat1] = STATE(9130),
    [sym__heredoc_body_start] = ACTIONS(10455),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_RPAREN] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_EQ] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_EQ_GT] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [9131] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4507),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2125),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2125),
    [sym__argument] = STATE(6908),
    [sym_splat_argument] = STATE(6908),
    [sym_hash_splat_argument] = STATE(6908),
    [sym_block_argument] = STATE(6908),
    [sym_assignment] = STATE(4507),
    [sym_operator_assignment] = STATE(4507),
    [sym_conditional] = STATE(4507),
    [sym_range] = STATE(4507),
    [sym_binary] = STATE(4507),
    [sym_unary] = STATE(4507),
    [sym_left_assignment_list] = STATE(2124),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2125),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2125),
    [sym_false] = STATE(2125),
    [sym_nil] = STATE(2125),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4510),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(6908),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(7356),
    [sym__splat_star] = ACTIONS(7358),
    [sym__unary_minus] = ACTIONS(3705),
    [sym__identifier_hash_key] = ACTIONS(7360),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12696),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3713),
    [anon_sym_break] = ACTIONS(3715),
    [anon_sym_next] = ACTIONS(3717),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3719),
    [anon_sym_defined_QMARK] = ACTIONS(3721),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [sym_constant] = ACTIONS(7364),
    [sym_identifier] = ACTIONS(7364),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9132] = {
    [sym_heredoc_body] = STATE(9130),
    [aux_sym_call_repeat1] = STATE(9130),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_RPAREN] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_EQ] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_EQ_GT] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [9133] = {
    [aux_sym_argument_list_repeat1] = STATE(9133),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_RPAREN] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(13985),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_STAR_STAR] = ACTIONS(7925),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_EQ] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_EQ_GT] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7925),
    [anon_sym_AMP_AMP] = ACTIONS(7925),
    [anon_sym_LT_LT] = ACTIONS(7925),
    [anon_sym_GT_GT] = ACTIONS(7925),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7925),
    [anon_sym_PLUS] = ACTIONS(7925),
    [anon_sym_SLASH] = ACTIONS(7925),
    [anon_sym_PERCENT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [9134] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(10264),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2125),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2125),
    [sym_assignment] = STATE(10264),
    [sym_operator_assignment] = STATE(10264),
    [sym_conditional] = STATE(10264),
    [sym_range] = STATE(10264),
    [sym_binary] = STATE(10264),
    [sym_unary] = STATE(10264),
    [sym_left_assignment_list] = STATE(2124),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2125),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2125),
    [sym_false] = STATE(2125),
    [sym_nil] = STATE(2125),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4499),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3705),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3713),
    [anon_sym_break] = ACTIONS(3715),
    [anon_sym_next] = ACTIONS(3717),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3719),
    [anon_sym_defined_QMARK] = ACTIONS(3721),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [sym_constant] = ACTIONS(3667),
    [sym_identifier] = ACTIONS(3667),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9135] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(7138),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2125),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2125),
    [sym_splat_argument] = STATE(9013),
    [sym_assignment] = STATE(7138),
    [sym_operator_assignment] = STATE(7138),
    [sym_conditional] = STATE(7138),
    [sym_range] = STATE(7138),
    [sym_binary] = STATE(7138),
    [sym_unary] = STATE(7138),
    [sym__arg_or_splat_arg] = STATE(9013),
    [sym_left_assignment_list] = STATE(2124),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2125),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2125),
    [sym_false] = STATE(2125),
    [sym_nil] = STATE(2125),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4499),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(7358),
    [sym__unary_minus] = ACTIONS(3705),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3713),
    [anon_sym_break] = ACTIONS(3715),
    [anon_sym_next] = ACTIONS(3717),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3719),
    [anon_sym_defined_QMARK] = ACTIONS(3721),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [sym_constant] = ACTIONS(3667),
    [sym_identifier] = ACTIONS(3667),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9136] = {
    [aux_sym_exceptions_repeat1] = STATE(10265),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_LBRACE] = ACTIONS(9855),
    [anon_sym_RPAREN] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(13988),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_EQ] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_do] = ACTIONS(9855),
    [anon_sym_EQ_GT] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [9137] = {
    [sym_heredoc_body] = STATE(9137),
    [aux_sym_call_repeat1] = STATE(9137),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(7916),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_RPAREN] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [9138] = {
    [sym_heredoc_body] = STATE(9137),
    [aux_sym_call_repeat1] = STATE(9137),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_RPAREN] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [9139] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10266),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2136),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(2136),
    [sym_assignment] = STATE(10266),
    [sym_operator_assignment] = STATE(10266),
    [sym_conditional] = STATE(10266),
    [sym_range] = STATE(10266),
    [sym_binary] = STATE(10266),
    [sym_unary] = STATE(10266),
    [sym_left_assignment_list] = STATE(2135),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2136),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2136),
    [sym_false] = STATE(2136),
    [sym_nil] = STATE(2136),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2137),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3729),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3731),
    [anon_sym_yield] = ACTIONS(3733),
    [anon_sym_break] = ACTIONS(3735),
    [anon_sym_next] = ACTIONS(3737),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3739),
    [anon_sym_defined_QMARK] = ACTIONS(3741),
    [anon_sym_not] = ACTIONS(3743),
    [anon_sym_BANG] = ACTIONS(3745),
    [anon_sym_TILDE] = ACTIONS(3745),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9140] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7154),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2136),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(2136),
    [sym_splat_argument] = STATE(7439),
    [sym_assignment] = STATE(7154),
    [sym_operator_assignment] = STATE(7154),
    [sym_conditional] = STATE(7154),
    [sym_range] = STATE(7154),
    [sym_binary] = STATE(7154),
    [sym_unary] = STATE(7154),
    [sym__arg_or_splat_arg] = STATE(7439),
    [sym_left_assignment_list] = STATE(2135),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2136),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2136),
    [sym_false] = STATE(2136),
    [sym_nil] = STATE(2136),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2137),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(1301),
    [sym__unary_minus] = ACTIONS(3729),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3731),
    [anon_sym_yield] = ACTIONS(3733),
    [anon_sym_break] = ACTIONS(3735),
    [anon_sym_next] = ACTIONS(3737),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3739),
    [anon_sym_defined_QMARK] = ACTIONS(3741),
    [anon_sym_not] = ACTIONS(3743),
    [anon_sym_BANG] = ACTIONS(3745),
    [anon_sym_TILDE] = ACTIONS(3745),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9141] = {
    [aux_sym_exceptions_repeat1] = STATE(10267),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_RPAREN] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(13990),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [9142] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(3761),
    [sym__binary_star] = ACTIONS(3763),
    [anon_sym_RPAREN] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(3765),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(3763),
    [anon_sym_AMP] = ACTIONS(3767),
    [anon_sym_LT] = ACTIONS(3769),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_EQ_GT] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(3771),
    [anon_sym_DOT_DOT] = ACTIONS(3773),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3775),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(3777),
    [anon_sym_AMP_AMP] = ACTIONS(3777),
    [anon_sym_LT_LT] = ACTIONS(3779),
    [anon_sym_GT_GT] = ACTIONS(3779),
    [anon_sym_EQ_EQ] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3777),
    [anon_sym_LT_EQ_GT] = ACTIONS(3777),
    [anon_sym_EQ_TILDE] = ACTIONS(3777),
    [anon_sym_BANG_TILDE] = ACTIONS(3777),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3783),
    [anon_sym_CARET] = ACTIONS(3785),
    [anon_sym_PLUS] = ACTIONS(3761),
    [anon_sym_SLASH] = ACTIONS(3763),
    [anon_sym_PERCENT] = ACTIONS(3763),
    [sym_comment] = ACTIONS(87),
  },
  [9143] = {
    [aux_sym_exceptions_repeat1] = STATE(9143),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_RPAREN] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(13992),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [9144] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10268),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2205),
    [sym_scope_resolution] = STATE(2203),
    [sym_call] = STATE(2203),
    [sym_method_call] = STATE(2205),
    [sym_assignment] = STATE(10268),
    [sym_operator_assignment] = STATE(10268),
    [sym_conditional] = STATE(10268),
    [sym_range] = STATE(10268),
    [sym_binary] = STATE(10268),
    [sym_unary] = STATE(10268),
    [sym_left_assignment_list] = STATE(2204),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2205),
    [sym__variable] = STATE(2203),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2205),
    [sym_false] = STATE(2205),
    [sym_nil] = STATE(2205),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2206),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(3809),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(3811),
    [anon_sym_yield] = ACTIONS(3813),
    [anon_sym_break] = ACTIONS(3815),
    [anon_sym_next] = ACTIONS(3817),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(3819),
    [anon_sym_defined_QMARK] = ACTIONS(3821),
    [anon_sym_not] = ACTIONS(3823),
    [anon_sym_BANG] = ACTIONS(3825),
    [anon_sym_TILDE] = ACTIONS(3825),
    [sym_constant] = ACTIONS(3827),
    [sym_identifier] = ACTIONS(3827),
    [sym_instance_variable] = ACTIONS(3829),
    [sym_class_variable] = ACTIONS(3829),
    [sym_global_variable] = ACTIONS(3829),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(3827),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3827),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [9145] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(7184),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2205),
    [sym_scope_resolution] = STATE(2203),
    [sym_call] = STATE(2203),
    [sym_method_call] = STATE(2205),
    [sym_splat_argument] = STATE(10067),
    [sym_assignment] = STATE(7184),
    [sym_operator_assignment] = STATE(7184),
    [sym_conditional] = STATE(7184),
    [sym_range] = STATE(7184),
    [sym_binary] = STATE(7184),
    [sym_unary] = STATE(7184),
    [sym__arg_or_splat_arg] = STATE(10067),
    [sym_left_assignment_list] = STATE(2204),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2205),
    [sym__variable] = STATE(2203),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2205),
    [sym_false] = STATE(2205),
    [sym_nil] = STATE(2205),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2206),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__splat_star] = ACTIONS(1373),
    [sym__unary_minus] = ACTIONS(3809),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(3811),
    [anon_sym_yield] = ACTIONS(3813),
    [anon_sym_break] = ACTIONS(3815),
    [anon_sym_next] = ACTIONS(3817),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(3819),
    [anon_sym_defined_QMARK] = ACTIONS(3821),
    [anon_sym_not] = ACTIONS(3823),
    [anon_sym_BANG] = ACTIONS(3825),
    [anon_sym_TILDE] = ACTIONS(3825),
    [sym_constant] = ACTIONS(3827),
    [sym_identifier] = ACTIONS(3827),
    [sym_instance_variable] = ACTIONS(3829),
    [sym_class_variable] = ACTIONS(3829),
    [sym_global_variable] = ACTIONS(3829),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(3827),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3827),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [9146] = {
    [aux_sym_exceptions_repeat1] = STATE(10269),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_LBRACE] = ACTIONS(9855),
    [anon_sym_RPAREN] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(13995),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9857),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_EQ] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_do] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_PLUS_EQ] = ACTIONS(9855),
    [anon_sym_DASH_EQ] = ACTIONS(9855),
    [anon_sym_STAR_EQ] = ACTIONS(9855),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9855),
    [anon_sym_SLASH_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9855),
    [anon_sym_AMP_EQ] = ACTIONS(9855),
    [anon_sym_PERCENT_EQ] = ACTIONS(9855),
    [anon_sym_GT_GT_EQ] = ACTIONS(9855),
    [anon_sym_LT_LT_EQ] = ACTIONS(9855),
    [anon_sym_CARET_EQ] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9857),
    [anon_sym_AMP_AMP] = ACTIONS(9857),
    [anon_sym_LT_LT] = ACTIONS(9857),
    [anon_sym_GT_GT] = ACTIONS(9857),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9857),
    [anon_sym_PLUS] = ACTIONS(9857),
    [anon_sym_SLASH] = ACTIONS(9857),
    [anon_sym_PERCENT] = ACTIONS(9857),
    [sym_comment] = ACTIONS(87),
  },
  [9147] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(3837),
    [sym__binary_star] = ACTIONS(3839),
    [anon_sym_LBRACE] = ACTIONS(12120),
    [anon_sym_RPAREN] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(3841),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(3843),
    [anon_sym_AMP] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(12879),
    [anon_sym_LT] = ACTIONS(3847),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_EQ_GT] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_PLUS_EQ] = ACTIONS(12120),
    [anon_sym_DASH_EQ] = ACTIONS(12120),
    [anon_sym_STAR_EQ] = ACTIONS(12120),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12120),
    [anon_sym_SLASH_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12120),
    [anon_sym_AMP_EQ] = ACTIONS(12120),
    [anon_sym_PERCENT_EQ] = ACTIONS(12120),
    [anon_sym_GT_GT_EQ] = ACTIONS(12120),
    [anon_sym_LT_LT_EQ] = ACTIONS(12120),
    [anon_sym_CARET_EQ] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(3849),
    [anon_sym_DOT_DOT] = ACTIONS(3851),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3853),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(3855),
    [anon_sym_AMP_AMP] = ACTIONS(3855),
    [anon_sym_LT_LT] = ACTIONS(3857),
    [anon_sym_GT_GT] = ACTIONS(3857),
    [anon_sym_EQ_EQ] = ACTIONS(3855),
    [anon_sym_BANG_EQ] = ACTIONS(3859),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3859),
    [anon_sym_LT_EQ_GT] = ACTIONS(3859),
    [anon_sym_EQ_TILDE] = ACTIONS(3859),
    [anon_sym_BANG_TILDE] = ACTIONS(3859),
    [anon_sym_LT_EQ] = ACTIONS(3847),
    [anon_sym_GT] = ACTIONS(3847),
    [anon_sym_GT_EQ] = ACTIONS(3861),
    [anon_sym_CARET] = ACTIONS(3841),
    [anon_sym_PLUS] = ACTIONS(3863),
    [anon_sym_SLASH] = ACTIONS(3843),
    [anon_sym_PERCENT] = ACTIONS(3843),
    [sym_comment] = ACTIONS(87),
  },
  [9148] = {
    [aux_sym_exceptions_repeat1] = STATE(9148),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_RPAREN] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(13997),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_PLUS_EQ] = ACTIONS(11597),
    [anon_sym_DASH_EQ] = ACTIONS(11597),
    [anon_sym_STAR_EQ] = ACTIONS(11597),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11597),
    [anon_sym_SLASH_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11597),
    [anon_sym_AMP_EQ] = ACTIONS(11597),
    [anon_sym_PERCENT_EQ] = ACTIONS(11597),
    [anon_sym_GT_GT_EQ] = ACTIONS(11597),
    [anon_sym_LT_LT_EQ] = ACTIONS(11597),
    [anon_sym_CARET_EQ] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_LT] = ACTIONS(12338),
    [anon_sym_GT_GT] = ACTIONS(12338),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(12338),
    [anon_sym_PLUS] = ACTIONS(12338),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [9149] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10270),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2237),
    [sym_scope_resolution] = STATE(146),
    [sym_call] = STATE(146),
    [sym_method_call] = STATE(2237),
    [sym_assignment] = STATE(10270),
    [sym_operator_assignment] = STATE(10270),
    [sym_conditional] = STATE(10270),
    [sym_range] = STATE(10270),
    [sym_binary] = STATE(10270),
    [sym_unary] = STATE(10270),
    [sym_left_assignment_list] = STATE(2236),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2237),
    [sym__variable] = STATE(146),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2237),
    [sym_false] = STATE(2237),
    [sym_nil] = STATE(2237),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2137),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3877),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3731),
    [anon_sym_yield] = ACTIONS(3733),
    [anon_sym_break] = ACTIONS(3735),
    [anon_sym_next] = ACTIONS(3737),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3879),
    [anon_sym_defined_QMARK] = ACTIONS(3881),
    [anon_sym_not] = ACTIONS(3883),
    [anon_sym_BANG] = ACTIONS(3885),
    [anon_sym_TILDE] = ACTIONS(3885),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9150] = {
    [anon_sym_DOT] = ACTIONS(12555),
    [anon_sym_LBRACK] = ACTIONS(12555),
    [anon_sym_COLON_COLON2] = ACTIONS(12555),
    [anon_sym_AMP_DOT] = ACTIONS(12555),
    [sym_comment] = ACTIONS(87),
  },
  [9151] = {
    [anon_sym_DOT] = ACTIONS(12559),
    [anon_sym_LBRACK] = ACTIONS(12559),
    [anon_sym_COLON_COLON2] = ACTIONS(12559),
    [anon_sym_AMP_DOT] = ACTIONS(12559),
    [sym_comment] = ACTIONS(87),
  },
  [9152] = {
    [anon_sym_DOT] = ACTIONS(12663),
    [anon_sym_LBRACK] = ACTIONS(12663),
    [anon_sym_COLON_COLON2] = ACTIONS(12663),
    [anon_sym_AMP_DOT] = ACTIONS(12663),
    [sym_comment] = ACTIONS(87),
  },
  [9153] = {
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(7575),
    [sym__binary_star] = ACTIONS(7577),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(7579),
    [anon_sym_STAR_STAR] = ACTIONS(7577),
    [anon_sym_AMP] = ACTIONS(7581),
    [anon_sym_LT] = ACTIONS(7583),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(7585),
    [anon_sym_DOT_DOT] = ACTIONS(7587),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7589),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(7593),
    [anon_sym_AMP_AMP] = ACTIONS(7593),
    [anon_sym_LT_LT] = ACTIONS(7595),
    [anon_sym_GT_GT] = ACTIONS(7595),
    [anon_sym_EQ_EQ] = ACTIONS(7597),
    [anon_sym_BANG_EQ] = ACTIONS(7593),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7593),
    [anon_sym_LT_EQ_GT] = ACTIONS(7593),
    [anon_sym_EQ_TILDE] = ACTIONS(7593),
    [anon_sym_BANG_TILDE] = ACTIONS(7593),
    [anon_sym_LT_EQ] = ACTIONS(7583),
    [anon_sym_GT] = ACTIONS(7583),
    [anon_sym_GT_EQ] = ACTIONS(7599),
    [anon_sym_CARET] = ACTIONS(7601),
    [anon_sym_PLUS] = ACTIONS(7575),
    [anon_sym_SLASH] = ACTIONS(7577),
    [anon_sym_PERCENT] = ACTIONS(7577),
    [sym_comment] = ACTIONS(87),
  },
  [9154] = {
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(7575),
    [sym__binary_star] = ACTIONS(7577),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(7579),
    [anon_sym_STAR_STAR] = ACTIONS(7577),
    [anon_sym_AMP] = ACTIONS(7581),
    [anon_sym_LT] = ACTIONS(7583),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(7585),
    [anon_sym_DOT_DOT] = ACTIONS(7587),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7589),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(7593),
    [anon_sym_AMP_AMP] = ACTIONS(7593),
    [anon_sym_LT_LT] = ACTIONS(7595),
    [anon_sym_GT_GT] = ACTIONS(7595),
    [anon_sym_EQ_EQ] = ACTIONS(7597),
    [anon_sym_BANG_EQ] = ACTIONS(7593),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7593),
    [anon_sym_LT_EQ_GT] = ACTIONS(7593),
    [anon_sym_EQ_TILDE] = ACTIONS(7593),
    [anon_sym_BANG_TILDE] = ACTIONS(7593),
    [anon_sym_LT_EQ] = ACTIONS(7583),
    [anon_sym_GT] = ACTIONS(7583),
    [anon_sym_GT_EQ] = ACTIONS(7599),
    [anon_sym_CARET] = ACTIONS(7601),
    [anon_sym_PLUS] = ACTIONS(7575),
    [anon_sym_SLASH] = ACTIONS(7577),
    [anon_sym_PERCENT] = ACTIONS(7577),
    [sym_comment] = ACTIONS(87),
  },
  [9155] = {
    [sym_heredoc_body] = STATE(9155),
    [aux_sym_call_repeat1] = STATE(9155),
    [sym__heredoc_body_start] = ACTIONS(10455),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [9156] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4663),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(567),
    [sym_scope_resolution] = STATE(562),
    [sym_call] = STATE(562),
    [sym_method_call] = STATE(567),
    [sym__argument] = STATE(6908),
    [sym_splat_argument] = STATE(6908),
    [sym_hash_splat_argument] = STATE(6908),
    [sym_block_argument] = STATE(6908),
    [sym_assignment] = STATE(4663),
    [sym_operator_assignment] = STATE(4663),
    [sym_conditional] = STATE(4663),
    [sym_range] = STATE(4663),
    [sym_binary] = STATE(4663),
    [sym_unary] = STATE(4663),
    [sym_left_assignment_list] = STATE(566),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(567),
    [sym__variable] = STATE(562),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(567),
    [sym_false] = STATE(567),
    [sym_nil] = STATE(567),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4666),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(6908),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(7567),
    [sym__splat_star] = ACTIONS(7569),
    [sym__unary_minus] = ACTIONS(1049),
    [sym__identifier_hash_key] = ACTIONS(7571),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12726),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(7573),
    [sym_identifier] = ACTIONS(7573),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9157] = {
    [sym_heredoc_body] = STATE(9155),
    [aux_sym_call_repeat1] = STATE(9155),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [9158] = {
    [aux_sym_argument_list_repeat1] = STATE(9158),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(14000),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_STAR_STAR] = ACTIONS(7925),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7925),
    [anon_sym_AMP_AMP] = ACTIONS(7925),
    [anon_sym_LT_LT] = ACTIONS(7925),
    [anon_sym_GT_GT] = ACTIONS(7925),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7925),
    [anon_sym_PLUS] = ACTIONS(7925),
    [anon_sym_SLASH] = ACTIONS(7925),
    [anon_sym_PERCENT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [9159] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(10271),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2279),
    [sym_scope_resolution] = STATE(2277),
    [sym_call] = STATE(2277),
    [sym_method_call] = STATE(2279),
    [sym_assignment] = STATE(10271),
    [sym_operator_assignment] = STATE(10271),
    [sym_conditional] = STATE(10271),
    [sym_range] = STATE(10271),
    [sym_binary] = STATE(10271),
    [sym_unary] = STATE(10271),
    [sym_left_assignment_list] = STATE(2278),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2277),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2279),
    [sym_false] = STATE(2279),
    [sym_nil] = STATE(2279),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2280),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3931),
    [anon_sym_yield] = ACTIONS(3933),
    [anon_sym_break] = ACTIONS(3935),
    [anon_sym_next] = ACTIONS(3937),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3939),
    [anon_sym_defined_QMARK] = ACTIONS(3941),
    [anon_sym_not] = ACTIONS(3943),
    [anon_sym_BANG] = ACTIONS(3945),
    [anon_sym_TILDE] = ACTIONS(3945),
    [sym_constant] = ACTIONS(3947),
    [sym_identifier] = ACTIONS(3947),
    [sym_instance_variable] = ACTIONS(3949),
    [sym_class_variable] = ACTIONS(3949),
    [sym_global_variable] = ACTIONS(3949),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3947),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3947),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9160] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(12736),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [9161] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(12730),
    [sym__binary_star] = ACTIONS(12732),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(12734),
    [anon_sym_STAR_STAR] = ACTIONS(12736),
    [anon_sym_AMP] = ACTIONS(12738),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(12740),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(12742),
    [anon_sym_DOT_DOT] = ACTIONS(12744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12746),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(12748),
    [anon_sym_AMP_AMP] = ACTIONS(12748),
    [anon_sym_LT_LT] = ACTIONS(12750),
    [anon_sym_GT_GT] = ACTIONS(12750),
    [anon_sym_EQ_EQ] = ACTIONS(12748),
    [anon_sym_BANG_EQ] = ACTIONS(12752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12752),
    [anon_sym_LT_EQ_GT] = ACTIONS(12752),
    [anon_sym_EQ_TILDE] = ACTIONS(12752),
    [anon_sym_BANG_TILDE] = ACTIONS(12752),
    [anon_sym_LT_EQ] = ACTIONS(12740),
    [anon_sym_GT] = ACTIONS(12740),
    [anon_sym_GT_EQ] = ACTIONS(12754),
    [anon_sym_CARET] = ACTIONS(12734),
    [anon_sym_PLUS] = ACTIONS(12756),
    [anon_sym_SLASH] = ACTIONS(12736),
    [anon_sym_PERCENT] = ACTIONS(12736),
    [sym_comment] = ACTIONS(87),
  },
  [9162] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(10272),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(7240),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(7240),
    [sym_assignment] = STATE(10272),
    [sym_operator_assignment] = STATE(10272),
    [sym_conditional] = STATE(10272),
    [sym_range] = STATE(10272),
    [sym_binary] = STATE(10272),
    [sym_unary] = STATE(10272),
    [sym_left_assignment_list] = STATE(7239),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7240),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(7240),
    [sym_false] = STATE(7240),
    [sym_nil] = STATE(7240),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(7241),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(10782),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(10784),
    [anon_sym_yield] = ACTIONS(10786),
    [anon_sym_break] = ACTIONS(10788),
    [anon_sym_next] = ACTIONS(10790),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(10792),
    [anon_sym_defined_QMARK] = ACTIONS(10794),
    [anon_sym_not] = ACTIONS(10796),
    [anon_sym_BANG] = ACTIONS(10798),
    [anon_sym_TILDE] = ACTIONS(10798),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [9163] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(10273),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(7240),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(7240),
    [sym_assignment] = STATE(10273),
    [sym_operator_assignment] = STATE(10273),
    [sym_conditional] = STATE(10273),
    [sym_range] = STATE(10273),
    [sym_binary] = STATE(10273),
    [sym_unary] = STATE(10273),
    [sym_left_assignment_list] = STATE(7239),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7240),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(7240),
    [sym_false] = STATE(7240),
    [sym_nil] = STATE(7240),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(7241),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(10782),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(10784),
    [anon_sym_yield] = ACTIONS(10786),
    [anon_sym_break] = ACTIONS(10788),
    [anon_sym_next] = ACTIONS(10790),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(10792),
    [anon_sym_defined_QMARK] = ACTIONS(10794),
    [anon_sym_not] = ACTIONS(10796),
    [anon_sym_BANG] = ACTIONS(10798),
    [anon_sym_TILDE] = ACTIONS(10798),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [9164] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(10274),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(7240),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(7240),
    [sym_assignment] = STATE(10274),
    [sym_operator_assignment] = STATE(10274),
    [sym_conditional] = STATE(10274),
    [sym_range] = STATE(10274),
    [sym_binary] = STATE(10274),
    [sym_unary] = STATE(10274),
    [sym_left_assignment_list] = STATE(7239),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7240),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(7240),
    [sym_false] = STATE(7240),
    [sym_nil] = STATE(7240),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(7241),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(10782),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(10784),
    [anon_sym_yield] = ACTIONS(10786),
    [anon_sym_break] = ACTIONS(10788),
    [anon_sym_next] = ACTIONS(10790),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(10792),
    [anon_sym_defined_QMARK] = ACTIONS(10794),
    [anon_sym_not] = ACTIONS(10796),
    [anon_sym_BANG] = ACTIONS(10798),
    [anon_sym_TILDE] = ACTIONS(10798),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [9165] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(10275),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(7240),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(7240),
    [sym_assignment] = STATE(10275),
    [sym_operator_assignment] = STATE(10275),
    [sym_conditional] = STATE(10275),
    [sym_range] = STATE(10275),
    [sym_binary] = STATE(10275),
    [sym_unary] = STATE(10275),
    [sym_left_assignment_list] = STATE(7239),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7240),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(7240),
    [sym_false] = STATE(7240),
    [sym_nil] = STATE(7240),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(7241),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(10782),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(10784),
    [anon_sym_yield] = ACTIONS(10786),
    [anon_sym_break] = ACTIONS(10788),
    [anon_sym_next] = ACTIONS(10790),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(10792),
    [anon_sym_defined_QMARK] = ACTIONS(10794),
    [anon_sym_not] = ACTIONS(10796),
    [anon_sym_BANG] = ACTIONS(10798),
    [anon_sym_TILDE] = ACTIONS(10798),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [9166] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(10276),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(7240),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(7240),
    [sym_assignment] = STATE(10276),
    [sym_operator_assignment] = STATE(10276),
    [sym_conditional] = STATE(10276),
    [sym_range] = STATE(10276),
    [sym_binary] = STATE(10276),
    [sym_unary] = STATE(10276),
    [sym_left_assignment_list] = STATE(7239),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7240),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(7240),
    [sym_false] = STATE(7240),
    [sym_nil] = STATE(7240),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(7241),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(10782),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(10784),
    [anon_sym_yield] = ACTIONS(10786),
    [anon_sym_break] = ACTIONS(10788),
    [anon_sym_next] = ACTIONS(10790),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(10792),
    [anon_sym_defined_QMARK] = ACTIONS(10794),
    [anon_sym_not] = ACTIONS(10796),
    [anon_sym_BANG] = ACTIONS(10798),
    [anon_sym_TILDE] = ACTIONS(10798),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [9167] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(10277),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(10277),
    [sym_operator_assignment] = STATE(10277),
    [sym_conditional] = STATE(10277),
    [sym_range] = STATE(10277),
    [sym_binary] = STATE(10277),
    [sym_unary] = STATE(10277),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9168] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(10278),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(7240),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(7240),
    [sym_assignment] = STATE(10278),
    [sym_operator_assignment] = STATE(10278),
    [sym_conditional] = STATE(10278),
    [sym_range] = STATE(10278),
    [sym_binary] = STATE(10278),
    [sym_unary] = STATE(10278),
    [sym_left_assignment_list] = STATE(7239),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7240),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(7240),
    [sym_false] = STATE(7240),
    [sym_nil] = STATE(7240),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(7241),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(10782),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(10784),
    [anon_sym_yield] = ACTIONS(10786),
    [anon_sym_break] = ACTIONS(10788),
    [anon_sym_next] = ACTIONS(10790),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(10792),
    [anon_sym_defined_QMARK] = ACTIONS(10794),
    [anon_sym_not] = ACTIONS(10796),
    [anon_sym_BANG] = ACTIONS(10798),
    [anon_sym_TILDE] = ACTIONS(10798),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [9169] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(10279),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(7240),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(7240),
    [sym_assignment] = STATE(10279),
    [sym_operator_assignment] = STATE(10279),
    [sym_conditional] = STATE(10279),
    [sym_range] = STATE(10279),
    [sym_binary] = STATE(10279),
    [sym_unary] = STATE(10279),
    [sym_left_assignment_list] = STATE(7239),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7240),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(7240),
    [sym_false] = STATE(7240),
    [sym_nil] = STATE(7240),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(7241),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(10782),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(10784),
    [anon_sym_yield] = ACTIONS(10786),
    [anon_sym_break] = ACTIONS(10788),
    [anon_sym_next] = ACTIONS(10790),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(10792),
    [anon_sym_defined_QMARK] = ACTIONS(10794),
    [anon_sym_not] = ACTIONS(10796),
    [anon_sym_BANG] = ACTIONS(10798),
    [anon_sym_TILDE] = ACTIONS(10798),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [9170] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(10280),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(7240),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(7240),
    [sym_assignment] = STATE(10280),
    [sym_operator_assignment] = STATE(10280),
    [sym_conditional] = STATE(10280),
    [sym_range] = STATE(10280),
    [sym_binary] = STATE(10280),
    [sym_unary] = STATE(10280),
    [sym_left_assignment_list] = STATE(7239),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7240),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(7240),
    [sym_false] = STATE(7240),
    [sym_nil] = STATE(7240),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(7241),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(10782),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(10784),
    [anon_sym_yield] = ACTIONS(10786),
    [anon_sym_break] = ACTIONS(10788),
    [anon_sym_next] = ACTIONS(10790),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(10792),
    [anon_sym_defined_QMARK] = ACTIONS(10794),
    [anon_sym_not] = ACTIONS(10796),
    [anon_sym_BANG] = ACTIONS(10798),
    [anon_sym_TILDE] = ACTIONS(10798),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [9171] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(10281),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(7240),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(7240),
    [sym_assignment] = STATE(10281),
    [sym_operator_assignment] = STATE(10281),
    [sym_conditional] = STATE(10281),
    [sym_range] = STATE(10281),
    [sym_binary] = STATE(10281),
    [sym_unary] = STATE(10281),
    [sym_left_assignment_list] = STATE(7239),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7240),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(7240),
    [sym_false] = STATE(7240),
    [sym_nil] = STATE(7240),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(7241),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(10782),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(10784),
    [anon_sym_yield] = ACTIONS(10786),
    [anon_sym_break] = ACTIONS(10788),
    [anon_sym_next] = ACTIONS(10790),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(10792),
    [anon_sym_defined_QMARK] = ACTIONS(10794),
    [anon_sym_not] = ACTIONS(10796),
    [anon_sym_BANG] = ACTIONS(10798),
    [anon_sym_TILDE] = ACTIONS(10798),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [9172] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(10282),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(7240),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(7240),
    [sym_splat_argument] = STATE(10283),
    [sym_assignment] = STATE(10282),
    [sym_operator_assignment] = STATE(10282),
    [sym_conditional] = STATE(10282),
    [sym_range] = STATE(10282),
    [sym_binary] = STATE(10282),
    [sym_unary] = STATE(10282),
    [sym_right_assignment_list] = STATE(8878),
    [sym__arg_or_splat_arg] = STATE(10283),
    [sym_left_assignment_list] = STATE(7239),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7240),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(7240),
    [sym_false] = STATE(7240),
    [sym_nil] = STATE(7240),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(7241),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__splat_star] = ACTIONS(7605),
    [sym__unary_minus] = ACTIONS(10782),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(10784),
    [anon_sym_yield] = ACTIONS(10786),
    [anon_sym_break] = ACTIONS(10788),
    [anon_sym_next] = ACTIONS(10790),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(10792),
    [anon_sym_defined_QMARK] = ACTIONS(10794),
    [anon_sym_not] = ACTIONS(10796),
    [anon_sym_BANG] = ACTIONS(10798),
    [anon_sym_TILDE] = ACTIONS(10798),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [9173] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(10284),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(7240),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(7240),
    [sym_assignment] = STATE(10284),
    [sym_operator_assignment] = STATE(10284),
    [sym_conditional] = STATE(10284),
    [sym_range] = STATE(10284),
    [sym_binary] = STATE(10284),
    [sym_unary] = STATE(10284),
    [sym_left_assignment_list] = STATE(7239),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7240),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(7240),
    [sym_false] = STATE(7240),
    [sym_nil] = STATE(7240),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(7241),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(10782),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(10784),
    [anon_sym_yield] = ACTIONS(10786),
    [anon_sym_break] = ACTIONS(10788),
    [anon_sym_next] = ACTIONS(10790),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(10792),
    [anon_sym_defined_QMARK] = ACTIONS(10794),
    [anon_sym_not] = ACTIONS(10796),
    [anon_sym_BANG] = ACTIONS(10798),
    [anon_sym_TILDE] = ACTIONS(10798),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [9174] = {
    [sym_string] = STATE(10285),
    [aux_sym_chained_string_repeat1] = STATE(10285),
    [sym__string_start] = ACTIONS(6455),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_STAR_STAR] = ACTIONS(2755),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_EQ] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_PLUS_EQ] = ACTIONS(2753),
    [anon_sym_DASH_EQ] = ACTIONS(2753),
    [anon_sym_STAR_EQ] = ACTIONS(2753),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2753),
    [anon_sym_SLASH_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2753),
    [anon_sym_AMP_EQ] = ACTIONS(2753),
    [anon_sym_PERCENT_EQ] = ACTIONS(2753),
    [anon_sym_GT_GT_EQ] = ACTIONS(2753),
    [anon_sym_LT_LT_EQ] = ACTIONS(2753),
    [anon_sym_CARET_EQ] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2755),
    [anon_sym_AMP_AMP] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2755),
    [anon_sym_GT_GT] = ACTIONS(2755),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_SLASH] = ACTIONS(2755),
    [anon_sym_PERCENT] = ACTIONS(2755),
    [sym_comment] = ACTIONS(87),
  },
  [9175] = {
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(12730),
    [sym__binary_star] = ACTIONS(12732),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(12734),
    [anon_sym_STAR_STAR] = ACTIONS(12736),
    [anon_sym_AMP] = ACTIONS(12738),
    [anon_sym_EQ] = ACTIONS(7822),
    [anon_sym_LT] = ACTIONS(12740),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_PLUS_EQ] = ACTIONS(6823),
    [anon_sym_DASH_EQ] = ACTIONS(6823),
    [anon_sym_STAR_EQ] = ACTIONS(6823),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6823),
    [anon_sym_SLASH_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6823),
    [anon_sym_AMP_EQ] = ACTIONS(6823),
    [anon_sym_PERCENT_EQ] = ACTIONS(6823),
    [anon_sym_GT_GT_EQ] = ACTIONS(6823),
    [anon_sym_LT_LT_EQ] = ACTIONS(6823),
    [anon_sym_CARET_EQ] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(12742),
    [anon_sym_DOT_DOT] = ACTIONS(12744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12746),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(12748),
    [anon_sym_AMP_AMP] = ACTIONS(12748),
    [anon_sym_LT_LT] = ACTIONS(12750),
    [anon_sym_GT_GT] = ACTIONS(12750),
    [anon_sym_EQ_EQ] = ACTIONS(12748),
    [anon_sym_BANG_EQ] = ACTIONS(12752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12752),
    [anon_sym_LT_EQ_GT] = ACTIONS(12752),
    [anon_sym_EQ_TILDE] = ACTIONS(12752),
    [anon_sym_BANG_TILDE] = ACTIONS(12752),
    [anon_sym_LT_EQ] = ACTIONS(12740),
    [anon_sym_GT] = ACTIONS(12740),
    [anon_sym_GT_EQ] = ACTIONS(12754),
    [anon_sym_CARET] = ACTIONS(12734),
    [anon_sym_PLUS] = ACTIONS(12756),
    [anon_sym_SLASH] = ACTIONS(12736),
    [anon_sym_PERCENT] = ACTIONS(12736),
    [sym_comment] = ACTIONS(87),
  },
  [9176] = {
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(12730),
    [sym__binary_star] = ACTIONS(12732),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(12734),
    [anon_sym_STAR_STAR] = ACTIONS(12736),
    [anon_sym_AMP] = ACTIONS(12738),
    [anon_sym_EQ] = ACTIONS(7884),
    [anon_sym_LT] = ACTIONS(12740),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_PLUS_EQ] = ACTIONS(7027),
    [anon_sym_DASH_EQ] = ACTIONS(7027),
    [anon_sym_STAR_EQ] = ACTIONS(7027),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7027),
    [anon_sym_SLASH_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7027),
    [anon_sym_AMP_EQ] = ACTIONS(7027),
    [anon_sym_PERCENT_EQ] = ACTIONS(7027),
    [anon_sym_GT_GT_EQ] = ACTIONS(7027),
    [anon_sym_LT_LT_EQ] = ACTIONS(7027),
    [anon_sym_CARET_EQ] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(12742),
    [anon_sym_DOT_DOT] = ACTIONS(12744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12746),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(12748),
    [anon_sym_AMP_AMP] = ACTIONS(12748),
    [anon_sym_LT_LT] = ACTIONS(12750),
    [anon_sym_GT_GT] = ACTIONS(12750),
    [anon_sym_EQ_EQ] = ACTIONS(12748),
    [anon_sym_BANG_EQ] = ACTIONS(12752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12752),
    [anon_sym_LT_EQ_GT] = ACTIONS(12752),
    [anon_sym_EQ_TILDE] = ACTIONS(12752),
    [anon_sym_BANG_TILDE] = ACTIONS(12752),
    [anon_sym_LT_EQ] = ACTIONS(12740),
    [anon_sym_GT] = ACTIONS(12740),
    [anon_sym_GT_EQ] = ACTIONS(12754),
    [anon_sym_CARET] = ACTIONS(12734),
    [anon_sym_PLUS] = ACTIONS(12756),
    [anon_sym_SLASH] = ACTIONS(12736),
    [anon_sym_PERCENT] = ACTIONS(12736),
    [sym_comment] = ACTIONS(87),
  },
  [9177] = {
    [sym_heredoc_body] = STATE(9177),
    [aux_sym_call_repeat1] = STATE(9177),
    [sym__heredoc_body_start] = ACTIONS(12549),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_STAR_STAR] = ACTIONS(7919),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_EQ] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_PLUS_EQ] = ACTIONS(7914),
    [anon_sym_DASH_EQ] = ACTIONS(7914),
    [anon_sym_STAR_EQ] = ACTIONS(7914),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7914),
    [anon_sym_SLASH_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7914),
    [anon_sym_AMP_EQ] = ACTIONS(7914),
    [anon_sym_PERCENT_EQ] = ACTIONS(7914),
    [anon_sym_GT_GT_EQ] = ACTIONS(7914),
    [anon_sym_LT_LT_EQ] = ACTIONS(7914),
    [anon_sym_CARET_EQ] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7919),
    [anon_sym_AMP_AMP] = ACTIONS(7919),
    [anon_sym_LT_LT] = ACTIONS(7919),
    [anon_sym_GT_GT] = ACTIONS(7919),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7919),
    [anon_sym_PLUS] = ACTIONS(7919),
    [anon_sym_SLASH] = ACTIONS(7919),
    [anon_sym_PERCENT] = ACTIONS(7919),
    [sym_comment] = ACTIONS(87),
  },
  [9178] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4683),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym__argument] = STATE(8888),
    [sym_splat_argument] = STATE(8888),
    [sym_hash_splat_argument] = STATE(8888),
    [sym_block_argument] = STATE(8888),
    [sym_assignment] = STATE(4683),
    [sym_operator_assignment] = STATE(4683),
    [sym_conditional] = STATE(4683),
    [sym_range] = STATE(4683),
    [sym_binary] = STATE(4683),
    [sym_unary] = STATE(4683),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4686),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(8888),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(7603),
    [sym__splat_star] = ACTIONS(7605),
    [sym__unary_minus] = ACTIONS(1159),
    [sym__identifier_hash_key] = ACTIONS(7607),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12764),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(3469),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(7609),
    [sym_identifier] = ACTIONS(7609),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [9179] = {
    [sym_heredoc_body] = STATE(9177),
    [aux_sym_call_repeat1] = STATE(9177),
    [sym__heredoc_body_start] = ACTIONS(6569),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_STAR_STAR] = ACTIONS(7931),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_EQ] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_PLUS_EQ] = ACTIONS(7929),
    [anon_sym_DASH_EQ] = ACTIONS(7929),
    [anon_sym_STAR_EQ] = ACTIONS(7929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7929),
    [anon_sym_SLASH_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7929),
    [anon_sym_AMP_EQ] = ACTIONS(7929),
    [anon_sym_PERCENT_EQ] = ACTIONS(7929),
    [anon_sym_GT_GT_EQ] = ACTIONS(7929),
    [anon_sym_LT_LT_EQ] = ACTIONS(7929),
    [anon_sym_CARET_EQ] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7931),
    [anon_sym_AMP_AMP] = ACTIONS(7931),
    [anon_sym_LT_LT] = ACTIONS(7931),
    [anon_sym_GT_GT] = ACTIONS(7931),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7931),
    [anon_sym_PLUS] = ACTIONS(7931),
    [anon_sym_SLASH] = ACTIONS(7931),
    [anon_sym_PERCENT] = ACTIONS(7931),
    [sym_comment] = ACTIONS(87),
  },
  [9180] = {
    [aux_sym_argument_list_repeat1] = STATE(9180),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(14003),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_STAR_STAR] = ACTIONS(7927),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_EQ] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_PLUS_EQ] = ACTIONS(7925),
    [anon_sym_DASH_EQ] = ACTIONS(7925),
    [anon_sym_STAR_EQ] = ACTIONS(7925),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7925),
    [anon_sym_SLASH_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7925),
    [anon_sym_AMP_EQ] = ACTIONS(7925),
    [anon_sym_PERCENT_EQ] = ACTIONS(7925),
    [anon_sym_GT_GT_EQ] = ACTIONS(7925),
    [anon_sym_LT_LT_EQ] = ACTIONS(7925),
    [anon_sym_CARET_EQ] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7927),
    [anon_sym_AMP_AMP] = ACTIONS(7927),
    [anon_sym_LT_LT] = ACTIONS(7927),
    [anon_sym_GT_GT] = ACTIONS(7927),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7927),
    [anon_sym_PLUS] = ACTIONS(7927),
    [anon_sym_SLASH] = ACTIONS(7927),
    [anon_sym_PERCENT] = ACTIONS(7927),
    [sym_comment] = ACTIONS(87),
  },
  [9181] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7249),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2279),
    [sym_scope_resolution] = STATE(2277),
    [sym_call] = STATE(2277),
    [sym_method_call] = STATE(2279),
    [sym_splat_argument] = STATE(9013),
    [sym_assignment] = STATE(7249),
    [sym_operator_assignment] = STATE(7249),
    [sym_conditional] = STATE(7249),
    [sym_range] = STATE(7249),
    [sym_binary] = STATE(7249),
    [sym_unary] = STATE(7249),
    [sym__arg_or_splat_arg] = STATE(9013),
    [sym_left_assignment_list] = STATE(2278),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2277),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2279),
    [sym_false] = STATE(2279),
    [sym_nil] = STATE(2279),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2280),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(7569),
    [sym__unary_minus] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3931),
    [anon_sym_yield] = ACTIONS(3933),
    [anon_sym_break] = ACTIONS(3935),
    [anon_sym_next] = ACTIONS(3937),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3939),
    [anon_sym_defined_QMARK] = ACTIONS(3941),
    [anon_sym_not] = ACTIONS(3943),
    [anon_sym_BANG] = ACTIONS(3945),
    [anon_sym_TILDE] = ACTIONS(3945),
    [sym_constant] = ACTIONS(3947),
    [sym_identifier] = ACTIONS(3947),
    [sym_instance_variable] = ACTIONS(3949),
    [sym_class_variable] = ACTIONS(3949),
    [sym_global_variable] = ACTIONS(3949),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3947),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3947),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9182] = {
    [aux_sym_exceptions_repeat1] = STATE(10286),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(14006),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [9183] = {
    [anon_sym_DOT] = ACTIONS(13224),
    [anon_sym_LBRACK] = ACTIONS(13224),
    [anon_sym_COLON_COLON2] = ACTIONS(13224),
    [anon_sym_AMP_DOT] = ACTIONS(13224),
    [sym_comment] = ACTIONS(87),
  },
  [9184] = {
    [anon_sym_DOT] = ACTIONS(13235),
    [anon_sym_LBRACK] = ACTIONS(13235),
    [anon_sym_COLON_COLON2] = ACTIONS(13235),
    [anon_sym_AMP_DOT] = ACTIONS(13235),
    [sym_comment] = ACTIONS(87),
  },
  [9185] = {
    [anon_sym_end] = ACTIONS(14008),
    [sym_comment] = ACTIONS(87),
  },
  [9186] = {
    [anon_sym_DOT] = ACTIONS(13547),
    [anon_sym_LBRACK] = ACTIONS(13547),
    [anon_sym_COLON_COLON2] = ACTIONS(13547),
    [anon_sym_AMP_DOT] = ACTIONS(13547),
    [sym_comment] = ACTIONS(87),
  },
  [9187] = {
    [anon_sym_LBRACE] = ACTIONS(13712),
    [anon_sym_RPAREN] = ACTIONS(13712),
    [anon_sym_DOT] = ACTIONS(13712),
    [anon_sym_COMMA] = ACTIONS(13712),
    [anon_sym_PIPE] = ACTIONS(13712),
    [anon_sym_SEMI] = ACTIONS(13712),
    [anon_sym_EQ] = ACTIONS(13712),
    [anon_sym_in] = ACTIONS(13712),
    [anon_sym_do] = ACTIONS(13712),
    [anon_sym_LBRACK] = ACTIONS(13712),
    [anon_sym_COLON_COLON2] = ACTIONS(13712),
    [anon_sym_AMP_DOT] = ACTIONS(13712),
    [sym_comment] = ACTIONS(87),
  },
  [9188] = {
    [anon_sym_end] = ACTIONS(14010),
    [sym_comment] = ACTIONS(87),
  },
  [9189] = {
    [sym__heredoc_body_start] = ACTIONS(6601),
    [sym__binary_minus] = ACTIONS(6601),
    [sym__binary_star] = ACTIONS(6601),
    [anon_sym_LBRACE] = ACTIONS(6601),
    [anon_sym_RPAREN] = ACTIONS(6601),
    [anon_sym_DOT] = ACTIONS(6603),
    [anon_sym_COMMA] = ACTIONS(6601),
    [anon_sym_PIPE] = ACTIONS(6603),
    [anon_sym_STAR_STAR] = ACTIONS(6601),
    [anon_sym_AMP] = ACTIONS(6603),
    [anon_sym_EQ] = ACTIONS(6603),
    [anon_sym_LT] = ACTIONS(6603),
    [anon_sym_do] = ACTIONS(6601),
    [anon_sym_LBRACK] = ACTIONS(6601),
    [anon_sym_COLON_COLON2] = ACTIONS(6601),
    [anon_sym_AMP_DOT] = ACTIONS(6601),
    [anon_sym_QMARK] = ACTIONS(6601),
    [anon_sym_DOT_DOT] = ACTIONS(6603),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6601),
    [anon_sym_and] = ACTIONS(6601),
    [anon_sym_or] = ACTIONS(6601),
    [anon_sym_PIPE_PIPE] = ACTIONS(6601),
    [anon_sym_AMP_AMP] = ACTIONS(6601),
    [anon_sym_LT_LT] = ACTIONS(6601),
    [anon_sym_GT_GT] = ACTIONS(6601),
    [anon_sym_EQ_EQ] = ACTIONS(6603),
    [anon_sym_BANG_EQ] = ACTIONS(6601),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6601),
    [anon_sym_LT_EQ_GT] = ACTIONS(6601),
    [anon_sym_EQ_TILDE] = ACTIONS(6601),
    [anon_sym_BANG_TILDE] = ACTIONS(6601),
    [anon_sym_LT_EQ] = ACTIONS(6603),
    [anon_sym_GT] = ACTIONS(6603),
    [anon_sym_GT_EQ] = ACTIONS(6601),
    [anon_sym_CARET] = ACTIONS(6601),
    [anon_sym_PLUS] = ACTIONS(6601),
    [anon_sym_SLASH] = ACTIONS(6601),
    [anon_sym_PERCENT] = ACTIONS(6601),
    [sym_comment] = ACTIONS(87),
  },
  [9190] = {
    [sym__heredoc_body_start] = ACTIONS(6605),
    [sym__binary_minus] = ACTIONS(6605),
    [sym__binary_star] = ACTIONS(6605),
    [anon_sym_LBRACE] = ACTIONS(6605),
    [anon_sym_RPAREN] = ACTIONS(6605),
    [anon_sym_DOT] = ACTIONS(6607),
    [anon_sym_COMMA] = ACTIONS(6605),
    [anon_sym_PIPE] = ACTIONS(6607),
    [anon_sym_STAR_STAR] = ACTIONS(6605),
    [anon_sym_AMP] = ACTIONS(6607),
    [anon_sym_EQ] = ACTIONS(6607),
    [anon_sym_LT] = ACTIONS(6607),
    [anon_sym_do] = ACTIONS(6605),
    [anon_sym_LBRACK] = ACTIONS(6605),
    [anon_sym_COLON_COLON2] = ACTIONS(6605),
    [anon_sym_AMP_DOT] = ACTIONS(6605),
    [anon_sym_QMARK] = ACTIONS(6605),
    [anon_sym_DOT_DOT] = ACTIONS(6607),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6605),
    [anon_sym_and] = ACTIONS(6605),
    [anon_sym_or] = ACTIONS(6605),
    [anon_sym_PIPE_PIPE] = ACTIONS(6605),
    [anon_sym_AMP_AMP] = ACTIONS(6605),
    [anon_sym_LT_LT] = ACTIONS(6605),
    [anon_sym_GT_GT] = ACTIONS(6605),
    [anon_sym_EQ_EQ] = ACTIONS(6607),
    [anon_sym_BANG_EQ] = ACTIONS(6605),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6605),
    [anon_sym_LT_EQ_GT] = ACTIONS(6605),
    [anon_sym_EQ_TILDE] = ACTIONS(6605),
    [anon_sym_BANG_TILDE] = ACTIONS(6605),
    [anon_sym_LT_EQ] = ACTIONS(6607),
    [anon_sym_GT] = ACTIONS(6607),
    [anon_sym_GT_EQ] = ACTIONS(6605),
    [anon_sym_CARET] = ACTIONS(6605),
    [anon_sym_PLUS] = ACTIONS(6605),
    [anon_sym_SLASH] = ACTIONS(6605),
    [anon_sym_PERCENT] = ACTIONS(6605),
    [sym_comment] = ACTIONS(87),
  },
  [9191] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1697),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(14012),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [9192] = {
    [aux_sym_string_array_repeat1] = STATE(1699),
    [sym__string_end] = ACTIONS(14012),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(14014),
  },
  [9193] = {
    [sym__heredoc_body_start] = ACTIONS(6613),
    [sym__binary_minus] = ACTIONS(6613),
    [sym__binary_star] = ACTIONS(6613),
    [anon_sym_LBRACE] = ACTIONS(6613),
    [anon_sym_RPAREN] = ACTIONS(6613),
    [anon_sym_DOT] = ACTIONS(6615),
    [anon_sym_COMMA] = ACTIONS(6613),
    [anon_sym_PIPE] = ACTIONS(6615),
    [anon_sym_STAR_STAR] = ACTIONS(6613),
    [anon_sym_AMP] = ACTIONS(6615),
    [anon_sym_EQ] = ACTIONS(6615),
    [anon_sym_LT] = ACTIONS(6615),
    [anon_sym_do] = ACTIONS(6613),
    [anon_sym_LBRACK] = ACTIONS(6613),
    [anon_sym_COLON_COLON2] = ACTIONS(6613),
    [anon_sym_AMP_DOT] = ACTIONS(6613),
    [anon_sym_QMARK] = ACTIONS(6613),
    [anon_sym_DOT_DOT] = ACTIONS(6615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6613),
    [anon_sym_and] = ACTIONS(6613),
    [anon_sym_or] = ACTIONS(6613),
    [anon_sym_PIPE_PIPE] = ACTIONS(6613),
    [anon_sym_AMP_AMP] = ACTIONS(6613),
    [anon_sym_LT_LT] = ACTIONS(6613),
    [anon_sym_GT_GT] = ACTIONS(6613),
    [anon_sym_EQ_EQ] = ACTIONS(6615),
    [anon_sym_BANG_EQ] = ACTIONS(6613),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6613),
    [anon_sym_LT_EQ_GT] = ACTIONS(6613),
    [anon_sym_EQ_TILDE] = ACTIONS(6613),
    [anon_sym_BANG_TILDE] = ACTIONS(6613),
    [anon_sym_LT_EQ] = ACTIONS(6615),
    [anon_sym_GT] = ACTIONS(6615),
    [anon_sym_GT_EQ] = ACTIONS(6613),
    [anon_sym_CARET] = ACTIONS(6613),
    [anon_sym_PLUS] = ACTIONS(6613),
    [anon_sym_SLASH] = ACTIONS(6613),
    [anon_sym_PERCENT] = ACTIONS(6613),
    [sym_comment] = ACTIONS(87),
  },
  [9194] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1697),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(14016),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [9195] = {
    [sym__heredoc_body_start] = ACTIONS(6626),
    [sym__binary_minus] = ACTIONS(6626),
    [sym__binary_star] = ACTIONS(6626),
    [anon_sym_LBRACE] = ACTIONS(6626),
    [anon_sym_RPAREN] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(6628),
    [anon_sym_COMMA] = ACTIONS(6626),
    [anon_sym_PIPE] = ACTIONS(6628),
    [anon_sym_STAR_STAR] = ACTIONS(6626),
    [anon_sym_AMP] = ACTIONS(6628),
    [anon_sym_EQ] = ACTIONS(6628),
    [anon_sym_LT] = ACTIONS(6628),
    [anon_sym_do] = ACTIONS(6626),
    [anon_sym_LBRACK] = ACTIONS(6626),
    [anon_sym_COLON_COLON2] = ACTIONS(6626),
    [anon_sym_AMP_DOT] = ACTIONS(6626),
    [anon_sym_QMARK] = ACTIONS(6626),
    [anon_sym_DOT_DOT] = ACTIONS(6628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6626),
    [anon_sym_and] = ACTIONS(6626),
    [anon_sym_or] = ACTIONS(6626),
    [anon_sym_PIPE_PIPE] = ACTIONS(6626),
    [anon_sym_AMP_AMP] = ACTIONS(6626),
    [anon_sym_LT_LT] = ACTIONS(6626),
    [anon_sym_GT_GT] = ACTIONS(6626),
    [anon_sym_EQ_EQ] = ACTIONS(6628),
    [anon_sym_BANG_EQ] = ACTIONS(6626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6626),
    [anon_sym_LT_EQ_GT] = ACTIONS(6626),
    [anon_sym_EQ_TILDE] = ACTIONS(6626),
    [anon_sym_BANG_TILDE] = ACTIONS(6626),
    [anon_sym_LT_EQ] = ACTIONS(6628),
    [anon_sym_GT] = ACTIONS(6628),
    [anon_sym_GT_EQ] = ACTIONS(6626),
    [anon_sym_CARET] = ACTIONS(6626),
    [anon_sym_PLUS] = ACTIONS(6626),
    [anon_sym_SLASH] = ACTIONS(6626),
    [anon_sym_PERCENT] = ACTIONS(6626),
    [sym_comment] = ACTIONS(87),
  },
  [9196] = {
    [sym__heredoc_body_start] = ACTIONS(6630),
    [sym__binary_minus] = ACTIONS(6630),
    [sym__binary_star] = ACTIONS(6630),
    [anon_sym_LBRACE] = ACTIONS(6630),
    [anon_sym_RPAREN] = ACTIONS(6630),
    [anon_sym_DOT] = ACTIONS(6632),
    [anon_sym_COMMA] = ACTIONS(6630),
    [anon_sym_PIPE] = ACTIONS(6632),
    [anon_sym_STAR_STAR] = ACTIONS(6630),
    [anon_sym_AMP] = ACTIONS(6632),
    [anon_sym_EQ] = ACTIONS(6632),
    [anon_sym_LT] = ACTIONS(6632),
    [anon_sym_do] = ACTIONS(6630),
    [anon_sym_LBRACK] = ACTIONS(6630),
    [anon_sym_COLON_COLON2] = ACTIONS(6630),
    [anon_sym_AMP_DOT] = ACTIONS(6630),
    [anon_sym_QMARK] = ACTIONS(6630),
    [anon_sym_DOT_DOT] = ACTIONS(6632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6630),
    [anon_sym_and] = ACTIONS(6630),
    [anon_sym_or] = ACTIONS(6630),
    [anon_sym_PIPE_PIPE] = ACTIONS(6630),
    [anon_sym_AMP_AMP] = ACTIONS(6630),
    [anon_sym_LT_LT] = ACTIONS(6630),
    [anon_sym_GT_GT] = ACTIONS(6630),
    [anon_sym_EQ_EQ] = ACTIONS(6632),
    [anon_sym_BANG_EQ] = ACTIONS(6630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6630),
    [anon_sym_LT_EQ_GT] = ACTIONS(6630),
    [anon_sym_EQ_TILDE] = ACTIONS(6630),
    [anon_sym_BANG_TILDE] = ACTIONS(6630),
    [anon_sym_LT_EQ] = ACTIONS(6632),
    [anon_sym_GT] = ACTIONS(6632),
    [anon_sym_GT_EQ] = ACTIONS(6630),
    [anon_sym_CARET] = ACTIONS(6630),
    [anon_sym_PLUS] = ACTIONS(6630),
    [anon_sym_SLASH] = ACTIONS(6630),
    [anon_sym_PERCENT] = ACTIONS(6630),
    [sym_comment] = ACTIONS(87),
  },
  [9197] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1705),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(14018),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [9198] = {
    [aux_sym_symbol_array_repeat1] = STATE(1707),
    [sym__string_end] = ACTIONS(14018),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(14020),
  },
  [9199] = {
    [sym__heredoc_body_start] = ACTIONS(6638),
    [sym__binary_minus] = ACTIONS(6638),
    [sym__binary_star] = ACTIONS(6638),
    [anon_sym_LBRACE] = ACTIONS(6638),
    [anon_sym_RPAREN] = ACTIONS(6638),
    [anon_sym_DOT] = ACTIONS(6640),
    [anon_sym_COMMA] = ACTIONS(6638),
    [anon_sym_PIPE] = ACTIONS(6640),
    [anon_sym_STAR_STAR] = ACTIONS(6638),
    [anon_sym_AMP] = ACTIONS(6640),
    [anon_sym_EQ] = ACTIONS(6640),
    [anon_sym_LT] = ACTIONS(6640),
    [anon_sym_do] = ACTIONS(6638),
    [anon_sym_LBRACK] = ACTIONS(6638),
    [anon_sym_COLON_COLON2] = ACTIONS(6638),
    [anon_sym_AMP_DOT] = ACTIONS(6638),
    [anon_sym_QMARK] = ACTIONS(6638),
    [anon_sym_DOT_DOT] = ACTIONS(6640),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6638),
    [anon_sym_and] = ACTIONS(6638),
    [anon_sym_or] = ACTIONS(6638),
    [anon_sym_PIPE_PIPE] = ACTIONS(6638),
    [anon_sym_AMP_AMP] = ACTIONS(6638),
    [anon_sym_LT_LT] = ACTIONS(6638),
    [anon_sym_GT_GT] = ACTIONS(6638),
    [anon_sym_EQ_EQ] = ACTIONS(6640),
    [anon_sym_BANG_EQ] = ACTIONS(6638),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6638),
    [anon_sym_LT_EQ_GT] = ACTIONS(6638),
    [anon_sym_EQ_TILDE] = ACTIONS(6638),
    [anon_sym_BANG_TILDE] = ACTIONS(6638),
    [anon_sym_LT_EQ] = ACTIONS(6640),
    [anon_sym_GT] = ACTIONS(6640),
    [anon_sym_GT_EQ] = ACTIONS(6638),
    [anon_sym_CARET] = ACTIONS(6638),
    [anon_sym_PLUS] = ACTIONS(6638),
    [anon_sym_SLASH] = ACTIONS(6638),
    [anon_sym_PERCENT] = ACTIONS(6638),
    [sym_comment] = ACTIONS(87),
  },
  [9200] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1705),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(14022),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [9201] = {
    [sym__heredoc_body_start] = ACTIONS(7162),
    [sym__binary_minus] = ACTIONS(7162),
    [sym__binary_star] = ACTIONS(7162),
    [anon_sym_LBRACE] = ACTIONS(7162),
    [anon_sym_RPAREN] = ACTIONS(7162),
    [anon_sym_DOT] = ACTIONS(7164),
    [anon_sym_COMMA] = ACTIONS(7162),
    [anon_sym_PIPE] = ACTIONS(7164),
    [anon_sym_STAR_STAR] = ACTIONS(7162),
    [anon_sym_AMP] = ACTIONS(7164),
    [anon_sym_EQ] = ACTIONS(7164),
    [anon_sym_LT] = ACTIONS(7164),
    [anon_sym_do] = ACTIONS(7162),
    [anon_sym_LBRACK] = ACTIONS(7162),
    [anon_sym_COLON_COLON2] = ACTIONS(7162),
    [anon_sym_AMP_DOT] = ACTIONS(7162),
    [anon_sym_QMARK] = ACTIONS(7162),
    [anon_sym_DOT_DOT] = ACTIONS(7164),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7162),
    [anon_sym_and] = ACTIONS(7162),
    [anon_sym_or] = ACTIONS(7162),
    [anon_sym_PIPE_PIPE] = ACTIONS(7162),
    [anon_sym_AMP_AMP] = ACTIONS(7162),
    [anon_sym_LT_LT] = ACTIONS(7162),
    [anon_sym_GT_GT] = ACTIONS(7162),
    [anon_sym_EQ_EQ] = ACTIONS(7164),
    [anon_sym_BANG_EQ] = ACTIONS(7162),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7162),
    [anon_sym_LT_EQ_GT] = ACTIONS(7162),
    [anon_sym_EQ_TILDE] = ACTIONS(7162),
    [anon_sym_BANG_TILDE] = ACTIONS(7162),
    [anon_sym_LT_EQ] = ACTIONS(7164),
    [anon_sym_GT] = ACTIONS(7164),
    [anon_sym_GT_EQ] = ACTIONS(7162),
    [anon_sym_CARET] = ACTIONS(7162),
    [anon_sym_PLUS] = ACTIONS(7162),
    [anon_sym_SLASH] = ACTIONS(7162),
    [anon_sym_PERCENT] = ACTIONS(7162),
    [sym_comment] = ACTIONS(87),
  },
  [9202] = {
    [anon_sym_DOT] = ACTIONS(14024),
    [anon_sym_COLON_COLON] = ACTIONS(14024),
    [sym_comment] = ACTIONS(87),
  },
  [9203] = {
    [sym__heredoc_body_start] = ACTIONS(7314),
    [sym__binary_minus] = ACTIONS(7314),
    [sym__binary_star] = ACTIONS(7314),
    [anon_sym_LBRACE] = ACTIONS(7314),
    [anon_sym_RPAREN] = ACTIONS(7314),
    [anon_sym_DOT] = ACTIONS(7316),
    [anon_sym_COMMA] = ACTIONS(7314),
    [anon_sym_PIPE] = ACTIONS(7316),
    [anon_sym_STAR_STAR] = ACTIONS(7314),
    [anon_sym_AMP] = ACTIONS(7316),
    [anon_sym_EQ] = ACTIONS(7316),
    [anon_sym_LT] = ACTIONS(7316),
    [anon_sym_do] = ACTIONS(7314),
    [anon_sym_LBRACK] = ACTIONS(7314),
    [anon_sym_COLON_COLON2] = ACTIONS(7314),
    [anon_sym_AMP_DOT] = ACTIONS(7314),
    [anon_sym_QMARK] = ACTIONS(7314),
    [anon_sym_DOT_DOT] = ACTIONS(7316),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7314),
    [anon_sym_and] = ACTIONS(7314),
    [anon_sym_or] = ACTIONS(7314),
    [anon_sym_PIPE_PIPE] = ACTIONS(7314),
    [anon_sym_AMP_AMP] = ACTIONS(7314),
    [anon_sym_LT_LT] = ACTIONS(7314),
    [anon_sym_GT_GT] = ACTIONS(7314),
    [anon_sym_EQ_EQ] = ACTIONS(7316),
    [anon_sym_BANG_EQ] = ACTIONS(7314),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7314),
    [anon_sym_LT_EQ_GT] = ACTIONS(7314),
    [anon_sym_EQ_TILDE] = ACTIONS(7314),
    [anon_sym_BANG_TILDE] = ACTIONS(7314),
    [anon_sym_LT_EQ] = ACTIONS(7316),
    [anon_sym_GT] = ACTIONS(7316),
    [anon_sym_GT_EQ] = ACTIONS(7314),
    [anon_sym_CARET] = ACTIONS(7314),
    [anon_sym_PLUS] = ACTIONS(7314),
    [anon_sym_SLASH] = ACTIONS(7314),
    [anon_sym_PERCENT] = ACTIONS(7314),
    [sym_comment] = ACTIONS(87),
  },
  [9204] = {
    [sym__heredoc_body_start] = ACTIONS(7330),
    [sym__binary_minus] = ACTIONS(7330),
    [sym__binary_star] = ACTIONS(7330),
    [anon_sym_LBRACE] = ACTIONS(7330),
    [anon_sym_RPAREN] = ACTIONS(7330),
    [anon_sym_DOT] = ACTIONS(7332),
    [anon_sym_COMMA] = ACTIONS(7330),
    [anon_sym_PIPE] = ACTIONS(7332),
    [anon_sym_STAR_STAR] = ACTIONS(7330),
    [anon_sym_AMP] = ACTIONS(7332),
    [anon_sym_EQ] = ACTIONS(7332),
    [anon_sym_LT] = ACTIONS(7332),
    [anon_sym_do] = ACTIONS(7330),
    [anon_sym_LBRACK] = ACTIONS(7330),
    [anon_sym_COLON_COLON2] = ACTIONS(7330),
    [anon_sym_AMP_DOT] = ACTIONS(7330),
    [anon_sym_QMARK] = ACTIONS(7330),
    [anon_sym_DOT_DOT] = ACTIONS(7332),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7330),
    [anon_sym_and] = ACTIONS(7330),
    [anon_sym_or] = ACTIONS(7330),
    [anon_sym_PIPE_PIPE] = ACTIONS(7330),
    [anon_sym_AMP_AMP] = ACTIONS(7330),
    [anon_sym_LT_LT] = ACTIONS(7330),
    [anon_sym_GT_GT] = ACTIONS(7330),
    [anon_sym_EQ_EQ] = ACTIONS(7332),
    [anon_sym_BANG_EQ] = ACTIONS(7330),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7330),
    [anon_sym_LT_EQ_GT] = ACTIONS(7330),
    [anon_sym_EQ_TILDE] = ACTIONS(7330),
    [anon_sym_BANG_TILDE] = ACTIONS(7330),
    [anon_sym_LT_EQ] = ACTIONS(7332),
    [anon_sym_GT] = ACTIONS(7332),
    [anon_sym_GT_EQ] = ACTIONS(7330),
    [anon_sym_CARET] = ACTIONS(7330),
    [anon_sym_PLUS] = ACTIONS(7330),
    [anon_sym_SLASH] = ACTIONS(7330),
    [anon_sym_PERCENT] = ACTIONS(7330),
    [sym_comment] = ACTIONS(87),
  },
  [9205] = {
    [sym__statements] = STATE(4775),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(4776),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(4777),
    [sym_rescue] = STATE(4778),
    [sym__body_statement] = STATE(10296),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(14026),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9206] = {
    [sym__statements] = STATE(4775),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(4776),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(4777),
    [sym_rescue] = STATE(4778),
    [sym__body_statement] = STATE(10297),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(14028),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9207] = {
    [sym__heredoc_body_start] = ACTIONS(7764),
    [sym__binary_minus] = ACTIONS(7764),
    [sym__binary_star] = ACTIONS(7764),
    [anon_sym_LBRACE] = ACTIONS(7764),
    [anon_sym_RPAREN] = ACTIONS(7764),
    [anon_sym_DOT] = ACTIONS(7766),
    [anon_sym_COMMA] = ACTIONS(7764),
    [anon_sym_PIPE] = ACTIONS(7766),
    [anon_sym_STAR_STAR] = ACTIONS(7764),
    [anon_sym_AMP] = ACTIONS(7766),
    [anon_sym_EQ] = ACTIONS(7766),
    [anon_sym_LT] = ACTIONS(7766),
    [anon_sym_do] = ACTIONS(7764),
    [anon_sym_LBRACK] = ACTIONS(7764),
    [anon_sym_COLON_COLON2] = ACTIONS(7764),
    [anon_sym_AMP_DOT] = ACTIONS(7764),
    [anon_sym_QMARK] = ACTIONS(7764),
    [anon_sym_DOT_DOT] = ACTIONS(7766),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7764),
    [anon_sym_and] = ACTIONS(7764),
    [anon_sym_or] = ACTIONS(7764),
    [anon_sym_PIPE_PIPE] = ACTIONS(7764),
    [anon_sym_AMP_AMP] = ACTIONS(7764),
    [anon_sym_LT_LT] = ACTIONS(7764),
    [anon_sym_GT_GT] = ACTIONS(7764),
    [anon_sym_EQ_EQ] = ACTIONS(7766),
    [anon_sym_BANG_EQ] = ACTIONS(7764),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7764),
    [anon_sym_LT_EQ_GT] = ACTIONS(7764),
    [anon_sym_EQ_TILDE] = ACTIONS(7764),
    [anon_sym_BANG_TILDE] = ACTIONS(7764),
    [anon_sym_LT_EQ] = ACTIONS(7766),
    [anon_sym_GT] = ACTIONS(7766),
    [anon_sym_GT_EQ] = ACTIONS(7764),
    [anon_sym_CARET] = ACTIONS(7764),
    [anon_sym_PLUS] = ACTIONS(7764),
    [anon_sym_SLASH] = ACTIONS(7764),
    [anon_sym_PERCENT] = ACTIONS(7764),
    [sym_comment] = ACTIONS(87),
  },
  [9208] = {
    [sym__heredoc_body_start] = ACTIONS(7818),
    [sym__binary_minus] = ACTIONS(7818),
    [sym__binary_star] = ACTIONS(7818),
    [anon_sym_LBRACE] = ACTIONS(7818),
    [anon_sym_RPAREN] = ACTIONS(7818),
    [anon_sym_DOT] = ACTIONS(7820),
    [anon_sym_COMMA] = ACTIONS(7818),
    [anon_sym_PIPE] = ACTIONS(7820),
    [anon_sym_STAR_STAR] = ACTIONS(7818),
    [anon_sym_AMP] = ACTIONS(7820),
    [anon_sym_EQ] = ACTIONS(7820),
    [anon_sym_LT] = ACTIONS(7820),
    [anon_sym_do] = ACTIONS(7818),
    [anon_sym_LBRACK] = ACTIONS(7818),
    [anon_sym_COLON_COLON2] = ACTIONS(7818),
    [anon_sym_AMP_DOT] = ACTIONS(7818),
    [anon_sym_QMARK] = ACTIONS(7818),
    [anon_sym_DOT_DOT] = ACTIONS(7820),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7818),
    [anon_sym_and] = ACTIONS(7818),
    [anon_sym_or] = ACTIONS(7818),
    [anon_sym_PIPE_PIPE] = ACTIONS(7818),
    [anon_sym_AMP_AMP] = ACTIONS(7818),
    [anon_sym_LT_LT] = ACTIONS(7818),
    [anon_sym_GT_GT] = ACTIONS(7818),
    [anon_sym_EQ_EQ] = ACTIONS(7820),
    [anon_sym_BANG_EQ] = ACTIONS(7818),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7818),
    [anon_sym_LT_EQ_GT] = ACTIONS(7818),
    [anon_sym_EQ_TILDE] = ACTIONS(7818),
    [anon_sym_BANG_TILDE] = ACTIONS(7818),
    [anon_sym_LT_EQ] = ACTIONS(7820),
    [anon_sym_GT] = ACTIONS(7820),
    [anon_sym_GT_EQ] = ACTIONS(7818),
    [anon_sym_CARET] = ACTIONS(7818),
    [anon_sym_PLUS] = ACTIONS(7818),
    [anon_sym_SLASH] = ACTIONS(7818),
    [anon_sym_PERCENT] = ACTIONS(7818),
    [sym_comment] = ACTIONS(87),
  },
  [9209] = {
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(7711),
    [sym__binary_star] = ACTIONS(7713),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(7715),
    [anon_sym_STAR_STAR] = ACTIONS(7713),
    [anon_sym_AMP] = ACTIONS(7717),
    [anon_sym_EQ] = ACTIONS(7822),
    [anon_sym_LT] = ACTIONS(7719),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(7721),
    [anon_sym_DOT_DOT] = ACTIONS(7723),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7725),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(7729),
    [anon_sym_AMP_AMP] = ACTIONS(7729),
    [anon_sym_LT_LT] = ACTIONS(7731),
    [anon_sym_GT_GT] = ACTIONS(7731),
    [anon_sym_EQ_EQ] = ACTIONS(7733),
    [anon_sym_BANG_EQ] = ACTIONS(7729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7729),
    [anon_sym_LT_EQ_GT] = ACTIONS(7729),
    [anon_sym_EQ_TILDE] = ACTIONS(7729),
    [anon_sym_BANG_TILDE] = ACTIONS(7729),
    [anon_sym_LT_EQ] = ACTIONS(7719),
    [anon_sym_GT] = ACTIONS(7719),
    [anon_sym_GT_EQ] = ACTIONS(7735),
    [anon_sym_CARET] = ACTIONS(7737),
    [anon_sym_PLUS] = ACTIONS(7711),
    [anon_sym_SLASH] = ACTIONS(7713),
    [anon_sym_PERCENT] = ACTIONS(7713),
    [sym_comment] = ACTIONS(87),
  },
  [9210] = {
    [sym__heredoc_body_start] = ACTIONS(7876),
    [sym__binary_minus] = ACTIONS(7876),
    [sym__binary_star] = ACTIONS(7876),
    [anon_sym_LBRACE] = ACTIONS(7876),
    [anon_sym_RPAREN] = ACTIONS(7876),
    [anon_sym_DOT] = ACTIONS(7878),
    [anon_sym_COMMA] = ACTIONS(7876),
    [anon_sym_PIPE] = ACTIONS(7878),
    [anon_sym_STAR_STAR] = ACTIONS(7876),
    [anon_sym_AMP] = ACTIONS(7878),
    [anon_sym_EQ] = ACTIONS(7878),
    [anon_sym_LT] = ACTIONS(7878),
    [anon_sym_do] = ACTIONS(7876),
    [anon_sym_LBRACK] = ACTIONS(7876),
    [anon_sym_COLON_COLON2] = ACTIONS(7876),
    [anon_sym_AMP_DOT] = ACTIONS(7876),
    [anon_sym_QMARK] = ACTIONS(7876),
    [anon_sym_DOT_DOT] = ACTIONS(7878),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7876),
    [anon_sym_and] = ACTIONS(7876),
    [anon_sym_or] = ACTIONS(7876),
    [anon_sym_PIPE_PIPE] = ACTIONS(7876),
    [anon_sym_AMP_AMP] = ACTIONS(7876),
    [anon_sym_LT_LT] = ACTIONS(7876),
    [anon_sym_GT_GT] = ACTIONS(7876),
    [anon_sym_EQ_EQ] = ACTIONS(7878),
    [anon_sym_BANG_EQ] = ACTIONS(7876),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7876),
    [anon_sym_LT_EQ_GT] = ACTIONS(7876),
    [anon_sym_EQ_TILDE] = ACTIONS(7876),
    [anon_sym_BANG_TILDE] = ACTIONS(7876),
    [anon_sym_LT_EQ] = ACTIONS(7878),
    [anon_sym_GT] = ACTIONS(7878),
    [anon_sym_GT_EQ] = ACTIONS(7876),
    [anon_sym_CARET] = ACTIONS(7876),
    [anon_sym_PLUS] = ACTIONS(7876),
    [anon_sym_SLASH] = ACTIONS(7876),
    [anon_sym_PERCENT] = ACTIONS(7876),
    [sym_comment] = ACTIONS(87),
  },
  [9211] = {
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(7711),
    [sym__binary_star] = ACTIONS(7713),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(7715),
    [anon_sym_STAR_STAR] = ACTIONS(7713),
    [anon_sym_AMP] = ACTIONS(7717),
    [anon_sym_EQ] = ACTIONS(7884),
    [anon_sym_LT] = ACTIONS(7719),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(7721),
    [anon_sym_DOT_DOT] = ACTIONS(7723),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7725),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(7729),
    [anon_sym_AMP_AMP] = ACTIONS(7729),
    [anon_sym_LT_LT] = ACTIONS(7731),
    [anon_sym_GT_GT] = ACTIONS(7731),
    [anon_sym_EQ_EQ] = ACTIONS(7733),
    [anon_sym_BANG_EQ] = ACTIONS(7729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7729),
    [anon_sym_LT_EQ_GT] = ACTIONS(7729),
    [anon_sym_EQ_TILDE] = ACTIONS(7729),
    [anon_sym_BANG_TILDE] = ACTIONS(7729),
    [anon_sym_LT_EQ] = ACTIONS(7719),
    [anon_sym_GT] = ACTIONS(7719),
    [anon_sym_GT_EQ] = ACTIONS(7735),
    [anon_sym_CARET] = ACTIONS(7737),
    [anon_sym_PLUS] = ACTIONS(7711),
    [anon_sym_SLASH] = ACTIONS(7713),
    [anon_sym_PERCENT] = ACTIONS(7713),
    [sym_comment] = ACTIONS(87),
  },
  [9212] = {
    [sym__heredoc_body_start] = ACTIONS(3235),
    [sym__binary_minus] = ACTIONS(3235),
    [sym__binary_star] = ACTIONS(3235),
    [anon_sym_LBRACE] = ACTIONS(3235),
    [anon_sym_RPAREN] = ACTIONS(3235),
    [anon_sym_DOT] = ACTIONS(4997),
    [anon_sym_COMMA] = ACTIONS(3235),
    [anon_sym_PIPE] = ACTIONS(4997),
    [anon_sym_STAR_STAR] = ACTIONS(3235),
    [anon_sym_AMP] = ACTIONS(4997),
    [anon_sym_EQ] = ACTIONS(4997),
    [anon_sym_LT] = ACTIONS(4997),
    [anon_sym_do] = ACTIONS(3235),
    [anon_sym_LBRACK] = ACTIONS(3235),
    [anon_sym_COLON_COLON2] = ACTIONS(3235),
    [anon_sym_AMP_DOT] = ACTIONS(3235),
    [anon_sym_QMARK] = ACTIONS(3235),
    [anon_sym_DOT_DOT] = ACTIONS(4997),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3235),
    [anon_sym_and] = ACTIONS(3235),
    [anon_sym_or] = ACTIONS(3235),
    [anon_sym_PIPE_PIPE] = ACTIONS(3235),
    [anon_sym_AMP_AMP] = ACTIONS(3235),
    [anon_sym_LT_LT] = ACTIONS(3235),
    [anon_sym_GT_GT] = ACTIONS(3235),
    [anon_sym_EQ_EQ] = ACTIONS(4997),
    [anon_sym_BANG_EQ] = ACTIONS(3235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3235),
    [anon_sym_LT_EQ_GT] = ACTIONS(3235),
    [anon_sym_EQ_TILDE] = ACTIONS(3235),
    [anon_sym_BANG_TILDE] = ACTIONS(3235),
    [anon_sym_LT_EQ] = ACTIONS(4997),
    [anon_sym_GT] = ACTIONS(4997),
    [anon_sym_GT_EQ] = ACTIONS(3235),
    [anon_sym_CARET] = ACTIONS(3235),
    [anon_sym_PLUS] = ACTIONS(3235),
    [anon_sym_SLASH] = ACTIONS(3235),
    [anon_sym_PERCENT] = ACTIONS(3235),
    [sym_comment] = ACTIONS(87),
  },
  [9213] = {
    [sym_interpolation] = STATE(1787),
    [aux_sym_heredoc_body_repeat1] = STATE(1787),
    [sym__heredoc_content] = ACTIONS(3237),
    [sym_heredoc_end] = ACTIONS(14030),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(3237),
  },
  [9214] = {
    [sym_heredoc_body] = STATE(9214),
    [aux_sym_call_repeat1] = STATE(9214),
    [sym__heredoc_body_start] = ACTIONS(14032),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_EQ] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [9215] = {
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_RPAREN] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(7925),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_STAR_STAR] = ACTIONS(7925),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_EQ] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7925),
    [anon_sym_AMP_AMP] = ACTIONS(7925),
    [anon_sym_LT_LT] = ACTIONS(7925),
    [anon_sym_GT_GT] = ACTIONS(7925),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7925),
    [anon_sym_PLUS] = ACTIONS(7925),
    [anon_sym_SLASH] = ACTIONS(7925),
    [anon_sym_PERCENT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [9216] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4760),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(837),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(837),
    [sym__argument] = STATE(10299),
    [sym_splat_argument] = STATE(10299),
    [sym_hash_splat_argument] = STATE(10299),
    [sym_block_argument] = STATE(10299),
    [sym_assignment] = STATE(4760),
    [sym_operator_assignment] = STATE(4760),
    [sym_conditional] = STATE(4760),
    [sym_range] = STATE(4760),
    [sym_binary] = STATE(4760),
    [sym_unary] = STATE(4760),
    [sym_left_assignment_list] = STATE(836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(837),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(837),
    [sym_false] = STATE(837),
    [sym_nil] = STATE(837),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4764),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(10299),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(7687),
    [sym__splat_star] = ACTIONS(7689),
    [sym__unary_minus] = ACTIONS(1485),
    [sym__identifier_hash_key] = ACTIONS(7691),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12818),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1493),
    [anon_sym_yield] = ACTIONS(1495),
    [anon_sym_break] = ACTIONS(1497),
    [anon_sym_next] = ACTIONS(1499),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1507),
    [anon_sym_TILDE] = ACTIONS(1507),
    [sym_constant] = ACTIONS(7695),
    [sym_identifier] = ACTIONS(7695),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9217] = {
    [sym_heredoc_body] = STATE(9214),
    [aux_sym_call_repeat1] = STATE(9214),
    [sym__heredoc_body_start] = ACTIONS(10884),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_EQ] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [9218] = {
    [aux_sym_argument_list_repeat1] = STATE(9218),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(14035),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_STAR_STAR] = ACTIONS(7925),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_EQ] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7925),
    [anon_sym_AMP_AMP] = ACTIONS(7925),
    [anon_sym_LT_LT] = ACTIONS(7925),
    [anon_sym_GT_GT] = ACTIONS(7925),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7925),
    [anon_sym_PLUS] = ACTIONS(7925),
    [anon_sym_SLASH] = ACTIONS(7925),
    [anon_sym_PERCENT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [9219] = {
    [sym__heredoc_body_start] = ACTIONS(8098),
    [sym__binary_minus] = ACTIONS(8098),
    [sym__binary_star] = ACTIONS(8098),
    [anon_sym_LBRACE] = ACTIONS(8098),
    [anon_sym_RPAREN] = ACTIONS(8098),
    [anon_sym_DOT] = ACTIONS(8100),
    [anon_sym_COMMA] = ACTIONS(8098),
    [anon_sym_PIPE] = ACTIONS(8100),
    [anon_sym_STAR_STAR] = ACTIONS(8098),
    [anon_sym_AMP] = ACTIONS(8100),
    [anon_sym_EQ] = ACTIONS(8100),
    [anon_sym_LT] = ACTIONS(8100),
    [anon_sym_do] = ACTIONS(8098),
    [anon_sym_LBRACK] = ACTIONS(8098),
    [anon_sym_COLON_COLON2] = ACTIONS(8098),
    [anon_sym_AMP_DOT] = ACTIONS(8098),
    [anon_sym_QMARK] = ACTIONS(8098),
    [anon_sym_DOT_DOT] = ACTIONS(8100),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8098),
    [anon_sym_and] = ACTIONS(8098),
    [anon_sym_or] = ACTIONS(8098),
    [anon_sym_PIPE_PIPE] = ACTIONS(8098),
    [anon_sym_AMP_AMP] = ACTIONS(8098),
    [anon_sym_LT_LT] = ACTIONS(8098),
    [anon_sym_GT_GT] = ACTIONS(8098),
    [anon_sym_EQ_EQ] = ACTIONS(8100),
    [anon_sym_BANG_EQ] = ACTIONS(8098),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8098),
    [anon_sym_LT_EQ_GT] = ACTIONS(8098),
    [anon_sym_EQ_TILDE] = ACTIONS(8098),
    [anon_sym_BANG_TILDE] = ACTIONS(8098),
    [anon_sym_LT_EQ] = ACTIONS(8100),
    [anon_sym_GT] = ACTIONS(8100),
    [anon_sym_GT_EQ] = ACTIONS(8098),
    [anon_sym_CARET] = ACTIONS(8098),
    [anon_sym_PLUS] = ACTIONS(8098),
    [anon_sym_SLASH] = ACTIONS(8098),
    [anon_sym_PERCENT] = ACTIONS(8098),
    [sym_comment] = ACTIONS(87),
  },
  [9220] = {
    [anon_sym_end] = ACTIONS(14038),
    [sym_comment] = ACTIONS(87),
  },
  [9221] = {
    [sym__heredoc_body_start] = ACTIONS(8284),
    [sym__binary_minus] = ACTIONS(8284),
    [sym__binary_star] = ACTIONS(8284),
    [anon_sym_LBRACE] = ACTIONS(8284),
    [anon_sym_RPAREN] = ACTIONS(8284),
    [anon_sym_DOT] = ACTIONS(8286),
    [anon_sym_COMMA] = ACTIONS(8284),
    [anon_sym_PIPE] = ACTIONS(8286),
    [anon_sym_STAR_STAR] = ACTIONS(8284),
    [anon_sym_AMP] = ACTIONS(8286),
    [anon_sym_EQ] = ACTIONS(8286),
    [anon_sym_LT] = ACTIONS(8286),
    [anon_sym_do] = ACTIONS(8284),
    [anon_sym_LBRACK] = ACTIONS(8284),
    [anon_sym_COLON_COLON2] = ACTIONS(8284),
    [anon_sym_AMP_DOT] = ACTIONS(8284),
    [anon_sym_QMARK] = ACTIONS(8284),
    [anon_sym_DOT_DOT] = ACTIONS(8286),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8284),
    [anon_sym_and] = ACTIONS(8284),
    [anon_sym_or] = ACTIONS(8284),
    [anon_sym_PIPE_PIPE] = ACTIONS(8284),
    [anon_sym_AMP_AMP] = ACTIONS(8284),
    [anon_sym_LT_LT] = ACTIONS(8284),
    [anon_sym_GT_GT] = ACTIONS(8284),
    [anon_sym_EQ_EQ] = ACTIONS(8286),
    [anon_sym_BANG_EQ] = ACTIONS(8284),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8284),
    [anon_sym_LT_EQ_GT] = ACTIONS(8284),
    [anon_sym_EQ_TILDE] = ACTIONS(8284),
    [anon_sym_BANG_TILDE] = ACTIONS(8284),
    [anon_sym_LT_EQ] = ACTIONS(8286),
    [anon_sym_GT] = ACTIONS(8286),
    [anon_sym_GT_EQ] = ACTIONS(8284),
    [anon_sym_CARET] = ACTIONS(8284),
    [anon_sym_PLUS] = ACTIONS(8284),
    [anon_sym_SLASH] = ACTIONS(8284),
    [anon_sym_PERCENT] = ACTIONS(8284),
    [sym_comment] = ACTIONS(87),
  },
  [9222] = {
    [anon_sym_end] = ACTIONS(14040),
    [sym_comment] = ACTIONS(87),
  },
  [9223] = {
    [sym__heredoc_body_start] = ACTIONS(8344),
    [sym__binary_minus] = ACTIONS(8344),
    [sym__binary_star] = ACTIONS(8344),
    [anon_sym_LBRACE] = ACTIONS(8344),
    [anon_sym_RPAREN] = ACTIONS(8344),
    [anon_sym_DOT] = ACTIONS(8346),
    [anon_sym_COMMA] = ACTIONS(8344),
    [anon_sym_PIPE] = ACTIONS(8346),
    [anon_sym_STAR_STAR] = ACTIONS(8344),
    [anon_sym_AMP] = ACTIONS(8346),
    [anon_sym_EQ] = ACTIONS(8346),
    [anon_sym_LT] = ACTIONS(8346),
    [anon_sym_do] = ACTIONS(8344),
    [anon_sym_LBRACK] = ACTIONS(8344),
    [anon_sym_COLON_COLON2] = ACTIONS(8344),
    [anon_sym_AMP_DOT] = ACTIONS(8344),
    [anon_sym_QMARK] = ACTIONS(8344),
    [anon_sym_DOT_DOT] = ACTIONS(8346),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8344),
    [anon_sym_and] = ACTIONS(8344),
    [anon_sym_or] = ACTIONS(8344),
    [anon_sym_PIPE_PIPE] = ACTIONS(8344),
    [anon_sym_AMP_AMP] = ACTIONS(8344),
    [anon_sym_LT_LT] = ACTIONS(8344),
    [anon_sym_GT_GT] = ACTIONS(8344),
    [anon_sym_EQ_EQ] = ACTIONS(8346),
    [anon_sym_BANG_EQ] = ACTIONS(8344),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8344),
    [anon_sym_LT_EQ_GT] = ACTIONS(8344),
    [anon_sym_EQ_TILDE] = ACTIONS(8344),
    [anon_sym_BANG_TILDE] = ACTIONS(8344),
    [anon_sym_LT_EQ] = ACTIONS(8346),
    [anon_sym_GT] = ACTIONS(8346),
    [anon_sym_GT_EQ] = ACTIONS(8344),
    [anon_sym_CARET] = ACTIONS(8344),
    [anon_sym_PLUS] = ACTIONS(8344),
    [anon_sym_SLASH] = ACTIONS(8344),
    [anon_sym_PERCENT] = ACTIONS(8344),
    [sym_comment] = ACTIONS(87),
  },
  [9224] = {
    [anon_sym_end] = ACTIONS(14042),
    [sym_comment] = ACTIONS(87),
  },
  [9225] = {
    [sym__heredoc_body_start] = ACTIONS(8420),
    [sym__binary_minus] = ACTIONS(8420),
    [sym__binary_star] = ACTIONS(8420),
    [anon_sym_LBRACE] = ACTIONS(8420),
    [anon_sym_RPAREN] = ACTIONS(8420),
    [anon_sym_DOT] = ACTIONS(8422),
    [anon_sym_COMMA] = ACTIONS(8420),
    [anon_sym_PIPE] = ACTIONS(8422),
    [anon_sym_STAR_STAR] = ACTIONS(8420),
    [anon_sym_AMP] = ACTIONS(8422),
    [anon_sym_EQ] = ACTIONS(8422),
    [anon_sym_LT] = ACTIONS(8422),
    [anon_sym_do] = ACTIONS(8420),
    [anon_sym_LBRACK] = ACTIONS(8420),
    [anon_sym_COLON_COLON2] = ACTIONS(8420),
    [anon_sym_AMP_DOT] = ACTIONS(8420),
    [anon_sym_QMARK] = ACTIONS(8420),
    [anon_sym_DOT_DOT] = ACTIONS(8422),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8420),
    [anon_sym_and] = ACTIONS(8420),
    [anon_sym_or] = ACTIONS(8420),
    [anon_sym_PIPE_PIPE] = ACTIONS(8420),
    [anon_sym_AMP_AMP] = ACTIONS(8420),
    [anon_sym_LT_LT] = ACTIONS(8420),
    [anon_sym_GT_GT] = ACTIONS(8420),
    [anon_sym_EQ_EQ] = ACTIONS(8422),
    [anon_sym_BANG_EQ] = ACTIONS(8420),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8420),
    [anon_sym_LT_EQ_GT] = ACTIONS(8420),
    [anon_sym_EQ_TILDE] = ACTIONS(8420),
    [anon_sym_BANG_TILDE] = ACTIONS(8420),
    [anon_sym_LT_EQ] = ACTIONS(8422),
    [anon_sym_GT] = ACTIONS(8422),
    [anon_sym_GT_EQ] = ACTIONS(8420),
    [anon_sym_CARET] = ACTIONS(8420),
    [anon_sym_PLUS] = ACTIONS(8420),
    [anon_sym_SLASH] = ACTIONS(8420),
    [anon_sym_PERCENT] = ACTIONS(8420),
    [sym_comment] = ACTIONS(87),
  },
  [9226] = {
    [anon_sym_end] = ACTIONS(14044),
    [sym_comment] = ACTIONS(87),
  },
  [9227] = {
    [sym__statements] = STATE(10305),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(14046),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9228] = {
    [sym__heredoc_body_start] = ACTIONS(8581),
    [sym__binary_minus] = ACTIONS(8581),
    [sym__binary_star] = ACTIONS(8581),
    [anon_sym_LBRACE] = ACTIONS(8581),
    [anon_sym_RPAREN] = ACTIONS(8581),
    [anon_sym_DOT] = ACTIONS(8583),
    [anon_sym_COMMA] = ACTIONS(8581),
    [anon_sym_PIPE] = ACTIONS(8583),
    [anon_sym_STAR_STAR] = ACTIONS(8581),
    [anon_sym_AMP] = ACTIONS(8583),
    [anon_sym_EQ] = ACTIONS(8583),
    [anon_sym_LT] = ACTIONS(8583),
    [anon_sym_do] = ACTIONS(8581),
    [anon_sym_LBRACK] = ACTIONS(8581),
    [anon_sym_COLON_COLON2] = ACTIONS(8581),
    [anon_sym_AMP_DOT] = ACTIONS(8581),
    [anon_sym_QMARK] = ACTIONS(8581),
    [anon_sym_DOT_DOT] = ACTIONS(8583),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8581),
    [anon_sym_and] = ACTIONS(8581),
    [anon_sym_or] = ACTIONS(8581),
    [anon_sym_PIPE_PIPE] = ACTIONS(8581),
    [anon_sym_AMP_AMP] = ACTIONS(8581),
    [anon_sym_LT_LT] = ACTIONS(8581),
    [anon_sym_GT_GT] = ACTIONS(8581),
    [anon_sym_EQ_EQ] = ACTIONS(8583),
    [anon_sym_BANG_EQ] = ACTIONS(8581),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8581),
    [anon_sym_LT_EQ_GT] = ACTIONS(8581),
    [anon_sym_EQ_TILDE] = ACTIONS(8581),
    [anon_sym_BANG_TILDE] = ACTIONS(8581),
    [anon_sym_LT_EQ] = ACTIONS(8583),
    [anon_sym_GT] = ACTIONS(8583),
    [anon_sym_GT_EQ] = ACTIONS(8581),
    [anon_sym_CARET] = ACTIONS(8581),
    [anon_sym_PLUS] = ACTIONS(8581),
    [anon_sym_SLASH] = ACTIONS(8581),
    [anon_sym_PERCENT] = ACTIONS(8581),
    [sym_comment] = ACTIONS(87),
  },
  [9229] = {
    [anon_sym_end] = ACTIONS(14048),
    [sym_comment] = ACTIONS(87),
  },
  [9230] = {
    [sym_when] = STATE(10308),
    [sym_else] = STATE(10307),
    [aux_sym_case_repeat1] = STATE(2987),
    [aux_sym_case_repeat2] = STATE(10308),
    [anon_sym_SEMI] = ACTIONS(4995),
    [anon_sym_end] = ACTIONS(14048),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [9231] = {
    [sym_when] = STATE(2988),
    [sym_else] = STATE(10307),
    [aux_sym_case_repeat2] = STATE(2988),
    [anon_sym_end] = ACTIONS(14048),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [9232] = {
    [sym__heredoc_body_start] = ACTIONS(9185),
    [sym__binary_minus] = ACTIONS(9185),
    [sym__binary_star] = ACTIONS(9185),
    [anon_sym_LBRACE] = ACTIONS(9185),
    [anon_sym_RPAREN] = ACTIONS(9185),
    [anon_sym_DOT] = ACTIONS(9187),
    [anon_sym_COMMA] = ACTIONS(9185),
    [anon_sym_PIPE] = ACTIONS(9187),
    [anon_sym_STAR_STAR] = ACTIONS(9185),
    [anon_sym_AMP] = ACTIONS(9187),
    [anon_sym_EQ] = ACTIONS(9187),
    [anon_sym_LT] = ACTIONS(9187),
    [anon_sym_do] = ACTIONS(9185),
    [anon_sym_LBRACK] = ACTIONS(9185),
    [anon_sym_COLON_COLON2] = ACTIONS(9185),
    [anon_sym_AMP_DOT] = ACTIONS(9185),
    [anon_sym_QMARK] = ACTIONS(9185),
    [anon_sym_DOT_DOT] = ACTIONS(9187),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9185),
    [anon_sym_and] = ACTIONS(9185),
    [anon_sym_or] = ACTIONS(9185),
    [anon_sym_PIPE_PIPE] = ACTIONS(9185),
    [anon_sym_AMP_AMP] = ACTIONS(9185),
    [anon_sym_LT_LT] = ACTIONS(9185),
    [anon_sym_GT_GT] = ACTIONS(9185),
    [anon_sym_EQ_EQ] = ACTIONS(9187),
    [anon_sym_BANG_EQ] = ACTIONS(9185),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9185),
    [anon_sym_LT_EQ_GT] = ACTIONS(9185),
    [anon_sym_EQ_TILDE] = ACTIONS(9185),
    [anon_sym_BANG_TILDE] = ACTIONS(9185),
    [anon_sym_LT_EQ] = ACTIONS(9187),
    [anon_sym_GT] = ACTIONS(9187),
    [anon_sym_GT_EQ] = ACTIONS(9185),
    [anon_sym_CARET] = ACTIONS(9185),
    [anon_sym_PLUS] = ACTIONS(9185),
    [anon_sym_SLASH] = ACTIONS(9185),
    [anon_sym_PERCENT] = ACTIONS(9185),
    [sym_comment] = ACTIONS(87),
  },
  [9233] = {
    [anon_sym_end] = ACTIONS(14050),
    [sym_comment] = ACTIONS(87),
  },
  [9234] = {
    [sym_ensure] = STATE(10310),
    [anon_sym_end] = ACTIONS(14050),
    [anon_sym_ensure] = ACTIONS(2169),
    [sym_comment] = ACTIONS(87),
  },
  [9235] = {
    [sym__heredoc_body_start] = ACTIONS(9426),
    [sym__binary_minus] = ACTIONS(9426),
    [sym__binary_star] = ACTIONS(9426),
    [anon_sym_LBRACE] = ACTIONS(9426),
    [anon_sym_RPAREN] = ACTIONS(9426),
    [anon_sym_DOT] = ACTIONS(9428),
    [anon_sym_COMMA] = ACTIONS(9426),
    [anon_sym_PIPE] = ACTIONS(9428),
    [anon_sym_STAR_STAR] = ACTIONS(9426),
    [anon_sym_AMP] = ACTIONS(9428),
    [anon_sym_EQ] = ACTIONS(9428),
    [anon_sym_LT] = ACTIONS(9428),
    [anon_sym_do] = ACTIONS(9426),
    [anon_sym_LBRACK] = ACTIONS(9426),
    [anon_sym_COLON_COLON2] = ACTIONS(9426),
    [anon_sym_AMP_DOT] = ACTIONS(9426),
    [anon_sym_QMARK] = ACTIONS(9426),
    [anon_sym_DOT_DOT] = ACTIONS(9428),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9426),
    [anon_sym_and] = ACTIONS(9426),
    [anon_sym_or] = ACTIONS(9426),
    [anon_sym_PIPE_PIPE] = ACTIONS(9426),
    [anon_sym_AMP_AMP] = ACTIONS(9426),
    [anon_sym_LT_LT] = ACTIONS(9426),
    [anon_sym_GT_GT] = ACTIONS(9426),
    [anon_sym_EQ_EQ] = ACTIONS(9428),
    [anon_sym_BANG_EQ] = ACTIONS(9426),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9426),
    [anon_sym_LT_EQ_GT] = ACTIONS(9426),
    [anon_sym_EQ_TILDE] = ACTIONS(9426),
    [anon_sym_BANG_TILDE] = ACTIONS(9426),
    [anon_sym_LT_EQ] = ACTIONS(9428),
    [anon_sym_GT] = ACTIONS(9428),
    [anon_sym_GT_EQ] = ACTIONS(9426),
    [anon_sym_CARET] = ACTIONS(9426),
    [anon_sym_PLUS] = ACTIONS(9426),
    [anon_sym_SLASH] = ACTIONS(9426),
    [anon_sym_PERCENT] = ACTIONS(9426),
    [sym_comment] = ACTIONS(87),
  },
  [9236] = {
    [anon_sym_RBRACE] = ACTIONS(14052),
    [sym_comment] = ACTIONS(87),
  },
  [9237] = {
    [sym__heredoc_body_start] = ACTIONS(9446),
    [sym__binary_minus] = ACTIONS(9446),
    [sym__binary_star] = ACTIONS(9446),
    [anon_sym_LBRACE] = ACTIONS(9446),
    [anon_sym_RPAREN] = ACTIONS(9446),
    [anon_sym_DOT] = ACTIONS(9448),
    [anon_sym_COMMA] = ACTIONS(9446),
    [anon_sym_PIPE] = ACTIONS(9448),
    [anon_sym_STAR_STAR] = ACTIONS(9446),
    [anon_sym_AMP] = ACTIONS(9448),
    [anon_sym_EQ] = ACTIONS(9448),
    [anon_sym_LT] = ACTIONS(9448),
    [anon_sym_do] = ACTIONS(9446),
    [anon_sym_LBRACK] = ACTIONS(9446),
    [anon_sym_COLON_COLON2] = ACTIONS(9446),
    [anon_sym_AMP_DOT] = ACTIONS(9446),
    [anon_sym_QMARK] = ACTIONS(9446),
    [anon_sym_DOT_DOT] = ACTIONS(9448),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9446),
    [anon_sym_and] = ACTIONS(9446),
    [anon_sym_or] = ACTIONS(9446),
    [anon_sym_PIPE_PIPE] = ACTIONS(9446),
    [anon_sym_AMP_AMP] = ACTIONS(9446),
    [anon_sym_LT_LT] = ACTIONS(9446),
    [anon_sym_GT_GT] = ACTIONS(9446),
    [anon_sym_EQ_EQ] = ACTIONS(9448),
    [anon_sym_BANG_EQ] = ACTIONS(9446),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9446),
    [anon_sym_LT_EQ_GT] = ACTIONS(9446),
    [anon_sym_EQ_TILDE] = ACTIONS(9446),
    [anon_sym_BANG_TILDE] = ACTIONS(9446),
    [anon_sym_LT_EQ] = ACTIONS(9448),
    [anon_sym_GT] = ACTIONS(9448),
    [anon_sym_GT_EQ] = ACTIONS(9446),
    [anon_sym_CARET] = ACTIONS(9446),
    [anon_sym_PLUS] = ACTIONS(9446),
    [anon_sym_SLASH] = ACTIONS(9446),
    [anon_sym_PERCENT] = ACTIONS(9446),
    [sym_comment] = ACTIONS(87),
  },
  [9238] = {
    [anon_sym_end] = ACTIONS(14054),
    [sym_comment] = ACTIONS(87),
  },
  [9239] = {
    [sym__statements] = STATE(10313),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(14056),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9240] = {
    [sym__statements] = STATE(10313),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_heredoc_body] = STATE(10314),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [sym__terminator] = STATE(10314),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__line_break] = ACTIONS(14058),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(509),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(14058),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(14056),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9241] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(10315),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2357),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(2357),
    [sym_assignment] = STATE(10315),
    [sym_operator_assignment] = STATE(10315),
    [sym_conditional] = STATE(10315),
    [sym_range] = STATE(10315),
    [sym_binary] = STATE(10315),
    [sym_unary] = STATE(10315),
    [sym_left_assignment_list] = STATE(2356),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2357),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2357),
    [sym_false] = STATE(2357),
    [sym_nil] = STATE(2357),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2358),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(4005),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(4009),
    [sym__subshell_start] = ACTIONS(4011),
    [sym__regex_start] = ACTIONS(4013),
    [sym__string_array_start] = ACTIONS(4015),
    [sym__symbol_array_start] = ACTIONS(4017),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4019),
    [anon_sym_LBRACE] = ACTIONS(4021),
    [anon_sym_def] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4025),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(4027),
    [anon_sym_module] = ACTIONS(4029),
    [anon_sym_return] = ACTIONS(4031),
    [anon_sym_yield] = ACTIONS(4033),
    [anon_sym_break] = ACTIONS(4035),
    [anon_sym_next] = ACTIONS(4037),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(4039),
    [anon_sym_unless] = ACTIONS(4041),
    [anon_sym_while] = ACTIONS(4043),
    [anon_sym_until] = ACTIONS(4045),
    [anon_sym_for] = ACTIONS(4047),
    [anon_sym_case] = ACTIONS(4049),
    [anon_sym_begin] = ACTIONS(4051),
    [anon_sym_PLUS] = ACTIONS(4053),
    [anon_sym_defined_QMARK] = ACTIONS(4055),
    [anon_sym_not] = ACTIONS(4057),
    [anon_sym_BANG] = ACTIONS(4059),
    [anon_sym_TILDE] = ACTIONS(4059),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4065),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(4067),
    [anon_sym_DASH_GT] = ACTIONS(4069),
  },
  [9242] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7345),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2357),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(2357),
    [sym_splat_argument] = STATE(10316),
    [sym_assignment] = STATE(7345),
    [sym_operator_assignment] = STATE(7345),
    [sym_conditional] = STATE(7345),
    [sym_range] = STATE(7345),
    [sym_binary] = STATE(7345),
    [sym_unary] = STATE(7345),
    [sym__arg_or_splat_arg] = STATE(10316),
    [sym_left_assignment_list] = STATE(2356),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2357),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2357),
    [sym_false] = STATE(2357),
    [sym_nil] = STATE(2357),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2358),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(4005),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(4009),
    [sym__subshell_start] = ACTIONS(4011),
    [sym__regex_start] = ACTIONS(4013),
    [sym__string_array_start] = ACTIONS(4015),
    [sym__symbol_array_start] = ACTIONS(4017),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(7689),
    [sym__unary_minus] = ACTIONS(4019),
    [anon_sym_LBRACE] = ACTIONS(4021),
    [anon_sym_def] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4025),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(4027),
    [anon_sym_module] = ACTIONS(4029),
    [anon_sym_return] = ACTIONS(4031),
    [anon_sym_yield] = ACTIONS(4033),
    [anon_sym_break] = ACTIONS(4035),
    [anon_sym_next] = ACTIONS(4037),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(4039),
    [anon_sym_unless] = ACTIONS(4041),
    [anon_sym_while] = ACTIONS(4043),
    [anon_sym_until] = ACTIONS(4045),
    [anon_sym_for] = ACTIONS(4047),
    [anon_sym_case] = ACTIONS(4049),
    [anon_sym_begin] = ACTIONS(4051),
    [anon_sym_PLUS] = ACTIONS(4053),
    [anon_sym_defined_QMARK] = ACTIONS(4055),
    [anon_sym_not] = ACTIONS(4057),
    [anon_sym_BANG] = ACTIONS(4059),
    [anon_sym_TILDE] = ACTIONS(4059),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4065),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(4067),
    [anon_sym_DASH_GT] = ACTIONS(4069),
  },
  [9243] = {
    [aux_sym_exceptions_repeat1] = STATE(10317),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_LBRACE] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(14060),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_EQ] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_do] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [9244] = {
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(4087),
    [sym__binary_star] = ACTIONS(4089),
    [anon_sym_LBRACE] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(4091),
    [anon_sym_STAR_STAR] = ACTIONS(4089),
    [anon_sym_AMP] = ACTIONS(4093),
    [anon_sym_EQ] = ACTIONS(12879),
    [anon_sym_LT] = ACTIONS(4095),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_EQ_GT] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(4097),
    [anon_sym_DOT_DOT] = ACTIONS(4099),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4101),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(4105),
    [anon_sym_AMP_AMP] = ACTIONS(4105),
    [anon_sym_LT_LT] = ACTIONS(4107),
    [anon_sym_GT_GT] = ACTIONS(4107),
    [anon_sym_EQ_EQ] = ACTIONS(4109),
    [anon_sym_BANG_EQ] = ACTIONS(4105),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4105),
    [anon_sym_LT_EQ_GT] = ACTIONS(4105),
    [anon_sym_EQ_TILDE] = ACTIONS(4105),
    [anon_sym_BANG_TILDE] = ACTIONS(4105),
    [anon_sym_LT_EQ] = ACTIONS(4095),
    [anon_sym_GT] = ACTIONS(4095),
    [anon_sym_GT_EQ] = ACTIONS(4111),
    [anon_sym_CARET] = ACTIONS(4113),
    [anon_sym_PLUS] = ACTIONS(4087),
    [anon_sym_SLASH] = ACTIONS(4089),
    [anon_sym_PERCENT] = ACTIONS(4089),
    [sym_comment] = ACTIONS(87),
  },
  [9245] = {
    [aux_sym_exceptions_repeat1] = STATE(9245),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(14062),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [9246] = {
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(7776),
    [sym__binary_star] = ACTIONS(7778),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(7780),
    [anon_sym_STAR_STAR] = ACTIONS(7778),
    [anon_sym_AMP] = ACTIONS(7782),
    [anon_sym_LT] = ACTIONS(7784),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(7786),
    [anon_sym_DOT_DOT] = ACTIONS(7788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7790),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(7794),
    [anon_sym_AMP_AMP] = ACTIONS(7794),
    [anon_sym_LT_LT] = ACTIONS(7796),
    [anon_sym_GT_GT] = ACTIONS(7796),
    [anon_sym_EQ_EQ] = ACTIONS(7798),
    [anon_sym_BANG_EQ] = ACTIONS(7794),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7794),
    [anon_sym_LT_EQ_GT] = ACTIONS(7794),
    [anon_sym_EQ_TILDE] = ACTIONS(7794),
    [anon_sym_BANG_TILDE] = ACTIONS(7794),
    [anon_sym_LT_EQ] = ACTIONS(7784),
    [anon_sym_GT] = ACTIONS(7784),
    [anon_sym_GT_EQ] = ACTIONS(7800),
    [anon_sym_CARET] = ACTIONS(7802),
    [anon_sym_PLUS] = ACTIONS(7776),
    [anon_sym_SLASH] = ACTIONS(7778),
    [anon_sym_PERCENT] = ACTIONS(7778),
    [sym_comment] = ACTIONS(87),
  },
  [9247] = {
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(7776),
    [sym__binary_star] = ACTIONS(7778),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(7780),
    [anon_sym_STAR_STAR] = ACTIONS(7778),
    [anon_sym_AMP] = ACTIONS(7782),
    [anon_sym_LT] = ACTIONS(7784),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(7786),
    [anon_sym_DOT_DOT] = ACTIONS(7788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7790),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(7794),
    [anon_sym_AMP_AMP] = ACTIONS(7794),
    [anon_sym_LT_LT] = ACTIONS(7796),
    [anon_sym_GT_GT] = ACTIONS(7796),
    [anon_sym_EQ_EQ] = ACTIONS(7798),
    [anon_sym_BANG_EQ] = ACTIONS(7794),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7794),
    [anon_sym_LT_EQ_GT] = ACTIONS(7794),
    [anon_sym_EQ_TILDE] = ACTIONS(7794),
    [anon_sym_BANG_TILDE] = ACTIONS(7794),
    [anon_sym_LT_EQ] = ACTIONS(7784),
    [anon_sym_GT] = ACTIONS(7784),
    [anon_sym_GT_EQ] = ACTIONS(7800),
    [anon_sym_CARET] = ACTIONS(7802),
    [anon_sym_PLUS] = ACTIONS(7776),
    [anon_sym_SLASH] = ACTIONS(7778),
    [anon_sym_PERCENT] = ACTIONS(7778),
    [sym_comment] = ACTIONS(87),
  },
  [9248] = {
    [sym_heredoc_body] = STATE(9248),
    [aux_sym_call_repeat1] = STATE(9248),
    [sym__heredoc_body_start] = ACTIONS(10455),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [9249] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(4841),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(863),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(863),
    [sym__argument] = STATE(6908),
    [sym_splat_argument] = STATE(6908),
    [sym_hash_splat_argument] = STATE(6908),
    [sym_block_argument] = STATE(6908),
    [sym_assignment] = STATE(4841),
    [sym_operator_assignment] = STATE(4841),
    [sym_conditional] = STATE(4841),
    [sym_range] = STATE(4841),
    [sym_binary] = STATE(4841),
    [sym_unary] = STATE(4841),
    [sym_left_assignment_list] = STATE(862),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(863),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(4844),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(6908),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(7768),
    [sym__splat_star] = ACTIONS(7770),
    [sym__unary_minus] = ACTIONS(1525),
    [sym__identifier_hash_key] = ACTIONS(7772),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12858),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_next] = ACTIONS(1539),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_defined_QMARK] = ACTIONS(1543),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(7774),
    [sym_identifier] = ACTIONS(7774),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9250] = {
    [sym_heredoc_body] = STATE(9248),
    [aux_sym_call_repeat1] = STATE(9248),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [9251] = {
    [aux_sym_argument_list_repeat1] = STATE(9251),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(14065),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_STAR_STAR] = ACTIONS(7925),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7925),
    [anon_sym_AMP_AMP] = ACTIONS(7925),
    [anon_sym_LT_LT] = ACTIONS(7925),
    [anon_sym_GT_GT] = ACTIONS(7925),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7925),
    [anon_sym_PLUS] = ACTIONS(7925),
    [anon_sym_SLASH] = ACTIONS(7925),
    [anon_sym_PERCENT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [9252] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(10318),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2408),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(2408),
    [sym_assignment] = STATE(10318),
    [sym_operator_assignment] = STATE(10318),
    [sym_conditional] = STATE(10318),
    [sym_range] = STATE(10318),
    [sym_binary] = STATE(10318),
    [sym_unary] = STATE(10318),
    [sym_left_assignment_list] = STATE(2407),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2408),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2408),
    [sym_false] = STATE(2408),
    [sym_nil] = STATE(2408),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2409),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4133),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4135),
    [anon_sym_yield] = ACTIONS(4137),
    [anon_sym_break] = ACTIONS(4139),
    [anon_sym_next] = ACTIONS(4141),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4143),
    [anon_sym_defined_QMARK] = ACTIONS(4145),
    [anon_sym_not] = ACTIONS(4147),
    [anon_sym_BANG] = ACTIONS(4149),
    [anon_sym_TILDE] = ACTIONS(4149),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9253] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7377),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2408),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(2408),
    [sym_splat_argument] = STATE(9013),
    [sym_assignment] = STATE(7377),
    [sym_operator_assignment] = STATE(7377),
    [sym_conditional] = STATE(7377),
    [sym_range] = STATE(7377),
    [sym_binary] = STATE(7377),
    [sym_unary] = STATE(7377),
    [sym__arg_or_splat_arg] = STATE(9013),
    [sym_left_assignment_list] = STATE(2407),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2408),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2408),
    [sym_false] = STATE(2408),
    [sym_nil] = STATE(2408),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2409),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(7770),
    [sym__unary_minus] = ACTIONS(4133),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4135),
    [anon_sym_yield] = ACTIONS(4137),
    [anon_sym_break] = ACTIONS(4139),
    [anon_sym_next] = ACTIONS(4141),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4143),
    [anon_sym_defined_QMARK] = ACTIONS(4145),
    [anon_sym_not] = ACTIONS(4147),
    [anon_sym_BANG] = ACTIONS(4149),
    [anon_sym_TILDE] = ACTIONS(4149),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9254] = {
    [aux_sym_exceptions_repeat1] = STATE(10319),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_LBRACE] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(14068),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_do] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [9255] = {
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(4167),
    [sym__binary_star] = ACTIONS(4169),
    [anon_sym_LBRACE] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(4171),
    [anon_sym_STAR_STAR] = ACTIONS(4169),
    [anon_sym_AMP] = ACTIONS(4173),
    [anon_sym_LT] = ACTIONS(4175),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_EQ_GT] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_DOT_DOT] = ACTIONS(4179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4181),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(4185),
    [anon_sym_AMP_AMP] = ACTIONS(4185),
    [anon_sym_LT_LT] = ACTIONS(4187),
    [anon_sym_GT_GT] = ACTIONS(4187),
    [anon_sym_EQ_EQ] = ACTIONS(4189),
    [anon_sym_BANG_EQ] = ACTIONS(4185),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4185),
    [anon_sym_LT_EQ_GT] = ACTIONS(4185),
    [anon_sym_EQ_TILDE] = ACTIONS(4185),
    [anon_sym_BANG_TILDE] = ACTIONS(4185),
    [anon_sym_LT_EQ] = ACTIONS(4175),
    [anon_sym_GT] = ACTIONS(4175),
    [anon_sym_GT_EQ] = ACTIONS(4191),
    [anon_sym_CARET] = ACTIONS(4193),
    [anon_sym_PLUS] = ACTIONS(4167),
    [anon_sym_SLASH] = ACTIONS(4169),
    [anon_sym_PERCENT] = ACTIONS(4169),
    [sym_comment] = ACTIONS(87),
  },
  [9256] = {
    [aux_sym_exceptions_repeat1] = STATE(9256),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(14070),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [9257] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(4213),
    [sym__binary_star] = ACTIONS(4215),
    [ts_builtin_sym_end] = ACTIONS(12120),
    [anon_sym___END__] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(4219),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(4215),
    [anon_sym_AMP] = ACTIONS(4221),
    [anon_sym_LT] = ACTIONS(4223),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(4225),
    [anon_sym_DOT_DOT] = ACTIONS(4227),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4229),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(4231),
    [anon_sym_AMP_AMP] = ACTIONS(4231),
    [anon_sym_LT_LT] = ACTIONS(4233),
    [anon_sym_GT_GT] = ACTIONS(4233),
    [anon_sym_EQ_EQ] = ACTIONS(4235),
    [anon_sym_BANG_EQ] = ACTIONS(4231),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4231),
    [anon_sym_LT_EQ_GT] = ACTIONS(4231),
    [anon_sym_EQ_TILDE] = ACTIONS(4231),
    [anon_sym_BANG_TILDE] = ACTIONS(4231),
    [anon_sym_LT_EQ] = ACTIONS(4223),
    [anon_sym_GT] = ACTIONS(4223),
    [anon_sym_GT_EQ] = ACTIONS(4237),
    [anon_sym_CARET] = ACTIONS(4239),
    [anon_sym_PLUS] = ACTIONS(4213),
    [anon_sym_SLASH] = ACTIONS(4215),
    [anon_sym_PERCENT] = ACTIONS(4215),
    [sym_comment] = ACTIONS(87),
  },
  [9258] = {
    [aux_sym_exceptions_repeat1] = STATE(9258),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [ts_builtin_sym_end] = ACTIONS(11597),
    [anon_sym___END__] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(14073),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [9259] = {
    [sym_heredoc_body] = STATE(9259),
    [aux_sym_call_repeat1] = STATE(9259),
    [sym__heredoc_body_start] = ACTIONS(10455),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_RPAREN] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [9260] = {
    [sym_heredoc_body] = STATE(9259),
    [aux_sym_call_repeat1] = STATE(9259),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_RPAREN] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [9261] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(10320),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2480),
    [sym_scope_resolution] = STATE(2478),
    [sym_call] = STATE(2478),
    [sym_method_call] = STATE(2480),
    [sym_assignment] = STATE(10320),
    [sym_operator_assignment] = STATE(10320),
    [sym_conditional] = STATE(10320),
    [sym_range] = STATE(10320),
    [sym_binary] = STATE(10320),
    [sym_unary] = STATE(10320),
    [sym_left_assignment_list] = STATE(2479),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2480),
    [sym__variable] = STATE(2478),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2480),
    [sym_false] = STATE(2480),
    [sym_nil] = STATE(2480),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2481),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4261),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4263),
    [anon_sym_yield] = ACTIONS(4265),
    [anon_sym_break] = ACTIONS(4267),
    [anon_sym_next] = ACTIONS(4269),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4271),
    [anon_sym_defined_QMARK] = ACTIONS(4273),
    [anon_sym_not] = ACTIONS(4275),
    [anon_sym_BANG] = ACTIONS(4277),
    [anon_sym_TILDE] = ACTIONS(4277),
    [sym_constant] = ACTIONS(4279),
    [sym_identifier] = ACTIONS(4279),
    [sym_instance_variable] = ACTIONS(4281),
    [sym_class_variable] = ACTIONS(4281),
    [sym_global_variable] = ACTIONS(4281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4279),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4279),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9262] = {
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(7826),
    [sym__binary_star] = ACTIONS(7828),
    [anon_sym_RPAREN] = ACTIONS(4247),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(7830),
    [anon_sym_STAR_STAR] = ACTIONS(7828),
    [anon_sym_AMP] = ACTIONS(7832),
    [anon_sym_LT] = ACTIONS(7834),
    [anon_sym_QMARK] = ACTIONS(7836),
    [anon_sym_DOT_DOT] = ACTIONS(7838),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7840),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(7844),
    [anon_sym_AMP_AMP] = ACTIONS(7844),
    [anon_sym_LT_LT] = ACTIONS(7846),
    [anon_sym_GT_GT] = ACTIONS(7846),
    [anon_sym_EQ_EQ] = ACTIONS(7848),
    [anon_sym_BANG_EQ] = ACTIONS(7844),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7844),
    [anon_sym_LT_EQ_GT] = ACTIONS(7844),
    [anon_sym_EQ_TILDE] = ACTIONS(7844),
    [anon_sym_BANG_TILDE] = ACTIONS(7844),
    [anon_sym_LT_EQ] = ACTIONS(7834),
    [anon_sym_GT] = ACTIONS(7834),
    [anon_sym_GT_EQ] = ACTIONS(7850),
    [anon_sym_CARET] = ACTIONS(7852),
    [anon_sym_PLUS] = ACTIONS(7826),
    [anon_sym_SLASH] = ACTIONS(7828),
    [anon_sym_PERCENT] = ACTIONS(7828),
    [sym_comment] = ACTIONS(87),
  },
  [9263] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7408),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2480),
    [sym_scope_resolution] = STATE(2478),
    [sym_call] = STATE(2478),
    [sym_method_call] = STATE(2480),
    [sym_splat_argument] = STATE(8429),
    [sym_assignment] = STATE(7408),
    [sym_operator_assignment] = STATE(7408),
    [sym_conditional] = STATE(7408),
    [sym_range] = STATE(7408),
    [sym_binary] = STATE(7408),
    [sym_unary] = STATE(7408),
    [sym__arg_or_splat_arg] = STATE(8429),
    [sym_left_assignment_list] = STATE(2479),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2480),
    [sym__variable] = STATE(2478),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2480),
    [sym_false] = STATE(2480),
    [sym_nil] = STATE(2480),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2481),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(10955),
    [sym__unary_minus] = ACTIONS(4261),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4263),
    [anon_sym_yield] = ACTIONS(4265),
    [anon_sym_break] = ACTIONS(4267),
    [anon_sym_next] = ACTIONS(4269),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4271),
    [anon_sym_defined_QMARK] = ACTIONS(4273),
    [anon_sym_not] = ACTIONS(4275),
    [anon_sym_BANG] = ACTIONS(4277),
    [anon_sym_TILDE] = ACTIONS(4277),
    [sym_constant] = ACTIONS(4279),
    [sym_identifier] = ACTIONS(4279),
    [sym_instance_variable] = ACTIONS(4281),
    [sym_class_variable] = ACTIONS(4281),
    [sym_global_variable] = ACTIONS(4281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4279),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4279),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9264] = {
    [aux_sym_exceptions_repeat1] = STATE(10321),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_RPAREN] = ACTIONS(9855),
    [anon_sym_COMMA] = ACTIONS(14076),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [9265] = {
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(4299),
    [sym__binary_star] = ACTIONS(4301),
    [anon_sym_RPAREN] = ACTIONS(12120),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(4303),
    [anon_sym_STAR_STAR] = ACTIONS(4301),
    [anon_sym_AMP] = ACTIONS(4305),
    [anon_sym_LT] = ACTIONS(4307),
    [anon_sym_EQ_GT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(4309),
    [anon_sym_DOT_DOT] = ACTIONS(4311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4313),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(4317),
    [anon_sym_AMP_AMP] = ACTIONS(4317),
    [anon_sym_LT_LT] = ACTIONS(4319),
    [anon_sym_GT_GT] = ACTIONS(4319),
    [anon_sym_EQ_EQ] = ACTIONS(4321),
    [anon_sym_BANG_EQ] = ACTIONS(4317),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4317),
    [anon_sym_LT_EQ_GT] = ACTIONS(4317),
    [anon_sym_EQ_TILDE] = ACTIONS(4317),
    [anon_sym_BANG_TILDE] = ACTIONS(4317),
    [anon_sym_LT_EQ] = ACTIONS(4307),
    [anon_sym_GT] = ACTIONS(4307),
    [anon_sym_GT_EQ] = ACTIONS(4323),
    [anon_sym_CARET] = ACTIONS(4325),
    [anon_sym_PLUS] = ACTIONS(4299),
    [anon_sym_SLASH] = ACTIONS(4301),
    [anon_sym_PERCENT] = ACTIONS(4301),
    [sym_comment] = ACTIONS(87),
  },
  [9266] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(906),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(911),
    [sym_scope_resolution] = STATE(907),
    [sym_call] = STATE(907),
    [sym_method_call] = STATE(911),
    [sym__argument] = STATE(6088),
    [sym_splat_argument] = STATE(6088),
    [sym_hash_splat_argument] = STATE(6088),
    [sym_block_argument] = STATE(6088),
    [sym_assignment] = STATE(906),
    [sym_operator_assignment] = STATE(906),
    [sym_conditional] = STATE(906),
    [sym_range] = STATE(906),
    [sym_binary] = STATE(906),
    [sym_unary] = STATE(906),
    [sym_left_assignment_list] = STATE(910),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(911),
    [sym__variable] = STATE(907),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(911),
    [sym_false] = STATE(911),
    [sym_nil] = STATE(911),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(912),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(6088),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1589),
    [sym__splat_star] = ACTIONS(1591),
    [sym__unary_minus] = ACTIONS(1593),
    [sym__identifier_hash_key] = ACTIONS(1595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1599),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_next] = ACTIONS(1607),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_defined_QMARK] = ACTIONS(1611),
    [anon_sym_not] = ACTIONS(1613),
    [anon_sym_BANG] = ACTIONS(1615),
    [anon_sym_TILDE] = ACTIONS(1615),
    [sym_constant] = ACTIONS(1617),
    [sym_identifier] = ACTIONS(1617),
    [sym_instance_variable] = ACTIONS(1619),
    [sym_class_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1621),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9267] = {
    [aux_sym_exceptions_repeat1] = STATE(9267),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_RPAREN] = ACTIONS(11597),
    [anon_sym_COMMA] = ACTIONS(14078),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [9268] = {
    [sym__line_break] = ACTIONS(13712),
    [sym__heredoc_body_start] = ACTIONS(13712),
    [sym__binary_minus] = ACTIONS(13712),
    [sym__binary_star] = ACTIONS(13712),
    [ts_builtin_sym_end] = ACTIONS(13712),
    [anon_sym___END__] = ACTIONS(13712),
    [anon_sym_LBRACE] = ACTIONS(13712),
    [anon_sym_RBRACE] = ACTIONS(13712),
    [anon_sym_RPAREN] = ACTIONS(13712),
    [anon_sym_DOT] = ACTIONS(13714),
    [anon_sym_COMMA] = ACTIONS(13712),
    [anon_sym_PIPE] = ACTIONS(13714),
    [anon_sym_SEMI] = ACTIONS(13712),
    [anon_sym_STAR_STAR] = ACTIONS(13714),
    [anon_sym_AMP] = ACTIONS(13714),
    [anon_sym_EQ] = ACTIONS(13714),
    [anon_sym_LT] = ACTIONS(13714),
    [anon_sym_end] = ACTIONS(13712),
    [anon_sym_if] = ACTIONS(13712),
    [anon_sym_unless] = ACTIONS(13712),
    [anon_sym_while] = ACTIONS(13712),
    [anon_sym_until] = ACTIONS(13712),
    [anon_sym_rescue] = ACTIONS(13712),
    [anon_sym_do] = ACTIONS(13712),
    [anon_sym_when] = ACTIONS(13712),
    [anon_sym_elsif] = ACTIONS(13712),
    [anon_sym_else] = ACTIONS(13712),
    [anon_sym_then] = ACTIONS(13712),
    [anon_sym_ensure] = ACTIONS(13712),
    [anon_sym_EQ_GT] = ACTIONS(13712),
    [anon_sym_LBRACK] = ACTIONS(13712),
    [anon_sym_COLON_COLON2] = ACTIONS(13712),
    [anon_sym_AMP_DOT] = ACTIONS(13712),
    [anon_sym_PLUS_EQ] = ACTIONS(13712),
    [anon_sym_DASH_EQ] = ACTIONS(13712),
    [anon_sym_STAR_EQ] = ACTIONS(13712),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13712),
    [anon_sym_SLASH_EQ] = ACTIONS(13712),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13712),
    [anon_sym_PIPE_EQ] = ACTIONS(13712),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13712),
    [anon_sym_AMP_EQ] = ACTIONS(13712),
    [anon_sym_PERCENT_EQ] = ACTIONS(13712),
    [anon_sym_GT_GT_EQ] = ACTIONS(13712),
    [anon_sym_LT_LT_EQ] = ACTIONS(13712),
    [anon_sym_CARET_EQ] = ACTIONS(13712),
    [anon_sym_QMARK] = ACTIONS(13712),
    [anon_sym_DOT_DOT] = ACTIONS(13714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13712),
    [anon_sym_and] = ACTIONS(13712),
    [anon_sym_or] = ACTIONS(13712),
    [anon_sym_PIPE_PIPE] = ACTIONS(13714),
    [anon_sym_AMP_AMP] = ACTIONS(13714),
    [anon_sym_LT_LT] = ACTIONS(13714),
    [anon_sym_GT_GT] = ACTIONS(13714),
    [anon_sym_EQ_EQ] = ACTIONS(13714),
    [anon_sym_BANG_EQ] = ACTIONS(13712),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13712),
    [anon_sym_LT_EQ_GT] = ACTIONS(13712),
    [anon_sym_EQ_TILDE] = ACTIONS(13712),
    [anon_sym_BANG_TILDE] = ACTIONS(13712),
    [anon_sym_LT_EQ] = ACTIONS(13714),
    [anon_sym_GT] = ACTIONS(13714),
    [anon_sym_GT_EQ] = ACTIONS(13712),
    [anon_sym_CARET] = ACTIONS(13714),
    [anon_sym_PLUS] = ACTIONS(13714),
    [anon_sym_SLASH] = ACTIONS(13714),
    [anon_sym_PERCENT] = ACTIONS(13714),
    [sym_comment] = ACTIONS(87),
  },
  [9269] = {
    [anon_sym_end] = ACTIONS(14081),
    [sym_comment] = ACTIONS(87),
  },
  [9270] = {
    [sym_heredoc_body] = STATE(9270),
    [aux_sym_call_repeat1] = STATE(9270),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(7916),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_then] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [9271] = {
    [sym_heredoc_body] = STATE(9270),
    [aux_sym_call_repeat1] = STATE(9270),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_then] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [9272] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10323),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2583),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2583),
    [sym_assignment] = STATE(10323),
    [sym_operator_assignment] = STATE(10323),
    [sym_conditional] = STATE(10323),
    [sym_range] = STATE(10323),
    [sym_binary] = STATE(10323),
    [sym_unary] = STATE(10323),
    [sym_left_assignment_list] = STATE(2582),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2583),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2583),
    [sym_false] = STATE(2583),
    [sym_nil] = STATE(2583),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2584),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4391),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4393),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_break] = ACTIONS(4397),
    [anon_sym_next] = ACTIONS(4399),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4401),
    [anon_sym_defined_QMARK] = ACTIONS(4403),
    [anon_sym_not] = ACTIONS(4405),
    [anon_sym_BANG] = ACTIONS(4407),
    [anon_sym_TILDE] = ACTIONS(4407),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9273] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7453),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2583),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2583),
    [sym_splat_argument] = STATE(7439),
    [sym_assignment] = STATE(7453),
    [sym_operator_assignment] = STATE(7453),
    [sym_conditional] = STATE(7453),
    [sym_range] = STATE(7453),
    [sym_binary] = STATE(7453),
    [sym_unary] = STATE(7453),
    [sym__arg_or_splat_arg] = STATE(7439),
    [sym_left_assignment_list] = STATE(2582),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2583),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2583),
    [sym_false] = STATE(2583),
    [sym_nil] = STATE(2583),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2584),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(1711),
    [sym__unary_minus] = ACTIONS(4391),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4393),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_break] = ACTIONS(4397),
    [anon_sym_next] = ACTIONS(4399),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4401),
    [anon_sym_defined_QMARK] = ACTIONS(4403),
    [anon_sym_not] = ACTIONS(4405),
    [anon_sym_BANG] = ACTIONS(4407),
    [anon_sym_TILDE] = ACTIONS(4407),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9274] = {
    [aux_sym_exceptions_repeat1] = STATE(10324),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(14083),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_then] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [9275] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(4423),
    [sym__binary_star] = ACTIONS(4425),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(4427),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(4425),
    [anon_sym_AMP] = ACTIONS(4429),
    [anon_sym_LT] = ACTIONS(4431),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_then] = ACTIONS(12120),
    [anon_sym_EQ_GT] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(4433),
    [anon_sym_DOT_DOT] = ACTIONS(4435),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4437),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(4439),
    [anon_sym_AMP_AMP] = ACTIONS(4439),
    [anon_sym_LT_LT] = ACTIONS(4441),
    [anon_sym_GT_GT] = ACTIONS(4441),
    [anon_sym_EQ_EQ] = ACTIONS(4443),
    [anon_sym_BANG_EQ] = ACTIONS(4439),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4439),
    [anon_sym_LT_EQ_GT] = ACTIONS(4439),
    [anon_sym_EQ_TILDE] = ACTIONS(4439),
    [anon_sym_BANG_TILDE] = ACTIONS(4439),
    [anon_sym_LT_EQ] = ACTIONS(4431),
    [anon_sym_GT] = ACTIONS(4431),
    [anon_sym_GT_EQ] = ACTIONS(4445),
    [anon_sym_CARET] = ACTIONS(4447),
    [anon_sym_PLUS] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(4425),
    [anon_sym_PERCENT] = ACTIONS(4425),
    [sym_comment] = ACTIONS(87),
  },
  [9276] = {
    [aux_sym_exceptions_repeat1] = STATE(9276),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(14085),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_then] = ACTIONS(11597),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [9277] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(12900),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_elsif] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [9278] = {
    [sym_heredoc_body] = STATE(10325),
    [aux_sym_call_repeat1] = STATE(10325),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_elsif] = ACTIONS(1681),
    [anon_sym_else] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [9279] = {
    [sym_heredoc_body] = STATE(10325),
    [aux_sym_call_repeat1] = STATE(10325),
    [aux_sym_argument_list_repeat1] = STATE(10326),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(11067),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_elsif] = ACTIONS(1681),
    [anon_sym_else] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [9280] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(12898),
    [sym__binary_star] = ACTIONS(12900),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(12902),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(12900),
    [anon_sym_AMP] = ACTIONS(12904),
    [anon_sym_LT] = ACTIONS(12906),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_elsif] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(12908),
    [anon_sym_DOT_DOT] = ACTIONS(12910),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12912),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(12914),
    [anon_sym_AMP_AMP] = ACTIONS(12914),
    [anon_sym_LT_LT] = ACTIONS(12916),
    [anon_sym_GT_GT] = ACTIONS(12916),
    [anon_sym_EQ_EQ] = ACTIONS(12918),
    [anon_sym_BANG_EQ] = ACTIONS(12914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12914),
    [anon_sym_LT_EQ_GT] = ACTIONS(12914),
    [anon_sym_EQ_TILDE] = ACTIONS(12914),
    [anon_sym_BANG_TILDE] = ACTIONS(12914),
    [anon_sym_LT_EQ] = ACTIONS(12906),
    [anon_sym_GT] = ACTIONS(12906),
    [anon_sym_GT_EQ] = ACTIONS(12920),
    [anon_sym_CARET] = ACTIONS(12922),
    [anon_sym_PLUS] = ACTIONS(12898),
    [anon_sym_SLASH] = ACTIONS(12900),
    [anon_sym_PERCENT] = ACTIONS(12900),
    [sym_comment] = ACTIONS(87),
  },
  [9281] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10327),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7481),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(7481),
    [sym_assignment] = STATE(10327),
    [sym_operator_assignment] = STATE(10327),
    [sym_conditional] = STATE(10327),
    [sym_range] = STATE(10327),
    [sym_binary] = STATE(10327),
    [sym_unary] = STATE(10327),
    [sym_left_assignment_list] = STATE(7480),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7481),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7481),
    [sym_false] = STATE(7481),
    [sym_nil] = STATE(7481),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7482),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11001),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11003),
    [anon_sym_yield] = ACTIONS(11005),
    [anon_sym_break] = ACTIONS(11007),
    [anon_sym_next] = ACTIONS(11009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11011),
    [anon_sym_defined_QMARK] = ACTIONS(11013),
    [anon_sym_not] = ACTIONS(11015),
    [anon_sym_BANG] = ACTIONS(11017),
    [anon_sym_TILDE] = ACTIONS(11017),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9282] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10328),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7481),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(7481),
    [sym_assignment] = STATE(10328),
    [sym_operator_assignment] = STATE(10328),
    [sym_conditional] = STATE(10328),
    [sym_range] = STATE(10328),
    [sym_binary] = STATE(10328),
    [sym_unary] = STATE(10328),
    [sym_left_assignment_list] = STATE(7480),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7481),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7481),
    [sym_false] = STATE(7481),
    [sym_nil] = STATE(7481),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7482),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11001),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11003),
    [anon_sym_yield] = ACTIONS(11005),
    [anon_sym_break] = ACTIONS(11007),
    [anon_sym_next] = ACTIONS(11009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11011),
    [anon_sym_defined_QMARK] = ACTIONS(11013),
    [anon_sym_not] = ACTIONS(11015),
    [anon_sym_BANG] = ACTIONS(11017),
    [anon_sym_TILDE] = ACTIONS(11017),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9283] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10329),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7481),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(7481),
    [sym_assignment] = STATE(10329),
    [sym_operator_assignment] = STATE(10329),
    [sym_conditional] = STATE(10329),
    [sym_range] = STATE(10329),
    [sym_binary] = STATE(10329),
    [sym_unary] = STATE(10329),
    [sym_left_assignment_list] = STATE(7480),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7481),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7481),
    [sym_false] = STATE(7481),
    [sym_nil] = STATE(7481),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7482),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11001),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11003),
    [anon_sym_yield] = ACTIONS(11005),
    [anon_sym_break] = ACTIONS(11007),
    [anon_sym_next] = ACTIONS(11009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11011),
    [anon_sym_defined_QMARK] = ACTIONS(11013),
    [anon_sym_not] = ACTIONS(11015),
    [anon_sym_BANG] = ACTIONS(11017),
    [anon_sym_TILDE] = ACTIONS(11017),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9284] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10330),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7481),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(7481),
    [sym_assignment] = STATE(10330),
    [sym_operator_assignment] = STATE(10330),
    [sym_conditional] = STATE(10330),
    [sym_range] = STATE(10330),
    [sym_binary] = STATE(10330),
    [sym_unary] = STATE(10330),
    [sym_left_assignment_list] = STATE(7480),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7481),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7481),
    [sym_false] = STATE(7481),
    [sym_nil] = STATE(7481),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7482),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11001),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11003),
    [anon_sym_yield] = ACTIONS(11005),
    [anon_sym_break] = ACTIONS(11007),
    [anon_sym_next] = ACTIONS(11009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11011),
    [anon_sym_defined_QMARK] = ACTIONS(11013),
    [anon_sym_not] = ACTIONS(11015),
    [anon_sym_BANG] = ACTIONS(11017),
    [anon_sym_TILDE] = ACTIONS(11017),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9285] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10331),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7481),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(7481),
    [sym_assignment] = STATE(10331),
    [sym_operator_assignment] = STATE(10331),
    [sym_conditional] = STATE(10331),
    [sym_range] = STATE(10331),
    [sym_binary] = STATE(10331),
    [sym_unary] = STATE(10331),
    [sym_left_assignment_list] = STATE(7480),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7481),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7481),
    [sym_false] = STATE(7481),
    [sym_nil] = STATE(7481),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7482),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11001),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11003),
    [anon_sym_yield] = ACTIONS(11005),
    [anon_sym_break] = ACTIONS(11007),
    [anon_sym_next] = ACTIONS(11009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11011),
    [anon_sym_defined_QMARK] = ACTIONS(11013),
    [anon_sym_not] = ACTIONS(11015),
    [anon_sym_BANG] = ACTIONS(11017),
    [anon_sym_TILDE] = ACTIONS(11017),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9286] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(10332),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(10332),
    [sym_operator_assignment] = STATE(10332),
    [sym_conditional] = STATE(10332),
    [sym_range] = STATE(10332),
    [sym_binary] = STATE(10332),
    [sym_unary] = STATE(10332),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9287] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10333),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7481),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(7481),
    [sym_assignment] = STATE(10333),
    [sym_operator_assignment] = STATE(10333),
    [sym_conditional] = STATE(10333),
    [sym_range] = STATE(10333),
    [sym_binary] = STATE(10333),
    [sym_unary] = STATE(10333),
    [sym_left_assignment_list] = STATE(7480),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7481),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7481),
    [sym_false] = STATE(7481),
    [sym_nil] = STATE(7481),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7482),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11001),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11003),
    [anon_sym_yield] = ACTIONS(11005),
    [anon_sym_break] = ACTIONS(11007),
    [anon_sym_next] = ACTIONS(11009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11011),
    [anon_sym_defined_QMARK] = ACTIONS(11013),
    [anon_sym_not] = ACTIONS(11015),
    [anon_sym_BANG] = ACTIONS(11017),
    [anon_sym_TILDE] = ACTIONS(11017),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9288] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10334),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7481),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(7481),
    [sym_assignment] = STATE(10334),
    [sym_operator_assignment] = STATE(10334),
    [sym_conditional] = STATE(10334),
    [sym_range] = STATE(10334),
    [sym_binary] = STATE(10334),
    [sym_unary] = STATE(10334),
    [sym_left_assignment_list] = STATE(7480),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7481),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7481),
    [sym_false] = STATE(7481),
    [sym_nil] = STATE(7481),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7482),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11001),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11003),
    [anon_sym_yield] = ACTIONS(11005),
    [anon_sym_break] = ACTIONS(11007),
    [anon_sym_next] = ACTIONS(11009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11011),
    [anon_sym_defined_QMARK] = ACTIONS(11013),
    [anon_sym_not] = ACTIONS(11015),
    [anon_sym_BANG] = ACTIONS(11017),
    [anon_sym_TILDE] = ACTIONS(11017),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9289] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10335),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7481),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(7481),
    [sym_assignment] = STATE(10335),
    [sym_operator_assignment] = STATE(10335),
    [sym_conditional] = STATE(10335),
    [sym_range] = STATE(10335),
    [sym_binary] = STATE(10335),
    [sym_unary] = STATE(10335),
    [sym_left_assignment_list] = STATE(7480),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7481),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7481),
    [sym_false] = STATE(7481),
    [sym_nil] = STATE(7481),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7482),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11001),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11003),
    [anon_sym_yield] = ACTIONS(11005),
    [anon_sym_break] = ACTIONS(11007),
    [anon_sym_next] = ACTIONS(11009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11011),
    [anon_sym_defined_QMARK] = ACTIONS(11013),
    [anon_sym_not] = ACTIONS(11015),
    [anon_sym_BANG] = ACTIONS(11017),
    [anon_sym_TILDE] = ACTIONS(11017),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9290] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10336),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7481),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(7481),
    [sym_assignment] = STATE(10336),
    [sym_operator_assignment] = STATE(10336),
    [sym_conditional] = STATE(10336),
    [sym_range] = STATE(10336),
    [sym_binary] = STATE(10336),
    [sym_unary] = STATE(10336),
    [sym_left_assignment_list] = STATE(7480),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7481),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7481),
    [sym_false] = STATE(7481),
    [sym_nil] = STATE(7481),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7482),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11001),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11003),
    [anon_sym_yield] = ACTIONS(11005),
    [anon_sym_break] = ACTIONS(11007),
    [anon_sym_next] = ACTIONS(11009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11011),
    [anon_sym_defined_QMARK] = ACTIONS(11013),
    [anon_sym_not] = ACTIONS(11015),
    [anon_sym_BANG] = ACTIONS(11017),
    [anon_sym_TILDE] = ACTIONS(11017),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9291] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10337),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7481),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(7481),
    [sym_splat_argument] = STATE(10338),
    [sym_assignment] = STATE(10337),
    [sym_operator_assignment] = STATE(10337),
    [sym_conditional] = STATE(10337),
    [sym_range] = STATE(10337),
    [sym_binary] = STATE(10337),
    [sym_unary] = STATE(10337),
    [sym_right_assignment_list] = STATE(2570),
    [sym__arg_or_splat_arg] = STATE(10338),
    [sym_left_assignment_list] = STATE(7480),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7481),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7481),
    [sym_false] = STATE(7481),
    [sym_nil] = STATE(7481),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7482),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(7992),
    [sym__unary_minus] = ACTIONS(11001),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11003),
    [anon_sym_yield] = ACTIONS(11005),
    [anon_sym_break] = ACTIONS(11007),
    [anon_sym_next] = ACTIONS(11009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11011),
    [anon_sym_defined_QMARK] = ACTIONS(11013),
    [anon_sym_not] = ACTIONS(11015),
    [anon_sym_BANG] = ACTIONS(11017),
    [anon_sym_TILDE] = ACTIONS(11017),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9292] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10339),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7481),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(7481),
    [sym_assignment] = STATE(10339),
    [sym_operator_assignment] = STATE(10339),
    [sym_conditional] = STATE(10339),
    [sym_range] = STATE(10339),
    [sym_binary] = STATE(10339),
    [sym_unary] = STATE(10339),
    [sym_left_assignment_list] = STATE(7480),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7481),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7481),
    [sym_false] = STATE(7481),
    [sym_nil] = STATE(7481),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7482),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11001),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11003),
    [anon_sym_yield] = ACTIONS(11005),
    [anon_sym_break] = ACTIONS(11007),
    [anon_sym_next] = ACTIONS(11009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11011),
    [anon_sym_defined_QMARK] = ACTIONS(11013),
    [anon_sym_not] = ACTIONS(11015),
    [anon_sym_BANG] = ACTIONS(11017),
    [anon_sym_TILDE] = ACTIONS(11017),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9293] = {
    [sym_string] = STATE(10340),
    [aux_sym_chained_string_repeat1] = STATE(10340),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_end] = ACTIONS(2753),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_elsif] = ACTIONS(2753),
    [anon_sym_else] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [9294] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(12898),
    [sym__binary_star] = ACTIONS(12900),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(12902),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(12900),
    [anon_sym_AMP] = ACTIONS(12904),
    [anon_sym_LT] = ACTIONS(12906),
    [anon_sym_end] = ACTIONS(6823),
    [anon_sym_if] = ACTIONS(6823),
    [anon_sym_unless] = ACTIONS(6823),
    [anon_sym_while] = ACTIONS(6823),
    [anon_sym_until] = ACTIONS(6823),
    [anon_sym_rescue] = ACTIONS(6823),
    [anon_sym_elsif] = ACTIONS(6823),
    [anon_sym_else] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(12908),
    [anon_sym_DOT_DOT] = ACTIONS(12910),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12912),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(12914),
    [anon_sym_AMP_AMP] = ACTIONS(12914),
    [anon_sym_LT_LT] = ACTIONS(12916),
    [anon_sym_GT_GT] = ACTIONS(12916),
    [anon_sym_EQ_EQ] = ACTIONS(12918),
    [anon_sym_BANG_EQ] = ACTIONS(12914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12914),
    [anon_sym_LT_EQ_GT] = ACTIONS(12914),
    [anon_sym_EQ_TILDE] = ACTIONS(12914),
    [anon_sym_BANG_TILDE] = ACTIONS(12914),
    [anon_sym_LT_EQ] = ACTIONS(12906),
    [anon_sym_GT] = ACTIONS(12906),
    [anon_sym_GT_EQ] = ACTIONS(12920),
    [anon_sym_CARET] = ACTIONS(12922),
    [anon_sym_PLUS] = ACTIONS(12898),
    [anon_sym_SLASH] = ACTIONS(12900),
    [anon_sym_PERCENT] = ACTIONS(12900),
    [sym_comment] = ACTIONS(87),
  },
  [9295] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(11033),
    [sym__binary_star] = ACTIONS(11035),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(11037),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(11035),
    [anon_sym_AMP] = ACTIONS(11039),
    [anon_sym_LT] = ACTIONS(11041),
    [anon_sym_end] = ACTIONS(4211),
    [anon_sym_if] = ACTIONS(4211),
    [anon_sym_unless] = ACTIONS(4211),
    [anon_sym_while] = ACTIONS(4211),
    [anon_sym_until] = ACTIONS(4211),
    [anon_sym_rescue] = ACTIONS(4211),
    [anon_sym_elsif] = ACTIONS(4211),
    [anon_sym_else] = ACTIONS(4211),
    [anon_sym_EQ_GT] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(11043),
    [anon_sym_DOT_DOT] = ACTIONS(11045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11047),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11049),
    [anon_sym_AMP_AMP] = ACTIONS(11049),
    [anon_sym_LT_LT] = ACTIONS(11051),
    [anon_sym_GT_GT] = ACTIONS(11051),
    [anon_sym_EQ_EQ] = ACTIONS(11053),
    [anon_sym_BANG_EQ] = ACTIONS(11049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11049),
    [anon_sym_LT_EQ_GT] = ACTIONS(11049),
    [anon_sym_EQ_TILDE] = ACTIONS(11049),
    [anon_sym_BANG_TILDE] = ACTIONS(11049),
    [anon_sym_LT_EQ] = ACTIONS(11041),
    [anon_sym_GT] = ACTIONS(11041),
    [anon_sym_GT_EQ] = ACTIONS(11055),
    [anon_sym_CARET] = ACTIONS(11057),
    [anon_sym_PLUS] = ACTIONS(11033),
    [anon_sym_SLASH] = ACTIONS(11035),
    [anon_sym_PERCENT] = ACTIONS(11035),
    [sym_comment] = ACTIONS(87),
  },
  [9296] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(11033),
    [sym__binary_star] = ACTIONS(11035),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(11037),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(11035),
    [anon_sym_AMP] = ACTIONS(11039),
    [anon_sym_LT] = ACTIONS(11041),
    [anon_sym_end] = ACTIONS(4247),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_elsif] = ACTIONS(4247),
    [anon_sym_else] = ACTIONS(4247),
    [anon_sym_EQ_GT] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(11043),
    [anon_sym_DOT_DOT] = ACTIONS(11045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11047),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(11049),
    [anon_sym_AMP_AMP] = ACTIONS(11049),
    [anon_sym_LT_LT] = ACTIONS(11051),
    [anon_sym_GT_GT] = ACTIONS(11051),
    [anon_sym_EQ_EQ] = ACTIONS(11053),
    [anon_sym_BANG_EQ] = ACTIONS(11049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11049),
    [anon_sym_LT_EQ_GT] = ACTIONS(11049),
    [anon_sym_EQ_TILDE] = ACTIONS(11049),
    [anon_sym_BANG_TILDE] = ACTIONS(11049),
    [anon_sym_LT_EQ] = ACTIONS(11041),
    [anon_sym_GT] = ACTIONS(11041),
    [anon_sym_GT_EQ] = ACTIONS(11055),
    [anon_sym_CARET] = ACTIONS(11057),
    [anon_sym_PLUS] = ACTIONS(11033),
    [anon_sym_SLASH] = ACTIONS(11035),
    [anon_sym_PERCENT] = ACTIONS(11035),
    [sym_comment] = ACTIONS(87),
  },
  [9297] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10341),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5061),
    [sym_scope_resolution] = STATE(5057),
    [sym_call] = STATE(5057),
    [sym_method_call] = STATE(5061),
    [sym_assignment] = STATE(10341),
    [sym_operator_assignment] = STATE(10341),
    [sym_conditional] = STATE(10341),
    [sym_range] = STATE(10341),
    [sym_binary] = STATE(10341),
    [sym_unary] = STATE(10341),
    [sym_left_assignment_list] = STATE(5060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5061),
    [sym__variable] = STATE(5057),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5061),
    [sym_false] = STATE(5061),
    [sym_nil] = STATE(5061),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7485),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(7994),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7998),
    [anon_sym_yield] = ACTIONS(8000),
    [anon_sym_break] = ACTIONS(8002),
    [anon_sym_next] = ACTIONS(8004),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11019),
    [anon_sym_defined_QMARK] = ACTIONS(8006),
    [anon_sym_not] = ACTIONS(8008),
    [anon_sym_BANG] = ACTIONS(8012),
    [anon_sym_TILDE] = ACTIONS(8012),
    [sym_constant] = ACTIONS(8018),
    [sym_identifier] = ACTIONS(8018),
    [sym_instance_variable] = ACTIONS(8016),
    [sym_class_variable] = ACTIONS(8016),
    [sym_global_variable] = ACTIONS(8016),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8018),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8018),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9298] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(11033),
    [sym__binary_star] = ACTIONS(11035),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(11037),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(11035),
    [anon_sym_AMP] = ACTIONS(11039),
    [anon_sym_LT] = ACTIONS(11041),
    [anon_sym_end] = ACTIONS(3281),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_unless] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_until] = ACTIONS(3281),
    [anon_sym_rescue] = ACTIONS(3281),
    [anon_sym_elsif] = ACTIONS(3281),
    [anon_sym_else] = ACTIONS(3281),
    [anon_sym_EQ_GT] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(11043),
    [anon_sym_DOT_DOT] = ACTIONS(11045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11047),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(11049),
    [anon_sym_AMP_AMP] = ACTIONS(11049),
    [anon_sym_LT_LT] = ACTIONS(11051),
    [anon_sym_GT_GT] = ACTIONS(11051),
    [anon_sym_EQ_EQ] = ACTIONS(11053),
    [anon_sym_BANG_EQ] = ACTIONS(11049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11049),
    [anon_sym_LT_EQ_GT] = ACTIONS(11049),
    [anon_sym_EQ_TILDE] = ACTIONS(11049),
    [anon_sym_BANG_TILDE] = ACTIONS(11049),
    [anon_sym_LT_EQ] = ACTIONS(11041),
    [anon_sym_GT] = ACTIONS(11041),
    [anon_sym_GT_EQ] = ACTIONS(11055),
    [anon_sym_CARET] = ACTIONS(11057),
    [anon_sym_PLUS] = ACTIONS(11033),
    [anon_sym_SLASH] = ACTIONS(11035),
    [anon_sym_PERCENT] = ACTIONS(11035),
    [sym_comment] = ACTIONS(87),
  },
  [9299] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10342),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5061),
    [sym_scope_resolution] = STATE(5057),
    [sym_call] = STATE(5057),
    [sym_method_call] = STATE(5061),
    [sym_assignment] = STATE(10342),
    [sym_operator_assignment] = STATE(10342),
    [sym_conditional] = STATE(10342),
    [sym_range] = STATE(10342),
    [sym_binary] = STATE(10342),
    [sym_unary] = STATE(10342),
    [sym_left_assignment_list] = STATE(5060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5061),
    [sym__variable] = STATE(5057),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5061),
    [sym_false] = STATE(5061),
    [sym_nil] = STATE(5061),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7485),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(7994),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7998),
    [anon_sym_yield] = ACTIONS(8000),
    [anon_sym_break] = ACTIONS(8002),
    [anon_sym_next] = ACTIONS(8004),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11019),
    [anon_sym_defined_QMARK] = ACTIONS(8006),
    [anon_sym_not] = ACTIONS(8008),
    [anon_sym_BANG] = ACTIONS(8012),
    [anon_sym_TILDE] = ACTIONS(8012),
    [sym_constant] = ACTIONS(8018),
    [sym_identifier] = ACTIONS(8018),
    [sym_instance_variable] = ACTIONS(8016),
    [sym_class_variable] = ACTIONS(8016),
    [sym_global_variable] = ACTIONS(8016),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8018),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8018),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9300] = {
    [sym_heredoc_body] = STATE(10343),
    [aux_sym_call_repeat1] = STATE(10343),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_elsif] = ACTIONS(4383),
    [anon_sym_else] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [9301] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7493),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5061),
    [sym_scope_resolution] = STATE(5057),
    [sym_call] = STATE(5057),
    [sym_method_call] = STATE(5061),
    [sym__argument] = STATE(2565),
    [sym_splat_argument] = STATE(2565),
    [sym_hash_splat_argument] = STATE(2565),
    [sym_block_argument] = STATE(2565),
    [sym_assignment] = STATE(7493),
    [sym_operator_assignment] = STATE(7493),
    [sym_conditional] = STATE(7493),
    [sym_range] = STATE(7493),
    [sym_binary] = STATE(7493),
    [sym_unary] = STATE(7493),
    [sym_left_assignment_list] = STATE(5060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5061),
    [sym__variable] = STATE(5057),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5061),
    [sym_false] = STATE(5061),
    [sym_nil] = STATE(5061),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7496),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(10344),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2565),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(11023),
    [sym__splat_star] = ACTIONS(11025),
    [sym__unary_minus] = ACTIONS(7994),
    [sym__identifier_hash_key] = ACTIONS(11027),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(14088),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7998),
    [anon_sym_yield] = ACTIONS(8000),
    [anon_sym_break] = ACTIONS(8002),
    [anon_sym_next] = ACTIONS(8004),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11019),
    [anon_sym_defined_QMARK] = ACTIONS(8006),
    [anon_sym_not] = ACTIONS(8008),
    [anon_sym_BANG] = ACTIONS(8012),
    [anon_sym_TILDE] = ACTIONS(8012),
    [sym_constant] = ACTIONS(11029),
    [sym_identifier] = ACTIONS(11029),
    [sym_instance_variable] = ACTIONS(8016),
    [sym_class_variable] = ACTIONS(8016),
    [sym_global_variable] = ACTIONS(8016),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8018),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8018),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9302] = {
    [sym_heredoc_body] = STATE(10345),
    [aux_sym_call_repeat1] = STATE(10345),
    [aux_sym_argument_list_repeat1] = STATE(10346),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(12934),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_elsif] = ACTIONS(4383),
    [anon_sym_else] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [9303] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(12898),
    [sym__binary_star] = ACTIONS(12900),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(12902),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(12900),
    [anon_sym_AMP] = ACTIONS(12904),
    [anon_sym_LT] = ACTIONS(12906),
    [anon_sym_end] = ACTIONS(7027),
    [anon_sym_if] = ACTIONS(7027),
    [anon_sym_unless] = ACTIONS(7027),
    [anon_sym_while] = ACTIONS(7027),
    [anon_sym_until] = ACTIONS(7027),
    [anon_sym_rescue] = ACTIONS(7027),
    [anon_sym_elsif] = ACTIONS(7027),
    [anon_sym_else] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(12908),
    [anon_sym_DOT_DOT] = ACTIONS(12910),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12912),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(12914),
    [anon_sym_AMP_AMP] = ACTIONS(12914),
    [anon_sym_LT_LT] = ACTIONS(12916),
    [anon_sym_GT_GT] = ACTIONS(12916),
    [anon_sym_EQ_EQ] = ACTIONS(12918),
    [anon_sym_BANG_EQ] = ACTIONS(12914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12914),
    [anon_sym_LT_EQ_GT] = ACTIONS(12914),
    [anon_sym_EQ_TILDE] = ACTIONS(12914),
    [anon_sym_BANG_TILDE] = ACTIONS(12914),
    [anon_sym_LT_EQ] = ACTIONS(12906),
    [anon_sym_GT] = ACTIONS(12906),
    [anon_sym_GT_EQ] = ACTIONS(12920),
    [anon_sym_CARET] = ACTIONS(12922),
    [anon_sym_PLUS] = ACTIONS(12898),
    [anon_sym_SLASH] = ACTIONS(12900),
    [anon_sym_PERCENT] = ACTIONS(12900),
    [sym_comment] = ACTIONS(87),
  },
  [9304] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(11035),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11035),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_elsif] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(11035),
    [anon_sym_PERCENT] = ACTIONS(11035),
    [sym_comment] = ACTIONS(87),
  },
  [9305] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11035),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_elsif] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [9306] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11033),
    [sym__binary_star] = ACTIONS(11035),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11035),
    [anon_sym_AMP] = ACTIONS(11039),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_elsif] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(11051),
    [anon_sym_GT_GT] = ACTIONS(11051),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(11033),
    [anon_sym_SLASH] = ACTIONS(11035),
    [anon_sym_PERCENT] = ACTIONS(11035),
    [sym_comment] = ACTIONS(87),
  },
  [9307] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11033),
    [sym__binary_star] = ACTIONS(11035),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11035),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_elsif] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(11051),
    [anon_sym_GT_GT] = ACTIONS(11051),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(11033),
    [anon_sym_SLASH] = ACTIONS(11035),
    [anon_sym_PERCENT] = ACTIONS(11035),
    [sym_comment] = ACTIONS(87),
  },
  [9308] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11033),
    [sym__binary_star] = ACTIONS(11035),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(11037),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11035),
    [anon_sym_AMP] = ACTIONS(11039),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_elsif] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(11051),
    [anon_sym_GT_GT] = ACTIONS(11051),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(11057),
    [anon_sym_PLUS] = ACTIONS(11033),
    [anon_sym_SLASH] = ACTIONS(11035),
    [anon_sym_PERCENT] = ACTIONS(11035),
    [sym_comment] = ACTIONS(87),
  },
  [9309] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(14090),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [9310] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(11033),
    [sym__binary_star] = ACTIONS(11035),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(11037),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(11035),
    [anon_sym_AMP] = ACTIONS(11039),
    [anon_sym_LT] = ACTIONS(11041),
    [anon_sym_end] = ACTIONS(5927),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_elsif] = ACTIONS(5927),
    [anon_sym_else] = ACTIONS(5927),
    [anon_sym_EQ_GT] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(11045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11047),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(11049),
    [anon_sym_AMP_AMP] = ACTIONS(11049),
    [anon_sym_LT_LT] = ACTIONS(11051),
    [anon_sym_GT_GT] = ACTIONS(11051),
    [anon_sym_EQ_EQ] = ACTIONS(11053),
    [anon_sym_BANG_EQ] = ACTIONS(11049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11049),
    [anon_sym_LT_EQ_GT] = ACTIONS(11049),
    [anon_sym_EQ_TILDE] = ACTIONS(11049),
    [anon_sym_BANG_TILDE] = ACTIONS(11049),
    [anon_sym_LT_EQ] = ACTIONS(11041),
    [anon_sym_GT] = ACTIONS(11041),
    [anon_sym_GT_EQ] = ACTIONS(11055),
    [anon_sym_CARET] = ACTIONS(11057),
    [anon_sym_PLUS] = ACTIONS(11033),
    [anon_sym_SLASH] = ACTIONS(11035),
    [anon_sym_PERCENT] = ACTIONS(11035),
    [sym_comment] = ACTIONS(87),
  },
  [9311] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11033),
    [sym__binary_star] = ACTIONS(11035),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(11037),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11035),
    [anon_sym_AMP] = ACTIONS(11039),
    [anon_sym_LT] = ACTIONS(11041),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_elsif] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(11043),
    [anon_sym_DOT_DOT] = ACTIONS(11045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11047),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(11049),
    [anon_sym_AMP_AMP] = ACTIONS(11049),
    [anon_sym_LT_LT] = ACTIONS(11051),
    [anon_sym_GT_GT] = ACTIONS(11051),
    [anon_sym_EQ_EQ] = ACTIONS(11053),
    [anon_sym_BANG_EQ] = ACTIONS(11049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11049),
    [anon_sym_LT_EQ_GT] = ACTIONS(11049),
    [anon_sym_EQ_TILDE] = ACTIONS(11049),
    [anon_sym_BANG_TILDE] = ACTIONS(11049),
    [anon_sym_LT_EQ] = ACTIONS(11041),
    [anon_sym_GT] = ACTIONS(11041),
    [anon_sym_GT_EQ] = ACTIONS(11055),
    [anon_sym_CARET] = ACTIONS(11057),
    [anon_sym_PLUS] = ACTIONS(11033),
    [anon_sym_SLASH] = ACTIONS(11035),
    [anon_sym_PERCENT] = ACTIONS(11035),
    [sym_comment] = ACTIONS(87),
  },
  [9312] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11033),
    [sym__binary_star] = ACTIONS(11035),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(11037),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11035),
    [anon_sym_AMP] = ACTIONS(11039),
    [anon_sym_LT] = ACTIONS(11041),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_elsif] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(11051),
    [anon_sym_GT_GT] = ACTIONS(11051),
    [anon_sym_EQ_EQ] = ACTIONS(11053),
    [anon_sym_BANG_EQ] = ACTIONS(11049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11049),
    [anon_sym_LT_EQ_GT] = ACTIONS(11049),
    [anon_sym_EQ_TILDE] = ACTIONS(11049),
    [anon_sym_BANG_TILDE] = ACTIONS(11049),
    [anon_sym_LT_EQ] = ACTIONS(11041),
    [anon_sym_GT] = ACTIONS(11041),
    [anon_sym_GT_EQ] = ACTIONS(11055),
    [anon_sym_CARET] = ACTIONS(11057),
    [anon_sym_PLUS] = ACTIONS(11033),
    [anon_sym_SLASH] = ACTIONS(11035),
    [anon_sym_PERCENT] = ACTIONS(11035),
    [sym_comment] = ACTIONS(87),
  },
  [9313] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11033),
    [sym__binary_star] = ACTIONS(11035),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11035),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_elsif] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(11033),
    [anon_sym_SLASH] = ACTIONS(11035),
    [anon_sym_PERCENT] = ACTIONS(11035),
    [sym_comment] = ACTIONS(87),
  },
  [9314] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(11105),
    [sym__binary_star] = ACTIONS(11107),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(11109),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(11111),
    [anon_sym_AMP] = ACTIONS(11113),
    [anon_sym_EQ] = ACTIONS(4217),
    [anon_sym_LT] = ACTIONS(11115),
    [anon_sym_end] = ACTIONS(4211),
    [anon_sym_if] = ACTIONS(4211),
    [anon_sym_unless] = ACTIONS(4211),
    [anon_sym_while] = ACTIONS(4211),
    [anon_sym_until] = ACTIONS(4211),
    [anon_sym_rescue] = ACTIONS(4211),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_elsif] = ACTIONS(4211),
    [anon_sym_else] = ACTIONS(4211),
    [anon_sym_EQ_GT] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_PLUS_EQ] = ACTIONS(4211),
    [anon_sym_DASH_EQ] = ACTIONS(4211),
    [anon_sym_STAR_EQ] = ACTIONS(4211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4211),
    [anon_sym_SLASH_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4211),
    [anon_sym_AMP_EQ] = ACTIONS(4211),
    [anon_sym_PERCENT_EQ] = ACTIONS(4211),
    [anon_sym_GT_GT_EQ] = ACTIONS(4211),
    [anon_sym_LT_LT_EQ] = ACTIONS(4211),
    [anon_sym_CARET_EQ] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(11117),
    [anon_sym_DOT_DOT] = ACTIONS(11119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11121),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11123),
    [anon_sym_AMP_AMP] = ACTIONS(11123),
    [anon_sym_LT_LT] = ACTIONS(11125),
    [anon_sym_GT_GT] = ACTIONS(11125),
    [anon_sym_EQ_EQ] = ACTIONS(11123),
    [anon_sym_BANG_EQ] = ACTIONS(11127),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11127),
    [anon_sym_LT_EQ_GT] = ACTIONS(11127),
    [anon_sym_EQ_TILDE] = ACTIONS(11127),
    [anon_sym_BANG_TILDE] = ACTIONS(11127),
    [anon_sym_LT_EQ] = ACTIONS(11115),
    [anon_sym_GT] = ACTIONS(11115),
    [anon_sym_GT_EQ] = ACTIONS(11129),
    [anon_sym_CARET] = ACTIONS(11109),
    [anon_sym_PLUS] = ACTIONS(11131),
    [anon_sym_SLASH] = ACTIONS(11111),
    [anon_sym_PERCENT] = ACTIONS(11111),
    [sym_comment] = ACTIONS(87),
  },
  [9315] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(11105),
    [sym__binary_star] = ACTIONS(11107),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(11109),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(11111),
    [anon_sym_AMP] = ACTIONS(11113),
    [anon_sym_EQ] = ACTIONS(4249),
    [anon_sym_LT] = ACTIONS(11115),
    [anon_sym_end] = ACTIONS(4247),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_elsif] = ACTIONS(4247),
    [anon_sym_else] = ACTIONS(4247),
    [anon_sym_EQ_GT] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_PLUS_EQ] = ACTIONS(4247),
    [anon_sym_DASH_EQ] = ACTIONS(4247),
    [anon_sym_STAR_EQ] = ACTIONS(4247),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4247),
    [anon_sym_SLASH_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4247),
    [anon_sym_AMP_EQ] = ACTIONS(4247),
    [anon_sym_PERCENT_EQ] = ACTIONS(4247),
    [anon_sym_GT_GT_EQ] = ACTIONS(4247),
    [anon_sym_LT_LT_EQ] = ACTIONS(4247),
    [anon_sym_CARET_EQ] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(11117),
    [anon_sym_DOT_DOT] = ACTIONS(11119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11121),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(11123),
    [anon_sym_AMP_AMP] = ACTIONS(11123),
    [anon_sym_LT_LT] = ACTIONS(11125),
    [anon_sym_GT_GT] = ACTIONS(11125),
    [anon_sym_EQ_EQ] = ACTIONS(11123),
    [anon_sym_BANG_EQ] = ACTIONS(11127),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11127),
    [anon_sym_LT_EQ_GT] = ACTIONS(11127),
    [anon_sym_EQ_TILDE] = ACTIONS(11127),
    [anon_sym_BANG_TILDE] = ACTIONS(11127),
    [anon_sym_LT_EQ] = ACTIONS(11115),
    [anon_sym_GT] = ACTIONS(11115),
    [anon_sym_GT_EQ] = ACTIONS(11129),
    [anon_sym_CARET] = ACTIONS(11109),
    [anon_sym_PLUS] = ACTIONS(11131),
    [anon_sym_SLASH] = ACTIONS(11111),
    [anon_sym_PERCENT] = ACTIONS(11111),
    [sym_comment] = ACTIONS(87),
  },
  [9316] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(10348),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5097),
    [sym_scope_resolution] = STATE(5093),
    [sym_call] = STATE(5093),
    [sym_method_call] = STATE(5097),
    [sym_assignment] = STATE(10348),
    [sym_operator_assignment] = STATE(10348),
    [sym_conditional] = STATE(10348),
    [sym_range] = STATE(10348),
    [sym_binary] = STATE(10348),
    [sym_unary] = STATE(10348),
    [sym_left_assignment_list] = STATE(5096),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5097),
    [sym__variable] = STATE(5093),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5097),
    [sym_false] = STATE(5097),
    [sym_nil] = STATE(5097),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7554),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(8066),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(8070),
    [anon_sym_yield] = ACTIONS(8072),
    [anon_sym_break] = ACTIONS(8074),
    [anon_sym_next] = ACTIONS(8076),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(11099),
    [anon_sym_defined_QMARK] = ACTIONS(8078),
    [anon_sym_not] = ACTIONS(8080),
    [anon_sym_BANG] = ACTIONS(8084),
    [anon_sym_TILDE] = ACTIONS(8084),
    [sym_constant] = ACTIONS(8090),
    [sym_identifier] = ACTIONS(8090),
    [sym_instance_variable] = ACTIONS(8088),
    [sym_class_variable] = ACTIONS(8088),
    [sym_global_variable] = ACTIONS(8088),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8090),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8090),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [9317] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(11105),
    [sym__binary_star] = ACTIONS(11107),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(11109),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(11111),
    [anon_sym_AMP] = ACTIONS(11113),
    [anon_sym_EQ] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(11115),
    [anon_sym_end] = ACTIONS(3281),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_unless] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_until] = ACTIONS(3281),
    [anon_sym_rescue] = ACTIONS(3281),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_elsif] = ACTIONS(3281),
    [anon_sym_else] = ACTIONS(3281),
    [anon_sym_EQ_GT] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_PLUS_EQ] = ACTIONS(3281),
    [anon_sym_DASH_EQ] = ACTIONS(3281),
    [anon_sym_STAR_EQ] = ACTIONS(3281),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3281),
    [anon_sym_SLASH_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3281),
    [anon_sym_AMP_EQ] = ACTIONS(3281),
    [anon_sym_PERCENT_EQ] = ACTIONS(3281),
    [anon_sym_GT_GT_EQ] = ACTIONS(3281),
    [anon_sym_LT_LT_EQ] = ACTIONS(3281),
    [anon_sym_CARET_EQ] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(11117),
    [anon_sym_DOT_DOT] = ACTIONS(11119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11121),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(11123),
    [anon_sym_AMP_AMP] = ACTIONS(11123),
    [anon_sym_LT_LT] = ACTIONS(11125),
    [anon_sym_GT_GT] = ACTIONS(11125),
    [anon_sym_EQ_EQ] = ACTIONS(11123),
    [anon_sym_BANG_EQ] = ACTIONS(11127),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11127),
    [anon_sym_LT_EQ_GT] = ACTIONS(11127),
    [anon_sym_EQ_TILDE] = ACTIONS(11127),
    [anon_sym_BANG_TILDE] = ACTIONS(11127),
    [anon_sym_LT_EQ] = ACTIONS(11115),
    [anon_sym_GT] = ACTIONS(11115),
    [anon_sym_GT_EQ] = ACTIONS(11129),
    [anon_sym_CARET] = ACTIONS(11109),
    [anon_sym_PLUS] = ACTIONS(11131),
    [anon_sym_SLASH] = ACTIONS(11111),
    [anon_sym_PERCENT] = ACTIONS(11111),
    [sym_comment] = ACTIONS(87),
  },
  [9318] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(10349),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5097),
    [sym_scope_resolution] = STATE(5093),
    [sym_call] = STATE(5093),
    [sym_method_call] = STATE(5097),
    [sym_assignment] = STATE(10349),
    [sym_operator_assignment] = STATE(10349),
    [sym_conditional] = STATE(10349),
    [sym_range] = STATE(10349),
    [sym_binary] = STATE(10349),
    [sym_unary] = STATE(10349),
    [sym_left_assignment_list] = STATE(5096),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5097),
    [sym__variable] = STATE(5093),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5097),
    [sym_false] = STATE(5097),
    [sym_nil] = STATE(5097),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7554),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(8066),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(8070),
    [anon_sym_yield] = ACTIONS(8072),
    [anon_sym_break] = ACTIONS(8074),
    [anon_sym_next] = ACTIONS(8076),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(11099),
    [anon_sym_defined_QMARK] = ACTIONS(8078),
    [anon_sym_not] = ACTIONS(8080),
    [anon_sym_BANG] = ACTIONS(8084),
    [anon_sym_TILDE] = ACTIONS(8084),
    [sym_constant] = ACTIONS(8090),
    [sym_identifier] = ACTIONS(8090),
    [sym_instance_variable] = ACTIONS(8088),
    [sym_class_variable] = ACTIONS(8088),
    [sym_global_variable] = ACTIONS(8088),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8090),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8090),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [9319] = {
    [sym_heredoc_body] = STATE(10350),
    [aux_sym_call_repeat1] = STATE(10350),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_elsif] = ACTIONS(4383),
    [anon_sym_else] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [9320] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(7514),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5097),
    [sym_scope_resolution] = STATE(5093),
    [sym_call] = STATE(5093),
    [sym_method_call] = STATE(5097),
    [sym__argument] = STATE(4979),
    [sym_splat_argument] = STATE(4979),
    [sym_hash_splat_argument] = STATE(4979),
    [sym_block_argument] = STATE(4979),
    [sym_assignment] = STATE(7514),
    [sym_operator_assignment] = STATE(7514),
    [sym_conditional] = STATE(7514),
    [sym_range] = STATE(7514),
    [sym_binary] = STATE(7514),
    [sym_unary] = STATE(7514),
    [sym_left_assignment_list] = STATE(5096),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5097),
    [sym__variable] = STATE(5093),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5097),
    [sym_false] = STATE(5097),
    [sym_nil] = STATE(5097),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7517),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_heredoc_body] = STATE(10351),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(4979),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(11059),
    [sym__splat_star] = ACTIONS(11061),
    [sym__unary_minus] = ACTIONS(8066),
    [sym__identifier_hash_key] = ACTIONS(11063),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(14092),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(8070),
    [anon_sym_yield] = ACTIONS(8072),
    [anon_sym_break] = ACTIONS(8074),
    [anon_sym_next] = ACTIONS(8076),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(11099),
    [anon_sym_defined_QMARK] = ACTIONS(8078),
    [anon_sym_not] = ACTIONS(8080),
    [anon_sym_BANG] = ACTIONS(8084),
    [anon_sym_TILDE] = ACTIONS(8084),
    [sym_constant] = ACTIONS(11065),
    [sym_identifier] = ACTIONS(11065),
    [sym_instance_variable] = ACTIONS(8088),
    [sym_class_variable] = ACTIONS(8088),
    [sym_global_variable] = ACTIONS(8088),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8090),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8090),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [9321] = {
    [sym_heredoc_body] = STATE(10352),
    [aux_sym_call_repeat1] = STATE(10352),
    [aux_sym_argument_list_repeat1] = STATE(10353),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(12942),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_elsif] = ACTIONS(4383),
    [anon_sym_else] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [9322] = {
    [sym_heredoc_body] = STATE(9322),
    [aux_sym_call_repeat1] = STATE(9322),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(7916),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_end] = ACTIONS(7914),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_elsif] = ACTIONS(7914),
    [anon_sym_else] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [9323] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5056),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5061),
    [sym_scope_resolution] = STATE(5057),
    [sym_call] = STATE(5057),
    [sym_method_call] = STATE(5061),
    [sym__argument] = STATE(4986),
    [sym_splat_argument] = STATE(4986),
    [sym_hash_splat_argument] = STATE(4986),
    [sym_block_argument] = STATE(4986),
    [sym_assignment] = STATE(5056),
    [sym_operator_assignment] = STATE(5056),
    [sym_conditional] = STATE(5056),
    [sym_range] = STATE(5056),
    [sym_binary] = STATE(5056),
    [sym_unary] = STATE(5056),
    [sym_left_assignment_list] = STATE(5060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5061),
    [sym__variable] = STATE(5057),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5061),
    [sym_false] = STATE(5061),
    [sym_nil] = STATE(5061),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5062),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4986),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(7990),
    [sym__splat_star] = ACTIONS(7992),
    [sym__unary_minus] = ACTIONS(7994),
    [sym__identifier_hash_key] = ACTIONS(7996),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12946),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7998),
    [anon_sym_yield] = ACTIONS(8000),
    [anon_sym_break] = ACTIONS(8002),
    [anon_sym_next] = ACTIONS(8004),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11019),
    [anon_sym_defined_QMARK] = ACTIONS(8006),
    [anon_sym_not] = ACTIONS(8008),
    [anon_sym_BANG] = ACTIONS(8012),
    [anon_sym_TILDE] = ACTIONS(8012),
    [sym_constant] = ACTIONS(8014),
    [sym_identifier] = ACTIONS(8014),
    [sym_instance_variable] = ACTIONS(8016),
    [sym_class_variable] = ACTIONS(8016),
    [sym_global_variable] = ACTIONS(8016),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8018),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8018),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9324] = {
    [sym_heredoc_body] = STATE(9322),
    [aux_sym_call_repeat1] = STATE(9322),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_end] = ACTIONS(7929),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_elsif] = ACTIONS(7929),
    [anon_sym_else] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [9325] = {
    [aux_sym_argument_list_repeat1] = STATE(9325),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(14094),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7925),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_end] = ACTIONS(7925),
    [anon_sym_if] = ACTIONS(7925),
    [anon_sym_unless] = ACTIONS(7925),
    [anon_sym_while] = ACTIONS(7925),
    [anon_sym_until] = ACTIONS(7925),
    [anon_sym_rescue] = ACTIONS(7925),
    [anon_sym_elsif] = ACTIONS(7925),
    [anon_sym_else] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7925),
    [anon_sym_AMP_AMP] = ACTIONS(7925),
    [anon_sym_LT_LT] = ACTIONS(7925),
    [anon_sym_GT_GT] = ACTIONS(7925),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7925),
    [anon_sym_PLUS] = ACTIONS(7925),
    [anon_sym_SLASH] = ACTIONS(7925),
    [anon_sym_PERCENT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [9326] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(11033),
    [sym__binary_star] = ACTIONS(11035),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(11037),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(11035),
    [anon_sym_AMP] = ACTIONS(11039),
    [anon_sym_LT] = ACTIONS(11041),
    [anon_sym_end] = ACTIONS(5115),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_elsif] = ACTIONS(5115),
    [anon_sym_else] = ACTIONS(5115),
    [anon_sym_EQ_GT] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(11043),
    [anon_sym_DOT_DOT] = ACTIONS(11045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11047),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(11049),
    [anon_sym_AMP_AMP] = ACTIONS(11049),
    [anon_sym_LT_LT] = ACTIONS(11051),
    [anon_sym_GT_GT] = ACTIONS(11051),
    [anon_sym_EQ_EQ] = ACTIONS(11053),
    [anon_sym_BANG_EQ] = ACTIONS(11049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11049),
    [anon_sym_LT_EQ_GT] = ACTIONS(11049),
    [anon_sym_EQ_TILDE] = ACTIONS(11049),
    [anon_sym_BANG_TILDE] = ACTIONS(11049),
    [anon_sym_LT_EQ] = ACTIONS(11041),
    [anon_sym_GT] = ACTIONS(11041),
    [anon_sym_GT_EQ] = ACTIONS(11055),
    [anon_sym_CARET] = ACTIONS(11057),
    [anon_sym_PLUS] = ACTIONS(11033),
    [anon_sym_SLASH] = ACTIONS(11035),
    [anon_sym_PERCENT] = ACTIONS(11035),
    [sym_comment] = ACTIONS(87),
  },
  [9327] = {
    [aux_sym_exceptions_repeat1] = STATE(10355),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_end] = ACTIONS(6191),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_elsif] = ACTIONS(6191),
    [anon_sym_else] = ACTIONS(6191),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [9328] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(11033),
    [sym__binary_star] = ACTIONS(11035),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(11037),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(11035),
    [anon_sym_AMP] = ACTIONS(11039),
    [anon_sym_LT] = ACTIONS(11041),
    [anon_sym_end] = ACTIONS(6210),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_elsif] = ACTIONS(6210),
    [anon_sym_else] = ACTIONS(6210),
    [anon_sym_EQ_GT] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(11043),
    [anon_sym_DOT_DOT] = ACTIONS(11045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11047),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(11049),
    [anon_sym_AMP_AMP] = ACTIONS(11049),
    [anon_sym_LT_LT] = ACTIONS(11051),
    [anon_sym_GT_GT] = ACTIONS(11051),
    [anon_sym_EQ_EQ] = ACTIONS(11053),
    [anon_sym_BANG_EQ] = ACTIONS(11049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11049),
    [anon_sym_LT_EQ_GT] = ACTIONS(11049),
    [anon_sym_EQ_TILDE] = ACTIONS(11049),
    [anon_sym_BANG_TILDE] = ACTIONS(11049),
    [anon_sym_LT_EQ] = ACTIONS(11041),
    [anon_sym_GT] = ACTIONS(11041),
    [anon_sym_GT_EQ] = ACTIONS(11055),
    [anon_sym_CARET] = ACTIONS(11057),
    [anon_sym_PLUS] = ACTIONS(11033),
    [anon_sym_SLASH] = ACTIONS(11035),
    [anon_sym_PERCENT] = ACTIONS(11035),
    [sym_comment] = ACTIONS(87),
  },
  [9329] = {
    [sym_string] = STATE(9329),
    [aux_sym_chained_string_repeat1] = STATE(9329),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(6214),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_end] = ACTIONS(6212),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_elsif] = ACTIONS(6212),
    [anon_sym_else] = ACTIONS(6212),
    [anon_sym_EQ_GT] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [9330] = {
    [aux_sym_undef_repeat1] = STATE(9330),
    [sym__line_break] = ACTIONS(9263),
    [sym__heredoc_body_start] = ACTIONS(9263),
    [anon_sym_COMMA] = ACTIONS(9265),
    [anon_sym_SEMI] = ACTIONS(9263),
    [anon_sym_end] = ACTIONS(9263),
    [anon_sym_if] = ACTIONS(9263),
    [anon_sym_unless] = ACTIONS(9263),
    [anon_sym_while] = ACTIONS(9263),
    [anon_sym_until] = ACTIONS(9263),
    [anon_sym_rescue] = ACTIONS(9263),
    [anon_sym_elsif] = ACTIONS(9263),
    [anon_sym_else] = ACTIONS(9263),
    [sym_comment] = ACTIONS(87),
  },
  [9331] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10356),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2645),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(2645),
    [sym_assignment] = STATE(10356),
    [sym_operator_assignment] = STATE(10356),
    [sym_conditional] = STATE(10356),
    [sym_range] = STATE(10356),
    [sym_binary] = STATE(10356),
    [sym_unary] = STATE(10356),
    [sym_left_assignment_list] = STATE(2644),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2645),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2645),
    [sym_false] = STATE(2645),
    [sym_nil] = STATE(2645),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2646),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4467),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4471),
    [anon_sym_yield] = ACTIONS(4473),
    [anon_sym_break] = ACTIONS(4475),
    [anon_sym_next] = ACTIONS(4477),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4479),
    [anon_sym_defined_QMARK] = ACTIONS(4481),
    [anon_sym_not] = ACTIONS(4483),
    [anon_sym_BANG] = ACTIONS(4485),
    [anon_sym_TILDE] = ACTIONS(4485),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9332] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(12956),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_elsif] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [9333] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(12950),
    [sym__binary_star] = ACTIONS(12952),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(12954),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(12956),
    [anon_sym_AMP] = ACTIONS(12958),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(12960),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_elsif] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(12962),
    [anon_sym_DOT_DOT] = ACTIONS(12964),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12966),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(12968),
    [anon_sym_AMP_AMP] = ACTIONS(12968),
    [anon_sym_LT_LT] = ACTIONS(12970),
    [anon_sym_GT_GT] = ACTIONS(12970),
    [anon_sym_EQ_EQ] = ACTIONS(12968),
    [anon_sym_BANG_EQ] = ACTIONS(12972),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12972),
    [anon_sym_LT_EQ_GT] = ACTIONS(12972),
    [anon_sym_EQ_TILDE] = ACTIONS(12972),
    [anon_sym_BANG_TILDE] = ACTIONS(12972),
    [anon_sym_LT_EQ] = ACTIONS(12960),
    [anon_sym_GT] = ACTIONS(12960),
    [anon_sym_GT_EQ] = ACTIONS(12974),
    [anon_sym_CARET] = ACTIONS(12954),
    [anon_sym_PLUS] = ACTIONS(12976),
    [anon_sym_SLASH] = ACTIONS(12956),
    [anon_sym_PERCENT] = ACTIONS(12956),
    [sym_comment] = ACTIONS(87),
  },
  [9334] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10357),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7550),
    [sym_scope_resolution] = STATE(7548),
    [sym_call] = STATE(7548),
    [sym_method_call] = STATE(7550),
    [sym_assignment] = STATE(10357),
    [sym_operator_assignment] = STATE(10357),
    [sym_conditional] = STATE(10357),
    [sym_range] = STATE(10357),
    [sym_binary] = STATE(10357),
    [sym_unary] = STATE(10357),
    [sym_left_assignment_list] = STATE(7549),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7550),
    [sym__variable] = STATE(7548),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7550),
    [sym_false] = STATE(7550),
    [sym_nil] = STATE(7550),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7551),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11077),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11079),
    [anon_sym_yield] = ACTIONS(11081),
    [anon_sym_break] = ACTIONS(11083),
    [anon_sym_next] = ACTIONS(11085),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11087),
    [anon_sym_defined_QMARK] = ACTIONS(11089),
    [anon_sym_not] = ACTIONS(11091),
    [anon_sym_BANG] = ACTIONS(11093),
    [anon_sym_TILDE] = ACTIONS(11093),
    [sym_constant] = ACTIONS(11095),
    [sym_identifier] = ACTIONS(11095),
    [sym_instance_variable] = ACTIONS(11097),
    [sym_class_variable] = ACTIONS(11097),
    [sym_global_variable] = ACTIONS(11097),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11095),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11095),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [9335] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10358),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7550),
    [sym_scope_resolution] = STATE(7548),
    [sym_call] = STATE(7548),
    [sym_method_call] = STATE(7550),
    [sym_assignment] = STATE(10358),
    [sym_operator_assignment] = STATE(10358),
    [sym_conditional] = STATE(10358),
    [sym_range] = STATE(10358),
    [sym_binary] = STATE(10358),
    [sym_unary] = STATE(10358),
    [sym_left_assignment_list] = STATE(7549),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7550),
    [sym__variable] = STATE(7548),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7550),
    [sym_false] = STATE(7550),
    [sym_nil] = STATE(7550),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7551),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11077),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11079),
    [anon_sym_yield] = ACTIONS(11081),
    [anon_sym_break] = ACTIONS(11083),
    [anon_sym_next] = ACTIONS(11085),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11087),
    [anon_sym_defined_QMARK] = ACTIONS(11089),
    [anon_sym_not] = ACTIONS(11091),
    [anon_sym_BANG] = ACTIONS(11093),
    [anon_sym_TILDE] = ACTIONS(11093),
    [sym_constant] = ACTIONS(11095),
    [sym_identifier] = ACTIONS(11095),
    [sym_instance_variable] = ACTIONS(11097),
    [sym_class_variable] = ACTIONS(11097),
    [sym_global_variable] = ACTIONS(11097),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11095),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11095),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [9336] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10359),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7550),
    [sym_scope_resolution] = STATE(7548),
    [sym_call] = STATE(7548),
    [sym_method_call] = STATE(7550),
    [sym_assignment] = STATE(10359),
    [sym_operator_assignment] = STATE(10359),
    [sym_conditional] = STATE(10359),
    [sym_range] = STATE(10359),
    [sym_binary] = STATE(10359),
    [sym_unary] = STATE(10359),
    [sym_left_assignment_list] = STATE(7549),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7550),
    [sym__variable] = STATE(7548),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7550),
    [sym_false] = STATE(7550),
    [sym_nil] = STATE(7550),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7551),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11077),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11079),
    [anon_sym_yield] = ACTIONS(11081),
    [anon_sym_break] = ACTIONS(11083),
    [anon_sym_next] = ACTIONS(11085),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11087),
    [anon_sym_defined_QMARK] = ACTIONS(11089),
    [anon_sym_not] = ACTIONS(11091),
    [anon_sym_BANG] = ACTIONS(11093),
    [anon_sym_TILDE] = ACTIONS(11093),
    [sym_constant] = ACTIONS(11095),
    [sym_identifier] = ACTIONS(11095),
    [sym_instance_variable] = ACTIONS(11097),
    [sym_class_variable] = ACTIONS(11097),
    [sym_global_variable] = ACTIONS(11097),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11095),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11095),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [9337] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10360),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7550),
    [sym_scope_resolution] = STATE(7548),
    [sym_call] = STATE(7548),
    [sym_method_call] = STATE(7550),
    [sym_assignment] = STATE(10360),
    [sym_operator_assignment] = STATE(10360),
    [sym_conditional] = STATE(10360),
    [sym_range] = STATE(10360),
    [sym_binary] = STATE(10360),
    [sym_unary] = STATE(10360),
    [sym_left_assignment_list] = STATE(7549),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7550),
    [sym__variable] = STATE(7548),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7550),
    [sym_false] = STATE(7550),
    [sym_nil] = STATE(7550),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7551),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11077),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11079),
    [anon_sym_yield] = ACTIONS(11081),
    [anon_sym_break] = ACTIONS(11083),
    [anon_sym_next] = ACTIONS(11085),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11087),
    [anon_sym_defined_QMARK] = ACTIONS(11089),
    [anon_sym_not] = ACTIONS(11091),
    [anon_sym_BANG] = ACTIONS(11093),
    [anon_sym_TILDE] = ACTIONS(11093),
    [sym_constant] = ACTIONS(11095),
    [sym_identifier] = ACTIONS(11095),
    [sym_instance_variable] = ACTIONS(11097),
    [sym_class_variable] = ACTIONS(11097),
    [sym_global_variable] = ACTIONS(11097),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11095),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11095),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [9338] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10361),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7550),
    [sym_scope_resolution] = STATE(7548),
    [sym_call] = STATE(7548),
    [sym_method_call] = STATE(7550),
    [sym_assignment] = STATE(10361),
    [sym_operator_assignment] = STATE(10361),
    [sym_conditional] = STATE(10361),
    [sym_range] = STATE(10361),
    [sym_binary] = STATE(10361),
    [sym_unary] = STATE(10361),
    [sym_left_assignment_list] = STATE(7549),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7550),
    [sym__variable] = STATE(7548),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7550),
    [sym_false] = STATE(7550),
    [sym_nil] = STATE(7550),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7551),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11077),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11079),
    [anon_sym_yield] = ACTIONS(11081),
    [anon_sym_break] = ACTIONS(11083),
    [anon_sym_next] = ACTIONS(11085),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11087),
    [anon_sym_defined_QMARK] = ACTIONS(11089),
    [anon_sym_not] = ACTIONS(11091),
    [anon_sym_BANG] = ACTIONS(11093),
    [anon_sym_TILDE] = ACTIONS(11093),
    [sym_constant] = ACTIONS(11095),
    [sym_identifier] = ACTIONS(11095),
    [sym_instance_variable] = ACTIONS(11097),
    [sym_class_variable] = ACTIONS(11097),
    [sym_global_variable] = ACTIONS(11097),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11095),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11095),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [9339] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(10362),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(10362),
    [sym_operator_assignment] = STATE(10362),
    [sym_conditional] = STATE(10362),
    [sym_range] = STATE(10362),
    [sym_binary] = STATE(10362),
    [sym_unary] = STATE(10362),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9340] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10363),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7550),
    [sym_scope_resolution] = STATE(7548),
    [sym_call] = STATE(7548),
    [sym_method_call] = STATE(7550),
    [sym_assignment] = STATE(10363),
    [sym_operator_assignment] = STATE(10363),
    [sym_conditional] = STATE(10363),
    [sym_range] = STATE(10363),
    [sym_binary] = STATE(10363),
    [sym_unary] = STATE(10363),
    [sym_left_assignment_list] = STATE(7549),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7550),
    [sym__variable] = STATE(7548),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7550),
    [sym_false] = STATE(7550),
    [sym_nil] = STATE(7550),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7551),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11077),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11079),
    [anon_sym_yield] = ACTIONS(11081),
    [anon_sym_break] = ACTIONS(11083),
    [anon_sym_next] = ACTIONS(11085),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11087),
    [anon_sym_defined_QMARK] = ACTIONS(11089),
    [anon_sym_not] = ACTIONS(11091),
    [anon_sym_BANG] = ACTIONS(11093),
    [anon_sym_TILDE] = ACTIONS(11093),
    [sym_constant] = ACTIONS(11095),
    [sym_identifier] = ACTIONS(11095),
    [sym_instance_variable] = ACTIONS(11097),
    [sym_class_variable] = ACTIONS(11097),
    [sym_global_variable] = ACTIONS(11097),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11095),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11095),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [9341] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10364),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7550),
    [sym_scope_resolution] = STATE(7548),
    [sym_call] = STATE(7548),
    [sym_method_call] = STATE(7550),
    [sym_assignment] = STATE(10364),
    [sym_operator_assignment] = STATE(10364),
    [sym_conditional] = STATE(10364),
    [sym_range] = STATE(10364),
    [sym_binary] = STATE(10364),
    [sym_unary] = STATE(10364),
    [sym_left_assignment_list] = STATE(7549),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7550),
    [sym__variable] = STATE(7548),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7550),
    [sym_false] = STATE(7550),
    [sym_nil] = STATE(7550),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7551),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11077),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11079),
    [anon_sym_yield] = ACTIONS(11081),
    [anon_sym_break] = ACTIONS(11083),
    [anon_sym_next] = ACTIONS(11085),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11087),
    [anon_sym_defined_QMARK] = ACTIONS(11089),
    [anon_sym_not] = ACTIONS(11091),
    [anon_sym_BANG] = ACTIONS(11093),
    [anon_sym_TILDE] = ACTIONS(11093),
    [sym_constant] = ACTIONS(11095),
    [sym_identifier] = ACTIONS(11095),
    [sym_instance_variable] = ACTIONS(11097),
    [sym_class_variable] = ACTIONS(11097),
    [sym_global_variable] = ACTIONS(11097),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11095),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11095),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [9342] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10365),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7550),
    [sym_scope_resolution] = STATE(7548),
    [sym_call] = STATE(7548),
    [sym_method_call] = STATE(7550),
    [sym_assignment] = STATE(10365),
    [sym_operator_assignment] = STATE(10365),
    [sym_conditional] = STATE(10365),
    [sym_range] = STATE(10365),
    [sym_binary] = STATE(10365),
    [sym_unary] = STATE(10365),
    [sym_left_assignment_list] = STATE(7549),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7550),
    [sym__variable] = STATE(7548),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7550),
    [sym_false] = STATE(7550),
    [sym_nil] = STATE(7550),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7551),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11077),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11079),
    [anon_sym_yield] = ACTIONS(11081),
    [anon_sym_break] = ACTIONS(11083),
    [anon_sym_next] = ACTIONS(11085),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11087),
    [anon_sym_defined_QMARK] = ACTIONS(11089),
    [anon_sym_not] = ACTIONS(11091),
    [anon_sym_BANG] = ACTIONS(11093),
    [anon_sym_TILDE] = ACTIONS(11093),
    [sym_constant] = ACTIONS(11095),
    [sym_identifier] = ACTIONS(11095),
    [sym_instance_variable] = ACTIONS(11097),
    [sym_class_variable] = ACTIONS(11097),
    [sym_global_variable] = ACTIONS(11097),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11095),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11095),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [9343] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10366),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7550),
    [sym_scope_resolution] = STATE(7548),
    [sym_call] = STATE(7548),
    [sym_method_call] = STATE(7550),
    [sym_assignment] = STATE(10366),
    [sym_operator_assignment] = STATE(10366),
    [sym_conditional] = STATE(10366),
    [sym_range] = STATE(10366),
    [sym_binary] = STATE(10366),
    [sym_unary] = STATE(10366),
    [sym_left_assignment_list] = STATE(7549),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7550),
    [sym__variable] = STATE(7548),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7550),
    [sym_false] = STATE(7550),
    [sym_nil] = STATE(7550),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7551),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11077),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11079),
    [anon_sym_yield] = ACTIONS(11081),
    [anon_sym_break] = ACTIONS(11083),
    [anon_sym_next] = ACTIONS(11085),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11087),
    [anon_sym_defined_QMARK] = ACTIONS(11089),
    [anon_sym_not] = ACTIONS(11091),
    [anon_sym_BANG] = ACTIONS(11093),
    [anon_sym_TILDE] = ACTIONS(11093),
    [sym_constant] = ACTIONS(11095),
    [sym_identifier] = ACTIONS(11095),
    [sym_instance_variable] = ACTIONS(11097),
    [sym_class_variable] = ACTIONS(11097),
    [sym_global_variable] = ACTIONS(11097),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11095),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11095),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [9344] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10367),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7550),
    [sym_scope_resolution] = STATE(7548),
    [sym_call] = STATE(7548),
    [sym_method_call] = STATE(7550),
    [sym_splat_argument] = STATE(10368),
    [sym_assignment] = STATE(10367),
    [sym_operator_assignment] = STATE(10367),
    [sym_conditional] = STATE(10367),
    [sym_range] = STATE(10367),
    [sym_binary] = STATE(10367),
    [sym_unary] = STATE(10367),
    [sym_right_assignment_list] = STATE(6323),
    [sym__arg_or_splat_arg] = STATE(10368),
    [sym_left_assignment_list] = STATE(7549),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7550),
    [sym__variable] = STATE(7548),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7550),
    [sym_false] = STATE(7550),
    [sym_nil] = STATE(7550),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7551),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__splat_star] = ACTIONS(8064),
    [sym__unary_minus] = ACTIONS(11077),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11079),
    [anon_sym_yield] = ACTIONS(11081),
    [anon_sym_break] = ACTIONS(11083),
    [anon_sym_next] = ACTIONS(11085),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11087),
    [anon_sym_defined_QMARK] = ACTIONS(11089),
    [anon_sym_not] = ACTIONS(11091),
    [anon_sym_BANG] = ACTIONS(11093),
    [anon_sym_TILDE] = ACTIONS(11093),
    [sym_constant] = ACTIONS(11095),
    [sym_identifier] = ACTIONS(11095),
    [sym_instance_variable] = ACTIONS(11097),
    [sym_class_variable] = ACTIONS(11097),
    [sym_global_variable] = ACTIONS(11097),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11095),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11095),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [9345] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10369),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7550),
    [sym_scope_resolution] = STATE(7548),
    [sym_call] = STATE(7548),
    [sym_method_call] = STATE(7550),
    [sym_assignment] = STATE(10369),
    [sym_operator_assignment] = STATE(10369),
    [sym_conditional] = STATE(10369),
    [sym_range] = STATE(10369),
    [sym_binary] = STATE(10369),
    [sym_unary] = STATE(10369),
    [sym_left_assignment_list] = STATE(7549),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7550),
    [sym__variable] = STATE(7548),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7550),
    [sym_false] = STATE(7550),
    [sym_nil] = STATE(7550),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7551),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11077),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11079),
    [anon_sym_yield] = ACTIONS(11081),
    [anon_sym_break] = ACTIONS(11083),
    [anon_sym_next] = ACTIONS(11085),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11087),
    [anon_sym_defined_QMARK] = ACTIONS(11089),
    [anon_sym_not] = ACTIONS(11091),
    [anon_sym_BANG] = ACTIONS(11093),
    [anon_sym_TILDE] = ACTIONS(11093),
    [sym_constant] = ACTIONS(11095),
    [sym_identifier] = ACTIONS(11095),
    [sym_instance_variable] = ACTIONS(11097),
    [sym_class_variable] = ACTIONS(11097),
    [sym_global_variable] = ACTIONS(11097),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11095),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11095),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [9346] = {
    [sym_string] = STATE(10370),
    [aux_sym_chained_string_repeat1] = STATE(10370),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(2551),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2755),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_EQ] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_end] = ACTIONS(2753),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_elsif] = ACTIONS(2753),
    [anon_sym_else] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_PLUS_EQ] = ACTIONS(2753),
    [anon_sym_DASH_EQ] = ACTIONS(2753),
    [anon_sym_STAR_EQ] = ACTIONS(2753),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2753),
    [anon_sym_SLASH_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2753),
    [anon_sym_AMP_EQ] = ACTIONS(2753),
    [anon_sym_PERCENT_EQ] = ACTIONS(2753),
    [anon_sym_GT_GT_EQ] = ACTIONS(2753),
    [anon_sym_LT_LT_EQ] = ACTIONS(2753),
    [anon_sym_CARET_EQ] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2755),
    [anon_sym_AMP_AMP] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2755),
    [anon_sym_GT_GT] = ACTIONS(2755),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_SLASH] = ACTIONS(2755),
    [anon_sym_PERCENT] = ACTIONS(2755),
    [sym_comment] = ACTIONS(87),
  },
  [9347] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(12950),
    [sym__binary_star] = ACTIONS(12952),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(12954),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(12956),
    [anon_sym_AMP] = ACTIONS(12958),
    [anon_sym_EQ] = ACTIONS(7822),
    [anon_sym_LT] = ACTIONS(12960),
    [anon_sym_end] = ACTIONS(6823),
    [anon_sym_if] = ACTIONS(6823),
    [anon_sym_unless] = ACTIONS(6823),
    [anon_sym_while] = ACTIONS(6823),
    [anon_sym_until] = ACTIONS(6823),
    [anon_sym_rescue] = ACTIONS(6823),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_elsif] = ACTIONS(6823),
    [anon_sym_else] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_PLUS_EQ] = ACTIONS(6823),
    [anon_sym_DASH_EQ] = ACTIONS(6823),
    [anon_sym_STAR_EQ] = ACTIONS(6823),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6823),
    [anon_sym_SLASH_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6823),
    [anon_sym_AMP_EQ] = ACTIONS(6823),
    [anon_sym_PERCENT_EQ] = ACTIONS(6823),
    [anon_sym_GT_GT_EQ] = ACTIONS(6823),
    [anon_sym_LT_LT_EQ] = ACTIONS(6823),
    [anon_sym_CARET_EQ] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(12962),
    [anon_sym_DOT_DOT] = ACTIONS(12964),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12966),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(12968),
    [anon_sym_AMP_AMP] = ACTIONS(12968),
    [anon_sym_LT_LT] = ACTIONS(12970),
    [anon_sym_GT_GT] = ACTIONS(12970),
    [anon_sym_EQ_EQ] = ACTIONS(12968),
    [anon_sym_BANG_EQ] = ACTIONS(12972),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12972),
    [anon_sym_LT_EQ_GT] = ACTIONS(12972),
    [anon_sym_EQ_TILDE] = ACTIONS(12972),
    [anon_sym_BANG_TILDE] = ACTIONS(12972),
    [anon_sym_LT_EQ] = ACTIONS(12960),
    [anon_sym_GT] = ACTIONS(12960),
    [anon_sym_GT_EQ] = ACTIONS(12974),
    [anon_sym_CARET] = ACTIONS(12954),
    [anon_sym_PLUS] = ACTIONS(12976),
    [anon_sym_SLASH] = ACTIONS(12956),
    [anon_sym_PERCENT] = ACTIONS(12956),
    [sym_comment] = ACTIONS(87),
  },
  [9348] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(12950),
    [sym__binary_star] = ACTIONS(12952),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(12954),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(12956),
    [anon_sym_AMP] = ACTIONS(12958),
    [anon_sym_EQ] = ACTIONS(7884),
    [anon_sym_LT] = ACTIONS(12960),
    [anon_sym_end] = ACTIONS(7027),
    [anon_sym_if] = ACTIONS(7027),
    [anon_sym_unless] = ACTIONS(7027),
    [anon_sym_while] = ACTIONS(7027),
    [anon_sym_until] = ACTIONS(7027),
    [anon_sym_rescue] = ACTIONS(7027),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_elsif] = ACTIONS(7027),
    [anon_sym_else] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_PLUS_EQ] = ACTIONS(7027),
    [anon_sym_DASH_EQ] = ACTIONS(7027),
    [anon_sym_STAR_EQ] = ACTIONS(7027),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7027),
    [anon_sym_SLASH_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7027),
    [anon_sym_AMP_EQ] = ACTIONS(7027),
    [anon_sym_PERCENT_EQ] = ACTIONS(7027),
    [anon_sym_GT_GT_EQ] = ACTIONS(7027),
    [anon_sym_LT_LT_EQ] = ACTIONS(7027),
    [anon_sym_CARET_EQ] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(12962),
    [anon_sym_DOT_DOT] = ACTIONS(12964),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12966),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(12968),
    [anon_sym_AMP_AMP] = ACTIONS(12968),
    [anon_sym_LT_LT] = ACTIONS(12970),
    [anon_sym_GT_GT] = ACTIONS(12970),
    [anon_sym_EQ_EQ] = ACTIONS(12968),
    [anon_sym_BANG_EQ] = ACTIONS(12972),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12972),
    [anon_sym_LT_EQ_GT] = ACTIONS(12972),
    [anon_sym_EQ_TILDE] = ACTIONS(12972),
    [anon_sym_BANG_TILDE] = ACTIONS(12972),
    [anon_sym_LT_EQ] = ACTIONS(12960),
    [anon_sym_GT] = ACTIONS(12960),
    [anon_sym_GT_EQ] = ACTIONS(12974),
    [anon_sym_CARET] = ACTIONS(12954),
    [anon_sym_PLUS] = ACTIONS(12976),
    [anon_sym_SLASH] = ACTIONS(12956),
    [anon_sym_PERCENT] = ACTIONS(12956),
    [sym_comment] = ACTIONS(87),
  },
  [9349] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(11107),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11111),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_elsif] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(11111),
    [anon_sym_PERCENT] = ACTIONS(11111),
    [sym_comment] = ACTIONS(87),
  },
  [9350] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11111),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_elsif] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(5827),
    [anon_sym_PERCENT] = ACTIONS(5827),
    [sym_comment] = ACTIONS(87),
  },
  [9351] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11105),
    [sym__binary_star] = ACTIONS(11107),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11111),
    [anon_sym_AMP] = ACTIONS(11113),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_elsif] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(11125),
    [anon_sym_GT_GT] = ACTIONS(11125),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(11131),
    [anon_sym_SLASH] = ACTIONS(11111),
    [anon_sym_PERCENT] = ACTIONS(11111),
    [sym_comment] = ACTIONS(87),
  },
  [9352] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11105),
    [sym__binary_star] = ACTIONS(11107),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11111),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_elsif] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(11125),
    [anon_sym_GT_GT] = ACTIONS(11125),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(11131),
    [anon_sym_SLASH] = ACTIONS(11111),
    [anon_sym_PERCENT] = ACTIONS(11111),
    [sym_comment] = ACTIONS(87),
  },
  [9353] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11105),
    [sym__binary_star] = ACTIONS(11107),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(11109),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11111),
    [anon_sym_AMP] = ACTIONS(11113),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_elsif] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(11125),
    [anon_sym_GT_GT] = ACTIONS(11125),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(11109),
    [anon_sym_PLUS] = ACTIONS(11131),
    [anon_sym_SLASH] = ACTIONS(11111),
    [anon_sym_PERCENT] = ACTIONS(11111),
    [sym_comment] = ACTIONS(87),
  },
  [9354] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(14097),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [9355] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(11105),
    [sym__binary_star] = ACTIONS(11107),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(11109),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(11111),
    [anon_sym_AMP] = ACTIONS(11113),
    [anon_sym_EQ] = ACTIONS(7888),
    [anon_sym_LT] = ACTIONS(11115),
    [anon_sym_end] = ACTIONS(5927),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_elsif] = ACTIONS(5927),
    [anon_sym_else] = ACTIONS(5927),
    [anon_sym_EQ_GT] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_PLUS_EQ] = ACTIONS(5927),
    [anon_sym_DASH_EQ] = ACTIONS(5927),
    [anon_sym_STAR_EQ] = ACTIONS(5927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5927),
    [anon_sym_SLASH_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5927),
    [anon_sym_AMP_EQ] = ACTIONS(5927),
    [anon_sym_PERCENT_EQ] = ACTIONS(5927),
    [anon_sym_GT_GT_EQ] = ACTIONS(5927),
    [anon_sym_LT_LT_EQ] = ACTIONS(5927),
    [anon_sym_CARET_EQ] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(11119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11121),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(11123),
    [anon_sym_AMP_AMP] = ACTIONS(11123),
    [anon_sym_LT_LT] = ACTIONS(11125),
    [anon_sym_GT_GT] = ACTIONS(11125),
    [anon_sym_EQ_EQ] = ACTIONS(11123),
    [anon_sym_BANG_EQ] = ACTIONS(11127),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11127),
    [anon_sym_LT_EQ_GT] = ACTIONS(11127),
    [anon_sym_EQ_TILDE] = ACTIONS(11127),
    [anon_sym_BANG_TILDE] = ACTIONS(11127),
    [anon_sym_LT_EQ] = ACTIONS(11115),
    [anon_sym_GT] = ACTIONS(11115),
    [anon_sym_GT_EQ] = ACTIONS(11129),
    [anon_sym_CARET] = ACTIONS(11109),
    [anon_sym_PLUS] = ACTIONS(11131),
    [anon_sym_SLASH] = ACTIONS(11111),
    [anon_sym_PERCENT] = ACTIONS(11111),
    [sym_comment] = ACTIONS(87),
  },
  [9356] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11105),
    [sym__binary_star] = ACTIONS(11107),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(11109),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11111),
    [anon_sym_AMP] = ACTIONS(11113),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(11115),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_elsif] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(11117),
    [anon_sym_DOT_DOT] = ACTIONS(11119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11121),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(11123),
    [anon_sym_AMP_AMP] = ACTIONS(11123),
    [anon_sym_LT_LT] = ACTIONS(11125),
    [anon_sym_GT_GT] = ACTIONS(11125),
    [anon_sym_EQ_EQ] = ACTIONS(11123),
    [anon_sym_BANG_EQ] = ACTIONS(11127),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11127),
    [anon_sym_LT_EQ_GT] = ACTIONS(11127),
    [anon_sym_EQ_TILDE] = ACTIONS(11127),
    [anon_sym_BANG_TILDE] = ACTIONS(11127),
    [anon_sym_LT_EQ] = ACTIONS(11115),
    [anon_sym_GT] = ACTIONS(11115),
    [anon_sym_GT_EQ] = ACTIONS(11129),
    [anon_sym_CARET] = ACTIONS(11109),
    [anon_sym_PLUS] = ACTIONS(11131),
    [anon_sym_SLASH] = ACTIONS(11111),
    [anon_sym_PERCENT] = ACTIONS(11111),
    [sym_comment] = ACTIONS(87),
  },
  [9357] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11105),
    [sym__binary_star] = ACTIONS(11107),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(11109),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11111),
    [anon_sym_AMP] = ACTIONS(11113),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(11115),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_elsif] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(11125),
    [anon_sym_GT_GT] = ACTIONS(11125),
    [anon_sym_EQ_EQ] = ACTIONS(11123),
    [anon_sym_BANG_EQ] = ACTIONS(11127),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11127),
    [anon_sym_LT_EQ_GT] = ACTIONS(11127),
    [anon_sym_EQ_TILDE] = ACTIONS(11127),
    [anon_sym_BANG_TILDE] = ACTIONS(11127),
    [anon_sym_LT_EQ] = ACTIONS(11115),
    [anon_sym_GT] = ACTIONS(11115),
    [anon_sym_GT_EQ] = ACTIONS(11129),
    [anon_sym_CARET] = ACTIONS(11109),
    [anon_sym_PLUS] = ACTIONS(11131),
    [anon_sym_SLASH] = ACTIONS(11111),
    [anon_sym_PERCENT] = ACTIONS(11111),
    [sym_comment] = ACTIONS(87),
  },
  [9358] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11105),
    [sym__binary_star] = ACTIONS(11107),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11111),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_elsif] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(11131),
    [anon_sym_SLASH] = ACTIONS(11111),
    [anon_sym_PERCENT] = ACTIONS(11111),
    [sym_comment] = ACTIONS(87),
  },
  [9359] = {
    [sym_heredoc_body] = STATE(9359),
    [aux_sym_call_repeat1] = STATE(9359),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(9846),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7919),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_EQ] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_end] = ACTIONS(7914),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_elsif] = ACTIONS(7914),
    [anon_sym_else] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_PLUS_EQ] = ACTIONS(7914),
    [anon_sym_DASH_EQ] = ACTIONS(7914),
    [anon_sym_STAR_EQ] = ACTIONS(7914),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7914),
    [anon_sym_SLASH_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7914),
    [anon_sym_AMP_EQ] = ACTIONS(7914),
    [anon_sym_PERCENT_EQ] = ACTIONS(7914),
    [anon_sym_GT_GT_EQ] = ACTIONS(7914),
    [anon_sym_LT_LT_EQ] = ACTIONS(7914),
    [anon_sym_CARET_EQ] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7919),
    [anon_sym_AMP_AMP] = ACTIONS(7919),
    [anon_sym_LT_LT] = ACTIONS(7919),
    [anon_sym_GT_GT] = ACTIONS(7919),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7919),
    [anon_sym_PLUS] = ACTIONS(7919),
    [anon_sym_SLASH] = ACTIONS(7919),
    [anon_sym_PERCENT] = ACTIONS(7919),
    [sym_comment] = ACTIONS(87),
  },
  [9360] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5092),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5097),
    [sym_scope_resolution] = STATE(5093),
    [sym_call] = STATE(5093),
    [sym_method_call] = STATE(5097),
    [sym__argument] = STATE(6393),
    [sym_splat_argument] = STATE(6393),
    [sym_hash_splat_argument] = STATE(6393),
    [sym_block_argument] = STATE(6393),
    [sym_assignment] = STATE(5092),
    [sym_operator_assignment] = STATE(5092),
    [sym_conditional] = STATE(5092),
    [sym_range] = STATE(5092),
    [sym_binary] = STATE(5092),
    [sym_unary] = STATE(5092),
    [sym_left_assignment_list] = STATE(5096),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5097),
    [sym__variable] = STATE(5093),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5097),
    [sym_false] = STATE(5097),
    [sym_nil] = STATE(5097),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5098),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(6393),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(8062),
    [sym__splat_star] = ACTIONS(8064),
    [sym__unary_minus] = ACTIONS(8066),
    [sym__identifier_hash_key] = ACTIONS(8068),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12984),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(8070),
    [anon_sym_yield] = ACTIONS(8072),
    [anon_sym_break] = ACTIONS(8074),
    [anon_sym_next] = ACTIONS(8076),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(11099),
    [anon_sym_defined_QMARK] = ACTIONS(8078),
    [anon_sym_not] = ACTIONS(8080),
    [anon_sym_BANG] = ACTIONS(8084),
    [anon_sym_TILDE] = ACTIONS(8084),
    [sym_constant] = ACTIONS(8086),
    [sym_identifier] = ACTIONS(8086),
    [sym_instance_variable] = ACTIONS(8088),
    [sym_class_variable] = ACTIONS(8088),
    [sym_global_variable] = ACTIONS(8088),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8090),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8090),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [9361] = {
    [sym_heredoc_body] = STATE(9359),
    [aux_sym_call_repeat1] = STATE(9359),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7931),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_EQ] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_end] = ACTIONS(7929),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_elsif] = ACTIONS(7929),
    [anon_sym_else] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_PLUS_EQ] = ACTIONS(7929),
    [anon_sym_DASH_EQ] = ACTIONS(7929),
    [anon_sym_STAR_EQ] = ACTIONS(7929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7929),
    [anon_sym_SLASH_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7929),
    [anon_sym_AMP_EQ] = ACTIONS(7929),
    [anon_sym_PERCENT_EQ] = ACTIONS(7929),
    [anon_sym_GT_GT_EQ] = ACTIONS(7929),
    [anon_sym_LT_LT_EQ] = ACTIONS(7929),
    [anon_sym_CARET_EQ] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7931),
    [anon_sym_AMP_AMP] = ACTIONS(7931),
    [anon_sym_LT_LT] = ACTIONS(7931),
    [anon_sym_GT_GT] = ACTIONS(7931),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7931),
    [anon_sym_PLUS] = ACTIONS(7931),
    [anon_sym_SLASH] = ACTIONS(7931),
    [anon_sym_PERCENT] = ACTIONS(7931),
    [sym_comment] = ACTIONS(87),
  },
  [9362] = {
    [aux_sym_argument_list_repeat1] = STATE(9362),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(14099),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7927),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_EQ] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_end] = ACTIONS(7925),
    [anon_sym_if] = ACTIONS(7925),
    [anon_sym_unless] = ACTIONS(7925),
    [anon_sym_while] = ACTIONS(7925),
    [anon_sym_until] = ACTIONS(7925),
    [anon_sym_rescue] = ACTIONS(7925),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_elsif] = ACTIONS(7925),
    [anon_sym_else] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_PLUS_EQ] = ACTIONS(7925),
    [anon_sym_DASH_EQ] = ACTIONS(7925),
    [anon_sym_STAR_EQ] = ACTIONS(7925),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7925),
    [anon_sym_SLASH_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7925),
    [anon_sym_AMP_EQ] = ACTIONS(7925),
    [anon_sym_PERCENT_EQ] = ACTIONS(7925),
    [anon_sym_GT_GT_EQ] = ACTIONS(7925),
    [anon_sym_LT_LT_EQ] = ACTIONS(7925),
    [anon_sym_CARET_EQ] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7927),
    [anon_sym_AMP_AMP] = ACTIONS(7927),
    [anon_sym_LT_LT] = ACTIONS(7927),
    [anon_sym_GT_GT] = ACTIONS(7927),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7927),
    [anon_sym_PLUS] = ACTIONS(7927),
    [anon_sym_SLASH] = ACTIONS(7927),
    [anon_sym_PERCENT] = ACTIONS(7927),
    [sym_comment] = ACTIONS(87),
  },
  [9363] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(11105),
    [sym__binary_star] = ACTIONS(11107),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(11109),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(11111),
    [anon_sym_AMP] = ACTIONS(11113),
    [anon_sym_EQ] = ACTIONS(7936),
    [anon_sym_LT] = ACTIONS(11115),
    [anon_sym_end] = ACTIONS(5115),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_elsif] = ACTIONS(5115),
    [anon_sym_else] = ACTIONS(5115),
    [anon_sym_EQ_GT] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_PLUS_EQ] = ACTIONS(5115),
    [anon_sym_DASH_EQ] = ACTIONS(5115),
    [anon_sym_STAR_EQ] = ACTIONS(5115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5115),
    [anon_sym_SLASH_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5115),
    [anon_sym_AMP_EQ] = ACTIONS(5115),
    [anon_sym_PERCENT_EQ] = ACTIONS(5115),
    [anon_sym_GT_GT_EQ] = ACTIONS(5115),
    [anon_sym_LT_LT_EQ] = ACTIONS(5115),
    [anon_sym_CARET_EQ] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(11117),
    [anon_sym_DOT_DOT] = ACTIONS(11119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11121),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(11123),
    [anon_sym_AMP_AMP] = ACTIONS(11123),
    [anon_sym_LT_LT] = ACTIONS(11125),
    [anon_sym_GT_GT] = ACTIONS(11125),
    [anon_sym_EQ_EQ] = ACTIONS(11123),
    [anon_sym_BANG_EQ] = ACTIONS(11127),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11127),
    [anon_sym_LT_EQ_GT] = ACTIONS(11127),
    [anon_sym_EQ_TILDE] = ACTIONS(11127),
    [anon_sym_BANG_TILDE] = ACTIONS(11127),
    [anon_sym_LT_EQ] = ACTIONS(11115),
    [anon_sym_GT] = ACTIONS(11115),
    [anon_sym_GT_EQ] = ACTIONS(11129),
    [anon_sym_CARET] = ACTIONS(11109),
    [anon_sym_PLUS] = ACTIONS(11131),
    [anon_sym_SLASH] = ACTIONS(11111),
    [anon_sym_PERCENT] = ACTIONS(11111),
    [sym_comment] = ACTIONS(87),
  },
  [9364] = {
    [aux_sym_exceptions_repeat1] = STATE(10373),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6193),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_end] = ACTIONS(6191),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_elsif] = ACTIONS(6191),
    [anon_sym_else] = ACTIONS(6191),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_PLUS_EQ] = ACTIONS(6191),
    [anon_sym_DASH_EQ] = ACTIONS(6191),
    [anon_sym_STAR_EQ] = ACTIONS(6191),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6191),
    [anon_sym_SLASH_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6191),
    [anon_sym_AMP_EQ] = ACTIONS(6191),
    [anon_sym_PERCENT_EQ] = ACTIONS(6191),
    [anon_sym_GT_GT_EQ] = ACTIONS(6191),
    [anon_sym_LT_LT_EQ] = ACTIONS(6191),
    [anon_sym_CARET_EQ] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6193),
    [anon_sym_AMP_AMP] = ACTIONS(6193),
    [anon_sym_LT_LT] = ACTIONS(6193),
    [anon_sym_GT_GT] = ACTIONS(6193),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6193),
    [anon_sym_PLUS] = ACTIONS(6193),
    [anon_sym_SLASH] = ACTIONS(6193),
    [anon_sym_PERCENT] = ACTIONS(6193),
    [sym_comment] = ACTIONS(87),
  },
  [9365] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(11105),
    [sym__binary_star] = ACTIONS(11107),
    [anon_sym_LBRACE] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(11109),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(11111),
    [anon_sym_AMP] = ACTIONS(11113),
    [anon_sym_EQ] = ACTIONS(7938),
    [anon_sym_LT] = ACTIONS(11115),
    [anon_sym_end] = ACTIONS(6210),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_elsif] = ACTIONS(6210),
    [anon_sym_else] = ACTIONS(6210),
    [anon_sym_EQ_GT] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_PLUS_EQ] = ACTIONS(6210),
    [anon_sym_DASH_EQ] = ACTIONS(6210),
    [anon_sym_STAR_EQ] = ACTIONS(6210),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6210),
    [anon_sym_SLASH_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6210),
    [anon_sym_AMP_EQ] = ACTIONS(6210),
    [anon_sym_PERCENT_EQ] = ACTIONS(6210),
    [anon_sym_GT_GT_EQ] = ACTIONS(6210),
    [anon_sym_LT_LT_EQ] = ACTIONS(6210),
    [anon_sym_CARET_EQ] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(11117),
    [anon_sym_DOT_DOT] = ACTIONS(11119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11121),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(11123),
    [anon_sym_AMP_AMP] = ACTIONS(11123),
    [anon_sym_LT_LT] = ACTIONS(11125),
    [anon_sym_GT_GT] = ACTIONS(11125),
    [anon_sym_EQ_EQ] = ACTIONS(11123),
    [anon_sym_BANG_EQ] = ACTIONS(11127),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11127),
    [anon_sym_LT_EQ_GT] = ACTIONS(11127),
    [anon_sym_EQ_TILDE] = ACTIONS(11127),
    [anon_sym_BANG_TILDE] = ACTIONS(11127),
    [anon_sym_LT_EQ] = ACTIONS(11115),
    [anon_sym_GT] = ACTIONS(11115),
    [anon_sym_GT_EQ] = ACTIONS(11129),
    [anon_sym_CARET] = ACTIONS(11109),
    [anon_sym_PLUS] = ACTIONS(11131),
    [anon_sym_SLASH] = ACTIONS(11111),
    [anon_sym_PERCENT] = ACTIONS(11111),
    [sym_comment] = ACTIONS(87),
  },
  [9366] = {
    [sym_string] = STATE(9366),
    [aux_sym_chained_string_repeat1] = STATE(9366),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(9852),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6217),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_EQ] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_end] = ACTIONS(6212),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_do] = ACTIONS(6212),
    [anon_sym_elsif] = ACTIONS(6212),
    [anon_sym_else] = ACTIONS(6212),
    [anon_sym_EQ_GT] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_PLUS_EQ] = ACTIONS(6212),
    [anon_sym_DASH_EQ] = ACTIONS(6212),
    [anon_sym_STAR_EQ] = ACTIONS(6212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6212),
    [anon_sym_SLASH_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6212),
    [anon_sym_AMP_EQ] = ACTIONS(6212),
    [anon_sym_PERCENT_EQ] = ACTIONS(6212),
    [anon_sym_GT_GT_EQ] = ACTIONS(6212),
    [anon_sym_LT_LT_EQ] = ACTIONS(6212),
    [anon_sym_CARET_EQ] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6217),
    [anon_sym_AMP_AMP] = ACTIONS(6217),
    [anon_sym_LT_LT] = ACTIONS(6217),
    [anon_sym_GT_GT] = ACTIONS(6217),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6217),
    [anon_sym_PLUS] = ACTIONS(6217),
    [anon_sym_SLASH] = ACTIONS(6217),
    [anon_sym_PERCENT] = ACTIONS(6217),
    [sym_comment] = ACTIONS(87),
  },
  [9367] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(12986),
    [sym__binary_star] = ACTIONS(12988),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(12990),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(12988),
    [anon_sym_AMP] = ACTIONS(12992),
    [anon_sym_LT] = ACTIONS(12994),
    [anon_sym_end] = ACTIONS(4247),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_elsif] = ACTIONS(4247),
    [anon_sym_else] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(12996),
    [anon_sym_DOT_DOT] = ACTIONS(12998),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13000),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(13002),
    [anon_sym_AMP_AMP] = ACTIONS(13002),
    [anon_sym_LT_LT] = ACTIONS(13004),
    [anon_sym_GT_GT] = ACTIONS(13004),
    [anon_sym_EQ_EQ] = ACTIONS(13006),
    [anon_sym_BANG_EQ] = ACTIONS(13002),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13002),
    [anon_sym_LT_EQ_GT] = ACTIONS(13002),
    [anon_sym_EQ_TILDE] = ACTIONS(13002),
    [anon_sym_BANG_TILDE] = ACTIONS(13002),
    [anon_sym_LT_EQ] = ACTIONS(12994),
    [anon_sym_GT] = ACTIONS(12994),
    [anon_sym_GT_EQ] = ACTIONS(13008),
    [anon_sym_CARET] = ACTIONS(13010),
    [anon_sym_PLUS] = ACTIONS(12986),
    [anon_sym_SLASH] = ACTIONS(12988),
    [anon_sym_PERCENT] = ACTIONS(12988),
    [sym_comment] = ACTIONS(87),
  },
  [9368] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(12988),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_elsif] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [9369] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(12986),
    [sym__binary_star] = ACTIONS(12988),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(12990),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(12988),
    [anon_sym_AMP] = ACTIONS(12992),
    [anon_sym_LT] = ACTIONS(12994),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_elsif] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(12996),
    [anon_sym_DOT_DOT] = ACTIONS(12998),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13000),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(13002),
    [anon_sym_AMP_AMP] = ACTIONS(13002),
    [anon_sym_LT_LT] = ACTIONS(13004),
    [anon_sym_GT_GT] = ACTIONS(13004),
    [anon_sym_EQ_EQ] = ACTIONS(13006),
    [anon_sym_BANG_EQ] = ACTIONS(13002),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13002),
    [anon_sym_LT_EQ_GT] = ACTIONS(13002),
    [anon_sym_EQ_TILDE] = ACTIONS(13002),
    [anon_sym_BANG_TILDE] = ACTIONS(13002),
    [anon_sym_LT_EQ] = ACTIONS(12994),
    [anon_sym_GT] = ACTIONS(12994),
    [anon_sym_GT_EQ] = ACTIONS(13008),
    [anon_sym_CARET] = ACTIONS(13010),
    [anon_sym_PLUS] = ACTIONS(12986),
    [anon_sym_SLASH] = ACTIONS(12988),
    [anon_sym_PERCENT] = ACTIONS(12988),
    [sym_comment] = ACTIONS(87),
  },
  [9370] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10374),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7582),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(7582),
    [sym_assignment] = STATE(10374),
    [sym_operator_assignment] = STATE(10374),
    [sym_conditional] = STATE(10374),
    [sym_range] = STATE(10374),
    [sym_binary] = STATE(10374),
    [sym_unary] = STATE(10374),
    [sym_left_assignment_list] = STATE(7581),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7582),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7582),
    [sym_false] = STATE(7582),
    [sym_nil] = STATE(7582),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7482),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11145),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11003),
    [anon_sym_yield] = ACTIONS(11005),
    [anon_sym_break] = ACTIONS(11007),
    [anon_sym_next] = ACTIONS(11009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11147),
    [anon_sym_defined_QMARK] = ACTIONS(11149),
    [anon_sym_not] = ACTIONS(11151),
    [anon_sym_BANG] = ACTIONS(11153),
    [anon_sym_TILDE] = ACTIONS(11153),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9371] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10375),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7582),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(7582),
    [sym_assignment] = STATE(10375),
    [sym_operator_assignment] = STATE(10375),
    [sym_conditional] = STATE(10375),
    [sym_range] = STATE(10375),
    [sym_binary] = STATE(10375),
    [sym_unary] = STATE(10375),
    [sym_left_assignment_list] = STATE(7581),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7582),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7582),
    [sym_false] = STATE(7582),
    [sym_nil] = STATE(7582),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7482),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11145),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11003),
    [anon_sym_yield] = ACTIONS(11005),
    [anon_sym_break] = ACTIONS(11007),
    [anon_sym_next] = ACTIONS(11009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11147),
    [anon_sym_defined_QMARK] = ACTIONS(11149),
    [anon_sym_not] = ACTIONS(11151),
    [anon_sym_BANG] = ACTIONS(11153),
    [anon_sym_TILDE] = ACTIONS(11153),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9372] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10376),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7582),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(7582),
    [sym_assignment] = STATE(10376),
    [sym_operator_assignment] = STATE(10376),
    [sym_conditional] = STATE(10376),
    [sym_range] = STATE(10376),
    [sym_binary] = STATE(10376),
    [sym_unary] = STATE(10376),
    [sym_left_assignment_list] = STATE(7581),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7582),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7582),
    [sym_false] = STATE(7582),
    [sym_nil] = STATE(7582),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7482),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11145),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11003),
    [anon_sym_yield] = ACTIONS(11005),
    [anon_sym_break] = ACTIONS(11007),
    [anon_sym_next] = ACTIONS(11009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11147),
    [anon_sym_defined_QMARK] = ACTIONS(11149),
    [anon_sym_not] = ACTIONS(11151),
    [anon_sym_BANG] = ACTIONS(11153),
    [anon_sym_TILDE] = ACTIONS(11153),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9373] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10377),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7582),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(7582),
    [sym_assignment] = STATE(10377),
    [sym_operator_assignment] = STATE(10377),
    [sym_conditional] = STATE(10377),
    [sym_range] = STATE(10377),
    [sym_binary] = STATE(10377),
    [sym_unary] = STATE(10377),
    [sym_left_assignment_list] = STATE(7581),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7582),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7582),
    [sym_false] = STATE(7582),
    [sym_nil] = STATE(7582),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7482),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11145),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11003),
    [anon_sym_yield] = ACTIONS(11005),
    [anon_sym_break] = ACTIONS(11007),
    [anon_sym_next] = ACTIONS(11009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11147),
    [anon_sym_defined_QMARK] = ACTIONS(11149),
    [anon_sym_not] = ACTIONS(11151),
    [anon_sym_BANG] = ACTIONS(11153),
    [anon_sym_TILDE] = ACTIONS(11153),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9374] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10378),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7582),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(7582),
    [sym_assignment] = STATE(10378),
    [sym_operator_assignment] = STATE(10378),
    [sym_conditional] = STATE(10378),
    [sym_range] = STATE(10378),
    [sym_binary] = STATE(10378),
    [sym_unary] = STATE(10378),
    [sym_left_assignment_list] = STATE(7581),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7582),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7582),
    [sym_false] = STATE(7582),
    [sym_nil] = STATE(7582),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7482),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11145),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11003),
    [anon_sym_yield] = ACTIONS(11005),
    [anon_sym_break] = ACTIONS(11007),
    [anon_sym_next] = ACTIONS(11009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11147),
    [anon_sym_defined_QMARK] = ACTIONS(11149),
    [anon_sym_not] = ACTIONS(11151),
    [anon_sym_BANG] = ACTIONS(11153),
    [anon_sym_TILDE] = ACTIONS(11153),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9375] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(10379),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(10379),
    [sym_operator_assignment] = STATE(10379),
    [sym_conditional] = STATE(10379),
    [sym_range] = STATE(10379),
    [sym_binary] = STATE(10379),
    [sym_unary] = STATE(10379),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9376] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10380),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7582),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(7582),
    [sym_assignment] = STATE(10380),
    [sym_operator_assignment] = STATE(10380),
    [sym_conditional] = STATE(10380),
    [sym_range] = STATE(10380),
    [sym_binary] = STATE(10380),
    [sym_unary] = STATE(10380),
    [sym_left_assignment_list] = STATE(7581),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7582),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7582),
    [sym_false] = STATE(7582),
    [sym_nil] = STATE(7582),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7482),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11145),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11003),
    [anon_sym_yield] = ACTIONS(11005),
    [anon_sym_break] = ACTIONS(11007),
    [anon_sym_next] = ACTIONS(11009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11147),
    [anon_sym_defined_QMARK] = ACTIONS(11149),
    [anon_sym_not] = ACTIONS(11151),
    [anon_sym_BANG] = ACTIONS(11153),
    [anon_sym_TILDE] = ACTIONS(11153),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9377] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10381),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7582),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(7582),
    [sym_assignment] = STATE(10381),
    [sym_operator_assignment] = STATE(10381),
    [sym_conditional] = STATE(10381),
    [sym_range] = STATE(10381),
    [sym_binary] = STATE(10381),
    [sym_unary] = STATE(10381),
    [sym_left_assignment_list] = STATE(7581),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7582),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7582),
    [sym_false] = STATE(7582),
    [sym_nil] = STATE(7582),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7482),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11145),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11003),
    [anon_sym_yield] = ACTIONS(11005),
    [anon_sym_break] = ACTIONS(11007),
    [anon_sym_next] = ACTIONS(11009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11147),
    [anon_sym_defined_QMARK] = ACTIONS(11149),
    [anon_sym_not] = ACTIONS(11151),
    [anon_sym_BANG] = ACTIONS(11153),
    [anon_sym_TILDE] = ACTIONS(11153),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9378] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10382),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7582),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(7582),
    [sym_assignment] = STATE(10382),
    [sym_operator_assignment] = STATE(10382),
    [sym_conditional] = STATE(10382),
    [sym_range] = STATE(10382),
    [sym_binary] = STATE(10382),
    [sym_unary] = STATE(10382),
    [sym_left_assignment_list] = STATE(7581),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7582),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7582),
    [sym_false] = STATE(7582),
    [sym_nil] = STATE(7582),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7482),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11145),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11003),
    [anon_sym_yield] = ACTIONS(11005),
    [anon_sym_break] = ACTIONS(11007),
    [anon_sym_next] = ACTIONS(11009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11147),
    [anon_sym_defined_QMARK] = ACTIONS(11149),
    [anon_sym_not] = ACTIONS(11151),
    [anon_sym_BANG] = ACTIONS(11153),
    [anon_sym_TILDE] = ACTIONS(11153),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9379] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10383),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7582),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(7582),
    [sym_assignment] = STATE(10383),
    [sym_operator_assignment] = STATE(10383),
    [sym_conditional] = STATE(10383),
    [sym_range] = STATE(10383),
    [sym_binary] = STATE(10383),
    [sym_unary] = STATE(10383),
    [sym_left_assignment_list] = STATE(7581),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7582),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7582),
    [sym_false] = STATE(7582),
    [sym_nil] = STATE(7582),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7482),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11145),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11003),
    [anon_sym_yield] = ACTIONS(11005),
    [anon_sym_break] = ACTIONS(11007),
    [anon_sym_next] = ACTIONS(11009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11147),
    [anon_sym_defined_QMARK] = ACTIONS(11149),
    [anon_sym_not] = ACTIONS(11151),
    [anon_sym_BANG] = ACTIONS(11153),
    [anon_sym_TILDE] = ACTIONS(11153),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9380] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7579),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7582),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(7582),
    [sym_splat_argument] = STATE(6406),
    [sym_assignment] = STATE(7579),
    [sym_operator_assignment] = STATE(7579),
    [sym_conditional] = STATE(7579),
    [sym_range] = STATE(7579),
    [sym_binary] = STATE(7579),
    [sym_unary] = STATE(7579),
    [sym__arg_or_splat_arg] = STATE(6406),
    [sym_left_assignment_list] = STATE(7581),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7582),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7582),
    [sym_false] = STATE(7582),
    [sym_nil] = STATE(7582),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7482),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(11143),
    [sym__unary_minus] = ACTIONS(11145),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11003),
    [anon_sym_yield] = ACTIONS(11005),
    [anon_sym_break] = ACTIONS(11007),
    [anon_sym_next] = ACTIONS(11009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11147),
    [anon_sym_defined_QMARK] = ACTIONS(11149),
    [anon_sym_not] = ACTIONS(11151),
    [anon_sym_BANG] = ACTIONS(11153),
    [anon_sym_TILDE] = ACTIONS(11153),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9381] = {
    [aux_sym_exceptions_repeat1] = STATE(10384),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_COMMA] = ACTIONS(13012),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_end] = ACTIONS(9855),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_elsif] = ACTIONS(9855),
    [anon_sym_else] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [9382] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7579),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7582),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(7582),
    [sym_splat_argument] = STATE(10385),
    [sym_assignment] = STATE(7579),
    [sym_operator_assignment] = STATE(7579),
    [sym_conditional] = STATE(7579),
    [sym_range] = STATE(7579),
    [sym_binary] = STATE(7579),
    [sym_unary] = STATE(7579),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(10385),
    [sym_left_assignment_list] = STATE(7581),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7582),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7582),
    [sym_false] = STATE(7582),
    [sym_nil] = STATE(7582),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7482),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(11143),
    [sym__unary_minus] = ACTIONS(11145),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11003),
    [anon_sym_yield] = ACTIONS(11005),
    [anon_sym_break] = ACTIONS(11007),
    [anon_sym_next] = ACTIONS(11009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11147),
    [anon_sym_defined_QMARK] = ACTIONS(11149),
    [anon_sym_not] = ACTIONS(11151),
    [anon_sym_BANG] = ACTIONS(11153),
    [anon_sym_TILDE] = ACTIONS(11153),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9383] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10386),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7582),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(7582),
    [sym_assignment] = STATE(10386),
    [sym_operator_assignment] = STATE(10386),
    [sym_conditional] = STATE(10386),
    [sym_range] = STATE(10386),
    [sym_binary] = STATE(10386),
    [sym_unary] = STATE(10386),
    [sym_left_assignment_list] = STATE(7581),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7582),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7582),
    [sym_false] = STATE(7582),
    [sym_nil] = STATE(7582),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7482),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11145),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11003),
    [anon_sym_yield] = ACTIONS(11005),
    [anon_sym_break] = ACTIONS(11007),
    [anon_sym_next] = ACTIONS(11009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11147),
    [anon_sym_defined_QMARK] = ACTIONS(11149),
    [anon_sym_not] = ACTIONS(11151),
    [anon_sym_BANG] = ACTIONS(11153),
    [anon_sym_TILDE] = ACTIONS(11153),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9384] = {
    [anon_sym_end] = ACTIONS(14102),
    [sym_comment] = ACTIONS(87),
  },
  [9385] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10387),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2672),
    [sym_scope_resolution] = STATE(2670),
    [sym_call] = STATE(2670),
    [sym_method_call] = STATE(2672),
    [sym_assignment] = STATE(10387),
    [sym_operator_assignment] = STATE(10387),
    [sym_conditional] = STATE(10387),
    [sym_range] = STATE(10387),
    [sym_binary] = STATE(10387),
    [sym_unary] = STATE(10387),
    [sym_left_assignment_list] = STATE(2671),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2672),
    [sym__variable] = STATE(2670),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2672),
    [sym_false] = STATE(2672),
    [sym_nil] = STATE(2672),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2673),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(4505),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(4507),
    [anon_sym_yield] = ACTIONS(4509),
    [anon_sym_break] = ACTIONS(4511),
    [anon_sym_next] = ACTIONS(4513),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(4515),
    [anon_sym_defined_QMARK] = ACTIONS(4517),
    [anon_sym_not] = ACTIONS(4519),
    [anon_sym_BANG] = ACTIONS(4521),
    [anon_sym_TILDE] = ACTIONS(4521),
    [sym_constant] = ACTIONS(4523),
    [sym_identifier] = ACTIONS(4523),
    [sym_instance_variable] = ACTIONS(4525),
    [sym_class_variable] = ACTIONS(4525),
    [sym_global_variable] = ACTIONS(4525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(4523),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4523),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [9386] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(7598),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2672),
    [sym_scope_resolution] = STATE(2670),
    [sym_call] = STATE(2670),
    [sym_method_call] = STATE(2672),
    [sym_splat_argument] = STATE(10067),
    [sym_assignment] = STATE(7598),
    [sym_operator_assignment] = STATE(7598),
    [sym_conditional] = STATE(7598),
    [sym_range] = STATE(7598),
    [sym_binary] = STATE(7598),
    [sym_unary] = STATE(7598),
    [sym__arg_or_splat_arg] = STATE(10067),
    [sym_left_assignment_list] = STATE(2671),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2672),
    [sym__variable] = STATE(2670),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2672),
    [sym_false] = STATE(2672),
    [sym_nil] = STATE(2672),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2673),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__splat_star] = ACTIONS(1785),
    [sym__unary_minus] = ACTIONS(4505),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(4507),
    [anon_sym_yield] = ACTIONS(4509),
    [anon_sym_break] = ACTIONS(4511),
    [anon_sym_next] = ACTIONS(4513),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(4515),
    [anon_sym_defined_QMARK] = ACTIONS(4517),
    [anon_sym_not] = ACTIONS(4519),
    [anon_sym_BANG] = ACTIONS(4521),
    [anon_sym_TILDE] = ACTIONS(4521),
    [sym_constant] = ACTIONS(4523),
    [sym_identifier] = ACTIONS(4523),
    [sym_instance_variable] = ACTIONS(4525),
    [sym_class_variable] = ACTIONS(4525),
    [sym_global_variable] = ACTIONS(4525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(4523),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4523),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [9387] = {
    [aux_sym_exceptions_repeat1] = STATE(10388),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_LBRACE] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(14104),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9857),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_EQ] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_do] = ACTIONS(9855),
    [anon_sym_then] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_PLUS_EQ] = ACTIONS(9855),
    [anon_sym_DASH_EQ] = ACTIONS(9855),
    [anon_sym_STAR_EQ] = ACTIONS(9855),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9855),
    [anon_sym_SLASH_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9855),
    [anon_sym_AMP_EQ] = ACTIONS(9855),
    [anon_sym_PERCENT_EQ] = ACTIONS(9855),
    [anon_sym_GT_GT_EQ] = ACTIONS(9855),
    [anon_sym_LT_LT_EQ] = ACTIONS(9855),
    [anon_sym_CARET_EQ] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9857),
    [anon_sym_AMP_AMP] = ACTIONS(9857),
    [anon_sym_LT_LT] = ACTIONS(9857),
    [anon_sym_GT_GT] = ACTIONS(9857),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9857),
    [anon_sym_PLUS] = ACTIONS(9857),
    [anon_sym_SLASH] = ACTIONS(9857),
    [anon_sym_PERCENT] = ACTIONS(9857),
    [sym_comment] = ACTIONS(87),
  },
  [9388] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(4533),
    [sym__binary_star] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(4537),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(4539),
    [anon_sym_AMP] = ACTIONS(4541),
    [anon_sym_EQ] = ACTIONS(12879),
    [anon_sym_LT] = ACTIONS(4543),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_then] = ACTIONS(12120),
    [anon_sym_EQ_GT] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_PLUS_EQ] = ACTIONS(12120),
    [anon_sym_DASH_EQ] = ACTIONS(12120),
    [anon_sym_STAR_EQ] = ACTIONS(12120),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12120),
    [anon_sym_SLASH_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12120),
    [anon_sym_AMP_EQ] = ACTIONS(12120),
    [anon_sym_PERCENT_EQ] = ACTIONS(12120),
    [anon_sym_GT_GT_EQ] = ACTIONS(12120),
    [anon_sym_LT_LT_EQ] = ACTIONS(12120),
    [anon_sym_CARET_EQ] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(4545),
    [anon_sym_DOT_DOT] = ACTIONS(4547),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4549),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(4551),
    [anon_sym_AMP_AMP] = ACTIONS(4551),
    [anon_sym_LT_LT] = ACTIONS(4553),
    [anon_sym_GT_GT] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4551),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4555),
    [anon_sym_LT_EQ_GT] = ACTIONS(4555),
    [anon_sym_EQ_TILDE] = ACTIONS(4555),
    [anon_sym_BANG_TILDE] = ACTIONS(4555),
    [anon_sym_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT] = ACTIONS(4543),
    [anon_sym_GT_EQ] = ACTIONS(4557),
    [anon_sym_CARET] = ACTIONS(4537),
    [anon_sym_PLUS] = ACTIONS(4559),
    [anon_sym_SLASH] = ACTIONS(4539),
    [anon_sym_PERCENT] = ACTIONS(4539),
    [sym_comment] = ACTIONS(87),
  },
  [9389] = {
    [aux_sym_exceptions_repeat1] = STATE(9389),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(14106),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_then] = ACTIONS(11597),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_PLUS_EQ] = ACTIONS(11597),
    [anon_sym_DASH_EQ] = ACTIONS(11597),
    [anon_sym_STAR_EQ] = ACTIONS(11597),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11597),
    [anon_sym_SLASH_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11597),
    [anon_sym_AMP_EQ] = ACTIONS(11597),
    [anon_sym_PERCENT_EQ] = ACTIONS(11597),
    [anon_sym_GT_GT_EQ] = ACTIONS(11597),
    [anon_sym_LT_LT_EQ] = ACTIONS(11597),
    [anon_sym_CARET_EQ] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_LT] = ACTIONS(12338),
    [anon_sym_GT_GT] = ACTIONS(12338),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(12338),
    [anon_sym_PLUS] = ACTIONS(12338),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [9390] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10389),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2704),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2704),
    [sym_assignment] = STATE(10389),
    [sym_operator_assignment] = STATE(10389),
    [sym_conditional] = STATE(10389),
    [sym_range] = STATE(10389),
    [sym_binary] = STATE(10389),
    [sym_unary] = STATE(10389),
    [sym_left_assignment_list] = STATE(2703),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2704),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2704),
    [sym_false] = STATE(2704),
    [sym_nil] = STATE(2704),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2584),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4573),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4393),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_break] = ACTIONS(4397),
    [anon_sym_next] = ACTIONS(4399),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4575),
    [anon_sym_defined_QMARK] = ACTIONS(4577),
    [anon_sym_not] = ACTIONS(4579),
    [anon_sym_BANG] = ACTIONS(4581),
    [anon_sym_TILDE] = ACTIONS(4581),
    [sym_constant] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_instance_variable] = ACTIONS(449),
    [sym_class_variable] = ACTIONS(449),
    [sym_global_variable] = ACTIONS(449),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(447),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9391] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(13035),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [9392] = {
    [sym_heredoc_body] = STATE(10390),
    [aux_sym_call_repeat1] = STATE(10390),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_else] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [9393] = {
    [sym_heredoc_body] = STATE(10390),
    [aux_sym_call_repeat1] = STATE(10390),
    [aux_sym_argument_list_repeat1] = STATE(10391),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(11234),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_else] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [9394] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(13033),
    [sym__binary_star] = ACTIONS(13035),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(13037),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(13035),
    [anon_sym_AMP] = ACTIONS(13039),
    [anon_sym_LT] = ACTIONS(13041),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(13043),
    [anon_sym_DOT_DOT] = ACTIONS(13045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13047),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(13049),
    [anon_sym_AMP_AMP] = ACTIONS(13049),
    [anon_sym_LT_LT] = ACTIONS(13051),
    [anon_sym_GT_GT] = ACTIONS(13051),
    [anon_sym_EQ_EQ] = ACTIONS(13053),
    [anon_sym_BANG_EQ] = ACTIONS(13049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13049),
    [anon_sym_LT_EQ_GT] = ACTIONS(13049),
    [anon_sym_EQ_TILDE] = ACTIONS(13049),
    [anon_sym_BANG_TILDE] = ACTIONS(13049),
    [anon_sym_LT_EQ] = ACTIONS(13041),
    [anon_sym_GT] = ACTIONS(13041),
    [anon_sym_GT_EQ] = ACTIONS(13055),
    [anon_sym_CARET] = ACTIONS(13057),
    [anon_sym_PLUS] = ACTIONS(13033),
    [anon_sym_SLASH] = ACTIONS(13035),
    [anon_sym_PERCENT] = ACTIONS(13035),
    [sym_comment] = ACTIONS(87),
  },
  [9395] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10392),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7627),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(7627),
    [sym_assignment] = STATE(10392),
    [sym_operator_assignment] = STATE(10392),
    [sym_conditional] = STATE(10392),
    [sym_range] = STATE(10392),
    [sym_binary] = STATE(10392),
    [sym_unary] = STATE(10392),
    [sym_left_assignment_list] = STATE(7626),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7627),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7627),
    [sym_false] = STATE(7627),
    [sym_nil] = STATE(7627),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7628),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11168),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11170),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_break] = ACTIONS(11174),
    [anon_sym_next] = ACTIONS(11176),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11178),
    [anon_sym_defined_QMARK] = ACTIONS(11180),
    [anon_sym_not] = ACTIONS(11182),
    [anon_sym_BANG] = ACTIONS(11184),
    [anon_sym_TILDE] = ACTIONS(11184),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9396] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10393),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7627),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(7627),
    [sym_assignment] = STATE(10393),
    [sym_operator_assignment] = STATE(10393),
    [sym_conditional] = STATE(10393),
    [sym_range] = STATE(10393),
    [sym_binary] = STATE(10393),
    [sym_unary] = STATE(10393),
    [sym_left_assignment_list] = STATE(7626),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7627),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7627),
    [sym_false] = STATE(7627),
    [sym_nil] = STATE(7627),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7628),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11168),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11170),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_break] = ACTIONS(11174),
    [anon_sym_next] = ACTIONS(11176),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11178),
    [anon_sym_defined_QMARK] = ACTIONS(11180),
    [anon_sym_not] = ACTIONS(11182),
    [anon_sym_BANG] = ACTIONS(11184),
    [anon_sym_TILDE] = ACTIONS(11184),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9397] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10394),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7627),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(7627),
    [sym_assignment] = STATE(10394),
    [sym_operator_assignment] = STATE(10394),
    [sym_conditional] = STATE(10394),
    [sym_range] = STATE(10394),
    [sym_binary] = STATE(10394),
    [sym_unary] = STATE(10394),
    [sym_left_assignment_list] = STATE(7626),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7627),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7627),
    [sym_false] = STATE(7627),
    [sym_nil] = STATE(7627),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7628),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11168),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11170),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_break] = ACTIONS(11174),
    [anon_sym_next] = ACTIONS(11176),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11178),
    [anon_sym_defined_QMARK] = ACTIONS(11180),
    [anon_sym_not] = ACTIONS(11182),
    [anon_sym_BANG] = ACTIONS(11184),
    [anon_sym_TILDE] = ACTIONS(11184),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9398] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10395),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7627),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(7627),
    [sym_assignment] = STATE(10395),
    [sym_operator_assignment] = STATE(10395),
    [sym_conditional] = STATE(10395),
    [sym_range] = STATE(10395),
    [sym_binary] = STATE(10395),
    [sym_unary] = STATE(10395),
    [sym_left_assignment_list] = STATE(7626),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7627),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7627),
    [sym_false] = STATE(7627),
    [sym_nil] = STATE(7627),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7628),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11168),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11170),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_break] = ACTIONS(11174),
    [anon_sym_next] = ACTIONS(11176),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11178),
    [anon_sym_defined_QMARK] = ACTIONS(11180),
    [anon_sym_not] = ACTIONS(11182),
    [anon_sym_BANG] = ACTIONS(11184),
    [anon_sym_TILDE] = ACTIONS(11184),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9399] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10396),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7627),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(7627),
    [sym_assignment] = STATE(10396),
    [sym_operator_assignment] = STATE(10396),
    [sym_conditional] = STATE(10396),
    [sym_range] = STATE(10396),
    [sym_binary] = STATE(10396),
    [sym_unary] = STATE(10396),
    [sym_left_assignment_list] = STATE(7626),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7627),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7627),
    [sym_false] = STATE(7627),
    [sym_nil] = STATE(7627),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7628),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11168),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11170),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_break] = ACTIONS(11174),
    [anon_sym_next] = ACTIONS(11176),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11178),
    [anon_sym_defined_QMARK] = ACTIONS(11180),
    [anon_sym_not] = ACTIONS(11182),
    [anon_sym_BANG] = ACTIONS(11184),
    [anon_sym_TILDE] = ACTIONS(11184),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9400] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(10397),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(10397),
    [sym_operator_assignment] = STATE(10397),
    [sym_conditional] = STATE(10397),
    [sym_range] = STATE(10397),
    [sym_binary] = STATE(10397),
    [sym_unary] = STATE(10397),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9401] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10398),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7627),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(7627),
    [sym_assignment] = STATE(10398),
    [sym_operator_assignment] = STATE(10398),
    [sym_conditional] = STATE(10398),
    [sym_range] = STATE(10398),
    [sym_binary] = STATE(10398),
    [sym_unary] = STATE(10398),
    [sym_left_assignment_list] = STATE(7626),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7627),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7627),
    [sym_false] = STATE(7627),
    [sym_nil] = STATE(7627),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7628),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11168),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11170),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_break] = ACTIONS(11174),
    [anon_sym_next] = ACTIONS(11176),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11178),
    [anon_sym_defined_QMARK] = ACTIONS(11180),
    [anon_sym_not] = ACTIONS(11182),
    [anon_sym_BANG] = ACTIONS(11184),
    [anon_sym_TILDE] = ACTIONS(11184),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9402] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10399),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7627),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(7627),
    [sym_assignment] = STATE(10399),
    [sym_operator_assignment] = STATE(10399),
    [sym_conditional] = STATE(10399),
    [sym_range] = STATE(10399),
    [sym_binary] = STATE(10399),
    [sym_unary] = STATE(10399),
    [sym_left_assignment_list] = STATE(7626),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7627),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7627),
    [sym_false] = STATE(7627),
    [sym_nil] = STATE(7627),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7628),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11168),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11170),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_break] = ACTIONS(11174),
    [anon_sym_next] = ACTIONS(11176),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11178),
    [anon_sym_defined_QMARK] = ACTIONS(11180),
    [anon_sym_not] = ACTIONS(11182),
    [anon_sym_BANG] = ACTIONS(11184),
    [anon_sym_TILDE] = ACTIONS(11184),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9403] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10400),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7627),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(7627),
    [sym_assignment] = STATE(10400),
    [sym_operator_assignment] = STATE(10400),
    [sym_conditional] = STATE(10400),
    [sym_range] = STATE(10400),
    [sym_binary] = STATE(10400),
    [sym_unary] = STATE(10400),
    [sym_left_assignment_list] = STATE(7626),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7627),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7627),
    [sym_false] = STATE(7627),
    [sym_nil] = STATE(7627),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7628),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11168),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11170),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_break] = ACTIONS(11174),
    [anon_sym_next] = ACTIONS(11176),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11178),
    [anon_sym_defined_QMARK] = ACTIONS(11180),
    [anon_sym_not] = ACTIONS(11182),
    [anon_sym_BANG] = ACTIONS(11184),
    [anon_sym_TILDE] = ACTIONS(11184),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9404] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10401),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7627),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(7627),
    [sym_assignment] = STATE(10401),
    [sym_operator_assignment] = STATE(10401),
    [sym_conditional] = STATE(10401),
    [sym_range] = STATE(10401),
    [sym_binary] = STATE(10401),
    [sym_unary] = STATE(10401),
    [sym_left_assignment_list] = STATE(7626),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7627),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7627),
    [sym_false] = STATE(7627),
    [sym_nil] = STATE(7627),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7628),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11168),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11170),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_break] = ACTIONS(11174),
    [anon_sym_next] = ACTIONS(11176),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11178),
    [anon_sym_defined_QMARK] = ACTIONS(11180),
    [anon_sym_not] = ACTIONS(11182),
    [anon_sym_BANG] = ACTIONS(11184),
    [anon_sym_TILDE] = ACTIONS(11184),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9405] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10402),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7627),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(7627),
    [sym_splat_argument] = STATE(10403),
    [sym_assignment] = STATE(10402),
    [sym_operator_assignment] = STATE(10402),
    [sym_conditional] = STATE(10402),
    [sym_range] = STATE(10402),
    [sym_binary] = STATE(10402),
    [sym_unary] = STATE(10402),
    [sym_right_assignment_list] = STATE(2570),
    [sym__arg_or_splat_arg] = STATE(10403),
    [sym_left_assignment_list] = STATE(7626),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7627),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7627),
    [sym_false] = STATE(7627),
    [sym_nil] = STATE(7627),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7628),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(8180),
    [sym__unary_minus] = ACTIONS(11168),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11170),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_break] = ACTIONS(11174),
    [anon_sym_next] = ACTIONS(11176),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11178),
    [anon_sym_defined_QMARK] = ACTIONS(11180),
    [anon_sym_not] = ACTIONS(11182),
    [anon_sym_BANG] = ACTIONS(11184),
    [anon_sym_TILDE] = ACTIONS(11184),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9406] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10404),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7627),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(7627),
    [sym_assignment] = STATE(10404),
    [sym_operator_assignment] = STATE(10404),
    [sym_conditional] = STATE(10404),
    [sym_range] = STATE(10404),
    [sym_binary] = STATE(10404),
    [sym_unary] = STATE(10404),
    [sym_left_assignment_list] = STATE(7626),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7627),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7627),
    [sym_false] = STATE(7627),
    [sym_nil] = STATE(7627),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7628),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11168),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11170),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_break] = ACTIONS(11174),
    [anon_sym_next] = ACTIONS(11176),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11178),
    [anon_sym_defined_QMARK] = ACTIONS(11180),
    [anon_sym_not] = ACTIONS(11182),
    [anon_sym_BANG] = ACTIONS(11184),
    [anon_sym_TILDE] = ACTIONS(11184),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9407] = {
    [sym_string] = STATE(10405),
    [aux_sym_chained_string_repeat1] = STATE(10405),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_end] = ACTIONS(2753),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_else] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [9408] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(13033),
    [sym__binary_star] = ACTIONS(13035),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(13037),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(13035),
    [anon_sym_AMP] = ACTIONS(13039),
    [anon_sym_LT] = ACTIONS(13041),
    [anon_sym_end] = ACTIONS(6823),
    [anon_sym_if] = ACTIONS(6823),
    [anon_sym_unless] = ACTIONS(6823),
    [anon_sym_while] = ACTIONS(6823),
    [anon_sym_until] = ACTIONS(6823),
    [anon_sym_rescue] = ACTIONS(6823),
    [anon_sym_else] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(13043),
    [anon_sym_DOT_DOT] = ACTIONS(13045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13047),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(13049),
    [anon_sym_AMP_AMP] = ACTIONS(13049),
    [anon_sym_LT_LT] = ACTIONS(13051),
    [anon_sym_GT_GT] = ACTIONS(13051),
    [anon_sym_EQ_EQ] = ACTIONS(13053),
    [anon_sym_BANG_EQ] = ACTIONS(13049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13049),
    [anon_sym_LT_EQ_GT] = ACTIONS(13049),
    [anon_sym_EQ_TILDE] = ACTIONS(13049),
    [anon_sym_BANG_TILDE] = ACTIONS(13049),
    [anon_sym_LT_EQ] = ACTIONS(13041),
    [anon_sym_GT] = ACTIONS(13041),
    [anon_sym_GT_EQ] = ACTIONS(13055),
    [anon_sym_CARET] = ACTIONS(13057),
    [anon_sym_PLUS] = ACTIONS(13033),
    [anon_sym_SLASH] = ACTIONS(13035),
    [anon_sym_PERCENT] = ACTIONS(13035),
    [sym_comment] = ACTIONS(87),
  },
  [9409] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(11200),
    [sym__binary_star] = ACTIONS(11202),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(11204),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(11202),
    [anon_sym_AMP] = ACTIONS(11206),
    [anon_sym_LT] = ACTIONS(11208),
    [anon_sym_end] = ACTIONS(4211),
    [anon_sym_if] = ACTIONS(4211),
    [anon_sym_unless] = ACTIONS(4211),
    [anon_sym_while] = ACTIONS(4211),
    [anon_sym_until] = ACTIONS(4211),
    [anon_sym_rescue] = ACTIONS(4211),
    [anon_sym_else] = ACTIONS(4211),
    [anon_sym_EQ_GT] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(11210),
    [anon_sym_DOT_DOT] = ACTIONS(11212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11214),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11216),
    [anon_sym_AMP_AMP] = ACTIONS(11216),
    [anon_sym_LT_LT] = ACTIONS(11218),
    [anon_sym_GT_GT] = ACTIONS(11218),
    [anon_sym_EQ_EQ] = ACTIONS(11220),
    [anon_sym_BANG_EQ] = ACTIONS(11216),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11216),
    [anon_sym_LT_EQ_GT] = ACTIONS(11216),
    [anon_sym_EQ_TILDE] = ACTIONS(11216),
    [anon_sym_BANG_TILDE] = ACTIONS(11216),
    [anon_sym_LT_EQ] = ACTIONS(11208),
    [anon_sym_GT] = ACTIONS(11208),
    [anon_sym_GT_EQ] = ACTIONS(11222),
    [anon_sym_CARET] = ACTIONS(11224),
    [anon_sym_PLUS] = ACTIONS(11200),
    [anon_sym_SLASH] = ACTIONS(11202),
    [anon_sym_PERCENT] = ACTIONS(11202),
    [sym_comment] = ACTIONS(87),
  },
  [9410] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(11200),
    [sym__binary_star] = ACTIONS(11202),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(11204),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(11202),
    [anon_sym_AMP] = ACTIONS(11206),
    [anon_sym_LT] = ACTIONS(11208),
    [anon_sym_end] = ACTIONS(4247),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_else] = ACTIONS(4247),
    [anon_sym_EQ_GT] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(11210),
    [anon_sym_DOT_DOT] = ACTIONS(11212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11214),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(11216),
    [anon_sym_AMP_AMP] = ACTIONS(11216),
    [anon_sym_LT_LT] = ACTIONS(11218),
    [anon_sym_GT_GT] = ACTIONS(11218),
    [anon_sym_EQ_EQ] = ACTIONS(11220),
    [anon_sym_BANG_EQ] = ACTIONS(11216),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11216),
    [anon_sym_LT_EQ_GT] = ACTIONS(11216),
    [anon_sym_EQ_TILDE] = ACTIONS(11216),
    [anon_sym_BANG_TILDE] = ACTIONS(11216),
    [anon_sym_LT_EQ] = ACTIONS(11208),
    [anon_sym_GT] = ACTIONS(11208),
    [anon_sym_GT_EQ] = ACTIONS(11222),
    [anon_sym_CARET] = ACTIONS(11224),
    [anon_sym_PLUS] = ACTIONS(11200),
    [anon_sym_SLASH] = ACTIONS(11202),
    [anon_sym_PERCENT] = ACTIONS(11202),
    [sym_comment] = ACTIONS(87),
  },
  [9411] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10406),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5178),
    [sym_scope_resolution] = STATE(5174),
    [sym_call] = STATE(5174),
    [sym_method_call] = STATE(5178),
    [sym_assignment] = STATE(10406),
    [sym_operator_assignment] = STATE(10406),
    [sym_conditional] = STATE(10406),
    [sym_range] = STATE(10406),
    [sym_binary] = STATE(10406),
    [sym_unary] = STATE(10406),
    [sym_left_assignment_list] = STATE(5177),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5178),
    [sym__variable] = STATE(5174),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5178),
    [sym_false] = STATE(5178),
    [sym_nil] = STATE(5178),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7631),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8186),
    [anon_sym_yield] = ACTIONS(8188),
    [anon_sym_break] = ACTIONS(8190),
    [anon_sym_next] = ACTIONS(8192),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11186),
    [anon_sym_defined_QMARK] = ACTIONS(8194),
    [anon_sym_not] = ACTIONS(8196),
    [anon_sym_BANG] = ACTIONS(8200),
    [anon_sym_TILDE] = ACTIONS(8200),
    [sym_constant] = ACTIONS(8206),
    [sym_identifier] = ACTIONS(8206),
    [sym_instance_variable] = ACTIONS(8204),
    [sym_class_variable] = ACTIONS(8204),
    [sym_global_variable] = ACTIONS(8204),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8206),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8206),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9412] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(11200),
    [sym__binary_star] = ACTIONS(11202),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(11204),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(11202),
    [anon_sym_AMP] = ACTIONS(11206),
    [anon_sym_LT] = ACTIONS(11208),
    [anon_sym_end] = ACTIONS(3281),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_unless] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_until] = ACTIONS(3281),
    [anon_sym_rescue] = ACTIONS(3281),
    [anon_sym_else] = ACTIONS(3281),
    [anon_sym_EQ_GT] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(11210),
    [anon_sym_DOT_DOT] = ACTIONS(11212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11214),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(11216),
    [anon_sym_AMP_AMP] = ACTIONS(11216),
    [anon_sym_LT_LT] = ACTIONS(11218),
    [anon_sym_GT_GT] = ACTIONS(11218),
    [anon_sym_EQ_EQ] = ACTIONS(11220),
    [anon_sym_BANG_EQ] = ACTIONS(11216),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11216),
    [anon_sym_LT_EQ_GT] = ACTIONS(11216),
    [anon_sym_EQ_TILDE] = ACTIONS(11216),
    [anon_sym_BANG_TILDE] = ACTIONS(11216),
    [anon_sym_LT_EQ] = ACTIONS(11208),
    [anon_sym_GT] = ACTIONS(11208),
    [anon_sym_GT_EQ] = ACTIONS(11222),
    [anon_sym_CARET] = ACTIONS(11224),
    [anon_sym_PLUS] = ACTIONS(11200),
    [anon_sym_SLASH] = ACTIONS(11202),
    [anon_sym_PERCENT] = ACTIONS(11202),
    [sym_comment] = ACTIONS(87),
  },
  [9413] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10407),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5178),
    [sym_scope_resolution] = STATE(5174),
    [sym_call] = STATE(5174),
    [sym_method_call] = STATE(5178),
    [sym_assignment] = STATE(10407),
    [sym_operator_assignment] = STATE(10407),
    [sym_conditional] = STATE(10407),
    [sym_range] = STATE(10407),
    [sym_binary] = STATE(10407),
    [sym_unary] = STATE(10407),
    [sym_left_assignment_list] = STATE(5177),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5178),
    [sym__variable] = STATE(5174),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5178),
    [sym_false] = STATE(5178),
    [sym_nil] = STATE(5178),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7631),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8186),
    [anon_sym_yield] = ACTIONS(8188),
    [anon_sym_break] = ACTIONS(8190),
    [anon_sym_next] = ACTIONS(8192),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11186),
    [anon_sym_defined_QMARK] = ACTIONS(8194),
    [anon_sym_not] = ACTIONS(8196),
    [anon_sym_BANG] = ACTIONS(8200),
    [anon_sym_TILDE] = ACTIONS(8200),
    [sym_constant] = ACTIONS(8206),
    [sym_identifier] = ACTIONS(8206),
    [sym_instance_variable] = ACTIONS(8204),
    [sym_class_variable] = ACTIONS(8204),
    [sym_global_variable] = ACTIONS(8204),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8206),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8206),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9414] = {
    [sym_heredoc_body] = STATE(10408),
    [aux_sym_call_repeat1] = STATE(10408),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_else] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [9415] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7639),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5178),
    [sym_scope_resolution] = STATE(5174),
    [sym_call] = STATE(5174),
    [sym_method_call] = STATE(5178),
    [sym__argument] = STATE(2565),
    [sym_splat_argument] = STATE(2565),
    [sym_hash_splat_argument] = STATE(2565),
    [sym_block_argument] = STATE(2565),
    [sym_assignment] = STATE(7639),
    [sym_operator_assignment] = STATE(7639),
    [sym_conditional] = STATE(7639),
    [sym_range] = STATE(7639),
    [sym_binary] = STATE(7639),
    [sym_unary] = STATE(7639),
    [sym_left_assignment_list] = STATE(5177),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5178),
    [sym__variable] = STATE(5174),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5178),
    [sym_false] = STATE(5178),
    [sym_nil] = STATE(5178),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7642),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(10409),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2565),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(11190),
    [sym__splat_star] = ACTIONS(11192),
    [sym__unary_minus] = ACTIONS(8182),
    [sym__identifier_hash_key] = ACTIONS(11194),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(14109),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8186),
    [anon_sym_yield] = ACTIONS(8188),
    [anon_sym_break] = ACTIONS(8190),
    [anon_sym_next] = ACTIONS(8192),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11186),
    [anon_sym_defined_QMARK] = ACTIONS(8194),
    [anon_sym_not] = ACTIONS(8196),
    [anon_sym_BANG] = ACTIONS(8200),
    [anon_sym_TILDE] = ACTIONS(8200),
    [sym_constant] = ACTIONS(11196),
    [sym_identifier] = ACTIONS(11196),
    [sym_instance_variable] = ACTIONS(8204),
    [sym_class_variable] = ACTIONS(8204),
    [sym_global_variable] = ACTIONS(8204),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8206),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8206),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9416] = {
    [sym_heredoc_body] = STATE(10410),
    [aux_sym_call_repeat1] = STATE(10410),
    [aux_sym_argument_list_repeat1] = STATE(10411),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(13069),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_else] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [9417] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(13033),
    [sym__binary_star] = ACTIONS(13035),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(13037),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(13035),
    [anon_sym_AMP] = ACTIONS(13039),
    [anon_sym_LT] = ACTIONS(13041),
    [anon_sym_end] = ACTIONS(7027),
    [anon_sym_if] = ACTIONS(7027),
    [anon_sym_unless] = ACTIONS(7027),
    [anon_sym_while] = ACTIONS(7027),
    [anon_sym_until] = ACTIONS(7027),
    [anon_sym_rescue] = ACTIONS(7027),
    [anon_sym_else] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(13043),
    [anon_sym_DOT_DOT] = ACTIONS(13045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13047),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(13049),
    [anon_sym_AMP_AMP] = ACTIONS(13049),
    [anon_sym_LT_LT] = ACTIONS(13051),
    [anon_sym_GT_GT] = ACTIONS(13051),
    [anon_sym_EQ_EQ] = ACTIONS(13053),
    [anon_sym_BANG_EQ] = ACTIONS(13049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13049),
    [anon_sym_LT_EQ_GT] = ACTIONS(13049),
    [anon_sym_EQ_TILDE] = ACTIONS(13049),
    [anon_sym_BANG_TILDE] = ACTIONS(13049),
    [anon_sym_LT_EQ] = ACTIONS(13041),
    [anon_sym_GT] = ACTIONS(13041),
    [anon_sym_GT_EQ] = ACTIONS(13055),
    [anon_sym_CARET] = ACTIONS(13057),
    [anon_sym_PLUS] = ACTIONS(13033),
    [anon_sym_SLASH] = ACTIONS(13035),
    [anon_sym_PERCENT] = ACTIONS(13035),
    [sym_comment] = ACTIONS(87),
  },
  [9418] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(11202),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11202),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(11202),
    [anon_sym_PERCENT] = ACTIONS(11202),
    [sym_comment] = ACTIONS(87),
  },
  [9419] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11202),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [9420] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11200),
    [sym__binary_star] = ACTIONS(11202),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11202),
    [anon_sym_AMP] = ACTIONS(11206),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(11218),
    [anon_sym_GT_GT] = ACTIONS(11218),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(11200),
    [anon_sym_SLASH] = ACTIONS(11202),
    [anon_sym_PERCENT] = ACTIONS(11202),
    [sym_comment] = ACTIONS(87),
  },
  [9421] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11200),
    [sym__binary_star] = ACTIONS(11202),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11202),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(11218),
    [anon_sym_GT_GT] = ACTIONS(11218),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(11200),
    [anon_sym_SLASH] = ACTIONS(11202),
    [anon_sym_PERCENT] = ACTIONS(11202),
    [sym_comment] = ACTIONS(87),
  },
  [9422] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11200),
    [sym__binary_star] = ACTIONS(11202),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(11204),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11202),
    [anon_sym_AMP] = ACTIONS(11206),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(11218),
    [anon_sym_GT_GT] = ACTIONS(11218),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(11224),
    [anon_sym_PLUS] = ACTIONS(11200),
    [anon_sym_SLASH] = ACTIONS(11202),
    [anon_sym_PERCENT] = ACTIONS(11202),
    [sym_comment] = ACTIONS(87),
  },
  [9423] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(14111),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [9424] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(11200),
    [sym__binary_star] = ACTIONS(11202),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(11204),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(11202),
    [anon_sym_AMP] = ACTIONS(11206),
    [anon_sym_LT] = ACTIONS(11208),
    [anon_sym_end] = ACTIONS(5927),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_else] = ACTIONS(5927),
    [anon_sym_EQ_GT] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(11212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11214),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(11216),
    [anon_sym_AMP_AMP] = ACTIONS(11216),
    [anon_sym_LT_LT] = ACTIONS(11218),
    [anon_sym_GT_GT] = ACTIONS(11218),
    [anon_sym_EQ_EQ] = ACTIONS(11220),
    [anon_sym_BANG_EQ] = ACTIONS(11216),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11216),
    [anon_sym_LT_EQ_GT] = ACTIONS(11216),
    [anon_sym_EQ_TILDE] = ACTIONS(11216),
    [anon_sym_BANG_TILDE] = ACTIONS(11216),
    [anon_sym_LT_EQ] = ACTIONS(11208),
    [anon_sym_GT] = ACTIONS(11208),
    [anon_sym_GT_EQ] = ACTIONS(11222),
    [anon_sym_CARET] = ACTIONS(11224),
    [anon_sym_PLUS] = ACTIONS(11200),
    [anon_sym_SLASH] = ACTIONS(11202),
    [anon_sym_PERCENT] = ACTIONS(11202),
    [sym_comment] = ACTIONS(87),
  },
  [9425] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11200),
    [sym__binary_star] = ACTIONS(11202),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(11204),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11202),
    [anon_sym_AMP] = ACTIONS(11206),
    [anon_sym_LT] = ACTIONS(11208),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(11210),
    [anon_sym_DOT_DOT] = ACTIONS(11212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11214),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(11216),
    [anon_sym_AMP_AMP] = ACTIONS(11216),
    [anon_sym_LT_LT] = ACTIONS(11218),
    [anon_sym_GT_GT] = ACTIONS(11218),
    [anon_sym_EQ_EQ] = ACTIONS(11220),
    [anon_sym_BANG_EQ] = ACTIONS(11216),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11216),
    [anon_sym_LT_EQ_GT] = ACTIONS(11216),
    [anon_sym_EQ_TILDE] = ACTIONS(11216),
    [anon_sym_BANG_TILDE] = ACTIONS(11216),
    [anon_sym_LT_EQ] = ACTIONS(11208),
    [anon_sym_GT] = ACTIONS(11208),
    [anon_sym_GT_EQ] = ACTIONS(11222),
    [anon_sym_CARET] = ACTIONS(11224),
    [anon_sym_PLUS] = ACTIONS(11200),
    [anon_sym_SLASH] = ACTIONS(11202),
    [anon_sym_PERCENT] = ACTIONS(11202),
    [sym_comment] = ACTIONS(87),
  },
  [9426] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11200),
    [sym__binary_star] = ACTIONS(11202),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(11204),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11202),
    [anon_sym_AMP] = ACTIONS(11206),
    [anon_sym_LT] = ACTIONS(11208),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(11218),
    [anon_sym_GT_GT] = ACTIONS(11218),
    [anon_sym_EQ_EQ] = ACTIONS(11220),
    [anon_sym_BANG_EQ] = ACTIONS(11216),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11216),
    [anon_sym_LT_EQ_GT] = ACTIONS(11216),
    [anon_sym_EQ_TILDE] = ACTIONS(11216),
    [anon_sym_BANG_TILDE] = ACTIONS(11216),
    [anon_sym_LT_EQ] = ACTIONS(11208),
    [anon_sym_GT] = ACTIONS(11208),
    [anon_sym_GT_EQ] = ACTIONS(11222),
    [anon_sym_CARET] = ACTIONS(11224),
    [anon_sym_PLUS] = ACTIONS(11200),
    [anon_sym_SLASH] = ACTIONS(11202),
    [anon_sym_PERCENT] = ACTIONS(11202),
    [sym_comment] = ACTIONS(87),
  },
  [9427] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11200),
    [sym__binary_star] = ACTIONS(11202),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11202),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(11200),
    [anon_sym_SLASH] = ACTIONS(11202),
    [anon_sym_PERCENT] = ACTIONS(11202),
    [sym_comment] = ACTIONS(87),
  },
  [9428] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(11272),
    [sym__binary_star] = ACTIONS(11274),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(11276),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(11278),
    [anon_sym_AMP] = ACTIONS(11280),
    [anon_sym_EQ] = ACTIONS(4217),
    [anon_sym_LT] = ACTIONS(11282),
    [anon_sym_end] = ACTIONS(4211),
    [anon_sym_if] = ACTIONS(4211),
    [anon_sym_unless] = ACTIONS(4211),
    [anon_sym_while] = ACTIONS(4211),
    [anon_sym_until] = ACTIONS(4211),
    [anon_sym_rescue] = ACTIONS(4211),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_else] = ACTIONS(4211),
    [anon_sym_EQ_GT] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_PLUS_EQ] = ACTIONS(4211),
    [anon_sym_DASH_EQ] = ACTIONS(4211),
    [anon_sym_STAR_EQ] = ACTIONS(4211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4211),
    [anon_sym_SLASH_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4211),
    [anon_sym_AMP_EQ] = ACTIONS(4211),
    [anon_sym_PERCENT_EQ] = ACTIONS(4211),
    [anon_sym_GT_GT_EQ] = ACTIONS(4211),
    [anon_sym_LT_LT_EQ] = ACTIONS(4211),
    [anon_sym_CARET_EQ] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(11284),
    [anon_sym_DOT_DOT] = ACTIONS(11286),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11288),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11290),
    [anon_sym_AMP_AMP] = ACTIONS(11290),
    [anon_sym_LT_LT] = ACTIONS(11292),
    [anon_sym_GT_GT] = ACTIONS(11292),
    [anon_sym_EQ_EQ] = ACTIONS(11290),
    [anon_sym_BANG_EQ] = ACTIONS(11294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11294),
    [anon_sym_LT_EQ_GT] = ACTIONS(11294),
    [anon_sym_EQ_TILDE] = ACTIONS(11294),
    [anon_sym_BANG_TILDE] = ACTIONS(11294),
    [anon_sym_LT_EQ] = ACTIONS(11282),
    [anon_sym_GT] = ACTIONS(11282),
    [anon_sym_GT_EQ] = ACTIONS(11296),
    [anon_sym_CARET] = ACTIONS(11276),
    [anon_sym_PLUS] = ACTIONS(11298),
    [anon_sym_SLASH] = ACTIONS(11278),
    [anon_sym_PERCENT] = ACTIONS(11278),
    [sym_comment] = ACTIONS(87),
  },
  [9429] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(11272),
    [sym__binary_star] = ACTIONS(11274),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(11276),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(11278),
    [anon_sym_AMP] = ACTIONS(11280),
    [anon_sym_EQ] = ACTIONS(4249),
    [anon_sym_LT] = ACTIONS(11282),
    [anon_sym_end] = ACTIONS(4247),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_else] = ACTIONS(4247),
    [anon_sym_EQ_GT] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_PLUS_EQ] = ACTIONS(4247),
    [anon_sym_DASH_EQ] = ACTIONS(4247),
    [anon_sym_STAR_EQ] = ACTIONS(4247),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4247),
    [anon_sym_SLASH_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4247),
    [anon_sym_AMP_EQ] = ACTIONS(4247),
    [anon_sym_PERCENT_EQ] = ACTIONS(4247),
    [anon_sym_GT_GT_EQ] = ACTIONS(4247),
    [anon_sym_LT_LT_EQ] = ACTIONS(4247),
    [anon_sym_CARET_EQ] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(11284),
    [anon_sym_DOT_DOT] = ACTIONS(11286),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11288),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(11290),
    [anon_sym_AMP_AMP] = ACTIONS(11290),
    [anon_sym_LT_LT] = ACTIONS(11292),
    [anon_sym_GT_GT] = ACTIONS(11292),
    [anon_sym_EQ_EQ] = ACTIONS(11290),
    [anon_sym_BANG_EQ] = ACTIONS(11294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11294),
    [anon_sym_LT_EQ_GT] = ACTIONS(11294),
    [anon_sym_EQ_TILDE] = ACTIONS(11294),
    [anon_sym_BANG_TILDE] = ACTIONS(11294),
    [anon_sym_LT_EQ] = ACTIONS(11282),
    [anon_sym_GT] = ACTIONS(11282),
    [anon_sym_GT_EQ] = ACTIONS(11296),
    [anon_sym_CARET] = ACTIONS(11276),
    [anon_sym_PLUS] = ACTIONS(11298),
    [anon_sym_SLASH] = ACTIONS(11278),
    [anon_sym_PERCENT] = ACTIONS(11278),
    [sym_comment] = ACTIONS(87),
  },
  [9430] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(10413),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5214),
    [sym_scope_resolution] = STATE(5210),
    [sym_call] = STATE(5210),
    [sym_method_call] = STATE(5214),
    [sym_assignment] = STATE(10413),
    [sym_operator_assignment] = STATE(10413),
    [sym_conditional] = STATE(10413),
    [sym_range] = STATE(10413),
    [sym_binary] = STATE(10413),
    [sym_unary] = STATE(10413),
    [sym_left_assignment_list] = STATE(5213),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5214),
    [sym__variable] = STATE(5210),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5214),
    [sym_false] = STATE(5214),
    [sym_nil] = STATE(5214),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7700),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(8252),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(8256),
    [anon_sym_yield] = ACTIONS(8258),
    [anon_sym_break] = ACTIONS(8260),
    [anon_sym_next] = ACTIONS(8262),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(11266),
    [anon_sym_defined_QMARK] = ACTIONS(8264),
    [anon_sym_not] = ACTIONS(8266),
    [anon_sym_BANG] = ACTIONS(8270),
    [anon_sym_TILDE] = ACTIONS(8270),
    [sym_constant] = ACTIONS(8276),
    [sym_identifier] = ACTIONS(8276),
    [sym_instance_variable] = ACTIONS(8274),
    [sym_class_variable] = ACTIONS(8274),
    [sym_global_variable] = ACTIONS(8274),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8276),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8276),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [9431] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(11272),
    [sym__binary_star] = ACTIONS(11274),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(11276),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(11278),
    [anon_sym_AMP] = ACTIONS(11280),
    [anon_sym_EQ] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(11282),
    [anon_sym_end] = ACTIONS(3281),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_unless] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_until] = ACTIONS(3281),
    [anon_sym_rescue] = ACTIONS(3281),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_else] = ACTIONS(3281),
    [anon_sym_EQ_GT] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_PLUS_EQ] = ACTIONS(3281),
    [anon_sym_DASH_EQ] = ACTIONS(3281),
    [anon_sym_STAR_EQ] = ACTIONS(3281),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3281),
    [anon_sym_SLASH_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3281),
    [anon_sym_AMP_EQ] = ACTIONS(3281),
    [anon_sym_PERCENT_EQ] = ACTIONS(3281),
    [anon_sym_GT_GT_EQ] = ACTIONS(3281),
    [anon_sym_LT_LT_EQ] = ACTIONS(3281),
    [anon_sym_CARET_EQ] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(11284),
    [anon_sym_DOT_DOT] = ACTIONS(11286),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11288),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(11290),
    [anon_sym_AMP_AMP] = ACTIONS(11290),
    [anon_sym_LT_LT] = ACTIONS(11292),
    [anon_sym_GT_GT] = ACTIONS(11292),
    [anon_sym_EQ_EQ] = ACTIONS(11290),
    [anon_sym_BANG_EQ] = ACTIONS(11294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11294),
    [anon_sym_LT_EQ_GT] = ACTIONS(11294),
    [anon_sym_EQ_TILDE] = ACTIONS(11294),
    [anon_sym_BANG_TILDE] = ACTIONS(11294),
    [anon_sym_LT_EQ] = ACTIONS(11282),
    [anon_sym_GT] = ACTIONS(11282),
    [anon_sym_GT_EQ] = ACTIONS(11296),
    [anon_sym_CARET] = ACTIONS(11276),
    [anon_sym_PLUS] = ACTIONS(11298),
    [anon_sym_SLASH] = ACTIONS(11278),
    [anon_sym_PERCENT] = ACTIONS(11278),
    [sym_comment] = ACTIONS(87),
  },
  [9432] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(10414),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5214),
    [sym_scope_resolution] = STATE(5210),
    [sym_call] = STATE(5210),
    [sym_method_call] = STATE(5214),
    [sym_assignment] = STATE(10414),
    [sym_operator_assignment] = STATE(10414),
    [sym_conditional] = STATE(10414),
    [sym_range] = STATE(10414),
    [sym_binary] = STATE(10414),
    [sym_unary] = STATE(10414),
    [sym_left_assignment_list] = STATE(5213),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5214),
    [sym__variable] = STATE(5210),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5214),
    [sym_false] = STATE(5214),
    [sym_nil] = STATE(5214),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7700),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(8252),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(8256),
    [anon_sym_yield] = ACTIONS(8258),
    [anon_sym_break] = ACTIONS(8260),
    [anon_sym_next] = ACTIONS(8262),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(11266),
    [anon_sym_defined_QMARK] = ACTIONS(8264),
    [anon_sym_not] = ACTIONS(8266),
    [anon_sym_BANG] = ACTIONS(8270),
    [anon_sym_TILDE] = ACTIONS(8270),
    [sym_constant] = ACTIONS(8276),
    [sym_identifier] = ACTIONS(8276),
    [sym_instance_variable] = ACTIONS(8274),
    [sym_class_variable] = ACTIONS(8274),
    [sym_global_variable] = ACTIONS(8274),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8276),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8276),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [9433] = {
    [sym_heredoc_body] = STATE(10415),
    [aux_sym_call_repeat1] = STATE(10415),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_else] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [9434] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(7660),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5214),
    [sym_scope_resolution] = STATE(5210),
    [sym_call] = STATE(5210),
    [sym_method_call] = STATE(5214),
    [sym__argument] = STATE(4979),
    [sym_splat_argument] = STATE(4979),
    [sym_hash_splat_argument] = STATE(4979),
    [sym_block_argument] = STATE(4979),
    [sym_assignment] = STATE(7660),
    [sym_operator_assignment] = STATE(7660),
    [sym_conditional] = STATE(7660),
    [sym_range] = STATE(7660),
    [sym_binary] = STATE(7660),
    [sym_unary] = STATE(7660),
    [sym_left_assignment_list] = STATE(5213),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5214),
    [sym__variable] = STATE(5210),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5214),
    [sym_false] = STATE(5214),
    [sym_nil] = STATE(5214),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7663),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_heredoc_body] = STATE(10416),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(4979),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(11226),
    [sym__splat_star] = ACTIONS(11228),
    [sym__unary_minus] = ACTIONS(8252),
    [sym__identifier_hash_key] = ACTIONS(11230),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(14113),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(8256),
    [anon_sym_yield] = ACTIONS(8258),
    [anon_sym_break] = ACTIONS(8260),
    [anon_sym_next] = ACTIONS(8262),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(11266),
    [anon_sym_defined_QMARK] = ACTIONS(8264),
    [anon_sym_not] = ACTIONS(8266),
    [anon_sym_BANG] = ACTIONS(8270),
    [anon_sym_TILDE] = ACTIONS(8270),
    [sym_constant] = ACTIONS(11232),
    [sym_identifier] = ACTIONS(11232),
    [sym_instance_variable] = ACTIONS(8274),
    [sym_class_variable] = ACTIONS(8274),
    [sym_global_variable] = ACTIONS(8274),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8276),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8276),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [9435] = {
    [sym_heredoc_body] = STATE(10417),
    [aux_sym_call_repeat1] = STATE(10417),
    [aux_sym_argument_list_repeat1] = STATE(10418),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(13077),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_else] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [9436] = {
    [sym_heredoc_body] = STATE(9436),
    [aux_sym_call_repeat1] = STATE(9436),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(7916),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_end] = ACTIONS(7914),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_else] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [9437] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5173),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5178),
    [sym_scope_resolution] = STATE(5174),
    [sym_call] = STATE(5174),
    [sym_method_call] = STATE(5178),
    [sym__argument] = STATE(4986),
    [sym_splat_argument] = STATE(4986),
    [sym_hash_splat_argument] = STATE(4986),
    [sym_block_argument] = STATE(4986),
    [sym_assignment] = STATE(5173),
    [sym_operator_assignment] = STATE(5173),
    [sym_conditional] = STATE(5173),
    [sym_range] = STATE(5173),
    [sym_binary] = STATE(5173),
    [sym_unary] = STATE(5173),
    [sym_left_assignment_list] = STATE(5177),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5178),
    [sym__variable] = STATE(5174),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5178),
    [sym_false] = STATE(5178),
    [sym_nil] = STATE(5178),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5179),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4986),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(8178),
    [sym__splat_star] = ACTIONS(8180),
    [sym__unary_minus] = ACTIONS(8182),
    [sym__identifier_hash_key] = ACTIONS(8184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13081),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8186),
    [anon_sym_yield] = ACTIONS(8188),
    [anon_sym_break] = ACTIONS(8190),
    [anon_sym_next] = ACTIONS(8192),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11186),
    [anon_sym_defined_QMARK] = ACTIONS(8194),
    [anon_sym_not] = ACTIONS(8196),
    [anon_sym_BANG] = ACTIONS(8200),
    [anon_sym_TILDE] = ACTIONS(8200),
    [sym_constant] = ACTIONS(8202),
    [sym_identifier] = ACTIONS(8202),
    [sym_instance_variable] = ACTIONS(8204),
    [sym_class_variable] = ACTIONS(8204),
    [sym_global_variable] = ACTIONS(8204),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8206),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8206),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9438] = {
    [sym_heredoc_body] = STATE(9436),
    [aux_sym_call_repeat1] = STATE(9436),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_end] = ACTIONS(7929),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_else] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [9439] = {
    [aux_sym_argument_list_repeat1] = STATE(9439),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(14115),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7925),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_end] = ACTIONS(7925),
    [anon_sym_if] = ACTIONS(7925),
    [anon_sym_unless] = ACTIONS(7925),
    [anon_sym_while] = ACTIONS(7925),
    [anon_sym_until] = ACTIONS(7925),
    [anon_sym_rescue] = ACTIONS(7925),
    [anon_sym_else] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7925),
    [anon_sym_AMP_AMP] = ACTIONS(7925),
    [anon_sym_LT_LT] = ACTIONS(7925),
    [anon_sym_GT_GT] = ACTIONS(7925),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7925),
    [anon_sym_PLUS] = ACTIONS(7925),
    [anon_sym_SLASH] = ACTIONS(7925),
    [anon_sym_PERCENT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [9440] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(11200),
    [sym__binary_star] = ACTIONS(11202),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(11204),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(11202),
    [anon_sym_AMP] = ACTIONS(11206),
    [anon_sym_LT] = ACTIONS(11208),
    [anon_sym_end] = ACTIONS(5115),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_else] = ACTIONS(5115),
    [anon_sym_EQ_GT] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(11210),
    [anon_sym_DOT_DOT] = ACTIONS(11212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11214),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(11216),
    [anon_sym_AMP_AMP] = ACTIONS(11216),
    [anon_sym_LT_LT] = ACTIONS(11218),
    [anon_sym_GT_GT] = ACTIONS(11218),
    [anon_sym_EQ_EQ] = ACTIONS(11220),
    [anon_sym_BANG_EQ] = ACTIONS(11216),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11216),
    [anon_sym_LT_EQ_GT] = ACTIONS(11216),
    [anon_sym_EQ_TILDE] = ACTIONS(11216),
    [anon_sym_BANG_TILDE] = ACTIONS(11216),
    [anon_sym_LT_EQ] = ACTIONS(11208),
    [anon_sym_GT] = ACTIONS(11208),
    [anon_sym_GT_EQ] = ACTIONS(11222),
    [anon_sym_CARET] = ACTIONS(11224),
    [anon_sym_PLUS] = ACTIONS(11200),
    [anon_sym_SLASH] = ACTIONS(11202),
    [anon_sym_PERCENT] = ACTIONS(11202),
    [sym_comment] = ACTIONS(87),
  },
  [9441] = {
    [aux_sym_exceptions_repeat1] = STATE(10420),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_end] = ACTIONS(6191),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_else] = ACTIONS(6191),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [9442] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(11200),
    [sym__binary_star] = ACTIONS(11202),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(11204),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(11202),
    [anon_sym_AMP] = ACTIONS(11206),
    [anon_sym_LT] = ACTIONS(11208),
    [anon_sym_end] = ACTIONS(6210),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_else] = ACTIONS(6210),
    [anon_sym_EQ_GT] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(11210),
    [anon_sym_DOT_DOT] = ACTIONS(11212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11214),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(11216),
    [anon_sym_AMP_AMP] = ACTIONS(11216),
    [anon_sym_LT_LT] = ACTIONS(11218),
    [anon_sym_GT_GT] = ACTIONS(11218),
    [anon_sym_EQ_EQ] = ACTIONS(11220),
    [anon_sym_BANG_EQ] = ACTIONS(11216),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11216),
    [anon_sym_LT_EQ_GT] = ACTIONS(11216),
    [anon_sym_EQ_TILDE] = ACTIONS(11216),
    [anon_sym_BANG_TILDE] = ACTIONS(11216),
    [anon_sym_LT_EQ] = ACTIONS(11208),
    [anon_sym_GT] = ACTIONS(11208),
    [anon_sym_GT_EQ] = ACTIONS(11222),
    [anon_sym_CARET] = ACTIONS(11224),
    [anon_sym_PLUS] = ACTIONS(11200),
    [anon_sym_SLASH] = ACTIONS(11202),
    [anon_sym_PERCENT] = ACTIONS(11202),
    [sym_comment] = ACTIONS(87),
  },
  [9443] = {
    [sym_string] = STATE(9443),
    [aux_sym_chained_string_repeat1] = STATE(9443),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(6214),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_end] = ACTIONS(6212),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_else] = ACTIONS(6212),
    [anon_sym_EQ_GT] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [9444] = {
    [aux_sym_undef_repeat1] = STATE(9444),
    [sym__line_break] = ACTIONS(9263),
    [sym__heredoc_body_start] = ACTIONS(9263),
    [anon_sym_COMMA] = ACTIONS(9265),
    [anon_sym_SEMI] = ACTIONS(9263),
    [anon_sym_end] = ACTIONS(9263),
    [anon_sym_if] = ACTIONS(9263),
    [anon_sym_unless] = ACTIONS(9263),
    [anon_sym_while] = ACTIONS(9263),
    [anon_sym_until] = ACTIONS(9263),
    [anon_sym_rescue] = ACTIONS(9263),
    [anon_sym_else] = ACTIONS(9263),
    [sym_comment] = ACTIONS(87),
  },
  [9445] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10421),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2719),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(2719),
    [sym_assignment] = STATE(10421),
    [sym_operator_assignment] = STATE(10421),
    [sym_conditional] = STATE(10421),
    [sym_range] = STATE(10421),
    [sym_binary] = STATE(10421),
    [sym_unary] = STATE(10421),
    [sym_left_assignment_list] = STATE(2718),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2719),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2719),
    [sym_false] = STATE(2719),
    [sym_nil] = STATE(2719),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2720),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4583),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4585),
    [anon_sym_yield] = ACTIONS(4587),
    [anon_sym_break] = ACTIONS(4589),
    [anon_sym_next] = ACTIONS(4591),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4593),
    [anon_sym_defined_QMARK] = ACTIONS(4595),
    [anon_sym_not] = ACTIONS(4597),
    [anon_sym_BANG] = ACTIONS(4599),
    [anon_sym_TILDE] = ACTIONS(4599),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9446] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(13091),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [9447] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(13085),
    [sym__binary_star] = ACTIONS(13087),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(13089),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(13091),
    [anon_sym_AMP] = ACTIONS(13093),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(13095),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(13097),
    [anon_sym_DOT_DOT] = ACTIONS(13099),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13101),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(13103),
    [anon_sym_AMP_AMP] = ACTIONS(13103),
    [anon_sym_LT_LT] = ACTIONS(13105),
    [anon_sym_GT_GT] = ACTIONS(13105),
    [anon_sym_EQ_EQ] = ACTIONS(13103),
    [anon_sym_BANG_EQ] = ACTIONS(13107),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13107),
    [anon_sym_LT_EQ_GT] = ACTIONS(13107),
    [anon_sym_EQ_TILDE] = ACTIONS(13107),
    [anon_sym_BANG_TILDE] = ACTIONS(13107),
    [anon_sym_LT_EQ] = ACTIONS(13095),
    [anon_sym_GT] = ACTIONS(13095),
    [anon_sym_GT_EQ] = ACTIONS(13109),
    [anon_sym_CARET] = ACTIONS(13089),
    [anon_sym_PLUS] = ACTIONS(13111),
    [anon_sym_SLASH] = ACTIONS(13091),
    [anon_sym_PERCENT] = ACTIONS(13091),
    [sym_comment] = ACTIONS(87),
  },
  [9448] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10422),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7696),
    [sym_scope_resolution] = STATE(7694),
    [sym_call] = STATE(7694),
    [sym_method_call] = STATE(7696),
    [sym_assignment] = STATE(10422),
    [sym_operator_assignment] = STATE(10422),
    [sym_conditional] = STATE(10422),
    [sym_range] = STATE(10422),
    [sym_binary] = STATE(10422),
    [sym_unary] = STATE(10422),
    [sym_left_assignment_list] = STATE(7695),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7696),
    [sym__variable] = STATE(7694),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7696),
    [sym_false] = STATE(7696),
    [sym_nil] = STATE(7696),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7697),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11244),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11246),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_break] = ACTIONS(11250),
    [anon_sym_next] = ACTIONS(11252),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11254),
    [anon_sym_defined_QMARK] = ACTIONS(11256),
    [anon_sym_not] = ACTIONS(11258),
    [anon_sym_BANG] = ACTIONS(11260),
    [anon_sym_TILDE] = ACTIONS(11260),
    [sym_constant] = ACTIONS(11262),
    [sym_identifier] = ACTIONS(11262),
    [sym_instance_variable] = ACTIONS(11264),
    [sym_class_variable] = ACTIONS(11264),
    [sym_global_variable] = ACTIONS(11264),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11262),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11262),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [9449] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10423),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7696),
    [sym_scope_resolution] = STATE(7694),
    [sym_call] = STATE(7694),
    [sym_method_call] = STATE(7696),
    [sym_assignment] = STATE(10423),
    [sym_operator_assignment] = STATE(10423),
    [sym_conditional] = STATE(10423),
    [sym_range] = STATE(10423),
    [sym_binary] = STATE(10423),
    [sym_unary] = STATE(10423),
    [sym_left_assignment_list] = STATE(7695),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7696),
    [sym__variable] = STATE(7694),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7696),
    [sym_false] = STATE(7696),
    [sym_nil] = STATE(7696),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7697),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11244),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11246),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_break] = ACTIONS(11250),
    [anon_sym_next] = ACTIONS(11252),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11254),
    [anon_sym_defined_QMARK] = ACTIONS(11256),
    [anon_sym_not] = ACTIONS(11258),
    [anon_sym_BANG] = ACTIONS(11260),
    [anon_sym_TILDE] = ACTIONS(11260),
    [sym_constant] = ACTIONS(11262),
    [sym_identifier] = ACTIONS(11262),
    [sym_instance_variable] = ACTIONS(11264),
    [sym_class_variable] = ACTIONS(11264),
    [sym_global_variable] = ACTIONS(11264),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11262),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11262),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [9450] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10424),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7696),
    [sym_scope_resolution] = STATE(7694),
    [sym_call] = STATE(7694),
    [sym_method_call] = STATE(7696),
    [sym_assignment] = STATE(10424),
    [sym_operator_assignment] = STATE(10424),
    [sym_conditional] = STATE(10424),
    [sym_range] = STATE(10424),
    [sym_binary] = STATE(10424),
    [sym_unary] = STATE(10424),
    [sym_left_assignment_list] = STATE(7695),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7696),
    [sym__variable] = STATE(7694),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7696),
    [sym_false] = STATE(7696),
    [sym_nil] = STATE(7696),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7697),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11244),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11246),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_break] = ACTIONS(11250),
    [anon_sym_next] = ACTIONS(11252),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11254),
    [anon_sym_defined_QMARK] = ACTIONS(11256),
    [anon_sym_not] = ACTIONS(11258),
    [anon_sym_BANG] = ACTIONS(11260),
    [anon_sym_TILDE] = ACTIONS(11260),
    [sym_constant] = ACTIONS(11262),
    [sym_identifier] = ACTIONS(11262),
    [sym_instance_variable] = ACTIONS(11264),
    [sym_class_variable] = ACTIONS(11264),
    [sym_global_variable] = ACTIONS(11264),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11262),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11262),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [9451] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10425),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7696),
    [sym_scope_resolution] = STATE(7694),
    [sym_call] = STATE(7694),
    [sym_method_call] = STATE(7696),
    [sym_assignment] = STATE(10425),
    [sym_operator_assignment] = STATE(10425),
    [sym_conditional] = STATE(10425),
    [sym_range] = STATE(10425),
    [sym_binary] = STATE(10425),
    [sym_unary] = STATE(10425),
    [sym_left_assignment_list] = STATE(7695),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7696),
    [sym__variable] = STATE(7694),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7696),
    [sym_false] = STATE(7696),
    [sym_nil] = STATE(7696),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7697),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11244),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11246),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_break] = ACTIONS(11250),
    [anon_sym_next] = ACTIONS(11252),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11254),
    [anon_sym_defined_QMARK] = ACTIONS(11256),
    [anon_sym_not] = ACTIONS(11258),
    [anon_sym_BANG] = ACTIONS(11260),
    [anon_sym_TILDE] = ACTIONS(11260),
    [sym_constant] = ACTIONS(11262),
    [sym_identifier] = ACTIONS(11262),
    [sym_instance_variable] = ACTIONS(11264),
    [sym_class_variable] = ACTIONS(11264),
    [sym_global_variable] = ACTIONS(11264),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11262),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11262),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [9452] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10426),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7696),
    [sym_scope_resolution] = STATE(7694),
    [sym_call] = STATE(7694),
    [sym_method_call] = STATE(7696),
    [sym_assignment] = STATE(10426),
    [sym_operator_assignment] = STATE(10426),
    [sym_conditional] = STATE(10426),
    [sym_range] = STATE(10426),
    [sym_binary] = STATE(10426),
    [sym_unary] = STATE(10426),
    [sym_left_assignment_list] = STATE(7695),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7696),
    [sym__variable] = STATE(7694),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7696),
    [sym_false] = STATE(7696),
    [sym_nil] = STATE(7696),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7697),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11244),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11246),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_break] = ACTIONS(11250),
    [anon_sym_next] = ACTIONS(11252),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11254),
    [anon_sym_defined_QMARK] = ACTIONS(11256),
    [anon_sym_not] = ACTIONS(11258),
    [anon_sym_BANG] = ACTIONS(11260),
    [anon_sym_TILDE] = ACTIONS(11260),
    [sym_constant] = ACTIONS(11262),
    [sym_identifier] = ACTIONS(11262),
    [sym_instance_variable] = ACTIONS(11264),
    [sym_class_variable] = ACTIONS(11264),
    [sym_global_variable] = ACTIONS(11264),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11262),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11262),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [9453] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(10427),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(10427),
    [sym_operator_assignment] = STATE(10427),
    [sym_conditional] = STATE(10427),
    [sym_range] = STATE(10427),
    [sym_binary] = STATE(10427),
    [sym_unary] = STATE(10427),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9454] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10428),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7696),
    [sym_scope_resolution] = STATE(7694),
    [sym_call] = STATE(7694),
    [sym_method_call] = STATE(7696),
    [sym_assignment] = STATE(10428),
    [sym_operator_assignment] = STATE(10428),
    [sym_conditional] = STATE(10428),
    [sym_range] = STATE(10428),
    [sym_binary] = STATE(10428),
    [sym_unary] = STATE(10428),
    [sym_left_assignment_list] = STATE(7695),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7696),
    [sym__variable] = STATE(7694),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7696),
    [sym_false] = STATE(7696),
    [sym_nil] = STATE(7696),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7697),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11244),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11246),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_break] = ACTIONS(11250),
    [anon_sym_next] = ACTIONS(11252),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11254),
    [anon_sym_defined_QMARK] = ACTIONS(11256),
    [anon_sym_not] = ACTIONS(11258),
    [anon_sym_BANG] = ACTIONS(11260),
    [anon_sym_TILDE] = ACTIONS(11260),
    [sym_constant] = ACTIONS(11262),
    [sym_identifier] = ACTIONS(11262),
    [sym_instance_variable] = ACTIONS(11264),
    [sym_class_variable] = ACTIONS(11264),
    [sym_global_variable] = ACTIONS(11264),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11262),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11262),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [9455] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10429),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7696),
    [sym_scope_resolution] = STATE(7694),
    [sym_call] = STATE(7694),
    [sym_method_call] = STATE(7696),
    [sym_assignment] = STATE(10429),
    [sym_operator_assignment] = STATE(10429),
    [sym_conditional] = STATE(10429),
    [sym_range] = STATE(10429),
    [sym_binary] = STATE(10429),
    [sym_unary] = STATE(10429),
    [sym_left_assignment_list] = STATE(7695),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7696),
    [sym__variable] = STATE(7694),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7696),
    [sym_false] = STATE(7696),
    [sym_nil] = STATE(7696),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7697),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11244),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11246),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_break] = ACTIONS(11250),
    [anon_sym_next] = ACTIONS(11252),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11254),
    [anon_sym_defined_QMARK] = ACTIONS(11256),
    [anon_sym_not] = ACTIONS(11258),
    [anon_sym_BANG] = ACTIONS(11260),
    [anon_sym_TILDE] = ACTIONS(11260),
    [sym_constant] = ACTIONS(11262),
    [sym_identifier] = ACTIONS(11262),
    [sym_instance_variable] = ACTIONS(11264),
    [sym_class_variable] = ACTIONS(11264),
    [sym_global_variable] = ACTIONS(11264),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11262),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11262),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [9456] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10430),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7696),
    [sym_scope_resolution] = STATE(7694),
    [sym_call] = STATE(7694),
    [sym_method_call] = STATE(7696),
    [sym_assignment] = STATE(10430),
    [sym_operator_assignment] = STATE(10430),
    [sym_conditional] = STATE(10430),
    [sym_range] = STATE(10430),
    [sym_binary] = STATE(10430),
    [sym_unary] = STATE(10430),
    [sym_left_assignment_list] = STATE(7695),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7696),
    [sym__variable] = STATE(7694),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7696),
    [sym_false] = STATE(7696),
    [sym_nil] = STATE(7696),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7697),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11244),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11246),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_break] = ACTIONS(11250),
    [anon_sym_next] = ACTIONS(11252),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11254),
    [anon_sym_defined_QMARK] = ACTIONS(11256),
    [anon_sym_not] = ACTIONS(11258),
    [anon_sym_BANG] = ACTIONS(11260),
    [anon_sym_TILDE] = ACTIONS(11260),
    [sym_constant] = ACTIONS(11262),
    [sym_identifier] = ACTIONS(11262),
    [sym_instance_variable] = ACTIONS(11264),
    [sym_class_variable] = ACTIONS(11264),
    [sym_global_variable] = ACTIONS(11264),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11262),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11262),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [9457] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10431),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7696),
    [sym_scope_resolution] = STATE(7694),
    [sym_call] = STATE(7694),
    [sym_method_call] = STATE(7696),
    [sym_assignment] = STATE(10431),
    [sym_operator_assignment] = STATE(10431),
    [sym_conditional] = STATE(10431),
    [sym_range] = STATE(10431),
    [sym_binary] = STATE(10431),
    [sym_unary] = STATE(10431),
    [sym_left_assignment_list] = STATE(7695),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7696),
    [sym__variable] = STATE(7694),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7696),
    [sym_false] = STATE(7696),
    [sym_nil] = STATE(7696),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7697),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11244),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11246),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_break] = ACTIONS(11250),
    [anon_sym_next] = ACTIONS(11252),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11254),
    [anon_sym_defined_QMARK] = ACTIONS(11256),
    [anon_sym_not] = ACTIONS(11258),
    [anon_sym_BANG] = ACTIONS(11260),
    [anon_sym_TILDE] = ACTIONS(11260),
    [sym_constant] = ACTIONS(11262),
    [sym_identifier] = ACTIONS(11262),
    [sym_instance_variable] = ACTIONS(11264),
    [sym_class_variable] = ACTIONS(11264),
    [sym_global_variable] = ACTIONS(11264),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11262),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11262),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [9458] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10432),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7696),
    [sym_scope_resolution] = STATE(7694),
    [sym_call] = STATE(7694),
    [sym_method_call] = STATE(7696),
    [sym_splat_argument] = STATE(10433),
    [sym_assignment] = STATE(10432),
    [sym_operator_assignment] = STATE(10432),
    [sym_conditional] = STATE(10432),
    [sym_range] = STATE(10432),
    [sym_binary] = STATE(10432),
    [sym_unary] = STATE(10432),
    [sym_right_assignment_list] = STATE(6323),
    [sym__arg_or_splat_arg] = STATE(10433),
    [sym_left_assignment_list] = STATE(7695),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7696),
    [sym__variable] = STATE(7694),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7696),
    [sym_false] = STATE(7696),
    [sym_nil] = STATE(7696),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7697),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__splat_star] = ACTIONS(8250),
    [sym__unary_minus] = ACTIONS(11244),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11246),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_break] = ACTIONS(11250),
    [anon_sym_next] = ACTIONS(11252),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11254),
    [anon_sym_defined_QMARK] = ACTIONS(11256),
    [anon_sym_not] = ACTIONS(11258),
    [anon_sym_BANG] = ACTIONS(11260),
    [anon_sym_TILDE] = ACTIONS(11260),
    [sym_constant] = ACTIONS(11262),
    [sym_identifier] = ACTIONS(11262),
    [sym_instance_variable] = ACTIONS(11264),
    [sym_class_variable] = ACTIONS(11264),
    [sym_global_variable] = ACTIONS(11264),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11262),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11262),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [9459] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10434),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7696),
    [sym_scope_resolution] = STATE(7694),
    [sym_call] = STATE(7694),
    [sym_method_call] = STATE(7696),
    [sym_assignment] = STATE(10434),
    [sym_operator_assignment] = STATE(10434),
    [sym_conditional] = STATE(10434),
    [sym_range] = STATE(10434),
    [sym_binary] = STATE(10434),
    [sym_unary] = STATE(10434),
    [sym_left_assignment_list] = STATE(7695),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7696),
    [sym__variable] = STATE(7694),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7696),
    [sym_false] = STATE(7696),
    [sym_nil] = STATE(7696),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7697),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11244),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11246),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_break] = ACTIONS(11250),
    [anon_sym_next] = ACTIONS(11252),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11254),
    [anon_sym_defined_QMARK] = ACTIONS(11256),
    [anon_sym_not] = ACTIONS(11258),
    [anon_sym_BANG] = ACTIONS(11260),
    [anon_sym_TILDE] = ACTIONS(11260),
    [sym_constant] = ACTIONS(11262),
    [sym_identifier] = ACTIONS(11262),
    [sym_instance_variable] = ACTIONS(11264),
    [sym_class_variable] = ACTIONS(11264),
    [sym_global_variable] = ACTIONS(11264),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11262),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11262),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [9460] = {
    [sym_string] = STATE(10435),
    [aux_sym_chained_string_repeat1] = STATE(10435),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(2551),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2755),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_EQ] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_end] = ACTIONS(2753),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_else] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_PLUS_EQ] = ACTIONS(2753),
    [anon_sym_DASH_EQ] = ACTIONS(2753),
    [anon_sym_STAR_EQ] = ACTIONS(2753),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2753),
    [anon_sym_SLASH_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2753),
    [anon_sym_AMP_EQ] = ACTIONS(2753),
    [anon_sym_PERCENT_EQ] = ACTIONS(2753),
    [anon_sym_GT_GT_EQ] = ACTIONS(2753),
    [anon_sym_LT_LT_EQ] = ACTIONS(2753),
    [anon_sym_CARET_EQ] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2755),
    [anon_sym_AMP_AMP] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2755),
    [anon_sym_GT_GT] = ACTIONS(2755),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_SLASH] = ACTIONS(2755),
    [anon_sym_PERCENT] = ACTIONS(2755),
    [sym_comment] = ACTIONS(87),
  },
  [9461] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(13085),
    [sym__binary_star] = ACTIONS(13087),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(13089),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(13091),
    [anon_sym_AMP] = ACTIONS(13093),
    [anon_sym_EQ] = ACTIONS(7822),
    [anon_sym_LT] = ACTIONS(13095),
    [anon_sym_end] = ACTIONS(6823),
    [anon_sym_if] = ACTIONS(6823),
    [anon_sym_unless] = ACTIONS(6823),
    [anon_sym_while] = ACTIONS(6823),
    [anon_sym_until] = ACTIONS(6823),
    [anon_sym_rescue] = ACTIONS(6823),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_else] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_PLUS_EQ] = ACTIONS(6823),
    [anon_sym_DASH_EQ] = ACTIONS(6823),
    [anon_sym_STAR_EQ] = ACTIONS(6823),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6823),
    [anon_sym_SLASH_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6823),
    [anon_sym_AMP_EQ] = ACTIONS(6823),
    [anon_sym_PERCENT_EQ] = ACTIONS(6823),
    [anon_sym_GT_GT_EQ] = ACTIONS(6823),
    [anon_sym_LT_LT_EQ] = ACTIONS(6823),
    [anon_sym_CARET_EQ] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(13097),
    [anon_sym_DOT_DOT] = ACTIONS(13099),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13101),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(13103),
    [anon_sym_AMP_AMP] = ACTIONS(13103),
    [anon_sym_LT_LT] = ACTIONS(13105),
    [anon_sym_GT_GT] = ACTIONS(13105),
    [anon_sym_EQ_EQ] = ACTIONS(13103),
    [anon_sym_BANG_EQ] = ACTIONS(13107),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13107),
    [anon_sym_LT_EQ_GT] = ACTIONS(13107),
    [anon_sym_EQ_TILDE] = ACTIONS(13107),
    [anon_sym_BANG_TILDE] = ACTIONS(13107),
    [anon_sym_LT_EQ] = ACTIONS(13095),
    [anon_sym_GT] = ACTIONS(13095),
    [anon_sym_GT_EQ] = ACTIONS(13109),
    [anon_sym_CARET] = ACTIONS(13089),
    [anon_sym_PLUS] = ACTIONS(13111),
    [anon_sym_SLASH] = ACTIONS(13091),
    [anon_sym_PERCENT] = ACTIONS(13091),
    [sym_comment] = ACTIONS(87),
  },
  [9462] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(13085),
    [sym__binary_star] = ACTIONS(13087),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(13089),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(13091),
    [anon_sym_AMP] = ACTIONS(13093),
    [anon_sym_EQ] = ACTIONS(7884),
    [anon_sym_LT] = ACTIONS(13095),
    [anon_sym_end] = ACTIONS(7027),
    [anon_sym_if] = ACTIONS(7027),
    [anon_sym_unless] = ACTIONS(7027),
    [anon_sym_while] = ACTIONS(7027),
    [anon_sym_until] = ACTIONS(7027),
    [anon_sym_rescue] = ACTIONS(7027),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_else] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_PLUS_EQ] = ACTIONS(7027),
    [anon_sym_DASH_EQ] = ACTIONS(7027),
    [anon_sym_STAR_EQ] = ACTIONS(7027),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7027),
    [anon_sym_SLASH_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7027),
    [anon_sym_AMP_EQ] = ACTIONS(7027),
    [anon_sym_PERCENT_EQ] = ACTIONS(7027),
    [anon_sym_GT_GT_EQ] = ACTIONS(7027),
    [anon_sym_LT_LT_EQ] = ACTIONS(7027),
    [anon_sym_CARET_EQ] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(13097),
    [anon_sym_DOT_DOT] = ACTIONS(13099),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13101),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(13103),
    [anon_sym_AMP_AMP] = ACTIONS(13103),
    [anon_sym_LT_LT] = ACTIONS(13105),
    [anon_sym_GT_GT] = ACTIONS(13105),
    [anon_sym_EQ_EQ] = ACTIONS(13103),
    [anon_sym_BANG_EQ] = ACTIONS(13107),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13107),
    [anon_sym_LT_EQ_GT] = ACTIONS(13107),
    [anon_sym_EQ_TILDE] = ACTIONS(13107),
    [anon_sym_BANG_TILDE] = ACTIONS(13107),
    [anon_sym_LT_EQ] = ACTIONS(13095),
    [anon_sym_GT] = ACTIONS(13095),
    [anon_sym_GT_EQ] = ACTIONS(13109),
    [anon_sym_CARET] = ACTIONS(13089),
    [anon_sym_PLUS] = ACTIONS(13111),
    [anon_sym_SLASH] = ACTIONS(13091),
    [anon_sym_PERCENT] = ACTIONS(13091),
    [sym_comment] = ACTIONS(87),
  },
  [9463] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(11274),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11278),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(11278),
    [anon_sym_PERCENT] = ACTIONS(11278),
    [sym_comment] = ACTIONS(87),
  },
  [9464] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11278),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(5827),
    [anon_sym_PERCENT] = ACTIONS(5827),
    [sym_comment] = ACTIONS(87),
  },
  [9465] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11272),
    [sym__binary_star] = ACTIONS(11274),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11278),
    [anon_sym_AMP] = ACTIONS(11280),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(11292),
    [anon_sym_GT_GT] = ACTIONS(11292),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(11298),
    [anon_sym_SLASH] = ACTIONS(11278),
    [anon_sym_PERCENT] = ACTIONS(11278),
    [sym_comment] = ACTIONS(87),
  },
  [9466] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11272),
    [sym__binary_star] = ACTIONS(11274),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11278),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(11292),
    [anon_sym_GT_GT] = ACTIONS(11292),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(11298),
    [anon_sym_SLASH] = ACTIONS(11278),
    [anon_sym_PERCENT] = ACTIONS(11278),
    [sym_comment] = ACTIONS(87),
  },
  [9467] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11272),
    [sym__binary_star] = ACTIONS(11274),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(11276),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11278),
    [anon_sym_AMP] = ACTIONS(11280),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(11292),
    [anon_sym_GT_GT] = ACTIONS(11292),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(11276),
    [anon_sym_PLUS] = ACTIONS(11298),
    [anon_sym_SLASH] = ACTIONS(11278),
    [anon_sym_PERCENT] = ACTIONS(11278),
    [sym_comment] = ACTIONS(87),
  },
  [9468] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(14118),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [9469] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(11272),
    [sym__binary_star] = ACTIONS(11274),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(11276),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(11278),
    [anon_sym_AMP] = ACTIONS(11280),
    [anon_sym_EQ] = ACTIONS(7888),
    [anon_sym_LT] = ACTIONS(11282),
    [anon_sym_end] = ACTIONS(5927),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_else] = ACTIONS(5927),
    [anon_sym_EQ_GT] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_PLUS_EQ] = ACTIONS(5927),
    [anon_sym_DASH_EQ] = ACTIONS(5927),
    [anon_sym_STAR_EQ] = ACTIONS(5927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5927),
    [anon_sym_SLASH_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5927),
    [anon_sym_AMP_EQ] = ACTIONS(5927),
    [anon_sym_PERCENT_EQ] = ACTIONS(5927),
    [anon_sym_GT_GT_EQ] = ACTIONS(5927),
    [anon_sym_LT_LT_EQ] = ACTIONS(5927),
    [anon_sym_CARET_EQ] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(11286),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11288),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(11290),
    [anon_sym_AMP_AMP] = ACTIONS(11290),
    [anon_sym_LT_LT] = ACTIONS(11292),
    [anon_sym_GT_GT] = ACTIONS(11292),
    [anon_sym_EQ_EQ] = ACTIONS(11290),
    [anon_sym_BANG_EQ] = ACTIONS(11294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11294),
    [anon_sym_LT_EQ_GT] = ACTIONS(11294),
    [anon_sym_EQ_TILDE] = ACTIONS(11294),
    [anon_sym_BANG_TILDE] = ACTIONS(11294),
    [anon_sym_LT_EQ] = ACTIONS(11282),
    [anon_sym_GT] = ACTIONS(11282),
    [anon_sym_GT_EQ] = ACTIONS(11296),
    [anon_sym_CARET] = ACTIONS(11276),
    [anon_sym_PLUS] = ACTIONS(11298),
    [anon_sym_SLASH] = ACTIONS(11278),
    [anon_sym_PERCENT] = ACTIONS(11278),
    [sym_comment] = ACTIONS(87),
  },
  [9470] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11272),
    [sym__binary_star] = ACTIONS(11274),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(11276),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11278),
    [anon_sym_AMP] = ACTIONS(11280),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(11282),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(11284),
    [anon_sym_DOT_DOT] = ACTIONS(11286),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11288),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(11290),
    [anon_sym_AMP_AMP] = ACTIONS(11290),
    [anon_sym_LT_LT] = ACTIONS(11292),
    [anon_sym_GT_GT] = ACTIONS(11292),
    [anon_sym_EQ_EQ] = ACTIONS(11290),
    [anon_sym_BANG_EQ] = ACTIONS(11294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11294),
    [anon_sym_LT_EQ_GT] = ACTIONS(11294),
    [anon_sym_EQ_TILDE] = ACTIONS(11294),
    [anon_sym_BANG_TILDE] = ACTIONS(11294),
    [anon_sym_LT_EQ] = ACTIONS(11282),
    [anon_sym_GT] = ACTIONS(11282),
    [anon_sym_GT_EQ] = ACTIONS(11296),
    [anon_sym_CARET] = ACTIONS(11276),
    [anon_sym_PLUS] = ACTIONS(11298),
    [anon_sym_SLASH] = ACTIONS(11278),
    [anon_sym_PERCENT] = ACTIONS(11278),
    [sym_comment] = ACTIONS(87),
  },
  [9471] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11272),
    [sym__binary_star] = ACTIONS(11274),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(11276),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11278),
    [anon_sym_AMP] = ACTIONS(11280),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(11282),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(11292),
    [anon_sym_GT_GT] = ACTIONS(11292),
    [anon_sym_EQ_EQ] = ACTIONS(11290),
    [anon_sym_BANG_EQ] = ACTIONS(11294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11294),
    [anon_sym_LT_EQ_GT] = ACTIONS(11294),
    [anon_sym_EQ_TILDE] = ACTIONS(11294),
    [anon_sym_BANG_TILDE] = ACTIONS(11294),
    [anon_sym_LT_EQ] = ACTIONS(11282),
    [anon_sym_GT] = ACTIONS(11282),
    [anon_sym_GT_EQ] = ACTIONS(11296),
    [anon_sym_CARET] = ACTIONS(11276),
    [anon_sym_PLUS] = ACTIONS(11298),
    [anon_sym_SLASH] = ACTIONS(11278),
    [anon_sym_PERCENT] = ACTIONS(11278),
    [sym_comment] = ACTIONS(87),
  },
  [9472] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11272),
    [sym__binary_star] = ACTIONS(11274),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11278),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(11298),
    [anon_sym_SLASH] = ACTIONS(11278),
    [anon_sym_PERCENT] = ACTIONS(11278),
    [sym_comment] = ACTIONS(87),
  },
  [9473] = {
    [sym_heredoc_body] = STATE(9473),
    [aux_sym_call_repeat1] = STATE(9473),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(9846),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7919),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_EQ] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_end] = ACTIONS(7914),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_else] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_PLUS_EQ] = ACTIONS(7914),
    [anon_sym_DASH_EQ] = ACTIONS(7914),
    [anon_sym_STAR_EQ] = ACTIONS(7914),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7914),
    [anon_sym_SLASH_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7914),
    [anon_sym_AMP_EQ] = ACTIONS(7914),
    [anon_sym_PERCENT_EQ] = ACTIONS(7914),
    [anon_sym_GT_GT_EQ] = ACTIONS(7914),
    [anon_sym_LT_LT_EQ] = ACTIONS(7914),
    [anon_sym_CARET_EQ] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7919),
    [anon_sym_AMP_AMP] = ACTIONS(7919),
    [anon_sym_LT_LT] = ACTIONS(7919),
    [anon_sym_GT_GT] = ACTIONS(7919),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7919),
    [anon_sym_PLUS] = ACTIONS(7919),
    [anon_sym_SLASH] = ACTIONS(7919),
    [anon_sym_PERCENT] = ACTIONS(7919),
    [sym_comment] = ACTIONS(87),
  },
  [9474] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5209),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5214),
    [sym_scope_resolution] = STATE(5210),
    [sym_call] = STATE(5210),
    [sym_method_call] = STATE(5214),
    [sym__argument] = STATE(6393),
    [sym_splat_argument] = STATE(6393),
    [sym_hash_splat_argument] = STATE(6393),
    [sym_block_argument] = STATE(6393),
    [sym_assignment] = STATE(5209),
    [sym_operator_assignment] = STATE(5209),
    [sym_conditional] = STATE(5209),
    [sym_range] = STATE(5209),
    [sym_binary] = STATE(5209),
    [sym_unary] = STATE(5209),
    [sym_left_assignment_list] = STATE(5213),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5214),
    [sym__variable] = STATE(5210),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5214),
    [sym_false] = STATE(5214),
    [sym_nil] = STATE(5214),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5215),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(6393),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(8248),
    [sym__splat_star] = ACTIONS(8250),
    [sym__unary_minus] = ACTIONS(8252),
    [sym__identifier_hash_key] = ACTIONS(8254),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13119),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(8256),
    [anon_sym_yield] = ACTIONS(8258),
    [anon_sym_break] = ACTIONS(8260),
    [anon_sym_next] = ACTIONS(8262),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(11266),
    [anon_sym_defined_QMARK] = ACTIONS(8264),
    [anon_sym_not] = ACTIONS(8266),
    [anon_sym_BANG] = ACTIONS(8270),
    [anon_sym_TILDE] = ACTIONS(8270),
    [sym_constant] = ACTIONS(8272),
    [sym_identifier] = ACTIONS(8272),
    [sym_instance_variable] = ACTIONS(8274),
    [sym_class_variable] = ACTIONS(8274),
    [sym_global_variable] = ACTIONS(8274),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8276),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8276),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [9475] = {
    [sym_heredoc_body] = STATE(9473),
    [aux_sym_call_repeat1] = STATE(9473),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7931),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_EQ] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_end] = ACTIONS(7929),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_else] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_PLUS_EQ] = ACTIONS(7929),
    [anon_sym_DASH_EQ] = ACTIONS(7929),
    [anon_sym_STAR_EQ] = ACTIONS(7929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7929),
    [anon_sym_SLASH_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7929),
    [anon_sym_AMP_EQ] = ACTIONS(7929),
    [anon_sym_PERCENT_EQ] = ACTIONS(7929),
    [anon_sym_GT_GT_EQ] = ACTIONS(7929),
    [anon_sym_LT_LT_EQ] = ACTIONS(7929),
    [anon_sym_CARET_EQ] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7931),
    [anon_sym_AMP_AMP] = ACTIONS(7931),
    [anon_sym_LT_LT] = ACTIONS(7931),
    [anon_sym_GT_GT] = ACTIONS(7931),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7931),
    [anon_sym_PLUS] = ACTIONS(7931),
    [anon_sym_SLASH] = ACTIONS(7931),
    [anon_sym_PERCENT] = ACTIONS(7931),
    [sym_comment] = ACTIONS(87),
  },
  [9476] = {
    [aux_sym_argument_list_repeat1] = STATE(9476),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(14120),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7927),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_EQ] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_end] = ACTIONS(7925),
    [anon_sym_if] = ACTIONS(7925),
    [anon_sym_unless] = ACTIONS(7925),
    [anon_sym_while] = ACTIONS(7925),
    [anon_sym_until] = ACTIONS(7925),
    [anon_sym_rescue] = ACTIONS(7925),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_else] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_PLUS_EQ] = ACTIONS(7925),
    [anon_sym_DASH_EQ] = ACTIONS(7925),
    [anon_sym_STAR_EQ] = ACTIONS(7925),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7925),
    [anon_sym_SLASH_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7925),
    [anon_sym_AMP_EQ] = ACTIONS(7925),
    [anon_sym_PERCENT_EQ] = ACTIONS(7925),
    [anon_sym_GT_GT_EQ] = ACTIONS(7925),
    [anon_sym_LT_LT_EQ] = ACTIONS(7925),
    [anon_sym_CARET_EQ] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7927),
    [anon_sym_AMP_AMP] = ACTIONS(7927),
    [anon_sym_LT_LT] = ACTIONS(7927),
    [anon_sym_GT_GT] = ACTIONS(7927),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7927),
    [anon_sym_PLUS] = ACTIONS(7927),
    [anon_sym_SLASH] = ACTIONS(7927),
    [anon_sym_PERCENT] = ACTIONS(7927),
    [sym_comment] = ACTIONS(87),
  },
  [9477] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(11272),
    [sym__binary_star] = ACTIONS(11274),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(11276),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(11278),
    [anon_sym_AMP] = ACTIONS(11280),
    [anon_sym_EQ] = ACTIONS(7936),
    [anon_sym_LT] = ACTIONS(11282),
    [anon_sym_end] = ACTIONS(5115),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_else] = ACTIONS(5115),
    [anon_sym_EQ_GT] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_PLUS_EQ] = ACTIONS(5115),
    [anon_sym_DASH_EQ] = ACTIONS(5115),
    [anon_sym_STAR_EQ] = ACTIONS(5115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5115),
    [anon_sym_SLASH_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5115),
    [anon_sym_AMP_EQ] = ACTIONS(5115),
    [anon_sym_PERCENT_EQ] = ACTIONS(5115),
    [anon_sym_GT_GT_EQ] = ACTIONS(5115),
    [anon_sym_LT_LT_EQ] = ACTIONS(5115),
    [anon_sym_CARET_EQ] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(11284),
    [anon_sym_DOT_DOT] = ACTIONS(11286),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11288),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(11290),
    [anon_sym_AMP_AMP] = ACTIONS(11290),
    [anon_sym_LT_LT] = ACTIONS(11292),
    [anon_sym_GT_GT] = ACTIONS(11292),
    [anon_sym_EQ_EQ] = ACTIONS(11290),
    [anon_sym_BANG_EQ] = ACTIONS(11294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11294),
    [anon_sym_LT_EQ_GT] = ACTIONS(11294),
    [anon_sym_EQ_TILDE] = ACTIONS(11294),
    [anon_sym_BANG_TILDE] = ACTIONS(11294),
    [anon_sym_LT_EQ] = ACTIONS(11282),
    [anon_sym_GT] = ACTIONS(11282),
    [anon_sym_GT_EQ] = ACTIONS(11296),
    [anon_sym_CARET] = ACTIONS(11276),
    [anon_sym_PLUS] = ACTIONS(11298),
    [anon_sym_SLASH] = ACTIONS(11278),
    [anon_sym_PERCENT] = ACTIONS(11278),
    [sym_comment] = ACTIONS(87),
  },
  [9478] = {
    [aux_sym_exceptions_repeat1] = STATE(10438),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6193),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_end] = ACTIONS(6191),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_else] = ACTIONS(6191),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_PLUS_EQ] = ACTIONS(6191),
    [anon_sym_DASH_EQ] = ACTIONS(6191),
    [anon_sym_STAR_EQ] = ACTIONS(6191),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6191),
    [anon_sym_SLASH_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6191),
    [anon_sym_AMP_EQ] = ACTIONS(6191),
    [anon_sym_PERCENT_EQ] = ACTIONS(6191),
    [anon_sym_GT_GT_EQ] = ACTIONS(6191),
    [anon_sym_LT_LT_EQ] = ACTIONS(6191),
    [anon_sym_CARET_EQ] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6193),
    [anon_sym_AMP_AMP] = ACTIONS(6193),
    [anon_sym_LT_LT] = ACTIONS(6193),
    [anon_sym_GT_GT] = ACTIONS(6193),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6193),
    [anon_sym_PLUS] = ACTIONS(6193),
    [anon_sym_SLASH] = ACTIONS(6193),
    [anon_sym_PERCENT] = ACTIONS(6193),
    [sym_comment] = ACTIONS(87),
  },
  [9479] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(11272),
    [sym__binary_star] = ACTIONS(11274),
    [anon_sym_LBRACE] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(11276),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(11278),
    [anon_sym_AMP] = ACTIONS(11280),
    [anon_sym_EQ] = ACTIONS(7938),
    [anon_sym_LT] = ACTIONS(11282),
    [anon_sym_end] = ACTIONS(6210),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_else] = ACTIONS(6210),
    [anon_sym_EQ_GT] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_PLUS_EQ] = ACTIONS(6210),
    [anon_sym_DASH_EQ] = ACTIONS(6210),
    [anon_sym_STAR_EQ] = ACTIONS(6210),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6210),
    [anon_sym_SLASH_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6210),
    [anon_sym_AMP_EQ] = ACTIONS(6210),
    [anon_sym_PERCENT_EQ] = ACTIONS(6210),
    [anon_sym_GT_GT_EQ] = ACTIONS(6210),
    [anon_sym_LT_LT_EQ] = ACTIONS(6210),
    [anon_sym_CARET_EQ] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(11284),
    [anon_sym_DOT_DOT] = ACTIONS(11286),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11288),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(11290),
    [anon_sym_AMP_AMP] = ACTIONS(11290),
    [anon_sym_LT_LT] = ACTIONS(11292),
    [anon_sym_GT_GT] = ACTIONS(11292),
    [anon_sym_EQ_EQ] = ACTIONS(11290),
    [anon_sym_BANG_EQ] = ACTIONS(11294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11294),
    [anon_sym_LT_EQ_GT] = ACTIONS(11294),
    [anon_sym_EQ_TILDE] = ACTIONS(11294),
    [anon_sym_BANG_TILDE] = ACTIONS(11294),
    [anon_sym_LT_EQ] = ACTIONS(11282),
    [anon_sym_GT] = ACTIONS(11282),
    [anon_sym_GT_EQ] = ACTIONS(11296),
    [anon_sym_CARET] = ACTIONS(11276),
    [anon_sym_PLUS] = ACTIONS(11298),
    [anon_sym_SLASH] = ACTIONS(11278),
    [anon_sym_PERCENT] = ACTIONS(11278),
    [sym_comment] = ACTIONS(87),
  },
  [9480] = {
    [sym_string] = STATE(9480),
    [aux_sym_chained_string_repeat1] = STATE(9480),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(9852),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6217),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_EQ] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_end] = ACTIONS(6212),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_do] = ACTIONS(6212),
    [anon_sym_else] = ACTIONS(6212),
    [anon_sym_EQ_GT] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_PLUS_EQ] = ACTIONS(6212),
    [anon_sym_DASH_EQ] = ACTIONS(6212),
    [anon_sym_STAR_EQ] = ACTIONS(6212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6212),
    [anon_sym_SLASH_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6212),
    [anon_sym_AMP_EQ] = ACTIONS(6212),
    [anon_sym_PERCENT_EQ] = ACTIONS(6212),
    [anon_sym_GT_GT_EQ] = ACTIONS(6212),
    [anon_sym_LT_LT_EQ] = ACTIONS(6212),
    [anon_sym_CARET_EQ] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6217),
    [anon_sym_AMP_AMP] = ACTIONS(6217),
    [anon_sym_LT_LT] = ACTIONS(6217),
    [anon_sym_GT_GT] = ACTIONS(6217),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6217),
    [anon_sym_PLUS] = ACTIONS(6217),
    [anon_sym_SLASH] = ACTIONS(6217),
    [anon_sym_PERCENT] = ACTIONS(6217),
    [sym_comment] = ACTIONS(87),
  },
  [9481] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(13121),
    [sym__binary_star] = ACTIONS(13123),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(13125),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(13123),
    [anon_sym_AMP] = ACTIONS(13127),
    [anon_sym_LT] = ACTIONS(13129),
    [anon_sym_end] = ACTIONS(4247),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_else] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(13131),
    [anon_sym_DOT_DOT] = ACTIONS(13133),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13135),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(13137),
    [anon_sym_AMP_AMP] = ACTIONS(13137),
    [anon_sym_LT_LT] = ACTIONS(13139),
    [anon_sym_GT_GT] = ACTIONS(13139),
    [anon_sym_EQ_EQ] = ACTIONS(13141),
    [anon_sym_BANG_EQ] = ACTIONS(13137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13137),
    [anon_sym_LT_EQ_GT] = ACTIONS(13137),
    [anon_sym_EQ_TILDE] = ACTIONS(13137),
    [anon_sym_BANG_TILDE] = ACTIONS(13137),
    [anon_sym_LT_EQ] = ACTIONS(13129),
    [anon_sym_GT] = ACTIONS(13129),
    [anon_sym_GT_EQ] = ACTIONS(13143),
    [anon_sym_CARET] = ACTIONS(13145),
    [anon_sym_PLUS] = ACTIONS(13121),
    [anon_sym_SLASH] = ACTIONS(13123),
    [anon_sym_PERCENT] = ACTIONS(13123),
    [sym_comment] = ACTIONS(87),
  },
  [9482] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(13123),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [9483] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(13121),
    [sym__binary_star] = ACTIONS(13123),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(13125),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(13123),
    [anon_sym_AMP] = ACTIONS(13127),
    [anon_sym_LT] = ACTIONS(13129),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(13131),
    [anon_sym_DOT_DOT] = ACTIONS(13133),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13135),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(13137),
    [anon_sym_AMP_AMP] = ACTIONS(13137),
    [anon_sym_LT_LT] = ACTIONS(13139),
    [anon_sym_GT_GT] = ACTIONS(13139),
    [anon_sym_EQ_EQ] = ACTIONS(13141),
    [anon_sym_BANG_EQ] = ACTIONS(13137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13137),
    [anon_sym_LT_EQ_GT] = ACTIONS(13137),
    [anon_sym_EQ_TILDE] = ACTIONS(13137),
    [anon_sym_BANG_TILDE] = ACTIONS(13137),
    [anon_sym_LT_EQ] = ACTIONS(13129),
    [anon_sym_GT] = ACTIONS(13129),
    [anon_sym_GT_EQ] = ACTIONS(13143),
    [anon_sym_CARET] = ACTIONS(13145),
    [anon_sym_PLUS] = ACTIONS(13121),
    [anon_sym_SLASH] = ACTIONS(13123),
    [anon_sym_PERCENT] = ACTIONS(13123),
    [sym_comment] = ACTIONS(87),
  },
  [9484] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10439),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7728),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(7728),
    [sym_assignment] = STATE(10439),
    [sym_operator_assignment] = STATE(10439),
    [sym_conditional] = STATE(10439),
    [sym_range] = STATE(10439),
    [sym_binary] = STATE(10439),
    [sym_unary] = STATE(10439),
    [sym_left_assignment_list] = STATE(7727),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7728),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7728),
    [sym_false] = STATE(7728),
    [sym_nil] = STATE(7728),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7628),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11312),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11170),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_break] = ACTIONS(11174),
    [anon_sym_next] = ACTIONS(11176),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11314),
    [anon_sym_defined_QMARK] = ACTIONS(11316),
    [anon_sym_not] = ACTIONS(11318),
    [anon_sym_BANG] = ACTIONS(11320),
    [anon_sym_TILDE] = ACTIONS(11320),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9485] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10440),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7728),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(7728),
    [sym_assignment] = STATE(10440),
    [sym_operator_assignment] = STATE(10440),
    [sym_conditional] = STATE(10440),
    [sym_range] = STATE(10440),
    [sym_binary] = STATE(10440),
    [sym_unary] = STATE(10440),
    [sym_left_assignment_list] = STATE(7727),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7728),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7728),
    [sym_false] = STATE(7728),
    [sym_nil] = STATE(7728),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7628),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11312),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11170),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_break] = ACTIONS(11174),
    [anon_sym_next] = ACTIONS(11176),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11314),
    [anon_sym_defined_QMARK] = ACTIONS(11316),
    [anon_sym_not] = ACTIONS(11318),
    [anon_sym_BANG] = ACTIONS(11320),
    [anon_sym_TILDE] = ACTIONS(11320),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9486] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10441),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7728),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(7728),
    [sym_assignment] = STATE(10441),
    [sym_operator_assignment] = STATE(10441),
    [sym_conditional] = STATE(10441),
    [sym_range] = STATE(10441),
    [sym_binary] = STATE(10441),
    [sym_unary] = STATE(10441),
    [sym_left_assignment_list] = STATE(7727),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7728),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7728),
    [sym_false] = STATE(7728),
    [sym_nil] = STATE(7728),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7628),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11312),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11170),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_break] = ACTIONS(11174),
    [anon_sym_next] = ACTIONS(11176),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11314),
    [anon_sym_defined_QMARK] = ACTIONS(11316),
    [anon_sym_not] = ACTIONS(11318),
    [anon_sym_BANG] = ACTIONS(11320),
    [anon_sym_TILDE] = ACTIONS(11320),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9487] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10442),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7728),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(7728),
    [sym_assignment] = STATE(10442),
    [sym_operator_assignment] = STATE(10442),
    [sym_conditional] = STATE(10442),
    [sym_range] = STATE(10442),
    [sym_binary] = STATE(10442),
    [sym_unary] = STATE(10442),
    [sym_left_assignment_list] = STATE(7727),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7728),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7728),
    [sym_false] = STATE(7728),
    [sym_nil] = STATE(7728),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7628),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11312),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11170),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_break] = ACTIONS(11174),
    [anon_sym_next] = ACTIONS(11176),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11314),
    [anon_sym_defined_QMARK] = ACTIONS(11316),
    [anon_sym_not] = ACTIONS(11318),
    [anon_sym_BANG] = ACTIONS(11320),
    [anon_sym_TILDE] = ACTIONS(11320),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9488] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10443),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7728),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(7728),
    [sym_assignment] = STATE(10443),
    [sym_operator_assignment] = STATE(10443),
    [sym_conditional] = STATE(10443),
    [sym_range] = STATE(10443),
    [sym_binary] = STATE(10443),
    [sym_unary] = STATE(10443),
    [sym_left_assignment_list] = STATE(7727),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7728),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7728),
    [sym_false] = STATE(7728),
    [sym_nil] = STATE(7728),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7628),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11312),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11170),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_break] = ACTIONS(11174),
    [anon_sym_next] = ACTIONS(11176),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11314),
    [anon_sym_defined_QMARK] = ACTIONS(11316),
    [anon_sym_not] = ACTIONS(11318),
    [anon_sym_BANG] = ACTIONS(11320),
    [anon_sym_TILDE] = ACTIONS(11320),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9489] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(10444),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(10444),
    [sym_operator_assignment] = STATE(10444),
    [sym_conditional] = STATE(10444),
    [sym_range] = STATE(10444),
    [sym_binary] = STATE(10444),
    [sym_unary] = STATE(10444),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9490] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10445),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7728),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(7728),
    [sym_assignment] = STATE(10445),
    [sym_operator_assignment] = STATE(10445),
    [sym_conditional] = STATE(10445),
    [sym_range] = STATE(10445),
    [sym_binary] = STATE(10445),
    [sym_unary] = STATE(10445),
    [sym_left_assignment_list] = STATE(7727),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7728),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7728),
    [sym_false] = STATE(7728),
    [sym_nil] = STATE(7728),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7628),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11312),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11170),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_break] = ACTIONS(11174),
    [anon_sym_next] = ACTIONS(11176),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11314),
    [anon_sym_defined_QMARK] = ACTIONS(11316),
    [anon_sym_not] = ACTIONS(11318),
    [anon_sym_BANG] = ACTIONS(11320),
    [anon_sym_TILDE] = ACTIONS(11320),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9491] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10446),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7728),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(7728),
    [sym_assignment] = STATE(10446),
    [sym_operator_assignment] = STATE(10446),
    [sym_conditional] = STATE(10446),
    [sym_range] = STATE(10446),
    [sym_binary] = STATE(10446),
    [sym_unary] = STATE(10446),
    [sym_left_assignment_list] = STATE(7727),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7728),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7728),
    [sym_false] = STATE(7728),
    [sym_nil] = STATE(7728),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7628),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11312),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11170),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_break] = ACTIONS(11174),
    [anon_sym_next] = ACTIONS(11176),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11314),
    [anon_sym_defined_QMARK] = ACTIONS(11316),
    [anon_sym_not] = ACTIONS(11318),
    [anon_sym_BANG] = ACTIONS(11320),
    [anon_sym_TILDE] = ACTIONS(11320),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9492] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10447),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7728),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(7728),
    [sym_assignment] = STATE(10447),
    [sym_operator_assignment] = STATE(10447),
    [sym_conditional] = STATE(10447),
    [sym_range] = STATE(10447),
    [sym_binary] = STATE(10447),
    [sym_unary] = STATE(10447),
    [sym_left_assignment_list] = STATE(7727),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7728),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7728),
    [sym_false] = STATE(7728),
    [sym_nil] = STATE(7728),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7628),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11312),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11170),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_break] = ACTIONS(11174),
    [anon_sym_next] = ACTIONS(11176),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11314),
    [anon_sym_defined_QMARK] = ACTIONS(11316),
    [anon_sym_not] = ACTIONS(11318),
    [anon_sym_BANG] = ACTIONS(11320),
    [anon_sym_TILDE] = ACTIONS(11320),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9493] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10448),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7728),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(7728),
    [sym_assignment] = STATE(10448),
    [sym_operator_assignment] = STATE(10448),
    [sym_conditional] = STATE(10448),
    [sym_range] = STATE(10448),
    [sym_binary] = STATE(10448),
    [sym_unary] = STATE(10448),
    [sym_left_assignment_list] = STATE(7727),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7728),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7728),
    [sym_false] = STATE(7728),
    [sym_nil] = STATE(7728),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7628),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11312),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11170),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_break] = ACTIONS(11174),
    [anon_sym_next] = ACTIONS(11176),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11314),
    [anon_sym_defined_QMARK] = ACTIONS(11316),
    [anon_sym_not] = ACTIONS(11318),
    [anon_sym_BANG] = ACTIONS(11320),
    [anon_sym_TILDE] = ACTIONS(11320),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9494] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7725),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7728),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(7728),
    [sym_splat_argument] = STATE(6406),
    [sym_assignment] = STATE(7725),
    [sym_operator_assignment] = STATE(7725),
    [sym_conditional] = STATE(7725),
    [sym_range] = STATE(7725),
    [sym_binary] = STATE(7725),
    [sym_unary] = STATE(7725),
    [sym__arg_or_splat_arg] = STATE(6406),
    [sym_left_assignment_list] = STATE(7727),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7728),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7728),
    [sym_false] = STATE(7728),
    [sym_nil] = STATE(7728),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7628),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(11310),
    [sym__unary_minus] = ACTIONS(11312),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11170),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_break] = ACTIONS(11174),
    [anon_sym_next] = ACTIONS(11176),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11314),
    [anon_sym_defined_QMARK] = ACTIONS(11316),
    [anon_sym_not] = ACTIONS(11318),
    [anon_sym_BANG] = ACTIONS(11320),
    [anon_sym_TILDE] = ACTIONS(11320),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9495] = {
    [aux_sym_exceptions_repeat1] = STATE(10449),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_COMMA] = ACTIONS(13147),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_end] = ACTIONS(9855),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_else] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [9496] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7725),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7728),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(7728),
    [sym_splat_argument] = STATE(10450),
    [sym_assignment] = STATE(7725),
    [sym_operator_assignment] = STATE(7725),
    [sym_conditional] = STATE(7725),
    [sym_range] = STATE(7725),
    [sym_binary] = STATE(7725),
    [sym_unary] = STATE(7725),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(10450),
    [sym_left_assignment_list] = STATE(7727),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7728),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7728),
    [sym_false] = STATE(7728),
    [sym_nil] = STATE(7728),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7628),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(11310),
    [sym__unary_minus] = ACTIONS(11312),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11170),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_break] = ACTIONS(11174),
    [anon_sym_next] = ACTIONS(11176),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11314),
    [anon_sym_defined_QMARK] = ACTIONS(11316),
    [anon_sym_not] = ACTIONS(11318),
    [anon_sym_BANG] = ACTIONS(11320),
    [anon_sym_TILDE] = ACTIONS(11320),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9497] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10451),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7728),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(7728),
    [sym_assignment] = STATE(10451),
    [sym_operator_assignment] = STATE(10451),
    [sym_conditional] = STATE(10451),
    [sym_range] = STATE(10451),
    [sym_binary] = STATE(10451),
    [sym_unary] = STATE(10451),
    [sym_left_assignment_list] = STATE(7727),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7728),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7728),
    [sym_false] = STATE(7728),
    [sym_nil] = STATE(7728),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7628),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11312),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11170),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_break] = ACTIONS(11174),
    [anon_sym_next] = ACTIONS(11176),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11314),
    [anon_sym_defined_QMARK] = ACTIONS(11316),
    [anon_sym_not] = ACTIONS(11318),
    [anon_sym_BANG] = ACTIONS(11320),
    [anon_sym_TILDE] = ACTIONS(11320),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9498] = {
    [sym_heredoc_body] = STATE(9498),
    [aux_sym_call_repeat1] = STATE(9498),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(7916),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [9499] = {
    [sym_heredoc_body] = STATE(9498),
    [aux_sym_call_repeat1] = STATE(9498),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [9500] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10452),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2734),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2734),
    [sym_assignment] = STATE(10452),
    [sym_operator_assignment] = STATE(10452),
    [sym_conditional] = STATE(10452),
    [sym_range] = STATE(10452),
    [sym_binary] = STATE(10452),
    [sym_unary] = STATE(10452),
    [sym_left_assignment_list] = STATE(2733),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2734),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2734),
    [sym_false] = STATE(2734),
    [sym_nil] = STATE(2734),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2735),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4613),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4615),
    [anon_sym_yield] = ACTIONS(4617),
    [anon_sym_break] = ACTIONS(4619),
    [anon_sym_next] = ACTIONS(4621),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4623),
    [anon_sym_defined_QMARK] = ACTIONS(4625),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_BANG] = ACTIONS(4629),
    [anon_sym_TILDE] = ACTIONS(4629),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9501] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7743),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2734),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2734),
    [sym_splat_argument] = STATE(7439),
    [sym_assignment] = STATE(7743),
    [sym_operator_assignment] = STATE(7743),
    [sym_conditional] = STATE(7743),
    [sym_range] = STATE(7743),
    [sym_binary] = STATE(7743),
    [sym_unary] = STATE(7743),
    [sym__arg_or_splat_arg] = STATE(7439),
    [sym_left_assignment_list] = STATE(2733),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2734),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2734),
    [sym_false] = STATE(2734),
    [sym_nil] = STATE(2734),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2735),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(1825),
    [sym__unary_minus] = ACTIONS(4613),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4615),
    [anon_sym_yield] = ACTIONS(4617),
    [anon_sym_break] = ACTIONS(4619),
    [anon_sym_next] = ACTIONS(4621),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4623),
    [anon_sym_defined_QMARK] = ACTIONS(4625),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_BANG] = ACTIONS(4629),
    [anon_sym_TILDE] = ACTIONS(4629),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9502] = {
    [aux_sym_exceptions_repeat1] = STATE(10453),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(14123),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_do] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [9503] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(4645),
    [sym__binary_star] = ACTIONS(4647),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(4649),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(4647),
    [anon_sym_AMP] = ACTIONS(4651),
    [anon_sym_LT] = ACTIONS(4653),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_EQ_GT] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(4655),
    [anon_sym_DOT_DOT] = ACTIONS(4657),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4659),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(4661),
    [anon_sym_AMP_AMP] = ACTIONS(4661),
    [anon_sym_LT_LT] = ACTIONS(4663),
    [anon_sym_GT_GT] = ACTIONS(4663),
    [anon_sym_EQ_EQ] = ACTIONS(4665),
    [anon_sym_BANG_EQ] = ACTIONS(4661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4661),
    [anon_sym_LT_EQ_GT] = ACTIONS(4661),
    [anon_sym_EQ_TILDE] = ACTIONS(4661),
    [anon_sym_BANG_TILDE] = ACTIONS(4661),
    [anon_sym_LT_EQ] = ACTIONS(4653),
    [anon_sym_GT] = ACTIONS(4653),
    [anon_sym_GT_EQ] = ACTIONS(4667),
    [anon_sym_CARET] = ACTIONS(4669),
    [anon_sym_PLUS] = ACTIONS(4645),
    [anon_sym_SLASH] = ACTIONS(4647),
    [anon_sym_PERCENT] = ACTIONS(4647),
    [sym_comment] = ACTIONS(87),
  },
  [9504] = {
    [aux_sym_exceptions_repeat1] = STATE(9504),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(14125),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [9505] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10454),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2800),
    [sym_scope_resolution] = STATE(2798),
    [sym_call] = STATE(2798),
    [sym_method_call] = STATE(2800),
    [sym_assignment] = STATE(10454),
    [sym_operator_assignment] = STATE(10454),
    [sym_conditional] = STATE(10454),
    [sym_range] = STATE(10454),
    [sym_binary] = STATE(10454),
    [sym_unary] = STATE(10454),
    [sym_left_assignment_list] = STATE(2799),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2800),
    [sym__variable] = STATE(2798),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2800),
    [sym_false] = STATE(2800),
    [sym_nil] = STATE(2800),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2801),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(4693),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(4695),
    [anon_sym_yield] = ACTIONS(4697),
    [anon_sym_break] = ACTIONS(4699),
    [anon_sym_next] = ACTIONS(4701),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(4703),
    [anon_sym_defined_QMARK] = ACTIONS(4705),
    [anon_sym_not] = ACTIONS(4707),
    [anon_sym_BANG] = ACTIONS(4709),
    [anon_sym_TILDE] = ACTIONS(4709),
    [sym_constant] = ACTIONS(4711),
    [sym_identifier] = ACTIONS(4711),
    [sym_instance_variable] = ACTIONS(4713),
    [sym_class_variable] = ACTIONS(4713),
    [sym_global_variable] = ACTIONS(4713),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(4711),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4711),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [9506] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(7773),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(2800),
    [sym_scope_resolution] = STATE(2798),
    [sym_call] = STATE(2798),
    [sym_method_call] = STATE(2800),
    [sym_splat_argument] = STATE(10067),
    [sym_assignment] = STATE(7773),
    [sym_operator_assignment] = STATE(7773),
    [sym_conditional] = STATE(7773),
    [sym_range] = STATE(7773),
    [sym_binary] = STATE(7773),
    [sym_unary] = STATE(7773),
    [sym__arg_or_splat_arg] = STATE(10067),
    [sym_left_assignment_list] = STATE(2799),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2800),
    [sym__variable] = STATE(2798),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(2800),
    [sym_false] = STATE(2800),
    [sym_nil] = STATE(2800),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(2801),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__splat_star] = ACTIONS(1885),
    [sym__unary_minus] = ACTIONS(4693),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(4695),
    [anon_sym_yield] = ACTIONS(4697),
    [anon_sym_break] = ACTIONS(4699),
    [anon_sym_next] = ACTIONS(4701),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(4703),
    [anon_sym_defined_QMARK] = ACTIONS(4705),
    [anon_sym_not] = ACTIONS(4707),
    [anon_sym_BANG] = ACTIONS(4709),
    [anon_sym_TILDE] = ACTIONS(4709),
    [sym_constant] = ACTIONS(4711),
    [sym_identifier] = ACTIONS(4711),
    [sym_instance_variable] = ACTIONS(4713),
    [sym_class_variable] = ACTIONS(4713),
    [sym_global_variable] = ACTIONS(4713),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(4711),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4711),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [9507] = {
    [aux_sym_exceptions_repeat1] = STATE(10455),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_LBRACE] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(14128),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9857),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_EQ] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_do] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_PLUS_EQ] = ACTIONS(9855),
    [anon_sym_DASH_EQ] = ACTIONS(9855),
    [anon_sym_STAR_EQ] = ACTIONS(9855),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9855),
    [anon_sym_SLASH_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9855),
    [anon_sym_AMP_EQ] = ACTIONS(9855),
    [anon_sym_PERCENT_EQ] = ACTIONS(9855),
    [anon_sym_GT_GT_EQ] = ACTIONS(9855),
    [anon_sym_LT_LT_EQ] = ACTIONS(9855),
    [anon_sym_CARET_EQ] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9857),
    [anon_sym_AMP_AMP] = ACTIONS(9857),
    [anon_sym_LT_LT] = ACTIONS(9857),
    [anon_sym_GT_GT] = ACTIONS(9857),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9857),
    [anon_sym_PLUS] = ACTIONS(9857),
    [anon_sym_SLASH] = ACTIONS(9857),
    [anon_sym_PERCENT] = ACTIONS(9857),
    [sym_comment] = ACTIONS(87),
  },
  [9508] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(4723),
    [sym__binary_star] = ACTIONS(4725),
    [anon_sym_LBRACE] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(4727),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(4729),
    [anon_sym_AMP] = ACTIONS(4731),
    [anon_sym_EQ] = ACTIONS(12879),
    [anon_sym_LT] = ACTIONS(4733),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_EQ_GT] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_PLUS_EQ] = ACTIONS(12120),
    [anon_sym_DASH_EQ] = ACTIONS(12120),
    [anon_sym_STAR_EQ] = ACTIONS(12120),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12120),
    [anon_sym_SLASH_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12120),
    [anon_sym_AMP_EQ] = ACTIONS(12120),
    [anon_sym_PERCENT_EQ] = ACTIONS(12120),
    [anon_sym_GT_GT_EQ] = ACTIONS(12120),
    [anon_sym_LT_LT_EQ] = ACTIONS(12120),
    [anon_sym_CARET_EQ] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(4735),
    [anon_sym_DOT_DOT] = ACTIONS(4737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4739),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(4741),
    [anon_sym_AMP_AMP] = ACTIONS(4741),
    [anon_sym_LT_LT] = ACTIONS(4743),
    [anon_sym_GT_GT] = ACTIONS(4743),
    [anon_sym_EQ_EQ] = ACTIONS(4741),
    [anon_sym_BANG_EQ] = ACTIONS(4745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4745),
    [anon_sym_LT_EQ_GT] = ACTIONS(4745),
    [anon_sym_EQ_TILDE] = ACTIONS(4745),
    [anon_sym_BANG_TILDE] = ACTIONS(4745),
    [anon_sym_LT_EQ] = ACTIONS(4733),
    [anon_sym_GT] = ACTIONS(4733),
    [anon_sym_GT_EQ] = ACTIONS(4747),
    [anon_sym_CARET] = ACTIONS(4727),
    [anon_sym_PLUS] = ACTIONS(4749),
    [anon_sym_SLASH] = ACTIONS(4729),
    [anon_sym_PERCENT] = ACTIONS(4729),
    [sym_comment] = ACTIONS(87),
  },
  [9509] = {
    [aux_sym_exceptions_repeat1] = STATE(9509),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(14130),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_PLUS_EQ] = ACTIONS(11597),
    [anon_sym_DASH_EQ] = ACTIONS(11597),
    [anon_sym_STAR_EQ] = ACTIONS(11597),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11597),
    [anon_sym_SLASH_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11597),
    [anon_sym_AMP_EQ] = ACTIONS(11597),
    [anon_sym_PERCENT_EQ] = ACTIONS(11597),
    [anon_sym_GT_GT_EQ] = ACTIONS(11597),
    [anon_sym_LT_LT_EQ] = ACTIONS(11597),
    [anon_sym_CARET_EQ] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_LT] = ACTIONS(12338),
    [anon_sym_GT_GT] = ACTIONS(12338),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(12338),
    [anon_sym_PLUS] = ACTIONS(12338),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [9510] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10456),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2833),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2833),
    [sym_assignment] = STATE(10456),
    [sym_operator_assignment] = STATE(10456),
    [sym_conditional] = STATE(10456),
    [sym_range] = STATE(10456),
    [sym_binary] = STATE(10456),
    [sym_unary] = STATE(10456),
    [sym_left_assignment_list] = STATE(2832),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2833),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2833),
    [sym_false] = STATE(2833),
    [sym_nil] = STATE(2833),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2735),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4763),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4615),
    [anon_sym_yield] = ACTIONS(4617),
    [anon_sym_break] = ACTIONS(4619),
    [anon_sym_next] = ACTIONS(4621),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4765),
    [anon_sym_defined_QMARK] = ACTIONS(4767),
    [anon_sym_not] = ACTIONS(4769),
    [anon_sym_BANG] = ACTIONS(4771),
    [anon_sym_TILDE] = ACTIONS(4771),
    [sym_constant] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_instance_variable] = ACTIONS(473),
    [sym_class_variable] = ACTIONS(473),
    [sym_global_variable] = ACTIONS(473),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(471),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9511] = {
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(8434),
    [sym__binary_star] = ACTIONS(8436),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(8438),
    [anon_sym_STAR_STAR] = ACTIONS(8436),
    [anon_sym_AMP] = ACTIONS(8440),
    [anon_sym_LT] = ACTIONS(8442),
    [anon_sym_in] = ACTIONS(6823),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(8444),
    [anon_sym_DOT_DOT] = ACTIONS(8446),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8448),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(8452),
    [anon_sym_AMP_AMP] = ACTIONS(8452),
    [anon_sym_LT_LT] = ACTIONS(8454),
    [anon_sym_GT_GT] = ACTIONS(8454),
    [anon_sym_EQ_EQ] = ACTIONS(8456),
    [anon_sym_BANG_EQ] = ACTIONS(8452),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8452),
    [anon_sym_LT_EQ_GT] = ACTIONS(8452),
    [anon_sym_EQ_TILDE] = ACTIONS(8452),
    [anon_sym_BANG_TILDE] = ACTIONS(8452),
    [anon_sym_LT_EQ] = ACTIONS(8442),
    [anon_sym_GT] = ACTIONS(8442),
    [anon_sym_GT_EQ] = ACTIONS(8458),
    [anon_sym_CARET] = ACTIONS(8460),
    [anon_sym_PLUS] = ACTIONS(8434),
    [anon_sym_SLASH] = ACTIONS(8436),
    [anon_sym_PERCENT] = ACTIONS(8436),
    [sym_comment] = ACTIONS(87),
  },
  [9512] = {
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(8434),
    [sym__binary_star] = ACTIONS(8436),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(8438),
    [anon_sym_STAR_STAR] = ACTIONS(8436),
    [anon_sym_AMP] = ACTIONS(8440),
    [anon_sym_LT] = ACTIONS(8442),
    [anon_sym_in] = ACTIONS(7027),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(8444),
    [anon_sym_DOT_DOT] = ACTIONS(8446),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8448),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(8452),
    [anon_sym_AMP_AMP] = ACTIONS(8452),
    [anon_sym_LT_LT] = ACTIONS(8454),
    [anon_sym_GT_GT] = ACTIONS(8454),
    [anon_sym_EQ_EQ] = ACTIONS(8456),
    [anon_sym_BANG_EQ] = ACTIONS(8452),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8452),
    [anon_sym_LT_EQ_GT] = ACTIONS(8452),
    [anon_sym_EQ_TILDE] = ACTIONS(8452),
    [anon_sym_BANG_TILDE] = ACTIONS(8452),
    [anon_sym_LT_EQ] = ACTIONS(8442),
    [anon_sym_GT] = ACTIONS(8442),
    [anon_sym_GT_EQ] = ACTIONS(8458),
    [anon_sym_CARET] = ACTIONS(8460),
    [anon_sym_PLUS] = ACTIONS(8434),
    [anon_sym_SLASH] = ACTIONS(8436),
    [anon_sym_PERCENT] = ACTIONS(8436),
    [sym_comment] = ACTIONS(87),
  },
  [9513] = {
    [sym_heredoc_body] = STATE(9513),
    [aux_sym_call_repeat1] = STATE(9513),
    [sym__heredoc_body_start] = ACTIONS(10455),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_in] = ACTIONS(7914),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [9514] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(5337),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(1089),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(1089),
    [sym__argument] = STATE(6908),
    [sym_splat_argument] = STATE(6908),
    [sym_hash_splat_argument] = STATE(6908),
    [sym_block_argument] = STATE(6908),
    [sym_assignment] = STATE(5337),
    [sym_operator_assignment] = STATE(5337),
    [sym_conditional] = STATE(5337),
    [sym_range] = STATE(5337),
    [sym_binary] = STATE(5337),
    [sym_unary] = STATE(5337),
    [sym_left_assignment_list] = STATE(1088),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1089),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(1089),
    [sym_false] = STATE(1089),
    [sym_nil] = STATE(1089),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(5340),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(6908),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(8426),
    [sym__splat_star] = ACTIONS(8428),
    [sym__unary_minus] = ACTIONS(1937),
    [sym__identifier_hash_key] = ACTIONS(8430),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13174),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1943),
    [anon_sym_yield] = ACTIONS(1945),
    [anon_sym_break] = ACTIONS(1947),
    [anon_sym_next] = ACTIONS(1949),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1951),
    [anon_sym_defined_QMARK] = ACTIONS(1953),
    [anon_sym_not] = ACTIONS(1955),
    [anon_sym_BANG] = ACTIONS(1957),
    [anon_sym_TILDE] = ACTIONS(1957),
    [sym_constant] = ACTIONS(8432),
    [sym_identifier] = ACTIONS(8432),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9515] = {
    [sym_heredoc_body] = STATE(9513),
    [aux_sym_call_repeat1] = STATE(9513),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_in] = ACTIONS(7929),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [9516] = {
    [aux_sym_argument_list_repeat1] = STATE(9516),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(14133),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_STAR_STAR] = ACTIONS(7925),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_in] = ACTIONS(7925),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7925),
    [anon_sym_AMP_AMP] = ACTIONS(7925),
    [anon_sym_LT_LT] = ACTIONS(7925),
    [anon_sym_GT_GT] = ACTIONS(7925),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7925),
    [anon_sym_PLUS] = ACTIONS(7925),
    [anon_sym_SLASH] = ACTIONS(7925),
    [anon_sym_PERCENT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [9517] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(10457),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2848),
    [sym_scope_resolution] = STATE(2846),
    [sym_call] = STATE(2846),
    [sym_method_call] = STATE(2848),
    [sym_assignment] = STATE(10457),
    [sym_operator_assignment] = STATE(10457),
    [sym_conditional] = STATE(10457),
    [sym_range] = STATE(10457),
    [sym_binary] = STATE(10457),
    [sym_unary] = STATE(10457),
    [sym_left_assignment_list] = STATE(2847),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2848),
    [sym__variable] = STATE(2846),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2848),
    [sym_false] = STATE(2848),
    [sym_nil] = STATE(2848),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2849),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4775),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4777),
    [anon_sym_yield] = ACTIONS(4779),
    [anon_sym_break] = ACTIONS(4781),
    [anon_sym_next] = ACTIONS(4783),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4785),
    [anon_sym_defined_QMARK] = ACTIONS(4787),
    [anon_sym_not] = ACTIONS(4789),
    [anon_sym_BANG] = ACTIONS(4791),
    [anon_sym_TILDE] = ACTIONS(4791),
    [sym_constant] = ACTIONS(4793),
    [sym_identifier] = ACTIONS(4793),
    [sym_instance_variable] = ACTIONS(4795),
    [sym_class_variable] = ACTIONS(4795),
    [sym_global_variable] = ACTIONS(4795),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4793),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4793),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9518] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(13184),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_in] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [9519] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(13178),
    [sym__binary_star] = ACTIONS(13180),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(13182),
    [anon_sym_STAR_STAR] = ACTIONS(13184),
    [anon_sym_AMP] = ACTIONS(13186),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(13188),
    [anon_sym_in] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(13190),
    [anon_sym_DOT_DOT] = ACTIONS(13192),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13194),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(13196),
    [anon_sym_AMP_AMP] = ACTIONS(13196),
    [anon_sym_LT_LT] = ACTIONS(13198),
    [anon_sym_GT_GT] = ACTIONS(13198),
    [anon_sym_EQ_EQ] = ACTIONS(13196),
    [anon_sym_BANG_EQ] = ACTIONS(13200),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13200),
    [anon_sym_LT_EQ_GT] = ACTIONS(13200),
    [anon_sym_EQ_TILDE] = ACTIONS(13200),
    [anon_sym_BANG_TILDE] = ACTIONS(13200),
    [anon_sym_LT_EQ] = ACTIONS(13188),
    [anon_sym_GT] = ACTIONS(13188),
    [anon_sym_GT_EQ] = ACTIONS(13202),
    [anon_sym_CARET] = ACTIONS(13182),
    [anon_sym_PLUS] = ACTIONS(13204),
    [anon_sym_SLASH] = ACTIONS(13184),
    [anon_sym_PERCENT] = ACTIONS(13184),
    [sym_comment] = ACTIONS(87),
  },
  [9520] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(10458),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(7820),
    [sym_scope_resolution] = STATE(2846),
    [sym_call] = STATE(2846),
    [sym_method_call] = STATE(7820),
    [sym_assignment] = STATE(10458),
    [sym_operator_assignment] = STATE(10458),
    [sym_conditional] = STATE(10458),
    [sym_range] = STATE(10458),
    [sym_binary] = STATE(10458),
    [sym_unary] = STATE(10458),
    [sym_left_assignment_list] = STATE(7819),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7820),
    [sym__variable] = STATE(2846),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(7820),
    [sym_false] = STATE(7820),
    [sym_nil] = STATE(7820),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(7821),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(11356),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(11358),
    [anon_sym_yield] = ACTIONS(11360),
    [anon_sym_break] = ACTIONS(11362),
    [anon_sym_next] = ACTIONS(11364),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(11366),
    [anon_sym_defined_QMARK] = ACTIONS(11368),
    [anon_sym_not] = ACTIONS(11370),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_TILDE] = ACTIONS(11372),
    [sym_constant] = ACTIONS(4793),
    [sym_identifier] = ACTIONS(4793),
    [sym_instance_variable] = ACTIONS(4795),
    [sym_class_variable] = ACTIONS(4795),
    [sym_global_variable] = ACTIONS(4795),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(4793),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4793),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [9521] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(10459),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(7820),
    [sym_scope_resolution] = STATE(2846),
    [sym_call] = STATE(2846),
    [sym_method_call] = STATE(7820),
    [sym_assignment] = STATE(10459),
    [sym_operator_assignment] = STATE(10459),
    [sym_conditional] = STATE(10459),
    [sym_range] = STATE(10459),
    [sym_binary] = STATE(10459),
    [sym_unary] = STATE(10459),
    [sym_left_assignment_list] = STATE(7819),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7820),
    [sym__variable] = STATE(2846),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(7820),
    [sym_false] = STATE(7820),
    [sym_nil] = STATE(7820),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(7821),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(11356),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(11358),
    [anon_sym_yield] = ACTIONS(11360),
    [anon_sym_break] = ACTIONS(11362),
    [anon_sym_next] = ACTIONS(11364),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(11366),
    [anon_sym_defined_QMARK] = ACTIONS(11368),
    [anon_sym_not] = ACTIONS(11370),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_TILDE] = ACTIONS(11372),
    [sym_constant] = ACTIONS(4793),
    [sym_identifier] = ACTIONS(4793),
    [sym_instance_variable] = ACTIONS(4795),
    [sym_class_variable] = ACTIONS(4795),
    [sym_global_variable] = ACTIONS(4795),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(4793),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4793),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [9522] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(10460),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(7820),
    [sym_scope_resolution] = STATE(2846),
    [sym_call] = STATE(2846),
    [sym_method_call] = STATE(7820),
    [sym_assignment] = STATE(10460),
    [sym_operator_assignment] = STATE(10460),
    [sym_conditional] = STATE(10460),
    [sym_range] = STATE(10460),
    [sym_binary] = STATE(10460),
    [sym_unary] = STATE(10460),
    [sym_left_assignment_list] = STATE(7819),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7820),
    [sym__variable] = STATE(2846),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(7820),
    [sym_false] = STATE(7820),
    [sym_nil] = STATE(7820),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(7821),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(11356),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(11358),
    [anon_sym_yield] = ACTIONS(11360),
    [anon_sym_break] = ACTIONS(11362),
    [anon_sym_next] = ACTIONS(11364),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(11366),
    [anon_sym_defined_QMARK] = ACTIONS(11368),
    [anon_sym_not] = ACTIONS(11370),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_TILDE] = ACTIONS(11372),
    [sym_constant] = ACTIONS(4793),
    [sym_identifier] = ACTIONS(4793),
    [sym_instance_variable] = ACTIONS(4795),
    [sym_class_variable] = ACTIONS(4795),
    [sym_global_variable] = ACTIONS(4795),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(4793),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4793),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [9523] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(10461),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(7820),
    [sym_scope_resolution] = STATE(2846),
    [sym_call] = STATE(2846),
    [sym_method_call] = STATE(7820),
    [sym_assignment] = STATE(10461),
    [sym_operator_assignment] = STATE(10461),
    [sym_conditional] = STATE(10461),
    [sym_range] = STATE(10461),
    [sym_binary] = STATE(10461),
    [sym_unary] = STATE(10461),
    [sym_left_assignment_list] = STATE(7819),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7820),
    [sym__variable] = STATE(2846),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(7820),
    [sym_false] = STATE(7820),
    [sym_nil] = STATE(7820),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(7821),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(11356),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(11358),
    [anon_sym_yield] = ACTIONS(11360),
    [anon_sym_break] = ACTIONS(11362),
    [anon_sym_next] = ACTIONS(11364),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(11366),
    [anon_sym_defined_QMARK] = ACTIONS(11368),
    [anon_sym_not] = ACTIONS(11370),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_TILDE] = ACTIONS(11372),
    [sym_constant] = ACTIONS(4793),
    [sym_identifier] = ACTIONS(4793),
    [sym_instance_variable] = ACTIONS(4795),
    [sym_class_variable] = ACTIONS(4795),
    [sym_global_variable] = ACTIONS(4795),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(4793),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4793),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [9524] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(10462),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(7820),
    [sym_scope_resolution] = STATE(2846),
    [sym_call] = STATE(2846),
    [sym_method_call] = STATE(7820),
    [sym_assignment] = STATE(10462),
    [sym_operator_assignment] = STATE(10462),
    [sym_conditional] = STATE(10462),
    [sym_range] = STATE(10462),
    [sym_binary] = STATE(10462),
    [sym_unary] = STATE(10462),
    [sym_left_assignment_list] = STATE(7819),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7820),
    [sym__variable] = STATE(2846),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(7820),
    [sym_false] = STATE(7820),
    [sym_nil] = STATE(7820),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(7821),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(11356),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(11358),
    [anon_sym_yield] = ACTIONS(11360),
    [anon_sym_break] = ACTIONS(11362),
    [anon_sym_next] = ACTIONS(11364),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(11366),
    [anon_sym_defined_QMARK] = ACTIONS(11368),
    [anon_sym_not] = ACTIONS(11370),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_TILDE] = ACTIONS(11372),
    [sym_constant] = ACTIONS(4793),
    [sym_identifier] = ACTIONS(4793),
    [sym_instance_variable] = ACTIONS(4795),
    [sym_class_variable] = ACTIONS(4795),
    [sym_global_variable] = ACTIONS(4795),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(4793),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4793),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [9525] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(10463),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(10463),
    [sym_operator_assignment] = STATE(10463),
    [sym_conditional] = STATE(10463),
    [sym_range] = STATE(10463),
    [sym_binary] = STATE(10463),
    [sym_unary] = STATE(10463),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9526] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(10464),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(7820),
    [sym_scope_resolution] = STATE(2846),
    [sym_call] = STATE(2846),
    [sym_method_call] = STATE(7820),
    [sym_assignment] = STATE(10464),
    [sym_operator_assignment] = STATE(10464),
    [sym_conditional] = STATE(10464),
    [sym_range] = STATE(10464),
    [sym_binary] = STATE(10464),
    [sym_unary] = STATE(10464),
    [sym_left_assignment_list] = STATE(7819),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7820),
    [sym__variable] = STATE(2846),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(7820),
    [sym_false] = STATE(7820),
    [sym_nil] = STATE(7820),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(7821),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(11356),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(11358),
    [anon_sym_yield] = ACTIONS(11360),
    [anon_sym_break] = ACTIONS(11362),
    [anon_sym_next] = ACTIONS(11364),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(11366),
    [anon_sym_defined_QMARK] = ACTIONS(11368),
    [anon_sym_not] = ACTIONS(11370),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_TILDE] = ACTIONS(11372),
    [sym_constant] = ACTIONS(4793),
    [sym_identifier] = ACTIONS(4793),
    [sym_instance_variable] = ACTIONS(4795),
    [sym_class_variable] = ACTIONS(4795),
    [sym_global_variable] = ACTIONS(4795),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(4793),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4793),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [9527] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(10465),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(7820),
    [sym_scope_resolution] = STATE(2846),
    [sym_call] = STATE(2846),
    [sym_method_call] = STATE(7820),
    [sym_assignment] = STATE(10465),
    [sym_operator_assignment] = STATE(10465),
    [sym_conditional] = STATE(10465),
    [sym_range] = STATE(10465),
    [sym_binary] = STATE(10465),
    [sym_unary] = STATE(10465),
    [sym_left_assignment_list] = STATE(7819),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7820),
    [sym__variable] = STATE(2846),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(7820),
    [sym_false] = STATE(7820),
    [sym_nil] = STATE(7820),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(7821),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(11356),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(11358),
    [anon_sym_yield] = ACTIONS(11360),
    [anon_sym_break] = ACTIONS(11362),
    [anon_sym_next] = ACTIONS(11364),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(11366),
    [anon_sym_defined_QMARK] = ACTIONS(11368),
    [anon_sym_not] = ACTIONS(11370),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_TILDE] = ACTIONS(11372),
    [sym_constant] = ACTIONS(4793),
    [sym_identifier] = ACTIONS(4793),
    [sym_instance_variable] = ACTIONS(4795),
    [sym_class_variable] = ACTIONS(4795),
    [sym_global_variable] = ACTIONS(4795),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(4793),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4793),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [9528] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(10466),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(7820),
    [sym_scope_resolution] = STATE(2846),
    [sym_call] = STATE(2846),
    [sym_method_call] = STATE(7820),
    [sym_assignment] = STATE(10466),
    [sym_operator_assignment] = STATE(10466),
    [sym_conditional] = STATE(10466),
    [sym_range] = STATE(10466),
    [sym_binary] = STATE(10466),
    [sym_unary] = STATE(10466),
    [sym_left_assignment_list] = STATE(7819),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7820),
    [sym__variable] = STATE(2846),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(7820),
    [sym_false] = STATE(7820),
    [sym_nil] = STATE(7820),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(7821),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(11356),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(11358),
    [anon_sym_yield] = ACTIONS(11360),
    [anon_sym_break] = ACTIONS(11362),
    [anon_sym_next] = ACTIONS(11364),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(11366),
    [anon_sym_defined_QMARK] = ACTIONS(11368),
    [anon_sym_not] = ACTIONS(11370),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_TILDE] = ACTIONS(11372),
    [sym_constant] = ACTIONS(4793),
    [sym_identifier] = ACTIONS(4793),
    [sym_instance_variable] = ACTIONS(4795),
    [sym_class_variable] = ACTIONS(4795),
    [sym_global_variable] = ACTIONS(4795),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(4793),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4793),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [9529] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(10467),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(7820),
    [sym_scope_resolution] = STATE(2846),
    [sym_call] = STATE(2846),
    [sym_method_call] = STATE(7820),
    [sym_assignment] = STATE(10467),
    [sym_operator_assignment] = STATE(10467),
    [sym_conditional] = STATE(10467),
    [sym_range] = STATE(10467),
    [sym_binary] = STATE(10467),
    [sym_unary] = STATE(10467),
    [sym_left_assignment_list] = STATE(7819),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7820),
    [sym__variable] = STATE(2846),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(7820),
    [sym_false] = STATE(7820),
    [sym_nil] = STATE(7820),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(7821),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(11356),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(11358),
    [anon_sym_yield] = ACTIONS(11360),
    [anon_sym_break] = ACTIONS(11362),
    [anon_sym_next] = ACTIONS(11364),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(11366),
    [anon_sym_defined_QMARK] = ACTIONS(11368),
    [anon_sym_not] = ACTIONS(11370),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_TILDE] = ACTIONS(11372),
    [sym_constant] = ACTIONS(4793),
    [sym_identifier] = ACTIONS(4793),
    [sym_instance_variable] = ACTIONS(4795),
    [sym_class_variable] = ACTIONS(4795),
    [sym_global_variable] = ACTIONS(4795),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(4793),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4793),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [9530] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(10468),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(7820),
    [sym_scope_resolution] = STATE(2846),
    [sym_call] = STATE(2846),
    [sym_method_call] = STATE(7820),
    [sym_splat_argument] = STATE(10469),
    [sym_assignment] = STATE(10468),
    [sym_operator_assignment] = STATE(10468),
    [sym_conditional] = STATE(10468),
    [sym_range] = STATE(10468),
    [sym_binary] = STATE(10468),
    [sym_unary] = STATE(10468),
    [sym_right_assignment_list] = STATE(8878),
    [sym__arg_or_splat_arg] = STATE(10469),
    [sym_left_assignment_list] = STATE(7819),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7820),
    [sym__variable] = STATE(2846),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(7820),
    [sym_false] = STATE(7820),
    [sym_nil] = STATE(7820),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(7821),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__splat_star] = ACTIONS(8464),
    [sym__unary_minus] = ACTIONS(11356),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(11358),
    [anon_sym_yield] = ACTIONS(11360),
    [anon_sym_break] = ACTIONS(11362),
    [anon_sym_next] = ACTIONS(11364),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(11366),
    [anon_sym_defined_QMARK] = ACTIONS(11368),
    [anon_sym_not] = ACTIONS(11370),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_TILDE] = ACTIONS(11372),
    [sym_constant] = ACTIONS(4793),
    [sym_identifier] = ACTIONS(4793),
    [sym_instance_variable] = ACTIONS(4795),
    [sym_class_variable] = ACTIONS(4795),
    [sym_global_variable] = ACTIONS(4795),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(4793),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4793),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [9531] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(10470),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(7820),
    [sym_scope_resolution] = STATE(2846),
    [sym_call] = STATE(2846),
    [sym_method_call] = STATE(7820),
    [sym_assignment] = STATE(10470),
    [sym_operator_assignment] = STATE(10470),
    [sym_conditional] = STATE(10470),
    [sym_range] = STATE(10470),
    [sym_binary] = STATE(10470),
    [sym_unary] = STATE(10470),
    [sym_left_assignment_list] = STATE(7819),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7820),
    [sym__variable] = STATE(2846),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(7820),
    [sym_false] = STATE(7820),
    [sym_nil] = STATE(7820),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(7821),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(11356),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(11358),
    [anon_sym_yield] = ACTIONS(11360),
    [anon_sym_break] = ACTIONS(11362),
    [anon_sym_next] = ACTIONS(11364),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(11366),
    [anon_sym_defined_QMARK] = ACTIONS(11368),
    [anon_sym_not] = ACTIONS(11370),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_TILDE] = ACTIONS(11372),
    [sym_constant] = ACTIONS(4793),
    [sym_identifier] = ACTIONS(4793),
    [sym_instance_variable] = ACTIONS(4795),
    [sym_class_variable] = ACTIONS(4795),
    [sym_global_variable] = ACTIONS(4795),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(4793),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4793),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [9532] = {
    [sym_string] = STATE(10471),
    [aux_sym_chained_string_repeat1] = STATE(10471),
    [sym__string_start] = ACTIONS(6455),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_STAR_STAR] = ACTIONS(2755),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_EQ] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_in] = ACTIONS(2753),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_PLUS_EQ] = ACTIONS(2753),
    [anon_sym_DASH_EQ] = ACTIONS(2753),
    [anon_sym_STAR_EQ] = ACTIONS(2753),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2753),
    [anon_sym_SLASH_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2753),
    [anon_sym_AMP_EQ] = ACTIONS(2753),
    [anon_sym_PERCENT_EQ] = ACTIONS(2753),
    [anon_sym_GT_GT_EQ] = ACTIONS(2753),
    [anon_sym_LT_LT_EQ] = ACTIONS(2753),
    [anon_sym_CARET_EQ] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2755),
    [anon_sym_AMP_AMP] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2755),
    [anon_sym_GT_GT] = ACTIONS(2755),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_SLASH] = ACTIONS(2755),
    [anon_sym_PERCENT] = ACTIONS(2755),
    [sym_comment] = ACTIONS(87),
  },
  [9533] = {
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(13178),
    [sym__binary_star] = ACTIONS(13180),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(13182),
    [anon_sym_STAR_STAR] = ACTIONS(13184),
    [anon_sym_AMP] = ACTIONS(13186),
    [anon_sym_EQ] = ACTIONS(7822),
    [anon_sym_LT] = ACTIONS(13188),
    [anon_sym_in] = ACTIONS(6823),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_PLUS_EQ] = ACTIONS(6823),
    [anon_sym_DASH_EQ] = ACTIONS(6823),
    [anon_sym_STAR_EQ] = ACTIONS(6823),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6823),
    [anon_sym_SLASH_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6823),
    [anon_sym_AMP_EQ] = ACTIONS(6823),
    [anon_sym_PERCENT_EQ] = ACTIONS(6823),
    [anon_sym_GT_GT_EQ] = ACTIONS(6823),
    [anon_sym_LT_LT_EQ] = ACTIONS(6823),
    [anon_sym_CARET_EQ] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(13190),
    [anon_sym_DOT_DOT] = ACTIONS(13192),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13194),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(13196),
    [anon_sym_AMP_AMP] = ACTIONS(13196),
    [anon_sym_LT_LT] = ACTIONS(13198),
    [anon_sym_GT_GT] = ACTIONS(13198),
    [anon_sym_EQ_EQ] = ACTIONS(13196),
    [anon_sym_BANG_EQ] = ACTIONS(13200),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13200),
    [anon_sym_LT_EQ_GT] = ACTIONS(13200),
    [anon_sym_EQ_TILDE] = ACTIONS(13200),
    [anon_sym_BANG_TILDE] = ACTIONS(13200),
    [anon_sym_LT_EQ] = ACTIONS(13188),
    [anon_sym_GT] = ACTIONS(13188),
    [anon_sym_GT_EQ] = ACTIONS(13202),
    [anon_sym_CARET] = ACTIONS(13182),
    [anon_sym_PLUS] = ACTIONS(13204),
    [anon_sym_SLASH] = ACTIONS(13184),
    [anon_sym_PERCENT] = ACTIONS(13184),
    [sym_comment] = ACTIONS(87),
  },
  [9534] = {
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(13178),
    [sym__binary_star] = ACTIONS(13180),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(13182),
    [anon_sym_STAR_STAR] = ACTIONS(13184),
    [anon_sym_AMP] = ACTIONS(13186),
    [anon_sym_EQ] = ACTIONS(7884),
    [anon_sym_LT] = ACTIONS(13188),
    [anon_sym_in] = ACTIONS(7027),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_PLUS_EQ] = ACTIONS(7027),
    [anon_sym_DASH_EQ] = ACTIONS(7027),
    [anon_sym_STAR_EQ] = ACTIONS(7027),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7027),
    [anon_sym_SLASH_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7027),
    [anon_sym_AMP_EQ] = ACTIONS(7027),
    [anon_sym_PERCENT_EQ] = ACTIONS(7027),
    [anon_sym_GT_GT_EQ] = ACTIONS(7027),
    [anon_sym_LT_LT_EQ] = ACTIONS(7027),
    [anon_sym_CARET_EQ] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(13190),
    [anon_sym_DOT_DOT] = ACTIONS(13192),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13194),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(13196),
    [anon_sym_AMP_AMP] = ACTIONS(13196),
    [anon_sym_LT_LT] = ACTIONS(13198),
    [anon_sym_GT_GT] = ACTIONS(13198),
    [anon_sym_EQ_EQ] = ACTIONS(13196),
    [anon_sym_BANG_EQ] = ACTIONS(13200),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13200),
    [anon_sym_LT_EQ_GT] = ACTIONS(13200),
    [anon_sym_EQ_TILDE] = ACTIONS(13200),
    [anon_sym_BANG_TILDE] = ACTIONS(13200),
    [anon_sym_LT_EQ] = ACTIONS(13188),
    [anon_sym_GT] = ACTIONS(13188),
    [anon_sym_GT_EQ] = ACTIONS(13202),
    [anon_sym_CARET] = ACTIONS(13182),
    [anon_sym_PLUS] = ACTIONS(13204),
    [anon_sym_SLASH] = ACTIONS(13184),
    [anon_sym_PERCENT] = ACTIONS(13184),
    [sym_comment] = ACTIONS(87),
  },
  [9535] = {
    [sym_heredoc_body] = STATE(9535),
    [aux_sym_call_repeat1] = STATE(9535),
    [sym__heredoc_body_start] = ACTIONS(12549),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_STAR_STAR] = ACTIONS(7919),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_EQ] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_in] = ACTIONS(7914),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_PLUS_EQ] = ACTIONS(7914),
    [anon_sym_DASH_EQ] = ACTIONS(7914),
    [anon_sym_STAR_EQ] = ACTIONS(7914),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7914),
    [anon_sym_SLASH_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7914),
    [anon_sym_AMP_EQ] = ACTIONS(7914),
    [anon_sym_PERCENT_EQ] = ACTIONS(7914),
    [anon_sym_GT_GT_EQ] = ACTIONS(7914),
    [anon_sym_LT_LT_EQ] = ACTIONS(7914),
    [anon_sym_CARET_EQ] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7919),
    [anon_sym_AMP_AMP] = ACTIONS(7919),
    [anon_sym_LT_LT] = ACTIONS(7919),
    [anon_sym_GT_GT] = ACTIONS(7919),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7919),
    [anon_sym_PLUS] = ACTIONS(7919),
    [anon_sym_SLASH] = ACTIONS(7919),
    [anon_sym_PERCENT] = ACTIONS(7919),
    [sym_comment] = ACTIONS(87),
  },
  [9536] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(5357),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2892),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(2892),
    [sym__argument] = STATE(8888),
    [sym_splat_argument] = STATE(8888),
    [sym_hash_splat_argument] = STATE(8888),
    [sym_block_argument] = STATE(8888),
    [sym_assignment] = STATE(5357),
    [sym_operator_assignment] = STATE(5357),
    [sym_conditional] = STATE(5357),
    [sym_range] = STATE(5357),
    [sym_binary] = STATE(5357),
    [sym_unary] = STATE(5357),
    [sym_left_assignment_list] = STATE(2891),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2892),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2892),
    [sym_false] = STATE(2892),
    [sym_nil] = STATE(2892),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(5360),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(8888),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(8462),
    [sym__splat_star] = ACTIONS(8464),
    [sym__unary_minus] = ACTIONS(4843),
    [sym__identifier_hash_key] = ACTIONS(8466),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13212),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4847),
    [anon_sym_yield] = ACTIONS(4849),
    [anon_sym_break] = ACTIONS(4851),
    [anon_sym_next] = ACTIONS(4853),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(8484),
    [anon_sym_defined_QMARK] = ACTIONS(4855),
    [anon_sym_not] = ACTIONS(4857),
    [anon_sym_BANG] = ACTIONS(4861),
    [anon_sym_TILDE] = ACTIONS(4861),
    [sym_constant] = ACTIONS(8468),
    [sym_identifier] = ACTIONS(8468),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [9537] = {
    [sym_heredoc_body] = STATE(9535),
    [aux_sym_call_repeat1] = STATE(9535),
    [sym__heredoc_body_start] = ACTIONS(6569),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_STAR_STAR] = ACTIONS(7931),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_EQ] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_in] = ACTIONS(7929),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_PLUS_EQ] = ACTIONS(7929),
    [anon_sym_DASH_EQ] = ACTIONS(7929),
    [anon_sym_STAR_EQ] = ACTIONS(7929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7929),
    [anon_sym_SLASH_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7929),
    [anon_sym_AMP_EQ] = ACTIONS(7929),
    [anon_sym_PERCENT_EQ] = ACTIONS(7929),
    [anon_sym_GT_GT_EQ] = ACTIONS(7929),
    [anon_sym_LT_LT_EQ] = ACTIONS(7929),
    [anon_sym_CARET_EQ] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7931),
    [anon_sym_AMP_AMP] = ACTIONS(7931),
    [anon_sym_LT_LT] = ACTIONS(7931),
    [anon_sym_GT_GT] = ACTIONS(7931),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7931),
    [anon_sym_PLUS] = ACTIONS(7931),
    [anon_sym_SLASH] = ACTIONS(7931),
    [anon_sym_PERCENT] = ACTIONS(7931),
    [sym_comment] = ACTIONS(87),
  },
  [9538] = {
    [aux_sym_argument_list_repeat1] = STATE(9538),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(14136),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_STAR_STAR] = ACTIONS(7927),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_EQ] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_in] = ACTIONS(7925),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_PLUS_EQ] = ACTIONS(7925),
    [anon_sym_DASH_EQ] = ACTIONS(7925),
    [anon_sym_STAR_EQ] = ACTIONS(7925),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7925),
    [anon_sym_SLASH_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7925),
    [anon_sym_AMP_EQ] = ACTIONS(7925),
    [anon_sym_PERCENT_EQ] = ACTIONS(7925),
    [anon_sym_GT_GT_EQ] = ACTIONS(7925),
    [anon_sym_LT_LT_EQ] = ACTIONS(7925),
    [anon_sym_CARET_EQ] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7927),
    [anon_sym_AMP_AMP] = ACTIONS(7927),
    [anon_sym_LT_LT] = ACTIONS(7927),
    [anon_sym_GT_GT] = ACTIONS(7927),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7927),
    [anon_sym_PLUS] = ACTIONS(7927),
    [anon_sym_SLASH] = ACTIONS(7927),
    [anon_sym_PERCENT] = ACTIONS(7927),
    [sym_comment] = ACTIONS(87),
  },
  [9539] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(7829),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(2848),
    [sym_scope_resolution] = STATE(2846),
    [sym_call] = STATE(2846),
    [sym_method_call] = STATE(2848),
    [sym_splat_argument] = STATE(9013),
    [sym_assignment] = STATE(7829),
    [sym_operator_assignment] = STATE(7829),
    [sym_conditional] = STATE(7829),
    [sym_range] = STATE(7829),
    [sym_binary] = STATE(7829),
    [sym_unary] = STATE(7829),
    [sym__arg_or_splat_arg] = STATE(9013),
    [sym_left_assignment_list] = STATE(2847),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2848),
    [sym__variable] = STATE(2846),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(2848),
    [sym_false] = STATE(2848),
    [sym_nil] = STATE(2848),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2849),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(8428),
    [sym__unary_minus] = ACTIONS(4775),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4777),
    [anon_sym_yield] = ACTIONS(4779),
    [anon_sym_break] = ACTIONS(4781),
    [anon_sym_next] = ACTIONS(4783),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4785),
    [anon_sym_defined_QMARK] = ACTIONS(4787),
    [anon_sym_not] = ACTIONS(4789),
    [anon_sym_BANG] = ACTIONS(4791),
    [anon_sym_TILDE] = ACTIONS(4791),
    [sym_constant] = ACTIONS(4793),
    [sym_identifier] = ACTIONS(4793),
    [sym_instance_variable] = ACTIONS(4795),
    [sym_class_variable] = ACTIONS(4795),
    [sym_global_variable] = ACTIONS(4795),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4793),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4793),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9540] = {
    [aux_sym_exceptions_repeat1] = STATE(10472),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_LBRACE] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(14139),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_in] = ACTIONS(9855),
    [anon_sym_do] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [9541] = {
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(4811),
    [sym__binary_star] = ACTIONS(4813),
    [anon_sym_LBRACE] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(4815),
    [anon_sym_STAR_STAR] = ACTIONS(4813),
    [anon_sym_AMP] = ACTIONS(4817),
    [anon_sym_LT] = ACTIONS(4819),
    [anon_sym_in] = ACTIONS(12120),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_EQ_GT] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(4821),
    [anon_sym_DOT_DOT] = ACTIONS(4823),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4825),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(4829),
    [anon_sym_AMP_AMP] = ACTIONS(4829),
    [anon_sym_LT_LT] = ACTIONS(4831),
    [anon_sym_GT_GT] = ACTIONS(4831),
    [anon_sym_EQ_EQ] = ACTIONS(4833),
    [anon_sym_BANG_EQ] = ACTIONS(4829),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4829),
    [anon_sym_LT_EQ_GT] = ACTIONS(4829),
    [anon_sym_EQ_TILDE] = ACTIONS(4829),
    [anon_sym_BANG_TILDE] = ACTIONS(4829),
    [anon_sym_LT_EQ] = ACTIONS(4819),
    [anon_sym_GT] = ACTIONS(4819),
    [anon_sym_GT_EQ] = ACTIONS(4835),
    [anon_sym_CARET] = ACTIONS(4837),
    [anon_sym_PLUS] = ACTIONS(4811),
    [anon_sym_SLASH] = ACTIONS(4813),
    [anon_sym_PERCENT] = ACTIONS(4813),
    [sym_comment] = ACTIONS(87),
  },
  [9542] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(10473),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2892),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(2892),
    [sym_assignment] = STATE(10473),
    [sym_operator_assignment] = STATE(10473),
    [sym_conditional] = STATE(10473),
    [sym_range] = STATE(10473),
    [sym_binary] = STATE(10473),
    [sym_unary] = STATE(10473),
    [sym_left_assignment_list] = STATE(2891),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2892),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2892),
    [sym_false] = STATE(2892),
    [sym_nil] = STATE(2892),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(5385),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(4843),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4847),
    [anon_sym_yield] = ACTIONS(4849),
    [anon_sym_break] = ACTIONS(4851),
    [anon_sym_next] = ACTIONS(4853),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(8484),
    [anon_sym_defined_QMARK] = ACTIONS(4855),
    [anon_sym_not] = ACTIONS(4857),
    [anon_sym_BANG] = ACTIONS(4861),
    [anon_sym_TILDE] = ACTIONS(4861),
    [sym_constant] = ACTIONS(1963),
    [sym_identifier] = ACTIONS(1963),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [9543] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(7856),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2892),
    [sym_scope_resolution] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_method_call] = STATE(2892),
    [sym_splat_argument] = STATE(9044),
    [sym_assignment] = STATE(7856),
    [sym_operator_assignment] = STATE(7856),
    [sym_conditional] = STATE(7856),
    [sym_range] = STATE(7856),
    [sym_binary] = STATE(7856),
    [sym_unary] = STATE(7856),
    [sym__arg_or_splat_arg] = STATE(9044),
    [sym_left_assignment_list] = STATE(2891),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2892),
    [sym__variable] = STATE(1085),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2892),
    [sym_false] = STATE(2892),
    [sym_nil] = STATE(2892),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(5385),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__splat_star] = ACTIONS(4841),
    [sym__unary_minus] = ACTIONS(4843),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4847),
    [anon_sym_yield] = ACTIONS(4849),
    [anon_sym_break] = ACTIONS(4851),
    [anon_sym_next] = ACTIONS(4853),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(8484),
    [anon_sym_defined_QMARK] = ACTIONS(4855),
    [anon_sym_not] = ACTIONS(4857),
    [anon_sym_BANG] = ACTIONS(4861),
    [anon_sym_TILDE] = ACTIONS(4861),
    [sym_constant] = ACTIONS(1963),
    [sym_identifier] = ACTIONS(1963),
    [sym_instance_variable] = ACTIONS(1961),
    [sym_class_variable] = ACTIONS(1961),
    [sym_global_variable] = ACTIONS(1961),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1963),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1963),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [9544] = {
    [aux_sym_exceptions_repeat1] = STATE(10474),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_LBRACE] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(14141),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_STAR_STAR] = ACTIONS(9857),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_EQ] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_in] = ACTIONS(9855),
    [anon_sym_do] = ACTIONS(9855),
    [anon_sym_EQ_GT] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_PLUS_EQ] = ACTIONS(9855),
    [anon_sym_DASH_EQ] = ACTIONS(9855),
    [anon_sym_STAR_EQ] = ACTIONS(9855),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9855),
    [anon_sym_SLASH_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9855),
    [anon_sym_AMP_EQ] = ACTIONS(9855),
    [anon_sym_PERCENT_EQ] = ACTIONS(9855),
    [anon_sym_GT_GT_EQ] = ACTIONS(9855),
    [anon_sym_LT_LT_EQ] = ACTIONS(9855),
    [anon_sym_CARET_EQ] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9857),
    [anon_sym_AMP_AMP] = ACTIONS(9857),
    [anon_sym_LT_LT] = ACTIONS(9857),
    [anon_sym_GT_GT] = ACTIONS(9857),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9857),
    [anon_sym_PLUS] = ACTIONS(9857),
    [anon_sym_SLASH] = ACTIONS(9857),
    [anon_sym_PERCENT] = ACTIONS(9857),
    [sym_comment] = ACTIONS(87),
  },
  [9545] = {
    [aux_sym_exceptions_repeat1] = STATE(9545),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(14143),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_in] = ACTIONS(11597),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [9546] = {
    [sym_heredoc_body] = STATE(9546),
    [aux_sym_call_repeat1] = STATE(9546),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(7916),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [9547] = {
    [sym_heredoc_body] = STATE(9546),
    [aux_sym_call_repeat1] = STATE(9546),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [9548] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10475),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2913),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2913),
    [sym_assignment] = STATE(10475),
    [sym_operator_assignment] = STATE(10475),
    [sym_conditional] = STATE(10475),
    [sym_range] = STATE(10475),
    [sym_binary] = STATE(10475),
    [sym_unary] = STATE(10475),
    [sym_left_assignment_list] = STATE(2912),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2913),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2913),
    [sym_false] = STATE(2913),
    [sym_nil] = STATE(2913),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2914),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4881),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4883),
    [anon_sym_yield] = ACTIONS(4885),
    [anon_sym_break] = ACTIONS(4887),
    [anon_sym_next] = ACTIONS(4889),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4891),
    [anon_sym_defined_QMARK] = ACTIONS(4893),
    [anon_sym_not] = ACTIONS(4895),
    [anon_sym_BANG] = ACTIONS(4897),
    [anon_sym_TILDE] = ACTIONS(4897),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9549] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7875),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2913),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2913),
    [sym_splat_argument] = STATE(7439),
    [sym_assignment] = STATE(7875),
    [sym_operator_assignment] = STATE(7875),
    [sym_conditional] = STATE(7875),
    [sym_range] = STATE(7875),
    [sym_binary] = STATE(7875),
    [sym_unary] = STATE(7875),
    [sym__arg_or_splat_arg] = STATE(7439),
    [sym_left_assignment_list] = STATE(2912),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2913),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2913),
    [sym_false] = STATE(2913),
    [sym_nil] = STATE(2913),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2914),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(1971),
    [sym__unary_minus] = ACTIONS(4881),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4883),
    [anon_sym_yield] = ACTIONS(4885),
    [anon_sym_break] = ACTIONS(4887),
    [anon_sym_next] = ACTIONS(4889),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4891),
    [anon_sym_defined_QMARK] = ACTIONS(4893),
    [anon_sym_not] = ACTIONS(4895),
    [anon_sym_BANG] = ACTIONS(4897),
    [anon_sym_TILDE] = ACTIONS(4897),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9550] = {
    [aux_sym_exceptions_repeat1] = STATE(10476),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(14146),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [9551] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(4913),
    [sym__binary_star] = ACTIONS(4915),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(4917),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(4915),
    [anon_sym_AMP] = ACTIONS(4919),
    [anon_sym_LT] = ACTIONS(4921),
    [anon_sym_EQ_GT] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_DOT_DOT] = ACTIONS(4925),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4927),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(4929),
    [anon_sym_AMP_AMP] = ACTIONS(4929),
    [anon_sym_LT_LT] = ACTIONS(4931),
    [anon_sym_GT_GT] = ACTIONS(4931),
    [anon_sym_EQ_EQ] = ACTIONS(4933),
    [anon_sym_BANG_EQ] = ACTIONS(4929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4929),
    [anon_sym_LT_EQ_GT] = ACTIONS(4929),
    [anon_sym_EQ_TILDE] = ACTIONS(4929),
    [anon_sym_BANG_TILDE] = ACTIONS(4929),
    [anon_sym_LT_EQ] = ACTIONS(4921),
    [anon_sym_GT] = ACTIONS(4921),
    [anon_sym_GT_EQ] = ACTIONS(4935),
    [anon_sym_CARET] = ACTIONS(4937),
    [anon_sym_PLUS] = ACTIONS(4913),
    [anon_sym_SLASH] = ACTIONS(4915),
    [anon_sym_PERCENT] = ACTIONS(4915),
    [sym_comment] = ACTIONS(87),
  },
  [9552] = {
    [aux_sym_exceptions_repeat1] = STATE(9552),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(14148),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [9553] = {
    [sym__line_break] = ACTIONS(14151),
    [sym__heredoc_body_start] = ACTIONS(14151),
    [sym__binary_minus] = ACTIONS(14151),
    [sym__binary_star] = ACTIONS(14151),
    [ts_builtin_sym_end] = ACTIONS(14151),
    [anon_sym___END__] = ACTIONS(14151),
    [anon_sym_LBRACE] = ACTIONS(14151),
    [anon_sym_RBRACE] = ACTIONS(14151),
    [anon_sym_RPAREN] = ACTIONS(14151),
    [anon_sym_DOT] = ACTIONS(14153),
    [anon_sym_COMMA] = ACTIONS(14151),
    [anon_sym_PIPE] = ACTIONS(14153),
    [anon_sym_SEMI] = ACTIONS(14151),
    [anon_sym_STAR_STAR] = ACTIONS(14151),
    [anon_sym_AMP] = ACTIONS(14153),
    [anon_sym_LT] = ACTIONS(14153),
    [anon_sym_end] = ACTIONS(14151),
    [anon_sym_if] = ACTIONS(14151),
    [anon_sym_unless] = ACTIONS(14151),
    [anon_sym_while] = ACTIONS(14151),
    [anon_sym_until] = ACTIONS(14151),
    [anon_sym_rescue] = ACTIONS(14151),
    [anon_sym_do] = ACTIONS(14151),
    [anon_sym_when] = ACTIONS(14151),
    [anon_sym_elsif] = ACTIONS(14151),
    [anon_sym_else] = ACTIONS(14151),
    [anon_sym_then] = ACTIONS(14151),
    [anon_sym_ensure] = ACTIONS(14151),
    [anon_sym_EQ_GT] = ACTIONS(14151),
    [anon_sym_LBRACK] = ACTIONS(14151),
    [anon_sym_COLON_COLON2] = ACTIONS(14151),
    [anon_sym_AMP_DOT] = ACTIONS(14151),
    [anon_sym_QMARK] = ACTIONS(14151),
    [anon_sym_DOT_DOT] = ACTIONS(14153),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14151),
    [anon_sym_and] = ACTIONS(14151),
    [anon_sym_or] = ACTIONS(14151),
    [anon_sym_PIPE_PIPE] = ACTIONS(14151),
    [anon_sym_AMP_AMP] = ACTIONS(14151),
    [anon_sym_LT_LT] = ACTIONS(14151),
    [anon_sym_GT_GT] = ACTIONS(14151),
    [anon_sym_EQ_EQ] = ACTIONS(14153),
    [anon_sym_BANG_EQ] = ACTIONS(14151),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14151),
    [anon_sym_LT_EQ_GT] = ACTIONS(14151),
    [anon_sym_EQ_TILDE] = ACTIONS(14151),
    [anon_sym_BANG_TILDE] = ACTIONS(14151),
    [anon_sym_LT_EQ] = ACTIONS(14153),
    [anon_sym_GT] = ACTIONS(14153),
    [anon_sym_GT_EQ] = ACTIONS(14151),
    [anon_sym_CARET] = ACTIONS(14151),
    [anon_sym_PLUS] = ACTIONS(14151),
    [anon_sym_SLASH] = ACTIONS(14151),
    [anon_sym_PERCENT] = ACTIONS(14151),
    [sym_comment] = ACTIONS(87),
  },
  [9554] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10477),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2968),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2968),
    [sym_assignment] = STATE(10477),
    [sym_operator_assignment] = STATE(10477),
    [sym_conditional] = STATE(10477),
    [sym_range] = STATE(10477),
    [sym_binary] = STATE(10477),
    [sym_unary] = STATE(10477),
    [sym_left_assignment_list] = STATE(2967),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2968),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2968),
    [sym_false] = STATE(2968),
    [sym_nil] = STATE(2968),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2914),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4955),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4883),
    [anon_sym_yield] = ACTIONS(4885),
    [anon_sym_break] = ACTIONS(4887),
    [anon_sym_next] = ACTIONS(4889),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4957),
    [anon_sym_defined_QMARK] = ACTIONS(4959),
    [anon_sym_not] = ACTIONS(4961),
    [anon_sym_BANG] = ACTIONS(4963),
    [anon_sym_TILDE] = ACTIONS(4963),
    [sym_constant] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_instance_variable] = ACTIONS(505),
    [sym_class_variable] = ACTIONS(505),
    [sym_global_variable] = ACTIONS(505),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(503),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9555] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(13248),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [9556] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(13246),
    [sym__binary_star] = ACTIONS(13248),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(13250),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(13248),
    [anon_sym_AMP] = ACTIONS(13252),
    [anon_sym_LT] = ACTIONS(13254),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(13256),
    [anon_sym_DOT_DOT] = ACTIONS(13258),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13260),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(13262),
    [anon_sym_AMP_AMP] = ACTIONS(13262),
    [anon_sym_LT_LT] = ACTIONS(13264),
    [anon_sym_GT_GT] = ACTIONS(13264),
    [anon_sym_EQ_EQ] = ACTIONS(13266),
    [anon_sym_BANG_EQ] = ACTIONS(13262),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13262),
    [anon_sym_LT_EQ_GT] = ACTIONS(13262),
    [anon_sym_EQ_TILDE] = ACTIONS(13262),
    [anon_sym_BANG_TILDE] = ACTIONS(13262),
    [anon_sym_LT_EQ] = ACTIONS(13254),
    [anon_sym_GT] = ACTIONS(13254),
    [anon_sym_GT_EQ] = ACTIONS(13268),
    [anon_sym_CARET] = ACTIONS(13270),
    [anon_sym_PLUS] = ACTIONS(13246),
    [anon_sym_SLASH] = ACTIONS(13248),
    [anon_sym_PERCENT] = ACTIONS(13248),
    [sym_comment] = ACTIONS(87),
  },
  [9557] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10478),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7909),
    [sym_scope_resolution] = STATE(2981),
    [sym_call] = STATE(2981),
    [sym_method_call] = STATE(7909),
    [sym_assignment] = STATE(10478),
    [sym_operator_assignment] = STATE(10478),
    [sym_conditional] = STATE(10478),
    [sym_range] = STATE(10478),
    [sym_binary] = STATE(10478),
    [sym_unary] = STATE(10478),
    [sym_left_assignment_list] = STATE(7908),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7909),
    [sym__variable] = STATE(2981),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7909),
    [sym_false] = STATE(7909),
    [sym_nil] = STATE(7909),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2985),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11410),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4973),
    [anon_sym_yield] = ACTIONS(4975),
    [anon_sym_break] = ACTIONS(4977),
    [anon_sym_next] = ACTIONS(4979),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11412),
    [anon_sym_defined_QMARK] = ACTIONS(11414),
    [anon_sym_not] = ACTIONS(11416),
    [anon_sym_BANG] = ACTIONS(11418),
    [anon_sym_TILDE] = ACTIONS(11418),
    [sym_constant] = ACTIONS(4989),
    [sym_identifier] = ACTIONS(4989),
    [sym_instance_variable] = ACTIONS(4991),
    [sym_class_variable] = ACTIONS(4991),
    [sym_global_variable] = ACTIONS(4991),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4989),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4989),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9558] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10479),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7909),
    [sym_scope_resolution] = STATE(2981),
    [sym_call] = STATE(2981),
    [sym_method_call] = STATE(7909),
    [sym_assignment] = STATE(10479),
    [sym_operator_assignment] = STATE(10479),
    [sym_conditional] = STATE(10479),
    [sym_range] = STATE(10479),
    [sym_binary] = STATE(10479),
    [sym_unary] = STATE(10479),
    [sym_left_assignment_list] = STATE(7908),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7909),
    [sym__variable] = STATE(2981),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7909),
    [sym_false] = STATE(7909),
    [sym_nil] = STATE(7909),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2985),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11410),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4973),
    [anon_sym_yield] = ACTIONS(4975),
    [anon_sym_break] = ACTIONS(4977),
    [anon_sym_next] = ACTIONS(4979),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11412),
    [anon_sym_defined_QMARK] = ACTIONS(11414),
    [anon_sym_not] = ACTIONS(11416),
    [anon_sym_BANG] = ACTIONS(11418),
    [anon_sym_TILDE] = ACTIONS(11418),
    [sym_constant] = ACTIONS(4989),
    [sym_identifier] = ACTIONS(4989),
    [sym_instance_variable] = ACTIONS(4991),
    [sym_class_variable] = ACTIONS(4991),
    [sym_global_variable] = ACTIONS(4991),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4989),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4989),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9559] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10480),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7909),
    [sym_scope_resolution] = STATE(2981),
    [sym_call] = STATE(2981),
    [sym_method_call] = STATE(7909),
    [sym_assignment] = STATE(10480),
    [sym_operator_assignment] = STATE(10480),
    [sym_conditional] = STATE(10480),
    [sym_range] = STATE(10480),
    [sym_binary] = STATE(10480),
    [sym_unary] = STATE(10480),
    [sym_left_assignment_list] = STATE(7908),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7909),
    [sym__variable] = STATE(2981),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7909),
    [sym_false] = STATE(7909),
    [sym_nil] = STATE(7909),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2985),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11410),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4973),
    [anon_sym_yield] = ACTIONS(4975),
    [anon_sym_break] = ACTIONS(4977),
    [anon_sym_next] = ACTIONS(4979),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11412),
    [anon_sym_defined_QMARK] = ACTIONS(11414),
    [anon_sym_not] = ACTIONS(11416),
    [anon_sym_BANG] = ACTIONS(11418),
    [anon_sym_TILDE] = ACTIONS(11418),
    [sym_constant] = ACTIONS(4989),
    [sym_identifier] = ACTIONS(4989),
    [sym_instance_variable] = ACTIONS(4991),
    [sym_class_variable] = ACTIONS(4991),
    [sym_global_variable] = ACTIONS(4991),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4989),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4989),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9560] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10481),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7909),
    [sym_scope_resolution] = STATE(2981),
    [sym_call] = STATE(2981),
    [sym_method_call] = STATE(7909),
    [sym_assignment] = STATE(10481),
    [sym_operator_assignment] = STATE(10481),
    [sym_conditional] = STATE(10481),
    [sym_range] = STATE(10481),
    [sym_binary] = STATE(10481),
    [sym_unary] = STATE(10481),
    [sym_left_assignment_list] = STATE(7908),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7909),
    [sym__variable] = STATE(2981),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7909),
    [sym_false] = STATE(7909),
    [sym_nil] = STATE(7909),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2985),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11410),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4973),
    [anon_sym_yield] = ACTIONS(4975),
    [anon_sym_break] = ACTIONS(4977),
    [anon_sym_next] = ACTIONS(4979),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11412),
    [anon_sym_defined_QMARK] = ACTIONS(11414),
    [anon_sym_not] = ACTIONS(11416),
    [anon_sym_BANG] = ACTIONS(11418),
    [anon_sym_TILDE] = ACTIONS(11418),
    [sym_constant] = ACTIONS(4989),
    [sym_identifier] = ACTIONS(4989),
    [sym_instance_variable] = ACTIONS(4991),
    [sym_class_variable] = ACTIONS(4991),
    [sym_global_variable] = ACTIONS(4991),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4989),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4989),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9561] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10482),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7909),
    [sym_scope_resolution] = STATE(2981),
    [sym_call] = STATE(2981),
    [sym_method_call] = STATE(7909),
    [sym_assignment] = STATE(10482),
    [sym_operator_assignment] = STATE(10482),
    [sym_conditional] = STATE(10482),
    [sym_range] = STATE(10482),
    [sym_binary] = STATE(10482),
    [sym_unary] = STATE(10482),
    [sym_left_assignment_list] = STATE(7908),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7909),
    [sym__variable] = STATE(2981),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7909),
    [sym_false] = STATE(7909),
    [sym_nil] = STATE(7909),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2985),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11410),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4973),
    [anon_sym_yield] = ACTIONS(4975),
    [anon_sym_break] = ACTIONS(4977),
    [anon_sym_next] = ACTIONS(4979),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11412),
    [anon_sym_defined_QMARK] = ACTIONS(11414),
    [anon_sym_not] = ACTIONS(11416),
    [anon_sym_BANG] = ACTIONS(11418),
    [anon_sym_TILDE] = ACTIONS(11418),
    [sym_constant] = ACTIONS(4989),
    [sym_identifier] = ACTIONS(4989),
    [sym_instance_variable] = ACTIONS(4991),
    [sym_class_variable] = ACTIONS(4991),
    [sym_global_variable] = ACTIONS(4991),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4989),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4989),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9562] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(10483),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(10483),
    [sym_operator_assignment] = STATE(10483),
    [sym_conditional] = STATE(10483),
    [sym_range] = STATE(10483),
    [sym_binary] = STATE(10483),
    [sym_unary] = STATE(10483),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9563] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10484),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7909),
    [sym_scope_resolution] = STATE(2981),
    [sym_call] = STATE(2981),
    [sym_method_call] = STATE(7909),
    [sym_assignment] = STATE(10484),
    [sym_operator_assignment] = STATE(10484),
    [sym_conditional] = STATE(10484),
    [sym_range] = STATE(10484),
    [sym_binary] = STATE(10484),
    [sym_unary] = STATE(10484),
    [sym_left_assignment_list] = STATE(7908),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7909),
    [sym__variable] = STATE(2981),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7909),
    [sym_false] = STATE(7909),
    [sym_nil] = STATE(7909),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2985),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11410),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4973),
    [anon_sym_yield] = ACTIONS(4975),
    [anon_sym_break] = ACTIONS(4977),
    [anon_sym_next] = ACTIONS(4979),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11412),
    [anon_sym_defined_QMARK] = ACTIONS(11414),
    [anon_sym_not] = ACTIONS(11416),
    [anon_sym_BANG] = ACTIONS(11418),
    [anon_sym_TILDE] = ACTIONS(11418),
    [sym_constant] = ACTIONS(4989),
    [sym_identifier] = ACTIONS(4989),
    [sym_instance_variable] = ACTIONS(4991),
    [sym_class_variable] = ACTIONS(4991),
    [sym_global_variable] = ACTIONS(4991),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4989),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4989),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9564] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10485),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7909),
    [sym_scope_resolution] = STATE(2981),
    [sym_call] = STATE(2981),
    [sym_method_call] = STATE(7909),
    [sym_assignment] = STATE(10485),
    [sym_operator_assignment] = STATE(10485),
    [sym_conditional] = STATE(10485),
    [sym_range] = STATE(10485),
    [sym_binary] = STATE(10485),
    [sym_unary] = STATE(10485),
    [sym_left_assignment_list] = STATE(7908),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7909),
    [sym__variable] = STATE(2981),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7909),
    [sym_false] = STATE(7909),
    [sym_nil] = STATE(7909),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2985),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11410),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4973),
    [anon_sym_yield] = ACTIONS(4975),
    [anon_sym_break] = ACTIONS(4977),
    [anon_sym_next] = ACTIONS(4979),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11412),
    [anon_sym_defined_QMARK] = ACTIONS(11414),
    [anon_sym_not] = ACTIONS(11416),
    [anon_sym_BANG] = ACTIONS(11418),
    [anon_sym_TILDE] = ACTIONS(11418),
    [sym_constant] = ACTIONS(4989),
    [sym_identifier] = ACTIONS(4989),
    [sym_instance_variable] = ACTIONS(4991),
    [sym_class_variable] = ACTIONS(4991),
    [sym_global_variable] = ACTIONS(4991),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4989),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4989),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9565] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10486),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7909),
    [sym_scope_resolution] = STATE(2981),
    [sym_call] = STATE(2981),
    [sym_method_call] = STATE(7909),
    [sym_assignment] = STATE(10486),
    [sym_operator_assignment] = STATE(10486),
    [sym_conditional] = STATE(10486),
    [sym_range] = STATE(10486),
    [sym_binary] = STATE(10486),
    [sym_unary] = STATE(10486),
    [sym_left_assignment_list] = STATE(7908),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7909),
    [sym__variable] = STATE(2981),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7909),
    [sym_false] = STATE(7909),
    [sym_nil] = STATE(7909),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2985),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11410),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4973),
    [anon_sym_yield] = ACTIONS(4975),
    [anon_sym_break] = ACTIONS(4977),
    [anon_sym_next] = ACTIONS(4979),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11412),
    [anon_sym_defined_QMARK] = ACTIONS(11414),
    [anon_sym_not] = ACTIONS(11416),
    [anon_sym_BANG] = ACTIONS(11418),
    [anon_sym_TILDE] = ACTIONS(11418),
    [sym_constant] = ACTIONS(4989),
    [sym_identifier] = ACTIONS(4989),
    [sym_instance_variable] = ACTIONS(4991),
    [sym_class_variable] = ACTIONS(4991),
    [sym_global_variable] = ACTIONS(4991),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4989),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4989),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9566] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10487),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7909),
    [sym_scope_resolution] = STATE(2981),
    [sym_call] = STATE(2981),
    [sym_method_call] = STATE(7909),
    [sym_assignment] = STATE(10487),
    [sym_operator_assignment] = STATE(10487),
    [sym_conditional] = STATE(10487),
    [sym_range] = STATE(10487),
    [sym_binary] = STATE(10487),
    [sym_unary] = STATE(10487),
    [sym_left_assignment_list] = STATE(7908),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7909),
    [sym__variable] = STATE(2981),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7909),
    [sym_false] = STATE(7909),
    [sym_nil] = STATE(7909),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2985),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11410),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4973),
    [anon_sym_yield] = ACTIONS(4975),
    [anon_sym_break] = ACTIONS(4977),
    [anon_sym_next] = ACTIONS(4979),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11412),
    [anon_sym_defined_QMARK] = ACTIONS(11414),
    [anon_sym_not] = ACTIONS(11416),
    [anon_sym_BANG] = ACTIONS(11418),
    [anon_sym_TILDE] = ACTIONS(11418),
    [sym_constant] = ACTIONS(4989),
    [sym_identifier] = ACTIONS(4989),
    [sym_instance_variable] = ACTIONS(4991),
    [sym_class_variable] = ACTIONS(4991),
    [sym_global_variable] = ACTIONS(4991),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4989),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4989),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9567] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10488),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7909),
    [sym_scope_resolution] = STATE(2981),
    [sym_call] = STATE(2981),
    [sym_method_call] = STATE(7909),
    [sym_splat_argument] = STATE(10489),
    [sym_assignment] = STATE(10488),
    [sym_operator_assignment] = STATE(10488),
    [sym_conditional] = STATE(10488),
    [sym_range] = STATE(10488),
    [sym_binary] = STATE(10488),
    [sym_unary] = STATE(10488),
    [sym_right_assignment_list] = STATE(2570),
    [sym__arg_or_splat_arg] = STATE(10489),
    [sym_left_assignment_list] = STATE(7908),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7909),
    [sym__variable] = STATE(2981),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7909),
    [sym_false] = STATE(7909),
    [sym_nil] = STATE(7909),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2985),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(8623),
    [sym__unary_minus] = ACTIONS(11410),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4973),
    [anon_sym_yield] = ACTIONS(4975),
    [anon_sym_break] = ACTIONS(4977),
    [anon_sym_next] = ACTIONS(4979),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11412),
    [anon_sym_defined_QMARK] = ACTIONS(11414),
    [anon_sym_not] = ACTIONS(11416),
    [anon_sym_BANG] = ACTIONS(11418),
    [anon_sym_TILDE] = ACTIONS(11418),
    [sym_constant] = ACTIONS(4989),
    [sym_identifier] = ACTIONS(4989),
    [sym_instance_variable] = ACTIONS(4991),
    [sym_class_variable] = ACTIONS(4991),
    [sym_global_variable] = ACTIONS(4991),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4989),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4989),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9568] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10490),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7909),
    [sym_scope_resolution] = STATE(2981),
    [sym_call] = STATE(2981),
    [sym_method_call] = STATE(7909),
    [sym_assignment] = STATE(10490),
    [sym_operator_assignment] = STATE(10490),
    [sym_conditional] = STATE(10490),
    [sym_range] = STATE(10490),
    [sym_binary] = STATE(10490),
    [sym_unary] = STATE(10490),
    [sym_left_assignment_list] = STATE(7908),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7909),
    [sym__variable] = STATE(2981),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7909),
    [sym_false] = STATE(7909),
    [sym_nil] = STATE(7909),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2985),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11410),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4973),
    [anon_sym_yield] = ACTIONS(4975),
    [anon_sym_break] = ACTIONS(4977),
    [anon_sym_next] = ACTIONS(4979),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11412),
    [anon_sym_defined_QMARK] = ACTIONS(11414),
    [anon_sym_not] = ACTIONS(11416),
    [anon_sym_BANG] = ACTIONS(11418),
    [anon_sym_TILDE] = ACTIONS(11418),
    [sym_constant] = ACTIONS(4989),
    [sym_identifier] = ACTIONS(4989),
    [sym_instance_variable] = ACTIONS(4991),
    [sym_class_variable] = ACTIONS(4991),
    [sym_global_variable] = ACTIONS(4991),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4989),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4989),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9569] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(13246),
    [sym__binary_star] = ACTIONS(13248),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(13250),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(13248),
    [anon_sym_AMP] = ACTIONS(13252),
    [anon_sym_LT] = ACTIONS(13254),
    [anon_sym_then] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(13256),
    [anon_sym_DOT_DOT] = ACTIONS(13258),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13260),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(13262),
    [anon_sym_AMP_AMP] = ACTIONS(13262),
    [anon_sym_LT_LT] = ACTIONS(13264),
    [anon_sym_GT_GT] = ACTIONS(13264),
    [anon_sym_EQ_EQ] = ACTIONS(13266),
    [anon_sym_BANG_EQ] = ACTIONS(13262),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13262),
    [anon_sym_LT_EQ_GT] = ACTIONS(13262),
    [anon_sym_EQ_TILDE] = ACTIONS(13262),
    [anon_sym_BANG_TILDE] = ACTIONS(13262),
    [anon_sym_LT_EQ] = ACTIONS(13254),
    [anon_sym_GT] = ACTIONS(13254),
    [anon_sym_GT_EQ] = ACTIONS(13268),
    [anon_sym_CARET] = ACTIONS(13270),
    [anon_sym_PLUS] = ACTIONS(13246),
    [anon_sym_SLASH] = ACTIONS(13248),
    [anon_sym_PERCENT] = ACTIONS(13248),
    [sym_comment] = ACTIONS(87),
  },
  [9570] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(13246),
    [sym__binary_star] = ACTIONS(13248),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(13250),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(13248),
    [anon_sym_AMP] = ACTIONS(13252),
    [anon_sym_LT] = ACTIONS(13254),
    [anon_sym_then] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(13256),
    [anon_sym_DOT_DOT] = ACTIONS(13258),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13260),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(13262),
    [anon_sym_AMP_AMP] = ACTIONS(13262),
    [anon_sym_LT_LT] = ACTIONS(13264),
    [anon_sym_GT_GT] = ACTIONS(13264),
    [anon_sym_EQ_EQ] = ACTIONS(13266),
    [anon_sym_BANG_EQ] = ACTIONS(13262),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13262),
    [anon_sym_LT_EQ_GT] = ACTIONS(13262),
    [anon_sym_EQ_TILDE] = ACTIONS(13262),
    [anon_sym_BANG_TILDE] = ACTIONS(13262),
    [anon_sym_LT_EQ] = ACTIONS(13254),
    [anon_sym_GT] = ACTIONS(13254),
    [anon_sym_GT_EQ] = ACTIONS(13268),
    [anon_sym_CARET] = ACTIONS(13270),
    [anon_sym_PLUS] = ACTIONS(13246),
    [anon_sym_SLASH] = ACTIONS(13248),
    [anon_sym_PERCENT] = ACTIONS(13248),
    [sym_comment] = ACTIONS(87),
  },
  [9571] = {
    [sym_heredoc_body] = STATE(9571),
    [aux_sym_call_repeat1] = STATE(9571),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(7916),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_then] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [9572] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5492),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3056),
    [sym_scope_resolution] = STATE(1172),
    [sym_call] = STATE(1172),
    [sym_method_call] = STATE(3056),
    [sym__argument] = STATE(4986),
    [sym_splat_argument] = STATE(4986),
    [sym_hash_splat_argument] = STATE(4986),
    [sym_block_argument] = STATE(4986),
    [sym_assignment] = STATE(5492),
    [sym_operator_assignment] = STATE(5492),
    [sym_conditional] = STATE(5492),
    [sym_range] = STATE(5492),
    [sym_binary] = STATE(5492),
    [sym_unary] = STATE(5492),
    [sym_left_assignment_list] = STATE(3055),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3056),
    [sym__variable] = STATE(1172),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3056),
    [sym_false] = STATE(3056),
    [sym_nil] = STATE(3056),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5495),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4986),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(8621),
    [sym__splat_star] = ACTIONS(8623),
    [sym__unary_minus] = ACTIONS(5081),
    [sym__identifier_hash_key] = ACTIONS(8625),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13278),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2085),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_next] = ACTIONS(2089),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8741),
    [anon_sym_defined_QMARK] = ACTIONS(5085),
    [anon_sym_not] = ACTIONS(5087),
    [anon_sym_BANG] = ACTIONS(5091),
    [anon_sym_TILDE] = ACTIONS(5091),
    [sym_constant] = ACTIONS(8627),
    [sym_identifier] = ACTIONS(8627),
    [sym_instance_variable] = ACTIONS(2105),
    [sym_class_variable] = ACTIONS(2105),
    [sym_global_variable] = ACTIONS(2105),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2103),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2103),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9573] = {
    [sym_heredoc_body] = STATE(9571),
    [aux_sym_call_repeat1] = STATE(9571),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_then] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [9574] = {
    [aux_sym_argument_list_repeat1] = STATE(9574),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(14155),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7925),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_then] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7925),
    [anon_sym_AMP_AMP] = ACTIONS(7925),
    [anon_sym_LT_LT] = ACTIONS(7925),
    [anon_sym_GT_GT] = ACTIONS(7925),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7925),
    [anon_sym_PLUS] = ACTIONS(7925),
    [anon_sym_SLASH] = ACTIONS(7925),
    [anon_sym_PERCENT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [9575] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(13326),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_when] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [9576] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10498),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(10500),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(10500),
    [sym_assignment] = STATE(10498),
    [sym_operator_assignment] = STATE(10498),
    [sym_conditional] = STATE(10498),
    [sym_range] = STATE(10498),
    [sym_binary] = STATE(10498),
    [sym_unary] = STATE(10498),
    [sym_left_assignment_list] = STATE(10499),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10500),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(10500),
    [sym_false] = STATE(10500),
    [sym_nil] = STATE(10500),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(10501),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(14158),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14160),
    [anon_sym_yield] = ACTIONS(14162),
    [anon_sym_break] = ACTIONS(14164),
    [anon_sym_next] = ACTIONS(14166),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14168),
    [anon_sym_defined_QMARK] = ACTIONS(14170),
    [anon_sym_not] = ACTIONS(14172),
    [anon_sym_BANG] = ACTIONS(14174),
    [anon_sym_TILDE] = ACTIONS(14174),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9577] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10502),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(10500),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(10500),
    [sym_assignment] = STATE(10502),
    [sym_operator_assignment] = STATE(10502),
    [sym_conditional] = STATE(10502),
    [sym_range] = STATE(10502),
    [sym_binary] = STATE(10502),
    [sym_unary] = STATE(10502),
    [sym_left_assignment_list] = STATE(10499),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10500),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(10500),
    [sym_false] = STATE(10500),
    [sym_nil] = STATE(10500),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(10501),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(14158),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14160),
    [anon_sym_yield] = ACTIONS(14162),
    [anon_sym_break] = ACTIONS(14164),
    [anon_sym_next] = ACTIONS(14166),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14168),
    [anon_sym_defined_QMARK] = ACTIONS(14170),
    [anon_sym_not] = ACTIONS(14172),
    [anon_sym_BANG] = ACTIONS(14174),
    [anon_sym_TILDE] = ACTIONS(14174),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9578] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10503),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9593),
    [sym_scope_resolution] = STATE(9589),
    [sym_call] = STATE(9589),
    [sym_method_call] = STATE(9593),
    [sym_assignment] = STATE(10503),
    [sym_operator_assignment] = STATE(10503),
    [sym_conditional] = STATE(10503),
    [sym_range] = STATE(10503),
    [sym_binary] = STATE(10503),
    [sym_unary] = STATE(10503),
    [sym_left_assignment_list] = STATE(9592),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9593),
    [sym__variable] = STATE(9589),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9593),
    [sym_false] = STATE(9593),
    [sym_nil] = STATE(9593),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(10504),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(13286),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13290),
    [anon_sym_yield] = ACTIONS(13292),
    [anon_sym_break] = ACTIONS(13294),
    [anon_sym_next] = ACTIONS(13296),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14176),
    [anon_sym_defined_QMARK] = ACTIONS(13298),
    [anon_sym_not] = ACTIONS(13300),
    [anon_sym_BANG] = ACTIONS(13304),
    [anon_sym_TILDE] = ACTIONS(13304),
    [sym_constant] = ACTIONS(13310),
    [sym_identifier] = ACTIONS(13310),
    [sym_instance_variable] = ACTIONS(13308),
    [sym_class_variable] = ACTIONS(13308),
    [sym_global_variable] = ACTIONS(13308),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(13310),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13310),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9579] = {
    [anon_sym_COLON] = ACTIONS(14178),
    [sym_comment] = ACTIONS(87),
  },
  [9580] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10506),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(10500),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(10500),
    [sym_assignment] = STATE(10506),
    [sym_operator_assignment] = STATE(10506),
    [sym_conditional] = STATE(10506),
    [sym_range] = STATE(10506),
    [sym_binary] = STATE(10506),
    [sym_unary] = STATE(10506),
    [sym_left_assignment_list] = STATE(10499),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10500),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(10500),
    [sym_false] = STATE(10500),
    [sym_nil] = STATE(10500),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(10501),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(14158),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14160),
    [anon_sym_yield] = ACTIONS(14162),
    [anon_sym_break] = ACTIONS(14164),
    [anon_sym_next] = ACTIONS(14166),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14168),
    [anon_sym_defined_QMARK] = ACTIONS(14170),
    [anon_sym_not] = ACTIONS(14172),
    [anon_sym_BANG] = ACTIONS(14174),
    [anon_sym_TILDE] = ACTIONS(14174),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9581] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10512),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9593),
    [sym_scope_resolution] = STATE(9589),
    [sym_call] = STATE(9589),
    [sym_method_call] = STATE(9593),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(10513),
    [sym__argument] = STATE(10514),
    [sym_splat_argument] = STATE(10514),
    [sym_hash_splat_argument] = STATE(10514),
    [sym_block_argument] = STATE(10514),
    [sym_assignment] = STATE(10512),
    [sym_operator_assignment] = STATE(10512),
    [sym_conditional] = STATE(10512),
    [sym_range] = STATE(10512),
    [sym_binary] = STATE(10512),
    [sym_unary] = STATE(10512),
    [sym_left_assignment_list] = STATE(9592),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9593),
    [sym__variable] = STATE(9589),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9593),
    [sym_false] = STATE(9593),
    [sym_nil] = STATE(9593),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(10515),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(10514),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(14180),
    [sym__splat_star] = ACTIONS(14182),
    [sym__unary_minus] = ACTIONS(13286),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(14184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(13290),
    [anon_sym_yield] = ACTIONS(13292),
    [anon_sym_break] = ACTIONS(13294),
    [anon_sym_next] = ACTIONS(13296),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_when] = ACTIONS(377),
    [anon_sym_else] = ACTIONS(377),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(13298),
    [anon_sym_not] = ACTIONS(13300),
    [anon_sym_BANG] = ACTIONS(13302),
    [anon_sym_TILDE] = ACTIONS(13304),
    [sym_constant] = ACTIONS(14186),
    [sym_identifier] = ACTIONS(14186),
    [sym_instance_variable] = ACTIONS(13308),
    [sym_class_variable] = ACTIONS(13308),
    [sym_global_variable] = ACTIONS(13308),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(13310),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13310),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9582] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10512),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9593),
    [sym_scope_resolution] = STATE(9589),
    [sym_call] = STATE(9589),
    [sym_method_call] = STATE(9593),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(10513),
    [sym__argument] = STATE(10514),
    [sym_splat_argument] = STATE(10514),
    [sym_hash_splat_argument] = STATE(10514),
    [sym_block_argument] = STATE(10514),
    [sym_assignment] = STATE(10512),
    [sym_operator_assignment] = STATE(10512),
    [sym_conditional] = STATE(10512),
    [sym_range] = STATE(10512),
    [sym_binary] = STATE(10512),
    [sym_unary] = STATE(10512),
    [sym_left_assignment_list] = STATE(9592),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9593),
    [sym__variable] = STATE(9589),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9593),
    [sym_false] = STATE(9593),
    [sym_nil] = STATE(9593),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(10515),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(10514),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(14180),
    [sym__splat_star] = ACTIONS(14182),
    [sym__unary_minus] = ACTIONS(13286),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(14184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(13290),
    [anon_sym_yield] = ACTIONS(13292),
    [anon_sym_break] = ACTIONS(13294),
    [anon_sym_next] = ACTIONS(13296),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_when] = ACTIONS(419),
    [anon_sym_else] = ACTIONS(419),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(13298),
    [anon_sym_not] = ACTIONS(13300),
    [anon_sym_BANG] = ACTIONS(13302),
    [anon_sym_TILDE] = ACTIONS(13304),
    [sym_constant] = ACTIONS(14186),
    [sym_identifier] = ACTIONS(14186),
    [sym_instance_variable] = ACTIONS(13308),
    [sym_class_variable] = ACTIONS(13308),
    [sym_global_variable] = ACTIONS(13308),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(13310),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13310),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9583] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10512),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9593),
    [sym_scope_resolution] = STATE(9589),
    [sym_call] = STATE(9589),
    [sym_method_call] = STATE(9593),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(10513),
    [sym__argument] = STATE(10514),
    [sym_splat_argument] = STATE(10514),
    [sym_hash_splat_argument] = STATE(10514),
    [sym_block_argument] = STATE(10514),
    [sym_assignment] = STATE(10512),
    [sym_operator_assignment] = STATE(10512),
    [sym_conditional] = STATE(10512),
    [sym_range] = STATE(10512),
    [sym_binary] = STATE(10512),
    [sym_unary] = STATE(10512),
    [sym_left_assignment_list] = STATE(9592),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9593),
    [sym__variable] = STATE(9589),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9593),
    [sym_false] = STATE(9593),
    [sym_nil] = STATE(9593),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(10515),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(10514),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(14180),
    [sym__splat_star] = ACTIONS(14182),
    [sym__unary_minus] = ACTIONS(13286),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(14184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(423),
    [anon_sym_return] = ACTIONS(13290),
    [anon_sym_yield] = ACTIONS(13292),
    [anon_sym_break] = ACTIONS(13294),
    [anon_sym_next] = ACTIONS(13296),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_when] = ACTIONS(423),
    [anon_sym_else] = ACTIONS(423),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(13298),
    [anon_sym_not] = ACTIONS(13300),
    [anon_sym_BANG] = ACTIONS(13302),
    [anon_sym_TILDE] = ACTIONS(13304),
    [sym_constant] = ACTIONS(14186),
    [sym_identifier] = ACTIONS(14186),
    [sym_instance_variable] = ACTIONS(13308),
    [sym_class_variable] = ACTIONS(13308),
    [sym_global_variable] = ACTIONS(13308),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(13310),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13310),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9584] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10512),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9593),
    [sym_scope_resolution] = STATE(9589),
    [sym_call] = STATE(9589),
    [sym_method_call] = STATE(9593),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(10513),
    [sym__argument] = STATE(10514),
    [sym_splat_argument] = STATE(10514),
    [sym_hash_splat_argument] = STATE(10514),
    [sym_block_argument] = STATE(10514),
    [sym_assignment] = STATE(10512),
    [sym_operator_assignment] = STATE(10512),
    [sym_conditional] = STATE(10512),
    [sym_range] = STATE(10512),
    [sym_binary] = STATE(10512),
    [sym_unary] = STATE(10512),
    [sym_left_assignment_list] = STATE(9592),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9593),
    [sym__variable] = STATE(9589),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9593),
    [sym_false] = STATE(9593),
    [sym_nil] = STATE(9593),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(10515),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(10514),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(14180),
    [sym__splat_star] = ACTIONS(14182),
    [sym__unary_minus] = ACTIONS(13286),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(14184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(427),
    [anon_sym_return] = ACTIONS(13290),
    [anon_sym_yield] = ACTIONS(13292),
    [anon_sym_break] = ACTIONS(13294),
    [anon_sym_next] = ACTIONS(13296),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_when] = ACTIONS(427),
    [anon_sym_else] = ACTIONS(427),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(13298),
    [anon_sym_not] = ACTIONS(13300),
    [anon_sym_BANG] = ACTIONS(13302),
    [anon_sym_TILDE] = ACTIONS(13304),
    [sym_constant] = ACTIONS(14186),
    [sym_identifier] = ACTIONS(14186),
    [sym_instance_variable] = ACTIONS(13308),
    [sym_class_variable] = ACTIONS(13308),
    [sym_global_variable] = ACTIONS(13308),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(13310),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13310),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9585] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10516),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9593),
    [sym_scope_resolution] = STATE(9589),
    [sym_call] = STATE(9589),
    [sym_method_call] = STATE(9593),
    [sym_assignment] = STATE(10516),
    [sym_operator_assignment] = STATE(10516),
    [sym_conditional] = STATE(10516),
    [sym_range] = STATE(10516),
    [sym_binary] = STATE(10516),
    [sym_unary] = STATE(10516),
    [sym_left_assignment_list] = STATE(9592),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9593),
    [sym__variable] = STATE(9589),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9593),
    [sym_false] = STATE(9593),
    [sym_nil] = STATE(9593),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(10504),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(13286),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13290),
    [anon_sym_yield] = ACTIONS(13292),
    [anon_sym_break] = ACTIONS(13294),
    [anon_sym_next] = ACTIONS(13296),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14176),
    [anon_sym_defined_QMARK] = ACTIONS(13298),
    [anon_sym_not] = ACTIONS(13300),
    [anon_sym_BANG] = ACTIONS(13304),
    [anon_sym_TILDE] = ACTIONS(13304),
    [sym_constant] = ACTIONS(13310),
    [sym_identifier] = ACTIONS(13310),
    [sym_instance_variable] = ACTIONS(13308),
    [sym_class_variable] = ACTIONS(13308),
    [sym_global_variable] = ACTIONS(13308),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(13310),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13310),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9586] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9593),
    [sym_scope_resolution] = STATE(9589),
    [sym_call] = STATE(9589),
    [sym_method_call] = STATE(9593),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(9592),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9593),
    [sym__variable] = STATE(9589),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9593),
    [sym_false] = STATE(9593),
    [sym_nil] = STATE(9593),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(10504),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(13286),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13290),
    [anon_sym_yield] = ACTIONS(13292),
    [anon_sym_break] = ACTIONS(13294),
    [anon_sym_next] = ACTIONS(13296),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14176),
    [anon_sym_defined_QMARK] = ACTIONS(13298),
    [anon_sym_not] = ACTIONS(13300),
    [anon_sym_BANG] = ACTIONS(13304),
    [anon_sym_TILDE] = ACTIONS(13304),
    [sym_constant] = ACTIONS(13310),
    [sym_identifier] = ACTIONS(13310),
    [sym_instance_variable] = ACTIONS(13308),
    [sym_class_variable] = ACTIONS(13308),
    [sym_global_variable] = ACTIONS(13308),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(13310),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13310),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9587] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(14188),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(1091),
    [anon_sym_else] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [9588] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(14190),
    [sym__binary_star] = ACTIONS(14192),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(14194),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(14192),
    [anon_sym_AMP] = ACTIONS(14196),
    [anon_sym_LT] = ACTIONS(14198),
    [anon_sym_end] = ACTIONS(1625),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_unless] = ACTIONS(1625),
    [anon_sym_while] = ACTIONS(1625),
    [anon_sym_until] = ACTIONS(1625),
    [anon_sym_rescue] = ACTIONS(1625),
    [anon_sym_when] = ACTIONS(1625),
    [anon_sym_else] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(14178),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(14200),
    [anon_sym_DOT_DOT] = ACTIONS(14202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14204),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(14206),
    [anon_sym_AMP_AMP] = ACTIONS(14206),
    [anon_sym_LT_LT] = ACTIONS(14208),
    [anon_sym_GT_GT] = ACTIONS(14208),
    [anon_sym_EQ_EQ] = ACTIONS(14210),
    [anon_sym_BANG_EQ] = ACTIONS(14206),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14206),
    [anon_sym_LT_EQ_GT] = ACTIONS(14206),
    [anon_sym_EQ_TILDE] = ACTIONS(14206),
    [anon_sym_BANG_TILDE] = ACTIONS(14206),
    [anon_sym_LT_EQ] = ACTIONS(14198),
    [anon_sym_GT] = ACTIONS(14198),
    [anon_sym_GT_EQ] = ACTIONS(14212),
    [anon_sym_CARET] = ACTIONS(14214),
    [anon_sym_PLUS] = ACTIONS(14190),
    [anon_sym_SLASH] = ACTIONS(14192),
    [anon_sym_PERCENT] = ACTIONS(14192),
    [sym_comment] = ACTIONS(87),
  },
  [9589] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(10533),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(9629),
    [sym_scope_resolution] = STATE(9625),
    [sym_call] = STATE(9625),
    [sym_method_call] = STATE(9629),
    [sym_argument_list] = STATE(938),
    [sym__argument_list_with_parens] = STATE(10534),
    [sym__argument] = STATE(10535),
    [sym_splat_argument] = STATE(10535),
    [sym_hash_splat_argument] = STATE(10535),
    [sym_block_argument] = STATE(10535),
    [sym_do_block] = STATE(941),
    [sym_block] = STATE(941),
    [sym_assignment] = STATE(10533),
    [sym_operator_assignment] = STATE(10533),
    [sym_conditional] = STATE(10533),
    [sym_range] = STATE(10533),
    [sym_binary] = STATE(10533),
    [sym_unary] = STATE(10533),
    [sym_left_assignment_list] = STATE(9628),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9629),
    [sym__variable] = STATE(9625),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(9629),
    [sym_false] = STATE(9629),
    [sym_nil] = STATE(9629),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(10536),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(10535),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(743),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(14216),
    [sym__splat_star] = ACTIONS(14218),
    [sym__unary_minus] = ACTIONS(13356),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(14220),
    [anon_sym_LBRACE] = ACTIONS(1669),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(769),
    [anon_sym_return] = ACTIONS(13360),
    [anon_sym_yield] = ACTIONS(13362),
    [anon_sym_break] = ACTIONS(13364),
    [anon_sym_next] = ACTIONS(13366),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(769),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(769),
    [anon_sym_until] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(769),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(1671),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_when] = ACTIONS(769),
    [anon_sym_else] = ACTIONS(769),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(13368),
    [anon_sym_not] = ACTIONS(13370),
    [anon_sym_BANG] = ACTIONS(13372),
    [anon_sym_TILDE] = ACTIONS(13374),
    [sym_constant] = ACTIONS(14222),
    [sym_identifier] = ACTIONS(14222),
    [sym_instance_variable] = ACTIONS(13378),
    [sym_class_variable] = ACTIONS(13378),
    [sym_global_variable] = ACTIONS(13378),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(13380),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13380),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [9590] = {
    [sym_heredoc_body] = STATE(10537),
    [aux_sym_call_repeat1] = STATE(10537),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_when] = ACTIONS(1681),
    [anon_sym_else] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [9591] = {
    [sym_heredoc_body] = STATE(10537),
    [aux_sym_call_repeat1] = STATE(10537),
    [aux_sym_argument_list_repeat1] = STATE(10539),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(14224),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_when] = ACTIONS(1681),
    [anon_sym_else] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [9592] = {
    [anon_sym_EQ] = ACTIONS(14226),
    [sym_comment] = ACTIONS(87),
  },
  [9593] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(14228),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_when] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(14230),
    [anon_sym_DASH_EQ] = ACTIONS(14230),
    [anon_sym_STAR_EQ] = ACTIONS(14230),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14230),
    [anon_sym_SLASH_EQ] = ACTIONS(14230),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14230),
    [anon_sym_PIPE_EQ] = ACTIONS(14230),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14230),
    [anon_sym_AMP_EQ] = ACTIONS(14230),
    [anon_sym_PERCENT_EQ] = ACTIONS(14230),
    [anon_sym_GT_GT_EQ] = ACTIONS(14230),
    [anon_sym_LT_LT_EQ] = ACTIONS(14230),
    [anon_sym_CARET_EQ] = ACTIONS(14230),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [9594] = {
    [sym_string] = STATE(10542),
    [aux_sym_chained_string_repeat1] = STATE(10542),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(14232),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_when] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [9595] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(13324),
    [sym__binary_star] = ACTIONS(13326),
    [anon_sym_PIPE] = ACTIONS(13328),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(13326),
    [anon_sym_AMP] = ACTIONS(13330),
    [anon_sym_LT] = ACTIONS(13332),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_when] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(13334),
    [anon_sym_DOT_DOT] = ACTIONS(13336),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13338),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(13342),
    [anon_sym_AMP_AMP] = ACTIONS(13342),
    [anon_sym_LT_LT] = ACTIONS(13344),
    [anon_sym_GT_GT] = ACTIONS(13344),
    [anon_sym_EQ_EQ] = ACTIONS(13346),
    [anon_sym_BANG_EQ] = ACTIONS(13342),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13342),
    [anon_sym_LT_EQ_GT] = ACTIONS(13342),
    [anon_sym_EQ_TILDE] = ACTIONS(13342),
    [anon_sym_BANG_TILDE] = ACTIONS(13342),
    [anon_sym_LT_EQ] = ACTIONS(13332),
    [anon_sym_GT] = ACTIONS(13332),
    [anon_sym_GT_EQ] = ACTIONS(13348),
    [anon_sym_CARET] = ACTIONS(13350),
    [anon_sym_PLUS] = ACTIONS(13324),
    [anon_sym_SLASH] = ACTIONS(13326),
    [anon_sym_PERCENT] = ACTIONS(13326),
    [sym_comment] = ACTIONS(87),
  },
  [9596] = {
    [aux_sym_undef_repeat1] = STATE(10543),
    [sym__line_break] = ACTIONS(2251),
    [sym__heredoc_body_start] = ACTIONS(2251),
    [anon_sym_COMMA] = ACTIONS(2253),
    [anon_sym_SEMI] = ACTIONS(2251),
    [anon_sym_end] = ACTIONS(2251),
    [anon_sym_if] = ACTIONS(2251),
    [anon_sym_unless] = ACTIONS(2251),
    [anon_sym_while] = ACTIONS(2251),
    [anon_sym_until] = ACTIONS(2251),
    [anon_sym_rescue] = ACTIONS(2251),
    [anon_sym_when] = ACTIONS(2251),
    [anon_sym_else] = ACTIONS(2251),
    [sym_comment] = ACTIONS(87),
  },
  [9597] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10544),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7930),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(7930),
    [sym_assignment] = STATE(10544),
    [sym_operator_assignment] = STATE(10544),
    [sym_conditional] = STATE(10544),
    [sym_range] = STATE(10544),
    [sym_binary] = STATE(10544),
    [sym_unary] = STATE(10544),
    [sym_left_assignment_list] = STATE(7929),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7930),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7930),
    [sym_false] = STATE(7930),
    [sym_nil] = STATE(7930),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7931),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11428),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11430),
    [anon_sym_yield] = ACTIONS(11432),
    [anon_sym_break] = ACTIONS(11434),
    [anon_sym_next] = ACTIONS(11436),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11438),
    [anon_sym_defined_QMARK] = ACTIONS(11440),
    [anon_sym_not] = ACTIONS(11442),
    [anon_sym_BANG] = ACTIONS(11444),
    [anon_sym_TILDE] = ACTIONS(11444),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9598] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10545),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7930),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(7930),
    [sym_assignment] = STATE(10545),
    [sym_operator_assignment] = STATE(10545),
    [sym_conditional] = STATE(10545),
    [sym_range] = STATE(10545),
    [sym_binary] = STATE(10545),
    [sym_unary] = STATE(10545),
    [sym_left_assignment_list] = STATE(7929),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7930),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7930),
    [sym_false] = STATE(7930),
    [sym_nil] = STATE(7930),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7931),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11428),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11430),
    [anon_sym_yield] = ACTIONS(11432),
    [anon_sym_break] = ACTIONS(11434),
    [anon_sym_next] = ACTIONS(11436),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11438),
    [anon_sym_defined_QMARK] = ACTIONS(11440),
    [anon_sym_not] = ACTIONS(11442),
    [anon_sym_BANG] = ACTIONS(11444),
    [anon_sym_TILDE] = ACTIONS(11444),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9599] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10546),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7930),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(7930),
    [sym_assignment] = STATE(10546),
    [sym_operator_assignment] = STATE(10546),
    [sym_conditional] = STATE(10546),
    [sym_range] = STATE(10546),
    [sym_binary] = STATE(10546),
    [sym_unary] = STATE(10546),
    [sym_left_assignment_list] = STATE(7929),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7930),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7930),
    [sym_false] = STATE(7930),
    [sym_nil] = STATE(7930),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7931),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11428),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11430),
    [anon_sym_yield] = ACTIONS(11432),
    [anon_sym_break] = ACTIONS(11434),
    [anon_sym_next] = ACTIONS(11436),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11438),
    [anon_sym_defined_QMARK] = ACTIONS(11440),
    [anon_sym_not] = ACTIONS(11442),
    [anon_sym_BANG] = ACTIONS(11444),
    [anon_sym_TILDE] = ACTIONS(11444),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9600] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10547),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7930),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(7930),
    [sym_assignment] = STATE(10547),
    [sym_operator_assignment] = STATE(10547),
    [sym_conditional] = STATE(10547),
    [sym_range] = STATE(10547),
    [sym_binary] = STATE(10547),
    [sym_unary] = STATE(10547),
    [sym_left_assignment_list] = STATE(7929),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7930),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7930),
    [sym_false] = STATE(7930),
    [sym_nil] = STATE(7930),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7931),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11428),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11430),
    [anon_sym_yield] = ACTIONS(11432),
    [anon_sym_break] = ACTIONS(11434),
    [anon_sym_next] = ACTIONS(11436),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11438),
    [anon_sym_defined_QMARK] = ACTIONS(11440),
    [anon_sym_not] = ACTIONS(11442),
    [anon_sym_BANG] = ACTIONS(11444),
    [anon_sym_TILDE] = ACTIONS(11444),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9601] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10548),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7930),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(7930),
    [sym_assignment] = STATE(10548),
    [sym_operator_assignment] = STATE(10548),
    [sym_conditional] = STATE(10548),
    [sym_range] = STATE(10548),
    [sym_binary] = STATE(10548),
    [sym_unary] = STATE(10548),
    [sym_left_assignment_list] = STATE(7929),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7930),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7930),
    [sym_false] = STATE(7930),
    [sym_nil] = STATE(7930),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7931),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11428),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11430),
    [anon_sym_yield] = ACTIONS(11432),
    [anon_sym_break] = ACTIONS(11434),
    [anon_sym_next] = ACTIONS(11436),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11438),
    [anon_sym_defined_QMARK] = ACTIONS(11440),
    [anon_sym_not] = ACTIONS(11442),
    [anon_sym_BANG] = ACTIONS(11444),
    [anon_sym_TILDE] = ACTIONS(11444),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9602] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10549),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7930),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(7930),
    [sym_assignment] = STATE(10549),
    [sym_operator_assignment] = STATE(10549),
    [sym_conditional] = STATE(10549),
    [sym_range] = STATE(10549),
    [sym_binary] = STATE(10549),
    [sym_unary] = STATE(10549),
    [sym_left_assignment_list] = STATE(7929),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7930),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7930),
    [sym_false] = STATE(7930),
    [sym_nil] = STATE(7930),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7931),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11428),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11430),
    [anon_sym_yield] = ACTIONS(11432),
    [anon_sym_break] = ACTIONS(11434),
    [anon_sym_next] = ACTIONS(11436),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11438),
    [anon_sym_defined_QMARK] = ACTIONS(11440),
    [anon_sym_not] = ACTIONS(11442),
    [anon_sym_BANG] = ACTIONS(11444),
    [anon_sym_TILDE] = ACTIONS(11444),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9603] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10550),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7930),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(7930),
    [sym_assignment] = STATE(10550),
    [sym_operator_assignment] = STATE(10550),
    [sym_conditional] = STATE(10550),
    [sym_range] = STATE(10550),
    [sym_binary] = STATE(10550),
    [sym_unary] = STATE(10550),
    [sym_left_assignment_list] = STATE(7929),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7930),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7930),
    [sym_false] = STATE(7930),
    [sym_nil] = STATE(7930),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7931),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11428),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11430),
    [anon_sym_yield] = ACTIONS(11432),
    [anon_sym_break] = ACTIONS(11434),
    [anon_sym_next] = ACTIONS(11436),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11438),
    [anon_sym_defined_QMARK] = ACTIONS(11440),
    [anon_sym_not] = ACTIONS(11442),
    [anon_sym_BANG] = ACTIONS(11444),
    [anon_sym_TILDE] = ACTIONS(11444),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9604] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10551),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7930),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(7930),
    [sym_assignment] = STATE(10551),
    [sym_operator_assignment] = STATE(10551),
    [sym_conditional] = STATE(10551),
    [sym_range] = STATE(10551),
    [sym_binary] = STATE(10551),
    [sym_unary] = STATE(10551),
    [sym_left_assignment_list] = STATE(7929),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7930),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7930),
    [sym_false] = STATE(7930),
    [sym_nil] = STATE(7930),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7931),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11428),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11430),
    [anon_sym_yield] = ACTIONS(11432),
    [anon_sym_break] = ACTIONS(11434),
    [anon_sym_next] = ACTIONS(11436),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11438),
    [anon_sym_defined_QMARK] = ACTIONS(11440),
    [anon_sym_not] = ACTIONS(11442),
    [anon_sym_BANG] = ACTIONS(11444),
    [anon_sym_TILDE] = ACTIONS(11444),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9605] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10552),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7930),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(7930),
    [sym_assignment] = STATE(10552),
    [sym_operator_assignment] = STATE(10552),
    [sym_conditional] = STATE(10552),
    [sym_range] = STATE(10552),
    [sym_binary] = STATE(10552),
    [sym_unary] = STATE(10552),
    [sym_left_assignment_list] = STATE(7929),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7930),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7930),
    [sym_false] = STATE(7930),
    [sym_nil] = STATE(7930),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7931),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11428),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11430),
    [anon_sym_yield] = ACTIONS(11432),
    [anon_sym_break] = ACTIONS(11434),
    [anon_sym_next] = ACTIONS(11436),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11438),
    [anon_sym_defined_QMARK] = ACTIONS(11440),
    [anon_sym_not] = ACTIONS(11442),
    [anon_sym_BANG] = ACTIONS(11444),
    [anon_sym_TILDE] = ACTIONS(11444),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9606] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10553),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7930),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(7930),
    [sym_assignment] = STATE(10553),
    [sym_operator_assignment] = STATE(10553),
    [sym_conditional] = STATE(10553),
    [sym_range] = STATE(10553),
    [sym_binary] = STATE(10553),
    [sym_unary] = STATE(10553),
    [sym_left_assignment_list] = STATE(7929),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7930),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7930),
    [sym_false] = STATE(7930),
    [sym_nil] = STATE(7930),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7931),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11428),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11430),
    [anon_sym_yield] = ACTIONS(11432),
    [anon_sym_break] = ACTIONS(11434),
    [anon_sym_next] = ACTIONS(11436),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11438),
    [anon_sym_defined_QMARK] = ACTIONS(11440),
    [anon_sym_not] = ACTIONS(11442),
    [anon_sym_BANG] = ACTIONS(11444),
    [anon_sym_TILDE] = ACTIONS(11444),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9607] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(10554),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(10554),
    [sym_operator_assignment] = STATE(10554),
    [sym_conditional] = STATE(10554),
    [sym_range] = STATE(10554),
    [sym_binary] = STATE(10554),
    [sym_unary] = STATE(10554),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9608] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10555),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7930),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(7930),
    [sym_assignment] = STATE(10555),
    [sym_operator_assignment] = STATE(10555),
    [sym_conditional] = STATE(10555),
    [sym_range] = STATE(10555),
    [sym_binary] = STATE(10555),
    [sym_unary] = STATE(10555),
    [sym_left_assignment_list] = STATE(7929),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7930),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7930),
    [sym_false] = STATE(7930),
    [sym_nil] = STATE(7930),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7931),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11428),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11430),
    [anon_sym_yield] = ACTIONS(11432),
    [anon_sym_break] = ACTIONS(11434),
    [anon_sym_next] = ACTIONS(11436),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11438),
    [anon_sym_defined_QMARK] = ACTIONS(11440),
    [anon_sym_not] = ACTIONS(11442),
    [anon_sym_BANG] = ACTIONS(11444),
    [anon_sym_TILDE] = ACTIONS(11444),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9609] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10556),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7930),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(7930),
    [sym_assignment] = STATE(10556),
    [sym_operator_assignment] = STATE(10556),
    [sym_conditional] = STATE(10556),
    [sym_range] = STATE(10556),
    [sym_binary] = STATE(10556),
    [sym_unary] = STATE(10556),
    [sym_left_assignment_list] = STATE(7929),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7930),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7930),
    [sym_false] = STATE(7930),
    [sym_nil] = STATE(7930),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7931),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11428),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11430),
    [anon_sym_yield] = ACTIONS(11432),
    [anon_sym_break] = ACTIONS(11434),
    [anon_sym_next] = ACTIONS(11436),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11438),
    [anon_sym_defined_QMARK] = ACTIONS(11440),
    [anon_sym_not] = ACTIONS(11442),
    [anon_sym_BANG] = ACTIONS(11444),
    [anon_sym_TILDE] = ACTIONS(11444),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9610] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10557),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7930),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(7930),
    [sym_assignment] = STATE(10557),
    [sym_operator_assignment] = STATE(10557),
    [sym_conditional] = STATE(10557),
    [sym_range] = STATE(10557),
    [sym_binary] = STATE(10557),
    [sym_unary] = STATE(10557),
    [sym_left_assignment_list] = STATE(7929),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7930),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7930),
    [sym_false] = STATE(7930),
    [sym_nil] = STATE(7930),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7931),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11428),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11430),
    [anon_sym_yield] = ACTIONS(11432),
    [anon_sym_break] = ACTIONS(11434),
    [anon_sym_next] = ACTIONS(11436),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11438),
    [anon_sym_defined_QMARK] = ACTIONS(11440),
    [anon_sym_not] = ACTIONS(11442),
    [anon_sym_BANG] = ACTIONS(11444),
    [anon_sym_TILDE] = ACTIONS(11444),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9611] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10558),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7930),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(7930),
    [sym_assignment] = STATE(10558),
    [sym_operator_assignment] = STATE(10558),
    [sym_conditional] = STATE(10558),
    [sym_range] = STATE(10558),
    [sym_binary] = STATE(10558),
    [sym_unary] = STATE(10558),
    [sym_left_assignment_list] = STATE(7929),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7930),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7930),
    [sym_false] = STATE(7930),
    [sym_nil] = STATE(7930),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7931),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11428),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11430),
    [anon_sym_yield] = ACTIONS(11432),
    [anon_sym_break] = ACTIONS(11434),
    [anon_sym_next] = ACTIONS(11436),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11438),
    [anon_sym_defined_QMARK] = ACTIONS(11440),
    [anon_sym_not] = ACTIONS(11442),
    [anon_sym_BANG] = ACTIONS(11444),
    [anon_sym_TILDE] = ACTIONS(11444),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9612] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10566),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(10569),
    [sym_scope_resolution] = STATE(10567),
    [sym_call] = STATE(10567),
    [sym_method_call] = STATE(10569),
    [sym_assignment] = STATE(10566),
    [sym_operator_assignment] = STATE(10566),
    [sym_conditional] = STATE(10566),
    [sym_range] = STATE(10566),
    [sym_binary] = STATE(10566),
    [sym_unary] = STATE(10566),
    [sym_left_assignment_list] = STATE(10568),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10569),
    [sym__variable] = STATE(10567),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(10569),
    [sym_false] = STATE(10569),
    [sym_nil] = STATE(10569),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(10570),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(14234),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(14236),
    [anon_sym_yield] = ACTIONS(14238),
    [anon_sym_break] = ACTIONS(14240),
    [anon_sym_next] = ACTIONS(14242),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(14244),
    [anon_sym_defined_QMARK] = ACTIONS(14246),
    [anon_sym_not] = ACTIONS(14248),
    [anon_sym_BANG] = ACTIONS(14250),
    [anon_sym_TILDE] = ACTIONS(14250),
    [sym_constant] = ACTIONS(14252),
    [sym_identifier] = ACTIONS(14252),
    [sym_instance_variable] = ACTIONS(14254),
    [sym_class_variable] = ACTIONS(14254),
    [sym_global_variable] = ACTIONS(14254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(14252),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(14252),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [9613] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10571),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(10569),
    [sym_scope_resolution] = STATE(10567),
    [sym_call] = STATE(10567),
    [sym_method_call] = STATE(10569),
    [sym_assignment] = STATE(10571),
    [sym_operator_assignment] = STATE(10571),
    [sym_conditional] = STATE(10571),
    [sym_range] = STATE(10571),
    [sym_binary] = STATE(10571),
    [sym_unary] = STATE(10571),
    [sym_left_assignment_list] = STATE(10568),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10569),
    [sym__variable] = STATE(10567),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(10569),
    [sym_false] = STATE(10569),
    [sym_nil] = STATE(10569),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(10570),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(14234),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(14236),
    [anon_sym_yield] = ACTIONS(14238),
    [anon_sym_break] = ACTIONS(14240),
    [anon_sym_next] = ACTIONS(14242),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(14244),
    [anon_sym_defined_QMARK] = ACTIONS(14246),
    [anon_sym_not] = ACTIONS(14248),
    [anon_sym_BANG] = ACTIONS(14250),
    [anon_sym_TILDE] = ACTIONS(14250),
    [sym_constant] = ACTIONS(14252),
    [sym_identifier] = ACTIONS(14252),
    [sym_instance_variable] = ACTIONS(14254),
    [sym_class_variable] = ACTIONS(14254),
    [sym_global_variable] = ACTIONS(14254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(14252),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(14252),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [9614] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(10572),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(9629),
    [sym_scope_resolution] = STATE(9625),
    [sym_call] = STATE(9625),
    [sym_method_call] = STATE(9629),
    [sym_assignment] = STATE(10572),
    [sym_operator_assignment] = STATE(10572),
    [sym_conditional] = STATE(10572),
    [sym_range] = STATE(10572),
    [sym_binary] = STATE(10572),
    [sym_unary] = STATE(10572),
    [sym_left_assignment_list] = STATE(9628),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9629),
    [sym__variable] = STATE(9625),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(9629),
    [sym_false] = STATE(9629),
    [sym_nil] = STATE(9629),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(10573),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(13356),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(13360),
    [anon_sym_yield] = ACTIONS(13362),
    [anon_sym_break] = ACTIONS(13364),
    [anon_sym_next] = ACTIONS(13366),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(14256),
    [anon_sym_defined_QMARK] = ACTIONS(13368),
    [anon_sym_not] = ACTIONS(13370),
    [anon_sym_BANG] = ACTIONS(13374),
    [anon_sym_TILDE] = ACTIONS(13374),
    [sym_constant] = ACTIONS(13380),
    [sym_identifier] = ACTIONS(13380),
    [sym_instance_variable] = ACTIONS(13378),
    [sym_class_variable] = ACTIONS(13378),
    [sym_global_variable] = ACTIONS(13378),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(13380),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13380),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [9615] = {
    [anon_sym_COLON] = ACTIONS(14258),
    [sym_comment] = ACTIONS(87),
  },
  [9616] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10575),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(10569),
    [sym_scope_resolution] = STATE(10567),
    [sym_call] = STATE(10567),
    [sym_method_call] = STATE(10569),
    [sym_assignment] = STATE(10575),
    [sym_operator_assignment] = STATE(10575),
    [sym_conditional] = STATE(10575),
    [sym_range] = STATE(10575),
    [sym_binary] = STATE(10575),
    [sym_unary] = STATE(10575),
    [sym_left_assignment_list] = STATE(10568),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10569),
    [sym__variable] = STATE(10567),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(10569),
    [sym_false] = STATE(10569),
    [sym_nil] = STATE(10569),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(10570),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(14234),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(14236),
    [anon_sym_yield] = ACTIONS(14238),
    [anon_sym_break] = ACTIONS(14240),
    [anon_sym_next] = ACTIONS(14242),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(14244),
    [anon_sym_defined_QMARK] = ACTIONS(14246),
    [anon_sym_not] = ACTIONS(14248),
    [anon_sym_BANG] = ACTIONS(14250),
    [anon_sym_TILDE] = ACTIONS(14250),
    [sym_constant] = ACTIONS(14252),
    [sym_identifier] = ACTIONS(14252),
    [sym_instance_variable] = ACTIONS(14254),
    [sym_class_variable] = ACTIONS(14254),
    [sym_global_variable] = ACTIONS(14254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(14252),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(14252),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [9617] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(10533),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(9629),
    [sym_scope_resolution] = STATE(9625),
    [sym_call] = STATE(9625),
    [sym_method_call] = STATE(9629),
    [sym_argument_list] = STATE(1535),
    [sym__argument_list_with_parens] = STATE(10534),
    [sym__argument] = STATE(10535),
    [sym_splat_argument] = STATE(10535),
    [sym_hash_splat_argument] = STATE(10535),
    [sym_block_argument] = STATE(10535),
    [sym_assignment] = STATE(10533),
    [sym_operator_assignment] = STATE(10533),
    [sym_conditional] = STATE(10533),
    [sym_range] = STATE(10533),
    [sym_binary] = STATE(10533),
    [sym_unary] = STATE(10533),
    [sym_left_assignment_list] = STATE(9628),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9629),
    [sym__variable] = STATE(9625),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(9629),
    [sym_false] = STATE(9629),
    [sym_nil] = STATE(9629),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(10536),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(10535),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(14216),
    [sym__splat_star] = ACTIONS(14218),
    [sym__unary_minus] = ACTIONS(13356),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(14220),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(13360),
    [anon_sym_yield] = ACTIONS(13362),
    [anon_sym_break] = ACTIONS(13364),
    [anon_sym_next] = ACTIONS(13366),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_when] = ACTIONS(377),
    [anon_sym_else] = ACTIONS(377),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(365),
    [anon_sym_DASH_EQ] = ACTIONS(365),
    [anon_sym_STAR_EQ] = ACTIONS(365),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(365),
    [anon_sym_SLASH_EQ] = ACTIONS(365),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(365),
    [anon_sym_PIPE_EQ] = ACTIONS(365),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(365),
    [anon_sym_AMP_EQ] = ACTIONS(365),
    [anon_sym_PERCENT_EQ] = ACTIONS(365),
    [anon_sym_GT_GT_EQ] = ACTIONS(365),
    [anon_sym_LT_LT_EQ] = ACTIONS(365),
    [anon_sym_CARET_EQ] = ACTIONS(365),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_PERCENT] = ACTIONS(377),
    [anon_sym_defined_QMARK] = ACTIONS(13368),
    [anon_sym_not] = ACTIONS(13370),
    [anon_sym_BANG] = ACTIONS(13372),
    [anon_sym_TILDE] = ACTIONS(13374),
    [sym_constant] = ACTIONS(14222),
    [sym_identifier] = ACTIONS(14222),
    [sym_instance_variable] = ACTIONS(13378),
    [sym_class_variable] = ACTIONS(13378),
    [sym_global_variable] = ACTIONS(13378),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(13380),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13380),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [9618] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(10533),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(9629),
    [sym_scope_resolution] = STATE(9625),
    [sym_call] = STATE(9625),
    [sym_method_call] = STATE(9629),
    [sym_argument_list] = STATE(1536),
    [sym__argument_list_with_parens] = STATE(10534),
    [sym__argument] = STATE(10535),
    [sym_splat_argument] = STATE(10535),
    [sym_hash_splat_argument] = STATE(10535),
    [sym_block_argument] = STATE(10535),
    [sym_assignment] = STATE(10533),
    [sym_operator_assignment] = STATE(10533),
    [sym_conditional] = STATE(10533),
    [sym_range] = STATE(10533),
    [sym_binary] = STATE(10533),
    [sym_unary] = STATE(10533),
    [sym_left_assignment_list] = STATE(9628),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9629),
    [sym__variable] = STATE(9625),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(9629),
    [sym_false] = STATE(9629),
    [sym_nil] = STATE(9629),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(10536),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(10535),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(14216),
    [sym__splat_star] = ACTIONS(14218),
    [sym__unary_minus] = ACTIONS(13356),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(14220),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_EQ] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(13360),
    [anon_sym_yield] = ACTIONS(13362),
    [anon_sym_break] = ACTIONS(13364),
    [anon_sym_next] = ACTIONS(13366),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_when] = ACTIONS(419),
    [anon_sym_else] = ACTIONS(419),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(417),
    [anon_sym_DASH_EQ] = ACTIONS(417),
    [anon_sym_STAR_EQ] = ACTIONS(417),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(417),
    [anon_sym_SLASH_EQ] = ACTIONS(417),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(417),
    [anon_sym_PIPE_EQ] = ACTIONS(417),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(417),
    [anon_sym_AMP_EQ] = ACTIONS(417),
    [anon_sym_PERCENT_EQ] = ACTIONS(417),
    [anon_sym_GT_GT_EQ] = ACTIONS(417),
    [anon_sym_LT_LT_EQ] = ACTIONS(417),
    [anon_sym_CARET_EQ] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(13368),
    [anon_sym_not] = ACTIONS(13370),
    [anon_sym_BANG] = ACTIONS(13372),
    [anon_sym_TILDE] = ACTIONS(13374),
    [sym_constant] = ACTIONS(14222),
    [sym_identifier] = ACTIONS(14222),
    [sym_instance_variable] = ACTIONS(13378),
    [sym_class_variable] = ACTIONS(13378),
    [sym_global_variable] = ACTIONS(13378),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(13380),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13380),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [9619] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(10533),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(9629),
    [sym_scope_resolution] = STATE(9625),
    [sym_call] = STATE(9625),
    [sym_method_call] = STATE(9629),
    [sym_argument_list] = STATE(1537),
    [sym__argument_list_with_parens] = STATE(10534),
    [sym__argument] = STATE(10535),
    [sym_splat_argument] = STATE(10535),
    [sym_hash_splat_argument] = STATE(10535),
    [sym_block_argument] = STATE(10535),
    [sym_assignment] = STATE(10533),
    [sym_operator_assignment] = STATE(10533),
    [sym_conditional] = STATE(10533),
    [sym_range] = STATE(10533),
    [sym_binary] = STATE(10533),
    [sym_unary] = STATE(10533),
    [sym_left_assignment_list] = STATE(9628),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9629),
    [sym__variable] = STATE(9625),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(9629),
    [sym_false] = STATE(9629),
    [sym_nil] = STATE(9629),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(10536),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(10535),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(14216),
    [sym__splat_star] = ACTIONS(14218),
    [sym__unary_minus] = ACTIONS(13356),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(14220),
    [anon_sym_LBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_EQ] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(423),
    [anon_sym_return] = ACTIONS(13360),
    [anon_sym_yield] = ACTIONS(13362),
    [anon_sym_break] = ACTIONS(13364),
    [anon_sym_next] = ACTIONS(13366),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_when] = ACTIONS(423),
    [anon_sym_else] = ACTIONS(423),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(421),
    [anon_sym_DASH_EQ] = ACTIONS(421),
    [anon_sym_STAR_EQ] = ACTIONS(421),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(421),
    [anon_sym_SLASH_EQ] = ACTIONS(421),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(421),
    [anon_sym_PIPE_EQ] = ACTIONS(421),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(421),
    [anon_sym_AMP_EQ] = ACTIONS(421),
    [anon_sym_PERCENT_EQ] = ACTIONS(421),
    [anon_sym_GT_GT_EQ] = ACTIONS(421),
    [anon_sym_LT_LT_EQ] = ACTIONS(421),
    [anon_sym_CARET_EQ] = ACTIONS(421),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(13368),
    [anon_sym_not] = ACTIONS(13370),
    [anon_sym_BANG] = ACTIONS(13372),
    [anon_sym_TILDE] = ACTIONS(13374),
    [sym_constant] = ACTIONS(14222),
    [sym_identifier] = ACTIONS(14222),
    [sym_instance_variable] = ACTIONS(13378),
    [sym_class_variable] = ACTIONS(13378),
    [sym_global_variable] = ACTIONS(13378),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(13380),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13380),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [9620] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(10533),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(9629),
    [sym_scope_resolution] = STATE(9625),
    [sym_call] = STATE(9625),
    [sym_method_call] = STATE(9629),
    [sym_argument_list] = STATE(1538),
    [sym__argument_list_with_parens] = STATE(10534),
    [sym__argument] = STATE(10535),
    [sym_splat_argument] = STATE(10535),
    [sym_hash_splat_argument] = STATE(10535),
    [sym_block_argument] = STATE(10535),
    [sym_assignment] = STATE(10533),
    [sym_operator_assignment] = STATE(10533),
    [sym_conditional] = STATE(10533),
    [sym_range] = STATE(10533),
    [sym_binary] = STATE(10533),
    [sym_unary] = STATE(10533),
    [sym_left_assignment_list] = STATE(9628),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9629),
    [sym__variable] = STATE(9625),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(9629),
    [sym_false] = STATE(9629),
    [sym_nil] = STATE(9629),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(10536),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(10535),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(14216),
    [sym__splat_star] = ACTIONS(14218),
    [sym__unary_minus] = ACTIONS(13356),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(14220),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(427),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(427),
    [anon_sym_return] = ACTIONS(13360),
    [anon_sym_yield] = ACTIONS(13362),
    [anon_sym_break] = ACTIONS(13364),
    [anon_sym_next] = ACTIONS(13366),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_when] = ACTIONS(427),
    [anon_sym_else] = ACTIONS(427),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(425),
    [anon_sym_DASH_EQ] = ACTIONS(425),
    [anon_sym_STAR_EQ] = ACTIONS(425),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(425),
    [anon_sym_SLASH_EQ] = ACTIONS(425),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(425),
    [anon_sym_PIPE_EQ] = ACTIONS(425),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(425),
    [anon_sym_AMP_EQ] = ACTIONS(425),
    [anon_sym_PERCENT_EQ] = ACTIONS(425),
    [anon_sym_GT_GT_EQ] = ACTIONS(425),
    [anon_sym_LT_LT_EQ] = ACTIONS(425),
    [anon_sym_CARET_EQ] = ACTIONS(425),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(13368),
    [anon_sym_not] = ACTIONS(13370),
    [anon_sym_BANG] = ACTIONS(13372),
    [anon_sym_TILDE] = ACTIONS(13374),
    [sym_constant] = ACTIONS(14222),
    [sym_identifier] = ACTIONS(14222),
    [sym_instance_variable] = ACTIONS(13378),
    [sym_class_variable] = ACTIONS(13378),
    [sym_global_variable] = ACTIONS(13378),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(13380),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13380),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [9621] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(10576),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(9629),
    [sym_scope_resolution] = STATE(9625),
    [sym_call] = STATE(9625),
    [sym_method_call] = STATE(9629),
    [sym_assignment] = STATE(10576),
    [sym_operator_assignment] = STATE(10576),
    [sym_conditional] = STATE(10576),
    [sym_range] = STATE(10576),
    [sym_binary] = STATE(10576),
    [sym_unary] = STATE(10576),
    [sym_left_assignment_list] = STATE(9628),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9629),
    [sym__variable] = STATE(9625),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(9629),
    [sym_false] = STATE(9629),
    [sym_nil] = STATE(9629),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(10573),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(13356),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(13360),
    [anon_sym_yield] = ACTIONS(13362),
    [anon_sym_break] = ACTIONS(13364),
    [anon_sym_next] = ACTIONS(13366),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(14256),
    [anon_sym_defined_QMARK] = ACTIONS(13368),
    [anon_sym_not] = ACTIONS(13370),
    [anon_sym_BANG] = ACTIONS(13374),
    [anon_sym_TILDE] = ACTIONS(13374),
    [sym_constant] = ACTIONS(13380),
    [sym_identifier] = ACTIONS(13380),
    [sym_instance_variable] = ACTIONS(13378),
    [sym_class_variable] = ACTIONS(13378),
    [sym_global_variable] = ACTIONS(13378),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(13380),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13380),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [9622] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(1559),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(9629),
    [sym_scope_resolution] = STATE(9625),
    [sym_call] = STATE(9625),
    [sym_method_call] = STATE(9629),
    [sym_assignment] = STATE(1559),
    [sym_operator_assignment] = STATE(1559),
    [sym_conditional] = STATE(1559),
    [sym_range] = STATE(1559),
    [sym_binary] = STATE(1559),
    [sym_unary] = STATE(1559),
    [sym_left_assignment_list] = STATE(9628),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9629),
    [sym__variable] = STATE(9625),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(9629),
    [sym_false] = STATE(9629),
    [sym_nil] = STATE(9629),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(10573),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(13356),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(13360),
    [anon_sym_yield] = ACTIONS(13362),
    [anon_sym_break] = ACTIONS(13364),
    [anon_sym_next] = ACTIONS(13366),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(14256),
    [anon_sym_defined_QMARK] = ACTIONS(13368),
    [anon_sym_not] = ACTIONS(13370),
    [anon_sym_BANG] = ACTIONS(13374),
    [anon_sym_TILDE] = ACTIONS(13374),
    [sym_constant] = ACTIONS(13380),
    [sym_identifier] = ACTIONS(13380),
    [sym_instance_variable] = ACTIONS(13378),
    [sym_class_variable] = ACTIONS(13378),
    [sym_global_variable] = ACTIONS(13378),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(13380),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13380),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [9623] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(14260),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(1091),
    [anon_sym_else] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [9624] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(14262),
    [sym__binary_star] = ACTIONS(14264),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(14266),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(14268),
    [anon_sym_AMP] = ACTIONS(14270),
    [anon_sym_EQ] = ACTIONS(1631),
    [anon_sym_LT] = ACTIONS(14272),
    [anon_sym_end] = ACTIONS(1625),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_unless] = ACTIONS(1625),
    [anon_sym_while] = ACTIONS(1625),
    [anon_sym_until] = ACTIONS(1625),
    [anon_sym_rescue] = ACTIONS(1625),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_when] = ACTIONS(1625),
    [anon_sym_else] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(14258),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_PLUS_EQ] = ACTIONS(1625),
    [anon_sym_DASH_EQ] = ACTIONS(1625),
    [anon_sym_STAR_EQ] = ACTIONS(1625),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1625),
    [anon_sym_SLASH_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1625),
    [anon_sym_AMP_EQ] = ACTIONS(1625),
    [anon_sym_PERCENT_EQ] = ACTIONS(1625),
    [anon_sym_GT_GT_EQ] = ACTIONS(1625),
    [anon_sym_LT_LT_EQ] = ACTIONS(1625),
    [anon_sym_CARET_EQ] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(14274),
    [anon_sym_DOT_DOT] = ACTIONS(14276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14278),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(14280),
    [anon_sym_AMP_AMP] = ACTIONS(14280),
    [anon_sym_LT_LT] = ACTIONS(14282),
    [anon_sym_GT_GT] = ACTIONS(14282),
    [anon_sym_EQ_EQ] = ACTIONS(14280),
    [anon_sym_BANG_EQ] = ACTIONS(14284),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14284),
    [anon_sym_LT_EQ_GT] = ACTIONS(14284),
    [anon_sym_EQ_TILDE] = ACTIONS(14284),
    [anon_sym_BANG_TILDE] = ACTIONS(14284),
    [anon_sym_LT_EQ] = ACTIONS(14272),
    [anon_sym_GT] = ACTIONS(14272),
    [anon_sym_GT_EQ] = ACTIONS(14286),
    [anon_sym_CARET] = ACTIONS(14266),
    [anon_sym_PLUS] = ACTIONS(14288),
    [anon_sym_SLASH] = ACTIONS(14268),
    [anon_sym_PERCENT] = ACTIONS(14268),
    [sym_comment] = ACTIONS(87),
  },
  [9625] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(10533),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(9629),
    [sym_scope_resolution] = STATE(9625),
    [sym_call] = STATE(9625),
    [sym_method_call] = STATE(9629),
    [sym_argument_list] = STATE(1578),
    [sym__argument_list_with_parens] = STATE(10534),
    [sym__argument] = STATE(10535),
    [sym_splat_argument] = STATE(10535),
    [sym_hash_splat_argument] = STATE(10535),
    [sym_block_argument] = STATE(10535),
    [sym_do_block] = STATE(941),
    [sym_block] = STATE(941),
    [sym_assignment] = STATE(10533),
    [sym_operator_assignment] = STATE(10533),
    [sym_conditional] = STATE(10533),
    [sym_range] = STATE(10533),
    [sym_binary] = STATE(10533),
    [sym_unary] = STATE(10533),
    [sym_left_assignment_list] = STATE(9628),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9629),
    [sym__variable] = STATE(9625),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(9629),
    [sym_false] = STATE(9629),
    [sym_nil] = STATE(9629),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(10536),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(10535),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(743),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(14216),
    [sym__splat_star] = ACTIONS(14218),
    [sym__unary_minus] = ACTIONS(13356),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(14220),
    [anon_sym_LBRACE] = ACTIONS(2715),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(769),
    [anon_sym_return] = ACTIONS(13360),
    [anon_sym_yield] = ACTIONS(13362),
    [anon_sym_break] = ACTIONS(13364),
    [anon_sym_next] = ACTIONS(13366),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(769),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(769),
    [anon_sym_until] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(769),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(769),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_when] = ACTIONS(769),
    [anon_sym_else] = ACTIONS(769),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(13368),
    [anon_sym_not] = ACTIONS(13370),
    [anon_sym_BANG] = ACTIONS(13372),
    [anon_sym_TILDE] = ACTIONS(13374),
    [sym_constant] = ACTIONS(14222),
    [sym_identifier] = ACTIONS(14222),
    [sym_instance_variable] = ACTIONS(13378),
    [sym_class_variable] = ACTIONS(13378),
    [sym_global_variable] = ACTIONS(13378),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(13380),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13380),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [9626] = {
    [sym_heredoc_body] = STATE(10588),
    [aux_sym_call_repeat1] = STATE(10588),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_when] = ACTIONS(1681),
    [anon_sym_else] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [9627] = {
    [sym_heredoc_body] = STATE(10588),
    [aux_sym_call_repeat1] = STATE(10588),
    [aux_sym_argument_list_repeat1] = STATE(10590),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(14290),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_when] = ACTIONS(1681),
    [anon_sym_else] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [9628] = {
    [anon_sym_EQ] = ACTIONS(14292),
    [sym_comment] = ACTIONS(87),
  },
  [9629] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(14294),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_when] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(14296),
    [anon_sym_DASH_EQ] = ACTIONS(14296),
    [anon_sym_STAR_EQ] = ACTIONS(14296),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14296),
    [anon_sym_SLASH_EQ] = ACTIONS(14296),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14296),
    [anon_sym_PIPE_EQ] = ACTIONS(14296),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14296),
    [anon_sym_AMP_EQ] = ACTIONS(14296),
    [anon_sym_PERCENT_EQ] = ACTIONS(14296),
    [anon_sym_GT_GT_EQ] = ACTIONS(14296),
    [anon_sym_LT_LT_EQ] = ACTIONS(14296),
    [anon_sym_CARET_EQ] = ACTIONS(14296),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [9630] = {
    [sym_string] = STATE(10593),
    [aux_sym_chained_string_repeat1] = STATE(10593),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(747),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(14298),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_when] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [9631] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10598),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(10601),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(10601),
    [sym_splat_argument] = STATE(10599),
    [sym_assignment] = STATE(10598),
    [sym_operator_assignment] = STATE(10598),
    [sym_conditional] = STATE(10598),
    [sym_range] = STATE(10598),
    [sym_binary] = STATE(10598),
    [sym_unary] = STATE(10598),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(10599),
    [sym_left_assignment_list] = STATE(10600),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10601),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(10601),
    [sym_false] = STATE(10601),
    [sym_nil] = STATE(10601),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(10501),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(14300),
    [sym__unary_minus] = ACTIONS(14302),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14160),
    [anon_sym_yield] = ACTIONS(14162),
    [anon_sym_break] = ACTIONS(14164),
    [anon_sym_next] = ACTIONS(14166),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14304),
    [anon_sym_defined_QMARK] = ACTIONS(14306),
    [anon_sym_not] = ACTIONS(14308),
    [anon_sym_BANG] = ACTIONS(14310),
    [anon_sym_TILDE] = ACTIONS(14310),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9632] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10602),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7930),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(7930),
    [sym_assignment] = STATE(10602),
    [sym_operator_assignment] = STATE(10602),
    [sym_conditional] = STATE(10602),
    [sym_range] = STATE(10602),
    [sym_binary] = STATE(10602),
    [sym_unary] = STATE(10602),
    [sym_left_assignment_list] = STATE(7929),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7930),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7930),
    [sym_false] = STATE(7930),
    [sym_nil] = STATE(7930),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7931),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11428),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11430),
    [anon_sym_yield] = ACTIONS(11432),
    [anon_sym_break] = ACTIONS(11434),
    [anon_sym_next] = ACTIONS(11436),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11438),
    [anon_sym_defined_QMARK] = ACTIONS(11440),
    [anon_sym_not] = ACTIONS(11442),
    [anon_sym_BANG] = ACTIONS(11444),
    [anon_sym_TILDE] = ACTIONS(11444),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9633] = {
    [sym_string] = STATE(10603),
    [aux_sym_chained_string_repeat1] = STATE(10603),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_end] = ACTIONS(2753),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_when] = ACTIONS(2753),
    [anon_sym_else] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [9634] = {
    [sym_heredoc_body] = STATE(370),
    [sym__terminator] = STATE(370),
    [sym__line_break] = ACTIONS(687),
    [sym__heredoc_body_start] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(687),
    [anon_sym_end] = ACTIONS(2757),
    [anon_sym_if] = ACTIONS(13314),
    [anon_sym_unless] = ACTIONS(13316),
    [anon_sym_while] = ACTIONS(13318),
    [anon_sym_until] = ACTIONS(13320),
    [anon_sym_rescue] = ACTIONS(13322),
    [anon_sym_when] = ACTIONS(2757),
    [anon_sym_else] = ACTIONS(2757),
    [sym_comment] = ACTIONS(87),
  },
  [9635] = {
    [sym_begin_block] = STATE(1611),
    [sym_end_block] = STATE(1611),
    [sym__statement] = STATE(1611),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1611),
    [sym_unless_modifier] = STATE(1611),
    [sym_while_modifier] = STATE(1611),
    [sym_until_modifier] = STATE(1611),
    [sym_rescue_modifier] = STATE(1611),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1612),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1615),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(1615),
    [sym_assignment] = STATE(1612),
    [sym_operator_assignment] = STATE(1612),
    [sym_conditional] = STATE(1612),
    [sym_range] = STATE(1612),
    [sym_binary] = STATE(1612),
    [sym_unary] = STATE(1612),
    [sym_left_assignment_list] = STATE(1614),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1615),
    [sym__variable] = STATE(1613),
    [sym_undef] = STATE(1611),
    [sym_alias] = STATE(1611),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1615),
    [sym_false] = STATE(1615),
    [sym_nil] = STATE(1615),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1616),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(9635),
    [aux_sym__statements_repeat1] = STATE(9635),
    [sym__simple_symbol] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(2762),
    [sym__symbol_start] = ACTIONS(2765),
    [sym__subshell_start] = ACTIONS(2768),
    [sym__regex_start] = ACTIONS(2771),
    [sym__string_array_start] = ACTIONS(2774),
    [sym__symbol_array_start] = ACTIONS(2777),
    [sym_heredoc_beginning] = ACTIONS(2780),
    [sym__unary_minus] = ACTIONS(2783),
    [anon_sym_BEGIN] = ACTIONS(2786),
    [anon_sym_LBRACE] = ACTIONS(2789),
    [anon_sym_END] = ACTIONS(2792),
    [anon_sym_def] = ACTIONS(2795),
    [anon_sym_LPAREN] = ACTIONS(2798),
    [anon_sym_COLON_COLON] = ACTIONS(2801),
    [anon_sym_SEMI] = ACTIONS(2804),
    [anon_sym_STAR] = ACTIONS(2807),
    [anon_sym_class] = ACTIONS(2810),
    [anon_sym_module] = ACTIONS(2813),
    [anon_sym_end] = ACTIONS(2493),
    [anon_sym_return] = ACTIONS(2816),
    [anon_sym_yield] = ACTIONS(2819),
    [anon_sym_break] = ACTIONS(2822),
    [anon_sym_next] = ACTIONS(2825),
    [sym_redo] = ACTIONS(2828),
    [sym_retry] = ACTIONS(2828),
    [anon_sym_if] = ACTIONS(2831),
    [anon_sym_unless] = ACTIONS(2834),
    [anon_sym_while] = ACTIONS(2837),
    [anon_sym_until] = ACTIONS(2840),
    [anon_sym_for] = ACTIONS(2843),
    [anon_sym_case] = ACTIONS(2846),
    [anon_sym_when] = ACTIONS(2493),
    [anon_sym_else] = ACTIONS(2493),
    [anon_sym_begin] = ACTIONS(2849),
    [anon_sym_PLUS] = ACTIONS(2852),
    [anon_sym_defined_QMARK] = ACTIONS(2855),
    [anon_sym_not] = ACTIONS(2858),
    [anon_sym_BANG] = ACTIONS(2861),
    [anon_sym_TILDE] = ACTIONS(2861),
    [sym_constant] = ACTIONS(2864),
    [sym_identifier] = ACTIONS(2864),
    [sym_instance_variable] = ACTIONS(2867),
    [sym_class_variable] = ACTIONS(2867),
    [sym_global_variable] = ACTIONS(2867),
    [anon_sym_undef] = ACTIONS(2870),
    [anon_sym_alias] = ACTIONS(2873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2876),
    [sym_float] = ACTIONS(2828),
    [sym_complex] = ACTIONS(2780),
    [sym_super] = ACTIONS(2864),
    [anon_sym_true] = ACTIONS(2879),
    [anon_sym_TRUE] = ACTIONS(2879),
    [anon_sym_false] = ACTIONS(2882),
    [anon_sym_FALSE] = ACTIONS(2882),
    [sym_self] = ACTIONS(2864),
    [anon_sym_nil] = ACTIONS(2885),
    [anon_sym_NIL] = ACTIONS(2885),
    [sym_character] = ACTIONS(2780),
    [anon_sym_LBRACK2] = ACTIONS(2888),
    [anon_sym_DASH_GT] = ACTIONS(2891),
  },
  [9636] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10604),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2984),
    [sym_scope_resolution] = STATE(2981),
    [sym_call] = STATE(2981),
    [sym_method_call] = STATE(2984),
    [sym_assignment] = STATE(10604),
    [sym_operator_assignment] = STATE(10604),
    [sym_conditional] = STATE(10604),
    [sym_range] = STATE(10604),
    [sym_binary] = STATE(10604),
    [sym_unary] = STATE(10604),
    [sym_left_assignment_list] = STATE(2983),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2984),
    [sym__variable] = STATE(2981),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2984),
    [sym_false] = STATE(2984),
    [sym_nil] = STATE(2984),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2985),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4971),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4973),
    [anon_sym_yield] = ACTIONS(4975),
    [anon_sym_break] = ACTIONS(4977),
    [anon_sym_next] = ACTIONS(4979),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4981),
    [anon_sym_defined_QMARK] = ACTIONS(4983),
    [anon_sym_not] = ACTIONS(4985),
    [anon_sym_BANG] = ACTIONS(4987),
    [anon_sym_TILDE] = ACTIONS(4987),
    [sym_constant] = ACTIONS(4989),
    [sym_identifier] = ACTIONS(4989),
    [sym_instance_variable] = ACTIONS(4991),
    [sym_class_variable] = ACTIONS(4991),
    [sym_global_variable] = ACTIONS(4991),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4989),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4989),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9637] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(13403),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [9638] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(13397),
    [sym__binary_star] = ACTIONS(13399),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(13401),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(13403),
    [anon_sym_AMP] = ACTIONS(13405),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(13407),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(13409),
    [anon_sym_DOT_DOT] = ACTIONS(13411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13413),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(13415),
    [anon_sym_AMP_AMP] = ACTIONS(13415),
    [anon_sym_LT_LT] = ACTIONS(13417),
    [anon_sym_GT_GT] = ACTIONS(13417),
    [anon_sym_EQ_EQ] = ACTIONS(13415),
    [anon_sym_BANG_EQ] = ACTIONS(13419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13419),
    [anon_sym_LT_EQ_GT] = ACTIONS(13419),
    [anon_sym_EQ_TILDE] = ACTIONS(13419),
    [anon_sym_BANG_TILDE] = ACTIONS(13419),
    [anon_sym_LT_EQ] = ACTIONS(13407),
    [anon_sym_GT] = ACTIONS(13407),
    [anon_sym_GT_EQ] = ACTIONS(13421),
    [anon_sym_CARET] = ACTIONS(13401),
    [anon_sym_PLUS] = ACTIONS(13423),
    [anon_sym_SLASH] = ACTIONS(13403),
    [anon_sym_PERCENT] = ACTIONS(13403),
    [sym_comment] = ACTIONS(87),
  },
  [9639] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10605),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7957),
    [sym_scope_resolution] = STATE(7955),
    [sym_call] = STATE(7955),
    [sym_method_call] = STATE(7957),
    [sym_assignment] = STATE(10605),
    [sym_operator_assignment] = STATE(10605),
    [sym_conditional] = STATE(10605),
    [sym_range] = STATE(10605),
    [sym_binary] = STATE(10605),
    [sym_unary] = STATE(10605),
    [sym_left_assignment_list] = STATE(7956),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7957),
    [sym__variable] = STATE(7955),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7957),
    [sym_false] = STATE(7957),
    [sym_nil] = STATE(7957),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7958),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11460),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11462),
    [anon_sym_yield] = ACTIONS(11464),
    [anon_sym_break] = ACTIONS(11466),
    [anon_sym_next] = ACTIONS(11468),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11470),
    [anon_sym_defined_QMARK] = ACTIONS(11472),
    [anon_sym_not] = ACTIONS(11474),
    [anon_sym_BANG] = ACTIONS(11476),
    [anon_sym_TILDE] = ACTIONS(11476),
    [sym_constant] = ACTIONS(11478),
    [sym_identifier] = ACTIONS(11478),
    [sym_instance_variable] = ACTIONS(11480),
    [sym_class_variable] = ACTIONS(11480),
    [sym_global_variable] = ACTIONS(11480),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11478),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11478),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [9640] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10606),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7957),
    [sym_scope_resolution] = STATE(7955),
    [sym_call] = STATE(7955),
    [sym_method_call] = STATE(7957),
    [sym_assignment] = STATE(10606),
    [sym_operator_assignment] = STATE(10606),
    [sym_conditional] = STATE(10606),
    [sym_range] = STATE(10606),
    [sym_binary] = STATE(10606),
    [sym_unary] = STATE(10606),
    [sym_left_assignment_list] = STATE(7956),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7957),
    [sym__variable] = STATE(7955),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7957),
    [sym_false] = STATE(7957),
    [sym_nil] = STATE(7957),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7958),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11460),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11462),
    [anon_sym_yield] = ACTIONS(11464),
    [anon_sym_break] = ACTIONS(11466),
    [anon_sym_next] = ACTIONS(11468),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11470),
    [anon_sym_defined_QMARK] = ACTIONS(11472),
    [anon_sym_not] = ACTIONS(11474),
    [anon_sym_BANG] = ACTIONS(11476),
    [anon_sym_TILDE] = ACTIONS(11476),
    [sym_constant] = ACTIONS(11478),
    [sym_identifier] = ACTIONS(11478),
    [sym_instance_variable] = ACTIONS(11480),
    [sym_class_variable] = ACTIONS(11480),
    [sym_global_variable] = ACTIONS(11480),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11478),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11478),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [9641] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10607),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7957),
    [sym_scope_resolution] = STATE(7955),
    [sym_call] = STATE(7955),
    [sym_method_call] = STATE(7957),
    [sym_assignment] = STATE(10607),
    [sym_operator_assignment] = STATE(10607),
    [sym_conditional] = STATE(10607),
    [sym_range] = STATE(10607),
    [sym_binary] = STATE(10607),
    [sym_unary] = STATE(10607),
    [sym_left_assignment_list] = STATE(7956),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7957),
    [sym__variable] = STATE(7955),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7957),
    [sym_false] = STATE(7957),
    [sym_nil] = STATE(7957),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7958),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11460),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11462),
    [anon_sym_yield] = ACTIONS(11464),
    [anon_sym_break] = ACTIONS(11466),
    [anon_sym_next] = ACTIONS(11468),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11470),
    [anon_sym_defined_QMARK] = ACTIONS(11472),
    [anon_sym_not] = ACTIONS(11474),
    [anon_sym_BANG] = ACTIONS(11476),
    [anon_sym_TILDE] = ACTIONS(11476),
    [sym_constant] = ACTIONS(11478),
    [sym_identifier] = ACTIONS(11478),
    [sym_instance_variable] = ACTIONS(11480),
    [sym_class_variable] = ACTIONS(11480),
    [sym_global_variable] = ACTIONS(11480),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11478),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11478),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [9642] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10608),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7957),
    [sym_scope_resolution] = STATE(7955),
    [sym_call] = STATE(7955),
    [sym_method_call] = STATE(7957),
    [sym_assignment] = STATE(10608),
    [sym_operator_assignment] = STATE(10608),
    [sym_conditional] = STATE(10608),
    [sym_range] = STATE(10608),
    [sym_binary] = STATE(10608),
    [sym_unary] = STATE(10608),
    [sym_left_assignment_list] = STATE(7956),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7957),
    [sym__variable] = STATE(7955),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7957),
    [sym_false] = STATE(7957),
    [sym_nil] = STATE(7957),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7958),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11460),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11462),
    [anon_sym_yield] = ACTIONS(11464),
    [anon_sym_break] = ACTIONS(11466),
    [anon_sym_next] = ACTIONS(11468),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11470),
    [anon_sym_defined_QMARK] = ACTIONS(11472),
    [anon_sym_not] = ACTIONS(11474),
    [anon_sym_BANG] = ACTIONS(11476),
    [anon_sym_TILDE] = ACTIONS(11476),
    [sym_constant] = ACTIONS(11478),
    [sym_identifier] = ACTIONS(11478),
    [sym_instance_variable] = ACTIONS(11480),
    [sym_class_variable] = ACTIONS(11480),
    [sym_global_variable] = ACTIONS(11480),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11478),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11478),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [9643] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10609),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7957),
    [sym_scope_resolution] = STATE(7955),
    [sym_call] = STATE(7955),
    [sym_method_call] = STATE(7957),
    [sym_assignment] = STATE(10609),
    [sym_operator_assignment] = STATE(10609),
    [sym_conditional] = STATE(10609),
    [sym_range] = STATE(10609),
    [sym_binary] = STATE(10609),
    [sym_unary] = STATE(10609),
    [sym_left_assignment_list] = STATE(7956),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7957),
    [sym__variable] = STATE(7955),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7957),
    [sym_false] = STATE(7957),
    [sym_nil] = STATE(7957),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7958),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11460),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11462),
    [anon_sym_yield] = ACTIONS(11464),
    [anon_sym_break] = ACTIONS(11466),
    [anon_sym_next] = ACTIONS(11468),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11470),
    [anon_sym_defined_QMARK] = ACTIONS(11472),
    [anon_sym_not] = ACTIONS(11474),
    [anon_sym_BANG] = ACTIONS(11476),
    [anon_sym_TILDE] = ACTIONS(11476),
    [sym_constant] = ACTIONS(11478),
    [sym_identifier] = ACTIONS(11478),
    [sym_instance_variable] = ACTIONS(11480),
    [sym_class_variable] = ACTIONS(11480),
    [sym_global_variable] = ACTIONS(11480),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11478),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11478),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [9644] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(10610),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(10610),
    [sym_operator_assignment] = STATE(10610),
    [sym_conditional] = STATE(10610),
    [sym_range] = STATE(10610),
    [sym_binary] = STATE(10610),
    [sym_unary] = STATE(10610),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9645] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10611),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7957),
    [sym_scope_resolution] = STATE(7955),
    [sym_call] = STATE(7955),
    [sym_method_call] = STATE(7957),
    [sym_assignment] = STATE(10611),
    [sym_operator_assignment] = STATE(10611),
    [sym_conditional] = STATE(10611),
    [sym_range] = STATE(10611),
    [sym_binary] = STATE(10611),
    [sym_unary] = STATE(10611),
    [sym_left_assignment_list] = STATE(7956),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7957),
    [sym__variable] = STATE(7955),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7957),
    [sym_false] = STATE(7957),
    [sym_nil] = STATE(7957),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7958),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11460),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11462),
    [anon_sym_yield] = ACTIONS(11464),
    [anon_sym_break] = ACTIONS(11466),
    [anon_sym_next] = ACTIONS(11468),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11470),
    [anon_sym_defined_QMARK] = ACTIONS(11472),
    [anon_sym_not] = ACTIONS(11474),
    [anon_sym_BANG] = ACTIONS(11476),
    [anon_sym_TILDE] = ACTIONS(11476),
    [sym_constant] = ACTIONS(11478),
    [sym_identifier] = ACTIONS(11478),
    [sym_instance_variable] = ACTIONS(11480),
    [sym_class_variable] = ACTIONS(11480),
    [sym_global_variable] = ACTIONS(11480),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11478),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11478),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [9646] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10612),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7957),
    [sym_scope_resolution] = STATE(7955),
    [sym_call] = STATE(7955),
    [sym_method_call] = STATE(7957),
    [sym_assignment] = STATE(10612),
    [sym_operator_assignment] = STATE(10612),
    [sym_conditional] = STATE(10612),
    [sym_range] = STATE(10612),
    [sym_binary] = STATE(10612),
    [sym_unary] = STATE(10612),
    [sym_left_assignment_list] = STATE(7956),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7957),
    [sym__variable] = STATE(7955),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7957),
    [sym_false] = STATE(7957),
    [sym_nil] = STATE(7957),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7958),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11460),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11462),
    [anon_sym_yield] = ACTIONS(11464),
    [anon_sym_break] = ACTIONS(11466),
    [anon_sym_next] = ACTIONS(11468),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11470),
    [anon_sym_defined_QMARK] = ACTIONS(11472),
    [anon_sym_not] = ACTIONS(11474),
    [anon_sym_BANG] = ACTIONS(11476),
    [anon_sym_TILDE] = ACTIONS(11476),
    [sym_constant] = ACTIONS(11478),
    [sym_identifier] = ACTIONS(11478),
    [sym_instance_variable] = ACTIONS(11480),
    [sym_class_variable] = ACTIONS(11480),
    [sym_global_variable] = ACTIONS(11480),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11478),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11478),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [9647] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10613),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7957),
    [sym_scope_resolution] = STATE(7955),
    [sym_call] = STATE(7955),
    [sym_method_call] = STATE(7957),
    [sym_assignment] = STATE(10613),
    [sym_operator_assignment] = STATE(10613),
    [sym_conditional] = STATE(10613),
    [sym_range] = STATE(10613),
    [sym_binary] = STATE(10613),
    [sym_unary] = STATE(10613),
    [sym_left_assignment_list] = STATE(7956),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7957),
    [sym__variable] = STATE(7955),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7957),
    [sym_false] = STATE(7957),
    [sym_nil] = STATE(7957),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7958),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11460),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11462),
    [anon_sym_yield] = ACTIONS(11464),
    [anon_sym_break] = ACTIONS(11466),
    [anon_sym_next] = ACTIONS(11468),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11470),
    [anon_sym_defined_QMARK] = ACTIONS(11472),
    [anon_sym_not] = ACTIONS(11474),
    [anon_sym_BANG] = ACTIONS(11476),
    [anon_sym_TILDE] = ACTIONS(11476),
    [sym_constant] = ACTIONS(11478),
    [sym_identifier] = ACTIONS(11478),
    [sym_instance_variable] = ACTIONS(11480),
    [sym_class_variable] = ACTIONS(11480),
    [sym_global_variable] = ACTIONS(11480),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11478),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11478),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [9648] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10614),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7957),
    [sym_scope_resolution] = STATE(7955),
    [sym_call] = STATE(7955),
    [sym_method_call] = STATE(7957),
    [sym_assignment] = STATE(10614),
    [sym_operator_assignment] = STATE(10614),
    [sym_conditional] = STATE(10614),
    [sym_range] = STATE(10614),
    [sym_binary] = STATE(10614),
    [sym_unary] = STATE(10614),
    [sym_left_assignment_list] = STATE(7956),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7957),
    [sym__variable] = STATE(7955),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7957),
    [sym_false] = STATE(7957),
    [sym_nil] = STATE(7957),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7958),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11460),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11462),
    [anon_sym_yield] = ACTIONS(11464),
    [anon_sym_break] = ACTIONS(11466),
    [anon_sym_next] = ACTIONS(11468),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11470),
    [anon_sym_defined_QMARK] = ACTIONS(11472),
    [anon_sym_not] = ACTIONS(11474),
    [anon_sym_BANG] = ACTIONS(11476),
    [anon_sym_TILDE] = ACTIONS(11476),
    [sym_constant] = ACTIONS(11478),
    [sym_identifier] = ACTIONS(11478),
    [sym_instance_variable] = ACTIONS(11480),
    [sym_class_variable] = ACTIONS(11480),
    [sym_global_variable] = ACTIONS(11480),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11478),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11478),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [9649] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10615),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7957),
    [sym_scope_resolution] = STATE(7955),
    [sym_call] = STATE(7955),
    [sym_method_call] = STATE(7957),
    [sym_splat_argument] = STATE(10616),
    [sym_assignment] = STATE(10615),
    [sym_operator_assignment] = STATE(10615),
    [sym_conditional] = STATE(10615),
    [sym_range] = STATE(10615),
    [sym_binary] = STATE(10615),
    [sym_unary] = STATE(10615),
    [sym_right_assignment_list] = STATE(6323),
    [sym__arg_or_splat_arg] = STATE(10616),
    [sym_left_assignment_list] = STATE(7956),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7957),
    [sym__variable] = STATE(7955),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7957),
    [sym_false] = STATE(7957),
    [sym_nil] = STATE(7957),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7958),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__splat_star] = ACTIONS(8667),
    [sym__unary_minus] = ACTIONS(11460),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11462),
    [anon_sym_yield] = ACTIONS(11464),
    [anon_sym_break] = ACTIONS(11466),
    [anon_sym_next] = ACTIONS(11468),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11470),
    [anon_sym_defined_QMARK] = ACTIONS(11472),
    [anon_sym_not] = ACTIONS(11474),
    [anon_sym_BANG] = ACTIONS(11476),
    [anon_sym_TILDE] = ACTIONS(11476),
    [sym_constant] = ACTIONS(11478),
    [sym_identifier] = ACTIONS(11478),
    [sym_instance_variable] = ACTIONS(11480),
    [sym_class_variable] = ACTIONS(11480),
    [sym_global_variable] = ACTIONS(11480),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11478),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11478),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [9650] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10617),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7957),
    [sym_scope_resolution] = STATE(7955),
    [sym_call] = STATE(7955),
    [sym_method_call] = STATE(7957),
    [sym_assignment] = STATE(10617),
    [sym_operator_assignment] = STATE(10617),
    [sym_conditional] = STATE(10617),
    [sym_range] = STATE(10617),
    [sym_binary] = STATE(10617),
    [sym_unary] = STATE(10617),
    [sym_left_assignment_list] = STATE(7956),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7957),
    [sym__variable] = STATE(7955),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7957),
    [sym_false] = STATE(7957),
    [sym_nil] = STATE(7957),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7958),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11460),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11462),
    [anon_sym_yield] = ACTIONS(11464),
    [anon_sym_break] = ACTIONS(11466),
    [anon_sym_next] = ACTIONS(11468),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11470),
    [anon_sym_defined_QMARK] = ACTIONS(11472),
    [anon_sym_not] = ACTIONS(11474),
    [anon_sym_BANG] = ACTIONS(11476),
    [anon_sym_TILDE] = ACTIONS(11476),
    [sym_constant] = ACTIONS(11478),
    [sym_identifier] = ACTIONS(11478),
    [sym_instance_variable] = ACTIONS(11480),
    [sym_class_variable] = ACTIONS(11480),
    [sym_global_variable] = ACTIONS(11480),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11478),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11478),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [9651] = {
    [sym_string] = STATE(10618),
    [aux_sym_chained_string_repeat1] = STATE(10618),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(2551),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2755),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_EQ] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_then] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_PLUS_EQ] = ACTIONS(2753),
    [anon_sym_DASH_EQ] = ACTIONS(2753),
    [anon_sym_STAR_EQ] = ACTIONS(2753),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2753),
    [anon_sym_SLASH_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2753),
    [anon_sym_AMP_EQ] = ACTIONS(2753),
    [anon_sym_PERCENT_EQ] = ACTIONS(2753),
    [anon_sym_GT_GT_EQ] = ACTIONS(2753),
    [anon_sym_LT_LT_EQ] = ACTIONS(2753),
    [anon_sym_CARET_EQ] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2755),
    [anon_sym_AMP_AMP] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2755),
    [anon_sym_GT_GT] = ACTIONS(2755),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_SLASH] = ACTIONS(2755),
    [anon_sym_PERCENT] = ACTIONS(2755),
    [sym_comment] = ACTIONS(87),
  },
  [9652] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(13397),
    [sym__binary_star] = ACTIONS(13399),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(13401),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(13403),
    [anon_sym_AMP] = ACTIONS(13405),
    [anon_sym_EQ] = ACTIONS(7822),
    [anon_sym_LT] = ACTIONS(13407),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_then] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_PLUS_EQ] = ACTIONS(6823),
    [anon_sym_DASH_EQ] = ACTIONS(6823),
    [anon_sym_STAR_EQ] = ACTIONS(6823),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6823),
    [anon_sym_SLASH_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6823),
    [anon_sym_AMP_EQ] = ACTIONS(6823),
    [anon_sym_PERCENT_EQ] = ACTIONS(6823),
    [anon_sym_GT_GT_EQ] = ACTIONS(6823),
    [anon_sym_LT_LT_EQ] = ACTIONS(6823),
    [anon_sym_CARET_EQ] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(13409),
    [anon_sym_DOT_DOT] = ACTIONS(13411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13413),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(13415),
    [anon_sym_AMP_AMP] = ACTIONS(13415),
    [anon_sym_LT_LT] = ACTIONS(13417),
    [anon_sym_GT_GT] = ACTIONS(13417),
    [anon_sym_EQ_EQ] = ACTIONS(13415),
    [anon_sym_BANG_EQ] = ACTIONS(13419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13419),
    [anon_sym_LT_EQ_GT] = ACTIONS(13419),
    [anon_sym_EQ_TILDE] = ACTIONS(13419),
    [anon_sym_BANG_TILDE] = ACTIONS(13419),
    [anon_sym_LT_EQ] = ACTIONS(13407),
    [anon_sym_GT] = ACTIONS(13407),
    [anon_sym_GT_EQ] = ACTIONS(13421),
    [anon_sym_CARET] = ACTIONS(13401),
    [anon_sym_PLUS] = ACTIONS(13423),
    [anon_sym_SLASH] = ACTIONS(13403),
    [anon_sym_PERCENT] = ACTIONS(13403),
    [sym_comment] = ACTIONS(87),
  },
  [9653] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(13397),
    [sym__binary_star] = ACTIONS(13399),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(13401),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(13403),
    [anon_sym_AMP] = ACTIONS(13405),
    [anon_sym_EQ] = ACTIONS(7884),
    [anon_sym_LT] = ACTIONS(13407),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_then] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_PLUS_EQ] = ACTIONS(7027),
    [anon_sym_DASH_EQ] = ACTIONS(7027),
    [anon_sym_STAR_EQ] = ACTIONS(7027),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7027),
    [anon_sym_SLASH_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7027),
    [anon_sym_AMP_EQ] = ACTIONS(7027),
    [anon_sym_PERCENT_EQ] = ACTIONS(7027),
    [anon_sym_GT_GT_EQ] = ACTIONS(7027),
    [anon_sym_LT_LT_EQ] = ACTIONS(7027),
    [anon_sym_CARET_EQ] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(13409),
    [anon_sym_DOT_DOT] = ACTIONS(13411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13413),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(13415),
    [anon_sym_AMP_AMP] = ACTIONS(13415),
    [anon_sym_LT_LT] = ACTIONS(13417),
    [anon_sym_GT_GT] = ACTIONS(13417),
    [anon_sym_EQ_EQ] = ACTIONS(13415),
    [anon_sym_BANG_EQ] = ACTIONS(13419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13419),
    [anon_sym_LT_EQ_GT] = ACTIONS(13419),
    [anon_sym_EQ_TILDE] = ACTIONS(13419),
    [anon_sym_BANG_TILDE] = ACTIONS(13419),
    [anon_sym_LT_EQ] = ACTIONS(13407),
    [anon_sym_GT] = ACTIONS(13407),
    [anon_sym_GT_EQ] = ACTIONS(13421),
    [anon_sym_CARET] = ACTIONS(13401),
    [anon_sym_PLUS] = ACTIONS(13423),
    [anon_sym_SLASH] = ACTIONS(13403),
    [anon_sym_PERCENT] = ACTIONS(13403),
    [sym_comment] = ACTIONS(87),
  },
  [9654] = {
    [sym_heredoc_body] = STATE(9654),
    [aux_sym_call_repeat1] = STATE(9654),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(9846),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7919),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_EQ] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_then] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_PLUS_EQ] = ACTIONS(7914),
    [anon_sym_DASH_EQ] = ACTIONS(7914),
    [anon_sym_STAR_EQ] = ACTIONS(7914),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7914),
    [anon_sym_SLASH_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7914),
    [anon_sym_AMP_EQ] = ACTIONS(7914),
    [anon_sym_PERCENT_EQ] = ACTIONS(7914),
    [anon_sym_GT_GT_EQ] = ACTIONS(7914),
    [anon_sym_LT_LT_EQ] = ACTIONS(7914),
    [anon_sym_CARET_EQ] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7919),
    [anon_sym_AMP_AMP] = ACTIONS(7919),
    [anon_sym_LT_LT] = ACTIONS(7919),
    [anon_sym_GT_GT] = ACTIONS(7919),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7919),
    [anon_sym_PLUS] = ACTIONS(7919),
    [anon_sym_SLASH] = ACTIONS(7919),
    [anon_sym_PERCENT] = ACTIONS(7919),
    [sym_comment] = ACTIONS(87),
  },
  [9655] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5517),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3096),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(3096),
    [sym__argument] = STATE(6393),
    [sym_splat_argument] = STATE(6393),
    [sym_hash_splat_argument] = STATE(6393),
    [sym_block_argument] = STATE(6393),
    [sym_assignment] = STATE(5517),
    [sym_operator_assignment] = STATE(5517),
    [sym_conditional] = STATE(5517),
    [sym_range] = STATE(5517),
    [sym_binary] = STATE(5517),
    [sym_unary] = STATE(5517),
    [sym_left_assignment_list] = STATE(3095),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3096),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3096),
    [sym_false] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5520),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(6393),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(8665),
    [sym__splat_star] = ACTIONS(8667),
    [sym__unary_minus] = ACTIONS(5149),
    [sym__identifier_hash_key] = ACTIONS(8669),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13431),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5153),
    [anon_sym_yield] = ACTIONS(5155),
    [anon_sym_break] = ACTIONS(5157),
    [anon_sym_next] = ACTIONS(5159),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(8827),
    [anon_sym_defined_QMARK] = ACTIONS(5161),
    [anon_sym_not] = ACTIONS(5163),
    [anon_sym_BANG] = ACTIONS(5167),
    [anon_sym_TILDE] = ACTIONS(5167),
    [sym_constant] = ACTIONS(8671),
    [sym_identifier] = ACTIONS(8671),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [9656] = {
    [sym_heredoc_body] = STATE(9654),
    [aux_sym_call_repeat1] = STATE(9654),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7931),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_EQ] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_then] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_PLUS_EQ] = ACTIONS(7929),
    [anon_sym_DASH_EQ] = ACTIONS(7929),
    [anon_sym_STAR_EQ] = ACTIONS(7929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7929),
    [anon_sym_SLASH_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7929),
    [anon_sym_AMP_EQ] = ACTIONS(7929),
    [anon_sym_PERCENT_EQ] = ACTIONS(7929),
    [anon_sym_GT_GT_EQ] = ACTIONS(7929),
    [anon_sym_LT_LT_EQ] = ACTIONS(7929),
    [anon_sym_CARET_EQ] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7931),
    [anon_sym_AMP_AMP] = ACTIONS(7931),
    [anon_sym_LT_LT] = ACTIONS(7931),
    [anon_sym_GT_GT] = ACTIONS(7931),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7931),
    [anon_sym_PLUS] = ACTIONS(7931),
    [anon_sym_SLASH] = ACTIONS(7931),
    [anon_sym_PERCENT] = ACTIONS(7931),
    [sym_comment] = ACTIONS(87),
  },
  [9657] = {
    [aux_sym_argument_list_repeat1] = STATE(9657),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(14312),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7927),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_EQ] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_then] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_PLUS_EQ] = ACTIONS(7925),
    [anon_sym_DASH_EQ] = ACTIONS(7925),
    [anon_sym_STAR_EQ] = ACTIONS(7925),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7925),
    [anon_sym_SLASH_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7925),
    [anon_sym_AMP_EQ] = ACTIONS(7925),
    [anon_sym_PERCENT_EQ] = ACTIONS(7925),
    [anon_sym_GT_GT_EQ] = ACTIONS(7925),
    [anon_sym_LT_LT_EQ] = ACTIONS(7925),
    [anon_sym_CARET_EQ] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7927),
    [anon_sym_AMP_AMP] = ACTIONS(7927),
    [anon_sym_LT_LT] = ACTIONS(7927),
    [anon_sym_GT_GT] = ACTIONS(7927),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7927),
    [anon_sym_PLUS] = ACTIONS(7927),
    [anon_sym_SLASH] = ACTIONS(7927),
    [anon_sym_PERCENT] = ACTIONS(7927),
    [sym_comment] = ACTIONS(87),
  },
  [9658] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(8637),
    [sym__binary_star] = ACTIONS(8639),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(8641),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(8639),
    [anon_sym_AMP] = ACTIONS(8643),
    [anon_sym_LT] = ACTIONS(8645),
    [anon_sym_then] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(8647),
    [anon_sym_DOT_DOT] = ACTIONS(8649),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8651),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(8655),
    [anon_sym_AMP_AMP] = ACTIONS(8655),
    [anon_sym_LT_LT] = ACTIONS(8657),
    [anon_sym_GT_GT] = ACTIONS(8657),
    [anon_sym_EQ_EQ] = ACTIONS(8659),
    [anon_sym_BANG_EQ] = ACTIONS(8655),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8655),
    [anon_sym_LT_EQ_GT] = ACTIONS(8655),
    [anon_sym_EQ_TILDE] = ACTIONS(8655),
    [anon_sym_BANG_TILDE] = ACTIONS(8655),
    [anon_sym_LT_EQ] = ACTIONS(8645),
    [anon_sym_GT] = ACTIONS(8645),
    [anon_sym_GT_EQ] = ACTIONS(8661),
    [anon_sym_CARET] = ACTIONS(8663),
    [anon_sym_PLUS] = ACTIONS(8637),
    [anon_sym_SLASH] = ACTIONS(8639),
    [anon_sym_PERCENT] = ACTIONS(8639),
    [sym_comment] = ACTIONS(87),
  },
  [9659] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7967),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2984),
    [sym_scope_resolution] = STATE(2981),
    [sym_call] = STATE(2981),
    [sym_method_call] = STATE(2984),
    [sym_splat_argument] = STATE(6406),
    [sym_assignment] = STATE(7967),
    [sym_operator_assignment] = STATE(7967),
    [sym_conditional] = STATE(7967),
    [sym_range] = STATE(7967),
    [sym_binary] = STATE(7967),
    [sym_unary] = STATE(7967),
    [sym__arg_or_splat_arg] = STATE(6406),
    [sym_left_assignment_list] = STATE(2983),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2984),
    [sym__variable] = STATE(2981),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2984),
    [sym_false] = STATE(2984),
    [sym_nil] = STATE(2984),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2985),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(11490),
    [sym__unary_minus] = ACTIONS(4971),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4973),
    [anon_sym_yield] = ACTIONS(4975),
    [anon_sym_break] = ACTIONS(4977),
    [anon_sym_next] = ACTIONS(4979),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4981),
    [anon_sym_defined_QMARK] = ACTIONS(4983),
    [anon_sym_not] = ACTIONS(4985),
    [anon_sym_BANG] = ACTIONS(4987),
    [anon_sym_TILDE] = ACTIONS(4987),
    [sym_constant] = ACTIONS(4989),
    [sym_identifier] = ACTIONS(4989),
    [sym_instance_variable] = ACTIONS(4991),
    [sym_class_variable] = ACTIONS(4991),
    [sym_global_variable] = ACTIONS(4991),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4989),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4989),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9660] = {
    [aux_sym_exceptions_repeat1] = STATE(10619),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_COMMA] = ACTIONS(14315),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_then] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [9661] = {
    [sym_heredoc_body] = STATE(9661),
    [aux_sym_call_repeat1] = STATE(9661),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(7916),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_end] = ACTIONS(7914),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_else] = ACTIONS(7914),
    [anon_sym_ensure] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [9662] = {
    [sym_heredoc_body] = STATE(9661),
    [aux_sym_call_repeat1] = STATE(9661),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_end] = ACTIONS(7929),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_else] = ACTIONS(7929),
    [anon_sym_ensure] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [9663] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10620),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2999),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(2999),
    [sym_assignment] = STATE(10620),
    [sym_operator_assignment] = STATE(10620),
    [sym_conditional] = STATE(10620),
    [sym_range] = STATE(10620),
    [sym_binary] = STATE(10620),
    [sym_unary] = STATE(10620),
    [sym_left_assignment_list] = STATE(2998),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2999),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2999),
    [sym_false] = STATE(2999),
    [sym_nil] = STATE(2999),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(3000),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(5001),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5003),
    [anon_sym_yield] = ACTIONS(5005),
    [anon_sym_break] = ACTIONS(5007),
    [anon_sym_next] = ACTIONS(5009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5011),
    [anon_sym_defined_QMARK] = ACTIONS(5013),
    [anon_sym_not] = ACTIONS(5015),
    [anon_sym_BANG] = ACTIONS(5017),
    [anon_sym_TILDE] = ACTIONS(5017),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9664] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(7983),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(2999),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(2999),
    [sym_splat_argument] = STATE(7439),
    [sym_assignment] = STATE(7983),
    [sym_operator_assignment] = STATE(7983),
    [sym_conditional] = STATE(7983),
    [sym_range] = STATE(7983),
    [sym_binary] = STATE(7983),
    [sym_unary] = STATE(7983),
    [sym__arg_or_splat_arg] = STATE(7439),
    [sym_left_assignment_list] = STATE(2998),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2999),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(2999),
    [sym_false] = STATE(2999),
    [sym_nil] = STATE(2999),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(3000),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(2049),
    [sym__unary_minus] = ACTIONS(5001),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5003),
    [anon_sym_yield] = ACTIONS(5005),
    [anon_sym_break] = ACTIONS(5007),
    [anon_sym_next] = ACTIONS(5009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5011),
    [anon_sym_defined_QMARK] = ACTIONS(5013),
    [anon_sym_not] = ACTIONS(5015),
    [anon_sym_BANG] = ACTIONS(5017),
    [anon_sym_TILDE] = ACTIONS(5017),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9665] = {
    [aux_sym_exceptions_repeat1] = STATE(10621),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(14317),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_end] = ACTIONS(9855),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_else] = ACTIONS(9855),
    [anon_sym_ensure] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [9666] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(5033),
    [sym__binary_star] = ACTIONS(5035),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(5037),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(5035),
    [anon_sym_AMP] = ACTIONS(5039),
    [anon_sym_LT] = ACTIONS(5041),
    [anon_sym_end] = ACTIONS(12120),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_else] = ACTIONS(12120),
    [anon_sym_ensure] = ACTIONS(12120),
    [anon_sym_EQ_GT] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(5043),
    [anon_sym_DOT_DOT] = ACTIONS(5045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5047),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(5049),
    [anon_sym_AMP_AMP] = ACTIONS(5049),
    [anon_sym_LT_LT] = ACTIONS(5051),
    [anon_sym_GT_GT] = ACTIONS(5051),
    [anon_sym_EQ_EQ] = ACTIONS(5053),
    [anon_sym_BANG_EQ] = ACTIONS(5049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5049),
    [anon_sym_LT_EQ_GT] = ACTIONS(5049),
    [anon_sym_EQ_TILDE] = ACTIONS(5049),
    [anon_sym_BANG_TILDE] = ACTIONS(5049),
    [anon_sym_LT_EQ] = ACTIONS(5041),
    [anon_sym_GT] = ACTIONS(5041),
    [anon_sym_GT_EQ] = ACTIONS(5055),
    [anon_sym_CARET] = ACTIONS(5057),
    [anon_sym_PLUS] = ACTIONS(5033),
    [anon_sym_SLASH] = ACTIONS(5035),
    [anon_sym_PERCENT] = ACTIONS(5035),
    [sym_comment] = ACTIONS(87),
  },
  [9667] = {
    [aux_sym_exceptions_repeat1] = STATE(9667),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(14319),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_end] = ACTIONS(11597),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_else] = ACTIONS(11597),
    [anon_sym_ensure] = ACTIONS(11597),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [9668] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10622),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3056),
    [sym_scope_resolution] = STATE(1172),
    [sym_call] = STATE(1172),
    [sym_method_call] = STATE(3056),
    [sym_assignment] = STATE(10622),
    [sym_operator_assignment] = STATE(10622),
    [sym_conditional] = STATE(10622),
    [sym_range] = STATE(10622),
    [sym_binary] = STATE(10622),
    [sym_unary] = STATE(10622),
    [sym_left_assignment_list] = STATE(3055),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3056),
    [sym__variable] = STATE(1172),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3056),
    [sym_false] = STATE(3056),
    [sym_nil] = STATE(3056),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1176),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5081),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2085),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_next] = ACTIONS(2089),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8741),
    [anon_sym_defined_QMARK] = ACTIONS(5085),
    [anon_sym_not] = ACTIONS(5087),
    [anon_sym_BANG] = ACTIONS(5091),
    [anon_sym_TILDE] = ACTIONS(5091),
    [sym_constant] = ACTIONS(2103),
    [sym_identifier] = ACTIONS(2103),
    [sym_instance_variable] = ACTIONS(2105),
    [sym_class_variable] = ACTIONS(2105),
    [sym_global_variable] = ACTIONS(2105),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2103),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2103),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9669] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8018),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3056),
    [sym_scope_resolution] = STATE(1172),
    [sym_call] = STATE(1172),
    [sym_method_call] = STATE(3056),
    [sym_splat_argument] = STATE(7439),
    [sym_assignment] = STATE(8018),
    [sym_operator_assignment] = STATE(8018),
    [sym_conditional] = STATE(8018),
    [sym_range] = STATE(8018),
    [sym_binary] = STATE(8018),
    [sym_unary] = STATE(8018),
    [sym__arg_or_splat_arg] = STATE(7439),
    [sym_left_assignment_list] = STATE(3055),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3056),
    [sym__variable] = STATE(1172),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3056),
    [sym_false] = STATE(3056),
    [sym_nil] = STATE(3056),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1176),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__splat_star] = ACTIONS(5079),
    [sym__unary_minus] = ACTIONS(5081),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2085),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_next] = ACTIONS(2089),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8741),
    [anon_sym_defined_QMARK] = ACTIONS(5085),
    [anon_sym_not] = ACTIONS(5087),
    [anon_sym_BANG] = ACTIONS(5091),
    [anon_sym_TILDE] = ACTIONS(5091),
    [sym_constant] = ACTIONS(2103),
    [sym_identifier] = ACTIONS(2103),
    [sym_instance_variable] = ACTIONS(2105),
    [sym_class_variable] = ACTIONS(2105),
    [sym_global_variable] = ACTIONS(2105),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2103),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2103),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9670] = {
    [aux_sym_exceptions_repeat1] = STATE(10623),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(14322),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_then] = ACTIONS(9855),
    [anon_sym_EQ_GT] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [9671] = {
    [sym__line_break] = ACTIONS(4285),
    [sym__simple_symbol] = ACTIONS(4285),
    [sym__string_start] = ACTIONS(4285),
    [sym__symbol_start] = ACTIONS(4285),
    [sym__subshell_start] = ACTIONS(4285),
    [sym__regex_start] = ACTIONS(4285),
    [sym__string_array_start] = ACTIONS(4285),
    [sym__symbol_array_start] = ACTIONS(4285),
    [sym__heredoc_body_start] = ACTIONS(4285),
    [sym_heredoc_beginning] = ACTIONS(4285),
    [sym__block_ampersand] = ACTIONS(4285),
    [sym__splat_star] = ACTIONS(4285),
    [sym__unary_minus] = ACTIONS(4285),
    [sym__identifier_hash_key] = ACTIONS(4285),
    [anon_sym_LBRACE] = ACTIONS(4285),
    [anon_sym_def] = ACTIONS(4287),
    [anon_sym_LPAREN] = ACTIONS(4287),
    [anon_sym_DOT] = ACTIONS(4285),
    [anon_sym_COLON_COLON] = ACTIONS(4287),
    [anon_sym_SEMI] = ACTIONS(4285),
    [anon_sym_STAR] = ACTIONS(4287),
    [anon_sym_STAR_STAR] = ACTIONS(4285),
    [anon_sym_class] = ACTIONS(4287),
    [anon_sym_module] = ACTIONS(4287),
    [anon_sym_return] = ACTIONS(4287),
    [anon_sym_yield] = ACTIONS(4287),
    [anon_sym_break] = ACTIONS(4287),
    [anon_sym_next] = ACTIONS(4287),
    [sym_redo] = ACTIONS(4287),
    [sym_retry] = ACTIONS(4287),
    [anon_sym_if] = ACTIONS(4287),
    [anon_sym_unless] = ACTIONS(4287),
    [anon_sym_while] = ACTIONS(4287),
    [anon_sym_until] = ACTIONS(4287),
    [anon_sym_for] = ACTIONS(4287),
    [anon_sym_do] = ACTIONS(4287),
    [anon_sym_case] = ACTIONS(4287),
    [anon_sym_then] = ACTIONS(4287),
    [anon_sym_begin] = ACTIONS(4287),
    [anon_sym_LBRACK] = ACTIONS(4285),
    [anon_sym_COLON_COLON2] = ACTIONS(4285),
    [anon_sym_AMP_DOT] = ACTIONS(4285),
    [anon_sym_LPAREN2] = ACTIONS(4285),
    [anon_sym_PLUS] = ACTIONS(4287),
    [anon_sym_defined_QMARK] = ACTIONS(4285),
    [anon_sym_not] = ACTIONS(4287),
    [anon_sym_BANG] = ACTIONS(4285),
    [anon_sym_TILDE] = ACTIONS(4285),
    [sym_constant] = ACTIONS(4287),
    [sym_identifier] = ACTIONS(4287),
    [sym_instance_variable] = ACTIONS(4285),
    [sym_class_variable] = ACTIONS(4285),
    [sym_global_variable] = ACTIONS(4285),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4287),
    [sym_float] = ACTIONS(4287),
    [sym_complex] = ACTIONS(4285),
    [sym_super] = ACTIONS(4287),
    [anon_sym_true] = ACTIONS(4287),
    [anon_sym_TRUE] = ACTIONS(4287),
    [anon_sym_false] = ACTIONS(4287),
    [anon_sym_FALSE] = ACTIONS(4287),
    [sym_self] = ACTIONS(4287),
    [anon_sym_nil] = ACTIONS(4287),
    [anon_sym_NIL] = ACTIONS(4287),
    [sym_character] = ACTIONS(4285),
    [anon_sym_LBRACK2] = ACTIONS(4287),
    [anon_sym_DASH_GT] = ACTIONS(4285),
  },
  [9672] = {
    [anon_sym_RPAREN] = ACTIONS(14324),
    [sym_comment] = ACTIONS(87),
  },
  [9673] = {
    [sym__line_break] = ACTIONS(9679),
    [sym__simple_symbol] = ACTIONS(9679),
    [sym__string_start] = ACTIONS(9679),
    [sym__symbol_start] = ACTIONS(9679),
    [sym__subshell_start] = ACTIONS(9679),
    [sym__regex_start] = ACTIONS(9679),
    [sym__string_array_start] = ACTIONS(9679),
    [sym__symbol_array_start] = ACTIONS(9679),
    [sym__heredoc_body_start] = ACTIONS(9679),
    [sym_heredoc_beginning] = ACTIONS(9679),
    [sym__block_ampersand] = ACTIONS(9679),
    [sym__splat_star] = ACTIONS(9679),
    [sym__unary_minus] = ACTIONS(9679),
    [sym__identifier_hash_key] = ACTIONS(9679),
    [anon_sym_LBRACE] = ACTIONS(9679),
    [anon_sym_def] = ACTIONS(9681),
    [anon_sym_LPAREN] = ACTIONS(9681),
    [anon_sym_DOT] = ACTIONS(9679),
    [anon_sym_COLON_COLON] = ACTIONS(9681),
    [anon_sym_SEMI] = ACTIONS(9679),
    [anon_sym_STAR] = ACTIONS(9681),
    [anon_sym_STAR_STAR] = ACTIONS(9679),
    [anon_sym_class] = ACTIONS(9681),
    [anon_sym_module] = ACTIONS(9681),
    [anon_sym_return] = ACTIONS(9681),
    [anon_sym_yield] = ACTIONS(9681),
    [anon_sym_break] = ACTIONS(9681),
    [anon_sym_next] = ACTIONS(9681),
    [sym_redo] = ACTIONS(9681),
    [sym_retry] = ACTIONS(9681),
    [anon_sym_if] = ACTIONS(9681),
    [anon_sym_unless] = ACTIONS(9681),
    [anon_sym_while] = ACTIONS(9681),
    [anon_sym_until] = ACTIONS(9681),
    [anon_sym_for] = ACTIONS(9681),
    [anon_sym_do] = ACTIONS(9681),
    [anon_sym_case] = ACTIONS(9681),
    [anon_sym_then] = ACTIONS(9681),
    [anon_sym_begin] = ACTIONS(9681),
    [anon_sym_LBRACK] = ACTIONS(9679),
    [anon_sym_COLON_COLON2] = ACTIONS(9679),
    [anon_sym_AMP_DOT] = ACTIONS(9679),
    [anon_sym_LPAREN2] = ACTIONS(9679),
    [anon_sym_PLUS] = ACTIONS(9681),
    [anon_sym_defined_QMARK] = ACTIONS(9679),
    [anon_sym_not] = ACTIONS(9681),
    [anon_sym_BANG] = ACTIONS(9679),
    [anon_sym_TILDE] = ACTIONS(9679),
    [sym_constant] = ACTIONS(9681),
    [sym_identifier] = ACTIONS(9681),
    [sym_instance_variable] = ACTIONS(9679),
    [sym_class_variable] = ACTIONS(9679),
    [sym_global_variable] = ACTIONS(9679),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(9681),
    [sym_float] = ACTIONS(9681),
    [sym_complex] = ACTIONS(9679),
    [sym_super] = ACTIONS(9681),
    [anon_sym_true] = ACTIONS(9681),
    [anon_sym_TRUE] = ACTIONS(9681),
    [anon_sym_false] = ACTIONS(9681),
    [anon_sym_FALSE] = ACTIONS(9681),
    [sym_self] = ACTIONS(9681),
    [anon_sym_nil] = ACTIONS(9681),
    [anon_sym_NIL] = ACTIONS(9681),
    [sym_character] = ACTIONS(9679),
    [anon_sym_LBRACK2] = ACTIONS(9681),
    [anon_sym_DASH_GT] = ACTIONS(9679),
  },
  [9674] = {
    [sym__line_break] = ACTIONS(9686),
    [sym__heredoc_body_start] = ACTIONS(9686),
    [anon_sym_DOT] = ACTIONS(9686),
    [anon_sym_SEMI] = ACTIONS(9686),
    [anon_sym_then] = ACTIONS(9686),
    [anon_sym_LBRACK] = ACTIONS(9686),
    [anon_sym_COLON_COLON2] = ACTIONS(9686),
    [anon_sym_AMP_DOT] = ACTIONS(9686),
    [sym_comment] = ACTIONS(87),
  },
  [9675] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(13464),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [9676] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10625),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(8037),
    [sym_scope_resolution] = STATE(7955),
    [sym_call] = STATE(7955),
    [sym_method_call] = STATE(8037),
    [sym_assignment] = STATE(10625),
    [sym_operator_assignment] = STATE(10625),
    [sym_conditional] = STATE(10625),
    [sym_range] = STATE(10625),
    [sym_binary] = STATE(10625),
    [sym_unary] = STATE(10625),
    [sym_left_assignment_list] = STATE(8036),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(8037),
    [sym__variable] = STATE(7955),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(8037),
    [sym_false] = STATE(8037),
    [sym_nil] = STATE(8037),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(8038),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11513),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11515),
    [anon_sym_yield] = ACTIONS(11517),
    [anon_sym_break] = ACTIONS(11519),
    [anon_sym_next] = ACTIONS(11521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11523),
    [anon_sym_defined_QMARK] = ACTIONS(11525),
    [anon_sym_not] = ACTIONS(11527),
    [anon_sym_BANG] = ACTIONS(11529),
    [anon_sym_TILDE] = ACTIONS(11529),
    [sym_constant] = ACTIONS(11478),
    [sym_identifier] = ACTIONS(11478),
    [sym_instance_variable] = ACTIONS(11480),
    [sym_class_variable] = ACTIONS(11480),
    [sym_global_variable] = ACTIONS(11480),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11478),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11478),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9677] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10626),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(8037),
    [sym_scope_resolution] = STATE(7955),
    [sym_call] = STATE(7955),
    [sym_method_call] = STATE(8037),
    [sym_assignment] = STATE(10626),
    [sym_operator_assignment] = STATE(10626),
    [sym_conditional] = STATE(10626),
    [sym_range] = STATE(10626),
    [sym_binary] = STATE(10626),
    [sym_unary] = STATE(10626),
    [sym_left_assignment_list] = STATE(8036),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(8037),
    [sym__variable] = STATE(7955),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(8037),
    [sym_false] = STATE(8037),
    [sym_nil] = STATE(8037),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(8038),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11513),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11515),
    [anon_sym_yield] = ACTIONS(11517),
    [anon_sym_break] = ACTIONS(11519),
    [anon_sym_next] = ACTIONS(11521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11523),
    [anon_sym_defined_QMARK] = ACTIONS(11525),
    [anon_sym_not] = ACTIONS(11527),
    [anon_sym_BANG] = ACTIONS(11529),
    [anon_sym_TILDE] = ACTIONS(11529),
    [sym_constant] = ACTIONS(11478),
    [sym_identifier] = ACTIONS(11478),
    [sym_instance_variable] = ACTIONS(11480),
    [sym_class_variable] = ACTIONS(11480),
    [sym_global_variable] = ACTIONS(11480),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11478),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11478),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9678] = {
    [anon_sym_COLON] = ACTIONS(14326),
    [sym_comment] = ACTIONS(87),
  },
  [9679] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10628),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(8037),
    [sym_scope_resolution] = STATE(7955),
    [sym_call] = STATE(7955),
    [sym_method_call] = STATE(8037),
    [sym_assignment] = STATE(10628),
    [sym_operator_assignment] = STATE(10628),
    [sym_conditional] = STATE(10628),
    [sym_range] = STATE(10628),
    [sym_binary] = STATE(10628),
    [sym_unary] = STATE(10628),
    [sym_left_assignment_list] = STATE(8036),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(8037),
    [sym__variable] = STATE(7955),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(8037),
    [sym_false] = STATE(8037),
    [sym_nil] = STATE(8037),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(8038),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11513),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11515),
    [anon_sym_yield] = ACTIONS(11517),
    [anon_sym_break] = ACTIONS(11519),
    [anon_sym_next] = ACTIONS(11521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11523),
    [anon_sym_defined_QMARK] = ACTIONS(11525),
    [anon_sym_not] = ACTIONS(11527),
    [anon_sym_BANG] = ACTIONS(11529),
    [anon_sym_TILDE] = ACTIONS(11529),
    [sym_constant] = ACTIONS(11478),
    [sym_identifier] = ACTIONS(11478),
    [sym_instance_variable] = ACTIONS(11480),
    [sym_class_variable] = ACTIONS(11480),
    [sym_global_variable] = ACTIONS(11480),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11478),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11478),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9680] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(14328),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_then] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [9681] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(11549),
    [sym__binary_star] = ACTIONS(11551),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(11553),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(11551),
    [anon_sym_AMP] = ACTIONS(11555),
    [anon_sym_LT] = ACTIONS(11557),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_then] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(14326),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(11559),
    [anon_sym_DOT_DOT] = ACTIONS(11561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11563),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(11567),
    [anon_sym_AMP_AMP] = ACTIONS(11567),
    [anon_sym_LT_LT] = ACTIONS(11569),
    [anon_sym_GT_GT] = ACTIONS(11569),
    [anon_sym_EQ_EQ] = ACTIONS(11571),
    [anon_sym_BANG_EQ] = ACTIONS(11567),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11567),
    [anon_sym_LT_EQ_GT] = ACTIONS(11567),
    [anon_sym_EQ_TILDE] = ACTIONS(11567),
    [anon_sym_BANG_TILDE] = ACTIONS(11567),
    [anon_sym_LT_EQ] = ACTIONS(11557),
    [anon_sym_GT] = ACTIONS(11557),
    [anon_sym_GT_EQ] = ACTIONS(11573),
    [anon_sym_CARET] = ACTIONS(11575),
    [anon_sym_PLUS] = ACTIONS(11549),
    [anon_sym_SLASH] = ACTIONS(11551),
    [anon_sym_PERCENT] = ACTIONS(11551),
    [sym_comment] = ACTIONS(87),
  },
  [9682] = {
    [sym_heredoc_body] = STATE(10630),
    [aux_sym_call_repeat1] = STATE(10630),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_then] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [9683] = {
    [sym_heredoc_body] = STATE(10630),
    [aux_sym_call_repeat1] = STATE(10630),
    [aux_sym_argument_list_repeat1] = STATE(10632),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(14330),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_then] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [9684] = {
    [sym_string] = STATE(8075),
    [aux_sym_chained_string_repeat1] = STATE(8075),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(14332),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [9685] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(13462),
    [sym__binary_star] = ACTIONS(13464),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(13466),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(13464),
    [anon_sym_AMP] = ACTIONS(13468),
    [anon_sym_LT] = ACTIONS(13470),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(13472),
    [anon_sym_DOT_DOT] = ACTIONS(13474),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13476),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(13480),
    [anon_sym_AMP_AMP] = ACTIONS(13480),
    [anon_sym_LT_LT] = ACTIONS(13482),
    [anon_sym_GT_GT] = ACTIONS(13482),
    [anon_sym_EQ_EQ] = ACTIONS(13484),
    [anon_sym_BANG_EQ] = ACTIONS(13480),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13480),
    [anon_sym_LT_EQ_GT] = ACTIONS(13480),
    [anon_sym_EQ_TILDE] = ACTIONS(13480),
    [anon_sym_BANG_TILDE] = ACTIONS(13480),
    [anon_sym_LT_EQ] = ACTIONS(13470),
    [anon_sym_GT] = ACTIONS(13470),
    [anon_sym_GT_EQ] = ACTIONS(13486),
    [anon_sym_CARET] = ACTIONS(13488),
    [anon_sym_PLUS] = ACTIONS(13462),
    [anon_sym_SLASH] = ACTIONS(13464),
    [anon_sym_PERCENT] = ACTIONS(13464),
    [sym_comment] = ACTIONS(87),
  },
  [9686] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10633),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(8037),
    [sym_scope_resolution] = STATE(7955),
    [sym_call] = STATE(7955),
    [sym_method_call] = STATE(8037),
    [sym_assignment] = STATE(10633),
    [sym_operator_assignment] = STATE(10633),
    [sym_conditional] = STATE(10633),
    [sym_range] = STATE(10633),
    [sym_binary] = STATE(10633),
    [sym_unary] = STATE(10633),
    [sym_left_assignment_list] = STATE(8036),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(8037),
    [sym__variable] = STATE(7955),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(8037),
    [sym_false] = STATE(8037),
    [sym_nil] = STATE(8037),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(8038),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11513),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11515),
    [anon_sym_yield] = ACTIONS(11517),
    [anon_sym_break] = ACTIONS(11519),
    [anon_sym_next] = ACTIONS(11521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11523),
    [anon_sym_defined_QMARK] = ACTIONS(11525),
    [anon_sym_not] = ACTIONS(11527),
    [anon_sym_BANG] = ACTIONS(11529),
    [anon_sym_TILDE] = ACTIONS(11529),
    [sym_constant] = ACTIONS(11478),
    [sym_identifier] = ACTIONS(11478),
    [sym_instance_variable] = ACTIONS(11480),
    [sym_class_variable] = ACTIONS(11480),
    [sym_global_variable] = ACTIONS(11480),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11478),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11478),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9687] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10634),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(8037),
    [sym_scope_resolution] = STATE(7955),
    [sym_call] = STATE(7955),
    [sym_method_call] = STATE(8037),
    [sym_assignment] = STATE(10634),
    [sym_operator_assignment] = STATE(10634),
    [sym_conditional] = STATE(10634),
    [sym_range] = STATE(10634),
    [sym_binary] = STATE(10634),
    [sym_unary] = STATE(10634),
    [sym_left_assignment_list] = STATE(8036),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(8037),
    [sym__variable] = STATE(7955),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(8037),
    [sym_false] = STATE(8037),
    [sym_nil] = STATE(8037),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(8038),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11513),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11515),
    [anon_sym_yield] = ACTIONS(11517),
    [anon_sym_break] = ACTIONS(11519),
    [anon_sym_next] = ACTIONS(11521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11523),
    [anon_sym_defined_QMARK] = ACTIONS(11525),
    [anon_sym_not] = ACTIONS(11527),
    [anon_sym_BANG] = ACTIONS(11529),
    [anon_sym_TILDE] = ACTIONS(11529),
    [sym_constant] = ACTIONS(11478),
    [sym_identifier] = ACTIONS(11478),
    [sym_instance_variable] = ACTIONS(11480),
    [sym_class_variable] = ACTIONS(11480),
    [sym_global_variable] = ACTIONS(11480),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11478),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11478),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9688] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10635),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(8037),
    [sym_scope_resolution] = STATE(7955),
    [sym_call] = STATE(7955),
    [sym_method_call] = STATE(8037),
    [sym_assignment] = STATE(10635),
    [sym_operator_assignment] = STATE(10635),
    [sym_conditional] = STATE(10635),
    [sym_range] = STATE(10635),
    [sym_binary] = STATE(10635),
    [sym_unary] = STATE(10635),
    [sym_left_assignment_list] = STATE(8036),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(8037),
    [sym__variable] = STATE(7955),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(8037),
    [sym_false] = STATE(8037),
    [sym_nil] = STATE(8037),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(8038),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11513),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11515),
    [anon_sym_yield] = ACTIONS(11517),
    [anon_sym_break] = ACTIONS(11519),
    [anon_sym_next] = ACTIONS(11521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11523),
    [anon_sym_defined_QMARK] = ACTIONS(11525),
    [anon_sym_not] = ACTIONS(11527),
    [anon_sym_BANG] = ACTIONS(11529),
    [anon_sym_TILDE] = ACTIONS(11529),
    [sym_constant] = ACTIONS(11478),
    [sym_identifier] = ACTIONS(11478),
    [sym_instance_variable] = ACTIONS(11480),
    [sym_class_variable] = ACTIONS(11480),
    [sym_global_variable] = ACTIONS(11480),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11478),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11478),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9689] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10636),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(8037),
    [sym_scope_resolution] = STATE(7955),
    [sym_call] = STATE(7955),
    [sym_method_call] = STATE(8037),
    [sym_assignment] = STATE(10636),
    [sym_operator_assignment] = STATE(10636),
    [sym_conditional] = STATE(10636),
    [sym_range] = STATE(10636),
    [sym_binary] = STATE(10636),
    [sym_unary] = STATE(10636),
    [sym_left_assignment_list] = STATE(8036),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(8037),
    [sym__variable] = STATE(7955),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(8037),
    [sym_false] = STATE(8037),
    [sym_nil] = STATE(8037),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(8038),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11513),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11515),
    [anon_sym_yield] = ACTIONS(11517),
    [anon_sym_break] = ACTIONS(11519),
    [anon_sym_next] = ACTIONS(11521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11523),
    [anon_sym_defined_QMARK] = ACTIONS(11525),
    [anon_sym_not] = ACTIONS(11527),
    [anon_sym_BANG] = ACTIONS(11529),
    [anon_sym_TILDE] = ACTIONS(11529),
    [sym_constant] = ACTIONS(11478),
    [sym_identifier] = ACTIONS(11478),
    [sym_instance_variable] = ACTIONS(11480),
    [sym_class_variable] = ACTIONS(11480),
    [sym_global_variable] = ACTIONS(11480),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11478),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11478),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9690] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10637),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(8037),
    [sym_scope_resolution] = STATE(7955),
    [sym_call] = STATE(7955),
    [sym_method_call] = STATE(8037),
    [sym_assignment] = STATE(10637),
    [sym_operator_assignment] = STATE(10637),
    [sym_conditional] = STATE(10637),
    [sym_range] = STATE(10637),
    [sym_binary] = STATE(10637),
    [sym_unary] = STATE(10637),
    [sym_left_assignment_list] = STATE(8036),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(8037),
    [sym__variable] = STATE(7955),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(8037),
    [sym_false] = STATE(8037),
    [sym_nil] = STATE(8037),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(8038),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11513),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11515),
    [anon_sym_yield] = ACTIONS(11517),
    [anon_sym_break] = ACTIONS(11519),
    [anon_sym_next] = ACTIONS(11521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11523),
    [anon_sym_defined_QMARK] = ACTIONS(11525),
    [anon_sym_not] = ACTIONS(11527),
    [anon_sym_BANG] = ACTIONS(11529),
    [anon_sym_TILDE] = ACTIONS(11529),
    [sym_constant] = ACTIONS(11478),
    [sym_identifier] = ACTIONS(11478),
    [sym_instance_variable] = ACTIONS(11480),
    [sym_class_variable] = ACTIONS(11480),
    [sym_global_variable] = ACTIONS(11480),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11478),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11478),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9691] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(10638),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(10638),
    [sym_operator_assignment] = STATE(10638),
    [sym_conditional] = STATE(10638),
    [sym_range] = STATE(10638),
    [sym_binary] = STATE(10638),
    [sym_unary] = STATE(10638),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9692] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10639),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(8037),
    [sym_scope_resolution] = STATE(7955),
    [sym_call] = STATE(7955),
    [sym_method_call] = STATE(8037),
    [sym_assignment] = STATE(10639),
    [sym_operator_assignment] = STATE(10639),
    [sym_conditional] = STATE(10639),
    [sym_range] = STATE(10639),
    [sym_binary] = STATE(10639),
    [sym_unary] = STATE(10639),
    [sym_left_assignment_list] = STATE(8036),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(8037),
    [sym__variable] = STATE(7955),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(8037),
    [sym_false] = STATE(8037),
    [sym_nil] = STATE(8037),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(8038),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11513),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11515),
    [anon_sym_yield] = ACTIONS(11517),
    [anon_sym_break] = ACTIONS(11519),
    [anon_sym_next] = ACTIONS(11521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11523),
    [anon_sym_defined_QMARK] = ACTIONS(11525),
    [anon_sym_not] = ACTIONS(11527),
    [anon_sym_BANG] = ACTIONS(11529),
    [anon_sym_TILDE] = ACTIONS(11529),
    [sym_constant] = ACTIONS(11478),
    [sym_identifier] = ACTIONS(11478),
    [sym_instance_variable] = ACTIONS(11480),
    [sym_class_variable] = ACTIONS(11480),
    [sym_global_variable] = ACTIONS(11480),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11478),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11478),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9693] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10640),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(8037),
    [sym_scope_resolution] = STATE(7955),
    [sym_call] = STATE(7955),
    [sym_method_call] = STATE(8037),
    [sym_assignment] = STATE(10640),
    [sym_operator_assignment] = STATE(10640),
    [sym_conditional] = STATE(10640),
    [sym_range] = STATE(10640),
    [sym_binary] = STATE(10640),
    [sym_unary] = STATE(10640),
    [sym_left_assignment_list] = STATE(8036),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(8037),
    [sym__variable] = STATE(7955),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(8037),
    [sym_false] = STATE(8037),
    [sym_nil] = STATE(8037),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(8038),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11513),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11515),
    [anon_sym_yield] = ACTIONS(11517),
    [anon_sym_break] = ACTIONS(11519),
    [anon_sym_next] = ACTIONS(11521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11523),
    [anon_sym_defined_QMARK] = ACTIONS(11525),
    [anon_sym_not] = ACTIONS(11527),
    [anon_sym_BANG] = ACTIONS(11529),
    [anon_sym_TILDE] = ACTIONS(11529),
    [sym_constant] = ACTIONS(11478),
    [sym_identifier] = ACTIONS(11478),
    [sym_instance_variable] = ACTIONS(11480),
    [sym_class_variable] = ACTIONS(11480),
    [sym_global_variable] = ACTIONS(11480),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11478),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11478),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9694] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10641),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(8037),
    [sym_scope_resolution] = STATE(7955),
    [sym_call] = STATE(7955),
    [sym_method_call] = STATE(8037),
    [sym_assignment] = STATE(10641),
    [sym_operator_assignment] = STATE(10641),
    [sym_conditional] = STATE(10641),
    [sym_range] = STATE(10641),
    [sym_binary] = STATE(10641),
    [sym_unary] = STATE(10641),
    [sym_left_assignment_list] = STATE(8036),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(8037),
    [sym__variable] = STATE(7955),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(8037),
    [sym_false] = STATE(8037),
    [sym_nil] = STATE(8037),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(8038),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11513),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11515),
    [anon_sym_yield] = ACTIONS(11517),
    [anon_sym_break] = ACTIONS(11519),
    [anon_sym_next] = ACTIONS(11521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11523),
    [anon_sym_defined_QMARK] = ACTIONS(11525),
    [anon_sym_not] = ACTIONS(11527),
    [anon_sym_BANG] = ACTIONS(11529),
    [anon_sym_TILDE] = ACTIONS(11529),
    [sym_constant] = ACTIONS(11478),
    [sym_identifier] = ACTIONS(11478),
    [sym_instance_variable] = ACTIONS(11480),
    [sym_class_variable] = ACTIONS(11480),
    [sym_global_variable] = ACTIONS(11480),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11478),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11478),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9695] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10642),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(8037),
    [sym_scope_resolution] = STATE(7955),
    [sym_call] = STATE(7955),
    [sym_method_call] = STATE(8037),
    [sym_assignment] = STATE(10642),
    [sym_operator_assignment] = STATE(10642),
    [sym_conditional] = STATE(10642),
    [sym_range] = STATE(10642),
    [sym_binary] = STATE(10642),
    [sym_unary] = STATE(10642),
    [sym_left_assignment_list] = STATE(8036),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(8037),
    [sym__variable] = STATE(7955),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(8037),
    [sym_false] = STATE(8037),
    [sym_nil] = STATE(8037),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(8038),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11513),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11515),
    [anon_sym_yield] = ACTIONS(11517),
    [anon_sym_break] = ACTIONS(11519),
    [anon_sym_next] = ACTIONS(11521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11523),
    [anon_sym_defined_QMARK] = ACTIONS(11525),
    [anon_sym_not] = ACTIONS(11527),
    [anon_sym_BANG] = ACTIONS(11529),
    [anon_sym_TILDE] = ACTIONS(11529),
    [sym_constant] = ACTIONS(11478),
    [sym_identifier] = ACTIONS(11478),
    [sym_instance_variable] = ACTIONS(11480),
    [sym_class_variable] = ACTIONS(11480),
    [sym_global_variable] = ACTIONS(11480),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11478),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11478),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9696] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10643),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(8037),
    [sym_scope_resolution] = STATE(7955),
    [sym_call] = STATE(7955),
    [sym_method_call] = STATE(8037),
    [sym_splat_argument] = STATE(10644),
    [sym_assignment] = STATE(10643),
    [sym_operator_assignment] = STATE(10643),
    [sym_conditional] = STATE(10643),
    [sym_range] = STATE(10643),
    [sym_binary] = STATE(10643),
    [sym_unary] = STATE(10643),
    [sym_right_assignment_list] = STATE(2570),
    [sym__arg_or_splat_arg] = STATE(10644),
    [sym_left_assignment_list] = STATE(8036),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(8037),
    [sym__variable] = STATE(7955),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(8037),
    [sym_false] = STATE(8037),
    [sym_nil] = STATE(8037),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(8038),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(13456),
    [sym__unary_minus] = ACTIONS(11513),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11515),
    [anon_sym_yield] = ACTIONS(11517),
    [anon_sym_break] = ACTIONS(11519),
    [anon_sym_next] = ACTIONS(11521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11523),
    [anon_sym_defined_QMARK] = ACTIONS(11525),
    [anon_sym_not] = ACTIONS(11527),
    [anon_sym_BANG] = ACTIONS(11529),
    [anon_sym_TILDE] = ACTIONS(11529),
    [sym_constant] = ACTIONS(11478),
    [sym_identifier] = ACTIONS(11478),
    [sym_instance_variable] = ACTIONS(11480),
    [sym_class_variable] = ACTIONS(11480),
    [sym_global_variable] = ACTIONS(11480),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11478),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11478),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9697] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10645),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(8037),
    [sym_scope_resolution] = STATE(7955),
    [sym_call] = STATE(7955),
    [sym_method_call] = STATE(8037),
    [sym_assignment] = STATE(10645),
    [sym_operator_assignment] = STATE(10645),
    [sym_conditional] = STATE(10645),
    [sym_range] = STATE(10645),
    [sym_binary] = STATE(10645),
    [sym_unary] = STATE(10645),
    [sym_left_assignment_list] = STATE(8036),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(8037),
    [sym__variable] = STATE(7955),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(8037),
    [sym_false] = STATE(8037),
    [sym_nil] = STATE(8037),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(8038),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11513),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11515),
    [anon_sym_yield] = ACTIONS(11517),
    [anon_sym_break] = ACTIONS(11519),
    [anon_sym_next] = ACTIONS(11521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11523),
    [anon_sym_defined_QMARK] = ACTIONS(11525),
    [anon_sym_not] = ACTIONS(11527),
    [anon_sym_BANG] = ACTIONS(11529),
    [anon_sym_TILDE] = ACTIONS(11529),
    [sym_constant] = ACTIONS(11478),
    [sym_identifier] = ACTIONS(11478),
    [sym_instance_variable] = ACTIONS(11480),
    [sym_class_variable] = ACTIONS(11480),
    [sym_global_variable] = ACTIONS(11480),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11478),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11478),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9698] = {
    [sym_string] = STATE(10646),
    [aux_sym_chained_string_repeat1] = STATE(10646),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_then] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [9699] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(13462),
    [sym__binary_star] = ACTIONS(13464),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(13466),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(13464),
    [anon_sym_AMP] = ACTIONS(13468),
    [anon_sym_LT] = ACTIONS(13470),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_then] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(13472),
    [anon_sym_DOT_DOT] = ACTIONS(13474),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13476),
    [anon_sym_and] = ACTIONS(13478),
    [anon_sym_or] = ACTIONS(13478),
    [anon_sym_PIPE_PIPE] = ACTIONS(13480),
    [anon_sym_AMP_AMP] = ACTIONS(13480),
    [anon_sym_LT_LT] = ACTIONS(13482),
    [anon_sym_GT_GT] = ACTIONS(13482),
    [anon_sym_EQ_EQ] = ACTIONS(13484),
    [anon_sym_BANG_EQ] = ACTIONS(13480),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13480),
    [anon_sym_LT_EQ_GT] = ACTIONS(13480),
    [anon_sym_EQ_TILDE] = ACTIONS(13480),
    [anon_sym_BANG_TILDE] = ACTIONS(13480),
    [anon_sym_LT_EQ] = ACTIONS(13470),
    [anon_sym_GT] = ACTIONS(13470),
    [anon_sym_GT_EQ] = ACTIONS(13486),
    [anon_sym_CARET] = ACTIONS(13488),
    [anon_sym_PLUS] = ACTIONS(13462),
    [anon_sym_SLASH] = ACTIONS(13464),
    [anon_sym_PERCENT] = ACTIONS(13464),
    [sym_comment] = ACTIONS(87),
  },
  [9700] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(11549),
    [sym__binary_star] = ACTIONS(11551),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(11553),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(11551),
    [anon_sym_AMP] = ACTIONS(11555),
    [anon_sym_LT] = ACTIONS(11557),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_then] = ACTIONS(4211),
    [anon_sym_EQ_GT] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(11559),
    [anon_sym_DOT_DOT] = ACTIONS(11561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11563),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11567),
    [anon_sym_AMP_AMP] = ACTIONS(11567),
    [anon_sym_LT_LT] = ACTIONS(11569),
    [anon_sym_GT_GT] = ACTIONS(11569),
    [anon_sym_EQ_EQ] = ACTIONS(11571),
    [anon_sym_BANG_EQ] = ACTIONS(11567),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11567),
    [anon_sym_LT_EQ_GT] = ACTIONS(11567),
    [anon_sym_EQ_TILDE] = ACTIONS(11567),
    [anon_sym_BANG_TILDE] = ACTIONS(11567),
    [anon_sym_LT_EQ] = ACTIONS(11557),
    [anon_sym_GT] = ACTIONS(11557),
    [anon_sym_GT_EQ] = ACTIONS(11573),
    [anon_sym_CARET] = ACTIONS(11575),
    [anon_sym_PLUS] = ACTIONS(11549),
    [anon_sym_SLASH] = ACTIONS(11551),
    [anon_sym_PERCENT] = ACTIONS(11551),
    [sym_comment] = ACTIONS(87),
  },
  [9701] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(11549),
    [sym__binary_star] = ACTIONS(11551),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(11553),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(11551),
    [anon_sym_AMP] = ACTIONS(11555),
    [anon_sym_LT] = ACTIONS(11557),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_then] = ACTIONS(4247),
    [anon_sym_EQ_GT] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(11559),
    [anon_sym_DOT_DOT] = ACTIONS(11561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11563),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(11567),
    [anon_sym_AMP_AMP] = ACTIONS(11567),
    [anon_sym_LT_LT] = ACTIONS(11569),
    [anon_sym_GT_GT] = ACTIONS(11569),
    [anon_sym_EQ_EQ] = ACTIONS(11571),
    [anon_sym_BANG_EQ] = ACTIONS(11567),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11567),
    [anon_sym_LT_EQ_GT] = ACTIONS(11567),
    [anon_sym_EQ_TILDE] = ACTIONS(11567),
    [anon_sym_BANG_TILDE] = ACTIONS(11567),
    [anon_sym_LT_EQ] = ACTIONS(11557),
    [anon_sym_GT] = ACTIONS(11557),
    [anon_sym_GT_EQ] = ACTIONS(11573),
    [anon_sym_CARET] = ACTIONS(11575),
    [anon_sym_PLUS] = ACTIONS(11549),
    [anon_sym_SLASH] = ACTIONS(11551),
    [anon_sym_PERCENT] = ACTIONS(11551),
    [sym_comment] = ACTIONS(87),
  },
  [9702] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10647),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5621),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(5621),
    [sym_assignment] = STATE(10647),
    [sym_operator_assignment] = STATE(10647),
    [sym_conditional] = STATE(10647),
    [sym_range] = STATE(10647),
    [sym_binary] = STATE(10647),
    [sym_unary] = STATE(10647),
    [sym_left_assignment_list] = STATE(5620),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5621),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5621),
    [sym_false] = STATE(5621),
    [sym_nil] = STATE(5621),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(8041),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(8791),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8799),
    [anon_sym_yield] = ACTIONS(8801),
    [anon_sym_break] = ACTIONS(8803),
    [anon_sym_next] = ACTIONS(8805),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8809),
    [anon_sym_defined_QMARK] = ACTIONS(8811),
    [anon_sym_not] = ACTIONS(8813),
    [anon_sym_BANG] = ACTIONS(8815),
    [anon_sym_TILDE] = ACTIONS(8815),
    [sym_constant] = ACTIONS(5173),
    [sym_identifier] = ACTIONS(5173),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9703] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(11549),
    [sym__binary_star] = ACTIONS(11551),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(11553),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(11551),
    [anon_sym_AMP] = ACTIONS(11555),
    [anon_sym_LT] = ACTIONS(11557),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_then] = ACTIONS(3281),
    [anon_sym_EQ_GT] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(11559),
    [anon_sym_DOT_DOT] = ACTIONS(11561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11563),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(11567),
    [anon_sym_AMP_AMP] = ACTIONS(11567),
    [anon_sym_LT_LT] = ACTIONS(11569),
    [anon_sym_GT_GT] = ACTIONS(11569),
    [anon_sym_EQ_EQ] = ACTIONS(11571),
    [anon_sym_BANG_EQ] = ACTIONS(11567),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11567),
    [anon_sym_LT_EQ_GT] = ACTIONS(11567),
    [anon_sym_EQ_TILDE] = ACTIONS(11567),
    [anon_sym_BANG_TILDE] = ACTIONS(11567),
    [anon_sym_LT_EQ] = ACTIONS(11557),
    [anon_sym_GT] = ACTIONS(11557),
    [anon_sym_GT_EQ] = ACTIONS(11573),
    [anon_sym_CARET] = ACTIONS(11575),
    [anon_sym_PLUS] = ACTIONS(11549),
    [anon_sym_SLASH] = ACTIONS(11551),
    [anon_sym_PERCENT] = ACTIONS(11551),
    [sym_comment] = ACTIONS(87),
  },
  [9704] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10648),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5621),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(5621),
    [sym_assignment] = STATE(10648),
    [sym_operator_assignment] = STATE(10648),
    [sym_conditional] = STATE(10648),
    [sym_range] = STATE(10648),
    [sym_binary] = STATE(10648),
    [sym_unary] = STATE(10648),
    [sym_left_assignment_list] = STATE(5620),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5621),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5621),
    [sym_false] = STATE(5621),
    [sym_nil] = STATE(5621),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(8041),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(8791),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8799),
    [anon_sym_yield] = ACTIONS(8801),
    [anon_sym_break] = ACTIONS(8803),
    [anon_sym_next] = ACTIONS(8805),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8809),
    [anon_sym_defined_QMARK] = ACTIONS(8811),
    [anon_sym_not] = ACTIONS(8813),
    [anon_sym_BANG] = ACTIONS(8815),
    [anon_sym_TILDE] = ACTIONS(8815),
    [sym_constant] = ACTIONS(5173),
    [sym_identifier] = ACTIONS(5173),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9705] = {
    [sym_heredoc_body] = STATE(10649),
    [aux_sym_call_repeat1] = STATE(10649),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_then] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [9706] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8050),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5621),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(5621),
    [sym__argument] = STATE(2565),
    [sym_splat_argument] = STATE(2565),
    [sym_hash_splat_argument] = STATE(2565),
    [sym_block_argument] = STATE(2565),
    [sym_assignment] = STATE(8050),
    [sym_operator_assignment] = STATE(8050),
    [sym_conditional] = STATE(8050),
    [sym_range] = STATE(8050),
    [sym_binary] = STATE(8050),
    [sym_unary] = STATE(8050),
    [sym_left_assignment_list] = STATE(5620),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5621),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5621),
    [sym_false] = STATE(5621),
    [sym_nil] = STATE(5621),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(8053),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(10650),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2565),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(11535),
    [sym__splat_star] = ACTIONS(11537),
    [sym__unary_minus] = ACTIONS(8791),
    [sym__identifier_hash_key] = ACTIONS(11539),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(14334),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8799),
    [anon_sym_yield] = ACTIONS(8801),
    [anon_sym_break] = ACTIONS(8803),
    [anon_sym_next] = ACTIONS(8805),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8809),
    [anon_sym_defined_QMARK] = ACTIONS(8811),
    [anon_sym_not] = ACTIONS(8813),
    [anon_sym_BANG] = ACTIONS(8815),
    [anon_sym_TILDE] = ACTIONS(8815),
    [sym_constant] = ACTIONS(11543),
    [sym_identifier] = ACTIONS(11543),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9707] = {
    [sym_heredoc_body] = STATE(10651),
    [aux_sym_call_repeat1] = STATE(10651),
    [aux_sym_argument_list_repeat1] = STATE(10652),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(13500),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_then] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [9708] = {
    [sym__line_break] = ACTIONS(7876),
    [sym__heredoc_body_start] = ACTIONS(7876),
    [anon_sym_LBRACE] = ACTIONS(7876),
    [anon_sym_DOT] = ACTIONS(7876),
    [anon_sym_SEMI] = ACTIONS(7876),
    [anon_sym_do] = ACTIONS(7876),
    [anon_sym_then] = ACTIONS(7876),
    [anon_sym_LBRACK] = ACTIONS(7876),
    [anon_sym_COLON_COLON2] = ACTIONS(7876),
    [anon_sym_AMP_DOT] = ACTIONS(7876),
    [sym_comment] = ACTIONS(87),
  },
  [9709] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(13462),
    [sym__binary_star] = ACTIONS(13464),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(13466),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(13464),
    [anon_sym_AMP] = ACTIONS(13468),
    [anon_sym_LT] = ACTIONS(13470),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_then] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(13472),
    [anon_sym_DOT_DOT] = ACTIONS(13474),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13476),
    [anon_sym_and] = ACTIONS(13478),
    [anon_sym_or] = ACTIONS(13478),
    [anon_sym_PIPE_PIPE] = ACTIONS(13480),
    [anon_sym_AMP_AMP] = ACTIONS(13480),
    [anon_sym_LT_LT] = ACTIONS(13482),
    [anon_sym_GT_GT] = ACTIONS(13482),
    [anon_sym_EQ_EQ] = ACTIONS(13484),
    [anon_sym_BANG_EQ] = ACTIONS(13480),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13480),
    [anon_sym_LT_EQ_GT] = ACTIONS(13480),
    [anon_sym_EQ_TILDE] = ACTIONS(13480),
    [anon_sym_BANG_TILDE] = ACTIONS(13480),
    [anon_sym_LT_EQ] = ACTIONS(13470),
    [anon_sym_GT] = ACTIONS(13470),
    [anon_sym_GT_EQ] = ACTIONS(13486),
    [anon_sym_CARET] = ACTIONS(13488),
    [anon_sym_PLUS] = ACTIONS(13462),
    [anon_sym_SLASH] = ACTIONS(13464),
    [anon_sym_PERCENT] = ACTIONS(13464),
    [sym_comment] = ACTIONS(87),
  },
  [9710] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(11551),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11551),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(11551),
    [anon_sym_PERCENT] = ACTIONS(11551),
    [sym_comment] = ACTIONS(87),
  },
  [9711] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11551),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [9712] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11549),
    [sym__binary_star] = ACTIONS(11551),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11551),
    [anon_sym_AMP] = ACTIONS(11555),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(11569),
    [anon_sym_GT_GT] = ACTIONS(11569),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(11549),
    [anon_sym_SLASH] = ACTIONS(11551),
    [anon_sym_PERCENT] = ACTIONS(11551),
    [sym_comment] = ACTIONS(87),
  },
  [9713] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11549),
    [sym__binary_star] = ACTIONS(11551),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11551),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(11569),
    [anon_sym_GT_GT] = ACTIONS(11569),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(11549),
    [anon_sym_SLASH] = ACTIONS(11551),
    [anon_sym_PERCENT] = ACTIONS(11551),
    [sym_comment] = ACTIONS(87),
  },
  [9714] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11549),
    [sym__binary_star] = ACTIONS(11551),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(11553),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11551),
    [anon_sym_AMP] = ACTIONS(11555),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(11569),
    [anon_sym_GT_GT] = ACTIONS(11569),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(11575),
    [anon_sym_PLUS] = ACTIONS(11549),
    [anon_sym_SLASH] = ACTIONS(11551),
    [anon_sym_PERCENT] = ACTIONS(11551),
    [sym_comment] = ACTIONS(87),
  },
  [9715] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(14336),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [9716] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(11549),
    [sym__binary_star] = ACTIONS(11551),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(11553),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(11551),
    [anon_sym_AMP] = ACTIONS(11555),
    [anon_sym_LT] = ACTIONS(11557),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_then] = ACTIONS(5927),
    [anon_sym_EQ_GT] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(11561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11563),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(11567),
    [anon_sym_AMP_AMP] = ACTIONS(11567),
    [anon_sym_LT_LT] = ACTIONS(11569),
    [anon_sym_GT_GT] = ACTIONS(11569),
    [anon_sym_EQ_EQ] = ACTIONS(11571),
    [anon_sym_BANG_EQ] = ACTIONS(11567),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11567),
    [anon_sym_LT_EQ_GT] = ACTIONS(11567),
    [anon_sym_EQ_TILDE] = ACTIONS(11567),
    [anon_sym_BANG_TILDE] = ACTIONS(11567),
    [anon_sym_LT_EQ] = ACTIONS(11557),
    [anon_sym_GT] = ACTIONS(11557),
    [anon_sym_GT_EQ] = ACTIONS(11573),
    [anon_sym_CARET] = ACTIONS(11575),
    [anon_sym_PLUS] = ACTIONS(11549),
    [anon_sym_SLASH] = ACTIONS(11551),
    [anon_sym_PERCENT] = ACTIONS(11551),
    [sym_comment] = ACTIONS(87),
  },
  [9717] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11549),
    [sym__binary_star] = ACTIONS(11551),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(11553),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11551),
    [anon_sym_AMP] = ACTIONS(11555),
    [anon_sym_LT] = ACTIONS(11557),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(11559),
    [anon_sym_DOT_DOT] = ACTIONS(11561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11563),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(11567),
    [anon_sym_AMP_AMP] = ACTIONS(11567),
    [anon_sym_LT_LT] = ACTIONS(11569),
    [anon_sym_GT_GT] = ACTIONS(11569),
    [anon_sym_EQ_EQ] = ACTIONS(11571),
    [anon_sym_BANG_EQ] = ACTIONS(11567),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11567),
    [anon_sym_LT_EQ_GT] = ACTIONS(11567),
    [anon_sym_EQ_TILDE] = ACTIONS(11567),
    [anon_sym_BANG_TILDE] = ACTIONS(11567),
    [anon_sym_LT_EQ] = ACTIONS(11557),
    [anon_sym_GT] = ACTIONS(11557),
    [anon_sym_GT_EQ] = ACTIONS(11573),
    [anon_sym_CARET] = ACTIONS(11575),
    [anon_sym_PLUS] = ACTIONS(11549),
    [anon_sym_SLASH] = ACTIONS(11551),
    [anon_sym_PERCENT] = ACTIONS(11551),
    [sym_comment] = ACTIONS(87),
  },
  [9718] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11549),
    [sym__binary_star] = ACTIONS(11551),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(11553),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11551),
    [anon_sym_AMP] = ACTIONS(11555),
    [anon_sym_LT] = ACTIONS(11557),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(11569),
    [anon_sym_GT_GT] = ACTIONS(11569),
    [anon_sym_EQ_EQ] = ACTIONS(11571),
    [anon_sym_BANG_EQ] = ACTIONS(11567),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11567),
    [anon_sym_LT_EQ_GT] = ACTIONS(11567),
    [anon_sym_EQ_TILDE] = ACTIONS(11567),
    [anon_sym_BANG_TILDE] = ACTIONS(11567),
    [anon_sym_LT_EQ] = ACTIONS(11557),
    [anon_sym_GT] = ACTIONS(11557),
    [anon_sym_GT_EQ] = ACTIONS(11573),
    [anon_sym_CARET] = ACTIONS(11575),
    [anon_sym_PLUS] = ACTIONS(11549),
    [anon_sym_SLASH] = ACTIONS(11551),
    [anon_sym_PERCENT] = ACTIONS(11551),
    [sym_comment] = ACTIONS(87),
  },
  [9719] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11549),
    [sym__binary_star] = ACTIONS(11551),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11551),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(11549),
    [anon_sym_SLASH] = ACTIONS(11551),
    [anon_sym_PERCENT] = ACTIONS(11551),
    [sym_comment] = ACTIONS(87),
  },
  [9720] = {
    [sym__line_break] = ACTIONS(3235),
    [sym__heredoc_body_start] = ACTIONS(3235),
    [anon_sym_LBRACE] = ACTIONS(3235),
    [anon_sym_DOT] = ACTIONS(3235),
    [anon_sym_SEMI] = ACTIONS(3235),
    [anon_sym_do] = ACTIONS(3235),
    [anon_sym_then] = ACTIONS(3235),
    [anon_sym_LBRACK] = ACTIONS(3235),
    [anon_sym_COLON_COLON2] = ACTIONS(3235),
    [anon_sym_AMP_DOT] = ACTIONS(3235),
    [sym_comment] = ACTIONS(87),
  },
  [9721] = {
    [sym_interpolation] = STATE(1787),
    [aux_sym_heredoc_body_repeat1] = STATE(1787),
    [sym__heredoc_content] = ACTIONS(3237),
    [sym_heredoc_end] = ACTIONS(14338),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(3237),
  },
  [9722] = {
    [sym_heredoc_body] = STATE(9722),
    [aux_sym_call_repeat1] = STATE(9722),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(14340),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7914),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_then] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [9723] = {
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7925),
    [anon_sym_COMMA] = ACTIONS(7925),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_then] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [9724] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5615),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5621),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(5621),
    [sym__argument] = STATE(10655),
    [sym_splat_argument] = STATE(10655),
    [sym_hash_splat_argument] = STATE(10655),
    [sym_block_argument] = STATE(10655),
    [sym_assignment] = STATE(5615),
    [sym_operator_assignment] = STATE(5615),
    [sym_conditional] = STATE(5615),
    [sym_range] = STATE(5615),
    [sym_binary] = STATE(5615),
    [sym_unary] = STATE(5615),
    [sym_left_assignment_list] = STATE(5620),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5621),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5621),
    [sym_false] = STATE(5621),
    [sym_nil] = STATE(5621),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5622),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(10655),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(8787),
    [sym__splat_star] = ACTIONS(8789),
    [sym__unary_minus] = ACTIONS(8791),
    [sym__identifier_hash_key] = ACTIONS(8793),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(8797),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8799),
    [anon_sym_yield] = ACTIONS(8801),
    [anon_sym_break] = ACTIONS(8803),
    [anon_sym_next] = ACTIONS(8805),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8809),
    [anon_sym_defined_QMARK] = ACTIONS(8811),
    [anon_sym_not] = ACTIONS(8813),
    [anon_sym_BANG] = ACTIONS(8815),
    [anon_sym_TILDE] = ACTIONS(8815),
    [sym_constant] = ACTIONS(8817),
    [sym_identifier] = ACTIONS(8817),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9725] = {
    [sym_heredoc_body] = STATE(9722),
    [aux_sym_call_repeat1] = STATE(9722),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(11577),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7929),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_then] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [9726] = {
    [aux_sym_argument_list_repeat1] = STATE(9726),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7925),
    [anon_sym_COMMA] = ACTIONS(14343),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_then] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [9727] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(11549),
    [sym__binary_star] = ACTIONS(11551),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(11553),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(11551),
    [anon_sym_AMP] = ACTIONS(11555),
    [anon_sym_LT] = ACTIONS(11557),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_then] = ACTIONS(5115),
    [anon_sym_EQ_GT] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(11559),
    [anon_sym_DOT_DOT] = ACTIONS(11561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11563),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(11567),
    [anon_sym_AMP_AMP] = ACTIONS(11567),
    [anon_sym_LT_LT] = ACTIONS(11569),
    [anon_sym_GT_GT] = ACTIONS(11569),
    [anon_sym_EQ_EQ] = ACTIONS(11571),
    [anon_sym_BANG_EQ] = ACTIONS(11567),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11567),
    [anon_sym_LT_EQ_GT] = ACTIONS(11567),
    [anon_sym_EQ_TILDE] = ACTIONS(11567),
    [anon_sym_BANG_TILDE] = ACTIONS(11567),
    [anon_sym_LT_EQ] = ACTIONS(11557),
    [anon_sym_GT] = ACTIONS(11557),
    [anon_sym_GT_EQ] = ACTIONS(11573),
    [anon_sym_CARET] = ACTIONS(11575),
    [anon_sym_PLUS] = ACTIONS(11549),
    [anon_sym_SLASH] = ACTIONS(11551),
    [anon_sym_PERCENT] = ACTIONS(11551),
    [sym_comment] = ACTIONS(87),
  },
  [9728] = {
    [aux_sym_exceptions_repeat1] = STATE(10657),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_then] = ACTIONS(6191),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [9729] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(11549),
    [sym__binary_star] = ACTIONS(11551),
    [anon_sym_LBRACE] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(11553),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(11551),
    [anon_sym_AMP] = ACTIONS(11555),
    [anon_sym_LT] = ACTIONS(11557),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_then] = ACTIONS(6210),
    [anon_sym_EQ_GT] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(11559),
    [anon_sym_DOT_DOT] = ACTIONS(11561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11563),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(11567),
    [anon_sym_AMP_AMP] = ACTIONS(11567),
    [anon_sym_LT_LT] = ACTIONS(11569),
    [anon_sym_GT_GT] = ACTIONS(11569),
    [anon_sym_EQ_EQ] = ACTIONS(11571),
    [anon_sym_BANG_EQ] = ACTIONS(11567),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11567),
    [anon_sym_LT_EQ_GT] = ACTIONS(11567),
    [anon_sym_EQ_TILDE] = ACTIONS(11567),
    [anon_sym_BANG_TILDE] = ACTIONS(11567),
    [anon_sym_LT_EQ] = ACTIONS(11557),
    [anon_sym_GT] = ACTIONS(11557),
    [anon_sym_GT_EQ] = ACTIONS(11573),
    [anon_sym_CARET] = ACTIONS(11575),
    [anon_sym_PLUS] = ACTIONS(11549),
    [anon_sym_SLASH] = ACTIONS(11551),
    [anon_sym_PERCENT] = ACTIONS(11551),
    [sym_comment] = ACTIONS(87),
  },
  [9730] = {
    [sym_string] = STATE(9730),
    [aux_sym_chained_string_repeat1] = STATE(9730),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(6214),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_do] = ACTIONS(6212),
    [anon_sym_then] = ACTIONS(6212),
    [anon_sym_EQ_GT] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [9731] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(5117),
    [sym__binary_star] = ACTIONS(5119),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(5121),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(5119),
    [anon_sym_AMP] = ACTIONS(5123),
    [anon_sym_LT] = ACTIONS(5125),
    [anon_sym_then] = ACTIONS(12120),
    [anon_sym_EQ_GT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(5127),
    [anon_sym_DOT_DOT] = ACTIONS(5129),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5131),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(5135),
    [anon_sym_AMP_AMP] = ACTIONS(5135),
    [anon_sym_LT_LT] = ACTIONS(5137),
    [anon_sym_GT_GT] = ACTIONS(5137),
    [anon_sym_EQ_EQ] = ACTIONS(5139),
    [anon_sym_BANG_EQ] = ACTIONS(5135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5135),
    [anon_sym_LT_EQ_GT] = ACTIONS(5135),
    [anon_sym_EQ_TILDE] = ACTIONS(5135),
    [anon_sym_BANG_TILDE] = ACTIONS(5135),
    [anon_sym_LT_EQ] = ACTIONS(5125),
    [anon_sym_GT] = ACTIONS(5125),
    [anon_sym_GT_EQ] = ACTIONS(5141),
    [anon_sym_CARET] = ACTIONS(5143),
    [anon_sym_PLUS] = ACTIONS(5117),
    [anon_sym_SLASH] = ACTIONS(5119),
    [anon_sym_PERCENT] = ACTIONS(5119),
    [sym_comment] = ACTIONS(87),
  },
  [9732] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(10658),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3096),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(3096),
    [sym_assignment] = STATE(10658),
    [sym_operator_assignment] = STATE(10658),
    [sym_conditional] = STATE(10658),
    [sym_range] = STATE(10658),
    [sym_binary] = STATE(10658),
    [sym_unary] = STATE(10658),
    [sym_left_assignment_list] = STATE(3095),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3096),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3096),
    [sym_false] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5637),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5149),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5153),
    [anon_sym_yield] = ACTIONS(5155),
    [anon_sym_break] = ACTIONS(5157),
    [anon_sym_next] = ACTIONS(5159),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(8827),
    [anon_sym_defined_QMARK] = ACTIONS(5161),
    [anon_sym_not] = ACTIONS(5163),
    [anon_sym_BANG] = ACTIONS(5167),
    [anon_sym_TILDE] = ACTIONS(5167),
    [sym_constant] = ACTIONS(5173),
    [sym_identifier] = ACTIONS(5173),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [9733] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8094),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3096),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(3096),
    [sym_splat_argument] = STATE(8678),
    [sym_assignment] = STATE(8094),
    [sym_operator_assignment] = STATE(8094),
    [sym_conditional] = STATE(8094),
    [sym_range] = STATE(8094),
    [sym_binary] = STATE(8094),
    [sym_unary] = STATE(8094),
    [sym__arg_or_splat_arg] = STATE(8678),
    [sym_left_assignment_list] = STATE(3095),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3096),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3096),
    [sym_false] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5637),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__splat_star] = ACTIONS(5147),
    [sym__unary_minus] = ACTIONS(5149),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5153),
    [anon_sym_yield] = ACTIONS(5155),
    [anon_sym_break] = ACTIONS(5157),
    [anon_sym_next] = ACTIONS(5159),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(8827),
    [anon_sym_defined_QMARK] = ACTIONS(5161),
    [anon_sym_not] = ACTIONS(5163),
    [anon_sym_BANG] = ACTIONS(5167),
    [anon_sym_TILDE] = ACTIONS(5167),
    [sym_constant] = ACTIONS(5173),
    [sym_identifier] = ACTIONS(5173),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [9734] = {
    [aux_sym_exceptions_repeat1] = STATE(10659),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_LBRACE] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(14346),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9857),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_EQ] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_do] = ACTIONS(9855),
    [anon_sym_then] = ACTIONS(9855),
    [anon_sym_EQ_GT] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_PLUS_EQ] = ACTIONS(9855),
    [anon_sym_DASH_EQ] = ACTIONS(9855),
    [anon_sym_STAR_EQ] = ACTIONS(9855),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9855),
    [anon_sym_SLASH_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9855),
    [anon_sym_AMP_EQ] = ACTIONS(9855),
    [anon_sym_PERCENT_EQ] = ACTIONS(9855),
    [anon_sym_GT_GT_EQ] = ACTIONS(9855),
    [anon_sym_LT_LT_EQ] = ACTIONS(9855),
    [anon_sym_CARET_EQ] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9857),
    [anon_sym_AMP_AMP] = ACTIONS(9857),
    [anon_sym_LT_LT] = ACTIONS(9857),
    [anon_sym_GT_GT] = ACTIONS(9857),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9857),
    [anon_sym_PLUS] = ACTIONS(9857),
    [anon_sym_SLASH] = ACTIONS(9857),
    [anon_sym_PERCENT] = ACTIONS(9857),
    [sym_comment] = ACTIONS(87),
  },
  [9735] = {
    [aux_sym_exceptions_repeat1] = STATE(9735),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_COMMA] = ACTIONS(14348),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_then] = ACTIONS(11597),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [9736] = {
    [sym_heredoc_body] = STATE(10660),
    [aux_sym_call_repeat1] = STATE(10660),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_ensure] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [9737] = {
    [sym_heredoc_body] = STATE(10661),
    [aux_sym_call_repeat1] = STATE(10661),
    [aux_sym_argument_list_repeat1] = STATE(8149),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(8941),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_ensure] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [9738] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(11604),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11604),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(11604),
    [anon_sym_PERCENT] = ACTIONS(11604),
    [sym_comment] = ACTIONS(87),
  },
  [9739] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11604),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [9740] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11602),
    [sym__binary_star] = ACTIONS(11604),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11604),
    [anon_sym_AMP] = ACTIONS(11608),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(11620),
    [anon_sym_GT_GT] = ACTIONS(11620),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(11602),
    [anon_sym_SLASH] = ACTIONS(11604),
    [anon_sym_PERCENT] = ACTIONS(11604),
    [sym_comment] = ACTIONS(87),
  },
  [9741] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11602),
    [sym__binary_star] = ACTIONS(11604),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11604),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(11620),
    [anon_sym_GT_GT] = ACTIONS(11620),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(11602),
    [anon_sym_SLASH] = ACTIONS(11604),
    [anon_sym_PERCENT] = ACTIONS(11604),
    [sym_comment] = ACTIONS(87),
  },
  [9742] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11602),
    [sym__binary_star] = ACTIONS(11604),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(11606),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11604),
    [anon_sym_AMP] = ACTIONS(11608),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(11620),
    [anon_sym_GT_GT] = ACTIONS(11620),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(11626),
    [anon_sym_PLUS] = ACTIONS(11602),
    [anon_sym_SLASH] = ACTIONS(11604),
    [anon_sym_PERCENT] = ACTIONS(11604),
    [sym_comment] = ACTIONS(87),
  },
  [9743] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(14351),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [9744] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(11602),
    [sym__binary_star] = ACTIONS(11604),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(11606),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(11604),
    [anon_sym_AMP] = ACTIONS(11608),
    [anon_sym_LT] = ACTIONS(11610),
    [anon_sym_end] = ACTIONS(5927),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_ensure] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(11614),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11616),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(11618),
    [anon_sym_AMP_AMP] = ACTIONS(11618),
    [anon_sym_LT_LT] = ACTIONS(11620),
    [anon_sym_GT_GT] = ACTIONS(11620),
    [anon_sym_EQ_EQ] = ACTIONS(11622),
    [anon_sym_BANG_EQ] = ACTIONS(11618),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11618),
    [anon_sym_LT_EQ_GT] = ACTIONS(11618),
    [anon_sym_EQ_TILDE] = ACTIONS(11618),
    [anon_sym_BANG_TILDE] = ACTIONS(11618),
    [anon_sym_LT_EQ] = ACTIONS(11610),
    [anon_sym_GT] = ACTIONS(11610),
    [anon_sym_GT_EQ] = ACTIONS(11624),
    [anon_sym_CARET] = ACTIONS(11626),
    [anon_sym_PLUS] = ACTIONS(11602),
    [anon_sym_SLASH] = ACTIONS(11604),
    [anon_sym_PERCENT] = ACTIONS(11604),
    [sym_comment] = ACTIONS(87),
  },
  [9745] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11602),
    [sym__binary_star] = ACTIONS(11604),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(11606),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11604),
    [anon_sym_AMP] = ACTIONS(11608),
    [anon_sym_LT] = ACTIONS(11610),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(11612),
    [anon_sym_DOT_DOT] = ACTIONS(11614),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11616),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(11618),
    [anon_sym_AMP_AMP] = ACTIONS(11618),
    [anon_sym_LT_LT] = ACTIONS(11620),
    [anon_sym_GT_GT] = ACTIONS(11620),
    [anon_sym_EQ_EQ] = ACTIONS(11622),
    [anon_sym_BANG_EQ] = ACTIONS(11618),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11618),
    [anon_sym_LT_EQ_GT] = ACTIONS(11618),
    [anon_sym_EQ_TILDE] = ACTIONS(11618),
    [anon_sym_BANG_TILDE] = ACTIONS(11618),
    [anon_sym_LT_EQ] = ACTIONS(11610),
    [anon_sym_GT] = ACTIONS(11610),
    [anon_sym_GT_EQ] = ACTIONS(11624),
    [anon_sym_CARET] = ACTIONS(11626),
    [anon_sym_PLUS] = ACTIONS(11602),
    [anon_sym_SLASH] = ACTIONS(11604),
    [anon_sym_PERCENT] = ACTIONS(11604),
    [sym_comment] = ACTIONS(87),
  },
  [9746] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11602),
    [sym__binary_star] = ACTIONS(11604),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(11606),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11604),
    [anon_sym_AMP] = ACTIONS(11608),
    [anon_sym_LT] = ACTIONS(11610),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(11620),
    [anon_sym_GT_GT] = ACTIONS(11620),
    [anon_sym_EQ_EQ] = ACTIONS(11622),
    [anon_sym_BANG_EQ] = ACTIONS(11618),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11618),
    [anon_sym_LT_EQ_GT] = ACTIONS(11618),
    [anon_sym_EQ_TILDE] = ACTIONS(11618),
    [anon_sym_BANG_TILDE] = ACTIONS(11618),
    [anon_sym_LT_EQ] = ACTIONS(11610),
    [anon_sym_GT] = ACTIONS(11610),
    [anon_sym_GT_EQ] = ACTIONS(11624),
    [anon_sym_CARET] = ACTIONS(11626),
    [anon_sym_PLUS] = ACTIONS(11602),
    [anon_sym_SLASH] = ACTIONS(11604),
    [anon_sym_PERCENT] = ACTIONS(11604),
    [sym_comment] = ACTIONS(87),
  },
  [9747] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11602),
    [sym__binary_star] = ACTIONS(11604),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11604),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(11602),
    [anon_sym_SLASH] = ACTIONS(11604),
    [anon_sym_PERCENT] = ACTIONS(11604),
    [sym_comment] = ACTIONS(87),
  },
  [9748] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(11602),
    [sym__binary_star] = ACTIONS(11604),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(11606),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(11604),
    [anon_sym_AMP] = ACTIONS(11608),
    [anon_sym_LT] = ACTIONS(11610),
    [anon_sym_end] = ACTIONS(5115),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_ensure] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(11612),
    [anon_sym_DOT_DOT] = ACTIONS(11614),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11616),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(11618),
    [anon_sym_AMP_AMP] = ACTIONS(11618),
    [anon_sym_LT_LT] = ACTIONS(11620),
    [anon_sym_GT_GT] = ACTIONS(11620),
    [anon_sym_EQ_EQ] = ACTIONS(11622),
    [anon_sym_BANG_EQ] = ACTIONS(11618),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11618),
    [anon_sym_LT_EQ_GT] = ACTIONS(11618),
    [anon_sym_EQ_TILDE] = ACTIONS(11618),
    [anon_sym_BANG_TILDE] = ACTIONS(11618),
    [anon_sym_LT_EQ] = ACTIONS(11610),
    [anon_sym_GT] = ACTIONS(11610),
    [anon_sym_GT_EQ] = ACTIONS(11624),
    [anon_sym_CARET] = ACTIONS(11626),
    [anon_sym_PLUS] = ACTIONS(11602),
    [anon_sym_SLASH] = ACTIONS(11604),
    [anon_sym_PERCENT] = ACTIONS(11604),
    [sym_comment] = ACTIONS(87),
  },
  [9749] = {
    [aux_sym_exceptions_repeat1] = STATE(10664),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_end] = ACTIONS(6191),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_ensure] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [9750] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(11602),
    [sym__binary_star] = ACTIONS(11604),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(11606),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(11604),
    [anon_sym_AMP] = ACTIONS(11608),
    [anon_sym_LT] = ACTIONS(11610),
    [anon_sym_end] = ACTIONS(6210),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_ensure] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(11612),
    [anon_sym_DOT_DOT] = ACTIONS(11614),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11616),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(11618),
    [anon_sym_AMP_AMP] = ACTIONS(11618),
    [anon_sym_LT_LT] = ACTIONS(11620),
    [anon_sym_GT_GT] = ACTIONS(11620),
    [anon_sym_EQ_EQ] = ACTIONS(11622),
    [anon_sym_BANG_EQ] = ACTIONS(11618),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11618),
    [anon_sym_LT_EQ_GT] = ACTIONS(11618),
    [anon_sym_EQ_TILDE] = ACTIONS(11618),
    [anon_sym_BANG_TILDE] = ACTIONS(11618),
    [anon_sym_LT_EQ] = ACTIONS(11610),
    [anon_sym_GT] = ACTIONS(11610),
    [anon_sym_GT_EQ] = ACTIONS(11624),
    [anon_sym_CARET] = ACTIONS(11626),
    [anon_sym_PLUS] = ACTIONS(11602),
    [anon_sym_SLASH] = ACTIONS(11604),
    [anon_sym_PERCENT] = ACTIONS(11604),
    [sym_comment] = ACTIONS(87),
  },
  [9751] = {
    [sym_string] = STATE(9751),
    [aux_sym_chained_string_repeat1] = STATE(9751),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(6214),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_end] = ACTIONS(6212),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_ensure] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [9752] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(8907),
    [sym__binary_star] = ACTIONS(8909),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(8911),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(8909),
    [anon_sym_AMP] = ACTIONS(8913),
    [anon_sym_LT] = ACTIONS(8915),
    [anon_sym_end] = ACTIONS(6823),
    [anon_sym_if] = ACTIONS(6823),
    [anon_sym_unless] = ACTIONS(6823),
    [anon_sym_while] = ACTIONS(6823),
    [anon_sym_until] = ACTIONS(6823),
    [anon_sym_rescue] = ACTIONS(6823),
    [anon_sym_ensure] = ACTIONS(6823),
    [anon_sym_EQ_GT] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(8917),
    [anon_sym_DOT_DOT] = ACTIONS(8919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8921),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(8923),
    [anon_sym_AMP_AMP] = ACTIONS(8923),
    [anon_sym_LT_LT] = ACTIONS(8925),
    [anon_sym_GT_GT] = ACTIONS(8925),
    [anon_sym_EQ_EQ] = ACTIONS(8927),
    [anon_sym_BANG_EQ] = ACTIONS(8923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8923),
    [anon_sym_LT_EQ_GT] = ACTIONS(8923),
    [anon_sym_EQ_TILDE] = ACTIONS(8923),
    [anon_sym_BANG_TILDE] = ACTIONS(8923),
    [anon_sym_LT_EQ] = ACTIONS(8915),
    [anon_sym_GT] = ACTIONS(8915),
    [anon_sym_GT_EQ] = ACTIONS(8929),
    [anon_sym_CARET] = ACTIONS(8931),
    [anon_sym_PLUS] = ACTIONS(8907),
    [anon_sym_SLASH] = ACTIONS(8909),
    [anon_sym_PERCENT] = ACTIONS(8909),
    [sym_comment] = ACTIONS(87),
  },
  [9753] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(8907),
    [sym__binary_star] = ACTIONS(8909),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(8911),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(8909),
    [anon_sym_AMP] = ACTIONS(8913),
    [anon_sym_LT] = ACTIONS(8915),
    [anon_sym_end] = ACTIONS(7027),
    [anon_sym_if] = ACTIONS(7027),
    [anon_sym_unless] = ACTIONS(7027),
    [anon_sym_while] = ACTIONS(7027),
    [anon_sym_until] = ACTIONS(7027),
    [anon_sym_rescue] = ACTIONS(7027),
    [anon_sym_ensure] = ACTIONS(7027),
    [anon_sym_EQ_GT] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(8917),
    [anon_sym_DOT_DOT] = ACTIONS(8919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8921),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(8923),
    [anon_sym_AMP_AMP] = ACTIONS(8923),
    [anon_sym_LT_LT] = ACTIONS(8925),
    [anon_sym_GT_GT] = ACTIONS(8925),
    [anon_sym_EQ_EQ] = ACTIONS(8927),
    [anon_sym_BANG_EQ] = ACTIONS(8923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8923),
    [anon_sym_LT_EQ_GT] = ACTIONS(8923),
    [anon_sym_EQ_TILDE] = ACTIONS(8923),
    [anon_sym_BANG_TILDE] = ACTIONS(8923),
    [anon_sym_LT_EQ] = ACTIONS(8915),
    [anon_sym_GT] = ACTIONS(8915),
    [anon_sym_GT_EQ] = ACTIONS(8929),
    [anon_sym_CARET] = ACTIONS(8931),
    [anon_sym_PLUS] = ACTIONS(8907),
    [anon_sym_SLASH] = ACTIONS(8909),
    [anon_sym_PERCENT] = ACTIONS(8909),
    [sym_comment] = ACTIONS(87),
  },
  [9754] = {
    [sym_heredoc_body] = STATE(9754),
    [aux_sym_call_repeat1] = STATE(9754),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(7916),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_end] = ACTIONS(7914),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_ensure] = ACTIONS(7914),
    [anon_sym_EQ_GT] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [9755] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5688),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(3118),
    [sym_call] = STATE(3118),
    [sym_method_call] = STATE(3122),
    [sym__argument] = STATE(4986),
    [sym_splat_argument] = STATE(4986),
    [sym_hash_splat_argument] = STATE(4986),
    [sym_block_argument] = STATE(4986),
    [sym_assignment] = STATE(5688),
    [sym_operator_assignment] = STATE(5688),
    [sym_conditional] = STATE(5688),
    [sym_range] = STATE(5688),
    [sym_binary] = STATE(5688),
    [sym_unary] = STATE(5688),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(3118),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5691),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4986),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(8897),
    [sym__splat_star] = ACTIONS(8899),
    [sym__unary_minus] = ACTIONS(5193),
    [sym__identifier_hash_key] = ACTIONS(8901),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13519),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5197),
    [anon_sym_yield] = ACTIONS(5199),
    [anon_sym_break] = ACTIONS(5201),
    [anon_sym_next] = ACTIONS(5203),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8893),
    [anon_sym_defined_QMARK] = ACTIONS(5205),
    [anon_sym_not] = ACTIONS(5207),
    [anon_sym_BANG] = ACTIONS(5211),
    [anon_sym_TILDE] = ACTIONS(5211),
    [sym_constant] = ACTIONS(8903),
    [sym_identifier] = ACTIONS(8903),
    [sym_instance_variable] = ACTIONS(5215),
    [sym_class_variable] = ACTIONS(5215),
    [sym_global_variable] = ACTIONS(5215),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5217),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5217),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9756] = {
    [sym_heredoc_body] = STATE(9754),
    [aux_sym_call_repeat1] = STATE(9754),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_end] = ACTIONS(7929),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_ensure] = ACTIONS(7929),
    [anon_sym_EQ_GT] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [9757] = {
    [aux_sym_argument_list_repeat1] = STATE(9757),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(14353),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7925),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_end] = ACTIONS(7925),
    [anon_sym_if] = ACTIONS(7925),
    [anon_sym_unless] = ACTIONS(7925),
    [anon_sym_while] = ACTIONS(7925),
    [anon_sym_until] = ACTIONS(7925),
    [anon_sym_rescue] = ACTIONS(7925),
    [anon_sym_ensure] = ACTIONS(7925),
    [anon_sym_EQ_GT] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7925),
    [anon_sym_AMP_AMP] = ACTIONS(7925),
    [anon_sym_LT_LT] = ACTIONS(7925),
    [anon_sym_GT_GT] = ACTIONS(7925),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7925),
    [anon_sym_PLUS] = ACTIONS(7925),
    [anon_sym_SLASH] = ACTIONS(7925),
    [anon_sym_PERCENT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [9758] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10665),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(3118),
    [sym_call] = STATE(3118),
    [sym_method_call] = STATE(3122),
    [sym_assignment] = STATE(10665),
    [sym_operator_assignment] = STATE(10665),
    [sym_conditional] = STATE(10665),
    [sym_range] = STATE(10665),
    [sym_binary] = STATE(10665),
    [sym_unary] = STATE(10665),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(3118),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5680),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5193),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5197),
    [anon_sym_yield] = ACTIONS(5199),
    [anon_sym_break] = ACTIONS(5201),
    [anon_sym_next] = ACTIONS(5203),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8893),
    [anon_sym_defined_QMARK] = ACTIONS(5205),
    [anon_sym_not] = ACTIONS(5207),
    [anon_sym_BANG] = ACTIONS(5211),
    [anon_sym_TILDE] = ACTIONS(5211),
    [sym_constant] = ACTIONS(5217),
    [sym_identifier] = ACTIONS(5217),
    [sym_instance_variable] = ACTIONS(5215),
    [sym_class_variable] = ACTIONS(5215),
    [sym_global_variable] = ACTIONS(5215),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5217),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5217),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9759] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(8979),
    [sym__binary_star] = ACTIONS(8981),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(8983),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(8985),
    [anon_sym_AMP] = ACTIONS(8987),
    [anon_sym_EQ] = ACTIONS(7822),
    [anon_sym_LT] = ACTIONS(8989),
    [anon_sym_end] = ACTIONS(6823),
    [anon_sym_if] = ACTIONS(6823),
    [anon_sym_unless] = ACTIONS(6823),
    [anon_sym_while] = ACTIONS(6823),
    [anon_sym_until] = ACTIONS(6823),
    [anon_sym_rescue] = ACTIONS(6823),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_ensure] = ACTIONS(6823),
    [anon_sym_EQ_GT] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_PLUS_EQ] = ACTIONS(6823),
    [anon_sym_DASH_EQ] = ACTIONS(6823),
    [anon_sym_STAR_EQ] = ACTIONS(6823),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6823),
    [anon_sym_SLASH_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6823),
    [anon_sym_AMP_EQ] = ACTIONS(6823),
    [anon_sym_PERCENT_EQ] = ACTIONS(6823),
    [anon_sym_GT_GT_EQ] = ACTIONS(6823),
    [anon_sym_LT_LT_EQ] = ACTIONS(6823),
    [anon_sym_CARET_EQ] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(8991),
    [anon_sym_DOT_DOT] = ACTIONS(8993),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8995),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(8997),
    [anon_sym_AMP_AMP] = ACTIONS(8997),
    [anon_sym_LT_LT] = ACTIONS(8999),
    [anon_sym_GT_GT] = ACTIONS(8999),
    [anon_sym_EQ_EQ] = ACTIONS(8997),
    [anon_sym_BANG_EQ] = ACTIONS(9001),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9001),
    [anon_sym_LT_EQ_GT] = ACTIONS(9001),
    [anon_sym_EQ_TILDE] = ACTIONS(9001),
    [anon_sym_BANG_TILDE] = ACTIONS(9001),
    [anon_sym_LT_EQ] = ACTIONS(8989),
    [anon_sym_GT] = ACTIONS(8989),
    [anon_sym_GT_EQ] = ACTIONS(9003),
    [anon_sym_CARET] = ACTIONS(8983),
    [anon_sym_PLUS] = ACTIONS(9005),
    [anon_sym_SLASH] = ACTIONS(8985),
    [anon_sym_PERCENT] = ACTIONS(8985),
    [sym_comment] = ACTIONS(87),
  },
  [9760] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(8979),
    [sym__binary_star] = ACTIONS(8981),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(8983),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(8985),
    [anon_sym_AMP] = ACTIONS(8987),
    [anon_sym_EQ] = ACTIONS(7884),
    [anon_sym_LT] = ACTIONS(8989),
    [anon_sym_end] = ACTIONS(7027),
    [anon_sym_if] = ACTIONS(7027),
    [anon_sym_unless] = ACTIONS(7027),
    [anon_sym_while] = ACTIONS(7027),
    [anon_sym_until] = ACTIONS(7027),
    [anon_sym_rescue] = ACTIONS(7027),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_ensure] = ACTIONS(7027),
    [anon_sym_EQ_GT] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_PLUS_EQ] = ACTIONS(7027),
    [anon_sym_DASH_EQ] = ACTIONS(7027),
    [anon_sym_STAR_EQ] = ACTIONS(7027),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7027),
    [anon_sym_SLASH_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7027),
    [anon_sym_AMP_EQ] = ACTIONS(7027),
    [anon_sym_PERCENT_EQ] = ACTIONS(7027),
    [anon_sym_GT_GT_EQ] = ACTIONS(7027),
    [anon_sym_LT_LT_EQ] = ACTIONS(7027),
    [anon_sym_CARET_EQ] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(8991),
    [anon_sym_DOT_DOT] = ACTIONS(8993),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8995),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(8997),
    [anon_sym_AMP_AMP] = ACTIONS(8997),
    [anon_sym_LT_LT] = ACTIONS(8999),
    [anon_sym_GT_GT] = ACTIONS(8999),
    [anon_sym_EQ_EQ] = ACTIONS(8997),
    [anon_sym_BANG_EQ] = ACTIONS(9001),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9001),
    [anon_sym_LT_EQ_GT] = ACTIONS(9001),
    [anon_sym_EQ_TILDE] = ACTIONS(9001),
    [anon_sym_BANG_TILDE] = ACTIONS(9001),
    [anon_sym_LT_EQ] = ACTIONS(8989),
    [anon_sym_GT] = ACTIONS(8989),
    [anon_sym_GT_EQ] = ACTIONS(9003),
    [anon_sym_CARET] = ACTIONS(8983),
    [anon_sym_PLUS] = ACTIONS(9005),
    [anon_sym_SLASH] = ACTIONS(8985),
    [anon_sym_PERCENT] = ACTIONS(8985),
    [sym_comment] = ACTIONS(87),
  },
  [9761] = {
    [sym_heredoc_body] = STATE(9761),
    [aux_sym_call_repeat1] = STATE(9761),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(10978),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7919),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_EQ] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_end] = ACTIONS(7914),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_ensure] = ACTIONS(7914),
    [anon_sym_EQ_GT] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_PLUS_EQ] = ACTIONS(7914),
    [anon_sym_DASH_EQ] = ACTIONS(7914),
    [anon_sym_STAR_EQ] = ACTIONS(7914),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7914),
    [anon_sym_SLASH_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7914),
    [anon_sym_AMP_EQ] = ACTIONS(7914),
    [anon_sym_PERCENT_EQ] = ACTIONS(7914),
    [anon_sym_GT_GT_EQ] = ACTIONS(7914),
    [anon_sym_LT_LT_EQ] = ACTIONS(7914),
    [anon_sym_CARET_EQ] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7919),
    [anon_sym_AMP_AMP] = ACTIONS(7919),
    [anon_sym_LT_LT] = ACTIONS(7919),
    [anon_sym_GT_GT] = ACTIONS(7919),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7919),
    [anon_sym_PLUS] = ACTIONS(7919),
    [anon_sym_SLASH] = ACTIONS(7919),
    [anon_sym_PERCENT] = ACTIONS(7919),
    [sym_comment] = ACTIONS(87),
  },
  [9762] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5709),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3158),
    [sym_scope_resolution] = STATE(3154),
    [sym_call] = STATE(3154),
    [sym_method_call] = STATE(3158),
    [sym__argument] = STATE(7437),
    [sym_splat_argument] = STATE(7437),
    [sym_hash_splat_argument] = STATE(7437),
    [sym_block_argument] = STATE(7437),
    [sym_assignment] = STATE(5709),
    [sym_operator_assignment] = STATE(5709),
    [sym_conditional] = STATE(5709),
    [sym_range] = STATE(5709),
    [sym_binary] = STATE(5709),
    [sym_unary] = STATE(5709),
    [sym_left_assignment_list] = STATE(3157),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3158),
    [sym__variable] = STATE(3154),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3158),
    [sym_false] = STATE(3158),
    [sym_nil] = STATE(3158),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5712),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(7437),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(8933),
    [sym__splat_star] = ACTIONS(8935),
    [sym__unary_minus] = ACTIONS(5265),
    [sym__identifier_hash_key] = ACTIONS(8937),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13523),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5269),
    [anon_sym_yield] = ACTIONS(5271),
    [anon_sym_break] = ACTIONS(5273),
    [anon_sym_next] = ACTIONS(5275),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(8973),
    [anon_sym_defined_QMARK] = ACTIONS(5277),
    [anon_sym_not] = ACTIONS(5279),
    [anon_sym_BANG] = ACTIONS(5283),
    [anon_sym_TILDE] = ACTIONS(5283),
    [sym_constant] = ACTIONS(8939),
    [sym_identifier] = ACTIONS(8939),
    [sym_instance_variable] = ACTIONS(5287),
    [sym_class_variable] = ACTIONS(5287),
    [sym_global_variable] = ACTIONS(5287),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5289),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5289),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [9763] = {
    [sym_heredoc_body] = STATE(9761),
    [aux_sym_call_repeat1] = STATE(9761),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7931),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_EQ] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_end] = ACTIONS(7929),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_ensure] = ACTIONS(7929),
    [anon_sym_EQ_GT] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_PLUS_EQ] = ACTIONS(7929),
    [anon_sym_DASH_EQ] = ACTIONS(7929),
    [anon_sym_STAR_EQ] = ACTIONS(7929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7929),
    [anon_sym_SLASH_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7929),
    [anon_sym_AMP_EQ] = ACTIONS(7929),
    [anon_sym_PERCENT_EQ] = ACTIONS(7929),
    [anon_sym_GT_GT_EQ] = ACTIONS(7929),
    [anon_sym_LT_LT_EQ] = ACTIONS(7929),
    [anon_sym_CARET_EQ] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7931),
    [anon_sym_AMP_AMP] = ACTIONS(7931),
    [anon_sym_LT_LT] = ACTIONS(7931),
    [anon_sym_GT_GT] = ACTIONS(7931),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7931),
    [anon_sym_PLUS] = ACTIONS(7931),
    [anon_sym_SLASH] = ACTIONS(7931),
    [anon_sym_PERCENT] = ACTIONS(7931),
    [sym_comment] = ACTIONS(87),
  },
  [9764] = {
    [aux_sym_argument_list_repeat1] = STATE(9764),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(14356),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7927),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_EQ] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_end] = ACTIONS(7925),
    [anon_sym_if] = ACTIONS(7925),
    [anon_sym_unless] = ACTIONS(7925),
    [anon_sym_while] = ACTIONS(7925),
    [anon_sym_until] = ACTIONS(7925),
    [anon_sym_rescue] = ACTIONS(7925),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_ensure] = ACTIONS(7925),
    [anon_sym_EQ_GT] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_PLUS_EQ] = ACTIONS(7925),
    [anon_sym_DASH_EQ] = ACTIONS(7925),
    [anon_sym_STAR_EQ] = ACTIONS(7925),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7925),
    [anon_sym_SLASH_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7925),
    [anon_sym_AMP_EQ] = ACTIONS(7925),
    [anon_sym_PERCENT_EQ] = ACTIONS(7925),
    [anon_sym_GT_GT_EQ] = ACTIONS(7925),
    [anon_sym_LT_LT_EQ] = ACTIONS(7925),
    [anon_sym_CARET_EQ] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7927),
    [anon_sym_AMP_AMP] = ACTIONS(7927),
    [anon_sym_LT_LT] = ACTIONS(7927),
    [anon_sym_GT_GT] = ACTIONS(7927),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7927),
    [anon_sym_PLUS] = ACTIONS(7927),
    [anon_sym_SLASH] = ACTIONS(7927),
    [anon_sym_PERCENT] = ACTIONS(7927),
    [sym_comment] = ACTIONS(87),
  },
  [9765] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8150),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(3118),
    [sym_call] = STATE(3118),
    [sym_method_call] = STATE(3122),
    [sym_splat_argument] = STATE(7439),
    [sym_assignment] = STATE(8150),
    [sym_operator_assignment] = STATE(8150),
    [sym_conditional] = STATE(8150),
    [sym_range] = STATE(8150),
    [sym_binary] = STATE(8150),
    [sym_unary] = STATE(8150),
    [sym__arg_or_splat_arg] = STATE(7439),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(3118),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5680),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__splat_star] = ACTIONS(8899),
    [sym__unary_minus] = ACTIONS(5193),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5197),
    [anon_sym_yield] = ACTIONS(5199),
    [anon_sym_break] = ACTIONS(5201),
    [anon_sym_next] = ACTIONS(5203),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8893),
    [anon_sym_defined_QMARK] = ACTIONS(5205),
    [anon_sym_not] = ACTIONS(5207),
    [anon_sym_BANG] = ACTIONS(5211),
    [anon_sym_TILDE] = ACTIONS(5211),
    [sym_constant] = ACTIONS(5217),
    [sym_identifier] = ACTIONS(5217),
    [sym_instance_variable] = ACTIONS(5215),
    [sym_class_variable] = ACTIONS(5215),
    [sym_global_variable] = ACTIONS(5215),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5217),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5217),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9766] = {
    [aux_sym_exceptions_repeat1] = STATE(10666),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(14359),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_end] = ACTIONS(9855),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_ensure] = ACTIONS(9855),
    [anon_sym_EQ_GT] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [9767] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(5233),
    [sym__binary_star] = ACTIONS(5235),
    [anon_sym_PIPE] = ACTIONS(5237),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(5235),
    [anon_sym_AMP] = ACTIONS(5239),
    [anon_sym_LT] = ACTIONS(5241),
    [anon_sym_end] = ACTIONS(12120),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_ensure] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(5243),
    [anon_sym_DOT_DOT] = ACTIONS(5245),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5247),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(5251),
    [anon_sym_AMP_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5253),
    [anon_sym_GT_GT] = ACTIONS(5253),
    [anon_sym_EQ_EQ] = ACTIONS(5255),
    [anon_sym_BANG_EQ] = ACTIONS(5251),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5251),
    [anon_sym_LT_EQ_GT] = ACTIONS(5251),
    [anon_sym_EQ_TILDE] = ACTIONS(5251),
    [anon_sym_BANG_TILDE] = ACTIONS(5251),
    [anon_sym_LT_EQ] = ACTIONS(5241),
    [anon_sym_GT] = ACTIONS(5241),
    [anon_sym_GT_EQ] = ACTIONS(5257),
    [anon_sym_CARET] = ACTIONS(5259),
    [anon_sym_PLUS] = ACTIONS(5233),
    [anon_sym_SLASH] = ACTIONS(5235),
    [anon_sym_PERCENT] = ACTIONS(5235),
    [sym_comment] = ACTIONS(87),
  },
  [9768] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(11656),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11660),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(11660),
    [anon_sym_PERCENT] = ACTIONS(11660),
    [sym_comment] = ACTIONS(87),
  },
  [9769] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11660),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(5827),
    [anon_sym_PERCENT] = ACTIONS(5827),
    [sym_comment] = ACTIONS(87),
  },
  [9770] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11654),
    [sym__binary_star] = ACTIONS(11656),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11660),
    [anon_sym_AMP] = ACTIONS(11662),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(11674),
    [anon_sym_GT_GT] = ACTIONS(11674),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(11680),
    [anon_sym_SLASH] = ACTIONS(11660),
    [anon_sym_PERCENT] = ACTIONS(11660),
    [sym_comment] = ACTIONS(87),
  },
  [9771] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11654),
    [sym__binary_star] = ACTIONS(11656),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11660),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(11674),
    [anon_sym_GT_GT] = ACTIONS(11674),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(11680),
    [anon_sym_SLASH] = ACTIONS(11660),
    [anon_sym_PERCENT] = ACTIONS(11660),
    [sym_comment] = ACTIONS(87),
  },
  [9772] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11654),
    [sym__binary_star] = ACTIONS(11656),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(11658),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11660),
    [anon_sym_AMP] = ACTIONS(11662),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(11674),
    [anon_sym_GT_GT] = ACTIONS(11674),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(11658),
    [anon_sym_PLUS] = ACTIONS(11680),
    [anon_sym_SLASH] = ACTIONS(11660),
    [anon_sym_PERCENT] = ACTIONS(11660),
    [sym_comment] = ACTIONS(87),
  },
  [9773] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(14361),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [9774] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(11654),
    [sym__binary_star] = ACTIONS(11656),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(11658),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(11660),
    [anon_sym_AMP] = ACTIONS(11662),
    [anon_sym_EQ] = ACTIONS(7888),
    [anon_sym_LT] = ACTIONS(11664),
    [anon_sym_end] = ACTIONS(5927),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_ensure] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_PLUS_EQ] = ACTIONS(5927),
    [anon_sym_DASH_EQ] = ACTIONS(5927),
    [anon_sym_STAR_EQ] = ACTIONS(5927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5927),
    [anon_sym_SLASH_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5927),
    [anon_sym_AMP_EQ] = ACTIONS(5927),
    [anon_sym_PERCENT_EQ] = ACTIONS(5927),
    [anon_sym_GT_GT_EQ] = ACTIONS(5927),
    [anon_sym_LT_LT_EQ] = ACTIONS(5927),
    [anon_sym_CARET_EQ] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(11668),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11670),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(11672),
    [anon_sym_AMP_AMP] = ACTIONS(11672),
    [anon_sym_LT_LT] = ACTIONS(11674),
    [anon_sym_GT_GT] = ACTIONS(11674),
    [anon_sym_EQ_EQ] = ACTIONS(11672),
    [anon_sym_BANG_EQ] = ACTIONS(11676),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11676),
    [anon_sym_LT_EQ_GT] = ACTIONS(11676),
    [anon_sym_EQ_TILDE] = ACTIONS(11676),
    [anon_sym_BANG_TILDE] = ACTIONS(11676),
    [anon_sym_LT_EQ] = ACTIONS(11664),
    [anon_sym_GT] = ACTIONS(11664),
    [anon_sym_GT_EQ] = ACTIONS(11678),
    [anon_sym_CARET] = ACTIONS(11658),
    [anon_sym_PLUS] = ACTIONS(11680),
    [anon_sym_SLASH] = ACTIONS(11660),
    [anon_sym_PERCENT] = ACTIONS(11660),
    [sym_comment] = ACTIONS(87),
  },
  [9775] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11654),
    [sym__binary_star] = ACTIONS(11656),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(11658),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11660),
    [anon_sym_AMP] = ACTIONS(11662),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(11664),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(11666),
    [anon_sym_DOT_DOT] = ACTIONS(11668),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11670),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(11672),
    [anon_sym_AMP_AMP] = ACTIONS(11672),
    [anon_sym_LT_LT] = ACTIONS(11674),
    [anon_sym_GT_GT] = ACTIONS(11674),
    [anon_sym_EQ_EQ] = ACTIONS(11672),
    [anon_sym_BANG_EQ] = ACTIONS(11676),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11676),
    [anon_sym_LT_EQ_GT] = ACTIONS(11676),
    [anon_sym_EQ_TILDE] = ACTIONS(11676),
    [anon_sym_BANG_TILDE] = ACTIONS(11676),
    [anon_sym_LT_EQ] = ACTIONS(11664),
    [anon_sym_GT] = ACTIONS(11664),
    [anon_sym_GT_EQ] = ACTIONS(11678),
    [anon_sym_CARET] = ACTIONS(11658),
    [anon_sym_PLUS] = ACTIONS(11680),
    [anon_sym_SLASH] = ACTIONS(11660),
    [anon_sym_PERCENT] = ACTIONS(11660),
    [sym_comment] = ACTIONS(87),
  },
  [9776] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11654),
    [sym__binary_star] = ACTIONS(11656),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(11658),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11660),
    [anon_sym_AMP] = ACTIONS(11662),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(11664),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(11674),
    [anon_sym_GT_GT] = ACTIONS(11674),
    [anon_sym_EQ_EQ] = ACTIONS(11672),
    [anon_sym_BANG_EQ] = ACTIONS(11676),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11676),
    [anon_sym_LT_EQ_GT] = ACTIONS(11676),
    [anon_sym_EQ_TILDE] = ACTIONS(11676),
    [anon_sym_BANG_TILDE] = ACTIONS(11676),
    [anon_sym_LT_EQ] = ACTIONS(11664),
    [anon_sym_GT] = ACTIONS(11664),
    [anon_sym_GT_EQ] = ACTIONS(11678),
    [anon_sym_CARET] = ACTIONS(11658),
    [anon_sym_PLUS] = ACTIONS(11680),
    [anon_sym_SLASH] = ACTIONS(11660),
    [anon_sym_PERCENT] = ACTIONS(11660),
    [sym_comment] = ACTIONS(87),
  },
  [9777] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11654),
    [sym__binary_star] = ACTIONS(11656),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11660),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(11680),
    [anon_sym_SLASH] = ACTIONS(11660),
    [anon_sym_PERCENT] = ACTIONS(11660),
    [sym_comment] = ACTIONS(87),
  },
  [9778] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(11654),
    [sym__binary_star] = ACTIONS(11656),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(11658),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(11660),
    [anon_sym_AMP] = ACTIONS(11662),
    [anon_sym_EQ] = ACTIONS(7936),
    [anon_sym_LT] = ACTIONS(11664),
    [anon_sym_end] = ACTIONS(5115),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_ensure] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_PLUS_EQ] = ACTIONS(5115),
    [anon_sym_DASH_EQ] = ACTIONS(5115),
    [anon_sym_STAR_EQ] = ACTIONS(5115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5115),
    [anon_sym_SLASH_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5115),
    [anon_sym_AMP_EQ] = ACTIONS(5115),
    [anon_sym_PERCENT_EQ] = ACTIONS(5115),
    [anon_sym_GT_GT_EQ] = ACTIONS(5115),
    [anon_sym_LT_LT_EQ] = ACTIONS(5115),
    [anon_sym_CARET_EQ] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(11666),
    [anon_sym_DOT_DOT] = ACTIONS(11668),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11670),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(11672),
    [anon_sym_AMP_AMP] = ACTIONS(11672),
    [anon_sym_LT_LT] = ACTIONS(11674),
    [anon_sym_GT_GT] = ACTIONS(11674),
    [anon_sym_EQ_EQ] = ACTIONS(11672),
    [anon_sym_BANG_EQ] = ACTIONS(11676),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11676),
    [anon_sym_LT_EQ_GT] = ACTIONS(11676),
    [anon_sym_EQ_TILDE] = ACTIONS(11676),
    [anon_sym_BANG_TILDE] = ACTIONS(11676),
    [anon_sym_LT_EQ] = ACTIONS(11664),
    [anon_sym_GT] = ACTIONS(11664),
    [anon_sym_GT_EQ] = ACTIONS(11678),
    [anon_sym_CARET] = ACTIONS(11658),
    [anon_sym_PLUS] = ACTIONS(11680),
    [anon_sym_SLASH] = ACTIONS(11660),
    [anon_sym_PERCENT] = ACTIONS(11660),
    [sym_comment] = ACTIONS(87),
  },
  [9779] = {
    [aux_sym_exceptions_repeat1] = STATE(10669),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6193),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_end] = ACTIONS(6191),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_ensure] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_PLUS_EQ] = ACTIONS(6191),
    [anon_sym_DASH_EQ] = ACTIONS(6191),
    [anon_sym_STAR_EQ] = ACTIONS(6191),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6191),
    [anon_sym_SLASH_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6191),
    [anon_sym_AMP_EQ] = ACTIONS(6191),
    [anon_sym_PERCENT_EQ] = ACTIONS(6191),
    [anon_sym_GT_GT_EQ] = ACTIONS(6191),
    [anon_sym_LT_LT_EQ] = ACTIONS(6191),
    [anon_sym_CARET_EQ] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6193),
    [anon_sym_AMP_AMP] = ACTIONS(6193),
    [anon_sym_LT_LT] = ACTIONS(6193),
    [anon_sym_GT_GT] = ACTIONS(6193),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6193),
    [anon_sym_PLUS] = ACTIONS(6193),
    [anon_sym_SLASH] = ACTIONS(6193),
    [anon_sym_PERCENT] = ACTIONS(6193),
    [sym_comment] = ACTIONS(87),
  },
  [9780] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(11654),
    [sym__binary_star] = ACTIONS(11656),
    [anon_sym_LBRACE] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(11658),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(11660),
    [anon_sym_AMP] = ACTIONS(11662),
    [anon_sym_EQ] = ACTIONS(7938),
    [anon_sym_LT] = ACTIONS(11664),
    [anon_sym_end] = ACTIONS(6210),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_ensure] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_PLUS_EQ] = ACTIONS(6210),
    [anon_sym_DASH_EQ] = ACTIONS(6210),
    [anon_sym_STAR_EQ] = ACTIONS(6210),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6210),
    [anon_sym_SLASH_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6210),
    [anon_sym_AMP_EQ] = ACTIONS(6210),
    [anon_sym_PERCENT_EQ] = ACTIONS(6210),
    [anon_sym_GT_GT_EQ] = ACTIONS(6210),
    [anon_sym_LT_LT_EQ] = ACTIONS(6210),
    [anon_sym_CARET_EQ] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(11666),
    [anon_sym_DOT_DOT] = ACTIONS(11668),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11670),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(11672),
    [anon_sym_AMP_AMP] = ACTIONS(11672),
    [anon_sym_LT_LT] = ACTIONS(11674),
    [anon_sym_GT_GT] = ACTIONS(11674),
    [anon_sym_EQ_EQ] = ACTIONS(11672),
    [anon_sym_BANG_EQ] = ACTIONS(11676),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11676),
    [anon_sym_LT_EQ_GT] = ACTIONS(11676),
    [anon_sym_EQ_TILDE] = ACTIONS(11676),
    [anon_sym_BANG_TILDE] = ACTIONS(11676),
    [anon_sym_LT_EQ] = ACTIONS(11664),
    [anon_sym_GT] = ACTIONS(11664),
    [anon_sym_GT_EQ] = ACTIONS(11678),
    [anon_sym_CARET] = ACTIONS(11658),
    [anon_sym_PLUS] = ACTIONS(11680),
    [anon_sym_SLASH] = ACTIONS(11660),
    [anon_sym_PERCENT] = ACTIONS(11660),
    [sym_comment] = ACTIONS(87),
  },
  [9781] = {
    [sym_string] = STATE(9781),
    [aux_sym_chained_string_repeat1] = STATE(9781),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(12267),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6217),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_EQ] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_end] = ACTIONS(6212),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_do] = ACTIONS(6212),
    [anon_sym_ensure] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_PLUS_EQ] = ACTIONS(6212),
    [anon_sym_DASH_EQ] = ACTIONS(6212),
    [anon_sym_STAR_EQ] = ACTIONS(6212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6212),
    [anon_sym_SLASH_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6212),
    [anon_sym_AMP_EQ] = ACTIONS(6212),
    [anon_sym_PERCENT_EQ] = ACTIONS(6212),
    [anon_sym_GT_GT_EQ] = ACTIONS(6212),
    [anon_sym_LT_LT_EQ] = ACTIONS(6212),
    [anon_sym_CARET_EQ] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6217),
    [anon_sym_AMP_AMP] = ACTIONS(6217),
    [anon_sym_LT_LT] = ACTIONS(6217),
    [anon_sym_GT_GT] = ACTIONS(6217),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6217),
    [anon_sym_PLUS] = ACTIONS(6217),
    [anon_sym_SLASH] = ACTIONS(6217),
    [anon_sym_PERCENT] = ACTIONS(6217),
    [sym_comment] = ACTIONS(87),
  },
  [9782] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(10670),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3158),
    [sym_scope_resolution] = STATE(3154),
    [sym_call] = STATE(3154),
    [sym_method_call] = STATE(3158),
    [sym_assignment] = STATE(10670),
    [sym_operator_assignment] = STATE(10670),
    [sym_conditional] = STATE(10670),
    [sym_range] = STATE(10670),
    [sym_binary] = STATE(10670),
    [sym_unary] = STATE(10670),
    [sym_left_assignment_list] = STATE(3157),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3158),
    [sym__variable] = STATE(3154),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3158),
    [sym_false] = STATE(3158),
    [sym_nil] = STATE(3158),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5749),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5265),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5269),
    [anon_sym_yield] = ACTIONS(5271),
    [anon_sym_break] = ACTIONS(5273),
    [anon_sym_next] = ACTIONS(5275),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(8973),
    [anon_sym_defined_QMARK] = ACTIONS(5277),
    [anon_sym_not] = ACTIONS(5279),
    [anon_sym_BANG] = ACTIONS(5283),
    [anon_sym_TILDE] = ACTIONS(5283),
    [sym_constant] = ACTIONS(5289),
    [sym_identifier] = ACTIONS(5289),
    [sym_instance_variable] = ACTIONS(5287),
    [sym_class_variable] = ACTIONS(5287),
    [sym_global_variable] = ACTIONS(5287),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5289),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5289),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [9783] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8187),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3158),
    [sym_scope_resolution] = STATE(3154),
    [sym_call] = STATE(3154),
    [sym_method_call] = STATE(3158),
    [sym_splat_argument] = STATE(8678),
    [sym_assignment] = STATE(8187),
    [sym_operator_assignment] = STATE(8187),
    [sym_conditional] = STATE(8187),
    [sym_range] = STATE(8187),
    [sym_binary] = STATE(8187),
    [sym_unary] = STATE(8187),
    [sym__arg_or_splat_arg] = STATE(8678),
    [sym_left_assignment_list] = STATE(3157),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3158),
    [sym__variable] = STATE(3154),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3158),
    [sym_false] = STATE(3158),
    [sym_nil] = STATE(3158),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5749),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__splat_star] = ACTIONS(8935),
    [sym__unary_minus] = ACTIONS(5265),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5269),
    [anon_sym_yield] = ACTIONS(5271),
    [anon_sym_break] = ACTIONS(5273),
    [anon_sym_next] = ACTIONS(5275),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(8973),
    [anon_sym_defined_QMARK] = ACTIONS(5277),
    [anon_sym_not] = ACTIONS(5279),
    [anon_sym_BANG] = ACTIONS(5283),
    [anon_sym_TILDE] = ACTIONS(5283),
    [sym_constant] = ACTIONS(5289),
    [sym_identifier] = ACTIONS(5289),
    [sym_instance_variable] = ACTIONS(5287),
    [sym_class_variable] = ACTIONS(5287),
    [sym_global_variable] = ACTIONS(5287),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5289),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5289),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [9784] = {
    [aux_sym_exceptions_repeat1] = STATE(10671),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_LBRACE] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(14363),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9857),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_EQ] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_end] = ACTIONS(9855),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_do] = ACTIONS(9855),
    [anon_sym_ensure] = ACTIONS(9855),
    [anon_sym_EQ_GT] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_PLUS_EQ] = ACTIONS(9855),
    [anon_sym_DASH_EQ] = ACTIONS(9855),
    [anon_sym_STAR_EQ] = ACTIONS(9855),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9855),
    [anon_sym_SLASH_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9855),
    [anon_sym_AMP_EQ] = ACTIONS(9855),
    [anon_sym_PERCENT_EQ] = ACTIONS(9855),
    [anon_sym_GT_GT_EQ] = ACTIONS(9855),
    [anon_sym_LT_LT_EQ] = ACTIONS(9855),
    [anon_sym_CARET_EQ] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9857),
    [anon_sym_AMP_AMP] = ACTIONS(9857),
    [anon_sym_LT_LT] = ACTIONS(9857),
    [anon_sym_GT_GT] = ACTIONS(9857),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9857),
    [anon_sym_PLUS] = ACTIONS(9857),
    [anon_sym_SLASH] = ACTIONS(9857),
    [anon_sym_PERCENT] = ACTIONS(9857),
    [sym_comment] = ACTIONS(87),
  },
  [9785] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(11692),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11692),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(11692),
    [anon_sym_PERCENT] = ACTIONS(11692),
    [sym_comment] = ACTIONS(87),
  },
  [9786] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11692),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [9787] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11690),
    [sym__binary_star] = ACTIONS(11692),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11692),
    [anon_sym_AMP] = ACTIONS(11696),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(11708),
    [anon_sym_GT_GT] = ACTIONS(11708),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(11690),
    [anon_sym_SLASH] = ACTIONS(11692),
    [anon_sym_PERCENT] = ACTIONS(11692),
    [sym_comment] = ACTIONS(87),
  },
  [9788] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11690),
    [sym__binary_star] = ACTIONS(11692),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11692),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(11708),
    [anon_sym_GT_GT] = ACTIONS(11708),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(11690),
    [anon_sym_SLASH] = ACTIONS(11692),
    [anon_sym_PERCENT] = ACTIONS(11692),
    [sym_comment] = ACTIONS(87),
  },
  [9789] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11690),
    [sym__binary_star] = ACTIONS(11692),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(11694),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11692),
    [anon_sym_AMP] = ACTIONS(11696),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(11708),
    [anon_sym_GT_GT] = ACTIONS(11708),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(11714),
    [anon_sym_PLUS] = ACTIONS(11690),
    [anon_sym_SLASH] = ACTIONS(11692),
    [anon_sym_PERCENT] = ACTIONS(11692),
    [sym_comment] = ACTIONS(87),
  },
  [9790] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(14365),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [9791] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(11690),
    [sym__binary_star] = ACTIONS(11692),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(11694),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(11692),
    [anon_sym_AMP] = ACTIONS(11696),
    [anon_sym_LT] = ACTIONS(11698),
    [anon_sym_end] = ACTIONS(5927),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_ensure] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(11702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11704),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(11706),
    [anon_sym_AMP_AMP] = ACTIONS(11706),
    [anon_sym_LT_LT] = ACTIONS(11708),
    [anon_sym_GT_GT] = ACTIONS(11708),
    [anon_sym_EQ_EQ] = ACTIONS(11710),
    [anon_sym_BANG_EQ] = ACTIONS(11706),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11706),
    [anon_sym_LT_EQ_GT] = ACTIONS(11706),
    [anon_sym_EQ_TILDE] = ACTIONS(11706),
    [anon_sym_BANG_TILDE] = ACTIONS(11706),
    [anon_sym_LT_EQ] = ACTIONS(11698),
    [anon_sym_GT] = ACTIONS(11698),
    [anon_sym_GT_EQ] = ACTIONS(11712),
    [anon_sym_CARET] = ACTIONS(11714),
    [anon_sym_PLUS] = ACTIONS(11690),
    [anon_sym_SLASH] = ACTIONS(11692),
    [anon_sym_PERCENT] = ACTIONS(11692),
    [sym_comment] = ACTIONS(87),
  },
  [9792] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11690),
    [sym__binary_star] = ACTIONS(11692),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(11694),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11692),
    [anon_sym_AMP] = ACTIONS(11696),
    [anon_sym_LT] = ACTIONS(11698),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(11700),
    [anon_sym_DOT_DOT] = ACTIONS(11702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11704),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(11706),
    [anon_sym_AMP_AMP] = ACTIONS(11706),
    [anon_sym_LT_LT] = ACTIONS(11708),
    [anon_sym_GT_GT] = ACTIONS(11708),
    [anon_sym_EQ_EQ] = ACTIONS(11710),
    [anon_sym_BANG_EQ] = ACTIONS(11706),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11706),
    [anon_sym_LT_EQ_GT] = ACTIONS(11706),
    [anon_sym_EQ_TILDE] = ACTIONS(11706),
    [anon_sym_BANG_TILDE] = ACTIONS(11706),
    [anon_sym_LT_EQ] = ACTIONS(11698),
    [anon_sym_GT] = ACTIONS(11698),
    [anon_sym_GT_EQ] = ACTIONS(11712),
    [anon_sym_CARET] = ACTIONS(11714),
    [anon_sym_PLUS] = ACTIONS(11690),
    [anon_sym_SLASH] = ACTIONS(11692),
    [anon_sym_PERCENT] = ACTIONS(11692),
    [sym_comment] = ACTIONS(87),
  },
  [9793] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11690),
    [sym__binary_star] = ACTIONS(11692),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(11694),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11692),
    [anon_sym_AMP] = ACTIONS(11696),
    [anon_sym_LT] = ACTIONS(11698),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(11708),
    [anon_sym_GT_GT] = ACTIONS(11708),
    [anon_sym_EQ_EQ] = ACTIONS(11710),
    [anon_sym_BANG_EQ] = ACTIONS(11706),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11706),
    [anon_sym_LT_EQ_GT] = ACTIONS(11706),
    [anon_sym_EQ_TILDE] = ACTIONS(11706),
    [anon_sym_BANG_TILDE] = ACTIONS(11706),
    [anon_sym_LT_EQ] = ACTIONS(11698),
    [anon_sym_GT] = ACTIONS(11698),
    [anon_sym_GT_EQ] = ACTIONS(11712),
    [anon_sym_CARET] = ACTIONS(11714),
    [anon_sym_PLUS] = ACTIONS(11690),
    [anon_sym_SLASH] = ACTIONS(11692),
    [anon_sym_PERCENT] = ACTIONS(11692),
    [sym_comment] = ACTIONS(87),
  },
  [9794] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11690),
    [sym__binary_star] = ACTIONS(11692),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11692),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_ensure] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(11690),
    [anon_sym_SLASH] = ACTIONS(11692),
    [anon_sym_PERCENT] = ACTIONS(11692),
    [sym_comment] = ACTIONS(87),
  },
  [9795] = {
    [aux_sym_exceptions_repeat1] = STATE(9795),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_COMMA] = ACTIONS(14367),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_end] = ACTIONS(11597),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_ensure] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [9796] = {
    [aux_sym_exceptions_repeat1] = STATE(8205),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_end] = ACTIONS(6191),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_ensure] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [9797] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(11690),
    [sym__binary_star] = ACTIONS(11692),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(11694),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(11692),
    [anon_sym_AMP] = ACTIONS(11696),
    [anon_sym_LT] = ACTIONS(11698),
    [anon_sym_end] = ACTIONS(6210),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_ensure] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(11700),
    [anon_sym_DOT_DOT] = ACTIONS(11702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11704),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(11706),
    [anon_sym_AMP_AMP] = ACTIONS(11706),
    [anon_sym_LT_LT] = ACTIONS(11708),
    [anon_sym_GT_GT] = ACTIONS(11708),
    [anon_sym_EQ_EQ] = ACTIONS(11710),
    [anon_sym_BANG_EQ] = ACTIONS(11706),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11706),
    [anon_sym_LT_EQ_GT] = ACTIONS(11706),
    [anon_sym_EQ_TILDE] = ACTIONS(11706),
    [anon_sym_BANG_TILDE] = ACTIONS(11706),
    [anon_sym_LT_EQ] = ACTIONS(11698),
    [anon_sym_GT] = ACTIONS(11698),
    [anon_sym_GT_EQ] = ACTIONS(11712),
    [anon_sym_CARET] = ACTIONS(11714),
    [anon_sym_PLUS] = ACTIONS(11690),
    [anon_sym_SLASH] = ACTIONS(11692),
    [anon_sym_PERCENT] = ACTIONS(11692),
    [sym_comment] = ACTIONS(87),
  },
  [9798] = {
    [sym_heredoc_body] = STATE(10673),
    [aux_sym_call_repeat1] = STATE(10673),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [9799] = {
    [sym_heredoc_body] = STATE(10674),
    [aux_sym_call_repeat1] = STATE(10674),
    [aux_sym_argument_list_repeat1] = STATE(8256),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(9097),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [9800] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(11726),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11726),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(11726),
    [anon_sym_PERCENT] = ACTIONS(11726),
    [sym_comment] = ACTIONS(87),
  },
  [9801] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11726),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [9802] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11724),
    [sym__binary_star] = ACTIONS(11726),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11726),
    [anon_sym_AMP] = ACTIONS(11730),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(11742),
    [anon_sym_GT_GT] = ACTIONS(11742),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(11724),
    [anon_sym_SLASH] = ACTIONS(11726),
    [anon_sym_PERCENT] = ACTIONS(11726),
    [sym_comment] = ACTIONS(87),
  },
  [9803] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11724),
    [sym__binary_star] = ACTIONS(11726),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11726),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(11742),
    [anon_sym_GT_GT] = ACTIONS(11742),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(11724),
    [anon_sym_SLASH] = ACTIONS(11726),
    [anon_sym_PERCENT] = ACTIONS(11726),
    [sym_comment] = ACTIONS(87),
  },
  [9804] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11724),
    [sym__binary_star] = ACTIONS(11726),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(11728),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11726),
    [anon_sym_AMP] = ACTIONS(11730),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(11742),
    [anon_sym_GT_GT] = ACTIONS(11742),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(11748),
    [anon_sym_PLUS] = ACTIONS(11724),
    [anon_sym_SLASH] = ACTIONS(11726),
    [anon_sym_PERCENT] = ACTIONS(11726),
    [sym_comment] = ACTIONS(87),
  },
  [9805] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(14370),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [9806] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(11724),
    [sym__binary_star] = ACTIONS(11726),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(11728),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(11726),
    [anon_sym_AMP] = ACTIONS(11730),
    [anon_sym_LT] = ACTIONS(11732),
    [anon_sym_end] = ACTIONS(5927),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(11736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11738),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(11740),
    [anon_sym_AMP_AMP] = ACTIONS(11740),
    [anon_sym_LT_LT] = ACTIONS(11742),
    [anon_sym_GT_GT] = ACTIONS(11742),
    [anon_sym_EQ_EQ] = ACTIONS(11744),
    [anon_sym_BANG_EQ] = ACTIONS(11740),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11740),
    [anon_sym_LT_EQ_GT] = ACTIONS(11740),
    [anon_sym_EQ_TILDE] = ACTIONS(11740),
    [anon_sym_BANG_TILDE] = ACTIONS(11740),
    [anon_sym_LT_EQ] = ACTIONS(11732),
    [anon_sym_GT] = ACTIONS(11732),
    [anon_sym_GT_EQ] = ACTIONS(11746),
    [anon_sym_CARET] = ACTIONS(11748),
    [anon_sym_PLUS] = ACTIONS(11724),
    [anon_sym_SLASH] = ACTIONS(11726),
    [anon_sym_PERCENT] = ACTIONS(11726),
    [sym_comment] = ACTIONS(87),
  },
  [9807] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11724),
    [sym__binary_star] = ACTIONS(11726),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(11728),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11726),
    [anon_sym_AMP] = ACTIONS(11730),
    [anon_sym_LT] = ACTIONS(11732),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(11734),
    [anon_sym_DOT_DOT] = ACTIONS(11736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11738),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(11740),
    [anon_sym_AMP_AMP] = ACTIONS(11740),
    [anon_sym_LT_LT] = ACTIONS(11742),
    [anon_sym_GT_GT] = ACTIONS(11742),
    [anon_sym_EQ_EQ] = ACTIONS(11744),
    [anon_sym_BANG_EQ] = ACTIONS(11740),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11740),
    [anon_sym_LT_EQ_GT] = ACTIONS(11740),
    [anon_sym_EQ_TILDE] = ACTIONS(11740),
    [anon_sym_BANG_TILDE] = ACTIONS(11740),
    [anon_sym_LT_EQ] = ACTIONS(11732),
    [anon_sym_GT] = ACTIONS(11732),
    [anon_sym_GT_EQ] = ACTIONS(11746),
    [anon_sym_CARET] = ACTIONS(11748),
    [anon_sym_PLUS] = ACTIONS(11724),
    [anon_sym_SLASH] = ACTIONS(11726),
    [anon_sym_PERCENT] = ACTIONS(11726),
    [sym_comment] = ACTIONS(87),
  },
  [9808] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11724),
    [sym__binary_star] = ACTIONS(11726),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(11728),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11726),
    [anon_sym_AMP] = ACTIONS(11730),
    [anon_sym_LT] = ACTIONS(11732),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(11742),
    [anon_sym_GT_GT] = ACTIONS(11742),
    [anon_sym_EQ_EQ] = ACTIONS(11744),
    [anon_sym_BANG_EQ] = ACTIONS(11740),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11740),
    [anon_sym_LT_EQ_GT] = ACTIONS(11740),
    [anon_sym_EQ_TILDE] = ACTIONS(11740),
    [anon_sym_BANG_TILDE] = ACTIONS(11740),
    [anon_sym_LT_EQ] = ACTIONS(11732),
    [anon_sym_GT] = ACTIONS(11732),
    [anon_sym_GT_EQ] = ACTIONS(11746),
    [anon_sym_CARET] = ACTIONS(11748),
    [anon_sym_PLUS] = ACTIONS(11724),
    [anon_sym_SLASH] = ACTIONS(11726),
    [anon_sym_PERCENT] = ACTIONS(11726),
    [sym_comment] = ACTIONS(87),
  },
  [9809] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11724),
    [sym__binary_star] = ACTIONS(11726),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11726),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(11724),
    [anon_sym_SLASH] = ACTIONS(11726),
    [anon_sym_PERCENT] = ACTIONS(11726),
    [sym_comment] = ACTIONS(87),
  },
  [9810] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(11724),
    [sym__binary_star] = ACTIONS(11726),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(11728),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(11726),
    [anon_sym_AMP] = ACTIONS(11730),
    [anon_sym_LT] = ACTIONS(11732),
    [anon_sym_end] = ACTIONS(5115),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(11734),
    [anon_sym_DOT_DOT] = ACTIONS(11736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11738),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(11740),
    [anon_sym_AMP_AMP] = ACTIONS(11740),
    [anon_sym_LT_LT] = ACTIONS(11742),
    [anon_sym_GT_GT] = ACTIONS(11742),
    [anon_sym_EQ_EQ] = ACTIONS(11744),
    [anon_sym_BANG_EQ] = ACTIONS(11740),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11740),
    [anon_sym_LT_EQ_GT] = ACTIONS(11740),
    [anon_sym_EQ_TILDE] = ACTIONS(11740),
    [anon_sym_BANG_TILDE] = ACTIONS(11740),
    [anon_sym_LT_EQ] = ACTIONS(11732),
    [anon_sym_GT] = ACTIONS(11732),
    [anon_sym_GT_EQ] = ACTIONS(11746),
    [anon_sym_CARET] = ACTIONS(11748),
    [anon_sym_PLUS] = ACTIONS(11724),
    [anon_sym_SLASH] = ACTIONS(11726),
    [anon_sym_PERCENT] = ACTIONS(11726),
    [sym_comment] = ACTIONS(87),
  },
  [9811] = {
    [aux_sym_exceptions_repeat1] = STATE(10677),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_end] = ACTIONS(6191),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [9812] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(11724),
    [sym__binary_star] = ACTIONS(11726),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(11728),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(11726),
    [anon_sym_AMP] = ACTIONS(11730),
    [anon_sym_LT] = ACTIONS(11732),
    [anon_sym_end] = ACTIONS(6210),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(11734),
    [anon_sym_DOT_DOT] = ACTIONS(11736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11738),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(11740),
    [anon_sym_AMP_AMP] = ACTIONS(11740),
    [anon_sym_LT_LT] = ACTIONS(11742),
    [anon_sym_GT_GT] = ACTIONS(11742),
    [anon_sym_EQ_EQ] = ACTIONS(11744),
    [anon_sym_BANG_EQ] = ACTIONS(11740),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11740),
    [anon_sym_LT_EQ_GT] = ACTIONS(11740),
    [anon_sym_EQ_TILDE] = ACTIONS(11740),
    [anon_sym_BANG_TILDE] = ACTIONS(11740),
    [anon_sym_LT_EQ] = ACTIONS(11732),
    [anon_sym_GT] = ACTIONS(11732),
    [anon_sym_GT_EQ] = ACTIONS(11746),
    [anon_sym_CARET] = ACTIONS(11748),
    [anon_sym_PLUS] = ACTIONS(11724),
    [anon_sym_SLASH] = ACTIONS(11726),
    [anon_sym_PERCENT] = ACTIONS(11726),
    [sym_comment] = ACTIONS(87),
  },
  [9813] = {
    [sym_string] = STATE(9813),
    [aux_sym_chained_string_repeat1] = STATE(9813),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(6214),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_end] = ACTIONS(6212),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [9814] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(9063),
    [sym__binary_star] = ACTIONS(9065),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(9067),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(9065),
    [anon_sym_AMP] = ACTIONS(9069),
    [anon_sym_LT] = ACTIONS(9071),
    [anon_sym_end] = ACTIONS(6823),
    [anon_sym_if] = ACTIONS(6823),
    [anon_sym_unless] = ACTIONS(6823),
    [anon_sym_while] = ACTIONS(6823),
    [anon_sym_until] = ACTIONS(6823),
    [anon_sym_rescue] = ACTIONS(6823),
    [anon_sym_EQ_GT] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(9073),
    [anon_sym_DOT_DOT] = ACTIONS(9075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9077),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(9079),
    [anon_sym_AMP_AMP] = ACTIONS(9079),
    [anon_sym_LT_LT] = ACTIONS(9081),
    [anon_sym_GT_GT] = ACTIONS(9081),
    [anon_sym_EQ_EQ] = ACTIONS(9083),
    [anon_sym_BANG_EQ] = ACTIONS(9079),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9079),
    [anon_sym_LT_EQ_GT] = ACTIONS(9079),
    [anon_sym_EQ_TILDE] = ACTIONS(9079),
    [anon_sym_BANG_TILDE] = ACTIONS(9079),
    [anon_sym_LT_EQ] = ACTIONS(9071),
    [anon_sym_GT] = ACTIONS(9071),
    [anon_sym_GT_EQ] = ACTIONS(9085),
    [anon_sym_CARET] = ACTIONS(9087),
    [anon_sym_PLUS] = ACTIONS(9063),
    [anon_sym_SLASH] = ACTIONS(9065),
    [anon_sym_PERCENT] = ACTIONS(9065),
    [sym_comment] = ACTIONS(87),
  },
  [9815] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(9063),
    [sym__binary_star] = ACTIONS(9065),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(9067),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(9065),
    [anon_sym_AMP] = ACTIONS(9069),
    [anon_sym_LT] = ACTIONS(9071),
    [anon_sym_end] = ACTIONS(7027),
    [anon_sym_if] = ACTIONS(7027),
    [anon_sym_unless] = ACTIONS(7027),
    [anon_sym_while] = ACTIONS(7027),
    [anon_sym_until] = ACTIONS(7027),
    [anon_sym_rescue] = ACTIONS(7027),
    [anon_sym_EQ_GT] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(9073),
    [anon_sym_DOT_DOT] = ACTIONS(9075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9077),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(9079),
    [anon_sym_AMP_AMP] = ACTIONS(9079),
    [anon_sym_LT_LT] = ACTIONS(9081),
    [anon_sym_GT_GT] = ACTIONS(9081),
    [anon_sym_EQ_EQ] = ACTIONS(9083),
    [anon_sym_BANG_EQ] = ACTIONS(9079),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9079),
    [anon_sym_LT_EQ_GT] = ACTIONS(9079),
    [anon_sym_EQ_TILDE] = ACTIONS(9079),
    [anon_sym_BANG_TILDE] = ACTIONS(9079),
    [anon_sym_LT_EQ] = ACTIONS(9071),
    [anon_sym_GT] = ACTIONS(9071),
    [anon_sym_GT_EQ] = ACTIONS(9085),
    [anon_sym_CARET] = ACTIONS(9087),
    [anon_sym_PLUS] = ACTIONS(9063),
    [anon_sym_SLASH] = ACTIONS(9065),
    [anon_sym_PERCENT] = ACTIONS(9065),
    [sym_comment] = ACTIONS(87),
  },
  [9816] = {
    [sym_heredoc_body] = STATE(9816),
    [aux_sym_call_repeat1] = STATE(9816),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(7916),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_end] = ACTIONS(7914),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_EQ_GT] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [9817] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5801),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3184),
    [sym_scope_resolution] = STATE(3180),
    [sym_call] = STATE(3180),
    [sym_method_call] = STATE(3184),
    [sym__argument] = STATE(4986),
    [sym_splat_argument] = STATE(4986),
    [sym_hash_splat_argument] = STATE(4986),
    [sym_block_argument] = STATE(4986),
    [sym_assignment] = STATE(5801),
    [sym_operator_assignment] = STATE(5801),
    [sym_conditional] = STATE(5801),
    [sym_range] = STATE(5801),
    [sym_binary] = STATE(5801),
    [sym_unary] = STATE(5801),
    [sym_left_assignment_list] = STATE(3183),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3184),
    [sym__variable] = STATE(3180),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3184),
    [sym_false] = STATE(3184),
    [sym_nil] = STATE(3184),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5804),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4986),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(9053),
    [sym__splat_star] = ACTIONS(9055),
    [sym__unary_minus] = ACTIONS(5303),
    [sym__identifier_hash_key] = ACTIONS(9057),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13533),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5307),
    [anon_sym_yield] = ACTIONS(5309),
    [anon_sym_break] = ACTIONS(5311),
    [anon_sym_next] = ACTIONS(5313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9049),
    [anon_sym_defined_QMARK] = ACTIONS(5315),
    [anon_sym_not] = ACTIONS(5317),
    [anon_sym_BANG] = ACTIONS(5321),
    [anon_sym_TILDE] = ACTIONS(5321),
    [sym_constant] = ACTIONS(9059),
    [sym_identifier] = ACTIONS(9059),
    [sym_instance_variable] = ACTIONS(5325),
    [sym_class_variable] = ACTIONS(5325),
    [sym_global_variable] = ACTIONS(5325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9818] = {
    [sym_heredoc_body] = STATE(9816),
    [aux_sym_call_repeat1] = STATE(9816),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_end] = ACTIONS(7929),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_EQ_GT] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [9819] = {
    [aux_sym_argument_list_repeat1] = STATE(9819),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(14372),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7925),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_end] = ACTIONS(7925),
    [anon_sym_if] = ACTIONS(7925),
    [anon_sym_unless] = ACTIONS(7925),
    [anon_sym_while] = ACTIONS(7925),
    [anon_sym_until] = ACTIONS(7925),
    [anon_sym_rescue] = ACTIONS(7925),
    [anon_sym_EQ_GT] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7925),
    [anon_sym_AMP_AMP] = ACTIONS(7925),
    [anon_sym_LT_LT] = ACTIONS(7925),
    [anon_sym_GT_GT] = ACTIONS(7925),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7925),
    [anon_sym_PLUS] = ACTIONS(7925),
    [anon_sym_SLASH] = ACTIONS(7925),
    [anon_sym_PERCENT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [9820] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10678),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3184),
    [sym_scope_resolution] = STATE(3180),
    [sym_call] = STATE(3180),
    [sym_method_call] = STATE(3184),
    [sym_assignment] = STATE(10678),
    [sym_operator_assignment] = STATE(10678),
    [sym_conditional] = STATE(10678),
    [sym_range] = STATE(10678),
    [sym_binary] = STATE(10678),
    [sym_unary] = STATE(10678),
    [sym_left_assignment_list] = STATE(3183),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3184),
    [sym__variable] = STATE(3180),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3184),
    [sym_false] = STATE(3184),
    [sym_nil] = STATE(3184),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5793),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(5303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5307),
    [anon_sym_yield] = ACTIONS(5309),
    [anon_sym_break] = ACTIONS(5311),
    [anon_sym_next] = ACTIONS(5313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9049),
    [anon_sym_defined_QMARK] = ACTIONS(5315),
    [anon_sym_not] = ACTIONS(5317),
    [anon_sym_BANG] = ACTIONS(5321),
    [anon_sym_TILDE] = ACTIONS(5321),
    [sym_constant] = ACTIONS(5327),
    [sym_identifier] = ACTIONS(5327),
    [sym_instance_variable] = ACTIONS(5325),
    [sym_class_variable] = ACTIONS(5325),
    [sym_global_variable] = ACTIONS(5325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9821] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(9135),
    [sym__binary_star] = ACTIONS(9137),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(9139),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(9141),
    [anon_sym_AMP] = ACTIONS(9143),
    [anon_sym_EQ] = ACTIONS(7822),
    [anon_sym_LT] = ACTIONS(9145),
    [anon_sym_end] = ACTIONS(6823),
    [anon_sym_if] = ACTIONS(6823),
    [anon_sym_unless] = ACTIONS(6823),
    [anon_sym_while] = ACTIONS(6823),
    [anon_sym_until] = ACTIONS(6823),
    [anon_sym_rescue] = ACTIONS(6823),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_EQ_GT] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_PLUS_EQ] = ACTIONS(6823),
    [anon_sym_DASH_EQ] = ACTIONS(6823),
    [anon_sym_STAR_EQ] = ACTIONS(6823),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6823),
    [anon_sym_SLASH_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6823),
    [anon_sym_AMP_EQ] = ACTIONS(6823),
    [anon_sym_PERCENT_EQ] = ACTIONS(6823),
    [anon_sym_GT_GT_EQ] = ACTIONS(6823),
    [anon_sym_LT_LT_EQ] = ACTIONS(6823),
    [anon_sym_CARET_EQ] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(9147),
    [anon_sym_DOT_DOT] = ACTIONS(9149),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9151),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(9153),
    [anon_sym_AMP_AMP] = ACTIONS(9153),
    [anon_sym_LT_LT] = ACTIONS(9155),
    [anon_sym_GT_GT] = ACTIONS(9155),
    [anon_sym_EQ_EQ] = ACTIONS(9153),
    [anon_sym_BANG_EQ] = ACTIONS(9157),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9157),
    [anon_sym_LT_EQ_GT] = ACTIONS(9157),
    [anon_sym_EQ_TILDE] = ACTIONS(9157),
    [anon_sym_BANG_TILDE] = ACTIONS(9157),
    [anon_sym_LT_EQ] = ACTIONS(9145),
    [anon_sym_GT] = ACTIONS(9145),
    [anon_sym_GT_EQ] = ACTIONS(9159),
    [anon_sym_CARET] = ACTIONS(9139),
    [anon_sym_PLUS] = ACTIONS(9161),
    [anon_sym_SLASH] = ACTIONS(9141),
    [anon_sym_PERCENT] = ACTIONS(9141),
    [sym_comment] = ACTIONS(87),
  },
  [9822] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(9135),
    [sym__binary_star] = ACTIONS(9137),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(9139),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(9141),
    [anon_sym_AMP] = ACTIONS(9143),
    [anon_sym_EQ] = ACTIONS(7884),
    [anon_sym_LT] = ACTIONS(9145),
    [anon_sym_end] = ACTIONS(7027),
    [anon_sym_if] = ACTIONS(7027),
    [anon_sym_unless] = ACTIONS(7027),
    [anon_sym_while] = ACTIONS(7027),
    [anon_sym_until] = ACTIONS(7027),
    [anon_sym_rescue] = ACTIONS(7027),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_EQ_GT] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_PLUS_EQ] = ACTIONS(7027),
    [anon_sym_DASH_EQ] = ACTIONS(7027),
    [anon_sym_STAR_EQ] = ACTIONS(7027),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7027),
    [anon_sym_SLASH_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7027),
    [anon_sym_AMP_EQ] = ACTIONS(7027),
    [anon_sym_PERCENT_EQ] = ACTIONS(7027),
    [anon_sym_GT_GT_EQ] = ACTIONS(7027),
    [anon_sym_LT_LT_EQ] = ACTIONS(7027),
    [anon_sym_CARET_EQ] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(9147),
    [anon_sym_DOT_DOT] = ACTIONS(9149),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9151),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(9153),
    [anon_sym_AMP_AMP] = ACTIONS(9153),
    [anon_sym_LT_LT] = ACTIONS(9155),
    [anon_sym_GT_GT] = ACTIONS(9155),
    [anon_sym_EQ_EQ] = ACTIONS(9153),
    [anon_sym_BANG_EQ] = ACTIONS(9157),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9157),
    [anon_sym_LT_EQ_GT] = ACTIONS(9157),
    [anon_sym_EQ_TILDE] = ACTIONS(9157),
    [anon_sym_BANG_TILDE] = ACTIONS(9157),
    [anon_sym_LT_EQ] = ACTIONS(9145),
    [anon_sym_GT] = ACTIONS(9145),
    [anon_sym_GT_EQ] = ACTIONS(9159),
    [anon_sym_CARET] = ACTIONS(9139),
    [anon_sym_PLUS] = ACTIONS(9161),
    [anon_sym_SLASH] = ACTIONS(9141),
    [anon_sym_PERCENT] = ACTIONS(9141),
    [sym_comment] = ACTIONS(87),
  },
  [9823] = {
    [sym_heredoc_body] = STATE(9823),
    [aux_sym_call_repeat1] = STATE(9823),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(10978),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7919),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_EQ] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_end] = ACTIONS(7914),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_EQ_GT] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_PLUS_EQ] = ACTIONS(7914),
    [anon_sym_DASH_EQ] = ACTIONS(7914),
    [anon_sym_STAR_EQ] = ACTIONS(7914),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7914),
    [anon_sym_SLASH_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7914),
    [anon_sym_AMP_EQ] = ACTIONS(7914),
    [anon_sym_PERCENT_EQ] = ACTIONS(7914),
    [anon_sym_GT_GT_EQ] = ACTIONS(7914),
    [anon_sym_LT_LT_EQ] = ACTIONS(7914),
    [anon_sym_CARET_EQ] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7919),
    [anon_sym_AMP_AMP] = ACTIONS(7919),
    [anon_sym_LT_LT] = ACTIONS(7919),
    [anon_sym_GT_GT] = ACTIONS(7919),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7919),
    [anon_sym_PLUS] = ACTIONS(7919),
    [anon_sym_SLASH] = ACTIONS(7919),
    [anon_sym_PERCENT] = ACTIONS(7919),
    [sym_comment] = ACTIONS(87),
  },
  [9824] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(5822),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3220),
    [sym_scope_resolution] = STATE(3216),
    [sym_call] = STATE(3216),
    [sym_method_call] = STATE(3220),
    [sym__argument] = STATE(7437),
    [sym_splat_argument] = STATE(7437),
    [sym_hash_splat_argument] = STATE(7437),
    [sym_block_argument] = STATE(7437),
    [sym_assignment] = STATE(5822),
    [sym_operator_assignment] = STATE(5822),
    [sym_conditional] = STATE(5822),
    [sym_range] = STATE(5822),
    [sym_binary] = STATE(5822),
    [sym_unary] = STATE(5822),
    [sym_left_assignment_list] = STATE(3219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3220),
    [sym__variable] = STATE(3216),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3220),
    [sym_false] = STATE(3220),
    [sym_nil] = STATE(3220),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5825),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(7437),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(9089),
    [sym__splat_star] = ACTIONS(9091),
    [sym__unary_minus] = ACTIONS(5375),
    [sym__identifier_hash_key] = ACTIONS(9093),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13537),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5379),
    [anon_sym_yield] = ACTIONS(5381),
    [anon_sym_break] = ACTIONS(5383),
    [anon_sym_next] = ACTIONS(5385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(9129),
    [anon_sym_defined_QMARK] = ACTIONS(5387),
    [anon_sym_not] = ACTIONS(5389),
    [anon_sym_BANG] = ACTIONS(5393),
    [anon_sym_TILDE] = ACTIONS(5393),
    [sym_constant] = ACTIONS(9095),
    [sym_identifier] = ACTIONS(9095),
    [sym_instance_variable] = ACTIONS(5397),
    [sym_class_variable] = ACTIONS(5397),
    [sym_global_variable] = ACTIONS(5397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [9825] = {
    [sym_heredoc_body] = STATE(9823),
    [aux_sym_call_repeat1] = STATE(9823),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7931),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_EQ] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_end] = ACTIONS(7929),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_EQ_GT] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_PLUS_EQ] = ACTIONS(7929),
    [anon_sym_DASH_EQ] = ACTIONS(7929),
    [anon_sym_STAR_EQ] = ACTIONS(7929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7929),
    [anon_sym_SLASH_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7929),
    [anon_sym_AMP_EQ] = ACTIONS(7929),
    [anon_sym_PERCENT_EQ] = ACTIONS(7929),
    [anon_sym_GT_GT_EQ] = ACTIONS(7929),
    [anon_sym_LT_LT_EQ] = ACTIONS(7929),
    [anon_sym_CARET_EQ] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7931),
    [anon_sym_AMP_AMP] = ACTIONS(7931),
    [anon_sym_LT_LT] = ACTIONS(7931),
    [anon_sym_GT_GT] = ACTIONS(7931),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7931),
    [anon_sym_PLUS] = ACTIONS(7931),
    [anon_sym_SLASH] = ACTIONS(7931),
    [anon_sym_PERCENT] = ACTIONS(7931),
    [sym_comment] = ACTIONS(87),
  },
  [9826] = {
    [aux_sym_argument_list_repeat1] = STATE(9826),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(14375),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7927),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_EQ] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_end] = ACTIONS(7925),
    [anon_sym_if] = ACTIONS(7925),
    [anon_sym_unless] = ACTIONS(7925),
    [anon_sym_while] = ACTIONS(7925),
    [anon_sym_until] = ACTIONS(7925),
    [anon_sym_rescue] = ACTIONS(7925),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_EQ_GT] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_PLUS_EQ] = ACTIONS(7925),
    [anon_sym_DASH_EQ] = ACTIONS(7925),
    [anon_sym_STAR_EQ] = ACTIONS(7925),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7925),
    [anon_sym_SLASH_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7925),
    [anon_sym_AMP_EQ] = ACTIONS(7925),
    [anon_sym_PERCENT_EQ] = ACTIONS(7925),
    [anon_sym_GT_GT_EQ] = ACTIONS(7925),
    [anon_sym_LT_LT_EQ] = ACTIONS(7925),
    [anon_sym_CARET_EQ] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7927),
    [anon_sym_AMP_AMP] = ACTIONS(7927),
    [anon_sym_LT_LT] = ACTIONS(7927),
    [anon_sym_GT_GT] = ACTIONS(7927),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7927),
    [anon_sym_PLUS] = ACTIONS(7927),
    [anon_sym_SLASH] = ACTIONS(7927),
    [anon_sym_PERCENT] = ACTIONS(7927),
    [sym_comment] = ACTIONS(87),
  },
  [9827] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8257),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3184),
    [sym_scope_resolution] = STATE(3180),
    [sym_call] = STATE(3180),
    [sym_method_call] = STATE(3184),
    [sym_splat_argument] = STATE(7439),
    [sym_assignment] = STATE(8257),
    [sym_operator_assignment] = STATE(8257),
    [sym_conditional] = STATE(8257),
    [sym_range] = STATE(8257),
    [sym_binary] = STATE(8257),
    [sym_unary] = STATE(8257),
    [sym__arg_or_splat_arg] = STATE(7439),
    [sym_left_assignment_list] = STATE(3183),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3184),
    [sym__variable] = STATE(3180),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3184),
    [sym_false] = STATE(3184),
    [sym_nil] = STATE(3184),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5793),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__splat_star] = ACTIONS(9055),
    [sym__unary_minus] = ACTIONS(5303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5307),
    [anon_sym_yield] = ACTIONS(5309),
    [anon_sym_break] = ACTIONS(5311),
    [anon_sym_next] = ACTIONS(5313),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9049),
    [anon_sym_defined_QMARK] = ACTIONS(5315),
    [anon_sym_not] = ACTIONS(5317),
    [anon_sym_BANG] = ACTIONS(5321),
    [anon_sym_TILDE] = ACTIONS(5321),
    [sym_constant] = ACTIONS(5327),
    [sym_identifier] = ACTIONS(5327),
    [sym_instance_variable] = ACTIONS(5325),
    [sym_class_variable] = ACTIONS(5325),
    [sym_global_variable] = ACTIONS(5325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5327),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5327),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9828] = {
    [aux_sym_exceptions_repeat1] = STATE(10679),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(14378),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_end] = ACTIONS(9855),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_EQ_GT] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [9829] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(5343),
    [sym__binary_star] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(5345),
    [anon_sym_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_end] = ACTIONS(12120),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(5353),
    [anon_sym_DOT_DOT] = ACTIONS(5355),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5357),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(5361),
    [anon_sym_AMP_AMP] = ACTIONS(5361),
    [anon_sym_LT_LT] = ACTIONS(5363),
    [anon_sym_GT_GT] = ACTIONS(5363),
    [anon_sym_EQ_EQ] = ACTIONS(5365),
    [anon_sym_BANG_EQ] = ACTIONS(5361),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5361),
    [anon_sym_LT_EQ_GT] = ACTIONS(5361),
    [anon_sym_EQ_TILDE] = ACTIONS(5361),
    [anon_sym_BANG_TILDE] = ACTIONS(5361),
    [anon_sym_LT_EQ] = ACTIONS(5351),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5367),
    [anon_sym_CARET] = ACTIONS(5369),
    [anon_sym_PLUS] = ACTIONS(5343),
    [anon_sym_SLASH] = ACTIONS(5345),
    [anon_sym_PERCENT] = ACTIONS(5345),
    [sym_comment] = ACTIONS(87),
  },
  [9830] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(11778),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11782),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(11782),
    [anon_sym_PERCENT] = ACTIONS(11782),
    [sym_comment] = ACTIONS(87),
  },
  [9831] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11782),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(5827),
    [anon_sym_PERCENT] = ACTIONS(5827),
    [sym_comment] = ACTIONS(87),
  },
  [9832] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11776),
    [sym__binary_star] = ACTIONS(11778),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11782),
    [anon_sym_AMP] = ACTIONS(11784),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(11796),
    [anon_sym_GT_GT] = ACTIONS(11796),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(11802),
    [anon_sym_SLASH] = ACTIONS(11782),
    [anon_sym_PERCENT] = ACTIONS(11782),
    [sym_comment] = ACTIONS(87),
  },
  [9833] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11776),
    [sym__binary_star] = ACTIONS(11778),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11782),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(11796),
    [anon_sym_GT_GT] = ACTIONS(11796),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(11802),
    [anon_sym_SLASH] = ACTIONS(11782),
    [anon_sym_PERCENT] = ACTIONS(11782),
    [sym_comment] = ACTIONS(87),
  },
  [9834] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11776),
    [sym__binary_star] = ACTIONS(11778),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(11780),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11782),
    [anon_sym_AMP] = ACTIONS(11784),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(11796),
    [anon_sym_GT_GT] = ACTIONS(11796),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(11780),
    [anon_sym_PLUS] = ACTIONS(11802),
    [anon_sym_SLASH] = ACTIONS(11782),
    [anon_sym_PERCENT] = ACTIONS(11782),
    [sym_comment] = ACTIONS(87),
  },
  [9835] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(14380),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [9836] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(11776),
    [sym__binary_star] = ACTIONS(11778),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(11780),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(11782),
    [anon_sym_AMP] = ACTIONS(11784),
    [anon_sym_EQ] = ACTIONS(7888),
    [anon_sym_LT] = ACTIONS(11786),
    [anon_sym_end] = ACTIONS(5927),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_PLUS_EQ] = ACTIONS(5927),
    [anon_sym_DASH_EQ] = ACTIONS(5927),
    [anon_sym_STAR_EQ] = ACTIONS(5927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5927),
    [anon_sym_SLASH_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5927),
    [anon_sym_AMP_EQ] = ACTIONS(5927),
    [anon_sym_PERCENT_EQ] = ACTIONS(5927),
    [anon_sym_GT_GT_EQ] = ACTIONS(5927),
    [anon_sym_LT_LT_EQ] = ACTIONS(5927),
    [anon_sym_CARET_EQ] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(11790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11792),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(11794),
    [anon_sym_AMP_AMP] = ACTIONS(11794),
    [anon_sym_LT_LT] = ACTIONS(11796),
    [anon_sym_GT_GT] = ACTIONS(11796),
    [anon_sym_EQ_EQ] = ACTIONS(11794),
    [anon_sym_BANG_EQ] = ACTIONS(11798),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11798),
    [anon_sym_LT_EQ_GT] = ACTIONS(11798),
    [anon_sym_EQ_TILDE] = ACTIONS(11798),
    [anon_sym_BANG_TILDE] = ACTIONS(11798),
    [anon_sym_LT_EQ] = ACTIONS(11786),
    [anon_sym_GT] = ACTIONS(11786),
    [anon_sym_GT_EQ] = ACTIONS(11800),
    [anon_sym_CARET] = ACTIONS(11780),
    [anon_sym_PLUS] = ACTIONS(11802),
    [anon_sym_SLASH] = ACTIONS(11782),
    [anon_sym_PERCENT] = ACTIONS(11782),
    [sym_comment] = ACTIONS(87),
  },
  [9837] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11776),
    [sym__binary_star] = ACTIONS(11778),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(11780),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11782),
    [anon_sym_AMP] = ACTIONS(11784),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(11786),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(11788),
    [anon_sym_DOT_DOT] = ACTIONS(11790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11792),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(11794),
    [anon_sym_AMP_AMP] = ACTIONS(11794),
    [anon_sym_LT_LT] = ACTIONS(11796),
    [anon_sym_GT_GT] = ACTIONS(11796),
    [anon_sym_EQ_EQ] = ACTIONS(11794),
    [anon_sym_BANG_EQ] = ACTIONS(11798),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11798),
    [anon_sym_LT_EQ_GT] = ACTIONS(11798),
    [anon_sym_EQ_TILDE] = ACTIONS(11798),
    [anon_sym_BANG_TILDE] = ACTIONS(11798),
    [anon_sym_LT_EQ] = ACTIONS(11786),
    [anon_sym_GT] = ACTIONS(11786),
    [anon_sym_GT_EQ] = ACTIONS(11800),
    [anon_sym_CARET] = ACTIONS(11780),
    [anon_sym_PLUS] = ACTIONS(11802),
    [anon_sym_SLASH] = ACTIONS(11782),
    [anon_sym_PERCENT] = ACTIONS(11782),
    [sym_comment] = ACTIONS(87),
  },
  [9838] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11776),
    [sym__binary_star] = ACTIONS(11778),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(11780),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11782),
    [anon_sym_AMP] = ACTIONS(11784),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(11786),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(11796),
    [anon_sym_GT_GT] = ACTIONS(11796),
    [anon_sym_EQ_EQ] = ACTIONS(11794),
    [anon_sym_BANG_EQ] = ACTIONS(11798),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11798),
    [anon_sym_LT_EQ_GT] = ACTIONS(11798),
    [anon_sym_EQ_TILDE] = ACTIONS(11798),
    [anon_sym_BANG_TILDE] = ACTIONS(11798),
    [anon_sym_LT_EQ] = ACTIONS(11786),
    [anon_sym_GT] = ACTIONS(11786),
    [anon_sym_GT_EQ] = ACTIONS(11800),
    [anon_sym_CARET] = ACTIONS(11780),
    [anon_sym_PLUS] = ACTIONS(11802),
    [anon_sym_SLASH] = ACTIONS(11782),
    [anon_sym_PERCENT] = ACTIONS(11782),
    [sym_comment] = ACTIONS(87),
  },
  [9839] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11776),
    [sym__binary_star] = ACTIONS(11778),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11782),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(11802),
    [anon_sym_SLASH] = ACTIONS(11782),
    [anon_sym_PERCENT] = ACTIONS(11782),
    [sym_comment] = ACTIONS(87),
  },
  [9840] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(11776),
    [sym__binary_star] = ACTIONS(11778),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(11780),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(11782),
    [anon_sym_AMP] = ACTIONS(11784),
    [anon_sym_EQ] = ACTIONS(7936),
    [anon_sym_LT] = ACTIONS(11786),
    [anon_sym_end] = ACTIONS(5115),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_PLUS_EQ] = ACTIONS(5115),
    [anon_sym_DASH_EQ] = ACTIONS(5115),
    [anon_sym_STAR_EQ] = ACTIONS(5115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5115),
    [anon_sym_SLASH_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5115),
    [anon_sym_AMP_EQ] = ACTIONS(5115),
    [anon_sym_PERCENT_EQ] = ACTIONS(5115),
    [anon_sym_GT_GT_EQ] = ACTIONS(5115),
    [anon_sym_LT_LT_EQ] = ACTIONS(5115),
    [anon_sym_CARET_EQ] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(11788),
    [anon_sym_DOT_DOT] = ACTIONS(11790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11792),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(11794),
    [anon_sym_AMP_AMP] = ACTIONS(11794),
    [anon_sym_LT_LT] = ACTIONS(11796),
    [anon_sym_GT_GT] = ACTIONS(11796),
    [anon_sym_EQ_EQ] = ACTIONS(11794),
    [anon_sym_BANG_EQ] = ACTIONS(11798),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11798),
    [anon_sym_LT_EQ_GT] = ACTIONS(11798),
    [anon_sym_EQ_TILDE] = ACTIONS(11798),
    [anon_sym_BANG_TILDE] = ACTIONS(11798),
    [anon_sym_LT_EQ] = ACTIONS(11786),
    [anon_sym_GT] = ACTIONS(11786),
    [anon_sym_GT_EQ] = ACTIONS(11800),
    [anon_sym_CARET] = ACTIONS(11780),
    [anon_sym_PLUS] = ACTIONS(11802),
    [anon_sym_SLASH] = ACTIONS(11782),
    [anon_sym_PERCENT] = ACTIONS(11782),
    [sym_comment] = ACTIONS(87),
  },
  [9841] = {
    [aux_sym_exceptions_repeat1] = STATE(10682),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6193),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_end] = ACTIONS(6191),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_PLUS_EQ] = ACTIONS(6191),
    [anon_sym_DASH_EQ] = ACTIONS(6191),
    [anon_sym_STAR_EQ] = ACTIONS(6191),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6191),
    [anon_sym_SLASH_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6191),
    [anon_sym_AMP_EQ] = ACTIONS(6191),
    [anon_sym_PERCENT_EQ] = ACTIONS(6191),
    [anon_sym_GT_GT_EQ] = ACTIONS(6191),
    [anon_sym_LT_LT_EQ] = ACTIONS(6191),
    [anon_sym_CARET_EQ] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6193),
    [anon_sym_AMP_AMP] = ACTIONS(6193),
    [anon_sym_LT_LT] = ACTIONS(6193),
    [anon_sym_GT_GT] = ACTIONS(6193),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6193),
    [anon_sym_PLUS] = ACTIONS(6193),
    [anon_sym_SLASH] = ACTIONS(6193),
    [anon_sym_PERCENT] = ACTIONS(6193),
    [sym_comment] = ACTIONS(87),
  },
  [9842] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(11776),
    [sym__binary_star] = ACTIONS(11778),
    [anon_sym_LBRACE] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(11780),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(11782),
    [anon_sym_AMP] = ACTIONS(11784),
    [anon_sym_EQ] = ACTIONS(7938),
    [anon_sym_LT] = ACTIONS(11786),
    [anon_sym_end] = ACTIONS(6210),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_PLUS_EQ] = ACTIONS(6210),
    [anon_sym_DASH_EQ] = ACTIONS(6210),
    [anon_sym_STAR_EQ] = ACTIONS(6210),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6210),
    [anon_sym_SLASH_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6210),
    [anon_sym_AMP_EQ] = ACTIONS(6210),
    [anon_sym_PERCENT_EQ] = ACTIONS(6210),
    [anon_sym_GT_GT_EQ] = ACTIONS(6210),
    [anon_sym_LT_LT_EQ] = ACTIONS(6210),
    [anon_sym_CARET_EQ] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(11788),
    [anon_sym_DOT_DOT] = ACTIONS(11790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11792),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(11794),
    [anon_sym_AMP_AMP] = ACTIONS(11794),
    [anon_sym_LT_LT] = ACTIONS(11796),
    [anon_sym_GT_GT] = ACTIONS(11796),
    [anon_sym_EQ_EQ] = ACTIONS(11794),
    [anon_sym_BANG_EQ] = ACTIONS(11798),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11798),
    [anon_sym_LT_EQ_GT] = ACTIONS(11798),
    [anon_sym_EQ_TILDE] = ACTIONS(11798),
    [anon_sym_BANG_TILDE] = ACTIONS(11798),
    [anon_sym_LT_EQ] = ACTIONS(11786),
    [anon_sym_GT] = ACTIONS(11786),
    [anon_sym_GT_EQ] = ACTIONS(11800),
    [anon_sym_CARET] = ACTIONS(11780),
    [anon_sym_PLUS] = ACTIONS(11802),
    [anon_sym_SLASH] = ACTIONS(11782),
    [anon_sym_PERCENT] = ACTIONS(11782),
    [sym_comment] = ACTIONS(87),
  },
  [9843] = {
    [sym_string] = STATE(9843),
    [aux_sym_chained_string_repeat1] = STATE(9843),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(12267),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6217),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_EQ] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_end] = ACTIONS(6212),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_do] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_PLUS_EQ] = ACTIONS(6212),
    [anon_sym_DASH_EQ] = ACTIONS(6212),
    [anon_sym_STAR_EQ] = ACTIONS(6212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6212),
    [anon_sym_SLASH_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6212),
    [anon_sym_AMP_EQ] = ACTIONS(6212),
    [anon_sym_PERCENT_EQ] = ACTIONS(6212),
    [anon_sym_GT_GT_EQ] = ACTIONS(6212),
    [anon_sym_LT_LT_EQ] = ACTIONS(6212),
    [anon_sym_CARET_EQ] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6217),
    [anon_sym_AMP_AMP] = ACTIONS(6217),
    [anon_sym_LT_LT] = ACTIONS(6217),
    [anon_sym_GT_GT] = ACTIONS(6217),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6217),
    [anon_sym_PLUS] = ACTIONS(6217),
    [anon_sym_SLASH] = ACTIONS(6217),
    [anon_sym_PERCENT] = ACTIONS(6217),
    [sym_comment] = ACTIONS(87),
  },
  [9844] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(10683),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3220),
    [sym_scope_resolution] = STATE(3216),
    [sym_call] = STATE(3216),
    [sym_method_call] = STATE(3220),
    [sym_assignment] = STATE(10683),
    [sym_operator_assignment] = STATE(10683),
    [sym_conditional] = STATE(10683),
    [sym_range] = STATE(10683),
    [sym_binary] = STATE(10683),
    [sym_unary] = STATE(10683),
    [sym_left_assignment_list] = STATE(3219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3220),
    [sym__variable] = STATE(3216),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3220),
    [sym_false] = STATE(3220),
    [sym_nil] = STATE(3220),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5862),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(5375),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5379),
    [anon_sym_yield] = ACTIONS(5381),
    [anon_sym_break] = ACTIONS(5383),
    [anon_sym_next] = ACTIONS(5385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(9129),
    [anon_sym_defined_QMARK] = ACTIONS(5387),
    [anon_sym_not] = ACTIONS(5389),
    [anon_sym_BANG] = ACTIONS(5393),
    [anon_sym_TILDE] = ACTIONS(5393),
    [sym_constant] = ACTIONS(5399),
    [sym_identifier] = ACTIONS(5399),
    [sym_instance_variable] = ACTIONS(5397),
    [sym_class_variable] = ACTIONS(5397),
    [sym_global_variable] = ACTIONS(5397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [9845] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8294),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3220),
    [sym_scope_resolution] = STATE(3216),
    [sym_call] = STATE(3216),
    [sym_method_call] = STATE(3220),
    [sym_splat_argument] = STATE(8678),
    [sym_assignment] = STATE(8294),
    [sym_operator_assignment] = STATE(8294),
    [sym_conditional] = STATE(8294),
    [sym_range] = STATE(8294),
    [sym_binary] = STATE(8294),
    [sym_unary] = STATE(8294),
    [sym__arg_or_splat_arg] = STATE(8678),
    [sym_left_assignment_list] = STATE(3219),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3220),
    [sym__variable] = STATE(3216),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3220),
    [sym_false] = STATE(3220),
    [sym_nil] = STATE(3220),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(5862),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__splat_star] = ACTIONS(9091),
    [sym__unary_minus] = ACTIONS(5375),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(5379),
    [anon_sym_yield] = ACTIONS(5381),
    [anon_sym_break] = ACTIONS(5383),
    [anon_sym_next] = ACTIONS(5385),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(9129),
    [anon_sym_defined_QMARK] = ACTIONS(5387),
    [anon_sym_not] = ACTIONS(5389),
    [anon_sym_BANG] = ACTIONS(5393),
    [anon_sym_TILDE] = ACTIONS(5393),
    [sym_constant] = ACTIONS(5399),
    [sym_identifier] = ACTIONS(5399),
    [sym_instance_variable] = ACTIONS(5397),
    [sym_class_variable] = ACTIONS(5397),
    [sym_global_variable] = ACTIONS(5397),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(5399),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5399),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [9846] = {
    [aux_sym_exceptions_repeat1] = STATE(10684),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_LBRACE] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(14382),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9857),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_EQ] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_end] = ACTIONS(9855),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_do] = ACTIONS(9855),
    [anon_sym_EQ_GT] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_PLUS_EQ] = ACTIONS(9855),
    [anon_sym_DASH_EQ] = ACTIONS(9855),
    [anon_sym_STAR_EQ] = ACTIONS(9855),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9855),
    [anon_sym_SLASH_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9855),
    [anon_sym_AMP_EQ] = ACTIONS(9855),
    [anon_sym_PERCENT_EQ] = ACTIONS(9855),
    [anon_sym_GT_GT_EQ] = ACTIONS(9855),
    [anon_sym_LT_LT_EQ] = ACTIONS(9855),
    [anon_sym_CARET_EQ] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9857),
    [anon_sym_AMP_AMP] = ACTIONS(9857),
    [anon_sym_LT_LT] = ACTIONS(9857),
    [anon_sym_GT_GT] = ACTIONS(9857),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9857),
    [anon_sym_PLUS] = ACTIONS(9857),
    [anon_sym_SLASH] = ACTIONS(9857),
    [anon_sym_PERCENT] = ACTIONS(9857),
    [sym_comment] = ACTIONS(87),
  },
  [9847] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(11814),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11814),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(11814),
    [anon_sym_PERCENT] = ACTIONS(11814),
    [sym_comment] = ACTIONS(87),
  },
  [9848] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11814),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [9849] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11812),
    [sym__binary_star] = ACTIONS(11814),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11814),
    [anon_sym_AMP] = ACTIONS(11818),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(11830),
    [anon_sym_GT_GT] = ACTIONS(11830),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(11812),
    [anon_sym_SLASH] = ACTIONS(11814),
    [anon_sym_PERCENT] = ACTIONS(11814),
    [sym_comment] = ACTIONS(87),
  },
  [9850] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11812),
    [sym__binary_star] = ACTIONS(11814),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11814),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(11830),
    [anon_sym_GT_GT] = ACTIONS(11830),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(11812),
    [anon_sym_SLASH] = ACTIONS(11814),
    [anon_sym_PERCENT] = ACTIONS(11814),
    [sym_comment] = ACTIONS(87),
  },
  [9851] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11812),
    [sym__binary_star] = ACTIONS(11814),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(11816),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11814),
    [anon_sym_AMP] = ACTIONS(11818),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(11830),
    [anon_sym_GT_GT] = ACTIONS(11830),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(11836),
    [anon_sym_PLUS] = ACTIONS(11812),
    [anon_sym_SLASH] = ACTIONS(11814),
    [anon_sym_PERCENT] = ACTIONS(11814),
    [sym_comment] = ACTIONS(87),
  },
  [9852] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(14384),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [9853] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(11812),
    [sym__binary_star] = ACTIONS(11814),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(11816),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(11814),
    [anon_sym_AMP] = ACTIONS(11818),
    [anon_sym_LT] = ACTIONS(11820),
    [anon_sym_end] = ACTIONS(5927),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(11824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11826),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(11828),
    [anon_sym_AMP_AMP] = ACTIONS(11828),
    [anon_sym_LT_LT] = ACTIONS(11830),
    [anon_sym_GT_GT] = ACTIONS(11830),
    [anon_sym_EQ_EQ] = ACTIONS(11832),
    [anon_sym_BANG_EQ] = ACTIONS(11828),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11828),
    [anon_sym_LT_EQ_GT] = ACTIONS(11828),
    [anon_sym_EQ_TILDE] = ACTIONS(11828),
    [anon_sym_BANG_TILDE] = ACTIONS(11828),
    [anon_sym_LT_EQ] = ACTIONS(11820),
    [anon_sym_GT] = ACTIONS(11820),
    [anon_sym_GT_EQ] = ACTIONS(11834),
    [anon_sym_CARET] = ACTIONS(11836),
    [anon_sym_PLUS] = ACTIONS(11812),
    [anon_sym_SLASH] = ACTIONS(11814),
    [anon_sym_PERCENT] = ACTIONS(11814),
    [sym_comment] = ACTIONS(87),
  },
  [9854] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11812),
    [sym__binary_star] = ACTIONS(11814),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(11816),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11814),
    [anon_sym_AMP] = ACTIONS(11818),
    [anon_sym_LT] = ACTIONS(11820),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(11822),
    [anon_sym_DOT_DOT] = ACTIONS(11824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11826),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(11828),
    [anon_sym_AMP_AMP] = ACTIONS(11828),
    [anon_sym_LT_LT] = ACTIONS(11830),
    [anon_sym_GT_GT] = ACTIONS(11830),
    [anon_sym_EQ_EQ] = ACTIONS(11832),
    [anon_sym_BANG_EQ] = ACTIONS(11828),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11828),
    [anon_sym_LT_EQ_GT] = ACTIONS(11828),
    [anon_sym_EQ_TILDE] = ACTIONS(11828),
    [anon_sym_BANG_TILDE] = ACTIONS(11828),
    [anon_sym_LT_EQ] = ACTIONS(11820),
    [anon_sym_GT] = ACTIONS(11820),
    [anon_sym_GT_EQ] = ACTIONS(11834),
    [anon_sym_CARET] = ACTIONS(11836),
    [anon_sym_PLUS] = ACTIONS(11812),
    [anon_sym_SLASH] = ACTIONS(11814),
    [anon_sym_PERCENT] = ACTIONS(11814),
    [sym_comment] = ACTIONS(87),
  },
  [9855] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11812),
    [sym__binary_star] = ACTIONS(11814),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(11816),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11814),
    [anon_sym_AMP] = ACTIONS(11818),
    [anon_sym_LT] = ACTIONS(11820),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(11830),
    [anon_sym_GT_GT] = ACTIONS(11830),
    [anon_sym_EQ_EQ] = ACTIONS(11832),
    [anon_sym_BANG_EQ] = ACTIONS(11828),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11828),
    [anon_sym_LT_EQ_GT] = ACTIONS(11828),
    [anon_sym_EQ_TILDE] = ACTIONS(11828),
    [anon_sym_BANG_TILDE] = ACTIONS(11828),
    [anon_sym_LT_EQ] = ACTIONS(11820),
    [anon_sym_GT] = ACTIONS(11820),
    [anon_sym_GT_EQ] = ACTIONS(11834),
    [anon_sym_CARET] = ACTIONS(11836),
    [anon_sym_PLUS] = ACTIONS(11812),
    [anon_sym_SLASH] = ACTIONS(11814),
    [anon_sym_PERCENT] = ACTIONS(11814),
    [sym_comment] = ACTIONS(87),
  },
  [9856] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11812),
    [sym__binary_star] = ACTIONS(11814),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(11814),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(11812),
    [anon_sym_SLASH] = ACTIONS(11814),
    [anon_sym_PERCENT] = ACTIONS(11814),
    [sym_comment] = ACTIONS(87),
  },
  [9857] = {
    [aux_sym_exceptions_repeat1] = STATE(9857),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_COMMA] = ACTIONS(14386),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_end] = ACTIONS(11597),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [9858] = {
    [aux_sym_exceptions_repeat1] = STATE(8312),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_end] = ACTIONS(6191),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [9859] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(11812),
    [sym__binary_star] = ACTIONS(11814),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(11816),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(11814),
    [anon_sym_AMP] = ACTIONS(11818),
    [anon_sym_LT] = ACTIONS(11820),
    [anon_sym_end] = ACTIONS(6210),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(11822),
    [anon_sym_DOT_DOT] = ACTIONS(11824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11826),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(11828),
    [anon_sym_AMP_AMP] = ACTIONS(11828),
    [anon_sym_LT_LT] = ACTIONS(11830),
    [anon_sym_GT_GT] = ACTIONS(11830),
    [anon_sym_EQ_EQ] = ACTIONS(11832),
    [anon_sym_BANG_EQ] = ACTIONS(11828),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11828),
    [anon_sym_LT_EQ_GT] = ACTIONS(11828),
    [anon_sym_EQ_TILDE] = ACTIONS(11828),
    [anon_sym_BANG_TILDE] = ACTIONS(11828),
    [anon_sym_LT_EQ] = ACTIONS(11820),
    [anon_sym_GT] = ACTIONS(11820),
    [anon_sym_GT_EQ] = ACTIONS(11834),
    [anon_sym_CARET] = ACTIONS(11836),
    [anon_sym_PLUS] = ACTIONS(11812),
    [anon_sym_SLASH] = ACTIONS(11814),
    [anon_sym_PERCENT] = ACTIONS(11814),
    [sym_comment] = ACTIONS(87),
  },
  [9860] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10686),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(3256),
    [sym_scope_resolution] = STATE(3254),
    [sym_call] = STATE(3254),
    [sym_method_call] = STATE(3256),
    [sym_assignment] = STATE(10686),
    [sym_operator_assignment] = STATE(10686),
    [sym_conditional] = STATE(10686),
    [sym_range] = STATE(10686),
    [sym_binary] = STATE(10686),
    [sym_unary] = STATE(10686),
    [sym_left_assignment_list] = STATE(3255),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3256),
    [sym__variable] = STATE(3254),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(3256),
    [sym_false] = STATE(3256),
    [sym_nil] = STATE(3256),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(3257),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(5413),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(5415),
    [anon_sym_yield] = ACTIONS(5417),
    [anon_sym_break] = ACTIONS(5419),
    [anon_sym_next] = ACTIONS(5421),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(5423),
    [anon_sym_defined_QMARK] = ACTIONS(5425),
    [anon_sym_not] = ACTIONS(5427),
    [anon_sym_BANG] = ACTIONS(5429),
    [anon_sym_TILDE] = ACTIONS(5429),
    [sym_constant] = ACTIONS(5431),
    [sym_identifier] = ACTIONS(5431),
    [sym_instance_variable] = ACTIONS(5433),
    [sym_class_variable] = ACTIONS(5433),
    [sym_global_variable] = ACTIONS(5433),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(5431),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5431),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [9861] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(8327),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(3256),
    [sym_scope_resolution] = STATE(3254),
    [sym_call] = STATE(3254),
    [sym_method_call] = STATE(3256),
    [sym_splat_argument] = STATE(10067),
    [sym_assignment] = STATE(8327),
    [sym_operator_assignment] = STATE(8327),
    [sym_conditional] = STATE(8327),
    [sym_range] = STATE(8327),
    [sym_binary] = STATE(8327),
    [sym_unary] = STATE(8327),
    [sym__arg_or_splat_arg] = STATE(10067),
    [sym_left_assignment_list] = STATE(3255),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3256),
    [sym__variable] = STATE(3254),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(3256),
    [sym_false] = STATE(3256),
    [sym_nil] = STATE(3256),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(3257),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__splat_star] = ACTIONS(2215),
    [sym__unary_minus] = ACTIONS(5413),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(5415),
    [anon_sym_yield] = ACTIONS(5417),
    [anon_sym_break] = ACTIONS(5419),
    [anon_sym_next] = ACTIONS(5421),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(5423),
    [anon_sym_defined_QMARK] = ACTIONS(5425),
    [anon_sym_not] = ACTIONS(5427),
    [anon_sym_BANG] = ACTIONS(5429),
    [anon_sym_TILDE] = ACTIONS(5429),
    [sym_constant] = ACTIONS(5431),
    [sym_identifier] = ACTIONS(5431),
    [sym_instance_variable] = ACTIONS(5433),
    [sym_class_variable] = ACTIONS(5433),
    [sym_global_variable] = ACTIONS(5433),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(5431),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5431),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [9862] = {
    [aux_sym_exceptions_repeat1] = STATE(10687),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_LBRACE] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(14389),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9857),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_EQ] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_end] = ACTIONS(9855),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_do] = ACTIONS(9855),
    [anon_sym_else] = ACTIONS(9855),
    [anon_sym_ensure] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_PLUS_EQ] = ACTIONS(9855),
    [anon_sym_DASH_EQ] = ACTIONS(9855),
    [anon_sym_STAR_EQ] = ACTIONS(9855),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9855),
    [anon_sym_SLASH_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9855),
    [anon_sym_AMP_EQ] = ACTIONS(9855),
    [anon_sym_PERCENT_EQ] = ACTIONS(9855),
    [anon_sym_GT_GT_EQ] = ACTIONS(9855),
    [anon_sym_LT_LT_EQ] = ACTIONS(9855),
    [anon_sym_CARET_EQ] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9857),
    [anon_sym_AMP_AMP] = ACTIONS(9857),
    [anon_sym_LT_LT] = ACTIONS(9857),
    [anon_sym_GT_GT] = ACTIONS(9857),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9857),
    [anon_sym_PLUS] = ACTIONS(9857),
    [anon_sym_SLASH] = ACTIONS(9857),
    [anon_sym_PERCENT] = ACTIONS(9857),
    [sym_comment] = ACTIONS(87),
  },
  [9863] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(5441),
    [sym__binary_star] = ACTIONS(5443),
    [anon_sym_LBRACE] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(5445),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(5447),
    [anon_sym_AMP] = ACTIONS(5449),
    [anon_sym_EQ] = ACTIONS(12879),
    [anon_sym_LT] = ACTIONS(5451),
    [anon_sym_end] = ACTIONS(12120),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_else] = ACTIONS(12120),
    [anon_sym_ensure] = ACTIONS(12120),
    [anon_sym_EQ_GT] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_PLUS_EQ] = ACTIONS(12120),
    [anon_sym_DASH_EQ] = ACTIONS(12120),
    [anon_sym_STAR_EQ] = ACTIONS(12120),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12120),
    [anon_sym_SLASH_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12120),
    [anon_sym_AMP_EQ] = ACTIONS(12120),
    [anon_sym_PERCENT_EQ] = ACTIONS(12120),
    [anon_sym_GT_GT_EQ] = ACTIONS(12120),
    [anon_sym_LT_LT_EQ] = ACTIONS(12120),
    [anon_sym_CARET_EQ] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(5453),
    [anon_sym_DOT_DOT] = ACTIONS(5455),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5457),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(5459),
    [anon_sym_AMP_AMP] = ACTIONS(5459),
    [anon_sym_LT_LT] = ACTIONS(5461),
    [anon_sym_GT_GT] = ACTIONS(5461),
    [anon_sym_EQ_EQ] = ACTIONS(5459),
    [anon_sym_BANG_EQ] = ACTIONS(5463),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5463),
    [anon_sym_LT_EQ_GT] = ACTIONS(5463),
    [anon_sym_EQ_TILDE] = ACTIONS(5463),
    [anon_sym_BANG_TILDE] = ACTIONS(5463),
    [anon_sym_LT_EQ] = ACTIONS(5451),
    [anon_sym_GT] = ACTIONS(5451),
    [anon_sym_GT_EQ] = ACTIONS(5465),
    [anon_sym_CARET] = ACTIONS(5445),
    [anon_sym_PLUS] = ACTIONS(5467),
    [anon_sym_SLASH] = ACTIONS(5447),
    [anon_sym_PERCENT] = ACTIONS(5447),
    [sym_comment] = ACTIONS(87),
  },
  [9864] = {
    [aux_sym_exceptions_repeat1] = STATE(9864),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(14391),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_end] = ACTIONS(11597),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_else] = ACTIONS(11597),
    [anon_sym_ensure] = ACTIONS(11597),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_PLUS_EQ] = ACTIONS(11597),
    [anon_sym_DASH_EQ] = ACTIONS(11597),
    [anon_sym_STAR_EQ] = ACTIONS(11597),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11597),
    [anon_sym_SLASH_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11597),
    [anon_sym_AMP_EQ] = ACTIONS(11597),
    [anon_sym_PERCENT_EQ] = ACTIONS(11597),
    [anon_sym_GT_GT_EQ] = ACTIONS(11597),
    [anon_sym_LT_LT_EQ] = ACTIONS(11597),
    [anon_sym_CARET_EQ] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_LT] = ACTIONS(12338),
    [anon_sym_GT_GT] = ACTIONS(12338),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(12338),
    [anon_sym_PLUS] = ACTIONS(12338),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [9865] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10688),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(3288),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(3288),
    [sym_assignment] = STATE(10688),
    [sym_operator_assignment] = STATE(10688),
    [sym_conditional] = STATE(10688),
    [sym_range] = STATE(10688),
    [sym_binary] = STATE(10688),
    [sym_unary] = STATE(10688),
    [sym_left_assignment_list] = STATE(3287),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3288),
    [sym__variable] = STATE(291),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(3288),
    [sym_false] = STATE(3288),
    [sym_nil] = STATE(3288),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(3000),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(5481),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5003),
    [anon_sym_yield] = ACTIONS(5005),
    [anon_sym_break] = ACTIONS(5007),
    [anon_sym_next] = ACTIONS(5009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5483),
    [anon_sym_defined_QMARK] = ACTIONS(5485),
    [anon_sym_not] = ACTIONS(5487),
    [anon_sym_BANG] = ACTIONS(5489),
    [anon_sym_TILDE] = ACTIONS(5489),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9866] = {
    [sym__heredoc_body_start] = ACTIONS(12555),
    [sym__binary_minus] = ACTIONS(12555),
    [sym__binary_star] = ACTIONS(12555),
    [anon_sym_LBRACE] = ACTIONS(12555),
    [anon_sym_RBRACE] = ACTIONS(12555),
    [anon_sym_RPAREN] = ACTIONS(12555),
    [anon_sym_DOT] = ACTIONS(12557),
    [anon_sym_COMMA] = ACTIONS(12555),
    [anon_sym_PIPE] = ACTIONS(12557),
    [anon_sym_SEMI] = ACTIONS(12555),
    [anon_sym_STAR_STAR] = ACTIONS(12555),
    [anon_sym_AMP] = ACTIONS(12557),
    [anon_sym_EQ] = ACTIONS(12557),
    [anon_sym_LT] = ACTIONS(12557),
    [anon_sym_if] = ACTIONS(12555),
    [anon_sym_unless] = ACTIONS(12555),
    [anon_sym_while] = ACTIONS(12555),
    [anon_sym_until] = ACTIONS(12555),
    [anon_sym_rescue] = ACTIONS(12555),
    [anon_sym_in] = ACTIONS(12555),
    [anon_sym_do] = ACTIONS(12555),
    [anon_sym_EQ_GT] = ACTIONS(12555),
    [anon_sym_LBRACK] = ACTIONS(12555),
    [anon_sym_RBRACK] = ACTIONS(12555),
    [anon_sym_COLON_COLON2] = ACTIONS(12555),
    [anon_sym_AMP_DOT] = ACTIONS(12555),
    [anon_sym_QMARK] = ACTIONS(12555),
    [anon_sym_COLON2] = ACTIONS(12557),
    [anon_sym_DOT_DOT] = ACTIONS(12557),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12555),
    [anon_sym_and] = ACTIONS(12555),
    [anon_sym_or] = ACTIONS(12555),
    [anon_sym_PIPE_PIPE] = ACTIONS(12555),
    [anon_sym_AMP_AMP] = ACTIONS(12555),
    [anon_sym_LT_LT] = ACTIONS(12555),
    [anon_sym_GT_GT] = ACTIONS(12555),
    [anon_sym_EQ_EQ] = ACTIONS(12557),
    [anon_sym_BANG_EQ] = ACTIONS(12555),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12555),
    [anon_sym_LT_EQ_GT] = ACTIONS(12555),
    [anon_sym_EQ_TILDE] = ACTIONS(12555),
    [anon_sym_BANG_TILDE] = ACTIONS(12555),
    [anon_sym_LT_EQ] = ACTIONS(12557),
    [anon_sym_GT] = ACTIONS(12557),
    [anon_sym_GT_EQ] = ACTIONS(12555),
    [anon_sym_CARET] = ACTIONS(12555),
    [anon_sym_PLUS] = ACTIONS(12555),
    [anon_sym_SLASH] = ACTIONS(12555),
    [anon_sym_PERCENT] = ACTIONS(12555),
    [sym_comment] = ACTIONS(87),
  },
  [9867] = {
    [sym__heredoc_body_start] = ACTIONS(12559),
    [sym__binary_minus] = ACTIONS(12559),
    [sym__binary_star] = ACTIONS(12559),
    [anon_sym_LBRACE] = ACTIONS(12559),
    [anon_sym_RBRACE] = ACTIONS(12559),
    [anon_sym_RPAREN] = ACTIONS(12559),
    [anon_sym_DOT] = ACTIONS(12561),
    [anon_sym_COMMA] = ACTIONS(12559),
    [anon_sym_PIPE] = ACTIONS(12561),
    [anon_sym_SEMI] = ACTIONS(12559),
    [anon_sym_STAR_STAR] = ACTIONS(12559),
    [anon_sym_AMP] = ACTIONS(12561),
    [anon_sym_EQ] = ACTIONS(12561),
    [anon_sym_LT] = ACTIONS(12561),
    [anon_sym_if] = ACTIONS(12559),
    [anon_sym_unless] = ACTIONS(12559),
    [anon_sym_while] = ACTIONS(12559),
    [anon_sym_until] = ACTIONS(12559),
    [anon_sym_rescue] = ACTIONS(12559),
    [anon_sym_in] = ACTIONS(12559),
    [anon_sym_do] = ACTIONS(12559),
    [anon_sym_EQ_GT] = ACTIONS(12559),
    [anon_sym_LBRACK] = ACTIONS(12559),
    [anon_sym_RBRACK] = ACTIONS(12559),
    [anon_sym_COLON_COLON2] = ACTIONS(12559),
    [anon_sym_AMP_DOT] = ACTIONS(12559),
    [anon_sym_QMARK] = ACTIONS(12559),
    [anon_sym_COLON2] = ACTIONS(12561),
    [anon_sym_DOT_DOT] = ACTIONS(12561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12559),
    [anon_sym_and] = ACTIONS(12559),
    [anon_sym_or] = ACTIONS(12559),
    [anon_sym_PIPE_PIPE] = ACTIONS(12559),
    [anon_sym_AMP_AMP] = ACTIONS(12559),
    [anon_sym_LT_LT] = ACTIONS(12559),
    [anon_sym_GT_GT] = ACTIONS(12559),
    [anon_sym_EQ_EQ] = ACTIONS(12561),
    [anon_sym_BANG_EQ] = ACTIONS(12559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12559),
    [anon_sym_LT_EQ_GT] = ACTIONS(12559),
    [anon_sym_EQ_TILDE] = ACTIONS(12559),
    [anon_sym_BANG_TILDE] = ACTIONS(12559),
    [anon_sym_LT_EQ] = ACTIONS(12561),
    [anon_sym_GT] = ACTIONS(12561),
    [anon_sym_GT_EQ] = ACTIONS(12559),
    [anon_sym_CARET] = ACTIONS(12559),
    [anon_sym_PLUS] = ACTIONS(12559),
    [anon_sym_SLASH] = ACTIONS(12559),
    [anon_sym_PERCENT] = ACTIONS(12559),
    [sym_comment] = ACTIONS(87),
  },
  [9868] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(11871),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(11871),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_RBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(11871),
    [anon_sym_PERCENT] = ACTIONS(11871),
    [sym_comment] = ACTIONS(87),
  },
  [9869] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(11871),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_RBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [9870] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11869),
    [sym__binary_star] = ACTIONS(11871),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(11871),
    [anon_sym_AMP] = ACTIONS(11875),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_RBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(11887),
    [anon_sym_GT_GT] = ACTIONS(11887),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(11869),
    [anon_sym_SLASH] = ACTIONS(11871),
    [anon_sym_PERCENT] = ACTIONS(11871),
    [sym_comment] = ACTIONS(87),
  },
  [9871] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11869),
    [sym__binary_star] = ACTIONS(11871),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(11871),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_RBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(11887),
    [anon_sym_GT_GT] = ACTIONS(11887),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(11869),
    [anon_sym_SLASH] = ACTIONS(11871),
    [anon_sym_PERCENT] = ACTIONS(11871),
    [sym_comment] = ACTIONS(87),
  },
  [9872] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11869),
    [sym__binary_star] = ACTIONS(11871),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(11873),
    [anon_sym_STAR_STAR] = ACTIONS(11871),
    [anon_sym_AMP] = ACTIONS(11875),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_RBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(11887),
    [anon_sym_GT_GT] = ACTIONS(11887),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(11893),
    [anon_sym_PLUS] = ACTIONS(11869),
    [anon_sym_SLASH] = ACTIONS(11871),
    [anon_sym_PERCENT] = ACTIONS(11871),
    [sym_comment] = ACTIONS(87),
  },
  [9873] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(14394),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [9874] = {
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(11869),
    [sym__binary_star] = ACTIONS(11871),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(11873),
    [anon_sym_STAR_STAR] = ACTIONS(11871),
    [anon_sym_AMP] = ACTIONS(11875),
    [anon_sym_LT] = ACTIONS(11877),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_RBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(11881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11883),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(11885),
    [anon_sym_AMP_AMP] = ACTIONS(11885),
    [anon_sym_LT_LT] = ACTIONS(11887),
    [anon_sym_GT_GT] = ACTIONS(11887),
    [anon_sym_EQ_EQ] = ACTIONS(11889),
    [anon_sym_BANG_EQ] = ACTIONS(11885),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11885),
    [anon_sym_LT_EQ_GT] = ACTIONS(11885),
    [anon_sym_EQ_TILDE] = ACTIONS(11885),
    [anon_sym_BANG_TILDE] = ACTIONS(11885),
    [anon_sym_LT_EQ] = ACTIONS(11877),
    [anon_sym_GT] = ACTIONS(11877),
    [anon_sym_GT_EQ] = ACTIONS(11891),
    [anon_sym_CARET] = ACTIONS(11893),
    [anon_sym_PLUS] = ACTIONS(11869),
    [anon_sym_SLASH] = ACTIONS(11871),
    [anon_sym_PERCENT] = ACTIONS(11871),
    [sym_comment] = ACTIONS(87),
  },
  [9875] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11869),
    [sym__binary_star] = ACTIONS(11871),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(11873),
    [anon_sym_STAR_STAR] = ACTIONS(11871),
    [anon_sym_AMP] = ACTIONS(11875),
    [anon_sym_LT] = ACTIONS(11877),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_RBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(11879),
    [anon_sym_DOT_DOT] = ACTIONS(11881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11883),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(11885),
    [anon_sym_AMP_AMP] = ACTIONS(11885),
    [anon_sym_LT_LT] = ACTIONS(11887),
    [anon_sym_GT_GT] = ACTIONS(11887),
    [anon_sym_EQ_EQ] = ACTIONS(11889),
    [anon_sym_BANG_EQ] = ACTIONS(11885),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11885),
    [anon_sym_LT_EQ_GT] = ACTIONS(11885),
    [anon_sym_EQ_TILDE] = ACTIONS(11885),
    [anon_sym_BANG_TILDE] = ACTIONS(11885),
    [anon_sym_LT_EQ] = ACTIONS(11877),
    [anon_sym_GT] = ACTIONS(11877),
    [anon_sym_GT_EQ] = ACTIONS(11891),
    [anon_sym_CARET] = ACTIONS(11893),
    [anon_sym_PLUS] = ACTIONS(11869),
    [anon_sym_SLASH] = ACTIONS(11871),
    [anon_sym_PERCENT] = ACTIONS(11871),
    [sym_comment] = ACTIONS(87),
  },
  [9876] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11869),
    [sym__binary_star] = ACTIONS(11871),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(11873),
    [anon_sym_STAR_STAR] = ACTIONS(11871),
    [anon_sym_AMP] = ACTIONS(11875),
    [anon_sym_LT] = ACTIONS(11877),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_RBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(11887),
    [anon_sym_GT_GT] = ACTIONS(11887),
    [anon_sym_EQ_EQ] = ACTIONS(11889),
    [anon_sym_BANG_EQ] = ACTIONS(11885),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11885),
    [anon_sym_LT_EQ_GT] = ACTIONS(11885),
    [anon_sym_EQ_TILDE] = ACTIONS(11885),
    [anon_sym_BANG_TILDE] = ACTIONS(11885),
    [anon_sym_LT_EQ] = ACTIONS(11877),
    [anon_sym_GT] = ACTIONS(11877),
    [anon_sym_GT_EQ] = ACTIONS(11891),
    [anon_sym_CARET] = ACTIONS(11893),
    [anon_sym_PLUS] = ACTIONS(11869),
    [anon_sym_SLASH] = ACTIONS(11871),
    [anon_sym_PERCENT] = ACTIONS(11871),
    [sym_comment] = ACTIONS(87),
  },
  [9877] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11869),
    [sym__binary_star] = ACTIONS(11871),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(11871),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_RBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(11869),
    [anon_sym_SLASH] = ACTIONS(11871),
    [anon_sym_PERCENT] = ACTIONS(11871),
    [sym_comment] = ACTIONS(87),
  },
  [9878] = {
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(11869),
    [sym__binary_star] = ACTIONS(11871),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(11873),
    [anon_sym_STAR_STAR] = ACTIONS(11871),
    [anon_sym_AMP] = ACTIONS(11875),
    [anon_sym_LT] = ACTIONS(11877),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_RBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(11879),
    [anon_sym_DOT_DOT] = ACTIONS(11881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11883),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(11885),
    [anon_sym_AMP_AMP] = ACTIONS(11885),
    [anon_sym_LT_LT] = ACTIONS(11887),
    [anon_sym_GT_GT] = ACTIONS(11887),
    [anon_sym_EQ_EQ] = ACTIONS(11889),
    [anon_sym_BANG_EQ] = ACTIONS(11885),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11885),
    [anon_sym_LT_EQ_GT] = ACTIONS(11885),
    [anon_sym_EQ_TILDE] = ACTIONS(11885),
    [anon_sym_BANG_TILDE] = ACTIONS(11885),
    [anon_sym_LT_EQ] = ACTIONS(11877),
    [anon_sym_GT] = ACTIONS(11877),
    [anon_sym_GT_EQ] = ACTIONS(11891),
    [anon_sym_CARET] = ACTIONS(11893),
    [anon_sym_PLUS] = ACTIONS(11869),
    [anon_sym_SLASH] = ACTIONS(11871),
    [anon_sym_PERCENT] = ACTIONS(11871),
    [sym_comment] = ACTIONS(87),
  },
  [9879] = {
    [aux_sym_exceptions_repeat1] = STATE(10691),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_RBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [9880] = {
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(11869),
    [sym__binary_star] = ACTIONS(11871),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(11873),
    [anon_sym_STAR_STAR] = ACTIONS(11871),
    [anon_sym_AMP] = ACTIONS(11875),
    [anon_sym_LT] = ACTIONS(11877),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_RBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(11879),
    [anon_sym_DOT_DOT] = ACTIONS(11881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11883),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(11885),
    [anon_sym_AMP_AMP] = ACTIONS(11885),
    [anon_sym_LT_LT] = ACTIONS(11887),
    [anon_sym_GT_GT] = ACTIONS(11887),
    [anon_sym_EQ_EQ] = ACTIONS(11889),
    [anon_sym_BANG_EQ] = ACTIONS(11885),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11885),
    [anon_sym_LT_EQ_GT] = ACTIONS(11885),
    [anon_sym_EQ_TILDE] = ACTIONS(11885),
    [anon_sym_BANG_TILDE] = ACTIONS(11885),
    [anon_sym_LT_EQ] = ACTIONS(11877),
    [anon_sym_GT] = ACTIONS(11877),
    [anon_sym_GT_EQ] = ACTIONS(11891),
    [anon_sym_CARET] = ACTIONS(11893),
    [anon_sym_PLUS] = ACTIONS(11869),
    [anon_sym_SLASH] = ACTIONS(11871),
    [anon_sym_PERCENT] = ACTIONS(11871),
    [sym_comment] = ACTIONS(87),
  },
  [9881] = {
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(5535),
    [sym__binary_star] = ACTIONS(5537),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5537),
    [anon_sym_AMP] = ACTIONS(5541),
    [anon_sym_LT] = ACTIONS(5543),
    [anon_sym_RBRACK] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(5545),
    [anon_sym_DOT_DOT] = ACTIONS(5547),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5549),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(5553),
    [anon_sym_AMP_AMP] = ACTIONS(5553),
    [anon_sym_LT_LT] = ACTIONS(5555),
    [anon_sym_GT_GT] = ACTIONS(5555),
    [anon_sym_EQ_EQ] = ACTIONS(5557),
    [anon_sym_BANG_EQ] = ACTIONS(5553),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5553),
    [anon_sym_LT_EQ_GT] = ACTIONS(5553),
    [anon_sym_EQ_TILDE] = ACTIONS(5553),
    [anon_sym_BANG_TILDE] = ACTIONS(5553),
    [anon_sym_LT_EQ] = ACTIONS(5543),
    [anon_sym_GT] = ACTIONS(5543),
    [anon_sym_GT_EQ] = ACTIONS(5559),
    [anon_sym_CARET] = ACTIONS(5561),
    [anon_sym_PLUS] = ACTIONS(5535),
    [anon_sym_SLASH] = ACTIONS(5537),
    [anon_sym_PERCENT] = ACTIONS(5537),
    [sym_comment] = ACTIONS(87),
  },
  [9882] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(11907),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(11911),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_RBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(11911),
    [anon_sym_PERCENT] = ACTIONS(11911),
    [sym_comment] = ACTIONS(87),
  },
  [9883] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(11911),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_RBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(5827),
    [anon_sym_PERCENT] = ACTIONS(5827),
    [sym_comment] = ACTIONS(87),
  },
  [9884] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11905),
    [sym__binary_star] = ACTIONS(11907),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(11911),
    [anon_sym_AMP] = ACTIONS(11913),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_RBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(11925),
    [anon_sym_GT_GT] = ACTIONS(11925),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(11931),
    [anon_sym_SLASH] = ACTIONS(11911),
    [anon_sym_PERCENT] = ACTIONS(11911),
    [sym_comment] = ACTIONS(87),
  },
  [9885] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11905),
    [sym__binary_star] = ACTIONS(11907),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(11911),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_RBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(11925),
    [anon_sym_GT_GT] = ACTIONS(11925),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(11931),
    [anon_sym_SLASH] = ACTIONS(11911),
    [anon_sym_PERCENT] = ACTIONS(11911),
    [sym_comment] = ACTIONS(87),
  },
  [9886] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11905),
    [sym__binary_star] = ACTIONS(11907),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(11909),
    [anon_sym_STAR_STAR] = ACTIONS(11911),
    [anon_sym_AMP] = ACTIONS(11913),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_RBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(11925),
    [anon_sym_GT_GT] = ACTIONS(11925),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(11909),
    [anon_sym_PLUS] = ACTIONS(11931),
    [anon_sym_SLASH] = ACTIONS(11911),
    [anon_sym_PERCENT] = ACTIONS(11911),
    [sym_comment] = ACTIONS(87),
  },
  [9887] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(14396),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [9888] = {
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(11905),
    [sym__binary_star] = ACTIONS(11907),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(11909),
    [anon_sym_STAR_STAR] = ACTIONS(11911),
    [anon_sym_AMP] = ACTIONS(11913),
    [anon_sym_EQ] = ACTIONS(7888),
    [anon_sym_LT] = ACTIONS(11915),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_RBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_PLUS_EQ] = ACTIONS(5927),
    [anon_sym_DASH_EQ] = ACTIONS(5927),
    [anon_sym_STAR_EQ] = ACTIONS(5927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5927),
    [anon_sym_SLASH_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5927),
    [anon_sym_AMP_EQ] = ACTIONS(5927),
    [anon_sym_PERCENT_EQ] = ACTIONS(5927),
    [anon_sym_GT_GT_EQ] = ACTIONS(5927),
    [anon_sym_LT_LT_EQ] = ACTIONS(5927),
    [anon_sym_CARET_EQ] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(11919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11921),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(11923),
    [anon_sym_AMP_AMP] = ACTIONS(11923),
    [anon_sym_LT_LT] = ACTIONS(11925),
    [anon_sym_GT_GT] = ACTIONS(11925),
    [anon_sym_EQ_EQ] = ACTIONS(11923),
    [anon_sym_BANG_EQ] = ACTIONS(11927),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11927),
    [anon_sym_LT_EQ_GT] = ACTIONS(11927),
    [anon_sym_EQ_TILDE] = ACTIONS(11927),
    [anon_sym_BANG_TILDE] = ACTIONS(11927),
    [anon_sym_LT_EQ] = ACTIONS(11915),
    [anon_sym_GT] = ACTIONS(11915),
    [anon_sym_GT_EQ] = ACTIONS(11929),
    [anon_sym_CARET] = ACTIONS(11909),
    [anon_sym_PLUS] = ACTIONS(11931),
    [anon_sym_SLASH] = ACTIONS(11911),
    [anon_sym_PERCENT] = ACTIONS(11911),
    [sym_comment] = ACTIONS(87),
  },
  [9889] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11905),
    [sym__binary_star] = ACTIONS(11907),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(11909),
    [anon_sym_STAR_STAR] = ACTIONS(11911),
    [anon_sym_AMP] = ACTIONS(11913),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(11915),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_RBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(11917),
    [anon_sym_DOT_DOT] = ACTIONS(11919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11921),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(11923),
    [anon_sym_AMP_AMP] = ACTIONS(11923),
    [anon_sym_LT_LT] = ACTIONS(11925),
    [anon_sym_GT_GT] = ACTIONS(11925),
    [anon_sym_EQ_EQ] = ACTIONS(11923),
    [anon_sym_BANG_EQ] = ACTIONS(11927),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11927),
    [anon_sym_LT_EQ_GT] = ACTIONS(11927),
    [anon_sym_EQ_TILDE] = ACTIONS(11927),
    [anon_sym_BANG_TILDE] = ACTIONS(11927),
    [anon_sym_LT_EQ] = ACTIONS(11915),
    [anon_sym_GT] = ACTIONS(11915),
    [anon_sym_GT_EQ] = ACTIONS(11929),
    [anon_sym_CARET] = ACTIONS(11909),
    [anon_sym_PLUS] = ACTIONS(11931),
    [anon_sym_SLASH] = ACTIONS(11911),
    [anon_sym_PERCENT] = ACTIONS(11911),
    [sym_comment] = ACTIONS(87),
  },
  [9890] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11905),
    [sym__binary_star] = ACTIONS(11907),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(11909),
    [anon_sym_STAR_STAR] = ACTIONS(11911),
    [anon_sym_AMP] = ACTIONS(11913),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(11915),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_RBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(11925),
    [anon_sym_GT_GT] = ACTIONS(11925),
    [anon_sym_EQ_EQ] = ACTIONS(11923),
    [anon_sym_BANG_EQ] = ACTIONS(11927),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11927),
    [anon_sym_LT_EQ_GT] = ACTIONS(11927),
    [anon_sym_EQ_TILDE] = ACTIONS(11927),
    [anon_sym_BANG_TILDE] = ACTIONS(11927),
    [anon_sym_LT_EQ] = ACTIONS(11915),
    [anon_sym_GT] = ACTIONS(11915),
    [anon_sym_GT_EQ] = ACTIONS(11929),
    [anon_sym_CARET] = ACTIONS(11909),
    [anon_sym_PLUS] = ACTIONS(11931),
    [anon_sym_SLASH] = ACTIONS(11911),
    [anon_sym_PERCENT] = ACTIONS(11911),
    [sym_comment] = ACTIONS(87),
  },
  [9891] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(11905),
    [sym__binary_star] = ACTIONS(11907),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(11911),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_RBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(11931),
    [anon_sym_SLASH] = ACTIONS(11911),
    [anon_sym_PERCENT] = ACTIONS(11911),
    [sym_comment] = ACTIONS(87),
  },
  [9892] = {
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(11905),
    [sym__binary_star] = ACTIONS(11907),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(11909),
    [anon_sym_STAR_STAR] = ACTIONS(11911),
    [anon_sym_AMP] = ACTIONS(11913),
    [anon_sym_EQ] = ACTIONS(7936),
    [anon_sym_LT] = ACTIONS(11915),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_RBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_PLUS_EQ] = ACTIONS(5115),
    [anon_sym_DASH_EQ] = ACTIONS(5115),
    [anon_sym_STAR_EQ] = ACTIONS(5115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5115),
    [anon_sym_SLASH_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5115),
    [anon_sym_AMP_EQ] = ACTIONS(5115),
    [anon_sym_PERCENT_EQ] = ACTIONS(5115),
    [anon_sym_GT_GT_EQ] = ACTIONS(5115),
    [anon_sym_LT_LT_EQ] = ACTIONS(5115),
    [anon_sym_CARET_EQ] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(11917),
    [anon_sym_DOT_DOT] = ACTIONS(11919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11921),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(11923),
    [anon_sym_AMP_AMP] = ACTIONS(11923),
    [anon_sym_LT_LT] = ACTIONS(11925),
    [anon_sym_GT_GT] = ACTIONS(11925),
    [anon_sym_EQ_EQ] = ACTIONS(11923),
    [anon_sym_BANG_EQ] = ACTIONS(11927),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11927),
    [anon_sym_LT_EQ_GT] = ACTIONS(11927),
    [anon_sym_EQ_TILDE] = ACTIONS(11927),
    [anon_sym_BANG_TILDE] = ACTIONS(11927),
    [anon_sym_LT_EQ] = ACTIONS(11915),
    [anon_sym_GT] = ACTIONS(11915),
    [anon_sym_GT_EQ] = ACTIONS(11929),
    [anon_sym_CARET] = ACTIONS(11909),
    [anon_sym_PLUS] = ACTIONS(11931),
    [anon_sym_SLASH] = ACTIONS(11911),
    [anon_sym_PERCENT] = ACTIONS(11911),
    [sym_comment] = ACTIONS(87),
  },
  [9893] = {
    [aux_sym_exceptions_repeat1] = STATE(10694),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_STAR_STAR] = ACTIONS(6193),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_RBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_PLUS_EQ] = ACTIONS(6191),
    [anon_sym_DASH_EQ] = ACTIONS(6191),
    [anon_sym_STAR_EQ] = ACTIONS(6191),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6191),
    [anon_sym_SLASH_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6191),
    [anon_sym_AMP_EQ] = ACTIONS(6191),
    [anon_sym_PERCENT_EQ] = ACTIONS(6191),
    [anon_sym_GT_GT_EQ] = ACTIONS(6191),
    [anon_sym_LT_LT_EQ] = ACTIONS(6191),
    [anon_sym_CARET_EQ] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6193),
    [anon_sym_AMP_AMP] = ACTIONS(6193),
    [anon_sym_LT_LT] = ACTIONS(6193),
    [anon_sym_GT_GT] = ACTIONS(6193),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6193),
    [anon_sym_PLUS] = ACTIONS(6193),
    [anon_sym_SLASH] = ACTIONS(6193),
    [anon_sym_PERCENT] = ACTIONS(6193),
    [sym_comment] = ACTIONS(87),
  },
  [9894] = {
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(11905),
    [sym__binary_star] = ACTIONS(11907),
    [anon_sym_LBRACE] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(11909),
    [anon_sym_STAR_STAR] = ACTIONS(11911),
    [anon_sym_AMP] = ACTIONS(11913),
    [anon_sym_EQ] = ACTIONS(7938),
    [anon_sym_LT] = ACTIONS(11915),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_RBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_PLUS_EQ] = ACTIONS(6210),
    [anon_sym_DASH_EQ] = ACTIONS(6210),
    [anon_sym_STAR_EQ] = ACTIONS(6210),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6210),
    [anon_sym_SLASH_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6210),
    [anon_sym_AMP_EQ] = ACTIONS(6210),
    [anon_sym_PERCENT_EQ] = ACTIONS(6210),
    [anon_sym_GT_GT_EQ] = ACTIONS(6210),
    [anon_sym_LT_LT_EQ] = ACTIONS(6210),
    [anon_sym_CARET_EQ] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(11917),
    [anon_sym_DOT_DOT] = ACTIONS(11919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11921),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(11923),
    [anon_sym_AMP_AMP] = ACTIONS(11923),
    [anon_sym_LT_LT] = ACTIONS(11925),
    [anon_sym_GT_GT] = ACTIONS(11925),
    [anon_sym_EQ_EQ] = ACTIONS(11923),
    [anon_sym_BANG_EQ] = ACTIONS(11927),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11927),
    [anon_sym_LT_EQ_GT] = ACTIONS(11927),
    [anon_sym_EQ_TILDE] = ACTIONS(11927),
    [anon_sym_BANG_TILDE] = ACTIONS(11927),
    [anon_sym_LT_EQ] = ACTIONS(11915),
    [anon_sym_GT] = ACTIONS(11915),
    [anon_sym_GT_EQ] = ACTIONS(11929),
    [anon_sym_CARET] = ACTIONS(11909),
    [anon_sym_PLUS] = ACTIONS(11931),
    [anon_sym_SLASH] = ACTIONS(11911),
    [anon_sym_PERCENT] = ACTIONS(11911),
    [sym_comment] = ACTIONS(87),
  },
  [9895] = {
    [sym_string] = STATE(9895),
    [aux_sym_chained_string_repeat1] = STATE(9895),
    [sym__string_start] = ACTIONS(13881),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_STAR_STAR] = ACTIONS(6217),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_EQ] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_do] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_RBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_PLUS_EQ] = ACTIONS(6212),
    [anon_sym_DASH_EQ] = ACTIONS(6212),
    [anon_sym_STAR_EQ] = ACTIONS(6212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6212),
    [anon_sym_SLASH_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6212),
    [anon_sym_AMP_EQ] = ACTIONS(6212),
    [anon_sym_PERCENT_EQ] = ACTIONS(6212),
    [anon_sym_GT_GT_EQ] = ACTIONS(6212),
    [anon_sym_LT_LT_EQ] = ACTIONS(6212),
    [anon_sym_CARET_EQ] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6217),
    [anon_sym_AMP_AMP] = ACTIONS(6217),
    [anon_sym_LT_LT] = ACTIONS(6217),
    [anon_sym_GT_GT] = ACTIONS(6217),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6217),
    [anon_sym_PLUS] = ACTIONS(6217),
    [anon_sym_SLASH] = ACTIONS(6217),
    [anon_sym_PERCENT] = ACTIONS(6217),
    [sym_comment] = ACTIONS(87),
  },
  [9896] = {
    [aux_sym_exceptions_repeat1] = STATE(9896),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_COMMA] = ACTIONS(14398),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_RBRACK] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [9897] = {
    [sym__heredoc_body_start] = ACTIONS(12663),
    [sym__binary_minus] = ACTIONS(12663),
    [sym__binary_star] = ACTIONS(12663),
    [anon_sym_LBRACE] = ACTIONS(12663),
    [anon_sym_RBRACE] = ACTIONS(12663),
    [anon_sym_RPAREN] = ACTIONS(12663),
    [anon_sym_DOT] = ACTIONS(12665),
    [anon_sym_COMMA] = ACTIONS(12663),
    [anon_sym_PIPE] = ACTIONS(12665),
    [anon_sym_SEMI] = ACTIONS(12663),
    [anon_sym_STAR_STAR] = ACTIONS(12663),
    [anon_sym_AMP] = ACTIONS(12665),
    [anon_sym_EQ] = ACTIONS(12665),
    [anon_sym_LT] = ACTIONS(12665),
    [anon_sym_if] = ACTIONS(12663),
    [anon_sym_unless] = ACTIONS(12663),
    [anon_sym_while] = ACTIONS(12663),
    [anon_sym_until] = ACTIONS(12663),
    [anon_sym_rescue] = ACTIONS(12663),
    [anon_sym_in] = ACTIONS(12663),
    [anon_sym_do] = ACTIONS(12663),
    [anon_sym_EQ_GT] = ACTIONS(12663),
    [anon_sym_LBRACK] = ACTIONS(12663),
    [anon_sym_RBRACK] = ACTIONS(12663),
    [anon_sym_COLON_COLON2] = ACTIONS(12663),
    [anon_sym_AMP_DOT] = ACTIONS(12663),
    [anon_sym_QMARK] = ACTIONS(12663),
    [anon_sym_COLON2] = ACTIONS(12665),
    [anon_sym_DOT_DOT] = ACTIONS(12665),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12663),
    [anon_sym_and] = ACTIONS(12663),
    [anon_sym_or] = ACTIONS(12663),
    [anon_sym_PIPE_PIPE] = ACTIONS(12663),
    [anon_sym_AMP_AMP] = ACTIONS(12663),
    [anon_sym_LT_LT] = ACTIONS(12663),
    [anon_sym_GT_GT] = ACTIONS(12663),
    [anon_sym_EQ_EQ] = ACTIONS(12665),
    [anon_sym_BANG_EQ] = ACTIONS(12663),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12663),
    [anon_sym_LT_EQ_GT] = ACTIONS(12663),
    [anon_sym_EQ_TILDE] = ACTIONS(12663),
    [anon_sym_BANG_TILDE] = ACTIONS(12663),
    [anon_sym_LT_EQ] = ACTIONS(12665),
    [anon_sym_GT] = ACTIONS(12665),
    [anon_sym_GT_EQ] = ACTIONS(12663),
    [anon_sym_CARET] = ACTIONS(12663),
    [anon_sym_PLUS] = ACTIONS(12663),
    [anon_sym_SLASH] = ACTIONS(12663),
    [anon_sym_PERCENT] = ACTIONS(12663),
    [sym_comment] = ACTIONS(87),
  },
  [9898] = {
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(5597),
    [sym__binary_star] = ACTIONS(5599),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(5601),
    [anon_sym_STAR_STAR] = ACTIONS(5599),
    [anon_sym_AMP] = ACTIONS(5603),
    [anon_sym_LT] = ACTIONS(5605),
    [anon_sym_EQ_GT] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_RBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(5607),
    [anon_sym_DOT_DOT] = ACTIONS(5609),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5611),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(5613),
    [anon_sym_AMP_AMP] = ACTIONS(5613),
    [anon_sym_LT_LT] = ACTIONS(5615),
    [anon_sym_GT_GT] = ACTIONS(5615),
    [anon_sym_EQ_EQ] = ACTIONS(5617),
    [anon_sym_BANG_EQ] = ACTIONS(5613),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5613),
    [anon_sym_LT_EQ_GT] = ACTIONS(5613),
    [anon_sym_EQ_TILDE] = ACTIONS(5613),
    [anon_sym_BANG_TILDE] = ACTIONS(5613),
    [anon_sym_LT_EQ] = ACTIONS(5605),
    [anon_sym_GT] = ACTIONS(5605),
    [anon_sym_GT_EQ] = ACTIONS(5619),
    [anon_sym_CARET] = ACTIONS(5621),
    [anon_sym_PLUS] = ACTIONS(5597),
    [anon_sym_SLASH] = ACTIONS(5599),
    [anon_sym_PERCENT] = ACTIONS(5599),
    [sym_comment] = ACTIONS(87),
  },
  [9899] = {
    [aux_sym_exceptions_repeat1] = STATE(9899),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(14401),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_RBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [9900] = {
    [sym__heredoc_body_start] = ACTIONS(13224),
    [sym__binary_minus] = ACTIONS(13224),
    [sym__binary_star] = ACTIONS(13224),
    [anon_sym_LBRACE] = ACTIONS(13224),
    [anon_sym_RBRACE] = ACTIONS(13224),
    [anon_sym_RPAREN] = ACTIONS(13224),
    [anon_sym_DOT] = ACTIONS(13226),
    [anon_sym_COMMA] = ACTIONS(13224),
    [anon_sym_PIPE] = ACTIONS(13226),
    [anon_sym_SEMI] = ACTIONS(13224),
    [anon_sym_STAR_STAR] = ACTIONS(13224),
    [anon_sym_AMP] = ACTIONS(13226),
    [anon_sym_EQ] = ACTIONS(13226),
    [anon_sym_LT] = ACTIONS(13226),
    [anon_sym_if] = ACTIONS(13224),
    [anon_sym_unless] = ACTIONS(13224),
    [anon_sym_while] = ACTIONS(13224),
    [anon_sym_until] = ACTIONS(13224),
    [anon_sym_rescue] = ACTIONS(13224),
    [anon_sym_in] = ACTIONS(13224),
    [anon_sym_do] = ACTIONS(13224),
    [anon_sym_EQ_GT] = ACTIONS(13224),
    [anon_sym_LBRACK] = ACTIONS(13224),
    [anon_sym_RBRACK] = ACTIONS(13224),
    [anon_sym_COLON_COLON2] = ACTIONS(13224),
    [anon_sym_AMP_DOT] = ACTIONS(13224),
    [anon_sym_QMARK] = ACTIONS(13224),
    [anon_sym_COLON2] = ACTIONS(13226),
    [anon_sym_DOT_DOT] = ACTIONS(13226),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13224),
    [anon_sym_and] = ACTIONS(13224),
    [anon_sym_or] = ACTIONS(13224),
    [anon_sym_PIPE_PIPE] = ACTIONS(13224),
    [anon_sym_AMP_AMP] = ACTIONS(13224),
    [anon_sym_LT_LT] = ACTIONS(13224),
    [anon_sym_GT_GT] = ACTIONS(13224),
    [anon_sym_EQ_EQ] = ACTIONS(13226),
    [anon_sym_BANG_EQ] = ACTIONS(13224),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13224),
    [anon_sym_LT_EQ_GT] = ACTIONS(13224),
    [anon_sym_EQ_TILDE] = ACTIONS(13224),
    [anon_sym_BANG_TILDE] = ACTIONS(13224),
    [anon_sym_LT_EQ] = ACTIONS(13226),
    [anon_sym_GT] = ACTIONS(13226),
    [anon_sym_GT_EQ] = ACTIONS(13224),
    [anon_sym_CARET] = ACTIONS(13224),
    [anon_sym_PLUS] = ACTIONS(13224),
    [anon_sym_SLASH] = ACTIONS(13224),
    [anon_sym_PERCENT] = ACTIONS(13224),
    [sym_comment] = ACTIONS(87),
  },
  [9901] = {
    [sym__heredoc_body_start] = ACTIONS(13235),
    [sym__binary_minus] = ACTIONS(13235),
    [sym__binary_star] = ACTIONS(13235),
    [anon_sym_LBRACE] = ACTIONS(13235),
    [anon_sym_RBRACE] = ACTIONS(13235),
    [anon_sym_RPAREN] = ACTIONS(13235),
    [anon_sym_DOT] = ACTIONS(13237),
    [anon_sym_COMMA] = ACTIONS(13235),
    [anon_sym_PIPE] = ACTIONS(13237),
    [anon_sym_SEMI] = ACTIONS(13235),
    [anon_sym_STAR_STAR] = ACTIONS(13235),
    [anon_sym_AMP] = ACTIONS(13237),
    [anon_sym_EQ] = ACTIONS(13237),
    [anon_sym_LT] = ACTIONS(13237),
    [anon_sym_if] = ACTIONS(13235),
    [anon_sym_unless] = ACTIONS(13235),
    [anon_sym_while] = ACTIONS(13235),
    [anon_sym_until] = ACTIONS(13235),
    [anon_sym_rescue] = ACTIONS(13235),
    [anon_sym_in] = ACTIONS(13235),
    [anon_sym_do] = ACTIONS(13235),
    [anon_sym_EQ_GT] = ACTIONS(13235),
    [anon_sym_LBRACK] = ACTIONS(13235),
    [anon_sym_RBRACK] = ACTIONS(13235),
    [anon_sym_COLON_COLON2] = ACTIONS(13235),
    [anon_sym_AMP_DOT] = ACTIONS(13235),
    [anon_sym_QMARK] = ACTIONS(13235),
    [anon_sym_COLON2] = ACTIONS(13237),
    [anon_sym_DOT_DOT] = ACTIONS(13237),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13235),
    [anon_sym_and] = ACTIONS(13235),
    [anon_sym_or] = ACTIONS(13235),
    [anon_sym_PIPE_PIPE] = ACTIONS(13235),
    [anon_sym_AMP_AMP] = ACTIONS(13235),
    [anon_sym_LT_LT] = ACTIONS(13235),
    [anon_sym_GT_GT] = ACTIONS(13235),
    [anon_sym_EQ_EQ] = ACTIONS(13237),
    [anon_sym_BANG_EQ] = ACTIONS(13235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13235),
    [anon_sym_LT_EQ_GT] = ACTIONS(13235),
    [anon_sym_EQ_TILDE] = ACTIONS(13235),
    [anon_sym_BANG_TILDE] = ACTIONS(13235),
    [anon_sym_LT_EQ] = ACTIONS(13237),
    [anon_sym_GT] = ACTIONS(13237),
    [anon_sym_GT_EQ] = ACTIONS(13235),
    [anon_sym_CARET] = ACTIONS(13235),
    [anon_sym_PLUS] = ACTIONS(13235),
    [anon_sym_SLASH] = ACTIONS(13235),
    [anon_sym_PERCENT] = ACTIONS(13235),
    [sym_comment] = ACTIONS(87),
  },
  [9902] = {
    [anon_sym_end] = ACTIONS(14404),
    [sym_comment] = ACTIONS(87),
  },
  [9903] = {
    [sym__heredoc_body_start] = ACTIONS(13547),
    [sym__binary_minus] = ACTIONS(13547),
    [sym__binary_star] = ACTIONS(13547),
    [anon_sym_LBRACE] = ACTIONS(13547),
    [anon_sym_RBRACE] = ACTIONS(13547),
    [anon_sym_RPAREN] = ACTIONS(13547),
    [anon_sym_DOT] = ACTIONS(13549),
    [anon_sym_COMMA] = ACTIONS(13547),
    [anon_sym_PIPE] = ACTIONS(13549),
    [anon_sym_SEMI] = ACTIONS(13547),
    [anon_sym_STAR_STAR] = ACTIONS(13547),
    [anon_sym_AMP] = ACTIONS(13549),
    [anon_sym_EQ] = ACTIONS(13549),
    [anon_sym_LT] = ACTIONS(13549),
    [anon_sym_if] = ACTIONS(13547),
    [anon_sym_unless] = ACTIONS(13547),
    [anon_sym_while] = ACTIONS(13547),
    [anon_sym_until] = ACTIONS(13547),
    [anon_sym_rescue] = ACTIONS(13547),
    [anon_sym_in] = ACTIONS(13547),
    [anon_sym_do] = ACTIONS(13547),
    [anon_sym_EQ_GT] = ACTIONS(13547),
    [anon_sym_LBRACK] = ACTIONS(13547),
    [anon_sym_RBRACK] = ACTIONS(13547),
    [anon_sym_COLON_COLON2] = ACTIONS(13547),
    [anon_sym_AMP_DOT] = ACTIONS(13547),
    [anon_sym_QMARK] = ACTIONS(13547),
    [anon_sym_COLON2] = ACTIONS(13549),
    [anon_sym_DOT_DOT] = ACTIONS(13549),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13547),
    [anon_sym_and] = ACTIONS(13547),
    [anon_sym_or] = ACTIONS(13547),
    [anon_sym_PIPE_PIPE] = ACTIONS(13547),
    [anon_sym_AMP_AMP] = ACTIONS(13547),
    [anon_sym_LT_LT] = ACTIONS(13547),
    [anon_sym_GT_GT] = ACTIONS(13547),
    [anon_sym_EQ_EQ] = ACTIONS(13549),
    [anon_sym_BANG_EQ] = ACTIONS(13547),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13547),
    [anon_sym_LT_EQ_GT] = ACTIONS(13547),
    [anon_sym_EQ_TILDE] = ACTIONS(13547),
    [anon_sym_BANG_TILDE] = ACTIONS(13547),
    [anon_sym_LT_EQ] = ACTIONS(13549),
    [anon_sym_GT] = ACTIONS(13549),
    [anon_sym_GT_EQ] = ACTIONS(13547),
    [anon_sym_CARET] = ACTIONS(13547),
    [anon_sym_PLUS] = ACTIONS(13547),
    [anon_sym_SLASH] = ACTIONS(13547),
    [anon_sym_PERCENT] = ACTIONS(13547),
    [sym_comment] = ACTIONS(87),
  },
  [9904] = {
    [sym__heredoc_body_start] = ACTIONS(13712),
    [sym__binary_minus] = ACTIONS(13712),
    [sym__binary_star] = ACTIONS(13712),
    [anon_sym_LBRACE] = ACTIONS(13712),
    [anon_sym_RBRACE] = ACTIONS(13712),
    [anon_sym_RPAREN] = ACTIONS(13712),
    [anon_sym_DOT] = ACTIONS(13714),
    [anon_sym_COMMA] = ACTIONS(13712),
    [anon_sym_PIPE] = ACTIONS(13714),
    [anon_sym_SEMI] = ACTIONS(13712),
    [anon_sym_STAR_STAR] = ACTIONS(13712),
    [anon_sym_AMP] = ACTIONS(13714),
    [anon_sym_EQ] = ACTIONS(13714),
    [anon_sym_LT] = ACTIONS(13714),
    [anon_sym_if] = ACTIONS(13712),
    [anon_sym_unless] = ACTIONS(13712),
    [anon_sym_while] = ACTIONS(13712),
    [anon_sym_until] = ACTIONS(13712),
    [anon_sym_rescue] = ACTIONS(13712),
    [anon_sym_in] = ACTIONS(13712),
    [anon_sym_do] = ACTIONS(13712),
    [anon_sym_EQ_GT] = ACTIONS(13712),
    [anon_sym_LBRACK] = ACTIONS(13712),
    [anon_sym_RBRACK] = ACTIONS(13712),
    [anon_sym_COLON_COLON2] = ACTIONS(13712),
    [anon_sym_AMP_DOT] = ACTIONS(13712),
    [anon_sym_QMARK] = ACTIONS(13712),
    [anon_sym_COLON2] = ACTIONS(13714),
    [anon_sym_DOT_DOT] = ACTIONS(13714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13712),
    [anon_sym_and] = ACTIONS(13712),
    [anon_sym_or] = ACTIONS(13712),
    [anon_sym_PIPE_PIPE] = ACTIONS(13712),
    [anon_sym_AMP_AMP] = ACTIONS(13712),
    [anon_sym_LT_LT] = ACTIONS(13712),
    [anon_sym_GT_GT] = ACTIONS(13712),
    [anon_sym_EQ_EQ] = ACTIONS(13714),
    [anon_sym_BANG_EQ] = ACTIONS(13712),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13712),
    [anon_sym_LT_EQ_GT] = ACTIONS(13712),
    [anon_sym_EQ_TILDE] = ACTIONS(13712),
    [anon_sym_BANG_TILDE] = ACTIONS(13712),
    [anon_sym_LT_EQ] = ACTIONS(13714),
    [anon_sym_GT] = ACTIONS(13714),
    [anon_sym_GT_EQ] = ACTIONS(13712),
    [anon_sym_CARET] = ACTIONS(13712),
    [anon_sym_PLUS] = ACTIONS(13712),
    [anon_sym_SLASH] = ACTIONS(13712),
    [anon_sym_PERCENT] = ACTIONS(13712),
    [sym_comment] = ACTIONS(87),
  },
  [9905] = {
    [anon_sym_end] = ACTIONS(14406),
    [sym_comment] = ACTIONS(87),
  },
  [9906] = {
    [sym__heredoc_body_start] = ACTIONS(13712),
    [sym__binary_minus] = ACTIONS(13712),
    [sym__binary_star] = ACTIONS(13712),
    [anon_sym_LBRACE] = ACTIONS(13712),
    [anon_sym_RBRACE] = ACTIONS(13712),
    [anon_sym_RPAREN] = ACTIONS(13712),
    [anon_sym_DOT] = ACTIONS(13714),
    [anon_sym_COMMA] = ACTIONS(13712),
    [anon_sym_PIPE] = ACTIONS(13714),
    [anon_sym_SEMI] = ACTIONS(13712),
    [anon_sym_STAR_STAR] = ACTIONS(13714),
    [anon_sym_AMP] = ACTIONS(13714),
    [anon_sym_EQ] = ACTIONS(13714),
    [anon_sym_LT] = ACTIONS(13714),
    [anon_sym_if] = ACTIONS(13712),
    [anon_sym_unless] = ACTIONS(13712),
    [anon_sym_while] = ACTIONS(13712),
    [anon_sym_until] = ACTIONS(13712),
    [anon_sym_rescue] = ACTIONS(13712),
    [anon_sym_in] = ACTIONS(13712),
    [anon_sym_do] = ACTIONS(13712),
    [anon_sym_EQ_GT] = ACTIONS(13712),
    [anon_sym_LBRACK] = ACTIONS(13712),
    [anon_sym_RBRACK] = ACTIONS(13712),
    [anon_sym_COLON_COLON2] = ACTIONS(13712),
    [anon_sym_AMP_DOT] = ACTIONS(13712),
    [anon_sym_PLUS_EQ] = ACTIONS(13712),
    [anon_sym_DASH_EQ] = ACTIONS(13712),
    [anon_sym_STAR_EQ] = ACTIONS(13712),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13712),
    [anon_sym_SLASH_EQ] = ACTIONS(13712),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13712),
    [anon_sym_PIPE_EQ] = ACTIONS(13712),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13712),
    [anon_sym_AMP_EQ] = ACTIONS(13712),
    [anon_sym_PERCENT_EQ] = ACTIONS(13712),
    [anon_sym_GT_GT_EQ] = ACTIONS(13712),
    [anon_sym_LT_LT_EQ] = ACTIONS(13712),
    [anon_sym_CARET_EQ] = ACTIONS(13712),
    [anon_sym_QMARK] = ACTIONS(13712),
    [anon_sym_COLON2] = ACTIONS(13714),
    [anon_sym_DOT_DOT] = ACTIONS(13714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13712),
    [anon_sym_and] = ACTIONS(13712),
    [anon_sym_or] = ACTIONS(13712),
    [anon_sym_PIPE_PIPE] = ACTIONS(13714),
    [anon_sym_AMP_AMP] = ACTIONS(13714),
    [anon_sym_LT_LT] = ACTIONS(13714),
    [anon_sym_GT_GT] = ACTIONS(13714),
    [anon_sym_EQ_EQ] = ACTIONS(13714),
    [anon_sym_BANG_EQ] = ACTIONS(13712),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13712),
    [anon_sym_LT_EQ_GT] = ACTIONS(13712),
    [anon_sym_EQ_TILDE] = ACTIONS(13712),
    [anon_sym_BANG_TILDE] = ACTIONS(13712),
    [anon_sym_LT_EQ] = ACTIONS(13714),
    [anon_sym_GT] = ACTIONS(13714),
    [anon_sym_GT_EQ] = ACTIONS(13712),
    [anon_sym_CARET] = ACTIONS(13714),
    [anon_sym_PLUS] = ACTIONS(13714),
    [anon_sym_SLASH] = ACTIONS(13714),
    [anon_sym_PERCENT] = ACTIONS(13714),
    [sym_comment] = ACTIONS(87),
  },
  [9907] = {
    [anon_sym_end] = ACTIONS(14408),
    [sym_comment] = ACTIONS(87),
  },
  [9908] = {
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(5685),
    [sym__binary_star] = ACTIONS(5687),
    [anon_sym_LBRACE] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(5689),
    [anon_sym_STAR_STAR] = ACTIONS(5691),
    [anon_sym_AMP] = ACTIONS(5693),
    [anon_sym_EQ] = ACTIONS(12879),
    [anon_sym_LT] = ACTIONS(5695),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_EQ_GT] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_RBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_PLUS_EQ] = ACTIONS(12120),
    [anon_sym_DASH_EQ] = ACTIONS(12120),
    [anon_sym_STAR_EQ] = ACTIONS(12120),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12120),
    [anon_sym_SLASH_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12120),
    [anon_sym_AMP_EQ] = ACTIONS(12120),
    [anon_sym_PERCENT_EQ] = ACTIONS(12120),
    [anon_sym_GT_GT_EQ] = ACTIONS(12120),
    [anon_sym_LT_LT_EQ] = ACTIONS(12120),
    [anon_sym_CARET_EQ] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(5697),
    [anon_sym_DOT_DOT] = ACTIONS(5699),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5701),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(5703),
    [anon_sym_AMP_AMP] = ACTIONS(5703),
    [anon_sym_LT_LT] = ACTIONS(5705),
    [anon_sym_GT_GT] = ACTIONS(5705),
    [anon_sym_EQ_EQ] = ACTIONS(5703),
    [anon_sym_BANG_EQ] = ACTIONS(5707),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5707),
    [anon_sym_LT_EQ_GT] = ACTIONS(5707),
    [anon_sym_EQ_TILDE] = ACTIONS(5707),
    [anon_sym_BANG_TILDE] = ACTIONS(5707),
    [anon_sym_LT_EQ] = ACTIONS(5695),
    [anon_sym_GT] = ACTIONS(5695),
    [anon_sym_GT_EQ] = ACTIONS(5709),
    [anon_sym_CARET] = ACTIONS(5689),
    [anon_sym_PLUS] = ACTIONS(5711),
    [anon_sym_SLASH] = ACTIONS(5691),
    [anon_sym_PERCENT] = ACTIONS(5691),
    [sym_comment] = ACTIONS(87),
  },
  [9909] = {
    [aux_sym_exceptions_repeat1] = STATE(9909),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(14410),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_RBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_PLUS_EQ] = ACTIONS(11597),
    [anon_sym_DASH_EQ] = ACTIONS(11597),
    [anon_sym_STAR_EQ] = ACTIONS(11597),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11597),
    [anon_sym_SLASH_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11597),
    [anon_sym_AMP_EQ] = ACTIONS(11597),
    [anon_sym_PERCENT_EQ] = ACTIONS(11597),
    [anon_sym_GT_GT_EQ] = ACTIONS(11597),
    [anon_sym_LT_LT_EQ] = ACTIONS(11597),
    [anon_sym_CARET_EQ] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_LT] = ACTIONS(12338),
    [anon_sym_GT_GT] = ACTIONS(12338),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(12338),
    [anon_sym_PLUS] = ACTIONS(12338),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [9910] = {
    [sym__simple_symbol] = ACTIONS(14413),
    [sym__string_start] = ACTIONS(14413),
    [sym__symbol_start] = ACTIONS(14413),
    [sym__subshell_start] = ACTIONS(14413),
    [sym__regex_start] = ACTIONS(14413),
    [sym__string_array_start] = ACTIONS(14413),
    [sym__symbol_array_start] = ACTIONS(14413),
    [sym_heredoc_beginning] = ACTIONS(14413),
    [sym__unary_minus] = ACTIONS(14413),
    [anon_sym_BEGIN] = ACTIONS(14415),
    [anon_sym_LBRACE] = ACTIONS(14413),
    [anon_sym_RBRACE] = ACTIONS(14413),
    [anon_sym_END] = ACTIONS(14415),
    [anon_sym_def] = ACTIONS(14415),
    [anon_sym_LPAREN] = ACTIONS(14413),
    [anon_sym_COLON_COLON] = ACTIONS(14413),
    [anon_sym_SEMI] = ACTIONS(14413),
    [anon_sym_STAR] = ACTIONS(14413),
    [anon_sym_class] = ACTIONS(14415),
    [anon_sym_module] = ACTIONS(14415),
    [anon_sym_return] = ACTIONS(14415),
    [anon_sym_yield] = ACTIONS(14415),
    [anon_sym_break] = ACTIONS(14415),
    [anon_sym_next] = ACTIONS(14415),
    [sym_redo] = ACTIONS(14415),
    [sym_retry] = ACTIONS(14415),
    [anon_sym_if] = ACTIONS(14415),
    [anon_sym_unless] = ACTIONS(14415),
    [anon_sym_while] = ACTIONS(14415),
    [anon_sym_until] = ACTIONS(14415),
    [anon_sym_for] = ACTIONS(14415),
    [anon_sym_case] = ACTIONS(14415),
    [anon_sym_begin] = ACTIONS(14415),
    [anon_sym_PLUS] = ACTIONS(14415),
    [anon_sym_defined_QMARK] = ACTIONS(14413),
    [anon_sym_not] = ACTIONS(14415),
    [anon_sym_BANG] = ACTIONS(14413),
    [anon_sym_TILDE] = ACTIONS(14413),
    [sym_constant] = ACTIONS(14415),
    [sym_identifier] = ACTIONS(14415),
    [sym_instance_variable] = ACTIONS(14413),
    [sym_class_variable] = ACTIONS(14413),
    [sym_global_variable] = ACTIONS(14413),
    [anon_sym_undef] = ACTIONS(14415),
    [anon_sym_alias] = ACTIONS(14415),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(14415),
    [sym_float] = ACTIONS(14415),
    [sym_complex] = ACTIONS(14413),
    [sym_super] = ACTIONS(14415),
    [anon_sym_true] = ACTIONS(14415),
    [anon_sym_TRUE] = ACTIONS(14415),
    [anon_sym_false] = ACTIONS(14415),
    [anon_sym_FALSE] = ACTIONS(14415),
    [sym_self] = ACTIONS(14415),
    [anon_sym_nil] = ACTIONS(14415),
    [anon_sym_NIL] = ACTIONS(14415),
    [sym_character] = ACTIONS(14413),
    [anon_sym_LBRACK2] = ACTIONS(14413),
    [anon_sym_DASH_GT] = ACTIONS(14413),
  },
  [9911] = {
    [aux_sym_block_parameters_repeat1] = STATE(9913),
    [anon_sym_COMMA] = ACTIONS(11999),
    [anon_sym_PIPE] = ACTIONS(14417),
    [sym_comment] = ACTIONS(87),
  },
  [9912] = {
    [anon_sym_COMMA] = ACTIONS(14419),
    [anon_sym_PIPE] = ACTIONS(14419),
    [sym_comment] = ACTIONS(87),
  },
  [9913] = {
    [aux_sym_block_parameters_repeat1] = STATE(9913),
    [anon_sym_COMMA] = ACTIONS(14421),
    [anon_sym_PIPE] = ACTIONS(14419),
    [sym_comment] = ACTIONS(87),
  },
  [9914] = {
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(13633),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [9915] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(10706),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(10709),
    [sym_scope_resolution] = STATE(10707),
    [sym_call] = STATE(10707),
    [sym_method_call] = STATE(10709),
    [sym_assignment] = STATE(10706),
    [sym_operator_assignment] = STATE(10706),
    [sym_conditional] = STATE(10706),
    [sym_range] = STATE(10706),
    [sym_binary] = STATE(10706),
    [sym_unary] = STATE(10706),
    [sym_left_assignment_list] = STATE(10708),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10709),
    [sym__variable] = STATE(10707),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(10709),
    [sym_false] = STATE(10709),
    [sym_nil] = STATE(10709),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(10710),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(14424),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(14426),
    [anon_sym_yield] = ACTIONS(14428),
    [anon_sym_break] = ACTIONS(14430),
    [anon_sym_next] = ACTIONS(14432),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14434),
    [anon_sym_defined_QMARK] = ACTIONS(14436),
    [anon_sym_not] = ACTIONS(14438),
    [anon_sym_BANG] = ACTIONS(14440),
    [anon_sym_TILDE] = ACTIONS(14440),
    [sym_constant] = ACTIONS(14442),
    [sym_identifier] = ACTIONS(14442),
    [sym_instance_variable] = ACTIONS(14444),
    [sym_class_variable] = ACTIONS(14444),
    [sym_global_variable] = ACTIONS(14444),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(14442),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14442),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9916] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(10711),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(10709),
    [sym_scope_resolution] = STATE(10707),
    [sym_call] = STATE(10707),
    [sym_method_call] = STATE(10709),
    [sym_assignment] = STATE(10711),
    [sym_operator_assignment] = STATE(10711),
    [sym_conditional] = STATE(10711),
    [sym_range] = STATE(10711),
    [sym_binary] = STATE(10711),
    [sym_unary] = STATE(10711),
    [sym_left_assignment_list] = STATE(10708),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10709),
    [sym__variable] = STATE(10707),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(10709),
    [sym_false] = STATE(10709),
    [sym_nil] = STATE(10709),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(10710),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(14424),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(14426),
    [anon_sym_yield] = ACTIONS(14428),
    [anon_sym_break] = ACTIONS(14430),
    [anon_sym_next] = ACTIONS(14432),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14434),
    [anon_sym_defined_QMARK] = ACTIONS(14436),
    [anon_sym_not] = ACTIONS(14438),
    [anon_sym_BANG] = ACTIONS(14440),
    [anon_sym_TILDE] = ACTIONS(14440),
    [sym_constant] = ACTIONS(14442),
    [sym_identifier] = ACTIONS(14442),
    [sym_instance_variable] = ACTIONS(14444),
    [sym_class_variable] = ACTIONS(14444),
    [sym_global_variable] = ACTIONS(14444),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(14442),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14442),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9917] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(10712),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(9932),
    [sym_scope_resolution] = STATE(9928),
    [sym_call] = STATE(9928),
    [sym_method_call] = STATE(9932),
    [sym_assignment] = STATE(10712),
    [sym_operator_assignment] = STATE(10712),
    [sym_conditional] = STATE(10712),
    [sym_range] = STATE(10712),
    [sym_binary] = STATE(10712),
    [sym_unary] = STATE(10712),
    [sym_left_assignment_list] = STATE(9931),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9932),
    [sym__variable] = STATE(9928),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(9932),
    [sym_false] = STATE(9932),
    [sym_nil] = STATE(9932),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(10713),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(13605),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13609),
    [anon_sym_yield] = ACTIONS(13611),
    [anon_sym_break] = ACTIONS(13613),
    [anon_sym_next] = ACTIONS(13615),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14446),
    [anon_sym_defined_QMARK] = ACTIONS(13617),
    [anon_sym_not] = ACTIONS(13619),
    [anon_sym_BANG] = ACTIONS(13623),
    [anon_sym_TILDE] = ACTIONS(13623),
    [sym_constant] = ACTIONS(13629),
    [sym_identifier] = ACTIONS(13629),
    [sym_instance_variable] = ACTIONS(13627),
    [sym_class_variable] = ACTIONS(13627),
    [sym_global_variable] = ACTIONS(13627),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13629),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13629),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9918] = {
    [anon_sym_COLON] = ACTIONS(14448),
    [sym_comment] = ACTIONS(87),
  },
  [9919] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(10715),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(10709),
    [sym_scope_resolution] = STATE(10707),
    [sym_call] = STATE(10707),
    [sym_method_call] = STATE(10709),
    [sym_assignment] = STATE(10715),
    [sym_operator_assignment] = STATE(10715),
    [sym_conditional] = STATE(10715),
    [sym_range] = STATE(10715),
    [sym_binary] = STATE(10715),
    [sym_unary] = STATE(10715),
    [sym_left_assignment_list] = STATE(10708),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10709),
    [sym__variable] = STATE(10707),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(10709),
    [sym_false] = STATE(10709),
    [sym_nil] = STATE(10709),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(10710),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(14424),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(14426),
    [anon_sym_yield] = ACTIONS(14428),
    [anon_sym_break] = ACTIONS(14430),
    [anon_sym_next] = ACTIONS(14432),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14434),
    [anon_sym_defined_QMARK] = ACTIONS(14436),
    [anon_sym_not] = ACTIONS(14438),
    [anon_sym_BANG] = ACTIONS(14440),
    [anon_sym_TILDE] = ACTIONS(14440),
    [sym_constant] = ACTIONS(14442),
    [sym_identifier] = ACTIONS(14442),
    [sym_instance_variable] = ACTIONS(14444),
    [sym_class_variable] = ACTIONS(14444),
    [sym_global_variable] = ACTIONS(14444),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(14442),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14442),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9920] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(10721),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(9932),
    [sym_scope_resolution] = STATE(9928),
    [sym_call] = STATE(9928),
    [sym_method_call] = STATE(9932),
    [sym_argument_list] = STATE(1318),
    [sym__argument_list_with_parens] = STATE(10722),
    [sym__argument] = STATE(10723),
    [sym_splat_argument] = STATE(10723),
    [sym_hash_splat_argument] = STATE(10723),
    [sym_block_argument] = STATE(10723),
    [sym_assignment] = STATE(10721),
    [sym_operator_assignment] = STATE(10721),
    [sym_conditional] = STATE(10721),
    [sym_range] = STATE(10721),
    [sym_binary] = STATE(10721),
    [sym_unary] = STATE(10721),
    [sym_left_assignment_list] = STATE(9931),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9932),
    [sym__variable] = STATE(9928),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(9932),
    [sym_false] = STATE(9932),
    [sym_nil] = STATE(9932),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(10724),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(10723),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(14450),
    [sym__splat_star] = ACTIONS(14452),
    [sym__unary_minus] = ACTIONS(13605),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(14454),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13609),
    [anon_sym_yield] = ACTIONS(13611),
    [anon_sym_break] = ACTIONS(13613),
    [anon_sym_next] = ACTIONS(13615),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(13617),
    [anon_sym_not] = ACTIONS(13619),
    [anon_sym_BANG] = ACTIONS(13621),
    [anon_sym_TILDE] = ACTIONS(13623),
    [sym_constant] = ACTIONS(14456),
    [sym_identifier] = ACTIONS(14456),
    [sym_instance_variable] = ACTIONS(13627),
    [sym_class_variable] = ACTIONS(13627),
    [sym_global_variable] = ACTIONS(13627),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13629),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13629),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9921] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(10721),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(9932),
    [sym_scope_resolution] = STATE(9928),
    [sym_call] = STATE(9928),
    [sym_method_call] = STATE(9932),
    [sym_argument_list] = STATE(1324),
    [sym__argument_list_with_parens] = STATE(10722),
    [sym__argument] = STATE(10723),
    [sym_splat_argument] = STATE(10723),
    [sym_hash_splat_argument] = STATE(10723),
    [sym_block_argument] = STATE(10723),
    [sym_assignment] = STATE(10721),
    [sym_operator_assignment] = STATE(10721),
    [sym_conditional] = STATE(10721),
    [sym_range] = STATE(10721),
    [sym_binary] = STATE(10721),
    [sym_unary] = STATE(10721),
    [sym_left_assignment_list] = STATE(9931),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9932),
    [sym__variable] = STATE(9928),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(9932),
    [sym_false] = STATE(9932),
    [sym_nil] = STATE(9932),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(10724),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(10723),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(14450),
    [sym__splat_star] = ACTIONS(14452),
    [sym__unary_minus] = ACTIONS(13605),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(14454),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13609),
    [anon_sym_yield] = ACTIONS(13611),
    [anon_sym_break] = ACTIONS(13613),
    [anon_sym_next] = ACTIONS(13615),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(13617),
    [anon_sym_not] = ACTIONS(13619),
    [anon_sym_BANG] = ACTIONS(13621),
    [anon_sym_TILDE] = ACTIONS(13623),
    [sym_constant] = ACTIONS(14456),
    [sym_identifier] = ACTIONS(14456),
    [sym_instance_variable] = ACTIONS(13627),
    [sym_class_variable] = ACTIONS(13627),
    [sym_global_variable] = ACTIONS(13627),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13629),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13629),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9922] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(10721),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(9932),
    [sym_scope_resolution] = STATE(9928),
    [sym_call] = STATE(9928),
    [sym_method_call] = STATE(9932),
    [sym_argument_list] = STATE(1325),
    [sym__argument_list_with_parens] = STATE(10722),
    [sym__argument] = STATE(10723),
    [sym_splat_argument] = STATE(10723),
    [sym_hash_splat_argument] = STATE(10723),
    [sym_block_argument] = STATE(10723),
    [sym_assignment] = STATE(10721),
    [sym_operator_assignment] = STATE(10721),
    [sym_conditional] = STATE(10721),
    [sym_range] = STATE(10721),
    [sym_binary] = STATE(10721),
    [sym_unary] = STATE(10721),
    [sym_left_assignment_list] = STATE(9931),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9932),
    [sym__variable] = STATE(9928),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(9932),
    [sym_false] = STATE(9932),
    [sym_nil] = STATE(9932),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(10724),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(10723),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(14450),
    [sym__splat_star] = ACTIONS(14452),
    [sym__unary_minus] = ACTIONS(13605),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(14454),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13609),
    [anon_sym_yield] = ACTIONS(13611),
    [anon_sym_break] = ACTIONS(13613),
    [anon_sym_next] = ACTIONS(13615),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(13617),
    [anon_sym_not] = ACTIONS(13619),
    [anon_sym_BANG] = ACTIONS(13621),
    [anon_sym_TILDE] = ACTIONS(13623),
    [sym_constant] = ACTIONS(14456),
    [sym_identifier] = ACTIONS(14456),
    [sym_instance_variable] = ACTIONS(13627),
    [sym_class_variable] = ACTIONS(13627),
    [sym_global_variable] = ACTIONS(13627),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13629),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13629),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9923] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(10721),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(9932),
    [sym_scope_resolution] = STATE(9928),
    [sym_call] = STATE(9928),
    [sym_method_call] = STATE(9932),
    [sym_argument_list] = STATE(1326),
    [sym__argument_list_with_parens] = STATE(10722),
    [sym__argument] = STATE(10723),
    [sym_splat_argument] = STATE(10723),
    [sym_hash_splat_argument] = STATE(10723),
    [sym_block_argument] = STATE(10723),
    [sym_assignment] = STATE(10721),
    [sym_operator_assignment] = STATE(10721),
    [sym_conditional] = STATE(10721),
    [sym_range] = STATE(10721),
    [sym_binary] = STATE(10721),
    [sym_unary] = STATE(10721),
    [sym_left_assignment_list] = STATE(9931),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9932),
    [sym__variable] = STATE(9928),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(9932),
    [sym_false] = STATE(9932),
    [sym_nil] = STATE(9932),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(10724),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(10723),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(14450),
    [sym__splat_star] = ACTIONS(14452),
    [sym__unary_minus] = ACTIONS(13605),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(14454),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13609),
    [anon_sym_yield] = ACTIONS(13611),
    [anon_sym_break] = ACTIONS(13613),
    [anon_sym_next] = ACTIONS(13615),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(13617),
    [anon_sym_not] = ACTIONS(13619),
    [anon_sym_BANG] = ACTIONS(13621),
    [anon_sym_TILDE] = ACTIONS(13623),
    [sym_constant] = ACTIONS(14456),
    [sym_identifier] = ACTIONS(14456),
    [sym_instance_variable] = ACTIONS(13627),
    [sym_class_variable] = ACTIONS(13627),
    [sym_global_variable] = ACTIONS(13627),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13629),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13629),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9924] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(10725),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(9932),
    [sym_scope_resolution] = STATE(9928),
    [sym_call] = STATE(9928),
    [sym_method_call] = STATE(9932),
    [sym_assignment] = STATE(10725),
    [sym_operator_assignment] = STATE(10725),
    [sym_conditional] = STATE(10725),
    [sym_range] = STATE(10725),
    [sym_binary] = STATE(10725),
    [sym_unary] = STATE(10725),
    [sym_left_assignment_list] = STATE(9931),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9932),
    [sym__variable] = STATE(9928),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(9932),
    [sym_false] = STATE(9932),
    [sym_nil] = STATE(9932),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(10713),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(13605),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13609),
    [anon_sym_yield] = ACTIONS(13611),
    [anon_sym_break] = ACTIONS(13613),
    [anon_sym_next] = ACTIONS(13615),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14446),
    [anon_sym_defined_QMARK] = ACTIONS(13617),
    [anon_sym_not] = ACTIONS(13619),
    [anon_sym_BANG] = ACTIONS(13623),
    [anon_sym_TILDE] = ACTIONS(13623),
    [sym_constant] = ACTIONS(13629),
    [sym_identifier] = ACTIONS(13629),
    [sym_instance_variable] = ACTIONS(13627),
    [sym_class_variable] = ACTIONS(13627),
    [sym_global_variable] = ACTIONS(13627),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13629),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13629),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9925] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(1872),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(9932),
    [sym_scope_resolution] = STATE(9928),
    [sym_call] = STATE(9928),
    [sym_method_call] = STATE(9932),
    [sym_assignment] = STATE(1872),
    [sym_operator_assignment] = STATE(1872),
    [sym_conditional] = STATE(1872),
    [sym_range] = STATE(1872),
    [sym_binary] = STATE(1872),
    [sym_unary] = STATE(1872),
    [sym_left_assignment_list] = STATE(9931),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9932),
    [sym__variable] = STATE(9928),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(9932),
    [sym_false] = STATE(9932),
    [sym_nil] = STATE(9932),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(10713),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(13605),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13609),
    [anon_sym_yield] = ACTIONS(13611),
    [anon_sym_break] = ACTIONS(13613),
    [anon_sym_next] = ACTIONS(13615),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14446),
    [anon_sym_defined_QMARK] = ACTIONS(13617),
    [anon_sym_not] = ACTIONS(13619),
    [anon_sym_BANG] = ACTIONS(13623),
    [anon_sym_TILDE] = ACTIONS(13623),
    [sym_constant] = ACTIONS(13629),
    [sym_identifier] = ACTIONS(13629),
    [sym_instance_variable] = ACTIONS(13627),
    [sym_class_variable] = ACTIONS(13627),
    [sym_global_variable] = ACTIONS(13627),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13629),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13629),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9926] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(14458),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [9927] = {
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(14460),
    [sym__binary_star] = ACTIONS(14462),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(14464),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(14462),
    [anon_sym_AMP] = ACTIONS(14466),
    [anon_sym_LT] = ACTIONS(14468),
    [anon_sym_EQ_GT] = ACTIONS(14448),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(14470),
    [anon_sym_DOT_DOT] = ACTIONS(14472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14474),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(14476),
    [anon_sym_AMP_AMP] = ACTIONS(14476),
    [anon_sym_LT_LT] = ACTIONS(14478),
    [anon_sym_GT_GT] = ACTIONS(14478),
    [anon_sym_EQ_EQ] = ACTIONS(14480),
    [anon_sym_BANG_EQ] = ACTIONS(14476),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14476),
    [anon_sym_LT_EQ_GT] = ACTIONS(14476),
    [anon_sym_EQ_TILDE] = ACTIONS(14476),
    [anon_sym_BANG_TILDE] = ACTIONS(14476),
    [anon_sym_LT_EQ] = ACTIONS(14468),
    [anon_sym_GT] = ACTIONS(14468),
    [anon_sym_GT_EQ] = ACTIONS(14482),
    [anon_sym_CARET] = ACTIONS(14484),
    [anon_sym_PLUS] = ACTIONS(14460),
    [anon_sym_SLASH] = ACTIONS(14462),
    [anon_sym_PERCENT] = ACTIONS(14462),
    [sym_comment] = ACTIONS(87),
  },
  [9928] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(10742),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9962),
    [sym_scope_resolution] = STATE(9958),
    [sym_call] = STATE(9958),
    [sym_method_call] = STATE(9962),
    [sym_argument_list] = STATE(1379),
    [sym__argument_list_with_parens] = STATE(10743),
    [sym__argument] = STATE(10744),
    [sym_splat_argument] = STATE(10744),
    [sym_hash_splat_argument] = STATE(10744),
    [sym_block_argument] = STATE(10744),
    [sym_do_block] = STATE(1382),
    [sym_block] = STATE(1382),
    [sym_assignment] = STATE(10742),
    [sym_operator_assignment] = STATE(10742),
    [sym_conditional] = STATE(10742),
    [sym_range] = STATE(10742),
    [sym_binary] = STATE(10742),
    [sym_unary] = STATE(10742),
    [sym_left_assignment_list] = STATE(9961),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9962),
    [sym__variable] = STATE(9958),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9962),
    [sym_false] = STATE(9962),
    [sym_nil] = STATE(9962),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10745),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(10744),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(14486),
    [sym__splat_star] = ACTIONS(14488),
    [sym__unary_minus] = ACTIONS(13663),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(14490),
    [anon_sym_LBRACE] = ACTIONS(2403),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13667),
    [anon_sym_yield] = ACTIONS(13669),
    [anon_sym_break] = ACTIONS(13671),
    [anon_sym_next] = ACTIONS(13673),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(2413),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(13675),
    [anon_sym_not] = ACTIONS(13677),
    [anon_sym_BANG] = ACTIONS(13679),
    [anon_sym_TILDE] = ACTIONS(13681),
    [sym_constant] = ACTIONS(14492),
    [sym_identifier] = ACTIONS(14492),
    [sym_instance_variable] = ACTIONS(13685),
    [sym_class_variable] = ACTIONS(13685),
    [sym_global_variable] = ACTIONS(13685),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13687),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13687),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [9929] = {
    [sym_heredoc_body] = STATE(10746),
    [aux_sym_call_repeat1] = STATE(10746),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [9930] = {
    [sym_heredoc_body] = STATE(10746),
    [aux_sym_call_repeat1] = STATE(10746),
    [aux_sym_argument_list_repeat1] = STATE(10748),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(14494),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [9931] = {
    [anon_sym_EQ] = ACTIONS(14496),
    [sym_comment] = ACTIONS(87),
  },
  [9932] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(14498),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(14500),
    [anon_sym_DASH_EQ] = ACTIONS(14500),
    [anon_sym_STAR_EQ] = ACTIONS(14500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14500),
    [anon_sym_SLASH_EQ] = ACTIONS(14500),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14500),
    [anon_sym_PIPE_EQ] = ACTIONS(14500),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14500),
    [anon_sym_AMP_EQ] = ACTIONS(14500),
    [anon_sym_PERCENT_EQ] = ACTIONS(14500),
    [anon_sym_GT_GT_EQ] = ACTIONS(14500),
    [anon_sym_LT_LT_EQ] = ACTIONS(14500),
    [anon_sym_CARET_EQ] = ACTIONS(14500),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [9933] = {
    [sym_string] = STATE(10751),
    [aux_sym_chained_string_repeat1] = STATE(10751),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(14502),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [9934] = {
    [sym__binary_minus] = ACTIONS(13631),
    [sym__binary_star] = ACTIONS(13633),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(14504),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(13633),
    [anon_sym_AMP] = ACTIONS(13637),
    [anon_sym_LT] = ACTIONS(13639),
    [anon_sym_QMARK] = ACTIONS(13641),
    [anon_sym_DOT_DOT] = ACTIONS(13643),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13645),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(13649),
    [anon_sym_AMP_AMP] = ACTIONS(13649),
    [anon_sym_LT_LT] = ACTIONS(13651),
    [anon_sym_GT_GT] = ACTIONS(13651),
    [anon_sym_EQ_EQ] = ACTIONS(13653),
    [anon_sym_BANG_EQ] = ACTIONS(13649),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13649),
    [anon_sym_LT_EQ_GT] = ACTIONS(13649),
    [anon_sym_EQ_TILDE] = ACTIONS(13649),
    [anon_sym_BANG_TILDE] = ACTIONS(13649),
    [anon_sym_LT_EQ] = ACTIONS(13639),
    [anon_sym_GT] = ACTIONS(13639),
    [anon_sym_GT_EQ] = ACTIONS(13655),
    [anon_sym_CARET] = ACTIONS(13657),
    [anon_sym_PLUS] = ACTIONS(13631),
    [anon_sym_SLASH] = ACTIONS(13633),
    [anon_sym_PERCENT] = ACTIONS(13633),
    [sym_comment] = ACTIONS(87),
  },
  [9935] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(10752),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(8445),
    [sym_scope_resolution] = STATE(8443),
    [sym_call] = STATE(8443),
    [sym_method_call] = STATE(8445),
    [sym_assignment] = STATE(10752),
    [sym_operator_assignment] = STATE(10752),
    [sym_conditional] = STATE(10752),
    [sym_range] = STATE(10752),
    [sym_binary] = STATE(10752),
    [sym_unary] = STATE(10752),
    [sym_left_assignment_list] = STATE(8444),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(8445),
    [sym__variable] = STATE(8443),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(8445),
    [sym_false] = STATE(8445),
    [sym_nil] = STATE(8445),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(8446),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(12003),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(12005),
    [anon_sym_yield] = ACTIONS(12007),
    [anon_sym_break] = ACTIONS(12009),
    [anon_sym_next] = ACTIONS(12011),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(12013),
    [anon_sym_defined_QMARK] = ACTIONS(12015),
    [anon_sym_not] = ACTIONS(12017),
    [anon_sym_BANG] = ACTIONS(12019),
    [anon_sym_TILDE] = ACTIONS(12019),
    [sym_constant] = ACTIONS(12021),
    [sym_identifier] = ACTIONS(12021),
    [sym_instance_variable] = ACTIONS(12023),
    [sym_class_variable] = ACTIONS(12023),
    [sym_global_variable] = ACTIONS(12023),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(12021),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(12021),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9936] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(10753),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(8445),
    [sym_scope_resolution] = STATE(8443),
    [sym_call] = STATE(8443),
    [sym_method_call] = STATE(8445),
    [sym_assignment] = STATE(10753),
    [sym_operator_assignment] = STATE(10753),
    [sym_conditional] = STATE(10753),
    [sym_range] = STATE(10753),
    [sym_binary] = STATE(10753),
    [sym_unary] = STATE(10753),
    [sym_left_assignment_list] = STATE(8444),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(8445),
    [sym__variable] = STATE(8443),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(8445),
    [sym_false] = STATE(8445),
    [sym_nil] = STATE(8445),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(8446),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(12003),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(12005),
    [anon_sym_yield] = ACTIONS(12007),
    [anon_sym_break] = ACTIONS(12009),
    [anon_sym_next] = ACTIONS(12011),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(12013),
    [anon_sym_defined_QMARK] = ACTIONS(12015),
    [anon_sym_not] = ACTIONS(12017),
    [anon_sym_BANG] = ACTIONS(12019),
    [anon_sym_TILDE] = ACTIONS(12019),
    [sym_constant] = ACTIONS(12021),
    [sym_identifier] = ACTIONS(12021),
    [sym_instance_variable] = ACTIONS(12023),
    [sym_class_variable] = ACTIONS(12023),
    [sym_global_variable] = ACTIONS(12023),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(12021),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(12021),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9937] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(10754),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(8445),
    [sym_scope_resolution] = STATE(8443),
    [sym_call] = STATE(8443),
    [sym_method_call] = STATE(8445),
    [sym_assignment] = STATE(10754),
    [sym_operator_assignment] = STATE(10754),
    [sym_conditional] = STATE(10754),
    [sym_range] = STATE(10754),
    [sym_binary] = STATE(10754),
    [sym_unary] = STATE(10754),
    [sym_left_assignment_list] = STATE(8444),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(8445),
    [sym__variable] = STATE(8443),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(8445),
    [sym_false] = STATE(8445),
    [sym_nil] = STATE(8445),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(8446),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(12003),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(12005),
    [anon_sym_yield] = ACTIONS(12007),
    [anon_sym_break] = ACTIONS(12009),
    [anon_sym_next] = ACTIONS(12011),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(12013),
    [anon_sym_defined_QMARK] = ACTIONS(12015),
    [anon_sym_not] = ACTIONS(12017),
    [anon_sym_BANG] = ACTIONS(12019),
    [anon_sym_TILDE] = ACTIONS(12019),
    [sym_constant] = ACTIONS(12021),
    [sym_identifier] = ACTIONS(12021),
    [sym_instance_variable] = ACTIONS(12023),
    [sym_class_variable] = ACTIONS(12023),
    [sym_global_variable] = ACTIONS(12023),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(12021),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(12021),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9938] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(10755),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(8445),
    [sym_scope_resolution] = STATE(8443),
    [sym_call] = STATE(8443),
    [sym_method_call] = STATE(8445),
    [sym_assignment] = STATE(10755),
    [sym_operator_assignment] = STATE(10755),
    [sym_conditional] = STATE(10755),
    [sym_range] = STATE(10755),
    [sym_binary] = STATE(10755),
    [sym_unary] = STATE(10755),
    [sym_left_assignment_list] = STATE(8444),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(8445),
    [sym__variable] = STATE(8443),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(8445),
    [sym_false] = STATE(8445),
    [sym_nil] = STATE(8445),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(8446),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(12003),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(12005),
    [anon_sym_yield] = ACTIONS(12007),
    [anon_sym_break] = ACTIONS(12009),
    [anon_sym_next] = ACTIONS(12011),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(12013),
    [anon_sym_defined_QMARK] = ACTIONS(12015),
    [anon_sym_not] = ACTIONS(12017),
    [anon_sym_BANG] = ACTIONS(12019),
    [anon_sym_TILDE] = ACTIONS(12019),
    [sym_constant] = ACTIONS(12021),
    [sym_identifier] = ACTIONS(12021),
    [sym_instance_variable] = ACTIONS(12023),
    [sym_class_variable] = ACTIONS(12023),
    [sym_global_variable] = ACTIONS(12023),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(12021),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(12021),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9939] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(10756),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(8445),
    [sym_scope_resolution] = STATE(8443),
    [sym_call] = STATE(8443),
    [sym_method_call] = STATE(8445),
    [sym_assignment] = STATE(10756),
    [sym_operator_assignment] = STATE(10756),
    [sym_conditional] = STATE(10756),
    [sym_range] = STATE(10756),
    [sym_binary] = STATE(10756),
    [sym_unary] = STATE(10756),
    [sym_left_assignment_list] = STATE(8444),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(8445),
    [sym__variable] = STATE(8443),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(8445),
    [sym_false] = STATE(8445),
    [sym_nil] = STATE(8445),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(8446),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(12003),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(12005),
    [anon_sym_yield] = ACTIONS(12007),
    [anon_sym_break] = ACTIONS(12009),
    [anon_sym_next] = ACTIONS(12011),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(12013),
    [anon_sym_defined_QMARK] = ACTIONS(12015),
    [anon_sym_not] = ACTIONS(12017),
    [anon_sym_BANG] = ACTIONS(12019),
    [anon_sym_TILDE] = ACTIONS(12019),
    [sym_constant] = ACTIONS(12021),
    [sym_identifier] = ACTIONS(12021),
    [sym_instance_variable] = ACTIONS(12023),
    [sym_class_variable] = ACTIONS(12023),
    [sym_global_variable] = ACTIONS(12023),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(12021),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(12021),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9940] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(10757),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(10757),
    [sym_operator_assignment] = STATE(10757),
    [sym_conditional] = STATE(10757),
    [sym_range] = STATE(10757),
    [sym_binary] = STATE(10757),
    [sym_unary] = STATE(10757),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9941] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(10758),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(8445),
    [sym_scope_resolution] = STATE(8443),
    [sym_call] = STATE(8443),
    [sym_method_call] = STATE(8445),
    [sym_assignment] = STATE(10758),
    [sym_operator_assignment] = STATE(10758),
    [sym_conditional] = STATE(10758),
    [sym_range] = STATE(10758),
    [sym_binary] = STATE(10758),
    [sym_unary] = STATE(10758),
    [sym_left_assignment_list] = STATE(8444),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(8445),
    [sym__variable] = STATE(8443),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(8445),
    [sym_false] = STATE(8445),
    [sym_nil] = STATE(8445),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(8446),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(12003),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(12005),
    [anon_sym_yield] = ACTIONS(12007),
    [anon_sym_break] = ACTIONS(12009),
    [anon_sym_next] = ACTIONS(12011),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(12013),
    [anon_sym_defined_QMARK] = ACTIONS(12015),
    [anon_sym_not] = ACTIONS(12017),
    [anon_sym_BANG] = ACTIONS(12019),
    [anon_sym_TILDE] = ACTIONS(12019),
    [sym_constant] = ACTIONS(12021),
    [sym_identifier] = ACTIONS(12021),
    [sym_instance_variable] = ACTIONS(12023),
    [sym_class_variable] = ACTIONS(12023),
    [sym_global_variable] = ACTIONS(12023),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(12021),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(12021),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9942] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(10759),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(8445),
    [sym_scope_resolution] = STATE(8443),
    [sym_call] = STATE(8443),
    [sym_method_call] = STATE(8445),
    [sym_assignment] = STATE(10759),
    [sym_operator_assignment] = STATE(10759),
    [sym_conditional] = STATE(10759),
    [sym_range] = STATE(10759),
    [sym_binary] = STATE(10759),
    [sym_unary] = STATE(10759),
    [sym_left_assignment_list] = STATE(8444),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(8445),
    [sym__variable] = STATE(8443),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(8445),
    [sym_false] = STATE(8445),
    [sym_nil] = STATE(8445),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(8446),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(12003),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(12005),
    [anon_sym_yield] = ACTIONS(12007),
    [anon_sym_break] = ACTIONS(12009),
    [anon_sym_next] = ACTIONS(12011),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(12013),
    [anon_sym_defined_QMARK] = ACTIONS(12015),
    [anon_sym_not] = ACTIONS(12017),
    [anon_sym_BANG] = ACTIONS(12019),
    [anon_sym_TILDE] = ACTIONS(12019),
    [sym_constant] = ACTIONS(12021),
    [sym_identifier] = ACTIONS(12021),
    [sym_instance_variable] = ACTIONS(12023),
    [sym_class_variable] = ACTIONS(12023),
    [sym_global_variable] = ACTIONS(12023),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(12021),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(12021),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9943] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(10760),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(8445),
    [sym_scope_resolution] = STATE(8443),
    [sym_call] = STATE(8443),
    [sym_method_call] = STATE(8445),
    [sym_assignment] = STATE(10760),
    [sym_operator_assignment] = STATE(10760),
    [sym_conditional] = STATE(10760),
    [sym_range] = STATE(10760),
    [sym_binary] = STATE(10760),
    [sym_unary] = STATE(10760),
    [sym_left_assignment_list] = STATE(8444),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(8445),
    [sym__variable] = STATE(8443),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(8445),
    [sym_false] = STATE(8445),
    [sym_nil] = STATE(8445),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(8446),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(12003),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(12005),
    [anon_sym_yield] = ACTIONS(12007),
    [anon_sym_break] = ACTIONS(12009),
    [anon_sym_next] = ACTIONS(12011),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(12013),
    [anon_sym_defined_QMARK] = ACTIONS(12015),
    [anon_sym_not] = ACTIONS(12017),
    [anon_sym_BANG] = ACTIONS(12019),
    [anon_sym_TILDE] = ACTIONS(12019),
    [sym_constant] = ACTIONS(12021),
    [sym_identifier] = ACTIONS(12021),
    [sym_instance_variable] = ACTIONS(12023),
    [sym_class_variable] = ACTIONS(12023),
    [sym_global_variable] = ACTIONS(12023),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(12021),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(12021),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9944] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(10761),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(8445),
    [sym_scope_resolution] = STATE(8443),
    [sym_call] = STATE(8443),
    [sym_method_call] = STATE(8445),
    [sym_assignment] = STATE(10761),
    [sym_operator_assignment] = STATE(10761),
    [sym_conditional] = STATE(10761),
    [sym_range] = STATE(10761),
    [sym_binary] = STATE(10761),
    [sym_unary] = STATE(10761),
    [sym_left_assignment_list] = STATE(8444),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(8445),
    [sym__variable] = STATE(8443),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(8445),
    [sym_false] = STATE(8445),
    [sym_nil] = STATE(8445),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(8446),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(12003),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(12005),
    [anon_sym_yield] = ACTIONS(12007),
    [anon_sym_break] = ACTIONS(12009),
    [anon_sym_next] = ACTIONS(12011),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(12013),
    [anon_sym_defined_QMARK] = ACTIONS(12015),
    [anon_sym_not] = ACTIONS(12017),
    [anon_sym_BANG] = ACTIONS(12019),
    [anon_sym_TILDE] = ACTIONS(12019),
    [sym_constant] = ACTIONS(12021),
    [sym_identifier] = ACTIONS(12021),
    [sym_instance_variable] = ACTIONS(12023),
    [sym_class_variable] = ACTIONS(12023),
    [sym_global_variable] = ACTIONS(12023),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(12021),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(12021),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9945] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(10769),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(10772),
    [sym_scope_resolution] = STATE(10770),
    [sym_call] = STATE(10770),
    [sym_method_call] = STATE(10772),
    [sym_assignment] = STATE(10769),
    [sym_operator_assignment] = STATE(10769),
    [sym_conditional] = STATE(10769),
    [sym_range] = STATE(10769),
    [sym_binary] = STATE(10769),
    [sym_unary] = STATE(10769),
    [sym_left_assignment_list] = STATE(10771),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10772),
    [sym__variable] = STATE(10770),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(10772),
    [sym_false] = STATE(10772),
    [sym_nil] = STATE(10772),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(10773),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(14506),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(14508),
    [anon_sym_yield] = ACTIONS(14510),
    [anon_sym_break] = ACTIONS(14512),
    [anon_sym_next] = ACTIONS(14514),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(14516),
    [anon_sym_defined_QMARK] = ACTIONS(14518),
    [anon_sym_not] = ACTIONS(14520),
    [anon_sym_BANG] = ACTIONS(14522),
    [anon_sym_TILDE] = ACTIONS(14522),
    [sym_constant] = ACTIONS(14524),
    [sym_identifier] = ACTIONS(14524),
    [sym_instance_variable] = ACTIONS(14526),
    [sym_class_variable] = ACTIONS(14526),
    [sym_global_variable] = ACTIONS(14526),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(14524),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14524),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [9946] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(10774),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(10772),
    [sym_scope_resolution] = STATE(10770),
    [sym_call] = STATE(10770),
    [sym_method_call] = STATE(10772),
    [sym_assignment] = STATE(10774),
    [sym_operator_assignment] = STATE(10774),
    [sym_conditional] = STATE(10774),
    [sym_range] = STATE(10774),
    [sym_binary] = STATE(10774),
    [sym_unary] = STATE(10774),
    [sym_left_assignment_list] = STATE(10771),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10772),
    [sym__variable] = STATE(10770),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(10772),
    [sym_false] = STATE(10772),
    [sym_nil] = STATE(10772),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(10773),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(14506),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(14508),
    [anon_sym_yield] = ACTIONS(14510),
    [anon_sym_break] = ACTIONS(14512),
    [anon_sym_next] = ACTIONS(14514),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(14516),
    [anon_sym_defined_QMARK] = ACTIONS(14518),
    [anon_sym_not] = ACTIONS(14520),
    [anon_sym_BANG] = ACTIONS(14522),
    [anon_sym_TILDE] = ACTIONS(14522),
    [sym_constant] = ACTIONS(14524),
    [sym_identifier] = ACTIONS(14524),
    [sym_instance_variable] = ACTIONS(14526),
    [sym_class_variable] = ACTIONS(14526),
    [sym_global_variable] = ACTIONS(14526),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(14524),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14524),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [9947] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(10775),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9962),
    [sym_scope_resolution] = STATE(9958),
    [sym_call] = STATE(9958),
    [sym_method_call] = STATE(9962),
    [sym_assignment] = STATE(10775),
    [sym_operator_assignment] = STATE(10775),
    [sym_conditional] = STATE(10775),
    [sym_range] = STATE(10775),
    [sym_binary] = STATE(10775),
    [sym_unary] = STATE(10775),
    [sym_left_assignment_list] = STATE(9961),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9962),
    [sym__variable] = STATE(9958),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9962),
    [sym_false] = STATE(9962),
    [sym_nil] = STATE(9962),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10776),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(13663),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13667),
    [anon_sym_yield] = ACTIONS(13669),
    [anon_sym_break] = ACTIONS(13671),
    [anon_sym_next] = ACTIONS(13673),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(14528),
    [anon_sym_defined_QMARK] = ACTIONS(13675),
    [anon_sym_not] = ACTIONS(13677),
    [anon_sym_BANG] = ACTIONS(13681),
    [anon_sym_TILDE] = ACTIONS(13681),
    [sym_constant] = ACTIONS(13687),
    [sym_identifier] = ACTIONS(13687),
    [sym_instance_variable] = ACTIONS(13685),
    [sym_class_variable] = ACTIONS(13685),
    [sym_global_variable] = ACTIONS(13685),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13687),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13687),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [9948] = {
    [anon_sym_COLON] = ACTIONS(14530),
    [sym_comment] = ACTIONS(87),
  },
  [9949] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(10778),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(10772),
    [sym_scope_resolution] = STATE(10770),
    [sym_call] = STATE(10770),
    [sym_method_call] = STATE(10772),
    [sym_assignment] = STATE(10778),
    [sym_operator_assignment] = STATE(10778),
    [sym_conditional] = STATE(10778),
    [sym_range] = STATE(10778),
    [sym_binary] = STATE(10778),
    [sym_unary] = STATE(10778),
    [sym_left_assignment_list] = STATE(10771),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10772),
    [sym__variable] = STATE(10770),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(10772),
    [sym_false] = STATE(10772),
    [sym_nil] = STATE(10772),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(10773),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(14506),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(14508),
    [anon_sym_yield] = ACTIONS(14510),
    [anon_sym_break] = ACTIONS(14512),
    [anon_sym_next] = ACTIONS(14514),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(14516),
    [anon_sym_defined_QMARK] = ACTIONS(14518),
    [anon_sym_not] = ACTIONS(14520),
    [anon_sym_BANG] = ACTIONS(14522),
    [anon_sym_TILDE] = ACTIONS(14522),
    [sym_constant] = ACTIONS(14524),
    [sym_identifier] = ACTIONS(14524),
    [sym_instance_variable] = ACTIONS(14526),
    [sym_class_variable] = ACTIONS(14526),
    [sym_global_variable] = ACTIONS(14526),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(14524),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14524),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [9950] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(10742),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9962),
    [sym_scope_resolution] = STATE(9958),
    [sym_call] = STATE(9958),
    [sym_method_call] = STATE(9962),
    [sym_argument_list] = STATE(1973),
    [sym__argument_list_with_parens] = STATE(10743),
    [sym__argument] = STATE(10744),
    [sym_splat_argument] = STATE(10744),
    [sym_hash_splat_argument] = STATE(10744),
    [sym_block_argument] = STATE(10744),
    [sym_assignment] = STATE(10742),
    [sym_operator_assignment] = STATE(10742),
    [sym_conditional] = STATE(10742),
    [sym_range] = STATE(10742),
    [sym_binary] = STATE(10742),
    [sym_unary] = STATE(10742),
    [sym_left_assignment_list] = STATE(9961),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9962),
    [sym__variable] = STATE(9958),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9962),
    [sym_false] = STATE(9962),
    [sym_nil] = STATE(9962),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10745),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(10744),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(14486),
    [sym__splat_star] = ACTIONS(14488),
    [sym__unary_minus] = ACTIONS(13663),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(14490),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13667),
    [anon_sym_yield] = ACTIONS(13669),
    [anon_sym_break] = ACTIONS(13671),
    [anon_sym_next] = ACTIONS(13673),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(365),
    [anon_sym_DASH_EQ] = ACTIONS(365),
    [anon_sym_STAR_EQ] = ACTIONS(365),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(365),
    [anon_sym_SLASH_EQ] = ACTIONS(365),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(365),
    [anon_sym_PIPE_EQ] = ACTIONS(365),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(365),
    [anon_sym_AMP_EQ] = ACTIONS(365),
    [anon_sym_PERCENT_EQ] = ACTIONS(365),
    [anon_sym_GT_GT_EQ] = ACTIONS(365),
    [anon_sym_LT_LT_EQ] = ACTIONS(365),
    [anon_sym_CARET_EQ] = ACTIONS(365),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_PERCENT] = ACTIONS(377),
    [anon_sym_defined_QMARK] = ACTIONS(13675),
    [anon_sym_not] = ACTIONS(13677),
    [anon_sym_BANG] = ACTIONS(13679),
    [anon_sym_TILDE] = ACTIONS(13681),
    [sym_constant] = ACTIONS(14492),
    [sym_identifier] = ACTIONS(14492),
    [sym_instance_variable] = ACTIONS(13685),
    [sym_class_variable] = ACTIONS(13685),
    [sym_global_variable] = ACTIONS(13685),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13687),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13687),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [9951] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(10742),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9962),
    [sym_scope_resolution] = STATE(9958),
    [sym_call] = STATE(9958),
    [sym_method_call] = STATE(9962),
    [sym_argument_list] = STATE(1974),
    [sym__argument_list_with_parens] = STATE(10743),
    [sym__argument] = STATE(10744),
    [sym_splat_argument] = STATE(10744),
    [sym_hash_splat_argument] = STATE(10744),
    [sym_block_argument] = STATE(10744),
    [sym_assignment] = STATE(10742),
    [sym_operator_assignment] = STATE(10742),
    [sym_conditional] = STATE(10742),
    [sym_range] = STATE(10742),
    [sym_binary] = STATE(10742),
    [sym_unary] = STATE(10742),
    [sym_left_assignment_list] = STATE(9961),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9962),
    [sym__variable] = STATE(9958),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9962),
    [sym_false] = STATE(9962),
    [sym_nil] = STATE(9962),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10745),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(10744),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(14486),
    [sym__splat_star] = ACTIONS(14488),
    [sym__unary_minus] = ACTIONS(13663),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(14490),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_EQ] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13667),
    [anon_sym_yield] = ACTIONS(13669),
    [anon_sym_break] = ACTIONS(13671),
    [anon_sym_next] = ACTIONS(13673),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(417),
    [anon_sym_DASH_EQ] = ACTIONS(417),
    [anon_sym_STAR_EQ] = ACTIONS(417),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(417),
    [anon_sym_SLASH_EQ] = ACTIONS(417),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(417),
    [anon_sym_PIPE_EQ] = ACTIONS(417),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(417),
    [anon_sym_AMP_EQ] = ACTIONS(417),
    [anon_sym_PERCENT_EQ] = ACTIONS(417),
    [anon_sym_GT_GT_EQ] = ACTIONS(417),
    [anon_sym_LT_LT_EQ] = ACTIONS(417),
    [anon_sym_CARET_EQ] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(13675),
    [anon_sym_not] = ACTIONS(13677),
    [anon_sym_BANG] = ACTIONS(13679),
    [anon_sym_TILDE] = ACTIONS(13681),
    [sym_constant] = ACTIONS(14492),
    [sym_identifier] = ACTIONS(14492),
    [sym_instance_variable] = ACTIONS(13685),
    [sym_class_variable] = ACTIONS(13685),
    [sym_global_variable] = ACTIONS(13685),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13687),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13687),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [9952] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(10742),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9962),
    [sym_scope_resolution] = STATE(9958),
    [sym_call] = STATE(9958),
    [sym_method_call] = STATE(9962),
    [sym_argument_list] = STATE(1975),
    [sym__argument_list_with_parens] = STATE(10743),
    [sym__argument] = STATE(10744),
    [sym_splat_argument] = STATE(10744),
    [sym_hash_splat_argument] = STATE(10744),
    [sym_block_argument] = STATE(10744),
    [sym_assignment] = STATE(10742),
    [sym_operator_assignment] = STATE(10742),
    [sym_conditional] = STATE(10742),
    [sym_range] = STATE(10742),
    [sym_binary] = STATE(10742),
    [sym_unary] = STATE(10742),
    [sym_left_assignment_list] = STATE(9961),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9962),
    [sym__variable] = STATE(9958),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9962),
    [sym_false] = STATE(9962),
    [sym_nil] = STATE(9962),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10745),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(10744),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(14486),
    [sym__splat_star] = ACTIONS(14488),
    [sym__unary_minus] = ACTIONS(13663),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(14490),
    [anon_sym_LBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_EQ] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13667),
    [anon_sym_yield] = ACTIONS(13669),
    [anon_sym_break] = ACTIONS(13671),
    [anon_sym_next] = ACTIONS(13673),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(421),
    [anon_sym_DASH_EQ] = ACTIONS(421),
    [anon_sym_STAR_EQ] = ACTIONS(421),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(421),
    [anon_sym_SLASH_EQ] = ACTIONS(421),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(421),
    [anon_sym_PIPE_EQ] = ACTIONS(421),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(421),
    [anon_sym_AMP_EQ] = ACTIONS(421),
    [anon_sym_PERCENT_EQ] = ACTIONS(421),
    [anon_sym_GT_GT_EQ] = ACTIONS(421),
    [anon_sym_LT_LT_EQ] = ACTIONS(421),
    [anon_sym_CARET_EQ] = ACTIONS(421),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(13675),
    [anon_sym_not] = ACTIONS(13677),
    [anon_sym_BANG] = ACTIONS(13679),
    [anon_sym_TILDE] = ACTIONS(13681),
    [sym_constant] = ACTIONS(14492),
    [sym_identifier] = ACTIONS(14492),
    [sym_instance_variable] = ACTIONS(13685),
    [sym_class_variable] = ACTIONS(13685),
    [sym_global_variable] = ACTIONS(13685),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13687),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13687),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [9953] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(10742),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9962),
    [sym_scope_resolution] = STATE(9958),
    [sym_call] = STATE(9958),
    [sym_method_call] = STATE(9962),
    [sym_argument_list] = STATE(1976),
    [sym__argument_list_with_parens] = STATE(10743),
    [sym__argument] = STATE(10744),
    [sym_splat_argument] = STATE(10744),
    [sym_hash_splat_argument] = STATE(10744),
    [sym_block_argument] = STATE(10744),
    [sym_assignment] = STATE(10742),
    [sym_operator_assignment] = STATE(10742),
    [sym_conditional] = STATE(10742),
    [sym_range] = STATE(10742),
    [sym_binary] = STATE(10742),
    [sym_unary] = STATE(10742),
    [sym_left_assignment_list] = STATE(9961),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9962),
    [sym__variable] = STATE(9958),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9962),
    [sym_false] = STATE(9962),
    [sym_nil] = STATE(9962),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10745),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(10744),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(14486),
    [sym__splat_star] = ACTIONS(14488),
    [sym__unary_minus] = ACTIONS(13663),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(14490),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(427),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13667),
    [anon_sym_yield] = ACTIONS(13669),
    [anon_sym_break] = ACTIONS(13671),
    [anon_sym_next] = ACTIONS(13673),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(425),
    [anon_sym_DASH_EQ] = ACTIONS(425),
    [anon_sym_STAR_EQ] = ACTIONS(425),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(425),
    [anon_sym_SLASH_EQ] = ACTIONS(425),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(425),
    [anon_sym_PIPE_EQ] = ACTIONS(425),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(425),
    [anon_sym_AMP_EQ] = ACTIONS(425),
    [anon_sym_PERCENT_EQ] = ACTIONS(425),
    [anon_sym_GT_GT_EQ] = ACTIONS(425),
    [anon_sym_LT_LT_EQ] = ACTIONS(425),
    [anon_sym_CARET_EQ] = ACTIONS(425),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(13675),
    [anon_sym_not] = ACTIONS(13677),
    [anon_sym_BANG] = ACTIONS(13679),
    [anon_sym_TILDE] = ACTIONS(13681),
    [sym_constant] = ACTIONS(14492),
    [sym_identifier] = ACTIONS(14492),
    [sym_instance_variable] = ACTIONS(13685),
    [sym_class_variable] = ACTIONS(13685),
    [sym_global_variable] = ACTIONS(13685),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13687),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13687),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [9954] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(10779),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9962),
    [sym_scope_resolution] = STATE(9958),
    [sym_call] = STATE(9958),
    [sym_method_call] = STATE(9962),
    [sym_assignment] = STATE(10779),
    [sym_operator_assignment] = STATE(10779),
    [sym_conditional] = STATE(10779),
    [sym_range] = STATE(10779),
    [sym_binary] = STATE(10779),
    [sym_unary] = STATE(10779),
    [sym_left_assignment_list] = STATE(9961),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9962),
    [sym__variable] = STATE(9958),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9962),
    [sym_false] = STATE(9962),
    [sym_nil] = STATE(9962),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10776),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(13663),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13667),
    [anon_sym_yield] = ACTIONS(13669),
    [anon_sym_break] = ACTIONS(13671),
    [anon_sym_next] = ACTIONS(13673),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(14528),
    [anon_sym_defined_QMARK] = ACTIONS(13675),
    [anon_sym_not] = ACTIONS(13677),
    [anon_sym_BANG] = ACTIONS(13681),
    [anon_sym_TILDE] = ACTIONS(13681),
    [sym_constant] = ACTIONS(13687),
    [sym_identifier] = ACTIONS(13687),
    [sym_instance_variable] = ACTIONS(13685),
    [sym_class_variable] = ACTIONS(13685),
    [sym_global_variable] = ACTIONS(13685),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13687),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13687),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [9955] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1997),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9962),
    [sym_scope_resolution] = STATE(9958),
    [sym_call] = STATE(9958),
    [sym_method_call] = STATE(9962),
    [sym_assignment] = STATE(1997),
    [sym_operator_assignment] = STATE(1997),
    [sym_conditional] = STATE(1997),
    [sym_range] = STATE(1997),
    [sym_binary] = STATE(1997),
    [sym_unary] = STATE(1997),
    [sym_left_assignment_list] = STATE(9961),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9962),
    [sym__variable] = STATE(9958),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9962),
    [sym_false] = STATE(9962),
    [sym_nil] = STATE(9962),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10776),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(13663),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13667),
    [anon_sym_yield] = ACTIONS(13669),
    [anon_sym_break] = ACTIONS(13671),
    [anon_sym_next] = ACTIONS(13673),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(14528),
    [anon_sym_defined_QMARK] = ACTIONS(13675),
    [anon_sym_not] = ACTIONS(13677),
    [anon_sym_BANG] = ACTIONS(13681),
    [anon_sym_TILDE] = ACTIONS(13681),
    [sym_constant] = ACTIONS(13687),
    [sym_identifier] = ACTIONS(13687),
    [sym_instance_variable] = ACTIONS(13685),
    [sym_class_variable] = ACTIONS(13685),
    [sym_global_variable] = ACTIONS(13685),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13687),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13687),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [9956] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(14532),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [9957] = {
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(14534),
    [sym__binary_star] = ACTIONS(14536),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(14538),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(14540),
    [anon_sym_AMP] = ACTIONS(14542),
    [anon_sym_EQ] = ACTIONS(1631),
    [anon_sym_LT] = ACTIONS(14544),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(14530),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_PLUS_EQ] = ACTIONS(1625),
    [anon_sym_DASH_EQ] = ACTIONS(1625),
    [anon_sym_STAR_EQ] = ACTIONS(1625),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1625),
    [anon_sym_SLASH_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1625),
    [anon_sym_AMP_EQ] = ACTIONS(1625),
    [anon_sym_PERCENT_EQ] = ACTIONS(1625),
    [anon_sym_GT_GT_EQ] = ACTIONS(1625),
    [anon_sym_LT_LT_EQ] = ACTIONS(1625),
    [anon_sym_CARET_EQ] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(14546),
    [anon_sym_DOT_DOT] = ACTIONS(14548),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14550),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(14552),
    [anon_sym_AMP_AMP] = ACTIONS(14552),
    [anon_sym_LT_LT] = ACTIONS(14554),
    [anon_sym_GT_GT] = ACTIONS(14554),
    [anon_sym_EQ_EQ] = ACTIONS(14552),
    [anon_sym_BANG_EQ] = ACTIONS(14556),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14556),
    [anon_sym_LT_EQ_GT] = ACTIONS(14556),
    [anon_sym_EQ_TILDE] = ACTIONS(14556),
    [anon_sym_BANG_TILDE] = ACTIONS(14556),
    [anon_sym_LT_EQ] = ACTIONS(14544),
    [anon_sym_GT] = ACTIONS(14544),
    [anon_sym_GT_EQ] = ACTIONS(14558),
    [anon_sym_CARET] = ACTIONS(14538),
    [anon_sym_PLUS] = ACTIONS(14560),
    [anon_sym_SLASH] = ACTIONS(14540),
    [anon_sym_PERCENT] = ACTIONS(14540),
    [sym_comment] = ACTIONS(87),
  },
  [9958] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(10742),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9962),
    [sym_scope_resolution] = STATE(9958),
    [sym_call] = STATE(9958),
    [sym_method_call] = STATE(9962),
    [sym_argument_list] = STATE(2016),
    [sym__argument_list_with_parens] = STATE(10743),
    [sym__argument] = STATE(10744),
    [sym_splat_argument] = STATE(10744),
    [sym_hash_splat_argument] = STATE(10744),
    [sym_block_argument] = STATE(10744),
    [sym_do_block] = STATE(1382),
    [sym_block] = STATE(1382),
    [sym_assignment] = STATE(10742),
    [sym_operator_assignment] = STATE(10742),
    [sym_conditional] = STATE(10742),
    [sym_range] = STATE(10742),
    [sym_binary] = STATE(10742),
    [sym_unary] = STATE(10742),
    [sym_left_assignment_list] = STATE(9961),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9962),
    [sym__variable] = STATE(9958),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9962),
    [sym_false] = STATE(9962),
    [sym_nil] = STATE(9962),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10745),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(10744),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(14486),
    [sym__splat_star] = ACTIONS(14488),
    [sym__unary_minus] = ACTIONS(13663),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(14490),
    [anon_sym_LBRACE] = ACTIONS(3537),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13667),
    [anon_sym_yield] = ACTIONS(13669),
    [anon_sym_break] = ACTIONS(13671),
    [anon_sym_next] = ACTIONS(13673),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(769),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(13675),
    [anon_sym_not] = ACTIONS(13677),
    [anon_sym_BANG] = ACTIONS(13679),
    [anon_sym_TILDE] = ACTIONS(13681),
    [sym_constant] = ACTIONS(14492),
    [sym_identifier] = ACTIONS(14492),
    [sym_instance_variable] = ACTIONS(13685),
    [sym_class_variable] = ACTIONS(13685),
    [sym_global_variable] = ACTIONS(13685),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13687),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13687),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [9959] = {
    [sym_heredoc_body] = STATE(10791),
    [aux_sym_call_repeat1] = STATE(10791),
    [sym__heredoc_body_start] = ACTIONS(6569),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [9960] = {
    [sym_heredoc_body] = STATE(10791),
    [aux_sym_call_repeat1] = STATE(10791),
    [aux_sym_argument_list_repeat1] = STATE(10793),
    [sym__heredoc_body_start] = ACTIONS(6569),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(14562),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [9961] = {
    [anon_sym_EQ] = ACTIONS(14564),
    [sym_comment] = ACTIONS(87),
  },
  [9962] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(14566),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(14568),
    [anon_sym_DASH_EQ] = ACTIONS(14568),
    [anon_sym_STAR_EQ] = ACTIONS(14568),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14568),
    [anon_sym_SLASH_EQ] = ACTIONS(14568),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14568),
    [anon_sym_PIPE_EQ] = ACTIONS(14568),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14568),
    [anon_sym_AMP_EQ] = ACTIONS(14568),
    [anon_sym_PERCENT_EQ] = ACTIONS(14568),
    [anon_sym_GT_GT_EQ] = ACTIONS(14568),
    [anon_sym_LT_LT_EQ] = ACTIONS(14568),
    [anon_sym_CARET_EQ] = ACTIONS(14568),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [9963] = {
    [sym_string] = STATE(10796),
    [aux_sym_chained_string_repeat1] = STATE(10796),
    [sym__string_start] = ACTIONS(1141),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(14570),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [9964] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(10798),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(8445),
    [sym_scope_resolution] = STATE(8443),
    [sym_call] = STATE(8443),
    [sym_method_call] = STATE(8445),
    [sym_splat_argument] = STATE(10799),
    [sym_assignment] = STATE(10798),
    [sym_operator_assignment] = STATE(10798),
    [sym_conditional] = STATE(10798),
    [sym_range] = STATE(10798),
    [sym_binary] = STATE(10798),
    [sym_unary] = STATE(10798),
    [sym_right_assignment_list] = STATE(2035),
    [sym__arg_or_splat_arg] = STATE(10799),
    [sym_left_assignment_list] = STATE(8444),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(8445),
    [sym__variable] = STATE(8443),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(8445),
    [sym_false] = STATE(8445),
    [sym_nil] = STATE(8445),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(8446),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__splat_star] = ACTIONS(14572),
    [sym__unary_minus] = ACTIONS(12003),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(12005),
    [anon_sym_yield] = ACTIONS(12007),
    [anon_sym_break] = ACTIONS(12009),
    [anon_sym_next] = ACTIONS(12011),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(12013),
    [anon_sym_defined_QMARK] = ACTIONS(12015),
    [anon_sym_not] = ACTIONS(12017),
    [anon_sym_BANG] = ACTIONS(12019),
    [anon_sym_TILDE] = ACTIONS(12019),
    [sym_constant] = ACTIONS(12021),
    [sym_identifier] = ACTIONS(12021),
    [sym_instance_variable] = ACTIONS(12023),
    [sym_class_variable] = ACTIONS(12023),
    [sym_global_variable] = ACTIONS(12023),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(12021),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(12021),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9965] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(10800),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(8445),
    [sym_scope_resolution] = STATE(8443),
    [sym_call] = STATE(8443),
    [sym_method_call] = STATE(8445),
    [sym_assignment] = STATE(10800),
    [sym_operator_assignment] = STATE(10800),
    [sym_conditional] = STATE(10800),
    [sym_range] = STATE(10800),
    [sym_binary] = STATE(10800),
    [sym_unary] = STATE(10800),
    [sym_left_assignment_list] = STATE(8444),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(8445),
    [sym__variable] = STATE(8443),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(8445),
    [sym_false] = STATE(8445),
    [sym_nil] = STATE(8445),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(8446),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(12003),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(12005),
    [anon_sym_yield] = ACTIONS(12007),
    [anon_sym_break] = ACTIONS(12009),
    [anon_sym_next] = ACTIONS(12011),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(12013),
    [anon_sym_defined_QMARK] = ACTIONS(12015),
    [anon_sym_not] = ACTIONS(12017),
    [anon_sym_BANG] = ACTIONS(12019),
    [anon_sym_TILDE] = ACTIONS(12019),
    [sym_constant] = ACTIONS(12021),
    [sym_identifier] = ACTIONS(12021),
    [sym_instance_variable] = ACTIONS(12023),
    [sym_class_variable] = ACTIONS(12023),
    [sym_global_variable] = ACTIONS(12023),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(12021),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(12021),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9966] = {
    [sym_string] = STATE(10801),
    [aux_sym_chained_string_repeat1] = STATE(10801),
    [sym__string_start] = ACTIONS(139),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [9967] = {
    [aux_sym_block_parameters_repeat1] = STATE(10802),
    [anon_sym_COMMA] = ACTIONS(11999),
    [anon_sym_PIPE] = ACTIONS(14417),
    [sym_comment] = ACTIONS(87),
  },
  [9968] = {
    [sym_identifier] = ACTIONS(14574),
    [sym_comment] = ACTIONS(87),
  },
  [9969] = {
    [sym__formal_parameter] = STATE(6106),
    [sym__simple_formal_parameter] = STATE(6106),
    [sym_destructured_parameter] = STATE(6106),
    [sym_splat_parameter] = STATE(6106),
    [sym_hash_splat_parameter] = STATE(6106),
    [sym_block_parameter] = STATE(6106),
    [sym_keyword_parameter] = STATE(6106),
    [sym_optional_parameter] = STATE(6106),
    [anon_sym_LPAREN] = ACTIONS(2447),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [sym_identifier] = ACTIONS(5745),
    [sym_comment] = ACTIONS(87),
  },
  [9970] = {
    [sym__line_break] = ACTIONS(14413),
    [sym__simple_symbol] = ACTIONS(14413),
    [sym__string_start] = ACTIONS(14413),
    [sym__symbol_start] = ACTIONS(14413),
    [sym__subshell_start] = ACTIONS(14413),
    [sym__regex_start] = ACTIONS(14413),
    [sym__string_array_start] = ACTIONS(14413),
    [sym__symbol_array_start] = ACTIONS(14413),
    [sym__heredoc_body_start] = ACTIONS(14413),
    [sym_heredoc_beginning] = ACTIONS(14413),
    [sym__unary_minus] = ACTIONS(14413),
    [anon_sym_BEGIN] = ACTIONS(14415),
    [anon_sym_LBRACE] = ACTIONS(14413),
    [anon_sym_END] = ACTIONS(14415),
    [anon_sym_def] = ACTIONS(14415),
    [anon_sym_LPAREN] = ACTIONS(14413),
    [anon_sym_COLON_COLON] = ACTIONS(14413),
    [anon_sym_SEMI] = ACTIONS(14413),
    [anon_sym_STAR] = ACTIONS(14413),
    [anon_sym_class] = ACTIONS(14415),
    [anon_sym_module] = ACTIONS(14415),
    [anon_sym_end] = ACTIONS(14415),
    [anon_sym_return] = ACTIONS(14415),
    [anon_sym_yield] = ACTIONS(14415),
    [anon_sym_break] = ACTIONS(14415),
    [anon_sym_next] = ACTIONS(14415),
    [sym_redo] = ACTIONS(14415),
    [sym_retry] = ACTIONS(14415),
    [anon_sym_if] = ACTIONS(14415),
    [anon_sym_unless] = ACTIONS(14415),
    [anon_sym_while] = ACTIONS(14415),
    [anon_sym_until] = ACTIONS(14415),
    [anon_sym_for] = ACTIONS(14415),
    [anon_sym_case] = ACTIONS(14415),
    [anon_sym_begin] = ACTIONS(14415),
    [anon_sym_PLUS] = ACTIONS(14415),
    [anon_sym_defined_QMARK] = ACTIONS(14413),
    [anon_sym_not] = ACTIONS(14415),
    [anon_sym_BANG] = ACTIONS(14413),
    [anon_sym_TILDE] = ACTIONS(14413),
    [sym_constant] = ACTIONS(14415),
    [sym_identifier] = ACTIONS(14415),
    [sym_instance_variable] = ACTIONS(14413),
    [sym_class_variable] = ACTIONS(14413),
    [sym_global_variable] = ACTIONS(14413),
    [anon_sym_undef] = ACTIONS(14415),
    [anon_sym_alias] = ACTIONS(14415),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(14415),
    [sym_float] = ACTIONS(14415),
    [sym_complex] = ACTIONS(14413),
    [sym_super] = ACTIONS(14415),
    [anon_sym_true] = ACTIONS(14415),
    [anon_sym_TRUE] = ACTIONS(14415),
    [anon_sym_false] = ACTIONS(14415),
    [anon_sym_FALSE] = ACTIONS(14415),
    [sym_self] = ACTIONS(14415),
    [anon_sym_nil] = ACTIONS(14415),
    [anon_sym_NIL] = ACTIONS(14415),
    [sym_character] = ACTIONS(14413),
    [anon_sym_LBRACK2] = ACTIONS(14413),
    [anon_sym_DASH_GT] = ACTIONS(14413),
  },
  [9971] = {
    [aux_sym_block_parameters_repeat1] = STATE(9913),
    [anon_sym_COMMA] = ACTIONS(11999),
    [anon_sym_PIPE] = ACTIONS(14576),
    [sym_comment] = ACTIONS(87),
  },
  [9972] = {
    [aux_sym_block_parameters_repeat1] = STATE(10805),
    [anon_sym_COMMA] = ACTIONS(11999),
    [anon_sym_PIPE] = ACTIONS(14576),
    [sym_comment] = ACTIONS(87),
  },
  [9973] = {
    [sym_identifier] = ACTIONS(14578),
    [sym_comment] = ACTIONS(87),
  },
  [9974] = {
    [sym__line_break] = ACTIONS(14580),
    [sym__heredoc_body_start] = ACTIONS(14580),
    [sym__binary_minus] = ACTIONS(14580),
    [sym__binary_star] = ACTIONS(14580),
    [ts_builtin_sym_end] = ACTIONS(14580),
    [anon_sym___END__] = ACTIONS(14580),
    [anon_sym_LBRACE] = ACTIONS(14580),
    [anon_sym_RBRACE] = ACTIONS(14580),
    [anon_sym_RPAREN] = ACTIONS(14580),
    [anon_sym_DOT] = ACTIONS(14582),
    [anon_sym_COMMA] = ACTIONS(14580),
    [anon_sym_PIPE] = ACTIONS(14582),
    [anon_sym_SEMI] = ACTIONS(14580),
    [anon_sym_STAR_STAR] = ACTIONS(14580),
    [anon_sym_AMP] = ACTIONS(14582),
    [anon_sym_LT] = ACTIONS(14582),
    [anon_sym_end] = ACTIONS(14580),
    [anon_sym_if] = ACTIONS(14580),
    [anon_sym_unless] = ACTIONS(14580),
    [anon_sym_while] = ACTIONS(14580),
    [anon_sym_until] = ACTIONS(14580),
    [anon_sym_rescue] = ACTIONS(14580),
    [anon_sym_do] = ACTIONS(14580),
    [anon_sym_when] = ACTIONS(14580),
    [anon_sym_elsif] = ACTIONS(14580),
    [anon_sym_else] = ACTIONS(14580),
    [anon_sym_then] = ACTIONS(14580),
    [anon_sym_ensure] = ACTIONS(14580),
    [anon_sym_EQ_GT] = ACTIONS(14580),
    [anon_sym_LBRACK] = ACTIONS(14580),
    [anon_sym_COLON_COLON2] = ACTIONS(14580),
    [anon_sym_AMP_DOT] = ACTIONS(14580),
    [anon_sym_QMARK] = ACTIONS(14580),
    [anon_sym_DOT_DOT] = ACTIONS(14582),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14580),
    [anon_sym_and] = ACTIONS(14580),
    [anon_sym_or] = ACTIONS(14580),
    [anon_sym_PIPE_PIPE] = ACTIONS(14580),
    [anon_sym_AMP_AMP] = ACTIONS(14580),
    [anon_sym_LT_LT] = ACTIONS(14580),
    [anon_sym_GT_GT] = ACTIONS(14580),
    [anon_sym_EQ_EQ] = ACTIONS(14582),
    [anon_sym_BANG_EQ] = ACTIONS(14580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14580),
    [anon_sym_LT_EQ_GT] = ACTIONS(14580),
    [anon_sym_EQ_TILDE] = ACTIONS(14580),
    [anon_sym_BANG_TILDE] = ACTIONS(14580),
    [anon_sym_LT_EQ] = ACTIONS(14582),
    [anon_sym_GT] = ACTIONS(14582),
    [anon_sym_GT_EQ] = ACTIONS(14580),
    [anon_sym_CARET] = ACTIONS(14580),
    [anon_sym_PLUS] = ACTIONS(14580),
    [anon_sym_SLASH] = ACTIONS(14580),
    [anon_sym_PERCENT] = ACTIONS(14580),
    [sym_comment] = ACTIONS(87),
  },
  [9975] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(10807),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(3496),
    [sym_scope_resolution] = STATE(3494),
    [sym_call] = STATE(3494),
    [sym_method_call] = STATE(3496),
    [sym_assignment] = STATE(10807),
    [sym_operator_assignment] = STATE(10807),
    [sym_conditional] = STATE(10807),
    [sym_range] = STATE(10807),
    [sym_binary] = STATE(10807),
    [sym_unary] = STATE(10807),
    [sym_left_assignment_list] = STATE(3495),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3496),
    [sym__variable] = STATE(3494),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(3496),
    [sym_false] = STATE(3496),
    [sym_nil] = STATE(3496),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(5781),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5785),
    [anon_sym_yield] = ACTIONS(5787),
    [anon_sym_break] = ACTIONS(5789),
    [anon_sym_next] = ACTIONS(5791),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5795),
    [anon_sym_defined_QMARK] = ACTIONS(5797),
    [anon_sym_not] = ACTIONS(5799),
    [anon_sym_BANG] = ACTIONS(5801),
    [anon_sym_TILDE] = ACTIONS(5801),
    [sym_constant] = ACTIONS(5803),
    [sym_identifier] = ACTIONS(5803),
    [sym_instance_variable] = ACTIONS(5805),
    [sym_class_variable] = ACTIONS(5805),
    [sym_global_variable] = ACTIONS(5805),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(5803),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(5803),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9976] = {
    [sym__binary_minus] = ACTIONS(9456),
    [sym__binary_star] = ACTIONS(9458),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(9462),
    [anon_sym_STAR_STAR] = ACTIONS(9458),
    [anon_sym_AMP] = ACTIONS(9464),
    [anon_sym_LT] = ACTIONS(9466),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(9468),
    [anon_sym_DOT_DOT] = ACTIONS(9470),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9472),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(9476),
    [anon_sym_AMP_AMP] = ACTIONS(9476),
    [anon_sym_LT_LT] = ACTIONS(9478),
    [anon_sym_GT_GT] = ACTIONS(9478),
    [anon_sym_EQ_EQ] = ACTIONS(9480),
    [anon_sym_BANG_EQ] = ACTIONS(9476),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9476),
    [anon_sym_LT_EQ_GT] = ACTIONS(9476),
    [anon_sym_EQ_TILDE] = ACTIONS(9476),
    [anon_sym_BANG_TILDE] = ACTIONS(9476),
    [anon_sym_LT_EQ] = ACTIONS(9466),
    [anon_sym_GT] = ACTIONS(9466),
    [anon_sym_GT_EQ] = ACTIONS(9482),
    [anon_sym_CARET] = ACTIONS(9484),
    [anon_sym_PLUS] = ACTIONS(9456),
    [anon_sym_SLASH] = ACTIONS(9458),
    [anon_sym_PERCENT] = ACTIONS(9458),
    [sym_comment] = ACTIONS(87),
  },
  [9977] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(8471),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(3496),
    [sym_scope_resolution] = STATE(3494),
    [sym_call] = STATE(3494),
    [sym_method_call] = STATE(3496),
    [sym_splat_argument] = STATE(6983),
    [sym_assignment] = STATE(8471),
    [sym_operator_assignment] = STATE(8471),
    [sym_conditional] = STATE(8471),
    [sym_range] = STATE(8471),
    [sym_binary] = STATE(8471),
    [sym_unary] = STATE(8471),
    [sym__arg_or_splat_arg] = STATE(6983),
    [sym_left_assignment_list] = STATE(3495),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3496),
    [sym__variable] = STATE(3494),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(3496),
    [sym_false] = STATE(3496),
    [sym_nil] = STATE(3496),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__splat_star] = ACTIONS(12064),
    [sym__unary_minus] = ACTIONS(5781),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5785),
    [anon_sym_yield] = ACTIONS(5787),
    [anon_sym_break] = ACTIONS(5789),
    [anon_sym_next] = ACTIONS(5791),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5795),
    [anon_sym_defined_QMARK] = ACTIONS(5797),
    [anon_sym_not] = ACTIONS(5799),
    [anon_sym_BANG] = ACTIONS(5801),
    [anon_sym_TILDE] = ACTIONS(5801),
    [sym_constant] = ACTIONS(5803),
    [sym_identifier] = ACTIONS(5803),
    [sym_instance_variable] = ACTIONS(5805),
    [sym_class_variable] = ACTIONS(5805),
    [sym_global_variable] = ACTIONS(5805),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(5803),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(5803),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9978] = {
    [aux_sym_exceptions_repeat1] = STATE(10808),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_LBRACE] = ACTIONS(9855),
    [anon_sym_COMMA] = ACTIONS(14584),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_do] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [9979] = {
    [sym_heredoc_body] = STATE(10809),
    [aux_sym_call_repeat1] = STATE(10809),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_COLON2] = ACTIONS(4385),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [9980] = {
    [sym_heredoc_body] = STATE(10810),
    [aux_sym_call_repeat1] = STATE(10810),
    [aux_sym_argument_list_repeat1] = STATE(8525),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(9577),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_COLON2] = ACTIONS(4385),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [9981] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(12068),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(12068),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_COLON2] = ACTIONS(5827),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(12068),
    [anon_sym_PERCENT] = ACTIONS(12068),
    [sym_comment] = ACTIONS(87),
  },
  [9982] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(12068),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_COLON2] = ACTIONS(5827),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [9983] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12066),
    [sym__binary_star] = ACTIONS(12068),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(12068),
    [anon_sym_AMP] = ACTIONS(12072),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_COLON2] = ACTIONS(5827),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(12084),
    [anon_sym_GT_GT] = ACTIONS(12084),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(12066),
    [anon_sym_SLASH] = ACTIONS(12068),
    [anon_sym_PERCENT] = ACTIONS(12068),
    [sym_comment] = ACTIONS(87),
  },
  [9984] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12066),
    [sym__binary_star] = ACTIONS(12068),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(12068),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_COLON2] = ACTIONS(5827),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(12084),
    [anon_sym_GT_GT] = ACTIONS(12084),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(12066),
    [anon_sym_SLASH] = ACTIONS(12068),
    [anon_sym_PERCENT] = ACTIONS(12068),
    [sym_comment] = ACTIONS(87),
  },
  [9985] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12066),
    [sym__binary_star] = ACTIONS(12068),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(12070),
    [anon_sym_STAR_STAR] = ACTIONS(12068),
    [anon_sym_AMP] = ACTIONS(12072),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_COLON2] = ACTIONS(5827),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(12084),
    [anon_sym_GT_GT] = ACTIONS(12084),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(12090),
    [anon_sym_PLUS] = ACTIONS(12066),
    [anon_sym_SLASH] = ACTIONS(12068),
    [anon_sym_PERCENT] = ACTIONS(12068),
    [sym_comment] = ACTIONS(87),
  },
  [9986] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(14586),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [9987] = {
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(12066),
    [sym__binary_star] = ACTIONS(12068),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(12070),
    [anon_sym_STAR_STAR] = ACTIONS(12068),
    [anon_sym_AMP] = ACTIONS(12072),
    [anon_sym_LT] = ACTIONS(12074),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_COLON2] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(12078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12080),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(12082),
    [anon_sym_AMP_AMP] = ACTIONS(12082),
    [anon_sym_LT_LT] = ACTIONS(12084),
    [anon_sym_GT_GT] = ACTIONS(12084),
    [anon_sym_EQ_EQ] = ACTIONS(12086),
    [anon_sym_BANG_EQ] = ACTIONS(12082),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12082),
    [anon_sym_LT_EQ_GT] = ACTIONS(12082),
    [anon_sym_EQ_TILDE] = ACTIONS(12082),
    [anon_sym_BANG_TILDE] = ACTIONS(12082),
    [anon_sym_LT_EQ] = ACTIONS(12074),
    [anon_sym_GT] = ACTIONS(12074),
    [anon_sym_GT_EQ] = ACTIONS(12088),
    [anon_sym_CARET] = ACTIONS(12090),
    [anon_sym_PLUS] = ACTIONS(12066),
    [anon_sym_SLASH] = ACTIONS(12068),
    [anon_sym_PERCENT] = ACTIONS(12068),
    [sym_comment] = ACTIONS(87),
  },
  [9988] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12066),
    [sym__binary_star] = ACTIONS(12068),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(12070),
    [anon_sym_STAR_STAR] = ACTIONS(12068),
    [anon_sym_AMP] = ACTIONS(12072),
    [anon_sym_LT] = ACTIONS(12074),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(12076),
    [anon_sym_COLON2] = ACTIONS(5827),
    [anon_sym_DOT_DOT] = ACTIONS(12078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12080),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(12082),
    [anon_sym_AMP_AMP] = ACTIONS(12082),
    [anon_sym_LT_LT] = ACTIONS(12084),
    [anon_sym_GT_GT] = ACTIONS(12084),
    [anon_sym_EQ_EQ] = ACTIONS(12086),
    [anon_sym_BANG_EQ] = ACTIONS(12082),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12082),
    [anon_sym_LT_EQ_GT] = ACTIONS(12082),
    [anon_sym_EQ_TILDE] = ACTIONS(12082),
    [anon_sym_BANG_TILDE] = ACTIONS(12082),
    [anon_sym_LT_EQ] = ACTIONS(12074),
    [anon_sym_GT] = ACTIONS(12074),
    [anon_sym_GT_EQ] = ACTIONS(12088),
    [anon_sym_CARET] = ACTIONS(12090),
    [anon_sym_PLUS] = ACTIONS(12066),
    [anon_sym_SLASH] = ACTIONS(12068),
    [anon_sym_PERCENT] = ACTIONS(12068),
    [sym_comment] = ACTIONS(87),
  },
  [9989] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12066),
    [sym__binary_star] = ACTIONS(12068),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(12070),
    [anon_sym_STAR_STAR] = ACTIONS(12068),
    [anon_sym_AMP] = ACTIONS(12072),
    [anon_sym_LT] = ACTIONS(12074),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_COLON2] = ACTIONS(5827),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(12084),
    [anon_sym_GT_GT] = ACTIONS(12084),
    [anon_sym_EQ_EQ] = ACTIONS(12086),
    [anon_sym_BANG_EQ] = ACTIONS(12082),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12082),
    [anon_sym_LT_EQ_GT] = ACTIONS(12082),
    [anon_sym_EQ_TILDE] = ACTIONS(12082),
    [anon_sym_BANG_TILDE] = ACTIONS(12082),
    [anon_sym_LT_EQ] = ACTIONS(12074),
    [anon_sym_GT] = ACTIONS(12074),
    [anon_sym_GT_EQ] = ACTIONS(12088),
    [anon_sym_CARET] = ACTIONS(12090),
    [anon_sym_PLUS] = ACTIONS(12066),
    [anon_sym_SLASH] = ACTIONS(12068),
    [anon_sym_PERCENT] = ACTIONS(12068),
    [sym_comment] = ACTIONS(87),
  },
  [9990] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12066),
    [sym__binary_star] = ACTIONS(12068),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(12068),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_COLON2] = ACTIONS(5827),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(12066),
    [anon_sym_SLASH] = ACTIONS(12068),
    [anon_sym_PERCENT] = ACTIONS(12068),
    [sym_comment] = ACTIONS(87),
  },
  [9991] = {
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(12066),
    [sym__binary_star] = ACTIONS(12068),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(12070),
    [anon_sym_STAR_STAR] = ACTIONS(12068),
    [anon_sym_AMP] = ACTIONS(12072),
    [anon_sym_LT] = ACTIONS(12074),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(12076),
    [anon_sym_COLON2] = ACTIONS(7936),
    [anon_sym_DOT_DOT] = ACTIONS(12078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12080),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(12082),
    [anon_sym_AMP_AMP] = ACTIONS(12082),
    [anon_sym_LT_LT] = ACTIONS(12084),
    [anon_sym_GT_GT] = ACTIONS(12084),
    [anon_sym_EQ_EQ] = ACTIONS(12086),
    [anon_sym_BANG_EQ] = ACTIONS(12082),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12082),
    [anon_sym_LT_EQ_GT] = ACTIONS(12082),
    [anon_sym_EQ_TILDE] = ACTIONS(12082),
    [anon_sym_BANG_TILDE] = ACTIONS(12082),
    [anon_sym_LT_EQ] = ACTIONS(12074),
    [anon_sym_GT] = ACTIONS(12074),
    [anon_sym_GT_EQ] = ACTIONS(12088),
    [anon_sym_CARET] = ACTIONS(12090),
    [anon_sym_PLUS] = ACTIONS(12066),
    [anon_sym_SLASH] = ACTIONS(12068),
    [anon_sym_PERCENT] = ACTIONS(12068),
    [sym_comment] = ACTIONS(87),
  },
  [9992] = {
    [aux_sym_exceptions_repeat1] = STATE(10813),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_COLON2] = ACTIONS(6193),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [9993] = {
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(12066),
    [sym__binary_star] = ACTIONS(12068),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(12070),
    [anon_sym_STAR_STAR] = ACTIONS(12068),
    [anon_sym_AMP] = ACTIONS(12072),
    [anon_sym_LT] = ACTIONS(12074),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(12076),
    [anon_sym_COLON2] = ACTIONS(7938),
    [anon_sym_DOT_DOT] = ACTIONS(12078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12080),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(12082),
    [anon_sym_AMP_AMP] = ACTIONS(12082),
    [anon_sym_LT_LT] = ACTIONS(12084),
    [anon_sym_GT_GT] = ACTIONS(12084),
    [anon_sym_EQ_EQ] = ACTIONS(12086),
    [anon_sym_BANG_EQ] = ACTIONS(12082),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12082),
    [anon_sym_LT_EQ_GT] = ACTIONS(12082),
    [anon_sym_EQ_TILDE] = ACTIONS(12082),
    [anon_sym_BANG_TILDE] = ACTIONS(12082),
    [anon_sym_LT_EQ] = ACTIONS(12074),
    [anon_sym_GT] = ACTIONS(12074),
    [anon_sym_GT_EQ] = ACTIONS(12088),
    [anon_sym_CARET] = ACTIONS(12090),
    [anon_sym_PLUS] = ACTIONS(12066),
    [anon_sym_SLASH] = ACTIONS(12068),
    [anon_sym_PERCENT] = ACTIONS(12068),
    [sym_comment] = ACTIONS(87),
  },
  [9994] = {
    [sym_string] = STATE(9994),
    [aux_sym_chained_string_repeat1] = STATE(9994),
    [sym__string_start] = ACTIONS(12850),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_COLON2] = ACTIONS(6217),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [9995] = {
    [sym__string_start] = ACTIONS(3030),
    [sym__heredoc_body_start] = ACTIONS(3030),
    [sym__binary_minus] = ACTIONS(3030),
    [sym__binary_star] = ACTIONS(3030),
    [anon_sym_DOT] = ACTIONS(3032),
    [anon_sym_COMMA] = ACTIONS(3030),
    [anon_sym_PIPE] = ACTIONS(3032),
    [anon_sym_STAR_STAR] = ACTIONS(3030),
    [anon_sym_AMP] = ACTIONS(3032),
    [anon_sym_LT] = ACTIONS(3032),
    [anon_sym_EQ_GT] = ACTIONS(3030),
    [anon_sym_LBRACK] = ACTIONS(3030),
    [anon_sym_COLON_COLON2] = ACTIONS(3030),
    [anon_sym_AMP_DOT] = ACTIONS(3030),
    [anon_sym_QMARK] = ACTIONS(3030),
    [anon_sym_COLON2] = ACTIONS(3032),
    [anon_sym_DOT_DOT] = ACTIONS(3032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3030),
    [anon_sym_and] = ACTIONS(3030),
    [anon_sym_or] = ACTIONS(3030),
    [anon_sym_PIPE_PIPE] = ACTIONS(3030),
    [anon_sym_AMP_AMP] = ACTIONS(3030),
    [anon_sym_LT_LT] = ACTIONS(3030),
    [anon_sym_GT_GT] = ACTIONS(3030),
    [anon_sym_EQ_EQ] = ACTIONS(3032),
    [anon_sym_BANG_EQ] = ACTIONS(3030),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3030),
    [anon_sym_LT_EQ_GT] = ACTIONS(3030),
    [anon_sym_EQ_TILDE] = ACTIONS(3030),
    [anon_sym_BANG_TILDE] = ACTIONS(3030),
    [anon_sym_LT_EQ] = ACTIONS(3032),
    [anon_sym_GT] = ACTIONS(3032),
    [anon_sym_GT_EQ] = ACTIONS(3030),
    [anon_sym_CARET] = ACTIONS(3030),
    [anon_sym_PLUS] = ACTIONS(3030),
    [anon_sym_SLASH] = ACTIONS(3030),
    [anon_sym_PERCENT] = ACTIONS(3030),
    [sym_comment] = ACTIONS(87),
  },
  [9996] = {
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(9543),
    [sym__binary_star] = ACTIONS(9545),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(9547),
    [anon_sym_STAR_STAR] = ACTIONS(9545),
    [anon_sym_AMP] = ACTIONS(9549),
    [anon_sym_LT] = ACTIONS(9551),
    [anon_sym_EQ_GT] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(9553),
    [anon_sym_COLON2] = ACTIONS(7822),
    [anon_sym_DOT_DOT] = ACTIONS(9555),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9557),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(9559),
    [anon_sym_AMP_AMP] = ACTIONS(9559),
    [anon_sym_LT_LT] = ACTIONS(9561),
    [anon_sym_GT_GT] = ACTIONS(9561),
    [anon_sym_EQ_EQ] = ACTIONS(9563),
    [anon_sym_BANG_EQ] = ACTIONS(9559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9559),
    [anon_sym_LT_EQ_GT] = ACTIONS(9559),
    [anon_sym_EQ_TILDE] = ACTIONS(9559),
    [anon_sym_BANG_TILDE] = ACTIONS(9559),
    [anon_sym_LT_EQ] = ACTIONS(9551),
    [anon_sym_GT] = ACTIONS(9551),
    [anon_sym_GT_EQ] = ACTIONS(9565),
    [anon_sym_CARET] = ACTIONS(9567),
    [anon_sym_PLUS] = ACTIONS(9543),
    [anon_sym_SLASH] = ACTIONS(9545),
    [anon_sym_PERCENT] = ACTIONS(9545),
    [sym_comment] = ACTIONS(87),
  },
  [9997] = {
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(9543),
    [sym__binary_star] = ACTIONS(9545),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(9547),
    [anon_sym_STAR_STAR] = ACTIONS(9545),
    [anon_sym_AMP] = ACTIONS(9549),
    [anon_sym_LT] = ACTIONS(9551),
    [anon_sym_EQ_GT] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(9553),
    [anon_sym_COLON2] = ACTIONS(7884),
    [anon_sym_DOT_DOT] = ACTIONS(9555),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9557),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(9559),
    [anon_sym_AMP_AMP] = ACTIONS(9559),
    [anon_sym_LT_LT] = ACTIONS(9561),
    [anon_sym_GT_GT] = ACTIONS(9561),
    [anon_sym_EQ_EQ] = ACTIONS(9563),
    [anon_sym_BANG_EQ] = ACTIONS(9559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9559),
    [anon_sym_LT_EQ_GT] = ACTIONS(9559),
    [anon_sym_EQ_TILDE] = ACTIONS(9559),
    [anon_sym_BANG_TILDE] = ACTIONS(9559),
    [anon_sym_LT_EQ] = ACTIONS(9551),
    [anon_sym_GT] = ACTIONS(9551),
    [anon_sym_GT_EQ] = ACTIONS(9565),
    [anon_sym_CARET] = ACTIONS(9567),
    [anon_sym_PLUS] = ACTIONS(9543),
    [anon_sym_SLASH] = ACTIONS(9545),
    [anon_sym_PERCENT] = ACTIONS(9545),
    [sym_comment] = ACTIONS(87),
  },
  [9998] = {
    [sym_heredoc_body] = STATE(9998),
    [aux_sym_call_repeat1] = STATE(9998),
    [sym__heredoc_body_start] = ACTIONS(10455),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_EQ_GT] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_COLON2] = ACTIONS(7919),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [9999] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(6158),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(3522),
    [sym_scope_resolution] = STATE(3518),
    [sym_call] = STATE(3518),
    [sym_method_call] = STATE(3522),
    [sym__argument] = STATE(6908),
    [sym_splat_argument] = STATE(6908),
    [sym_hash_splat_argument] = STATE(6908),
    [sym_block_argument] = STATE(6908),
    [sym_assignment] = STATE(6158),
    [sym_operator_assignment] = STATE(6158),
    [sym_conditional] = STATE(6158),
    [sym_range] = STATE(6158),
    [sym_binary] = STATE(6158),
    [sym_unary] = STATE(6158),
    [sym_left_assignment_list] = STATE(3521),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3522),
    [sym__variable] = STATE(3518),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(3522),
    [sym_false] = STATE(3522),
    [sym_nil] = STATE(3522),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(6161),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(6908),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(9533),
    [sym__splat_star] = ACTIONS(9535),
    [sym__unary_minus] = ACTIONS(5835),
    [sym__identifier_hash_key] = ACTIONS(9537),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13722),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5839),
    [anon_sym_yield] = ACTIONS(5841),
    [anon_sym_break] = ACTIONS(5843),
    [anon_sym_next] = ACTIONS(5845),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9529),
    [anon_sym_defined_QMARK] = ACTIONS(5847),
    [anon_sym_not] = ACTIONS(5849),
    [anon_sym_BANG] = ACTIONS(5853),
    [anon_sym_TILDE] = ACTIONS(5853),
    [sym_constant] = ACTIONS(9539),
    [sym_identifier] = ACTIONS(9539),
    [sym_instance_variable] = ACTIONS(5857),
    [sym_class_variable] = ACTIONS(5857),
    [sym_global_variable] = ACTIONS(5857),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5859),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5859),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10000] = {
    [sym_heredoc_body] = STATE(9998),
    [aux_sym_call_repeat1] = STATE(9998),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_EQ_GT] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_COLON2] = ACTIONS(7931),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [10001] = {
    [aux_sym_argument_list_repeat1] = STATE(10001),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(14588),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_STAR_STAR] = ACTIONS(7925),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_EQ_GT] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_COLON2] = ACTIONS(7927),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7925),
    [anon_sym_AMP_AMP] = ACTIONS(7925),
    [anon_sym_LT_LT] = ACTIONS(7925),
    [anon_sym_GT_GT] = ACTIONS(7925),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7925),
    [anon_sym_PLUS] = ACTIONS(7925),
    [anon_sym_SLASH] = ACTIONS(7925),
    [anon_sym_PERCENT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [10002] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(10814),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(3522),
    [sym_scope_resolution] = STATE(3518),
    [sym_call] = STATE(3518),
    [sym_method_call] = STATE(3522),
    [sym_assignment] = STATE(10814),
    [sym_operator_assignment] = STATE(10814),
    [sym_conditional] = STATE(10814),
    [sym_range] = STATE(10814),
    [sym_binary] = STATE(10814),
    [sym_unary] = STATE(10814),
    [sym_left_assignment_list] = STATE(3521),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3522),
    [sym__variable] = STATE(3518),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(3522),
    [sym_false] = STATE(3522),
    [sym_nil] = STATE(3522),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(6150),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(9527),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(5835),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5839),
    [anon_sym_yield] = ACTIONS(5841),
    [anon_sym_break] = ACTIONS(5843),
    [anon_sym_next] = ACTIONS(5845),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9529),
    [anon_sym_defined_QMARK] = ACTIONS(5847),
    [anon_sym_not] = ACTIONS(5849),
    [anon_sym_BANG] = ACTIONS(5853),
    [anon_sym_TILDE] = ACTIONS(5853),
    [sym_constant] = ACTIONS(5859),
    [sym_identifier] = ACTIONS(5859),
    [sym_instance_variable] = ACTIONS(5857),
    [sym_class_variable] = ACTIONS(5857),
    [sym_global_variable] = ACTIONS(5857),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5859),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5859),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10003] = {
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(9617),
    [sym__binary_star] = ACTIONS(9619),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(9621),
    [anon_sym_STAR_STAR] = ACTIONS(9623),
    [anon_sym_AMP] = ACTIONS(9625),
    [anon_sym_EQ] = ACTIONS(7822),
    [anon_sym_LT] = ACTIONS(9627),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_EQ_GT] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_PLUS_EQ] = ACTIONS(6823),
    [anon_sym_DASH_EQ] = ACTIONS(6823),
    [anon_sym_STAR_EQ] = ACTIONS(6823),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6823),
    [anon_sym_SLASH_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6823),
    [anon_sym_AMP_EQ] = ACTIONS(6823),
    [anon_sym_PERCENT_EQ] = ACTIONS(6823),
    [anon_sym_GT_GT_EQ] = ACTIONS(6823),
    [anon_sym_LT_LT_EQ] = ACTIONS(6823),
    [anon_sym_CARET_EQ] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(9629),
    [anon_sym_COLON2] = ACTIONS(7822),
    [anon_sym_DOT_DOT] = ACTIONS(9631),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9633),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(9635),
    [anon_sym_AMP_AMP] = ACTIONS(9635),
    [anon_sym_LT_LT] = ACTIONS(9637),
    [anon_sym_GT_GT] = ACTIONS(9637),
    [anon_sym_EQ_EQ] = ACTIONS(9635),
    [anon_sym_BANG_EQ] = ACTIONS(9639),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9639),
    [anon_sym_LT_EQ_GT] = ACTIONS(9639),
    [anon_sym_EQ_TILDE] = ACTIONS(9639),
    [anon_sym_BANG_TILDE] = ACTIONS(9639),
    [anon_sym_LT_EQ] = ACTIONS(9627),
    [anon_sym_GT] = ACTIONS(9627),
    [anon_sym_GT_EQ] = ACTIONS(9641),
    [anon_sym_CARET] = ACTIONS(9621),
    [anon_sym_PLUS] = ACTIONS(9643),
    [anon_sym_SLASH] = ACTIONS(9623),
    [anon_sym_PERCENT] = ACTIONS(9623),
    [sym_comment] = ACTIONS(87),
  },
  [10004] = {
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(9617),
    [sym__binary_star] = ACTIONS(9619),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(9621),
    [anon_sym_STAR_STAR] = ACTIONS(9623),
    [anon_sym_AMP] = ACTIONS(9625),
    [anon_sym_EQ] = ACTIONS(7884),
    [anon_sym_LT] = ACTIONS(9627),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_EQ_GT] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_PLUS_EQ] = ACTIONS(7027),
    [anon_sym_DASH_EQ] = ACTIONS(7027),
    [anon_sym_STAR_EQ] = ACTIONS(7027),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7027),
    [anon_sym_SLASH_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7027),
    [anon_sym_AMP_EQ] = ACTIONS(7027),
    [anon_sym_PERCENT_EQ] = ACTIONS(7027),
    [anon_sym_GT_GT_EQ] = ACTIONS(7027),
    [anon_sym_LT_LT_EQ] = ACTIONS(7027),
    [anon_sym_CARET_EQ] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(9629),
    [anon_sym_COLON2] = ACTIONS(7884),
    [anon_sym_DOT_DOT] = ACTIONS(9631),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9633),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(9635),
    [anon_sym_AMP_AMP] = ACTIONS(9635),
    [anon_sym_LT_LT] = ACTIONS(9637),
    [anon_sym_GT_GT] = ACTIONS(9637),
    [anon_sym_EQ_EQ] = ACTIONS(9635),
    [anon_sym_BANG_EQ] = ACTIONS(9639),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9639),
    [anon_sym_LT_EQ_GT] = ACTIONS(9639),
    [anon_sym_EQ_TILDE] = ACTIONS(9639),
    [anon_sym_BANG_TILDE] = ACTIONS(9639),
    [anon_sym_LT_EQ] = ACTIONS(9627),
    [anon_sym_GT] = ACTIONS(9627),
    [anon_sym_GT_EQ] = ACTIONS(9641),
    [anon_sym_CARET] = ACTIONS(9621),
    [anon_sym_PLUS] = ACTIONS(9643),
    [anon_sym_SLASH] = ACTIONS(9623),
    [anon_sym_PERCENT] = ACTIONS(9623),
    [sym_comment] = ACTIONS(87),
  },
  [10005] = {
    [sym_heredoc_body] = STATE(10005),
    [aux_sym_call_repeat1] = STATE(10005),
    [sym__heredoc_body_start] = ACTIONS(10553),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_STAR_STAR] = ACTIONS(7919),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_EQ] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_EQ_GT] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_PLUS_EQ] = ACTIONS(7914),
    [anon_sym_DASH_EQ] = ACTIONS(7914),
    [anon_sym_STAR_EQ] = ACTIONS(7914),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7914),
    [anon_sym_SLASH_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7914),
    [anon_sym_AMP_EQ] = ACTIONS(7914),
    [anon_sym_PERCENT_EQ] = ACTIONS(7914),
    [anon_sym_GT_GT_EQ] = ACTIONS(7914),
    [anon_sym_LT_LT_EQ] = ACTIONS(7914),
    [anon_sym_CARET_EQ] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_COLON2] = ACTIONS(7919),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7919),
    [anon_sym_AMP_AMP] = ACTIONS(7919),
    [anon_sym_LT_LT] = ACTIONS(7919),
    [anon_sym_GT_GT] = ACTIONS(7919),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7919),
    [anon_sym_PLUS] = ACTIONS(7919),
    [anon_sym_SLASH] = ACTIONS(7919),
    [anon_sym_PERCENT] = ACTIONS(7919),
    [sym_comment] = ACTIONS(87),
  },
  [10006] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6179),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3553),
    [sym_scope_resolution] = STATE(3549),
    [sym_call] = STATE(3549),
    [sym_method_call] = STATE(3553),
    [sym__argument] = STATE(6970),
    [sym_splat_argument] = STATE(6970),
    [sym_hash_splat_argument] = STATE(6970),
    [sym_block_argument] = STATE(6970),
    [sym_assignment] = STATE(6179),
    [sym_operator_assignment] = STATE(6179),
    [sym_conditional] = STATE(6179),
    [sym_range] = STATE(6179),
    [sym_binary] = STATE(6179),
    [sym_unary] = STATE(6179),
    [sym_left_assignment_list] = STATE(3552),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3553),
    [sym__variable] = STATE(3549),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3553),
    [sym_false] = STATE(3553),
    [sym_nil] = STATE(3553),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6182),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(6970),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(9569),
    [sym__splat_star] = ACTIONS(9571),
    [sym__unary_minus] = ACTIONS(5895),
    [sym__identifier_hash_key] = ACTIONS(9573),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13726),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5899),
    [anon_sym_yield] = ACTIONS(5901),
    [anon_sym_break] = ACTIONS(5903),
    [anon_sym_next] = ACTIONS(5905),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(9611),
    [anon_sym_defined_QMARK] = ACTIONS(5907),
    [anon_sym_not] = ACTIONS(5909),
    [anon_sym_BANG] = ACTIONS(5913),
    [anon_sym_TILDE] = ACTIONS(5913),
    [sym_constant] = ACTIONS(9575),
    [sym_identifier] = ACTIONS(9575),
    [sym_instance_variable] = ACTIONS(5917),
    [sym_class_variable] = ACTIONS(5917),
    [sym_global_variable] = ACTIONS(5917),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5919),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5919),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [10007] = {
    [sym_heredoc_body] = STATE(10005),
    [aux_sym_call_repeat1] = STATE(10005),
    [sym__heredoc_body_start] = ACTIONS(3543),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_STAR_STAR] = ACTIONS(7931),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_EQ] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_EQ_GT] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_PLUS_EQ] = ACTIONS(7929),
    [anon_sym_DASH_EQ] = ACTIONS(7929),
    [anon_sym_STAR_EQ] = ACTIONS(7929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7929),
    [anon_sym_SLASH_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7929),
    [anon_sym_AMP_EQ] = ACTIONS(7929),
    [anon_sym_PERCENT_EQ] = ACTIONS(7929),
    [anon_sym_GT_GT_EQ] = ACTIONS(7929),
    [anon_sym_LT_LT_EQ] = ACTIONS(7929),
    [anon_sym_CARET_EQ] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_COLON2] = ACTIONS(7931),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7931),
    [anon_sym_AMP_AMP] = ACTIONS(7931),
    [anon_sym_LT_LT] = ACTIONS(7931),
    [anon_sym_GT_GT] = ACTIONS(7931),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7931),
    [anon_sym_PLUS] = ACTIONS(7931),
    [anon_sym_SLASH] = ACTIONS(7931),
    [anon_sym_PERCENT] = ACTIONS(7931),
    [sym_comment] = ACTIONS(87),
  },
  [10008] = {
    [aux_sym_argument_list_repeat1] = STATE(10008),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(14591),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_STAR_STAR] = ACTIONS(7927),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_EQ] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_EQ_GT] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_PLUS_EQ] = ACTIONS(7925),
    [anon_sym_DASH_EQ] = ACTIONS(7925),
    [anon_sym_STAR_EQ] = ACTIONS(7925),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7925),
    [anon_sym_SLASH_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7925),
    [anon_sym_AMP_EQ] = ACTIONS(7925),
    [anon_sym_PERCENT_EQ] = ACTIONS(7925),
    [anon_sym_GT_GT_EQ] = ACTIONS(7925),
    [anon_sym_LT_LT_EQ] = ACTIONS(7925),
    [anon_sym_CARET_EQ] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_COLON2] = ACTIONS(7927),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7927),
    [anon_sym_AMP_AMP] = ACTIONS(7927),
    [anon_sym_LT_LT] = ACTIONS(7927),
    [anon_sym_GT_GT] = ACTIONS(7927),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7927),
    [anon_sym_PLUS] = ACTIONS(7927),
    [anon_sym_SLASH] = ACTIONS(7927),
    [anon_sym_PERCENT] = ACTIONS(7927),
    [sym_comment] = ACTIONS(87),
  },
  [10009] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(8526),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(3522),
    [sym_scope_resolution] = STATE(3518),
    [sym_call] = STATE(3518),
    [sym_method_call] = STATE(3522),
    [sym_splat_argument] = STATE(9013),
    [sym_assignment] = STATE(8526),
    [sym_operator_assignment] = STATE(8526),
    [sym_conditional] = STATE(8526),
    [sym_range] = STATE(8526),
    [sym_binary] = STATE(8526),
    [sym_unary] = STATE(8526),
    [sym__arg_or_splat_arg] = STATE(9013),
    [sym_left_assignment_list] = STATE(3521),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3522),
    [sym__variable] = STATE(3518),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(3522),
    [sym_false] = STATE(3522),
    [sym_nil] = STATE(3522),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(6150),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(9527),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(9535),
    [sym__unary_minus] = ACTIONS(5835),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5839),
    [anon_sym_yield] = ACTIONS(5841),
    [anon_sym_break] = ACTIONS(5843),
    [anon_sym_next] = ACTIONS(5845),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9529),
    [anon_sym_defined_QMARK] = ACTIONS(5847),
    [anon_sym_not] = ACTIONS(5849),
    [anon_sym_BANG] = ACTIONS(5853),
    [anon_sym_TILDE] = ACTIONS(5853),
    [sym_constant] = ACTIONS(5859),
    [sym_identifier] = ACTIONS(5859),
    [sym_instance_variable] = ACTIONS(5857),
    [sym_class_variable] = ACTIONS(5857),
    [sym_global_variable] = ACTIONS(5857),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5859),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5859),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10010] = {
    [aux_sym_exceptions_repeat1] = STATE(10815),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(14594),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_EQ_GT] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_COLON2] = ACTIONS(9857),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [10011] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(12120),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [10012] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(12124),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(12128),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_COLON2] = ACTIONS(5827),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(12128),
    [anon_sym_PERCENT] = ACTIONS(12128),
    [sym_comment] = ACTIONS(87),
  },
  [10013] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(12128),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_COLON2] = ACTIONS(5827),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(5827),
    [anon_sym_PERCENT] = ACTIONS(5827),
    [sym_comment] = ACTIONS(87),
  },
  [10014] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12122),
    [sym__binary_star] = ACTIONS(12124),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(12128),
    [anon_sym_AMP] = ACTIONS(12130),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_COLON2] = ACTIONS(5827),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(12142),
    [anon_sym_GT_GT] = ACTIONS(12142),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(12148),
    [anon_sym_SLASH] = ACTIONS(12128),
    [anon_sym_PERCENT] = ACTIONS(12128),
    [sym_comment] = ACTIONS(87),
  },
  [10015] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12122),
    [sym__binary_star] = ACTIONS(12124),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(12128),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_COLON2] = ACTIONS(5827),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(12142),
    [anon_sym_GT_GT] = ACTIONS(12142),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(12148),
    [anon_sym_SLASH] = ACTIONS(12128),
    [anon_sym_PERCENT] = ACTIONS(12128),
    [sym_comment] = ACTIONS(87),
  },
  [10016] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12122),
    [sym__binary_star] = ACTIONS(12124),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(12126),
    [anon_sym_STAR_STAR] = ACTIONS(12128),
    [anon_sym_AMP] = ACTIONS(12130),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_COLON2] = ACTIONS(5827),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(12142),
    [anon_sym_GT_GT] = ACTIONS(12142),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(12126),
    [anon_sym_PLUS] = ACTIONS(12148),
    [anon_sym_SLASH] = ACTIONS(12128),
    [anon_sym_PERCENT] = ACTIONS(12128),
    [sym_comment] = ACTIONS(87),
  },
  [10017] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(14596),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [10018] = {
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(12122),
    [sym__binary_star] = ACTIONS(12124),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(12126),
    [anon_sym_STAR_STAR] = ACTIONS(12128),
    [anon_sym_AMP] = ACTIONS(12130),
    [anon_sym_EQ] = ACTIONS(7888),
    [anon_sym_LT] = ACTIONS(12132),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_PLUS_EQ] = ACTIONS(5927),
    [anon_sym_DASH_EQ] = ACTIONS(5927),
    [anon_sym_STAR_EQ] = ACTIONS(5927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5927),
    [anon_sym_SLASH_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5927),
    [anon_sym_AMP_EQ] = ACTIONS(5927),
    [anon_sym_PERCENT_EQ] = ACTIONS(5927),
    [anon_sym_GT_GT_EQ] = ACTIONS(5927),
    [anon_sym_LT_LT_EQ] = ACTIONS(5927),
    [anon_sym_CARET_EQ] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_COLON2] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(12136),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12138),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(12140),
    [anon_sym_AMP_AMP] = ACTIONS(12140),
    [anon_sym_LT_LT] = ACTIONS(12142),
    [anon_sym_GT_GT] = ACTIONS(12142),
    [anon_sym_EQ_EQ] = ACTIONS(12140),
    [anon_sym_BANG_EQ] = ACTIONS(12144),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12144),
    [anon_sym_LT_EQ_GT] = ACTIONS(12144),
    [anon_sym_EQ_TILDE] = ACTIONS(12144),
    [anon_sym_BANG_TILDE] = ACTIONS(12144),
    [anon_sym_LT_EQ] = ACTIONS(12132),
    [anon_sym_GT] = ACTIONS(12132),
    [anon_sym_GT_EQ] = ACTIONS(12146),
    [anon_sym_CARET] = ACTIONS(12126),
    [anon_sym_PLUS] = ACTIONS(12148),
    [anon_sym_SLASH] = ACTIONS(12128),
    [anon_sym_PERCENT] = ACTIONS(12128),
    [sym_comment] = ACTIONS(87),
  },
  [10019] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12122),
    [sym__binary_star] = ACTIONS(12124),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(12126),
    [anon_sym_STAR_STAR] = ACTIONS(12128),
    [anon_sym_AMP] = ACTIONS(12130),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(12132),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(12134),
    [anon_sym_COLON2] = ACTIONS(5827),
    [anon_sym_DOT_DOT] = ACTIONS(12136),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12138),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(12140),
    [anon_sym_AMP_AMP] = ACTIONS(12140),
    [anon_sym_LT_LT] = ACTIONS(12142),
    [anon_sym_GT_GT] = ACTIONS(12142),
    [anon_sym_EQ_EQ] = ACTIONS(12140),
    [anon_sym_BANG_EQ] = ACTIONS(12144),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12144),
    [anon_sym_LT_EQ_GT] = ACTIONS(12144),
    [anon_sym_EQ_TILDE] = ACTIONS(12144),
    [anon_sym_BANG_TILDE] = ACTIONS(12144),
    [anon_sym_LT_EQ] = ACTIONS(12132),
    [anon_sym_GT] = ACTIONS(12132),
    [anon_sym_GT_EQ] = ACTIONS(12146),
    [anon_sym_CARET] = ACTIONS(12126),
    [anon_sym_PLUS] = ACTIONS(12148),
    [anon_sym_SLASH] = ACTIONS(12128),
    [anon_sym_PERCENT] = ACTIONS(12128),
    [sym_comment] = ACTIONS(87),
  },
  [10020] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12122),
    [sym__binary_star] = ACTIONS(12124),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(12126),
    [anon_sym_STAR_STAR] = ACTIONS(12128),
    [anon_sym_AMP] = ACTIONS(12130),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(12132),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_COLON2] = ACTIONS(5827),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(12142),
    [anon_sym_GT_GT] = ACTIONS(12142),
    [anon_sym_EQ_EQ] = ACTIONS(12140),
    [anon_sym_BANG_EQ] = ACTIONS(12144),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12144),
    [anon_sym_LT_EQ_GT] = ACTIONS(12144),
    [anon_sym_EQ_TILDE] = ACTIONS(12144),
    [anon_sym_BANG_TILDE] = ACTIONS(12144),
    [anon_sym_LT_EQ] = ACTIONS(12132),
    [anon_sym_GT] = ACTIONS(12132),
    [anon_sym_GT_EQ] = ACTIONS(12146),
    [anon_sym_CARET] = ACTIONS(12126),
    [anon_sym_PLUS] = ACTIONS(12148),
    [anon_sym_SLASH] = ACTIONS(12128),
    [anon_sym_PERCENT] = ACTIONS(12128),
    [sym_comment] = ACTIONS(87),
  },
  [10021] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12122),
    [sym__binary_star] = ACTIONS(12124),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(12128),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_COLON2] = ACTIONS(5827),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(12148),
    [anon_sym_SLASH] = ACTIONS(12128),
    [anon_sym_PERCENT] = ACTIONS(12128),
    [sym_comment] = ACTIONS(87),
  },
  [10022] = {
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(12122),
    [sym__binary_star] = ACTIONS(12124),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(12126),
    [anon_sym_STAR_STAR] = ACTIONS(12128),
    [anon_sym_AMP] = ACTIONS(12130),
    [anon_sym_EQ] = ACTIONS(7936),
    [anon_sym_LT] = ACTIONS(12132),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_PLUS_EQ] = ACTIONS(5115),
    [anon_sym_DASH_EQ] = ACTIONS(5115),
    [anon_sym_STAR_EQ] = ACTIONS(5115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5115),
    [anon_sym_SLASH_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5115),
    [anon_sym_AMP_EQ] = ACTIONS(5115),
    [anon_sym_PERCENT_EQ] = ACTIONS(5115),
    [anon_sym_GT_GT_EQ] = ACTIONS(5115),
    [anon_sym_LT_LT_EQ] = ACTIONS(5115),
    [anon_sym_CARET_EQ] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(12134),
    [anon_sym_COLON2] = ACTIONS(7936),
    [anon_sym_DOT_DOT] = ACTIONS(12136),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12138),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(12140),
    [anon_sym_AMP_AMP] = ACTIONS(12140),
    [anon_sym_LT_LT] = ACTIONS(12142),
    [anon_sym_GT_GT] = ACTIONS(12142),
    [anon_sym_EQ_EQ] = ACTIONS(12140),
    [anon_sym_BANG_EQ] = ACTIONS(12144),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12144),
    [anon_sym_LT_EQ_GT] = ACTIONS(12144),
    [anon_sym_EQ_TILDE] = ACTIONS(12144),
    [anon_sym_BANG_TILDE] = ACTIONS(12144),
    [anon_sym_LT_EQ] = ACTIONS(12132),
    [anon_sym_GT] = ACTIONS(12132),
    [anon_sym_GT_EQ] = ACTIONS(12146),
    [anon_sym_CARET] = ACTIONS(12126),
    [anon_sym_PLUS] = ACTIONS(12148),
    [anon_sym_SLASH] = ACTIONS(12128),
    [anon_sym_PERCENT] = ACTIONS(12128),
    [sym_comment] = ACTIONS(87),
  },
  [10023] = {
    [aux_sym_exceptions_repeat1] = STATE(10818),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_STAR_STAR] = ACTIONS(6193),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_PLUS_EQ] = ACTIONS(6191),
    [anon_sym_DASH_EQ] = ACTIONS(6191),
    [anon_sym_STAR_EQ] = ACTIONS(6191),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6191),
    [anon_sym_SLASH_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6191),
    [anon_sym_AMP_EQ] = ACTIONS(6191),
    [anon_sym_PERCENT_EQ] = ACTIONS(6191),
    [anon_sym_GT_GT_EQ] = ACTIONS(6191),
    [anon_sym_LT_LT_EQ] = ACTIONS(6191),
    [anon_sym_CARET_EQ] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_COLON2] = ACTIONS(6193),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6193),
    [anon_sym_AMP_AMP] = ACTIONS(6193),
    [anon_sym_LT_LT] = ACTIONS(6193),
    [anon_sym_GT_GT] = ACTIONS(6193),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6193),
    [anon_sym_PLUS] = ACTIONS(6193),
    [anon_sym_SLASH] = ACTIONS(6193),
    [anon_sym_PERCENT] = ACTIONS(6193),
    [sym_comment] = ACTIONS(87),
  },
  [10024] = {
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(12122),
    [sym__binary_star] = ACTIONS(12124),
    [anon_sym_LBRACE] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(12126),
    [anon_sym_STAR_STAR] = ACTIONS(12128),
    [anon_sym_AMP] = ACTIONS(12130),
    [anon_sym_EQ] = ACTIONS(7938),
    [anon_sym_LT] = ACTIONS(12132),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_PLUS_EQ] = ACTIONS(6210),
    [anon_sym_DASH_EQ] = ACTIONS(6210),
    [anon_sym_STAR_EQ] = ACTIONS(6210),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6210),
    [anon_sym_SLASH_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6210),
    [anon_sym_AMP_EQ] = ACTIONS(6210),
    [anon_sym_PERCENT_EQ] = ACTIONS(6210),
    [anon_sym_GT_GT_EQ] = ACTIONS(6210),
    [anon_sym_LT_LT_EQ] = ACTIONS(6210),
    [anon_sym_CARET_EQ] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(12134),
    [anon_sym_COLON2] = ACTIONS(7938),
    [anon_sym_DOT_DOT] = ACTIONS(12136),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12138),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(12140),
    [anon_sym_AMP_AMP] = ACTIONS(12140),
    [anon_sym_LT_LT] = ACTIONS(12142),
    [anon_sym_GT_GT] = ACTIONS(12142),
    [anon_sym_EQ_EQ] = ACTIONS(12140),
    [anon_sym_BANG_EQ] = ACTIONS(12144),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12144),
    [anon_sym_LT_EQ_GT] = ACTIONS(12144),
    [anon_sym_EQ_TILDE] = ACTIONS(12144),
    [anon_sym_BANG_TILDE] = ACTIONS(12144),
    [anon_sym_LT_EQ] = ACTIONS(12132),
    [anon_sym_GT] = ACTIONS(12132),
    [anon_sym_GT_EQ] = ACTIONS(12146),
    [anon_sym_CARET] = ACTIONS(12126),
    [anon_sym_PLUS] = ACTIONS(12148),
    [anon_sym_SLASH] = ACTIONS(12128),
    [anon_sym_PERCENT] = ACTIONS(12128),
    [sym_comment] = ACTIONS(87),
  },
  [10025] = {
    [sym_string] = STATE(10025),
    [aux_sym_chained_string_repeat1] = STATE(10025),
    [sym__string_start] = ACTIONS(13881),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_STAR_STAR] = ACTIONS(6217),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_EQ] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_do] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_PLUS_EQ] = ACTIONS(6212),
    [anon_sym_DASH_EQ] = ACTIONS(6212),
    [anon_sym_STAR_EQ] = ACTIONS(6212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6212),
    [anon_sym_SLASH_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6212),
    [anon_sym_AMP_EQ] = ACTIONS(6212),
    [anon_sym_PERCENT_EQ] = ACTIONS(6212),
    [anon_sym_GT_GT_EQ] = ACTIONS(6212),
    [anon_sym_LT_LT_EQ] = ACTIONS(6212),
    [anon_sym_CARET_EQ] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_COLON2] = ACTIONS(6217),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6217),
    [anon_sym_AMP_AMP] = ACTIONS(6217),
    [anon_sym_LT_LT] = ACTIONS(6217),
    [anon_sym_GT_GT] = ACTIONS(6217),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6217),
    [anon_sym_PLUS] = ACTIONS(6217),
    [anon_sym_SLASH] = ACTIONS(6217),
    [anon_sym_PERCENT] = ACTIONS(6217),
    [sym_comment] = ACTIONS(87),
  },
  [10026] = {
    [sym__string_start] = ACTIONS(3030),
    [sym__heredoc_body_start] = ACTIONS(3030),
    [sym__binary_minus] = ACTIONS(3030),
    [sym__binary_star] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3030),
    [anon_sym_DOT] = ACTIONS(3032),
    [anon_sym_COMMA] = ACTIONS(3030),
    [anon_sym_PIPE] = ACTIONS(3032),
    [anon_sym_STAR_STAR] = ACTIONS(3032),
    [anon_sym_AMP] = ACTIONS(3032),
    [anon_sym_EQ] = ACTIONS(3032),
    [anon_sym_LT] = ACTIONS(3032),
    [anon_sym_do] = ACTIONS(3030),
    [anon_sym_EQ_GT] = ACTIONS(3030),
    [anon_sym_LBRACK] = ACTIONS(3030),
    [anon_sym_COLON_COLON2] = ACTIONS(3030),
    [anon_sym_AMP_DOT] = ACTIONS(3030),
    [anon_sym_PLUS_EQ] = ACTIONS(3030),
    [anon_sym_DASH_EQ] = ACTIONS(3030),
    [anon_sym_STAR_EQ] = ACTIONS(3030),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3030),
    [anon_sym_SLASH_EQ] = ACTIONS(3030),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3030),
    [anon_sym_PIPE_EQ] = ACTIONS(3030),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3030),
    [anon_sym_AMP_EQ] = ACTIONS(3030),
    [anon_sym_PERCENT_EQ] = ACTIONS(3030),
    [anon_sym_GT_GT_EQ] = ACTIONS(3030),
    [anon_sym_LT_LT_EQ] = ACTIONS(3030),
    [anon_sym_CARET_EQ] = ACTIONS(3030),
    [anon_sym_QMARK] = ACTIONS(3030),
    [anon_sym_COLON2] = ACTIONS(3032),
    [anon_sym_DOT_DOT] = ACTIONS(3032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3030),
    [anon_sym_and] = ACTIONS(3030),
    [anon_sym_or] = ACTIONS(3030),
    [anon_sym_PIPE_PIPE] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_LT_LT] = ACTIONS(3032),
    [anon_sym_GT_GT] = ACTIONS(3032),
    [anon_sym_EQ_EQ] = ACTIONS(3032),
    [anon_sym_BANG_EQ] = ACTIONS(3030),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3030),
    [anon_sym_LT_EQ_GT] = ACTIONS(3030),
    [anon_sym_EQ_TILDE] = ACTIONS(3030),
    [anon_sym_BANG_TILDE] = ACTIONS(3030),
    [anon_sym_LT_EQ] = ACTIONS(3032),
    [anon_sym_GT] = ACTIONS(3032),
    [anon_sym_GT_EQ] = ACTIONS(3030),
    [anon_sym_CARET] = ACTIONS(3032),
    [anon_sym_PLUS] = ACTIONS(3032),
    [anon_sym_SLASH] = ACTIONS(3032),
    [anon_sym_PERCENT] = ACTIONS(3032),
    [sym_comment] = ACTIONS(87),
  },
  [10027] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(10819),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3553),
    [sym_scope_resolution] = STATE(3549),
    [sym_call] = STATE(3549),
    [sym_method_call] = STATE(3553),
    [sym_assignment] = STATE(10819),
    [sym_operator_assignment] = STATE(10819),
    [sym_conditional] = STATE(10819),
    [sym_range] = STATE(10819),
    [sym_binary] = STATE(10819),
    [sym_unary] = STATE(10819),
    [sym_left_assignment_list] = STATE(3552),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3553),
    [sym__variable] = STATE(3549),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3553),
    [sym_false] = STATE(3553),
    [sym_nil] = STATE(3553),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6215),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(9609),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(5895),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5899),
    [anon_sym_yield] = ACTIONS(5901),
    [anon_sym_break] = ACTIONS(5903),
    [anon_sym_next] = ACTIONS(5905),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(9611),
    [anon_sym_defined_QMARK] = ACTIONS(5907),
    [anon_sym_not] = ACTIONS(5909),
    [anon_sym_BANG] = ACTIONS(5913),
    [anon_sym_TILDE] = ACTIONS(5913),
    [sym_constant] = ACTIONS(5919),
    [sym_identifier] = ACTIONS(5919),
    [sym_instance_variable] = ACTIONS(5917),
    [sym_class_variable] = ACTIONS(5917),
    [sym_global_variable] = ACTIONS(5917),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5919),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5919),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [10028] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(8564),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3553),
    [sym_scope_resolution] = STATE(3549),
    [sym_call] = STATE(3549),
    [sym_method_call] = STATE(3553),
    [sym_splat_argument] = STATE(9044),
    [sym_assignment] = STATE(8564),
    [sym_operator_assignment] = STATE(8564),
    [sym_conditional] = STATE(8564),
    [sym_range] = STATE(8564),
    [sym_binary] = STATE(8564),
    [sym_unary] = STATE(8564),
    [sym__arg_or_splat_arg] = STATE(9044),
    [sym_left_assignment_list] = STATE(3552),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3553),
    [sym__variable] = STATE(3549),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3553),
    [sym_false] = STATE(3553),
    [sym_nil] = STATE(3553),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6215),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(9609),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__splat_star] = ACTIONS(9571),
    [sym__unary_minus] = ACTIONS(5895),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5899),
    [anon_sym_yield] = ACTIONS(5901),
    [anon_sym_break] = ACTIONS(5903),
    [anon_sym_next] = ACTIONS(5905),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(9611),
    [anon_sym_defined_QMARK] = ACTIONS(5907),
    [anon_sym_not] = ACTIONS(5909),
    [anon_sym_BANG] = ACTIONS(5913),
    [anon_sym_TILDE] = ACTIONS(5913),
    [sym_constant] = ACTIONS(5919),
    [sym_identifier] = ACTIONS(5919),
    [sym_instance_variable] = ACTIONS(5917),
    [sym_class_variable] = ACTIONS(5917),
    [sym_global_variable] = ACTIONS(5917),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5919),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5919),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [10029] = {
    [aux_sym_exceptions_repeat1] = STATE(10820),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_LBRACE] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(14598),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_STAR_STAR] = ACTIONS(9857),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_EQ] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_do] = ACTIONS(9855),
    [anon_sym_EQ_GT] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_PLUS_EQ] = ACTIONS(9855),
    [anon_sym_DASH_EQ] = ACTIONS(9855),
    [anon_sym_STAR_EQ] = ACTIONS(9855),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9855),
    [anon_sym_SLASH_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9855),
    [anon_sym_AMP_EQ] = ACTIONS(9855),
    [anon_sym_PERCENT_EQ] = ACTIONS(9855),
    [anon_sym_GT_GT_EQ] = ACTIONS(9855),
    [anon_sym_LT_LT_EQ] = ACTIONS(9855),
    [anon_sym_CARET_EQ] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_COLON2] = ACTIONS(9857),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9857),
    [anon_sym_AMP_AMP] = ACTIONS(9857),
    [anon_sym_LT_LT] = ACTIONS(9857),
    [anon_sym_GT_GT] = ACTIONS(9857),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9857),
    [anon_sym_PLUS] = ACTIONS(9857),
    [anon_sym_SLASH] = ACTIONS(9857),
    [anon_sym_PERCENT] = ACTIONS(9857),
    [sym_comment] = ACTIONS(87),
  },
  [10030] = {
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(12162),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_COLON2] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(12162),
    [anon_sym_PERCENT] = ACTIONS(12162),
    [sym_comment] = ACTIONS(87),
  },
  [10031] = {
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(12162),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_COLON2] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [10032] = {
    [sym__binary_minus] = ACTIONS(12160),
    [sym__binary_star] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(12162),
    [anon_sym_AMP] = ACTIONS(12166),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_COLON2] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(12178),
    [anon_sym_GT_GT] = ACTIONS(12178),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(12160),
    [anon_sym_SLASH] = ACTIONS(12162),
    [anon_sym_PERCENT] = ACTIONS(12162),
    [sym_comment] = ACTIONS(87),
  },
  [10033] = {
    [sym__binary_minus] = ACTIONS(12160),
    [sym__binary_star] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(12162),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_COLON2] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(12178),
    [anon_sym_GT_GT] = ACTIONS(12178),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(12160),
    [anon_sym_SLASH] = ACTIONS(12162),
    [anon_sym_PERCENT] = ACTIONS(12162),
    [sym_comment] = ACTIONS(87),
  },
  [10034] = {
    [sym__binary_minus] = ACTIONS(12160),
    [sym__binary_star] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(12164),
    [anon_sym_STAR_STAR] = ACTIONS(12162),
    [anon_sym_AMP] = ACTIONS(12166),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_COLON2] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(12178),
    [anon_sym_GT_GT] = ACTIONS(12178),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(12184),
    [anon_sym_PLUS] = ACTIONS(12160),
    [anon_sym_SLASH] = ACTIONS(12162),
    [anon_sym_PERCENT] = ACTIONS(12162),
    [sym_comment] = ACTIONS(87),
  },
  [10035] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(14600),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [10036] = {
    [sym__binary_minus] = ACTIONS(12160),
    [sym__binary_star] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(12164),
    [anon_sym_STAR_STAR] = ACTIONS(12162),
    [anon_sym_AMP] = ACTIONS(12166),
    [anon_sym_LT] = ACTIONS(12168),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_COLON2] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(12172),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12174),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(12176),
    [anon_sym_AMP_AMP] = ACTIONS(12176),
    [anon_sym_LT_LT] = ACTIONS(12178),
    [anon_sym_GT_GT] = ACTIONS(12178),
    [anon_sym_EQ_EQ] = ACTIONS(12180),
    [anon_sym_BANG_EQ] = ACTIONS(12176),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12176),
    [anon_sym_LT_EQ_GT] = ACTIONS(12176),
    [anon_sym_EQ_TILDE] = ACTIONS(12176),
    [anon_sym_BANG_TILDE] = ACTIONS(12176),
    [anon_sym_LT_EQ] = ACTIONS(12168),
    [anon_sym_GT] = ACTIONS(12168),
    [anon_sym_GT_EQ] = ACTIONS(12182),
    [anon_sym_CARET] = ACTIONS(12184),
    [anon_sym_PLUS] = ACTIONS(12160),
    [anon_sym_SLASH] = ACTIONS(12162),
    [anon_sym_PERCENT] = ACTIONS(12162),
    [sym_comment] = ACTIONS(87),
  },
  [10037] = {
    [sym__binary_minus] = ACTIONS(12160),
    [sym__binary_star] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(12164),
    [anon_sym_STAR_STAR] = ACTIONS(12162),
    [anon_sym_AMP] = ACTIONS(12166),
    [anon_sym_LT] = ACTIONS(12168),
    [anon_sym_QMARK] = ACTIONS(12170),
    [anon_sym_COLON2] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(12172),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12174),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(12176),
    [anon_sym_AMP_AMP] = ACTIONS(12176),
    [anon_sym_LT_LT] = ACTIONS(12178),
    [anon_sym_GT_GT] = ACTIONS(12178),
    [anon_sym_EQ_EQ] = ACTIONS(12180),
    [anon_sym_BANG_EQ] = ACTIONS(12176),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12176),
    [anon_sym_LT_EQ_GT] = ACTIONS(12176),
    [anon_sym_EQ_TILDE] = ACTIONS(12176),
    [anon_sym_BANG_TILDE] = ACTIONS(12176),
    [anon_sym_LT_EQ] = ACTIONS(12168),
    [anon_sym_GT] = ACTIONS(12168),
    [anon_sym_GT_EQ] = ACTIONS(12182),
    [anon_sym_CARET] = ACTIONS(12184),
    [anon_sym_PLUS] = ACTIONS(12160),
    [anon_sym_SLASH] = ACTIONS(12162),
    [anon_sym_PERCENT] = ACTIONS(12162),
    [sym_comment] = ACTIONS(87),
  },
  [10038] = {
    [sym__binary_minus] = ACTIONS(12160),
    [sym__binary_star] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(12164),
    [anon_sym_STAR_STAR] = ACTIONS(12162),
    [anon_sym_AMP] = ACTIONS(12166),
    [anon_sym_LT] = ACTIONS(12168),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_COLON2] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(12178),
    [anon_sym_GT_GT] = ACTIONS(12178),
    [anon_sym_EQ_EQ] = ACTIONS(12180),
    [anon_sym_BANG_EQ] = ACTIONS(12176),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12176),
    [anon_sym_LT_EQ_GT] = ACTIONS(12176),
    [anon_sym_EQ_TILDE] = ACTIONS(12176),
    [anon_sym_BANG_TILDE] = ACTIONS(12176),
    [anon_sym_LT_EQ] = ACTIONS(12168),
    [anon_sym_GT] = ACTIONS(12168),
    [anon_sym_GT_EQ] = ACTIONS(12182),
    [anon_sym_CARET] = ACTIONS(12184),
    [anon_sym_PLUS] = ACTIONS(12160),
    [anon_sym_SLASH] = ACTIONS(12162),
    [anon_sym_PERCENT] = ACTIONS(12162),
    [sym_comment] = ACTIONS(87),
  },
  [10039] = {
    [sym__binary_minus] = ACTIONS(12160),
    [sym__binary_star] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(12162),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_COLON2] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(12160),
    [anon_sym_SLASH] = ACTIONS(12162),
    [anon_sym_PERCENT] = ACTIONS(12162),
    [sym_comment] = ACTIONS(87),
  },
  [10040] = {
    [aux_sym_exceptions_repeat1] = STATE(10040),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_COMMA] = ACTIONS(14602),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_COLON2] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [10041] = {
    [aux_sym_exceptions_repeat1] = STATE(8582),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_COLON2] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [10042] = {
    [sym__binary_minus] = ACTIONS(12160),
    [sym__binary_star] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(12164),
    [anon_sym_STAR_STAR] = ACTIONS(12162),
    [anon_sym_AMP] = ACTIONS(12166),
    [anon_sym_LT] = ACTIONS(12168),
    [anon_sym_QMARK] = ACTIONS(12170),
    [anon_sym_COLON2] = ACTIONS(6210),
    [anon_sym_DOT_DOT] = ACTIONS(12172),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12174),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(12176),
    [anon_sym_AMP_AMP] = ACTIONS(12176),
    [anon_sym_LT_LT] = ACTIONS(12178),
    [anon_sym_GT_GT] = ACTIONS(12178),
    [anon_sym_EQ_EQ] = ACTIONS(12180),
    [anon_sym_BANG_EQ] = ACTIONS(12176),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12176),
    [anon_sym_LT_EQ_GT] = ACTIONS(12176),
    [anon_sym_EQ_TILDE] = ACTIONS(12176),
    [anon_sym_BANG_TILDE] = ACTIONS(12176),
    [anon_sym_LT_EQ] = ACTIONS(12168),
    [anon_sym_GT] = ACTIONS(12168),
    [anon_sym_GT_EQ] = ACTIONS(12182),
    [anon_sym_CARET] = ACTIONS(12184),
    [anon_sym_PLUS] = ACTIONS(12160),
    [anon_sym_SLASH] = ACTIONS(12162),
    [anon_sym_PERCENT] = ACTIONS(12162),
    [sym_comment] = ACTIONS(87),
  },
  [10043] = {
    [sym_string] = STATE(10043),
    [aux_sym_chained_string_repeat1] = STATE(10043),
    [sym__string_start] = ACTIONS(12194),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_COLON2] = ACTIONS(6217),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [10044] = {
    [sym__line_break] = ACTIONS(12555),
    [sym__heredoc_body_start] = ACTIONS(12555),
    [sym__binary_minus] = ACTIONS(12555),
    [sym__binary_star] = ACTIONS(12555),
    [ts_builtin_sym_end] = ACTIONS(12555),
    [anon_sym___END__] = ACTIONS(12555),
    [anon_sym_LBRACE] = ACTIONS(12555),
    [anon_sym_RBRACE] = ACTIONS(12555),
    [anon_sym_RPAREN] = ACTIONS(12555),
    [anon_sym_DOT] = ACTIONS(12557),
    [anon_sym_COMMA] = ACTIONS(12555),
    [anon_sym_PIPE] = ACTIONS(12557),
    [anon_sym_SEMI] = ACTIONS(12555),
    [anon_sym_STAR_STAR] = ACTIONS(12557),
    [anon_sym_AMP] = ACTIONS(12557),
    [anon_sym_EQ] = ACTIONS(12557),
    [anon_sym_LT] = ACTIONS(12557),
    [anon_sym_end] = ACTIONS(12555),
    [anon_sym_if] = ACTIONS(12555),
    [anon_sym_unless] = ACTIONS(12555),
    [anon_sym_while] = ACTIONS(12555),
    [anon_sym_until] = ACTIONS(12555),
    [anon_sym_rescue] = ACTIONS(12555),
    [anon_sym_do] = ACTIONS(12555),
    [anon_sym_when] = ACTIONS(12555),
    [anon_sym_elsif] = ACTIONS(12555),
    [anon_sym_else] = ACTIONS(12555),
    [anon_sym_then] = ACTIONS(12555),
    [anon_sym_ensure] = ACTIONS(12555),
    [anon_sym_EQ_GT] = ACTIONS(12555),
    [anon_sym_LBRACK] = ACTIONS(12555),
    [anon_sym_COLON_COLON2] = ACTIONS(12555),
    [anon_sym_AMP_DOT] = ACTIONS(12555),
    [anon_sym_PLUS_EQ] = ACTIONS(12555),
    [anon_sym_DASH_EQ] = ACTIONS(12555),
    [anon_sym_STAR_EQ] = ACTIONS(12555),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12555),
    [anon_sym_SLASH_EQ] = ACTIONS(12555),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12555),
    [anon_sym_PIPE_EQ] = ACTIONS(12555),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12555),
    [anon_sym_AMP_EQ] = ACTIONS(12555),
    [anon_sym_PERCENT_EQ] = ACTIONS(12555),
    [anon_sym_GT_GT_EQ] = ACTIONS(12555),
    [anon_sym_LT_LT_EQ] = ACTIONS(12555),
    [anon_sym_CARET_EQ] = ACTIONS(12555),
    [anon_sym_QMARK] = ACTIONS(12555),
    [anon_sym_DOT_DOT] = ACTIONS(12557),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12555),
    [anon_sym_and] = ACTIONS(12555),
    [anon_sym_or] = ACTIONS(12555),
    [anon_sym_PIPE_PIPE] = ACTIONS(12557),
    [anon_sym_AMP_AMP] = ACTIONS(12557),
    [anon_sym_LT_LT] = ACTIONS(12557),
    [anon_sym_GT_GT] = ACTIONS(12557),
    [anon_sym_EQ_EQ] = ACTIONS(12557),
    [anon_sym_BANG_EQ] = ACTIONS(12555),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12555),
    [anon_sym_LT_EQ_GT] = ACTIONS(12555),
    [anon_sym_EQ_TILDE] = ACTIONS(12555),
    [anon_sym_BANG_TILDE] = ACTIONS(12555),
    [anon_sym_LT_EQ] = ACTIONS(12557),
    [anon_sym_GT] = ACTIONS(12557),
    [anon_sym_GT_EQ] = ACTIONS(12555),
    [anon_sym_CARET] = ACTIONS(12557),
    [anon_sym_PLUS] = ACTIONS(12557),
    [anon_sym_SLASH] = ACTIONS(12557),
    [anon_sym_PERCENT] = ACTIONS(12557),
    [sym_comment] = ACTIONS(87),
  },
  [10045] = {
    [sym__line_break] = ACTIONS(12559),
    [sym__heredoc_body_start] = ACTIONS(12559),
    [sym__binary_minus] = ACTIONS(12559),
    [sym__binary_star] = ACTIONS(12559),
    [ts_builtin_sym_end] = ACTIONS(12559),
    [anon_sym___END__] = ACTIONS(12559),
    [anon_sym_LBRACE] = ACTIONS(12559),
    [anon_sym_RBRACE] = ACTIONS(12559),
    [anon_sym_RPAREN] = ACTIONS(12559),
    [anon_sym_DOT] = ACTIONS(12561),
    [anon_sym_COMMA] = ACTIONS(12559),
    [anon_sym_PIPE] = ACTIONS(12561),
    [anon_sym_SEMI] = ACTIONS(12559),
    [anon_sym_STAR_STAR] = ACTIONS(12561),
    [anon_sym_AMP] = ACTIONS(12561),
    [anon_sym_EQ] = ACTIONS(12561),
    [anon_sym_LT] = ACTIONS(12561),
    [anon_sym_end] = ACTIONS(12559),
    [anon_sym_if] = ACTIONS(12559),
    [anon_sym_unless] = ACTIONS(12559),
    [anon_sym_while] = ACTIONS(12559),
    [anon_sym_until] = ACTIONS(12559),
    [anon_sym_rescue] = ACTIONS(12559),
    [anon_sym_do] = ACTIONS(12559),
    [anon_sym_when] = ACTIONS(12559),
    [anon_sym_elsif] = ACTIONS(12559),
    [anon_sym_else] = ACTIONS(12559),
    [anon_sym_then] = ACTIONS(12559),
    [anon_sym_ensure] = ACTIONS(12559),
    [anon_sym_EQ_GT] = ACTIONS(12559),
    [anon_sym_LBRACK] = ACTIONS(12559),
    [anon_sym_COLON_COLON2] = ACTIONS(12559),
    [anon_sym_AMP_DOT] = ACTIONS(12559),
    [anon_sym_PLUS_EQ] = ACTIONS(12559),
    [anon_sym_DASH_EQ] = ACTIONS(12559),
    [anon_sym_STAR_EQ] = ACTIONS(12559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12559),
    [anon_sym_SLASH_EQ] = ACTIONS(12559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12559),
    [anon_sym_PIPE_EQ] = ACTIONS(12559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12559),
    [anon_sym_AMP_EQ] = ACTIONS(12559),
    [anon_sym_PERCENT_EQ] = ACTIONS(12559),
    [anon_sym_GT_GT_EQ] = ACTIONS(12559),
    [anon_sym_LT_LT_EQ] = ACTIONS(12559),
    [anon_sym_CARET_EQ] = ACTIONS(12559),
    [anon_sym_QMARK] = ACTIONS(12559),
    [anon_sym_DOT_DOT] = ACTIONS(12561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12559),
    [anon_sym_and] = ACTIONS(12559),
    [anon_sym_or] = ACTIONS(12559),
    [anon_sym_PIPE_PIPE] = ACTIONS(12561),
    [anon_sym_AMP_AMP] = ACTIONS(12561),
    [anon_sym_LT_LT] = ACTIONS(12561),
    [anon_sym_GT_GT] = ACTIONS(12561),
    [anon_sym_EQ_EQ] = ACTIONS(12561),
    [anon_sym_BANG_EQ] = ACTIONS(12559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12559),
    [anon_sym_LT_EQ_GT] = ACTIONS(12559),
    [anon_sym_EQ_TILDE] = ACTIONS(12559),
    [anon_sym_BANG_TILDE] = ACTIONS(12559),
    [anon_sym_LT_EQ] = ACTIONS(12561),
    [anon_sym_GT] = ACTIONS(12561),
    [anon_sym_GT_EQ] = ACTIONS(12559),
    [anon_sym_CARET] = ACTIONS(12561),
    [anon_sym_PLUS] = ACTIONS(12561),
    [anon_sym_SLASH] = ACTIONS(12561),
    [anon_sym_PERCENT] = ACTIONS(12561),
    [sym_comment] = ACTIONS(87),
  },
  [10046] = {
    [sym__line_break] = ACTIONS(10203),
    [sym__heredoc_body_start] = ACTIONS(10203),
    [sym__binary_minus] = ACTIONS(10203),
    [sym__binary_star] = ACTIONS(10203),
    [ts_builtin_sym_end] = ACTIONS(10203),
    [anon_sym___END__] = ACTIONS(10203),
    [anon_sym_LBRACE] = ACTIONS(10203),
    [anon_sym_RBRACE] = ACTIONS(10203),
    [anon_sym_RPAREN] = ACTIONS(10203),
    [anon_sym_DOT] = ACTIONS(10205),
    [anon_sym_COMMA] = ACTIONS(10203),
    [anon_sym_PIPE] = ACTIONS(10205),
    [anon_sym_SEMI] = ACTIONS(10203),
    [anon_sym_STAR_STAR] = ACTIONS(10205),
    [anon_sym_AMP] = ACTIONS(10205),
    [anon_sym_EQ] = ACTIONS(10205),
    [anon_sym_LT] = ACTIONS(10205),
    [anon_sym_end] = ACTIONS(10203),
    [anon_sym_if] = ACTIONS(10203),
    [anon_sym_unless] = ACTIONS(10203),
    [anon_sym_while] = ACTIONS(10203),
    [anon_sym_until] = ACTIONS(10203),
    [anon_sym_rescue] = ACTIONS(10203),
    [anon_sym_do] = ACTIONS(10203),
    [anon_sym_when] = ACTIONS(10203),
    [anon_sym_elsif] = ACTIONS(10203),
    [anon_sym_else] = ACTIONS(10203),
    [anon_sym_then] = ACTIONS(10203),
    [anon_sym_ensure] = ACTIONS(10203),
    [anon_sym_LBRACK] = ACTIONS(10203),
    [anon_sym_COLON_COLON2] = ACTIONS(10203),
    [anon_sym_AMP_DOT] = ACTIONS(10203),
    [anon_sym_PLUS_EQ] = ACTIONS(10203),
    [anon_sym_DASH_EQ] = ACTIONS(10203),
    [anon_sym_STAR_EQ] = ACTIONS(10203),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10203),
    [anon_sym_SLASH_EQ] = ACTIONS(10203),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10203),
    [anon_sym_PIPE_EQ] = ACTIONS(10203),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10203),
    [anon_sym_AMP_EQ] = ACTIONS(10203),
    [anon_sym_PERCENT_EQ] = ACTIONS(10203),
    [anon_sym_GT_GT_EQ] = ACTIONS(10203),
    [anon_sym_LT_LT_EQ] = ACTIONS(10203),
    [anon_sym_CARET_EQ] = ACTIONS(10203),
    [anon_sym_QMARK] = ACTIONS(10203),
    [anon_sym_DOT_DOT] = ACTIONS(10205),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10203),
    [anon_sym_and] = ACTIONS(10203),
    [anon_sym_or] = ACTIONS(10203),
    [anon_sym_PIPE_PIPE] = ACTIONS(10205),
    [anon_sym_AMP_AMP] = ACTIONS(10205),
    [anon_sym_LT_LT] = ACTIONS(10205),
    [anon_sym_GT_GT] = ACTIONS(10205),
    [anon_sym_EQ_EQ] = ACTIONS(10205),
    [anon_sym_BANG_EQ] = ACTIONS(10203),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10203),
    [anon_sym_LT_EQ_GT] = ACTIONS(10203),
    [anon_sym_EQ_TILDE] = ACTIONS(10203),
    [anon_sym_BANG_TILDE] = ACTIONS(10203),
    [anon_sym_LT_EQ] = ACTIONS(10205),
    [anon_sym_GT] = ACTIONS(10205),
    [anon_sym_GT_EQ] = ACTIONS(10203),
    [anon_sym_CARET] = ACTIONS(10205),
    [anon_sym_PLUS] = ACTIONS(10205),
    [anon_sym_SLASH] = ACTIONS(10205),
    [anon_sym_PERCENT] = ACTIONS(10205),
    [sym_comment] = ACTIONS(87),
  },
  [10047] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1697),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(14605),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [10048] = {
    [sym__line_break] = ACTIONS(10209),
    [sym__heredoc_body_start] = ACTIONS(10209),
    [sym__binary_minus] = ACTIONS(10209),
    [sym__binary_star] = ACTIONS(10209),
    [ts_builtin_sym_end] = ACTIONS(10209),
    [anon_sym___END__] = ACTIONS(10209),
    [anon_sym_LBRACE] = ACTIONS(10209),
    [anon_sym_RBRACE] = ACTIONS(10209),
    [anon_sym_RPAREN] = ACTIONS(10209),
    [anon_sym_DOT] = ACTIONS(10211),
    [anon_sym_COMMA] = ACTIONS(10209),
    [anon_sym_PIPE] = ACTIONS(10211),
    [anon_sym_SEMI] = ACTIONS(10209),
    [anon_sym_STAR_STAR] = ACTIONS(10211),
    [anon_sym_AMP] = ACTIONS(10211),
    [anon_sym_EQ] = ACTIONS(10211),
    [anon_sym_LT] = ACTIONS(10211),
    [anon_sym_end] = ACTIONS(10209),
    [anon_sym_if] = ACTIONS(10209),
    [anon_sym_unless] = ACTIONS(10209),
    [anon_sym_while] = ACTIONS(10209),
    [anon_sym_until] = ACTIONS(10209),
    [anon_sym_rescue] = ACTIONS(10209),
    [anon_sym_do] = ACTIONS(10209),
    [anon_sym_when] = ACTIONS(10209),
    [anon_sym_elsif] = ACTIONS(10209),
    [anon_sym_else] = ACTIONS(10209),
    [anon_sym_then] = ACTIONS(10209),
    [anon_sym_ensure] = ACTIONS(10209),
    [anon_sym_LBRACK] = ACTIONS(10209),
    [anon_sym_COLON_COLON2] = ACTIONS(10209),
    [anon_sym_AMP_DOT] = ACTIONS(10209),
    [anon_sym_PLUS_EQ] = ACTIONS(10209),
    [anon_sym_DASH_EQ] = ACTIONS(10209),
    [anon_sym_STAR_EQ] = ACTIONS(10209),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10209),
    [anon_sym_SLASH_EQ] = ACTIONS(10209),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10209),
    [anon_sym_PIPE_EQ] = ACTIONS(10209),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10209),
    [anon_sym_AMP_EQ] = ACTIONS(10209),
    [anon_sym_PERCENT_EQ] = ACTIONS(10209),
    [anon_sym_GT_GT_EQ] = ACTIONS(10209),
    [anon_sym_LT_LT_EQ] = ACTIONS(10209),
    [anon_sym_CARET_EQ] = ACTIONS(10209),
    [anon_sym_QMARK] = ACTIONS(10209),
    [anon_sym_DOT_DOT] = ACTIONS(10211),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10209),
    [anon_sym_and] = ACTIONS(10209),
    [anon_sym_or] = ACTIONS(10209),
    [anon_sym_PIPE_PIPE] = ACTIONS(10211),
    [anon_sym_AMP_AMP] = ACTIONS(10211),
    [anon_sym_LT_LT] = ACTIONS(10211),
    [anon_sym_GT_GT] = ACTIONS(10211),
    [anon_sym_EQ_EQ] = ACTIONS(10211),
    [anon_sym_BANG_EQ] = ACTIONS(10209),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10209),
    [anon_sym_LT_EQ_GT] = ACTIONS(10209),
    [anon_sym_EQ_TILDE] = ACTIONS(10209),
    [anon_sym_BANG_TILDE] = ACTIONS(10209),
    [anon_sym_LT_EQ] = ACTIONS(10211),
    [anon_sym_GT] = ACTIONS(10211),
    [anon_sym_GT_EQ] = ACTIONS(10209),
    [anon_sym_CARET] = ACTIONS(10211),
    [anon_sym_PLUS] = ACTIONS(10211),
    [anon_sym_SLASH] = ACTIONS(10211),
    [anon_sym_PERCENT] = ACTIONS(10211),
    [sym_comment] = ACTIONS(87),
  },
  [10049] = {
    [sym__line_break] = ACTIONS(10213),
    [sym__heredoc_body_start] = ACTIONS(10213),
    [sym__binary_minus] = ACTIONS(10213),
    [sym__binary_star] = ACTIONS(10213),
    [ts_builtin_sym_end] = ACTIONS(10213),
    [anon_sym___END__] = ACTIONS(10213),
    [anon_sym_LBRACE] = ACTIONS(10213),
    [anon_sym_RBRACE] = ACTIONS(10213),
    [anon_sym_RPAREN] = ACTIONS(10213),
    [anon_sym_DOT] = ACTIONS(10215),
    [anon_sym_COMMA] = ACTIONS(10213),
    [anon_sym_PIPE] = ACTIONS(10215),
    [anon_sym_SEMI] = ACTIONS(10213),
    [anon_sym_STAR_STAR] = ACTIONS(10215),
    [anon_sym_AMP] = ACTIONS(10215),
    [anon_sym_EQ] = ACTIONS(10215),
    [anon_sym_LT] = ACTIONS(10215),
    [anon_sym_end] = ACTIONS(10213),
    [anon_sym_if] = ACTIONS(10213),
    [anon_sym_unless] = ACTIONS(10213),
    [anon_sym_while] = ACTIONS(10213),
    [anon_sym_until] = ACTIONS(10213),
    [anon_sym_rescue] = ACTIONS(10213),
    [anon_sym_do] = ACTIONS(10213),
    [anon_sym_when] = ACTIONS(10213),
    [anon_sym_elsif] = ACTIONS(10213),
    [anon_sym_else] = ACTIONS(10213),
    [anon_sym_then] = ACTIONS(10213),
    [anon_sym_ensure] = ACTIONS(10213),
    [anon_sym_LBRACK] = ACTIONS(10213),
    [anon_sym_COLON_COLON2] = ACTIONS(10213),
    [anon_sym_AMP_DOT] = ACTIONS(10213),
    [anon_sym_PLUS_EQ] = ACTIONS(10213),
    [anon_sym_DASH_EQ] = ACTIONS(10213),
    [anon_sym_STAR_EQ] = ACTIONS(10213),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10213),
    [anon_sym_SLASH_EQ] = ACTIONS(10213),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10213),
    [anon_sym_PIPE_EQ] = ACTIONS(10213),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10213),
    [anon_sym_AMP_EQ] = ACTIONS(10213),
    [anon_sym_PERCENT_EQ] = ACTIONS(10213),
    [anon_sym_GT_GT_EQ] = ACTIONS(10213),
    [anon_sym_LT_LT_EQ] = ACTIONS(10213),
    [anon_sym_CARET_EQ] = ACTIONS(10213),
    [anon_sym_QMARK] = ACTIONS(10213),
    [anon_sym_DOT_DOT] = ACTIONS(10215),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10213),
    [anon_sym_and] = ACTIONS(10213),
    [anon_sym_or] = ACTIONS(10213),
    [anon_sym_PIPE_PIPE] = ACTIONS(10215),
    [anon_sym_AMP_AMP] = ACTIONS(10215),
    [anon_sym_LT_LT] = ACTIONS(10215),
    [anon_sym_GT_GT] = ACTIONS(10215),
    [anon_sym_EQ_EQ] = ACTIONS(10215),
    [anon_sym_BANG_EQ] = ACTIONS(10213),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10213),
    [anon_sym_LT_EQ_GT] = ACTIONS(10213),
    [anon_sym_EQ_TILDE] = ACTIONS(10213),
    [anon_sym_BANG_TILDE] = ACTIONS(10213),
    [anon_sym_LT_EQ] = ACTIONS(10215),
    [anon_sym_GT] = ACTIONS(10215),
    [anon_sym_GT_EQ] = ACTIONS(10213),
    [anon_sym_CARET] = ACTIONS(10215),
    [anon_sym_PLUS] = ACTIONS(10215),
    [anon_sym_SLASH] = ACTIONS(10215),
    [anon_sym_PERCENT] = ACTIONS(10215),
    [sym_comment] = ACTIONS(87),
  },
  [10050] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1705),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(14607),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [10051] = {
    [sym__line_break] = ACTIONS(10219),
    [sym__heredoc_body_start] = ACTIONS(10219),
    [sym__binary_minus] = ACTIONS(10219),
    [sym__binary_star] = ACTIONS(10219),
    [ts_builtin_sym_end] = ACTIONS(10219),
    [anon_sym___END__] = ACTIONS(10219),
    [anon_sym_LBRACE] = ACTIONS(10219),
    [anon_sym_RBRACE] = ACTIONS(10219),
    [anon_sym_RPAREN] = ACTIONS(10219),
    [anon_sym_DOT] = ACTIONS(10221),
    [anon_sym_COMMA] = ACTIONS(10219),
    [anon_sym_PIPE] = ACTIONS(10221),
    [anon_sym_SEMI] = ACTIONS(10219),
    [anon_sym_STAR_STAR] = ACTIONS(10221),
    [anon_sym_AMP] = ACTIONS(10221),
    [anon_sym_EQ] = ACTIONS(10221),
    [anon_sym_LT] = ACTIONS(10221),
    [anon_sym_end] = ACTIONS(10219),
    [anon_sym_if] = ACTIONS(10219),
    [anon_sym_unless] = ACTIONS(10219),
    [anon_sym_while] = ACTIONS(10219),
    [anon_sym_until] = ACTIONS(10219),
    [anon_sym_rescue] = ACTIONS(10219),
    [anon_sym_do] = ACTIONS(10219),
    [anon_sym_when] = ACTIONS(10219),
    [anon_sym_elsif] = ACTIONS(10219),
    [anon_sym_else] = ACTIONS(10219),
    [anon_sym_then] = ACTIONS(10219),
    [anon_sym_ensure] = ACTIONS(10219),
    [anon_sym_LBRACK] = ACTIONS(10219),
    [anon_sym_COLON_COLON2] = ACTIONS(10219),
    [anon_sym_AMP_DOT] = ACTIONS(10219),
    [anon_sym_PLUS_EQ] = ACTIONS(10219),
    [anon_sym_DASH_EQ] = ACTIONS(10219),
    [anon_sym_STAR_EQ] = ACTIONS(10219),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10219),
    [anon_sym_SLASH_EQ] = ACTIONS(10219),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10219),
    [anon_sym_PIPE_EQ] = ACTIONS(10219),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10219),
    [anon_sym_AMP_EQ] = ACTIONS(10219),
    [anon_sym_PERCENT_EQ] = ACTIONS(10219),
    [anon_sym_GT_GT_EQ] = ACTIONS(10219),
    [anon_sym_LT_LT_EQ] = ACTIONS(10219),
    [anon_sym_CARET_EQ] = ACTIONS(10219),
    [anon_sym_QMARK] = ACTIONS(10219),
    [anon_sym_DOT_DOT] = ACTIONS(10221),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10219),
    [anon_sym_and] = ACTIONS(10219),
    [anon_sym_or] = ACTIONS(10219),
    [anon_sym_PIPE_PIPE] = ACTIONS(10221),
    [anon_sym_AMP_AMP] = ACTIONS(10221),
    [anon_sym_LT_LT] = ACTIONS(10221),
    [anon_sym_GT_GT] = ACTIONS(10221),
    [anon_sym_EQ_EQ] = ACTIONS(10221),
    [anon_sym_BANG_EQ] = ACTIONS(10219),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10219),
    [anon_sym_LT_EQ_GT] = ACTIONS(10219),
    [anon_sym_EQ_TILDE] = ACTIONS(10219),
    [anon_sym_BANG_TILDE] = ACTIONS(10219),
    [anon_sym_LT_EQ] = ACTIONS(10221),
    [anon_sym_GT] = ACTIONS(10221),
    [anon_sym_GT_EQ] = ACTIONS(10219),
    [anon_sym_CARET] = ACTIONS(10221),
    [anon_sym_PLUS] = ACTIONS(10221),
    [anon_sym_SLASH] = ACTIONS(10221),
    [anon_sym_PERCENT] = ACTIONS(10221),
    [sym_comment] = ACTIONS(87),
  },
  [10052] = {
    [sym__method_rest] = STATE(10824),
    [sym_operator] = STATE(3602),
    [sym__method_name] = STATE(3602),
    [sym_setter] = STATE(3602),
    [sym_symbol] = STATE(3602),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(12233),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(12233),
    [sym_class_variable] = ACTIONS(12233),
    [sym_global_variable] = ACTIONS(12233),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [10053] = {
    [sym__line_break] = ACTIONS(10927),
    [sym__heredoc_body_start] = ACTIONS(10927),
    [sym__binary_minus] = ACTIONS(10927),
    [sym__binary_star] = ACTIONS(10927),
    [ts_builtin_sym_end] = ACTIONS(10927),
    [anon_sym___END__] = ACTIONS(10927),
    [anon_sym_LBRACE] = ACTIONS(10927),
    [anon_sym_RBRACE] = ACTIONS(10927),
    [anon_sym_RPAREN] = ACTIONS(10927),
    [anon_sym_DOT] = ACTIONS(10929),
    [anon_sym_COMMA] = ACTIONS(10927),
    [anon_sym_PIPE] = ACTIONS(10929),
    [anon_sym_SEMI] = ACTIONS(10927),
    [anon_sym_STAR_STAR] = ACTIONS(10929),
    [anon_sym_AMP] = ACTIONS(10929),
    [anon_sym_EQ] = ACTIONS(10929),
    [anon_sym_LT] = ACTIONS(10929),
    [anon_sym_end] = ACTIONS(10927),
    [anon_sym_if] = ACTIONS(10927),
    [anon_sym_unless] = ACTIONS(10927),
    [anon_sym_while] = ACTIONS(10927),
    [anon_sym_until] = ACTIONS(10927),
    [anon_sym_rescue] = ACTIONS(10927),
    [anon_sym_do] = ACTIONS(10927),
    [anon_sym_when] = ACTIONS(10927),
    [anon_sym_elsif] = ACTIONS(10927),
    [anon_sym_else] = ACTIONS(10927),
    [anon_sym_then] = ACTIONS(10927),
    [anon_sym_ensure] = ACTIONS(10927),
    [anon_sym_LBRACK] = ACTIONS(10927),
    [anon_sym_COLON_COLON2] = ACTIONS(10927),
    [anon_sym_AMP_DOT] = ACTIONS(10927),
    [anon_sym_PLUS_EQ] = ACTIONS(10927),
    [anon_sym_DASH_EQ] = ACTIONS(10927),
    [anon_sym_STAR_EQ] = ACTIONS(10927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10927),
    [anon_sym_SLASH_EQ] = ACTIONS(10927),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10927),
    [anon_sym_PIPE_EQ] = ACTIONS(10927),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10927),
    [anon_sym_AMP_EQ] = ACTIONS(10927),
    [anon_sym_PERCENT_EQ] = ACTIONS(10927),
    [anon_sym_GT_GT_EQ] = ACTIONS(10927),
    [anon_sym_LT_LT_EQ] = ACTIONS(10927),
    [anon_sym_CARET_EQ] = ACTIONS(10927),
    [anon_sym_QMARK] = ACTIONS(10927),
    [anon_sym_DOT_DOT] = ACTIONS(10929),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10927),
    [anon_sym_and] = ACTIONS(10927),
    [anon_sym_or] = ACTIONS(10927),
    [anon_sym_PIPE_PIPE] = ACTIONS(10929),
    [anon_sym_AMP_AMP] = ACTIONS(10929),
    [anon_sym_LT_LT] = ACTIONS(10929),
    [anon_sym_GT_GT] = ACTIONS(10929),
    [anon_sym_EQ_EQ] = ACTIONS(10929),
    [anon_sym_BANG_EQ] = ACTIONS(10927),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10927),
    [anon_sym_LT_EQ_GT] = ACTIONS(10927),
    [anon_sym_EQ_TILDE] = ACTIONS(10927),
    [anon_sym_BANG_TILDE] = ACTIONS(10927),
    [anon_sym_LT_EQ] = ACTIONS(10929),
    [anon_sym_GT] = ACTIONS(10929),
    [anon_sym_GT_EQ] = ACTIONS(10927),
    [anon_sym_CARET] = ACTIONS(10929),
    [anon_sym_PLUS] = ACTIONS(10929),
    [anon_sym_SLASH] = ACTIONS(10929),
    [anon_sym_PERCENT] = ACTIONS(10929),
    [sym_comment] = ACTIONS(87),
  },
  [10054] = {
    [sym__line_break] = ACTIONS(10931),
    [sym__heredoc_body_start] = ACTIONS(10931),
    [sym__binary_minus] = ACTIONS(10931),
    [sym__binary_star] = ACTIONS(10931),
    [ts_builtin_sym_end] = ACTIONS(10931),
    [anon_sym___END__] = ACTIONS(10931),
    [anon_sym_LBRACE] = ACTIONS(10931),
    [anon_sym_RBRACE] = ACTIONS(10931),
    [anon_sym_RPAREN] = ACTIONS(10931),
    [anon_sym_DOT] = ACTIONS(10933),
    [anon_sym_COMMA] = ACTIONS(10931),
    [anon_sym_PIPE] = ACTIONS(10933),
    [anon_sym_SEMI] = ACTIONS(10931),
    [anon_sym_STAR_STAR] = ACTIONS(10933),
    [anon_sym_AMP] = ACTIONS(10933),
    [anon_sym_EQ] = ACTIONS(10933),
    [anon_sym_LT] = ACTIONS(10933),
    [anon_sym_end] = ACTIONS(10931),
    [anon_sym_if] = ACTIONS(10931),
    [anon_sym_unless] = ACTIONS(10931),
    [anon_sym_while] = ACTIONS(10931),
    [anon_sym_until] = ACTIONS(10931),
    [anon_sym_rescue] = ACTIONS(10931),
    [anon_sym_do] = ACTIONS(10931),
    [anon_sym_when] = ACTIONS(10931),
    [anon_sym_elsif] = ACTIONS(10931),
    [anon_sym_else] = ACTIONS(10931),
    [anon_sym_then] = ACTIONS(10931),
    [anon_sym_ensure] = ACTIONS(10931),
    [anon_sym_LBRACK] = ACTIONS(10931),
    [anon_sym_COLON_COLON2] = ACTIONS(10931),
    [anon_sym_AMP_DOT] = ACTIONS(10931),
    [anon_sym_PLUS_EQ] = ACTIONS(10931),
    [anon_sym_DASH_EQ] = ACTIONS(10931),
    [anon_sym_STAR_EQ] = ACTIONS(10931),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10931),
    [anon_sym_SLASH_EQ] = ACTIONS(10931),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10931),
    [anon_sym_PIPE_EQ] = ACTIONS(10931),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10931),
    [anon_sym_AMP_EQ] = ACTIONS(10931),
    [anon_sym_PERCENT_EQ] = ACTIONS(10931),
    [anon_sym_GT_GT_EQ] = ACTIONS(10931),
    [anon_sym_LT_LT_EQ] = ACTIONS(10931),
    [anon_sym_CARET_EQ] = ACTIONS(10931),
    [anon_sym_QMARK] = ACTIONS(10931),
    [anon_sym_DOT_DOT] = ACTIONS(10933),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10931),
    [anon_sym_and] = ACTIONS(10931),
    [anon_sym_or] = ACTIONS(10931),
    [anon_sym_PIPE_PIPE] = ACTIONS(10933),
    [anon_sym_AMP_AMP] = ACTIONS(10933),
    [anon_sym_LT_LT] = ACTIONS(10933),
    [anon_sym_GT_GT] = ACTIONS(10933),
    [anon_sym_EQ_EQ] = ACTIONS(10933),
    [anon_sym_BANG_EQ] = ACTIONS(10931),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10931),
    [anon_sym_LT_EQ_GT] = ACTIONS(10931),
    [anon_sym_EQ_TILDE] = ACTIONS(10931),
    [anon_sym_BANG_TILDE] = ACTIONS(10931),
    [anon_sym_LT_EQ] = ACTIONS(10933),
    [anon_sym_GT] = ACTIONS(10933),
    [anon_sym_GT_EQ] = ACTIONS(10931),
    [anon_sym_CARET] = ACTIONS(10933),
    [anon_sym_PLUS] = ACTIONS(10933),
    [anon_sym_SLASH] = ACTIONS(10933),
    [anon_sym_PERCENT] = ACTIONS(10933),
    [sym_comment] = ACTIONS(87),
  },
  [10055] = {
    [sym__line_break] = ACTIONS(11157),
    [sym__heredoc_body_start] = ACTIONS(11157),
    [sym__binary_minus] = ACTIONS(11157),
    [sym__binary_star] = ACTIONS(11157),
    [ts_builtin_sym_end] = ACTIONS(11157),
    [anon_sym___END__] = ACTIONS(11157),
    [anon_sym_LBRACE] = ACTIONS(11157),
    [anon_sym_RBRACE] = ACTIONS(11157),
    [anon_sym_RPAREN] = ACTIONS(11157),
    [anon_sym_DOT] = ACTIONS(11159),
    [anon_sym_COMMA] = ACTIONS(11157),
    [anon_sym_PIPE] = ACTIONS(11159),
    [anon_sym_SEMI] = ACTIONS(11157),
    [anon_sym_STAR_STAR] = ACTIONS(11159),
    [anon_sym_AMP] = ACTIONS(11159),
    [anon_sym_EQ] = ACTIONS(11159),
    [anon_sym_LT] = ACTIONS(11159),
    [anon_sym_end] = ACTIONS(11157),
    [anon_sym_if] = ACTIONS(11157),
    [anon_sym_unless] = ACTIONS(11157),
    [anon_sym_while] = ACTIONS(11157),
    [anon_sym_until] = ACTIONS(11157),
    [anon_sym_rescue] = ACTIONS(11157),
    [anon_sym_do] = ACTIONS(11157),
    [anon_sym_when] = ACTIONS(11157),
    [anon_sym_elsif] = ACTIONS(11157),
    [anon_sym_else] = ACTIONS(11157),
    [anon_sym_then] = ACTIONS(11157),
    [anon_sym_ensure] = ACTIONS(11157),
    [anon_sym_LBRACK] = ACTIONS(11157),
    [anon_sym_COLON_COLON2] = ACTIONS(11157),
    [anon_sym_AMP_DOT] = ACTIONS(11157),
    [anon_sym_PLUS_EQ] = ACTIONS(11157),
    [anon_sym_DASH_EQ] = ACTIONS(11157),
    [anon_sym_STAR_EQ] = ACTIONS(11157),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11157),
    [anon_sym_SLASH_EQ] = ACTIONS(11157),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11157),
    [anon_sym_PIPE_EQ] = ACTIONS(11157),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11157),
    [anon_sym_AMP_EQ] = ACTIONS(11157),
    [anon_sym_PERCENT_EQ] = ACTIONS(11157),
    [anon_sym_GT_GT_EQ] = ACTIONS(11157),
    [anon_sym_LT_LT_EQ] = ACTIONS(11157),
    [anon_sym_CARET_EQ] = ACTIONS(11157),
    [anon_sym_QMARK] = ACTIONS(11157),
    [anon_sym_DOT_DOT] = ACTIONS(11159),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11157),
    [anon_sym_and] = ACTIONS(11157),
    [anon_sym_or] = ACTIONS(11157),
    [anon_sym_PIPE_PIPE] = ACTIONS(11159),
    [anon_sym_AMP_AMP] = ACTIONS(11159),
    [anon_sym_LT_LT] = ACTIONS(11159),
    [anon_sym_GT_GT] = ACTIONS(11159),
    [anon_sym_EQ_EQ] = ACTIONS(11159),
    [anon_sym_BANG_EQ] = ACTIONS(11157),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11157),
    [anon_sym_LT_EQ_GT] = ACTIONS(11157),
    [anon_sym_EQ_TILDE] = ACTIONS(11157),
    [anon_sym_BANG_TILDE] = ACTIONS(11157),
    [anon_sym_LT_EQ] = ACTIONS(11159),
    [anon_sym_GT] = ACTIONS(11159),
    [anon_sym_GT_EQ] = ACTIONS(11157),
    [anon_sym_CARET] = ACTIONS(11159),
    [anon_sym_PLUS] = ACTIONS(11159),
    [anon_sym_SLASH] = ACTIONS(11159),
    [anon_sym_PERCENT] = ACTIONS(11159),
    [sym_comment] = ACTIONS(87),
  },
  [10056] = {
    [sym__line_break] = ACTIONS(11322),
    [sym__heredoc_body_start] = ACTIONS(11322),
    [sym__binary_minus] = ACTIONS(11322),
    [sym__binary_star] = ACTIONS(11322),
    [ts_builtin_sym_end] = ACTIONS(11322),
    [anon_sym___END__] = ACTIONS(11322),
    [anon_sym_LBRACE] = ACTIONS(11322),
    [anon_sym_RBRACE] = ACTIONS(11322),
    [anon_sym_RPAREN] = ACTIONS(11322),
    [anon_sym_DOT] = ACTIONS(11324),
    [anon_sym_COMMA] = ACTIONS(11322),
    [anon_sym_PIPE] = ACTIONS(11324),
    [anon_sym_SEMI] = ACTIONS(11322),
    [anon_sym_STAR_STAR] = ACTIONS(11324),
    [anon_sym_AMP] = ACTIONS(11324),
    [anon_sym_EQ] = ACTIONS(11324),
    [anon_sym_LT] = ACTIONS(11324),
    [anon_sym_end] = ACTIONS(11322),
    [anon_sym_if] = ACTIONS(11322),
    [anon_sym_unless] = ACTIONS(11322),
    [anon_sym_while] = ACTIONS(11322),
    [anon_sym_until] = ACTIONS(11322),
    [anon_sym_rescue] = ACTIONS(11322),
    [anon_sym_do] = ACTIONS(11322),
    [anon_sym_when] = ACTIONS(11322),
    [anon_sym_elsif] = ACTIONS(11322),
    [anon_sym_else] = ACTIONS(11322),
    [anon_sym_then] = ACTIONS(11322),
    [anon_sym_ensure] = ACTIONS(11322),
    [anon_sym_LBRACK] = ACTIONS(11322),
    [anon_sym_COLON_COLON2] = ACTIONS(11322),
    [anon_sym_AMP_DOT] = ACTIONS(11322),
    [anon_sym_PLUS_EQ] = ACTIONS(11322),
    [anon_sym_DASH_EQ] = ACTIONS(11322),
    [anon_sym_STAR_EQ] = ACTIONS(11322),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11322),
    [anon_sym_SLASH_EQ] = ACTIONS(11322),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11322),
    [anon_sym_PIPE_EQ] = ACTIONS(11322),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11322),
    [anon_sym_AMP_EQ] = ACTIONS(11322),
    [anon_sym_PERCENT_EQ] = ACTIONS(11322),
    [anon_sym_GT_GT_EQ] = ACTIONS(11322),
    [anon_sym_LT_LT_EQ] = ACTIONS(11322),
    [anon_sym_CARET_EQ] = ACTIONS(11322),
    [anon_sym_QMARK] = ACTIONS(11322),
    [anon_sym_DOT_DOT] = ACTIONS(11324),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11322),
    [anon_sym_and] = ACTIONS(11322),
    [anon_sym_or] = ACTIONS(11322),
    [anon_sym_PIPE_PIPE] = ACTIONS(11324),
    [anon_sym_AMP_AMP] = ACTIONS(11324),
    [anon_sym_LT_LT] = ACTIONS(11324),
    [anon_sym_GT_GT] = ACTIONS(11324),
    [anon_sym_EQ_EQ] = ACTIONS(11324),
    [anon_sym_BANG_EQ] = ACTIONS(11322),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11322),
    [anon_sym_LT_EQ_GT] = ACTIONS(11322),
    [anon_sym_EQ_TILDE] = ACTIONS(11322),
    [anon_sym_BANG_TILDE] = ACTIONS(11322),
    [anon_sym_LT_EQ] = ACTIONS(11324),
    [anon_sym_GT] = ACTIONS(11324),
    [anon_sym_GT_EQ] = ACTIONS(11322),
    [anon_sym_CARET] = ACTIONS(11324),
    [anon_sym_PLUS] = ACTIONS(11324),
    [anon_sym_SLASH] = ACTIONS(11324),
    [anon_sym_PERCENT] = ACTIONS(11324),
    [sym_comment] = ACTIONS(87),
  },
  [10057] = {
    [sym__line_break] = ACTIONS(11335),
    [sym__heredoc_body_start] = ACTIONS(11335),
    [sym__binary_minus] = ACTIONS(11335),
    [sym__binary_star] = ACTIONS(11335),
    [ts_builtin_sym_end] = ACTIONS(11335),
    [anon_sym___END__] = ACTIONS(11335),
    [anon_sym_LBRACE] = ACTIONS(11335),
    [anon_sym_RBRACE] = ACTIONS(11335),
    [anon_sym_RPAREN] = ACTIONS(11335),
    [anon_sym_DOT] = ACTIONS(11337),
    [anon_sym_COMMA] = ACTIONS(11335),
    [anon_sym_PIPE] = ACTIONS(11337),
    [anon_sym_SEMI] = ACTIONS(11335),
    [anon_sym_STAR_STAR] = ACTIONS(11337),
    [anon_sym_AMP] = ACTIONS(11337),
    [anon_sym_EQ] = ACTIONS(11337),
    [anon_sym_LT] = ACTIONS(11337),
    [anon_sym_end] = ACTIONS(11335),
    [anon_sym_if] = ACTIONS(11335),
    [anon_sym_unless] = ACTIONS(11335),
    [anon_sym_while] = ACTIONS(11335),
    [anon_sym_until] = ACTIONS(11335),
    [anon_sym_rescue] = ACTIONS(11335),
    [anon_sym_do] = ACTIONS(11335),
    [anon_sym_when] = ACTIONS(11335),
    [anon_sym_elsif] = ACTIONS(11335),
    [anon_sym_else] = ACTIONS(11335),
    [anon_sym_then] = ACTIONS(11335),
    [anon_sym_ensure] = ACTIONS(11335),
    [anon_sym_LBRACK] = ACTIONS(11335),
    [anon_sym_COLON_COLON2] = ACTIONS(11335),
    [anon_sym_AMP_DOT] = ACTIONS(11335),
    [anon_sym_PLUS_EQ] = ACTIONS(11335),
    [anon_sym_DASH_EQ] = ACTIONS(11335),
    [anon_sym_STAR_EQ] = ACTIONS(11335),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11335),
    [anon_sym_SLASH_EQ] = ACTIONS(11335),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11335),
    [anon_sym_PIPE_EQ] = ACTIONS(11335),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11335),
    [anon_sym_AMP_EQ] = ACTIONS(11335),
    [anon_sym_PERCENT_EQ] = ACTIONS(11335),
    [anon_sym_GT_GT_EQ] = ACTIONS(11335),
    [anon_sym_LT_LT_EQ] = ACTIONS(11335),
    [anon_sym_CARET_EQ] = ACTIONS(11335),
    [anon_sym_QMARK] = ACTIONS(11335),
    [anon_sym_DOT_DOT] = ACTIONS(11337),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11335),
    [anon_sym_and] = ACTIONS(11335),
    [anon_sym_or] = ACTIONS(11335),
    [anon_sym_PIPE_PIPE] = ACTIONS(11337),
    [anon_sym_AMP_AMP] = ACTIONS(11337),
    [anon_sym_LT_LT] = ACTIONS(11337),
    [anon_sym_GT_GT] = ACTIONS(11337),
    [anon_sym_EQ_EQ] = ACTIONS(11337),
    [anon_sym_BANG_EQ] = ACTIONS(11335),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11335),
    [anon_sym_LT_EQ_GT] = ACTIONS(11335),
    [anon_sym_EQ_TILDE] = ACTIONS(11335),
    [anon_sym_BANG_TILDE] = ACTIONS(11335),
    [anon_sym_LT_EQ] = ACTIONS(11337),
    [anon_sym_GT] = ACTIONS(11337),
    [anon_sym_GT_EQ] = ACTIONS(11335),
    [anon_sym_CARET] = ACTIONS(11337),
    [anon_sym_PLUS] = ACTIONS(11337),
    [anon_sym_SLASH] = ACTIONS(11337),
    [anon_sym_PERCENT] = ACTIONS(11337),
    [sym_comment] = ACTIONS(87),
  },
  [10058] = {
    [sym__line_break] = ACTIONS(11344),
    [sym__heredoc_body_start] = ACTIONS(11344),
    [sym__binary_minus] = ACTIONS(11344),
    [sym__binary_star] = ACTIONS(11344),
    [ts_builtin_sym_end] = ACTIONS(11344),
    [anon_sym___END__] = ACTIONS(11344),
    [anon_sym_LBRACE] = ACTIONS(11344),
    [anon_sym_RBRACE] = ACTIONS(11344),
    [anon_sym_RPAREN] = ACTIONS(11344),
    [anon_sym_DOT] = ACTIONS(11346),
    [anon_sym_COMMA] = ACTIONS(11344),
    [anon_sym_PIPE] = ACTIONS(11346),
    [anon_sym_SEMI] = ACTIONS(11344),
    [anon_sym_STAR_STAR] = ACTIONS(11346),
    [anon_sym_AMP] = ACTIONS(11346),
    [anon_sym_EQ] = ACTIONS(11346),
    [anon_sym_LT] = ACTIONS(11346),
    [anon_sym_end] = ACTIONS(11344),
    [anon_sym_if] = ACTIONS(11344),
    [anon_sym_unless] = ACTIONS(11344),
    [anon_sym_while] = ACTIONS(11344),
    [anon_sym_until] = ACTIONS(11344),
    [anon_sym_rescue] = ACTIONS(11344),
    [anon_sym_do] = ACTIONS(11344),
    [anon_sym_when] = ACTIONS(11344),
    [anon_sym_elsif] = ACTIONS(11344),
    [anon_sym_else] = ACTIONS(11344),
    [anon_sym_then] = ACTIONS(11344),
    [anon_sym_ensure] = ACTIONS(11344),
    [anon_sym_LBRACK] = ACTIONS(11344),
    [anon_sym_COLON_COLON2] = ACTIONS(11344),
    [anon_sym_AMP_DOT] = ACTIONS(11344),
    [anon_sym_PLUS_EQ] = ACTIONS(11344),
    [anon_sym_DASH_EQ] = ACTIONS(11344),
    [anon_sym_STAR_EQ] = ACTIONS(11344),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11344),
    [anon_sym_SLASH_EQ] = ACTIONS(11344),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11344),
    [anon_sym_PIPE_EQ] = ACTIONS(11344),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11344),
    [anon_sym_AMP_EQ] = ACTIONS(11344),
    [anon_sym_PERCENT_EQ] = ACTIONS(11344),
    [anon_sym_GT_GT_EQ] = ACTIONS(11344),
    [anon_sym_LT_LT_EQ] = ACTIONS(11344),
    [anon_sym_CARET_EQ] = ACTIONS(11344),
    [anon_sym_QMARK] = ACTIONS(11344),
    [anon_sym_DOT_DOT] = ACTIONS(11346),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11344),
    [anon_sym_and] = ACTIONS(11344),
    [anon_sym_or] = ACTIONS(11344),
    [anon_sym_PIPE_PIPE] = ACTIONS(11346),
    [anon_sym_AMP_AMP] = ACTIONS(11346),
    [anon_sym_LT_LT] = ACTIONS(11346),
    [anon_sym_GT_GT] = ACTIONS(11346),
    [anon_sym_EQ_EQ] = ACTIONS(11346),
    [anon_sym_BANG_EQ] = ACTIONS(11344),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11344),
    [anon_sym_LT_EQ_GT] = ACTIONS(11344),
    [anon_sym_EQ_TILDE] = ACTIONS(11344),
    [anon_sym_BANG_TILDE] = ACTIONS(11344),
    [anon_sym_LT_EQ] = ACTIONS(11346),
    [anon_sym_GT] = ACTIONS(11346),
    [anon_sym_GT_EQ] = ACTIONS(11344),
    [anon_sym_CARET] = ACTIONS(11346),
    [anon_sym_PLUS] = ACTIONS(11346),
    [anon_sym_SLASH] = ACTIONS(11346),
    [anon_sym_PERCENT] = ACTIONS(11346),
    [sym_comment] = ACTIONS(87),
  },
  [10059] = {
    [sym__line_break] = ACTIONS(11391),
    [sym__heredoc_body_start] = ACTIONS(11391),
    [sym__binary_minus] = ACTIONS(11391),
    [sym__binary_star] = ACTIONS(11391),
    [ts_builtin_sym_end] = ACTIONS(11391),
    [anon_sym___END__] = ACTIONS(11391),
    [anon_sym_LBRACE] = ACTIONS(11391),
    [anon_sym_RBRACE] = ACTIONS(11391),
    [anon_sym_RPAREN] = ACTIONS(11391),
    [anon_sym_DOT] = ACTIONS(11393),
    [anon_sym_COMMA] = ACTIONS(11391),
    [anon_sym_PIPE] = ACTIONS(11393),
    [anon_sym_SEMI] = ACTIONS(11391),
    [anon_sym_STAR_STAR] = ACTIONS(11393),
    [anon_sym_AMP] = ACTIONS(11393),
    [anon_sym_EQ] = ACTIONS(11393),
    [anon_sym_LT] = ACTIONS(11393),
    [anon_sym_end] = ACTIONS(11391),
    [anon_sym_if] = ACTIONS(11391),
    [anon_sym_unless] = ACTIONS(11391),
    [anon_sym_while] = ACTIONS(11391),
    [anon_sym_until] = ACTIONS(11391),
    [anon_sym_rescue] = ACTIONS(11391),
    [anon_sym_do] = ACTIONS(11391),
    [anon_sym_when] = ACTIONS(11391),
    [anon_sym_elsif] = ACTIONS(11391),
    [anon_sym_else] = ACTIONS(11391),
    [anon_sym_then] = ACTIONS(11391),
    [anon_sym_ensure] = ACTIONS(11391),
    [anon_sym_LBRACK] = ACTIONS(11391),
    [anon_sym_COLON_COLON2] = ACTIONS(11391),
    [anon_sym_AMP_DOT] = ACTIONS(11391),
    [anon_sym_PLUS_EQ] = ACTIONS(11391),
    [anon_sym_DASH_EQ] = ACTIONS(11391),
    [anon_sym_STAR_EQ] = ACTIONS(11391),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11391),
    [anon_sym_SLASH_EQ] = ACTIONS(11391),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11391),
    [anon_sym_PIPE_EQ] = ACTIONS(11391),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11391),
    [anon_sym_AMP_EQ] = ACTIONS(11391),
    [anon_sym_PERCENT_EQ] = ACTIONS(11391),
    [anon_sym_GT_GT_EQ] = ACTIONS(11391),
    [anon_sym_LT_LT_EQ] = ACTIONS(11391),
    [anon_sym_CARET_EQ] = ACTIONS(11391),
    [anon_sym_QMARK] = ACTIONS(11391),
    [anon_sym_DOT_DOT] = ACTIONS(11393),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11391),
    [anon_sym_and] = ACTIONS(11391),
    [anon_sym_or] = ACTIONS(11391),
    [anon_sym_PIPE_PIPE] = ACTIONS(11393),
    [anon_sym_AMP_AMP] = ACTIONS(11393),
    [anon_sym_LT_LT] = ACTIONS(11393),
    [anon_sym_GT_GT] = ACTIONS(11393),
    [anon_sym_EQ_EQ] = ACTIONS(11393),
    [anon_sym_BANG_EQ] = ACTIONS(11391),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11391),
    [anon_sym_LT_EQ_GT] = ACTIONS(11391),
    [anon_sym_EQ_TILDE] = ACTIONS(11391),
    [anon_sym_BANG_TILDE] = ACTIONS(11391),
    [anon_sym_LT_EQ] = ACTIONS(11393),
    [anon_sym_GT] = ACTIONS(11393),
    [anon_sym_GT_EQ] = ACTIONS(11391),
    [anon_sym_CARET] = ACTIONS(11393),
    [anon_sym_PLUS] = ACTIONS(11393),
    [anon_sym_SLASH] = ACTIONS(11393),
    [anon_sym_PERCENT] = ACTIONS(11393),
    [sym_comment] = ACTIONS(87),
  },
  [10060] = {
    [anon_sym_end] = ACTIONS(14609),
    [sym_comment] = ACTIONS(87),
  },
  [10061] = {
    [sym__line_break] = ACTIONS(11404),
    [sym__heredoc_body_start] = ACTIONS(11404),
    [sym__binary_minus] = ACTIONS(11404),
    [sym__binary_star] = ACTIONS(11404),
    [ts_builtin_sym_end] = ACTIONS(11404),
    [anon_sym___END__] = ACTIONS(11404),
    [anon_sym_LBRACE] = ACTIONS(11404),
    [anon_sym_RBRACE] = ACTIONS(11404),
    [anon_sym_RPAREN] = ACTIONS(11404),
    [anon_sym_DOT] = ACTIONS(11406),
    [anon_sym_COMMA] = ACTIONS(11404),
    [anon_sym_PIPE] = ACTIONS(11406),
    [anon_sym_SEMI] = ACTIONS(11404),
    [anon_sym_STAR_STAR] = ACTIONS(11406),
    [anon_sym_AMP] = ACTIONS(11406),
    [anon_sym_EQ] = ACTIONS(11406),
    [anon_sym_LT] = ACTIONS(11406),
    [anon_sym_end] = ACTIONS(11404),
    [anon_sym_if] = ACTIONS(11404),
    [anon_sym_unless] = ACTIONS(11404),
    [anon_sym_while] = ACTIONS(11404),
    [anon_sym_until] = ACTIONS(11404),
    [anon_sym_rescue] = ACTIONS(11404),
    [anon_sym_do] = ACTIONS(11404),
    [anon_sym_when] = ACTIONS(11404),
    [anon_sym_elsif] = ACTIONS(11404),
    [anon_sym_else] = ACTIONS(11404),
    [anon_sym_then] = ACTIONS(11404),
    [anon_sym_ensure] = ACTIONS(11404),
    [anon_sym_LBRACK] = ACTIONS(11404),
    [anon_sym_COLON_COLON2] = ACTIONS(11404),
    [anon_sym_AMP_DOT] = ACTIONS(11404),
    [anon_sym_PLUS_EQ] = ACTIONS(11404),
    [anon_sym_DASH_EQ] = ACTIONS(11404),
    [anon_sym_STAR_EQ] = ACTIONS(11404),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11404),
    [anon_sym_SLASH_EQ] = ACTIONS(11404),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11404),
    [anon_sym_PIPE_EQ] = ACTIONS(11404),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11404),
    [anon_sym_AMP_EQ] = ACTIONS(11404),
    [anon_sym_PERCENT_EQ] = ACTIONS(11404),
    [anon_sym_GT_GT_EQ] = ACTIONS(11404),
    [anon_sym_LT_LT_EQ] = ACTIONS(11404),
    [anon_sym_CARET_EQ] = ACTIONS(11404),
    [anon_sym_QMARK] = ACTIONS(11404),
    [anon_sym_DOT_DOT] = ACTIONS(11406),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11404),
    [anon_sym_and] = ACTIONS(11404),
    [anon_sym_or] = ACTIONS(11404),
    [anon_sym_PIPE_PIPE] = ACTIONS(11406),
    [anon_sym_AMP_AMP] = ACTIONS(11406),
    [anon_sym_LT_LT] = ACTIONS(11406),
    [anon_sym_GT_GT] = ACTIONS(11406),
    [anon_sym_EQ_EQ] = ACTIONS(11406),
    [anon_sym_BANG_EQ] = ACTIONS(11404),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11404),
    [anon_sym_LT_EQ_GT] = ACTIONS(11404),
    [anon_sym_EQ_TILDE] = ACTIONS(11404),
    [anon_sym_BANG_TILDE] = ACTIONS(11404),
    [anon_sym_LT_EQ] = ACTIONS(11406),
    [anon_sym_GT] = ACTIONS(11406),
    [anon_sym_GT_EQ] = ACTIONS(11404),
    [anon_sym_CARET] = ACTIONS(11406),
    [anon_sym_PLUS] = ACTIONS(11406),
    [anon_sym_SLASH] = ACTIONS(11406),
    [anon_sym_PERCENT] = ACTIONS(11406),
    [sym_comment] = ACTIONS(87),
  },
  [10062] = {
    [anon_sym_end] = ACTIONS(14611),
    [sym_comment] = ACTIONS(87),
  },
  [10063] = {
    [sym_when] = STATE(2988),
    [sym_else] = STATE(10827),
    [aux_sym_case_repeat2] = STATE(2988),
    [anon_sym_end] = ACTIONS(14611),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [10064] = {
    [sym__line_break] = ACTIONS(11846),
    [sym__heredoc_body_start] = ACTIONS(11846),
    [sym__binary_minus] = ACTIONS(11846),
    [sym__binary_star] = ACTIONS(11846),
    [ts_builtin_sym_end] = ACTIONS(11846),
    [anon_sym___END__] = ACTIONS(11846),
    [anon_sym_LBRACE] = ACTIONS(11846),
    [anon_sym_RBRACE] = ACTIONS(11846),
    [anon_sym_RPAREN] = ACTIONS(11846),
    [anon_sym_DOT] = ACTIONS(11848),
    [anon_sym_COMMA] = ACTIONS(11846),
    [anon_sym_PIPE] = ACTIONS(11848),
    [anon_sym_SEMI] = ACTIONS(11846),
    [anon_sym_STAR_STAR] = ACTIONS(11848),
    [anon_sym_AMP] = ACTIONS(11848),
    [anon_sym_EQ] = ACTIONS(11848),
    [anon_sym_LT] = ACTIONS(11848),
    [anon_sym_end] = ACTIONS(11846),
    [anon_sym_if] = ACTIONS(11846),
    [anon_sym_unless] = ACTIONS(11846),
    [anon_sym_while] = ACTIONS(11846),
    [anon_sym_until] = ACTIONS(11846),
    [anon_sym_rescue] = ACTIONS(11846),
    [anon_sym_do] = ACTIONS(11846),
    [anon_sym_when] = ACTIONS(11846),
    [anon_sym_elsif] = ACTIONS(11846),
    [anon_sym_else] = ACTIONS(11846),
    [anon_sym_then] = ACTIONS(11846),
    [anon_sym_ensure] = ACTIONS(11846),
    [anon_sym_LBRACK] = ACTIONS(11846),
    [anon_sym_COLON_COLON2] = ACTIONS(11846),
    [anon_sym_AMP_DOT] = ACTIONS(11846),
    [anon_sym_PLUS_EQ] = ACTIONS(11846),
    [anon_sym_DASH_EQ] = ACTIONS(11846),
    [anon_sym_STAR_EQ] = ACTIONS(11846),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11846),
    [anon_sym_SLASH_EQ] = ACTIONS(11846),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11846),
    [anon_sym_PIPE_EQ] = ACTIONS(11846),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11846),
    [anon_sym_AMP_EQ] = ACTIONS(11846),
    [anon_sym_PERCENT_EQ] = ACTIONS(11846),
    [anon_sym_GT_GT_EQ] = ACTIONS(11846),
    [anon_sym_LT_LT_EQ] = ACTIONS(11846),
    [anon_sym_CARET_EQ] = ACTIONS(11846),
    [anon_sym_QMARK] = ACTIONS(11846),
    [anon_sym_DOT_DOT] = ACTIONS(11848),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11846),
    [anon_sym_and] = ACTIONS(11846),
    [anon_sym_or] = ACTIONS(11846),
    [anon_sym_PIPE_PIPE] = ACTIONS(11848),
    [anon_sym_AMP_AMP] = ACTIONS(11848),
    [anon_sym_LT_LT] = ACTIONS(11848),
    [anon_sym_GT_GT] = ACTIONS(11848),
    [anon_sym_EQ_EQ] = ACTIONS(11848),
    [anon_sym_BANG_EQ] = ACTIONS(11846),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11846),
    [anon_sym_LT_EQ_GT] = ACTIONS(11846),
    [anon_sym_EQ_TILDE] = ACTIONS(11846),
    [anon_sym_BANG_TILDE] = ACTIONS(11846),
    [anon_sym_LT_EQ] = ACTIONS(11848),
    [anon_sym_GT] = ACTIONS(11848),
    [anon_sym_GT_EQ] = ACTIONS(11846),
    [anon_sym_CARET] = ACTIONS(11848),
    [anon_sym_PLUS] = ACTIONS(11848),
    [anon_sym_SLASH] = ACTIONS(11848),
    [anon_sym_PERCENT] = ACTIONS(11848),
    [sym_comment] = ACTIONS(87),
  },
  [10065] = {
    [anon_sym_end] = ACTIONS(14613),
    [sym_comment] = ACTIONS(87),
  },
  [10066] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(6019),
    [sym__binary_star] = ACTIONS(6021),
    [ts_builtin_sym_end] = ACTIONS(12120),
    [anon_sym___END__] = ACTIONS(12120),
    [anon_sym_LBRACE] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(6023),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_AMP] = ACTIONS(6027),
    [anon_sym_EQ] = ACTIONS(12879),
    [anon_sym_LT] = ACTIONS(6029),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_PLUS_EQ] = ACTIONS(12120),
    [anon_sym_DASH_EQ] = ACTIONS(12120),
    [anon_sym_STAR_EQ] = ACTIONS(12120),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12120),
    [anon_sym_SLASH_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12120),
    [anon_sym_AMP_EQ] = ACTIONS(12120),
    [anon_sym_PERCENT_EQ] = ACTIONS(12120),
    [anon_sym_GT_GT_EQ] = ACTIONS(12120),
    [anon_sym_LT_LT_EQ] = ACTIONS(12120),
    [anon_sym_CARET_EQ] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(6031),
    [anon_sym_DOT_DOT] = ACTIONS(6033),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6035),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(6037),
    [anon_sym_AMP_AMP] = ACTIONS(6037),
    [anon_sym_LT_LT] = ACTIONS(6039),
    [anon_sym_GT_GT] = ACTIONS(6039),
    [anon_sym_EQ_EQ] = ACTIONS(6037),
    [anon_sym_BANG_EQ] = ACTIONS(6041),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6041),
    [anon_sym_LT_EQ_GT] = ACTIONS(6041),
    [anon_sym_EQ_TILDE] = ACTIONS(6041),
    [anon_sym_BANG_TILDE] = ACTIONS(6041),
    [anon_sym_LT_EQ] = ACTIONS(6029),
    [anon_sym_GT] = ACTIONS(6029),
    [anon_sym_GT_EQ] = ACTIONS(6043),
    [anon_sym_CARET] = ACTIONS(6023),
    [anon_sym_PLUS] = ACTIONS(6045),
    [anon_sym_SLASH] = ACTIONS(6025),
    [anon_sym_PERCENT] = ACTIONS(6025),
    [sym_comment] = ACTIONS(87),
  },
  [10067] = {
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [ts_builtin_sym_end] = ACTIONS(11597),
    [anon_sym___END__] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_RBRACE] = ACTIONS(11597),
    [anon_sym_RPAREN] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(11597),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_end] = ACTIONS(11597),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_when] = ACTIONS(11597),
    [anon_sym_elsif] = ACTIONS(11597),
    [anon_sym_else] = ACTIONS(11597),
    [anon_sym_then] = ACTIONS(11597),
    [anon_sym_ensure] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_PLUS_EQ] = ACTIONS(11597),
    [anon_sym_DASH_EQ] = ACTIONS(11597),
    [anon_sym_STAR_EQ] = ACTIONS(11597),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11597),
    [anon_sym_SLASH_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11597),
    [anon_sym_AMP_EQ] = ACTIONS(11597),
    [anon_sym_PERCENT_EQ] = ACTIONS(11597),
    [anon_sym_GT_GT_EQ] = ACTIONS(11597),
    [anon_sym_LT_LT_EQ] = ACTIONS(11597),
    [anon_sym_CARET_EQ] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_LT] = ACTIONS(12338),
    [anon_sym_GT_GT] = ACTIONS(12338),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(12338),
    [anon_sym_PLUS] = ACTIONS(12338),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [10068] = {
    [aux_sym_exceptions_repeat1] = STATE(10068),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [ts_builtin_sym_end] = ACTIONS(11597),
    [anon_sym___END__] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(14615),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_PLUS_EQ] = ACTIONS(11597),
    [anon_sym_DASH_EQ] = ACTIONS(11597),
    [anon_sym_STAR_EQ] = ACTIONS(11597),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11597),
    [anon_sym_SLASH_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11597),
    [anon_sym_AMP_EQ] = ACTIONS(11597),
    [anon_sym_PERCENT_EQ] = ACTIONS(11597),
    [anon_sym_GT_GT_EQ] = ACTIONS(11597),
    [anon_sym_LT_LT_EQ] = ACTIONS(11597),
    [anon_sym_CARET_EQ] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_LT] = ACTIONS(12338),
    [anon_sym_GT_GT] = ACTIONS(12338),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(12338),
    [anon_sym_PLUS] = ACTIONS(12338),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [10069] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(6067),
    [sym__binary_star] = ACTIONS(6069),
    [anon_sym_RBRACE] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(6071),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(6069),
    [anon_sym_AMP] = ACTIONS(6073),
    [anon_sym_LT] = ACTIONS(6075),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_EQ_GT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(6077),
    [anon_sym_DOT_DOT] = ACTIONS(6079),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6081),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(6085),
    [anon_sym_AMP_AMP] = ACTIONS(6085),
    [anon_sym_LT_LT] = ACTIONS(6087),
    [anon_sym_GT_GT] = ACTIONS(6087),
    [anon_sym_EQ_EQ] = ACTIONS(6089),
    [anon_sym_BANG_EQ] = ACTIONS(6085),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6085),
    [anon_sym_LT_EQ_GT] = ACTIONS(6085),
    [anon_sym_EQ_TILDE] = ACTIONS(6085),
    [anon_sym_BANG_TILDE] = ACTIONS(6085),
    [anon_sym_LT_EQ] = ACTIONS(6075),
    [anon_sym_GT] = ACTIONS(6075),
    [anon_sym_GT_EQ] = ACTIONS(6091),
    [anon_sym_CARET] = ACTIONS(6093),
    [anon_sym_PLUS] = ACTIONS(6067),
    [anon_sym_SLASH] = ACTIONS(6069),
    [anon_sym_PERCENT] = ACTIONS(6069),
    [sym_comment] = ACTIONS(87),
  },
  [10070] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(12278),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(12278),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(12278),
    [anon_sym_PERCENT] = ACTIONS(12278),
    [sym_comment] = ACTIONS(87),
  },
  [10071] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(12278),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [10072] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12276),
    [sym__binary_star] = ACTIONS(12278),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(12278),
    [anon_sym_AMP] = ACTIONS(12282),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(12294),
    [anon_sym_GT_GT] = ACTIONS(12294),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(12276),
    [anon_sym_SLASH] = ACTIONS(12278),
    [anon_sym_PERCENT] = ACTIONS(12278),
    [sym_comment] = ACTIONS(87),
  },
  [10073] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12276),
    [sym__binary_star] = ACTIONS(12278),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(12278),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(12294),
    [anon_sym_GT_GT] = ACTIONS(12294),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(12276),
    [anon_sym_SLASH] = ACTIONS(12278),
    [anon_sym_PERCENT] = ACTIONS(12278),
    [sym_comment] = ACTIONS(87),
  },
  [10074] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12276),
    [sym__binary_star] = ACTIONS(12278),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(12280),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(12278),
    [anon_sym_AMP] = ACTIONS(12282),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(12294),
    [anon_sym_GT_GT] = ACTIONS(12294),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(12300),
    [anon_sym_PLUS] = ACTIONS(12276),
    [anon_sym_SLASH] = ACTIONS(12278),
    [anon_sym_PERCENT] = ACTIONS(12278),
    [sym_comment] = ACTIONS(87),
  },
  [10075] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(14618),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [10076] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(12276),
    [sym__binary_star] = ACTIONS(12278),
    [anon_sym_RBRACE] = ACTIONS(5927),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(12280),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(12278),
    [anon_sym_AMP] = ACTIONS(12282),
    [anon_sym_LT] = ACTIONS(12284),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_EQ_GT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(12288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12290),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(12292),
    [anon_sym_AMP_AMP] = ACTIONS(12292),
    [anon_sym_LT_LT] = ACTIONS(12294),
    [anon_sym_GT_GT] = ACTIONS(12294),
    [anon_sym_EQ_EQ] = ACTIONS(12296),
    [anon_sym_BANG_EQ] = ACTIONS(12292),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12292),
    [anon_sym_LT_EQ_GT] = ACTIONS(12292),
    [anon_sym_EQ_TILDE] = ACTIONS(12292),
    [anon_sym_BANG_TILDE] = ACTIONS(12292),
    [anon_sym_LT_EQ] = ACTIONS(12284),
    [anon_sym_GT] = ACTIONS(12284),
    [anon_sym_GT_EQ] = ACTIONS(12298),
    [anon_sym_CARET] = ACTIONS(12300),
    [anon_sym_PLUS] = ACTIONS(12276),
    [anon_sym_SLASH] = ACTIONS(12278),
    [anon_sym_PERCENT] = ACTIONS(12278),
    [sym_comment] = ACTIONS(87),
  },
  [10077] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12276),
    [sym__binary_star] = ACTIONS(12278),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(12280),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(12278),
    [anon_sym_AMP] = ACTIONS(12282),
    [anon_sym_LT] = ACTIONS(12284),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(12286),
    [anon_sym_DOT_DOT] = ACTIONS(12288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12290),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(12292),
    [anon_sym_AMP_AMP] = ACTIONS(12292),
    [anon_sym_LT_LT] = ACTIONS(12294),
    [anon_sym_GT_GT] = ACTIONS(12294),
    [anon_sym_EQ_EQ] = ACTIONS(12296),
    [anon_sym_BANG_EQ] = ACTIONS(12292),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12292),
    [anon_sym_LT_EQ_GT] = ACTIONS(12292),
    [anon_sym_EQ_TILDE] = ACTIONS(12292),
    [anon_sym_BANG_TILDE] = ACTIONS(12292),
    [anon_sym_LT_EQ] = ACTIONS(12284),
    [anon_sym_GT] = ACTIONS(12284),
    [anon_sym_GT_EQ] = ACTIONS(12298),
    [anon_sym_CARET] = ACTIONS(12300),
    [anon_sym_PLUS] = ACTIONS(12276),
    [anon_sym_SLASH] = ACTIONS(12278),
    [anon_sym_PERCENT] = ACTIONS(12278),
    [sym_comment] = ACTIONS(87),
  },
  [10078] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12276),
    [sym__binary_star] = ACTIONS(12278),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(12280),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(12278),
    [anon_sym_AMP] = ACTIONS(12282),
    [anon_sym_LT] = ACTIONS(12284),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(12294),
    [anon_sym_GT_GT] = ACTIONS(12294),
    [anon_sym_EQ_EQ] = ACTIONS(12296),
    [anon_sym_BANG_EQ] = ACTIONS(12292),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12292),
    [anon_sym_LT_EQ_GT] = ACTIONS(12292),
    [anon_sym_EQ_TILDE] = ACTIONS(12292),
    [anon_sym_BANG_TILDE] = ACTIONS(12292),
    [anon_sym_LT_EQ] = ACTIONS(12284),
    [anon_sym_GT] = ACTIONS(12284),
    [anon_sym_GT_EQ] = ACTIONS(12298),
    [anon_sym_CARET] = ACTIONS(12300),
    [anon_sym_PLUS] = ACTIONS(12276),
    [anon_sym_SLASH] = ACTIONS(12278),
    [anon_sym_PERCENT] = ACTIONS(12278),
    [sym_comment] = ACTIONS(87),
  },
  [10079] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12276),
    [sym__binary_star] = ACTIONS(12278),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(12278),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(12276),
    [anon_sym_SLASH] = ACTIONS(12278),
    [anon_sym_PERCENT] = ACTIONS(12278),
    [sym_comment] = ACTIONS(87),
  },
  [10080] = {
    [aux_sym_exceptions_repeat1] = STATE(10080),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_RBRACE] = ACTIONS(11597),
    [anon_sym_COMMA] = ACTIONS(14620),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [10081] = {
    [aux_sym_exceptions_repeat1] = STATE(8658),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_RBRACE] = ACTIONS(6191),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [10082] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(12276),
    [sym__binary_star] = ACTIONS(12278),
    [anon_sym_RBRACE] = ACTIONS(6210),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(12280),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(12278),
    [anon_sym_AMP] = ACTIONS(12282),
    [anon_sym_LT] = ACTIONS(12284),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_EQ_GT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(12286),
    [anon_sym_DOT_DOT] = ACTIONS(12288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12290),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(12292),
    [anon_sym_AMP_AMP] = ACTIONS(12292),
    [anon_sym_LT_LT] = ACTIONS(12294),
    [anon_sym_GT_GT] = ACTIONS(12294),
    [anon_sym_EQ_EQ] = ACTIONS(12296),
    [anon_sym_BANG_EQ] = ACTIONS(12292),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12292),
    [anon_sym_LT_EQ_GT] = ACTIONS(12292),
    [anon_sym_EQ_TILDE] = ACTIONS(12292),
    [anon_sym_BANG_TILDE] = ACTIONS(12292),
    [anon_sym_LT_EQ] = ACTIONS(12284),
    [anon_sym_GT] = ACTIONS(12284),
    [anon_sym_GT_EQ] = ACTIONS(12298),
    [anon_sym_CARET] = ACTIONS(12300),
    [anon_sym_PLUS] = ACTIONS(12276),
    [anon_sym_SLASH] = ACTIONS(12278),
    [anon_sym_PERCENT] = ACTIONS(12278),
    [sym_comment] = ACTIONS(87),
  },
  [10083] = {
    [sym__line_break] = ACTIONS(12663),
    [sym__heredoc_body_start] = ACTIONS(12663),
    [sym__binary_minus] = ACTIONS(12663),
    [sym__binary_star] = ACTIONS(12663),
    [ts_builtin_sym_end] = ACTIONS(12663),
    [anon_sym___END__] = ACTIONS(12663),
    [anon_sym_LBRACE] = ACTIONS(12663),
    [anon_sym_RBRACE] = ACTIONS(12663),
    [anon_sym_RPAREN] = ACTIONS(12663),
    [anon_sym_DOT] = ACTIONS(12665),
    [anon_sym_COMMA] = ACTIONS(12663),
    [anon_sym_PIPE] = ACTIONS(12665),
    [anon_sym_SEMI] = ACTIONS(12663),
    [anon_sym_STAR_STAR] = ACTIONS(12665),
    [anon_sym_AMP] = ACTIONS(12665),
    [anon_sym_EQ] = ACTIONS(12665),
    [anon_sym_LT] = ACTIONS(12665),
    [anon_sym_end] = ACTIONS(12663),
    [anon_sym_if] = ACTIONS(12663),
    [anon_sym_unless] = ACTIONS(12663),
    [anon_sym_while] = ACTIONS(12663),
    [anon_sym_until] = ACTIONS(12663),
    [anon_sym_rescue] = ACTIONS(12663),
    [anon_sym_do] = ACTIONS(12663),
    [anon_sym_when] = ACTIONS(12663),
    [anon_sym_elsif] = ACTIONS(12663),
    [anon_sym_else] = ACTIONS(12663),
    [anon_sym_then] = ACTIONS(12663),
    [anon_sym_ensure] = ACTIONS(12663),
    [anon_sym_EQ_GT] = ACTIONS(12663),
    [anon_sym_LBRACK] = ACTIONS(12663),
    [anon_sym_COLON_COLON2] = ACTIONS(12663),
    [anon_sym_AMP_DOT] = ACTIONS(12663),
    [anon_sym_PLUS_EQ] = ACTIONS(12663),
    [anon_sym_DASH_EQ] = ACTIONS(12663),
    [anon_sym_STAR_EQ] = ACTIONS(12663),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12663),
    [anon_sym_SLASH_EQ] = ACTIONS(12663),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12663),
    [anon_sym_PIPE_EQ] = ACTIONS(12663),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12663),
    [anon_sym_AMP_EQ] = ACTIONS(12663),
    [anon_sym_PERCENT_EQ] = ACTIONS(12663),
    [anon_sym_GT_GT_EQ] = ACTIONS(12663),
    [anon_sym_LT_LT_EQ] = ACTIONS(12663),
    [anon_sym_CARET_EQ] = ACTIONS(12663),
    [anon_sym_QMARK] = ACTIONS(12663),
    [anon_sym_DOT_DOT] = ACTIONS(12665),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12663),
    [anon_sym_and] = ACTIONS(12663),
    [anon_sym_or] = ACTIONS(12663),
    [anon_sym_PIPE_PIPE] = ACTIONS(12665),
    [anon_sym_AMP_AMP] = ACTIONS(12665),
    [anon_sym_LT_LT] = ACTIONS(12665),
    [anon_sym_GT_GT] = ACTIONS(12665),
    [anon_sym_EQ_EQ] = ACTIONS(12665),
    [anon_sym_BANG_EQ] = ACTIONS(12663),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12663),
    [anon_sym_LT_EQ_GT] = ACTIONS(12663),
    [anon_sym_EQ_TILDE] = ACTIONS(12663),
    [anon_sym_BANG_TILDE] = ACTIONS(12663),
    [anon_sym_LT_EQ] = ACTIONS(12665),
    [anon_sym_GT] = ACTIONS(12665),
    [anon_sym_GT_EQ] = ACTIONS(12663),
    [anon_sym_CARET] = ACTIONS(12665),
    [anon_sym_PLUS] = ACTIONS(12665),
    [anon_sym_SLASH] = ACTIONS(12665),
    [anon_sym_PERCENT] = ACTIONS(12665),
    [sym_comment] = ACTIONS(87),
  },
  [10084] = {
    [sym__line_break] = ACTIONS(13224),
    [sym__heredoc_body_start] = ACTIONS(13224),
    [sym__binary_minus] = ACTIONS(13224),
    [sym__binary_star] = ACTIONS(13224),
    [ts_builtin_sym_end] = ACTIONS(13224),
    [anon_sym___END__] = ACTIONS(13224),
    [anon_sym_LBRACE] = ACTIONS(13224),
    [anon_sym_RBRACE] = ACTIONS(13224),
    [anon_sym_RPAREN] = ACTIONS(13224),
    [anon_sym_DOT] = ACTIONS(13226),
    [anon_sym_COMMA] = ACTIONS(13224),
    [anon_sym_PIPE] = ACTIONS(13226),
    [anon_sym_SEMI] = ACTIONS(13224),
    [anon_sym_STAR_STAR] = ACTIONS(13226),
    [anon_sym_AMP] = ACTIONS(13226),
    [anon_sym_EQ] = ACTIONS(13226),
    [anon_sym_LT] = ACTIONS(13226),
    [anon_sym_end] = ACTIONS(13224),
    [anon_sym_if] = ACTIONS(13224),
    [anon_sym_unless] = ACTIONS(13224),
    [anon_sym_while] = ACTIONS(13224),
    [anon_sym_until] = ACTIONS(13224),
    [anon_sym_rescue] = ACTIONS(13224),
    [anon_sym_do] = ACTIONS(13224),
    [anon_sym_when] = ACTIONS(13224),
    [anon_sym_elsif] = ACTIONS(13224),
    [anon_sym_else] = ACTIONS(13224),
    [anon_sym_then] = ACTIONS(13224),
    [anon_sym_ensure] = ACTIONS(13224),
    [anon_sym_EQ_GT] = ACTIONS(13224),
    [anon_sym_LBRACK] = ACTIONS(13224),
    [anon_sym_COLON_COLON2] = ACTIONS(13224),
    [anon_sym_AMP_DOT] = ACTIONS(13224),
    [anon_sym_PLUS_EQ] = ACTIONS(13224),
    [anon_sym_DASH_EQ] = ACTIONS(13224),
    [anon_sym_STAR_EQ] = ACTIONS(13224),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13224),
    [anon_sym_SLASH_EQ] = ACTIONS(13224),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13224),
    [anon_sym_PIPE_EQ] = ACTIONS(13224),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13224),
    [anon_sym_AMP_EQ] = ACTIONS(13224),
    [anon_sym_PERCENT_EQ] = ACTIONS(13224),
    [anon_sym_GT_GT_EQ] = ACTIONS(13224),
    [anon_sym_LT_LT_EQ] = ACTIONS(13224),
    [anon_sym_CARET_EQ] = ACTIONS(13224),
    [anon_sym_QMARK] = ACTIONS(13224),
    [anon_sym_DOT_DOT] = ACTIONS(13226),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13224),
    [anon_sym_and] = ACTIONS(13224),
    [anon_sym_or] = ACTIONS(13224),
    [anon_sym_PIPE_PIPE] = ACTIONS(13226),
    [anon_sym_AMP_AMP] = ACTIONS(13226),
    [anon_sym_LT_LT] = ACTIONS(13226),
    [anon_sym_GT_GT] = ACTIONS(13226),
    [anon_sym_EQ_EQ] = ACTIONS(13226),
    [anon_sym_BANG_EQ] = ACTIONS(13224),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13224),
    [anon_sym_LT_EQ_GT] = ACTIONS(13224),
    [anon_sym_EQ_TILDE] = ACTIONS(13224),
    [anon_sym_BANG_TILDE] = ACTIONS(13224),
    [anon_sym_LT_EQ] = ACTIONS(13226),
    [anon_sym_GT] = ACTIONS(13226),
    [anon_sym_GT_EQ] = ACTIONS(13224),
    [anon_sym_CARET] = ACTIONS(13226),
    [anon_sym_PLUS] = ACTIONS(13226),
    [anon_sym_SLASH] = ACTIONS(13226),
    [anon_sym_PERCENT] = ACTIONS(13226),
    [sym_comment] = ACTIONS(87),
  },
  [10085] = {
    [sym__line_break] = ACTIONS(14580),
    [sym__heredoc_body_start] = ACTIONS(14580),
    [sym__binary_minus] = ACTIONS(14580),
    [sym__binary_star] = ACTIONS(14580),
    [ts_builtin_sym_end] = ACTIONS(14580),
    [anon_sym___END__] = ACTIONS(14580),
    [anon_sym_LBRACE] = ACTIONS(14580),
    [anon_sym_RBRACE] = ACTIONS(14580),
    [anon_sym_RPAREN] = ACTIONS(14580),
    [anon_sym_DOT] = ACTIONS(14582),
    [anon_sym_COMMA] = ACTIONS(14580),
    [anon_sym_PIPE] = ACTIONS(14582),
    [anon_sym_SEMI] = ACTIONS(14580),
    [anon_sym_STAR_STAR] = ACTIONS(14582),
    [anon_sym_AMP] = ACTIONS(14582),
    [anon_sym_EQ] = ACTIONS(14582),
    [anon_sym_LT] = ACTIONS(14582),
    [anon_sym_end] = ACTIONS(14580),
    [anon_sym_if] = ACTIONS(14580),
    [anon_sym_unless] = ACTIONS(14580),
    [anon_sym_while] = ACTIONS(14580),
    [anon_sym_until] = ACTIONS(14580),
    [anon_sym_rescue] = ACTIONS(14580),
    [anon_sym_do] = ACTIONS(14580),
    [anon_sym_when] = ACTIONS(14580),
    [anon_sym_elsif] = ACTIONS(14580),
    [anon_sym_else] = ACTIONS(14580),
    [anon_sym_then] = ACTIONS(14580),
    [anon_sym_ensure] = ACTIONS(14580),
    [anon_sym_LBRACK] = ACTIONS(14580),
    [anon_sym_COLON_COLON2] = ACTIONS(14580),
    [anon_sym_AMP_DOT] = ACTIONS(14580),
    [anon_sym_PLUS_EQ] = ACTIONS(14580),
    [anon_sym_DASH_EQ] = ACTIONS(14580),
    [anon_sym_STAR_EQ] = ACTIONS(14580),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14580),
    [anon_sym_SLASH_EQ] = ACTIONS(14580),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14580),
    [anon_sym_PIPE_EQ] = ACTIONS(14580),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14580),
    [anon_sym_AMP_EQ] = ACTIONS(14580),
    [anon_sym_PERCENT_EQ] = ACTIONS(14580),
    [anon_sym_GT_GT_EQ] = ACTIONS(14580),
    [anon_sym_LT_LT_EQ] = ACTIONS(14580),
    [anon_sym_CARET_EQ] = ACTIONS(14580),
    [anon_sym_QMARK] = ACTIONS(14580),
    [anon_sym_DOT_DOT] = ACTIONS(14582),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14580),
    [anon_sym_and] = ACTIONS(14580),
    [anon_sym_or] = ACTIONS(14580),
    [anon_sym_PIPE_PIPE] = ACTIONS(14582),
    [anon_sym_AMP_AMP] = ACTIONS(14582),
    [anon_sym_LT_LT] = ACTIONS(14582),
    [anon_sym_GT_GT] = ACTIONS(14582),
    [anon_sym_EQ_EQ] = ACTIONS(14582),
    [anon_sym_BANG_EQ] = ACTIONS(14580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14580),
    [anon_sym_LT_EQ_GT] = ACTIONS(14580),
    [anon_sym_EQ_TILDE] = ACTIONS(14580),
    [anon_sym_BANG_TILDE] = ACTIONS(14580),
    [anon_sym_LT_EQ] = ACTIONS(14582),
    [anon_sym_GT] = ACTIONS(14582),
    [anon_sym_GT_EQ] = ACTIONS(14580),
    [anon_sym_CARET] = ACTIONS(14582),
    [anon_sym_PLUS] = ACTIONS(14582),
    [anon_sym_SLASH] = ACTIONS(14582),
    [anon_sym_PERCENT] = ACTIONS(14582),
    [sym_comment] = ACTIONS(87),
  },
  [10086] = {
    [sym__line_break] = ACTIONS(13235),
    [sym__heredoc_body_start] = ACTIONS(13235),
    [sym__binary_minus] = ACTIONS(13235),
    [sym__binary_star] = ACTIONS(13235),
    [ts_builtin_sym_end] = ACTIONS(13235),
    [anon_sym___END__] = ACTIONS(13235),
    [anon_sym_LBRACE] = ACTIONS(13235),
    [anon_sym_RBRACE] = ACTIONS(13235),
    [anon_sym_RPAREN] = ACTIONS(13235),
    [anon_sym_DOT] = ACTIONS(13237),
    [anon_sym_COMMA] = ACTIONS(13235),
    [anon_sym_PIPE] = ACTIONS(13237),
    [anon_sym_SEMI] = ACTIONS(13235),
    [anon_sym_STAR_STAR] = ACTIONS(13237),
    [anon_sym_AMP] = ACTIONS(13237),
    [anon_sym_EQ] = ACTIONS(13237),
    [anon_sym_LT] = ACTIONS(13237),
    [anon_sym_end] = ACTIONS(13235),
    [anon_sym_if] = ACTIONS(13235),
    [anon_sym_unless] = ACTIONS(13235),
    [anon_sym_while] = ACTIONS(13235),
    [anon_sym_until] = ACTIONS(13235),
    [anon_sym_rescue] = ACTIONS(13235),
    [anon_sym_do] = ACTIONS(13235),
    [anon_sym_when] = ACTIONS(13235),
    [anon_sym_elsif] = ACTIONS(13235),
    [anon_sym_else] = ACTIONS(13235),
    [anon_sym_then] = ACTIONS(13235),
    [anon_sym_ensure] = ACTIONS(13235),
    [anon_sym_EQ_GT] = ACTIONS(13235),
    [anon_sym_LBRACK] = ACTIONS(13235),
    [anon_sym_COLON_COLON2] = ACTIONS(13235),
    [anon_sym_AMP_DOT] = ACTIONS(13235),
    [anon_sym_PLUS_EQ] = ACTIONS(13235),
    [anon_sym_DASH_EQ] = ACTIONS(13235),
    [anon_sym_STAR_EQ] = ACTIONS(13235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13235),
    [anon_sym_SLASH_EQ] = ACTIONS(13235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13235),
    [anon_sym_PIPE_EQ] = ACTIONS(13235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13235),
    [anon_sym_AMP_EQ] = ACTIONS(13235),
    [anon_sym_PERCENT_EQ] = ACTIONS(13235),
    [anon_sym_GT_GT_EQ] = ACTIONS(13235),
    [anon_sym_LT_LT_EQ] = ACTIONS(13235),
    [anon_sym_CARET_EQ] = ACTIONS(13235),
    [anon_sym_QMARK] = ACTIONS(13235),
    [anon_sym_DOT_DOT] = ACTIONS(13237),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13235),
    [anon_sym_and] = ACTIONS(13235),
    [anon_sym_or] = ACTIONS(13235),
    [anon_sym_PIPE_PIPE] = ACTIONS(13237),
    [anon_sym_AMP_AMP] = ACTIONS(13237),
    [anon_sym_LT_LT] = ACTIONS(13237),
    [anon_sym_GT_GT] = ACTIONS(13237),
    [anon_sym_EQ_EQ] = ACTIONS(13237),
    [anon_sym_BANG_EQ] = ACTIONS(13235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13235),
    [anon_sym_LT_EQ_GT] = ACTIONS(13235),
    [anon_sym_EQ_TILDE] = ACTIONS(13235),
    [anon_sym_BANG_TILDE] = ACTIONS(13235),
    [anon_sym_LT_EQ] = ACTIONS(13237),
    [anon_sym_GT] = ACTIONS(13237),
    [anon_sym_GT_EQ] = ACTIONS(13235),
    [anon_sym_CARET] = ACTIONS(13237),
    [anon_sym_PLUS] = ACTIONS(13237),
    [anon_sym_SLASH] = ACTIONS(13237),
    [anon_sym_PERCENT] = ACTIONS(13237),
    [sym_comment] = ACTIONS(87),
  },
  [10087] = {
    [anon_sym_end] = ACTIONS(14623),
    [sym_comment] = ACTIONS(87),
  },
  [10088] = {
    [sym__line_break] = ACTIONS(13547),
    [sym__heredoc_body_start] = ACTIONS(13547),
    [sym__binary_minus] = ACTIONS(13547),
    [sym__binary_star] = ACTIONS(13547),
    [ts_builtin_sym_end] = ACTIONS(13547),
    [anon_sym___END__] = ACTIONS(13547),
    [anon_sym_LBRACE] = ACTIONS(13547),
    [anon_sym_RBRACE] = ACTIONS(13547),
    [anon_sym_RPAREN] = ACTIONS(13547),
    [anon_sym_DOT] = ACTIONS(13549),
    [anon_sym_COMMA] = ACTIONS(13547),
    [anon_sym_PIPE] = ACTIONS(13549),
    [anon_sym_SEMI] = ACTIONS(13547),
    [anon_sym_STAR_STAR] = ACTIONS(13549),
    [anon_sym_AMP] = ACTIONS(13549),
    [anon_sym_EQ] = ACTIONS(13549),
    [anon_sym_LT] = ACTIONS(13549),
    [anon_sym_end] = ACTIONS(13547),
    [anon_sym_if] = ACTIONS(13547),
    [anon_sym_unless] = ACTIONS(13547),
    [anon_sym_while] = ACTIONS(13547),
    [anon_sym_until] = ACTIONS(13547),
    [anon_sym_rescue] = ACTIONS(13547),
    [anon_sym_do] = ACTIONS(13547),
    [anon_sym_when] = ACTIONS(13547),
    [anon_sym_elsif] = ACTIONS(13547),
    [anon_sym_else] = ACTIONS(13547),
    [anon_sym_then] = ACTIONS(13547),
    [anon_sym_ensure] = ACTIONS(13547),
    [anon_sym_EQ_GT] = ACTIONS(13547),
    [anon_sym_LBRACK] = ACTIONS(13547),
    [anon_sym_COLON_COLON2] = ACTIONS(13547),
    [anon_sym_AMP_DOT] = ACTIONS(13547),
    [anon_sym_PLUS_EQ] = ACTIONS(13547),
    [anon_sym_DASH_EQ] = ACTIONS(13547),
    [anon_sym_STAR_EQ] = ACTIONS(13547),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13547),
    [anon_sym_SLASH_EQ] = ACTIONS(13547),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13547),
    [anon_sym_PIPE_EQ] = ACTIONS(13547),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13547),
    [anon_sym_AMP_EQ] = ACTIONS(13547),
    [anon_sym_PERCENT_EQ] = ACTIONS(13547),
    [anon_sym_GT_GT_EQ] = ACTIONS(13547),
    [anon_sym_LT_LT_EQ] = ACTIONS(13547),
    [anon_sym_CARET_EQ] = ACTIONS(13547),
    [anon_sym_QMARK] = ACTIONS(13547),
    [anon_sym_DOT_DOT] = ACTIONS(13549),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13547),
    [anon_sym_and] = ACTIONS(13547),
    [anon_sym_or] = ACTIONS(13547),
    [anon_sym_PIPE_PIPE] = ACTIONS(13549),
    [anon_sym_AMP_AMP] = ACTIONS(13549),
    [anon_sym_LT_LT] = ACTIONS(13549),
    [anon_sym_GT_GT] = ACTIONS(13549),
    [anon_sym_EQ_EQ] = ACTIONS(13549),
    [anon_sym_BANG_EQ] = ACTIONS(13547),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13547),
    [anon_sym_LT_EQ_GT] = ACTIONS(13547),
    [anon_sym_EQ_TILDE] = ACTIONS(13547),
    [anon_sym_BANG_TILDE] = ACTIONS(13547),
    [anon_sym_LT_EQ] = ACTIONS(13549),
    [anon_sym_GT] = ACTIONS(13549),
    [anon_sym_GT_EQ] = ACTIONS(13547),
    [anon_sym_CARET] = ACTIONS(13549),
    [anon_sym_PLUS] = ACTIONS(13549),
    [anon_sym_SLASH] = ACTIONS(13549),
    [anon_sym_PERCENT] = ACTIONS(13549),
    [sym_comment] = ACTIONS(87),
  },
  [10089] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(6165),
    [sym__binary_star] = ACTIONS(6167),
    [ts_builtin_sym_end] = ACTIONS(12120),
    [anon_sym___END__] = ACTIONS(12120),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(6169),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(6167),
    [anon_sym_AMP] = ACTIONS(6171),
    [anon_sym_LT] = ACTIONS(6173),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(6175),
    [anon_sym_DOT_DOT] = ACTIONS(6177),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6179),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(6181),
    [anon_sym_AMP_AMP] = ACTIONS(6181),
    [anon_sym_LT_LT] = ACTIONS(6183),
    [anon_sym_GT_GT] = ACTIONS(6183),
    [anon_sym_EQ_EQ] = ACTIONS(6185),
    [anon_sym_BANG_EQ] = ACTIONS(6181),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6181),
    [anon_sym_LT_EQ_GT] = ACTIONS(6181),
    [anon_sym_EQ_TILDE] = ACTIONS(6181),
    [anon_sym_BANG_TILDE] = ACTIONS(6181),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6173),
    [anon_sym_GT_EQ] = ACTIONS(6187),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_PLUS] = ACTIONS(6165),
    [anon_sym_SLASH] = ACTIONS(6167),
    [anon_sym_PERCENT] = ACTIONS(6167),
    [sym_comment] = ACTIONS(87),
  },
  [10090] = {
    [sym_heredoc_body] = STATE(10831),
    [aux_sym_call_repeat1] = STATE(10831),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [10091] = {
    [sym_heredoc_body] = STATE(10832),
    [aux_sym_call_repeat1] = STATE(10832),
    [aux_sym_argument_list_repeat1] = STATE(8729),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(9925),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [10092] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(12345),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(12345),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(12345),
    [anon_sym_PERCENT] = ACTIONS(12345),
    [sym_comment] = ACTIONS(87),
  },
  [10093] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(12345),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [10094] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12343),
    [sym__binary_star] = ACTIONS(12345),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(12345),
    [anon_sym_AMP] = ACTIONS(12349),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(12361),
    [anon_sym_GT_GT] = ACTIONS(12361),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(12343),
    [anon_sym_SLASH] = ACTIONS(12345),
    [anon_sym_PERCENT] = ACTIONS(12345),
    [sym_comment] = ACTIONS(87),
  },
  [10095] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12343),
    [sym__binary_star] = ACTIONS(12345),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(12345),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(12361),
    [anon_sym_GT_GT] = ACTIONS(12361),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(12343),
    [anon_sym_SLASH] = ACTIONS(12345),
    [anon_sym_PERCENT] = ACTIONS(12345),
    [sym_comment] = ACTIONS(87),
  },
  [10096] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12343),
    [sym__binary_star] = ACTIONS(12345),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(12347),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(12345),
    [anon_sym_AMP] = ACTIONS(12349),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(12361),
    [anon_sym_GT_GT] = ACTIONS(12361),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(12367),
    [anon_sym_PLUS] = ACTIONS(12343),
    [anon_sym_SLASH] = ACTIONS(12345),
    [anon_sym_PERCENT] = ACTIONS(12345),
    [sym_comment] = ACTIONS(87),
  },
  [10097] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(14625),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [10098] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(12343),
    [sym__binary_star] = ACTIONS(12345),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(12347),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(12345),
    [anon_sym_AMP] = ACTIONS(12349),
    [anon_sym_LT] = ACTIONS(12351),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(12355),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12357),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(12359),
    [anon_sym_AMP_AMP] = ACTIONS(12359),
    [anon_sym_LT_LT] = ACTIONS(12361),
    [anon_sym_GT_GT] = ACTIONS(12361),
    [anon_sym_EQ_EQ] = ACTIONS(12363),
    [anon_sym_BANG_EQ] = ACTIONS(12359),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12359),
    [anon_sym_LT_EQ_GT] = ACTIONS(12359),
    [anon_sym_EQ_TILDE] = ACTIONS(12359),
    [anon_sym_BANG_TILDE] = ACTIONS(12359),
    [anon_sym_LT_EQ] = ACTIONS(12351),
    [anon_sym_GT] = ACTIONS(12351),
    [anon_sym_GT_EQ] = ACTIONS(12365),
    [anon_sym_CARET] = ACTIONS(12367),
    [anon_sym_PLUS] = ACTIONS(12343),
    [anon_sym_SLASH] = ACTIONS(12345),
    [anon_sym_PERCENT] = ACTIONS(12345),
    [sym_comment] = ACTIONS(87),
  },
  [10099] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12343),
    [sym__binary_star] = ACTIONS(12345),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(12347),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(12345),
    [anon_sym_AMP] = ACTIONS(12349),
    [anon_sym_LT] = ACTIONS(12351),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(12353),
    [anon_sym_DOT_DOT] = ACTIONS(12355),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12357),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(12359),
    [anon_sym_AMP_AMP] = ACTIONS(12359),
    [anon_sym_LT_LT] = ACTIONS(12361),
    [anon_sym_GT_GT] = ACTIONS(12361),
    [anon_sym_EQ_EQ] = ACTIONS(12363),
    [anon_sym_BANG_EQ] = ACTIONS(12359),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12359),
    [anon_sym_LT_EQ_GT] = ACTIONS(12359),
    [anon_sym_EQ_TILDE] = ACTIONS(12359),
    [anon_sym_BANG_TILDE] = ACTIONS(12359),
    [anon_sym_LT_EQ] = ACTIONS(12351),
    [anon_sym_GT] = ACTIONS(12351),
    [anon_sym_GT_EQ] = ACTIONS(12365),
    [anon_sym_CARET] = ACTIONS(12367),
    [anon_sym_PLUS] = ACTIONS(12343),
    [anon_sym_SLASH] = ACTIONS(12345),
    [anon_sym_PERCENT] = ACTIONS(12345),
    [sym_comment] = ACTIONS(87),
  },
  [10100] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12343),
    [sym__binary_star] = ACTIONS(12345),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(12347),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(12345),
    [anon_sym_AMP] = ACTIONS(12349),
    [anon_sym_LT] = ACTIONS(12351),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(12361),
    [anon_sym_GT_GT] = ACTIONS(12361),
    [anon_sym_EQ_EQ] = ACTIONS(12363),
    [anon_sym_BANG_EQ] = ACTIONS(12359),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12359),
    [anon_sym_LT_EQ_GT] = ACTIONS(12359),
    [anon_sym_EQ_TILDE] = ACTIONS(12359),
    [anon_sym_BANG_TILDE] = ACTIONS(12359),
    [anon_sym_LT_EQ] = ACTIONS(12351),
    [anon_sym_GT] = ACTIONS(12351),
    [anon_sym_GT_EQ] = ACTIONS(12365),
    [anon_sym_CARET] = ACTIONS(12367),
    [anon_sym_PLUS] = ACTIONS(12343),
    [anon_sym_SLASH] = ACTIONS(12345),
    [anon_sym_PERCENT] = ACTIONS(12345),
    [sym_comment] = ACTIONS(87),
  },
  [10101] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12343),
    [sym__binary_star] = ACTIONS(12345),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(12345),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(12343),
    [anon_sym_SLASH] = ACTIONS(12345),
    [anon_sym_PERCENT] = ACTIONS(12345),
    [sym_comment] = ACTIONS(87),
  },
  [10102] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(12343),
    [sym__binary_star] = ACTIONS(12345),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(12347),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(12345),
    [anon_sym_AMP] = ACTIONS(12349),
    [anon_sym_LT] = ACTIONS(12351),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(12353),
    [anon_sym_DOT_DOT] = ACTIONS(12355),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12357),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(12359),
    [anon_sym_AMP_AMP] = ACTIONS(12359),
    [anon_sym_LT_LT] = ACTIONS(12361),
    [anon_sym_GT_GT] = ACTIONS(12361),
    [anon_sym_EQ_EQ] = ACTIONS(12363),
    [anon_sym_BANG_EQ] = ACTIONS(12359),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12359),
    [anon_sym_LT_EQ_GT] = ACTIONS(12359),
    [anon_sym_EQ_TILDE] = ACTIONS(12359),
    [anon_sym_BANG_TILDE] = ACTIONS(12359),
    [anon_sym_LT_EQ] = ACTIONS(12351),
    [anon_sym_GT] = ACTIONS(12351),
    [anon_sym_GT_EQ] = ACTIONS(12365),
    [anon_sym_CARET] = ACTIONS(12367),
    [anon_sym_PLUS] = ACTIONS(12343),
    [anon_sym_SLASH] = ACTIONS(12345),
    [anon_sym_PERCENT] = ACTIONS(12345),
    [sym_comment] = ACTIONS(87),
  },
  [10103] = {
    [aux_sym_exceptions_repeat1] = STATE(10835),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [10104] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(12343),
    [sym__binary_star] = ACTIONS(12345),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(12347),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(12345),
    [anon_sym_AMP] = ACTIONS(12349),
    [anon_sym_LT] = ACTIONS(12351),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(12353),
    [anon_sym_DOT_DOT] = ACTIONS(12355),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12357),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(12359),
    [anon_sym_AMP_AMP] = ACTIONS(12359),
    [anon_sym_LT_LT] = ACTIONS(12361),
    [anon_sym_GT_GT] = ACTIONS(12361),
    [anon_sym_EQ_EQ] = ACTIONS(12363),
    [anon_sym_BANG_EQ] = ACTIONS(12359),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12359),
    [anon_sym_LT_EQ_GT] = ACTIONS(12359),
    [anon_sym_EQ_TILDE] = ACTIONS(12359),
    [anon_sym_BANG_TILDE] = ACTIONS(12359),
    [anon_sym_LT_EQ] = ACTIONS(12351),
    [anon_sym_GT] = ACTIONS(12351),
    [anon_sym_GT_EQ] = ACTIONS(12365),
    [anon_sym_CARET] = ACTIONS(12367),
    [anon_sym_PLUS] = ACTIONS(12343),
    [anon_sym_SLASH] = ACTIONS(12345),
    [anon_sym_PERCENT] = ACTIONS(12345),
    [sym_comment] = ACTIONS(87),
  },
  [10105] = {
    [sym_string] = STATE(10105),
    [aux_sym_chained_string_repeat1] = STATE(10105),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(6214),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [10106] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(9891),
    [sym__binary_star] = ACTIONS(9893),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(9895),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(9893),
    [anon_sym_AMP] = ACTIONS(9897),
    [anon_sym_LT] = ACTIONS(9899),
    [anon_sym_if] = ACTIONS(6823),
    [anon_sym_unless] = ACTIONS(6823),
    [anon_sym_while] = ACTIONS(6823),
    [anon_sym_until] = ACTIONS(6823),
    [anon_sym_rescue] = ACTIONS(6823),
    [anon_sym_EQ_GT] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(9901),
    [anon_sym_DOT_DOT] = ACTIONS(9903),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9905),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(9907),
    [anon_sym_AMP_AMP] = ACTIONS(9907),
    [anon_sym_LT_LT] = ACTIONS(9909),
    [anon_sym_GT_GT] = ACTIONS(9909),
    [anon_sym_EQ_EQ] = ACTIONS(9911),
    [anon_sym_BANG_EQ] = ACTIONS(9907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9907),
    [anon_sym_LT_EQ_GT] = ACTIONS(9907),
    [anon_sym_EQ_TILDE] = ACTIONS(9907),
    [anon_sym_BANG_TILDE] = ACTIONS(9907),
    [anon_sym_LT_EQ] = ACTIONS(9899),
    [anon_sym_GT] = ACTIONS(9899),
    [anon_sym_GT_EQ] = ACTIONS(9913),
    [anon_sym_CARET] = ACTIONS(9915),
    [anon_sym_PLUS] = ACTIONS(9891),
    [anon_sym_SLASH] = ACTIONS(9893),
    [anon_sym_PERCENT] = ACTIONS(9893),
    [sym_comment] = ACTIONS(87),
  },
  [10107] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(9891),
    [sym__binary_star] = ACTIONS(9893),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(9895),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(9893),
    [anon_sym_AMP] = ACTIONS(9897),
    [anon_sym_LT] = ACTIONS(9899),
    [anon_sym_if] = ACTIONS(7027),
    [anon_sym_unless] = ACTIONS(7027),
    [anon_sym_while] = ACTIONS(7027),
    [anon_sym_until] = ACTIONS(7027),
    [anon_sym_rescue] = ACTIONS(7027),
    [anon_sym_EQ_GT] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(9901),
    [anon_sym_DOT_DOT] = ACTIONS(9903),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9905),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(9907),
    [anon_sym_AMP_AMP] = ACTIONS(9907),
    [anon_sym_LT_LT] = ACTIONS(9909),
    [anon_sym_GT_GT] = ACTIONS(9909),
    [anon_sym_EQ_EQ] = ACTIONS(9911),
    [anon_sym_BANG_EQ] = ACTIONS(9907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9907),
    [anon_sym_LT_EQ_GT] = ACTIONS(9907),
    [anon_sym_EQ_TILDE] = ACTIONS(9907),
    [anon_sym_BANG_TILDE] = ACTIONS(9907),
    [anon_sym_LT_EQ] = ACTIONS(9899),
    [anon_sym_GT] = ACTIONS(9899),
    [anon_sym_GT_EQ] = ACTIONS(9913),
    [anon_sym_CARET] = ACTIONS(9915),
    [anon_sym_PLUS] = ACTIONS(9891),
    [anon_sym_SLASH] = ACTIONS(9893),
    [anon_sym_PERCENT] = ACTIONS(9893),
    [sym_comment] = ACTIONS(87),
  },
  [10108] = {
    [sym_heredoc_body] = STATE(10108),
    [aux_sym_call_repeat1] = STATE(10108),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(7916),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_EQ_GT] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [10109] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6431),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3782),
    [sym_scope_resolution] = STATE(3778),
    [sym_call] = STATE(3778),
    [sym_method_call] = STATE(3782),
    [sym__argument] = STATE(4986),
    [sym_splat_argument] = STATE(4986),
    [sym_hash_splat_argument] = STATE(4986),
    [sym_block_argument] = STATE(4986),
    [sym_assignment] = STATE(6431),
    [sym_operator_assignment] = STATE(6431),
    [sym_conditional] = STATE(6431),
    [sym_range] = STATE(6431),
    [sym_binary] = STATE(6431),
    [sym_unary] = STATE(6431),
    [sym_left_assignment_list] = STATE(3781),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3782),
    [sym__variable] = STATE(3778),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3782),
    [sym_false] = STATE(3782),
    [sym_nil] = STATE(3782),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(6434),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4986),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(9881),
    [sym__splat_star] = ACTIONS(9883),
    [sym__unary_minus] = ACTIONS(6245),
    [sym__identifier_hash_key] = ACTIONS(9885),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13799),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6249),
    [anon_sym_yield] = ACTIONS(6251),
    [anon_sym_break] = ACTIONS(6253),
    [anon_sym_next] = ACTIONS(6255),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9877),
    [anon_sym_defined_QMARK] = ACTIONS(6257),
    [anon_sym_not] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(6263),
    [anon_sym_TILDE] = ACTIONS(6263),
    [sym_constant] = ACTIONS(9887),
    [sym_identifier] = ACTIONS(9887),
    [sym_instance_variable] = ACTIONS(6267),
    [sym_class_variable] = ACTIONS(6267),
    [sym_global_variable] = ACTIONS(6267),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(6269),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6269),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10110] = {
    [sym_heredoc_body] = STATE(10108),
    [aux_sym_call_repeat1] = STATE(10108),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_EQ_GT] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [10111] = {
    [aux_sym_argument_list_repeat1] = STATE(10111),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(14627),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7925),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_if] = ACTIONS(7925),
    [anon_sym_unless] = ACTIONS(7925),
    [anon_sym_while] = ACTIONS(7925),
    [anon_sym_until] = ACTIONS(7925),
    [anon_sym_rescue] = ACTIONS(7925),
    [anon_sym_EQ_GT] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7925),
    [anon_sym_AMP_AMP] = ACTIONS(7925),
    [anon_sym_LT_LT] = ACTIONS(7925),
    [anon_sym_GT_GT] = ACTIONS(7925),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7925),
    [anon_sym_PLUS] = ACTIONS(7925),
    [anon_sym_SLASH] = ACTIONS(7925),
    [anon_sym_PERCENT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [10112] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10836),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3782),
    [sym_scope_resolution] = STATE(3778),
    [sym_call] = STATE(3778),
    [sym_method_call] = STATE(3782),
    [sym_assignment] = STATE(10836),
    [sym_operator_assignment] = STATE(10836),
    [sym_conditional] = STATE(10836),
    [sym_range] = STATE(10836),
    [sym_binary] = STATE(10836),
    [sym_unary] = STATE(10836),
    [sym_left_assignment_list] = STATE(3781),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3782),
    [sym__variable] = STATE(3778),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3782),
    [sym_false] = STATE(3782),
    [sym_nil] = STATE(3782),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(6423),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(6245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6249),
    [anon_sym_yield] = ACTIONS(6251),
    [anon_sym_break] = ACTIONS(6253),
    [anon_sym_next] = ACTIONS(6255),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9877),
    [anon_sym_defined_QMARK] = ACTIONS(6257),
    [anon_sym_not] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(6263),
    [anon_sym_TILDE] = ACTIONS(6263),
    [sym_constant] = ACTIONS(6269),
    [sym_identifier] = ACTIONS(6269),
    [sym_instance_variable] = ACTIONS(6267),
    [sym_class_variable] = ACTIONS(6267),
    [sym_global_variable] = ACTIONS(6267),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(6269),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6269),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10113] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(9963),
    [sym__binary_star] = ACTIONS(9965),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(9967),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(9969),
    [anon_sym_AMP] = ACTIONS(9971),
    [anon_sym_EQ] = ACTIONS(7822),
    [anon_sym_LT] = ACTIONS(9973),
    [anon_sym_if] = ACTIONS(6823),
    [anon_sym_unless] = ACTIONS(6823),
    [anon_sym_while] = ACTIONS(6823),
    [anon_sym_until] = ACTIONS(6823),
    [anon_sym_rescue] = ACTIONS(6823),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_EQ_GT] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_PLUS_EQ] = ACTIONS(6823),
    [anon_sym_DASH_EQ] = ACTIONS(6823),
    [anon_sym_STAR_EQ] = ACTIONS(6823),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6823),
    [anon_sym_SLASH_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6823),
    [anon_sym_AMP_EQ] = ACTIONS(6823),
    [anon_sym_PERCENT_EQ] = ACTIONS(6823),
    [anon_sym_GT_GT_EQ] = ACTIONS(6823),
    [anon_sym_LT_LT_EQ] = ACTIONS(6823),
    [anon_sym_CARET_EQ] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(9975),
    [anon_sym_DOT_DOT] = ACTIONS(9977),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9979),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(9981),
    [anon_sym_AMP_AMP] = ACTIONS(9981),
    [anon_sym_LT_LT] = ACTIONS(9983),
    [anon_sym_GT_GT] = ACTIONS(9983),
    [anon_sym_EQ_EQ] = ACTIONS(9981),
    [anon_sym_BANG_EQ] = ACTIONS(9985),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9985),
    [anon_sym_LT_EQ_GT] = ACTIONS(9985),
    [anon_sym_EQ_TILDE] = ACTIONS(9985),
    [anon_sym_BANG_TILDE] = ACTIONS(9985),
    [anon_sym_LT_EQ] = ACTIONS(9973),
    [anon_sym_GT] = ACTIONS(9973),
    [anon_sym_GT_EQ] = ACTIONS(9987),
    [anon_sym_CARET] = ACTIONS(9967),
    [anon_sym_PLUS] = ACTIONS(9989),
    [anon_sym_SLASH] = ACTIONS(9969),
    [anon_sym_PERCENT] = ACTIONS(9969),
    [sym_comment] = ACTIONS(87),
  },
  [10114] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(9963),
    [sym__binary_star] = ACTIONS(9965),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(9967),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(9969),
    [anon_sym_AMP] = ACTIONS(9971),
    [anon_sym_EQ] = ACTIONS(7884),
    [anon_sym_LT] = ACTIONS(9973),
    [anon_sym_if] = ACTIONS(7027),
    [anon_sym_unless] = ACTIONS(7027),
    [anon_sym_while] = ACTIONS(7027),
    [anon_sym_until] = ACTIONS(7027),
    [anon_sym_rescue] = ACTIONS(7027),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_EQ_GT] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_PLUS_EQ] = ACTIONS(7027),
    [anon_sym_DASH_EQ] = ACTIONS(7027),
    [anon_sym_STAR_EQ] = ACTIONS(7027),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7027),
    [anon_sym_SLASH_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7027),
    [anon_sym_AMP_EQ] = ACTIONS(7027),
    [anon_sym_PERCENT_EQ] = ACTIONS(7027),
    [anon_sym_GT_GT_EQ] = ACTIONS(7027),
    [anon_sym_LT_LT_EQ] = ACTIONS(7027),
    [anon_sym_CARET_EQ] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(9975),
    [anon_sym_DOT_DOT] = ACTIONS(9977),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9979),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(9981),
    [anon_sym_AMP_AMP] = ACTIONS(9981),
    [anon_sym_LT_LT] = ACTIONS(9983),
    [anon_sym_GT_GT] = ACTIONS(9983),
    [anon_sym_EQ_EQ] = ACTIONS(9981),
    [anon_sym_BANG_EQ] = ACTIONS(9985),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9985),
    [anon_sym_LT_EQ_GT] = ACTIONS(9985),
    [anon_sym_EQ_TILDE] = ACTIONS(9985),
    [anon_sym_BANG_TILDE] = ACTIONS(9985),
    [anon_sym_LT_EQ] = ACTIONS(9973),
    [anon_sym_GT] = ACTIONS(9973),
    [anon_sym_GT_EQ] = ACTIONS(9987),
    [anon_sym_CARET] = ACTIONS(9967),
    [anon_sym_PLUS] = ACTIONS(9989),
    [anon_sym_SLASH] = ACTIONS(9969),
    [anon_sym_PERCENT] = ACTIONS(9969),
    [sym_comment] = ACTIONS(87),
  },
  [10115] = {
    [sym_heredoc_body] = STATE(10115),
    [aux_sym_call_repeat1] = STATE(10115),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(10978),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7919),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_EQ] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_EQ_GT] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_PLUS_EQ] = ACTIONS(7914),
    [anon_sym_DASH_EQ] = ACTIONS(7914),
    [anon_sym_STAR_EQ] = ACTIONS(7914),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7914),
    [anon_sym_SLASH_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7914),
    [anon_sym_AMP_EQ] = ACTIONS(7914),
    [anon_sym_PERCENT_EQ] = ACTIONS(7914),
    [anon_sym_GT_GT_EQ] = ACTIONS(7914),
    [anon_sym_LT_LT_EQ] = ACTIONS(7914),
    [anon_sym_CARET_EQ] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7919),
    [anon_sym_AMP_AMP] = ACTIONS(7919),
    [anon_sym_LT_LT] = ACTIONS(7919),
    [anon_sym_GT_GT] = ACTIONS(7919),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7919),
    [anon_sym_PLUS] = ACTIONS(7919),
    [anon_sym_SLASH] = ACTIONS(7919),
    [anon_sym_PERCENT] = ACTIONS(7919),
    [sym_comment] = ACTIONS(87),
  },
  [10116] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(6452),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3818),
    [sym_scope_resolution] = STATE(3814),
    [sym_call] = STATE(3814),
    [sym_method_call] = STATE(3818),
    [sym__argument] = STATE(7437),
    [sym_splat_argument] = STATE(7437),
    [sym_hash_splat_argument] = STATE(7437),
    [sym_block_argument] = STATE(7437),
    [sym_assignment] = STATE(6452),
    [sym_operator_assignment] = STATE(6452),
    [sym_conditional] = STATE(6452),
    [sym_range] = STATE(6452),
    [sym_binary] = STATE(6452),
    [sym_unary] = STATE(6452),
    [sym_left_assignment_list] = STATE(3817),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3818),
    [sym__variable] = STATE(3814),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3818),
    [sym_false] = STATE(3818),
    [sym_nil] = STATE(3818),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(6455),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(7437),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(9917),
    [sym__splat_star] = ACTIONS(9919),
    [sym__unary_minus] = ACTIONS(6315),
    [sym__identifier_hash_key] = ACTIONS(9921),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13803),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(6319),
    [anon_sym_yield] = ACTIONS(6321),
    [anon_sym_break] = ACTIONS(6323),
    [anon_sym_next] = ACTIONS(6325),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(9957),
    [anon_sym_defined_QMARK] = ACTIONS(6327),
    [anon_sym_not] = ACTIONS(6329),
    [anon_sym_BANG] = ACTIONS(6333),
    [anon_sym_TILDE] = ACTIONS(6333),
    [sym_constant] = ACTIONS(9923),
    [sym_identifier] = ACTIONS(9923),
    [sym_instance_variable] = ACTIONS(6337),
    [sym_class_variable] = ACTIONS(6337),
    [sym_global_variable] = ACTIONS(6337),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(6339),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6339),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [10117] = {
    [sym_heredoc_body] = STATE(10115),
    [aux_sym_call_repeat1] = STATE(10115),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7931),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_EQ] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_EQ_GT] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_PLUS_EQ] = ACTIONS(7929),
    [anon_sym_DASH_EQ] = ACTIONS(7929),
    [anon_sym_STAR_EQ] = ACTIONS(7929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7929),
    [anon_sym_SLASH_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7929),
    [anon_sym_AMP_EQ] = ACTIONS(7929),
    [anon_sym_PERCENT_EQ] = ACTIONS(7929),
    [anon_sym_GT_GT_EQ] = ACTIONS(7929),
    [anon_sym_LT_LT_EQ] = ACTIONS(7929),
    [anon_sym_CARET_EQ] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7931),
    [anon_sym_AMP_AMP] = ACTIONS(7931),
    [anon_sym_LT_LT] = ACTIONS(7931),
    [anon_sym_GT_GT] = ACTIONS(7931),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7931),
    [anon_sym_PLUS] = ACTIONS(7931),
    [anon_sym_SLASH] = ACTIONS(7931),
    [anon_sym_PERCENT] = ACTIONS(7931),
    [sym_comment] = ACTIONS(87),
  },
  [10118] = {
    [aux_sym_argument_list_repeat1] = STATE(10118),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(14630),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7927),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_EQ] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_if] = ACTIONS(7925),
    [anon_sym_unless] = ACTIONS(7925),
    [anon_sym_while] = ACTIONS(7925),
    [anon_sym_until] = ACTIONS(7925),
    [anon_sym_rescue] = ACTIONS(7925),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_EQ_GT] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_PLUS_EQ] = ACTIONS(7925),
    [anon_sym_DASH_EQ] = ACTIONS(7925),
    [anon_sym_STAR_EQ] = ACTIONS(7925),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7925),
    [anon_sym_SLASH_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7925),
    [anon_sym_AMP_EQ] = ACTIONS(7925),
    [anon_sym_PERCENT_EQ] = ACTIONS(7925),
    [anon_sym_GT_GT_EQ] = ACTIONS(7925),
    [anon_sym_LT_LT_EQ] = ACTIONS(7925),
    [anon_sym_CARET_EQ] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7927),
    [anon_sym_AMP_AMP] = ACTIONS(7927),
    [anon_sym_LT_LT] = ACTIONS(7927),
    [anon_sym_GT_GT] = ACTIONS(7927),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7927),
    [anon_sym_PLUS] = ACTIONS(7927),
    [anon_sym_SLASH] = ACTIONS(7927),
    [anon_sym_PERCENT] = ACTIONS(7927),
    [sym_comment] = ACTIONS(87),
  },
  [10119] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8730),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3782),
    [sym_scope_resolution] = STATE(3778),
    [sym_call] = STATE(3778),
    [sym_method_call] = STATE(3782),
    [sym_splat_argument] = STATE(7439),
    [sym_assignment] = STATE(8730),
    [sym_operator_assignment] = STATE(8730),
    [sym_conditional] = STATE(8730),
    [sym_range] = STATE(8730),
    [sym_binary] = STATE(8730),
    [sym_unary] = STATE(8730),
    [sym__arg_or_splat_arg] = STATE(7439),
    [sym_left_assignment_list] = STATE(3781),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3782),
    [sym__variable] = STATE(3778),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3782),
    [sym_false] = STATE(3782),
    [sym_nil] = STATE(3782),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(6423),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__splat_star] = ACTIONS(9883),
    [sym__unary_minus] = ACTIONS(6245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6249),
    [anon_sym_yield] = ACTIONS(6251),
    [anon_sym_break] = ACTIONS(6253),
    [anon_sym_next] = ACTIONS(6255),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9877),
    [anon_sym_defined_QMARK] = ACTIONS(6257),
    [anon_sym_not] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(6263),
    [anon_sym_TILDE] = ACTIONS(6263),
    [sym_constant] = ACTIONS(6269),
    [sym_identifier] = ACTIONS(6269),
    [sym_instance_variable] = ACTIONS(6267),
    [sym_class_variable] = ACTIONS(6267),
    [sym_global_variable] = ACTIONS(6267),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(6269),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6269),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10120] = {
    [aux_sym_exceptions_repeat1] = STATE(10837),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(14633),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_EQ_GT] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [10121] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(6283),
    [sym__binary_star] = ACTIONS(6285),
    [anon_sym_PIPE] = ACTIONS(6287),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(6285),
    [anon_sym_AMP] = ACTIONS(6289),
    [anon_sym_LT] = ACTIONS(6291),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(6293),
    [anon_sym_DOT_DOT] = ACTIONS(6295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6297),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(6301),
    [anon_sym_AMP_AMP] = ACTIONS(6301),
    [anon_sym_LT_LT] = ACTIONS(6303),
    [anon_sym_GT_GT] = ACTIONS(6303),
    [anon_sym_EQ_EQ] = ACTIONS(6305),
    [anon_sym_BANG_EQ] = ACTIONS(6301),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6301),
    [anon_sym_LT_EQ_GT] = ACTIONS(6301),
    [anon_sym_EQ_TILDE] = ACTIONS(6301),
    [anon_sym_BANG_TILDE] = ACTIONS(6301),
    [anon_sym_LT_EQ] = ACTIONS(6291),
    [anon_sym_GT] = ACTIONS(6291),
    [anon_sym_GT_EQ] = ACTIONS(6307),
    [anon_sym_CARET] = ACTIONS(6309),
    [anon_sym_PLUS] = ACTIONS(6283),
    [anon_sym_SLASH] = ACTIONS(6285),
    [anon_sym_PERCENT] = ACTIONS(6285),
    [sym_comment] = ACTIONS(87),
  },
  [10122] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(12397),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(12401),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(12401),
    [anon_sym_PERCENT] = ACTIONS(12401),
    [sym_comment] = ACTIONS(87),
  },
  [10123] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(12401),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(5827),
    [anon_sym_PERCENT] = ACTIONS(5827),
    [sym_comment] = ACTIONS(87),
  },
  [10124] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12395),
    [sym__binary_star] = ACTIONS(12397),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(12401),
    [anon_sym_AMP] = ACTIONS(12403),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(12415),
    [anon_sym_GT_GT] = ACTIONS(12415),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(12421),
    [anon_sym_SLASH] = ACTIONS(12401),
    [anon_sym_PERCENT] = ACTIONS(12401),
    [sym_comment] = ACTIONS(87),
  },
  [10125] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12395),
    [sym__binary_star] = ACTIONS(12397),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(12401),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(12415),
    [anon_sym_GT_GT] = ACTIONS(12415),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(12421),
    [anon_sym_SLASH] = ACTIONS(12401),
    [anon_sym_PERCENT] = ACTIONS(12401),
    [sym_comment] = ACTIONS(87),
  },
  [10126] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12395),
    [sym__binary_star] = ACTIONS(12397),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(12399),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(12401),
    [anon_sym_AMP] = ACTIONS(12403),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(12415),
    [anon_sym_GT_GT] = ACTIONS(12415),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(12399),
    [anon_sym_PLUS] = ACTIONS(12421),
    [anon_sym_SLASH] = ACTIONS(12401),
    [anon_sym_PERCENT] = ACTIONS(12401),
    [sym_comment] = ACTIONS(87),
  },
  [10127] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(14635),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [10128] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(12395),
    [sym__binary_star] = ACTIONS(12397),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(12399),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(12401),
    [anon_sym_AMP] = ACTIONS(12403),
    [anon_sym_EQ] = ACTIONS(7888),
    [anon_sym_LT] = ACTIONS(12405),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_PLUS_EQ] = ACTIONS(5927),
    [anon_sym_DASH_EQ] = ACTIONS(5927),
    [anon_sym_STAR_EQ] = ACTIONS(5927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5927),
    [anon_sym_SLASH_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5927),
    [anon_sym_AMP_EQ] = ACTIONS(5927),
    [anon_sym_PERCENT_EQ] = ACTIONS(5927),
    [anon_sym_GT_GT_EQ] = ACTIONS(5927),
    [anon_sym_LT_LT_EQ] = ACTIONS(5927),
    [anon_sym_CARET_EQ] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(12409),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12411),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(12413),
    [anon_sym_AMP_AMP] = ACTIONS(12413),
    [anon_sym_LT_LT] = ACTIONS(12415),
    [anon_sym_GT_GT] = ACTIONS(12415),
    [anon_sym_EQ_EQ] = ACTIONS(12413),
    [anon_sym_BANG_EQ] = ACTIONS(12417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12417),
    [anon_sym_LT_EQ_GT] = ACTIONS(12417),
    [anon_sym_EQ_TILDE] = ACTIONS(12417),
    [anon_sym_BANG_TILDE] = ACTIONS(12417),
    [anon_sym_LT_EQ] = ACTIONS(12405),
    [anon_sym_GT] = ACTIONS(12405),
    [anon_sym_GT_EQ] = ACTIONS(12419),
    [anon_sym_CARET] = ACTIONS(12399),
    [anon_sym_PLUS] = ACTIONS(12421),
    [anon_sym_SLASH] = ACTIONS(12401),
    [anon_sym_PERCENT] = ACTIONS(12401),
    [sym_comment] = ACTIONS(87),
  },
  [10129] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12395),
    [sym__binary_star] = ACTIONS(12397),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(12399),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(12401),
    [anon_sym_AMP] = ACTIONS(12403),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(12405),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(12407),
    [anon_sym_DOT_DOT] = ACTIONS(12409),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12411),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(12413),
    [anon_sym_AMP_AMP] = ACTIONS(12413),
    [anon_sym_LT_LT] = ACTIONS(12415),
    [anon_sym_GT_GT] = ACTIONS(12415),
    [anon_sym_EQ_EQ] = ACTIONS(12413),
    [anon_sym_BANG_EQ] = ACTIONS(12417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12417),
    [anon_sym_LT_EQ_GT] = ACTIONS(12417),
    [anon_sym_EQ_TILDE] = ACTIONS(12417),
    [anon_sym_BANG_TILDE] = ACTIONS(12417),
    [anon_sym_LT_EQ] = ACTIONS(12405),
    [anon_sym_GT] = ACTIONS(12405),
    [anon_sym_GT_EQ] = ACTIONS(12419),
    [anon_sym_CARET] = ACTIONS(12399),
    [anon_sym_PLUS] = ACTIONS(12421),
    [anon_sym_SLASH] = ACTIONS(12401),
    [anon_sym_PERCENT] = ACTIONS(12401),
    [sym_comment] = ACTIONS(87),
  },
  [10130] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12395),
    [sym__binary_star] = ACTIONS(12397),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(12399),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(12401),
    [anon_sym_AMP] = ACTIONS(12403),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(12405),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(12415),
    [anon_sym_GT_GT] = ACTIONS(12415),
    [anon_sym_EQ_EQ] = ACTIONS(12413),
    [anon_sym_BANG_EQ] = ACTIONS(12417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12417),
    [anon_sym_LT_EQ_GT] = ACTIONS(12417),
    [anon_sym_EQ_TILDE] = ACTIONS(12417),
    [anon_sym_BANG_TILDE] = ACTIONS(12417),
    [anon_sym_LT_EQ] = ACTIONS(12405),
    [anon_sym_GT] = ACTIONS(12405),
    [anon_sym_GT_EQ] = ACTIONS(12419),
    [anon_sym_CARET] = ACTIONS(12399),
    [anon_sym_PLUS] = ACTIONS(12421),
    [anon_sym_SLASH] = ACTIONS(12401),
    [anon_sym_PERCENT] = ACTIONS(12401),
    [sym_comment] = ACTIONS(87),
  },
  [10131] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12395),
    [sym__binary_star] = ACTIONS(12397),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(12401),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(12421),
    [anon_sym_SLASH] = ACTIONS(12401),
    [anon_sym_PERCENT] = ACTIONS(12401),
    [sym_comment] = ACTIONS(87),
  },
  [10132] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(12395),
    [sym__binary_star] = ACTIONS(12397),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(12399),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(12401),
    [anon_sym_AMP] = ACTIONS(12403),
    [anon_sym_EQ] = ACTIONS(7936),
    [anon_sym_LT] = ACTIONS(12405),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_PLUS_EQ] = ACTIONS(5115),
    [anon_sym_DASH_EQ] = ACTIONS(5115),
    [anon_sym_STAR_EQ] = ACTIONS(5115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5115),
    [anon_sym_SLASH_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5115),
    [anon_sym_AMP_EQ] = ACTIONS(5115),
    [anon_sym_PERCENT_EQ] = ACTIONS(5115),
    [anon_sym_GT_GT_EQ] = ACTIONS(5115),
    [anon_sym_LT_LT_EQ] = ACTIONS(5115),
    [anon_sym_CARET_EQ] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(12407),
    [anon_sym_DOT_DOT] = ACTIONS(12409),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12411),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(12413),
    [anon_sym_AMP_AMP] = ACTIONS(12413),
    [anon_sym_LT_LT] = ACTIONS(12415),
    [anon_sym_GT_GT] = ACTIONS(12415),
    [anon_sym_EQ_EQ] = ACTIONS(12413),
    [anon_sym_BANG_EQ] = ACTIONS(12417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12417),
    [anon_sym_LT_EQ_GT] = ACTIONS(12417),
    [anon_sym_EQ_TILDE] = ACTIONS(12417),
    [anon_sym_BANG_TILDE] = ACTIONS(12417),
    [anon_sym_LT_EQ] = ACTIONS(12405),
    [anon_sym_GT] = ACTIONS(12405),
    [anon_sym_GT_EQ] = ACTIONS(12419),
    [anon_sym_CARET] = ACTIONS(12399),
    [anon_sym_PLUS] = ACTIONS(12421),
    [anon_sym_SLASH] = ACTIONS(12401),
    [anon_sym_PERCENT] = ACTIONS(12401),
    [sym_comment] = ACTIONS(87),
  },
  [10133] = {
    [aux_sym_exceptions_repeat1] = STATE(10840),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6193),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_PLUS_EQ] = ACTIONS(6191),
    [anon_sym_DASH_EQ] = ACTIONS(6191),
    [anon_sym_STAR_EQ] = ACTIONS(6191),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6191),
    [anon_sym_SLASH_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6191),
    [anon_sym_AMP_EQ] = ACTIONS(6191),
    [anon_sym_PERCENT_EQ] = ACTIONS(6191),
    [anon_sym_GT_GT_EQ] = ACTIONS(6191),
    [anon_sym_LT_LT_EQ] = ACTIONS(6191),
    [anon_sym_CARET_EQ] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6193),
    [anon_sym_AMP_AMP] = ACTIONS(6193),
    [anon_sym_LT_LT] = ACTIONS(6193),
    [anon_sym_GT_GT] = ACTIONS(6193),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6193),
    [anon_sym_PLUS] = ACTIONS(6193),
    [anon_sym_SLASH] = ACTIONS(6193),
    [anon_sym_PERCENT] = ACTIONS(6193),
    [sym_comment] = ACTIONS(87),
  },
  [10134] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(12395),
    [sym__binary_star] = ACTIONS(12397),
    [anon_sym_LBRACE] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(12399),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(12401),
    [anon_sym_AMP] = ACTIONS(12403),
    [anon_sym_EQ] = ACTIONS(7938),
    [anon_sym_LT] = ACTIONS(12405),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_PLUS_EQ] = ACTIONS(6210),
    [anon_sym_DASH_EQ] = ACTIONS(6210),
    [anon_sym_STAR_EQ] = ACTIONS(6210),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6210),
    [anon_sym_SLASH_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6210),
    [anon_sym_AMP_EQ] = ACTIONS(6210),
    [anon_sym_PERCENT_EQ] = ACTIONS(6210),
    [anon_sym_GT_GT_EQ] = ACTIONS(6210),
    [anon_sym_LT_LT_EQ] = ACTIONS(6210),
    [anon_sym_CARET_EQ] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(12407),
    [anon_sym_DOT_DOT] = ACTIONS(12409),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12411),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(12413),
    [anon_sym_AMP_AMP] = ACTIONS(12413),
    [anon_sym_LT_LT] = ACTIONS(12415),
    [anon_sym_GT_GT] = ACTIONS(12415),
    [anon_sym_EQ_EQ] = ACTIONS(12413),
    [anon_sym_BANG_EQ] = ACTIONS(12417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12417),
    [anon_sym_LT_EQ_GT] = ACTIONS(12417),
    [anon_sym_EQ_TILDE] = ACTIONS(12417),
    [anon_sym_BANG_TILDE] = ACTIONS(12417),
    [anon_sym_LT_EQ] = ACTIONS(12405),
    [anon_sym_GT] = ACTIONS(12405),
    [anon_sym_GT_EQ] = ACTIONS(12419),
    [anon_sym_CARET] = ACTIONS(12399),
    [anon_sym_PLUS] = ACTIONS(12421),
    [anon_sym_SLASH] = ACTIONS(12401),
    [anon_sym_PERCENT] = ACTIONS(12401),
    [sym_comment] = ACTIONS(87),
  },
  [10135] = {
    [sym_string] = STATE(10135),
    [aux_sym_chained_string_repeat1] = STATE(10135),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(12267),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6217),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_EQ] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_do] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_PLUS_EQ] = ACTIONS(6212),
    [anon_sym_DASH_EQ] = ACTIONS(6212),
    [anon_sym_STAR_EQ] = ACTIONS(6212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6212),
    [anon_sym_SLASH_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6212),
    [anon_sym_AMP_EQ] = ACTIONS(6212),
    [anon_sym_PERCENT_EQ] = ACTIONS(6212),
    [anon_sym_GT_GT_EQ] = ACTIONS(6212),
    [anon_sym_LT_LT_EQ] = ACTIONS(6212),
    [anon_sym_CARET_EQ] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6217),
    [anon_sym_AMP_AMP] = ACTIONS(6217),
    [anon_sym_LT_LT] = ACTIONS(6217),
    [anon_sym_GT_GT] = ACTIONS(6217),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6217),
    [anon_sym_PLUS] = ACTIONS(6217),
    [anon_sym_SLASH] = ACTIONS(6217),
    [anon_sym_PERCENT] = ACTIONS(6217),
    [sym_comment] = ACTIONS(87),
  },
  [10136] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(10841),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3818),
    [sym_scope_resolution] = STATE(3814),
    [sym_call] = STATE(3814),
    [sym_method_call] = STATE(3818),
    [sym_assignment] = STATE(10841),
    [sym_operator_assignment] = STATE(10841),
    [sym_conditional] = STATE(10841),
    [sym_range] = STATE(10841),
    [sym_binary] = STATE(10841),
    [sym_unary] = STATE(10841),
    [sym_left_assignment_list] = STATE(3817),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3818),
    [sym__variable] = STATE(3814),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3818),
    [sym_false] = STATE(3818),
    [sym_nil] = STATE(3818),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(6492),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(6319),
    [anon_sym_yield] = ACTIONS(6321),
    [anon_sym_break] = ACTIONS(6323),
    [anon_sym_next] = ACTIONS(6325),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(9957),
    [anon_sym_defined_QMARK] = ACTIONS(6327),
    [anon_sym_not] = ACTIONS(6329),
    [anon_sym_BANG] = ACTIONS(6333),
    [anon_sym_TILDE] = ACTIONS(6333),
    [sym_constant] = ACTIONS(6339),
    [sym_identifier] = ACTIONS(6339),
    [sym_instance_variable] = ACTIONS(6337),
    [sym_class_variable] = ACTIONS(6337),
    [sym_global_variable] = ACTIONS(6337),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(6339),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6339),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [10137] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(8767),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(3818),
    [sym_scope_resolution] = STATE(3814),
    [sym_call] = STATE(3814),
    [sym_method_call] = STATE(3818),
    [sym_splat_argument] = STATE(8678),
    [sym_assignment] = STATE(8767),
    [sym_operator_assignment] = STATE(8767),
    [sym_conditional] = STATE(8767),
    [sym_range] = STATE(8767),
    [sym_binary] = STATE(8767),
    [sym_unary] = STATE(8767),
    [sym__arg_or_splat_arg] = STATE(8678),
    [sym_left_assignment_list] = STATE(3817),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3818),
    [sym__variable] = STATE(3814),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(3818),
    [sym_false] = STATE(3818),
    [sym_nil] = STATE(3818),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(6492),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__splat_star] = ACTIONS(9919),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(6319),
    [anon_sym_yield] = ACTIONS(6321),
    [anon_sym_break] = ACTIONS(6323),
    [anon_sym_next] = ACTIONS(6325),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(9957),
    [anon_sym_defined_QMARK] = ACTIONS(6327),
    [anon_sym_not] = ACTIONS(6329),
    [anon_sym_BANG] = ACTIONS(6333),
    [anon_sym_TILDE] = ACTIONS(6333),
    [sym_constant] = ACTIONS(6339),
    [sym_identifier] = ACTIONS(6339),
    [sym_instance_variable] = ACTIONS(6337),
    [sym_class_variable] = ACTIONS(6337),
    [sym_global_variable] = ACTIONS(6337),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(6339),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(6339),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [10138] = {
    [aux_sym_exceptions_repeat1] = STATE(10842),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_LBRACE] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(14637),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9857),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_EQ] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_do] = ACTIONS(9855),
    [anon_sym_EQ_GT] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_PLUS_EQ] = ACTIONS(9855),
    [anon_sym_DASH_EQ] = ACTIONS(9855),
    [anon_sym_STAR_EQ] = ACTIONS(9855),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9855),
    [anon_sym_SLASH_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9855),
    [anon_sym_AMP_EQ] = ACTIONS(9855),
    [anon_sym_PERCENT_EQ] = ACTIONS(9855),
    [anon_sym_GT_GT_EQ] = ACTIONS(9855),
    [anon_sym_LT_LT_EQ] = ACTIONS(9855),
    [anon_sym_CARET_EQ] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9857),
    [anon_sym_AMP_AMP] = ACTIONS(9857),
    [anon_sym_LT_LT] = ACTIONS(9857),
    [anon_sym_GT_GT] = ACTIONS(9857),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9857),
    [anon_sym_PLUS] = ACTIONS(9857),
    [anon_sym_SLASH] = ACTIONS(9857),
    [anon_sym_PERCENT] = ACTIONS(9857),
    [sym_comment] = ACTIONS(87),
  },
  [10139] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(12433),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(12433),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(12433),
    [anon_sym_PERCENT] = ACTIONS(12433),
    [sym_comment] = ACTIONS(87),
  },
  [10140] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(12433),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [10141] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12431),
    [sym__binary_star] = ACTIONS(12433),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(12433),
    [anon_sym_AMP] = ACTIONS(12437),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(12449),
    [anon_sym_GT_GT] = ACTIONS(12449),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(12431),
    [anon_sym_SLASH] = ACTIONS(12433),
    [anon_sym_PERCENT] = ACTIONS(12433),
    [sym_comment] = ACTIONS(87),
  },
  [10142] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12431),
    [sym__binary_star] = ACTIONS(12433),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(12433),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(12449),
    [anon_sym_GT_GT] = ACTIONS(12449),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(12431),
    [anon_sym_SLASH] = ACTIONS(12433),
    [anon_sym_PERCENT] = ACTIONS(12433),
    [sym_comment] = ACTIONS(87),
  },
  [10143] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12431),
    [sym__binary_star] = ACTIONS(12433),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(12435),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(12433),
    [anon_sym_AMP] = ACTIONS(12437),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(12449),
    [anon_sym_GT_GT] = ACTIONS(12449),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(12455),
    [anon_sym_PLUS] = ACTIONS(12431),
    [anon_sym_SLASH] = ACTIONS(12433),
    [anon_sym_PERCENT] = ACTIONS(12433),
    [sym_comment] = ACTIONS(87),
  },
  [10144] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(14639),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [10145] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(12431),
    [sym__binary_star] = ACTIONS(12433),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(12435),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(12433),
    [anon_sym_AMP] = ACTIONS(12437),
    [anon_sym_LT] = ACTIONS(12439),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(12443),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12445),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(12447),
    [anon_sym_AMP_AMP] = ACTIONS(12447),
    [anon_sym_LT_LT] = ACTIONS(12449),
    [anon_sym_GT_GT] = ACTIONS(12449),
    [anon_sym_EQ_EQ] = ACTIONS(12451),
    [anon_sym_BANG_EQ] = ACTIONS(12447),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12447),
    [anon_sym_LT_EQ_GT] = ACTIONS(12447),
    [anon_sym_EQ_TILDE] = ACTIONS(12447),
    [anon_sym_BANG_TILDE] = ACTIONS(12447),
    [anon_sym_LT_EQ] = ACTIONS(12439),
    [anon_sym_GT] = ACTIONS(12439),
    [anon_sym_GT_EQ] = ACTIONS(12453),
    [anon_sym_CARET] = ACTIONS(12455),
    [anon_sym_PLUS] = ACTIONS(12431),
    [anon_sym_SLASH] = ACTIONS(12433),
    [anon_sym_PERCENT] = ACTIONS(12433),
    [sym_comment] = ACTIONS(87),
  },
  [10146] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12431),
    [sym__binary_star] = ACTIONS(12433),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(12435),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(12433),
    [anon_sym_AMP] = ACTIONS(12437),
    [anon_sym_LT] = ACTIONS(12439),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(12441),
    [anon_sym_DOT_DOT] = ACTIONS(12443),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12445),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(12447),
    [anon_sym_AMP_AMP] = ACTIONS(12447),
    [anon_sym_LT_LT] = ACTIONS(12449),
    [anon_sym_GT_GT] = ACTIONS(12449),
    [anon_sym_EQ_EQ] = ACTIONS(12451),
    [anon_sym_BANG_EQ] = ACTIONS(12447),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12447),
    [anon_sym_LT_EQ_GT] = ACTIONS(12447),
    [anon_sym_EQ_TILDE] = ACTIONS(12447),
    [anon_sym_BANG_TILDE] = ACTIONS(12447),
    [anon_sym_LT_EQ] = ACTIONS(12439),
    [anon_sym_GT] = ACTIONS(12439),
    [anon_sym_GT_EQ] = ACTIONS(12453),
    [anon_sym_CARET] = ACTIONS(12455),
    [anon_sym_PLUS] = ACTIONS(12431),
    [anon_sym_SLASH] = ACTIONS(12433),
    [anon_sym_PERCENT] = ACTIONS(12433),
    [sym_comment] = ACTIONS(87),
  },
  [10147] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12431),
    [sym__binary_star] = ACTIONS(12433),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(12435),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(12433),
    [anon_sym_AMP] = ACTIONS(12437),
    [anon_sym_LT] = ACTIONS(12439),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(12449),
    [anon_sym_GT_GT] = ACTIONS(12449),
    [anon_sym_EQ_EQ] = ACTIONS(12451),
    [anon_sym_BANG_EQ] = ACTIONS(12447),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12447),
    [anon_sym_LT_EQ_GT] = ACTIONS(12447),
    [anon_sym_EQ_TILDE] = ACTIONS(12447),
    [anon_sym_BANG_TILDE] = ACTIONS(12447),
    [anon_sym_LT_EQ] = ACTIONS(12439),
    [anon_sym_GT] = ACTIONS(12439),
    [anon_sym_GT_EQ] = ACTIONS(12453),
    [anon_sym_CARET] = ACTIONS(12455),
    [anon_sym_PLUS] = ACTIONS(12431),
    [anon_sym_SLASH] = ACTIONS(12433),
    [anon_sym_PERCENT] = ACTIONS(12433),
    [sym_comment] = ACTIONS(87),
  },
  [10148] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12431),
    [sym__binary_star] = ACTIONS(12433),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(12433),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(12431),
    [anon_sym_SLASH] = ACTIONS(12433),
    [anon_sym_PERCENT] = ACTIONS(12433),
    [sym_comment] = ACTIONS(87),
  },
  [10149] = {
    [aux_sym_exceptions_repeat1] = STATE(10149),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_COMMA] = ACTIONS(14641),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [10150] = {
    [aux_sym_exceptions_repeat1] = STATE(8785),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [10151] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(12431),
    [sym__binary_star] = ACTIONS(12433),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(12435),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(12433),
    [anon_sym_AMP] = ACTIONS(12437),
    [anon_sym_LT] = ACTIONS(12439),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(12441),
    [anon_sym_DOT_DOT] = ACTIONS(12443),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12445),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(12447),
    [anon_sym_AMP_AMP] = ACTIONS(12447),
    [anon_sym_LT_LT] = ACTIONS(12449),
    [anon_sym_GT_GT] = ACTIONS(12449),
    [anon_sym_EQ_EQ] = ACTIONS(12451),
    [anon_sym_BANG_EQ] = ACTIONS(12447),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12447),
    [anon_sym_LT_EQ_GT] = ACTIONS(12447),
    [anon_sym_EQ_TILDE] = ACTIONS(12447),
    [anon_sym_BANG_TILDE] = ACTIONS(12447),
    [anon_sym_LT_EQ] = ACTIONS(12439),
    [anon_sym_GT] = ACTIONS(12439),
    [anon_sym_GT_EQ] = ACTIONS(12453),
    [anon_sym_CARET] = ACTIONS(12455),
    [anon_sym_PLUS] = ACTIONS(12431),
    [anon_sym_SLASH] = ACTIONS(12433),
    [anon_sym_PERCENT] = ACTIONS(12433),
    [sym_comment] = ACTIONS(87),
  },
  [10152] = {
    [sym_heredoc_body] = STATE(10152),
    [aux_sym_call_repeat1] = STATE(10152),
    [sym__heredoc_body_start] = ACTIONS(10455),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_RBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [10153] = {
    [sym_heredoc_body] = STATE(10152),
    [aux_sym_call_repeat1] = STATE(10152),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_RBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [10154] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(10844),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(3837),
    [sym_scope_resolution] = STATE(3835),
    [sym_call] = STATE(3835),
    [sym_method_call] = STATE(3837),
    [sym_assignment] = STATE(10844),
    [sym_operator_assignment] = STATE(10844),
    [sym_conditional] = STATE(10844),
    [sym_range] = STATE(10844),
    [sym_binary] = STATE(10844),
    [sym_unary] = STATE(10844),
    [sym_left_assignment_list] = STATE(3836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3837),
    [sym__variable] = STATE(3835),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(3837),
    [sym_false] = STATE(3837),
    [sym_nil] = STATE(3837),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(3838),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6351),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6353),
    [anon_sym_yield] = ACTIONS(6355),
    [anon_sym_break] = ACTIONS(6357),
    [anon_sym_next] = ACTIONS(6359),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6361),
    [anon_sym_defined_QMARK] = ACTIONS(6363),
    [anon_sym_not] = ACTIONS(6365),
    [anon_sym_BANG] = ACTIONS(6367),
    [anon_sym_TILDE] = ACTIONS(6367),
    [sym_constant] = ACTIONS(6369),
    [sym_identifier] = ACTIONS(6369),
    [sym_instance_variable] = ACTIONS(6371),
    [sym_class_variable] = ACTIONS(6371),
    [sym_global_variable] = ACTIONS(6371),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6369),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6369),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10155] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(8800),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(3837),
    [sym_scope_resolution] = STATE(3835),
    [sym_call] = STATE(3835),
    [sym_method_call] = STATE(3837),
    [sym_splat_argument] = STATE(9013),
    [sym_assignment] = STATE(8800),
    [sym_operator_assignment] = STATE(8800),
    [sym_conditional] = STATE(8800),
    [sym_range] = STATE(8800),
    [sym_binary] = STATE(8800),
    [sym_unary] = STATE(8800),
    [sym__arg_or_splat_arg] = STATE(9013),
    [sym_left_assignment_list] = STATE(3836),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3837),
    [sym__variable] = STATE(3835),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(3837),
    [sym_false] = STATE(3837),
    [sym_nil] = STATE(3837),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(3838),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(2902),
    [sym__unary_minus] = ACTIONS(6351),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6353),
    [anon_sym_yield] = ACTIONS(6355),
    [anon_sym_break] = ACTIONS(6357),
    [anon_sym_next] = ACTIONS(6359),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6361),
    [anon_sym_defined_QMARK] = ACTIONS(6363),
    [anon_sym_not] = ACTIONS(6365),
    [anon_sym_BANG] = ACTIONS(6367),
    [anon_sym_TILDE] = ACTIONS(6367),
    [sym_constant] = ACTIONS(6369),
    [sym_identifier] = ACTIONS(6369),
    [sym_instance_variable] = ACTIONS(6371),
    [sym_class_variable] = ACTIONS(6371),
    [sym_global_variable] = ACTIONS(6371),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6369),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6369),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10156] = {
    [aux_sym_exceptions_repeat1] = STATE(10845),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_RBRACE] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(14644),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [10157] = {
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(6387),
    [sym__binary_star] = ACTIONS(6389),
    [anon_sym_RBRACE] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(6391),
    [anon_sym_STAR_STAR] = ACTIONS(6389),
    [anon_sym_AMP] = ACTIONS(6393),
    [anon_sym_LT] = ACTIONS(6395),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_EQ_GT] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(6397),
    [anon_sym_DOT_DOT] = ACTIONS(6399),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6401),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(6403),
    [anon_sym_AMP_AMP] = ACTIONS(6403),
    [anon_sym_LT_LT] = ACTIONS(6405),
    [anon_sym_GT_GT] = ACTIONS(6405),
    [anon_sym_EQ_EQ] = ACTIONS(6407),
    [anon_sym_BANG_EQ] = ACTIONS(6403),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6403),
    [anon_sym_LT_EQ_GT] = ACTIONS(6403),
    [anon_sym_EQ_TILDE] = ACTIONS(6403),
    [anon_sym_BANG_TILDE] = ACTIONS(6403),
    [anon_sym_LT_EQ] = ACTIONS(6395),
    [anon_sym_GT] = ACTIONS(6395),
    [anon_sym_GT_EQ] = ACTIONS(6409),
    [anon_sym_CARET] = ACTIONS(6411),
    [anon_sym_PLUS] = ACTIONS(6387),
    [anon_sym_SLASH] = ACTIONS(6389),
    [anon_sym_PERCENT] = ACTIONS(6389),
    [sym_comment] = ACTIONS(87),
  },
  [10158] = {
    [aux_sym_exceptions_repeat1] = STATE(10158),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_RBRACE] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(14646),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [10159] = {
    [sym__heredoc_body_start] = ACTIONS(6601),
    [sym__binary_minus] = ACTIONS(6601),
    [sym__binary_star] = ACTIONS(6601),
    [anon_sym_LBRACE] = ACTIONS(6601),
    [anon_sym_RBRACE] = ACTIONS(6601),
    [anon_sym_RPAREN] = ACTIONS(6601),
    [anon_sym_DOT] = ACTIONS(6603),
    [anon_sym_COMMA] = ACTIONS(6601),
    [anon_sym_PIPE] = ACTIONS(6603),
    [anon_sym_SEMI] = ACTIONS(6601),
    [anon_sym_STAR_STAR] = ACTIONS(6603),
    [anon_sym_AMP] = ACTIONS(6603),
    [anon_sym_EQ] = ACTIONS(6603),
    [anon_sym_LT] = ACTIONS(6603),
    [anon_sym_if] = ACTIONS(6601),
    [anon_sym_unless] = ACTIONS(6601),
    [anon_sym_while] = ACTIONS(6601),
    [anon_sym_until] = ACTIONS(6601),
    [anon_sym_rescue] = ACTIONS(6601),
    [anon_sym_in] = ACTIONS(6601),
    [anon_sym_do] = ACTIONS(6601),
    [anon_sym_LBRACK] = ACTIONS(6601),
    [anon_sym_RBRACK] = ACTIONS(6601),
    [anon_sym_COLON_COLON2] = ACTIONS(6601),
    [anon_sym_AMP_DOT] = ACTIONS(6601),
    [anon_sym_PLUS_EQ] = ACTIONS(6601),
    [anon_sym_DASH_EQ] = ACTIONS(6601),
    [anon_sym_STAR_EQ] = ACTIONS(6601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6601),
    [anon_sym_SLASH_EQ] = ACTIONS(6601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6601),
    [anon_sym_PIPE_EQ] = ACTIONS(6601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6601),
    [anon_sym_AMP_EQ] = ACTIONS(6601),
    [anon_sym_PERCENT_EQ] = ACTIONS(6601),
    [anon_sym_GT_GT_EQ] = ACTIONS(6601),
    [anon_sym_LT_LT_EQ] = ACTIONS(6601),
    [anon_sym_CARET_EQ] = ACTIONS(6601),
    [anon_sym_QMARK] = ACTIONS(6601),
    [anon_sym_COLON2] = ACTIONS(6603),
    [anon_sym_DOT_DOT] = ACTIONS(6603),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6601),
    [anon_sym_and] = ACTIONS(6601),
    [anon_sym_or] = ACTIONS(6601),
    [anon_sym_PIPE_PIPE] = ACTIONS(6603),
    [anon_sym_AMP_AMP] = ACTIONS(6603),
    [anon_sym_LT_LT] = ACTIONS(6603),
    [anon_sym_GT_GT] = ACTIONS(6603),
    [anon_sym_EQ_EQ] = ACTIONS(6603),
    [anon_sym_BANG_EQ] = ACTIONS(6601),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6601),
    [anon_sym_LT_EQ_GT] = ACTIONS(6601),
    [anon_sym_EQ_TILDE] = ACTIONS(6601),
    [anon_sym_BANG_TILDE] = ACTIONS(6601),
    [anon_sym_LT_EQ] = ACTIONS(6603),
    [anon_sym_GT] = ACTIONS(6603),
    [anon_sym_GT_EQ] = ACTIONS(6601),
    [anon_sym_CARET] = ACTIONS(6603),
    [anon_sym_PLUS] = ACTIONS(6603),
    [anon_sym_SLASH] = ACTIONS(6603),
    [anon_sym_PERCENT] = ACTIONS(6603),
    [sym_comment] = ACTIONS(87),
  },
  [10160] = {
    [sym__heredoc_body_start] = ACTIONS(6605),
    [sym__binary_minus] = ACTIONS(6605),
    [sym__binary_star] = ACTIONS(6605),
    [anon_sym_LBRACE] = ACTIONS(6605),
    [anon_sym_RBRACE] = ACTIONS(6605),
    [anon_sym_RPAREN] = ACTIONS(6605),
    [anon_sym_DOT] = ACTIONS(6607),
    [anon_sym_COMMA] = ACTIONS(6605),
    [anon_sym_PIPE] = ACTIONS(6607),
    [anon_sym_SEMI] = ACTIONS(6605),
    [anon_sym_STAR_STAR] = ACTIONS(6607),
    [anon_sym_AMP] = ACTIONS(6607),
    [anon_sym_EQ] = ACTIONS(6607),
    [anon_sym_LT] = ACTIONS(6607),
    [anon_sym_if] = ACTIONS(6605),
    [anon_sym_unless] = ACTIONS(6605),
    [anon_sym_while] = ACTIONS(6605),
    [anon_sym_until] = ACTIONS(6605),
    [anon_sym_rescue] = ACTIONS(6605),
    [anon_sym_in] = ACTIONS(6605),
    [anon_sym_do] = ACTIONS(6605),
    [anon_sym_LBRACK] = ACTIONS(6605),
    [anon_sym_RBRACK] = ACTIONS(6605),
    [anon_sym_COLON_COLON2] = ACTIONS(6605),
    [anon_sym_AMP_DOT] = ACTIONS(6605),
    [anon_sym_PLUS_EQ] = ACTIONS(6605),
    [anon_sym_DASH_EQ] = ACTIONS(6605),
    [anon_sym_STAR_EQ] = ACTIONS(6605),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6605),
    [anon_sym_SLASH_EQ] = ACTIONS(6605),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6605),
    [anon_sym_PIPE_EQ] = ACTIONS(6605),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6605),
    [anon_sym_AMP_EQ] = ACTIONS(6605),
    [anon_sym_PERCENT_EQ] = ACTIONS(6605),
    [anon_sym_GT_GT_EQ] = ACTIONS(6605),
    [anon_sym_LT_LT_EQ] = ACTIONS(6605),
    [anon_sym_CARET_EQ] = ACTIONS(6605),
    [anon_sym_QMARK] = ACTIONS(6605),
    [anon_sym_COLON2] = ACTIONS(6607),
    [anon_sym_DOT_DOT] = ACTIONS(6607),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6605),
    [anon_sym_and] = ACTIONS(6605),
    [anon_sym_or] = ACTIONS(6605),
    [anon_sym_PIPE_PIPE] = ACTIONS(6607),
    [anon_sym_AMP_AMP] = ACTIONS(6607),
    [anon_sym_LT_LT] = ACTIONS(6607),
    [anon_sym_GT_GT] = ACTIONS(6607),
    [anon_sym_EQ_EQ] = ACTIONS(6607),
    [anon_sym_BANG_EQ] = ACTIONS(6605),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6605),
    [anon_sym_LT_EQ_GT] = ACTIONS(6605),
    [anon_sym_EQ_TILDE] = ACTIONS(6605),
    [anon_sym_BANG_TILDE] = ACTIONS(6605),
    [anon_sym_LT_EQ] = ACTIONS(6607),
    [anon_sym_GT] = ACTIONS(6607),
    [anon_sym_GT_EQ] = ACTIONS(6605),
    [anon_sym_CARET] = ACTIONS(6607),
    [anon_sym_PLUS] = ACTIONS(6607),
    [anon_sym_SLASH] = ACTIONS(6607),
    [anon_sym_PERCENT] = ACTIONS(6607),
    [sym_comment] = ACTIONS(87),
  },
  [10161] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1697),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(14649),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [10162] = {
    [aux_sym_string_array_repeat1] = STATE(1699),
    [sym__string_end] = ACTIONS(14649),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(14651),
  },
  [10163] = {
    [sym__heredoc_body_start] = ACTIONS(6613),
    [sym__binary_minus] = ACTIONS(6613),
    [sym__binary_star] = ACTIONS(6613),
    [anon_sym_LBRACE] = ACTIONS(6613),
    [anon_sym_RBRACE] = ACTIONS(6613),
    [anon_sym_RPAREN] = ACTIONS(6613),
    [anon_sym_DOT] = ACTIONS(6615),
    [anon_sym_COMMA] = ACTIONS(6613),
    [anon_sym_PIPE] = ACTIONS(6615),
    [anon_sym_SEMI] = ACTIONS(6613),
    [anon_sym_STAR_STAR] = ACTIONS(6615),
    [anon_sym_AMP] = ACTIONS(6615),
    [anon_sym_EQ] = ACTIONS(6615),
    [anon_sym_LT] = ACTIONS(6615),
    [anon_sym_if] = ACTIONS(6613),
    [anon_sym_unless] = ACTIONS(6613),
    [anon_sym_while] = ACTIONS(6613),
    [anon_sym_until] = ACTIONS(6613),
    [anon_sym_rescue] = ACTIONS(6613),
    [anon_sym_in] = ACTIONS(6613),
    [anon_sym_do] = ACTIONS(6613),
    [anon_sym_LBRACK] = ACTIONS(6613),
    [anon_sym_RBRACK] = ACTIONS(6613),
    [anon_sym_COLON_COLON2] = ACTIONS(6613),
    [anon_sym_AMP_DOT] = ACTIONS(6613),
    [anon_sym_PLUS_EQ] = ACTIONS(6613),
    [anon_sym_DASH_EQ] = ACTIONS(6613),
    [anon_sym_STAR_EQ] = ACTIONS(6613),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6613),
    [anon_sym_SLASH_EQ] = ACTIONS(6613),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6613),
    [anon_sym_PIPE_EQ] = ACTIONS(6613),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6613),
    [anon_sym_AMP_EQ] = ACTIONS(6613),
    [anon_sym_PERCENT_EQ] = ACTIONS(6613),
    [anon_sym_GT_GT_EQ] = ACTIONS(6613),
    [anon_sym_LT_LT_EQ] = ACTIONS(6613),
    [anon_sym_CARET_EQ] = ACTIONS(6613),
    [anon_sym_QMARK] = ACTIONS(6613),
    [anon_sym_COLON2] = ACTIONS(6615),
    [anon_sym_DOT_DOT] = ACTIONS(6615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6613),
    [anon_sym_and] = ACTIONS(6613),
    [anon_sym_or] = ACTIONS(6613),
    [anon_sym_PIPE_PIPE] = ACTIONS(6615),
    [anon_sym_AMP_AMP] = ACTIONS(6615),
    [anon_sym_LT_LT] = ACTIONS(6615),
    [anon_sym_GT_GT] = ACTIONS(6615),
    [anon_sym_EQ_EQ] = ACTIONS(6615),
    [anon_sym_BANG_EQ] = ACTIONS(6613),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6613),
    [anon_sym_LT_EQ_GT] = ACTIONS(6613),
    [anon_sym_EQ_TILDE] = ACTIONS(6613),
    [anon_sym_BANG_TILDE] = ACTIONS(6613),
    [anon_sym_LT_EQ] = ACTIONS(6615),
    [anon_sym_GT] = ACTIONS(6615),
    [anon_sym_GT_EQ] = ACTIONS(6613),
    [anon_sym_CARET] = ACTIONS(6615),
    [anon_sym_PLUS] = ACTIONS(6615),
    [anon_sym_SLASH] = ACTIONS(6615),
    [anon_sym_PERCENT] = ACTIONS(6615),
    [sym_comment] = ACTIONS(87),
  },
  [10164] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1697),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(14653),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [10165] = {
    [sym__heredoc_body_start] = ACTIONS(6626),
    [sym__binary_minus] = ACTIONS(6626),
    [sym__binary_star] = ACTIONS(6626),
    [anon_sym_LBRACE] = ACTIONS(6626),
    [anon_sym_RBRACE] = ACTIONS(6626),
    [anon_sym_RPAREN] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(6628),
    [anon_sym_COMMA] = ACTIONS(6626),
    [anon_sym_PIPE] = ACTIONS(6628),
    [anon_sym_SEMI] = ACTIONS(6626),
    [anon_sym_STAR_STAR] = ACTIONS(6628),
    [anon_sym_AMP] = ACTIONS(6628),
    [anon_sym_EQ] = ACTIONS(6628),
    [anon_sym_LT] = ACTIONS(6628),
    [anon_sym_if] = ACTIONS(6626),
    [anon_sym_unless] = ACTIONS(6626),
    [anon_sym_while] = ACTIONS(6626),
    [anon_sym_until] = ACTIONS(6626),
    [anon_sym_rescue] = ACTIONS(6626),
    [anon_sym_in] = ACTIONS(6626),
    [anon_sym_do] = ACTIONS(6626),
    [anon_sym_LBRACK] = ACTIONS(6626),
    [anon_sym_RBRACK] = ACTIONS(6626),
    [anon_sym_COLON_COLON2] = ACTIONS(6626),
    [anon_sym_AMP_DOT] = ACTIONS(6626),
    [anon_sym_PLUS_EQ] = ACTIONS(6626),
    [anon_sym_DASH_EQ] = ACTIONS(6626),
    [anon_sym_STAR_EQ] = ACTIONS(6626),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6626),
    [anon_sym_SLASH_EQ] = ACTIONS(6626),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6626),
    [anon_sym_PIPE_EQ] = ACTIONS(6626),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6626),
    [anon_sym_AMP_EQ] = ACTIONS(6626),
    [anon_sym_PERCENT_EQ] = ACTIONS(6626),
    [anon_sym_GT_GT_EQ] = ACTIONS(6626),
    [anon_sym_LT_LT_EQ] = ACTIONS(6626),
    [anon_sym_CARET_EQ] = ACTIONS(6626),
    [anon_sym_QMARK] = ACTIONS(6626),
    [anon_sym_COLON2] = ACTIONS(6628),
    [anon_sym_DOT_DOT] = ACTIONS(6628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6626),
    [anon_sym_and] = ACTIONS(6626),
    [anon_sym_or] = ACTIONS(6626),
    [anon_sym_PIPE_PIPE] = ACTIONS(6628),
    [anon_sym_AMP_AMP] = ACTIONS(6628),
    [anon_sym_LT_LT] = ACTIONS(6628),
    [anon_sym_GT_GT] = ACTIONS(6628),
    [anon_sym_EQ_EQ] = ACTIONS(6628),
    [anon_sym_BANG_EQ] = ACTIONS(6626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6626),
    [anon_sym_LT_EQ_GT] = ACTIONS(6626),
    [anon_sym_EQ_TILDE] = ACTIONS(6626),
    [anon_sym_BANG_TILDE] = ACTIONS(6626),
    [anon_sym_LT_EQ] = ACTIONS(6628),
    [anon_sym_GT] = ACTIONS(6628),
    [anon_sym_GT_EQ] = ACTIONS(6626),
    [anon_sym_CARET] = ACTIONS(6628),
    [anon_sym_PLUS] = ACTIONS(6628),
    [anon_sym_SLASH] = ACTIONS(6628),
    [anon_sym_PERCENT] = ACTIONS(6628),
    [sym_comment] = ACTIONS(87),
  },
  [10166] = {
    [sym__heredoc_body_start] = ACTIONS(6630),
    [sym__binary_minus] = ACTIONS(6630),
    [sym__binary_star] = ACTIONS(6630),
    [anon_sym_LBRACE] = ACTIONS(6630),
    [anon_sym_RBRACE] = ACTIONS(6630),
    [anon_sym_RPAREN] = ACTIONS(6630),
    [anon_sym_DOT] = ACTIONS(6632),
    [anon_sym_COMMA] = ACTIONS(6630),
    [anon_sym_PIPE] = ACTIONS(6632),
    [anon_sym_SEMI] = ACTIONS(6630),
    [anon_sym_STAR_STAR] = ACTIONS(6632),
    [anon_sym_AMP] = ACTIONS(6632),
    [anon_sym_EQ] = ACTIONS(6632),
    [anon_sym_LT] = ACTIONS(6632),
    [anon_sym_if] = ACTIONS(6630),
    [anon_sym_unless] = ACTIONS(6630),
    [anon_sym_while] = ACTIONS(6630),
    [anon_sym_until] = ACTIONS(6630),
    [anon_sym_rescue] = ACTIONS(6630),
    [anon_sym_in] = ACTIONS(6630),
    [anon_sym_do] = ACTIONS(6630),
    [anon_sym_LBRACK] = ACTIONS(6630),
    [anon_sym_RBRACK] = ACTIONS(6630),
    [anon_sym_COLON_COLON2] = ACTIONS(6630),
    [anon_sym_AMP_DOT] = ACTIONS(6630),
    [anon_sym_PLUS_EQ] = ACTIONS(6630),
    [anon_sym_DASH_EQ] = ACTIONS(6630),
    [anon_sym_STAR_EQ] = ACTIONS(6630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6630),
    [anon_sym_SLASH_EQ] = ACTIONS(6630),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6630),
    [anon_sym_PIPE_EQ] = ACTIONS(6630),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6630),
    [anon_sym_AMP_EQ] = ACTIONS(6630),
    [anon_sym_PERCENT_EQ] = ACTIONS(6630),
    [anon_sym_GT_GT_EQ] = ACTIONS(6630),
    [anon_sym_LT_LT_EQ] = ACTIONS(6630),
    [anon_sym_CARET_EQ] = ACTIONS(6630),
    [anon_sym_QMARK] = ACTIONS(6630),
    [anon_sym_COLON2] = ACTIONS(6632),
    [anon_sym_DOT_DOT] = ACTIONS(6632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6630),
    [anon_sym_and] = ACTIONS(6630),
    [anon_sym_or] = ACTIONS(6630),
    [anon_sym_PIPE_PIPE] = ACTIONS(6632),
    [anon_sym_AMP_AMP] = ACTIONS(6632),
    [anon_sym_LT_LT] = ACTIONS(6632),
    [anon_sym_GT_GT] = ACTIONS(6632),
    [anon_sym_EQ_EQ] = ACTIONS(6632),
    [anon_sym_BANG_EQ] = ACTIONS(6630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6630),
    [anon_sym_LT_EQ_GT] = ACTIONS(6630),
    [anon_sym_EQ_TILDE] = ACTIONS(6630),
    [anon_sym_BANG_TILDE] = ACTIONS(6630),
    [anon_sym_LT_EQ] = ACTIONS(6632),
    [anon_sym_GT] = ACTIONS(6632),
    [anon_sym_GT_EQ] = ACTIONS(6630),
    [anon_sym_CARET] = ACTIONS(6632),
    [anon_sym_PLUS] = ACTIONS(6632),
    [anon_sym_SLASH] = ACTIONS(6632),
    [anon_sym_PERCENT] = ACTIONS(6632),
    [sym_comment] = ACTIONS(87),
  },
  [10167] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1705),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(14655),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [10168] = {
    [aux_sym_symbol_array_repeat1] = STATE(1707),
    [sym__string_end] = ACTIONS(14655),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(14657),
  },
  [10169] = {
    [sym__heredoc_body_start] = ACTIONS(6638),
    [sym__binary_minus] = ACTIONS(6638),
    [sym__binary_star] = ACTIONS(6638),
    [anon_sym_LBRACE] = ACTIONS(6638),
    [anon_sym_RBRACE] = ACTIONS(6638),
    [anon_sym_RPAREN] = ACTIONS(6638),
    [anon_sym_DOT] = ACTIONS(6640),
    [anon_sym_COMMA] = ACTIONS(6638),
    [anon_sym_PIPE] = ACTIONS(6640),
    [anon_sym_SEMI] = ACTIONS(6638),
    [anon_sym_STAR_STAR] = ACTIONS(6640),
    [anon_sym_AMP] = ACTIONS(6640),
    [anon_sym_EQ] = ACTIONS(6640),
    [anon_sym_LT] = ACTIONS(6640),
    [anon_sym_if] = ACTIONS(6638),
    [anon_sym_unless] = ACTIONS(6638),
    [anon_sym_while] = ACTIONS(6638),
    [anon_sym_until] = ACTIONS(6638),
    [anon_sym_rescue] = ACTIONS(6638),
    [anon_sym_in] = ACTIONS(6638),
    [anon_sym_do] = ACTIONS(6638),
    [anon_sym_LBRACK] = ACTIONS(6638),
    [anon_sym_RBRACK] = ACTIONS(6638),
    [anon_sym_COLON_COLON2] = ACTIONS(6638),
    [anon_sym_AMP_DOT] = ACTIONS(6638),
    [anon_sym_PLUS_EQ] = ACTIONS(6638),
    [anon_sym_DASH_EQ] = ACTIONS(6638),
    [anon_sym_STAR_EQ] = ACTIONS(6638),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6638),
    [anon_sym_SLASH_EQ] = ACTIONS(6638),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6638),
    [anon_sym_PIPE_EQ] = ACTIONS(6638),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6638),
    [anon_sym_AMP_EQ] = ACTIONS(6638),
    [anon_sym_PERCENT_EQ] = ACTIONS(6638),
    [anon_sym_GT_GT_EQ] = ACTIONS(6638),
    [anon_sym_LT_LT_EQ] = ACTIONS(6638),
    [anon_sym_CARET_EQ] = ACTIONS(6638),
    [anon_sym_QMARK] = ACTIONS(6638),
    [anon_sym_COLON2] = ACTIONS(6640),
    [anon_sym_DOT_DOT] = ACTIONS(6640),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6638),
    [anon_sym_and] = ACTIONS(6638),
    [anon_sym_or] = ACTIONS(6638),
    [anon_sym_PIPE_PIPE] = ACTIONS(6640),
    [anon_sym_AMP_AMP] = ACTIONS(6640),
    [anon_sym_LT_LT] = ACTIONS(6640),
    [anon_sym_GT_GT] = ACTIONS(6640),
    [anon_sym_EQ_EQ] = ACTIONS(6640),
    [anon_sym_BANG_EQ] = ACTIONS(6638),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6638),
    [anon_sym_LT_EQ_GT] = ACTIONS(6638),
    [anon_sym_EQ_TILDE] = ACTIONS(6638),
    [anon_sym_BANG_TILDE] = ACTIONS(6638),
    [anon_sym_LT_EQ] = ACTIONS(6640),
    [anon_sym_GT] = ACTIONS(6640),
    [anon_sym_GT_EQ] = ACTIONS(6638),
    [anon_sym_CARET] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(6640),
    [anon_sym_SLASH] = ACTIONS(6640),
    [anon_sym_PERCENT] = ACTIONS(6640),
    [sym_comment] = ACTIONS(87),
  },
  [10170] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1705),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(14659),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [10171] = {
    [sym__heredoc_body_start] = ACTIONS(7162),
    [sym__binary_minus] = ACTIONS(7162),
    [sym__binary_star] = ACTIONS(7162),
    [anon_sym_LBRACE] = ACTIONS(7162),
    [anon_sym_RBRACE] = ACTIONS(7162),
    [anon_sym_RPAREN] = ACTIONS(7162),
    [anon_sym_DOT] = ACTIONS(7164),
    [anon_sym_COMMA] = ACTIONS(7162),
    [anon_sym_PIPE] = ACTIONS(7164),
    [anon_sym_SEMI] = ACTIONS(7162),
    [anon_sym_STAR_STAR] = ACTIONS(7164),
    [anon_sym_AMP] = ACTIONS(7164),
    [anon_sym_EQ] = ACTIONS(7164),
    [anon_sym_LT] = ACTIONS(7164),
    [anon_sym_if] = ACTIONS(7162),
    [anon_sym_unless] = ACTIONS(7162),
    [anon_sym_while] = ACTIONS(7162),
    [anon_sym_until] = ACTIONS(7162),
    [anon_sym_rescue] = ACTIONS(7162),
    [anon_sym_in] = ACTIONS(7162),
    [anon_sym_do] = ACTIONS(7162),
    [anon_sym_LBRACK] = ACTIONS(7162),
    [anon_sym_RBRACK] = ACTIONS(7162),
    [anon_sym_COLON_COLON2] = ACTIONS(7162),
    [anon_sym_AMP_DOT] = ACTIONS(7162),
    [anon_sym_PLUS_EQ] = ACTIONS(7162),
    [anon_sym_DASH_EQ] = ACTIONS(7162),
    [anon_sym_STAR_EQ] = ACTIONS(7162),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7162),
    [anon_sym_SLASH_EQ] = ACTIONS(7162),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7162),
    [anon_sym_PIPE_EQ] = ACTIONS(7162),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7162),
    [anon_sym_AMP_EQ] = ACTIONS(7162),
    [anon_sym_PERCENT_EQ] = ACTIONS(7162),
    [anon_sym_GT_GT_EQ] = ACTIONS(7162),
    [anon_sym_LT_LT_EQ] = ACTIONS(7162),
    [anon_sym_CARET_EQ] = ACTIONS(7162),
    [anon_sym_QMARK] = ACTIONS(7162),
    [anon_sym_COLON2] = ACTIONS(7164),
    [anon_sym_DOT_DOT] = ACTIONS(7164),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7162),
    [anon_sym_and] = ACTIONS(7162),
    [anon_sym_or] = ACTIONS(7162),
    [anon_sym_PIPE_PIPE] = ACTIONS(7164),
    [anon_sym_AMP_AMP] = ACTIONS(7164),
    [anon_sym_LT_LT] = ACTIONS(7164),
    [anon_sym_GT_GT] = ACTIONS(7164),
    [anon_sym_EQ_EQ] = ACTIONS(7164),
    [anon_sym_BANG_EQ] = ACTIONS(7162),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7162),
    [anon_sym_LT_EQ_GT] = ACTIONS(7162),
    [anon_sym_EQ_TILDE] = ACTIONS(7162),
    [anon_sym_BANG_TILDE] = ACTIONS(7162),
    [anon_sym_LT_EQ] = ACTIONS(7164),
    [anon_sym_GT] = ACTIONS(7164),
    [anon_sym_GT_EQ] = ACTIONS(7162),
    [anon_sym_CARET] = ACTIONS(7164),
    [anon_sym_PLUS] = ACTIONS(7164),
    [anon_sym_SLASH] = ACTIONS(7164),
    [anon_sym_PERCENT] = ACTIONS(7164),
    [sym_comment] = ACTIONS(87),
  },
  [10172] = {
    [anon_sym_DOT] = ACTIONS(14661),
    [anon_sym_COLON_COLON] = ACTIONS(14661),
    [sym_comment] = ACTIONS(87),
  },
  [10173] = {
    [sym__heredoc_body_start] = ACTIONS(7314),
    [sym__binary_minus] = ACTIONS(7314),
    [sym__binary_star] = ACTIONS(7314),
    [anon_sym_LBRACE] = ACTIONS(7314),
    [anon_sym_RBRACE] = ACTIONS(7314),
    [anon_sym_RPAREN] = ACTIONS(7314),
    [anon_sym_DOT] = ACTIONS(7316),
    [anon_sym_COMMA] = ACTIONS(7314),
    [anon_sym_PIPE] = ACTIONS(7316),
    [anon_sym_SEMI] = ACTIONS(7314),
    [anon_sym_STAR_STAR] = ACTIONS(7316),
    [anon_sym_AMP] = ACTIONS(7316),
    [anon_sym_EQ] = ACTIONS(7316),
    [anon_sym_LT] = ACTIONS(7316),
    [anon_sym_if] = ACTIONS(7314),
    [anon_sym_unless] = ACTIONS(7314),
    [anon_sym_while] = ACTIONS(7314),
    [anon_sym_until] = ACTIONS(7314),
    [anon_sym_rescue] = ACTIONS(7314),
    [anon_sym_in] = ACTIONS(7314),
    [anon_sym_do] = ACTIONS(7314),
    [anon_sym_LBRACK] = ACTIONS(7314),
    [anon_sym_RBRACK] = ACTIONS(7314),
    [anon_sym_COLON_COLON2] = ACTIONS(7314),
    [anon_sym_AMP_DOT] = ACTIONS(7314),
    [anon_sym_PLUS_EQ] = ACTIONS(7314),
    [anon_sym_DASH_EQ] = ACTIONS(7314),
    [anon_sym_STAR_EQ] = ACTIONS(7314),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7314),
    [anon_sym_SLASH_EQ] = ACTIONS(7314),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7314),
    [anon_sym_PIPE_EQ] = ACTIONS(7314),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7314),
    [anon_sym_AMP_EQ] = ACTIONS(7314),
    [anon_sym_PERCENT_EQ] = ACTIONS(7314),
    [anon_sym_GT_GT_EQ] = ACTIONS(7314),
    [anon_sym_LT_LT_EQ] = ACTIONS(7314),
    [anon_sym_CARET_EQ] = ACTIONS(7314),
    [anon_sym_QMARK] = ACTIONS(7314),
    [anon_sym_COLON2] = ACTIONS(7316),
    [anon_sym_DOT_DOT] = ACTIONS(7316),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7314),
    [anon_sym_and] = ACTIONS(7314),
    [anon_sym_or] = ACTIONS(7314),
    [anon_sym_PIPE_PIPE] = ACTIONS(7316),
    [anon_sym_AMP_AMP] = ACTIONS(7316),
    [anon_sym_LT_LT] = ACTIONS(7316),
    [anon_sym_GT_GT] = ACTIONS(7316),
    [anon_sym_EQ_EQ] = ACTIONS(7316),
    [anon_sym_BANG_EQ] = ACTIONS(7314),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7314),
    [anon_sym_LT_EQ_GT] = ACTIONS(7314),
    [anon_sym_EQ_TILDE] = ACTIONS(7314),
    [anon_sym_BANG_TILDE] = ACTIONS(7314),
    [anon_sym_LT_EQ] = ACTIONS(7316),
    [anon_sym_GT] = ACTIONS(7316),
    [anon_sym_GT_EQ] = ACTIONS(7314),
    [anon_sym_CARET] = ACTIONS(7316),
    [anon_sym_PLUS] = ACTIONS(7316),
    [anon_sym_SLASH] = ACTIONS(7316),
    [anon_sym_PERCENT] = ACTIONS(7316),
    [sym_comment] = ACTIONS(87),
  },
  [10174] = {
    [sym__heredoc_body_start] = ACTIONS(7330),
    [sym__binary_minus] = ACTIONS(7330),
    [sym__binary_star] = ACTIONS(7330),
    [anon_sym_LBRACE] = ACTIONS(7330),
    [anon_sym_RBRACE] = ACTIONS(7330),
    [anon_sym_RPAREN] = ACTIONS(7330),
    [anon_sym_DOT] = ACTIONS(7332),
    [anon_sym_COMMA] = ACTIONS(7330),
    [anon_sym_PIPE] = ACTIONS(7332),
    [anon_sym_SEMI] = ACTIONS(7330),
    [anon_sym_STAR_STAR] = ACTIONS(7332),
    [anon_sym_AMP] = ACTIONS(7332),
    [anon_sym_EQ] = ACTIONS(7332),
    [anon_sym_LT] = ACTIONS(7332),
    [anon_sym_if] = ACTIONS(7330),
    [anon_sym_unless] = ACTIONS(7330),
    [anon_sym_while] = ACTIONS(7330),
    [anon_sym_until] = ACTIONS(7330),
    [anon_sym_rescue] = ACTIONS(7330),
    [anon_sym_in] = ACTIONS(7330),
    [anon_sym_do] = ACTIONS(7330),
    [anon_sym_LBRACK] = ACTIONS(7330),
    [anon_sym_RBRACK] = ACTIONS(7330),
    [anon_sym_COLON_COLON2] = ACTIONS(7330),
    [anon_sym_AMP_DOT] = ACTIONS(7330),
    [anon_sym_PLUS_EQ] = ACTIONS(7330),
    [anon_sym_DASH_EQ] = ACTIONS(7330),
    [anon_sym_STAR_EQ] = ACTIONS(7330),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7330),
    [anon_sym_SLASH_EQ] = ACTIONS(7330),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7330),
    [anon_sym_PIPE_EQ] = ACTIONS(7330),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7330),
    [anon_sym_AMP_EQ] = ACTIONS(7330),
    [anon_sym_PERCENT_EQ] = ACTIONS(7330),
    [anon_sym_GT_GT_EQ] = ACTIONS(7330),
    [anon_sym_LT_LT_EQ] = ACTIONS(7330),
    [anon_sym_CARET_EQ] = ACTIONS(7330),
    [anon_sym_QMARK] = ACTIONS(7330),
    [anon_sym_COLON2] = ACTIONS(7332),
    [anon_sym_DOT_DOT] = ACTIONS(7332),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7330),
    [anon_sym_and] = ACTIONS(7330),
    [anon_sym_or] = ACTIONS(7330),
    [anon_sym_PIPE_PIPE] = ACTIONS(7332),
    [anon_sym_AMP_AMP] = ACTIONS(7332),
    [anon_sym_LT_LT] = ACTIONS(7332),
    [anon_sym_GT_GT] = ACTIONS(7332),
    [anon_sym_EQ_EQ] = ACTIONS(7332),
    [anon_sym_BANG_EQ] = ACTIONS(7330),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7330),
    [anon_sym_LT_EQ_GT] = ACTIONS(7330),
    [anon_sym_EQ_TILDE] = ACTIONS(7330),
    [anon_sym_BANG_TILDE] = ACTIONS(7330),
    [anon_sym_LT_EQ] = ACTIONS(7332),
    [anon_sym_GT] = ACTIONS(7332),
    [anon_sym_GT_EQ] = ACTIONS(7330),
    [anon_sym_CARET] = ACTIONS(7332),
    [anon_sym_PLUS] = ACTIONS(7332),
    [anon_sym_SLASH] = ACTIONS(7332),
    [anon_sym_PERCENT] = ACTIONS(7332),
    [sym_comment] = ACTIONS(87),
  },
  [10175] = {
    [sym__statements] = STATE(6625),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(6626),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(6627),
    [sym_rescue] = STATE(6628),
    [sym__body_statement] = STATE(10853),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(14663),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10176] = {
    [sym__statements] = STATE(6625),
    [sym_begin_block] = STATE(285),
    [sym_end_block] = STATE(285),
    [sym__statement] = STATE(285),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(285),
    [sym_unless_modifier] = STATE(285),
    [sym_while_modifier] = STATE(285),
    [sym_until_modifier] = STATE(285),
    [sym_rescue_modifier] = STATE(285),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_else] = STATE(6626),
    [sym_begin] = STATE(46),
    [sym_ensure] = STATE(6627),
    [sym_rescue] = STATE(6628),
    [sym__body_statement] = STATE(10854),
    [sym__arg] = STATE(290),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(293),
    [sym_scope_resolution] = STATE(291),
    [sym_call] = STATE(291),
    [sym_method_call] = STATE(293),
    [sym_assignment] = STATE(290),
    [sym_operator_assignment] = STATE(290),
    [sym_conditional] = STATE(290),
    [sym_range] = STATE(290),
    [sym_binary] = STATE(290),
    [sym_unary] = STATE(290),
    [sym_left_assignment_list] = STATE(292),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(293),
    [sym__variable] = STATE(291),
    [sym_undef] = STATE(285),
    [sym_alias] = STATE(285),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(293),
    [sym_false] = STATE(293),
    [sym_nil] = STATE(293),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(294),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(296),
    [aux_sym__statements_repeat1] = STATE(296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(511),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(14665),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10177] = {
    [sym__heredoc_body_start] = ACTIONS(7764),
    [sym__binary_minus] = ACTIONS(7764),
    [sym__binary_star] = ACTIONS(7764),
    [anon_sym_LBRACE] = ACTIONS(7764),
    [anon_sym_RBRACE] = ACTIONS(7764),
    [anon_sym_RPAREN] = ACTIONS(7764),
    [anon_sym_DOT] = ACTIONS(7766),
    [anon_sym_COMMA] = ACTIONS(7764),
    [anon_sym_PIPE] = ACTIONS(7766),
    [anon_sym_SEMI] = ACTIONS(7764),
    [anon_sym_STAR_STAR] = ACTIONS(7766),
    [anon_sym_AMP] = ACTIONS(7766),
    [anon_sym_EQ] = ACTIONS(7766),
    [anon_sym_LT] = ACTIONS(7766),
    [anon_sym_if] = ACTIONS(7764),
    [anon_sym_unless] = ACTIONS(7764),
    [anon_sym_while] = ACTIONS(7764),
    [anon_sym_until] = ACTIONS(7764),
    [anon_sym_rescue] = ACTIONS(7764),
    [anon_sym_in] = ACTIONS(7764),
    [anon_sym_do] = ACTIONS(7764),
    [anon_sym_LBRACK] = ACTIONS(7764),
    [anon_sym_RBRACK] = ACTIONS(7764),
    [anon_sym_COLON_COLON2] = ACTIONS(7764),
    [anon_sym_AMP_DOT] = ACTIONS(7764),
    [anon_sym_PLUS_EQ] = ACTIONS(7764),
    [anon_sym_DASH_EQ] = ACTIONS(7764),
    [anon_sym_STAR_EQ] = ACTIONS(7764),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7764),
    [anon_sym_SLASH_EQ] = ACTIONS(7764),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7764),
    [anon_sym_PIPE_EQ] = ACTIONS(7764),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7764),
    [anon_sym_AMP_EQ] = ACTIONS(7764),
    [anon_sym_PERCENT_EQ] = ACTIONS(7764),
    [anon_sym_GT_GT_EQ] = ACTIONS(7764),
    [anon_sym_LT_LT_EQ] = ACTIONS(7764),
    [anon_sym_CARET_EQ] = ACTIONS(7764),
    [anon_sym_QMARK] = ACTIONS(7764),
    [anon_sym_COLON2] = ACTIONS(7766),
    [anon_sym_DOT_DOT] = ACTIONS(7766),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7764),
    [anon_sym_and] = ACTIONS(7764),
    [anon_sym_or] = ACTIONS(7764),
    [anon_sym_PIPE_PIPE] = ACTIONS(7766),
    [anon_sym_AMP_AMP] = ACTIONS(7766),
    [anon_sym_LT_LT] = ACTIONS(7766),
    [anon_sym_GT_GT] = ACTIONS(7766),
    [anon_sym_EQ_EQ] = ACTIONS(7766),
    [anon_sym_BANG_EQ] = ACTIONS(7764),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7764),
    [anon_sym_LT_EQ_GT] = ACTIONS(7764),
    [anon_sym_EQ_TILDE] = ACTIONS(7764),
    [anon_sym_BANG_TILDE] = ACTIONS(7764),
    [anon_sym_LT_EQ] = ACTIONS(7766),
    [anon_sym_GT] = ACTIONS(7766),
    [anon_sym_GT_EQ] = ACTIONS(7764),
    [anon_sym_CARET] = ACTIONS(7766),
    [anon_sym_PLUS] = ACTIONS(7766),
    [anon_sym_SLASH] = ACTIONS(7766),
    [anon_sym_PERCENT] = ACTIONS(7766),
    [sym_comment] = ACTIONS(87),
  },
  [10178] = {
    [sym__heredoc_body_start] = ACTIONS(7818),
    [sym__binary_minus] = ACTIONS(7818),
    [sym__binary_star] = ACTIONS(7818),
    [anon_sym_LBRACE] = ACTIONS(7818),
    [anon_sym_RBRACE] = ACTIONS(7818),
    [anon_sym_RPAREN] = ACTIONS(7818),
    [anon_sym_DOT] = ACTIONS(7820),
    [anon_sym_COMMA] = ACTIONS(7818),
    [anon_sym_PIPE] = ACTIONS(7820),
    [anon_sym_SEMI] = ACTIONS(7818),
    [anon_sym_STAR_STAR] = ACTIONS(7820),
    [anon_sym_AMP] = ACTIONS(7820),
    [anon_sym_EQ] = ACTIONS(7820),
    [anon_sym_LT] = ACTIONS(7820),
    [anon_sym_if] = ACTIONS(7818),
    [anon_sym_unless] = ACTIONS(7818),
    [anon_sym_while] = ACTIONS(7818),
    [anon_sym_until] = ACTIONS(7818),
    [anon_sym_rescue] = ACTIONS(7818),
    [anon_sym_in] = ACTIONS(7818),
    [anon_sym_do] = ACTIONS(7818),
    [anon_sym_LBRACK] = ACTIONS(7818),
    [anon_sym_RBRACK] = ACTIONS(7818),
    [anon_sym_COLON_COLON2] = ACTIONS(7818),
    [anon_sym_AMP_DOT] = ACTIONS(7818),
    [anon_sym_PLUS_EQ] = ACTIONS(7818),
    [anon_sym_DASH_EQ] = ACTIONS(7818),
    [anon_sym_STAR_EQ] = ACTIONS(7818),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7818),
    [anon_sym_SLASH_EQ] = ACTIONS(7818),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7818),
    [anon_sym_PIPE_EQ] = ACTIONS(7818),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7818),
    [anon_sym_AMP_EQ] = ACTIONS(7818),
    [anon_sym_PERCENT_EQ] = ACTIONS(7818),
    [anon_sym_GT_GT_EQ] = ACTIONS(7818),
    [anon_sym_LT_LT_EQ] = ACTIONS(7818),
    [anon_sym_CARET_EQ] = ACTIONS(7818),
    [anon_sym_QMARK] = ACTIONS(7818),
    [anon_sym_COLON2] = ACTIONS(7820),
    [anon_sym_DOT_DOT] = ACTIONS(7820),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7818),
    [anon_sym_and] = ACTIONS(7818),
    [anon_sym_or] = ACTIONS(7818),
    [anon_sym_PIPE_PIPE] = ACTIONS(7820),
    [anon_sym_AMP_AMP] = ACTIONS(7820),
    [anon_sym_LT_LT] = ACTIONS(7820),
    [anon_sym_GT_GT] = ACTIONS(7820),
    [anon_sym_EQ_EQ] = ACTIONS(7820),
    [anon_sym_BANG_EQ] = ACTIONS(7818),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7818),
    [anon_sym_LT_EQ_GT] = ACTIONS(7818),
    [anon_sym_EQ_TILDE] = ACTIONS(7818),
    [anon_sym_BANG_TILDE] = ACTIONS(7818),
    [anon_sym_LT_EQ] = ACTIONS(7820),
    [anon_sym_GT] = ACTIONS(7820),
    [anon_sym_GT_EQ] = ACTIONS(7818),
    [anon_sym_CARET] = ACTIONS(7820),
    [anon_sym_PLUS] = ACTIONS(7820),
    [anon_sym_SLASH] = ACTIONS(7820),
    [anon_sym_PERCENT] = ACTIONS(7820),
    [sym_comment] = ACTIONS(87),
  },
  [10179] = {
    [sym__heredoc_body_start] = ACTIONS(8098),
    [sym__binary_minus] = ACTIONS(8098),
    [sym__binary_star] = ACTIONS(8098),
    [anon_sym_LBRACE] = ACTIONS(8098),
    [anon_sym_RBRACE] = ACTIONS(8098),
    [anon_sym_RPAREN] = ACTIONS(8098),
    [anon_sym_DOT] = ACTIONS(8100),
    [anon_sym_COMMA] = ACTIONS(8098),
    [anon_sym_PIPE] = ACTIONS(8100),
    [anon_sym_SEMI] = ACTIONS(8098),
    [anon_sym_STAR_STAR] = ACTIONS(8100),
    [anon_sym_AMP] = ACTIONS(8100),
    [anon_sym_EQ] = ACTIONS(8100),
    [anon_sym_LT] = ACTIONS(8100),
    [anon_sym_if] = ACTIONS(8098),
    [anon_sym_unless] = ACTIONS(8098),
    [anon_sym_while] = ACTIONS(8098),
    [anon_sym_until] = ACTIONS(8098),
    [anon_sym_rescue] = ACTIONS(8098),
    [anon_sym_in] = ACTIONS(8098),
    [anon_sym_do] = ACTIONS(8098),
    [anon_sym_LBRACK] = ACTIONS(8098),
    [anon_sym_RBRACK] = ACTIONS(8098),
    [anon_sym_COLON_COLON2] = ACTIONS(8098),
    [anon_sym_AMP_DOT] = ACTIONS(8098),
    [anon_sym_PLUS_EQ] = ACTIONS(8098),
    [anon_sym_DASH_EQ] = ACTIONS(8098),
    [anon_sym_STAR_EQ] = ACTIONS(8098),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8098),
    [anon_sym_SLASH_EQ] = ACTIONS(8098),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8098),
    [anon_sym_PIPE_EQ] = ACTIONS(8098),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8098),
    [anon_sym_AMP_EQ] = ACTIONS(8098),
    [anon_sym_PERCENT_EQ] = ACTIONS(8098),
    [anon_sym_GT_GT_EQ] = ACTIONS(8098),
    [anon_sym_LT_LT_EQ] = ACTIONS(8098),
    [anon_sym_CARET_EQ] = ACTIONS(8098),
    [anon_sym_QMARK] = ACTIONS(8098),
    [anon_sym_COLON2] = ACTIONS(8100),
    [anon_sym_DOT_DOT] = ACTIONS(8100),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8098),
    [anon_sym_and] = ACTIONS(8098),
    [anon_sym_or] = ACTIONS(8098),
    [anon_sym_PIPE_PIPE] = ACTIONS(8100),
    [anon_sym_AMP_AMP] = ACTIONS(8100),
    [anon_sym_LT_LT] = ACTIONS(8100),
    [anon_sym_GT_GT] = ACTIONS(8100),
    [anon_sym_EQ_EQ] = ACTIONS(8100),
    [anon_sym_BANG_EQ] = ACTIONS(8098),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8098),
    [anon_sym_LT_EQ_GT] = ACTIONS(8098),
    [anon_sym_EQ_TILDE] = ACTIONS(8098),
    [anon_sym_BANG_TILDE] = ACTIONS(8098),
    [anon_sym_LT_EQ] = ACTIONS(8100),
    [anon_sym_GT] = ACTIONS(8100),
    [anon_sym_GT_EQ] = ACTIONS(8098),
    [anon_sym_CARET] = ACTIONS(8100),
    [anon_sym_PLUS] = ACTIONS(8100),
    [anon_sym_SLASH] = ACTIONS(8100),
    [anon_sym_PERCENT] = ACTIONS(8100),
    [sym_comment] = ACTIONS(87),
  },
  [10180] = {
    [anon_sym_end] = ACTIONS(14667),
    [sym_comment] = ACTIONS(87),
  },
  [10181] = {
    [sym__heredoc_body_start] = ACTIONS(8284),
    [sym__binary_minus] = ACTIONS(8284),
    [sym__binary_star] = ACTIONS(8284),
    [anon_sym_LBRACE] = ACTIONS(8284),
    [anon_sym_RBRACE] = ACTIONS(8284),
    [anon_sym_RPAREN] = ACTIONS(8284),
    [anon_sym_DOT] = ACTIONS(8286),
    [anon_sym_COMMA] = ACTIONS(8284),
    [anon_sym_PIPE] = ACTIONS(8286),
    [anon_sym_SEMI] = ACTIONS(8284),
    [anon_sym_STAR_STAR] = ACTIONS(8286),
    [anon_sym_AMP] = ACTIONS(8286),
    [anon_sym_EQ] = ACTIONS(8286),
    [anon_sym_LT] = ACTIONS(8286),
    [anon_sym_if] = ACTIONS(8284),
    [anon_sym_unless] = ACTIONS(8284),
    [anon_sym_while] = ACTIONS(8284),
    [anon_sym_until] = ACTIONS(8284),
    [anon_sym_rescue] = ACTIONS(8284),
    [anon_sym_in] = ACTIONS(8284),
    [anon_sym_do] = ACTIONS(8284),
    [anon_sym_LBRACK] = ACTIONS(8284),
    [anon_sym_RBRACK] = ACTIONS(8284),
    [anon_sym_COLON_COLON2] = ACTIONS(8284),
    [anon_sym_AMP_DOT] = ACTIONS(8284),
    [anon_sym_PLUS_EQ] = ACTIONS(8284),
    [anon_sym_DASH_EQ] = ACTIONS(8284),
    [anon_sym_STAR_EQ] = ACTIONS(8284),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8284),
    [anon_sym_SLASH_EQ] = ACTIONS(8284),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8284),
    [anon_sym_PIPE_EQ] = ACTIONS(8284),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8284),
    [anon_sym_AMP_EQ] = ACTIONS(8284),
    [anon_sym_PERCENT_EQ] = ACTIONS(8284),
    [anon_sym_GT_GT_EQ] = ACTIONS(8284),
    [anon_sym_LT_LT_EQ] = ACTIONS(8284),
    [anon_sym_CARET_EQ] = ACTIONS(8284),
    [anon_sym_QMARK] = ACTIONS(8284),
    [anon_sym_COLON2] = ACTIONS(8286),
    [anon_sym_DOT_DOT] = ACTIONS(8286),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8284),
    [anon_sym_and] = ACTIONS(8284),
    [anon_sym_or] = ACTIONS(8284),
    [anon_sym_PIPE_PIPE] = ACTIONS(8286),
    [anon_sym_AMP_AMP] = ACTIONS(8286),
    [anon_sym_LT_LT] = ACTIONS(8286),
    [anon_sym_GT_GT] = ACTIONS(8286),
    [anon_sym_EQ_EQ] = ACTIONS(8286),
    [anon_sym_BANG_EQ] = ACTIONS(8284),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8284),
    [anon_sym_LT_EQ_GT] = ACTIONS(8284),
    [anon_sym_EQ_TILDE] = ACTIONS(8284),
    [anon_sym_BANG_TILDE] = ACTIONS(8284),
    [anon_sym_LT_EQ] = ACTIONS(8286),
    [anon_sym_GT] = ACTIONS(8286),
    [anon_sym_GT_EQ] = ACTIONS(8284),
    [anon_sym_CARET] = ACTIONS(8286),
    [anon_sym_PLUS] = ACTIONS(8286),
    [anon_sym_SLASH] = ACTIONS(8286),
    [anon_sym_PERCENT] = ACTIONS(8286),
    [sym_comment] = ACTIONS(87),
  },
  [10182] = {
    [anon_sym_end] = ACTIONS(14669),
    [sym_comment] = ACTIONS(87),
  },
  [10183] = {
    [sym__heredoc_body_start] = ACTIONS(8344),
    [sym__binary_minus] = ACTIONS(8344),
    [sym__binary_star] = ACTIONS(8344),
    [anon_sym_LBRACE] = ACTIONS(8344),
    [anon_sym_RBRACE] = ACTIONS(8344),
    [anon_sym_RPAREN] = ACTIONS(8344),
    [anon_sym_DOT] = ACTIONS(8346),
    [anon_sym_COMMA] = ACTIONS(8344),
    [anon_sym_PIPE] = ACTIONS(8346),
    [anon_sym_SEMI] = ACTIONS(8344),
    [anon_sym_STAR_STAR] = ACTIONS(8346),
    [anon_sym_AMP] = ACTIONS(8346),
    [anon_sym_EQ] = ACTIONS(8346),
    [anon_sym_LT] = ACTIONS(8346),
    [anon_sym_if] = ACTIONS(8344),
    [anon_sym_unless] = ACTIONS(8344),
    [anon_sym_while] = ACTIONS(8344),
    [anon_sym_until] = ACTIONS(8344),
    [anon_sym_rescue] = ACTIONS(8344),
    [anon_sym_in] = ACTIONS(8344),
    [anon_sym_do] = ACTIONS(8344),
    [anon_sym_LBRACK] = ACTIONS(8344),
    [anon_sym_RBRACK] = ACTIONS(8344),
    [anon_sym_COLON_COLON2] = ACTIONS(8344),
    [anon_sym_AMP_DOT] = ACTIONS(8344),
    [anon_sym_PLUS_EQ] = ACTIONS(8344),
    [anon_sym_DASH_EQ] = ACTIONS(8344),
    [anon_sym_STAR_EQ] = ACTIONS(8344),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8344),
    [anon_sym_SLASH_EQ] = ACTIONS(8344),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8344),
    [anon_sym_PIPE_EQ] = ACTIONS(8344),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8344),
    [anon_sym_AMP_EQ] = ACTIONS(8344),
    [anon_sym_PERCENT_EQ] = ACTIONS(8344),
    [anon_sym_GT_GT_EQ] = ACTIONS(8344),
    [anon_sym_LT_LT_EQ] = ACTIONS(8344),
    [anon_sym_CARET_EQ] = ACTIONS(8344),
    [anon_sym_QMARK] = ACTIONS(8344),
    [anon_sym_COLON2] = ACTIONS(8346),
    [anon_sym_DOT_DOT] = ACTIONS(8346),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8344),
    [anon_sym_and] = ACTIONS(8344),
    [anon_sym_or] = ACTIONS(8344),
    [anon_sym_PIPE_PIPE] = ACTIONS(8346),
    [anon_sym_AMP_AMP] = ACTIONS(8346),
    [anon_sym_LT_LT] = ACTIONS(8346),
    [anon_sym_GT_GT] = ACTIONS(8346),
    [anon_sym_EQ_EQ] = ACTIONS(8346),
    [anon_sym_BANG_EQ] = ACTIONS(8344),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8344),
    [anon_sym_LT_EQ_GT] = ACTIONS(8344),
    [anon_sym_EQ_TILDE] = ACTIONS(8344),
    [anon_sym_BANG_TILDE] = ACTIONS(8344),
    [anon_sym_LT_EQ] = ACTIONS(8346),
    [anon_sym_GT] = ACTIONS(8346),
    [anon_sym_GT_EQ] = ACTIONS(8344),
    [anon_sym_CARET] = ACTIONS(8346),
    [anon_sym_PLUS] = ACTIONS(8346),
    [anon_sym_SLASH] = ACTIONS(8346),
    [anon_sym_PERCENT] = ACTIONS(8346),
    [sym_comment] = ACTIONS(87),
  },
  [10184] = {
    [anon_sym_end] = ACTIONS(14671),
    [sym_comment] = ACTIONS(87),
  },
  [10185] = {
    [sym__heredoc_body_start] = ACTIONS(8420),
    [sym__binary_minus] = ACTIONS(8420),
    [sym__binary_star] = ACTIONS(8420),
    [anon_sym_LBRACE] = ACTIONS(8420),
    [anon_sym_RBRACE] = ACTIONS(8420),
    [anon_sym_RPAREN] = ACTIONS(8420),
    [anon_sym_DOT] = ACTIONS(8422),
    [anon_sym_COMMA] = ACTIONS(8420),
    [anon_sym_PIPE] = ACTIONS(8422),
    [anon_sym_SEMI] = ACTIONS(8420),
    [anon_sym_STAR_STAR] = ACTIONS(8422),
    [anon_sym_AMP] = ACTIONS(8422),
    [anon_sym_EQ] = ACTIONS(8422),
    [anon_sym_LT] = ACTIONS(8422),
    [anon_sym_if] = ACTIONS(8420),
    [anon_sym_unless] = ACTIONS(8420),
    [anon_sym_while] = ACTIONS(8420),
    [anon_sym_until] = ACTIONS(8420),
    [anon_sym_rescue] = ACTIONS(8420),
    [anon_sym_in] = ACTIONS(8420),
    [anon_sym_do] = ACTIONS(8420),
    [anon_sym_LBRACK] = ACTIONS(8420),
    [anon_sym_RBRACK] = ACTIONS(8420),
    [anon_sym_COLON_COLON2] = ACTIONS(8420),
    [anon_sym_AMP_DOT] = ACTIONS(8420),
    [anon_sym_PLUS_EQ] = ACTIONS(8420),
    [anon_sym_DASH_EQ] = ACTIONS(8420),
    [anon_sym_STAR_EQ] = ACTIONS(8420),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8420),
    [anon_sym_SLASH_EQ] = ACTIONS(8420),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8420),
    [anon_sym_PIPE_EQ] = ACTIONS(8420),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8420),
    [anon_sym_AMP_EQ] = ACTIONS(8420),
    [anon_sym_PERCENT_EQ] = ACTIONS(8420),
    [anon_sym_GT_GT_EQ] = ACTIONS(8420),
    [anon_sym_LT_LT_EQ] = ACTIONS(8420),
    [anon_sym_CARET_EQ] = ACTIONS(8420),
    [anon_sym_QMARK] = ACTIONS(8420),
    [anon_sym_COLON2] = ACTIONS(8422),
    [anon_sym_DOT_DOT] = ACTIONS(8422),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8420),
    [anon_sym_and] = ACTIONS(8420),
    [anon_sym_or] = ACTIONS(8420),
    [anon_sym_PIPE_PIPE] = ACTIONS(8422),
    [anon_sym_AMP_AMP] = ACTIONS(8422),
    [anon_sym_LT_LT] = ACTIONS(8422),
    [anon_sym_GT_GT] = ACTIONS(8422),
    [anon_sym_EQ_EQ] = ACTIONS(8422),
    [anon_sym_BANG_EQ] = ACTIONS(8420),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8420),
    [anon_sym_LT_EQ_GT] = ACTIONS(8420),
    [anon_sym_EQ_TILDE] = ACTIONS(8420),
    [anon_sym_BANG_TILDE] = ACTIONS(8420),
    [anon_sym_LT_EQ] = ACTIONS(8422),
    [anon_sym_GT] = ACTIONS(8422),
    [anon_sym_GT_EQ] = ACTIONS(8420),
    [anon_sym_CARET] = ACTIONS(8422),
    [anon_sym_PLUS] = ACTIONS(8422),
    [anon_sym_SLASH] = ACTIONS(8422),
    [anon_sym_PERCENT] = ACTIONS(8422),
    [sym_comment] = ACTIONS(87),
  },
  [10186] = {
    [anon_sym_end] = ACTIONS(14673),
    [sym_comment] = ACTIONS(87),
  },
  [10187] = {
    [sym__statements] = STATE(10860),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(14675),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10188] = {
    [sym__heredoc_body_start] = ACTIONS(8581),
    [sym__binary_minus] = ACTIONS(8581),
    [sym__binary_star] = ACTIONS(8581),
    [anon_sym_LBRACE] = ACTIONS(8581),
    [anon_sym_RBRACE] = ACTIONS(8581),
    [anon_sym_RPAREN] = ACTIONS(8581),
    [anon_sym_DOT] = ACTIONS(8583),
    [anon_sym_COMMA] = ACTIONS(8581),
    [anon_sym_PIPE] = ACTIONS(8583),
    [anon_sym_SEMI] = ACTIONS(8581),
    [anon_sym_STAR_STAR] = ACTIONS(8583),
    [anon_sym_AMP] = ACTIONS(8583),
    [anon_sym_EQ] = ACTIONS(8583),
    [anon_sym_LT] = ACTIONS(8583),
    [anon_sym_if] = ACTIONS(8581),
    [anon_sym_unless] = ACTIONS(8581),
    [anon_sym_while] = ACTIONS(8581),
    [anon_sym_until] = ACTIONS(8581),
    [anon_sym_rescue] = ACTIONS(8581),
    [anon_sym_in] = ACTIONS(8581),
    [anon_sym_do] = ACTIONS(8581),
    [anon_sym_LBRACK] = ACTIONS(8581),
    [anon_sym_RBRACK] = ACTIONS(8581),
    [anon_sym_COLON_COLON2] = ACTIONS(8581),
    [anon_sym_AMP_DOT] = ACTIONS(8581),
    [anon_sym_PLUS_EQ] = ACTIONS(8581),
    [anon_sym_DASH_EQ] = ACTIONS(8581),
    [anon_sym_STAR_EQ] = ACTIONS(8581),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8581),
    [anon_sym_SLASH_EQ] = ACTIONS(8581),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8581),
    [anon_sym_PIPE_EQ] = ACTIONS(8581),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8581),
    [anon_sym_AMP_EQ] = ACTIONS(8581),
    [anon_sym_PERCENT_EQ] = ACTIONS(8581),
    [anon_sym_GT_GT_EQ] = ACTIONS(8581),
    [anon_sym_LT_LT_EQ] = ACTIONS(8581),
    [anon_sym_CARET_EQ] = ACTIONS(8581),
    [anon_sym_QMARK] = ACTIONS(8581),
    [anon_sym_COLON2] = ACTIONS(8583),
    [anon_sym_DOT_DOT] = ACTIONS(8583),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8581),
    [anon_sym_and] = ACTIONS(8581),
    [anon_sym_or] = ACTIONS(8581),
    [anon_sym_PIPE_PIPE] = ACTIONS(8583),
    [anon_sym_AMP_AMP] = ACTIONS(8583),
    [anon_sym_LT_LT] = ACTIONS(8583),
    [anon_sym_GT_GT] = ACTIONS(8583),
    [anon_sym_EQ_EQ] = ACTIONS(8583),
    [anon_sym_BANG_EQ] = ACTIONS(8581),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8581),
    [anon_sym_LT_EQ_GT] = ACTIONS(8581),
    [anon_sym_EQ_TILDE] = ACTIONS(8581),
    [anon_sym_BANG_TILDE] = ACTIONS(8581),
    [anon_sym_LT_EQ] = ACTIONS(8583),
    [anon_sym_GT] = ACTIONS(8583),
    [anon_sym_GT_EQ] = ACTIONS(8581),
    [anon_sym_CARET] = ACTIONS(8583),
    [anon_sym_PLUS] = ACTIONS(8583),
    [anon_sym_SLASH] = ACTIONS(8583),
    [anon_sym_PERCENT] = ACTIONS(8583),
    [sym_comment] = ACTIONS(87),
  },
  [10189] = {
    [anon_sym_end] = ACTIONS(14677),
    [sym_comment] = ACTIONS(87),
  },
  [10190] = {
    [sym_when] = STATE(10863),
    [sym_else] = STATE(10862),
    [aux_sym_case_repeat1] = STATE(2987),
    [aux_sym_case_repeat2] = STATE(10863),
    [anon_sym_SEMI] = ACTIONS(4995),
    [anon_sym_end] = ACTIONS(14677),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [10191] = {
    [sym_when] = STATE(2988),
    [sym_else] = STATE(10862),
    [aux_sym_case_repeat2] = STATE(2988),
    [anon_sym_end] = ACTIONS(14677),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [10192] = {
    [sym__heredoc_body_start] = ACTIONS(9185),
    [sym__binary_minus] = ACTIONS(9185),
    [sym__binary_star] = ACTIONS(9185),
    [anon_sym_LBRACE] = ACTIONS(9185),
    [anon_sym_RBRACE] = ACTIONS(9185),
    [anon_sym_RPAREN] = ACTIONS(9185),
    [anon_sym_DOT] = ACTIONS(9187),
    [anon_sym_COMMA] = ACTIONS(9185),
    [anon_sym_PIPE] = ACTIONS(9187),
    [anon_sym_SEMI] = ACTIONS(9185),
    [anon_sym_STAR_STAR] = ACTIONS(9187),
    [anon_sym_AMP] = ACTIONS(9187),
    [anon_sym_EQ] = ACTIONS(9187),
    [anon_sym_LT] = ACTIONS(9187),
    [anon_sym_if] = ACTIONS(9185),
    [anon_sym_unless] = ACTIONS(9185),
    [anon_sym_while] = ACTIONS(9185),
    [anon_sym_until] = ACTIONS(9185),
    [anon_sym_rescue] = ACTIONS(9185),
    [anon_sym_in] = ACTIONS(9185),
    [anon_sym_do] = ACTIONS(9185),
    [anon_sym_LBRACK] = ACTIONS(9185),
    [anon_sym_RBRACK] = ACTIONS(9185),
    [anon_sym_COLON_COLON2] = ACTIONS(9185),
    [anon_sym_AMP_DOT] = ACTIONS(9185),
    [anon_sym_PLUS_EQ] = ACTIONS(9185),
    [anon_sym_DASH_EQ] = ACTIONS(9185),
    [anon_sym_STAR_EQ] = ACTIONS(9185),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9185),
    [anon_sym_SLASH_EQ] = ACTIONS(9185),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9185),
    [anon_sym_PIPE_EQ] = ACTIONS(9185),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9185),
    [anon_sym_AMP_EQ] = ACTIONS(9185),
    [anon_sym_PERCENT_EQ] = ACTIONS(9185),
    [anon_sym_GT_GT_EQ] = ACTIONS(9185),
    [anon_sym_LT_LT_EQ] = ACTIONS(9185),
    [anon_sym_CARET_EQ] = ACTIONS(9185),
    [anon_sym_QMARK] = ACTIONS(9185),
    [anon_sym_COLON2] = ACTIONS(9187),
    [anon_sym_DOT_DOT] = ACTIONS(9187),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9185),
    [anon_sym_and] = ACTIONS(9185),
    [anon_sym_or] = ACTIONS(9185),
    [anon_sym_PIPE_PIPE] = ACTIONS(9187),
    [anon_sym_AMP_AMP] = ACTIONS(9187),
    [anon_sym_LT_LT] = ACTIONS(9187),
    [anon_sym_GT_GT] = ACTIONS(9187),
    [anon_sym_EQ_EQ] = ACTIONS(9187),
    [anon_sym_BANG_EQ] = ACTIONS(9185),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9185),
    [anon_sym_LT_EQ_GT] = ACTIONS(9185),
    [anon_sym_EQ_TILDE] = ACTIONS(9185),
    [anon_sym_BANG_TILDE] = ACTIONS(9185),
    [anon_sym_LT_EQ] = ACTIONS(9187),
    [anon_sym_GT] = ACTIONS(9187),
    [anon_sym_GT_EQ] = ACTIONS(9185),
    [anon_sym_CARET] = ACTIONS(9187),
    [anon_sym_PLUS] = ACTIONS(9187),
    [anon_sym_SLASH] = ACTIONS(9187),
    [anon_sym_PERCENT] = ACTIONS(9187),
    [sym_comment] = ACTIONS(87),
  },
  [10193] = {
    [anon_sym_end] = ACTIONS(14679),
    [sym_comment] = ACTIONS(87),
  },
  [10194] = {
    [sym_ensure] = STATE(10865),
    [anon_sym_end] = ACTIONS(14679),
    [anon_sym_ensure] = ACTIONS(2169),
    [sym_comment] = ACTIONS(87),
  },
  [10195] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(10866),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(3940),
    [sym_scope_resolution] = STATE(3938),
    [sym_call] = STATE(3938),
    [sym_method_call] = STATE(3940),
    [sym_assignment] = STATE(10866),
    [sym_operator_assignment] = STATE(10866),
    [sym_conditional] = STATE(10866),
    [sym_range] = STATE(10866),
    [sym_binary] = STATE(10866),
    [sym_unary] = STATE(10866),
    [sym_left_assignment_list] = STATE(3939),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3940),
    [sym__variable] = STATE(3938),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(3940),
    [sym_false] = STATE(3940),
    [sym_nil] = STATE(3940),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(3941),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(6469),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(6481),
    [anon_sym_yield] = ACTIONS(6483),
    [anon_sym_break] = ACTIONS(6485),
    [anon_sym_next] = ACTIONS(6487),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(6505),
    [anon_sym_defined_QMARK] = ACTIONS(6507),
    [anon_sym_not] = ACTIONS(6509),
    [anon_sym_BANG] = ACTIONS(6511),
    [anon_sym_TILDE] = ACTIONS(6511),
    [sym_constant] = ACTIONS(6513),
    [sym_identifier] = ACTIONS(6513),
    [sym_instance_variable] = ACTIONS(6515),
    [sym_class_variable] = ACTIONS(6515),
    [sym_global_variable] = ACTIONS(6515),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(6513),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6513),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [10196] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(8877),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(3940),
    [sym_scope_resolution] = STATE(3938),
    [sym_call] = STATE(3938),
    [sym_method_call] = STATE(3940),
    [sym_splat_argument] = STATE(10867),
    [sym_assignment] = STATE(8877),
    [sym_operator_assignment] = STATE(8877),
    [sym_conditional] = STATE(8877),
    [sym_range] = STATE(8877),
    [sym_binary] = STATE(8877),
    [sym_unary] = STATE(8877),
    [sym__arg_or_splat_arg] = STATE(10867),
    [sym_left_assignment_list] = STATE(3939),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3940),
    [sym__variable] = STATE(3938),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(3940),
    [sym_false] = STATE(3940),
    [sym_nil] = STATE(3940),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(3941),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__splat_star] = ACTIONS(2990),
    [sym__unary_minus] = ACTIONS(6469),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(6481),
    [anon_sym_yield] = ACTIONS(6483),
    [anon_sym_break] = ACTIONS(6485),
    [anon_sym_next] = ACTIONS(6487),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(6505),
    [anon_sym_defined_QMARK] = ACTIONS(6507),
    [anon_sym_not] = ACTIONS(6509),
    [anon_sym_BANG] = ACTIONS(6511),
    [anon_sym_TILDE] = ACTIONS(6511),
    [sym_constant] = ACTIONS(6513),
    [sym_identifier] = ACTIONS(6513),
    [sym_instance_variable] = ACTIONS(6515),
    [sym_class_variable] = ACTIONS(6515),
    [sym_global_variable] = ACTIONS(6515),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(6513),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6513),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [10197] = {
    [aux_sym_exceptions_repeat1] = STATE(10868),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_LBRACE] = ACTIONS(9855),
    [anon_sym_RBRACE] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(14681),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_STAR_STAR] = ACTIONS(9857),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_EQ] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_do] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_PLUS_EQ] = ACTIONS(9855),
    [anon_sym_DASH_EQ] = ACTIONS(9855),
    [anon_sym_STAR_EQ] = ACTIONS(9855),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9855),
    [anon_sym_SLASH_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9855),
    [anon_sym_AMP_EQ] = ACTIONS(9855),
    [anon_sym_PERCENT_EQ] = ACTIONS(9855),
    [anon_sym_GT_GT_EQ] = ACTIONS(9855),
    [anon_sym_LT_LT_EQ] = ACTIONS(9855),
    [anon_sym_CARET_EQ] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9857),
    [anon_sym_AMP_AMP] = ACTIONS(9857),
    [anon_sym_LT_LT] = ACTIONS(9857),
    [anon_sym_GT_GT] = ACTIONS(9857),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9857),
    [anon_sym_PLUS] = ACTIONS(9857),
    [anon_sym_SLASH] = ACTIONS(9857),
    [anon_sym_PERCENT] = ACTIONS(9857),
    [sym_comment] = ACTIONS(87),
  },
  [10198] = {
    [sym__binary_minus] = ACTIONS(13712),
    [sym__binary_star] = ACTIONS(13712),
    [anon_sym_LBRACE] = ACTIONS(13712),
    [anon_sym_RBRACE] = ACTIONS(13712),
    [anon_sym_RPAREN] = ACTIONS(13712),
    [anon_sym_DOT] = ACTIONS(13714),
    [anon_sym_COMMA] = ACTIONS(13712),
    [anon_sym_PIPE] = ACTIONS(13714),
    [anon_sym_SEMI] = ACTIONS(13712),
    [anon_sym_STAR_STAR] = ACTIONS(13714),
    [anon_sym_AMP] = ACTIONS(13714),
    [anon_sym_EQ] = ACTIONS(13714),
    [anon_sym_LT] = ACTIONS(13714),
    [anon_sym_if] = ACTIONS(13712),
    [anon_sym_unless] = ACTIONS(13712),
    [anon_sym_while] = ACTIONS(13712),
    [anon_sym_until] = ACTIONS(13712),
    [anon_sym_rescue] = ACTIONS(13712),
    [anon_sym_do] = ACTIONS(13712),
    [anon_sym_LBRACK] = ACTIONS(13712),
    [anon_sym_COLON_COLON2] = ACTIONS(13712),
    [anon_sym_AMP_DOT] = ACTIONS(13712),
    [anon_sym_PLUS_EQ] = ACTIONS(13712),
    [anon_sym_DASH_EQ] = ACTIONS(13712),
    [anon_sym_STAR_EQ] = ACTIONS(13712),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13712),
    [anon_sym_SLASH_EQ] = ACTIONS(13712),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13712),
    [anon_sym_PIPE_EQ] = ACTIONS(13712),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13712),
    [anon_sym_AMP_EQ] = ACTIONS(13712),
    [anon_sym_PERCENT_EQ] = ACTIONS(13712),
    [anon_sym_GT_GT_EQ] = ACTIONS(13712),
    [anon_sym_LT_LT_EQ] = ACTIONS(13712),
    [anon_sym_CARET_EQ] = ACTIONS(13712),
    [anon_sym_QMARK] = ACTIONS(13712),
    [anon_sym_COLON2] = ACTIONS(13714),
    [anon_sym_DOT_DOT] = ACTIONS(13714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13712),
    [anon_sym_and] = ACTIONS(13712),
    [anon_sym_or] = ACTIONS(13712),
    [anon_sym_PIPE_PIPE] = ACTIONS(13714),
    [anon_sym_AMP_AMP] = ACTIONS(13714),
    [anon_sym_LT_LT] = ACTIONS(13714),
    [anon_sym_GT_GT] = ACTIONS(13714),
    [anon_sym_EQ_EQ] = ACTIONS(13714),
    [anon_sym_BANG_EQ] = ACTIONS(13712),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13712),
    [anon_sym_LT_EQ_GT] = ACTIONS(13712),
    [anon_sym_EQ_TILDE] = ACTIONS(13712),
    [anon_sym_BANG_TILDE] = ACTIONS(13712),
    [anon_sym_LT_EQ] = ACTIONS(13714),
    [anon_sym_GT] = ACTIONS(13714),
    [anon_sym_GT_EQ] = ACTIONS(13712),
    [anon_sym_CARET] = ACTIONS(13714),
    [anon_sym_PLUS] = ACTIONS(13714),
    [anon_sym_SLASH] = ACTIONS(13714),
    [anon_sym_PERCENT] = ACTIONS(13714),
    [sym_comment] = ACTIONS(87),
  },
  [10199] = {
    [anon_sym_end] = ACTIONS(14683),
    [sym_comment] = ACTIONS(87),
  },
  [10200] = {
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(6537),
    [sym__binary_star] = ACTIONS(6539),
    [anon_sym_LBRACE] = ACTIONS(12120),
    [anon_sym_RBRACE] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(6541),
    [anon_sym_STAR_STAR] = ACTIONS(6543),
    [anon_sym_AMP] = ACTIONS(6545),
    [anon_sym_EQ] = ACTIONS(12879),
    [anon_sym_LT] = ACTIONS(6547),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_EQ_GT] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_PLUS_EQ] = ACTIONS(12120),
    [anon_sym_DASH_EQ] = ACTIONS(12120),
    [anon_sym_STAR_EQ] = ACTIONS(12120),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12120),
    [anon_sym_SLASH_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12120),
    [anon_sym_AMP_EQ] = ACTIONS(12120),
    [anon_sym_PERCENT_EQ] = ACTIONS(12120),
    [anon_sym_GT_GT_EQ] = ACTIONS(12120),
    [anon_sym_LT_LT_EQ] = ACTIONS(12120),
    [anon_sym_CARET_EQ] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(6549),
    [anon_sym_DOT_DOT] = ACTIONS(6551),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6553),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(6555),
    [anon_sym_AMP_AMP] = ACTIONS(6555),
    [anon_sym_LT_LT] = ACTIONS(6557),
    [anon_sym_GT_GT] = ACTIONS(6557),
    [anon_sym_EQ_EQ] = ACTIONS(6555),
    [anon_sym_BANG_EQ] = ACTIONS(6559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6559),
    [anon_sym_LT_EQ_GT] = ACTIONS(6559),
    [anon_sym_EQ_TILDE] = ACTIONS(6559),
    [anon_sym_BANG_TILDE] = ACTIONS(6559),
    [anon_sym_LT_EQ] = ACTIONS(6547),
    [anon_sym_GT] = ACTIONS(6547),
    [anon_sym_GT_EQ] = ACTIONS(6561),
    [anon_sym_CARET] = ACTIONS(6541),
    [anon_sym_PLUS] = ACTIONS(6563),
    [anon_sym_SLASH] = ACTIONS(6543),
    [anon_sym_PERCENT] = ACTIONS(6543),
    [sym_comment] = ACTIONS(87),
  },
  [10201] = {
    [aux_sym_exceptions_repeat1] = STATE(10201),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_RBRACE] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(14685),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_PLUS_EQ] = ACTIONS(11597),
    [anon_sym_DASH_EQ] = ACTIONS(11597),
    [anon_sym_STAR_EQ] = ACTIONS(11597),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11597),
    [anon_sym_SLASH_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11597),
    [anon_sym_AMP_EQ] = ACTIONS(11597),
    [anon_sym_PERCENT_EQ] = ACTIONS(11597),
    [anon_sym_GT_GT_EQ] = ACTIONS(11597),
    [anon_sym_LT_LT_EQ] = ACTIONS(11597),
    [anon_sym_CARET_EQ] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_LT] = ACTIONS(12338),
    [anon_sym_GT_GT] = ACTIONS(12338),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(12338),
    [anon_sym_PLUS] = ACTIONS(12338),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [10202] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(10870),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(3988),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym_method_call] = STATE(3988),
    [sym_assignment] = STATE(10870),
    [sym_operator_assignment] = STATE(10870),
    [sym_conditional] = STATE(10870),
    [sym_range] = STATE(10870),
    [sym_binary] = STATE(10870),
    [sym_unary] = STATE(10870),
    [sym_left_assignment_list] = STATE(3987),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(3988),
    [sym__variable] = STATE(455),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(3988),
    [sym_false] = STATE(3988),
    [sym_nil] = STATE(3988),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(3989),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(6583),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6585),
    [anon_sym_yield] = ACTIONS(6587),
    [anon_sym_break] = ACTIONS(6589),
    [anon_sym_next] = ACTIONS(6591),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6593),
    [anon_sym_defined_QMARK] = ACTIONS(6595),
    [anon_sym_not] = ACTIONS(6597),
    [anon_sym_BANG] = ACTIONS(6599),
    [anon_sym_TILDE] = ACTIONS(6599),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [10203] = {
    [sym_heredoc_body] = STATE(10203),
    [aux_sym_call_repeat1] = STATE(10203),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(7916),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_RBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [10204] = {
    [sym_heredoc_body] = STATE(10203),
    [aux_sym_call_repeat1] = STATE(10203),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_RBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [10205] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10871),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(4009),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4009),
    [sym_assignment] = STATE(10871),
    [sym_operator_assignment] = STATE(10871),
    [sym_conditional] = STATE(10871),
    [sym_range] = STATE(10871),
    [sym_binary] = STATE(10871),
    [sym_unary] = STATE(10871),
    [sym_left_assignment_list] = STATE(4008),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4009),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(4009),
    [sym_false] = STATE(4009),
    [sym_nil] = STATE(4009),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(4010),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6651),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6653),
    [anon_sym_yield] = ACTIONS(6655),
    [anon_sym_break] = ACTIONS(6657),
    [anon_sym_next] = ACTIONS(6659),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6661),
    [anon_sym_defined_QMARK] = ACTIONS(6663),
    [anon_sym_not] = ACTIONS(6665),
    [anon_sym_BANG] = ACTIONS(6667),
    [anon_sym_TILDE] = ACTIONS(6667),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10206] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(8917),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(4009),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4009),
    [sym_splat_argument] = STATE(7439),
    [sym_assignment] = STATE(8917),
    [sym_operator_assignment] = STATE(8917),
    [sym_conditional] = STATE(8917),
    [sym_range] = STATE(8917),
    [sym_binary] = STATE(8917),
    [sym_unary] = STATE(8917),
    [sym__arg_or_splat_arg] = STATE(7439),
    [sym_left_assignment_list] = STATE(4008),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4009),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(4009),
    [sym_false] = STATE(4009),
    [sym_nil] = STATE(4009),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(4010),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(3109),
    [sym__unary_minus] = ACTIONS(6651),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6653),
    [anon_sym_yield] = ACTIONS(6655),
    [anon_sym_break] = ACTIONS(6657),
    [anon_sym_next] = ACTIONS(6659),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6661),
    [anon_sym_defined_QMARK] = ACTIONS(6663),
    [anon_sym_not] = ACTIONS(6665),
    [anon_sym_BANG] = ACTIONS(6667),
    [anon_sym_TILDE] = ACTIONS(6667),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10207] = {
    [aux_sym_exceptions_repeat1] = STATE(10872),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_RBRACE] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(14688),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [10208] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(6675),
    [sym__binary_star] = ACTIONS(6677),
    [anon_sym_RBRACE] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(6679),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(6677),
    [anon_sym_AMP] = ACTIONS(6681),
    [anon_sym_LT] = ACTIONS(6683),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_EQ_GT] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(6685),
    [anon_sym_DOT_DOT] = ACTIONS(6687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6689),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(6691),
    [anon_sym_AMP_AMP] = ACTIONS(6691),
    [anon_sym_LT_LT] = ACTIONS(6693),
    [anon_sym_GT_GT] = ACTIONS(6693),
    [anon_sym_EQ_EQ] = ACTIONS(6695),
    [anon_sym_BANG_EQ] = ACTIONS(6691),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6691),
    [anon_sym_LT_EQ_GT] = ACTIONS(6691),
    [anon_sym_EQ_TILDE] = ACTIONS(6691),
    [anon_sym_BANG_TILDE] = ACTIONS(6691),
    [anon_sym_LT_EQ] = ACTIONS(6683),
    [anon_sym_GT] = ACTIONS(6683),
    [anon_sym_GT_EQ] = ACTIONS(6697),
    [anon_sym_CARET] = ACTIONS(6699),
    [anon_sym_PLUS] = ACTIONS(6675),
    [anon_sym_SLASH] = ACTIONS(6677),
    [anon_sym_PERCENT] = ACTIONS(6677),
    [sym_comment] = ACTIONS(87),
  },
  [10209] = {
    [aux_sym_exceptions_repeat1] = STATE(10209),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_RBRACE] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(14690),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [10210] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10873),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(4062),
    [sym_scope_resolution] = STATE(4060),
    [sym_call] = STATE(4060),
    [sym_method_call] = STATE(4062),
    [sym_assignment] = STATE(10873),
    [sym_operator_assignment] = STATE(10873),
    [sym_conditional] = STATE(10873),
    [sym_range] = STATE(10873),
    [sym_binary] = STATE(10873),
    [sym_unary] = STATE(10873),
    [sym_left_assignment_list] = STATE(4061),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4062),
    [sym__variable] = STATE(4060),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(4062),
    [sym_false] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(4063),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(6713),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(6715),
    [anon_sym_yield] = ACTIONS(6717),
    [anon_sym_break] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6721),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(6723),
    [anon_sym_defined_QMARK] = ACTIONS(6725),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6731),
    [sym_identifier] = ACTIONS(6731),
    [sym_instance_variable] = ACTIONS(6733),
    [sym_class_variable] = ACTIONS(6733),
    [sym_global_variable] = ACTIONS(6733),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(6731),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6731),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [10211] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(8937),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(4062),
    [sym_scope_resolution] = STATE(4060),
    [sym_call] = STATE(4060),
    [sym_method_call] = STATE(4062),
    [sym_splat_argument] = STATE(10067),
    [sym_assignment] = STATE(8937),
    [sym_operator_assignment] = STATE(8937),
    [sym_conditional] = STATE(8937),
    [sym_range] = STATE(8937),
    [sym_binary] = STATE(8937),
    [sym_unary] = STATE(8937),
    [sym__arg_or_splat_arg] = STATE(10067),
    [sym_left_assignment_list] = STATE(4061),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4062),
    [sym__variable] = STATE(4060),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(4062),
    [sym_false] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(4063),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__splat_star] = ACTIONS(3177),
    [sym__unary_minus] = ACTIONS(6713),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(6715),
    [anon_sym_yield] = ACTIONS(6717),
    [anon_sym_break] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6721),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(6723),
    [anon_sym_defined_QMARK] = ACTIONS(6725),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6731),
    [sym_identifier] = ACTIONS(6731),
    [sym_instance_variable] = ACTIONS(6733),
    [sym_class_variable] = ACTIONS(6733),
    [sym_global_variable] = ACTIONS(6733),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(6731),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6731),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [10212] = {
    [aux_sym_exceptions_repeat1] = STATE(10874),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_LBRACE] = ACTIONS(9855),
    [anon_sym_RBRACE] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(14693),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9857),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_EQ] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_do] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_PLUS_EQ] = ACTIONS(9855),
    [anon_sym_DASH_EQ] = ACTIONS(9855),
    [anon_sym_STAR_EQ] = ACTIONS(9855),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9855),
    [anon_sym_SLASH_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9855),
    [anon_sym_AMP_EQ] = ACTIONS(9855),
    [anon_sym_PERCENT_EQ] = ACTIONS(9855),
    [anon_sym_GT_GT_EQ] = ACTIONS(9855),
    [anon_sym_LT_LT_EQ] = ACTIONS(9855),
    [anon_sym_CARET_EQ] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9857),
    [anon_sym_AMP_AMP] = ACTIONS(9857),
    [anon_sym_LT_LT] = ACTIONS(9857),
    [anon_sym_GT_GT] = ACTIONS(9857),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9857),
    [anon_sym_PLUS] = ACTIONS(9857),
    [anon_sym_SLASH] = ACTIONS(9857),
    [anon_sym_PERCENT] = ACTIONS(9857),
    [sym_comment] = ACTIONS(87),
  },
  [10213] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(6741),
    [sym__binary_star] = ACTIONS(6743),
    [anon_sym_LBRACE] = ACTIONS(12120),
    [anon_sym_RBRACE] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(6747),
    [anon_sym_AMP] = ACTIONS(6749),
    [anon_sym_EQ] = ACTIONS(12879),
    [anon_sym_LT] = ACTIONS(6751),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_EQ_GT] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_PLUS_EQ] = ACTIONS(12120),
    [anon_sym_DASH_EQ] = ACTIONS(12120),
    [anon_sym_STAR_EQ] = ACTIONS(12120),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12120),
    [anon_sym_SLASH_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12120),
    [anon_sym_AMP_EQ] = ACTIONS(12120),
    [anon_sym_PERCENT_EQ] = ACTIONS(12120),
    [anon_sym_GT_GT_EQ] = ACTIONS(12120),
    [anon_sym_LT_LT_EQ] = ACTIONS(12120),
    [anon_sym_CARET_EQ] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(6753),
    [anon_sym_DOT_DOT] = ACTIONS(6755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6757),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(6759),
    [anon_sym_AMP_AMP] = ACTIONS(6759),
    [anon_sym_LT_LT] = ACTIONS(6761),
    [anon_sym_GT_GT] = ACTIONS(6761),
    [anon_sym_EQ_EQ] = ACTIONS(6759),
    [anon_sym_BANG_EQ] = ACTIONS(6763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6763),
    [anon_sym_LT_EQ_GT] = ACTIONS(6763),
    [anon_sym_EQ_TILDE] = ACTIONS(6763),
    [anon_sym_BANG_TILDE] = ACTIONS(6763),
    [anon_sym_LT_EQ] = ACTIONS(6751),
    [anon_sym_GT] = ACTIONS(6751),
    [anon_sym_GT_EQ] = ACTIONS(6765),
    [anon_sym_CARET] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6767),
    [anon_sym_SLASH] = ACTIONS(6747),
    [anon_sym_PERCENT] = ACTIONS(6747),
    [sym_comment] = ACTIONS(87),
  },
  [10214] = {
    [aux_sym_exceptions_repeat1] = STATE(10214),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_RBRACE] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(14695),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_PLUS_EQ] = ACTIONS(11597),
    [anon_sym_DASH_EQ] = ACTIONS(11597),
    [anon_sym_STAR_EQ] = ACTIONS(11597),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11597),
    [anon_sym_SLASH_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11597),
    [anon_sym_AMP_EQ] = ACTIONS(11597),
    [anon_sym_PERCENT_EQ] = ACTIONS(11597),
    [anon_sym_GT_GT_EQ] = ACTIONS(11597),
    [anon_sym_LT_LT_EQ] = ACTIONS(11597),
    [anon_sym_CARET_EQ] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_LT] = ACTIONS(12338),
    [anon_sym_GT_GT] = ACTIONS(12338),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(12338),
    [anon_sym_PLUS] = ACTIONS(12338),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [10215] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10875),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(4094),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4094),
    [sym_assignment] = STATE(10875),
    [sym_operator_assignment] = STATE(10875),
    [sym_conditional] = STATE(10875),
    [sym_range] = STATE(10875),
    [sym_binary] = STATE(10875),
    [sym_unary] = STATE(10875),
    [sym_left_assignment_list] = STATE(4093),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4094),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(4094),
    [sym_false] = STATE(4094),
    [sym_nil] = STATE(4094),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(4010),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6781),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6653),
    [anon_sym_yield] = ACTIONS(6655),
    [anon_sym_break] = ACTIONS(6657),
    [anon_sym_next] = ACTIONS(6659),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6783),
    [anon_sym_defined_QMARK] = ACTIONS(6785),
    [anon_sym_not] = ACTIONS(6787),
    [anon_sym_BANG] = ACTIONS(6789),
    [anon_sym_TILDE] = ACTIONS(6789),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10216] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(10876),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4119),
    [sym_scope_resolution] = STATE(539),
    [sym_call] = STATE(539),
    [sym_method_call] = STATE(4119),
    [sym_assignment] = STATE(10876),
    [sym_operator_assignment] = STATE(10876),
    [sym_conditional] = STATE(10876),
    [sym_range] = STATE(10876),
    [sym_binary] = STATE(10876),
    [sym_unary] = STATE(10876),
    [sym_left_assignment_list] = STATE(4118),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4119),
    [sym__variable] = STATE(539),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4119),
    [sym_false] = STATE(4119),
    [sym_nil] = STATE(4119),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(542),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6833),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6835),
    [anon_sym_defined_QMARK] = ACTIONS(6837),
    [anon_sym_not] = ACTIONS(6839),
    [anon_sym_BANG] = ACTIONS(6841),
    [anon_sym_TILDE] = ACTIONS(6841),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10217] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(8970),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4119),
    [sym_scope_resolution] = STATE(539),
    [sym_call] = STATE(539),
    [sym_method_call] = STATE(4119),
    [sym_splat_argument] = STATE(9013),
    [sym_assignment] = STATE(8970),
    [sym_operator_assignment] = STATE(8970),
    [sym_conditional] = STATE(8970),
    [sym_range] = STATE(8970),
    [sym_binary] = STATE(8970),
    [sym_unary] = STATE(8970),
    [sym__arg_or_splat_arg] = STATE(9013),
    [sym_left_assignment_list] = STATE(4118),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4119),
    [sym__variable] = STATE(539),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4119),
    [sym_false] = STATE(4119),
    [sym_nil] = STATE(4119),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(542),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(3253),
    [sym__unary_minus] = ACTIONS(6833),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6835),
    [anon_sym_defined_QMARK] = ACTIONS(6837),
    [anon_sym_not] = ACTIONS(6839),
    [anon_sym_BANG] = ACTIONS(6841),
    [anon_sym_TILDE] = ACTIONS(6841),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10218] = {
    [aux_sym_exceptions_repeat1] = STATE(10877),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_RBRACE] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(14698),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [10219] = {
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(6857),
    [sym__binary_star] = ACTIONS(6859),
    [anon_sym_RBRACE] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(6861),
    [anon_sym_STAR_STAR] = ACTIONS(6859),
    [anon_sym_AMP] = ACTIONS(6863),
    [anon_sym_LT] = ACTIONS(6865),
    [anon_sym_EQ_GT] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(6867),
    [anon_sym_DOT_DOT] = ACTIONS(6869),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6871),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(6873),
    [anon_sym_AMP_AMP] = ACTIONS(6873),
    [anon_sym_LT_LT] = ACTIONS(6875),
    [anon_sym_GT_GT] = ACTIONS(6875),
    [anon_sym_EQ_EQ] = ACTIONS(6877),
    [anon_sym_BANG_EQ] = ACTIONS(6873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6873),
    [anon_sym_LT_EQ_GT] = ACTIONS(6873),
    [anon_sym_EQ_TILDE] = ACTIONS(6873),
    [anon_sym_BANG_TILDE] = ACTIONS(6873),
    [anon_sym_LT_EQ] = ACTIONS(6865),
    [anon_sym_GT] = ACTIONS(6865),
    [anon_sym_GT_EQ] = ACTIONS(6879),
    [anon_sym_CARET] = ACTIONS(6881),
    [anon_sym_PLUS] = ACTIONS(6857),
    [anon_sym_SLASH] = ACTIONS(6859),
    [anon_sym_PERCENT] = ACTIONS(6859),
    [sym_comment] = ACTIONS(87),
  },
  [10220] = {
    [aux_sym_exceptions_repeat1] = STATE(10220),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_RBRACE] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(14700),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [10221] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(10878),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(4189),
    [sym_scope_resolution] = STATE(4187),
    [sym_call] = STATE(4187),
    [sym_method_call] = STATE(4189),
    [sym_assignment] = STATE(10878),
    [sym_operator_assignment] = STATE(10878),
    [sym_conditional] = STATE(10878),
    [sym_range] = STATE(10878),
    [sym_binary] = STATE(10878),
    [sym_unary] = STATE(10878),
    [sym_left_assignment_list] = STATE(4188),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4189),
    [sym__variable] = STATE(4187),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(4189),
    [sym_false] = STATE(4189),
    [sym_nil] = STATE(4189),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(4190),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(6913),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(6915),
    [anon_sym_yield] = ACTIONS(6917),
    [anon_sym_break] = ACTIONS(6919),
    [anon_sym_next] = ACTIONS(6921),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_defined_QMARK] = ACTIONS(6925),
    [anon_sym_not] = ACTIONS(6927),
    [anon_sym_BANG] = ACTIONS(6929),
    [anon_sym_TILDE] = ACTIONS(6929),
    [sym_constant] = ACTIONS(6931),
    [sym_identifier] = ACTIONS(6931),
    [sym_instance_variable] = ACTIONS(6933),
    [sym_class_variable] = ACTIONS(6933),
    [sym_global_variable] = ACTIONS(6933),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(6931),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6931),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [10222] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(9000),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(4189),
    [sym_scope_resolution] = STATE(4187),
    [sym_call] = STATE(4187),
    [sym_method_call] = STATE(4189),
    [sym_splat_argument] = STATE(10867),
    [sym_assignment] = STATE(9000),
    [sym_operator_assignment] = STATE(9000),
    [sym_conditional] = STATE(9000),
    [sym_range] = STATE(9000),
    [sym_binary] = STATE(9000),
    [sym_unary] = STATE(9000),
    [sym__arg_or_splat_arg] = STATE(10867),
    [sym_left_assignment_list] = STATE(4188),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4189),
    [sym__variable] = STATE(4187),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(4189),
    [sym_false] = STATE(4189),
    [sym_nil] = STATE(4189),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(4190),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__splat_star] = ACTIONS(3321),
    [sym__unary_minus] = ACTIONS(6913),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(6915),
    [anon_sym_yield] = ACTIONS(6917),
    [anon_sym_break] = ACTIONS(6919),
    [anon_sym_next] = ACTIONS(6921),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_defined_QMARK] = ACTIONS(6925),
    [anon_sym_not] = ACTIONS(6927),
    [anon_sym_BANG] = ACTIONS(6929),
    [anon_sym_TILDE] = ACTIONS(6929),
    [sym_constant] = ACTIONS(6931),
    [sym_identifier] = ACTIONS(6931),
    [sym_instance_variable] = ACTIONS(6933),
    [sym_class_variable] = ACTIONS(6933),
    [sym_global_variable] = ACTIONS(6933),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(6931),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6931),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [10223] = {
    [aux_sym_exceptions_repeat1] = STATE(10879),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_LBRACE] = ACTIONS(9855),
    [anon_sym_RBRACE] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(14703),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_STAR_STAR] = ACTIONS(9857),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_EQ] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_do] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_PLUS_EQ] = ACTIONS(9855),
    [anon_sym_DASH_EQ] = ACTIONS(9855),
    [anon_sym_STAR_EQ] = ACTIONS(9855),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9855),
    [anon_sym_SLASH_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9855),
    [anon_sym_AMP_EQ] = ACTIONS(9855),
    [anon_sym_PERCENT_EQ] = ACTIONS(9855),
    [anon_sym_GT_GT_EQ] = ACTIONS(9855),
    [anon_sym_LT_LT_EQ] = ACTIONS(9855),
    [anon_sym_CARET_EQ] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9857),
    [anon_sym_AMP_AMP] = ACTIONS(9857),
    [anon_sym_LT_LT] = ACTIONS(9857),
    [anon_sym_GT_GT] = ACTIONS(9857),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9857),
    [anon_sym_PLUS] = ACTIONS(9857),
    [anon_sym_SLASH] = ACTIONS(9857),
    [anon_sym_PERCENT] = ACTIONS(9857),
    [sym_comment] = ACTIONS(87),
  },
  [10224] = {
    [sym__heredoc_body_start] = ACTIONS(13712),
    [sym__binary_minus] = ACTIONS(13712),
    [sym__binary_star] = ACTIONS(13712),
    [anon_sym_LBRACE] = ACTIONS(13712),
    [anon_sym_RBRACE] = ACTIONS(13712),
    [anon_sym_RPAREN] = ACTIONS(13712),
    [anon_sym_DOT] = ACTIONS(13714),
    [anon_sym_COMMA] = ACTIONS(13712),
    [anon_sym_PIPE] = ACTIONS(13714),
    [anon_sym_SEMI] = ACTIONS(13712),
    [anon_sym_STAR_STAR] = ACTIONS(13714),
    [anon_sym_AMP] = ACTIONS(13714),
    [anon_sym_EQ] = ACTIONS(13714),
    [anon_sym_LT] = ACTIONS(13714),
    [anon_sym_if] = ACTIONS(13712),
    [anon_sym_unless] = ACTIONS(13712),
    [anon_sym_while] = ACTIONS(13712),
    [anon_sym_until] = ACTIONS(13712),
    [anon_sym_rescue] = ACTIONS(13712),
    [anon_sym_in] = ACTIONS(13712),
    [anon_sym_do] = ACTIONS(13712),
    [anon_sym_LBRACK] = ACTIONS(13712),
    [anon_sym_RBRACK] = ACTIONS(13712),
    [anon_sym_COLON_COLON2] = ACTIONS(13712),
    [anon_sym_AMP_DOT] = ACTIONS(13712),
    [anon_sym_PLUS_EQ] = ACTIONS(13712),
    [anon_sym_DASH_EQ] = ACTIONS(13712),
    [anon_sym_STAR_EQ] = ACTIONS(13712),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13712),
    [anon_sym_SLASH_EQ] = ACTIONS(13712),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13712),
    [anon_sym_PIPE_EQ] = ACTIONS(13712),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13712),
    [anon_sym_AMP_EQ] = ACTIONS(13712),
    [anon_sym_PERCENT_EQ] = ACTIONS(13712),
    [anon_sym_GT_GT_EQ] = ACTIONS(13712),
    [anon_sym_LT_LT_EQ] = ACTIONS(13712),
    [anon_sym_CARET_EQ] = ACTIONS(13712),
    [anon_sym_QMARK] = ACTIONS(13712),
    [anon_sym_COLON2] = ACTIONS(13714),
    [anon_sym_DOT_DOT] = ACTIONS(13714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13712),
    [anon_sym_and] = ACTIONS(13712),
    [anon_sym_or] = ACTIONS(13712),
    [anon_sym_PIPE_PIPE] = ACTIONS(13714),
    [anon_sym_AMP_AMP] = ACTIONS(13714),
    [anon_sym_LT_LT] = ACTIONS(13714),
    [anon_sym_GT_GT] = ACTIONS(13714),
    [anon_sym_EQ_EQ] = ACTIONS(13714),
    [anon_sym_BANG_EQ] = ACTIONS(13712),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13712),
    [anon_sym_LT_EQ_GT] = ACTIONS(13712),
    [anon_sym_EQ_TILDE] = ACTIONS(13712),
    [anon_sym_BANG_TILDE] = ACTIONS(13712),
    [anon_sym_LT_EQ] = ACTIONS(13714),
    [anon_sym_GT] = ACTIONS(13714),
    [anon_sym_GT_EQ] = ACTIONS(13712),
    [anon_sym_CARET] = ACTIONS(13714),
    [anon_sym_PLUS] = ACTIONS(13714),
    [anon_sym_SLASH] = ACTIONS(13714),
    [anon_sym_PERCENT] = ACTIONS(13714),
    [sym_comment] = ACTIONS(87),
  },
  [10225] = {
    [anon_sym_end] = ACTIONS(14705),
    [sym_comment] = ACTIONS(87),
  },
  [10226] = {
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(6947),
    [sym__binary_star] = ACTIONS(6949),
    [anon_sym_LBRACE] = ACTIONS(12120),
    [anon_sym_RBRACE] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(6951),
    [anon_sym_STAR_STAR] = ACTIONS(6953),
    [anon_sym_AMP] = ACTIONS(6955),
    [anon_sym_EQ] = ACTIONS(12879),
    [anon_sym_LT] = ACTIONS(6957),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_EQ_GT] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_PLUS_EQ] = ACTIONS(12120),
    [anon_sym_DASH_EQ] = ACTIONS(12120),
    [anon_sym_STAR_EQ] = ACTIONS(12120),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12120),
    [anon_sym_SLASH_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12120),
    [anon_sym_AMP_EQ] = ACTIONS(12120),
    [anon_sym_PERCENT_EQ] = ACTIONS(12120),
    [anon_sym_GT_GT_EQ] = ACTIONS(12120),
    [anon_sym_LT_LT_EQ] = ACTIONS(12120),
    [anon_sym_CARET_EQ] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(6959),
    [anon_sym_DOT_DOT] = ACTIONS(6961),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6963),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(6965),
    [anon_sym_AMP_AMP] = ACTIONS(6965),
    [anon_sym_LT_LT] = ACTIONS(6967),
    [anon_sym_GT_GT] = ACTIONS(6967),
    [anon_sym_EQ_EQ] = ACTIONS(6965),
    [anon_sym_BANG_EQ] = ACTIONS(6969),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6969),
    [anon_sym_LT_EQ_GT] = ACTIONS(6969),
    [anon_sym_EQ_TILDE] = ACTIONS(6969),
    [anon_sym_BANG_TILDE] = ACTIONS(6969),
    [anon_sym_LT_EQ] = ACTIONS(6957),
    [anon_sym_GT] = ACTIONS(6957),
    [anon_sym_GT_EQ] = ACTIONS(6971),
    [anon_sym_CARET] = ACTIONS(6951),
    [anon_sym_PLUS] = ACTIONS(6973),
    [anon_sym_SLASH] = ACTIONS(6953),
    [anon_sym_PERCENT] = ACTIONS(6953),
    [sym_comment] = ACTIONS(87),
  },
  [10227] = {
    [aux_sym_exceptions_repeat1] = STATE(10227),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_RBRACE] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(14707),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_PLUS_EQ] = ACTIONS(11597),
    [anon_sym_DASH_EQ] = ACTIONS(11597),
    [anon_sym_STAR_EQ] = ACTIONS(11597),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11597),
    [anon_sym_SLASH_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11597),
    [anon_sym_AMP_EQ] = ACTIONS(11597),
    [anon_sym_PERCENT_EQ] = ACTIONS(11597),
    [anon_sym_GT_GT_EQ] = ACTIONS(11597),
    [anon_sym_LT_LT_EQ] = ACTIONS(11597),
    [anon_sym_CARET_EQ] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_LT] = ACTIONS(12338),
    [anon_sym_GT_GT] = ACTIONS(12338),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(12338),
    [anon_sym_PLUS] = ACTIONS(12338),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [10228] = {
    [sym__binary_minus] = ACTIONS(14151),
    [sym__binary_star] = ACTIONS(14151),
    [anon_sym_LBRACE] = ACTIONS(14151),
    [anon_sym_RBRACE] = ACTIONS(14151),
    [anon_sym_RPAREN] = ACTIONS(14151),
    [anon_sym_DOT] = ACTIONS(14153),
    [anon_sym_COMMA] = ACTIONS(14151),
    [anon_sym_PIPE] = ACTIONS(14153),
    [anon_sym_SEMI] = ACTIONS(14151),
    [anon_sym_STAR_STAR] = ACTIONS(14151),
    [anon_sym_AMP] = ACTIONS(14153),
    [anon_sym_LT] = ACTIONS(14153),
    [anon_sym_if] = ACTIONS(14151),
    [anon_sym_unless] = ACTIONS(14151),
    [anon_sym_while] = ACTIONS(14151),
    [anon_sym_until] = ACTIONS(14151),
    [anon_sym_rescue] = ACTIONS(14151),
    [anon_sym_do] = ACTIONS(14151),
    [anon_sym_EQ_GT] = ACTIONS(14151),
    [anon_sym_LBRACK] = ACTIONS(14151),
    [anon_sym_COLON_COLON2] = ACTIONS(14151),
    [anon_sym_AMP_DOT] = ACTIONS(14151),
    [anon_sym_QMARK] = ACTIONS(14151),
    [anon_sym_COLON2] = ACTIONS(14153),
    [anon_sym_DOT_DOT] = ACTIONS(14153),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14151),
    [anon_sym_and] = ACTIONS(14151),
    [anon_sym_or] = ACTIONS(14151),
    [anon_sym_PIPE_PIPE] = ACTIONS(14151),
    [anon_sym_AMP_AMP] = ACTIONS(14151),
    [anon_sym_LT_LT] = ACTIONS(14151),
    [anon_sym_GT_GT] = ACTIONS(14151),
    [anon_sym_EQ_EQ] = ACTIONS(14153),
    [anon_sym_BANG_EQ] = ACTIONS(14151),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14151),
    [anon_sym_LT_EQ_GT] = ACTIONS(14151),
    [anon_sym_EQ_TILDE] = ACTIONS(14151),
    [anon_sym_BANG_TILDE] = ACTIONS(14151),
    [anon_sym_LT_EQ] = ACTIONS(14153),
    [anon_sym_GT] = ACTIONS(14153),
    [anon_sym_GT_EQ] = ACTIONS(14151),
    [anon_sym_CARET] = ACTIONS(14151),
    [anon_sym_PLUS] = ACTIONS(14151),
    [anon_sym_SLASH] = ACTIONS(14151),
    [anon_sym_PERCENT] = ACTIONS(14151),
    [sym_comment] = ACTIONS(87),
  },
  [10229] = {
    [sym__binary_minus] = ACTIONS(14580),
    [sym__binary_star] = ACTIONS(14580),
    [anon_sym_LBRACE] = ACTIONS(14580),
    [anon_sym_RBRACE] = ACTIONS(14580),
    [anon_sym_RPAREN] = ACTIONS(14580),
    [anon_sym_DOT] = ACTIONS(14582),
    [anon_sym_COMMA] = ACTIONS(14580),
    [anon_sym_PIPE] = ACTIONS(14582),
    [anon_sym_SEMI] = ACTIONS(14580),
    [anon_sym_STAR_STAR] = ACTIONS(14580),
    [anon_sym_AMP] = ACTIONS(14582),
    [anon_sym_LT] = ACTIONS(14582),
    [anon_sym_if] = ACTIONS(14580),
    [anon_sym_unless] = ACTIONS(14580),
    [anon_sym_while] = ACTIONS(14580),
    [anon_sym_until] = ACTIONS(14580),
    [anon_sym_rescue] = ACTIONS(14580),
    [anon_sym_do] = ACTIONS(14580),
    [anon_sym_EQ_GT] = ACTIONS(14580),
    [anon_sym_LBRACK] = ACTIONS(14580),
    [anon_sym_COLON_COLON2] = ACTIONS(14580),
    [anon_sym_AMP_DOT] = ACTIONS(14580),
    [anon_sym_QMARK] = ACTIONS(14580),
    [anon_sym_COLON2] = ACTIONS(14582),
    [anon_sym_DOT_DOT] = ACTIONS(14582),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14580),
    [anon_sym_and] = ACTIONS(14580),
    [anon_sym_or] = ACTIONS(14580),
    [anon_sym_PIPE_PIPE] = ACTIONS(14580),
    [anon_sym_AMP_AMP] = ACTIONS(14580),
    [anon_sym_LT_LT] = ACTIONS(14580),
    [anon_sym_GT_GT] = ACTIONS(14580),
    [anon_sym_EQ_EQ] = ACTIONS(14582),
    [anon_sym_BANG_EQ] = ACTIONS(14580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14580),
    [anon_sym_LT_EQ_GT] = ACTIONS(14580),
    [anon_sym_EQ_TILDE] = ACTIONS(14580),
    [anon_sym_BANG_TILDE] = ACTIONS(14580),
    [anon_sym_LT_EQ] = ACTIONS(14582),
    [anon_sym_GT] = ACTIONS(14582),
    [anon_sym_GT_EQ] = ACTIONS(14580),
    [anon_sym_CARET] = ACTIONS(14580),
    [anon_sym_PLUS] = ACTIONS(14580),
    [anon_sym_SLASH] = ACTIONS(14580),
    [anon_sym_PERCENT] = ACTIONS(14580),
    [sym_comment] = ACTIONS(87),
  },
  [10230] = {
    [sym__heredoc_body_start] = ACTIONS(12555),
    [sym__binary_minus] = ACTIONS(12555),
    [sym__binary_star] = ACTIONS(12555),
    [anon_sym_LBRACE] = ACTIONS(12555),
    [anon_sym_RBRACE] = ACTIONS(12555),
    [anon_sym_RPAREN] = ACTIONS(12555),
    [anon_sym_DOT] = ACTIONS(12557),
    [anon_sym_COMMA] = ACTIONS(12555),
    [anon_sym_PIPE] = ACTIONS(12557),
    [anon_sym_SEMI] = ACTIONS(12555),
    [anon_sym_STAR_STAR] = ACTIONS(12557),
    [anon_sym_AMP] = ACTIONS(12557),
    [anon_sym_EQ] = ACTIONS(12557),
    [anon_sym_LT] = ACTIONS(12557),
    [anon_sym_if] = ACTIONS(12555),
    [anon_sym_unless] = ACTIONS(12555),
    [anon_sym_while] = ACTIONS(12555),
    [anon_sym_until] = ACTIONS(12555),
    [anon_sym_rescue] = ACTIONS(12555),
    [anon_sym_in] = ACTIONS(12555),
    [anon_sym_do] = ACTIONS(12555),
    [anon_sym_EQ_GT] = ACTIONS(12555),
    [anon_sym_LBRACK] = ACTIONS(12555),
    [anon_sym_RBRACK] = ACTIONS(12555),
    [anon_sym_COLON_COLON2] = ACTIONS(12555),
    [anon_sym_AMP_DOT] = ACTIONS(12555),
    [anon_sym_PLUS_EQ] = ACTIONS(12555),
    [anon_sym_DASH_EQ] = ACTIONS(12555),
    [anon_sym_STAR_EQ] = ACTIONS(12555),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12555),
    [anon_sym_SLASH_EQ] = ACTIONS(12555),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12555),
    [anon_sym_PIPE_EQ] = ACTIONS(12555),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12555),
    [anon_sym_AMP_EQ] = ACTIONS(12555),
    [anon_sym_PERCENT_EQ] = ACTIONS(12555),
    [anon_sym_GT_GT_EQ] = ACTIONS(12555),
    [anon_sym_LT_LT_EQ] = ACTIONS(12555),
    [anon_sym_CARET_EQ] = ACTIONS(12555),
    [anon_sym_QMARK] = ACTIONS(12555),
    [anon_sym_COLON2] = ACTIONS(12557),
    [anon_sym_DOT_DOT] = ACTIONS(12557),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12555),
    [anon_sym_and] = ACTIONS(12555),
    [anon_sym_or] = ACTIONS(12555),
    [anon_sym_PIPE_PIPE] = ACTIONS(12557),
    [anon_sym_AMP_AMP] = ACTIONS(12557),
    [anon_sym_LT_LT] = ACTIONS(12557),
    [anon_sym_GT_GT] = ACTIONS(12557),
    [anon_sym_EQ_EQ] = ACTIONS(12557),
    [anon_sym_BANG_EQ] = ACTIONS(12555),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12555),
    [anon_sym_LT_EQ_GT] = ACTIONS(12555),
    [anon_sym_EQ_TILDE] = ACTIONS(12555),
    [anon_sym_BANG_TILDE] = ACTIONS(12555),
    [anon_sym_LT_EQ] = ACTIONS(12557),
    [anon_sym_GT] = ACTIONS(12557),
    [anon_sym_GT_EQ] = ACTIONS(12555),
    [anon_sym_CARET] = ACTIONS(12557),
    [anon_sym_PLUS] = ACTIONS(12557),
    [anon_sym_SLASH] = ACTIONS(12557),
    [anon_sym_PERCENT] = ACTIONS(12557),
    [sym_comment] = ACTIONS(87),
  },
  [10231] = {
    [sym__heredoc_body_start] = ACTIONS(12559),
    [sym__binary_minus] = ACTIONS(12559),
    [sym__binary_star] = ACTIONS(12559),
    [anon_sym_LBRACE] = ACTIONS(12559),
    [anon_sym_RBRACE] = ACTIONS(12559),
    [anon_sym_RPAREN] = ACTIONS(12559),
    [anon_sym_DOT] = ACTIONS(12561),
    [anon_sym_COMMA] = ACTIONS(12559),
    [anon_sym_PIPE] = ACTIONS(12561),
    [anon_sym_SEMI] = ACTIONS(12559),
    [anon_sym_STAR_STAR] = ACTIONS(12561),
    [anon_sym_AMP] = ACTIONS(12561),
    [anon_sym_EQ] = ACTIONS(12561),
    [anon_sym_LT] = ACTIONS(12561),
    [anon_sym_if] = ACTIONS(12559),
    [anon_sym_unless] = ACTIONS(12559),
    [anon_sym_while] = ACTIONS(12559),
    [anon_sym_until] = ACTIONS(12559),
    [anon_sym_rescue] = ACTIONS(12559),
    [anon_sym_in] = ACTIONS(12559),
    [anon_sym_do] = ACTIONS(12559),
    [anon_sym_EQ_GT] = ACTIONS(12559),
    [anon_sym_LBRACK] = ACTIONS(12559),
    [anon_sym_RBRACK] = ACTIONS(12559),
    [anon_sym_COLON_COLON2] = ACTIONS(12559),
    [anon_sym_AMP_DOT] = ACTIONS(12559),
    [anon_sym_PLUS_EQ] = ACTIONS(12559),
    [anon_sym_DASH_EQ] = ACTIONS(12559),
    [anon_sym_STAR_EQ] = ACTIONS(12559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12559),
    [anon_sym_SLASH_EQ] = ACTIONS(12559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12559),
    [anon_sym_PIPE_EQ] = ACTIONS(12559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12559),
    [anon_sym_AMP_EQ] = ACTIONS(12559),
    [anon_sym_PERCENT_EQ] = ACTIONS(12559),
    [anon_sym_GT_GT_EQ] = ACTIONS(12559),
    [anon_sym_LT_LT_EQ] = ACTIONS(12559),
    [anon_sym_CARET_EQ] = ACTIONS(12559),
    [anon_sym_QMARK] = ACTIONS(12559),
    [anon_sym_COLON2] = ACTIONS(12561),
    [anon_sym_DOT_DOT] = ACTIONS(12561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12559),
    [anon_sym_and] = ACTIONS(12559),
    [anon_sym_or] = ACTIONS(12559),
    [anon_sym_PIPE_PIPE] = ACTIONS(12561),
    [anon_sym_AMP_AMP] = ACTIONS(12561),
    [anon_sym_LT_LT] = ACTIONS(12561),
    [anon_sym_GT_GT] = ACTIONS(12561),
    [anon_sym_EQ_EQ] = ACTIONS(12561),
    [anon_sym_BANG_EQ] = ACTIONS(12559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12559),
    [anon_sym_LT_EQ_GT] = ACTIONS(12559),
    [anon_sym_EQ_TILDE] = ACTIONS(12559),
    [anon_sym_BANG_TILDE] = ACTIONS(12559),
    [anon_sym_LT_EQ] = ACTIONS(12561),
    [anon_sym_GT] = ACTIONS(12561),
    [anon_sym_GT_EQ] = ACTIONS(12559),
    [anon_sym_CARET] = ACTIONS(12561),
    [anon_sym_PLUS] = ACTIONS(12561),
    [anon_sym_SLASH] = ACTIONS(12561),
    [anon_sym_PERCENT] = ACTIONS(12561),
    [sym_comment] = ACTIONS(87),
  },
  [10232] = {
    [sym__heredoc_body_start] = ACTIONS(12663),
    [sym__binary_minus] = ACTIONS(12663),
    [sym__binary_star] = ACTIONS(12663),
    [anon_sym_LBRACE] = ACTIONS(12663),
    [anon_sym_RBRACE] = ACTIONS(12663),
    [anon_sym_RPAREN] = ACTIONS(12663),
    [anon_sym_DOT] = ACTIONS(12665),
    [anon_sym_COMMA] = ACTIONS(12663),
    [anon_sym_PIPE] = ACTIONS(12665),
    [anon_sym_SEMI] = ACTIONS(12663),
    [anon_sym_STAR_STAR] = ACTIONS(12665),
    [anon_sym_AMP] = ACTIONS(12665),
    [anon_sym_EQ] = ACTIONS(12665),
    [anon_sym_LT] = ACTIONS(12665),
    [anon_sym_if] = ACTIONS(12663),
    [anon_sym_unless] = ACTIONS(12663),
    [anon_sym_while] = ACTIONS(12663),
    [anon_sym_until] = ACTIONS(12663),
    [anon_sym_rescue] = ACTIONS(12663),
    [anon_sym_in] = ACTIONS(12663),
    [anon_sym_do] = ACTIONS(12663),
    [anon_sym_EQ_GT] = ACTIONS(12663),
    [anon_sym_LBRACK] = ACTIONS(12663),
    [anon_sym_RBRACK] = ACTIONS(12663),
    [anon_sym_COLON_COLON2] = ACTIONS(12663),
    [anon_sym_AMP_DOT] = ACTIONS(12663),
    [anon_sym_PLUS_EQ] = ACTIONS(12663),
    [anon_sym_DASH_EQ] = ACTIONS(12663),
    [anon_sym_STAR_EQ] = ACTIONS(12663),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12663),
    [anon_sym_SLASH_EQ] = ACTIONS(12663),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12663),
    [anon_sym_PIPE_EQ] = ACTIONS(12663),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12663),
    [anon_sym_AMP_EQ] = ACTIONS(12663),
    [anon_sym_PERCENT_EQ] = ACTIONS(12663),
    [anon_sym_GT_GT_EQ] = ACTIONS(12663),
    [anon_sym_LT_LT_EQ] = ACTIONS(12663),
    [anon_sym_CARET_EQ] = ACTIONS(12663),
    [anon_sym_QMARK] = ACTIONS(12663),
    [anon_sym_COLON2] = ACTIONS(12665),
    [anon_sym_DOT_DOT] = ACTIONS(12665),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12663),
    [anon_sym_and] = ACTIONS(12663),
    [anon_sym_or] = ACTIONS(12663),
    [anon_sym_PIPE_PIPE] = ACTIONS(12665),
    [anon_sym_AMP_AMP] = ACTIONS(12665),
    [anon_sym_LT_LT] = ACTIONS(12665),
    [anon_sym_GT_GT] = ACTIONS(12665),
    [anon_sym_EQ_EQ] = ACTIONS(12665),
    [anon_sym_BANG_EQ] = ACTIONS(12663),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12663),
    [anon_sym_LT_EQ_GT] = ACTIONS(12663),
    [anon_sym_EQ_TILDE] = ACTIONS(12663),
    [anon_sym_BANG_TILDE] = ACTIONS(12663),
    [anon_sym_LT_EQ] = ACTIONS(12665),
    [anon_sym_GT] = ACTIONS(12665),
    [anon_sym_GT_EQ] = ACTIONS(12663),
    [anon_sym_CARET] = ACTIONS(12665),
    [anon_sym_PLUS] = ACTIONS(12665),
    [anon_sym_SLASH] = ACTIONS(12665),
    [anon_sym_PERCENT] = ACTIONS(12665),
    [sym_comment] = ACTIONS(87),
  },
  [10233] = {
    [sym__heredoc_body_start] = ACTIONS(13224),
    [sym__binary_minus] = ACTIONS(13224),
    [sym__binary_star] = ACTIONS(13224),
    [anon_sym_LBRACE] = ACTIONS(13224),
    [anon_sym_RBRACE] = ACTIONS(13224),
    [anon_sym_RPAREN] = ACTIONS(13224),
    [anon_sym_DOT] = ACTIONS(13226),
    [anon_sym_COMMA] = ACTIONS(13224),
    [anon_sym_PIPE] = ACTIONS(13226),
    [anon_sym_SEMI] = ACTIONS(13224),
    [anon_sym_STAR_STAR] = ACTIONS(13226),
    [anon_sym_AMP] = ACTIONS(13226),
    [anon_sym_EQ] = ACTIONS(13226),
    [anon_sym_LT] = ACTIONS(13226),
    [anon_sym_if] = ACTIONS(13224),
    [anon_sym_unless] = ACTIONS(13224),
    [anon_sym_while] = ACTIONS(13224),
    [anon_sym_until] = ACTIONS(13224),
    [anon_sym_rescue] = ACTIONS(13224),
    [anon_sym_in] = ACTIONS(13224),
    [anon_sym_do] = ACTIONS(13224),
    [anon_sym_EQ_GT] = ACTIONS(13224),
    [anon_sym_LBRACK] = ACTIONS(13224),
    [anon_sym_RBRACK] = ACTIONS(13224),
    [anon_sym_COLON_COLON2] = ACTIONS(13224),
    [anon_sym_AMP_DOT] = ACTIONS(13224),
    [anon_sym_PLUS_EQ] = ACTIONS(13224),
    [anon_sym_DASH_EQ] = ACTIONS(13224),
    [anon_sym_STAR_EQ] = ACTIONS(13224),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13224),
    [anon_sym_SLASH_EQ] = ACTIONS(13224),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13224),
    [anon_sym_PIPE_EQ] = ACTIONS(13224),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13224),
    [anon_sym_AMP_EQ] = ACTIONS(13224),
    [anon_sym_PERCENT_EQ] = ACTIONS(13224),
    [anon_sym_GT_GT_EQ] = ACTIONS(13224),
    [anon_sym_LT_LT_EQ] = ACTIONS(13224),
    [anon_sym_CARET_EQ] = ACTIONS(13224),
    [anon_sym_QMARK] = ACTIONS(13224),
    [anon_sym_COLON2] = ACTIONS(13226),
    [anon_sym_DOT_DOT] = ACTIONS(13226),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13224),
    [anon_sym_and] = ACTIONS(13224),
    [anon_sym_or] = ACTIONS(13224),
    [anon_sym_PIPE_PIPE] = ACTIONS(13226),
    [anon_sym_AMP_AMP] = ACTIONS(13226),
    [anon_sym_LT_LT] = ACTIONS(13226),
    [anon_sym_GT_GT] = ACTIONS(13226),
    [anon_sym_EQ_EQ] = ACTIONS(13226),
    [anon_sym_BANG_EQ] = ACTIONS(13224),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13224),
    [anon_sym_LT_EQ_GT] = ACTIONS(13224),
    [anon_sym_EQ_TILDE] = ACTIONS(13224),
    [anon_sym_BANG_TILDE] = ACTIONS(13224),
    [anon_sym_LT_EQ] = ACTIONS(13226),
    [anon_sym_GT] = ACTIONS(13226),
    [anon_sym_GT_EQ] = ACTIONS(13224),
    [anon_sym_CARET] = ACTIONS(13226),
    [anon_sym_PLUS] = ACTIONS(13226),
    [anon_sym_SLASH] = ACTIONS(13226),
    [anon_sym_PERCENT] = ACTIONS(13226),
    [sym_comment] = ACTIONS(87),
  },
  [10234] = {
    [sym__binary_minus] = ACTIONS(14580),
    [sym__binary_star] = ACTIONS(14580),
    [anon_sym_DOT] = ACTIONS(14582),
    [anon_sym_COMMA] = ACTIONS(14580),
    [anon_sym_PIPE] = ACTIONS(14582),
    [anon_sym_STAR_STAR] = ACTIONS(14582),
    [anon_sym_AMP] = ACTIONS(14582),
    [anon_sym_EQ] = ACTIONS(14582),
    [anon_sym_LT] = ACTIONS(14582),
    [anon_sym_EQ_GT] = ACTIONS(14580),
    [anon_sym_LBRACK] = ACTIONS(14580),
    [anon_sym_COLON_COLON2] = ACTIONS(14580),
    [anon_sym_AMP_DOT] = ACTIONS(14580),
    [anon_sym_PLUS_EQ] = ACTIONS(14580),
    [anon_sym_DASH_EQ] = ACTIONS(14580),
    [anon_sym_STAR_EQ] = ACTIONS(14580),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14580),
    [anon_sym_SLASH_EQ] = ACTIONS(14580),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14580),
    [anon_sym_PIPE_EQ] = ACTIONS(14580),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14580),
    [anon_sym_AMP_EQ] = ACTIONS(14580),
    [anon_sym_PERCENT_EQ] = ACTIONS(14580),
    [anon_sym_GT_GT_EQ] = ACTIONS(14580),
    [anon_sym_LT_LT_EQ] = ACTIONS(14580),
    [anon_sym_CARET_EQ] = ACTIONS(14580),
    [anon_sym_QMARK] = ACTIONS(14580),
    [anon_sym_DOT_DOT] = ACTIONS(14582),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14580),
    [anon_sym_and] = ACTIONS(14580),
    [anon_sym_or] = ACTIONS(14580),
    [anon_sym_PIPE_PIPE] = ACTIONS(14582),
    [anon_sym_AMP_AMP] = ACTIONS(14582),
    [anon_sym_LT_LT] = ACTIONS(14582),
    [anon_sym_GT_GT] = ACTIONS(14582),
    [anon_sym_EQ_EQ] = ACTIONS(14582),
    [anon_sym_BANG_EQ] = ACTIONS(14580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14580),
    [anon_sym_LT_EQ_GT] = ACTIONS(14580),
    [anon_sym_EQ_TILDE] = ACTIONS(14580),
    [anon_sym_BANG_TILDE] = ACTIONS(14580),
    [anon_sym_LT_EQ] = ACTIONS(14582),
    [anon_sym_GT] = ACTIONS(14582),
    [anon_sym_GT_EQ] = ACTIONS(14580),
    [anon_sym_CARET] = ACTIONS(14582),
    [anon_sym_PLUS] = ACTIONS(14582),
    [anon_sym_SLASH] = ACTIONS(14582),
    [anon_sym_PERCENT] = ACTIONS(14582),
    [sym_comment] = ACTIONS(87),
  },
  [10235] = {
    [sym__heredoc_body_start] = ACTIONS(13235),
    [sym__binary_minus] = ACTIONS(13235),
    [sym__binary_star] = ACTIONS(13235),
    [anon_sym_LBRACE] = ACTIONS(13235),
    [anon_sym_RBRACE] = ACTIONS(13235),
    [anon_sym_RPAREN] = ACTIONS(13235),
    [anon_sym_DOT] = ACTIONS(13237),
    [anon_sym_COMMA] = ACTIONS(13235),
    [anon_sym_PIPE] = ACTIONS(13237),
    [anon_sym_SEMI] = ACTIONS(13235),
    [anon_sym_STAR_STAR] = ACTIONS(13237),
    [anon_sym_AMP] = ACTIONS(13237),
    [anon_sym_EQ] = ACTIONS(13237),
    [anon_sym_LT] = ACTIONS(13237),
    [anon_sym_if] = ACTIONS(13235),
    [anon_sym_unless] = ACTIONS(13235),
    [anon_sym_while] = ACTIONS(13235),
    [anon_sym_until] = ACTIONS(13235),
    [anon_sym_rescue] = ACTIONS(13235),
    [anon_sym_in] = ACTIONS(13235),
    [anon_sym_do] = ACTIONS(13235),
    [anon_sym_EQ_GT] = ACTIONS(13235),
    [anon_sym_LBRACK] = ACTIONS(13235),
    [anon_sym_RBRACK] = ACTIONS(13235),
    [anon_sym_COLON_COLON2] = ACTIONS(13235),
    [anon_sym_AMP_DOT] = ACTIONS(13235),
    [anon_sym_PLUS_EQ] = ACTIONS(13235),
    [anon_sym_DASH_EQ] = ACTIONS(13235),
    [anon_sym_STAR_EQ] = ACTIONS(13235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13235),
    [anon_sym_SLASH_EQ] = ACTIONS(13235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13235),
    [anon_sym_PIPE_EQ] = ACTIONS(13235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13235),
    [anon_sym_AMP_EQ] = ACTIONS(13235),
    [anon_sym_PERCENT_EQ] = ACTIONS(13235),
    [anon_sym_GT_GT_EQ] = ACTIONS(13235),
    [anon_sym_LT_LT_EQ] = ACTIONS(13235),
    [anon_sym_CARET_EQ] = ACTIONS(13235),
    [anon_sym_QMARK] = ACTIONS(13235),
    [anon_sym_COLON2] = ACTIONS(13237),
    [anon_sym_DOT_DOT] = ACTIONS(13237),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13235),
    [anon_sym_and] = ACTIONS(13235),
    [anon_sym_or] = ACTIONS(13235),
    [anon_sym_PIPE_PIPE] = ACTIONS(13237),
    [anon_sym_AMP_AMP] = ACTIONS(13237),
    [anon_sym_LT_LT] = ACTIONS(13237),
    [anon_sym_GT_GT] = ACTIONS(13237),
    [anon_sym_EQ_EQ] = ACTIONS(13237),
    [anon_sym_BANG_EQ] = ACTIONS(13235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13235),
    [anon_sym_LT_EQ_GT] = ACTIONS(13235),
    [anon_sym_EQ_TILDE] = ACTIONS(13235),
    [anon_sym_BANG_TILDE] = ACTIONS(13235),
    [anon_sym_LT_EQ] = ACTIONS(13237),
    [anon_sym_GT] = ACTIONS(13237),
    [anon_sym_GT_EQ] = ACTIONS(13235),
    [anon_sym_CARET] = ACTIONS(13237),
    [anon_sym_PLUS] = ACTIONS(13237),
    [anon_sym_SLASH] = ACTIONS(13237),
    [anon_sym_PERCENT] = ACTIONS(13237),
    [sym_comment] = ACTIONS(87),
  },
  [10236] = {
    [anon_sym_end] = ACTIONS(14710),
    [sym_comment] = ACTIONS(87),
  },
  [10237] = {
    [sym__heredoc_body_start] = ACTIONS(13547),
    [sym__binary_minus] = ACTIONS(13547),
    [sym__binary_star] = ACTIONS(13547),
    [anon_sym_LBRACE] = ACTIONS(13547),
    [anon_sym_RBRACE] = ACTIONS(13547),
    [anon_sym_RPAREN] = ACTIONS(13547),
    [anon_sym_DOT] = ACTIONS(13549),
    [anon_sym_COMMA] = ACTIONS(13547),
    [anon_sym_PIPE] = ACTIONS(13549),
    [anon_sym_SEMI] = ACTIONS(13547),
    [anon_sym_STAR_STAR] = ACTIONS(13549),
    [anon_sym_AMP] = ACTIONS(13549),
    [anon_sym_EQ] = ACTIONS(13549),
    [anon_sym_LT] = ACTIONS(13549),
    [anon_sym_if] = ACTIONS(13547),
    [anon_sym_unless] = ACTIONS(13547),
    [anon_sym_while] = ACTIONS(13547),
    [anon_sym_until] = ACTIONS(13547),
    [anon_sym_rescue] = ACTIONS(13547),
    [anon_sym_in] = ACTIONS(13547),
    [anon_sym_do] = ACTIONS(13547),
    [anon_sym_EQ_GT] = ACTIONS(13547),
    [anon_sym_LBRACK] = ACTIONS(13547),
    [anon_sym_RBRACK] = ACTIONS(13547),
    [anon_sym_COLON_COLON2] = ACTIONS(13547),
    [anon_sym_AMP_DOT] = ACTIONS(13547),
    [anon_sym_PLUS_EQ] = ACTIONS(13547),
    [anon_sym_DASH_EQ] = ACTIONS(13547),
    [anon_sym_STAR_EQ] = ACTIONS(13547),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13547),
    [anon_sym_SLASH_EQ] = ACTIONS(13547),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13547),
    [anon_sym_PIPE_EQ] = ACTIONS(13547),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13547),
    [anon_sym_AMP_EQ] = ACTIONS(13547),
    [anon_sym_PERCENT_EQ] = ACTIONS(13547),
    [anon_sym_GT_GT_EQ] = ACTIONS(13547),
    [anon_sym_LT_LT_EQ] = ACTIONS(13547),
    [anon_sym_CARET_EQ] = ACTIONS(13547),
    [anon_sym_QMARK] = ACTIONS(13547),
    [anon_sym_COLON2] = ACTIONS(13549),
    [anon_sym_DOT_DOT] = ACTIONS(13549),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13547),
    [anon_sym_and] = ACTIONS(13547),
    [anon_sym_or] = ACTIONS(13547),
    [anon_sym_PIPE_PIPE] = ACTIONS(13549),
    [anon_sym_AMP_AMP] = ACTIONS(13549),
    [anon_sym_LT_LT] = ACTIONS(13549),
    [anon_sym_GT_GT] = ACTIONS(13549),
    [anon_sym_EQ_EQ] = ACTIONS(13549),
    [anon_sym_BANG_EQ] = ACTIONS(13547),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13547),
    [anon_sym_LT_EQ_GT] = ACTIONS(13547),
    [anon_sym_EQ_TILDE] = ACTIONS(13547),
    [anon_sym_BANG_TILDE] = ACTIONS(13547),
    [anon_sym_LT_EQ] = ACTIONS(13549),
    [anon_sym_GT] = ACTIONS(13549),
    [anon_sym_GT_EQ] = ACTIONS(13547),
    [anon_sym_CARET] = ACTIONS(13549),
    [anon_sym_PLUS] = ACTIONS(13549),
    [anon_sym_SLASH] = ACTIONS(13549),
    [anon_sym_PERCENT] = ACTIONS(13549),
    [sym_comment] = ACTIONS(87),
  },
  [10238] = {
    [sym__binary_minus] = ACTIONS(7125),
    [sym__binary_star] = ACTIONS(7127),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(7129),
    [anon_sym_STAR_STAR] = ACTIONS(7127),
    [anon_sym_AMP] = ACTIONS(7131),
    [anon_sym_LT] = ACTIONS(7133),
    [anon_sym_EQ_GT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(7135),
    [anon_sym_DOT_DOT] = ACTIONS(7137),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7139),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(7141),
    [anon_sym_AMP_AMP] = ACTIONS(7141),
    [anon_sym_LT_LT] = ACTIONS(7143),
    [anon_sym_GT_GT] = ACTIONS(7143),
    [anon_sym_EQ_EQ] = ACTIONS(7145),
    [anon_sym_BANG_EQ] = ACTIONS(7141),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7141),
    [anon_sym_LT_EQ_GT] = ACTIONS(7141),
    [anon_sym_EQ_TILDE] = ACTIONS(7141),
    [anon_sym_BANG_TILDE] = ACTIONS(7141),
    [anon_sym_LT_EQ] = ACTIONS(7133),
    [anon_sym_GT] = ACTIONS(7133),
    [anon_sym_GT_EQ] = ACTIONS(7147),
    [anon_sym_CARET] = ACTIONS(7149),
    [anon_sym_PLUS] = ACTIONS(7125),
    [anon_sym_SLASH] = ACTIONS(7127),
    [anon_sym_PERCENT] = ACTIONS(7127),
    [sym_comment] = ACTIONS(87),
  },
  [10239] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(10882),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4392),
    [sym_scope_resolution] = STATE(2478),
    [sym_call] = STATE(2478),
    [sym_method_call] = STATE(4392),
    [sym_assignment] = STATE(10882),
    [sym_operator_assignment] = STATE(10882),
    [sym_conditional] = STATE(10882),
    [sym_range] = STATE(10882),
    [sym_binary] = STATE(10882),
    [sym_unary] = STATE(10882),
    [sym_left_assignment_list] = STATE(4391),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4392),
    [sym__variable] = STATE(2478),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4392),
    [sym_false] = STATE(4392),
    [sym_nil] = STATE(4392),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2481),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7174),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4263),
    [anon_sym_yield] = ACTIONS(4265),
    [anon_sym_break] = ACTIONS(4267),
    [anon_sym_next] = ACTIONS(4269),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7176),
    [anon_sym_defined_QMARK] = ACTIONS(7178),
    [anon_sym_not] = ACTIONS(7180),
    [anon_sym_BANG] = ACTIONS(7182),
    [anon_sym_TILDE] = ACTIONS(7182),
    [sym_constant] = ACTIONS(4279),
    [sym_identifier] = ACTIONS(4279),
    [sym_instance_variable] = ACTIONS(4281),
    [sym_class_variable] = ACTIONS(4281),
    [sym_global_variable] = ACTIONS(4281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4279),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4279),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10240] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9057),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4392),
    [sym_scope_resolution] = STATE(2478),
    [sym_call] = STATE(2478),
    [sym_method_call] = STATE(4392),
    [sym_splat_argument] = STATE(9013),
    [sym_assignment] = STATE(9057),
    [sym_operator_assignment] = STATE(9057),
    [sym_conditional] = STATE(9057),
    [sym_range] = STATE(9057),
    [sym_binary] = STATE(9057),
    [sym_unary] = STATE(9057),
    [sym__arg_or_splat_arg] = STATE(9013),
    [sym_left_assignment_list] = STATE(4391),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4392),
    [sym__variable] = STATE(2478),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4392),
    [sym_false] = STATE(4392),
    [sym_nil] = STATE(4392),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(2481),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(3593),
    [sym__unary_minus] = ACTIONS(7174),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4263),
    [anon_sym_yield] = ACTIONS(4265),
    [anon_sym_break] = ACTIONS(4267),
    [anon_sym_next] = ACTIONS(4269),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7176),
    [anon_sym_defined_QMARK] = ACTIONS(7178),
    [anon_sym_not] = ACTIONS(7180),
    [anon_sym_BANG] = ACTIONS(7182),
    [anon_sym_TILDE] = ACTIONS(7182),
    [sym_constant] = ACTIONS(4279),
    [sym_identifier] = ACTIONS(4279),
    [sym_instance_variable] = ACTIONS(4281),
    [sym_class_variable] = ACTIONS(4281),
    [sym_global_variable] = ACTIONS(4281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4279),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4279),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10241] = {
    [aux_sym_exceptions_repeat1] = STATE(10883),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_RPAREN] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(14712),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [10242] = {
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(7190),
    [sym__binary_star] = ACTIONS(7192),
    [anon_sym_RPAREN] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(7194),
    [anon_sym_STAR_STAR] = ACTIONS(7192),
    [anon_sym_AMP] = ACTIONS(7196),
    [anon_sym_LT] = ACTIONS(7198),
    [anon_sym_EQ_GT] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(7200),
    [anon_sym_DOT_DOT] = ACTIONS(7202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7204),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(7206),
    [anon_sym_AMP_AMP] = ACTIONS(7206),
    [anon_sym_LT_LT] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7208),
    [anon_sym_EQ_EQ] = ACTIONS(7210),
    [anon_sym_BANG_EQ] = ACTIONS(7206),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7206),
    [anon_sym_LT_EQ_GT] = ACTIONS(7206),
    [anon_sym_EQ_TILDE] = ACTIONS(7206),
    [anon_sym_BANG_TILDE] = ACTIONS(7206),
    [anon_sym_LT_EQ] = ACTIONS(7198),
    [anon_sym_GT] = ACTIONS(7198),
    [anon_sym_GT_EQ] = ACTIONS(7212),
    [anon_sym_CARET] = ACTIONS(7214),
    [anon_sym_PLUS] = ACTIONS(7190),
    [anon_sym_SLASH] = ACTIONS(7192),
    [anon_sym_PERCENT] = ACTIONS(7192),
    [sym_comment] = ACTIONS(87),
  },
  [10243] = {
    [aux_sym_exceptions_repeat1] = STATE(10243),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_RPAREN] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(14714),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [10244] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(10884),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(4435),
    [sym_scope_resolution] = STATE(4433),
    [sym_call] = STATE(4433),
    [sym_method_call] = STATE(4435),
    [sym_assignment] = STATE(10884),
    [sym_operator_assignment] = STATE(10884),
    [sym_conditional] = STATE(10884),
    [sym_range] = STATE(10884),
    [sym_binary] = STATE(10884),
    [sym_unary] = STATE(10884),
    [sym_left_assignment_list] = STATE(4434),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4435),
    [sym__variable] = STATE(4433),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(4435),
    [sym_false] = STATE(4435),
    [sym_nil] = STATE(4435),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(4436),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(7228),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(7230),
    [anon_sym_yield] = ACTIONS(7232),
    [anon_sym_break] = ACTIONS(7234),
    [anon_sym_next] = ACTIONS(7236),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(7238),
    [anon_sym_defined_QMARK] = ACTIONS(7240),
    [anon_sym_not] = ACTIONS(7242),
    [anon_sym_BANG] = ACTIONS(7244),
    [anon_sym_TILDE] = ACTIONS(7244),
    [sym_constant] = ACTIONS(7246),
    [sym_identifier] = ACTIONS(7246),
    [sym_instance_variable] = ACTIONS(7248),
    [sym_class_variable] = ACTIONS(7248),
    [sym_global_variable] = ACTIONS(7248),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(7246),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(7246),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [10245] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(9074),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(4435),
    [sym_scope_resolution] = STATE(4433),
    [sym_call] = STATE(4433),
    [sym_method_call] = STATE(4435),
    [sym_splat_argument] = STATE(10867),
    [sym_assignment] = STATE(9074),
    [sym_operator_assignment] = STATE(9074),
    [sym_conditional] = STATE(9074),
    [sym_range] = STATE(9074),
    [sym_binary] = STATE(9074),
    [sym_unary] = STATE(9074),
    [sym__arg_or_splat_arg] = STATE(10867),
    [sym_left_assignment_list] = STATE(4434),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4435),
    [sym__variable] = STATE(4433),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(4435),
    [sym_false] = STATE(4435),
    [sym_nil] = STATE(4435),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(4436),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__splat_star] = ACTIONS(3641),
    [sym__unary_minus] = ACTIONS(7228),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(7230),
    [anon_sym_yield] = ACTIONS(7232),
    [anon_sym_break] = ACTIONS(7234),
    [anon_sym_next] = ACTIONS(7236),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(7238),
    [anon_sym_defined_QMARK] = ACTIONS(7240),
    [anon_sym_not] = ACTIONS(7242),
    [anon_sym_BANG] = ACTIONS(7244),
    [anon_sym_TILDE] = ACTIONS(7244),
    [sym_constant] = ACTIONS(7246),
    [sym_identifier] = ACTIONS(7246),
    [sym_instance_variable] = ACTIONS(7248),
    [sym_class_variable] = ACTIONS(7248),
    [sym_global_variable] = ACTIONS(7248),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(7246),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(7246),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [10246] = {
    [aux_sym_exceptions_repeat1] = STATE(10885),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_LBRACE] = ACTIONS(9855),
    [anon_sym_RPAREN] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(14717),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_STAR_STAR] = ACTIONS(9857),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_EQ] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_do] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_PLUS_EQ] = ACTIONS(9855),
    [anon_sym_DASH_EQ] = ACTIONS(9855),
    [anon_sym_STAR_EQ] = ACTIONS(9855),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9855),
    [anon_sym_SLASH_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9855),
    [anon_sym_AMP_EQ] = ACTIONS(9855),
    [anon_sym_PERCENT_EQ] = ACTIONS(9855),
    [anon_sym_GT_GT_EQ] = ACTIONS(9855),
    [anon_sym_LT_LT_EQ] = ACTIONS(9855),
    [anon_sym_CARET_EQ] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9857),
    [anon_sym_AMP_AMP] = ACTIONS(9857),
    [anon_sym_LT_LT] = ACTIONS(9857),
    [anon_sym_GT_GT] = ACTIONS(9857),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9857),
    [anon_sym_PLUS] = ACTIONS(9857),
    [anon_sym_SLASH] = ACTIONS(9857),
    [anon_sym_PERCENT] = ACTIONS(9857),
    [sym_comment] = ACTIONS(87),
  },
  [10247] = {
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(7256),
    [sym__binary_star] = ACTIONS(7258),
    [anon_sym_LBRACE] = ACTIONS(12120),
    [anon_sym_RPAREN] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(7260),
    [anon_sym_STAR_STAR] = ACTIONS(7262),
    [anon_sym_AMP] = ACTIONS(7264),
    [anon_sym_EQ] = ACTIONS(12879),
    [anon_sym_LT] = ACTIONS(7266),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_EQ_GT] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_PLUS_EQ] = ACTIONS(12120),
    [anon_sym_DASH_EQ] = ACTIONS(12120),
    [anon_sym_STAR_EQ] = ACTIONS(12120),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12120),
    [anon_sym_SLASH_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12120),
    [anon_sym_AMP_EQ] = ACTIONS(12120),
    [anon_sym_PERCENT_EQ] = ACTIONS(12120),
    [anon_sym_GT_GT_EQ] = ACTIONS(12120),
    [anon_sym_LT_LT_EQ] = ACTIONS(12120),
    [anon_sym_CARET_EQ] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(7268),
    [anon_sym_DOT_DOT] = ACTIONS(7270),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7272),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(7274),
    [anon_sym_AMP_AMP] = ACTIONS(7274),
    [anon_sym_LT_LT] = ACTIONS(7276),
    [anon_sym_GT_GT] = ACTIONS(7276),
    [anon_sym_EQ_EQ] = ACTIONS(7274),
    [anon_sym_BANG_EQ] = ACTIONS(7278),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7278),
    [anon_sym_LT_EQ_GT] = ACTIONS(7278),
    [anon_sym_EQ_TILDE] = ACTIONS(7278),
    [anon_sym_BANG_TILDE] = ACTIONS(7278),
    [anon_sym_LT_EQ] = ACTIONS(7266),
    [anon_sym_GT] = ACTIONS(7266),
    [anon_sym_GT_EQ] = ACTIONS(7280),
    [anon_sym_CARET] = ACTIONS(7260),
    [anon_sym_PLUS] = ACTIONS(7282),
    [anon_sym_SLASH] = ACTIONS(7262),
    [anon_sym_PERCENT] = ACTIONS(7262),
    [sym_comment] = ACTIONS(87),
  },
  [10248] = {
    [aux_sym_exceptions_repeat1] = STATE(10248),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_RPAREN] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(14719),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_PLUS_EQ] = ACTIONS(11597),
    [anon_sym_DASH_EQ] = ACTIONS(11597),
    [anon_sym_STAR_EQ] = ACTIONS(11597),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11597),
    [anon_sym_SLASH_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11597),
    [anon_sym_AMP_EQ] = ACTIONS(11597),
    [anon_sym_PERCENT_EQ] = ACTIONS(11597),
    [anon_sym_GT_GT_EQ] = ACTIONS(11597),
    [anon_sym_LT_LT_EQ] = ACTIONS(11597),
    [anon_sym_CARET_EQ] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_LT] = ACTIONS(12338),
    [anon_sym_GT_GT] = ACTIONS(12338),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(12338),
    [anon_sym_PLUS] = ACTIONS(12338),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [10249] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(10886),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(4471),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(4471),
    [sym_assignment] = STATE(10886),
    [sym_operator_assignment] = STATE(10886),
    [sym_conditional] = STATE(10886),
    [sym_range] = STATE(10886),
    [sym_binary] = STATE(10886),
    [sym_unary] = STATE(10886),
    [sym_left_assignment_list] = STATE(4470),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4471),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(4471),
    [sym_false] = STATE(4471),
    [sym_nil] = STATE(4471),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(4472),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(7296),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7298),
    [anon_sym_yield] = ACTIONS(7300),
    [anon_sym_break] = ACTIONS(7302),
    [anon_sym_next] = ACTIONS(7304),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7306),
    [anon_sym_defined_QMARK] = ACTIONS(7308),
    [anon_sym_not] = ACTIONS(7310),
    [anon_sym_BANG] = ACTIONS(7312),
    [anon_sym_TILDE] = ACTIONS(7312),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [10250] = {
    [sym__line_break] = ACTIONS(12029),
    [sym__heredoc_body_start] = ACTIONS(12029),
    [anon_sym_DOT] = ACTIONS(12029),
    [anon_sym_COMMA] = ACTIONS(12029),
    [anon_sym_SEMI] = ACTIONS(12029),
    [anon_sym_then] = ACTIONS(12029),
    [anon_sym_LBRACK] = ACTIONS(12029),
    [anon_sym_COLON_COLON2] = ACTIONS(12029),
    [anon_sym_AMP_DOT] = ACTIONS(12029),
    [sym_comment] = ACTIONS(87),
  },
  [10251] = {
    [sym__line_break] = ACTIONS(12054),
    [sym__heredoc_body_start] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_SEMI] = ACTIONS(12054),
    [anon_sym_then] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_COLON_COLON2] = ACTIONS(12054),
    [anon_sym_AMP_DOT] = ACTIONS(12054),
    [sym_comment] = ACTIONS(87),
  },
  [10252] = {
    [anon_sym_end] = ACTIONS(14722),
    [sym_comment] = ACTIONS(87),
  },
  [10253] = {
    [sym__statements] = STATE(10888),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(14724),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10254] = {
    [sym__line_break] = ACTIONS(13704),
    [sym__heredoc_body_start] = ACTIONS(13704),
    [anon_sym_COMMA] = ACTIONS(13704),
    [anon_sym_SEMI] = ACTIONS(13704),
    [sym_comment] = ACTIONS(87),
  },
  [10255] = {
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(10700),
    [sym__binary_star] = ACTIONS(10702),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_RPAREN] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(10704),
    [anon_sym_STAR_STAR] = ACTIONS(10702),
    [anon_sym_AMP] = ACTIONS(10706),
    [anon_sym_EQ] = ACTIONS(7822),
    [anon_sym_LT] = ACTIONS(10708),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(10710),
    [anon_sym_DOT_DOT] = ACTIONS(10712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10714),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(10718),
    [anon_sym_AMP_AMP] = ACTIONS(10718),
    [anon_sym_LT_LT] = ACTIONS(10720),
    [anon_sym_GT_GT] = ACTIONS(10720),
    [anon_sym_EQ_EQ] = ACTIONS(10722),
    [anon_sym_BANG_EQ] = ACTIONS(10718),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10718),
    [anon_sym_LT_EQ_GT] = ACTIONS(10718),
    [anon_sym_EQ_TILDE] = ACTIONS(10718),
    [anon_sym_BANG_TILDE] = ACTIONS(10718),
    [anon_sym_LT_EQ] = ACTIONS(10708),
    [anon_sym_GT] = ACTIONS(10708),
    [anon_sym_GT_EQ] = ACTIONS(10724),
    [anon_sym_CARET] = ACTIONS(10726),
    [anon_sym_PLUS] = ACTIONS(10700),
    [anon_sym_SLASH] = ACTIONS(10702),
    [anon_sym_PERCENT] = ACTIONS(10702),
    [sym_comment] = ACTIONS(87),
  },
  [10256] = {
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(10700),
    [sym__binary_star] = ACTIONS(10702),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_RPAREN] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(10704),
    [anon_sym_STAR_STAR] = ACTIONS(10702),
    [anon_sym_AMP] = ACTIONS(10706),
    [anon_sym_EQ] = ACTIONS(7884),
    [anon_sym_LT] = ACTIONS(10708),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(10710),
    [anon_sym_DOT_DOT] = ACTIONS(10712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10714),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(10718),
    [anon_sym_AMP_AMP] = ACTIONS(10718),
    [anon_sym_LT_LT] = ACTIONS(10720),
    [anon_sym_GT_GT] = ACTIONS(10720),
    [anon_sym_EQ_EQ] = ACTIONS(10722),
    [anon_sym_BANG_EQ] = ACTIONS(10718),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10718),
    [anon_sym_LT_EQ_GT] = ACTIONS(10718),
    [anon_sym_EQ_TILDE] = ACTIONS(10718),
    [anon_sym_BANG_TILDE] = ACTIONS(10718),
    [anon_sym_LT_EQ] = ACTIONS(10708),
    [anon_sym_GT] = ACTIONS(10708),
    [anon_sym_GT_EQ] = ACTIONS(10724),
    [anon_sym_CARET] = ACTIONS(10726),
    [anon_sym_PLUS] = ACTIONS(10700),
    [anon_sym_SLASH] = ACTIONS(10702),
    [anon_sym_PERCENT] = ACTIONS(10702),
    [sym_comment] = ACTIONS(87),
  },
  [10257] = {
    [sym_heredoc_body] = STATE(10257),
    [aux_sym_call_repeat1] = STATE(10257),
    [sym__heredoc_body_start] = ACTIONS(14032),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_RPAREN] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_EQ] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [10258] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(7096),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(2125),
    [sym_scope_resolution] = STATE(2088),
    [sym_call] = STATE(2088),
    [sym_method_call] = STATE(2125),
    [sym__argument] = STATE(10299),
    [sym_splat_argument] = STATE(10299),
    [sym_hash_splat_argument] = STATE(10299),
    [sym_block_argument] = STATE(10299),
    [sym_assignment] = STATE(7096),
    [sym_operator_assignment] = STATE(7096),
    [sym_conditional] = STATE(7096),
    [sym_range] = STATE(7096),
    [sym_binary] = STATE(7096),
    [sym_unary] = STATE(7096),
    [sym_left_assignment_list] = STATE(2124),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(2125),
    [sym__variable] = STATE(2088),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(2125),
    [sym_false] = STATE(2125),
    [sym_nil] = STATE(2125),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(7099),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(10299),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(10692),
    [sym__splat_star] = ACTIONS(10694),
    [sym__unary_minus] = ACTIONS(3705),
    [sym__identifier_hash_key] = ACTIONS(10696),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13981),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3713),
    [anon_sym_break] = ACTIONS(3715),
    [anon_sym_next] = ACTIONS(3717),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3719),
    [anon_sym_defined_QMARK] = ACTIONS(3721),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [sym_constant] = ACTIONS(10698),
    [sym_identifier] = ACTIONS(10698),
    [sym_instance_variable] = ACTIONS(3665),
    [sym_class_variable] = ACTIONS(3665),
    [sym_global_variable] = ACTIONS(3665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3667),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10259] = {
    [sym_heredoc_body] = STATE(10257),
    [aux_sym_call_repeat1] = STATE(10257),
    [sym__heredoc_body_start] = ACTIONS(10884),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_RPAREN] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_EQ] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [10260] = {
    [aux_sym_argument_list_repeat1] = STATE(10260),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_RPAREN] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(14726),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_STAR_STAR] = ACTIONS(7925),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_EQ] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7925),
    [anon_sym_AMP_AMP] = ACTIONS(7925),
    [anon_sym_LT_LT] = ACTIONS(7925),
    [anon_sym_GT_GT] = ACTIONS(7925),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7925),
    [anon_sym_PLUS] = ACTIONS(7925),
    [anon_sym_SLASH] = ACTIONS(7925),
    [anon_sym_PERCENT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [10261] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(10889),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4495),
    [sym_scope_resolution] = STATE(4433),
    [sym_call] = STATE(4433),
    [sym_method_call] = STATE(4495),
    [sym_assignment] = STATE(10889),
    [sym_operator_assignment] = STATE(10889),
    [sym_conditional] = STATE(10889),
    [sym_range] = STATE(10889),
    [sym_binary] = STATE(10889),
    [sym_unary] = STATE(10889),
    [sym_left_assignment_list] = STATE(4494),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4495),
    [sym__variable] = STATE(4433),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4495),
    [sym_false] = STATE(4495),
    [sym_nil] = STATE(4495),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(4496),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(4005),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(4009),
    [sym__subshell_start] = ACTIONS(4011),
    [sym__regex_start] = ACTIONS(4013),
    [sym__string_array_start] = ACTIONS(4015),
    [sym__symbol_array_start] = ACTIONS(4017),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7336),
    [anon_sym_LBRACE] = ACTIONS(4021),
    [anon_sym_def] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4025),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(4027),
    [anon_sym_module] = ACTIONS(4029),
    [anon_sym_return] = ACTIONS(7338),
    [anon_sym_yield] = ACTIONS(7340),
    [anon_sym_break] = ACTIONS(7342),
    [anon_sym_next] = ACTIONS(7344),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(4039),
    [anon_sym_unless] = ACTIONS(4041),
    [anon_sym_while] = ACTIONS(4043),
    [anon_sym_until] = ACTIONS(4045),
    [anon_sym_for] = ACTIONS(4047),
    [anon_sym_case] = ACTIONS(4049),
    [anon_sym_begin] = ACTIONS(4051),
    [anon_sym_PLUS] = ACTIONS(7346),
    [anon_sym_defined_QMARK] = ACTIONS(7348),
    [anon_sym_not] = ACTIONS(7350),
    [anon_sym_BANG] = ACTIONS(7352),
    [anon_sym_TILDE] = ACTIONS(7352),
    [sym_constant] = ACTIONS(7246),
    [sym_identifier] = ACTIONS(7246),
    [sym_instance_variable] = ACTIONS(7248),
    [sym_class_variable] = ACTIONS(7248),
    [sym_global_variable] = ACTIONS(7248),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4065),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(7246),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(7246),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(4067),
    [anon_sym_DASH_GT] = ACTIONS(4069),
  },
  [10262] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9124),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(4495),
    [sym_scope_resolution] = STATE(4433),
    [sym_call] = STATE(4433),
    [sym_method_call] = STATE(4495),
    [sym_splat_argument] = STATE(10316),
    [sym_assignment] = STATE(9124),
    [sym_operator_assignment] = STATE(9124),
    [sym_conditional] = STATE(9124),
    [sym_range] = STATE(9124),
    [sym_binary] = STATE(9124),
    [sym_unary] = STATE(9124),
    [sym__arg_or_splat_arg] = STATE(10316),
    [sym_left_assignment_list] = STATE(4494),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(4495),
    [sym__variable] = STATE(4433),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(4495),
    [sym_false] = STATE(4495),
    [sym_nil] = STATE(4495),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(4496),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(4005),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(4009),
    [sym__subshell_start] = ACTIONS(4011),
    [sym__regex_start] = ACTIONS(4013),
    [sym__string_array_start] = ACTIONS(4015),
    [sym__symbol_array_start] = ACTIONS(4017),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(10694),
    [sym__unary_minus] = ACTIONS(7336),
    [anon_sym_LBRACE] = ACTIONS(4021),
    [anon_sym_def] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4025),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(4027),
    [anon_sym_module] = ACTIONS(4029),
    [anon_sym_return] = ACTIONS(7338),
    [anon_sym_yield] = ACTIONS(7340),
    [anon_sym_break] = ACTIONS(7342),
    [anon_sym_next] = ACTIONS(7344),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(4039),
    [anon_sym_unless] = ACTIONS(4041),
    [anon_sym_while] = ACTIONS(4043),
    [anon_sym_until] = ACTIONS(4045),
    [anon_sym_for] = ACTIONS(4047),
    [anon_sym_case] = ACTIONS(4049),
    [anon_sym_begin] = ACTIONS(4051),
    [anon_sym_PLUS] = ACTIONS(7346),
    [anon_sym_defined_QMARK] = ACTIONS(7348),
    [anon_sym_not] = ACTIONS(7350),
    [anon_sym_BANG] = ACTIONS(7352),
    [anon_sym_TILDE] = ACTIONS(7352),
    [sym_constant] = ACTIONS(7246),
    [sym_identifier] = ACTIONS(7246),
    [sym_instance_variable] = ACTIONS(7248),
    [sym_class_variable] = ACTIONS(7248),
    [sym_global_variable] = ACTIONS(7248),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4065),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(7246),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(7246),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(4067),
    [anon_sym_DASH_GT] = ACTIONS(4069),
  },
  [10263] = {
    [aux_sym_exceptions_repeat1] = STATE(10890),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_LBRACE] = ACTIONS(9855),
    [anon_sym_RPAREN] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(14729),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_EQ] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_do] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [10264] = {
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(7368),
    [sym__binary_star] = ACTIONS(7370),
    [anon_sym_LBRACE] = ACTIONS(12120),
    [anon_sym_RPAREN] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(7372),
    [anon_sym_STAR_STAR] = ACTIONS(7370),
    [anon_sym_AMP] = ACTIONS(7374),
    [anon_sym_EQ] = ACTIONS(12879),
    [anon_sym_LT] = ACTIONS(7376),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_EQ_GT] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(7378),
    [anon_sym_DOT_DOT] = ACTIONS(7380),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7382),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(7386),
    [anon_sym_AMP_AMP] = ACTIONS(7386),
    [anon_sym_LT_LT] = ACTIONS(7388),
    [anon_sym_GT_GT] = ACTIONS(7388),
    [anon_sym_EQ_EQ] = ACTIONS(7390),
    [anon_sym_BANG_EQ] = ACTIONS(7386),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7386),
    [anon_sym_LT_EQ_GT] = ACTIONS(7386),
    [anon_sym_EQ_TILDE] = ACTIONS(7386),
    [anon_sym_BANG_TILDE] = ACTIONS(7386),
    [anon_sym_LT_EQ] = ACTIONS(7376),
    [anon_sym_GT] = ACTIONS(7376),
    [anon_sym_GT_EQ] = ACTIONS(7392),
    [anon_sym_CARET] = ACTIONS(7394),
    [anon_sym_PLUS] = ACTIONS(7368),
    [anon_sym_SLASH] = ACTIONS(7370),
    [anon_sym_PERCENT] = ACTIONS(7370),
    [sym_comment] = ACTIONS(87),
  },
  [10265] = {
    [aux_sym_exceptions_repeat1] = STATE(10265),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_RPAREN] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(14731),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [10266] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(7406),
    [sym__binary_star] = ACTIONS(7408),
    [anon_sym_RPAREN] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(7410),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(7408),
    [anon_sym_AMP] = ACTIONS(7412),
    [anon_sym_LT] = ACTIONS(7414),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(7416),
    [anon_sym_DOT_DOT] = ACTIONS(7418),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7420),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(7422),
    [anon_sym_AMP_AMP] = ACTIONS(7422),
    [anon_sym_LT_LT] = ACTIONS(7424),
    [anon_sym_GT_GT] = ACTIONS(7424),
    [anon_sym_EQ_EQ] = ACTIONS(7426),
    [anon_sym_BANG_EQ] = ACTIONS(7422),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7422),
    [anon_sym_LT_EQ_GT] = ACTIONS(7422),
    [anon_sym_EQ_TILDE] = ACTIONS(7422),
    [anon_sym_BANG_TILDE] = ACTIONS(7422),
    [anon_sym_LT_EQ] = ACTIONS(7414),
    [anon_sym_GT] = ACTIONS(7414),
    [anon_sym_GT_EQ] = ACTIONS(7428),
    [anon_sym_CARET] = ACTIONS(7430),
    [anon_sym_PLUS] = ACTIONS(7406),
    [anon_sym_SLASH] = ACTIONS(7408),
    [anon_sym_PERCENT] = ACTIONS(7408),
    [sym_comment] = ACTIONS(87),
  },
  [10267] = {
    [aux_sym_exceptions_repeat1] = STATE(10267),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_RPAREN] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(14734),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [10268] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(7458),
    [sym__binary_star] = ACTIONS(7460),
    [anon_sym_LBRACE] = ACTIONS(12120),
    [anon_sym_RPAREN] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(7462),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(7464),
    [anon_sym_AMP] = ACTIONS(7466),
    [anon_sym_EQ] = ACTIONS(12879),
    [anon_sym_LT] = ACTIONS(7468),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_PLUS_EQ] = ACTIONS(12120),
    [anon_sym_DASH_EQ] = ACTIONS(12120),
    [anon_sym_STAR_EQ] = ACTIONS(12120),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12120),
    [anon_sym_SLASH_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12120),
    [anon_sym_AMP_EQ] = ACTIONS(12120),
    [anon_sym_PERCENT_EQ] = ACTIONS(12120),
    [anon_sym_GT_GT_EQ] = ACTIONS(12120),
    [anon_sym_LT_LT_EQ] = ACTIONS(12120),
    [anon_sym_CARET_EQ] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(7470),
    [anon_sym_DOT_DOT] = ACTIONS(7472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7474),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(7476),
    [anon_sym_AMP_AMP] = ACTIONS(7476),
    [anon_sym_LT_LT] = ACTIONS(7478),
    [anon_sym_GT_GT] = ACTIONS(7478),
    [anon_sym_EQ_EQ] = ACTIONS(7476),
    [anon_sym_BANG_EQ] = ACTIONS(7480),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7480),
    [anon_sym_LT_EQ_GT] = ACTIONS(7480),
    [anon_sym_EQ_TILDE] = ACTIONS(7480),
    [anon_sym_BANG_TILDE] = ACTIONS(7480),
    [anon_sym_LT_EQ] = ACTIONS(7468),
    [anon_sym_GT] = ACTIONS(7468),
    [anon_sym_GT_EQ] = ACTIONS(7482),
    [anon_sym_CARET] = ACTIONS(7462),
    [anon_sym_PLUS] = ACTIONS(7484),
    [anon_sym_SLASH] = ACTIONS(7464),
    [anon_sym_PERCENT] = ACTIONS(7464),
    [sym_comment] = ACTIONS(87),
  },
  [10269] = {
    [aux_sym_exceptions_repeat1] = STATE(10269),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_RPAREN] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(14737),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_PLUS_EQ] = ACTIONS(11597),
    [anon_sym_DASH_EQ] = ACTIONS(11597),
    [anon_sym_STAR_EQ] = ACTIONS(11597),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11597),
    [anon_sym_SLASH_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11597),
    [anon_sym_AMP_EQ] = ACTIONS(11597),
    [anon_sym_PERCENT_EQ] = ACTIONS(11597),
    [anon_sym_GT_GT_EQ] = ACTIONS(11597),
    [anon_sym_LT_LT_EQ] = ACTIONS(11597),
    [anon_sym_CARET_EQ] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_LT] = ACTIONS(12338),
    [anon_sym_GT_GT] = ACTIONS(12338),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(12338),
    [anon_sym_PLUS] = ACTIONS(12338),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [10270] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(7494),
    [sym__binary_star] = ACTIONS(7496),
    [anon_sym_RPAREN] = ACTIONS(12120),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(7498),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(7496),
    [anon_sym_AMP] = ACTIONS(7500),
    [anon_sym_LT] = ACTIONS(7502),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(7504),
    [anon_sym_DOT_DOT] = ACTIONS(7506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7508),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(7510),
    [anon_sym_AMP_AMP] = ACTIONS(7510),
    [anon_sym_LT_LT] = ACTIONS(7512),
    [anon_sym_GT_GT] = ACTIONS(7512),
    [anon_sym_EQ_EQ] = ACTIONS(7514),
    [anon_sym_BANG_EQ] = ACTIONS(7510),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7510),
    [anon_sym_LT_EQ_GT] = ACTIONS(7510),
    [anon_sym_EQ_TILDE] = ACTIONS(7510),
    [anon_sym_BANG_TILDE] = ACTIONS(7510),
    [anon_sym_LT_EQ] = ACTIONS(7502),
    [anon_sym_GT] = ACTIONS(7502),
    [anon_sym_GT_EQ] = ACTIONS(7516),
    [anon_sym_CARET] = ACTIONS(7518),
    [anon_sym_PLUS] = ACTIONS(7494),
    [anon_sym_SLASH] = ACTIONS(7496),
    [anon_sym_PERCENT] = ACTIONS(7496),
    [sym_comment] = ACTIONS(87),
  },
  [10271] = {
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(7575),
    [sym__binary_star] = ACTIONS(7577),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(7579),
    [anon_sym_STAR_STAR] = ACTIONS(7577),
    [anon_sym_AMP] = ACTIONS(7581),
    [anon_sym_LT] = ACTIONS(7583),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(7585),
    [anon_sym_DOT_DOT] = ACTIONS(7587),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7589),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(7593),
    [anon_sym_AMP_AMP] = ACTIONS(7593),
    [anon_sym_LT_LT] = ACTIONS(7595),
    [anon_sym_GT_GT] = ACTIONS(7595),
    [anon_sym_EQ_EQ] = ACTIONS(7597),
    [anon_sym_BANG_EQ] = ACTIONS(7593),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7593),
    [anon_sym_LT_EQ_GT] = ACTIONS(7593),
    [anon_sym_EQ_TILDE] = ACTIONS(7593),
    [anon_sym_BANG_TILDE] = ACTIONS(7593),
    [anon_sym_LT_EQ] = ACTIONS(7583),
    [anon_sym_GT] = ACTIONS(7583),
    [anon_sym_GT_EQ] = ACTIONS(7599),
    [anon_sym_CARET] = ACTIONS(7601),
    [anon_sym_PLUS] = ACTIONS(7575),
    [anon_sym_SLASH] = ACTIONS(7577),
    [anon_sym_PERCENT] = ACTIONS(7577),
    [sym_comment] = ACTIONS(87),
  },
  [10272] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(12732),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(12736),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(12736),
    [anon_sym_PERCENT] = ACTIONS(12736),
    [sym_comment] = ACTIONS(87),
  },
  [10273] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(12736),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(5827),
    [anon_sym_PERCENT] = ACTIONS(5827),
    [sym_comment] = ACTIONS(87),
  },
  [10274] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12730),
    [sym__binary_star] = ACTIONS(12732),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(12736),
    [anon_sym_AMP] = ACTIONS(12738),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(12750),
    [anon_sym_GT_GT] = ACTIONS(12750),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(12756),
    [anon_sym_SLASH] = ACTIONS(12736),
    [anon_sym_PERCENT] = ACTIONS(12736),
    [sym_comment] = ACTIONS(87),
  },
  [10275] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12730),
    [sym__binary_star] = ACTIONS(12732),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(12736),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(12750),
    [anon_sym_GT_GT] = ACTIONS(12750),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(12756),
    [anon_sym_SLASH] = ACTIONS(12736),
    [anon_sym_PERCENT] = ACTIONS(12736),
    [sym_comment] = ACTIONS(87),
  },
  [10276] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12730),
    [sym__binary_star] = ACTIONS(12732),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(12734),
    [anon_sym_STAR_STAR] = ACTIONS(12736),
    [anon_sym_AMP] = ACTIONS(12738),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(12750),
    [anon_sym_GT_GT] = ACTIONS(12750),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(12734),
    [anon_sym_PLUS] = ACTIONS(12756),
    [anon_sym_SLASH] = ACTIONS(12736),
    [anon_sym_PERCENT] = ACTIONS(12736),
    [sym_comment] = ACTIONS(87),
  },
  [10277] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(14740),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [10278] = {
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(12730),
    [sym__binary_star] = ACTIONS(12732),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(12734),
    [anon_sym_STAR_STAR] = ACTIONS(12736),
    [anon_sym_AMP] = ACTIONS(12738),
    [anon_sym_EQ] = ACTIONS(7888),
    [anon_sym_LT] = ACTIONS(12740),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_PLUS_EQ] = ACTIONS(5927),
    [anon_sym_DASH_EQ] = ACTIONS(5927),
    [anon_sym_STAR_EQ] = ACTIONS(5927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5927),
    [anon_sym_SLASH_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5927),
    [anon_sym_AMP_EQ] = ACTIONS(5927),
    [anon_sym_PERCENT_EQ] = ACTIONS(5927),
    [anon_sym_GT_GT_EQ] = ACTIONS(5927),
    [anon_sym_LT_LT_EQ] = ACTIONS(5927),
    [anon_sym_CARET_EQ] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(12744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12746),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(12748),
    [anon_sym_AMP_AMP] = ACTIONS(12748),
    [anon_sym_LT_LT] = ACTIONS(12750),
    [anon_sym_GT_GT] = ACTIONS(12750),
    [anon_sym_EQ_EQ] = ACTIONS(12748),
    [anon_sym_BANG_EQ] = ACTIONS(12752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12752),
    [anon_sym_LT_EQ_GT] = ACTIONS(12752),
    [anon_sym_EQ_TILDE] = ACTIONS(12752),
    [anon_sym_BANG_TILDE] = ACTIONS(12752),
    [anon_sym_LT_EQ] = ACTIONS(12740),
    [anon_sym_GT] = ACTIONS(12740),
    [anon_sym_GT_EQ] = ACTIONS(12754),
    [anon_sym_CARET] = ACTIONS(12734),
    [anon_sym_PLUS] = ACTIONS(12756),
    [anon_sym_SLASH] = ACTIONS(12736),
    [anon_sym_PERCENT] = ACTIONS(12736),
    [sym_comment] = ACTIONS(87),
  },
  [10279] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12730),
    [sym__binary_star] = ACTIONS(12732),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(12734),
    [anon_sym_STAR_STAR] = ACTIONS(12736),
    [anon_sym_AMP] = ACTIONS(12738),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(12740),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(12742),
    [anon_sym_DOT_DOT] = ACTIONS(12744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12746),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(12748),
    [anon_sym_AMP_AMP] = ACTIONS(12748),
    [anon_sym_LT_LT] = ACTIONS(12750),
    [anon_sym_GT_GT] = ACTIONS(12750),
    [anon_sym_EQ_EQ] = ACTIONS(12748),
    [anon_sym_BANG_EQ] = ACTIONS(12752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12752),
    [anon_sym_LT_EQ_GT] = ACTIONS(12752),
    [anon_sym_EQ_TILDE] = ACTIONS(12752),
    [anon_sym_BANG_TILDE] = ACTIONS(12752),
    [anon_sym_LT_EQ] = ACTIONS(12740),
    [anon_sym_GT] = ACTIONS(12740),
    [anon_sym_GT_EQ] = ACTIONS(12754),
    [anon_sym_CARET] = ACTIONS(12734),
    [anon_sym_PLUS] = ACTIONS(12756),
    [anon_sym_SLASH] = ACTIONS(12736),
    [anon_sym_PERCENT] = ACTIONS(12736),
    [sym_comment] = ACTIONS(87),
  },
  [10280] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12730),
    [sym__binary_star] = ACTIONS(12732),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(12734),
    [anon_sym_STAR_STAR] = ACTIONS(12736),
    [anon_sym_AMP] = ACTIONS(12738),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(12740),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(12750),
    [anon_sym_GT_GT] = ACTIONS(12750),
    [anon_sym_EQ_EQ] = ACTIONS(12748),
    [anon_sym_BANG_EQ] = ACTIONS(12752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12752),
    [anon_sym_LT_EQ_GT] = ACTIONS(12752),
    [anon_sym_EQ_TILDE] = ACTIONS(12752),
    [anon_sym_BANG_TILDE] = ACTIONS(12752),
    [anon_sym_LT_EQ] = ACTIONS(12740),
    [anon_sym_GT] = ACTIONS(12740),
    [anon_sym_GT_EQ] = ACTIONS(12754),
    [anon_sym_CARET] = ACTIONS(12734),
    [anon_sym_PLUS] = ACTIONS(12756),
    [anon_sym_SLASH] = ACTIONS(12736),
    [anon_sym_PERCENT] = ACTIONS(12736),
    [sym_comment] = ACTIONS(87),
  },
  [10281] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12730),
    [sym__binary_star] = ACTIONS(12732),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(12736),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(12756),
    [anon_sym_SLASH] = ACTIONS(12736),
    [anon_sym_PERCENT] = ACTIONS(12736),
    [sym_comment] = ACTIONS(87),
  },
  [10282] = {
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(12730),
    [sym__binary_star] = ACTIONS(12732),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(12734),
    [anon_sym_STAR_STAR] = ACTIONS(12736),
    [anon_sym_AMP] = ACTIONS(12738),
    [anon_sym_EQ] = ACTIONS(7936),
    [anon_sym_LT] = ACTIONS(12740),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_PLUS_EQ] = ACTIONS(5115),
    [anon_sym_DASH_EQ] = ACTIONS(5115),
    [anon_sym_STAR_EQ] = ACTIONS(5115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5115),
    [anon_sym_SLASH_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5115),
    [anon_sym_AMP_EQ] = ACTIONS(5115),
    [anon_sym_PERCENT_EQ] = ACTIONS(5115),
    [anon_sym_GT_GT_EQ] = ACTIONS(5115),
    [anon_sym_LT_LT_EQ] = ACTIONS(5115),
    [anon_sym_CARET_EQ] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(12742),
    [anon_sym_DOT_DOT] = ACTIONS(12744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12746),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(12748),
    [anon_sym_AMP_AMP] = ACTIONS(12748),
    [anon_sym_LT_LT] = ACTIONS(12750),
    [anon_sym_GT_GT] = ACTIONS(12750),
    [anon_sym_EQ_EQ] = ACTIONS(12748),
    [anon_sym_BANG_EQ] = ACTIONS(12752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12752),
    [anon_sym_LT_EQ_GT] = ACTIONS(12752),
    [anon_sym_EQ_TILDE] = ACTIONS(12752),
    [anon_sym_BANG_TILDE] = ACTIONS(12752),
    [anon_sym_LT_EQ] = ACTIONS(12740),
    [anon_sym_GT] = ACTIONS(12740),
    [anon_sym_GT_EQ] = ACTIONS(12754),
    [anon_sym_CARET] = ACTIONS(12734),
    [anon_sym_PLUS] = ACTIONS(12756),
    [anon_sym_SLASH] = ACTIONS(12736),
    [anon_sym_PERCENT] = ACTIONS(12736),
    [sym_comment] = ACTIONS(87),
  },
  [10283] = {
    [aux_sym_exceptions_repeat1] = STATE(10893),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_STAR_STAR] = ACTIONS(6193),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_PLUS_EQ] = ACTIONS(6191),
    [anon_sym_DASH_EQ] = ACTIONS(6191),
    [anon_sym_STAR_EQ] = ACTIONS(6191),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6191),
    [anon_sym_SLASH_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6191),
    [anon_sym_AMP_EQ] = ACTIONS(6191),
    [anon_sym_PERCENT_EQ] = ACTIONS(6191),
    [anon_sym_GT_GT_EQ] = ACTIONS(6191),
    [anon_sym_LT_LT_EQ] = ACTIONS(6191),
    [anon_sym_CARET_EQ] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6193),
    [anon_sym_AMP_AMP] = ACTIONS(6193),
    [anon_sym_LT_LT] = ACTIONS(6193),
    [anon_sym_GT_GT] = ACTIONS(6193),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6193),
    [anon_sym_PLUS] = ACTIONS(6193),
    [anon_sym_SLASH] = ACTIONS(6193),
    [anon_sym_PERCENT] = ACTIONS(6193),
    [sym_comment] = ACTIONS(87),
  },
  [10284] = {
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(12730),
    [sym__binary_star] = ACTIONS(12732),
    [anon_sym_LBRACE] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(12734),
    [anon_sym_STAR_STAR] = ACTIONS(12736),
    [anon_sym_AMP] = ACTIONS(12738),
    [anon_sym_EQ] = ACTIONS(7938),
    [anon_sym_LT] = ACTIONS(12740),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_PLUS_EQ] = ACTIONS(6210),
    [anon_sym_DASH_EQ] = ACTIONS(6210),
    [anon_sym_STAR_EQ] = ACTIONS(6210),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6210),
    [anon_sym_SLASH_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6210),
    [anon_sym_AMP_EQ] = ACTIONS(6210),
    [anon_sym_PERCENT_EQ] = ACTIONS(6210),
    [anon_sym_GT_GT_EQ] = ACTIONS(6210),
    [anon_sym_LT_LT_EQ] = ACTIONS(6210),
    [anon_sym_CARET_EQ] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(12742),
    [anon_sym_DOT_DOT] = ACTIONS(12744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12746),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(12748),
    [anon_sym_AMP_AMP] = ACTIONS(12748),
    [anon_sym_LT_LT] = ACTIONS(12750),
    [anon_sym_GT_GT] = ACTIONS(12750),
    [anon_sym_EQ_EQ] = ACTIONS(12748),
    [anon_sym_BANG_EQ] = ACTIONS(12752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12752),
    [anon_sym_LT_EQ_GT] = ACTIONS(12752),
    [anon_sym_EQ_TILDE] = ACTIONS(12752),
    [anon_sym_BANG_TILDE] = ACTIONS(12752),
    [anon_sym_LT_EQ] = ACTIONS(12740),
    [anon_sym_GT] = ACTIONS(12740),
    [anon_sym_GT_EQ] = ACTIONS(12754),
    [anon_sym_CARET] = ACTIONS(12734),
    [anon_sym_PLUS] = ACTIONS(12756),
    [anon_sym_SLASH] = ACTIONS(12736),
    [anon_sym_PERCENT] = ACTIONS(12736),
    [sym_comment] = ACTIONS(87),
  },
  [10285] = {
    [sym_string] = STATE(10285),
    [aux_sym_chained_string_repeat1] = STATE(10285),
    [sym__string_start] = ACTIONS(13881),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_STAR_STAR] = ACTIONS(6217),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_EQ] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_do] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_PLUS_EQ] = ACTIONS(6212),
    [anon_sym_DASH_EQ] = ACTIONS(6212),
    [anon_sym_STAR_EQ] = ACTIONS(6212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6212),
    [anon_sym_SLASH_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6212),
    [anon_sym_AMP_EQ] = ACTIONS(6212),
    [anon_sym_PERCENT_EQ] = ACTIONS(6212),
    [anon_sym_GT_GT_EQ] = ACTIONS(6212),
    [anon_sym_LT_LT_EQ] = ACTIONS(6212),
    [anon_sym_CARET_EQ] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6217),
    [anon_sym_AMP_AMP] = ACTIONS(6217),
    [anon_sym_LT_LT] = ACTIONS(6217),
    [anon_sym_GT_GT] = ACTIONS(6217),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6217),
    [anon_sym_PLUS] = ACTIONS(6217),
    [anon_sym_SLASH] = ACTIONS(6217),
    [anon_sym_PERCENT] = ACTIONS(6217),
    [sym_comment] = ACTIONS(87),
  },
  [10286] = {
    [aux_sym_exceptions_repeat1] = STATE(10286),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(14742),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [10287] = {
    [anon_sym_DOT] = ACTIONS(14151),
    [anon_sym_LBRACK] = ACTIONS(14151),
    [anon_sym_COLON_COLON2] = ACTIONS(14151),
    [anon_sym_AMP_DOT] = ACTIONS(14151),
    [sym_comment] = ACTIONS(87),
  },
  [10288] = {
    [anon_sym_LBRACE] = ACTIONS(14580),
    [anon_sym_RPAREN] = ACTIONS(14580),
    [anon_sym_DOT] = ACTIONS(14580),
    [anon_sym_COMMA] = ACTIONS(14580),
    [anon_sym_PIPE] = ACTIONS(14580),
    [anon_sym_SEMI] = ACTIONS(14580),
    [anon_sym_EQ] = ACTIONS(14580),
    [anon_sym_in] = ACTIONS(14580),
    [anon_sym_do] = ACTIONS(14580),
    [anon_sym_LBRACK] = ACTIONS(14580),
    [anon_sym_COLON_COLON2] = ACTIONS(14580),
    [anon_sym_AMP_DOT] = ACTIONS(14580),
    [sym_comment] = ACTIONS(87),
  },
  [10289] = {
    [sym__heredoc_body_start] = ACTIONS(10203),
    [sym__binary_minus] = ACTIONS(10203),
    [sym__binary_star] = ACTIONS(10203),
    [anon_sym_LBRACE] = ACTIONS(10203),
    [anon_sym_RPAREN] = ACTIONS(10203),
    [anon_sym_DOT] = ACTIONS(10205),
    [anon_sym_COMMA] = ACTIONS(10203),
    [anon_sym_PIPE] = ACTIONS(10205),
    [anon_sym_STAR_STAR] = ACTIONS(10203),
    [anon_sym_AMP] = ACTIONS(10205),
    [anon_sym_EQ] = ACTIONS(10205),
    [anon_sym_LT] = ACTIONS(10205),
    [anon_sym_do] = ACTIONS(10203),
    [anon_sym_LBRACK] = ACTIONS(10203),
    [anon_sym_COLON_COLON2] = ACTIONS(10203),
    [anon_sym_AMP_DOT] = ACTIONS(10203),
    [anon_sym_QMARK] = ACTIONS(10203),
    [anon_sym_DOT_DOT] = ACTIONS(10205),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10203),
    [anon_sym_and] = ACTIONS(10203),
    [anon_sym_or] = ACTIONS(10203),
    [anon_sym_PIPE_PIPE] = ACTIONS(10203),
    [anon_sym_AMP_AMP] = ACTIONS(10203),
    [anon_sym_LT_LT] = ACTIONS(10203),
    [anon_sym_GT_GT] = ACTIONS(10203),
    [anon_sym_EQ_EQ] = ACTIONS(10205),
    [anon_sym_BANG_EQ] = ACTIONS(10203),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10203),
    [anon_sym_LT_EQ_GT] = ACTIONS(10203),
    [anon_sym_EQ_TILDE] = ACTIONS(10203),
    [anon_sym_BANG_TILDE] = ACTIONS(10203),
    [anon_sym_LT_EQ] = ACTIONS(10205),
    [anon_sym_GT] = ACTIONS(10205),
    [anon_sym_GT_EQ] = ACTIONS(10203),
    [anon_sym_CARET] = ACTIONS(10203),
    [anon_sym_PLUS] = ACTIONS(10203),
    [anon_sym_SLASH] = ACTIONS(10203),
    [anon_sym_PERCENT] = ACTIONS(10203),
    [sym_comment] = ACTIONS(87),
  },
  [10290] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1697),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(14745),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [10291] = {
    [sym__heredoc_body_start] = ACTIONS(10209),
    [sym__binary_minus] = ACTIONS(10209),
    [sym__binary_star] = ACTIONS(10209),
    [anon_sym_LBRACE] = ACTIONS(10209),
    [anon_sym_RPAREN] = ACTIONS(10209),
    [anon_sym_DOT] = ACTIONS(10211),
    [anon_sym_COMMA] = ACTIONS(10209),
    [anon_sym_PIPE] = ACTIONS(10211),
    [anon_sym_STAR_STAR] = ACTIONS(10209),
    [anon_sym_AMP] = ACTIONS(10211),
    [anon_sym_EQ] = ACTIONS(10211),
    [anon_sym_LT] = ACTIONS(10211),
    [anon_sym_do] = ACTIONS(10209),
    [anon_sym_LBRACK] = ACTIONS(10209),
    [anon_sym_COLON_COLON2] = ACTIONS(10209),
    [anon_sym_AMP_DOT] = ACTIONS(10209),
    [anon_sym_QMARK] = ACTIONS(10209),
    [anon_sym_DOT_DOT] = ACTIONS(10211),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10209),
    [anon_sym_and] = ACTIONS(10209),
    [anon_sym_or] = ACTIONS(10209),
    [anon_sym_PIPE_PIPE] = ACTIONS(10209),
    [anon_sym_AMP_AMP] = ACTIONS(10209),
    [anon_sym_LT_LT] = ACTIONS(10209),
    [anon_sym_GT_GT] = ACTIONS(10209),
    [anon_sym_EQ_EQ] = ACTIONS(10211),
    [anon_sym_BANG_EQ] = ACTIONS(10209),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10209),
    [anon_sym_LT_EQ_GT] = ACTIONS(10209),
    [anon_sym_EQ_TILDE] = ACTIONS(10209),
    [anon_sym_BANG_TILDE] = ACTIONS(10209),
    [anon_sym_LT_EQ] = ACTIONS(10211),
    [anon_sym_GT] = ACTIONS(10211),
    [anon_sym_GT_EQ] = ACTIONS(10209),
    [anon_sym_CARET] = ACTIONS(10209),
    [anon_sym_PLUS] = ACTIONS(10209),
    [anon_sym_SLASH] = ACTIONS(10209),
    [anon_sym_PERCENT] = ACTIONS(10209),
    [sym_comment] = ACTIONS(87),
  },
  [10292] = {
    [sym__heredoc_body_start] = ACTIONS(10213),
    [sym__binary_minus] = ACTIONS(10213),
    [sym__binary_star] = ACTIONS(10213),
    [anon_sym_LBRACE] = ACTIONS(10213),
    [anon_sym_RPAREN] = ACTIONS(10213),
    [anon_sym_DOT] = ACTIONS(10215),
    [anon_sym_COMMA] = ACTIONS(10213),
    [anon_sym_PIPE] = ACTIONS(10215),
    [anon_sym_STAR_STAR] = ACTIONS(10213),
    [anon_sym_AMP] = ACTIONS(10215),
    [anon_sym_EQ] = ACTIONS(10215),
    [anon_sym_LT] = ACTIONS(10215),
    [anon_sym_do] = ACTIONS(10213),
    [anon_sym_LBRACK] = ACTIONS(10213),
    [anon_sym_COLON_COLON2] = ACTIONS(10213),
    [anon_sym_AMP_DOT] = ACTIONS(10213),
    [anon_sym_QMARK] = ACTIONS(10213),
    [anon_sym_DOT_DOT] = ACTIONS(10215),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10213),
    [anon_sym_and] = ACTIONS(10213),
    [anon_sym_or] = ACTIONS(10213),
    [anon_sym_PIPE_PIPE] = ACTIONS(10213),
    [anon_sym_AMP_AMP] = ACTIONS(10213),
    [anon_sym_LT_LT] = ACTIONS(10213),
    [anon_sym_GT_GT] = ACTIONS(10213),
    [anon_sym_EQ_EQ] = ACTIONS(10215),
    [anon_sym_BANG_EQ] = ACTIONS(10213),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10213),
    [anon_sym_LT_EQ_GT] = ACTIONS(10213),
    [anon_sym_EQ_TILDE] = ACTIONS(10213),
    [anon_sym_BANG_TILDE] = ACTIONS(10213),
    [anon_sym_LT_EQ] = ACTIONS(10215),
    [anon_sym_GT] = ACTIONS(10215),
    [anon_sym_GT_EQ] = ACTIONS(10213),
    [anon_sym_CARET] = ACTIONS(10213),
    [anon_sym_PLUS] = ACTIONS(10213),
    [anon_sym_SLASH] = ACTIONS(10213),
    [anon_sym_PERCENT] = ACTIONS(10213),
    [sym_comment] = ACTIONS(87),
  },
  [10293] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1705),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(14747),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [10294] = {
    [sym__heredoc_body_start] = ACTIONS(10219),
    [sym__binary_minus] = ACTIONS(10219),
    [sym__binary_star] = ACTIONS(10219),
    [anon_sym_LBRACE] = ACTIONS(10219),
    [anon_sym_RPAREN] = ACTIONS(10219),
    [anon_sym_DOT] = ACTIONS(10221),
    [anon_sym_COMMA] = ACTIONS(10219),
    [anon_sym_PIPE] = ACTIONS(10221),
    [anon_sym_STAR_STAR] = ACTIONS(10219),
    [anon_sym_AMP] = ACTIONS(10221),
    [anon_sym_EQ] = ACTIONS(10221),
    [anon_sym_LT] = ACTIONS(10221),
    [anon_sym_do] = ACTIONS(10219),
    [anon_sym_LBRACK] = ACTIONS(10219),
    [anon_sym_COLON_COLON2] = ACTIONS(10219),
    [anon_sym_AMP_DOT] = ACTIONS(10219),
    [anon_sym_QMARK] = ACTIONS(10219),
    [anon_sym_DOT_DOT] = ACTIONS(10221),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10219),
    [anon_sym_and] = ACTIONS(10219),
    [anon_sym_or] = ACTIONS(10219),
    [anon_sym_PIPE_PIPE] = ACTIONS(10219),
    [anon_sym_AMP_AMP] = ACTIONS(10219),
    [anon_sym_LT_LT] = ACTIONS(10219),
    [anon_sym_GT_GT] = ACTIONS(10219),
    [anon_sym_EQ_EQ] = ACTIONS(10221),
    [anon_sym_BANG_EQ] = ACTIONS(10219),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10219),
    [anon_sym_LT_EQ_GT] = ACTIONS(10219),
    [anon_sym_EQ_TILDE] = ACTIONS(10219),
    [anon_sym_BANG_TILDE] = ACTIONS(10219),
    [anon_sym_LT_EQ] = ACTIONS(10221),
    [anon_sym_GT] = ACTIONS(10221),
    [anon_sym_GT_EQ] = ACTIONS(10219),
    [anon_sym_CARET] = ACTIONS(10219),
    [anon_sym_PLUS] = ACTIONS(10219),
    [anon_sym_SLASH] = ACTIONS(10219),
    [anon_sym_PERCENT] = ACTIONS(10219),
    [sym_comment] = ACTIONS(87),
  },
  [10295] = {
    [sym__method_rest] = STATE(10896),
    [sym_operator] = STATE(4746),
    [sym__method_name] = STATE(4746),
    [sym_setter] = STATE(4746),
    [sym_symbol] = STATE(4746),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(12800),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(12800),
    [sym_class_variable] = ACTIONS(12800),
    [sym_global_variable] = ACTIONS(12800),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [10296] = {
    [sym__heredoc_body_start] = ACTIONS(10927),
    [sym__binary_minus] = ACTIONS(10927),
    [sym__binary_star] = ACTIONS(10927),
    [anon_sym_LBRACE] = ACTIONS(10927),
    [anon_sym_RPAREN] = ACTIONS(10927),
    [anon_sym_DOT] = ACTIONS(10929),
    [anon_sym_COMMA] = ACTIONS(10927),
    [anon_sym_PIPE] = ACTIONS(10929),
    [anon_sym_STAR_STAR] = ACTIONS(10927),
    [anon_sym_AMP] = ACTIONS(10929),
    [anon_sym_EQ] = ACTIONS(10929),
    [anon_sym_LT] = ACTIONS(10929),
    [anon_sym_do] = ACTIONS(10927),
    [anon_sym_LBRACK] = ACTIONS(10927),
    [anon_sym_COLON_COLON2] = ACTIONS(10927),
    [anon_sym_AMP_DOT] = ACTIONS(10927),
    [anon_sym_QMARK] = ACTIONS(10927),
    [anon_sym_DOT_DOT] = ACTIONS(10929),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10927),
    [anon_sym_and] = ACTIONS(10927),
    [anon_sym_or] = ACTIONS(10927),
    [anon_sym_PIPE_PIPE] = ACTIONS(10927),
    [anon_sym_AMP_AMP] = ACTIONS(10927),
    [anon_sym_LT_LT] = ACTIONS(10927),
    [anon_sym_GT_GT] = ACTIONS(10927),
    [anon_sym_EQ_EQ] = ACTIONS(10929),
    [anon_sym_BANG_EQ] = ACTIONS(10927),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10927),
    [anon_sym_LT_EQ_GT] = ACTIONS(10927),
    [anon_sym_EQ_TILDE] = ACTIONS(10927),
    [anon_sym_BANG_TILDE] = ACTIONS(10927),
    [anon_sym_LT_EQ] = ACTIONS(10929),
    [anon_sym_GT] = ACTIONS(10929),
    [anon_sym_GT_EQ] = ACTIONS(10927),
    [anon_sym_CARET] = ACTIONS(10927),
    [anon_sym_PLUS] = ACTIONS(10927),
    [anon_sym_SLASH] = ACTIONS(10927),
    [anon_sym_PERCENT] = ACTIONS(10927),
    [sym_comment] = ACTIONS(87),
  },
  [10297] = {
    [sym__heredoc_body_start] = ACTIONS(10931),
    [sym__binary_minus] = ACTIONS(10931),
    [sym__binary_star] = ACTIONS(10931),
    [anon_sym_LBRACE] = ACTIONS(10931),
    [anon_sym_RPAREN] = ACTIONS(10931),
    [anon_sym_DOT] = ACTIONS(10933),
    [anon_sym_COMMA] = ACTIONS(10931),
    [anon_sym_PIPE] = ACTIONS(10933),
    [anon_sym_STAR_STAR] = ACTIONS(10931),
    [anon_sym_AMP] = ACTIONS(10933),
    [anon_sym_EQ] = ACTIONS(10933),
    [anon_sym_LT] = ACTIONS(10933),
    [anon_sym_do] = ACTIONS(10931),
    [anon_sym_LBRACK] = ACTIONS(10931),
    [anon_sym_COLON_COLON2] = ACTIONS(10931),
    [anon_sym_AMP_DOT] = ACTIONS(10931),
    [anon_sym_QMARK] = ACTIONS(10931),
    [anon_sym_DOT_DOT] = ACTIONS(10933),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10931),
    [anon_sym_and] = ACTIONS(10931),
    [anon_sym_or] = ACTIONS(10931),
    [anon_sym_PIPE_PIPE] = ACTIONS(10931),
    [anon_sym_AMP_AMP] = ACTIONS(10931),
    [anon_sym_LT_LT] = ACTIONS(10931),
    [anon_sym_GT_GT] = ACTIONS(10931),
    [anon_sym_EQ_EQ] = ACTIONS(10933),
    [anon_sym_BANG_EQ] = ACTIONS(10931),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10931),
    [anon_sym_LT_EQ_GT] = ACTIONS(10931),
    [anon_sym_EQ_TILDE] = ACTIONS(10931),
    [anon_sym_BANG_TILDE] = ACTIONS(10931),
    [anon_sym_LT_EQ] = ACTIONS(10933),
    [anon_sym_GT] = ACTIONS(10933),
    [anon_sym_GT_EQ] = ACTIONS(10931),
    [anon_sym_CARET] = ACTIONS(10931),
    [anon_sym_PLUS] = ACTIONS(10931),
    [anon_sym_SLASH] = ACTIONS(10931),
    [anon_sym_PERCENT] = ACTIONS(10931),
    [sym_comment] = ACTIONS(87),
  },
  [10298] = {
    [sym__heredoc_body_start] = ACTIONS(6813),
    [sym__binary_minus] = ACTIONS(6813),
    [sym__binary_star] = ACTIONS(6813),
    [anon_sym_LBRACE] = ACTIONS(6813),
    [anon_sym_RPAREN] = ACTIONS(6813),
    [anon_sym_DOT] = ACTIONS(8689),
    [anon_sym_COMMA] = ACTIONS(6813),
    [anon_sym_PIPE] = ACTIONS(8689),
    [anon_sym_STAR_STAR] = ACTIONS(6813),
    [anon_sym_AMP] = ACTIONS(8689),
    [anon_sym_EQ] = ACTIONS(8689),
    [anon_sym_LT] = ACTIONS(8689),
    [anon_sym_do] = ACTIONS(6813),
    [anon_sym_LBRACK] = ACTIONS(6813),
    [anon_sym_COLON_COLON2] = ACTIONS(6813),
    [anon_sym_AMP_DOT] = ACTIONS(6813),
    [anon_sym_QMARK] = ACTIONS(6813),
    [anon_sym_DOT_DOT] = ACTIONS(8689),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6813),
    [anon_sym_and] = ACTIONS(6813),
    [anon_sym_or] = ACTIONS(6813),
    [anon_sym_PIPE_PIPE] = ACTIONS(6813),
    [anon_sym_AMP_AMP] = ACTIONS(6813),
    [anon_sym_LT_LT] = ACTIONS(6813),
    [anon_sym_GT_GT] = ACTIONS(6813),
    [anon_sym_EQ_EQ] = ACTIONS(8689),
    [anon_sym_BANG_EQ] = ACTIONS(6813),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6813),
    [anon_sym_LT_EQ_GT] = ACTIONS(6813),
    [anon_sym_EQ_TILDE] = ACTIONS(6813),
    [anon_sym_BANG_TILDE] = ACTIONS(6813),
    [anon_sym_LT_EQ] = ACTIONS(8689),
    [anon_sym_GT] = ACTIONS(8689),
    [anon_sym_GT_EQ] = ACTIONS(6813),
    [anon_sym_CARET] = ACTIONS(6813),
    [anon_sym_PLUS] = ACTIONS(6813),
    [anon_sym_SLASH] = ACTIONS(6813),
    [anon_sym_PERCENT] = ACTIONS(6813),
    [sym_comment] = ACTIONS(87),
  },
  [10299] = {
    [sym__heredoc_body_start] = ACTIONS(10986),
    [sym__binary_minus] = ACTIONS(10986),
    [sym__binary_star] = ACTIONS(10986),
    [anon_sym_LBRACE] = ACTIONS(10986),
    [anon_sym_RPAREN] = ACTIONS(10986),
    [anon_sym_DOT] = ACTIONS(10988),
    [anon_sym_COMMA] = ACTIONS(10986),
    [anon_sym_PIPE] = ACTIONS(10988),
    [anon_sym_STAR_STAR] = ACTIONS(10986),
    [anon_sym_AMP] = ACTIONS(10988),
    [anon_sym_EQ] = ACTIONS(10988),
    [anon_sym_LT] = ACTIONS(10988),
    [anon_sym_do] = ACTIONS(10986),
    [anon_sym_LBRACK] = ACTIONS(10986),
    [anon_sym_COLON_COLON2] = ACTIONS(10986),
    [anon_sym_AMP_DOT] = ACTIONS(10986),
    [anon_sym_QMARK] = ACTIONS(10986),
    [anon_sym_DOT_DOT] = ACTIONS(10988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10986),
    [anon_sym_and] = ACTIONS(10986),
    [anon_sym_or] = ACTIONS(10986),
    [anon_sym_PIPE_PIPE] = ACTIONS(10986),
    [anon_sym_AMP_AMP] = ACTIONS(10986),
    [anon_sym_LT_LT] = ACTIONS(10986),
    [anon_sym_GT_GT] = ACTIONS(10986),
    [anon_sym_EQ_EQ] = ACTIONS(10988),
    [anon_sym_BANG_EQ] = ACTIONS(10986),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10986),
    [anon_sym_LT_EQ_GT] = ACTIONS(10986),
    [anon_sym_EQ_TILDE] = ACTIONS(10986),
    [anon_sym_BANG_TILDE] = ACTIONS(10986),
    [anon_sym_LT_EQ] = ACTIONS(10988),
    [anon_sym_GT] = ACTIONS(10988),
    [anon_sym_GT_EQ] = ACTIONS(10986),
    [anon_sym_CARET] = ACTIONS(10986),
    [anon_sym_PLUS] = ACTIONS(10986),
    [anon_sym_SLASH] = ACTIONS(10986),
    [anon_sym_PERCENT] = ACTIONS(10986),
    [sym_comment] = ACTIONS(87),
  },
  [10300] = {
    [sym__heredoc_body_start] = ACTIONS(11157),
    [sym__binary_minus] = ACTIONS(11157),
    [sym__binary_star] = ACTIONS(11157),
    [anon_sym_LBRACE] = ACTIONS(11157),
    [anon_sym_RPAREN] = ACTIONS(11157),
    [anon_sym_DOT] = ACTIONS(11159),
    [anon_sym_COMMA] = ACTIONS(11157),
    [anon_sym_PIPE] = ACTIONS(11159),
    [anon_sym_STAR_STAR] = ACTIONS(11157),
    [anon_sym_AMP] = ACTIONS(11159),
    [anon_sym_EQ] = ACTIONS(11159),
    [anon_sym_LT] = ACTIONS(11159),
    [anon_sym_do] = ACTIONS(11157),
    [anon_sym_LBRACK] = ACTIONS(11157),
    [anon_sym_COLON_COLON2] = ACTIONS(11157),
    [anon_sym_AMP_DOT] = ACTIONS(11157),
    [anon_sym_QMARK] = ACTIONS(11157),
    [anon_sym_DOT_DOT] = ACTIONS(11159),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11157),
    [anon_sym_and] = ACTIONS(11157),
    [anon_sym_or] = ACTIONS(11157),
    [anon_sym_PIPE_PIPE] = ACTIONS(11157),
    [anon_sym_AMP_AMP] = ACTIONS(11157),
    [anon_sym_LT_LT] = ACTIONS(11157),
    [anon_sym_GT_GT] = ACTIONS(11157),
    [anon_sym_EQ_EQ] = ACTIONS(11159),
    [anon_sym_BANG_EQ] = ACTIONS(11157),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11157),
    [anon_sym_LT_EQ_GT] = ACTIONS(11157),
    [anon_sym_EQ_TILDE] = ACTIONS(11157),
    [anon_sym_BANG_TILDE] = ACTIONS(11157),
    [anon_sym_LT_EQ] = ACTIONS(11159),
    [anon_sym_GT] = ACTIONS(11159),
    [anon_sym_GT_EQ] = ACTIONS(11157),
    [anon_sym_CARET] = ACTIONS(11157),
    [anon_sym_PLUS] = ACTIONS(11157),
    [anon_sym_SLASH] = ACTIONS(11157),
    [anon_sym_PERCENT] = ACTIONS(11157),
    [sym_comment] = ACTIONS(87),
  },
  [10301] = {
    [sym__heredoc_body_start] = ACTIONS(11322),
    [sym__binary_minus] = ACTIONS(11322),
    [sym__binary_star] = ACTIONS(11322),
    [anon_sym_LBRACE] = ACTIONS(11322),
    [anon_sym_RPAREN] = ACTIONS(11322),
    [anon_sym_DOT] = ACTIONS(11324),
    [anon_sym_COMMA] = ACTIONS(11322),
    [anon_sym_PIPE] = ACTIONS(11324),
    [anon_sym_STAR_STAR] = ACTIONS(11322),
    [anon_sym_AMP] = ACTIONS(11324),
    [anon_sym_EQ] = ACTIONS(11324),
    [anon_sym_LT] = ACTIONS(11324),
    [anon_sym_do] = ACTIONS(11322),
    [anon_sym_LBRACK] = ACTIONS(11322),
    [anon_sym_COLON_COLON2] = ACTIONS(11322),
    [anon_sym_AMP_DOT] = ACTIONS(11322),
    [anon_sym_QMARK] = ACTIONS(11322),
    [anon_sym_DOT_DOT] = ACTIONS(11324),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11322),
    [anon_sym_and] = ACTIONS(11322),
    [anon_sym_or] = ACTIONS(11322),
    [anon_sym_PIPE_PIPE] = ACTIONS(11322),
    [anon_sym_AMP_AMP] = ACTIONS(11322),
    [anon_sym_LT_LT] = ACTIONS(11322),
    [anon_sym_GT_GT] = ACTIONS(11322),
    [anon_sym_EQ_EQ] = ACTIONS(11324),
    [anon_sym_BANG_EQ] = ACTIONS(11322),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11322),
    [anon_sym_LT_EQ_GT] = ACTIONS(11322),
    [anon_sym_EQ_TILDE] = ACTIONS(11322),
    [anon_sym_BANG_TILDE] = ACTIONS(11322),
    [anon_sym_LT_EQ] = ACTIONS(11324),
    [anon_sym_GT] = ACTIONS(11324),
    [anon_sym_GT_EQ] = ACTIONS(11322),
    [anon_sym_CARET] = ACTIONS(11322),
    [anon_sym_PLUS] = ACTIONS(11322),
    [anon_sym_SLASH] = ACTIONS(11322),
    [anon_sym_PERCENT] = ACTIONS(11322),
    [sym_comment] = ACTIONS(87),
  },
  [10302] = {
    [sym__heredoc_body_start] = ACTIONS(11335),
    [sym__binary_minus] = ACTIONS(11335),
    [sym__binary_star] = ACTIONS(11335),
    [anon_sym_LBRACE] = ACTIONS(11335),
    [anon_sym_RPAREN] = ACTIONS(11335),
    [anon_sym_DOT] = ACTIONS(11337),
    [anon_sym_COMMA] = ACTIONS(11335),
    [anon_sym_PIPE] = ACTIONS(11337),
    [anon_sym_STAR_STAR] = ACTIONS(11335),
    [anon_sym_AMP] = ACTIONS(11337),
    [anon_sym_EQ] = ACTIONS(11337),
    [anon_sym_LT] = ACTIONS(11337),
    [anon_sym_do] = ACTIONS(11335),
    [anon_sym_LBRACK] = ACTIONS(11335),
    [anon_sym_COLON_COLON2] = ACTIONS(11335),
    [anon_sym_AMP_DOT] = ACTIONS(11335),
    [anon_sym_QMARK] = ACTIONS(11335),
    [anon_sym_DOT_DOT] = ACTIONS(11337),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11335),
    [anon_sym_and] = ACTIONS(11335),
    [anon_sym_or] = ACTIONS(11335),
    [anon_sym_PIPE_PIPE] = ACTIONS(11335),
    [anon_sym_AMP_AMP] = ACTIONS(11335),
    [anon_sym_LT_LT] = ACTIONS(11335),
    [anon_sym_GT_GT] = ACTIONS(11335),
    [anon_sym_EQ_EQ] = ACTIONS(11337),
    [anon_sym_BANG_EQ] = ACTIONS(11335),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11335),
    [anon_sym_LT_EQ_GT] = ACTIONS(11335),
    [anon_sym_EQ_TILDE] = ACTIONS(11335),
    [anon_sym_BANG_TILDE] = ACTIONS(11335),
    [anon_sym_LT_EQ] = ACTIONS(11337),
    [anon_sym_GT] = ACTIONS(11337),
    [anon_sym_GT_EQ] = ACTIONS(11335),
    [anon_sym_CARET] = ACTIONS(11335),
    [anon_sym_PLUS] = ACTIONS(11335),
    [anon_sym_SLASH] = ACTIONS(11335),
    [anon_sym_PERCENT] = ACTIONS(11335),
    [sym_comment] = ACTIONS(87),
  },
  [10303] = {
    [sym__heredoc_body_start] = ACTIONS(11344),
    [sym__binary_minus] = ACTIONS(11344),
    [sym__binary_star] = ACTIONS(11344),
    [anon_sym_LBRACE] = ACTIONS(11344),
    [anon_sym_RPAREN] = ACTIONS(11344),
    [anon_sym_DOT] = ACTIONS(11346),
    [anon_sym_COMMA] = ACTIONS(11344),
    [anon_sym_PIPE] = ACTIONS(11346),
    [anon_sym_STAR_STAR] = ACTIONS(11344),
    [anon_sym_AMP] = ACTIONS(11346),
    [anon_sym_EQ] = ACTIONS(11346),
    [anon_sym_LT] = ACTIONS(11346),
    [anon_sym_do] = ACTIONS(11344),
    [anon_sym_LBRACK] = ACTIONS(11344),
    [anon_sym_COLON_COLON2] = ACTIONS(11344),
    [anon_sym_AMP_DOT] = ACTIONS(11344),
    [anon_sym_QMARK] = ACTIONS(11344),
    [anon_sym_DOT_DOT] = ACTIONS(11346),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11344),
    [anon_sym_and] = ACTIONS(11344),
    [anon_sym_or] = ACTIONS(11344),
    [anon_sym_PIPE_PIPE] = ACTIONS(11344),
    [anon_sym_AMP_AMP] = ACTIONS(11344),
    [anon_sym_LT_LT] = ACTIONS(11344),
    [anon_sym_GT_GT] = ACTIONS(11344),
    [anon_sym_EQ_EQ] = ACTIONS(11346),
    [anon_sym_BANG_EQ] = ACTIONS(11344),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11344),
    [anon_sym_LT_EQ_GT] = ACTIONS(11344),
    [anon_sym_EQ_TILDE] = ACTIONS(11344),
    [anon_sym_BANG_TILDE] = ACTIONS(11344),
    [anon_sym_LT_EQ] = ACTIONS(11346),
    [anon_sym_GT] = ACTIONS(11346),
    [anon_sym_GT_EQ] = ACTIONS(11344),
    [anon_sym_CARET] = ACTIONS(11344),
    [anon_sym_PLUS] = ACTIONS(11344),
    [anon_sym_SLASH] = ACTIONS(11344),
    [anon_sym_PERCENT] = ACTIONS(11344),
    [sym_comment] = ACTIONS(87),
  },
  [10304] = {
    [sym__heredoc_body_start] = ACTIONS(11391),
    [sym__binary_minus] = ACTIONS(11391),
    [sym__binary_star] = ACTIONS(11391),
    [anon_sym_LBRACE] = ACTIONS(11391),
    [anon_sym_RPAREN] = ACTIONS(11391),
    [anon_sym_DOT] = ACTIONS(11393),
    [anon_sym_COMMA] = ACTIONS(11391),
    [anon_sym_PIPE] = ACTIONS(11393),
    [anon_sym_STAR_STAR] = ACTIONS(11391),
    [anon_sym_AMP] = ACTIONS(11393),
    [anon_sym_EQ] = ACTIONS(11393),
    [anon_sym_LT] = ACTIONS(11393),
    [anon_sym_do] = ACTIONS(11391),
    [anon_sym_LBRACK] = ACTIONS(11391),
    [anon_sym_COLON_COLON2] = ACTIONS(11391),
    [anon_sym_AMP_DOT] = ACTIONS(11391),
    [anon_sym_QMARK] = ACTIONS(11391),
    [anon_sym_DOT_DOT] = ACTIONS(11393),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11391),
    [anon_sym_and] = ACTIONS(11391),
    [anon_sym_or] = ACTIONS(11391),
    [anon_sym_PIPE_PIPE] = ACTIONS(11391),
    [anon_sym_AMP_AMP] = ACTIONS(11391),
    [anon_sym_LT_LT] = ACTIONS(11391),
    [anon_sym_GT_GT] = ACTIONS(11391),
    [anon_sym_EQ_EQ] = ACTIONS(11393),
    [anon_sym_BANG_EQ] = ACTIONS(11391),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11391),
    [anon_sym_LT_EQ_GT] = ACTIONS(11391),
    [anon_sym_EQ_TILDE] = ACTIONS(11391),
    [anon_sym_BANG_TILDE] = ACTIONS(11391),
    [anon_sym_LT_EQ] = ACTIONS(11393),
    [anon_sym_GT] = ACTIONS(11393),
    [anon_sym_GT_EQ] = ACTIONS(11391),
    [anon_sym_CARET] = ACTIONS(11391),
    [anon_sym_PLUS] = ACTIONS(11391),
    [anon_sym_SLASH] = ACTIONS(11391),
    [anon_sym_PERCENT] = ACTIONS(11391),
    [sym_comment] = ACTIONS(87),
  },
  [10305] = {
    [anon_sym_end] = ACTIONS(14749),
    [sym_comment] = ACTIONS(87),
  },
  [10306] = {
    [sym__heredoc_body_start] = ACTIONS(11404),
    [sym__binary_minus] = ACTIONS(11404),
    [sym__binary_star] = ACTIONS(11404),
    [anon_sym_LBRACE] = ACTIONS(11404),
    [anon_sym_RPAREN] = ACTIONS(11404),
    [anon_sym_DOT] = ACTIONS(11406),
    [anon_sym_COMMA] = ACTIONS(11404),
    [anon_sym_PIPE] = ACTIONS(11406),
    [anon_sym_STAR_STAR] = ACTIONS(11404),
    [anon_sym_AMP] = ACTIONS(11406),
    [anon_sym_EQ] = ACTIONS(11406),
    [anon_sym_LT] = ACTIONS(11406),
    [anon_sym_do] = ACTIONS(11404),
    [anon_sym_LBRACK] = ACTIONS(11404),
    [anon_sym_COLON_COLON2] = ACTIONS(11404),
    [anon_sym_AMP_DOT] = ACTIONS(11404),
    [anon_sym_QMARK] = ACTIONS(11404),
    [anon_sym_DOT_DOT] = ACTIONS(11406),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11404),
    [anon_sym_and] = ACTIONS(11404),
    [anon_sym_or] = ACTIONS(11404),
    [anon_sym_PIPE_PIPE] = ACTIONS(11404),
    [anon_sym_AMP_AMP] = ACTIONS(11404),
    [anon_sym_LT_LT] = ACTIONS(11404),
    [anon_sym_GT_GT] = ACTIONS(11404),
    [anon_sym_EQ_EQ] = ACTIONS(11406),
    [anon_sym_BANG_EQ] = ACTIONS(11404),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11404),
    [anon_sym_LT_EQ_GT] = ACTIONS(11404),
    [anon_sym_EQ_TILDE] = ACTIONS(11404),
    [anon_sym_BANG_TILDE] = ACTIONS(11404),
    [anon_sym_LT_EQ] = ACTIONS(11406),
    [anon_sym_GT] = ACTIONS(11406),
    [anon_sym_GT_EQ] = ACTIONS(11404),
    [anon_sym_CARET] = ACTIONS(11404),
    [anon_sym_PLUS] = ACTIONS(11404),
    [anon_sym_SLASH] = ACTIONS(11404),
    [anon_sym_PERCENT] = ACTIONS(11404),
    [sym_comment] = ACTIONS(87),
  },
  [10307] = {
    [anon_sym_end] = ACTIONS(14751),
    [sym_comment] = ACTIONS(87),
  },
  [10308] = {
    [sym_when] = STATE(2988),
    [sym_else] = STATE(10899),
    [aux_sym_case_repeat2] = STATE(2988),
    [anon_sym_end] = ACTIONS(14751),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [10309] = {
    [sym__heredoc_body_start] = ACTIONS(11846),
    [sym__binary_minus] = ACTIONS(11846),
    [sym__binary_star] = ACTIONS(11846),
    [anon_sym_LBRACE] = ACTIONS(11846),
    [anon_sym_RPAREN] = ACTIONS(11846),
    [anon_sym_DOT] = ACTIONS(11848),
    [anon_sym_COMMA] = ACTIONS(11846),
    [anon_sym_PIPE] = ACTIONS(11848),
    [anon_sym_STAR_STAR] = ACTIONS(11846),
    [anon_sym_AMP] = ACTIONS(11848),
    [anon_sym_EQ] = ACTIONS(11848),
    [anon_sym_LT] = ACTIONS(11848),
    [anon_sym_do] = ACTIONS(11846),
    [anon_sym_LBRACK] = ACTIONS(11846),
    [anon_sym_COLON_COLON2] = ACTIONS(11846),
    [anon_sym_AMP_DOT] = ACTIONS(11846),
    [anon_sym_QMARK] = ACTIONS(11846),
    [anon_sym_DOT_DOT] = ACTIONS(11848),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11846),
    [anon_sym_and] = ACTIONS(11846),
    [anon_sym_or] = ACTIONS(11846),
    [anon_sym_PIPE_PIPE] = ACTIONS(11846),
    [anon_sym_AMP_AMP] = ACTIONS(11846),
    [anon_sym_LT_LT] = ACTIONS(11846),
    [anon_sym_GT_GT] = ACTIONS(11846),
    [anon_sym_EQ_EQ] = ACTIONS(11848),
    [anon_sym_BANG_EQ] = ACTIONS(11846),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11846),
    [anon_sym_LT_EQ_GT] = ACTIONS(11846),
    [anon_sym_EQ_TILDE] = ACTIONS(11846),
    [anon_sym_BANG_TILDE] = ACTIONS(11846),
    [anon_sym_LT_EQ] = ACTIONS(11848),
    [anon_sym_GT] = ACTIONS(11848),
    [anon_sym_GT_EQ] = ACTIONS(11846),
    [anon_sym_CARET] = ACTIONS(11846),
    [anon_sym_PLUS] = ACTIONS(11846),
    [anon_sym_SLASH] = ACTIONS(11846),
    [anon_sym_PERCENT] = ACTIONS(11846),
    [sym_comment] = ACTIONS(87),
  },
  [10310] = {
    [anon_sym_end] = ACTIONS(14753),
    [sym_comment] = ACTIONS(87),
  },
  [10311] = {
    [sym__heredoc_body_start] = ACTIONS(12029),
    [sym__binary_minus] = ACTIONS(12029),
    [sym__binary_star] = ACTIONS(12029),
    [anon_sym_LBRACE] = ACTIONS(12029),
    [anon_sym_RPAREN] = ACTIONS(12029),
    [anon_sym_DOT] = ACTIONS(12031),
    [anon_sym_COMMA] = ACTIONS(12029),
    [anon_sym_PIPE] = ACTIONS(12031),
    [anon_sym_STAR_STAR] = ACTIONS(12029),
    [anon_sym_AMP] = ACTIONS(12031),
    [anon_sym_EQ] = ACTIONS(12031),
    [anon_sym_LT] = ACTIONS(12031),
    [anon_sym_do] = ACTIONS(12029),
    [anon_sym_LBRACK] = ACTIONS(12029),
    [anon_sym_COLON_COLON2] = ACTIONS(12029),
    [anon_sym_AMP_DOT] = ACTIONS(12029),
    [anon_sym_QMARK] = ACTIONS(12029),
    [anon_sym_DOT_DOT] = ACTIONS(12031),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12029),
    [anon_sym_and] = ACTIONS(12029),
    [anon_sym_or] = ACTIONS(12029),
    [anon_sym_PIPE_PIPE] = ACTIONS(12029),
    [anon_sym_AMP_AMP] = ACTIONS(12029),
    [anon_sym_LT_LT] = ACTIONS(12029),
    [anon_sym_GT_GT] = ACTIONS(12029),
    [anon_sym_EQ_EQ] = ACTIONS(12031),
    [anon_sym_BANG_EQ] = ACTIONS(12029),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12029),
    [anon_sym_LT_EQ_GT] = ACTIONS(12029),
    [anon_sym_EQ_TILDE] = ACTIONS(12029),
    [anon_sym_BANG_TILDE] = ACTIONS(12029),
    [anon_sym_LT_EQ] = ACTIONS(12031),
    [anon_sym_GT] = ACTIONS(12031),
    [anon_sym_GT_EQ] = ACTIONS(12029),
    [anon_sym_CARET] = ACTIONS(12029),
    [anon_sym_PLUS] = ACTIONS(12029),
    [anon_sym_SLASH] = ACTIONS(12029),
    [anon_sym_PERCENT] = ACTIONS(12029),
    [sym_comment] = ACTIONS(87),
  },
  [10312] = {
    [sym__heredoc_body_start] = ACTIONS(12054),
    [sym__binary_minus] = ACTIONS(12054),
    [sym__binary_star] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_RPAREN] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12056),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_PIPE] = ACTIONS(12056),
    [anon_sym_STAR_STAR] = ACTIONS(12054),
    [anon_sym_AMP] = ACTIONS(12056),
    [anon_sym_EQ] = ACTIONS(12056),
    [anon_sym_LT] = ACTIONS(12056),
    [anon_sym_do] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_COLON_COLON2] = ACTIONS(12054),
    [anon_sym_AMP_DOT] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_DOT_DOT] = ACTIONS(12056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_and] = ACTIONS(12054),
    [anon_sym_or] = ACTIONS(12054),
    [anon_sym_PIPE_PIPE] = ACTIONS(12054),
    [anon_sym_AMP_AMP] = ACTIONS(12054),
    [anon_sym_LT_LT] = ACTIONS(12054),
    [anon_sym_GT_GT] = ACTIONS(12054),
    [anon_sym_EQ_EQ] = ACTIONS(12056),
    [anon_sym_BANG_EQ] = ACTIONS(12054),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12054),
    [anon_sym_LT_EQ_GT] = ACTIONS(12054),
    [anon_sym_EQ_TILDE] = ACTIONS(12054),
    [anon_sym_BANG_TILDE] = ACTIONS(12054),
    [anon_sym_LT_EQ] = ACTIONS(12056),
    [anon_sym_GT] = ACTIONS(12056),
    [anon_sym_GT_EQ] = ACTIONS(12054),
    [anon_sym_CARET] = ACTIONS(12054),
    [anon_sym_PLUS] = ACTIONS(12054),
    [anon_sym_SLASH] = ACTIONS(12054),
    [anon_sym_PERCENT] = ACTIONS(12054),
    [sym_comment] = ACTIONS(87),
  },
  [10313] = {
    [anon_sym_end] = ACTIONS(14755),
    [sym_comment] = ACTIONS(87),
  },
  [10314] = {
    [sym__statements] = STATE(10902),
    [sym_begin_block] = STATE(1204),
    [sym_end_block] = STATE(1204),
    [sym__statement] = STATE(1204),
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_if_modifier] = STATE(1204),
    [sym_unless_modifier] = STATE(1204),
    [sym_while_modifier] = STATE(1204),
    [sym_until_modifier] = STATE(1204),
    [sym_rescue_modifier] = STATE(1204),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(1208),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(1208),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(1207),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1208),
    [sym__variable] = STATE(1206),
    [sym_undef] = STATE(1204),
    [sym_alias] = STATE(1204),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(1208),
    [sym_false] = STATE(1208),
    [sym_nil] = STATE(1208),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(1209),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym_empty_statement] = STATE(1210),
    [aux_sym__statements_repeat1] = STATE(1210),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2135),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(14757),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_next] = ACTIONS(2145),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_defined_QMARK] = ACTIONS(2149),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [anon_sym_undef] = ACTIONS(2159),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10315] = {
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(7711),
    [sym__binary_star] = ACTIONS(7713),
    [anon_sym_LBRACE] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(7715),
    [anon_sym_STAR_STAR] = ACTIONS(7713),
    [anon_sym_AMP] = ACTIONS(7717),
    [anon_sym_EQ] = ACTIONS(12879),
    [anon_sym_LT] = ACTIONS(7719),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(7721),
    [anon_sym_DOT_DOT] = ACTIONS(7723),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7725),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(7729),
    [anon_sym_AMP_AMP] = ACTIONS(7729),
    [anon_sym_LT_LT] = ACTIONS(7731),
    [anon_sym_GT_GT] = ACTIONS(7731),
    [anon_sym_EQ_EQ] = ACTIONS(7733),
    [anon_sym_BANG_EQ] = ACTIONS(7729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7729),
    [anon_sym_LT_EQ_GT] = ACTIONS(7729),
    [anon_sym_EQ_TILDE] = ACTIONS(7729),
    [anon_sym_BANG_TILDE] = ACTIONS(7729),
    [anon_sym_LT_EQ] = ACTIONS(7719),
    [anon_sym_GT] = ACTIONS(7719),
    [anon_sym_GT_EQ] = ACTIONS(7735),
    [anon_sym_CARET] = ACTIONS(7737),
    [anon_sym_PLUS] = ACTIONS(7711),
    [anon_sym_SLASH] = ACTIONS(7713),
    [anon_sym_PERCENT] = ACTIONS(7713),
    [sym_comment] = ACTIONS(87),
  },
  [10316] = {
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_RPAREN] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(11597),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [10317] = {
    [aux_sym_exceptions_repeat1] = STATE(10317),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(14759),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [10318] = {
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(7776),
    [sym__binary_star] = ACTIONS(7778),
    [anon_sym_LBRACE] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(7780),
    [anon_sym_STAR_STAR] = ACTIONS(7778),
    [anon_sym_AMP] = ACTIONS(7782),
    [anon_sym_LT] = ACTIONS(7784),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(7786),
    [anon_sym_DOT_DOT] = ACTIONS(7788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7790),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(7794),
    [anon_sym_AMP_AMP] = ACTIONS(7794),
    [anon_sym_LT_LT] = ACTIONS(7796),
    [anon_sym_GT_GT] = ACTIONS(7796),
    [anon_sym_EQ_EQ] = ACTIONS(7798),
    [anon_sym_BANG_EQ] = ACTIONS(7794),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7794),
    [anon_sym_LT_EQ_GT] = ACTIONS(7794),
    [anon_sym_EQ_TILDE] = ACTIONS(7794),
    [anon_sym_BANG_TILDE] = ACTIONS(7794),
    [anon_sym_LT_EQ] = ACTIONS(7784),
    [anon_sym_GT] = ACTIONS(7784),
    [anon_sym_GT_EQ] = ACTIONS(7800),
    [anon_sym_CARET] = ACTIONS(7802),
    [anon_sym_PLUS] = ACTIONS(7776),
    [anon_sym_SLASH] = ACTIONS(7778),
    [anon_sym_PERCENT] = ACTIONS(7778),
    [sym_comment] = ACTIONS(87),
  },
  [10319] = {
    [aux_sym_exceptions_repeat1] = STATE(10319),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(14762),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [10320] = {
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(7826),
    [sym__binary_star] = ACTIONS(7828),
    [anon_sym_RPAREN] = ACTIONS(12120),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(7830),
    [anon_sym_STAR_STAR] = ACTIONS(7828),
    [anon_sym_AMP] = ACTIONS(7832),
    [anon_sym_LT] = ACTIONS(7834),
    [anon_sym_QMARK] = ACTIONS(7836),
    [anon_sym_DOT_DOT] = ACTIONS(7838),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7840),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(7844),
    [anon_sym_AMP_AMP] = ACTIONS(7844),
    [anon_sym_LT_LT] = ACTIONS(7846),
    [anon_sym_GT_GT] = ACTIONS(7846),
    [anon_sym_EQ_EQ] = ACTIONS(7848),
    [anon_sym_BANG_EQ] = ACTIONS(7844),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7844),
    [anon_sym_LT_EQ_GT] = ACTIONS(7844),
    [anon_sym_EQ_TILDE] = ACTIONS(7844),
    [anon_sym_BANG_TILDE] = ACTIONS(7844),
    [anon_sym_LT_EQ] = ACTIONS(7834),
    [anon_sym_GT] = ACTIONS(7834),
    [anon_sym_GT_EQ] = ACTIONS(7850),
    [anon_sym_CARET] = ACTIONS(7852),
    [anon_sym_PLUS] = ACTIONS(7826),
    [anon_sym_SLASH] = ACTIONS(7828),
    [anon_sym_PERCENT] = ACTIONS(7828),
    [sym_comment] = ACTIONS(87),
  },
  [10321] = {
    [aux_sym_exceptions_repeat1] = STATE(10321),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_RPAREN] = ACTIONS(11597),
    [anon_sym_COMMA] = ACTIONS(14765),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [10322] = {
    [sym__line_break] = ACTIONS(14580),
    [sym__heredoc_body_start] = ACTIONS(14580),
    [sym__binary_minus] = ACTIONS(14580),
    [sym__binary_star] = ACTIONS(14580),
    [ts_builtin_sym_end] = ACTIONS(14580),
    [anon_sym___END__] = ACTIONS(14580),
    [anon_sym_LBRACE] = ACTIONS(14580),
    [anon_sym_RBRACE] = ACTIONS(14580),
    [anon_sym_RPAREN] = ACTIONS(14580),
    [anon_sym_DOT] = ACTIONS(14582),
    [anon_sym_COMMA] = ACTIONS(14580),
    [anon_sym_PIPE] = ACTIONS(14582),
    [anon_sym_SEMI] = ACTIONS(14580),
    [anon_sym_STAR_STAR] = ACTIONS(14582),
    [anon_sym_AMP] = ACTIONS(14582),
    [anon_sym_EQ] = ACTIONS(14582),
    [anon_sym_LT] = ACTIONS(14582),
    [anon_sym_end] = ACTIONS(14580),
    [anon_sym_if] = ACTIONS(14580),
    [anon_sym_unless] = ACTIONS(14580),
    [anon_sym_while] = ACTIONS(14580),
    [anon_sym_until] = ACTIONS(14580),
    [anon_sym_rescue] = ACTIONS(14580),
    [anon_sym_do] = ACTIONS(14580),
    [anon_sym_when] = ACTIONS(14580),
    [anon_sym_elsif] = ACTIONS(14580),
    [anon_sym_else] = ACTIONS(14580),
    [anon_sym_then] = ACTIONS(14580),
    [anon_sym_ensure] = ACTIONS(14580),
    [anon_sym_EQ_GT] = ACTIONS(14580),
    [anon_sym_LBRACK] = ACTIONS(14580),
    [anon_sym_COLON_COLON2] = ACTIONS(14580),
    [anon_sym_AMP_DOT] = ACTIONS(14580),
    [anon_sym_PLUS_EQ] = ACTIONS(14580),
    [anon_sym_DASH_EQ] = ACTIONS(14580),
    [anon_sym_STAR_EQ] = ACTIONS(14580),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14580),
    [anon_sym_SLASH_EQ] = ACTIONS(14580),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14580),
    [anon_sym_PIPE_EQ] = ACTIONS(14580),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14580),
    [anon_sym_AMP_EQ] = ACTIONS(14580),
    [anon_sym_PERCENT_EQ] = ACTIONS(14580),
    [anon_sym_GT_GT_EQ] = ACTIONS(14580),
    [anon_sym_LT_LT_EQ] = ACTIONS(14580),
    [anon_sym_CARET_EQ] = ACTIONS(14580),
    [anon_sym_QMARK] = ACTIONS(14580),
    [anon_sym_DOT_DOT] = ACTIONS(14582),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14580),
    [anon_sym_and] = ACTIONS(14580),
    [anon_sym_or] = ACTIONS(14580),
    [anon_sym_PIPE_PIPE] = ACTIONS(14582),
    [anon_sym_AMP_AMP] = ACTIONS(14582),
    [anon_sym_LT_LT] = ACTIONS(14582),
    [anon_sym_GT_GT] = ACTIONS(14582),
    [anon_sym_EQ_EQ] = ACTIONS(14582),
    [anon_sym_BANG_EQ] = ACTIONS(14580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14580),
    [anon_sym_LT_EQ_GT] = ACTIONS(14580),
    [anon_sym_EQ_TILDE] = ACTIONS(14580),
    [anon_sym_BANG_TILDE] = ACTIONS(14580),
    [anon_sym_LT_EQ] = ACTIONS(14582),
    [anon_sym_GT] = ACTIONS(14582),
    [anon_sym_GT_EQ] = ACTIONS(14580),
    [anon_sym_CARET] = ACTIONS(14582),
    [anon_sym_PLUS] = ACTIONS(14582),
    [anon_sym_SLASH] = ACTIONS(14582),
    [anon_sym_PERCENT] = ACTIONS(14582),
    [sym_comment] = ACTIONS(87),
  },
  [10323] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(7940),
    [sym__binary_star] = ACTIONS(7942),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(7944),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(7942),
    [anon_sym_AMP] = ACTIONS(7946),
    [anon_sym_LT] = ACTIONS(7948),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_then] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(7950),
    [anon_sym_DOT_DOT] = ACTIONS(7952),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7954),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(7956),
    [anon_sym_AMP_AMP] = ACTIONS(7956),
    [anon_sym_LT_LT] = ACTIONS(7958),
    [anon_sym_GT_GT] = ACTIONS(7958),
    [anon_sym_EQ_EQ] = ACTIONS(7960),
    [anon_sym_BANG_EQ] = ACTIONS(7956),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7956),
    [anon_sym_LT_EQ_GT] = ACTIONS(7956),
    [anon_sym_EQ_TILDE] = ACTIONS(7956),
    [anon_sym_BANG_TILDE] = ACTIONS(7956),
    [anon_sym_LT_EQ] = ACTIONS(7948),
    [anon_sym_GT] = ACTIONS(7948),
    [anon_sym_GT_EQ] = ACTIONS(7962),
    [anon_sym_CARET] = ACTIONS(7964),
    [anon_sym_PLUS] = ACTIONS(7940),
    [anon_sym_SLASH] = ACTIONS(7942),
    [anon_sym_PERCENT] = ACTIONS(7942),
    [sym_comment] = ACTIONS(87),
  },
  [10324] = {
    [aux_sym_exceptions_repeat1] = STATE(10324),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(14768),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_then] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [10325] = {
    [sym_heredoc_body] = STATE(10903),
    [aux_sym_call_repeat1] = STATE(10903),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_elsif] = ACTIONS(4383),
    [anon_sym_else] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [10326] = {
    [sym_heredoc_body] = STATE(10904),
    [aux_sym_call_repeat1] = STATE(10904),
    [aux_sym_argument_list_repeat1] = STATE(9325),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(11067),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_elsif] = ACTIONS(4383),
    [anon_sym_else] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [10327] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(12900),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(12900),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_elsif] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(12900),
    [anon_sym_PERCENT] = ACTIONS(12900),
    [sym_comment] = ACTIONS(87),
  },
  [10328] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(12900),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_elsif] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [10329] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12898),
    [sym__binary_star] = ACTIONS(12900),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(12900),
    [anon_sym_AMP] = ACTIONS(12904),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_elsif] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(12916),
    [anon_sym_GT_GT] = ACTIONS(12916),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(12898),
    [anon_sym_SLASH] = ACTIONS(12900),
    [anon_sym_PERCENT] = ACTIONS(12900),
    [sym_comment] = ACTIONS(87),
  },
  [10330] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12898),
    [sym__binary_star] = ACTIONS(12900),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(12900),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_elsif] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(12916),
    [anon_sym_GT_GT] = ACTIONS(12916),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(12898),
    [anon_sym_SLASH] = ACTIONS(12900),
    [anon_sym_PERCENT] = ACTIONS(12900),
    [sym_comment] = ACTIONS(87),
  },
  [10331] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12898),
    [sym__binary_star] = ACTIONS(12900),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(12902),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(12900),
    [anon_sym_AMP] = ACTIONS(12904),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_elsif] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(12916),
    [anon_sym_GT_GT] = ACTIONS(12916),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(12922),
    [anon_sym_PLUS] = ACTIONS(12898),
    [anon_sym_SLASH] = ACTIONS(12900),
    [anon_sym_PERCENT] = ACTIONS(12900),
    [sym_comment] = ACTIONS(87),
  },
  [10332] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(14771),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [10333] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(12898),
    [sym__binary_star] = ACTIONS(12900),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(12902),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(12900),
    [anon_sym_AMP] = ACTIONS(12904),
    [anon_sym_LT] = ACTIONS(12906),
    [anon_sym_end] = ACTIONS(5927),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_elsif] = ACTIONS(5927),
    [anon_sym_else] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(12910),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12912),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(12914),
    [anon_sym_AMP_AMP] = ACTIONS(12914),
    [anon_sym_LT_LT] = ACTIONS(12916),
    [anon_sym_GT_GT] = ACTIONS(12916),
    [anon_sym_EQ_EQ] = ACTIONS(12918),
    [anon_sym_BANG_EQ] = ACTIONS(12914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12914),
    [anon_sym_LT_EQ_GT] = ACTIONS(12914),
    [anon_sym_EQ_TILDE] = ACTIONS(12914),
    [anon_sym_BANG_TILDE] = ACTIONS(12914),
    [anon_sym_LT_EQ] = ACTIONS(12906),
    [anon_sym_GT] = ACTIONS(12906),
    [anon_sym_GT_EQ] = ACTIONS(12920),
    [anon_sym_CARET] = ACTIONS(12922),
    [anon_sym_PLUS] = ACTIONS(12898),
    [anon_sym_SLASH] = ACTIONS(12900),
    [anon_sym_PERCENT] = ACTIONS(12900),
    [sym_comment] = ACTIONS(87),
  },
  [10334] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12898),
    [sym__binary_star] = ACTIONS(12900),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(12902),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(12900),
    [anon_sym_AMP] = ACTIONS(12904),
    [anon_sym_LT] = ACTIONS(12906),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_elsif] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(12908),
    [anon_sym_DOT_DOT] = ACTIONS(12910),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12912),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(12914),
    [anon_sym_AMP_AMP] = ACTIONS(12914),
    [anon_sym_LT_LT] = ACTIONS(12916),
    [anon_sym_GT_GT] = ACTIONS(12916),
    [anon_sym_EQ_EQ] = ACTIONS(12918),
    [anon_sym_BANG_EQ] = ACTIONS(12914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12914),
    [anon_sym_LT_EQ_GT] = ACTIONS(12914),
    [anon_sym_EQ_TILDE] = ACTIONS(12914),
    [anon_sym_BANG_TILDE] = ACTIONS(12914),
    [anon_sym_LT_EQ] = ACTIONS(12906),
    [anon_sym_GT] = ACTIONS(12906),
    [anon_sym_GT_EQ] = ACTIONS(12920),
    [anon_sym_CARET] = ACTIONS(12922),
    [anon_sym_PLUS] = ACTIONS(12898),
    [anon_sym_SLASH] = ACTIONS(12900),
    [anon_sym_PERCENT] = ACTIONS(12900),
    [sym_comment] = ACTIONS(87),
  },
  [10335] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12898),
    [sym__binary_star] = ACTIONS(12900),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(12902),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(12900),
    [anon_sym_AMP] = ACTIONS(12904),
    [anon_sym_LT] = ACTIONS(12906),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_elsif] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(12916),
    [anon_sym_GT_GT] = ACTIONS(12916),
    [anon_sym_EQ_EQ] = ACTIONS(12918),
    [anon_sym_BANG_EQ] = ACTIONS(12914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12914),
    [anon_sym_LT_EQ_GT] = ACTIONS(12914),
    [anon_sym_EQ_TILDE] = ACTIONS(12914),
    [anon_sym_BANG_TILDE] = ACTIONS(12914),
    [anon_sym_LT_EQ] = ACTIONS(12906),
    [anon_sym_GT] = ACTIONS(12906),
    [anon_sym_GT_EQ] = ACTIONS(12920),
    [anon_sym_CARET] = ACTIONS(12922),
    [anon_sym_PLUS] = ACTIONS(12898),
    [anon_sym_SLASH] = ACTIONS(12900),
    [anon_sym_PERCENT] = ACTIONS(12900),
    [sym_comment] = ACTIONS(87),
  },
  [10336] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12898),
    [sym__binary_star] = ACTIONS(12900),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(12900),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_elsif] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(12898),
    [anon_sym_SLASH] = ACTIONS(12900),
    [anon_sym_PERCENT] = ACTIONS(12900),
    [sym_comment] = ACTIONS(87),
  },
  [10337] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(12898),
    [sym__binary_star] = ACTIONS(12900),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(12902),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(12900),
    [anon_sym_AMP] = ACTIONS(12904),
    [anon_sym_LT] = ACTIONS(12906),
    [anon_sym_end] = ACTIONS(5115),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_elsif] = ACTIONS(5115),
    [anon_sym_else] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(12908),
    [anon_sym_DOT_DOT] = ACTIONS(12910),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12912),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(12914),
    [anon_sym_AMP_AMP] = ACTIONS(12914),
    [anon_sym_LT_LT] = ACTIONS(12916),
    [anon_sym_GT_GT] = ACTIONS(12916),
    [anon_sym_EQ_EQ] = ACTIONS(12918),
    [anon_sym_BANG_EQ] = ACTIONS(12914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12914),
    [anon_sym_LT_EQ_GT] = ACTIONS(12914),
    [anon_sym_EQ_TILDE] = ACTIONS(12914),
    [anon_sym_BANG_TILDE] = ACTIONS(12914),
    [anon_sym_LT_EQ] = ACTIONS(12906),
    [anon_sym_GT] = ACTIONS(12906),
    [anon_sym_GT_EQ] = ACTIONS(12920),
    [anon_sym_CARET] = ACTIONS(12922),
    [anon_sym_PLUS] = ACTIONS(12898),
    [anon_sym_SLASH] = ACTIONS(12900),
    [anon_sym_PERCENT] = ACTIONS(12900),
    [sym_comment] = ACTIONS(87),
  },
  [10338] = {
    [aux_sym_exceptions_repeat1] = STATE(10907),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_end] = ACTIONS(6191),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_elsif] = ACTIONS(6191),
    [anon_sym_else] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [10339] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(12898),
    [sym__binary_star] = ACTIONS(12900),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(12902),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(12900),
    [anon_sym_AMP] = ACTIONS(12904),
    [anon_sym_LT] = ACTIONS(12906),
    [anon_sym_end] = ACTIONS(6210),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_elsif] = ACTIONS(6210),
    [anon_sym_else] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(12908),
    [anon_sym_DOT_DOT] = ACTIONS(12910),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12912),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(12914),
    [anon_sym_AMP_AMP] = ACTIONS(12914),
    [anon_sym_LT_LT] = ACTIONS(12916),
    [anon_sym_GT_GT] = ACTIONS(12916),
    [anon_sym_EQ_EQ] = ACTIONS(12918),
    [anon_sym_BANG_EQ] = ACTIONS(12914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12914),
    [anon_sym_LT_EQ_GT] = ACTIONS(12914),
    [anon_sym_EQ_TILDE] = ACTIONS(12914),
    [anon_sym_BANG_TILDE] = ACTIONS(12914),
    [anon_sym_LT_EQ] = ACTIONS(12906),
    [anon_sym_GT] = ACTIONS(12906),
    [anon_sym_GT_EQ] = ACTIONS(12920),
    [anon_sym_CARET] = ACTIONS(12922),
    [anon_sym_PLUS] = ACTIONS(12898),
    [anon_sym_SLASH] = ACTIONS(12900),
    [anon_sym_PERCENT] = ACTIONS(12900),
    [sym_comment] = ACTIONS(87),
  },
  [10340] = {
    [sym_string] = STATE(10340),
    [aux_sym_chained_string_repeat1] = STATE(10340),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(6214),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_end] = ACTIONS(6212),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_elsif] = ACTIONS(6212),
    [anon_sym_else] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [10341] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(11033),
    [sym__binary_star] = ACTIONS(11035),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(11037),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(11035),
    [anon_sym_AMP] = ACTIONS(11039),
    [anon_sym_LT] = ACTIONS(11041),
    [anon_sym_end] = ACTIONS(6823),
    [anon_sym_if] = ACTIONS(6823),
    [anon_sym_unless] = ACTIONS(6823),
    [anon_sym_while] = ACTIONS(6823),
    [anon_sym_until] = ACTIONS(6823),
    [anon_sym_rescue] = ACTIONS(6823),
    [anon_sym_elsif] = ACTIONS(6823),
    [anon_sym_else] = ACTIONS(6823),
    [anon_sym_EQ_GT] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(11043),
    [anon_sym_DOT_DOT] = ACTIONS(11045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11047),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(11049),
    [anon_sym_AMP_AMP] = ACTIONS(11049),
    [anon_sym_LT_LT] = ACTIONS(11051),
    [anon_sym_GT_GT] = ACTIONS(11051),
    [anon_sym_EQ_EQ] = ACTIONS(11053),
    [anon_sym_BANG_EQ] = ACTIONS(11049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11049),
    [anon_sym_LT_EQ_GT] = ACTIONS(11049),
    [anon_sym_EQ_TILDE] = ACTIONS(11049),
    [anon_sym_BANG_TILDE] = ACTIONS(11049),
    [anon_sym_LT_EQ] = ACTIONS(11041),
    [anon_sym_GT] = ACTIONS(11041),
    [anon_sym_GT_EQ] = ACTIONS(11055),
    [anon_sym_CARET] = ACTIONS(11057),
    [anon_sym_PLUS] = ACTIONS(11033),
    [anon_sym_SLASH] = ACTIONS(11035),
    [anon_sym_PERCENT] = ACTIONS(11035),
    [sym_comment] = ACTIONS(87),
  },
  [10342] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(11033),
    [sym__binary_star] = ACTIONS(11035),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(11037),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(11035),
    [anon_sym_AMP] = ACTIONS(11039),
    [anon_sym_LT] = ACTIONS(11041),
    [anon_sym_end] = ACTIONS(7027),
    [anon_sym_if] = ACTIONS(7027),
    [anon_sym_unless] = ACTIONS(7027),
    [anon_sym_while] = ACTIONS(7027),
    [anon_sym_until] = ACTIONS(7027),
    [anon_sym_rescue] = ACTIONS(7027),
    [anon_sym_elsif] = ACTIONS(7027),
    [anon_sym_else] = ACTIONS(7027),
    [anon_sym_EQ_GT] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(11043),
    [anon_sym_DOT_DOT] = ACTIONS(11045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11047),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(11049),
    [anon_sym_AMP_AMP] = ACTIONS(11049),
    [anon_sym_LT_LT] = ACTIONS(11051),
    [anon_sym_GT_GT] = ACTIONS(11051),
    [anon_sym_EQ_EQ] = ACTIONS(11053),
    [anon_sym_BANG_EQ] = ACTIONS(11049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11049),
    [anon_sym_LT_EQ_GT] = ACTIONS(11049),
    [anon_sym_EQ_TILDE] = ACTIONS(11049),
    [anon_sym_BANG_TILDE] = ACTIONS(11049),
    [anon_sym_LT_EQ] = ACTIONS(11041),
    [anon_sym_GT] = ACTIONS(11041),
    [anon_sym_GT_EQ] = ACTIONS(11055),
    [anon_sym_CARET] = ACTIONS(11057),
    [anon_sym_PLUS] = ACTIONS(11033),
    [anon_sym_SLASH] = ACTIONS(11035),
    [anon_sym_PERCENT] = ACTIONS(11035),
    [sym_comment] = ACTIONS(87),
  },
  [10343] = {
    [sym_heredoc_body] = STATE(10343),
    [aux_sym_call_repeat1] = STATE(10343),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(7916),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_end] = ACTIONS(7914),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_elsif] = ACTIONS(7914),
    [anon_sym_else] = ACTIONS(7914),
    [anon_sym_EQ_GT] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [10344] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7493),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5061),
    [sym_scope_resolution] = STATE(5057),
    [sym_call] = STATE(5057),
    [sym_method_call] = STATE(5061),
    [sym__argument] = STATE(4986),
    [sym_splat_argument] = STATE(4986),
    [sym_hash_splat_argument] = STATE(4986),
    [sym_block_argument] = STATE(4986),
    [sym_assignment] = STATE(7493),
    [sym_operator_assignment] = STATE(7493),
    [sym_conditional] = STATE(7493),
    [sym_range] = STATE(7493),
    [sym_binary] = STATE(7493),
    [sym_unary] = STATE(7493),
    [sym_left_assignment_list] = STATE(5060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5061),
    [sym__variable] = STATE(5057),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5061),
    [sym_false] = STATE(5061),
    [sym_nil] = STATE(5061),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7496),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4986),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(11023),
    [sym__splat_star] = ACTIONS(11025),
    [sym__unary_minus] = ACTIONS(7994),
    [sym__identifier_hash_key] = ACTIONS(11027),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(14088),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7998),
    [anon_sym_yield] = ACTIONS(8000),
    [anon_sym_break] = ACTIONS(8002),
    [anon_sym_next] = ACTIONS(8004),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11019),
    [anon_sym_defined_QMARK] = ACTIONS(8006),
    [anon_sym_not] = ACTIONS(8008),
    [anon_sym_BANG] = ACTIONS(8012),
    [anon_sym_TILDE] = ACTIONS(8012),
    [sym_constant] = ACTIONS(11029),
    [sym_identifier] = ACTIONS(11029),
    [sym_instance_variable] = ACTIONS(8016),
    [sym_class_variable] = ACTIONS(8016),
    [sym_global_variable] = ACTIONS(8016),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8018),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8018),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10345] = {
    [sym_heredoc_body] = STATE(10343),
    [aux_sym_call_repeat1] = STATE(10343),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_end] = ACTIONS(7929),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_elsif] = ACTIONS(7929),
    [anon_sym_else] = ACTIONS(7929),
    [anon_sym_EQ_GT] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [10346] = {
    [aux_sym_argument_list_repeat1] = STATE(10346),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(14773),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7925),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_end] = ACTIONS(7925),
    [anon_sym_if] = ACTIONS(7925),
    [anon_sym_unless] = ACTIONS(7925),
    [anon_sym_while] = ACTIONS(7925),
    [anon_sym_until] = ACTIONS(7925),
    [anon_sym_rescue] = ACTIONS(7925),
    [anon_sym_elsif] = ACTIONS(7925),
    [anon_sym_else] = ACTIONS(7925),
    [anon_sym_EQ_GT] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7925),
    [anon_sym_AMP_AMP] = ACTIONS(7925),
    [anon_sym_LT_LT] = ACTIONS(7925),
    [anon_sym_GT_GT] = ACTIONS(7925),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7925),
    [anon_sym_PLUS] = ACTIONS(7925),
    [anon_sym_SLASH] = ACTIONS(7925),
    [anon_sym_PERCENT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [10347] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10908),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5061),
    [sym_scope_resolution] = STATE(5057),
    [sym_call] = STATE(5057),
    [sym_method_call] = STATE(5061),
    [sym_assignment] = STATE(10908),
    [sym_operator_assignment] = STATE(10908),
    [sym_conditional] = STATE(10908),
    [sym_range] = STATE(10908),
    [sym_binary] = STATE(10908),
    [sym_unary] = STATE(10908),
    [sym_left_assignment_list] = STATE(5060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5061),
    [sym__variable] = STATE(5057),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5061),
    [sym_false] = STATE(5061),
    [sym_nil] = STATE(5061),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7485),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(7994),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7998),
    [anon_sym_yield] = ACTIONS(8000),
    [anon_sym_break] = ACTIONS(8002),
    [anon_sym_next] = ACTIONS(8004),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11019),
    [anon_sym_defined_QMARK] = ACTIONS(8006),
    [anon_sym_not] = ACTIONS(8008),
    [anon_sym_BANG] = ACTIONS(8012),
    [anon_sym_TILDE] = ACTIONS(8012),
    [sym_constant] = ACTIONS(8018),
    [sym_identifier] = ACTIONS(8018),
    [sym_instance_variable] = ACTIONS(8016),
    [sym_class_variable] = ACTIONS(8016),
    [sym_global_variable] = ACTIONS(8016),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8018),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8018),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10348] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(11105),
    [sym__binary_star] = ACTIONS(11107),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(11109),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(11111),
    [anon_sym_AMP] = ACTIONS(11113),
    [anon_sym_EQ] = ACTIONS(7822),
    [anon_sym_LT] = ACTIONS(11115),
    [anon_sym_end] = ACTIONS(6823),
    [anon_sym_if] = ACTIONS(6823),
    [anon_sym_unless] = ACTIONS(6823),
    [anon_sym_while] = ACTIONS(6823),
    [anon_sym_until] = ACTIONS(6823),
    [anon_sym_rescue] = ACTIONS(6823),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_elsif] = ACTIONS(6823),
    [anon_sym_else] = ACTIONS(6823),
    [anon_sym_EQ_GT] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_PLUS_EQ] = ACTIONS(6823),
    [anon_sym_DASH_EQ] = ACTIONS(6823),
    [anon_sym_STAR_EQ] = ACTIONS(6823),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6823),
    [anon_sym_SLASH_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6823),
    [anon_sym_AMP_EQ] = ACTIONS(6823),
    [anon_sym_PERCENT_EQ] = ACTIONS(6823),
    [anon_sym_GT_GT_EQ] = ACTIONS(6823),
    [anon_sym_LT_LT_EQ] = ACTIONS(6823),
    [anon_sym_CARET_EQ] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(11117),
    [anon_sym_DOT_DOT] = ACTIONS(11119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11121),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(11123),
    [anon_sym_AMP_AMP] = ACTIONS(11123),
    [anon_sym_LT_LT] = ACTIONS(11125),
    [anon_sym_GT_GT] = ACTIONS(11125),
    [anon_sym_EQ_EQ] = ACTIONS(11123),
    [anon_sym_BANG_EQ] = ACTIONS(11127),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11127),
    [anon_sym_LT_EQ_GT] = ACTIONS(11127),
    [anon_sym_EQ_TILDE] = ACTIONS(11127),
    [anon_sym_BANG_TILDE] = ACTIONS(11127),
    [anon_sym_LT_EQ] = ACTIONS(11115),
    [anon_sym_GT] = ACTIONS(11115),
    [anon_sym_GT_EQ] = ACTIONS(11129),
    [anon_sym_CARET] = ACTIONS(11109),
    [anon_sym_PLUS] = ACTIONS(11131),
    [anon_sym_SLASH] = ACTIONS(11111),
    [anon_sym_PERCENT] = ACTIONS(11111),
    [sym_comment] = ACTIONS(87),
  },
  [10349] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(11105),
    [sym__binary_star] = ACTIONS(11107),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(11109),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(11111),
    [anon_sym_AMP] = ACTIONS(11113),
    [anon_sym_EQ] = ACTIONS(7884),
    [anon_sym_LT] = ACTIONS(11115),
    [anon_sym_end] = ACTIONS(7027),
    [anon_sym_if] = ACTIONS(7027),
    [anon_sym_unless] = ACTIONS(7027),
    [anon_sym_while] = ACTIONS(7027),
    [anon_sym_until] = ACTIONS(7027),
    [anon_sym_rescue] = ACTIONS(7027),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_elsif] = ACTIONS(7027),
    [anon_sym_else] = ACTIONS(7027),
    [anon_sym_EQ_GT] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_PLUS_EQ] = ACTIONS(7027),
    [anon_sym_DASH_EQ] = ACTIONS(7027),
    [anon_sym_STAR_EQ] = ACTIONS(7027),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7027),
    [anon_sym_SLASH_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7027),
    [anon_sym_AMP_EQ] = ACTIONS(7027),
    [anon_sym_PERCENT_EQ] = ACTIONS(7027),
    [anon_sym_GT_GT_EQ] = ACTIONS(7027),
    [anon_sym_LT_LT_EQ] = ACTIONS(7027),
    [anon_sym_CARET_EQ] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(11117),
    [anon_sym_DOT_DOT] = ACTIONS(11119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11121),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(11123),
    [anon_sym_AMP_AMP] = ACTIONS(11123),
    [anon_sym_LT_LT] = ACTIONS(11125),
    [anon_sym_GT_GT] = ACTIONS(11125),
    [anon_sym_EQ_EQ] = ACTIONS(11123),
    [anon_sym_BANG_EQ] = ACTIONS(11127),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11127),
    [anon_sym_LT_EQ_GT] = ACTIONS(11127),
    [anon_sym_EQ_TILDE] = ACTIONS(11127),
    [anon_sym_BANG_TILDE] = ACTIONS(11127),
    [anon_sym_LT_EQ] = ACTIONS(11115),
    [anon_sym_GT] = ACTIONS(11115),
    [anon_sym_GT_EQ] = ACTIONS(11129),
    [anon_sym_CARET] = ACTIONS(11109),
    [anon_sym_PLUS] = ACTIONS(11131),
    [anon_sym_SLASH] = ACTIONS(11111),
    [anon_sym_PERCENT] = ACTIONS(11111),
    [sym_comment] = ACTIONS(87),
  },
  [10350] = {
    [sym_heredoc_body] = STATE(10350),
    [aux_sym_call_repeat1] = STATE(10350),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(10978),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7919),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_EQ] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_end] = ACTIONS(7914),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_elsif] = ACTIONS(7914),
    [anon_sym_else] = ACTIONS(7914),
    [anon_sym_EQ_GT] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_PLUS_EQ] = ACTIONS(7914),
    [anon_sym_DASH_EQ] = ACTIONS(7914),
    [anon_sym_STAR_EQ] = ACTIONS(7914),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7914),
    [anon_sym_SLASH_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7914),
    [anon_sym_AMP_EQ] = ACTIONS(7914),
    [anon_sym_PERCENT_EQ] = ACTIONS(7914),
    [anon_sym_GT_GT_EQ] = ACTIONS(7914),
    [anon_sym_LT_LT_EQ] = ACTIONS(7914),
    [anon_sym_CARET_EQ] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7919),
    [anon_sym_AMP_AMP] = ACTIONS(7919),
    [anon_sym_LT_LT] = ACTIONS(7919),
    [anon_sym_GT_GT] = ACTIONS(7919),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7919),
    [anon_sym_PLUS] = ACTIONS(7919),
    [anon_sym_SLASH] = ACTIONS(7919),
    [anon_sym_PERCENT] = ACTIONS(7919),
    [sym_comment] = ACTIONS(87),
  },
  [10351] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(7514),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5097),
    [sym_scope_resolution] = STATE(5093),
    [sym_call] = STATE(5093),
    [sym_method_call] = STATE(5097),
    [sym__argument] = STATE(7437),
    [sym_splat_argument] = STATE(7437),
    [sym_hash_splat_argument] = STATE(7437),
    [sym_block_argument] = STATE(7437),
    [sym_assignment] = STATE(7514),
    [sym_operator_assignment] = STATE(7514),
    [sym_conditional] = STATE(7514),
    [sym_range] = STATE(7514),
    [sym_binary] = STATE(7514),
    [sym_unary] = STATE(7514),
    [sym_left_assignment_list] = STATE(5096),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5097),
    [sym__variable] = STATE(5093),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5097),
    [sym_false] = STATE(5097),
    [sym_nil] = STATE(5097),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7517),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(7437),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(11059),
    [sym__splat_star] = ACTIONS(11061),
    [sym__unary_minus] = ACTIONS(8066),
    [sym__identifier_hash_key] = ACTIONS(11063),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(14092),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(8070),
    [anon_sym_yield] = ACTIONS(8072),
    [anon_sym_break] = ACTIONS(8074),
    [anon_sym_next] = ACTIONS(8076),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(11099),
    [anon_sym_defined_QMARK] = ACTIONS(8078),
    [anon_sym_not] = ACTIONS(8080),
    [anon_sym_BANG] = ACTIONS(8084),
    [anon_sym_TILDE] = ACTIONS(8084),
    [sym_constant] = ACTIONS(11065),
    [sym_identifier] = ACTIONS(11065),
    [sym_instance_variable] = ACTIONS(8088),
    [sym_class_variable] = ACTIONS(8088),
    [sym_global_variable] = ACTIONS(8088),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8090),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8090),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [10352] = {
    [sym_heredoc_body] = STATE(10350),
    [aux_sym_call_repeat1] = STATE(10350),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7931),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_EQ] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_end] = ACTIONS(7929),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_elsif] = ACTIONS(7929),
    [anon_sym_else] = ACTIONS(7929),
    [anon_sym_EQ_GT] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_PLUS_EQ] = ACTIONS(7929),
    [anon_sym_DASH_EQ] = ACTIONS(7929),
    [anon_sym_STAR_EQ] = ACTIONS(7929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7929),
    [anon_sym_SLASH_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7929),
    [anon_sym_AMP_EQ] = ACTIONS(7929),
    [anon_sym_PERCENT_EQ] = ACTIONS(7929),
    [anon_sym_GT_GT_EQ] = ACTIONS(7929),
    [anon_sym_LT_LT_EQ] = ACTIONS(7929),
    [anon_sym_CARET_EQ] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7931),
    [anon_sym_AMP_AMP] = ACTIONS(7931),
    [anon_sym_LT_LT] = ACTIONS(7931),
    [anon_sym_GT_GT] = ACTIONS(7931),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7931),
    [anon_sym_PLUS] = ACTIONS(7931),
    [anon_sym_SLASH] = ACTIONS(7931),
    [anon_sym_PERCENT] = ACTIONS(7931),
    [sym_comment] = ACTIONS(87),
  },
  [10353] = {
    [aux_sym_argument_list_repeat1] = STATE(10353),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(14776),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7927),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_EQ] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_end] = ACTIONS(7925),
    [anon_sym_if] = ACTIONS(7925),
    [anon_sym_unless] = ACTIONS(7925),
    [anon_sym_while] = ACTIONS(7925),
    [anon_sym_until] = ACTIONS(7925),
    [anon_sym_rescue] = ACTIONS(7925),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_elsif] = ACTIONS(7925),
    [anon_sym_else] = ACTIONS(7925),
    [anon_sym_EQ_GT] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_PLUS_EQ] = ACTIONS(7925),
    [anon_sym_DASH_EQ] = ACTIONS(7925),
    [anon_sym_STAR_EQ] = ACTIONS(7925),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7925),
    [anon_sym_SLASH_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7925),
    [anon_sym_AMP_EQ] = ACTIONS(7925),
    [anon_sym_PERCENT_EQ] = ACTIONS(7925),
    [anon_sym_GT_GT_EQ] = ACTIONS(7925),
    [anon_sym_LT_LT_EQ] = ACTIONS(7925),
    [anon_sym_CARET_EQ] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7927),
    [anon_sym_AMP_AMP] = ACTIONS(7927),
    [anon_sym_LT_LT] = ACTIONS(7927),
    [anon_sym_GT_GT] = ACTIONS(7927),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7927),
    [anon_sym_PLUS] = ACTIONS(7927),
    [anon_sym_SLASH] = ACTIONS(7927),
    [anon_sym_PERCENT] = ACTIONS(7927),
    [sym_comment] = ACTIONS(87),
  },
  [10354] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9326),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5061),
    [sym_scope_resolution] = STATE(5057),
    [sym_call] = STATE(5057),
    [sym_method_call] = STATE(5061),
    [sym_splat_argument] = STATE(7439),
    [sym_assignment] = STATE(9326),
    [sym_operator_assignment] = STATE(9326),
    [sym_conditional] = STATE(9326),
    [sym_range] = STATE(9326),
    [sym_binary] = STATE(9326),
    [sym_unary] = STATE(9326),
    [sym__arg_or_splat_arg] = STATE(7439),
    [sym_left_assignment_list] = STATE(5060),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5061),
    [sym__variable] = STATE(5057),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5061),
    [sym_false] = STATE(5061),
    [sym_nil] = STATE(5061),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7485),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__splat_star] = ACTIONS(11025),
    [sym__unary_minus] = ACTIONS(7994),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7998),
    [anon_sym_yield] = ACTIONS(8000),
    [anon_sym_break] = ACTIONS(8002),
    [anon_sym_next] = ACTIONS(8004),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11019),
    [anon_sym_defined_QMARK] = ACTIONS(8006),
    [anon_sym_not] = ACTIONS(8008),
    [anon_sym_BANG] = ACTIONS(8012),
    [anon_sym_TILDE] = ACTIONS(8012),
    [sym_constant] = ACTIONS(8018),
    [sym_identifier] = ACTIONS(8018),
    [sym_instance_variable] = ACTIONS(8016),
    [sym_class_variable] = ACTIONS(8016),
    [sym_global_variable] = ACTIONS(8016),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8018),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8018),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10355] = {
    [aux_sym_exceptions_repeat1] = STATE(10909),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(14779),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_end] = ACTIONS(9855),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_elsif] = ACTIONS(9855),
    [anon_sym_else] = ACTIONS(9855),
    [anon_sym_EQ_GT] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [10356] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(8034),
    [sym__binary_star] = ACTIONS(8036),
    [anon_sym_PIPE] = ACTIONS(8038),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(8036),
    [anon_sym_AMP] = ACTIONS(8040),
    [anon_sym_LT] = ACTIONS(8042),
    [anon_sym_end] = ACTIONS(12120),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_elsif] = ACTIONS(12120),
    [anon_sym_else] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(8044),
    [anon_sym_DOT_DOT] = ACTIONS(8046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8048),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(8052),
    [anon_sym_AMP_AMP] = ACTIONS(8052),
    [anon_sym_LT_LT] = ACTIONS(8054),
    [anon_sym_GT_GT] = ACTIONS(8054),
    [anon_sym_EQ_EQ] = ACTIONS(8056),
    [anon_sym_BANG_EQ] = ACTIONS(8052),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8052),
    [anon_sym_LT_EQ_GT] = ACTIONS(8052),
    [anon_sym_EQ_TILDE] = ACTIONS(8052),
    [anon_sym_BANG_TILDE] = ACTIONS(8052),
    [anon_sym_LT_EQ] = ACTIONS(8042),
    [anon_sym_GT] = ACTIONS(8042),
    [anon_sym_GT_EQ] = ACTIONS(8058),
    [anon_sym_CARET] = ACTIONS(8060),
    [anon_sym_PLUS] = ACTIONS(8034),
    [anon_sym_SLASH] = ACTIONS(8036),
    [anon_sym_PERCENT] = ACTIONS(8036),
    [sym_comment] = ACTIONS(87),
  },
  [10357] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(12952),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(12956),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_elsif] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(12956),
    [anon_sym_PERCENT] = ACTIONS(12956),
    [sym_comment] = ACTIONS(87),
  },
  [10358] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(12956),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_elsif] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(5827),
    [anon_sym_PERCENT] = ACTIONS(5827),
    [sym_comment] = ACTIONS(87),
  },
  [10359] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12950),
    [sym__binary_star] = ACTIONS(12952),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(12956),
    [anon_sym_AMP] = ACTIONS(12958),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_elsif] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(12970),
    [anon_sym_GT_GT] = ACTIONS(12970),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(12976),
    [anon_sym_SLASH] = ACTIONS(12956),
    [anon_sym_PERCENT] = ACTIONS(12956),
    [sym_comment] = ACTIONS(87),
  },
  [10360] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12950),
    [sym__binary_star] = ACTIONS(12952),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(12956),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_elsif] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(12970),
    [anon_sym_GT_GT] = ACTIONS(12970),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(12976),
    [anon_sym_SLASH] = ACTIONS(12956),
    [anon_sym_PERCENT] = ACTIONS(12956),
    [sym_comment] = ACTIONS(87),
  },
  [10361] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12950),
    [sym__binary_star] = ACTIONS(12952),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(12954),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(12956),
    [anon_sym_AMP] = ACTIONS(12958),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_elsif] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(12970),
    [anon_sym_GT_GT] = ACTIONS(12970),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(12954),
    [anon_sym_PLUS] = ACTIONS(12976),
    [anon_sym_SLASH] = ACTIONS(12956),
    [anon_sym_PERCENT] = ACTIONS(12956),
    [sym_comment] = ACTIONS(87),
  },
  [10362] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(14781),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [10363] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(12950),
    [sym__binary_star] = ACTIONS(12952),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(12954),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(12956),
    [anon_sym_AMP] = ACTIONS(12958),
    [anon_sym_EQ] = ACTIONS(7888),
    [anon_sym_LT] = ACTIONS(12960),
    [anon_sym_end] = ACTIONS(5927),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_elsif] = ACTIONS(5927),
    [anon_sym_else] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_PLUS_EQ] = ACTIONS(5927),
    [anon_sym_DASH_EQ] = ACTIONS(5927),
    [anon_sym_STAR_EQ] = ACTIONS(5927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5927),
    [anon_sym_SLASH_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5927),
    [anon_sym_AMP_EQ] = ACTIONS(5927),
    [anon_sym_PERCENT_EQ] = ACTIONS(5927),
    [anon_sym_GT_GT_EQ] = ACTIONS(5927),
    [anon_sym_LT_LT_EQ] = ACTIONS(5927),
    [anon_sym_CARET_EQ] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(12964),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12966),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(12968),
    [anon_sym_AMP_AMP] = ACTIONS(12968),
    [anon_sym_LT_LT] = ACTIONS(12970),
    [anon_sym_GT_GT] = ACTIONS(12970),
    [anon_sym_EQ_EQ] = ACTIONS(12968),
    [anon_sym_BANG_EQ] = ACTIONS(12972),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12972),
    [anon_sym_LT_EQ_GT] = ACTIONS(12972),
    [anon_sym_EQ_TILDE] = ACTIONS(12972),
    [anon_sym_BANG_TILDE] = ACTIONS(12972),
    [anon_sym_LT_EQ] = ACTIONS(12960),
    [anon_sym_GT] = ACTIONS(12960),
    [anon_sym_GT_EQ] = ACTIONS(12974),
    [anon_sym_CARET] = ACTIONS(12954),
    [anon_sym_PLUS] = ACTIONS(12976),
    [anon_sym_SLASH] = ACTIONS(12956),
    [anon_sym_PERCENT] = ACTIONS(12956),
    [sym_comment] = ACTIONS(87),
  },
  [10364] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12950),
    [sym__binary_star] = ACTIONS(12952),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(12954),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(12956),
    [anon_sym_AMP] = ACTIONS(12958),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(12960),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_elsif] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(12962),
    [anon_sym_DOT_DOT] = ACTIONS(12964),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12966),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(12968),
    [anon_sym_AMP_AMP] = ACTIONS(12968),
    [anon_sym_LT_LT] = ACTIONS(12970),
    [anon_sym_GT_GT] = ACTIONS(12970),
    [anon_sym_EQ_EQ] = ACTIONS(12968),
    [anon_sym_BANG_EQ] = ACTIONS(12972),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12972),
    [anon_sym_LT_EQ_GT] = ACTIONS(12972),
    [anon_sym_EQ_TILDE] = ACTIONS(12972),
    [anon_sym_BANG_TILDE] = ACTIONS(12972),
    [anon_sym_LT_EQ] = ACTIONS(12960),
    [anon_sym_GT] = ACTIONS(12960),
    [anon_sym_GT_EQ] = ACTIONS(12974),
    [anon_sym_CARET] = ACTIONS(12954),
    [anon_sym_PLUS] = ACTIONS(12976),
    [anon_sym_SLASH] = ACTIONS(12956),
    [anon_sym_PERCENT] = ACTIONS(12956),
    [sym_comment] = ACTIONS(87),
  },
  [10365] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12950),
    [sym__binary_star] = ACTIONS(12952),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(12954),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(12956),
    [anon_sym_AMP] = ACTIONS(12958),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(12960),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_elsif] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(12970),
    [anon_sym_GT_GT] = ACTIONS(12970),
    [anon_sym_EQ_EQ] = ACTIONS(12968),
    [anon_sym_BANG_EQ] = ACTIONS(12972),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12972),
    [anon_sym_LT_EQ_GT] = ACTIONS(12972),
    [anon_sym_EQ_TILDE] = ACTIONS(12972),
    [anon_sym_BANG_TILDE] = ACTIONS(12972),
    [anon_sym_LT_EQ] = ACTIONS(12960),
    [anon_sym_GT] = ACTIONS(12960),
    [anon_sym_GT_EQ] = ACTIONS(12974),
    [anon_sym_CARET] = ACTIONS(12954),
    [anon_sym_PLUS] = ACTIONS(12976),
    [anon_sym_SLASH] = ACTIONS(12956),
    [anon_sym_PERCENT] = ACTIONS(12956),
    [sym_comment] = ACTIONS(87),
  },
  [10366] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12950),
    [sym__binary_star] = ACTIONS(12952),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(12956),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_elsif] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(12976),
    [anon_sym_SLASH] = ACTIONS(12956),
    [anon_sym_PERCENT] = ACTIONS(12956),
    [sym_comment] = ACTIONS(87),
  },
  [10367] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(12950),
    [sym__binary_star] = ACTIONS(12952),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(12954),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(12956),
    [anon_sym_AMP] = ACTIONS(12958),
    [anon_sym_EQ] = ACTIONS(7936),
    [anon_sym_LT] = ACTIONS(12960),
    [anon_sym_end] = ACTIONS(5115),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_elsif] = ACTIONS(5115),
    [anon_sym_else] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_PLUS_EQ] = ACTIONS(5115),
    [anon_sym_DASH_EQ] = ACTIONS(5115),
    [anon_sym_STAR_EQ] = ACTIONS(5115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5115),
    [anon_sym_SLASH_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5115),
    [anon_sym_AMP_EQ] = ACTIONS(5115),
    [anon_sym_PERCENT_EQ] = ACTIONS(5115),
    [anon_sym_GT_GT_EQ] = ACTIONS(5115),
    [anon_sym_LT_LT_EQ] = ACTIONS(5115),
    [anon_sym_CARET_EQ] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(12962),
    [anon_sym_DOT_DOT] = ACTIONS(12964),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12966),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(12968),
    [anon_sym_AMP_AMP] = ACTIONS(12968),
    [anon_sym_LT_LT] = ACTIONS(12970),
    [anon_sym_GT_GT] = ACTIONS(12970),
    [anon_sym_EQ_EQ] = ACTIONS(12968),
    [anon_sym_BANG_EQ] = ACTIONS(12972),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12972),
    [anon_sym_LT_EQ_GT] = ACTIONS(12972),
    [anon_sym_EQ_TILDE] = ACTIONS(12972),
    [anon_sym_BANG_TILDE] = ACTIONS(12972),
    [anon_sym_LT_EQ] = ACTIONS(12960),
    [anon_sym_GT] = ACTIONS(12960),
    [anon_sym_GT_EQ] = ACTIONS(12974),
    [anon_sym_CARET] = ACTIONS(12954),
    [anon_sym_PLUS] = ACTIONS(12976),
    [anon_sym_SLASH] = ACTIONS(12956),
    [anon_sym_PERCENT] = ACTIONS(12956),
    [sym_comment] = ACTIONS(87),
  },
  [10368] = {
    [aux_sym_exceptions_repeat1] = STATE(10912),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6193),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_end] = ACTIONS(6191),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_elsif] = ACTIONS(6191),
    [anon_sym_else] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_PLUS_EQ] = ACTIONS(6191),
    [anon_sym_DASH_EQ] = ACTIONS(6191),
    [anon_sym_STAR_EQ] = ACTIONS(6191),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6191),
    [anon_sym_SLASH_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6191),
    [anon_sym_AMP_EQ] = ACTIONS(6191),
    [anon_sym_PERCENT_EQ] = ACTIONS(6191),
    [anon_sym_GT_GT_EQ] = ACTIONS(6191),
    [anon_sym_LT_LT_EQ] = ACTIONS(6191),
    [anon_sym_CARET_EQ] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6193),
    [anon_sym_AMP_AMP] = ACTIONS(6193),
    [anon_sym_LT_LT] = ACTIONS(6193),
    [anon_sym_GT_GT] = ACTIONS(6193),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6193),
    [anon_sym_PLUS] = ACTIONS(6193),
    [anon_sym_SLASH] = ACTIONS(6193),
    [anon_sym_PERCENT] = ACTIONS(6193),
    [sym_comment] = ACTIONS(87),
  },
  [10369] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(12950),
    [sym__binary_star] = ACTIONS(12952),
    [anon_sym_LBRACE] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(12954),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(12956),
    [anon_sym_AMP] = ACTIONS(12958),
    [anon_sym_EQ] = ACTIONS(7938),
    [anon_sym_LT] = ACTIONS(12960),
    [anon_sym_end] = ACTIONS(6210),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_elsif] = ACTIONS(6210),
    [anon_sym_else] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_PLUS_EQ] = ACTIONS(6210),
    [anon_sym_DASH_EQ] = ACTIONS(6210),
    [anon_sym_STAR_EQ] = ACTIONS(6210),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6210),
    [anon_sym_SLASH_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6210),
    [anon_sym_AMP_EQ] = ACTIONS(6210),
    [anon_sym_PERCENT_EQ] = ACTIONS(6210),
    [anon_sym_GT_GT_EQ] = ACTIONS(6210),
    [anon_sym_LT_LT_EQ] = ACTIONS(6210),
    [anon_sym_CARET_EQ] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(12962),
    [anon_sym_DOT_DOT] = ACTIONS(12964),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12966),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(12968),
    [anon_sym_AMP_AMP] = ACTIONS(12968),
    [anon_sym_LT_LT] = ACTIONS(12970),
    [anon_sym_GT_GT] = ACTIONS(12970),
    [anon_sym_EQ_EQ] = ACTIONS(12968),
    [anon_sym_BANG_EQ] = ACTIONS(12972),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12972),
    [anon_sym_LT_EQ_GT] = ACTIONS(12972),
    [anon_sym_EQ_TILDE] = ACTIONS(12972),
    [anon_sym_BANG_TILDE] = ACTIONS(12972),
    [anon_sym_LT_EQ] = ACTIONS(12960),
    [anon_sym_GT] = ACTIONS(12960),
    [anon_sym_GT_EQ] = ACTIONS(12974),
    [anon_sym_CARET] = ACTIONS(12954),
    [anon_sym_PLUS] = ACTIONS(12976),
    [anon_sym_SLASH] = ACTIONS(12956),
    [anon_sym_PERCENT] = ACTIONS(12956),
    [sym_comment] = ACTIONS(87),
  },
  [10370] = {
    [sym_string] = STATE(10370),
    [aux_sym_chained_string_repeat1] = STATE(10370),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(12267),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6217),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_EQ] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_end] = ACTIONS(6212),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_do] = ACTIONS(6212),
    [anon_sym_elsif] = ACTIONS(6212),
    [anon_sym_else] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_PLUS_EQ] = ACTIONS(6212),
    [anon_sym_DASH_EQ] = ACTIONS(6212),
    [anon_sym_STAR_EQ] = ACTIONS(6212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6212),
    [anon_sym_SLASH_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6212),
    [anon_sym_AMP_EQ] = ACTIONS(6212),
    [anon_sym_PERCENT_EQ] = ACTIONS(6212),
    [anon_sym_GT_GT_EQ] = ACTIONS(6212),
    [anon_sym_LT_LT_EQ] = ACTIONS(6212),
    [anon_sym_CARET_EQ] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6217),
    [anon_sym_AMP_AMP] = ACTIONS(6217),
    [anon_sym_LT_LT] = ACTIONS(6217),
    [anon_sym_GT_GT] = ACTIONS(6217),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6217),
    [anon_sym_PLUS] = ACTIONS(6217),
    [anon_sym_SLASH] = ACTIONS(6217),
    [anon_sym_PERCENT] = ACTIONS(6217),
    [sym_comment] = ACTIONS(87),
  },
  [10371] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(10913),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5097),
    [sym_scope_resolution] = STATE(5093),
    [sym_call] = STATE(5093),
    [sym_method_call] = STATE(5097),
    [sym_assignment] = STATE(10913),
    [sym_operator_assignment] = STATE(10913),
    [sym_conditional] = STATE(10913),
    [sym_range] = STATE(10913),
    [sym_binary] = STATE(10913),
    [sym_unary] = STATE(10913),
    [sym_left_assignment_list] = STATE(5096),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5097),
    [sym__variable] = STATE(5093),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5097),
    [sym_false] = STATE(5097),
    [sym_nil] = STATE(5097),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7554),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(8066),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(8070),
    [anon_sym_yield] = ACTIONS(8072),
    [anon_sym_break] = ACTIONS(8074),
    [anon_sym_next] = ACTIONS(8076),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(11099),
    [anon_sym_defined_QMARK] = ACTIONS(8078),
    [anon_sym_not] = ACTIONS(8080),
    [anon_sym_BANG] = ACTIONS(8084),
    [anon_sym_TILDE] = ACTIONS(8084),
    [sym_constant] = ACTIONS(8090),
    [sym_identifier] = ACTIONS(8090),
    [sym_instance_variable] = ACTIONS(8088),
    [sym_class_variable] = ACTIONS(8088),
    [sym_global_variable] = ACTIONS(8088),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8090),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8090),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [10372] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(9363),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5097),
    [sym_scope_resolution] = STATE(5093),
    [sym_call] = STATE(5093),
    [sym_method_call] = STATE(5097),
    [sym_splat_argument] = STATE(8678),
    [sym_assignment] = STATE(9363),
    [sym_operator_assignment] = STATE(9363),
    [sym_conditional] = STATE(9363),
    [sym_range] = STATE(9363),
    [sym_binary] = STATE(9363),
    [sym_unary] = STATE(9363),
    [sym__arg_or_splat_arg] = STATE(8678),
    [sym_left_assignment_list] = STATE(5096),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5097),
    [sym__variable] = STATE(5093),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5097),
    [sym_false] = STATE(5097),
    [sym_nil] = STATE(5097),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7554),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__splat_star] = ACTIONS(11061),
    [sym__unary_minus] = ACTIONS(8066),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(8070),
    [anon_sym_yield] = ACTIONS(8072),
    [anon_sym_break] = ACTIONS(8074),
    [anon_sym_next] = ACTIONS(8076),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(11099),
    [anon_sym_defined_QMARK] = ACTIONS(8078),
    [anon_sym_not] = ACTIONS(8080),
    [anon_sym_BANG] = ACTIONS(8084),
    [anon_sym_TILDE] = ACTIONS(8084),
    [sym_constant] = ACTIONS(8090),
    [sym_identifier] = ACTIONS(8090),
    [sym_instance_variable] = ACTIONS(8088),
    [sym_class_variable] = ACTIONS(8088),
    [sym_global_variable] = ACTIONS(8088),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8090),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8090),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [10373] = {
    [aux_sym_exceptions_repeat1] = STATE(10914),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_LBRACE] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(14783),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9857),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_EQ] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_end] = ACTIONS(9855),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_do] = ACTIONS(9855),
    [anon_sym_elsif] = ACTIONS(9855),
    [anon_sym_else] = ACTIONS(9855),
    [anon_sym_EQ_GT] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_PLUS_EQ] = ACTIONS(9855),
    [anon_sym_DASH_EQ] = ACTIONS(9855),
    [anon_sym_STAR_EQ] = ACTIONS(9855),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9855),
    [anon_sym_SLASH_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9855),
    [anon_sym_AMP_EQ] = ACTIONS(9855),
    [anon_sym_PERCENT_EQ] = ACTIONS(9855),
    [anon_sym_GT_GT_EQ] = ACTIONS(9855),
    [anon_sym_LT_LT_EQ] = ACTIONS(9855),
    [anon_sym_CARET_EQ] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9857),
    [anon_sym_AMP_AMP] = ACTIONS(9857),
    [anon_sym_LT_LT] = ACTIONS(9857),
    [anon_sym_GT_GT] = ACTIONS(9857),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9857),
    [anon_sym_PLUS] = ACTIONS(9857),
    [anon_sym_SLASH] = ACTIONS(9857),
    [anon_sym_PERCENT] = ACTIONS(9857),
    [sym_comment] = ACTIONS(87),
  },
  [10374] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(12988),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(12988),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_elsif] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(12988),
    [anon_sym_PERCENT] = ACTIONS(12988),
    [sym_comment] = ACTIONS(87),
  },
  [10375] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(12988),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_elsif] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [10376] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12986),
    [sym__binary_star] = ACTIONS(12988),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(12988),
    [anon_sym_AMP] = ACTIONS(12992),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_elsif] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(13004),
    [anon_sym_GT_GT] = ACTIONS(13004),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(12986),
    [anon_sym_SLASH] = ACTIONS(12988),
    [anon_sym_PERCENT] = ACTIONS(12988),
    [sym_comment] = ACTIONS(87),
  },
  [10377] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12986),
    [sym__binary_star] = ACTIONS(12988),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(12988),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_elsif] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(13004),
    [anon_sym_GT_GT] = ACTIONS(13004),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(12986),
    [anon_sym_SLASH] = ACTIONS(12988),
    [anon_sym_PERCENT] = ACTIONS(12988),
    [sym_comment] = ACTIONS(87),
  },
  [10378] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12986),
    [sym__binary_star] = ACTIONS(12988),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(12990),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(12988),
    [anon_sym_AMP] = ACTIONS(12992),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_elsif] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(13004),
    [anon_sym_GT_GT] = ACTIONS(13004),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(13010),
    [anon_sym_PLUS] = ACTIONS(12986),
    [anon_sym_SLASH] = ACTIONS(12988),
    [anon_sym_PERCENT] = ACTIONS(12988),
    [sym_comment] = ACTIONS(87),
  },
  [10379] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(14785),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [10380] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(12986),
    [sym__binary_star] = ACTIONS(12988),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(12990),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(12988),
    [anon_sym_AMP] = ACTIONS(12992),
    [anon_sym_LT] = ACTIONS(12994),
    [anon_sym_end] = ACTIONS(5927),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_elsif] = ACTIONS(5927),
    [anon_sym_else] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(12998),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13000),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(13002),
    [anon_sym_AMP_AMP] = ACTIONS(13002),
    [anon_sym_LT_LT] = ACTIONS(13004),
    [anon_sym_GT_GT] = ACTIONS(13004),
    [anon_sym_EQ_EQ] = ACTIONS(13006),
    [anon_sym_BANG_EQ] = ACTIONS(13002),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13002),
    [anon_sym_LT_EQ_GT] = ACTIONS(13002),
    [anon_sym_EQ_TILDE] = ACTIONS(13002),
    [anon_sym_BANG_TILDE] = ACTIONS(13002),
    [anon_sym_LT_EQ] = ACTIONS(12994),
    [anon_sym_GT] = ACTIONS(12994),
    [anon_sym_GT_EQ] = ACTIONS(13008),
    [anon_sym_CARET] = ACTIONS(13010),
    [anon_sym_PLUS] = ACTIONS(12986),
    [anon_sym_SLASH] = ACTIONS(12988),
    [anon_sym_PERCENT] = ACTIONS(12988),
    [sym_comment] = ACTIONS(87),
  },
  [10381] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12986),
    [sym__binary_star] = ACTIONS(12988),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(12990),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(12988),
    [anon_sym_AMP] = ACTIONS(12992),
    [anon_sym_LT] = ACTIONS(12994),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_elsif] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(12996),
    [anon_sym_DOT_DOT] = ACTIONS(12998),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13000),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(13002),
    [anon_sym_AMP_AMP] = ACTIONS(13002),
    [anon_sym_LT_LT] = ACTIONS(13004),
    [anon_sym_GT_GT] = ACTIONS(13004),
    [anon_sym_EQ_EQ] = ACTIONS(13006),
    [anon_sym_BANG_EQ] = ACTIONS(13002),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13002),
    [anon_sym_LT_EQ_GT] = ACTIONS(13002),
    [anon_sym_EQ_TILDE] = ACTIONS(13002),
    [anon_sym_BANG_TILDE] = ACTIONS(13002),
    [anon_sym_LT_EQ] = ACTIONS(12994),
    [anon_sym_GT] = ACTIONS(12994),
    [anon_sym_GT_EQ] = ACTIONS(13008),
    [anon_sym_CARET] = ACTIONS(13010),
    [anon_sym_PLUS] = ACTIONS(12986),
    [anon_sym_SLASH] = ACTIONS(12988),
    [anon_sym_PERCENT] = ACTIONS(12988),
    [sym_comment] = ACTIONS(87),
  },
  [10382] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12986),
    [sym__binary_star] = ACTIONS(12988),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(12990),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(12988),
    [anon_sym_AMP] = ACTIONS(12992),
    [anon_sym_LT] = ACTIONS(12994),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_elsif] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(13004),
    [anon_sym_GT_GT] = ACTIONS(13004),
    [anon_sym_EQ_EQ] = ACTIONS(13006),
    [anon_sym_BANG_EQ] = ACTIONS(13002),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13002),
    [anon_sym_LT_EQ_GT] = ACTIONS(13002),
    [anon_sym_EQ_TILDE] = ACTIONS(13002),
    [anon_sym_BANG_TILDE] = ACTIONS(13002),
    [anon_sym_LT_EQ] = ACTIONS(12994),
    [anon_sym_GT] = ACTIONS(12994),
    [anon_sym_GT_EQ] = ACTIONS(13008),
    [anon_sym_CARET] = ACTIONS(13010),
    [anon_sym_PLUS] = ACTIONS(12986),
    [anon_sym_SLASH] = ACTIONS(12988),
    [anon_sym_PERCENT] = ACTIONS(12988),
    [sym_comment] = ACTIONS(87),
  },
  [10383] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(12986),
    [sym__binary_star] = ACTIONS(12988),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(12988),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_elsif] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(12986),
    [anon_sym_SLASH] = ACTIONS(12988),
    [anon_sym_PERCENT] = ACTIONS(12988),
    [sym_comment] = ACTIONS(87),
  },
  [10384] = {
    [aux_sym_exceptions_repeat1] = STATE(10384),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_COMMA] = ACTIONS(14787),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_end] = ACTIONS(11597),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_elsif] = ACTIONS(11597),
    [anon_sym_else] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [10385] = {
    [aux_sym_exceptions_repeat1] = STATE(9381),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_end] = ACTIONS(6191),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_elsif] = ACTIONS(6191),
    [anon_sym_else] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [10386] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(12986),
    [sym__binary_star] = ACTIONS(12988),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(12990),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(12988),
    [anon_sym_AMP] = ACTIONS(12992),
    [anon_sym_LT] = ACTIONS(12994),
    [anon_sym_end] = ACTIONS(6210),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_elsif] = ACTIONS(6210),
    [anon_sym_else] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(12996),
    [anon_sym_DOT_DOT] = ACTIONS(12998),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13000),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(13002),
    [anon_sym_AMP_AMP] = ACTIONS(13002),
    [anon_sym_LT_LT] = ACTIONS(13004),
    [anon_sym_GT_GT] = ACTIONS(13004),
    [anon_sym_EQ_EQ] = ACTIONS(13006),
    [anon_sym_BANG_EQ] = ACTIONS(13002),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13002),
    [anon_sym_LT_EQ_GT] = ACTIONS(13002),
    [anon_sym_EQ_TILDE] = ACTIONS(13002),
    [anon_sym_BANG_TILDE] = ACTIONS(13002),
    [anon_sym_LT_EQ] = ACTIONS(12994),
    [anon_sym_GT] = ACTIONS(12994),
    [anon_sym_GT_EQ] = ACTIONS(13008),
    [anon_sym_CARET] = ACTIONS(13010),
    [anon_sym_PLUS] = ACTIONS(12986),
    [anon_sym_SLASH] = ACTIONS(12988),
    [anon_sym_PERCENT] = ACTIONS(12988),
    [sym_comment] = ACTIONS(87),
  },
  [10387] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(8108),
    [sym__binary_star] = ACTIONS(8110),
    [anon_sym_LBRACE] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(8112),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(8114),
    [anon_sym_AMP] = ACTIONS(8116),
    [anon_sym_EQ] = ACTIONS(12879),
    [anon_sym_LT] = ACTIONS(8118),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_then] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_PLUS_EQ] = ACTIONS(12120),
    [anon_sym_DASH_EQ] = ACTIONS(12120),
    [anon_sym_STAR_EQ] = ACTIONS(12120),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12120),
    [anon_sym_SLASH_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12120),
    [anon_sym_AMP_EQ] = ACTIONS(12120),
    [anon_sym_PERCENT_EQ] = ACTIONS(12120),
    [anon_sym_GT_GT_EQ] = ACTIONS(12120),
    [anon_sym_LT_LT_EQ] = ACTIONS(12120),
    [anon_sym_CARET_EQ] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(8120),
    [anon_sym_DOT_DOT] = ACTIONS(8122),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8124),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(8126),
    [anon_sym_AMP_AMP] = ACTIONS(8126),
    [anon_sym_LT_LT] = ACTIONS(8128),
    [anon_sym_GT_GT] = ACTIONS(8128),
    [anon_sym_EQ_EQ] = ACTIONS(8126),
    [anon_sym_BANG_EQ] = ACTIONS(8130),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8130),
    [anon_sym_LT_EQ_GT] = ACTIONS(8130),
    [anon_sym_EQ_TILDE] = ACTIONS(8130),
    [anon_sym_BANG_TILDE] = ACTIONS(8130),
    [anon_sym_LT_EQ] = ACTIONS(8118),
    [anon_sym_GT] = ACTIONS(8118),
    [anon_sym_GT_EQ] = ACTIONS(8132),
    [anon_sym_CARET] = ACTIONS(8112),
    [anon_sym_PLUS] = ACTIONS(8134),
    [anon_sym_SLASH] = ACTIONS(8114),
    [anon_sym_PERCENT] = ACTIONS(8114),
    [sym_comment] = ACTIONS(87),
  },
  [10388] = {
    [aux_sym_exceptions_repeat1] = STATE(10388),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(14790),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_then] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_PLUS_EQ] = ACTIONS(11597),
    [anon_sym_DASH_EQ] = ACTIONS(11597),
    [anon_sym_STAR_EQ] = ACTIONS(11597),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11597),
    [anon_sym_SLASH_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11597),
    [anon_sym_AMP_EQ] = ACTIONS(11597),
    [anon_sym_PERCENT_EQ] = ACTIONS(11597),
    [anon_sym_GT_GT_EQ] = ACTIONS(11597),
    [anon_sym_LT_LT_EQ] = ACTIONS(11597),
    [anon_sym_CARET_EQ] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_LT] = ACTIONS(12338),
    [anon_sym_GT_GT] = ACTIONS(12338),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(12338),
    [anon_sym_PLUS] = ACTIONS(12338),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [10389] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(8144),
    [sym__binary_star] = ACTIONS(8146),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(8148),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(8146),
    [anon_sym_AMP] = ACTIONS(8150),
    [anon_sym_LT] = ACTIONS(8152),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_then] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(8154),
    [anon_sym_DOT_DOT] = ACTIONS(8156),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8158),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(8160),
    [anon_sym_AMP_AMP] = ACTIONS(8160),
    [anon_sym_LT_LT] = ACTIONS(8162),
    [anon_sym_GT_GT] = ACTIONS(8162),
    [anon_sym_EQ_EQ] = ACTIONS(8164),
    [anon_sym_BANG_EQ] = ACTIONS(8160),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8160),
    [anon_sym_LT_EQ_GT] = ACTIONS(8160),
    [anon_sym_EQ_TILDE] = ACTIONS(8160),
    [anon_sym_BANG_TILDE] = ACTIONS(8160),
    [anon_sym_LT_EQ] = ACTIONS(8152),
    [anon_sym_GT] = ACTIONS(8152),
    [anon_sym_GT_EQ] = ACTIONS(8166),
    [anon_sym_CARET] = ACTIONS(8168),
    [anon_sym_PLUS] = ACTIONS(8144),
    [anon_sym_SLASH] = ACTIONS(8146),
    [anon_sym_PERCENT] = ACTIONS(8146),
    [sym_comment] = ACTIONS(87),
  },
  [10390] = {
    [sym_heredoc_body] = STATE(10916),
    [aux_sym_call_repeat1] = STATE(10916),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_else] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [10391] = {
    [sym_heredoc_body] = STATE(10917),
    [aux_sym_call_repeat1] = STATE(10917),
    [aux_sym_argument_list_repeat1] = STATE(9439),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(11234),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_else] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [10392] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(13035),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13035),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(13035),
    [anon_sym_PERCENT] = ACTIONS(13035),
    [sym_comment] = ACTIONS(87),
  },
  [10393] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13035),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [10394] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(13033),
    [sym__binary_star] = ACTIONS(13035),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13035),
    [anon_sym_AMP] = ACTIONS(13039),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(13051),
    [anon_sym_GT_GT] = ACTIONS(13051),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(13033),
    [anon_sym_SLASH] = ACTIONS(13035),
    [anon_sym_PERCENT] = ACTIONS(13035),
    [sym_comment] = ACTIONS(87),
  },
  [10395] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(13033),
    [sym__binary_star] = ACTIONS(13035),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13035),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(13051),
    [anon_sym_GT_GT] = ACTIONS(13051),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(13033),
    [anon_sym_SLASH] = ACTIONS(13035),
    [anon_sym_PERCENT] = ACTIONS(13035),
    [sym_comment] = ACTIONS(87),
  },
  [10396] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(13033),
    [sym__binary_star] = ACTIONS(13035),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(13037),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13035),
    [anon_sym_AMP] = ACTIONS(13039),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(13051),
    [anon_sym_GT_GT] = ACTIONS(13051),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(13057),
    [anon_sym_PLUS] = ACTIONS(13033),
    [anon_sym_SLASH] = ACTIONS(13035),
    [anon_sym_PERCENT] = ACTIONS(13035),
    [sym_comment] = ACTIONS(87),
  },
  [10397] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(14793),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [10398] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(13033),
    [sym__binary_star] = ACTIONS(13035),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(13037),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(13035),
    [anon_sym_AMP] = ACTIONS(13039),
    [anon_sym_LT] = ACTIONS(13041),
    [anon_sym_end] = ACTIONS(5927),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_else] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(13045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13047),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(13049),
    [anon_sym_AMP_AMP] = ACTIONS(13049),
    [anon_sym_LT_LT] = ACTIONS(13051),
    [anon_sym_GT_GT] = ACTIONS(13051),
    [anon_sym_EQ_EQ] = ACTIONS(13053),
    [anon_sym_BANG_EQ] = ACTIONS(13049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13049),
    [anon_sym_LT_EQ_GT] = ACTIONS(13049),
    [anon_sym_EQ_TILDE] = ACTIONS(13049),
    [anon_sym_BANG_TILDE] = ACTIONS(13049),
    [anon_sym_LT_EQ] = ACTIONS(13041),
    [anon_sym_GT] = ACTIONS(13041),
    [anon_sym_GT_EQ] = ACTIONS(13055),
    [anon_sym_CARET] = ACTIONS(13057),
    [anon_sym_PLUS] = ACTIONS(13033),
    [anon_sym_SLASH] = ACTIONS(13035),
    [anon_sym_PERCENT] = ACTIONS(13035),
    [sym_comment] = ACTIONS(87),
  },
  [10399] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(13033),
    [sym__binary_star] = ACTIONS(13035),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(13037),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13035),
    [anon_sym_AMP] = ACTIONS(13039),
    [anon_sym_LT] = ACTIONS(13041),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(13043),
    [anon_sym_DOT_DOT] = ACTIONS(13045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13047),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(13049),
    [anon_sym_AMP_AMP] = ACTIONS(13049),
    [anon_sym_LT_LT] = ACTIONS(13051),
    [anon_sym_GT_GT] = ACTIONS(13051),
    [anon_sym_EQ_EQ] = ACTIONS(13053),
    [anon_sym_BANG_EQ] = ACTIONS(13049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13049),
    [anon_sym_LT_EQ_GT] = ACTIONS(13049),
    [anon_sym_EQ_TILDE] = ACTIONS(13049),
    [anon_sym_BANG_TILDE] = ACTIONS(13049),
    [anon_sym_LT_EQ] = ACTIONS(13041),
    [anon_sym_GT] = ACTIONS(13041),
    [anon_sym_GT_EQ] = ACTIONS(13055),
    [anon_sym_CARET] = ACTIONS(13057),
    [anon_sym_PLUS] = ACTIONS(13033),
    [anon_sym_SLASH] = ACTIONS(13035),
    [anon_sym_PERCENT] = ACTIONS(13035),
    [sym_comment] = ACTIONS(87),
  },
  [10400] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(13033),
    [sym__binary_star] = ACTIONS(13035),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(13037),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13035),
    [anon_sym_AMP] = ACTIONS(13039),
    [anon_sym_LT] = ACTIONS(13041),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(13051),
    [anon_sym_GT_GT] = ACTIONS(13051),
    [anon_sym_EQ_EQ] = ACTIONS(13053),
    [anon_sym_BANG_EQ] = ACTIONS(13049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13049),
    [anon_sym_LT_EQ_GT] = ACTIONS(13049),
    [anon_sym_EQ_TILDE] = ACTIONS(13049),
    [anon_sym_BANG_TILDE] = ACTIONS(13049),
    [anon_sym_LT_EQ] = ACTIONS(13041),
    [anon_sym_GT] = ACTIONS(13041),
    [anon_sym_GT_EQ] = ACTIONS(13055),
    [anon_sym_CARET] = ACTIONS(13057),
    [anon_sym_PLUS] = ACTIONS(13033),
    [anon_sym_SLASH] = ACTIONS(13035),
    [anon_sym_PERCENT] = ACTIONS(13035),
    [sym_comment] = ACTIONS(87),
  },
  [10401] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(13033),
    [sym__binary_star] = ACTIONS(13035),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13035),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(13033),
    [anon_sym_SLASH] = ACTIONS(13035),
    [anon_sym_PERCENT] = ACTIONS(13035),
    [sym_comment] = ACTIONS(87),
  },
  [10402] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(13033),
    [sym__binary_star] = ACTIONS(13035),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(13037),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(13035),
    [anon_sym_AMP] = ACTIONS(13039),
    [anon_sym_LT] = ACTIONS(13041),
    [anon_sym_end] = ACTIONS(5115),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_else] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(13043),
    [anon_sym_DOT_DOT] = ACTIONS(13045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13047),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(13049),
    [anon_sym_AMP_AMP] = ACTIONS(13049),
    [anon_sym_LT_LT] = ACTIONS(13051),
    [anon_sym_GT_GT] = ACTIONS(13051),
    [anon_sym_EQ_EQ] = ACTIONS(13053),
    [anon_sym_BANG_EQ] = ACTIONS(13049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13049),
    [anon_sym_LT_EQ_GT] = ACTIONS(13049),
    [anon_sym_EQ_TILDE] = ACTIONS(13049),
    [anon_sym_BANG_TILDE] = ACTIONS(13049),
    [anon_sym_LT_EQ] = ACTIONS(13041),
    [anon_sym_GT] = ACTIONS(13041),
    [anon_sym_GT_EQ] = ACTIONS(13055),
    [anon_sym_CARET] = ACTIONS(13057),
    [anon_sym_PLUS] = ACTIONS(13033),
    [anon_sym_SLASH] = ACTIONS(13035),
    [anon_sym_PERCENT] = ACTIONS(13035),
    [sym_comment] = ACTIONS(87),
  },
  [10403] = {
    [aux_sym_exceptions_repeat1] = STATE(10920),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_end] = ACTIONS(6191),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_else] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [10404] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(13033),
    [sym__binary_star] = ACTIONS(13035),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(13037),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(13035),
    [anon_sym_AMP] = ACTIONS(13039),
    [anon_sym_LT] = ACTIONS(13041),
    [anon_sym_end] = ACTIONS(6210),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_else] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(13043),
    [anon_sym_DOT_DOT] = ACTIONS(13045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13047),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(13049),
    [anon_sym_AMP_AMP] = ACTIONS(13049),
    [anon_sym_LT_LT] = ACTIONS(13051),
    [anon_sym_GT_GT] = ACTIONS(13051),
    [anon_sym_EQ_EQ] = ACTIONS(13053),
    [anon_sym_BANG_EQ] = ACTIONS(13049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13049),
    [anon_sym_LT_EQ_GT] = ACTIONS(13049),
    [anon_sym_EQ_TILDE] = ACTIONS(13049),
    [anon_sym_BANG_TILDE] = ACTIONS(13049),
    [anon_sym_LT_EQ] = ACTIONS(13041),
    [anon_sym_GT] = ACTIONS(13041),
    [anon_sym_GT_EQ] = ACTIONS(13055),
    [anon_sym_CARET] = ACTIONS(13057),
    [anon_sym_PLUS] = ACTIONS(13033),
    [anon_sym_SLASH] = ACTIONS(13035),
    [anon_sym_PERCENT] = ACTIONS(13035),
    [sym_comment] = ACTIONS(87),
  },
  [10405] = {
    [sym_string] = STATE(10405),
    [aux_sym_chained_string_repeat1] = STATE(10405),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(6214),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_end] = ACTIONS(6212),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_else] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [10406] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(11200),
    [sym__binary_star] = ACTIONS(11202),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(11204),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(11202),
    [anon_sym_AMP] = ACTIONS(11206),
    [anon_sym_LT] = ACTIONS(11208),
    [anon_sym_end] = ACTIONS(6823),
    [anon_sym_if] = ACTIONS(6823),
    [anon_sym_unless] = ACTIONS(6823),
    [anon_sym_while] = ACTIONS(6823),
    [anon_sym_until] = ACTIONS(6823),
    [anon_sym_rescue] = ACTIONS(6823),
    [anon_sym_else] = ACTIONS(6823),
    [anon_sym_EQ_GT] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(11210),
    [anon_sym_DOT_DOT] = ACTIONS(11212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11214),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(11216),
    [anon_sym_AMP_AMP] = ACTIONS(11216),
    [anon_sym_LT_LT] = ACTIONS(11218),
    [anon_sym_GT_GT] = ACTIONS(11218),
    [anon_sym_EQ_EQ] = ACTIONS(11220),
    [anon_sym_BANG_EQ] = ACTIONS(11216),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11216),
    [anon_sym_LT_EQ_GT] = ACTIONS(11216),
    [anon_sym_EQ_TILDE] = ACTIONS(11216),
    [anon_sym_BANG_TILDE] = ACTIONS(11216),
    [anon_sym_LT_EQ] = ACTIONS(11208),
    [anon_sym_GT] = ACTIONS(11208),
    [anon_sym_GT_EQ] = ACTIONS(11222),
    [anon_sym_CARET] = ACTIONS(11224),
    [anon_sym_PLUS] = ACTIONS(11200),
    [anon_sym_SLASH] = ACTIONS(11202),
    [anon_sym_PERCENT] = ACTIONS(11202),
    [sym_comment] = ACTIONS(87),
  },
  [10407] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(11200),
    [sym__binary_star] = ACTIONS(11202),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(11204),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(11202),
    [anon_sym_AMP] = ACTIONS(11206),
    [anon_sym_LT] = ACTIONS(11208),
    [anon_sym_end] = ACTIONS(7027),
    [anon_sym_if] = ACTIONS(7027),
    [anon_sym_unless] = ACTIONS(7027),
    [anon_sym_while] = ACTIONS(7027),
    [anon_sym_until] = ACTIONS(7027),
    [anon_sym_rescue] = ACTIONS(7027),
    [anon_sym_else] = ACTIONS(7027),
    [anon_sym_EQ_GT] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(11210),
    [anon_sym_DOT_DOT] = ACTIONS(11212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11214),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(11216),
    [anon_sym_AMP_AMP] = ACTIONS(11216),
    [anon_sym_LT_LT] = ACTIONS(11218),
    [anon_sym_GT_GT] = ACTIONS(11218),
    [anon_sym_EQ_EQ] = ACTIONS(11220),
    [anon_sym_BANG_EQ] = ACTIONS(11216),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11216),
    [anon_sym_LT_EQ_GT] = ACTIONS(11216),
    [anon_sym_EQ_TILDE] = ACTIONS(11216),
    [anon_sym_BANG_TILDE] = ACTIONS(11216),
    [anon_sym_LT_EQ] = ACTIONS(11208),
    [anon_sym_GT] = ACTIONS(11208),
    [anon_sym_GT_EQ] = ACTIONS(11222),
    [anon_sym_CARET] = ACTIONS(11224),
    [anon_sym_PLUS] = ACTIONS(11200),
    [anon_sym_SLASH] = ACTIONS(11202),
    [anon_sym_PERCENT] = ACTIONS(11202),
    [sym_comment] = ACTIONS(87),
  },
  [10408] = {
    [sym_heredoc_body] = STATE(10408),
    [aux_sym_call_repeat1] = STATE(10408),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(7916),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_end] = ACTIONS(7914),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_else] = ACTIONS(7914),
    [anon_sym_EQ_GT] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [10409] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7639),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5178),
    [sym_scope_resolution] = STATE(5174),
    [sym_call] = STATE(5174),
    [sym_method_call] = STATE(5178),
    [sym__argument] = STATE(4986),
    [sym_splat_argument] = STATE(4986),
    [sym_hash_splat_argument] = STATE(4986),
    [sym_block_argument] = STATE(4986),
    [sym_assignment] = STATE(7639),
    [sym_operator_assignment] = STATE(7639),
    [sym_conditional] = STATE(7639),
    [sym_range] = STATE(7639),
    [sym_binary] = STATE(7639),
    [sym_unary] = STATE(7639),
    [sym_left_assignment_list] = STATE(5177),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5178),
    [sym__variable] = STATE(5174),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5178),
    [sym_false] = STATE(5178),
    [sym_nil] = STATE(5178),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7642),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4986),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(11190),
    [sym__splat_star] = ACTIONS(11192),
    [sym__unary_minus] = ACTIONS(8182),
    [sym__identifier_hash_key] = ACTIONS(11194),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(14109),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8186),
    [anon_sym_yield] = ACTIONS(8188),
    [anon_sym_break] = ACTIONS(8190),
    [anon_sym_next] = ACTIONS(8192),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11186),
    [anon_sym_defined_QMARK] = ACTIONS(8194),
    [anon_sym_not] = ACTIONS(8196),
    [anon_sym_BANG] = ACTIONS(8200),
    [anon_sym_TILDE] = ACTIONS(8200),
    [sym_constant] = ACTIONS(11196),
    [sym_identifier] = ACTIONS(11196),
    [sym_instance_variable] = ACTIONS(8204),
    [sym_class_variable] = ACTIONS(8204),
    [sym_global_variable] = ACTIONS(8204),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8206),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8206),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10410] = {
    [sym_heredoc_body] = STATE(10408),
    [aux_sym_call_repeat1] = STATE(10408),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_end] = ACTIONS(7929),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_else] = ACTIONS(7929),
    [anon_sym_EQ_GT] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [10411] = {
    [aux_sym_argument_list_repeat1] = STATE(10411),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(14795),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7925),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_end] = ACTIONS(7925),
    [anon_sym_if] = ACTIONS(7925),
    [anon_sym_unless] = ACTIONS(7925),
    [anon_sym_while] = ACTIONS(7925),
    [anon_sym_until] = ACTIONS(7925),
    [anon_sym_rescue] = ACTIONS(7925),
    [anon_sym_else] = ACTIONS(7925),
    [anon_sym_EQ_GT] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7925),
    [anon_sym_AMP_AMP] = ACTIONS(7925),
    [anon_sym_LT_LT] = ACTIONS(7925),
    [anon_sym_GT_GT] = ACTIONS(7925),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7925),
    [anon_sym_PLUS] = ACTIONS(7925),
    [anon_sym_SLASH] = ACTIONS(7925),
    [anon_sym_PERCENT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [10412] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10921),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5178),
    [sym_scope_resolution] = STATE(5174),
    [sym_call] = STATE(5174),
    [sym_method_call] = STATE(5178),
    [sym_assignment] = STATE(10921),
    [sym_operator_assignment] = STATE(10921),
    [sym_conditional] = STATE(10921),
    [sym_range] = STATE(10921),
    [sym_binary] = STATE(10921),
    [sym_unary] = STATE(10921),
    [sym_left_assignment_list] = STATE(5177),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5178),
    [sym__variable] = STATE(5174),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5178),
    [sym_false] = STATE(5178),
    [sym_nil] = STATE(5178),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7631),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8186),
    [anon_sym_yield] = ACTIONS(8188),
    [anon_sym_break] = ACTIONS(8190),
    [anon_sym_next] = ACTIONS(8192),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11186),
    [anon_sym_defined_QMARK] = ACTIONS(8194),
    [anon_sym_not] = ACTIONS(8196),
    [anon_sym_BANG] = ACTIONS(8200),
    [anon_sym_TILDE] = ACTIONS(8200),
    [sym_constant] = ACTIONS(8206),
    [sym_identifier] = ACTIONS(8206),
    [sym_instance_variable] = ACTIONS(8204),
    [sym_class_variable] = ACTIONS(8204),
    [sym_global_variable] = ACTIONS(8204),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8206),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8206),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10413] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(11272),
    [sym__binary_star] = ACTIONS(11274),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(11276),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(11278),
    [anon_sym_AMP] = ACTIONS(11280),
    [anon_sym_EQ] = ACTIONS(7822),
    [anon_sym_LT] = ACTIONS(11282),
    [anon_sym_end] = ACTIONS(6823),
    [anon_sym_if] = ACTIONS(6823),
    [anon_sym_unless] = ACTIONS(6823),
    [anon_sym_while] = ACTIONS(6823),
    [anon_sym_until] = ACTIONS(6823),
    [anon_sym_rescue] = ACTIONS(6823),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_else] = ACTIONS(6823),
    [anon_sym_EQ_GT] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_PLUS_EQ] = ACTIONS(6823),
    [anon_sym_DASH_EQ] = ACTIONS(6823),
    [anon_sym_STAR_EQ] = ACTIONS(6823),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6823),
    [anon_sym_SLASH_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6823),
    [anon_sym_AMP_EQ] = ACTIONS(6823),
    [anon_sym_PERCENT_EQ] = ACTIONS(6823),
    [anon_sym_GT_GT_EQ] = ACTIONS(6823),
    [anon_sym_LT_LT_EQ] = ACTIONS(6823),
    [anon_sym_CARET_EQ] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(11284),
    [anon_sym_DOT_DOT] = ACTIONS(11286),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11288),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(11290),
    [anon_sym_AMP_AMP] = ACTIONS(11290),
    [anon_sym_LT_LT] = ACTIONS(11292),
    [anon_sym_GT_GT] = ACTIONS(11292),
    [anon_sym_EQ_EQ] = ACTIONS(11290),
    [anon_sym_BANG_EQ] = ACTIONS(11294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11294),
    [anon_sym_LT_EQ_GT] = ACTIONS(11294),
    [anon_sym_EQ_TILDE] = ACTIONS(11294),
    [anon_sym_BANG_TILDE] = ACTIONS(11294),
    [anon_sym_LT_EQ] = ACTIONS(11282),
    [anon_sym_GT] = ACTIONS(11282),
    [anon_sym_GT_EQ] = ACTIONS(11296),
    [anon_sym_CARET] = ACTIONS(11276),
    [anon_sym_PLUS] = ACTIONS(11298),
    [anon_sym_SLASH] = ACTIONS(11278),
    [anon_sym_PERCENT] = ACTIONS(11278),
    [sym_comment] = ACTIONS(87),
  },
  [10414] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(11272),
    [sym__binary_star] = ACTIONS(11274),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(11276),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(11278),
    [anon_sym_AMP] = ACTIONS(11280),
    [anon_sym_EQ] = ACTIONS(7884),
    [anon_sym_LT] = ACTIONS(11282),
    [anon_sym_end] = ACTIONS(7027),
    [anon_sym_if] = ACTIONS(7027),
    [anon_sym_unless] = ACTIONS(7027),
    [anon_sym_while] = ACTIONS(7027),
    [anon_sym_until] = ACTIONS(7027),
    [anon_sym_rescue] = ACTIONS(7027),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_else] = ACTIONS(7027),
    [anon_sym_EQ_GT] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_PLUS_EQ] = ACTIONS(7027),
    [anon_sym_DASH_EQ] = ACTIONS(7027),
    [anon_sym_STAR_EQ] = ACTIONS(7027),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7027),
    [anon_sym_SLASH_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7027),
    [anon_sym_AMP_EQ] = ACTIONS(7027),
    [anon_sym_PERCENT_EQ] = ACTIONS(7027),
    [anon_sym_GT_GT_EQ] = ACTIONS(7027),
    [anon_sym_LT_LT_EQ] = ACTIONS(7027),
    [anon_sym_CARET_EQ] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(11284),
    [anon_sym_DOT_DOT] = ACTIONS(11286),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11288),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(11290),
    [anon_sym_AMP_AMP] = ACTIONS(11290),
    [anon_sym_LT_LT] = ACTIONS(11292),
    [anon_sym_GT_GT] = ACTIONS(11292),
    [anon_sym_EQ_EQ] = ACTIONS(11290),
    [anon_sym_BANG_EQ] = ACTIONS(11294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11294),
    [anon_sym_LT_EQ_GT] = ACTIONS(11294),
    [anon_sym_EQ_TILDE] = ACTIONS(11294),
    [anon_sym_BANG_TILDE] = ACTIONS(11294),
    [anon_sym_LT_EQ] = ACTIONS(11282),
    [anon_sym_GT] = ACTIONS(11282),
    [anon_sym_GT_EQ] = ACTIONS(11296),
    [anon_sym_CARET] = ACTIONS(11276),
    [anon_sym_PLUS] = ACTIONS(11298),
    [anon_sym_SLASH] = ACTIONS(11278),
    [anon_sym_PERCENT] = ACTIONS(11278),
    [sym_comment] = ACTIONS(87),
  },
  [10415] = {
    [sym_heredoc_body] = STATE(10415),
    [aux_sym_call_repeat1] = STATE(10415),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(10978),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7919),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_EQ] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_end] = ACTIONS(7914),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_else] = ACTIONS(7914),
    [anon_sym_EQ_GT] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_PLUS_EQ] = ACTIONS(7914),
    [anon_sym_DASH_EQ] = ACTIONS(7914),
    [anon_sym_STAR_EQ] = ACTIONS(7914),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7914),
    [anon_sym_SLASH_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7914),
    [anon_sym_AMP_EQ] = ACTIONS(7914),
    [anon_sym_PERCENT_EQ] = ACTIONS(7914),
    [anon_sym_GT_GT_EQ] = ACTIONS(7914),
    [anon_sym_LT_LT_EQ] = ACTIONS(7914),
    [anon_sym_CARET_EQ] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7919),
    [anon_sym_AMP_AMP] = ACTIONS(7919),
    [anon_sym_LT_LT] = ACTIONS(7919),
    [anon_sym_GT_GT] = ACTIONS(7919),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7919),
    [anon_sym_PLUS] = ACTIONS(7919),
    [anon_sym_SLASH] = ACTIONS(7919),
    [anon_sym_PERCENT] = ACTIONS(7919),
    [sym_comment] = ACTIONS(87),
  },
  [10416] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(7660),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5214),
    [sym_scope_resolution] = STATE(5210),
    [sym_call] = STATE(5210),
    [sym_method_call] = STATE(5214),
    [sym__argument] = STATE(7437),
    [sym_splat_argument] = STATE(7437),
    [sym_hash_splat_argument] = STATE(7437),
    [sym_block_argument] = STATE(7437),
    [sym_assignment] = STATE(7660),
    [sym_operator_assignment] = STATE(7660),
    [sym_conditional] = STATE(7660),
    [sym_range] = STATE(7660),
    [sym_binary] = STATE(7660),
    [sym_unary] = STATE(7660),
    [sym_left_assignment_list] = STATE(5213),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5214),
    [sym__variable] = STATE(5210),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5214),
    [sym_false] = STATE(5214),
    [sym_nil] = STATE(5214),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7663),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(7437),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(11226),
    [sym__splat_star] = ACTIONS(11228),
    [sym__unary_minus] = ACTIONS(8252),
    [sym__identifier_hash_key] = ACTIONS(11230),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(14113),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(8256),
    [anon_sym_yield] = ACTIONS(8258),
    [anon_sym_break] = ACTIONS(8260),
    [anon_sym_next] = ACTIONS(8262),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(11266),
    [anon_sym_defined_QMARK] = ACTIONS(8264),
    [anon_sym_not] = ACTIONS(8266),
    [anon_sym_BANG] = ACTIONS(8270),
    [anon_sym_TILDE] = ACTIONS(8270),
    [sym_constant] = ACTIONS(11232),
    [sym_identifier] = ACTIONS(11232),
    [sym_instance_variable] = ACTIONS(8274),
    [sym_class_variable] = ACTIONS(8274),
    [sym_global_variable] = ACTIONS(8274),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8276),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8276),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [10417] = {
    [sym_heredoc_body] = STATE(10415),
    [aux_sym_call_repeat1] = STATE(10415),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7931),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_EQ] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_end] = ACTIONS(7929),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_else] = ACTIONS(7929),
    [anon_sym_EQ_GT] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_PLUS_EQ] = ACTIONS(7929),
    [anon_sym_DASH_EQ] = ACTIONS(7929),
    [anon_sym_STAR_EQ] = ACTIONS(7929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7929),
    [anon_sym_SLASH_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7929),
    [anon_sym_AMP_EQ] = ACTIONS(7929),
    [anon_sym_PERCENT_EQ] = ACTIONS(7929),
    [anon_sym_GT_GT_EQ] = ACTIONS(7929),
    [anon_sym_LT_LT_EQ] = ACTIONS(7929),
    [anon_sym_CARET_EQ] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7931),
    [anon_sym_AMP_AMP] = ACTIONS(7931),
    [anon_sym_LT_LT] = ACTIONS(7931),
    [anon_sym_GT_GT] = ACTIONS(7931),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7931),
    [anon_sym_PLUS] = ACTIONS(7931),
    [anon_sym_SLASH] = ACTIONS(7931),
    [anon_sym_PERCENT] = ACTIONS(7931),
    [sym_comment] = ACTIONS(87),
  },
  [10418] = {
    [aux_sym_argument_list_repeat1] = STATE(10418),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(14798),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7927),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_EQ] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_end] = ACTIONS(7925),
    [anon_sym_if] = ACTIONS(7925),
    [anon_sym_unless] = ACTIONS(7925),
    [anon_sym_while] = ACTIONS(7925),
    [anon_sym_until] = ACTIONS(7925),
    [anon_sym_rescue] = ACTIONS(7925),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_else] = ACTIONS(7925),
    [anon_sym_EQ_GT] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_PLUS_EQ] = ACTIONS(7925),
    [anon_sym_DASH_EQ] = ACTIONS(7925),
    [anon_sym_STAR_EQ] = ACTIONS(7925),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7925),
    [anon_sym_SLASH_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7925),
    [anon_sym_AMP_EQ] = ACTIONS(7925),
    [anon_sym_PERCENT_EQ] = ACTIONS(7925),
    [anon_sym_GT_GT_EQ] = ACTIONS(7925),
    [anon_sym_LT_LT_EQ] = ACTIONS(7925),
    [anon_sym_CARET_EQ] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7927),
    [anon_sym_AMP_AMP] = ACTIONS(7927),
    [anon_sym_LT_LT] = ACTIONS(7927),
    [anon_sym_GT_GT] = ACTIONS(7927),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7927),
    [anon_sym_PLUS] = ACTIONS(7927),
    [anon_sym_SLASH] = ACTIONS(7927),
    [anon_sym_PERCENT] = ACTIONS(7927),
    [sym_comment] = ACTIONS(87),
  },
  [10419] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9440),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5178),
    [sym_scope_resolution] = STATE(5174),
    [sym_call] = STATE(5174),
    [sym_method_call] = STATE(5178),
    [sym_splat_argument] = STATE(7439),
    [sym_assignment] = STATE(9440),
    [sym_operator_assignment] = STATE(9440),
    [sym_conditional] = STATE(9440),
    [sym_range] = STATE(9440),
    [sym_binary] = STATE(9440),
    [sym_unary] = STATE(9440),
    [sym__arg_or_splat_arg] = STATE(7439),
    [sym_left_assignment_list] = STATE(5177),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5178),
    [sym__variable] = STATE(5174),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5178),
    [sym_false] = STATE(5178),
    [sym_nil] = STATE(5178),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7631),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__splat_star] = ACTIONS(11192),
    [sym__unary_minus] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8186),
    [anon_sym_yield] = ACTIONS(8188),
    [anon_sym_break] = ACTIONS(8190),
    [anon_sym_next] = ACTIONS(8192),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11186),
    [anon_sym_defined_QMARK] = ACTIONS(8194),
    [anon_sym_not] = ACTIONS(8196),
    [anon_sym_BANG] = ACTIONS(8200),
    [anon_sym_TILDE] = ACTIONS(8200),
    [sym_constant] = ACTIONS(8206),
    [sym_identifier] = ACTIONS(8206),
    [sym_instance_variable] = ACTIONS(8204),
    [sym_class_variable] = ACTIONS(8204),
    [sym_global_variable] = ACTIONS(8204),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(8206),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8206),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10420] = {
    [aux_sym_exceptions_repeat1] = STATE(10922),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(14801),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_end] = ACTIONS(9855),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_else] = ACTIONS(9855),
    [anon_sym_EQ_GT] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [10421] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(8220),
    [sym__binary_star] = ACTIONS(8222),
    [anon_sym_PIPE] = ACTIONS(8224),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(8222),
    [anon_sym_AMP] = ACTIONS(8226),
    [anon_sym_LT] = ACTIONS(8228),
    [anon_sym_end] = ACTIONS(12120),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_else] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(8230),
    [anon_sym_DOT_DOT] = ACTIONS(8232),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8234),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(8238),
    [anon_sym_AMP_AMP] = ACTIONS(8238),
    [anon_sym_LT_LT] = ACTIONS(8240),
    [anon_sym_GT_GT] = ACTIONS(8240),
    [anon_sym_EQ_EQ] = ACTIONS(8242),
    [anon_sym_BANG_EQ] = ACTIONS(8238),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8238),
    [anon_sym_LT_EQ_GT] = ACTIONS(8238),
    [anon_sym_EQ_TILDE] = ACTIONS(8238),
    [anon_sym_BANG_TILDE] = ACTIONS(8238),
    [anon_sym_LT_EQ] = ACTIONS(8228),
    [anon_sym_GT] = ACTIONS(8228),
    [anon_sym_GT_EQ] = ACTIONS(8244),
    [anon_sym_CARET] = ACTIONS(8246),
    [anon_sym_PLUS] = ACTIONS(8220),
    [anon_sym_SLASH] = ACTIONS(8222),
    [anon_sym_PERCENT] = ACTIONS(8222),
    [sym_comment] = ACTIONS(87),
  },
  [10422] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(13087),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13091),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(13091),
    [anon_sym_PERCENT] = ACTIONS(13091),
    [sym_comment] = ACTIONS(87),
  },
  [10423] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13091),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(5827),
    [anon_sym_PERCENT] = ACTIONS(5827),
    [sym_comment] = ACTIONS(87),
  },
  [10424] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(13085),
    [sym__binary_star] = ACTIONS(13087),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13091),
    [anon_sym_AMP] = ACTIONS(13093),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(13105),
    [anon_sym_GT_GT] = ACTIONS(13105),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(13111),
    [anon_sym_SLASH] = ACTIONS(13091),
    [anon_sym_PERCENT] = ACTIONS(13091),
    [sym_comment] = ACTIONS(87),
  },
  [10425] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(13085),
    [sym__binary_star] = ACTIONS(13087),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13091),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(13105),
    [anon_sym_GT_GT] = ACTIONS(13105),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(13111),
    [anon_sym_SLASH] = ACTIONS(13091),
    [anon_sym_PERCENT] = ACTIONS(13091),
    [sym_comment] = ACTIONS(87),
  },
  [10426] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(13085),
    [sym__binary_star] = ACTIONS(13087),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(13089),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13091),
    [anon_sym_AMP] = ACTIONS(13093),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(13105),
    [anon_sym_GT_GT] = ACTIONS(13105),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(13089),
    [anon_sym_PLUS] = ACTIONS(13111),
    [anon_sym_SLASH] = ACTIONS(13091),
    [anon_sym_PERCENT] = ACTIONS(13091),
    [sym_comment] = ACTIONS(87),
  },
  [10427] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(14803),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [10428] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(13085),
    [sym__binary_star] = ACTIONS(13087),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(13089),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(13091),
    [anon_sym_AMP] = ACTIONS(13093),
    [anon_sym_EQ] = ACTIONS(7888),
    [anon_sym_LT] = ACTIONS(13095),
    [anon_sym_end] = ACTIONS(5927),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_else] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_PLUS_EQ] = ACTIONS(5927),
    [anon_sym_DASH_EQ] = ACTIONS(5927),
    [anon_sym_STAR_EQ] = ACTIONS(5927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5927),
    [anon_sym_SLASH_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5927),
    [anon_sym_AMP_EQ] = ACTIONS(5927),
    [anon_sym_PERCENT_EQ] = ACTIONS(5927),
    [anon_sym_GT_GT_EQ] = ACTIONS(5927),
    [anon_sym_LT_LT_EQ] = ACTIONS(5927),
    [anon_sym_CARET_EQ] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(13099),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13101),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(13103),
    [anon_sym_AMP_AMP] = ACTIONS(13103),
    [anon_sym_LT_LT] = ACTIONS(13105),
    [anon_sym_GT_GT] = ACTIONS(13105),
    [anon_sym_EQ_EQ] = ACTIONS(13103),
    [anon_sym_BANG_EQ] = ACTIONS(13107),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13107),
    [anon_sym_LT_EQ_GT] = ACTIONS(13107),
    [anon_sym_EQ_TILDE] = ACTIONS(13107),
    [anon_sym_BANG_TILDE] = ACTIONS(13107),
    [anon_sym_LT_EQ] = ACTIONS(13095),
    [anon_sym_GT] = ACTIONS(13095),
    [anon_sym_GT_EQ] = ACTIONS(13109),
    [anon_sym_CARET] = ACTIONS(13089),
    [anon_sym_PLUS] = ACTIONS(13111),
    [anon_sym_SLASH] = ACTIONS(13091),
    [anon_sym_PERCENT] = ACTIONS(13091),
    [sym_comment] = ACTIONS(87),
  },
  [10429] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(13085),
    [sym__binary_star] = ACTIONS(13087),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(13089),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13091),
    [anon_sym_AMP] = ACTIONS(13093),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(13095),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(13097),
    [anon_sym_DOT_DOT] = ACTIONS(13099),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13101),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(13103),
    [anon_sym_AMP_AMP] = ACTIONS(13103),
    [anon_sym_LT_LT] = ACTIONS(13105),
    [anon_sym_GT_GT] = ACTIONS(13105),
    [anon_sym_EQ_EQ] = ACTIONS(13103),
    [anon_sym_BANG_EQ] = ACTIONS(13107),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13107),
    [anon_sym_LT_EQ_GT] = ACTIONS(13107),
    [anon_sym_EQ_TILDE] = ACTIONS(13107),
    [anon_sym_BANG_TILDE] = ACTIONS(13107),
    [anon_sym_LT_EQ] = ACTIONS(13095),
    [anon_sym_GT] = ACTIONS(13095),
    [anon_sym_GT_EQ] = ACTIONS(13109),
    [anon_sym_CARET] = ACTIONS(13089),
    [anon_sym_PLUS] = ACTIONS(13111),
    [anon_sym_SLASH] = ACTIONS(13091),
    [anon_sym_PERCENT] = ACTIONS(13091),
    [sym_comment] = ACTIONS(87),
  },
  [10430] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(13085),
    [sym__binary_star] = ACTIONS(13087),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(13089),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13091),
    [anon_sym_AMP] = ACTIONS(13093),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(13095),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(13105),
    [anon_sym_GT_GT] = ACTIONS(13105),
    [anon_sym_EQ_EQ] = ACTIONS(13103),
    [anon_sym_BANG_EQ] = ACTIONS(13107),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13107),
    [anon_sym_LT_EQ_GT] = ACTIONS(13107),
    [anon_sym_EQ_TILDE] = ACTIONS(13107),
    [anon_sym_BANG_TILDE] = ACTIONS(13107),
    [anon_sym_LT_EQ] = ACTIONS(13095),
    [anon_sym_GT] = ACTIONS(13095),
    [anon_sym_GT_EQ] = ACTIONS(13109),
    [anon_sym_CARET] = ACTIONS(13089),
    [anon_sym_PLUS] = ACTIONS(13111),
    [anon_sym_SLASH] = ACTIONS(13091),
    [anon_sym_PERCENT] = ACTIONS(13091),
    [sym_comment] = ACTIONS(87),
  },
  [10431] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(13085),
    [sym__binary_star] = ACTIONS(13087),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13091),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(13111),
    [anon_sym_SLASH] = ACTIONS(13091),
    [anon_sym_PERCENT] = ACTIONS(13091),
    [sym_comment] = ACTIONS(87),
  },
  [10432] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(13085),
    [sym__binary_star] = ACTIONS(13087),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(13089),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(13091),
    [anon_sym_AMP] = ACTIONS(13093),
    [anon_sym_EQ] = ACTIONS(7936),
    [anon_sym_LT] = ACTIONS(13095),
    [anon_sym_end] = ACTIONS(5115),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_else] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_PLUS_EQ] = ACTIONS(5115),
    [anon_sym_DASH_EQ] = ACTIONS(5115),
    [anon_sym_STAR_EQ] = ACTIONS(5115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5115),
    [anon_sym_SLASH_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5115),
    [anon_sym_AMP_EQ] = ACTIONS(5115),
    [anon_sym_PERCENT_EQ] = ACTIONS(5115),
    [anon_sym_GT_GT_EQ] = ACTIONS(5115),
    [anon_sym_LT_LT_EQ] = ACTIONS(5115),
    [anon_sym_CARET_EQ] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(13097),
    [anon_sym_DOT_DOT] = ACTIONS(13099),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13101),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(13103),
    [anon_sym_AMP_AMP] = ACTIONS(13103),
    [anon_sym_LT_LT] = ACTIONS(13105),
    [anon_sym_GT_GT] = ACTIONS(13105),
    [anon_sym_EQ_EQ] = ACTIONS(13103),
    [anon_sym_BANG_EQ] = ACTIONS(13107),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13107),
    [anon_sym_LT_EQ_GT] = ACTIONS(13107),
    [anon_sym_EQ_TILDE] = ACTIONS(13107),
    [anon_sym_BANG_TILDE] = ACTIONS(13107),
    [anon_sym_LT_EQ] = ACTIONS(13095),
    [anon_sym_GT] = ACTIONS(13095),
    [anon_sym_GT_EQ] = ACTIONS(13109),
    [anon_sym_CARET] = ACTIONS(13089),
    [anon_sym_PLUS] = ACTIONS(13111),
    [anon_sym_SLASH] = ACTIONS(13091),
    [anon_sym_PERCENT] = ACTIONS(13091),
    [sym_comment] = ACTIONS(87),
  },
  [10433] = {
    [aux_sym_exceptions_repeat1] = STATE(10925),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6193),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_end] = ACTIONS(6191),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_else] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_PLUS_EQ] = ACTIONS(6191),
    [anon_sym_DASH_EQ] = ACTIONS(6191),
    [anon_sym_STAR_EQ] = ACTIONS(6191),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6191),
    [anon_sym_SLASH_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6191),
    [anon_sym_AMP_EQ] = ACTIONS(6191),
    [anon_sym_PERCENT_EQ] = ACTIONS(6191),
    [anon_sym_GT_GT_EQ] = ACTIONS(6191),
    [anon_sym_LT_LT_EQ] = ACTIONS(6191),
    [anon_sym_CARET_EQ] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6193),
    [anon_sym_AMP_AMP] = ACTIONS(6193),
    [anon_sym_LT_LT] = ACTIONS(6193),
    [anon_sym_GT_GT] = ACTIONS(6193),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6193),
    [anon_sym_PLUS] = ACTIONS(6193),
    [anon_sym_SLASH] = ACTIONS(6193),
    [anon_sym_PERCENT] = ACTIONS(6193),
    [sym_comment] = ACTIONS(87),
  },
  [10434] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(13085),
    [sym__binary_star] = ACTIONS(13087),
    [anon_sym_LBRACE] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(13089),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(13091),
    [anon_sym_AMP] = ACTIONS(13093),
    [anon_sym_EQ] = ACTIONS(7938),
    [anon_sym_LT] = ACTIONS(13095),
    [anon_sym_end] = ACTIONS(6210),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_else] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_PLUS_EQ] = ACTIONS(6210),
    [anon_sym_DASH_EQ] = ACTIONS(6210),
    [anon_sym_STAR_EQ] = ACTIONS(6210),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6210),
    [anon_sym_SLASH_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6210),
    [anon_sym_AMP_EQ] = ACTIONS(6210),
    [anon_sym_PERCENT_EQ] = ACTIONS(6210),
    [anon_sym_GT_GT_EQ] = ACTIONS(6210),
    [anon_sym_LT_LT_EQ] = ACTIONS(6210),
    [anon_sym_CARET_EQ] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(13097),
    [anon_sym_DOT_DOT] = ACTIONS(13099),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13101),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(13103),
    [anon_sym_AMP_AMP] = ACTIONS(13103),
    [anon_sym_LT_LT] = ACTIONS(13105),
    [anon_sym_GT_GT] = ACTIONS(13105),
    [anon_sym_EQ_EQ] = ACTIONS(13103),
    [anon_sym_BANG_EQ] = ACTIONS(13107),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13107),
    [anon_sym_LT_EQ_GT] = ACTIONS(13107),
    [anon_sym_EQ_TILDE] = ACTIONS(13107),
    [anon_sym_BANG_TILDE] = ACTIONS(13107),
    [anon_sym_LT_EQ] = ACTIONS(13095),
    [anon_sym_GT] = ACTIONS(13095),
    [anon_sym_GT_EQ] = ACTIONS(13109),
    [anon_sym_CARET] = ACTIONS(13089),
    [anon_sym_PLUS] = ACTIONS(13111),
    [anon_sym_SLASH] = ACTIONS(13091),
    [anon_sym_PERCENT] = ACTIONS(13091),
    [sym_comment] = ACTIONS(87),
  },
  [10435] = {
    [sym_string] = STATE(10435),
    [aux_sym_chained_string_repeat1] = STATE(10435),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(12267),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6217),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_EQ] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_end] = ACTIONS(6212),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_do] = ACTIONS(6212),
    [anon_sym_else] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_PLUS_EQ] = ACTIONS(6212),
    [anon_sym_DASH_EQ] = ACTIONS(6212),
    [anon_sym_STAR_EQ] = ACTIONS(6212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6212),
    [anon_sym_SLASH_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6212),
    [anon_sym_AMP_EQ] = ACTIONS(6212),
    [anon_sym_PERCENT_EQ] = ACTIONS(6212),
    [anon_sym_GT_GT_EQ] = ACTIONS(6212),
    [anon_sym_LT_LT_EQ] = ACTIONS(6212),
    [anon_sym_CARET_EQ] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6217),
    [anon_sym_AMP_AMP] = ACTIONS(6217),
    [anon_sym_LT_LT] = ACTIONS(6217),
    [anon_sym_GT_GT] = ACTIONS(6217),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6217),
    [anon_sym_PLUS] = ACTIONS(6217),
    [anon_sym_SLASH] = ACTIONS(6217),
    [anon_sym_PERCENT] = ACTIONS(6217),
    [sym_comment] = ACTIONS(87),
  },
  [10436] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(10926),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5214),
    [sym_scope_resolution] = STATE(5210),
    [sym_call] = STATE(5210),
    [sym_method_call] = STATE(5214),
    [sym_assignment] = STATE(10926),
    [sym_operator_assignment] = STATE(10926),
    [sym_conditional] = STATE(10926),
    [sym_range] = STATE(10926),
    [sym_binary] = STATE(10926),
    [sym_unary] = STATE(10926),
    [sym_left_assignment_list] = STATE(5213),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5214),
    [sym__variable] = STATE(5210),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5214),
    [sym_false] = STATE(5214),
    [sym_nil] = STATE(5214),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7700),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(8252),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(8256),
    [anon_sym_yield] = ACTIONS(8258),
    [anon_sym_break] = ACTIONS(8260),
    [anon_sym_next] = ACTIONS(8262),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(11266),
    [anon_sym_defined_QMARK] = ACTIONS(8264),
    [anon_sym_not] = ACTIONS(8266),
    [anon_sym_BANG] = ACTIONS(8270),
    [anon_sym_TILDE] = ACTIONS(8270),
    [sym_constant] = ACTIONS(8276),
    [sym_identifier] = ACTIONS(8276),
    [sym_instance_variable] = ACTIONS(8274),
    [sym_class_variable] = ACTIONS(8274),
    [sym_global_variable] = ACTIONS(8274),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8276),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8276),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [10437] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(9477),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(5214),
    [sym_scope_resolution] = STATE(5210),
    [sym_call] = STATE(5210),
    [sym_method_call] = STATE(5214),
    [sym_splat_argument] = STATE(8678),
    [sym_assignment] = STATE(9477),
    [sym_operator_assignment] = STATE(9477),
    [sym_conditional] = STATE(9477),
    [sym_range] = STATE(9477),
    [sym_binary] = STATE(9477),
    [sym_unary] = STATE(9477),
    [sym__arg_or_splat_arg] = STATE(8678),
    [sym_left_assignment_list] = STATE(5213),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5214),
    [sym__variable] = STATE(5210),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(5214),
    [sym_false] = STATE(5214),
    [sym_nil] = STATE(5214),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(7700),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__splat_star] = ACTIONS(11228),
    [sym__unary_minus] = ACTIONS(8252),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(8256),
    [anon_sym_yield] = ACTIONS(8258),
    [anon_sym_break] = ACTIONS(8260),
    [anon_sym_next] = ACTIONS(8262),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(11266),
    [anon_sym_defined_QMARK] = ACTIONS(8264),
    [anon_sym_not] = ACTIONS(8266),
    [anon_sym_BANG] = ACTIONS(8270),
    [anon_sym_TILDE] = ACTIONS(8270),
    [sym_constant] = ACTIONS(8276),
    [sym_identifier] = ACTIONS(8276),
    [sym_instance_variable] = ACTIONS(8274),
    [sym_class_variable] = ACTIONS(8274),
    [sym_global_variable] = ACTIONS(8274),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(8276),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(8276),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [10438] = {
    [aux_sym_exceptions_repeat1] = STATE(10927),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_LBRACE] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(14805),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9857),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_EQ] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_end] = ACTIONS(9855),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_do] = ACTIONS(9855),
    [anon_sym_else] = ACTIONS(9855),
    [anon_sym_EQ_GT] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_PLUS_EQ] = ACTIONS(9855),
    [anon_sym_DASH_EQ] = ACTIONS(9855),
    [anon_sym_STAR_EQ] = ACTIONS(9855),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9855),
    [anon_sym_SLASH_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9855),
    [anon_sym_AMP_EQ] = ACTIONS(9855),
    [anon_sym_PERCENT_EQ] = ACTIONS(9855),
    [anon_sym_GT_GT_EQ] = ACTIONS(9855),
    [anon_sym_LT_LT_EQ] = ACTIONS(9855),
    [anon_sym_CARET_EQ] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9857),
    [anon_sym_AMP_AMP] = ACTIONS(9857),
    [anon_sym_LT_LT] = ACTIONS(9857),
    [anon_sym_GT_GT] = ACTIONS(9857),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9857),
    [anon_sym_PLUS] = ACTIONS(9857),
    [anon_sym_SLASH] = ACTIONS(9857),
    [anon_sym_PERCENT] = ACTIONS(9857),
    [sym_comment] = ACTIONS(87),
  },
  [10439] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(13123),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13123),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(13123),
    [anon_sym_PERCENT] = ACTIONS(13123),
    [sym_comment] = ACTIONS(87),
  },
  [10440] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13123),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [10441] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(13121),
    [sym__binary_star] = ACTIONS(13123),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13123),
    [anon_sym_AMP] = ACTIONS(13127),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(13139),
    [anon_sym_GT_GT] = ACTIONS(13139),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(13121),
    [anon_sym_SLASH] = ACTIONS(13123),
    [anon_sym_PERCENT] = ACTIONS(13123),
    [sym_comment] = ACTIONS(87),
  },
  [10442] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(13121),
    [sym__binary_star] = ACTIONS(13123),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13123),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(13139),
    [anon_sym_GT_GT] = ACTIONS(13139),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(13121),
    [anon_sym_SLASH] = ACTIONS(13123),
    [anon_sym_PERCENT] = ACTIONS(13123),
    [sym_comment] = ACTIONS(87),
  },
  [10443] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(13121),
    [sym__binary_star] = ACTIONS(13123),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(13125),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13123),
    [anon_sym_AMP] = ACTIONS(13127),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(13139),
    [anon_sym_GT_GT] = ACTIONS(13139),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(13145),
    [anon_sym_PLUS] = ACTIONS(13121),
    [anon_sym_SLASH] = ACTIONS(13123),
    [anon_sym_PERCENT] = ACTIONS(13123),
    [sym_comment] = ACTIONS(87),
  },
  [10444] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(14807),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [10445] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(13121),
    [sym__binary_star] = ACTIONS(13123),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(13125),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(13123),
    [anon_sym_AMP] = ACTIONS(13127),
    [anon_sym_LT] = ACTIONS(13129),
    [anon_sym_end] = ACTIONS(5927),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_else] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(13133),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13135),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(13137),
    [anon_sym_AMP_AMP] = ACTIONS(13137),
    [anon_sym_LT_LT] = ACTIONS(13139),
    [anon_sym_GT_GT] = ACTIONS(13139),
    [anon_sym_EQ_EQ] = ACTIONS(13141),
    [anon_sym_BANG_EQ] = ACTIONS(13137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13137),
    [anon_sym_LT_EQ_GT] = ACTIONS(13137),
    [anon_sym_EQ_TILDE] = ACTIONS(13137),
    [anon_sym_BANG_TILDE] = ACTIONS(13137),
    [anon_sym_LT_EQ] = ACTIONS(13129),
    [anon_sym_GT] = ACTIONS(13129),
    [anon_sym_GT_EQ] = ACTIONS(13143),
    [anon_sym_CARET] = ACTIONS(13145),
    [anon_sym_PLUS] = ACTIONS(13121),
    [anon_sym_SLASH] = ACTIONS(13123),
    [anon_sym_PERCENT] = ACTIONS(13123),
    [sym_comment] = ACTIONS(87),
  },
  [10446] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(13121),
    [sym__binary_star] = ACTIONS(13123),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(13125),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13123),
    [anon_sym_AMP] = ACTIONS(13127),
    [anon_sym_LT] = ACTIONS(13129),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(13131),
    [anon_sym_DOT_DOT] = ACTIONS(13133),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13135),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(13137),
    [anon_sym_AMP_AMP] = ACTIONS(13137),
    [anon_sym_LT_LT] = ACTIONS(13139),
    [anon_sym_GT_GT] = ACTIONS(13139),
    [anon_sym_EQ_EQ] = ACTIONS(13141),
    [anon_sym_BANG_EQ] = ACTIONS(13137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13137),
    [anon_sym_LT_EQ_GT] = ACTIONS(13137),
    [anon_sym_EQ_TILDE] = ACTIONS(13137),
    [anon_sym_BANG_TILDE] = ACTIONS(13137),
    [anon_sym_LT_EQ] = ACTIONS(13129),
    [anon_sym_GT] = ACTIONS(13129),
    [anon_sym_GT_EQ] = ACTIONS(13143),
    [anon_sym_CARET] = ACTIONS(13145),
    [anon_sym_PLUS] = ACTIONS(13121),
    [anon_sym_SLASH] = ACTIONS(13123),
    [anon_sym_PERCENT] = ACTIONS(13123),
    [sym_comment] = ACTIONS(87),
  },
  [10447] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(13121),
    [sym__binary_star] = ACTIONS(13123),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(13125),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13123),
    [anon_sym_AMP] = ACTIONS(13127),
    [anon_sym_LT] = ACTIONS(13129),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(13139),
    [anon_sym_GT_GT] = ACTIONS(13139),
    [anon_sym_EQ_EQ] = ACTIONS(13141),
    [anon_sym_BANG_EQ] = ACTIONS(13137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13137),
    [anon_sym_LT_EQ_GT] = ACTIONS(13137),
    [anon_sym_EQ_TILDE] = ACTIONS(13137),
    [anon_sym_BANG_TILDE] = ACTIONS(13137),
    [anon_sym_LT_EQ] = ACTIONS(13129),
    [anon_sym_GT] = ACTIONS(13129),
    [anon_sym_GT_EQ] = ACTIONS(13143),
    [anon_sym_CARET] = ACTIONS(13145),
    [anon_sym_PLUS] = ACTIONS(13121),
    [anon_sym_SLASH] = ACTIONS(13123),
    [anon_sym_PERCENT] = ACTIONS(13123),
    [sym_comment] = ACTIONS(87),
  },
  [10448] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(13121),
    [sym__binary_star] = ACTIONS(13123),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13123),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(13121),
    [anon_sym_SLASH] = ACTIONS(13123),
    [anon_sym_PERCENT] = ACTIONS(13123),
    [sym_comment] = ACTIONS(87),
  },
  [10449] = {
    [aux_sym_exceptions_repeat1] = STATE(10449),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_COMMA] = ACTIONS(14809),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_end] = ACTIONS(11597),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_else] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [10450] = {
    [aux_sym_exceptions_repeat1] = STATE(9495),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_end] = ACTIONS(6191),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_else] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [10451] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(13121),
    [sym__binary_star] = ACTIONS(13123),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(13125),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(13123),
    [anon_sym_AMP] = ACTIONS(13127),
    [anon_sym_LT] = ACTIONS(13129),
    [anon_sym_end] = ACTIONS(6210),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_else] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(13131),
    [anon_sym_DOT_DOT] = ACTIONS(13133),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13135),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(13137),
    [anon_sym_AMP_AMP] = ACTIONS(13137),
    [anon_sym_LT_LT] = ACTIONS(13139),
    [anon_sym_GT_GT] = ACTIONS(13139),
    [anon_sym_EQ_EQ] = ACTIONS(13141),
    [anon_sym_BANG_EQ] = ACTIONS(13137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13137),
    [anon_sym_LT_EQ_GT] = ACTIONS(13137),
    [anon_sym_EQ_TILDE] = ACTIONS(13137),
    [anon_sym_BANG_TILDE] = ACTIONS(13137),
    [anon_sym_LT_EQ] = ACTIONS(13129),
    [anon_sym_GT] = ACTIONS(13129),
    [anon_sym_GT_EQ] = ACTIONS(13143),
    [anon_sym_CARET] = ACTIONS(13145),
    [anon_sym_PLUS] = ACTIONS(13121),
    [anon_sym_SLASH] = ACTIONS(13123),
    [anon_sym_PERCENT] = ACTIONS(13123),
    [sym_comment] = ACTIONS(87),
  },
  [10452] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(8290),
    [sym__binary_star] = ACTIONS(8292),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(8294),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(8292),
    [anon_sym_AMP] = ACTIONS(8296),
    [anon_sym_LT] = ACTIONS(8298),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(8300),
    [anon_sym_DOT_DOT] = ACTIONS(8302),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8304),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(8306),
    [anon_sym_AMP_AMP] = ACTIONS(8306),
    [anon_sym_LT_LT] = ACTIONS(8308),
    [anon_sym_GT_GT] = ACTIONS(8308),
    [anon_sym_EQ_EQ] = ACTIONS(8310),
    [anon_sym_BANG_EQ] = ACTIONS(8306),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8306),
    [anon_sym_LT_EQ_GT] = ACTIONS(8306),
    [anon_sym_EQ_TILDE] = ACTIONS(8306),
    [anon_sym_BANG_TILDE] = ACTIONS(8306),
    [anon_sym_LT_EQ] = ACTIONS(8298),
    [anon_sym_GT] = ACTIONS(8298),
    [anon_sym_GT_EQ] = ACTIONS(8312),
    [anon_sym_CARET] = ACTIONS(8314),
    [anon_sym_PLUS] = ACTIONS(8290),
    [anon_sym_SLASH] = ACTIONS(8292),
    [anon_sym_PERCENT] = ACTIONS(8292),
    [sym_comment] = ACTIONS(87),
  },
  [10453] = {
    [aux_sym_exceptions_repeat1] = STATE(10453),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(14812),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [10454] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(8350),
    [sym__binary_star] = ACTIONS(8352),
    [anon_sym_LBRACE] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(8354),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(8356),
    [anon_sym_AMP] = ACTIONS(8358),
    [anon_sym_EQ] = ACTIONS(12879),
    [anon_sym_LT] = ACTIONS(8360),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_PLUS_EQ] = ACTIONS(12120),
    [anon_sym_DASH_EQ] = ACTIONS(12120),
    [anon_sym_STAR_EQ] = ACTIONS(12120),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12120),
    [anon_sym_SLASH_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12120),
    [anon_sym_AMP_EQ] = ACTIONS(12120),
    [anon_sym_PERCENT_EQ] = ACTIONS(12120),
    [anon_sym_GT_GT_EQ] = ACTIONS(12120),
    [anon_sym_LT_LT_EQ] = ACTIONS(12120),
    [anon_sym_CARET_EQ] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(8362),
    [anon_sym_DOT_DOT] = ACTIONS(8364),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8366),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(8368),
    [anon_sym_AMP_AMP] = ACTIONS(8368),
    [anon_sym_LT_LT] = ACTIONS(8370),
    [anon_sym_GT_GT] = ACTIONS(8370),
    [anon_sym_EQ_EQ] = ACTIONS(8368),
    [anon_sym_BANG_EQ] = ACTIONS(8372),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8372),
    [anon_sym_LT_EQ_GT] = ACTIONS(8372),
    [anon_sym_EQ_TILDE] = ACTIONS(8372),
    [anon_sym_BANG_TILDE] = ACTIONS(8372),
    [anon_sym_LT_EQ] = ACTIONS(8360),
    [anon_sym_GT] = ACTIONS(8360),
    [anon_sym_GT_EQ] = ACTIONS(8374),
    [anon_sym_CARET] = ACTIONS(8354),
    [anon_sym_PLUS] = ACTIONS(8376),
    [anon_sym_SLASH] = ACTIONS(8356),
    [anon_sym_PERCENT] = ACTIONS(8356),
    [sym_comment] = ACTIONS(87),
  },
  [10455] = {
    [aux_sym_exceptions_repeat1] = STATE(10455),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(14815),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_PLUS_EQ] = ACTIONS(11597),
    [anon_sym_DASH_EQ] = ACTIONS(11597),
    [anon_sym_STAR_EQ] = ACTIONS(11597),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11597),
    [anon_sym_SLASH_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11597),
    [anon_sym_AMP_EQ] = ACTIONS(11597),
    [anon_sym_PERCENT_EQ] = ACTIONS(11597),
    [anon_sym_GT_GT_EQ] = ACTIONS(11597),
    [anon_sym_LT_LT_EQ] = ACTIONS(11597),
    [anon_sym_CARET_EQ] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_LT] = ACTIONS(12338),
    [anon_sym_GT_GT] = ACTIONS(12338),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(12338),
    [anon_sym_PLUS] = ACTIONS(12338),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [10456] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(8386),
    [sym__binary_star] = ACTIONS(8388),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(8390),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(8388),
    [anon_sym_AMP] = ACTIONS(8392),
    [anon_sym_LT] = ACTIONS(8394),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(8396),
    [anon_sym_DOT_DOT] = ACTIONS(8398),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8400),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(8402),
    [anon_sym_AMP_AMP] = ACTIONS(8402),
    [anon_sym_LT_LT] = ACTIONS(8404),
    [anon_sym_GT_GT] = ACTIONS(8404),
    [anon_sym_EQ_EQ] = ACTIONS(8406),
    [anon_sym_BANG_EQ] = ACTIONS(8402),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8402),
    [anon_sym_LT_EQ_GT] = ACTIONS(8402),
    [anon_sym_EQ_TILDE] = ACTIONS(8402),
    [anon_sym_BANG_TILDE] = ACTIONS(8402),
    [anon_sym_LT_EQ] = ACTIONS(8394),
    [anon_sym_GT] = ACTIONS(8394),
    [anon_sym_GT_EQ] = ACTIONS(8408),
    [anon_sym_CARET] = ACTIONS(8410),
    [anon_sym_PLUS] = ACTIONS(8386),
    [anon_sym_SLASH] = ACTIONS(8388),
    [anon_sym_PERCENT] = ACTIONS(8388),
    [sym_comment] = ACTIONS(87),
  },
  [10457] = {
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(8434),
    [sym__binary_star] = ACTIONS(8436),
    [anon_sym_LBRACE] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(8438),
    [anon_sym_STAR_STAR] = ACTIONS(8436),
    [anon_sym_AMP] = ACTIONS(8440),
    [anon_sym_LT] = ACTIONS(8442),
    [anon_sym_in] = ACTIONS(12120),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(8444),
    [anon_sym_DOT_DOT] = ACTIONS(8446),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8448),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(8452),
    [anon_sym_AMP_AMP] = ACTIONS(8452),
    [anon_sym_LT_LT] = ACTIONS(8454),
    [anon_sym_GT_GT] = ACTIONS(8454),
    [anon_sym_EQ_EQ] = ACTIONS(8456),
    [anon_sym_BANG_EQ] = ACTIONS(8452),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8452),
    [anon_sym_LT_EQ_GT] = ACTIONS(8452),
    [anon_sym_EQ_TILDE] = ACTIONS(8452),
    [anon_sym_BANG_TILDE] = ACTIONS(8452),
    [anon_sym_LT_EQ] = ACTIONS(8442),
    [anon_sym_GT] = ACTIONS(8442),
    [anon_sym_GT_EQ] = ACTIONS(8458),
    [anon_sym_CARET] = ACTIONS(8460),
    [anon_sym_PLUS] = ACTIONS(8434),
    [anon_sym_SLASH] = ACTIONS(8436),
    [anon_sym_PERCENT] = ACTIONS(8436),
    [sym_comment] = ACTIONS(87),
  },
  [10458] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(13180),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(13184),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_in] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(13184),
    [anon_sym_PERCENT] = ACTIONS(13184),
    [sym_comment] = ACTIONS(87),
  },
  [10459] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(13184),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_in] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(5827),
    [anon_sym_PERCENT] = ACTIONS(5827),
    [sym_comment] = ACTIONS(87),
  },
  [10460] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(13178),
    [sym__binary_star] = ACTIONS(13180),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(13184),
    [anon_sym_AMP] = ACTIONS(13186),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_in] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(13198),
    [anon_sym_GT_GT] = ACTIONS(13198),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(13204),
    [anon_sym_SLASH] = ACTIONS(13184),
    [anon_sym_PERCENT] = ACTIONS(13184),
    [sym_comment] = ACTIONS(87),
  },
  [10461] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(13178),
    [sym__binary_star] = ACTIONS(13180),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(13184),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_in] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(13198),
    [anon_sym_GT_GT] = ACTIONS(13198),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(13204),
    [anon_sym_SLASH] = ACTIONS(13184),
    [anon_sym_PERCENT] = ACTIONS(13184),
    [sym_comment] = ACTIONS(87),
  },
  [10462] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(13178),
    [sym__binary_star] = ACTIONS(13180),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(13182),
    [anon_sym_STAR_STAR] = ACTIONS(13184),
    [anon_sym_AMP] = ACTIONS(13186),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_in] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(13198),
    [anon_sym_GT_GT] = ACTIONS(13198),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(13182),
    [anon_sym_PLUS] = ACTIONS(13204),
    [anon_sym_SLASH] = ACTIONS(13184),
    [anon_sym_PERCENT] = ACTIONS(13184),
    [sym_comment] = ACTIONS(87),
  },
  [10463] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(14818),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [10464] = {
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(13178),
    [sym__binary_star] = ACTIONS(13180),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(13182),
    [anon_sym_STAR_STAR] = ACTIONS(13184),
    [anon_sym_AMP] = ACTIONS(13186),
    [anon_sym_EQ] = ACTIONS(7888),
    [anon_sym_LT] = ACTIONS(13188),
    [anon_sym_in] = ACTIONS(5927),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_PLUS_EQ] = ACTIONS(5927),
    [anon_sym_DASH_EQ] = ACTIONS(5927),
    [anon_sym_STAR_EQ] = ACTIONS(5927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5927),
    [anon_sym_SLASH_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5927),
    [anon_sym_AMP_EQ] = ACTIONS(5927),
    [anon_sym_PERCENT_EQ] = ACTIONS(5927),
    [anon_sym_GT_GT_EQ] = ACTIONS(5927),
    [anon_sym_LT_LT_EQ] = ACTIONS(5927),
    [anon_sym_CARET_EQ] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(13192),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13194),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(13196),
    [anon_sym_AMP_AMP] = ACTIONS(13196),
    [anon_sym_LT_LT] = ACTIONS(13198),
    [anon_sym_GT_GT] = ACTIONS(13198),
    [anon_sym_EQ_EQ] = ACTIONS(13196),
    [anon_sym_BANG_EQ] = ACTIONS(13200),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13200),
    [anon_sym_LT_EQ_GT] = ACTIONS(13200),
    [anon_sym_EQ_TILDE] = ACTIONS(13200),
    [anon_sym_BANG_TILDE] = ACTIONS(13200),
    [anon_sym_LT_EQ] = ACTIONS(13188),
    [anon_sym_GT] = ACTIONS(13188),
    [anon_sym_GT_EQ] = ACTIONS(13202),
    [anon_sym_CARET] = ACTIONS(13182),
    [anon_sym_PLUS] = ACTIONS(13204),
    [anon_sym_SLASH] = ACTIONS(13184),
    [anon_sym_PERCENT] = ACTIONS(13184),
    [sym_comment] = ACTIONS(87),
  },
  [10465] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(13178),
    [sym__binary_star] = ACTIONS(13180),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(13182),
    [anon_sym_STAR_STAR] = ACTIONS(13184),
    [anon_sym_AMP] = ACTIONS(13186),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(13188),
    [anon_sym_in] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(13190),
    [anon_sym_DOT_DOT] = ACTIONS(13192),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13194),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(13196),
    [anon_sym_AMP_AMP] = ACTIONS(13196),
    [anon_sym_LT_LT] = ACTIONS(13198),
    [anon_sym_GT_GT] = ACTIONS(13198),
    [anon_sym_EQ_EQ] = ACTIONS(13196),
    [anon_sym_BANG_EQ] = ACTIONS(13200),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13200),
    [anon_sym_LT_EQ_GT] = ACTIONS(13200),
    [anon_sym_EQ_TILDE] = ACTIONS(13200),
    [anon_sym_BANG_TILDE] = ACTIONS(13200),
    [anon_sym_LT_EQ] = ACTIONS(13188),
    [anon_sym_GT] = ACTIONS(13188),
    [anon_sym_GT_EQ] = ACTIONS(13202),
    [anon_sym_CARET] = ACTIONS(13182),
    [anon_sym_PLUS] = ACTIONS(13204),
    [anon_sym_SLASH] = ACTIONS(13184),
    [anon_sym_PERCENT] = ACTIONS(13184),
    [sym_comment] = ACTIONS(87),
  },
  [10466] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(13178),
    [sym__binary_star] = ACTIONS(13180),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(13182),
    [anon_sym_STAR_STAR] = ACTIONS(13184),
    [anon_sym_AMP] = ACTIONS(13186),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(13188),
    [anon_sym_in] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(13198),
    [anon_sym_GT_GT] = ACTIONS(13198),
    [anon_sym_EQ_EQ] = ACTIONS(13196),
    [anon_sym_BANG_EQ] = ACTIONS(13200),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13200),
    [anon_sym_LT_EQ_GT] = ACTIONS(13200),
    [anon_sym_EQ_TILDE] = ACTIONS(13200),
    [anon_sym_BANG_TILDE] = ACTIONS(13200),
    [anon_sym_LT_EQ] = ACTIONS(13188),
    [anon_sym_GT] = ACTIONS(13188),
    [anon_sym_GT_EQ] = ACTIONS(13202),
    [anon_sym_CARET] = ACTIONS(13182),
    [anon_sym_PLUS] = ACTIONS(13204),
    [anon_sym_SLASH] = ACTIONS(13184),
    [anon_sym_PERCENT] = ACTIONS(13184),
    [sym_comment] = ACTIONS(87),
  },
  [10467] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(13178),
    [sym__binary_star] = ACTIONS(13180),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_STAR_STAR] = ACTIONS(13184),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_in] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(13204),
    [anon_sym_SLASH] = ACTIONS(13184),
    [anon_sym_PERCENT] = ACTIONS(13184),
    [sym_comment] = ACTIONS(87),
  },
  [10468] = {
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(13178),
    [sym__binary_star] = ACTIONS(13180),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(13182),
    [anon_sym_STAR_STAR] = ACTIONS(13184),
    [anon_sym_AMP] = ACTIONS(13186),
    [anon_sym_EQ] = ACTIONS(7936),
    [anon_sym_LT] = ACTIONS(13188),
    [anon_sym_in] = ACTIONS(5115),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_PLUS_EQ] = ACTIONS(5115),
    [anon_sym_DASH_EQ] = ACTIONS(5115),
    [anon_sym_STAR_EQ] = ACTIONS(5115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5115),
    [anon_sym_SLASH_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5115),
    [anon_sym_AMP_EQ] = ACTIONS(5115),
    [anon_sym_PERCENT_EQ] = ACTIONS(5115),
    [anon_sym_GT_GT_EQ] = ACTIONS(5115),
    [anon_sym_LT_LT_EQ] = ACTIONS(5115),
    [anon_sym_CARET_EQ] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(13190),
    [anon_sym_DOT_DOT] = ACTIONS(13192),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13194),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(13196),
    [anon_sym_AMP_AMP] = ACTIONS(13196),
    [anon_sym_LT_LT] = ACTIONS(13198),
    [anon_sym_GT_GT] = ACTIONS(13198),
    [anon_sym_EQ_EQ] = ACTIONS(13196),
    [anon_sym_BANG_EQ] = ACTIONS(13200),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13200),
    [anon_sym_LT_EQ_GT] = ACTIONS(13200),
    [anon_sym_EQ_TILDE] = ACTIONS(13200),
    [anon_sym_BANG_TILDE] = ACTIONS(13200),
    [anon_sym_LT_EQ] = ACTIONS(13188),
    [anon_sym_GT] = ACTIONS(13188),
    [anon_sym_GT_EQ] = ACTIONS(13202),
    [anon_sym_CARET] = ACTIONS(13182),
    [anon_sym_PLUS] = ACTIONS(13204),
    [anon_sym_SLASH] = ACTIONS(13184),
    [anon_sym_PERCENT] = ACTIONS(13184),
    [sym_comment] = ACTIONS(87),
  },
  [10469] = {
    [aux_sym_exceptions_repeat1] = STATE(10931),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_STAR_STAR] = ACTIONS(6193),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_in] = ACTIONS(6191),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_PLUS_EQ] = ACTIONS(6191),
    [anon_sym_DASH_EQ] = ACTIONS(6191),
    [anon_sym_STAR_EQ] = ACTIONS(6191),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6191),
    [anon_sym_SLASH_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6191),
    [anon_sym_AMP_EQ] = ACTIONS(6191),
    [anon_sym_PERCENT_EQ] = ACTIONS(6191),
    [anon_sym_GT_GT_EQ] = ACTIONS(6191),
    [anon_sym_LT_LT_EQ] = ACTIONS(6191),
    [anon_sym_CARET_EQ] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6193),
    [anon_sym_AMP_AMP] = ACTIONS(6193),
    [anon_sym_LT_LT] = ACTIONS(6193),
    [anon_sym_GT_GT] = ACTIONS(6193),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6193),
    [anon_sym_PLUS] = ACTIONS(6193),
    [anon_sym_SLASH] = ACTIONS(6193),
    [anon_sym_PERCENT] = ACTIONS(6193),
    [sym_comment] = ACTIONS(87),
  },
  [10470] = {
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(13178),
    [sym__binary_star] = ACTIONS(13180),
    [anon_sym_LBRACE] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(13182),
    [anon_sym_STAR_STAR] = ACTIONS(13184),
    [anon_sym_AMP] = ACTIONS(13186),
    [anon_sym_EQ] = ACTIONS(7938),
    [anon_sym_LT] = ACTIONS(13188),
    [anon_sym_in] = ACTIONS(6210),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_PLUS_EQ] = ACTIONS(6210),
    [anon_sym_DASH_EQ] = ACTIONS(6210),
    [anon_sym_STAR_EQ] = ACTIONS(6210),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6210),
    [anon_sym_SLASH_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6210),
    [anon_sym_AMP_EQ] = ACTIONS(6210),
    [anon_sym_PERCENT_EQ] = ACTIONS(6210),
    [anon_sym_GT_GT_EQ] = ACTIONS(6210),
    [anon_sym_LT_LT_EQ] = ACTIONS(6210),
    [anon_sym_CARET_EQ] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(13190),
    [anon_sym_DOT_DOT] = ACTIONS(13192),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13194),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(13196),
    [anon_sym_AMP_AMP] = ACTIONS(13196),
    [anon_sym_LT_LT] = ACTIONS(13198),
    [anon_sym_GT_GT] = ACTIONS(13198),
    [anon_sym_EQ_EQ] = ACTIONS(13196),
    [anon_sym_BANG_EQ] = ACTIONS(13200),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13200),
    [anon_sym_LT_EQ_GT] = ACTIONS(13200),
    [anon_sym_EQ_TILDE] = ACTIONS(13200),
    [anon_sym_BANG_TILDE] = ACTIONS(13200),
    [anon_sym_LT_EQ] = ACTIONS(13188),
    [anon_sym_GT] = ACTIONS(13188),
    [anon_sym_GT_EQ] = ACTIONS(13202),
    [anon_sym_CARET] = ACTIONS(13182),
    [anon_sym_PLUS] = ACTIONS(13204),
    [anon_sym_SLASH] = ACTIONS(13184),
    [anon_sym_PERCENT] = ACTIONS(13184),
    [sym_comment] = ACTIONS(87),
  },
  [10471] = {
    [sym_string] = STATE(10471),
    [aux_sym_chained_string_repeat1] = STATE(10471),
    [sym__string_start] = ACTIONS(13881),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_STAR_STAR] = ACTIONS(6217),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_EQ] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_in] = ACTIONS(6212),
    [anon_sym_do] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_PLUS_EQ] = ACTIONS(6212),
    [anon_sym_DASH_EQ] = ACTIONS(6212),
    [anon_sym_STAR_EQ] = ACTIONS(6212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6212),
    [anon_sym_SLASH_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6212),
    [anon_sym_AMP_EQ] = ACTIONS(6212),
    [anon_sym_PERCENT_EQ] = ACTIONS(6212),
    [anon_sym_GT_GT_EQ] = ACTIONS(6212),
    [anon_sym_LT_LT_EQ] = ACTIONS(6212),
    [anon_sym_CARET_EQ] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6217),
    [anon_sym_AMP_AMP] = ACTIONS(6217),
    [anon_sym_LT_LT] = ACTIONS(6217),
    [anon_sym_GT_GT] = ACTIONS(6217),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6217),
    [anon_sym_PLUS] = ACTIONS(6217),
    [anon_sym_SLASH] = ACTIONS(6217),
    [anon_sym_PERCENT] = ACTIONS(6217),
    [sym_comment] = ACTIONS(87),
  },
  [10472] = {
    [aux_sym_exceptions_repeat1] = STATE(10472),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(14820),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_in] = ACTIONS(11597),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [10473] = {
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(8490),
    [sym__binary_star] = ACTIONS(8492),
    [anon_sym_LBRACE] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(8494),
    [anon_sym_STAR_STAR] = ACTIONS(8496),
    [anon_sym_AMP] = ACTIONS(8498),
    [anon_sym_EQ] = ACTIONS(12879),
    [anon_sym_LT] = ACTIONS(8500),
    [anon_sym_in] = ACTIONS(12120),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_EQ_GT] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_PLUS_EQ] = ACTIONS(12120),
    [anon_sym_DASH_EQ] = ACTIONS(12120),
    [anon_sym_STAR_EQ] = ACTIONS(12120),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12120),
    [anon_sym_SLASH_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12120),
    [anon_sym_AMP_EQ] = ACTIONS(12120),
    [anon_sym_PERCENT_EQ] = ACTIONS(12120),
    [anon_sym_GT_GT_EQ] = ACTIONS(12120),
    [anon_sym_LT_LT_EQ] = ACTIONS(12120),
    [anon_sym_CARET_EQ] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(8502),
    [anon_sym_DOT_DOT] = ACTIONS(8504),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8506),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(8508),
    [anon_sym_AMP_AMP] = ACTIONS(8508),
    [anon_sym_LT_LT] = ACTIONS(8510),
    [anon_sym_GT_GT] = ACTIONS(8510),
    [anon_sym_EQ_EQ] = ACTIONS(8508),
    [anon_sym_BANG_EQ] = ACTIONS(8512),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8512),
    [anon_sym_LT_EQ_GT] = ACTIONS(8512),
    [anon_sym_EQ_TILDE] = ACTIONS(8512),
    [anon_sym_BANG_TILDE] = ACTIONS(8512),
    [anon_sym_LT_EQ] = ACTIONS(8500),
    [anon_sym_GT] = ACTIONS(8500),
    [anon_sym_GT_EQ] = ACTIONS(8514),
    [anon_sym_CARET] = ACTIONS(8494),
    [anon_sym_PLUS] = ACTIONS(8516),
    [anon_sym_SLASH] = ACTIONS(8496),
    [anon_sym_PERCENT] = ACTIONS(8496),
    [sym_comment] = ACTIONS(87),
  },
  [10474] = {
    [aux_sym_exceptions_repeat1] = STATE(10474),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(14823),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_in] = ACTIONS(11597),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_PLUS_EQ] = ACTIONS(11597),
    [anon_sym_DASH_EQ] = ACTIONS(11597),
    [anon_sym_STAR_EQ] = ACTIONS(11597),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11597),
    [anon_sym_SLASH_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11597),
    [anon_sym_AMP_EQ] = ACTIONS(11597),
    [anon_sym_PERCENT_EQ] = ACTIONS(11597),
    [anon_sym_GT_GT_EQ] = ACTIONS(11597),
    [anon_sym_LT_LT_EQ] = ACTIONS(11597),
    [anon_sym_CARET_EQ] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_LT] = ACTIONS(12338),
    [anon_sym_GT_GT] = ACTIONS(12338),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(12338),
    [anon_sym_PLUS] = ACTIONS(12338),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [10475] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(8537),
    [sym__binary_star] = ACTIONS(8539),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(8541),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(8539),
    [anon_sym_AMP] = ACTIONS(8543),
    [anon_sym_LT] = ACTIONS(8545),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(8547),
    [anon_sym_DOT_DOT] = ACTIONS(8549),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8551),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(8553),
    [anon_sym_AMP_AMP] = ACTIONS(8553),
    [anon_sym_LT_LT] = ACTIONS(8555),
    [anon_sym_GT_GT] = ACTIONS(8555),
    [anon_sym_EQ_EQ] = ACTIONS(8557),
    [anon_sym_BANG_EQ] = ACTIONS(8553),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8553),
    [anon_sym_LT_EQ_GT] = ACTIONS(8553),
    [anon_sym_EQ_TILDE] = ACTIONS(8553),
    [anon_sym_BANG_TILDE] = ACTIONS(8553),
    [anon_sym_LT_EQ] = ACTIONS(8545),
    [anon_sym_GT] = ACTIONS(8545),
    [anon_sym_GT_EQ] = ACTIONS(8559),
    [anon_sym_CARET] = ACTIONS(8561),
    [anon_sym_PLUS] = ACTIONS(8537),
    [anon_sym_SLASH] = ACTIONS(8539),
    [anon_sym_PERCENT] = ACTIONS(8539),
    [sym_comment] = ACTIONS(87),
  },
  [10476] = {
    [aux_sym_exceptions_repeat1] = STATE(10476),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(14826),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [10477] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(8587),
    [sym__binary_star] = ACTIONS(8589),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(8591),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(8589),
    [anon_sym_AMP] = ACTIONS(8593),
    [anon_sym_LT] = ACTIONS(8595),
    [anon_sym_QMARK] = ACTIONS(8597),
    [anon_sym_DOT_DOT] = ACTIONS(8599),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8601),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(8603),
    [anon_sym_AMP_AMP] = ACTIONS(8603),
    [anon_sym_LT_LT] = ACTIONS(8605),
    [anon_sym_GT_GT] = ACTIONS(8605),
    [anon_sym_EQ_EQ] = ACTIONS(8607),
    [anon_sym_BANG_EQ] = ACTIONS(8603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8603),
    [anon_sym_LT_EQ_GT] = ACTIONS(8603),
    [anon_sym_EQ_TILDE] = ACTIONS(8603),
    [anon_sym_BANG_TILDE] = ACTIONS(8603),
    [anon_sym_LT_EQ] = ACTIONS(8595),
    [anon_sym_GT] = ACTIONS(8595),
    [anon_sym_GT_EQ] = ACTIONS(8609),
    [anon_sym_CARET] = ACTIONS(8611),
    [anon_sym_PLUS] = ACTIONS(8587),
    [anon_sym_SLASH] = ACTIONS(8589),
    [anon_sym_PERCENT] = ACTIONS(8589),
    [sym_comment] = ACTIONS(87),
  },
  [10478] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(13248),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13248),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(13248),
    [anon_sym_PERCENT] = ACTIONS(13248),
    [sym_comment] = ACTIONS(87),
  },
  [10479] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13248),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [10480] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(13246),
    [sym__binary_star] = ACTIONS(13248),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13248),
    [anon_sym_AMP] = ACTIONS(13252),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(13264),
    [anon_sym_GT_GT] = ACTIONS(13264),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(13246),
    [anon_sym_SLASH] = ACTIONS(13248),
    [anon_sym_PERCENT] = ACTIONS(13248),
    [sym_comment] = ACTIONS(87),
  },
  [10481] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(13246),
    [sym__binary_star] = ACTIONS(13248),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13248),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(13264),
    [anon_sym_GT_GT] = ACTIONS(13264),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(13246),
    [anon_sym_SLASH] = ACTIONS(13248),
    [anon_sym_PERCENT] = ACTIONS(13248),
    [sym_comment] = ACTIONS(87),
  },
  [10482] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(13246),
    [sym__binary_star] = ACTIONS(13248),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(13250),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13248),
    [anon_sym_AMP] = ACTIONS(13252),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(13264),
    [anon_sym_GT_GT] = ACTIONS(13264),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(13270),
    [anon_sym_PLUS] = ACTIONS(13246),
    [anon_sym_SLASH] = ACTIONS(13248),
    [anon_sym_PERCENT] = ACTIONS(13248),
    [sym_comment] = ACTIONS(87),
  },
  [10483] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(14829),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [10484] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(13246),
    [sym__binary_star] = ACTIONS(13248),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(13250),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(13248),
    [anon_sym_AMP] = ACTIONS(13252),
    [anon_sym_LT] = ACTIONS(13254),
    [anon_sym_then] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(13258),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13260),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(13262),
    [anon_sym_AMP_AMP] = ACTIONS(13262),
    [anon_sym_LT_LT] = ACTIONS(13264),
    [anon_sym_GT_GT] = ACTIONS(13264),
    [anon_sym_EQ_EQ] = ACTIONS(13266),
    [anon_sym_BANG_EQ] = ACTIONS(13262),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13262),
    [anon_sym_LT_EQ_GT] = ACTIONS(13262),
    [anon_sym_EQ_TILDE] = ACTIONS(13262),
    [anon_sym_BANG_TILDE] = ACTIONS(13262),
    [anon_sym_LT_EQ] = ACTIONS(13254),
    [anon_sym_GT] = ACTIONS(13254),
    [anon_sym_GT_EQ] = ACTIONS(13268),
    [anon_sym_CARET] = ACTIONS(13270),
    [anon_sym_PLUS] = ACTIONS(13246),
    [anon_sym_SLASH] = ACTIONS(13248),
    [anon_sym_PERCENT] = ACTIONS(13248),
    [sym_comment] = ACTIONS(87),
  },
  [10485] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(13246),
    [sym__binary_star] = ACTIONS(13248),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(13250),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13248),
    [anon_sym_AMP] = ACTIONS(13252),
    [anon_sym_LT] = ACTIONS(13254),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(13256),
    [anon_sym_DOT_DOT] = ACTIONS(13258),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13260),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(13262),
    [anon_sym_AMP_AMP] = ACTIONS(13262),
    [anon_sym_LT_LT] = ACTIONS(13264),
    [anon_sym_GT_GT] = ACTIONS(13264),
    [anon_sym_EQ_EQ] = ACTIONS(13266),
    [anon_sym_BANG_EQ] = ACTIONS(13262),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13262),
    [anon_sym_LT_EQ_GT] = ACTIONS(13262),
    [anon_sym_EQ_TILDE] = ACTIONS(13262),
    [anon_sym_BANG_TILDE] = ACTIONS(13262),
    [anon_sym_LT_EQ] = ACTIONS(13254),
    [anon_sym_GT] = ACTIONS(13254),
    [anon_sym_GT_EQ] = ACTIONS(13268),
    [anon_sym_CARET] = ACTIONS(13270),
    [anon_sym_PLUS] = ACTIONS(13246),
    [anon_sym_SLASH] = ACTIONS(13248),
    [anon_sym_PERCENT] = ACTIONS(13248),
    [sym_comment] = ACTIONS(87),
  },
  [10486] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(13246),
    [sym__binary_star] = ACTIONS(13248),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(13250),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13248),
    [anon_sym_AMP] = ACTIONS(13252),
    [anon_sym_LT] = ACTIONS(13254),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(13264),
    [anon_sym_GT_GT] = ACTIONS(13264),
    [anon_sym_EQ_EQ] = ACTIONS(13266),
    [anon_sym_BANG_EQ] = ACTIONS(13262),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13262),
    [anon_sym_LT_EQ_GT] = ACTIONS(13262),
    [anon_sym_EQ_TILDE] = ACTIONS(13262),
    [anon_sym_BANG_TILDE] = ACTIONS(13262),
    [anon_sym_LT_EQ] = ACTIONS(13254),
    [anon_sym_GT] = ACTIONS(13254),
    [anon_sym_GT_EQ] = ACTIONS(13268),
    [anon_sym_CARET] = ACTIONS(13270),
    [anon_sym_PLUS] = ACTIONS(13246),
    [anon_sym_SLASH] = ACTIONS(13248),
    [anon_sym_PERCENT] = ACTIONS(13248),
    [sym_comment] = ACTIONS(87),
  },
  [10487] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(13246),
    [sym__binary_star] = ACTIONS(13248),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13248),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(13246),
    [anon_sym_SLASH] = ACTIONS(13248),
    [anon_sym_PERCENT] = ACTIONS(13248),
    [sym_comment] = ACTIONS(87),
  },
  [10488] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(13246),
    [sym__binary_star] = ACTIONS(13248),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(13250),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(13248),
    [anon_sym_AMP] = ACTIONS(13252),
    [anon_sym_LT] = ACTIONS(13254),
    [anon_sym_then] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(13256),
    [anon_sym_DOT_DOT] = ACTIONS(13258),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13260),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(13262),
    [anon_sym_AMP_AMP] = ACTIONS(13262),
    [anon_sym_LT_LT] = ACTIONS(13264),
    [anon_sym_GT_GT] = ACTIONS(13264),
    [anon_sym_EQ_EQ] = ACTIONS(13266),
    [anon_sym_BANG_EQ] = ACTIONS(13262),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13262),
    [anon_sym_LT_EQ_GT] = ACTIONS(13262),
    [anon_sym_EQ_TILDE] = ACTIONS(13262),
    [anon_sym_BANG_TILDE] = ACTIONS(13262),
    [anon_sym_LT_EQ] = ACTIONS(13254),
    [anon_sym_GT] = ACTIONS(13254),
    [anon_sym_GT_EQ] = ACTIONS(13268),
    [anon_sym_CARET] = ACTIONS(13270),
    [anon_sym_PLUS] = ACTIONS(13246),
    [anon_sym_SLASH] = ACTIONS(13248),
    [anon_sym_PERCENT] = ACTIONS(13248),
    [sym_comment] = ACTIONS(87),
  },
  [10489] = {
    [aux_sym_exceptions_repeat1] = STATE(10934),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_then] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [10490] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(13246),
    [sym__binary_star] = ACTIONS(13248),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(13250),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(13248),
    [anon_sym_AMP] = ACTIONS(13252),
    [anon_sym_LT] = ACTIONS(13254),
    [anon_sym_then] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(13256),
    [anon_sym_DOT_DOT] = ACTIONS(13258),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13260),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(13262),
    [anon_sym_AMP_AMP] = ACTIONS(13262),
    [anon_sym_LT_LT] = ACTIONS(13264),
    [anon_sym_GT_GT] = ACTIONS(13264),
    [anon_sym_EQ_EQ] = ACTIONS(13266),
    [anon_sym_BANG_EQ] = ACTIONS(13262),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13262),
    [anon_sym_LT_EQ_GT] = ACTIONS(13262),
    [anon_sym_EQ_TILDE] = ACTIONS(13262),
    [anon_sym_BANG_TILDE] = ACTIONS(13262),
    [anon_sym_LT_EQ] = ACTIONS(13254),
    [anon_sym_GT] = ACTIONS(13254),
    [anon_sym_GT_EQ] = ACTIONS(13268),
    [anon_sym_CARET] = ACTIONS(13270),
    [anon_sym_PLUS] = ACTIONS(13246),
    [anon_sym_SLASH] = ACTIONS(13248),
    [anon_sym_PERCENT] = ACTIONS(13248),
    [sym_comment] = ACTIONS(87),
  },
  [10491] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10935),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(10500),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(10500),
    [sym_assignment] = STATE(10935),
    [sym_operator_assignment] = STATE(10935),
    [sym_conditional] = STATE(10935),
    [sym_range] = STATE(10935),
    [sym_binary] = STATE(10935),
    [sym_unary] = STATE(10935),
    [sym_left_assignment_list] = STATE(10499),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10500),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(10500),
    [sym_false] = STATE(10500),
    [sym_nil] = STATE(10500),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(10501),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(14158),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14160),
    [anon_sym_yield] = ACTIONS(14162),
    [anon_sym_break] = ACTIONS(14164),
    [anon_sym_next] = ACTIONS(14166),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14168),
    [anon_sym_defined_QMARK] = ACTIONS(14170),
    [anon_sym_not] = ACTIONS(14172),
    [anon_sym_BANG] = ACTIONS(14174),
    [anon_sym_TILDE] = ACTIONS(14174),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10492] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9588),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9593),
    [sym_scope_resolution] = STATE(9589),
    [sym_call] = STATE(9589),
    [sym_method_call] = STATE(9593),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(10936),
    [sym__argument] = STATE(10937),
    [sym_splat_argument] = STATE(10937),
    [sym_hash_splat_argument] = STATE(10937),
    [sym_block_argument] = STATE(10937),
    [sym_assignment] = STATE(9588),
    [sym_operator_assignment] = STATE(9588),
    [sym_conditional] = STATE(9588),
    [sym_range] = STATE(9588),
    [sym_binary] = STATE(9588),
    [sym_unary] = STATE(9588),
    [sym_left_assignment_list] = STATE(9592),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9593),
    [sym__variable] = STATE(9589),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9593),
    [sym_false] = STATE(9593),
    [sym_nil] = STATE(9593),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(9594),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(10937),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(13282),
    [sym__splat_star] = ACTIONS(13284),
    [sym__unary_minus] = ACTIONS(13286),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(13288),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(13290),
    [anon_sym_yield] = ACTIONS(13292),
    [anon_sym_break] = ACTIONS(13294),
    [anon_sym_next] = ACTIONS(13296),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_when] = ACTIONS(377),
    [anon_sym_else] = ACTIONS(377),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(13298),
    [anon_sym_not] = ACTIONS(13300),
    [anon_sym_BANG] = ACTIONS(13302),
    [anon_sym_TILDE] = ACTIONS(13304),
    [sym_constant] = ACTIONS(13306),
    [sym_identifier] = ACTIONS(13306),
    [sym_instance_variable] = ACTIONS(13308),
    [sym_class_variable] = ACTIONS(13308),
    [sym_global_variable] = ACTIONS(13308),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(13310),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13310),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10493] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9588),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9593),
    [sym_scope_resolution] = STATE(9589),
    [sym_call] = STATE(9589),
    [sym_method_call] = STATE(9593),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(10936),
    [sym__argument] = STATE(10937),
    [sym_splat_argument] = STATE(10937),
    [sym_hash_splat_argument] = STATE(10937),
    [sym_block_argument] = STATE(10937),
    [sym_assignment] = STATE(9588),
    [sym_operator_assignment] = STATE(9588),
    [sym_conditional] = STATE(9588),
    [sym_range] = STATE(9588),
    [sym_binary] = STATE(9588),
    [sym_unary] = STATE(9588),
    [sym_left_assignment_list] = STATE(9592),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9593),
    [sym__variable] = STATE(9589),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9593),
    [sym_false] = STATE(9593),
    [sym_nil] = STATE(9593),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(9594),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(10937),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(13282),
    [sym__splat_star] = ACTIONS(13284),
    [sym__unary_minus] = ACTIONS(13286),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(13288),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(13290),
    [anon_sym_yield] = ACTIONS(13292),
    [anon_sym_break] = ACTIONS(13294),
    [anon_sym_next] = ACTIONS(13296),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_when] = ACTIONS(419),
    [anon_sym_else] = ACTIONS(419),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(13298),
    [anon_sym_not] = ACTIONS(13300),
    [anon_sym_BANG] = ACTIONS(13302),
    [anon_sym_TILDE] = ACTIONS(13304),
    [sym_constant] = ACTIONS(13306),
    [sym_identifier] = ACTIONS(13306),
    [sym_instance_variable] = ACTIONS(13308),
    [sym_class_variable] = ACTIONS(13308),
    [sym_global_variable] = ACTIONS(13308),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(13310),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13310),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10494] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9588),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9593),
    [sym_scope_resolution] = STATE(9589),
    [sym_call] = STATE(9589),
    [sym_method_call] = STATE(9593),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(10936),
    [sym__argument] = STATE(10937),
    [sym_splat_argument] = STATE(10937),
    [sym_hash_splat_argument] = STATE(10937),
    [sym_block_argument] = STATE(10937),
    [sym_assignment] = STATE(9588),
    [sym_operator_assignment] = STATE(9588),
    [sym_conditional] = STATE(9588),
    [sym_range] = STATE(9588),
    [sym_binary] = STATE(9588),
    [sym_unary] = STATE(9588),
    [sym_left_assignment_list] = STATE(9592),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9593),
    [sym__variable] = STATE(9589),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9593),
    [sym_false] = STATE(9593),
    [sym_nil] = STATE(9593),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(9594),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(10937),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(13282),
    [sym__splat_star] = ACTIONS(13284),
    [sym__unary_minus] = ACTIONS(13286),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(13288),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(423),
    [anon_sym_return] = ACTIONS(13290),
    [anon_sym_yield] = ACTIONS(13292),
    [anon_sym_break] = ACTIONS(13294),
    [anon_sym_next] = ACTIONS(13296),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_when] = ACTIONS(423),
    [anon_sym_else] = ACTIONS(423),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(13298),
    [anon_sym_not] = ACTIONS(13300),
    [anon_sym_BANG] = ACTIONS(13302),
    [anon_sym_TILDE] = ACTIONS(13304),
    [sym_constant] = ACTIONS(13306),
    [sym_identifier] = ACTIONS(13306),
    [sym_instance_variable] = ACTIONS(13308),
    [sym_class_variable] = ACTIONS(13308),
    [sym_global_variable] = ACTIONS(13308),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(13310),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13310),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10495] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9588),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9593),
    [sym_scope_resolution] = STATE(9589),
    [sym_call] = STATE(9589),
    [sym_method_call] = STATE(9593),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(10936),
    [sym__argument] = STATE(10937),
    [sym_splat_argument] = STATE(10937),
    [sym_hash_splat_argument] = STATE(10937),
    [sym_block_argument] = STATE(10937),
    [sym_assignment] = STATE(9588),
    [sym_operator_assignment] = STATE(9588),
    [sym_conditional] = STATE(9588),
    [sym_range] = STATE(9588),
    [sym_binary] = STATE(9588),
    [sym_unary] = STATE(9588),
    [sym_left_assignment_list] = STATE(9592),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9593),
    [sym__variable] = STATE(9589),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9593),
    [sym_false] = STATE(9593),
    [sym_nil] = STATE(9593),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(9594),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(10937),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(13282),
    [sym__splat_star] = ACTIONS(13284),
    [sym__unary_minus] = ACTIONS(13286),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(13288),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(427),
    [anon_sym_return] = ACTIONS(13290),
    [anon_sym_yield] = ACTIONS(13292),
    [anon_sym_break] = ACTIONS(13294),
    [anon_sym_next] = ACTIONS(13296),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_when] = ACTIONS(427),
    [anon_sym_else] = ACTIONS(427),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(13298),
    [anon_sym_not] = ACTIONS(13300),
    [anon_sym_BANG] = ACTIONS(13302),
    [anon_sym_TILDE] = ACTIONS(13304),
    [sym_constant] = ACTIONS(13306),
    [sym_identifier] = ACTIONS(13306),
    [sym_instance_variable] = ACTIONS(13308),
    [sym_class_variable] = ACTIONS(13308),
    [sym_global_variable] = ACTIONS(13308),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(13310),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13310),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(415),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10496] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10938),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(10500),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(10500),
    [sym_assignment] = STATE(10938),
    [sym_operator_assignment] = STATE(10938),
    [sym_conditional] = STATE(10938),
    [sym_range] = STATE(10938),
    [sym_binary] = STATE(10938),
    [sym_unary] = STATE(10938),
    [sym_left_assignment_list] = STATE(10499),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10500),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(10500),
    [sym_false] = STATE(10500),
    [sym_nil] = STATE(10500),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(10501),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(14158),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14160),
    [anon_sym_yield] = ACTIONS(14162),
    [anon_sym_break] = ACTIONS(14164),
    [anon_sym_next] = ACTIONS(14166),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14168),
    [anon_sym_defined_QMARK] = ACTIONS(14170),
    [anon_sym_not] = ACTIONS(14172),
    [anon_sym_BANG] = ACTIONS(14174),
    [anon_sym_TILDE] = ACTIONS(14174),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10497] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(10500),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(10500),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(10499),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10500),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(10500),
    [sym_false] = STATE(10500),
    [sym_nil] = STATE(10500),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(10501),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(14158),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14160),
    [anon_sym_yield] = ACTIONS(14162),
    [anon_sym_break] = ACTIONS(14164),
    [anon_sym_next] = ACTIONS(14166),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14168),
    [anon_sym_defined_QMARK] = ACTIONS(14170),
    [anon_sym_not] = ACTIONS(14172),
    [anon_sym_BANG] = ACTIONS(14174),
    [anon_sym_TILDE] = ACTIONS(14174),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10498] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(14831),
    [sym__binary_star] = ACTIONS(14833),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(14835),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(14833),
    [anon_sym_AMP] = ACTIONS(14837),
    [anon_sym_LT] = ACTIONS(14839),
    [anon_sym_end] = ACTIONS(4211),
    [anon_sym_if] = ACTIONS(4211),
    [anon_sym_unless] = ACTIONS(4211),
    [anon_sym_while] = ACTIONS(4211),
    [anon_sym_until] = ACTIONS(4211),
    [anon_sym_rescue] = ACTIONS(4211),
    [anon_sym_when] = ACTIONS(4211),
    [anon_sym_else] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(14841),
    [anon_sym_DOT_DOT] = ACTIONS(14843),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14845),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(14847),
    [anon_sym_AMP_AMP] = ACTIONS(14847),
    [anon_sym_LT_LT] = ACTIONS(14849),
    [anon_sym_GT_GT] = ACTIONS(14849),
    [anon_sym_EQ_EQ] = ACTIONS(14851),
    [anon_sym_BANG_EQ] = ACTIONS(14847),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14847),
    [anon_sym_LT_EQ_GT] = ACTIONS(14847),
    [anon_sym_EQ_TILDE] = ACTIONS(14847),
    [anon_sym_BANG_TILDE] = ACTIONS(14847),
    [anon_sym_LT_EQ] = ACTIONS(14839),
    [anon_sym_GT] = ACTIONS(14839),
    [anon_sym_GT_EQ] = ACTIONS(14853),
    [anon_sym_CARET] = ACTIONS(14855),
    [anon_sym_PLUS] = ACTIONS(14831),
    [anon_sym_SLASH] = ACTIONS(14833),
    [anon_sym_PERCENT] = ACTIONS(14833),
    [sym_comment] = ACTIONS(87),
  },
  [10499] = {
    [anon_sym_EQ] = ACTIONS(14857),
    [sym_comment] = ACTIONS(87),
  },
  [10500] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(14859),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_when] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(14861),
    [anon_sym_DASH_EQ] = ACTIONS(14861),
    [anon_sym_STAR_EQ] = ACTIONS(14861),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14861),
    [anon_sym_SLASH_EQ] = ACTIONS(14861),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14861),
    [anon_sym_PIPE_EQ] = ACTIONS(14861),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14861),
    [anon_sym_AMP_EQ] = ACTIONS(14861),
    [anon_sym_PERCENT_EQ] = ACTIONS(14861),
    [anon_sym_GT_GT_EQ] = ACTIONS(14861),
    [anon_sym_LT_LT_EQ] = ACTIONS(14861),
    [anon_sym_CARET_EQ] = ACTIONS(14861),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [10501] = {
    [sym_string] = STATE(10951),
    [aux_sym_chained_string_repeat1] = STATE(10951),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_when] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [10502] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(14831),
    [sym__binary_star] = ACTIONS(14833),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(14835),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(14833),
    [anon_sym_AMP] = ACTIONS(14837),
    [anon_sym_LT] = ACTIONS(14839),
    [anon_sym_end] = ACTIONS(4247),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_when] = ACTIONS(4247),
    [anon_sym_else] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(14841),
    [anon_sym_DOT_DOT] = ACTIONS(14843),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14845),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(14847),
    [anon_sym_AMP_AMP] = ACTIONS(14847),
    [anon_sym_LT_LT] = ACTIONS(14849),
    [anon_sym_GT_GT] = ACTIONS(14849),
    [anon_sym_EQ_EQ] = ACTIONS(14851),
    [anon_sym_BANG_EQ] = ACTIONS(14847),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14847),
    [anon_sym_LT_EQ_GT] = ACTIONS(14847),
    [anon_sym_EQ_TILDE] = ACTIONS(14847),
    [anon_sym_BANG_TILDE] = ACTIONS(14847),
    [anon_sym_LT_EQ] = ACTIONS(14839),
    [anon_sym_GT] = ACTIONS(14839),
    [anon_sym_GT_EQ] = ACTIONS(14853),
    [anon_sym_CARET] = ACTIONS(14855),
    [anon_sym_PLUS] = ACTIONS(14831),
    [anon_sym_SLASH] = ACTIONS(14833),
    [anon_sym_PERCENT] = ACTIONS(14833),
    [sym_comment] = ACTIONS(87),
  },
  [10503] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(14192),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_when] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [10504] = {
    [sym_string] = STATE(10542),
    [aux_sym_chained_string_repeat1] = STATE(10542),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_when] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [10505] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10952),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(10500),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(10500),
    [sym_assignment] = STATE(10952),
    [sym_operator_assignment] = STATE(10952),
    [sym_conditional] = STATE(10952),
    [sym_range] = STATE(10952),
    [sym_binary] = STATE(10952),
    [sym_unary] = STATE(10952),
    [sym_left_assignment_list] = STATE(10499),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10500),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(10500),
    [sym_false] = STATE(10500),
    [sym_nil] = STATE(10500),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(10501),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(14158),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14160),
    [anon_sym_yield] = ACTIONS(14162),
    [anon_sym_break] = ACTIONS(14164),
    [anon_sym_next] = ACTIONS(14166),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14168),
    [anon_sym_defined_QMARK] = ACTIONS(14170),
    [anon_sym_not] = ACTIONS(14172),
    [anon_sym_BANG] = ACTIONS(14174),
    [anon_sym_TILDE] = ACTIONS(14174),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10506] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(14831),
    [sym__binary_star] = ACTIONS(14833),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(14835),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(14833),
    [anon_sym_AMP] = ACTIONS(14837),
    [anon_sym_LT] = ACTIONS(14839),
    [anon_sym_end] = ACTIONS(3281),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_unless] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_until] = ACTIONS(3281),
    [anon_sym_rescue] = ACTIONS(3281),
    [anon_sym_when] = ACTIONS(3281),
    [anon_sym_else] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(14841),
    [anon_sym_DOT_DOT] = ACTIONS(14843),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14845),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(14847),
    [anon_sym_AMP_AMP] = ACTIONS(14847),
    [anon_sym_LT_LT] = ACTIONS(14849),
    [anon_sym_GT_GT] = ACTIONS(14849),
    [anon_sym_EQ_EQ] = ACTIONS(14851),
    [anon_sym_BANG_EQ] = ACTIONS(14847),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14847),
    [anon_sym_LT_EQ_GT] = ACTIONS(14847),
    [anon_sym_EQ_TILDE] = ACTIONS(14847),
    [anon_sym_BANG_TILDE] = ACTIONS(14847),
    [anon_sym_LT_EQ] = ACTIONS(14839),
    [anon_sym_GT] = ACTIONS(14839),
    [anon_sym_GT_EQ] = ACTIONS(14853),
    [anon_sym_CARET] = ACTIONS(14855),
    [anon_sym_PLUS] = ACTIONS(14831),
    [anon_sym_SLASH] = ACTIONS(14833),
    [anon_sym_PERCENT] = ACTIONS(14833),
    [sym_comment] = ACTIONS(87),
  },
  [10507] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10953),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9593),
    [sym_scope_resolution] = STATE(9589),
    [sym_call] = STATE(9589),
    [sym_method_call] = STATE(9593),
    [sym_assignment] = STATE(10953),
    [sym_operator_assignment] = STATE(10953),
    [sym_conditional] = STATE(10953),
    [sym_range] = STATE(10953),
    [sym_binary] = STATE(10953),
    [sym_unary] = STATE(10953),
    [sym_left_assignment_list] = STATE(9592),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9593),
    [sym__variable] = STATE(9589),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9593),
    [sym_false] = STATE(9593),
    [sym_nil] = STATE(9593),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(10504),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(13286),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13290),
    [anon_sym_yield] = ACTIONS(13292),
    [anon_sym_break] = ACTIONS(13294),
    [anon_sym_next] = ACTIONS(13296),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14176),
    [anon_sym_defined_QMARK] = ACTIONS(13298),
    [anon_sym_not] = ACTIONS(13300),
    [anon_sym_BANG] = ACTIONS(13304),
    [anon_sym_TILDE] = ACTIONS(13304),
    [sym_constant] = ACTIONS(13310),
    [sym_identifier] = ACTIONS(13310),
    [sym_instance_variable] = ACTIONS(13308),
    [sym_class_variable] = ACTIONS(13308),
    [sym_global_variable] = ACTIONS(13308),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(13310),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13310),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10508] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10954),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9593),
    [sym_scope_resolution] = STATE(9589),
    [sym_call] = STATE(9589),
    [sym_method_call] = STATE(9593),
    [sym_assignment] = STATE(10954),
    [sym_operator_assignment] = STATE(10954),
    [sym_conditional] = STATE(10954),
    [sym_range] = STATE(10954),
    [sym_binary] = STATE(10954),
    [sym_unary] = STATE(10954),
    [sym_left_assignment_list] = STATE(9592),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9593),
    [sym__variable] = STATE(9589),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9593),
    [sym_false] = STATE(9593),
    [sym_nil] = STATE(9593),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(10504),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(13286),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13290),
    [anon_sym_yield] = ACTIONS(13292),
    [anon_sym_break] = ACTIONS(13294),
    [anon_sym_next] = ACTIONS(13296),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14176),
    [anon_sym_defined_QMARK] = ACTIONS(13298),
    [anon_sym_not] = ACTIONS(13300),
    [anon_sym_BANG] = ACTIONS(13304),
    [anon_sym_TILDE] = ACTIONS(13304),
    [sym_constant] = ACTIONS(13310),
    [sym_identifier] = ACTIONS(13310),
    [sym_instance_variable] = ACTIONS(13308),
    [sym_class_variable] = ACTIONS(13308),
    [sym_global_variable] = ACTIONS(13308),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(13310),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13310),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10509] = {
    [anon_sym_COLON] = ACTIONS(14863),
    [sym_comment] = ACTIONS(87),
  },
  [10510] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10956),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9593),
    [sym_scope_resolution] = STATE(9589),
    [sym_call] = STATE(9589),
    [sym_method_call] = STATE(9593),
    [sym_assignment] = STATE(10956),
    [sym_operator_assignment] = STATE(10956),
    [sym_conditional] = STATE(10956),
    [sym_range] = STATE(10956),
    [sym_binary] = STATE(10956),
    [sym_unary] = STATE(10956),
    [sym_left_assignment_list] = STATE(9592),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9593),
    [sym__variable] = STATE(9589),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9593),
    [sym_false] = STATE(9593),
    [sym_nil] = STATE(9593),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(10504),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(13286),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13290),
    [anon_sym_yield] = ACTIONS(13292),
    [anon_sym_break] = ACTIONS(13294),
    [anon_sym_next] = ACTIONS(13296),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14176),
    [anon_sym_defined_QMARK] = ACTIONS(13298),
    [anon_sym_not] = ACTIONS(13300),
    [anon_sym_BANG] = ACTIONS(13304),
    [anon_sym_TILDE] = ACTIONS(13304),
    [sym_constant] = ACTIONS(13310),
    [sym_identifier] = ACTIONS(13310),
    [sym_instance_variable] = ACTIONS(13308),
    [sym_class_variable] = ACTIONS(13308),
    [sym_global_variable] = ACTIONS(13308),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(13310),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13310),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10511] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(14865),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(1091),
    [anon_sym_else] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [10512] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(14190),
    [sym__binary_star] = ACTIONS(14192),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(14194),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(14192),
    [anon_sym_AMP] = ACTIONS(14196),
    [anon_sym_LT] = ACTIONS(14198),
    [anon_sym_end] = ACTIONS(1625),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_unless] = ACTIONS(1625),
    [anon_sym_while] = ACTIONS(1625),
    [anon_sym_until] = ACTIONS(1625),
    [anon_sym_rescue] = ACTIONS(1625),
    [anon_sym_when] = ACTIONS(1625),
    [anon_sym_else] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(1625),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(14200),
    [anon_sym_DOT_DOT] = ACTIONS(14202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14204),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(14206),
    [anon_sym_AMP_AMP] = ACTIONS(14206),
    [anon_sym_LT_LT] = ACTIONS(14208),
    [anon_sym_GT_GT] = ACTIONS(14208),
    [anon_sym_EQ_EQ] = ACTIONS(14210),
    [anon_sym_BANG_EQ] = ACTIONS(14206),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14206),
    [anon_sym_LT_EQ_GT] = ACTIONS(14206),
    [anon_sym_EQ_TILDE] = ACTIONS(14206),
    [anon_sym_BANG_TILDE] = ACTIONS(14206),
    [anon_sym_LT_EQ] = ACTIONS(14198),
    [anon_sym_GT] = ACTIONS(14198),
    [anon_sym_GT_EQ] = ACTIONS(14212),
    [anon_sym_CARET] = ACTIONS(14214),
    [anon_sym_PLUS] = ACTIONS(14190),
    [anon_sym_SLASH] = ACTIONS(14192),
    [anon_sym_PERCENT] = ACTIONS(14192),
    [sym_comment] = ACTIONS(87),
  },
  [10513] = {
    [sym_heredoc_body] = STATE(10958),
    [aux_sym_call_repeat1] = STATE(10958),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_when] = ACTIONS(1681),
    [anon_sym_else] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [10514] = {
    [sym_heredoc_body] = STATE(10958),
    [aux_sym_call_repeat1] = STATE(10958),
    [aux_sym_argument_list_repeat1] = STATE(10960),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(14867),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_when] = ACTIONS(1681),
    [anon_sym_else] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [10515] = {
    [sym_string] = STATE(10542),
    [aux_sym_chained_string_repeat1] = STATE(10542),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(14869),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_when] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [10516] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(14190),
    [sym__binary_star] = ACTIONS(14192),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(14194),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(14192),
    [anon_sym_AMP] = ACTIONS(14196),
    [anon_sym_LT] = ACTIONS(14198),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_when] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(14200),
    [anon_sym_DOT_DOT] = ACTIONS(14202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14204),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(14206),
    [anon_sym_AMP_AMP] = ACTIONS(14206),
    [anon_sym_LT_LT] = ACTIONS(14208),
    [anon_sym_GT_GT] = ACTIONS(14208),
    [anon_sym_EQ_EQ] = ACTIONS(14210),
    [anon_sym_BANG_EQ] = ACTIONS(14206),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14206),
    [anon_sym_LT_EQ_GT] = ACTIONS(14206),
    [anon_sym_EQ_TILDE] = ACTIONS(14206),
    [anon_sym_BANG_TILDE] = ACTIONS(14206),
    [anon_sym_LT_EQ] = ACTIONS(14198),
    [anon_sym_GT] = ACTIONS(14198),
    [anon_sym_GT_EQ] = ACTIONS(14212),
    [anon_sym_CARET] = ACTIONS(14214),
    [anon_sym_PLUS] = ACTIONS(14190),
    [anon_sym_SLASH] = ACTIONS(14192),
    [anon_sym_PERCENT] = ACTIONS(14192),
    [sym_comment] = ACTIONS(87),
  },
  [10517] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10961),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(10500),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(10500),
    [sym_assignment] = STATE(10961),
    [sym_operator_assignment] = STATE(10961),
    [sym_conditional] = STATE(10961),
    [sym_range] = STATE(10961),
    [sym_binary] = STATE(10961),
    [sym_unary] = STATE(10961),
    [sym_left_assignment_list] = STATE(10499),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10500),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(10500),
    [sym_false] = STATE(10500),
    [sym_nil] = STATE(10500),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(10501),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(14158),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14160),
    [anon_sym_yield] = ACTIONS(14162),
    [anon_sym_break] = ACTIONS(14164),
    [anon_sym_next] = ACTIONS(14166),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14168),
    [anon_sym_defined_QMARK] = ACTIONS(14170),
    [anon_sym_not] = ACTIONS(14172),
    [anon_sym_BANG] = ACTIONS(14174),
    [anon_sym_TILDE] = ACTIONS(14174),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10518] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10962),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9593),
    [sym_scope_resolution] = STATE(9589),
    [sym_call] = STATE(9589),
    [sym_method_call] = STATE(9593),
    [sym_assignment] = STATE(10962),
    [sym_operator_assignment] = STATE(10962),
    [sym_conditional] = STATE(10962),
    [sym_range] = STATE(10962),
    [sym_binary] = STATE(10962),
    [sym_unary] = STATE(10962),
    [sym_left_assignment_list] = STATE(9592),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9593),
    [sym__variable] = STATE(9589),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9593),
    [sym_false] = STATE(9593),
    [sym_nil] = STATE(9593),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(10504),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(13286),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13290),
    [anon_sym_yield] = ACTIONS(13292),
    [anon_sym_break] = ACTIONS(13294),
    [anon_sym_next] = ACTIONS(13296),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14176),
    [anon_sym_defined_QMARK] = ACTIONS(13298),
    [anon_sym_not] = ACTIONS(13300),
    [anon_sym_BANG] = ACTIONS(13304),
    [anon_sym_TILDE] = ACTIONS(13304),
    [sym_constant] = ACTIONS(13310),
    [sym_identifier] = ACTIONS(13310),
    [sym_instance_variable] = ACTIONS(13308),
    [sym_class_variable] = ACTIONS(13308),
    [sym_global_variable] = ACTIONS(13308),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(13310),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13310),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10519] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10963),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9593),
    [sym_scope_resolution] = STATE(9589),
    [sym_call] = STATE(9589),
    [sym_method_call] = STATE(9593),
    [sym_assignment] = STATE(10963),
    [sym_operator_assignment] = STATE(10963),
    [sym_conditional] = STATE(10963),
    [sym_range] = STATE(10963),
    [sym_binary] = STATE(10963),
    [sym_unary] = STATE(10963),
    [sym_left_assignment_list] = STATE(9592),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9593),
    [sym__variable] = STATE(9589),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9593),
    [sym_false] = STATE(9593),
    [sym_nil] = STATE(9593),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(10504),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(13286),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13290),
    [anon_sym_yield] = ACTIONS(13292),
    [anon_sym_break] = ACTIONS(13294),
    [anon_sym_next] = ACTIONS(13296),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14176),
    [anon_sym_defined_QMARK] = ACTIONS(13298),
    [anon_sym_not] = ACTIONS(13300),
    [anon_sym_BANG] = ACTIONS(13304),
    [anon_sym_TILDE] = ACTIONS(13304),
    [sym_constant] = ACTIONS(13310),
    [sym_identifier] = ACTIONS(13310),
    [sym_instance_variable] = ACTIONS(13308),
    [sym_class_variable] = ACTIONS(13308),
    [sym_global_variable] = ACTIONS(13308),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(13310),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13310),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10520] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10964),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9593),
    [sym_scope_resolution] = STATE(9589),
    [sym_call] = STATE(9589),
    [sym_method_call] = STATE(9593),
    [sym_assignment] = STATE(10964),
    [sym_operator_assignment] = STATE(10964),
    [sym_conditional] = STATE(10964),
    [sym_range] = STATE(10964),
    [sym_binary] = STATE(10964),
    [sym_unary] = STATE(10964),
    [sym_left_assignment_list] = STATE(9592),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9593),
    [sym__variable] = STATE(9589),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9593),
    [sym_false] = STATE(9593),
    [sym_nil] = STATE(9593),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(10504),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(13286),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13290),
    [anon_sym_yield] = ACTIONS(13292),
    [anon_sym_break] = ACTIONS(13294),
    [anon_sym_next] = ACTIONS(13296),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14176),
    [anon_sym_defined_QMARK] = ACTIONS(13298),
    [anon_sym_not] = ACTIONS(13300),
    [anon_sym_BANG] = ACTIONS(13304),
    [anon_sym_TILDE] = ACTIONS(13304),
    [sym_constant] = ACTIONS(13310),
    [sym_identifier] = ACTIONS(13310),
    [sym_instance_variable] = ACTIONS(13308),
    [sym_class_variable] = ACTIONS(13308),
    [sym_global_variable] = ACTIONS(13308),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(13310),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13310),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10521] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10965),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9593),
    [sym_scope_resolution] = STATE(9589),
    [sym_call] = STATE(9589),
    [sym_method_call] = STATE(9593),
    [sym_assignment] = STATE(10965),
    [sym_operator_assignment] = STATE(10965),
    [sym_conditional] = STATE(10965),
    [sym_range] = STATE(10965),
    [sym_binary] = STATE(10965),
    [sym_unary] = STATE(10965),
    [sym_left_assignment_list] = STATE(9592),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9593),
    [sym__variable] = STATE(9589),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9593),
    [sym_false] = STATE(9593),
    [sym_nil] = STATE(9593),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(10504),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(13286),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13290),
    [anon_sym_yield] = ACTIONS(13292),
    [anon_sym_break] = ACTIONS(13294),
    [anon_sym_next] = ACTIONS(13296),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14176),
    [anon_sym_defined_QMARK] = ACTIONS(13298),
    [anon_sym_not] = ACTIONS(13300),
    [anon_sym_BANG] = ACTIONS(13304),
    [anon_sym_TILDE] = ACTIONS(13304),
    [sym_constant] = ACTIONS(13310),
    [sym_identifier] = ACTIONS(13310),
    [sym_instance_variable] = ACTIONS(13308),
    [sym_class_variable] = ACTIONS(13308),
    [sym_global_variable] = ACTIONS(13308),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(13310),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13310),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10522] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10966),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9593),
    [sym_scope_resolution] = STATE(9589),
    [sym_call] = STATE(9589),
    [sym_method_call] = STATE(9593),
    [sym_assignment] = STATE(10966),
    [sym_operator_assignment] = STATE(10966),
    [sym_conditional] = STATE(10966),
    [sym_range] = STATE(10966),
    [sym_binary] = STATE(10966),
    [sym_unary] = STATE(10966),
    [sym_left_assignment_list] = STATE(9592),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9593),
    [sym__variable] = STATE(9589),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9593),
    [sym_false] = STATE(9593),
    [sym_nil] = STATE(9593),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(10504),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(13286),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13290),
    [anon_sym_yield] = ACTIONS(13292),
    [anon_sym_break] = ACTIONS(13294),
    [anon_sym_next] = ACTIONS(13296),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14176),
    [anon_sym_defined_QMARK] = ACTIONS(13298),
    [anon_sym_not] = ACTIONS(13300),
    [anon_sym_BANG] = ACTIONS(13304),
    [anon_sym_TILDE] = ACTIONS(13304),
    [sym_constant] = ACTIONS(13310),
    [sym_identifier] = ACTIONS(13310),
    [sym_instance_variable] = ACTIONS(13308),
    [sym_class_variable] = ACTIONS(13308),
    [sym_global_variable] = ACTIONS(13308),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(13310),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13310),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10523] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(10967),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(10967),
    [sym_operator_assignment] = STATE(10967),
    [sym_conditional] = STATE(10967),
    [sym_range] = STATE(10967),
    [sym_binary] = STATE(10967),
    [sym_unary] = STATE(10967),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [10524] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10968),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9593),
    [sym_scope_resolution] = STATE(9589),
    [sym_call] = STATE(9589),
    [sym_method_call] = STATE(9593),
    [sym_assignment] = STATE(10968),
    [sym_operator_assignment] = STATE(10968),
    [sym_conditional] = STATE(10968),
    [sym_range] = STATE(10968),
    [sym_binary] = STATE(10968),
    [sym_unary] = STATE(10968),
    [sym_left_assignment_list] = STATE(9592),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9593),
    [sym__variable] = STATE(9589),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9593),
    [sym_false] = STATE(9593),
    [sym_nil] = STATE(9593),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(10504),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(13286),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13290),
    [anon_sym_yield] = ACTIONS(13292),
    [anon_sym_break] = ACTIONS(13294),
    [anon_sym_next] = ACTIONS(13296),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14176),
    [anon_sym_defined_QMARK] = ACTIONS(13298),
    [anon_sym_not] = ACTIONS(13300),
    [anon_sym_BANG] = ACTIONS(13304),
    [anon_sym_TILDE] = ACTIONS(13304),
    [sym_constant] = ACTIONS(13310),
    [sym_identifier] = ACTIONS(13310),
    [sym_instance_variable] = ACTIONS(13308),
    [sym_class_variable] = ACTIONS(13308),
    [sym_global_variable] = ACTIONS(13308),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(13310),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13310),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10525] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10969),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9593),
    [sym_scope_resolution] = STATE(9589),
    [sym_call] = STATE(9589),
    [sym_method_call] = STATE(9593),
    [sym_assignment] = STATE(10969),
    [sym_operator_assignment] = STATE(10969),
    [sym_conditional] = STATE(10969),
    [sym_range] = STATE(10969),
    [sym_binary] = STATE(10969),
    [sym_unary] = STATE(10969),
    [sym_left_assignment_list] = STATE(9592),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9593),
    [sym__variable] = STATE(9589),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9593),
    [sym_false] = STATE(9593),
    [sym_nil] = STATE(9593),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(10504),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(13286),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13290),
    [anon_sym_yield] = ACTIONS(13292),
    [anon_sym_break] = ACTIONS(13294),
    [anon_sym_next] = ACTIONS(13296),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14176),
    [anon_sym_defined_QMARK] = ACTIONS(13298),
    [anon_sym_not] = ACTIONS(13300),
    [anon_sym_BANG] = ACTIONS(13304),
    [anon_sym_TILDE] = ACTIONS(13304),
    [sym_constant] = ACTIONS(13310),
    [sym_identifier] = ACTIONS(13310),
    [sym_instance_variable] = ACTIONS(13308),
    [sym_class_variable] = ACTIONS(13308),
    [sym_global_variable] = ACTIONS(13308),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(13310),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13310),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10526] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10970),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9593),
    [sym_scope_resolution] = STATE(9589),
    [sym_call] = STATE(9589),
    [sym_method_call] = STATE(9593),
    [sym_assignment] = STATE(10970),
    [sym_operator_assignment] = STATE(10970),
    [sym_conditional] = STATE(10970),
    [sym_range] = STATE(10970),
    [sym_binary] = STATE(10970),
    [sym_unary] = STATE(10970),
    [sym_left_assignment_list] = STATE(9592),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9593),
    [sym__variable] = STATE(9589),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9593),
    [sym_false] = STATE(9593),
    [sym_nil] = STATE(9593),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(10504),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(13286),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13290),
    [anon_sym_yield] = ACTIONS(13292),
    [anon_sym_break] = ACTIONS(13294),
    [anon_sym_next] = ACTIONS(13296),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14176),
    [anon_sym_defined_QMARK] = ACTIONS(13298),
    [anon_sym_not] = ACTIONS(13300),
    [anon_sym_BANG] = ACTIONS(13304),
    [anon_sym_TILDE] = ACTIONS(13304),
    [sym_constant] = ACTIONS(13310),
    [sym_identifier] = ACTIONS(13310),
    [sym_instance_variable] = ACTIONS(13308),
    [sym_class_variable] = ACTIONS(13308),
    [sym_global_variable] = ACTIONS(13308),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(13310),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13310),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10527] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10971),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9593),
    [sym_scope_resolution] = STATE(9589),
    [sym_call] = STATE(9589),
    [sym_method_call] = STATE(9593),
    [sym_assignment] = STATE(10971),
    [sym_operator_assignment] = STATE(10971),
    [sym_conditional] = STATE(10971),
    [sym_range] = STATE(10971),
    [sym_binary] = STATE(10971),
    [sym_unary] = STATE(10971),
    [sym_left_assignment_list] = STATE(9592),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9593),
    [sym__variable] = STATE(9589),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9593),
    [sym_false] = STATE(9593),
    [sym_nil] = STATE(9593),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(10504),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(13286),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13290),
    [anon_sym_yield] = ACTIONS(13292),
    [anon_sym_break] = ACTIONS(13294),
    [anon_sym_next] = ACTIONS(13296),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14176),
    [anon_sym_defined_QMARK] = ACTIONS(13298),
    [anon_sym_not] = ACTIONS(13300),
    [anon_sym_BANG] = ACTIONS(13304),
    [anon_sym_TILDE] = ACTIONS(13304),
    [sym_constant] = ACTIONS(13310),
    [sym_identifier] = ACTIONS(13310),
    [sym_instance_variable] = ACTIONS(13308),
    [sym_class_variable] = ACTIONS(13308),
    [sym_global_variable] = ACTIONS(13308),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(13310),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13310),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10528] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(10972),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(9629),
    [sym_scope_resolution] = STATE(9625),
    [sym_call] = STATE(9625),
    [sym_method_call] = STATE(9629),
    [sym_assignment] = STATE(10972),
    [sym_operator_assignment] = STATE(10972),
    [sym_conditional] = STATE(10972),
    [sym_range] = STATE(10972),
    [sym_binary] = STATE(10972),
    [sym_unary] = STATE(10972),
    [sym_left_assignment_list] = STATE(9628),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9629),
    [sym__variable] = STATE(9625),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(9629),
    [sym_false] = STATE(9629),
    [sym_nil] = STATE(9629),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(10573),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(13356),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(13360),
    [anon_sym_yield] = ACTIONS(13362),
    [anon_sym_break] = ACTIONS(13364),
    [anon_sym_next] = ACTIONS(13366),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(14256),
    [anon_sym_defined_QMARK] = ACTIONS(13368),
    [anon_sym_not] = ACTIONS(13370),
    [anon_sym_BANG] = ACTIONS(13374),
    [anon_sym_TILDE] = ACTIONS(13374),
    [sym_constant] = ACTIONS(13380),
    [sym_identifier] = ACTIONS(13380),
    [sym_instance_variable] = ACTIONS(13378),
    [sym_class_variable] = ACTIONS(13378),
    [sym_global_variable] = ACTIONS(13378),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(13380),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13380),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [10529] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(10973),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(9629),
    [sym_scope_resolution] = STATE(9625),
    [sym_call] = STATE(9625),
    [sym_method_call] = STATE(9629),
    [sym_assignment] = STATE(10973),
    [sym_operator_assignment] = STATE(10973),
    [sym_conditional] = STATE(10973),
    [sym_range] = STATE(10973),
    [sym_binary] = STATE(10973),
    [sym_unary] = STATE(10973),
    [sym_left_assignment_list] = STATE(9628),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9629),
    [sym__variable] = STATE(9625),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(9629),
    [sym_false] = STATE(9629),
    [sym_nil] = STATE(9629),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(10573),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(13356),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(13360),
    [anon_sym_yield] = ACTIONS(13362),
    [anon_sym_break] = ACTIONS(13364),
    [anon_sym_next] = ACTIONS(13366),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(14256),
    [anon_sym_defined_QMARK] = ACTIONS(13368),
    [anon_sym_not] = ACTIONS(13370),
    [anon_sym_BANG] = ACTIONS(13374),
    [anon_sym_TILDE] = ACTIONS(13374),
    [sym_constant] = ACTIONS(13380),
    [sym_identifier] = ACTIONS(13380),
    [sym_instance_variable] = ACTIONS(13378),
    [sym_class_variable] = ACTIONS(13378),
    [sym_global_variable] = ACTIONS(13378),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(13380),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13380),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [10530] = {
    [anon_sym_COLON] = ACTIONS(14871),
    [sym_comment] = ACTIONS(87),
  },
  [10531] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(10975),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(9629),
    [sym_scope_resolution] = STATE(9625),
    [sym_call] = STATE(9625),
    [sym_method_call] = STATE(9629),
    [sym_assignment] = STATE(10975),
    [sym_operator_assignment] = STATE(10975),
    [sym_conditional] = STATE(10975),
    [sym_range] = STATE(10975),
    [sym_binary] = STATE(10975),
    [sym_unary] = STATE(10975),
    [sym_left_assignment_list] = STATE(9628),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9629),
    [sym__variable] = STATE(9625),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(9629),
    [sym_false] = STATE(9629),
    [sym_nil] = STATE(9629),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(10573),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(13356),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(13360),
    [anon_sym_yield] = ACTIONS(13362),
    [anon_sym_break] = ACTIONS(13364),
    [anon_sym_next] = ACTIONS(13366),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(14256),
    [anon_sym_defined_QMARK] = ACTIONS(13368),
    [anon_sym_not] = ACTIONS(13370),
    [anon_sym_BANG] = ACTIONS(13374),
    [anon_sym_TILDE] = ACTIONS(13374),
    [sym_constant] = ACTIONS(13380),
    [sym_identifier] = ACTIONS(13380),
    [sym_instance_variable] = ACTIONS(13378),
    [sym_class_variable] = ACTIONS(13378),
    [sym_global_variable] = ACTIONS(13378),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(13380),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13380),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [10532] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(14873),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(1091),
    [anon_sym_else] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [10533] = {
    [sym__line_break] = ACTIONS(1625),
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(14262),
    [sym__binary_star] = ACTIONS(14264),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(14266),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(14268),
    [anon_sym_AMP] = ACTIONS(14270),
    [anon_sym_EQ] = ACTIONS(1631),
    [anon_sym_LT] = ACTIONS(14272),
    [anon_sym_end] = ACTIONS(1625),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_unless] = ACTIONS(1625),
    [anon_sym_while] = ACTIONS(1625),
    [anon_sym_until] = ACTIONS(1625),
    [anon_sym_rescue] = ACTIONS(1625),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_when] = ACTIONS(1625),
    [anon_sym_else] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(1625),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_PLUS_EQ] = ACTIONS(1625),
    [anon_sym_DASH_EQ] = ACTIONS(1625),
    [anon_sym_STAR_EQ] = ACTIONS(1625),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1625),
    [anon_sym_SLASH_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1625),
    [anon_sym_AMP_EQ] = ACTIONS(1625),
    [anon_sym_PERCENT_EQ] = ACTIONS(1625),
    [anon_sym_GT_GT_EQ] = ACTIONS(1625),
    [anon_sym_LT_LT_EQ] = ACTIONS(1625),
    [anon_sym_CARET_EQ] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(14274),
    [anon_sym_DOT_DOT] = ACTIONS(14276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14278),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(14280),
    [anon_sym_AMP_AMP] = ACTIONS(14280),
    [anon_sym_LT_LT] = ACTIONS(14282),
    [anon_sym_GT_GT] = ACTIONS(14282),
    [anon_sym_EQ_EQ] = ACTIONS(14280),
    [anon_sym_BANG_EQ] = ACTIONS(14284),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14284),
    [anon_sym_LT_EQ_GT] = ACTIONS(14284),
    [anon_sym_EQ_TILDE] = ACTIONS(14284),
    [anon_sym_BANG_TILDE] = ACTIONS(14284),
    [anon_sym_LT_EQ] = ACTIONS(14272),
    [anon_sym_GT] = ACTIONS(14272),
    [anon_sym_GT_EQ] = ACTIONS(14286),
    [anon_sym_CARET] = ACTIONS(14266),
    [anon_sym_PLUS] = ACTIONS(14288),
    [anon_sym_SLASH] = ACTIONS(14268),
    [anon_sym_PERCENT] = ACTIONS(14268),
    [sym_comment] = ACTIONS(87),
  },
  [10534] = {
    [sym_heredoc_body] = STATE(10977),
    [aux_sym_call_repeat1] = STATE(10977),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_when] = ACTIONS(1681),
    [anon_sym_else] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [10535] = {
    [sym_heredoc_body] = STATE(10977),
    [aux_sym_call_repeat1] = STATE(10977),
    [aux_sym_argument_list_repeat1] = STATE(10979),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(14875),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_when] = ACTIONS(1681),
    [anon_sym_else] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [10536] = {
    [sym_string] = STATE(10593),
    [aux_sym_chained_string_repeat1] = STATE(10593),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(747),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(14877),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_when] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [10537] = {
    [sym_heredoc_body] = STATE(10980),
    [aux_sym_call_repeat1] = STATE(10980),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_when] = ACTIONS(4383),
    [anon_sym_else] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [10538] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9588),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9593),
    [sym_scope_resolution] = STATE(9589),
    [sym_call] = STATE(9589),
    [sym_method_call] = STATE(9593),
    [sym__argument] = STATE(2565),
    [sym_splat_argument] = STATE(2565),
    [sym_hash_splat_argument] = STATE(2565),
    [sym_block_argument] = STATE(2565),
    [sym_assignment] = STATE(9588),
    [sym_operator_assignment] = STATE(9588),
    [sym_conditional] = STATE(9588),
    [sym_range] = STATE(9588),
    [sym_binary] = STATE(9588),
    [sym_unary] = STATE(9588),
    [sym_left_assignment_list] = STATE(9592),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9593),
    [sym__variable] = STATE(9589),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9593),
    [sym_false] = STATE(9593),
    [sym_nil] = STATE(9593),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(9594),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(10981),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2565),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(13282),
    [sym__splat_star] = ACTIONS(13284),
    [sym__unary_minus] = ACTIONS(13286),
    [sym__identifier_hash_key] = ACTIONS(13288),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(14879),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13290),
    [anon_sym_yield] = ACTIONS(13292),
    [anon_sym_break] = ACTIONS(13294),
    [anon_sym_next] = ACTIONS(13296),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14176),
    [anon_sym_defined_QMARK] = ACTIONS(13298),
    [anon_sym_not] = ACTIONS(13300),
    [anon_sym_BANG] = ACTIONS(13304),
    [anon_sym_TILDE] = ACTIONS(13304),
    [sym_constant] = ACTIONS(13306),
    [sym_identifier] = ACTIONS(13306),
    [sym_instance_variable] = ACTIONS(13308),
    [sym_class_variable] = ACTIONS(13308),
    [sym_global_variable] = ACTIONS(13308),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(13310),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13310),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10539] = {
    [sym_heredoc_body] = STATE(10982),
    [aux_sym_call_repeat1] = STATE(10982),
    [aux_sym_argument_list_repeat1] = STATE(10983),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(14224),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_when] = ACTIONS(4383),
    [anon_sym_else] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [10540] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10984),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9593),
    [sym_scope_resolution] = STATE(9589),
    [sym_call] = STATE(9589),
    [sym_method_call] = STATE(9593),
    [sym_splat_argument] = STATE(10985),
    [sym_assignment] = STATE(10984),
    [sym_operator_assignment] = STATE(10984),
    [sym_conditional] = STATE(10984),
    [sym_range] = STATE(10984),
    [sym_binary] = STATE(10984),
    [sym_unary] = STATE(10984),
    [sym_right_assignment_list] = STATE(2570),
    [sym__arg_or_splat_arg] = STATE(10985),
    [sym_left_assignment_list] = STATE(9592),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9593),
    [sym__variable] = STATE(9589),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9593),
    [sym_false] = STATE(9593),
    [sym_nil] = STATE(9593),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(10504),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__splat_star] = ACTIONS(14182),
    [sym__unary_minus] = ACTIONS(13286),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13290),
    [anon_sym_yield] = ACTIONS(13292),
    [anon_sym_break] = ACTIONS(13294),
    [anon_sym_next] = ACTIONS(13296),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14176),
    [anon_sym_defined_QMARK] = ACTIONS(13298),
    [anon_sym_not] = ACTIONS(13300),
    [anon_sym_BANG] = ACTIONS(13304),
    [anon_sym_TILDE] = ACTIONS(13304),
    [sym_constant] = ACTIONS(13310),
    [sym_identifier] = ACTIONS(13310),
    [sym_instance_variable] = ACTIONS(13308),
    [sym_class_variable] = ACTIONS(13308),
    [sym_global_variable] = ACTIONS(13308),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(13310),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13310),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10541] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10986),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9593),
    [sym_scope_resolution] = STATE(9589),
    [sym_call] = STATE(9589),
    [sym_method_call] = STATE(9593),
    [sym_assignment] = STATE(10986),
    [sym_operator_assignment] = STATE(10986),
    [sym_conditional] = STATE(10986),
    [sym_range] = STATE(10986),
    [sym_binary] = STATE(10986),
    [sym_unary] = STATE(10986),
    [sym_left_assignment_list] = STATE(9592),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9593),
    [sym__variable] = STATE(9589),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9593),
    [sym_false] = STATE(9593),
    [sym_nil] = STATE(9593),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(10504),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(13286),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13290),
    [anon_sym_yield] = ACTIONS(13292),
    [anon_sym_break] = ACTIONS(13294),
    [anon_sym_next] = ACTIONS(13296),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14176),
    [anon_sym_defined_QMARK] = ACTIONS(13298),
    [anon_sym_not] = ACTIONS(13300),
    [anon_sym_BANG] = ACTIONS(13304),
    [anon_sym_TILDE] = ACTIONS(13304),
    [sym_constant] = ACTIONS(13310),
    [sym_identifier] = ACTIONS(13310),
    [sym_instance_variable] = ACTIONS(13308),
    [sym_class_variable] = ACTIONS(13308),
    [sym_global_variable] = ACTIONS(13308),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(13310),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13310),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10542] = {
    [sym_string] = STATE(10987),
    [aux_sym_chained_string_repeat1] = STATE(10987),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_end] = ACTIONS(2753),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_when] = ACTIONS(2753),
    [anon_sym_else] = ACTIONS(2753),
    [anon_sym_EQ_GT] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [10543] = {
    [aux_sym_undef_repeat1] = STATE(10988),
    [sym__line_break] = ACTIONS(5497),
    [sym__heredoc_body_start] = ACTIONS(5497),
    [anon_sym_COMMA] = ACTIONS(2253),
    [anon_sym_SEMI] = ACTIONS(5497),
    [anon_sym_end] = ACTIONS(5497),
    [anon_sym_if] = ACTIONS(5497),
    [anon_sym_unless] = ACTIONS(5497),
    [anon_sym_while] = ACTIONS(5497),
    [anon_sym_until] = ACTIONS(5497),
    [anon_sym_rescue] = ACTIONS(5497),
    [anon_sym_when] = ACTIONS(5497),
    [anon_sym_else] = ACTIONS(5497),
    [sym_comment] = ACTIONS(87),
  },
  [10544] = {
    [sym__line_break] = ACTIONS(5815),
    [sym__heredoc_body_start] = ACTIONS(5815),
    [sym__binary_minus] = ACTIONS(13324),
    [sym__binary_star] = ACTIONS(13326),
    [anon_sym_PIPE] = ACTIONS(13328),
    [anon_sym_SEMI] = ACTIONS(5815),
    [anon_sym_STAR_STAR] = ACTIONS(13326),
    [anon_sym_AMP] = ACTIONS(13330),
    [anon_sym_LT] = ACTIONS(13332),
    [anon_sym_end] = ACTIONS(5815),
    [anon_sym_if] = ACTIONS(5815),
    [anon_sym_unless] = ACTIONS(5815),
    [anon_sym_while] = ACTIONS(5815),
    [anon_sym_until] = ACTIONS(5815),
    [anon_sym_rescue] = ACTIONS(5815),
    [anon_sym_when] = ACTIONS(5815),
    [anon_sym_else] = ACTIONS(5815),
    [anon_sym_QMARK] = ACTIONS(13334),
    [anon_sym_DOT_DOT] = ACTIONS(13336),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13338),
    [anon_sym_and] = ACTIONS(13340),
    [anon_sym_or] = ACTIONS(13340),
    [anon_sym_PIPE_PIPE] = ACTIONS(13342),
    [anon_sym_AMP_AMP] = ACTIONS(13342),
    [anon_sym_LT_LT] = ACTIONS(13344),
    [anon_sym_GT_GT] = ACTIONS(13344),
    [anon_sym_EQ_EQ] = ACTIONS(13346),
    [anon_sym_BANG_EQ] = ACTIONS(13342),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13342),
    [anon_sym_LT_EQ_GT] = ACTIONS(13342),
    [anon_sym_EQ_TILDE] = ACTIONS(13342),
    [anon_sym_BANG_TILDE] = ACTIONS(13342),
    [anon_sym_LT_EQ] = ACTIONS(13332),
    [anon_sym_GT] = ACTIONS(13332),
    [anon_sym_GT_EQ] = ACTIONS(13348),
    [anon_sym_CARET] = ACTIONS(13350),
    [anon_sym_PLUS] = ACTIONS(13324),
    [anon_sym_SLASH] = ACTIONS(13326),
    [anon_sym_PERCENT] = ACTIONS(13326),
    [sym_comment] = ACTIONS(87),
  },
  [10545] = {
    [sym__line_break] = ACTIONS(5817),
    [sym__heredoc_body_start] = ACTIONS(5817),
    [sym__binary_minus] = ACTIONS(13324),
    [sym__binary_star] = ACTIONS(13326),
    [anon_sym_PIPE] = ACTIONS(13328),
    [anon_sym_SEMI] = ACTIONS(5817),
    [anon_sym_STAR_STAR] = ACTIONS(13326),
    [anon_sym_AMP] = ACTIONS(13330),
    [anon_sym_LT] = ACTIONS(13332),
    [anon_sym_end] = ACTIONS(5817),
    [anon_sym_if] = ACTIONS(5817),
    [anon_sym_unless] = ACTIONS(5817),
    [anon_sym_while] = ACTIONS(5817),
    [anon_sym_until] = ACTIONS(5817),
    [anon_sym_rescue] = ACTIONS(5817),
    [anon_sym_when] = ACTIONS(5817),
    [anon_sym_else] = ACTIONS(5817),
    [anon_sym_QMARK] = ACTIONS(13334),
    [anon_sym_DOT_DOT] = ACTIONS(13336),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13338),
    [anon_sym_and] = ACTIONS(13340),
    [anon_sym_or] = ACTIONS(13340),
    [anon_sym_PIPE_PIPE] = ACTIONS(13342),
    [anon_sym_AMP_AMP] = ACTIONS(13342),
    [anon_sym_LT_LT] = ACTIONS(13344),
    [anon_sym_GT_GT] = ACTIONS(13344),
    [anon_sym_EQ_EQ] = ACTIONS(13346),
    [anon_sym_BANG_EQ] = ACTIONS(13342),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13342),
    [anon_sym_LT_EQ_GT] = ACTIONS(13342),
    [anon_sym_EQ_TILDE] = ACTIONS(13342),
    [anon_sym_BANG_TILDE] = ACTIONS(13342),
    [anon_sym_LT_EQ] = ACTIONS(13332),
    [anon_sym_GT] = ACTIONS(13332),
    [anon_sym_GT_EQ] = ACTIONS(13348),
    [anon_sym_CARET] = ACTIONS(13350),
    [anon_sym_PLUS] = ACTIONS(13324),
    [anon_sym_SLASH] = ACTIONS(13326),
    [anon_sym_PERCENT] = ACTIONS(13326),
    [sym_comment] = ACTIONS(87),
  },
  [10546] = {
    [sym__line_break] = ACTIONS(5819),
    [sym__heredoc_body_start] = ACTIONS(5819),
    [sym__binary_minus] = ACTIONS(13324),
    [sym__binary_star] = ACTIONS(13326),
    [anon_sym_PIPE] = ACTIONS(13328),
    [anon_sym_SEMI] = ACTIONS(5819),
    [anon_sym_STAR_STAR] = ACTIONS(13326),
    [anon_sym_AMP] = ACTIONS(13330),
    [anon_sym_LT] = ACTIONS(13332),
    [anon_sym_end] = ACTIONS(5819),
    [anon_sym_if] = ACTIONS(5819),
    [anon_sym_unless] = ACTIONS(5819),
    [anon_sym_while] = ACTIONS(5819),
    [anon_sym_until] = ACTIONS(5819),
    [anon_sym_rescue] = ACTIONS(5819),
    [anon_sym_when] = ACTIONS(5819),
    [anon_sym_else] = ACTIONS(5819),
    [anon_sym_QMARK] = ACTIONS(13334),
    [anon_sym_DOT_DOT] = ACTIONS(13336),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13338),
    [anon_sym_and] = ACTIONS(13340),
    [anon_sym_or] = ACTIONS(13340),
    [anon_sym_PIPE_PIPE] = ACTIONS(13342),
    [anon_sym_AMP_AMP] = ACTIONS(13342),
    [anon_sym_LT_LT] = ACTIONS(13344),
    [anon_sym_GT_GT] = ACTIONS(13344),
    [anon_sym_EQ_EQ] = ACTIONS(13346),
    [anon_sym_BANG_EQ] = ACTIONS(13342),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13342),
    [anon_sym_LT_EQ_GT] = ACTIONS(13342),
    [anon_sym_EQ_TILDE] = ACTIONS(13342),
    [anon_sym_BANG_TILDE] = ACTIONS(13342),
    [anon_sym_LT_EQ] = ACTIONS(13332),
    [anon_sym_GT] = ACTIONS(13332),
    [anon_sym_GT_EQ] = ACTIONS(13348),
    [anon_sym_CARET] = ACTIONS(13350),
    [anon_sym_PLUS] = ACTIONS(13324),
    [anon_sym_SLASH] = ACTIONS(13326),
    [anon_sym_PERCENT] = ACTIONS(13326),
    [sym_comment] = ACTIONS(87),
  },
  [10547] = {
    [sym__line_break] = ACTIONS(5821),
    [sym__heredoc_body_start] = ACTIONS(5821),
    [sym__binary_minus] = ACTIONS(13324),
    [sym__binary_star] = ACTIONS(13326),
    [anon_sym_PIPE] = ACTIONS(13328),
    [anon_sym_SEMI] = ACTIONS(5821),
    [anon_sym_STAR_STAR] = ACTIONS(13326),
    [anon_sym_AMP] = ACTIONS(13330),
    [anon_sym_LT] = ACTIONS(13332),
    [anon_sym_end] = ACTIONS(5821),
    [anon_sym_if] = ACTIONS(5821),
    [anon_sym_unless] = ACTIONS(5821),
    [anon_sym_while] = ACTIONS(5821),
    [anon_sym_until] = ACTIONS(5821),
    [anon_sym_rescue] = ACTIONS(5821),
    [anon_sym_when] = ACTIONS(5821),
    [anon_sym_else] = ACTIONS(5821),
    [anon_sym_QMARK] = ACTIONS(13334),
    [anon_sym_DOT_DOT] = ACTIONS(13336),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13338),
    [anon_sym_and] = ACTIONS(13340),
    [anon_sym_or] = ACTIONS(13340),
    [anon_sym_PIPE_PIPE] = ACTIONS(13342),
    [anon_sym_AMP_AMP] = ACTIONS(13342),
    [anon_sym_LT_LT] = ACTIONS(13344),
    [anon_sym_GT_GT] = ACTIONS(13344),
    [anon_sym_EQ_EQ] = ACTIONS(13346),
    [anon_sym_BANG_EQ] = ACTIONS(13342),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13342),
    [anon_sym_LT_EQ_GT] = ACTIONS(13342),
    [anon_sym_EQ_TILDE] = ACTIONS(13342),
    [anon_sym_BANG_TILDE] = ACTIONS(13342),
    [anon_sym_LT_EQ] = ACTIONS(13332),
    [anon_sym_GT] = ACTIONS(13332),
    [anon_sym_GT_EQ] = ACTIONS(13348),
    [anon_sym_CARET] = ACTIONS(13350),
    [anon_sym_PLUS] = ACTIONS(13324),
    [anon_sym_SLASH] = ACTIONS(13326),
    [anon_sym_PERCENT] = ACTIONS(13326),
    [sym_comment] = ACTIONS(87),
  },
  [10548] = {
    [sym__line_break] = ACTIONS(5823),
    [sym__heredoc_body_start] = ACTIONS(5823),
    [sym__binary_minus] = ACTIONS(13324),
    [sym__binary_star] = ACTIONS(13326),
    [anon_sym_PIPE] = ACTIONS(13328),
    [anon_sym_SEMI] = ACTIONS(5823),
    [anon_sym_STAR_STAR] = ACTIONS(13326),
    [anon_sym_AMP] = ACTIONS(13330),
    [anon_sym_LT] = ACTIONS(13332),
    [anon_sym_end] = ACTIONS(5823),
    [anon_sym_if] = ACTIONS(5823),
    [anon_sym_unless] = ACTIONS(5823),
    [anon_sym_while] = ACTIONS(5823),
    [anon_sym_until] = ACTIONS(5823),
    [anon_sym_rescue] = ACTIONS(5823),
    [anon_sym_when] = ACTIONS(5823),
    [anon_sym_else] = ACTIONS(5823),
    [anon_sym_QMARK] = ACTIONS(13334),
    [anon_sym_DOT_DOT] = ACTIONS(13336),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13338),
    [anon_sym_and] = ACTIONS(13340),
    [anon_sym_or] = ACTIONS(13340),
    [anon_sym_PIPE_PIPE] = ACTIONS(13342),
    [anon_sym_AMP_AMP] = ACTIONS(13342),
    [anon_sym_LT_LT] = ACTIONS(13344),
    [anon_sym_GT_GT] = ACTIONS(13344),
    [anon_sym_EQ_EQ] = ACTIONS(13346),
    [anon_sym_BANG_EQ] = ACTIONS(13342),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13342),
    [anon_sym_LT_EQ_GT] = ACTIONS(13342),
    [anon_sym_EQ_TILDE] = ACTIONS(13342),
    [anon_sym_BANG_TILDE] = ACTIONS(13342),
    [anon_sym_LT_EQ] = ACTIONS(13332),
    [anon_sym_GT] = ACTIONS(13332),
    [anon_sym_GT_EQ] = ACTIONS(13348),
    [anon_sym_CARET] = ACTIONS(13350),
    [anon_sym_PLUS] = ACTIONS(13324),
    [anon_sym_SLASH] = ACTIONS(13326),
    [anon_sym_PERCENT] = ACTIONS(13326),
    [sym_comment] = ACTIONS(87),
  },
  [10549] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(13326),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13326),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_when] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(13326),
    [anon_sym_PERCENT] = ACTIONS(13326),
    [sym_comment] = ACTIONS(87),
  },
  [10550] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13326),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_when] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [10551] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(13324),
    [sym__binary_star] = ACTIONS(13326),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13326),
    [anon_sym_AMP] = ACTIONS(13330),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_when] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(13344),
    [anon_sym_GT_GT] = ACTIONS(13344),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(13324),
    [anon_sym_SLASH] = ACTIONS(13326),
    [anon_sym_PERCENT] = ACTIONS(13326),
    [sym_comment] = ACTIONS(87),
  },
  [10552] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(13324),
    [sym__binary_star] = ACTIONS(13326),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13326),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_when] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(13344),
    [anon_sym_GT_GT] = ACTIONS(13344),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(13324),
    [anon_sym_SLASH] = ACTIONS(13326),
    [anon_sym_PERCENT] = ACTIONS(13326),
    [sym_comment] = ACTIONS(87),
  },
  [10553] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(13324),
    [sym__binary_star] = ACTIONS(13326),
    [anon_sym_PIPE] = ACTIONS(13328),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13326),
    [anon_sym_AMP] = ACTIONS(13330),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_when] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(13344),
    [anon_sym_GT_GT] = ACTIONS(13344),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(13350),
    [anon_sym_PLUS] = ACTIONS(13324),
    [anon_sym_SLASH] = ACTIONS(13326),
    [anon_sym_PERCENT] = ACTIONS(13326),
    [sym_comment] = ACTIONS(87),
  },
  [10554] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(14881),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [10555] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(13324),
    [sym__binary_star] = ACTIONS(13326),
    [anon_sym_PIPE] = ACTIONS(13328),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(13326),
    [anon_sym_AMP] = ACTIONS(13330),
    [anon_sym_LT] = ACTIONS(13332),
    [anon_sym_end] = ACTIONS(5927),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_when] = ACTIONS(5927),
    [anon_sym_else] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(13336),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13338),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(13342),
    [anon_sym_AMP_AMP] = ACTIONS(13342),
    [anon_sym_LT_LT] = ACTIONS(13344),
    [anon_sym_GT_GT] = ACTIONS(13344),
    [anon_sym_EQ_EQ] = ACTIONS(13346),
    [anon_sym_BANG_EQ] = ACTIONS(13342),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13342),
    [anon_sym_LT_EQ_GT] = ACTIONS(13342),
    [anon_sym_EQ_TILDE] = ACTIONS(13342),
    [anon_sym_BANG_TILDE] = ACTIONS(13342),
    [anon_sym_LT_EQ] = ACTIONS(13332),
    [anon_sym_GT] = ACTIONS(13332),
    [anon_sym_GT_EQ] = ACTIONS(13348),
    [anon_sym_CARET] = ACTIONS(13350),
    [anon_sym_PLUS] = ACTIONS(13324),
    [anon_sym_SLASH] = ACTIONS(13326),
    [anon_sym_PERCENT] = ACTIONS(13326),
    [sym_comment] = ACTIONS(87),
  },
  [10556] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(13324),
    [sym__binary_star] = ACTIONS(13326),
    [anon_sym_PIPE] = ACTIONS(13328),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13326),
    [anon_sym_AMP] = ACTIONS(13330),
    [anon_sym_LT] = ACTIONS(13332),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_when] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(13334),
    [anon_sym_DOT_DOT] = ACTIONS(13336),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13338),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(13342),
    [anon_sym_AMP_AMP] = ACTIONS(13342),
    [anon_sym_LT_LT] = ACTIONS(13344),
    [anon_sym_GT_GT] = ACTIONS(13344),
    [anon_sym_EQ_EQ] = ACTIONS(13346),
    [anon_sym_BANG_EQ] = ACTIONS(13342),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13342),
    [anon_sym_LT_EQ_GT] = ACTIONS(13342),
    [anon_sym_EQ_TILDE] = ACTIONS(13342),
    [anon_sym_BANG_TILDE] = ACTIONS(13342),
    [anon_sym_LT_EQ] = ACTIONS(13332),
    [anon_sym_GT] = ACTIONS(13332),
    [anon_sym_GT_EQ] = ACTIONS(13348),
    [anon_sym_CARET] = ACTIONS(13350),
    [anon_sym_PLUS] = ACTIONS(13324),
    [anon_sym_SLASH] = ACTIONS(13326),
    [anon_sym_PERCENT] = ACTIONS(13326),
    [sym_comment] = ACTIONS(87),
  },
  [10557] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(13324),
    [sym__binary_star] = ACTIONS(13326),
    [anon_sym_PIPE] = ACTIONS(13328),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13326),
    [anon_sym_AMP] = ACTIONS(13330),
    [anon_sym_LT] = ACTIONS(13332),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_when] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(13344),
    [anon_sym_GT_GT] = ACTIONS(13344),
    [anon_sym_EQ_EQ] = ACTIONS(13346),
    [anon_sym_BANG_EQ] = ACTIONS(13342),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13342),
    [anon_sym_LT_EQ_GT] = ACTIONS(13342),
    [anon_sym_EQ_TILDE] = ACTIONS(13342),
    [anon_sym_BANG_TILDE] = ACTIONS(13342),
    [anon_sym_LT_EQ] = ACTIONS(13332),
    [anon_sym_GT] = ACTIONS(13332),
    [anon_sym_GT_EQ] = ACTIONS(13348),
    [anon_sym_CARET] = ACTIONS(13350),
    [anon_sym_PLUS] = ACTIONS(13324),
    [anon_sym_SLASH] = ACTIONS(13326),
    [anon_sym_PERCENT] = ACTIONS(13326),
    [sym_comment] = ACTIONS(87),
  },
  [10558] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(13324),
    [sym__binary_star] = ACTIONS(13326),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13326),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_when] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(13324),
    [anon_sym_SLASH] = ACTIONS(13326),
    [anon_sym_PERCENT] = ACTIONS(13326),
    [sym_comment] = ACTIONS(87),
  },
  [10559] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10990),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(10569),
    [sym_scope_resolution] = STATE(10567),
    [sym_call] = STATE(10567),
    [sym_method_call] = STATE(10569),
    [sym_assignment] = STATE(10990),
    [sym_operator_assignment] = STATE(10990),
    [sym_conditional] = STATE(10990),
    [sym_range] = STATE(10990),
    [sym_binary] = STATE(10990),
    [sym_unary] = STATE(10990),
    [sym_left_assignment_list] = STATE(10568),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10569),
    [sym__variable] = STATE(10567),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(10569),
    [sym_false] = STATE(10569),
    [sym_nil] = STATE(10569),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(10570),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(14234),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(14236),
    [anon_sym_yield] = ACTIONS(14238),
    [anon_sym_break] = ACTIONS(14240),
    [anon_sym_next] = ACTIONS(14242),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(14244),
    [anon_sym_defined_QMARK] = ACTIONS(14246),
    [anon_sym_not] = ACTIONS(14248),
    [anon_sym_BANG] = ACTIONS(14250),
    [anon_sym_TILDE] = ACTIONS(14250),
    [sym_constant] = ACTIONS(14252),
    [sym_identifier] = ACTIONS(14252),
    [sym_instance_variable] = ACTIONS(14254),
    [sym_class_variable] = ACTIONS(14254),
    [sym_global_variable] = ACTIONS(14254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(14252),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(14252),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [10560] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(9624),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(9629),
    [sym_scope_resolution] = STATE(9625),
    [sym_call] = STATE(9625),
    [sym_method_call] = STATE(9629),
    [sym_argument_list] = STATE(3610),
    [sym__argument_list_with_parens] = STATE(9626),
    [sym__argument] = STATE(9627),
    [sym_splat_argument] = STATE(9627),
    [sym_hash_splat_argument] = STATE(9627),
    [sym_block_argument] = STATE(9627),
    [sym_assignment] = STATE(9624),
    [sym_operator_assignment] = STATE(9624),
    [sym_conditional] = STATE(9624),
    [sym_range] = STATE(9624),
    [sym_binary] = STATE(9624),
    [sym_unary] = STATE(9624),
    [sym_left_assignment_list] = STATE(9628),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9629),
    [sym__variable] = STATE(9625),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(9629),
    [sym_false] = STATE(9629),
    [sym_nil] = STATE(9629),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(9630),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(9627),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(13352),
    [sym__splat_star] = ACTIONS(13354),
    [sym__unary_minus] = ACTIONS(13356),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(13358),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(13360),
    [anon_sym_yield] = ACTIONS(13362),
    [anon_sym_break] = ACTIONS(13364),
    [anon_sym_next] = ACTIONS(13366),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_unless] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_until] = ACTIONS(377),
    [anon_sym_rescue] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_when] = ACTIONS(377),
    [anon_sym_else] = ACTIONS(377),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(365),
    [anon_sym_DASH_EQ] = ACTIONS(365),
    [anon_sym_STAR_EQ] = ACTIONS(365),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(365),
    [anon_sym_SLASH_EQ] = ACTIONS(365),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(365),
    [anon_sym_PIPE_EQ] = ACTIONS(365),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(365),
    [anon_sym_AMP_EQ] = ACTIONS(365),
    [anon_sym_PERCENT_EQ] = ACTIONS(365),
    [anon_sym_GT_GT_EQ] = ACTIONS(365),
    [anon_sym_LT_LT_EQ] = ACTIONS(365),
    [anon_sym_CARET_EQ] = ACTIONS(365),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_PERCENT] = ACTIONS(377),
    [anon_sym_defined_QMARK] = ACTIONS(13368),
    [anon_sym_not] = ACTIONS(13370),
    [anon_sym_BANG] = ACTIONS(13372),
    [anon_sym_TILDE] = ACTIONS(13374),
    [sym_constant] = ACTIONS(13376),
    [sym_identifier] = ACTIONS(13376),
    [sym_instance_variable] = ACTIONS(13378),
    [sym_class_variable] = ACTIONS(13378),
    [sym_global_variable] = ACTIONS(13378),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(13380),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13380),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [10561] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(9624),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(9629),
    [sym_scope_resolution] = STATE(9625),
    [sym_call] = STATE(9625),
    [sym_method_call] = STATE(9629),
    [sym_argument_list] = STATE(3611),
    [sym__argument_list_with_parens] = STATE(9626),
    [sym__argument] = STATE(9627),
    [sym_splat_argument] = STATE(9627),
    [sym_hash_splat_argument] = STATE(9627),
    [sym_block_argument] = STATE(9627),
    [sym_assignment] = STATE(9624),
    [sym_operator_assignment] = STATE(9624),
    [sym_conditional] = STATE(9624),
    [sym_range] = STATE(9624),
    [sym_binary] = STATE(9624),
    [sym_unary] = STATE(9624),
    [sym_left_assignment_list] = STATE(9628),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9629),
    [sym__variable] = STATE(9625),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(9629),
    [sym_false] = STATE(9629),
    [sym_nil] = STATE(9629),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(9630),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(9627),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(417),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(13352),
    [sym__splat_star] = ACTIONS(13354),
    [sym__unary_minus] = ACTIONS(13356),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(13358),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_EQ] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(13360),
    [anon_sym_yield] = ACTIONS(13362),
    [anon_sym_break] = ACTIONS(13364),
    [anon_sym_next] = ACTIONS(13366),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_unless] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_until] = ACTIONS(419),
    [anon_sym_rescue] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_when] = ACTIONS(419),
    [anon_sym_else] = ACTIONS(419),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(417),
    [anon_sym_DASH_EQ] = ACTIONS(417),
    [anon_sym_STAR_EQ] = ACTIONS(417),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(417),
    [anon_sym_SLASH_EQ] = ACTIONS(417),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(417),
    [anon_sym_PIPE_EQ] = ACTIONS(417),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(417),
    [anon_sym_AMP_EQ] = ACTIONS(417),
    [anon_sym_PERCENT_EQ] = ACTIONS(417),
    [anon_sym_GT_GT_EQ] = ACTIONS(417),
    [anon_sym_LT_LT_EQ] = ACTIONS(417),
    [anon_sym_CARET_EQ] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(13368),
    [anon_sym_not] = ACTIONS(13370),
    [anon_sym_BANG] = ACTIONS(13372),
    [anon_sym_TILDE] = ACTIONS(13374),
    [sym_constant] = ACTIONS(13376),
    [sym_identifier] = ACTIONS(13376),
    [sym_instance_variable] = ACTIONS(13378),
    [sym_class_variable] = ACTIONS(13378),
    [sym_global_variable] = ACTIONS(13378),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(13380),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13380),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [10562] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(9624),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(9629),
    [sym_scope_resolution] = STATE(9625),
    [sym_call] = STATE(9625),
    [sym_method_call] = STATE(9629),
    [sym_argument_list] = STATE(3612),
    [sym__argument_list_with_parens] = STATE(9626),
    [sym__argument] = STATE(9627),
    [sym_splat_argument] = STATE(9627),
    [sym_hash_splat_argument] = STATE(9627),
    [sym_block_argument] = STATE(9627),
    [sym_assignment] = STATE(9624),
    [sym_operator_assignment] = STATE(9624),
    [sym_conditional] = STATE(9624),
    [sym_range] = STATE(9624),
    [sym_binary] = STATE(9624),
    [sym_unary] = STATE(9624),
    [sym_left_assignment_list] = STATE(9628),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9629),
    [sym__variable] = STATE(9625),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(9629),
    [sym_false] = STATE(9629),
    [sym_nil] = STATE(9629),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(9630),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(9627),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(13352),
    [sym__splat_star] = ACTIONS(13354),
    [sym__unary_minus] = ACTIONS(13356),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(13358),
    [anon_sym_LBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_EQ] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(423),
    [anon_sym_return] = ACTIONS(13360),
    [anon_sym_yield] = ACTIONS(13362),
    [anon_sym_break] = ACTIONS(13364),
    [anon_sym_next] = ACTIONS(13366),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_unless] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_until] = ACTIONS(423),
    [anon_sym_rescue] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_when] = ACTIONS(423),
    [anon_sym_else] = ACTIONS(423),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(421),
    [anon_sym_DASH_EQ] = ACTIONS(421),
    [anon_sym_STAR_EQ] = ACTIONS(421),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(421),
    [anon_sym_SLASH_EQ] = ACTIONS(421),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(421),
    [anon_sym_PIPE_EQ] = ACTIONS(421),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(421),
    [anon_sym_AMP_EQ] = ACTIONS(421),
    [anon_sym_PERCENT_EQ] = ACTIONS(421),
    [anon_sym_GT_GT_EQ] = ACTIONS(421),
    [anon_sym_LT_LT_EQ] = ACTIONS(421),
    [anon_sym_CARET_EQ] = ACTIONS(421),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(13368),
    [anon_sym_not] = ACTIONS(13370),
    [anon_sym_BANG] = ACTIONS(13372),
    [anon_sym_TILDE] = ACTIONS(13374),
    [sym_constant] = ACTIONS(13376),
    [sym_identifier] = ACTIONS(13376),
    [sym_instance_variable] = ACTIONS(13378),
    [sym_class_variable] = ACTIONS(13378),
    [sym_global_variable] = ACTIONS(13378),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(13380),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13380),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [10563] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(9624),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(9629),
    [sym_scope_resolution] = STATE(9625),
    [sym_call] = STATE(9625),
    [sym_method_call] = STATE(9629),
    [sym_argument_list] = STATE(3613),
    [sym__argument_list_with_parens] = STATE(9626),
    [sym__argument] = STATE(9627),
    [sym_splat_argument] = STATE(9627),
    [sym_hash_splat_argument] = STATE(9627),
    [sym_block_argument] = STATE(9627),
    [sym_assignment] = STATE(9624),
    [sym_operator_assignment] = STATE(9624),
    [sym_conditional] = STATE(9624),
    [sym_range] = STATE(9624),
    [sym_binary] = STATE(9624),
    [sym_unary] = STATE(9624),
    [sym_left_assignment_list] = STATE(9628),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9629),
    [sym__variable] = STATE(9625),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(9629),
    [sym_false] = STATE(9629),
    [sym_nil] = STATE(9629),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(9630),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(9627),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(425),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(13352),
    [sym__splat_star] = ACTIONS(13354),
    [sym__unary_minus] = ACTIONS(13356),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(13358),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(427),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(427),
    [anon_sym_return] = ACTIONS(13360),
    [anon_sym_yield] = ACTIONS(13362),
    [anon_sym_break] = ACTIONS(13364),
    [anon_sym_next] = ACTIONS(13366),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_unless] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_until] = ACTIONS(427),
    [anon_sym_rescue] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_when] = ACTIONS(427),
    [anon_sym_else] = ACTIONS(427),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(425),
    [anon_sym_DASH_EQ] = ACTIONS(425),
    [anon_sym_STAR_EQ] = ACTIONS(425),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(425),
    [anon_sym_SLASH_EQ] = ACTIONS(425),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(425),
    [anon_sym_PIPE_EQ] = ACTIONS(425),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(425),
    [anon_sym_AMP_EQ] = ACTIONS(425),
    [anon_sym_PERCENT_EQ] = ACTIONS(425),
    [anon_sym_GT_GT_EQ] = ACTIONS(425),
    [anon_sym_LT_LT_EQ] = ACTIONS(425),
    [anon_sym_CARET_EQ] = ACTIONS(425),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(13368),
    [anon_sym_not] = ACTIONS(13370),
    [anon_sym_BANG] = ACTIONS(13372),
    [anon_sym_TILDE] = ACTIONS(13374),
    [sym_constant] = ACTIONS(13376),
    [sym_identifier] = ACTIONS(13376),
    [sym_instance_variable] = ACTIONS(13378),
    [sym_class_variable] = ACTIONS(13378),
    [sym_global_variable] = ACTIONS(13378),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(13380),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13380),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [10564] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10991),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(10569),
    [sym_scope_resolution] = STATE(10567),
    [sym_call] = STATE(10567),
    [sym_method_call] = STATE(10569),
    [sym_assignment] = STATE(10991),
    [sym_operator_assignment] = STATE(10991),
    [sym_conditional] = STATE(10991),
    [sym_range] = STATE(10991),
    [sym_binary] = STATE(10991),
    [sym_unary] = STATE(10991),
    [sym_left_assignment_list] = STATE(10568),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10569),
    [sym__variable] = STATE(10567),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(10569),
    [sym_false] = STATE(10569),
    [sym_nil] = STATE(10569),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(10570),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(14234),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(14236),
    [anon_sym_yield] = ACTIONS(14238),
    [anon_sym_break] = ACTIONS(14240),
    [anon_sym_next] = ACTIONS(14242),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(14244),
    [anon_sym_defined_QMARK] = ACTIONS(14246),
    [anon_sym_not] = ACTIONS(14248),
    [anon_sym_BANG] = ACTIONS(14250),
    [anon_sym_TILDE] = ACTIONS(14250),
    [sym_constant] = ACTIONS(14252),
    [sym_identifier] = ACTIONS(14252),
    [sym_instance_variable] = ACTIONS(14254),
    [sym_class_variable] = ACTIONS(14254),
    [sym_global_variable] = ACTIONS(14254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(14252),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(14252),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [10565] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(3628),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(10569),
    [sym_scope_resolution] = STATE(10567),
    [sym_call] = STATE(10567),
    [sym_method_call] = STATE(10569),
    [sym_assignment] = STATE(3628),
    [sym_operator_assignment] = STATE(3628),
    [sym_conditional] = STATE(3628),
    [sym_range] = STATE(3628),
    [sym_binary] = STATE(3628),
    [sym_unary] = STATE(3628),
    [sym_left_assignment_list] = STATE(10568),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10569),
    [sym__variable] = STATE(10567),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(10569),
    [sym_false] = STATE(10569),
    [sym_nil] = STATE(10569),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(10570),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(14234),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(14236),
    [anon_sym_yield] = ACTIONS(14238),
    [anon_sym_break] = ACTIONS(14240),
    [anon_sym_next] = ACTIONS(14242),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(14244),
    [anon_sym_defined_QMARK] = ACTIONS(14246),
    [anon_sym_not] = ACTIONS(14248),
    [anon_sym_BANG] = ACTIONS(14250),
    [anon_sym_TILDE] = ACTIONS(14250),
    [sym_constant] = ACTIONS(14252),
    [sym_identifier] = ACTIONS(14252),
    [sym_instance_variable] = ACTIONS(14254),
    [sym_class_variable] = ACTIONS(14254),
    [sym_global_variable] = ACTIONS(14254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(14252),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(14252),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [10566] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(14883),
    [sym__binary_star] = ACTIONS(14885),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(14887),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(14889),
    [anon_sym_AMP] = ACTIONS(14891),
    [anon_sym_EQ] = ACTIONS(4217),
    [anon_sym_LT] = ACTIONS(14893),
    [anon_sym_end] = ACTIONS(4211),
    [anon_sym_if] = ACTIONS(4211),
    [anon_sym_unless] = ACTIONS(4211),
    [anon_sym_while] = ACTIONS(4211),
    [anon_sym_until] = ACTIONS(4211),
    [anon_sym_rescue] = ACTIONS(4211),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_when] = ACTIONS(4211),
    [anon_sym_else] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_PLUS_EQ] = ACTIONS(4211),
    [anon_sym_DASH_EQ] = ACTIONS(4211),
    [anon_sym_STAR_EQ] = ACTIONS(4211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4211),
    [anon_sym_SLASH_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4211),
    [anon_sym_AMP_EQ] = ACTIONS(4211),
    [anon_sym_PERCENT_EQ] = ACTIONS(4211),
    [anon_sym_GT_GT_EQ] = ACTIONS(4211),
    [anon_sym_LT_LT_EQ] = ACTIONS(4211),
    [anon_sym_CARET_EQ] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(14895),
    [anon_sym_DOT_DOT] = ACTIONS(14897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14899),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(14901),
    [anon_sym_AMP_AMP] = ACTIONS(14901),
    [anon_sym_LT_LT] = ACTIONS(14903),
    [anon_sym_GT_GT] = ACTIONS(14903),
    [anon_sym_EQ_EQ] = ACTIONS(14901),
    [anon_sym_BANG_EQ] = ACTIONS(14905),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14905),
    [anon_sym_LT_EQ_GT] = ACTIONS(14905),
    [anon_sym_EQ_TILDE] = ACTIONS(14905),
    [anon_sym_BANG_TILDE] = ACTIONS(14905),
    [anon_sym_LT_EQ] = ACTIONS(14893),
    [anon_sym_GT] = ACTIONS(14893),
    [anon_sym_GT_EQ] = ACTIONS(14907),
    [anon_sym_CARET] = ACTIONS(14887),
    [anon_sym_PLUS] = ACTIONS(14909),
    [anon_sym_SLASH] = ACTIONS(14889),
    [anon_sym_PERCENT] = ACTIONS(14889),
    [sym_comment] = ACTIONS(87),
  },
  [10567] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(9624),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(9629),
    [sym_scope_resolution] = STATE(9625),
    [sym_call] = STATE(9625),
    [sym_method_call] = STATE(9629),
    [sym_argument_list] = STATE(1062),
    [sym__argument_list_with_parens] = STATE(9626),
    [sym__argument] = STATE(9627),
    [sym_splat_argument] = STATE(9627),
    [sym_hash_splat_argument] = STATE(9627),
    [sym_block_argument] = STATE(9627),
    [sym_do_block] = STATE(426),
    [sym_block] = STATE(426),
    [sym_assignment] = STATE(9624),
    [sym_operator_assignment] = STATE(9624),
    [sym_conditional] = STATE(9624),
    [sym_range] = STATE(9624),
    [sym_binary] = STATE(9624),
    [sym_unary] = STATE(9624),
    [sym_left_assignment_list] = STATE(9628),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9629),
    [sym__variable] = STATE(9625),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(9629),
    [sym_false] = STATE(9629),
    [sym_nil] = STATE(9629),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(9630),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(9627),
    [sym_lambda] = STATE(421),
    [sym__line_break] = ACTIONS(743),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(13352),
    [sym__splat_star] = ACTIONS(13354),
    [sym__unary_minus] = ACTIONS(13356),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(13358),
    [anon_sym_LBRACE] = ACTIONS(6047),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_end] = ACTIONS(769),
    [anon_sym_return] = ACTIONS(13360),
    [anon_sym_yield] = ACTIONS(13362),
    [anon_sym_break] = ACTIONS(13364),
    [anon_sym_next] = ACTIONS(13366),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(769),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(769),
    [anon_sym_until] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(769),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(769),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_when] = ACTIONS(769),
    [anon_sym_else] = ACTIONS(769),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(13368),
    [anon_sym_not] = ACTIONS(13370),
    [anon_sym_BANG] = ACTIONS(13372),
    [anon_sym_TILDE] = ACTIONS(13374),
    [sym_constant] = ACTIONS(13376),
    [sym_identifier] = ACTIONS(13376),
    [sym_instance_variable] = ACTIONS(13378),
    [sym_class_variable] = ACTIONS(13378),
    [sym_global_variable] = ACTIONS(13378),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(13380),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13380),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(817),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [10568] = {
    [anon_sym_EQ] = ACTIONS(14911),
    [sym_comment] = ACTIONS(87),
  },
  [10569] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(14913),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_when] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(14915),
    [anon_sym_DASH_EQ] = ACTIONS(14915),
    [anon_sym_STAR_EQ] = ACTIONS(14915),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14915),
    [anon_sym_SLASH_EQ] = ACTIONS(14915),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14915),
    [anon_sym_PIPE_EQ] = ACTIONS(14915),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14915),
    [anon_sym_AMP_EQ] = ACTIONS(14915),
    [anon_sym_PERCENT_EQ] = ACTIONS(14915),
    [anon_sym_GT_GT_EQ] = ACTIONS(14915),
    [anon_sym_LT_LT_EQ] = ACTIONS(14915),
    [anon_sym_CARET_EQ] = ACTIONS(14915),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [10570] = {
    [sym_string] = STATE(11004),
    [aux_sym_chained_string_repeat1] = STATE(11004),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(2551),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_when] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [10571] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(14883),
    [sym__binary_star] = ACTIONS(14885),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(14887),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(14889),
    [anon_sym_AMP] = ACTIONS(14891),
    [anon_sym_EQ] = ACTIONS(4249),
    [anon_sym_LT] = ACTIONS(14893),
    [anon_sym_end] = ACTIONS(4247),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_when] = ACTIONS(4247),
    [anon_sym_else] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_PLUS_EQ] = ACTIONS(4247),
    [anon_sym_DASH_EQ] = ACTIONS(4247),
    [anon_sym_STAR_EQ] = ACTIONS(4247),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4247),
    [anon_sym_SLASH_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4247),
    [anon_sym_AMP_EQ] = ACTIONS(4247),
    [anon_sym_PERCENT_EQ] = ACTIONS(4247),
    [anon_sym_GT_GT_EQ] = ACTIONS(4247),
    [anon_sym_LT_LT_EQ] = ACTIONS(4247),
    [anon_sym_CARET_EQ] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(14895),
    [anon_sym_DOT_DOT] = ACTIONS(14897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14899),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(14901),
    [anon_sym_AMP_AMP] = ACTIONS(14901),
    [anon_sym_LT_LT] = ACTIONS(14903),
    [anon_sym_GT_GT] = ACTIONS(14903),
    [anon_sym_EQ_EQ] = ACTIONS(14901),
    [anon_sym_BANG_EQ] = ACTIONS(14905),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14905),
    [anon_sym_LT_EQ_GT] = ACTIONS(14905),
    [anon_sym_EQ_TILDE] = ACTIONS(14905),
    [anon_sym_BANG_TILDE] = ACTIONS(14905),
    [anon_sym_LT_EQ] = ACTIONS(14893),
    [anon_sym_GT] = ACTIONS(14893),
    [anon_sym_GT_EQ] = ACTIONS(14907),
    [anon_sym_CARET] = ACTIONS(14887),
    [anon_sym_PLUS] = ACTIONS(14909),
    [anon_sym_SLASH] = ACTIONS(14889),
    [anon_sym_PERCENT] = ACTIONS(14889),
    [sym_comment] = ACTIONS(87),
  },
  [10572] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(14268),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_when] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [10573] = {
    [sym_string] = STATE(10593),
    [aux_sym_chained_string_repeat1] = STATE(10593),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(747),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_when] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [10574] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(11005),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(10569),
    [sym_scope_resolution] = STATE(10567),
    [sym_call] = STATE(10567),
    [sym_method_call] = STATE(10569),
    [sym_assignment] = STATE(11005),
    [sym_operator_assignment] = STATE(11005),
    [sym_conditional] = STATE(11005),
    [sym_range] = STATE(11005),
    [sym_binary] = STATE(11005),
    [sym_unary] = STATE(11005),
    [sym_left_assignment_list] = STATE(10568),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10569),
    [sym__variable] = STATE(10567),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(10569),
    [sym_false] = STATE(10569),
    [sym_nil] = STATE(10569),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(10570),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(14234),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(14236),
    [anon_sym_yield] = ACTIONS(14238),
    [anon_sym_break] = ACTIONS(14240),
    [anon_sym_next] = ACTIONS(14242),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(14244),
    [anon_sym_defined_QMARK] = ACTIONS(14246),
    [anon_sym_not] = ACTIONS(14248),
    [anon_sym_BANG] = ACTIONS(14250),
    [anon_sym_TILDE] = ACTIONS(14250),
    [sym_constant] = ACTIONS(14252),
    [sym_identifier] = ACTIONS(14252),
    [sym_instance_variable] = ACTIONS(14254),
    [sym_class_variable] = ACTIONS(14254),
    [sym_global_variable] = ACTIONS(14254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(14252),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(14252),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [10575] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(14883),
    [sym__binary_star] = ACTIONS(14885),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(14887),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(14889),
    [anon_sym_AMP] = ACTIONS(14891),
    [anon_sym_EQ] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(14893),
    [anon_sym_end] = ACTIONS(3281),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_unless] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_until] = ACTIONS(3281),
    [anon_sym_rescue] = ACTIONS(3281),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_when] = ACTIONS(3281),
    [anon_sym_else] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_PLUS_EQ] = ACTIONS(3281),
    [anon_sym_DASH_EQ] = ACTIONS(3281),
    [anon_sym_STAR_EQ] = ACTIONS(3281),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3281),
    [anon_sym_SLASH_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3281),
    [anon_sym_AMP_EQ] = ACTIONS(3281),
    [anon_sym_PERCENT_EQ] = ACTIONS(3281),
    [anon_sym_GT_GT_EQ] = ACTIONS(3281),
    [anon_sym_LT_LT_EQ] = ACTIONS(3281),
    [anon_sym_CARET_EQ] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(14895),
    [anon_sym_DOT_DOT] = ACTIONS(14897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14899),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(14901),
    [anon_sym_AMP_AMP] = ACTIONS(14901),
    [anon_sym_LT_LT] = ACTIONS(14903),
    [anon_sym_GT_GT] = ACTIONS(14903),
    [anon_sym_EQ_EQ] = ACTIONS(14901),
    [anon_sym_BANG_EQ] = ACTIONS(14905),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14905),
    [anon_sym_LT_EQ_GT] = ACTIONS(14905),
    [anon_sym_EQ_TILDE] = ACTIONS(14905),
    [anon_sym_BANG_TILDE] = ACTIONS(14905),
    [anon_sym_LT_EQ] = ACTIONS(14893),
    [anon_sym_GT] = ACTIONS(14893),
    [anon_sym_GT_EQ] = ACTIONS(14907),
    [anon_sym_CARET] = ACTIONS(14887),
    [anon_sym_PLUS] = ACTIONS(14909),
    [anon_sym_SLASH] = ACTIONS(14889),
    [anon_sym_PERCENT] = ACTIONS(14889),
    [sym_comment] = ACTIONS(87),
  },
  [10576] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(14262),
    [sym__binary_star] = ACTIONS(14264),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(14266),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(14268),
    [anon_sym_AMP] = ACTIONS(14270),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(14272),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_when] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(14274),
    [anon_sym_DOT_DOT] = ACTIONS(14276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14278),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(14280),
    [anon_sym_AMP_AMP] = ACTIONS(14280),
    [anon_sym_LT_LT] = ACTIONS(14282),
    [anon_sym_GT_GT] = ACTIONS(14282),
    [anon_sym_EQ_EQ] = ACTIONS(14280),
    [anon_sym_BANG_EQ] = ACTIONS(14284),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14284),
    [anon_sym_LT_EQ_GT] = ACTIONS(14284),
    [anon_sym_EQ_TILDE] = ACTIONS(14284),
    [anon_sym_BANG_TILDE] = ACTIONS(14284),
    [anon_sym_LT_EQ] = ACTIONS(14272),
    [anon_sym_GT] = ACTIONS(14272),
    [anon_sym_GT_EQ] = ACTIONS(14286),
    [anon_sym_CARET] = ACTIONS(14266),
    [anon_sym_PLUS] = ACTIONS(14288),
    [anon_sym_SLASH] = ACTIONS(14268),
    [anon_sym_PERCENT] = ACTIONS(14268),
    [sym_comment] = ACTIONS(87),
  },
  [10577] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(11006),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(10569),
    [sym_scope_resolution] = STATE(10567),
    [sym_call] = STATE(10567),
    [sym_method_call] = STATE(10569),
    [sym_assignment] = STATE(11006),
    [sym_operator_assignment] = STATE(11006),
    [sym_conditional] = STATE(11006),
    [sym_range] = STATE(11006),
    [sym_binary] = STATE(11006),
    [sym_unary] = STATE(11006),
    [sym_left_assignment_list] = STATE(10568),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10569),
    [sym__variable] = STATE(10567),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(10569),
    [sym_false] = STATE(10569),
    [sym_nil] = STATE(10569),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(10570),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(14234),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(14236),
    [anon_sym_yield] = ACTIONS(14238),
    [anon_sym_break] = ACTIONS(14240),
    [anon_sym_next] = ACTIONS(14242),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(14244),
    [anon_sym_defined_QMARK] = ACTIONS(14246),
    [anon_sym_not] = ACTIONS(14248),
    [anon_sym_BANG] = ACTIONS(14250),
    [anon_sym_TILDE] = ACTIONS(14250),
    [sym_constant] = ACTIONS(14252),
    [sym_identifier] = ACTIONS(14252),
    [sym_instance_variable] = ACTIONS(14254),
    [sym_class_variable] = ACTIONS(14254),
    [sym_global_variable] = ACTIONS(14254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(14252),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(14252),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [10578] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(11007),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(9629),
    [sym_scope_resolution] = STATE(9625),
    [sym_call] = STATE(9625),
    [sym_method_call] = STATE(9629),
    [sym_assignment] = STATE(11007),
    [sym_operator_assignment] = STATE(11007),
    [sym_conditional] = STATE(11007),
    [sym_range] = STATE(11007),
    [sym_binary] = STATE(11007),
    [sym_unary] = STATE(11007),
    [sym_left_assignment_list] = STATE(9628),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9629),
    [sym__variable] = STATE(9625),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(9629),
    [sym_false] = STATE(9629),
    [sym_nil] = STATE(9629),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(10573),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(13356),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(13360),
    [anon_sym_yield] = ACTIONS(13362),
    [anon_sym_break] = ACTIONS(13364),
    [anon_sym_next] = ACTIONS(13366),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(14256),
    [anon_sym_defined_QMARK] = ACTIONS(13368),
    [anon_sym_not] = ACTIONS(13370),
    [anon_sym_BANG] = ACTIONS(13374),
    [anon_sym_TILDE] = ACTIONS(13374),
    [sym_constant] = ACTIONS(13380),
    [sym_identifier] = ACTIONS(13380),
    [sym_instance_variable] = ACTIONS(13378),
    [sym_class_variable] = ACTIONS(13378),
    [sym_global_variable] = ACTIONS(13378),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(13380),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13380),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [10579] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(11008),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(9629),
    [sym_scope_resolution] = STATE(9625),
    [sym_call] = STATE(9625),
    [sym_method_call] = STATE(9629),
    [sym_assignment] = STATE(11008),
    [sym_operator_assignment] = STATE(11008),
    [sym_conditional] = STATE(11008),
    [sym_range] = STATE(11008),
    [sym_binary] = STATE(11008),
    [sym_unary] = STATE(11008),
    [sym_left_assignment_list] = STATE(9628),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9629),
    [sym__variable] = STATE(9625),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(9629),
    [sym_false] = STATE(9629),
    [sym_nil] = STATE(9629),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(10573),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(13356),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(13360),
    [anon_sym_yield] = ACTIONS(13362),
    [anon_sym_break] = ACTIONS(13364),
    [anon_sym_next] = ACTIONS(13366),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(14256),
    [anon_sym_defined_QMARK] = ACTIONS(13368),
    [anon_sym_not] = ACTIONS(13370),
    [anon_sym_BANG] = ACTIONS(13374),
    [anon_sym_TILDE] = ACTIONS(13374),
    [sym_constant] = ACTIONS(13380),
    [sym_identifier] = ACTIONS(13380),
    [sym_instance_variable] = ACTIONS(13378),
    [sym_class_variable] = ACTIONS(13378),
    [sym_global_variable] = ACTIONS(13378),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(13380),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13380),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [10580] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(11009),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(9629),
    [sym_scope_resolution] = STATE(9625),
    [sym_call] = STATE(9625),
    [sym_method_call] = STATE(9629),
    [sym_assignment] = STATE(11009),
    [sym_operator_assignment] = STATE(11009),
    [sym_conditional] = STATE(11009),
    [sym_range] = STATE(11009),
    [sym_binary] = STATE(11009),
    [sym_unary] = STATE(11009),
    [sym_left_assignment_list] = STATE(9628),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9629),
    [sym__variable] = STATE(9625),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(9629),
    [sym_false] = STATE(9629),
    [sym_nil] = STATE(9629),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(10573),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(13356),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(13360),
    [anon_sym_yield] = ACTIONS(13362),
    [anon_sym_break] = ACTIONS(13364),
    [anon_sym_next] = ACTIONS(13366),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(14256),
    [anon_sym_defined_QMARK] = ACTIONS(13368),
    [anon_sym_not] = ACTIONS(13370),
    [anon_sym_BANG] = ACTIONS(13374),
    [anon_sym_TILDE] = ACTIONS(13374),
    [sym_constant] = ACTIONS(13380),
    [sym_identifier] = ACTIONS(13380),
    [sym_instance_variable] = ACTIONS(13378),
    [sym_class_variable] = ACTIONS(13378),
    [sym_global_variable] = ACTIONS(13378),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(13380),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13380),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [10581] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(11010),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(9629),
    [sym_scope_resolution] = STATE(9625),
    [sym_call] = STATE(9625),
    [sym_method_call] = STATE(9629),
    [sym_assignment] = STATE(11010),
    [sym_operator_assignment] = STATE(11010),
    [sym_conditional] = STATE(11010),
    [sym_range] = STATE(11010),
    [sym_binary] = STATE(11010),
    [sym_unary] = STATE(11010),
    [sym_left_assignment_list] = STATE(9628),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9629),
    [sym__variable] = STATE(9625),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(9629),
    [sym_false] = STATE(9629),
    [sym_nil] = STATE(9629),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(10573),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(13356),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(13360),
    [anon_sym_yield] = ACTIONS(13362),
    [anon_sym_break] = ACTIONS(13364),
    [anon_sym_next] = ACTIONS(13366),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(14256),
    [anon_sym_defined_QMARK] = ACTIONS(13368),
    [anon_sym_not] = ACTIONS(13370),
    [anon_sym_BANG] = ACTIONS(13374),
    [anon_sym_TILDE] = ACTIONS(13374),
    [sym_constant] = ACTIONS(13380),
    [sym_identifier] = ACTIONS(13380),
    [sym_instance_variable] = ACTIONS(13378),
    [sym_class_variable] = ACTIONS(13378),
    [sym_global_variable] = ACTIONS(13378),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(13380),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13380),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [10582] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(11011),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(9629),
    [sym_scope_resolution] = STATE(9625),
    [sym_call] = STATE(9625),
    [sym_method_call] = STATE(9629),
    [sym_assignment] = STATE(11011),
    [sym_operator_assignment] = STATE(11011),
    [sym_conditional] = STATE(11011),
    [sym_range] = STATE(11011),
    [sym_binary] = STATE(11011),
    [sym_unary] = STATE(11011),
    [sym_left_assignment_list] = STATE(9628),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9629),
    [sym__variable] = STATE(9625),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(9629),
    [sym_false] = STATE(9629),
    [sym_nil] = STATE(9629),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(10573),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(13356),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(13360),
    [anon_sym_yield] = ACTIONS(13362),
    [anon_sym_break] = ACTIONS(13364),
    [anon_sym_next] = ACTIONS(13366),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(14256),
    [anon_sym_defined_QMARK] = ACTIONS(13368),
    [anon_sym_not] = ACTIONS(13370),
    [anon_sym_BANG] = ACTIONS(13374),
    [anon_sym_TILDE] = ACTIONS(13374),
    [sym_constant] = ACTIONS(13380),
    [sym_identifier] = ACTIONS(13380),
    [sym_instance_variable] = ACTIONS(13378),
    [sym_class_variable] = ACTIONS(13378),
    [sym_global_variable] = ACTIONS(13378),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(13380),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13380),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [10583] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(11012),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(11012),
    [sym_operator_assignment] = STATE(11012),
    [sym_conditional] = STATE(11012),
    [sym_range] = STATE(11012),
    [sym_binary] = STATE(11012),
    [sym_unary] = STATE(11012),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [10584] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(11013),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(9629),
    [sym_scope_resolution] = STATE(9625),
    [sym_call] = STATE(9625),
    [sym_method_call] = STATE(9629),
    [sym_assignment] = STATE(11013),
    [sym_operator_assignment] = STATE(11013),
    [sym_conditional] = STATE(11013),
    [sym_range] = STATE(11013),
    [sym_binary] = STATE(11013),
    [sym_unary] = STATE(11013),
    [sym_left_assignment_list] = STATE(9628),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9629),
    [sym__variable] = STATE(9625),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(9629),
    [sym_false] = STATE(9629),
    [sym_nil] = STATE(9629),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(10573),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(13356),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(13360),
    [anon_sym_yield] = ACTIONS(13362),
    [anon_sym_break] = ACTIONS(13364),
    [anon_sym_next] = ACTIONS(13366),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(14256),
    [anon_sym_defined_QMARK] = ACTIONS(13368),
    [anon_sym_not] = ACTIONS(13370),
    [anon_sym_BANG] = ACTIONS(13374),
    [anon_sym_TILDE] = ACTIONS(13374),
    [sym_constant] = ACTIONS(13380),
    [sym_identifier] = ACTIONS(13380),
    [sym_instance_variable] = ACTIONS(13378),
    [sym_class_variable] = ACTIONS(13378),
    [sym_global_variable] = ACTIONS(13378),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(13380),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13380),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [10585] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(11014),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(9629),
    [sym_scope_resolution] = STATE(9625),
    [sym_call] = STATE(9625),
    [sym_method_call] = STATE(9629),
    [sym_assignment] = STATE(11014),
    [sym_operator_assignment] = STATE(11014),
    [sym_conditional] = STATE(11014),
    [sym_range] = STATE(11014),
    [sym_binary] = STATE(11014),
    [sym_unary] = STATE(11014),
    [sym_left_assignment_list] = STATE(9628),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9629),
    [sym__variable] = STATE(9625),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(9629),
    [sym_false] = STATE(9629),
    [sym_nil] = STATE(9629),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(10573),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(13356),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(13360),
    [anon_sym_yield] = ACTIONS(13362),
    [anon_sym_break] = ACTIONS(13364),
    [anon_sym_next] = ACTIONS(13366),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(14256),
    [anon_sym_defined_QMARK] = ACTIONS(13368),
    [anon_sym_not] = ACTIONS(13370),
    [anon_sym_BANG] = ACTIONS(13374),
    [anon_sym_TILDE] = ACTIONS(13374),
    [sym_constant] = ACTIONS(13380),
    [sym_identifier] = ACTIONS(13380),
    [sym_instance_variable] = ACTIONS(13378),
    [sym_class_variable] = ACTIONS(13378),
    [sym_global_variable] = ACTIONS(13378),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(13380),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13380),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [10586] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(11015),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(9629),
    [sym_scope_resolution] = STATE(9625),
    [sym_call] = STATE(9625),
    [sym_method_call] = STATE(9629),
    [sym_assignment] = STATE(11015),
    [sym_operator_assignment] = STATE(11015),
    [sym_conditional] = STATE(11015),
    [sym_range] = STATE(11015),
    [sym_binary] = STATE(11015),
    [sym_unary] = STATE(11015),
    [sym_left_assignment_list] = STATE(9628),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9629),
    [sym__variable] = STATE(9625),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(9629),
    [sym_false] = STATE(9629),
    [sym_nil] = STATE(9629),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(10573),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(13356),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(13360),
    [anon_sym_yield] = ACTIONS(13362),
    [anon_sym_break] = ACTIONS(13364),
    [anon_sym_next] = ACTIONS(13366),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(14256),
    [anon_sym_defined_QMARK] = ACTIONS(13368),
    [anon_sym_not] = ACTIONS(13370),
    [anon_sym_BANG] = ACTIONS(13374),
    [anon_sym_TILDE] = ACTIONS(13374),
    [sym_constant] = ACTIONS(13380),
    [sym_identifier] = ACTIONS(13380),
    [sym_instance_variable] = ACTIONS(13378),
    [sym_class_variable] = ACTIONS(13378),
    [sym_global_variable] = ACTIONS(13378),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(13380),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13380),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [10587] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(11016),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(9629),
    [sym_scope_resolution] = STATE(9625),
    [sym_call] = STATE(9625),
    [sym_method_call] = STATE(9629),
    [sym_assignment] = STATE(11016),
    [sym_operator_assignment] = STATE(11016),
    [sym_conditional] = STATE(11016),
    [sym_range] = STATE(11016),
    [sym_binary] = STATE(11016),
    [sym_unary] = STATE(11016),
    [sym_left_assignment_list] = STATE(9628),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9629),
    [sym__variable] = STATE(9625),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(9629),
    [sym_false] = STATE(9629),
    [sym_nil] = STATE(9629),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(10573),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(13356),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(13360),
    [anon_sym_yield] = ACTIONS(13362),
    [anon_sym_break] = ACTIONS(13364),
    [anon_sym_next] = ACTIONS(13366),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(14256),
    [anon_sym_defined_QMARK] = ACTIONS(13368),
    [anon_sym_not] = ACTIONS(13370),
    [anon_sym_BANG] = ACTIONS(13374),
    [anon_sym_TILDE] = ACTIONS(13374),
    [sym_constant] = ACTIONS(13380),
    [sym_identifier] = ACTIONS(13380),
    [sym_instance_variable] = ACTIONS(13378),
    [sym_class_variable] = ACTIONS(13378),
    [sym_global_variable] = ACTIONS(13378),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(13380),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13380),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [10588] = {
    [sym_heredoc_body] = STATE(11017),
    [aux_sym_call_repeat1] = STATE(11017),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_when] = ACTIONS(4383),
    [anon_sym_else] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [10589] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(9624),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(9629),
    [sym_scope_resolution] = STATE(9625),
    [sym_call] = STATE(9625),
    [sym_method_call] = STATE(9629),
    [sym__argument] = STATE(3737),
    [sym_splat_argument] = STATE(3737),
    [sym_hash_splat_argument] = STATE(3737),
    [sym_block_argument] = STATE(3737),
    [sym_assignment] = STATE(9624),
    [sym_operator_assignment] = STATE(9624),
    [sym_conditional] = STATE(9624),
    [sym_range] = STATE(9624),
    [sym_binary] = STATE(9624),
    [sym_unary] = STATE(9624),
    [sym_left_assignment_list] = STATE(9628),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9629),
    [sym__variable] = STATE(9625),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(9629),
    [sym_false] = STATE(9629),
    [sym_nil] = STATE(9629),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(9630),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_heredoc_body] = STATE(11018),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(3737),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(13352),
    [sym__splat_star] = ACTIONS(13354),
    [sym__unary_minus] = ACTIONS(13356),
    [sym__identifier_hash_key] = ACTIONS(13358),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(14917),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(13360),
    [anon_sym_yield] = ACTIONS(13362),
    [anon_sym_break] = ACTIONS(13364),
    [anon_sym_next] = ACTIONS(13366),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(14256),
    [anon_sym_defined_QMARK] = ACTIONS(13368),
    [anon_sym_not] = ACTIONS(13370),
    [anon_sym_BANG] = ACTIONS(13374),
    [anon_sym_TILDE] = ACTIONS(13374),
    [sym_constant] = ACTIONS(13376),
    [sym_identifier] = ACTIONS(13376),
    [sym_instance_variable] = ACTIONS(13378),
    [sym_class_variable] = ACTIONS(13378),
    [sym_global_variable] = ACTIONS(13378),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(13380),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13380),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [10590] = {
    [sym_heredoc_body] = STATE(11019),
    [aux_sym_call_repeat1] = STATE(11019),
    [aux_sym_argument_list_repeat1] = STATE(11020),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(14290),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_when] = ACTIONS(4383),
    [anon_sym_else] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [10591] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(11021),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(9629),
    [sym_scope_resolution] = STATE(9625),
    [sym_call] = STATE(9625),
    [sym_method_call] = STATE(9629),
    [sym_splat_argument] = STATE(11022),
    [sym_assignment] = STATE(11021),
    [sym_operator_assignment] = STATE(11021),
    [sym_conditional] = STATE(11021),
    [sym_range] = STATE(11021),
    [sym_binary] = STATE(11021),
    [sym_unary] = STATE(11021),
    [sym_right_assignment_list] = STATE(3742),
    [sym__arg_or_splat_arg] = STATE(11022),
    [sym_left_assignment_list] = STATE(9628),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9629),
    [sym__variable] = STATE(9625),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(9629),
    [sym_false] = STATE(9629),
    [sym_nil] = STATE(9629),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(10573),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__splat_star] = ACTIONS(14218),
    [sym__unary_minus] = ACTIONS(13356),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(13360),
    [anon_sym_yield] = ACTIONS(13362),
    [anon_sym_break] = ACTIONS(13364),
    [anon_sym_next] = ACTIONS(13366),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(14256),
    [anon_sym_defined_QMARK] = ACTIONS(13368),
    [anon_sym_not] = ACTIONS(13370),
    [anon_sym_BANG] = ACTIONS(13374),
    [anon_sym_TILDE] = ACTIONS(13374),
    [sym_constant] = ACTIONS(13380),
    [sym_identifier] = ACTIONS(13380),
    [sym_instance_variable] = ACTIONS(13378),
    [sym_class_variable] = ACTIONS(13378),
    [sym_global_variable] = ACTIONS(13378),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(13380),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13380),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [10592] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(11023),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(9629),
    [sym_scope_resolution] = STATE(9625),
    [sym_call] = STATE(9625),
    [sym_method_call] = STATE(9629),
    [sym_assignment] = STATE(11023),
    [sym_operator_assignment] = STATE(11023),
    [sym_conditional] = STATE(11023),
    [sym_range] = STATE(11023),
    [sym_binary] = STATE(11023),
    [sym_unary] = STATE(11023),
    [sym_left_assignment_list] = STATE(9628),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9629),
    [sym__variable] = STATE(9625),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(9629),
    [sym_false] = STATE(9629),
    [sym_nil] = STATE(9629),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(10573),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(13356),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(13360),
    [anon_sym_yield] = ACTIONS(13362),
    [anon_sym_break] = ACTIONS(13364),
    [anon_sym_next] = ACTIONS(13366),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(14256),
    [anon_sym_defined_QMARK] = ACTIONS(13368),
    [anon_sym_not] = ACTIONS(13370),
    [anon_sym_BANG] = ACTIONS(13374),
    [anon_sym_TILDE] = ACTIONS(13374),
    [sym_constant] = ACTIONS(13380),
    [sym_identifier] = ACTIONS(13380),
    [sym_instance_variable] = ACTIONS(13378),
    [sym_class_variable] = ACTIONS(13378),
    [sym_global_variable] = ACTIONS(13378),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(13380),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13380),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [10593] = {
    [sym_string] = STATE(11024),
    [aux_sym_chained_string_repeat1] = STATE(11024),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(747),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2755),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_EQ] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_end] = ACTIONS(2753),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_when] = ACTIONS(2753),
    [anon_sym_else] = ACTIONS(2753),
    [anon_sym_EQ_GT] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_PLUS_EQ] = ACTIONS(2753),
    [anon_sym_DASH_EQ] = ACTIONS(2753),
    [anon_sym_STAR_EQ] = ACTIONS(2753),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2753),
    [anon_sym_SLASH_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2753),
    [anon_sym_AMP_EQ] = ACTIONS(2753),
    [anon_sym_PERCENT_EQ] = ACTIONS(2753),
    [anon_sym_GT_GT_EQ] = ACTIONS(2753),
    [anon_sym_LT_LT_EQ] = ACTIONS(2753),
    [anon_sym_CARET_EQ] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2755),
    [anon_sym_AMP_AMP] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2755),
    [anon_sym_GT_GT] = ACTIONS(2755),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_SLASH] = ACTIONS(2755),
    [anon_sym_PERCENT] = ACTIONS(2755),
    [sym_comment] = ACTIONS(87),
  },
  [10594] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(11025),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(10601),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(10601),
    [sym_assignment] = STATE(11025),
    [sym_operator_assignment] = STATE(11025),
    [sym_conditional] = STATE(11025),
    [sym_range] = STATE(11025),
    [sym_binary] = STATE(11025),
    [sym_unary] = STATE(11025),
    [sym_left_assignment_list] = STATE(10600),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10601),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(10601),
    [sym_false] = STATE(10601),
    [sym_nil] = STATE(10601),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(10501),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(14302),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14160),
    [anon_sym_yield] = ACTIONS(14162),
    [anon_sym_break] = ACTIONS(14164),
    [anon_sym_next] = ACTIONS(14166),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14304),
    [anon_sym_defined_QMARK] = ACTIONS(14306),
    [anon_sym_not] = ACTIONS(14308),
    [anon_sym_BANG] = ACTIONS(14310),
    [anon_sym_TILDE] = ACTIONS(14310),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10595] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(11026),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(10601),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(10601),
    [sym_assignment] = STATE(11026),
    [sym_operator_assignment] = STATE(11026),
    [sym_conditional] = STATE(11026),
    [sym_range] = STATE(11026),
    [sym_binary] = STATE(11026),
    [sym_unary] = STATE(11026),
    [sym_left_assignment_list] = STATE(10600),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10601),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(10601),
    [sym_false] = STATE(10601),
    [sym_nil] = STATE(10601),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(10501),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(14302),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14160),
    [anon_sym_yield] = ACTIONS(14162),
    [anon_sym_break] = ACTIONS(14164),
    [anon_sym_next] = ACTIONS(14166),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14304),
    [anon_sym_defined_QMARK] = ACTIONS(14306),
    [anon_sym_not] = ACTIONS(14308),
    [anon_sym_BANG] = ACTIONS(14310),
    [anon_sym_TILDE] = ACTIONS(14310),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10596] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(11027),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(10601),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(10601),
    [sym_assignment] = STATE(11027),
    [sym_operator_assignment] = STATE(11027),
    [sym_conditional] = STATE(11027),
    [sym_range] = STATE(11027),
    [sym_binary] = STATE(11027),
    [sym_unary] = STATE(11027),
    [sym_left_assignment_list] = STATE(10600),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10601),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(10601),
    [sym_false] = STATE(10601),
    [sym_nil] = STATE(10601),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(10501),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(14302),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14160),
    [anon_sym_yield] = ACTIONS(14162),
    [anon_sym_break] = ACTIONS(14164),
    [anon_sym_next] = ACTIONS(14166),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14304),
    [anon_sym_defined_QMARK] = ACTIONS(14306),
    [anon_sym_not] = ACTIONS(14308),
    [anon_sym_BANG] = ACTIONS(14310),
    [anon_sym_TILDE] = ACTIONS(14310),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10597] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(298),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(10601),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(10601),
    [sym_assignment] = STATE(298),
    [sym_operator_assignment] = STATE(298),
    [sym_conditional] = STATE(298),
    [sym_range] = STATE(298),
    [sym_binary] = STATE(298),
    [sym_unary] = STATE(298),
    [sym_left_assignment_list] = STATE(10600),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10601),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(10601),
    [sym_false] = STATE(10601),
    [sym_nil] = STATE(10601),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(10501),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(14302),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14160),
    [anon_sym_yield] = ACTIONS(14162),
    [anon_sym_break] = ACTIONS(14164),
    [anon_sym_next] = ACTIONS(14166),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14304),
    [anon_sym_defined_QMARK] = ACTIONS(14306),
    [anon_sym_not] = ACTIONS(14308),
    [anon_sym_BANG] = ACTIONS(14310),
    [anon_sym_TILDE] = ACTIONS(14310),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10598] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(14919),
    [sym__binary_star] = ACTIONS(14921),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(14923),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(14921),
    [anon_sym_AMP] = ACTIONS(14925),
    [anon_sym_LT] = ACTIONS(14927),
    [anon_sym_end] = ACTIONS(5115),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_when] = ACTIONS(5115),
    [anon_sym_else] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(14929),
    [anon_sym_DOT_DOT] = ACTIONS(14931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14933),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(14935),
    [anon_sym_AMP_AMP] = ACTIONS(14935),
    [anon_sym_LT_LT] = ACTIONS(14937),
    [anon_sym_GT_GT] = ACTIONS(14937),
    [anon_sym_EQ_EQ] = ACTIONS(14939),
    [anon_sym_BANG_EQ] = ACTIONS(14935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14935),
    [anon_sym_LT_EQ_GT] = ACTIONS(14935),
    [anon_sym_EQ_TILDE] = ACTIONS(14935),
    [anon_sym_BANG_TILDE] = ACTIONS(14935),
    [anon_sym_LT_EQ] = ACTIONS(14927),
    [anon_sym_GT] = ACTIONS(14927),
    [anon_sym_GT_EQ] = ACTIONS(14941),
    [anon_sym_CARET] = ACTIONS(14943),
    [anon_sym_PLUS] = ACTIONS(14919),
    [anon_sym_SLASH] = ACTIONS(14921),
    [anon_sym_PERCENT] = ACTIONS(14921),
    [sym_comment] = ACTIONS(87),
  },
  [10599] = {
    [aux_sym_exceptions_repeat1] = STATE(11039),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_COMMA] = ACTIONS(14945),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_end] = ACTIONS(6191),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_when] = ACTIONS(6191),
    [anon_sym_else] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [10600] = {
    [anon_sym_EQ] = ACTIONS(14947),
    [sym_comment] = ACTIONS(87),
  },
  [10601] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(14949),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_when] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(14951),
    [anon_sym_DASH_EQ] = ACTIONS(14951),
    [anon_sym_STAR_EQ] = ACTIONS(14951),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14951),
    [anon_sym_SLASH_EQ] = ACTIONS(14951),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14951),
    [anon_sym_PIPE_EQ] = ACTIONS(14951),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14951),
    [anon_sym_AMP_EQ] = ACTIONS(14951),
    [anon_sym_PERCENT_EQ] = ACTIONS(14951),
    [anon_sym_GT_GT_EQ] = ACTIONS(14951),
    [anon_sym_LT_LT_EQ] = ACTIONS(14951),
    [anon_sym_CARET_EQ] = ACTIONS(14951),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [10602] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(13324),
    [sym__binary_star] = ACTIONS(13326),
    [anon_sym_PIPE] = ACTIONS(13328),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(13326),
    [anon_sym_AMP] = ACTIONS(13330),
    [anon_sym_LT] = ACTIONS(13332),
    [anon_sym_end] = ACTIONS(6210),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_when] = ACTIONS(6210),
    [anon_sym_else] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(13334),
    [anon_sym_DOT_DOT] = ACTIONS(13336),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13338),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(13342),
    [anon_sym_AMP_AMP] = ACTIONS(13342),
    [anon_sym_LT_LT] = ACTIONS(13344),
    [anon_sym_GT_GT] = ACTIONS(13344),
    [anon_sym_EQ_EQ] = ACTIONS(13346),
    [anon_sym_BANG_EQ] = ACTIONS(13342),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13342),
    [anon_sym_LT_EQ_GT] = ACTIONS(13342),
    [anon_sym_EQ_TILDE] = ACTIONS(13342),
    [anon_sym_BANG_TILDE] = ACTIONS(13342),
    [anon_sym_LT_EQ] = ACTIONS(13332),
    [anon_sym_GT] = ACTIONS(13332),
    [anon_sym_GT_EQ] = ACTIONS(13348),
    [anon_sym_CARET] = ACTIONS(13350),
    [anon_sym_PLUS] = ACTIONS(13324),
    [anon_sym_SLASH] = ACTIONS(13326),
    [anon_sym_PERCENT] = ACTIONS(13326),
    [sym_comment] = ACTIONS(87),
  },
  [10603] = {
    [sym_string] = STATE(10603),
    [aux_sym_chained_string_repeat1] = STATE(10603),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(6214),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_end] = ACTIONS(6212),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_when] = ACTIONS(6212),
    [anon_sym_else] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [10604] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(8637),
    [sym__binary_star] = ACTIONS(8639),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(8641),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(8639),
    [anon_sym_AMP] = ACTIONS(8643),
    [anon_sym_LT] = ACTIONS(8645),
    [anon_sym_then] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(8647),
    [anon_sym_DOT_DOT] = ACTIONS(8649),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8651),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(8655),
    [anon_sym_AMP_AMP] = ACTIONS(8655),
    [anon_sym_LT_LT] = ACTIONS(8657),
    [anon_sym_GT_GT] = ACTIONS(8657),
    [anon_sym_EQ_EQ] = ACTIONS(8659),
    [anon_sym_BANG_EQ] = ACTIONS(8655),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8655),
    [anon_sym_LT_EQ_GT] = ACTIONS(8655),
    [anon_sym_EQ_TILDE] = ACTIONS(8655),
    [anon_sym_BANG_TILDE] = ACTIONS(8655),
    [anon_sym_LT_EQ] = ACTIONS(8645),
    [anon_sym_GT] = ACTIONS(8645),
    [anon_sym_GT_EQ] = ACTIONS(8661),
    [anon_sym_CARET] = ACTIONS(8663),
    [anon_sym_PLUS] = ACTIONS(8637),
    [anon_sym_SLASH] = ACTIONS(8639),
    [anon_sym_PERCENT] = ACTIONS(8639),
    [sym_comment] = ACTIONS(87),
  },
  [10605] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(13399),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13403),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(13403),
    [anon_sym_PERCENT] = ACTIONS(13403),
    [sym_comment] = ACTIONS(87),
  },
  [10606] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13403),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(5827),
    [anon_sym_PERCENT] = ACTIONS(5827),
    [sym_comment] = ACTIONS(87),
  },
  [10607] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(13397),
    [sym__binary_star] = ACTIONS(13399),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13403),
    [anon_sym_AMP] = ACTIONS(13405),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(13417),
    [anon_sym_GT_GT] = ACTIONS(13417),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(13423),
    [anon_sym_SLASH] = ACTIONS(13403),
    [anon_sym_PERCENT] = ACTIONS(13403),
    [sym_comment] = ACTIONS(87),
  },
  [10608] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(13397),
    [sym__binary_star] = ACTIONS(13399),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13403),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(13417),
    [anon_sym_GT_GT] = ACTIONS(13417),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(13423),
    [anon_sym_SLASH] = ACTIONS(13403),
    [anon_sym_PERCENT] = ACTIONS(13403),
    [sym_comment] = ACTIONS(87),
  },
  [10609] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(13397),
    [sym__binary_star] = ACTIONS(13399),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(13401),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13403),
    [anon_sym_AMP] = ACTIONS(13405),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(13417),
    [anon_sym_GT_GT] = ACTIONS(13417),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(13401),
    [anon_sym_PLUS] = ACTIONS(13423),
    [anon_sym_SLASH] = ACTIONS(13403),
    [anon_sym_PERCENT] = ACTIONS(13403),
    [sym_comment] = ACTIONS(87),
  },
  [10610] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(14953),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [10611] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(13397),
    [sym__binary_star] = ACTIONS(13399),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(13401),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(13403),
    [anon_sym_AMP] = ACTIONS(13405),
    [anon_sym_EQ] = ACTIONS(7888),
    [anon_sym_LT] = ACTIONS(13407),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_then] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_PLUS_EQ] = ACTIONS(5927),
    [anon_sym_DASH_EQ] = ACTIONS(5927),
    [anon_sym_STAR_EQ] = ACTIONS(5927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5927),
    [anon_sym_SLASH_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5927),
    [anon_sym_AMP_EQ] = ACTIONS(5927),
    [anon_sym_PERCENT_EQ] = ACTIONS(5927),
    [anon_sym_GT_GT_EQ] = ACTIONS(5927),
    [anon_sym_LT_LT_EQ] = ACTIONS(5927),
    [anon_sym_CARET_EQ] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(13411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13413),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(13415),
    [anon_sym_AMP_AMP] = ACTIONS(13415),
    [anon_sym_LT_LT] = ACTIONS(13417),
    [anon_sym_GT_GT] = ACTIONS(13417),
    [anon_sym_EQ_EQ] = ACTIONS(13415),
    [anon_sym_BANG_EQ] = ACTIONS(13419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13419),
    [anon_sym_LT_EQ_GT] = ACTIONS(13419),
    [anon_sym_EQ_TILDE] = ACTIONS(13419),
    [anon_sym_BANG_TILDE] = ACTIONS(13419),
    [anon_sym_LT_EQ] = ACTIONS(13407),
    [anon_sym_GT] = ACTIONS(13407),
    [anon_sym_GT_EQ] = ACTIONS(13421),
    [anon_sym_CARET] = ACTIONS(13401),
    [anon_sym_PLUS] = ACTIONS(13423),
    [anon_sym_SLASH] = ACTIONS(13403),
    [anon_sym_PERCENT] = ACTIONS(13403),
    [sym_comment] = ACTIONS(87),
  },
  [10612] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(13397),
    [sym__binary_star] = ACTIONS(13399),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(13401),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13403),
    [anon_sym_AMP] = ACTIONS(13405),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(13407),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(13409),
    [anon_sym_DOT_DOT] = ACTIONS(13411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13413),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(13415),
    [anon_sym_AMP_AMP] = ACTIONS(13415),
    [anon_sym_LT_LT] = ACTIONS(13417),
    [anon_sym_GT_GT] = ACTIONS(13417),
    [anon_sym_EQ_EQ] = ACTIONS(13415),
    [anon_sym_BANG_EQ] = ACTIONS(13419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13419),
    [anon_sym_LT_EQ_GT] = ACTIONS(13419),
    [anon_sym_EQ_TILDE] = ACTIONS(13419),
    [anon_sym_BANG_TILDE] = ACTIONS(13419),
    [anon_sym_LT_EQ] = ACTIONS(13407),
    [anon_sym_GT] = ACTIONS(13407),
    [anon_sym_GT_EQ] = ACTIONS(13421),
    [anon_sym_CARET] = ACTIONS(13401),
    [anon_sym_PLUS] = ACTIONS(13423),
    [anon_sym_SLASH] = ACTIONS(13403),
    [anon_sym_PERCENT] = ACTIONS(13403),
    [sym_comment] = ACTIONS(87),
  },
  [10613] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(13397),
    [sym__binary_star] = ACTIONS(13399),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(13401),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13403),
    [anon_sym_AMP] = ACTIONS(13405),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(13407),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(13417),
    [anon_sym_GT_GT] = ACTIONS(13417),
    [anon_sym_EQ_EQ] = ACTIONS(13415),
    [anon_sym_BANG_EQ] = ACTIONS(13419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13419),
    [anon_sym_LT_EQ_GT] = ACTIONS(13419),
    [anon_sym_EQ_TILDE] = ACTIONS(13419),
    [anon_sym_BANG_TILDE] = ACTIONS(13419),
    [anon_sym_LT_EQ] = ACTIONS(13407),
    [anon_sym_GT] = ACTIONS(13407),
    [anon_sym_GT_EQ] = ACTIONS(13421),
    [anon_sym_CARET] = ACTIONS(13401),
    [anon_sym_PLUS] = ACTIONS(13423),
    [anon_sym_SLASH] = ACTIONS(13403),
    [anon_sym_PERCENT] = ACTIONS(13403),
    [sym_comment] = ACTIONS(87),
  },
  [10614] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(13397),
    [sym__binary_star] = ACTIONS(13399),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13403),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(13423),
    [anon_sym_SLASH] = ACTIONS(13403),
    [anon_sym_PERCENT] = ACTIONS(13403),
    [sym_comment] = ACTIONS(87),
  },
  [10615] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(13397),
    [sym__binary_star] = ACTIONS(13399),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(13401),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(13403),
    [anon_sym_AMP] = ACTIONS(13405),
    [anon_sym_EQ] = ACTIONS(7936),
    [anon_sym_LT] = ACTIONS(13407),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_then] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_PLUS_EQ] = ACTIONS(5115),
    [anon_sym_DASH_EQ] = ACTIONS(5115),
    [anon_sym_STAR_EQ] = ACTIONS(5115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5115),
    [anon_sym_SLASH_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5115),
    [anon_sym_AMP_EQ] = ACTIONS(5115),
    [anon_sym_PERCENT_EQ] = ACTIONS(5115),
    [anon_sym_GT_GT_EQ] = ACTIONS(5115),
    [anon_sym_LT_LT_EQ] = ACTIONS(5115),
    [anon_sym_CARET_EQ] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(13409),
    [anon_sym_DOT_DOT] = ACTIONS(13411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13413),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(13415),
    [anon_sym_AMP_AMP] = ACTIONS(13415),
    [anon_sym_LT_LT] = ACTIONS(13417),
    [anon_sym_GT_GT] = ACTIONS(13417),
    [anon_sym_EQ_EQ] = ACTIONS(13415),
    [anon_sym_BANG_EQ] = ACTIONS(13419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13419),
    [anon_sym_LT_EQ_GT] = ACTIONS(13419),
    [anon_sym_EQ_TILDE] = ACTIONS(13419),
    [anon_sym_BANG_TILDE] = ACTIONS(13419),
    [anon_sym_LT_EQ] = ACTIONS(13407),
    [anon_sym_GT] = ACTIONS(13407),
    [anon_sym_GT_EQ] = ACTIONS(13421),
    [anon_sym_CARET] = ACTIONS(13401),
    [anon_sym_PLUS] = ACTIONS(13423),
    [anon_sym_SLASH] = ACTIONS(13403),
    [anon_sym_PERCENT] = ACTIONS(13403),
    [sym_comment] = ACTIONS(87),
  },
  [10616] = {
    [aux_sym_exceptions_repeat1] = STATE(11044),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6193),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_then] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_PLUS_EQ] = ACTIONS(6191),
    [anon_sym_DASH_EQ] = ACTIONS(6191),
    [anon_sym_STAR_EQ] = ACTIONS(6191),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6191),
    [anon_sym_SLASH_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6191),
    [anon_sym_AMP_EQ] = ACTIONS(6191),
    [anon_sym_PERCENT_EQ] = ACTIONS(6191),
    [anon_sym_GT_GT_EQ] = ACTIONS(6191),
    [anon_sym_LT_LT_EQ] = ACTIONS(6191),
    [anon_sym_CARET_EQ] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6193),
    [anon_sym_AMP_AMP] = ACTIONS(6193),
    [anon_sym_LT_LT] = ACTIONS(6193),
    [anon_sym_GT_GT] = ACTIONS(6193),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6193),
    [anon_sym_PLUS] = ACTIONS(6193),
    [anon_sym_SLASH] = ACTIONS(6193),
    [anon_sym_PERCENT] = ACTIONS(6193),
    [sym_comment] = ACTIONS(87),
  },
  [10617] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(13397),
    [sym__binary_star] = ACTIONS(13399),
    [anon_sym_LBRACE] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(13401),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(13403),
    [anon_sym_AMP] = ACTIONS(13405),
    [anon_sym_EQ] = ACTIONS(7938),
    [anon_sym_LT] = ACTIONS(13407),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_then] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_PLUS_EQ] = ACTIONS(6210),
    [anon_sym_DASH_EQ] = ACTIONS(6210),
    [anon_sym_STAR_EQ] = ACTIONS(6210),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6210),
    [anon_sym_SLASH_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6210),
    [anon_sym_AMP_EQ] = ACTIONS(6210),
    [anon_sym_PERCENT_EQ] = ACTIONS(6210),
    [anon_sym_GT_GT_EQ] = ACTIONS(6210),
    [anon_sym_LT_LT_EQ] = ACTIONS(6210),
    [anon_sym_CARET_EQ] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(13409),
    [anon_sym_DOT_DOT] = ACTIONS(13411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13413),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(13415),
    [anon_sym_AMP_AMP] = ACTIONS(13415),
    [anon_sym_LT_LT] = ACTIONS(13417),
    [anon_sym_GT_GT] = ACTIONS(13417),
    [anon_sym_EQ_EQ] = ACTIONS(13415),
    [anon_sym_BANG_EQ] = ACTIONS(13419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13419),
    [anon_sym_LT_EQ_GT] = ACTIONS(13419),
    [anon_sym_EQ_TILDE] = ACTIONS(13419),
    [anon_sym_BANG_TILDE] = ACTIONS(13419),
    [anon_sym_LT_EQ] = ACTIONS(13407),
    [anon_sym_GT] = ACTIONS(13407),
    [anon_sym_GT_EQ] = ACTIONS(13421),
    [anon_sym_CARET] = ACTIONS(13401),
    [anon_sym_PLUS] = ACTIONS(13423),
    [anon_sym_SLASH] = ACTIONS(13403),
    [anon_sym_PERCENT] = ACTIONS(13403),
    [sym_comment] = ACTIONS(87),
  },
  [10618] = {
    [sym_string] = STATE(10618),
    [aux_sym_chained_string_repeat1] = STATE(10618),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(12267),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6217),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_EQ] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_do] = ACTIONS(6212),
    [anon_sym_then] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_PLUS_EQ] = ACTIONS(6212),
    [anon_sym_DASH_EQ] = ACTIONS(6212),
    [anon_sym_STAR_EQ] = ACTIONS(6212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6212),
    [anon_sym_SLASH_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6212),
    [anon_sym_AMP_EQ] = ACTIONS(6212),
    [anon_sym_PERCENT_EQ] = ACTIONS(6212),
    [anon_sym_GT_GT_EQ] = ACTIONS(6212),
    [anon_sym_LT_LT_EQ] = ACTIONS(6212),
    [anon_sym_CARET_EQ] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6217),
    [anon_sym_AMP_AMP] = ACTIONS(6217),
    [anon_sym_LT_LT] = ACTIONS(6217),
    [anon_sym_GT_GT] = ACTIONS(6217),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6217),
    [anon_sym_PLUS] = ACTIONS(6217),
    [anon_sym_SLASH] = ACTIONS(6217),
    [anon_sym_PERCENT] = ACTIONS(6217),
    [sym_comment] = ACTIONS(87),
  },
  [10619] = {
    [aux_sym_exceptions_repeat1] = STATE(10619),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_COMMA] = ACTIONS(14955),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_then] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [10620] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(8691),
    [sym__binary_star] = ACTIONS(8693),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(8695),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(8693),
    [anon_sym_AMP] = ACTIONS(8697),
    [anon_sym_LT] = ACTIONS(8699),
    [anon_sym_end] = ACTIONS(12120),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_else] = ACTIONS(12120),
    [anon_sym_ensure] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(8701),
    [anon_sym_DOT_DOT] = ACTIONS(8703),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8705),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(8707),
    [anon_sym_AMP_AMP] = ACTIONS(8707),
    [anon_sym_LT_LT] = ACTIONS(8709),
    [anon_sym_GT_GT] = ACTIONS(8709),
    [anon_sym_EQ_EQ] = ACTIONS(8711),
    [anon_sym_BANG_EQ] = ACTIONS(8707),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8707),
    [anon_sym_LT_EQ_GT] = ACTIONS(8707),
    [anon_sym_EQ_TILDE] = ACTIONS(8707),
    [anon_sym_BANG_TILDE] = ACTIONS(8707),
    [anon_sym_LT_EQ] = ACTIONS(8699),
    [anon_sym_GT] = ACTIONS(8699),
    [anon_sym_GT_EQ] = ACTIONS(8713),
    [anon_sym_CARET] = ACTIONS(8715),
    [anon_sym_PLUS] = ACTIONS(8691),
    [anon_sym_SLASH] = ACTIONS(8693),
    [anon_sym_PERCENT] = ACTIONS(8693),
    [sym_comment] = ACTIONS(87),
  },
  [10621] = {
    [aux_sym_exceptions_repeat1] = STATE(10621),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(14958),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_end] = ACTIONS(11597),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_else] = ACTIONS(11597),
    [anon_sym_ensure] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [10622] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(8747),
    [sym__binary_star] = ACTIONS(8749),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(8751),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(8749),
    [anon_sym_AMP] = ACTIONS(8753),
    [anon_sym_LT] = ACTIONS(8755),
    [anon_sym_then] = ACTIONS(12120),
    [anon_sym_EQ_GT] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(8757),
    [anon_sym_DOT_DOT] = ACTIONS(8759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8761),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(8763),
    [anon_sym_AMP_AMP] = ACTIONS(8763),
    [anon_sym_LT_LT] = ACTIONS(8765),
    [anon_sym_GT_GT] = ACTIONS(8765),
    [anon_sym_EQ_EQ] = ACTIONS(8767),
    [anon_sym_BANG_EQ] = ACTIONS(8763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8763),
    [anon_sym_LT_EQ_GT] = ACTIONS(8763),
    [anon_sym_EQ_TILDE] = ACTIONS(8763),
    [anon_sym_BANG_TILDE] = ACTIONS(8763),
    [anon_sym_LT_EQ] = ACTIONS(8755),
    [anon_sym_GT] = ACTIONS(8755),
    [anon_sym_GT_EQ] = ACTIONS(8769),
    [anon_sym_CARET] = ACTIONS(8771),
    [anon_sym_PLUS] = ACTIONS(8747),
    [anon_sym_SLASH] = ACTIONS(8749),
    [anon_sym_PERCENT] = ACTIONS(8749),
    [sym_comment] = ACTIONS(87),
  },
  [10623] = {
    [aux_sym_exceptions_repeat1] = STATE(10623),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(14961),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_then] = ACTIONS(11597),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [10624] = {
    [sym__line_break] = ACTIONS(7876),
    [sym__simple_symbol] = ACTIONS(7876),
    [sym__string_start] = ACTIONS(7876),
    [sym__symbol_start] = ACTIONS(7876),
    [sym__subshell_start] = ACTIONS(7876),
    [sym__regex_start] = ACTIONS(7876),
    [sym__string_array_start] = ACTIONS(7876),
    [sym__symbol_array_start] = ACTIONS(7876),
    [sym__heredoc_body_start] = ACTIONS(7876),
    [sym_heredoc_beginning] = ACTIONS(7876),
    [sym__block_ampersand] = ACTIONS(7876),
    [sym__splat_star] = ACTIONS(7876),
    [sym__unary_minus] = ACTIONS(7876),
    [sym__identifier_hash_key] = ACTIONS(7876),
    [anon_sym_LBRACE] = ACTIONS(7876),
    [anon_sym_def] = ACTIONS(7878),
    [anon_sym_LPAREN] = ACTIONS(7878),
    [anon_sym_DOT] = ACTIONS(7876),
    [anon_sym_COLON_COLON] = ACTIONS(7878),
    [anon_sym_SEMI] = ACTIONS(7876),
    [anon_sym_STAR] = ACTIONS(7878),
    [anon_sym_STAR_STAR] = ACTIONS(7876),
    [anon_sym_class] = ACTIONS(7878),
    [anon_sym_module] = ACTIONS(7878),
    [anon_sym_return] = ACTIONS(7878),
    [anon_sym_yield] = ACTIONS(7878),
    [anon_sym_break] = ACTIONS(7878),
    [anon_sym_next] = ACTIONS(7878),
    [sym_redo] = ACTIONS(7878),
    [sym_retry] = ACTIONS(7878),
    [anon_sym_if] = ACTIONS(7878),
    [anon_sym_unless] = ACTIONS(7878),
    [anon_sym_while] = ACTIONS(7878),
    [anon_sym_until] = ACTIONS(7878),
    [anon_sym_for] = ACTIONS(7878),
    [anon_sym_do] = ACTIONS(7878),
    [anon_sym_case] = ACTIONS(7878),
    [anon_sym_then] = ACTIONS(7878),
    [anon_sym_begin] = ACTIONS(7878),
    [anon_sym_LBRACK] = ACTIONS(7876),
    [anon_sym_COLON_COLON2] = ACTIONS(7876),
    [anon_sym_AMP_DOT] = ACTIONS(7876),
    [anon_sym_LPAREN2] = ACTIONS(7876),
    [anon_sym_PLUS] = ACTIONS(7878),
    [anon_sym_defined_QMARK] = ACTIONS(7876),
    [anon_sym_not] = ACTIONS(7878),
    [anon_sym_BANG] = ACTIONS(7876),
    [anon_sym_TILDE] = ACTIONS(7876),
    [sym_constant] = ACTIONS(7878),
    [sym_identifier] = ACTIONS(7878),
    [sym_instance_variable] = ACTIONS(7876),
    [sym_class_variable] = ACTIONS(7876),
    [sym_global_variable] = ACTIONS(7876),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(7878),
    [sym_float] = ACTIONS(7878),
    [sym_complex] = ACTIONS(7876),
    [sym_super] = ACTIONS(7878),
    [anon_sym_true] = ACTIONS(7878),
    [anon_sym_TRUE] = ACTIONS(7878),
    [anon_sym_false] = ACTIONS(7878),
    [anon_sym_FALSE] = ACTIONS(7878),
    [sym_self] = ACTIONS(7878),
    [anon_sym_nil] = ACTIONS(7878),
    [anon_sym_NIL] = ACTIONS(7878),
    [sym_character] = ACTIONS(7876),
    [anon_sym_LBRACK2] = ACTIONS(7878),
    [anon_sym_DASH_GT] = ACTIONS(7876),
  },
  [10625] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(13462),
    [sym__binary_star] = ACTIONS(13464),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(13466),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(13464),
    [anon_sym_AMP] = ACTIONS(13468),
    [anon_sym_LT] = ACTIONS(13470),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_then] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(13472),
    [anon_sym_DOT_DOT] = ACTIONS(13474),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13476),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(13480),
    [anon_sym_AMP_AMP] = ACTIONS(13480),
    [anon_sym_LT_LT] = ACTIONS(13482),
    [anon_sym_GT_GT] = ACTIONS(13482),
    [anon_sym_EQ_EQ] = ACTIONS(13484),
    [anon_sym_BANG_EQ] = ACTIONS(13480),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13480),
    [anon_sym_LT_EQ_GT] = ACTIONS(13480),
    [anon_sym_EQ_TILDE] = ACTIONS(13480),
    [anon_sym_BANG_TILDE] = ACTIONS(13480),
    [anon_sym_LT_EQ] = ACTIONS(13470),
    [anon_sym_GT] = ACTIONS(13470),
    [anon_sym_GT_EQ] = ACTIONS(13486),
    [anon_sym_CARET] = ACTIONS(13488),
    [anon_sym_PLUS] = ACTIONS(13462),
    [anon_sym_SLASH] = ACTIONS(13464),
    [anon_sym_PERCENT] = ACTIONS(13464),
    [sym_comment] = ACTIONS(87),
  },
  [10626] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(13462),
    [sym__binary_star] = ACTIONS(13464),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(13466),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(13464),
    [anon_sym_AMP] = ACTIONS(13468),
    [anon_sym_LT] = ACTIONS(13470),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_then] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(13472),
    [anon_sym_DOT_DOT] = ACTIONS(13474),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13476),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(13480),
    [anon_sym_AMP_AMP] = ACTIONS(13480),
    [anon_sym_LT_LT] = ACTIONS(13482),
    [anon_sym_GT_GT] = ACTIONS(13482),
    [anon_sym_EQ_EQ] = ACTIONS(13484),
    [anon_sym_BANG_EQ] = ACTIONS(13480),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13480),
    [anon_sym_LT_EQ_GT] = ACTIONS(13480),
    [anon_sym_EQ_TILDE] = ACTIONS(13480),
    [anon_sym_BANG_TILDE] = ACTIONS(13480),
    [anon_sym_LT_EQ] = ACTIONS(13470),
    [anon_sym_GT] = ACTIONS(13470),
    [anon_sym_GT_EQ] = ACTIONS(13486),
    [anon_sym_CARET] = ACTIONS(13488),
    [anon_sym_PLUS] = ACTIONS(13462),
    [anon_sym_SLASH] = ACTIONS(13464),
    [anon_sym_PERCENT] = ACTIONS(13464),
    [sym_comment] = ACTIONS(87),
  },
  [10627] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(11045),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(8037),
    [sym_scope_resolution] = STATE(7955),
    [sym_call] = STATE(7955),
    [sym_method_call] = STATE(8037),
    [sym_assignment] = STATE(11045),
    [sym_operator_assignment] = STATE(11045),
    [sym_conditional] = STATE(11045),
    [sym_range] = STATE(11045),
    [sym_binary] = STATE(11045),
    [sym_unary] = STATE(11045),
    [sym_left_assignment_list] = STATE(8036),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(8037),
    [sym__variable] = STATE(7955),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(8037),
    [sym_false] = STATE(8037),
    [sym_nil] = STATE(8037),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(8038),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11513),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11515),
    [anon_sym_yield] = ACTIONS(11517),
    [anon_sym_break] = ACTIONS(11519),
    [anon_sym_next] = ACTIONS(11521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11523),
    [anon_sym_defined_QMARK] = ACTIONS(11525),
    [anon_sym_not] = ACTIONS(11527),
    [anon_sym_BANG] = ACTIONS(11529),
    [anon_sym_TILDE] = ACTIONS(11529),
    [sym_constant] = ACTIONS(11478),
    [sym_identifier] = ACTIONS(11478),
    [sym_instance_variable] = ACTIONS(11480),
    [sym_class_variable] = ACTIONS(11480),
    [sym_global_variable] = ACTIONS(11480),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11478),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11478),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10628] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(13462),
    [sym__binary_star] = ACTIONS(13464),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(13466),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(13464),
    [anon_sym_AMP] = ACTIONS(13468),
    [anon_sym_LT] = ACTIONS(13470),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_then] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(13472),
    [anon_sym_DOT_DOT] = ACTIONS(13474),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13476),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(13480),
    [anon_sym_AMP_AMP] = ACTIONS(13480),
    [anon_sym_LT_LT] = ACTIONS(13482),
    [anon_sym_GT_GT] = ACTIONS(13482),
    [anon_sym_EQ_EQ] = ACTIONS(13484),
    [anon_sym_BANG_EQ] = ACTIONS(13480),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13480),
    [anon_sym_LT_EQ_GT] = ACTIONS(13480),
    [anon_sym_EQ_TILDE] = ACTIONS(13480),
    [anon_sym_BANG_TILDE] = ACTIONS(13480),
    [anon_sym_LT_EQ] = ACTIONS(13470),
    [anon_sym_GT] = ACTIONS(13470),
    [anon_sym_GT_EQ] = ACTIONS(13486),
    [anon_sym_CARET] = ACTIONS(13488),
    [anon_sym_PLUS] = ACTIONS(13462),
    [anon_sym_SLASH] = ACTIONS(13464),
    [anon_sym_PERCENT] = ACTIONS(13464),
    [sym_comment] = ACTIONS(87),
  },
  [10629] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(11046),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(8037),
    [sym_scope_resolution] = STATE(7955),
    [sym_call] = STATE(7955),
    [sym_method_call] = STATE(8037),
    [sym_assignment] = STATE(11046),
    [sym_operator_assignment] = STATE(11046),
    [sym_conditional] = STATE(11046),
    [sym_range] = STATE(11046),
    [sym_binary] = STATE(11046),
    [sym_unary] = STATE(11046),
    [sym_left_assignment_list] = STATE(8036),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(8037),
    [sym__variable] = STATE(7955),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(8037),
    [sym_false] = STATE(8037),
    [sym_nil] = STATE(8037),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(8038),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11513),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11515),
    [anon_sym_yield] = ACTIONS(11517),
    [anon_sym_break] = ACTIONS(11519),
    [anon_sym_next] = ACTIONS(11521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11523),
    [anon_sym_defined_QMARK] = ACTIONS(11525),
    [anon_sym_not] = ACTIONS(11527),
    [anon_sym_BANG] = ACTIONS(11529),
    [anon_sym_TILDE] = ACTIONS(11529),
    [sym_constant] = ACTIONS(11478),
    [sym_identifier] = ACTIONS(11478),
    [sym_instance_variable] = ACTIONS(11480),
    [sym_class_variable] = ACTIONS(11480),
    [sym_global_variable] = ACTIONS(11480),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11478),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11478),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10630] = {
    [sym_heredoc_body] = STATE(11047),
    [aux_sym_call_repeat1] = STATE(11047),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_then] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [10631] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9681),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5621),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(5621),
    [sym__argument] = STATE(2565),
    [sym_splat_argument] = STATE(2565),
    [sym_hash_splat_argument] = STATE(2565),
    [sym_block_argument] = STATE(2565),
    [sym_assignment] = STATE(9681),
    [sym_operator_assignment] = STATE(9681),
    [sym_conditional] = STATE(9681),
    [sym_range] = STATE(9681),
    [sym_binary] = STATE(9681),
    [sym_unary] = STATE(9681),
    [sym_left_assignment_list] = STATE(5620),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5621),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5621),
    [sym_false] = STATE(5621),
    [sym_nil] = STATE(5621),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(9684),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(11048),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2565),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(13454),
    [sym__splat_star] = ACTIONS(13456),
    [sym__unary_minus] = ACTIONS(8791),
    [sym__identifier_hash_key] = ACTIONS(13458),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(14964),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8799),
    [anon_sym_yield] = ACTIONS(8801),
    [anon_sym_break] = ACTIONS(8803),
    [anon_sym_next] = ACTIONS(8805),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8809),
    [anon_sym_defined_QMARK] = ACTIONS(8811),
    [anon_sym_not] = ACTIONS(8813),
    [anon_sym_BANG] = ACTIONS(8815),
    [anon_sym_TILDE] = ACTIONS(8815),
    [sym_constant] = ACTIONS(13460),
    [sym_identifier] = ACTIONS(13460),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10632] = {
    [sym_heredoc_body] = STATE(11049),
    [aux_sym_call_repeat1] = STATE(11049),
    [aux_sym_argument_list_repeat1] = STATE(11050),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(14330),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_then] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [10633] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(13464),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13464),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(13464),
    [anon_sym_PERCENT] = ACTIONS(13464),
    [sym_comment] = ACTIONS(87),
  },
  [10634] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13464),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [10635] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(13462),
    [sym__binary_star] = ACTIONS(13464),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13464),
    [anon_sym_AMP] = ACTIONS(13468),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(13482),
    [anon_sym_GT_GT] = ACTIONS(13482),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(13462),
    [anon_sym_SLASH] = ACTIONS(13464),
    [anon_sym_PERCENT] = ACTIONS(13464),
    [sym_comment] = ACTIONS(87),
  },
  [10636] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(13462),
    [sym__binary_star] = ACTIONS(13464),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13464),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(13482),
    [anon_sym_GT_GT] = ACTIONS(13482),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(13462),
    [anon_sym_SLASH] = ACTIONS(13464),
    [anon_sym_PERCENT] = ACTIONS(13464),
    [sym_comment] = ACTIONS(87),
  },
  [10637] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(13462),
    [sym__binary_star] = ACTIONS(13464),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(13466),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13464),
    [anon_sym_AMP] = ACTIONS(13468),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(13482),
    [anon_sym_GT_GT] = ACTIONS(13482),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(13488),
    [anon_sym_PLUS] = ACTIONS(13462),
    [anon_sym_SLASH] = ACTIONS(13464),
    [anon_sym_PERCENT] = ACTIONS(13464),
    [sym_comment] = ACTIONS(87),
  },
  [10638] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(14966),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [10639] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(13462),
    [sym__binary_star] = ACTIONS(13464),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(13466),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(13464),
    [anon_sym_AMP] = ACTIONS(13468),
    [anon_sym_LT] = ACTIONS(13470),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_then] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(13474),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13476),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(13480),
    [anon_sym_AMP_AMP] = ACTIONS(13480),
    [anon_sym_LT_LT] = ACTIONS(13482),
    [anon_sym_GT_GT] = ACTIONS(13482),
    [anon_sym_EQ_EQ] = ACTIONS(13484),
    [anon_sym_BANG_EQ] = ACTIONS(13480),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13480),
    [anon_sym_LT_EQ_GT] = ACTIONS(13480),
    [anon_sym_EQ_TILDE] = ACTIONS(13480),
    [anon_sym_BANG_TILDE] = ACTIONS(13480),
    [anon_sym_LT_EQ] = ACTIONS(13470),
    [anon_sym_GT] = ACTIONS(13470),
    [anon_sym_GT_EQ] = ACTIONS(13486),
    [anon_sym_CARET] = ACTIONS(13488),
    [anon_sym_PLUS] = ACTIONS(13462),
    [anon_sym_SLASH] = ACTIONS(13464),
    [anon_sym_PERCENT] = ACTIONS(13464),
    [sym_comment] = ACTIONS(87),
  },
  [10640] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(13462),
    [sym__binary_star] = ACTIONS(13464),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(13466),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13464),
    [anon_sym_AMP] = ACTIONS(13468),
    [anon_sym_LT] = ACTIONS(13470),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(13472),
    [anon_sym_DOT_DOT] = ACTIONS(13474),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13476),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(13480),
    [anon_sym_AMP_AMP] = ACTIONS(13480),
    [anon_sym_LT_LT] = ACTIONS(13482),
    [anon_sym_GT_GT] = ACTIONS(13482),
    [anon_sym_EQ_EQ] = ACTIONS(13484),
    [anon_sym_BANG_EQ] = ACTIONS(13480),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13480),
    [anon_sym_LT_EQ_GT] = ACTIONS(13480),
    [anon_sym_EQ_TILDE] = ACTIONS(13480),
    [anon_sym_BANG_TILDE] = ACTIONS(13480),
    [anon_sym_LT_EQ] = ACTIONS(13470),
    [anon_sym_GT] = ACTIONS(13470),
    [anon_sym_GT_EQ] = ACTIONS(13486),
    [anon_sym_CARET] = ACTIONS(13488),
    [anon_sym_PLUS] = ACTIONS(13462),
    [anon_sym_SLASH] = ACTIONS(13464),
    [anon_sym_PERCENT] = ACTIONS(13464),
    [sym_comment] = ACTIONS(87),
  },
  [10641] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(13462),
    [sym__binary_star] = ACTIONS(13464),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(13466),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13464),
    [anon_sym_AMP] = ACTIONS(13468),
    [anon_sym_LT] = ACTIONS(13470),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(13482),
    [anon_sym_GT_GT] = ACTIONS(13482),
    [anon_sym_EQ_EQ] = ACTIONS(13484),
    [anon_sym_BANG_EQ] = ACTIONS(13480),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13480),
    [anon_sym_LT_EQ_GT] = ACTIONS(13480),
    [anon_sym_EQ_TILDE] = ACTIONS(13480),
    [anon_sym_BANG_TILDE] = ACTIONS(13480),
    [anon_sym_LT_EQ] = ACTIONS(13470),
    [anon_sym_GT] = ACTIONS(13470),
    [anon_sym_GT_EQ] = ACTIONS(13486),
    [anon_sym_CARET] = ACTIONS(13488),
    [anon_sym_PLUS] = ACTIONS(13462),
    [anon_sym_SLASH] = ACTIONS(13464),
    [anon_sym_PERCENT] = ACTIONS(13464),
    [sym_comment] = ACTIONS(87),
  },
  [10642] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(13462),
    [sym__binary_star] = ACTIONS(13464),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13464),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_then] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(13462),
    [anon_sym_SLASH] = ACTIONS(13464),
    [anon_sym_PERCENT] = ACTIONS(13464),
    [sym_comment] = ACTIONS(87),
  },
  [10643] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(13462),
    [sym__binary_star] = ACTIONS(13464),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(13466),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(13464),
    [anon_sym_AMP] = ACTIONS(13468),
    [anon_sym_LT] = ACTIONS(13470),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_then] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(13472),
    [anon_sym_DOT_DOT] = ACTIONS(13474),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13476),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(13480),
    [anon_sym_AMP_AMP] = ACTIONS(13480),
    [anon_sym_LT_LT] = ACTIONS(13482),
    [anon_sym_GT_GT] = ACTIONS(13482),
    [anon_sym_EQ_EQ] = ACTIONS(13484),
    [anon_sym_BANG_EQ] = ACTIONS(13480),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13480),
    [anon_sym_LT_EQ_GT] = ACTIONS(13480),
    [anon_sym_EQ_TILDE] = ACTIONS(13480),
    [anon_sym_BANG_TILDE] = ACTIONS(13480),
    [anon_sym_LT_EQ] = ACTIONS(13470),
    [anon_sym_GT] = ACTIONS(13470),
    [anon_sym_GT_EQ] = ACTIONS(13486),
    [anon_sym_CARET] = ACTIONS(13488),
    [anon_sym_PLUS] = ACTIONS(13462),
    [anon_sym_SLASH] = ACTIONS(13464),
    [anon_sym_PERCENT] = ACTIONS(13464),
    [sym_comment] = ACTIONS(87),
  },
  [10644] = {
    [aux_sym_exceptions_repeat1] = STATE(11053),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_then] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [10645] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(13462),
    [sym__binary_star] = ACTIONS(13464),
    [anon_sym_LBRACE] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(13466),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(13464),
    [anon_sym_AMP] = ACTIONS(13468),
    [anon_sym_LT] = ACTIONS(13470),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_then] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(13472),
    [anon_sym_DOT_DOT] = ACTIONS(13474),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13476),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(13480),
    [anon_sym_AMP_AMP] = ACTIONS(13480),
    [anon_sym_LT_LT] = ACTIONS(13482),
    [anon_sym_GT_GT] = ACTIONS(13482),
    [anon_sym_EQ_EQ] = ACTIONS(13484),
    [anon_sym_BANG_EQ] = ACTIONS(13480),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13480),
    [anon_sym_LT_EQ_GT] = ACTIONS(13480),
    [anon_sym_EQ_TILDE] = ACTIONS(13480),
    [anon_sym_BANG_TILDE] = ACTIONS(13480),
    [anon_sym_LT_EQ] = ACTIONS(13470),
    [anon_sym_GT] = ACTIONS(13470),
    [anon_sym_GT_EQ] = ACTIONS(13486),
    [anon_sym_CARET] = ACTIONS(13488),
    [anon_sym_PLUS] = ACTIONS(13462),
    [anon_sym_SLASH] = ACTIONS(13464),
    [anon_sym_PERCENT] = ACTIONS(13464),
    [sym_comment] = ACTIONS(87),
  },
  [10646] = {
    [sym_string] = STATE(10646),
    [aux_sym_chained_string_repeat1] = STATE(10646),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(6214),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_do] = ACTIONS(6212),
    [anon_sym_then] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [10647] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(11549),
    [sym__binary_star] = ACTIONS(11551),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(11553),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(11551),
    [anon_sym_AMP] = ACTIONS(11555),
    [anon_sym_LT] = ACTIONS(11557),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_then] = ACTIONS(6823),
    [anon_sym_EQ_GT] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(11559),
    [anon_sym_DOT_DOT] = ACTIONS(11561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11563),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(11567),
    [anon_sym_AMP_AMP] = ACTIONS(11567),
    [anon_sym_LT_LT] = ACTIONS(11569),
    [anon_sym_GT_GT] = ACTIONS(11569),
    [anon_sym_EQ_EQ] = ACTIONS(11571),
    [anon_sym_BANG_EQ] = ACTIONS(11567),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11567),
    [anon_sym_LT_EQ_GT] = ACTIONS(11567),
    [anon_sym_EQ_TILDE] = ACTIONS(11567),
    [anon_sym_BANG_TILDE] = ACTIONS(11567),
    [anon_sym_LT_EQ] = ACTIONS(11557),
    [anon_sym_GT] = ACTIONS(11557),
    [anon_sym_GT_EQ] = ACTIONS(11573),
    [anon_sym_CARET] = ACTIONS(11575),
    [anon_sym_PLUS] = ACTIONS(11549),
    [anon_sym_SLASH] = ACTIONS(11551),
    [anon_sym_PERCENT] = ACTIONS(11551),
    [sym_comment] = ACTIONS(87),
  },
  [10648] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(11549),
    [sym__binary_star] = ACTIONS(11551),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(11553),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(11551),
    [anon_sym_AMP] = ACTIONS(11555),
    [anon_sym_LT] = ACTIONS(11557),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_then] = ACTIONS(7027),
    [anon_sym_EQ_GT] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(11559),
    [anon_sym_DOT_DOT] = ACTIONS(11561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11563),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(11567),
    [anon_sym_AMP_AMP] = ACTIONS(11567),
    [anon_sym_LT_LT] = ACTIONS(11569),
    [anon_sym_GT_GT] = ACTIONS(11569),
    [anon_sym_EQ_EQ] = ACTIONS(11571),
    [anon_sym_BANG_EQ] = ACTIONS(11567),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11567),
    [anon_sym_LT_EQ_GT] = ACTIONS(11567),
    [anon_sym_EQ_TILDE] = ACTIONS(11567),
    [anon_sym_BANG_TILDE] = ACTIONS(11567),
    [anon_sym_LT_EQ] = ACTIONS(11557),
    [anon_sym_GT] = ACTIONS(11557),
    [anon_sym_GT_EQ] = ACTIONS(11573),
    [anon_sym_CARET] = ACTIONS(11575),
    [anon_sym_PLUS] = ACTIONS(11549),
    [anon_sym_SLASH] = ACTIONS(11551),
    [anon_sym_PERCENT] = ACTIONS(11551),
    [sym_comment] = ACTIONS(87),
  },
  [10649] = {
    [sym_heredoc_body] = STATE(10649),
    [aux_sym_call_repeat1] = STATE(10649),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(7916),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_then] = ACTIONS(7914),
    [anon_sym_EQ_GT] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [10650] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8050),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5621),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(5621),
    [sym__argument] = STATE(4986),
    [sym_splat_argument] = STATE(4986),
    [sym_hash_splat_argument] = STATE(4986),
    [sym_block_argument] = STATE(4986),
    [sym_assignment] = STATE(8050),
    [sym_operator_assignment] = STATE(8050),
    [sym_conditional] = STATE(8050),
    [sym_range] = STATE(8050),
    [sym_binary] = STATE(8050),
    [sym_unary] = STATE(8050),
    [sym_left_assignment_list] = STATE(5620),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5621),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5621),
    [sym_false] = STATE(5621),
    [sym_nil] = STATE(5621),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(8053),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4986),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(11535),
    [sym__splat_star] = ACTIONS(11537),
    [sym__unary_minus] = ACTIONS(8791),
    [sym__identifier_hash_key] = ACTIONS(11539),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(14334),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8799),
    [anon_sym_yield] = ACTIONS(8801),
    [anon_sym_break] = ACTIONS(8803),
    [anon_sym_next] = ACTIONS(8805),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8809),
    [anon_sym_defined_QMARK] = ACTIONS(8811),
    [anon_sym_not] = ACTIONS(8813),
    [anon_sym_BANG] = ACTIONS(8815),
    [anon_sym_TILDE] = ACTIONS(8815),
    [sym_constant] = ACTIONS(11543),
    [sym_identifier] = ACTIONS(11543),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10651] = {
    [sym_heredoc_body] = STATE(10649),
    [aux_sym_call_repeat1] = STATE(10649),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_then] = ACTIONS(7929),
    [anon_sym_EQ_GT] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [10652] = {
    [aux_sym_argument_list_repeat1] = STATE(10652),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(14968),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7925),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_then] = ACTIONS(7925),
    [anon_sym_EQ_GT] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7925),
    [anon_sym_AMP_AMP] = ACTIONS(7925),
    [anon_sym_LT_LT] = ACTIONS(7925),
    [anon_sym_GT_GT] = ACTIONS(7925),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7925),
    [anon_sym_PLUS] = ACTIONS(7925),
    [anon_sym_SLASH] = ACTIONS(7925),
    [anon_sym_PERCENT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [10653] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(11054),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5621),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(5621),
    [sym_assignment] = STATE(11054),
    [sym_operator_assignment] = STATE(11054),
    [sym_conditional] = STATE(11054),
    [sym_range] = STATE(11054),
    [sym_binary] = STATE(11054),
    [sym_unary] = STATE(11054),
    [sym_left_assignment_list] = STATE(5620),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5621),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5621),
    [sym_false] = STATE(5621),
    [sym_nil] = STATE(5621),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(8041),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(8791),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8799),
    [anon_sym_yield] = ACTIONS(8801),
    [anon_sym_break] = ACTIONS(8803),
    [anon_sym_next] = ACTIONS(8805),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8809),
    [anon_sym_defined_QMARK] = ACTIONS(8811),
    [anon_sym_not] = ACTIONS(8813),
    [anon_sym_BANG] = ACTIONS(8815),
    [anon_sym_TILDE] = ACTIONS(8815),
    [sym_constant] = ACTIONS(5173),
    [sym_identifier] = ACTIONS(5173),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10654] = {
    [sym__line_break] = ACTIONS(6813),
    [sym__heredoc_body_start] = ACTIONS(6813),
    [anon_sym_LBRACE] = ACTIONS(6813),
    [anon_sym_DOT] = ACTIONS(6813),
    [anon_sym_SEMI] = ACTIONS(6813),
    [anon_sym_do] = ACTIONS(6813),
    [anon_sym_then] = ACTIONS(6813),
    [anon_sym_LBRACK] = ACTIONS(6813),
    [anon_sym_COLON_COLON2] = ACTIONS(6813),
    [anon_sym_AMP_DOT] = ACTIONS(6813),
    [sym_comment] = ACTIONS(87),
  },
  [10655] = {
    [sym__line_break] = ACTIONS(10986),
    [sym__heredoc_body_start] = ACTIONS(10986),
    [anon_sym_LBRACE] = ACTIONS(10986),
    [anon_sym_DOT] = ACTIONS(10986),
    [anon_sym_COMMA] = ACTIONS(10986),
    [anon_sym_SEMI] = ACTIONS(10986),
    [anon_sym_do] = ACTIONS(10986),
    [anon_sym_then] = ACTIONS(10986),
    [anon_sym_LBRACK] = ACTIONS(10986),
    [anon_sym_COLON_COLON2] = ACTIONS(10986),
    [anon_sym_AMP_DOT] = ACTIONS(10986),
    [sym_comment] = ACTIONS(87),
  },
  [10656] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9727),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5621),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(5621),
    [sym_splat_argument] = STATE(7439),
    [sym_assignment] = STATE(9727),
    [sym_operator_assignment] = STATE(9727),
    [sym_conditional] = STATE(9727),
    [sym_range] = STATE(9727),
    [sym_binary] = STATE(9727),
    [sym_unary] = STATE(9727),
    [sym__arg_or_splat_arg] = STATE(7439),
    [sym_left_assignment_list] = STATE(5620),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5621),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5621),
    [sym_false] = STATE(5621),
    [sym_nil] = STATE(5621),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(8041),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__splat_star] = ACTIONS(11537),
    [sym__unary_minus] = ACTIONS(8791),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8799),
    [anon_sym_yield] = ACTIONS(8801),
    [anon_sym_break] = ACTIONS(8803),
    [anon_sym_next] = ACTIONS(8805),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8809),
    [anon_sym_defined_QMARK] = ACTIONS(8811),
    [anon_sym_not] = ACTIONS(8813),
    [anon_sym_BANG] = ACTIONS(8815),
    [anon_sym_TILDE] = ACTIONS(8815),
    [sym_constant] = ACTIONS(5173),
    [sym_identifier] = ACTIONS(5173),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10657] = {
    [aux_sym_exceptions_repeat1] = STATE(11055),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_LBRACE] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(14971),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_do] = ACTIONS(9855),
    [anon_sym_then] = ACTIONS(9855),
    [anon_sym_EQ_GT] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [10658] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(8833),
    [sym__binary_star] = ACTIONS(8835),
    [anon_sym_LBRACE] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(8837),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(8839),
    [anon_sym_AMP] = ACTIONS(8841),
    [anon_sym_EQ] = ACTIONS(12879),
    [anon_sym_LT] = ACTIONS(8843),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_then] = ACTIONS(12120),
    [anon_sym_EQ_GT] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_PLUS_EQ] = ACTIONS(12120),
    [anon_sym_DASH_EQ] = ACTIONS(12120),
    [anon_sym_STAR_EQ] = ACTIONS(12120),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12120),
    [anon_sym_SLASH_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12120),
    [anon_sym_AMP_EQ] = ACTIONS(12120),
    [anon_sym_PERCENT_EQ] = ACTIONS(12120),
    [anon_sym_GT_GT_EQ] = ACTIONS(12120),
    [anon_sym_LT_LT_EQ] = ACTIONS(12120),
    [anon_sym_CARET_EQ] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(8845),
    [anon_sym_DOT_DOT] = ACTIONS(8847),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8849),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(8851),
    [anon_sym_AMP_AMP] = ACTIONS(8851),
    [anon_sym_LT_LT] = ACTIONS(8853),
    [anon_sym_GT_GT] = ACTIONS(8853),
    [anon_sym_EQ_EQ] = ACTIONS(8851),
    [anon_sym_BANG_EQ] = ACTIONS(8855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8855),
    [anon_sym_LT_EQ_GT] = ACTIONS(8855),
    [anon_sym_EQ_TILDE] = ACTIONS(8855),
    [anon_sym_BANG_TILDE] = ACTIONS(8855),
    [anon_sym_LT_EQ] = ACTIONS(8843),
    [anon_sym_GT] = ACTIONS(8843),
    [anon_sym_GT_EQ] = ACTIONS(8857),
    [anon_sym_CARET] = ACTIONS(8837),
    [anon_sym_PLUS] = ACTIONS(8859),
    [anon_sym_SLASH] = ACTIONS(8839),
    [anon_sym_PERCENT] = ACTIONS(8839),
    [sym_comment] = ACTIONS(87),
  },
  [10659] = {
    [aux_sym_exceptions_repeat1] = STATE(10659),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(14973),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_then] = ACTIONS(11597),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_PLUS_EQ] = ACTIONS(11597),
    [anon_sym_DASH_EQ] = ACTIONS(11597),
    [anon_sym_STAR_EQ] = ACTIONS(11597),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11597),
    [anon_sym_SLASH_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11597),
    [anon_sym_AMP_EQ] = ACTIONS(11597),
    [anon_sym_PERCENT_EQ] = ACTIONS(11597),
    [anon_sym_GT_GT_EQ] = ACTIONS(11597),
    [anon_sym_LT_LT_EQ] = ACTIONS(11597),
    [anon_sym_CARET_EQ] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_LT] = ACTIONS(12338),
    [anon_sym_GT_GT] = ACTIONS(12338),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(12338),
    [anon_sym_PLUS] = ACTIONS(12338),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [10660] = {
    [sym_heredoc_body] = STATE(10660),
    [aux_sym_call_repeat1] = STATE(10660),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(7916),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_end] = ACTIONS(7914),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_ensure] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [10661] = {
    [sym_heredoc_body] = STATE(10660),
    [aux_sym_call_repeat1] = STATE(10660),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_end] = ACTIONS(7929),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_ensure] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [10662] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(11056),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5676),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(5676),
    [sym_assignment] = STATE(11056),
    [sym_operator_assignment] = STATE(11056),
    [sym_conditional] = STATE(11056),
    [sym_range] = STATE(11056),
    [sym_binary] = STATE(11056),
    [sym_unary] = STATE(11056),
    [sym_left_assignment_list] = STATE(5675),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5676),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5676),
    [sym_false] = STATE(5676),
    [sym_nil] = STATE(5676),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5677),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8875),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8877),
    [anon_sym_yield] = ACTIONS(8879),
    [anon_sym_break] = ACTIONS(8881),
    [anon_sym_next] = ACTIONS(8883),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8885),
    [anon_sym_defined_QMARK] = ACTIONS(8887),
    [anon_sym_not] = ACTIONS(8889),
    [anon_sym_BANG] = ACTIONS(8891),
    [anon_sym_TILDE] = ACTIONS(8891),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10663] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9748),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5676),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(5676),
    [sym_splat_argument] = STATE(7439),
    [sym_assignment] = STATE(9748),
    [sym_operator_assignment] = STATE(9748),
    [sym_conditional] = STATE(9748),
    [sym_range] = STATE(9748),
    [sym_binary] = STATE(9748),
    [sym_unary] = STATE(9748),
    [sym__arg_or_splat_arg] = STATE(7439),
    [sym_left_assignment_list] = STATE(5675),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5676),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5676),
    [sym_false] = STATE(5676),
    [sym_nil] = STATE(5676),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5677),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(5191),
    [sym__unary_minus] = ACTIONS(8875),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8877),
    [anon_sym_yield] = ACTIONS(8879),
    [anon_sym_break] = ACTIONS(8881),
    [anon_sym_next] = ACTIONS(8883),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8885),
    [anon_sym_defined_QMARK] = ACTIONS(8887),
    [anon_sym_not] = ACTIONS(8889),
    [anon_sym_BANG] = ACTIONS(8891),
    [anon_sym_TILDE] = ACTIONS(8891),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10664] = {
    [aux_sym_exceptions_repeat1] = STATE(11057),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(14976),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_end] = ACTIONS(9855),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_ensure] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [10665] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(8907),
    [sym__binary_star] = ACTIONS(8909),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(8911),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(8909),
    [anon_sym_AMP] = ACTIONS(8913),
    [anon_sym_LT] = ACTIONS(8915),
    [anon_sym_end] = ACTIONS(12120),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_ensure] = ACTIONS(12120),
    [anon_sym_EQ_GT] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(8917),
    [anon_sym_DOT_DOT] = ACTIONS(8919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8921),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(8923),
    [anon_sym_AMP_AMP] = ACTIONS(8923),
    [anon_sym_LT_LT] = ACTIONS(8925),
    [anon_sym_GT_GT] = ACTIONS(8925),
    [anon_sym_EQ_EQ] = ACTIONS(8927),
    [anon_sym_BANG_EQ] = ACTIONS(8923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8923),
    [anon_sym_LT_EQ_GT] = ACTIONS(8923),
    [anon_sym_EQ_TILDE] = ACTIONS(8923),
    [anon_sym_BANG_TILDE] = ACTIONS(8923),
    [anon_sym_LT_EQ] = ACTIONS(8915),
    [anon_sym_GT] = ACTIONS(8915),
    [anon_sym_GT_EQ] = ACTIONS(8929),
    [anon_sym_CARET] = ACTIONS(8931),
    [anon_sym_PLUS] = ACTIONS(8907),
    [anon_sym_SLASH] = ACTIONS(8909),
    [anon_sym_PERCENT] = ACTIONS(8909),
    [sym_comment] = ACTIONS(87),
  },
  [10666] = {
    [aux_sym_exceptions_repeat1] = STATE(10666),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(14978),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_end] = ACTIONS(11597),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_ensure] = ACTIONS(11597),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [10667] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(11058),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(5745),
    [sym_scope_resolution] = STATE(5743),
    [sym_call] = STATE(5743),
    [sym_method_call] = STATE(5745),
    [sym_assignment] = STATE(11058),
    [sym_operator_assignment] = STATE(11058),
    [sym_conditional] = STATE(11058),
    [sym_range] = STATE(11058),
    [sym_binary] = STATE(11058),
    [sym_unary] = STATE(11058),
    [sym_left_assignment_list] = STATE(5744),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5745),
    [sym__variable] = STATE(5743),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(5745),
    [sym_false] = STATE(5745),
    [sym_nil] = STATE(5745),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(5746),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(8951),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(8953),
    [anon_sym_yield] = ACTIONS(8955),
    [anon_sym_break] = ACTIONS(8957),
    [anon_sym_next] = ACTIONS(8959),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(8961),
    [anon_sym_defined_QMARK] = ACTIONS(8963),
    [anon_sym_not] = ACTIONS(8965),
    [anon_sym_BANG] = ACTIONS(8967),
    [anon_sym_TILDE] = ACTIONS(8967),
    [sym_constant] = ACTIONS(8969),
    [sym_identifier] = ACTIONS(8969),
    [sym_instance_variable] = ACTIONS(8971),
    [sym_class_variable] = ACTIONS(8971),
    [sym_global_variable] = ACTIONS(8971),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(8969),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8969),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [10668] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(9778),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(5745),
    [sym_scope_resolution] = STATE(5743),
    [sym_call] = STATE(5743),
    [sym_method_call] = STATE(5745),
    [sym_splat_argument] = STATE(10067),
    [sym_assignment] = STATE(9778),
    [sym_operator_assignment] = STATE(9778),
    [sym_conditional] = STATE(9778),
    [sym_range] = STATE(9778),
    [sym_binary] = STATE(9778),
    [sym_unary] = STATE(9778),
    [sym__arg_or_splat_arg] = STATE(10067),
    [sym_left_assignment_list] = STATE(5744),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5745),
    [sym__variable] = STATE(5743),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(5745),
    [sym_false] = STATE(5745),
    [sym_nil] = STATE(5745),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(5746),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__splat_star] = ACTIONS(5263),
    [sym__unary_minus] = ACTIONS(8951),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(8953),
    [anon_sym_yield] = ACTIONS(8955),
    [anon_sym_break] = ACTIONS(8957),
    [anon_sym_next] = ACTIONS(8959),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(8961),
    [anon_sym_defined_QMARK] = ACTIONS(8963),
    [anon_sym_not] = ACTIONS(8965),
    [anon_sym_BANG] = ACTIONS(8967),
    [anon_sym_TILDE] = ACTIONS(8967),
    [sym_constant] = ACTIONS(8969),
    [sym_identifier] = ACTIONS(8969),
    [sym_instance_variable] = ACTIONS(8971),
    [sym_class_variable] = ACTIONS(8971),
    [sym_global_variable] = ACTIONS(8971),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(8969),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8969),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [10669] = {
    [aux_sym_exceptions_repeat1] = STATE(11059),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_LBRACE] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(14981),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9857),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_EQ] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_end] = ACTIONS(9855),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_do] = ACTIONS(9855),
    [anon_sym_ensure] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_PLUS_EQ] = ACTIONS(9855),
    [anon_sym_DASH_EQ] = ACTIONS(9855),
    [anon_sym_STAR_EQ] = ACTIONS(9855),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9855),
    [anon_sym_SLASH_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9855),
    [anon_sym_AMP_EQ] = ACTIONS(9855),
    [anon_sym_PERCENT_EQ] = ACTIONS(9855),
    [anon_sym_GT_GT_EQ] = ACTIONS(9855),
    [anon_sym_LT_LT_EQ] = ACTIONS(9855),
    [anon_sym_CARET_EQ] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9857),
    [anon_sym_AMP_AMP] = ACTIONS(9857),
    [anon_sym_LT_LT] = ACTIONS(9857),
    [anon_sym_GT_GT] = ACTIONS(9857),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9857),
    [anon_sym_PLUS] = ACTIONS(9857),
    [anon_sym_SLASH] = ACTIONS(9857),
    [anon_sym_PERCENT] = ACTIONS(9857),
    [sym_comment] = ACTIONS(87),
  },
  [10670] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(8979),
    [sym__binary_star] = ACTIONS(8981),
    [anon_sym_LBRACE] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(8983),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(8985),
    [anon_sym_AMP] = ACTIONS(8987),
    [anon_sym_EQ] = ACTIONS(12879),
    [anon_sym_LT] = ACTIONS(8989),
    [anon_sym_end] = ACTIONS(12120),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_ensure] = ACTIONS(12120),
    [anon_sym_EQ_GT] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_PLUS_EQ] = ACTIONS(12120),
    [anon_sym_DASH_EQ] = ACTIONS(12120),
    [anon_sym_STAR_EQ] = ACTIONS(12120),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12120),
    [anon_sym_SLASH_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12120),
    [anon_sym_AMP_EQ] = ACTIONS(12120),
    [anon_sym_PERCENT_EQ] = ACTIONS(12120),
    [anon_sym_GT_GT_EQ] = ACTIONS(12120),
    [anon_sym_LT_LT_EQ] = ACTIONS(12120),
    [anon_sym_CARET_EQ] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(8991),
    [anon_sym_DOT_DOT] = ACTIONS(8993),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8995),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(8997),
    [anon_sym_AMP_AMP] = ACTIONS(8997),
    [anon_sym_LT_LT] = ACTIONS(8999),
    [anon_sym_GT_GT] = ACTIONS(8999),
    [anon_sym_EQ_EQ] = ACTIONS(8997),
    [anon_sym_BANG_EQ] = ACTIONS(9001),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9001),
    [anon_sym_LT_EQ_GT] = ACTIONS(9001),
    [anon_sym_EQ_TILDE] = ACTIONS(9001),
    [anon_sym_BANG_TILDE] = ACTIONS(9001),
    [anon_sym_LT_EQ] = ACTIONS(8989),
    [anon_sym_GT] = ACTIONS(8989),
    [anon_sym_GT_EQ] = ACTIONS(9003),
    [anon_sym_CARET] = ACTIONS(8983),
    [anon_sym_PLUS] = ACTIONS(9005),
    [anon_sym_SLASH] = ACTIONS(8985),
    [anon_sym_PERCENT] = ACTIONS(8985),
    [sym_comment] = ACTIONS(87),
  },
  [10671] = {
    [aux_sym_exceptions_repeat1] = STATE(10671),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(14983),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_end] = ACTIONS(11597),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_ensure] = ACTIONS(11597),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_PLUS_EQ] = ACTIONS(11597),
    [anon_sym_DASH_EQ] = ACTIONS(11597),
    [anon_sym_STAR_EQ] = ACTIONS(11597),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11597),
    [anon_sym_SLASH_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11597),
    [anon_sym_AMP_EQ] = ACTIONS(11597),
    [anon_sym_PERCENT_EQ] = ACTIONS(11597),
    [anon_sym_GT_GT_EQ] = ACTIONS(11597),
    [anon_sym_LT_LT_EQ] = ACTIONS(11597),
    [anon_sym_CARET_EQ] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_LT] = ACTIONS(12338),
    [anon_sym_GT_GT] = ACTIONS(12338),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(12338),
    [anon_sym_PLUS] = ACTIONS(12338),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [10672] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(11060),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5777),
    [sym_scope_resolution] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_method_call] = STATE(5777),
    [sym_assignment] = STATE(11060),
    [sym_operator_assignment] = STATE(11060),
    [sym_conditional] = STATE(11060),
    [sym_range] = STATE(11060),
    [sym_binary] = STATE(11060),
    [sym_unary] = STATE(11060),
    [sym_left_assignment_list] = STATE(5776),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5777),
    [sym__variable] = STATE(1189),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5777),
    [sym_false] = STATE(5777),
    [sym_nil] = STATE(5777),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5677),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9019),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8877),
    [anon_sym_yield] = ACTIONS(8879),
    [anon_sym_break] = ACTIONS(8881),
    [anon_sym_next] = ACTIONS(8883),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9021),
    [anon_sym_defined_QMARK] = ACTIONS(9023),
    [anon_sym_not] = ACTIONS(9025),
    [anon_sym_BANG] = ACTIONS(9027),
    [anon_sym_TILDE] = ACTIONS(9027),
    [sym_constant] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2129),
    [sym_instance_variable] = ACTIONS(2131),
    [sym_class_variable] = ACTIONS(2131),
    [sym_global_variable] = ACTIONS(2131),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2129),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10673] = {
    [sym_heredoc_body] = STATE(10673),
    [aux_sym_call_repeat1] = STATE(10673),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(7916),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_end] = ACTIONS(7914),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [10674] = {
    [sym_heredoc_body] = STATE(10673),
    [aux_sym_call_repeat1] = STATE(10673),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_end] = ACTIONS(7929),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [10675] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(11061),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5789),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(5789),
    [sym_assignment] = STATE(11061),
    [sym_operator_assignment] = STATE(11061),
    [sym_conditional] = STATE(11061),
    [sym_range] = STATE(11061),
    [sym_binary] = STATE(11061),
    [sym_unary] = STATE(11061),
    [sym_left_assignment_list] = STATE(5788),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5789),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5789),
    [sym_false] = STATE(5789),
    [sym_nil] = STATE(5789),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5790),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9031),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9033),
    [anon_sym_yield] = ACTIONS(9035),
    [anon_sym_break] = ACTIONS(9037),
    [anon_sym_next] = ACTIONS(9039),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9041),
    [anon_sym_defined_QMARK] = ACTIONS(9043),
    [anon_sym_not] = ACTIONS(9045),
    [anon_sym_BANG] = ACTIONS(9047),
    [anon_sym_TILDE] = ACTIONS(9047),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10676] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(9810),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5789),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(5789),
    [sym_splat_argument] = STATE(7439),
    [sym_assignment] = STATE(9810),
    [sym_operator_assignment] = STATE(9810),
    [sym_conditional] = STATE(9810),
    [sym_range] = STATE(9810),
    [sym_binary] = STATE(9810),
    [sym_unary] = STATE(9810),
    [sym__arg_or_splat_arg] = STATE(7439),
    [sym_left_assignment_list] = STATE(5788),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5789),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5789),
    [sym_false] = STATE(5789),
    [sym_nil] = STATE(5789),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5790),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(5301),
    [sym__unary_minus] = ACTIONS(9031),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9033),
    [anon_sym_yield] = ACTIONS(9035),
    [anon_sym_break] = ACTIONS(9037),
    [anon_sym_next] = ACTIONS(9039),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9041),
    [anon_sym_defined_QMARK] = ACTIONS(9043),
    [anon_sym_not] = ACTIONS(9045),
    [anon_sym_BANG] = ACTIONS(9047),
    [anon_sym_TILDE] = ACTIONS(9047),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10677] = {
    [aux_sym_exceptions_repeat1] = STATE(11062),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(14986),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_end] = ACTIONS(9855),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [10678] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(9063),
    [sym__binary_star] = ACTIONS(9065),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(9067),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(9065),
    [anon_sym_AMP] = ACTIONS(9069),
    [anon_sym_LT] = ACTIONS(9071),
    [anon_sym_end] = ACTIONS(12120),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_EQ_GT] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(9073),
    [anon_sym_DOT_DOT] = ACTIONS(9075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9077),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(9079),
    [anon_sym_AMP_AMP] = ACTIONS(9079),
    [anon_sym_LT_LT] = ACTIONS(9081),
    [anon_sym_GT_GT] = ACTIONS(9081),
    [anon_sym_EQ_EQ] = ACTIONS(9083),
    [anon_sym_BANG_EQ] = ACTIONS(9079),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9079),
    [anon_sym_LT_EQ_GT] = ACTIONS(9079),
    [anon_sym_EQ_TILDE] = ACTIONS(9079),
    [anon_sym_BANG_TILDE] = ACTIONS(9079),
    [anon_sym_LT_EQ] = ACTIONS(9071),
    [anon_sym_GT] = ACTIONS(9071),
    [anon_sym_GT_EQ] = ACTIONS(9085),
    [anon_sym_CARET] = ACTIONS(9087),
    [anon_sym_PLUS] = ACTIONS(9063),
    [anon_sym_SLASH] = ACTIONS(9065),
    [anon_sym_PERCENT] = ACTIONS(9065),
    [sym_comment] = ACTIONS(87),
  },
  [10679] = {
    [aux_sym_exceptions_repeat1] = STATE(10679),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(14988),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_end] = ACTIONS(11597),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [10680] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(11063),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(5858),
    [sym_scope_resolution] = STATE(5856),
    [sym_call] = STATE(5856),
    [sym_method_call] = STATE(5858),
    [sym_assignment] = STATE(11063),
    [sym_operator_assignment] = STATE(11063),
    [sym_conditional] = STATE(11063),
    [sym_range] = STATE(11063),
    [sym_binary] = STATE(11063),
    [sym_unary] = STATE(11063),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5858),
    [sym__variable] = STATE(5856),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(5858),
    [sym_false] = STATE(5858),
    [sym_nil] = STATE(5858),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(5859),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(9107),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(9109),
    [anon_sym_yield] = ACTIONS(9111),
    [anon_sym_break] = ACTIONS(9113),
    [anon_sym_next] = ACTIONS(9115),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(9117),
    [anon_sym_defined_QMARK] = ACTIONS(9119),
    [anon_sym_not] = ACTIONS(9121),
    [anon_sym_BANG] = ACTIONS(9123),
    [anon_sym_TILDE] = ACTIONS(9123),
    [sym_constant] = ACTIONS(9125),
    [sym_identifier] = ACTIONS(9125),
    [sym_instance_variable] = ACTIONS(9127),
    [sym_class_variable] = ACTIONS(9127),
    [sym_global_variable] = ACTIONS(9127),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(9125),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9125),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [10681] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(9840),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(5858),
    [sym_scope_resolution] = STATE(5856),
    [sym_call] = STATE(5856),
    [sym_method_call] = STATE(5858),
    [sym_splat_argument] = STATE(10067),
    [sym_assignment] = STATE(9840),
    [sym_operator_assignment] = STATE(9840),
    [sym_conditional] = STATE(9840),
    [sym_range] = STATE(9840),
    [sym_binary] = STATE(9840),
    [sym_unary] = STATE(9840),
    [sym__arg_or_splat_arg] = STATE(10067),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5858),
    [sym__variable] = STATE(5856),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(5858),
    [sym_false] = STATE(5858),
    [sym_nil] = STATE(5858),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(5859),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__splat_star] = ACTIONS(5373),
    [sym__unary_minus] = ACTIONS(9107),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(9109),
    [anon_sym_yield] = ACTIONS(9111),
    [anon_sym_break] = ACTIONS(9113),
    [anon_sym_next] = ACTIONS(9115),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(9117),
    [anon_sym_defined_QMARK] = ACTIONS(9119),
    [anon_sym_not] = ACTIONS(9121),
    [anon_sym_BANG] = ACTIONS(9123),
    [anon_sym_TILDE] = ACTIONS(9123),
    [sym_constant] = ACTIONS(9125),
    [sym_identifier] = ACTIONS(9125),
    [sym_instance_variable] = ACTIONS(9127),
    [sym_class_variable] = ACTIONS(9127),
    [sym_global_variable] = ACTIONS(9127),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(9125),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9125),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [10682] = {
    [aux_sym_exceptions_repeat1] = STATE(11064),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_LBRACE] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(14991),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9857),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_EQ] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_end] = ACTIONS(9855),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_do] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_PLUS_EQ] = ACTIONS(9855),
    [anon_sym_DASH_EQ] = ACTIONS(9855),
    [anon_sym_STAR_EQ] = ACTIONS(9855),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9855),
    [anon_sym_SLASH_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9855),
    [anon_sym_AMP_EQ] = ACTIONS(9855),
    [anon_sym_PERCENT_EQ] = ACTIONS(9855),
    [anon_sym_GT_GT_EQ] = ACTIONS(9855),
    [anon_sym_LT_LT_EQ] = ACTIONS(9855),
    [anon_sym_CARET_EQ] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9857),
    [anon_sym_AMP_AMP] = ACTIONS(9857),
    [anon_sym_LT_LT] = ACTIONS(9857),
    [anon_sym_GT_GT] = ACTIONS(9857),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9857),
    [anon_sym_PLUS] = ACTIONS(9857),
    [anon_sym_SLASH] = ACTIONS(9857),
    [anon_sym_PERCENT] = ACTIONS(9857),
    [sym_comment] = ACTIONS(87),
  },
  [10683] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(9135),
    [sym__binary_star] = ACTIONS(9137),
    [anon_sym_LBRACE] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(9139),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(9141),
    [anon_sym_AMP] = ACTIONS(9143),
    [anon_sym_EQ] = ACTIONS(12879),
    [anon_sym_LT] = ACTIONS(9145),
    [anon_sym_end] = ACTIONS(12120),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_EQ_GT] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_PLUS_EQ] = ACTIONS(12120),
    [anon_sym_DASH_EQ] = ACTIONS(12120),
    [anon_sym_STAR_EQ] = ACTIONS(12120),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12120),
    [anon_sym_SLASH_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12120),
    [anon_sym_AMP_EQ] = ACTIONS(12120),
    [anon_sym_PERCENT_EQ] = ACTIONS(12120),
    [anon_sym_GT_GT_EQ] = ACTIONS(12120),
    [anon_sym_LT_LT_EQ] = ACTIONS(12120),
    [anon_sym_CARET_EQ] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(9147),
    [anon_sym_DOT_DOT] = ACTIONS(9149),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9151),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(9153),
    [anon_sym_AMP_AMP] = ACTIONS(9153),
    [anon_sym_LT_LT] = ACTIONS(9155),
    [anon_sym_GT_GT] = ACTIONS(9155),
    [anon_sym_EQ_EQ] = ACTIONS(9153),
    [anon_sym_BANG_EQ] = ACTIONS(9157),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9157),
    [anon_sym_LT_EQ_GT] = ACTIONS(9157),
    [anon_sym_EQ_TILDE] = ACTIONS(9157),
    [anon_sym_BANG_TILDE] = ACTIONS(9157),
    [anon_sym_LT_EQ] = ACTIONS(9145),
    [anon_sym_GT] = ACTIONS(9145),
    [anon_sym_GT_EQ] = ACTIONS(9159),
    [anon_sym_CARET] = ACTIONS(9139),
    [anon_sym_PLUS] = ACTIONS(9161),
    [anon_sym_SLASH] = ACTIONS(9141),
    [anon_sym_PERCENT] = ACTIONS(9141),
    [sym_comment] = ACTIONS(87),
  },
  [10684] = {
    [aux_sym_exceptions_repeat1] = STATE(10684),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(14993),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_end] = ACTIONS(11597),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_PLUS_EQ] = ACTIONS(11597),
    [anon_sym_DASH_EQ] = ACTIONS(11597),
    [anon_sym_STAR_EQ] = ACTIONS(11597),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11597),
    [anon_sym_SLASH_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11597),
    [anon_sym_AMP_EQ] = ACTIONS(11597),
    [anon_sym_PERCENT_EQ] = ACTIONS(11597),
    [anon_sym_GT_GT_EQ] = ACTIONS(11597),
    [anon_sym_LT_LT_EQ] = ACTIONS(11597),
    [anon_sym_CARET_EQ] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_LT] = ACTIONS(12338),
    [anon_sym_GT_GT] = ACTIONS(12338),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(12338),
    [anon_sym_PLUS] = ACTIONS(12338),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [10685] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(11065),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(5890),
    [sym_scope_resolution] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_method_call] = STATE(5890),
    [sym_assignment] = STATE(11065),
    [sym_operator_assignment] = STATE(11065),
    [sym_conditional] = STATE(11065),
    [sym_range] = STATE(11065),
    [sym_binary] = STATE(11065),
    [sym_unary] = STATE(11065),
    [sym_left_assignment_list] = STATE(5889),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5890),
    [sym__variable] = STATE(1206),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(5890),
    [sym_false] = STATE(5890),
    [sym_nil] = STATE(5890),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(5790),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9175),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9033),
    [anon_sym_yield] = ACTIONS(9035),
    [anon_sym_break] = ACTIONS(9037),
    [anon_sym_next] = ACTIONS(9039),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9177),
    [anon_sym_defined_QMARK] = ACTIONS(9179),
    [anon_sym_not] = ACTIONS(9181),
    [anon_sym_BANG] = ACTIONS(9183),
    [anon_sym_TILDE] = ACTIONS(9183),
    [sym_constant] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2155),
    [sym_instance_variable] = ACTIONS(2157),
    [sym_class_variable] = ACTIONS(2157),
    [sym_global_variable] = ACTIONS(2157),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2155),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10686] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(9193),
    [sym__binary_star] = ACTIONS(9195),
    [anon_sym_LBRACE] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(9197),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(9199),
    [anon_sym_AMP] = ACTIONS(9201),
    [anon_sym_EQ] = ACTIONS(12879),
    [anon_sym_LT] = ACTIONS(9203),
    [anon_sym_end] = ACTIONS(12120),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_else] = ACTIONS(12120),
    [anon_sym_ensure] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_PLUS_EQ] = ACTIONS(12120),
    [anon_sym_DASH_EQ] = ACTIONS(12120),
    [anon_sym_STAR_EQ] = ACTIONS(12120),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12120),
    [anon_sym_SLASH_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12120),
    [anon_sym_AMP_EQ] = ACTIONS(12120),
    [anon_sym_PERCENT_EQ] = ACTIONS(12120),
    [anon_sym_GT_GT_EQ] = ACTIONS(12120),
    [anon_sym_LT_LT_EQ] = ACTIONS(12120),
    [anon_sym_CARET_EQ] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(9205),
    [anon_sym_DOT_DOT] = ACTIONS(9207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9209),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(9211),
    [anon_sym_AMP_AMP] = ACTIONS(9211),
    [anon_sym_LT_LT] = ACTIONS(9213),
    [anon_sym_GT_GT] = ACTIONS(9213),
    [anon_sym_EQ_EQ] = ACTIONS(9211),
    [anon_sym_BANG_EQ] = ACTIONS(9215),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9215),
    [anon_sym_LT_EQ_GT] = ACTIONS(9215),
    [anon_sym_EQ_TILDE] = ACTIONS(9215),
    [anon_sym_BANG_TILDE] = ACTIONS(9215),
    [anon_sym_LT_EQ] = ACTIONS(9203),
    [anon_sym_GT] = ACTIONS(9203),
    [anon_sym_GT_EQ] = ACTIONS(9217),
    [anon_sym_CARET] = ACTIONS(9197),
    [anon_sym_PLUS] = ACTIONS(9219),
    [anon_sym_SLASH] = ACTIONS(9199),
    [anon_sym_PERCENT] = ACTIONS(9199),
    [sym_comment] = ACTIONS(87),
  },
  [10687] = {
    [aux_sym_exceptions_repeat1] = STATE(10687),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(14996),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_end] = ACTIONS(11597),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_else] = ACTIONS(11597),
    [anon_sym_ensure] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_PLUS_EQ] = ACTIONS(11597),
    [anon_sym_DASH_EQ] = ACTIONS(11597),
    [anon_sym_STAR_EQ] = ACTIONS(11597),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11597),
    [anon_sym_SLASH_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11597),
    [anon_sym_AMP_EQ] = ACTIONS(11597),
    [anon_sym_PERCENT_EQ] = ACTIONS(11597),
    [anon_sym_GT_GT_EQ] = ACTIONS(11597),
    [anon_sym_LT_LT_EQ] = ACTIONS(11597),
    [anon_sym_CARET_EQ] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_LT] = ACTIONS(12338),
    [anon_sym_GT_GT] = ACTIONS(12338),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(12338),
    [anon_sym_PLUS] = ACTIONS(12338),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [10688] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(9229),
    [sym__binary_star] = ACTIONS(9231),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(9233),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(9231),
    [anon_sym_AMP] = ACTIONS(9235),
    [anon_sym_LT] = ACTIONS(9237),
    [anon_sym_end] = ACTIONS(12120),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_else] = ACTIONS(12120),
    [anon_sym_ensure] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(9239),
    [anon_sym_DOT_DOT] = ACTIONS(9241),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9243),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(9245),
    [anon_sym_AMP_AMP] = ACTIONS(9245),
    [anon_sym_LT_LT] = ACTIONS(9247),
    [anon_sym_GT_GT] = ACTIONS(9247),
    [anon_sym_EQ_EQ] = ACTIONS(9249),
    [anon_sym_BANG_EQ] = ACTIONS(9245),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9245),
    [anon_sym_LT_EQ_GT] = ACTIONS(9245),
    [anon_sym_EQ_TILDE] = ACTIONS(9245),
    [anon_sym_BANG_TILDE] = ACTIONS(9245),
    [anon_sym_LT_EQ] = ACTIONS(9237),
    [anon_sym_GT] = ACTIONS(9237),
    [anon_sym_GT_EQ] = ACTIONS(9251),
    [anon_sym_CARET] = ACTIONS(9253),
    [anon_sym_PLUS] = ACTIONS(9229),
    [anon_sym_SLASH] = ACTIONS(9231),
    [anon_sym_PERCENT] = ACTIONS(9231),
    [sym_comment] = ACTIONS(87),
  },
  [10689] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(11066),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(5966),
    [sym_scope_resolution] = STATE(1285),
    [sym_call] = STATE(1285),
    [sym_method_call] = STATE(5966),
    [sym_assignment] = STATE(11066),
    [sym_operator_assignment] = STATE(11066),
    [sym_conditional] = STATE(11066),
    [sym_range] = STATE(11066),
    [sym_binary] = STATE(11066),
    [sym_unary] = STATE(11066),
    [sym_left_assignment_list] = STATE(5965),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5966),
    [sym__variable] = STATE(1285),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(5966),
    [sym_false] = STATE(5966),
    [sym_nil] = STATE(5966),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(1288),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9288),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2283),
    [anon_sym_yield] = ACTIONS(2285),
    [anon_sym_break] = ACTIONS(2287),
    [anon_sym_next] = ACTIONS(2289),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9290),
    [anon_sym_defined_QMARK] = ACTIONS(9292),
    [anon_sym_not] = ACTIONS(9294),
    [anon_sym_BANG] = ACTIONS(9296),
    [anon_sym_TILDE] = ACTIONS(9296),
    [sym_constant] = ACTIONS(2299),
    [sym_identifier] = ACTIONS(2299),
    [sym_instance_variable] = ACTIONS(2301),
    [sym_class_variable] = ACTIONS(2301),
    [sym_global_variable] = ACTIONS(2301),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2299),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2299),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10690] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9878),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(5966),
    [sym_scope_resolution] = STATE(1285),
    [sym_call] = STATE(1285),
    [sym_method_call] = STATE(5966),
    [sym_splat_argument] = STATE(9013),
    [sym_assignment] = STATE(9878),
    [sym_operator_assignment] = STATE(9878),
    [sym_conditional] = STATE(9878),
    [sym_range] = STATE(9878),
    [sym_binary] = STATE(9878),
    [sym_unary] = STATE(9878),
    [sym__arg_or_splat_arg] = STATE(9013),
    [sym_left_assignment_list] = STATE(5965),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5966),
    [sym__variable] = STATE(1285),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(5966),
    [sym_false] = STATE(5966),
    [sym_nil] = STATE(5966),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(1288),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(5529),
    [sym__unary_minus] = ACTIONS(9288),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2283),
    [anon_sym_yield] = ACTIONS(2285),
    [anon_sym_break] = ACTIONS(2287),
    [anon_sym_next] = ACTIONS(2289),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9290),
    [anon_sym_defined_QMARK] = ACTIONS(9292),
    [anon_sym_not] = ACTIONS(9294),
    [anon_sym_BANG] = ACTIONS(9296),
    [anon_sym_TILDE] = ACTIONS(9296),
    [sym_constant] = ACTIONS(2299),
    [sym_identifier] = ACTIONS(2299),
    [sym_instance_variable] = ACTIONS(2301),
    [sym_class_variable] = ACTIONS(2301),
    [sym_global_variable] = ACTIONS(2301),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2299),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2299),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10691] = {
    [aux_sym_exceptions_repeat1] = STATE(11067),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(14999),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_RBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [10692] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(11068),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(5994),
    [sym_scope_resolution] = STATE(5992),
    [sym_call] = STATE(5992),
    [sym_method_call] = STATE(5994),
    [sym_assignment] = STATE(11068),
    [sym_operator_assignment] = STATE(11068),
    [sym_conditional] = STATE(11068),
    [sym_range] = STATE(11068),
    [sym_binary] = STATE(11068),
    [sym_unary] = STATE(11068),
    [sym_left_assignment_list] = STATE(5993),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5994),
    [sym__variable] = STATE(5992),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(5994),
    [sym_false] = STATE(5994),
    [sym_nil] = STATE(5994),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(5995),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(9306),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(9308),
    [anon_sym_yield] = ACTIONS(9310),
    [anon_sym_break] = ACTIONS(9312),
    [anon_sym_next] = ACTIONS(9314),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(9316),
    [anon_sym_defined_QMARK] = ACTIONS(9318),
    [anon_sym_not] = ACTIONS(9320),
    [anon_sym_BANG] = ACTIONS(9322),
    [anon_sym_TILDE] = ACTIONS(9322),
    [sym_constant] = ACTIONS(9324),
    [sym_identifier] = ACTIONS(9324),
    [sym_instance_variable] = ACTIONS(9326),
    [sym_class_variable] = ACTIONS(9326),
    [sym_global_variable] = ACTIONS(9326),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(9324),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9324),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [10693] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(9892),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(5994),
    [sym_scope_resolution] = STATE(5992),
    [sym_call] = STATE(5992),
    [sym_method_call] = STATE(5994),
    [sym_splat_argument] = STATE(10867),
    [sym_assignment] = STATE(9892),
    [sym_operator_assignment] = STATE(9892),
    [sym_conditional] = STATE(9892),
    [sym_range] = STATE(9892),
    [sym_binary] = STATE(9892),
    [sym_unary] = STATE(9892),
    [sym__arg_or_splat_arg] = STATE(10867),
    [sym_left_assignment_list] = STATE(5993),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5994),
    [sym__variable] = STATE(5992),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(5994),
    [sym_false] = STATE(5994),
    [sym_nil] = STATE(5994),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(5995),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__splat_star] = ACTIONS(5565),
    [sym__unary_minus] = ACTIONS(9306),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(9308),
    [anon_sym_yield] = ACTIONS(9310),
    [anon_sym_break] = ACTIONS(9312),
    [anon_sym_next] = ACTIONS(9314),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(9316),
    [anon_sym_defined_QMARK] = ACTIONS(9318),
    [anon_sym_not] = ACTIONS(9320),
    [anon_sym_BANG] = ACTIONS(9322),
    [anon_sym_TILDE] = ACTIONS(9322),
    [sym_constant] = ACTIONS(9324),
    [sym_identifier] = ACTIONS(9324),
    [sym_instance_variable] = ACTIONS(9326),
    [sym_class_variable] = ACTIONS(9326),
    [sym_global_variable] = ACTIONS(9326),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(9324),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9324),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [10694] = {
    [aux_sym_exceptions_repeat1] = STATE(11069),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_LBRACE] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(15001),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_STAR_STAR] = ACTIONS(9857),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_EQ] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_do] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_RBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_PLUS_EQ] = ACTIONS(9855),
    [anon_sym_DASH_EQ] = ACTIONS(9855),
    [anon_sym_STAR_EQ] = ACTIONS(9855),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9855),
    [anon_sym_SLASH_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9855),
    [anon_sym_AMP_EQ] = ACTIONS(9855),
    [anon_sym_PERCENT_EQ] = ACTIONS(9855),
    [anon_sym_GT_GT_EQ] = ACTIONS(9855),
    [anon_sym_LT_LT_EQ] = ACTIONS(9855),
    [anon_sym_CARET_EQ] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9857),
    [anon_sym_AMP_AMP] = ACTIONS(9857),
    [anon_sym_LT_LT] = ACTIONS(9857),
    [anon_sym_GT_GT] = ACTIONS(9857),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9857),
    [anon_sym_PLUS] = ACTIONS(9857),
    [anon_sym_SLASH] = ACTIONS(9857),
    [anon_sym_PERCENT] = ACTIONS(9857),
    [sym_comment] = ACTIONS(87),
  },
  [10695] = {
    [sym__heredoc_body_start] = ACTIONS(14151),
    [sym__binary_minus] = ACTIONS(14151),
    [sym__binary_star] = ACTIONS(14151),
    [anon_sym_LBRACE] = ACTIONS(14151),
    [anon_sym_RBRACE] = ACTIONS(14151),
    [anon_sym_RPAREN] = ACTIONS(14151),
    [anon_sym_DOT] = ACTIONS(14153),
    [anon_sym_COMMA] = ACTIONS(14151),
    [anon_sym_PIPE] = ACTIONS(14153),
    [anon_sym_SEMI] = ACTIONS(14151),
    [anon_sym_STAR_STAR] = ACTIONS(14151),
    [anon_sym_AMP] = ACTIONS(14153),
    [anon_sym_EQ] = ACTIONS(14153),
    [anon_sym_LT] = ACTIONS(14153),
    [anon_sym_if] = ACTIONS(14151),
    [anon_sym_unless] = ACTIONS(14151),
    [anon_sym_while] = ACTIONS(14151),
    [anon_sym_until] = ACTIONS(14151),
    [anon_sym_rescue] = ACTIONS(14151),
    [anon_sym_in] = ACTIONS(14151),
    [anon_sym_do] = ACTIONS(14151),
    [anon_sym_EQ_GT] = ACTIONS(14151),
    [anon_sym_LBRACK] = ACTIONS(14151),
    [anon_sym_RBRACK] = ACTIONS(14151),
    [anon_sym_COLON_COLON2] = ACTIONS(14151),
    [anon_sym_AMP_DOT] = ACTIONS(14151),
    [anon_sym_QMARK] = ACTIONS(14151),
    [anon_sym_COLON2] = ACTIONS(14153),
    [anon_sym_DOT_DOT] = ACTIONS(14153),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14151),
    [anon_sym_and] = ACTIONS(14151),
    [anon_sym_or] = ACTIONS(14151),
    [anon_sym_PIPE_PIPE] = ACTIONS(14151),
    [anon_sym_AMP_AMP] = ACTIONS(14151),
    [anon_sym_LT_LT] = ACTIONS(14151),
    [anon_sym_GT_GT] = ACTIONS(14151),
    [anon_sym_EQ_EQ] = ACTIONS(14153),
    [anon_sym_BANG_EQ] = ACTIONS(14151),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14151),
    [anon_sym_LT_EQ_GT] = ACTIONS(14151),
    [anon_sym_EQ_TILDE] = ACTIONS(14151),
    [anon_sym_BANG_TILDE] = ACTIONS(14151),
    [anon_sym_LT_EQ] = ACTIONS(14153),
    [anon_sym_GT] = ACTIONS(14153),
    [anon_sym_GT_EQ] = ACTIONS(14151),
    [anon_sym_CARET] = ACTIONS(14151),
    [anon_sym_PLUS] = ACTIONS(14151),
    [anon_sym_SLASH] = ACTIONS(14151),
    [anon_sym_PERCENT] = ACTIONS(14151),
    [sym_comment] = ACTIONS(87),
  },
  [10696] = {
    [sym__heredoc_body_start] = ACTIONS(14580),
    [sym__binary_minus] = ACTIONS(14580),
    [sym__binary_star] = ACTIONS(14580),
    [anon_sym_LBRACE] = ACTIONS(14580),
    [anon_sym_RBRACE] = ACTIONS(14580),
    [anon_sym_RPAREN] = ACTIONS(14580),
    [anon_sym_DOT] = ACTIONS(14582),
    [anon_sym_COMMA] = ACTIONS(14580),
    [anon_sym_PIPE] = ACTIONS(14582),
    [anon_sym_SEMI] = ACTIONS(14580),
    [anon_sym_STAR_STAR] = ACTIONS(14580),
    [anon_sym_AMP] = ACTIONS(14582),
    [anon_sym_EQ] = ACTIONS(14582),
    [anon_sym_LT] = ACTIONS(14582),
    [anon_sym_if] = ACTIONS(14580),
    [anon_sym_unless] = ACTIONS(14580),
    [anon_sym_while] = ACTIONS(14580),
    [anon_sym_until] = ACTIONS(14580),
    [anon_sym_rescue] = ACTIONS(14580),
    [anon_sym_in] = ACTIONS(14580),
    [anon_sym_do] = ACTIONS(14580),
    [anon_sym_EQ_GT] = ACTIONS(14580),
    [anon_sym_LBRACK] = ACTIONS(14580),
    [anon_sym_RBRACK] = ACTIONS(14580),
    [anon_sym_COLON_COLON2] = ACTIONS(14580),
    [anon_sym_AMP_DOT] = ACTIONS(14580),
    [anon_sym_QMARK] = ACTIONS(14580),
    [anon_sym_COLON2] = ACTIONS(14582),
    [anon_sym_DOT_DOT] = ACTIONS(14582),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14580),
    [anon_sym_and] = ACTIONS(14580),
    [anon_sym_or] = ACTIONS(14580),
    [anon_sym_PIPE_PIPE] = ACTIONS(14580),
    [anon_sym_AMP_AMP] = ACTIONS(14580),
    [anon_sym_LT_LT] = ACTIONS(14580),
    [anon_sym_GT_GT] = ACTIONS(14580),
    [anon_sym_EQ_EQ] = ACTIONS(14582),
    [anon_sym_BANG_EQ] = ACTIONS(14580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14580),
    [anon_sym_LT_EQ_GT] = ACTIONS(14580),
    [anon_sym_EQ_TILDE] = ACTIONS(14580),
    [anon_sym_BANG_TILDE] = ACTIONS(14580),
    [anon_sym_LT_EQ] = ACTIONS(14582),
    [anon_sym_GT] = ACTIONS(14582),
    [anon_sym_GT_EQ] = ACTIONS(14580),
    [anon_sym_CARET] = ACTIONS(14580),
    [anon_sym_PLUS] = ACTIONS(14580),
    [anon_sym_SLASH] = ACTIONS(14580),
    [anon_sym_PERCENT] = ACTIONS(14580),
    [sym_comment] = ACTIONS(87),
  },
  [10697] = {
    [sym__heredoc_body_start] = ACTIONS(14580),
    [sym__binary_minus] = ACTIONS(14580),
    [sym__binary_star] = ACTIONS(14580),
    [anon_sym_LBRACE] = ACTIONS(14580),
    [anon_sym_RBRACE] = ACTIONS(14580),
    [anon_sym_RPAREN] = ACTIONS(14580),
    [anon_sym_DOT] = ACTIONS(14582),
    [anon_sym_COMMA] = ACTIONS(14580),
    [anon_sym_PIPE] = ACTIONS(14582),
    [anon_sym_SEMI] = ACTIONS(14580),
    [anon_sym_STAR_STAR] = ACTIONS(14582),
    [anon_sym_AMP] = ACTIONS(14582),
    [anon_sym_EQ] = ACTIONS(14582),
    [anon_sym_LT] = ACTIONS(14582),
    [anon_sym_if] = ACTIONS(14580),
    [anon_sym_unless] = ACTIONS(14580),
    [anon_sym_while] = ACTIONS(14580),
    [anon_sym_until] = ACTIONS(14580),
    [anon_sym_rescue] = ACTIONS(14580),
    [anon_sym_in] = ACTIONS(14580),
    [anon_sym_do] = ACTIONS(14580),
    [anon_sym_EQ_GT] = ACTIONS(14580),
    [anon_sym_LBRACK] = ACTIONS(14580),
    [anon_sym_RBRACK] = ACTIONS(14580),
    [anon_sym_COLON_COLON2] = ACTIONS(14580),
    [anon_sym_AMP_DOT] = ACTIONS(14580),
    [anon_sym_PLUS_EQ] = ACTIONS(14580),
    [anon_sym_DASH_EQ] = ACTIONS(14580),
    [anon_sym_STAR_EQ] = ACTIONS(14580),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14580),
    [anon_sym_SLASH_EQ] = ACTIONS(14580),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14580),
    [anon_sym_PIPE_EQ] = ACTIONS(14580),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14580),
    [anon_sym_AMP_EQ] = ACTIONS(14580),
    [anon_sym_PERCENT_EQ] = ACTIONS(14580),
    [anon_sym_GT_GT_EQ] = ACTIONS(14580),
    [anon_sym_LT_LT_EQ] = ACTIONS(14580),
    [anon_sym_CARET_EQ] = ACTIONS(14580),
    [anon_sym_QMARK] = ACTIONS(14580),
    [anon_sym_COLON2] = ACTIONS(14582),
    [anon_sym_DOT_DOT] = ACTIONS(14582),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14580),
    [anon_sym_and] = ACTIONS(14580),
    [anon_sym_or] = ACTIONS(14580),
    [anon_sym_PIPE_PIPE] = ACTIONS(14582),
    [anon_sym_AMP_AMP] = ACTIONS(14582),
    [anon_sym_LT_LT] = ACTIONS(14582),
    [anon_sym_GT_GT] = ACTIONS(14582),
    [anon_sym_EQ_EQ] = ACTIONS(14582),
    [anon_sym_BANG_EQ] = ACTIONS(14580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14580),
    [anon_sym_LT_EQ_GT] = ACTIONS(14580),
    [anon_sym_EQ_TILDE] = ACTIONS(14580),
    [anon_sym_BANG_TILDE] = ACTIONS(14580),
    [anon_sym_LT_EQ] = ACTIONS(14582),
    [anon_sym_GT] = ACTIONS(14582),
    [anon_sym_GT_EQ] = ACTIONS(14580),
    [anon_sym_CARET] = ACTIONS(14582),
    [anon_sym_PLUS] = ACTIONS(14582),
    [anon_sym_SLASH] = ACTIONS(14582),
    [anon_sym_PERCENT] = ACTIONS(14582),
    [sym_comment] = ACTIONS(87),
  },
  [10698] = {
    [sym__simple_symbol] = ACTIONS(15003),
    [sym__string_start] = ACTIONS(15003),
    [sym__symbol_start] = ACTIONS(15003),
    [sym__subshell_start] = ACTIONS(15003),
    [sym__regex_start] = ACTIONS(15003),
    [sym__string_array_start] = ACTIONS(15003),
    [sym__symbol_array_start] = ACTIONS(15003),
    [sym_heredoc_beginning] = ACTIONS(15003),
    [sym__unary_minus] = ACTIONS(15003),
    [anon_sym_BEGIN] = ACTIONS(15005),
    [anon_sym_LBRACE] = ACTIONS(15003),
    [anon_sym_RBRACE] = ACTIONS(15003),
    [anon_sym_END] = ACTIONS(15005),
    [anon_sym_def] = ACTIONS(15005),
    [anon_sym_LPAREN] = ACTIONS(15003),
    [anon_sym_COLON_COLON] = ACTIONS(15003),
    [anon_sym_SEMI] = ACTIONS(15003),
    [anon_sym_STAR] = ACTIONS(15003),
    [anon_sym_class] = ACTIONS(15005),
    [anon_sym_module] = ACTIONS(15005),
    [anon_sym_return] = ACTIONS(15005),
    [anon_sym_yield] = ACTIONS(15005),
    [anon_sym_break] = ACTIONS(15005),
    [anon_sym_next] = ACTIONS(15005),
    [sym_redo] = ACTIONS(15005),
    [sym_retry] = ACTIONS(15005),
    [anon_sym_if] = ACTIONS(15005),
    [anon_sym_unless] = ACTIONS(15005),
    [anon_sym_while] = ACTIONS(15005),
    [anon_sym_until] = ACTIONS(15005),
    [anon_sym_for] = ACTIONS(15005),
    [anon_sym_case] = ACTIONS(15005),
    [anon_sym_begin] = ACTIONS(15005),
    [anon_sym_PLUS] = ACTIONS(15005),
    [anon_sym_defined_QMARK] = ACTIONS(15003),
    [anon_sym_not] = ACTIONS(15005),
    [anon_sym_BANG] = ACTIONS(15003),
    [anon_sym_TILDE] = ACTIONS(15003),
    [sym_constant] = ACTIONS(15005),
    [sym_identifier] = ACTIONS(15005),
    [sym_instance_variable] = ACTIONS(15003),
    [sym_class_variable] = ACTIONS(15003),
    [sym_global_variable] = ACTIONS(15003),
    [anon_sym_undef] = ACTIONS(15005),
    [anon_sym_alias] = ACTIONS(15005),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(15005),
    [sym_float] = ACTIONS(15005),
    [sym_complex] = ACTIONS(15003),
    [sym_super] = ACTIONS(15005),
    [anon_sym_true] = ACTIONS(15005),
    [anon_sym_TRUE] = ACTIONS(15005),
    [anon_sym_false] = ACTIONS(15005),
    [anon_sym_FALSE] = ACTIONS(15005),
    [sym_self] = ACTIONS(15005),
    [anon_sym_nil] = ACTIONS(15005),
    [anon_sym_NIL] = ACTIONS(15005),
    [sym_character] = ACTIONS(15003),
    [anon_sym_LBRACK2] = ACTIONS(15003),
    [anon_sym_DASH_GT] = ACTIONS(15003),
  },
  [10699] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(11070),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(10709),
    [sym_scope_resolution] = STATE(10707),
    [sym_call] = STATE(10707),
    [sym_method_call] = STATE(10709),
    [sym_assignment] = STATE(11070),
    [sym_operator_assignment] = STATE(11070),
    [sym_conditional] = STATE(11070),
    [sym_range] = STATE(11070),
    [sym_binary] = STATE(11070),
    [sym_unary] = STATE(11070),
    [sym_left_assignment_list] = STATE(10708),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10709),
    [sym__variable] = STATE(10707),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(10709),
    [sym_false] = STATE(10709),
    [sym_nil] = STATE(10709),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(10710),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(14424),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(14426),
    [anon_sym_yield] = ACTIONS(14428),
    [anon_sym_break] = ACTIONS(14430),
    [anon_sym_next] = ACTIONS(14432),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14434),
    [anon_sym_defined_QMARK] = ACTIONS(14436),
    [anon_sym_not] = ACTIONS(14438),
    [anon_sym_BANG] = ACTIONS(14440),
    [anon_sym_TILDE] = ACTIONS(14440),
    [sym_constant] = ACTIONS(14442),
    [sym_identifier] = ACTIONS(14442),
    [sym_instance_variable] = ACTIONS(14444),
    [sym_class_variable] = ACTIONS(14444),
    [sym_global_variable] = ACTIONS(14444),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(14442),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14442),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10700] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(9927),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(9932),
    [sym_scope_resolution] = STATE(9928),
    [sym_call] = STATE(9928),
    [sym_method_call] = STATE(9932),
    [sym_argument_list] = STATE(1318),
    [sym__argument_list_with_parens] = STATE(9929),
    [sym__argument] = STATE(9930),
    [sym_splat_argument] = STATE(9930),
    [sym_hash_splat_argument] = STATE(9930),
    [sym_block_argument] = STATE(9930),
    [sym_assignment] = STATE(9927),
    [sym_operator_assignment] = STATE(9927),
    [sym_conditional] = STATE(9927),
    [sym_range] = STATE(9927),
    [sym_binary] = STATE(9927),
    [sym_unary] = STATE(9927),
    [sym_left_assignment_list] = STATE(9931),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9932),
    [sym__variable] = STATE(9928),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(9932),
    [sym_false] = STATE(9932),
    [sym_nil] = STATE(9932),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(9933),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(9930),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(13601),
    [sym__splat_star] = ACTIONS(13603),
    [sym__unary_minus] = ACTIONS(13605),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(13607),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13609),
    [anon_sym_yield] = ACTIONS(13611),
    [anon_sym_break] = ACTIONS(13613),
    [anon_sym_next] = ACTIONS(13615),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_defined_QMARK] = ACTIONS(13617),
    [anon_sym_not] = ACTIONS(13619),
    [anon_sym_BANG] = ACTIONS(13621),
    [anon_sym_TILDE] = ACTIONS(13623),
    [sym_constant] = ACTIONS(13625),
    [sym_identifier] = ACTIONS(13625),
    [sym_instance_variable] = ACTIONS(13627),
    [sym_class_variable] = ACTIONS(13627),
    [sym_global_variable] = ACTIONS(13627),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13629),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13629),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10701] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(9927),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(9932),
    [sym_scope_resolution] = STATE(9928),
    [sym_call] = STATE(9928),
    [sym_method_call] = STATE(9932),
    [sym_argument_list] = STATE(1324),
    [sym__argument_list_with_parens] = STATE(9929),
    [sym__argument] = STATE(9930),
    [sym_splat_argument] = STATE(9930),
    [sym_hash_splat_argument] = STATE(9930),
    [sym_block_argument] = STATE(9930),
    [sym_assignment] = STATE(9927),
    [sym_operator_assignment] = STATE(9927),
    [sym_conditional] = STATE(9927),
    [sym_range] = STATE(9927),
    [sym_binary] = STATE(9927),
    [sym_unary] = STATE(9927),
    [sym_left_assignment_list] = STATE(9931),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9932),
    [sym__variable] = STATE(9928),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(9932),
    [sym_false] = STATE(9932),
    [sym_nil] = STATE(9932),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(9933),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(9930),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(13601),
    [sym__splat_star] = ACTIONS(13603),
    [sym__unary_minus] = ACTIONS(13605),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(13607),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13609),
    [anon_sym_yield] = ACTIONS(13611),
    [anon_sym_break] = ACTIONS(13613),
    [anon_sym_next] = ACTIONS(13615),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(13617),
    [anon_sym_not] = ACTIONS(13619),
    [anon_sym_BANG] = ACTIONS(13621),
    [anon_sym_TILDE] = ACTIONS(13623),
    [sym_constant] = ACTIONS(13625),
    [sym_identifier] = ACTIONS(13625),
    [sym_instance_variable] = ACTIONS(13627),
    [sym_class_variable] = ACTIONS(13627),
    [sym_global_variable] = ACTIONS(13627),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13629),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13629),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10702] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(9927),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(9932),
    [sym_scope_resolution] = STATE(9928),
    [sym_call] = STATE(9928),
    [sym_method_call] = STATE(9932),
    [sym_argument_list] = STATE(1325),
    [sym__argument_list_with_parens] = STATE(9929),
    [sym__argument] = STATE(9930),
    [sym_splat_argument] = STATE(9930),
    [sym_hash_splat_argument] = STATE(9930),
    [sym_block_argument] = STATE(9930),
    [sym_assignment] = STATE(9927),
    [sym_operator_assignment] = STATE(9927),
    [sym_conditional] = STATE(9927),
    [sym_range] = STATE(9927),
    [sym_binary] = STATE(9927),
    [sym_unary] = STATE(9927),
    [sym_left_assignment_list] = STATE(9931),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9932),
    [sym__variable] = STATE(9928),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(9932),
    [sym_false] = STATE(9932),
    [sym_nil] = STATE(9932),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(9933),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(9930),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(13601),
    [sym__splat_star] = ACTIONS(13603),
    [sym__unary_minus] = ACTIONS(13605),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(13607),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13609),
    [anon_sym_yield] = ACTIONS(13611),
    [anon_sym_break] = ACTIONS(13613),
    [anon_sym_next] = ACTIONS(13615),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(13617),
    [anon_sym_not] = ACTIONS(13619),
    [anon_sym_BANG] = ACTIONS(13621),
    [anon_sym_TILDE] = ACTIONS(13623),
    [sym_constant] = ACTIONS(13625),
    [sym_identifier] = ACTIONS(13625),
    [sym_instance_variable] = ACTIONS(13627),
    [sym_class_variable] = ACTIONS(13627),
    [sym_global_variable] = ACTIONS(13627),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13629),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13629),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10703] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(9927),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(9932),
    [sym_scope_resolution] = STATE(9928),
    [sym_call] = STATE(9928),
    [sym_method_call] = STATE(9932),
    [sym_argument_list] = STATE(1326),
    [sym__argument_list_with_parens] = STATE(9929),
    [sym__argument] = STATE(9930),
    [sym_splat_argument] = STATE(9930),
    [sym_hash_splat_argument] = STATE(9930),
    [sym_block_argument] = STATE(9930),
    [sym_assignment] = STATE(9927),
    [sym_operator_assignment] = STATE(9927),
    [sym_conditional] = STATE(9927),
    [sym_range] = STATE(9927),
    [sym_binary] = STATE(9927),
    [sym_unary] = STATE(9927),
    [sym_left_assignment_list] = STATE(9931),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9932),
    [sym__variable] = STATE(9928),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(9932),
    [sym_false] = STATE(9932),
    [sym_nil] = STATE(9932),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(9933),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(9930),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(13601),
    [sym__splat_star] = ACTIONS(13603),
    [sym__unary_minus] = ACTIONS(13605),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(13607),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13609),
    [anon_sym_yield] = ACTIONS(13611),
    [anon_sym_break] = ACTIONS(13613),
    [anon_sym_next] = ACTIONS(13615),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(13617),
    [anon_sym_not] = ACTIONS(13619),
    [anon_sym_BANG] = ACTIONS(13621),
    [anon_sym_TILDE] = ACTIONS(13623),
    [sym_constant] = ACTIONS(13625),
    [sym_identifier] = ACTIONS(13625),
    [sym_instance_variable] = ACTIONS(13627),
    [sym_class_variable] = ACTIONS(13627),
    [sym_global_variable] = ACTIONS(13627),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13629),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13629),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10704] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(11071),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(10709),
    [sym_scope_resolution] = STATE(10707),
    [sym_call] = STATE(10707),
    [sym_method_call] = STATE(10709),
    [sym_assignment] = STATE(11071),
    [sym_operator_assignment] = STATE(11071),
    [sym_conditional] = STATE(11071),
    [sym_range] = STATE(11071),
    [sym_binary] = STATE(11071),
    [sym_unary] = STATE(11071),
    [sym_left_assignment_list] = STATE(10708),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10709),
    [sym__variable] = STATE(10707),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(10709),
    [sym_false] = STATE(10709),
    [sym_nil] = STATE(10709),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(10710),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(14424),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(14426),
    [anon_sym_yield] = ACTIONS(14428),
    [anon_sym_break] = ACTIONS(14430),
    [anon_sym_next] = ACTIONS(14432),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14434),
    [anon_sym_defined_QMARK] = ACTIONS(14436),
    [anon_sym_not] = ACTIONS(14438),
    [anon_sym_BANG] = ACTIONS(14440),
    [anon_sym_TILDE] = ACTIONS(14440),
    [sym_constant] = ACTIONS(14442),
    [sym_identifier] = ACTIONS(14442),
    [sym_instance_variable] = ACTIONS(14444),
    [sym_class_variable] = ACTIONS(14444),
    [sym_global_variable] = ACTIONS(14444),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(14442),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14442),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10705] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(1872),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(10709),
    [sym_scope_resolution] = STATE(10707),
    [sym_call] = STATE(10707),
    [sym_method_call] = STATE(10709),
    [sym_assignment] = STATE(1872),
    [sym_operator_assignment] = STATE(1872),
    [sym_conditional] = STATE(1872),
    [sym_range] = STATE(1872),
    [sym_binary] = STATE(1872),
    [sym_unary] = STATE(1872),
    [sym_left_assignment_list] = STATE(10708),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10709),
    [sym__variable] = STATE(10707),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(10709),
    [sym_false] = STATE(10709),
    [sym_nil] = STATE(10709),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(10710),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(14424),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(14426),
    [anon_sym_yield] = ACTIONS(14428),
    [anon_sym_break] = ACTIONS(14430),
    [anon_sym_next] = ACTIONS(14432),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14434),
    [anon_sym_defined_QMARK] = ACTIONS(14436),
    [anon_sym_not] = ACTIONS(14438),
    [anon_sym_BANG] = ACTIONS(14440),
    [anon_sym_TILDE] = ACTIONS(14440),
    [sym_constant] = ACTIONS(14442),
    [sym_identifier] = ACTIONS(14442),
    [sym_instance_variable] = ACTIONS(14444),
    [sym_class_variable] = ACTIONS(14444),
    [sym_global_variable] = ACTIONS(14444),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(14442),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14442),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10706] = {
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(15007),
    [sym__binary_star] = ACTIONS(15009),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(15011),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(15009),
    [anon_sym_AMP] = ACTIONS(15013),
    [anon_sym_LT] = ACTIONS(15015),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(15017),
    [anon_sym_DOT_DOT] = ACTIONS(15019),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15021),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(15023),
    [anon_sym_AMP_AMP] = ACTIONS(15023),
    [anon_sym_LT_LT] = ACTIONS(15025),
    [anon_sym_GT_GT] = ACTIONS(15025),
    [anon_sym_EQ_EQ] = ACTIONS(15027),
    [anon_sym_BANG_EQ] = ACTIONS(15023),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15023),
    [anon_sym_LT_EQ_GT] = ACTIONS(15023),
    [anon_sym_EQ_TILDE] = ACTIONS(15023),
    [anon_sym_BANG_TILDE] = ACTIONS(15023),
    [anon_sym_LT_EQ] = ACTIONS(15015),
    [anon_sym_GT] = ACTIONS(15015),
    [anon_sym_GT_EQ] = ACTIONS(15029),
    [anon_sym_CARET] = ACTIONS(15031),
    [anon_sym_PLUS] = ACTIONS(15007),
    [anon_sym_SLASH] = ACTIONS(15009),
    [anon_sym_PERCENT] = ACTIONS(15009),
    [sym_comment] = ACTIONS(87),
  },
  [10707] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(9957),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9962),
    [sym_scope_resolution] = STATE(9958),
    [sym_call] = STATE(9958),
    [sym_method_call] = STATE(9962),
    [sym_argument_list] = STATE(1846),
    [sym__argument_list_with_parens] = STATE(9959),
    [sym__argument] = STATE(9960),
    [sym_splat_argument] = STATE(9960),
    [sym_hash_splat_argument] = STATE(9960),
    [sym_block_argument] = STATE(9960),
    [sym_do_block] = STATE(1849),
    [sym_block] = STATE(1849),
    [sym_assignment] = STATE(9957),
    [sym_operator_assignment] = STATE(9957),
    [sym_conditional] = STATE(9957),
    [sym_range] = STATE(9957),
    [sym_binary] = STATE(9957),
    [sym_unary] = STATE(9957),
    [sym_left_assignment_list] = STATE(9961),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9962),
    [sym__variable] = STATE(9958),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9962),
    [sym_false] = STATE(9962),
    [sym_nil] = STATE(9962),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(9963),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(9960),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(13659),
    [sym__splat_star] = ACTIONS(13661),
    [sym__unary_minus] = ACTIONS(13663),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(13665),
    [anon_sym_LBRACE] = ACTIONS(3327),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13667),
    [anon_sym_yield] = ACTIONS(13669),
    [anon_sym_break] = ACTIONS(13671),
    [anon_sym_next] = ACTIONS(13673),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(3337),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(13675),
    [anon_sym_not] = ACTIONS(13677),
    [anon_sym_BANG] = ACTIONS(13679),
    [anon_sym_TILDE] = ACTIONS(13681),
    [sym_constant] = ACTIONS(13683),
    [sym_identifier] = ACTIONS(13683),
    [sym_instance_variable] = ACTIONS(13685),
    [sym_class_variable] = ACTIONS(13685),
    [sym_global_variable] = ACTIONS(13685),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13687),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13687),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [10708] = {
    [anon_sym_EQ] = ACTIONS(15033),
    [sym_comment] = ACTIONS(87),
  },
  [10709] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(15035),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(15037),
    [anon_sym_DASH_EQ] = ACTIONS(15037),
    [anon_sym_STAR_EQ] = ACTIONS(15037),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(15037),
    [anon_sym_SLASH_EQ] = ACTIONS(15037),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(15037),
    [anon_sym_PIPE_EQ] = ACTIONS(15037),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(15037),
    [anon_sym_AMP_EQ] = ACTIONS(15037),
    [anon_sym_PERCENT_EQ] = ACTIONS(15037),
    [anon_sym_GT_GT_EQ] = ACTIONS(15037),
    [anon_sym_LT_LT_EQ] = ACTIONS(15037),
    [anon_sym_CARET_EQ] = ACTIONS(15037),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [10710] = {
    [sym_string] = STATE(11084),
    [aux_sym_chained_string_repeat1] = STATE(11084),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [10711] = {
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(15007),
    [sym__binary_star] = ACTIONS(15009),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(15011),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(15009),
    [anon_sym_AMP] = ACTIONS(15013),
    [anon_sym_LT] = ACTIONS(15015),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(15017),
    [anon_sym_DOT_DOT] = ACTIONS(15019),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15021),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(15023),
    [anon_sym_AMP_AMP] = ACTIONS(15023),
    [anon_sym_LT_LT] = ACTIONS(15025),
    [anon_sym_GT_GT] = ACTIONS(15025),
    [anon_sym_EQ_EQ] = ACTIONS(15027),
    [anon_sym_BANG_EQ] = ACTIONS(15023),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15023),
    [anon_sym_LT_EQ_GT] = ACTIONS(15023),
    [anon_sym_EQ_TILDE] = ACTIONS(15023),
    [anon_sym_BANG_TILDE] = ACTIONS(15023),
    [anon_sym_LT_EQ] = ACTIONS(15015),
    [anon_sym_GT] = ACTIONS(15015),
    [anon_sym_GT_EQ] = ACTIONS(15029),
    [anon_sym_CARET] = ACTIONS(15031),
    [anon_sym_PLUS] = ACTIONS(15007),
    [anon_sym_SLASH] = ACTIONS(15009),
    [anon_sym_PERCENT] = ACTIONS(15009),
    [sym_comment] = ACTIONS(87),
  },
  [10712] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(14462),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [10713] = {
    [sym_string] = STATE(10751),
    [aux_sym_chained_string_repeat1] = STATE(10751),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [10714] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(11085),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(10709),
    [sym_scope_resolution] = STATE(10707),
    [sym_call] = STATE(10707),
    [sym_method_call] = STATE(10709),
    [sym_assignment] = STATE(11085),
    [sym_operator_assignment] = STATE(11085),
    [sym_conditional] = STATE(11085),
    [sym_range] = STATE(11085),
    [sym_binary] = STATE(11085),
    [sym_unary] = STATE(11085),
    [sym_left_assignment_list] = STATE(10708),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10709),
    [sym__variable] = STATE(10707),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(10709),
    [sym_false] = STATE(10709),
    [sym_nil] = STATE(10709),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(10710),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(14424),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(14426),
    [anon_sym_yield] = ACTIONS(14428),
    [anon_sym_break] = ACTIONS(14430),
    [anon_sym_next] = ACTIONS(14432),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14434),
    [anon_sym_defined_QMARK] = ACTIONS(14436),
    [anon_sym_not] = ACTIONS(14438),
    [anon_sym_BANG] = ACTIONS(14440),
    [anon_sym_TILDE] = ACTIONS(14440),
    [sym_constant] = ACTIONS(14442),
    [sym_identifier] = ACTIONS(14442),
    [sym_instance_variable] = ACTIONS(14444),
    [sym_class_variable] = ACTIONS(14444),
    [sym_global_variable] = ACTIONS(14444),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(14442),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14442),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10715] = {
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(15007),
    [sym__binary_star] = ACTIONS(15009),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(15011),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(15009),
    [anon_sym_AMP] = ACTIONS(15013),
    [anon_sym_LT] = ACTIONS(15015),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(15017),
    [anon_sym_DOT_DOT] = ACTIONS(15019),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15021),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(15023),
    [anon_sym_AMP_AMP] = ACTIONS(15023),
    [anon_sym_LT_LT] = ACTIONS(15025),
    [anon_sym_GT_GT] = ACTIONS(15025),
    [anon_sym_EQ_EQ] = ACTIONS(15027),
    [anon_sym_BANG_EQ] = ACTIONS(15023),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15023),
    [anon_sym_LT_EQ_GT] = ACTIONS(15023),
    [anon_sym_EQ_TILDE] = ACTIONS(15023),
    [anon_sym_BANG_TILDE] = ACTIONS(15023),
    [anon_sym_LT_EQ] = ACTIONS(15015),
    [anon_sym_GT] = ACTIONS(15015),
    [anon_sym_GT_EQ] = ACTIONS(15029),
    [anon_sym_CARET] = ACTIONS(15031),
    [anon_sym_PLUS] = ACTIONS(15007),
    [anon_sym_SLASH] = ACTIONS(15009),
    [anon_sym_PERCENT] = ACTIONS(15009),
    [sym_comment] = ACTIONS(87),
  },
  [10716] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(11086),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(9932),
    [sym_scope_resolution] = STATE(9928),
    [sym_call] = STATE(9928),
    [sym_method_call] = STATE(9932),
    [sym_assignment] = STATE(11086),
    [sym_operator_assignment] = STATE(11086),
    [sym_conditional] = STATE(11086),
    [sym_range] = STATE(11086),
    [sym_binary] = STATE(11086),
    [sym_unary] = STATE(11086),
    [sym_left_assignment_list] = STATE(9931),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9932),
    [sym__variable] = STATE(9928),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(9932),
    [sym_false] = STATE(9932),
    [sym_nil] = STATE(9932),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(10713),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(13605),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13609),
    [anon_sym_yield] = ACTIONS(13611),
    [anon_sym_break] = ACTIONS(13613),
    [anon_sym_next] = ACTIONS(13615),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14446),
    [anon_sym_defined_QMARK] = ACTIONS(13617),
    [anon_sym_not] = ACTIONS(13619),
    [anon_sym_BANG] = ACTIONS(13623),
    [anon_sym_TILDE] = ACTIONS(13623),
    [sym_constant] = ACTIONS(13629),
    [sym_identifier] = ACTIONS(13629),
    [sym_instance_variable] = ACTIONS(13627),
    [sym_class_variable] = ACTIONS(13627),
    [sym_global_variable] = ACTIONS(13627),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13629),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13629),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10717] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(11087),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(9932),
    [sym_scope_resolution] = STATE(9928),
    [sym_call] = STATE(9928),
    [sym_method_call] = STATE(9932),
    [sym_assignment] = STATE(11087),
    [sym_operator_assignment] = STATE(11087),
    [sym_conditional] = STATE(11087),
    [sym_range] = STATE(11087),
    [sym_binary] = STATE(11087),
    [sym_unary] = STATE(11087),
    [sym_left_assignment_list] = STATE(9931),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9932),
    [sym__variable] = STATE(9928),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(9932),
    [sym_false] = STATE(9932),
    [sym_nil] = STATE(9932),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(10713),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(13605),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13609),
    [anon_sym_yield] = ACTIONS(13611),
    [anon_sym_break] = ACTIONS(13613),
    [anon_sym_next] = ACTIONS(13615),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14446),
    [anon_sym_defined_QMARK] = ACTIONS(13617),
    [anon_sym_not] = ACTIONS(13619),
    [anon_sym_BANG] = ACTIONS(13623),
    [anon_sym_TILDE] = ACTIONS(13623),
    [sym_constant] = ACTIONS(13629),
    [sym_identifier] = ACTIONS(13629),
    [sym_instance_variable] = ACTIONS(13627),
    [sym_class_variable] = ACTIONS(13627),
    [sym_global_variable] = ACTIONS(13627),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13629),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13629),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10718] = {
    [anon_sym_COLON] = ACTIONS(15039),
    [sym_comment] = ACTIONS(87),
  },
  [10719] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(11089),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(9932),
    [sym_scope_resolution] = STATE(9928),
    [sym_call] = STATE(9928),
    [sym_method_call] = STATE(9932),
    [sym_assignment] = STATE(11089),
    [sym_operator_assignment] = STATE(11089),
    [sym_conditional] = STATE(11089),
    [sym_range] = STATE(11089),
    [sym_binary] = STATE(11089),
    [sym_unary] = STATE(11089),
    [sym_left_assignment_list] = STATE(9931),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9932),
    [sym__variable] = STATE(9928),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(9932),
    [sym_false] = STATE(9932),
    [sym_nil] = STATE(9932),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(10713),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(13605),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13609),
    [anon_sym_yield] = ACTIONS(13611),
    [anon_sym_break] = ACTIONS(13613),
    [anon_sym_next] = ACTIONS(13615),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14446),
    [anon_sym_defined_QMARK] = ACTIONS(13617),
    [anon_sym_not] = ACTIONS(13619),
    [anon_sym_BANG] = ACTIONS(13623),
    [anon_sym_TILDE] = ACTIONS(13623),
    [sym_constant] = ACTIONS(13629),
    [sym_identifier] = ACTIONS(13629),
    [sym_instance_variable] = ACTIONS(13627),
    [sym_class_variable] = ACTIONS(13627),
    [sym_global_variable] = ACTIONS(13627),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13629),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13629),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10720] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(15041),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [10721] = {
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(14460),
    [sym__binary_star] = ACTIONS(14462),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(14464),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(14462),
    [anon_sym_AMP] = ACTIONS(14466),
    [anon_sym_LT] = ACTIONS(14468),
    [anon_sym_EQ_GT] = ACTIONS(1625),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(14470),
    [anon_sym_DOT_DOT] = ACTIONS(14472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14474),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(14476),
    [anon_sym_AMP_AMP] = ACTIONS(14476),
    [anon_sym_LT_LT] = ACTIONS(14478),
    [anon_sym_GT_GT] = ACTIONS(14478),
    [anon_sym_EQ_EQ] = ACTIONS(14480),
    [anon_sym_BANG_EQ] = ACTIONS(14476),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14476),
    [anon_sym_LT_EQ_GT] = ACTIONS(14476),
    [anon_sym_EQ_TILDE] = ACTIONS(14476),
    [anon_sym_BANG_TILDE] = ACTIONS(14476),
    [anon_sym_LT_EQ] = ACTIONS(14468),
    [anon_sym_GT] = ACTIONS(14468),
    [anon_sym_GT_EQ] = ACTIONS(14482),
    [anon_sym_CARET] = ACTIONS(14484),
    [anon_sym_PLUS] = ACTIONS(14460),
    [anon_sym_SLASH] = ACTIONS(14462),
    [anon_sym_PERCENT] = ACTIONS(14462),
    [sym_comment] = ACTIONS(87),
  },
  [10722] = {
    [sym_heredoc_body] = STATE(11091),
    [aux_sym_call_repeat1] = STATE(11091),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [10723] = {
    [sym_heredoc_body] = STATE(11091),
    [aux_sym_call_repeat1] = STATE(11091),
    [aux_sym_argument_list_repeat1] = STATE(11093),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(15043),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [10724] = {
    [sym_string] = STATE(10751),
    [aux_sym_chained_string_repeat1] = STATE(10751),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(15045),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [10725] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(14460),
    [sym__binary_star] = ACTIONS(14462),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(14464),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(14462),
    [anon_sym_AMP] = ACTIONS(14466),
    [anon_sym_LT] = ACTIONS(14468),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(14470),
    [anon_sym_DOT_DOT] = ACTIONS(14472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14474),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(14476),
    [anon_sym_AMP_AMP] = ACTIONS(14476),
    [anon_sym_LT_LT] = ACTIONS(14478),
    [anon_sym_GT_GT] = ACTIONS(14478),
    [anon_sym_EQ_EQ] = ACTIONS(14480),
    [anon_sym_BANG_EQ] = ACTIONS(14476),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14476),
    [anon_sym_LT_EQ_GT] = ACTIONS(14476),
    [anon_sym_EQ_TILDE] = ACTIONS(14476),
    [anon_sym_BANG_TILDE] = ACTIONS(14476),
    [anon_sym_LT_EQ] = ACTIONS(14468),
    [anon_sym_GT] = ACTIONS(14468),
    [anon_sym_GT_EQ] = ACTIONS(14482),
    [anon_sym_CARET] = ACTIONS(14484),
    [anon_sym_PLUS] = ACTIONS(14460),
    [anon_sym_SLASH] = ACTIONS(14462),
    [anon_sym_PERCENT] = ACTIONS(14462),
    [sym_comment] = ACTIONS(87),
  },
  [10726] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(11094),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(10709),
    [sym_scope_resolution] = STATE(10707),
    [sym_call] = STATE(10707),
    [sym_method_call] = STATE(10709),
    [sym_assignment] = STATE(11094),
    [sym_operator_assignment] = STATE(11094),
    [sym_conditional] = STATE(11094),
    [sym_range] = STATE(11094),
    [sym_binary] = STATE(11094),
    [sym_unary] = STATE(11094),
    [sym_left_assignment_list] = STATE(10708),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10709),
    [sym__variable] = STATE(10707),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(10709),
    [sym_false] = STATE(10709),
    [sym_nil] = STATE(10709),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(10710),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(14424),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(14426),
    [anon_sym_yield] = ACTIONS(14428),
    [anon_sym_break] = ACTIONS(14430),
    [anon_sym_next] = ACTIONS(14432),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14434),
    [anon_sym_defined_QMARK] = ACTIONS(14436),
    [anon_sym_not] = ACTIONS(14438),
    [anon_sym_BANG] = ACTIONS(14440),
    [anon_sym_TILDE] = ACTIONS(14440),
    [sym_constant] = ACTIONS(14442),
    [sym_identifier] = ACTIONS(14442),
    [sym_instance_variable] = ACTIONS(14444),
    [sym_class_variable] = ACTIONS(14444),
    [sym_global_variable] = ACTIONS(14444),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(14442),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14442),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10727] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(11095),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(9932),
    [sym_scope_resolution] = STATE(9928),
    [sym_call] = STATE(9928),
    [sym_method_call] = STATE(9932),
    [sym_assignment] = STATE(11095),
    [sym_operator_assignment] = STATE(11095),
    [sym_conditional] = STATE(11095),
    [sym_range] = STATE(11095),
    [sym_binary] = STATE(11095),
    [sym_unary] = STATE(11095),
    [sym_left_assignment_list] = STATE(9931),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9932),
    [sym__variable] = STATE(9928),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(9932),
    [sym_false] = STATE(9932),
    [sym_nil] = STATE(9932),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(10713),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(13605),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13609),
    [anon_sym_yield] = ACTIONS(13611),
    [anon_sym_break] = ACTIONS(13613),
    [anon_sym_next] = ACTIONS(13615),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14446),
    [anon_sym_defined_QMARK] = ACTIONS(13617),
    [anon_sym_not] = ACTIONS(13619),
    [anon_sym_BANG] = ACTIONS(13623),
    [anon_sym_TILDE] = ACTIONS(13623),
    [sym_constant] = ACTIONS(13629),
    [sym_identifier] = ACTIONS(13629),
    [sym_instance_variable] = ACTIONS(13627),
    [sym_class_variable] = ACTIONS(13627),
    [sym_global_variable] = ACTIONS(13627),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13629),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13629),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10728] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(11096),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(9932),
    [sym_scope_resolution] = STATE(9928),
    [sym_call] = STATE(9928),
    [sym_method_call] = STATE(9932),
    [sym_assignment] = STATE(11096),
    [sym_operator_assignment] = STATE(11096),
    [sym_conditional] = STATE(11096),
    [sym_range] = STATE(11096),
    [sym_binary] = STATE(11096),
    [sym_unary] = STATE(11096),
    [sym_left_assignment_list] = STATE(9931),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9932),
    [sym__variable] = STATE(9928),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(9932),
    [sym_false] = STATE(9932),
    [sym_nil] = STATE(9932),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(10713),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(13605),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13609),
    [anon_sym_yield] = ACTIONS(13611),
    [anon_sym_break] = ACTIONS(13613),
    [anon_sym_next] = ACTIONS(13615),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14446),
    [anon_sym_defined_QMARK] = ACTIONS(13617),
    [anon_sym_not] = ACTIONS(13619),
    [anon_sym_BANG] = ACTIONS(13623),
    [anon_sym_TILDE] = ACTIONS(13623),
    [sym_constant] = ACTIONS(13629),
    [sym_identifier] = ACTIONS(13629),
    [sym_instance_variable] = ACTIONS(13627),
    [sym_class_variable] = ACTIONS(13627),
    [sym_global_variable] = ACTIONS(13627),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13629),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13629),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10729] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(11097),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(9932),
    [sym_scope_resolution] = STATE(9928),
    [sym_call] = STATE(9928),
    [sym_method_call] = STATE(9932),
    [sym_assignment] = STATE(11097),
    [sym_operator_assignment] = STATE(11097),
    [sym_conditional] = STATE(11097),
    [sym_range] = STATE(11097),
    [sym_binary] = STATE(11097),
    [sym_unary] = STATE(11097),
    [sym_left_assignment_list] = STATE(9931),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9932),
    [sym__variable] = STATE(9928),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(9932),
    [sym_false] = STATE(9932),
    [sym_nil] = STATE(9932),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(10713),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(13605),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13609),
    [anon_sym_yield] = ACTIONS(13611),
    [anon_sym_break] = ACTIONS(13613),
    [anon_sym_next] = ACTIONS(13615),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14446),
    [anon_sym_defined_QMARK] = ACTIONS(13617),
    [anon_sym_not] = ACTIONS(13619),
    [anon_sym_BANG] = ACTIONS(13623),
    [anon_sym_TILDE] = ACTIONS(13623),
    [sym_constant] = ACTIONS(13629),
    [sym_identifier] = ACTIONS(13629),
    [sym_instance_variable] = ACTIONS(13627),
    [sym_class_variable] = ACTIONS(13627),
    [sym_global_variable] = ACTIONS(13627),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13629),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13629),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10730] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(11098),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(9932),
    [sym_scope_resolution] = STATE(9928),
    [sym_call] = STATE(9928),
    [sym_method_call] = STATE(9932),
    [sym_assignment] = STATE(11098),
    [sym_operator_assignment] = STATE(11098),
    [sym_conditional] = STATE(11098),
    [sym_range] = STATE(11098),
    [sym_binary] = STATE(11098),
    [sym_unary] = STATE(11098),
    [sym_left_assignment_list] = STATE(9931),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9932),
    [sym__variable] = STATE(9928),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(9932),
    [sym_false] = STATE(9932),
    [sym_nil] = STATE(9932),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(10713),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(13605),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13609),
    [anon_sym_yield] = ACTIONS(13611),
    [anon_sym_break] = ACTIONS(13613),
    [anon_sym_next] = ACTIONS(13615),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14446),
    [anon_sym_defined_QMARK] = ACTIONS(13617),
    [anon_sym_not] = ACTIONS(13619),
    [anon_sym_BANG] = ACTIONS(13623),
    [anon_sym_TILDE] = ACTIONS(13623),
    [sym_constant] = ACTIONS(13629),
    [sym_identifier] = ACTIONS(13629),
    [sym_instance_variable] = ACTIONS(13627),
    [sym_class_variable] = ACTIONS(13627),
    [sym_global_variable] = ACTIONS(13627),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13629),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13629),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10731] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(11099),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(9932),
    [sym_scope_resolution] = STATE(9928),
    [sym_call] = STATE(9928),
    [sym_method_call] = STATE(9932),
    [sym_assignment] = STATE(11099),
    [sym_operator_assignment] = STATE(11099),
    [sym_conditional] = STATE(11099),
    [sym_range] = STATE(11099),
    [sym_binary] = STATE(11099),
    [sym_unary] = STATE(11099),
    [sym_left_assignment_list] = STATE(9931),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9932),
    [sym__variable] = STATE(9928),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(9932),
    [sym_false] = STATE(9932),
    [sym_nil] = STATE(9932),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(10713),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(13605),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13609),
    [anon_sym_yield] = ACTIONS(13611),
    [anon_sym_break] = ACTIONS(13613),
    [anon_sym_next] = ACTIONS(13615),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14446),
    [anon_sym_defined_QMARK] = ACTIONS(13617),
    [anon_sym_not] = ACTIONS(13619),
    [anon_sym_BANG] = ACTIONS(13623),
    [anon_sym_TILDE] = ACTIONS(13623),
    [sym_constant] = ACTIONS(13629),
    [sym_identifier] = ACTIONS(13629),
    [sym_instance_variable] = ACTIONS(13627),
    [sym_class_variable] = ACTIONS(13627),
    [sym_global_variable] = ACTIONS(13627),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13629),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13629),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10732] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(11100),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(11100),
    [sym_operator_assignment] = STATE(11100),
    [sym_conditional] = STATE(11100),
    [sym_range] = STATE(11100),
    [sym_binary] = STATE(11100),
    [sym_unary] = STATE(11100),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [10733] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(11101),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(9932),
    [sym_scope_resolution] = STATE(9928),
    [sym_call] = STATE(9928),
    [sym_method_call] = STATE(9932),
    [sym_assignment] = STATE(11101),
    [sym_operator_assignment] = STATE(11101),
    [sym_conditional] = STATE(11101),
    [sym_range] = STATE(11101),
    [sym_binary] = STATE(11101),
    [sym_unary] = STATE(11101),
    [sym_left_assignment_list] = STATE(9931),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9932),
    [sym__variable] = STATE(9928),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(9932),
    [sym_false] = STATE(9932),
    [sym_nil] = STATE(9932),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(10713),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(13605),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13609),
    [anon_sym_yield] = ACTIONS(13611),
    [anon_sym_break] = ACTIONS(13613),
    [anon_sym_next] = ACTIONS(13615),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14446),
    [anon_sym_defined_QMARK] = ACTIONS(13617),
    [anon_sym_not] = ACTIONS(13619),
    [anon_sym_BANG] = ACTIONS(13623),
    [anon_sym_TILDE] = ACTIONS(13623),
    [sym_constant] = ACTIONS(13629),
    [sym_identifier] = ACTIONS(13629),
    [sym_instance_variable] = ACTIONS(13627),
    [sym_class_variable] = ACTIONS(13627),
    [sym_global_variable] = ACTIONS(13627),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13629),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13629),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10734] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(11102),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(9932),
    [sym_scope_resolution] = STATE(9928),
    [sym_call] = STATE(9928),
    [sym_method_call] = STATE(9932),
    [sym_assignment] = STATE(11102),
    [sym_operator_assignment] = STATE(11102),
    [sym_conditional] = STATE(11102),
    [sym_range] = STATE(11102),
    [sym_binary] = STATE(11102),
    [sym_unary] = STATE(11102),
    [sym_left_assignment_list] = STATE(9931),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9932),
    [sym__variable] = STATE(9928),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(9932),
    [sym_false] = STATE(9932),
    [sym_nil] = STATE(9932),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(10713),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(13605),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13609),
    [anon_sym_yield] = ACTIONS(13611),
    [anon_sym_break] = ACTIONS(13613),
    [anon_sym_next] = ACTIONS(13615),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14446),
    [anon_sym_defined_QMARK] = ACTIONS(13617),
    [anon_sym_not] = ACTIONS(13619),
    [anon_sym_BANG] = ACTIONS(13623),
    [anon_sym_TILDE] = ACTIONS(13623),
    [sym_constant] = ACTIONS(13629),
    [sym_identifier] = ACTIONS(13629),
    [sym_instance_variable] = ACTIONS(13627),
    [sym_class_variable] = ACTIONS(13627),
    [sym_global_variable] = ACTIONS(13627),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13629),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13629),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10735] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(11103),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(9932),
    [sym_scope_resolution] = STATE(9928),
    [sym_call] = STATE(9928),
    [sym_method_call] = STATE(9932),
    [sym_assignment] = STATE(11103),
    [sym_operator_assignment] = STATE(11103),
    [sym_conditional] = STATE(11103),
    [sym_range] = STATE(11103),
    [sym_binary] = STATE(11103),
    [sym_unary] = STATE(11103),
    [sym_left_assignment_list] = STATE(9931),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9932),
    [sym__variable] = STATE(9928),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(9932),
    [sym_false] = STATE(9932),
    [sym_nil] = STATE(9932),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(10713),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(13605),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13609),
    [anon_sym_yield] = ACTIONS(13611),
    [anon_sym_break] = ACTIONS(13613),
    [anon_sym_next] = ACTIONS(13615),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14446),
    [anon_sym_defined_QMARK] = ACTIONS(13617),
    [anon_sym_not] = ACTIONS(13619),
    [anon_sym_BANG] = ACTIONS(13623),
    [anon_sym_TILDE] = ACTIONS(13623),
    [sym_constant] = ACTIONS(13629),
    [sym_identifier] = ACTIONS(13629),
    [sym_instance_variable] = ACTIONS(13627),
    [sym_class_variable] = ACTIONS(13627),
    [sym_global_variable] = ACTIONS(13627),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13629),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13629),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10736] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(11104),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(9932),
    [sym_scope_resolution] = STATE(9928),
    [sym_call] = STATE(9928),
    [sym_method_call] = STATE(9932),
    [sym_assignment] = STATE(11104),
    [sym_operator_assignment] = STATE(11104),
    [sym_conditional] = STATE(11104),
    [sym_range] = STATE(11104),
    [sym_binary] = STATE(11104),
    [sym_unary] = STATE(11104),
    [sym_left_assignment_list] = STATE(9931),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9932),
    [sym__variable] = STATE(9928),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(9932),
    [sym_false] = STATE(9932),
    [sym_nil] = STATE(9932),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(10713),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(13605),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13609),
    [anon_sym_yield] = ACTIONS(13611),
    [anon_sym_break] = ACTIONS(13613),
    [anon_sym_next] = ACTIONS(13615),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14446),
    [anon_sym_defined_QMARK] = ACTIONS(13617),
    [anon_sym_not] = ACTIONS(13619),
    [anon_sym_BANG] = ACTIONS(13623),
    [anon_sym_TILDE] = ACTIONS(13623),
    [sym_constant] = ACTIONS(13629),
    [sym_identifier] = ACTIONS(13629),
    [sym_instance_variable] = ACTIONS(13627),
    [sym_class_variable] = ACTIONS(13627),
    [sym_global_variable] = ACTIONS(13627),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13629),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13629),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10737] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(11105),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9962),
    [sym_scope_resolution] = STATE(9958),
    [sym_call] = STATE(9958),
    [sym_method_call] = STATE(9962),
    [sym_assignment] = STATE(11105),
    [sym_operator_assignment] = STATE(11105),
    [sym_conditional] = STATE(11105),
    [sym_range] = STATE(11105),
    [sym_binary] = STATE(11105),
    [sym_unary] = STATE(11105),
    [sym_left_assignment_list] = STATE(9961),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9962),
    [sym__variable] = STATE(9958),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9962),
    [sym_false] = STATE(9962),
    [sym_nil] = STATE(9962),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10776),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(13663),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13667),
    [anon_sym_yield] = ACTIONS(13669),
    [anon_sym_break] = ACTIONS(13671),
    [anon_sym_next] = ACTIONS(13673),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(14528),
    [anon_sym_defined_QMARK] = ACTIONS(13675),
    [anon_sym_not] = ACTIONS(13677),
    [anon_sym_BANG] = ACTIONS(13681),
    [anon_sym_TILDE] = ACTIONS(13681),
    [sym_constant] = ACTIONS(13687),
    [sym_identifier] = ACTIONS(13687),
    [sym_instance_variable] = ACTIONS(13685),
    [sym_class_variable] = ACTIONS(13685),
    [sym_global_variable] = ACTIONS(13685),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13687),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13687),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [10738] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(11106),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9962),
    [sym_scope_resolution] = STATE(9958),
    [sym_call] = STATE(9958),
    [sym_method_call] = STATE(9962),
    [sym_assignment] = STATE(11106),
    [sym_operator_assignment] = STATE(11106),
    [sym_conditional] = STATE(11106),
    [sym_range] = STATE(11106),
    [sym_binary] = STATE(11106),
    [sym_unary] = STATE(11106),
    [sym_left_assignment_list] = STATE(9961),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9962),
    [sym__variable] = STATE(9958),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9962),
    [sym_false] = STATE(9962),
    [sym_nil] = STATE(9962),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10776),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(13663),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13667),
    [anon_sym_yield] = ACTIONS(13669),
    [anon_sym_break] = ACTIONS(13671),
    [anon_sym_next] = ACTIONS(13673),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(14528),
    [anon_sym_defined_QMARK] = ACTIONS(13675),
    [anon_sym_not] = ACTIONS(13677),
    [anon_sym_BANG] = ACTIONS(13681),
    [anon_sym_TILDE] = ACTIONS(13681),
    [sym_constant] = ACTIONS(13687),
    [sym_identifier] = ACTIONS(13687),
    [sym_instance_variable] = ACTIONS(13685),
    [sym_class_variable] = ACTIONS(13685),
    [sym_global_variable] = ACTIONS(13685),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13687),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13687),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [10739] = {
    [anon_sym_COLON] = ACTIONS(15047),
    [sym_comment] = ACTIONS(87),
  },
  [10740] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(11108),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9962),
    [sym_scope_resolution] = STATE(9958),
    [sym_call] = STATE(9958),
    [sym_method_call] = STATE(9962),
    [sym_assignment] = STATE(11108),
    [sym_operator_assignment] = STATE(11108),
    [sym_conditional] = STATE(11108),
    [sym_range] = STATE(11108),
    [sym_binary] = STATE(11108),
    [sym_unary] = STATE(11108),
    [sym_left_assignment_list] = STATE(9961),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9962),
    [sym__variable] = STATE(9958),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9962),
    [sym_false] = STATE(9962),
    [sym_nil] = STATE(9962),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10776),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(13663),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13667),
    [anon_sym_yield] = ACTIONS(13669),
    [anon_sym_break] = ACTIONS(13671),
    [anon_sym_next] = ACTIONS(13673),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(14528),
    [anon_sym_defined_QMARK] = ACTIONS(13675),
    [anon_sym_not] = ACTIONS(13677),
    [anon_sym_BANG] = ACTIONS(13681),
    [anon_sym_TILDE] = ACTIONS(13681),
    [sym_constant] = ACTIONS(13687),
    [sym_identifier] = ACTIONS(13687),
    [sym_instance_variable] = ACTIONS(13685),
    [sym_class_variable] = ACTIONS(13685),
    [sym_global_variable] = ACTIONS(13685),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13687),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13687),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [10741] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(15049),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [10742] = {
    [sym__heredoc_body_start] = ACTIONS(1625),
    [sym__binary_minus] = ACTIONS(14534),
    [sym__binary_star] = ACTIONS(14536),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(14538),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(14540),
    [anon_sym_AMP] = ACTIONS(14542),
    [anon_sym_EQ] = ACTIONS(1631),
    [anon_sym_LT] = ACTIONS(14544),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(1625),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_COLON_COLON2] = ACTIONS(1625),
    [anon_sym_AMP_DOT] = ACTIONS(1625),
    [anon_sym_PLUS_EQ] = ACTIONS(1625),
    [anon_sym_DASH_EQ] = ACTIONS(1625),
    [anon_sym_STAR_EQ] = ACTIONS(1625),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1625),
    [anon_sym_SLASH_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_PIPE_EQ] = ACTIONS(1625),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1625),
    [anon_sym_AMP_EQ] = ACTIONS(1625),
    [anon_sym_PERCENT_EQ] = ACTIONS(1625),
    [anon_sym_GT_GT_EQ] = ACTIONS(1625),
    [anon_sym_LT_LT_EQ] = ACTIONS(1625),
    [anon_sym_CARET_EQ] = ACTIONS(1625),
    [anon_sym_QMARK] = ACTIONS(14546),
    [anon_sym_DOT_DOT] = ACTIONS(14548),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14550),
    [anon_sym_and] = ACTIONS(1625),
    [anon_sym_or] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(14552),
    [anon_sym_AMP_AMP] = ACTIONS(14552),
    [anon_sym_LT_LT] = ACTIONS(14554),
    [anon_sym_GT_GT] = ACTIONS(14554),
    [anon_sym_EQ_EQ] = ACTIONS(14552),
    [anon_sym_BANG_EQ] = ACTIONS(14556),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14556),
    [anon_sym_LT_EQ_GT] = ACTIONS(14556),
    [anon_sym_EQ_TILDE] = ACTIONS(14556),
    [anon_sym_BANG_TILDE] = ACTIONS(14556),
    [anon_sym_LT_EQ] = ACTIONS(14544),
    [anon_sym_GT] = ACTIONS(14544),
    [anon_sym_GT_EQ] = ACTIONS(14558),
    [anon_sym_CARET] = ACTIONS(14538),
    [anon_sym_PLUS] = ACTIONS(14560),
    [anon_sym_SLASH] = ACTIONS(14540),
    [anon_sym_PERCENT] = ACTIONS(14540),
    [sym_comment] = ACTIONS(87),
  },
  [10743] = {
    [sym_heredoc_body] = STATE(11110),
    [aux_sym_call_repeat1] = STATE(11110),
    [sym__heredoc_body_start] = ACTIONS(3543),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [10744] = {
    [sym_heredoc_body] = STATE(11110),
    [aux_sym_call_repeat1] = STATE(11110),
    [aux_sym_argument_list_repeat1] = STATE(11112),
    [sym__heredoc_body_start] = ACTIONS(3543),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(15051),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_do] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
    [anon_sym_STAR_EQ] = ACTIONS(1681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1681),
    [anon_sym_SLASH_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_EQ] = ACTIONS(1681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1681),
    [anon_sym_AMP_EQ] = ACTIONS(1681),
    [anon_sym_PERCENT_EQ] = ACTIONS(1681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1681),
    [anon_sym_LT_LT_EQ] = ACTIONS(1681),
    [anon_sym_CARET_EQ] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1685),
    [sym_comment] = ACTIONS(87),
  },
  [10745] = {
    [sym_string] = STATE(10796),
    [aux_sym_chained_string_repeat1] = STATE(10796),
    [sym__string_start] = ACTIONS(1141),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(15053),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [10746] = {
    [sym_heredoc_body] = STATE(11113),
    [aux_sym_call_repeat1] = STATE(11113),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [10747] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(9927),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(9932),
    [sym_scope_resolution] = STATE(9928),
    [sym_call] = STATE(9928),
    [sym_method_call] = STATE(9932),
    [sym__argument] = STATE(4250),
    [sym_splat_argument] = STATE(4250),
    [sym_hash_splat_argument] = STATE(4250),
    [sym_block_argument] = STATE(4250),
    [sym_assignment] = STATE(9927),
    [sym_operator_assignment] = STATE(9927),
    [sym_conditional] = STATE(9927),
    [sym_range] = STATE(9927),
    [sym_binary] = STATE(9927),
    [sym_unary] = STATE(9927),
    [sym_left_assignment_list] = STATE(9931),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9932),
    [sym__variable] = STATE(9928),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(9932),
    [sym_false] = STATE(9932),
    [sym_nil] = STATE(9932),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(9933),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_heredoc_body] = STATE(11114),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(4250),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(13601),
    [sym__splat_star] = ACTIONS(13603),
    [sym__unary_minus] = ACTIONS(13605),
    [sym__identifier_hash_key] = ACTIONS(13607),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(15055),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13609),
    [anon_sym_yield] = ACTIONS(13611),
    [anon_sym_break] = ACTIONS(13613),
    [anon_sym_next] = ACTIONS(13615),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14446),
    [anon_sym_defined_QMARK] = ACTIONS(13617),
    [anon_sym_not] = ACTIONS(13619),
    [anon_sym_BANG] = ACTIONS(13623),
    [anon_sym_TILDE] = ACTIONS(13623),
    [sym_constant] = ACTIONS(13625),
    [sym_identifier] = ACTIONS(13625),
    [sym_instance_variable] = ACTIONS(13627),
    [sym_class_variable] = ACTIONS(13627),
    [sym_global_variable] = ACTIONS(13627),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13629),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13629),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10748] = {
    [sym_heredoc_body] = STATE(11115),
    [aux_sym_call_repeat1] = STATE(11115),
    [aux_sym_argument_list_repeat1] = STATE(11116),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(14494),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [10749] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(11117),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(9932),
    [sym_scope_resolution] = STATE(9928),
    [sym_call] = STATE(9928),
    [sym_method_call] = STATE(9932),
    [sym_splat_argument] = STATE(11118),
    [sym_assignment] = STATE(11117),
    [sym_operator_assignment] = STATE(11117),
    [sym_conditional] = STATE(11117),
    [sym_range] = STATE(11117),
    [sym_binary] = STATE(11117),
    [sym_unary] = STATE(11117),
    [sym_right_assignment_list] = STATE(4255),
    [sym__arg_or_splat_arg] = STATE(11118),
    [sym_left_assignment_list] = STATE(9931),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9932),
    [sym__variable] = STATE(9928),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(9932),
    [sym_false] = STATE(9932),
    [sym_nil] = STATE(9932),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(10713),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(14452),
    [sym__unary_minus] = ACTIONS(13605),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13609),
    [anon_sym_yield] = ACTIONS(13611),
    [anon_sym_break] = ACTIONS(13613),
    [anon_sym_next] = ACTIONS(13615),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14446),
    [anon_sym_defined_QMARK] = ACTIONS(13617),
    [anon_sym_not] = ACTIONS(13619),
    [anon_sym_BANG] = ACTIONS(13623),
    [anon_sym_TILDE] = ACTIONS(13623),
    [sym_constant] = ACTIONS(13629),
    [sym_identifier] = ACTIONS(13629),
    [sym_instance_variable] = ACTIONS(13627),
    [sym_class_variable] = ACTIONS(13627),
    [sym_global_variable] = ACTIONS(13627),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13629),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13629),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10750] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(11119),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(9932),
    [sym_scope_resolution] = STATE(9928),
    [sym_call] = STATE(9928),
    [sym_method_call] = STATE(9932),
    [sym_assignment] = STATE(11119),
    [sym_operator_assignment] = STATE(11119),
    [sym_conditional] = STATE(11119),
    [sym_range] = STATE(11119),
    [sym_binary] = STATE(11119),
    [sym_unary] = STATE(11119),
    [sym_left_assignment_list] = STATE(9931),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9932),
    [sym__variable] = STATE(9928),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(9932),
    [sym_false] = STATE(9932),
    [sym_nil] = STATE(9932),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(10713),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(13605),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13609),
    [anon_sym_yield] = ACTIONS(13611),
    [anon_sym_break] = ACTIONS(13613),
    [anon_sym_next] = ACTIONS(13615),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14446),
    [anon_sym_defined_QMARK] = ACTIONS(13617),
    [anon_sym_not] = ACTIONS(13619),
    [anon_sym_BANG] = ACTIONS(13623),
    [anon_sym_TILDE] = ACTIONS(13623),
    [sym_constant] = ACTIONS(13629),
    [sym_identifier] = ACTIONS(13629),
    [sym_instance_variable] = ACTIONS(13627),
    [sym_class_variable] = ACTIONS(13627),
    [sym_global_variable] = ACTIONS(13627),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13629),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13629),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10751] = {
    [sym_string] = STATE(11120),
    [aux_sym_chained_string_repeat1] = STATE(11120),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_EQ_GT] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [10752] = {
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(13633),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13633),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(13633),
    [anon_sym_PERCENT] = ACTIONS(13633),
    [sym_comment] = ACTIONS(87),
  },
  [10753] = {
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13633),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [10754] = {
    [sym__binary_minus] = ACTIONS(13631),
    [sym__binary_star] = ACTIONS(13633),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13633),
    [anon_sym_AMP] = ACTIONS(13637),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(13651),
    [anon_sym_GT_GT] = ACTIONS(13651),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(13631),
    [anon_sym_SLASH] = ACTIONS(13633),
    [anon_sym_PERCENT] = ACTIONS(13633),
    [sym_comment] = ACTIONS(87),
  },
  [10755] = {
    [sym__binary_minus] = ACTIONS(13631),
    [sym__binary_star] = ACTIONS(13633),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13633),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(13651),
    [anon_sym_GT_GT] = ACTIONS(13651),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(13631),
    [anon_sym_SLASH] = ACTIONS(13633),
    [anon_sym_PERCENT] = ACTIONS(13633),
    [sym_comment] = ACTIONS(87),
  },
  [10756] = {
    [sym__binary_minus] = ACTIONS(13631),
    [sym__binary_star] = ACTIONS(13633),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(14504),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13633),
    [anon_sym_AMP] = ACTIONS(13637),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(13651),
    [anon_sym_GT_GT] = ACTIONS(13651),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(13657),
    [anon_sym_PLUS] = ACTIONS(13631),
    [anon_sym_SLASH] = ACTIONS(13633),
    [anon_sym_PERCENT] = ACTIONS(13633),
    [sym_comment] = ACTIONS(87),
  },
  [10757] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(15057),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [10758] = {
    [sym__binary_minus] = ACTIONS(13631),
    [sym__binary_star] = ACTIONS(13633),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(14504),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(13633),
    [anon_sym_AMP] = ACTIONS(13637),
    [anon_sym_LT] = ACTIONS(13639),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(13643),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13645),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(13649),
    [anon_sym_AMP_AMP] = ACTIONS(13649),
    [anon_sym_LT_LT] = ACTIONS(13651),
    [anon_sym_GT_GT] = ACTIONS(13651),
    [anon_sym_EQ_EQ] = ACTIONS(13653),
    [anon_sym_BANG_EQ] = ACTIONS(13649),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13649),
    [anon_sym_LT_EQ_GT] = ACTIONS(13649),
    [anon_sym_EQ_TILDE] = ACTIONS(13649),
    [anon_sym_BANG_TILDE] = ACTIONS(13649),
    [anon_sym_LT_EQ] = ACTIONS(13639),
    [anon_sym_GT] = ACTIONS(13639),
    [anon_sym_GT_EQ] = ACTIONS(13655),
    [anon_sym_CARET] = ACTIONS(13657),
    [anon_sym_PLUS] = ACTIONS(13631),
    [anon_sym_SLASH] = ACTIONS(13633),
    [anon_sym_PERCENT] = ACTIONS(13633),
    [sym_comment] = ACTIONS(87),
  },
  [10759] = {
    [sym__binary_minus] = ACTIONS(13631),
    [sym__binary_star] = ACTIONS(13633),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(14504),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13633),
    [anon_sym_AMP] = ACTIONS(13637),
    [anon_sym_LT] = ACTIONS(13639),
    [anon_sym_QMARK] = ACTIONS(13641),
    [anon_sym_DOT_DOT] = ACTIONS(13643),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13645),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(13649),
    [anon_sym_AMP_AMP] = ACTIONS(13649),
    [anon_sym_LT_LT] = ACTIONS(13651),
    [anon_sym_GT_GT] = ACTIONS(13651),
    [anon_sym_EQ_EQ] = ACTIONS(13653),
    [anon_sym_BANG_EQ] = ACTIONS(13649),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13649),
    [anon_sym_LT_EQ_GT] = ACTIONS(13649),
    [anon_sym_EQ_TILDE] = ACTIONS(13649),
    [anon_sym_BANG_TILDE] = ACTIONS(13649),
    [anon_sym_LT_EQ] = ACTIONS(13639),
    [anon_sym_GT] = ACTIONS(13639),
    [anon_sym_GT_EQ] = ACTIONS(13655),
    [anon_sym_CARET] = ACTIONS(13657),
    [anon_sym_PLUS] = ACTIONS(13631),
    [anon_sym_SLASH] = ACTIONS(13633),
    [anon_sym_PERCENT] = ACTIONS(13633),
    [sym_comment] = ACTIONS(87),
  },
  [10760] = {
    [sym__binary_minus] = ACTIONS(13631),
    [sym__binary_star] = ACTIONS(13633),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(14504),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13633),
    [anon_sym_AMP] = ACTIONS(13637),
    [anon_sym_LT] = ACTIONS(13639),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(13651),
    [anon_sym_GT_GT] = ACTIONS(13651),
    [anon_sym_EQ_EQ] = ACTIONS(13653),
    [anon_sym_BANG_EQ] = ACTIONS(13649),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13649),
    [anon_sym_LT_EQ_GT] = ACTIONS(13649),
    [anon_sym_EQ_TILDE] = ACTIONS(13649),
    [anon_sym_BANG_TILDE] = ACTIONS(13649),
    [anon_sym_LT_EQ] = ACTIONS(13639),
    [anon_sym_GT] = ACTIONS(13639),
    [anon_sym_GT_EQ] = ACTIONS(13655),
    [anon_sym_CARET] = ACTIONS(13657),
    [anon_sym_PLUS] = ACTIONS(13631),
    [anon_sym_SLASH] = ACTIONS(13633),
    [anon_sym_PERCENT] = ACTIONS(13633),
    [sym_comment] = ACTIONS(87),
  },
  [10761] = {
    [sym__binary_minus] = ACTIONS(13631),
    [sym__binary_star] = ACTIONS(13633),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(13633),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(13631),
    [anon_sym_SLASH] = ACTIONS(13633),
    [anon_sym_PERCENT] = ACTIONS(13633),
    [sym_comment] = ACTIONS(87),
  },
  [10762] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(11122),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(10772),
    [sym_scope_resolution] = STATE(10770),
    [sym_call] = STATE(10770),
    [sym_method_call] = STATE(10772),
    [sym_assignment] = STATE(11122),
    [sym_operator_assignment] = STATE(11122),
    [sym_conditional] = STATE(11122),
    [sym_range] = STATE(11122),
    [sym_binary] = STATE(11122),
    [sym_unary] = STATE(11122),
    [sym_left_assignment_list] = STATE(10771),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10772),
    [sym__variable] = STATE(10770),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(10772),
    [sym_false] = STATE(10772),
    [sym_nil] = STATE(10772),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(10773),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(14506),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(14508),
    [anon_sym_yield] = ACTIONS(14510),
    [anon_sym_break] = ACTIONS(14512),
    [anon_sym_next] = ACTIONS(14514),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(14516),
    [anon_sym_defined_QMARK] = ACTIONS(14518),
    [anon_sym_not] = ACTIONS(14520),
    [anon_sym_BANG] = ACTIONS(14522),
    [anon_sym_TILDE] = ACTIONS(14522),
    [sym_constant] = ACTIONS(14524),
    [sym_identifier] = ACTIONS(14524),
    [sym_instance_variable] = ACTIONS(14526),
    [sym_class_variable] = ACTIONS(14526),
    [sym_global_variable] = ACTIONS(14526),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(14524),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14524),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [10763] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(9957),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9962),
    [sym_scope_resolution] = STATE(9958),
    [sym_call] = STATE(9958),
    [sym_method_call] = STATE(9962),
    [sym_argument_list] = STATE(6614),
    [sym__argument_list_with_parens] = STATE(9959),
    [sym__argument] = STATE(9960),
    [sym_splat_argument] = STATE(9960),
    [sym_hash_splat_argument] = STATE(9960),
    [sym_block_argument] = STATE(9960),
    [sym_assignment] = STATE(9957),
    [sym_operator_assignment] = STATE(9957),
    [sym_conditional] = STATE(9957),
    [sym_range] = STATE(9957),
    [sym_binary] = STATE(9957),
    [sym_unary] = STATE(9957),
    [sym_left_assignment_list] = STATE(9961),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9962),
    [sym__variable] = STATE(9958),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9962),
    [sym_false] = STATE(9962),
    [sym_nil] = STATE(9962),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(9963),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(9960),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(365),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(13659),
    [sym__splat_star] = ACTIONS(13661),
    [sym__unary_minus] = ACTIONS(13663),
    [sym__binary_minus] = ACTIONS(365),
    [sym__binary_star] = ACTIONS(365),
    [sym__identifier_hash_key] = ACTIONS(13665),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13667),
    [anon_sym_yield] = ACTIONS(13669),
    [anon_sym_break] = ACTIONS(13671),
    [anon_sym_next] = ACTIONS(13673),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_COLON_COLON2] = ACTIONS(365),
    [anon_sym_AMP_DOT] = ACTIONS(365),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_PLUS_EQ] = ACTIONS(365),
    [anon_sym_DASH_EQ] = ACTIONS(365),
    [anon_sym_STAR_EQ] = ACTIONS(365),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(365),
    [anon_sym_SLASH_EQ] = ACTIONS(365),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(365),
    [anon_sym_PIPE_EQ] = ACTIONS(365),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(365),
    [anon_sym_AMP_EQ] = ACTIONS(365),
    [anon_sym_PERCENT_EQ] = ACTIONS(365),
    [anon_sym_GT_GT_EQ] = ACTIONS(365),
    [anon_sym_LT_LT_EQ] = ACTIONS(365),
    [anon_sym_CARET_EQ] = ACTIONS(365),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(365),
    [anon_sym_LT_EQ_GT] = ACTIONS(365),
    [anon_sym_EQ_TILDE] = ACTIONS(365),
    [anon_sym_BANG_TILDE] = ACTIONS(365),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_EQ] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_PERCENT] = ACTIONS(377),
    [anon_sym_defined_QMARK] = ACTIONS(13675),
    [anon_sym_not] = ACTIONS(13677),
    [anon_sym_BANG] = ACTIONS(13679),
    [anon_sym_TILDE] = ACTIONS(13681),
    [sym_constant] = ACTIONS(13683),
    [sym_identifier] = ACTIONS(13683),
    [sym_instance_variable] = ACTIONS(13685),
    [sym_class_variable] = ACTIONS(13685),
    [sym_global_variable] = ACTIONS(13685),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13687),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13687),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [10764] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(9957),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9962),
    [sym_scope_resolution] = STATE(9958),
    [sym_call] = STATE(9958),
    [sym_method_call] = STATE(9962),
    [sym_argument_list] = STATE(6615),
    [sym__argument_list_with_parens] = STATE(9959),
    [sym__argument] = STATE(9960),
    [sym_splat_argument] = STATE(9960),
    [sym_hash_splat_argument] = STATE(9960),
    [sym_block_argument] = STATE(9960),
    [sym_assignment] = STATE(9957),
    [sym_operator_assignment] = STATE(9957),
    [sym_conditional] = STATE(9957),
    [sym_range] = STATE(9957),
    [sym_binary] = STATE(9957),
    [sym_unary] = STATE(9957),
    [sym_left_assignment_list] = STATE(9961),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9962),
    [sym__variable] = STATE(9958),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9962),
    [sym_false] = STATE(9962),
    [sym_nil] = STATE(9962),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(9963),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(9960),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(417),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(13659),
    [sym__splat_star] = ACTIONS(13661),
    [sym__unary_minus] = ACTIONS(13663),
    [sym__binary_minus] = ACTIONS(417),
    [sym__binary_star] = ACTIONS(417),
    [sym__identifier_hash_key] = ACTIONS(13665),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_EQ] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13667),
    [anon_sym_yield] = ACTIONS(13669),
    [anon_sym_break] = ACTIONS(13671),
    [anon_sym_next] = ACTIONS(13673),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(417),
    [anon_sym_AMP_DOT] = ACTIONS(417),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_PLUS_EQ] = ACTIONS(417),
    [anon_sym_DASH_EQ] = ACTIONS(417),
    [anon_sym_STAR_EQ] = ACTIONS(417),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(417),
    [anon_sym_SLASH_EQ] = ACTIONS(417),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(417),
    [anon_sym_PIPE_EQ] = ACTIONS(417),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(417),
    [anon_sym_AMP_EQ] = ACTIONS(417),
    [anon_sym_PERCENT_EQ] = ACTIONS(417),
    [anon_sym_GT_GT_EQ] = ACTIONS(417),
    [anon_sym_LT_LT_EQ] = ACTIONS(417),
    [anon_sym_CARET_EQ] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ_GT] = ACTIONS(417),
    [anon_sym_EQ_TILDE] = ACTIONS(417),
    [anon_sym_BANG_TILDE] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(13675),
    [anon_sym_not] = ACTIONS(13677),
    [anon_sym_BANG] = ACTIONS(13679),
    [anon_sym_TILDE] = ACTIONS(13681),
    [sym_constant] = ACTIONS(13683),
    [sym_identifier] = ACTIONS(13683),
    [sym_instance_variable] = ACTIONS(13685),
    [sym_class_variable] = ACTIONS(13685),
    [sym_global_variable] = ACTIONS(13685),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13687),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13687),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [10765] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(9957),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9962),
    [sym_scope_resolution] = STATE(9958),
    [sym_call] = STATE(9958),
    [sym_method_call] = STATE(9962),
    [sym_argument_list] = STATE(6616),
    [sym__argument_list_with_parens] = STATE(9959),
    [sym__argument] = STATE(9960),
    [sym_splat_argument] = STATE(9960),
    [sym_hash_splat_argument] = STATE(9960),
    [sym_block_argument] = STATE(9960),
    [sym_assignment] = STATE(9957),
    [sym_operator_assignment] = STATE(9957),
    [sym_conditional] = STATE(9957),
    [sym_range] = STATE(9957),
    [sym_binary] = STATE(9957),
    [sym_unary] = STATE(9957),
    [sym_left_assignment_list] = STATE(9961),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9962),
    [sym__variable] = STATE(9958),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9962),
    [sym_false] = STATE(9962),
    [sym_nil] = STATE(9962),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(9963),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(9960),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(421),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(13659),
    [sym__splat_star] = ACTIONS(13661),
    [sym__unary_minus] = ACTIONS(13663),
    [sym__binary_minus] = ACTIONS(421),
    [sym__binary_star] = ACTIONS(421),
    [sym__identifier_hash_key] = ACTIONS(13665),
    [anon_sym_LBRACE] = ACTIONS(421),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_EQ] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13667),
    [anon_sym_yield] = ACTIONS(13669),
    [anon_sym_break] = ACTIONS(13671),
    [anon_sym_next] = ACTIONS(13673),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(421),
    [anon_sym_AMP_DOT] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_PLUS_EQ] = ACTIONS(421),
    [anon_sym_DASH_EQ] = ACTIONS(421),
    [anon_sym_STAR_EQ] = ACTIONS(421),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(421),
    [anon_sym_SLASH_EQ] = ACTIONS(421),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(421),
    [anon_sym_PIPE_EQ] = ACTIONS(421),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(421),
    [anon_sym_AMP_EQ] = ACTIONS(421),
    [anon_sym_PERCENT_EQ] = ACTIONS(421),
    [anon_sym_GT_GT_EQ] = ACTIONS(421),
    [anon_sym_LT_LT_EQ] = ACTIONS(421),
    [anon_sym_CARET_EQ] = ACTIONS(421),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_DOT_DOT] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(421),
    [anon_sym_LT_EQ_GT] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(421),
    [anon_sym_BANG_TILDE] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(13675),
    [anon_sym_not] = ACTIONS(13677),
    [anon_sym_BANG] = ACTIONS(13679),
    [anon_sym_TILDE] = ACTIONS(13681),
    [sym_constant] = ACTIONS(13683),
    [sym_identifier] = ACTIONS(13683),
    [sym_instance_variable] = ACTIONS(13685),
    [sym_class_variable] = ACTIONS(13685),
    [sym_global_variable] = ACTIONS(13685),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13687),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13687),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [10766] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(9957),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9962),
    [sym_scope_resolution] = STATE(9958),
    [sym_call] = STATE(9958),
    [sym_method_call] = STATE(9962),
    [sym_argument_list] = STATE(6617),
    [sym__argument_list_with_parens] = STATE(9959),
    [sym__argument] = STATE(9960),
    [sym_splat_argument] = STATE(9960),
    [sym_hash_splat_argument] = STATE(9960),
    [sym_block_argument] = STATE(9960),
    [sym_assignment] = STATE(9957),
    [sym_operator_assignment] = STATE(9957),
    [sym_conditional] = STATE(9957),
    [sym_range] = STATE(9957),
    [sym_binary] = STATE(9957),
    [sym_unary] = STATE(9957),
    [sym_left_assignment_list] = STATE(9961),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9962),
    [sym__variable] = STATE(9958),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9962),
    [sym_false] = STATE(9962),
    [sym_nil] = STATE(9962),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(9963),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(9960),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(425),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(13659),
    [sym__splat_star] = ACTIONS(13661),
    [sym__unary_minus] = ACTIONS(13663),
    [sym__binary_minus] = ACTIONS(425),
    [sym__binary_star] = ACTIONS(425),
    [sym__identifier_hash_key] = ACTIONS(13665),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(427),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13667),
    [anon_sym_yield] = ACTIONS(13669),
    [anon_sym_break] = ACTIONS(13671),
    [anon_sym_next] = ACTIONS(13673),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(425),
    [anon_sym_AMP_DOT] = ACTIONS(425),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_PLUS_EQ] = ACTIONS(425),
    [anon_sym_DASH_EQ] = ACTIONS(425),
    [anon_sym_STAR_EQ] = ACTIONS(425),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(425),
    [anon_sym_SLASH_EQ] = ACTIONS(425),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(425),
    [anon_sym_PIPE_EQ] = ACTIONS(425),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(425),
    [anon_sym_AMP_EQ] = ACTIONS(425),
    [anon_sym_PERCENT_EQ] = ACTIONS(425),
    [anon_sym_GT_GT_EQ] = ACTIONS(425),
    [anon_sym_LT_LT_EQ] = ACTIONS(425),
    [anon_sym_CARET_EQ] = ACTIONS(425),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(427),
    [anon_sym_or] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT_EQ_GT] = ACTIONS(425),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_BANG_TILDE] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(13675),
    [anon_sym_not] = ACTIONS(13677),
    [anon_sym_BANG] = ACTIONS(13679),
    [anon_sym_TILDE] = ACTIONS(13681),
    [sym_constant] = ACTIONS(13683),
    [sym_identifier] = ACTIONS(13683),
    [sym_instance_variable] = ACTIONS(13685),
    [sym_class_variable] = ACTIONS(13685),
    [sym_global_variable] = ACTIONS(13685),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13687),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13687),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [10767] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(11123),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(10772),
    [sym_scope_resolution] = STATE(10770),
    [sym_call] = STATE(10770),
    [sym_method_call] = STATE(10772),
    [sym_assignment] = STATE(11123),
    [sym_operator_assignment] = STATE(11123),
    [sym_conditional] = STATE(11123),
    [sym_range] = STATE(11123),
    [sym_binary] = STATE(11123),
    [sym_unary] = STATE(11123),
    [sym_left_assignment_list] = STATE(10771),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10772),
    [sym__variable] = STATE(10770),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(10772),
    [sym_false] = STATE(10772),
    [sym_nil] = STATE(10772),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(10773),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(14506),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(14508),
    [anon_sym_yield] = ACTIONS(14510),
    [anon_sym_break] = ACTIONS(14512),
    [anon_sym_next] = ACTIONS(14514),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(14516),
    [anon_sym_defined_QMARK] = ACTIONS(14518),
    [anon_sym_not] = ACTIONS(14520),
    [anon_sym_BANG] = ACTIONS(14522),
    [anon_sym_TILDE] = ACTIONS(14522),
    [sym_constant] = ACTIONS(14524),
    [sym_identifier] = ACTIONS(14524),
    [sym_instance_variable] = ACTIONS(14526),
    [sym_class_variable] = ACTIONS(14526),
    [sym_global_variable] = ACTIONS(14526),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(14524),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14524),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [10768] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(6632),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(10772),
    [sym_scope_resolution] = STATE(10770),
    [sym_call] = STATE(10770),
    [sym_method_call] = STATE(10772),
    [sym_assignment] = STATE(6632),
    [sym_operator_assignment] = STATE(6632),
    [sym_conditional] = STATE(6632),
    [sym_range] = STATE(6632),
    [sym_binary] = STATE(6632),
    [sym_unary] = STATE(6632),
    [sym_left_assignment_list] = STATE(10771),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10772),
    [sym__variable] = STATE(10770),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(10772),
    [sym_false] = STATE(10772),
    [sym_nil] = STATE(10772),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(10773),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(14506),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(14508),
    [anon_sym_yield] = ACTIONS(14510),
    [anon_sym_break] = ACTIONS(14512),
    [anon_sym_next] = ACTIONS(14514),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(14516),
    [anon_sym_defined_QMARK] = ACTIONS(14518),
    [anon_sym_not] = ACTIONS(14520),
    [anon_sym_BANG] = ACTIONS(14522),
    [anon_sym_TILDE] = ACTIONS(14522),
    [sym_constant] = ACTIONS(14524),
    [sym_identifier] = ACTIONS(14524),
    [sym_instance_variable] = ACTIONS(14526),
    [sym_class_variable] = ACTIONS(14526),
    [sym_global_variable] = ACTIONS(14526),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(14524),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14524),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [10769] = {
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(15059),
    [sym__binary_star] = ACTIONS(15061),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(15063),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(15065),
    [anon_sym_AMP] = ACTIONS(15067),
    [anon_sym_EQ] = ACTIONS(4217),
    [anon_sym_LT] = ACTIONS(15069),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_PLUS_EQ] = ACTIONS(4211),
    [anon_sym_DASH_EQ] = ACTIONS(4211),
    [anon_sym_STAR_EQ] = ACTIONS(4211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4211),
    [anon_sym_SLASH_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4211),
    [anon_sym_AMP_EQ] = ACTIONS(4211),
    [anon_sym_PERCENT_EQ] = ACTIONS(4211),
    [anon_sym_GT_GT_EQ] = ACTIONS(4211),
    [anon_sym_LT_LT_EQ] = ACTIONS(4211),
    [anon_sym_CARET_EQ] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(15071),
    [anon_sym_DOT_DOT] = ACTIONS(15073),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15075),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(15077),
    [anon_sym_AMP_AMP] = ACTIONS(15077),
    [anon_sym_LT_LT] = ACTIONS(15079),
    [anon_sym_GT_GT] = ACTIONS(15079),
    [anon_sym_EQ_EQ] = ACTIONS(15077),
    [anon_sym_BANG_EQ] = ACTIONS(15081),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15081),
    [anon_sym_LT_EQ_GT] = ACTIONS(15081),
    [anon_sym_EQ_TILDE] = ACTIONS(15081),
    [anon_sym_BANG_TILDE] = ACTIONS(15081),
    [anon_sym_LT_EQ] = ACTIONS(15069),
    [anon_sym_GT] = ACTIONS(15069),
    [anon_sym_GT_EQ] = ACTIONS(15083),
    [anon_sym_CARET] = ACTIONS(15063),
    [anon_sym_PLUS] = ACTIONS(15085),
    [anon_sym_SLASH] = ACTIONS(15065),
    [anon_sym_PERCENT] = ACTIONS(15065),
    [sym_comment] = ACTIONS(87),
  },
  [10770] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(9957),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9962),
    [sym_scope_resolution] = STATE(9958),
    [sym_call] = STATE(9958),
    [sym_method_call] = STATE(9962),
    [sym_argument_list] = STATE(4801),
    [sym__argument_list_with_parens] = STATE(9959),
    [sym__argument] = STATE(9960),
    [sym_splat_argument] = STATE(9960),
    [sym_hash_splat_argument] = STATE(9960),
    [sym_block_argument] = STATE(9960),
    [sym_do_block] = STATE(1849),
    [sym_block] = STATE(1849),
    [sym_assignment] = STATE(9957),
    [sym_operator_assignment] = STATE(9957),
    [sym_conditional] = STATE(9957),
    [sym_range] = STATE(9957),
    [sym_binary] = STATE(9957),
    [sym_unary] = STATE(9957),
    [sym_left_assignment_list] = STATE(9961),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9962),
    [sym__variable] = STATE(9958),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9962),
    [sym_false] = STATE(9962),
    [sym_nil] = STATE(9962),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(9963),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(9960),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(13659),
    [sym__splat_star] = ACTIONS(13661),
    [sym__unary_minus] = ACTIONS(13663),
    [sym__binary_minus] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [sym__identifier_hash_key] = ACTIONS(13665),
    [anon_sym_LBRACE] = ACTIONS(7739),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13667),
    [anon_sym_yield] = ACTIONS(13669),
    [anon_sym_break] = ACTIONS(13671),
    [anon_sym_next] = ACTIONS(13673),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(769),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(769),
    [anon_sym_or] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_defined_QMARK] = ACTIONS(13675),
    [anon_sym_not] = ACTIONS(13677),
    [anon_sym_BANG] = ACTIONS(13679),
    [anon_sym_TILDE] = ACTIONS(13681),
    [sym_constant] = ACTIONS(13683),
    [sym_identifier] = ACTIONS(13683),
    [sym_instance_variable] = ACTIONS(13685),
    [sym_class_variable] = ACTIONS(13685),
    [sym_global_variable] = ACTIONS(13685),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13687),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13687),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [10771] = {
    [anon_sym_EQ] = ACTIONS(15087),
    [sym_comment] = ACTIONS(87),
  },
  [10772] = {
    [aux_sym__mlhs_repeat1] = STATE(432),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(15089),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(15091),
    [anon_sym_DASH_EQ] = ACTIONS(15091),
    [anon_sym_STAR_EQ] = ACTIONS(15091),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(15091),
    [anon_sym_SLASH_EQ] = ACTIONS(15091),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(15091),
    [anon_sym_PIPE_EQ] = ACTIONS(15091),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(15091),
    [anon_sym_AMP_EQ] = ACTIONS(15091),
    [anon_sym_PERCENT_EQ] = ACTIONS(15091),
    [anon_sym_GT_GT_EQ] = ACTIONS(15091),
    [anon_sym_LT_LT_EQ] = ACTIONS(15091),
    [anon_sym_CARET_EQ] = ACTIONS(15091),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [10773] = {
    [sym_string] = STATE(11136),
    [aux_sym_chained_string_repeat1] = STATE(11136),
    [sym__string_start] = ACTIONS(6455),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [10774] = {
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(15059),
    [sym__binary_star] = ACTIONS(15061),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(15063),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(15065),
    [anon_sym_AMP] = ACTIONS(15067),
    [anon_sym_EQ] = ACTIONS(4249),
    [anon_sym_LT] = ACTIONS(15069),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_PLUS_EQ] = ACTIONS(4247),
    [anon_sym_DASH_EQ] = ACTIONS(4247),
    [anon_sym_STAR_EQ] = ACTIONS(4247),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4247),
    [anon_sym_SLASH_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4247),
    [anon_sym_AMP_EQ] = ACTIONS(4247),
    [anon_sym_PERCENT_EQ] = ACTIONS(4247),
    [anon_sym_GT_GT_EQ] = ACTIONS(4247),
    [anon_sym_LT_LT_EQ] = ACTIONS(4247),
    [anon_sym_CARET_EQ] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(15071),
    [anon_sym_DOT_DOT] = ACTIONS(15073),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15075),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(15077),
    [anon_sym_AMP_AMP] = ACTIONS(15077),
    [anon_sym_LT_LT] = ACTIONS(15079),
    [anon_sym_GT_GT] = ACTIONS(15079),
    [anon_sym_EQ_EQ] = ACTIONS(15077),
    [anon_sym_BANG_EQ] = ACTIONS(15081),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15081),
    [anon_sym_LT_EQ_GT] = ACTIONS(15081),
    [anon_sym_EQ_TILDE] = ACTIONS(15081),
    [anon_sym_BANG_TILDE] = ACTIONS(15081),
    [anon_sym_LT_EQ] = ACTIONS(15069),
    [anon_sym_GT] = ACTIONS(15069),
    [anon_sym_GT_EQ] = ACTIONS(15083),
    [anon_sym_CARET] = ACTIONS(15063),
    [anon_sym_PLUS] = ACTIONS(15085),
    [anon_sym_SLASH] = ACTIONS(15065),
    [anon_sym_PERCENT] = ACTIONS(15065),
    [sym_comment] = ACTIONS(87),
  },
  [10775] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(14540),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [10776] = {
    [sym_string] = STATE(10796),
    [aux_sym_chained_string_repeat1] = STATE(10796),
    [sym__string_start] = ACTIONS(1141),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [10777] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(11137),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(10772),
    [sym_scope_resolution] = STATE(10770),
    [sym_call] = STATE(10770),
    [sym_method_call] = STATE(10772),
    [sym_assignment] = STATE(11137),
    [sym_operator_assignment] = STATE(11137),
    [sym_conditional] = STATE(11137),
    [sym_range] = STATE(11137),
    [sym_binary] = STATE(11137),
    [sym_unary] = STATE(11137),
    [sym_left_assignment_list] = STATE(10771),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10772),
    [sym__variable] = STATE(10770),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(10772),
    [sym_false] = STATE(10772),
    [sym_nil] = STATE(10772),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(10773),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(14506),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(14508),
    [anon_sym_yield] = ACTIONS(14510),
    [anon_sym_break] = ACTIONS(14512),
    [anon_sym_next] = ACTIONS(14514),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(14516),
    [anon_sym_defined_QMARK] = ACTIONS(14518),
    [anon_sym_not] = ACTIONS(14520),
    [anon_sym_BANG] = ACTIONS(14522),
    [anon_sym_TILDE] = ACTIONS(14522),
    [sym_constant] = ACTIONS(14524),
    [sym_identifier] = ACTIONS(14524),
    [sym_instance_variable] = ACTIONS(14526),
    [sym_class_variable] = ACTIONS(14526),
    [sym_global_variable] = ACTIONS(14526),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(14524),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14524),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [10778] = {
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(15059),
    [sym__binary_star] = ACTIONS(15061),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(15063),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(15065),
    [anon_sym_AMP] = ACTIONS(15067),
    [anon_sym_EQ] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(15069),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_PLUS_EQ] = ACTIONS(3281),
    [anon_sym_DASH_EQ] = ACTIONS(3281),
    [anon_sym_STAR_EQ] = ACTIONS(3281),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3281),
    [anon_sym_SLASH_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3281),
    [anon_sym_AMP_EQ] = ACTIONS(3281),
    [anon_sym_PERCENT_EQ] = ACTIONS(3281),
    [anon_sym_GT_GT_EQ] = ACTIONS(3281),
    [anon_sym_LT_LT_EQ] = ACTIONS(3281),
    [anon_sym_CARET_EQ] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(15071),
    [anon_sym_DOT_DOT] = ACTIONS(15073),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15075),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(15077),
    [anon_sym_AMP_AMP] = ACTIONS(15077),
    [anon_sym_LT_LT] = ACTIONS(15079),
    [anon_sym_GT_GT] = ACTIONS(15079),
    [anon_sym_EQ_EQ] = ACTIONS(15077),
    [anon_sym_BANG_EQ] = ACTIONS(15081),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15081),
    [anon_sym_LT_EQ_GT] = ACTIONS(15081),
    [anon_sym_EQ_TILDE] = ACTIONS(15081),
    [anon_sym_BANG_TILDE] = ACTIONS(15081),
    [anon_sym_LT_EQ] = ACTIONS(15069),
    [anon_sym_GT] = ACTIONS(15069),
    [anon_sym_GT_EQ] = ACTIONS(15083),
    [anon_sym_CARET] = ACTIONS(15063),
    [anon_sym_PLUS] = ACTIONS(15085),
    [anon_sym_SLASH] = ACTIONS(15065),
    [anon_sym_PERCENT] = ACTIONS(15065),
    [sym_comment] = ACTIONS(87),
  },
  [10779] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(14534),
    [sym__binary_star] = ACTIONS(14536),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(14538),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(14540),
    [anon_sym_AMP] = ACTIONS(14542),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(14544),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(14546),
    [anon_sym_DOT_DOT] = ACTIONS(14548),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14550),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(14552),
    [anon_sym_AMP_AMP] = ACTIONS(14552),
    [anon_sym_LT_LT] = ACTIONS(14554),
    [anon_sym_GT_GT] = ACTIONS(14554),
    [anon_sym_EQ_EQ] = ACTIONS(14552),
    [anon_sym_BANG_EQ] = ACTIONS(14556),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14556),
    [anon_sym_LT_EQ_GT] = ACTIONS(14556),
    [anon_sym_EQ_TILDE] = ACTIONS(14556),
    [anon_sym_BANG_TILDE] = ACTIONS(14556),
    [anon_sym_LT_EQ] = ACTIONS(14544),
    [anon_sym_GT] = ACTIONS(14544),
    [anon_sym_GT_EQ] = ACTIONS(14558),
    [anon_sym_CARET] = ACTIONS(14538),
    [anon_sym_PLUS] = ACTIONS(14560),
    [anon_sym_SLASH] = ACTIONS(14540),
    [anon_sym_PERCENT] = ACTIONS(14540),
    [sym_comment] = ACTIONS(87),
  },
  [10780] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(11138),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(10772),
    [sym_scope_resolution] = STATE(10770),
    [sym_call] = STATE(10770),
    [sym_method_call] = STATE(10772),
    [sym_assignment] = STATE(11138),
    [sym_operator_assignment] = STATE(11138),
    [sym_conditional] = STATE(11138),
    [sym_range] = STATE(11138),
    [sym_binary] = STATE(11138),
    [sym_unary] = STATE(11138),
    [sym_left_assignment_list] = STATE(10771),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10772),
    [sym__variable] = STATE(10770),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(10772),
    [sym_false] = STATE(10772),
    [sym_nil] = STATE(10772),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(10773),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(14506),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(14508),
    [anon_sym_yield] = ACTIONS(14510),
    [anon_sym_break] = ACTIONS(14512),
    [anon_sym_next] = ACTIONS(14514),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(14516),
    [anon_sym_defined_QMARK] = ACTIONS(14518),
    [anon_sym_not] = ACTIONS(14520),
    [anon_sym_BANG] = ACTIONS(14522),
    [anon_sym_TILDE] = ACTIONS(14522),
    [sym_constant] = ACTIONS(14524),
    [sym_identifier] = ACTIONS(14524),
    [sym_instance_variable] = ACTIONS(14526),
    [sym_class_variable] = ACTIONS(14526),
    [sym_global_variable] = ACTIONS(14526),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(14524),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14524),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [10781] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(11139),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9962),
    [sym_scope_resolution] = STATE(9958),
    [sym_call] = STATE(9958),
    [sym_method_call] = STATE(9962),
    [sym_assignment] = STATE(11139),
    [sym_operator_assignment] = STATE(11139),
    [sym_conditional] = STATE(11139),
    [sym_range] = STATE(11139),
    [sym_binary] = STATE(11139),
    [sym_unary] = STATE(11139),
    [sym_left_assignment_list] = STATE(9961),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9962),
    [sym__variable] = STATE(9958),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9962),
    [sym_false] = STATE(9962),
    [sym_nil] = STATE(9962),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10776),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(13663),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13667),
    [anon_sym_yield] = ACTIONS(13669),
    [anon_sym_break] = ACTIONS(13671),
    [anon_sym_next] = ACTIONS(13673),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(14528),
    [anon_sym_defined_QMARK] = ACTIONS(13675),
    [anon_sym_not] = ACTIONS(13677),
    [anon_sym_BANG] = ACTIONS(13681),
    [anon_sym_TILDE] = ACTIONS(13681),
    [sym_constant] = ACTIONS(13687),
    [sym_identifier] = ACTIONS(13687),
    [sym_instance_variable] = ACTIONS(13685),
    [sym_class_variable] = ACTIONS(13685),
    [sym_global_variable] = ACTIONS(13685),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13687),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13687),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [10782] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(11140),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9962),
    [sym_scope_resolution] = STATE(9958),
    [sym_call] = STATE(9958),
    [sym_method_call] = STATE(9962),
    [sym_assignment] = STATE(11140),
    [sym_operator_assignment] = STATE(11140),
    [sym_conditional] = STATE(11140),
    [sym_range] = STATE(11140),
    [sym_binary] = STATE(11140),
    [sym_unary] = STATE(11140),
    [sym_left_assignment_list] = STATE(9961),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9962),
    [sym__variable] = STATE(9958),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9962),
    [sym_false] = STATE(9962),
    [sym_nil] = STATE(9962),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10776),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(13663),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13667),
    [anon_sym_yield] = ACTIONS(13669),
    [anon_sym_break] = ACTIONS(13671),
    [anon_sym_next] = ACTIONS(13673),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(14528),
    [anon_sym_defined_QMARK] = ACTIONS(13675),
    [anon_sym_not] = ACTIONS(13677),
    [anon_sym_BANG] = ACTIONS(13681),
    [anon_sym_TILDE] = ACTIONS(13681),
    [sym_constant] = ACTIONS(13687),
    [sym_identifier] = ACTIONS(13687),
    [sym_instance_variable] = ACTIONS(13685),
    [sym_class_variable] = ACTIONS(13685),
    [sym_global_variable] = ACTIONS(13685),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13687),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13687),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [10783] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(11141),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9962),
    [sym_scope_resolution] = STATE(9958),
    [sym_call] = STATE(9958),
    [sym_method_call] = STATE(9962),
    [sym_assignment] = STATE(11141),
    [sym_operator_assignment] = STATE(11141),
    [sym_conditional] = STATE(11141),
    [sym_range] = STATE(11141),
    [sym_binary] = STATE(11141),
    [sym_unary] = STATE(11141),
    [sym_left_assignment_list] = STATE(9961),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9962),
    [sym__variable] = STATE(9958),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9962),
    [sym_false] = STATE(9962),
    [sym_nil] = STATE(9962),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10776),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(13663),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13667),
    [anon_sym_yield] = ACTIONS(13669),
    [anon_sym_break] = ACTIONS(13671),
    [anon_sym_next] = ACTIONS(13673),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(14528),
    [anon_sym_defined_QMARK] = ACTIONS(13675),
    [anon_sym_not] = ACTIONS(13677),
    [anon_sym_BANG] = ACTIONS(13681),
    [anon_sym_TILDE] = ACTIONS(13681),
    [sym_constant] = ACTIONS(13687),
    [sym_identifier] = ACTIONS(13687),
    [sym_instance_variable] = ACTIONS(13685),
    [sym_class_variable] = ACTIONS(13685),
    [sym_global_variable] = ACTIONS(13685),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13687),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13687),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [10784] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(11142),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9962),
    [sym_scope_resolution] = STATE(9958),
    [sym_call] = STATE(9958),
    [sym_method_call] = STATE(9962),
    [sym_assignment] = STATE(11142),
    [sym_operator_assignment] = STATE(11142),
    [sym_conditional] = STATE(11142),
    [sym_range] = STATE(11142),
    [sym_binary] = STATE(11142),
    [sym_unary] = STATE(11142),
    [sym_left_assignment_list] = STATE(9961),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9962),
    [sym__variable] = STATE(9958),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9962),
    [sym_false] = STATE(9962),
    [sym_nil] = STATE(9962),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10776),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(13663),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13667),
    [anon_sym_yield] = ACTIONS(13669),
    [anon_sym_break] = ACTIONS(13671),
    [anon_sym_next] = ACTIONS(13673),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(14528),
    [anon_sym_defined_QMARK] = ACTIONS(13675),
    [anon_sym_not] = ACTIONS(13677),
    [anon_sym_BANG] = ACTIONS(13681),
    [anon_sym_TILDE] = ACTIONS(13681),
    [sym_constant] = ACTIONS(13687),
    [sym_identifier] = ACTIONS(13687),
    [sym_instance_variable] = ACTIONS(13685),
    [sym_class_variable] = ACTIONS(13685),
    [sym_global_variable] = ACTIONS(13685),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13687),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13687),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [10785] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(11143),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9962),
    [sym_scope_resolution] = STATE(9958),
    [sym_call] = STATE(9958),
    [sym_method_call] = STATE(9962),
    [sym_assignment] = STATE(11143),
    [sym_operator_assignment] = STATE(11143),
    [sym_conditional] = STATE(11143),
    [sym_range] = STATE(11143),
    [sym_binary] = STATE(11143),
    [sym_unary] = STATE(11143),
    [sym_left_assignment_list] = STATE(9961),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9962),
    [sym__variable] = STATE(9958),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9962),
    [sym_false] = STATE(9962),
    [sym_nil] = STATE(9962),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10776),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(13663),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13667),
    [anon_sym_yield] = ACTIONS(13669),
    [anon_sym_break] = ACTIONS(13671),
    [anon_sym_next] = ACTIONS(13673),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(14528),
    [anon_sym_defined_QMARK] = ACTIONS(13675),
    [anon_sym_not] = ACTIONS(13677),
    [anon_sym_BANG] = ACTIONS(13681),
    [anon_sym_TILDE] = ACTIONS(13681),
    [sym_constant] = ACTIONS(13687),
    [sym_identifier] = ACTIONS(13687),
    [sym_instance_variable] = ACTIONS(13685),
    [sym_class_variable] = ACTIONS(13685),
    [sym_global_variable] = ACTIONS(13685),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13687),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13687),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [10786] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(11144),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(11144),
    [sym_operator_assignment] = STATE(11144),
    [sym_conditional] = STATE(11144),
    [sym_range] = STATE(11144),
    [sym_binary] = STATE(11144),
    [sym_unary] = STATE(11144),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [10787] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(11145),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9962),
    [sym_scope_resolution] = STATE(9958),
    [sym_call] = STATE(9958),
    [sym_method_call] = STATE(9962),
    [sym_assignment] = STATE(11145),
    [sym_operator_assignment] = STATE(11145),
    [sym_conditional] = STATE(11145),
    [sym_range] = STATE(11145),
    [sym_binary] = STATE(11145),
    [sym_unary] = STATE(11145),
    [sym_left_assignment_list] = STATE(9961),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9962),
    [sym__variable] = STATE(9958),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9962),
    [sym_false] = STATE(9962),
    [sym_nil] = STATE(9962),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10776),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(13663),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13667),
    [anon_sym_yield] = ACTIONS(13669),
    [anon_sym_break] = ACTIONS(13671),
    [anon_sym_next] = ACTIONS(13673),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(14528),
    [anon_sym_defined_QMARK] = ACTIONS(13675),
    [anon_sym_not] = ACTIONS(13677),
    [anon_sym_BANG] = ACTIONS(13681),
    [anon_sym_TILDE] = ACTIONS(13681),
    [sym_constant] = ACTIONS(13687),
    [sym_identifier] = ACTIONS(13687),
    [sym_instance_variable] = ACTIONS(13685),
    [sym_class_variable] = ACTIONS(13685),
    [sym_global_variable] = ACTIONS(13685),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13687),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13687),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [10788] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(11146),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9962),
    [sym_scope_resolution] = STATE(9958),
    [sym_call] = STATE(9958),
    [sym_method_call] = STATE(9962),
    [sym_assignment] = STATE(11146),
    [sym_operator_assignment] = STATE(11146),
    [sym_conditional] = STATE(11146),
    [sym_range] = STATE(11146),
    [sym_binary] = STATE(11146),
    [sym_unary] = STATE(11146),
    [sym_left_assignment_list] = STATE(9961),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9962),
    [sym__variable] = STATE(9958),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9962),
    [sym_false] = STATE(9962),
    [sym_nil] = STATE(9962),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10776),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(13663),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13667),
    [anon_sym_yield] = ACTIONS(13669),
    [anon_sym_break] = ACTIONS(13671),
    [anon_sym_next] = ACTIONS(13673),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(14528),
    [anon_sym_defined_QMARK] = ACTIONS(13675),
    [anon_sym_not] = ACTIONS(13677),
    [anon_sym_BANG] = ACTIONS(13681),
    [anon_sym_TILDE] = ACTIONS(13681),
    [sym_constant] = ACTIONS(13687),
    [sym_identifier] = ACTIONS(13687),
    [sym_instance_variable] = ACTIONS(13685),
    [sym_class_variable] = ACTIONS(13685),
    [sym_global_variable] = ACTIONS(13685),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13687),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13687),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [10789] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(11147),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9962),
    [sym_scope_resolution] = STATE(9958),
    [sym_call] = STATE(9958),
    [sym_method_call] = STATE(9962),
    [sym_assignment] = STATE(11147),
    [sym_operator_assignment] = STATE(11147),
    [sym_conditional] = STATE(11147),
    [sym_range] = STATE(11147),
    [sym_binary] = STATE(11147),
    [sym_unary] = STATE(11147),
    [sym_left_assignment_list] = STATE(9961),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9962),
    [sym__variable] = STATE(9958),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9962),
    [sym_false] = STATE(9962),
    [sym_nil] = STATE(9962),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10776),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(13663),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13667),
    [anon_sym_yield] = ACTIONS(13669),
    [anon_sym_break] = ACTIONS(13671),
    [anon_sym_next] = ACTIONS(13673),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(14528),
    [anon_sym_defined_QMARK] = ACTIONS(13675),
    [anon_sym_not] = ACTIONS(13677),
    [anon_sym_BANG] = ACTIONS(13681),
    [anon_sym_TILDE] = ACTIONS(13681),
    [sym_constant] = ACTIONS(13687),
    [sym_identifier] = ACTIONS(13687),
    [sym_instance_variable] = ACTIONS(13685),
    [sym_class_variable] = ACTIONS(13685),
    [sym_global_variable] = ACTIONS(13685),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13687),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13687),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [10790] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(11148),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9962),
    [sym_scope_resolution] = STATE(9958),
    [sym_call] = STATE(9958),
    [sym_method_call] = STATE(9962),
    [sym_assignment] = STATE(11148),
    [sym_operator_assignment] = STATE(11148),
    [sym_conditional] = STATE(11148),
    [sym_range] = STATE(11148),
    [sym_binary] = STATE(11148),
    [sym_unary] = STATE(11148),
    [sym_left_assignment_list] = STATE(9961),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9962),
    [sym__variable] = STATE(9958),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9962),
    [sym_false] = STATE(9962),
    [sym_nil] = STATE(9962),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10776),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(13663),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13667),
    [anon_sym_yield] = ACTIONS(13669),
    [anon_sym_break] = ACTIONS(13671),
    [anon_sym_next] = ACTIONS(13673),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(14528),
    [anon_sym_defined_QMARK] = ACTIONS(13675),
    [anon_sym_not] = ACTIONS(13677),
    [anon_sym_BANG] = ACTIONS(13681),
    [anon_sym_TILDE] = ACTIONS(13681),
    [sym_constant] = ACTIONS(13687),
    [sym_identifier] = ACTIONS(13687),
    [sym_instance_variable] = ACTIONS(13685),
    [sym_class_variable] = ACTIONS(13685),
    [sym_global_variable] = ACTIONS(13685),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13687),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13687),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [10791] = {
    [sym_heredoc_body] = STATE(11149),
    [aux_sym_call_repeat1] = STATE(11149),
    [sym__heredoc_body_start] = ACTIONS(6569),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [10792] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(9957),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9962),
    [sym_scope_resolution] = STATE(9958),
    [sym_call] = STATE(9958),
    [sym_method_call] = STATE(9962),
    [sym__argument] = STATE(6674),
    [sym_splat_argument] = STATE(6674),
    [sym_hash_splat_argument] = STATE(6674),
    [sym_block_argument] = STATE(6674),
    [sym_assignment] = STATE(9957),
    [sym_operator_assignment] = STATE(9957),
    [sym_conditional] = STATE(9957),
    [sym_range] = STATE(9957),
    [sym_binary] = STATE(9957),
    [sym_unary] = STATE(9957),
    [sym_left_assignment_list] = STATE(9961),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9962),
    [sym__variable] = STATE(9958),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9962),
    [sym_false] = STATE(9962),
    [sym_nil] = STATE(9962),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(9963),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_heredoc_body] = STATE(11150),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(6674),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(13659),
    [sym__splat_star] = ACTIONS(13661),
    [sym__unary_minus] = ACTIONS(13663),
    [sym__identifier_hash_key] = ACTIONS(13665),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(15093),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13667),
    [anon_sym_yield] = ACTIONS(13669),
    [anon_sym_break] = ACTIONS(13671),
    [anon_sym_next] = ACTIONS(13673),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(14528),
    [anon_sym_defined_QMARK] = ACTIONS(13675),
    [anon_sym_not] = ACTIONS(13677),
    [anon_sym_BANG] = ACTIONS(13681),
    [anon_sym_TILDE] = ACTIONS(13681),
    [sym_constant] = ACTIONS(13683),
    [sym_identifier] = ACTIONS(13683),
    [sym_instance_variable] = ACTIONS(13685),
    [sym_class_variable] = ACTIONS(13685),
    [sym_global_variable] = ACTIONS(13685),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13687),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13687),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [10793] = {
    [sym_heredoc_body] = STATE(11151),
    [aux_sym_call_repeat1] = STATE(11151),
    [aux_sym_argument_list_repeat1] = STATE(11152),
    [sym__heredoc_body_start] = ACTIONS(6569),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(14562),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [10794] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(11153),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9962),
    [sym_scope_resolution] = STATE(9958),
    [sym_call] = STATE(9958),
    [sym_method_call] = STATE(9962),
    [sym_splat_argument] = STATE(11154),
    [sym_assignment] = STATE(11153),
    [sym_operator_assignment] = STATE(11153),
    [sym_conditional] = STATE(11153),
    [sym_range] = STATE(11153),
    [sym_binary] = STATE(11153),
    [sym_unary] = STATE(11153),
    [sym_right_assignment_list] = STATE(4362),
    [sym__arg_or_splat_arg] = STATE(11154),
    [sym_left_assignment_list] = STATE(9961),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9962),
    [sym__variable] = STATE(9958),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9962),
    [sym_false] = STATE(9962),
    [sym_nil] = STATE(9962),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10776),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__splat_star] = ACTIONS(14488),
    [sym__unary_minus] = ACTIONS(13663),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13667),
    [anon_sym_yield] = ACTIONS(13669),
    [anon_sym_break] = ACTIONS(13671),
    [anon_sym_next] = ACTIONS(13673),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(14528),
    [anon_sym_defined_QMARK] = ACTIONS(13675),
    [anon_sym_not] = ACTIONS(13677),
    [anon_sym_BANG] = ACTIONS(13681),
    [anon_sym_TILDE] = ACTIONS(13681),
    [sym_constant] = ACTIONS(13687),
    [sym_identifier] = ACTIONS(13687),
    [sym_instance_variable] = ACTIONS(13685),
    [sym_class_variable] = ACTIONS(13685),
    [sym_global_variable] = ACTIONS(13685),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13687),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13687),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [10795] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(11155),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9962),
    [sym_scope_resolution] = STATE(9958),
    [sym_call] = STATE(9958),
    [sym_method_call] = STATE(9962),
    [sym_assignment] = STATE(11155),
    [sym_operator_assignment] = STATE(11155),
    [sym_conditional] = STATE(11155),
    [sym_range] = STATE(11155),
    [sym_binary] = STATE(11155),
    [sym_unary] = STATE(11155),
    [sym_left_assignment_list] = STATE(9961),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9962),
    [sym__variable] = STATE(9958),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9962),
    [sym_false] = STATE(9962),
    [sym_nil] = STATE(9962),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10776),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(13663),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13667),
    [anon_sym_yield] = ACTIONS(13669),
    [anon_sym_break] = ACTIONS(13671),
    [anon_sym_next] = ACTIONS(13673),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(14528),
    [anon_sym_defined_QMARK] = ACTIONS(13675),
    [anon_sym_not] = ACTIONS(13677),
    [anon_sym_BANG] = ACTIONS(13681),
    [anon_sym_TILDE] = ACTIONS(13681),
    [sym_constant] = ACTIONS(13687),
    [sym_identifier] = ACTIONS(13687),
    [sym_instance_variable] = ACTIONS(13685),
    [sym_class_variable] = ACTIONS(13685),
    [sym_global_variable] = ACTIONS(13685),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13687),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13687),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [10796] = {
    [sym_string] = STATE(11156),
    [aux_sym_chained_string_repeat1] = STATE(11156),
    [sym__string_start] = ACTIONS(1141),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2755),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_EQ] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_EQ_GT] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_PLUS_EQ] = ACTIONS(2753),
    [anon_sym_DASH_EQ] = ACTIONS(2753),
    [anon_sym_STAR_EQ] = ACTIONS(2753),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2753),
    [anon_sym_SLASH_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2753),
    [anon_sym_AMP_EQ] = ACTIONS(2753),
    [anon_sym_PERCENT_EQ] = ACTIONS(2753),
    [anon_sym_GT_GT_EQ] = ACTIONS(2753),
    [anon_sym_LT_LT_EQ] = ACTIONS(2753),
    [anon_sym_CARET_EQ] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2755),
    [anon_sym_AMP_AMP] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2755),
    [anon_sym_GT_GT] = ACTIONS(2755),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_SLASH] = ACTIONS(2755),
    [anon_sym_PERCENT] = ACTIONS(2755),
    [sym_comment] = ACTIONS(87),
  },
  [10797] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(11157),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(8445),
    [sym_scope_resolution] = STATE(8443),
    [sym_call] = STATE(8443),
    [sym_method_call] = STATE(8445),
    [sym_assignment] = STATE(11157),
    [sym_operator_assignment] = STATE(11157),
    [sym_conditional] = STATE(11157),
    [sym_range] = STATE(11157),
    [sym_binary] = STATE(11157),
    [sym_unary] = STATE(11157),
    [sym_left_assignment_list] = STATE(8444),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(8445),
    [sym__variable] = STATE(8443),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(8445),
    [sym_false] = STATE(8445),
    [sym_nil] = STATE(8445),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(8446),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(12003),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(12005),
    [anon_sym_yield] = ACTIONS(12007),
    [anon_sym_break] = ACTIONS(12009),
    [anon_sym_next] = ACTIONS(12011),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(12013),
    [anon_sym_defined_QMARK] = ACTIONS(12015),
    [anon_sym_not] = ACTIONS(12017),
    [anon_sym_BANG] = ACTIONS(12019),
    [anon_sym_TILDE] = ACTIONS(12019),
    [sym_constant] = ACTIONS(12021),
    [sym_identifier] = ACTIONS(12021),
    [sym_instance_variable] = ACTIONS(12023),
    [sym_class_variable] = ACTIONS(12023),
    [sym_global_variable] = ACTIONS(12023),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(12021),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(12021),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [10798] = {
    [sym__binary_minus] = ACTIONS(13631),
    [sym__binary_star] = ACTIONS(13633),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(14504),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(13633),
    [anon_sym_AMP] = ACTIONS(13637),
    [anon_sym_LT] = ACTIONS(13639),
    [anon_sym_QMARK] = ACTIONS(13641),
    [anon_sym_DOT_DOT] = ACTIONS(13643),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13645),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(13649),
    [anon_sym_AMP_AMP] = ACTIONS(13649),
    [anon_sym_LT_LT] = ACTIONS(13651),
    [anon_sym_GT_GT] = ACTIONS(13651),
    [anon_sym_EQ_EQ] = ACTIONS(13653),
    [anon_sym_BANG_EQ] = ACTIONS(13649),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13649),
    [anon_sym_LT_EQ_GT] = ACTIONS(13649),
    [anon_sym_EQ_TILDE] = ACTIONS(13649),
    [anon_sym_BANG_TILDE] = ACTIONS(13649),
    [anon_sym_LT_EQ] = ACTIONS(13639),
    [anon_sym_GT] = ACTIONS(13639),
    [anon_sym_GT_EQ] = ACTIONS(13655),
    [anon_sym_CARET] = ACTIONS(13657),
    [anon_sym_PLUS] = ACTIONS(13631),
    [anon_sym_SLASH] = ACTIONS(13633),
    [anon_sym_PERCENT] = ACTIONS(13633),
    [sym_comment] = ACTIONS(87),
  },
  [10799] = {
    [aux_sym_exceptions_repeat1] = STATE(11159),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [10800] = {
    [sym__binary_minus] = ACTIONS(13631),
    [sym__binary_star] = ACTIONS(13633),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(14504),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(13633),
    [anon_sym_AMP] = ACTIONS(13637),
    [anon_sym_LT] = ACTIONS(13639),
    [anon_sym_QMARK] = ACTIONS(13641),
    [anon_sym_DOT_DOT] = ACTIONS(13643),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13645),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(13649),
    [anon_sym_AMP_AMP] = ACTIONS(13649),
    [anon_sym_LT_LT] = ACTIONS(13651),
    [anon_sym_GT_GT] = ACTIONS(13651),
    [anon_sym_EQ_EQ] = ACTIONS(13653),
    [anon_sym_BANG_EQ] = ACTIONS(13649),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13649),
    [anon_sym_LT_EQ_GT] = ACTIONS(13649),
    [anon_sym_EQ_TILDE] = ACTIONS(13649),
    [anon_sym_BANG_TILDE] = ACTIONS(13649),
    [anon_sym_LT_EQ] = ACTIONS(13639),
    [anon_sym_GT] = ACTIONS(13639),
    [anon_sym_GT_EQ] = ACTIONS(13655),
    [anon_sym_CARET] = ACTIONS(13657),
    [anon_sym_PLUS] = ACTIONS(13631),
    [anon_sym_SLASH] = ACTIONS(13633),
    [anon_sym_PERCENT] = ACTIONS(13633),
    [sym_comment] = ACTIONS(87),
  },
  [10801] = {
    [sym_string] = STATE(10801),
    [aux_sym_chained_string_repeat1] = STATE(10801),
    [sym__string_start] = ACTIONS(7159),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [10802] = {
    [aux_sym_block_parameters_repeat1] = STATE(9913),
    [anon_sym_COMMA] = ACTIONS(11999),
    [anon_sym_PIPE] = ACTIONS(15095),
    [sym_comment] = ACTIONS(87),
  },
  [10803] = {
    [aux_sym_block_parameters_repeat1] = STATE(11161),
    [anon_sym_COMMA] = ACTIONS(11999),
    [anon_sym_PIPE] = ACTIONS(15095),
    [sym_comment] = ACTIONS(87),
  },
  [10804] = {
    [sym__line_break] = ACTIONS(15003),
    [sym__simple_symbol] = ACTIONS(15003),
    [sym__string_start] = ACTIONS(15003),
    [sym__symbol_start] = ACTIONS(15003),
    [sym__subshell_start] = ACTIONS(15003),
    [sym__regex_start] = ACTIONS(15003),
    [sym__string_array_start] = ACTIONS(15003),
    [sym__symbol_array_start] = ACTIONS(15003),
    [sym__heredoc_body_start] = ACTIONS(15003),
    [sym_heredoc_beginning] = ACTIONS(15003),
    [sym__unary_minus] = ACTIONS(15003),
    [anon_sym_BEGIN] = ACTIONS(15005),
    [anon_sym_LBRACE] = ACTIONS(15003),
    [anon_sym_END] = ACTIONS(15005),
    [anon_sym_def] = ACTIONS(15005),
    [anon_sym_LPAREN] = ACTIONS(15003),
    [anon_sym_COLON_COLON] = ACTIONS(15003),
    [anon_sym_SEMI] = ACTIONS(15003),
    [anon_sym_STAR] = ACTIONS(15003),
    [anon_sym_class] = ACTIONS(15005),
    [anon_sym_module] = ACTIONS(15005),
    [anon_sym_end] = ACTIONS(15005),
    [anon_sym_return] = ACTIONS(15005),
    [anon_sym_yield] = ACTIONS(15005),
    [anon_sym_break] = ACTIONS(15005),
    [anon_sym_next] = ACTIONS(15005),
    [sym_redo] = ACTIONS(15005),
    [sym_retry] = ACTIONS(15005),
    [anon_sym_if] = ACTIONS(15005),
    [anon_sym_unless] = ACTIONS(15005),
    [anon_sym_while] = ACTIONS(15005),
    [anon_sym_until] = ACTIONS(15005),
    [anon_sym_for] = ACTIONS(15005),
    [anon_sym_case] = ACTIONS(15005),
    [anon_sym_begin] = ACTIONS(15005),
    [anon_sym_PLUS] = ACTIONS(15005),
    [anon_sym_defined_QMARK] = ACTIONS(15003),
    [anon_sym_not] = ACTIONS(15005),
    [anon_sym_BANG] = ACTIONS(15003),
    [anon_sym_TILDE] = ACTIONS(15003),
    [sym_constant] = ACTIONS(15005),
    [sym_identifier] = ACTIONS(15005),
    [sym_instance_variable] = ACTIONS(15003),
    [sym_class_variable] = ACTIONS(15003),
    [sym_global_variable] = ACTIONS(15003),
    [anon_sym_undef] = ACTIONS(15005),
    [anon_sym_alias] = ACTIONS(15005),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(15005),
    [sym_float] = ACTIONS(15005),
    [sym_complex] = ACTIONS(15003),
    [sym_super] = ACTIONS(15005),
    [anon_sym_true] = ACTIONS(15005),
    [anon_sym_TRUE] = ACTIONS(15005),
    [anon_sym_false] = ACTIONS(15005),
    [anon_sym_FALSE] = ACTIONS(15005),
    [sym_self] = ACTIONS(15005),
    [anon_sym_nil] = ACTIONS(15005),
    [anon_sym_NIL] = ACTIONS(15005),
    [sym_character] = ACTIONS(15003),
    [anon_sym_LBRACK2] = ACTIONS(15003),
    [anon_sym_DASH_GT] = ACTIONS(15003),
  },
  [10805] = {
    [aux_sym_block_parameters_repeat1] = STATE(9913),
    [anon_sym_COMMA] = ACTIONS(11999),
    [anon_sym_PIPE] = ACTIONS(15097),
    [sym_comment] = ACTIONS(87),
  },
  [10806] = {
    [aux_sym_block_parameters_repeat1] = STATE(11163),
    [anon_sym_COMMA] = ACTIONS(11999),
    [anon_sym_PIPE] = ACTIONS(15097),
    [sym_comment] = ACTIONS(87),
  },
  [10807] = {
    [sym__binary_minus] = ACTIONS(9456),
    [sym__binary_star] = ACTIONS(9458),
    [anon_sym_LBRACE] = ACTIONS(12120),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(9462),
    [anon_sym_STAR_STAR] = ACTIONS(9458),
    [anon_sym_AMP] = ACTIONS(9464),
    [anon_sym_LT] = ACTIONS(9466),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(9468),
    [anon_sym_DOT_DOT] = ACTIONS(9470),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9472),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(9476),
    [anon_sym_AMP_AMP] = ACTIONS(9476),
    [anon_sym_LT_LT] = ACTIONS(9478),
    [anon_sym_GT_GT] = ACTIONS(9478),
    [anon_sym_EQ_EQ] = ACTIONS(9480),
    [anon_sym_BANG_EQ] = ACTIONS(9476),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9476),
    [anon_sym_LT_EQ_GT] = ACTIONS(9476),
    [anon_sym_EQ_TILDE] = ACTIONS(9476),
    [anon_sym_BANG_TILDE] = ACTIONS(9476),
    [anon_sym_LT_EQ] = ACTIONS(9466),
    [anon_sym_GT] = ACTIONS(9466),
    [anon_sym_GT_EQ] = ACTIONS(9482),
    [anon_sym_CARET] = ACTIONS(9484),
    [anon_sym_PLUS] = ACTIONS(9456),
    [anon_sym_SLASH] = ACTIONS(9458),
    [anon_sym_PERCENT] = ACTIONS(9458),
    [sym_comment] = ACTIONS(87),
  },
  [10808] = {
    [aux_sym_exceptions_repeat1] = STATE(10808),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_COMMA] = ACTIONS(15099),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [10809] = {
    [sym_heredoc_body] = STATE(10809),
    [aux_sym_call_repeat1] = STATE(10809),
    [sym__heredoc_body_start] = ACTIONS(10455),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_COLON2] = ACTIONS(7919),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [10810] = {
    [sym_heredoc_body] = STATE(10809),
    [aux_sym_call_repeat1] = STATE(10809),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_COLON2] = ACTIONS(7931),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [10811] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(11164),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(6145),
    [sym_scope_resolution] = STATE(6143),
    [sym_call] = STATE(6143),
    [sym_method_call] = STATE(6145),
    [sym_assignment] = STATE(11164),
    [sym_operator_assignment] = STATE(11164),
    [sym_conditional] = STATE(11164),
    [sym_range] = STATE(11164),
    [sym_binary] = STATE(11164),
    [sym_unary] = STATE(11164),
    [sym_left_assignment_list] = STATE(6144),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6145),
    [sym__variable] = STATE(6143),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(6145),
    [sym_false] = STATE(6145),
    [sym_nil] = STATE(6145),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(6146),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9505),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9507),
    [anon_sym_yield] = ACTIONS(9509),
    [anon_sym_break] = ACTIONS(9511),
    [anon_sym_next] = ACTIONS(9513),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9515),
    [anon_sym_defined_QMARK] = ACTIONS(9517),
    [anon_sym_not] = ACTIONS(9519),
    [anon_sym_BANG] = ACTIONS(9521),
    [anon_sym_TILDE] = ACTIONS(9521),
    [sym_constant] = ACTIONS(9523),
    [sym_identifier] = ACTIONS(9523),
    [sym_instance_variable] = ACTIONS(9525),
    [sym_class_variable] = ACTIONS(9525),
    [sym_global_variable] = ACTIONS(9525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(9523),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9523),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10812] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(9991),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(6145),
    [sym_scope_resolution] = STATE(6143),
    [sym_call] = STATE(6143),
    [sym_method_call] = STATE(6145),
    [sym_splat_argument] = STATE(9013),
    [sym_assignment] = STATE(9991),
    [sym_operator_assignment] = STATE(9991),
    [sym_conditional] = STATE(9991),
    [sym_range] = STATE(9991),
    [sym_binary] = STATE(9991),
    [sym_unary] = STATE(9991),
    [sym__arg_or_splat_arg] = STATE(9013),
    [sym_left_assignment_list] = STATE(6144),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6145),
    [sym__variable] = STATE(6143),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(6145),
    [sym_false] = STATE(6145),
    [sym_nil] = STATE(6145),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(6146),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(4007),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(5833),
    [sym__unary_minus] = ACTIONS(9505),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9507),
    [anon_sym_yield] = ACTIONS(9509),
    [anon_sym_break] = ACTIONS(9511),
    [anon_sym_next] = ACTIONS(9513),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9515),
    [anon_sym_defined_QMARK] = ACTIONS(9517),
    [anon_sym_not] = ACTIONS(9519),
    [anon_sym_BANG] = ACTIONS(9521),
    [anon_sym_TILDE] = ACTIONS(9521),
    [sym_constant] = ACTIONS(9523),
    [sym_identifier] = ACTIONS(9523),
    [sym_instance_variable] = ACTIONS(9525),
    [sym_class_variable] = ACTIONS(9525),
    [sym_global_variable] = ACTIONS(9525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(9523),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9523),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10813] = {
    [aux_sym_exceptions_repeat1] = STATE(11165),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(15102),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_COLON2] = ACTIONS(9857),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [10814] = {
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(9543),
    [sym__binary_star] = ACTIONS(9545),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(9547),
    [anon_sym_STAR_STAR] = ACTIONS(9545),
    [anon_sym_AMP] = ACTIONS(9549),
    [anon_sym_LT] = ACTIONS(9551),
    [anon_sym_EQ_GT] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(9553),
    [anon_sym_COLON2] = ACTIONS(12879),
    [anon_sym_DOT_DOT] = ACTIONS(9555),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9557),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(9559),
    [anon_sym_AMP_AMP] = ACTIONS(9559),
    [anon_sym_LT_LT] = ACTIONS(9561),
    [anon_sym_GT_GT] = ACTIONS(9561),
    [anon_sym_EQ_EQ] = ACTIONS(9563),
    [anon_sym_BANG_EQ] = ACTIONS(9559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9559),
    [anon_sym_LT_EQ_GT] = ACTIONS(9559),
    [anon_sym_EQ_TILDE] = ACTIONS(9559),
    [anon_sym_BANG_TILDE] = ACTIONS(9559),
    [anon_sym_LT_EQ] = ACTIONS(9551),
    [anon_sym_GT] = ACTIONS(9551),
    [anon_sym_GT_EQ] = ACTIONS(9565),
    [anon_sym_CARET] = ACTIONS(9567),
    [anon_sym_PLUS] = ACTIONS(9543),
    [anon_sym_SLASH] = ACTIONS(9545),
    [anon_sym_PERCENT] = ACTIONS(9545),
    [sym_comment] = ACTIONS(87),
  },
  [10815] = {
    [aux_sym_exceptions_repeat1] = STATE(10815),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(15104),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_COLON2] = ACTIONS(12338),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [10816] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(11166),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(6210),
    [sym_scope_resolution] = STATE(6208),
    [sym_call] = STATE(6208),
    [sym_method_call] = STATE(6210),
    [sym_assignment] = STATE(11166),
    [sym_operator_assignment] = STATE(11166),
    [sym_conditional] = STATE(11166),
    [sym_range] = STATE(11166),
    [sym_binary] = STATE(11166),
    [sym_unary] = STATE(11166),
    [sym_left_assignment_list] = STATE(6209),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6210),
    [sym__variable] = STATE(6208),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(6210),
    [sym_false] = STATE(6210),
    [sym_nil] = STATE(6210),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(6211),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(9587),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(9589),
    [anon_sym_yield] = ACTIONS(9591),
    [anon_sym_break] = ACTIONS(9593),
    [anon_sym_next] = ACTIONS(9595),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(9597),
    [anon_sym_defined_QMARK] = ACTIONS(9599),
    [anon_sym_not] = ACTIONS(9601),
    [anon_sym_BANG] = ACTIONS(9603),
    [anon_sym_TILDE] = ACTIONS(9603),
    [sym_constant] = ACTIONS(9605),
    [sym_identifier] = ACTIONS(9605),
    [sym_instance_variable] = ACTIONS(9607),
    [sym_class_variable] = ACTIONS(9607),
    [sym_global_variable] = ACTIONS(9607),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(9605),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9605),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [10817] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(10022),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(6210),
    [sym_scope_resolution] = STATE(6208),
    [sym_call] = STATE(6208),
    [sym_method_call] = STATE(6210),
    [sym_splat_argument] = STATE(10867),
    [sym_assignment] = STATE(10022),
    [sym_operator_assignment] = STATE(10022),
    [sym_conditional] = STATE(10022),
    [sym_range] = STATE(10022),
    [sym_binary] = STATE(10022),
    [sym_unary] = STATE(10022),
    [sym__arg_or_splat_arg] = STATE(10867),
    [sym_left_assignment_list] = STATE(6209),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6210),
    [sym__variable] = STATE(6208),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(6210),
    [sym_false] = STATE(6210),
    [sym_nil] = STATE(6210),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(6211),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__splat_star] = ACTIONS(5893),
    [sym__unary_minus] = ACTIONS(9587),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(9589),
    [anon_sym_yield] = ACTIONS(9591),
    [anon_sym_break] = ACTIONS(9593),
    [anon_sym_next] = ACTIONS(9595),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(9597),
    [anon_sym_defined_QMARK] = ACTIONS(9599),
    [anon_sym_not] = ACTIONS(9601),
    [anon_sym_BANG] = ACTIONS(9603),
    [anon_sym_TILDE] = ACTIONS(9603),
    [sym_constant] = ACTIONS(9605),
    [sym_identifier] = ACTIONS(9605),
    [sym_instance_variable] = ACTIONS(9607),
    [sym_class_variable] = ACTIONS(9607),
    [sym_global_variable] = ACTIONS(9607),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(9605),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9605),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [10818] = {
    [aux_sym_exceptions_repeat1] = STATE(11167),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_LBRACE] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(15107),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_STAR_STAR] = ACTIONS(9857),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_EQ] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_do] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_PLUS_EQ] = ACTIONS(9855),
    [anon_sym_DASH_EQ] = ACTIONS(9855),
    [anon_sym_STAR_EQ] = ACTIONS(9855),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9855),
    [anon_sym_SLASH_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9855),
    [anon_sym_AMP_EQ] = ACTIONS(9855),
    [anon_sym_PERCENT_EQ] = ACTIONS(9855),
    [anon_sym_GT_GT_EQ] = ACTIONS(9855),
    [anon_sym_LT_LT_EQ] = ACTIONS(9855),
    [anon_sym_CARET_EQ] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_COLON2] = ACTIONS(9857),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9857),
    [anon_sym_AMP_AMP] = ACTIONS(9857),
    [anon_sym_LT_LT] = ACTIONS(9857),
    [anon_sym_GT_GT] = ACTIONS(9857),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9857),
    [anon_sym_PLUS] = ACTIONS(9857),
    [anon_sym_SLASH] = ACTIONS(9857),
    [anon_sym_PERCENT] = ACTIONS(9857),
    [sym_comment] = ACTIONS(87),
  },
  [10819] = {
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(9617),
    [sym__binary_star] = ACTIONS(9619),
    [anon_sym_LBRACE] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(9621),
    [anon_sym_STAR_STAR] = ACTIONS(9623),
    [anon_sym_AMP] = ACTIONS(9625),
    [anon_sym_EQ] = ACTIONS(12879),
    [anon_sym_LT] = ACTIONS(9627),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_EQ_GT] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_PLUS_EQ] = ACTIONS(12120),
    [anon_sym_DASH_EQ] = ACTIONS(12120),
    [anon_sym_STAR_EQ] = ACTIONS(12120),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12120),
    [anon_sym_SLASH_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12120),
    [anon_sym_AMP_EQ] = ACTIONS(12120),
    [anon_sym_PERCENT_EQ] = ACTIONS(12120),
    [anon_sym_GT_GT_EQ] = ACTIONS(12120),
    [anon_sym_LT_LT_EQ] = ACTIONS(12120),
    [anon_sym_CARET_EQ] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(9629),
    [anon_sym_COLON2] = ACTIONS(12879),
    [anon_sym_DOT_DOT] = ACTIONS(9631),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9633),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(9635),
    [anon_sym_AMP_AMP] = ACTIONS(9635),
    [anon_sym_LT_LT] = ACTIONS(9637),
    [anon_sym_GT_GT] = ACTIONS(9637),
    [anon_sym_EQ_EQ] = ACTIONS(9635),
    [anon_sym_BANG_EQ] = ACTIONS(9639),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9639),
    [anon_sym_LT_EQ_GT] = ACTIONS(9639),
    [anon_sym_EQ_TILDE] = ACTIONS(9639),
    [anon_sym_BANG_TILDE] = ACTIONS(9639),
    [anon_sym_LT_EQ] = ACTIONS(9627),
    [anon_sym_GT] = ACTIONS(9627),
    [anon_sym_GT_EQ] = ACTIONS(9641),
    [anon_sym_CARET] = ACTIONS(9621),
    [anon_sym_PLUS] = ACTIONS(9643),
    [anon_sym_SLASH] = ACTIONS(9623),
    [anon_sym_PERCENT] = ACTIONS(9623),
    [sym_comment] = ACTIONS(87),
  },
  [10820] = {
    [aux_sym_exceptions_repeat1] = STATE(10820),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(15109),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_PLUS_EQ] = ACTIONS(11597),
    [anon_sym_DASH_EQ] = ACTIONS(11597),
    [anon_sym_STAR_EQ] = ACTIONS(11597),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11597),
    [anon_sym_SLASH_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11597),
    [anon_sym_AMP_EQ] = ACTIONS(11597),
    [anon_sym_PERCENT_EQ] = ACTIONS(11597),
    [anon_sym_GT_GT_EQ] = ACTIONS(11597),
    [anon_sym_LT_LT_EQ] = ACTIONS(11597),
    [anon_sym_CARET_EQ] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_COLON2] = ACTIONS(12338),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_LT] = ACTIONS(12338),
    [anon_sym_GT_GT] = ACTIONS(12338),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(12338),
    [anon_sym_PLUS] = ACTIONS(12338),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [10821] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(11168),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(6247),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(6247),
    [sym_assignment] = STATE(11168),
    [sym_operator_assignment] = STATE(11168),
    [sym_conditional] = STATE(11168),
    [sym_range] = STATE(11168),
    [sym_binary] = STATE(11168),
    [sym_unary] = STATE(11168),
    [sym_left_assignment_list] = STATE(6246),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6247),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(6247),
    [sym_false] = STATE(6247),
    [sym_nil] = STATE(6247),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(6248),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(9657),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9659),
    [anon_sym_yield] = ACTIONS(9661),
    [anon_sym_break] = ACTIONS(9663),
    [anon_sym_next] = ACTIONS(9665),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9667),
    [anon_sym_defined_QMARK] = ACTIONS(9669),
    [anon_sym_not] = ACTIONS(9671),
    [anon_sym_BANG] = ACTIONS(9673),
    [anon_sym_TILDE] = ACTIONS(9673),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [10822] = {
    [sym__line_break] = ACTIONS(12555),
    [sym__heredoc_body_start] = ACTIONS(12555),
    [sym__binary_minus] = ACTIONS(12555),
    [sym__binary_star] = ACTIONS(12555),
    [ts_builtin_sym_end] = ACTIONS(12555),
    [anon_sym___END__] = ACTIONS(12555),
    [anon_sym_LBRACE] = ACTIONS(12555),
    [anon_sym_RBRACE] = ACTIONS(12555),
    [anon_sym_RPAREN] = ACTIONS(12555),
    [anon_sym_DOT] = ACTIONS(12557),
    [anon_sym_COMMA] = ACTIONS(12555),
    [anon_sym_PIPE] = ACTIONS(12557),
    [anon_sym_SEMI] = ACTIONS(12555),
    [anon_sym_STAR_STAR] = ACTIONS(12557),
    [anon_sym_AMP] = ACTIONS(12557),
    [anon_sym_EQ] = ACTIONS(12557),
    [anon_sym_LT] = ACTIONS(12557),
    [anon_sym_end] = ACTIONS(12555),
    [anon_sym_if] = ACTIONS(12555),
    [anon_sym_unless] = ACTIONS(12555),
    [anon_sym_while] = ACTIONS(12555),
    [anon_sym_until] = ACTIONS(12555),
    [anon_sym_rescue] = ACTIONS(12555),
    [anon_sym_do] = ACTIONS(12555),
    [anon_sym_when] = ACTIONS(12555),
    [anon_sym_elsif] = ACTIONS(12555),
    [anon_sym_else] = ACTIONS(12555),
    [anon_sym_then] = ACTIONS(12555),
    [anon_sym_ensure] = ACTIONS(12555),
    [anon_sym_LBRACK] = ACTIONS(12555),
    [anon_sym_COLON_COLON2] = ACTIONS(12555),
    [anon_sym_AMP_DOT] = ACTIONS(12555),
    [anon_sym_PLUS_EQ] = ACTIONS(12555),
    [anon_sym_DASH_EQ] = ACTIONS(12555),
    [anon_sym_STAR_EQ] = ACTIONS(12555),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12555),
    [anon_sym_SLASH_EQ] = ACTIONS(12555),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12555),
    [anon_sym_PIPE_EQ] = ACTIONS(12555),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12555),
    [anon_sym_AMP_EQ] = ACTIONS(12555),
    [anon_sym_PERCENT_EQ] = ACTIONS(12555),
    [anon_sym_GT_GT_EQ] = ACTIONS(12555),
    [anon_sym_LT_LT_EQ] = ACTIONS(12555),
    [anon_sym_CARET_EQ] = ACTIONS(12555),
    [anon_sym_QMARK] = ACTIONS(12555),
    [anon_sym_DOT_DOT] = ACTIONS(12557),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12555),
    [anon_sym_and] = ACTIONS(12555),
    [anon_sym_or] = ACTIONS(12555),
    [anon_sym_PIPE_PIPE] = ACTIONS(12557),
    [anon_sym_AMP_AMP] = ACTIONS(12557),
    [anon_sym_LT_LT] = ACTIONS(12557),
    [anon_sym_GT_GT] = ACTIONS(12557),
    [anon_sym_EQ_EQ] = ACTIONS(12557),
    [anon_sym_BANG_EQ] = ACTIONS(12555),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12555),
    [anon_sym_LT_EQ_GT] = ACTIONS(12555),
    [anon_sym_EQ_TILDE] = ACTIONS(12555),
    [anon_sym_BANG_TILDE] = ACTIONS(12555),
    [anon_sym_LT_EQ] = ACTIONS(12557),
    [anon_sym_GT] = ACTIONS(12557),
    [anon_sym_GT_EQ] = ACTIONS(12555),
    [anon_sym_CARET] = ACTIONS(12557),
    [anon_sym_PLUS] = ACTIONS(12557),
    [anon_sym_SLASH] = ACTIONS(12557),
    [anon_sym_PERCENT] = ACTIONS(12557),
    [sym_comment] = ACTIONS(87),
  },
  [10823] = {
    [sym__line_break] = ACTIONS(12559),
    [sym__heredoc_body_start] = ACTIONS(12559),
    [sym__binary_minus] = ACTIONS(12559),
    [sym__binary_star] = ACTIONS(12559),
    [ts_builtin_sym_end] = ACTIONS(12559),
    [anon_sym___END__] = ACTIONS(12559),
    [anon_sym_LBRACE] = ACTIONS(12559),
    [anon_sym_RBRACE] = ACTIONS(12559),
    [anon_sym_RPAREN] = ACTIONS(12559),
    [anon_sym_DOT] = ACTIONS(12561),
    [anon_sym_COMMA] = ACTIONS(12559),
    [anon_sym_PIPE] = ACTIONS(12561),
    [anon_sym_SEMI] = ACTIONS(12559),
    [anon_sym_STAR_STAR] = ACTIONS(12561),
    [anon_sym_AMP] = ACTIONS(12561),
    [anon_sym_EQ] = ACTIONS(12561),
    [anon_sym_LT] = ACTIONS(12561),
    [anon_sym_end] = ACTIONS(12559),
    [anon_sym_if] = ACTIONS(12559),
    [anon_sym_unless] = ACTIONS(12559),
    [anon_sym_while] = ACTIONS(12559),
    [anon_sym_until] = ACTIONS(12559),
    [anon_sym_rescue] = ACTIONS(12559),
    [anon_sym_do] = ACTIONS(12559),
    [anon_sym_when] = ACTIONS(12559),
    [anon_sym_elsif] = ACTIONS(12559),
    [anon_sym_else] = ACTIONS(12559),
    [anon_sym_then] = ACTIONS(12559),
    [anon_sym_ensure] = ACTIONS(12559),
    [anon_sym_LBRACK] = ACTIONS(12559),
    [anon_sym_COLON_COLON2] = ACTIONS(12559),
    [anon_sym_AMP_DOT] = ACTIONS(12559),
    [anon_sym_PLUS_EQ] = ACTIONS(12559),
    [anon_sym_DASH_EQ] = ACTIONS(12559),
    [anon_sym_STAR_EQ] = ACTIONS(12559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12559),
    [anon_sym_SLASH_EQ] = ACTIONS(12559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12559),
    [anon_sym_PIPE_EQ] = ACTIONS(12559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12559),
    [anon_sym_AMP_EQ] = ACTIONS(12559),
    [anon_sym_PERCENT_EQ] = ACTIONS(12559),
    [anon_sym_GT_GT_EQ] = ACTIONS(12559),
    [anon_sym_LT_LT_EQ] = ACTIONS(12559),
    [anon_sym_CARET_EQ] = ACTIONS(12559),
    [anon_sym_QMARK] = ACTIONS(12559),
    [anon_sym_DOT_DOT] = ACTIONS(12561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12559),
    [anon_sym_and] = ACTIONS(12559),
    [anon_sym_or] = ACTIONS(12559),
    [anon_sym_PIPE_PIPE] = ACTIONS(12561),
    [anon_sym_AMP_AMP] = ACTIONS(12561),
    [anon_sym_LT_LT] = ACTIONS(12561),
    [anon_sym_GT_GT] = ACTIONS(12561),
    [anon_sym_EQ_EQ] = ACTIONS(12561),
    [anon_sym_BANG_EQ] = ACTIONS(12559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12559),
    [anon_sym_LT_EQ_GT] = ACTIONS(12559),
    [anon_sym_EQ_TILDE] = ACTIONS(12559),
    [anon_sym_BANG_TILDE] = ACTIONS(12559),
    [anon_sym_LT_EQ] = ACTIONS(12561),
    [anon_sym_GT] = ACTIONS(12561),
    [anon_sym_GT_EQ] = ACTIONS(12559),
    [anon_sym_CARET] = ACTIONS(12561),
    [anon_sym_PLUS] = ACTIONS(12561),
    [anon_sym_SLASH] = ACTIONS(12561),
    [anon_sym_PERCENT] = ACTIONS(12561),
    [sym_comment] = ACTIONS(87),
  },
  [10824] = {
    [sym__line_break] = ACTIONS(12663),
    [sym__heredoc_body_start] = ACTIONS(12663),
    [sym__binary_minus] = ACTIONS(12663),
    [sym__binary_star] = ACTIONS(12663),
    [ts_builtin_sym_end] = ACTIONS(12663),
    [anon_sym___END__] = ACTIONS(12663),
    [anon_sym_LBRACE] = ACTIONS(12663),
    [anon_sym_RBRACE] = ACTIONS(12663),
    [anon_sym_RPAREN] = ACTIONS(12663),
    [anon_sym_DOT] = ACTIONS(12665),
    [anon_sym_COMMA] = ACTIONS(12663),
    [anon_sym_PIPE] = ACTIONS(12665),
    [anon_sym_SEMI] = ACTIONS(12663),
    [anon_sym_STAR_STAR] = ACTIONS(12665),
    [anon_sym_AMP] = ACTIONS(12665),
    [anon_sym_EQ] = ACTIONS(12665),
    [anon_sym_LT] = ACTIONS(12665),
    [anon_sym_end] = ACTIONS(12663),
    [anon_sym_if] = ACTIONS(12663),
    [anon_sym_unless] = ACTIONS(12663),
    [anon_sym_while] = ACTIONS(12663),
    [anon_sym_until] = ACTIONS(12663),
    [anon_sym_rescue] = ACTIONS(12663),
    [anon_sym_do] = ACTIONS(12663),
    [anon_sym_when] = ACTIONS(12663),
    [anon_sym_elsif] = ACTIONS(12663),
    [anon_sym_else] = ACTIONS(12663),
    [anon_sym_then] = ACTIONS(12663),
    [anon_sym_ensure] = ACTIONS(12663),
    [anon_sym_LBRACK] = ACTIONS(12663),
    [anon_sym_COLON_COLON2] = ACTIONS(12663),
    [anon_sym_AMP_DOT] = ACTIONS(12663),
    [anon_sym_PLUS_EQ] = ACTIONS(12663),
    [anon_sym_DASH_EQ] = ACTIONS(12663),
    [anon_sym_STAR_EQ] = ACTIONS(12663),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12663),
    [anon_sym_SLASH_EQ] = ACTIONS(12663),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12663),
    [anon_sym_PIPE_EQ] = ACTIONS(12663),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12663),
    [anon_sym_AMP_EQ] = ACTIONS(12663),
    [anon_sym_PERCENT_EQ] = ACTIONS(12663),
    [anon_sym_GT_GT_EQ] = ACTIONS(12663),
    [anon_sym_LT_LT_EQ] = ACTIONS(12663),
    [anon_sym_CARET_EQ] = ACTIONS(12663),
    [anon_sym_QMARK] = ACTIONS(12663),
    [anon_sym_DOT_DOT] = ACTIONS(12665),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12663),
    [anon_sym_and] = ACTIONS(12663),
    [anon_sym_or] = ACTIONS(12663),
    [anon_sym_PIPE_PIPE] = ACTIONS(12665),
    [anon_sym_AMP_AMP] = ACTIONS(12665),
    [anon_sym_LT_LT] = ACTIONS(12665),
    [anon_sym_GT_GT] = ACTIONS(12665),
    [anon_sym_EQ_EQ] = ACTIONS(12665),
    [anon_sym_BANG_EQ] = ACTIONS(12663),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12663),
    [anon_sym_LT_EQ_GT] = ACTIONS(12663),
    [anon_sym_EQ_TILDE] = ACTIONS(12663),
    [anon_sym_BANG_TILDE] = ACTIONS(12663),
    [anon_sym_LT_EQ] = ACTIONS(12665),
    [anon_sym_GT] = ACTIONS(12665),
    [anon_sym_GT_EQ] = ACTIONS(12663),
    [anon_sym_CARET] = ACTIONS(12665),
    [anon_sym_PLUS] = ACTIONS(12665),
    [anon_sym_SLASH] = ACTIONS(12665),
    [anon_sym_PERCENT] = ACTIONS(12665),
    [sym_comment] = ACTIONS(87),
  },
  [10825] = {
    [sym__line_break] = ACTIONS(13224),
    [sym__heredoc_body_start] = ACTIONS(13224),
    [sym__binary_minus] = ACTIONS(13224),
    [sym__binary_star] = ACTIONS(13224),
    [ts_builtin_sym_end] = ACTIONS(13224),
    [anon_sym___END__] = ACTIONS(13224),
    [anon_sym_LBRACE] = ACTIONS(13224),
    [anon_sym_RBRACE] = ACTIONS(13224),
    [anon_sym_RPAREN] = ACTIONS(13224),
    [anon_sym_DOT] = ACTIONS(13226),
    [anon_sym_COMMA] = ACTIONS(13224),
    [anon_sym_PIPE] = ACTIONS(13226),
    [anon_sym_SEMI] = ACTIONS(13224),
    [anon_sym_STAR_STAR] = ACTIONS(13226),
    [anon_sym_AMP] = ACTIONS(13226),
    [anon_sym_EQ] = ACTIONS(13226),
    [anon_sym_LT] = ACTIONS(13226),
    [anon_sym_end] = ACTIONS(13224),
    [anon_sym_if] = ACTIONS(13224),
    [anon_sym_unless] = ACTIONS(13224),
    [anon_sym_while] = ACTIONS(13224),
    [anon_sym_until] = ACTIONS(13224),
    [anon_sym_rescue] = ACTIONS(13224),
    [anon_sym_do] = ACTIONS(13224),
    [anon_sym_when] = ACTIONS(13224),
    [anon_sym_elsif] = ACTIONS(13224),
    [anon_sym_else] = ACTIONS(13224),
    [anon_sym_then] = ACTIONS(13224),
    [anon_sym_ensure] = ACTIONS(13224),
    [anon_sym_LBRACK] = ACTIONS(13224),
    [anon_sym_COLON_COLON2] = ACTIONS(13224),
    [anon_sym_AMP_DOT] = ACTIONS(13224),
    [anon_sym_PLUS_EQ] = ACTIONS(13224),
    [anon_sym_DASH_EQ] = ACTIONS(13224),
    [anon_sym_STAR_EQ] = ACTIONS(13224),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13224),
    [anon_sym_SLASH_EQ] = ACTIONS(13224),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13224),
    [anon_sym_PIPE_EQ] = ACTIONS(13224),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13224),
    [anon_sym_AMP_EQ] = ACTIONS(13224),
    [anon_sym_PERCENT_EQ] = ACTIONS(13224),
    [anon_sym_GT_GT_EQ] = ACTIONS(13224),
    [anon_sym_LT_LT_EQ] = ACTIONS(13224),
    [anon_sym_CARET_EQ] = ACTIONS(13224),
    [anon_sym_QMARK] = ACTIONS(13224),
    [anon_sym_DOT_DOT] = ACTIONS(13226),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13224),
    [anon_sym_and] = ACTIONS(13224),
    [anon_sym_or] = ACTIONS(13224),
    [anon_sym_PIPE_PIPE] = ACTIONS(13226),
    [anon_sym_AMP_AMP] = ACTIONS(13226),
    [anon_sym_LT_LT] = ACTIONS(13226),
    [anon_sym_GT_GT] = ACTIONS(13226),
    [anon_sym_EQ_EQ] = ACTIONS(13226),
    [anon_sym_BANG_EQ] = ACTIONS(13224),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13224),
    [anon_sym_LT_EQ_GT] = ACTIONS(13224),
    [anon_sym_EQ_TILDE] = ACTIONS(13224),
    [anon_sym_BANG_TILDE] = ACTIONS(13224),
    [anon_sym_LT_EQ] = ACTIONS(13226),
    [anon_sym_GT] = ACTIONS(13226),
    [anon_sym_GT_EQ] = ACTIONS(13224),
    [anon_sym_CARET] = ACTIONS(13226),
    [anon_sym_PLUS] = ACTIONS(13226),
    [anon_sym_SLASH] = ACTIONS(13226),
    [anon_sym_PERCENT] = ACTIONS(13226),
    [sym_comment] = ACTIONS(87),
  },
  [10826] = {
    [sym__line_break] = ACTIONS(13235),
    [sym__heredoc_body_start] = ACTIONS(13235),
    [sym__binary_minus] = ACTIONS(13235),
    [sym__binary_star] = ACTIONS(13235),
    [ts_builtin_sym_end] = ACTIONS(13235),
    [anon_sym___END__] = ACTIONS(13235),
    [anon_sym_LBRACE] = ACTIONS(13235),
    [anon_sym_RBRACE] = ACTIONS(13235),
    [anon_sym_RPAREN] = ACTIONS(13235),
    [anon_sym_DOT] = ACTIONS(13237),
    [anon_sym_COMMA] = ACTIONS(13235),
    [anon_sym_PIPE] = ACTIONS(13237),
    [anon_sym_SEMI] = ACTIONS(13235),
    [anon_sym_STAR_STAR] = ACTIONS(13237),
    [anon_sym_AMP] = ACTIONS(13237),
    [anon_sym_EQ] = ACTIONS(13237),
    [anon_sym_LT] = ACTIONS(13237),
    [anon_sym_end] = ACTIONS(13235),
    [anon_sym_if] = ACTIONS(13235),
    [anon_sym_unless] = ACTIONS(13235),
    [anon_sym_while] = ACTIONS(13235),
    [anon_sym_until] = ACTIONS(13235),
    [anon_sym_rescue] = ACTIONS(13235),
    [anon_sym_do] = ACTIONS(13235),
    [anon_sym_when] = ACTIONS(13235),
    [anon_sym_elsif] = ACTIONS(13235),
    [anon_sym_else] = ACTIONS(13235),
    [anon_sym_then] = ACTIONS(13235),
    [anon_sym_ensure] = ACTIONS(13235),
    [anon_sym_LBRACK] = ACTIONS(13235),
    [anon_sym_COLON_COLON2] = ACTIONS(13235),
    [anon_sym_AMP_DOT] = ACTIONS(13235),
    [anon_sym_PLUS_EQ] = ACTIONS(13235),
    [anon_sym_DASH_EQ] = ACTIONS(13235),
    [anon_sym_STAR_EQ] = ACTIONS(13235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13235),
    [anon_sym_SLASH_EQ] = ACTIONS(13235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13235),
    [anon_sym_PIPE_EQ] = ACTIONS(13235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13235),
    [anon_sym_AMP_EQ] = ACTIONS(13235),
    [anon_sym_PERCENT_EQ] = ACTIONS(13235),
    [anon_sym_GT_GT_EQ] = ACTIONS(13235),
    [anon_sym_LT_LT_EQ] = ACTIONS(13235),
    [anon_sym_CARET_EQ] = ACTIONS(13235),
    [anon_sym_QMARK] = ACTIONS(13235),
    [anon_sym_DOT_DOT] = ACTIONS(13237),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13235),
    [anon_sym_and] = ACTIONS(13235),
    [anon_sym_or] = ACTIONS(13235),
    [anon_sym_PIPE_PIPE] = ACTIONS(13237),
    [anon_sym_AMP_AMP] = ACTIONS(13237),
    [anon_sym_LT_LT] = ACTIONS(13237),
    [anon_sym_GT_GT] = ACTIONS(13237),
    [anon_sym_EQ_EQ] = ACTIONS(13237),
    [anon_sym_BANG_EQ] = ACTIONS(13235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13235),
    [anon_sym_LT_EQ_GT] = ACTIONS(13235),
    [anon_sym_EQ_TILDE] = ACTIONS(13235),
    [anon_sym_BANG_TILDE] = ACTIONS(13235),
    [anon_sym_LT_EQ] = ACTIONS(13237),
    [anon_sym_GT] = ACTIONS(13237),
    [anon_sym_GT_EQ] = ACTIONS(13235),
    [anon_sym_CARET] = ACTIONS(13237),
    [anon_sym_PLUS] = ACTIONS(13237),
    [anon_sym_SLASH] = ACTIONS(13237),
    [anon_sym_PERCENT] = ACTIONS(13237),
    [sym_comment] = ACTIONS(87),
  },
  [10827] = {
    [anon_sym_end] = ACTIONS(15112),
    [sym_comment] = ACTIONS(87),
  },
  [10828] = {
    [sym__line_break] = ACTIONS(13547),
    [sym__heredoc_body_start] = ACTIONS(13547),
    [sym__binary_minus] = ACTIONS(13547),
    [sym__binary_star] = ACTIONS(13547),
    [ts_builtin_sym_end] = ACTIONS(13547),
    [anon_sym___END__] = ACTIONS(13547),
    [anon_sym_LBRACE] = ACTIONS(13547),
    [anon_sym_RBRACE] = ACTIONS(13547),
    [anon_sym_RPAREN] = ACTIONS(13547),
    [anon_sym_DOT] = ACTIONS(13549),
    [anon_sym_COMMA] = ACTIONS(13547),
    [anon_sym_PIPE] = ACTIONS(13549),
    [anon_sym_SEMI] = ACTIONS(13547),
    [anon_sym_STAR_STAR] = ACTIONS(13549),
    [anon_sym_AMP] = ACTIONS(13549),
    [anon_sym_EQ] = ACTIONS(13549),
    [anon_sym_LT] = ACTIONS(13549),
    [anon_sym_end] = ACTIONS(13547),
    [anon_sym_if] = ACTIONS(13547),
    [anon_sym_unless] = ACTIONS(13547),
    [anon_sym_while] = ACTIONS(13547),
    [anon_sym_until] = ACTIONS(13547),
    [anon_sym_rescue] = ACTIONS(13547),
    [anon_sym_do] = ACTIONS(13547),
    [anon_sym_when] = ACTIONS(13547),
    [anon_sym_elsif] = ACTIONS(13547),
    [anon_sym_else] = ACTIONS(13547),
    [anon_sym_then] = ACTIONS(13547),
    [anon_sym_ensure] = ACTIONS(13547),
    [anon_sym_LBRACK] = ACTIONS(13547),
    [anon_sym_COLON_COLON2] = ACTIONS(13547),
    [anon_sym_AMP_DOT] = ACTIONS(13547),
    [anon_sym_PLUS_EQ] = ACTIONS(13547),
    [anon_sym_DASH_EQ] = ACTIONS(13547),
    [anon_sym_STAR_EQ] = ACTIONS(13547),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13547),
    [anon_sym_SLASH_EQ] = ACTIONS(13547),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13547),
    [anon_sym_PIPE_EQ] = ACTIONS(13547),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13547),
    [anon_sym_AMP_EQ] = ACTIONS(13547),
    [anon_sym_PERCENT_EQ] = ACTIONS(13547),
    [anon_sym_GT_GT_EQ] = ACTIONS(13547),
    [anon_sym_LT_LT_EQ] = ACTIONS(13547),
    [anon_sym_CARET_EQ] = ACTIONS(13547),
    [anon_sym_QMARK] = ACTIONS(13547),
    [anon_sym_DOT_DOT] = ACTIONS(13549),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13547),
    [anon_sym_and] = ACTIONS(13547),
    [anon_sym_or] = ACTIONS(13547),
    [anon_sym_PIPE_PIPE] = ACTIONS(13549),
    [anon_sym_AMP_AMP] = ACTIONS(13549),
    [anon_sym_LT_LT] = ACTIONS(13549),
    [anon_sym_GT_GT] = ACTIONS(13549),
    [anon_sym_EQ_EQ] = ACTIONS(13549),
    [anon_sym_BANG_EQ] = ACTIONS(13547),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13547),
    [anon_sym_LT_EQ_GT] = ACTIONS(13547),
    [anon_sym_EQ_TILDE] = ACTIONS(13547),
    [anon_sym_BANG_TILDE] = ACTIONS(13547),
    [anon_sym_LT_EQ] = ACTIONS(13549),
    [anon_sym_GT] = ACTIONS(13549),
    [anon_sym_GT_EQ] = ACTIONS(13547),
    [anon_sym_CARET] = ACTIONS(13549),
    [anon_sym_PLUS] = ACTIONS(13549),
    [anon_sym_SLASH] = ACTIONS(13549),
    [anon_sym_PERCENT] = ACTIONS(13549),
    [sym_comment] = ACTIONS(87),
  },
  [10829] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(11170),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(6361),
    [sym_scope_resolution] = STATE(1517),
    [sym_call] = STATE(1517),
    [sym_method_call] = STATE(6361),
    [sym_assignment] = STATE(11170),
    [sym_operator_assignment] = STATE(11170),
    [sym_conditional] = STATE(11170),
    [sym_range] = STATE(11170),
    [sym_binary] = STATE(11170),
    [sym_unary] = STATE(11170),
    [sym_left_assignment_list] = STATE(6360),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6361),
    [sym__variable] = STATE(1517),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(6361),
    [sym_false] = STATE(6361),
    [sym_nil] = STATE(6361),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(4013),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(9790),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_next] = ACTIONS(3121),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9792),
    [anon_sym_defined_QMARK] = ACTIONS(9794),
    [anon_sym_not] = ACTIONS(9796),
    [anon_sym_BANG] = ACTIONS(9798),
    [anon_sym_TILDE] = ACTIONS(9798),
    [sym_constant] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_instance_variable] = ACTIONS(2651),
    [sym_class_variable] = ACTIONS(2651),
    [sym_global_variable] = ACTIONS(2651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(2653),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(2653),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10830] = {
    [sym__line_break] = ACTIONS(14151),
    [sym__heredoc_body_start] = ACTIONS(14151),
    [sym__binary_minus] = ACTIONS(14151),
    [sym__binary_star] = ACTIONS(14151),
    [ts_builtin_sym_end] = ACTIONS(14151),
    [anon_sym___END__] = ACTIONS(14151),
    [anon_sym_LBRACE] = ACTIONS(14151),
    [anon_sym_RBRACE] = ACTIONS(14151),
    [anon_sym_RPAREN] = ACTIONS(14151),
    [anon_sym_DOT] = ACTIONS(14153),
    [anon_sym_COMMA] = ACTIONS(14151),
    [anon_sym_PIPE] = ACTIONS(14153),
    [anon_sym_SEMI] = ACTIONS(14151),
    [anon_sym_STAR_STAR] = ACTIONS(14153),
    [anon_sym_AMP] = ACTIONS(14153),
    [anon_sym_EQ] = ACTIONS(14153),
    [anon_sym_LT] = ACTIONS(14153),
    [anon_sym_end] = ACTIONS(14151),
    [anon_sym_if] = ACTIONS(14151),
    [anon_sym_unless] = ACTIONS(14151),
    [anon_sym_while] = ACTIONS(14151),
    [anon_sym_until] = ACTIONS(14151),
    [anon_sym_rescue] = ACTIONS(14151),
    [anon_sym_do] = ACTIONS(14151),
    [anon_sym_when] = ACTIONS(14151),
    [anon_sym_elsif] = ACTIONS(14151),
    [anon_sym_else] = ACTIONS(14151),
    [anon_sym_then] = ACTIONS(14151),
    [anon_sym_ensure] = ACTIONS(14151),
    [anon_sym_EQ_GT] = ACTIONS(14151),
    [anon_sym_LBRACK] = ACTIONS(14151),
    [anon_sym_COLON_COLON2] = ACTIONS(14151),
    [anon_sym_AMP_DOT] = ACTIONS(14151),
    [anon_sym_PLUS_EQ] = ACTIONS(14151),
    [anon_sym_DASH_EQ] = ACTIONS(14151),
    [anon_sym_STAR_EQ] = ACTIONS(14151),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14151),
    [anon_sym_SLASH_EQ] = ACTIONS(14151),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14151),
    [anon_sym_PIPE_EQ] = ACTIONS(14151),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14151),
    [anon_sym_AMP_EQ] = ACTIONS(14151),
    [anon_sym_PERCENT_EQ] = ACTIONS(14151),
    [anon_sym_GT_GT_EQ] = ACTIONS(14151),
    [anon_sym_LT_LT_EQ] = ACTIONS(14151),
    [anon_sym_CARET_EQ] = ACTIONS(14151),
    [anon_sym_QMARK] = ACTIONS(14151),
    [anon_sym_DOT_DOT] = ACTIONS(14153),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14151),
    [anon_sym_and] = ACTIONS(14151),
    [anon_sym_or] = ACTIONS(14151),
    [anon_sym_PIPE_PIPE] = ACTIONS(14153),
    [anon_sym_AMP_AMP] = ACTIONS(14153),
    [anon_sym_LT_LT] = ACTIONS(14153),
    [anon_sym_GT_GT] = ACTIONS(14153),
    [anon_sym_EQ_EQ] = ACTIONS(14153),
    [anon_sym_BANG_EQ] = ACTIONS(14151),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14151),
    [anon_sym_LT_EQ_GT] = ACTIONS(14151),
    [anon_sym_EQ_TILDE] = ACTIONS(14151),
    [anon_sym_BANG_TILDE] = ACTIONS(14151),
    [anon_sym_LT_EQ] = ACTIONS(14153),
    [anon_sym_GT] = ACTIONS(14153),
    [anon_sym_GT_EQ] = ACTIONS(14151),
    [anon_sym_CARET] = ACTIONS(14153),
    [anon_sym_PLUS] = ACTIONS(14153),
    [anon_sym_SLASH] = ACTIONS(14153),
    [anon_sym_PERCENT] = ACTIONS(14153),
    [sym_comment] = ACTIONS(87),
  },
  [10831] = {
    [sym_heredoc_body] = STATE(10831),
    [aux_sym_call_repeat1] = STATE(10831),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(7916),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [10832] = {
    [sym_heredoc_body] = STATE(10831),
    [aux_sym_call_repeat1] = STATE(10831),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [10833] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(11171),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(6419),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(6419),
    [sym_assignment] = STATE(11171),
    [sym_operator_assignment] = STATE(11171),
    [sym_conditional] = STATE(11171),
    [sym_range] = STATE(11171),
    [sym_binary] = STATE(11171),
    [sym_unary] = STATE(11171),
    [sym_left_assignment_list] = STATE(6418),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6419),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(6419),
    [sym_false] = STATE(6419),
    [sym_nil] = STATE(6419),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(6420),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(9859),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9861),
    [anon_sym_yield] = ACTIONS(9863),
    [anon_sym_break] = ACTIONS(9865),
    [anon_sym_next] = ACTIONS(9867),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9869),
    [anon_sym_defined_QMARK] = ACTIONS(9871),
    [anon_sym_not] = ACTIONS(9873),
    [anon_sym_BANG] = ACTIONS(9875),
    [anon_sym_TILDE] = ACTIONS(9875),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10834] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10102),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(6419),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(6419),
    [sym_splat_argument] = STATE(7439),
    [sym_assignment] = STATE(10102),
    [sym_operator_assignment] = STATE(10102),
    [sym_conditional] = STATE(10102),
    [sym_range] = STATE(10102),
    [sym_binary] = STATE(10102),
    [sym_unary] = STATE(10102),
    [sym__arg_or_splat_arg] = STATE(7439),
    [sym_left_assignment_list] = STATE(6418),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6419),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(6419),
    [sym_false] = STATE(6419),
    [sym_nil] = STATE(6419),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(6420),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(6243),
    [sym__unary_minus] = ACTIONS(9859),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9861),
    [anon_sym_yield] = ACTIONS(9863),
    [anon_sym_break] = ACTIONS(9865),
    [anon_sym_next] = ACTIONS(9867),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9869),
    [anon_sym_defined_QMARK] = ACTIONS(9871),
    [anon_sym_not] = ACTIONS(9873),
    [anon_sym_BANG] = ACTIONS(9875),
    [anon_sym_TILDE] = ACTIONS(9875),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10835] = {
    [aux_sym_exceptions_repeat1] = STATE(11172),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(15114),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [10836] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(9891),
    [sym__binary_star] = ACTIONS(9893),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(9895),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(9893),
    [anon_sym_AMP] = ACTIONS(9897),
    [anon_sym_LT] = ACTIONS(9899),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_EQ_GT] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(9901),
    [anon_sym_DOT_DOT] = ACTIONS(9903),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9905),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(9907),
    [anon_sym_AMP_AMP] = ACTIONS(9907),
    [anon_sym_LT_LT] = ACTIONS(9909),
    [anon_sym_GT_GT] = ACTIONS(9909),
    [anon_sym_EQ_EQ] = ACTIONS(9911),
    [anon_sym_BANG_EQ] = ACTIONS(9907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9907),
    [anon_sym_LT_EQ_GT] = ACTIONS(9907),
    [anon_sym_EQ_TILDE] = ACTIONS(9907),
    [anon_sym_BANG_TILDE] = ACTIONS(9907),
    [anon_sym_LT_EQ] = ACTIONS(9899),
    [anon_sym_GT] = ACTIONS(9899),
    [anon_sym_GT_EQ] = ACTIONS(9913),
    [anon_sym_CARET] = ACTIONS(9915),
    [anon_sym_PLUS] = ACTIONS(9891),
    [anon_sym_SLASH] = ACTIONS(9893),
    [anon_sym_PERCENT] = ACTIONS(9893),
    [sym_comment] = ACTIONS(87),
  },
  [10837] = {
    [aux_sym_exceptions_repeat1] = STATE(10837),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(15116),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [10838] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(11173),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(6488),
    [sym_scope_resolution] = STATE(6486),
    [sym_call] = STATE(6486),
    [sym_method_call] = STATE(6488),
    [sym_assignment] = STATE(11173),
    [sym_operator_assignment] = STATE(11173),
    [sym_conditional] = STATE(11173),
    [sym_range] = STATE(11173),
    [sym_binary] = STATE(11173),
    [sym_unary] = STATE(11173),
    [sym_left_assignment_list] = STATE(6487),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6488),
    [sym__variable] = STATE(6486),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(6488),
    [sym_false] = STATE(6488),
    [sym_nil] = STATE(6488),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(6489),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(9935),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(9937),
    [anon_sym_yield] = ACTIONS(9939),
    [anon_sym_break] = ACTIONS(9941),
    [anon_sym_next] = ACTIONS(9943),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(9945),
    [anon_sym_defined_QMARK] = ACTIONS(9947),
    [anon_sym_not] = ACTIONS(9949),
    [anon_sym_BANG] = ACTIONS(9951),
    [anon_sym_TILDE] = ACTIONS(9951),
    [sym_constant] = ACTIONS(9953),
    [sym_identifier] = ACTIONS(9953),
    [sym_instance_variable] = ACTIONS(9955),
    [sym_class_variable] = ACTIONS(9955),
    [sym_global_variable] = ACTIONS(9955),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(9953),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9953),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [10839] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10132),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(6488),
    [sym_scope_resolution] = STATE(6486),
    [sym_call] = STATE(6486),
    [sym_method_call] = STATE(6488),
    [sym_splat_argument] = STATE(10067),
    [sym_assignment] = STATE(10132),
    [sym_operator_assignment] = STATE(10132),
    [sym_conditional] = STATE(10132),
    [sym_range] = STATE(10132),
    [sym_binary] = STATE(10132),
    [sym_unary] = STATE(10132),
    [sym__arg_or_splat_arg] = STATE(10067),
    [sym_left_assignment_list] = STATE(6487),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6488),
    [sym__variable] = STATE(6486),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(6488),
    [sym_false] = STATE(6488),
    [sym_nil] = STATE(6488),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(6489),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__splat_star] = ACTIONS(6313),
    [sym__unary_minus] = ACTIONS(9935),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(9937),
    [anon_sym_yield] = ACTIONS(9939),
    [anon_sym_break] = ACTIONS(9941),
    [anon_sym_next] = ACTIONS(9943),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(9945),
    [anon_sym_defined_QMARK] = ACTIONS(9947),
    [anon_sym_not] = ACTIONS(9949),
    [anon_sym_BANG] = ACTIONS(9951),
    [anon_sym_TILDE] = ACTIONS(9951),
    [sym_constant] = ACTIONS(9953),
    [sym_identifier] = ACTIONS(9953),
    [sym_instance_variable] = ACTIONS(9955),
    [sym_class_variable] = ACTIONS(9955),
    [sym_global_variable] = ACTIONS(9955),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(9953),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9953),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [10840] = {
    [aux_sym_exceptions_repeat1] = STATE(11174),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_LBRACE] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(15119),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9857),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_EQ] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_do] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_PLUS_EQ] = ACTIONS(9855),
    [anon_sym_DASH_EQ] = ACTIONS(9855),
    [anon_sym_STAR_EQ] = ACTIONS(9855),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9855),
    [anon_sym_SLASH_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9855),
    [anon_sym_AMP_EQ] = ACTIONS(9855),
    [anon_sym_PERCENT_EQ] = ACTIONS(9855),
    [anon_sym_GT_GT_EQ] = ACTIONS(9855),
    [anon_sym_LT_LT_EQ] = ACTIONS(9855),
    [anon_sym_CARET_EQ] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9857),
    [anon_sym_AMP_AMP] = ACTIONS(9857),
    [anon_sym_LT_LT] = ACTIONS(9857),
    [anon_sym_GT_GT] = ACTIONS(9857),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9857),
    [anon_sym_PLUS] = ACTIONS(9857),
    [anon_sym_SLASH] = ACTIONS(9857),
    [anon_sym_PERCENT] = ACTIONS(9857),
    [sym_comment] = ACTIONS(87),
  },
  [10841] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(9963),
    [sym__binary_star] = ACTIONS(9965),
    [anon_sym_LBRACE] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(9967),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(9969),
    [anon_sym_AMP] = ACTIONS(9971),
    [anon_sym_EQ] = ACTIONS(12879),
    [anon_sym_LT] = ACTIONS(9973),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_EQ_GT] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_PLUS_EQ] = ACTIONS(12120),
    [anon_sym_DASH_EQ] = ACTIONS(12120),
    [anon_sym_STAR_EQ] = ACTIONS(12120),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12120),
    [anon_sym_SLASH_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12120),
    [anon_sym_AMP_EQ] = ACTIONS(12120),
    [anon_sym_PERCENT_EQ] = ACTIONS(12120),
    [anon_sym_GT_GT_EQ] = ACTIONS(12120),
    [anon_sym_LT_LT_EQ] = ACTIONS(12120),
    [anon_sym_CARET_EQ] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(9975),
    [anon_sym_DOT_DOT] = ACTIONS(9977),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9979),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(9981),
    [anon_sym_AMP_AMP] = ACTIONS(9981),
    [anon_sym_LT_LT] = ACTIONS(9983),
    [anon_sym_GT_GT] = ACTIONS(9983),
    [anon_sym_EQ_EQ] = ACTIONS(9981),
    [anon_sym_BANG_EQ] = ACTIONS(9985),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9985),
    [anon_sym_LT_EQ_GT] = ACTIONS(9985),
    [anon_sym_EQ_TILDE] = ACTIONS(9985),
    [anon_sym_BANG_TILDE] = ACTIONS(9985),
    [anon_sym_LT_EQ] = ACTIONS(9973),
    [anon_sym_GT] = ACTIONS(9973),
    [anon_sym_GT_EQ] = ACTIONS(9987),
    [anon_sym_CARET] = ACTIONS(9967),
    [anon_sym_PLUS] = ACTIONS(9989),
    [anon_sym_SLASH] = ACTIONS(9969),
    [anon_sym_PERCENT] = ACTIONS(9969),
    [sym_comment] = ACTIONS(87),
  },
  [10842] = {
    [aux_sym_exceptions_repeat1] = STATE(10842),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(15121),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_PLUS_EQ] = ACTIONS(11597),
    [anon_sym_DASH_EQ] = ACTIONS(11597),
    [anon_sym_STAR_EQ] = ACTIONS(11597),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11597),
    [anon_sym_SLASH_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11597),
    [anon_sym_AMP_EQ] = ACTIONS(11597),
    [anon_sym_PERCENT_EQ] = ACTIONS(11597),
    [anon_sym_GT_GT_EQ] = ACTIONS(11597),
    [anon_sym_LT_LT_EQ] = ACTIONS(11597),
    [anon_sym_CARET_EQ] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_LT] = ACTIONS(12338),
    [anon_sym_GT_GT] = ACTIONS(12338),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(12338),
    [anon_sym_PLUS] = ACTIONS(12338),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [10843] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(11175),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(6520),
    [sym_scope_resolution] = STATE(1613),
    [sym_call] = STATE(1613),
    [sym_method_call] = STATE(6520),
    [sym_assignment] = STATE(11175),
    [sym_operator_assignment] = STATE(11175),
    [sym_conditional] = STATE(11175),
    [sym_range] = STATE(11175),
    [sym_binary] = STATE(11175),
    [sym_unary] = STATE(11175),
    [sym_left_assignment_list] = STATE(6519),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(6520),
    [sym__variable] = STATE(1613),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(6520),
    [sym_false] = STATE(6520),
    [sym_nil] = STATE(6520),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(6420),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10003),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9861),
    [anon_sym_yield] = ACTIONS(9863),
    [anon_sym_break] = ACTIONS(9865),
    [anon_sym_next] = ACTIONS(9867),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10005),
    [anon_sym_defined_QMARK] = ACTIONS(10007),
    [anon_sym_not] = ACTIONS(10009),
    [anon_sym_BANG] = ACTIONS(10011),
    [anon_sym_TILDE] = ACTIONS(10011),
    [sym_constant] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6237),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_class_variable] = ACTIONS(6239),
    [sym_global_variable] = ACTIONS(6239),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(6237),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6237),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10844] = {
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(10017),
    [sym__binary_star] = ACTIONS(10019),
    [anon_sym_RBRACE] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(10021),
    [anon_sym_STAR_STAR] = ACTIONS(10019),
    [anon_sym_AMP] = ACTIONS(10023),
    [anon_sym_LT] = ACTIONS(10025),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(10027),
    [anon_sym_DOT_DOT] = ACTIONS(10029),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10031),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(10033),
    [anon_sym_AMP_AMP] = ACTIONS(10033),
    [anon_sym_LT_LT] = ACTIONS(10035),
    [anon_sym_GT_GT] = ACTIONS(10035),
    [anon_sym_EQ_EQ] = ACTIONS(10037),
    [anon_sym_BANG_EQ] = ACTIONS(10033),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10033),
    [anon_sym_LT_EQ_GT] = ACTIONS(10033),
    [anon_sym_EQ_TILDE] = ACTIONS(10033),
    [anon_sym_BANG_TILDE] = ACTIONS(10033),
    [anon_sym_LT_EQ] = ACTIONS(10025),
    [anon_sym_GT] = ACTIONS(10025),
    [anon_sym_GT_EQ] = ACTIONS(10039),
    [anon_sym_CARET] = ACTIONS(10041),
    [anon_sym_PLUS] = ACTIONS(10017),
    [anon_sym_SLASH] = ACTIONS(10019),
    [anon_sym_PERCENT] = ACTIONS(10019),
    [sym_comment] = ACTIONS(87),
  },
  [10845] = {
    [aux_sym_exceptions_repeat1] = STATE(10845),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_RBRACE] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(15124),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [10846] = {
    [sym__heredoc_body_start] = ACTIONS(10203),
    [sym__binary_minus] = ACTIONS(10203),
    [sym__binary_star] = ACTIONS(10203),
    [anon_sym_LBRACE] = ACTIONS(10203),
    [anon_sym_RBRACE] = ACTIONS(10203),
    [anon_sym_RPAREN] = ACTIONS(10203),
    [anon_sym_DOT] = ACTIONS(10205),
    [anon_sym_COMMA] = ACTIONS(10203),
    [anon_sym_PIPE] = ACTIONS(10205),
    [anon_sym_SEMI] = ACTIONS(10203),
    [anon_sym_STAR_STAR] = ACTIONS(10205),
    [anon_sym_AMP] = ACTIONS(10205),
    [anon_sym_EQ] = ACTIONS(10205),
    [anon_sym_LT] = ACTIONS(10205),
    [anon_sym_if] = ACTIONS(10203),
    [anon_sym_unless] = ACTIONS(10203),
    [anon_sym_while] = ACTIONS(10203),
    [anon_sym_until] = ACTIONS(10203),
    [anon_sym_rescue] = ACTIONS(10203),
    [anon_sym_in] = ACTIONS(10203),
    [anon_sym_do] = ACTIONS(10203),
    [anon_sym_LBRACK] = ACTIONS(10203),
    [anon_sym_RBRACK] = ACTIONS(10203),
    [anon_sym_COLON_COLON2] = ACTIONS(10203),
    [anon_sym_AMP_DOT] = ACTIONS(10203),
    [anon_sym_PLUS_EQ] = ACTIONS(10203),
    [anon_sym_DASH_EQ] = ACTIONS(10203),
    [anon_sym_STAR_EQ] = ACTIONS(10203),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10203),
    [anon_sym_SLASH_EQ] = ACTIONS(10203),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10203),
    [anon_sym_PIPE_EQ] = ACTIONS(10203),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10203),
    [anon_sym_AMP_EQ] = ACTIONS(10203),
    [anon_sym_PERCENT_EQ] = ACTIONS(10203),
    [anon_sym_GT_GT_EQ] = ACTIONS(10203),
    [anon_sym_LT_LT_EQ] = ACTIONS(10203),
    [anon_sym_CARET_EQ] = ACTIONS(10203),
    [anon_sym_QMARK] = ACTIONS(10203),
    [anon_sym_COLON2] = ACTIONS(10205),
    [anon_sym_DOT_DOT] = ACTIONS(10205),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10203),
    [anon_sym_and] = ACTIONS(10203),
    [anon_sym_or] = ACTIONS(10203),
    [anon_sym_PIPE_PIPE] = ACTIONS(10205),
    [anon_sym_AMP_AMP] = ACTIONS(10205),
    [anon_sym_LT_LT] = ACTIONS(10205),
    [anon_sym_GT_GT] = ACTIONS(10205),
    [anon_sym_EQ_EQ] = ACTIONS(10205),
    [anon_sym_BANG_EQ] = ACTIONS(10203),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10203),
    [anon_sym_LT_EQ_GT] = ACTIONS(10203),
    [anon_sym_EQ_TILDE] = ACTIONS(10203),
    [anon_sym_BANG_TILDE] = ACTIONS(10203),
    [anon_sym_LT_EQ] = ACTIONS(10205),
    [anon_sym_GT] = ACTIONS(10205),
    [anon_sym_GT_EQ] = ACTIONS(10203),
    [anon_sym_CARET] = ACTIONS(10205),
    [anon_sym_PLUS] = ACTIONS(10205),
    [anon_sym_SLASH] = ACTIONS(10205),
    [anon_sym_PERCENT] = ACTIONS(10205),
    [sym_comment] = ACTIONS(87),
  },
  [10847] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1697),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(15127),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [10848] = {
    [sym__heredoc_body_start] = ACTIONS(10209),
    [sym__binary_minus] = ACTIONS(10209),
    [sym__binary_star] = ACTIONS(10209),
    [anon_sym_LBRACE] = ACTIONS(10209),
    [anon_sym_RBRACE] = ACTIONS(10209),
    [anon_sym_RPAREN] = ACTIONS(10209),
    [anon_sym_DOT] = ACTIONS(10211),
    [anon_sym_COMMA] = ACTIONS(10209),
    [anon_sym_PIPE] = ACTIONS(10211),
    [anon_sym_SEMI] = ACTIONS(10209),
    [anon_sym_STAR_STAR] = ACTIONS(10211),
    [anon_sym_AMP] = ACTIONS(10211),
    [anon_sym_EQ] = ACTIONS(10211),
    [anon_sym_LT] = ACTIONS(10211),
    [anon_sym_if] = ACTIONS(10209),
    [anon_sym_unless] = ACTIONS(10209),
    [anon_sym_while] = ACTIONS(10209),
    [anon_sym_until] = ACTIONS(10209),
    [anon_sym_rescue] = ACTIONS(10209),
    [anon_sym_in] = ACTIONS(10209),
    [anon_sym_do] = ACTIONS(10209),
    [anon_sym_LBRACK] = ACTIONS(10209),
    [anon_sym_RBRACK] = ACTIONS(10209),
    [anon_sym_COLON_COLON2] = ACTIONS(10209),
    [anon_sym_AMP_DOT] = ACTIONS(10209),
    [anon_sym_PLUS_EQ] = ACTIONS(10209),
    [anon_sym_DASH_EQ] = ACTIONS(10209),
    [anon_sym_STAR_EQ] = ACTIONS(10209),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10209),
    [anon_sym_SLASH_EQ] = ACTIONS(10209),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10209),
    [anon_sym_PIPE_EQ] = ACTIONS(10209),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10209),
    [anon_sym_AMP_EQ] = ACTIONS(10209),
    [anon_sym_PERCENT_EQ] = ACTIONS(10209),
    [anon_sym_GT_GT_EQ] = ACTIONS(10209),
    [anon_sym_LT_LT_EQ] = ACTIONS(10209),
    [anon_sym_CARET_EQ] = ACTIONS(10209),
    [anon_sym_QMARK] = ACTIONS(10209),
    [anon_sym_COLON2] = ACTIONS(10211),
    [anon_sym_DOT_DOT] = ACTIONS(10211),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10209),
    [anon_sym_and] = ACTIONS(10209),
    [anon_sym_or] = ACTIONS(10209),
    [anon_sym_PIPE_PIPE] = ACTIONS(10211),
    [anon_sym_AMP_AMP] = ACTIONS(10211),
    [anon_sym_LT_LT] = ACTIONS(10211),
    [anon_sym_GT_GT] = ACTIONS(10211),
    [anon_sym_EQ_EQ] = ACTIONS(10211),
    [anon_sym_BANG_EQ] = ACTIONS(10209),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10209),
    [anon_sym_LT_EQ_GT] = ACTIONS(10209),
    [anon_sym_EQ_TILDE] = ACTIONS(10209),
    [anon_sym_BANG_TILDE] = ACTIONS(10209),
    [anon_sym_LT_EQ] = ACTIONS(10211),
    [anon_sym_GT] = ACTIONS(10211),
    [anon_sym_GT_EQ] = ACTIONS(10209),
    [anon_sym_CARET] = ACTIONS(10211),
    [anon_sym_PLUS] = ACTIONS(10211),
    [anon_sym_SLASH] = ACTIONS(10211),
    [anon_sym_PERCENT] = ACTIONS(10211),
    [sym_comment] = ACTIONS(87),
  },
  [10849] = {
    [sym__heredoc_body_start] = ACTIONS(10213),
    [sym__binary_minus] = ACTIONS(10213),
    [sym__binary_star] = ACTIONS(10213),
    [anon_sym_LBRACE] = ACTIONS(10213),
    [anon_sym_RBRACE] = ACTIONS(10213),
    [anon_sym_RPAREN] = ACTIONS(10213),
    [anon_sym_DOT] = ACTIONS(10215),
    [anon_sym_COMMA] = ACTIONS(10213),
    [anon_sym_PIPE] = ACTIONS(10215),
    [anon_sym_SEMI] = ACTIONS(10213),
    [anon_sym_STAR_STAR] = ACTIONS(10215),
    [anon_sym_AMP] = ACTIONS(10215),
    [anon_sym_EQ] = ACTIONS(10215),
    [anon_sym_LT] = ACTIONS(10215),
    [anon_sym_if] = ACTIONS(10213),
    [anon_sym_unless] = ACTIONS(10213),
    [anon_sym_while] = ACTIONS(10213),
    [anon_sym_until] = ACTIONS(10213),
    [anon_sym_rescue] = ACTIONS(10213),
    [anon_sym_in] = ACTIONS(10213),
    [anon_sym_do] = ACTIONS(10213),
    [anon_sym_LBRACK] = ACTIONS(10213),
    [anon_sym_RBRACK] = ACTIONS(10213),
    [anon_sym_COLON_COLON2] = ACTIONS(10213),
    [anon_sym_AMP_DOT] = ACTIONS(10213),
    [anon_sym_PLUS_EQ] = ACTIONS(10213),
    [anon_sym_DASH_EQ] = ACTIONS(10213),
    [anon_sym_STAR_EQ] = ACTIONS(10213),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10213),
    [anon_sym_SLASH_EQ] = ACTIONS(10213),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10213),
    [anon_sym_PIPE_EQ] = ACTIONS(10213),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10213),
    [anon_sym_AMP_EQ] = ACTIONS(10213),
    [anon_sym_PERCENT_EQ] = ACTIONS(10213),
    [anon_sym_GT_GT_EQ] = ACTIONS(10213),
    [anon_sym_LT_LT_EQ] = ACTIONS(10213),
    [anon_sym_CARET_EQ] = ACTIONS(10213),
    [anon_sym_QMARK] = ACTIONS(10213),
    [anon_sym_COLON2] = ACTIONS(10215),
    [anon_sym_DOT_DOT] = ACTIONS(10215),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10213),
    [anon_sym_and] = ACTIONS(10213),
    [anon_sym_or] = ACTIONS(10213),
    [anon_sym_PIPE_PIPE] = ACTIONS(10215),
    [anon_sym_AMP_AMP] = ACTIONS(10215),
    [anon_sym_LT_LT] = ACTIONS(10215),
    [anon_sym_GT_GT] = ACTIONS(10215),
    [anon_sym_EQ_EQ] = ACTIONS(10215),
    [anon_sym_BANG_EQ] = ACTIONS(10213),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10213),
    [anon_sym_LT_EQ_GT] = ACTIONS(10213),
    [anon_sym_EQ_TILDE] = ACTIONS(10213),
    [anon_sym_BANG_TILDE] = ACTIONS(10213),
    [anon_sym_LT_EQ] = ACTIONS(10215),
    [anon_sym_GT] = ACTIONS(10215),
    [anon_sym_GT_EQ] = ACTIONS(10213),
    [anon_sym_CARET] = ACTIONS(10215),
    [anon_sym_PLUS] = ACTIONS(10215),
    [anon_sym_SLASH] = ACTIONS(10215),
    [anon_sym_PERCENT] = ACTIONS(10215),
    [sym_comment] = ACTIONS(87),
  },
  [10850] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1705),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(15129),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [10851] = {
    [sym__heredoc_body_start] = ACTIONS(10219),
    [sym__binary_minus] = ACTIONS(10219),
    [sym__binary_star] = ACTIONS(10219),
    [anon_sym_LBRACE] = ACTIONS(10219),
    [anon_sym_RBRACE] = ACTIONS(10219),
    [anon_sym_RPAREN] = ACTIONS(10219),
    [anon_sym_DOT] = ACTIONS(10221),
    [anon_sym_COMMA] = ACTIONS(10219),
    [anon_sym_PIPE] = ACTIONS(10221),
    [anon_sym_SEMI] = ACTIONS(10219),
    [anon_sym_STAR_STAR] = ACTIONS(10221),
    [anon_sym_AMP] = ACTIONS(10221),
    [anon_sym_EQ] = ACTIONS(10221),
    [anon_sym_LT] = ACTIONS(10221),
    [anon_sym_if] = ACTIONS(10219),
    [anon_sym_unless] = ACTIONS(10219),
    [anon_sym_while] = ACTIONS(10219),
    [anon_sym_until] = ACTIONS(10219),
    [anon_sym_rescue] = ACTIONS(10219),
    [anon_sym_in] = ACTIONS(10219),
    [anon_sym_do] = ACTIONS(10219),
    [anon_sym_LBRACK] = ACTIONS(10219),
    [anon_sym_RBRACK] = ACTIONS(10219),
    [anon_sym_COLON_COLON2] = ACTIONS(10219),
    [anon_sym_AMP_DOT] = ACTIONS(10219),
    [anon_sym_PLUS_EQ] = ACTIONS(10219),
    [anon_sym_DASH_EQ] = ACTIONS(10219),
    [anon_sym_STAR_EQ] = ACTIONS(10219),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10219),
    [anon_sym_SLASH_EQ] = ACTIONS(10219),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10219),
    [anon_sym_PIPE_EQ] = ACTIONS(10219),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10219),
    [anon_sym_AMP_EQ] = ACTIONS(10219),
    [anon_sym_PERCENT_EQ] = ACTIONS(10219),
    [anon_sym_GT_GT_EQ] = ACTIONS(10219),
    [anon_sym_LT_LT_EQ] = ACTIONS(10219),
    [anon_sym_CARET_EQ] = ACTIONS(10219),
    [anon_sym_QMARK] = ACTIONS(10219),
    [anon_sym_COLON2] = ACTIONS(10221),
    [anon_sym_DOT_DOT] = ACTIONS(10221),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10219),
    [anon_sym_and] = ACTIONS(10219),
    [anon_sym_or] = ACTIONS(10219),
    [anon_sym_PIPE_PIPE] = ACTIONS(10221),
    [anon_sym_AMP_AMP] = ACTIONS(10221),
    [anon_sym_LT_LT] = ACTIONS(10221),
    [anon_sym_GT_GT] = ACTIONS(10221),
    [anon_sym_EQ_EQ] = ACTIONS(10221),
    [anon_sym_BANG_EQ] = ACTIONS(10219),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10219),
    [anon_sym_LT_EQ_GT] = ACTIONS(10219),
    [anon_sym_EQ_TILDE] = ACTIONS(10219),
    [anon_sym_BANG_TILDE] = ACTIONS(10219),
    [anon_sym_LT_EQ] = ACTIONS(10221),
    [anon_sym_GT] = ACTIONS(10221),
    [anon_sym_GT_EQ] = ACTIONS(10219),
    [anon_sym_CARET] = ACTIONS(10221),
    [anon_sym_PLUS] = ACTIONS(10221),
    [anon_sym_SLASH] = ACTIONS(10221),
    [anon_sym_PERCENT] = ACTIONS(10221),
    [sym_comment] = ACTIONS(87),
  },
  [10852] = {
    [sym__method_rest] = STATE(11178),
    [sym_operator] = STATE(6606),
    [sym__method_name] = STATE(6606),
    [sym_setter] = STATE(6606),
    [sym_symbol] = STATE(6606),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(13847),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(13847),
    [sym_class_variable] = ACTIONS(13847),
    [sym_global_variable] = ACTIONS(13847),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [10853] = {
    [sym__heredoc_body_start] = ACTIONS(10927),
    [sym__binary_minus] = ACTIONS(10927),
    [sym__binary_star] = ACTIONS(10927),
    [anon_sym_LBRACE] = ACTIONS(10927),
    [anon_sym_RBRACE] = ACTIONS(10927),
    [anon_sym_RPAREN] = ACTIONS(10927),
    [anon_sym_DOT] = ACTIONS(10929),
    [anon_sym_COMMA] = ACTIONS(10927),
    [anon_sym_PIPE] = ACTIONS(10929),
    [anon_sym_SEMI] = ACTIONS(10927),
    [anon_sym_STAR_STAR] = ACTIONS(10929),
    [anon_sym_AMP] = ACTIONS(10929),
    [anon_sym_EQ] = ACTIONS(10929),
    [anon_sym_LT] = ACTIONS(10929),
    [anon_sym_if] = ACTIONS(10927),
    [anon_sym_unless] = ACTIONS(10927),
    [anon_sym_while] = ACTIONS(10927),
    [anon_sym_until] = ACTIONS(10927),
    [anon_sym_rescue] = ACTIONS(10927),
    [anon_sym_in] = ACTIONS(10927),
    [anon_sym_do] = ACTIONS(10927),
    [anon_sym_LBRACK] = ACTIONS(10927),
    [anon_sym_RBRACK] = ACTIONS(10927),
    [anon_sym_COLON_COLON2] = ACTIONS(10927),
    [anon_sym_AMP_DOT] = ACTIONS(10927),
    [anon_sym_PLUS_EQ] = ACTIONS(10927),
    [anon_sym_DASH_EQ] = ACTIONS(10927),
    [anon_sym_STAR_EQ] = ACTIONS(10927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10927),
    [anon_sym_SLASH_EQ] = ACTIONS(10927),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10927),
    [anon_sym_PIPE_EQ] = ACTIONS(10927),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10927),
    [anon_sym_AMP_EQ] = ACTIONS(10927),
    [anon_sym_PERCENT_EQ] = ACTIONS(10927),
    [anon_sym_GT_GT_EQ] = ACTIONS(10927),
    [anon_sym_LT_LT_EQ] = ACTIONS(10927),
    [anon_sym_CARET_EQ] = ACTIONS(10927),
    [anon_sym_QMARK] = ACTIONS(10927),
    [anon_sym_COLON2] = ACTIONS(10929),
    [anon_sym_DOT_DOT] = ACTIONS(10929),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10927),
    [anon_sym_and] = ACTIONS(10927),
    [anon_sym_or] = ACTIONS(10927),
    [anon_sym_PIPE_PIPE] = ACTIONS(10929),
    [anon_sym_AMP_AMP] = ACTIONS(10929),
    [anon_sym_LT_LT] = ACTIONS(10929),
    [anon_sym_GT_GT] = ACTIONS(10929),
    [anon_sym_EQ_EQ] = ACTIONS(10929),
    [anon_sym_BANG_EQ] = ACTIONS(10927),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10927),
    [anon_sym_LT_EQ_GT] = ACTIONS(10927),
    [anon_sym_EQ_TILDE] = ACTIONS(10927),
    [anon_sym_BANG_TILDE] = ACTIONS(10927),
    [anon_sym_LT_EQ] = ACTIONS(10929),
    [anon_sym_GT] = ACTIONS(10929),
    [anon_sym_GT_EQ] = ACTIONS(10927),
    [anon_sym_CARET] = ACTIONS(10929),
    [anon_sym_PLUS] = ACTIONS(10929),
    [anon_sym_SLASH] = ACTIONS(10929),
    [anon_sym_PERCENT] = ACTIONS(10929),
    [sym_comment] = ACTIONS(87),
  },
  [10854] = {
    [sym__heredoc_body_start] = ACTIONS(10931),
    [sym__binary_minus] = ACTIONS(10931),
    [sym__binary_star] = ACTIONS(10931),
    [anon_sym_LBRACE] = ACTIONS(10931),
    [anon_sym_RBRACE] = ACTIONS(10931),
    [anon_sym_RPAREN] = ACTIONS(10931),
    [anon_sym_DOT] = ACTIONS(10933),
    [anon_sym_COMMA] = ACTIONS(10931),
    [anon_sym_PIPE] = ACTIONS(10933),
    [anon_sym_SEMI] = ACTIONS(10931),
    [anon_sym_STAR_STAR] = ACTIONS(10933),
    [anon_sym_AMP] = ACTIONS(10933),
    [anon_sym_EQ] = ACTIONS(10933),
    [anon_sym_LT] = ACTIONS(10933),
    [anon_sym_if] = ACTIONS(10931),
    [anon_sym_unless] = ACTIONS(10931),
    [anon_sym_while] = ACTIONS(10931),
    [anon_sym_until] = ACTIONS(10931),
    [anon_sym_rescue] = ACTIONS(10931),
    [anon_sym_in] = ACTIONS(10931),
    [anon_sym_do] = ACTIONS(10931),
    [anon_sym_LBRACK] = ACTIONS(10931),
    [anon_sym_RBRACK] = ACTIONS(10931),
    [anon_sym_COLON_COLON2] = ACTIONS(10931),
    [anon_sym_AMP_DOT] = ACTIONS(10931),
    [anon_sym_PLUS_EQ] = ACTIONS(10931),
    [anon_sym_DASH_EQ] = ACTIONS(10931),
    [anon_sym_STAR_EQ] = ACTIONS(10931),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10931),
    [anon_sym_SLASH_EQ] = ACTIONS(10931),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10931),
    [anon_sym_PIPE_EQ] = ACTIONS(10931),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10931),
    [anon_sym_AMP_EQ] = ACTIONS(10931),
    [anon_sym_PERCENT_EQ] = ACTIONS(10931),
    [anon_sym_GT_GT_EQ] = ACTIONS(10931),
    [anon_sym_LT_LT_EQ] = ACTIONS(10931),
    [anon_sym_CARET_EQ] = ACTIONS(10931),
    [anon_sym_QMARK] = ACTIONS(10931),
    [anon_sym_COLON2] = ACTIONS(10933),
    [anon_sym_DOT_DOT] = ACTIONS(10933),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10931),
    [anon_sym_and] = ACTIONS(10931),
    [anon_sym_or] = ACTIONS(10931),
    [anon_sym_PIPE_PIPE] = ACTIONS(10933),
    [anon_sym_AMP_AMP] = ACTIONS(10933),
    [anon_sym_LT_LT] = ACTIONS(10933),
    [anon_sym_GT_GT] = ACTIONS(10933),
    [anon_sym_EQ_EQ] = ACTIONS(10933),
    [anon_sym_BANG_EQ] = ACTIONS(10931),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10931),
    [anon_sym_LT_EQ_GT] = ACTIONS(10931),
    [anon_sym_EQ_TILDE] = ACTIONS(10931),
    [anon_sym_BANG_TILDE] = ACTIONS(10931),
    [anon_sym_LT_EQ] = ACTIONS(10933),
    [anon_sym_GT] = ACTIONS(10933),
    [anon_sym_GT_EQ] = ACTIONS(10931),
    [anon_sym_CARET] = ACTIONS(10933),
    [anon_sym_PLUS] = ACTIONS(10933),
    [anon_sym_SLASH] = ACTIONS(10933),
    [anon_sym_PERCENT] = ACTIONS(10933),
    [sym_comment] = ACTIONS(87),
  },
  [10855] = {
    [sym__heredoc_body_start] = ACTIONS(11157),
    [sym__binary_minus] = ACTIONS(11157),
    [sym__binary_star] = ACTIONS(11157),
    [anon_sym_LBRACE] = ACTIONS(11157),
    [anon_sym_RBRACE] = ACTIONS(11157),
    [anon_sym_RPAREN] = ACTIONS(11157),
    [anon_sym_DOT] = ACTIONS(11159),
    [anon_sym_COMMA] = ACTIONS(11157),
    [anon_sym_PIPE] = ACTIONS(11159),
    [anon_sym_SEMI] = ACTIONS(11157),
    [anon_sym_STAR_STAR] = ACTIONS(11159),
    [anon_sym_AMP] = ACTIONS(11159),
    [anon_sym_EQ] = ACTIONS(11159),
    [anon_sym_LT] = ACTIONS(11159),
    [anon_sym_if] = ACTIONS(11157),
    [anon_sym_unless] = ACTIONS(11157),
    [anon_sym_while] = ACTIONS(11157),
    [anon_sym_until] = ACTIONS(11157),
    [anon_sym_rescue] = ACTIONS(11157),
    [anon_sym_in] = ACTIONS(11157),
    [anon_sym_do] = ACTIONS(11157),
    [anon_sym_LBRACK] = ACTIONS(11157),
    [anon_sym_RBRACK] = ACTIONS(11157),
    [anon_sym_COLON_COLON2] = ACTIONS(11157),
    [anon_sym_AMP_DOT] = ACTIONS(11157),
    [anon_sym_PLUS_EQ] = ACTIONS(11157),
    [anon_sym_DASH_EQ] = ACTIONS(11157),
    [anon_sym_STAR_EQ] = ACTIONS(11157),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11157),
    [anon_sym_SLASH_EQ] = ACTIONS(11157),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11157),
    [anon_sym_PIPE_EQ] = ACTIONS(11157),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11157),
    [anon_sym_AMP_EQ] = ACTIONS(11157),
    [anon_sym_PERCENT_EQ] = ACTIONS(11157),
    [anon_sym_GT_GT_EQ] = ACTIONS(11157),
    [anon_sym_LT_LT_EQ] = ACTIONS(11157),
    [anon_sym_CARET_EQ] = ACTIONS(11157),
    [anon_sym_QMARK] = ACTIONS(11157),
    [anon_sym_COLON2] = ACTIONS(11159),
    [anon_sym_DOT_DOT] = ACTIONS(11159),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11157),
    [anon_sym_and] = ACTIONS(11157),
    [anon_sym_or] = ACTIONS(11157),
    [anon_sym_PIPE_PIPE] = ACTIONS(11159),
    [anon_sym_AMP_AMP] = ACTIONS(11159),
    [anon_sym_LT_LT] = ACTIONS(11159),
    [anon_sym_GT_GT] = ACTIONS(11159),
    [anon_sym_EQ_EQ] = ACTIONS(11159),
    [anon_sym_BANG_EQ] = ACTIONS(11157),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11157),
    [anon_sym_LT_EQ_GT] = ACTIONS(11157),
    [anon_sym_EQ_TILDE] = ACTIONS(11157),
    [anon_sym_BANG_TILDE] = ACTIONS(11157),
    [anon_sym_LT_EQ] = ACTIONS(11159),
    [anon_sym_GT] = ACTIONS(11159),
    [anon_sym_GT_EQ] = ACTIONS(11157),
    [anon_sym_CARET] = ACTIONS(11159),
    [anon_sym_PLUS] = ACTIONS(11159),
    [anon_sym_SLASH] = ACTIONS(11159),
    [anon_sym_PERCENT] = ACTIONS(11159),
    [sym_comment] = ACTIONS(87),
  },
  [10856] = {
    [sym__heredoc_body_start] = ACTIONS(11322),
    [sym__binary_minus] = ACTIONS(11322),
    [sym__binary_star] = ACTIONS(11322),
    [anon_sym_LBRACE] = ACTIONS(11322),
    [anon_sym_RBRACE] = ACTIONS(11322),
    [anon_sym_RPAREN] = ACTIONS(11322),
    [anon_sym_DOT] = ACTIONS(11324),
    [anon_sym_COMMA] = ACTIONS(11322),
    [anon_sym_PIPE] = ACTIONS(11324),
    [anon_sym_SEMI] = ACTIONS(11322),
    [anon_sym_STAR_STAR] = ACTIONS(11324),
    [anon_sym_AMP] = ACTIONS(11324),
    [anon_sym_EQ] = ACTIONS(11324),
    [anon_sym_LT] = ACTIONS(11324),
    [anon_sym_if] = ACTIONS(11322),
    [anon_sym_unless] = ACTIONS(11322),
    [anon_sym_while] = ACTIONS(11322),
    [anon_sym_until] = ACTIONS(11322),
    [anon_sym_rescue] = ACTIONS(11322),
    [anon_sym_in] = ACTIONS(11322),
    [anon_sym_do] = ACTIONS(11322),
    [anon_sym_LBRACK] = ACTIONS(11322),
    [anon_sym_RBRACK] = ACTIONS(11322),
    [anon_sym_COLON_COLON2] = ACTIONS(11322),
    [anon_sym_AMP_DOT] = ACTIONS(11322),
    [anon_sym_PLUS_EQ] = ACTIONS(11322),
    [anon_sym_DASH_EQ] = ACTIONS(11322),
    [anon_sym_STAR_EQ] = ACTIONS(11322),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11322),
    [anon_sym_SLASH_EQ] = ACTIONS(11322),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11322),
    [anon_sym_PIPE_EQ] = ACTIONS(11322),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11322),
    [anon_sym_AMP_EQ] = ACTIONS(11322),
    [anon_sym_PERCENT_EQ] = ACTIONS(11322),
    [anon_sym_GT_GT_EQ] = ACTIONS(11322),
    [anon_sym_LT_LT_EQ] = ACTIONS(11322),
    [anon_sym_CARET_EQ] = ACTIONS(11322),
    [anon_sym_QMARK] = ACTIONS(11322),
    [anon_sym_COLON2] = ACTIONS(11324),
    [anon_sym_DOT_DOT] = ACTIONS(11324),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11322),
    [anon_sym_and] = ACTIONS(11322),
    [anon_sym_or] = ACTIONS(11322),
    [anon_sym_PIPE_PIPE] = ACTIONS(11324),
    [anon_sym_AMP_AMP] = ACTIONS(11324),
    [anon_sym_LT_LT] = ACTIONS(11324),
    [anon_sym_GT_GT] = ACTIONS(11324),
    [anon_sym_EQ_EQ] = ACTIONS(11324),
    [anon_sym_BANG_EQ] = ACTIONS(11322),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11322),
    [anon_sym_LT_EQ_GT] = ACTIONS(11322),
    [anon_sym_EQ_TILDE] = ACTIONS(11322),
    [anon_sym_BANG_TILDE] = ACTIONS(11322),
    [anon_sym_LT_EQ] = ACTIONS(11324),
    [anon_sym_GT] = ACTIONS(11324),
    [anon_sym_GT_EQ] = ACTIONS(11322),
    [anon_sym_CARET] = ACTIONS(11324),
    [anon_sym_PLUS] = ACTIONS(11324),
    [anon_sym_SLASH] = ACTIONS(11324),
    [anon_sym_PERCENT] = ACTIONS(11324),
    [sym_comment] = ACTIONS(87),
  },
  [10857] = {
    [sym__heredoc_body_start] = ACTIONS(11335),
    [sym__binary_minus] = ACTIONS(11335),
    [sym__binary_star] = ACTIONS(11335),
    [anon_sym_LBRACE] = ACTIONS(11335),
    [anon_sym_RBRACE] = ACTIONS(11335),
    [anon_sym_RPAREN] = ACTIONS(11335),
    [anon_sym_DOT] = ACTIONS(11337),
    [anon_sym_COMMA] = ACTIONS(11335),
    [anon_sym_PIPE] = ACTIONS(11337),
    [anon_sym_SEMI] = ACTIONS(11335),
    [anon_sym_STAR_STAR] = ACTIONS(11337),
    [anon_sym_AMP] = ACTIONS(11337),
    [anon_sym_EQ] = ACTIONS(11337),
    [anon_sym_LT] = ACTIONS(11337),
    [anon_sym_if] = ACTIONS(11335),
    [anon_sym_unless] = ACTIONS(11335),
    [anon_sym_while] = ACTIONS(11335),
    [anon_sym_until] = ACTIONS(11335),
    [anon_sym_rescue] = ACTIONS(11335),
    [anon_sym_in] = ACTIONS(11335),
    [anon_sym_do] = ACTIONS(11335),
    [anon_sym_LBRACK] = ACTIONS(11335),
    [anon_sym_RBRACK] = ACTIONS(11335),
    [anon_sym_COLON_COLON2] = ACTIONS(11335),
    [anon_sym_AMP_DOT] = ACTIONS(11335),
    [anon_sym_PLUS_EQ] = ACTIONS(11335),
    [anon_sym_DASH_EQ] = ACTIONS(11335),
    [anon_sym_STAR_EQ] = ACTIONS(11335),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11335),
    [anon_sym_SLASH_EQ] = ACTIONS(11335),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11335),
    [anon_sym_PIPE_EQ] = ACTIONS(11335),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11335),
    [anon_sym_AMP_EQ] = ACTIONS(11335),
    [anon_sym_PERCENT_EQ] = ACTIONS(11335),
    [anon_sym_GT_GT_EQ] = ACTIONS(11335),
    [anon_sym_LT_LT_EQ] = ACTIONS(11335),
    [anon_sym_CARET_EQ] = ACTIONS(11335),
    [anon_sym_QMARK] = ACTIONS(11335),
    [anon_sym_COLON2] = ACTIONS(11337),
    [anon_sym_DOT_DOT] = ACTIONS(11337),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11335),
    [anon_sym_and] = ACTIONS(11335),
    [anon_sym_or] = ACTIONS(11335),
    [anon_sym_PIPE_PIPE] = ACTIONS(11337),
    [anon_sym_AMP_AMP] = ACTIONS(11337),
    [anon_sym_LT_LT] = ACTIONS(11337),
    [anon_sym_GT_GT] = ACTIONS(11337),
    [anon_sym_EQ_EQ] = ACTIONS(11337),
    [anon_sym_BANG_EQ] = ACTIONS(11335),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11335),
    [anon_sym_LT_EQ_GT] = ACTIONS(11335),
    [anon_sym_EQ_TILDE] = ACTIONS(11335),
    [anon_sym_BANG_TILDE] = ACTIONS(11335),
    [anon_sym_LT_EQ] = ACTIONS(11337),
    [anon_sym_GT] = ACTIONS(11337),
    [anon_sym_GT_EQ] = ACTIONS(11335),
    [anon_sym_CARET] = ACTIONS(11337),
    [anon_sym_PLUS] = ACTIONS(11337),
    [anon_sym_SLASH] = ACTIONS(11337),
    [anon_sym_PERCENT] = ACTIONS(11337),
    [sym_comment] = ACTIONS(87),
  },
  [10858] = {
    [sym__heredoc_body_start] = ACTIONS(11344),
    [sym__binary_minus] = ACTIONS(11344),
    [sym__binary_star] = ACTIONS(11344),
    [anon_sym_LBRACE] = ACTIONS(11344),
    [anon_sym_RBRACE] = ACTIONS(11344),
    [anon_sym_RPAREN] = ACTIONS(11344),
    [anon_sym_DOT] = ACTIONS(11346),
    [anon_sym_COMMA] = ACTIONS(11344),
    [anon_sym_PIPE] = ACTIONS(11346),
    [anon_sym_SEMI] = ACTIONS(11344),
    [anon_sym_STAR_STAR] = ACTIONS(11346),
    [anon_sym_AMP] = ACTIONS(11346),
    [anon_sym_EQ] = ACTIONS(11346),
    [anon_sym_LT] = ACTIONS(11346),
    [anon_sym_if] = ACTIONS(11344),
    [anon_sym_unless] = ACTIONS(11344),
    [anon_sym_while] = ACTIONS(11344),
    [anon_sym_until] = ACTIONS(11344),
    [anon_sym_rescue] = ACTIONS(11344),
    [anon_sym_in] = ACTIONS(11344),
    [anon_sym_do] = ACTIONS(11344),
    [anon_sym_LBRACK] = ACTIONS(11344),
    [anon_sym_RBRACK] = ACTIONS(11344),
    [anon_sym_COLON_COLON2] = ACTIONS(11344),
    [anon_sym_AMP_DOT] = ACTIONS(11344),
    [anon_sym_PLUS_EQ] = ACTIONS(11344),
    [anon_sym_DASH_EQ] = ACTIONS(11344),
    [anon_sym_STAR_EQ] = ACTIONS(11344),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11344),
    [anon_sym_SLASH_EQ] = ACTIONS(11344),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11344),
    [anon_sym_PIPE_EQ] = ACTIONS(11344),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11344),
    [anon_sym_AMP_EQ] = ACTIONS(11344),
    [anon_sym_PERCENT_EQ] = ACTIONS(11344),
    [anon_sym_GT_GT_EQ] = ACTIONS(11344),
    [anon_sym_LT_LT_EQ] = ACTIONS(11344),
    [anon_sym_CARET_EQ] = ACTIONS(11344),
    [anon_sym_QMARK] = ACTIONS(11344),
    [anon_sym_COLON2] = ACTIONS(11346),
    [anon_sym_DOT_DOT] = ACTIONS(11346),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11344),
    [anon_sym_and] = ACTIONS(11344),
    [anon_sym_or] = ACTIONS(11344),
    [anon_sym_PIPE_PIPE] = ACTIONS(11346),
    [anon_sym_AMP_AMP] = ACTIONS(11346),
    [anon_sym_LT_LT] = ACTIONS(11346),
    [anon_sym_GT_GT] = ACTIONS(11346),
    [anon_sym_EQ_EQ] = ACTIONS(11346),
    [anon_sym_BANG_EQ] = ACTIONS(11344),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11344),
    [anon_sym_LT_EQ_GT] = ACTIONS(11344),
    [anon_sym_EQ_TILDE] = ACTIONS(11344),
    [anon_sym_BANG_TILDE] = ACTIONS(11344),
    [anon_sym_LT_EQ] = ACTIONS(11346),
    [anon_sym_GT] = ACTIONS(11346),
    [anon_sym_GT_EQ] = ACTIONS(11344),
    [anon_sym_CARET] = ACTIONS(11346),
    [anon_sym_PLUS] = ACTIONS(11346),
    [anon_sym_SLASH] = ACTIONS(11346),
    [anon_sym_PERCENT] = ACTIONS(11346),
    [sym_comment] = ACTIONS(87),
  },
  [10859] = {
    [sym__heredoc_body_start] = ACTIONS(11391),
    [sym__binary_minus] = ACTIONS(11391),
    [sym__binary_star] = ACTIONS(11391),
    [anon_sym_LBRACE] = ACTIONS(11391),
    [anon_sym_RBRACE] = ACTIONS(11391),
    [anon_sym_RPAREN] = ACTIONS(11391),
    [anon_sym_DOT] = ACTIONS(11393),
    [anon_sym_COMMA] = ACTIONS(11391),
    [anon_sym_PIPE] = ACTIONS(11393),
    [anon_sym_SEMI] = ACTIONS(11391),
    [anon_sym_STAR_STAR] = ACTIONS(11393),
    [anon_sym_AMP] = ACTIONS(11393),
    [anon_sym_EQ] = ACTIONS(11393),
    [anon_sym_LT] = ACTIONS(11393),
    [anon_sym_if] = ACTIONS(11391),
    [anon_sym_unless] = ACTIONS(11391),
    [anon_sym_while] = ACTIONS(11391),
    [anon_sym_until] = ACTIONS(11391),
    [anon_sym_rescue] = ACTIONS(11391),
    [anon_sym_in] = ACTIONS(11391),
    [anon_sym_do] = ACTIONS(11391),
    [anon_sym_LBRACK] = ACTIONS(11391),
    [anon_sym_RBRACK] = ACTIONS(11391),
    [anon_sym_COLON_COLON2] = ACTIONS(11391),
    [anon_sym_AMP_DOT] = ACTIONS(11391),
    [anon_sym_PLUS_EQ] = ACTIONS(11391),
    [anon_sym_DASH_EQ] = ACTIONS(11391),
    [anon_sym_STAR_EQ] = ACTIONS(11391),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11391),
    [anon_sym_SLASH_EQ] = ACTIONS(11391),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11391),
    [anon_sym_PIPE_EQ] = ACTIONS(11391),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11391),
    [anon_sym_AMP_EQ] = ACTIONS(11391),
    [anon_sym_PERCENT_EQ] = ACTIONS(11391),
    [anon_sym_GT_GT_EQ] = ACTIONS(11391),
    [anon_sym_LT_LT_EQ] = ACTIONS(11391),
    [anon_sym_CARET_EQ] = ACTIONS(11391),
    [anon_sym_QMARK] = ACTIONS(11391),
    [anon_sym_COLON2] = ACTIONS(11393),
    [anon_sym_DOT_DOT] = ACTIONS(11393),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11391),
    [anon_sym_and] = ACTIONS(11391),
    [anon_sym_or] = ACTIONS(11391),
    [anon_sym_PIPE_PIPE] = ACTIONS(11393),
    [anon_sym_AMP_AMP] = ACTIONS(11393),
    [anon_sym_LT_LT] = ACTIONS(11393),
    [anon_sym_GT_GT] = ACTIONS(11393),
    [anon_sym_EQ_EQ] = ACTIONS(11393),
    [anon_sym_BANG_EQ] = ACTIONS(11391),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11391),
    [anon_sym_LT_EQ_GT] = ACTIONS(11391),
    [anon_sym_EQ_TILDE] = ACTIONS(11391),
    [anon_sym_BANG_TILDE] = ACTIONS(11391),
    [anon_sym_LT_EQ] = ACTIONS(11393),
    [anon_sym_GT] = ACTIONS(11393),
    [anon_sym_GT_EQ] = ACTIONS(11391),
    [anon_sym_CARET] = ACTIONS(11393),
    [anon_sym_PLUS] = ACTIONS(11393),
    [anon_sym_SLASH] = ACTIONS(11393),
    [anon_sym_PERCENT] = ACTIONS(11393),
    [sym_comment] = ACTIONS(87),
  },
  [10860] = {
    [anon_sym_end] = ACTIONS(15131),
    [sym_comment] = ACTIONS(87),
  },
  [10861] = {
    [sym__heredoc_body_start] = ACTIONS(11404),
    [sym__binary_minus] = ACTIONS(11404),
    [sym__binary_star] = ACTIONS(11404),
    [anon_sym_LBRACE] = ACTIONS(11404),
    [anon_sym_RBRACE] = ACTIONS(11404),
    [anon_sym_RPAREN] = ACTIONS(11404),
    [anon_sym_DOT] = ACTIONS(11406),
    [anon_sym_COMMA] = ACTIONS(11404),
    [anon_sym_PIPE] = ACTIONS(11406),
    [anon_sym_SEMI] = ACTIONS(11404),
    [anon_sym_STAR_STAR] = ACTIONS(11406),
    [anon_sym_AMP] = ACTIONS(11406),
    [anon_sym_EQ] = ACTIONS(11406),
    [anon_sym_LT] = ACTIONS(11406),
    [anon_sym_if] = ACTIONS(11404),
    [anon_sym_unless] = ACTIONS(11404),
    [anon_sym_while] = ACTIONS(11404),
    [anon_sym_until] = ACTIONS(11404),
    [anon_sym_rescue] = ACTIONS(11404),
    [anon_sym_in] = ACTIONS(11404),
    [anon_sym_do] = ACTIONS(11404),
    [anon_sym_LBRACK] = ACTIONS(11404),
    [anon_sym_RBRACK] = ACTIONS(11404),
    [anon_sym_COLON_COLON2] = ACTIONS(11404),
    [anon_sym_AMP_DOT] = ACTIONS(11404),
    [anon_sym_PLUS_EQ] = ACTIONS(11404),
    [anon_sym_DASH_EQ] = ACTIONS(11404),
    [anon_sym_STAR_EQ] = ACTIONS(11404),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11404),
    [anon_sym_SLASH_EQ] = ACTIONS(11404),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11404),
    [anon_sym_PIPE_EQ] = ACTIONS(11404),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11404),
    [anon_sym_AMP_EQ] = ACTIONS(11404),
    [anon_sym_PERCENT_EQ] = ACTIONS(11404),
    [anon_sym_GT_GT_EQ] = ACTIONS(11404),
    [anon_sym_LT_LT_EQ] = ACTIONS(11404),
    [anon_sym_CARET_EQ] = ACTIONS(11404),
    [anon_sym_QMARK] = ACTIONS(11404),
    [anon_sym_COLON2] = ACTIONS(11406),
    [anon_sym_DOT_DOT] = ACTIONS(11406),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11404),
    [anon_sym_and] = ACTIONS(11404),
    [anon_sym_or] = ACTIONS(11404),
    [anon_sym_PIPE_PIPE] = ACTIONS(11406),
    [anon_sym_AMP_AMP] = ACTIONS(11406),
    [anon_sym_LT_LT] = ACTIONS(11406),
    [anon_sym_GT_GT] = ACTIONS(11406),
    [anon_sym_EQ_EQ] = ACTIONS(11406),
    [anon_sym_BANG_EQ] = ACTIONS(11404),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11404),
    [anon_sym_LT_EQ_GT] = ACTIONS(11404),
    [anon_sym_EQ_TILDE] = ACTIONS(11404),
    [anon_sym_BANG_TILDE] = ACTIONS(11404),
    [anon_sym_LT_EQ] = ACTIONS(11406),
    [anon_sym_GT] = ACTIONS(11406),
    [anon_sym_GT_EQ] = ACTIONS(11404),
    [anon_sym_CARET] = ACTIONS(11406),
    [anon_sym_PLUS] = ACTIONS(11406),
    [anon_sym_SLASH] = ACTIONS(11406),
    [anon_sym_PERCENT] = ACTIONS(11406),
    [sym_comment] = ACTIONS(87),
  },
  [10862] = {
    [anon_sym_end] = ACTIONS(15133),
    [sym_comment] = ACTIONS(87),
  },
  [10863] = {
    [sym_when] = STATE(2988),
    [sym_else] = STATE(11181),
    [aux_sym_case_repeat2] = STATE(2988),
    [anon_sym_end] = ACTIONS(15133),
    [anon_sym_when] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [10864] = {
    [sym__heredoc_body_start] = ACTIONS(11846),
    [sym__binary_minus] = ACTIONS(11846),
    [sym__binary_star] = ACTIONS(11846),
    [anon_sym_LBRACE] = ACTIONS(11846),
    [anon_sym_RBRACE] = ACTIONS(11846),
    [anon_sym_RPAREN] = ACTIONS(11846),
    [anon_sym_DOT] = ACTIONS(11848),
    [anon_sym_COMMA] = ACTIONS(11846),
    [anon_sym_PIPE] = ACTIONS(11848),
    [anon_sym_SEMI] = ACTIONS(11846),
    [anon_sym_STAR_STAR] = ACTIONS(11848),
    [anon_sym_AMP] = ACTIONS(11848),
    [anon_sym_EQ] = ACTIONS(11848),
    [anon_sym_LT] = ACTIONS(11848),
    [anon_sym_if] = ACTIONS(11846),
    [anon_sym_unless] = ACTIONS(11846),
    [anon_sym_while] = ACTIONS(11846),
    [anon_sym_until] = ACTIONS(11846),
    [anon_sym_rescue] = ACTIONS(11846),
    [anon_sym_in] = ACTIONS(11846),
    [anon_sym_do] = ACTIONS(11846),
    [anon_sym_LBRACK] = ACTIONS(11846),
    [anon_sym_RBRACK] = ACTIONS(11846),
    [anon_sym_COLON_COLON2] = ACTIONS(11846),
    [anon_sym_AMP_DOT] = ACTIONS(11846),
    [anon_sym_PLUS_EQ] = ACTIONS(11846),
    [anon_sym_DASH_EQ] = ACTIONS(11846),
    [anon_sym_STAR_EQ] = ACTIONS(11846),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11846),
    [anon_sym_SLASH_EQ] = ACTIONS(11846),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11846),
    [anon_sym_PIPE_EQ] = ACTIONS(11846),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11846),
    [anon_sym_AMP_EQ] = ACTIONS(11846),
    [anon_sym_PERCENT_EQ] = ACTIONS(11846),
    [anon_sym_GT_GT_EQ] = ACTIONS(11846),
    [anon_sym_LT_LT_EQ] = ACTIONS(11846),
    [anon_sym_CARET_EQ] = ACTIONS(11846),
    [anon_sym_QMARK] = ACTIONS(11846),
    [anon_sym_COLON2] = ACTIONS(11848),
    [anon_sym_DOT_DOT] = ACTIONS(11848),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11846),
    [anon_sym_and] = ACTIONS(11846),
    [anon_sym_or] = ACTIONS(11846),
    [anon_sym_PIPE_PIPE] = ACTIONS(11848),
    [anon_sym_AMP_AMP] = ACTIONS(11848),
    [anon_sym_LT_LT] = ACTIONS(11848),
    [anon_sym_GT_GT] = ACTIONS(11848),
    [anon_sym_EQ_EQ] = ACTIONS(11848),
    [anon_sym_BANG_EQ] = ACTIONS(11846),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11846),
    [anon_sym_LT_EQ_GT] = ACTIONS(11846),
    [anon_sym_EQ_TILDE] = ACTIONS(11846),
    [anon_sym_BANG_TILDE] = ACTIONS(11846),
    [anon_sym_LT_EQ] = ACTIONS(11848),
    [anon_sym_GT] = ACTIONS(11848),
    [anon_sym_GT_EQ] = ACTIONS(11846),
    [anon_sym_CARET] = ACTIONS(11848),
    [anon_sym_PLUS] = ACTIONS(11848),
    [anon_sym_SLASH] = ACTIONS(11848),
    [anon_sym_PERCENT] = ACTIONS(11848),
    [sym_comment] = ACTIONS(87),
  },
  [10865] = {
    [anon_sym_end] = ACTIONS(15135),
    [sym_comment] = ACTIONS(87),
  },
  [10866] = {
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(10117),
    [sym__binary_star] = ACTIONS(10119),
    [anon_sym_LBRACE] = ACTIONS(12120),
    [anon_sym_RBRACE] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(10121),
    [anon_sym_STAR_STAR] = ACTIONS(10123),
    [anon_sym_AMP] = ACTIONS(10125),
    [anon_sym_EQ] = ACTIONS(12879),
    [anon_sym_LT] = ACTIONS(10127),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_PLUS_EQ] = ACTIONS(12120),
    [anon_sym_DASH_EQ] = ACTIONS(12120),
    [anon_sym_STAR_EQ] = ACTIONS(12120),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12120),
    [anon_sym_SLASH_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12120),
    [anon_sym_AMP_EQ] = ACTIONS(12120),
    [anon_sym_PERCENT_EQ] = ACTIONS(12120),
    [anon_sym_GT_GT_EQ] = ACTIONS(12120),
    [anon_sym_LT_LT_EQ] = ACTIONS(12120),
    [anon_sym_CARET_EQ] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(10129),
    [anon_sym_DOT_DOT] = ACTIONS(10131),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10133),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(10135),
    [anon_sym_AMP_AMP] = ACTIONS(10135),
    [anon_sym_LT_LT] = ACTIONS(10137),
    [anon_sym_GT_GT] = ACTIONS(10137),
    [anon_sym_EQ_EQ] = ACTIONS(10135),
    [anon_sym_BANG_EQ] = ACTIONS(10139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10139),
    [anon_sym_LT_EQ_GT] = ACTIONS(10139),
    [anon_sym_EQ_TILDE] = ACTIONS(10139),
    [anon_sym_BANG_TILDE] = ACTIONS(10139),
    [anon_sym_LT_EQ] = ACTIONS(10127),
    [anon_sym_GT] = ACTIONS(10127),
    [anon_sym_GT_EQ] = ACTIONS(10141),
    [anon_sym_CARET] = ACTIONS(10121),
    [anon_sym_PLUS] = ACTIONS(10143),
    [anon_sym_SLASH] = ACTIONS(10123),
    [anon_sym_PERCENT] = ACTIONS(10123),
    [sym_comment] = ACTIONS(87),
  },
  [10867] = {
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_RBRACE] = ACTIONS(11597),
    [anon_sym_RPAREN] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(11597),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_in] = ACTIONS(11597),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_RBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_PLUS_EQ] = ACTIONS(11597),
    [anon_sym_DASH_EQ] = ACTIONS(11597),
    [anon_sym_STAR_EQ] = ACTIONS(11597),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11597),
    [anon_sym_SLASH_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11597),
    [anon_sym_AMP_EQ] = ACTIONS(11597),
    [anon_sym_PERCENT_EQ] = ACTIONS(11597),
    [anon_sym_GT_GT_EQ] = ACTIONS(11597),
    [anon_sym_LT_LT_EQ] = ACTIONS(11597),
    [anon_sym_CARET_EQ] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_COLON2] = ACTIONS(12338),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_LT] = ACTIONS(12338),
    [anon_sym_GT_GT] = ACTIONS(12338),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(12338),
    [anon_sym_PLUS] = ACTIONS(12338),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [10868] = {
    [aux_sym_exceptions_repeat1] = STATE(10868),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_RBRACE] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(15137),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_PLUS_EQ] = ACTIONS(11597),
    [anon_sym_DASH_EQ] = ACTIONS(11597),
    [anon_sym_STAR_EQ] = ACTIONS(11597),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11597),
    [anon_sym_SLASH_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11597),
    [anon_sym_AMP_EQ] = ACTIONS(11597),
    [anon_sym_PERCENT_EQ] = ACTIONS(11597),
    [anon_sym_GT_GT_EQ] = ACTIONS(11597),
    [anon_sym_LT_LT_EQ] = ACTIONS(11597),
    [anon_sym_CARET_EQ] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_LT] = ACTIONS(12338),
    [anon_sym_GT_GT] = ACTIONS(12338),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(12338),
    [anon_sym_PLUS] = ACTIONS(12338),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [10869] = {
    [sym__binary_minus] = ACTIONS(14580),
    [sym__binary_star] = ACTIONS(14580),
    [anon_sym_LBRACE] = ACTIONS(14580),
    [anon_sym_RBRACE] = ACTIONS(14580),
    [anon_sym_RPAREN] = ACTIONS(14580),
    [anon_sym_DOT] = ACTIONS(14582),
    [anon_sym_COMMA] = ACTIONS(14580),
    [anon_sym_PIPE] = ACTIONS(14582),
    [anon_sym_SEMI] = ACTIONS(14580),
    [anon_sym_STAR_STAR] = ACTIONS(14582),
    [anon_sym_AMP] = ACTIONS(14582),
    [anon_sym_EQ] = ACTIONS(14582),
    [anon_sym_LT] = ACTIONS(14582),
    [anon_sym_if] = ACTIONS(14580),
    [anon_sym_unless] = ACTIONS(14580),
    [anon_sym_while] = ACTIONS(14580),
    [anon_sym_until] = ACTIONS(14580),
    [anon_sym_rescue] = ACTIONS(14580),
    [anon_sym_do] = ACTIONS(14580),
    [anon_sym_LBRACK] = ACTIONS(14580),
    [anon_sym_COLON_COLON2] = ACTIONS(14580),
    [anon_sym_AMP_DOT] = ACTIONS(14580),
    [anon_sym_PLUS_EQ] = ACTIONS(14580),
    [anon_sym_DASH_EQ] = ACTIONS(14580),
    [anon_sym_STAR_EQ] = ACTIONS(14580),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14580),
    [anon_sym_SLASH_EQ] = ACTIONS(14580),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14580),
    [anon_sym_PIPE_EQ] = ACTIONS(14580),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14580),
    [anon_sym_AMP_EQ] = ACTIONS(14580),
    [anon_sym_PERCENT_EQ] = ACTIONS(14580),
    [anon_sym_GT_GT_EQ] = ACTIONS(14580),
    [anon_sym_LT_LT_EQ] = ACTIONS(14580),
    [anon_sym_CARET_EQ] = ACTIONS(14580),
    [anon_sym_QMARK] = ACTIONS(14580),
    [anon_sym_COLON2] = ACTIONS(14582),
    [anon_sym_DOT_DOT] = ACTIONS(14582),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14580),
    [anon_sym_and] = ACTIONS(14580),
    [anon_sym_or] = ACTIONS(14580),
    [anon_sym_PIPE_PIPE] = ACTIONS(14582),
    [anon_sym_AMP_AMP] = ACTIONS(14582),
    [anon_sym_LT_LT] = ACTIONS(14582),
    [anon_sym_GT_GT] = ACTIONS(14582),
    [anon_sym_EQ_EQ] = ACTIONS(14582),
    [anon_sym_BANG_EQ] = ACTIONS(14580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14580),
    [anon_sym_LT_EQ_GT] = ACTIONS(14580),
    [anon_sym_EQ_TILDE] = ACTIONS(14580),
    [anon_sym_BANG_TILDE] = ACTIONS(14580),
    [anon_sym_LT_EQ] = ACTIONS(14582),
    [anon_sym_GT] = ACTIONS(14582),
    [anon_sym_GT_EQ] = ACTIONS(14580),
    [anon_sym_CARET] = ACTIONS(14582),
    [anon_sym_PLUS] = ACTIONS(14582),
    [anon_sym_SLASH] = ACTIONS(14582),
    [anon_sym_PERCENT] = ACTIONS(14582),
    [sym_comment] = ACTIONS(87),
  },
  [10870] = {
    [sym__binary_minus] = ACTIONS(10169),
    [sym__binary_star] = ACTIONS(10171),
    [anon_sym_RBRACE] = ACTIONS(12120),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(10173),
    [anon_sym_STAR_STAR] = ACTIONS(10171),
    [anon_sym_AMP] = ACTIONS(10175),
    [anon_sym_LT] = ACTIONS(10177),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(10179),
    [anon_sym_DOT_DOT] = ACTIONS(10181),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10183),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(10185),
    [anon_sym_AMP_AMP] = ACTIONS(10185),
    [anon_sym_LT_LT] = ACTIONS(10187),
    [anon_sym_GT_GT] = ACTIONS(10187),
    [anon_sym_EQ_EQ] = ACTIONS(10189),
    [anon_sym_BANG_EQ] = ACTIONS(10185),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10185),
    [anon_sym_LT_EQ_GT] = ACTIONS(10185),
    [anon_sym_EQ_TILDE] = ACTIONS(10185),
    [anon_sym_BANG_TILDE] = ACTIONS(10185),
    [anon_sym_LT_EQ] = ACTIONS(10177),
    [anon_sym_GT] = ACTIONS(10177),
    [anon_sym_GT_EQ] = ACTIONS(10191),
    [anon_sym_CARET] = ACTIONS(10193),
    [anon_sym_PLUS] = ACTIONS(10169),
    [anon_sym_SLASH] = ACTIONS(10171),
    [anon_sym_PERCENT] = ACTIONS(10171),
    [sym_comment] = ACTIONS(87),
  },
  [10871] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(10223),
    [sym__binary_star] = ACTIONS(10225),
    [anon_sym_RBRACE] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(10227),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(10225),
    [anon_sym_AMP] = ACTIONS(10229),
    [anon_sym_LT] = ACTIONS(10231),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(10233),
    [anon_sym_DOT_DOT] = ACTIONS(10235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10237),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(10239),
    [anon_sym_AMP_AMP] = ACTIONS(10239),
    [anon_sym_LT_LT] = ACTIONS(10241),
    [anon_sym_GT_GT] = ACTIONS(10241),
    [anon_sym_EQ_EQ] = ACTIONS(10243),
    [anon_sym_BANG_EQ] = ACTIONS(10239),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10239),
    [anon_sym_LT_EQ_GT] = ACTIONS(10239),
    [anon_sym_EQ_TILDE] = ACTIONS(10239),
    [anon_sym_BANG_TILDE] = ACTIONS(10239),
    [anon_sym_LT_EQ] = ACTIONS(10231),
    [anon_sym_GT] = ACTIONS(10231),
    [anon_sym_GT_EQ] = ACTIONS(10245),
    [anon_sym_CARET] = ACTIONS(10247),
    [anon_sym_PLUS] = ACTIONS(10223),
    [anon_sym_SLASH] = ACTIONS(10225),
    [anon_sym_PERCENT] = ACTIONS(10225),
    [sym_comment] = ACTIONS(87),
  },
  [10872] = {
    [aux_sym_exceptions_repeat1] = STATE(10872),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_RBRACE] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(15140),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [10873] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(10259),
    [sym__binary_star] = ACTIONS(10261),
    [anon_sym_LBRACE] = ACTIONS(12120),
    [anon_sym_RBRACE] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(10263),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(10265),
    [anon_sym_AMP] = ACTIONS(10267),
    [anon_sym_EQ] = ACTIONS(12879),
    [anon_sym_LT] = ACTIONS(10269),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_PLUS_EQ] = ACTIONS(12120),
    [anon_sym_DASH_EQ] = ACTIONS(12120),
    [anon_sym_STAR_EQ] = ACTIONS(12120),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12120),
    [anon_sym_SLASH_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12120),
    [anon_sym_AMP_EQ] = ACTIONS(12120),
    [anon_sym_PERCENT_EQ] = ACTIONS(12120),
    [anon_sym_GT_GT_EQ] = ACTIONS(12120),
    [anon_sym_LT_LT_EQ] = ACTIONS(12120),
    [anon_sym_CARET_EQ] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(10271),
    [anon_sym_DOT_DOT] = ACTIONS(10273),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10275),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(10277),
    [anon_sym_AMP_AMP] = ACTIONS(10277),
    [anon_sym_LT_LT] = ACTIONS(10279),
    [anon_sym_GT_GT] = ACTIONS(10279),
    [anon_sym_EQ_EQ] = ACTIONS(10277),
    [anon_sym_BANG_EQ] = ACTIONS(10281),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10281),
    [anon_sym_LT_EQ_GT] = ACTIONS(10281),
    [anon_sym_EQ_TILDE] = ACTIONS(10281),
    [anon_sym_BANG_TILDE] = ACTIONS(10281),
    [anon_sym_LT_EQ] = ACTIONS(10269),
    [anon_sym_GT] = ACTIONS(10269),
    [anon_sym_GT_EQ] = ACTIONS(10283),
    [anon_sym_CARET] = ACTIONS(10263),
    [anon_sym_PLUS] = ACTIONS(10285),
    [anon_sym_SLASH] = ACTIONS(10265),
    [anon_sym_PERCENT] = ACTIONS(10265),
    [sym_comment] = ACTIONS(87),
  },
  [10874] = {
    [aux_sym_exceptions_repeat1] = STATE(10874),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_RBRACE] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(15143),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_PLUS_EQ] = ACTIONS(11597),
    [anon_sym_DASH_EQ] = ACTIONS(11597),
    [anon_sym_STAR_EQ] = ACTIONS(11597),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11597),
    [anon_sym_SLASH_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11597),
    [anon_sym_AMP_EQ] = ACTIONS(11597),
    [anon_sym_PERCENT_EQ] = ACTIONS(11597),
    [anon_sym_GT_GT_EQ] = ACTIONS(11597),
    [anon_sym_LT_LT_EQ] = ACTIONS(11597),
    [anon_sym_CARET_EQ] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_LT] = ACTIONS(12338),
    [anon_sym_GT_GT] = ACTIONS(12338),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(12338),
    [anon_sym_PLUS] = ACTIONS(12338),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [10875] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(10295),
    [sym__binary_star] = ACTIONS(10297),
    [anon_sym_RBRACE] = ACTIONS(12120),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(10299),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(10297),
    [anon_sym_AMP] = ACTIONS(10301),
    [anon_sym_LT] = ACTIONS(10303),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(10305),
    [anon_sym_DOT_DOT] = ACTIONS(10307),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10309),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(10311),
    [anon_sym_AMP_AMP] = ACTIONS(10311),
    [anon_sym_LT_LT] = ACTIONS(10313),
    [anon_sym_GT_GT] = ACTIONS(10313),
    [anon_sym_EQ_EQ] = ACTIONS(10315),
    [anon_sym_BANG_EQ] = ACTIONS(10311),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10311),
    [anon_sym_LT_EQ_GT] = ACTIONS(10311),
    [anon_sym_EQ_TILDE] = ACTIONS(10311),
    [anon_sym_BANG_TILDE] = ACTIONS(10311),
    [anon_sym_LT_EQ] = ACTIONS(10303),
    [anon_sym_GT] = ACTIONS(10303),
    [anon_sym_GT_EQ] = ACTIONS(10317),
    [anon_sym_CARET] = ACTIONS(10319),
    [anon_sym_PLUS] = ACTIONS(10295),
    [anon_sym_SLASH] = ACTIONS(10297),
    [anon_sym_PERCENT] = ACTIONS(10297),
    [sym_comment] = ACTIONS(87),
  },
  [10876] = {
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(10343),
    [sym__binary_star] = ACTIONS(10345),
    [anon_sym_RBRACE] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(10347),
    [anon_sym_STAR_STAR] = ACTIONS(10345),
    [anon_sym_AMP] = ACTIONS(10349),
    [anon_sym_LT] = ACTIONS(10351),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(10353),
    [anon_sym_DOT_DOT] = ACTIONS(10355),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10357),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(10359),
    [anon_sym_AMP_AMP] = ACTIONS(10359),
    [anon_sym_LT_LT] = ACTIONS(10361),
    [anon_sym_GT_GT] = ACTIONS(10361),
    [anon_sym_EQ_EQ] = ACTIONS(10363),
    [anon_sym_BANG_EQ] = ACTIONS(10359),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10359),
    [anon_sym_LT_EQ_GT] = ACTIONS(10359),
    [anon_sym_EQ_TILDE] = ACTIONS(10359),
    [anon_sym_BANG_TILDE] = ACTIONS(10359),
    [anon_sym_LT_EQ] = ACTIONS(10351),
    [anon_sym_GT] = ACTIONS(10351),
    [anon_sym_GT_EQ] = ACTIONS(10365),
    [anon_sym_CARET] = ACTIONS(10367),
    [anon_sym_PLUS] = ACTIONS(10343),
    [anon_sym_SLASH] = ACTIONS(10345),
    [anon_sym_PERCENT] = ACTIONS(10345),
    [sym_comment] = ACTIONS(87),
  },
  [10877] = {
    [aux_sym_exceptions_repeat1] = STATE(10877),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_RBRACE] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(15146),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [10878] = {
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(10401),
    [sym__binary_star] = ACTIONS(10403),
    [anon_sym_LBRACE] = ACTIONS(12120),
    [anon_sym_RBRACE] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(10405),
    [anon_sym_STAR_STAR] = ACTIONS(10407),
    [anon_sym_AMP] = ACTIONS(10409),
    [anon_sym_EQ] = ACTIONS(12879),
    [anon_sym_LT] = ACTIONS(10411),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_PLUS_EQ] = ACTIONS(12120),
    [anon_sym_DASH_EQ] = ACTIONS(12120),
    [anon_sym_STAR_EQ] = ACTIONS(12120),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12120),
    [anon_sym_SLASH_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12120),
    [anon_sym_AMP_EQ] = ACTIONS(12120),
    [anon_sym_PERCENT_EQ] = ACTIONS(12120),
    [anon_sym_GT_GT_EQ] = ACTIONS(12120),
    [anon_sym_LT_LT_EQ] = ACTIONS(12120),
    [anon_sym_CARET_EQ] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(10413),
    [anon_sym_DOT_DOT] = ACTIONS(10415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10417),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(10419),
    [anon_sym_AMP_AMP] = ACTIONS(10419),
    [anon_sym_LT_LT] = ACTIONS(10421),
    [anon_sym_GT_GT] = ACTIONS(10421),
    [anon_sym_EQ_EQ] = ACTIONS(10419),
    [anon_sym_BANG_EQ] = ACTIONS(10423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10423),
    [anon_sym_LT_EQ_GT] = ACTIONS(10423),
    [anon_sym_EQ_TILDE] = ACTIONS(10423),
    [anon_sym_BANG_TILDE] = ACTIONS(10423),
    [anon_sym_LT_EQ] = ACTIONS(10411),
    [anon_sym_GT] = ACTIONS(10411),
    [anon_sym_GT_EQ] = ACTIONS(10425),
    [anon_sym_CARET] = ACTIONS(10405),
    [anon_sym_PLUS] = ACTIONS(10427),
    [anon_sym_SLASH] = ACTIONS(10407),
    [anon_sym_PERCENT] = ACTIONS(10407),
    [sym_comment] = ACTIONS(87),
  },
  [10879] = {
    [aux_sym_exceptions_repeat1] = STATE(10879),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_RBRACE] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(15149),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_PLUS_EQ] = ACTIONS(11597),
    [anon_sym_DASH_EQ] = ACTIONS(11597),
    [anon_sym_STAR_EQ] = ACTIONS(11597),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11597),
    [anon_sym_SLASH_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11597),
    [anon_sym_AMP_EQ] = ACTIONS(11597),
    [anon_sym_PERCENT_EQ] = ACTIONS(11597),
    [anon_sym_GT_GT_EQ] = ACTIONS(11597),
    [anon_sym_LT_LT_EQ] = ACTIONS(11597),
    [anon_sym_CARET_EQ] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_LT] = ACTIONS(12338),
    [anon_sym_GT_GT] = ACTIONS(12338),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(12338),
    [anon_sym_PLUS] = ACTIONS(12338),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [10880] = {
    [sym__heredoc_body_start] = ACTIONS(14580),
    [sym__binary_minus] = ACTIONS(14580),
    [sym__binary_star] = ACTIONS(14580),
    [anon_sym_LBRACE] = ACTIONS(14580),
    [anon_sym_RBRACE] = ACTIONS(14580),
    [anon_sym_RPAREN] = ACTIONS(14580),
    [anon_sym_DOT] = ACTIONS(14582),
    [anon_sym_COMMA] = ACTIONS(14580),
    [anon_sym_PIPE] = ACTIONS(14582),
    [anon_sym_SEMI] = ACTIONS(14580),
    [anon_sym_STAR_STAR] = ACTIONS(14582),
    [anon_sym_AMP] = ACTIONS(14582),
    [anon_sym_EQ] = ACTIONS(14582),
    [anon_sym_LT] = ACTIONS(14582),
    [anon_sym_if] = ACTIONS(14580),
    [anon_sym_unless] = ACTIONS(14580),
    [anon_sym_while] = ACTIONS(14580),
    [anon_sym_until] = ACTIONS(14580),
    [anon_sym_rescue] = ACTIONS(14580),
    [anon_sym_in] = ACTIONS(14580),
    [anon_sym_do] = ACTIONS(14580),
    [anon_sym_LBRACK] = ACTIONS(14580),
    [anon_sym_RBRACK] = ACTIONS(14580),
    [anon_sym_COLON_COLON2] = ACTIONS(14580),
    [anon_sym_AMP_DOT] = ACTIONS(14580),
    [anon_sym_PLUS_EQ] = ACTIONS(14580),
    [anon_sym_DASH_EQ] = ACTIONS(14580),
    [anon_sym_STAR_EQ] = ACTIONS(14580),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14580),
    [anon_sym_SLASH_EQ] = ACTIONS(14580),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14580),
    [anon_sym_PIPE_EQ] = ACTIONS(14580),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14580),
    [anon_sym_AMP_EQ] = ACTIONS(14580),
    [anon_sym_PERCENT_EQ] = ACTIONS(14580),
    [anon_sym_GT_GT_EQ] = ACTIONS(14580),
    [anon_sym_LT_LT_EQ] = ACTIONS(14580),
    [anon_sym_CARET_EQ] = ACTIONS(14580),
    [anon_sym_QMARK] = ACTIONS(14580),
    [anon_sym_COLON2] = ACTIONS(14582),
    [anon_sym_DOT_DOT] = ACTIONS(14582),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14580),
    [anon_sym_and] = ACTIONS(14580),
    [anon_sym_or] = ACTIONS(14580),
    [anon_sym_PIPE_PIPE] = ACTIONS(14582),
    [anon_sym_AMP_AMP] = ACTIONS(14582),
    [anon_sym_LT_LT] = ACTIONS(14582),
    [anon_sym_GT_GT] = ACTIONS(14582),
    [anon_sym_EQ_EQ] = ACTIONS(14582),
    [anon_sym_BANG_EQ] = ACTIONS(14580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14580),
    [anon_sym_LT_EQ_GT] = ACTIONS(14580),
    [anon_sym_EQ_TILDE] = ACTIONS(14580),
    [anon_sym_BANG_TILDE] = ACTIONS(14580),
    [anon_sym_LT_EQ] = ACTIONS(14582),
    [anon_sym_GT] = ACTIONS(14582),
    [anon_sym_GT_EQ] = ACTIONS(14580),
    [anon_sym_CARET] = ACTIONS(14582),
    [anon_sym_PLUS] = ACTIONS(14582),
    [anon_sym_SLASH] = ACTIONS(14582),
    [anon_sym_PERCENT] = ACTIONS(14582),
    [sym_comment] = ACTIONS(87),
  },
  [10881] = {
    [sym__heredoc_body_start] = ACTIONS(14151),
    [sym__binary_minus] = ACTIONS(14151),
    [sym__binary_star] = ACTIONS(14151),
    [anon_sym_LBRACE] = ACTIONS(14151),
    [anon_sym_RBRACE] = ACTIONS(14151),
    [anon_sym_RPAREN] = ACTIONS(14151),
    [anon_sym_DOT] = ACTIONS(14153),
    [anon_sym_COMMA] = ACTIONS(14151),
    [anon_sym_PIPE] = ACTIONS(14153),
    [anon_sym_SEMI] = ACTIONS(14151),
    [anon_sym_STAR_STAR] = ACTIONS(14153),
    [anon_sym_AMP] = ACTIONS(14153),
    [anon_sym_EQ] = ACTIONS(14153),
    [anon_sym_LT] = ACTIONS(14153),
    [anon_sym_if] = ACTIONS(14151),
    [anon_sym_unless] = ACTIONS(14151),
    [anon_sym_while] = ACTIONS(14151),
    [anon_sym_until] = ACTIONS(14151),
    [anon_sym_rescue] = ACTIONS(14151),
    [anon_sym_in] = ACTIONS(14151),
    [anon_sym_do] = ACTIONS(14151),
    [anon_sym_EQ_GT] = ACTIONS(14151),
    [anon_sym_LBRACK] = ACTIONS(14151),
    [anon_sym_RBRACK] = ACTIONS(14151),
    [anon_sym_COLON_COLON2] = ACTIONS(14151),
    [anon_sym_AMP_DOT] = ACTIONS(14151),
    [anon_sym_PLUS_EQ] = ACTIONS(14151),
    [anon_sym_DASH_EQ] = ACTIONS(14151),
    [anon_sym_STAR_EQ] = ACTIONS(14151),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14151),
    [anon_sym_SLASH_EQ] = ACTIONS(14151),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14151),
    [anon_sym_PIPE_EQ] = ACTIONS(14151),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14151),
    [anon_sym_AMP_EQ] = ACTIONS(14151),
    [anon_sym_PERCENT_EQ] = ACTIONS(14151),
    [anon_sym_GT_GT_EQ] = ACTIONS(14151),
    [anon_sym_LT_LT_EQ] = ACTIONS(14151),
    [anon_sym_CARET_EQ] = ACTIONS(14151),
    [anon_sym_QMARK] = ACTIONS(14151),
    [anon_sym_COLON2] = ACTIONS(14153),
    [anon_sym_DOT_DOT] = ACTIONS(14153),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14151),
    [anon_sym_and] = ACTIONS(14151),
    [anon_sym_or] = ACTIONS(14151),
    [anon_sym_PIPE_PIPE] = ACTIONS(14153),
    [anon_sym_AMP_AMP] = ACTIONS(14153),
    [anon_sym_LT_LT] = ACTIONS(14153),
    [anon_sym_GT_GT] = ACTIONS(14153),
    [anon_sym_EQ_EQ] = ACTIONS(14153),
    [anon_sym_BANG_EQ] = ACTIONS(14151),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14151),
    [anon_sym_LT_EQ_GT] = ACTIONS(14151),
    [anon_sym_EQ_TILDE] = ACTIONS(14151),
    [anon_sym_BANG_TILDE] = ACTIONS(14151),
    [anon_sym_LT_EQ] = ACTIONS(14153),
    [anon_sym_GT] = ACTIONS(14153),
    [anon_sym_GT_EQ] = ACTIONS(14151),
    [anon_sym_CARET] = ACTIONS(14153),
    [anon_sym_PLUS] = ACTIONS(14153),
    [anon_sym_SLASH] = ACTIONS(14153),
    [anon_sym_PERCENT] = ACTIONS(14153),
    [sym_comment] = ACTIONS(87),
  },
  [10882] = {
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(10566),
    [sym__binary_star] = ACTIONS(10568),
    [anon_sym_RPAREN] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(10570),
    [anon_sym_STAR_STAR] = ACTIONS(10568),
    [anon_sym_AMP] = ACTIONS(10572),
    [anon_sym_LT] = ACTIONS(10574),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(10576),
    [anon_sym_DOT_DOT] = ACTIONS(10578),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10580),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(10582),
    [anon_sym_AMP_AMP] = ACTIONS(10582),
    [anon_sym_LT_LT] = ACTIONS(10584),
    [anon_sym_GT_GT] = ACTIONS(10584),
    [anon_sym_EQ_EQ] = ACTIONS(10586),
    [anon_sym_BANG_EQ] = ACTIONS(10582),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10582),
    [anon_sym_LT_EQ_GT] = ACTIONS(10582),
    [anon_sym_EQ_TILDE] = ACTIONS(10582),
    [anon_sym_BANG_TILDE] = ACTIONS(10582),
    [anon_sym_LT_EQ] = ACTIONS(10574),
    [anon_sym_GT] = ACTIONS(10574),
    [anon_sym_GT_EQ] = ACTIONS(10588),
    [anon_sym_CARET] = ACTIONS(10590),
    [anon_sym_PLUS] = ACTIONS(10566),
    [anon_sym_SLASH] = ACTIONS(10568),
    [anon_sym_PERCENT] = ACTIONS(10568),
    [sym_comment] = ACTIONS(87),
  },
  [10883] = {
    [aux_sym_exceptions_repeat1] = STATE(10883),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_RPAREN] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(15152),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [10884] = {
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(10602),
    [sym__binary_star] = ACTIONS(10604),
    [anon_sym_LBRACE] = ACTIONS(12120),
    [anon_sym_RPAREN] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(10606),
    [anon_sym_STAR_STAR] = ACTIONS(10608),
    [anon_sym_AMP] = ACTIONS(10610),
    [anon_sym_EQ] = ACTIONS(12879),
    [anon_sym_LT] = ACTIONS(10612),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_PLUS_EQ] = ACTIONS(12120),
    [anon_sym_DASH_EQ] = ACTIONS(12120),
    [anon_sym_STAR_EQ] = ACTIONS(12120),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12120),
    [anon_sym_SLASH_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12120),
    [anon_sym_AMP_EQ] = ACTIONS(12120),
    [anon_sym_PERCENT_EQ] = ACTIONS(12120),
    [anon_sym_GT_GT_EQ] = ACTIONS(12120),
    [anon_sym_LT_LT_EQ] = ACTIONS(12120),
    [anon_sym_CARET_EQ] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(10614),
    [anon_sym_DOT_DOT] = ACTIONS(10616),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10618),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(10620),
    [anon_sym_AMP_AMP] = ACTIONS(10620),
    [anon_sym_LT_LT] = ACTIONS(10622),
    [anon_sym_GT_GT] = ACTIONS(10622),
    [anon_sym_EQ_EQ] = ACTIONS(10620),
    [anon_sym_BANG_EQ] = ACTIONS(10624),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10624),
    [anon_sym_LT_EQ_GT] = ACTIONS(10624),
    [anon_sym_EQ_TILDE] = ACTIONS(10624),
    [anon_sym_BANG_TILDE] = ACTIONS(10624),
    [anon_sym_LT_EQ] = ACTIONS(10612),
    [anon_sym_GT] = ACTIONS(10612),
    [anon_sym_GT_EQ] = ACTIONS(10626),
    [anon_sym_CARET] = ACTIONS(10606),
    [anon_sym_PLUS] = ACTIONS(10628),
    [anon_sym_SLASH] = ACTIONS(10608),
    [anon_sym_PERCENT] = ACTIONS(10608),
    [sym_comment] = ACTIONS(87),
  },
  [10885] = {
    [aux_sym_exceptions_repeat1] = STATE(10885),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_RPAREN] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(15155),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_PLUS_EQ] = ACTIONS(11597),
    [anon_sym_DASH_EQ] = ACTIONS(11597),
    [anon_sym_STAR_EQ] = ACTIONS(11597),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11597),
    [anon_sym_SLASH_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11597),
    [anon_sym_AMP_EQ] = ACTIONS(11597),
    [anon_sym_PERCENT_EQ] = ACTIONS(11597),
    [anon_sym_GT_GT_EQ] = ACTIONS(11597),
    [anon_sym_LT_LT_EQ] = ACTIONS(11597),
    [anon_sym_CARET_EQ] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_LT] = ACTIONS(12338),
    [anon_sym_GT_GT] = ACTIONS(12338),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(12338),
    [anon_sym_PLUS] = ACTIONS(12338),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [10886] = {
    [sym__binary_minus] = ACTIONS(10638),
    [sym__binary_star] = ACTIONS(10640),
    [anon_sym_RPAREN] = ACTIONS(12120),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(10642),
    [anon_sym_STAR_STAR] = ACTIONS(10640),
    [anon_sym_AMP] = ACTIONS(10644),
    [anon_sym_LT] = ACTIONS(10646),
    [anon_sym_QMARK] = ACTIONS(10648),
    [anon_sym_DOT_DOT] = ACTIONS(10650),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10652),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(10654),
    [anon_sym_AMP_AMP] = ACTIONS(10654),
    [anon_sym_LT_LT] = ACTIONS(10656),
    [anon_sym_GT_GT] = ACTIONS(10656),
    [anon_sym_EQ_EQ] = ACTIONS(10658),
    [anon_sym_BANG_EQ] = ACTIONS(10654),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10654),
    [anon_sym_LT_EQ_GT] = ACTIONS(10654),
    [anon_sym_EQ_TILDE] = ACTIONS(10654),
    [anon_sym_BANG_TILDE] = ACTIONS(10654),
    [anon_sym_LT_EQ] = ACTIONS(10646),
    [anon_sym_GT] = ACTIONS(10646),
    [anon_sym_GT_EQ] = ACTIONS(10660),
    [anon_sym_CARET] = ACTIONS(10662),
    [anon_sym_PLUS] = ACTIONS(10638),
    [anon_sym_SLASH] = ACTIONS(10640),
    [anon_sym_PERCENT] = ACTIONS(10640),
    [sym_comment] = ACTIONS(87),
  },
  [10887] = {
    [sym__line_break] = ACTIONS(13712),
    [sym__heredoc_body_start] = ACTIONS(13712),
    [anon_sym_DOT] = ACTIONS(13712),
    [anon_sym_COMMA] = ACTIONS(13712),
    [anon_sym_SEMI] = ACTIONS(13712),
    [anon_sym_then] = ACTIONS(13712),
    [anon_sym_LBRACK] = ACTIONS(13712),
    [anon_sym_COLON_COLON2] = ACTIONS(13712),
    [anon_sym_AMP_DOT] = ACTIONS(13712),
    [sym_comment] = ACTIONS(87),
  },
  [10888] = {
    [anon_sym_end] = ACTIONS(15158),
    [sym_comment] = ACTIONS(87),
  },
  [10889] = {
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(10700),
    [sym__binary_star] = ACTIONS(10702),
    [anon_sym_LBRACE] = ACTIONS(12120),
    [anon_sym_RPAREN] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(10704),
    [anon_sym_STAR_STAR] = ACTIONS(10702),
    [anon_sym_AMP] = ACTIONS(10706),
    [anon_sym_EQ] = ACTIONS(12879),
    [anon_sym_LT] = ACTIONS(10708),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(10710),
    [anon_sym_DOT_DOT] = ACTIONS(10712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10714),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(10718),
    [anon_sym_AMP_AMP] = ACTIONS(10718),
    [anon_sym_LT_LT] = ACTIONS(10720),
    [anon_sym_GT_GT] = ACTIONS(10720),
    [anon_sym_EQ_EQ] = ACTIONS(10722),
    [anon_sym_BANG_EQ] = ACTIONS(10718),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10718),
    [anon_sym_LT_EQ_GT] = ACTIONS(10718),
    [anon_sym_EQ_TILDE] = ACTIONS(10718),
    [anon_sym_BANG_TILDE] = ACTIONS(10718),
    [anon_sym_LT_EQ] = ACTIONS(10708),
    [anon_sym_GT] = ACTIONS(10708),
    [anon_sym_GT_EQ] = ACTIONS(10724),
    [anon_sym_CARET] = ACTIONS(10726),
    [anon_sym_PLUS] = ACTIONS(10700),
    [anon_sym_SLASH] = ACTIONS(10702),
    [anon_sym_PERCENT] = ACTIONS(10702),
    [sym_comment] = ACTIONS(87),
  },
  [10890] = {
    [aux_sym_exceptions_repeat1] = STATE(10890),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_RPAREN] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(15160),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [10891] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(11184),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(7240),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(7240),
    [sym_assignment] = STATE(11184),
    [sym_operator_assignment] = STATE(11184),
    [sym_conditional] = STATE(11184),
    [sym_range] = STATE(11184),
    [sym_binary] = STATE(11184),
    [sym_unary] = STATE(11184),
    [sym_left_assignment_list] = STATE(7239),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7240),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(7240),
    [sym_false] = STATE(7240),
    [sym_nil] = STATE(7240),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(7241),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(10782),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(10784),
    [anon_sym_yield] = ACTIONS(10786),
    [anon_sym_break] = ACTIONS(10788),
    [anon_sym_next] = ACTIONS(10790),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(10792),
    [anon_sym_defined_QMARK] = ACTIONS(10794),
    [anon_sym_not] = ACTIONS(10796),
    [anon_sym_BANG] = ACTIONS(10798),
    [anon_sym_TILDE] = ACTIONS(10798),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [10892] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(10282),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(7240),
    [sym_scope_resolution] = STATE(2355),
    [sym_call] = STATE(2355),
    [sym_method_call] = STATE(7240),
    [sym_splat_argument] = STATE(10867),
    [sym_assignment] = STATE(10282),
    [sym_operator_assignment] = STATE(10282),
    [sym_conditional] = STATE(10282),
    [sym_range] = STATE(10282),
    [sym_binary] = STATE(10282),
    [sym_unary] = STATE(10282),
    [sym__arg_or_splat_arg] = STATE(10867),
    [sym_left_assignment_list] = STATE(7239),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7240),
    [sym__variable] = STATE(2355),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(7240),
    [sym_false] = STATE(7240),
    [sym_nil] = STATE(7240),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(7241),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__splat_star] = ACTIONS(7605),
    [sym__unary_minus] = ACTIONS(10782),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(10784),
    [anon_sym_yield] = ACTIONS(10786),
    [anon_sym_break] = ACTIONS(10788),
    [anon_sym_next] = ACTIONS(10790),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(10792),
    [anon_sym_defined_QMARK] = ACTIONS(10794),
    [anon_sym_not] = ACTIONS(10796),
    [anon_sym_BANG] = ACTIONS(10798),
    [anon_sym_TILDE] = ACTIONS(10798),
    [sym_constant] = ACTIONS(4061),
    [sym_identifier] = ACTIONS(4061),
    [sym_instance_variable] = ACTIONS(4063),
    [sym_class_variable] = ACTIONS(4063),
    [sym_global_variable] = ACTIONS(4063),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(4061),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4061),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [10893] = {
    [aux_sym_exceptions_repeat1] = STATE(11185),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_LBRACE] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(15163),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_STAR_STAR] = ACTIONS(9857),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_EQ] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_do] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_PLUS_EQ] = ACTIONS(9855),
    [anon_sym_DASH_EQ] = ACTIONS(9855),
    [anon_sym_STAR_EQ] = ACTIONS(9855),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9855),
    [anon_sym_SLASH_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9855),
    [anon_sym_AMP_EQ] = ACTIONS(9855),
    [anon_sym_PERCENT_EQ] = ACTIONS(9855),
    [anon_sym_GT_GT_EQ] = ACTIONS(9855),
    [anon_sym_LT_LT_EQ] = ACTIONS(9855),
    [anon_sym_CARET_EQ] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9857),
    [anon_sym_AMP_AMP] = ACTIONS(9857),
    [anon_sym_LT_LT] = ACTIONS(9857),
    [anon_sym_GT_GT] = ACTIONS(9857),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9857),
    [anon_sym_PLUS] = ACTIONS(9857),
    [anon_sym_SLASH] = ACTIONS(9857),
    [anon_sym_PERCENT] = ACTIONS(9857),
    [sym_comment] = ACTIONS(87),
  },
  [10894] = {
    [sym__heredoc_body_start] = ACTIONS(12555),
    [sym__binary_minus] = ACTIONS(12555),
    [sym__binary_star] = ACTIONS(12555),
    [anon_sym_LBRACE] = ACTIONS(12555),
    [anon_sym_RPAREN] = ACTIONS(12555),
    [anon_sym_DOT] = ACTIONS(12557),
    [anon_sym_COMMA] = ACTIONS(12555),
    [anon_sym_PIPE] = ACTIONS(12557),
    [anon_sym_STAR_STAR] = ACTIONS(12555),
    [anon_sym_AMP] = ACTIONS(12557),
    [anon_sym_EQ] = ACTIONS(12557),
    [anon_sym_LT] = ACTIONS(12557),
    [anon_sym_do] = ACTIONS(12555),
    [anon_sym_LBRACK] = ACTIONS(12555),
    [anon_sym_COLON_COLON2] = ACTIONS(12555),
    [anon_sym_AMP_DOT] = ACTIONS(12555),
    [anon_sym_QMARK] = ACTIONS(12555),
    [anon_sym_DOT_DOT] = ACTIONS(12557),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12555),
    [anon_sym_and] = ACTIONS(12555),
    [anon_sym_or] = ACTIONS(12555),
    [anon_sym_PIPE_PIPE] = ACTIONS(12555),
    [anon_sym_AMP_AMP] = ACTIONS(12555),
    [anon_sym_LT_LT] = ACTIONS(12555),
    [anon_sym_GT_GT] = ACTIONS(12555),
    [anon_sym_EQ_EQ] = ACTIONS(12557),
    [anon_sym_BANG_EQ] = ACTIONS(12555),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12555),
    [anon_sym_LT_EQ_GT] = ACTIONS(12555),
    [anon_sym_EQ_TILDE] = ACTIONS(12555),
    [anon_sym_BANG_TILDE] = ACTIONS(12555),
    [anon_sym_LT_EQ] = ACTIONS(12557),
    [anon_sym_GT] = ACTIONS(12557),
    [anon_sym_GT_EQ] = ACTIONS(12555),
    [anon_sym_CARET] = ACTIONS(12555),
    [anon_sym_PLUS] = ACTIONS(12555),
    [anon_sym_SLASH] = ACTIONS(12555),
    [anon_sym_PERCENT] = ACTIONS(12555),
    [sym_comment] = ACTIONS(87),
  },
  [10895] = {
    [sym__heredoc_body_start] = ACTIONS(12559),
    [sym__binary_minus] = ACTIONS(12559),
    [sym__binary_star] = ACTIONS(12559),
    [anon_sym_LBRACE] = ACTIONS(12559),
    [anon_sym_RPAREN] = ACTIONS(12559),
    [anon_sym_DOT] = ACTIONS(12561),
    [anon_sym_COMMA] = ACTIONS(12559),
    [anon_sym_PIPE] = ACTIONS(12561),
    [anon_sym_STAR_STAR] = ACTIONS(12559),
    [anon_sym_AMP] = ACTIONS(12561),
    [anon_sym_EQ] = ACTIONS(12561),
    [anon_sym_LT] = ACTIONS(12561),
    [anon_sym_do] = ACTIONS(12559),
    [anon_sym_LBRACK] = ACTIONS(12559),
    [anon_sym_COLON_COLON2] = ACTIONS(12559),
    [anon_sym_AMP_DOT] = ACTIONS(12559),
    [anon_sym_QMARK] = ACTIONS(12559),
    [anon_sym_DOT_DOT] = ACTIONS(12561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12559),
    [anon_sym_and] = ACTIONS(12559),
    [anon_sym_or] = ACTIONS(12559),
    [anon_sym_PIPE_PIPE] = ACTIONS(12559),
    [anon_sym_AMP_AMP] = ACTIONS(12559),
    [anon_sym_LT_LT] = ACTIONS(12559),
    [anon_sym_GT_GT] = ACTIONS(12559),
    [anon_sym_EQ_EQ] = ACTIONS(12561),
    [anon_sym_BANG_EQ] = ACTIONS(12559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12559),
    [anon_sym_LT_EQ_GT] = ACTIONS(12559),
    [anon_sym_EQ_TILDE] = ACTIONS(12559),
    [anon_sym_BANG_TILDE] = ACTIONS(12559),
    [anon_sym_LT_EQ] = ACTIONS(12561),
    [anon_sym_GT] = ACTIONS(12561),
    [anon_sym_GT_EQ] = ACTIONS(12559),
    [anon_sym_CARET] = ACTIONS(12559),
    [anon_sym_PLUS] = ACTIONS(12559),
    [anon_sym_SLASH] = ACTIONS(12559),
    [anon_sym_PERCENT] = ACTIONS(12559),
    [sym_comment] = ACTIONS(87),
  },
  [10896] = {
    [sym__heredoc_body_start] = ACTIONS(12663),
    [sym__binary_minus] = ACTIONS(12663),
    [sym__binary_star] = ACTIONS(12663),
    [anon_sym_LBRACE] = ACTIONS(12663),
    [anon_sym_RPAREN] = ACTIONS(12663),
    [anon_sym_DOT] = ACTIONS(12665),
    [anon_sym_COMMA] = ACTIONS(12663),
    [anon_sym_PIPE] = ACTIONS(12665),
    [anon_sym_STAR_STAR] = ACTIONS(12663),
    [anon_sym_AMP] = ACTIONS(12665),
    [anon_sym_EQ] = ACTIONS(12665),
    [anon_sym_LT] = ACTIONS(12665),
    [anon_sym_do] = ACTIONS(12663),
    [anon_sym_LBRACK] = ACTIONS(12663),
    [anon_sym_COLON_COLON2] = ACTIONS(12663),
    [anon_sym_AMP_DOT] = ACTIONS(12663),
    [anon_sym_QMARK] = ACTIONS(12663),
    [anon_sym_DOT_DOT] = ACTIONS(12665),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12663),
    [anon_sym_and] = ACTIONS(12663),
    [anon_sym_or] = ACTIONS(12663),
    [anon_sym_PIPE_PIPE] = ACTIONS(12663),
    [anon_sym_AMP_AMP] = ACTIONS(12663),
    [anon_sym_LT_LT] = ACTIONS(12663),
    [anon_sym_GT_GT] = ACTIONS(12663),
    [anon_sym_EQ_EQ] = ACTIONS(12665),
    [anon_sym_BANG_EQ] = ACTIONS(12663),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12663),
    [anon_sym_LT_EQ_GT] = ACTIONS(12663),
    [anon_sym_EQ_TILDE] = ACTIONS(12663),
    [anon_sym_BANG_TILDE] = ACTIONS(12663),
    [anon_sym_LT_EQ] = ACTIONS(12665),
    [anon_sym_GT] = ACTIONS(12665),
    [anon_sym_GT_EQ] = ACTIONS(12663),
    [anon_sym_CARET] = ACTIONS(12663),
    [anon_sym_PLUS] = ACTIONS(12663),
    [anon_sym_SLASH] = ACTIONS(12663),
    [anon_sym_PERCENT] = ACTIONS(12663),
    [sym_comment] = ACTIONS(87),
  },
  [10897] = {
    [sym__heredoc_body_start] = ACTIONS(13224),
    [sym__binary_minus] = ACTIONS(13224),
    [sym__binary_star] = ACTIONS(13224),
    [anon_sym_LBRACE] = ACTIONS(13224),
    [anon_sym_RPAREN] = ACTIONS(13224),
    [anon_sym_DOT] = ACTIONS(13226),
    [anon_sym_COMMA] = ACTIONS(13224),
    [anon_sym_PIPE] = ACTIONS(13226),
    [anon_sym_STAR_STAR] = ACTIONS(13224),
    [anon_sym_AMP] = ACTIONS(13226),
    [anon_sym_EQ] = ACTIONS(13226),
    [anon_sym_LT] = ACTIONS(13226),
    [anon_sym_do] = ACTIONS(13224),
    [anon_sym_LBRACK] = ACTIONS(13224),
    [anon_sym_COLON_COLON2] = ACTIONS(13224),
    [anon_sym_AMP_DOT] = ACTIONS(13224),
    [anon_sym_QMARK] = ACTIONS(13224),
    [anon_sym_DOT_DOT] = ACTIONS(13226),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13224),
    [anon_sym_and] = ACTIONS(13224),
    [anon_sym_or] = ACTIONS(13224),
    [anon_sym_PIPE_PIPE] = ACTIONS(13224),
    [anon_sym_AMP_AMP] = ACTIONS(13224),
    [anon_sym_LT_LT] = ACTIONS(13224),
    [anon_sym_GT_GT] = ACTIONS(13224),
    [anon_sym_EQ_EQ] = ACTIONS(13226),
    [anon_sym_BANG_EQ] = ACTIONS(13224),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13224),
    [anon_sym_LT_EQ_GT] = ACTIONS(13224),
    [anon_sym_EQ_TILDE] = ACTIONS(13224),
    [anon_sym_BANG_TILDE] = ACTIONS(13224),
    [anon_sym_LT_EQ] = ACTIONS(13226),
    [anon_sym_GT] = ACTIONS(13226),
    [anon_sym_GT_EQ] = ACTIONS(13224),
    [anon_sym_CARET] = ACTIONS(13224),
    [anon_sym_PLUS] = ACTIONS(13224),
    [anon_sym_SLASH] = ACTIONS(13224),
    [anon_sym_PERCENT] = ACTIONS(13224),
    [sym_comment] = ACTIONS(87),
  },
  [10898] = {
    [sym__heredoc_body_start] = ACTIONS(13235),
    [sym__binary_minus] = ACTIONS(13235),
    [sym__binary_star] = ACTIONS(13235),
    [anon_sym_LBRACE] = ACTIONS(13235),
    [anon_sym_RPAREN] = ACTIONS(13235),
    [anon_sym_DOT] = ACTIONS(13237),
    [anon_sym_COMMA] = ACTIONS(13235),
    [anon_sym_PIPE] = ACTIONS(13237),
    [anon_sym_STAR_STAR] = ACTIONS(13235),
    [anon_sym_AMP] = ACTIONS(13237),
    [anon_sym_EQ] = ACTIONS(13237),
    [anon_sym_LT] = ACTIONS(13237),
    [anon_sym_do] = ACTIONS(13235),
    [anon_sym_LBRACK] = ACTIONS(13235),
    [anon_sym_COLON_COLON2] = ACTIONS(13235),
    [anon_sym_AMP_DOT] = ACTIONS(13235),
    [anon_sym_QMARK] = ACTIONS(13235),
    [anon_sym_DOT_DOT] = ACTIONS(13237),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13235),
    [anon_sym_and] = ACTIONS(13235),
    [anon_sym_or] = ACTIONS(13235),
    [anon_sym_PIPE_PIPE] = ACTIONS(13235),
    [anon_sym_AMP_AMP] = ACTIONS(13235),
    [anon_sym_LT_LT] = ACTIONS(13235),
    [anon_sym_GT_GT] = ACTIONS(13235),
    [anon_sym_EQ_EQ] = ACTIONS(13237),
    [anon_sym_BANG_EQ] = ACTIONS(13235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13235),
    [anon_sym_LT_EQ_GT] = ACTIONS(13235),
    [anon_sym_EQ_TILDE] = ACTIONS(13235),
    [anon_sym_BANG_TILDE] = ACTIONS(13235),
    [anon_sym_LT_EQ] = ACTIONS(13237),
    [anon_sym_GT] = ACTIONS(13237),
    [anon_sym_GT_EQ] = ACTIONS(13235),
    [anon_sym_CARET] = ACTIONS(13235),
    [anon_sym_PLUS] = ACTIONS(13235),
    [anon_sym_SLASH] = ACTIONS(13235),
    [anon_sym_PERCENT] = ACTIONS(13235),
    [sym_comment] = ACTIONS(87),
  },
  [10899] = {
    [anon_sym_end] = ACTIONS(15165),
    [sym_comment] = ACTIONS(87),
  },
  [10900] = {
    [sym__heredoc_body_start] = ACTIONS(13547),
    [sym__binary_minus] = ACTIONS(13547),
    [sym__binary_star] = ACTIONS(13547),
    [anon_sym_LBRACE] = ACTIONS(13547),
    [anon_sym_RPAREN] = ACTIONS(13547),
    [anon_sym_DOT] = ACTIONS(13549),
    [anon_sym_COMMA] = ACTIONS(13547),
    [anon_sym_PIPE] = ACTIONS(13549),
    [anon_sym_STAR_STAR] = ACTIONS(13547),
    [anon_sym_AMP] = ACTIONS(13549),
    [anon_sym_EQ] = ACTIONS(13549),
    [anon_sym_LT] = ACTIONS(13549),
    [anon_sym_do] = ACTIONS(13547),
    [anon_sym_LBRACK] = ACTIONS(13547),
    [anon_sym_COLON_COLON2] = ACTIONS(13547),
    [anon_sym_AMP_DOT] = ACTIONS(13547),
    [anon_sym_QMARK] = ACTIONS(13547),
    [anon_sym_DOT_DOT] = ACTIONS(13549),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13547),
    [anon_sym_and] = ACTIONS(13547),
    [anon_sym_or] = ACTIONS(13547),
    [anon_sym_PIPE_PIPE] = ACTIONS(13547),
    [anon_sym_AMP_AMP] = ACTIONS(13547),
    [anon_sym_LT_LT] = ACTIONS(13547),
    [anon_sym_GT_GT] = ACTIONS(13547),
    [anon_sym_EQ_EQ] = ACTIONS(13549),
    [anon_sym_BANG_EQ] = ACTIONS(13547),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13547),
    [anon_sym_LT_EQ_GT] = ACTIONS(13547),
    [anon_sym_EQ_TILDE] = ACTIONS(13547),
    [anon_sym_BANG_TILDE] = ACTIONS(13547),
    [anon_sym_LT_EQ] = ACTIONS(13549),
    [anon_sym_GT] = ACTIONS(13549),
    [anon_sym_GT_EQ] = ACTIONS(13547),
    [anon_sym_CARET] = ACTIONS(13547),
    [anon_sym_PLUS] = ACTIONS(13547),
    [anon_sym_SLASH] = ACTIONS(13547),
    [anon_sym_PERCENT] = ACTIONS(13547),
    [sym_comment] = ACTIONS(87),
  },
  [10901] = {
    [sym__heredoc_body_start] = ACTIONS(13712),
    [sym__binary_minus] = ACTIONS(13712),
    [sym__binary_star] = ACTIONS(13712),
    [anon_sym_LBRACE] = ACTIONS(13712),
    [anon_sym_RPAREN] = ACTIONS(13712),
    [anon_sym_DOT] = ACTIONS(13714),
    [anon_sym_COMMA] = ACTIONS(13712),
    [anon_sym_PIPE] = ACTIONS(13714),
    [anon_sym_STAR_STAR] = ACTIONS(13712),
    [anon_sym_AMP] = ACTIONS(13714),
    [anon_sym_EQ] = ACTIONS(13714),
    [anon_sym_LT] = ACTIONS(13714),
    [anon_sym_do] = ACTIONS(13712),
    [anon_sym_LBRACK] = ACTIONS(13712),
    [anon_sym_COLON_COLON2] = ACTIONS(13712),
    [anon_sym_AMP_DOT] = ACTIONS(13712),
    [anon_sym_QMARK] = ACTIONS(13712),
    [anon_sym_DOT_DOT] = ACTIONS(13714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13712),
    [anon_sym_and] = ACTIONS(13712),
    [anon_sym_or] = ACTIONS(13712),
    [anon_sym_PIPE_PIPE] = ACTIONS(13712),
    [anon_sym_AMP_AMP] = ACTIONS(13712),
    [anon_sym_LT_LT] = ACTIONS(13712),
    [anon_sym_GT_GT] = ACTIONS(13712),
    [anon_sym_EQ_EQ] = ACTIONS(13714),
    [anon_sym_BANG_EQ] = ACTIONS(13712),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13712),
    [anon_sym_LT_EQ_GT] = ACTIONS(13712),
    [anon_sym_EQ_TILDE] = ACTIONS(13712),
    [anon_sym_BANG_TILDE] = ACTIONS(13712),
    [anon_sym_LT_EQ] = ACTIONS(13714),
    [anon_sym_GT] = ACTIONS(13714),
    [anon_sym_GT_EQ] = ACTIONS(13712),
    [anon_sym_CARET] = ACTIONS(13712),
    [anon_sym_PLUS] = ACTIONS(13712),
    [anon_sym_SLASH] = ACTIONS(13712),
    [anon_sym_PERCENT] = ACTIONS(13712),
    [sym_comment] = ACTIONS(87),
  },
  [10902] = {
    [anon_sym_end] = ACTIONS(15167),
    [sym_comment] = ACTIONS(87),
  },
  [10903] = {
    [sym_heredoc_body] = STATE(10903),
    [aux_sym_call_repeat1] = STATE(10903),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(7916),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_end] = ACTIONS(7914),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_elsif] = ACTIONS(7914),
    [anon_sym_else] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [10904] = {
    [sym_heredoc_body] = STATE(10903),
    [aux_sym_call_repeat1] = STATE(10903),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_end] = ACTIONS(7929),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_elsif] = ACTIONS(7929),
    [anon_sym_else] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [10905] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(11188),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7481),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(7481),
    [sym_assignment] = STATE(11188),
    [sym_operator_assignment] = STATE(11188),
    [sym_conditional] = STATE(11188),
    [sym_range] = STATE(11188),
    [sym_binary] = STATE(11188),
    [sym_unary] = STATE(11188),
    [sym_left_assignment_list] = STATE(7480),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7481),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7481),
    [sym_false] = STATE(7481),
    [sym_nil] = STATE(7481),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7482),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11001),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11003),
    [anon_sym_yield] = ACTIONS(11005),
    [anon_sym_break] = ACTIONS(11007),
    [anon_sym_next] = ACTIONS(11009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11011),
    [anon_sym_defined_QMARK] = ACTIONS(11013),
    [anon_sym_not] = ACTIONS(11015),
    [anon_sym_BANG] = ACTIONS(11017),
    [anon_sym_TILDE] = ACTIONS(11017),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10906] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10337),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7481),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(7481),
    [sym_splat_argument] = STATE(7439),
    [sym_assignment] = STATE(10337),
    [sym_operator_assignment] = STATE(10337),
    [sym_conditional] = STATE(10337),
    [sym_range] = STATE(10337),
    [sym_binary] = STATE(10337),
    [sym_unary] = STATE(10337),
    [sym__arg_or_splat_arg] = STATE(7439),
    [sym_left_assignment_list] = STATE(7480),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7481),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7481),
    [sym_false] = STATE(7481),
    [sym_nil] = STATE(7481),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7482),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(7992),
    [sym__unary_minus] = ACTIONS(11001),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11003),
    [anon_sym_yield] = ACTIONS(11005),
    [anon_sym_break] = ACTIONS(11007),
    [anon_sym_next] = ACTIONS(11009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11011),
    [anon_sym_defined_QMARK] = ACTIONS(11013),
    [anon_sym_not] = ACTIONS(11015),
    [anon_sym_BANG] = ACTIONS(11017),
    [anon_sym_TILDE] = ACTIONS(11017),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10907] = {
    [aux_sym_exceptions_repeat1] = STATE(11189),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(15169),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_end] = ACTIONS(9855),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_elsif] = ACTIONS(9855),
    [anon_sym_else] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [10908] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(11033),
    [sym__binary_star] = ACTIONS(11035),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(11037),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(11035),
    [anon_sym_AMP] = ACTIONS(11039),
    [anon_sym_LT] = ACTIONS(11041),
    [anon_sym_end] = ACTIONS(12120),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_elsif] = ACTIONS(12120),
    [anon_sym_else] = ACTIONS(12120),
    [anon_sym_EQ_GT] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(11043),
    [anon_sym_DOT_DOT] = ACTIONS(11045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11047),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(11049),
    [anon_sym_AMP_AMP] = ACTIONS(11049),
    [anon_sym_LT_LT] = ACTIONS(11051),
    [anon_sym_GT_GT] = ACTIONS(11051),
    [anon_sym_EQ_EQ] = ACTIONS(11053),
    [anon_sym_BANG_EQ] = ACTIONS(11049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11049),
    [anon_sym_LT_EQ_GT] = ACTIONS(11049),
    [anon_sym_EQ_TILDE] = ACTIONS(11049),
    [anon_sym_BANG_TILDE] = ACTIONS(11049),
    [anon_sym_LT_EQ] = ACTIONS(11041),
    [anon_sym_GT] = ACTIONS(11041),
    [anon_sym_GT_EQ] = ACTIONS(11055),
    [anon_sym_CARET] = ACTIONS(11057),
    [anon_sym_PLUS] = ACTIONS(11033),
    [anon_sym_SLASH] = ACTIONS(11035),
    [anon_sym_PERCENT] = ACTIONS(11035),
    [sym_comment] = ACTIONS(87),
  },
  [10909] = {
    [aux_sym_exceptions_repeat1] = STATE(10909),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(15171),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_end] = ACTIONS(11597),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_elsif] = ACTIONS(11597),
    [anon_sym_else] = ACTIONS(11597),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [10910] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(11190),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7550),
    [sym_scope_resolution] = STATE(7548),
    [sym_call] = STATE(7548),
    [sym_method_call] = STATE(7550),
    [sym_assignment] = STATE(11190),
    [sym_operator_assignment] = STATE(11190),
    [sym_conditional] = STATE(11190),
    [sym_range] = STATE(11190),
    [sym_binary] = STATE(11190),
    [sym_unary] = STATE(11190),
    [sym_left_assignment_list] = STATE(7549),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7550),
    [sym__variable] = STATE(7548),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7550),
    [sym_false] = STATE(7550),
    [sym_nil] = STATE(7550),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7551),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11077),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11079),
    [anon_sym_yield] = ACTIONS(11081),
    [anon_sym_break] = ACTIONS(11083),
    [anon_sym_next] = ACTIONS(11085),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11087),
    [anon_sym_defined_QMARK] = ACTIONS(11089),
    [anon_sym_not] = ACTIONS(11091),
    [anon_sym_BANG] = ACTIONS(11093),
    [anon_sym_TILDE] = ACTIONS(11093),
    [sym_constant] = ACTIONS(11095),
    [sym_identifier] = ACTIONS(11095),
    [sym_instance_variable] = ACTIONS(11097),
    [sym_class_variable] = ACTIONS(11097),
    [sym_global_variable] = ACTIONS(11097),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11095),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11095),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [10911] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10367),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7550),
    [sym_scope_resolution] = STATE(7548),
    [sym_call] = STATE(7548),
    [sym_method_call] = STATE(7550),
    [sym_splat_argument] = STATE(10067),
    [sym_assignment] = STATE(10367),
    [sym_operator_assignment] = STATE(10367),
    [sym_conditional] = STATE(10367),
    [sym_range] = STATE(10367),
    [sym_binary] = STATE(10367),
    [sym_unary] = STATE(10367),
    [sym__arg_or_splat_arg] = STATE(10067),
    [sym_left_assignment_list] = STATE(7549),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7550),
    [sym__variable] = STATE(7548),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7550),
    [sym_false] = STATE(7550),
    [sym_nil] = STATE(7550),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7551),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__splat_star] = ACTIONS(8064),
    [sym__unary_minus] = ACTIONS(11077),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11079),
    [anon_sym_yield] = ACTIONS(11081),
    [anon_sym_break] = ACTIONS(11083),
    [anon_sym_next] = ACTIONS(11085),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11087),
    [anon_sym_defined_QMARK] = ACTIONS(11089),
    [anon_sym_not] = ACTIONS(11091),
    [anon_sym_BANG] = ACTIONS(11093),
    [anon_sym_TILDE] = ACTIONS(11093),
    [sym_constant] = ACTIONS(11095),
    [sym_identifier] = ACTIONS(11095),
    [sym_instance_variable] = ACTIONS(11097),
    [sym_class_variable] = ACTIONS(11097),
    [sym_global_variable] = ACTIONS(11097),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11095),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11095),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [10912] = {
    [aux_sym_exceptions_repeat1] = STATE(11191),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_LBRACE] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(15174),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9857),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_EQ] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_end] = ACTIONS(9855),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_do] = ACTIONS(9855),
    [anon_sym_elsif] = ACTIONS(9855),
    [anon_sym_else] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_PLUS_EQ] = ACTIONS(9855),
    [anon_sym_DASH_EQ] = ACTIONS(9855),
    [anon_sym_STAR_EQ] = ACTIONS(9855),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9855),
    [anon_sym_SLASH_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9855),
    [anon_sym_AMP_EQ] = ACTIONS(9855),
    [anon_sym_PERCENT_EQ] = ACTIONS(9855),
    [anon_sym_GT_GT_EQ] = ACTIONS(9855),
    [anon_sym_LT_LT_EQ] = ACTIONS(9855),
    [anon_sym_CARET_EQ] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9857),
    [anon_sym_AMP_AMP] = ACTIONS(9857),
    [anon_sym_LT_LT] = ACTIONS(9857),
    [anon_sym_GT_GT] = ACTIONS(9857),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9857),
    [anon_sym_PLUS] = ACTIONS(9857),
    [anon_sym_SLASH] = ACTIONS(9857),
    [anon_sym_PERCENT] = ACTIONS(9857),
    [sym_comment] = ACTIONS(87),
  },
  [10913] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(11105),
    [sym__binary_star] = ACTIONS(11107),
    [anon_sym_LBRACE] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(11109),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(11111),
    [anon_sym_AMP] = ACTIONS(11113),
    [anon_sym_EQ] = ACTIONS(12879),
    [anon_sym_LT] = ACTIONS(11115),
    [anon_sym_end] = ACTIONS(12120),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_elsif] = ACTIONS(12120),
    [anon_sym_else] = ACTIONS(12120),
    [anon_sym_EQ_GT] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_PLUS_EQ] = ACTIONS(12120),
    [anon_sym_DASH_EQ] = ACTIONS(12120),
    [anon_sym_STAR_EQ] = ACTIONS(12120),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12120),
    [anon_sym_SLASH_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12120),
    [anon_sym_AMP_EQ] = ACTIONS(12120),
    [anon_sym_PERCENT_EQ] = ACTIONS(12120),
    [anon_sym_GT_GT_EQ] = ACTIONS(12120),
    [anon_sym_LT_LT_EQ] = ACTIONS(12120),
    [anon_sym_CARET_EQ] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(11117),
    [anon_sym_DOT_DOT] = ACTIONS(11119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11121),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(11123),
    [anon_sym_AMP_AMP] = ACTIONS(11123),
    [anon_sym_LT_LT] = ACTIONS(11125),
    [anon_sym_GT_GT] = ACTIONS(11125),
    [anon_sym_EQ_EQ] = ACTIONS(11123),
    [anon_sym_BANG_EQ] = ACTIONS(11127),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11127),
    [anon_sym_LT_EQ_GT] = ACTIONS(11127),
    [anon_sym_EQ_TILDE] = ACTIONS(11127),
    [anon_sym_BANG_TILDE] = ACTIONS(11127),
    [anon_sym_LT_EQ] = ACTIONS(11115),
    [anon_sym_GT] = ACTIONS(11115),
    [anon_sym_GT_EQ] = ACTIONS(11129),
    [anon_sym_CARET] = ACTIONS(11109),
    [anon_sym_PLUS] = ACTIONS(11131),
    [anon_sym_SLASH] = ACTIONS(11111),
    [anon_sym_PERCENT] = ACTIONS(11111),
    [sym_comment] = ACTIONS(87),
  },
  [10914] = {
    [aux_sym_exceptions_repeat1] = STATE(10914),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(15176),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_end] = ACTIONS(11597),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_elsif] = ACTIONS(11597),
    [anon_sym_else] = ACTIONS(11597),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_PLUS_EQ] = ACTIONS(11597),
    [anon_sym_DASH_EQ] = ACTIONS(11597),
    [anon_sym_STAR_EQ] = ACTIONS(11597),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11597),
    [anon_sym_SLASH_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11597),
    [anon_sym_AMP_EQ] = ACTIONS(11597),
    [anon_sym_PERCENT_EQ] = ACTIONS(11597),
    [anon_sym_GT_GT_EQ] = ACTIONS(11597),
    [anon_sym_LT_LT_EQ] = ACTIONS(11597),
    [anon_sym_CARET_EQ] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_LT] = ACTIONS(12338),
    [anon_sym_GT_GT] = ACTIONS(12338),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(12338),
    [anon_sym_PLUS] = ACTIONS(12338),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [10915] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(11192),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7582),
    [sym_scope_resolution] = STATE(2643),
    [sym_call] = STATE(2643),
    [sym_method_call] = STATE(7582),
    [sym_assignment] = STATE(11192),
    [sym_operator_assignment] = STATE(11192),
    [sym_conditional] = STATE(11192),
    [sym_range] = STATE(11192),
    [sym_binary] = STATE(11192),
    [sym_unary] = STATE(11192),
    [sym_left_assignment_list] = STATE(7581),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7582),
    [sym__variable] = STATE(2643),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7582),
    [sym_false] = STATE(7582),
    [sym_nil] = STATE(7582),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7482),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11145),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11003),
    [anon_sym_yield] = ACTIONS(11005),
    [anon_sym_break] = ACTIONS(11007),
    [anon_sym_next] = ACTIONS(11009),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11147),
    [anon_sym_defined_QMARK] = ACTIONS(11149),
    [anon_sym_not] = ACTIONS(11151),
    [anon_sym_BANG] = ACTIONS(11153),
    [anon_sym_TILDE] = ACTIONS(11153),
    [sym_constant] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(4487),
    [sym_instance_variable] = ACTIONS(4489),
    [sym_class_variable] = ACTIONS(4489),
    [sym_global_variable] = ACTIONS(4489),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4487),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10916] = {
    [sym_heredoc_body] = STATE(10916),
    [aux_sym_call_repeat1] = STATE(10916),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(7916),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_end] = ACTIONS(7914),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_else] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [10917] = {
    [sym_heredoc_body] = STATE(10916),
    [aux_sym_call_repeat1] = STATE(10916),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_end] = ACTIONS(7929),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_else] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [10918] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(11193),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7627),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(7627),
    [sym_assignment] = STATE(11193),
    [sym_operator_assignment] = STATE(11193),
    [sym_conditional] = STATE(11193),
    [sym_range] = STATE(11193),
    [sym_binary] = STATE(11193),
    [sym_unary] = STATE(11193),
    [sym_left_assignment_list] = STATE(7626),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7627),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7627),
    [sym_false] = STATE(7627),
    [sym_nil] = STATE(7627),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7628),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11168),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11170),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_break] = ACTIONS(11174),
    [anon_sym_next] = ACTIONS(11176),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11178),
    [anon_sym_defined_QMARK] = ACTIONS(11180),
    [anon_sym_not] = ACTIONS(11182),
    [anon_sym_BANG] = ACTIONS(11184),
    [anon_sym_TILDE] = ACTIONS(11184),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10919] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10402),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7627),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(7627),
    [sym_splat_argument] = STATE(7439),
    [sym_assignment] = STATE(10402),
    [sym_operator_assignment] = STATE(10402),
    [sym_conditional] = STATE(10402),
    [sym_range] = STATE(10402),
    [sym_binary] = STATE(10402),
    [sym_unary] = STATE(10402),
    [sym__arg_or_splat_arg] = STATE(7439),
    [sym_left_assignment_list] = STATE(7626),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7627),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7627),
    [sym_false] = STATE(7627),
    [sym_nil] = STATE(7627),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7628),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(8180),
    [sym__unary_minus] = ACTIONS(11168),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11170),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_break] = ACTIONS(11174),
    [anon_sym_next] = ACTIONS(11176),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11178),
    [anon_sym_defined_QMARK] = ACTIONS(11180),
    [anon_sym_not] = ACTIONS(11182),
    [anon_sym_BANG] = ACTIONS(11184),
    [anon_sym_TILDE] = ACTIONS(11184),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10920] = {
    [aux_sym_exceptions_repeat1] = STATE(11194),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(15179),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_end] = ACTIONS(9855),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_else] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [10921] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(11200),
    [sym__binary_star] = ACTIONS(11202),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(11204),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(11202),
    [anon_sym_AMP] = ACTIONS(11206),
    [anon_sym_LT] = ACTIONS(11208),
    [anon_sym_end] = ACTIONS(12120),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_else] = ACTIONS(12120),
    [anon_sym_EQ_GT] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(11210),
    [anon_sym_DOT_DOT] = ACTIONS(11212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11214),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(11216),
    [anon_sym_AMP_AMP] = ACTIONS(11216),
    [anon_sym_LT_LT] = ACTIONS(11218),
    [anon_sym_GT_GT] = ACTIONS(11218),
    [anon_sym_EQ_EQ] = ACTIONS(11220),
    [anon_sym_BANG_EQ] = ACTIONS(11216),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11216),
    [anon_sym_LT_EQ_GT] = ACTIONS(11216),
    [anon_sym_EQ_TILDE] = ACTIONS(11216),
    [anon_sym_BANG_TILDE] = ACTIONS(11216),
    [anon_sym_LT_EQ] = ACTIONS(11208),
    [anon_sym_GT] = ACTIONS(11208),
    [anon_sym_GT_EQ] = ACTIONS(11222),
    [anon_sym_CARET] = ACTIONS(11224),
    [anon_sym_PLUS] = ACTIONS(11200),
    [anon_sym_SLASH] = ACTIONS(11202),
    [anon_sym_PERCENT] = ACTIONS(11202),
    [sym_comment] = ACTIONS(87),
  },
  [10922] = {
    [aux_sym_exceptions_repeat1] = STATE(10922),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(15181),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_end] = ACTIONS(11597),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_else] = ACTIONS(11597),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [10923] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(11195),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7696),
    [sym_scope_resolution] = STATE(7694),
    [sym_call] = STATE(7694),
    [sym_method_call] = STATE(7696),
    [sym_assignment] = STATE(11195),
    [sym_operator_assignment] = STATE(11195),
    [sym_conditional] = STATE(11195),
    [sym_range] = STATE(11195),
    [sym_binary] = STATE(11195),
    [sym_unary] = STATE(11195),
    [sym_left_assignment_list] = STATE(7695),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7696),
    [sym__variable] = STATE(7694),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7696),
    [sym_false] = STATE(7696),
    [sym_nil] = STATE(7696),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7697),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11244),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11246),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_break] = ACTIONS(11250),
    [anon_sym_next] = ACTIONS(11252),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11254),
    [anon_sym_defined_QMARK] = ACTIONS(11256),
    [anon_sym_not] = ACTIONS(11258),
    [anon_sym_BANG] = ACTIONS(11260),
    [anon_sym_TILDE] = ACTIONS(11260),
    [sym_constant] = ACTIONS(11262),
    [sym_identifier] = ACTIONS(11262),
    [sym_instance_variable] = ACTIONS(11264),
    [sym_class_variable] = ACTIONS(11264),
    [sym_global_variable] = ACTIONS(11264),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11262),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11262),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [10924] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10432),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7696),
    [sym_scope_resolution] = STATE(7694),
    [sym_call] = STATE(7694),
    [sym_method_call] = STATE(7696),
    [sym_splat_argument] = STATE(10067),
    [sym_assignment] = STATE(10432),
    [sym_operator_assignment] = STATE(10432),
    [sym_conditional] = STATE(10432),
    [sym_range] = STATE(10432),
    [sym_binary] = STATE(10432),
    [sym_unary] = STATE(10432),
    [sym__arg_or_splat_arg] = STATE(10067),
    [sym_left_assignment_list] = STATE(7695),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7696),
    [sym__variable] = STATE(7694),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7696),
    [sym_false] = STATE(7696),
    [sym_nil] = STATE(7696),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7697),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__splat_star] = ACTIONS(8250),
    [sym__unary_minus] = ACTIONS(11244),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11246),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_break] = ACTIONS(11250),
    [anon_sym_next] = ACTIONS(11252),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11254),
    [anon_sym_defined_QMARK] = ACTIONS(11256),
    [anon_sym_not] = ACTIONS(11258),
    [anon_sym_BANG] = ACTIONS(11260),
    [anon_sym_TILDE] = ACTIONS(11260),
    [sym_constant] = ACTIONS(11262),
    [sym_identifier] = ACTIONS(11262),
    [sym_instance_variable] = ACTIONS(11264),
    [sym_class_variable] = ACTIONS(11264),
    [sym_global_variable] = ACTIONS(11264),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11262),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11262),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [10925] = {
    [aux_sym_exceptions_repeat1] = STATE(11196),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_LBRACE] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(15184),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9857),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_EQ] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_end] = ACTIONS(9855),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_do] = ACTIONS(9855),
    [anon_sym_else] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_PLUS_EQ] = ACTIONS(9855),
    [anon_sym_DASH_EQ] = ACTIONS(9855),
    [anon_sym_STAR_EQ] = ACTIONS(9855),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9855),
    [anon_sym_SLASH_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9855),
    [anon_sym_AMP_EQ] = ACTIONS(9855),
    [anon_sym_PERCENT_EQ] = ACTIONS(9855),
    [anon_sym_GT_GT_EQ] = ACTIONS(9855),
    [anon_sym_LT_LT_EQ] = ACTIONS(9855),
    [anon_sym_CARET_EQ] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9857),
    [anon_sym_AMP_AMP] = ACTIONS(9857),
    [anon_sym_LT_LT] = ACTIONS(9857),
    [anon_sym_GT_GT] = ACTIONS(9857),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9857),
    [anon_sym_PLUS] = ACTIONS(9857),
    [anon_sym_SLASH] = ACTIONS(9857),
    [anon_sym_PERCENT] = ACTIONS(9857),
    [sym_comment] = ACTIONS(87),
  },
  [10926] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(11272),
    [sym__binary_star] = ACTIONS(11274),
    [anon_sym_LBRACE] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(11276),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(11278),
    [anon_sym_AMP] = ACTIONS(11280),
    [anon_sym_EQ] = ACTIONS(12879),
    [anon_sym_LT] = ACTIONS(11282),
    [anon_sym_end] = ACTIONS(12120),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_else] = ACTIONS(12120),
    [anon_sym_EQ_GT] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_PLUS_EQ] = ACTIONS(12120),
    [anon_sym_DASH_EQ] = ACTIONS(12120),
    [anon_sym_STAR_EQ] = ACTIONS(12120),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12120),
    [anon_sym_SLASH_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12120),
    [anon_sym_AMP_EQ] = ACTIONS(12120),
    [anon_sym_PERCENT_EQ] = ACTIONS(12120),
    [anon_sym_GT_GT_EQ] = ACTIONS(12120),
    [anon_sym_LT_LT_EQ] = ACTIONS(12120),
    [anon_sym_CARET_EQ] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(11284),
    [anon_sym_DOT_DOT] = ACTIONS(11286),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11288),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(11290),
    [anon_sym_AMP_AMP] = ACTIONS(11290),
    [anon_sym_LT_LT] = ACTIONS(11292),
    [anon_sym_GT_GT] = ACTIONS(11292),
    [anon_sym_EQ_EQ] = ACTIONS(11290),
    [anon_sym_BANG_EQ] = ACTIONS(11294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11294),
    [anon_sym_LT_EQ_GT] = ACTIONS(11294),
    [anon_sym_EQ_TILDE] = ACTIONS(11294),
    [anon_sym_BANG_TILDE] = ACTIONS(11294),
    [anon_sym_LT_EQ] = ACTIONS(11282),
    [anon_sym_GT] = ACTIONS(11282),
    [anon_sym_GT_EQ] = ACTIONS(11296),
    [anon_sym_CARET] = ACTIONS(11276),
    [anon_sym_PLUS] = ACTIONS(11298),
    [anon_sym_SLASH] = ACTIONS(11278),
    [anon_sym_PERCENT] = ACTIONS(11278),
    [sym_comment] = ACTIONS(87),
  },
  [10927] = {
    [aux_sym_exceptions_repeat1] = STATE(10927),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(15186),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_end] = ACTIONS(11597),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_else] = ACTIONS(11597),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_PLUS_EQ] = ACTIONS(11597),
    [anon_sym_DASH_EQ] = ACTIONS(11597),
    [anon_sym_STAR_EQ] = ACTIONS(11597),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11597),
    [anon_sym_SLASH_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11597),
    [anon_sym_AMP_EQ] = ACTIONS(11597),
    [anon_sym_PERCENT_EQ] = ACTIONS(11597),
    [anon_sym_GT_GT_EQ] = ACTIONS(11597),
    [anon_sym_LT_LT_EQ] = ACTIONS(11597),
    [anon_sym_CARET_EQ] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_LT] = ACTIONS(12338),
    [anon_sym_GT_GT] = ACTIONS(12338),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(12338),
    [anon_sym_PLUS] = ACTIONS(12338),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [10928] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(11197),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7728),
    [sym_scope_resolution] = STATE(2717),
    [sym_call] = STATE(2717),
    [sym_method_call] = STATE(7728),
    [sym_assignment] = STATE(11197),
    [sym_operator_assignment] = STATE(11197),
    [sym_conditional] = STATE(11197),
    [sym_range] = STATE(11197),
    [sym_binary] = STATE(11197),
    [sym_unary] = STATE(11197),
    [sym_left_assignment_list] = STATE(7727),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7728),
    [sym__variable] = STATE(2717),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7728),
    [sym_false] = STATE(7728),
    [sym_nil] = STATE(7728),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7628),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11312),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11170),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_break] = ACTIONS(11174),
    [anon_sym_next] = ACTIONS(11176),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11314),
    [anon_sym_defined_QMARK] = ACTIONS(11316),
    [anon_sym_not] = ACTIONS(11318),
    [anon_sym_BANG] = ACTIONS(11320),
    [anon_sym_TILDE] = ACTIONS(11320),
    [sym_constant] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4601),
    [sym_instance_variable] = ACTIONS(4603),
    [sym_class_variable] = ACTIONS(4603),
    [sym_global_variable] = ACTIONS(4603),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4601),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4601),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10929] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(11198),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(7820),
    [sym_scope_resolution] = STATE(2846),
    [sym_call] = STATE(2846),
    [sym_method_call] = STATE(7820),
    [sym_assignment] = STATE(11198),
    [sym_operator_assignment] = STATE(11198),
    [sym_conditional] = STATE(11198),
    [sym_range] = STATE(11198),
    [sym_binary] = STATE(11198),
    [sym_unary] = STATE(11198),
    [sym_left_assignment_list] = STATE(7819),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7820),
    [sym__variable] = STATE(2846),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(7820),
    [sym_false] = STATE(7820),
    [sym_nil] = STATE(7820),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(7821),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(11356),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(11358),
    [anon_sym_yield] = ACTIONS(11360),
    [anon_sym_break] = ACTIONS(11362),
    [anon_sym_next] = ACTIONS(11364),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(11366),
    [anon_sym_defined_QMARK] = ACTIONS(11368),
    [anon_sym_not] = ACTIONS(11370),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_TILDE] = ACTIONS(11372),
    [sym_constant] = ACTIONS(4793),
    [sym_identifier] = ACTIONS(4793),
    [sym_instance_variable] = ACTIONS(4795),
    [sym_class_variable] = ACTIONS(4795),
    [sym_global_variable] = ACTIONS(4795),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(4793),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4793),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [10930] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(10468),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(7820),
    [sym_scope_resolution] = STATE(2846),
    [sym_call] = STATE(2846),
    [sym_method_call] = STATE(7820),
    [sym_splat_argument] = STATE(10867),
    [sym_assignment] = STATE(10468),
    [sym_operator_assignment] = STATE(10468),
    [sym_conditional] = STATE(10468),
    [sym_range] = STATE(10468),
    [sym_binary] = STATE(10468),
    [sym_unary] = STATE(10468),
    [sym__arg_or_splat_arg] = STATE(10867),
    [sym_left_assignment_list] = STATE(7819),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7820),
    [sym__variable] = STATE(2846),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(7820),
    [sym_false] = STATE(7820),
    [sym_nil] = STATE(7820),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(7821),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__splat_star] = ACTIONS(8464),
    [sym__unary_minus] = ACTIONS(11356),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(11358),
    [anon_sym_yield] = ACTIONS(11360),
    [anon_sym_break] = ACTIONS(11362),
    [anon_sym_next] = ACTIONS(11364),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(11366),
    [anon_sym_defined_QMARK] = ACTIONS(11368),
    [anon_sym_not] = ACTIONS(11370),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_TILDE] = ACTIONS(11372),
    [sym_constant] = ACTIONS(4793),
    [sym_identifier] = ACTIONS(4793),
    [sym_instance_variable] = ACTIONS(4795),
    [sym_class_variable] = ACTIONS(4795),
    [sym_global_variable] = ACTIONS(4795),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(4793),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4793),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [10931] = {
    [aux_sym_exceptions_repeat1] = STATE(11199),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_LBRACE] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(15189),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_STAR_STAR] = ACTIONS(9857),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_EQ] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_in] = ACTIONS(9855),
    [anon_sym_do] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_PLUS_EQ] = ACTIONS(9855),
    [anon_sym_DASH_EQ] = ACTIONS(9855),
    [anon_sym_STAR_EQ] = ACTIONS(9855),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9855),
    [anon_sym_SLASH_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9855),
    [anon_sym_AMP_EQ] = ACTIONS(9855),
    [anon_sym_PERCENT_EQ] = ACTIONS(9855),
    [anon_sym_GT_GT_EQ] = ACTIONS(9855),
    [anon_sym_LT_LT_EQ] = ACTIONS(9855),
    [anon_sym_CARET_EQ] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9857),
    [anon_sym_AMP_AMP] = ACTIONS(9857),
    [anon_sym_LT_LT] = ACTIONS(9857),
    [anon_sym_GT_GT] = ACTIONS(9857),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9857),
    [anon_sym_PLUS] = ACTIONS(9857),
    [anon_sym_SLASH] = ACTIONS(9857),
    [anon_sym_PERCENT] = ACTIONS(9857),
    [sym_comment] = ACTIONS(87),
  },
  [10932] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(11200),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7909),
    [sym_scope_resolution] = STATE(2981),
    [sym_call] = STATE(2981),
    [sym_method_call] = STATE(7909),
    [sym_assignment] = STATE(11200),
    [sym_operator_assignment] = STATE(11200),
    [sym_conditional] = STATE(11200),
    [sym_range] = STATE(11200),
    [sym_binary] = STATE(11200),
    [sym_unary] = STATE(11200),
    [sym_left_assignment_list] = STATE(7908),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7909),
    [sym__variable] = STATE(2981),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7909),
    [sym_false] = STATE(7909),
    [sym_nil] = STATE(7909),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2985),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11410),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4973),
    [anon_sym_yield] = ACTIONS(4975),
    [anon_sym_break] = ACTIONS(4977),
    [anon_sym_next] = ACTIONS(4979),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11412),
    [anon_sym_defined_QMARK] = ACTIONS(11414),
    [anon_sym_not] = ACTIONS(11416),
    [anon_sym_BANG] = ACTIONS(11418),
    [anon_sym_TILDE] = ACTIONS(11418),
    [sym_constant] = ACTIONS(4989),
    [sym_identifier] = ACTIONS(4989),
    [sym_instance_variable] = ACTIONS(4991),
    [sym_class_variable] = ACTIONS(4991),
    [sym_global_variable] = ACTIONS(4991),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4989),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4989),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10933] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10488),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7909),
    [sym_scope_resolution] = STATE(2981),
    [sym_call] = STATE(2981),
    [sym_method_call] = STATE(7909),
    [sym_splat_argument] = STATE(7439),
    [sym_assignment] = STATE(10488),
    [sym_operator_assignment] = STATE(10488),
    [sym_conditional] = STATE(10488),
    [sym_range] = STATE(10488),
    [sym_binary] = STATE(10488),
    [sym_unary] = STATE(10488),
    [sym__arg_or_splat_arg] = STATE(7439),
    [sym_left_assignment_list] = STATE(7908),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7909),
    [sym__variable] = STATE(2981),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7909),
    [sym_false] = STATE(7909),
    [sym_nil] = STATE(7909),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(2985),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(8623),
    [sym__unary_minus] = ACTIONS(11410),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4973),
    [anon_sym_yield] = ACTIONS(4975),
    [anon_sym_break] = ACTIONS(4977),
    [anon_sym_next] = ACTIONS(4979),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11412),
    [anon_sym_defined_QMARK] = ACTIONS(11414),
    [anon_sym_not] = ACTIONS(11416),
    [anon_sym_BANG] = ACTIONS(11418),
    [anon_sym_TILDE] = ACTIONS(11418),
    [sym_constant] = ACTIONS(4989),
    [sym_identifier] = ACTIONS(4989),
    [sym_instance_variable] = ACTIONS(4991),
    [sym_class_variable] = ACTIONS(4991),
    [sym_global_variable] = ACTIONS(4991),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4989),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4989),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10934] = {
    [aux_sym_exceptions_repeat1] = STATE(11201),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(15191),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_then] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [10935] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(14833),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_when] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [10936] = {
    [sym_heredoc_body] = STATE(11202),
    [aux_sym_call_repeat1] = STATE(11202),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_when] = ACTIONS(1681),
    [anon_sym_else] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [10937] = {
    [sym_heredoc_body] = STATE(11202),
    [aux_sym_call_repeat1] = STATE(11202),
    [aux_sym_argument_list_repeat1] = STATE(11203),
    [sym__line_break] = ACTIONS(1681),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(1681),
    [sym__binary_star] = ACTIONS(1681),
    [anon_sym_DOT] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(14224),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1685),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_unless] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_until] = ACTIONS(1681),
    [anon_sym_rescue] = ACTIONS(1681),
    [anon_sym_when] = ACTIONS(1681),
    [anon_sym_else] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1681),
    [anon_sym_and] = ACTIONS(1681),
    [anon_sym_or] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1681),
    [anon_sym_LT_EQ_GT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_BANG_TILDE] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1685),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [10938] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(14831),
    [sym__binary_star] = ACTIONS(14833),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(14835),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(14833),
    [anon_sym_AMP] = ACTIONS(14837),
    [anon_sym_LT] = ACTIONS(14839),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_when] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(14841),
    [anon_sym_DOT_DOT] = ACTIONS(14843),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14845),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(14847),
    [anon_sym_AMP_AMP] = ACTIONS(14847),
    [anon_sym_LT_LT] = ACTIONS(14849),
    [anon_sym_GT_GT] = ACTIONS(14849),
    [anon_sym_EQ_EQ] = ACTIONS(14851),
    [anon_sym_BANG_EQ] = ACTIONS(14847),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14847),
    [anon_sym_LT_EQ_GT] = ACTIONS(14847),
    [anon_sym_EQ_TILDE] = ACTIONS(14847),
    [anon_sym_BANG_TILDE] = ACTIONS(14847),
    [anon_sym_LT_EQ] = ACTIONS(14839),
    [anon_sym_GT] = ACTIONS(14839),
    [anon_sym_GT_EQ] = ACTIONS(14853),
    [anon_sym_CARET] = ACTIONS(14855),
    [anon_sym_PLUS] = ACTIONS(14831),
    [anon_sym_SLASH] = ACTIONS(14833),
    [anon_sym_PERCENT] = ACTIONS(14833),
    [sym_comment] = ACTIONS(87),
  },
  [10939] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(11204),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(10500),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(10500),
    [sym_assignment] = STATE(11204),
    [sym_operator_assignment] = STATE(11204),
    [sym_conditional] = STATE(11204),
    [sym_range] = STATE(11204),
    [sym_binary] = STATE(11204),
    [sym_unary] = STATE(11204),
    [sym_left_assignment_list] = STATE(10499),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10500),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(10500),
    [sym_false] = STATE(10500),
    [sym_nil] = STATE(10500),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(10501),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(14158),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14160),
    [anon_sym_yield] = ACTIONS(14162),
    [anon_sym_break] = ACTIONS(14164),
    [anon_sym_next] = ACTIONS(14166),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14168),
    [anon_sym_defined_QMARK] = ACTIONS(14170),
    [anon_sym_not] = ACTIONS(14172),
    [anon_sym_BANG] = ACTIONS(14174),
    [anon_sym_TILDE] = ACTIONS(14174),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10940] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(11205),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(10500),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(10500),
    [sym_assignment] = STATE(11205),
    [sym_operator_assignment] = STATE(11205),
    [sym_conditional] = STATE(11205),
    [sym_range] = STATE(11205),
    [sym_binary] = STATE(11205),
    [sym_unary] = STATE(11205),
    [sym_left_assignment_list] = STATE(10499),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10500),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(10500),
    [sym_false] = STATE(10500),
    [sym_nil] = STATE(10500),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(10501),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(14158),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14160),
    [anon_sym_yield] = ACTIONS(14162),
    [anon_sym_break] = ACTIONS(14164),
    [anon_sym_next] = ACTIONS(14166),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14168),
    [anon_sym_defined_QMARK] = ACTIONS(14170),
    [anon_sym_not] = ACTIONS(14172),
    [anon_sym_BANG] = ACTIONS(14174),
    [anon_sym_TILDE] = ACTIONS(14174),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10941] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(11206),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(10500),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(10500),
    [sym_assignment] = STATE(11206),
    [sym_operator_assignment] = STATE(11206),
    [sym_conditional] = STATE(11206),
    [sym_range] = STATE(11206),
    [sym_binary] = STATE(11206),
    [sym_unary] = STATE(11206),
    [sym_left_assignment_list] = STATE(10499),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10500),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(10500),
    [sym_false] = STATE(10500),
    [sym_nil] = STATE(10500),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(10501),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(14158),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14160),
    [anon_sym_yield] = ACTIONS(14162),
    [anon_sym_break] = ACTIONS(14164),
    [anon_sym_next] = ACTIONS(14166),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14168),
    [anon_sym_defined_QMARK] = ACTIONS(14170),
    [anon_sym_not] = ACTIONS(14172),
    [anon_sym_BANG] = ACTIONS(14174),
    [anon_sym_TILDE] = ACTIONS(14174),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10942] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(11207),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(10500),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(10500),
    [sym_assignment] = STATE(11207),
    [sym_operator_assignment] = STATE(11207),
    [sym_conditional] = STATE(11207),
    [sym_range] = STATE(11207),
    [sym_binary] = STATE(11207),
    [sym_unary] = STATE(11207),
    [sym_left_assignment_list] = STATE(10499),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10500),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(10500),
    [sym_false] = STATE(10500),
    [sym_nil] = STATE(10500),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(10501),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(14158),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14160),
    [anon_sym_yield] = ACTIONS(14162),
    [anon_sym_break] = ACTIONS(14164),
    [anon_sym_next] = ACTIONS(14166),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14168),
    [anon_sym_defined_QMARK] = ACTIONS(14170),
    [anon_sym_not] = ACTIONS(14172),
    [anon_sym_BANG] = ACTIONS(14174),
    [anon_sym_TILDE] = ACTIONS(14174),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10943] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(11208),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(10500),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(10500),
    [sym_assignment] = STATE(11208),
    [sym_operator_assignment] = STATE(11208),
    [sym_conditional] = STATE(11208),
    [sym_range] = STATE(11208),
    [sym_binary] = STATE(11208),
    [sym_unary] = STATE(11208),
    [sym_left_assignment_list] = STATE(10499),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10500),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(10500),
    [sym_false] = STATE(10500),
    [sym_nil] = STATE(10500),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(10501),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(14158),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14160),
    [anon_sym_yield] = ACTIONS(14162),
    [anon_sym_break] = ACTIONS(14164),
    [anon_sym_next] = ACTIONS(14166),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14168),
    [anon_sym_defined_QMARK] = ACTIONS(14170),
    [anon_sym_not] = ACTIONS(14172),
    [anon_sym_BANG] = ACTIONS(14174),
    [anon_sym_TILDE] = ACTIONS(14174),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10944] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(11209),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(11209),
    [sym_operator_assignment] = STATE(11209),
    [sym_conditional] = STATE(11209),
    [sym_range] = STATE(11209),
    [sym_binary] = STATE(11209),
    [sym_unary] = STATE(11209),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [10945] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(11210),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(10500),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(10500),
    [sym_assignment] = STATE(11210),
    [sym_operator_assignment] = STATE(11210),
    [sym_conditional] = STATE(11210),
    [sym_range] = STATE(11210),
    [sym_binary] = STATE(11210),
    [sym_unary] = STATE(11210),
    [sym_left_assignment_list] = STATE(10499),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10500),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(10500),
    [sym_false] = STATE(10500),
    [sym_nil] = STATE(10500),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(10501),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(14158),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14160),
    [anon_sym_yield] = ACTIONS(14162),
    [anon_sym_break] = ACTIONS(14164),
    [anon_sym_next] = ACTIONS(14166),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14168),
    [anon_sym_defined_QMARK] = ACTIONS(14170),
    [anon_sym_not] = ACTIONS(14172),
    [anon_sym_BANG] = ACTIONS(14174),
    [anon_sym_TILDE] = ACTIONS(14174),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10946] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(11211),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(10500),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(10500),
    [sym_assignment] = STATE(11211),
    [sym_operator_assignment] = STATE(11211),
    [sym_conditional] = STATE(11211),
    [sym_range] = STATE(11211),
    [sym_binary] = STATE(11211),
    [sym_unary] = STATE(11211),
    [sym_left_assignment_list] = STATE(10499),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10500),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(10500),
    [sym_false] = STATE(10500),
    [sym_nil] = STATE(10500),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(10501),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(14158),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14160),
    [anon_sym_yield] = ACTIONS(14162),
    [anon_sym_break] = ACTIONS(14164),
    [anon_sym_next] = ACTIONS(14166),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14168),
    [anon_sym_defined_QMARK] = ACTIONS(14170),
    [anon_sym_not] = ACTIONS(14172),
    [anon_sym_BANG] = ACTIONS(14174),
    [anon_sym_TILDE] = ACTIONS(14174),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10947] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(11212),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(10500),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(10500),
    [sym_assignment] = STATE(11212),
    [sym_operator_assignment] = STATE(11212),
    [sym_conditional] = STATE(11212),
    [sym_range] = STATE(11212),
    [sym_binary] = STATE(11212),
    [sym_unary] = STATE(11212),
    [sym_left_assignment_list] = STATE(10499),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10500),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(10500),
    [sym_false] = STATE(10500),
    [sym_nil] = STATE(10500),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(10501),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(14158),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14160),
    [anon_sym_yield] = ACTIONS(14162),
    [anon_sym_break] = ACTIONS(14164),
    [anon_sym_next] = ACTIONS(14166),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14168),
    [anon_sym_defined_QMARK] = ACTIONS(14170),
    [anon_sym_not] = ACTIONS(14172),
    [anon_sym_BANG] = ACTIONS(14174),
    [anon_sym_TILDE] = ACTIONS(14174),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10948] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(11213),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(10500),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(10500),
    [sym_assignment] = STATE(11213),
    [sym_operator_assignment] = STATE(11213),
    [sym_conditional] = STATE(11213),
    [sym_range] = STATE(11213),
    [sym_binary] = STATE(11213),
    [sym_unary] = STATE(11213),
    [sym_left_assignment_list] = STATE(10499),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10500),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(10500),
    [sym_false] = STATE(10500),
    [sym_nil] = STATE(10500),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(10501),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(14158),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14160),
    [anon_sym_yield] = ACTIONS(14162),
    [anon_sym_break] = ACTIONS(14164),
    [anon_sym_next] = ACTIONS(14166),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14168),
    [anon_sym_defined_QMARK] = ACTIONS(14170),
    [anon_sym_not] = ACTIONS(14172),
    [anon_sym_BANG] = ACTIONS(14174),
    [anon_sym_TILDE] = ACTIONS(14174),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10949] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(11214),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(10500),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(10500),
    [sym_splat_argument] = STATE(11215),
    [sym_assignment] = STATE(11214),
    [sym_operator_assignment] = STATE(11214),
    [sym_conditional] = STATE(11214),
    [sym_range] = STATE(11214),
    [sym_binary] = STATE(11214),
    [sym_unary] = STATE(11214),
    [sym_right_assignment_list] = STATE(2570),
    [sym__arg_or_splat_arg] = STATE(11215),
    [sym_left_assignment_list] = STATE(10499),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10500),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(10500),
    [sym_false] = STATE(10500),
    [sym_nil] = STATE(10500),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(10501),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(13284),
    [sym__unary_minus] = ACTIONS(14158),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14160),
    [anon_sym_yield] = ACTIONS(14162),
    [anon_sym_break] = ACTIONS(14164),
    [anon_sym_next] = ACTIONS(14166),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14168),
    [anon_sym_defined_QMARK] = ACTIONS(14170),
    [anon_sym_not] = ACTIONS(14172),
    [anon_sym_BANG] = ACTIONS(14174),
    [anon_sym_TILDE] = ACTIONS(14174),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10950] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(11216),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(10500),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(10500),
    [sym_assignment] = STATE(11216),
    [sym_operator_assignment] = STATE(11216),
    [sym_conditional] = STATE(11216),
    [sym_range] = STATE(11216),
    [sym_binary] = STATE(11216),
    [sym_unary] = STATE(11216),
    [sym_left_assignment_list] = STATE(10499),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10500),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(10500),
    [sym_false] = STATE(10500),
    [sym_nil] = STATE(10500),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(10501),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(14158),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14160),
    [anon_sym_yield] = ACTIONS(14162),
    [anon_sym_break] = ACTIONS(14164),
    [anon_sym_next] = ACTIONS(14166),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14168),
    [anon_sym_defined_QMARK] = ACTIONS(14170),
    [anon_sym_not] = ACTIONS(14172),
    [anon_sym_BANG] = ACTIONS(14174),
    [anon_sym_TILDE] = ACTIONS(14174),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10951] = {
    [sym_string] = STATE(11217),
    [aux_sym_chained_string_repeat1] = STATE(11217),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_end] = ACTIONS(2753),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_when] = ACTIONS(2753),
    [anon_sym_else] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [10952] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(14831),
    [sym__binary_star] = ACTIONS(14833),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(14835),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(14833),
    [anon_sym_AMP] = ACTIONS(14837),
    [anon_sym_LT] = ACTIONS(14839),
    [anon_sym_end] = ACTIONS(6823),
    [anon_sym_if] = ACTIONS(6823),
    [anon_sym_unless] = ACTIONS(6823),
    [anon_sym_while] = ACTIONS(6823),
    [anon_sym_until] = ACTIONS(6823),
    [anon_sym_rescue] = ACTIONS(6823),
    [anon_sym_when] = ACTIONS(6823),
    [anon_sym_else] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(14841),
    [anon_sym_DOT_DOT] = ACTIONS(14843),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14845),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(14847),
    [anon_sym_AMP_AMP] = ACTIONS(14847),
    [anon_sym_LT_LT] = ACTIONS(14849),
    [anon_sym_GT_GT] = ACTIONS(14849),
    [anon_sym_EQ_EQ] = ACTIONS(14851),
    [anon_sym_BANG_EQ] = ACTIONS(14847),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14847),
    [anon_sym_LT_EQ_GT] = ACTIONS(14847),
    [anon_sym_EQ_TILDE] = ACTIONS(14847),
    [anon_sym_BANG_TILDE] = ACTIONS(14847),
    [anon_sym_LT_EQ] = ACTIONS(14839),
    [anon_sym_GT] = ACTIONS(14839),
    [anon_sym_GT_EQ] = ACTIONS(14853),
    [anon_sym_CARET] = ACTIONS(14855),
    [anon_sym_PLUS] = ACTIONS(14831),
    [anon_sym_SLASH] = ACTIONS(14833),
    [anon_sym_PERCENT] = ACTIONS(14833),
    [sym_comment] = ACTIONS(87),
  },
  [10953] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(14190),
    [sym__binary_star] = ACTIONS(14192),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(14194),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(14192),
    [anon_sym_AMP] = ACTIONS(14196),
    [anon_sym_LT] = ACTIONS(14198),
    [anon_sym_end] = ACTIONS(4211),
    [anon_sym_if] = ACTIONS(4211),
    [anon_sym_unless] = ACTIONS(4211),
    [anon_sym_while] = ACTIONS(4211),
    [anon_sym_until] = ACTIONS(4211),
    [anon_sym_rescue] = ACTIONS(4211),
    [anon_sym_when] = ACTIONS(4211),
    [anon_sym_else] = ACTIONS(4211),
    [anon_sym_EQ_GT] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(14200),
    [anon_sym_DOT_DOT] = ACTIONS(14202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14204),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(14206),
    [anon_sym_AMP_AMP] = ACTIONS(14206),
    [anon_sym_LT_LT] = ACTIONS(14208),
    [anon_sym_GT_GT] = ACTIONS(14208),
    [anon_sym_EQ_EQ] = ACTIONS(14210),
    [anon_sym_BANG_EQ] = ACTIONS(14206),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14206),
    [anon_sym_LT_EQ_GT] = ACTIONS(14206),
    [anon_sym_EQ_TILDE] = ACTIONS(14206),
    [anon_sym_BANG_TILDE] = ACTIONS(14206),
    [anon_sym_LT_EQ] = ACTIONS(14198),
    [anon_sym_GT] = ACTIONS(14198),
    [anon_sym_GT_EQ] = ACTIONS(14212),
    [anon_sym_CARET] = ACTIONS(14214),
    [anon_sym_PLUS] = ACTIONS(14190),
    [anon_sym_SLASH] = ACTIONS(14192),
    [anon_sym_PERCENT] = ACTIONS(14192),
    [sym_comment] = ACTIONS(87),
  },
  [10954] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(14190),
    [sym__binary_star] = ACTIONS(14192),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(14194),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(14192),
    [anon_sym_AMP] = ACTIONS(14196),
    [anon_sym_LT] = ACTIONS(14198),
    [anon_sym_end] = ACTIONS(4247),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_when] = ACTIONS(4247),
    [anon_sym_else] = ACTIONS(4247),
    [anon_sym_EQ_GT] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(14200),
    [anon_sym_DOT_DOT] = ACTIONS(14202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14204),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(14206),
    [anon_sym_AMP_AMP] = ACTIONS(14206),
    [anon_sym_LT_LT] = ACTIONS(14208),
    [anon_sym_GT_GT] = ACTIONS(14208),
    [anon_sym_EQ_EQ] = ACTIONS(14210),
    [anon_sym_BANG_EQ] = ACTIONS(14206),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14206),
    [anon_sym_LT_EQ_GT] = ACTIONS(14206),
    [anon_sym_EQ_TILDE] = ACTIONS(14206),
    [anon_sym_BANG_TILDE] = ACTIONS(14206),
    [anon_sym_LT_EQ] = ACTIONS(14198),
    [anon_sym_GT] = ACTIONS(14198),
    [anon_sym_GT_EQ] = ACTIONS(14212),
    [anon_sym_CARET] = ACTIONS(14214),
    [anon_sym_PLUS] = ACTIONS(14190),
    [anon_sym_SLASH] = ACTIONS(14192),
    [anon_sym_PERCENT] = ACTIONS(14192),
    [sym_comment] = ACTIONS(87),
  },
  [10955] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(11218),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9593),
    [sym_scope_resolution] = STATE(9589),
    [sym_call] = STATE(9589),
    [sym_method_call] = STATE(9593),
    [sym_assignment] = STATE(11218),
    [sym_operator_assignment] = STATE(11218),
    [sym_conditional] = STATE(11218),
    [sym_range] = STATE(11218),
    [sym_binary] = STATE(11218),
    [sym_unary] = STATE(11218),
    [sym_left_assignment_list] = STATE(9592),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9593),
    [sym__variable] = STATE(9589),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9593),
    [sym_false] = STATE(9593),
    [sym_nil] = STATE(9593),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(10504),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(13286),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13290),
    [anon_sym_yield] = ACTIONS(13292),
    [anon_sym_break] = ACTIONS(13294),
    [anon_sym_next] = ACTIONS(13296),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14176),
    [anon_sym_defined_QMARK] = ACTIONS(13298),
    [anon_sym_not] = ACTIONS(13300),
    [anon_sym_BANG] = ACTIONS(13304),
    [anon_sym_TILDE] = ACTIONS(13304),
    [sym_constant] = ACTIONS(13310),
    [sym_identifier] = ACTIONS(13310),
    [sym_instance_variable] = ACTIONS(13308),
    [sym_class_variable] = ACTIONS(13308),
    [sym_global_variable] = ACTIONS(13308),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(13310),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13310),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10956] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(14190),
    [sym__binary_star] = ACTIONS(14192),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(14194),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(14192),
    [anon_sym_AMP] = ACTIONS(14196),
    [anon_sym_LT] = ACTIONS(14198),
    [anon_sym_end] = ACTIONS(3281),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_unless] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_until] = ACTIONS(3281),
    [anon_sym_rescue] = ACTIONS(3281),
    [anon_sym_when] = ACTIONS(3281),
    [anon_sym_else] = ACTIONS(3281),
    [anon_sym_EQ_GT] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(14200),
    [anon_sym_DOT_DOT] = ACTIONS(14202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14204),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(14206),
    [anon_sym_AMP_AMP] = ACTIONS(14206),
    [anon_sym_LT_LT] = ACTIONS(14208),
    [anon_sym_GT_GT] = ACTIONS(14208),
    [anon_sym_EQ_EQ] = ACTIONS(14210),
    [anon_sym_BANG_EQ] = ACTIONS(14206),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14206),
    [anon_sym_LT_EQ_GT] = ACTIONS(14206),
    [anon_sym_EQ_TILDE] = ACTIONS(14206),
    [anon_sym_BANG_TILDE] = ACTIONS(14206),
    [anon_sym_LT_EQ] = ACTIONS(14198),
    [anon_sym_GT] = ACTIONS(14198),
    [anon_sym_GT_EQ] = ACTIONS(14212),
    [anon_sym_CARET] = ACTIONS(14214),
    [anon_sym_PLUS] = ACTIONS(14190),
    [anon_sym_SLASH] = ACTIONS(14192),
    [anon_sym_PERCENT] = ACTIONS(14192),
    [sym_comment] = ACTIONS(87),
  },
  [10957] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(11219),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9593),
    [sym_scope_resolution] = STATE(9589),
    [sym_call] = STATE(9589),
    [sym_method_call] = STATE(9593),
    [sym_assignment] = STATE(11219),
    [sym_operator_assignment] = STATE(11219),
    [sym_conditional] = STATE(11219),
    [sym_range] = STATE(11219),
    [sym_binary] = STATE(11219),
    [sym_unary] = STATE(11219),
    [sym_left_assignment_list] = STATE(9592),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9593),
    [sym__variable] = STATE(9589),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9593),
    [sym_false] = STATE(9593),
    [sym_nil] = STATE(9593),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(10504),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(13286),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13290),
    [anon_sym_yield] = ACTIONS(13292),
    [anon_sym_break] = ACTIONS(13294),
    [anon_sym_next] = ACTIONS(13296),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14176),
    [anon_sym_defined_QMARK] = ACTIONS(13298),
    [anon_sym_not] = ACTIONS(13300),
    [anon_sym_BANG] = ACTIONS(13304),
    [anon_sym_TILDE] = ACTIONS(13304),
    [sym_constant] = ACTIONS(13310),
    [sym_identifier] = ACTIONS(13310),
    [sym_instance_variable] = ACTIONS(13308),
    [sym_class_variable] = ACTIONS(13308),
    [sym_global_variable] = ACTIONS(13308),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(13310),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13310),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10958] = {
    [sym_heredoc_body] = STATE(11220),
    [aux_sym_call_repeat1] = STATE(11220),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_when] = ACTIONS(4383),
    [anon_sym_else] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [10959] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10512),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9593),
    [sym_scope_resolution] = STATE(9589),
    [sym_call] = STATE(9589),
    [sym_method_call] = STATE(9593),
    [sym__argument] = STATE(2565),
    [sym_splat_argument] = STATE(2565),
    [sym_hash_splat_argument] = STATE(2565),
    [sym_block_argument] = STATE(2565),
    [sym_assignment] = STATE(10512),
    [sym_operator_assignment] = STATE(10512),
    [sym_conditional] = STATE(10512),
    [sym_range] = STATE(10512),
    [sym_binary] = STATE(10512),
    [sym_unary] = STATE(10512),
    [sym_left_assignment_list] = STATE(9592),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9593),
    [sym__variable] = STATE(9589),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9593),
    [sym_false] = STATE(9593),
    [sym_nil] = STATE(9593),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(10515),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(11221),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2565),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(14180),
    [sym__splat_star] = ACTIONS(14182),
    [sym__unary_minus] = ACTIONS(13286),
    [sym__identifier_hash_key] = ACTIONS(14184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(15193),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13290),
    [anon_sym_yield] = ACTIONS(13292),
    [anon_sym_break] = ACTIONS(13294),
    [anon_sym_next] = ACTIONS(13296),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14176),
    [anon_sym_defined_QMARK] = ACTIONS(13298),
    [anon_sym_not] = ACTIONS(13300),
    [anon_sym_BANG] = ACTIONS(13304),
    [anon_sym_TILDE] = ACTIONS(13304),
    [sym_constant] = ACTIONS(14186),
    [sym_identifier] = ACTIONS(14186),
    [sym_instance_variable] = ACTIONS(13308),
    [sym_class_variable] = ACTIONS(13308),
    [sym_global_variable] = ACTIONS(13308),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(13310),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13310),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10960] = {
    [sym_heredoc_body] = STATE(11222),
    [aux_sym_call_repeat1] = STATE(11222),
    [aux_sym_argument_list_repeat1] = STATE(11223),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(14867),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_when] = ACTIONS(4383),
    [anon_sym_else] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [10961] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(14831),
    [sym__binary_star] = ACTIONS(14833),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(14835),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(14833),
    [anon_sym_AMP] = ACTIONS(14837),
    [anon_sym_LT] = ACTIONS(14839),
    [anon_sym_end] = ACTIONS(7027),
    [anon_sym_if] = ACTIONS(7027),
    [anon_sym_unless] = ACTIONS(7027),
    [anon_sym_while] = ACTIONS(7027),
    [anon_sym_until] = ACTIONS(7027),
    [anon_sym_rescue] = ACTIONS(7027),
    [anon_sym_when] = ACTIONS(7027),
    [anon_sym_else] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(14841),
    [anon_sym_DOT_DOT] = ACTIONS(14843),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14845),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(14847),
    [anon_sym_AMP_AMP] = ACTIONS(14847),
    [anon_sym_LT_LT] = ACTIONS(14849),
    [anon_sym_GT_GT] = ACTIONS(14849),
    [anon_sym_EQ_EQ] = ACTIONS(14851),
    [anon_sym_BANG_EQ] = ACTIONS(14847),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14847),
    [anon_sym_LT_EQ_GT] = ACTIONS(14847),
    [anon_sym_EQ_TILDE] = ACTIONS(14847),
    [anon_sym_BANG_TILDE] = ACTIONS(14847),
    [anon_sym_LT_EQ] = ACTIONS(14839),
    [anon_sym_GT] = ACTIONS(14839),
    [anon_sym_GT_EQ] = ACTIONS(14853),
    [anon_sym_CARET] = ACTIONS(14855),
    [anon_sym_PLUS] = ACTIONS(14831),
    [anon_sym_SLASH] = ACTIONS(14833),
    [anon_sym_PERCENT] = ACTIONS(14833),
    [sym_comment] = ACTIONS(87),
  },
  [10962] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(14192),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(14192),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_when] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(14192),
    [anon_sym_PERCENT] = ACTIONS(14192),
    [sym_comment] = ACTIONS(87),
  },
  [10963] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(14192),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_when] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [10964] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(14190),
    [sym__binary_star] = ACTIONS(14192),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(14192),
    [anon_sym_AMP] = ACTIONS(14196),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_when] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(14208),
    [anon_sym_GT_GT] = ACTIONS(14208),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(14190),
    [anon_sym_SLASH] = ACTIONS(14192),
    [anon_sym_PERCENT] = ACTIONS(14192),
    [sym_comment] = ACTIONS(87),
  },
  [10965] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(14190),
    [sym__binary_star] = ACTIONS(14192),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(14192),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_when] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(14208),
    [anon_sym_GT_GT] = ACTIONS(14208),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(14190),
    [anon_sym_SLASH] = ACTIONS(14192),
    [anon_sym_PERCENT] = ACTIONS(14192),
    [sym_comment] = ACTIONS(87),
  },
  [10966] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(14190),
    [sym__binary_star] = ACTIONS(14192),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(14194),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(14192),
    [anon_sym_AMP] = ACTIONS(14196),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_when] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(14208),
    [anon_sym_GT_GT] = ACTIONS(14208),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(14214),
    [anon_sym_PLUS] = ACTIONS(14190),
    [anon_sym_SLASH] = ACTIONS(14192),
    [anon_sym_PERCENT] = ACTIONS(14192),
    [sym_comment] = ACTIONS(87),
  },
  [10967] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(15195),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [10968] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(14190),
    [sym__binary_star] = ACTIONS(14192),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(14194),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(14192),
    [anon_sym_AMP] = ACTIONS(14196),
    [anon_sym_LT] = ACTIONS(14198),
    [anon_sym_end] = ACTIONS(5927),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_when] = ACTIONS(5927),
    [anon_sym_else] = ACTIONS(5927),
    [anon_sym_EQ_GT] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(14202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14204),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(14206),
    [anon_sym_AMP_AMP] = ACTIONS(14206),
    [anon_sym_LT_LT] = ACTIONS(14208),
    [anon_sym_GT_GT] = ACTIONS(14208),
    [anon_sym_EQ_EQ] = ACTIONS(14210),
    [anon_sym_BANG_EQ] = ACTIONS(14206),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14206),
    [anon_sym_LT_EQ_GT] = ACTIONS(14206),
    [anon_sym_EQ_TILDE] = ACTIONS(14206),
    [anon_sym_BANG_TILDE] = ACTIONS(14206),
    [anon_sym_LT_EQ] = ACTIONS(14198),
    [anon_sym_GT] = ACTIONS(14198),
    [anon_sym_GT_EQ] = ACTIONS(14212),
    [anon_sym_CARET] = ACTIONS(14214),
    [anon_sym_PLUS] = ACTIONS(14190),
    [anon_sym_SLASH] = ACTIONS(14192),
    [anon_sym_PERCENT] = ACTIONS(14192),
    [sym_comment] = ACTIONS(87),
  },
  [10969] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(14190),
    [sym__binary_star] = ACTIONS(14192),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(14194),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(14192),
    [anon_sym_AMP] = ACTIONS(14196),
    [anon_sym_LT] = ACTIONS(14198),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_when] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(14200),
    [anon_sym_DOT_DOT] = ACTIONS(14202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14204),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(14206),
    [anon_sym_AMP_AMP] = ACTIONS(14206),
    [anon_sym_LT_LT] = ACTIONS(14208),
    [anon_sym_GT_GT] = ACTIONS(14208),
    [anon_sym_EQ_EQ] = ACTIONS(14210),
    [anon_sym_BANG_EQ] = ACTIONS(14206),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14206),
    [anon_sym_LT_EQ_GT] = ACTIONS(14206),
    [anon_sym_EQ_TILDE] = ACTIONS(14206),
    [anon_sym_BANG_TILDE] = ACTIONS(14206),
    [anon_sym_LT_EQ] = ACTIONS(14198),
    [anon_sym_GT] = ACTIONS(14198),
    [anon_sym_GT_EQ] = ACTIONS(14212),
    [anon_sym_CARET] = ACTIONS(14214),
    [anon_sym_PLUS] = ACTIONS(14190),
    [anon_sym_SLASH] = ACTIONS(14192),
    [anon_sym_PERCENT] = ACTIONS(14192),
    [sym_comment] = ACTIONS(87),
  },
  [10970] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(14190),
    [sym__binary_star] = ACTIONS(14192),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(14194),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(14192),
    [anon_sym_AMP] = ACTIONS(14196),
    [anon_sym_LT] = ACTIONS(14198),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_when] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(14208),
    [anon_sym_GT_GT] = ACTIONS(14208),
    [anon_sym_EQ_EQ] = ACTIONS(14210),
    [anon_sym_BANG_EQ] = ACTIONS(14206),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14206),
    [anon_sym_LT_EQ_GT] = ACTIONS(14206),
    [anon_sym_EQ_TILDE] = ACTIONS(14206),
    [anon_sym_BANG_TILDE] = ACTIONS(14206),
    [anon_sym_LT_EQ] = ACTIONS(14198),
    [anon_sym_GT] = ACTIONS(14198),
    [anon_sym_GT_EQ] = ACTIONS(14212),
    [anon_sym_CARET] = ACTIONS(14214),
    [anon_sym_PLUS] = ACTIONS(14190),
    [anon_sym_SLASH] = ACTIONS(14192),
    [anon_sym_PERCENT] = ACTIONS(14192),
    [sym_comment] = ACTIONS(87),
  },
  [10971] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(14190),
    [sym__binary_star] = ACTIONS(14192),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(14192),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_when] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(14190),
    [anon_sym_SLASH] = ACTIONS(14192),
    [anon_sym_PERCENT] = ACTIONS(14192),
    [sym_comment] = ACTIONS(87),
  },
  [10972] = {
    [sym__line_break] = ACTIONS(4211),
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(14262),
    [sym__binary_star] = ACTIONS(14264),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(14266),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(14268),
    [anon_sym_AMP] = ACTIONS(14270),
    [anon_sym_EQ] = ACTIONS(4217),
    [anon_sym_LT] = ACTIONS(14272),
    [anon_sym_end] = ACTIONS(4211),
    [anon_sym_if] = ACTIONS(4211),
    [anon_sym_unless] = ACTIONS(4211),
    [anon_sym_while] = ACTIONS(4211),
    [anon_sym_until] = ACTIONS(4211),
    [anon_sym_rescue] = ACTIONS(4211),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_when] = ACTIONS(4211),
    [anon_sym_else] = ACTIONS(4211),
    [anon_sym_EQ_GT] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_PLUS_EQ] = ACTIONS(4211),
    [anon_sym_DASH_EQ] = ACTIONS(4211),
    [anon_sym_STAR_EQ] = ACTIONS(4211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4211),
    [anon_sym_SLASH_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4211),
    [anon_sym_AMP_EQ] = ACTIONS(4211),
    [anon_sym_PERCENT_EQ] = ACTIONS(4211),
    [anon_sym_GT_GT_EQ] = ACTIONS(4211),
    [anon_sym_LT_LT_EQ] = ACTIONS(4211),
    [anon_sym_CARET_EQ] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(14274),
    [anon_sym_DOT_DOT] = ACTIONS(14276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14278),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(14280),
    [anon_sym_AMP_AMP] = ACTIONS(14280),
    [anon_sym_LT_LT] = ACTIONS(14282),
    [anon_sym_GT_GT] = ACTIONS(14282),
    [anon_sym_EQ_EQ] = ACTIONS(14280),
    [anon_sym_BANG_EQ] = ACTIONS(14284),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14284),
    [anon_sym_LT_EQ_GT] = ACTIONS(14284),
    [anon_sym_EQ_TILDE] = ACTIONS(14284),
    [anon_sym_BANG_TILDE] = ACTIONS(14284),
    [anon_sym_LT_EQ] = ACTIONS(14272),
    [anon_sym_GT] = ACTIONS(14272),
    [anon_sym_GT_EQ] = ACTIONS(14286),
    [anon_sym_CARET] = ACTIONS(14266),
    [anon_sym_PLUS] = ACTIONS(14288),
    [anon_sym_SLASH] = ACTIONS(14268),
    [anon_sym_PERCENT] = ACTIONS(14268),
    [sym_comment] = ACTIONS(87),
  },
  [10973] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(14262),
    [sym__binary_star] = ACTIONS(14264),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(14266),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(14268),
    [anon_sym_AMP] = ACTIONS(14270),
    [anon_sym_EQ] = ACTIONS(4249),
    [anon_sym_LT] = ACTIONS(14272),
    [anon_sym_end] = ACTIONS(4247),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_when] = ACTIONS(4247),
    [anon_sym_else] = ACTIONS(4247),
    [anon_sym_EQ_GT] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_PLUS_EQ] = ACTIONS(4247),
    [anon_sym_DASH_EQ] = ACTIONS(4247),
    [anon_sym_STAR_EQ] = ACTIONS(4247),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4247),
    [anon_sym_SLASH_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4247),
    [anon_sym_AMP_EQ] = ACTIONS(4247),
    [anon_sym_PERCENT_EQ] = ACTIONS(4247),
    [anon_sym_GT_GT_EQ] = ACTIONS(4247),
    [anon_sym_LT_LT_EQ] = ACTIONS(4247),
    [anon_sym_CARET_EQ] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(14274),
    [anon_sym_DOT_DOT] = ACTIONS(14276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14278),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(14280),
    [anon_sym_AMP_AMP] = ACTIONS(14280),
    [anon_sym_LT_LT] = ACTIONS(14282),
    [anon_sym_GT_GT] = ACTIONS(14282),
    [anon_sym_EQ_EQ] = ACTIONS(14280),
    [anon_sym_BANG_EQ] = ACTIONS(14284),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14284),
    [anon_sym_LT_EQ_GT] = ACTIONS(14284),
    [anon_sym_EQ_TILDE] = ACTIONS(14284),
    [anon_sym_BANG_TILDE] = ACTIONS(14284),
    [anon_sym_LT_EQ] = ACTIONS(14272),
    [anon_sym_GT] = ACTIONS(14272),
    [anon_sym_GT_EQ] = ACTIONS(14286),
    [anon_sym_CARET] = ACTIONS(14266),
    [anon_sym_PLUS] = ACTIONS(14288),
    [anon_sym_SLASH] = ACTIONS(14268),
    [anon_sym_PERCENT] = ACTIONS(14268),
    [sym_comment] = ACTIONS(87),
  },
  [10974] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(11225),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(9629),
    [sym_scope_resolution] = STATE(9625),
    [sym_call] = STATE(9625),
    [sym_method_call] = STATE(9629),
    [sym_assignment] = STATE(11225),
    [sym_operator_assignment] = STATE(11225),
    [sym_conditional] = STATE(11225),
    [sym_range] = STATE(11225),
    [sym_binary] = STATE(11225),
    [sym_unary] = STATE(11225),
    [sym_left_assignment_list] = STATE(9628),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9629),
    [sym__variable] = STATE(9625),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(9629),
    [sym_false] = STATE(9629),
    [sym_nil] = STATE(9629),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(10573),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(13356),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(13360),
    [anon_sym_yield] = ACTIONS(13362),
    [anon_sym_break] = ACTIONS(13364),
    [anon_sym_next] = ACTIONS(13366),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(14256),
    [anon_sym_defined_QMARK] = ACTIONS(13368),
    [anon_sym_not] = ACTIONS(13370),
    [anon_sym_BANG] = ACTIONS(13374),
    [anon_sym_TILDE] = ACTIONS(13374),
    [sym_constant] = ACTIONS(13380),
    [sym_identifier] = ACTIONS(13380),
    [sym_instance_variable] = ACTIONS(13378),
    [sym_class_variable] = ACTIONS(13378),
    [sym_global_variable] = ACTIONS(13378),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(13380),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13380),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [10975] = {
    [sym__line_break] = ACTIONS(3281),
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(14262),
    [sym__binary_star] = ACTIONS(14264),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(14266),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(14268),
    [anon_sym_AMP] = ACTIONS(14270),
    [anon_sym_EQ] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(14272),
    [anon_sym_end] = ACTIONS(3281),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_unless] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_until] = ACTIONS(3281),
    [anon_sym_rescue] = ACTIONS(3281),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_when] = ACTIONS(3281),
    [anon_sym_else] = ACTIONS(3281),
    [anon_sym_EQ_GT] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_PLUS_EQ] = ACTIONS(3281),
    [anon_sym_DASH_EQ] = ACTIONS(3281),
    [anon_sym_STAR_EQ] = ACTIONS(3281),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3281),
    [anon_sym_SLASH_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3281),
    [anon_sym_AMP_EQ] = ACTIONS(3281),
    [anon_sym_PERCENT_EQ] = ACTIONS(3281),
    [anon_sym_GT_GT_EQ] = ACTIONS(3281),
    [anon_sym_LT_LT_EQ] = ACTIONS(3281),
    [anon_sym_CARET_EQ] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(14274),
    [anon_sym_DOT_DOT] = ACTIONS(14276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14278),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(14280),
    [anon_sym_AMP_AMP] = ACTIONS(14280),
    [anon_sym_LT_LT] = ACTIONS(14282),
    [anon_sym_GT_GT] = ACTIONS(14282),
    [anon_sym_EQ_EQ] = ACTIONS(14280),
    [anon_sym_BANG_EQ] = ACTIONS(14284),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14284),
    [anon_sym_LT_EQ_GT] = ACTIONS(14284),
    [anon_sym_EQ_TILDE] = ACTIONS(14284),
    [anon_sym_BANG_TILDE] = ACTIONS(14284),
    [anon_sym_LT_EQ] = ACTIONS(14272),
    [anon_sym_GT] = ACTIONS(14272),
    [anon_sym_GT_EQ] = ACTIONS(14286),
    [anon_sym_CARET] = ACTIONS(14266),
    [anon_sym_PLUS] = ACTIONS(14288),
    [anon_sym_SLASH] = ACTIONS(14268),
    [anon_sym_PERCENT] = ACTIONS(14268),
    [sym_comment] = ACTIONS(87),
  },
  [10976] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(11226),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(9629),
    [sym_scope_resolution] = STATE(9625),
    [sym_call] = STATE(9625),
    [sym_method_call] = STATE(9629),
    [sym_assignment] = STATE(11226),
    [sym_operator_assignment] = STATE(11226),
    [sym_conditional] = STATE(11226),
    [sym_range] = STATE(11226),
    [sym_binary] = STATE(11226),
    [sym_unary] = STATE(11226),
    [sym_left_assignment_list] = STATE(9628),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9629),
    [sym__variable] = STATE(9625),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(9629),
    [sym_false] = STATE(9629),
    [sym_nil] = STATE(9629),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(10573),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(13356),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(13360),
    [anon_sym_yield] = ACTIONS(13362),
    [anon_sym_break] = ACTIONS(13364),
    [anon_sym_next] = ACTIONS(13366),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(14256),
    [anon_sym_defined_QMARK] = ACTIONS(13368),
    [anon_sym_not] = ACTIONS(13370),
    [anon_sym_BANG] = ACTIONS(13374),
    [anon_sym_TILDE] = ACTIONS(13374),
    [sym_constant] = ACTIONS(13380),
    [sym_identifier] = ACTIONS(13380),
    [sym_instance_variable] = ACTIONS(13378),
    [sym_class_variable] = ACTIONS(13378),
    [sym_global_variable] = ACTIONS(13378),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(13380),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13380),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [10977] = {
    [sym_heredoc_body] = STATE(11227),
    [aux_sym_call_repeat1] = STATE(11227),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_when] = ACTIONS(4383),
    [anon_sym_else] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [10978] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(10533),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(9629),
    [sym_scope_resolution] = STATE(9625),
    [sym_call] = STATE(9625),
    [sym_method_call] = STATE(9629),
    [sym__argument] = STATE(4979),
    [sym_splat_argument] = STATE(4979),
    [sym_hash_splat_argument] = STATE(4979),
    [sym_block_argument] = STATE(4979),
    [sym_assignment] = STATE(10533),
    [sym_operator_assignment] = STATE(10533),
    [sym_conditional] = STATE(10533),
    [sym_range] = STATE(10533),
    [sym_binary] = STATE(10533),
    [sym_unary] = STATE(10533),
    [sym_left_assignment_list] = STATE(9628),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9629),
    [sym__variable] = STATE(9625),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(9629),
    [sym_false] = STATE(9629),
    [sym_nil] = STATE(9629),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(10536),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_heredoc_body] = STATE(11228),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(4979),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(14216),
    [sym__splat_star] = ACTIONS(14218),
    [sym__unary_minus] = ACTIONS(13356),
    [sym__identifier_hash_key] = ACTIONS(14220),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(15197),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(13360),
    [anon_sym_yield] = ACTIONS(13362),
    [anon_sym_break] = ACTIONS(13364),
    [anon_sym_next] = ACTIONS(13366),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(14256),
    [anon_sym_defined_QMARK] = ACTIONS(13368),
    [anon_sym_not] = ACTIONS(13370),
    [anon_sym_BANG] = ACTIONS(13374),
    [anon_sym_TILDE] = ACTIONS(13374),
    [sym_constant] = ACTIONS(14222),
    [sym_identifier] = ACTIONS(14222),
    [sym_instance_variable] = ACTIONS(13378),
    [sym_class_variable] = ACTIONS(13378),
    [sym_global_variable] = ACTIONS(13378),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(13380),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13380),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [10979] = {
    [sym_heredoc_body] = STATE(11229),
    [aux_sym_call_repeat1] = STATE(11229),
    [aux_sym_argument_list_repeat1] = STATE(11230),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(14875),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_when] = ACTIONS(4383),
    [anon_sym_else] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [10980] = {
    [sym_heredoc_body] = STATE(10980),
    [aux_sym_call_repeat1] = STATE(10980),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(7916),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_end] = ACTIONS(7914),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_when] = ACTIONS(7914),
    [anon_sym_else] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [10981] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9588),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9593),
    [sym_scope_resolution] = STATE(9589),
    [sym_call] = STATE(9589),
    [sym_method_call] = STATE(9593),
    [sym__argument] = STATE(4986),
    [sym_splat_argument] = STATE(4986),
    [sym_hash_splat_argument] = STATE(4986),
    [sym_block_argument] = STATE(4986),
    [sym_assignment] = STATE(9588),
    [sym_operator_assignment] = STATE(9588),
    [sym_conditional] = STATE(9588),
    [sym_range] = STATE(9588),
    [sym_binary] = STATE(9588),
    [sym_unary] = STATE(9588),
    [sym_left_assignment_list] = STATE(9592),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9593),
    [sym__variable] = STATE(9589),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9593),
    [sym_false] = STATE(9593),
    [sym_nil] = STATE(9593),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(9594),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4986),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(13282),
    [sym__splat_star] = ACTIONS(13284),
    [sym__unary_minus] = ACTIONS(13286),
    [sym__identifier_hash_key] = ACTIONS(13288),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(14879),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13290),
    [anon_sym_yield] = ACTIONS(13292),
    [anon_sym_break] = ACTIONS(13294),
    [anon_sym_next] = ACTIONS(13296),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14176),
    [anon_sym_defined_QMARK] = ACTIONS(13298),
    [anon_sym_not] = ACTIONS(13300),
    [anon_sym_BANG] = ACTIONS(13304),
    [anon_sym_TILDE] = ACTIONS(13304),
    [sym_constant] = ACTIONS(13306),
    [sym_identifier] = ACTIONS(13306),
    [sym_instance_variable] = ACTIONS(13308),
    [sym_class_variable] = ACTIONS(13308),
    [sym_global_variable] = ACTIONS(13308),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(13310),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13310),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10982] = {
    [sym_heredoc_body] = STATE(10980),
    [aux_sym_call_repeat1] = STATE(10980),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_end] = ACTIONS(7929),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_when] = ACTIONS(7929),
    [anon_sym_else] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [10983] = {
    [aux_sym_argument_list_repeat1] = STATE(10983),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(15199),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7925),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_end] = ACTIONS(7925),
    [anon_sym_if] = ACTIONS(7925),
    [anon_sym_unless] = ACTIONS(7925),
    [anon_sym_while] = ACTIONS(7925),
    [anon_sym_until] = ACTIONS(7925),
    [anon_sym_rescue] = ACTIONS(7925),
    [anon_sym_when] = ACTIONS(7925),
    [anon_sym_else] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7925),
    [anon_sym_AMP_AMP] = ACTIONS(7925),
    [anon_sym_LT_LT] = ACTIONS(7925),
    [anon_sym_GT_GT] = ACTIONS(7925),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7925),
    [anon_sym_PLUS] = ACTIONS(7925),
    [anon_sym_SLASH] = ACTIONS(7925),
    [anon_sym_PERCENT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [10984] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(14190),
    [sym__binary_star] = ACTIONS(14192),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(14194),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(14192),
    [anon_sym_AMP] = ACTIONS(14196),
    [anon_sym_LT] = ACTIONS(14198),
    [anon_sym_end] = ACTIONS(5115),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_when] = ACTIONS(5115),
    [anon_sym_else] = ACTIONS(5115),
    [anon_sym_EQ_GT] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(14200),
    [anon_sym_DOT_DOT] = ACTIONS(14202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14204),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(14206),
    [anon_sym_AMP_AMP] = ACTIONS(14206),
    [anon_sym_LT_LT] = ACTIONS(14208),
    [anon_sym_GT_GT] = ACTIONS(14208),
    [anon_sym_EQ_EQ] = ACTIONS(14210),
    [anon_sym_BANG_EQ] = ACTIONS(14206),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14206),
    [anon_sym_LT_EQ_GT] = ACTIONS(14206),
    [anon_sym_EQ_TILDE] = ACTIONS(14206),
    [anon_sym_BANG_TILDE] = ACTIONS(14206),
    [anon_sym_LT_EQ] = ACTIONS(14198),
    [anon_sym_GT] = ACTIONS(14198),
    [anon_sym_GT_EQ] = ACTIONS(14212),
    [anon_sym_CARET] = ACTIONS(14214),
    [anon_sym_PLUS] = ACTIONS(14190),
    [anon_sym_SLASH] = ACTIONS(14192),
    [anon_sym_PERCENT] = ACTIONS(14192),
    [sym_comment] = ACTIONS(87),
  },
  [10985] = {
    [aux_sym_exceptions_repeat1] = STATE(11232),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_end] = ACTIONS(6191),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_when] = ACTIONS(6191),
    [anon_sym_else] = ACTIONS(6191),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [10986] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(14190),
    [sym__binary_star] = ACTIONS(14192),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(14194),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(14192),
    [anon_sym_AMP] = ACTIONS(14196),
    [anon_sym_LT] = ACTIONS(14198),
    [anon_sym_end] = ACTIONS(6210),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_when] = ACTIONS(6210),
    [anon_sym_else] = ACTIONS(6210),
    [anon_sym_EQ_GT] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(14200),
    [anon_sym_DOT_DOT] = ACTIONS(14202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14204),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(14206),
    [anon_sym_AMP_AMP] = ACTIONS(14206),
    [anon_sym_LT_LT] = ACTIONS(14208),
    [anon_sym_GT_GT] = ACTIONS(14208),
    [anon_sym_EQ_EQ] = ACTIONS(14210),
    [anon_sym_BANG_EQ] = ACTIONS(14206),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14206),
    [anon_sym_LT_EQ_GT] = ACTIONS(14206),
    [anon_sym_EQ_TILDE] = ACTIONS(14206),
    [anon_sym_BANG_TILDE] = ACTIONS(14206),
    [anon_sym_LT_EQ] = ACTIONS(14198),
    [anon_sym_GT] = ACTIONS(14198),
    [anon_sym_GT_EQ] = ACTIONS(14212),
    [anon_sym_CARET] = ACTIONS(14214),
    [anon_sym_PLUS] = ACTIONS(14190),
    [anon_sym_SLASH] = ACTIONS(14192),
    [anon_sym_PERCENT] = ACTIONS(14192),
    [sym_comment] = ACTIONS(87),
  },
  [10987] = {
    [sym_string] = STATE(10987),
    [aux_sym_chained_string_repeat1] = STATE(10987),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(6214),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_end] = ACTIONS(6212),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_when] = ACTIONS(6212),
    [anon_sym_else] = ACTIONS(6212),
    [anon_sym_EQ_GT] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [10988] = {
    [aux_sym_undef_repeat1] = STATE(10988),
    [sym__line_break] = ACTIONS(9263),
    [sym__heredoc_body_start] = ACTIONS(9263),
    [anon_sym_COMMA] = ACTIONS(9265),
    [anon_sym_SEMI] = ACTIONS(9263),
    [anon_sym_end] = ACTIONS(9263),
    [anon_sym_if] = ACTIONS(9263),
    [anon_sym_unless] = ACTIONS(9263),
    [anon_sym_while] = ACTIONS(9263),
    [anon_sym_until] = ACTIONS(9263),
    [anon_sym_rescue] = ACTIONS(9263),
    [anon_sym_when] = ACTIONS(9263),
    [anon_sym_else] = ACTIONS(9263),
    [sym_comment] = ACTIONS(87),
  },
  [10989] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(11233),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(7930),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(7930),
    [sym_assignment] = STATE(11233),
    [sym_operator_assignment] = STATE(11233),
    [sym_conditional] = STATE(11233),
    [sym_range] = STATE(11233),
    [sym_binary] = STATE(11233),
    [sym_unary] = STATE(11233),
    [sym_left_assignment_list] = STATE(7929),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7930),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(7930),
    [sym_false] = STATE(7930),
    [sym_nil] = STATE(7930),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(7931),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11428),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11430),
    [anon_sym_yield] = ACTIONS(11432),
    [anon_sym_break] = ACTIONS(11434),
    [anon_sym_next] = ACTIONS(11436),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11438),
    [anon_sym_defined_QMARK] = ACTIONS(11440),
    [anon_sym_not] = ACTIONS(11442),
    [anon_sym_BANG] = ACTIONS(11444),
    [anon_sym_TILDE] = ACTIONS(11444),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10990] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(14889),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_when] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [10991] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(14883),
    [sym__binary_star] = ACTIONS(14885),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(14887),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(14889),
    [anon_sym_AMP] = ACTIONS(14891),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(14893),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_when] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(14895),
    [anon_sym_DOT_DOT] = ACTIONS(14897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14899),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(14901),
    [anon_sym_AMP_AMP] = ACTIONS(14901),
    [anon_sym_LT_LT] = ACTIONS(14903),
    [anon_sym_GT_GT] = ACTIONS(14903),
    [anon_sym_EQ_EQ] = ACTIONS(14901),
    [anon_sym_BANG_EQ] = ACTIONS(14905),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14905),
    [anon_sym_LT_EQ_GT] = ACTIONS(14905),
    [anon_sym_EQ_TILDE] = ACTIONS(14905),
    [anon_sym_BANG_TILDE] = ACTIONS(14905),
    [anon_sym_LT_EQ] = ACTIONS(14893),
    [anon_sym_GT] = ACTIONS(14893),
    [anon_sym_GT_EQ] = ACTIONS(14907),
    [anon_sym_CARET] = ACTIONS(14887),
    [anon_sym_PLUS] = ACTIONS(14909),
    [anon_sym_SLASH] = ACTIONS(14889),
    [anon_sym_PERCENT] = ACTIONS(14889),
    [sym_comment] = ACTIONS(87),
  },
  [10992] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(11234),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(10569),
    [sym_scope_resolution] = STATE(10567),
    [sym_call] = STATE(10567),
    [sym_method_call] = STATE(10569),
    [sym_assignment] = STATE(11234),
    [sym_operator_assignment] = STATE(11234),
    [sym_conditional] = STATE(11234),
    [sym_range] = STATE(11234),
    [sym_binary] = STATE(11234),
    [sym_unary] = STATE(11234),
    [sym_left_assignment_list] = STATE(10568),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10569),
    [sym__variable] = STATE(10567),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(10569),
    [sym_false] = STATE(10569),
    [sym_nil] = STATE(10569),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(10570),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(14234),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(14236),
    [anon_sym_yield] = ACTIONS(14238),
    [anon_sym_break] = ACTIONS(14240),
    [anon_sym_next] = ACTIONS(14242),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(14244),
    [anon_sym_defined_QMARK] = ACTIONS(14246),
    [anon_sym_not] = ACTIONS(14248),
    [anon_sym_BANG] = ACTIONS(14250),
    [anon_sym_TILDE] = ACTIONS(14250),
    [sym_constant] = ACTIONS(14252),
    [sym_identifier] = ACTIONS(14252),
    [sym_instance_variable] = ACTIONS(14254),
    [sym_class_variable] = ACTIONS(14254),
    [sym_global_variable] = ACTIONS(14254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(14252),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(14252),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [10993] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(11235),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(10569),
    [sym_scope_resolution] = STATE(10567),
    [sym_call] = STATE(10567),
    [sym_method_call] = STATE(10569),
    [sym_assignment] = STATE(11235),
    [sym_operator_assignment] = STATE(11235),
    [sym_conditional] = STATE(11235),
    [sym_range] = STATE(11235),
    [sym_binary] = STATE(11235),
    [sym_unary] = STATE(11235),
    [sym_left_assignment_list] = STATE(10568),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10569),
    [sym__variable] = STATE(10567),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(10569),
    [sym_false] = STATE(10569),
    [sym_nil] = STATE(10569),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(10570),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(14234),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(14236),
    [anon_sym_yield] = ACTIONS(14238),
    [anon_sym_break] = ACTIONS(14240),
    [anon_sym_next] = ACTIONS(14242),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(14244),
    [anon_sym_defined_QMARK] = ACTIONS(14246),
    [anon_sym_not] = ACTIONS(14248),
    [anon_sym_BANG] = ACTIONS(14250),
    [anon_sym_TILDE] = ACTIONS(14250),
    [sym_constant] = ACTIONS(14252),
    [sym_identifier] = ACTIONS(14252),
    [sym_instance_variable] = ACTIONS(14254),
    [sym_class_variable] = ACTIONS(14254),
    [sym_global_variable] = ACTIONS(14254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(14252),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(14252),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [10994] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(11236),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(10569),
    [sym_scope_resolution] = STATE(10567),
    [sym_call] = STATE(10567),
    [sym_method_call] = STATE(10569),
    [sym_assignment] = STATE(11236),
    [sym_operator_assignment] = STATE(11236),
    [sym_conditional] = STATE(11236),
    [sym_range] = STATE(11236),
    [sym_binary] = STATE(11236),
    [sym_unary] = STATE(11236),
    [sym_left_assignment_list] = STATE(10568),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10569),
    [sym__variable] = STATE(10567),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(10569),
    [sym_false] = STATE(10569),
    [sym_nil] = STATE(10569),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(10570),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(14234),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(14236),
    [anon_sym_yield] = ACTIONS(14238),
    [anon_sym_break] = ACTIONS(14240),
    [anon_sym_next] = ACTIONS(14242),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(14244),
    [anon_sym_defined_QMARK] = ACTIONS(14246),
    [anon_sym_not] = ACTIONS(14248),
    [anon_sym_BANG] = ACTIONS(14250),
    [anon_sym_TILDE] = ACTIONS(14250),
    [sym_constant] = ACTIONS(14252),
    [sym_identifier] = ACTIONS(14252),
    [sym_instance_variable] = ACTIONS(14254),
    [sym_class_variable] = ACTIONS(14254),
    [sym_global_variable] = ACTIONS(14254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(14252),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(14252),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [10995] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(11237),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(10569),
    [sym_scope_resolution] = STATE(10567),
    [sym_call] = STATE(10567),
    [sym_method_call] = STATE(10569),
    [sym_assignment] = STATE(11237),
    [sym_operator_assignment] = STATE(11237),
    [sym_conditional] = STATE(11237),
    [sym_range] = STATE(11237),
    [sym_binary] = STATE(11237),
    [sym_unary] = STATE(11237),
    [sym_left_assignment_list] = STATE(10568),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10569),
    [sym__variable] = STATE(10567),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(10569),
    [sym_false] = STATE(10569),
    [sym_nil] = STATE(10569),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(10570),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(14234),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(14236),
    [anon_sym_yield] = ACTIONS(14238),
    [anon_sym_break] = ACTIONS(14240),
    [anon_sym_next] = ACTIONS(14242),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(14244),
    [anon_sym_defined_QMARK] = ACTIONS(14246),
    [anon_sym_not] = ACTIONS(14248),
    [anon_sym_BANG] = ACTIONS(14250),
    [anon_sym_TILDE] = ACTIONS(14250),
    [sym_constant] = ACTIONS(14252),
    [sym_identifier] = ACTIONS(14252),
    [sym_instance_variable] = ACTIONS(14254),
    [sym_class_variable] = ACTIONS(14254),
    [sym_global_variable] = ACTIONS(14254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(14252),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(14252),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [10996] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(11238),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(10569),
    [sym_scope_resolution] = STATE(10567),
    [sym_call] = STATE(10567),
    [sym_method_call] = STATE(10569),
    [sym_assignment] = STATE(11238),
    [sym_operator_assignment] = STATE(11238),
    [sym_conditional] = STATE(11238),
    [sym_range] = STATE(11238),
    [sym_binary] = STATE(11238),
    [sym_unary] = STATE(11238),
    [sym_left_assignment_list] = STATE(10568),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10569),
    [sym__variable] = STATE(10567),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(10569),
    [sym_false] = STATE(10569),
    [sym_nil] = STATE(10569),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(10570),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(14234),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(14236),
    [anon_sym_yield] = ACTIONS(14238),
    [anon_sym_break] = ACTIONS(14240),
    [anon_sym_next] = ACTIONS(14242),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(14244),
    [anon_sym_defined_QMARK] = ACTIONS(14246),
    [anon_sym_not] = ACTIONS(14248),
    [anon_sym_BANG] = ACTIONS(14250),
    [anon_sym_TILDE] = ACTIONS(14250),
    [sym_constant] = ACTIONS(14252),
    [sym_identifier] = ACTIONS(14252),
    [sym_instance_variable] = ACTIONS(14254),
    [sym_class_variable] = ACTIONS(14254),
    [sym_global_variable] = ACTIONS(14254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(14252),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(14252),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [10997] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(11239),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(11239),
    [sym_operator_assignment] = STATE(11239),
    [sym_conditional] = STATE(11239),
    [sym_range] = STATE(11239),
    [sym_binary] = STATE(11239),
    [sym_unary] = STATE(11239),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [10998] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(11240),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(10569),
    [sym_scope_resolution] = STATE(10567),
    [sym_call] = STATE(10567),
    [sym_method_call] = STATE(10569),
    [sym_assignment] = STATE(11240),
    [sym_operator_assignment] = STATE(11240),
    [sym_conditional] = STATE(11240),
    [sym_range] = STATE(11240),
    [sym_binary] = STATE(11240),
    [sym_unary] = STATE(11240),
    [sym_left_assignment_list] = STATE(10568),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10569),
    [sym__variable] = STATE(10567),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(10569),
    [sym_false] = STATE(10569),
    [sym_nil] = STATE(10569),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(10570),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(14234),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(14236),
    [anon_sym_yield] = ACTIONS(14238),
    [anon_sym_break] = ACTIONS(14240),
    [anon_sym_next] = ACTIONS(14242),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(14244),
    [anon_sym_defined_QMARK] = ACTIONS(14246),
    [anon_sym_not] = ACTIONS(14248),
    [anon_sym_BANG] = ACTIONS(14250),
    [anon_sym_TILDE] = ACTIONS(14250),
    [sym_constant] = ACTIONS(14252),
    [sym_identifier] = ACTIONS(14252),
    [sym_instance_variable] = ACTIONS(14254),
    [sym_class_variable] = ACTIONS(14254),
    [sym_global_variable] = ACTIONS(14254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(14252),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(14252),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [10999] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(11241),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(10569),
    [sym_scope_resolution] = STATE(10567),
    [sym_call] = STATE(10567),
    [sym_method_call] = STATE(10569),
    [sym_assignment] = STATE(11241),
    [sym_operator_assignment] = STATE(11241),
    [sym_conditional] = STATE(11241),
    [sym_range] = STATE(11241),
    [sym_binary] = STATE(11241),
    [sym_unary] = STATE(11241),
    [sym_left_assignment_list] = STATE(10568),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10569),
    [sym__variable] = STATE(10567),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(10569),
    [sym_false] = STATE(10569),
    [sym_nil] = STATE(10569),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(10570),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(14234),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(14236),
    [anon_sym_yield] = ACTIONS(14238),
    [anon_sym_break] = ACTIONS(14240),
    [anon_sym_next] = ACTIONS(14242),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(14244),
    [anon_sym_defined_QMARK] = ACTIONS(14246),
    [anon_sym_not] = ACTIONS(14248),
    [anon_sym_BANG] = ACTIONS(14250),
    [anon_sym_TILDE] = ACTIONS(14250),
    [sym_constant] = ACTIONS(14252),
    [sym_identifier] = ACTIONS(14252),
    [sym_instance_variable] = ACTIONS(14254),
    [sym_class_variable] = ACTIONS(14254),
    [sym_global_variable] = ACTIONS(14254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(14252),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(14252),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [11000] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(11242),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(10569),
    [sym_scope_resolution] = STATE(10567),
    [sym_call] = STATE(10567),
    [sym_method_call] = STATE(10569),
    [sym_assignment] = STATE(11242),
    [sym_operator_assignment] = STATE(11242),
    [sym_conditional] = STATE(11242),
    [sym_range] = STATE(11242),
    [sym_binary] = STATE(11242),
    [sym_unary] = STATE(11242),
    [sym_left_assignment_list] = STATE(10568),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10569),
    [sym__variable] = STATE(10567),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(10569),
    [sym_false] = STATE(10569),
    [sym_nil] = STATE(10569),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(10570),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(14234),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(14236),
    [anon_sym_yield] = ACTIONS(14238),
    [anon_sym_break] = ACTIONS(14240),
    [anon_sym_next] = ACTIONS(14242),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(14244),
    [anon_sym_defined_QMARK] = ACTIONS(14246),
    [anon_sym_not] = ACTIONS(14248),
    [anon_sym_BANG] = ACTIONS(14250),
    [anon_sym_TILDE] = ACTIONS(14250),
    [sym_constant] = ACTIONS(14252),
    [sym_identifier] = ACTIONS(14252),
    [sym_instance_variable] = ACTIONS(14254),
    [sym_class_variable] = ACTIONS(14254),
    [sym_global_variable] = ACTIONS(14254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(14252),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(14252),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [11001] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(11243),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(10569),
    [sym_scope_resolution] = STATE(10567),
    [sym_call] = STATE(10567),
    [sym_method_call] = STATE(10569),
    [sym_assignment] = STATE(11243),
    [sym_operator_assignment] = STATE(11243),
    [sym_conditional] = STATE(11243),
    [sym_range] = STATE(11243),
    [sym_binary] = STATE(11243),
    [sym_unary] = STATE(11243),
    [sym_left_assignment_list] = STATE(10568),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10569),
    [sym__variable] = STATE(10567),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(10569),
    [sym_false] = STATE(10569),
    [sym_nil] = STATE(10569),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(10570),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(14234),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(14236),
    [anon_sym_yield] = ACTIONS(14238),
    [anon_sym_break] = ACTIONS(14240),
    [anon_sym_next] = ACTIONS(14242),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(14244),
    [anon_sym_defined_QMARK] = ACTIONS(14246),
    [anon_sym_not] = ACTIONS(14248),
    [anon_sym_BANG] = ACTIONS(14250),
    [anon_sym_TILDE] = ACTIONS(14250),
    [sym_constant] = ACTIONS(14252),
    [sym_identifier] = ACTIONS(14252),
    [sym_instance_variable] = ACTIONS(14254),
    [sym_class_variable] = ACTIONS(14254),
    [sym_global_variable] = ACTIONS(14254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(14252),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(14252),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [11002] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(11244),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(10569),
    [sym_scope_resolution] = STATE(10567),
    [sym_call] = STATE(10567),
    [sym_method_call] = STATE(10569),
    [sym_splat_argument] = STATE(11245),
    [sym_assignment] = STATE(11244),
    [sym_operator_assignment] = STATE(11244),
    [sym_conditional] = STATE(11244),
    [sym_range] = STATE(11244),
    [sym_binary] = STATE(11244),
    [sym_unary] = STATE(11244),
    [sym_right_assignment_list] = STATE(6323),
    [sym__arg_or_splat_arg] = STATE(11245),
    [sym_left_assignment_list] = STATE(10568),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10569),
    [sym__variable] = STATE(10567),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(10569),
    [sym_false] = STATE(10569),
    [sym_nil] = STATE(10569),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(10570),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__splat_star] = ACTIONS(13354),
    [sym__unary_minus] = ACTIONS(14234),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(14236),
    [anon_sym_yield] = ACTIONS(14238),
    [anon_sym_break] = ACTIONS(14240),
    [anon_sym_next] = ACTIONS(14242),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(14244),
    [anon_sym_defined_QMARK] = ACTIONS(14246),
    [anon_sym_not] = ACTIONS(14248),
    [anon_sym_BANG] = ACTIONS(14250),
    [anon_sym_TILDE] = ACTIONS(14250),
    [sym_constant] = ACTIONS(14252),
    [sym_identifier] = ACTIONS(14252),
    [sym_instance_variable] = ACTIONS(14254),
    [sym_class_variable] = ACTIONS(14254),
    [sym_global_variable] = ACTIONS(14254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(14252),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(14252),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [11003] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(11246),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(10569),
    [sym_scope_resolution] = STATE(10567),
    [sym_call] = STATE(10567),
    [sym_method_call] = STATE(10569),
    [sym_assignment] = STATE(11246),
    [sym_operator_assignment] = STATE(11246),
    [sym_conditional] = STATE(11246),
    [sym_range] = STATE(11246),
    [sym_binary] = STATE(11246),
    [sym_unary] = STATE(11246),
    [sym_left_assignment_list] = STATE(10568),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10569),
    [sym__variable] = STATE(10567),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(10569),
    [sym_false] = STATE(10569),
    [sym_nil] = STATE(10569),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(10570),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(14234),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(14236),
    [anon_sym_yield] = ACTIONS(14238),
    [anon_sym_break] = ACTIONS(14240),
    [anon_sym_next] = ACTIONS(14242),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(14244),
    [anon_sym_defined_QMARK] = ACTIONS(14246),
    [anon_sym_not] = ACTIONS(14248),
    [anon_sym_BANG] = ACTIONS(14250),
    [anon_sym_TILDE] = ACTIONS(14250),
    [sym_constant] = ACTIONS(14252),
    [sym_identifier] = ACTIONS(14252),
    [sym_instance_variable] = ACTIONS(14254),
    [sym_class_variable] = ACTIONS(14254),
    [sym_global_variable] = ACTIONS(14254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(14252),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(14252),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [11004] = {
    [sym_string] = STATE(11247),
    [aux_sym_chained_string_repeat1] = STATE(11247),
    [sym__line_break] = ACTIONS(2753),
    [sym__string_start] = ACTIONS(2551),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2755),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_EQ] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_end] = ACTIONS(2753),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_unless] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_until] = ACTIONS(2753),
    [anon_sym_rescue] = ACTIONS(2753),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_when] = ACTIONS(2753),
    [anon_sym_else] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_PLUS_EQ] = ACTIONS(2753),
    [anon_sym_DASH_EQ] = ACTIONS(2753),
    [anon_sym_STAR_EQ] = ACTIONS(2753),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2753),
    [anon_sym_SLASH_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2753),
    [anon_sym_AMP_EQ] = ACTIONS(2753),
    [anon_sym_PERCENT_EQ] = ACTIONS(2753),
    [anon_sym_GT_GT_EQ] = ACTIONS(2753),
    [anon_sym_LT_LT_EQ] = ACTIONS(2753),
    [anon_sym_CARET_EQ] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2755),
    [anon_sym_AMP_AMP] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2755),
    [anon_sym_GT_GT] = ACTIONS(2755),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_SLASH] = ACTIONS(2755),
    [anon_sym_PERCENT] = ACTIONS(2755),
    [sym_comment] = ACTIONS(87),
  },
  [11005] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(14883),
    [sym__binary_star] = ACTIONS(14885),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(14887),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(14889),
    [anon_sym_AMP] = ACTIONS(14891),
    [anon_sym_EQ] = ACTIONS(7822),
    [anon_sym_LT] = ACTIONS(14893),
    [anon_sym_end] = ACTIONS(6823),
    [anon_sym_if] = ACTIONS(6823),
    [anon_sym_unless] = ACTIONS(6823),
    [anon_sym_while] = ACTIONS(6823),
    [anon_sym_until] = ACTIONS(6823),
    [anon_sym_rescue] = ACTIONS(6823),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_when] = ACTIONS(6823),
    [anon_sym_else] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_PLUS_EQ] = ACTIONS(6823),
    [anon_sym_DASH_EQ] = ACTIONS(6823),
    [anon_sym_STAR_EQ] = ACTIONS(6823),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6823),
    [anon_sym_SLASH_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6823),
    [anon_sym_AMP_EQ] = ACTIONS(6823),
    [anon_sym_PERCENT_EQ] = ACTIONS(6823),
    [anon_sym_GT_GT_EQ] = ACTIONS(6823),
    [anon_sym_LT_LT_EQ] = ACTIONS(6823),
    [anon_sym_CARET_EQ] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(14895),
    [anon_sym_DOT_DOT] = ACTIONS(14897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14899),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(14901),
    [anon_sym_AMP_AMP] = ACTIONS(14901),
    [anon_sym_LT_LT] = ACTIONS(14903),
    [anon_sym_GT_GT] = ACTIONS(14903),
    [anon_sym_EQ_EQ] = ACTIONS(14901),
    [anon_sym_BANG_EQ] = ACTIONS(14905),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14905),
    [anon_sym_LT_EQ_GT] = ACTIONS(14905),
    [anon_sym_EQ_TILDE] = ACTIONS(14905),
    [anon_sym_BANG_TILDE] = ACTIONS(14905),
    [anon_sym_LT_EQ] = ACTIONS(14893),
    [anon_sym_GT] = ACTIONS(14893),
    [anon_sym_GT_EQ] = ACTIONS(14907),
    [anon_sym_CARET] = ACTIONS(14887),
    [anon_sym_PLUS] = ACTIONS(14909),
    [anon_sym_SLASH] = ACTIONS(14889),
    [anon_sym_PERCENT] = ACTIONS(14889),
    [sym_comment] = ACTIONS(87),
  },
  [11006] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(14883),
    [sym__binary_star] = ACTIONS(14885),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(14887),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(14889),
    [anon_sym_AMP] = ACTIONS(14891),
    [anon_sym_EQ] = ACTIONS(7884),
    [anon_sym_LT] = ACTIONS(14893),
    [anon_sym_end] = ACTIONS(7027),
    [anon_sym_if] = ACTIONS(7027),
    [anon_sym_unless] = ACTIONS(7027),
    [anon_sym_while] = ACTIONS(7027),
    [anon_sym_until] = ACTIONS(7027),
    [anon_sym_rescue] = ACTIONS(7027),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_when] = ACTIONS(7027),
    [anon_sym_else] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_PLUS_EQ] = ACTIONS(7027),
    [anon_sym_DASH_EQ] = ACTIONS(7027),
    [anon_sym_STAR_EQ] = ACTIONS(7027),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7027),
    [anon_sym_SLASH_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7027),
    [anon_sym_AMP_EQ] = ACTIONS(7027),
    [anon_sym_PERCENT_EQ] = ACTIONS(7027),
    [anon_sym_GT_GT_EQ] = ACTIONS(7027),
    [anon_sym_LT_LT_EQ] = ACTIONS(7027),
    [anon_sym_CARET_EQ] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(14895),
    [anon_sym_DOT_DOT] = ACTIONS(14897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14899),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(14901),
    [anon_sym_AMP_AMP] = ACTIONS(14901),
    [anon_sym_LT_LT] = ACTIONS(14903),
    [anon_sym_GT_GT] = ACTIONS(14903),
    [anon_sym_EQ_EQ] = ACTIONS(14901),
    [anon_sym_BANG_EQ] = ACTIONS(14905),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14905),
    [anon_sym_LT_EQ_GT] = ACTIONS(14905),
    [anon_sym_EQ_TILDE] = ACTIONS(14905),
    [anon_sym_BANG_TILDE] = ACTIONS(14905),
    [anon_sym_LT_EQ] = ACTIONS(14893),
    [anon_sym_GT] = ACTIONS(14893),
    [anon_sym_GT_EQ] = ACTIONS(14907),
    [anon_sym_CARET] = ACTIONS(14887),
    [anon_sym_PLUS] = ACTIONS(14909),
    [anon_sym_SLASH] = ACTIONS(14889),
    [anon_sym_PERCENT] = ACTIONS(14889),
    [sym_comment] = ACTIONS(87),
  },
  [11007] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(14264),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(14268),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_when] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(14268),
    [anon_sym_PERCENT] = ACTIONS(14268),
    [sym_comment] = ACTIONS(87),
  },
  [11008] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(14268),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_when] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(5827),
    [anon_sym_PERCENT] = ACTIONS(5827),
    [sym_comment] = ACTIONS(87),
  },
  [11009] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(14262),
    [sym__binary_star] = ACTIONS(14264),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(14268),
    [anon_sym_AMP] = ACTIONS(14270),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_when] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(14282),
    [anon_sym_GT_GT] = ACTIONS(14282),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(14288),
    [anon_sym_SLASH] = ACTIONS(14268),
    [anon_sym_PERCENT] = ACTIONS(14268),
    [sym_comment] = ACTIONS(87),
  },
  [11010] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(14262),
    [sym__binary_star] = ACTIONS(14264),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(14268),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_when] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(14282),
    [anon_sym_GT_GT] = ACTIONS(14282),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(14288),
    [anon_sym_SLASH] = ACTIONS(14268),
    [anon_sym_PERCENT] = ACTIONS(14268),
    [sym_comment] = ACTIONS(87),
  },
  [11011] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(14262),
    [sym__binary_star] = ACTIONS(14264),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(14266),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(14268),
    [anon_sym_AMP] = ACTIONS(14270),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_when] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(14282),
    [anon_sym_GT_GT] = ACTIONS(14282),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(14266),
    [anon_sym_PLUS] = ACTIONS(14288),
    [anon_sym_SLASH] = ACTIONS(14268),
    [anon_sym_PERCENT] = ACTIONS(14268),
    [sym_comment] = ACTIONS(87),
  },
  [11012] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(15202),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [11013] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(14262),
    [sym__binary_star] = ACTIONS(14264),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(14266),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(14268),
    [anon_sym_AMP] = ACTIONS(14270),
    [anon_sym_EQ] = ACTIONS(7888),
    [anon_sym_LT] = ACTIONS(14272),
    [anon_sym_end] = ACTIONS(5927),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_when] = ACTIONS(5927),
    [anon_sym_else] = ACTIONS(5927),
    [anon_sym_EQ_GT] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_PLUS_EQ] = ACTIONS(5927),
    [anon_sym_DASH_EQ] = ACTIONS(5927),
    [anon_sym_STAR_EQ] = ACTIONS(5927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5927),
    [anon_sym_SLASH_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5927),
    [anon_sym_AMP_EQ] = ACTIONS(5927),
    [anon_sym_PERCENT_EQ] = ACTIONS(5927),
    [anon_sym_GT_GT_EQ] = ACTIONS(5927),
    [anon_sym_LT_LT_EQ] = ACTIONS(5927),
    [anon_sym_CARET_EQ] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(14276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14278),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(14280),
    [anon_sym_AMP_AMP] = ACTIONS(14280),
    [anon_sym_LT_LT] = ACTIONS(14282),
    [anon_sym_GT_GT] = ACTIONS(14282),
    [anon_sym_EQ_EQ] = ACTIONS(14280),
    [anon_sym_BANG_EQ] = ACTIONS(14284),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14284),
    [anon_sym_LT_EQ_GT] = ACTIONS(14284),
    [anon_sym_EQ_TILDE] = ACTIONS(14284),
    [anon_sym_BANG_TILDE] = ACTIONS(14284),
    [anon_sym_LT_EQ] = ACTIONS(14272),
    [anon_sym_GT] = ACTIONS(14272),
    [anon_sym_GT_EQ] = ACTIONS(14286),
    [anon_sym_CARET] = ACTIONS(14266),
    [anon_sym_PLUS] = ACTIONS(14288),
    [anon_sym_SLASH] = ACTIONS(14268),
    [anon_sym_PERCENT] = ACTIONS(14268),
    [sym_comment] = ACTIONS(87),
  },
  [11014] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(14262),
    [sym__binary_star] = ACTIONS(14264),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(14266),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(14268),
    [anon_sym_AMP] = ACTIONS(14270),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(14272),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_when] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(14274),
    [anon_sym_DOT_DOT] = ACTIONS(14276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14278),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(14280),
    [anon_sym_AMP_AMP] = ACTIONS(14280),
    [anon_sym_LT_LT] = ACTIONS(14282),
    [anon_sym_GT_GT] = ACTIONS(14282),
    [anon_sym_EQ_EQ] = ACTIONS(14280),
    [anon_sym_BANG_EQ] = ACTIONS(14284),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14284),
    [anon_sym_LT_EQ_GT] = ACTIONS(14284),
    [anon_sym_EQ_TILDE] = ACTIONS(14284),
    [anon_sym_BANG_TILDE] = ACTIONS(14284),
    [anon_sym_LT_EQ] = ACTIONS(14272),
    [anon_sym_GT] = ACTIONS(14272),
    [anon_sym_GT_EQ] = ACTIONS(14286),
    [anon_sym_CARET] = ACTIONS(14266),
    [anon_sym_PLUS] = ACTIONS(14288),
    [anon_sym_SLASH] = ACTIONS(14268),
    [anon_sym_PERCENT] = ACTIONS(14268),
    [sym_comment] = ACTIONS(87),
  },
  [11015] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(14262),
    [sym__binary_star] = ACTIONS(14264),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(14266),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(14268),
    [anon_sym_AMP] = ACTIONS(14270),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(14272),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_when] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(14282),
    [anon_sym_GT_GT] = ACTIONS(14282),
    [anon_sym_EQ_EQ] = ACTIONS(14280),
    [anon_sym_BANG_EQ] = ACTIONS(14284),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14284),
    [anon_sym_LT_EQ_GT] = ACTIONS(14284),
    [anon_sym_EQ_TILDE] = ACTIONS(14284),
    [anon_sym_BANG_TILDE] = ACTIONS(14284),
    [anon_sym_LT_EQ] = ACTIONS(14272),
    [anon_sym_GT] = ACTIONS(14272),
    [anon_sym_GT_EQ] = ACTIONS(14286),
    [anon_sym_CARET] = ACTIONS(14266),
    [anon_sym_PLUS] = ACTIONS(14288),
    [anon_sym_SLASH] = ACTIONS(14268),
    [anon_sym_PERCENT] = ACTIONS(14268),
    [sym_comment] = ACTIONS(87),
  },
  [11016] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(14262),
    [sym__binary_star] = ACTIONS(14264),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(14268),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_when] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(14288),
    [anon_sym_SLASH] = ACTIONS(14268),
    [anon_sym_PERCENT] = ACTIONS(14268),
    [sym_comment] = ACTIONS(87),
  },
  [11017] = {
    [sym_heredoc_body] = STATE(11017),
    [aux_sym_call_repeat1] = STATE(11017),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(9846),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7919),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_EQ] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_end] = ACTIONS(7914),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_when] = ACTIONS(7914),
    [anon_sym_else] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_PLUS_EQ] = ACTIONS(7914),
    [anon_sym_DASH_EQ] = ACTIONS(7914),
    [anon_sym_STAR_EQ] = ACTIONS(7914),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7914),
    [anon_sym_SLASH_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7914),
    [anon_sym_AMP_EQ] = ACTIONS(7914),
    [anon_sym_PERCENT_EQ] = ACTIONS(7914),
    [anon_sym_GT_GT_EQ] = ACTIONS(7914),
    [anon_sym_LT_LT_EQ] = ACTIONS(7914),
    [anon_sym_CARET_EQ] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7919),
    [anon_sym_AMP_AMP] = ACTIONS(7919),
    [anon_sym_LT_LT] = ACTIONS(7919),
    [anon_sym_GT_GT] = ACTIONS(7919),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7919),
    [anon_sym_PLUS] = ACTIONS(7919),
    [anon_sym_SLASH] = ACTIONS(7919),
    [anon_sym_PERCENT] = ACTIONS(7919),
    [sym_comment] = ACTIONS(87),
  },
  [11018] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(9624),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(9629),
    [sym_scope_resolution] = STATE(9625),
    [sym_call] = STATE(9625),
    [sym_method_call] = STATE(9629),
    [sym__argument] = STATE(6393),
    [sym_splat_argument] = STATE(6393),
    [sym_hash_splat_argument] = STATE(6393),
    [sym_block_argument] = STATE(6393),
    [sym_assignment] = STATE(9624),
    [sym_operator_assignment] = STATE(9624),
    [sym_conditional] = STATE(9624),
    [sym_range] = STATE(9624),
    [sym_binary] = STATE(9624),
    [sym_unary] = STATE(9624),
    [sym_left_assignment_list] = STATE(9628),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9629),
    [sym__variable] = STATE(9625),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(9629),
    [sym_false] = STATE(9629),
    [sym_nil] = STATE(9629),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(9630),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(6393),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(13352),
    [sym__splat_star] = ACTIONS(13354),
    [sym__unary_minus] = ACTIONS(13356),
    [sym__identifier_hash_key] = ACTIONS(13358),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(14917),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(13360),
    [anon_sym_yield] = ACTIONS(13362),
    [anon_sym_break] = ACTIONS(13364),
    [anon_sym_next] = ACTIONS(13366),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(14256),
    [anon_sym_defined_QMARK] = ACTIONS(13368),
    [anon_sym_not] = ACTIONS(13370),
    [anon_sym_BANG] = ACTIONS(13374),
    [anon_sym_TILDE] = ACTIONS(13374),
    [sym_constant] = ACTIONS(13376),
    [sym_identifier] = ACTIONS(13376),
    [sym_instance_variable] = ACTIONS(13378),
    [sym_class_variable] = ACTIONS(13378),
    [sym_global_variable] = ACTIONS(13378),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(13380),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13380),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [11019] = {
    [sym_heredoc_body] = STATE(11017),
    [aux_sym_call_repeat1] = STATE(11017),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7931),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_EQ] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_end] = ACTIONS(7929),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_when] = ACTIONS(7929),
    [anon_sym_else] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_PLUS_EQ] = ACTIONS(7929),
    [anon_sym_DASH_EQ] = ACTIONS(7929),
    [anon_sym_STAR_EQ] = ACTIONS(7929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7929),
    [anon_sym_SLASH_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7929),
    [anon_sym_AMP_EQ] = ACTIONS(7929),
    [anon_sym_PERCENT_EQ] = ACTIONS(7929),
    [anon_sym_GT_GT_EQ] = ACTIONS(7929),
    [anon_sym_LT_LT_EQ] = ACTIONS(7929),
    [anon_sym_CARET_EQ] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7931),
    [anon_sym_AMP_AMP] = ACTIONS(7931),
    [anon_sym_LT_LT] = ACTIONS(7931),
    [anon_sym_GT_GT] = ACTIONS(7931),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7931),
    [anon_sym_PLUS] = ACTIONS(7931),
    [anon_sym_SLASH] = ACTIONS(7931),
    [anon_sym_PERCENT] = ACTIONS(7931),
    [sym_comment] = ACTIONS(87),
  },
  [11020] = {
    [aux_sym_argument_list_repeat1] = STATE(11020),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(15204),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7927),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_EQ] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_end] = ACTIONS(7925),
    [anon_sym_if] = ACTIONS(7925),
    [anon_sym_unless] = ACTIONS(7925),
    [anon_sym_while] = ACTIONS(7925),
    [anon_sym_until] = ACTIONS(7925),
    [anon_sym_rescue] = ACTIONS(7925),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_when] = ACTIONS(7925),
    [anon_sym_else] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_PLUS_EQ] = ACTIONS(7925),
    [anon_sym_DASH_EQ] = ACTIONS(7925),
    [anon_sym_STAR_EQ] = ACTIONS(7925),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7925),
    [anon_sym_SLASH_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7925),
    [anon_sym_AMP_EQ] = ACTIONS(7925),
    [anon_sym_PERCENT_EQ] = ACTIONS(7925),
    [anon_sym_GT_GT_EQ] = ACTIONS(7925),
    [anon_sym_LT_LT_EQ] = ACTIONS(7925),
    [anon_sym_CARET_EQ] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7927),
    [anon_sym_AMP_AMP] = ACTIONS(7927),
    [anon_sym_LT_LT] = ACTIONS(7927),
    [anon_sym_GT_GT] = ACTIONS(7927),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7927),
    [anon_sym_PLUS] = ACTIONS(7927),
    [anon_sym_SLASH] = ACTIONS(7927),
    [anon_sym_PERCENT] = ACTIONS(7927),
    [sym_comment] = ACTIONS(87),
  },
  [11021] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(14262),
    [sym__binary_star] = ACTIONS(14264),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(14266),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(14268),
    [anon_sym_AMP] = ACTIONS(14270),
    [anon_sym_EQ] = ACTIONS(7936),
    [anon_sym_LT] = ACTIONS(14272),
    [anon_sym_end] = ACTIONS(5115),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_when] = ACTIONS(5115),
    [anon_sym_else] = ACTIONS(5115),
    [anon_sym_EQ_GT] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_PLUS_EQ] = ACTIONS(5115),
    [anon_sym_DASH_EQ] = ACTIONS(5115),
    [anon_sym_STAR_EQ] = ACTIONS(5115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5115),
    [anon_sym_SLASH_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5115),
    [anon_sym_AMP_EQ] = ACTIONS(5115),
    [anon_sym_PERCENT_EQ] = ACTIONS(5115),
    [anon_sym_GT_GT_EQ] = ACTIONS(5115),
    [anon_sym_LT_LT_EQ] = ACTIONS(5115),
    [anon_sym_CARET_EQ] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(14274),
    [anon_sym_DOT_DOT] = ACTIONS(14276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14278),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(14280),
    [anon_sym_AMP_AMP] = ACTIONS(14280),
    [anon_sym_LT_LT] = ACTIONS(14282),
    [anon_sym_GT_GT] = ACTIONS(14282),
    [anon_sym_EQ_EQ] = ACTIONS(14280),
    [anon_sym_BANG_EQ] = ACTIONS(14284),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14284),
    [anon_sym_LT_EQ_GT] = ACTIONS(14284),
    [anon_sym_EQ_TILDE] = ACTIONS(14284),
    [anon_sym_BANG_TILDE] = ACTIONS(14284),
    [anon_sym_LT_EQ] = ACTIONS(14272),
    [anon_sym_GT] = ACTIONS(14272),
    [anon_sym_GT_EQ] = ACTIONS(14286),
    [anon_sym_CARET] = ACTIONS(14266),
    [anon_sym_PLUS] = ACTIONS(14288),
    [anon_sym_SLASH] = ACTIONS(14268),
    [anon_sym_PERCENT] = ACTIONS(14268),
    [sym_comment] = ACTIONS(87),
  },
  [11022] = {
    [aux_sym_exceptions_repeat1] = STATE(11250),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6193),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_end] = ACTIONS(6191),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_when] = ACTIONS(6191),
    [anon_sym_else] = ACTIONS(6191),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_PLUS_EQ] = ACTIONS(6191),
    [anon_sym_DASH_EQ] = ACTIONS(6191),
    [anon_sym_STAR_EQ] = ACTIONS(6191),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6191),
    [anon_sym_SLASH_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6191),
    [anon_sym_AMP_EQ] = ACTIONS(6191),
    [anon_sym_PERCENT_EQ] = ACTIONS(6191),
    [anon_sym_GT_GT_EQ] = ACTIONS(6191),
    [anon_sym_LT_LT_EQ] = ACTIONS(6191),
    [anon_sym_CARET_EQ] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6193),
    [anon_sym_AMP_AMP] = ACTIONS(6193),
    [anon_sym_LT_LT] = ACTIONS(6193),
    [anon_sym_GT_GT] = ACTIONS(6193),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6193),
    [anon_sym_PLUS] = ACTIONS(6193),
    [anon_sym_SLASH] = ACTIONS(6193),
    [anon_sym_PERCENT] = ACTIONS(6193),
    [sym_comment] = ACTIONS(87),
  },
  [11023] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(14262),
    [sym__binary_star] = ACTIONS(14264),
    [anon_sym_LBRACE] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(14266),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(14268),
    [anon_sym_AMP] = ACTIONS(14270),
    [anon_sym_EQ] = ACTIONS(7938),
    [anon_sym_LT] = ACTIONS(14272),
    [anon_sym_end] = ACTIONS(6210),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_when] = ACTIONS(6210),
    [anon_sym_else] = ACTIONS(6210),
    [anon_sym_EQ_GT] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_PLUS_EQ] = ACTIONS(6210),
    [anon_sym_DASH_EQ] = ACTIONS(6210),
    [anon_sym_STAR_EQ] = ACTIONS(6210),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6210),
    [anon_sym_SLASH_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6210),
    [anon_sym_AMP_EQ] = ACTIONS(6210),
    [anon_sym_PERCENT_EQ] = ACTIONS(6210),
    [anon_sym_GT_GT_EQ] = ACTIONS(6210),
    [anon_sym_LT_LT_EQ] = ACTIONS(6210),
    [anon_sym_CARET_EQ] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(14274),
    [anon_sym_DOT_DOT] = ACTIONS(14276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14278),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(14280),
    [anon_sym_AMP_AMP] = ACTIONS(14280),
    [anon_sym_LT_LT] = ACTIONS(14282),
    [anon_sym_GT_GT] = ACTIONS(14282),
    [anon_sym_EQ_EQ] = ACTIONS(14280),
    [anon_sym_BANG_EQ] = ACTIONS(14284),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14284),
    [anon_sym_LT_EQ_GT] = ACTIONS(14284),
    [anon_sym_EQ_TILDE] = ACTIONS(14284),
    [anon_sym_BANG_TILDE] = ACTIONS(14284),
    [anon_sym_LT_EQ] = ACTIONS(14272),
    [anon_sym_GT] = ACTIONS(14272),
    [anon_sym_GT_EQ] = ACTIONS(14286),
    [anon_sym_CARET] = ACTIONS(14266),
    [anon_sym_PLUS] = ACTIONS(14288),
    [anon_sym_SLASH] = ACTIONS(14268),
    [anon_sym_PERCENT] = ACTIONS(14268),
    [sym_comment] = ACTIONS(87),
  },
  [11024] = {
    [sym_string] = STATE(11024),
    [aux_sym_chained_string_repeat1] = STATE(11024),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(9852),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6217),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_EQ] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_end] = ACTIONS(6212),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_do] = ACTIONS(6212),
    [anon_sym_when] = ACTIONS(6212),
    [anon_sym_else] = ACTIONS(6212),
    [anon_sym_EQ_GT] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_PLUS_EQ] = ACTIONS(6212),
    [anon_sym_DASH_EQ] = ACTIONS(6212),
    [anon_sym_STAR_EQ] = ACTIONS(6212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6212),
    [anon_sym_SLASH_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6212),
    [anon_sym_AMP_EQ] = ACTIONS(6212),
    [anon_sym_PERCENT_EQ] = ACTIONS(6212),
    [anon_sym_GT_GT_EQ] = ACTIONS(6212),
    [anon_sym_LT_LT_EQ] = ACTIONS(6212),
    [anon_sym_CARET_EQ] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6217),
    [anon_sym_AMP_AMP] = ACTIONS(6217),
    [anon_sym_LT_LT] = ACTIONS(6217),
    [anon_sym_GT_GT] = ACTIONS(6217),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6217),
    [anon_sym_PLUS] = ACTIONS(6217),
    [anon_sym_SLASH] = ACTIONS(6217),
    [anon_sym_PERCENT] = ACTIONS(6217),
    [sym_comment] = ACTIONS(87),
  },
  [11025] = {
    [sym__line_break] = ACTIONS(4247),
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(14919),
    [sym__binary_star] = ACTIONS(14921),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(14923),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(14921),
    [anon_sym_AMP] = ACTIONS(14925),
    [anon_sym_LT] = ACTIONS(14927),
    [anon_sym_end] = ACTIONS(4247),
    [anon_sym_if] = ACTIONS(4247),
    [anon_sym_unless] = ACTIONS(4247),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_until] = ACTIONS(4247),
    [anon_sym_rescue] = ACTIONS(4247),
    [anon_sym_when] = ACTIONS(4247),
    [anon_sym_else] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(14929),
    [anon_sym_DOT_DOT] = ACTIONS(14931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14933),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(14935),
    [anon_sym_AMP_AMP] = ACTIONS(14935),
    [anon_sym_LT_LT] = ACTIONS(14937),
    [anon_sym_GT_GT] = ACTIONS(14937),
    [anon_sym_EQ_EQ] = ACTIONS(14939),
    [anon_sym_BANG_EQ] = ACTIONS(14935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14935),
    [anon_sym_LT_EQ_GT] = ACTIONS(14935),
    [anon_sym_EQ_TILDE] = ACTIONS(14935),
    [anon_sym_BANG_TILDE] = ACTIONS(14935),
    [anon_sym_LT_EQ] = ACTIONS(14927),
    [anon_sym_GT] = ACTIONS(14927),
    [anon_sym_GT_EQ] = ACTIONS(14941),
    [anon_sym_CARET] = ACTIONS(14943),
    [anon_sym_PLUS] = ACTIONS(14919),
    [anon_sym_SLASH] = ACTIONS(14921),
    [anon_sym_PERCENT] = ACTIONS(14921),
    [sym_comment] = ACTIONS(87),
  },
  [11026] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(14921),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_when] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [11027] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(14919),
    [sym__binary_star] = ACTIONS(14921),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(14923),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(14921),
    [anon_sym_AMP] = ACTIONS(14925),
    [anon_sym_LT] = ACTIONS(14927),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_when] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(14929),
    [anon_sym_DOT_DOT] = ACTIONS(14931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14933),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(14935),
    [anon_sym_AMP_AMP] = ACTIONS(14935),
    [anon_sym_LT_LT] = ACTIONS(14937),
    [anon_sym_GT_GT] = ACTIONS(14937),
    [anon_sym_EQ_EQ] = ACTIONS(14939),
    [anon_sym_BANG_EQ] = ACTIONS(14935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14935),
    [anon_sym_LT_EQ_GT] = ACTIONS(14935),
    [anon_sym_EQ_TILDE] = ACTIONS(14935),
    [anon_sym_BANG_TILDE] = ACTIONS(14935),
    [anon_sym_LT_EQ] = ACTIONS(14927),
    [anon_sym_GT] = ACTIONS(14927),
    [anon_sym_GT_EQ] = ACTIONS(14941),
    [anon_sym_CARET] = ACTIONS(14943),
    [anon_sym_PLUS] = ACTIONS(14919),
    [anon_sym_SLASH] = ACTIONS(14921),
    [anon_sym_PERCENT] = ACTIONS(14921),
    [sym_comment] = ACTIONS(87),
  },
  [11028] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(11251),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(10601),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(10601),
    [sym_assignment] = STATE(11251),
    [sym_operator_assignment] = STATE(11251),
    [sym_conditional] = STATE(11251),
    [sym_range] = STATE(11251),
    [sym_binary] = STATE(11251),
    [sym_unary] = STATE(11251),
    [sym_left_assignment_list] = STATE(10600),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10601),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(10601),
    [sym_false] = STATE(10601),
    [sym_nil] = STATE(10601),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(10501),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(14302),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14160),
    [anon_sym_yield] = ACTIONS(14162),
    [anon_sym_break] = ACTIONS(14164),
    [anon_sym_next] = ACTIONS(14166),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14304),
    [anon_sym_defined_QMARK] = ACTIONS(14306),
    [anon_sym_not] = ACTIONS(14308),
    [anon_sym_BANG] = ACTIONS(14310),
    [anon_sym_TILDE] = ACTIONS(14310),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11029] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(11252),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(10601),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(10601),
    [sym_assignment] = STATE(11252),
    [sym_operator_assignment] = STATE(11252),
    [sym_conditional] = STATE(11252),
    [sym_range] = STATE(11252),
    [sym_binary] = STATE(11252),
    [sym_unary] = STATE(11252),
    [sym_left_assignment_list] = STATE(10600),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10601),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(10601),
    [sym_false] = STATE(10601),
    [sym_nil] = STATE(10601),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(10501),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(14302),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14160),
    [anon_sym_yield] = ACTIONS(14162),
    [anon_sym_break] = ACTIONS(14164),
    [anon_sym_next] = ACTIONS(14166),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14304),
    [anon_sym_defined_QMARK] = ACTIONS(14306),
    [anon_sym_not] = ACTIONS(14308),
    [anon_sym_BANG] = ACTIONS(14310),
    [anon_sym_TILDE] = ACTIONS(14310),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11030] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(11253),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(10601),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(10601),
    [sym_assignment] = STATE(11253),
    [sym_operator_assignment] = STATE(11253),
    [sym_conditional] = STATE(11253),
    [sym_range] = STATE(11253),
    [sym_binary] = STATE(11253),
    [sym_unary] = STATE(11253),
    [sym_left_assignment_list] = STATE(10600),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10601),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(10601),
    [sym_false] = STATE(10601),
    [sym_nil] = STATE(10601),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(10501),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(14302),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14160),
    [anon_sym_yield] = ACTIONS(14162),
    [anon_sym_break] = ACTIONS(14164),
    [anon_sym_next] = ACTIONS(14166),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14304),
    [anon_sym_defined_QMARK] = ACTIONS(14306),
    [anon_sym_not] = ACTIONS(14308),
    [anon_sym_BANG] = ACTIONS(14310),
    [anon_sym_TILDE] = ACTIONS(14310),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11031] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(11254),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(10601),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(10601),
    [sym_assignment] = STATE(11254),
    [sym_operator_assignment] = STATE(11254),
    [sym_conditional] = STATE(11254),
    [sym_range] = STATE(11254),
    [sym_binary] = STATE(11254),
    [sym_unary] = STATE(11254),
    [sym_left_assignment_list] = STATE(10600),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10601),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(10601),
    [sym_false] = STATE(10601),
    [sym_nil] = STATE(10601),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(10501),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(14302),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14160),
    [anon_sym_yield] = ACTIONS(14162),
    [anon_sym_break] = ACTIONS(14164),
    [anon_sym_next] = ACTIONS(14166),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14304),
    [anon_sym_defined_QMARK] = ACTIONS(14306),
    [anon_sym_not] = ACTIONS(14308),
    [anon_sym_BANG] = ACTIONS(14310),
    [anon_sym_TILDE] = ACTIONS(14310),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11032] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(11255),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(10601),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(10601),
    [sym_assignment] = STATE(11255),
    [sym_operator_assignment] = STATE(11255),
    [sym_conditional] = STATE(11255),
    [sym_range] = STATE(11255),
    [sym_binary] = STATE(11255),
    [sym_unary] = STATE(11255),
    [sym_left_assignment_list] = STATE(10600),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10601),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(10601),
    [sym_false] = STATE(10601),
    [sym_nil] = STATE(10601),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(10501),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(14302),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14160),
    [anon_sym_yield] = ACTIONS(14162),
    [anon_sym_break] = ACTIONS(14164),
    [anon_sym_next] = ACTIONS(14166),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14304),
    [anon_sym_defined_QMARK] = ACTIONS(14306),
    [anon_sym_not] = ACTIONS(14308),
    [anon_sym_BANG] = ACTIONS(14310),
    [anon_sym_TILDE] = ACTIONS(14310),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11033] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(11256),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(11256),
    [sym_operator_assignment] = STATE(11256),
    [sym_conditional] = STATE(11256),
    [sym_range] = STATE(11256),
    [sym_binary] = STATE(11256),
    [sym_unary] = STATE(11256),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [11034] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(11257),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(10601),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(10601),
    [sym_assignment] = STATE(11257),
    [sym_operator_assignment] = STATE(11257),
    [sym_conditional] = STATE(11257),
    [sym_range] = STATE(11257),
    [sym_binary] = STATE(11257),
    [sym_unary] = STATE(11257),
    [sym_left_assignment_list] = STATE(10600),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10601),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(10601),
    [sym_false] = STATE(10601),
    [sym_nil] = STATE(10601),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(10501),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(14302),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14160),
    [anon_sym_yield] = ACTIONS(14162),
    [anon_sym_break] = ACTIONS(14164),
    [anon_sym_next] = ACTIONS(14166),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14304),
    [anon_sym_defined_QMARK] = ACTIONS(14306),
    [anon_sym_not] = ACTIONS(14308),
    [anon_sym_BANG] = ACTIONS(14310),
    [anon_sym_TILDE] = ACTIONS(14310),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11035] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(11258),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(10601),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(10601),
    [sym_assignment] = STATE(11258),
    [sym_operator_assignment] = STATE(11258),
    [sym_conditional] = STATE(11258),
    [sym_range] = STATE(11258),
    [sym_binary] = STATE(11258),
    [sym_unary] = STATE(11258),
    [sym_left_assignment_list] = STATE(10600),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10601),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(10601),
    [sym_false] = STATE(10601),
    [sym_nil] = STATE(10601),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(10501),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(14302),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14160),
    [anon_sym_yield] = ACTIONS(14162),
    [anon_sym_break] = ACTIONS(14164),
    [anon_sym_next] = ACTIONS(14166),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14304),
    [anon_sym_defined_QMARK] = ACTIONS(14306),
    [anon_sym_not] = ACTIONS(14308),
    [anon_sym_BANG] = ACTIONS(14310),
    [anon_sym_TILDE] = ACTIONS(14310),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11036] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(11259),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(10601),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(10601),
    [sym_assignment] = STATE(11259),
    [sym_operator_assignment] = STATE(11259),
    [sym_conditional] = STATE(11259),
    [sym_range] = STATE(11259),
    [sym_binary] = STATE(11259),
    [sym_unary] = STATE(11259),
    [sym_left_assignment_list] = STATE(10600),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10601),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(10601),
    [sym_false] = STATE(10601),
    [sym_nil] = STATE(10601),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(10501),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(14302),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14160),
    [anon_sym_yield] = ACTIONS(14162),
    [anon_sym_break] = ACTIONS(14164),
    [anon_sym_next] = ACTIONS(14166),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14304),
    [anon_sym_defined_QMARK] = ACTIONS(14306),
    [anon_sym_not] = ACTIONS(14308),
    [anon_sym_BANG] = ACTIONS(14310),
    [anon_sym_TILDE] = ACTIONS(14310),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11037] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(11260),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(10601),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(10601),
    [sym_assignment] = STATE(11260),
    [sym_operator_assignment] = STATE(11260),
    [sym_conditional] = STATE(11260),
    [sym_range] = STATE(11260),
    [sym_binary] = STATE(11260),
    [sym_unary] = STATE(11260),
    [sym_left_assignment_list] = STATE(10600),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10601),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(10601),
    [sym_false] = STATE(10601),
    [sym_nil] = STATE(10601),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(10501),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(14302),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14160),
    [anon_sym_yield] = ACTIONS(14162),
    [anon_sym_break] = ACTIONS(14164),
    [anon_sym_next] = ACTIONS(14166),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14304),
    [anon_sym_defined_QMARK] = ACTIONS(14306),
    [anon_sym_not] = ACTIONS(14308),
    [anon_sym_BANG] = ACTIONS(14310),
    [anon_sym_TILDE] = ACTIONS(14310),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11038] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10598),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(10601),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(10601),
    [sym_splat_argument] = STATE(6406),
    [sym_assignment] = STATE(10598),
    [sym_operator_assignment] = STATE(10598),
    [sym_conditional] = STATE(10598),
    [sym_range] = STATE(10598),
    [sym_binary] = STATE(10598),
    [sym_unary] = STATE(10598),
    [sym__arg_or_splat_arg] = STATE(6406),
    [sym_left_assignment_list] = STATE(10600),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10601),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(10601),
    [sym_false] = STATE(10601),
    [sym_nil] = STATE(10601),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(10501),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(14300),
    [sym__unary_minus] = ACTIONS(14302),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14160),
    [anon_sym_yield] = ACTIONS(14162),
    [anon_sym_break] = ACTIONS(14164),
    [anon_sym_next] = ACTIONS(14166),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14304),
    [anon_sym_defined_QMARK] = ACTIONS(14306),
    [anon_sym_not] = ACTIONS(14308),
    [anon_sym_BANG] = ACTIONS(14310),
    [anon_sym_TILDE] = ACTIONS(14310),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11039] = {
    [aux_sym_exceptions_repeat1] = STATE(11261),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_COMMA] = ACTIONS(14945),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_end] = ACTIONS(9855),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_when] = ACTIONS(9855),
    [anon_sym_else] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [11040] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10598),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(10601),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(10601),
    [sym_splat_argument] = STATE(11262),
    [sym_assignment] = STATE(10598),
    [sym_operator_assignment] = STATE(10598),
    [sym_conditional] = STATE(10598),
    [sym_range] = STATE(10598),
    [sym_binary] = STATE(10598),
    [sym_unary] = STATE(10598),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(11262),
    [sym_left_assignment_list] = STATE(10600),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10601),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(10601),
    [sym_false] = STATE(10601),
    [sym_nil] = STATE(10601),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(10501),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(14300),
    [sym__unary_minus] = ACTIONS(14302),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14160),
    [anon_sym_yield] = ACTIONS(14162),
    [anon_sym_break] = ACTIONS(14164),
    [anon_sym_next] = ACTIONS(14166),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14304),
    [anon_sym_defined_QMARK] = ACTIONS(14306),
    [anon_sym_not] = ACTIONS(14308),
    [anon_sym_BANG] = ACTIONS(14310),
    [anon_sym_TILDE] = ACTIONS(14310),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11041] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(11263),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(10601),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(10601),
    [sym_assignment] = STATE(11263),
    [sym_operator_assignment] = STATE(11263),
    [sym_conditional] = STATE(11263),
    [sym_range] = STATE(11263),
    [sym_binary] = STATE(11263),
    [sym_unary] = STATE(11263),
    [sym_left_assignment_list] = STATE(10600),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10601),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(10601),
    [sym_false] = STATE(10601),
    [sym_nil] = STATE(10601),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(10501),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(14302),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14160),
    [anon_sym_yield] = ACTIONS(14162),
    [anon_sym_break] = ACTIONS(14164),
    [anon_sym_next] = ACTIONS(14166),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14304),
    [anon_sym_defined_QMARK] = ACTIONS(14306),
    [anon_sym_not] = ACTIONS(14308),
    [anon_sym_BANG] = ACTIONS(14310),
    [anon_sym_TILDE] = ACTIONS(14310),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11042] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(11264),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7957),
    [sym_scope_resolution] = STATE(7955),
    [sym_call] = STATE(7955),
    [sym_method_call] = STATE(7957),
    [sym_assignment] = STATE(11264),
    [sym_operator_assignment] = STATE(11264),
    [sym_conditional] = STATE(11264),
    [sym_range] = STATE(11264),
    [sym_binary] = STATE(11264),
    [sym_unary] = STATE(11264),
    [sym_left_assignment_list] = STATE(7956),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7957),
    [sym__variable] = STATE(7955),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7957),
    [sym_false] = STATE(7957),
    [sym_nil] = STATE(7957),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7958),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(11460),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11462),
    [anon_sym_yield] = ACTIONS(11464),
    [anon_sym_break] = ACTIONS(11466),
    [anon_sym_next] = ACTIONS(11468),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11470),
    [anon_sym_defined_QMARK] = ACTIONS(11472),
    [anon_sym_not] = ACTIONS(11474),
    [anon_sym_BANG] = ACTIONS(11476),
    [anon_sym_TILDE] = ACTIONS(11476),
    [sym_constant] = ACTIONS(11478),
    [sym_identifier] = ACTIONS(11478),
    [sym_instance_variable] = ACTIONS(11480),
    [sym_class_variable] = ACTIONS(11480),
    [sym_global_variable] = ACTIONS(11480),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11478),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11478),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [11043] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(10615),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(7957),
    [sym_scope_resolution] = STATE(7955),
    [sym_call] = STATE(7955),
    [sym_method_call] = STATE(7957),
    [sym_splat_argument] = STATE(10067),
    [sym_assignment] = STATE(10615),
    [sym_operator_assignment] = STATE(10615),
    [sym_conditional] = STATE(10615),
    [sym_range] = STATE(10615),
    [sym_binary] = STATE(10615),
    [sym_unary] = STATE(10615),
    [sym__arg_or_splat_arg] = STATE(10067),
    [sym_left_assignment_list] = STATE(7956),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(7957),
    [sym__variable] = STATE(7955),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(7957),
    [sym_false] = STATE(7957),
    [sym_nil] = STATE(7957),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(7958),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__splat_star] = ACTIONS(8667),
    [sym__unary_minus] = ACTIONS(11460),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(11462),
    [anon_sym_yield] = ACTIONS(11464),
    [anon_sym_break] = ACTIONS(11466),
    [anon_sym_next] = ACTIONS(11468),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(11470),
    [anon_sym_defined_QMARK] = ACTIONS(11472),
    [anon_sym_not] = ACTIONS(11474),
    [anon_sym_BANG] = ACTIONS(11476),
    [anon_sym_TILDE] = ACTIONS(11476),
    [sym_constant] = ACTIONS(11478),
    [sym_identifier] = ACTIONS(11478),
    [sym_instance_variable] = ACTIONS(11480),
    [sym_class_variable] = ACTIONS(11480),
    [sym_global_variable] = ACTIONS(11480),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(11478),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11478),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [11044] = {
    [aux_sym_exceptions_repeat1] = STATE(11265),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_LBRACE] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(15207),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9857),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_EQ] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_do] = ACTIONS(9855),
    [anon_sym_then] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_PLUS_EQ] = ACTIONS(9855),
    [anon_sym_DASH_EQ] = ACTIONS(9855),
    [anon_sym_STAR_EQ] = ACTIONS(9855),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9855),
    [anon_sym_SLASH_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9855),
    [anon_sym_AMP_EQ] = ACTIONS(9855),
    [anon_sym_PERCENT_EQ] = ACTIONS(9855),
    [anon_sym_GT_GT_EQ] = ACTIONS(9855),
    [anon_sym_LT_LT_EQ] = ACTIONS(9855),
    [anon_sym_CARET_EQ] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9857),
    [anon_sym_AMP_AMP] = ACTIONS(9857),
    [anon_sym_LT_LT] = ACTIONS(9857),
    [anon_sym_GT_GT] = ACTIONS(9857),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9857),
    [anon_sym_PLUS] = ACTIONS(9857),
    [anon_sym_SLASH] = ACTIONS(9857),
    [anon_sym_PERCENT] = ACTIONS(9857),
    [sym_comment] = ACTIONS(87),
  },
  [11045] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(13462),
    [sym__binary_star] = ACTIONS(13464),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(13466),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(13464),
    [anon_sym_AMP] = ACTIONS(13468),
    [anon_sym_LT] = ACTIONS(13470),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_then] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(13472),
    [anon_sym_DOT_DOT] = ACTIONS(13474),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13476),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(13480),
    [anon_sym_AMP_AMP] = ACTIONS(13480),
    [anon_sym_LT_LT] = ACTIONS(13482),
    [anon_sym_GT_GT] = ACTIONS(13482),
    [anon_sym_EQ_EQ] = ACTIONS(13484),
    [anon_sym_BANG_EQ] = ACTIONS(13480),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13480),
    [anon_sym_LT_EQ_GT] = ACTIONS(13480),
    [anon_sym_EQ_TILDE] = ACTIONS(13480),
    [anon_sym_BANG_TILDE] = ACTIONS(13480),
    [anon_sym_LT_EQ] = ACTIONS(13470),
    [anon_sym_GT] = ACTIONS(13470),
    [anon_sym_GT_EQ] = ACTIONS(13486),
    [anon_sym_CARET] = ACTIONS(13488),
    [anon_sym_PLUS] = ACTIONS(13462),
    [anon_sym_SLASH] = ACTIONS(13464),
    [anon_sym_PERCENT] = ACTIONS(13464),
    [sym_comment] = ACTIONS(87),
  },
  [11046] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(13462),
    [sym__binary_star] = ACTIONS(13464),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(13466),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(13464),
    [anon_sym_AMP] = ACTIONS(13468),
    [anon_sym_LT] = ACTIONS(13470),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_then] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(13472),
    [anon_sym_DOT_DOT] = ACTIONS(13474),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13476),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(13480),
    [anon_sym_AMP_AMP] = ACTIONS(13480),
    [anon_sym_LT_LT] = ACTIONS(13482),
    [anon_sym_GT_GT] = ACTIONS(13482),
    [anon_sym_EQ_EQ] = ACTIONS(13484),
    [anon_sym_BANG_EQ] = ACTIONS(13480),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13480),
    [anon_sym_LT_EQ_GT] = ACTIONS(13480),
    [anon_sym_EQ_TILDE] = ACTIONS(13480),
    [anon_sym_BANG_TILDE] = ACTIONS(13480),
    [anon_sym_LT_EQ] = ACTIONS(13470),
    [anon_sym_GT] = ACTIONS(13470),
    [anon_sym_GT_EQ] = ACTIONS(13486),
    [anon_sym_CARET] = ACTIONS(13488),
    [anon_sym_PLUS] = ACTIONS(13462),
    [anon_sym_SLASH] = ACTIONS(13464),
    [anon_sym_PERCENT] = ACTIONS(13464),
    [sym_comment] = ACTIONS(87),
  },
  [11047] = {
    [sym_heredoc_body] = STATE(11047),
    [aux_sym_call_repeat1] = STATE(11047),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(7916),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_then] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [11048] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9681),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5621),
    [sym_scope_resolution] = STATE(3092),
    [sym_call] = STATE(3092),
    [sym_method_call] = STATE(5621),
    [sym__argument] = STATE(4986),
    [sym_splat_argument] = STATE(4986),
    [sym_hash_splat_argument] = STATE(4986),
    [sym_block_argument] = STATE(4986),
    [sym_assignment] = STATE(9681),
    [sym_operator_assignment] = STATE(9681),
    [sym_conditional] = STATE(9681),
    [sym_range] = STATE(9681),
    [sym_binary] = STATE(9681),
    [sym_unary] = STATE(9681),
    [sym_left_assignment_list] = STATE(5620),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(5621),
    [sym__variable] = STATE(3092),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5621),
    [sym_false] = STATE(5621),
    [sym_nil] = STATE(5621),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(9684),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4986),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(13454),
    [sym__splat_star] = ACTIONS(13456),
    [sym__unary_minus] = ACTIONS(8791),
    [sym__identifier_hash_key] = ACTIONS(13458),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(14964),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8799),
    [anon_sym_yield] = ACTIONS(8801),
    [anon_sym_break] = ACTIONS(8803),
    [anon_sym_next] = ACTIONS(8805),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8809),
    [anon_sym_defined_QMARK] = ACTIONS(8811),
    [anon_sym_not] = ACTIONS(8813),
    [anon_sym_BANG] = ACTIONS(8815),
    [anon_sym_TILDE] = ACTIONS(8815),
    [sym_constant] = ACTIONS(13460),
    [sym_identifier] = ACTIONS(13460),
    [sym_instance_variable] = ACTIONS(5171),
    [sym_class_variable] = ACTIONS(5171),
    [sym_global_variable] = ACTIONS(5171),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(5173),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(5173),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11049] = {
    [sym_heredoc_body] = STATE(11047),
    [aux_sym_call_repeat1] = STATE(11047),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_then] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [11050] = {
    [aux_sym_argument_list_repeat1] = STATE(11050),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(15209),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7925),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_then] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7925),
    [anon_sym_AMP_AMP] = ACTIONS(7925),
    [anon_sym_LT_LT] = ACTIONS(7925),
    [anon_sym_GT_GT] = ACTIONS(7925),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7925),
    [anon_sym_PLUS] = ACTIONS(7925),
    [anon_sym_SLASH] = ACTIONS(7925),
    [anon_sym_PERCENT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [11051] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(11266),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(8037),
    [sym_scope_resolution] = STATE(7955),
    [sym_call] = STATE(7955),
    [sym_method_call] = STATE(8037),
    [sym_assignment] = STATE(11266),
    [sym_operator_assignment] = STATE(11266),
    [sym_conditional] = STATE(11266),
    [sym_range] = STATE(11266),
    [sym_binary] = STATE(11266),
    [sym_unary] = STATE(11266),
    [sym_left_assignment_list] = STATE(8036),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(8037),
    [sym__variable] = STATE(7955),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(8037),
    [sym_false] = STATE(8037),
    [sym_nil] = STATE(8037),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(8038),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11513),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11515),
    [anon_sym_yield] = ACTIONS(11517),
    [anon_sym_break] = ACTIONS(11519),
    [anon_sym_next] = ACTIONS(11521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11523),
    [anon_sym_defined_QMARK] = ACTIONS(11525),
    [anon_sym_not] = ACTIONS(11527),
    [anon_sym_BANG] = ACTIONS(11529),
    [anon_sym_TILDE] = ACTIONS(11529),
    [sym_constant] = ACTIONS(11478),
    [sym_identifier] = ACTIONS(11478),
    [sym_instance_variable] = ACTIONS(11480),
    [sym_class_variable] = ACTIONS(11480),
    [sym_global_variable] = ACTIONS(11480),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11478),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11478),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11052] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(10643),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(8037),
    [sym_scope_resolution] = STATE(7955),
    [sym_call] = STATE(7955),
    [sym_method_call] = STATE(8037),
    [sym_splat_argument] = STATE(7439),
    [sym_assignment] = STATE(10643),
    [sym_operator_assignment] = STATE(10643),
    [sym_conditional] = STATE(10643),
    [sym_range] = STATE(10643),
    [sym_binary] = STATE(10643),
    [sym_unary] = STATE(10643),
    [sym__arg_or_splat_arg] = STATE(7439),
    [sym_left_assignment_list] = STATE(8036),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(8037),
    [sym__variable] = STATE(7955),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(8037),
    [sym_false] = STATE(8037),
    [sym_nil] = STATE(8037),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(8038),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(13456),
    [sym__unary_minus] = ACTIONS(11513),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11515),
    [anon_sym_yield] = ACTIONS(11517),
    [anon_sym_break] = ACTIONS(11519),
    [anon_sym_next] = ACTIONS(11521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11523),
    [anon_sym_defined_QMARK] = ACTIONS(11525),
    [anon_sym_not] = ACTIONS(11527),
    [anon_sym_BANG] = ACTIONS(11529),
    [anon_sym_TILDE] = ACTIONS(11529),
    [sym_constant] = ACTIONS(11478),
    [sym_identifier] = ACTIONS(11478),
    [sym_instance_variable] = ACTIONS(11480),
    [sym_class_variable] = ACTIONS(11480),
    [sym_global_variable] = ACTIONS(11480),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11478),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11478),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11053] = {
    [aux_sym_exceptions_repeat1] = STATE(11267),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_LBRACE] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(15212),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_do] = ACTIONS(9855),
    [anon_sym_then] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [11054] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(11549),
    [sym__binary_star] = ACTIONS(11551),
    [anon_sym_LBRACE] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(11553),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(11551),
    [anon_sym_AMP] = ACTIONS(11555),
    [anon_sym_LT] = ACTIONS(11557),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_then] = ACTIONS(12120),
    [anon_sym_EQ_GT] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(11559),
    [anon_sym_DOT_DOT] = ACTIONS(11561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11563),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(11567),
    [anon_sym_AMP_AMP] = ACTIONS(11567),
    [anon_sym_LT_LT] = ACTIONS(11569),
    [anon_sym_GT_GT] = ACTIONS(11569),
    [anon_sym_EQ_EQ] = ACTIONS(11571),
    [anon_sym_BANG_EQ] = ACTIONS(11567),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11567),
    [anon_sym_LT_EQ_GT] = ACTIONS(11567),
    [anon_sym_EQ_TILDE] = ACTIONS(11567),
    [anon_sym_BANG_TILDE] = ACTIONS(11567),
    [anon_sym_LT_EQ] = ACTIONS(11557),
    [anon_sym_GT] = ACTIONS(11557),
    [anon_sym_GT_EQ] = ACTIONS(11573),
    [anon_sym_CARET] = ACTIONS(11575),
    [anon_sym_PLUS] = ACTIONS(11549),
    [anon_sym_SLASH] = ACTIONS(11551),
    [anon_sym_PERCENT] = ACTIONS(11551),
    [sym_comment] = ACTIONS(87),
  },
  [11055] = {
    [aux_sym_exceptions_repeat1] = STATE(11055),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(15214),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_then] = ACTIONS(11597),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [11056] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(11602),
    [sym__binary_star] = ACTIONS(11604),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(11606),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(11604),
    [anon_sym_AMP] = ACTIONS(11608),
    [anon_sym_LT] = ACTIONS(11610),
    [anon_sym_end] = ACTIONS(12120),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_ensure] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(11612),
    [anon_sym_DOT_DOT] = ACTIONS(11614),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11616),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(11618),
    [anon_sym_AMP_AMP] = ACTIONS(11618),
    [anon_sym_LT_LT] = ACTIONS(11620),
    [anon_sym_GT_GT] = ACTIONS(11620),
    [anon_sym_EQ_EQ] = ACTIONS(11622),
    [anon_sym_BANG_EQ] = ACTIONS(11618),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11618),
    [anon_sym_LT_EQ_GT] = ACTIONS(11618),
    [anon_sym_EQ_TILDE] = ACTIONS(11618),
    [anon_sym_BANG_TILDE] = ACTIONS(11618),
    [anon_sym_LT_EQ] = ACTIONS(11610),
    [anon_sym_GT] = ACTIONS(11610),
    [anon_sym_GT_EQ] = ACTIONS(11624),
    [anon_sym_CARET] = ACTIONS(11626),
    [anon_sym_PLUS] = ACTIONS(11602),
    [anon_sym_SLASH] = ACTIONS(11604),
    [anon_sym_PERCENT] = ACTIONS(11604),
    [sym_comment] = ACTIONS(87),
  },
  [11057] = {
    [aux_sym_exceptions_repeat1] = STATE(11057),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(15217),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_end] = ACTIONS(11597),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_ensure] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [11058] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(11654),
    [sym__binary_star] = ACTIONS(11656),
    [anon_sym_LBRACE] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(11658),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(11660),
    [anon_sym_AMP] = ACTIONS(11662),
    [anon_sym_EQ] = ACTIONS(12879),
    [anon_sym_LT] = ACTIONS(11664),
    [anon_sym_end] = ACTIONS(12120),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_ensure] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_PLUS_EQ] = ACTIONS(12120),
    [anon_sym_DASH_EQ] = ACTIONS(12120),
    [anon_sym_STAR_EQ] = ACTIONS(12120),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12120),
    [anon_sym_SLASH_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12120),
    [anon_sym_AMP_EQ] = ACTIONS(12120),
    [anon_sym_PERCENT_EQ] = ACTIONS(12120),
    [anon_sym_GT_GT_EQ] = ACTIONS(12120),
    [anon_sym_LT_LT_EQ] = ACTIONS(12120),
    [anon_sym_CARET_EQ] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(11666),
    [anon_sym_DOT_DOT] = ACTIONS(11668),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11670),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(11672),
    [anon_sym_AMP_AMP] = ACTIONS(11672),
    [anon_sym_LT_LT] = ACTIONS(11674),
    [anon_sym_GT_GT] = ACTIONS(11674),
    [anon_sym_EQ_EQ] = ACTIONS(11672),
    [anon_sym_BANG_EQ] = ACTIONS(11676),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11676),
    [anon_sym_LT_EQ_GT] = ACTIONS(11676),
    [anon_sym_EQ_TILDE] = ACTIONS(11676),
    [anon_sym_BANG_TILDE] = ACTIONS(11676),
    [anon_sym_LT_EQ] = ACTIONS(11664),
    [anon_sym_GT] = ACTIONS(11664),
    [anon_sym_GT_EQ] = ACTIONS(11678),
    [anon_sym_CARET] = ACTIONS(11658),
    [anon_sym_PLUS] = ACTIONS(11680),
    [anon_sym_SLASH] = ACTIONS(11660),
    [anon_sym_PERCENT] = ACTIONS(11660),
    [sym_comment] = ACTIONS(87),
  },
  [11059] = {
    [aux_sym_exceptions_repeat1] = STATE(11059),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(15220),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_end] = ACTIONS(11597),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_ensure] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_PLUS_EQ] = ACTIONS(11597),
    [anon_sym_DASH_EQ] = ACTIONS(11597),
    [anon_sym_STAR_EQ] = ACTIONS(11597),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11597),
    [anon_sym_SLASH_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11597),
    [anon_sym_AMP_EQ] = ACTIONS(11597),
    [anon_sym_PERCENT_EQ] = ACTIONS(11597),
    [anon_sym_GT_GT_EQ] = ACTIONS(11597),
    [anon_sym_LT_LT_EQ] = ACTIONS(11597),
    [anon_sym_CARET_EQ] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_LT] = ACTIONS(12338),
    [anon_sym_GT_GT] = ACTIONS(12338),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(12338),
    [anon_sym_PLUS] = ACTIONS(12338),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [11060] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(11690),
    [sym__binary_star] = ACTIONS(11692),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(11694),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(11692),
    [anon_sym_AMP] = ACTIONS(11696),
    [anon_sym_LT] = ACTIONS(11698),
    [anon_sym_end] = ACTIONS(12120),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_ensure] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(11700),
    [anon_sym_DOT_DOT] = ACTIONS(11702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11704),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(11706),
    [anon_sym_AMP_AMP] = ACTIONS(11706),
    [anon_sym_LT_LT] = ACTIONS(11708),
    [anon_sym_GT_GT] = ACTIONS(11708),
    [anon_sym_EQ_EQ] = ACTIONS(11710),
    [anon_sym_BANG_EQ] = ACTIONS(11706),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11706),
    [anon_sym_LT_EQ_GT] = ACTIONS(11706),
    [anon_sym_EQ_TILDE] = ACTIONS(11706),
    [anon_sym_BANG_TILDE] = ACTIONS(11706),
    [anon_sym_LT_EQ] = ACTIONS(11698),
    [anon_sym_GT] = ACTIONS(11698),
    [anon_sym_GT_EQ] = ACTIONS(11712),
    [anon_sym_CARET] = ACTIONS(11714),
    [anon_sym_PLUS] = ACTIONS(11690),
    [anon_sym_SLASH] = ACTIONS(11692),
    [anon_sym_PERCENT] = ACTIONS(11692),
    [sym_comment] = ACTIONS(87),
  },
  [11061] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(11724),
    [sym__binary_star] = ACTIONS(11726),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(11728),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(11726),
    [anon_sym_AMP] = ACTIONS(11730),
    [anon_sym_LT] = ACTIONS(11732),
    [anon_sym_end] = ACTIONS(12120),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(11734),
    [anon_sym_DOT_DOT] = ACTIONS(11736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11738),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(11740),
    [anon_sym_AMP_AMP] = ACTIONS(11740),
    [anon_sym_LT_LT] = ACTIONS(11742),
    [anon_sym_GT_GT] = ACTIONS(11742),
    [anon_sym_EQ_EQ] = ACTIONS(11744),
    [anon_sym_BANG_EQ] = ACTIONS(11740),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11740),
    [anon_sym_LT_EQ_GT] = ACTIONS(11740),
    [anon_sym_EQ_TILDE] = ACTIONS(11740),
    [anon_sym_BANG_TILDE] = ACTIONS(11740),
    [anon_sym_LT_EQ] = ACTIONS(11732),
    [anon_sym_GT] = ACTIONS(11732),
    [anon_sym_GT_EQ] = ACTIONS(11746),
    [anon_sym_CARET] = ACTIONS(11748),
    [anon_sym_PLUS] = ACTIONS(11724),
    [anon_sym_SLASH] = ACTIONS(11726),
    [anon_sym_PERCENT] = ACTIONS(11726),
    [sym_comment] = ACTIONS(87),
  },
  [11062] = {
    [aux_sym_exceptions_repeat1] = STATE(11062),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(15223),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_end] = ACTIONS(11597),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [11063] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(11776),
    [sym__binary_star] = ACTIONS(11778),
    [anon_sym_LBRACE] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(11780),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(11782),
    [anon_sym_AMP] = ACTIONS(11784),
    [anon_sym_EQ] = ACTIONS(12879),
    [anon_sym_LT] = ACTIONS(11786),
    [anon_sym_end] = ACTIONS(12120),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_PLUS_EQ] = ACTIONS(12120),
    [anon_sym_DASH_EQ] = ACTIONS(12120),
    [anon_sym_STAR_EQ] = ACTIONS(12120),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12120),
    [anon_sym_SLASH_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12120),
    [anon_sym_AMP_EQ] = ACTIONS(12120),
    [anon_sym_PERCENT_EQ] = ACTIONS(12120),
    [anon_sym_GT_GT_EQ] = ACTIONS(12120),
    [anon_sym_LT_LT_EQ] = ACTIONS(12120),
    [anon_sym_CARET_EQ] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(11788),
    [anon_sym_DOT_DOT] = ACTIONS(11790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11792),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(11794),
    [anon_sym_AMP_AMP] = ACTIONS(11794),
    [anon_sym_LT_LT] = ACTIONS(11796),
    [anon_sym_GT_GT] = ACTIONS(11796),
    [anon_sym_EQ_EQ] = ACTIONS(11794),
    [anon_sym_BANG_EQ] = ACTIONS(11798),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11798),
    [anon_sym_LT_EQ_GT] = ACTIONS(11798),
    [anon_sym_EQ_TILDE] = ACTIONS(11798),
    [anon_sym_BANG_TILDE] = ACTIONS(11798),
    [anon_sym_LT_EQ] = ACTIONS(11786),
    [anon_sym_GT] = ACTIONS(11786),
    [anon_sym_GT_EQ] = ACTIONS(11800),
    [anon_sym_CARET] = ACTIONS(11780),
    [anon_sym_PLUS] = ACTIONS(11802),
    [anon_sym_SLASH] = ACTIONS(11782),
    [anon_sym_PERCENT] = ACTIONS(11782),
    [sym_comment] = ACTIONS(87),
  },
  [11064] = {
    [aux_sym_exceptions_repeat1] = STATE(11064),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(15226),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_end] = ACTIONS(11597),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_PLUS_EQ] = ACTIONS(11597),
    [anon_sym_DASH_EQ] = ACTIONS(11597),
    [anon_sym_STAR_EQ] = ACTIONS(11597),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11597),
    [anon_sym_SLASH_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11597),
    [anon_sym_AMP_EQ] = ACTIONS(11597),
    [anon_sym_PERCENT_EQ] = ACTIONS(11597),
    [anon_sym_GT_GT_EQ] = ACTIONS(11597),
    [anon_sym_LT_LT_EQ] = ACTIONS(11597),
    [anon_sym_CARET_EQ] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_LT] = ACTIONS(12338),
    [anon_sym_GT_GT] = ACTIONS(12338),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(12338),
    [anon_sym_PLUS] = ACTIONS(12338),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [11065] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(11812),
    [sym__binary_star] = ACTIONS(11814),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(11816),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(11814),
    [anon_sym_AMP] = ACTIONS(11818),
    [anon_sym_LT] = ACTIONS(11820),
    [anon_sym_end] = ACTIONS(12120),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(11822),
    [anon_sym_DOT_DOT] = ACTIONS(11824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11826),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(11828),
    [anon_sym_AMP_AMP] = ACTIONS(11828),
    [anon_sym_LT_LT] = ACTIONS(11830),
    [anon_sym_GT_GT] = ACTIONS(11830),
    [anon_sym_EQ_EQ] = ACTIONS(11832),
    [anon_sym_BANG_EQ] = ACTIONS(11828),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11828),
    [anon_sym_LT_EQ_GT] = ACTIONS(11828),
    [anon_sym_EQ_TILDE] = ACTIONS(11828),
    [anon_sym_BANG_TILDE] = ACTIONS(11828),
    [anon_sym_LT_EQ] = ACTIONS(11820),
    [anon_sym_GT] = ACTIONS(11820),
    [anon_sym_GT_EQ] = ACTIONS(11834),
    [anon_sym_CARET] = ACTIONS(11836),
    [anon_sym_PLUS] = ACTIONS(11812),
    [anon_sym_SLASH] = ACTIONS(11814),
    [anon_sym_PERCENT] = ACTIONS(11814),
    [sym_comment] = ACTIONS(87),
  },
  [11066] = {
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(11869),
    [sym__binary_star] = ACTIONS(11871),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(11873),
    [anon_sym_STAR_STAR] = ACTIONS(11871),
    [anon_sym_AMP] = ACTIONS(11875),
    [anon_sym_LT] = ACTIONS(11877),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_RBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(11879),
    [anon_sym_DOT_DOT] = ACTIONS(11881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11883),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(11885),
    [anon_sym_AMP_AMP] = ACTIONS(11885),
    [anon_sym_LT_LT] = ACTIONS(11887),
    [anon_sym_GT_GT] = ACTIONS(11887),
    [anon_sym_EQ_EQ] = ACTIONS(11889),
    [anon_sym_BANG_EQ] = ACTIONS(11885),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11885),
    [anon_sym_LT_EQ_GT] = ACTIONS(11885),
    [anon_sym_EQ_TILDE] = ACTIONS(11885),
    [anon_sym_BANG_TILDE] = ACTIONS(11885),
    [anon_sym_LT_EQ] = ACTIONS(11877),
    [anon_sym_GT] = ACTIONS(11877),
    [anon_sym_GT_EQ] = ACTIONS(11891),
    [anon_sym_CARET] = ACTIONS(11893),
    [anon_sym_PLUS] = ACTIONS(11869),
    [anon_sym_SLASH] = ACTIONS(11871),
    [anon_sym_PERCENT] = ACTIONS(11871),
    [sym_comment] = ACTIONS(87),
  },
  [11067] = {
    [aux_sym_exceptions_repeat1] = STATE(11067),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(15229),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_RBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [11068] = {
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(11905),
    [sym__binary_star] = ACTIONS(11907),
    [anon_sym_LBRACE] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(11909),
    [anon_sym_STAR_STAR] = ACTIONS(11911),
    [anon_sym_AMP] = ACTIONS(11913),
    [anon_sym_EQ] = ACTIONS(12879),
    [anon_sym_LT] = ACTIONS(11915),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_RBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_PLUS_EQ] = ACTIONS(12120),
    [anon_sym_DASH_EQ] = ACTIONS(12120),
    [anon_sym_STAR_EQ] = ACTIONS(12120),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12120),
    [anon_sym_SLASH_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12120),
    [anon_sym_AMP_EQ] = ACTIONS(12120),
    [anon_sym_PERCENT_EQ] = ACTIONS(12120),
    [anon_sym_GT_GT_EQ] = ACTIONS(12120),
    [anon_sym_LT_LT_EQ] = ACTIONS(12120),
    [anon_sym_CARET_EQ] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(11917),
    [anon_sym_DOT_DOT] = ACTIONS(11919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11921),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(11923),
    [anon_sym_AMP_AMP] = ACTIONS(11923),
    [anon_sym_LT_LT] = ACTIONS(11925),
    [anon_sym_GT_GT] = ACTIONS(11925),
    [anon_sym_EQ_EQ] = ACTIONS(11923),
    [anon_sym_BANG_EQ] = ACTIONS(11927),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11927),
    [anon_sym_LT_EQ_GT] = ACTIONS(11927),
    [anon_sym_EQ_TILDE] = ACTIONS(11927),
    [anon_sym_BANG_TILDE] = ACTIONS(11927),
    [anon_sym_LT_EQ] = ACTIONS(11915),
    [anon_sym_GT] = ACTIONS(11915),
    [anon_sym_GT_EQ] = ACTIONS(11929),
    [anon_sym_CARET] = ACTIONS(11909),
    [anon_sym_PLUS] = ACTIONS(11931),
    [anon_sym_SLASH] = ACTIONS(11911),
    [anon_sym_PERCENT] = ACTIONS(11911),
    [sym_comment] = ACTIONS(87),
  },
  [11069] = {
    [aux_sym_exceptions_repeat1] = STATE(11069),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(15232),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_RBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_PLUS_EQ] = ACTIONS(11597),
    [anon_sym_DASH_EQ] = ACTIONS(11597),
    [anon_sym_STAR_EQ] = ACTIONS(11597),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11597),
    [anon_sym_SLASH_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11597),
    [anon_sym_AMP_EQ] = ACTIONS(11597),
    [anon_sym_PERCENT_EQ] = ACTIONS(11597),
    [anon_sym_GT_GT_EQ] = ACTIONS(11597),
    [anon_sym_LT_LT_EQ] = ACTIONS(11597),
    [anon_sym_CARET_EQ] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_LT] = ACTIONS(12338),
    [anon_sym_GT_GT] = ACTIONS(12338),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(12338),
    [anon_sym_PLUS] = ACTIONS(12338),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [11070] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(15009),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [11071] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(15007),
    [sym__binary_star] = ACTIONS(15009),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(15011),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(15009),
    [anon_sym_AMP] = ACTIONS(15013),
    [anon_sym_LT] = ACTIONS(15015),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(15017),
    [anon_sym_DOT_DOT] = ACTIONS(15019),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15021),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(15023),
    [anon_sym_AMP_AMP] = ACTIONS(15023),
    [anon_sym_LT_LT] = ACTIONS(15025),
    [anon_sym_GT_GT] = ACTIONS(15025),
    [anon_sym_EQ_EQ] = ACTIONS(15027),
    [anon_sym_BANG_EQ] = ACTIONS(15023),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15023),
    [anon_sym_LT_EQ_GT] = ACTIONS(15023),
    [anon_sym_EQ_TILDE] = ACTIONS(15023),
    [anon_sym_BANG_TILDE] = ACTIONS(15023),
    [anon_sym_LT_EQ] = ACTIONS(15015),
    [anon_sym_GT] = ACTIONS(15015),
    [anon_sym_GT_EQ] = ACTIONS(15029),
    [anon_sym_CARET] = ACTIONS(15031),
    [anon_sym_PLUS] = ACTIONS(15007),
    [anon_sym_SLASH] = ACTIONS(15009),
    [anon_sym_PERCENT] = ACTIONS(15009),
    [sym_comment] = ACTIONS(87),
  },
  [11072] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(11268),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(10709),
    [sym_scope_resolution] = STATE(10707),
    [sym_call] = STATE(10707),
    [sym_method_call] = STATE(10709),
    [sym_assignment] = STATE(11268),
    [sym_operator_assignment] = STATE(11268),
    [sym_conditional] = STATE(11268),
    [sym_range] = STATE(11268),
    [sym_binary] = STATE(11268),
    [sym_unary] = STATE(11268),
    [sym_left_assignment_list] = STATE(10708),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10709),
    [sym__variable] = STATE(10707),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(10709),
    [sym_false] = STATE(10709),
    [sym_nil] = STATE(10709),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(10710),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(14424),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(14426),
    [anon_sym_yield] = ACTIONS(14428),
    [anon_sym_break] = ACTIONS(14430),
    [anon_sym_next] = ACTIONS(14432),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14434),
    [anon_sym_defined_QMARK] = ACTIONS(14436),
    [anon_sym_not] = ACTIONS(14438),
    [anon_sym_BANG] = ACTIONS(14440),
    [anon_sym_TILDE] = ACTIONS(14440),
    [sym_constant] = ACTIONS(14442),
    [sym_identifier] = ACTIONS(14442),
    [sym_instance_variable] = ACTIONS(14444),
    [sym_class_variable] = ACTIONS(14444),
    [sym_global_variable] = ACTIONS(14444),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(14442),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14442),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11073] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(11269),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(10709),
    [sym_scope_resolution] = STATE(10707),
    [sym_call] = STATE(10707),
    [sym_method_call] = STATE(10709),
    [sym_assignment] = STATE(11269),
    [sym_operator_assignment] = STATE(11269),
    [sym_conditional] = STATE(11269),
    [sym_range] = STATE(11269),
    [sym_binary] = STATE(11269),
    [sym_unary] = STATE(11269),
    [sym_left_assignment_list] = STATE(10708),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10709),
    [sym__variable] = STATE(10707),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(10709),
    [sym_false] = STATE(10709),
    [sym_nil] = STATE(10709),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(10710),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(14424),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(14426),
    [anon_sym_yield] = ACTIONS(14428),
    [anon_sym_break] = ACTIONS(14430),
    [anon_sym_next] = ACTIONS(14432),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14434),
    [anon_sym_defined_QMARK] = ACTIONS(14436),
    [anon_sym_not] = ACTIONS(14438),
    [anon_sym_BANG] = ACTIONS(14440),
    [anon_sym_TILDE] = ACTIONS(14440),
    [sym_constant] = ACTIONS(14442),
    [sym_identifier] = ACTIONS(14442),
    [sym_instance_variable] = ACTIONS(14444),
    [sym_class_variable] = ACTIONS(14444),
    [sym_global_variable] = ACTIONS(14444),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(14442),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14442),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11074] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(11270),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(10709),
    [sym_scope_resolution] = STATE(10707),
    [sym_call] = STATE(10707),
    [sym_method_call] = STATE(10709),
    [sym_assignment] = STATE(11270),
    [sym_operator_assignment] = STATE(11270),
    [sym_conditional] = STATE(11270),
    [sym_range] = STATE(11270),
    [sym_binary] = STATE(11270),
    [sym_unary] = STATE(11270),
    [sym_left_assignment_list] = STATE(10708),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10709),
    [sym__variable] = STATE(10707),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(10709),
    [sym_false] = STATE(10709),
    [sym_nil] = STATE(10709),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(10710),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(14424),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(14426),
    [anon_sym_yield] = ACTIONS(14428),
    [anon_sym_break] = ACTIONS(14430),
    [anon_sym_next] = ACTIONS(14432),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14434),
    [anon_sym_defined_QMARK] = ACTIONS(14436),
    [anon_sym_not] = ACTIONS(14438),
    [anon_sym_BANG] = ACTIONS(14440),
    [anon_sym_TILDE] = ACTIONS(14440),
    [sym_constant] = ACTIONS(14442),
    [sym_identifier] = ACTIONS(14442),
    [sym_instance_variable] = ACTIONS(14444),
    [sym_class_variable] = ACTIONS(14444),
    [sym_global_variable] = ACTIONS(14444),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(14442),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14442),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11075] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(11271),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(10709),
    [sym_scope_resolution] = STATE(10707),
    [sym_call] = STATE(10707),
    [sym_method_call] = STATE(10709),
    [sym_assignment] = STATE(11271),
    [sym_operator_assignment] = STATE(11271),
    [sym_conditional] = STATE(11271),
    [sym_range] = STATE(11271),
    [sym_binary] = STATE(11271),
    [sym_unary] = STATE(11271),
    [sym_left_assignment_list] = STATE(10708),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10709),
    [sym__variable] = STATE(10707),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(10709),
    [sym_false] = STATE(10709),
    [sym_nil] = STATE(10709),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(10710),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(14424),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(14426),
    [anon_sym_yield] = ACTIONS(14428),
    [anon_sym_break] = ACTIONS(14430),
    [anon_sym_next] = ACTIONS(14432),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14434),
    [anon_sym_defined_QMARK] = ACTIONS(14436),
    [anon_sym_not] = ACTIONS(14438),
    [anon_sym_BANG] = ACTIONS(14440),
    [anon_sym_TILDE] = ACTIONS(14440),
    [sym_constant] = ACTIONS(14442),
    [sym_identifier] = ACTIONS(14442),
    [sym_instance_variable] = ACTIONS(14444),
    [sym_class_variable] = ACTIONS(14444),
    [sym_global_variable] = ACTIONS(14444),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(14442),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14442),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11076] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(11272),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(10709),
    [sym_scope_resolution] = STATE(10707),
    [sym_call] = STATE(10707),
    [sym_method_call] = STATE(10709),
    [sym_assignment] = STATE(11272),
    [sym_operator_assignment] = STATE(11272),
    [sym_conditional] = STATE(11272),
    [sym_range] = STATE(11272),
    [sym_binary] = STATE(11272),
    [sym_unary] = STATE(11272),
    [sym_left_assignment_list] = STATE(10708),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10709),
    [sym__variable] = STATE(10707),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(10709),
    [sym_false] = STATE(10709),
    [sym_nil] = STATE(10709),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(10710),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(14424),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(14426),
    [anon_sym_yield] = ACTIONS(14428),
    [anon_sym_break] = ACTIONS(14430),
    [anon_sym_next] = ACTIONS(14432),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14434),
    [anon_sym_defined_QMARK] = ACTIONS(14436),
    [anon_sym_not] = ACTIONS(14438),
    [anon_sym_BANG] = ACTIONS(14440),
    [anon_sym_TILDE] = ACTIONS(14440),
    [sym_constant] = ACTIONS(14442),
    [sym_identifier] = ACTIONS(14442),
    [sym_instance_variable] = ACTIONS(14444),
    [sym_class_variable] = ACTIONS(14444),
    [sym_global_variable] = ACTIONS(14444),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(14442),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14442),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11077] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(11273),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(11273),
    [sym_operator_assignment] = STATE(11273),
    [sym_conditional] = STATE(11273),
    [sym_range] = STATE(11273),
    [sym_binary] = STATE(11273),
    [sym_unary] = STATE(11273),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [11078] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(11274),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(10709),
    [sym_scope_resolution] = STATE(10707),
    [sym_call] = STATE(10707),
    [sym_method_call] = STATE(10709),
    [sym_assignment] = STATE(11274),
    [sym_operator_assignment] = STATE(11274),
    [sym_conditional] = STATE(11274),
    [sym_range] = STATE(11274),
    [sym_binary] = STATE(11274),
    [sym_unary] = STATE(11274),
    [sym_left_assignment_list] = STATE(10708),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10709),
    [sym__variable] = STATE(10707),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(10709),
    [sym_false] = STATE(10709),
    [sym_nil] = STATE(10709),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(10710),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(14424),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(14426),
    [anon_sym_yield] = ACTIONS(14428),
    [anon_sym_break] = ACTIONS(14430),
    [anon_sym_next] = ACTIONS(14432),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14434),
    [anon_sym_defined_QMARK] = ACTIONS(14436),
    [anon_sym_not] = ACTIONS(14438),
    [anon_sym_BANG] = ACTIONS(14440),
    [anon_sym_TILDE] = ACTIONS(14440),
    [sym_constant] = ACTIONS(14442),
    [sym_identifier] = ACTIONS(14442),
    [sym_instance_variable] = ACTIONS(14444),
    [sym_class_variable] = ACTIONS(14444),
    [sym_global_variable] = ACTIONS(14444),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(14442),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14442),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11079] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(11275),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(10709),
    [sym_scope_resolution] = STATE(10707),
    [sym_call] = STATE(10707),
    [sym_method_call] = STATE(10709),
    [sym_assignment] = STATE(11275),
    [sym_operator_assignment] = STATE(11275),
    [sym_conditional] = STATE(11275),
    [sym_range] = STATE(11275),
    [sym_binary] = STATE(11275),
    [sym_unary] = STATE(11275),
    [sym_left_assignment_list] = STATE(10708),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10709),
    [sym__variable] = STATE(10707),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(10709),
    [sym_false] = STATE(10709),
    [sym_nil] = STATE(10709),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(10710),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(14424),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(14426),
    [anon_sym_yield] = ACTIONS(14428),
    [anon_sym_break] = ACTIONS(14430),
    [anon_sym_next] = ACTIONS(14432),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14434),
    [anon_sym_defined_QMARK] = ACTIONS(14436),
    [anon_sym_not] = ACTIONS(14438),
    [anon_sym_BANG] = ACTIONS(14440),
    [anon_sym_TILDE] = ACTIONS(14440),
    [sym_constant] = ACTIONS(14442),
    [sym_identifier] = ACTIONS(14442),
    [sym_instance_variable] = ACTIONS(14444),
    [sym_class_variable] = ACTIONS(14444),
    [sym_global_variable] = ACTIONS(14444),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(14442),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14442),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11080] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(11276),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(10709),
    [sym_scope_resolution] = STATE(10707),
    [sym_call] = STATE(10707),
    [sym_method_call] = STATE(10709),
    [sym_assignment] = STATE(11276),
    [sym_operator_assignment] = STATE(11276),
    [sym_conditional] = STATE(11276),
    [sym_range] = STATE(11276),
    [sym_binary] = STATE(11276),
    [sym_unary] = STATE(11276),
    [sym_left_assignment_list] = STATE(10708),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10709),
    [sym__variable] = STATE(10707),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(10709),
    [sym_false] = STATE(10709),
    [sym_nil] = STATE(10709),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(10710),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(14424),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(14426),
    [anon_sym_yield] = ACTIONS(14428),
    [anon_sym_break] = ACTIONS(14430),
    [anon_sym_next] = ACTIONS(14432),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14434),
    [anon_sym_defined_QMARK] = ACTIONS(14436),
    [anon_sym_not] = ACTIONS(14438),
    [anon_sym_BANG] = ACTIONS(14440),
    [anon_sym_TILDE] = ACTIONS(14440),
    [sym_constant] = ACTIONS(14442),
    [sym_identifier] = ACTIONS(14442),
    [sym_instance_variable] = ACTIONS(14444),
    [sym_class_variable] = ACTIONS(14444),
    [sym_global_variable] = ACTIONS(14444),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(14442),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14442),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11081] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(11277),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(10709),
    [sym_scope_resolution] = STATE(10707),
    [sym_call] = STATE(10707),
    [sym_method_call] = STATE(10709),
    [sym_assignment] = STATE(11277),
    [sym_operator_assignment] = STATE(11277),
    [sym_conditional] = STATE(11277),
    [sym_range] = STATE(11277),
    [sym_binary] = STATE(11277),
    [sym_unary] = STATE(11277),
    [sym_left_assignment_list] = STATE(10708),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10709),
    [sym__variable] = STATE(10707),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(10709),
    [sym_false] = STATE(10709),
    [sym_nil] = STATE(10709),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(10710),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(14424),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(14426),
    [anon_sym_yield] = ACTIONS(14428),
    [anon_sym_break] = ACTIONS(14430),
    [anon_sym_next] = ACTIONS(14432),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14434),
    [anon_sym_defined_QMARK] = ACTIONS(14436),
    [anon_sym_not] = ACTIONS(14438),
    [anon_sym_BANG] = ACTIONS(14440),
    [anon_sym_TILDE] = ACTIONS(14440),
    [sym_constant] = ACTIONS(14442),
    [sym_identifier] = ACTIONS(14442),
    [sym_instance_variable] = ACTIONS(14444),
    [sym_class_variable] = ACTIONS(14444),
    [sym_global_variable] = ACTIONS(14444),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(14442),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14442),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11082] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(11278),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(10709),
    [sym_scope_resolution] = STATE(10707),
    [sym_call] = STATE(10707),
    [sym_method_call] = STATE(10709),
    [sym_splat_argument] = STATE(11279),
    [sym_assignment] = STATE(11278),
    [sym_operator_assignment] = STATE(11278),
    [sym_conditional] = STATE(11278),
    [sym_range] = STATE(11278),
    [sym_binary] = STATE(11278),
    [sym_unary] = STATE(11278),
    [sym_right_assignment_list] = STATE(4255),
    [sym__arg_or_splat_arg] = STATE(11279),
    [sym_left_assignment_list] = STATE(10708),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10709),
    [sym__variable] = STATE(10707),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(10709),
    [sym_false] = STATE(10709),
    [sym_nil] = STATE(10709),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(10710),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(13603),
    [sym__unary_minus] = ACTIONS(14424),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(14426),
    [anon_sym_yield] = ACTIONS(14428),
    [anon_sym_break] = ACTIONS(14430),
    [anon_sym_next] = ACTIONS(14432),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14434),
    [anon_sym_defined_QMARK] = ACTIONS(14436),
    [anon_sym_not] = ACTIONS(14438),
    [anon_sym_BANG] = ACTIONS(14440),
    [anon_sym_TILDE] = ACTIONS(14440),
    [sym_constant] = ACTIONS(14442),
    [sym_identifier] = ACTIONS(14442),
    [sym_instance_variable] = ACTIONS(14444),
    [sym_class_variable] = ACTIONS(14444),
    [sym_global_variable] = ACTIONS(14444),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(14442),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14442),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11083] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(11280),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(10709),
    [sym_scope_resolution] = STATE(10707),
    [sym_call] = STATE(10707),
    [sym_method_call] = STATE(10709),
    [sym_assignment] = STATE(11280),
    [sym_operator_assignment] = STATE(11280),
    [sym_conditional] = STATE(11280),
    [sym_range] = STATE(11280),
    [sym_binary] = STATE(11280),
    [sym_unary] = STATE(11280),
    [sym_left_assignment_list] = STATE(10708),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10709),
    [sym__variable] = STATE(10707),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(10709),
    [sym_false] = STATE(10709),
    [sym_nil] = STATE(10709),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(10710),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(14424),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(14426),
    [anon_sym_yield] = ACTIONS(14428),
    [anon_sym_break] = ACTIONS(14430),
    [anon_sym_next] = ACTIONS(14432),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14434),
    [anon_sym_defined_QMARK] = ACTIONS(14436),
    [anon_sym_not] = ACTIONS(14438),
    [anon_sym_BANG] = ACTIONS(14440),
    [anon_sym_TILDE] = ACTIONS(14440),
    [sym_constant] = ACTIONS(14442),
    [sym_identifier] = ACTIONS(14442),
    [sym_instance_variable] = ACTIONS(14444),
    [sym_class_variable] = ACTIONS(14444),
    [sym_global_variable] = ACTIONS(14444),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(14442),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14442),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11084] = {
    [sym_string] = STATE(11281),
    [aux_sym_chained_string_repeat1] = STATE(11281),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_LT_LT] = ACTIONS(2753),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(87),
  },
  [11085] = {
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(15007),
    [sym__binary_star] = ACTIONS(15009),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(15011),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(15009),
    [anon_sym_AMP] = ACTIONS(15013),
    [anon_sym_LT] = ACTIONS(15015),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(15017),
    [anon_sym_DOT_DOT] = ACTIONS(15019),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15021),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(15023),
    [anon_sym_AMP_AMP] = ACTIONS(15023),
    [anon_sym_LT_LT] = ACTIONS(15025),
    [anon_sym_GT_GT] = ACTIONS(15025),
    [anon_sym_EQ_EQ] = ACTIONS(15027),
    [anon_sym_BANG_EQ] = ACTIONS(15023),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15023),
    [anon_sym_LT_EQ_GT] = ACTIONS(15023),
    [anon_sym_EQ_TILDE] = ACTIONS(15023),
    [anon_sym_BANG_TILDE] = ACTIONS(15023),
    [anon_sym_LT_EQ] = ACTIONS(15015),
    [anon_sym_GT] = ACTIONS(15015),
    [anon_sym_GT_EQ] = ACTIONS(15029),
    [anon_sym_CARET] = ACTIONS(15031),
    [anon_sym_PLUS] = ACTIONS(15007),
    [anon_sym_SLASH] = ACTIONS(15009),
    [anon_sym_PERCENT] = ACTIONS(15009),
    [sym_comment] = ACTIONS(87),
  },
  [11086] = {
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(14460),
    [sym__binary_star] = ACTIONS(14462),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(14464),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(14462),
    [anon_sym_AMP] = ACTIONS(14466),
    [anon_sym_LT] = ACTIONS(14468),
    [anon_sym_EQ_GT] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(14470),
    [anon_sym_DOT_DOT] = ACTIONS(14472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14474),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(14476),
    [anon_sym_AMP_AMP] = ACTIONS(14476),
    [anon_sym_LT_LT] = ACTIONS(14478),
    [anon_sym_GT_GT] = ACTIONS(14478),
    [anon_sym_EQ_EQ] = ACTIONS(14480),
    [anon_sym_BANG_EQ] = ACTIONS(14476),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14476),
    [anon_sym_LT_EQ_GT] = ACTIONS(14476),
    [anon_sym_EQ_TILDE] = ACTIONS(14476),
    [anon_sym_BANG_TILDE] = ACTIONS(14476),
    [anon_sym_LT_EQ] = ACTIONS(14468),
    [anon_sym_GT] = ACTIONS(14468),
    [anon_sym_GT_EQ] = ACTIONS(14482),
    [anon_sym_CARET] = ACTIONS(14484),
    [anon_sym_PLUS] = ACTIONS(14460),
    [anon_sym_SLASH] = ACTIONS(14462),
    [anon_sym_PERCENT] = ACTIONS(14462),
    [sym_comment] = ACTIONS(87),
  },
  [11087] = {
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(14460),
    [sym__binary_star] = ACTIONS(14462),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(14464),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(14462),
    [anon_sym_AMP] = ACTIONS(14466),
    [anon_sym_LT] = ACTIONS(14468),
    [anon_sym_EQ_GT] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(14470),
    [anon_sym_DOT_DOT] = ACTIONS(14472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14474),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(14476),
    [anon_sym_AMP_AMP] = ACTIONS(14476),
    [anon_sym_LT_LT] = ACTIONS(14478),
    [anon_sym_GT_GT] = ACTIONS(14478),
    [anon_sym_EQ_EQ] = ACTIONS(14480),
    [anon_sym_BANG_EQ] = ACTIONS(14476),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14476),
    [anon_sym_LT_EQ_GT] = ACTIONS(14476),
    [anon_sym_EQ_TILDE] = ACTIONS(14476),
    [anon_sym_BANG_TILDE] = ACTIONS(14476),
    [anon_sym_LT_EQ] = ACTIONS(14468),
    [anon_sym_GT] = ACTIONS(14468),
    [anon_sym_GT_EQ] = ACTIONS(14482),
    [anon_sym_CARET] = ACTIONS(14484),
    [anon_sym_PLUS] = ACTIONS(14460),
    [anon_sym_SLASH] = ACTIONS(14462),
    [anon_sym_PERCENT] = ACTIONS(14462),
    [sym_comment] = ACTIONS(87),
  },
  [11088] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(11282),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(9932),
    [sym_scope_resolution] = STATE(9928),
    [sym_call] = STATE(9928),
    [sym_method_call] = STATE(9932),
    [sym_assignment] = STATE(11282),
    [sym_operator_assignment] = STATE(11282),
    [sym_conditional] = STATE(11282),
    [sym_range] = STATE(11282),
    [sym_binary] = STATE(11282),
    [sym_unary] = STATE(11282),
    [sym_left_assignment_list] = STATE(9931),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9932),
    [sym__variable] = STATE(9928),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(9932),
    [sym_false] = STATE(9932),
    [sym_nil] = STATE(9932),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(10713),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(13605),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13609),
    [anon_sym_yield] = ACTIONS(13611),
    [anon_sym_break] = ACTIONS(13613),
    [anon_sym_next] = ACTIONS(13615),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14446),
    [anon_sym_defined_QMARK] = ACTIONS(13617),
    [anon_sym_not] = ACTIONS(13619),
    [anon_sym_BANG] = ACTIONS(13623),
    [anon_sym_TILDE] = ACTIONS(13623),
    [sym_constant] = ACTIONS(13629),
    [sym_identifier] = ACTIONS(13629),
    [sym_instance_variable] = ACTIONS(13627),
    [sym_class_variable] = ACTIONS(13627),
    [sym_global_variable] = ACTIONS(13627),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13629),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13629),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11089] = {
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(14460),
    [sym__binary_star] = ACTIONS(14462),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(14464),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(14462),
    [anon_sym_AMP] = ACTIONS(14466),
    [anon_sym_LT] = ACTIONS(14468),
    [anon_sym_EQ_GT] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(14470),
    [anon_sym_DOT_DOT] = ACTIONS(14472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14474),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(14476),
    [anon_sym_AMP_AMP] = ACTIONS(14476),
    [anon_sym_LT_LT] = ACTIONS(14478),
    [anon_sym_GT_GT] = ACTIONS(14478),
    [anon_sym_EQ_EQ] = ACTIONS(14480),
    [anon_sym_BANG_EQ] = ACTIONS(14476),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14476),
    [anon_sym_LT_EQ_GT] = ACTIONS(14476),
    [anon_sym_EQ_TILDE] = ACTIONS(14476),
    [anon_sym_BANG_TILDE] = ACTIONS(14476),
    [anon_sym_LT_EQ] = ACTIONS(14468),
    [anon_sym_GT] = ACTIONS(14468),
    [anon_sym_GT_EQ] = ACTIONS(14482),
    [anon_sym_CARET] = ACTIONS(14484),
    [anon_sym_PLUS] = ACTIONS(14460),
    [anon_sym_SLASH] = ACTIONS(14462),
    [anon_sym_PERCENT] = ACTIONS(14462),
    [sym_comment] = ACTIONS(87),
  },
  [11090] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(11283),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(9932),
    [sym_scope_resolution] = STATE(9928),
    [sym_call] = STATE(9928),
    [sym_method_call] = STATE(9932),
    [sym_assignment] = STATE(11283),
    [sym_operator_assignment] = STATE(11283),
    [sym_conditional] = STATE(11283),
    [sym_range] = STATE(11283),
    [sym_binary] = STATE(11283),
    [sym_unary] = STATE(11283),
    [sym_left_assignment_list] = STATE(9931),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9932),
    [sym__variable] = STATE(9928),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(9932),
    [sym_false] = STATE(9932),
    [sym_nil] = STATE(9932),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(10713),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(13605),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13609),
    [anon_sym_yield] = ACTIONS(13611),
    [anon_sym_break] = ACTIONS(13613),
    [anon_sym_next] = ACTIONS(13615),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14446),
    [anon_sym_defined_QMARK] = ACTIONS(13617),
    [anon_sym_not] = ACTIONS(13619),
    [anon_sym_BANG] = ACTIONS(13623),
    [anon_sym_TILDE] = ACTIONS(13623),
    [sym_constant] = ACTIONS(13629),
    [sym_identifier] = ACTIONS(13629),
    [sym_instance_variable] = ACTIONS(13627),
    [sym_class_variable] = ACTIONS(13627),
    [sym_global_variable] = ACTIONS(13627),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13629),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13629),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11091] = {
    [sym_heredoc_body] = STATE(11284),
    [aux_sym_call_repeat1] = STATE(11284),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [11092] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(10721),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(9932),
    [sym_scope_resolution] = STATE(9928),
    [sym_call] = STATE(9928),
    [sym_method_call] = STATE(9932),
    [sym__argument] = STATE(4250),
    [sym_splat_argument] = STATE(4250),
    [sym_hash_splat_argument] = STATE(4250),
    [sym_block_argument] = STATE(4250),
    [sym_assignment] = STATE(10721),
    [sym_operator_assignment] = STATE(10721),
    [sym_conditional] = STATE(10721),
    [sym_range] = STATE(10721),
    [sym_binary] = STATE(10721),
    [sym_unary] = STATE(10721),
    [sym_left_assignment_list] = STATE(9931),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9932),
    [sym__variable] = STATE(9928),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(9932),
    [sym_false] = STATE(9932),
    [sym_nil] = STATE(9932),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(10724),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_heredoc_body] = STATE(11285),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(4250),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(14450),
    [sym__splat_star] = ACTIONS(14452),
    [sym__unary_minus] = ACTIONS(13605),
    [sym__identifier_hash_key] = ACTIONS(14454),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(15235),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13609),
    [anon_sym_yield] = ACTIONS(13611),
    [anon_sym_break] = ACTIONS(13613),
    [anon_sym_next] = ACTIONS(13615),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14446),
    [anon_sym_defined_QMARK] = ACTIONS(13617),
    [anon_sym_not] = ACTIONS(13619),
    [anon_sym_BANG] = ACTIONS(13623),
    [anon_sym_TILDE] = ACTIONS(13623),
    [sym_constant] = ACTIONS(14456),
    [sym_identifier] = ACTIONS(14456),
    [sym_instance_variable] = ACTIONS(13627),
    [sym_class_variable] = ACTIONS(13627),
    [sym_global_variable] = ACTIONS(13627),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13629),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13629),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11093] = {
    [sym_heredoc_body] = STATE(11286),
    [aux_sym_call_repeat1] = STATE(11286),
    [aux_sym_argument_list_repeat1] = STATE(11287),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(15043),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [11094] = {
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(15007),
    [sym__binary_star] = ACTIONS(15009),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(15011),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(15009),
    [anon_sym_AMP] = ACTIONS(15013),
    [anon_sym_LT] = ACTIONS(15015),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(15017),
    [anon_sym_DOT_DOT] = ACTIONS(15019),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15021),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(15023),
    [anon_sym_AMP_AMP] = ACTIONS(15023),
    [anon_sym_LT_LT] = ACTIONS(15025),
    [anon_sym_GT_GT] = ACTIONS(15025),
    [anon_sym_EQ_EQ] = ACTIONS(15027),
    [anon_sym_BANG_EQ] = ACTIONS(15023),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15023),
    [anon_sym_LT_EQ_GT] = ACTIONS(15023),
    [anon_sym_EQ_TILDE] = ACTIONS(15023),
    [anon_sym_BANG_TILDE] = ACTIONS(15023),
    [anon_sym_LT_EQ] = ACTIONS(15015),
    [anon_sym_GT] = ACTIONS(15015),
    [anon_sym_GT_EQ] = ACTIONS(15029),
    [anon_sym_CARET] = ACTIONS(15031),
    [anon_sym_PLUS] = ACTIONS(15007),
    [anon_sym_SLASH] = ACTIONS(15009),
    [anon_sym_PERCENT] = ACTIONS(15009),
    [sym_comment] = ACTIONS(87),
  },
  [11095] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(14462),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(14462),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(14462),
    [anon_sym_PERCENT] = ACTIONS(14462),
    [sym_comment] = ACTIONS(87),
  },
  [11096] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(14462),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [11097] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(14460),
    [sym__binary_star] = ACTIONS(14462),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(14462),
    [anon_sym_AMP] = ACTIONS(14466),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(14478),
    [anon_sym_GT_GT] = ACTIONS(14478),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(14460),
    [anon_sym_SLASH] = ACTIONS(14462),
    [anon_sym_PERCENT] = ACTIONS(14462),
    [sym_comment] = ACTIONS(87),
  },
  [11098] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(14460),
    [sym__binary_star] = ACTIONS(14462),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(14462),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(14478),
    [anon_sym_GT_GT] = ACTIONS(14478),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(14460),
    [anon_sym_SLASH] = ACTIONS(14462),
    [anon_sym_PERCENT] = ACTIONS(14462),
    [sym_comment] = ACTIONS(87),
  },
  [11099] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(14460),
    [sym__binary_star] = ACTIONS(14462),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(14464),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(14462),
    [anon_sym_AMP] = ACTIONS(14466),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(14478),
    [anon_sym_GT_GT] = ACTIONS(14478),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(14484),
    [anon_sym_PLUS] = ACTIONS(14460),
    [anon_sym_SLASH] = ACTIONS(14462),
    [anon_sym_PERCENT] = ACTIONS(14462),
    [sym_comment] = ACTIONS(87),
  },
  [11100] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(15237),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [11101] = {
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(14460),
    [sym__binary_star] = ACTIONS(14462),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(14464),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(14462),
    [anon_sym_AMP] = ACTIONS(14466),
    [anon_sym_LT] = ACTIONS(14468),
    [anon_sym_EQ_GT] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(14472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14474),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(14476),
    [anon_sym_AMP_AMP] = ACTIONS(14476),
    [anon_sym_LT_LT] = ACTIONS(14478),
    [anon_sym_GT_GT] = ACTIONS(14478),
    [anon_sym_EQ_EQ] = ACTIONS(14480),
    [anon_sym_BANG_EQ] = ACTIONS(14476),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14476),
    [anon_sym_LT_EQ_GT] = ACTIONS(14476),
    [anon_sym_EQ_TILDE] = ACTIONS(14476),
    [anon_sym_BANG_TILDE] = ACTIONS(14476),
    [anon_sym_LT_EQ] = ACTIONS(14468),
    [anon_sym_GT] = ACTIONS(14468),
    [anon_sym_GT_EQ] = ACTIONS(14482),
    [anon_sym_CARET] = ACTIONS(14484),
    [anon_sym_PLUS] = ACTIONS(14460),
    [anon_sym_SLASH] = ACTIONS(14462),
    [anon_sym_PERCENT] = ACTIONS(14462),
    [sym_comment] = ACTIONS(87),
  },
  [11102] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(14460),
    [sym__binary_star] = ACTIONS(14462),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(14464),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(14462),
    [anon_sym_AMP] = ACTIONS(14466),
    [anon_sym_LT] = ACTIONS(14468),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(14470),
    [anon_sym_DOT_DOT] = ACTIONS(14472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14474),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(14476),
    [anon_sym_AMP_AMP] = ACTIONS(14476),
    [anon_sym_LT_LT] = ACTIONS(14478),
    [anon_sym_GT_GT] = ACTIONS(14478),
    [anon_sym_EQ_EQ] = ACTIONS(14480),
    [anon_sym_BANG_EQ] = ACTIONS(14476),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14476),
    [anon_sym_LT_EQ_GT] = ACTIONS(14476),
    [anon_sym_EQ_TILDE] = ACTIONS(14476),
    [anon_sym_BANG_TILDE] = ACTIONS(14476),
    [anon_sym_LT_EQ] = ACTIONS(14468),
    [anon_sym_GT] = ACTIONS(14468),
    [anon_sym_GT_EQ] = ACTIONS(14482),
    [anon_sym_CARET] = ACTIONS(14484),
    [anon_sym_PLUS] = ACTIONS(14460),
    [anon_sym_SLASH] = ACTIONS(14462),
    [anon_sym_PERCENT] = ACTIONS(14462),
    [sym_comment] = ACTIONS(87),
  },
  [11103] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(14460),
    [sym__binary_star] = ACTIONS(14462),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(14464),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(14462),
    [anon_sym_AMP] = ACTIONS(14466),
    [anon_sym_LT] = ACTIONS(14468),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(14478),
    [anon_sym_GT_GT] = ACTIONS(14478),
    [anon_sym_EQ_EQ] = ACTIONS(14480),
    [anon_sym_BANG_EQ] = ACTIONS(14476),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14476),
    [anon_sym_LT_EQ_GT] = ACTIONS(14476),
    [anon_sym_EQ_TILDE] = ACTIONS(14476),
    [anon_sym_BANG_TILDE] = ACTIONS(14476),
    [anon_sym_LT_EQ] = ACTIONS(14468),
    [anon_sym_GT] = ACTIONS(14468),
    [anon_sym_GT_EQ] = ACTIONS(14482),
    [anon_sym_CARET] = ACTIONS(14484),
    [anon_sym_PLUS] = ACTIONS(14460),
    [anon_sym_SLASH] = ACTIONS(14462),
    [anon_sym_PERCENT] = ACTIONS(14462),
    [sym_comment] = ACTIONS(87),
  },
  [11104] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(14460),
    [sym__binary_star] = ACTIONS(14462),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(14462),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(14460),
    [anon_sym_SLASH] = ACTIONS(14462),
    [anon_sym_PERCENT] = ACTIONS(14462),
    [sym_comment] = ACTIONS(87),
  },
  [11105] = {
    [sym__heredoc_body_start] = ACTIONS(4211),
    [sym__binary_minus] = ACTIONS(14534),
    [sym__binary_star] = ACTIONS(14536),
    [anon_sym_LBRACE] = ACTIONS(4211),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_PIPE] = ACTIONS(14538),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_STAR_STAR] = ACTIONS(14540),
    [anon_sym_AMP] = ACTIONS(14542),
    [anon_sym_EQ] = ACTIONS(4217),
    [anon_sym_LT] = ACTIONS(14544),
    [anon_sym_do] = ACTIONS(4211),
    [anon_sym_EQ_GT] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(4211),
    [anon_sym_COLON_COLON2] = ACTIONS(4211),
    [anon_sym_AMP_DOT] = ACTIONS(4211),
    [anon_sym_PLUS_EQ] = ACTIONS(4211),
    [anon_sym_DASH_EQ] = ACTIONS(4211),
    [anon_sym_STAR_EQ] = ACTIONS(4211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4211),
    [anon_sym_SLASH_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_PIPE_EQ] = ACTIONS(4211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4211),
    [anon_sym_AMP_EQ] = ACTIONS(4211),
    [anon_sym_PERCENT_EQ] = ACTIONS(4211),
    [anon_sym_GT_GT_EQ] = ACTIONS(4211),
    [anon_sym_LT_LT_EQ] = ACTIONS(4211),
    [anon_sym_CARET_EQ] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(14546),
    [anon_sym_DOT_DOT] = ACTIONS(14548),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14550),
    [anon_sym_and] = ACTIONS(4211),
    [anon_sym_or] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(14552),
    [anon_sym_AMP_AMP] = ACTIONS(14552),
    [anon_sym_LT_LT] = ACTIONS(14554),
    [anon_sym_GT_GT] = ACTIONS(14554),
    [anon_sym_EQ_EQ] = ACTIONS(14552),
    [anon_sym_BANG_EQ] = ACTIONS(14556),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14556),
    [anon_sym_LT_EQ_GT] = ACTIONS(14556),
    [anon_sym_EQ_TILDE] = ACTIONS(14556),
    [anon_sym_BANG_TILDE] = ACTIONS(14556),
    [anon_sym_LT_EQ] = ACTIONS(14544),
    [anon_sym_GT] = ACTIONS(14544),
    [anon_sym_GT_EQ] = ACTIONS(14558),
    [anon_sym_CARET] = ACTIONS(14538),
    [anon_sym_PLUS] = ACTIONS(14560),
    [anon_sym_SLASH] = ACTIONS(14540),
    [anon_sym_PERCENT] = ACTIONS(14540),
    [sym_comment] = ACTIONS(87),
  },
  [11106] = {
    [sym__heredoc_body_start] = ACTIONS(4247),
    [sym__binary_minus] = ACTIONS(14534),
    [sym__binary_star] = ACTIONS(14536),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(4249),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(14538),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(14540),
    [anon_sym_AMP] = ACTIONS(14542),
    [anon_sym_EQ] = ACTIONS(4249),
    [anon_sym_LT] = ACTIONS(14544),
    [anon_sym_do] = ACTIONS(4247),
    [anon_sym_EQ_GT] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON_COLON2] = ACTIONS(4247),
    [anon_sym_AMP_DOT] = ACTIONS(4247),
    [anon_sym_PLUS_EQ] = ACTIONS(4247),
    [anon_sym_DASH_EQ] = ACTIONS(4247),
    [anon_sym_STAR_EQ] = ACTIONS(4247),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4247),
    [anon_sym_SLASH_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_PIPE_EQ] = ACTIONS(4247),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4247),
    [anon_sym_AMP_EQ] = ACTIONS(4247),
    [anon_sym_PERCENT_EQ] = ACTIONS(4247),
    [anon_sym_GT_GT_EQ] = ACTIONS(4247),
    [anon_sym_LT_LT_EQ] = ACTIONS(4247),
    [anon_sym_CARET_EQ] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(14546),
    [anon_sym_DOT_DOT] = ACTIONS(14548),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14550),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(14552),
    [anon_sym_AMP_AMP] = ACTIONS(14552),
    [anon_sym_LT_LT] = ACTIONS(14554),
    [anon_sym_GT_GT] = ACTIONS(14554),
    [anon_sym_EQ_EQ] = ACTIONS(14552),
    [anon_sym_BANG_EQ] = ACTIONS(14556),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14556),
    [anon_sym_LT_EQ_GT] = ACTIONS(14556),
    [anon_sym_EQ_TILDE] = ACTIONS(14556),
    [anon_sym_BANG_TILDE] = ACTIONS(14556),
    [anon_sym_LT_EQ] = ACTIONS(14544),
    [anon_sym_GT] = ACTIONS(14544),
    [anon_sym_GT_EQ] = ACTIONS(14558),
    [anon_sym_CARET] = ACTIONS(14538),
    [anon_sym_PLUS] = ACTIONS(14560),
    [anon_sym_SLASH] = ACTIONS(14540),
    [anon_sym_PERCENT] = ACTIONS(14540),
    [sym_comment] = ACTIONS(87),
  },
  [11107] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(11289),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9962),
    [sym_scope_resolution] = STATE(9958),
    [sym_call] = STATE(9958),
    [sym_method_call] = STATE(9962),
    [sym_assignment] = STATE(11289),
    [sym_operator_assignment] = STATE(11289),
    [sym_conditional] = STATE(11289),
    [sym_range] = STATE(11289),
    [sym_binary] = STATE(11289),
    [sym_unary] = STATE(11289),
    [sym_left_assignment_list] = STATE(9961),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9962),
    [sym__variable] = STATE(9958),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9962),
    [sym_false] = STATE(9962),
    [sym_nil] = STATE(9962),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10776),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(13663),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13667),
    [anon_sym_yield] = ACTIONS(13669),
    [anon_sym_break] = ACTIONS(13671),
    [anon_sym_next] = ACTIONS(13673),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(14528),
    [anon_sym_defined_QMARK] = ACTIONS(13675),
    [anon_sym_not] = ACTIONS(13677),
    [anon_sym_BANG] = ACTIONS(13681),
    [anon_sym_TILDE] = ACTIONS(13681),
    [sym_constant] = ACTIONS(13687),
    [sym_identifier] = ACTIONS(13687),
    [sym_instance_variable] = ACTIONS(13685),
    [sym_class_variable] = ACTIONS(13685),
    [sym_global_variable] = ACTIONS(13685),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13687),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13687),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [11108] = {
    [sym__heredoc_body_start] = ACTIONS(3281),
    [sym__binary_minus] = ACTIONS(14534),
    [sym__binary_star] = ACTIONS(14536),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_COMMA] = ACTIONS(3281),
    [anon_sym_PIPE] = ACTIONS(14538),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR_STAR] = ACTIONS(14540),
    [anon_sym_AMP] = ACTIONS(14542),
    [anon_sym_EQ] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(14544),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_EQ_GT] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_COLON_COLON2] = ACTIONS(3281),
    [anon_sym_AMP_DOT] = ACTIONS(3281),
    [anon_sym_PLUS_EQ] = ACTIONS(3281),
    [anon_sym_DASH_EQ] = ACTIONS(3281),
    [anon_sym_STAR_EQ] = ACTIONS(3281),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3281),
    [anon_sym_SLASH_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_PIPE_EQ] = ACTIONS(3281),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3281),
    [anon_sym_AMP_EQ] = ACTIONS(3281),
    [anon_sym_PERCENT_EQ] = ACTIONS(3281),
    [anon_sym_GT_GT_EQ] = ACTIONS(3281),
    [anon_sym_LT_LT_EQ] = ACTIONS(3281),
    [anon_sym_CARET_EQ] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(14546),
    [anon_sym_DOT_DOT] = ACTIONS(14548),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14550),
    [anon_sym_and] = ACTIONS(3281),
    [anon_sym_or] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(14552),
    [anon_sym_AMP_AMP] = ACTIONS(14552),
    [anon_sym_LT_LT] = ACTIONS(14554),
    [anon_sym_GT_GT] = ACTIONS(14554),
    [anon_sym_EQ_EQ] = ACTIONS(14552),
    [anon_sym_BANG_EQ] = ACTIONS(14556),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14556),
    [anon_sym_LT_EQ_GT] = ACTIONS(14556),
    [anon_sym_EQ_TILDE] = ACTIONS(14556),
    [anon_sym_BANG_TILDE] = ACTIONS(14556),
    [anon_sym_LT_EQ] = ACTIONS(14544),
    [anon_sym_GT] = ACTIONS(14544),
    [anon_sym_GT_EQ] = ACTIONS(14558),
    [anon_sym_CARET] = ACTIONS(14538),
    [anon_sym_PLUS] = ACTIONS(14560),
    [anon_sym_SLASH] = ACTIONS(14540),
    [anon_sym_PERCENT] = ACTIONS(14540),
    [sym_comment] = ACTIONS(87),
  },
  [11109] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(11290),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9962),
    [sym_scope_resolution] = STATE(9958),
    [sym_call] = STATE(9958),
    [sym_method_call] = STATE(9962),
    [sym_assignment] = STATE(11290),
    [sym_operator_assignment] = STATE(11290),
    [sym_conditional] = STATE(11290),
    [sym_range] = STATE(11290),
    [sym_binary] = STATE(11290),
    [sym_unary] = STATE(11290),
    [sym_left_assignment_list] = STATE(9961),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9962),
    [sym__variable] = STATE(9958),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9962),
    [sym_false] = STATE(9962),
    [sym_nil] = STATE(9962),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10776),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(13663),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13667),
    [anon_sym_yield] = ACTIONS(13669),
    [anon_sym_break] = ACTIONS(13671),
    [anon_sym_next] = ACTIONS(13673),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(14528),
    [anon_sym_defined_QMARK] = ACTIONS(13675),
    [anon_sym_not] = ACTIONS(13677),
    [anon_sym_BANG] = ACTIONS(13681),
    [anon_sym_TILDE] = ACTIONS(13681),
    [sym_constant] = ACTIONS(13687),
    [sym_identifier] = ACTIONS(13687),
    [sym_instance_variable] = ACTIONS(13685),
    [sym_class_variable] = ACTIONS(13685),
    [sym_global_variable] = ACTIONS(13685),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13687),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13687),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [11110] = {
    [sym_heredoc_body] = STATE(11291),
    [aux_sym_call_repeat1] = STATE(11291),
    [sym__heredoc_body_start] = ACTIONS(3543),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [11111] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(10742),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9962),
    [sym_scope_resolution] = STATE(9958),
    [sym_call] = STATE(9958),
    [sym_method_call] = STATE(9962),
    [sym__argument] = STATE(4357),
    [sym_splat_argument] = STATE(4357),
    [sym_hash_splat_argument] = STATE(4357),
    [sym_block_argument] = STATE(4357),
    [sym_assignment] = STATE(10742),
    [sym_operator_assignment] = STATE(10742),
    [sym_conditional] = STATE(10742),
    [sym_range] = STATE(10742),
    [sym_binary] = STATE(10742),
    [sym_unary] = STATE(10742),
    [sym_left_assignment_list] = STATE(9961),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9962),
    [sym__variable] = STATE(9958),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9962),
    [sym_false] = STATE(9962),
    [sym_nil] = STATE(9962),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10745),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_heredoc_body] = STATE(11292),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(4357),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(4387),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(14486),
    [sym__splat_star] = ACTIONS(14488),
    [sym__unary_minus] = ACTIONS(13663),
    [sym__identifier_hash_key] = ACTIONS(14490),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(15239),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13667),
    [anon_sym_yield] = ACTIONS(13669),
    [anon_sym_break] = ACTIONS(13671),
    [anon_sym_next] = ACTIONS(13673),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(14528),
    [anon_sym_defined_QMARK] = ACTIONS(13675),
    [anon_sym_not] = ACTIONS(13677),
    [anon_sym_BANG] = ACTIONS(13681),
    [anon_sym_TILDE] = ACTIONS(13681),
    [sym_constant] = ACTIONS(14492),
    [sym_identifier] = ACTIONS(14492),
    [sym_instance_variable] = ACTIONS(13685),
    [sym_class_variable] = ACTIONS(13685),
    [sym_global_variable] = ACTIONS(13685),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13687),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13687),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [11112] = {
    [sym_heredoc_body] = STATE(11293),
    [aux_sym_call_repeat1] = STATE(11293),
    [aux_sym_argument_list_repeat1] = STATE(11294),
    [sym__heredoc_body_start] = ACTIONS(3543),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(15051),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_PLUS_EQ] = ACTIONS(4383),
    [anon_sym_DASH_EQ] = ACTIONS(4383),
    [anon_sym_STAR_EQ] = ACTIONS(4383),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4383),
    [anon_sym_SLASH_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_PIPE_EQ] = ACTIONS(4383),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4383),
    [anon_sym_AMP_EQ] = ACTIONS(4383),
    [anon_sym_PERCENT_EQ] = ACTIONS(4383),
    [anon_sym_GT_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_LT_EQ] = ACTIONS(4383),
    [anon_sym_CARET_EQ] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4385),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [sym_comment] = ACTIONS(87),
  },
  [11113] = {
    [sym_heredoc_body] = STATE(11113),
    [aux_sym_call_repeat1] = STATE(11113),
    [sym__heredoc_body_start] = ACTIONS(10455),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [11114] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(9927),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(9932),
    [sym_scope_resolution] = STATE(9928),
    [sym_call] = STATE(9928),
    [sym_method_call] = STATE(9932),
    [sym__argument] = STATE(6908),
    [sym_splat_argument] = STATE(6908),
    [sym_hash_splat_argument] = STATE(6908),
    [sym_block_argument] = STATE(6908),
    [sym_assignment] = STATE(9927),
    [sym_operator_assignment] = STATE(9927),
    [sym_conditional] = STATE(9927),
    [sym_range] = STATE(9927),
    [sym_binary] = STATE(9927),
    [sym_unary] = STATE(9927),
    [sym_left_assignment_list] = STATE(9931),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9932),
    [sym__variable] = STATE(9928),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(9932),
    [sym_false] = STATE(9932),
    [sym_nil] = STATE(9932),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(9933),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(6908),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(13601),
    [sym__splat_star] = ACTIONS(13603),
    [sym__unary_minus] = ACTIONS(13605),
    [sym__identifier_hash_key] = ACTIONS(13607),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(15055),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13609),
    [anon_sym_yield] = ACTIONS(13611),
    [anon_sym_break] = ACTIONS(13613),
    [anon_sym_next] = ACTIONS(13615),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14446),
    [anon_sym_defined_QMARK] = ACTIONS(13617),
    [anon_sym_not] = ACTIONS(13619),
    [anon_sym_BANG] = ACTIONS(13623),
    [anon_sym_TILDE] = ACTIONS(13623),
    [sym_constant] = ACTIONS(13625),
    [sym_identifier] = ACTIONS(13625),
    [sym_instance_variable] = ACTIONS(13627),
    [sym_class_variable] = ACTIONS(13627),
    [sym_global_variable] = ACTIONS(13627),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13629),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13629),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11115] = {
    [sym_heredoc_body] = STATE(11113),
    [aux_sym_call_repeat1] = STATE(11113),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [11116] = {
    [aux_sym_argument_list_repeat1] = STATE(11116),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(15241),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7925),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7925),
    [anon_sym_AMP_AMP] = ACTIONS(7925),
    [anon_sym_LT_LT] = ACTIONS(7925),
    [anon_sym_GT_GT] = ACTIONS(7925),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7925),
    [anon_sym_PLUS] = ACTIONS(7925),
    [anon_sym_SLASH] = ACTIONS(7925),
    [anon_sym_PERCENT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [11117] = {
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(14460),
    [sym__binary_star] = ACTIONS(14462),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(14464),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(14462),
    [anon_sym_AMP] = ACTIONS(14466),
    [anon_sym_LT] = ACTIONS(14468),
    [anon_sym_EQ_GT] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(14470),
    [anon_sym_DOT_DOT] = ACTIONS(14472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14474),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(14476),
    [anon_sym_AMP_AMP] = ACTIONS(14476),
    [anon_sym_LT_LT] = ACTIONS(14478),
    [anon_sym_GT_GT] = ACTIONS(14478),
    [anon_sym_EQ_EQ] = ACTIONS(14480),
    [anon_sym_BANG_EQ] = ACTIONS(14476),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14476),
    [anon_sym_LT_EQ_GT] = ACTIONS(14476),
    [anon_sym_EQ_TILDE] = ACTIONS(14476),
    [anon_sym_BANG_TILDE] = ACTIONS(14476),
    [anon_sym_LT_EQ] = ACTIONS(14468),
    [anon_sym_GT] = ACTIONS(14468),
    [anon_sym_GT_EQ] = ACTIONS(14482),
    [anon_sym_CARET] = ACTIONS(14484),
    [anon_sym_PLUS] = ACTIONS(14460),
    [anon_sym_SLASH] = ACTIONS(14462),
    [anon_sym_PERCENT] = ACTIONS(14462),
    [sym_comment] = ACTIONS(87),
  },
  [11118] = {
    [aux_sym_exceptions_repeat1] = STATE(11296),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [11119] = {
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(14460),
    [sym__binary_star] = ACTIONS(14462),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(14464),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(14462),
    [anon_sym_AMP] = ACTIONS(14466),
    [anon_sym_LT] = ACTIONS(14468),
    [anon_sym_EQ_GT] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(14470),
    [anon_sym_DOT_DOT] = ACTIONS(14472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14474),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(14476),
    [anon_sym_AMP_AMP] = ACTIONS(14476),
    [anon_sym_LT_LT] = ACTIONS(14478),
    [anon_sym_GT_GT] = ACTIONS(14478),
    [anon_sym_EQ_EQ] = ACTIONS(14480),
    [anon_sym_BANG_EQ] = ACTIONS(14476),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14476),
    [anon_sym_LT_EQ_GT] = ACTIONS(14476),
    [anon_sym_EQ_TILDE] = ACTIONS(14476),
    [anon_sym_BANG_TILDE] = ACTIONS(14476),
    [anon_sym_LT_EQ] = ACTIONS(14468),
    [anon_sym_GT] = ACTIONS(14468),
    [anon_sym_GT_EQ] = ACTIONS(14482),
    [anon_sym_CARET] = ACTIONS(14484),
    [anon_sym_PLUS] = ACTIONS(14460),
    [anon_sym_SLASH] = ACTIONS(14462),
    [anon_sym_PERCENT] = ACTIONS(14462),
    [sym_comment] = ACTIONS(87),
  },
  [11120] = {
    [sym_string] = STATE(11120),
    [aux_sym_chained_string_repeat1] = STATE(11120),
    [sym__string_start] = ACTIONS(9407),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_EQ_GT] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [11121] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(11297),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(8445),
    [sym_scope_resolution] = STATE(8443),
    [sym_call] = STATE(8443),
    [sym_method_call] = STATE(8445),
    [sym_assignment] = STATE(11297),
    [sym_operator_assignment] = STATE(11297),
    [sym_conditional] = STATE(11297),
    [sym_range] = STATE(11297),
    [sym_binary] = STATE(11297),
    [sym_unary] = STATE(11297),
    [sym_left_assignment_list] = STATE(8444),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(8445),
    [sym__variable] = STATE(8443),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(8445),
    [sym_false] = STATE(8445),
    [sym_nil] = STATE(8445),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(8446),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(12003),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(12005),
    [anon_sym_yield] = ACTIONS(12007),
    [anon_sym_break] = ACTIONS(12009),
    [anon_sym_next] = ACTIONS(12011),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(12013),
    [anon_sym_defined_QMARK] = ACTIONS(12015),
    [anon_sym_not] = ACTIONS(12017),
    [anon_sym_BANG] = ACTIONS(12019),
    [anon_sym_TILDE] = ACTIONS(12019),
    [sym_constant] = ACTIONS(12021),
    [sym_identifier] = ACTIONS(12021),
    [sym_instance_variable] = ACTIONS(12023),
    [sym_class_variable] = ACTIONS(12023),
    [sym_global_variable] = ACTIONS(12023),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(12021),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(12021),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [11122] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(15065),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [11123] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(15059),
    [sym__binary_star] = ACTIONS(15061),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(15063),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(15065),
    [anon_sym_AMP] = ACTIONS(15067),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(15069),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(15071),
    [anon_sym_DOT_DOT] = ACTIONS(15073),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15075),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(15077),
    [anon_sym_AMP_AMP] = ACTIONS(15077),
    [anon_sym_LT_LT] = ACTIONS(15079),
    [anon_sym_GT_GT] = ACTIONS(15079),
    [anon_sym_EQ_EQ] = ACTIONS(15077),
    [anon_sym_BANG_EQ] = ACTIONS(15081),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15081),
    [anon_sym_LT_EQ_GT] = ACTIONS(15081),
    [anon_sym_EQ_TILDE] = ACTIONS(15081),
    [anon_sym_BANG_TILDE] = ACTIONS(15081),
    [anon_sym_LT_EQ] = ACTIONS(15069),
    [anon_sym_GT] = ACTIONS(15069),
    [anon_sym_GT_EQ] = ACTIONS(15083),
    [anon_sym_CARET] = ACTIONS(15063),
    [anon_sym_PLUS] = ACTIONS(15085),
    [anon_sym_SLASH] = ACTIONS(15065),
    [anon_sym_PERCENT] = ACTIONS(15065),
    [sym_comment] = ACTIONS(87),
  },
  [11124] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(11298),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(10772),
    [sym_scope_resolution] = STATE(10770),
    [sym_call] = STATE(10770),
    [sym_method_call] = STATE(10772),
    [sym_assignment] = STATE(11298),
    [sym_operator_assignment] = STATE(11298),
    [sym_conditional] = STATE(11298),
    [sym_range] = STATE(11298),
    [sym_binary] = STATE(11298),
    [sym_unary] = STATE(11298),
    [sym_left_assignment_list] = STATE(10771),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10772),
    [sym__variable] = STATE(10770),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(10772),
    [sym_false] = STATE(10772),
    [sym_nil] = STATE(10772),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(10773),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(14506),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(14508),
    [anon_sym_yield] = ACTIONS(14510),
    [anon_sym_break] = ACTIONS(14512),
    [anon_sym_next] = ACTIONS(14514),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(14516),
    [anon_sym_defined_QMARK] = ACTIONS(14518),
    [anon_sym_not] = ACTIONS(14520),
    [anon_sym_BANG] = ACTIONS(14522),
    [anon_sym_TILDE] = ACTIONS(14522),
    [sym_constant] = ACTIONS(14524),
    [sym_identifier] = ACTIONS(14524),
    [sym_instance_variable] = ACTIONS(14526),
    [sym_class_variable] = ACTIONS(14526),
    [sym_global_variable] = ACTIONS(14526),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(14524),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14524),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [11125] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(11299),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(10772),
    [sym_scope_resolution] = STATE(10770),
    [sym_call] = STATE(10770),
    [sym_method_call] = STATE(10772),
    [sym_assignment] = STATE(11299),
    [sym_operator_assignment] = STATE(11299),
    [sym_conditional] = STATE(11299),
    [sym_range] = STATE(11299),
    [sym_binary] = STATE(11299),
    [sym_unary] = STATE(11299),
    [sym_left_assignment_list] = STATE(10771),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10772),
    [sym__variable] = STATE(10770),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(10772),
    [sym_false] = STATE(10772),
    [sym_nil] = STATE(10772),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(10773),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(14506),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(14508),
    [anon_sym_yield] = ACTIONS(14510),
    [anon_sym_break] = ACTIONS(14512),
    [anon_sym_next] = ACTIONS(14514),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(14516),
    [anon_sym_defined_QMARK] = ACTIONS(14518),
    [anon_sym_not] = ACTIONS(14520),
    [anon_sym_BANG] = ACTIONS(14522),
    [anon_sym_TILDE] = ACTIONS(14522),
    [sym_constant] = ACTIONS(14524),
    [sym_identifier] = ACTIONS(14524),
    [sym_instance_variable] = ACTIONS(14526),
    [sym_class_variable] = ACTIONS(14526),
    [sym_global_variable] = ACTIONS(14526),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(14524),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14524),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [11126] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(11300),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(10772),
    [sym_scope_resolution] = STATE(10770),
    [sym_call] = STATE(10770),
    [sym_method_call] = STATE(10772),
    [sym_assignment] = STATE(11300),
    [sym_operator_assignment] = STATE(11300),
    [sym_conditional] = STATE(11300),
    [sym_range] = STATE(11300),
    [sym_binary] = STATE(11300),
    [sym_unary] = STATE(11300),
    [sym_left_assignment_list] = STATE(10771),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10772),
    [sym__variable] = STATE(10770),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(10772),
    [sym_false] = STATE(10772),
    [sym_nil] = STATE(10772),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(10773),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(14506),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(14508),
    [anon_sym_yield] = ACTIONS(14510),
    [anon_sym_break] = ACTIONS(14512),
    [anon_sym_next] = ACTIONS(14514),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(14516),
    [anon_sym_defined_QMARK] = ACTIONS(14518),
    [anon_sym_not] = ACTIONS(14520),
    [anon_sym_BANG] = ACTIONS(14522),
    [anon_sym_TILDE] = ACTIONS(14522),
    [sym_constant] = ACTIONS(14524),
    [sym_identifier] = ACTIONS(14524),
    [sym_instance_variable] = ACTIONS(14526),
    [sym_class_variable] = ACTIONS(14526),
    [sym_global_variable] = ACTIONS(14526),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(14524),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14524),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [11127] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(11301),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(10772),
    [sym_scope_resolution] = STATE(10770),
    [sym_call] = STATE(10770),
    [sym_method_call] = STATE(10772),
    [sym_assignment] = STATE(11301),
    [sym_operator_assignment] = STATE(11301),
    [sym_conditional] = STATE(11301),
    [sym_range] = STATE(11301),
    [sym_binary] = STATE(11301),
    [sym_unary] = STATE(11301),
    [sym_left_assignment_list] = STATE(10771),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10772),
    [sym__variable] = STATE(10770),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(10772),
    [sym_false] = STATE(10772),
    [sym_nil] = STATE(10772),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(10773),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(14506),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(14508),
    [anon_sym_yield] = ACTIONS(14510),
    [anon_sym_break] = ACTIONS(14512),
    [anon_sym_next] = ACTIONS(14514),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(14516),
    [anon_sym_defined_QMARK] = ACTIONS(14518),
    [anon_sym_not] = ACTIONS(14520),
    [anon_sym_BANG] = ACTIONS(14522),
    [anon_sym_TILDE] = ACTIONS(14522),
    [sym_constant] = ACTIONS(14524),
    [sym_identifier] = ACTIONS(14524),
    [sym_instance_variable] = ACTIONS(14526),
    [sym_class_variable] = ACTIONS(14526),
    [sym_global_variable] = ACTIONS(14526),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(14524),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14524),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [11128] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(11302),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(10772),
    [sym_scope_resolution] = STATE(10770),
    [sym_call] = STATE(10770),
    [sym_method_call] = STATE(10772),
    [sym_assignment] = STATE(11302),
    [sym_operator_assignment] = STATE(11302),
    [sym_conditional] = STATE(11302),
    [sym_range] = STATE(11302),
    [sym_binary] = STATE(11302),
    [sym_unary] = STATE(11302),
    [sym_left_assignment_list] = STATE(10771),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10772),
    [sym__variable] = STATE(10770),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(10772),
    [sym_false] = STATE(10772),
    [sym_nil] = STATE(10772),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(10773),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(14506),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(14508),
    [anon_sym_yield] = ACTIONS(14510),
    [anon_sym_break] = ACTIONS(14512),
    [anon_sym_next] = ACTIONS(14514),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(14516),
    [anon_sym_defined_QMARK] = ACTIONS(14518),
    [anon_sym_not] = ACTIONS(14520),
    [anon_sym_BANG] = ACTIONS(14522),
    [anon_sym_TILDE] = ACTIONS(14522),
    [sym_constant] = ACTIONS(14524),
    [sym_identifier] = ACTIONS(14524),
    [sym_instance_variable] = ACTIONS(14526),
    [sym_class_variable] = ACTIONS(14526),
    [sym_global_variable] = ACTIONS(14526),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(14524),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14524),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [11129] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(11303),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(1436),
    [sym_scope_resolution] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_method_call] = STATE(1436),
    [sym_assignment] = STATE(11303),
    [sym_operator_assignment] = STATE(11303),
    [sym_conditional] = STATE(11303),
    [sym_range] = STATE(11303),
    [sym_binary] = STATE(11303),
    [sym_unary] = STATE(11303),
    [sym_left_assignment_list] = STATE(1435),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(1436),
    [sym__variable] = STATE(1434),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(1436),
    [sym_false] = STATE(1436),
    [sym_nil] = STATE(1436),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(1437),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2495),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__unary_minus] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2501),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_next] = ACTIONS(2505),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_defined_QMARK] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [sym_constant] = ACTIONS(2515),
    [sym_identifier] = ACTIONS(2515),
    [sym_instance_variable] = ACTIONS(2517),
    [sym_class_variable] = ACTIONS(2517),
    [sym_global_variable] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(2515),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2515),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [11130] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(11304),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(10772),
    [sym_scope_resolution] = STATE(10770),
    [sym_call] = STATE(10770),
    [sym_method_call] = STATE(10772),
    [sym_assignment] = STATE(11304),
    [sym_operator_assignment] = STATE(11304),
    [sym_conditional] = STATE(11304),
    [sym_range] = STATE(11304),
    [sym_binary] = STATE(11304),
    [sym_unary] = STATE(11304),
    [sym_left_assignment_list] = STATE(10771),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10772),
    [sym__variable] = STATE(10770),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(10772),
    [sym_false] = STATE(10772),
    [sym_nil] = STATE(10772),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(10773),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(14506),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(14508),
    [anon_sym_yield] = ACTIONS(14510),
    [anon_sym_break] = ACTIONS(14512),
    [anon_sym_next] = ACTIONS(14514),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(14516),
    [anon_sym_defined_QMARK] = ACTIONS(14518),
    [anon_sym_not] = ACTIONS(14520),
    [anon_sym_BANG] = ACTIONS(14522),
    [anon_sym_TILDE] = ACTIONS(14522),
    [sym_constant] = ACTIONS(14524),
    [sym_identifier] = ACTIONS(14524),
    [sym_instance_variable] = ACTIONS(14526),
    [sym_class_variable] = ACTIONS(14526),
    [sym_global_variable] = ACTIONS(14526),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(14524),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14524),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [11131] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(11305),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(10772),
    [sym_scope_resolution] = STATE(10770),
    [sym_call] = STATE(10770),
    [sym_method_call] = STATE(10772),
    [sym_assignment] = STATE(11305),
    [sym_operator_assignment] = STATE(11305),
    [sym_conditional] = STATE(11305),
    [sym_range] = STATE(11305),
    [sym_binary] = STATE(11305),
    [sym_unary] = STATE(11305),
    [sym_left_assignment_list] = STATE(10771),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10772),
    [sym__variable] = STATE(10770),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(10772),
    [sym_false] = STATE(10772),
    [sym_nil] = STATE(10772),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(10773),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(14506),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(14508),
    [anon_sym_yield] = ACTIONS(14510),
    [anon_sym_break] = ACTIONS(14512),
    [anon_sym_next] = ACTIONS(14514),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(14516),
    [anon_sym_defined_QMARK] = ACTIONS(14518),
    [anon_sym_not] = ACTIONS(14520),
    [anon_sym_BANG] = ACTIONS(14522),
    [anon_sym_TILDE] = ACTIONS(14522),
    [sym_constant] = ACTIONS(14524),
    [sym_identifier] = ACTIONS(14524),
    [sym_instance_variable] = ACTIONS(14526),
    [sym_class_variable] = ACTIONS(14526),
    [sym_global_variable] = ACTIONS(14526),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(14524),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14524),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [11132] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(11306),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(10772),
    [sym_scope_resolution] = STATE(10770),
    [sym_call] = STATE(10770),
    [sym_method_call] = STATE(10772),
    [sym_assignment] = STATE(11306),
    [sym_operator_assignment] = STATE(11306),
    [sym_conditional] = STATE(11306),
    [sym_range] = STATE(11306),
    [sym_binary] = STATE(11306),
    [sym_unary] = STATE(11306),
    [sym_left_assignment_list] = STATE(10771),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10772),
    [sym__variable] = STATE(10770),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(10772),
    [sym_false] = STATE(10772),
    [sym_nil] = STATE(10772),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(10773),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(14506),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(14508),
    [anon_sym_yield] = ACTIONS(14510),
    [anon_sym_break] = ACTIONS(14512),
    [anon_sym_next] = ACTIONS(14514),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(14516),
    [anon_sym_defined_QMARK] = ACTIONS(14518),
    [anon_sym_not] = ACTIONS(14520),
    [anon_sym_BANG] = ACTIONS(14522),
    [anon_sym_TILDE] = ACTIONS(14522),
    [sym_constant] = ACTIONS(14524),
    [sym_identifier] = ACTIONS(14524),
    [sym_instance_variable] = ACTIONS(14526),
    [sym_class_variable] = ACTIONS(14526),
    [sym_global_variable] = ACTIONS(14526),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(14524),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14524),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [11133] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(11307),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(10772),
    [sym_scope_resolution] = STATE(10770),
    [sym_call] = STATE(10770),
    [sym_method_call] = STATE(10772),
    [sym_assignment] = STATE(11307),
    [sym_operator_assignment] = STATE(11307),
    [sym_conditional] = STATE(11307),
    [sym_range] = STATE(11307),
    [sym_binary] = STATE(11307),
    [sym_unary] = STATE(11307),
    [sym_left_assignment_list] = STATE(10771),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10772),
    [sym__variable] = STATE(10770),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(10772),
    [sym_false] = STATE(10772),
    [sym_nil] = STATE(10772),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(10773),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(14506),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(14508),
    [anon_sym_yield] = ACTIONS(14510),
    [anon_sym_break] = ACTIONS(14512),
    [anon_sym_next] = ACTIONS(14514),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(14516),
    [anon_sym_defined_QMARK] = ACTIONS(14518),
    [anon_sym_not] = ACTIONS(14520),
    [anon_sym_BANG] = ACTIONS(14522),
    [anon_sym_TILDE] = ACTIONS(14522),
    [sym_constant] = ACTIONS(14524),
    [sym_identifier] = ACTIONS(14524),
    [sym_instance_variable] = ACTIONS(14526),
    [sym_class_variable] = ACTIONS(14526),
    [sym_global_variable] = ACTIONS(14526),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(14524),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14524),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [11134] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(11308),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(10772),
    [sym_scope_resolution] = STATE(10770),
    [sym_call] = STATE(10770),
    [sym_method_call] = STATE(10772),
    [sym_splat_argument] = STATE(11309),
    [sym_assignment] = STATE(11308),
    [sym_operator_assignment] = STATE(11308),
    [sym_conditional] = STATE(11308),
    [sym_range] = STATE(11308),
    [sym_binary] = STATE(11308),
    [sym_unary] = STATE(11308),
    [sym_right_assignment_list] = STATE(8878),
    [sym__arg_or_splat_arg] = STATE(11309),
    [sym_left_assignment_list] = STATE(10771),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10772),
    [sym__variable] = STATE(10770),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(10772),
    [sym_false] = STATE(10772),
    [sym_nil] = STATE(10772),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(10773),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__splat_star] = ACTIONS(13661),
    [sym__unary_minus] = ACTIONS(14506),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(14508),
    [anon_sym_yield] = ACTIONS(14510),
    [anon_sym_break] = ACTIONS(14512),
    [anon_sym_next] = ACTIONS(14514),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(14516),
    [anon_sym_defined_QMARK] = ACTIONS(14518),
    [anon_sym_not] = ACTIONS(14520),
    [anon_sym_BANG] = ACTIONS(14522),
    [anon_sym_TILDE] = ACTIONS(14522),
    [sym_constant] = ACTIONS(14524),
    [sym_identifier] = ACTIONS(14524),
    [sym_instance_variable] = ACTIONS(14526),
    [sym_class_variable] = ACTIONS(14526),
    [sym_global_variable] = ACTIONS(14526),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(14524),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14524),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [11135] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(11310),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(10772),
    [sym_scope_resolution] = STATE(10770),
    [sym_call] = STATE(10770),
    [sym_method_call] = STATE(10772),
    [sym_assignment] = STATE(11310),
    [sym_operator_assignment] = STATE(11310),
    [sym_conditional] = STATE(11310),
    [sym_range] = STATE(11310),
    [sym_binary] = STATE(11310),
    [sym_unary] = STATE(11310),
    [sym_left_assignment_list] = STATE(10771),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10772),
    [sym__variable] = STATE(10770),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(10772),
    [sym_false] = STATE(10772),
    [sym_nil] = STATE(10772),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(10773),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(14506),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(14508),
    [anon_sym_yield] = ACTIONS(14510),
    [anon_sym_break] = ACTIONS(14512),
    [anon_sym_next] = ACTIONS(14514),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(14516),
    [anon_sym_defined_QMARK] = ACTIONS(14518),
    [anon_sym_not] = ACTIONS(14520),
    [anon_sym_BANG] = ACTIONS(14522),
    [anon_sym_TILDE] = ACTIONS(14522),
    [sym_constant] = ACTIONS(14524),
    [sym_identifier] = ACTIONS(14524),
    [sym_instance_variable] = ACTIONS(14526),
    [sym_class_variable] = ACTIONS(14526),
    [sym_global_variable] = ACTIONS(14526),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(14524),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14524),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [11136] = {
    [sym_string] = STATE(11311),
    [aux_sym_chained_string_repeat1] = STATE(11311),
    [sym__string_start] = ACTIONS(6455),
    [sym__heredoc_body_start] = ACTIONS(2753),
    [sym__binary_minus] = ACTIONS(2753),
    [sym__binary_star] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_STAR_STAR] = ACTIONS(2755),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_EQ] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(2753),
    [anon_sym_AMP_DOT] = ACTIONS(2753),
    [anon_sym_PLUS_EQ] = ACTIONS(2753),
    [anon_sym_DASH_EQ] = ACTIONS(2753),
    [anon_sym_STAR_EQ] = ACTIONS(2753),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2753),
    [anon_sym_SLASH_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_PIPE_EQ] = ACTIONS(2753),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2753),
    [anon_sym_AMP_EQ] = ACTIONS(2753),
    [anon_sym_PERCENT_EQ] = ACTIONS(2753),
    [anon_sym_GT_GT_EQ] = ACTIONS(2753),
    [anon_sym_LT_LT_EQ] = ACTIONS(2753),
    [anon_sym_CARET_EQ] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2753),
    [anon_sym_and] = ACTIONS(2753),
    [anon_sym_or] = ACTIONS(2753),
    [anon_sym_PIPE_PIPE] = ACTIONS(2755),
    [anon_sym_AMP_AMP] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2755),
    [anon_sym_GT_GT] = ACTIONS(2755),
    [anon_sym_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2753),
    [anon_sym_LT_EQ_GT] = ACTIONS(2753),
    [anon_sym_EQ_TILDE] = ACTIONS(2753),
    [anon_sym_BANG_TILDE] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_SLASH] = ACTIONS(2755),
    [anon_sym_PERCENT] = ACTIONS(2755),
    [sym_comment] = ACTIONS(87),
  },
  [11137] = {
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(15059),
    [sym__binary_star] = ACTIONS(15061),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(15063),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(15065),
    [anon_sym_AMP] = ACTIONS(15067),
    [anon_sym_EQ] = ACTIONS(7822),
    [anon_sym_LT] = ACTIONS(15069),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_PLUS_EQ] = ACTIONS(6823),
    [anon_sym_DASH_EQ] = ACTIONS(6823),
    [anon_sym_STAR_EQ] = ACTIONS(6823),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6823),
    [anon_sym_SLASH_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6823),
    [anon_sym_AMP_EQ] = ACTIONS(6823),
    [anon_sym_PERCENT_EQ] = ACTIONS(6823),
    [anon_sym_GT_GT_EQ] = ACTIONS(6823),
    [anon_sym_LT_LT_EQ] = ACTIONS(6823),
    [anon_sym_CARET_EQ] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(15071),
    [anon_sym_DOT_DOT] = ACTIONS(15073),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15075),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(15077),
    [anon_sym_AMP_AMP] = ACTIONS(15077),
    [anon_sym_LT_LT] = ACTIONS(15079),
    [anon_sym_GT_GT] = ACTIONS(15079),
    [anon_sym_EQ_EQ] = ACTIONS(15077),
    [anon_sym_BANG_EQ] = ACTIONS(15081),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15081),
    [anon_sym_LT_EQ_GT] = ACTIONS(15081),
    [anon_sym_EQ_TILDE] = ACTIONS(15081),
    [anon_sym_BANG_TILDE] = ACTIONS(15081),
    [anon_sym_LT_EQ] = ACTIONS(15069),
    [anon_sym_GT] = ACTIONS(15069),
    [anon_sym_GT_EQ] = ACTIONS(15083),
    [anon_sym_CARET] = ACTIONS(15063),
    [anon_sym_PLUS] = ACTIONS(15085),
    [anon_sym_SLASH] = ACTIONS(15065),
    [anon_sym_PERCENT] = ACTIONS(15065),
    [sym_comment] = ACTIONS(87),
  },
  [11138] = {
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(15059),
    [sym__binary_star] = ACTIONS(15061),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(15063),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(15065),
    [anon_sym_AMP] = ACTIONS(15067),
    [anon_sym_EQ] = ACTIONS(7884),
    [anon_sym_LT] = ACTIONS(15069),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_PLUS_EQ] = ACTIONS(7027),
    [anon_sym_DASH_EQ] = ACTIONS(7027),
    [anon_sym_STAR_EQ] = ACTIONS(7027),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7027),
    [anon_sym_SLASH_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7027),
    [anon_sym_AMP_EQ] = ACTIONS(7027),
    [anon_sym_PERCENT_EQ] = ACTIONS(7027),
    [anon_sym_GT_GT_EQ] = ACTIONS(7027),
    [anon_sym_LT_LT_EQ] = ACTIONS(7027),
    [anon_sym_CARET_EQ] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(15071),
    [anon_sym_DOT_DOT] = ACTIONS(15073),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15075),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(15077),
    [anon_sym_AMP_AMP] = ACTIONS(15077),
    [anon_sym_LT_LT] = ACTIONS(15079),
    [anon_sym_GT_GT] = ACTIONS(15079),
    [anon_sym_EQ_EQ] = ACTIONS(15077),
    [anon_sym_BANG_EQ] = ACTIONS(15081),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15081),
    [anon_sym_LT_EQ_GT] = ACTIONS(15081),
    [anon_sym_EQ_TILDE] = ACTIONS(15081),
    [anon_sym_BANG_TILDE] = ACTIONS(15081),
    [anon_sym_LT_EQ] = ACTIONS(15069),
    [anon_sym_GT] = ACTIONS(15069),
    [anon_sym_GT_EQ] = ACTIONS(15083),
    [anon_sym_CARET] = ACTIONS(15063),
    [anon_sym_PLUS] = ACTIONS(15085),
    [anon_sym_SLASH] = ACTIONS(15065),
    [anon_sym_PERCENT] = ACTIONS(15065),
    [sym_comment] = ACTIONS(87),
  },
  [11139] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(14536),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(14540),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(14540),
    [anon_sym_PERCENT] = ACTIONS(14540),
    [sym_comment] = ACTIONS(87),
  },
  [11140] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(14540),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(5827),
    [anon_sym_PERCENT] = ACTIONS(5827),
    [sym_comment] = ACTIONS(87),
  },
  [11141] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(14534),
    [sym__binary_star] = ACTIONS(14536),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(14540),
    [anon_sym_AMP] = ACTIONS(14542),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(14554),
    [anon_sym_GT_GT] = ACTIONS(14554),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(14560),
    [anon_sym_SLASH] = ACTIONS(14540),
    [anon_sym_PERCENT] = ACTIONS(14540),
    [sym_comment] = ACTIONS(87),
  },
  [11142] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(14534),
    [sym__binary_star] = ACTIONS(14536),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(14540),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(14554),
    [anon_sym_GT_GT] = ACTIONS(14554),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(14560),
    [anon_sym_SLASH] = ACTIONS(14540),
    [anon_sym_PERCENT] = ACTIONS(14540),
    [sym_comment] = ACTIONS(87),
  },
  [11143] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(14534),
    [sym__binary_star] = ACTIONS(14536),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(14538),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(14540),
    [anon_sym_AMP] = ACTIONS(14542),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(14554),
    [anon_sym_GT_GT] = ACTIONS(14554),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(14538),
    [anon_sym_PLUS] = ACTIONS(14560),
    [anon_sym_SLASH] = ACTIONS(14540),
    [anon_sym_PERCENT] = ACTIONS(14540),
    [sym_comment] = ACTIONS(87),
  },
  [11144] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(15244),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [11145] = {
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(14534),
    [sym__binary_star] = ACTIONS(14536),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(14538),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(14540),
    [anon_sym_AMP] = ACTIONS(14542),
    [anon_sym_EQ] = ACTIONS(7888),
    [anon_sym_LT] = ACTIONS(14544),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_EQ_GT] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_PLUS_EQ] = ACTIONS(5927),
    [anon_sym_DASH_EQ] = ACTIONS(5927),
    [anon_sym_STAR_EQ] = ACTIONS(5927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5927),
    [anon_sym_SLASH_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5927),
    [anon_sym_AMP_EQ] = ACTIONS(5927),
    [anon_sym_PERCENT_EQ] = ACTIONS(5927),
    [anon_sym_GT_GT_EQ] = ACTIONS(5927),
    [anon_sym_LT_LT_EQ] = ACTIONS(5927),
    [anon_sym_CARET_EQ] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(14548),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14550),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(14552),
    [anon_sym_AMP_AMP] = ACTIONS(14552),
    [anon_sym_LT_LT] = ACTIONS(14554),
    [anon_sym_GT_GT] = ACTIONS(14554),
    [anon_sym_EQ_EQ] = ACTIONS(14552),
    [anon_sym_BANG_EQ] = ACTIONS(14556),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14556),
    [anon_sym_LT_EQ_GT] = ACTIONS(14556),
    [anon_sym_EQ_TILDE] = ACTIONS(14556),
    [anon_sym_BANG_TILDE] = ACTIONS(14556),
    [anon_sym_LT_EQ] = ACTIONS(14544),
    [anon_sym_GT] = ACTIONS(14544),
    [anon_sym_GT_EQ] = ACTIONS(14558),
    [anon_sym_CARET] = ACTIONS(14538),
    [anon_sym_PLUS] = ACTIONS(14560),
    [anon_sym_SLASH] = ACTIONS(14540),
    [anon_sym_PERCENT] = ACTIONS(14540),
    [sym_comment] = ACTIONS(87),
  },
  [11146] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(14534),
    [sym__binary_star] = ACTIONS(14536),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(14538),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(14540),
    [anon_sym_AMP] = ACTIONS(14542),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(14544),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(14546),
    [anon_sym_DOT_DOT] = ACTIONS(14548),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14550),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(14552),
    [anon_sym_AMP_AMP] = ACTIONS(14552),
    [anon_sym_LT_LT] = ACTIONS(14554),
    [anon_sym_GT_GT] = ACTIONS(14554),
    [anon_sym_EQ_EQ] = ACTIONS(14552),
    [anon_sym_BANG_EQ] = ACTIONS(14556),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14556),
    [anon_sym_LT_EQ_GT] = ACTIONS(14556),
    [anon_sym_EQ_TILDE] = ACTIONS(14556),
    [anon_sym_BANG_TILDE] = ACTIONS(14556),
    [anon_sym_LT_EQ] = ACTIONS(14544),
    [anon_sym_GT] = ACTIONS(14544),
    [anon_sym_GT_EQ] = ACTIONS(14558),
    [anon_sym_CARET] = ACTIONS(14538),
    [anon_sym_PLUS] = ACTIONS(14560),
    [anon_sym_SLASH] = ACTIONS(14540),
    [anon_sym_PERCENT] = ACTIONS(14540),
    [sym_comment] = ACTIONS(87),
  },
  [11147] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(14534),
    [sym__binary_star] = ACTIONS(14536),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(14538),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(14540),
    [anon_sym_AMP] = ACTIONS(14542),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(14544),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(14554),
    [anon_sym_GT_GT] = ACTIONS(14554),
    [anon_sym_EQ_EQ] = ACTIONS(14552),
    [anon_sym_BANG_EQ] = ACTIONS(14556),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14556),
    [anon_sym_LT_EQ_GT] = ACTIONS(14556),
    [anon_sym_EQ_TILDE] = ACTIONS(14556),
    [anon_sym_BANG_TILDE] = ACTIONS(14556),
    [anon_sym_LT_EQ] = ACTIONS(14544),
    [anon_sym_GT] = ACTIONS(14544),
    [anon_sym_GT_EQ] = ACTIONS(14558),
    [anon_sym_CARET] = ACTIONS(14538),
    [anon_sym_PLUS] = ACTIONS(14560),
    [anon_sym_SLASH] = ACTIONS(14540),
    [anon_sym_PERCENT] = ACTIONS(14540),
    [sym_comment] = ACTIONS(87),
  },
  [11148] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(14534),
    [sym__binary_star] = ACTIONS(14536),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(14540),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_EQ_GT] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(14560),
    [anon_sym_SLASH] = ACTIONS(14540),
    [anon_sym_PERCENT] = ACTIONS(14540),
    [sym_comment] = ACTIONS(87),
  },
  [11149] = {
    [sym_heredoc_body] = STATE(11149),
    [aux_sym_call_repeat1] = STATE(11149),
    [sym__heredoc_body_start] = ACTIONS(12549),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7919),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_EQ] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_PLUS_EQ] = ACTIONS(7914),
    [anon_sym_DASH_EQ] = ACTIONS(7914),
    [anon_sym_STAR_EQ] = ACTIONS(7914),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7914),
    [anon_sym_SLASH_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7914),
    [anon_sym_AMP_EQ] = ACTIONS(7914),
    [anon_sym_PERCENT_EQ] = ACTIONS(7914),
    [anon_sym_GT_GT_EQ] = ACTIONS(7914),
    [anon_sym_LT_LT_EQ] = ACTIONS(7914),
    [anon_sym_CARET_EQ] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7919),
    [anon_sym_AMP_AMP] = ACTIONS(7919),
    [anon_sym_LT_LT] = ACTIONS(7919),
    [anon_sym_GT_GT] = ACTIONS(7919),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7919),
    [anon_sym_PLUS] = ACTIONS(7919),
    [anon_sym_SLASH] = ACTIONS(7919),
    [anon_sym_PERCENT] = ACTIONS(7919),
    [sym_comment] = ACTIONS(87),
  },
  [11150] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(9957),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9962),
    [sym_scope_resolution] = STATE(9958),
    [sym_call] = STATE(9958),
    [sym_method_call] = STATE(9962),
    [sym__argument] = STATE(8888),
    [sym_splat_argument] = STATE(8888),
    [sym_hash_splat_argument] = STATE(8888),
    [sym_block_argument] = STATE(8888),
    [sym_assignment] = STATE(9957),
    [sym_operator_assignment] = STATE(9957),
    [sym_conditional] = STATE(9957),
    [sym_range] = STATE(9957),
    [sym_binary] = STATE(9957),
    [sym_unary] = STATE(9957),
    [sym_left_assignment_list] = STATE(9961),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9962),
    [sym__variable] = STATE(9958),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9962),
    [sym_false] = STATE(9962),
    [sym_nil] = STATE(9962),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(9963),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(8888),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(13659),
    [sym__splat_star] = ACTIONS(13661),
    [sym__unary_minus] = ACTIONS(13663),
    [sym__identifier_hash_key] = ACTIONS(13665),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(15093),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13667),
    [anon_sym_yield] = ACTIONS(13669),
    [anon_sym_break] = ACTIONS(13671),
    [anon_sym_next] = ACTIONS(13673),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(14528),
    [anon_sym_defined_QMARK] = ACTIONS(13675),
    [anon_sym_not] = ACTIONS(13677),
    [anon_sym_BANG] = ACTIONS(13681),
    [anon_sym_TILDE] = ACTIONS(13681),
    [sym_constant] = ACTIONS(13683),
    [sym_identifier] = ACTIONS(13683),
    [sym_instance_variable] = ACTIONS(13685),
    [sym_class_variable] = ACTIONS(13685),
    [sym_global_variable] = ACTIONS(13685),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13687),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13687),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [11151] = {
    [sym_heredoc_body] = STATE(11149),
    [aux_sym_call_repeat1] = STATE(11149),
    [sym__heredoc_body_start] = ACTIONS(6569),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7931),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_EQ] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_PLUS_EQ] = ACTIONS(7929),
    [anon_sym_DASH_EQ] = ACTIONS(7929),
    [anon_sym_STAR_EQ] = ACTIONS(7929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7929),
    [anon_sym_SLASH_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7929),
    [anon_sym_AMP_EQ] = ACTIONS(7929),
    [anon_sym_PERCENT_EQ] = ACTIONS(7929),
    [anon_sym_GT_GT_EQ] = ACTIONS(7929),
    [anon_sym_LT_LT_EQ] = ACTIONS(7929),
    [anon_sym_CARET_EQ] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7931),
    [anon_sym_AMP_AMP] = ACTIONS(7931),
    [anon_sym_LT_LT] = ACTIONS(7931),
    [anon_sym_GT_GT] = ACTIONS(7931),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7931),
    [anon_sym_PLUS] = ACTIONS(7931),
    [anon_sym_SLASH] = ACTIONS(7931),
    [anon_sym_PERCENT] = ACTIONS(7931),
    [sym_comment] = ACTIONS(87),
  },
  [11152] = {
    [aux_sym_argument_list_repeat1] = STATE(11152),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(15246),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7927),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_EQ] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_PLUS_EQ] = ACTIONS(7925),
    [anon_sym_DASH_EQ] = ACTIONS(7925),
    [anon_sym_STAR_EQ] = ACTIONS(7925),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7925),
    [anon_sym_SLASH_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7925),
    [anon_sym_AMP_EQ] = ACTIONS(7925),
    [anon_sym_PERCENT_EQ] = ACTIONS(7925),
    [anon_sym_GT_GT_EQ] = ACTIONS(7925),
    [anon_sym_LT_LT_EQ] = ACTIONS(7925),
    [anon_sym_CARET_EQ] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7927),
    [anon_sym_AMP_AMP] = ACTIONS(7927),
    [anon_sym_LT_LT] = ACTIONS(7927),
    [anon_sym_GT_GT] = ACTIONS(7927),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7927),
    [anon_sym_PLUS] = ACTIONS(7927),
    [anon_sym_SLASH] = ACTIONS(7927),
    [anon_sym_PERCENT] = ACTIONS(7927),
    [sym_comment] = ACTIONS(87),
  },
  [11153] = {
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(14534),
    [sym__binary_star] = ACTIONS(14536),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(14538),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(14540),
    [anon_sym_AMP] = ACTIONS(14542),
    [anon_sym_EQ] = ACTIONS(7936),
    [anon_sym_LT] = ACTIONS(14544),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_EQ_GT] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_PLUS_EQ] = ACTIONS(5115),
    [anon_sym_DASH_EQ] = ACTIONS(5115),
    [anon_sym_STAR_EQ] = ACTIONS(5115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5115),
    [anon_sym_SLASH_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5115),
    [anon_sym_AMP_EQ] = ACTIONS(5115),
    [anon_sym_PERCENT_EQ] = ACTIONS(5115),
    [anon_sym_GT_GT_EQ] = ACTIONS(5115),
    [anon_sym_LT_LT_EQ] = ACTIONS(5115),
    [anon_sym_CARET_EQ] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(14546),
    [anon_sym_DOT_DOT] = ACTIONS(14548),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14550),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(14552),
    [anon_sym_AMP_AMP] = ACTIONS(14552),
    [anon_sym_LT_LT] = ACTIONS(14554),
    [anon_sym_GT_GT] = ACTIONS(14554),
    [anon_sym_EQ_EQ] = ACTIONS(14552),
    [anon_sym_BANG_EQ] = ACTIONS(14556),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14556),
    [anon_sym_LT_EQ_GT] = ACTIONS(14556),
    [anon_sym_EQ_TILDE] = ACTIONS(14556),
    [anon_sym_BANG_TILDE] = ACTIONS(14556),
    [anon_sym_LT_EQ] = ACTIONS(14544),
    [anon_sym_GT] = ACTIONS(14544),
    [anon_sym_GT_EQ] = ACTIONS(14558),
    [anon_sym_CARET] = ACTIONS(14538),
    [anon_sym_PLUS] = ACTIONS(14560),
    [anon_sym_SLASH] = ACTIONS(14540),
    [anon_sym_PERCENT] = ACTIONS(14540),
    [sym_comment] = ACTIONS(87),
  },
  [11154] = {
    [aux_sym_exceptions_repeat1] = STATE(11314),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6193),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_EQ_GT] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_PLUS_EQ] = ACTIONS(6191),
    [anon_sym_DASH_EQ] = ACTIONS(6191),
    [anon_sym_STAR_EQ] = ACTIONS(6191),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6191),
    [anon_sym_SLASH_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6191),
    [anon_sym_AMP_EQ] = ACTIONS(6191),
    [anon_sym_PERCENT_EQ] = ACTIONS(6191),
    [anon_sym_GT_GT_EQ] = ACTIONS(6191),
    [anon_sym_LT_LT_EQ] = ACTIONS(6191),
    [anon_sym_CARET_EQ] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6193),
    [anon_sym_AMP_AMP] = ACTIONS(6193),
    [anon_sym_LT_LT] = ACTIONS(6193),
    [anon_sym_GT_GT] = ACTIONS(6193),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6193),
    [anon_sym_PLUS] = ACTIONS(6193),
    [anon_sym_SLASH] = ACTIONS(6193),
    [anon_sym_PERCENT] = ACTIONS(6193),
    [sym_comment] = ACTIONS(87),
  },
  [11155] = {
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(14534),
    [sym__binary_star] = ACTIONS(14536),
    [anon_sym_LBRACE] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(14538),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(14540),
    [anon_sym_AMP] = ACTIONS(14542),
    [anon_sym_EQ] = ACTIONS(7938),
    [anon_sym_LT] = ACTIONS(14544),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_EQ_GT] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_PLUS_EQ] = ACTIONS(6210),
    [anon_sym_DASH_EQ] = ACTIONS(6210),
    [anon_sym_STAR_EQ] = ACTIONS(6210),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6210),
    [anon_sym_SLASH_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6210),
    [anon_sym_AMP_EQ] = ACTIONS(6210),
    [anon_sym_PERCENT_EQ] = ACTIONS(6210),
    [anon_sym_GT_GT_EQ] = ACTIONS(6210),
    [anon_sym_LT_LT_EQ] = ACTIONS(6210),
    [anon_sym_CARET_EQ] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(14546),
    [anon_sym_DOT_DOT] = ACTIONS(14548),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14550),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(14552),
    [anon_sym_AMP_AMP] = ACTIONS(14552),
    [anon_sym_LT_LT] = ACTIONS(14554),
    [anon_sym_GT_GT] = ACTIONS(14554),
    [anon_sym_EQ_EQ] = ACTIONS(14552),
    [anon_sym_BANG_EQ] = ACTIONS(14556),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14556),
    [anon_sym_LT_EQ_GT] = ACTIONS(14556),
    [anon_sym_EQ_TILDE] = ACTIONS(14556),
    [anon_sym_BANG_TILDE] = ACTIONS(14556),
    [anon_sym_LT_EQ] = ACTIONS(14544),
    [anon_sym_GT] = ACTIONS(14544),
    [anon_sym_GT_EQ] = ACTIONS(14558),
    [anon_sym_CARET] = ACTIONS(14538),
    [anon_sym_PLUS] = ACTIONS(14560),
    [anon_sym_SLASH] = ACTIONS(14540),
    [anon_sym_PERCENT] = ACTIONS(14540),
    [sym_comment] = ACTIONS(87),
  },
  [11156] = {
    [sym_string] = STATE(11156),
    [aux_sym_chained_string_repeat1] = STATE(11156),
    [sym__string_start] = ACTIONS(10559),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6217),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_EQ] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_do] = ACTIONS(6212),
    [anon_sym_EQ_GT] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_PLUS_EQ] = ACTIONS(6212),
    [anon_sym_DASH_EQ] = ACTIONS(6212),
    [anon_sym_STAR_EQ] = ACTIONS(6212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6212),
    [anon_sym_SLASH_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6212),
    [anon_sym_AMP_EQ] = ACTIONS(6212),
    [anon_sym_PERCENT_EQ] = ACTIONS(6212),
    [anon_sym_GT_GT_EQ] = ACTIONS(6212),
    [anon_sym_LT_LT_EQ] = ACTIONS(6212),
    [anon_sym_CARET_EQ] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6217),
    [anon_sym_AMP_AMP] = ACTIONS(6217),
    [anon_sym_LT_LT] = ACTIONS(6217),
    [anon_sym_GT_GT] = ACTIONS(6217),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6217),
    [anon_sym_PLUS] = ACTIONS(6217),
    [anon_sym_SLASH] = ACTIONS(6217),
    [anon_sym_PERCENT] = ACTIONS(6217),
    [sym_comment] = ACTIONS(87),
  },
  [11157] = {
    [sym__binary_minus] = ACTIONS(13631),
    [sym__binary_star] = ACTIONS(13633),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(14504),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_STAR_STAR] = ACTIONS(13633),
    [anon_sym_AMP] = ACTIONS(13637),
    [anon_sym_LT] = ACTIONS(13639),
    [anon_sym_QMARK] = ACTIONS(13641),
    [anon_sym_DOT_DOT] = ACTIONS(13643),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13645),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(13649),
    [anon_sym_AMP_AMP] = ACTIONS(13649),
    [anon_sym_LT_LT] = ACTIONS(13651),
    [anon_sym_GT_GT] = ACTIONS(13651),
    [anon_sym_EQ_EQ] = ACTIONS(13653),
    [anon_sym_BANG_EQ] = ACTIONS(13649),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13649),
    [anon_sym_LT_EQ_GT] = ACTIONS(13649),
    [anon_sym_EQ_TILDE] = ACTIONS(13649),
    [anon_sym_BANG_TILDE] = ACTIONS(13649),
    [anon_sym_LT_EQ] = ACTIONS(13639),
    [anon_sym_GT] = ACTIONS(13639),
    [anon_sym_GT_EQ] = ACTIONS(13655),
    [anon_sym_CARET] = ACTIONS(13657),
    [anon_sym_PLUS] = ACTIONS(13631),
    [anon_sym_SLASH] = ACTIONS(13633),
    [anon_sym_PERCENT] = ACTIONS(13633),
    [sym_comment] = ACTIONS(87),
  },
  [11158] = {
    [sym_method] = STATE(454),
    [sym_singleton_method] = STATE(454),
    [sym_class] = STATE(454),
    [sym_singleton_class] = STATE(454),
    [sym_module] = STATE(454),
    [sym_return] = STATE(454),
    [sym_yield] = STATE(454),
    [sym_break] = STATE(454),
    [sym_next] = STATE(454),
    [sym_while] = STATE(454),
    [sym_until] = STATE(454),
    [sym_for] = STATE(454),
    [sym_case] = STATE(454),
    [sym_if] = STATE(454),
    [sym_unless] = STATE(454),
    [sym_begin] = STATE(454),
    [sym__arg] = STATE(10798),
    [sym__primary] = STATE(454),
    [sym_parenthesized_statements] = STATE(454),
    [sym_element_reference] = STATE(8445),
    [sym_scope_resolution] = STATE(8443),
    [sym_call] = STATE(8443),
    [sym_method_call] = STATE(8445),
    [sym_splat_argument] = STATE(6983),
    [sym_assignment] = STATE(10798),
    [sym_operator_assignment] = STATE(10798),
    [sym_conditional] = STATE(10798),
    [sym_range] = STATE(10798),
    [sym_binary] = STATE(10798),
    [sym_unary] = STATE(10798),
    [sym__arg_or_splat_arg] = STATE(6983),
    [sym_left_assignment_list] = STATE(8444),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(8445),
    [sym__variable] = STATE(8443),
    [sym_rational] = STATE(454),
    [sym_true] = STATE(8445),
    [sym_false] = STATE(8445),
    [sym_nil] = STATE(8445),
    [sym_chained_string] = STATE(454),
    [sym_string] = STATE(8446),
    [sym_subshell] = STATE(454),
    [sym_string_array] = STATE(454),
    [sym_symbol_array] = STATE(454),
    [sym_symbol] = STATE(454),
    [sym_regex] = STATE(454),
    [sym_array] = STATE(454),
    [sym_hash] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(839),
    [sym__splat_star] = ACTIONS(14572),
    [sym__unary_minus] = ACTIONS(12003),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(12005),
    [anon_sym_yield] = ACTIONS(12007),
    [anon_sym_break] = ACTIONS(12009),
    [anon_sym_next] = ACTIONS(12011),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(12013),
    [anon_sym_defined_QMARK] = ACTIONS(12015),
    [anon_sym_not] = ACTIONS(12017),
    [anon_sym_BANG] = ACTIONS(12019),
    [anon_sym_TILDE] = ACTIONS(12019),
    [sym_constant] = ACTIONS(12021),
    [sym_identifier] = ACTIONS(12021),
    [sym_instance_variable] = ACTIONS(12023),
    [sym_class_variable] = ACTIONS(12023),
    [sym_global_variable] = ACTIONS(12023),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(839),
    [sym_super] = ACTIONS(12021),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(12021),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(839),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [11159] = {
    [aux_sym_exceptions_repeat1] = STATE(11315),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_COMMA] = ACTIONS(15249),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [11160] = {
    [sym__simple_symbol] = ACTIONS(15251),
    [sym__string_start] = ACTIONS(15251),
    [sym__symbol_start] = ACTIONS(15251),
    [sym__subshell_start] = ACTIONS(15251),
    [sym__regex_start] = ACTIONS(15251),
    [sym__string_array_start] = ACTIONS(15251),
    [sym__symbol_array_start] = ACTIONS(15251),
    [sym_heredoc_beginning] = ACTIONS(15251),
    [sym__unary_minus] = ACTIONS(15251),
    [anon_sym_BEGIN] = ACTIONS(15253),
    [anon_sym_LBRACE] = ACTIONS(15251),
    [anon_sym_RBRACE] = ACTIONS(15251),
    [anon_sym_END] = ACTIONS(15253),
    [anon_sym_def] = ACTIONS(15253),
    [anon_sym_LPAREN] = ACTIONS(15251),
    [anon_sym_COLON_COLON] = ACTIONS(15251),
    [anon_sym_SEMI] = ACTIONS(15251),
    [anon_sym_STAR] = ACTIONS(15251),
    [anon_sym_class] = ACTIONS(15253),
    [anon_sym_module] = ACTIONS(15253),
    [anon_sym_return] = ACTIONS(15253),
    [anon_sym_yield] = ACTIONS(15253),
    [anon_sym_break] = ACTIONS(15253),
    [anon_sym_next] = ACTIONS(15253),
    [sym_redo] = ACTIONS(15253),
    [sym_retry] = ACTIONS(15253),
    [anon_sym_if] = ACTIONS(15253),
    [anon_sym_unless] = ACTIONS(15253),
    [anon_sym_while] = ACTIONS(15253),
    [anon_sym_until] = ACTIONS(15253),
    [anon_sym_for] = ACTIONS(15253),
    [anon_sym_case] = ACTIONS(15253),
    [anon_sym_begin] = ACTIONS(15253),
    [anon_sym_PLUS] = ACTIONS(15253),
    [anon_sym_defined_QMARK] = ACTIONS(15251),
    [anon_sym_not] = ACTIONS(15253),
    [anon_sym_BANG] = ACTIONS(15251),
    [anon_sym_TILDE] = ACTIONS(15251),
    [sym_constant] = ACTIONS(15253),
    [sym_identifier] = ACTIONS(15253),
    [sym_instance_variable] = ACTIONS(15251),
    [sym_class_variable] = ACTIONS(15251),
    [sym_global_variable] = ACTIONS(15251),
    [anon_sym_undef] = ACTIONS(15253),
    [anon_sym_alias] = ACTIONS(15253),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(15253),
    [sym_float] = ACTIONS(15253),
    [sym_complex] = ACTIONS(15251),
    [sym_super] = ACTIONS(15253),
    [anon_sym_true] = ACTIONS(15253),
    [anon_sym_TRUE] = ACTIONS(15253),
    [anon_sym_false] = ACTIONS(15253),
    [anon_sym_FALSE] = ACTIONS(15253),
    [sym_self] = ACTIONS(15253),
    [anon_sym_nil] = ACTIONS(15253),
    [anon_sym_NIL] = ACTIONS(15253),
    [sym_character] = ACTIONS(15251),
    [anon_sym_LBRACK2] = ACTIONS(15251),
    [anon_sym_DASH_GT] = ACTIONS(15251),
  },
  [11161] = {
    [aux_sym_block_parameters_repeat1] = STATE(9913),
    [anon_sym_COMMA] = ACTIONS(11999),
    [anon_sym_PIPE] = ACTIONS(15255),
    [sym_comment] = ACTIONS(87),
  },
  [11162] = {
    [sym__line_break] = ACTIONS(15251),
    [sym__simple_symbol] = ACTIONS(15251),
    [sym__string_start] = ACTIONS(15251),
    [sym__symbol_start] = ACTIONS(15251),
    [sym__subshell_start] = ACTIONS(15251),
    [sym__regex_start] = ACTIONS(15251),
    [sym__string_array_start] = ACTIONS(15251),
    [sym__symbol_array_start] = ACTIONS(15251),
    [sym__heredoc_body_start] = ACTIONS(15251),
    [sym_heredoc_beginning] = ACTIONS(15251),
    [sym__unary_minus] = ACTIONS(15251),
    [anon_sym_BEGIN] = ACTIONS(15253),
    [anon_sym_LBRACE] = ACTIONS(15251),
    [anon_sym_END] = ACTIONS(15253),
    [anon_sym_def] = ACTIONS(15253),
    [anon_sym_LPAREN] = ACTIONS(15251),
    [anon_sym_COLON_COLON] = ACTIONS(15251),
    [anon_sym_SEMI] = ACTIONS(15251),
    [anon_sym_STAR] = ACTIONS(15251),
    [anon_sym_class] = ACTIONS(15253),
    [anon_sym_module] = ACTIONS(15253),
    [anon_sym_end] = ACTIONS(15253),
    [anon_sym_return] = ACTIONS(15253),
    [anon_sym_yield] = ACTIONS(15253),
    [anon_sym_break] = ACTIONS(15253),
    [anon_sym_next] = ACTIONS(15253),
    [sym_redo] = ACTIONS(15253),
    [sym_retry] = ACTIONS(15253),
    [anon_sym_if] = ACTIONS(15253),
    [anon_sym_unless] = ACTIONS(15253),
    [anon_sym_while] = ACTIONS(15253),
    [anon_sym_until] = ACTIONS(15253),
    [anon_sym_for] = ACTIONS(15253),
    [anon_sym_case] = ACTIONS(15253),
    [anon_sym_begin] = ACTIONS(15253),
    [anon_sym_PLUS] = ACTIONS(15253),
    [anon_sym_defined_QMARK] = ACTIONS(15251),
    [anon_sym_not] = ACTIONS(15253),
    [anon_sym_BANG] = ACTIONS(15251),
    [anon_sym_TILDE] = ACTIONS(15251),
    [sym_constant] = ACTIONS(15253),
    [sym_identifier] = ACTIONS(15253),
    [sym_instance_variable] = ACTIONS(15251),
    [sym_class_variable] = ACTIONS(15251),
    [sym_global_variable] = ACTIONS(15251),
    [anon_sym_undef] = ACTIONS(15253),
    [anon_sym_alias] = ACTIONS(15253),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(15253),
    [sym_float] = ACTIONS(15253),
    [sym_complex] = ACTIONS(15251),
    [sym_super] = ACTIONS(15253),
    [anon_sym_true] = ACTIONS(15253),
    [anon_sym_TRUE] = ACTIONS(15253),
    [anon_sym_false] = ACTIONS(15253),
    [anon_sym_FALSE] = ACTIONS(15253),
    [sym_self] = ACTIONS(15253),
    [anon_sym_nil] = ACTIONS(15253),
    [anon_sym_NIL] = ACTIONS(15253),
    [sym_character] = ACTIONS(15251),
    [anon_sym_LBRACK2] = ACTIONS(15251),
    [anon_sym_DASH_GT] = ACTIONS(15251),
  },
  [11163] = {
    [aux_sym_block_parameters_repeat1] = STATE(9913),
    [anon_sym_COMMA] = ACTIONS(11999),
    [anon_sym_PIPE] = ACTIONS(15257),
    [sym_comment] = ACTIONS(87),
  },
  [11164] = {
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(12066),
    [sym__binary_star] = ACTIONS(12068),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(12070),
    [anon_sym_STAR_STAR] = ACTIONS(12068),
    [anon_sym_AMP] = ACTIONS(12072),
    [anon_sym_LT] = ACTIONS(12074),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(12076),
    [anon_sym_COLON2] = ACTIONS(12879),
    [anon_sym_DOT_DOT] = ACTIONS(12078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12080),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(12082),
    [anon_sym_AMP_AMP] = ACTIONS(12082),
    [anon_sym_LT_LT] = ACTIONS(12084),
    [anon_sym_GT_GT] = ACTIONS(12084),
    [anon_sym_EQ_EQ] = ACTIONS(12086),
    [anon_sym_BANG_EQ] = ACTIONS(12082),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12082),
    [anon_sym_LT_EQ_GT] = ACTIONS(12082),
    [anon_sym_EQ_TILDE] = ACTIONS(12082),
    [anon_sym_BANG_TILDE] = ACTIONS(12082),
    [anon_sym_LT_EQ] = ACTIONS(12074),
    [anon_sym_GT] = ACTIONS(12074),
    [anon_sym_GT_EQ] = ACTIONS(12088),
    [anon_sym_CARET] = ACTIONS(12090),
    [anon_sym_PLUS] = ACTIONS(12066),
    [anon_sym_SLASH] = ACTIONS(12068),
    [anon_sym_PERCENT] = ACTIONS(12068),
    [sym_comment] = ACTIONS(87),
  },
  [11165] = {
    [aux_sym_exceptions_repeat1] = STATE(11165),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(15259),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_COLON2] = ACTIONS(12338),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [11166] = {
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(12122),
    [sym__binary_star] = ACTIONS(12124),
    [anon_sym_LBRACE] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(12126),
    [anon_sym_STAR_STAR] = ACTIONS(12128),
    [anon_sym_AMP] = ACTIONS(12130),
    [anon_sym_EQ] = ACTIONS(12879),
    [anon_sym_LT] = ACTIONS(12132),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_PLUS_EQ] = ACTIONS(12120),
    [anon_sym_DASH_EQ] = ACTIONS(12120),
    [anon_sym_STAR_EQ] = ACTIONS(12120),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12120),
    [anon_sym_SLASH_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12120),
    [anon_sym_AMP_EQ] = ACTIONS(12120),
    [anon_sym_PERCENT_EQ] = ACTIONS(12120),
    [anon_sym_GT_GT_EQ] = ACTIONS(12120),
    [anon_sym_LT_LT_EQ] = ACTIONS(12120),
    [anon_sym_CARET_EQ] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(12134),
    [anon_sym_COLON2] = ACTIONS(12879),
    [anon_sym_DOT_DOT] = ACTIONS(12136),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12138),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(12140),
    [anon_sym_AMP_AMP] = ACTIONS(12140),
    [anon_sym_LT_LT] = ACTIONS(12142),
    [anon_sym_GT_GT] = ACTIONS(12142),
    [anon_sym_EQ_EQ] = ACTIONS(12140),
    [anon_sym_BANG_EQ] = ACTIONS(12144),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12144),
    [anon_sym_LT_EQ_GT] = ACTIONS(12144),
    [anon_sym_EQ_TILDE] = ACTIONS(12144),
    [anon_sym_BANG_TILDE] = ACTIONS(12144),
    [anon_sym_LT_EQ] = ACTIONS(12132),
    [anon_sym_GT] = ACTIONS(12132),
    [anon_sym_GT_EQ] = ACTIONS(12146),
    [anon_sym_CARET] = ACTIONS(12126),
    [anon_sym_PLUS] = ACTIONS(12148),
    [anon_sym_SLASH] = ACTIONS(12128),
    [anon_sym_PERCENT] = ACTIONS(12128),
    [sym_comment] = ACTIONS(87),
  },
  [11167] = {
    [aux_sym_exceptions_repeat1] = STATE(11167),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(15262),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_PLUS_EQ] = ACTIONS(11597),
    [anon_sym_DASH_EQ] = ACTIONS(11597),
    [anon_sym_STAR_EQ] = ACTIONS(11597),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11597),
    [anon_sym_SLASH_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11597),
    [anon_sym_AMP_EQ] = ACTIONS(11597),
    [anon_sym_PERCENT_EQ] = ACTIONS(11597),
    [anon_sym_GT_GT_EQ] = ACTIONS(11597),
    [anon_sym_LT_LT_EQ] = ACTIONS(11597),
    [anon_sym_CARET_EQ] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_COLON2] = ACTIONS(12338),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_LT] = ACTIONS(12338),
    [anon_sym_GT_GT] = ACTIONS(12338),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(12338),
    [anon_sym_PLUS] = ACTIONS(12338),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [11168] = {
    [sym__binary_minus] = ACTIONS(12160),
    [sym__binary_star] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(12164),
    [anon_sym_STAR_STAR] = ACTIONS(12162),
    [anon_sym_AMP] = ACTIONS(12166),
    [anon_sym_LT] = ACTIONS(12168),
    [anon_sym_QMARK] = ACTIONS(12170),
    [anon_sym_COLON2] = ACTIONS(12120),
    [anon_sym_DOT_DOT] = ACTIONS(12172),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12174),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(12176),
    [anon_sym_AMP_AMP] = ACTIONS(12176),
    [anon_sym_LT_LT] = ACTIONS(12178),
    [anon_sym_GT_GT] = ACTIONS(12178),
    [anon_sym_EQ_EQ] = ACTIONS(12180),
    [anon_sym_BANG_EQ] = ACTIONS(12176),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12176),
    [anon_sym_LT_EQ_GT] = ACTIONS(12176),
    [anon_sym_EQ_TILDE] = ACTIONS(12176),
    [anon_sym_BANG_TILDE] = ACTIONS(12176),
    [anon_sym_LT_EQ] = ACTIONS(12168),
    [anon_sym_GT] = ACTIONS(12168),
    [anon_sym_GT_EQ] = ACTIONS(12182),
    [anon_sym_CARET] = ACTIONS(12184),
    [anon_sym_PLUS] = ACTIONS(12160),
    [anon_sym_SLASH] = ACTIONS(12162),
    [anon_sym_PERCENT] = ACTIONS(12162),
    [sym_comment] = ACTIONS(87),
  },
  [11169] = {
    [sym__line_break] = ACTIONS(14151),
    [sym__heredoc_body_start] = ACTIONS(14151),
    [sym__binary_minus] = ACTIONS(14151),
    [sym__binary_star] = ACTIONS(14151),
    [ts_builtin_sym_end] = ACTIONS(14151),
    [anon_sym___END__] = ACTIONS(14151),
    [anon_sym_LBRACE] = ACTIONS(14151),
    [anon_sym_RBRACE] = ACTIONS(14151),
    [anon_sym_RPAREN] = ACTIONS(14151),
    [anon_sym_DOT] = ACTIONS(14153),
    [anon_sym_COMMA] = ACTIONS(14151),
    [anon_sym_PIPE] = ACTIONS(14153),
    [anon_sym_SEMI] = ACTIONS(14151),
    [anon_sym_STAR_STAR] = ACTIONS(14153),
    [anon_sym_AMP] = ACTIONS(14153),
    [anon_sym_EQ] = ACTIONS(14153),
    [anon_sym_LT] = ACTIONS(14153),
    [anon_sym_end] = ACTIONS(14151),
    [anon_sym_if] = ACTIONS(14151),
    [anon_sym_unless] = ACTIONS(14151),
    [anon_sym_while] = ACTIONS(14151),
    [anon_sym_until] = ACTIONS(14151),
    [anon_sym_rescue] = ACTIONS(14151),
    [anon_sym_do] = ACTIONS(14151),
    [anon_sym_when] = ACTIONS(14151),
    [anon_sym_elsif] = ACTIONS(14151),
    [anon_sym_else] = ACTIONS(14151),
    [anon_sym_then] = ACTIONS(14151),
    [anon_sym_ensure] = ACTIONS(14151),
    [anon_sym_LBRACK] = ACTIONS(14151),
    [anon_sym_COLON_COLON2] = ACTIONS(14151),
    [anon_sym_AMP_DOT] = ACTIONS(14151),
    [anon_sym_PLUS_EQ] = ACTIONS(14151),
    [anon_sym_DASH_EQ] = ACTIONS(14151),
    [anon_sym_STAR_EQ] = ACTIONS(14151),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14151),
    [anon_sym_SLASH_EQ] = ACTIONS(14151),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14151),
    [anon_sym_PIPE_EQ] = ACTIONS(14151),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14151),
    [anon_sym_AMP_EQ] = ACTIONS(14151),
    [anon_sym_PERCENT_EQ] = ACTIONS(14151),
    [anon_sym_GT_GT_EQ] = ACTIONS(14151),
    [anon_sym_LT_LT_EQ] = ACTIONS(14151),
    [anon_sym_CARET_EQ] = ACTIONS(14151),
    [anon_sym_QMARK] = ACTIONS(14151),
    [anon_sym_DOT_DOT] = ACTIONS(14153),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14151),
    [anon_sym_and] = ACTIONS(14151),
    [anon_sym_or] = ACTIONS(14151),
    [anon_sym_PIPE_PIPE] = ACTIONS(14153),
    [anon_sym_AMP_AMP] = ACTIONS(14153),
    [anon_sym_LT_LT] = ACTIONS(14153),
    [anon_sym_GT_GT] = ACTIONS(14153),
    [anon_sym_EQ_EQ] = ACTIONS(14153),
    [anon_sym_BANG_EQ] = ACTIONS(14151),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14151),
    [anon_sym_LT_EQ_GT] = ACTIONS(14151),
    [anon_sym_EQ_TILDE] = ACTIONS(14151),
    [anon_sym_BANG_TILDE] = ACTIONS(14151),
    [anon_sym_LT_EQ] = ACTIONS(14153),
    [anon_sym_GT] = ACTIONS(14153),
    [anon_sym_GT_EQ] = ACTIONS(14151),
    [anon_sym_CARET] = ACTIONS(14153),
    [anon_sym_PLUS] = ACTIONS(14153),
    [anon_sym_SLASH] = ACTIONS(14153),
    [anon_sym_PERCENT] = ACTIONS(14153),
    [sym_comment] = ACTIONS(87),
  },
  [11170] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(12276),
    [sym__binary_star] = ACTIONS(12278),
    [anon_sym_RBRACE] = ACTIONS(12120),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(12280),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(12278),
    [anon_sym_AMP] = ACTIONS(12282),
    [anon_sym_LT] = ACTIONS(12284),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_EQ_GT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(12286),
    [anon_sym_DOT_DOT] = ACTIONS(12288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12290),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(12292),
    [anon_sym_AMP_AMP] = ACTIONS(12292),
    [anon_sym_LT_LT] = ACTIONS(12294),
    [anon_sym_GT_GT] = ACTIONS(12294),
    [anon_sym_EQ_EQ] = ACTIONS(12296),
    [anon_sym_BANG_EQ] = ACTIONS(12292),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12292),
    [anon_sym_LT_EQ_GT] = ACTIONS(12292),
    [anon_sym_EQ_TILDE] = ACTIONS(12292),
    [anon_sym_BANG_TILDE] = ACTIONS(12292),
    [anon_sym_LT_EQ] = ACTIONS(12284),
    [anon_sym_GT] = ACTIONS(12284),
    [anon_sym_GT_EQ] = ACTIONS(12298),
    [anon_sym_CARET] = ACTIONS(12300),
    [anon_sym_PLUS] = ACTIONS(12276),
    [anon_sym_SLASH] = ACTIONS(12278),
    [anon_sym_PERCENT] = ACTIONS(12278),
    [sym_comment] = ACTIONS(87),
  },
  [11171] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(12343),
    [sym__binary_star] = ACTIONS(12345),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(12347),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(12345),
    [anon_sym_AMP] = ACTIONS(12349),
    [anon_sym_LT] = ACTIONS(12351),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(12353),
    [anon_sym_DOT_DOT] = ACTIONS(12355),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12357),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(12359),
    [anon_sym_AMP_AMP] = ACTIONS(12359),
    [anon_sym_LT_LT] = ACTIONS(12361),
    [anon_sym_GT_GT] = ACTIONS(12361),
    [anon_sym_EQ_EQ] = ACTIONS(12363),
    [anon_sym_BANG_EQ] = ACTIONS(12359),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12359),
    [anon_sym_LT_EQ_GT] = ACTIONS(12359),
    [anon_sym_EQ_TILDE] = ACTIONS(12359),
    [anon_sym_BANG_TILDE] = ACTIONS(12359),
    [anon_sym_LT_EQ] = ACTIONS(12351),
    [anon_sym_GT] = ACTIONS(12351),
    [anon_sym_GT_EQ] = ACTIONS(12365),
    [anon_sym_CARET] = ACTIONS(12367),
    [anon_sym_PLUS] = ACTIONS(12343),
    [anon_sym_SLASH] = ACTIONS(12345),
    [anon_sym_PERCENT] = ACTIONS(12345),
    [sym_comment] = ACTIONS(87),
  },
  [11172] = {
    [aux_sym_exceptions_repeat1] = STATE(11172),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(15265),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [11173] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(12395),
    [sym__binary_star] = ACTIONS(12397),
    [anon_sym_LBRACE] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(12399),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(12401),
    [anon_sym_AMP] = ACTIONS(12403),
    [anon_sym_EQ] = ACTIONS(12879),
    [anon_sym_LT] = ACTIONS(12405),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_PLUS_EQ] = ACTIONS(12120),
    [anon_sym_DASH_EQ] = ACTIONS(12120),
    [anon_sym_STAR_EQ] = ACTIONS(12120),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12120),
    [anon_sym_SLASH_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12120),
    [anon_sym_AMP_EQ] = ACTIONS(12120),
    [anon_sym_PERCENT_EQ] = ACTIONS(12120),
    [anon_sym_GT_GT_EQ] = ACTIONS(12120),
    [anon_sym_LT_LT_EQ] = ACTIONS(12120),
    [anon_sym_CARET_EQ] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(12407),
    [anon_sym_DOT_DOT] = ACTIONS(12409),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12411),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(12413),
    [anon_sym_AMP_AMP] = ACTIONS(12413),
    [anon_sym_LT_LT] = ACTIONS(12415),
    [anon_sym_GT_GT] = ACTIONS(12415),
    [anon_sym_EQ_EQ] = ACTIONS(12413),
    [anon_sym_BANG_EQ] = ACTIONS(12417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12417),
    [anon_sym_LT_EQ_GT] = ACTIONS(12417),
    [anon_sym_EQ_TILDE] = ACTIONS(12417),
    [anon_sym_BANG_TILDE] = ACTIONS(12417),
    [anon_sym_LT_EQ] = ACTIONS(12405),
    [anon_sym_GT] = ACTIONS(12405),
    [anon_sym_GT_EQ] = ACTIONS(12419),
    [anon_sym_CARET] = ACTIONS(12399),
    [anon_sym_PLUS] = ACTIONS(12421),
    [anon_sym_SLASH] = ACTIONS(12401),
    [anon_sym_PERCENT] = ACTIONS(12401),
    [sym_comment] = ACTIONS(87),
  },
  [11174] = {
    [aux_sym_exceptions_repeat1] = STATE(11174),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(15268),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_PLUS_EQ] = ACTIONS(11597),
    [anon_sym_DASH_EQ] = ACTIONS(11597),
    [anon_sym_STAR_EQ] = ACTIONS(11597),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11597),
    [anon_sym_SLASH_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11597),
    [anon_sym_AMP_EQ] = ACTIONS(11597),
    [anon_sym_PERCENT_EQ] = ACTIONS(11597),
    [anon_sym_GT_GT_EQ] = ACTIONS(11597),
    [anon_sym_LT_LT_EQ] = ACTIONS(11597),
    [anon_sym_CARET_EQ] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_LT] = ACTIONS(12338),
    [anon_sym_GT_GT] = ACTIONS(12338),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(12338),
    [anon_sym_PLUS] = ACTIONS(12338),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [11175] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(12431),
    [sym__binary_star] = ACTIONS(12433),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(12435),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(12433),
    [anon_sym_AMP] = ACTIONS(12437),
    [anon_sym_LT] = ACTIONS(12439),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(12441),
    [anon_sym_DOT_DOT] = ACTIONS(12443),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12445),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(12447),
    [anon_sym_AMP_AMP] = ACTIONS(12447),
    [anon_sym_LT_LT] = ACTIONS(12449),
    [anon_sym_GT_GT] = ACTIONS(12449),
    [anon_sym_EQ_EQ] = ACTIONS(12451),
    [anon_sym_BANG_EQ] = ACTIONS(12447),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12447),
    [anon_sym_LT_EQ_GT] = ACTIONS(12447),
    [anon_sym_EQ_TILDE] = ACTIONS(12447),
    [anon_sym_BANG_TILDE] = ACTIONS(12447),
    [anon_sym_LT_EQ] = ACTIONS(12439),
    [anon_sym_GT] = ACTIONS(12439),
    [anon_sym_GT_EQ] = ACTIONS(12453),
    [anon_sym_CARET] = ACTIONS(12455),
    [anon_sym_PLUS] = ACTIONS(12431),
    [anon_sym_SLASH] = ACTIONS(12433),
    [anon_sym_PERCENT] = ACTIONS(12433),
    [sym_comment] = ACTIONS(87),
  },
  [11176] = {
    [sym__heredoc_body_start] = ACTIONS(12555),
    [sym__binary_minus] = ACTIONS(12555),
    [sym__binary_star] = ACTIONS(12555),
    [anon_sym_LBRACE] = ACTIONS(12555),
    [anon_sym_RBRACE] = ACTIONS(12555),
    [anon_sym_RPAREN] = ACTIONS(12555),
    [anon_sym_DOT] = ACTIONS(12557),
    [anon_sym_COMMA] = ACTIONS(12555),
    [anon_sym_PIPE] = ACTIONS(12557),
    [anon_sym_SEMI] = ACTIONS(12555),
    [anon_sym_STAR_STAR] = ACTIONS(12557),
    [anon_sym_AMP] = ACTIONS(12557),
    [anon_sym_EQ] = ACTIONS(12557),
    [anon_sym_LT] = ACTIONS(12557),
    [anon_sym_if] = ACTIONS(12555),
    [anon_sym_unless] = ACTIONS(12555),
    [anon_sym_while] = ACTIONS(12555),
    [anon_sym_until] = ACTIONS(12555),
    [anon_sym_rescue] = ACTIONS(12555),
    [anon_sym_in] = ACTIONS(12555),
    [anon_sym_do] = ACTIONS(12555),
    [anon_sym_LBRACK] = ACTIONS(12555),
    [anon_sym_RBRACK] = ACTIONS(12555),
    [anon_sym_COLON_COLON2] = ACTIONS(12555),
    [anon_sym_AMP_DOT] = ACTIONS(12555),
    [anon_sym_PLUS_EQ] = ACTIONS(12555),
    [anon_sym_DASH_EQ] = ACTIONS(12555),
    [anon_sym_STAR_EQ] = ACTIONS(12555),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12555),
    [anon_sym_SLASH_EQ] = ACTIONS(12555),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12555),
    [anon_sym_PIPE_EQ] = ACTIONS(12555),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12555),
    [anon_sym_AMP_EQ] = ACTIONS(12555),
    [anon_sym_PERCENT_EQ] = ACTIONS(12555),
    [anon_sym_GT_GT_EQ] = ACTIONS(12555),
    [anon_sym_LT_LT_EQ] = ACTIONS(12555),
    [anon_sym_CARET_EQ] = ACTIONS(12555),
    [anon_sym_QMARK] = ACTIONS(12555),
    [anon_sym_COLON2] = ACTIONS(12557),
    [anon_sym_DOT_DOT] = ACTIONS(12557),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12555),
    [anon_sym_and] = ACTIONS(12555),
    [anon_sym_or] = ACTIONS(12555),
    [anon_sym_PIPE_PIPE] = ACTIONS(12557),
    [anon_sym_AMP_AMP] = ACTIONS(12557),
    [anon_sym_LT_LT] = ACTIONS(12557),
    [anon_sym_GT_GT] = ACTIONS(12557),
    [anon_sym_EQ_EQ] = ACTIONS(12557),
    [anon_sym_BANG_EQ] = ACTIONS(12555),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12555),
    [anon_sym_LT_EQ_GT] = ACTIONS(12555),
    [anon_sym_EQ_TILDE] = ACTIONS(12555),
    [anon_sym_BANG_TILDE] = ACTIONS(12555),
    [anon_sym_LT_EQ] = ACTIONS(12557),
    [anon_sym_GT] = ACTIONS(12557),
    [anon_sym_GT_EQ] = ACTIONS(12555),
    [anon_sym_CARET] = ACTIONS(12557),
    [anon_sym_PLUS] = ACTIONS(12557),
    [anon_sym_SLASH] = ACTIONS(12557),
    [anon_sym_PERCENT] = ACTIONS(12557),
    [sym_comment] = ACTIONS(87),
  },
  [11177] = {
    [sym__heredoc_body_start] = ACTIONS(12559),
    [sym__binary_minus] = ACTIONS(12559),
    [sym__binary_star] = ACTIONS(12559),
    [anon_sym_LBRACE] = ACTIONS(12559),
    [anon_sym_RBRACE] = ACTIONS(12559),
    [anon_sym_RPAREN] = ACTIONS(12559),
    [anon_sym_DOT] = ACTIONS(12561),
    [anon_sym_COMMA] = ACTIONS(12559),
    [anon_sym_PIPE] = ACTIONS(12561),
    [anon_sym_SEMI] = ACTIONS(12559),
    [anon_sym_STAR_STAR] = ACTIONS(12561),
    [anon_sym_AMP] = ACTIONS(12561),
    [anon_sym_EQ] = ACTIONS(12561),
    [anon_sym_LT] = ACTIONS(12561),
    [anon_sym_if] = ACTIONS(12559),
    [anon_sym_unless] = ACTIONS(12559),
    [anon_sym_while] = ACTIONS(12559),
    [anon_sym_until] = ACTIONS(12559),
    [anon_sym_rescue] = ACTIONS(12559),
    [anon_sym_in] = ACTIONS(12559),
    [anon_sym_do] = ACTIONS(12559),
    [anon_sym_LBRACK] = ACTIONS(12559),
    [anon_sym_RBRACK] = ACTIONS(12559),
    [anon_sym_COLON_COLON2] = ACTIONS(12559),
    [anon_sym_AMP_DOT] = ACTIONS(12559),
    [anon_sym_PLUS_EQ] = ACTIONS(12559),
    [anon_sym_DASH_EQ] = ACTIONS(12559),
    [anon_sym_STAR_EQ] = ACTIONS(12559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12559),
    [anon_sym_SLASH_EQ] = ACTIONS(12559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12559),
    [anon_sym_PIPE_EQ] = ACTIONS(12559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12559),
    [anon_sym_AMP_EQ] = ACTIONS(12559),
    [anon_sym_PERCENT_EQ] = ACTIONS(12559),
    [anon_sym_GT_GT_EQ] = ACTIONS(12559),
    [anon_sym_LT_LT_EQ] = ACTIONS(12559),
    [anon_sym_CARET_EQ] = ACTIONS(12559),
    [anon_sym_QMARK] = ACTIONS(12559),
    [anon_sym_COLON2] = ACTIONS(12561),
    [anon_sym_DOT_DOT] = ACTIONS(12561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12559),
    [anon_sym_and] = ACTIONS(12559),
    [anon_sym_or] = ACTIONS(12559),
    [anon_sym_PIPE_PIPE] = ACTIONS(12561),
    [anon_sym_AMP_AMP] = ACTIONS(12561),
    [anon_sym_LT_LT] = ACTIONS(12561),
    [anon_sym_GT_GT] = ACTIONS(12561),
    [anon_sym_EQ_EQ] = ACTIONS(12561),
    [anon_sym_BANG_EQ] = ACTIONS(12559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12559),
    [anon_sym_LT_EQ_GT] = ACTIONS(12559),
    [anon_sym_EQ_TILDE] = ACTIONS(12559),
    [anon_sym_BANG_TILDE] = ACTIONS(12559),
    [anon_sym_LT_EQ] = ACTIONS(12561),
    [anon_sym_GT] = ACTIONS(12561),
    [anon_sym_GT_EQ] = ACTIONS(12559),
    [anon_sym_CARET] = ACTIONS(12561),
    [anon_sym_PLUS] = ACTIONS(12561),
    [anon_sym_SLASH] = ACTIONS(12561),
    [anon_sym_PERCENT] = ACTIONS(12561),
    [sym_comment] = ACTIONS(87),
  },
  [11178] = {
    [sym__heredoc_body_start] = ACTIONS(12663),
    [sym__binary_minus] = ACTIONS(12663),
    [sym__binary_star] = ACTIONS(12663),
    [anon_sym_LBRACE] = ACTIONS(12663),
    [anon_sym_RBRACE] = ACTIONS(12663),
    [anon_sym_RPAREN] = ACTIONS(12663),
    [anon_sym_DOT] = ACTIONS(12665),
    [anon_sym_COMMA] = ACTIONS(12663),
    [anon_sym_PIPE] = ACTIONS(12665),
    [anon_sym_SEMI] = ACTIONS(12663),
    [anon_sym_STAR_STAR] = ACTIONS(12665),
    [anon_sym_AMP] = ACTIONS(12665),
    [anon_sym_EQ] = ACTIONS(12665),
    [anon_sym_LT] = ACTIONS(12665),
    [anon_sym_if] = ACTIONS(12663),
    [anon_sym_unless] = ACTIONS(12663),
    [anon_sym_while] = ACTIONS(12663),
    [anon_sym_until] = ACTIONS(12663),
    [anon_sym_rescue] = ACTIONS(12663),
    [anon_sym_in] = ACTIONS(12663),
    [anon_sym_do] = ACTIONS(12663),
    [anon_sym_LBRACK] = ACTIONS(12663),
    [anon_sym_RBRACK] = ACTIONS(12663),
    [anon_sym_COLON_COLON2] = ACTIONS(12663),
    [anon_sym_AMP_DOT] = ACTIONS(12663),
    [anon_sym_PLUS_EQ] = ACTIONS(12663),
    [anon_sym_DASH_EQ] = ACTIONS(12663),
    [anon_sym_STAR_EQ] = ACTIONS(12663),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12663),
    [anon_sym_SLASH_EQ] = ACTIONS(12663),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12663),
    [anon_sym_PIPE_EQ] = ACTIONS(12663),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12663),
    [anon_sym_AMP_EQ] = ACTIONS(12663),
    [anon_sym_PERCENT_EQ] = ACTIONS(12663),
    [anon_sym_GT_GT_EQ] = ACTIONS(12663),
    [anon_sym_LT_LT_EQ] = ACTIONS(12663),
    [anon_sym_CARET_EQ] = ACTIONS(12663),
    [anon_sym_QMARK] = ACTIONS(12663),
    [anon_sym_COLON2] = ACTIONS(12665),
    [anon_sym_DOT_DOT] = ACTIONS(12665),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12663),
    [anon_sym_and] = ACTIONS(12663),
    [anon_sym_or] = ACTIONS(12663),
    [anon_sym_PIPE_PIPE] = ACTIONS(12665),
    [anon_sym_AMP_AMP] = ACTIONS(12665),
    [anon_sym_LT_LT] = ACTIONS(12665),
    [anon_sym_GT_GT] = ACTIONS(12665),
    [anon_sym_EQ_EQ] = ACTIONS(12665),
    [anon_sym_BANG_EQ] = ACTIONS(12663),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12663),
    [anon_sym_LT_EQ_GT] = ACTIONS(12663),
    [anon_sym_EQ_TILDE] = ACTIONS(12663),
    [anon_sym_BANG_TILDE] = ACTIONS(12663),
    [anon_sym_LT_EQ] = ACTIONS(12665),
    [anon_sym_GT] = ACTIONS(12665),
    [anon_sym_GT_EQ] = ACTIONS(12663),
    [anon_sym_CARET] = ACTIONS(12665),
    [anon_sym_PLUS] = ACTIONS(12665),
    [anon_sym_SLASH] = ACTIONS(12665),
    [anon_sym_PERCENT] = ACTIONS(12665),
    [sym_comment] = ACTIONS(87),
  },
  [11179] = {
    [sym__heredoc_body_start] = ACTIONS(13224),
    [sym__binary_minus] = ACTIONS(13224),
    [sym__binary_star] = ACTIONS(13224),
    [anon_sym_LBRACE] = ACTIONS(13224),
    [anon_sym_RBRACE] = ACTIONS(13224),
    [anon_sym_RPAREN] = ACTIONS(13224),
    [anon_sym_DOT] = ACTIONS(13226),
    [anon_sym_COMMA] = ACTIONS(13224),
    [anon_sym_PIPE] = ACTIONS(13226),
    [anon_sym_SEMI] = ACTIONS(13224),
    [anon_sym_STAR_STAR] = ACTIONS(13226),
    [anon_sym_AMP] = ACTIONS(13226),
    [anon_sym_EQ] = ACTIONS(13226),
    [anon_sym_LT] = ACTIONS(13226),
    [anon_sym_if] = ACTIONS(13224),
    [anon_sym_unless] = ACTIONS(13224),
    [anon_sym_while] = ACTIONS(13224),
    [anon_sym_until] = ACTIONS(13224),
    [anon_sym_rescue] = ACTIONS(13224),
    [anon_sym_in] = ACTIONS(13224),
    [anon_sym_do] = ACTIONS(13224),
    [anon_sym_LBRACK] = ACTIONS(13224),
    [anon_sym_RBRACK] = ACTIONS(13224),
    [anon_sym_COLON_COLON2] = ACTIONS(13224),
    [anon_sym_AMP_DOT] = ACTIONS(13224),
    [anon_sym_PLUS_EQ] = ACTIONS(13224),
    [anon_sym_DASH_EQ] = ACTIONS(13224),
    [anon_sym_STAR_EQ] = ACTIONS(13224),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13224),
    [anon_sym_SLASH_EQ] = ACTIONS(13224),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13224),
    [anon_sym_PIPE_EQ] = ACTIONS(13224),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13224),
    [anon_sym_AMP_EQ] = ACTIONS(13224),
    [anon_sym_PERCENT_EQ] = ACTIONS(13224),
    [anon_sym_GT_GT_EQ] = ACTIONS(13224),
    [anon_sym_LT_LT_EQ] = ACTIONS(13224),
    [anon_sym_CARET_EQ] = ACTIONS(13224),
    [anon_sym_QMARK] = ACTIONS(13224),
    [anon_sym_COLON2] = ACTIONS(13226),
    [anon_sym_DOT_DOT] = ACTIONS(13226),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13224),
    [anon_sym_and] = ACTIONS(13224),
    [anon_sym_or] = ACTIONS(13224),
    [anon_sym_PIPE_PIPE] = ACTIONS(13226),
    [anon_sym_AMP_AMP] = ACTIONS(13226),
    [anon_sym_LT_LT] = ACTIONS(13226),
    [anon_sym_GT_GT] = ACTIONS(13226),
    [anon_sym_EQ_EQ] = ACTIONS(13226),
    [anon_sym_BANG_EQ] = ACTIONS(13224),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13224),
    [anon_sym_LT_EQ_GT] = ACTIONS(13224),
    [anon_sym_EQ_TILDE] = ACTIONS(13224),
    [anon_sym_BANG_TILDE] = ACTIONS(13224),
    [anon_sym_LT_EQ] = ACTIONS(13226),
    [anon_sym_GT] = ACTIONS(13226),
    [anon_sym_GT_EQ] = ACTIONS(13224),
    [anon_sym_CARET] = ACTIONS(13226),
    [anon_sym_PLUS] = ACTIONS(13226),
    [anon_sym_SLASH] = ACTIONS(13226),
    [anon_sym_PERCENT] = ACTIONS(13226),
    [sym_comment] = ACTIONS(87),
  },
  [11180] = {
    [sym__heredoc_body_start] = ACTIONS(13235),
    [sym__binary_minus] = ACTIONS(13235),
    [sym__binary_star] = ACTIONS(13235),
    [anon_sym_LBRACE] = ACTIONS(13235),
    [anon_sym_RBRACE] = ACTIONS(13235),
    [anon_sym_RPAREN] = ACTIONS(13235),
    [anon_sym_DOT] = ACTIONS(13237),
    [anon_sym_COMMA] = ACTIONS(13235),
    [anon_sym_PIPE] = ACTIONS(13237),
    [anon_sym_SEMI] = ACTIONS(13235),
    [anon_sym_STAR_STAR] = ACTIONS(13237),
    [anon_sym_AMP] = ACTIONS(13237),
    [anon_sym_EQ] = ACTIONS(13237),
    [anon_sym_LT] = ACTIONS(13237),
    [anon_sym_if] = ACTIONS(13235),
    [anon_sym_unless] = ACTIONS(13235),
    [anon_sym_while] = ACTIONS(13235),
    [anon_sym_until] = ACTIONS(13235),
    [anon_sym_rescue] = ACTIONS(13235),
    [anon_sym_in] = ACTIONS(13235),
    [anon_sym_do] = ACTIONS(13235),
    [anon_sym_LBRACK] = ACTIONS(13235),
    [anon_sym_RBRACK] = ACTIONS(13235),
    [anon_sym_COLON_COLON2] = ACTIONS(13235),
    [anon_sym_AMP_DOT] = ACTIONS(13235),
    [anon_sym_PLUS_EQ] = ACTIONS(13235),
    [anon_sym_DASH_EQ] = ACTIONS(13235),
    [anon_sym_STAR_EQ] = ACTIONS(13235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13235),
    [anon_sym_SLASH_EQ] = ACTIONS(13235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13235),
    [anon_sym_PIPE_EQ] = ACTIONS(13235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13235),
    [anon_sym_AMP_EQ] = ACTIONS(13235),
    [anon_sym_PERCENT_EQ] = ACTIONS(13235),
    [anon_sym_GT_GT_EQ] = ACTIONS(13235),
    [anon_sym_LT_LT_EQ] = ACTIONS(13235),
    [anon_sym_CARET_EQ] = ACTIONS(13235),
    [anon_sym_QMARK] = ACTIONS(13235),
    [anon_sym_COLON2] = ACTIONS(13237),
    [anon_sym_DOT_DOT] = ACTIONS(13237),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13235),
    [anon_sym_and] = ACTIONS(13235),
    [anon_sym_or] = ACTIONS(13235),
    [anon_sym_PIPE_PIPE] = ACTIONS(13237),
    [anon_sym_AMP_AMP] = ACTIONS(13237),
    [anon_sym_LT_LT] = ACTIONS(13237),
    [anon_sym_GT_GT] = ACTIONS(13237),
    [anon_sym_EQ_EQ] = ACTIONS(13237),
    [anon_sym_BANG_EQ] = ACTIONS(13235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13235),
    [anon_sym_LT_EQ_GT] = ACTIONS(13235),
    [anon_sym_EQ_TILDE] = ACTIONS(13235),
    [anon_sym_BANG_TILDE] = ACTIONS(13235),
    [anon_sym_LT_EQ] = ACTIONS(13237),
    [anon_sym_GT] = ACTIONS(13237),
    [anon_sym_GT_EQ] = ACTIONS(13235),
    [anon_sym_CARET] = ACTIONS(13237),
    [anon_sym_PLUS] = ACTIONS(13237),
    [anon_sym_SLASH] = ACTIONS(13237),
    [anon_sym_PERCENT] = ACTIONS(13237),
    [sym_comment] = ACTIONS(87),
  },
  [11181] = {
    [anon_sym_end] = ACTIONS(15271),
    [sym_comment] = ACTIONS(87),
  },
  [11182] = {
    [sym__heredoc_body_start] = ACTIONS(13547),
    [sym__binary_minus] = ACTIONS(13547),
    [sym__binary_star] = ACTIONS(13547),
    [anon_sym_LBRACE] = ACTIONS(13547),
    [anon_sym_RBRACE] = ACTIONS(13547),
    [anon_sym_RPAREN] = ACTIONS(13547),
    [anon_sym_DOT] = ACTIONS(13549),
    [anon_sym_COMMA] = ACTIONS(13547),
    [anon_sym_PIPE] = ACTIONS(13549),
    [anon_sym_SEMI] = ACTIONS(13547),
    [anon_sym_STAR_STAR] = ACTIONS(13549),
    [anon_sym_AMP] = ACTIONS(13549),
    [anon_sym_EQ] = ACTIONS(13549),
    [anon_sym_LT] = ACTIONS(13549),
    [anon_sym_if] = ACTIONS(13547),
    [anon_sym_unless] = ACTIONS(13547),
    [anon_sym_while] = ACTIONS(13547),
    [anon_sym_until] = ACTIONS(13547),
    [anon_sym_rescue] = ACTIONS(13547),
    [anon_sym_in] = ACTIONS(13547),
    [anon_sym_do] = ACTIONS(13547),
    [anon_sym_LBRACK] = ACTIONS(13547),
    [anon_sym_RBRACK] = ACTIONS(13547),
    [anon_sym_COLON_COLON2] = ACTIONS(13547),
    [anon_sym_AMP_DOT] = ACTIONS(13547),
    [anon_sym_PLUS_EQ] = ACTIONS(13547),
    [anon_sym_DASH_EQ] = ACTIONS(13547),
    [anon_sym_STAR_EQ] = ACTIONS(13547),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13547),
    [anon_sym_SLASH_EQ] = ACTIONS(13547),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13547),
    [anon_sym_PIPE_EQ] = ACTIONS(13547),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13547),
    [anon_sym_AMP_EQ] = ACTIONS(13547),
    [anon_sym_PERCENT_EQ] = ACTIONS(13547),
    [anon_sym_GT_GT_EQ] = ACTIONS(13547),
    [anon_sym_LT_LT_EQ] = ACTIONS(13547),
    [anon_sym_CARET_EQ] = ACTIONS(13547),
    [anon_sym_QMARK] = ACTIONS(13547),
    [anon_sym_COLON2] = ACTIONS(13549),
    [anon_sym_DOT_DOT] = ACTIONS(13549),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13547),
    [anon_sym_and] = ACTIONS(13547),
    [anon_sym_or] = ACTIONS(13547),
    [anon_sym_PIPE_PIPE] = ACTIONS(13549),
    [anon_sym_AMP_AMP] = ACTIONS(13549),
    [anon_sym_LT_LT] = ACTIONS(13549),
    [anon_sym_GT_GT] = ACTIONS(13549),
    [anon_sym_EQ_EQ] = ACTIONS(13549),
    [anon_sym_BANG_EQ] = ACTIONS(13547),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13547),
    [anon_sym_LT_EQ_GT] = ACTIONS(13547),
    [anon_sym_EQ_TILDE] = ACTIONS(13547),
    [anon_sym_BANG_TILDE] = ACTIONS(13547),
    [anon_sym_LT_EQ] = ACTIONS(13549),
    [anon_sym_GT] = ACTIONS(13549),
    [anon_sym_GT_EQ] = ACTIONS(13547),
    [anon_sym_CARET] = ACTIONS(13549),
    [anon_sym_PLUS] = ACTIONS(13549),
    [anon_sym_SLASH] = ACTIONS(13549),
    [anon_sym_PERCENT] = ACTIONS(13549),
    [sym_comment] = ACTIONS(87),
  },
  [11183] = {
    [sym__line_break] = ACTIONS(14580),
    [sym__heredoc_body_start] = ACTIONS(14580),
    [anon_sym_DOT] = ACTIONS(14580),
    [anon_sym_COMMA] = ACTIONS(14580),
    [anon_sym_SEMI] = ACTIONS(14580),
    [anon_sym_then] = ACTIONS(14580),
    [anon_sym_LBRACK] = ACTIONS(14580),
    [anon_sym_COLON_COLON2] = ACTIONS(14580),
    [anon_sym_AMP_DOT] = ACTIONS(14580),
    [sym_comment] = ACTIONS(87),
  },
  [11184] = {
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(12730),
    [sym__binary_star] = ACTIONS(12732),
    [anon_sym_LBRACE] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(12734),
    [anon_sym_STAR_STAR] = ACTIONS(12736),
    [anon_sym_AMP] = ACTIONS(12738),
    [anon_sym_EQ] = ACTIONS(12879),
    [anon_sym_LT] = ACTIONS(12740),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_PLUS_EQ] = ACTIONS(12120),
    [anon_sym_DASH_EQ] = ACTIONS(12120),
    [anon_sym_STAR_EQ] = ACTIONS(12120),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12120),
    [anon_sym_SLASH_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12120),
    [anon_sym_AMP_EQ] = ACTIONS(12120),
    [anon_sym_PERCENT_EQ] = ACTIONS(12120),
    [anon_sym_GT_GT_EQ] = ACTIONS(12120),
    [anon_sym_LT_LT_EQ] = ACTIONS(12120),
    [anon_sym_CARET_EQ] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(12742),
    [anon_sym_DOT_DOT] = ACTIONS(12744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12746),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(12748),
    [anon_sym_AMP_AMP] = ACTIONS(12748),
    [anon_sym_LT_LT] = ACTIONS(12750),
    [anon_sym_GT_GT] = ACTIONS(12750),
    [anon_sym_EQ_EQ] = ACTIONS(12748),
    [anon_sym_BANG_EQ] = ACTIONS(12752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12752),
    [anon_sym_LT_EQ_GT] = ACTIONS(12752),
    [anon_sym_EQ_TILDE] = ACTIONS(12752),
    [anon_sym_BANG_TILDE] = ACTIONS(12752),
    [anon_sym_LT_EQ] = ACTIONS(12740),
    [anon_sym_GT] = ACTIONS(12740),
    [anon_sym_GT_EQ] = ACTIONS(12754),
    [anon_sym_CARET] = ACTIONS(12734),
    [anon_sym_PLUS] = ACTIONS(12756),
    [anon_sym_SLASH] = ACTIONS(12736),
    [anon_sym_PERCENT] = ACTIONS(12736),
    [sym_comment] = ACTIONS(87),
  },
  [11185] = {
    [aux_sym_exceptions_repeat1] = STATE(11185),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(15273),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_PLUS_EQ] = ACTIONS(11597),
    [anon_sym_DASH_EQ] = ACTIONS(11597),
    [anon_sym_STAR_EQ] = ACTIONS(11597),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11597),
    [anon_sym_SLASH_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11597),
    [anon_sym_AMP_EQ] = ACTIONS(11597),
    [anon_sym_PERCENT_EQ] = ACTIONS(11597),
    [anon_sym_GT_GT_EQ] = ACTIONS(11597),
    [anon_sym_LT_LT_EQ] = ACTIONS(11597),
    [anon_sym_CARET_EQ] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_LT] = ACTIONS(12338),
    [anon_sym_GT_GT] = ACTIONS(12338),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(12338),
    [anon_sym_PLUS] = ACTIONS(12338),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [11186] = {
    [sym__heredoc_body_start] = ACTIONS(14151),
    [sym__binary_minus] = ACTIONS(14151),
    [sym__binary_star] = ACTIONS(14151),
    [anon_sym_LBRACE] = ACTIONS(14151),
    [anon_sym_RPAREN] = ACTIONS(14151),
    [anon_sym_DOT] = ACTIONS(14153),
    [anon_sym_COMMA] = ACTIONS(14151),
    [anon_sym_PIPE] = ACTIONS(14153),
    [anon_sym_STAR_STAR] = ACTIONS(14151),
    [anon_sym_AMP] = ACTIONS(14153),
    [anon_sym_EQ] = ACTIONS(14153),
    [anon_sym_LT] = ACTIONS(14153),
    [anon_sym_do] = ACTIONS(14151),
    [anon_sym_LBRACK] = ACTIONS(14151),
    [anon_sym_COLON_COLON2] = ACTIONS(14151),
    [anon_sym_AMP_DOT] = ACTIONS(14151),
    [anon_sym_QMARK] = ACTIONS(14151),
    [anon_sym_DOT_DOT] = ACTIONS(14153),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14151),
    [anon_sym_and] = ACTIONS(14151),
    [anon_sym_or] = ACTIONS(14151),
    [anon_sym_PIPE_PIPE] = ACTIONS(14151),
    [anon_sym_AMP_AMP] = ACTIONS(14151),
    [anon_sym_LT_LT] = ACTIONS(14151),
    [anon_sym_GT_GT] = ACTIONS(14151),
    [anon_sym_EQ_EQ] = ACTIONS(14153),
    [anon_sym_BANG_EQ] = ACTIONS(14151),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14151),
    [anon_sym_LT_EQ_GT] = ACTIONS(14151),
    [anon_sym_EQ_TILDE] = ACTIONS(14151),
    [anon_sym_BANG_TILDE] = ACTIONS(14151),
    [anon_sym_LT_EQ] = ACTIONS(14153),
    [anon_sym_GT] = ACTIONS(14153),
    [anon_sym_GT_EQ] = ACTIONS(14151),
    [anon_sym_CARET] = ACTIONS(14151),
    [anon_sym_PLUS] = ACTIONS(14151),
    [anon_sym_SLASH] = ACTIONS(14151),
    [anon_sym_PERCENT] = ACTIONS(14151),
    [sym_comment] = ACTIONS(87),
  },
  [11187] = {
    [sym__heredoc_body_start] = ACTIONS(14580),
    [sym__binary_minus] = ACTIONS(14580),
    [sym__binary_star] = ACTIONS(14580),
    [anon_sym_LBRACE] = ACTIONS(14580),
    [anon_sym_RPAREN] = ACTIONS(14580),
    [anon_sym_DOT] = ACTIONS(14582),
    [anon_sym_COMMA] = ACTIONS(14580),
    [anon_sym_PIPE] = ACTIONS(14582),
    [anon_sym_STAR_STAR] = ACTIONS(14580),
    [anon_sym_AMP] = ACTIONS(14582),
    [anon_sym_EQ] = ACTIONS(14582),
    [anon_sym_LT] = ACTIONS(14582),
    [anon_sym_do] = ACTIONS(14580),
    [anon_sym_LBRACK] = ACTIONS(14580),
    [anon_sym_COLON_COLON2] = ACTIONS(14580),
    [anon_sym_AMP_DOT] = ACTIONS(14580),
    [anon_sym_QMARK] = ACTIONS(14580),
    [anon_sym_DOT_DOT] = ACTIONS(14582),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14580),
    [anon_sym_and] = ACTIONS(14580),
    [anon_sym_or] = ACTIONS(14580),
    [anon_sym_PIPE_PIPE] = ACTIONS(14580),
    [anon_sym_AMP_AMP] = ACTIONS(14580),
    [anon_sym_LT_LT] = ACTIONS(14580),
    [anon_sym_GT_GT] = ACTIONS(14580),
    [anon_sym_EQ_EQ] = ACTIONS(14582),
    [anon_sym_BANG_EQ] = ACTIONS(14580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14580),
    [anon_sym_LT_EQ_GT] = ACTIONS(14580),
    [anon_sym_EQ_TILDE] = ACTIONS(14580),
    [anon_sym_BANG_TILDE] = ACTIONS(14580),
    [anon_sym_LT_EQ] = ACTIONS(14582),
    [anon_sym_GT] = ACTIONS(14582),
    [anon_sym_GT_EQ] = ACTIONS(14580),
    [anon_sym_CARET] = ACTIONS(14580),
    [anon_sym_PLUS] = ACTIONS(14580),
    [anon_sym_SLASH] = ACTIONS(14580),
    [anon_sym_PERCENT] = ACTIONS(14580),
    [sym_comment] = ACTIONS(87),
  },
  [11188] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(12898),
    [sym__binary_star] = ACTIONS(12900),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(12902),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(12900),
    [anon_sym_AMP] = ACTIONS(12904),
    [anon_sym_LT] = ACTIONS(12906),
    [anon_sym_end] = ACTIONS(12120),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_elsif] = ACTIONS(12120),
    [anon_sym_else] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(12908),
    [anon_sym_DOT_DOT] = ACTIONS(12910),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12912),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(12914),
    [anon_sym_AMP_AMP] = ACTIONS(12914),
    [anon_sym_LT_LT] = ACTIONS(12916),
    [anon_sym_GT_GT] = ACTIONS(12916),
    [anon_sym_EQ_EQ] = ACTIONS(12918),
    [anon_sym_BANG_EQ] = ACTIONS(12914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12914),
    [anon_sym_LT_EQ_GT] = ACTIONS(12914),
    [anon_sym_EQ_TILDE] = ACTIONS(12914),
    [anon_sym_BANG_TILDE] = ACTIONS(12914),
    [anon_sym_LT_EQ] = ACTIONS(12906),
    [anon_sym_GT] = ACTIONS(12906),
    [anon_sym_GT_EQ] = ACTIONS(12920),
    [anon_sym_CARET] = ACTIONS(12922),
    [anon_sym_PLUS] = ACTIONS(12898),
    [anon_sym_SLASH] = ACTIONS(12900),
    [anon_sym_PERCENT] = ACTIONS(12900),
    [sym_comment] = ACTIONS(87),
  },
  [11189] = {
    [aux_sym_exceptions_repeat1] = STATE(11189),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(15276),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_end] = ACTIONS(11597),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_elsif] = ACTIONS(11597),
    [anon_sym_else] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [11190] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(12950),
    [sym__binary_star] = ACTIONS(12952),
    [anon_sym_LBRACE] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(12954),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(12956),
    [anon_sym_AMP] = ACTIONS(12958),
    [anon_sym_EQ] = ACTIONS(12879),
    [anon_sym_LT] = ACTIONS(12960),
    [anon_sym_end] = ACTIONS(12120),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_elsif] = ACTIONS(12120),
    [anon_sym_else] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_PLUS_EQ] = ACTIONS(12120),
    [anon_sym_DASH_EQ] = ACTIONS(12120),
    [anon_sym_STAR_EQ] = ACTIONS(12120),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12120),
    [anon_sym_SLASH_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12120),
    [anon_sym_AMP_EQ] = ACTIONS(12120),
    [anon_sym_PERCENT_EQ] = ACTIONS(12120),
    [anon_sym_GT_GT_EQ] = ACTIONS(12120),
    [anon_sym_LT_LT_EQ] = ACTIONS(12120),
    [anon_sym_CARET_EQ] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(12962),
    [anon_sym_DOT_DOT] = ACTIONS(12964),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12966),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(12968),
    [anon_sym_AMP_AMP] = ACTIONS(12968),
    [anon_sym_LT_LT] = ACTIONS(12970),
    [anon_sym_GT_GT] = ACTIONS(12970),
    [anon_sym_EQ_EQ] = ACTIONS(12968),
    [anon_sym_BANG_EQ] = ACTIONS(12972),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12972),
    [anon_sym_LT_EQ_GT] = ACTIONS(12972),
    [anon_sym_EQ_TILDE] = ACTIONS(12972),
    [anon_sym_BANG_TILDE] = ACTIONS(12972),
    [anon_sym_LT_EQ] = ACTIONS(12960),
    [anon_sym_GT] = ACTIONS(12960),
    [anon_sym_GT_EQ] = ACTIONS(12974),
    [anon_sym_CARET] = ACTIONS(12954),
    [anon_sym_PLUS] = ACTIONS(12976),
    [anon_sym_SLASH] = ACTIONS(12956),
    [anon_sym_PERCENT] = ACTIONS(12956),
    [sym_comment] = ACTIONS(87),
  },
  [11191] = {
    [aux_sym_exceptions_repeat1] = STATE(11191),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(15279),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_end] = ACTIONS(11597),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_elsif] = ACTIONS(11597),
    [anon_sym_else] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_PLUS_EQ] = ACTIONS(11597),
    [anon_sym_DASH_EQ] = ACTIONS(11597),
    [anon_sym_STAR_EQ] = ACTIONS(11597),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11597),
    [anon_sym_SLASH_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11597),
    [anon_sym_AMP_EQ] = ACTIONS(11597),
    [anon_sym_PERCENT_EQ] = ACTIONS(11597),
    [anon_sym_GT_GT_EQ] = ACTIONS(11597),
    [anon_sym_LT_LT_EQ] = ACTIONS(11597),
    [anon_sym_CARET_EQ] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_LT] = ACTIONS(12338),
    [anon_sym_GT_GT] = ACTIONS(12338),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(12338),
    [anon_sym_PLUS] = ACTIONS(12338),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [11192] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(12986),
    [sym__binary_star] = ACTIONS(12988),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(12990),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(12988),
    [anon_sym_AMP] = ACTIONS(12992),
    [anon_sym_LT] = ACTIONS(12994),
    [anon_sym_end] = ACTIONS(12120),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_elsif] = ACTIONS(12120),
    [anon_sym_else] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(12996),
    [anon_sym_DOT_DOT] = ACTIONS(12998),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13000),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(13002),
    [anon_sym_AMP_AMP] = ACTIONS(13002),
    [anon_sym_LT_LT] = ACTIONS(13004),
    [anon_sym_GT_GT] = ACTIONS(13004),
    [anon_sym_EQ_EQ] = ACTIONS(13006),
    [anon_sym_BANG_EQ] = ACTIONS(13002),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13002),
    [anon_sym_LT_EQ_GT] = ACTIONS(13002),
    [anon_sym_EQ_TILDE] = ACTIONS(13002),
    [anon_sym_BANG_TILDE] = ACTIONS(13002),
    [anon_sym_LT_EQ] = ACTIONS(12994),
    [anon_sym_GT] = ACTIONS(12994),
    [anon_sym_GT_EQ] = ACTIONS(13008),
    [anon_sym_CARET] = ACTIONS(13010),
    [anon_sym_PLUS] = ACTIONS(12986),
    [anon_sym_SLASH] = ACTIONS(12988),
    [anon_sym_PERCENT] = ACTIONS(12988),
    [sym_comment] = ACTIONS(87),
  },
  [11193] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(13033),
    [sym__binary_star] = ACTIONS(13035),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(13037),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(13035),
    [anon_sym_AMP] = ACTIONS(13039),
    [anon_sym_LT] = ACTIONS(13041),
    [anon_sym_end] = ACTIONS(12120),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_else] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(13043),
    [anon_sym_DOT_DOT] = ACTIONS(13045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13047),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(13049),
    [anon_sym_AMP_AMP] = ACTIONS(13049),
    [anon_sym_LT_LT] = ACTIONS(13051),
    [anon_sym_GT_GT] = ACTIONS(13051),
    [anon_sym_EQ_EQ] = ACTIONS(13053),
    [anon_sym_BANG_EQ] = ACTIONS(13049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13049),
    [anon_sym_LT_EQ_GT] = ACTIONS(13049),
    [anon_sym_EQ_TILDE] = ACTIONS(13049),
    [anon_sym_BANG_TILDE] = ACTIONS(13049),
    [anon_sym_LT_EQ] = ACTIONS(13041),
    [anon_sym_GT] = ACTIONS(13041),
    [anon_sym_GT_EQ] = ACTIONS(13055),
    [anon_sym_CARET] = ACTIONS(13057),
    [anon_sym_PLUS] = ACTIONS(13033),
    [anon_sym_SLASH] = ACTIONS(13035),
    [anon_sym_PERCENT] = ACTIONS(13035),
    [sym_comment] = ACTIONS(87),
  },
  [11194] = {
    [aux_sym_exceptions_repeat1] = STATE(11194),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(15282),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_end] = ACTIONS(11597),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_else] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [11195] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(13085),
    [sym__binary_star] = ACTIONS(13087),
    [anon_sym_LBRACE] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(13089),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(13091),
    [anon_sym_AMP] = ACTIONS(13093),
    [anon_sym_EQ] = ACTIONS(12879),
    [anon_sym_LT] = ACTIONS(13095),
    [anon_sym_end] = ACTIONS(12120),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_else] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_PLUS_EQ] = ACTIONS(12120),
    [anon_sym_DASH_EQ] = ACTIONS(12120),
    [anon_sym_STAR_EQ] = ACTIONS(12120),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12120),
    [anon_sym_SLASH_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12120),
    [anon_sym_AMP_EQ] = ACTIONS(12120),
    [anon_sym_PERCENT_EQ] = ACTIONS(12120),
    [anon_sym_GT_GT_EQ] = ACTIONS(12120),
    [anon_sym_LT_LT_EQ] = ACTIONS(12120),
    [anon_sym_CARET_EQ] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(13097),
    [anon_sym_DOT_DOT] = ACTIONS(13099),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13101),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(13103),
    [anon_sym_AMP_AMP] = ACTIONS(13103),
    [anon_sym_LT_LT] = ACTIONS(13105),
    [anon_sym_GT_GT] = ACTIONS(13105),
    [anon_sym_EQ_EQ] = ACTIONS(13103),
    [anon_sym_BANG_EQ] = ACTIONS(13107),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13107),
    [anon_sym_LT_EQ_GT] = ACTIONS(13107),
    [anon_sym_EQ_TILDE] = ACTIONS(13107),
    [anon_sym_BANG_TILDE] = ACTIONS(13107),
    [anon_sym_LT_EQ] = ACTIONS(13095),
    [anon_sym_GT] = ACTIONS(13095),
    [anon_sym_GT_EQ] = ACTIONS(13109),
    [anon_sym_CARET] = ACTIONS(13089),
    [anon_sym_PLUS] = ACTIONS(13111),
    [anon_sym_SLASH] = ACTIONS(13091),
    [anon_sym_PERCENT] = ACTIONS(13091),
    [sym_comment] = ACTIONS(87),
  },
  [11196] = {
    [aux_sym_exceptions_repeat1] = STATE(11196),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(15285),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_end] = ACTIONS(11597),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_else] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_PLUS_EQ] = ACTIONS(11597),
    [anon_sym_DASH_EQ] = ACTIONS(11597),
    [anon_sym_STAR_EQ] = ACTIONS(11597),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11597),
    [anon_sym_SLASH_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11597),
    [anon_sym_AMP_EQ] = ACTIONS(11597),
    [anon_sym_PERCENT_EQ] = ACTIONS(11597),
    [anon_sym_GT_GT_EQ] = ACTIONS(11597),
    [anon_sym_LT_LT_EQ] = ACTIONS(11597),
    [anon_sym_CARET_EQ] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_LT] = ACTIONS(12338),
    [anon_sym_GT_GT] = ACTIONS(12338),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(12338),
    [anon_sym_PLUS] = ACTIONS(12338),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [11197] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(13121),
    [sym__binary_star] = ACTIONS(13123),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(13125),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(13123),
    [anon_sym_AMP] = ACTIONS(13127),
    [anon_sym_LT] = ACTIONS(13129),
    [anon_sym_end] = ACTIONS(12120),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_else] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(13131),
    [anon_sym_DOT_DOT] = ACTIONS(13133),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13135),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(13137),
    [anon_sym_AMP_AMP] = ACTIONS(13137),
    [anon_sym_LT_LT] = ACTIONS(13139),
    [anon_sym_GT_GT] = ACTIONS(13139),
    [anon_sym_EQ_EQ] = ACTIONS(13141),
    [anon_sym_BANG_EQ] = ACTIONS(13137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13137),
    [anon_sym_LT_EQ_GT] = ACTIONS(13137),
    [anon_sym_EQ_TILDE] = ACTIONS(13137),
    [anon_sym_BANG_TILDE] = ACTIONS(13137),
    [anon_sym_LT_EQ] = ACTIONS(13129),
    [anon_sym_GT] = ACTIONS(13129),
    [anon_sym_GT_EQ] = ACTIONS(13143),
    [anon_sym_CARET] = ACTIONS(13145),
    [anon_sym_PLUS] = ACTIONS(13121),
    [anon_sym_SLASH] = ACTIONS(13123),
    [anon_sym_PERCENT] = ACTIONS(13123),
    [sym_comment] = ACTIONS(87),
  },
  [11198] = {
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(13178),
    [sym__binary_star] = ACTIONS(13180),
    [anon_sym_LBRACE] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(13182),
    [anon_sym_STAR_STAR] = ACTIONS(13184),
    [anon_sym_AMP] = ACTIONS(13186),
    [anon_sym_EQ] = ACTIONS(12879),
    [anon_sym_LT] = ACTIONS(13188),
    [anon_sym_in] = ACTIONS(12120),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_PLUS_EQ] = ACTIONS(12120),
    [anon_sym_DASH_EQ] = ACTIONS(12120),
    [anon_sym_STAR_EQ] = ACTIONS(12120),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12120),
    [anon_sym_SLASH_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12120),
    [anon_sym_AMP_EQ] = ACTIONS(12120),
    [anon_sym_PERCENT_EQ] = ACTIONS(12120),
    [anon_sym_GT_GT_EQ] = ACTIONS(12120),
    [anon_sym_LT_LT_EQ] = ACTIONS(12120),
    [anon_sym_CARET_EQ] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(13190),
    [anon_sym_DOT_DOT] = ACTIONS(13192),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13194),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(13196),
    [anon_sym_AMP_AMP] = ACTIONS(13196),
    [anon_sym_LT_LT] = ACTIONS(13198),
    [anon_sym_GT_GT] = ACTIONS(13198),
    [anon_sym_EQ_EQ] = ACTIONS(13196),
    [anon_sym_BANG_EQ] = ACTIONS(13200),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13200),
    [anon_sym_LT_EQ_GT] = ACTIONS(13200),
    [anon_sym_EQ_TILDE] = ACTIONS(13200),
    [anon_sym_BANG_TILDE] = ACTIONS(13200),
    [anon_sym_LT_EQ] = ACTIONS(13188),
    [anon_sym_GT] = ACTIONS(13188),
    [anon_sym_GT_EQ] = ACTIONS(13202),
    [anon_sym_CARET] = ACTIONS(13182),
    [anon_sym_PLUS] = ACTIONS(13204),
    [anon_sym_SLASH] = ACTIONS(13184),
    [anon_sym_PERCENT] = ACTIONS(13184),
    [sym_comment] = ACTIONS(87),
  },
  [11199] = {
    [aux_sym_exceptions_repeat1] = STATE(11199),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(15288),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_in] = ACTIONS(11597),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_PLUS_EQ] = ACTIONS(11597),
    [anon_sym_DASH_EQ] = ACTIONS(11597),
    [anon_sym_STAR_EQ] = ACTIONS(11597),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11597),
    [anon_sym_SLASH_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11597),
    [anon_sym_AMP_EQ] = ACTIONS(11597),
    [anon_sym_PERCENT_EQ] = ACTIONS(11597),
    [anon_sym_GT_GT_EQ] = ACTIONS(11597),
    [anon_sym_LT_LT_EQ] = ACTIONS(11597),
    [anon_sym_CARET_EQ] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_LT] = ACTIONS(12338),
    [anon_sym_GT_GT] = ACTIONS(12338),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(12338),
    [anon_sym_PLUS] = ACTIONS(12338),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [11200] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(13246),
    [sym__binary_star] = ACTIONS(13248),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(13250),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(13248),
    [anon_sym_AMP] = ACTIONS(13252),
    [anon_sym_LT] = ACTIONS(13254),
    [anon_sym_then] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(13256),
    [anon_sym_DOT_DOT] = ACTIONS(13258),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13260),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(13262),
    [anon_sym_AMP_AMP] = ACTIONS(13262),
    [anon_sym_LT_LT] = ACTIONS(13264),
    [anon_sym_GT_GT] = ACTIONS(13264),
    [anon_sym_EQ_EQ] = ACTIONS(13266),
    [anon_sym_BANG_EQ] = ACTIONS(13262),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13262),
    [anon_sym_LT_EQ_GT] = ACTIONS(13262),
    [anon_sym_EQ_TILDE] = ACTIONS(13262),
    [anon_sym_BANG_TILDE] = ACTIONS(13262),
    [anon_sym_LT_EQ] = ACTIONS(13254),
    [anon_sym_GT] = ACTIONS(13254),
    [anon_sym_GT_EQ] = ACTIONS(13268),
    [anon_sym_CARET] = ACTIONS(13270),
    [anon_sym_PLUS] = ACTIONS(13246),
    [anon_sym_SLASH] = ACTIONS(13248),
    [anon_sym_PERCENT] = ACTIONS(13248),
    [sym_comment] = ACTIONS(87),
  },
  [11201] = {
    [aux_sym_exceptions_repeat1] = STATE(11201),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(15291),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_then] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [11202] = {
    [sym_heredoc_body] = STATE(11319),
    [aux_sym_call_repeat1] = STATE(11319),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_when] = ACTIONS(4383),
    [anon_sym_else] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [11203] = {
    [sym_heredoc_body] = STATE(11320),
    [aux_sym_call_repeat1] = STATE(11320),
    [aux_sym_argument_list_repeat1] = STATE(10983),
    [sym__line_break] = ACTIONS(4383),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(4383),
    [sym__binary_star] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_COMMA] = ACTIONS(14224),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_STAR_STAR] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_end] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_unless] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_until] = ACTIONS(4383),
    [anon_sym_rescue] = ACTIONS(4383),
    [anon_sym_when] = ACTIONS(4383),
    [anon_sym_else] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON_COLON2] = ACTIONS(4383),
    [anon_sym_AMP_DOT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_DOT_DOT] = ACTIONS(4385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4383),
    [anon_sym_or] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4385),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ_GT] = ACTIONS(4383),
    [anon_sym_EQ_TILDE] = ACTIONS(4383),
    [anon_sym_BANG_TILDE] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [sym_comment] = ACTIONS(87),
  },
  [11204] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(14833),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(14833),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_when] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(14833),
    [anon_sym_PERCENT] = ACTIONS(14833),
    [sym_comment] = ACTIONS(87),
  },
  [11205] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(14833),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_when] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [11206] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(14831),
    [sym__binary_star] = ACTIONS(14833),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(14833),
    [anon_sym_AMP] = ACTIONS(14837),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_when] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(14849),
    [anon_sym_GT_GT] = ACTIONS(14849),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(14831),
    [anon_sym_SLASH] = ACTIONS(14833),
    [anon_sym_PERCENT] = ACTIONS(14833),
    [sym_comment] = ACTIONS(87),
  },
  [11207] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(14831),
    [sym__binary_star] = ACTIONS(14833),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(14833),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_when] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(14849),
    [anon_sym_GT_GT] = ACTIONS(14849),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(14831),
    [anon_sym_SLASH] = ACTIONS(14833),
    [anon_sym_PERCENT] = ACTIONS(14833),
    [sym_comment] = ACTIONS(87),
  },
  [11208] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(14831),
    [sym__binary_star] = ACTIONS(14833),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(14835),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(14833),
    [anon_sym_AMP] = ACTIONS(14837),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_when] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(14849),
    [anon_sym_GT_GT] = ACTIONS(14849),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(14855),
    [anon_sym_PLUS] = ACTIONS(14831),
    [anon_sym_SLASH] = ACTIONS(14833),
    [anon_sym_PERCENT] = ACTIONS(14833),
    [sym_comment] = ACTIONS(87),
  },
  [11209] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(15294),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [11210] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(14831),
    [sym__binary_star] = ACTIONS(14833),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(14835),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(14833),
    [anon_sym_AMP] = ACTIONS(14837),
    [anon_sym_LT] = ACTIONS(14839),
    [anon_sym_end] = ACTIONS(5927),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_when] = ACTIONS(5927),
    [anon_sym_else] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(14843),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14845),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(14847),
    [anon_sym_AMP_AMP] = ACTIONS(14847),
    [anon_sym_LT_LT] = ACTIONS(14849),
    [anon_sym_GT_GT] = ACTIONS(14849),
    [anon_sym_EQ_EQ] = ACTIONS(14851),
    [anon_sym_BANG_EQ] = ACTIONS(14847),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14847),
    [anon_sym_LT_EQ_GT] = ACTIONS(14847),
    [anon_sym_EQ_TILDE] = ACTIONS(14847),
    [anon_sym_BANG_TILDE] = ACTIONS(14847),
    [anon_sym_LT_EQ] = ACTIONS(14839),
    [anon_sym_GT] = ACTIONS(14839),
    [anon_sym_GT_EQ] = ACTIONS(14853),
    [anon_sym_CARET] = ACTIONS(14855),
    [anon_sym_PLUS] = ACTIONS(14831),
    [anon_sym_SLASH] = ACTIONS(14833),
    [anon_sym_PERCENT] = ACTIONS(14833),
    [sym_comment] = ACTIONS(87),
  },
  [11211] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(14831),
    [sym__binary_star] = ACTIONS(14833),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(14835),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(14833),
    [anon_sym_AMP] = ACTIONS(14837),
    [anon_sym_LT] = ACTIONS(14839),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_when] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(14841),
    [anon_sym_DOT_DOT] = ACTIONS(14843),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14845),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(14847),
    [anon_sym_AMP_AMP] = ACTIONS(14847),
    [anon_sym_LT_LT] = ACTIONS(14849),
    [anon_sym_GT_GT] = ACTIONS(14849),
    [anon_sym_EQ_EQ] = ACTIONS(14851),
    [anon_sym_BANG_EQ] = ACTIONS(14847),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14847),
    [anon_sym_LT_EQ_GT] = ACTIONS(14847),
    [anon_sym_EQ_TILDE] = ACTIONS(14847),
    [anon_sym_BANG_TILDE] = ACTIONS(14847),
    [anon_sym_LT_EQ] = ACTIONS(14839),
    [anon_sym_GT] = ACTIONS(14839),
    [anon_sym_GT_EQ] = ACTIONS(14853),
    [anon_sym_CARET] = ACTIONS(14855),
    [anon_sym_PLUS] = ACTIONS(14831),
    [anon_sym_SLASH] = ACTIONS(14833),
    [anon_sym_PERCENT] = ACTIONS(14833),
    [sym_comment] = ACTIONS(87),
  },
  [11212] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(14831),
    [sym__binary_star] = ACTIONS(14833),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(14835),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(14833),
    [anon_sym_AMP] = ACTIONS(14837),
    [anon_sym_LT] = ACTIONS(14839),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_when] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(14849),
    [anon_sym_GT_GT] = ACTIONS(14849),
    [anon_sym_EQ_EQ] = ACTIONS(14851),
    [anon_sym_BANG_EQ] = ACTIONS(14847),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14847),
    [anon_sym_LT_EQ_GT] = ACTIONS(14847),
    [anon_sym_EQ_TILDE] = ACTIONS(14847),
    [anon_sym_BANG_TILDE] = ACTIONS(14847),
    [anon_sym_LT_EQ] = ACTIONS(14839),
    [anon_sym_GT] = ACTIONS(14839),
    [anon_sym_GT_EQ] = ACTIONS(14853),
    [anon_sym_CARET] = ACTIONS(14855),
    [anon_sym_PLUS] = ACTIONS(14831),
    [anon_sym_SLASH] = ACTIONS(14833),
    [anon_sym_PERCENT] = ACTIONS(14833),
    [sym_comment] = ACTIONS(87),
  },
  [11213] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(14831),
    [sym__binary_star] = ACTIONS(14833),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(14833),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_when] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(14831),
    [anon_sym_SLASH] = ACTIONS(14833),
    [anon_sym_PERCENT] = ACTIONS(14833),
    [sym_comment] = ACTIONS(87),
  },
  [11214] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(14831),
    [sym__binary_star] = ACTIONS(14833),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(14835),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(14833),
    [anon_sym_AMP] = ACTIONS(14837),
    [anon_sym_LT] = ACTIONS(14839),
    [anon_sym_end] = ACTIONS(5115),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_when] = ACTIONS(5115),
    [anon_sym_else] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(14841),
    [anon_sym_DOT_DOT] = ACTIONS(14843),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14845),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(14847),
    [anon_sym_AMP_AMP] = ACTIONS(14847),
    [anon_sym_LT_LT] = ACTIONS(14849),
    [anon_sym_GT_GT] = ACTIONS(14849),
    [anon_sym_EQ_EQ] = ACTIONS(14851),
    [anon_sym_BANG_EQ] = ACTIONS(14847),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14847),
    [anon_sym_LT_EQ_GT] = ACTIONS(14847),
    [anon_sym_EQ_TILDE] = ACTIONS(14847),
    [anon_sym_BANG_TILDE] = ACTIONS(14847),
    [anon_sym_LT_EQ] = ACTIONS(14839),
    [anon_sym_GT] = ACTIONS(14839),
    [anon_sym_GT_EQ] = ACTIONS(14853),
    [anon_sym_CARET] = ACTIONS(14855),
    [anon_sym_PLUS] = ACTIONS(14831),
    [anon_sym_SLASH] = ACTIONS(14833),
    [anon_sym_PERCENT] = ACTIONS(14833),
    [sym_comment] = ACTIONS(87),
  },
  [11215] = {
    [aux_sym_exceptions_repeat1] = STATE(11323),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_end] = ACTIONS(6191),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_when] = ACTIONS(6191),
    [anon_sym_else] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [11216] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(14831),
    [sym__binary_star] = ACTIONS(14833),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(14835),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(14833),
    [anon_sym_AMP] = ACTIONS(14837),
    [anon_sym_LT] = ACTIONS(14839),
    [anon_sym_end] = ACTIONS(6210),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_when] = ACTIONS(6210),
    [anon_sym_else] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(14841),
    [anon_sym_DOT_DOT] = ACTIONS(14843),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14845),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(14847),
    [anon_sym_AMP_AMP] = ACTIONS(14847),
    [anon_sym_LT_LT] = ACTIONS(14849),
    [anon_sym_GT_GT] = ACTIONS(14849),
    [anon_sym_EQ_EQ] = ACTIONS(14851),
    [anon_sym_BANG_EQ] = ACTIONS(14847),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14847),
    [anon_sym_LT_EQ_GT] = ACTIONS(14847),
    [anon_sym_EQ_TILDE] = ACTIONS(14847),
    [anon_sym_BANG_TILDE] = ACTIONS(14847),
    [anon_sym_LT_EQ] = ACTIONS(14839),
    [anon_sym_GT] = ACTIONS(14839),
    [anon_sym_GT_EQ] = ACTIONS(14853),
    [anon_sym_CARET] = ACTIONS(14855),
    [anon_sym_PLUS] = ACTIONS(14831),
    [anon_sym_SLASH] = ACTIONS(14833),
    [anon_sym_PERCENT] = ACTIONS(14833),
    [sym_comment] = ACTIONS(87),
  },
  [11217] = {
    [sym_string] = STATE(11217),
    [aux_sym_chained_string_repeat1] = STATE(11217),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(6214),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_end] = ACTIONS(6212),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_when] = ACTIONS(6212),
    [anon_sym_else] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [11218] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(14190),
    [sym__binary_star] = ACTIONS(14192),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(14194),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(14192),
    [anon_sym_AMP] = ACTIONS(14196),
    [anon_sym_LT] = ACTIONS(14198),
    [anon_sym_end] = ACTIONS(6823),
    [anon_sym_if] = ACTIONS(6823),
    [anon_sym_unless] = ACTIONS(6823),
    [anon_sym_while] = ACTIONS(6823),
    [anon_sym_until] = ACTIONS(6823),
    [anon_sym_rescue] = ACTIONS(6823),
    [anon_sym_when] = ACTIONS(6823),
    [anon_sym_else] = ACTIONS(6823),
    [anon_sym_EQ_GT] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(14200),
    [anon_sym_DOT_DOT] = ACTIONS(14202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14204),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(14206),
    [anon_sym_AMP_AMP] = ACTIONS(14206),
    [anon_sym_LT_LT] = ACTIONS(14208),
    [anon_sym_GT_GT] = ACTIONS(14208),
    [anon_sym_EQ_EQ] = ACTIONS(14210),
    [anon_sym_BANG_EQ] = ACTIONS(14206),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14206),
    [anon_sym_LT_EQ_GT] = ACTIONS(14206),
    [anon_sym_EQ_TILDE] = ACTIONS(14206),
    [anon_sym_BANG_TILDE] = ACTIONS(14206),
    [anon_sym_LT_EQ] = ACTIONS(14198),
    [anon_sym_GT] = ACTIONS(14198),
    [anon_sym_GT_EQ] = ACTIONS(14212),
    [anon_sym_CARET] = ACTIONS(14214),
    [anon_sym_PLUS] = ACTIONS(14190),
    [anon_sym_SLASH] = ACTIONS(14192),
    [anon_sym_PERCENT] = ACTIONS(14192),
    [sym_comment] = ACTIONS(87),
  },
  [11219] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(14190),
    [sym__binary_star] = ACTIONS(14192),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(14194),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(14192),
    [anon_sym_AMP] = ACTIONS(14196),
    [anon_sym_LT] = ACTIONS(14198),
    [anon_sym_end] = ACTIONS(7027),
    [anon_sym_if] = ACTIONS(7027),
    [anon_sym_unless] = ACTIONS(7027),
    [anon_sym_while] = ACTIONS(7027),
    [anon_sym_until] = ACTIONS(7027),
    [anon_sym_rescue] = ACTIONS(7027),
    [anon_sym_when] = ACTIONS(7027),
    [anon_sym_else] = ACTIONS(7027),
    [anon_sym_EQ_GT] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(14200),
    [anon_sym_DOT_DOT] = ACTIONS(14202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14204),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(14206),
    [anon_sym_AMP_AMP] = ACTIONS(14206),
    [anon_sym_LT_LT] = ACTIONS(14208),
    [anon_sym_GT_GT] = ACTIONS(14208),
    [anon_sym_EQ_EQ] = ACTIONS(14210),
    [anon_sym_BANG_EQ] = ACTIONS(14206),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14206),
    [anon_sym_LT_EQ_GT] = ACTIONS(14206),
    [anon_sym_EQ_TILDE] = ACTIONS(14206),
    [anon_sym_BANG_TILDE] = ACTIONS(14206),
    [anon_sym_LT_EQ] = ACTIONS(14198),
    [anon_sym_GT] = ACTIONS(14198),
    [anon_sym_GT_EQ] = ACTIONS(14212),
    [anon_sym_CARET] = ACTIONS(14214),
    [anon_sym_PLUS] = ACTIONS(14190),
    [anon_sym_SLASH] = ACTIONS(14192),
    [anon_sym_PERCENT] = ACTIONS(14192),
    [sym_comment] = ACTIONS(87),
  },
  [11220] = {
    [sym_heredoc_body] = STATE(11220),
    [aux_sym_call_repeat1] = STATE(11220),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(7916),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_end] = ACTIONS(7914),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_when] = ACTIONS(7914),
    [anon_sym_else] = ACTIONS(7914),
    [anon_sym_EQ_GT] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [11221] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10512),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9593),
    [sym_scope_resolution] = STATE(9589),
    [sym_call] = STATE(9589),
    [sym_method_call] = STATE(9593),
    [sym__argument] = STATE(4986),
    [sym_splat_argument] = STATE(4986),
    [sym_hash_splat_argument] = STATE(4986),
    [sym_block_argument] = STATE(4986),
    [sym_assignment] = STATE(10512),
    [sym_operator_assignment] = STATE(10512),
    [sym_conditional] = STATE(10512),
    [sym_range] = STATE(10512),
    [sym_binary] = STATE(10512),
    [sym_unary] = STATE(10512),
    [sym_left_assignment_list] = STATE(9592),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9593),
    [sym__variable] = STATE(9589),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9593),
    [sym_false] = STATE(9593),
    [sym_nil] = STATE(9593),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(10515),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4986),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__block_ampersand] = ACTIONS(14180),
    [sym__splat_star] = ACTIONS(14182),
    [sym__unary_minus] = ACTIONS(13286),
    [sym__identifier_hash_key] = ACTIONS(14184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(15193),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13290),
    [anon_sym_yield] = ACTIONS(13292),
    [anon_sym_break] = ACTIONS(13294),
    [anon_sym_next] = ACTIONS(13296),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14176),
    [anon_sym_defined_QMARK] = ACTIONS(13298),
    [anon_sym_not] = ACTIONS(13300),
    [anon_sym_BANG] = ACTIONS(13304),
    [anon_sym_TILDE] = ACTIONS(13304),
    [sym_constant] = ACTIONS(14186),
    [sym_identifier] = ACTIONS(14186),
    [sym_instance_variable] = ACTIONS(13308),
    [sym_class_variable] = ACTIONS(13308),
    [sym_global_variable] = ACTIONS(13308),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(13310),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13310),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11222] = {
    [sym_heredoc_body] = STATE(11220),
    [aux_sym_call_repeat1] = STATE(11220),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_end] = ACTIONS(7929),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_when] = ACTIONS(7929),
    [anon_sym_else] = ACTIONS(7929),
    [anon_sym_EQ_GT] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [11223] = {
    [aux_sym_argument_list_repeat1] = STATE(11223),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(15296),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7925),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_end] = ACTIONS(7925),
    [anon_sym_if] = ACTIONS(7925),
    [anon_sym_unless] = ACTIONS(7925),
    [anon_sym_while] = ACTIONS(7925),
    [anon_sym_until] = ACTIONS(7925),
    [anon_sym_rescue] = ACTIONS(7925),
    [anon_sym_when] = ACTIONS(7925),
    [anon_sym_else] = ACTIONS(7925),
    [anon_sym_EQ_GT] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7925),
    [anon_sym_AMP_AMP] = ACTIONS(7925),
    [anon_sym_LT_LT] = ACTIONS(7925),
    [anon_sym_GT_GT] = ACTIONS(7925),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7925),
    [anon_sym_PLUS] = ACTIONS(7925),
    [anon_sym_SLASH] = ACTIONS(7925),
    [anon_sym_PERCENT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [11224] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(11324),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9593),
    [sym_scope_resolution] = STATE(9589),
    [sym_call] = STATE(9589),
    [sym_method_call] = STATE(9593),
    [sym_assignment] = STATE(11324),
    [sym_operator_assignment] = STATE(11324),
    [sym_conditional] = STATE(11324),
    [sym_range] = STATE(11324),
    [sym_binary] = STATE(11324),
    [sym_unary] = STATE(11324),
    [sym_left_assignment_list] = STATE(9592),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9593),
    [sym__variable] = STATE(9589),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9593),
    [sym_false] = STATE(9593),
    [sym_nil] = STATE(9593),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(10504),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__unary_minus] = ACTIONS(13286),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13290),
    [anon_sym_yield] = ACTIONS(13292),
    [anon_sym_break] = ACTIONS(13294),
    [anon_sym_next] = ACTIONS(13296),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14176),
    [anon_sym_defined_QMARK] = ACTIONS(13298),
    [anon_sym_not] = ACTIONS(13300),
    [anon_sym_BANG] = ACTIONS(13304),
    [anon_sym_TILDE] = ACTIONS(13304),
    [sym_constant] = ACTIONS(13310),
    [sym_identifier] = ACTIONS(13310),
    [sym_instance_variable] = ACTIONS(13308),
    [sym_class_variable] = ACTIONS(13308),
    [sym_global_variable] = ACTIONS(13308),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(13310),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13310),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11225] = {
    [sym__line_break] = ACTIONS(6823),
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(14262),
    [sym__binary_star] = ACTIONS(14264),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(14266),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(14268),
    [anon_sym_AMP] = ACTIONS(14270),
    [anon_sym_EQ] = ACTIONS(7822),
    [anon_sym_LT] = ACTIONS(14272),
    [anon_sym_end] = ACTIONS(6823),
    [anon_sym_if] = ACTIONS(6823),
    [anon_sym_unless] = ACTIONS(6823),
    [anon_sym_while] = ACTIONS(6823),
    [anon_sym_until] = ACTIONS(6823),
    [anon_sym_rescue] = ACTIONS(6823),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_when] = ACTIONS(6823),
    [anon_sym_else] = ACTIONS(6823),
    [anon_sym_EQ_GT] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_PLUS_EQ] = ACTIONS(6823),
    [anon_sym_DASH_EQ] = ACTIONS(6823),
    [anon_sym_STAR_EQ] = ACTIONS(6823),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6823),
    [anon_sym_SLASH_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6823),
    [anon_sym_AMP_EQ] = ACTIONS(6823),
    [anon_sym_PERCENT_EQ] = ACTIONS(6823),
    [anon_sym_GT_GT_EQ] = ACTIONS(6823),
    [anon_sym_LT_LT_EQ] = ACTIONS(6823),
    [anon_sym_CARET_EQ] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(14274),
    [anon_sym_DOT_DOT] = ACTIONS(14276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14278),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(14280),
    [anon_sym_AMP_AMP] = ACTIONS(14280),
    [anon_sym_LT_LT] = ACTIONS(14282),
    [anon_sym_GT_GT] = ACTIONS(14282),
    [anon_sym_EQ_EQ] = ACTIONS(14280),
    [anon_sym_BANG_EQ] = ACTIONS(14284),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14284),
    [anon_sym_LT_EQ_GT] = ACTIONS(14284),
    [anon_sym_EQ_TILDE] = ACTIONS(14284),
    [anon_sym_BANG_TILDE] = ACTIONS(14284),
    [anon_sym_LT_EQ] = ACTIONS(14272),
    [anon_sym_GT] = ACTIONS(14272),
    [anon_sym_GT_EQ] = ACTIONS(14286),
    [anon_sym_CARET] = ACTIONS(14266),
    [anon_sym_PLUS] = ACTIONS(14288),
    [anon_sym_SLASH] = ACTIONS(14268),
    [anon_sym_PERCENT] = ACTIONS(14268),
    [sym_comment] = ACTIONS(87),
  },
  [11226] = {
    [sym__line_break] = ACTIONS(7027),
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(14262),
    [sym__binary_star] = ACTIONS(14264),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(14266),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(14268),
    [anon_sym_AMP] = ACTIONS(14270),
    [anon_sym_EQ] = ACTIONS(7884),
    [anon_sym_LT] = ACTIONS(14272),
    [anon_sym_end] = ACTIONS(7027),
    [anon_sym_if] = ACTIONS(7027),
    [anon_sym_unless] = ACTIONS(7027),
    [anon_sym_while] = ACTIONS(7027),
    [anon_sym_until] = ACTIONS(7027),
    [anon_sym_rescue] = ACTIONS(7027),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_when] = ACTIONS(7027),
    [anon_sym_else] = ACTIONS(7027),
    [anon_sym_EQ_GT] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_PLUS_EQ] = ACTIONS(7027),
    [anon_sym_DASH_EQ] = ACTIONS(7027),
    [anon_sym_STAR_EQ] = ACTIONS(7027),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7027),
    [anon_sym_SLASH_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7027),
    [anon_sym_AMP_EQ] = ACTIONS(7027),
    [anon_sym_PERCENT_EQ] = ACTIONS(7027),
    [anon_sym_GT_GT_EQ] = ACTIONS(7027),
    [anon_sym_LT_LT_EQ] = ACTIONS(7027),
    [anon_sym_CARET_EQ] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(14274),
    [anon_sym_DOT_DOT] = ACTIONS(14276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14278),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(14280),
    [anon_sym_AMP_AMP] = ACTIONS(14280),
    [anon_sym_LT_LT] = ACTIONS(14282),
    [anon_sym_GT_GT] = ACTIONS(14282),
    [anon_sym_EQ_EQ] = ACTIONS(14280),
    [anon_sym_BANG_EQ] = ACTIONS(14284),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14284),
    [anon_sym_LT_EQ_GT] = ACTIONS(14284),
    [anon_sym_EQ_TILDE] = ACTIONS(14284),
    [anon_sym_BANG_TILDE] = ACTIONS(14284),
    [anon_sym_LT_EQ] = ACTIONS(14272),
    [anon_sym_GT] = ACTIONS(14272),
    [anon_sym_GT_EQ] = ACTIONS(14286),
    [anon_sym_CARET] = ACTIONS(14266),
    [anon_sym_PLUS] = ACTIONS(14288),
    [anon_sym_SLASH] = ACTIONS(14268),
    [anon_sym_PERCENT] = ACTIONS(14268),
    [sym_comment] = ACTIONS(87),
  },
  [11227] = {
    [sym_heredoc_body] = STATE(11227),
    [aux_sym_call_repeat1] = STATE(11227),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(10978),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7919),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_EQ] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_end] = ACTIONS(7914),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_when] = ACTIONS(7914),
    [anon_sym_else] = ACTIONS(7914),
    [anon_sym_EQ_GT] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_PLUS_EQ] = ACTIONS(7914),
    [anon_sym_DASH_EQ] = ACTIONS(7914),
    [anon_sym_STAR_EQ] = ACTIONS(7914),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7914),
    [anon_sym_SLASH_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7914),
    [anon_sym_AMP_EQ] = ACTIONS(7914),
    [anon_sym_PERCENT_EQ] = ACTIONS(7914),
    [anon_sym_GT_GT_EQ] = ACTIONS(7914),
    [anon_sym_LT_LT_EQ] = ACTIONS(7914),
    [anon_sym_CARET_EQ] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7919),
    [anon_sym_AMP_AMP] = ACTIONS(7919),
    [anon_sym_LT_LT] = ACTIONS(7919),
    [anon_sym_GT_GT] = ACTIONS(7919),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7919),
    [anon_sym_PLUS] = ACTIONS(7919),
    [anon_sym_SLASH] = ACTIONS(7919),
    [anon_sym_PERCENT] = ACTIONS(7919),
    [sym_comment] = ACTIONS(87),
  },
  [11228] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(10533),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(9629),
    [sym_scope_resolution] = STATE(9625),
    [sym_call] = STATE(9625),
    [sym_method_call] = STATE(9629),
    [sym__argument] = STATE(7437),
    [sym_splat_argument] = STATE(7437),
    [sym_hash_splat_argument] = STATE(7437),
    [sym_block_argument] = STATE(7437),
    [sym_assignment] = STATE(10533),
    [sym_operator_assignment] = STATE(10533),
    [sym_conditional] = STATE(10533),
    [sym_range] = STATE(10533),
    [sym_binary] = STATE(10533),
    [sym_unary] = STATE(10533),
    [sym_left_assignment_list] = STATE(9628),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9629),
    [sym__variable] = STATE(9625),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(9629),
    [sym_false] = STATE(9629),
    [sym_nil] = STATE(9629),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(10536),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_pair] = STATE(7437),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__block_ampersand] = ACTIONS(14216),
    [sym__splat_star] = ACTIONS(14218),
    [sym__unary_minus] = ACTIONS(13356),
    [sym__identifier_hash_key] = ACTIONS(14220),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(15197),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(13360),
    [anon_sym_yield] = ACTIONS(13362),
    [anon_sym_break] = ACTIONS(13364),
    [anon_sym_next] = ACTIONS(13366),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(14256),
    [anon_sym_defined_QMARK] = ACTIONS(13368),
    [anon_sym_not] = ACTIONS(13370),
    [anon_sym_BANG] = ACTIONS(13374),
    [anon_sym_TILDE] = ACTIONS(13374),
    [sym_constant] = ACTIONS(14222),
    [sym_identifier] = ACTIONS(14222),
    [sym_instance_variable] = ACTIONS(13378),
    [sym_class_variable] = ACTIONS(13378),
    [sym_global_variable] = ACTIONS(13378),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(13380),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13380),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [11229] = {
    [sym_heredoc_body] = STATE(11227),
    [aux_sym_call_repeat1] = STATE(11227),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(4373),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7931),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_EQ] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_end] = ACTIONS(7929),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_when] = ACTIONS(7929),
    [anon_sym_else] = ACTIONS(7929),
    [anon_sym_EQ_GT] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_PLUS_EQ] = ACTIONS(7929),
    [anon_sym_DASH_EQ] = ACTIONS(7929),
    [anon_sym_STAR_EQ] = ACTIONS(7929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7929),
    [anon_sym_SLASH_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7929),
    [anon_sym_AMP_EQ] = ACTIONS(7929),
    [anon_sym_PERCENT_EQ] = ACTIONS(7929),
    [anon_sym_GT_GT_EQ] = ACTIONS(7929),
    [anon_sym_LT_LT_EQ] = ACTIONS(7929),
    [anon_sym_CARET_EQ] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7931),
    [anon_sym_AMP_AMP] = ACTIONS(7931),
    [anon_sym_LT_LT] = ACTIONS(7931),
    [anon_sym_GT_GT] = ACTIONS(7931),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7931),
    [anon_sym_PLUS] = ACTIONS(7931),
    [anon_sym_SLASH] = ACTIONS(7931),
    [anon_sym_PERCENT] = ACTIONS(7931),
    [sym_comment] = ACTIONS(87),
  },
  [11230] = {
    [aux_sym_argument_list_repeat1] = STATE(11230),
    [sym__line_break] = ACTIONS(7925),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(15299),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7927),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_EQ] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_end] = ACTIONS(7925),
    [anon_sym_if] = ACTIONS(7925),
    [anon_sym_unless] = ACTIONS(7925),
    [anon_sym_while] = ACTIONS(7925),
    [anon_sym_until] = ACTIONS(7925),
    [anon_sym_rescue] = ACTIONS(7925),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_when] = ACTIONS(7925),
    [anon_sym_else] = ACTIONS(7925),
    [anon_sym_EQ_GT] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_PLUS_EQ] = ACTIONS(7925),
    [anon_sym_DASH_EQ] = ACTIONS(7925),
    [anon_sym_STAR_EQ] = ACTIONS(7925),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7925),
    [anon_sym_SLASH_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7925),
    [anon_sym_AMP_EQ] = ACTIONS(7925),
    [anon_sym_PERCENT_EQ] = ACTIONS(7925),
    [anon_sym_GT_GT_EQ] = ACTIONS(7925),
    [anon_sym_LT_LT_EQ] = ACTIONS(7925),
    [anon_sym_CARET_EQ] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7927),
    [anon_sym_AMP_AMP] = ACTIONS(7927),
    [anon_sym_LT_LT] = ACTIONS(7927),
    [anon_sym_GT_GT] = ACTIONS(7927),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7927),
    [anon_sym_PLUS] = ACTIONS(7927),
    [anon_sym_SLASH] = ACTIONS(7927),
    [anon_sym_PERCENT] = ACTIONS(7927),
    [sym_comment] = ACTIONS(87),
  },
  [11231] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10984),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9593),
    [sym_scope_resolution] = STATE(9589),
    [sym_call] = STATE(9589),
    [sym_method_call] = STATE(9593),
    [sym_splat_argument] = STATE(7439),
    [sym_assignment] = STATE(10984),
    [sym_operator_assignment] = STATE(10984),
    [sym_conditional] = STATE(10984),
    [sym_range] = STATE(10984),
    [sym_binary] = STATE(10984),
    [sym_unary] = STATE(10984),
    [sym__arg_or_splat_arg] = STATE(7439),
    [sym_left_assignment_list] = STATE(9592),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9593),
    [sym__variable] = STATE(9589),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9593),
    [sym_false] = STATE(9593),
    [sym_nil] = STATE(9593),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(10504),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(367),
    [sym__splat_star] = ACTIONS(14182),
    [sym__unary_minus] = ACTIONS(13286),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13290),
    [anon_sym_yield] = ACTIONS(13292),
    [anon_sym_break] = ACTIONS(13294),
    [anon_sym_next] = ACTIONS(13296),
    [sym_redo] = ACTIONS(391),
    [sym_retry] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14176),
    [anon_sym_defined_QMARK] = ACTIONS(13298),
    [anon_sym_not] = ACTIONS(13300),
    [anon_sym_BANG] = ACTIONS(13304),
    [anon_sym_TILDE] = ACTIONS(13304),
    [sym_constant] = ACTIONS(13310),
    [sym_identifier] = ACTIONS(13310),
    [sym_instance_variable] = ACTIONS(13308),
    [sym_class_variable] = ACTIONS(13308),
    [sym_global_variable] = ACTIONS(13308),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(391),
    [sym_complex] = ACTIONS(367),
    [sym_super] = ACTIONS(13310),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13310),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(367),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11232] = {
    [aux_sym_exceptions_repeat1] = STATE(11325),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(15302),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_end] = ACTIONS(9855),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_when] = ACTIONS(9855),
    [anon_sym_else] = ACTIONS(9855),
    [anon_sym_EQ_GT] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [11233] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(13324),
    [sym__binary_star] = ACTIONS(13326),
    [anon_sym_PIPE] = ACTIONS(13328),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(13326),
    [anon_sym_AMP] = ACTIONS(13330),
    [anon_sym_LT] = ACTIONS(13332),
    [anon_sym_end] = ACTIONS(12120),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_when] = ACTIONS(12120),
    [anon_sym_else] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(13334),
    [anon_sym_DOT_DOT] = ACTIONS(13336),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13338),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(13342),
    [anon_sym_AMP_AMP] = ACTIONS(13342),
    [anon_sym_LT_LT] = ACTIONS(13344),
    [anon_sym_GT_GT] = ACTIONS(13344),
    [anon_sym_EQ_EQ] = ACTIONS(13346),
    [anon_sym_BANG_EQ] = ACTIONS(13342),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13342),
    [anon_sym_LT_EQ_GT] = ACTIONS(13342),
    [anon_sym_EQ_TILDE] = ACTIONS(13342),
    [anon_sym_BANG_TILDE] = ACTIONS(13342),
    [anon_sym_LT_EQ] = ACTIONS(13332),
    [anon_sym_GT] = ACTIONS(13332),
    [anon_sym_GT_EQ] = ACTIONS(13348),
    [anon_sym_CARET] = ACTIONS(13350),
    [anon_sym_PLUS] = ACTIONS(13324),
    [anon_sym_SLASH] = ACTIONS(13326),
    [anon_sym_PERCENT] = ACTIONS(13326),
    [sym_comment] = ACTIONS(87),
  },
  [11234] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(14885),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(14889),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_when] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(14889),
    [anon_sym_PERCENT] = ACTIONS(14889),
    [sym_comment] = ACTIONS(87),
  },
  [11235] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(14889),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_when] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(5827),
    [anon_sym_PERCENT] = ACTIONS(5827),
    [sym_comment] = ACTIONS(87),
  },
  [11236] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(14883),
    [sym__binary_star] = ACTIONS(14885),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(14889),
    [anon_sym_AMP] = ACTIONS(14891),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_when] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(14903),
    [anon_sym_GT_GT] = ACTIONS(14903),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(14909),
    [anon_sym_SLASH] = ACTIONS(14889),
    [anon_sym_PERCENT] = ACTIONS(14889),
    [sym_comment] = ACTIONS(87),
  },
  [11237] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(14883),
    [sym__binary_star] = ACTIONS(14885),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(14889),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_when] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(14903),
    [anon_sym_GT_GT] = ACTIONS(14903),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(14909),
    [anon_sym_SLASH] = ACTIONS(14889),
    [anon_sym_PERCENT] = ACTIONS(14889),
    [sym_comment] = ACTIONS(87),
  },
  [11238] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(14883),
    [sym__binary_star] = ACTIONS(14885),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(14887),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(14889),
    [anon_sym_AMP] = ACTIONS(14891),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_when] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(14903),
    [anon_sym_GT_GT] = ACTIONS(14903),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(14887),
    [anon_sym_PLUS] = ACTIONS(14909),
    [anon_sym_SLASH] = ACTIONS(14889),
    [anon_sym_PERCENT] = ACTIONS(14889),
    [sym_comment] = ACTIONS(87),
  },
  [11239] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(15304),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [11240] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(14883),
    [sym__binary_star] = ACTIONS(14885),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(14887),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(14889),
    [anon_sym_AMP] = ACTIONS(14891),
    [anon_sym_EQ] = ACTIONS(7888),
    [anon_sym_LT] = ACTIONS(14893),
    [anon_sym_end] = ACTIONS(5927),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_when] = ACTIONS(5927),
    [anon_sym_else] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_PLUS_EQ] = ACTIONS(5927),
    [anon_sym_DASH_EQ] = ACTIONS(5927),
    [anon_sym_STAR_EQ] = ACTIONS(5927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5927),
    [anon_sym_SLASH_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5927),
    [anon_sym_AMP_EQ] = ACTIONS(5927),
    [anon_sym_PERCENT_EQ] = ACTIONS(5927),
    [anon_sym_GT_GT_EQ] = ACTIONS(5927),
    [anon_sym_LT_LT_EQ] = ACTIONS(5927),
    [anon_sym_CARET_EQ] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(14897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14899),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(14901),
    [anon_sym_AMP_AMP] = ACTIONS(14901),
    [anon_sym_LT_LT] = ACTIONS(14903),
    [anon_sym_GT_GT] = ACTIONS(14903),
    [anon_sym_EQ_EQ] = ACTIONS(14901),
    [anon_sym_BANG_EQ] = ACTIONS(14905),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14905),
    [anon_sym_LT_EQ_GT] = ACTIONS(14905),
    [anon_sym_EQ_TILDE] = ACTIONS(14905),
    [anon_sym_BANG_TILDE] = ACTIONS(14905),
    [anon_sym_LT_EQ] = ACTIONS(14893),
    [anon_sym_GT] = ACTIONS(14893),
    [anon_sym_GT_EQ] = ACTIONS(14907),
    [anon_sym_CARET] = ACTIONS(14887),
    [anon_sym_PLUS] = ACTIONS(14909),
    [anon_sym_SLASH] = ACTIONS(14889),
    [anon_sym_PERCENT] = ACTIONS(14889),
    [sym_comment] = ACTIONS(87),
  },
  [11241] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(14883),
    [sym__binary_star] = ACTIONS(14885),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(14887),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(14889),
    [anon_sym_AMP] = ACTIONS(14891),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(14893),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_when] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(14895),
    [anon_sym_DOT_DOT] = ACTIONS(14897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14899),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(14901),
    [anon_sym_AMP_AMP] = ACTIONS(14901),
    [anon_sym_LT_LT] = ACTIONS(14903),
    [anon_sym_GT_GT] = ACTIONS(14903),
    [anon_sym_EQ_EQ] = ACTIONS(14901),
    [anon_sym_BANG_EQ] = ACTIONS(14905),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14905),
    [anon_sym_LT_EQ_GT] = ACTIONS(14905),
    [anon_sym_EQ_TILDE] = ACTIONS(14905),
    [anon_sym_BANG_TILDE] = ACTIONS(14905),
    [anon_sym_LT_EQ] = ACTIONS(14893),
    [anon_sym_GT] = ACTIONS(14893),
    [anon_sym_GT_EQ] = ACTIONS(14907),
    [anon_sym_CARET] = ACTIONS(14887),
    [anon_sym_PLUS] = ACTIONS(14909),
    [anon_sym_SLASH] = ACTIONS(14889),
    [anon_sym_PERCENT] = ACTIONS(14889),
    [sym_comment] = ACTIONS(87),
  },
  [11242] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(14883),
    [sym__binary_star] = ACTIONS(14885),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(14887),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(14889),
    [anon_sym_AMP] = ACTIONS(14891),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(14893),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_when] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(14903),
    [anon_sym_GT_GT] = ACTIONS(14903),
    [anon_sym_EQ_EQ] = ACTIONS(14901),
    [anon_sym_BANG_EQ] = ACTIONS(14905),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14905),
    [anon_sym_LT_EQ_GT] = ACTIONS(14905),
    [anon_sym_EQ_TILDE] = ACTIONS(14905),
    [anon_sym_BANG_TILDE] = ACTIONS(14905),
    [anon_sym_LT_EQ] = ACTIONS(14893),
    [anon_sym_GT] = ACTIONS(14893),
    [anon_sym_GT_EQ] = ACTIONS(14907),
    [anon_sym_CARET] = ACTIONS(14887),
    [anon_sym_PLUS] = ACTIONS(14909),
    [anon_sym_SLASH] = ACTIONS(14889),
    [anon_sym_PERCENT] = ACTIONS(14889),
    [sym_comment] = ACTIONS(87),
  },
  [11243] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(14883),
    [sym__binary_star] = ACTIONS(14885),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(14889),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_when] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(14909),
    [anon_sym_SLASH] = ACTIONS(14889),
    [anon_sym_PERCENT] = ACTIONS(14889),
    [sym_comment] = ACTIONS(87),
  },
  [11244] = {
    [sym__line_break] = ACTIONS(5115),
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(14883),
    [sym__binary_star] = ACTIONS(14885),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(14887),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(14889),
    [anon_sym_AMP] = ACTIONS(14891),
    [anon_sym_EQ] = ACTIONS(7936),
    [anon_sym_LT] = ACTIONS(14893),
    [anon_sym_end] = ACTIONS(5115),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_unless] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_until] = ACTIONS(5115),
    [anon_sym_rescue] = ACTIONS(5115),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_when] = ACTIONS(5115),
    [anon_sym_else] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_PLUS_EQ] = ACTIONS(5115),
    [anon_sym_DASH_EQ] = ACTIONS(5115),
    [anon_sym_STAR_EQ] = ACTIONS(5115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5115),
    [anon_sym_SLASH_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5115),
    [anon_sym_AMP_EQ] = ACTIONS(5115),
    [anon_sym_PERCENT_EQ] = ACTIONS(5115),
    [anon_sym_GT_GT_EQ] = ACTIONS(5115),
    [anon_sym_LT_LT_EQ] = ACTIONS(5115),
    [anon_sym_CARET_EQ] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(14895),
    [anon_sym_DOT_DOT] = ACTIONS(14897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14899),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(14901),
    [anon_sym_AMP_AMP] = ACTIONS(14901),
    [anon_sym_LT_LT] = ACTIONS(14903),
    [anon_sym_GT_GT] = ACTIONS(14903),
    [anon_sym_EQ_EQ] = ACTIONS(14901),
    [anon_sym_BANG_EQ] = ACTIONS(14905),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14905),
    [anon_sym_LT_EQ_GT] = ACTIONS(14905),
    [anon_sym_EQ_TILDE] = ACTIONS(14905),
    [anon_sym_BANG_TILDE] = ACTIONS(14905),
    [anon_sym_LT_EQ] = ACTIONS(14893),
    [anon_sym_GT] = ACTIONS(14893),
    [anon_sym_GT_EQ] = ACTIONS(14907),
    [anon_sym_CARET] = ACTIONS(14887),
    [anon_sym_PLUS] = ACTIONS(14909),
    [anon_sym_SLASH] = ACTIONS(14889),
    [anon_sym_PERCENT] = ACTIONS(14889),
    [sym_comment] = ACTIONS(87),
  },
  [11245] = {
    [aux_sym_exceptions_repeat1] = STATE(11328),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6193),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_end] = ACTIONS(6191),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_when] = ACTIONS(6191),
    [anon_sym_else] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_PLUS_EQ] = ACTIONS(6191),
    [anon_sym_DASH_EQ] = ACTIONS(6191),
    [anon_sym_STAR_EQ] = ACTIONS(6191),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6191),
    [anon_sym_SLASH_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6191),
    [anon_sym_AMP_EQ] = ACTIONS(6191),
    [anon_sym_PERCENT_EQ] = ACTIONS(6191),
    [anon_sym_GT_GT_EQ] = ACTIONS(6191),
    [anon_sym_LT_LT_EQ] = ACTIONS(6191),
    [anon_sym_CARET_EQ] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6193),
    [anon_sym_AMP_AMP] = ACTIONS(6193),
    [anon_sym_LT_LT] = ACTIONS(6193),
    [anon_sym_GT_GT] = ACTIONS(6193),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6193),
    [anon_sym_PLUS] = ACTIONS(6193),
    [anon_sym_SLASH] = ACTIONS(6193),
    [anon_sym_PERCENT] = ACTIONS(6193),
    [sym_comment] = ACTIONS(87),
  },
  [11246] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(14883),
    [sym__binary_star] = ACTIONS(14885),
    [anon_sym_LBRACE] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(14887),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(14889),
    [anon_sym_AMP] = ACTIONS(14891),
    [anon_sym_EQ] = ACTIONS(7938),
    [anon_sym_LT] = ACTIONS(14893),
    [anon_sym_end] = ACTIONS(6210),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_when] = ACTIONS(6210),
    [anon_sym_else] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_PLUS_EQ] = ACTIONS(6210),
    [anon_sym_DASH_EQ] = ACTIONS(6210),
    [anon_sym_STAR_EQ] = ACTIONS(6210),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6210),
    [anon_sym_SLASH_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6210),
    [anon_sym_AMP_EQ] = ACTIONS(6210),
    [anon_sym_PERCENT_EQ] = ACTIONS(6210),
    [anon_sym_GT_GT_EQ] = ACTIONS(6210),
    [anon_sym_LT_LT_EQ] = ACTIONS(6210),
    [anon_sym_CARET_EQ] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(14895),
    [anon_sym_DOT_DOT] = ACTIONS(14897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14899),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(14901),
    [anon_sym_AMP_AMP] = ACTIONS(14901),
    [anon_sym_LT_LT] = ACTIONS(14903),
    [anon_sym_GT_GT] = ACTIONS(14903),
    [anon_sym_EQ_EQ] = ACTIONS(14901),
    [anon_sym_BANG_EQ] = ACTIONS(14905),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14905),
    [anon_sym_LT_EQ_GT] = ACTIONS(14905),
    [anon_sym_EQ_TILDE] = ACTIONS(14905),
    [anon_sym_BANG_TILDE] = ACTIONS(14905),
    [anon_sym_LT_EQ] = ACTIONS(14893),
    [anon_sym_GT] = ACTIONS(14893),
    [anon_sym_GT_EQ] = ACTIONS(14907),
    [anon_sym_CARET] = ACTIONS(14887),
    [anon_sym_PLUS] = ACTIONS(14909),
    [anon_sym_SLASH] = ACTIONS(14889),
    [anon_sym_PERCENT] = ACTIONS(14889),
    [sym_comment] = ACTIONS(87),
  },
  [11247] = {
    [sym_string] = STATE(11247),
    [aux_sym_chained_string_repeat1] = STATE(11247),
    [sym__line_break] = ACTIONS(6212),
    [sym__string_start] = ACTIONS(12267),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6217),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_EQ] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_end] = ACTIONS(6212),
    [anon_sym_if] = ACTIONS(6212),
    [anon_sym_unless] = ACTIONS(6212),
    [anon_sym_while] = ACTIONS(6212),
    [anon_sym_until] = ACTIONS(6212),
    [anon_sym_rescue] = ACTIONS(6212),
    [anon_sym_do] = ACTIONS(6212),
    [anon_sym_when] = ACTIONS(6212),
    [anon_sym_else] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_PLUS_EQ] = ACTIONS(6212),
    [anon_sym_DASH_EQ] = ACTIONS(6212),
    [anon_sym_STAR_EQ] = ACTIONS(6212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6212),
    [anon_sym_SLASH_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6212),
    [anon_sym_AMP_EQ] = ACTIONS(6212),
    [anon_sym_PERCENT_EQ] = ACTIONS(6212),
    [anon_sym_GT_GT_EQ] = ACTIONS(6212),
    [anon_sym_LT_LT_EQ] = ACTIONS(6212),
    [anon_sym_CARET_EQ] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6217),
    [anon_sym_AMP_AMP] = ACTIONS(6217),
    [anon_sym_LT_LT] = ACTIONS(6217),
    [anon_sym_GT_GT] = ACTIONS(6217),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6217),
    [anon_sym_PLUS] = ACTIONS(6217),
    [anon_sym_SLASH] = ACTIONS(6217),
    [anon_sym_PERCENT] = ACTIONS(6217),
    [sym_comment] = ACTIONS(87),
  },
  [11248] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(11329),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(9629),
    [sym_scope_resolution] = STATE(9625),
    [sym_call] = STATE(9625),
    [sym_method_call] = STATE(9629),
    [sym_assignment] = STATE(11329),
    [sym_operator_assignment] = STATE(11329),
    [sym_conditional] = STATE(11329),
    [sym_range] = STATE(11329),
    [sym_binary] = STATE(11329),
    [sym_unary] = STATE(11329),
    [sym_left_assignment_list] = STATE(9628),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9629),
    [sym__variable] = STATE(9625),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(9629),
    [sym_false] = STATE(9629),
    [sym_nil] = STATE(9629),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(10573),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__unary_minus] = ACTIONS(13356),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(13360),
    [anon_sym_yield] = ACTIONS(13362),
    [anon_sym_break] = ACTIONS(13364),
    [anon_sym_next] = ACTIONS(13366),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(14256),
    [anon_sym_defined_QMARK] = ACTIONS(13368),
    [anon_sym_not] = ACTIONS(13370),
    [anon_sym_BANG] = ACTIONS(13374),
    [anon_sym_TILDE] = ACTIONS(13374),
    [sym_constant] = ACTIONS(13380),
    [sym_identifier] = ACTIONS(13380),
    [sym_instance_variable] = ACTIONS(13378),
    [sym_class_variable] = ACTIONS(13378),
    [sym_global_variable] = ACTIONS(13378),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(13380),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13380),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [11249] = {
    [sym_method] = STATE(421),
    [sym_singleton_method] = STATE(421),
    [sym_class] = STATE(421),
    [sym_singleton_class] = STATE(421),
    [sym_module] = STATE(421),
    [sym_return] = STATE(421),
    [sym_yield] = STATE(421),
    [sym_break] = STATE(421),
    [sym_next] = STATE(421),
    [sym_while] = STATE(421),
    [sym_until] = STATE(421),
    [sym_for] = STATE(421),
    [sym_case] = STATE(421),
    [sym_if] = STATE(421),
    [sym_unless] = STATE(421),
    [sym_begin] = STATE(421),
    [sym__arg] = STATE(11021),
    [sym__primary] = STATE(421),
    [sym_parenthesized_statements] = STATE(421),
    [sym_element_reference] = STATE(9629),
    [sym_scope_resolution] = STATE(9625),
    [sym_call] = STATE(9625),
    [sym_method_call] = STATE(9629),
    [sym_splat_argument] = STATE(8678),
    [sym_assignment] = STATE(11021),
    [sym_operator_assignment] = STATE(11021),
    [sym_conditional] = STATE(11021),
    [sym_range] = STATE(11021),
    [sym_binary] = STATE(11021),
    [sym_unary] = STATE(11021),
    [sym__arg_or_splat_arg] = STATE(8678),
    [sym_left_assignment_list] = STATE(9628),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9629),
    [sym__variable] = STATE(9625),
    [sym_rational] = STATE(421),
    [sym_true] = STATE(9629),
    [sym_false] = STATE(9629),
    [sym_nil] = STATE(9629),
    [sym_chained_string] = STATE(421),
    [sym_string] = STATE(10573),
    [sym_subshell] = STATE(421),
    [sym_string_array] = STATE(421),
    [sym_symbol_array] = STATE(421),
    [sym_symbol] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_array] = STATE(421),
    [sym_hash] = STATE(421),
    [sym_lambda] = STATE(421),
    [sym__simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(747),
    [sym__symbol_start] = ACTIONS(749),
    [sym__subshell_start] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(755),
    [sym__symbol_array_start] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(759),
    [sym__splat_star] = ACTIONS(14218),
    [sym__unary_minus] = ACTIONS(13356),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_def] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(13360),
    [anon_sym_yield] = ACTIONS(13362),
    [anon_sym_break] = ACTIONS(13364),
    [anon_sym_next] = ACTIONS(13366),
    [sym_redo] = ACTIONS(789),
    [sym_retry] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_unless] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_until] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_begin] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(14256),
    [anon_sym_defined_QMARK] = ACTIONS(13368),
    [anon_sym_not] = ACTIONS(13370),
    [anon_sym_BANG] = ACTIONS(13374),
    [anon_sym_TILDE] = ACTIONS(13374),
    [sym_constant] = ACTIONS(13380),
    [sym_identifier] = ACTIONS(13380),
    [sym_instance_variable] = ACTIONS(13378),
    [sym_class_variable] = ACTIONS(13378),
    [sym_global_variable] = ACTIONS(13378),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(813),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(759),
    [sym_super] = ACTIONS(13380),
    [anon_sym_true] = ACTIONS(409),
    [anon_sym_TRUE] = ACTIONS(409),
    [anon_sym_false] = ACTIONS(411),
    [anon_sym_FALSE] = ACTIONS(411),
    [sym_self] = ACTIONS(13380),
    [anon_sym_nil] = ACTIONS(413),
    [anon_sym_NIL] = ACTIONS(413),
    [sym_character] = ACTIONS(759),
    [anon_sym_LBRACK2] = ACTIONS(2625),
    [anon_sym_DASH_GT] = ACTIONS(819),
  },
  [11250] = {
    [aux_sym_exceptions_repeat1] = STATE(11330),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_LBRACE] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(15306),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9857),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_EQ] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_end] = ACTIONS(9855),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_do] = ACTIONS(9855),
    [anon_sym_when] = ACTIONS(9855),
    [anon_sym_else] = ACTIONS(9855),
    [anon_sym_EQ_GT] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_PLUS_EQ] = ACTIONS(9855),
    [anon_sym_DASH_EQ] = ACTIONS(9855),
    [anon_sym_STAR_EQ] = ACTIONS(9855),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9855),
    [anon_sym_SLASH_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9855),
    [anon_sym_AMP_EQ] = ACTIONS(9855),
    [anon_sym_PERCENT_EQ] = ACTIONS(9855),
    [anon_sym_GT_GT_EQ] = ACTIONS(9855),
    [anon_sym_LT_LT_EQ] = ACTIONS(9855),
    [anon_sym_CARET_EQ] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9857),
    [anon_sym_AMP_AMP] = ACTIONS(9857),
    [anon_sym_LT_LT] = ACTIONS(9857),
    [anon_sym_GT_GT] = ACTIONS(9857),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9857),
    [anon_sym_PLUS] = ACTIONS(9857),
    [anon_sym_SLASH] = ACTIONS(9857),
    [anon_sym_PERCENT] = ACTIONS(9857),
    [sym_comment] = ACTIONS(87),
  },
  [11251] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(14921),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(14921),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_when] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(14921),
    [anon_sym_PERCENT] = ACTIONS(14921),
    [sym_comment] = ACTIONS(87),
  },
  [11252] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(14921),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_when] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [11253] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(14919),
    [sym__binary_star] = ACTIONS(14921),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(14921),
    [anon_sym_AMP] = ACTIONS(14925),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_when] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(14937),
    [anon_sym_GT_GT] = ACTIONS(14937),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(14919),
    [anon_sym_SLASH] = ACTIONS(14921),
    [anon_sym_PERCENT] = ACTIONS(14921),
    [sym_comment] = ACTIONS(87),
  },
  [11254] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(14919),
    [sym__binary_star] = ACTIONS(14921),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(14921),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_when] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(14937),
    [anon_sym_GT_GT] = ACTIONS(14937),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(14919),
    [anon_sym_SLASH] = ACTIONS(14921),
    [anon_sym_PERCENT] = ACTIONS(14921),
    [sym_comment] = ACTIONS(87),
  },
  [11255] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(14919),
    [sym__binary_star] = ACTIONS(14921),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(14923),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(14921),
    [anon_sym_AMP] = ACTIONS(14925),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_when] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(14937),
    [anon_sym_GT_GT] = ACTIONS(14937),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(14943),
    [anon_sym_PLUS] = ACTIONS(14919),
    [anon_sym_SLASH] = ACTIONS(14921),
    [anon_sym_PERCENT] = ACTIONS(14921),
    [sym_comment] = ACTIONS(87),
  },
  [11256] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(15308),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [11257] = {
    [sym__line_break] = ACTIONS(5927),
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(14919),
    [sym__binary_star] = ACTIONS(14921),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(14923),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(14921),
    [anon_sym_AMP] = ACTIONS(14925),
    [anon_sym_LT] = ACTIONS(14927),
    [anon_sym_end] = ACTIONS(5927),
    [anon_sym_if] = ACTIONS(5927),
    [anon_sym_unless] = ACTIONS(5927),
    [anon_sym_while] = ACTIONS(5927),
    [anon_sym_until] = ACTIONS(5927),
    [anon_sym_rescue] = ACTIONS(5927),
    [anon_sym_when] = ACTIONS(5927),
    [anon_sym_else] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(14931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14933),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(14935),
    [anon_sym_AMP_AMP] = ACTIONS(14935),
    [anon_sym_LT_LT] = ACTIONS(14937),
    [anon_sym_GT_GT] = ACTIONS(14937),
    [anon_sym_EQ_EQ] = ACTIONS(14939),
    [anon_sym_BANG_EQ] = ACTIONS(14935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14935),
    [anon_sym_LT_EQ_GT] = ACTIONS(14935),
    [anon_sym_EQ_TILDE] = ACTIONS(14935),
    [anon_sym_BANG_TILDE] = ACTIONS(14935),
    [anon_sym_LT_EQ] = ACTIONS(14927),
    [anon_sym_GT] = ACTIONS(14927),
    [anon_sym_GT_EQ] = ACTIONS(14941),
    [anon_sym_CARET] = ACTIONS(14943),
    [anon_sym_PLUS] = ACTIONS(14919),
    [anon_sym_SLASH] = ACTIONS(14921),
    [anon_sym_PERCENT] = ACTIONS(14921),
    [sym_comment] = ACTIONS(87),
  },
  [11258] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(14919),
    [sym__binary_star] = ACTIONS(14921),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(14923),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(14921),
    [anon_sym_AMP] = ACTIONS(14925),
    [anon_sym_LT] = ACTIONS(14927),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_when] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(14929),
    [anon_sym_DOT_DOT] = ACTIONS(14931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14933),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(14935),
    [anon_sym_AMP_AMP] = ACTIONS(14935),
    [anon_sym_LT_LT] = ACTIONS(14937),
    [anon_sym_GT_GT] = ACTIONS(14937),
    [anon_sym_EQ_EQ] = ACTIONS(14939),
    [anon_sym_BANG_EQ] = ACTIONS(14935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14935),
    [anon_sym_LT_EQ_GT] = ACTIONS(14935),
    [anon_sym_EQ_TILDE] = ACTIONS(14935),
    [anon_sym_BANG_TILDE] = ACTIONS(14935),
    [anon_sym_LT_EQ] = ACTIONS(14927),
    [anon_sym_GT] = ACTIONS(14927),
    [anon_sym_GT_EQ] = ACTIONS(14941),
    [anon_sym_CARET] = ACTIONS(14943),
    [anon_sym_PLUS] = ACTIONS(14919),
    [anon_sym_SLASH] = ACTIONS(14921),
    [anon_sym_PERCENT] = ACTIONS(14921),
    [sym_comment] = ACTIONS(87),
  },
  [11259] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(14919),
    [sym__binary_star] = ACTIONS(14921),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(14923),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(14921),
    [anon_sym_AMP] = ACTIONS(14925),
    [anon_sym_LT] = ACTIONS(14927),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_when] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(14937),
    [anon_sym_GT_GT] = ACTIONS(14937),
    [anon_sym_EQ_EQ] = ACTIONS(14939),
    [anon_sym_BANG_EQ] = ACTIONS(14935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14935),
    [anon_sym_LT_EQ_GT] = ACTIONS(14935),
    [anon_sym_EQ_TILDE] = ACTIONS(14935),
    [anon_sym_BANG_TILDE] = ACTIONS(14935),
    [anon_sym_LT_EQ] = ACTIONS(14927),
    [anon_sym_GT] = ACTIONS(14927),
    [anon_sym_GT_EQ] = ACTIONS(14941),
    [anon_sym_CARET] = ACTIONS(14943),
    [anon_sym_PLUS] = ACTIONS(14919),
    [anon_sym_SLASH] = ACTIONS(14921),
    [anon_sym_PERCENT] = ACTIONS(14921),
    [sym_comment] = ACTIONS(87),
  },
  [11260] = {
    [sym__line_break] = ACTIONS(5825),
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(14919),
    [sym__binary_star] = ACTIONS(14921),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(14921),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_end] = ACTIONS(5825),
    [anon_sym_if] = ACTIONS(5825),
    [anon_sym_unless] = ACTIONS(5825),
    [anon_sym_while] = ACTIONS(5825),
    [anon_sym_until] = ACTIONS(5825),
    [anon_sym_rescue] = ACTIONS(5825),
    [anon_sym_when] = ACTIONS(5825),
    [anon_sym_else] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(14919),
    [anon_sym_SLASH] = ACTIONS(14921),
    [anon_sym_PERCENT] = ACTIONS(14921),
    [sym_comment] = ACTIONS(87),
  },
  [11261] = {
    [aux_sym_exceptions_repeat1] = STATE(11261),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_COMMA] = ACTIONS(15310),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_end] = ACTIONS(11597),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_when] = ACTIONS(11597),
    [anon_sym_else] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [11262] = {
    [aux_sym_exceptions_repeat1] = STATE(11039),
    [sym__line_break] = ACTIONS(6191),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_end] = ACTIONS(6191),
    [anon_sym_if] = ACTIONS(6191),
    [anon_sym_unless] = ACTIONS(6191),
    [anon_sym_while] = ACTIONS(6191),
    [anon_sym_until] = ACTIONS(6191),
    [anon_sym_rescue] = ACTIONS(6191),
    [anon_sym_when] = ACTIONS(6191),
    [anon_sym_else] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [11263] = {
    [sym__line_break] = ACTIONS(6210),
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(14919),
    [sym__binary_star] = ACTIONS(14921),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(14923),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(14921),
    [anon_sym_AMP] = ACTIONS(14925),
    [anon_sym_LT] = ACTIONS(14927),
    [anon_sym_end] = ACTIONS(6210),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_unless] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_until] = ACTIONS(6210),
    [anon_sym_rescue] = ACTIONS(6210),
    [anon_sym_when] = ACTIONS(6210),
    [anon_sym_else] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(14929),
    [anon_sym_DOT_DOT] = ACTIONS(14931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14933),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(14935),
    [anon_sym_AMP_AMP] = ACTIONS(14935),
    [anon_sym_LT_LT] = ACTIONS(14937),
    [anon_sym_GT_GT] = ACTIONS(14937),
    [anon_sym_EQ_EQ] = ACTIONS(14939),
    [anon_sym_BANG_EQ] = ACTIONS(14935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14935),
    [anon_sym_LT_EQ_GT] = ACTIONS(14935),
    [anon_sym_EQ_TILDE] = ACTIONS(14935),
    [anon_sym_BANG_TILDE] = ACTIONS(14935),
    [anon_sym_LT_EQ] = ACTIONS(14927),
    [anon_sym_GT] = ACTIONS(14927),
    [anon_sym_GT_EQ] = ACTIONS(14941),
    [anon_sym_CARET] = ACTIONS(14943),
    [anon_sym_PLUS] = ACTIONS(14919),
    [anon_sym_SLASH] = ACTIONS(14921),
    [anon_sym_PERCENT] = ACTIONS(14921),
    [sym_comment] = ACTIONS(87),
  },
  [11264] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(13397),
    [sym__binary_star] = ACTIONS(13399),
    [anon_sym_LBRACE] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(13401),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(13403),
    [anon_sym_AMP] = ACTIONS(13405),
    [anon_sym_EQ] = ACTIONS(12879),
    [anon_sym_LT] = ACTIONS(13407),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_then] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_PLUS_EQ] = ACTIONS(12120),
    [anon_sym_DASH_EQ] = ACTIONS(12120),
    [anon_sym_STAR_EQ] = ACTIONS(12120),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12120),
    [anon_sym_SLASH_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12120),
    [anon_sym_AMP_EQ] = ACTIONS(12120),
    [anon_sym_PERCENT_EQ] = ACTIONS(12120),
    [anon_sym_GT_GT_EQ] = ACTIONS(12120),
    [anon_sym_LT_LT_EQ] = ACTIONS(12120),
    [anon_sym_CARET_EQ] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(13409),
    [anon_sym_DOT_DOT] = ACTIONS(13411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13413),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(13415),
    [anon_sym_AMP_AMP] = ACTIONS(13415),
    [anon_sym_LT_LT] = ACTIONS(13417),
    [anon_sym_GT_GT] = ACTIONS(13417),
    [anon_sym_EQ_EQ] = ACTIONS(13415),
    [anon_sym_BANG_EQ] = ACTIONS(13419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13419),
    [anon_sym_LT_EQ_GT] = ACTIONS(13419),
    [anon_sym_EQ_TILDE] = ACTIONS(13419),
    [anon_sym_BANG_TILDE] = ACTIONS(13419),
    [anon_sym_LT_EQ] = ACTIONS(13407),
    [anon_sym_GT] = ACTIONS(13407),
    [anon_sym_GT_EQ] = ACTIONS(13421),
    [anon_sym_CARET] = ACTIONS(13401),
    [anon_sym_PLUS] = ACTIONS(13423),
    [anon_sym_SLASH] = ACTIONS(13403),
    [anon_sym_PERCENT] = ACTIONS(13403),
    [sym_comment] = ACTIONS(87),
  },
  [11265] = {
    [aux_sym_exceptions_repeat1] = STATE(11265),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(15313),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_then] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_PLUS_EQ] = ACTIONS(11597),
    [anon_sym_DASH_EQ] = ACTIONS(11597),
    [anon_sym_STAR_EQ] = ACTIONS(11597),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11597),
    [anon_sym_SLASH_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11597),
    [anon_sym_AMP_EQ] = ACTIONS(11597),
    [anon_sym_PERCENT_EQ] = ACTIONS(11597),
    [anon_sym_GT_GT_EQ] = ACTIONS(11597),
    [anon_sym_LT_LT_EQ] = ACTIONS(11597),
    [anon_sym_CARET_EQ] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_LT] = ACTIONS(12338),
    [anon_sym_GT_GT] = ACTIONS(12338),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(12338),
    [anon_sym_PLUS] = ACTIONS(12338),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [11266] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(13462),
    [sym__binary_star] = ACTIONS(13464),
    [anon_sym_LBRACE] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(13466),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(13464),
    [anon_sym_AMP] = ACTIONS(13468),
    [anon_sym_LT] = ACTIONS(13470),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_then] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(13472),
    [anon_sym_DOT_DOT] = ACTIONS(13474),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13476),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(13480),
    [anon_sym_AMP_AMP] = ACTIONS(13480),
    [anon_sym_LT_LT] = ACTIONS(13482),
    [anon_sym_GT_GT] = ACTIONS(13482),
    [anon_sym_EQ_EQ] = ACTIONS(13484),
    [anon_sym_BANG_EQ] = ACTIONS(13480),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13480),
    [anon_sym_LT_EQ_GT] = ACTIONS(13480),
    [anon_sym_EQ_TILDE] = ACTIONS(13480),
    [anon_sym_BANG_TILDE] = ACTIONS(13480),
    [anon_sym_LT_EQ] = ACTIONS(13470),
    [anon_sym_GT] = ACTIONS(13470),
    [anon_sym_GT_EQ] = ACTIONS(13486),
    [anon_sym_CARET] = ACTIONS(13488),
    [anon_sym_PLUS] = ACTIONS(13462),
    [anon_sym_SLASH] = ACTIONS(13464),
    [anon_sym_PERCENT] = ACTIONS(13464),
    [sym_comment] = ACTIONS(87),
  },
  [11267] = {
    [aux_sym_exceptions_repeat1] = STATE(11267),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(15316),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_then] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [11268] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(15009),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(15009),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(15009),
    [anon_sym_PERCENT] = ACTIONS(15009),
    [sym_comment] = ACTIONS(87),
  },
  [11269] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(15009),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(5825),
    [anon_sym_PERCENT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(87),
  },
  [11270] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(15007),
    [sym__binary_star] = ACTIONS(15009),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(15009),
    [anon_sym_AMP] = ACTIONS(15013),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(15025),
    [anon_sym_GT_GT] = ACTIONS(15025),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(15007),
    [anon_sym_SLASH] = ACTIONS(15009),
    [anon_sym_PERCENT] = ACTIONS(15009),
    [sym_comment] = ACTIONS(87),
  },
  [11271] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(15007),
    [sym__binary_star] = ACTIONS(15009),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(15009),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(15025),
    [anon_sym_GT_GT] = ACTIONS(15025),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(15007),
    [anon_sym_SLASH] = ACTIONS(15009),
    [anon_sym_PERCENT] = ACTIONS(15009),
    [sym_comment] = ACTIONS(87),
  },
  [11272] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(15007),
    [sym__binary_star] = ACTIONS(15009),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(15011),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(15009),
    [anon_sym_AMP] = ACTIONS(15013),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(15025),
    [anon_sym_GT_GT] = ACTIONS(15025),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(15031),
    [anon_sym_PLUS] = ACTIONS(15007),
    [anon_sym_SLASH] = ACTIONS(15009),
    [anon_sym_PERCENT] = ACTIONS(15009),
    [sym_comment] = ACTIONS(87),
  },
  [11273] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(15319),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [11274] = {
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(15007),
    [sym__binary_star] = ACTIONS(15009),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(15011),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(15009),
    [anon_sym_AMP] = ACTIONS(15013),
    [anon_sym_LT] = ACTIONS(15015),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(15019),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15021),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(15023),
    [anon_sym_AMP_AMP] = ACTIONS(15023),
    [anon_sym_LT_LT] = ACTIONS(15025),
    [anon_sym_GT_GT] = ACTIONS(15025),
    [anon_sym_EQ_EQ] = ACTIONS(15027),
    [anon_sym_BANG_EQ] = ACTIONS(15023),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15023),
    [anon_sym_LT_EQ_GT] = ACTIONS(15023),
    [anon_sym_EQ_TILDE] = ACTIONS(15023),
    [anon_sym_BANG_TILDE] = ACTIONS(15023),
    [anon_sym_LT_EQ] = ACTIONS(15015),
    [anon_sym_GT] = ACTIONS(15015),
    [anon_sym_GT_EQ] = ACTIONS(15029),
    [anon_sym_CARET] = ACTIONS(15031),
    [anon_sym_PLUS] = ACTIONS(15007),
    [anon_sym_SLASH] = ACTIONS(15009),
    [anon_sym_PERCENT] = ACTIONS(15009),
    [sym_comment] = ACTIONS(87),
  },
  [11275] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(15007),
    [sym__binary_star] = ACTIONS(15009),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(15011),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(15009),
    [anon_sym_AMP] = ACTIONS(15013),
    [anon_sym_LT] = ACTIONS(15015),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(15017),
    [anon_sym_DOT_DOT] = ACTIONS(15019),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15021),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(15023),
    [anon_sym_AMP_AMP] = ACTIONS(15023),
    [anon_sym_LT_LT] = ACTIONS(15025),
    [anon_sym_GT_GT] = ACTIONS(15025),
    [anon_sym_EQ_EQ] = ACTIONS(15027),
    [anon_sym_BANG_EQ] = ACTIONS(15023),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15023),
    [anon_sym_LT_EQ_GT] = ACTIONS(15023),
    [anon_sym_EQ_TILDE] = ACTIONS(15023),
    [anon_sym_BANG_TILDE] = ACTIONS(15023),
    [anon_sym_LT_EQ] = ACTIONS(15015),
    [anon_sym_GT] = ACTIONS(15015),
    [anon_sym_GT_EQ] = ACTIONS(15029),
    [anon_sym_CARET] = ACTIONS(15031),
    [anon_sym_PLUS] = ACTIONS(15007),
    [anon_sym_SLASH] = ACTIONS(15009),
    [anon_sym_PERCENT] = ACTIONS(15009),
    [sym_comment] = ACTIONS(87),
  },
  [11276] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(15007),
    [sym__binary_star] = ACTIONS(15009),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(15011),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(15009),
    [anon_sym_AMP] = ACTIONS(15013),
    [anon_sym_LT] = ACTIONS(15015),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(15025),
    [anon_sym_GT_GT] = ACTIONS(15025),
    [anon_sym_EQ_EQ] = ACTIONS(15027),
    [anon_sym_BANG_EQ] = ACTIONS(15023),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15023),
    [anon_sym_LT_EQ_GT] = ACTIONS(15023),
    [anon_sym_EQ_TILDE] = ACTIONS(15023),
    [anon_sym_BANG_TILDE] = ACTIONS(15023),
    [anon_sym_LT_EQ] = ACTIONS(15015),
    [anon_sym_GT] = ACTIONS(15015),
    [anon_sym_GT_EQ] = ACTIONS(15029),
    [anon_sym_CARET] = ACTIONS(15031),
    [anon_sym_PLUS] = ACTIONS(15007),
    [anon_sym_SLASH] = ACTIONS(15009),
    [anon_sym_PERCENT] = ACTIONS(15009),
    [sym_comment] = ACTIONS(87),
  },
  [11277] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(15007),
    [sym__binary_star] = ACTIONS(15009),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(15009),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_LT_LT] = ACTIONS(5825),
    [anon_sym_GT_GT] = ACTIONS(5825),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5825),
    [anon_sym_PLUS] = ACTIONS(15007),
    [anon_sym_SLASH] = ACTIONS(15009),
    [anon_sym_PERCENT] = ACTIONS(15009),
    [sym_comment] = ACTIONS(87),
  },
  [11278] = {
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(15007),
    [sym__binary_star] = ACTIONS(15009),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(15011),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(15009),
    [anon_sym_AMP] = ACTIONS(15013),
    [anon_sym_LT] = ACTIONS(15015),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(15017),
    [anon_sym_DOT_DOT] = ACTIONS(15019),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15021),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(15023),
    [anon_sym_AMP_AMP] = ACTIONS(15023),
    [anon_sym_LT_LT] = ACTIONS(15025),
    [anon_sym_GT_GT] = ACTIONS(15025),
    [anon_sym_EQ_EQ] = ACTIONS(15027),
    [anon_sym_BANG_EQ] = ACTIONS(15023),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15023),
    [anon_sym_LT_EQ_GT] = ACTIONS(15023),
    [anon_sym_EQ_TILDE] = ACTIONS(15023),
    [anon_sym_BANG_TILDE] = ACTIONS(15023),
    [anon_sym_LT_EQ] = ACTIONS(15015),
    [anon_sym_GT] = ACTIONS(15015),
    [anon_sym_GT_EQ] = ACTIONS(15029),
    [anon_sym_CARET] = ACTIONS(15031),
    [anon_sym_PLUS] = ACTIONS(15007),
    [anon_sym_SLASH] = ACTIONS(15009),
    [anon_sym_PERCENT] = ACTIONS(15009),
    [sym_comment] = ACTIONS(87),
  },
  [11279] = {
    [aux_sym_exceptions_repeat1] = STATE(11334),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(87),
  },
  [11280] = {
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(15007),
    [sym__binary_star] = ACTIONS(15009),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(15011),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(15009),
    [anon_sym_AMP] = ACTIONS(15013),
    [anon_sym_LT] = ACTIONS(15015),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(15017),
    [anon_sym_DOT_DOT] = ACTIONS(15019),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15021),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(15023),
    [anon_sym_AMP_AMP] = ACTIONS(15023),
    [anon_sym_LT_LT] = ACTIONS(15025),
    [anon_sym_GT_GT] = ACTIONS(15025),
    [anon_sym_EQ_EQ] = ACTIONS(15027),
    [anon_sym_BANG_EQ] = ACTIONS(15023),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15023),
    [anon_sym_LT_EQ_GT] = ACTIONS(15023),
    [anon_sym_EQ_TILDE] = ACTIONS(15023),
    [anon_sym_BANG_TILDE] = ACTIONS(15023),
    [anon_sym_LT_EQ] = ACTIONS(15015),
    [anon_sym_GT] = ACTIONS(15015),
    [anon_sym_GT_EQ] = ACTIONS(15029),
    [anon_sym_CARET] = ACTIONS(15031),
    [anon_sym_PLUS] = ACTIONS(15007),
    [anon_sym_SLASH] = ACTIONS(15009),
    [anon_sym_PERCENT] = ACTIONS(15009),
    [sym_comment] = ACTIONS(87),
  },
  [11281] = {
    [sym_string] = STATE(11281),
    [aux_sym_chained_string_repeat1] = STATE(11281),
    [sym__string_start] = ACTIONS(9407),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_LT_LT] = ACTIONS(6212),
    [anon_sym_GT_GT] = ACTIONS(6212),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [11282] = {
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(14460),
    [sym__binary_star] = ACTIONS(14462),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(14464),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(14462),
    [anon_sym_AMP] = ACTIONS(14466),
    [anon_sym_LT] = ACTIONS(14468),
    [anon_sym_EQ_GT] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(14470),
    [anon_sym_DOT_DOT] = ACTIONS(14472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14474),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(14476),
    [anon_sym_AMP_AMP] = ACTIONS(14476),
    [anon_sym_LT_LT] = ACTIONS(14478),
    [anon_sym_GT_GT] = ACTIONS(14478),
    [anon_sym_EQ_EQ] = ACTIONS(14480),
    [anon_sym_BANG_EQ] = ACTIONS(14476),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14476),
    [anon_sym_LT_EQ_GT] = ACTIONS(14476),
    [anon_sym_EQ_TILDE] = ACTIONS(14476),
    [anon_sym_BANG_TILDE] = ACTIONS(14476),
    [anon_sym_LT_EQ] = ACTIONS(14468),
    [anon_sym_GT] = ACTIONS(14468),
    [anon_sym_GT_EQ] = ACTIONS(14482),
    [anon_sym_CARET] = ACTIONS(14484),
    [anon_sym_PLUS] = ACTIONS(14460),
    [anon_sym_SLASH] = ACTIONS(14462),
    [anon_sym_PERCENT] = ACTIONS(14462),
    [sym_comment] = ACTIONS(87),
  },
  [11283] = {
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(14460),
    [sym__binary_star] = ACTIONS(14462),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(14464),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(14462),
    [anon_sym_AMP] = ACTIONS(14466),
    [anon_sym_LT] = ACTIONS(14468),
    [anon_sym_EQ_GT] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(14470),
    [anon_sym_DOT_DOT] = ACTIONS(14472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14474),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(14476),
    [anon_sym_AMP_AMP] = ACTIONS(14476),
    [anon_sym_LT_LT] = ACTIONS(14478),
    [anon_sym_GT_GT] = ACTIONS(14478),
    [anon_sym_EQ_EQ] = ACTIONS(14480),
    [anon_sym_BANG_EQ] = ACTIONS(14476),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14476),
    [anon_sym_LT_EQ_GT] = ACTIONS(14476),
    [anon_sym_EQ_TILDE] = ACTIONS(14476),
    [anon_sym_BANG_TILDE] = ACTIONS(14476),
    [anon_sym_LT_EQ] = ACTIONS(14468),
    [anon_sym_GT] = ACTIONS(14468),
    [anon_sym_GT_EQ] = ACTIONS(14482),
    [anon_sym_CARET] = ACTIONS(14484),
    [anon_sym_PLUS] = ACTIONS(14460),
    [anon_sym_SLASH] = ACTIONS(14462),
    [anon_sym_PERCENT] = ACTIONS(14462),
    [sym_comment] = ACTIONS(87),
  },
  [11284] = {
    [sym_heredoc_body] = STATE(11284),
    [aux_sym_call_repeat1] = STATE(11284),
    [sym__heredoc_body_start] = ACTIONS(10455),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_EQ_GT] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [11285] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(10721),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(9932),
    [sym_scope_resolution] = STATE(9928),
    [sym_call] = STATE(9928),
    [sym_method_call] = STATE(9932),
    [sym__argument] = STATE(6908),
    [sym_splat_argument] = STATE(6908),
    [sym_hash_splat_argument] = STATE(6908),
    [sym_block_argument] = STATE(6908),
    [sym_assignment] = STATE(10721),
    [sym_operator_assignment] = STATE(10721),
    [sym_conditional] = STATE(10721),
    [sym_range] = STATE(10721),
    [sym_binary] = STATE(10721),
    [sym_unary] = STATE(10721),
    [sym_left_assignment_list] = STATE(9931),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9932),
    [sym__variable] = STATE(9928),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(9932),
    [sym_false] = STATE(9932),
    [sym_nil] = STATE(9932),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(10724),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_pair] = STATE(6908),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(14450),
    [sym__splat_star] = ACTIONS(14452),
    [sym__unary_minus] = ACTIONS(13605),
    [sym__identifier_hash_key] = ACTIONS(14454),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(15235),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13609),
    [anon_sym_yield] = ACTIONS(13611),
    [anon_sym_break] = ACTIONS(13613),
    [anon_sym_next] = ACTIONS(13615),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14446),
    [anon_sym_defined_QMARK] = ACTIONS(13617),
    [anon_sym_not] = ACTIONS(13619),
    [anon_sym_BANG] = ACTIONS(13623),
    [anon_sym_TILDE] = ACTIONS(13623),
    [sym_constant] = ACTIONS(14456),
    [sym_identifier] = ACTIONS(14456),
    [sym_instance_variable] = ACTIONS(13627),
    [sym_class_variable] = ACTIONS(13627),
    [sym_global_variable] = ACTIONS(13627),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13629),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13629),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11286] = {
    [sym_heredoc_body] = STATE(11284),
    [aux_sym_call_repeat1] = STATE(11284),
    [sym__heredoc_body_start] = ACTIONS(3397),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_EQ_GT] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [11287] = {
    [aux_sym_argument_list_repeat1] = STATE(11287),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(15321),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7925),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_EQ_GT] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7925),
    [anon_sym_AMP_AMP] = ACTIONS(7925),
    [anon_sym_LT_LT] = ACTIONS(7925),
    [anon_sym_GT_GT] = ACTIONS(7925),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7925),
    [anon_sym_PLUS] = ACTIONS(7925),
    [anon_sym_SLASH] = ACTIONS(7925),
    [anon_sym_PERCENT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(87),
  },
  [11288] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(11335),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(9932),
    [sym_scope_resolution] = STATE(9928),
    [sym_call] = STATE(9928),
    [sym_method_call] = STATE(9932),
    [sym_assignment] = STATE(11335),
    [sym_operator_assignment] = STATE(11335),
    [sym_conditional] = STATE(11335),
    [sym_range] = STATE(11335),
    [sym_binary] = STATE(11335),
    [sym_unary] = STATE(11335),
    [sym_left_assignment_list] = STATE(9931),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9932),
    [sym__variable] = STATE(9928),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(9932),
    [sym_false] = STATE(9932),
    [sym_nil] = STATE(9932),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(10713),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(13605),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13609),
    [anon_sym_yield] = ACTIONS(13611),
    [anon_sym_break] = ACTIONS(13613),
    [anon_sym_next] = ACTIONS(13615),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14446),
    [anon_sym_defined_QMARK] = ACTIONS(13617),
    [anon_sym_not] = ACTIONS(13619),
    [anon_sym_BANG] = ACTIONS(13623),
    [anon_sym_TILDE] = ACTIONS(13623),
    [sym_constant] = ACTIONS(13629),
    [sym_identifier] = ACTIONS(13629),
    [sym_instance_variable] = ACTIONS(13627),
    [sym_class_variable] = ACTIONS(13627),
    [sym_global_variable] = ACTIONS(13627),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13629),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13629),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11289] = {
    [sym__heredoc_body_start] = ACTIONS(6823),
    [sym__binary_minus] = ACTIONS(14534),
    [sym__binary_star] = ACTIONS(14536),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(14538),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_STAR_STAR] = ACTIONS(14540),
    [anon_sym_AMP] = ACTIONS(14542),
    [anon_sym_EQ] = ACTIONS(7822),
    [anon_sym_LT] = ACTIONS(14544),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_EQ_GT] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_COLON_COLON2] = ACTIONS(6823),
    [anon_sym_AMP_DOT] = ACTIONS(6823),
    [anon_sym_PLUS_EQ] = ACTIONS(6823),
    [anon_sym_DASH_EQ] = ACTIONS(6823),
    [anon_sym_STAR_EQ] = ACTIONS(6823),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6823),
    [anon_sym_SLASH_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_PIPE_EQ] = ACTIONS(6823),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6823),
    [anon_sym_AMP_EQ] = ACTIONS(6823),
    [anon_sym_PERCENT_EQ] = ACTIONS(6823),
    [anon_sym_GT_GT_EQ] = ACTIONS(6823),
    [anon_sym_LT_LT_EQ] = ACTIONS(6823),
    [anon_sym_CARET_EQ] = ACTIONS(6823),
    [anon_sym_QMARK] = ACTIONS(14546),
    [anon_sym_DOT_DOT] = ACTIONS(14548),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14550),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_or] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(14552),
    [anon_sym_AMP_AMP] = ACTIONS(14552),
    [anon_sym_LT_LT] = ACTIONS(14554),
    [anon_sym_GT_GT] = ACTIONS(14554),
    [anon_sym_EQ_EQ] = ACTIONS(14552),
    [anon_sym_BANG_EQ] = ACTIONS(14556),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14556),
    [anon_sym_LT_EQ_GT] = ACTIONS(14556),
    [anon_sym_EQ_TILDE] = ACTIONS(14556),
    [anon_sym_BANG_TILDE] = ACTIONS(14556),
    [anon_sym_LT_EQ] = ACTIONS(14544),
    [anon_sym_GT] = ACTIONS(14544),
    [anon_sym_GT_EQ] = ACTIONS(14558),
    [anon_sym_CARET] = ACTIONS(14538),
    [anon_sym_PLUS] = ACTIONS(14560),
    [anon_sym_SLASH] = ACTIONS(14540),
    [anon_sym_PERCENT] = ACTIONS(14540),
    [sym_comment] = ACTIONS(87),
  },
  [11290] = {
    [sym__heredoc_body_start] = ACTIONS(7027),
    [sym__binary_minus] = ACTIONS(14534),
    [sym__binary_star] = ACTIONS(14536),
    [anon_sym_LBRACE] = ACTIONS(7027),
    [anon_sym_DOT] = ACTIONS(7884),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_PIPE] = ACTIONS(14538),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(14540),
    [anon_sym_AMP] = ACTIONS(14542),
    [anon_sym_EQ] = ACTIONS(7884),
    [anon_sym_LT] = ACTIONS(14544),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_EQ_GT] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(7027),
    [anon_sym_COLON_COLON2] = ACTIONS(7027),
    [anon_sym_AMP_DOT] = ACTIONS(7027),
    [anon_sym_PLUS_EQ] = ACTIONS(7027),
    [anon_sym_DASH_EQ] = ACTIONS(7027),
    [anon_sym_STAR_EQ] = ACTIONS(7027),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7027),
    [anon_sym_SLASH_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_PIPE_EQ] = ACTIONS(7027),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7027),
    [anon_sym_AMP_EQ] = ACTIONS(7027),
    [anon_sym_PERCENT_EQ] = ACTIONS(7027),
    [anon_sym_GT_GT_EQ] = ACTIONS(7027),
    [anon_sym_LT_LT_EQ] = ACTIONS(7027),
    [anon_sym_CARET_EQ] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(14546),
    [anon_sym_DOT_DOT] = ACTIONS(14548),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14550),
    [anon_sym_and] = ACTIONS(7027),
    [anon_sym_or] = ACTIONS(7027),
    [anon_sym_PIPE_PIPE] = ACTIONS(14552),
    [anon_sym_AMP_AMP] = ACTIONS(14552),
    [anon_sym_LT_LT] = ACTIONS(14554),
    [anon_sym_GT_GT] = ACTIONS(14554),
    [anon_sym_EQ_EQ] = ACTIONS(14552),
    [anon_sym_BANG_EQ] = ACTIONS(14556),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14556),
    [anon_sym_LT_EQ_GT] = ACTIONS(14556),
    [anon_sym_EQ_TILDE] = ACTIONS(14556),
    [anon_sym_BANG_TILDE] = ACTIONS(14556),
    [anon_sym_LT_EQ] = ACTIONS(14544),
    [anon_sym_GT] = ACTIONS(14544),
    [anon_sym_GT_EQ] = ACTIONS(14558),
    [anon_sym_CARET] = ACTIONS(14538),
    [anon_sym_PLUS] = ACTIONS(14560),
    [anon_sym_SLASH] = ACTIONS(14540),
    [anon_sym_PERCENT] = ACTIONS(14540),
    [sym_comment] = ACTIONS(87),
  },
  [11291] = {
    [sym_heredoc_body] = STATE(11291),
    [aux_sym_call_repeat1] = STATE(11291),
    [sym__heredoc_body_start] = ACTIONS(10553),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7919),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_EQ] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_do] = ACTIONS(7914),
    [anon_sym_EQ_GT] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_PLUS_EQ] = ACTIONS(7914),
    [anon_sym_DASH_EQ] = ACTIONS(7914),
    [anon_sym_STAR_EQ] = ACTIONS(7914),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7914),
    [anon_sym_SLASH_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_PIPE_EQ] = ACTIONS(7914),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7914),
    [anon_sym_AMP_EQ] = ACTIONS(7914),
    [anon_sym_PERCENT_EQ] = ACTIONS(7914),
    [anon_sym_GT_GT_EQ] = ACTIONS(7914),
    [anon_sym_LT_LT_EQ] = ACTIONS(7914),
    [anon_sym_CARET_EQ] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7919),
    [anon_sym_AMP_AMP] = ACTIONS(7919),
    [anon_sym_LT_LT] = ACTIONS(7919),
    [anon_sym_GT_GT] = ACTIONS(7919),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7919),
    [anon_sym_PLUS] = ACTIONS(7919),
    [anon_sym_SLASH] = ACTIONS(7919),
    [anon_sym_PERCENT] = ACTIONS(7919),
    [sym_comment] = ACTIONS(87),
  },
  [11292] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(10742),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9962),
    [sym_scope_resolution] = STATE(9958),
    [sym_call] = STATE(9958),
    [sym_method_call] = STATE(9962),
    [sym__argument] = STATE(6970),
    [sym_splat_argument] = STATE(6970),
    [sym_hash_splat_argument] = STATE(6970),
    [sym_block_argument] = STATE(6970),
    [sym_assignment] = STATE(10742),
    [sym_operator_assignment] = STATE(10742),
    [sym_conditional] = STATE(10742),
    [sym_range] = STATE(10742),
    [sym_binary] = STATE(10742),
    [sym_unary] = STATE(10742),
    [sym_left_assignment_list] = STATE(9961),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9962),
    [sym__variable] = STATE(9958),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9962),
    [sym_false] = STATE(9962),
    [sym_nil] = STATE(9962),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10745),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(6970),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(14486),
    [sym__splat_star] = ACTIONS(14488),
    [sym__unary_minus] = ACTIONS(13663),
    [sym__identifier_hash_key] = ACTIONS(14490),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(15239),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13667),
    [anon_sym_yield] = ACTIONS(13669),
    [anon_sym_break] = ACTIONS(13671),
    [anon_sym_next] = ACTIONS(13673),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(14528),
    [anon_sym_defined_QMARK] = ACTIONS(13675),
    [anon_sym_not] = ACTIONS(13677),
    [anon_sym_BANG] = ACTIONS(13681),
    [anon_sym_TILDE] = ACTIONS(13681),
    [sym_constant] = ACTIONS(14492),
    [sym_identifier] = ACTIONS(14492),
    [sym_instance_variable] = ACTIONS(13685),
    [sym_class_variable] = ACTIONS(13685),
    [sym_global_variable] = ACTIONS(13685),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13687),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13687),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [11293] = {
    [sym_heredoc_body] = STATE(11291),
    [aux_sym_call_repeat1] = STATE(11291),
    [sym__heredoc_body_start] = ACTIONS(3543),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_LBRACE] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7931),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_EQ] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_do] = ACTIONS(7929),
    [anon_sym_EQ_GT] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_PLUS_EQ] = ACTIONS(7929),
    [anon_sym_DASH_EQ] = ACTIONS(7929),
    [anon_sym_STAR_EQ] = ACTIONS(7929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7929),
    [anon_sym_SLASH_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7929),
    [anon_sym_AMP_EQ] = ACTIONS(7929),
    [anon_sym_PERCENT_EQ] = ACTIONS(7929),
    [anon_sym_GT_GT_EQ] = ACTIONS(7929),
    [anon_sym_LT_LT_EQ] = ACTIONS(7929),
    [anon_sym_CARET_EQ] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7931),
    [anon_sym_AMP_AMP] = ACTIONS(7931),
    [anon_sym_LT_LT] = ACTIONS(7931),
    [anon_sym_GT_GT] = ACTIONS(7931),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7931),
    [anon_sym_PLUS] = ACTIONS(7931),
    [anon_sym_SLASH] = ACTIONS(7931),
    [anon_sym_PERCENT] = ACTIONS(7931),
    [sym_comment] = ACTIONS(87),
  },
  [11294] = {
    [aux_sym_argument_list_repeat1] = STATE(11294),
    [sym__heredoc_body_start] = ACTIONS(7925),
    [sym__binary_minus] = ACTIONS(7925),
    [sym__binary_star] = ACTIONS(7925),
    [anon_sym_LBRACE] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_COMMA] = ACTIONS(15324),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym_STAR_STAR] = ACTIONS(7927),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_EQ] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_do] = ACTIONS(7925),
    [anon_sym_EQ_GT] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_COLON_COLON2] = ACTIONS(7925),
    [anon_sym_AMP_DOT] = ACTIONS(7925),
    [anon_sym_PLUS_EQ] = ACTIONS(7925),
    [anon_sym_DASH_EQ] = ACTIONS(7925),
    [anon_sym_STAR_EQ] = ACTIONS(7925),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7925),
    [anon_sym_SLASH_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7925),
    [anon_sym_AMP_EQ] = ACTIONS(7925),
    [anon_sym_PERCENT_EQ] = ACTIONS(7925),
    [anon_sym_GT_GT_EQ] = ACTIONS(7925),
    [anon_sym_LT_LT_EQ] = ACTIONS(7925),
    [anon_sym_CARET_EQ] = ACTIONS(7925),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_DOT_DOT] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_and] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7927),
    [anon_sym_AMP_AMP] = ACTIONS(7927),
    [anon_sym_LT_LT] = ACTIONS(7927),
    [anon_sym_GT_GT] = ACTIONS(7927),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_EQ_TILDE] = ACTIONS(7925),
    [anon_sym_BANG_TILDE] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_CARET] = ACTIONS(7927),
    [anon_sym_PLUS] = ACTIONS(7927),
    [anon_sym_SLASH] = ACTIONS(7927),
    [anon_sym_PERCENT] = ACTIONS(7927),
    [sym_comment] = ACTIONS(87),
  },
  [11295] = {
    [sym_method] = STATE(347),
    [sym_singleton_method] = STATE(347),
    [sym_class] = STATE(347),
    [sym_singleton_class] = STATE(347),
    [sym_module] = STATE(347),
    [sym_return] = STATE(347),
    [sym_yield] = STATE(347),
    [sym_break] = STATE(347),
    [sym_next] = STATE(347),
    [sym_while] = STATE(347),
    [sym_until] = STATE(347),
    [sym_for] = STATE(347),
    [sym_case] = STATE(347),
    [sym_if] = STATE(347),
    [sym_unless] = STATE(347),
    [sym_begin] = STATE(347),
    [sym__arg] = STATE(11117),
    [sym__primary] = STATE(347),
    [sym_parenthesized_statements] = STATE(347),
    [sym_element_reference] = STATE(9932),
    [sym_scope_resolution] = STATE(9928),
    [sym_call] = STATE(9928),
    [sym_method_call] = STATE(9932),
    [sym_splat_argument] = STATE(9013),
    [sym_assignment] = STATE(11117),
    [sym_operator_assignment] = STATE(11117),
    [sym_conditional] = STATE(11117),
    [sym_range] = STATE(11117),
    [sym_binary] = STATE(11117),
    [sym_unary] = STATE(11117),
    [sym__arg_or_splat_arg] = STATE(9013),
    [sym_left_assignment_list] = STATE(9931),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9932),
    [sym__variable] = STATE(9928),
    [sym_rational] = STATE(347),
    [sym_true] = STATE(9932),
    [sym_false] = STATE(9932),
    [sym_nil] = STATE(9932),
    [sym_chained_string] = STATE(347),
    [sym_string] = STATE(10713),
    [sym_subshell] = STATE(347),
    [sym_string_array] = STATE(347),
    [sym_symbol_array] = STATE(347),
    [sym_symbol] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_array] = STATE(347),
    [sym_hash] = STATE(347),
    [sym_lambda] = STATE(347),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(14452),
    [sym__unary_minus] = ACTIONS(13605),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13609),
    [anon_sym_yield] = ACTIONS(13611),
    [anon_sym_break] = ACTIONS(13613),
    [anon_sym_next] = ACTIONS(13615),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14446),
    [anon_sym_defined_QMARK] = ACTIONS(13617),
    [anon_sym_not] = ACTIONS(13619),
    [anon_sym_BANG] = ACTIONS(13623),
    [anon_sym_TILDE] = ACTIONS(13623),
    [sym_constant] = ACTIONS(13629),
    [sym_identifier] = ACTIONS(13629),
    [sym_instance_variable] = ACTIONS(13627),
    [sym_class_variable] = ACTIONS(13627),
    [sym_global_variable] = ACTIONS(13627),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13629),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13629),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11296] = {
    [aux_sym_exceptions_repeat1] = STATE(11336),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(15327),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_EQ_GT] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [11297] = {
    [sym__binary_minus] = ACTIONS(13631),
    [sym__binary_star] = ACTIONS(13633),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(14504),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(13633),
    [anon_sym_AMP] = ACTIONS(13637),
    [anon_sym_LT] = ACTIONS(13639),
    [anon_sym_QMARK] = ACTIONS(13641),
    [anon_sym_DOT_DOT] = ACTIONS(13643),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13645),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(13649),
    [anon_sym_AMP_AMP] = ACTIONS(13649),
    [anon_sym_LT_LT] = ACTIONS(13651),
    [anon_sym_GT_GT] = ACTIONS(13651),
    [anon_sym_EQ_EQ] = ACTIONS(13653),
    [anon_sym_BANG_EQ] = ACTIONS(13649),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13649),
    [anon_sym_LT_EQ_GT] = ACTIONS(13649),
    [anon_sym_EQ_TILDE] = ACTIONS(13649),
    [anon_sym_BANG_TILDE] = ACTIONS(13649),
    [anon_sym_LT_EQ] = ACTIONS(13639),
    [anon_sym_GT] = ACTIONS(13639),
    [anon_sym_GT_EQ] = ACTIONS(13655),
    [anon_sym_CARET] = ACTIONS(13657),
    [anon_sym_PLUS] = ACTIONS(13631),
    [anon_sym_SLASH] = ACTIONS(13633),
    [anon_sym_PERCENT] = ACTIONS(13633),
    [sym_comment] = ACTIONS(87),
  },
  [11298] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(15061),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(15065),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(15065),
    [anon_sym_PERCENT] = ACTIONS(15065),
    [sym_comment] = ACTIONS(87),
  },
  [11299] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(5825),
    [sym__binary_star] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(15065),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(5827),
    [anon_sym_SLASH] = ACTIONS(5827),
    [anon_sym_PERCENT] = ACTIONS(5827),
    [sym_comment] = ACTIONS(87),
  },
  [11300] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(15059),
    [sym__binary_star] = ACTIONS(15061),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(15065),
    [anon_sym_AMP] = ACTIONS(15067),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(15079),
    [anon_sym_GT_GT] = ACTIONS(15079),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(15085),
    [anon_sym_SLASH] = ACTIONS(15065),
    [anon_sym_PERCENT] = ACTIONS(15065),
    [sym_comment] = ACTIONS(87),
  },
  [11301] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(15059),
    [sym__binary_star] = ACTIONS(15061),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(15065),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(15079),
    [anon_sym_GT_GT] = ACTIONS(15079),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(15085),
    [anon_sym_SLASH] = ACTIONS(15065),
    [anon_sym_PERCENT] = ACTIONS(15065),
    [sym_comment] = ACTIONS(87),
  },
  [11302] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(15059),
    [sym__binary_star] = ACTIONS(15061),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(15063),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(15065),
    [anon_sym_AMP] = ACTIONS(15067),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(15079),
    [anon_sym_GT_GT] = ACTIONS(15079),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(15063),
    [anon_sym_PLUS] = ACTIONS(15085),
    [anon_sym_SLASH] = ACTIONS(15065),
    [anon_sym_PERCENT] = ACTIONS(15065),
    [sym_comment] = ACTIONS(87),
  },
  [11303] = {
    [sym__binary_minus] = ACTIONS(5861),
    [sym__binary_star] = ACTIONS(5863),
    [anon_sym_PIPE] = ACTIONS(5865),
    [anon_sym_STAR_STAR] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_COLON2] = ACTIONS(15329),
    [anon_sym_DOT_DOT] = ACTIONS(5875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5877),
    [anon_sym_and] = ACTIONS(5879),
    [anon_sym_or] = ACTIONS(5879),
    [anon_sym_PIPE_PIPE] = ACTIONS(5881),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_LT_LT] = ACTIONS(5883),
    [anon_sym_GT_GT] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(5881),
    [anon_sym_EQ_TILDE] = ACTIONS(5881),
    [anon_sym_BANG_TILDE] = ACTIONS(5881),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5861),
    [anon_sym_SLASH] = ACTIONS(5863),
    [anon_sym_PERCENT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(87),
  },
  [11304] = {
    [sym__heredoc_body_start] = ACTIONS(5927),
    [sym__binary_minus] = ACTIONS(15059),
    [sym__binary_star] = ACTIONS(15061),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(15063),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_STAR_STAR] = ACTIONS(15065),
    [anon_sym_AMP] = ACTIONS(15067),
    [anon_sym_EQ] = ACTIONS(7888),
    [anon_sym_LT] = ACTIONS(15069),
    [anon_sym_do] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_COLON_COLON2] = ACTIONS(5927),
    [anon_sym_AMP_DOT] = ACTIONS(5927),
    [anon_sym_PLUS_EQ] = ACTIONS(5927),
    [anon_sym_DASH_EQ] = ACTIONS(5927),
    [anon_sym_STAR_EQ] = ACTIONS(5927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5927),
    [anon_sym_SLASH_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5927),
    [anon_sym_AMP_EQ] = ACTIONS(5927),
    [anon_sym_PERCENT_EQ] = ACTIONS(5927),
    [anon_sym_GT_GT_EQ] = ACTIONS(5927),
    [anon_sym_LT_LT_EQ] = ACTIONS(5927),
    [anon_sym_CARET_EQ] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_DOT_DOT] = ACTIONS(15073),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15075),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(15077),
    [anon_sym_AMP_AMP] = ACTIONS(15077),
    [anon_sym_LT_LT] = ACTIONS(15079),
    [anon_sym_GT_GT] = ACTIONS(15079),
    [anon_sym_EQ_EQ] = ACTIONS(15077),
    [anon_sym_BANG_EQ] = ACTIONS(15081),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15081),
    [anon_sym_LT_EQ_GT] = ACTIONS(15081),
    [anon_sym_EQ_TILDE] = ACTIONS(15081),
    [anon_sym_BANG_TILDE] = ACTIONS(15081),
    [anon_sym_LT_EQ] = ACTIONS(15069),
    [anon_sym_GT] = ACTIONS(15069),
    [anon_sym_GT_EQ] = ACTIONS(15083),
    [anon_sym_CARET] = ACTIONS(15063),
    [anon_sym_PLUS] = ACTIONS(15085),
    [anon_sym_SLASH] = ACTIONS(15065),
    [anon_sym_PERCENT] = ACTIONS(15065),
    [sym_comment] = ACTIONS(87),
  },
  [11305] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(15059),
    [sym__binary_star] = ACTIONS(15061),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(15063),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(15065),
    [anon_sym_AMP] = ACTIONS(15067),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(15069),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(15071),
    [anon_sym_DOT_DOT] = ACTIONS(15073),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15075),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(15077),
    [anon_sym_AMP_AMP] = ACTIONS(15077),
    [anon_sym_LT_LT] = ACTIONS(15079),
    [anon_sym_GT_GT] = ACTIONS(15079),
    [anon_sym_EQ_EQ] = ACTIONS(15077),
    [anon_sym_BANG_EQ] = ACTIONS(15081),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15081),
    [anon_sym_LT_EQ_GT] = ACTIONS(15081),
    [anon_sym_EQ_TILDE] = ACTIONS(15081),
    [anon_sym_BANG_TILDE] = ACTIONS(15081),
    [anon_sym_LT_EQ] = ACTIONS(15069),
    [anon_sym_GT] = ACTIONS(15069),
    [anon_sym_GT_EQ] = ACTIONS(15083),
    [anon_sym_CARET] = ACTIONS(15063),
    [anon_sym_PLUS] = ACTIONS(15085),
    [anon_sym_SLASH] = ACTIONS(15065),
    [anon_sym_PERCENT] = ACTIONS(15065),
    [sym_comment] = ACTIONS(87),
  },
  [11306] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(15059),
    [sym__binary_star] = ACTIONS(15061),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(15063),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(15065),
    [anon_sym_AMP] = ACTIONS(15067),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(15069),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(15079),
    [anon_sym_GT_GT] = ACTIONS(15079),
    [anon_sym_EQ_EQ] = ACTIONS(15077),
    [anon_sym_BANG_EQ] = ACTIONS(15081),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15081),
    [anon_sym_LT_EQ_GT] = ACTIONS(15081),
    [anon_sym_EQ_TILDE] = ACTIONS(15081),
    [anon_sym_BANG_TILDE] = ACTIONS(15081),
    [anon_sym_LT_EQ] = ACTIONS(15069),
    [anon_sym_GT] = ACTIONS(15069),
    [anon_sym_GT_EQ] = ACTIONS(15083),
    [anon_sym_CARET] = ACTIONS(15063),
    [anon_sym_PLUS] = ACTIONS(15085),
    [anon_sym_SLASH] = ACTIONS(15065),
    [anon_sym_PERCENT] = ACTIONS(15065),
    [sym_comment] = ACTIONS(87),
  },
  [11307] = {
    [sym__heredoc_body_start] = ACTIONS(5825),
    [sym__binary_minus] = ACTIONS(15059),
    [sym__binary_star] = ACTIONS(15061),
    [anon_sym_LBRACE] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5827),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_STAR_STAR] = ACTIONS(15065),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5827),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_do] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5825),
    [anon_sym_COLON_COLON2] = ACTIONS(5825),
    [anon_sym_AMP_DOT] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_DOT_DOT] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_and] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5825),
    [anon_sym_PIPE_PIPE] = ACTIONS(5827),
    [anon_sym_AMP_AMP] = ACTIONS(5827),
    [anon_sym_LT_LT] = ACTIONS(5827),
    [anon_sym_GT_GT] = ACTIONS(5827),
    [anon_sym_EQ_EQ] = ACTIONS(5827),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_EQ_TILDE] = ACTIONS(5825),
    [anon_sym_BANG_TILDE] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_CARET] = ACTIONS(5827),
    [anon_sym_PLUS] = ACTIONS(15085),
    [anon_sym_SLASH] = ACTIONS(15065),
    [anon_sym_PERCENT] = ACTIONS(15065),
    [sym_comment] = ACTIONS(87),
  },
  [11308] = {
    [sym__heredoc_body_start] = ACTIONS(5115),
    [sym__binary_minus] = ACTIONS(15059),
    [sym__binary_star] = ACTIONS(15061),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(7936),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(15063),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_STAR_STAR] = ACTIONS(15065),
    [anon_sym_AMP] = ACTIONS(15067),
    [anon_sym_EQ] = ACTIONS(7936),
    [anon_sym_LT] = ACTIONS(15069),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_COLON_COLON2] = ACTIONS(5115),
    [anon_sym_AMP_DOT] = ACTIONS(5115),
    [anon_sym_PLUS_EQ] = ACTIONS(5115),
    [anon_sym_DASH_EQ] = ACTIONS(5115),
    [anon_sym_STAR_EQ] = ACTIONS(5115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5115),
    [anon_sym_SLASH_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5115),
    [anon_sym_AMP_EQ] = ACTIONS(5115),
    [anon_sym_PERCENT_EQ] = ACTIONS(5115),
    [anon_sym_GT_GT_EQ] = ACTIONS(5115),
    [anon_sym_LT_LT_EQ] = ACTIONS(5115),
    [anon_sym_CARET_EQ] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(15071),
    [anon_sym_DOT_DOT] = ACTIONS(15073),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15075),
    [anon_sym_and] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(15077),
    [anon_sym_AMP_AMP] = ACTIONS(15077),
    [anon_sym_LT_LT] = ACTIONS(15079),
    [anon_sym_GT_GT] = ACTIONS(15079),
    [anon_sym_EQ_EQ] = ACTIONS(15077),
    [anon_sym_BANG_EQ] = ACTIONS(15081),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15081),
    [anon_sym_LT_EQ_GT] = ACTIONS(15081),
    [anon_sym_EQ_TILDE] = ACTIONS(15081),
    [anon_sym_BANG_TILDE] = ACTIONS(15081),
    [anon_sym_LT_EQ] = ACTIONS(15069),
    [anon_sym_GT] = ACTIONS(15069),
    [anon_sym_GT_EQ] = ACTIONS(15083),
    [anon_sym_CARET] = ACTIONS(15063),
    [anon_sym_PLUS] = ACTIONS(15085),
    [anon_sym_SLASH] = ACTIONS(15065),
    [anon_sym_PERCENT] = ACTIONS(15065),
    [sym_comment] = ACTIONS(87),
  },
  [11309] = {
    [aux_sym_exceptions_repeat1] = STATE(11339),
    [sym__heredoc_body_start] = ACTIONS(6191),
    [sym__binary_minus] = ACTIONS(6191),
    [sym__binary_star] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_STAR_STAR] = ACTIONS(6193),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(6193),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_do] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_COLON_COLON2] = ACTIONS(6191),
    [anon_sym_AMP_DOT] = ACTIONS(6191),
    [anon_sym_PLUS_EQ] = ACTIONS(6191),
    [anon_sym_DASH_EQ] = ACTIONS(6191),
    [anon_sym_STAR_EQ] = ACTIONS(6191),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6191),
    [anon_sym_SLASH_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6191),
    [anon_sym_AMP_EQ] = ACTIONS(6191),
    [anon_sym_PERCENT_EQ] = ACTIONS(6191),
    [anon_sym_GT_GT_EQ] = ACTIONS(6191),
    [anon_sym_LT_LT_EQ] = ACTIONS(6191),
    [anon_sym_CARET_EQ] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_DOT_DOT] = ACTIONS(6193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6193),
    [anon_sym_AMP_AMP] = ACTIONS(6193),
    [anon_sym_LT_LT] = ACTIONS(6193),
    [anon_sym_GT_GT] = ACTIONS(6193),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6191),
    [anon_sym_EQ_TILDE] = ACTIONS(6191),
    [anon_sym_BANG_TILDE] = ACTIONS(6191),
    [anon_sym_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6193),
    [anon_sym_PLUS] = ACTIONS(6193),
    [anon_sym_SLASH] = ACTIONS(6193),
    [anon_sym_PERCENT] = ACTIONS(6193),
    [sym_comment] = ACTIONS(87),
  },
  [11310] = {
    [sym__heredoc_body_start] = ACTIONS(6210),
    [sym__binary_minus] = ACTIONS(15059),
    [sym__binary_star] = ACTIONS(15061),
    [anon_sym_LBRACE] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(7938),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(15063),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym_STAR_STAR] = ACTIONS(15065),
    [anon_sym_AMP] = ACTIONS(15067),
    [anon_sym_EQ] = ACTIONS(7938),
    [anon_sym_LT] = ACTIONS(15069),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_COLON_COLON2] = ACTIONS(6210),
    [anon_sym_AMP_DOT] = ACTIONS(6210),
    [anon_sym_PLUS_EQ] = ACTIONS(6210),
    [anon_sym_DASH_EQ] = ACTIONS(6210),
    [anon_sym_STAR_EQ] = ACTIONS(6210),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6210),
    [anon_sym_SLASH_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6210),
    [anon_sym_AMP_EQ] = ACTIONS(6210),
    [anon_sym_PERCENT_EQ] = ACTIONS(6210),
    [anon_sym_GT_GT_EQ] = ACTIONS(6210),
    [anon_sym_LT_LT_EQ] = ACTIONS(6210),
    [anon_sym_CARET_EQ] = ACTIONS(6210),
    [anon_sym_QMARK] = ACTIONS(15071),
    [anon_sym_DOT_DOT] = ACTIONS(15073),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15075),
    [anon_sym_and] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6210),
    [anon_sym_PIPE_PIPE] = ACTIONS(15077),
    [anon_sym_AMP_AMP] = ACTIONS(15077),
    [anon_sym_LT_LT] = ACTIONS(15079),
    [anon_sym_GT_GT] = ACTIONS(15079),
    [anon_sym_EQ_EQ] = ACTIONS(15077),
    [anon_sym_BANG_EQ] = ACTIONS(15081),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15081),
    [anon_sym_LT_EQ_GT] = ACTIONS(15081),
    [anon_sym_EQ_TILDE] = ACTIONS(15081),
    [anon_sym_BANG_TILDE] = ACTIONS(15081),
    [anon_sym_LT_EQ] = ACTIONS(15069),
    [anon_sym_GT] = ACTIONS(15069),
    [anon_sym_GT_EQ] = ACTIONS(15083),
    [anon_sym_CARET] = ACTIONS(15063),
    [anon_sym_PLUS] = ACTIONS(15085),
    [anon_sym_SLASH] = ACTIONS(15065),
    [anon_sym_PERCENT] = ACTIONS(15065),
    [sym_comment] = ACTIONS(87),
  },
  [11311] = {
    [sym_string] = STATE(11311),
    [aux_sym_chained_string_repeat1] = STATE(11311),
    [sym__string_start] = ACTIONS(13881),
    [sym__heredoc_body_start] = ACTIONS(6212),
    [sym__binary_minus] = ACTIONS(6212),
    [sym__binary_star] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_PIPE] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_STAR_STAR] = ACTIONS(6217),
    [anon_sym_AMP] = ACTIONS(6217),
    [anon_sym_EQ] = ACTIONS(6217),
    [anon_sym_LT] = ACTIONS(6217),
    [anon_sym_do] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_COLON_COLON2] = ACTIONS(6212),
    [anon_sym_AMP_DOT] = ACTIONS(6212),
    [anon_sym_PLUS_EQ] = ACTIONS(6212),
    [anon_sym_DASH_EQ] = ACTIONS(6212),
    [anon_sym_STAR_EQ] = ACTIONS(6212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6212),
    [anon_sym_SLASH_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_PIPE_EQ] = ACTIONS(6212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6212),
    [anon_sym_AMP_EQ] = ACTIONS(6212),
    [anon_sym_PERCENT_EQ] = ACTIONS(6212),
    [anon_sym_GT_GT_EQ] = ACTIONS(6212),
    [anon_sym_LT_LT_EQ] = ACTIONS(6212),
    [anon_sym_CARET_EQ] = ACTIONS(6212),
    [anon_sym_QMARK] = ACTIONS(6212),
    [anon_sym_DOT_DOT] = ACTIONS(6217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6212),
    [anon_sym_and] = ACTIONS(6212),
    [anon_sym_or] = ACTIONS(6212),
    [anon_sym_PIPE_PIPE] = ACTIONS(6217),
    [anon_sym_AMP_AMP] = ACTIONS(6217),
    [anon_sym_LT_LT] = ACTIONS(6217),
    [anon_sym_GT_GT] = ACTIONS(6217),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6212),
    [anon_sym_LT_EQ_GT] = ACTIONS(6212),
    [anon_sym_EQ_TILDE] = ACTIONS(6212),
    [anon_sym_BANG_TILDE] = ACTIONS(6212),
    [anon_sym_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6217),
    [anon_sym_GT_EQ] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6217),
    [anon_sym_PLUS] = ACTIONS(6217),
    [anon_sym_SLASH] = ACTIONS(6217),
    [anon_sym_PERCENT] = ACTIONS(6217),
    [sym_comment] = ACTIONS(87),
  },
  [11312] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(11340),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9962),
    [sym_scope_resolution] = STATE(9958),
    [sym_call] = STATE(9958),
    [sym_method_call] = STATE(9962),
    [sym_assignment] = STATE(11340),
    [sym_operator_assignment] = STATE(11340),
    [sym_conditional] = STATE(11340),
    [sym_range] = STATE(11340),
    [sym_binary] = STATE(11340),
    [sym_unary] = STATE(11340),
    [sym_left_assignment_list] = STATE(9961),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9962),
    [sym__variable] = STATE(9958),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9962),
    [sym_false] = STATE(9962),
    [sym_nil] = STATE(9962),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10776),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(13663),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13667),
    [anon_sym_yield] = ACTIONS(13669),
    [anon_sym_break] = ACTIONS(13671),
    [anon_sym_next] = ACTIONS(13673),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(14528),
    [anon_sym_defined_QMARK] = ACTIONS(13675),
    [anon_sym_not] = ACTIONS(13677),
    [anon_sym_BANG] = ACTIONS(13681),
    [anon_sym_TILDE] = ACTIONS(13681),
    [sym_constant] = ACTIONS(13687),
    [sym_identifier] = ACTIONS(13687),
    [sym_instance_variable] = ACTIONS(13685),
    [sym_class_variable] = ACTIONS(13685),
    [sym_global_variable] = ACTIONS(13685),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13687),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13687),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [11313] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(11153),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9962),
    [sym_scope_resolution] = STATE(9958),
    [sym_call] = STATE(9958),
    [sym_method_call] = STATE(9962),
    [sym_splat_argument] = STATE(9044),
    [sym_assignment] = STATE(11153),
    [sym_operator_assignment] = STATE(11153),
    [sym_conditional] = STATE(11153),
    [sym_range] = STATE(11153),
    [sym_binary] = STATE(11153),
    [sym_unary] = STATE(11153),
    [sym__arg_or_splat_arg] = STATE(9044),
    [sym_left_assignment_list] = STATE(9961),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(9962),
    [sym__variable] = STATE(9958),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9962),
    [sym_false] = STATE(9962),
    [sym_nil] = STATE(9962),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10776),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__splat_star] = ACTIONS(14488),
    [sym__unary_minus] = ACTIONS(13663),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13667),
    [anon_sym_yield] = ACTIONS(13669),
    [anon_sym_break] = ACTIONS(13671),
    [anon_sym_next] = ACTIONS(13673),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(14528),
    [anon_sym_defined_QMARK] = ACTIONS(13675),
    [anon_sym_not] = ACTIONS(13677),
    [anon_sym_BANG] = ACTIONS(13681),
    [anon_sym_TILDE] = ACTIONS(13681),
    [sym_constant] = ACTIONS(13687),
    [sym_identifier] = ACTIONS(13687),
    [sym_instance_variable] = ACTIONS(13685),
    [sym_class_variable] = ACTIONS(13685),
    [sym_global_variable] = ACTIONS(13685),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13687),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13687),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3471),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [11314] = {
    [aux_sym_exceptions_repeat1] = STATE(11341),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_LBRACE] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(15331),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9857),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_EQ] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_do] = ACTIONS(9855),
    [anon_sym_EQ_GT] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_PLUS_EQ] = ACTIONS(9855),
    [anon_sym_DASH_EQ] = ACTIONS(9855),
    [anon_sym_STAR_EQ] = ACTIONS(9855),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9855),
    [anon_sym_SLASH_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9855),
    [anon_sym_AMP_EQ] = ACTIONS(9855),
    [anon_sym_PERCENT_EQ] = ACTIONS(9855),
    [anon_sym_GT_GT_EQ] = ACTIONS(9855),
    [anon_sym_LT_LT_EQ] = ACTIONS(9855),
    [anon_sym_CARET_EQ] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9857),
    [anon_sym_AMP_AMP] = ACTIONS(9857),
    [anon_sym_LT_LT] = ACTIONS(9857),
    [anon_sym_GT_GT] = ACTIONS(9857),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9857),
    [anon_sym_PLUS] = ACTIONS(9857),
    [anon_sym_SLASH] = ACTIONS(9857),
    [anon_sym_PERCENT] = ACTIONS(9857),
    [sym_comment] = ACTIONS(87),
  },
  [11315] = {
    [aux_sym_exceptions_repeat1] = STATE(11315),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_COMMA] = ACTIONS(15333),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [11316] = {
    [sym__simple_symbol] = ACTIONS(15336),
    [sym__string_start] = ACTIONS(15336),
    [sym__symbol_start] = ACTIONS(15336),
    [sym__subshell_start] = ACTIONS(15336),
    [sym__regex_start] = ACTIONS(15336),
    [sym__string_array_start] = ACTIONS(15336),
    [sym__symbol_array_start] = ACTIONS(15336),
    [sym_heredoc_beginning] = ACTIONS(15336),
    [sym__unary_minus] = ACTIONS(15336),
    [anon_sym_BEGIN] = ACTIONS(15338),
    [anon_sym_LBRACE] = ACTIONS(15336),
    [anon_sym_RBRACE] = ACTIONS(15336),
    [anon_sym_END] = ACTIONS(15338),
    [anon_sym_def] = ACTIONS(15338),
    [anon_sym_LPAREN] = ACTIONS(15336),
    [anon_sym_COLON_COLON] = ACTIONS(15336),
    [anon_sym_SEMI] = ACTIONS(15336),
    [anon_sym_STAR] = ACTIONS(15336),
    [anon_sym_class] = ACTIONS(15338),
    [anon_sym_module] = ACTIONS(15338),
    [anon_sym_return] = ACTIONS(15338),
    [anon_sym_yield] = ACTIONS(15338),
    [anon_sym_break] = ACTIONS(15338),
    [anon_sym_next] = ACTIONS(15338),
    [sym_redo] = ACTIONS(15338),
    [sym_retry] = ACTIONS(15338),
    [anon_sym_if] = ACTIONS(15338),
    [anon_sym_unless] = ACTIONS(15338),
    [anon_sym_while] = ACTIONS(15338),
    [anon_sym_until] = ACTIONS(15338),
    [anon_sym_for] = ACTIONS(15338),
    [anon_sym_case] = ACTIONS(15338),
    [anon_sym_begin] = ACTIONS(15338),
    [anon_sym_PLUS] = ACTIONS(15338),
    [anon_sym_defined_QMARK] = ACTIONS(15336),
    [anon_sym_not] = ACTIONS(15338),
    [anon_sym_BANG] = ACTIONS(15336),
    [anon_sym_TILDE] = ACTIONS(15336),
    [sym_constant] = ACTIONS(15338),
    [sym_identifier] = ACTIONS(15338),
    [sym_instance_variable] = ACTIONS(15336),
    [sym_class_variable] = ACTIONS(15336),
    [sym_global_variable] = ACTIONS(15336),
    [anon_sym_undef] = ACTIONS(15338),
    [anon_sym_alias] = ACTIONS(15338),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(15338),
    [sym_float] = ACTIONS(15338),
    [sym_complex] = ACTIONS(15336),
    [sym_super] = ACTIONS(15338),
    [anon_sym_true] = ACTIONS(15338),
    [anon_sym_TRUE] = ACTIONS(15338),
    [anon_sym_false] = ACTIONS(15338),
    [anon_sym_FALSE] = ACTIONS(15338),
    [sym_self] = ACTIONS(15338),
    [anon_sym_nil] = ACTIONS(15338),
    [anon_sym_NIL] = ACTIONS(15338),
    [sym_character] = ACTIONS(15336),
    [anon_sym_LBRACK2] = ACTIONS(15336),
    [anon_sym_DASH_GT] = ACTIONS(15336),
  },
  [11317] = {
    [sym__line_break] = ACTIONS(15336),
    [sym__simple_symbol] = ACTIONS(15336),
    [sym__string_start] = ACTIONS(15336),
    [sym__symbol_start] = ACTIONS(15336),
    [sym__subshell_start] = ACTIONS(15336),
    [sym__regex_start] = ACTIONS(15336),
    [sym__string_array_start] = ACTIONS(15336),
    [sym__symbol_array_start] = ACTIONS(15336),
    [sym__heredoc_body_start] = ACTIONS(15336),
    [sym_heredoc_beginning] = ACTIONS(15336),
    [sym__unary_minus] = ACTIONS(15336),
    [anon_sym_BEGIN] = ACTIONS(15338),
    [anon_sym_LBRACE] = ACTIONS(15336),
    [anon_sym_END] = ACTIONS(15338),
    [anon_sym_def] = ACTIONS(15338),
    [anon_sym_LPAREN] = ACTIONS(15336),
    [anon_sym_COLON_COLON] = ACTIONS(15336),
    [anon_sym_SEMI] = ACTIONS(15336),
    [anon_sym_STAR] = ACTIONS(15336),
    [anon_sym_class] = ACTIONS(15338),
    [anon_sym_module] = ACTIONS(15338),
    [anon_sym_end] = ACTIONS(15338),
    [anon_sym_return] = ACTIONS(15338),
    [anon_sym_yield] = ACTIONS(15338),
    [anon_sym_break] = ACTIONS(15338),
    [anon_sym_next] = ACTIONS(15338),
    [sym_redo] = ACTIONS(15338),
    [sym_retry] = ACTIONS(15338),
    [anon_sym_if] = ACTIONS(15338),
    [anon_sym_unless] = ACTIONS(15338),
    [anon_sym_while] = ACTIONS(15338),
    [anon_sym_until] = ACTIONS(15338),
    [anon_sym_for] = ACTIONS(15338),
    [anon_sym_case] = ACTIONS(15338),
    [anon_sym_begin] = ACTIONS(15338),
    [anon_sym_PLUS] = ACTIONS(15338),
    [anon_sym_defined_QMARK] = ACTIONS(15336),
    [anon_sym_not] = ACTIONS(15338),
    [anon_sym_BANG] = ACTIONS(15336),
    [anon_sym_TILDE] = ACTIONS(15336),
    [sym_constant] = ACTIONS(15338),
    [sym_identifier] = ACTIONS(15338),
    [sym_instance_variable] = ACTIONS(15336),
    [sym_class_variable] = ACTIONS(15336),
    [sym_global_variable] = ACTIONS(15336),
    [anon_sym_undef] = ACTIONS(15338),
    [anon_sym_alias] = ACTIONS(15338),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(15338),
    [sym_float] = ACTIONS(15338),
    [sym_complex] = ACTIONS(15336),
    [sym_super] = ACTIONS(15338),
    [anon_sym_true] = ACTIONS(15338),
    [anon_sym_TRUE] = ACTIONS(15338),
    [anon_sym_false] = ACTIONS(15338),
    [anon_sym_FALSE] = ACTIONS(15338),
    [sym_self] = ACTIONS(15338),
    [anon_sym_nil] = ACTIONS(15338),
    [anon_sym_NIL] = ACTIONS(15338),
    [sym_character] = ACTIONS(15336),
    [anon_sym_LBRACK2] = ACTIONS(15336),
    [anon_sym_DASH_GT] = ACTIONS(15336),
  },
  [11318] = {
    [sym__heredoc_body_start] = ACTIONS(14151),
    [sym__binary_minus] = ACTIONS(14151),
    [sym__binary_star] = ACTIONS(14151),
    [anon_sym_LBRACE] = ACTIONS(14151),
    [anon_sym_RBRACE] = ACTIONS(14151),
    [anon_sym_RPAREN] = ACTIONS(14151),
    [anon_sym_DOT] = ACTIONS(14153),
    [anon_sym_COMMA] = ACTIONS(14151),
    [anon_sym_PIPE] = ACTIONS(14153),
    [anon_sym_SEMI] = ACTIONS(14151),
    [anon_sym_STAR_STAR] = ACTIONS(14153),
    [anon_sym_AMP] = ACTIONS(14153),
    [anon_sym_EQ] = ACTIONS(14153),
    [anon_sym_LT] = ACTIONS(14153),
    [anon_sym_if] = ACTIONS(14151),
    [anon_sym_unless] = ACTIONS(14151),
    [anon_sym_while] = ACTIONS(14151),
    [anon_sym_until] = ACTIONS(14151),
    [anon_sym_rescue] = ACTIONS(14151),
    [anon_sym_in] = ACTIONS(14151),
    [anon_sym_do] = ACTIONS(14151),
    [anon_sym_LBRACK] = ACTIONS(14151),
    [anon_sym_RBRACK] = ACTIONS(14151),
    [anon_sym_COLON_COLON2] = ACTIONS(14151),
    [anon_sym_AMP_DOT] = ACTIONS(14151),
    [anon_sym_PLUS_EQ] = ACTIONS(14151),
    [anon_sym_DASH_EQ] = ACTIONS(14151),
    [anon_sym_STAR_EQ] = ACTIONS(14151),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14151),
    [anon_sym_SLASH_EQ] = ACTIONS(14151),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14151),
    [anon_sym_PIPE_EQ] = ACTIONS(14151),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14151),
    [anon_sym_AMP_EQ] = ACTIONS(14151),
    [anon_sym_PERCENT_EQ] = ACTIONS(14151),
    [anon_sym_GT_GT_EQ] = ACTIONS(14151),
    [anon_sym_LT_LT_EQ] = ACTIONS(14151),
    [anon_sym_CARET_EQ] = ACTIONS(14151),
    [anon_sym_QMARK] = ACTIONS(14151),
    [anon_sym_COLON2] = ACTIONS(14153),
    [anon_sym_DOT_DOT] = ACTIONS(14153),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14151),
    [anon_sym_and] = ACTIONS(14151),
    [anon_sym_or] = ACTIONS(14151),
    [anon_sym_PIPE_PIPE] = ACTIONS(14153),
    [anon_sym_AMP_AMP] = ACTIONS(14153),
    [anon_sym_LT_LT] = ACTIONS(14153),
    [anon_sym_GT_GT] = ACTIONS(14153),
    [anon_sym_EQ_EQ] = ACTIONS(14153),
    [anon_sym_BANG_EQ] = ACTIONS(14151),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14151),
    [anon_sym_LT_EQ_GT] = ACTIONS(14151),
    [anon_sym_EQ_TILDE] = ACTIONS(14151),
    [anon_sym_BANG_TILDE] = ACTIONS(14151),
    [anon_sym_LT_EQ] = ACTIONS(14153),
    [anon_sym_GT] = ACTIONS(14153),
    [anon_sym_GT_EQ] = ACTIONS(14151),
    [anon_sym_CARET] = ACTIONS(14153),
    [anon_sym_PLUS] = ACTIONS(14153),
    [anon_sym_SLASH] = ACTIONS(14153),
    [anon_sym_PERCENT] = ACTIONS(14153),
    [sym_comment] = ACTIONS(87),
  },
  [11319] = {
    [sym_heredoc_body] = STATE(11319),
    [aux_sym_call_repeat1] = STATE(11319),
    [sym__line_break] = ACTIONS(7914),
    [sym__heredoc_body_start] = ACTIONS(7916),
    [sym__binary_minus] = ACTIONS(7914),
    [sym__binary_star] = ACTIONS(7914),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_SEMI] = ACTIONS(7914),
    [anon_sym_STAR_STAR] = ACTIONS(7914),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_end] = ACTIONS(7914),
    [anon_sym_if] = ACTIONS(7914),
    [anon_sym_unless] = ACTIONS(7914),
    [anon_sym_while] = ACTIONS(7914),
    [anon_sym_until] = ACTIONS(7914),
    [anon_sym_rescue] = ACTIONS(7914),
    [anon_sym_when] = ACTIONS(7914),
    [anon_sym_else] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_COLON_COLON2] = ACTIONS(7914),
    [anon_sym_AMP_DOT] = ACTIONS(7914),
    [anon_sym_QMARK] = ACTIONS(7914),
    [anon_sym_DOT_DOT] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7914),
    [anon_sym_and] = ACTIONS(7914),
    [anon_sym_or] = ACTIONS(7914),
    [anon_sym_PIPE_PIPE] = ACTIONS(7914),
    [anon_sym_AMP_AMP] = ACTIONS(7914),
    [anon_sym_LT_LT] = ACTIONS(7914),
    [anon_sym_GT_GT] = ACTIONS(7914),
    [anon_sym_EQ_EQ] = ACTIONS(7919),
    [anon_sym_BANG_EQ] = ACTIONS(7914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7914),
    [anon_sym_LT_EQ_GT] = ACTIONS(7914),
    [anon_sym_EQ_TILDE] = ACTIONS(7914),
    [anon_sym_BANG_TILDE] = ACTIONS(7914),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7914),
    [anon_sym_CARET] = ACTIONS(7914),
    [anon_sym_PLUS] = ACTIONS(7914),
    [anon_sym_SLASH] = ACTIONS(7914),
    [anon_sym_PERCENT] = ACTIONS(7914),
    [sym_comment] = ACTIONS(87),
  },
  [11320] = {
    [sym_heredoc_body] = STATE(11319),
    [aux_sym_call_repeat1] = STATE(11319),
    [sym__line_break] = ACTIONS(7929),
    [sym__heredoc_body_start] = ACTIONS(1683),
    [sym__binary_minus] = ACTIONS(7929),
    [sym__binary_star] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym_STAR_STAR] = ACTIONS(7929),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_end] = ACTIONS(7929),
    [anon_sym_if] = ACTIONS(7929),
    [anon_sym_unless] = ACTIONS(7929),
    [anon_sym_while] = ACTIONS(7929),
    [anon_sym_until] = ACTIONS(7929),
    [anon_sym_rescue] = ACTIONS(7929),
    [anon_sym_when] = ACTIONS(7929),
    [anon_sym_else] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_COLON_COLON2] = ACTIONS(7929),
    [anon_sym_AMP_DOT] = ACTIONS(7929),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_DOT_DOT] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_and] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7929),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_LT_LT] = ACTIONS(7929),
    [anon_sym_GT_GT] = ACTIONS(7929),
    [anon_sym_EQ_EQ] = ACTIONS(7931),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_EQ_TILDE] = ACTIONS(7929),
    [anon_sym_BANG_TILDE] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_CARET] = ACTIONS(7929),
    [anon_sym_PLUS] = ACTIONS(7929),
    [anon_sym_SLASH] = ACTIONS(7929),
    [anon_sym_PERCENT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(87),
  },
  [11321] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(11342),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(10500),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(10500),
    [sym_assignment] = STATE(11342),
    [sym_operator_assignment] = STATE(11342),
    [sym_conditional] = STATE(11342),
    [sym_range] = STATE(11342),
    [sym_binary] = STATE(11342),
    [sym_unary] = STATE(11342),
    [sym_left_assignment_list] = STATE(10499),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10500),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(10500),
    [sym_false] = STATE(10500),
    [sym_nil] = STATE(10500),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(10501),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(14158),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14160),
    [anon_sym_yield] = ACTIONS(14162),
    [anon_sym_break] = ACTIONS(14164),
    [anon_sym_next] = ACTIONS(14166),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14168),
    [anon_sym_defined_QMARK] = ACTIONS(14170),
    [anon_sym_not] = ACTIONS(14172),
    [anon_sym_BANG] = ACTIONS(14174),
    [anon_sym_TILDE] = ACTIONS(14174),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11322] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(11214),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(10500),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(10500),
    [sym_splat_argument] = STATE(7439),
    [sym_assignment] = STATE(11214),
    [sym_operator_assignment] = STATE(11214),
    [sym_conditional] = STATE(11214),
    [sym_range] = STATE(11214),
    [sym_binary] = STATE(11214),
    [sym_unary] = STATE(11214),
    [sym__arg_or_splat_arg] = STATE(7439),
    [sym_left_assignment_list] = STATE(10499),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10500),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(10500),
    [sym_false] = STATE(10500),
    [sym_nil] = STATE(10500),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(10501),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(13284),
    [sym__unary_minus] = ACTIONS(14158),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14160),
    [anon_sym_yield] = ACTIONS(14162),
    [anon_sym_break] = ACTIONS(14164),
    [anon_sym_next] = ACTIONS(14166),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14168),
    [anon_sym_defined_QMARK] = ACTIONS(14170),
    [anon_sym_not] = ACTIONS(14172),
    [anon_sym_BANG] = ACTIONS(14174),
    [anon_sym_TILDE] = ACTIONS(14174),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11323] = {
    [aux_sym_exceptions_repeat1] = STATE(11343),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(15340),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_end] = ACTIONS(9855),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_when] = ACTIONS(9855),
    [anon_sym_else] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [11324] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(14190),
    [sym__binary_star] = ACTIONS(14192),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(14194),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(14192),
    [anon_sym_AMP] = ACTIONS(14196),
    [anon_sym_LT] = ACTIONS(14198),
    [anon_sym_end] = ACTIONS(12120),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_when] = ACTIONS(12120),
    [anon_sym_else] = ACTIONS(12120),
    [anon_sym_EQ_GT] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(14200),
    [anon_sym_DOT_DOT] = ACTIONS(14202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14204),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(14206),
    [anon_sym_AMP_AMP] = ACTIONS(14206),
    [anon_sym_LT_LT] = ACTIONS(14208),
    [anon_sym_GT_GT] = ACTIONS(14208),
    [anon_sym_EQ_EQ] = ACTIONS(14210),
    [anon_sym_BANG_EQ] = ACTIONS(14206),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14206),
    [anon_sym_LT_EQ_GT] = ACTIONS(14206),
    [anon_sym_EQ_TILDE] = ACTIONS(14206),
    [anon_sym_BANG_TILDE] = ACTIONS(14206),
    [anon_sym_LT_EQ] = ACTIONS(14198),
    [anon_sym_GT] = ACTIONS(14198),
    [anon_sym_GT_EQ] = ACTIONS(14212),
    [anon_sym_CARET] = ACTIONS(14214),
    [anon_sym_PLUS] = ACTIONS(14190),
    [anon_sym_SLASH] = ACTIONS(14192),
    [anon_sym_PERCENT] = ACTIONS(14192),
    [sym_comment] = ACTIONS(87),
  },
  [11325] = {
    [aux_sym_exceptions_repeat1] = STATE(11325),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(15342),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_end] = ACTIONS(11597),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_when] = ACTIONS(11597),
    [anon_sym_else] = ACTIONS(11597),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [11326] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(11344),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(10569),
    [sym_scope_resolution] = STATE(10567),
    [sym_call] = STATE(10567),
    [sym_method_call] = STATE(10569),
    [sym_assignment] = STATE(11344),
    [sym_operator_assignment] = STATE(11344),
    [sym_conditional] = STATE(11344),
    [sym_range] = STATE(11344),
    [sym_binary] = STATE(11344),
    [sym_unary] = STATE(11344),
    [sym_left_assignment_list] = STATE(10568),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10569),
    [sym__variable] = STATE(10567),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(10569),
    [sym_false] = STATE(10569),
    [sym_nil] = STATE(10569),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(10570),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__unary_minus] = ACTIONS(14234),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(14236),
    [anon_sym_yield] = ACTIONS(14238),
    [anon_sym_break] = ACTIONS(14240),
    [anon_sym_next] = ACTIONS(14242),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(14244),
    [anon_sym_defined_QMARK] = ACTIONS(14246),
    [anon_sym_not] = ACTIONS(14248),
    [anon_sym_BANG] = ACTIONS(14250),
    [anon_sym_TILDE] = ACTIONS(14250),
    [sym_constant] = ACTIONS(14252),
    [sym_identifier] = ACTIONS(14252),
    [sym_instance_variable] = ACTIONS(14254),
    [sym_class_variable] = ACTIONS(14254),
    [sym_global_variable] = ACTIONS(14254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(14252),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(14252),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [11327] = {
    [sym_method] = STATE(1495),
    [sym_singleton_method] = STATE(1495),
    [sym_class] = STATE(1495),
    [sym_singleton_class] = STATE(1495),
    [sym_module] = STATE(1495),
    [sym_return] = STATE(1495),
    [sym_yield] = STATE(1495),
    [sym_break] = STATE(1495),
    [sym_next] = STATE(1495),
    [sym_while] = STATE(1495),
    [sym_until] = STATE(1495),
    [sym_for] = STATE(1495),
    [sym_case] = STATE(1495),
    [sym_if] = STATE(1495),
    [sym_unless] = STATE(1495),
    [sym_begin] = STATE(1495),
    [sym__arg] = STATE(11244),
    [sym__primary] = STATE(1495),
    [sym_parenthesized_statements] = STATE(1495),
    [sym_element_reference] = STATE(10569),
    [sym_scope_resolution] = STATE(10567),
    [sym_call] = STATE(10567),
    [sym_method_call] = STATE(10569),
    [sym_splat_argument] = STATE(10067),
    [sym_assignment] = STATE(11244),
    [sym_operator_assignment] = STATE(11244),
    [sym_conditional] = STATE(11244),
    [sym_range] = STATE(11244),
    [sym_binary] = STATE(11244),
    [sym_unary] = STATE(11244),
    [sym__arg_or_splat_arg] = STATE(10067),
    [sym_left_assignment_list] = STATE(10568),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10569),
    [sym__variable] = STATE(10567),
    [sym_rational] = STATE(1495),
    [sym_true] = STATE(10569),
    [sym_false] = STATE(10569),
    [sym_nil] = STATE(10569),
    [sym_chained_string] = STATE(1495),
    [sym_string] = STATE(10570),
    [sym_subshell] = STATE(1495),
    [sym_string_array] = STATE(1495),
    [sym_symbol_array] = STATE(1495),
    [sym_symbol] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_array] = STATE(1495),
    [sym_hash] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym__simple_symbol] = ACTIONS(2549),
    [sym__string_start] = ACTIONS(2551),
    [sym__symbol_start] = ACTIONS(2553),
    [sym__subshell_start] = ACTIONS(2555),
    [sym__regex_start] = ACTIONS(2557),
    [sym__string_array_start] = ACTIONS(2559),
    [sym__symbol_array_start] = ACTIONS(2561),
    [sym_heredoc_beginning] = ACTIONS(2563),
    [sym__splat_star] = ACTIONS(13354),
    [sym__unary_minus] = ACTIONS(14234),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_def] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(14236),
    [anon_sym_yield] = ACTIONS(14238),
    [anon_sym_break] = ACTIONS(14240),
    [anon_sym_next] = ACTIONS(14242),
    [sym_redo] = ACTIONS(2585),
    [sym_retry] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_unless] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_until] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_begin] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(14244),
    [anon_sym_defined_QMARK] = ACTIONS(14246),
    [anon_sym_not] = ACTIONS(14248),
    [anon_sym_BANG] = ACTIONS(14250),
    [anon_sym_TILDE] = ACTIONS(14250),
    [sym_constant] = ACTIONS(14252),
    [sym_identifier] = ACTIONS(14252),
    [sym_instance_variable] = ACTIONS(14254),
    [sym_class_variable] = ACTIONS(14254),
    [sym_global_variable] = ACTIONS(14254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2613),
    [sym_float] = ACTIONS(2585),
    [sym_complex] = ACTIONS(2563),
    [sym_super] = ACTIONS(14252),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(14252),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2563),
    [anon_sym_LBRACK2] = ACTIONS(2615),
    [anon_sym_DASH_GT] = ACTIONS(2617),
  },
  [11328] = {
    [aux_sym_exceptions_repeat1] = STATE(11345),
    [sym__line_break] = ACTIONS(9855),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_LBRACE] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(15345),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9857),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_EQ] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_end] = ACTIONS(9855),
    [anon_sym_if] = ACTIONS(9855),
    [anon_sym_unless] = ACTIONS(9855),
    [anon_sym_while] = ACTIONS(9855),
    [anon_sym_until] = ACTIONS(9855),
    [anon_sym_rescue] = ACTIONS(9855),
    [anon_sym_do] = ACTIONS(9855),
    [anon_sym_when] = ACTIONS(9855),
    [anon_sym_else] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_PLUS_EQ] = ACTIONS(9855),
    [anon_sym_DASH_EQ] = ACTIONS(9855),
    [anon_sym_STAR_EQ] = ACTIONS(9855),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9855),
    [anon_sym_SLASH_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9855),
    [anon_sym_AMP_EQ] = ACTIONS(9855),
    [anon_sym_PERCENT_EQ] = ACTIONS(9855),
    [anon_sym_GT_GT_EQ] = ACTIONS(9855),
    [anon_sym_LT_LT_EQ] = ACTIONS(9855),
    [anon_sym_CARET_EQ] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9857),
    [anon_sym_AMP_AMP] = ACTIONS(9857),
    [anon_sym_LT_LT] = ACTIONS(9857),
    [anon_sym_GT_GT] = ACTIONS(9857),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9857),
    [anon_sym_PLUS] = ACTIONS(9857),
    [anon_sym_SLASH] = ACTIONS(9857),
    [anon_sym_PERCENT] = ACTIONS(9857),
    [sym_comment] = ACTIONS(87),
  },
  [11329] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(14262),
    [sym__binary_star] = ACTIONS(14264),
    [anon_sym_LBRACE] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(14266),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(14268),
    [anon_sym_AMP] = ACTIONS(14270),
    [anon_sym_EQ] = ACTIONS(12879),
    [anon_sym_LT] = ACTIONS(14272),
    [anon_sym_end] = ACTIONS(12120),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_when] = ACTIONS(12120),
    [anon_sym_else] = ACTIONS(12120),
    [anon_sym_EQ_GT] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_PLUS_EQ] = ACTIONS(12120),
    [anon_sym_DASH_EQ] = ACTIONS(12120),
    [anon_sym_STAR_EQ] = ACTIONS(12120),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12120),
    [anon_sym_SLASH_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12120),
    [anon_sym_AMP_EQ] = ACTIONS(12120),
    [anon_sym_PERCENT_EQ] = ACTIONS(12120),
    [anon_sym_GT_GT_EQ] = ACTIONS(12120),
    [anon_sym_LT_LT_EQ] = ACTIONS(12120),
    [anon_sym_CARET_EQ] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(14274),
    [anon_sym_DOT_DOT] = ACTIONS(14276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14278),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(14280),
    [anon_sym_AMP_AMP] = ACTIONS(14280),
    [anon_sym_LT_LT] = ACTIONS(14282),
    [anon_sym_GT_GT] = ACTIONS(14282),
    [anon_sym_EQ_EQ] = ACTIONS(14280),
    [anon_sym_BANG_EQ] = ACTIONS(14284),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14284),
    [anon_sym_LT_EQ_GT] = ACTIONS(14284),
    [anon_sym_EQ_TILDE] = ACTIONS(14284),
    [anon_sym_BANG_TILDE] = ACTIONS(14284),
    [anon_sym_LT_EQ] = ACTIONS(14272),
    [anon_sym_GT] = ACTIONS(14272),
    [anon_sym_GT_EQ] = ACTIONS(14286),
    [anon_sym_CARET] = ACTIONS(14266),
    [anon_sym_PLUS] = ACTIONS(14288),
    [anon_sym_SLASH] = ACTIONS(14268),
    [anon_sym_PERCENT] = ACTIONS(14268),
    [sym_comment] = ACTIONS(87),
  },
  [11330] = {
    [aux_sym_exceptions_repeat1] = STATE(11330),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(15347),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_end] = ACTIONS(11597),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_when] = ACTIONS(11597),
    [anon_sym_else] = ACTIONS(11597),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_PLUS_EQ] = ACTIONS(11597),
    [anon_sym_DASH_EQ] = ACTIONS(11597),
    [anon_sym_STAR_EQ] = ACTIONS(11597),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11597),
    [anon_sym_SLASH_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11597),
    [anon_sym_AMP_EQ] = ACTIONS(11597),
    [anon_sym_PERCENT_EQ] = ACTIONS(11597),
    [anon_sym_GT_GT_EQ] = ACTIONS(11597),
    [anon_sym_LT_LT_EQ] = ACTIONS(11597),
    [anon_sym_CARET_EQ] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_LT] = ACTIONS(12338),
    [anon_sym_GT_GT] = ACTIONS(12338),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(12338),
    [anon_sym_PLUS] = ACTIONS(12338),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [11331] = {
    [sym_method] = STATE(46),
    [sym_singleton_method] = STATE(46),
    [sym_class] = STATE(46),
    [sym_singleton_class] = STATE(46),
    [sym_module] = STATE(46),
    [sym_return] = STATE(46),
    [sym_yield] = STATE(46),
    [sym_break] = STATE(46),
    [sym_next] = STATE(46),
    [sym_while] = STATE(46),
    [sym_until] = STATE(46),
    [sym_for] = STATE(46),
    [sym_case] = STATE(46),
    [sym_if] = STATE(46),
    [sym_unless] = STATE(46),
    [sym_begin] = STATE(46),
    [sym__arg] = STATE(11346),
    [sym__primary] = STATE(46),
    [sym_parenthesized_statements] = STATE(46),
    [sym_element_reference] = STATE(10601),
    [sym_scope_resolution] = STATE(7928),
    [sym_call] = STATE(7928),
    [sym_method_call] = STATE(10601),
    [sym_assignment] = STATE(11346),
    [sym_operator_assignment] = STATE(11346),
    [sym_conditional] = STATE(11346),
    [sym_range] = STATE(11346),
    [sym_binary] = STATE(11346),
    [sym_unary] = STATE(11346),
    [sym_left_assignment_list] = STATE(10600),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10601),
    [sym__variable] = STATE(7928),
    [sym_rational] = STATE(46),
    [sym_true] = STATE(10601),
    [sym_false] = STATE(10601),
    [sym_nil] = STATE(10601),
    [sym_chained_string] = STATE(46),
    [sym_string] = STATE(10501),
    [sym_subshell] = STATE(46),
    [sym_string_array] = STATE(46),
    [sym_symbol_array] = STATE(46),
    [sym_symbol] = STATE(46),
    [sym_regex] = STATE(46),
    [sym_array] = STATE(46),
    [sym_hash] = STATE(46),
    [sym_lambda] = STATE(46),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(14302),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14160),
    [anon_sym_yield] = ACTIONS(14162),
    [anon_sym_break] = ACTIONS(14164),
    [anon_sym_next] = ACTIONS(14166),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14304),
    [anon_sym_defined_QMARK] = ACTIONS(14306),
    [anon_sym_not] = ACTIONS(14308),
    [anon_sym_BANG] = ACTIONS(14310),
    [anon_sym_TILDE] = ACTIONS(14310),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
    [sym_instance_variable] = ACTIONS(11448),
    [sym_class_variable] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(11448),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11446),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11446),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11332] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(11347),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(10709),
    [sym_scope_resolution] = STATE(10707),
    [sym_call] = STATE(10707),
    [sym_method_call] = STATE(10709),
    [sym_assignment] = STATE(11347),
    [sym_operator_assignment] = STATE(11347),
    [sym_conditional] = STATE(11347),
    [sym_range] = STATE(11347),
    [sym_binary] = STATE(11347),
    [sym_unary] = STATE(11347),
    [sym_left_assignment_list] = STATE(10708),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10709),
    [sym__variable] = STATE(10707),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(10709),
    [sym_false] = STATE(10709),
    [sym_nil] = STATE(10709),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(10710),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(14424),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(14426),
    [anon_sym_yield] = ACTIONS(14428),
    [anon_sym_break] = ACTIONS(14430),
    [anon_sym_next] = ACTIONS(14432),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14434),
    [anon_sym_defined_QMARK] = ACTIONS(14436),
    [anon_sym_not] = ACTIONS(14438),
    [anon_sym_BANG] = ACTIONS(14440),
    [anon_sym_TILDE] = ACTIONS(14440),
    [sym_constant] = ACTIONS(14442),
    [sym_identifier] = ACTIONS(14442),
    [sym_instance_variable] = ACTIONS(14444),
    [sym_class_variable] = ACTIONS(14444),
    [sym_global_variable] = ACTIONS(14444),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(14442),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14442),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11333] = {
    [sym_method] = STATE(538),
    [sym_singleton_method] = STATE(538),
    [sym_class] = STATE(538),
    [sym_singleton_class] = STATE(538),
    [sym_module] = STATE(538),
    [sym_return] = STATE(538),
    [sym_yield] = STATE(538),
    [sym_break] = STATE(538),
    [sym_next] = STATE(538),
    [sym_while] = STATE(538),
    [sym_until] = STATE(538),
    [sym_for] = STATE(538),
    [sym_case] = STATE(538),
    [sym_if] = STATE(538),
    [sym_unless] = STATE(538),
    [sym_begin] = STATE(538),
    [sym__arg] = STATE(11278),
    [sym__primary] = STATE(538),
    [sym_parenthesized_statements] = STATE(538),
    [sym_element_reference] = STATE(10709),
    [sym_scope_resolution] = STATE(10707),
    [sym_call] = STATE(10707),
    [sym_method_call] = STATE(10709),
    [sym_splat_argument] = STATE(9013),
    [sym_assignment] = STATE(11278),
    [sym_operator_assignment] = STATE(11278),
    [sym_conditional] = STATE(11278),
    [sym_range] = STATE(11278),
    [sym_binary] = STATE(11278),
    [sym_unary] = STATE(11278),
    [sym__arg_or_splat_arg] = STATE(9013),
    [sym_left_assignment_list] = STATE(10708),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10709),
    [sym__variable] = STATE(10707),
    [sym_rational] = STATE(538),
    [sym_true] = STATE(10709),
    [sym_false] = STATE(10709),
    [sym_nil] = STATE(10709),
    [sym_chained_string] = STATE(538),
    [sym_string] = STATE(10710),
    [sym_subshell] = STATE(538),
    [sym_string_array] = STATE(538),
    [sym_symbol_array] = STATE(538),
    [sym_symbol] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_array] = STATE(538),
    [sym_hash] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(13603),
    [sym__unary_minus] = ACTIONS(14424),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(14426),
    [anon_sym_yield] = ACTIONS(14428),
    [anon_sym_break] = ACTIONS(14430),
    [anon_sym_next] = ACTIONS(14432),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14434),
    [anon_sym_defined_QMARK] = ACTIONS(14436),
    [anon_sym_not] = ACTIONS(14438),
    [anon_sym_BANG] = ACTIONS(14440),
    [anon_sym_TILDE] = ACTIONS(14440),
    [sym_constant] = ACTIONS(14442),
    [sym_identifier] = ACTIONS(14442),
    [sym_instance_variable] = ACTIONS(14444),
    [sym_class_variable] = ACTIONS(14444),
    [sym_global_variable] = ACTIONS(14444),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(14442),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14442),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11334] = {
    [aux_sym_exceptions_repeat1] = STATE(11348),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(15350),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9855),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9855),
    [anon_sym_AMP_AMP] = ACTIONS(9855),
    [anon_sym_LT_LT] = ACTIONS(9855),
    [anon_sym_GT_GT] = ACTIONS(9855),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9855),
    [anon_sym_PLUS] = ACTIONS(9855),
    [anon_sym_SLASH] = ACTIONS(9855),
    [anon_sym_PERCENT] = ACTIONS(9855),
    [sym_comment] = ACTIONS(87),
  },
  [11335] = {
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(14460),
    [sym__binary_star] = ACTIONS(14462),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(14464),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(14462),
    [anon_sym_AMP] = ACTIONS(14466),
    [anon_sym_LT] = ACTIONS(14468),
    [anon_sym_EQ_GT] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(14470),
    [anon_sym_DOT_DOT] = ACTIONS(14472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14474),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(14476),
    [anon_sym_AMP_AMP] = ACTIONS(14476),
    [anon_sym_LT_LT] = ACTIONS(14478),
    [anon_sym_GT_GT] = ACTIONS(14478),
    [anon_sym_EQ_EQ] = ACTIONS(14480),
    [anon_sym_BANG_EQ] = ACTIONS(14476),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14476),
    [anon_sym_LT_EQ_GT] = ACTIONS(14476),
    [anon_sym_EQ_TILDE] = ACTIONS(14476),
    [anon_sym_BANG_TILDE] = ACTIONS(14476),
    [anon_sym_LT_EQ] = ACTIONS(14468),
    [anon_sym_GT] = ACTIONS(14468),
    [anon_sym_GT_EQ] = ACTIONS(14482),
    [anon_sym_CARET] = ACTIONS(14484),
    [anon_sym_PLUS] = ACTIONS(14460),
    [anon_sym_SLASH] = ACTIONS(14462),
    [anon_sym_PERCENT] = ACTIONS(14462),
    [sym_comment] = ACTIONS(87),
  },
  [11336] = {
    [aux_sym_exceptions_repeat1] = STATE(11336),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(15352),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [11337] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(11349),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(10772),
    [sym_scope_resolution] = STATE(10770),
    [sym_call] = STATE(10770),
    [sym_method_call] = STATE(10772),
    [sym_assignment] = STATE(11349),
    [sym_operator_assignment] = STATE(11349),
    [sym_conditional] = STATE(11349),
    [sym_range] = STATE(11349),
    [sym_binary] = STATE(11349),
    [sym_unary] = STATE(11349),
    [sym_left_assignment_list] = STATE(10771),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10772),
    [sym__variable] = STATE(10770),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(10772),
    [sym_false] = STATE(10772),
    [sym_nil] = STATE(10772),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(10773),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__unary_minus] = ACTIONS(14506),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(14508),
    [anon_sym_yield] = ACTIONS(14510),
    [anon_sym_break] = ACTIONS(14512),
    [anon_sym_next] = ACTIONS(14514),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(14516),
    [anon_sym_defined_QMARK] = ACTIONS(14518),
    [anon_sym_not] = ACTIONS(14520),
    [anon_sym_BANG] = ACTIONS(14522),
    [anon_sym_TILDE] = ACTIONS(14522),
    [sym_constant] = ACTIONS(14524),
    [sym_identifier] = ACTIONS(14524),
    [sym_instance_variable] = ACTIONS(14526),
    [sym_class_variable] = ACTIONS(14526),
    [sym_global_variable] = ACTIONS(14526),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(14524),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14524),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [11338] = {
    [sym_method] = STATE(3937),
    [sym_singleton_method] = STATE(3937),
    [sym_class] = STATE(3937),
    [sym_singleton_class] = STATE(3937),
    [sym_module] = STATE(3937),
    [sym_return] = STATE(3937),
    [sym_yield] = STATE(3937),
    [sym_break] = STATE(3937),
    [sym_next] = STATE(3937),
    [sym_while] = STATE(3937),
    [sym_until] = STATE(3937),
    [sym_for] = STATE(3937),
    [sym_case] = STATE(3937),
    [sym_if] = STATE(3937),
    [sym_unless] = STATE(3937),
    [sym_begin] = STATE(3937),
    [sym__arg] = STATE(11308),
    [sym__primary] = STATE(3937),
    [sym_parenthesized_statements] = STATE(3937),
    [sym_element_reference] = STATE(10772),
    [sym_scope_resolution] = STATE(10770),
    [sym_call] = STATE(10770),
    [sym_method_call] = STATE(10772),
    [sym_splat_argument] = STATE(10867),
    [sym_assignment] = STATE(11308),
    [sym_operator_assignment] = STATE(11308),
    [sym_conditional] = STATE(11308),
    [sym_range] = STATE(11308),
    [sym_binary] = STATE(11308),
    [sym_unary] = STATE(11308),
    [sym__arg_or_splat_arg] = STATE(10867),
    [sym_left_assignment_list] = STATE(10771),
    [sym__mlhs] = STATE(49),
    [sym_destructured_left_assignment] = STATE(50),
    [sym_rest_assignment] = STATE(50),
    [sym__lhs] = STATE(10772),
    [sym__variable] = STATE(10770),
    [sym_rational] = STATE(3937),
    [sym_true] = STATE(10772),
    [sym_false] = STATE(10772),
    [sym_nil] = STATE(10772),
    [sym_chained_string] = STATE(3937),
    [sym_string] = STATE(10773),
    [sym_subshell] = STATE(3937),
    [sym_string_array] = STATE(3937),
    [sym_symbol_array] = STATE(3937),
    [sym_symbol] = STATE(3937),
    [sym_regex] = STATE(3937),
    [sym_array] = STATE(3937),
    [sym_hash] = STATE(3937),
    [sym_lambda] = STATE(3937),
    [sym__simple_symbol] = ACTIONS(6453),
    [sym__string_start] = ACTIONS(6455),
    [sym__symbol_start] = ACTIONS(6457),
    [sym__subshell_start] = ACTIONS(6459),
    [sym__regex_start] = ACTIONS(6461),
    [sym__string_array_start] = ACTIONS(6463),
    [sym__symbol_array_start] = ACTIONS(6465),
    [sym_heredoc_beginning] = ACTIONS(6467),
    [sym__splat_star] = ACTIONS(13661),
    [sym__unary_minus] = ACTIONS(14506),
    [anon_sym_LBRACE] = ACTIONS(6471),
    [anon_sym_def] = ACTIONS(6473),
    [anon_sym_LPAREN] = ACTIONS(6475),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6477),
    [anon_sym_module] = ACTIONS(6479),
    [anon_sym_return] = ACTIONS(14508),
    [anon_sym_yield] = ACTIONS(14510),
    [anon_sym_break] = ACTIONS(14512),
    [anon_sym_next] = ACTIONS(14514),
    [sym_redo] = ACTIONS(6489),
    [sym_retry] = ACTIONS(6489),
    [anon_sym_if] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_until] = ACTIONS(6497),
    [anon_sym_for] = ACTIONS(6499),
    [anon_sym_case] = ACTIONS(6501),
    [anon_sym_begin] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(14516),
    [anon_sym_defined_QMARK] = ACTIONS(14518),
    [anon_sym_not] = ACTIONS(14520),
    [anon_sym_BANG] = ACTIONS(14522),
    [anon_sym_TILDE] = ACTIONS(14522),
    [sym_constant] = ACTIONS(14524),
    [sym_identifier] = ACTIONS(14524),
    [sym_instance_variable] = ACTIONS(14526),
    [sym_class_variable] = ACTIONS(14526),
    [sym_global_variable] = ACTIONS(14526),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6517),
    [sym_float] = ACTIONS(6489),
    [sym_complex] = ACTIONS(6467),
    [sym_super] = ACTIONS(14524),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14524),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6467),
    [anon_sym_LBRACK2] = ACTIONS(6519),
    [anon_sym_DASH_GT] = ACTIONS(6521),
  },
  [11339] = {
    [aux_sym_exceptions_repeat1] = STATE(11350),
    [sym__heredoc_body_start] = ACTIONS(9855),
    [sym__binary_minus] = ACTIONS(9855),
    [sym__binary_star] = ACTIONS(9855),
    [anon_sym_LBRACE] = ACTIONS(9855),
    [anon_sym_DOT] = ACTIONS(9857),
    [anon_sym_COMMA] = ACTIONS(15355),
    [anon_sym_PIPE] = ACTIONS(9857),
    [anon_sym_SEMI] = ACTIONS(9855),
    [anon_sym_STAR_STAR] = ACTIONS(9857),
    [anon_sym_AMP] = ACTIONS(9857),
    [anon_sym_EQ] = ACTIONS(9857),
    [anon_sym_LT] = ACTIONS(9857),
    [anon_sym_do] = ACTIONS(9855),
    [anon_sym_LBRACK] = ACTIONS(9855),
    [anon_sym_COLON_COLON2] = ACTIONS(9855),
    [anon_sym_AMP_DOT] = ACTIONS(9855),
    [anon_sym_PLUS_EQ] = ACTIONS(9855),
    [anon_sym_DASH_EQ] = ACTIONS(9855),
    [anon_sym_STAR_EQ] = ACTIONS(9855),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9855),
    [anon_sym_SLASH_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_PIPE_EQ] = ACTIONS(9855),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9855),
    [anon_sym_AMP_EQ] = ACTIONS(9855),
    [anon_sym_PERCENT_EQ] = ACTIONS(9855),
    [anon_sym_GT_GT_EQ] = ACTIONS(9855),
    [anon_sym_LT_LT_EQ] = ACTIONS(9855),
    [anon_sym_CARET_EQ] = ACTIONS(9855),
    [anon_sym_QMARK] = ACTIONS(9855),
    [anon_sym_DOT_DOT] = ACTIONS(9857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9855),
    [anon_sym_and] = ACTIONS(9855),
    [anon_sym_or] = ACTIONS(9855),
    [anon_sym_PIPE_PIPE] = ACTIONS(9857),
    [anon_sym_AMP_AMP] = ACTIONS(9857),
    [anon_sym_LT_LT] = ACTIONS(9857),
    [anon_sym_GT_GT] = ACTIONS(9857),
    [anon_sym_EQ_EQ] = ACTIONS(9857),
    [anon_sym_BANG_EQ] = ACTIONS(9855),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9855),
    [anon_sym_LT_EQ_GT] = ACTIONS(9855),
    [anon_sym_EQ_TILDE] = ACTIONS(9855),
    [anon_sym_BANG_TILDE] = ACTIONS(9855),
    [anon_sym_LT_EQ] = ACTIONS(9857),
    [anon_sym_GT] = ACTIONS(9857),
    [anon_sym_GT_EQ] = ACTIONS(9855),
    [anon_sym_CARET] = ACTIONS(9857),
    [anon_sym_PLUS] = ACTIONS(9857),
    [anon_sym_SLASH] = ACTIONS(9857),
    [anon_sym_PERCENT] = ACTIONS(9857),
    [sym_comment] = ACTIONS(87),
  },
  [11340] = {
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(14534),
    [sym__binary_star] = ACTIONS(14536),
    [anon_sym_LBRACE] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(14538),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(14540),
    [anon_sym_AMP] = ACTIONS(14542),
    [anon_sym_EQ] = ACTIONS(12879),
    [anon_sym_LT] = ACTIONS(14544),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_EQ_GT] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_PLUS_EQ] = ACTIONS(12120),
    [anon_sym_DASH_EQ] = ACTIONS(12120),
    [anon_sym_STAR_EQ] = ACTIONS(12120),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12120),
    [anon_sym_SLASH_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12120),
    [anon_sym_AMP_EQ] = ACTIONS(12120),
    [anon_sym_PERCENT_EQ] = ACTIONS(12120),
    [anon_sym_GT_GT_EQ] = ACTIONS(12120),
    [anon_sym_LT_LT_EQ] = ACTIONS(12120),
    [anon_sym_CARET_EQ] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(14546),
    [anon_sym_DOT_DOT] = ACTIONS(14548),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14550),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(14552),
    [anon_sym_AMP_AMP] = ACTIONS(14552),
    [anon_sym_LT_LT] = ACTIONS(14554),
    [anon_sym_GT_GT] = ACTIONS(14554),
    [anon_sym_EQ_EQ] = ACTIONS(14552),
    [anon_sym_BANG_EQ] = ACTIONS(14556),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14556),
    [anon_sym_LT_EQ_GT] = ACTIONS(14556),
    [anon_sym_EQ_TILDE] = ACTIONS(14556),
    [anon_sym_BANG_TILDE] = ACTIONS(14556),
    [anon_sym_LT_EQ] = ACTIONS(14544),
    [anon_sym_GT] = ACTIONS(14544),
    [anon_sym_GT_EQ] = ACTIONS(14558),
    [anon_sym_CARET] = ACTIONS(14538),
    [anon_sym_PLUS] = ACTIONS(14560),
    [anon_sym_SLASH] = ACTIONS(14540),
    [anon_sym_PERCENT] = ACTIONS(14540),
    [sym_comment] = ACTIONS(87),
  },
  [11341] = {
    [aux_sym_exceptions_repeat1] = STATE(11341),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(15357),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_EQ_GT] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_PLUS_EQ] = ACTIONS(11597),
    [anon_sym_DASH_EQ] = ACTIONS(11597),
    [anon_sym_STAR_EQ] = ACTIONS(11597),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11597),
    [anon_sym_SLASH_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11597),
    [anon_sym_AMP_EQ] = ACTIONS(11597),
    [anon_sym_PERCENT_EQ] = ACTIONS(11597),
    [anon_sym_GT_GT_EQ] = ACTIONS(11597),
    [anon_sym_LT_LT_EQ] = ACTIONS(11597),
    [anon_sym_CARET_EQ] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_LT] = ACTIONS(12338),
    [anon_sym_GT_GT] = ACTIONS(12338),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(12338),
    [anon_sym_PLUS] = ACTIONS(12338),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [11342] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(14831),
    [sym__binary_star] = ACTIONS(14833),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(14835),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(14833),
    [anon_sym_AMP] = ACTIONS(14837),
    [anon_sym_LT] = ACTIONS(14839),
    [anon_sym_end] = ACTIONS(12120),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_when] = ACTIONS(12120),
    [anon_sym_else] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(14841),
    [anon_sym_DOT_DOT] = ACTIONS(14843),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14845),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(14847),
    [anon_sym_AMP_AMP] = ACTIONS(14847),
    [anon_sym_LT_LT] = ACTIONS(14849),
    [anon_sym_GT_GT] = ACTIONS(14849),
    [anon_sym_EQ_EQ] = ACTIONS(14851),
    [anon_sym_BANG_EQ] = ACTIONS(14847),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14847),
    [anon_sym_LT_EQ_GT] = ACTIONS(14847),
    [anon_sym_EQ_TILDE] = ACTIONS(14847),
    [anon_sym_BANG_TILDE] = ACTIONS(14847),
    [anon_sym_LT_EQ] = ACTIONS(14839),
    [anon_sym_GT] = ACTIONS(14839),
    [anon_sym_GT_EQ] = ACTIONS(14853),
    [anon_sym_CARET] = ACTIONS(14855),
    [anon_sym_PLUS] = ACTIONS(14831),
    [anon_sym_SLASH] = ACTIONS(14833),
    [anon_sym_PERCENT] = ACTIONS(14833),
    [sym_comment] = ACTIONS(87),
  },
  [11343] = {
    [aux_sym_exceptions_repeat1] = STATE(11343),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(15360),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_end] = ACTIONS(11597),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_when] = ACTIONS(11597),
    [anon_sym_else] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [11344] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(14883),
    [sym__binary_star] = ACTIONS(14885),
    [anon_sym_LBRACE] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(14887),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(14889),
    [anon_sym_AMP] = ACTIONS(14891),
    [anon_sym_EQ] = ACTIONS(12879),
    [anon_sym_LT] = ACTIONS(14893),
    [anon_sym_end] = ACTIONS(12120),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_when] = ACTIONS(12120),
    [anon_sym_else] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_PLUS_EQ] = ACTIONS(12120),
    [anon_sym_DASH_EQ] = ACTIONS(12120),
    [anon_sym_STAR_EQ] = ACTIONS(12120),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12120),
    [anon_sym_SLASH_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12120),
    [anon_sym_AMP_EQ] = ACTIONS(12120),
    [anon_sym_PERCENT_EQ] = ACTIONS(12120),
    [anon_sym_GT_GT_EQ] = ACTIONS(12120),
    [anon_sym_LT_LT_EQ] = ACTIONS(12120),
    [anon_sym_CARET_EQ] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(14895),
    [anon_sym_DOT_DOT] = ACTIONS(14897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14899),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(14901),
    [anon_sym_AMP_AMP] = ACTIONS(14901),
    [anon_sym_LT_LT] = ACTIONS(14903),
    [anon_sym_GT_GT] = ACTIONS(14903),
    [anon_sym_EQ_EQ] = ACTIONS(14901),
    [anon_sym_BANG_EQ] = ACTIONS(14905),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14905),
    [anon_sym_LT_EQ_GT] = ACTIONS(14905),
    [anon_sym_EQ_TILDE] = ACTIONS(14905),
    [anon_sym_BANG_TILDE] = ACTIONS(14905),
    [anon_sym_LT_EQ] = ACTIONS(14893),
    [anon_sym_GT] = ACTIONS(14893),
    [anon_sym_GT_EQ] = ACTIONS(14907),
    [anon_sym_CARET] = ACTIONS(14887),
    [anon_sym_PLUS] = ACTIONS(14909),
    [anon_sym_SLASH] = ACTIONS(14889),
    [anon_sym_PERCENT] = ACTIONS(14889),
    [sym_comment] = ACTIONS(87),
  },
  [11345] = {
    [aux_sym_exceptions_repeat1] = STATE(11345),
    [sym__line_break] = ACTIONS(11597),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(15363),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_end] = ACTIONS(11597),
    [anon_sym_if] = ACTIONS(11597),
    [anon_sym_unless] = ACTIONS(11597),
    [anon_sym_while] = ACTIONS(11597),
    [anon_sym_until] = ACTIONS(11597),
    [anon_sym_rescue] = ACTIONS(11597),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_when] = ACTIONS(11597),
    [anon_sym_else] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_PLUS_EQ] = ACTIONS(11597),
    [anon_sym_DASH_EQ] = ACTIONS(11597),
    [anon_sym_STAR_EQ] = ACTIONS(11597),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11597),
    [anon_sym_SLASH_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11597),
    [anon_sym_AMP_EQ] = ACTIONS(11597),
    [anon_sym_PERCENT_EQ] = ACTIONS(11597),
    [anon_sym_GT_GT_EQ] = ACTIONS(11597),
    [anon_sym_LT_LT_EQ] = ACTIONS(11597),
    [anon_sym_CARET_EQ] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_LT] = ACTIONS(12338),
    [anon_sym_GT_GT] = ACTIONS(12338),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(12338),
    [anon_sym_PLUS] = ACTIONS(12338),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [11346] = {
    [sym__line_break] = ACTIONS(12120),
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(14919),
    [sym__binary_star] = ACTIONS(14921),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(14923),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(14921),
    [anon_sym_AMP] = ACTIONS(14925),
    [anon_sym_LT] = ACTIONS(14927),
    [anon_sym_end] = ACTIONS(12120),
    [anon_sym_if] = ACTIONS(12120),
    [anon_sym_unless] = ACTIONS(12120),
    [anon_sym_while] = ACTIONS(12120),
    [anon_sym_until] = ACTIONS(12120),
    [anon_sym_rescue] = ACTIONS(12120),
    [anon_sym_when] = ACTIONS(12120),
    [anon_sym_else] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(14929),
    [anon_sym_DOT_DOT] = ACTIONS(14931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14933),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(14935),
    [anon_sym_AMP_AMP] = ACTIONS(14935),
    [anon_sym_LT_LT] = ACTIONS(14937),
    [anon_sym_GT_GT] = ACTIONS(14937),
    [anon_sym_EQ_EQ] = ACTIONS(14939),
    [anon_sym_BANG_EQ] = ACTIONS(14935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14935),
    [anon_sym_LT_EQ_GT] = ACTIONS(14935),
    [anon_sym_EQ_TILDE] = ACTIONS(14935),
    [anon_sym_BANG_TILDE] = ACTIONS(14935),
    [anon_sym_LT_EQ] = ACTIONS(14927),
    [anon_sym_GT] = ACTIONS(14927),
    [anon_sym_GT_EQ] = ACTIONS(14941),
    [anon_sym_CARET] = ACTIONS(14943),
    [anon_sym_PLUS] = ACTIONS(14919),
    [anon_sym_SLASH] = ACTIONS(14921),
    [anon_sym_PERCENT] = ACTIONS(14921),
    [sym_comment] = ACTIONS(87),
  },
  [11347] = {
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(15007),
    [sym__binary_star] = ACTIONS(15009),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(15011),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(15009),
    [anon_sym_AMP] = ACTIONS(15013),
    [anon_sym_LT] = ACTIONS(15015),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(15017),
    [anon_sym_DOT_DOT] = ACTIONS(15019),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15021),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(15023),
    [anon_sym_AMP_AMP] = ACTIONS(15023),
    [anon_sym_LT_LT] = ACTIONS(15025),
    [anon_sym_GT_GT] = ACTIONS(15025),
    [anon_sym_EQ_EQ] = ACTIONS(15027),
    [anon_sym_BANG_EQ] = ACTIONS(15023),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15023),
    [anon_sym_LT_EQ_GT] = ACTIONS(15023),
    [anon_sym_EQ_TILDE] = ACTIONS(15023),
    [anon_sym_BANG_TILDE] = ACTIONS(15023),
    [anon_sym_LT_EQ] = ACTIONS(15015),
    [anon_sym_GT] = ACTIONS(15015),
    [anon_sym_GT_EQ] = ACTIONS(15029),
    [anon_sym_CARET] = ACTIONS(15031),
    [anon_sym_PLUS] = ACTIONS(15007),
    [anon_sym_SLASH] = ACTIONS(15009),
    [anon_sym_PERCENT] = ACTIONS(15009),
    [sym_comment] = ACTIONS(87),
  },
  [11348] = {
    [aux_sym_exceptions_repeat1] = STATE(11348),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(15366),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(11597),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(11597),
    [anon_sym_AMP_AMP] = ACTIONS(11597),
    [anon_sym_LT_LT] = ACTIONS(11597),
    [anon_sym_GT_GT] = ACTIONS(11597),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(11597),
    [anon_sym_PLUS] = ACTIONS(11597),
    [anon_sym_SLASH] = ACTIONS(11597),
    [anon_sym_PERCENT] = ACTIONS(11597),
    [sym_comment] = ACTIONS(87),
  },
  [11349] = {
    [sym__heredoc_body_start] = ACTIONS(12120),
    [sym__binary_minus] = ACTIONS(15059),
    [sym__binary_star] = ACTIONS(15061),
    [anon_sym_LBRACE] = ACTIONS(12120),
    [anon_sym_DOT] = ACTIONS(12879),
    [anon_sym_COMMA] = ACTIONS(12120),
    [anon_sym_PIPE] = ACTIONS(15063),
    [anon_sym_SEMI] = ACTIONS(12120),
    [anon_sym_STAR_STAR] = ACTIONS(15065),
    [anon_sym_AMP] = ACTIONS(15067),
    [anon_sym_EQ] = ACTIONS(12879),
    [anon_sym_LT] = ACTIONS(15069),
    [anon_sym_do] = ACTIONS(12120),
    [anon_sym_LBRACK] = ACTIONS(12120),
    [anon_sym_COLON_COLON2] = ACTIONS(12120),
    [anon_sym_AMP_DOT] = ACTIONS(12120),
    [anon_sym_PLUS_EQ] = ACTIONS(12120),
    [anon_sym_DASH_EQ] = ACTIONS(12120),
    [anon_sym_STAR_EQ] = ACTIONS(12120),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12120),
    [anon_sym_SLASH_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_PIPE_EQ] = ACTIONS(12120),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12120),
    [anon_sym_AMP_EQ] = ACTIONS(12120),
    [anon_sym_PERCENT_EQ] = ACTIONS(12120),
    [anon_sym_GT_GT_EQ] = ACTIONS(12120),
    [anon_sym_LT_LT_EQ] = ACTIONS(12120),
    [anon_sym_CARET_EQ] = ACTIONS(12120),
    [anon_sym_QMARK] = ACTIONS(15071),
    [anon_sym_DOT_DOT] = ACTIONS(15073),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15075),
    [anon_sym_and] = ACTIONS(12120),
    [anon_sym_or] = ACTIONS(12120),
    [anon_sym_PIPE_PIPE] = ACTIONS(15077),
    [anon_sym_AMP_AMP] = ACTIONS(15077),
    [anon_sym_LT_LT] = ACTIONS(15079),
    [anon_sym_GT_GT] = ACTIONS(15079),
    [anon_sym_EQ_EQ] = ACTIONS(15077),
    [anon_sym_BANG_EQ] = ACTIONS(15081),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15081),
    [anon_sym_LT_EQ_GT] = ACTIONS(15081),
    [anon_sym_EQ_TILDE] = ACTIONS(15081),
    [anon_sym_BANG_TILDE] = ACTIONS(15081),
    [anon_sym_LT_EQ] = ACTIONS(15069),
    [anon_sym_GT] = ACTIONS(15069),
    [anon_sym_GT_EQ] = ACTIONS(15083),
    [anon_sym_CARET] = ACTIONS(15063),
    [anon_sym_PLUS] = ACTIONS(15085),
    [anon_sym_SLASH] = ACTIONS(15065),
    [anon_sym_PERCENT] = ACTIONS(15065),
    [sym_comment] = ACTIONS(87),
  },
  [11350] = {
    [aux_sym_exceptions_repeat1] = STATE(11350),
    [sym__heredoc_body_start] = ACTIONS(11597),
    [sym__binary_minus] = ACTIONS(11597),
    [sym__binary_star] = ACTIONS(11597),
    [anon_sym_LBRACE] = ACTIONS(11597),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(15369),
    [anon_sym_PIPE] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(11597),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_LT] = ACTIONS(12338),
    [anon_sym_do] = ACTIONS(11597),
    [anon_sym_LBRACK] = ACTIONS(11597),
    [anon_sym_COLON_COLON2] = ACTIONS(11597),
    [anon_sym_AMP_DOT] = ACTIONS(11597),
    [anon_sym_PLUS_EQ] = ACTIONS(11597),
    [anon_sym_DASH_EQ] = ACTIONS(11597),
    [anon_sym_STAR_EQ] = ACTIONS(11597),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11597),
    [anon_sym_SLASH_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_PIPE_EQ] = ACTIONS(11597),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11597),
    [anon_sym_AMP_EQ] = ACTIONS(11597),
    [anon_sym_PERCENT_EQ] = ACTIONS(11597),
    [anon_sym_GT_GT_EQ] = ACTIONS(11597),
    [anon_sym_LT_LT_EQ] = ACTIONS(11597),
    [anon_sym_CARET_EQ] = ACTIONS(11597),
    [anon_sym_QMARK] = ACTIONS(11597),
    [anon_sym_DOT_DOT] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11597),
    [anon_sym_and] = ACTIONS(11597),
    [anon_sym_or] = ACTIONS(11597),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_LT] = ACTIONS(12338),
    [anon_sym_GT_GT] = ACTIONS(12338),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_BANG_EQ] = ACTIONS(11597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11597),
    [anon_sym_LT_EQ_GT] = ACTIONS(11597),
    [anon_sym_EQ_TILDE] = ACTIONS(11597),
    [anon_sym_BANG_TILDE] = ACTIONS(11597),
    [anon_sym_LT_EQ] = ACTIONS(12338),
    [anon_sym_GT] = ACTIONS(12338),
    [anon_sym_GT_EQ] = ACTIONS(11597),
    [anon_sym_CARET] = ACTIONS(12338),
    [anon_sym_PLUS] = ACTIONS(12338),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false},
  [1] = {.count = 1, .reusable = true}, RECOVER(),
  [3] = {.count = 1, .reusable = false}, RECOVER(),
  [5] = {.count = 1, .reusable = true}, SHIFT(2),
  [7] = {.count = 1, .reusable = true}, SHIFT(3),
  [9] = {.count = 1, .reusable = true}, SHIFT(4),
  [11] = {.count = 1, .reusable = true}, SHIFT(5),
  [13] = {.count = 1, .reusable = true}, SHIFT(6),
  [15] = {.count = 1, .reusable = true}, SHIFT(7),
  [17] = {.count = 1, .reusable = true}, SHIFT(8),
  [19] = {.count = 1, .reusable = true}, SHIFT(46),
  [21] = {.count = 1, .reusable = true}, SHIFT(9),
  [23] = {.count = 1, .reusable = true}, REDUCE(sym_program, 0),
  [25] = {.count = 1, .reusable = false}, SHIFT(10),
  [27] = {.count = 1, .reusable = false}, SHIFT(11),
  [29] = {.count = 1, .reusable = true}, SHIFT(12),
  [31] = {.count = 1, .reusable = false}, SHIFT(13),
  [33] = {.count = 1, .reusable = false}, SHIFT(14),
  [35] = {.count = 1, .reusable = true}, SHIFT(15),
  [37] = {.count = 1, .reusable = true}, SHIFT(16),
  [39] = {.count = 1, .reusable = true}, SHIFT(17),
  [41] = {.count = 1, .reusable = true}, SHIFT(18),
  [43] = {.count = 1, .reusable = false}, SHIFT(19),
  [45] = {.count = 1, .reusable = false}, SHIFT(20),
  [47] = {.count = 1, .reusable = false}, SHIFT(21),
  [49] = {.count = 1, .reusable = false}, SHIFT(22),
  [51] = {.count = 1, .reusable = false}, SHIFT(23),
  [53] = {.count = 1, .reusable = false}, SHIFT(24),
  [55] = {.count = 1, .reusable = false}, SHIFT(46),
  [57] = {.count = 1, .reusable = false}, SHIFT(25),
  [59] = {.count = 1, .reusable = false}, SHIFT(26),
  [61] = {.count = 1, .reusable = false}, SHIFT(27),
  [63] = {.count = 1, .reusable = false}, SHIFT(28),
  [65] = {.count = 1, .reusable = false}, SHIFT(29),
  [67] = {.count = 1, .reusable = false}, SHIFT(30),
  [69] = {.count = 1, .reusable = false}, SHIFT(31),
  [71] = {.count = 1, .reusable = false}, SHIFT(9),
  [73] = {.count = 1, .reusable = true}, SHIFT(32),
  [75] = {.count = 1, .reusable = false}, SHIFT(32),
  [77] = {.count = 1, .reusable = true}, SHIFT(33),
  [79] = {.count = 1, .reusable = false}, SHIFT(47),
  [81] = {.count = 1, .reusable = true}, SHIFT(47),
  [83] = {.count = 1, .reusable = false}, SHIFT(34),
  [85] = {.count = 1, .reusable = false}, SHIFT(35),
  [87] = {.count = 1, .reusable = true}, SHIFT_EXTRA(),
  [89] = {.count = 1, .reusable = false}, SHIFT(36),
  [91] = {.count = 1, .reusable = false}, SHIFT(37),
  [93] = {.count = 1, .reusable = false}, SHIFT(38),
  [95] = {.count = 1, .reusable = false}, SHIFT(39),
  [97] = {.count = 1, .reusable = true}, SHIFT(40),
  [99] = {.count = 1, .reusable = true}, SHIFT(41),
  [101] = {.count = 1, .reusable = true}, REDUCE(sym_symbol, 1),
  [103] = {.count = 1, .reusable = false}, REDUCE(sym_symbol, 1),
  [105] = {.count = 1, .reusable = true}, SHIFT(57),
  [107] = {.count = 1, .reusable = true}, SHIFT(54),
  [109] = {.count = 1, .reusable = false}, SHIFT_EXTRA(),
  [111] = {.count = 1, .reusable = false}, SHIFT(55),
  [113] = {.count = 1, .reusable = true}, SHIFT(58),
  [115] = {.count = 1, .reusable = true}, SHIFT(60),
  [117] = {.count = 1, .reusable = true}, SHIFT(62),
  [119] = {.count = 1, .reusable = true}, SHIFT(68),
  [121] = {.count = 1, .reusable = true}, SHIFT(64),
  [123] = {.count = 1, .reusable = false}, SHIFT(65),
  [125] = {.count = 1, .reusable = false}, SHIFT(66),
  [127] = {.count = 1, .reusable = false}, SHIFT(68),
  [129] = {.count = 1, .reusable = true}, SHIFT(69),
  [131] = {.count = 1, .reusable = false}, SHIFT(70),
  [133] = {.count = 1, .reusable = true}, SHIFT(73),
  [135] = {.count = 1, .reusable = true}, SHIFT(74),
  [137] = {.count = 1, .reusable = true}, SHIFT(75),
  [139] = {.count = 1, .reusable = true}, SHIFT(76),
  [141] = {.count = 1, .reusable = true}, SHIFT(77),
  [143] = {.count = 1, .reusable = true}, SHIFT(78),
  [145] = {.count = 1, .reusable = true}, SHIFT(79),
  [147] = {.count = 1, .reusable = true}, SHIFT(80),
  [149] = {.count = 1, .reusable = true}, SHIFT(81),
  [151] = {.count = 1, .reusable = true}, SHIFT(82),
  [153] = {.count = 1, .reusable = true}, SHIFT(114),
  [155] = {.count = 1, .reusable = true}, SHIFT(83),
  [157] = {.count = 1, .reusable = true}, SHIFT(84),
  [159] = {.count = 1, .reusable = true}, SHIFT(85),
  [161] = {.count = 1, .reusable = true}, SHIFT(86),
  [163] = {.count = 1, .reusable = false}, SHIFT(87),
  [165] = {.count = 1, .reusable = true}, SHIFT(88),
  [167] = {.count = 1, .reusable = true}, SHIFT(89),
  [169] = {.count = 1, .reusable = false}, SHIFT(18),
  [171] = {.count = 1, .reusable = true}, SHIFT(90),
  [173] = {.count = 1, .reusable = false}, SHIFT(91),
  [175] = {.count = 1, .reusable = false}, SHIFT(92),
  [177] = {.count = 1, .reusable = false}, SHIFT(93),
  [179] = {.count = 1, .reusable = false}, SHIFT(94),
  [181] = {.count = 1, .reusable = false}, SHIFT(95),
  [183] = {.count = 1, .reusable = false}, SHIFT(96),
  [185] = {.count = 1, .reusable = false}, SHIFT(114),
  [187] = {.count = 1, .reusable = false}, SHIFT(97),
  [189] = {.count = 1, .reusable = false}, SHIFT(98),
  [191] = {.count = 1, .reusable = false}, SHIFT(99),
  [193] = {.count = 1, .reusable = false}, SHIFT(100),
  [195] = {.count = 1, .reusable = false}, SHIFT(101),
  [197] = {.count = 1, .reusable = false}, SHIFT(102),
  [199] = {.count = 1, .reusable = false}, SHIFT(103),
  [201] = {.count = 1, .reusable = false}, SHIFT(83),
  [203] = {.count = 1, .reusable = true}, SHIFT(104),
  [205] = {.count = 1, .reusable = false}, SHIFT(104),
  [207] = {.count = 1, .reusable = true}, SHIFT(105),
  [209] = {.count = 1, .reusable = false}, SHIFT(106),
  [211] = {.count = 1, .reusable = true}, SHIFT(115),
  [213] = {.count = 1, .reusable = false}, SHIFT(107),
  [215] = {.count = 1, .reusable = false}, SHIFT(115),
  [217] = {.count = 1, .reusable = false}, SHIFT(108),
  [219] = {.count = 1, .reusable = false}, SHIFT(109),
  [221] = {.count = 1, .reusable = false}, SHIFT(110),
  [223] = {.count = 1, .reusable = true}, SHIFT(111),
  [225] = {.count = 1, .reusable = true}, SHIFT(112),
  [227] = {.count = 1, .reusable = true}, SHIFT(123),
  [229] = {.count = 1, .reusable = true}, SHIFT(124),
  [231] = {.count = 1, .reusable = true}, SHIFT(125),
  [233] = {.count = 1, .reusable = true}, SHIFT(126),
  [235] = {.count = 1, .reusable = true}, SHIFT(127),
  [237] = {.count = 1, .reusable = false}, SHIFT(127),
  [239] = {.count = 1, .reusable = true}, SHIFT(128),
  [241] = {.count = 1, .reusable = false}, SHIFT(129),
  [243] = {.count = 1, .reusable = false}, SHIFT(131),
  [245] = {.count = 1, .reusable = true}, SHIFT(133),
  [247] = {.count = 1, .reusable = true}, SHIFT(134),
  [249] = {.count = 1, .reusable = true}, SHIFT(135),
  [251] = {.count = 1, .reusable = false}, SHIFT(136),
  [253] = {.count = 1, .reusable = false}, SHIFT(137),
  [255] = {.count = 1, .reusable = false}, SHIFT(138),
  [257] = {.count = 1, .reusable = false}, SHIFT(139),
  [259] = {.count = 1, .reusable = false}, SHIFT(133),
  [261] = {.count = 1, .reusable = true}, SHIFT(140),
  [263] = {.count = 1, .reusable = false}, SHIFT(140),
  [265] = {.count = 1, .reusable = true}, SHIFT(141),
  [267] = {.count = 1, .reusable = false}, SHIFT(146),
  [269] = {.count = 1, .reusable = true}, SHIFT(146),
  [271] = {.count = 1, .reusable = false}, SHIFT(142),
  [273] = {.count = 1, .reusable = true}, SHIFT(153),
  [275] = {.count = 1, .reusable = true}, REDUCE(sym_empty_statement, 1),
  [277] = {.count = 1, .reusable = false}, REDUCE(sym_empty_statement, 1),
  [279] = {.count = 1, .reusable = true}, SHIFT(154),
  [281] = {.count = 1, .reusable = true}, SHIFT(155),
  [283] = {.count = 1, .reusable = true}, SHIFT(156),
  [285] = {.count = 1, .reusable = true}, SHIFT(157),
  [287] = {.count = 1, .reusable = true}, SHIFT(158),
  [289] = {.count = 1, .reusable = true}, SHIFT(159),
  [291] = {.count = 1, .reusable = true}, SHIFT(160),
  [293] = {.count = 1, .reusable = true}, SHIFT(184),
  [295] = {.count = 1, .reusable = true}, SHIFT(161),
  [297] = {.count = 1, .reusable = false}, SHIFT(162),
  [299] = {.count = 1, .reusable = true}, SHIFT(163),
  [301] = {.count = 1, .reusable = true}, SHIFT(164),
  [303] = {.count = 1, .reusable = true}, REDUCE(sym_rest_assignment, 1),
  [305] = {.count = 1, .reusable = false}, SHIFT(165),
  [307] = {.count = 1, .reusable = false}, SHIFT(166),
  [309] = {.count = 1, .reusable = false}, SHIFT(167),
  [311] = {.count = 1, .reusable = false}, SHIFT(168),
  [313] = {.count = 1, .reusable = false}, SHIFT(169),
  [315] = {.count = 1, .reusable = false}, SHIFT(170),
  [317] = {.count = 1, .reusable = false}, SHIFT(184),
  [319] = {.count = 1, .reusable = false}, SHIFT(171),
  [321] = {.count = 1, .reusable = false}, SHIFT(172),
  [323] = {.count = 1, .reusable = false}, SHIFT(173),
  [325] = {.count = 1, .reusable = false}, SHIFT(174),
  [327] = {.count = 1, .reusable = false}, SHIFT(175),
  [329] = {.count = 1, .reusable = false}, SHIFT(176),
  [331] = {.count = 1, .reusable = false}, SHIFT(177),
  [333] = {.count = 1, .reusable = false}, SHIFT(185),
  [335] = {.count = 1, .reusable = true}, SHIFT(185),
  [337] = {.count = 1, .reusable = false}, SHIFT(178),
  [339] = {.count = 1, .reusable = false}, SHIFT(179),
  [341] = {.count = 1, .reusable = false}, SHIFT(180),
  [343] = {.count = 1, .reusable = false}, SHIFT(181),
  [345] = {.count = 1, .reusable = true}, SHIFT(182),
  [347] = {.count = 1, .reusable = true}, SHIFT(183),
  [349] = {.count = 1, .reusable = true}, SHIFT(191),
  [351] = {.count = 1, .reusable = true}, SHIFT(188),
  [353] = {.count = 1, .reusable = true}, SHIFT(189),
  [355] = {.count = 1, .reusable = false}, SHIFT(191),
  [357] = {.count = 1, .reusable = false}, SHIFT(190),
  [359] = {.count = 1, .reusable = false}, SHIFT(193),
  [361] = {.count = 1, .reusable = true}, SHIFT(193),
  [363] = {.count = 1, .reusable = false}, SHIFT(194),
  [365] = {.count = 1, .reusable = true}, REDUCE(sym_return, 1),
  [367] = {.count = 1, .reusable = true}, SHIFT(214),
  [369] = {.count = 1, .reusable = true}, SHIFT(196),
  [371] = {.count = 1, .reusable = true}, SHIFT(197),
  [373] = {.count = 1, .reusable = true}, SHIFT(198),
  [375] = {.count = 1, .reusable = true}, SHIFT(199),
  [377] = {.count = 1, .reusable = false}, REDUCE(sym_return, 1),
  [379] = {.count = 1, .reusable = false}, SHIFT(15),
  [381] = {.count = 1, .reusable = false}, SHIFT(200),
  [383] = {.count = 1, .reusable = false}, SHIFT(202),
  [385] = {.count = 1, .reusable = false}, SHIFT(203),
  [387] = {.count = 1, .reusable = false}, SHIFT(204),
  [389] = {.count = 1, .reusable = false}, SHIFT(205),
  [391] = {.count = 1, .reusable = false}, SHIFT(214),
  [393] = {.count = 1, .reusable = true}, SHIFT(206),
  [395] = {.count = 1, .reusable = true}, SHIFT(207),
  [397] = {.count = 1, .reusable = false}, SHIFT(207),
  [399] = {.count = 1, .reusable = false}, SHIFT(208),
  [401] = {.count = 1, .reusable = true}, SHIFT(208),
  [403] = {.count = 1, .reusable = false}, SHIFT(209),
  [405] = {.count = 1, .reusable = true}, SHIFT(215),
  [407] = {.count = 1, .reusable = false}, SHIFT(215),
  [409] = {.count = 1, .reusable = false}, SHIFT(210),
  [411] = {.count = 1, .reusable = false}, SHIFT(211),
  [413] = {.count = 1, .reusable = false}, SHIFT(212),
  [415] = {.count = 1, .reusable = false}, SHIFT(40),
  [417] = {.count = 1, .reusable = true}, REDUCE(sym_yield, 1),
  [419] = {.count = 1, .reusable = false}, REDUCE(sym_yield, 1),
  [421] = {.count = 1, .reusable = true}, REDUCE(sym_break, 1),
  [423] = {.count = 1, .reusable = false}, REDUCE(sym_break, 1),
  [425] = {.count = 1, .reusable = true}, REDUCE(sym_next, 1),
  [427] = {.count = 1, .reusable = false}, REDUCE(sym_next, 1),
  [429] = {.count = 1, .reusable = true}, SHIFT(225),
  [431] = {.count = 1, .reusable = false}, SHIFT(226),
  [433] = {.count = 1, .reusable = false}, SHIFT(227),
  [435] = {.count = 1, .reusable = false}, SHIFT(228),
  [437] = {.count = 1, .reusable = false}, SHIFT(229),
  [439] = {.count = 1, .reusable = false}, SHIFT(225),
  [441] = {.count = 1, .reusable = true}, SHIFT(230),
  [443] = {.count = 1, .reusable = false}, SHIFT(230),
  [445] = {.count = 1, .reusable = true}, SHIFT(231),
  [447] = {.count = 1, .reusable = false}, SHIFT(235),
  [449] = {.count = 1, .reusable = true}, SHIFT(235),
  [451] = {.count = 1, .reusable = false}, SHIFT(232),
  [453] = {.count = 1, .reusable = true}, SHIFT(240),
  [455] = {.count = 1, .reusable = false}, SHIFT(241),
  [457] = {.count = 1, .reusable = false}, SHIFT(242),
  [459] = {.count = 1, .reusable = false}, SHIFT(243),
  [461] = {.count = 1, .reusable = false}, SHIFT(244),
  [463] = {.count = 1, .reusable = false}, SHIFT(240),
  [465] = {.count = 1, .reusable = true}, SHIFT(245),
  [467] = {.count = 1, .reusable = false}, SHIFT(245),
  [469] = {.count = 1, .reusable = true}, SHIFT(246),
  [471] = {.count = 1, .reusable = false}, SHIFT(248),
  [473] = {.count = 1, .reusable = true}, SHIFT(248),
  [475] = {.count = 1, .reusable = true}, SHIFT(253),
  [477] = {.count = 1, .reusable = true}, SHIFT(254),
  [479] = {.count = 1, .reusable = false}, SHIFT(255),
  [481] = {.count = 1, .reusable = true}, SHIFT(255),
  [483] = {.count = 1, .reusable = true}, SHIFT(271),
  [485] = {.count = 1, .reusable = true}, SHIFT(259),
  [487] = {.count = 1, .reusable = false}, SHIFT(260),
  [489] = {.count = 1, .reusable = false}, SHIFT(261),
  [491] = {.count = 1, .reusable = false}, SHIFT(262),
  [493] = {.count = 1, .reusable = false}, SHIFT(263),
  [495] = {.count = 1, .reusable = false}, SHIFT(259),
  [497] = {.count = 1, .reusable = true}, SHIFT(264),
  [499] = {.count = 1, .reusable = false}, SHIFT(264),
  [501] = {.count = 1, .reusable = true}, SHIFT(265),
  [503] = {.count = 1, .reusable = false}, SHIFT(267),
  [505] = {.count = 1, .reusable = true}, SHIFT(267),
  [507] = {.count = 1, .reusable = true}, SHIFT(295),
  [509] = {.count = 1, .reusable = true}, SHIFT(272),
  [511] = {.count = 1, .reusable = true}, SHIFT(273),
  [513] = {.count = 1, .reusable = false}, SHIFT(289),
  [515] = {.count = 1, .reusable = false}, SHIFT(274),
  [517] = {.count = 1, .reusable = false}, SHIFT(275),
  [519] = {.count = 1, .reusable = false}, SHIFT(276),
  [521] = {.count = 1, .reusable = false}, SHIFT(277),
  [523] = {.count = 1, .reusable = false}, SHIFT(278),
  [525] = {.count = 1, .reusable = false}, SHIFT(279),
  [527] = {.count = 1, .reusable = false}, SHIFT(280),
  [529] = {.count = 1, .reusable = false}, SHIFT(273),
  [531] = {.count = 1, .reusable = true}, SHIFT(281),
  [533] = {.count = 1, .reusable = false}, SHIFT(281),
  [535] = {.count = 1, .reusable = true}, SHIFT(282),
  [537] = {.count = 1, .reusable = false}, SHIFT(291),
  [539] = {.count = 1, .reusable = true}, SHIFT(291),
  [541] = {.count = 1, .reusable = false}, SHIFT(283),
  [543] = {.count = 1, .reusable = true}, SHIFT(300),
  [545] = {.count = 1, .reusable = true}, SHIFT(299),
  [547] = {.count = 1, .reusable = true}, SHIFT(301),
  [549] = {.count = 1, .reusable = true}, SHIFT(302),
  [551] = {.count = 1, .reusable = true}, SHIFT(303),
  [553] = {.count = 1, .reusable = false}, SHIFT(303),
  [555] = {.count = 1, .reusable = true}, SHIFT(305),
  [557] = {.count = 1, .reusable = true}, SHIFT(304),
  [559] = {.count = 1, .reusable = true}, REDUCE(sym__primary, 1),
  [561] = {.count = 1, .reusable = false}, REDUCE(sym__primary, 1),
  [563] = {.count = 1, .reusable = false}, SHIFT(306),
  [565] = {.count = 1, .reusable = true}, REDUCE(sym_true, 1),
  [567] = {.count = 1, .reusable = false}, REDUCE(sym_true, 1),
  [569] = {.count = 1, .reusable = true}, REDUCE(sym_false, 1),
  [571] = {.count = 1, .reusable = false}, REDUCE(sym_false, 1),
  [573] = {.count = 1, .reusable = true}, REDUCE(sym_nil, 1),
  [575] = {.count = 1, .reusable = false}, REDUCE(sym_nil, 1),
  [577] = {.count = 1, .reusable = true}, SHIFT(307),
  [579] = {.count = 1, .reusable = true}, SHIFT(308),
  [581] = {.count = 1, .reusable = true}, SHIFT(309),
  [583] = {.count = 1, .reusable = true}, SHIFT(310),
  [585] = {.count = 1, .reusable = true}, SHIFT(311),
  [587] = {.count = 1, .reusable = true}, SHIFT(312),
  [589] = {.count = 1, .reusable = true}, SHIFT(313),
  [591] = {.count = 1, .reusable = true}, SHIFT(347),
  [593] = {.count = 1, .reusable = true}, SHIFT(314),
  [595] = {.count = 1, .reusable = true}, SHIFT(315),
  [597] = {.count = 1, .reusable = true}, SHIFT(316),
  [599] = {.count = 1, .reusable = true}, SHIFT(317),
  [601] = {.count = 1, .reusable = true}, SHIFT(318),
  [603] = {.count = 1, .reusable = false}, SHIFT(319),
  [605] = {.count = 1, .reusable = true}, SHIFT(320),
  [607] = {.count = 1, .reusable = true}, SHIFT(321),
  [609] = {.count = 1, .reusable = true}, SHIFT(322),
  [611] = {.count = 1, .reusable = false}, SHIFT(323),
  [613] = {.count = 1, .reusable = false}, SHIFT(324),
  [615] = {.count = 1, .reusable = false}, SHIFT(325),
  [617] = {.count = 1, .reusable = false}, SHIFT(326),
  [619] = {.count = 1, .reusable = false}, SHIFT(327),
  [621] = {.count = 1, .reusable = false}, SHIFT(328),
  [623] = {.count = 1, .reusable = false}, SHIFT(347),
  [625] = {.count = 1, .reusable = false}, SHIFT(329),
  [627] = {.count = 1, .reusable = false}, SHIFT(330),
  [629] = {.count = 1, .reusable = false}, SHIFT(331),
  [631] = {.count = 1, .reusable = false}, SHIFT(332),
  [633] = {.count = 1, .reusable = false}, SHIFT(333),
  [635] = {.count = 1, .reusable = false}, SHIFT(334),
  [637] = {.count = 1, .reusable = false}, SHIFT(335),
  [639] = {.count = 1, .reusable = true}, SHIFT(336),
  [641] = {.count = 1, .reusable = false}, SHIFT(316),
  [643] = {.count = 1, .reusable = true}, SHIFT(337),
  [645] = {.count = 1, .reusable = false}, SHIFT(337),
  [647] = {.count = 1, .reusable = true}, SHIFT(338),
  [649] = {.count = 1, .reusable = false}, SHIFT(339),
  [651] = {.count = 1, .reusable = true}, SHIFT(348),
  [653] = {.count = 1, .reusable = false}, SHIFT(340),
  [655] = {.count = 1, .reusable = false}, SHIFT(348),
  [657] = {.count = 1, .reusable = false}, SHIFT(341),
  [659] = {.count = 1, .reusable = false}, SHIFT(342),
  [661] = {.count = 1, .reusable = false}, SHIFT(343),
  [663] = {.count = 1, .reusable = true}, SHIFT(344),
  [665] = {.count = 1, .reusable = true}, SHIFT(345),
  [667] = {.count = 1, .reusable = true}, SHIFT(354),
  [669] = {.count = 1, .reusable = true}, SHIFT(355),
  [671] = {.count = 1, .reusable = false}, SHIFT(356),
  [673] = {.count = 1, .reusable = true}, SHIFT(357),
  [675] = {.count = 1, .reusable = true}, SHIFT(358),
  [677] = {.count = 1, .reusable = false}, SHIFT(359),
  [679] = {.count = 1, .reusable = false}, SHIFT(360),
  [681] = {.count = 1, .reusable = true}, ACCEPT_INPUT(),
  [683] = {.count = 1, .reusable = true}, REDUCE(sym_program, 1),
  [685] = {.count = 1, .reusable = true}, SHIFT(364),
  [687] = {.count = 1, .reusable = true}, SHIFT(370),
  [689] = {.count = 1, .reusable = true}, REDUCE(sym__statements, 1),
  [691] = {.count = 1, .reusable = true}, SHIFT(365),
  [693] = {.count = 1, .reusable = true}, SHIFT(366),
  [695] = {.count = 1, .reusable = true}, SHIFT(367),
  [697] = {.count = 1, .reusable = true}, SHIFT(368),
  [699] = {.count = 1, .reusable = true}, SHIFT(369),
  [701] = {.count = 1, .reusable = true}, REDUCE(sym__statement, 1),
  [703] = {.count = 1, .reusable = true}, SHIFT(371),
  [705] = {.count = 1, .reusable = true}, SHIFT(372),
  [707] = {.count = 1, .reusable = false}, SHIFT(373),
  [709] = {.count = 1, .reusable = false}, SHIFT(374),
  [711] = {.count = 1, .reusable = false}, SHIFT(375),
  [713] = {.count = 1, .reusable = true}, SHIFT(376),
  [715] = {.count = 1, .reusable = false}, SHIFT(377),
  [717] = {.count = 1, .reusable = true}, SHIFT(377),
  [719] = {.count = 1, .reusable = true}, SHIFT(378),
  [721] = {.count = 1, .reusable = true}, SHIFT(379),
  [723] = {.count = 1, .reusable = true}, SHIFT(380),
  [725] = {.count = 1, .reusable = false}, SHIFT(379),
  [727] = {.count = 1, .reusable = true}, SHIFT(375),
  [729] = {.count = 1, .reusable = true}, SHIFT(373),
  [731] = {.count = 1, .reusable = true}, REDUCE(sym__arg, 1),
  [733] = {.count = 1, .reusable = false}, SHIFT(381),
  [735] = {.count = 1, .reusable = false}, REDUCE(sym__arg, 1),
  [737] = {.count = 1, .reusable = true}, SHIFT(382),
  [739] = {.count = 1, .reusable = true}, SHIFT(383),
  [741] = {.count = 1, .reusable = true}, SHIFT(381),
  [743] = {.count = 1, .reusable = true}, REDUCE(sym__lhs, 1),
  [745] = {.count = 1, .reusable = true}, SHIFT(384),
  [747] = {.count = 1, .reusable = true}, SHIFT(385),
  [749] = {.count = 1, .reusable = true}, SHIFT(386),
  [751] = {.count = 1, .reusable = true}, SHIFT(387),
  [753] = {.count = 1, .reusable = true}, SHIFT(388),
  [755] = {.count = 1, .reusable = true}, SHIFT(389),
  [757] = {.count = 1, .reusable = true}, SHIFT(390),
  [759] = {.count = 1, .reusable = true}, SHIFT(421),
  [761] = {.count = 1, .reusable = true}, SHIFT(391),
  [763] = {.count = 1, .reusable = true}, SHIFT(392),
  [765] = {.count = 1, .reusable = true}, SHIFT(393),
  [767] = {.count = 1, .reusable = true}, SHIFT(394),
  [769] = {.count = 1, .reusable = false}, REDUCE(sym__lhs, 1),
  [771] = {.count = 1, .reusable = true}, SHIFT(395),
  [773] = {.count = 1, .reusable = false}, SHIFT(396),
  [775] = {.count = 1, .reusable = false}, SHIFT(397),
  [777] = {.count = 1, .reusable = false}, SHIFT(399),
  [779] = {.count = 1, .reusable = false}, SHIFT(400),
  [781] = {.count = 1, .reusable = false}, SHIFT(401),
  [783] = {.count = 1, .reusable = false}, SHIFT(402),
  [785] = {.count = 1, .reusable = false}, SHIFT(403),
  [787] = {.count = 1, .reusable = false}, SHIFT(404),
  [789] = {.count = 1, .reusable = false}, SHIFT(421),
  [791] = {.count = 1, .reusable = false}, SHIFT(409),
  [793] = {.count = 1, .reusable = false}, SHIFT(410),
  [795] = {.count = 1, .reusable = false}, SHIFT(411),
  [797] = {.count = 1, .reusable = false}, SHIFT(412),
  [799] = {.count = 1, .reusable = true}, SHIFT(413),
  [801] = {.count = 1, .reusable = true}, SHIFT(414),
  [803] = {.count = 1, .reusable = false}, SHIFT(414),
  [805] = {.count = 1, .reusable = false}, SHIFT(415),
  [807] = {.count = 1, .reusable = true}, SHIFT(415),
  [809] = {.count = 1, .reusable = false}, SHIFT(416),
  [811] = {.count = 1, .reusable = true}, SHIFT(422),
  [813] = {.count = 1, .reusable = false}, SHIFT(417),
  [815] = {.count = 1, .reusable = false}, SHIFT(422),
  [817] = {.count = 1, .reusable = false}, SHIFT(418),
  [819] = {.count = 1, .reusable = true}, SHIFT(419),
  [821] = {.count = 1, .reusable = true}, SHIFT(430),
  [823] = {.count = 1, .reusable = true}, REDUCE(sym_left_assignment_list, 1),
  [825] = {.count = 1, .reusable = true}, SHIFT(431),
  [827] = {.count = 1, .reusable = true}, REDUCE(sym__mlhs, 1),
  [829] = {.count = 1, .reusable = false}, SHIFT(430),
  [831] = {.count = 1, .reusable = true}, SHIFT(433),
  [833] = {.count = 1, .reusable = false}, REDUCE(sym__statements, 1),
  [835] = {.count = 1, .reusable = true}, REDUCE(sym_string, 2, .alias_sequence_id = 1),
  [837] = {.count = 1, .reusable = false}, REDUCE(sym_string, 2, .alias_sequence_id = 1),
  [839] = {.count = 1, .reusable = true}, SHIFT(454),
  [841] = {.count = 1, .reusable = true}, SHIFT(437),
  [843] = {.count = 1, .reusable = false}, SHIFT(438),
  [845] = {.count = 1, .reusable = false}, SHIFT(439),
  [847] = {.count = 1, .reusable = true}, SHIFT(440),
  [849] = {.count = 1, .reusable = false}, SHIFT(441),
  [851] = {.count = 1, .reusable = false}, SHIFT(442),
  [853] = {.count = 1, .reusable = false}, SHIFT(443),
  [855] = {.count = 1, .reusable = false}, SHIFT(444),
  [857] = {.count = 1, .reusable = false}, SHIFT(454),
  [859] = {.count = 1, .reusable = false}, SHIFT(437),
  [861] = {.count = 1, .reusable = true}, SHIFT(445),
  [863] = {.count = 1, .reusable = false}, SHIFT(445),
  [865] = {.count = 1, .reusable = true}, SHIFT(446),
  [867] = {.count = 1, .reusable = false}, SHIFT(455),
  [869] = {.count = 1, .reusable = true}, SHIFT(455),
  [871] = {.count = 1, .reusable = false}, SHIFT(447),
  [873] = {.count = 1, .reusable = false}, SHIFT(448),
  [875] = {.count = 1, .reusable = false}, SHIFT(449),
  [877] = {.count = 1, .reusable = false}, SHIFT(450),
  [879] = {.count = 1, .reusable = false}, SHIFT(451),
  [881] = {.count = 1, .reusable = true}, SHIFT(459),
  [883] = {.count = 1, .reusable = true}, SHIFT(460),
  [885] = {.count = 1, .reusable = true}, REDUCE(sym__literal_contents, 1),
  [887] = {.count = 1, .reusable = true}, REDUCE(sym_symbol, 2, .alias_sequence_id = 1),
  [889] = {.count = 1, .reusable = false}, REDUCE(sym_symbol, 2, .alias_sequence_id = 1),
  [891] = {.count = 1, .reusable = true}, SHIFT(461),
  [893] = {.count = 1, .reusable = true}, REDUCE(sym_subshell, 2, .alias_sequence_id = 2),
  [895] = {.count = 1, .reusable = false}, REDUCE(sym_subshell, 2, .alias_sequence_id = 2),
  [897] = {.count = 1, .reusable = true}, SHIFT(462),
  [899] = {.count = 1, .reusable = true}, REDUCE(sym_regex, 2, .alias_sequence_id = 3),
  [901] = {.count = 1, .reusable = false}, REDUCE(sym_regex, 2, .alias_sequence_id = 3),
  [903] = {.count = 1, .reusable = true}, SHIFT(463),
  [905] = {.count = 1, .reusable = true}, REDUCE(sym_string_array, 2, .alias_sequence_id = 4),
  [907] = {.count = 1, .reusable = false}, REDUCE(sym_string_array, 2, .alias_sequence_id = 4),
  [909] = {.count = 1, .reusable = true}, SHIFT(465),
  [911] = {.count = 1, .reusable = false}, SHIFT(466),
  [913] = {.count = 1, .reusable = true}, SHIFT(468),
  [915] = {.count = 1, .reusable = true}, SHIFT(469),
  [917] = {.count = 1, .reusable = true}, SHIFT(471),
  [919] = {.count = 1, .reusable = false}, REDUCE(sym__literal_contents, 1),
  [921] = {.count = 1, .reusable = false}, SHIFT(471),
  [923] = {.count = 1, .reusable = true}, REDUCE(sym_symbol_array, 2, .alias_sequence_id = 4),
  [925] = {.count = 1, .reusable = false}, REDUCE(sym_symbol_array, 2, .alias_sequence_id = 4),
  [927] = {.count = 1, .reusable = true}, SHIFT(472),
  [929] = {.count = 1, .reusable = false}, SHIFT(473),
  [931] = {.count = 1, .reusable = true}, SHIFT(475),
  [933] = {.count = 1, .reusable = true}, SHIFT(476),
  [935] = {.count = 1, .reusable = true}, REDUCE(sym_unary, 2),
  [937] = {.count = 1, .reusable = false}, REDUCE(sym_unary, 2),
  [939] = {.count = 1, .reusable = false}, SHIFT(478),
  [941] = {.count = 1, .reusable = true}, SHIFT(479),
  [943] = {.count = 1, .reusable = true}, SHIFT(480),
  [945] = {.count = 1, .reusable = false}, SHIFT(481),
  [947] = {.count = 1, .reusable = false}, SHIFT(482),
  [949] = {.count = 1, .reusable = false}, SHIFT(483),
  [951] = {.count = 1, .reusable = false}, SHIFT(484),
  [953] = {.count = 1, .reusable = false}, SHIFT(479),
  [955] = {.count = 1, .reusable = true}, SHIFT(485),
  [957] = {.count = 1, .reusable = false}, SHIFT(485),
  [959] = {.count = 1, .reusable = true}, SHIFT(486),
  [961] = {.count = 1, .reusable = false}, SHIFT(491),
  [963] = {.count = 1, .reusable = true}, SHIFT(491),
  [965] = {.count = 1, .reusable = false}, SHIFT(487),
  [967] = {.count = 1, .reusable = true}, SHIFT(496),
  [969] = {.count = 1, .reusable = true}, SHIFT(498),
  [971] = {.count = 1, .reusable = true}, SHIFT(500),
  [973] = {.count = 1, .reusable = true}, SHIFT(502),
  [975] = {.count = 1, .reusable = true}, SHIFT(504),
  [977] = {.count = 1, .reusable = false}, SHIFT(505),
  [979] = {.count = 1, .reusable = true}, SHIFT(507),
  [981] = {.count = 1, .reusable = false}, SHIFT(508),
  [983] = {.count = 1, .reusable = true}, SHIFT(512),
  [985] = {.count = 1, .reusable = true}, SHIFT(510),
  [987] = {.count = 1, .reusable = false}, SHIFT(511),
  [989] = {.count = 1, .reusable = true}, SHIFT(515),
  [991] = {.count = 1, .reusable = true}, SHIFT(516),
  [993] = {.count = 1, .reusable = true}, REDUCE(sym_hash, 2),
  [995] = {.count = 1, .reusable = false}, REDUCE(sym_hash, 2),
  [997] = {.count = 1, .reusable = true}, SHIFT(519),
  [999] = {.count = 1, .reusable = false}, SHIFT(521),
  [1001] = {.count = 1, .reusable = true}, SHIFT(523),
  [1003] = {.count = 1, .reusable = true}, SHIFT(525),
  [1005] = {.count = 1, .reusable = true}, SHIFT(538),
  [1007] = {.count = 1, .reusable = true}, SHIFT(526),
  [1009] = {.count = 1, .reusable = true}, SHIFT(527),
  [1011] = {.count = 1, .reusable = false}, SHIFT(528),
  [1013] = {.count = 1, .reusable = false}, SHIFT(529),
  [1015] = {.count = 1, .reusable = false}, SHIFT(530),
  [1017] = {.count = 1, .reusable = false}, SHIFT(531),
  [1019] = {.count = 1, .reusable = false}, SHIFT(538),
  [1021] = {.count = 1, .reusable = false}, SHIFT(526),
  [1023] = {.count = 1, .reusable = true}, SHIFT(532),
  [1025] = {.count = 1, .reusable = false}, SHIFT(532),
  [1027] = {.count = 1, .reusable = true}, SHIFT(533),
  [1029] = {.count = 1, .reusable = false}, SHIFT(539),
  [1031] = {.count = 1, .reusable = true}, SHIFT(539),
  [1033] = {.count = 1, .reusable = false}, SHIFT(534),
  [1035] = {.count = 1, .reusable = false}, SHIFT(535),
  [1037] = {.count = 1, .reusable = false}, SHIFT(536),
  [1039] = {.count = 1, .reusable = true}, SHIFT(543),
  [1041] = {.count = 1, .reusable = false}, SHIFT(544),
  [1043] = {.count = 1, .reusable = false}, SHIFT(546),
  [1045] = {.count = 1, .reusable = true}, SHIFT(548),
  [1047] = {.count = 1, .reusable = true}, SHIFT(549),
  [1049] = {.count = 1, .reusable = true}, SHIFT(550),
  [1051] = {.count = 1, .reusable = true}, SHIFT(551),
  [1053] = {.count = 1, .reusable = false}, SHIFT(320),
  [1055] = {.count = 1, .reusable = false}, SHIFT(321),
  [1057] = {.count = 1, .reusable = false}, SHIFT(553),
  [1059] = {.count = 1, .reusable = false}, SHIFT(554),
  [1061] = {.count = 1, .reusable = false}, SHIFT(555),
  [1063] = {.count = 1, .reusable = false}, SHIFT(556),
  [1065] = {.count = 1, .reusable = true}, SHIFT(557),
  [1067] = {.count = 1, .reusable = true}, SHIFT(558),
  [1069] = {.count = 1, .reusable = false}, SHIFT(558),
  [1071] = {.count = 1, .reusable = false}, SHIFT(559),
  [1073] = {.count = 1, .reusable = true}, SHIFT(559),
  [1075] = {.count = 1, .reusable = false}, SHIFT(560),
  [1077] = {.count = 1, .reusable = true}, SHIFT(562),
  [1079] = {.count = 1, .reusable = false}, SHIFT(562),
  [1081] = {.count = 1, .reusable = false}, SHIFT(344),
  [1083] = {.count = 1, .reusable = true}, SHIFT(578),
  [1085] = {.count = 1, .reusable = true}, SHIFT(584),
  [1087] = {.count = 1, .reusable = false}, SHIFT(583),
  [1089] = {.count = 1, .reusable = true}, REDUCE(sym__variable, 1),
  [1091] = {.count = 1, .reusable = false}, REDUCE(sym__variable, 1),
  [1093] = {.count = 1, .reusable = false}, SHIFT(587),
  [1095] = {.count = 1, .reusable = false}, SHIFT(588),
  [1097] = {.count = 1, .reusable = true}, SHIFT(589),
  [1099] = {.count = 1, .reusable = true}, SHIFT(591),
  [1101] = {.count = 1, .reusable = false}, SHIFT(592),
  [1103] = {.count = 1, .reusable = true}, SHIFT(595),
  [1105] = {.count = 1, .reusable = true}, SHIFT(596),
  [1107] = {.count = 1, .reusable = false}, SHIFT(597),
  [1109] = {.count = 1, .reusable = false}, SHIFT(598),
  [1111] = {.count = 1, .reusable = false}, SHIFT(599),
  [1113] = {.count = 1, .reusable = true}, SHIFT(600),
  [1115] = {.count = 1, .reusable = false}, SHIFT(601),
  [1117] = {.count = 1, .reusable = true}, SHIFT(601),
  [1119] = {.count = 1, .reusable = true}, SHIFT(602),
  [1121] = {.count = 1, .reusable = true}, SHIFT(603),
  [1123] = {.count = 1, .reusable = true}, SHIFT(604),
  [1125] = {.count = 1, .reusable = false}, SHIFT(603),
  [1127] = {.count = 1, .reusable = true}, SHIFT(599),
  [1129] = {.count = 1, .reusable = true}, SHIFT(597),
  [1131] = {.count = 1, .reusable = false}, SHIFT(605),
  [1133] = {.count = 1, .reusable = true}, SHIFT(606),
  [1135] = {.count = 1, .reusable = true}, SHIFT(607),
  [1137] = {.count = 1, .reusable = true}, SHIFT(605),
  [1139] = {.count = 1, .reusable = true}, SHIFT(608),
  [1141] = {.count = 1, .reusable = true}, SHIFT(609),
  [1143] = {.count = 1, .reusable = true}, SHIFT(610),
  [1145] = {.count = 1, .reusable = true}, SHIFT(611),
  [1147] = {.count = 1, .reusable = true}, SHIFT(612),
  [1149] = {.count = 1, .reusable = true}, SHIFT(613),
  [1151] = {.count = 1, .reusable = true}, SHIFT(614),
  [1153] = {.count = 1, .reusable = true}, SHIFT(645),
  [1155] = {.count = 1, .reusable = true}, SHIFT(615),
  [1157] = {.count = 1, .reusable = true}, SHIFT(616),
  [1159] = {.count = 1, .reusable = true}, SHIFT(617),
  [1161] = {.count = 1, .reusable = true}, SHIFT(618),
  [1163] = {.count = 1, .reusable = true}, SHIFT(619),
  [1165] = {.count = 1, .reusable = false}, SHIFT(620),
  [1167] = {.count = 1, .reusable = false}, SHIFT(621),
  [1169] = {.count = 1, .reusable = false}, SHIFT(623),
  [1171] = {.count = 1, .reusable = false}, SHIFT(624),
  [1173] = {.count = 1, .reusable = false}, SHIFT(625),
  [1175] = {.count = 1, .reusable = false}, SHIFT(626),
  [1177] = {.count = 1, .reusable = false}, SHIFT(627),
  [1179] = {.count = 1, .reusable = false}, SHIFT(628),
  [1181] = {.count = 1, .reusable = false}, SHIFT(645),
  [1183] = {.count = 1, .reusable = false}, SHIFT(629),
  [1185] = {.count = 1, .reusable = false}, SHIFT(630),
  [1187] = {.count = 1, .reusable = false}, SHIFT(631),
  [1189] = {.count = 1, .reusable = false}, SHIFT(632),
  [1191] = {.count = 1, .reusable = false}, SHIFT(633),
  [1193] = {.count = 1, .reusable = false}, SHIFT(634),
  [1195] = {.count = 1, .reusable = false}, SHIFT(635),
  [1197] = {.count = 1, .reusable = false}, SHIFT(636),
  [1199] = {.count = 1, .reusable = true}, SHIFT(637),
  [1201] = {.count = 1, .reusable = true}, SHIFT(638),
  [1203] = {.count = 1, .reusable = false}, SHIFT(638),
  [1205] = {.count = 1, .reusable = false}, SHIFT(639),
  [1207] = {.count = 1, .reusable = true}, SHIFT(639),
  [1209] = {.count = 1, .reusable = false}, SHIFT(640),
  [1211] = {.count = 1, .reusable = true}, SHIFT(646),
  [1213] = {.count = 1, .reusable = false}, SHIFT(641),
  [1215] = {.count = 1, .reusable = false}, SHIFT(646),
  [1217] = {.count = 1, .reusable = false}, SHIFT(642),
  [1219] = {.count = 1, .reusable = true}, SHIFT(643),
  [1221] = {.count = 1, .reusable = true}, REDUCE(sym_pair, 1),
  [1223] = {.count = 1, .reusable = true}, SHIFT(654),
  [1225] = {.count = 1, .reusable = false}, SHIFT(654),
  [1227] = {.count = 1, .reusable = true}, SHIFT(655),
  [1229] = {.count = 1, .reusable = false}, SHIFT(515),
  [1231] = {.count = 1, .reusable = true}, SHIFT(657),
  [1233] = {.count = 1, .reusable = true}, REDUCE(sym__hash_items, 1),
  [1235] = {.count = 1, .reusable = true}, SHIFT(659),
  [1237] = {.count = 1, .reusable = true}, SHIFT(660),
  [1239] = {.count = 1, .reusable = true}, SHIFT(662),
  [1241] = {.count = 1, .reusable = true}, SHIFT(664),
  [1243] = {.count = 1, .reusable = false}, SHIFT(665),
  [1245] = {.count = 1, .reusable = false}, SHIFT(666),
  [1247] = {.count = 1, .reusable = false}, SHIFT(667),
  [1249] = {.count = 1, .reusable = false}, SHIFT(668),
  [1251] = {.count = 1, .reusable = false}, SHIFT(664),
  [1253] = {.count = 1, .reusable = true}, SHIFT(669),
  [1255] = {.count = 1, .reusable = false}, SHIFT(669),
  [1257] = {.count = 1, .reusable = true}, SHIFT(670),
  [1259] = {.count = 1, .reusable = false}, SHIFT(672),
  [1261] = {.count = 1, .reusable = true}, SHIFT(672),
  [1263] = {.count = 1, .reusable = true}, REDUCE(sym_operator, 1),
  [1265] = {.count = 1, .reusable = false}, REDUCE(sym_operator, 1),
  [1267] = {.count = 1, .reusable = true}, REDUCE(sym__method_name, 1),
  [1269] = {.count = 1, .reusable = false}, REDUCE(sym__method_name, 1),
  [1271] = {.count = 1, .reusable = true}, SHIFT(676),
  [1273] = {.count = 1, .reusable = true}, REDUCE(sym_method, 2),
  [1275] = {.count = 1, .reusable = false}, REDUCE(sym_method, 2),
  [1277] = {.count = 1, .reusable = true}, SHIFT(677),
  [1279] = {.count = 1, .reusable = true}, SHIFT(683),
  [1281] = {.count = 1, .reusable = true}, SHIFT(678),
  [1283] = {.count = 1, .reusable = false}, SHIFT(679),
  [1285] = {.count = 1, .reusable = true}, SHIFT(680),
  [1287] = {.count = 1, .reusable = true}, SHIFT(681),
  [1289] = {.count = 1, .reusable = true}, SHIFT(682),
  [1291] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_statements, 2),
  [1293] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_statements, 2),
  [1295] = {.count = 1, .reusable = false}, SHIFT(687),
  [1297] = {.count = 1, .reusable = true}, SHIFT(687),
  [1299] = {.count = 1, .reusable = true}, SHIFT(688),
  [1301] = {.count = 1, .reusable = true}, SHIFT(689),
  [1303] = {.count = 1, .reusable = true}, SHIFT(690),
  [1305] = {.count = 1, .reusable = true}, SHIFT(691),
  [1307] = {.count = 1, .reusable = false}, SHIFT(693),
  [1309] = {.count = 1, .reusable = false}, SHIFT(694),
  [1311] = {.count = 1, .reusable = false}, SHIFT(695),
  [1313] = {.count = 1, .reusable = false}, SHIFT(696),
  [1315] = {.count = 1, .reusable = true}, SHIFT(697),
  [1317] = {.count = 1, .reusable = false}, SHIFT(697),
  [1319] = {.count = 1, .reusable = false}, SHIFT(698),
  [1321] = {.count = 1, .reusable = true}, SHIFT(698),
  [1323] = {.count = 1, .reusable = false}, SHIFT(699),
  [1325] = {.count = 1, .reusable = true}, SHIFT(701),
  [1327] = {.count = 1, .reusable = false}, SHIFT(701),
  [1329] = {.count = 1, .reusable = true}, SHIFT(708),
  [1331] = {.count = 1, .reusable = true}, SHIFT(709),
  [1333] = {.count = 1, .reusable = true}, SHIFT(710),
  [1335] = {.count = 1, .reusable = true}, SHIFT(711),
  [1337] = {.count = 1, .reusable = true}, SHIFT(712),
  [1339] = {.count = 1, .reusable = true}, SHIFT(713),
  [1341] = {.count = 1, .reusable = true}, SHIFT(714),
  [1343] = {.count = 1, .reusable = true}, SHIFT(715),
  [1345] = {.count = 1, .reusable = true}, SHIFT(716),
  [1347] = {.count = 1, .reusable = false}, SHIFT(717),
  [1349] = {.count = 1, .reusable = false}, SHIFT(718),
  [1351] = {.count = 1, .reusable = false}, SHIFT(719),
  [1353] = {.count = 1, .reusable = true}, SHIFT(720),
  [1355] = {.count = 1, .reusable = false}, SHIFT(721),
  [1357] = {.count = 1, .reusable = true}, SHIFT(721),
  [1359] = {.count = 1, .reusable = true}, SHIFT(722),
  [1361] = {.count = 1, .reusable = true}, SHIFT(723),
  [1363] = {.count = 1, .reusable = true}, SHIFT(724),
  [1365] = {.count = 1, .reusable = false}, SHIFT(723),
  [1367] = {.count = 1, .reusable = true}, SHIFT(719),
  [1369] = {.count = 1, .reusable = true}, SHIFT(717),
  [1371] = {.count = 1, .reusable = true}, SHIFT(725),
  [1373] = {.count = 1, .reusable = true}, SHIFT(726),
  [1375] = {.count = 1, .reusable = true}, SHIFT(727),
  [1377] = {.count = 1, .reusable = true}, SHIFT(728),
  [1379] = {.count = 1, .reusable = false}, SHIFT(730),
  [1381] = {.count = 1, .reusable = false}, SHIFT(731),
  [1383] = {.count = 1, .reusable = false}, SHIFT(732),
  [1385] = {.count = 1, .reusable = false}, SHIFT(733),
  [1387] = {.count = 1, .reusable = true}, SHIFT(734),
  [1389] = {.count = 1, .reusable = false}, SHIFT(734),
  [1391] = {.count = 1, .reusable = false}, SHIFT(735),
  [1393] = {.count = 1, .reusable = true}, SHIFT(735),
  [1395] = {.count = 1, .reusable = false}, SHIFT(736),
  [1397] = {.count = 1, .reusable = true}, SHIFT(738),
  [1399] = {.count = 1, .reusable = false}, SHIFT(738),
  [1401] = {.count = 1, .reusable = true}, SHIFT(744),
  [1403] = {.count = 1, .reusable = true}, SHIFT(745),
  [1405] = {.count = 1, .reusable = true}, SHIFT(746),
  [1407] = {.count = 1, .reusable = false}, SHIFT(744),
  [1409] = {.count = 1, .reusable = true}, SHIFT(748),
  [1411] = {.count = 1, .reusable = true}, REDUCE(sym_scope_resolution, 2),
  [1413] = {.count = 1, .reusable = false}, REDUCE(sym_scope_resolution, 2),
  [1415] = {.count = 1, .reusable = true}, SHIFT(752),
  [1417] = {.count = 1, .reusable = true}, SHIFT(754),
  [1419] = {.count = 1, .reusable = true}, SHIFT(756),
  [1421] = {.count = 1, .reusable = true}, SHIFT(758),
  [1423] = {.count = 1, .reusable = true}, SHIFT(760),
  [1425] = {.count = 1, .reusable = false}, SHIFT(761),
  [1427] = {.count = 1, .reusable = true}, SHIFT(763),
  [1429] = {.count = 1, .reusable = false}, SHIFT(764),
  [1431] = {.count = 1, .reusable = true}, SHIFT(766),
  [1433] = {.count = 1, .reusable = true}, SHIFT(769),
  [1435] = {.count = 1, .reusable = false}, SHIFT(771),
  [1437] = {.count = 1, .reusable = true}, SHIFT(773),
  [1439] = {.count = 1, .reusable = true}, SHIFT(775),
  [1441] = {.count = 1, .reusable = true}, SHIFT(776),
  [1443] = {.count = 1, .reusable = false}, SHIFT(777),
  [1445] = {.count = 1, .reusable = false}, SHIFT(779),
  [1447] = {.count = 1, .reusable = true}, SHIFT(781),
  [1449] = {.count = 1, .reusable = true}, SHIFT(782),
  [1451] = {.count = 1, .reusable = true}, SHIFT(783),
  [1453] = {.count = 1, .reusable = true}, SHIFT(784),
  [1455] = {.count = 1, .reusable = true}, SHIFT(785),
  [1457] = {.count = 1, .reusable = false}, SHIFT(550),
  [1459] = {.count = 1, .reusable = false}, SHIFT(786),
  [1461] = {.count = 1, .reusable = true}, SHIFT(801),
  [1463] = {.count = 1, .reusable = true}, SHIFT(807),
  [1465] = {.count = 1, .reusable = false}, SHIFT(806),
  [1467] = {.count = 1, .reusable = true}, SHIFT(808),
  [1469] = {.count = 1, .reusable = true}, SHIFT(809),
  [1471] = {.count = 1, .reusable = true}, SHIFT(811),
  [1473] = {.count = 1, .reusable = false}, SHIFT(812),
  [1475] = {.count = 1, .reusable = true}, SHIFT(815),
  [1477] = {.count = 1, .reusable = true}, SHIFT(816),
  [1479] = {.count = 1, .reusable = true}, SHIFT(817),
  [1481] = {.count = 1, .reusable = true}, SHIFT(818),
  [1483] = {.count = 1, .reusable = true}, SHIFT(819),
  [1485] = {.count = 1, .reusable = true}, SHIFT(820),
  [1487] = {.count = 1, .reusable = true}, SHIFT(821),
  [1489] = {.count = 1, .reusable = true}, SHIFT(822),
  [1491] = {.count = 1, .reusable = true}, SHIFT(823),
  [1493] = {.count = 1, .reusable = false}, SHIFT(824),
  [1495] = {.count = 1, .reusable = false}, SHIFT(825),
  [1497] = {.count = 1, .reusable = false}, SHIFT(826),
  [1499] = {.count = 1, .reusable = false}, SHIFT(827),
  [1501] = {.count = 1, .reusable = false}, SHIFT(820),
  [1503] = {.count = 1, .reusable = true}, SHIFT(828),
  [1505] = {.count = 1, .reusable = false}, SHIFT(828),
  [1507] = {.count = 1, .reusable = true}, SHIFT(829),
  [1509] = {.count = 1, .reusable = false}, SHIFT(830),
  [1511] = {.count = 1, .reusable = true}, REDUCE(sym_rest_assignment, 2),
  [1513] = {.count = 1, .reusable = true}, SHIFT(841),
  [1515] = {.count = 1, .reusable = true}, SHIFT(844),
  [1517] = {.count = 1, .reusable = true}, SHIFT(842),
  [1519] = {.count = 1, .reusable = true}, SHIFT(845),
  [1521] = {.count = 1, .reusable = true}, SHIFT(846),
  [1523] = {.count = 1, .reusable = true}, SHIFT(847),
  [1525] = {.count = 1, .reusable = true}, SHIFT(848),
  [1527] = {.count = 1, .reusable = true}, SHIFT(849),
  [1529] = {.count = 1, .reusable = true}, SHIFT(850),
  [1531] = {.count = 1, .reusable = true}, SHIFT(851),
  [1533] = {.count = 1, .reusable = false}, SHIFT(852),
  [1535] = {.count = 1, .reusable = false}, SHIFT(853),
  [1537] = {.count = 1, .reusable = false}, SHIFT(854),
  [1539] = {.count = 1, .reusable = false}, SHIFT(855),
  [1541] = {.count = 1, .reusable = false}, SHIFT(848),
  [1543] = {.count = 1, .reusable = true}, SHIFT(856),
  [1545] = {.count = 1, .reusable = false}, SHIFT(856),
  [1547] = {.count = 1, .reusable = true}, SHIFT(857),
  [1549] = {.count = 1, .reusable = false}, SHIFT(858),
  [1551] = {.count = 1, .reusable = true}, SHIFT(866),
  [1553] = {.count = 1, .reusable = false}, SHIFT(865),
  [1555] = {.count = 1, .reusable = true}, SHIFT(867),
  [1557] = {.count = 1, .reusable = false}, SHIFT(868),
  [1559] = {.count = 1, .reusable = false}, SHIFT(869),
  [1561] = {.count = 1, .reusable = false}, SHIFT(870),
  [1563] = {.count = 1, .reusable = false}, SHIFT(871),
  [1565] = {.count = 1, .reusable = false}, SHIFT(867),
  [1567] = {.count = 1, .reusable = true}, SHIFT(872),
  [1569] = {.count = 1, .reusable = false}, SHIFT(872),
  [1571] = {.count = 1, .reusable = true}, SHIFT(873),
  [1573] = {.count = 1, .reusable = true}, SHIFT(200),
  [1575] = {.count = 1, .reusable = false}, SHIFT(198),
  [1577] = {.count = 1, .reusable = true}, SHIFT(881),
  [1579] = {.count = 1, .reusable = true}, SHIFT(882),
  [1581] = {.count = 1, .reusable = true}, SHIFT(884),
  [1583] = {.count = 1, .reusable = true}, SHIFT(885),
  [1585] = {.count = 1, .reusable = true}, SHIFT(886),
  [1587] = {.count = 1, .reusable = false}, SHIFT(888),
  [1589] = {.count = 1, .reusable = true}, SHIFT(893),
  [1591] = {.count = 1, .reusable = true}, SHIFT(894),
  [1593] = {.count = 1, .reusable = true}, SHIFT(895),
  [1595] = {.count = 1, .reusable = true}, SHIFT(896),
  [1597] = {.count = 1, .reusable = true}, SHIFT(897),
  [1599] = {.count = 1, .reusable = true}, SHIFT(898),
  [1601] = {.count = 1, .reusable = false}, SHIFT(899),
  [1603] = {.count = 1, .reusable = false}, SHIFT(900),
  [1605] = {.count = 1, .reusable = false}, SHIFT(901),
  [1607] = {.count = 1, .reusable = false}, SHIFT(902),
  [1609] = {.count = 1, .reusable = false}, SHIFT(895),
  [1611] = {.count = 1, .reusable = true}, SHIFT(903),
  [1613] = {.count = 1, .reusable = false}, SHIFT(903),
  [1615] = {.count = 1, .reusable = true}, SHIFT(904),
  [1617] = {.count = 1, .reusable = false}, SHIFT(905),
  [1619] = {.count = 1, .reusable = true}, SHIFT(907),
  [1621] = {.count = 1, .reusable = false}, SHIFT(907),
  [1623] = {.count = 1, .reusable = false}, SHIFT(915),
  [1625] = {.count = 1, .reusable = true}, REDUCE(sym__argument, 1),
  [1627] = {.count = 1, .reusable = true}, SHIFT(916),
  [1629] = {.count = 1, .reusable = true}, SHIFT(917),
  [1631] = {.count = 1, .reusable = false}, REDUCE(sym__argument, 1),
  [1633] = {.count = 1, .reusable = false}, SHIFT(918),
  [1635] = {.count = 1, .reusable = false}, SHIFT(919),
  [1637] = {.count = 1, .reusable = false}, SHIFT(920),
  [1639] = {.count = 1, .reusable = true}, SHIFT(921),
  [1641] = {.count = 1, .reusable = false}, SHIFT(922),
  [1643] = {.count = 1, .reusable = true}, SHIFT(922),
  [1645] = {.count = 1, .reusable = true}, SHIFT(924),
  [1647] = {.count = 1, .reusable = true}, SHIFT(925),
  [1649] = {.count = 1, .reusable = false}, SHIFT(924),
  [1651] = {.count = 1, .reusable = true}, SHIFT(920),
  [1653] = {.count = 1, .reusable = true}, SHIFT(918),
  [1655] = {.count = 1, .reusable = false}, SHIFT(926),
  [1657] = {.count = 1, .reusable = true}, SHIFT(927),
  [1659] = {.count = 1, .reusable = true}, SHIFT(928),
  [1661] = {.count = 1, .reusable = true}, SHIFT(926),
  [1663] = {.count = 1, .reusable = true}, SHIFT(929),
  [1665] = {.count = 1, .reusable = true}, SHIFT(930),
  [1667] = {.count = 1, .reusable = true}, SHIFT(931),
  [1669] = {.count = 1, .reusable = true}, SHIFT(932),
  [1671] = {.count = 1, .reusable = false}, SHIFT(934),
  [1673] = {.count = 1, .reusable = true}, SHIFT(935),
  [1675] = {.count = 1, .reusable = false}, SHIFT(936),
  [1677] = {.count = 1, .reusable = true}, REDUCE(sym_return, 2),
  [1679] = {.count = 1, .reusable = false}, REDUCE(sym_return, 2),
  [1681] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list, 1),
  [1683] = {.count = 1, .reusable = true}, SHIFT(943),
  [1685] = {.count = 1, .reusable = false}, REDUCE(sym_argument_list, 1),
  [1687] = {.count = 1, .reusable = true}, SHIFT(945),
  [1689] = {.count = 1, .reusable = true}, SHIFT(947),
  [1691] = {.count = 1, .reusable = false}, SHIFT(947),
  [1693] = {.count = 1, .reusable = true}, SHIFT(948),
  [1695] = {.count = 1, .reusable = false}, SHIFT(881),
  [1697] = {.count = 1, .reusable = true}, REDUCE(sym_yield, 2),
  [1699] = {.count = 1, .reusable = false}, REDUCE(sym_yield, 2),
  [1701] = {.count = 1, .reusable = true}, REDUCE(sym_break, 2),
  [1703] = {.count = 1, .reusable = false}, REDUCE(sym_break, 2),
  [1705] = {.count = 1, .reusable = true}, REDUCE(sym_next, 2),
  [1707] = {.count = 1, .reusable = false}, REDUCE(sym_next, 2),
  [1709] = {.count = 1, .reusable = true}, SHIFT(951),
  [1711] = {.count = 1, .reusable = true}, SHIFT(952),
  [1713] = {.count = 1, .reusable = true}, SHIFT(953),
  [1715] = {.count = 1, .reusable = true}, SHIFT(954),
  [1717] = {.count = 1, .reusable = false}, SHIFT(956),
  [1719] = {.count = 1, .reusable = false}, SHIFT(957),
  [1721] = {.count = 1, .reusable = false}, SHIFT(958),
  [1723] = {.count = 1, .reusable = false}, SHIFT(959),
  [1725] = {.count = 1, .reusable = true}, SHIFT(960),
  [1727] = {.count = 1, .reusable = false}, SHIFT(960),
  [1729] = {.count = 1, .reusable = false}, SHIFT(961),
  [1731] = {.count = 1, .reusable = true}, SHIFT(961),
  [1733] = {.count = 1, .reusable = false}, SHIFT(962),
  [1735] = {.count = 1, .reusable = true}, SHIFT(964),
  [1737] = {.count = 1, .reusable = false}, SHIFT(964),
  [1739] = {.count = 1, .reusable = true}, SHIFT(971),
  [1741] = {.count = 1, .reusable = true}, SHIFT(979),
  [1743] = {.count = 1, .reusable = true}, SHIFT(972),
  [1745] = {.count = 1, .reusable = true}, SHIFT(973),
  [1747] = {.count = 1, .reusable = true}, SHIFT(974),
  [1749] = {.count = 1, .reusable = true}, SHIFT(975),
  [1751] = {.count = 1, .reusable = true}, SHIFT(976),
  [1753] = {.count = 1, .reusable = true}, SHIFT(977),
  [1755] = {.count = 1, .reusable = true}, SHIFT(980),
  [1757] = {.count = 1, .reusable = true}, SHIFT(981),
  [1759] = {.count = 1, .reusable = false}, SHIFT(982),
  [1761] = {.count = 1, .reusable = false}, SHIFT(983),
  [1763] = {.count = 1, .reusable = false}, SHIFT(984),
  [1765] = {.count = 1, .reusable = true}, SHIFT(985),
  [1767] = {.count = 1, .reusable = false}, SHIFT(986),
  [1769] = {.count = 1, .reusable = true}, SHIFT(986),
  [1771] = {.count = 1, .reusable = true}, SHIFT(987),
  [1773] = {.count = 1, .reusable = true}, SHIFT(988),
  [1775] = {.count = 1, .reusable = true}, SHIFT(989),
  [1777] = {.count = 1, .reusable = false}, SHIFT(988),
  [1779] = {.count = 1, .reusable = true}, SHIFT(984),
  [1781] = {.count = 1, .reusable = true}, SHIFT(982),
  [1783] = {.count = 1, .reusable = true}, SHIFT(990),
  [1785] = {.count = 1, .reusable = true}, SHIFT(991),
  [1787] = {.count = 1, .reusable = true}, SHIFT(992),
  [1789] = {.count = 1, .reusable = true}, SHIFT(993),
  [1791] = {.count = 1, .reusable = false}, SHIFT(995),
  [1793] = {.count = 1, .reusable = false}, SHIFT(996),
  [1795] = {.count = 1, .reusable = false}, SHIFT(997),
  [1797] = {.count = 1, .reusable = false}, SHIFT(998),
  [1799] = {.count = 1, .reusable = true}, SHIFT(999),
  [1801] = {.count = 1, .reusable = false}, SHIFT(999),
  [1803] = {.count = 1, .reusable = false}, SHIFT(1000),
  [1805] = {.count = 1, .reusable = true}, SHIFT(1000),
  [1807] = {.count = 1, .reusable = false}, SHIFT(1001),
  [1809] = {.count = 1, .reusable = true}, SHIFT(1003),
  [1811] = {.count = 1, .reusable = false}, SHIFT(1003),
  [1813] = {.count = 1, .reusable = true}, SHIFT(1009),
  [1815] = {.count = 1, .reusable = false}, SHIFT(1009),
  [1817] = {.count = 1, .reusable = true}, SHIFT(1010),
  [1819] = {.count = 1, .reusable = true}, SHIFT(1014),
  [1821] = {.count = 1, .reusable = true}, SHIFT(1012),
  [1823] = {.count = 1, .reusable = true}, SHIFT(1016),
  [1825] = {.count = 1, .reusable = true}, SHIFT(1017),
  [1827] = {.count = 1, .reusable = true}, SHIFT(1018),
  [1829] = {.count = 1, .reusable = true}, SHIFT(1019),
  [1831] = {.count = 1, .reusable = false}, SHIFT(1021),
  [1833] = {.count = 1, .reusable = false}, SHIFT(1022),
  [1835] = {.count = 1, .reusable = false}, SHIFT(1023),
  [1837] = {.count = 1, .reusable = false}, SHIFT(1024),
  [1839] = {.count = 1, .reusable = true}, SHIFT(1025),
  [1841] = {.count = 1, .reusable = false}, SHIFT(1025),
  [1843] = {.count = 1, .reusable = false}, SHIFT(1026),
  [1845] = {.count = 1, .reusable = true}, SHIFT(1026),
  [1847] = {.count = 1, .reusable = false}, SHIFT(1027),
  [1849] = {.count = 1, .reusable = true}, SHIFT(1029),
  [1851] = {.count = 1, .reusable = false}, SHIFT(1029),
  [1853] = {.count = 1, .reusable = true}, SHIFT(1046),
  [1855] = {.count = 1, .reusable = true}, SHIFT(1036),
  [1857] = {.count = 1, .reusable = true}, SHIFT(1037),
  [1859] = {.count = 1, .reusable = false}, SHIFT(1038),
  [1861] = {.count = 1, .reusable = false}, SHIFT(1039),
  [1863] = {.count = 1, .reusable = false}, SHIFT(1040),
  [1865] = {.count = 1, .reusable = true}, SHIFT(1041),
  [1867] = {.count = 1, .reusable = false}, SHIFT(1042),
  [1869] = {.count = 1, .reusable = true}, SHIFT(1042),
  [1871] = {.count = 1, .reusable = true}, SHIFT(1043),
  [1873] = {.count = 1, .reusable = true}, SHIFT(1044),
  [1875] = {.count = 1, .reusable = true}, SHIFT(1045),
  [1877] = {.count = 1, .reusable = false}, SHIFT(1044),
  [1879] = {.count = 1, .reusable = true}, SHIFT(1040),
  [1881] = {.count = 1, .reusable = true}, SHIFT(1038),
  [1883] = {.count = 1, .reusable = true}, SHIFT(1047),
  [1885] = {.count = 1, .reusable = true}, SHIFT(1048),
  [1887] = {.count = 1, .reusable = true}, SHIFT(1049),
  [1889] = {.count = 1, .reusable = true}, SHIFT(1050),
  [1891] = {.count = 1, .reusable = true}, SHIFT(1051),
  [1893] = {.count = 1, .reusable = false}, SHIFT(1053),
  [1895] = {.count = 1, .reusable = false}, SHIFT(1054),
  [1897] = {.count = 1, .reusable = false}, SHIFT(1055),
  [1899] = {.count = 1, .reusable = false}, SHIFT(1056),
  [1901] = {.count = 1, .reusable = false}, SHIFT(405),
  [1903] = {.count = 1, .reusable = false}, SHIFT(406),
  [1905] = {.count = 1, .reusable = false}, SHIFT(407),
  [1907] = {.count = 1, .reusable = false}, SHIFT(408),
  [1909] = {.count = 1, .reusable = true}, SHIFT(1057),
  [1911] = {.count = 1, .reusable = false}, SHIFT(1057),
  [1913] = {.count = 1, .reusable = false}, SHIFT(1058),
  [1915] = {.count = 1, .reusable = true}, SHIFT(1058),
  [1917] = {.count = 1, .reusable = false}, SHIFT(1059),
  [1919] = {.count = 1, .reusable = true}, SHIFT(1061),
  [1921] = {.count = 1, .reusable = false}, SHIFT(1061),
  [1923] = {.count = 1, .reusable = true}, SHIFT(1068),
  [1925] = {.count = 1, .reusable = false}, SHIFT(1068),
  [1927] = {.count = 1, .reusable = true}, SHIFT(1069),
  [1929] = {.count = 1, .reusable = true}, SHIFT(1071),
  [1931] = {.count = 1, .reusable = false}, REDUCE(sym_rest_assignment, 1),
  [1933] = {.count = 1, .reusable = true}, SHIFT(1072),
  [1935] = {.count = 1, .reusable = true}, SHIFT(1073),
  [1937] = {.count = 1, .reusable = true}, SHIFT(1074),
  [1939] = {.count = 1, .reusable = true}, SHIFT(1075),
  [1941] = {.count = 1, .reusable = true}, SHIFT(1076),
  [1943] = {.count = 1, .reusable = false}, SHIFT(1077),
  [1945] = {.count = 1, .reusable = false}, SHIFT(1078),
  [1947] = {.count = 1, .reusable = false}, SHIFT(1079),
  [1949] = {.count = 1, .reusable = false}, SHIFT(1080),
  [1951] = {.count = 1, .reusable = false}, SHIFT(1074),
  [1953] = {.count = 1, .reusable = true}, SHIFT(1081),
  [1955] = {.count = 1, .reusable = false}, SHIFT(1081),
  [1957] = {.count = 1, .reusable = true}, SHIFT(1082),
  [1959] = {.count = 1, .reusable = false}, SHIFT(1083),
  [1961] = {.count = 1, .reusable = true}, SHIFT(1085),
  [1963] = {.count = 1, .reusable = false}, SHIFT(1085),
  [1965] = {.count = 1, .reusable = true}, SHIFT(1091),
  [1967] = {.count = 1, .reusable = true}, SHIFT(1093),
  [1969] = {.count = 1, .reusable = true}, SHIFT(1096),
  [1971] = {.count = 1, .reusable = true}, SHIFT(1097),
  [1973] = {.count = 1, .reusable = true}, SHIFT(1098),
  [1975] = {.count = 1, .reusable = true}, SHIFT(1099),
  [1977] = {.count = 1, .reusable = false}, SHIFT(1101),
  [1979] = {.count = 1, .reusable = false}, SHIFT(1102),
  [1981] = {.count = 1, .reusable = false}, SHIFT(1103),
  [1983] = {.count = 1, .reusable = false}, SHIFT(1104),
  [1985] = {.count = 1, .reusable = true}, SHIFT(1105),
  [1987] = {.count = 1, .reusable = false}, SHIFT(1105),
  [1989] = {.count = 1, .reusable = false}, SHIFT(1106),
  [1991] = {.count = 1, .reusable = true}, SHIFT(1106),
  [1993] = {.count = 1, .reusable = false}, SHIFT(1107),
  [1995] = {.count = 1, .reusable = true}, SHIFT(1109),
  [1997] = {.count = 1, .reusable = false}, SHIFT(1109),
  [1999] = {.count = 1, .reusable = true}, SHIFT(1126),
  [2001] = {.count = 1, .reusable = true}, SHIFT(1116),
  [2003] = {.count = 1, .reusable = true}, SHIFT(1117),
  [2005] = {.count = 1, .reusable = false}, SHIFT(1118),
  [2007] = {.count = 1, .reusable = false}, SHIFT(1119),
  [2009] = {.count = 1, .reusable = false}, SHIFT(1120),
  [2011] = {.count = 1, .reusable = true}, SHIFT(1121),
  [2013] = {.count = 1, .reusable = false}, SHIFT(1122),
  [2015] = {.count = 1, .reusable = true}, SHIFT(1122),
  [2017] = {.count = 1, .reusable = true}, SHIFT(1123),
  [2019] = {.count = 1, .reusable = true}, SHIFT(1124),
  [2021] = {.count = 1, .reusable = true}, SHIFT(1125),
  [2023] = {.count = 1, .reusable = false}, SHIFT(1124),
  [2025] = {.count = 1, .reusable = true}, SHIFT(1120),
  [2027] = {.count = 1, .reusable = true}, SHIFT(1118),
  [2029] = {.count = 1, .reusable = true}, SHIFT(1127),
  [2031] = {.count = 1, .reusable = false}, SHIFT(1127),
  [2033] = {.count = 1, .reusable = true}, SHIFT(1128),
  [2035] = {.count = 1, .reusable = true}, SHIFT(1134),
  [2037] = {.count = 1, .reusable = true}, SHIFT(1130),
  [2039] = {.count = 1, .reusable = true}, SHIFT(1131),
  [2041] = {.count = 1, .reusable = true}, SHIFT(1132),
  [2043] = {.count = 1, .reusable = true}, SHIFT(1137),
  [2045] = {.count = 1, .reusable = true}, SHIFT(1136),
  [2047] = {.count = 1, .reusable = true}, SHIFT(1139),
  [2049] = {.count = 1, .reusable = true}, SHIFT(1140),
  [2051] = {.count = 1, .reusable = true}, SHIFT(1141),
  [2053] = {.count = 1, .reusable = true}, SHIFT(1142),
  [2055] = {.count = 1, .reusable = false}, SHIFT(1144),
  [2057] = {.count = 1, .reusable = false}, SHIFT(1145),
  [2059] = {.count = 1, .reusable = false}, SHIFT(1146),
  [2061] = {.count = 1, .reusable = false}, SHIFT(1147),
  [2063] = {.count = 1, .reusable = true}, SHIFT(1148),
  [2065] = {.count = 1, .reusable = false}, SHIFT(1148),
  [2067] = {.count = 1, .reusable = false}, SHIFT(1149),
  [2069] = {.count = 1, .reusable = true}, SHIFT(1149),
  [2071] = {.count = 1, .reusable = false}, SHIFT(1150),
  [2073] = {.count = 1, .reusable = true}, SHIFT(1152),
  [2075] = {.count = 1, .reusable = false}, SHIFT(1152),
  [2077] = {.count = 1, .reusable = true}, SHIFT(1177),
  [2079] = {.count = 1, .reusable = true}, SHIFT(1158),
  [2081] = {.count = 1, .reusable = true}, SHIFT(1159),
  [2083] = {.count = 1, .reusable = false}, SHIFT(1160),
  [2085] = {.count = 1, .reusable = false}, SHIFT(1161),
  [2087] = {.count = 1, .reusable = false}, SHIFT(1162),
  [2089] = {.count = 1, .reusable = false}, SHIFT(1163),
  [2091] = {.count = 1, .reusable = false}, SHIFT(1164),
  [2093] = {.count = 1, .reusable = true}, SHIFT(1165),
  [2095] = {.count = 1, .reusable = false}, SHIFT(1159),
  [2097] = {.count = 1, .reusable = true}, SHIFT(1166),
  [2099] = {.count = 1, .reusable = false}, SHIFT(1166),
  [2101] = {.count = 1, .reusable = true}, SHIFT(1167),
  [2103] = {.count = 1, .reusable = false}, SHIFT(1172),
  [2105] = {.count = 1, .reusable = true}, SHIFT(1172),
  [2107] = {.count = 1, .reusable = true}, SHIFT(1193),
  [2109] = {.count = 1, .reusable = true}, SHIFT(1178),
  [2111] = {.count = 1, .reusable = false}, REDUCE(sym_else, 1),
  [2113] = {.count = 1, .reusable = false}, SHIFT(1179),
  [2115] = {.count = 1, .reusable = false}, SHIFT(1180),
  [2117] = {.count = 1, .reusable = false}, SHIFT(1181),
  [2119] = {.count = 1, .reusable = false}, SHIFT(1182),
  [2121] = {.count = 1, .reusable = false}, SHIFT(1178),
  [2123] = {.count = 1, .reusable = true}, SHIFT(1183),
  [2125] = {.count = 1, .reusable = false}, SHIFT(1183),
  [2127] = {.count = 1, .reusable = true}, SHIFT(1184),
  [2129] = {.count = 1, .reusable = false}, SHIFT(1189),
  [2131] = {.count = 1, .reusable = true}, SHIFT(1189),
  [2133] = {.count = 1, .reusable = false}, SHIFT(1185),
  [2135] = {.count = 1, .reusable = true}, SHIFT(1195),
  [2137] = {.count = 1, .reusable = false}, REDUCE(sym_ensure, 1),
  [2139] = {.count = 1, .reusable = false}, SHIFT(1196),
  [2141] = {.count = 1, .reusable = false}, SHIFT(1197),
  [2143] = {.count = 1, .reusable = false}, SHIFT(1198),
  [2145] = {.count = 1, .reusable = false}, SHIFT(1199),
  [2147] = {.count = 1, .reusable = false}, SHIFT(1195),
  [2149] = {.count = 1, .reusable = true}, SHIFT(1200),
  [2151] = {.count = 1, .reusable = false}, SHIFT(1200),
  [2153] = {.count = 1, .reusable = true}, SHIFT(1201),
  [2155] = {.count = 1, .reusable = false}, SHIFT(1206),
  [2157] = {.count = 1, .reusable = true}, SHIFT(1206),
  [2159] = {.count = 1, .reusable = false}, SHIFT(1202),
  [2161] = {.count = 1, .reusable = true}, SHIFT(1212),
  [2163] = {.count = 1, .reusable = true}, SHIFT(1213),
  [2165] = {.count = 1, .reusable = true}, SHIFT(278),
  [2167] = {.count = 1, .reusable = true}, SHIFT(279),
  [2169] = {.count = 1, .reusable = true}, SHIFT(280),
  [2171] = {.count = 1, .reusable = true}, SHIFT(1217),
  [2173] = {.count = 1, .reusable = true}, SHIFT(1218),
  [2175] = {.count = 1, .reusable = true}, SHIFT(1219),
  [2177] = {.count = 1, .reusable = true}, SHIFT(1220),
  [2179] = {.count = 1, .reusable = true}, SHIFT(1221),
  [2181] = {.count = 1, .reusable = true}, REDUCE(sym_begin, 2),
  [2183] = {.count = 1, .reusable = false}, REDUCE(sym_begin, 2),
  [2185] = {.count = 1, .reusable = true}, SHIFT(1222),
  [2187] = {.count = 1, .reusable = true}, SHIFT(1223),
  [2189] = {.count = 1, .reusable = false}, SHIFT(1224),
  [2191] = {.count = 1, .reusable = false}, SHIFT(1225),
  [2193] = {.count = 1, .reusable = false}, SHIFT(1226),
  [2195] = {.count = 1, .reusable = true}, SHIFT(1227),
  [2197] = {.count = 1, .reusable = false}, SHIFT(1228),
  [2199] = {.count = 1, .reusable = true}, SHIFT(1228),
  [2201] = {.count = 1, .reusable = true}, SHIFT(1229),
  [2203] = {.count = 1, .reusable = true}, SHIFT(1230),
  [2205] = {.count = 1, .reusable = true}, SHIFT(1231),
  [2207] = {.count = 1, .reusable = false}, SHIFT(1230),
  [2209] = {.count = 1, .reusable = true}, SHIFT(1226),
  [2211] = {.count = 1, .reusable = true}, SHIFT(1224),
  [2213] = {.count = 1, .reusable = true}, SHIFT(1232),
  [2215] = {.count = 1, .reusable = true}, SHIFT(1233),
  [2217] = {.count = 1, .reusable = true}, SHIFT(1234),
  [2219] = {.count = 1, .reusable = true}, SHIFT(1235),
  [2221] = {.count = 1, .reusable = false}, SHIFT(1237),
  [2223] = {.count = 1, .reusable = false}, SHIFT(1238),
  [2225] = {.count = 1, .reusable = false}, SHIFT(1239),
  [2227] = {.count = 1, .reusable = false}, SHIFT(1240),
  [2229] = {.count = 1, .reusable = true}, SHIFT(1241),
  [2231] = {.count = 1, .reusable = false}, SHIFT(1241),
  [2233] = {.count = 1, .reusable = false}, SHIFT(1242),
  [2235] = {.count = 1, .reusable = true}, SHIFT(1242),
  [2237] = {.count = 1, .reusable = false}, SHIFT(1243),
  [2239] = {.count = 1, .reusable = true}, SHIFT(1245),
  [2241] = {.count = 1, .reusable = false}, SHIFT(1245),
  [2243] = {.count = 1, .reusable = true}, SHIFT(1251),
  [2245] = {.count = 1, .reusable = false}, SHIFT(1251),
  [2247] = {.count = 1, .reusable = true}, SHIFT(1252),
  [2249] = {.count = 1, .reusable = false}, SHIFT(1254),
  [2251] = {.count = 1, .reusable = true}, REDUCE(sym_undef, 2),
  [2253] = {.count = 1, .reusable = true}, SHIFT(1257),
  [2255] = {.count = 1, .reusable = true}, SHIFT(1259),
  [2257] = {.count = 1, .reusable = false}, SHIFT(1261),
  [2259] = {.count = 1, .reusable = true}, SHIFT(1262),
  [2261] = {.count = 1, .reusable = true}, REDUCE(sym_rational, 2),
  [2263] = {.count = 1, .reusable = false}, REDUCE(sym_rational, 2),
  [2265] = {.count = 1, .reusable = true}, SHIFT(1263),
  [2267] = {.count = 1, .reusable = true}, SHIFT(1265),
  [2269] = {.count = 1, .reusable = true}, SHIFT(1267),
  [2271] = {.count = 1, .reusable = true}, SHIFT(1269),
  [2273] = {.count = 1, .reusable = true}, SHIFT(1271),
  [2275] = {.count = 1, .reusable = false}, SHIFT(1272),
  [2277] = {.count = 1, .reusable = true}, SHIFT(1274),
  [2279] = {.count = 1, .reusable = false}, SHIFT(1275),
  [2281] = {.count = 1, .reusable = true}, SHIFT(1277),
  [2283] = {.count = 1, .reusable = false}, SHIFT(1278),
  [2285] = {.count = 1, .reusable = false}, SHIFT(1279),
  [2287] = {.count = 1, .reusable = false}, SHIFT(1280),
  [2289] = {.count = 1, .reusable = false}, SHIFT(1281),
  [2291] = {.count = 1, .reusable = false}, SHIFT(1277),
  [2293] = {.count = 1, .reusable = true}, SHIFT(1282),
  [2295] = {.count = 1, .reusable = false}, SHIFT(1282),
  [2297] = {.count = 1, .reusable = true}, SHIFT(1283),
  [2299] = {.count = 1, .reusable = false}, SHIFT(1285),
  [2301] = {.count = 1, .reusable = true}, SHIFT(1285),
  [2303] = {.count = 1, .reusable = true}, SHIFT(1292),
  [2305] = {.count = 1, .reusable = true}, SHIFT(1293),
  [2307] = {.count = 1, .reusable = true}, SHIFT(1296),
  [2309] = {.count = 1, .reusable = false}, SHIFT(1298),
  [2311] = {.count = 1, .reusable = true}, SHIFT(1300),
  [2313] = {.count = 1, .reusable = true}, SHIFT(1302),
  [2315] = {.count = 1, .reusable = true}, SHIFT(1304),
  [2317] = {.count = 1, .reusable = false}, SHIFT(1305),
  [2319] = {.count = 1, .reusable = false}, SHIFT(1307),
  [2321] = {.count = 1, .reusable = true}, SHIFT(1309),
  [2323] = {.count = 1, .reusable = true}, SHIFT(1310),
  [2325] = {.count = 1, .reusable = true}, SHIFT(1311),
  [2327] = {.count = 1, .reusable = true}, SHIFT(1312),
  [2329] = {.count = 1, .reusable = true}, SHIFT(1314),
  [2331] = {.count = 1, .reusable = false}, SHIFT(1314),
  [2333] = {.count = 1, .reusable = false}, SHIFT(1315),
  [2335] = {.count = 1, .reusable = true}, SHIFT(1315),
  [2337] = {.count = 1, .reusable = false}, SHIFT(1316),
  [2339] = {.count = 1, .reusable = true}, SHIFT(1333),
  [2341] = {.count = 1, .reusable = true}, SHIFT(1339),
  [2343] = {.count = 1, .reusable = false}, SHIFT(1338),
  [2345] = {.count = 1, .reusable = true}, REDUCE(sym_array, 2),
  [2347] = {.count = 1, .reusable = false}, REDUCE(sym_array, 2),
  [2349] = {.count = 1, .reusable = false}, SHIFT(1342),
  [2351] = {.count = 1, .reusable = false}, SHIFT(1343),
  [2353] = {.count = 1, .reusable = true}, SHIFT(1344),
  [2355] = {.count = 1, .reusable = true}, SHIFT(1346),
  [2357] = {.count = 1, .reusable = false}, SHIFT(1347),
  [2359] = {.count = 1, .reusable = true}, SHIFT(1350),
  [2361] = {.count = 1, .reusable = true}, SHIFT(1351),
  [2363] = {.count = 1, .reusable = false}, SHIFT(1352),
  [2365] = {.count = 1, .reusable = false}, SHIFT(1353),
  [2367] = {.count = 1, .reusable = false}, SHIFT(1354),
  [2369] = {.count = 1, .reusable = true}, SHIFT(1355),
  [2371] = {.count = 1, .reusable = false}, SHIFT(1356),
  [2373] = {.count = 1, .reusable = true}, SHIFT(1356),
  [2375] = {.count = 1, .reusable = true}, SHIFT(1357),
  [2377] = {.count = 1, .reusable = true}, SHIFT(1358),
  [2379] = {.count = 1, .reusable = true}, SHIFT(1359),
  [2381] = {.count = 1, .reusable = false}, SHIFT(1358),
  [2383] = {.count = 1, .reusable = true}, SHIFT(1354),
  [2385] = {.count = 1, .reusable = true}, SHIFT(1352),
  [2387] = {.count = 1, .reusable = false}, SHIFT(1360),
  [2389] = {.count = 1, .reusable = true}, SHIFT(1361),
  [2391] = {.count = 1, .reusable = true}, SHIFT(1362),
  [2393] = {.count = 1, .reusable = true}, SHIFT(1360),
  [2395] = {.count = 1, .reusable = true}, SHIFT(1363),
  [2397] = {.count = 1, .reusable = true}, SHIFT(1364),
  [2399] = {.count = 1, .reusable = true}, SHIFT(1365),
  [2401] = {.count = 1, .reusable = true}, SHIFT(1366),
  [2403] = {.count = 1, .reusable = true}, SHIFT(1367),
  [2405] = {.count = 1, .reusable = false}, SHIFT(1369),
  [2407] = {.count = 1, .reusable = false}, SHIFT(1370),
  [2409] = {.count = 1, .reusable = false}, SHIFT(1371),
  [2411] = {.count = 1, .reusable = false}, SHIFT(1372),
  [2413] = {.count = 1, .reusable = false}, SHIFT(1373),
  [2415] = {.count = 1, .reusable = true}, SHIFT(1374),
  [2417] = {.count = 1, .reusable = false}, SHIFT(1374),
  [2419] = {.count = 1, .reusable = false}, SHIFT(1375),
  [2421] = {.count = 1, .reusable = true}, SHIFT(1375),
  [2423] = {.count = 1, .reusable = false}, SHIFT(1376),
  [2425] = {.count = 1, .reusable = true}, SHIFT(1378),
  [2427] = {.count = 1, .reusable = false}, SHIFT(1378),
  [2429] = {.count = 1, .reusable = true}, SHIFT(1386),
  [2431] = {.count = 1, .reusable = true}, SHIFT(1387),
  [2433] = {.count = 1, .reusable = true}, REDUCE(sym__argument_list_with_trailing_comma, 1),
  [2435] = {.count = 1, .reusable = true}, SHIFT(1390),
  [2437] = {.count = 1, .reusable = false}, SHIFT(1390),
  [2439] = {.count = 1, .reusable = true}, SHIFT(1391),
  [2441] = {.count = 1, .reusable = false}, SHIFT(1292),
  [2443] = {.count = 1, .reusable = true}, SHIFT(1393),
  [2445] = {.count = 1, .reusable = true}, SHIFT(1394),
  [2447] = {.count = 1, .reusable = true}, SHIFT(1397),
  [2449] = {.count = 1, .reusable = true}, SHIFT(1398),
  [2451] = {.count = 1, .reusable = true}, SHIFT(1399),
  [2453] = {.count = 1, .reusable = true}, REDUCE(sym_splat_parameter, 1),
  [2455] = {.count = 1, .reusable = false}, REDUCE(sym_splat_parameter, 1),
  [2457] = {.count = 1, .reusable = false}, SHIFT(1401),
  [2459] = {.count = 1, .reusable = true}, REDUCE(sym_hash_splat_parameter, 1),
  [2461] = {.count = 1, .reusable = false}, REDUCE(sym_hash_splat_parameter, 1),
  [2463] = {.count = 1, .reusable = false}, SHIFT(1402),
  [2465] = {.count = 1, .reusable = true}, SHIFT(1403),
  [2467] = {.count = 1, .reusable = true}, SHIFT(1408),
  [2469] = {.count = 1, .reusable = true}, SHIFT(1404),
  [2471] = {.count = 1, .reusable = false}, SHIFT(1405),
  [2473] = {.count = 1, .reusable = true}, REDUCE(sym__simple_formal_parameter, 1),
  [2475] = {.count = 1, .reusable = true}, SHIFT(1409),
  [2477] = {.count = 1, .reusable = true}, SHIFT(1410),
  [2479] = {.count = 1, .reusable = true}, SHIFT(359),
  [2481] = {.count = 1, .reusable = true}, REDUCE(sym_lambda_parameters, 1),
  [2483] = {.count = 1, .reusable = true}, SHIFT(1412),
  [2485] = {.count = 1, .reusable = true}, REDUCE(sym_lambda, 2),
  [2487] = {.count = 1, .reusable = false}, REDUCE(sym_lambda, 2),
  [2489] = {.count = 1, .reusable = true}, SHIFT(1414),
  [2491] = {.count = 1, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2),
  [2493] = {.count = 1, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2),
  [2495] = {.count = 1, .reusable = true}, SHIFT(1425),
  [2497] = {.count = 1, .reusable = true}, SHIFT(1426),
  [2499] = {.count = 1, .reusable = false}, SHIFT(1427),
  [2501] = {.count = 1, .reusable = false}, SHIFT(1428),
  [2503] = {.count = 1, .reusable = false}, SHIFT(1429),
  [2505] = {.count = 1, .reusable = false}, SHIFT(1430),
  [2507] = {.count = 1, .reusable = false}, SHIFT(1426),
  [2509] = {.count = 1, .reusable = true}, SHIFT(1431),
  [2511] = {.count = 1, .reusable = false}, SHIFT(1431),
  [2513] = {.count = 1, .reusable = true}, SHIFT(1432),
  [2515] = {.count = 1, .reusable = false}, SHIFT(1434),
  [2517] = {.count = 1, .reusable = true}, SHIFT(1434),
  [2519] = {.count = 1, .reusable = true}, SHIFT(1442),
  [2521] = {.count = 1, .reusable = true}, SHIFT(1443),
  [2523] = {.count = 1, .reusable = false}, SHIFT(1443),
  [2525] = {.count = 1, .reusable = true}, SHIFT(1444),
  [2527] = {.count = 1, .reusable = true}, SHIFT(1445),
  [2529] = {.count = 1, .reusable = true}, SHIFT(1448),
  [2531] = {.count = 1, .reusable = true}, SHIFT(1450),
  [2533] = {.count = 1, .reusable = true}, SHIFT(1451),
  [2535] = {.count = 1, .reusable = true}, SHIFT(1453),
  [2537] = {.count = 1, .reusable = true}, SHIFT(1455),
  [2539] = {.count = 1, .reusable = true}, SHIFT(1457),
  [2541] = {.count = 1, .reusable = true}, SHIFT(1459),
  [2543] = {.count = 1, .reusable = false}, SHIFT(1460),
  [2545] = {.count = 1, .reusable = true}, SHIFT(1462),
  [2547] = {.count = 1, .reusable = false}, SHIFT(1463),
  [2549] = {.count = 1, .reusable = true}, SHIFT(1465),
  [2551] = {.count = 1, .reusable = true}, SHIFT(1466),
  [2553] = {.count = 1, .reusable = true}, SHIFT(1467),
  [2555] = {.count = 1, .reusable = true}, SHIFT(1468),
  [2557] = {.count = 1, .reusable = true}, SHIFT(1469),
  [2559] = {.count = 1, .reusable = true}, SHIFT(1470),
  [2561] = {.count = 1, .reusable = true}, SHIFT(1471),
  [2563] = {.count = 1, .reusable = true}, SHIFT(1495),
  [2565] = {.count = 1, .reusable = true}, SHIFT(1472),
  [2567] = {.count = 1, .reusable = true}, SHIFT(1473),
  [2569] = {.count = 1, .reusable = false}, SHIFT(1474),
  [2571] = {.count = 1, .reusable = true}, SHIFT(1475),
  [2573] = {.count = 1, .reusable = false}, SHIFT(1476),
  [2575] = {.count = 1, .reusable = false}, SHIFT(1477),
  [2577] = {.count = 1, .reusable = false}, SHIFT(1478),
  [2579] = {.count = 1, .reusable = false}, SHIFT(1479),
  [2581] = {.count = 1, .reusable = false}, SHIFT(1480),
  [2583] = {.count = 1, .reusable = false}, SHIFT(1481),
  [2585] = {.count = 1, .reusable = false}, SHIFT(1495),
  [2587] = {.count = 1, .reusable = false}, SHIFT(1482),
  [2589] = {.count = 1, .reusable = false}, SHIFT(1483),
  [2591] = {.count = 1, .reusable = false}, SHIFT(1484),
  [2593] = {.count = 1, .reusable = false}, SHIFT(1485),
  [2595] = {.count = 1, .reusable = false}, SHIFT(1486),
  [2597] = {.count = 1, .reusable = false}, SHIFT(1487),
  [2599] = {.count = 1, .reusable = false}, SHIFT(1488),
  [2601] = {.count = 1, .reusable = false}, SHIFT(1472),
  [2603] = {.count = 1, .reusable = true}, SHIFT(1489),
  [2605] = {.count = 1, .reusable = false}, SHIFT(1489),
  [2607] = {.count = 1, .reusable = true}, SHIFT(1490),
  [2609] = {.count = 1, .reusable = false}, SHIFT(1496),
  [2611] = {.count = 1, .reusable = true}, SHIFT(1496),
  [2613] = {.count = 1, .reusable = false}, SHIFT(1491),
  [2615] = {.count = 1, .reusable = true}, SHIFT(1492),
  [2617] = {.count = 1, .reusable = true}, SHIFT(1493),
  [2619] = {.count = 1, .reusable = true}, SHIFT(1501),
  [2621] = {.count = 1, .reusable = true}, SHIFT(397),
  [2623] = {.count = 1, .reusable = false}, SHIFT(393),
  [2625] = {.count = 1, .reusable = true}, SHIFT(418),
  [2627] = {.count = 1, .reusable = true}, SHIFT(1504),
  [2629] = {.count = 1, .reusable = true}, SHIFT(1505),
  [2631] = {.count = 1, .reusable = true}, SHIFT(1506),
  [2633] = {.count = 1, .reusable = false}, SHIFT(1507),
  [2635] = {.count = 1, .reusable = false}, SHIFT(1508),
  [2637] = {.count = 1, .reusable = false}, SHIFT(1509),
  [2639] = {.count = 1, .reusable = false}, SHIFT(1510),
  [2641] = {.count = 1, .reusable = false}, SHIFT(1505),
  [2643] = {.count = 1, .reusable = true}, SHIFT(1511),
  [2645] = {.count = 1, .reusable = false}, SHIFT(1511),
  [2647] = {.count = 1, .reusable = true}, SHIFT(1512),
  [2649] = {.count = 1, .reusable = false}, SHIFT(1513),
  [2651] = {.count = 1, .reusable = true}, SHIFT(1517),
  [2653] = {.count = 1, .reusable = false}, SHIFT(1517),
  [2655] = {.count = 1, .reusable = true}, SHIFT(1523),
  [2657] = {.count = 1, .reusable = false}, SHIFT(1525),
  [2659] = {.count = 1, .reusable = true}, SHIFT(1527),
  [2661] = {.count = 1, .reusable = true}, SHIFT(1530),
  [2663] = {.count = 1, .reusable = false}, SHIFT(1531),
  [2665] = {.count = 1, .reusable = false}, SHIFT(1533),
  [2667] = {.count = 1, .reusable = true}, SHIFT(1547),
  [2669] = {.count = 1, .reusable = false}, SHIFT(1544),
  [2671] = {.count = 1, .reusable = true}, SHIFT(1549),
  [2673] = {.count = 1, .reusable = true}, SHIFT(1555),
  [2675] = {.count = 1, .reusable = false}, SHIFT(1554),
  [2677] = {.count = 1, .reusable = true}, SHIFT(1556),
  [2679] = {.count = 1, .reusable = false}, SHIFT(1560),
  [2681] = {.count = 1, .reusable = false}, SHIFT(1561),
  [2683] = {.count = 1, .reusable = true}, SHIFT(1562),
  [2685] = {.count = 1, .reusable = true}, SHIFT(1564),
  [2687] = {.count = 1, .reusable = true}, SHIFT(1567),
  [2689] = {.count = 1, .reusable = true}, SHIFT(1568),
  [2691] = {.count = 1, .reusable = false}, SHIFT(1569),
  [2693] = {.count = 1, .reusable = false}, SHIFT(1568),
  [2695] = {.count = 1, .reusable = false}, SHIFT(1570),
  [2697] = {.count = 1, .reusable = false}, SHIFT(1571),
  [2699] = {.count = 1, .reusable = true}, SHIFT(1572),
  [2701] = {.count = 1, .reusable = false}, SHIFT(1573),
  [2703] = {.count = 1, .reusable = true}, SHIFT(1573),
  [2705] = {.count = 1, .reusable = false}, SHIFT(1575),
  [2707] = {.count = 1, .reusable = false}, SHIFT(1576),
  [2709] = {.count = 1, .reusable = true}, SHIFT(1575),
  [2711] = {.count = 1, .reusable = true}, SHIFT(1571),
  [2713] = {.count = 1, .reusable = false}, SHIFT(1567),
  [2715] = {.count = 1, .reusable = true}, SHIFT(1577),
  [2717] = {.count = 1, .reusable = true}, REDUCE(sym_method_call, 2),
  [2719] = {.count = 1, .reusable = true}, SHIFT(1579),
  [2721] = {.count = 1, .reusable = false}, REDUCE(sym_method_call, 2),
  [2723] = {.count = 1, .reusable = true}, SHIFT(410),
  [2725] = {.count = 1, .reusable = true}, SHIFT(1581),
  [2727] = {.count = 1, .reusable = true}, SHIFT(1583),
  [2729] = {.count = 1, .reusable = true}, SHIFT(1585),
  [2731] = {.count = 1, .reusable = false}, SHIFT(1585),
  [2733] = {.count = 1, .reusable = true}, SHIFT(1586),
  [2735] = {.count = 1, .reusable = false}, SHIFT(1504),
  [2737] = {.count = 1, .reusable = true}, SHIFT(1588),
  [2739] = {.count = 1, .reusable = true}, SHIFT(1589),
  [2741] = {.count = 1, .reusable = false}, SHIFT(1589),
  [2743] = {.count = 1, .reusable = true}, SHIFT(1590),
  [2745] = {.count = 1, .reusable = false}, SHIFT(1590),
  [2747] = {.count = 1, .reusable = true}, SHIFT(1591),
  [2749] = {.count = 1, .reusable = true}, REDUCE(sym__mlhs, 2),
  [2751] = {.count = 1, .reusable = true}, SHIFT(1599),
  [2753] = {.count = 1, .reusable = true}, REDUCE(sym_chained_string, 2),
  [2755] = {.count = 1, .reusable = false}, REDUCE(sym_chained_string, 2),
  [2757] = {.count = 1, .reusable = true}, REDUCE(sym__statements, 2),
  [2759] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(2),
  [2762] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(3),
  [2765] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(4),
  [2768] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(5),
  [2771] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(6),
  [2774] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(7),
  [2777] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(8),
  [2780] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(46),
  [2783] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(1603),
  [2786] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(11),
  [2789] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(12),
  [2792] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(13),
  [2795] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(14),
  [2798] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(15),
  [2801] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(16),
  [2804] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(17),
  [2807] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(18),
  [2810] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(19),
  [2813] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(20),
  [2816] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(1604),
  [2819] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(1605),
  [2822] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(1606),
  [2825] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(1607),
  [2828] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(46),
  [2831] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(25),
  [2834] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(26),
  [2837] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(27),
  [2840] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(28),
  [2843] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(29),
  [2846] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(30),
  [2849] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(31),
  [2852] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(1603),
  [2855] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(1608),
  [2858] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(1608),
  [2861] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(1609),
  [2864] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(1613),
  [2867] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(1613),
  [2870] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(1610),
  [2873] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(35),
  [2876] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(36),
  [2879] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(37),
  [2882] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(38),
  [2885] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(39),
  [2888] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(40),
  [2891] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(41),
  [2894] = {.count = 1, .reusable = true}, SHIFT(1618),
  [2896] = {.count = 1, .reusable = true}, SHIFT(1619),
  [2898] = {.count = 1, .reusable = true}, SHIFT(1620),
  [2900] = {.count = 1, .reusable = true}, SHIFT(1621),
  [2902] = {.count = 1, .reusable = true}, SHIFT(1622),
  [2904] = {.count = 1, .reusable = true}, SHIFT(1623),
  [2906] = {.count = 1, .reusable = true}, SHIFT(1624),
  [2908] = {.count = 1, .reusable = false}, SHIFT(1626),
  [2910] = {.count = 1, .reusable = false}, SHIFT(1627),
  [2912] = {.count = 1, .reusable = false}, SHIFT(1628),
  [2914] = {.count = 1, .reusable = false}, SHIFT(1629),
  [2916] = {.count = 1, .reusable = true}, SHIFT(1630),
  [2918] = {.count = 1, .reusable = false}, SHIFT(1630),
  [2920] = {.count = 1, .reusable = false}, SHIFT(1631),
  [2922] = {.count = 1, .reusable = true}, SHIFT(1631),
  [2924] = {.count = 1, .reusable = false}, SHIFT(1632),
  [2926] = {.count = 1, .reusable = true}, SHIFT(1634),
  [2928] = {.count = 1, .reusable = false}, SHIFT(1634),
  [2930] = {.count = 1, .reusable = true}, SHIFT(1641),
  [2932] = {.count = 1, .reusable = false}, SHIFT(1641),
  [2934] = {.count = 1, .reusable = true}, SHIFT(1643),
  [2936] = {.count = 1, .reusable = true}, SHIFT(1642),
  [2938] = {.count = 1, .reusable = true}, SHIFT(1644),
  [2940] = {.count = 1, .reusable = true}, SHIFT(1645),
  [2942] = {.count = 1, .reusable = true}, SHIFT(1646),
  [2944] = {.count = 1, .reusable = true}, SHIFT(1647),
  [2946] = {.count = 1, .reusable = true}, SHIFT(1648),
  [2948] = {.count = 1, .reusable = true}, SHIFT(1649),
  [2950] = {.count = 1, .reusable = true}, SHIFT(1650),
  [2952] = {.count = 1, .reusable = true}, SHIFT(1651),
  [2954] = {.count = 1, .reusable = true}, SHIFT(1652),
  [2956] = {.count = 1, .reusable = false}, SHIFT(1653),
  [2958] = {.count = 1, .reusable = false}, SHIFT(1654),
  [2960] = {.count = 1, .reusable = false}, SHIFT(1655),
  [2962] = {.count = 1, .reusable = true}, SHIFT(1656),
  [2964] = {.count = 1, .reusable = false}, SHIFT(1657),
  [2966] = {.count = 1, .reusable = true}, SHIFT(1657),
  [2968] = {.count = 1, .reusable = true}, SHIFT(1658),
  [2970] = {.count = 1, .reusable = true}, SHIFT(1659),
  [2972] = {.count = 1, .reusable = true}, SHIFT(1660),
  [2974] = {.count = 1, .reusable = false}, SHIFT(1659),
  [2976] = {.count = 1, .reusable = true}, SHIFT(1655),
  [2978] = {.count = 1, .reusable = true}, SHIFT(1653),
  [2980] = {.count = 1, .reusable = false}, SHIFT(1661),
  [2982] = {.count = 1, .reusable = true}, SHIFT(1662),
  [2984] = {.count = 1, .reusable = true}, SHIFT(1663),
  [2986] = {.count = 1, .reusable = true}, SHIFT(1661),
  [2988] = {.count = 1, .reusable = true}, SHIFT(1664),
  [2990] = {.count = 1, .reusable = true}, SHIFT(1665),
  [2992] = {.count = 1, .reusable = true}, SHIFT(1666),
  [2994] = {.count = 1, .reusable = true}, SHIFT(1667),
  [2996] = {.count = 1, .reusable = true}, SHIFT(1668),
  [2998] = {.count = 1, .reusable = false}, SHIFT(1670),
  [3000] = {.count = 1, .reusable = false}, SHIFT(1671),
  [3002] = {.count = 1, .reusable = false}, SHIFT(1672),
  [3004] = {.count = 1, .reusable = false}, SHIFT(1673),
  [3006] = {.count = 1, .reusable = false}, SHIFT(1674),
  [3008] = {.count = 1, .reusable = true}, SHIFT(1675),
  [3010] = {.count = 1, .reusable = true}, SHIFT(1676),
  [3012] = {.count = 1, .reusable = false}, SHIFT(1676),
  [3014] = {.count = 1, .reusable = false}, SHIFT(1677),
  [3016] = {.count = 1, .reusable = true}, SHIFT(1677),
  [3018] = {.count = 1, .reusable = false}, SHIFT(1678),
  [3020] = {.count = 1, .reusable = true}, SHIFT(1680),
  [3022] = {.count = 1, .reusable = false}, SHIFT(1680),
  [3024] = {.count = 1, .reusable = true}, SHIFT(1688),
  [3026] = {.count = 1, .reusable = false}, SHIFT(1688),
  [3028] = {.count = 1, .reusable = true}, SHIFT(1689),
  [3030] = {.count = 1, .reusable = true}, REDUCE(sym_string, 3, .alias_sequence_id = 5),
  [3032] = {.count = 1, .reusable = false}, REDUCE(sym_string, 3, .alias_sequence_id = 5),
  [3034] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_contents_repeat1, 2), SHIFT_REPEAT(460),
  [3037] = {.count = 1, .reusable = true}, REDUCE(aux_sym__literal_contents_repeat1, 2),
  [3039] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_contents_repeat1, 2), SHIFT_REPEAT(55),
  [3042] = {.count = 1, .reusable = true}, REDUCE(sym_symbol, 3, .alias_sequence_id = 5),
  [3044] = {.count = 1, .reusable = false}, REDUCE(sym_symbol, 3, .alias_sequence_id = 5),
  [3046] = {.count = 1, .reusable = true}, REDUCE(sym_subshell, 3, .alias_sequence_id = 6),
  [3048] = {.count = 1, .reusable = false}, REDUCE(sym_subshell, 3, .alias_sequence_id = 6),
  [3050] = {.count = 1, .reusable = true}, REDUCE(sym_regex, 3, .alias_sequence_id = 7),
  [3052] = {.count = 1, .reusable = false}, REDUCE(sym_regex, 3, .alias_sequence_id = 7),
  [3054] = {.count = 1, .reusable = true}, SHIFT(1691),
  [3056] = {.count = 1, .reusable = true}, REDUCE(sym_string_array, 3, .alias_sequence_id = 8),
  [3058] = {.count = 1, .reusable = false}, REDUCE(sym_string_array, 3, .alias_sequence_id = 8),
  [3060] = {.count = 1, .reusable = true}, SHIFT(1692),
  [3062] = {.count = 1, .reusable = true}, SHIFT(1693),
  [3064] = {.count = 1, .reusable = true}, SHIFT(1694),
  [3066] = {.count = 1, .reusable = true}, REDUCE(sym_string_array, 3, .alias_sequence_id = 9),
  [3068] = {.count = 1, .reusable = false}, REDUCE(sym_string_array, 3, .alias_sequence_id = 9),
  [3070] = {.count = 1, .reusable = true}, SHIFT(1696),
  [3072] = {.count = 1, .reusable = true}, SHIFT(1698),
  [3074] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_contents_repeat1, 2), SHIFT_REPEAT(471),
  [3077] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_contents_repeat1, 2), SHIFT_REPEAT(65),
  [3080] = {.count = 1, .reusable = false}, REDUCE(aux_sym__literal_contents_repeat1, 2),
  [3082] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_contents_repeat1, 2), SHIFT_REPEAT(471),
  [3085] = {.count = 1, .reusable = true}, REDUCE(sym_symbol_array, 3, .alias_sequence_id = 8),
  [3087] = {.count = 1, .reusable = false}, REDUCE(sym_symbol_array, 3, .alias_sequence_id = 8),
  [3089] = {.count = 1, .reusable = true}, SHIFT(1700),
  [3091] = {.count = 1, .reusable = true}, SHIFT(1701),
  [3093] = {.count = 1, .reusable = true}, SHIFT(1702),
  [3095] = {.count = 1, .reusable = true}, REDUCE(sym_symbol_array, 3, .alias_sequence_id = 10),
  [3097] = {.count = 1, .reusable = false}, REDUCE(sym_symbol_array, 3, .alias_sequence_id = 10),
  [3099] = {.count = 1, .reusable = true}, SHIFT(1704),
  [3101] = {.count = 1, .reusable = true}, SHIFT(1706),
  [3103] = {.count = 1, .reusable = true}, REDUCE(sym_program, 3),
  [3105] = {.count = 1, .reusable = true}, REDUCE(sym_begin_block, 3),
  [3107] = {.count = 1, .reusable = true}, SHIFT(1709),
  [3109] = {.count = 1, .reusable = true}, SHIFT(1710),
  [3111] = {.count = 1, .reusable = true}, SHIFT(1711),
  [3113] = {.count = 1, .reusable = true}, SHIFT(1712),
  [3115] = {.count = 1, .reusable = false}, SHIFT(1714),
  [3117] = {.count = 1, .reusable = false}, SHIFT(1715),
  [3119] = {.count = 1, .reusable = false}, SHIFT(1716),
  [3121] = {.count = 1, .reusable = false}, SHIFT(1717),
  [3123] = {.count = 1, .reusable = true}, SHIFT(1718),
  [3125] = {.count = 1, .reusable = false}, SHIFT(1718),
  [3127] = {.count = 1, .reusable = false}, SHIFT(1719),
  [3129] = {.count = 1, .reusable = true}, SHIFT(1719),
  [3131] = {.count = 1, .reusable = false}, SHIFT(1720),
  [3133] = {.count = 1, .reusable = true}, SHIFT(1728),
  [3135] = {.count = 1, .reusable = true}, SHIFT(1729),
  [3137] = {.count = 1, .reusable = true}, SHIFT(1730),
  [3139] = {.count = 1, .reusable = true}, SHIFT(1731),
  [3141] = {.count = 1, .reusable = true}, SHIFT(1732),
  [3143] = {.count = 1, .reusable = true}, SHIFT(1733),
  [3145] = {.count = 1, .reusable = true}, SHIFT(1734),
  [3147] = {.count = 1, .reusable = true}, SHIFT(1735),
  [3149] = {.count = 1, .reusable = true}, SHIFT(1736),
  [3151] = {.count = 1, .reusable = false}, SHIFT(1737),
  [3153] = {.count = 1, .reusable = false}, SHIFT(1738),
  [3155] = {.count = 1, .reusable = false}, SHIFT(1739),
  [3157] = {.count = 1, .reusable = true}, SHIFT(1740),
  [3159] = {.count = 1, .reusable = false}, SHIFT(1741),
  [3161] = {.count = 1, .reusable = true}, SHIFT(1741),
  [3163] = {.count = 1, .reusable = true}, SHIFT(1742),
  [3165] = {.count = 1, .reusable = true}, SHIFT(1743),
  [3167] = {.count = 1, .reusable = true}, SHIFT(1744),
  [3169] = {.count = 1, .reusable = false}, SHIFT(1743),
  [3171] = {.count = 1, .reusable = true}, SHIFT(1739),
  [3173] = {.count = 1, .reusable = true}, SHIFT(1737),
  [3175] = {.count = 1, .reusable = true}, SHIFT(1745),
  [3177] = {.count = 1, .reusable = true}, SHIFT(1746),
  [3179] = {.count = 1, .reusable = true}, SHIFT(1747),
  [3181] = {.count = 1, .reusable = true}, SHIFT(1748),
  [3183] = {.count = 1, .reusable = false}, SHIFT(1750),
  [3185] = {.count = 1, .reusable = false}, SHIFT(1751),
  [3187] = {.count = 1, .reusable = false}, SHIFT(1752),
  [3189] = {.count = 1, .reusable = false}, SHIFT(1753),
  [3191] = {.count = 1, .reusable = true}, SHIFT(1754),
  [3193] = {.count = 1, .reusable = false}, SHIFT(1754),
  [3195] = {.count = 1, .reusable = false}, SHIFT(1755),
  [3197] = {.count = 1, .reusable = true}, SHIFT(1755),
  [3199] = {.count = 1, .reusable = false}, SHIFT(1756),
  [3201] = {.count = 1, .reusable = true}, SHIFT(1758),
  [3203] = {.count = 1, .reusable = false}, SHIFT(1758),
  [3205] = {.count = 1, .reusable = true}, SHIFT(1764),
  [3207] = {.count = 1, .reusable = false}, SHIFT(1764),
  [3209] = {.count = 1, .reusable = true}, SHIFT(1765),
  [3211] = {.count = 1, .reusable = true}, SHIFT(1769),
  [3213] = {.count = 1, .reusable = true}, SHIFT(1770),
  [3215] = {.count = 1, .reusable = true}, SHIFT(1771),
  [3217] = {.count = 1, .reusable = true}, SHIFT(1772),
  [3219] = {.count = 1, .reusable = true}, SHIFT(1773),
  [3221] = {.count = 1, .reusable = false}, SHIFT(1774),
  [3223] = {.count = 1, .reusable = true}, SHIFT(1776),
  [3225] = {.count = 1, .reusable = true}, SHIFT(1777),
  [3227] = {.count = 1, .reusable = true}, SHIFT(1779),
  [3229] = {.count = 1, .reusable = false}, SHIFT(1780),
  [3231] = {.count = 1, .reusable = true}, SHIFT(1782),
  [3233] = {.count = 1, .reusable = true}, SHIFT(1783),
  [3235] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_body, 2),
  [3237] = {.count = 1, .reusable = true}, SHIFT(1787),
  [3239] = {.count = 1, .reusable = true}, SHIFT(1786),
  [3241] = {.count = 1, .reusable = true}, SHIFT(1789),
  [3243] = {.count = 1, .reusable = true}, SHIFT(1792),
  [3245] = {.count = 1, .reusable = true}, SHIFT(1793),
  [3247] = {.count = 1, .reusable = true}, SHIFT(1794),
  [3249] = {.count = 1, .reusable = true}, SHIFT(1796),
  [3251] = {.count = 1, .reusable = true}, SHIFT(1797),
  [3253] = {.count = 1, .reusable = true}, SHIFT(1798),
  [3255] = {.count = 1, .reusable = true}, SHIFT(1799),
  [3257] = {.count = 1, .reusable = true}, SHIFT(1800),
  [3259] = {.count = 1, .reusable = false}, SHIFT(1802),
  [3261] = {.count = 1, .reusable = false}, SHIFT(1803),
  [3263] = {.count = 1, .reusable = false}, SHIFT(1804),
  [3265] = {.count = 1, .reusable = false}, SHIFT(1805),
  [3267] = {.count = 1, .reusable = true}, SHIFT(1806),
  [3269] = {.count = 1, .reusable = false}, SHIFT(1806),
  [3271] = {.count = 1, .reusable = false}, SHIFT(1807),
  [3273] = {.count = 1, .reusable = true}, SHIFT(1807),
  [3275] = {.count = 1, .reusable = false}, SHIFT(1808),
  [3277] = {.count = 1, .reusable = true}, SHIFT(1810),
  [3279] = {.count = 1, .reusable = false}, SHIFT(1810),
  [3281] = {.count = 1, .reusable = true}, REDUCE(sym_hash_splat_argument, 2),
  [3283] = {.count = 1, .reusable = true}, SHIFT(1817),
  [3285] = {.count = 1, .reusable = true}, SHIFT(1818),
  [3287] = {.count = 1, .reusable = false}, SHIFT(1819),
  [3289] = {.count = 1, .reusable = false}, SHIFT(1820),
  [3291] = {.count = 1, .reusable = false}, SHIFT(1821),
  [3293] = {.count = 1, .reusable = true}, SHIFT(1822),
  [3295] = {.count = 1, .reusable = false}, SHIFT(1823),
  [3297] = {.count = 1, .reusable = true}, SHIFT(1823),
  [3299] = {.count = 1, .reusable = true}, SHIFT(1824),
  [3301] = {.count = 1, .reusable = true}, SHIFT(1825),
  [3303] = {.count = 1, .reusable = true}, SHIFT(1826),
  [3305] = {.count = 1, .reusable = false}, SHIFT(1825),
  [3307] = {.count = 1, .reusable = true}, SHIFT(1821),
  [3309] = {.count = 1, .reusable = true}, SHIFT(1819),
  [3311] = {.count = 1, .reusable = false}, SHIFT(1827),
  [3313] = {.count = 1, .reusable = true}, SHIFT(1828),
  [3315] = {.count = 1, .reusable = true}, SHIFT(1829),
  [3317] = {.count = 1, .reusable = true}, SHIFT(1827),
  [3319] = {.count = 1, .reusable = true}, SHIFT(1830),
  [3321] = {.count = 1, .reusable = true}, SHIFT(1831),
  [3323] = {.count = 1, .reusable = true}, SHIFT(1832),
  [3325] = {.count = 1, .reusable = true}, SHIFT(1833),
  [3327] = {.count = 1, .reusable = true}, SHIFT(1834),
  [3329] = {.count = 1, .reusable = false}, SHIFT(1836),
  [3331] = {.count = 1, .reusable = false}, SHIFT(1837),
  [3333] = {.count = 1, .reusable = false}, SHIFT(1838),
  [3335] = {.count = 1, .reusable = false}, SHIFT(1839),
  [3337] = {.count = 1, .reusable = false}, SHIFT(1840),
  [3339] = {.count = 1, .reusable = true}, SHIFT(1841),
  [3341] = {.count = 1, .reusable = false}, SHIFT(1841),
  [3343] = {.count = 1, .reusable = false}, SHIFT(1842),
  [3345] = {.count = 1, .reusable = true}, SHIFT(1842),
  [3347] = {.count = 1, .reusable = false}, SHIFT(1843),
  [3349] = {.count = 1, .reusable = true}, SHIFT(1845),
  [3351] = {.count = 1, .reusable = false}, SHIFT(1845),
  [3353] = {.count = 1, .reusable = true}, SHIFT(1853),
  [3355] = {.count = 1, .reusable = false}, SHIFT(1853),
  [3357] = {.count = 1, .reusable = true}, SHIFT(1854),
  [3359] = {.count = 1, .reusable = true}, SHIFT(1858),
  [3361] = {.count = 1, .reusable = true}, SHIFT(1860),
  [3363] = {.count = 1, .reusable = false}, SHIFT(1859),
  [3365] = {.count = 1, .reusable = true}, SHIFT(1865),
  [3367] = {.count = 1, .reusable = true}, SHIFT(1869),
  [3369] = {.count = 1, .reusable = false}, SHIFT(1873),
  [3371] = {.count = 1, .reusable = true}, SHIFT(1874),
  [3373] = {.count = 1, .reusable = true}, SHIFT(1875),
  [3375] = {.count = 1, .reusable = false}, SHIFT(1876),
  [3377] = {.count = 1, .reusable = false}, SHIFT(1877),
  [3379] = {.count = 1, .reusable = false}, SHIFT(1878),
  [3381] = {.count = 1, .reusable = true}, SHIFT(1879),
  [3383] = {.count = 1, .reusable = false}, SHIFT(1880),
  [3385] = {.count = 1, .reusable = true}, SHIFT(1880),
  [3387] = {.count = 1, .reusable = true}, SHIFT(1882),
  [3389] = {.count = 1, .reusable = true}, SHIFT(1883),
  [3391] = {.count = 1, .reusable = false}, SHIFT(1882),
  [3393] = {.count = 1, .reusable = true}, SHIFT(1878),
  [3395] = {.count = 1, .reusable = true}, SHIFT(1876),
  [3397] = {.count = 1, .reusable = true}, SHIFT(1884),
  [3399] = {.count = 1, .reusable = true}, SHIFT(1886),
  [3401] = {.count = 1, .reusable = true}, SHIFT(1888),
  [3403] = {.count = 1, .reusable = false}, SHIFT(1888),
  [3405] = {.count = 1, .reusable = true}, SHIFT(1889),
  [3407] = {.count = 1, .reusable = false}, SHIFT(1865),
  [3409] = {.count = 1, .reusable = true}, SHIFT(1892),
  [3411] = {.count = 1, .reusable = true}, SHIFT(1894),
  [3413] = {.count = 1, .reusable = true}, SHIFT(1895),
  [3415] = {.count = 1, .reusable = true}, SHIFT(1896),
  [3417] = {.count = 1, .reusable = true}, SHIFT(1898),
  [3419] = {.count = 1, .reusable = true}, SHIFT(1901),
  [3421] = {.count = 1, .reusable = true}, SHIFT(1899),
  [3423] = {.count = 1, .reusable = true}, SHIFT(1903),
  [3425] = {.count = 1, .reusable = false}, SHIFT(1907),
  [3427] = {.count = 1, .reusable = true}, SHIFT(1909),
  [3429] = {.count = 1, .reusable = true}, SHIFT(1910),
  [3431] = {.count = 1, .reusable = true}, SHIFT(1916),
  [3433] = {.count = 1, .reusable = false}, SHIFT(1913),
  [3435] = {.count = 1, .reusable = true}, SHIFT(592),
  [3437] = {.count = 1, .reusable = true}, SHIFT(1928),
  [3439] = {.count = 1, .reusable = false}, SHIFT(1928),
  [3441] = {.count = 1, .reusable = true}, SHIFT(1929),
  [3443] = {.count = 1, .reusable = true}, SHIFT(1930),
  [3445] = {.count = 1, .reusable = true}, SHIFT(1933),
  [3447] = {.count = 1, .reusable = true}, SHIFT(1935),
  [3449] = {.count = 1, .reusable = true}, SHIFT(1936),
  [3451] = {.count = 1, .reusable = true}, SHIFT(1938),
  [3453] = {.count = 1, .reusable = true}, SHIFT(1940),
  [3455] = {.count = 1, .reusable = true}, SHIFT(1942),
  [3457] = {.count = 1, .reusable = true}, SHIFT(1944),
  [3459] = {.count = 1, .reusable = false}, SHIFT(1945),
  [3461] = {.count = 1, .reusable = true}, SHIFT(1947),
  [3463] = {.count = 1, .reusable = false}, SHIFT(1948),
  [3465] = {.count = 1, .reusable = true}, SHIFT(1950),
  [3467] = {.count = 1, .reusable = true}, SHIFT(621),
  [3469] = {.count = 1, .reusable = false}, SHIFT(617),
  [3471] = {.count = 1, .reusable = true}, SHIFT(642),
  [3473] = {.count = 1, .reusable = true}, SHIFT(1955),
  [3475] = {.count = 1, .reusable = true}, SHIFT(1956),
  [3477] = {.count = 1, .reusable = true}, SHIFT(1961),
  [3479] = {.count = 1, .reusable = false}, SHIFT(1963),
  [3481] = {.count = 1, .reusable = true}, SHIFT(1965),
  [3483] = {.count = 1, .reusable = true}, SHIFT(1968),
  [3485] = {.count = 1, .reusable = false}, SHIFT(1969),
  [3487] = {.count = 1, .reusable = false}, SHIFT(1971),
  [3489] = {.count = 1, .reusable = true}, SHIFT(1985),
  [3491] = {.count = 1, .reusable = false}, SHIFT(1982),
  [3493] = {.count = 1, .reusable = true}, SHIFT(1987),
  [3495] = {.count = 1, .reusable = true}, SHIFT(1993),
  [3497] = {.count = 1, .reusable = false}, SHIFT(1992),
  [3499] = {.count = 1, .reusable = true}, SHIFT(1994),
  [3501] = {.count = 1, .reusable = false}, SHIFT(1998),
  [3503] = {.count = 1, .reusable = false}, SHIFT(1999),
  [3505] = {.count = 1, .reusable = true}, SHIFT(2000),
  [3507] = {.count = 1, .reusable = true}, SHIFT(2002),
  [3509] = {.count = 1, .reusable = true}, SHIFT(2005),
  [3511] = {.count = 1, .reusable = true}, SHIFT(2006),
  [3513] = {.count = 1, .reusable = false}, SHIFT(2007),
  [3515] = {.count = 1, .reusable = false}, SHIFT(2006),
  [3517] = {.count = 1, .reusable = false}, SHIFT(2008),
  [3519] = {.count = 1, .reusable = false}, SHIFT(2009),
  [3521] = {.count = 1, .reusable = true}, SHIFT(2010),
  [3523] = {.count = 1, .reusable = false}, SHIFT(2011),
  [3525] = {.count = 1, .reusable = true}, SHIFT(2011),
  [3527] = {.count = 1, .reusable = false}, SHIFT(2013),
  [3529] = {.count = 1, .reusable = false}, SHIFT(2014),
  [3531] = {.count = 1, .reusable = true}, SHIFT(2013),
  [3533] = {.count = 1, .reusable = true}, SHIFT(2009),
  [3535] = {.count = 1, .reusable = false}, SHIFT(2005),
  [3537] = {.count = 1, .reusable = true}, SHIFT(2015),
  [3539] = {.count = 1, .reusable = true}, SHIFT(2017),
  [3541] = {.count = 1, .reusable = true}, SHIFT(634),
  [3543] = {.count = 1, .reusable = true}, SHIFT(2019),
  [3545] = {.count = 1, .reusable = true}, SHIFT(2021),
  [3547] = {.count = 1, .reusable = true}, SHIFT(2023),
  [3549] = {.count = 1, .reusable = false}, SHIFT(2023),
  [3551] = {.count = 1, .reusable = true}, SHIFT(2024),
  [3553] = {.count = 1, .reusable = false}, SHIFT(1955),
  [3555] = {.count = 1, .reusable = true}, SHIFT(2026),
  [3557] = {.count = 1, .reusable = true}, SHIFT(2027),
  [3559] = {.count = 1, .reusable = false}, SHIFT(2028),
  [3561] = {.count = 1, .reusable = false}, SHIFT(2029),
  [3563] = {.count = 1, .reusable = false}, SHIFT(2030),
  [3565] = {.count = 1, .reusable = false}, SHIFT(2031),
  [3567] = {.count = 1, .reusable = false}, SHIFT(2027),
  [3569] = {.count = 1, .reusable = true}, SHIFT(2032),
  [3571] = {.count = 1, .reusable = false}, SHIFT(2032),
  [3573] = {.count = 1, .reusable = true}, SHIFT(2033),
  [3575] = {.count = 1, .reusable = true}, REDUCE(sym_hash, 3),
  [3577] = {.count = 1, .reusable = false}, REDUCE(sym_hash, 3),
  [3579] = {.count = 1, .reusable = true}, SHIFT(2042),
  [3581] = {.count = 1, .reusable = true}, SHIFT(2043),
  [3583] = {.count = 1, .reusable = true}, REDUCE(sym__hash_items, 2),
  [3585] = {.count = 1, .reusable = true}, REDUCE(sym_end_block, 3),
  [3587] = {.count = 1, .reusable = true}, SHIFT(2046),
  [3589] = {.count = 1, .reusable = true}, SHIFT(2047),
  [3591] = {.count = 1, .reusable = true}, SHIFT(2049),
  [3593] = {.count = 1, .reusable = true}, SHIFT(2050),
  [3595] = {.count = 1, .reusable = true}, SHIFT(2051),
  [3597] = {.count = 1, .reusable = true}, SHIFT(2052),
  [3599] = {.count = 1, .reusable = true}, SHIFT(2054),
  [3601] = {.count = 1, .reusable = false}, SHIFT(2054),
  [3603] = {.count = 1, .reusable = false}, SHIFT(2055),
  [3605] = {.count = 1, .reusable = true}, SHIFT(2055),
  [3607] = {.count = 1, .reusable = false}, SHIFT(2056),
  [3609] = {.count = 1, .reusable = true}, SHIFT(2064),
  [3611] = {.count = 1, .reusable = true}, SHIFT(2065),
  [3613] = {.count = 1, .reusable = true}, SHIFT(2066),
  [3615] = {.count = 1, .reusable = false}, SHIFT(2067),
  [3617] = {.count = 1, .reusable = false}, SHIFT(2068),
  [3619] = {.count = 1, .reusable = false}, SHIFT(2069),
  [3621] = {.count = 1, .reusable = true}, SHIFT(2070),
  [3623] = {.count = 1, .reusable = false}, SHIFT(2071),
  [3625] = {.count = 1, .reusable = true}, SHIFT(2071),
  [3627] = {.count = 1, .reusable = true}, SHIFT(2072),
  [3629] = {.count = 1, .reusable = true}, SHIFT(2073),
  [3631] = {.count = 1, .reusable = true}, SHIFT(2074),
  [3633] = {.count = 1, .reusable = false}, SHIFT(2073),
  [3635] = {.count = 1, .reusable = true}, SHIFT(2069),
  [3637] = {.count = 1, .reusable = true}, SHIFT(2067),
  [3639] = {.count = 1, .reusable = true}, SHIFT(2075),
  [3641] = {.count = 1, .reusable = true}, SHIFT(2076),
  [3643] = {.count = 1, .reusable = true}, SHIFT(2077),
  [3645] = {.count = 1, .reusable = true}, SHIFT(2078),
  [3647] = {.count = 1, .reusable = false}, SHIFT(2080),
  [3649] = {.count = 1, .reusable = false}, SHIFT(2081),
  [3651] = {.count = 1, .reusable = false}, SHIFT(2082),
  [3653] = {.count = 1, .reusable = false}, SHIFT(2083),
  [3655] = {.count = 1, .reusable = true}, SHIFT(2084),
  [3657] = {.count = 1, .reusable = false}, SHIFT(2084),
  [3659] = {.count = 1, .reusable = false}, SHIFT(2085),
  [3661] = {.count = 1, .reusable = true}, SHIFT(2085),
  [3663] = {.count = 1, .reusable = false}, SHIFT(2086),
  [3665] = {.count = 1, .reusable = true}, SHIFT(2088),
  [3667] = {.count = 1, .reusable = false}, SHIFT(2088),
  [3669] = {.count = 1, .reusable = true}, SHIFT(2094),
  [3671] = {.count = 1, .reusable = false}, SHIFT(2094),
  [3673] = {.count = 1, .reusable = true}, SHIFT(2095),
  [3675] = {.count = 1, .reusable = true}, REDUCE(sym_setter, 2),
  [3677] = {.count = 1, .reusable = false}, REDUCE(sym_setter, 2),
  [3679] = {.count = 1, .reusable = true}, SHIFT(132),
  [3681] = {.count = 1, .reusable = true}, SHIFT(2098),
  [3683] = {.count = 1, .reusable = true}, SHIFT(2100),
  [3685] = {.count = 1, .reusable = true}, SHIFT(2101),
  [3687] = {.count = 1, .reusable = true}, SHIFT(2102),
  [3689] = {.count = 1, .reusable = true}, SHIFT(2103),
  [3691] = {.count = 1, .reusable = true}, SHIFT(2104),
  [3693] = {.count = 1, .reusable = true}, SHIFT(2105),
  [3695] = {.count = 1, .reusable = false}, SHIFT(2106),
  [3697] = {.count = 1, .reusable = true}, SHIFT(2108),
  [3699] = {.count = 1, .reusable = true}, SHIFT(2107),
  [3701] = {.count = 1, .reusable = true}, SHIFT(2109),
  [3703] = {.count = 1, .reusable = true}, SHIFT(2110),
  [3705] = {.count = 1, .reusable = true}, SHIFT(2111),
  [3707] = {.count = 1, .reusable = true}, SHIFT(2112),
  [3709] = {.count = 1, .reusable = true}, SHIFT(2113),
  [3711] = {.count = 1, .reusable = false}, SHIFT(2114),
  [3713] = {.count = 1, .reusable = false}, SHIFT(2115),
  [3715] = {.count = 1, .reusable = false}, SHIFT(2116),
  [3717] = {.count = 1, .reusable = false}, SHIFT(2117),
  [3719] = {.count = 1, .reusable = false}, SHIFT(2111),
  [3721] = {.count = 1, .reusable = true}, SHIFT(2118),
  [3723] = {.count = 1, .reusable = false}, SHIFT(2118),
  [3725] = {.count = 1, .reusable = true}, SHIFT(2119),
  [3727] = {.count = 1, .reusable = false}, SHIFT(2120),
  [3729] = {.count = 1, .reusable = true}, SHIFT(2127),
  [3731] = {.count = 1, .reusable = false}, SHIFT(2128),
  [3733] = {.count = 1, .reusable = false}, SHIFT(2129),
  [3735] = {.count = 1, .reusable = false}, SHIFT(2130),
  [3737] = {.count = 1, .reusable = false}, SHIFT(2131),
  [3739] = {.count = 1, .reusable = false}, SHIFT(2127),
  [3741] = {.count = 1, .reusable = true}, SHIFT(2132),
  [3743] = {.count = 1, .reusable = false}, SHIFT(2132),
  [3745] = {.count = 1, .reusable = true}, SHIFT(2133),
  [3747] = {.count = 1, .reusable = false}, SHIFT(690),
  [3749] = {.count = 1, .reusable = true}, SHIFT(2141),
  [3751] = {.count = 1, .reusable = true}, SHIFT(2143),
  [3753] = {.count = 1, .reusable = true}, SHIFT(2144),
  [3755] = {.count = 1, .reusable = true}, SHIFT(2145),
  [3757] = {.count = 1, .reusable = false}, SHIFT(2147),
  [3759] = {.count = 1, .reusable = false}, SHIFT(2153),
  [3761] = {.count = 1, .reusable = true}, SHIFT(2154),
  [3763] = {.count = 1, .reusable = true}, SHIFT(2155),
  [3765] = {.count = 1, .reusable = false}, SHIFT(2156),
  [3767] = {.count = 1, .reusable = false}, SHIFT(2157),
  [3769] = {.count = 1, .reusable = false}, SHIFT(2158),
  [3771] = {.count = 1, .reusable = true}, SHIFT(2159),
  [3773] = {.count = 1, .reusable = false}, SHIFT(2160),
  [3775] = {.count = 1, .reusable = true}, SHIFT(2160),
  [3777] = {.count = 1, .reusable = true}, SHIFT(2162),
  [3779] = {.count = 1, .reusable = true}, SHIFT(2163),
  [3781] = {.count = 1, .reusable = false}, SHIFT(2162),
  [3783] = {.count = 1, .reusable = true}, SHIFT(2158),
  [3785] = {.count = 1, .reusable = true}, SHIFT(2156),
  [3787] = {.count = 1, .reusable = true}, SHIFT(2164),
  [3789] = {.count = 1, .reusable = true}, SHIFT(2165),
  [3791] = {.count = 1, .reusable = true}, SHIFT(2166),
  [3793] = {.count = 1, .reusable = false}, SHIFT(2168),
  [3795] = {.count = 1, .reusable = true}, SHIFT(2174),
  [3797] = {.count = 1, .reusable = true}, SHIFT(2176),
  [3799] = {.count = 1, .reusable = false}, SHIFT(2176),
  [3801] = {.count = 1, .reusable = true}, SHIFT(2177),
  [3803] = {.count = 1, .reusable = false}, SHIFT(2141),
  [3805] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_statements, 3),
  [3807] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_statements, 3),
  [3809] = {.count = 1, .reusable = true}, SHIFT(2195),
  [3811] = {.count = 1, .reusable = false}, SHIFT(2196),
  [3813] = {.count = 1, .reusable = false}, SHIFT(2197),
  [3815] = {.count = 1, .reusable = false}, SHIFT(2198),
  [3817] = {.count = 1, .reusable = false}, SHIFT(2199),
  [3819] = {.count = 1, .reusable = false}, SHIFT(2195),
  [3821] = {.count = 1, .reusable = true}, SHIFT(2200),
  [3823] = {.count = 1, .reusable = false}, SHIFT(2200),
  [3825] = {.count = 1, .reusable = true}, SHIFT(2201),
  [3827] = {.count = 1, .reusable = false}, SHIFT(2203),
  [3829] = {.count = 1, .reusable = true}, SHIFT(2203),
  [3831] = {.count = 1, .reusable = false}, SHIFT(727),
  [3833] = {.count = 1, .reusable = true}, SHIFT(2210),
  [3835] = {.count = 1, .reusable = false}, SHIFT(2213),
  [3837] = {.count = 1, .reusable = true}, SHIFT(2214),
  [3839] = {.count = 1, .reusable = true}, SHIFT(2215),
  [3841] = {.count = 1, .reusable = false}, SHIFT(2216),
  [3843] = {.count = 1, .reusable = false}, SHIFT(2215),
  [3845] = {.count = 1, .reusable = false}, SHIFT(2217),
  [3847] = {.count = 1, .reusable = false}, SHIFT(2218),
  [3849] = {.count = 1, .reusable = true}, SHIFT(2219),
  [3851] = {.count = 1, .reusable = false}, SHIFT(2220),
  [3853] = {.count = 1, .reusable = true}, SHIFT(2220),
  [3855] = {.count = 1, .reusable = false}, SHIFT(2222),
  [3857] = {.count = 1, .reusable = false}, SHIFT(2223),
  [3859] = {.count = 1, .reusable = true}, SHIFT(2222),
  [3861] = {.count = 1, .reusable = true}, SHIFT(2218),
  [3863] = {.count = 1, .reusable = false}, SHIFT(2214),
  [3865] = {.count = 1, .reusable = true}, SHIFT(2225),
  [3867] = {.count = 1, .reusable = true}, SHIFT(2227),
  [3869] = {.count = 1, .reusable = false}, SHIFT(2227),
  [3871] = {.count = 1, .reusable = true}, SHIFT(2228),
  [3873] = {.count = 1, .reusable = false}, SHIFT(2210),
  [3875] = {.count = 1, .reusable = true}, SHIFT(2230),
  [3877] = {.count = 1, .reusable = true}, SHIFT(2231),
  [3879] = {.count = 1, .reusable = false}, SHIFT(2231),
  [3881] = {.count = 1, .reusable = true}, SHIFT(2232),
  [3883] = {.count = 1, .reusable = false}, SHIFT(2232),
  [3885] = {.count = 1, .reusable = true}, SHIFT(2233),
  [3887] = {.count = 1, .reusable = true}, REDUCE(sym_destructured_left_assignment, 3),
  [3889] = {.count = 1, .reusable = true}, SHIFT(2238),
  [3891] = {.count = 1, .reusable = true}, SHIFT(2242),
  [3893] = {.count = 1, .reusable = true}, SHIFT(2243),
  [3895] = {.count = 1, .reusable = true}, SHIFT(2244),
  [3897] = {.count = 1, .reusable = true}, SHIFT(2245),
  [3899] = {.count = 1, .reusable = true}, SHIFT(2246),
  [3901] = {.count = 1, .reusable = false}, SHIFT(2247),
  [3903] = {.count = 1, .reusable = true}, SHIFT(2249),
  [3905] = {.count = 1, .reusable = true}, SHIFT(2250),
  [3907] = {.count = 1, .reusable = true}, SHIFT(2252),
  [3909] = {.count = 1, .reusable = false}, SHIFT(2253),
  [3911] = {.count = 1, .reusable = true}, SHIFT(2255),
  [3913] = {.count = 1, .reusable = true}, SHIFT(2256),
  [3915] = {.count = 1, .reusable = true}, SHIFT(2258),
  [3917] = {.count = 1, .reusable = true}, SHIFT(2261),
  [3919] = {.count = 1, .reusable = true}, SHIFT(2262),
  [3921] = {.count = 1, .reusable = true}, SHIFT(2263),
  [3923] = {.count = 1, .reusable = true}, SHIFT(2266),
  [3925] = {.count = 1, .reusable = true}, SHIFT(2268),
  [3927] = {.count = 1, .reusable = false}, SHIFT(2267),
  [3929] = {.count = 1, .reusable = true}, SHIFT(2269),
  [3931] = {.count = 1, .reusable = false}, SHIFT(2270),
  [3933] = {.count = 1, .reusable = false}, SHIFT(2271),
  [3935] = {.count = 1, .reusable = false}, SHIFT(2272),
  [3937] = {.count = 1, .reusable = false}, SHIFT(2273),
  [3939] = {.count = 1, .reusable = false}, SHIFT(2269),
  [3941] = {.count = 1, .reusable = true}, SHIFT(2274),
  [3943] = {.count = 1, .reusable = false}, SHIFT(2274),
  [3945] = {.count = 1, .reusable = true}, SHIFT(2275),
  [3947] = {.count = 1, .reusable = false}, SHIFT(2277),
  [3949] = {.count = 1, .reusable = true}, SHIFT(2277),
  [3951] = {.count = 1, .reusable = true}, SHIFT(2282),
  [3953] = {.count = 1, .reusable = true}, SHIFT(2284),
  [3955] = {.count = 1, .reusable = false}, SHIFT(2286),
  [3957] = {.count = 1, .reusable = true}, SHIFT(1881),
  [3959] = {.count = 1, .reusable = true}, SHIFT(2287),
  [3961] = {.count = 1, .reusable = true}, SHIFT(2289),
  [3963] = {.count = 1, .reusable = false}, SHIFT(2282),
  [3965] = {.count = 1, .reusable = true}, SHIFT(2292),
  [3967] = {.count = 1, .reusable = true}, SHIFT(2294),
  [3969] = {.count = 1, .reusable = true}, SHIFT(2295),
  [3971] = {.count = 1, .reusable = true}, SHIFT(2296),
  [3973] = {.count = 1, .reusable = true}, SHIFT(2298),
  [3975] = {.count = 1, .reusable = true}, SHIFT(2301),
  [3977] = {.count = 1, .reusable = true}, SHIFT(2299),
  [3979] = {.count = 1, .reusable = true}, SHIFT(2303),
  [3981] = {.count = 1, .reusable = false}, SHIFT(2307),
  [3983] = {.count = 1, .reusable = true}, SHIFT(2308),
  [3985] = {.count = 1, .reusable = true}, SHIFT(2309),
  [3987] = {.count = 1, .reusable = true}, SHIFT(2315),
  [3989] = {.count = 1, .reusable = false}, SHIFT(2312),
  [3991] = {.count = 1, .reusable = true}, SHIFT(812),
  [3993] = {.count = 1, .reusable = true}, SHIFT(2317),
  [3995] = {.count = 1, .reusable = false}, SHIFT(2317),
  [3997] = {.count = 1, .reusable = true}, SHIFT(2318),
  [3999] = {.count = 1, .reusable = true}, SHIFT(2319),
  [4001] = {.count = 1, .reusable = true}, SHIFT(2322),
  [4003] = {.count = 1, .reusable = true}, SHIFT(2324),
  [4005] = {.count = 1, .reusable = true}, SHIFT(2325),
  [4007] = {.count = 1, .reusable = true}, SHIFT(2326),
  [4009] = {.count = 1, .reusable = true}, SHIFT(2327),
  [4011] = {.count = 1, .reusable = true}, SHIFT(2328),
  [4013] = {.count = 1, .reusable = true}, SHIFT(2329),
  [4015] = {.count = 1, .reusable = true}, SHIFT(2330),
  [4017] = {.count = 1, .reusable = true}, SHIFT(2331),
  [4019] = {.count = 1, .reusable = true}, SHIFT(2332),
  [4021] = {.count = 1, .reusable = true}, SHIFT(2333),
  [4023] = {.count = 1, .reusable = false}, SHIFT(2334),
  [4025] = {.count = 1, .reusable = true}, SHIFT(2335),
  [4027] = {.count = 1, .reusable = false}, SHIFT(2336),
  [4029] = {.count = 1, .reusable = false}, SHIFT(2337),
  [4031] = {.count = 1, .reusable = false}, SHIFT(2338),
  [4033] = {.count = 1, .reusable = false}, SHIFT(2339),
  [4035] = {.count = 1, .reusable = false}, SHIFT(2340),
  [4037] = {.count = 1, .reusable = false}, SHIFT(2341),
  [4039] = {.count = 1, .reusable = false}, SHIFT(2342),
  [4041] = {.count = 1, .reusable = false}, SHIFT(2343),
  [4043] = {.count = 1, .reusable = false}, SHIFT(2344),
  [4045] = {.count = 1, .reusable = false}, SHIFT(2345),
  [4047] = {.count = 1, .reusable = false}, SHIFT(2346),
  [4049] = {.count = 1, .reusable = false}, SHIFT(2347),
  [4051] = {.count = 1, .reusable = false}, SHIFT(2348),
  [4053] = {.count = 1, .reusable = false}, SHIFT(2332),
  [4055] = {.count = 1, .reusable = true}, SHIFT(2349),
  [4057] = {.count = 1, .reusable = false}, SHIFT(2349),
  [4059] = {.count = 1, .reusable = true}, SHIFT(2350),
  [4061] = {.count = 1, .reusable = false}, SHIFT(2355),
  [4063] = {.count = 1, .reusable = true}, SHIFT(2355),
  [4065] = {.count = 1, .reusable = false}, SHIFT(2351),
  [4067] = {.count = 1, .reusable = true}, SHIFT(2352),
  [4069] = {.count = 1, .reusable = true}, SHIFT(2353),
  [4071] = {.count = 1, .reusable = true}, SHIFT(2362),
  [4073] = {.count = 1, .reusable = true}, SHIFT(2363),
  [4075] = {.count = 1, .reusable = true}, SHIFT(2365),
  [4077] = {.count = 1, .reusable = true}, SHIFT(2366),
  [4079] = {.count = 1, .reusable = true}, SHIFT(2367),
  [4081] = {.count = 1, .reusable = false}, SHIFT(829),
  [4083] = {.count = 1, .reusable = false}, SHIFT(2369),
  [4085] = {.count = 1, .reusable = false}, SHIFT(2375),
  [4087] = {.count = 1, .reusable = true}, SHIFT(2376),
  [4089] = {.count = 1, .reusable = true}, SHIFT(2377),
  [4091] = {.count = 1, .reusable = false}, SHIFT(2378),
  [4093] = {.count = 1, .reusable = false}, SHIFT(2379),
  [4095] = {.count = 1, .reusable = false}, SHIFT(2380),
  [4097] = {.count = 1, .reusable = true}, SHIFT(2381),
  [4099] = {.count = 1, .reusable = false}, SHIFT(2382),
  [4101] = {.count = 1, .reusable = true}, SHIFT(2382),
  [4103] = {.count = 1, .reusable = true}, SHIFT(2383),
  [4105] = {.count = 1, .reusable = true}, SHIFT(2384),
  [4107] = {.count = 1, .reusable = true}, SHIFT(2385),
  [4109] = {.count = 1, .reusable = false}, SHIFT(2384),
  [4111] = {.count = 1, .reusable = true}, SHIFT(2380),
  [4113] = {.count = 1, .reusable = true}, SHIFT(2378),
  [4115] = {.count = 1, .reusable = true}, SHIFT(2388),
  [4117] = {.count = 1, .reusable = true}, SHIFT(2390),
  [4119] = {.count = 1, .reusable = false}, SHIFT(2390),
  [4121] = {.count = 1, .reusable = true}, SHIFT(2391),
  [4123] = {.count = 1, .reusable = false}, SHIFT(2362),
  [4125] = {.count = 1, .reusable = true}, SHIFT(2394),
  [4127] = {.count = 1, .reusable = true}, SHIFT(2396),
  [4129] = {.count = 1, .reusable = false}, SHIFT(2397),
  [4131] = {.count = 1, .reusable = true}, SHIFT(2398),
  [4133] = {.count = 1, .reusable = true}, SHIFT(2399),
  [4135] = {.count = 1, .reusable = false}, SHIFT(2400),
  [4137] = {.count = 1, .reusable = false}, SHIFT(2401),
  [4139] = {.count = 1, .reusable = false}, SHIFT(2402),
  [4141] = {.count = 1, .reusable = false}, SHIFT(2403),
  [4143] = {.count = 1, .reusable = false}, SHIFT(2399),
  [4145] = {.count = 1, .reusable = true}, SHIFT(2404),
  [4147] = {.count = 1, .reusable = false}, SHIFT(2404),
  [4149] = {.count = 1, .reusable = true}, SHIFT(2405),
  [4151] = {.count = 1, .reusable = true}, SHIFT(2413),
  [4153] = {.count = 1, .reusable = true}, SHIFT(2414),
  [4155] = {.count = 1, .reusable = true}, SHIFT(2416),
  [4157] = {.count = 1, .reusable = true}, SHIFT(2417),
  [4159] = {.count = 1, .reusable = true}, SHIFT(2418),
  [4161] = {.count = 1, .reusable = false}, SHIFT(857),
  [4163] = {.count = 1, .reusable = false}, SHIFT(2420),
  [4165] = {.count = 1, .reusable = false}, SHIFT(2426),
  [4167] = {.count = 1, .reusable = true}, SHIFT(2427),
  [4169] = {.count = 1, .reusable = true}, SHIFT(2428),
  [4171] = {.count = 1, .reusable = false}, SHIFT(2429),
  [4173] = {.count = 1, .reusable = false}, SHIFT(2430),
  [4175] = {.count = 1, .reusable = false}, SHIFT(2431),
  [4177] = {.count = 1, .reusable = true}, SHIFT(2432),
  [4179] = {.count = 1, .reusable = false}, SHIFT(2433),
  [4181] = {.count = 1, .reusable = true}, SHIFT(2433),
  [4183] = {.count = 1, .reusable = true}, SHIFT(2434),
  [4185] = {.count = 1, .reusable = true}, SHIFT(2435),
  [4187] = {.count = 1, .reusable = true}, SHIFT(2436),
  [4189] = {.count = 1, .reusable = false}, SHIFT(2435),
  [4191] = {.count = 1, .reusable = true}, SHIFT(2431),
  [4193] = {.count = 1, .reusable = true}, SHIFT(2429),
  [4195] = {.count = 1, .reusable = true}, SHIFT(2438),
  [4197] = {.count = 1, .reusable = true}, SHIFT(2440),
  [4199] = {.count = 1, .reusable = false}, SHIFT(2440),
  [4201] = {.count = 1, .reusable = true}, SHIFT(2441),
  [4203] = {.count = 1, .reusable = false}, SHIFT(2413),
  [4205] = {.count = 1, .reusable = true}, REDUCE(sym_module, 3),
  [4207] = {.count = 1, .reusable = false}, REDUCE(sym_module, 3),
  [4209] = {.count = 1, .reusable = false}, SHIFT(2443),
  [4211] = {.count = 1, .reusable = true}, REDUCE(sym_block_argument, 2),
  [4213] = {.count = 1, .reusable = true}, SHIFT(2448),
  [4215] = {.count = 1, .reusable = true}, SHIFT(2449),
  [4217] = {.count = 1, .reusable = false}, REDUCE(sym_block_argument, 2),
  [4219] = {.count = 1, .reusable = false}, SHIFT(2450),
  [4221] = {.count = 1, .reusable = false}, SHIFT(2451),
  [4223] = {.count = 1, .reusable = false}, SHIFT(2452),
  [4225] = {.count = 1, .reusable = true}, SHIFT(2453),
  [4227] = {.count = 1, .reusable = false}, SHIFT(2454),
  [4229] = {.count = 1, .reusable = true}, SHIFT(2454),
  [4231] = {.count = 1, .reusable = true}, SHIFT(2456),
  [4233] = {.count = 1, .reusable = true}, SHIFT(2457),
  [4235] = {.count = 1, .reusable = false}, SHIFT(2456),
  [4237] = {.count = 1, .reusable = true}, SHIFT(2452),
  [4239] = {.count = 1, .reusable = true}, SHIFT(2450),
  [4241] = {.count = 1, .reusable = true}, SHIFT(2458),
  [4243] = {.count = 1, .reusable = false}, SHIFT(2458),
  [4245] = {.count = 1, .reusable = true}, SHIFT(2459),
  [4247] = {.count = 1, .reusable = true}, REDUCE(sym_splat_argument, 2),
  [4249] = {.count = 1, .reusable = false}, REDUCE(sym_splat_argument, 2),
  [4251] = {.count = 1, .reusable = false}, REDUCE(sym_hash_splat_argument, 2),
  [4253] = {.count = 1, .reusable = true}, SHIFT(2464),
  [4255] = {.count = 1, .reusable = false}, SHIFT(2466),
  [4257] = {.count = 1, .reusable = true}, SHIFT(2468),
  [4259] = {.count = 1, .reusable = false}, SHIFT(2464),
  [4261] = {.count = 1, .reusable = true}, SHIFT(2470),
  [4263] = {.count = 1, .reusable = false}, SHIFT(2471),
  [4265] = {.count = 1, .reusable = false}, SHIFT(2472),
  [4267] = {.count = 1, .reusable = false}, SHIFT(2473),
  [4269] = {.count = 1, .reusable = false}, SHIFT(2474),
  [4271] = {.count = 1, .reusable = false}, SHIFT(2470),
  [4273] = {.count = 1, .reusable = true}, SHIFT(2475),
  [4275] = {.count = 1, .reusable = false}, SHIFT(2475),
  [4277] = {.count = 1, .reusable = true}, SHIFT(2476),
  [4279] = {.count = 1, .reusable = false}, SHIFT(2478),
  [4281] = {.count = 1, .reusable = true}, SHIFT(2478),
  [4283] = {.count = 1, .reusable = true}, SHIFT(2485),
  [4285] = {.count = 1, .reusable = true}, REDUCE(sym__argument_list_with_parens, 2),
  [4287] = {.count = 1, .reusable = false}, REDUCE(sym__argument_list_with_parens, 2),
  [4289] = {.count = 1, .reusable = true}, SHIFT(2487),
  [4291] = {.count = 1, .reusable = true}, SHIFT(2488),
  [4293] = {.count = 1, .reusable = true}, SHIFT(2489),
  [4295] = {.count = 1, .reusable = false}, SHIFT(2491),
  [4297] = {.count = 1, .reusable = false}, SHIFT(2497),
  [4299] = {.count = 1, .reusable = true}, SHIFT(2498),
  [4301] = {.count = 1, .reusable = true}, SHIFT(2499),
  [4303] = {.count = 1, .reusable = false}, SHIFT(2500),
  [4305] = {.count = 1, .reusable = false}, SHIFT(2501),
  [4307] = {.count = 1, .reusable = false}, SHIFT(2502),
  [4309] = {.count = 1, .reusable = true}, SHIFT(2503),
  [4311] = {.count = 1, .reusable = false}, SHIFT(2504),
  [4313] = {.count = 1, .reusable = true}, SHIFT(2504),
  [4315] = {.count = 1, .reusable = true}, SHIFT(2505),
  [4317] = {.count = 1, .reusable = true}, SHIFT(2506),
  [4319] = {.count = 1, .reusable = true}, SHIFT(2507),
  [4321] = {.count = 1, .reusable = false}, SHIFT(2506),
  [4323] = {.count = 1, .reusable = true}, SHIFT(2502),
  [4325] = {.count = 1, .reusable = true}, SHIFT(2500),
  [4327] = {.count = 1, .reusable = true}, SHIFT(2508),
  [4329] = {.count = 1, .reusable = true}, SHIFT(2509),
  [4331] = {.count = 1, .reusable = true}, SHIFT(2510),
  [4333] = {.count = 1, .reusable = false}, SHIFT(2512),
  [4335] = {.count = 1, .reusable = true}, SHIFT(2517),
  [4337] = {.count = 1, .reusable = true}, SHIFT(2518),
  [4339] = {.count = 1, .reusable = true}, SHIFT(2520),
  [4341] = {.count = 1, .reusable = false}, SHIFT(2520),
  [4343] = {.count = 1, .reusable = true}, SHIFT(2521),
  [4345] = {.count = 1, .reusable = false}, SHIFT(2485),
  [4347] = {.count = 1, .reusable = true}, SHIFT(2534),
  [4349] = {.count = 1, .reusable = false}, SHIFT(2534),
  [4351] = {.count = 1, .reusable = true}, SHIFT(2535),
  [4353] = {.count = 1, .reusable = true}, SHIFT(2536),
  [4355] = {.count = 1, .reusable = true}, SHIFT(2539),
  [4357] = {.count = 1, .reusable = true}, SHIFT(2541),
  [4359] = {.count = 1, .reusable = true}, SHIFT(2544),
  [4361] = {.count = 1, .reusable = true}, SHIFT(2545),
  [4363] = {.count = 1, .reusable = true}, SHIFT(2552),
  [4365] = {.count = 1, .reusable = false}, SHIFT(2549),
  [4367] = {.count = 1, .reusable = true}, SHIFT(2553),
  [4369] = {.count = 1, .reusable = false}, SHIFT(2555),
  [4371] = {.count = 1, .reusable = true}, SHIFT(934),
  [4373] = {.count = 1, .reusable = true}, SHIFT(2557),
  [4375] = {.count = 1, .reusable = true}, SHIFT(2559),
  [4377] = {.count = 1, .reusable = false}, SHIFT(2544),
  [4379] = {.count = 1, .reusable = true}, SHIFT(2562),
  [4381] = {.count = 1, .reusable = true}, SHIFT(2561),
  [4383] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list, 2),
  [4385] = {.count = 1, .reusable = false}, REDUCE(sym_argument_list, 2),
  [4387] = {.count = 1, .reusable = true}, SHIFT(2564),
  [4389] = {.count = 1, .reusable = true}, SHIFT(201),
  [4391] = {.count = 1, .reusable = true}, SHIFT(2574),
  [4393] = {.count = 1, .reusable = false}, SHIFT(2575),
  [4395] = {.count = 1, .reusable = false}, SHIFT(2576),
  [4397] = {.count = 1, .reusable = false}, SHIFT(2577),
  [4399] = {.count = 1, .reusable = false}, SHIFT(2578),
  [4401] = {.count = 1, .reusable = false}, SHIFT(2574),
  [4403] = {.count = 1, .reusable = true}, SHIFT(2579),
  [4405] = {.count = 1, .reusable = false}, SHIFT(2579),
  [4407] = {.count = 1, .reusable = true}, SHIFT(2580),
  [4409] = {.count = 1, .reusable = false}, SHIFT(953),
  [4411] = {.count = 1, .reusable = true}, SHIFT(2588),
  [4413] = {.count = 1, .reusable = true}, SHIFT(2590),
  [4415] = {.count = 1, .reusable = true}, SHIFT(2591),
  [4417] = {.count = 1, .reusable = true}, SHIFT(2592),
  [4419] = {.count = 1, .reusable = false}, SHIFT(2594),
  [4421] = {.count = 1, .reusable = false}, SHIFT(2600),
  [4423] = {.count = 1, .reusable = true}, SHIFT(2601),
  [4425] = {.count = 1, .reusable = true}, SHIFT(2602),
  [4427] = {.count = 1, .reusable = false}, SHIFT(2603),
  [4429] = {.count = 1, .reusable = false}, SHIFT(2604),
  [4431] = {.count = 1, .reusable = false}, SHIFT(2605),
  [4433] = {.count = 1, .reusable = true}, SHIFT(2606),
  [4435] = {.count = 1, .reusable = false}, SHIFT(2607),
  [4437] = {.count = 1, .reusable = true}, SHIFT(2607),
  [4439] = {.count = 1, .reusable = true}, SHIFT(2609),
  [4441] = {.count = 1, .reusable = true}, SHIFT(2610),
  [4443] = {.count = 1, .reusable = false}, SHIFT(2609),
  [4445] = {.count = 1, .reusable = true}, SHIFT(2605),
  [4447] = {.count = 1, .reusable = true}, SHIFT(2603),
  [4449] = {.count = 1, .reusable = true}, SHIFT(2611),
  [4451] = {.count = 1, .reusable = true}, SHIFT(2612),
  [4453] = {.count = 1, .reusable = true}, SHIFT(2613),
  [4455] = {.count = 1, .reusable = false}, SHIFT(2615),
  [4457] = {.count = 1, .reusable = true}, SHIFT(2621),
  [4459] = {.count = 1, .reusable = true}, SHIFT(2623),
  [4461] = {.count = 1, .reusable = false}, SHIFT(2623),
  [4463] = {.count = 1, .reusable = true}, SHIFT(2624),
  [4465] = {.count = 1, .reusable = false}, SHIFT(2588),
  [4467] = {.count = 1, .reusable = true}, SHIFT(2632),
  [4469] = {.count = 1, .reusable = false}, REDUCE(sym_then, 1),
  [4471] = {.count = 1, .reusable = false}, SHIFT(2633),
  [4473] = {.count = 1, .reusable = false}, SHIFT(2634),
  [4475] = {.count = 1, .reusable = false}, SHIFT(2635),
  [4477] = {.count = 1, .reusable = false}, SHIFT(2636),
  [4479] = {.count = 1, .reusable = false}, SHIFT(2632),
  [4481] = {.count = 1, .reusable = true}, SHIFT(2637),
  [4483] = {.count = 1, .reusable = false}, SHIFT(2637),
  [4485] = {.count = 1, .reusable = true}, SHIFT(2638),
  [4487] = {.count = 1, .reusable = false}, SHIFT(2643),
  [4489] = {.count = 1, .reusable = true}, SHIFT(2643),
  [4491] = {.count = 1, .reusable = false}, SHIFT(2639),
  [4493] = {.count = 1, .reusable = true}, SHIFT(2648),
  [4495] = {.count = 1, .reusable = true}, SHIFT(2649),
  [4497] = {.count = 1, .reusable = false}, SHIFT(2648),
  [4499] = {.count = 1, .reusable = false}, SHIFT(2649),
  [4501] = {.count = 1, .reusable = false}, SHIFT(1132),
  [4503] = {.count = 1, .reusable = false}, SHIFT(2651),
  [4505] = {.count = 1, .reusable = true}, SHIFT(2662),
  [4507] = {.count = 1, .reusable = false}, SHIFT(2663),
  [4509] = {.count = 1, .reusable = false}, SHIFT(2664),
  [4511] = {.count = 1, .reusable = false}, SHIFT(2665),
  [4513] = {.count = 1, .reusable = false}, SHIFT(2666),
  [4515] = {.count = 1, .reusable = false}, SHIFT(2662),
  [4517] = {.count = 1, .reusable = true}, SHIFT(2667),
  [4519] = {.count = 1, .reusable = false}, SHIFT(2667),
  [4521] = {.count = 1, .reusable = true}, SHIFT(2668),
  [4523] = {.count = 1, .reusable = false}, SHIFT(2670),
  [4525] = {.count = 1, .reusable = true}, SHIFT(2670),
  [4527] = {.count = 1, .reusable = false}, SHIFT(992),
  [4529] = {.count = 1, .reusable = true}, SHIFT(2677),
  [4531] = {.count = 1, .reusable = false}, SHIFT(2680),
  [4533] = {.count = 1, .reusable = true}, SHIFT(2681),
  [4535] = {.count = 1, .reusable = true}, SHIFT(2682),
  [4537] = {.count = 1, .reusable = false}, SHIFT(2683),
  [4539] = {.count = 1, .reusable = false}, SHIFT(2682),
  [4541] = {.count = 1, .reusable = false}, SHIFT(2684),
  [4543] = {.count = 1, .reusable = false}, SHIFT(2685),
  [4545] = {.count = 1, .reusable = true}, SHIFT(2686),
  [4547] = {.count = 1, .reusable = false}, SHIFT(2687),
  [4549] = {.count = 1, .reusable = true}, SHIFT(2687),
  [4551] = {.count = 1, .reusable = false}, SHIFT(2689),
  [4553] = {.count = 1, .reusable = false}, SHIFT(2690),
  [4555] = {.count = 1, .reusable = true}, SHIFT(2689),
  [4557] = {.count = 1, .reusable = true}, SHIFT(2685),
  [4559] = {.count = 1, .reusable = false}, SHIFT(2681),
  [4561] = {.count = 1, .reusable = true}, SHIFT(2692),
  [4563] = {.count = 1, .reusable = true}, SHIFT(2694),
  [4565] = {.count = 1, .reusable = false}, SHIFT(2694),
  [4567] = {.count = 1, .reusable = true}, SHIFT(2695),
  [4569] = {.count = 1, .reusable = false}, SHIFT(2677),
  [4571] = {.count = 1, .reusable = true}, SHIFT(2697),
  [4573] = {.count = 1, .reusable = true}, SHIFT(2698),
  [4575] = {.count = 1, .reusable = false}, SHIFT(2698),
  [4577] = {.count = 1, .reusable = true}, SHIFT(2699),
  [4579] = {.count = 1, .reusable = false}, SHIFT(2699),
  [4581] = {.count = 1, .reusable = true}, SHIFT(2700),
  [4583] = {.count = 1, .reusable = true}, SHIFT(2707),
  [4585] = {.count = 1, .reusable = false}, SHIFT(2708),
  [4587] = {.count = 1, .reusable = false}, SHIFT(2709),
  [4589] = {.count = 1, .reusable = false}, SHIFT(2710),
  [4591] = {.count = 1, .reusable = false}, SHIFT(2711),
  [4593] = {.count = 1, .reusable = false}, SHIFT(2707),
  [4595] = {.count = 1, .reusable = true}, SHIFT(2712),
  [4597] = {.count = 1, .reusable = false}, SHIFT(2712),
  [4599] = {.count = 1, .reusable = true}, SHIFT(2713),
  [4601] = {.count = 1, .reusable = false}, SHIFT(2717),
  [4603] = {.count = 1, .reusable = true}, SHIFT(2717),
  [4605] = {.count = 1, .reusable = false}, SHIFT(2714),
  [4607] = {.count = 1, .reusable = true}, SHIFT(2722),
  [4609] = {.count = 1, .reusable = false}, SHIFT(2722),
  [4611] = {.count = 1, .reusable = false}, SHIFT(2724),
  [4613] = {.count = 1, .reusable = true}, SHIFT(2725),
  [4615] = {.count = 1, .reusable = false}, SHIFT(2726),
  [4617] = {.count = 1, .reusable = false}, SHIFT(2727),
  [4619] = {.count = 1, .reusable = false}, SHIFT(2728),
  [4621] = {.count = 1, .reusable = false}, SHIFT(2729),
  [4623] = {.count = 1, .reusable = false}, SHIFT(2725),
  [4625] = {.count = 1, .reusable = true}, SHIFT(2730),
  [4627] = {.count = 1, .reusable = false}, SHIFT(2730),
  [4629] = {.count = 1, .reusable = true}, SHIFT(2731),
  [4631] = {.count = 1, .reusable = false}, SHIFT(1018),
  [4633] = {.count = 1, .reusable = true}, SHIFT(2739),
  [4635] = {.count = 1, .reusable = true}, SHIFT(2741),
  [4637] = {.count = 1, .reusable = true}, SHIFT(2742),
  [4639] = {.count = 1, .reusable = true}, SHIFT(2743),
  [4641] = {.count = 1, .reusable = false}, SHIFT(2745),
  [4643] = {.count = 1, .reusable = false}, SHIFT(2751),
  [4645] = {.count = 1, .reusable = true}, SHIFT(2752),
  [4647] = {.count = 1, .reusable = true}, SHIFT(2753),
  [4649] = {.count = 1, .reusable = false}, SHIFT(2754),
  [4651] = {.count = 1, .reusable = false}, SHIFT(2755),
  [4653] = {.count = 1, .reusable = false}, SHIFT(2756),
  [4655] = {.count = 1, .reusable = true}, SHIFT(2757),
  [4657] = {.count = 1, .reusable = false}, SHIFT(2758),
  [4659] = {.count = 1, .reusable = true}, SHIFT(2758),
  [4661] = {.count = 1, .reusable = true}, SHIFT(2760),
  [4663] = {.count = 1, .reusable = true}, SHIFT(2761),
  [4665] = {.count = 1, .reusable = false}, SHIFT(2760),
  [4667] = {.count = 1, .reusable = true}, SHIFT(2756),
  [4669] = {.count = 1, .reusable = true}, SHIFT(2754),
  [4671] = {.count = 1, .reusable = true}, SHIFT(2762),
  [4673] = {.count = 1, .reusable = true}, SHIFT(2763),
  [4675] = {.count = 1, .reusable = true}, SHIFT(2764),
  [4677] = {.count = 1, .reusable = true}, SHIFT(2765),
  [4679] = {.count = 1, .reusable = false}, SHIFT(2767),
  [4681] = {.count = 1, .reusable = true}, SHIFT(2773),
  [4683] = {.count = 1, .reusable = true}, SHIFT(2775),
  [4685] = {.count = 1, .reusable = false}, SHIFT(2775),
  [4687] = {.count = 1, .reusable = true}, SHIFT(2776),
  [4689] = {.count = 1, .reusable = false}, SHIFT(2739),
  [4691] = {.count = 1, .reusable = false}, SHIFT(2788),
  [4693] = {.count = 1, .reusable = true}, SHIFT(2790),
  [4695] = {.count = 1, .reusable = false}, SHIFT(2791),
  [4697] = {.count = 1, .reusable = false}, SHIFT(2792),
  [4699] = {.count = 1, .reusable = false}, SHIFT(2793),
  [4701] = {.count = 1, .reusable = false}, SHIFT(2794),
  [4703] = {.count = 1, .reusable = false}, SHIFT(2790),
  [4705] = {.count = 1, .reusable = true}, SHIFT(2795),
  [4707] = {.count = 1, .reusable = false}, SHIFT(2795),
  [4709] = {.count = 1, .reusable = true}, SHIFT(2796),
  [4711] = {.count = 1, .reusable = false}, SHIFT(2798),
  [4713] = {.count = 1, .reusable = true}, SHIFT(2798),
  [4715] = {.count = 1, .reusable = false}, SHIFT(1049),
  [4717] = {.count = 1, .reusable = true}, SHIFT(2805),
  [4719] = {.count = 1, .reusable = true}, SHIFT(2806),
  [4721] = {.count = 1, .reusable = false}, SHIFT(2809),
  [4723] = {.count = 1, .reusable = true}, SHIFT(2810),
  [4725] = {.count = 1, .reusable = true}, SHIFT(2811),
  [4727] = {.count = 1, .reusable = false}, SHIFT(2812),
  [4729] = {.count = 1, .reusable = false}, SHIFT(2811),
  [4731] = {.count = 1, .reusable = false}, SHIFT(2813),
  [4733] = {.count = 1, .reusable = false}, SHIFT(2814),
  [4735] = {.count = 1, .reusable = true}, SHIFT(2815),
  [4737] = {.count = 1, .reusable = false}, SHIFT(2816),
  [4739] = {.count = 1, .reusable = true}, SHIFT(2816),
  [4741] = {.count = 1, .reusable = false}, SHIFT(2818),
  [4743] = {.count = 1, .reusable = false}, SHIFT(2819),
  [4745] = {.count = 1, .reusable = true}, SHIFT(2818),
  [4747] = {.count = 1, .reusable = true}, SHIFT(2814),
  [4749] = {.count = 1, .reusable = false}, SHIFT(2810),
  [4751] = {.count = 1, .reusable = true}, SHIFT(2821),
  [4753] = {.count = 1, .reusable = true}, SHIFT(2823),
  [4755] = {.count = 1, .reusable = false}, SHIFT(2823),
  [4757] = {.count = 1, .reusable = true}, SHIFT(2824),
  [4759] = {.count = 1, .reusable = false}, SHIFT(2805),
  [4761] = {.count = 1, .reusable = true}, SHIFT(2826),
  [4763] = {.count = 1, .reusable = true}, SHIFT(2827),
  [4765] = {.count = 1, .reusable = false}, SHIFT(2827),
  [4767] = {.count = 1, .reusable = true}, SHIFT(2828),
  [4769] = {.count = 1, .reusable = false}, SHIFT(2828),
  [4771] = {.count = 1, .reusable = true}, SHIFT(2829),
  [4773] = {.count = 1, .reusable = false}, SHIFT(2836),
  [4775] = {.count = 1, .reusable = true}, SHIFT(2838),
  [4777] = {.count = 1, .reusable = false}, SHIFT(2839),
  [4779] = {.count = 1, .reusable = false}, SHIFT(2840),
  [4781] = {.count = 1, .reusable = false}, SHIFT(2841),
  [4783] = {.count = 1, .reusable = false}, SHIFT(2842),
  [4785] = {.count = 1, .reusable = false}, SHIFT(2838),
  [4787] = {.count = 1, .reusable = true}, SHIFT(2843),
  [4789] = {.count = 1, .reusable = false}, SHIFT(2843),
  [4791] = {.count = 1, .reusable = true}, SHIFT(2844),
  [4793] = {.count = 1, .reusable = false}, SHIFT(2846),
  [4795] = {.count = 1, .reusable = true}, SHIFT(2846),
  [4797] = {.count = 1, .reusable = true}, SHIFT(2853),
  [4799] = {.count = 1, .reusable = true}, SHIFT(2855),
  [4801] = {.count = 1, .reusable = true}, SHIFT(2856),
  [4803] = {.count = 1, .reusable = true}, SHIFT(2857),
  [4805] = {.count = 1, .reusable = false}, SHIFT(1082),
  [4807] = {.count = 1, .reusable = false}, SHIFT(2859),
  [4809] = {.count = 1, .reusable = false}, SHIFT(2865),
  [4811] = {.count = 1, .reusable = true}, SHIFT(2866),
  [4813] = {.count = 1, .reusable = true}, SHIFT(2867),
  [4815] = {.count = 1, .reusable = false}, SHIFT(2868),
  [4817] = {.count = 1, .reusable = false}, SHIFT(2869),
  [4819] = {.count = 1, .reusable = false}, SHIFT(2870),
  [4821] = {.count = 1, .reusable = true}, SHIFT(2871),
  [4823] = {.count = 1, .reusable = false}, SHIFT(2872),
  [4825] = {.count = 1, .reusable = true}, SHIFT(2872),
  [4827] = {.count = 1, .reusable = true}, SHIFT(2873),
  [4829] = {.count = 1, .reusable = true}, SHIFT(2874),
  [4831] = {.count = 1, .reusable = true}, SHIFT(2875),
  [4833] = {.count = 1, .reusable = false}, SHIFT(2874),
  [4835] = {.count = 1, .reusable = true}, SHIFT(2870),
  [4837] = {.count = 1, .reusable = true}, SHIFT(2868),
  [4839] = {.count = 1, .reusable = true}, SHIFT(2876),
  [4841] = {.count = 1, .reusable = true}, SHIFT(2877),
  [4843] = {.count = 1, .reusable = true}, SHIFT(2878),
  [4845] = {.count = 1, .reusable = true}, SHIFT(2879),
  [4847] = {.count = 1, .reusable = false}, SHIFT(2881),
  [4849] = {.count = 1, .reusable = false}, SHIFT(2882),
  [4851] = {.count = 1, .reusable = false}, SHIFT(2883),
  [4853] = {.count = 1, .reusable = false}, SHIFT(2884),
  [4855] = {.count = 1, .reusable = true}, SHIFT(2885),
  [4857] = {.count = 1, .reusable = false}, SHIFT(2885),
  [4859] = {.count = 1, .reusable = false}, SHIFT(2886),
  [4861] = {.count = 1, .reusable = true}, SHIFT(2886),
  [4863] = {.count = 1, .reusable = false}, SHIFT(2887),
  [4865] = {.count = 1, .reusable = true}, SHIFT(2895),
  [4867] = {.count = 1, .reusable = true}, SHIFT(2897),
  [4869] = {.count = 1, .reusable = false}, SHIFT(2897),
  [4871] = {.count = 1, .reusable = true}, SHIFT(2898),
  [4873] = {.count = 1, .reusable = false}, SHIFT(2853),
  [4875] = {.count = 1, .reusable = true}, SHIFT(2901),
  [4877] = {.count = 1, .reusable = false}, REDUCE(sym__mlhs, 2),
  [4879] = {.count = 1, .reusable = true}, SHIFT(2902),
  [4881] = {.count = 1, .reusable = true}, SHIFT(2904),
  [4883] = {.count = 1, .reusable = false}, SHIFT(2905),
  [4885] = {.count = 1, .reusable = false}, SHIFT(2906),
  [4887] = {.count = 1, .reusable = false}, SHIFT(2907),
  [4889] = {.count = 1, .reusable = false}, SHIFT(2908),
  [4891] = {.count = 1, .reusable = false}, SHIFT(2904),
  [4893] = {.count = 1, .reusable = true}, SHIFT(2909),
  [4895] = {.count = 1, .reusable = false}, SHIFT(2909),
  [4897] = {.count = 1, .reusable = true}, SHIFT(2910),
  [4899] = {.count = 1, .reusable = false}, SHIFT(1098),
  [4901] = {.count = 1, .reusable = true}, SHIFT(2918),
  [4903] = {.count = 1, .reusable = true}, SHIFT(2920),
  [4905] = {.count = 1, .reusable = true}, SHIFT(2921),
  [4907] = {.count = 1, .reusable = true}, SHIFT(2922),
  [4909] = {.count = 1, .reusable = false}, SHIFT(2924),
  [4911] = {.count = 1, .reusable = false}, SHIFT(2930),
  [4913] = {.count = 1, .reusable = true}, SHIFT(2931),
  [4915] = {.count = 1, .reusable = true}, SHIFT(2932),
  [4917] = {.count = 1, .reusable = false}, SHIFT(2933),
  [4919] = {.count = 1, .reusable = false}, SHIFT(2934),
  [4921] = {.count = 1, .reusable = false}, SHIFT(2935),
  [4923] = {.count = 1, .reusable = true}, SHIFT(2936),
  [4925] = {.count = 1, .reusable = false}, SHIFT(2937),
  [4927] = {.count = 1, .reusable = true}, SHIFT(2937),
  [4929] = {.count = 1, .reusable = true}, SHIFT(2939),
  [4931] = {.count = 1, .reusable = true}, SHIFT(2940),
  [4933] = {.count = 1, .reusable = false}, SHIFT(2939),
  [4935] = {.count = 1, .reusable = true}, SHIFT(2935),
  [4937] = {.count = 1, .reusable = true}, SHIFT(2933),
  [4939] = {.count = 1, .reusable = true}, SHIFT(2942),
  [4941] = {.count = 1, .reusable = true}, SHIFT(2944),
  [4943] = {.count = 1, .reusable = false}, SHIFT(2944),
  [4945] = {.count = 1, .reusable = true}, SHIFT(2945),
  [4947] = {.count = 1, .reusable = false}, SHIFT(2918),
  [4949] = {.count = 1, .reusable = true}, SHIFT(2959),
  [4951] = {.count = 1, .reusable = true}, SHIFT(2957),
  [4953] = {.count = 1, .reusable = true}, SHIFT(2961),
  [4955] = {.count = 1, .reusable = true}, SHIFT(2962),
  [4957] = {.count = 1, .reusable = false}, SHIFT(2962),
  [4959] = {.count = 1, .reusable = true}, SHIFT(2963),
  [4961] = {.count = 1, .reusable = false}, SHIFT(2963),
  [4963] = {.count = 1, .reusable = true}, SHIFT(2964),
  [4965] = {.count = 1, .reusable = true}, REDUCE(sym_case, 3),
  [4967] = {.count = 1, .reusable = false}, REDUCE(sym_case, 3),
  [4969] = {.count = 1, .reusable = true}, SHIFT(2971),
  [4971] = {.count = 1, .reusable = true}, SHIFT(2972),
  [4973] = {.count = 1, .reusable = false}, SHIFT(2973),
  [4975] = {.count = 1, .reusable = false}, SHIFT(2974),
  [4977] = {.count = 1, .reusable = false}, SHIFT(2975),
  [4979] = {.count = 1, .reusable = false}, SHIFT(2976),
  [4981] = {.count = 1, .reusable = false}, SHIFT(2972),
  [4983] = {.count = 1, .reusable = true}, SHIFT(2977),
  [4985] = {.count = 1, .reusable = false}, SHIFT(2977),
  [4987] = {.count = 1, .reusable = true}, SHIFT(2978),
  [4989] = {.count = 1, .reusable = false}, SHIFT(2981),
  [4991] = {.count = 1, .reusable = true}, SHIFT(2981),
  [4993] = {.count = 1, .reusable = true}, SHIFT(2986),
  [4995] = {.count = 1, .reusable = true}, SHIFT(2987),
  [4997] = {.count = 1, .reusable = false}, REDUCE(sym_heredoc_body, 2),
  [4999] = {.count = 1, .reusable = true}, SHIFT(2989),
  [5001] = {.count = 1, .reusable = true}, SHIFT(2990),
  [5003] = {.count = 1, .reusable = false}, SHIFT(2991),
  [5005] = {.count = 1, .reusable = false}, SHIFT(2992),
  [5007] = {.count = 1, .reusable = false}, SHIFT(2993),
  [5009] = {.count = 1, .reusable = false}, SHIFT(2994),
  [5011] = {.count = 1, .reusable = false}, SHIFT(2990),
  [5013] = {.count = 1, .reusable = true}, SHIFT(2995),
  [5015] = {.count = 1, .reusable = false}, SHIFT(2995),
  [5017] = {.count = 1, .reusable = true}, SHIFT(2996),
  [5019] = {.count = 1, .reusable = false}, SHIFT(1141),
  [5021] = {.count = 1, .reusable = true}, SHIFT(3004),
  [5023] = {.count = 1, .reusable = true}, SHIFT(3006),
  [5025] = {.count = 1, .reusable = true}, SHIFT(3007),
  [5027] = {.count = 1, .reusable = true}, SHIFT(3008),
  [5029] = {.count = 1, .reusable = false}, SHIFT(3010),
  [5031] = {.count = 1, .reusable = false}, SHIFT(3016),
  [5033] = {.count = 1, .reusable = true}, SHIFT(3017),
  [5035] = {.count = 1, .reusable = true}, SHIFT(3018),
  [5037] = {.count = 1, .reusable = false}, SHIFT(3019),
  [5039] = {.count = 1, .reusable = false}, SHIFT(3020),
  [5041] = {.count = 1, .reusable = false}, SHIFT(3021),
  [5043] = {.count = 1, .reusable = true}, SHIFT(3022),
  [5045] = {.count = 1, .reusable = false}, SHIFT(3023),
  [5047] = {.count = 1, .reusable = true}, SHIFT(3023),
  [5049] = {.count = 1, .reusable = true}, SHIFT(3025),
  [5051] = {.count = 1, .reusable = true}, SHIFT(3026),
  [5053] = {.count = 1, .reusable = false}, SHIFT(3025),
  [5055] = {.count = 1, .reusable = true}, SHIFT(3021),
  [5057] = {.count = 1, .reusable = true}, SHIFT(3019),
  [5059] = {.count = 1, .reusable = true}, SHIFT(3027),
  [5061] = {.count = 1, .reusable = true}, SHIFT(3028),
  [5063] = {.count = 1, .reusable = true}, SHIFT(3029),
  [5065] = {.count = 1, .reusable = false}, SHIFT(3031),
  [5067] = {.count = 1, .reusable = true}, SHIFT(3037),
  [5069] = {.count = 1, .reusable = true}, SHIFT(3039),
  [5071] = {.count = 1, .reusable = false}, SHIFT(3039),
  [5073] = {.count = 1, .reusable = true}, SHIFT(3040),
  [5075] = {.count = 1, .reusable = false}, SHIFT(3004),
  [5077] = {.count = 1, .reusable = true}, SHIFT(3044),
  [5079] = {.count = 1, .reusable = true}, SHIFT(3045),
  [5081] = {.count = 1, .reusable = true}, SHIFT(3046),
  [5083] = {.count = 1, .reusable = true}, SHIFT(3047),
  [5085] = {.count = 1, .reusable = true}, SHIFT(3049),
  [5087] = {.count = 1, .reusable = false}, SHIFT(3049),
  [5089] = {.count = 1, .reusable = false}, SHIFT(3050),
  [5091] = {.count = 1, .reusable = true}, SHIFT(3050),
  [5093] = {.count = 1, .reusable = false}, SHIFT(3051),
  [5095] = {.count = 1, .reusable = true}, SHIFT(3061),
  [5097] = {.count = 1, .reusable = false}, SHIFT(3061),
  [5099] = {.count = 1, .reusable = false}, SHIFT(3062),
  [5101] = {.count = 1, .reusable = true}, SHIFT(3062),
  [5103] = {.count = 1, .reusable = false}, SHIFT(3058),
  [5105] = {.count = 1, .reusable = false}, SHIFT(3059),
  [5107] = {.count = 1, .reusable = false}, SHIFT(3060),
  [5109] = {.count = 1, .reusable = true}, REDUCE(sym_rescue, 2),
  [5111] = {.count = 1, .reusable = true}, SHIFT(3068),
  [5113] = {.count = 1, .reusable = true}, SHIFT(1164),
  [5115] = {.count = 1, .reusable = true}, REDUCE(sym__arg_or_splat_arg, 1),
  [5117] = {.count = 1, .reusable = true}, SHIFT(3069),
  [5119] = {.count = 1, .reusable = true}, SHIFT(3070),
  [5121] = {.count = 1, .reusable = false}, SHIFT(3071),
  [5123] = {.count = 1, .reusable = false}, SHIFT(3072),
  [5125] = {.count = 1, .reusable = false}, SHIFT(3073),
  [5127] = {.count = 1, .reusable = true}, SHIFT(3074),
  [5129] = {.count = 1, .reusable = false}, SHIFT(3075),
  [5131] = {.count = 1, .reusable = true}, SHIFT(3075),
  [5133] = {.count = 1, .reusable = true}, SHIFT(3076),
  [5135] = {.count = 1, .reusable = true}, SHIFT(3077),
  [5137] = {.count = 1, .reusable = true}, SHIFT(3078),
  [5139] = {.count = 1, .reusable = false}, SHIFT(3077),
  [5141] = {.count = 1, .reusable = true}, SHIFT(3073),
  [5143] = {.count = 1, .reusable = true}, SHIFT(3071),
  [5145] = {.count = 1, .reusable = true}, SHIFT(3079),
  [5147] = {.count = 1, .reusable = true}, SHIFT(3080),
  [5149] = {.count = 1, .reusable = true}, SHIFT(3081),
  [5151] = {.count = 1, .reusable = true}, SHIFT(3082),
  [5153] = {.count = 1, .reusable = false}, SHIFT(3084),
  [5155] = {.count = 1, .reusable = false}, SHIFT(3085),
  [5157] = {.count = 1, .reusable = false}, SHIFT(3086),
  [5159] = {.count = 1, .reusable = false}, SHIFT(3087),
  [5161] = {.count = 1, .reusable = true}, SHIFT(3088),
  [5163] = {.count = 1, .reusable = false}, SHIFT(3088),
  [5165] = {.count = 1, .reusable = false}, SHIFT(3089),
  [5167] = {.count = 1, .reusable = true}, SHIFT(3089),
  [5169] = {.count = 1, .reusable = false}, SHIFT(3090),
  [5171] = {.count = 1, .reusable = true}, SHIFT(3092),
  [5173] = {.count = 1, .reusable = false}, SHIFT(3092),
  [5175] = {.count = 1, .reusable = true}, REDUCE(sym_exceptions, 1),
  [5177] = {.count = 1, .reusable = true}, SHIFT(3098),
  [5179] = {.count = 1, .reusable = true}, SHIFT(3100),
  [5181] = {.count = 1, .reusable = false}, SHIFT(3100),
  [5183] = {.count = 1, .reusable = true}, SHIFT(3101),
  [5185] = {.count = 1, .reusable = false}, REDUCE(sym_rescue, 2),
  [5187] = {.count = 1, .reusable = false}, SHIFT(3103),
  [5189] = {.count = 1, .reusable = true}, SHIFT(3105),
  [5191] = {.count = 1, .reusable = true}, SHIFT(3106),
  [5193] = {.count = 1, .reusable = true}, SHIFT(3107),
  [5195] = {.count = 1, .reusable = true}, SHIFT(3108),
  [5197] = {.count = 1, .reusable = false}, SHIFT(3110),
  [5199] = {.count = 1, .reusable = false}, SHIFT(3111),
  [5201] = {.count = 1, .reusable = false}, SHIFT(3112),
  [5203] = {.count = 1, .reusable = false}, SHIFT(3113),
  [5205] = {.count = 1, .reusable = true}, SHIFT(3114),
  [5207] = {.count = 1, .reusable = false}, SHIFT(3114),
  [5209] = {.count = 1, .reusable = false}, SHIFT(3115),
  [5211] = {.count = 1, .reusable = true}, SHIFT(3115),
  [5213] = {.count = 1, .reusable = false}, SHIFT(3116),
  [5215] = {.count = 1, .reusable = true}, SHIFT(3118),
  [5217] = {.count = 1, .reusable = false}, SHIFT(3118),
  [5219] = {.count = 1, .reusable = true}, SHIFT(3125),
  [5221] = {.count = 1, .reusable = true}, REDUCE(sym_else, 2),
  [5223] = {.count = 1, .reusable = true}, SHIFT(3126),
  [5225] = {.count = 1, .reusable = true}, SHIFT(3127),
  [5227] = {.count = 1, .reusable = true}, SHIFT(3128),
  [5229] = {.count = 1, .reusable = true}, SHIFT(3129),
  [5231] = {.count = 1, .reusable = true}, SHIFT(3130),
  [5233] = {.count = 1, .reusable = true}, SHIFT(3131),
  [5235] = {.count = 1, .reusable = true}, SHIFT(3132),
  [5237] = {.count = 1, .reusable = false}, SHIFT(3133),
  [5239] = {.count = 1, .reusable = false}, SHIFT(3134),
  [5241] = {.count = 1, .reusable = false}, SHIFT(3135),
  [5243] = {.count = 1, .reusable = true}, SHIFT(3136),
  [5245] = {.count = 1, .reusable = false}, SHIFT(3137),
  [5247] = {.count = 1, .reusable = true}, SHIFT(3137),
  [5249] = {.count = 1, .reusable = true}, SHIFT(3138),
  [5251] = {.count = 1, .reusable = true}, SHIFT(3139),
  [5253] = {.count = 1, .reusable = true}, SHIFT(3140),
  [5255] = {.count = 1, .reusable = false}, SHIFT(3139),
  [5257] = {.count = 1, .reusable = true}, SHIFT(3135),
  [5259] = {.count = 1, .reusable = true}, SHIFT(3133),
  [5261] = {.count = 1, .reusable = true}, SHIFT(3141),
  [5263] = {.count = 1, .reusable = true}, SHIFT(3142),
  [5265] = {.count = 1, .reusable = true}, SHIFT(3143),
  [5267] = {.count = 1, .reusable = true}, SHIFT(3144),
  [5269] = {.count = 1, .reusable = false}, SHIFT(3146),
  [5271] = {.count = 1, .reusable = false}, SHIFT(3147),
  [5273] = {.count = 1, .reusable = false}, SHIFT(3148),
  [5275] = {.count = 1, .reusable = false}, SHIFT(3149),
  [5277] = {.count = 1, .reusable = true}, SHIFT(3150),
  [5279] = {.count = 1, .reusable = false}, SHIFT(3150),
  [5281] = {.count = 1, .reusable = false}, SHIFT(3151),
  [5283] = {.count = 1, .reusable = true}, SHIFT(3151),
  [5285] = {.count = 1, .reusable = false}, SHIFT(3152),
  [5287] = {.count = 1, .reusable = true}, SHIFT(3154),
  [5289] = {.count = 1, .reusable = false}, SHIFT(3154),
  [5291] = {.count = 1, .reusable = true}, SHIFT(3160),
  [5293] = {.count = 1, .reusable = false}, SHIFT(3160),
  [5295] = {.count = 1, .reusable = true}, SHIFT(3161),
  [5297] = {.count = 1, .reusable = false}, REDUCE(sym_else, 2),
  [5299] = {.count = 1, .reusable = true}, SHIFT(3167),
  [5301] = {.count = 1, .reusable = true}, SHIFT(3168),
  [5303] = {.count = 1, .reusable = true}, SHIFT(3169),
  [5305] = {.count = 1, .reusable = true}, SHIFT(3170),
  [5307] = {.count = 1, .reusable = false}, SHIFT(3172),
  [5309] = {.count = 1, .reusable = false}, SHIFT(3173),
  [5311] = {.count = 1, .reusable = false}, SHIFT(3174),
  [5313] = {.count = 1, .reusable = false}, SHIFT(3175),
  [5315] = {.count = 1, .reusable = true}, SHIFT(3176),
  [5317] = {.count = 1, .reusable = false}, SHIFT(3176),
  [5319] = {.count = 1, .reusable = false}, SHIFT(3177),
  [5321] = {.count = 1, .reusable = true}, SHIFT(3177),
  [5323] = {.count = 1, .reusable = false}, SHIFT(3178),
  [5325] = {.count = 1, .reusable = true}, SHIFT(3180),
  [5327] = {.count = 1, .reusable = false}, SHIFT(3180),
  [5329] = {.count = 1, .reusable = true}, SHIFT(3187),
  [5331] = {.count = 1, .reusable = true}, REDUCE(sym_ensure, 2),
  [5333] = {.count = 1, .reusable = true}, SHIFT(3188),
  [5335] = {.count = 1, .reusable = true}, SHIFT(3189),
  [5337] = {.count = 1, .reusable = true}, SHIFT(3190),
  [5339] = {.count = 1, .reusable = true}, SHIFT(3191),
  [5341] = {.count = 1, .reusable = true}, SHIFT(3192),
  [5343] = {.count = 1, .reusable = true}, SHIFT(3193),
  [5345] = {.count = 1, .reusable = true}, SHIFT(3194),
  [5347] = {.count = 1, .reusable = false}, SHIFT(3195),
  [5349] = {.count = 1, .reusable = false}, SHIFT(3196),
  [5351] = {.count = 1, .reusable = false}, SHIFT(3197),
  [5353] = {.count = 1, .reusable = true}, SHIFT(3198),
  [5355] = {.count = 1, .reusable = false}, SHIFT(3199),
  [5357] = {.count = 1, .reusable = true}, SHIFT(3199),
  [5359] = {.count = 1, .reusable = true}, SHIFT(3200),
  [5361] = {.count = 1, .reusable = true}, SHIFT(3201),
  [5363] = {.count = 1, .reusable = true}, SHIFT(3202),
  [5365] = {.count = 1, .reusable = false}, SHIFT(3201),
  [5367] = {.count = 1, .reusable = true}, SHIFT(3197),
  [5369] = {.count = 1, .reusable = true}, SHIFT(3195),
  [5371] = {.count = 1, .reusable = true}, SHIFT(3203),
  [5373] = {.count = 1, .reusable = true}, SHIFT(3204),
  [5375] = {.count = 1, .reusable = true}, SHIFT(3205),
  [5377] = {.count = 1, .reusable = true}, SHIFT(3206),
  [5379] = {.count = 1, .reusable = false}, SHIFT(3208),
  [5381] = {.count = 1, .reusable = false}, SHIFT(3209),
  [5383] = {.count = 1, .reusable = false}, SHIFT(3210),
  [5385] = {.count = 1, .reusable = false}, SHIFT(3211),
  [5387] = {.count = 1, .reusable = true}, SHIFT(3212),
  [5389] = {.count = 1, .reusable = false}, SHIFT(3212),
  [5391] = {.count = 1, .reusable = false}, SHIFT(3213),
  [5393] = {.count = 1, .reusable = true}, SHIFT(3213),
  [5395] = {.count = 1, .reusable = false}, SHIFT(3214),
  [5397] = {.count = 1, .reusable = true}, SHIFT(3216),
  [5399] = {.count = 1, .reusable = false}, SHIFT(3216),
  [5401] = {.count = 1, .reusable = true}, SHIFT(3222),
  [5403] = {.count = 1, .reusable = false}, SHIFT(3222),
  [5405] = {.count = 1, .reusable = true}, SHIFT(3223),
  [5407] = {.count = 1, .reusable = true}, REDUCE(sym__body_statement, 2),
  [5409] = {.count = 1, .reusable = false}, REDUCE(sym__body_statement, 2),
  [5411] = {.count = 1, .reusable = true}, SHIFT(3228),
  [5413] = {.count = 1, .reusable = true}, SHIFT(3246),
  [5415] = {.count = 1, .reusable = false}, SHIFT(3247),
  [5417] = {.count = 1, .reusable = false}, SHIFT(3248),
  [5419] = {.count = 1, .reusable = false}, SHIFT(3249),
  [5421] = {.count = 1, .reusable = false}, SHIFT(3250),
  [5423] = {.count = 1, .reusable = false}, SHIFT(3246),
  [5425] = {.count = 1, .reusable = true}, SHIFT(3251),
  [5427] = {.count = 1, .reusable = false}, SHIFT(3251),
  [5429] = {.count = 1, .reusable = true}, SHIFT(3252),
  [5431] = {.count = 1, .reusable = false}, SHIFT(3254),
  [5433] = {.count = 1, .reusable = true}, SHIFT(3254),
  [5435] = {.count = 1, .reusable = false}, SHIFT(1234),
  [5437] = {.count = 1, .reusable = true}, SHIFT(3261),
  [5439] = {.count = 1, .reusable = false}, SHIFT(3264),
  [5441] = {.count = 1, .reusable = true}, SHIFT(3265),
  [5443] = {.count = 1, .reusable = true}, SHIFT(3266),
  [5445] = {.count = 1, .reusable = false}, SHIFT(3267),
  [5447] = {.count = 1, .reusable = false}, SHIFT(3266),
  [5449] = {.count = 1, .reusable = false}, SHIFT(3268),
  [5451] = {.count = 1, .reusable = false}, SHIFT(3269),
  [5453] = {.count = 1, .reusable = true}, SHIFT(3270),
  [5455] = {.count = 1, .reusable = false}, SHIFT(3271),
  [5457] = {.count = 1, .reusable = true}, SHIFT(3271),
  [5459] = {.count = 1, .reusable = false}, SHIFT(3273),
  [5461] = {.count = 1, .reusable = false}, SHIFT(3274),
  [5463] = {.count = 1, .reusable = true}, SHIFT(3273),
  [5465] = {.count = 1, .reusable = true}, SHIFT(3269),
  [5467] = {.count = 1, .reusable = false}, SHIFT(3265),
  [5469] = {.count = 1, .reusable = true}, SHIFT(3276),
  [5471] = {.count = 1, .reusable = true}, SHIFT(3278),
  [5473] = {.count = 1, .reusable = false}, SHIFT(3278),
  [5475] = {.count = 1, .reusable = true}, SHIFT(3279),
  [5477] = {.count = 1, .reusable = false}, SHIFT(3261),
  [5479] = {.count = 1, .reusable = true}, SHIFT(3281),
  [5481] = {.count = 1, .reusable = true}, SHIFT(3282),
  [5483] = {.count = 1, .reusable = false}, SHIFT(3282),
  [5485] = {.count = 1, .reusable = true}, SHIFT(3283),
  [5487] = {.count = 1, .reusable = false}, SHIFT(3283),
  [5489] = {.count = 1, .reusable = true}, SHIFT(3284),
  [5491] = {.count = 1, .reusable = true}, REDUCE(sym_begin, 3),
  [5493] = {.count = 1, .reusable = false}, REDUCE(sym_begin, 3),
  [5495] = {.count = 1, .reusable = true}, SHIFT(3291),
  [5497] = {.count = 1, .reusable = true}, REDUCE(sym_undef, 3),
  [5499] = {.count = 1, .reusable = true}, SHIFT(3293),
  [5501] = {.count = 1, .reusable = true}, REDUCE(sym_alias, 3),
  [5503] = {.count = 1, .reusable = true}, SHIFT(3294),
  [5505] = {.count = 1, .reusable = true}, SHIFT(3295),
  [5507] = {.count = 1, .reusable = true}, SHIFT(3296),
  [5509] = {.count = 1, .reusable = true}, SHIFT(3297),
  [5511] = {.count = 1, .reusable = true}, SHIFT(3298),
  [5513] = {.count = 1, .reusable = false}, SHIFT(3299),
  [5515] = {.count = 1, .reusable = true}, SHIFT(3301),
  [5517] = {.count = 1, .reusable = true}, SHIFT(3302),
  [5519] = {.count = 1, .reusable = true}, SHIFT(3304),
  [5521] = {.count = 1, .reusable = false}, SHIFT(3305),
  [5523] = {.count = 1, .reusable = true}, SHIFT(3307),
  [5525] = {.count = 1, .reusable = true}, SHIFT(3308),
  [5527] = {.count = 1, .reusable = true}, SHIFT(3311),
  [5529] = {.count = 1, .reusable = true}, SHIFT(3312),
  [5531] = {.count = 1, .reusable = true}, SHIFT(3313),
  [5533] = {.count = 1, .reusable = false}, SHIFT(3315),
  [5535] = {.count = 1, .reusable = true}, SHIFT(3321),
  [5537] = {.count = 1, .reusable = true}, SHIFT(3322),
  [5539] = {.count = 1, .reusable = false}, SHIFT(3323),
  [5541] = {.count = 1, .reusable = false}, SHIFT(3324),
  [5543] = {.count = 1, .reusable = false}, SHIFT(3325),
  [5545] = {.count = 1, .reusable = true}, SHIFT(3326),
  [5547] = {.count = 1, .reusable = false}, SHIFT(3327),
  [5549] = {.count = 1, .reusable = true}, SHIFT(3327),
  [5551] = {.count = 1, .reusable = true}, SHIFT(3328),
  [5553] = {.count = 1, .reusable = true}, SHIFT(3329),
  [5555] = {.count = 1, .reusable = true}, SHIFT(3330),
  [5557] = {.count = 1, .reusable = false}, SHIFT(3329),
  [5559] = {.count = 1, .reusable = true}, SHIFT(3325),
  [5561] = {.count = 1, .reusable = true}, SHIFT(3323),
  [5563] = {.count = 1, .reusable = true}, SHIFT(3331),
  [5565] = {.count = 1, .reusable = true}, SHIFT(3332),
  [5567] = {.count = 1, .reusable = true}, SHIFT(3333),
  [5569] = {.count = 1, .reusable = false}, SHIFT(3335),
  [5571] = {.count = 1, .reusable = true}, SHIFT(3340),
  [5573] = {.count = 1, .reusable = false}, SHIFT(3340),
  [5575] = {.count = 1, .reusable = true}, SHIFT(3341),
  [5577] = {.count = 1, .reusable = true}, SHIFT(3344),
  [5579] = {.count = 1, .reusable = true}, SHIFT(3347),
  [5581] = {.count = 1, .reusable = true}, SHIFT(3348),
  [5583] = {.count = 1, .reusable = true}, SHIFT(3349),
  [5585] = {.count = 1, .reusable = true}, SHIFT(3352),
  [5587] = {.count = 1, .reusable = true}, SHIFT(3354),
  [5589] = {.count = 1, .reusable = false}, SHIFT(3353),
  [5591] = {.count = 1, .reusable = false}, SHIFT(1311),
  [5593] = {.count = 1, .reusable = true}, SHIFT(3358),
  [5595] = {.count = 1, .reusable = false}, SHIFT(3361),
  [5597] = {.count = 1, .reusable = true}, SHIFT(3362),
  [5599] = {.count = 1, .reusable = true}, SHIFT(3363),
  [5601] = {.count = 1, .reusable = false}, SHIFT(3364),
  [5603] = {.count = 1, .reusable = false}, SHIFT(3365),
  [5605] = {.count = 1, .reusable = false}, SHIFT(3366),
  [5607] = {.count = 1, .reusable = true}, SHIFT(3367),
  [5609] = {.count = 1, .reusable = false}, SHIFT(3368),
  [5611] = {.count = 1, .reusable = true}, SHIFT(3368),
  [5613] = {.count = 1, .reusable = true}, SHIFT(3370),
  [5615] = {.count = 1, .reusable = true}, SHIFT(3371),
  [5617] = {.count = 1, .reusable = false}, SHIFT(3370),
  [5619] = {.count = 1, .reusable = true}, SHIFT(3366),
  [5621] = {.count = 1, .reusable = true}, SHIFT(3364),
  [5623] = {.count = 1, .reusable = true}, SHIFT(3373),
  [5625] = {.count = 1, .reusable = true}, SHIFT(3375),
  [5627] = {.count = 1, .reusable = false}, SHIFT(3375),
  [5629] = {.count = 1, .reusable = true}, SHIFT(3376),
  [5631] = {.count = 1, .reusable = false}, SHIFT(3358),
  [5633] = {.count = 1, .reusable = true}, SHIFT(3378),
  [5635] = {.count = 1, .reusable = true}, SHIFT(3380),
  [5637] = {.count = 1, .reusable = true}, SHIFT(3381),
  [5639] = {.count = 1, .reusable = true}, SHIFT(3382),
  [5641] = {.count = 1, .reusable = true}, SHIFT(3384),
  [5643] = {.count = 1, .reusable = true}, SHIFT(3387),
  [5645] = {.count = 1, .reusable = true}, SHIFT(3385),
  [5647] = {.count = 1, .reusable = true}, SHIFT(3389),
  [5649] = {.count = 1, .reusable = false}, SHIFT(3393),
  [5651] = {.count = 1, .reusable = true}, SHIFT(3395),
  [5653] = {.count = 1, .reusable = true}, SHIFT(3396),
  [5655] = {.count = 1, .reusable = true}, SHIFT(3402),
  [5657] = {.count = 1, .reusable = false}, SHIFT(3399),
  [5659] = {.count = 1, .reusable = true}, SHIFT(1347),
  [5661] = {.count = 1, .reusable = true}, SHIFT(3414),
  [5663] = {.count = 1, .reusable = false}, SHIFT(3414),
  [5665] = {.count = 1, .reusable = true}, SHIFT(3415),
  [5667] = {.count = 1, .reusable = true}, SHIFT(3416),
  [5669] = {.count = 1, .reusable = true}, SHIFT(3419),
  [5671] = {.count = 1, .reusable = true}, SHIFT(3421),
  [5673] = {.count = 1, .reusable = false}, SHIFT(1365),
  [5675] = {.count = 1, .reusable = true}, SHIFT(3426),
  [5677] = {.count = 1, .reusable = true}, SHIFT(3427),
  [5679] = {.count = 1, .reusable = true}, SHIFT(3434),
  [5681] = {.count = 1, .reusable = false}, SHIFT(3431),
  [5683] = {.count = 1, .reusable = false}, SHIFT(3436),
  [5685] = {.count = 1, .reusable = true}, SHIFT(3437),
  [5687] = {.count = 1, .reusable = true}, SHIFT(3438),
  [5689] = {.count = 1, .reusable = false}, SHIFT(3439),
  [5691] = {.count = 1, .reusable = false}, SHIFT(3438),
  [5693] = {.count = 1, .reusable = false}, SHIFT(3440),
  [5695] = {.count = 1, .reusable = false}, SHIFT(3441),
  [5697] = {.count = 1, .reusable = true}, SHIFT(3442),
  [5699] = {.count = 1, .reusable = false}, SHIFT(3443),
  [5701] = {.count = 1, .reusable = true}, SHIFT(3443),
  [5703] = {.count = 1, .reusable = false}, SHIFT(3445),
  [5705] = {.count = 1, .reusable = false}, SHIFT(3446),
  [5707] = {.count = 1, .reusable = true}, SHIFT(3445),
  [5709] = {.count = 1, .reusable = true}, SHIFT(3441),
  [5711] = {.count = 1, .reusable = false}, SHIFT(3437),
  [5713] = {.count = 1, .reusable = true}, SHIFT(1373),
  [5715] = {.count = 1, .reusable = true}, SHIFT(3449),
  [5717] = {.count = 1, .reusable = true}, SHIFT(3451),
  [5719] = {.count = 1, .reusable = false}, SHIFT(3451),
  [5721] = {.count = 1, .reusable = true}, SHIFT(3452),
  [5723] = {.count = 1, .reusable = false}, SHIFT(3426),
  [5725] = {.count = 1, .reusable = true}, REDUCE(sym_array, 3),
  [5727] = {.count = 1, .reusable = false}, REDUCE(sym_array, 3),
  [5729] = {.count = 1, .reusable = true}, REDUCE(sym__argument_list_with_trailing_comma, 2),
  [5731] = {.count = 1, .reusable = true}, SHIFT(3456),
  [5733] = {.count = 1, .reusable = true}, SHIFT(3459),
  [5735] = {.count = 1, .reusable = true}, REDUCE(sym_block, 2),
  [5737] = {.count = 1, .reusable = false}, REDUCE(sym_block, 2),
  [5739] = {.count = 1, .reusable = true}, SHIFT(3465),
  [5741] = {.count = 1, .reusable = true}, SHIFT(3466),
  [5743] = {.count = 1, .reusable = true}, SHIFT(3467),
  [5745] = {.count = 1, .reusable = true}, SHIFT(3468),
  [5747] = {.count = 1, .reusable = true}, SHIFT(3470),
  [5749] = {.count = 1, .reusable = true}, REDUCE(sym_lambda_parameters, 2),
  [5751] = {.count = 1, .reusable = true}, SHIFT(3473),
  [5753] = {.count = 1, .reusable = true}, SHIFT(3474),
  [5755] = {.count = 1, .reusable = true}, SHIFT(3475),
  [5757] = {.count = 1, .reusable = true}, SHIFT(3476),
  [5759] = {.count = 1, .reusable = true}, REDUCE(sym_splat_parameter, 2),
  [5761] = {.count = 1, .reusable = true}, REDUCE(sym_hash_splat_parameter, 2),
  [5763] = {.count = 1, .reusable = true}, REDUCE(sym_block_parameter, 2),
  [5765] = {.count = 1, .reusable = true}, SHIFT(3478),
  [5767] = {.count = 1, .reusable = true}, SHIFT(3479),
  [5769] = {.count = 1, .reusable = true}, SHIFT(3480),
  [5771] = {.count = 1, .reusable = true}, REDUCE(sym_do_block, 2),
  [5773] = {.count = 1, .reusable = false}, REDUCE(sym_do_block, 2),
  [5775] = {.count = 1, .reusable = true}, SHIFT(3482),
  [5777] = {.count = 1, .reusable = true}, SHIFT(3484),
  [5779] = {.count = 1, .reusable = false}, SHIFT(3482),
  [5781] = {.count = 1, .reusable = true}, SHIFT(3486),
  [5783] = {.count = 1, .reusable = true}, REDUCE(sym_keyword_parameter, 2),
  [5785] = {.count = 1, .reusable = false}, SHIFT(3487),
  [5787] = {.count = 1, .reusable = false}, SHIFT(3488),
  [5789] = {.count = 1, .reusable = false}, SHIFT(3489),
  [5791] = {.count = 1, .reusable = false}, SHIFT(3490),
  [5793] = {.count = 1, .reusable = false}, REDUCE(sym_keyword_parameter, 2),
  [5795] = {.count = 1, .reusable = false}, SHIFT(3486),
  [5797] = {.count = 1, .reusable = true}, SHIFT(3491),
  [5799] = {.count = 1, .reusable = false}, SHIFT(3491),
  [5801] = {.count = 1, .reusable = true}, SHIFT(3492),
  [5803] = {.count = 1, .reusable = false}, SHIFT(3494),
  [5805] = {.count = 1, .reusable = true}, SHIFT(3494),
  [5807] = {.count = 1, .reusable = true}, REDUCE(sym_lambda, 3),
  [5809] = {.count = 1, .reusable = false}, REDUCE(sym_lambda, 3),
  [5811] = {.count = 1, .reusable = true}, SHIFT(360),
  [5813] = {.count = 1, .reusable = false}, SHIFT(3501),
  [5815] = {.count = 1, .reusable = true}, REDUCE(sym_if_modifier, 3),
  [5817] = {.count = 1, .reusable = true}, REDUCE(sym_unless_modifier, 3),
  [5819] = {.count = 1, .reusable = true}, REDUCE(sym_while_modifier, 3),
  [5821] = {.count = 1, .reusable = true}, REDUCE(sym_until_modifier, 3),
  [5823] = {.count = 1, .reusable = true}, REDUCE(sym_rescue_modifier, 3),
  [5825] = {.count = 1, .reusable = true}, REDUCE(sym_binary, 3),
  [5827] = {.count = 1, .reusable = false}, REDUCE(sym_binary, 3),
  [5829] = {.count = 1, .reusable = true}, SHIFT(3502),
  [5831] = {.count = 1, .reusable = true}, SHIFT(3505),
  [5833] = {.count = 1, .reusable = true}, SHIFT(3506),
  [5835] = {.count = 1, .reusable = true}, SHIFT(3507),
  [5837] = {.count = 1, .reusable = true}, SHIFT(3508),
  [5839] = {.count = 1, .reusable = false}, SHIFT(3510),
  [5841] = {.count = 1, .reusable = false}, SHIFT(3511),
  [5843] = {.count = 1, .reusable = false}, SHIFT(3512),
  [5845] = {.count = 1, .reusable = false}, SHIFT(3513),
  [5847] = {.count = 1, .reusable = true}, SHIFT(3514),
  [5849] = {.count = 1, .reusable = false}, SHIFT(3514),
  [5851] = {.count = 1, .reusable = false}, SHIFT(3515),
  [5853] = {.count = 1, .reusable = true}, SHIFT(3515),
  [5855] = {.count = 1, .reusable = false}, SHIFT(3516),
  [5857] = {.count = 1, .reusable = true}, SHIFT(3518),
  [5859] = {.count = 1, .reusable = false}, SHIFT(3518),
  [5861] = {.count = 1, .reusable = true}, SHIFT(3525),
  [5863] = {.count = 1, .reusable = true}, SHIFT(3526),
  [5865] = {.count = 1, .reusable = false}, SHIFT(3527),
  [5867] = {.count = 1, .reusable = false}, SHIFT(3528),
  [5869] = {.count = 1, .reusable = false}, SHIFT(3529),
  [5871] = {.count = 1, .reusable = true}, SHIFT(3530),
  [5873] = {.count = 1, .reusable = true}, SHIFT(3531),
  [5875] = {.count = 1, .reusable = false}, SHIFT(3532),
  [5877] = {.count = 1, .reusable = true}, SHIFT(3532),
  [5879] = {.count = 1, .reusable = true}, SHIFT(3533),
  [5881] = {.count = 1, .reusable = true}, SHIFT(3534),
  [5883] = {.count = 1, .reusable = true}, SHIFT(3535),
  [5885] = {.count = 1, .reusable = false}, SHIFT(3534),
  [5887] = {.count = 1, .reusable = true}, SHIFT(3529),
  [5889] = {.count = 1, .reusable = true}, SHIFT(3527),
  [5891] = {.count = 1, .reusable = true}, SHIFT(3536),
  [5893] = {.count = 1, .reusable = true}, SHIFT(3537),
  [5895] = {.count = 1, .reusable = true}, SHIFT(3538),
  [5897] = {.count = 1, .reusable = true}, SHIFT(3539),
  [5899] = {.count = 1, .reusable = false}, SHIFT(3541),
  [5901] = {.count = 1, .reusable = false}, SHIFT(3542),
  [5903] = {.count = 1, .reusable = false}, SHIFT(3543),
  [5905] = {.count = 1, .reusable = false}, SHIFT(3544),
  [5907] = {.count = 1, .reusable = true}, SHIFT(3545),
  [5909] = {.count = 1, .reusable = false}, SHIFT(3545),
  [5911] = {.count = 1, .reusable = false}, SHIFT(3546),
  [5913] = {.count = 1, .reusable = true}, SHIFT(3546),
  [5915] = {.count = 1, .reusable = false}, SHIFT(3547),
  [5917] = {.count = 1, .reusable = true}, SHIFT(3549),
  [5919] = {.count = 1, .reusable = false}, SHIFT(3549),
  [5921] = {.count = 1, .reusable = true}, SHIFT(3555),
  [5923] = {.count = 1, .reusable = false}, SHIFT(3555),
  [5925] = {.count = 1, .reusable = true}, SHIFT(3556),
  [5927] = {.count = 1, .reusable = true}, REDUCE(sym_range, 3),
  [5929] = {.count = 1, .reusable = true}, SHIFT(3559),
  [5931] = {.count = 1, .reusable = true}, SHIFT(3558),
  [5933] = {.count = 1, .reusable = true}, SHIFT(3560),
  [5935] = {.count = 1, .reusable = true}, REDUCE(sym_call, 3),
  [5937] = {.count = 1, .reusable = false}, REDUCE(sym_call, 3),
  [5939] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list_with_parens, 1),
  [5941] = {.count = 1, .reusable = false}, REDUCE(sym_argument_list_with_parens, 1),
  [5943] = {.count = 1, .reusable = true}, SHIFT(3562),
  [5945] = {.count = 1, .reusable = true}, REDUCE(sym_element_reference, 3),
  [5947] = {.count = 1, .reusable = false}, REDUCE(sym_element_reference, 3),
  [5949] = {.count = 1, .reusable = true}, SHIFT(3564),
  [5951] = {.count = 1, .reusable = true}, REDUCE(sym_scope_resolution, 3),
  [5953] = {.count = 1, .reusable = false}, REDUCE(sym_scope_resolution, 3),
  [5955] = {.count = 1, .reusable = true}, SHIFT(3565),
  [5957] = {.count = 1, .reusable = true}, SHIFT(3566),
  [5959] = {.count = 1, .reusable = true}, SHIFT(3567),
  [5961] = {.count = 1, .reusable = true}, SHIFT(3568),
  [5963] = {.count = 1, .reusable = true}, SHIFT(3569),
  [5965] = {.count = 1, .reusable = false}, SHIFT(3570),
  [5967] = {.count = 1, .reusable = true}, SHIFT(3572),
  [5969] = {.count = 1, .reusable = true}, SHIFT(3573),
  [5971] = {.count = 1, .reusable = true}, SHIFT(3575),
  [5973] = {.count = 1, .reusable = false}, SHIFT(3576),
  [5975] = {.count = 1, .reusable = true}, SHIFT(3578),
  [5977] = {.count = 1, .reusable = true}, SHIFT(3579),
  [5979] = {.count = 1, .reusable = true}, SHIFT(3581),
  [5981] = {.count = 1, .reusable = true}, SHIFT(3583),
  [5983] = {.count = 1, .reusable = true}, SHIFT(3585),
  [5985] = {.count = 1, .reusable = true}, SHIFT(3587),
  [5987] = {.count = 1, .reusable = true}, SHIFT(3589),
  [5989] = {.count = 1, .reusable = false}, SHIFT(3590),
  [5991] = {.count = 1, .reusable = true}, SHIFT(3592),
  [5993] = {.count = 1, .reusable = false}, SHIFT(3593),
  [5995] = {.count = 1, .reusable = true}, SHIFT(3596),
  [5997] = {.count = 1, .reusable = true}, SHIFT(3599),
  [5999] = {.count = 1, .reusable = false}, SHIFT(3601),
  [6001] = {.count = 1, .reusable = true}, SHIFT(3603),
  [6003] = {.count = 1, .reusable = true}, SHIFT(3605),
  [6005] = {.count = 1, .reusable = false}, SHIFT(3606),
  [6007] = {.count = 1, .reusable = false}, SHIFT(3608),
  [6009] = {.count = 1, .reusable = true}, SHIFT(3620),
  [6011] = {.count = 1, .reusable = true}, SHIFT(3626),
  [6013] = {.count = 1, .reusable = false}, SHIFT(3625),
  [6015] = {.count = 1, .reusable = false}, SHIFT(3629),
  [6017] = {.count = 1, .reusable = true}, SHIFT(3630),
  [6019] = {.count = 1, .reusable = true}, SHIFT(3634),
  [6021] = {.count = 1, .reusable = true}, SHIFT(3635),
  [6023] = {.count = 1, .reusable = false}, SHIFT(3636),
  [6025] = {.count = 1, .reusable = false}, SHIFT(3635),
  [6027] = {.count = 1, .reusable = false}, SHIFT(3637),
  [6029] = {.count = 1, .reusable = false}, SHIFT(3638),
  [6031] = {.count = 1, .reusable = true}, SHIFT(3639),
  [6033] = {.count = 1, .reusable = false}, SHIFT(3640),
  [6035] = {.count = 1, .reusable = true}, SHIFT(3640),
  [6037] = {.count = 1, .reusable = false}, SHIFT(3642),
  [6039] = {.count = 1, .reusable = false}, SHIFT(3643),
  [6041] = {.count = 1, .reusable = true}, SHIFT(3642),
  [6043] = {.count = 1, .reusable = true}, SHIFT(3638),
  [6045] = {.count = 1, .reusable = false}, SHIFT(3634),
  [6047] = {.count = 1, .reusable = true}, SHIFT(3644),
  [6049] = {.count = 1, .reusable = true}, SHIFT(3645),
  [6051] = {.count = 1, .reusable = false}, SHIFT(3645),
  [6053] = {.count = 1, .reusable = true}, SHIFT(3646),
  [6055] = {.count = 1, .reusable = true}, SHIFT(3648),
  [6057] = {.count = 1, .reusable = true}, SHIFT(3652),
  [6059] = {.count = 1, .reusable = true}, SHIFT(3653),
  [6061] = {.count = 1, .reusable = true}, SHIFT(3654),
  [6063] = {.count = 1, .reusable = false}, SHIFT(3656),
  [6065] = {.count = 1, .reusable = true}, SHIFT(3662),
  [6067] = {.count = 1, .reusable = true}, SHIFT(3664),
  [6069] = {.count = 1, .reusable = true}, SHIFT(3665),
  [6071] = {.count = 1, .reusable = false}, SHIFT(3666),
  [6073] = {.count = 1, .reusable = false}, SHIFT(3667),
  [6075] = {.count = 1, .reusable = false}, SHIFT(3668),
  [6077] = {.count = 1, .reusable = true}, SHIFT(3669),
  [6079] = {.count = 1, .reusable = false}, SHIFT(3670),
  [6081] = {.count = 1, .reusable = true}, SHIFT(3670),
  [6083] = {.count = 1, .reusable = true}, SHIFT(3671),
  [6085] = {.count = 1, .reusable = true}, SHIFT(3672),
  [6087] = {.count = 1, .reusable = true}, SHIFT(3673),
  [6089] = {.count = 1, .reusable = false}, SHIFT(3672),
  [6091] = {.count = 1, .reusable = true}, SHIFT(3668),
  [6093] = {.count = 1, .reusable = true}, SHIFT(3666),
  [6095] = {.count = 1, .reusable = true}, SHIFT(3674),
  [6097] = {.count = 1, .reusable = true}, SHIFT(3675),
  [6099] = {.count = 1, .reusable = true}, SHIFT(3676),
  [6101] = {.count = 1, .reusable = false}, SHIFT(3678),
  [6103] = {.count = 1, .reusable = true}, SHIFT(3683),
  [6105] = {.count = 1, .reusable = false}, SHIFT(3683),
  [6107] = {.count = 1, .reusable = true}, SHIFT(3684),
  [6109] = {.count = 1, .reusable = true}, SHIFT(3686),
  [6111] = {.count = 1, .reusable = true}, SHIFT(3689),
  [6113] = {.count = 1, .reusable = true}, SHIFT(3690),
  [6115] = {.count = 1, .reusable = true}, SHIFT(3691),
  [6117] = {.count = 1, .reusable = true}, SHIFT(3694),
  [6119] = {.count = 1, .reusable = true}, SHIFT(3696),
  [6121] = {.count = 1, .reusable = false}, SHIFT(3695),
  [6123] = {.count = 1, .reusable = true}, SHIFT(3698),
  [6125] = {.count = 1, .reusable = true}, SHIFT(3700),
  [6127] = {.count = 1, .reusable = true}, SHIFT(3701),
  [6129] = {.count = 1, .reusable = true}, SHIFT(3702),
  [6131] = {.count = 1, .reusable = true}, SHIFT(3704),
  [6133] = {.count = 1, .reusable = true}, SHIFT(3706),
  [6135] = {.count = 1, .reusable = false}, SHIFT(3704),
  [6137] = {.count = 1, .reusable = true}, SHIFT(3708),
  [6139] = {.count = 1, .reusable = true}, SHIFT(3711),
  [6141] = {.count = 1, .reusable = true}, SHIFT(3709),
  [6143] = {.count = 1, .reusable = true}, SHIFT(3713),
  [6145] = {.count = 1, .reusable = false}, SHIFT(3717),
  [6147] = {.count = 1, .reusable = true}, SHIFT(3718),
  [6149] = {.count = 1, .reusable = true}, SHIFT(3720),
  [6151] = {.count = 1, .reusable = true}, SHIFT(3721),
  [6153] = {.count = 1, .reusable = true}, SHIFT(3733),
  [6155] = {.count = 1, .reusable = true}, REDUCE(sym_method_call, 3),
  [6157] = {.count = 1, .reusable = false}, REDUCE(sym_method_call, 3),
  [6159] = {.count = 1, .reusable = true}, SHIFT(3735),
  [6161] = {.count = 1, .reusable = true}, SHIFT(3734),
  [6163] = {.count = 1, .reusable = true}, SHIFT(398),
  [6165] = {.count = 1, .reusable = true}, SHIFT(3749),
  [6167] = {.count = 1, .reusable = true}, SHIFT(3750),
  [6169] = {.count = 1, .reusable = false}, SHIFT(3751),
  [6171] = {.count = 1, .reusable = false}, SHIFT(3752),
  [6173] = {.count = 1, .reusable = false}, SHIFT(3753),
  [6175] = {.count = 1, .reusable = true}, SHIFT(3754),
  [6177] = {.count = 1, .reusable = false}, SHIFT(3755),
  [6179] = {.count = 1, .reusable = true}, SHIFT(3755),
  [6181] = {.count = 1, .reusable = true}, SHIFT(3757),
  [6183] = {.count = 1, .reusable = true}, SHIFT(3758),
  [6185] = {.count = 1, .reusable = false}, SHIFT(3757),
  [6187] = {.count = 1, .reusable = true}, SHIFT(3753),
  [6189] = {.count = 1, .reusable = true}, SHIFT(3751),
  [6191] = {.count = 1, .reusable = true}, REDUCE(sym_assignment, 3),
  [6193] = {.count = 1, .reusable = false}, REDUCE(sym_assignment, 3),
  [6195] = {.count = 1, .reusable = true}, SHIFT(3759),
  [6197] = {.count = 1, .reusable = true}, SHIFT(3761),
  [6199] = {.count = 1, .reusable = false}, SHIFT(3761),
  [6201] = {.count = 1, .reusable = true}, SHIFT(3762),
  [6203] = {.count = 1, .reusable = true}, REDUCE(aux_sym__mlhs_repeat1, 2),
  [6205] = {.count = 1, .reusable = true}, REDUCE(sym__mlhs, 3),
  [6207] = {.count = 2, .reusable = true}, REDUCE(aux_sym__mlhs_repeat1, 2), SHIFT_REPEAT(3763),
  [6210] = {.count = 1, .reusable = true}, REDUCE(sym_operator_assignment, 3),
  [6212] = {.count = 1, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2),
  [6214] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(3),
  [6217] = {.count = 1, .reusable = false}, REDUCE(aux_sym_chained_string_repeat1, 2),
  [6219] = {.count = 1, .reusable = true}, SHIFT(1603),
  [6221] = {.count = 1, .reusable = false}, SHIFT(1604),
  [6223] = {.count = 1, .reusable = false}, SHIFT(1605),
  [6225] = {.count = 1, .reusable = false}, SHIFT(1606),
  [6227] = {.count = 1, .reusable = false}, SHIFT(1607),
  [6229] = {.count = 1, .reusable = false}, SHIFT(1603),
  [6231] = {.count = 1, .reusable = true}, SHIFT(1608),
  [6233] = {.count = 1, .reusable = false}, SHIFT(1608),
  [6235] = {.count = 1, .reusable = true}, SHIFT(1609),
  [6237] = {.count = 1, .reusable = false}, SHIFT(1613),
  [6239] = {.count = 1, .reusable = true}, SHIFT(1613),
  [6241] = {.count = 1, .reusable = true}, SHIFT(3765),
  [6243] = {.count = 1, .reusable = true}, SHIFT(3766),
  [6245] = {.count = 1, .reusable = true}, SHIFT(3767),
  [6247] = {.count = 1, .reusable = true}, SHIFT(3768),
  [6249] = {.count = 1, .reusable = false}, SHIFT(3770),
  [6251] = {.count = 1, .reusable = false}, SHIFT(3771),
  [6253] = {.count = 1, .reusable = false}, SHIFT(3772),
  [6255] = {.count = 1, .reusable = false}, SHIFT(3773),
  [6257] = {.count = 1, .reusable = true}, SHIFT(3774),
  [6259] = {.count = 1, .reusable = false}, SHIFT(3774),
  [6261] = {.count = 1, .reusable = false}, SHIFT(3775),
  [6263] = {.count = 1, .reusable = true}, SHIFT(3775),
  [6265] = {.count = 1, .reusable = false}, SHIFT(3776),
  [6267] = {.count = 1, .reusable = true}, SHIFT(3778),
  [6269] = {.count = 1, .reusable = false}, SHIFT(3778),
  [6271] = {.count = 1, .reusable = true}, SHIFT(3785),
  [6273] = {.count = 1, .reusable = true}, SHIFT(3786),
  [6275] = {.count = 1, .reusable = true}, SHIFT(3787),
  [6277] = {.count = 1, .reusable = true}, SHIFT(3788),
  [6279] = {.count = 1, .reusable = true}, SHIFT(3789),
  [6281] = {.count = 1, .reusable = true}, SHIFT(3790),
  [6283] = {.count = 1, .reusable = true}, SHIFT(3791),
  [6285] = {.count = 1, .reusable = true}, SHIFT(3792),
  [6287] = {.count = 1, .reusable = false}, SHIFT(3793),
  [6289] = {.count = 1, .reusable = false}, SHIFT(3794),
  [6291] = {.count = 1, .reusable = false}, SHIFT(3795),
  [6293] = {.count = 1, .reusable = true}, SHIFT(3796),
  [6295] = {.count = 1, .reusable = false}, SHIFT(3797),
  [6297] = {.count = 1, .reusable = true}, SHIFT(3797),
  [6299] = {.count = 1, .reusable = true}, SHIFT(3798),
  [6301] = {.count = 1, .reusable = true}, SHIFT(3799),
  [6303] = {.count = 1, .reusable = true}, SHIFT(3800),
  [6305] = {.count = 1, .reusable = false}, SHIFT(3799),
  [6307] = {.count = 1, .reusable = true}, SHIFT(3795),
  [6309] = {.count = 1, .reusable = true}, SHIFT(3793),
  [6311] = {.count = 1, .reusable = true}, SHIFT(3801),
  [6313] = {.count = 1, .reusable = true}, SHIFT(3802),
  [6315] = {.count = 1, .reusable = true}, SHIFT(3803),
  [6317] = {.count = 1, .reusable = true}, SHIFT(3804),
  [6319] = {.count = 1, .reusable = false}, SHIFT(3806),
  [6321] = {.count = 1, .reusable = false}, SHIFT(3807),
  [6323] = {.count = 1, .reusable = false}, SHIFT(3808),
  [6325] = {.count = 1, .reusable = false}, SHIFT(3809),
  [6327] = {.count = 1, .reusable = true}, SHIFT(3810),
  [6329] = {.count = 1, .reusable = false}, SHIFT(3810),
  [6331] = {.count = 1, .reusable = false}, SHIFT(3811),
  [6333] = {.count = 1, .reusable = true}, SHIFT(3811),
  [6335] = {.count = 1, .reusable = false}, SHIFT(3812),
  [6337] = {.count = 1, .reusable = true}, SHIFT(3814),
  [6339] = {.count = 1, .reusable = false}, SHIFT(3814),
  [6341] = {.count = 1, .reusable = true}, SHIFT(3820),
  [6343] = {.count = 1, .reusable = false}, SHIFT(3820),
  [6345] = {.count = 1, .reusable = true}, SHIFT(3821),
  [6347] = {.count = 1, .reusable = true}, SHIFT(3823),
  [6349] = {.count = 1, .reusable = true}, SHIFT(3825),
  [6351] = {.count = 1, .reusable = true}, SHIFT(3827),
  [6353] = {.count = 1, .reusable = false}, SHIFT(3828),
  [6355] = {.count = 1, .reusable = false}, SHIFT(3829),
  [6357] = {.count = 1, .reusable = false}, SHIFT(3830),
  [6359] = {.count = 1, .reusable = false}, SHIFT(3831),
  [6361] = {.count = 1, .reusable = false}, SHIFT(3827),
  [6363] = {.count = 1, .reusable = true}, SHIFT(3832),
  [6365] = {.count = 1, .reusable = false}, SHIFT(3832),
  [6367] = {.count = 1, .reusable = true}, SHIFT(3833),
  [6369] = {.count = 1, .reusable = false}, SHIFT(3835),
  [6371] = {.count = 1, .reusable = true}, SHIFT(3835),
  [6373] = {.count = 1, .reusable = false}, SHIFT(1623),
  [6375] = {.count = 1, .reusable = true}, SHIFT(3842),
  [6377] = {.count = 1, .reusable = true}, SHIFT(3844),
  [6379] = {.count = 1, .reusable = true}, SHIFT(3845),
  [6381] = {.count = 1, .reusable = true}, SHIFT(3846),
  [6383] = {.count = 1, .reusable = false}, SHIFT(3848),
  [6385] = {.count = 1, .reusable = false}, SHIFT(3854),
  [6387] = {.count = 1, .reusable = true}, SHIFT(3855),
  [6389] = {.count = 1, .reusable = true}, SHIFT(3856),
  [6391] = {.count = 1, .reusable = false}, SHIFT(3857),
  [6393] = {.count = 1, .reusable = false}, SHIFT(3858),
  [6395] = {.count = 1, .reusable = false}, SHIFT(3859),
  [6397] = {.count = 1, .reusable = true}, SHIFT(3860),
  [6399] = {.count = 1, .reusable = false}, SHIFT(3861),
  [6401] = {.count = 1, .reusable = true}, SHIFT(3861),
  [6403] = {.count = 1, .reusable = true}, SHIFT(3863),
  [6405] = {.count = 1, .reusable = true}, SHIFT(3864),
  [6407] = {.count = 1, .reusable = false}, SHIFT(3863),
  [6409] = {.count = 1, .reusable = true}, SHIFT(3859),
  [6411] = {.count = 1, .reusable = true}, SHIFT(3857),
  [6413] = {.count = 1, .reusable = true}, SHIFT(3865),
  [6415] = {.count = 1, .reusable = true}, SHIFT(3866),
  [6417] = {.count = 1, .reusable = true}, SHIFT(3867),
  [6419] = {.count = 1, .reusable = false}, SHIFT(3869),
  [6421] = {.count = 1, .reusable = true}, SHIFT(3875),
  [6423] = {.count = 1, .reusable = true}, SHIFT(3877),
  [6425] = {.count = 1, .reusable = false}, SHIFT(3877),
  [6427] = {.count = 1, .reusable = true}, SHIFT(3878),
  [6429] = {.count = 1, .reusable = false}, SHIFT(3842),
  [6431] = {.count = 1, .reusable = true}, SHIFT(3880),
  [6433] = {.count = 1, .reusable = true}, SHIFT(3881),
  [6435] = {.count = 1, .reusable = true}, SHIFT(3883),
  [6437] = {.count = 1, .reusable = true}, REDUCE(sym_interpolation, 3),
  [6439] = {.count = 1, .reusable = false}, REDUCE(sym_interpolation, 3),
  [6441] = {.count = 1, .reusable = true}, SHIFT(3899),
  [6443] = {.count = 1, .reusable = false}, SHIFT(3899),
  [6445] = {.count = 1, .reusable = true}, SHIFT(3900),
  [6447] = {.count = 1, .reusable = true}, SHIFT(3901),
  [6449] = {.count = 1, .reusable = true}, SHIFT(3904),
  [6451] = {.count = 1, .reusable = true}, SHIFT(3906),
  [6453] = {.count = 1, .reusable = true}, SHIFT(3907),
  [6455] = {.count = 1, .reusable = true}, SHIFT(3908),
  [6457] = {.count = 1, .reusable = true}, SHIFT(3909),
  [6459] = {.count = 1, .reusable = true}, SHIFT(3910),
  [6461] = {.count = 1, .reusable = true}, SHIFT(3911),
  [6463] = {.count = 1, .reusable = true}, SHIFT(3912),
  [6465] = {.count = 1, .reusable = true}, SHIFT(3913),
  [6467] = {.count = 1, .reusable = true}, SHIFT(3937),
  [6469] = {.count = 1, .reusable = true}, SHIFT(3914),
  [6471] = {.count = 1, .reusable = true}, SHIFT(3915),
  [6473] = {.count = 1, .reusable = false}, SHIFT(3916),
  [6475] = {.count = 1, .reusable = true}, SHIFT(3917),
  [6477] = {.count = 1, .reusable = false}, SHIFT(3918),
  [6479] = {.count = 1, .reusable = false}, SHIFT(3919),
  [6481] = {.count = 1, .reusable = false}, SHIFT(3920),
  [6483] = {.count = 1, .reusable = false}, SHIFT(3921),
  [6485] = {.count = 1, .reusable = false}, SHIFT(3922),
  [6487] = {.count = 1, .reusable = false}, SHIFT(3923),
  [6489] = {.count = 1, .reusable = false}, SHIFT(3937),
  [6491] = {.count = 1, .reusable = false}, SHIFT(3924),
  [6493] = {.count = 1, .reusable = false}, SHIFT(3925),
  [6495] = {.count = 1, .reusable = false}, SHIFT(3926),
  [6497] = {.count = 1, .reusable = false}, SHIFT(3927),
  [6499] = {.count = 1, .reusable = false}, SHIFT(3928),
  [6501] = {.count = 1, .reusable = false}, SHIFT(3929),
  [6503] = {.count = 1, .reusable = false}, SHIFT(3930),
  [6505] = {.count = 1, .reusable = false}, SHIFT(3914),
  [6507] = {.count = 1, .reusable = true}, SHIFT(3931),
  [6509] = {.count = 1, .reusable = false}, SHIFT(3931),
  [6511] = {.count = 1, .reusable = true}, SHIFT(3932),
  [6513] = {.count = 1, .reusable = false}, SHIFT(3938),
  [6515] = {.count = 1, .reusable = true}, SHIFT(3938),
  [6517] = {.count = 1, .reusable = false}, SHIFT(3933),
  [6519] = {.count = 1, .reusable = true}, SHIFT(3934),
  [6521] = {.count = 1, .reusable = true}, SHIFT(3935),
  [6523] = {.count = 1, .reusable = false}, SHIFT(1666),
  [6525] = {.count = 1, .reusable = true}, SHIFT(3945),
  [6527] = {.count = 1, .reusable = true}, SHIFT(3946),
  [6529] = {.count = 1, .reusable = true}, SHIFT(3953),
  [6531] = {.count = 1, .reusable = false}, SHIFT(3950),
  [6533] = {.count = 1, .reusable = true}, SHIFT(3954),
  [6535] = {.count = 1, .reusable = false}, SHIFT(3957),
  [6537] = {.count = 1, .reusable = true}, SHIFT(3958),
  [6539] = {.count = 1, .reusable = true}, SHIFT(3959),
  [6541] = {.count = 1, .reusable = false}, SHIFT(3960),
  [6543] = {.count = 1, .reusable = false}, SHIFT(3959),
  [6545] = {.count = 1, .reusable = false}, SHIFT(3961),
  [6547] = {.count = 1, .reusable = false}, SHIFT(3962),
  [6549] = {.count = 1, .reusable = true}, SHIFT(3963),
  [6551] = {.count = 1, .reusable = false}, SHIFT(3964),
  [6553] = {.count = 1, .reusable = true}, SHIFT(3964),
  [6555] = {.count = 1, .reusable = false}, SHIFT(3966),
  [6557] = {.count = 1, .reusable = false}, SHIFT(3967),
  [6559] = {.count = 1, .reusable = true}, SHIFT(3966),
  [6561] = {.count = 1, .reusable = true}, SHIFT(3962),
  [6563] = {.count = 1, .reusable = false}, SHIFT(3958),
  [6565] = {.count = 1, .reusable = true}, SHIFT(3968),
  [6567] = {.count = 1, .reusable = true}, SHIFT(1674),
  [6569] = {.count = 1, .reusable = true}, SHIFT(3970),
  [6571] = {.count = 1, .reusable = true}, SHIFT(3972),
  [6573] = {.count = 1, .reusable = true}, SHIFT(3974),
  [6575] = {.count = 1, .reusable = false}, SHIFT(3974),
  [6577] = {.count = 1, .reusable = true}, SHIFT(3975),
  [6579] = {.count = 1, .reusable = false}, SHIFT(3945),
  [6581] = {.count = 1, .reusable = true}, SHIFT(3977),
  [6583] = {.count = 1, .reusable = true}, SHIFT(3978),
  [6585] = {.count = 1, .reusable = false}, SHIFT(3979),
  [6587] = {.count = 1, .reusable = false}, SHIFT(3980),
  [6589] = {.count = 1, .reusable = false}, SHIFT(3981),
  [6591] = {.count = 1, .reusable = false}, SHIFT(3982),
  [6593] = {.count = 1, .reusable = false}, SHIFT(3978),
  [6595] = {.count = 1, .reusable = true}, SHIFT(3983),
  [6597] = {.count = 1, .reusable = false}, SHIFT(3983),
  [6599] = {.count = 1, .reusable = true}, SHIFT(3984),
  [6601] = {.count = 1, .reusable = true}, REDUCE(sym_string_array, 4, .alias_sequence_id = 11),
  [6603] = {.count = 1, .reusable = false}, REDUCE(sym_string_array, 4, .alias_sequence_id = 11),
  [6605] = {.count = 1, .reusable = true}, REDUCE(sym_string_array, 4, .alias_sequence_id = 12),
  [6607] = {.count = 1, .reusable = false}, REDUCE(sym_string_array, 4, .alias_sequence_id = 12),
  [6609] = {.count = 1, .reusable = true}, SHIFT(3992),
  [6611] = {.count = 1, .reusable = true}, SHIFT(3993),
  [6613] = {.count = 1, .reusable = true}, REDUCE(sym_string_array, 4, .alias_sequence_id = 13),
  [6615] = {.count = 1, .reusable = false}, REDUCE(sym_string_array, 4, .alias_sequence_id = 13),
  [6617] = {.count = 1, .reusable = true}, REDUCE(aux_sym_string_array_repeat1, 2, .alias_sequence_id = 14),
  [6619] = {.count = 1, .reusable = true}, SHIFT(3994),
  [6621] = {.count = 1, .reusable = true}, REDUCE(aux_sym_string_array_repeat1, 2),
  [6623] = {.count = 2, .reusable = true}, REDUCE(aux_sym_string_array_repeat1, 2), SHIFT_REPEAT(3995),
  [6626] = {.count = 1, .reusable = true}, REDUCE(sym_symbol_array, 4, .alias_sequence_id = 11),
  [6628] = {.count = 1, .reusable = false}, REDUCE(sym_symbol_array, 4, .alias_sequence_id = 11),
  [6630] = {.count = 1, .reusable = true}, REDUCE(sym_symbol_array, 4, .alias_sequence_id = 15),
  [6632] = {.count = 1, .reusable = false}, REDUCE(sym_symbol_array, 4, .alias_sequence_id = 15),
  [6634] = {.count = 1, .reusable = true}, SHIFT(3996),
  [6636] = {.count = 1, .reusable = true}, SHIFT(3997),
  [6638] = {.count = 1, .reusable = true}, REDUCE(sym_symbol_array, 4, .alias_sequence_id = 16),
  [6640] = {.count = 1, .reusable = false}, REDUCE(sym_symbol_array, 4, .alias_sequence_id = 16),
  [6642] = {.count = 1, .reusable = true}, REDUCE(aux_sym_symbol_array_repeat1, 2, .alias_sequence_id = 17),
  [6644] = {.count = 1, .reusable = true}, SHIFT(3998),
  [6646] = {.count = 1, .reusable = true}, REDUCE(aux_sym_symbol_array_repeat1, 2),
  [6648] = {.count = 2, .reusable = true}, REDUCE(aux_sym_symbol_array_repeat1, 2), SHIFT_REPEAT(3999),
  [6651] = {.count = 1, .reusable = true}, SHIFT(4000),
  [6653] = {.count = 1, .reusable = false}, SHIFT(4001),
  [6655] = {.count = 1, .reusable = false}, SHIFT(4002),
  [6657] = {.count = 1, .reusable = false}, SHIFT(4003),
  [6659] = {.count = 1, .reusable = false}, SHIFT(4004),
  [6661] = {.count = 1, .reusable = false}, SHIFT(4000),
  [6663] = {.count = 1, .reusable = true}, SHIFT(4005),
  [6665] = {.count = 1, .reusable = false}, SHIFT(4005),
  [6667] = {.count = 1, .reusable = true}, SHIFT(4006),
  [6669] = {.count = 1, .reusable = false}, SHIFT(1711),
  [6671] = {.count = 1, .reusable = true}, SHIFT(4014),
  [6673] = {.count = 1, .reusable = false}, SHIFT(4019),
  [6675] = {.count = 1, .reusable = true}, SHIFT(4020),
  [6677] = {.count = 1, .reusable = true}, SHIFT(4021),
  [6679] = {.count = 1, .reusable = false}, SHIFT(4022),
  [6681] = {.count = 1, .reusable = false}, SHIFT(4023),
  [6683] = {.count = 1, .reusable = false}, SHIFT(4024),
  [6685] = {.count = 1, .reusable = true}, SHIFT(4025),
  [6687] = {.count = 1, .reusable = false}, SHIFT(4026),
  [6689] = {.count = 1, .reusable = true}, SHIFT(4026),
  [6691] = {.count = 1, .reusable = true}, SHIFT(4028),
  [6693] = {.count = 1, .reusable = true}, SHIFT(4029),
  [6695] = {.count = 1, .reusable = false}, SHIFT(4028),
  [6697] = {.count = 1, .reusable = true}, SHIFT(4024),
  [6699] = {.count = 1, .reusable = true}, SHIFT(4022),
  [6701] = {.count = 1, .reusable = true}, SHIFT(4031),
  [6703] = {.count = 1, .reusable = true}, SHIFT(4033),
  [6705] = {.count = 1, .reusable = false}, SHIFT(4033),
  [6707] = {.count = 1, .reusable = true}, SHIFT(4034),
  [6709] = {.count = 1, .reusable = false}, SHIFT(4014),
  [6711] = {.count = 1, .reusable = true}, REDUCE(sym_begin_block, 4),
  [6713] = {.count = 1, .reusable = true}, SHIFT(4052),
  [6715] = {.count = 1, .reusable = false}, SHIFT(4053),
  [6717] = {.count = 1, .reusable = false}, SHIFT(4054),
  [6719] = {.count = 1, .reusable = false}, SHIFT(4055),
  [6721] = {.count = 1, .reusable = false}, SHIFT(4056),
  [6723] = {.count = 1, .reusable = false}, SHIFT(4052),
  [6725] = {.count = 1, .reusable = true}, SHIFT(4057),
  [6727] = {.count = 1, .reusable = false}, SHIFT(4057),
  [6729] = {.count = 1, .reusable = true}, SHIFT(4058),
  [6731] = {.count = 1, .reusable = false}, SHIFT(4060),
  [6733] = {.count = 1, .reusable = true}, SHIFT(4060),
  [6735] = {.count = 1, .reusable = false}, SHIFT(1747),
  [6737] = {.count = 1, .reusable = true}, SHIFT(4067),
  [6739] = {.count = 1, .reusable = false}, SHIFT(4070),
  [6741] = {.count = 1, .reusable = true}, SHIFT(4071),
  [6743] = {.count = 1, .reusable = true}, SHIFT(4072),
  [6745] = {.count = 1, .reusable = false}, SHIFT(4073),
  [6747] = {.count = 1, .reusable = false}, SHIFT(4072),
  [6749] = {.count = 1, .reusable = false}, SHIFT(4074),
  [6751] = {.count = 1, .reusable = false}, SHIFT(4075),
  [6753] = {.count = 1, .reusable = true}, SHIFT(4076),
  [6755] = {.count = 1, .reusable = false}, SHIFT(4077),
  [6757] = {.count = 1, .reusable = true}, SHIFT(4077),
  [6759] = {.count = 1, .reusable = false}, SHIFT(4079),
  [6761] = {.count = 1, .reusable = false}, SHIFT(4080),
  [6763] = {.count = 1, .reusable = true}, SHIFT(4079),
  [6765] = {.count = 1, .reusable = true}, SHIFT(4075),
  [6767] = {.count = 1, .reusable = false}, SHIFT(4071),
  [6769] = {.count = 1, .reusable = true}, SHIFT(4082),
  [6771] = {.count = 1, .reusable = true}, SHIFT(4084),
  [6773] = {.count = 1, .reusable = false}, SHIFT(4084),
  [6775] = {.count = 1, .reusable = true}, SHIFT(4085),
  [6777] = {.count = 1, .reusable = false}, SHIFT(4067),
  [6779] = {.count = 1, .reusable = true}, SHIFT(4087),
  [6781] = {.count = 1, .reusable = true}, SHIFT(4088),
  [6783] = {.count = 1, .reusable = false}, SHIFT(4088),
  [6785] = {.count = 1, .reusable = true}, SHIFT(4089),
  [6787] = {.count = 1, .reusable = false}, SHIFT(4089),
  [6789] = {.count = 1, .reusable = true}, SHIFT(4090),
  [6791] = {.count = 1, .reusable = true}, SHIFT(4097),
  [6793] = {.count = 1, .reusable = true}, SHIFT(4098),
  [6795] = {.count = 1, .reusable = true}, SHIFT(4099),
  [6797] = {.count = 1, .reusable = true}, SHIFT(4101),
  [6799] = {.count = 1, .reusable = true}, SHIFT(4102),
  [6801] = {.count = 1, .reusable = true}, SHIFT(4103),
  [6803] = {.count = 1, .reusable = true}, SHIFT(4104),
  [6805] = {.count = 1, .reusable = true}, SHIFT(4105),
  [6807] = {.count = 1, .reusable = true}, SHIFT(4107),
  [6809] = {.count = 1, .reusable = true}, SHIFT(4108),
  [6811] = {.count = 1, .reusable = true}, SHIFT(4109),
  [6813] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_body, 3),
  [6815] = {.count = 2, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(1787),
  [6818] = {.count = 1, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2),
  [6820] = {.count = 2, .reusable = false}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(511),
  [6823] = {.count = 1, .reusable = true}, REDUCE(sym_pair, 3),
  [6825] = {.count = 1, .reusable = true}, SHIFT(4110),
  [6827] = {.count = 1, .reusable = true}, SHIFT(4111),
  [6829] = {.count = 1, .reusable = true}, SHIFT(522),
  [6831] = {.count = 1, .reusable = false}, SHIFT(4113),
  [6833] = {.count = 1, .reusable = true}, SHIFT(4114),
  [6835] = {.count = 1, .reusable = false}, SHIFT(4114),
  [6837] = {.count = 1, .reusable = true}, SHIFT(4115),
  [6839] = {.count = 1, .reusable = false}, SHIFT(4115),
  [6841] = {.count = 1, .reusable = true}, SHIFT(4116),
  [6843] = {.count = 1, .reusable = false}, SHIFT(1799),
  [6845] = {.count = 1, .reusable = true}, SHIFT(4123),
  [6847] = {.count = 1, .reusable = true}, SHIFT(4125),
  [6849] = {.count = 1, .reusable = true}, SHIFT(4126),
  [6851] = {.count = 1, .reusable = true}, SHIFT(4127),
  [6853] = {.count = 1, .reusable = false}, SHIFT(4129),
  [6855] = {.count = 1, .reusable = false}, SHIFT(4135),
  [6857] = {.count = 1, .reusable = true}, SHIFT(4136),
  [6859] = {.count = 1, .reusable = true}, SHIFT(4137),
  [6861] = {.count = 1, .reusable = false}, SHIFT(4138),
  [6863] = {.count = 1, .reusable = false}, SHIFT(4139),
  [6865] = {.count = 1, .reusable = false}, SHIFT(4140),
  [6867] = {.count = 1, .reusable = true}, SHIFT(4141),
  [6869] = {.count = 1, .reusable = false}, SHIFT(4142),
  [6871] = {.count = 1, .reusable = true}, SHIFT(4142),
  [6873] = {.count = 1, .reusable = true}, SHIFT(4144),
  [6875] = {.count = 1, .reusable = true}, SHIFT(4145),
  [6877] = {.count = 1, .reusable = false}, SHIFT(4144),
  [6879] = {.count = 1, .reusable = true}, SHIFT(4140),
  [6881] = {.count = 1, .reusable = true}, SHIFT(4138),
  [6883] = {.count = 1, .reusable = true}, SHIFT(4146),
  [6885] = {.count = 1, .reusable = true}, SHIFT(4147),
  [6887] = {.count = 1, .reusable = true}, SHIFT(4148),
  [6889] = {.count = 1, .reusable = false}, SHIFT(4150),
  [6891] = {.count = 1, .reusable = true}, SHIFT(4156),
  [6893] = {.count = 1, .reusable = true}, SHIFT(4158),
  [6895] = {.count = 1, .reusable = false}, SHIFT(4158),
  [6897] = {.count = 1, .reusable = true}, SHIFT(4159),
  [6899] = {.count = 1, .reusable = false}, SHIFT(4123),
  [6901] = {.count = 1, .reusable = true}, SHIFT(4171),
  [6903] = {.count = 1, .reusable = false}, SHIFT(4171),
  [6905] = {.count = 1, .reusable = true}, SHIFT(4172),
  [6907] = {.count = 1, .reusable = true}, SHIFT(4173),
  [6909] = {.count = 1, .reusable = true}, SHIFT(4176),
  [6911] = {.count = 1, .reusable = true}, SHIFT(4178),
  [6913] = {.count = 1, .reusable = true}, SHIFT(4179),
  [6915] = {.count = 1, .reusable = false}, SHIFT(4180),
  [6917] = {.count = 1, .reusable = false}, SHIFT(4181),
  [6919] = {.count = 1, .reusable = false}, SHIFT(4182),
  [6921] = {.count = 1, .reusable = false}, SHIFT(4183),
  [6923] = {.count = 1, .reusable = false}, SHIFT(4179),
  [6925] = {.count = 1, .reusable = true}, SHIFT(4184),
  [6927] = {.count = 1, .reusable = false}, SHIFT(4184),
  [6929] = {.count = 1, .reusable = true}, SHIFT(4185),
  [6931] = {.count = 1, .reusable = false}, SHIFT(4187),
  [6933] = {.count = 1, .reusable = true}, SHIFT(4187),
  [6935] = {.count = 1, .reusable = false}, SHIFT(1832),
  [6937] = {.count = 1, .reusable = true}, SHIFT(4194),
  [6939] = {.count = 1, .reusable = true}, SHIFT(4195),
  [6941] = {.count = 1, .reusable = true}, SHIFT(4202),
  [6943] = {.count = 1, .reusable = false}, SHIFT(4199),
  [6945] = {.count = 1, .reusable = false}, SHIFT(4204),
  [6947] = {.count = 1, .reusable = true}, SHIFT(4205),
  [6949] = {.count = 1, .reusable = true}, SHIFT(4206),
  [6951] = {.count = 1, .reusable = false}, SHIFT(4207),
  [6953] = {.count = 1, .reusable = false}, SHIFT(4206),
  [6955] = {.count = 1, .reusable = false}, SHIFT(4208),
  [6957] = {.count = 1, .reusable = false}, SHIFT(4209),
  [6959] = {.count = 1, .reusable = true}, SHIFT(4210),
  [6961] = {.count = 1, .reusable = false}, SHIFT(4211),
  [6963] = {.count = 1, .reusable = true}, SHIFT(4211),
  [6965] = {.count = 1, .reusable = false}, SHIFT(4213),
  [6967] = {.count = 1, .reusable = false}, SHIFT(4214),
  [6969] = {.count = 1, .reusable = true}, SHIFT(4213),
  [6971] = {.count = 1, .reusable = true}, SHIFT(4209),
  [6973] = {.count = 1, .reusable = false}, SHIFT(4205),
  [6975] = {.count = 1, .reusable = true}, SHIFT(4215),
  [6977] = {.count = 1, .reusable = true}, SHIFT(1840),
  [6979] = {.count = 1, .reusable = true}, SHIFT(4218),
  [6981] = {.count = 1, .reusable = true}, SHIFT(4220),
  [6983] = {.count = 1, .reusable = false}, SHIFT(4220),
  [6985] = {.count = 1, .reusable = true}, SHIFT(4221),
  [6987] = {.count = 1, .reusable = false}, SHIFT(4194),
  [6989] = {.count = 1, .reusable = true}, SHIFT(4223),
  [6991] = {.count = 1, .reusable = true}, SHIFT(4228),
  [6993] = {.count = 1, .reusable = true}, SHIFT(4229),
  [6995] = {.count = 1, .reusable = false}, SHIFT(4230),
  [6997] = {.count = 1, .reusable = false}, SHIFT(4231),
  [6999] = {.count = 1, .reusable = true}, SHIFT(4235),
  [7001] = {.count = 1, .reusable = true}, SHIFT(4248),
  [7003] = {.count = 1, .reusable = true}, SHIFT(4247),
  [7005] = {.count = 1, .reusable = true}, SHIFT(552),
  [7007] = {.count = 1, .reusable = true}, SHIFT(4259),
  [7009] = {.count = 1, .reusable = false}, SHIFT(4259),
  [7011] = {.count = 1, .reusable = true}, SHIFT(4261),
  [7013] = {.count = 1, .reusable = false}, SHIFT(4261),
  [7015] = {.count = 1, .reusable = false}, SHIFT(4263),
  [7017] = {.count = 1, .reusable = false}, SHIFT(4265),
  [7019] = {.count = 1, .reusable = true}, SHIFT(4267),
  [7021] = {.count = 1, .reusable = true}, SHIFT(4270),
  [7023] = {.count = 1, .reusable = true}, SHIFT(4268),
  [7025] = {.count = 1, .reusable = true}, SHIFT(4272),
  [7027] = {.count = 1, .reusable = true}, REDUCE(sym_pair, 3, .alias_sequence_id = 18),
  [7029] = {.count = 1, .reusable = true}, SHIFT(4275),
  [7031] = {.count = 1, .reusable = true}, SHIFT(4277),
  [7033] = {.count = 1, .reusable = true}, SHIFT(4279),
  [7035] = {.count = 1, .reusable = false}, SHIFT(4277),
  [7037] = {.count = 1, .reusable = true}, SHIFT(4281),
  [7039] = {.count = 1, .reusable = true}, SHIFT(4282),
  [7041] = {.count = 1, .reusable = true}, SHIFT(4284),
  [7043] = {.count = 1, .reusable = true}, SHIFT(4285),
  [7045] = {.count = 1, .reusable = true}, SHIFT(4286),
  [7047] = {.count = 1, .reusable = true}, SHIFT(4287),
  [7049] = {.count = 1, .reusable = true}, SHIFT(4288),
  [7051] = {.count = 1, .reusable = true}, SHIFT(4289),
  [7053] = {.count = 1, .reusable = true}, SHIFT(4290),
  [7055] = {.count = 1, .reusable = false}, SHIFT(4291),
  [7057] = {.count = 1, .reusable = true}, SHIFT(4293),
  [7059] = {.count = 1, .reusable = true}, SHIFT(4294),
  [7061] = {.count = 1, .reusable = true}, SHIFT(4296),
  [7063] = {.count = 1, .reusable = false}, SHIFT(4297),
  [7065] = {.count = 1, .reusable = true}, SHIFT(4299),
  [7067] = {.count = 1, .reusable = true}, SHIFT(4300),
  [7069] = {.count = 1, .reusable = true}, SHIFT(4302),
  [7071] = {.count = 1, .reusable = true}, SHIFT(4304),
  [7073] = {.count = 1, .reusable = true}, SHIFT(4306),
  [7075] = {.count = 1, .reusable = true}, SHIFT(4309),
  [7077] = {.count = 1, .reusable = true}, SHIFT(4310),
  [7079] = {.count = 1, .reusable = true}, SHIFT(4311),
  [7081] = {.count = 1, .reusable = true}, SHIFT(4314),
  [7083] = {.count = 1, .reusable = true}, SHIFT(4316),
  [7085] = {.count = 1, .reusable = false}, SHIFT(4315),
  [7087] = {.count = 1, .reusable = true}, SHIFT(4318),
  [7089] = {.count = 1, .reusable = true}, SHIFT(4320),
  [7091] = {.count = 1, .reusable = true}, SHIFT(4321),
  [7093] = {.count = 1, .reusable = true}, SHIFT(4322),
  [7095] = {.count = 1, .reusable = true}, SHIFT(4324),
  [7097] = {.count = 1, .reusable = true}, SHIFT(4326),
  [7099] = {.count = 1, .reusable = false}, SHIFT(4324),
  [7101] = {.count = 1, .reusable = true}, SHIFT(4328),
  [7103] = {.count = 1, .reusable = true}, SHIFT(4331),
  [7105] = {.count = 1, .reusable = true}, SHIFT(4329),
  [7107] = {.count = 1, .reusable = true}, SHIFT(4333),
  [7109] = {.count = 1, .reusable = false}, SHIFT(4337),
  [7111] = {.count = 1, .reusable = true}, SHIFT(4338),
  [7113] = {.count = 1, .reusable = true}, SHIFT(4340),
  [7115] = {.count = 1, .reusable = true}, SHIFT(4341),
  [7117] = {.count = 1, .reusable = true}, SHIFT(4353),
  [7119] = {.count = 1, .reusable = true}, SHIFT(4355),
  [7121] = {.count = 1, .reusable = true}, SHIFT(4354),
  [7123] = {.count = 1, .reusable = true}, SHIFT(622),
  [7125] = {.count = 1, .reusable = true}, SHIFT(4369),
  [7127] = {.count = 1, .reusable = true}, SHIFT(4370),
  [7129] = {.count = 1, .reusable = false}, SHIFT(4371),
  [7131] = {.count = 1, .reusable = false}, SHIFT(4372),
  [7133] = {.count = 1, .reusable = false}, SHIFT(4373),
  [7135] = {.count = 1, .reusable = true}, SHIFT(4374),
  [7137] = {.count = 1, .reusable = false}, SHIFT(4375),
  [7139] = {.count = 1, .reusable = true}, SHIFT(4375),
  [7141] = {.count = 1, .reusable = true}, SHIFT(4377),
  [7143] = {.count = 1, .reusable = true}, SHIFT(4378),
  [7145] = {.count = 1, .reusable = false}, SHIFT(4377),
  [7147] = {.count = 1, .reusable = true}, SHIFT(4373),
  [7149] = {.count = 1, .reusable = true}, SHIFT(4371),
  [7151] = {.count = 1, .reusable = true}, SHIFT(4379),
  [7153] = {.count = 1, .reusable = true}, SHIFT(4381),
  [7155] = {.count = 1, .reusable = false}, SHIFT(4381),
  [7157] = {.count = 1, .reusable = true}, SHIFT(4382),
  [7159] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(76),
  [7162] = {.count = 1, .reusable = true}, REDUCE(sym_hash, 4),
  [7164] = {.count = 1, .reusable = false}, REDUCE(sym_hash, 4),
  [7166] = {.count = 1, .reusable = true}, SHIFT(4385),
  [7168] = {.count = 1, .reusable = true}, SHIFT(4384),
  [7170] = {.count = 1, .reusable = true}, REDUCE(sym__hash_items, 3),
  [7172] = {.count = 1, .reusable = true}, REDUCE(sym_end_block, 4),
  [7174] = {.count = 1, .reusable = true}, SHIFT(4387),
  [7176] = {.count = 1, .reusable = false}, SHIFT(4387),
  [7178] = {.count = 1, .reusable = true}, SHIFT(4388),
  [7180] = {.count = 1, .reusable = false}, SHIFT(4388),
  [7182] = {.count = 1, .reusable = true}, SHIFT(4389),
  [7184] = {.count = 1, .reusable = false}, SHIFT(2051),
  [7186] = {.count = 1, .reusable = true}, SHIFT(4395),
  [7188] = {.count = 1, .reusable = false}, SHIFT(4398),
  [7190] = {.count = 1, .reusable = true}, SHIFT(4399),
  [7192] = {.count = 1, .reusable = true}, SHIFT(4400),
  [7194] = {.count = 1, .reusable = false}, SHIFT(4401),
  [7196] = {.count = 1, .reusable = false}, SHIFT(4402),
  [7198] = {.count = 1, .reusable = false}, SHIFT(4403),
  [7200] = {.count = 1, .reusable = true}, SHIFT(4404),
  [7202] = {.count = 1, .reusable = false}, SHIFT(4405),
  [7204] = {.count = 1, .reusable = true}, SHIFT(4405),
  [7206] = {.count = 1, .reusable = true}, SHIFT(4407),
  [7208] = {.count = 1, .reusable = true}, SHIFT(4408),
  [7210] = {.count = 1, .reusable = false}, SHIFT(4407),
  [7212] = {.count = 1, .reusable = true}, SHIFT(4403),
  [7214] = {.count = 1, .reusable = true}, SHIFT(4401),
  [7216] = {.count = 1, .reusable = true}, SHIFT(4410),
  [7218] = {.count = 1, .reusable = true}, SHIFT(4412),
  [7220] = {.count = 1, .reusable = false}, SHIFT(4412),
  [7222] = {.count = 1, .reusable = true}, SHIFT(4413),
  [7224] = {.count = 1, .reusable = false}, SHIFT(4395),
  [7226] = {.count = 1, .reusable = true}, SHIFT(4416),
  [7228] = {.count = 1, .reusable = true}, SHIFT(4425),
  [7230] = {.count = 1, .reusable = false}, SHIFT(4426),
  [7232] = {.count = 1, .reusable = false}, SHIFT(4427),
  [7234] = {.count = 1, .reusable = false}, SHIFT(4428),
  [7236] = {.count = 1, .reusable = false}, SHIFT(4429),
  [7238] = {.count = 1, .reusable = false}, SHIFT(4425),
  [7240] = {.count = 1, .reusable = true}, SHIFT(4430),
  [7242] = {.count = 1, .reusable = false}, SHIFT(4430),
  [7244] = {.count = 1, .reusable = true}, SHIFT(4431),
  [7246] = {.count = 1, .reusable = false}, SHIFT(4433),
  [7248] = {.count = 1, .reusable = true}, SHIFT(4433),
  [7250] = {.count = 1, .reusable = false}, SHIFT(2077),
  [7252] = {.count = 1, .reusable = true}, SHIFT(4440),
  [7254] = {.count = 1, .reusable = false}, SHIFT(4443),
  [7256] = {.count = 1, .reusable = true}, SHIFT(4444),
  [7258] = {.count = 1, .reusable = true}, SHIFT(4445),
  [7260] = {.count = 1, .reusable = false}, SHIFT(4446),
  [7262] = {.count = 1, .reusable = false}, SHIFT(4445),
  [7264] = {.count = 1, .reusable = false}, SHIFT(4447),
  [7266] = {.count = 1, .reusable = false}, SHIFT(4448),
  [7268] = {.count = 1, .reusable = true}, SHIFT(4449),
  [7270] = {.count = 1, .reusable = false}, SHIFT(4450),
  [7272] = {.count = 1, .reusable = true}, SHIFT(4450),
  [7274] = {.count = 1, .reusable = false}, SHIFT(4452),
  [7276] = {.count = 1, .reusable = false}, SHIFT(4453),
  [7278] = {.count = 1, .reusable = true}, SHIFT(4452),
  [7280] = {.count = 1, .reusable = true}, SHIFT(4448),
  [7282] = {.count = 1, .reusable = false}, SHIFT(4444),
  [7284] = {.count = 1, .reusable = true}, SHIFT(4455),
  [7286] = {.count = 1, .reusable = true}, SHIFT(4457),
  [7288] = {.count = 1, .reusable = false}, SHIFT(4457),
  [7290] = {.count = 1, .reusable = true}, SHIFT(4458),
  [7292] = {.count = 1, .reusable = false}, SHIFT(4440),
  [7294] = {.count = 1, .reusable = true}, SHIFT(4460),
  [7296] = {.count = 1, .reusable = true}, SHIFT(4461),
  [7298] = {.count = 1, .reusable = false}, SHIFT(4462),
  [7300] = {.count = 1, .reusable = false}, SHIFT(4463),
  [7302] = {.count = 1, .reusable = false}, SHIFT(4464),
  [7304] = {.count = 1, .reusable = false}, SHIFT(4465),
  [7306] = {.count = 1, .reusable = false}, SHIFT(4461),
  [7308] = {.count = 1, .reusable = true}, SHIFT(4466),
  [7310] = {.count = 1, .reusable = false}, SHIFT(4466),
  [7312] = {.count = 1, .reusable = true}, SHIFT(4467),
  [7314] = {.count = 1, .reusable = true}, REDUCE(sym_singleton_method, 4),
  [7316] = {.count = 1, .reusable = false}, REDUCE(sym_singleton_method, 4),
  [7318] = {.count = 1, .reusable = true}, SHIFT(4475),
  [7320] = {.count = 1, .reusable = true}, REDUCE(sym_method_parameters, 2),
  [7322] = {.count = 1, .reusable = false}, REDUCE(sym_method_parameters, 2),
  [7324] = {.count = 1, .reusable = true}, SHIFT(4476),
  [7326] = {.count = 1, .reusable = true}, SHIFT(4478),
  [7328] = {.count = 1, .reusable = false}, SHIFT(4479),
  [7330] = {.count = 1, .reusable = true}, REDUCE(sym__method_rest, 3),
  [7332] = {.count = 1, .reusable = false}, REDUCE(sym__method_rest, 3),
  [7334] = {.count = 1, .reusable = true}, SHIFT(4484),
  [7336] = {.count = 1, .reusable = true}, SHIFT(4486),
  [7338] = {.count = 1, .reusable = false}, SHIFT(4487),
  [7340] = {.count = 1, .reusable = false}, SHIFT(4488),
  [7342] = {.count = 1, .reusable = false}, SHIFT(4489),
  [7344] = {.count = 1, .reusable = false}, SHIFT(4490),
  [7346] = {.count = 1, .reusable = false}, SHIFT(4486),
  [7348] = {.count = 1, .reusable = true}, SHIFT(4491),
  [7350] = {.count = 1, .reusable = false}, SHIFT(4491),
  [7352] = {.count = 1, .reusable = true}, SHIFT(4492),
  [7354] = {.count = 1, .reusable = true}, SHIFT(4500),
  [7356] = {.count = 1, .reusable = true}, SHIFT(4502),
  [7358] = {.count = 1, .reusable = true}, SHIFT(4503),
  [7360] = {.count = 1, .reusable = true}, SHIFT(4504),
  [7362] = {.count = 1, .reusable = false}, SHIFT(2119),
  [7364] = {.count = 1, .reusable = false}, SHIFT(4506),
  [7366] = {.count = 1, .reusable = false}, SHIFT(4512),
  [7368] = {.count = 1, .reusable = true}, SHIFT(4513),
  [7370] = {.count = 1, .reusable = true}, SHIFT(4514),
  [7372] = {.count = 1, .reusable = false}, SHIFT(4515),
  [7374] = {.count = 1, .reusable = false}, SHIFT(4516),
  [7376] = {.count = 1, .reusable = false}, SHIFT(4517),
  [7378] = {.count = 1, .reusable = true}, SHIFT(4518),
  [7380] = {.count = 1, .reusable = false}, SHIFT(4519),
  [7382] = {.count = 1, .reusable = true}, SHIFT(4519),
  [7384] = {.count = 1, .reusable = true}, SHIFT(4520),
  [7386] = {.count = 1, .reusable = true}, SHIFT(4521),
  [7388] = {.count = 1, .reusable = true}, SHIFT(4522),
  [7390] = {.count = 1, .reusable = false}, SHIFT(4521),
  [7392] = {.count = 1, .reusable = true}, SHIFT(4517),
  [7394] = {.count = 1, .reusable = true}, SHIFT(4515),
  [7396] = {.count = 1, .reusable = true}, SHIFT(4524),
  [7398] = {.count = 1, .reusable = true}, SHIFT(4526),
  [7400] = {.count = 1, .reusable = false}, SHIFT(4526),
  [7402] = {.count = 1, .reusable = true}, SHIFT(4527),
  [7404] = {.count = 1, .reusable = false}, SHIFT(4500),
  [7406] = {.count = 1, .reusable = true}, SHIFT(4533),
  [7408] = {.count = 1, .reusable = true}, SHIFT(4534),
  [7410] = {.count = 1, .reusable = false}, SHIFT(4535),
  [7412] = {.count = 1, .reusable = false}, SHIFT(4536),
  [7414] = {.count = 1, .reusable = false}, SHIFT(4537),
  [7416] = {.count = 1, .reusable = true}, SHIFT(4538),
  [7418] = {.count = 1, .reusable = false}, SHIFT(4539),
  [7420] = {.count = 1, .reusable = true}, SHIFT(4539),
  [7422] = {.count = 1, .reusable = true}, SHIFT(4541),
  [7424] = {.count = 1, .reusable = true}, SHIFT(4542),
  [7426] = {.count = 1, .reusable = false}, SHIFT(4541),
  [7428] = {.count = 1, .reusable = true}, SHIFT(4537),
  [7430] = {.count = 1, .reusable = true}, SHIFT(4535),
  [7432] = {.count = 1, .reusable = true}, SHIFT(4543),
  [7434] = {.count = 1, .reusable = false}, SHIFT(4543),
  [7436] = {.count = 1, .reusable = true}, SHIFT(4544),
  [7438] = {.count = 1, .reusable = true}, SHIFT(4549),
  [7440] = {.count = 1, .reusable = false}, SHIFT(4551),
  [7442] = {.count = 1, .reusable = true}, SHIFT(4553),
  [7444] = {.count = 1, .reusable = false}, SHIFT(4549),
  [7446] = {.count = 1, .reusable = true}, SHIFT(4568),
  [7448] = {.count = 1, .reusable = false}, SHIFT(4570),
  [7450] = {.count = 1, .reusable = true}, SHIFT(4572),
  [7452] = {.count = 1, .reusable = false}, SHIFT(4568),
  [7454] = {.count = 1, .reusable = true}, SHIFT(692),
  [7456] = {.count = 1, .reusable = true}, SHIFT(4583),
  [7458] = {.count = 1, .reusable = true}, SHIFT(4586),
  [7460] = {.count = 1, .reusable = true}, SHIFT(4587),
  [7462] = {.count = 1, .reusable = false}, SHIFT(4588),
  [7464] = {.count = 1, .reusable = false}, SHIFT(4587),
  [7466] = {.count = 1, .reusable = false}, SHIFT(4589),
  [7468] = {.count = 1, .reusable = false}, SHIFT(4590),
  [7470] = {.count = 1, .reusable = true}, SHIFT(4591),
  [7472] = {.count = 1, .reusable = false}, SHIFT(4592),
  [7474] = {.count = 1, .reusable = true}, SHIFT(4592),
  [7476] = {.count = 1, .reusable = false}, SHIFT(4594),
  [7478] = {.count = 1, .reusable = false}, SHIFT(4595),
  [7480] = {.count = 1, .reusable = true}, SHIFT(4594),
  [7482] = {.count = 1, .reusable = true}, SHIFT(4590),
  [7484] = {.count = 1, .reusable = false}, SHIFT(4586),
  [7486] = {.count = 1, .reusable = true}, SHIFT(4596),
  [7488] = {.count = 1, .reusable = false}, SHIFT(4596),
  [7490] = {.count = 1, .reusable = true}, SHIFT(4597),
  [7492] = {.count = 1, .reusable = true}, SHIFT(729),
  [7494] = {.count = 1, .reusable = true}, SHIFT(4622),
  [7496] = {.count = 1, .reusable = true}, SHIFT(4623),
  [7498] = {.count = 1, .reusable = false}, SHIFT(4624),
  [7500] = {.count = 1, .reusable = false}, SHIFT(4625),
  [7502] = {.count = 1, .reusable = false}, SHIFT(4626),
  [7504] = {.count = 1, .reusable = true}, SHIFT(4627),
  [7506] = {.count = 1, .reusable = false}, SHIFT(4628),
  [7508] = {.count = 1, .reusable = true}, SHIFT(4628),
  [7510] = {.count = 1, .reusable = true}, SHIFT(4630),
  [7512] = {.count = 1, .reusable = true}, SHIFT(4631),
  [7514] = {.count = 1, .reusable = false}, SHIFT(4630),
  [7516] = {.count = 1, .reusable = true}, SHIFT(4626),
  [7518] = {.count = 1, .reusable = true}, SHIFT(4624),
  [7520] = {.count = 1, .reusable = true}, SHIFT(4632),
  [7522] = {.count = 1, .reusable = true}, SHIFT(4634),
  [7524] = {.count = 1, .reusable = false}, SHIFT(4634),
  [7526] = {.count = 1, .reusable = true}, SHIFT(4635),
  [7528] = {.count = 2, .reusable = true}, REDUCE(aux_sym__mlhs_repeat1, 2), SHIFT_REPEAT(4636),
  [7531] = {.count = 1, .reusable = true}, SHIFT(4637),
  [7533] = {.count = 1, .reusable = true}, SHIFT(4638),
  [7535] = {.count = 1, .reusable = true}, SHIFT(4639),
  [7537] = {.count = 1, .reusable = true}, SHIFT(4641),
  [7539] = {.count = 1, .reusable = true}, SHIFT(4642),
  [7541] = {.count = 1, .reusable = true}, SHIFT(4643),
  [7543] = {.count = 1, .reusable = true}, SHIFT(4644),
  [7545] = {.count = 1, .reusable = true}, SHIFT(4645),
  [7547] = {.count = 1, .reusable = true}, SHIFT(4647),
  [7549] = {.count = 1, .reusable = true}, SHIFT(4648),
  [7551] = {.count = 1, .reusable = true}, SHIFT(4649),
  [7553] = {.count = 1, .reusable = true}, SHIFT(4650),
  [7555] = {.count = 1, .reusable = true}, SHIFT(772),
  [7557] = {.count = 1, .reusable = false}, SHIFT(4652),
  [7559] = {.count = 1, .reusable = true}, SHIFT(4653),
  [7561] = {.count = 1, .reusable = true}, SHIFT(4654),
  [7563] = {.count = 1, .reusable = false}, SHIFT(4655),
  [7565] = {.count = 1, .reusable = false}, SHIFT(4656),
  [7567] = {.count = 1, .reusable = true}, SHIFT(4658),
  [7569] = {.count = 1, .reusable = true}, SHIFT(4659),
  [7571] = {.count = 1, .reusable = true}, SHIFT(4660),
  [7573] = {.count = 1, .reusable = false}, SHIFT(4662),
  [7575] = {.count = 1, .reusable = true}, SHIFT(4668),
  [7577] = {.count = 1, .reusable = true}, SHIFT(4669),
  [7579] = {.count = 1, .reusable = false}, SHIFT(4670),
  [7581] = {.count = 1, .reusable = false}, SHIFT(4671),
  [7583] = {.count = 1, .reusable = false}, SHIFT(4672),
  [7585] = {.count = 1, .reusable = true}, SHIFT(4673),
  [7587] = {.count = 1, .reusable = false}, SHIFT(4674),
  [7589] = {.count = 1, .reusable = true}, SHIFT(4674),
  [7591] = {.count = 1, .reusable = true}, SHIFT(4675),
  [7593] = {.count = 1, .reusable = true}, SHIFT(4676),
  [7595] = {.count = 1, .reusable = true}, SHIFT(4677),
  [7597] = {.count = 1, .reusable = false}, SHIFT(4676),
  [7599] = {.count = 1, .reusable = true}, SHIFT(4672),
  [7601] = {.count = 1, .reusable = true}, SHIFT(4670),
  [7603] = {.count = 1, .reusable = true}, SHIFT(4678),
  [7605] = {.count = 1, .reusable = true}, SHIFT(4679),
  [7607] = {.count = 1, .reusable = true}, SHIFT(4680),
  [7609] = {.count = 1, .reusable = false}, SHIFT(4682),
  [7611] = {.count = 1, .reusable = true}, SHIFT(4687),
  [7613] = {.count = 1, .reusable = false}, SHIFT(4687),
  [7615] = {.count = 1, .reusable = true}, SHIFT(4688),
  [7617] = {.count = 1, .reusable = true}, SHIFT(4691),
  [7619] = {.count = 1, .reusable = true}, SHIFT(4694),
  [7621] = {.count = 1, .reusable = true}, SHIFT(4693),
  [7623] = {.count = 1, .reusable = true}, SHIFT(4699),
  [7625] = {.count = 1, .reusable = false}, SHIFT(4699),
  [7627] = {.count = 1, .reusable = true}, SHIFT(4701),
  [7629] = {.count = 1, .reusable = false}, SHIFT(4701),
  [7631] = {.count = 1, .reusable = false}, SHIFT(4703),
  [7633] = {.count = 1, .reusable = false}, SHIFT(4705),
  [7635] = {.count = 1, .reusable = true}, SHIFT(4707),
  [7637] = {.count = 1, .reusable = true}, SHIFT(4710),
  [7639] = {.count = 1, .reusable = true}, SHIFT(4708),
  [7641] = {.count = 1, .reusable = true}, SHIFT(4712),
  [7643] = {.count = 1, .reusable = true}, SHIFT(4715),
  [7645] = {.count = 1, .reusable = true}, SHIFT(4717),
  [7647] = {.count = 1, .reusable = true}, SHIFT(4719),
  [7649] = {.count = 1, .reusable = false}, SHIFT(4717),
  [7651] = {.count = 1, .reusable = true}, SHIFT(4721),
  [7653] = {.count = 1, .reusable = true}, SHIFT(4723),
  [7655] = {.count = 1, .reusable = true}, SHIFT(4724),
  [7657] = {.count = 1, .reusable = true}, SHIFT(4725),
  [7659] = {.count = 1, .reusable = true}, SHIFT(4727),
  [7661] = {.count = 1, .reusable = true}, SHIFT(4729),
  [7663] = {.count = 1, .reusable = true}, SHIFT(4731),
  [7665] = {.count = 1, .reusable = true}, SHIFT(4733),
  [7667] = {.count = 1, .reusable = false}, SHIFT(4734),
  [7669] = {.count = 1, .reusable = true}, SHIFT(4736),
  [7671] = {.count = 1, .reusable = false}, SHIFT(4737),
  [7673] = {.count = 1, .reusable = true}, SHIFT(4740),
  [7675] = {.count = 1, .reusable = true}, SHIFT(4743),
  [7677] = {.count = 1, .reusable = false}, SHIFT(4745),
  [7679] = {.count = 1, .reusable = true}, SHIFT(4747),
  [7681] = {.count = 1, .reusable = true}, SHIFT(4749),
  [7683] = {.count = 1, .reusable = false}, SHIFT(4750),
  [7685] = {.count = 1, .reusable = false}, SHIFT(4752),
  [7687] = {.count = 1, .reusable = true}, SHIFT(4754),
  [7689] = {.count = 1, .reusable = true}, SHIFT(4755),
  [7691] = {.count = 1, .reusable = true}, SHIFT(4756),
  [7693] = {.count = 1, .reusable = true}, SHIFT(4758),
  [7695] = {.count = 1, .reusable = false}, SHIFT(4759),
  [7697] = {.count = 1, .reusable = true}, SHIFT(4774),
  [7699] = {.count = 1, .reusable = true}, SHIFT(4780),
  [7701] = {.count = 1, .reusable = false}, SHIFT(4779),
  [7703] = {.count = 1, .reusable = true}, SHIFT(4783),
  [7705] = {.count = 1, .reusable = true}, SHIFT(4784),
  [7707] = {.count = 1, .reusable = true}, SHIFT(4786),
  [7709] = {.count = 1, .reusable = false}, SHIFT(4787),
  [7711] = {.count = 1, .reusable = true}, SHIFT(4790),
  [7713] = {.count = 1, .reusable = true}, SHIFT(4791),
  [7715] = {.count = 1, .reusable = false}, SHIFT(4792),
  [7717] = {.count = 1, .reusable = false}, SHIFT(4793),
  [7719] = {.count = 1, .reusable = false}, SHIFT(4794),
  [7721] = {.count = 1, .reusable = true}, SHIFT(4795),
  [7723] = {.count = 1, .reusable = false}, SHIFT(4796),
  [7725] = {.count = 1, .reusable = true}, SHIFT(4796),
  [7727] = {.count = 1, .reusable = true}, SHIFT(4797),
  [7729] = {.count = 1, .reusable = true}, SHIFT(4798),
  [7731] = {.count = 1, .reusable = true}, SHIFT(4799),
  [7733] = {.count = 1, .reusable = false}, SHIFT(4798),
  [7735] = {.count = 1, .reusable = true}, SHIFT(4794),
  [7737] = {.count = 1, .reusable = true}, SHIFT(4792),
  [7739] = {.count = 1, .reusable = true}, SHIFT(4800),
  [7741] = {.count = 1, .reusable = true}, SHIFT(4802),
  [7743] = {.count = 1, .reusable = false}, SHIFT(4802),
  [7745] = {.count = 1, .reusable = true}, SHIFT(4803),
  [7747] = {.count = 1, .reusable = true}, SHIFT(4808),
  [7749] = {.count = 1, .reusable = false}, SHIFT(4810),
  [7751] = {.count = 1, .reusable = true}, SHIFT(4812),
  [7753] = {.count = 1, .reusable = false}, SHIFT(4808),
  [7755] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(155),
  [7758] = {.count = 1, .reusable = false}, SHIFT(4833),
  [7760] = {.count = 1, .reusable = true}, REDUCE(sym_superclass, 2),
  [7762] = {.count = 1, .reusable = false}, SHIFT(4834),
  [7764] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4),
  [7766] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4),
  [7768] = {.count = 1, .reusable = true}, SHIFT(4836),
  [7770] = {.count = 1, .reusable = true}, SHIFT(4837),
  [7772] = {.count = 1, .reusable = true}, SHIFT(4838),
  [7774] = {.count = 1, .reusable = false}, SHIFT(4840),
  [7776] = {.count = 1, .reusable = true}, SHIFT(4846),
  [7778] = {.count = 1, .reusable = true}, SHIFT(4847),
  [7780] = {.count = 1, .reusable = false}, SHIFT(4848),
  [7782] = {.count = 1, .reusable = false}, SHIFT(4849),
  [7784] = {.count = 1, .reusable = false}, SHIFT(4850),
  [7786] = {.count = 1, .reusable = true}, SHIFT(4851),
  [7788] = {.count = 1, .reusable = false}, SHIFT(4852),
  [7790] = {.count = 1, .reusable = true}, SHIFT(4852),
  [7792] = {.count = 1, .reusable = true}, SHIFT(4853),
  [7794] = {.count = 1, .reusable = true}, SHIFT(4854),
  [7796] = {.count = 1, .reusable = true}, SHIFT(4855),
  [7798] = {.count = 1, .reusable = false}, SHIFT(4854),
  [7800] = {.count = 1, .reusable = true}, SHIFT(4850),
  [7802] = {.count = 1, .reusable = true}, SHIFT(4848),
  [7804] = {.count = 1, .reusable = true}, SHIFT(4856),
  [7806] = {.count = 1, .reusable = false}, SHIFT(4856),
  [7808] = {.count = 1, .reusable = true}, SHIFT(4857),
  [7810] = {.count = 1, .reusable = true}, SHIFT(4862),
  [7812] = {.count = 1, .reusable = false}, SHIFT(4864),
  [7814] = {.count = 1, .reusable = true}, SHIFT(4866),
  [7816] = {.count = 1, .reusable = false}, SHIFT(4862),
  [7818] = {.count = 1, .reusable = true}, REDUCE(sym_module, 4),
  [7820] = {.count = 1, .reusable = false}, REDUCE(sym_module, 4),
  [7822] = {.count = 1, .reusable = false}, REDUCE(sym_pair, 3),
  [7824] = {.count = 1, .reusable = true}, SHIFT(887),
  [7826] = {.count = 1, .reusable = true}, SHIFT(4913),
  [7828] = {.count = 1, .reusable = true}, SHIFT(4914),
  [7830] = {.count = 1, .reusable = false}, SHIFT(4915),
  [7832] = {.count = 1, .reusable = false}, SHIFT(4916),
  [7834] = {.count = 1, .reusable = false}, SHIFT(4917),
  [7836] = {.count = 1, .reusable = true}, SHIFT(4918),
  [7838] = {.count = 1, .reusable = false}, SHIFT(4919),
  [7840] = {.count = 1, .reusable = true}, SHIFT(4919),
  [7842] = {.count = 1, .reusable = true}, SHIFT(4920),
  [7844] = {.count = 1, .reusable = true}, SHIFT(4921),
  [7846] = {.count = 1, .reusable = true}, SHIFT(4922),
  [7848] = {.count = 1, .reusable = false}, SHIFT(4921),
  [7850] = {.count = 1, .reusable = true}, SHIFT(4917),
  [7852] = {.count = 1, .reusable = true}, SHIFT(4915),
  [7854] = {.count = 1, .reusable = true}, SHIFT(4923),
  [7856] = {.count = 1, .reusable = false}, SHIFT(4923),
  [7858] = {.count = 1, .reusable = true}, SHIFT(4924),
  [7860] = {.count = 1, .reusable = true}, SHIFT(4929),
  [7862] = {.count = 1, .reusable = false}, SHIFT(4931),
  [7864] = {.count = 1, .reusable = true}, SHIFT(4933),
  [7866] = {.count = 1, .reusable = false}, SHIFT(4929),
  [7868] = {.count = 1, .reusable = true}, SHIFT(4948),
  [7870] = {.count = 1, .reusable = false}, SHIFT(4950),
  [7872] = {.count = 1, .reusable = true}, SHIFT(4952),
  [7874] = {.count = 1, .reusable = false}, SHIFT(4948),
  [7876] = {.count = 1, .reusable = true}, REDUCE(sym__argument_list_with_parens, 3),
  [7878] = {.count = 1, .reusable = false}, REDUCE(sym__argument_list_with_parens, 3),
  [7880] = {.count = 1, .reusable = true}, SHIFT(4955),
  [7882] = {.count = 1, .reusable = true}, SHIFT(4957),
  [7884] = {.count = 1, .reusable = false}, REDUCE(sym_pair, 3, .alias_sequence_id = 18),
  [7886] = {.count = 1, .reusable = true}, SHIFT(4962),
  [7888] = {.count = 1, .reusable = false}, REDUCE(sym_range, 3),
  [7890] = {.count = 1, .reusable = true}, SHIFT(4963),
  [7892] = {.count = 1, .reusable = true}, SHIFT(4965),
  [7894] = {.count = 1, .reusable = true}, SHIFT(4966),
  [7896] = {.count = 1, .reusable = true}, SHIFT(4968),
  [7898] = {.count = 1, .reusable = true}, SHIFT(4970),
  [7900] = {.count = 1, .reusable = true}, SHIFT(4972),
  [7902] = {.count = 1, .reusable = false}, SHIFT(4970),
  [7904] = {.count = 1, .reusable = true}, SHIFT(4974),
  [7906] = {.count = 1, .reusable = true}, SHIFT(4977),
  [7908] = {.count = 1, .reusable = true}, SHIFT(4976),
  [7910] = {.count = 1, .reusable = true}, SHIFT(933),
  [7912] = {.count = 1, .reusable = true}, SHIFT(4983),
  [7914] = {.count = 1, .reusable = true}, REDUCE(aux_sym_call_repeat1, 2),
  [7916] = {.count = 2, .reusable = true}, REDUCE(aux_sym_call_repeat1, 2), SHIFT_REPEAT(943),
  [7919] = {.count = 1, .reusable = false}, REDUCE(aux_sym_call_repeat1, 2),
  [7921] = {.count = 1, .reusable = true}, SHIFT(4985),
  [7923] = {.count = 1, .reusable = true}, SHIFT(4984),
  [7925] = {.count = 1, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2),
  [7927] = {.count = 1, .reusable = false}, REDUCE(aux_sym_argument_list_repeat1, 2),
  [7929] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list, 3),
  [7931] = {.count = 1, .reusable = false}, REDUCE(sym_argument_list, 3),
  [7933] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(945),
  [7936] = {.count = 1, .reusable = false}, REDUCE(sym__arg_or_splat_arg, 1),
  [7938] = {.count = 1, .reusable = false}, REDUCE(sym_operator_assignment, 3),
  [7940] = {.count = 1, .reusable = true}, SHIFT(4993),
  [7942] = {.count = 1, .reusable = true}, SHIFT(4994),
  [7944] = {.count = 1, .reusable = false}, SHIFT(4995),
  [7946] = {.count = 1, .reusable = false}, SHIFT(4996),
  [7948] = {.count = 1, .reusable = false}, SHIFT(4997),
  [7950] = {.count = 1, .reusable = true}, SHIFT(4998),
  [7952] = {.count = 1, .reusable = false}, SHIFT(4999),
  [7954] = {.count = 1, .reusable = true}, SHIFT(4999),
  [7956] = {.count = 1, .reusable = true}, SHIFT(5001),
  [7958] = {.count = 1, .reusable = true}, SHIFT(5002),
  [7960] = {.count = 1, .reusable = false}, SHIFT(5001),
  [7962] = {.count = 1, .reusable = true}, SHIFT(4997),
  [7964] = {.count = 1, .reusable = true}, SHIFT(4995),
  [7966] = {.count = 1, .reusable = true}, SHIFT(5003),
  [7968] = {.count = 1, .reusable = false}, SHIFT(5003),
  [7970] = {.count = 1, .reusable = true}, SHIFT(5004),
  [7972] = {.count = 1, .reusable = true}, SHIFT(5009),
  [7974] = {.count = 1, .reusable = false}, SHIFT(5011),
  [7976] = {.count = 1, .reusable = true}, SHIFT(5013),
  [7978] = {.count = 1, .reusable = false}, SHIFT(5009),
  [7980] = {.count = 1, .reusable = true}, SHIFT(5028),
  [7982] = {.count = 1, .reusable = false}, SHIFT(5030),
  [7984] = {.count = 1, .reusable = true}, SHIFT(5032),
  [7986] = {.count = 1, .reusable = false}, SHIFT(5028),
  [7988] = {.count = 1, .reusable = true}, SHIFT(955),
  [7990] = {.count = 1, .reusable = true}, SHIFT(5044),
  [7992] = {.count = 1, .reusable = true}, SHIFT(5045),
  [7994] = {.count = 1, .reusable = true}, SHIFT(5046),
  [7996] = {.count = 1, .reusable = true}, SHIFT(5047),
  [7998] = {.count = 1, .reusable = false}, SHIFT(5049),
  [8000] = {.count = 1, .reusable = false}, SHIFT(5050),
  [8002] = {.count = 1, .reusable = false}, SHIFT(5051),
  [8004] = {.count = 1, .reusable = false}, SHIFT(5052),
  [8006] = {.count = 1, .reusable = true}, SHIFT(5053),
  [8008] = {.count = 1, .reusable = false}, SHIFT(5053),
  [8010] = {.count = 1, .reusable = false}, SHIFT(5054),
  [8012] = {.count = 1, .reusable = true}, SHIFT(5054),
  [8014] = {.count = 1, .reusable = false}, SHIFT(5055),
  [8016] = {.count = 1, .reusable = true}, SHIFT(5057),
  [8018] = {.count = 1, .reusable = false}, SHIFT(5057),
  [8020] = {.count = 1, .reusable = true}, SHIFT(5064),
  [8022] = {.count = 1, .reusable = true}, REDUCE(sym_then, 2),
  [8024] = {.count = 1, .reusable = true}, SHIFT(5065),
  [8026] = {.count = 1, .reusable = true}, SHIFT(5066),
  [8028] = {.count = 1, .reusable = true}, SHIFT(5067),
  [8030] = {.count = 1, .reusable = true}, SHIFT(5068),
  [8032] = {.count = 1, .reusable = true}, SHIFT(5069),
  [8034] = {.count = 1, .reusable = true}, SHIFT(5070),
  [8036] = {.count = 1, .reusable = true}, SHIFT(5071),
  [8038] = {.count = 1, .reusable = false}, SHIFT(5072),
  [8040] = {.count = 1, .reusable = false}, SHIFT(5073),
  [8042] = {.count = 1, .reusable = false}, SHIFT(5074),
  [8044] = {.count = 1, .reusable = true}, SHIFT(5075),
  [8046] = {.count = 1, .reusable = false}, SHIFT(5076),
  [8048] = {.count = 1, .reusable = true}, SHIFT(5076),
  [8050] = {.count = 1, .reusable = true}, SHIFT(5077),
  [8052] = {.count = 1, .reusable = true}, SHIFT(5078),
  [8054] = {.count = 1, .reusable = true}, SHIFT(5079),
  [8056] = {.count = 1, .reusable = false}, SHIFT(5078),
  [8058] = {.count = 1, .reusable = true}, SHIFT(5074),
  [8060] = {.count = 1, .reusable = true}, SHIFT(5072),
  [8062] = {.count = 1, .reusable = true}, SHIFT(5080),
  [8064] = {.count = 1, .reusable = true}, SHIFT(5081),
  [8066] = {.count = 1, .reusable = true}, SHIFT(5082),
  [8068] = {.count = 1, .reusable = true}, SHIFT(5083),
  [8070] = {.count = 1, .reusable = false}, SHIFT(5085),
  [8072] = {.count = 1, .reusable = false}, SHIFT(5086),
  [8074] = {.count = 1, .reusable = false}, SHIFT(5087),
  [8076] = {.count = 1, .reusable = false}, SHIFT(5088),
  [8078] = {.count = 1, .reusable = true}, SHIFT(5089),
  [8080] = {.count = 1, .reusable = false}, SHIFT(5089),
  [8082] = {.count = 1, .reusable = false}, SHIFT(5090),
  [8084] = {.count = 1, .reusable = true}, SHIFT(5090),
  [8086] = {.count = 1, .reusable = false}, SHIFT(5091),
  [8088] = {.count = 1, .reusable = true}, SHIFT(5093),
  [8090] = {.count = 1, .reusable = false}, SHIFT(5093),
  [8092] = {.count = 1, .reusable = true}, SHIFT(5099),
  [8094] = {.count = 1, .reusable = false}, SHIFT(5099),
  [8096] = {.count = 1, .reusable = true}, SHIFT(5100),
  [8098] = {.count = 1, .reusable = true}, REDUCE(sym_if, 4),
  [8100] = {.count = 1, .reusable = false}, REDUCE(sym_if, 4),
  [8102] = {.count = 1, .reusable = true}, SHIFT(5105),
  [8104] = {.count = 1, .reusable = false}, REDUCE(sym_then, 2),
  [8106] = {.count = 1, .reusable = true}, SHIFT(5107),
  [8108] = {.count = 1, .reusable = true}, SHIFT(5110),
  [8110] = {.count = 1, .reusable = true}, SHIFT(5111),
  [8112] = {.count = 1, .reusable = false}, SHIFT(5112),
  [8114] = {.count = 1, .reusable = false}, SHIFT(5111),
  [8116] = {.count = 1, .reusable = false}, SHIFT(5113),
  [8118] = {.count = 1, .reusable = false}, SHIFT(5114),
  [8120] = {.count = 1, .reusable = true}, SHIFT(5115),
  [8122] = {.count = 1, .reusable = false}, SHIFT(5116),
  [8124] = {.count = 1, .reusable = true}, SHIFT(5116),
  [8126] = {.count = 1, .reusable = false}, SHIFT(5118),
  [8128] = {.count = 1, .reusable = false}, SHIFT(5119),
  [8130] = {.count = 1, .reusable = true}, SHIFT(5118),
  [8132] = {.count = 1, .reusable = true}, SHIFT(5114),
  [8134] = {.count = 1, .reusable = false}, SHIFT(5110),
  [8136] = {.count = 1, .reusable = true}, SHIFT(5120),
  [8138] = {.count = 1, .reusable = false}, SHIFT(5120),
  [8140] = {.count = 1, .reusable = true}, SHIFT(5121),
  [8142] = {.count = 1, .reusable = true}, SHIFT(994),
  [8144] = {.count = 1, .reusable = true}, SHIFT(5146),
  [8146] = {.count = 1, .reusable = true}, SHIFT(5147),
  [8148] = {.count = 1, .reusable = false}, SHIFT(5148),
  [8150] = {.count = 1, .reusable = false}, SHIFT(5149),
  [8152] = {.count = 1, .reusable = false}, SHIFT(5150),
  [8154] = {.count = 1, .reusable = true}, SHIFT(5151),
  [8156] = {.count = 1, .reusable = false}, SHIFT(5152),
  [8158] = {.count = 1, .reusable = true}, SHIFT(5152),
  [8160] = {.count = 1, .reusable = true}, SHIFT(5154),
  [8162] = {.count = 1, .reusable = true}, SHIFT(5155),
  [8164] = {.count = 1, .reusable = false}, SHIFT(5154),
  [8166] = {.count = 1, .reusable = true}, SHIFT(5150),
  [8168] = {.count = 1, .reusable = true}, SHIFT(5148),
  [8170] = {.count = 1, .reusable = true}, SHIFT(5156),
  [8172] = {.count = 1, .reusable = true}, SHIFT(5158),
  [8174] = {.count = 1, .reusable = false}, SHIFT(5158),
  [8176] = {.count = 1, .reusable = true}, SHIFT(5159),
  [8178] = {.count = 1, .reusable = true}, SHIFT(5161),
  [8180] = {.count = 1, .reusable = true}, SHIFT(5162),
  [8182] = {.count = 1, .reusable = true}, SHIFT(5163),
  [8184] = {.count = 1, .reusable = true}, SHIFT(5164),
  [8186] = {.count = 1, .reusable = false}, SHIFT(5166),
  [8188] = {.count = 1, .reusable = false}, SHIFT(5167),
  [8190] = {.count = 1, .reusable = false}, SHIFT(5168),
  [8192] = {.count = 1, .reusable = false}, SHIFT(5169),
  [8194] = {.count = 1, .reusable = true}, SHIFT(5170),
  [8196] = {.count = 1, .reusable = false}, SHIFT(5170),
  [8198] = {.count = 1, .reusable = false}, SHIFT(5171),
  [8200] = {.count = 1, .reusable = true}, SHIFT(5171),
  [8202] = {.count = 1, .reusable = false}, SHIFT(5172),
  [8204] = {.count = 1, .reusable = true}, SHIFT(5174),
  [8206] = {.count = 1, .reusable = false}, SHIFT(5174),
  [8208] = {.count = 1, .reusable = true}, SHIFT(5181),
  [8210] = {.count = 1, .reusable = true}, SHIFT(5182),
  [8212] = {.count = 1, .reusable = true}, SHIFT(5183),
  [8214] = {.count = 1, .reusable = true}, SHIFT(5184),
  [8216] = {.count = 1, .reusable = true}, SHIFT(5185),
  [8218] = {.count = 1, .reusable = true}, SHIFT(5186),
  [8220] = {.count = 1, .reusable = true}, SHIFT(5187),
  [8222] = {.count = 1, .reusable = true}, SHIFT(5188),
  [8224] = {.count = 1, .reusable = false}, SHIFT(5189),
  [8226] = {.count = 1, .reusable = false}, SHIFT(5190),
  [8228] = {.count = 1, .reusable = false}, SHIFT(5191),
  [8230] = {.count = 1, .reusable = true}, SHIFT(5192),
  [8232] = {.count = 1, .reusable = false}, SHIFT(5193),
  [8234] = {.count = 1, .reusable = true}, SHIFT(5193),
  [8236] = {.count = 1, .reusable = true}, SHIFT(5194),
  [8238] = {.count = 1, .reusable = true}, SHIFT(5195),
  [8240] = {.count = 1, .reusable = true}, SHIFT(5196),
  [8242] = {.count = 1, .reusable = false}, SHIFT(5195),
  [8244] = {.count = 1, .reusable = true}, SHIFT(5191),
  [8246] = {.count = 1, .reusable = true}, SHIFT(5189),
  [8248] = {.count = 1, .reusable = true}, SHIFT(5197),
  [8250] = {.count = 1, .reusable = true}, SHIFT(5198),
  [8252] = {.count = 1, .reusable = true}, SHIFT(5199),
  [8254] = {.count = 1, .reusable = true}, SHIFT(5200),
  [8256] = {.count = 1, .reusable = false}, SHIFT(5202),
  [8258] = {.count = 1, .reusable = false}, SHIFT(5203),
  [8260] = {.count = 1, .reusable = false}, SHIFT(5204),
  [8262] = {.count = 1, .reusable = false}, SHIFT(5205),
  [8264] = {.count = 1, .reusable = true}, SHIFT(5206),
  [8266] = {.count = 1, .reusable = false}, SHIFT(5206),
  [8268] = {.count = 1, .reusable = false}, SHIFT(5207),
  [8270] = {.count = 1, .reusable = true}, SHIFT(5207),
  [8272] = {.count = 1, .reusable = false}, SHIFT(5208),
  [8274] = {.count = 1, .reusable = true}, SHIFT(5210),
  [8276] = {.count = 1, .reusable = false}, SHIFT(5210),
  [8278] = {.count = 1, .reusable = true}, SHIFT(5216),
  [8280] = {.count = 1, .reusable = false}, SHIFT(5216),
  [8282] = {.count = 1, .reusable = true}, SHIFT(5217),
  [8284] = {.count = 1, .reusable = true}, REDUCE(sym_unless, 4),
  [8286] = {.count = 1, .reusable = false}, REDUCE(sym_unless, 4),
  [8288] = {.count = 1, .reusable = true}, SHIFT(5221),
  [8290] = {.count = 1, .reusable = true}, SHIFT(5226),
  [8292] = {.count = 1, .reusable = true}, SHIFT(5227),
  [8294] = {.count = 1, .reusable = false}, SHIFT(5228),
  [8296] = {.count = 1, .reusable = false}, SHIFT(5229),
  [8298] = {.count = 1, .reusable = false}, SHIFT(5230),
  [8300] = {.count = 1, .reusable = true}, SHIFT(5231),
  [8302] = {.count = 1, .reusable = false}, SHIFT(5232),
  [8304] = {.count = 1, .reusable = true}, SHIFT(5232),
  [8306] = {.count = 1, .reusable = true}, SHIFT(5234),
  [8308] = {.count = 1, .reusable = true}, SHIFT(5235),
  [8310] = {.count = 1, .reusable = false}, SHIFT(5234),
  [8312] = {.count = 1, .reusable = true}, SHIFT(5230),
  [8314] = {.count = 1, .reusable = true}, SHIFT(5228),
  [8316] = {.count = 1, .reusable = true}, SHIFT(5236),
  [8318] = {.count = 1, .reusable = false}, SHIFT(5236),
  [8320] = {.count = 1, .reusable = true}, SHIFT(5237),
  [8322] = {.count = 1, .reusable = true}, SHIFT(5242),
  [8324] = {.count = 1, .reusable = false}, SHIFT(5244),
  [8326] = {.count = 1, .reusable = true}, SHIFT(5246),
  [8328] = {.count = 1, .reusable = false}, SHIFT(5242),
  [8330] = {.count = 1, .reusable = true}, SHIFT(5261),
  [8332] = {.count = 1, .reusable = true}, SHIFT(5262),
  [8334] = {.count = 1, .reusable = false}, SHIFT(5264),
  [8336] = {.count = 1, .reusable = true}, SHIFT(5266),
  [8338] = {.count = 1, .reusable = false}, SHIFT(5261),
  [8340] = {.count = 1, .reusable = true}, SHIFT(1020),
  [8342] = {.count = 1, .reusable = true}, SHIFT(5276),
  [8344] = {.count = 1, .reusable = true}, REDUCE(sym_while, 4),
  [8346] = {.count = 1, .reusable = false}, REDUCE(sym_while, 4),
  [8348] = {.count = 1, .reusable = true}, SHIFT(5277),
  [8350] = {.count = 1, .reusable = true}, SHIFT(5280),
  [8352] = {.count = 1, .reusable = true}, SHIFT(5281),
  [8354] = {.count = 1, .reusable = false}, SHIFT(5282),
  [8356] = {.count = 1, .reusable = false}, SHIFT(5281),
  [8358] = {.count = 1, .reusable = false}, SHIFT(5283),
  [8360] = {.count = 1, .reusable = false}, SHIFT(5284),
  [8362] = {.count = 1, .reusable = true}, SHIFT(5285),
  [8364] = {.count = 1, .reusable = false}, SHIFT(5286),
  [8366] = {.count = 1, .reusable = true}, SHIFT(5286),
  [8368] = {.count = 1, .reusable = false}, SHIFT(5288),
  [8370] = {.count = 1, .reusable = false}, SHIFT(5289),
  [8372] = {.count = 1, .reusable = true}, SHIFT(5288),
  [8374] = {.count = 1, .reusable = true}, SHIFT(5284),
  [8376] = {.count = 1, .reusable = false}, SHIFT(5280),
  [8378] = {.count = 1, .reusable = true}, SHIFT(5290),
  [8380] = {.count = 1, .reusable = false}, SHIFT(5290),
  [8382] = {.count = 1, .reusable = true}, SHIFT(5291),
  [8384] = {.count = 1, .reusable = true}, SHIFT(1052),
  [8386] = {.count = 1, .reusable = true}, SHIFT(5316),
  [8388] = {.count = 1, .reusable = true}, SHIFT(5317),
  [8390] = {.count = 1, .reusable = false}, SHIFT(5318),
  [8392] = {.count = 1, .reusable = false}, SHIFT(5319),
  [8394] = {.count = 1, .reusable = false}, SHIFT(5320),
  [8396] = {.count = 1, .reusable = true}, SHIFT(5321),
  [8398] = {.count = 1, .reusable = false}, SHIFT(5322),
  [8400] = {.count = 1, .reusable = true}, SHIFT(5322),
  [8402] = {.count = 1, .reusable = true}, SHIFT(5324),
  [8404] = {.count = 1, .reusable = true}, SHIFT(5325),
  [8406] = {.count = 1, .reusable = false}, SHIFT(5324),
  [8408] = {.count = 1, .reusable = true}, SHIFT(5320),
  [8410] = {.count = 1, .reusable = true}, SHIFT(5318),
  [8412] = {.count = 1, .reusable = true}, SHIFT(5326),
  [8414] = {.count = 1, .reusable = true}, SHIFT(5328),
  [8416] = {.count = 1, .reusable = false}, SHIFT(5328),
  [8418] = {.count = 1, .reusable = true}, SHIFT(5329),
  [8420] = {.count = 1, .reusable = true}, REDUCE(sym_until, 4),
  [8422] = {.count = 1, .reusable = false}, REDUCE(sym_until, 4),
  [8424] = {.count = 1, .reusable = true}, SHIFT(5330),
  [8426] = {.count = 1, .reusable = true}, SHIFT(5332),
  [8428] = {.count = 1, .reusable = true}, SHIFT(5333),
  [8430] = {.count = 1, .reusable = true}, SHIFT(5334),
  [8432] = {.count = 1, .reusable = false}, SHIFT(5336),
  [8434] = {.count = 1, .reusable = true}, SHIFT(5342),
  [8436] = {.count = 1, .reusable = true}, SHIFT(5343),
  [8438] = {.count = 1, .reusable = false}, SHIFT(5344),
  [8440] = {.count = 1, .reusable = false}, SHIFT(5345),
  [8442] = {.count = 1, .reusable = false}, SHIFT(5346),
  [8444] = {.count = 1, .reusable = true}, SHIFT(5347),
  [8446] = {.count = 1, .reusable = false}, SHIFT(5348),
  [8448] = {.count = 1, .reusable = true}, SHIFT(5348),
  [8450] = {.count = 1, .reusable = true}, SHIFT(5349),
  [8452] = {.count = 1, .reusable = true}, SHIFT(5350),
  [8454] = {.count = 1, .reusable = true}, SHIFT(5351),
  [8456] = {.count = 1, .reusable = false}, SHIFT(5350),
  [8458] = {.count = 1, .reusable = true}, SHIFT(5346),
  [8460] = {.count = 1, .reusable = true}, SHIFT(5344),
  [8462] = {.count = 1, .reusable = true}, SHIFT(5352),
  [8464] = {.count = 1, .reusable = true}, SHIFT(5353),
  [8466] = {.count = 1, .reusable = true}, SHIFT(5354),
  [8468] = {.count = 1, .reusable = false}, SHIFT(5356),
  [8470] = {.count = 1, .reusable = true}, SHIFT(5361),
  [8472] = {.count = 1, .reusable = false}, SHIFT(5361),
  [8474] = {.count = 1, .reusable = true}, SHIFT(5362),
  [8476] = {.count = 1, .reusable = true}, SHIFT(5367),
  [8478] = {.count = 1, .reusable = false}, SHIFT(5369),
  [8480] = {.count = 1, .reusable = true}, SHIFT(5371),
  [8482] = {.count = 1, .reusable = false}, SHIFT(5367),
  [8484] = {.count = 1, .reusable = false}, SHIFT(2878),
  [8486] = {.count = 1, .reusable = true}, SHIFT(5388),
  [8488] = {.count = 1, .reusable = false}, SHIFT(5391),
  [8490] = {.count = 1, .reusable = true}, SHIFT(5392),
  [8492] = {.count = 1, .reusable = true}, SHIFT(5393),
  [8494] = {.count = 1, .reusable = false}, SHIFT(5394),
  [8496] = {.count = 1, .reusable = false}, SHIFT(5393),
  [8498] = {.count = 1, .reusable = false}, SHIFT(5395),
  [8500] = {.count = 1, .reusable = false}, SHIFT(5396),
  [8502] = {.count = 1, .reusable = true}, SHIFT(5397),
  [8504] = {.count = 1, .reusable = false}, SHIFT(5398),
  [8506] = {.count = 1, .reusable = true}, SHIFT(5398),
  [8508] = {.count = 1, .reusable = false}, SHIFT(5400),
  [8510] = {.count = 1, .reusable = false}, SHIFT(5401),
  [8512] = {.count = 1, .reusable = true}, SHIFT(5400),
  [8514] = {.count = 1, .reusable = true}, SHIFT(5396),
  [8516] = {.count = 1, .reusable = false}, SHIFT(5392),
  [8518] = {.count = 1, .reusable = true}, SHIFT(5403),
  [8520] = {.count = 1, .reusable = true}, SHIFT(5405),
  [8522] = {.count = 1, .reusable = false}, SHIFT(5405),
  [8524] = {.count = 1, .reusable = true}, SHIFT(5406),
  [8526] = {.count = 1, .reusable = false}, SHIFT(5388),
  [8528] = {.count = 1, .reusable = true}, REDUCE(sym_in, 2),
  [8530] = {.count = 1, .reusable = false}, SHIFT(5416),
  [8532] = {.count = 1, .reusable = false}, REDUCE(sym__mlhs, 3),
  [8534] = {.count = 2, .reusable = true}, REDUCE(aux_sym__mlhs_repeat1, 2), SHIFT_REPEAT(5418),
  [8537] = {.count = 1, .reusable = true}, SHIFT(5423),
  [8539] = {.count = 1, .reusable = true}, SHIFT(5424),
  [8541] = {.count = 1, .reusable = false}, SHIFT(5425),
  [8543] = {.count = 1, .reusable = false}, SHIFT(5426),
  [8545] = {.count = 1, .reusable = false}, SHIFT(5427),
  [8547] = {.count = 1, .reusable = true}, SHIFT(5428),
  [8549] = {.count = 1, .reusable = false}, SHIFT(5429),
  [8551] = {.count = 1, .reusable = true}, SHIFT(5429),
  [8553] = {.count = 1, .reusable = true}, SHIFT(5431),
  [8555] = {.count = 1, .reusable = true}, SHIFT(5432),
  [8557] = {.count = 1, .reusable = false}, SHIFT(5431),
  [8559] = {.count = 1, .reusable = true}, SHIFT(5427),
  [8561] = {.count = 1, .reusable = true}, SHIFT(5425),
  [8563] = {.count = 1, .reusable = true}, SHIFT(5433),
  [8565] = {.count = 1, .reusable = false}, SHIFT(5433),
  [8567] = {.count = 1, .reusable = true}, SHIFT(5434),
  [8569] = {.count = 1, .reusable = true}, SHIFT(5439),
  [8571] = {.count = 1, .reusable = false}, SHIFT(5441),
  [8573] = {.count = 1, .reusable = true}, SHIFT(5443),
  [8575] = {.count = 1, .reusable = false}, SHIFT(5439),
  [8577] = {.count = 1, .reusable = true}, SHIFT(1100),
  [8579] = {.count = 1, .reusable = true}, SHIFT(5464),
  [8581] = {.count = 1, .reusable = true}, REDUCE(sym_case, 4),
  [8583] = {.count = 1, .reusable = false}, REDUCE(sym_case, 4),
  [8585] = {.count = 1, .reusable = true}, SHIFT(5465),
  [8587] = {.count = 1, .reusable = true}, SHIFT(5471),
  [8589] = {.count = 1, .reusable = true}, SHIFT(5472),
  [8591] = {.count = 1, .reusable = false}, SHIFT(5473),
  [8593] = {.count = 1, .reusable = false}, SHIFT(5474),
  [8595] = {.count = 1, .reusable = false}, SHIFT(5475),
  [8597] = {.count = 1, .reusable = true}, SHIFT(5476),
  [8599] = {.count = 1, .reusable = false}, SHIFT(5477),
  [8601] = {.count = 1, .reusable = true}, SHIFT(5477),
  [8603] = {.count = 1, .reusable = true}, SHIFT(5479),
  [8605] = {.count = 1, .reusable = true}, SHIFT(5480),
  [8607] = {.count = 1, .reusable = false}, SHIFT(5479),
  [8609] = {.count = 1, .reusable = true}, SHIFT(5475),
  [8611] = {.count = 1, .reusable = true}, SHIFT(5473),
  [8613] = {.count = 1, .reusable = true}, SHIFT(5481),
  [8615] = {.count = 1, .reusable = true}, SHIFT(5483),
  [8617] = {.count = 1, .reusable = false}, SHIFT(5483),
  [8619] = {.count = 1, .reusable = true}, SHIFT(5484),
  [8621] = {.count = 1, .reusable = true}, SHIFT(5487),
  [8623] = {.count = 1, .reusable = true}, SHIFT(5488),
  [8625] = {.count = 1, .reusable = true}, SHIFT(5489),
  [8627] = {.count = 1, .reusable = false}, SHIFT(5491),
  [8629] = {.count = 1, .reusable = true}, SHIFT(5500),
  [8631] = {.count = 1, .reusable = true}, SHIFT(5497),
  [8633] = {.count = 1, .reusable = true}, SHIFT(5498),
  [8635] = {.count = 1, .reusable = true}, REDUCE(sym_pattern, 1),
  [8637] = {.count = 1, .reusable = true}, SHIFT(5502),
  [8639] = {.count = 1, .reusable = true}, SHIFT(5503),
  [8641] = {.count = 1, .reusable = false}, SHIFT(5504),
  [8643] = {.count = 1, .reusable = false}, SHIFT(5505),
  [8645] = {.count = 1, .reusable = false}, SHIFT(5506),
  [8647] = {.count = 1, .reusable = true}, SHIFT(5507),
  [8649] = {.count = 1, .reusable = false}, SHIFT(5508),
  [8651] = {.count = 1, .reusable = true}, SHIFT(5508),
  [8653] = {.count = 1, .reusable = true}, SHIFT(5509),
  [8655] = {.count = 1, .reusable = true}, SHIFT(5510),
  [8657] = {.count = 1, .reusable = true}, SHIFT(5511),
  [8659] = {.count = 1, .reusable = false}, SHIFT(5510),
  [8661] = {.count = 1, .reusable = true}, SHIFT(5506),
  [8663] = {.count = 1, .reusable = true}, SHIFT(5504),
  [8665] = {.count = 1, .reusable = true}, SHIFT(5512),
  [8667] = {.count = 1, .reusable = true}, SHIFT(5513),
  [8669] = {.count = 1, .reusable = true}, SHIFT(5514),
  [8671] = {.count = 1, .reusable = false}, SHIFT(5516),
  [8673] = {.count = 1, .reusable = true}, SHIFT(5521),
  [8675] = {.count = 1, .reusable = false}, SHIFT(5521),
  [8677] = {.count = 1, .reusable = true}, SHIFT(5522),
  [8679] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_repeat1, 2), SHIFT_REPEAT(2987),
  [8682] = {.count = 1, .reusable = true}, REDUCE(aux_sym_case_repeat1, 2),
  [8684] = {.count = 1, .reusable = true}, REDUCE(aux_sym_case_repeat2, 2),
  [8686] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_repeat2, 2), SHIFT_REPEAT(1131),
  [8689] = {.count = 1, .reusable = false}, REDUCE(sym_heredoc_body, 3),
  [8691] = {.count = 1, .reusable = true}, SHIFT(5528),
  [8693] = {.count = 1, .reusable = true}, SHIFT(5529),
  [8695] = {.count = 1, .reusable = false}, SHIFT(5530),
  [8697] = {.count = 1, .reusable = false}, SHIFT(5531),
  [8699] = {.count = 1, .reusable = false}, SHIFT(5532),
  [8701] = {.count = 1, .reusable = true}, SHIFT(5533),
  [8703] = {.count = 1, .reusable = false}, SHIFT(5534),
  [8705] = {.count = 1, .reusable = true}, SHIFT(5534),
  [8707] = {.count = 1, .reusable = true}, SHIFT(5536),
  [8709] = {.count = 1, .reusable = true}, SHIFT(5537),
  [8711] = {.count = 1, .reusable = false}, SHIFT(5536),
  [8713] = {.count = 1, .reusable = true}, SHIFT(5532),
  [8715] = {.count = 1, .reusable = true}, SHIFT(5530),
  [8717] = {.count = 1, .reusable = true}, SHIFT(5538),
  [8719] = {.count = 1, .reusable = false}, SHIFT(5538),
  [8721] = {.count = 1, .reusable = true}, SHIFT(5539),
  [8723] = {.count = 1, .reusable = true}, SHIFT(5544),
  [8725] = {.count = 1, .reusable = false}, SHIFT(5546),
  [8727] = {.count = 1, .reusable = true}, SHIFT(5548),
  [8729] = {.count = 1, .reusable = false}, SHIFT(5544),
  [8731] = {.count = 1, .reusable = true}, SHIFT(5563),
  [8733] = {.count = 1, .reusable = false}, SHIFT(5565),
  [8735] = {.count = 1, .reusable = true}, SHIFT(5567),
  [8737] = {.count = 1, .reusable = false}, SHIFT(5563),
  [8739] = {.count = 1, .reusable = true}, SHIFT(1143),
  [8741] = {.count = 1, .reusable = false}, SHIFT(3046),
  [8743] = {.count = 1, .reusable = true}, SHIFT(5580),
  [8745] = {.count = 1, .reusable = false}, SHIFT(5583),
  [8747] = {.count = 1, .reusable = true}, SHIFT(5584),
  [8749] = {.count = 1, .reusable = true}, SHIFT(5585),
  [8751] = {.count = 1, .reusable = false}, SHIFT(5586),
  [8753] = {.count = 1, .reusable = false}, SHIFT(5587),
  [8755] = {.count = 1, .reusable = false}, SHIFT(5588),
  [8757] = {.count = 1, .reusable = true}, SHIFT(5589),
  [8759] = {.count = 1, .reusable = false}, SHIFT(5590),
  [8761] = {.count = 1, .reusable = true}, SHIFT(5590),
  [8763] = {.count = 1, .reusable = true}, SHIFT(5592),
  [8765] = {.count = 1, .reusable = true}, SHIFT(5593),
  [8767] = {.count = 1, .reusable = false}, SHIFT(5592),
  [8769] = {.count = 1, .reusable = true}, SHIFT(5588),
  [8771] = {.count = 1, .reusable = true}, SHIFT(5586),
  [8773] = {.count = 1, .reusable = true}, SHIFT(5595),
  [8775] = {.count = 1, .reusable = true}, SHIFT(5597),
  [8777] = {.count = 1, .reusable = false}, SHIFT(5597),
  [8779] = {.count = 1, .reusable = true}, SHIFT(5598),
  [8781] = {.count = 1, .reusable = false}, SHIFT(5580),
  [8783] = {.count = 1, .reusable = true}, SHIFT(5599),
  [8785] = {.count = 1, .reusable = true}, SHIFT(5600),
  [8787] = {.count = 1, .reusable = true}, SHIFT(5601),
  [8789] = {.count = 1, .reusable = true}, SHIFT(5602),
  [8791] = {.count = 1, .reusable = true}, SHIFT(5603),
  [8793] = {.count = 1, .reusable = true}, SHIFT(5604),
  [8795] = {.count = 1, .reusable = true}, SHIFT(5605),
  [8797] = {.count = 1, .reusable = true}, SHIFT(5606),
  [8799] = {.count = 1, .reusable = false}, SHIFT(5607),
  [8801] = {.count = 1, .reusable = false}, SHIFT(5608),
  [8803] = {.count = 1, .reusable = false}, SHIFT(5609),
  [8805] = {.count = 1, .reusable = false}, SHIFT(5610),
  [8807] = {.count = 1, .reusable = true}, SHIFT(5611),
  [8809] = {.count = 1, .reusable = false}, SHIFT(5603),
  [8811] = {.count = 1, .reusable = true}, SHIFT(5612),
  [8813] = {.count = 1, .reusable = false}, SHIFT(5612),
  [8815] = {.count = 1, .reusable = true}, SHIFT(5613),
  [8817] = {.count = 1, .reusable = false}, SHIFT(5614),
  [8819] = {.count = 1, .reusable = true}, REDUCE(sym_exception_variable, 2),
  [8821] = {.count = 1, .reusable = true}, REDUCE(sym_rescue, 3),
  [8823] = {.count = 1, .reusable = true}, SHIFT(5625),
  [8825] = {.count = 1, .reusable = false}, REDUCE(sym_rescue, 3),
  [8827] = {.count = 1, .reusable = false}, SHIFT(3081),
  [8829] = {.count = 1, .reusable = true}, SHIFT(5640),
  [8831] = {.count = 1, .reusable = false}, SHIFT(5643),
  [8833] = {.count = 1, .reusable = true}, SHIFT(5644),
  [8835] = {.count = 1, .reusable = true}, SHIFT(5645),
  [8837] = {.count = 1, .reusable = false}, SHIFT(5646),
  [8839] = {.count = 1, .reusable = false}, SHIFT(5645),
  [8841] = {.count = 1, .reusable = false}, SHIFT(5647),
  [8843] = {.count = 1, .reusable = false}, SHIFT(5648),
  [8845] = {.count = 1, .reusable = true}, SHIFT(5649),
  [8847] = {.count = 1, .reusable = false}, SHIFT(5650),
  [8849] = {.count = 1, .reusable = true}, SHIFT(5650),
  [8851] = {.count = 1, .reusable = false}, SHIFT(5652),
  [8853] = {.count = 1, .reusable = false}, SHIFT(5653),
  [8855] = {.count = 1, .reusable = true}, SHIFT(5652),
  [8857] = {.count = 1, .reusable = true}, SHIFT(5648),
  [8859] = {.count = 1, .reusable = false}, SHIFT(5644),
  [8861] = {.count = 1, .reusable = true}, SHIFT(5655),
  [8863] = {.count = 1, .reusable = true}, SHIFT(5657),
  [8865] = {.count = 1, .reusable = false}, SHIFT(5657),
  [8867] = {.count = 1, .reusable = true}, SHIFT(5658),
  [8869] = {.count = 1, .reusable = false}, SHIFT(5640),
  [8871] = {.count = 1, .reusable = true}, REDUCE(sym_exceptions, 2),
  [8873] = {.count = 1, .reusable = true}, SHIFT(5662),
  [8875] = {.count = 1, .reusable = true}, SHIFT(5667),
  [8877] = {.count = 1, .reusable = false}, SHIFT(5668),
  [8879] = {.count = 1, .reusable = false}, SHIFT(5669),
  [8881] = {.count = 1, .reusable = false}, SHIFT(5670),
  [8883] = {.count = 1, .reusable = false}, SHIFT(5671),
  [8885] = {.count = 1, .reusable = false}, SHIFT(5667),
  [8887] = {.count = 1, .reusable = true}, SHIFT(5672),
  [8889] = {.count = 1, .reusable = false}, SHIFT(5672),
  [8891] = {.count = 1, .reusable = true}, SHIFT(5673),
  [8893] = {.count = 1, .reusable = false}, SHIFT(3107),
  [8895] = {.count = 1, .reusable = true}, SHIFT(5681),
  [8897] = {.count = 1, .reusable = true}, SHIFT(5683),
  [8899] = {.count = 1, .reusable = true}, SHIFT(5684),
  [8901] = {.count = 1, .reusable = true}, SHIFT(5685),
  [8903] = {.count = 1, .reusable = false}, SHIFT(5687),
  [8905] = {.count = 1, .reusable = false}, SHIFT(5693),
  [8907] = {.count = 1, .reusable = true}, SHIFT(5694),
  [8909] = {.count = 1, .reusable = true}, SHIFT(5695),
  [8911] = {.count = 1, .reusable = false}, SHIFT(5696),
  [8913] = {.count = 1, .reusable = false}, SHIFT(5697),
  [8915] = {.count = 1, .reusable = false}, SHIFT(5698),
  [8917] = {.count = 1, .reusable = true}, SHIFT(5699),
  [8919] = {.count = 1, .reusable = false}, SHIFT(5700),
  [8921] = {.count = 1, .reusable = true}, SHIFT(5700),
  [8923] = {.count = 1, .reusable = true}, SHIFT(5702),
  [8925] = {.count = 1, .reusable = true}, SHIFT(5703),
  [8927] = {.count = 1, .reusable = false}, SHIFT(5702),
  [8929] = {.count = 1, .reusable = true}, SHIFT(5698),
  [8931] = {.count = 1, .reusable = true}, SHIFT(5696),
  [8933] = {.count = 1, .reusable = true}, SHIFT(5704),
  [8935] = {.count = 1, .reusable = true}, SHIFT(5705),
  [8937] = {.count = 1, .reusable = true}, SHIFT(5706),
  [8939] = {.count = 1, .reusable = false}, SHIFT(5708),
  [8941] = {.count = 1, .reusable = true}, SHIFT(5714),
  [8943] = {.count = 1, .reusable = true}, SHIFT(5716),
  [8945] = {.count = 1, .reusable = false}, SHIFT(5716),
  [8947] = {.count = 1, .reusable = true}, SHIFT(5717),
  [8949] = {.count = 1, .reusable = false}, SHIFT(5681),
  [8951] = {.count = 1, .reusable = true}, SHIFT(5735),
  [8953] = {.count = 1, .reusable = false}, SHIFT(5736),
  [8955] = {.count = 1, .reusable = false}, SHIFT(5737),
  [8957] = {.count = 1, .reusable = false}, SHIFT(5738),
  [8959] = {.count = 1, .reusable = false}, SHIFT(5739),
  [8961] = {.count = 1, .reusable = false}, SHIFT(5735),
  [8963] = {.count = 1, .reusable = true}, SHIFT(5740),
  [8965] = {.count = 1, .reusable = false}, SHIFT(5740),
  [8967] = {.count = 1, .reusable = true}, SHIFT(5741),
  [8969] = {.count = 1, .reusable = false}, SHIFT(5743),
  [8971] = {.count = 1, .reusable = true}, SHIFT(5743),
  [8973] = {.count = 1, .reusable = false}, SHIFT(3143),
  [8975] = {.count = 1, .reusable = true}, SHIFT(5750),
  [8977] = {.count = 1, .reusable = false}, SHIFT(5753),
  [8979] = {.count = 1, .reusable = true}, SHIFT(5754),
  [8981] = {.count = 1, .reusable = true}, SHIFT(5755),
  [8983] = {.count = 1, .reusable = false}, SHIFT(5756),
  [8985] = {.count = 1, .reusable = false}, SHIFT(5755),
  [8987] = {.count = 1, .reusable = false}, SHIFT(5757),
  [8989] = {.count = 1, .reusable = false}, SHIFT(5758),
  [8991] = {.count = 1, .reusable = true}, SHIFT(5759),
  [8993] = {.count = 1, .reusable = false}, SHIFT(5760),
  [8995] = {.count = 1, .reusable = true}, SHIFT(5760),
  [8997] = {.count = 1, .reusable = false}, SHIFT(5762),
  [8999] = {.count = 1, .reusable = false}, SHIFT(5763),
  [9001] = {.count = 1, .reusable = true}, SHIFT(5762),
  [9003] = {.count = 1, .reusable = true}, SHIFT(5758),
  [9005] = {.count = 1, .reusable = false}, SHIFT(5754),
  [9007] = {.count = 1, .reusable = true}, SHIFT(5765),
  [9009] = {.count = 1, .reusable = true}, SHIFT(5767),
  [9011] = {.count = 1, .reusable = false}, SHIFT(5767),
  [9013] = {.count = 1, .reusable = true}, SHIFT(5768),
  [9015] = {.count = 1, .reusable = false}, SHIFT(5750),
  [9017] = {.count = 1, .reusable = true}, SHIFT(5770),
  [9019] = {.count = 1, .reusable = true}, SHIFT(5771),
  [9021] = {.count = 1, .reusable = false}, SHIFT(5771),
  [9023] = {.count = 1, .reusable = true}, SHIFT(5772),
  [9025] = {.count = 1, .reusable = false}, SHIFT(5772),
  [9027] = {.count = 1, .reusable = true}, SHIFT(5773),
  [9029] = {.count = 1, .reusable = true}, REDUCE(sym_else, 3),
  [9031] = {.count = 1, .reusable = true}, SHIFT(5780),
  [9033] = {.count = 1, .reusable = false}, SHIFT(5781),
  [9035] = {.count = 1, .reusable = false}, SHIFT(5782),
  [9037] = {.count = 1, .reusable = false}, SHIFT(5783),
  [9039] = {.count = 1, .reusable = false}, SHIFT(5784),
  [9041] = {.count = 1, .reusable = false}, SHIFT(5780),
  [9043] = {.count = 1, .reusable = true}, SHIFT(5785),
  [9045] = {.count = 1, .reusable = false}, SHIFT(5785),
  [9047] = {.count = 1, .reusable = true}, SHIFT(5786),
  [9049] = {.count = 1, .reusable = false}, SHIFT(3169),
  [9051] = {.count = 1, .reusable = true}, SHIFT(5794),
  [9053] = {.count = 1, .reusable = true}, SHIFT(5796),
  [9055] = {.count = 1, .reusable = true}, SHIFT(5797),
  [9057] = {.count = 1, .reusable = true}, SHIFT(5798),
  [9059] = {.count = 1, .reusable = false}, SHIFT(5800),
  [9061] = {.count = 1, .reusable = false}, SHIFT(5806),
  [9063] = {.count = 1, .reusable = true}, SHIFT(5807),
  [9065] = {.count = 1, .reusable = true}, SHIFT(5808),
  [9067] = {.count = 1, .reusable = false}, SHIFT(5809),
  [9069] = {.count = 1, .reusable = false}, SHIFT(5810),
  [9071] = {.count = 1, .reusable = false}, SHIFT(5811),
  [9073] = {.count = 1, .reusable = true}, SHIFT(5812),
  [9075] = {.count = 1, .reusable = false}, SHIFT(5813),
  [9077] = {.count = 1, .reusable = true}, SHIFT(5813),
  [9079] = {.count = 1, .reusable = true}, SHIFT(5815),
  [9081] = {.count = 1, .reusable = true}, SHIFT(5816),
  [9083] = {.count = 1, .reusable = false}, SHIFT(5815),
  [9085] = {.count = 1, .reusable = true}, SHIFT(5811),
  [9087] = {.count = 1, .reusable = true}, SHIFT(5809),
  [9089] = {.count = 1, .reusable = true}, SHIFT(5817),
  [9091] = {.count = 1, .reusable = true}, SHIFT(5818),
  [9093] = {.count = 1, .reusable = true}, SHIFT(5819),
  [9095] = {.count = 1, .reusable = false}, SHIFT(5821),
  [9097] = {.count = 1, .reusable = true}, SHIFT(5827),
  [9099] = {.count = 1, .reusable = true}, SHIFT(5829),
  [9101] = {.count = 1, .reusable = false}, SHIFT(5829),
  [9103] = {.count = 1, .reusable = true}, SHIFT(5830),
  [9105] = {.count = 1, .reusable = false}, SHIFT(5794),
  [9107] = {.count = 1, .reusable = true}, SHIFT(5848),
  [9109] = {.count = 1, .reusable = false}, SHIFT(5849),
  [9111] = {.count = 1, .reusable = false}, SHIFT(5850),
  [9113] = {.count = 1, .reusable = false}, SHIFT(5851),
  [9115] = {.count = 1, .reusable = false}, SHIFT(5852),
  [9117] = {.count = 1, .reusable = false}, SHIFT(5848),
  [9119] = {.count = 1, .reusable = true}, SHIFT(5853),
  [9121] = {.count = 1, .reusable = false}, SHIFT(5853),
  [9123] = {.count = 1, .reusable = true}, SHIFT(5854),
  [9125] = {.count = 1, .reusable = false}, SHIFT(5856),
  [9127] = {.count = 1, .reusable = true}, SHIFT(5856),
  [9129] = {.count = 1, .reusable = false}, SHIFT(3205),
  [9131] = {.count = 1, .reusable = true}, SHIFT(5863),
  [9133] = {.count = 1, .reusable = false}, SHIFT(5866),
  [9135] = {.count = 1, .reusable = true}, SHIFT(5867),
  [9137] = {.count = 1, .reusable = true}, SHIFT(5868),
  [9139] = {.count = 1, .reusable = false}, SHIFT(5869),
  [9141] = {.count = 1, .reusable = false}, SHIFT(5868),
  [9143] = {.count = 1, .reusable = false}, SHIFT(5870),
  [9145] = {.count = 1, .reusable = false}, SHIFT(5871),
  [9147] = {.count = 1, .reusable = true}, SHIFT(5872),
  [9149] = {.count = 1, .reusable = false}, SHIFT(5873),
  [9151] = {.count = 1, .reusable = true}, SHIFT(5873),
  [9153] = {.count = 1, .reusable = false}, SHIFT(5875),
  [9155] = {.count = 1, .reusable = false}, SHIFT(5876),
  [9157] = {.count = 1, .reusable = true}, SHIFT(5875),
  [9159] = {.count = 1, .reusable = true}, SHIFT(5871),
  [9161] = {.count = 1, .reusable = false}, SHIFT(5867),
  [9163] = {.count = 1, .reusable = true}, SHIFT(5878),
  [9165] = {.count = 1, .reusable = true}, SHIFT(5880),
  [9167] = {.count = 1, .reusable = false}, SHIFT(5880),
  [9169] = {.count = 1, .reusable = true}, SHIFT(5881),
  [9171] = {.count = 1, .reusable = false}, SHIFT(5863),
  [9173] = {.count = 1, .reusable = true}, SHIFT(5883),
  [9175] = {.count = 1, .reusable = true}, SHIFT(5884),
  [9177] = {.count = 1, .reusable = false}, SHIFT(5884),
  [9179] = {.count = 1, .reusable = true}, SHIFT(5885),
  [9181] = {.count = 1, .reusable = false}, SHIFT(5885),
  [9183] = {.count = 1, .reusable = true}, SHIFT(5886),
  [9185] = {.count = 1, .reusable = true}, REDUCE(sym__body_statement, 3),
  [9187] = {.count = 1, .reusable = false}, REDUCE(sym__body_statement, 3),
  [9189] = {.count = 1, .reusable = true}, SHIFT(5894),
  [9191] = {.count = 1, .reusable = true}, SHIFT(5896),
  [9193] = {.count = 1, .reusable = true}, SHIFT(5899),
  [9195] = {.count = 1, .reusable = true}, SHIFT(5900),
  [9197] = {.count = 1, .reusable = false}, SHIFT(5901),
  [9199] = {.count = 1, .reusable = false}, SHIFT(5900),
  [9201] = {.count = 1, .reusable = false}, SHIFT(5902),
  [9203] = {.count = 1, .reusable = false}, SHIFT(5903),
  [9205] = {.count = 1, .reusable = true}, SHIFT(5904),
  [9207] = {.count = 1, .reusable = false}, SHIFT(5905),
  [9209] = {.count = 1, .reusable = true}, SHIFT(5905),
  [9211] = {.count = 1, .reusable = false}, SHIFT(5907),
  [9213] = {.count = 1, .reusable = false}, SHIFT(5908),
  [9215] = {.count = 1, .reusable = true}, SHIFT(5907),
  [9217] = {.count = 1, .reusable = true}, SHIFT(5903),
  [9219] = {.count = 1, .reusable = false}, SHIFT(5899),
  [9221] = {.count = 1, .reusable = true}, SHIFT(5909),
  [9223] = {.count = 1, .reusable = false}, SHIFT(5909),
  [9225] = {.count = 1, .reusable = true}, SHIFT(5910),
  [9227] = {.count = 1, .reusable = true}, SHIFT(1236),
  [9229] = {.count = 1, .reusable = true}, SHIFT(5935),
  [9231] = {.count = 1, .reusable = true}, SHIFT(5936),
  [9233] = {.count = 1, .reusable = false}, SHIFT(5937),
  [9235] = {.count = 1, .reusable = false}, SHIFT(5938),
  [9237] = {.count = 1, .reusable = false}, SHIFT(5939),
  [9239] = {.count = 1, .reusable = true}, SHIFT(5940),
  [9241] = {.count = 1, .reusable = false}, SHIFT(5941),
  [9243] = {.count = 1, .reusable = true}, SHIFT(5941),
  [9245] = {.count = 1, .reusable = true}, SHIFT(5943),
  [9247] = {.count = 1, .reusable = true}, SHIFT(5944),
  [9249] = {.count = 1, .reusable = false}, SHIFT(5943),
  [9251] = {.count = 1, .reusable = true}, SHIFT(5939),
  [9253] = {.count = 1, .reusable = true}, SHIFT(5937),
  [9255] = {.count = 1, .reusable = true}, SHIFT(5945),
  [9257] = {.count = 1, .reusable = true}, SHIFT(5947),
  [9259] = {.count = 1, .reusable = false}, SHIFT(5947),
  [9261] = {.count = 1, .reusable = true}, SHIFT(5948),
  [9263] = {.count = 1, .reusable = true}, REDUCE(aux_sym_undef_repeat1, 2),
  [9265] = {.count = 2, .reusable = true}, REDUCE(aux_sym_undef_repeat1, 2), SHIFT_REPEAT(1257),
  [9268] = {.count = 1, .reusable = true}, SHIFT(5949),
  [9270] = {.count = 1, .reusable = true}, SHIFT(5950),
  [9272] = {.count = 1, .reusable = true}, SHIFT(5951),
  [9274] = {.count = 1, .reusable = true}, SHIFT(5953),
  [9276] = {.count = 1, .reusable = true}, SHIFT(5954),
  [9278] = {.count = 1, .reusable = true}, SHIFT(5955),
  [9280] = {.count = 1, .reusable = true}, SHIFT(5956),
  [9282] = {.count = 1, .reusable = true}, SHIFT(5957),
  [9284] = {.count = 1, .reusable = true}, SHIFT(5959),
  [9286] = {.count = 1, .reusable = true}, SHIFT(5960),
  [9288] = {.count = 1, .reusable = true}, SHIFT(5961),
  [9290] = {.count = 1, .reusable = false}, SHIFT(5961),
  [9292] = {.count = 1, .reusable = true}, SHIFT(5962),
  [9294] = {.count = 1, .reusable = false}, SHIFT(5962),
  [9296] = {.count = 1, .reusable = true}, SHIFT(5963),
  [9298] = {.count = 1, .reusable = true}, SHIFT(5968),
  [9300] = {.count = 1, .reusable = false}, SHIFT(5970),
  [9302] = {.count = 1, .reusable = true}, SHIFT(5972),
  [9304] = {.count = 1, .reusable = false}, SHIFT(5968),
  [9306] = {.count = 1, .reusable = true}, SHIFT(5984),
  [9308] = {.count = 1, .reusable = false}, SHIFT(5985),
  [9310] = {.count = 1, .reusable = false}, SHIFT(5986),
  [9312] = {.count = 1, .reusable = false}, SHIFT(5987),
  [9314] = {.count = 1, .reusable = false}, SHIFT(5988),
  [9316] = {.count = 1, .reusable = false}, SHIFT(5984),
  [9318] = {.count = 1, .reusable = true}, SHIFT(5989),
  [9320] = {.count = 1, .reusable = false}, SHIFT(5989),
  [9322] = {.count = 1, .reusable = true}, SHIFT(5990),
  [9324] = {.count = 1, .reusable = false}, SHIFT(5992),
  [9326] = {.count = 1, .reusable = true}, SHIFT(5992),
  [9328] = {.count = 1, .reusable = true}, SHIFT(5997),
  [9330] = {.count = 1, .reusable = false}, SHIFT(5999),
  [9332] = {.count = 1, .reusable = true}, SHIFT(6001),
  [9334] = {.count = 1, .reusable = false}, SHIFT(5997),
  [9336] = {.count = 1, .reusable = true}, SHIFT(6003),
  [9338] = {.count = 1, .reusable = true}, SHIFT(6008),
  [9340] = {.count = 1, .reusable = true}, SHIFT(6009),
  [9342] = {.count = 1, .reusable = true}, SHIFT(1299),
  [9344] = {.count = 1, .reusable = false}, SHIFT(6011),
  [9346] = {.count = 1, .reusable = true}, SHIFT(6012),
  [9348] = {.count = 1, .reusable = true}, SHIFT(6013),
  [9350] = {.count = 1, .reusable = false}, SHIFT(6014),
  [9352] = {.count = 1, .reusable = false}, SHIFT(6015),
  [9354] = {.count = 1, .reusable = true}, SHIFT(1313),
  [9356] = {.count = 1, .reusable = true}, SHIFT(6035),
  [9358] = {.count = 1, .reusable = false}, SHIFT(6035),
  [9360] = {.count = 1, .reusable = true}, SHIFT(6037),
  [9362] = {.count = 1, .reusable = false}, SHIFT(6037),
  [9364] = {.count = 1, .reusable = false}, SHIFT(6039),
  [9366] = {.count = 1, .reusable = false}, SHIFT(6041),
  [9368] = {.count = 1, .reusable = true}, SHIFT(6043),
  [9370] = {.count = 1, .reusable = true}, SHIFT(6046),
  [9372] = {.count = 1, .reusable = true}, SHIFT(6044),
  [9374] = {.count = 1, .reusable = true}, SHIFT(6048),
  [9376] = {.count = 1, .reusable = true}, SHIFT(6051),
  [9378] = {.count = 1, .reusable = true}, SHIFT(6053),
  [9380] = {.count = 1, .reusable = true}, SHIFT(6055),
  [9382] = {.count = 1, .reusable = false}, SHIFT(6053),
  [9384] = {.count = 1, .reusable = true}, SHIFT(6057),
  [9386] = {.count = 1, .reusable = true}, SHIFT(6058),
  [9388] = {.count = 1, .reusable = true}, SHIFT(6060),
  [9390] = {.count = 1, .reusable = true}, SHIFT(6061),
  [9392] = {.count = 1, .reusable = true}, SHIFT(6063),
  [9394] = {.count = 1, .reusable = true}, SHIFT(6065),
  [9396] = {.count = 1, .reusable = true}, SHIFT(6067),
  [9398] = {.count = 1, .reusable = false}, SHIFT(6065),
  [9400] = {.count = 1, .reusable = true}, SHIFT(1368),
  [9402] = {.count = 1, .reusable = true}, REDUCE(sym__argument_list_with_trailing_comma, 3),
  [9404] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(6090),
  [9407] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(308),
  [9410] = {.count = 1, .reusable = true}, SHIFT(6094),
  [9412] = {.count = 1, .reusable = true}, SHIFT(6095),
  [9414] = {.count = 1, .reusable = true}, REDUCE(sym_block_parameters, 2),
  [9416] = {.count = 1, .reusable = false}, REDUCE(sym_block_parameters, 2),
  [9418] = {.count = 1, .reusable = true}, SHIFT(6096),
  [9420] = {.count = 1, .reusable = true}, SHIFT(6097),
  [9422] = {.count = 1, .reusable = true}, SHIFT(6098),
  [9424] = {.count = 1, .reusable = true}, SHIFT(6099),
  [9426] = {.count = 1, .reusable = true}, REDUCE(sym_block, 3),
  [9428] = {.count = 1, .reusable = false}, REDUCE(sym_block, 3),
  [9430] = {.count = 1, .reusable = true}, SHIFT(6101),
  [9432] = {.count = 1, .reusable = true}, SHIFT(6102),
  [9434] = {.count = 1, .reusable = true}, REDUCE(sym_lambda_parameters, 3),
  [9436] = {.count = 1, .reusable = true}, SHIFT(6107),
  [9438] = {.count = 1, .reusable = true}, SHIFT(6109),
  [9440] = {.count = 1, .reusable = true}, SHIFT(6110),
  [9442] = {.count = 1, .reusable = true}, SHIFT(6111),
  [9444] = {.count = 1, .reusable = true}, SHIFT(6112),
  [9446] = {.count = 1, .reusable = true}, REDUCE(sym_do_block, 3),
  [9448] = {.count = 1, .reusable = false}, REDUCE(sym_do_block, 3),
  [9450] = {.count = 1, .reusable = true}, SHIFT(6114),
  [9452] = {.count = 1, .reusable = false}, SHIFT(6114),
  [9454] = {.count = 1, .reusable = true}, SHIFT(6116),
  [9456] = {.count = 1, .reusable = true}, SHIFT(6119),
  [9458] = {.count = 1, .reusable = true}, SHIFT(6120),
  [9460] = {.count = 1, .reusable = true}, REDUCE(sym_keyword_parameter, 3),
  [9462] = {.count = 1, .reusable = false}, SHIFT(6121),
  [9464] = {.count = 1, .reusable = false}, SHIFT(6122),
  [9466] = {.count = 1, .reusable = false}, SHIFT(6123),
  [9468] = {.count = 1, .reusable = true}, SHIFT(6124),
  [9470] = {.count = 1, .reusable = false}, SHIFT(6125),
  [9472] = {.count = 1, .reusable = true}, SHIFT(6125),
  [9474] = {.count = 1, .reusable = true}, SHIFT(6126),
  [9476] = {.count = 1, .reusable = true}, SHIFT(6127),
  [9478] = {.count = 1, .reusable = true}, SHIFT(6128),
  [9480] = {.count = 1, .reusable = false}, SHIFT(6127),
  [9482] = {.count = 1, .reusable = true}, SHIFT(6123),
  [9484] = {.count = 1, .reusable = true}, SHIFT(6121),
  [9486] = {.count = 1, .reusable = true}, SHIFT(6129),
  [9488] = {.count = 1, .reusable = true}, SHIFT(6131),
  [9490] = {.count = 1, .reusable = false}, SHIFT(6131),
  [9492] = {.count = 1, .reusable = true}, SHIFT(6132),
  [9494] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 3),
  [9496] = {.count = 1, .reusable = true}, REDUCE(aux_sym_lambda_parameters_repeat1, 2),
  [9498] = {.count = 2, .reusable = true}, REDUCE(aux_sym_lambda_parameters_repeat1, 2), SHIFT_REPEAT(1412),
  [9501] = {.count = 1, .reusable = true}, REDUCE(sym_program, 4),
  [9503] = {.count = 1, .reusable = true}, SHIFT(6134),
  [9505] = {.count = 1, .reusable = true}, SHIFT(6135),
  [9507] = {.count = 1, .reusable = false}, SHIFT(6136),
  [9509] = {.count = 1, .reusable = false}, SHIFT(6137),
  [9511] = {.count = 1, .reusable = false}, SHIFT(6138),
  [9513] = {.count = 1, .reusable = false}, SHIFT(6139),
  [9515] = {.count = 1, .reusable = false}, SHIFT(6135),
  [9517] = {.count = 1, .reusable = true}, SHIFT(6140),
  [9519] = {.count = 1, .reusable = false}, SHIFT(6140),
  [9521] = {.count = 1, .reusable = true}, SHIFT(6141),
  [9523] = {.count = 1, .reusable = false}, SHIFT(6143),
  [9525] = {.count = 1, .reusable = true}, SHIFT(6143),
  [9527] = {.count = 1, .reusable = true}, SHIFT(6148),
  [9529] = {.count = 1, .reusable = false}, SHIFT(3507),
  [9531] = {.count = 1, .reusable = true}, SHIFT(6151),
  [9533] = {.count = 1, .reusable = true}, SHIFT(6153),
  [9535] = {.count = 1, .reusable = true}, SHIFT(6154),
  [9537] = {.count = 1, .reusable = true}, SHIFT(6155),
  [9539] = {.count = 1, .reusable = false}, SHIFT(6157),
  [9541] = {.count = 1, .reusable = false}, SHIFT(6163),
  [9543] = {.count = 1, .reusable = true}, SHIFT(6164),
  [9545] = {.count = 1, .reusable = true}, SHIFT(6165),
  [9547] = {.count = 1, .reusable = false}, SHIFT(6166),
  [9549] = {.count = 1, .reusable = false}, SHIFT(6167),
  [9551] = {.count = 1, .reusable = false}, SHIFT(6168),
  [9553] = {.count = 1, .reusable = true}, SHIFT(6169),
  [9555] = {.count = 1, .reusable = false}, SHIFT(6170),
  [9557] = {.count = 1, .reusable = true}, SHIFT(6170),
  [9559] = {.count = 1, .reusable = true}, SHIFT(6172),
  [9561] = {.count = 1, .reusable = true}, SHIFT(6173),
  [9563] = {.count = 1, .reusable = false}, SHIFT(6172),
  [9565] = {.count = 1, .reusable = true}, SHIFT(6168),
  [9567] = {.count = 1, .reusable = true}, SHIFT(6166),
  [9569] = {.count = 1, .reusable = true}, SHIFT(6174),
  [9571] = {.count = 1, .reusable = true}, SHIFT(6175),
  [9573] = {.count = 1, .reusable = true}, SHIFT(6176),
  [9575] = {.count = 1, .reusable = false}, SHIFT(6178),
  [9577] = {.count = 1, .reusable = true}, SHIFT(6184),
  [9579] = {.count = 1, .reusable = true}, SHIFT(6186),
  [9581] = {.count = 1, .reusable = false}, SHIFT(6186),
  [9583] = {.count = 1, .reusable = true}, SHIFT(6187),
  [9585] = {.count = 1, .reusable = false}, SHIFT(6151),
  [9587] = {.count = 1, .reusable = true}, SHIFT(6200),
  [9589] = {.count = 1, .reusable = false}, SHIFT(6201),
  [9591] = {.count = 1, .reusable = false}, SHIFT(6202),
  [9593] = {.count = 1, .reusable = false}, SHIFT(6203),
  [9595] = {.count = 1, .reusable = false}, SHIFT(6204),
  [9597] = {.count = 1, .reusable = false}, SHIFT(6200),
  [9599] = {.count = 1, .reusable = true}, SHIFT(6205),
  [9601] = {.count = 1, .reusable = false}, SHIFT(6205),
  [9603] = {.count = 1, .reusable = true}, SHIFT(6206),
  [9605] = {.count = 1, .reusable = false}, SHIFT(6208),
  [9607] = {.count = 1, .reusable = true}, SHIFT(6208),
  [9609] = {.count = 1, .reusable = true}, SHIFT(6213),
  [9611] = {.count = 1, .reusable = false}, SHIFT(3538),
  [9613] = {.count = 1, .reusable = true}, SHIFT(6216),
  [9615] = {.count = 1, .reusable = false}, SHIFT(6219),
  [9617] = {.count = 1, .reusable = true}, SHIFT(6220),
  [9619] = {.count = 1, .reusable = true}, SHIFT(6221),
  [9621] = {.count = 1, .reusable = false}, SHIFT(6222),
  [9623] = {.count = 1, .reusable = false}, SHIFT(6221),
  [9625] = {.count = 1, .reusable = false}, SHIFT(6223),
  [9627] = {.count = 1, .reusable = false}, SHIFT(6224),
  [9629] = {.count = 1, .reusable = true}, SHIFT(6225),
  [9631] = {.count = 1, .reusable = false}, SHIFT(6226),
  [9633] = {.count = 1, .reusable = true}, SHIFT(6226),
  [9635] = {.count = 1, .reusable = false}, SHIFT(6228),
  [9637] = {.count = 1, .reusable = false}, SHIFT(6229),
  [9639] = {.count = 1, .reusable = true}, SHIFT(6228),
  [9641] = {.count = 1, .reusable = true}, SHIFT(6224),
  [9643] = {.count = 1, .reusable = false}, SHIFT(6220),
  [9645] = {.count = 1, .reusable = true}, SHIFT(6231),
  [9647] = {.count = 1, .reusable = true}, SHIFT(6233),
  [9649] = {.count = 1, .reusable = false}, SHIFT(6233),
  [9651] = {.count = 1, .reusable = true}, SHIFT(6234),
  [9653] = {.count = 1, .reusable = false}, SHIFT(6216),
  [9655] = {.count = 1, .reusable = true}, SHIFT(6236),
  [9657] = {.count = 1, .reusable = true}, SHIFT(6237),
  [9659] = {.count = 1, .reusable = false}, SHIFT(6238),
  [9661] = {.count = 1, .reusable = false}, SHIFT(6239),
  [9663] = {.count = 1, .reusable = false}, SHIFT(6240),
  [9665] = {.count = 1, .reusable = false}, SHIFT(6241),
  [9667] = {.count = 1, .reusable = false}, SHIFT(6237),
  [9669] = {.count = 1, .reusable = true}, SHIFT(6242),
  [9671] = {.count = 1, .reusable = false}, SHIFT(6242),
  [9673] = {.count = 1, .reusable = true}, SHIFT(6243),
  [9675] = {.count = 1, .reusable = true}, SHIFT(6251),
  [9677] = {.count = 1, .reusable = true}, SHIFT(6252),
  [9679] = {.count = 1, .reusable = true}, REDUCE(sym_call, 4),
  [9681] = {.count = 1, .reusable = false}, REDUCE(sym_call, 4),
  [9683] = {.count = 2, .reusable = true}, REDUCE(aux_sym_call_repeat1, 2), SHIFT_REPEAT(1442),
  [9686] = {.count = 1, .reusable = true}, REDUCE(sym_element_reference, 4),
  [9688] = {.count = 1, .reusable = false}, REDUCE(sym_element_reference, 4),
  [9690] = {.count = 1, .reusable = true}, SHIFT(6253),
  [9692] = {.count = 1, .reusable = true}, SHIFT(6254),
  [9694] = {.count = 1, .reusable = true}, SHIFT(6255),
  [9696] = {.count = 1, .reusable = true}, SHIFT(6257),
  [9698] = {.count = 1, .reusable = true}, SHIFT(6258),
  [9700] = {.count = 1, .reusable = true}, SHIFT(6259),
  [9702] = {.count = 1, .reusable = true}, SHIFT(6260),
  [9704] = {.count = 1, .reusable = true}, SHIFT(6261),
  [9706] = {.count = 1, .reusable = true}, SHIFT(6263),
  [9708] = {.count = 1, .reusable = true}, SHIFT(6264),
  [9710] = {.count = 1, .reusable = true}, SHIFT(6265),
  [9712] = {.count = 1, .reusable = true}, SHIFT(6266),
  [9714] = {.count = 1, .reusable = true}, SHIFT(6267),
  [9716] = {.count = 1, .reusable = true}, SHIFT(6268),
  [9718] = {.count = 1, .reusable = true}, SHIFT(6269),
  [9720] = {.count = 1, .reusable = false}, SHIFT(6270),
  [9722] = {.count = 1, .reusable = true}, SHIFT(6272),
  [9724] = {.count = 1, .reusable = true}, SHIFT(6273),
  [9726] = {.count = 1, .reusable = true}, SHIFT(6275),
  [9728] = {.count = 1, .reusable = false}, SHIFT(6276),
  [9730] = {.count = 1, .reusable = true}, SHIFT(6278),
  [9732] = {.count = 1, .reusable = true}, SHIFT(6279),
  [9734] = {.count = 1, .reusable = true}, SHIFT(6281),
  [9736] = {.count = 1, .reusable = true}, SHIFT(6284),
  [9738] = {.count = 1, .reusable = true}, SHIFT(6285),
  [9740] = {.count = 1, .reusable = true}, SHIFT(6286),
  [9742] = {.count = 1, .reusable = true}, SHIFT(6289),
  [9744] = {.count = 1, .reusable = true}, SHIFT(6291),
  [9746] = {.count = 1, .reusable = false}, SHIFT(6290),
  [9748] = {.count = 1, .reusable = true}, SHIFT(6293),
  [9750] = {.count = 1, .reusable = true}, SHIFT(6295),
  [9752] = {.count = 1, .reusable = true}, SHIFT(6296),
  [9754] = {.count = 1, .reusable = true}, SHIFT(6297),
  [9756] = {.count = 1, .reusable = true}, SHIFT(6299),
  [9758] = {.count = 1, .reusable = true}, SHIFT(6302),
  [9760] = {.count = 1, .reusable = true}, SHIFT(6300),
  [9762] = {.count = 1, .reusable = true}, SHIFT(6304),
  [9764] = {.count = 1, .reusable = false}, SHIFT(6308),
  [9766] = {.count = 1, .reusable = true}, SHIFT(6309),
  [9768] = {.count = 1, .reusable = true}, SHIFT(6321),
  [9770] = {.count = 1, .reusable = true}, SHIFT(6329),
  [9772] = {.count = 1, .reusable = false}, SHIFT(6331),
  [9774] = {.count = 1, .reusable = true}, SHIFT(6333),
  [9776] = {.count = 1, .reusable = false}, SHIFT(6329),
  [9778] = {.count = 1, .reusable = true}, SHIFT(6335),
  [9780] = {.count = 1, .reusable = true}, SHIFT(6348),
  [9782] = {.count = 1, .reusable = false}, SHIFT(6350),
  [9784] = {.count = 1, .reusable = true}, SHIFT(6352),
  [9786] = {.count = 1, .reusable = false}, SHIFT(6348),
  [9788] = {.count = 1, .reusable = true}, SHIFT(6354),
  [9790] = {.count = 1, .reusable = true}, SHIFT(6355),
  [9792] = {.count = 1, .reusable = false}, SHIFT(6355),
  [9794] = {.count = 1, .reusable = true}, SHIFT(6356),
  [9796] = {.count = 1, .reusable = false}, SHIFT(6356),
  [9798] = {.count = 1, .reusable = true}, SHIFT(6357),
  [9800] = {.count = 1, .reusable = true}, SHIFT(6364),
  [9802] = {.count = 1, .reusable = true}, SHIFT(6365),
  [9804] = {.count = 1, .reusable = true}, SHIFT(1526),
  [9806] = {.count = 1, .reusable = false}, SHIFT(6367),
  [9808] = {.count = 1, .reusable = true}, SHIFT(6368),
  [9810] = {.count = 1, .reusable = true}, SHIFT(6369),
  [9812] = {.count = 1, .reusable = false}, SHIFT(6370),
  [9814] = {.count = 1, .reusable = false}, SHIFT(6371),
  [9816] = {.count = 1, .reusable = true}, SHIFT(6372),
  [9818] = {.count = 1, .reusable = false}, SHIFT(6372),
  [9820] = {.count = 1, .reusable = true}, SHIFT(6374),
  [9822] = {.count = 1, .reusable = false}, SHIFT(6374),
  [9824] = {.count = 1, .reusable = false}, SHIFT(6376),
  [9826] = {.count = 1, .reusable = false}, SHIFT(6378),
  [9828] = {.count = 1, .reusable = true}, SHIFT(6380),
  [9830] = {.count = 1, .reusable = true}, SHIFT(6381),
  [9832] = {.count = 1, .reusable = false}, SHIFT(6381),
  [9834] = {.count = 1, .reusable = true}, SHIFT(6383),
  [9836] = {.count = 1, .reusable = true}, SHIFT(6386),
  [9838] = {.count = 1, .reusable = true}, SHIFT(6384),
  [9840] = {.count = 1, .reusable = true}, SHIFT(6388),
  [9842] = {.count = 1, .reusable = true}, SHIFT(6391),
  [9844] = {.count = 1, .reusable = true}, SHIFT(6392),
  [9846] = {.count = 2, .reusable = true}, REDUCE(aux_sym_call_repeat1, 2), SHIFT_REPEAT(1581),
  [9849] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(1583),
  [9852] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(385),
  [9855] = {.count = 1, .reusable = true}, REDUCE(sym_right_assignment_list, 2),
  [9857] = {.count = 1, .reusable = false}, REDUCE(sym_right_assignment_list, 2),
  [9859] = {.count = 1, .reusable = true}, SHIFT(6410),
  [9861] = {.count = 1, .reusable = false}, SHIFT(6411),
  [9863] = {.count = 1, .reusable = false}, SHIFT(6412),
  [9865] = {.count = 1, .reusable = false}, SHIFT(6413),
  [9867] = {.count = 1, .reusable = false}, SHIFT(6414),
  [9869] = {.count = 1, .reusable = false}, SHIFT(6410),
  [9871] = {.count = 1, .reusable = true}, SHIFT(6415),
  [9873] = {.count = 1, .reusable = false}, SHIFT(6415),
  [9875] = {.count = 1, .reusable = true}, SHIFT(6416),
  [9877] = {.count = 1, .reusable = false}, SHIFT(3767),
  [9879] = {.count = 1, .reusable = true}, SHIFT(6424),
  [9881] = {.count = 1, .reusable = true}, SHIFT(6426),
  [9883] = {.count = 1, .reusable = true}, SHIFT(6427),
  [9885] = {.count = 1, .reusable = true}, SHIFT(6428),
  [9887] = {.count = 1, .reusable = false}, SHIFT(6430),
  [9889] = {.count = 1, .reusable = false}, SHIFT(6436),
  [9891] = {.count = 1, .reusable = true}, SHIFT(6437),
  [9893] = {.count = 1, .reusable = true}, SHIFT(6438),
  [9895] = {.count = 1, .reusable = false}, SHIFT(6439),
  [9897] = {.count = 1, .reusable = false}, SHIFT(6440),
  [9899] = {.count = 1, .reusable = false}, SHIFT(6441),
  [9901] = {.count = 1, .reusable = true}, SHIFT(6442),
  [9903] = {.count = 1, .reusable = false}, SHIFT(6443),
  [9905] = {.count = 1, .reusable = true}, SHIFT(6443),
  [9907] = {.count = 1, .reusable = true}, SHIFT(6445),
  [9909] = {.count = 1, .reusable = true}, SHIFT(6446),
  [9911] = {.count = 1, .reusable = false}, SHIFT(6445),
  [9913] = {.count = 1, .reusable = true}, SHIFT(6441),
  [9915] = {.count = 1, .reusable = true}, SHIFT(6439),
  [9917] = {.count = 1, .reusable = true}, SHIFT(6447),
  [9919] = {.count = 1, .reusable = true}, SHIFT(6448),
  [9921] = {.count = 1, .reusable = true}, SHIFT(6449),
  [9923] = {.count = 1, .reusable = false}, SHIFT(6451),
  [9925] = {.count = 1, .reusable = true}, SHIFT(6457),
  [9927] = {.count = 1, .reusable = true}, SHIFT(6459),
  [9929] = {.count = 1, .reusable = false}, SHIFT(6459),
  [9931] = {.count = 1, .reusable = true}, SHIFT(6460),
  [9933] = {.count = 1, .reusable = false}, SHIFT(6424),
  [9935] = {.count = 1, .reusable = true}, SHIFT(6478),
  [9937] = {.count = 1, .reusable = false}, SHIFT(6479),
  [9939] = {.count = 1, .reusable = false}, SHIFT(6480),
  [9941] = {.count = 1, .reusable = false}, SHIFT(6481),
  [9943] = {.count = 1, .reusable = false}, SHIFT(6482),
  [9945] = {.count = 1, .reusable = false}, SHIFT(6478),
  [9947] = {.count = 1, .reusable = true}, SHIFT(6483),
  [9949] = {.count = 1, .reusable = false}, SHIFT(6483),
  [9951] = {.count = 1, .reusable = true}, SHIFT(6484),
  [9953] = {.count = 1, .reusable = false}, SHIFT(6486),
  [9955] = {.count = 1, .reusable = true}, SHIFT(6486),
  [9957] = {.count = 1, .reusable = false}, SHIFT(3803),
  [9959] = {.count = 1, .reusable = true}, SHIFT(6493),
  [9961] = {.count = 1, .reusable = false}, SHIFT(6496),
  [9963] = {.count = 1, .reusable = true}, SHIFT(6497),
  [9965] = {.count = 1, .reusable = true}, SHIFT(6498),
  [9967] = {.count = 1, .reusable = false}, SHIFT(6499),
  [9969] = {.count = 1, .reusable = false}, SHIFT(6498),
  [9971] = {.count = 1, .reusable = false}, SHIFT(6500),
  [9973] = {.count = 1, .reusable = false}, SHIFT(6501),
  [9975] = {.count = 1, .reusable = true}, SHIFT(6502),
  [9977] = {.count = 1, .reusable = false}, SHIFT(6503),
  [9979] = {.count = 1, .reusable = true}, SHIFT(6503),
  [9981] = {.count = 1, .reusable = false}, SHIFT(6505),
  [9983] = {.count = 1, .reusable = false}, SHIFT(6506),
  [9985] = {.count = 1, .reusable = true}, SHIFT(6505),
  [9987] = {.count = 1, .reusable = true}, SHIFT(6501),
  [9989] = {.count = 1, .reusable = false}, SHIFT(6497),
  [9991] = {.count = 1, .reusable = true}, SHIFT(6508),
  [9993] = {.count = 1, .reusable = true}, SHIFT(6510),
  [9995] = {.count = 1, .reusable = false}, SHIFT(6510),
  [9997] = {.count = 1, .reusable = true}, SHIFT(6511),
  [9999] = {.count = 1, .reusable = false}, SHIFT(6493),
  [10001] = {.count = 1, .reusable = true}, SHIFT(6513),
  [10003] = {.count = 1, .reusable = true}, SHIFT(6514),
  [10005] = {.count = 1, .reusable = false}, SHIFT(6514),
  [10007] = {.count = 1, .reusable = true}, SHIFT(6515),
  [10009] = {.count = 1, .reusable = false}, SHIFT(6515),
  [10011] = {.count = 1, .reusable = true}, SHIFT(6516),
  [10013] = {.count = 1, .reusable = true}, SHIFT(6523),
  [10015] = {.count = 1, .reusable = true}, SHIFT(6524),
  [10017] = {.count = 1, .reusable = true}, SHIFT(6529),
  [10019] = {.count = 1, .reusable = true}, SHIFT(6530),
  [10021] = {.count = 1, .reusable = false}, SHIFT(6531),
  [10023] = {.count = 1, .reusable = false}, SHIFT(6532),
  [10025] = {.count = 1, .reusable = false}, SHIFT(6533),
  [10027] = {.count = 1, .reusable = true}, SHIFT(6534),
  [10029] = {.count = 1, .reusable = false}, SHIFT(6535),
  [10031] = {.count = 1, .reusable = true}, SHIFT(6535),
  [10033] = {.count = 1, .reusable = true}, SHIFT(6537),
  [10035] = {.count = 1, .reusable = true}, SHIFT(6538),
  [10037] = {.count = 1, .reusable = false}, SHIFT(6537),
  [10039] = {.count = 1, .reusable = true}, SHIFT(6533),
  [10041] = {.count = 1, .reusable = true}, SHIFT(6531),
  [10043] = {.count = 1, .reusable = true}, SHIFT(6539),
  [10045] = {.count = 1, .reusable = false}, SHIFT(6539),
  [10047] = {.count = 1, .reusable = true}, SHIFT(6540),
  [10049] = {.count = 1, .reusable = true}, SHIFT(6545),
  [10051] = {.count = 1, .reusable = false}, SHIFT(6547),
  [10053] = {.count = 1, .reusable = true}, SHIFT(6549),
  [10055] = {.count = 1, .reusable = false}, SHIFT(6545),
  [10057] = {.count = 1, .reusable = true}, SHIFT(6564),
  [10059] = {.count = 1, .reusable = false}, SHIFT(6566),
  [10061] = {.count = 1, .reusable = true}, SHIFT(6568),
  [10063] = {.count = 1, .reusable = false}, SHIFT(6564),
  [10065] = {.count = 1, .reusable = true}, SHIFT(1625),
  [10067] = {.count = 1, .reusable = true}, SHIFT(6578),
  [10069] = {.count = 1, .reusable = true}, SHIFT(6580),
  [10071] = {.count = 1, .reusable = true}, SHIFT(6581),
  [10073] = {.count = 1, .reusable = true}, SHIFT(6583),
  [10075] = {.count = 1, .reusable = true}, SHIFT(6584),
  [10077] = {.count = 1, .reusable = true}, SHIFT(6585),
  [10079] = {.count = 1, .reusable = true}, SHIFT(6587),
  [10081] = {.count = 1, .reusable = true}, SHIFT(6589),
  [10083] = {.count = 1, .reusable = true}, SHIFT(6591),
  [10085] = {.count = 1, .reusable = true}, SHIFT(6593),
  [10087] = {.count = 1, .reusable = false}, SHIFT(6594),
  [10089] = {.count = 1, .reusable = true}, SHIFT(6596),
  [10091] = {.count = 1, .reusable = false}, SHIFT(6597),
  [10093] = {.count = 1, .reusable = true}, SHIFT(6600),
  [10095] = {.count = 1, .reusable = true}, SHIFT(6603),
  [10097] = {.count = 1, .reusable = false}, SHIFT(6605),
  [10099] = {.count = 1, .reusable = true}, SHIFT(6607),
  [10101] = {.count = 1, .reusable = true}, SHIFT(6609),
  [10103] = {.count = 1, .reusable = false}, SHIFT(6610),
  [10105] = {.count = 1, .reusable = false}, SHIFT(6612),
  [10107] = {.count = 1, .reusable = true}, SHIFT(6624),
  [10109] = {.count = 1, .reusable = true}, SHIFT(6630),
  [10111] = {.count = 1, .reusable = false}, SHIFT(6629),
  [10113] = {.count = 1, .reusable = false}, SHIFT(6633),
  [10115] = {.count = 1, .reusable = true}, SHIFT(6634),
  [10117] = {.count = 1, .reusable = true}, SHIFT(6638),
  [10119] = {.count = 1, .reusable = true}, SHIFT(6639),
  [10121] = {.count = 1, .reusable = false}, SHIFT(6640),
  [10123] = {.count = 1, .reusable = false}, SHIFT(6639),
  [10125] = {.count = 1, .reusable = false}, SHIFT(6641),
  [10127] = {.count = 1, .reusable = false}, SHIFT(6642),
  [10129] = {.count = 1, .reusable = true}, SHIFT(6643),
  [10131] = {.count = 1, .reusable = false}, SHIFT(6644),
  [10133] = {.count = 1, .reusable = true}, SHIFT(6644),
  [10135] = {.count = 1, .reusable = false}, SHIFT(6646),
  [10137] = {.count = 1, .reusable = false}, SHIFT(6647),
  [10139] = {.count = 1, .reusable = true}, SHIFT(6646),
  [10141] = {.count = 1, .reusable = true}, SHIFT(6642),
  [10143] = {.count = 1, .reusable = false}, SHIFT(6638),
  [10145] = {.count = 1, .reusable = true}, SHIFT(6648),
  [10147] = {.count = 1, .reusable = false}, SHIFT(6648),
  [10149] = {.count = 1, .reusable = true}, SHIFT(6649),
  [10151] = {.count = 1, .reusable = true}, SHIFT(6652),
  [10153] = {.count = 1, .reusable = true}, SHIFT(6654),
  [10155] = {.count = 1, .reusable = true}, SHIFT(6656),
  [10157] = {.count = 1, .reusable = false}, SHIFT(6654),
  [10159] = {.count = 1, .reusable = true}, SHIFT(6658),
  [10161] = {.count = 1, .reusable = true}, SHIFT(6670),
  [10163] = {.count = 1, .reusable = true}, SHIFT(6672),
  [10165] = {.count = 1, .reusable = true}, SHIFT(6671),
  [10167] = {.count = 1, .reusable = true}, SHIFT(1669),
  [10169] = {.count = 1, .reusable = true}, SHIFT(6685),
  [10171] = {.count = 1, .reusable = true}, SHIFT(6686),
  [10173] = {.count = 1, .reusable = false}, SHIFT(6687),
  [10175] = {.count = 1, .reusable = false}, SHIFT(6688),
  [10177] = {.count = 1, .reusable = false}, SHIFT(6689),
  [10179] = {.count = 1, .reusable = true}, SHIFT(6690),
  [10181] = {.count = 1, .reusable = false}, SHIFT(6691),
  [10183] = {.count = 1, .reusable = true}, SHIFT(6691),
  [10185] = {.count = 1, .reusable = true}, SHIFT(6693),
  [10187] = {.count = 1, .reusable = true}, SHIFT(6694),
  [10189] = {.count = 1, .reusable = false}, SHIFT(6693),
  [10191] = {.count = 1, .reusable = true}, SHIFT(6689),
  [10193] = {.count = 1, .reusable = true}, SHIFT(6687),
  [10195] = {.count = 1, .reusable = true}, SHIFT(6695),
  [10197] = {.count = 1, .reusable = true}, SHIFT(6697),
  [10199] = {.count = 1, .reusable = false}, SHIFT(6697),
  [10201] = {.count = 1, .reusable = true}, SHIFT(6698),
  [10203] = {.count = 1, .reusable = true}, REDUCE(sym_string_array, 5, .alias_sequence_id = 19),
  [10205] = {.count = 1, .reusable = false}, REDUCE(sym_string_array, 5, .alias_sequence_id = 19),
  [10207] = {.count = 1, .reusable = true}, SHIFT(6700),
  [10209] = {.count = 1, .reusable = true}, REDUCE(sym_string_array, 5, .alias_sequence_id = 20),
  [10211] = {.count = 1, .reusable = false}, REDUCE(sym_string_array, 5, .alias_sequence_id = 20),
  [10213] = {.count = 1, .reusable = true}, REDUCE(sym_symbol_array, 5, .alias_sequence_id = 21),
  [10215] = {.count = 1, .reusable = false}, REDUCE(sym_symbol_array, 5, .alias_sequence_id = 21),
  [10217] = {.count = 1, .reusable = true}, SHIFT(6701),
  [10219] = {.count = 1, .reusable = true}, REDUCE(sym_symbol_array, 5, .alias_sequence_id = 22),
  [10221] = {.count = 1, .reusable = false}, REDUCE(sym_symbol_array, 5, .alias_sequence_id = 22),
  [10223] = {.count = 1, .reusable = true}, SHIFT(6706),
  [10225] = {.count = 1, .reusable = true}, SHIFT(6707),
  [10227] = {.count = 1, .reusable = false}, SHIFT(6708),
  [10229] = {.count = 1, .reusable = false}, SHIFT(6709),
  [10231] = {.count = 1, .reusable = false}, SHIFT(6710),
  [10233] = {.count = 1, .reusable = true}, SHIFT(6711),
  [10235] = {.count = 1, .reusable = false}, SHIFT(6712),
  [10237] = {.count = 1, .reusable = true}, SHIFT(6712),
  [10239] = {.count = 1, .reusable = true}, SHIFT(6714),
  [10241] = {.count = 1, .reusable = true}, SHIFT(6715),
  [10243] = {.count = 1, .reusable = false}, SHIFT(6714),
  [10245] = {.count = 1, .reusable = true}, SHIFT(6710),
  [10247] = {.count = 1, .reusable = true}, SHIFT(6708),
  [10249] = {.count = 1, .reusable = true}, SHIFT(6716),
  [10251] = {.count = 1, .reusable = false}, SHIFT(6716),
  [10253] = {.count = 1, .reusable = true}, SHIFT(6717),
  [10255] = {.count = 1, .reusable = true}, SHIFT(1713),
  [10257] = {.count = 1, .reusable = true}, SHIFT(6742),
  [10259] = {.count = 1, .reusable = true}, SHIFT(6745),
  [10261] = {.count = 1, .reusable = true}, SHIFT(6746),
  [10263] = {.count = 1, .reusable = false}, SHIFT(6747),
  [10265] = {.count = 1, .reusable = false}, SHIFT(6746),
  [10267] = {.count = 1, .reusable = false}, SHIFT(6748),
  [10269] = {.count = 1, .reusable = false}, SHIFT(6749),
  [10271] = {.count = 1, .reusable = true}, SHIFT(6750),
  [10273] = {.count = 1, .reusable = false}, SHIFT(6751),
  [10275] = {.count = 1, .reusable = true}, SHIFT(6751),
  [10277] = {.count = 1, .reusable = false}, SHIFT(6753),
  [10279] = {.count = 1, .reusable = false}, SHIFT(6754),
  [10281] = {.count = 1, .reusable = true}, SHIFT(6753),
  [10283] = {.count = 1, .reusable = true}, SHIFT(6749),
  [10285] = {.count = 1, .reusable = false}, SHIFT(6745),
  [10287] = {.count = 1, .reusable = true}, SHIFT(6755),
  [10289] = {.count = 1, .reusable = false}, SHIFT(6755),
  [10291] = {.count = 1, .reusable = true}, SHIFT(6756),
  [10293] = {.count = 1, .reusable = true}, SHIFT(1749),
  [10295] = {.count = 1, .reusable = true}, SHIFT(6781),
  [10297] = {.count = 1, .reusable = true}, SHIFT(6782),
  [10299] = {.count = 1, .reusable = false}, SHIFT(6783),
  [10301] = {.count = 1, .reusable = false}, SHIFT(6784),
  [10303] = {.count = 1, .reusable = false}, SHIFT(6785),
  [10305] = {.count = 1, .reusable = true}, SHIFT(6786),
  [10307] = {.count = 1, .reusable = false}, SHIFT(6787),
  [10309] = {.count = 1, .reusable = true}, SHIFT(6787),
  [10311] = {.count = 1, .reusable = true}, SHIFT(6789),
  [10313] = {.count = 1, .reusable = true}, SHIFT(6790),
  [10315] = {.count = 1, .reusable = false}, SHIFT(6789),
  [10317] = {.count = 1, .reusable = true}, SHIFT(6785),
  [10319] = {.count = 1, .reusable = true}, SHIFT(6783),
  [10321] = {.count = 1, .reusable = true}, SHIFT(6791),
  [10323] = {.count = 1, .reusable = true}, SHIFT(6793),
  [10325] = {.count = 1, .reusable = false}, SHIFT(6793),
  [10327] = {.count = 1, .reusable = true}, SHIFT(6794),
  [10329] = {.count = 1, .reusable = true}, SHIFT(6795),
  [10331] = {.count = 1, .reusable = true}, SHIFT(6796),
  [10333] = {.count = 1, .reusable = true}, SHIFT(6797),
  [10335] = {.count = 1, .reusable = true}, SHIFT(6798),
  [10337] = {.count = 1, .reusable = true}, SHIFT(6799),
  [10339] = {.count = 1, .reusable = true}, SHIFT(6800),
  [10341] = {.count = 1, .reusable = true}, SHIFT(6801),
  [10343] = {.count = 1, .reusable = true}, SHIFT(6804),
  [10345] = {.count = 1, .reusable = true}, SHIFT(6805),
  [10347] = {.count = 1, .reusable = false}, SHIFT(6806),
  [10349] = {.count = 1, .reusable = false}, SHIFT(6807),
  [10351] = {.count = 1, .reusable = false}, SHIFT(6808),
  [10353] = {.count = 1, .reusable = true}, SHIFT(6809),
  [10355] = {.count = 1, .reusable = false}, SHIFT(6810),
  [10357] = {.count = 1, .reusable = true}, SHIFT(6810),
  [10359] = {.count = 1, .reusable = true}, SHIFT(6812),
  [10361] = {.count = 1, .reusable = true}, SHIFT(6813),
  [10363] = {.count = 1, .reusable = false}, SHIFT(6812),
  [10365] = {.count = 1, .reusable = true}, SHIFT(6808),
  [10367] = {.count = 1, .reusable = true}, SHIFT(6806),
  [10369] = {.count = 1, .reusable = true}, SHIFT(6814),
  [10371] = {.count = 1, .reusable = false}, SHIFT(6814),
  [10373] = {.count = 1, .reusable = true}, SHIFT(6815),
  [10375] = {.count = 1, .reusable = true}, SHIFT(6819),
  [10377] = {.count = 1, .reusable = false}, SHIFT(6821),
  [10379] = {.count = 1, .reusable = true}, SHIFT(6823),
  [10381] = {.count = 1, .reusable = false}, SHIFT(6819),
  [10383] = {.count = 1, .reusable = true}, SHIFT(6838),
  [10385] = {.count = 1, .reusable = false}, SHIFT(6840),
  [10387] = {.count = 1, .reusable = true}, SHIFT(6842),
  [10389] = {.count = 1, .reusable = false}, SHIFT(6838),
  [10391] = {.count = 1, .reusable = true}, SHIFT(1801),
  [10393] = {.count = 1, .reusable = true}, SHIFT(6852),
  [10395] = {.count = 1, .reusable = true}, SHIFT(6853),
  [10397] = {.count = 1, .reusable = true}, SHIFT(6855),
  [10399] = {.count = 1, .reusable = true}, SHIFT(6856),
  [10401] = {.count = 1, .reusable = true}, SHIFT(6859),
  [10403] = {.count = 1, .reusable = true}, SHIFT(6860),
  [10405] = {.count = 1, .reusable = false}, SHIFT(6861),
  [10407] = {.count = 1, .reusable = false}, SHIFT(6860),
  [10409] = {.count = 1, .reusable = false}, SHIFT(6862),
  [10411] = {.count = 1, .reusable = false}, SHIFT(6863),
  [10413] = {.count = 1, .reusable = true}, SHIFT(6864),
  [10415] = {.count = 1, .reusable = false}, SHIFT(6865),
  [10417] = {.count = 1, .reusable = true}, SHIFT(6865),
  [10419] = {.count = 1, .reusable = false}, SHIFT(6867),
  [10421] = {.count = 1, .reusable = false}, SHIFT(6868),
  [10423] = {.count = 1, .reusable = true}, SHIFT(6867),
  [10425] = {.count = 1, .reusable = true}, SHIFT(6863),
  [10427] = {.count = 1, .reusable = false}, SHIFT(6859),
  [10429] = {.count = 1, .reusable = true}, SHIFT(6869),
  [10431] = {.count = 1, .reusable = false}, SHIFT(6869),
  [10433] = {.count = 1, .reusable = true}, SHIFT(6870),
  [10435] = {.count = 1, .reusable = true}, SHIFT(6873),
  [10437] = {.count = 1, .reusable = true}, SHIFT(6875),
  [10439] = {.count = 1, .reusable = true}, SHIFT(6877),
  [10441] = {.count = 1, .reusable = false}, SHIFT(6875),
  [10443] = {.count = 1, .reusable = true}, SHIFT(6890),
  [10445] = {.count = 1, .reusable = true}, SHIFT(1835),
  [10447] = {.count = 1, .reusable = false}, SHIFT(6902),
  [10449] = {.count = 1, .reusable = false}, SHIFT(6903),
  [10451] = {.count = 1, .reusable = true}, SHIFT(6906),
  [10453] = {.count = 1, .reusable = true}, SHIFT(6907),
  [10455] = {.count = 2, .reusable = true}, REDUCE(aux_sym_call_repeat1, 2), SHIFT_REPEAT(1884),
  [10458] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(1886),
  [10461] = {.count = 1, .reusable = true}, SHIFT(6911),
  [10463] = {.count = 1, .reusable = true}, SHIFT(6912),
  [10465] = {.count = 1, .reusable = true}, SHIFT(6913),
  [10467] = {.count = 1, .reusable = true}, SHIFT(6914),
  [10469] = {.count = 1, .reusable = false}, SHIFT(6915),
  [10471] = {.count = 1, .reusable = true}, SHIFT(6917),
  [10473] = {.count = 1, .reusable = true}, SHIFT(6920),
  [10475] = {.count = 1, .reusable = true}, SHIFT(6922),
  [10477] = {.count = 1, .reusable = true}, SHIFT(6923),
  [10479] = {.count = 1, .reusable = false}, SHIFT(6923),
  [10481] = {.count = 1, .reusable = true}, SHIFT(6925),
  [10483] = {.count = 1, .reusable = true}, SHIFT(6927),
  [10485] = {.count = 1, .reusable = true}, SHIFT(6928),
  [10487] = {.count = 1, .reusable = true}, SHIFT(6929),
  [10489] = {.count = 1, .reusable = true}, SHIFT(6930),
  [10491] = {.count = 1, .reusable = true}, SHIFT(6932),
  [10493] = {.count = 1, .reusable = true}, SHIFT(6933),
  [10495] = {.count = 1, .reusable = true}, SHIFT(6934),
  [10497] = {.count = 1, .reusable = true}, SHIFT(6935),
  [10499] = {.count = 1, .reusable = true}, SHIFT(6936),
  [10501] = {.count = 1, .reusable = true}, SHIFT(6938),
  [10503] = {.count = 1, .reusable = true}, SHIFT(6939),
  [10505] = {.count = 1, .reusable = true}, SHIFT(6940),
  [10507] = {.count = 1, .reusable = true}, SHIFT(6941),
  [10509] = {.count = 1, .reusable = true}, SHIFT(6942),
  [10511] = {.count = 1, .reusable = true}, SHIFT(1964),
  [10513] = {.count = 1, .reusable = false}, SHIFT(6944),
  [10515] = {.count = 1, .reusable = true}, SHIFT(6945),
  [10517] = {.count = 1, .reusable = true}, SHIFT(6946),
  [10519] = {.count = 1, .reusable = false}, SHIFT(6947),
  [10521] = {.count = 1, .reusable = false}, SHIFT(6948),
  [10523] = {.count = 1, .reusable = true}, SHIFT(6949),
  [10525] = {.count = 1, .reusable = false}, SHIFT(6949),
  [10527] = {.count = 1, .reusable = true}, SHIFT(6951),
  [10529] = {.count = 1, .reusable = false}, SHIFT(6951),
  [10531] = {.count = 1, .reusable = false}, SHIFT(6953),
  [10533] = {.count = 1, .reusable = false}, SHIFT(6955),
  [10535] = {.count = 1, .reusable = true}, SHIFT(6957),
  [10537] = {.count = 1, .reusable = true}, SHIFT(6958),
  [10539] = {.count = 1, .reusable = false}, SHIFT(6958),
  [10541] = {.count = 1, .reusable = true}, SHIFT(6960),
  [10543] = {.count = 1, .reusable = true}, SHIFT(6963),
  [10545] = {.count = 1, .reusable = true}, SHIFT(6961),
  [10547] = {.count = 1, .reusable = true}, SHIFT(6965),
  [10549] = {.count = 1, .reusable = true}, SHIFT(6968),
  [10551] = {.count = 1, .reusable = true}, SHIFT(6969),
  [10553] = {.count = 2, .reusable = true}, REDUCE(aux_sym_call_repeat1, 2), SHIFT_REPEAT(2019),
  [10556] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(2021),
  [10559] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(609),
  [10562] = {.count = 1, .reusable = true}, SHIFT(6988),
  [10564] = {.count = 1, .reusable = true}, REDUCE(sym__hash_items, 4),
  [10566] = {.count = 1, .reusable = true}, SHIFT(6991),
  [10568] = {.count = 1, .reusable = true}, SHIFT(6992),
  [10570] = {.count = 1, .reusable = false}, SHIFT(6993),
  [10572] = {.count = 1, .reusable = false}, SHIFT(6994),
  [10574] = {.count = 1, .reusable = false}, SHIFT(6995),
  [10576] = {.count = 1, .reusable = true}, SHIFT(6996),
  [10578] = {.count = 1, .reusable = false}, SHIFT(6997),
  [10580] = {.count = 1, .reusable = true}, SHIFT(6997),
  [10582] = {.count = 1, .reusable = true}, SHIFT(6999),
  [10584] = {.count = 1, .reusable = true}, SHIFT(7000),
  [10586] = {.count = 1, .reusable = false}, SHIFT(6999),
  [10588] = {.count = 1, .reusable = true}, SHIFT(6995),
  [10590] = {.count = 1, .reusable = true}, SHIFT(6993),
  [10592] = {.count = 1, .reusable = true}, SHIFT(7001),
  [10594] = {.count = 1, .reusable = false}, SHIFT(7001),
  [10596] = {.count = 1, .reusable = true}, SHIFT(7002),
  [10598] = {.count = 1, .reusable = true}, SHIFT(2053),
  [10600] = {.count = 1, .reusable = true}, SHIFT(7023),
  [10602] = {.count = 1, .reusable = true}, SHIFT(7026),
  [10604] = {.count = 1, .reusable = true}, SHIFT(7027),
  [10606] = {.count = 1, .reusable = false}, SHIFT(7028),
  [10608] = {.count = 1, .reusable = false}, SHIFT(7027),
  [10610] = {.count = 1, .reusable = false}, SHIFT(7029),
  [10612] = {.count = 1, .reusable = false}, SHIFT(7030),
  [10614] = {.count = 1, .reusable = true}, SHIFT(7031),
  [10616] = {.count = 1, .reusable = false}, SHIFT(7032),
  [10618] = {.count = 1, .reusable = true}, SHIFT(7032),
  [10620] = {.count = 1, .reusable = false}, SHIFT(7034),
  [10622] = {.count = 1, .reusable = false}, SHIFT(7035),
  [10624] = {.count = 1, .reusable = true}, SHIFT(7034),
  [10626] = {.count = 1, .reusable = true}, SHIFT(7030),
  [10628] = {.count = 1, .reusable = false}, SHIFT(7026),
  [10630] = {.count = 1, .reusable = true}, SHIFT(7036),
  [10632] = {.count = 1, .reusable = false}, SHIFT(7036),
  [10634] = {.count = 1, .reusable = true}, SHIFT(7037),
  [10636] = {.count = 1, .reusable = true}, SHIFT(2079),
  [10638] = {.count = 1, .reusable = true}, SHIFT(7062),
  [10640] = {.count = 1, .reusable = true}, SHIFT(7063),
  [10642] = {.count = 1, .reusable = false}, SHIFT(7064),
  [10644] = {.count = 1, .reusable = false}, SHIFT(7065),
  [10646] = {.count = 1, .reusable = false}, SHIFT(7066),
  [10648] = {.count = 1, .reusable = true}, SHIFT(7067),
  [10650] = {.count = 1, .reusable = false}, SHIFT(7068),
  [10652] = {.count = 1, .reusable = true}, SHIFT(7068),
  [10654] = {.count = 1, .reusable = true}, SHIFT(7070),
  [10656] = {.count = 1, .reusable = true}, SHIFT(7071),
  [10658] = {.count = 1, .reusable = false}, SHIFT(7070),
  [10660] = {.count = 1, .reusable = true}, SHIFT(7066),
  [10662] = {.count = 1, .reusable = true}, SHIFT(7064),
  [10664] = {.count = 1, .reusable = true}, SHIFT(7072),
  [10666] = {.count = 1, .reusable = true}, SHIFT(7074),
  [10668] = {.count = 1, .reusable = false}, SHIFT(7074),
  [10670] = {.count = 1, .reusable = true}, SHIFT(7075),
  [10672] = {.count = 1, .reusable = true}, REDUCE(sym_method_parameters, 3),
  [10674] = {.count = 1, .reusable = false}, REDUCE(sym_method_parameters, 3),
  [10676] = {.count = 1, .reusable = true}, SHIFT(7077),
  [10678] = {.count = 1, .reusable = true}, SHIFT(7078),
  [10680] = {.count = 1, .reusable = true}, SHIFT(7079),
  [10682] = {.count = 1, .reusable = true}, SHIFT(7085),
  [10684] = {.count = 1, .reusable = false}, SHIFT(7082),
  [10686] = {.count = 1, .reusable = true}, SHIFT(4479),
  [10688] = {.count = 1, .reusable = true}, SHIFT(5478),
  [10690] = {.count = 1, .reusable = true}, SHIFT(7088),
  [10692] = {.count = 1, .reusable = true}, SHIFT(7091),
  [10694] = {.count = 1, .reusable = true}, SHIFT(7092),
  [10696] = {.count = 1, .reusable = true}, SHIFT(7093),
  [10698] = {.count = 1, .reusable = false}, SHIFT(7095),
  [10700] = {.count = 1, .reusable = true}, SHIFT(7101),
  [10702] = {.count = 1, .reusable = true}, SHIFT(7102),
  [10704] = {.count = 1, .reusable = false}, SHIFT(7103),
  [10706] = {.count = 1, .reusable = false}, SHIFT(7104),
  [10708] = {.count = 1, .reusable = false}, SHIFT(7105),
  [10710] = {.count = 1, .reusable = true}, SHIFT(7106),
  [10712] = {.count = 1, .reusable = false}, SHIFT(7107),
  [10714] = {.count = 1, .reusable = true}, SHIFT(7107),
  [10716] = {.count = 1, .reusable = true}, SHIFT(7108),
  [10718] = {.count = 1, .reusable = true}, SHIFT(7109),
  [10720] = {.count = 1, .reusable = true}, SHIFT(7110),
  [10722] = {.count = 1, .reusable = false}, SHIFT(7109),
  [10724] = {.count = 1, .reusable = true}, SHIFT(7105),
  [10726] = {.count = 1, .reusable = true}, SHIFT(7103),
  [10728] = {.count = 1, .reusable = true}, SHIFT(7111),
  [10730] = {.count = 1, .reusable = false}, SHIFT(7111),
  [10732] = {.count = 1, .reusable = true}, SHIFT(7112),
  [10734] = {.count = 1, .reusable = true}, SHIFT(7117),
  [10736] = {.count = 1, .reusable = false}, SHIFT(7119),
  [10738] = {.count = 1, .reusable = true}, SHIFT(7121),
  [10740] = {.count = 1, .reusable = false}, SHIFT(7117),
  [10742] = {.count = 1, .reusable = true}, SHIFT(2146),
  [10744] = {.count = 1, .reusable = true}, SHIFT(7164),
  [10746] = {.count = 1, .reusable = true}, SHIFT(2167),
  [10748] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(2174),
  [10751] = {.count = 1, .reusable = true}, SHIFT(7188),
  [10753] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(2225),
  [10756] = {.count = 1, .reusable = true}, SHIFT(7204),
  [10758] = {.count = 1, .reusable = true}, SHIFT(7205),
  [10760] = {.count = 1, .reusable = true}, SHIFT(7206),
  [10762] = {.count = 1, .reusable = true}, SHIFT(7207),
  [10764] = {.count = 1, .reusable = true}, SHIFT(7208),
  [10766] = {.count = 1, .reusable = true}, SHIFT(7209),
  [10768] = {.count = 1, .reusable = true}, SHIFT(7210),
  [10770] = {.count = 1, .reusable = false}, SHIFT(7211),
  [10772] = {.count = 1, .reusable = false}, SHIFT(7212),
  [10774] = {.count = 1, .reusable = true}, SHIFT(7215),
  [10776] = {.count = 1, .reusable = false}, SHIFT(7217),
  [10778] = {.count = 1, .reusable = true}, SHIFT(7219),
  [10780] = {.count = 1, .reusable = false}, SHIFT(7215),
  [10782] = {.count = 1, .reusable = true}, SHIFT(7231),
  [10784] = {.count = 1, .reusable = false}, SHIFT(7232),
  [10786] = {.count = 1, .reusable = false}, SHIFT(7233),
  [10788] = {.count = 1, .reusable = false}, SHIFT(7234),
  [10790] = {.count = 1, .reusable = false}, SHIFT(7235),
  [10792] = {.count = 1, .reusable = false}, SHIFT(7231),
  [10794] = {.count = 1, .reusable = true}, SHIFT(7236),
  [10796] = {.count = 1, .reusable = false}, SHIFT(7236),
  [10798] = {.count = 1, .reusable = true}, SHIFT(7237),
  [10800] = {.count = 1, .reusable = true}, SHIFT(7243),
  [10802] = {.count = 1, .reusable = false}, SHIFT(7245),
  [10804] = {.count = 1, .reusable = true}, SHIFT(7247),
  [10806] = {.count = 1, .reusable = false}, SHIFT(7243),
  [10808] = {.count = 1, .reusable = true}, SHIFT(7253),
  [10810] = {.count = 2, .reusable = true}, REDUCE(aux_sym_call_repeat1, 2), SHIFT_REPEAT(2287),
  [10813] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(2289),
  [10816] = {.count = 1, .reusable = true}, SHIFT(7254),
  [10818] = {.count = 1, .reusable = true}, SHIFT(7255),
  [10820] = {.count = 1, .reusable = true}, SHIFT(7256),
  [10822] = {.count = 1, .reusable = true}, SHIFT(7257),
  [10824] = {.count = 1, .reusable = false}, SHIFT(7258),
  [10826] = {.count = 1, .reusable = true}, SHIFT(7260),
  [10828] = {.count = 1, .reusable = true}, SHIFT(7263),
  [10830] = {.count = 1, .reusable = true}, SHIFT(7265),
  [10832] = {.count = 1, .reusable = true}, SHIFT(7266),
  [10834] = {.count = 1, .reusable = false}, SHIFT(7266),
  [10836] = {.count = 1, .reusable = true}, SHIFT(7268),
  [10838] = {.count = 1, .reusable = true}, SHIFT(7269),
  [10840] = {.count = 1, .reusable = true}, SHIFT(7270),
  [10842] = {.count = 1, .reusable = true}, SHIFT(7271),
  [10844] = {.count = 1, .reusable = true}, SHIFT(7272),
  [10846] = {.count = 1, .reusable = true}, SHIFT(7273),
  [10848] = {.count = 1, .reusable = true}, SHIFT(7274),
  [10850] = {.count = 1, .reusable = false}, SHIFT(7275),
  [10852] = {.count = 1, .reusable = true}, SHIFT(7277),
  [10854] = {.count = 1, .reusable = true}, SHIFT(7278),
  [10856] = {.count = 1, .reusable = true}, SHIFT(7280),
  [10858] = {.count = 1, .reusable = false}, SHIFT(7281),
  [10860] = {.count = 1, .reusable = true}, SHIFT(7283),
  [10862] = {.count = 1, .reusable = true}, SHIFT(7284),
  [10864] = {.count = 1, .reusable = true}, SHIFT(7286),
  [10866] = {.count = 1, .reusable = true}, SHIFT(7289),
  [10868] = {.count = 1, .reusable = true}, SHIFT(7290),
  [10870] = {.count = 1, .reusable = true}, SHIFT(7291),
  [10872] = {.count = 1, .reusable = true}, SHIFT(7294),
  [10874] = {.count = 1, .reusable = true}, SHIFT(7296),
  [10876] = {.count = 1, .reusable = false}, SHIFT(7295),
  [10878] = {.count = 1, .reusable = true}, SHIFT(7299),
  [10880] = {.count = 1, .reusable = true}, SHIFT(7301),
  [10882] = {.count = 1, .reusable = false}, SHIFT(7303),
  [10884] = {.count = 1, .reusable = true}, SHIFT(7304),
  [10886] = {.count = 1, .reusable = true}, SHIFT(7306),
  [10888] = {.count = 1, .reusable = false}, SHIFT(7299),
  [10890] = {.count = 1, .reusable = true}, SHIFT(7309),
  [10892] = {.count = 1, .reusable = true}, SHIFT(7311),
  [10894] = {.count = 1, .reusable = true}, SHIFT(7312),
  [10896] = {.count = 1, .reusable = true}, SHIFT(7313),
  [10898] = {.count = 1, .reusable = true}, SHIFT(7315),
  [10900] = {.count = 1, .reusable = true}, SHIFT(7318),
  [10902] = {.count = 1, .reusable = true}, SHIFT(7316),
  [10904] = {.count = 1, .reusable = true}, SHIFT(7320),
  [10906] = {.count = 1, .reusable = false}, SHIFT(7324),
  [10908] = {.count = 1, .reusable = true}, SHIFT(7325),
  [10910] = {.count = 1, .reusable = true}, SHIFT(7326),
  [10912] = {.count = 1, .reusable = true}, SHIFT(7332),
  [10914] = {.count = 1, .reusable = false}, SHIFT(7329),
  [10916] = {.count = 1, .reusable = true}, SHIFT(4787),
  [10918] = {.count = 1, .reusable = true}, SHIFT(7344),
  [10920] = {.count = 1, .reusable = true}, SHIFT(2368),
  [10922] = {.count = 1, .reusable = true}, SHIFT(7356),
  [10924] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(2388),
  [10927] = {.count = 1, .reusable = true}, REDUCE(sym_singleton_class, 5),
  [10929] = {.count = 1, .reusable = false}, REDUCE(sym_singleton_class, 5),
  [10931] = {.count = 1, .reusable = true}, REDUCE(sym_class, 5),
  [10933] = {.count = 1, .reusable = false}, REDUCE(sym_class, 5),
  [10935] = {.count = 1, .reusable = true}, SHIFT(7361),
  [10937] = {.count = 1, .reusable = false}, SHIFT(7363),
  [10939] = {.count = 1, .reusable = true}, SHIFT(7365),
  [10941] = {.count = 1, .reusable = false}, SHIFT(7361),
  [10943] = {.count = 1, .reusable = true}, SHIFT(2419),
  [10945] = {.count = 1, .reusable = true}, SHIFT(7387),
  [10947] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(2438),
  [10950] = {.count = 1, .reusable = true}, SHIFT(7392),
  [10952] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(2468),
  [10955] = {.count = 1, .reusable = true}, SHIFT(7407),
  [10957] = {.count = 1, .reusable = true}, SHIFT(2490),
  [10959] = {.count = 1, .reusable = true}, SHIFT(7418),
  [10961] = {.count = 1, .reusable = true}, SHIFT(2511),
  [10963] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(7426),
  [10966] = {.count = 1, .reusable = true}, SHIFT(7431),
  [10968] = {.count = 1, .reusable = true}, SHIFT(7432),
  [10970] = {.count = 1, .reusable = true}, SHIFT(7433),
  [10972] = {.count = 1, .reusable = false}, SHIFT(7433),
  [10974] = {.count = 1, .reusable = true}, SHIFT(7435),
  [10976] = {.count = 1, .reusable = true}, SHIFT(7436),
  [10978] = {.count = 2, .reusable = true}, REDUCE(aux_sym_call_repeat1, 2), SHIFT_REPEAT(2557),
  [10981] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(2559),
  [10984] = {.count = 1, .reusable = true}, SHIFT(7438),
  [10986] = {.count = 1, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 3),
  [10988] = {.count = 1, .reusable = false}, REDUCE(aux_sym_argument_list_repeat1, 3),
  [10990] = {.count = 1, .reusable = true}, SHIFT(4987),
  [10992] = {.count = 1, .reusable = true}, SHIFT(2593),
  [10994] = {.count = 1, .reusable = true}, SHIFT(7463),
  [10996] = {.count = 1, .reusable = true}, SHIFT(2614),
  [10998] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(2621),
  [11001] = {.count = 1, .reusable = true}, SHIFT(7472),
  [11003] = {.count = 1, .reusable = false}, SHIFT(7473),
  [11005] = {.count = 1, .reusable = false}, SHIFT(7474),
  [11007] = {.count = 1, .reusable = false}, SHIFT(7475),
  [11009] = {.count = 1, .reusable = false}, SHIFT(7476),
  [11011] = {.count = 1, .reusable = false}, SHIFT(7472),
  [11013] = {.count = 1, .reusable = true}, SHIFT(7477),
  [11015] = {.count = 1, .reusable = false}, SHIFT(7477),
  [11017] = {.count = 1, .reusable = true}, SHIFT(7478),
  [11019] = {.count = 1, .reusable = false}, SHIFT(5046),
  [11021] = {.count = 1, .reusable = true}, SHIFT(7486),
  [11023] = {.count = 1, .reusable = true}, SHIFT(7488),
  [11025] = {.count = 1, .reusable = true}, SHIFT(7489),
  [11027] = {.count = 1, .reusable = true}, SHIFT(7490),
  [11029] = {.count = 1, .reusable = false}, SHIFT(7492),
  [11031] = {.count = 1, .reusable = false}, SHIFT(7498),
  [11033] = {.count = 1, .reusable = true}, SHIFT(7499),
  [11035] = {.count = 1, .reusable = true}, SHIFT(7500),
  [11037] = {.count = 1, .reusable = false}, SHIFT(7501),
  [11039] = {.count = 1, .reusable = false}, SHIFT(7502),
  [11041] = {.count = 1, .reusable = false}, SHIFT(7503),
  [11043] = {.count = 1, .reusable = true}, SHIFT(7504),
  [11045] = {.count = 1, .reusable = false}, SHIFT(7505),
  [11047] = {.count = 1, .reusable = true}, SHIFT(7505),
  [11049] = {.count = 1, .reusable = true}, SHIFT(7507),
  [11051] = {.count = 1, .reusable = true}, SHIFT(7508),
  [11053] = {.count = 1, .reusable = false}, SHIFT(7507),
  [11055] = {.count = 1, .reusable = true}, SHIFT(7503),
  [11057] = {.count = 1, .reusable = true}, SHIFT(7501),
  [11059] = {.count = 1, .reusable = true}, SHIFT(7509),
  [11061] = {.count = 1, .reusable = true}, SHIFT(7510),
  [11063] = {.count = 1, .reusable = true}, SHIFT(7511),
  [11065] = {.count = 1, .reusable = false}, SHIFT(7513),
  [11067] = {.count = 1, .reusable = true}, SHIFT(7519),
  [11069] = {.count = 1, .reusable = true}, SHIFT(7521),
  [11071] = {.count = 1, .reusable = false}, SHIFT(7521),
  [11073] = {.count = 1, .reusable = true}, SHIFT(7522),
  [11075] = {.count = 1, .reusable = false}, SHIFT(7486),
  [11077] = {.count = 1, .reusable = true}, SHIFT(7540),
  [11079] = {.count = 1, .reusable = false}, SHIFT(7541),
  [11081] = {.count = 1, .reusable = false}, SHIFT(7542),
  [11083] = {.count = 1, .reusable = false}, SHIFT(7543),
  [11085] = {.count = 1, .reusable = false}, SHIFT(7544),
  [11087] = {.count = 1, .reusable = false}, SHIFT(7540),
  [11089] = {.count = 1, .reusable = true}, SHIFT(7545),
  [11091] = {.count = 1, .reusable = false}, SHIFT(7545),
  [11093] = {.count = 1, .reusable = true}, SHIFT(7546),
  [11095] = {.count = 1, .reusable = false}, SHIFT(7548),
  [11097] = {.count = 1, .reusable = true}, SHIFT(7548),
  [11099] = {.count = 1, .reusable = false}, SHIFT(5082),
  [11101] = {.count = 1, .reusable = true}, SHIFT(7555),
  [11103] = {.count = 1, .reusable = false}, SHIFT(7558),
  [11105] = {.count = 1, .reusable = true}, SHIFT(7559),
  [11107] = {.count = 1, .reusable = true}, SHIFT(7560),
  [11109] = {.count = 1, .reusable = false}, SHIFT(7561),
  [11111] = {.count = 1, .reusable = false}, SHIFT(7560),
  [11113] = {.count = 1, .reusable = false}, SHIFT(7562),
  [11115] = {.count = 1, .reusable = false}, SHIFT(7563),
  [11117] = {.count = 1, .reusable = true}, SHIFT(7564),
  [11119] = {.count = 1, .reusable = false}, SHIFT(7565),
  [11121] = {.count = 1, .reusable = true}, SHIFT(7565),
  [11123] = {.count = 1, .reusable = false}, SHIFT(7567),
  [11125] = {.count = 1, .reusable = false}, SHIFT(7568),
  [11127] = {.count = 1, .reusable = true}, SHIFT(7567),
  [11129] = {.count = 1, .reusable = true}, SHIFT(7563),
  [11131] = {.count = 1, .reusable = false}, SHIFT(7559),
  [11133] = {.count = 1, .reusable = true}, SHIFT(7570),
  [11135] = {.count = 1, .reusable = true}, SHIFT(7572),
  [11137] = {.count = 1, .reusable = false}, SHIFT(7572),
  [11139] = {.count = 1, .reusable = true}, SHIFT(7573),
  [11141] = {.count = 1, .reusable = false}, SHIFT(7555),
  [11143] = {.count = 1, .reusable = true}, SHIFT(7575),
  [11145] = {.count = 1, .reusable = true}, SHIFT(7576),
  [11147] = {.count = 1, .reusable = false}, SHIFT(7576),
  [11149] = {.count = 1, .reusable = true}, SHIFT(7577),
  [11151] = {.count = 1, .reusable = false}, SHIFT(7577),
  [11153] = {.count = 1, .reusable = true}, SHIFT(7578),
  [11155] = {.count = 1, .reusable = true}, SHIFT(7586),
  [11157] = {.count = 1, .reusable = true}, REDUCE(sym_if, 5),
  [11159] = {.count = 1, .reusable = false}, REDUCE(sym_if, 5),
  [11161] = {.count = 1, .reusable = true}, REDUCE(sym_then, 3),
  [11163] = {.count = 1, .reusable = true}, SHIFT(7602),
  [11165] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(2692),
  [11168] = {.count = 1, .reusable = true}, SHIFT(7618),
  [11170] = {.count = 1, .reusable = false}, SHIFT(7619),
  [11172] = {.count = 1, .reusable = false}, SHIFT(7620),
  [11174] = {.count = 1, .reusable = false}, SHIFT(7621),
  [11176] = {.count = 1, .reusable = false}, SHIFT(7622),
  [11178] = {.count = 1, .reusable = false}, SHIFT(7618),
  [11180] = {.count = 1, .reusable = true}, SHIFT(7623),
  [11182] = {.count = 1, .reusable = false}, SHIFT(7623),
  [11184] = {.count = 1, .reusable = true}, SHIFT(7624),
  [11186] = {.count = 1, .reusable = false}, SHIFT(5163),
  [11188] = {.count = 1, .reusable = true}, SHIFT(7632),
  [11190] = {.count = 1, .reusable = true}, SHIFT(7634),
  [11192] = {.count = 1, .reusable = true}, SHIFT(7635),
  [11194] = {.count = 1, .reusable = true}, SHIFT(7636),
  [11196] = {.count = 1, .reusable = false}, SHIFT(7638),
  [11198] = {.count = 1, .reusable = false}, SHIFT(7644),
  [11200] = {.count = 1, .reusable = true}, SHIFT(7645),
  [11202] = {.count = 1, .reusable = true}, SHIFT(7646),
  [11204] = {.count = 1, .reusable = false}, SHIFT(7647),
  [11206] = {.count = 1, .reusable = false}, SHIFT(7648),
  [11208] = {.count = 1, .reusable = false}, SHIFT(7649),
  [11210] = {.count = 1, .reusable = true}, SHIFT(7650),
  [11212] = {.count = 1, .reusable = false}, SHIFT(7651),
  [11214] = {.count = 1, .reusable = true}, SHIFT(7651),
  [11216] = {.count = 1, .reusable = true}, SHIFT(7653),
  [11218] = {.count = 1, .reusable = true}, SHIFT(7654),
  [11220] = {.count = 1, .reusable = false}, SHIFT(7653),
  [11222] = {.count = 1, .reusable = true}, SHIFT(7649),
  [11224] = {.count = 1, .reusable = true}, SHIFT(7647),
  [11226] = {.count = 1, .reusable = true}, SHIFT(7655),
  [11228] = {.count = 1, .reusable = true}, SHIFT(7656),
  [11230] = {.count = 1, .reusable = true}, SHIFT(7657),
  [11232] = {.count = 1, .reusable = false}, SHIFT(7659),
  [11234] = {.count = 1, .reusable = true}, SHIFT(7665),
  [11236] = {.count = 1, .reusable = true}, SHIFT(7667),
  [11238] = {.count = 1, .reusable = false}, SHIFT(7667),
  [11240] = {.count = 1, .reusable = true}, SHIFT(7668),
  [11242] = {.count = 1, .reusable = false}, SHIFT(7632),
  [11244] = {.count = 1, .reusable = true}, SHIFT(7686),
  [11246] = {.count = 1, .reusable = false}, SHIFT(7687),
  [11248] = {.count = 1, .reusable = false}, SHIFT(7688),
  [11250] = {.count = 1, .reusable = false}, SHIFT(7689),
  [11252] = {.count = 1, .reusable = false}, SHIFT(7690),
  [11254] = {.count = 1, .reusable = false}, SHIFT(7686),
  [11256] = {.count = 1, .reusable = true}, SHIFT(7691),
  [11258] = {.count = 1, .reusable = false}, SHIFT(7691),
  [11260] = {.count = 1, .reusable = true}, SHIFT(7692),
  [11262] = {.count = 1, .reusable = false}, SHIFT(7694),
  [11264] = {.count = 1, .reusable = true}, SHIFT(7694),
  [11266] = {.count = 1, .reusable = false}, SHIFT(5199),
  [11268] = {.count = 1, .reusable = true}, SHIFT(7701),
  [11270] = {.count = 1, .reusable = false}, SHIFT(7704),
  [11272] = {.count = 1, .reusable = true}, SHIFT(7705),
  [11274] = {.count = 1, .reusable = true}, SHIFT(7706),
  [11276] = {.count = 1, .reusable = false}, SHIFT(7707),
  [11278] = {.count = 1, .reusable = false}, SHIFT(7706),
  [11280] = {.count = 1, .reusable = false}, SHIFT(7708),
  [11282] = {.count = 1, .reusable = false}, SHIFT(7709),
  [11284] = {.count = 1, .reusable = true}, SHIFT(7710),
  [11286] = {.count = 1, .reusable = false}, SHIFT(7711),
  [11288] = {.count = 1, .reusable = true}, SHIFT(7711),
  [11290] = {.count = 1, .reusable = false}, SHIFT(7713),
  [11292] = {.count = 1, .reusable = false}, SHIFT(7714),
  [11294] = {.count = 1, .reusable = true}, SHIFT(7713),
  [11296] = {.count = 1, .reusable = true}, SHIFT(7709),
  [11298] = {.count = 1, .reusable = false}, SHIFT(7705),
  [11300] = {.count = 1, .reusable = true}, SHIFT(7716),
  [11302] = {.count = 1, .reusable = true}, SHIFT(7718),
  [11304] = {.count = 1, .reusable = false}, SHIFT(7718),
  [11306] = {.count = 1, .reusable = true}, SHIFT(7719),
  [11308] = {.count = 1, .reusable = false}, SHIFT(7701),
  [11310] = {.count = 1, .reusable = true}, SHIFT(7721),
  [11312] = {.count = 1, .reusable = true}, SHIFT(7722),
  [11314] = {.count = 1, .reusable = false}, SHIFT(7722),
  [11316] = {.count = 1, .reusable = true}, SHIFT(7723),
  [11318] = {.count = 1, .reusable = false}, SHIFT(7723),
  [11320] = {.count = 1, .reusable = true}, SHIFT(7724),
  [11322] = {.count = 1, .reusable = true}, REDUCE(sym_unless, 5),
  [11324] = {.count = 1, .reusable = false}, REDUCE(sym_unless, 5),
  [11326] = {.count = 1, .reusable = true}, SHIFT(2744),
  [11328] = {.count = 1, .reusable = true}, SHIFT(7753),
  [11330] = {.count = 1, .reusable = true}, SHIFT(2766),
  [11332] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(2773),
  [11335] = {.count = 1, .reusable = true}, REDUCE(sym_while, 5),
  [11337] = {.count = 1, .reusable = false}, REDUCE(sym_while, 5),
  [11339] = {.count = 1, .reusable = true}, SHIFT(7777),
  [11341] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(2821),
  [11344] = {.count = 1, .reusable = true}, REDUCE(sym_until, 5),
  [11346] = {.count = 1, .reusable = false}, REDUCE(sym_until, 5),
  [11348] = {.count = 1, .reusable = true}, SHIFT(7795),
  [11350] = {.count = 1, .reusable = false}, SHIFT(7797),
  [11352] = {.count = 1, .reusable = true}, SHIFT(7799),
  [11354] = {.count = 1, .reusable = false}, SHIFT(7795),
  [11356] = {.count = 1, .reusable = true}, SHIFT(7811),
  [11358] = {.count = 1, .reusable = false}, SHIFT(7812),
  [11360] = {.count = 1, .reusable = false}, SHIFT(7813),
  [11362] = {.count = 1, .reusable = false}, SHIFT(7814),
  [11364] = {.count = 1, .reusable = false}, SHIFT(7815),
  [11366] = {.count = 1, .reusable = false}, SHIFT(7811),
  [11368] = {.count = 1, .reusable = true}, SHIFT(7816),
  [11370] = {.count = 1, .reusable = false}, SHIFT(7816),
  [11372] = {.count = 1, .reusable = true}, SHIFT(7817),
  [11374] = {.count = 1, .reusable = true}, SHIFT(7823),
  [11376] = {.count = 1, .reusable = false}, SHIFT(7825),
  [11378] = {.count = 1, .reusable = true}, SHIFT(7827),
  [11380] = {.count = 1, .reusable = false}, SHIFT(7823),
  [11382] = {.count = 1, .reusable = true}, SHIFT(2858),
  [11384] = {.count = 1, .reusable = true}, SHIFT(7839),
  [11386] = {.count = 1, .reusable = true}, SHIFT(2880),
  [11388] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(2895),
  [11391] = {.count = 1, .reusable = true}, REDUCE(sym_for, 5),
  [11393] = {.count = 1, .reusable = false}, REDUCE(sym_for, 5),
  [11395] = {.count = 1, .reusable = true}, SHIFT(7862),
  [11397] = {.count = 1, .reusable = true}, SHIFT(2923),
  [11399] = {.count = 1, .reusable = true}, SHIFT(7885),
  [11401] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(2942),
  [11404] = {.count = 1, .reusable = true}, REDUCE(sym_case, 5),
  [11406] = {.count = 1, .reusable = false}, REDUCE(sym_case, 5),
  [11408] = {.count = 1, .reusable = true}, SHIFT(7889),
  [11410] = {.count = 1, .reusable = true}, SHIFT(7904),
  [11412] = {.count = 1, .reusable = false}, SHIFT(7904),
  [11414] = {.count = 1, .reusable = true}, SHIFT(7905),
  [11416] = {.count = 1, .reusable = false}, SHIFT(7905),
  [11418] = {.count = 1, .reusable = true}, SHIFT(7906),
  [11420] = {.count = 1, .reusable = true}, SHIFT(7911),
  [11422] = {.count = 1, .reusable = false}, SHIFT(7913),
  [11424] = {.count = 1, .reusable = true}, SHIFT(7915),
  [11426] = {.count = 1, .reusable = false}, SHIFT(7911),
  [11428] = {.count = 1, .reusable = true}, SHIFT(7918),
  [11430] = {.count = 1, .reusable = false}, SHIFT(7919),
  [11432] = {.count = 1, .reusable = false}, SHIFT(7920),
  [11434] = {.count = 1, .reusable = false}, SHIFT(7921),
  [11436] = {.count = 1, .reusable = false}, SHIFT(7922),
  [11438] = {.count = 1, .reusable = false}, SHIFT(7918),
  [11440] = {.count = 1, .reusable = true}, SHIFT(7923),
  [11442] = {.count = 1, .reusable = false}, SHIFT(7923),
  [11444] = {.count = 1, .reusable = true}, SHIFT(7924),
  [11446] = {.count = 1, .reusable = false}, SHIFT(7928),
  [11448] = {.count = 1, .reusable = true}, SHIFT(7928),
  [11450] = {.count = 1, .reusable = false}, SHIFT(7925),
  [11452] = {.count = 1, .reusable = true}, REDUCE(sym_when, 3),
  [11454] = {.count = 1, .reusable = false}, REDUCE(sym_when, 3),
  [11456] = {.count = 1, .reusable = false}, SHIFT(7933),
  [11458] = {.count = 1, .reusable = true}, SHIFT(7935),
  [11460] = {.count = 1, .reusable = true}, SHIFT(7947),
  [11462] = {.count = 1, .reusable = false}, SHIFT(7948),
  [11464] = {.count = 1, .reusable = false}, SHIFT(7949),
  [11466] = {.count = 1, .reusable = false}, SHIFT(7950),
  [11468] = {.count = 1, .reusable = false}, SHIFT(7951),
  [11470] = {.count = 1, .reusable = false}, SHIFT(7947),
  [11472] = {.count = 1, .reusable = true}, SHIFT(7952),
  [11474] = {.count = 1, .reusable = false}, SHIFT(7952),
  [11476] = {.count = 1, .reusable = true}, SHIFT(7953),
  [11478] = {.count = 1, .reusable = false}, SHIFT(7955),
  [11480] = {.count = 1, .reusable = true}, SHIFT(7955),
  [11482] = {.count = 1, .reusable = true}, SHIFT(7960),
  [11484] = {.count = 1, .reusable = false}, SHIFT(7962),
  [11486] = {.count = 1, .reusable = true}, SHIFT(7964),
  [11488] = {.count = 1, .reusable = false}, SHIFT(7960),
  [11490] = {.count = 1, .reusable = true}, SHIFT(7966),
  [11492] = {.count = 1, .reusable = true}, SHIFT(3009),
  [11494] = {.count = 1, .reusable = true}, SHIFT(7993),
  [11496] = {.count = 1, .reusable = true}, SHIFT(3030),
  [11498] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(3037),
  [11501] = {.count = 1, .reusable = true}, SHIFT(3048),
  [11503] = {.count = 1, .reusable = true}, SHIFT(8021),
  [11505] = {.count = 1, .reusable = false}, SHIFT(8021),
  [11507] = {.count = 1, .reusable = true}, SHIFT(8022),
  [11509] = {.count = 1, .reusable = true}, SHIFT(8023),
  [11511] = {.count = 1, .reusable = true}, SHIFT(8026),
  [11513] = {.count = 1, .reusable = true}, SHIFT(8028),
  [11515] = {.count = 1, .reusable = false}, SHIFT(8029),
  [11517] = {.count = 1, .reusable = false}, SHIFT(8030),
  [11519] = {.count = 1, .reusable = false}, SHIFT(8031),
  [11521] = {.count = 1, .reusable = false}, SHIFT(8032),
  [11523] = {.count = 1, .reusable = false}, SHIFT(8028),
  [11525] = {.count = 1, .reusable = true}, SHIFT(8033),
  [11527] = {.count = 1, .reusable = false}, SHIFT(8033),
  [11529] = {.count = 1, .reusable = true}, SHIFT(8034),
  [11531] = {.count = 1, .reusable = true}, SHIFT(8042),
  [11533] = {.count = 1, .reusable = true}, SHIFT(8043),
  [11535] = {.count = 1, .reusable = true}, SHIFT(8045),
  [11537] = {.count = 1, .reusable = true}, SHIFT(8046),
  [11539] = {.count = 1, .reusable = true}, SHIFT(8047),
  [11541] = {.count = 1, .reusable = false}, SHIFT(5613),
  [11543] = {.count = 1, .reusable = false}, SHIFT(8049),
  [11545] = {.count = 1, .reusable = true}, SHIFT(8054),
  [11547] = {.count = 1, .reusable = false}, SHIFT(8057),
  [11549] = {.count = 1, .reusable = true}, SHIFT(8058),
  [11551] = {.count = 1, .reusable = true}, SHIFT(8059),
  [11553] = {.count = 1, .reusable = false}, SHIFT(8060),
  [11555] = {.count = 1, .reusable = false}, SHIFT(8061),
  [11557] = {.count = 1, .reusable = false}, SHIFT(8062),
  [11559] = {.count = 1, .reusable = true}, SHIFT(8063),
  [11561] = {.count = 1, .reusable = false}, SHIFT(8064),
  [11563] = {.count = 1, .reusable = true}, SHIFT(8064),
  [11565] = {.count = 1, .reusable = true}, SHIFT(8065),
  [11567] = {.count = 1, .reusable = true}, SHIFT(8066),
  [11569] = {.count = 1, .reusable = true}, SHIFT(8067),
  [11571] = {.count = 1, .reusable = false}, SHIFT(8066),
  [11573] = {.count = 1, .reusable = true}, SHIFT(8062),
  [11575] = {.count = 1, .reusable = true}, SHIFT(8060),
  [11577] = {.count = 1, .reusable = true}, SHIFT(8069),
  [11579] = {.count = 1, .reusable = true}, SHIFT(8071),
  [11581] = {.count = 1, .reusable = true}, SHIFT(8073),
  [11583] = {.count = 1, .reusable = false}, SHIFT(8073),
  [11585] = {.count = 1, .reusable = true}, SHIFT(8074),
  [11587] = {.count = 1, .reusable = false}, SHIFT(8042),
  [11589] = {.count = 1, .reusable = true}, REDUCE(sym_rescue, 4),
  [11591] = {.count = 1, .reusable = false}, REDUCE(sym_rescue, 4),
  [11593] = {.count = 1, .reusable = true}, SHIFT(8077),
  [11595] = {.count = 1, .reusable = true}, SHIFT(3083),
  [11597] = {.count = 1, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2),
  [11599] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(3098),
  [11602] = {.count = 1, .reusable = true}, SHIFT(8105),
  [11604] = {.count = 1, .reusable = true}, SHIFT(8106),
  [11606] = {.count = 1, .reusable = false}, SHIFT(8107),
  [11608] = {.count = 1, .reusable = false}, SHIFT(8108),
  [11610] = {.count = 1, .reusable = false}, SHIFT(8109),
  [11612] = {.count = 1, .reusable = true}, SHIFT(8110),
  [11614] = {.count = 1, .reusable = false}, SHIFT(8111),
  [11616] = {.count = 1, .reusable = true}, SHIFT(8111),
  [11618] = {.count = 1, .reusable = true}, SHIFT(8113),
  [11620] = {.count = 1, .reusable = true}, SHIFT(8114),
  [11622] = {.count = 1, .reusable = false}, SHIFT(8113),
  [11624] = {.count = 1, .reusable = true}, SHIFT(8109),
  [11626] = {.count = 1, .reusable = true}, SHIFT(8107),
  [11628] = {.count = 1, .reusable = true}, SHIFT(8115),
  [11630] = {.count = 1, .reusable = false}, SHIFT(8115),
  [11632] = {.count = 1, .reusable = true}, SHIFT(8116),
  [11634] = {.count = 1, .reusable = true}, SHIFT(8121),
  [11636] = {.count = 1, .reusable = false}, SHIFT(8123),
  [11638] = {.count = 1, .reusable = true}, SHIFT(8125),
  [11640] = {.count = 1, .reusable = false}, SHIFT(8121),
  [11642] = {.count = 1, .reusable = true}, SHIFT(8140),
  [11644] = {.count = 1, .reusable = false}, SHIFT(8142),
  [11646] = {.count = 1, .reusable = true}, SHIFT(8144),
  [11648] = {.count = 1, .reusable = false}, SHIFT(8140),
  [11650] = {.count = 1, .reusable = true}, SHIFT(3109),
  [11652] = {.count = 1, .reusable = true}, SHIFT(8155),
  [11654] = {.count = 1, .reusable = true}, SHIFT(8158),
  [11656] = {.count = 1, .reusable = true}, SHIFT(8159),
  [11658] = {.count = 1, .reusable = false}, SHIFT(8160),
  [11660] = {.count = 1, .reusable = false}, SHIFT(8159),
  [11662] = {.count = 1, .reusable = false}, SHIFT(8161),
  [11664] = {.count = 1, .reusable = false}, SHIFT(8162),
  [11666] = {.count = 1, .reusable = true}, SHIFT(8163),
  [11668] = {.count = 1, .reusable = false}, SHIFT(8164),
  [11670] = {.count = 1, .reusable = true}, SHIFT(8164),
  [11672] = {.count = 1, .reusable = false}, SHIFT(8166),
  [11674] = {.count = 1, .reusable = false}, SHIFT(8167),
  [11676] = {.count = 1, .reusable = true}, SHIFT(8166),
  [11678] = {.count = 1, .reusable = true}, SHIFT(8162),
  [11680] = {.count = 1, .reusable = false}, SHIFT(8158),
  [11682] = {.count = 1, .reusable = true}, SHIFT(8168),
  [11684] = {.count = 1, .reusable = false}, SHIFT(8168),
  [11686] = {.count = 1, .reusable = true}, SHIFT(8169),
  [11688] = {.count = 1, .reusable = true}, SHIFT(3145),
  [11690] = {.count = 1, .reusable = true}, SHIFT(8194),
  [11692] = {.count = 1, .reusable = true}, SHIFT(8195),
  [11694] = {.count = 1, .reusable = false}, SHIFT(8196),
  [11696] = {.count = 1, .reusable = false}, SHIFT(8197),
  [11698] = {.count = 1, .reusable = false}, SHIFT(8198),
  [11700] = {.count = 1, .reusable = true}, SHIFT(8199),
  [11702] = {.count = 1, .reusable = false}, SHIFT(8200),
  [11704] = {.count = 1, .reusable = true}, SHIFT(8200),
  [11706] = {.count = 1, .reusable = true}, SHIFT(8202),
  [11708] = {.count = 1, .reusable = true}, SHIFT(8203),
  [11710] = {.count = 1, .reusable = false}, SHIFT(8202),
  [11712] = {.count = 1, .reusable = true}, SHIFT(8198),
  [11714] = {.count = 1, .reusable = true}, SHIFT(8196),
  [11716] = {.count = 1, .reusable = true}, SHIFT(8204),
  [11718] = {.count = 1, .reusable = true}, SHIFT(8206),
  [11720] = {.count = 1, .reusable = false}, SHIFT(8206),
  [11722] = {.count = 1, .reusable = true}, SHIFT(8207),
  [11724] = {.count = 1, .reusable = true}, SHIFT(8212),
  [11726] = {.count = 1, .reusable = true}, SHIFT(8213),
  [11728] = {.count = 1, .reusable = false}, SHIFT(8214),
  [11730] = {.count = 1, .reusable = false}, SHIFT(8215),
  [11732] = {.count = 1, .reusable = false}, SHIFT(8216),
  [11734] = {.count = 1, .reusable = true}, SHIFT(8217),
  [11736] = {.count = 1, .reusable = false}, SHIFT(8218),
  [11738] = {.count = 1, .reusable = true}, SHIFT(8218),
  [11740] = {.count = 1, .reusable = true}, SHIFT(8220),
  [11742] = {.count = 1, .reusable = true}, SHIFT(8221),
  [11744] = {.count = 1, .reusable = false}, SHIFT(8220),
  [11746] = {.count = 1, .reusable = true}, SHIFT(8216),
  [11748] = {.count = 1, .reusable = true}, SHIFT(8214),
  [11750] = {.count = 1, .reusable = true}, SHIFT(8222),
  [11752] = {.count = 1, .reusable = false}, SHIFT(8222),
  [11754] = {.count = 1, .reusable = true}, SHIFT(8223),
  [11756] = {.count = 1, .reusable = true}, SHIFT(8228),
  [11758] = {.count = 1, .reusable = false}, SHIFT(8230),
  [11760] = {.count = 1, .reusable = true}, SHIFT(8232),
  [11762] = {.count = 1, .reusable = false}, SHIFT(8228),
  [11764] = {.count = 1, .reusable = true}, SHIFT(8247),
  [11766] = {.count = 1, .reusable = false}, SHIFT(8249),
  [11768] = {.count = 1, .reusable = true}, SHIFT(8251),
  [11770] = {.count = 1, .reusable = false}, SHIFT(8247),
  [11772] = {.count = 1, .reusable = true}, SHIFT(3171),
  [11774] = {.count = 1, .reusable = true}, SHIFT(8262),
  [11776] = {.count = 1, .reusable = true}, SHIFT(8265),
  [11778] = {.count = 1, .reusable = true}, SHIFT(8266),
  [11780] = {.count = 1, .reusable = false}, SHIFT(8267),
  [11782] = {.count = 1, .reusable = false}, SHIFT(8266),
  [11784] = {.count = 1, .reusable = false}, SHIFT(8268),
  [11786] = {.count = 1, .reusable = false}, SHIFT(8269),
  [11788] = {.count = 1, .reusable = true}, SHIFT(8270),
  [11790] = {.count = 1, .reusable = false}, SHIFT(8271),
  [11792] = {.count = 1, .reusable = true}, SHIFT(8271),
  [11794] = {.count = 1, .reusable = false}, SHIFT(8273),
  [11796] = {.count = 1, .reusable = false}, SHIFT(8274),
  [11798] = {.count = 1, .reusable = true}, SHIFT(8273),
  [11800] = {.count = 1, .reusable = true}, SHIFT(8269),
  [11802] = {.count = 1, .reusable = false}, SHIFT(8265),
  [11804] = {.count = 1, .reusable = true}, SHIFT(8275),
  [11806] = {.count = 1, .reusable = false}, SHIFT(8275),
  [11808] = {.count = 1, .reusable = true}, SHIFT(8276),
  [11810] = {.count = 1, .reusable = true}, SHIFT(3207),
  [11812] = {.count = 1, .reusable = true}, SHIFT(8301),
  [11814] = {.count = 1, .reusable = true}, SHIFT(8302),
  [11816] = {.count = 1, .reusable = false}, SHIFT(8303),
  [11818] = {.count = 1, .reusable = false}, SHIFT(8304),
  [11820] = {.count = 1, .reusable = false}, SHIFT(8305),
  [11822] = {.count = 1, .reusable = true}, SHIFT(8306),
  [11824] = {.count = 1, .reusable = false}, SHIFT(8307),
  [11826] = {.count = 1, .reusable = true}, SHIFT(8307),
  [11828] = {.count = 1, .reusable = true}, SHIFT(8309),
  [11830] = {.count = 1, .reusable = true}, SHIFT(8310),
  [11832] = {.count = 1, .reusable = false}, SHIFT(8309),
  [11834] = {.count = 1, .reusable = true}, SHIFT(8305),
  [11836] = {.count = 1, .reusable = true}, SHIFT(8303),
  [11838] = {.count = 1, .reusable = true}, SHIFT(8311),
  [11840] = {.count = 1, .reusable = true}, SHIFT(8313),
  [11842] = {.count = 1, .reusable = false}, SHIFT(8313),
  [11844] = {.count = 1, .reusable = true}, SHIFT(8314),
  [11846] = {.count = 1, .reusable = true}, REDUCE(sym__body_statement, 4),
  [11848] = {.count = 1, .reusable = false}, REDUCE(sym__body_statement, 4),
  [11850] = {.count = 1, .reusable = true}, SHIFT(8315),
  [11852] = {.count = 1, .reusable = true}, SHIFT(8331),
  [11854] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(3276),
  [11857] = {.count = 1, .reusable = true}, SHIFT(8347),
  [11859] = {.count = 1, .reusable = true}, SHIFT(8348),
  [11861] = {.count = 1, .reusable = true}, SHIFT(8349),
  [11863] = {.count = 1, .reusable = true}, SHIFT(8350),
  [11865] = {.count = 1, .reusable = true}, SHIFT(8351),
  [11867] = {.count = 1, .reusable = true}, SHIFT(8352),
  [11869] = {.count = 1, .reusable = true}, SHIFT(8355),
  [11871] = {.count = 1, .reusable = true}, SHIFT(8356),
  [11873] = {.count = 1, .reusable = false}, SHIFT(8357),
  [11875] = {.count = 1, .reusable = false}, SHIFT(8358),
  [11877] = {.count = 1, .reusable = false}, SHIFT(8359),
  [11879] = {.count = 1, .reusable = true}, SHIFT(8360),
  [11881] = {.count = 1, .reusable = false}, SHIFT(8361),
  [11883] = {.count = 1, .reusable = true}, SHIFT(8361),
  [11885] = {.count = 1, .reusable = true}, SHIFT(8363),
  [11887] = {.count = 1, .reusable = true}, SHIFT(8364),
  [11889] = {.count = 1, .reusable = false}, SHIFT(8363),
  [11891] = {.count = 1, .reusable = true}, SHIFT(8359),
  [11893] = {.count = 1, .reusable = true}, SHIFT(8357),
  [11895] = {.count = 1, .reusable = true}, SHIFT(8365),
  [11897] = {.count = 1, .reusable = false}, SHIFT(8365),
  [11899] = {.count = 1, .reusable = true}, SHIFT(8366),
  [11901] = {.count = 1, .reusable = true}, SHIFT(3314),
  [11903] = {.count = 1, .reusable = true}, SHIFT(8373),
  [11905] = {.count = 1, .reusable = true}, SHIFT(8376),
  [11907] = {.count = 1, .reusable = true}, SHIFT(8377),
  [11909] = {.count = 1, .reusable = false}, SHIFT(8378),
  [11911] = {.count = 1, .reusable = false}, SHIFT(8377),
  [11913] = {.count = 1, .reusable = false}, SHIFT(8379),
  [11915] = {.count = 1, .reusable = false}, SHIFT(8380),
  [11917] = {.count = 1, .reusable = true}, SHIFT(8381),
  [11919] = {.count = 1, .reusable = false}, SHIFT(8382),
  [11921] = {.count = 1, .reusable = true}, SHIFT(8382),
  [11923] = {.count = 1, .reusable = false}, SHIFT(8384),
  [11925] = {.count = 1, .reusable = false}, SHIFT(8385),
  [11927] = {.count = 1, .reusable = true}, SHIFT(8384),
  [11929] = {.count = 1, .reusable = true}, SHIFT(8380),
  [11931] = {.count = 1, .reusable = false}, SHIFT(8376),
  [11933] = {.count = 1, .reusable = true}, SHIFT(8386),
  [11935] = {.count = 1, .reusable = false}, SHIFT(8386),
  [11937] = {.count = 1, .reusable = true}, SHIFT(8387),
  [11939] = {.count = 1, .reusable = true}, SHIFT(3334),
  [11941] = {.count = 1, .reusable = true}, SHIFT(8398),
  [11943] = {.count = 1, .reusable = false}, SHIFT(8399),
  [11945] = {.count = 1, .reusable = false}, SHIFT(8400),
  [11947] = {.count = 1, .reusable = true}, SHIFT(8401),
  [11949] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(3373),
  [11952] = {.count = 1, .reusable = true}, SHIFT(8404),
  [11954] = {.count = 1, .reusable = true}, SHIFT(8405),
  [11956] = {.count = 1, .reusable = true}, SHIFT(8406),
  [11958] = {.count = 1, .reusable = true}, SHIFT(8407),
  [11960] = {.count = 1, .reusable = false}, SHIFT(8408),
  [11962] = {.count = 1, .reusable = true}, SHIFT(8410),
  [11964] = {.count = 1, .reusable = true}, SHIFT(8413),
  [11966] = {.count = 1, .reusable = true}, SHIFT(8415),
  [11968] = {.count = 1, .reusable = true}, SHIFT(8416),
  [11970] = {.count = 1, .reusable = false}, SHIFT(8416),
  [11972] = {.count = 1, .reusable = true}, SHIFT(8418),
  [11974] = {.count = 1, .reusable = true}, SHIFT(8420),
  [11976] = {.count = 1, .reusable = true}, SHIFT(8421),
  [11978] = {.count = 1, .reusable = true}, SHIFT(8422),
  [11980] = {.count = 1, .reusable = false}, SHIFT(8422),
  [11982] = {.count = 1, .reusable = true}, SHIFT(8424),
  [11984] = {.count = 1, .reusable = true}, SHIFT(8425),
  [11986] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(3449),
  [11989] = {.count = 1, .reusable = true}, REDUCE(sym__argument_list_with_trailing_comma, 4),
  [11991] = {.count = 1, .reusable = true}, SHIFT(6092),
  [11993] = {.count = 1, .reusable = true}, REDUCE(sym_block_parameters, 3),
  [11995] = {.count = 1, .reusable = false}, REDUCE(sym_block_parameters, 3),
  [11997] = {.count = 1, .reusable = true}, SHIFT(8431),
  [11999] = {.count = 1, .reusable = true}, SHIFT(8432),
  [12001] = {.count = 1, .reusable = true}, SHIFT(8433),
  [12003] = {.count = 1, .reusable = true}, SHIFT(8435),
  [12005] = {.count = 1, .reusable = false}, SHIFT(8436),
  [12007] = {.count = 1, .reusable = false}, SHIFT(8437),
  [12009] = {.count = 1, .reusable = false}, SHIFT(8438),
  [12011] = {.count = 1, .reusable = false}, SHIFT(8439),
  [12013] = {.count = 1, .reusable = false}, SHIFT(8435),
  [12015] = {.count = 1, .reusable = true}, SHIFT(8440),
  [12017] = {.count = 1, .reusable = false}, SHIFT(8440),
  [12019] = {.count = 1, .reusable = true}, SHIFT(8441),
  [12021] = {.count = 1, .reusable = false}, SHIFT(8443),
  [12023] = {.count = 1, .reusable = true}, SHIFT(8443),
  [12025] = {.count = 1, .reusable = true}, SHIFT(8448),
  [12027] = {.count = 1, .reusable = true}, SHIFT(8449),
  [12029] = {.count = 1, .reusable = true}, REDUCE(sym_block, 4),
  [12031] = {.count = 1, .reusable = false}, REDUCE(sym_block, 4),
  [12033] = {.count = 1, .reusable = true}, REDUCE(sym_destructured_parameter, 3),
  [12035] = {.count = 1, .reusable = true}, SHIFT(8451),
  [12037] = {.count = 1, .reusable = true}, SHIFT(7069),
  [12039] = {.count = 1, .reusable = true}, REDUCE(aux_sym_method_parameters_repeat1, 2),
  [12041] = {.count = 1, .reusable = true}, REDUCE(sym_lambda_parameters, 4),
  [12043] = {.count = 2, .reusable = true}, REDUCE(aux_sym_method_parameters_repeat1, 2), SHIFT_REPEAT(3476),
  [12046] = {.count = 1, .reusable = true}, SHIFT(8452),
  [12048] = {.count = 1, .reusable = true}, SHIFT(8453),
  [12050] = {.count = 1, .reusable = true}, SHIFT(8455),
  [12052] = {.count = 1, .reusable = true}, SHIFT(8456),
  [12054] = {.count = 1, .reusable = true}, REDUCE(sym_do_block, 4),
  [12056] = {.count = 1, .reusable = false}, REDUCE(sym_do_block, 4),
  [12058] = {.count = 1, .reusable = true}, SHIFT(8457),
  [12060] = {.count = 1, .reusable = false}, SHIFT(8457),
  [12062] = {.count = 1, .reusable = true}, SHIFT(8469),
  [12064] = {.count = 1, .reusable = true}, SHIFT(8470),
  [12066] = {.count = 1, .reusable = true}, SHIFT(8479),
  [12068] = {.count = 1, .reusable = true}, SHIFT(8480),
  [12070] = {.count = 1, .reusable = false}, SHIFT(8481),
  [12072] = {.count = 1, .reusable = false}, SHIFT(8482),
  [12074] = {.count = 1, .reusable = false}, SHIFT(8483),
  [12076] = {.count = 1, .reusable = true}, SHIFT(8484),
  [12078] = {.count = 1, .reusable = false}, SHIFT(8485),
  [12080] = {.count = 1, .reusable = true}, SHIFT(8485),
  [12082] = {.count = 1, .reusable = true}, SHIFT(8487),
  [12084] = {.count = 1, .reusable = true}, SHIFT(8488),
  [12086] = {.count = 1, .reusable = false}, SHIFT(8487),
  [12088] = {.count = 1, .reusable = true}, SHIFT(8483),
  [12090] = {.count = 1, .reusable = true}, SHIFT(8481),
  [12092] = {.count = 1, .reusable = true}, SHIFT(8489),
  [12094] = {.count = 1, .reusable = false}, SHIFT(8489),
  [12096] = {.count = 1, .reusable = true}, SHIFT(8490),
  [12098] = {.count = 1, .reusable = true}, SHIFT(8492),
  [12100] = {.count = 1, .reusable = true}, SHIFT(8497),
  [12102] = {.count = 1, .reusable = false}, SHIFT(8499),
  [12104] = {.count = 1, .reusable = true}, SHIFT(8501),
  [12106] = {.count = 1, .reusable = false}, SHIFT(8497),
  [12108] = {.count = 1, .reusable = true}, SHIFT(8516),
  [12110] = {.count = 1, .reusable = false}, SHIFT(8518),
  [12112] = {.count = 1, .reusable = true}, SHIFT(8520),
  [12114] = {.count = 1, .reusable = false}, SHIFT(8516),
  [12116] = {.count = 1, .reusable = true}, SHIFT(3509),
  [12118] = {.count = 1, .reusable = true}, SHIFT(8530),
  [12120] = {.count = 1, .reusable = true}, REDUCE(sym_conditional, 5),
  [12122] = {.count = 1, .reusable = true}, SHIFT(8533),
  [12124] = {.count = 1, .reusable = true}, SHIFT(8534),
  [12126] = {.count = 1, .reusable = false}, SHIFT(8535),
  [12128] = {.count = 1, .reusable = false}, SHIFT(8534),
  [12130] = {.count = 1, .reusable = false}, SHIFT(8536),
  [12132] = {.count = 1, .reusable = false}, SHIFT(8537),
  [12134] = {.count = 1, .reusable = true}, SHIFT(8538),
  [12136] = {.count = 1, .reusable = false}, SHIFT(8539),
  [12138] = {.count = 1, .reusable = true}, SHIFT(8539),
  [12140] = {.count = 1, .reusable = false}, SHIFT(8541),
  [12142] = {.count = 1, .reusable = false}, SHIFT(8542),
  [12144] = {.count = 1, .reusable = true}, SHIFT(8541),
  [12146] = {.count = 1, .reusable = true}, SHIFT(8537),
  [12148] = {.count = 1, .reusable = false}, SHIFT(8533),
  [12150] = {.count = 1, .reusable = true}, SHIFT(8543),
  [12152] = {.count = 1, .reusable = false}, SHIFT(8543),
  [12154] = {.count = 1, .reusable = true}, SHIFT(8544),
  [12156] = {.count = 1, .reusable = true}, SHIFT(8546),
  [12158] = {.count = 1, .reusable = true}, SHIFT(3540),
  [12160] = {.count = 1, .reusable = true}, SHIFT(8571),
  [12162] = {.count = 1, .reusable = true}, SHIFT(8572),
  [12164] = {.count = 1, .reusable = false}, SHIFT(8573),
  [12166] = {.count = 1, .reusable = false}, SHIFT(8574),
  [12168] = {.count = 1, .reusable = false}, SHIFT(8575),
  [12170] = {.count = 1, .reusable = true}, SHIFT(8576),
  [12172] = {.count = 1, .reusable = false}, SHIFT(8577),
  [12174] = {.count = 1, .reusable = true}, SHIFT(8577),
  [12176] = {.count = 1, .reusable = true}, SHIFT(8579),
  [12178] = {.count = 1, .reusable = true}, SHIFT(8580),
  [12180] = {.count = 1, .reusable = false}, SHIFT(8579),
  [12182] = {.count = 1, .reusable = true}, SHIFT(8575),
  [12184] = {.count = 1, .reusable = true}, SHIFT(8573),
  [12186] = {.count = 1, .reusable = true}, SHIFT(8581),
  [12188] = {.count = 1, .reusable = true}, SHIFT(8583),
  [12190] = {.count = 1, .reusable = false}, SHIFT(8583),
  [12192] = {.count = 1, .reusable = true}, SHIFT(8584),
  [12194] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(1425),
  [12197] = {.count = 1, .reusable = true}, SHIFT(8586),
  [12199] = {.count = 1, .reusable = true}, SHIFT(8587),
  [12201] = {.count = 1, .reusable = true}, SHIFT(8588),
  [12203] = {.count = 1, .reusable = true}, SHIFT(8589),
  [12205] = {.count = 1, .reusable = true}, SHIFT(8590),
  [12207] = {.count = 1, .reusable = true}, SHIFT(8591),
  [12209] = {.count = 1, .reusable = true}, SHIFT(8592),
  [12211] = {.count = 1, .reusable = true}, SHIFT(8593),
  [12213] = {.count = 1, .reusable = true}, SHIFT(8594),
  [12215] = {.count = 1, .reusable = true}, SHIFT(8596),
  [12217] = {.count = 1, .reusable = true}, SHIFT(8597),
  [12219] = {.count = 1, .reusable = true}, SHIFT(8598),
  [12221] = {.count = 1, .reusable = true}, SHIFT(8599),
  [12223] = {.count = 1, .reusable = true}, SHIFT(8600),
  [12225] = {.count = 1, .reusable = true}, SHIFT(8602),
  [12227] = {.count = 1, .reusable = true}, SHIFT(8603),
  [12229] = {.count = 1, .reusable = true}, SHIFT(8604),
  [12231] = {.count = 1, .reusable = true}, SHIFT(8605),
  [12233] = {.count = 1, .reusable = true}, SHIFT(3602),
  [12235] = {.count = 1, .reusable = false}, SHIFT(8607),
  [12237] = {.count = 1, .reusable = true}, SHIFT(8608),
  [12239] = {.count = 1, .reusable = true}, SHIFT(8609),
  [12241] = {.count = 1, .reusable = false}, SHIFT(8610),
  [12243] = {.count = 1, .reusable = false}, SHIFT(8611),
  [12245] = {.count = 1, .reusable = true}, SHIFT(8612),
  [12247] = {.count = 1, .reusable = false}, SHIFT(8612),
  [12249] = {.count = 1, .reusable = true}, SHIFT(8614),
  [12251] = {.count = 1, .reusable = false}, SHIFT(8614),
  [12253] = {.count = 1, .reusable = false}, SHIFT(8616),
  [12255] = {.count = 1, .reusable = false}, SHIFT(8618),
  [12257] = {.count = 1, .reusable = true}, SHIFT(8620),
  [12259] = {.count = 1, .reusable = true}, SHIFT(8623),
  [12261] = {.count = 1, .reusable = true}, SHIFT(8621),
  [12263] = {.count = 1, .reusable = true}, SHIFT(8625),
  [12265] = {.count = 1, .reusable = true}, SHIFT(8628),
  [12267] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(1466),
  [12270] = {.count = 1, .reusable = true}, SHIFT(3655),
  [12272] = {.count = 1, .reusable = true}, SHIFT(8637),
  [12274] = {.count = 1, .reusable = true}, SHIFT(3677),
  [12276] = {.count = 1, .reusable = true}, SHIFT(8647),
  [12278] = {.count = 1, .reusable = true}, SHIFT(8648),
  [12280] = {.count = 1, .reusable = false}, SHIFT(8649),
  [12282] = {.count = 1, .reusable = false}, SHIFT(8650),
  [12284] = {.count = 1, .reusable = false}, SHIFT(8651),
  [12286] = {.count = 1, .reusable = true}, SHIFT(8652),
  [12288] = {.count = 1, .reusable = false}, SHIFT(8653),
  [12290] = {.count = 1, .reusable = true}, SHIFT(8653),
  [12292] = {.count = 1, .reusable = true}, SHIFT(8655),
  [12294] = {.count = 1, .reusable = true}, SHIFT(8656),
  [12296] = {.count = 1, .reusable = false}, SHIFT(8655),
  [12298] = {.count = 1, .reusable = true}, SHIFT(8651),
  [12300] = {.count = 1, .reusable = true}, SHIFT(8649),
  [12302] = {.count = 1, .reusable = true}, SHIFT(8657),
  [12304] = {.count = 1, .reusable = true}, SHIFT(8659),
  [12306] = {.count = 1, .reusable = false}, SHIFT(8659),
  [12308] = {.count = 1, .reusable = true}, SHIFT(8660),
  [12310] = {.count = 1, .reusable = true}, SHIFT(8661),
  [12312] = {.count = 1, .reusable = false}, SHIFT(8662),
  [12314] = {.count = 1, .reusable = false}, SHIFT(8663),
  [12316] = {.count = 1, .reusable = true}, SHIFT(8664),
  [12318] = {.count = 1, .reusable = true}, SHIFT(8665),
  [12320] = {.count = 1, .reusable = true}, SHIFT(8666),
  [12322] = {.count = 1, .reusable = true}, SHIFT(8667),
  [12324] = {.count = 1, .reusable = false}, SHIFT(8668),
  [12326] = {.count = 1, .reusable = true}, SHIFT(8670),
  [12328] = {.count = 1, .reusable = false}, SHIFT(8670),
  [12330] = {.count = 1, .reusable = true}, SHIFT(8672),
  [12332] = {.count = 1, .reusable = true}, SHIFT(8675),
  [12334] = {.count = 1, .reusable = true}, SHIFT(6394),
  [12336] = {.count = 1, .reusable = true}, SHIFT(8680),
  [12338] = {.count = 1, .reusable = false}, REDUCE(aux_sym_exceptions_repeat1, 2),
  [12340] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(3759),
  [12343] = {.count = 1, .reusable = true}, SHIFT(8685),
  [12345] = {.count = 1, .reusable = true}, SHIFT(8686),
  [12347] = {.count = 1, .reusable = false}, SHIFT(8687),
  [12349] = {.count = 1, .reusable = false}, SHIFT(8688),
  [12351] = {.count = 1, .reusable = false}, SHIFT(8689),
  [12353] = {.count = 1, .reusable = true}, SHIFT(8690),
  [12355] = {.count = 1, .reusable = false}, SHIFT(8691),
  [12357] = {.count = 1, .reusable = true}, SHIFT(8691),
  [12359] = {.count = 1, .reusable = true}, SHIFT(8693),
  [12361] = {.count = 1, .reusable = true}, SHIFT(8694),
  [12363] = {.count = 1, .reusable = false}, SHIFT(8693),
  [12365] = {.count = 1, .reusable = true}, SHIFT(8689),
  [12367] = {.count = 1, .reusable = true}, SHIFT(8687),
  [12369] = {.count = 1, .reusable = true}, SHIFT(8695),
  [12371] = {.count = 1, .reusable = false}, SHIFT(8695),
  [12373] = {.count = 1, .reusable = true}, SHIFT(8696),
  [12375] = {.count = 1, .reusable = true}, SHIFT(8701),
  [12377] = {.count = 1, .reusable = false}, SHIFT(8703),
  [12379] = {.count = 1, .reusable = true}, SHIFT(8705),
  [12381] = {.count = 1, .reusable = false}, SHIFT(8701),
  [12383] = {.count = 1, .reusable = true}, SHIFT(8720),
  [12385] = {.count = 1, .reusable = false}, SHIFT(8722),
  [12387] = {.count = 1, .reusable = true}, SHIFT(8724),
  [12389] = {.count = 1, .reusable = false}, SHIFT(8720),
  [12391] = {.count = 1, .reusable = true}, SHIFT(3769),
  [12393] = {.count = 1, .reusable = true}, SHIFT(8735),
  [12395] = {.count = 1, .reusable = true}, SHIFT(8738),
  [12397] = {.count = 1, .reusable = true}, SHIFT(8739),
  [12399] = {.count = 1, .reusable = false}, SHIFT(8740),
  [12401] = {.count = 1, .reusable = false}, SHIFT(8739),
  [12403] = {.count = 1, .reusable = false}, SHIFT(8741),
  [12405] = {.count = 1, .reusable = false}, SHIFT(8742),
  [12407] = {.count = 1, .reusable = true}, SHIFT(8743),
  [12409] = {.count = 1, .reusable = false}, SHIFT(8744),
  [12411] = {.count = 1, .reusable = true}, SHIFT(8744),
  [12413] = {.count = 1, .reusable = false}, SHIFT(8746),
  [12415] = {.count = 1, .reusable = false}, SHIFT(8747),
  [12417] = {.count = 1, .reusable = true}, SHIFT(8746),
  [12419] = {.count = 1, .reusable = true}, SHIFT(8742),
  [12421] = {.count = 1, .reusable = false}, SHIFT(8738),
  [12423] = {.count = 1, .reusable = true}, SHIFT(8748),
  [12425] = {.count = 1, .reusable = false}, SHIFT(8748),
  [12427] = {.count = 1, .reusable = true}, SHIFT(8749),
  [12429] = {.count = 1, .reusable = true}, SHIFT(3805),
  [12431] = {.count = 1, .reusable = true}, SHIFT(8774),
  [12433] = {.count = 1, .reusable = true}, SHIFT(8775),
  [12435] = {.count = 1, .reusable = false}, SHIFT(8776),
  [12437] = {.count = 1, .reusable = false}, SHIFT(8777),
  [12439] = {.count = 1, .reusable = false}, SHIFT(8778),
  [12441] = {.count = 1, .reusable = true}, SHIFT(8779),
  [12443] = {.count = 1, .reusable = false}, SHIFT(8780),
  [12445] = {.count = 1, .reusable = true}, SHIFT(8780),
  [12447] = {.count = 1, .reusable = true}, SHIFT(8782),
  [12449] = {.count = 1, .reusable = true}, SHIFT(8783),
  [12451] = {.count = 1, .reusable = false}, SHIFT(8782),
  [12453] = {.count = 1, .reusable = true}, SHIFT(8778),
  [12455] = {.count = 1, .reusable = true}, SHIFT(8776),
  [12457] = {.count = 1, .reusable = true}, SHIFT(8784),
  [12459] = {.count = 1, .reusable = true}, SHIFT(8786),
  [12461] = {.count = 1, .reusable = false}, SHIFT(8786),
  [12463] = {.count = 1, .reusable = true}, SHIFT(8787),
  [12465] = {.count = 1, .reusable = true}, SHIFT(3847),
  [12467] = {.count = 1, .reusable = true}, SHIFT(8810),
  [12469] = {.count = 1, .reusable = true}, SHIFT(3868),
  [12471] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(3875),
  [12474] = {.count = 2, .reusable = true}, REDUCE(aux_sym_undef_repeat1, 2), SHIFT_REPEAT(3881),
  [12477] = {.count = 1, .reusable = true}, SHIFT(8820),
  [12479] = {.count = 1, .reusable = true}, SHIFT(8821),
  [12481] = {.count = 1, .reusable = true}, SHIFT(8822),
  [12483] = {.count = 1, .reusable = true}, SHIFT(8823),
  [12485] = {.count = 1, .reusable = true}, SHIFT(8824),
  [12487] = {.count = 1, .reusable = true}, SHIFT(8825),
  [12489] = {.count = 1, .reusable = false}, SHIFT(8826),
  [12491] = {.count = 1, .reusable = true}, SHIFT(8828),
  [12493] = {.count = 1, .reusable = true}, SHIFT(8829),
  [12495] = {.count = 1, .reusable = true}, SHIFT(8831),
  [12497] = {.count = 1, .reusable = false}, SHIFT(8832),
  [12499] = {.count = 1, .reusable = true}, SHIFT(8834),
  [12501] = {.count = 1, .reusable = true}, SHIFT(8835),
  [12503] = {.count = 1, .reusable = true}, SHIFT(8837),
  [12505] = {.count = 1, .reusable = true}, SHIFT(8840),
  [12507] = {.count = 1, .reusable = true}, SHIFT(8841),
  [12509] = {.count = 1, .reusable = true}, SHIFT(8842),
  [12511] = {.count = 1, .reusable = true}, SHIFT(8845),
  [12513] = {.count = 1, .reusable = true}, SHIFT(8847),
  [12515] = {.count = 1, .reusable = false}, SHIFT(8846),
  [12517] = {.count = 1, .reusable = true}, SHIFT(8849),
  [12519] = {.count = 1, .reusable = true}, SHIFT(8851),
  [12521] = {.count = 1, .reusable = true}, SHIFT(8852),
  [12523] = {.count = 1, .reusable = true}, SHIFT(8853),
  [12525] = {.count = 1, .reusable = true}, SHIFT(8855),
  [12527] = {.count = 1, .reusable = true}, SHIFT(8858),
  [12529] = {.count = 1, .reusable = true}, SHIFT(8856),
  [12531] = {.count = 1, .reusable = true}, SHIFT(8860),
  [12533] = {.count = 1, .reusable = false}, SHIFT(8864),
  [12535] = {.count = 1, .reusable = true}, SHIFT(8865),
  [12537] = {.count = 1, .reusable = true}, SHIFT(8882),
  [12539] = {.count = 1, .reusable = true}, SHIFT(8883),
  [12541] = {.count = 1, .reusable = false}, SHIFT(8883),
  [12543] = {.count = 1, .reusable = true}, SHIFT(8885),
  [12545] = {.count = 1, .reusable = true}, SHIFT(8886),
  [12547] = {.count = 1, .reusable = true}, SHIFT(8887),
  [12549] = {.count = 2, .reusable = true}, REDUCE(aux_sym_call_repeat1, 2), SHIFT_REPEAT(3970),
  [12552] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(3972),
  [12555] = {.count = 1, .reusable = true}, REDUCE(sym_string_array, 6, .alias_sequence_id = 23),
  [12557] = {.count = 1, .reusable = false}, REDUCE(sym_string_array, 6, .alias_sequence_id = 23),
  [12559] = {.count = 1, .reusable = true}, REDUCE(sym_symbol_array, 6, .alias_sequence_id = 24),
  [12561] = {.count = 1, .reusable = false}, REDUCE(sym_symbol_array, 6, .alias_sequence_id = 24),
  [12563] = {.count = 1, .reusable = true}, SHIFT(8923),
  [12565] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(4031),
  [12568] = {.count = 1, .reusable = true}, SHIFT(8941),
  [12570] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(4082),
  [12573] = {.count = 1, .reusable = true}, SHIFT(8957),
  [12575] = {.count = 1, .reusable = true}, SHIFT(8958),
  [12577] = {.count = 1, .reusable = true}, SHIFT(4128),
  [12579] = {.count = 1, .reusable = true}, SHIFT(8979),
  [12581] = {.count = 1, .reusable = true}, SHIFT(4149),
  [12583] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(4156),
  [12586] = {.count = 1, .reusable = true}, SHIFT(8989),
  [12588] = {.count = 1, .reusable = true}, SHIFT(9004),
  [12590] = {.count = 1, .reusable = true}, SHIFT(9005),
  [12592] = {.count = 1, .reusable = false}, SHIFT(9005),
  [12594] = {.count = 1, .reusable = true}, SHIFT(9007),
  [12596] = {.count = 1, .reusable = true}, SHIFT(9008),
  [12598] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(4218),
  [12601] = {.count = 1, .reusable = true}, SHIFT(6900),
  [12603] = {.count = 1, .reusable = true}, SHIFT(6909),
  [12605] = {.count = 1, .reusable = true}, SHIFT(9015),
  [12607] = {.count = 1, .reusable = true}, SHIFT(9016),
  [12609] = {.count = 1, .reusable = true}, SHIFT(9018),
  [12611] = {.count = 1, .reusable = true}, SHIFT(9019),
  [12613] = {.count = 1, .reusable = false}, SHIFT(9019),
  [12615] = {.count = 1, .reusable = true}, SHIFT(9021),
  [12617] = {.count = 1, .reusable = true}, SHIFT(9022),
  [12619] = {.count = 1, .reusable = true}, SHIFT(9023),
  [12621] = {.count = 1, .reusable = true}, SHIFT(9024),
  [12623] = {.count = 1, .reusable = true}, SHIFT(9025),
  [12625] = {.count = 1, .reusable = true}, SHIFT(9026),
  [12627] = {.count = 1, .reusable = true}, SHIFT(9027),
  [12629] = {.count = 1, .reusable = false}, SHIFT(9028),
  [12631] = {.count = 1, .reusable = false}, SHIFT(9029),
  [12633] = {.count = 1, .reusable = true}, SHIFT(9030),
  [12635] = {.count = 1, .reusable = true}, SHIFT(9031),
  [12637] = {.count = 1, .reusable = true}, SHIFT(9032),
  [12639] = {.count = 1, .reusable = true}, SHIFT(9033),
  [12641] = {.count = 1, .reusable = false}, SHIFT(9034),
  [12643] = {.count = 1, .reusable = true}, SHIFT(9036),
  [12645] = {.count = 1, .reusable = false}, SHIFT(9036),
  [12647] = {.count = 1, .reusable = true}, SHIFT(9038),
  [12649] = {.count = 1, .reusable = true}, SHIFT(9041),
  [12651] = {.count = 1, .reusable = true}, SHIFT(6971),
  [12653] = {.count = 1, .reusable = true}, SHIFT(9046),
  [12655] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(4379),
  [12658] = {.count = 1, .reusable = true}, SHIFT(9060),
  [12660] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(4410),
  [12663] = {.count = 1, .reusable = true}, REDUCE(sym_singleton_method, 6),
  [12665] = {.count = 1, .reusable = false}, REDUCE(sym_singleton_method, 6),
  [12667] = {.count = 1, .reusable = true}, SHIFT(9078),
  [12669] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(4455),
  [12672] = {.count = 1, .reusable = true}, REDUCE(sym_method_parameters, 4),
  [12674] = {.count = 1, .reusable = false}, REDUCE(sym_method_parameters, 4),
  [12676] = {.count = 1, .reusable = true}, SHIFT(9095),
  [12678] = {.count = 1, .reusable = true}, SHIFT(9096),
  [12680] = {.count = 1, .reusable = true}, SHIFT(9098),
  [12682] = {.count = 1, .reusable = true}, SHIFT(9100),
  [12684] = {.count = 1, .reusable = false}, SHIFT(9098),
  [12686] = {.count = 1, .reusable = true}, SHIFT(9102),
  [12688] = {.count = 1, .reusable = true}, SHIFT(9108),
  [12690] = {.count = 1, .reusable = false}, SHIFT(9110),
  [12692] = {.count = 1, .reusable = true}, SHIFT(9112),
  [12694] = {.count = 1, .reusable = false}, SHIFT(9108),
  [12696] = {.count = 1, .reusable = true}, SHIFT(4505),
  [12698] = {.count = 1, .reusable = true}, SHIFT(9134),
  [12700] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(4524),
  [12703] = {.count = 1, .reusable = true}, SHIFT(9139),
  [12705] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(4553),
  [12708] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(4572),
  [12711] = {.count = 1, .reusable = true}, SHIFT(7171),
  [12713] = {.count = 1, .reusable = true}, SHIFT(9144),
  [12715] = {.count = 1, .reusable = true}, SHIFT(7189),
  [12717] = {.count = 1, .reusable = true}, SHIFT(9149),
  [12719] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(4632),
  [12722] = {.count = 1, .reusable = true}, SHIFT(9150),
  [12724] = {.count = 1, .reusable = true}, SHIFT(9151),
  [12726] = {.count = 1, .reusable = true}, SHIFT(4661),
  [12728] = {.count = 1, .reusable = true}, SHIFT(9159),
  [12730] = {.count = 1, .reusable = true}, SHIFT(9162),
  [12732] = {.count = 1, .reusable = true}, SHIFT(9163),
  [12734] = {.count = 1, .reusable = false}, SHIFT(9164),
  [12736] = {.count = 1, .reusable = false}, SHIFT(9163),
  [12738] = {.count = 1, .reusable = false}, SHIFT(9165),
  [12740] = {.count = 1, .reusable = false}, SHIFT(9166),
  [12742] = {.count = 1, .reusable = true}, SHIFT(9167),
  [12744] = {.count = 1, .reusable = false}, SHIFT(9168),
  [12746] = {.count = 1, .reusable = true}, SHIFT(9168),
  [12748] = {.count = 1, .reusable = false}, SHIFT(9170),
  [12750] = {.count = 1, .reusable = false}, SHIFT(9171),
  [12752] = {.count = 1, .reusable = true}, SHIFT(9170),
  [12754] = {.count = 1, .reusable = true}, SHIFT(9166),
  [12756] = {.count = 1, .reusable = false}, SHIFT(9162),
  [12758] = {.count = 1, .reusable = true}, SHIFT(9172),
  [12760] = {.count = 1, .reusable = false}, SHIFT(9172),
  [12762] = {.count = 1, .reusable = true}, SHIFT(9173),
  [12764] = {.count = 1, .reusable = true}, SHIFT(4681),
  [12766] = {.count = 1, .reusable = true}, SHIFT(9183),
  [12768] = {.count = 1, .reusable = true}, SHIFT(9184),
  [12770] = {.count = 1, .reusable = true}, SHIFT(9186),
  [12772] = {.count = 1, .reusable = true}, SHIFT(9187),
  [12774] = {.count = 1, .reusable = false}, SHIFT(9187),
  [12776] = {.count = 1, .reusable = true}, SHIFT(9189),
  [12778] = {.count = 1, .reusable = true}, SHIFT(9190),
  [12780] = {.count = 1, .reusable = true}, SHIFT(9191),
  [12782] = {.count = 1, .reusable = true}, SHIFT(9193),
  [12784] = {.count = 1, .reusable = true}, SHIFT(9194),
  [12786] = {.count = 1, .reusable = true}, SHIFT(9195),
  [12788] = {.count = 1, .reusable = true}, SHIFT(9196),
  [12790] = {.count = 1, .reusable = true}, SHIFT(9197),
  [12792] = {.count = 1, .reusable = true}, SHIFT(9199),
  [12794] = {.count = 1, .reusable = true}, SHIFT(9200),
  [12796] = {.count = 1, .reusable = true}, SHIFT(9201),
  [12798] = {.count = 1, .reusable = true}, SHIFT(9202),
  [12800] = {.count = 1, .reusable = true}, SHIFT(4746),
  [12802] = {.count = 1, .reusable = false}, SHIFT(9204),
  [12804] = {.count = 1, .reusable = true}, SHIFT(9205),
  [12806] = {.count = 1, .reusable = true}, SHIFT(9206),
  [12808] = {.count = 1, .reusable = false}, SHIFT(9207),
  [12810] = {.count = 1, .reusable = false}, SHIFT(9208),
  [12812] = {.count = 1, .reusable = true}, SHIFT(9210),
  [12814] = {.count = 1, .reusable = true}, SHIFT(9213),
  [12816] = {.count = 1, .reusable = true}, SHIFT(9212),
  [12818] = {.count = 1, .reusable = true}, SHIFT(4757),
  [12820] = {.count = 1, .reusable = true}, SHIFT(9219),
  [12822] = {.count = 1, .reusable = false}, SHIFT(9219),
  [12824] = {.count = 1, .reusable = true}, SHIFT(9221),
  [12826] = {.count = 1, .reusable = false}, SHIFT(9221),
  [12828] = {.count = 1, .reusable = false}, SHIFT(9223),
  [12830] = {.count = 1, .reusable = false}, SHIFT(9225),
  [12832] = {.count = 1, .reusable = true}, SHIFT(9227),
  [12834] = {.count = 1, .reusable = true}, SHIFT(9230),
  [12836] = {.count = 1, .reusable = true}, SHIFT(9228),
  [12838] = {.count = 1, .reusable = true}, SHIFT(9232),
  [12840] = {.count = 1, .reusable = true}, SHIFT(9235),
  [12842] = {.count = 1, .reusable = true}, SHIFT(9237),
  [12844] = {.count = 1, .reusable = true}, SHIFT(9239),
  [12846] = {.count = 1, .reusable = false}, SHIFT(9237),
  [12848] = {.count = 1, .reusable = true}, SHIFT(9241),
  [12850] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(2326),
  [12853] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(4812),
  [12856] = {.count = 1, .reusable = true}, SHIFT(7357),
  [12858] = {.count = 1, .reusable = true}, SHIFT(4839),
  [12860] = {.count = 1, .reusable = true}, SHIFT(9252),
  [12862] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(4866),
  [12865] = {.count = 1, .reusable = true}, SHIFT(7388),
  [12867] = {.count = 1, .reusable = true}, SHIFT(7393),
  [12869] = {.count = 1, .reusable = true}, SHIFT(9261),
  [12871] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(4933),
  [12874] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(4952),
  [12877] = {.count = 1, .reusable = true}, SHIFT(7428),
  [12879] = {.count = 1, .reusable = false}, REDUCE(sym_conditional, 5),
  [12881] = {.count = 1, .reusable = true}, SHIFT(9268),
  [12883] = {.count = 1, .reusable = false}, SHIFT(9268),
  [12885] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(4987),
  [12888] = {.count = 1, .reusable = true}, SHIFT(9272),
  [12890] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5013),
  [12893] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5032),
  [12896] = {.count = 1, .reusable = true}, SHIFT(7470),
  [12898] = {.count = 1, .reusable = true}, SHIFT(9281),
  [12900] = {.count = 1, .reusable = true}, SHIFT(9282),
  [12902] = {.count = 1, .reusable = false}, SHIFT(9283),
  [12904] = {.count = 1, .reusable = false}, SHIFT(9284),
  [12906] = {.count = 1, .reusable = false}, SHIFT(9285),
  [12908] = {.count = 1, .reusable = true}, SHIFT(9286),
  [12910] = {.count = 1, .reusable = false}, SHIFT(9287),
  [12912] = {.count = 1, .reusable = true}, SHIFT(9287),
  [12914] = {.count = 1, .reusable = true}, SHIFT(9289),
  [12916] = {.count = 1, .reusable = true}, SHIFT(9290),
  [12918] = {.count = 1, .reusable = false}, SHIFT(9289),
  [12920] = {.count = 1, .reusable = true}, SHIFT(9285),
  [12922] = {.count = 1, .reusable = true}, SHIFT(9283),
  [12924] = {.count = 1, .reusable = true}, SHIFT(9291),
  [12926] = {.count = 1, .reusable = false}, SHIFT(9291),
  [12928] = {.count = 1, .reusable = true}, SHIFT(9292),
  [12930] = {.count = 1, .reusable = true}, SHIFT(9297),
  [12932] = {.count = 1, .reusable = false}, SHIFT(9299),
  [12934] = {.count = 1, .reusable = true}, SHIFT(9301),
  [12936] = {.count = 1, .reusable = false}, SHIFT(9297),
  [12938] = {.count = 1, .reusable = true}, SHIFT(9316),
  [12940] = {.count = 1, .reusable = false}, SHIFT(9318),
  [12942] = {.count = 1, .reusable = true}, SHIFT(9320),
  [12944] = {.count = 1, .reusable = false}, SHIFT(9316),
  [12946] = {.count = 1, .reusable = true}, SHIFT(5048),
  [12948] = {.count = 1, .reusable = true}, SHIFT(9331),
  [12950] = {.count = 1, .reusable = true}, SHIFT(9334),
  [12952] = {.count = 1, .reusable = true}, SHIFT(9335),
  [12954] = {.count = 1, .reusable = false}, SHIFT(9336),
  [12956] = {.count = 1, .reusable = false}, SHIFT(9335),
  [12958] = {.count = 1, .reusable = false}, SHIFT(9337),
  [12960] = {.count = 1, .reusable = false}, SHIFT(9338),
  [12962] = {.count = 1, .reusable = true}, SHIFT(9339),
  [12964] = {.count = 1, .reusable = false}, SHIFT(9340),
  [12966] = {.count = 1, .reusable = true}, SHIFT(9340),
  [12968] = {.count = 1, .reusable = false}, SHIFT(9342),
  [12970] = {.count = 1, .reusable = false}, SHIFT(9343),
  [12972] = {.count = 1, .reusable = true}, SHIFT(9342),
  [12974] = {.count = 1, .reusable = true}, SHIFT(9338),
  [12976] = {.count = 1, .reusable = false}, SHIFT(9334),
  [12978] = {.count = 1, .reusable = true}, SHIFT(9344),
  [12980] = {.count = 1, .reusable = false}, SHIFT(9344),
  [12982] = {.count = 1, .reusable = true}, SHIFT(9345),
  [12984] = {.count = 1, .reusable = true}, SHIFT(5084),
  [12986] = {.count = 1, .reusable = true}, SHIFT(9370),
  [12988] = {.count = 1, .reusable = true}, SHIFT(9371),
  [12990] = {.count = 1, .reusable = false}, SHIFT(9372),
  [12992] = {.count = 1, .reusable = false}, SHIFT(9373),
  [12994] = {.count = 1, .reusable = false}, SHIFT(9374),
  [12996] = {.count = 1, .reusable = true}, SHIFT(9375),
  [12998] = {.count = 1, .reusable = false}, SHIFT(9376),
  [13000] = {.count = 1, .reusable = true}, SHIFT(9376),
  [13002] = {.count = 1, .reusable = true}, SHIFT(9378),
  [13004] = {.count = 1, .reusable = true}, SHIFT(9379),
  [13006] = {.count = 1, .reusable = false}, SHIFT(9378),
  [13008] = {.count = 1, .reusable = true}, SHIFT(9374),
  [13010] = {.count = 1, .reusable = true}, SHIFT(9372),
  [13012] = {.count = 1, .reusable = true}, SHIFT(9380),
  [13014] = {.count = 1, .reusable = true}, SHIFT(9382),
  [13016] = {.count = 1, .reusable = false}, SHIFT(9382),
  [13018] = {.count = 1, .reusable = true}, SHIFT(9383),
  [13020] = {.count = 1, .reusable = true}, REDUCE(sym_elsif, 3),
  [13022] = {.count = 1, .reusable = false}, REDUCE(sym_elsif, 3),
  [13024] = {.count = 1, .reusable = true}, SHIFT(9385),
  [13026] = {.count = 1, .reusable = true}, SHIFT(7603),
  [13028] = {.count = 1, .reusable = true}, SHIFT(9390),
  [13030] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(5156),
  [13033] = {.count = 1, .reusable = true}, SHIFT(9395),
  [13035] = {.count = 1, .reusable = true}, SHIFT(9396),
  [13037] = {.count = 1, .reusable = false}, SHIFT(9397),
  [13039] = {.count = 1, .reusable = false}, SHIFT(9398),
  [13041] = {.count = 1, .reusable = false}, SHIFT(9399),
  [13043] = {.count = 1, .reusable = true}, SHIFT(9400),
  [13045] = {.count = 1, .reusable = false}, SHIFT(9401),
  [13047] = {.count = 1, .reusable = true}, SHIFT(9401),
  [13049] = {.count = 1, .reusable = true}, SHIFT(9403),
  [13051] = {.count = 1, .reusable = true}, SHIFT(9404),
  [13053] = {.count = 1, .reusable = false}, SHIFT(9403),
  [13055] = {.count = 1, .reusable = true}, SHIFT(9399),
  [13057] = {.count = 1, .reusable = true}, SHIFT(9397),
  [13059] = {.count = 1, .reusable = true}, SHIFT(9405),
  [13061] = {.count = 1, .reusable = false}, SHIFT(9405),
  [13063] = {.count = 1, .reusable = true}, SHIFT(9406),
  [13065] = {.count = 1, .reusable = true}, SHIFT(9411),
  [13067] = {.count = 1, .reusable = false}, SHIFT(9413),
  [13069] = {.count = 1, .reusable = true}, SHIFT(9415),
  [13071] = {.count = 1, .reusable = false}, SHIFT(9411),
  [13073] = {.count = 1, .reusable = true}, SHIFT(9430),
  [13075] = {.count = 1, .reusable = false}, SHIFT(9432),
  [13077] = {.count = 1, .reusable = true}, SHIFT(9434),
  [13079] = {.count = 1, .reusable = false}, SHIFT(9430),
  [13081] = {.count = 1, .reusable = true}, SHIFT(5165),
  [13083] = {.count = 1, .reusable = true}, SHIFT(9445),
  [13085] = {.count = 1, .reusable = true}, SHIFT(9448),
  [13087] = {.count = 1, .reusable = true}, SHIFT(9449),
  [13089] = {.count = 1, .reusable = false}, SHIFT(9450),
  [13091] = {.count = 1, .reusable = false}, SHIFT(9449),
  [13093] = {.count = 1, .reusable = false}, SHIFT(9451),
  [13095] = {.count = 1, .reusable = false}, SHIFT(9452),
  [13097] = {.count = 1, .reusable = true}, SHIFT(9453),
  [13099] = {.count = 1, .reusable = false}, SHIFT(9454),
  [13101] = {.count = 1, .reusable = true}, SHIFT(9454),
  [13103] = {.count = 1, .reusable = false}, SHIFT(9456),
  [13105] = {.count = 1, .reusable = false}, SHIFT(9457),
  [13107] = {.count = 1, .reusable = true}, SHIFT(9456),
  [13109] = {.count = 1, .reusable = true}, SHIFT(9452),
  [13111] = {.count = 1, .reusable = false}, SHIFT(9448),
  [13113] = {.count = 1, .reusable = true}, SHIFT(9458),
  [13115] = {.count = 1, .reusable = false}, SHIFT(9458),
  [13117] = {.count = 1, .reusable = true}, SHIFT(9459),
  [13119] = {.count = 1, .reusable = true}, SHIFT(5201),
  [13121] = {.count = 1, .reusable = true}, SHIFT(9484),
  [13123] = {.count = 1, .reusable = true}, SHIFT(9485),
  [13125] = {.count = 1, .reusable = false}, SHIFT(9486),
  [13127] = {.count = 1, .reusable = false}, SHIFT(9487),
  [13129] = {.count = 1, .reusable = false}, SHIFT(9488),
  [13131] = {.count = 1, .reusable = true}, SHIFT(9489),
  [13133] = {.count = 1, .reusable = false}, SHIFT(9490),
  [13135] = {.count = 1, .reusable = true}, SHIFT(9490),
  [13137] = {.count = 1, .reusable = true}, SHIFT(9492),
  [13139] = {.count = 1, .reusable = true}, SHIFT(9493),
  [13141] = {.count = 1, .reusable = false}, SHIFT(9492),
  [13143] = {.count = 1, .reusable = true}, SHIFT(9488),
  [13145] = {.count = 1, .reusable = true}, SHIFT(9486),
  [13147] = {.count = 1, .reusable = true}, SHIFT(9494),
  [13149] = {.count = 1, .reusable = true}, SHIFT(9496),
  [13151] = {.count = 1, .reusable = false}, SHIFT(9496),
  [13153] = {.count = 1, .reusable = true}, SHIFT(9497),
  [13155] = {.count = 1, .reusable = true}, SHIFT(9500),
  [13157] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5246),
  [13160] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5266),
  [13163] = {.count = 1, .reusable = true}, SHIFT(7760),
  [13165] = {.count = 1, .reusable = true}, SHIFT(9505),
  [13167] = {.count = 1, .reusable = true}, SHIFT(7778),
  [13169] = {.count = 1, .reusable = true}, SHIFT(9510),
  [13171] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(5326),
  [13174] = {.count = 1, .reusable = true}, SHIFT(5335),
  [13176] = {.count = 1, .reusable = true}, SHIFT(9517),
  [13178] = {.count = 1, .reusable = true}, SHIFT(9520),
  [13180] = {.count = 1, .reusable = true}, SHIFT(9521),
  [13182] = {.count = 1, .reusable = false}, SHIFT(9522),
  [13184] = {.count = 1, .reusable = false}, SHIFT(9521),
  [13186] = {.count = 1, .reusable = false}, SHIFT(9523),
  [13188] = {.count = 1, .reusable = false}, SHIFT(9524),
  [13190] = {.count = 1, .reusable = true}, SHIFT(9525),
  [13192] = {.count = 1, .reusable = false}, SHIFT(9526),
  [13194] = {.count = 1, .reusable = true}, SHIFT(9526),
  [13196] = {.count = 1, .reusable = false}, SHIFT(9528),
  [13198] = {.count = 1, .reusable = false}, SHIFT(9529),
  [13200] = {.count = 1, .reusable = true}, SHIFT(9528),
  [13202] = {.count = 1, .reusable = true}, SHIFT(9524),
  [13204] = {.count = 1, .reusable = false}, SHIFT(9520),
  [13206] = {.count = 1, .reusable = true}, SHIFT(9530),
  [13208] = {.count = 1, .reusable = false}, SHIFT(9530),
  [13210] = {.count = 1, .reusable = true}, SHIFT(9531),
  [13212] = {.count = 1, .reusable = true}, SHIFT(5355),
  [13214] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5371),
  [13217] = {.count = 1, .reusable = true}, SHIFT(9542),
  [13219] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5403),
  [13222] = {.count = 1, .reusable = true}, SHIFT(7860),
  [13224] = {.count = 1, .reusable = true}, REDUCE(sym_for, 6),
  [13226] = {.count = 1, .reusable = false}, REDUCE(sym_for, 6),
  [13228] = {.count = 1, .reusable = true}, SHIFT(9548),
  [13230] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5443),
  [13233] = {.count = 1, .reusable = true}, SHIFT(7886),
  [13235] = {.count = 1, .reusable = true}, REDUCE(sym_case, 6),
  [13237] = {.count = 1, .reusable = false}, REDUCE(sym_case, 6),
  [13239] = {.count = 1, .reusable = true}, SHIFT(9553),
  [13241] = {.count = 1, .reusable = true}, SHIFT(9554),
  [13243] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(5481),
  [13246] = {.count = 1, .reusable = true}, SHIFT(9557),
  [13248] = {.count = 1, .reusable = true}, SHIFT(9558),
  [13250] = {.count = 1, .reusable = false}, SHIFT(9559),
  [13252] = {.count = 1, .reusable = false}, SHIFT(9560),
  [13254] = {.count = 1, .reusable = false}, SHIFT(9561),
  [13256] = {.count = 1, .reusable = true}, SHIFT(9562),
  [13258] = {.count = 1, .reusable = false}, SHIFT(9563),
  [13260] = {.count = 1, .reusable = true}, SHIFT(9563),
  [13262] = {.count = 1, .reusable = true}, SHIFT(9565),
  [13264] = {.count = 1, .reusable = true}, SHIFT(9566),
  [13266] = {.count = 1, .reusable = false}, SHIFT(9565),
  [13268] = {.count = 1, .reusable = true}, SHIFT(9561),
  [13270] = {.count = 1, .reusable = true}, SHIFT(9559),
  [13272] = {.count = 1, .reusable = true}, SHIFT(9567),
  [13274] = {.count = 1, .reusable = false}, SHIFT(9567),
  [13276] = {.count = 1, .reusable = true}, SHIFT(9568),
  [13278] = {.count = 1, .reusable = true}, SHIFT(5490),
  [13280] = {.count = 1, .reusable = true}, REDUCE(aux_sym_when_repeat1, 2),
  [13282] = {.count = 1, .reusable = true}, SHIFT(9576),
  [13284] = {.count = 1, .reusable = true}, SHIFT(9577),
  [13286] = {.count = 1, .reusable = true}, SHIFT(9578),
  [13288] = {.count = 1, .reusable = true}, SHIFT(9579),
  [13290] = {.count = 1, .reusable = false}, SHIFT(9581),
  [13292] = {.count = 1, .reusable = false}, SHIFT(9582),
  [13294] = {.count = 1, .reusable = false}, SHIFT(9583),
  [13296] = {.count = 1, .reusable = false}, SHIFT(9584),
  [13298] = {.count = 1, .reusable = true}, SHIFT(9585),
  [13300] = {.count = 1, .reusable = false}, SHIFT(9585),
  [13302] = {.count = 1, .reusable = false}, SHIFT(9586),
  [13304] = {.count = 1, .reusable = true}, SHIFT(9586),
  [13306] = {.count = 1, .reusable = false}, SHIFT(9587),
  [13308] = {.count = 1, .reusable = true}, SHIFT(9589),
  [13310] = {.count = 1, .reusable = false}, SHIFT(9589),
  [13312] = {.count = 1, .reusable = true}, SHIFT(9596),
  [13314] = {.count = 1, .reusable = true}, SHIFT(9597),
  [13316] = {.count = 1, .reusable = true}, SHIFT(9598),
  [13318] = {.count = 1, .reusable = true}, SHIFT(9599),
  [13320] = {.count = 1, .reusable = true}, SHIFT(9600),
  [13322] = {.count = 1, .reusable = true}, SHIFT(9601),
  [13324] = {.count = 1, .reusable = true}, SHIFT(9602),
  [13326] = {.count = 1, .reusable = true}, SHIFT(9603),
  [13328] = {.count = 1, .reusable = false}, SHIFT(9604),
  [13330] = {.count = 1, .reusable = false}, SHIFT(9605),
  [13332] = {.count = 1, .reusable = false}, SHIFT(9606),
  [13334] = {.count = 1, .reusable = true}, SHIFT(9607),
  [13336] = {.count = 1, .reusable = false}, SHIFT(9608),
  [13338] = {.count = 1, .reusable = true}, SHIFT(9608),
  [13340] = {.count = 1, .reusable = true}, SHIFT(9609),
  [13342] = {.count = 1, .reusable = true}, SHIFT(9610),
  [13344] = {.count = 1, .reusable = true}, SHIFT(9611),
  [13346] = {.count = 1, .reusable = false}, SHIFT(9610),
  [13348] = {.count = 1, .reusable = true}, SHIFT(9606),
  [13350] = {.count = 1, .reusable = true}, SHIFT(9604),
  [13352] = {.count = 1, .reusable = true}, SHIFT(9612),
  [13354] = {.count = 1, .reusable = true}, SHIFT(9613),
  [13356] = {.count = 1, .reusable = true}, SHIFT(9614),
  [13358] = {.count = 1, .reusable = true}, SHIFT(9615),
  [13360] = {.count = 1, .reusable = false}, SHIFT(9617),
  [13362] = {.count = 1, .reusable = false}, SHIFT(9618),
  [13364] = {.count = 1, .reusable = false}, SHIFT(9619),
  [13366] = {.count = 1, .reusable = false}, SHIFT(9620),
  [13368] = {.count = 1, .reusable = true}, SHIFT(9621),
  [13370] = {.count = 1, .reusable = false}, SHIFT(9621),
  [13372] = {.count = 1, .reusable = false}, SHIFT(9622),
  [13374] = {.count = 1, .reusable = true}, SHIFT(9622),
  [13376] = {.count = 1, .reusable = false}, SHIFT(9623),
  [13378] = {.count = 1, .reusable = true}, SHIFT(9625),
  [13380] = {.count = 1, .reusable = false}, SHIFT(9625),
  [13382] = {.count = 1, .reusable = true}, SHIFT(9631),
  [13384] = {.count = 1, .reusable = false}, SHIFT(9631),
  [13386] = {.count = 1, .reusable = true}, SHIFT(9632),
  [13388] = {.count = 1, .reusable = true}, REDUCE(sym_when, 4),
  [13390] = {.count = 1, .reusable = false}, REDUCE(sym_when, 4),
  [13392] = {.count = 2, .reusable = true}, REDUCE(aux_sym_when_repeat1, 2), SHIFT_REPEAT(5497),
  [13395] = {.count = 1, .reusable = true}, SHIFT(9636),
  [13397] = {.count = 1, .reusable = true}, SHIFT(9639),
  [13399] = {.count = 1, .reusable = true}, SHIFT(9640),
  [13401] = {.count = 1, .reusable = false}, SHIFT(9641),
  [13403] = {.count = 1, .reusable = false}, SHIFT(9640),
  [13405] = {.count = 1, .reusable = false}, SHIFT(9642),
  [13407] = {.count = 1, .reusable = false}, SHIFT(9643),
  [13409] = {.count = 1, .reusable = true}, SHIFT(9644),
  [13411] = {.count = 1, .reusable = false}, SHIFT(9645),
  [13413] = {.count = 1, .reusable = true}, SHIFT(9645),
  [13415] = {.count = 1, .reusable = false}, SHIFT(9647),
  [13417] = {.count = 1, .reusable = false}, SHIFT(9648),
  [13419] = {.count = 1, .reusable = true}, SHIFT(9647),
  [13421] = {.count = 1, .reusable = true}, SHIFT(9643),
  [13423] = {.count = 1, .reusable = false}, SHIFT(9639),
  [13425] = {.count = 1, .reusable = true}, SHIFT(9649),
  [13427] = {.count = 1, .reusable = false}, SHIFT(9649),
  [13429] = {.count = 1, .reusable = true}, SHIFT(9650),
  [13431] = {.count = 1, .reusable = true}, SHIFT(5515),
  [13433] = {.count = 1, .reusable = true}, SHIFT(9663),
  [13435] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5548),
  [13438] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5567),
  [13441] = {.count = 1, .reusable = true}, SHIFT(8000),
  [13443] = {.count = 1, .reusable = true}, SHIFT(9668),
  [13445] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5595),
  [13448] = {.count = 1, .reusable = true}, SHIFT(9671),
  [13450] = {.count = 1, .reusable = true}, SHIFT(9673),
  [13452] = {.count = 1, .reusable = true}, SHIFT(9674),
  [13454] = {.count = 1, .reusable = true}, SHIFT(9676),
  [13456] = {.count = 1, .reusable = true}, SHIFT(9677),
  [13458] = {.count = 1, .reusable = true}, SHIFT(9678),
  [13460] = {.count = 1, .reusable = false}, SHIFT(9680),
  [13462] = {.count = 1, .reusable = true}, SHIFT(9686),
  [13464] = {.count = 1, .reusable = true}, SHIFT(9687),
  [13466] = {.count = 1, .reusable = false}, SHIFT(9688),
  [13468] = {.count = 1, .reusable = false}, SHIFT(9689),
  [13470] = {.count = 1, .reusable = false}, SHIFT(9690),
  [13472] = {.count = 1, .reusable = true}, SHIFT(9691),
  [13474] = {.count = 1, .reusable = false}, SHIFT(9692),
  [13476] = {.count = 1, .reusable = true}, SHIFT(9692),
  [13478] = {.count = 1, .reusable = true}, SHIFT(9693),
  [13480] = {.count = 1, .reusable = true}, SHIFT(9694),
  [13482] = {.count = 1, .reusable = true}, SHIFT(9695),
  [13484] = {.count = 1, .reusable = false}, SHIFT(9694),
  [13486] = {.count = 1, .reusable = true}, SHIFT(9690),
  [13488] = {.count = 1, .reusable = true}, SHIFT(9688),
  [13490] = {.count = 1, .reusable = true}, SHIFT(9696),
  [13492] = {.count = 1, .reusable = false}, SHIFT(9696),
  [13494] = {.count = 1, .reusable = true}, SHIFT(9697),
  [13496] = {.count = 1, .reusable = true}, SHIFT(9702),
  [13498] = {.count = 1, .reusable = false}, SHIFT(9704),
  [13500] = {.count = 1, .reusable = true}, SHIFT(9706),
  [13502] = {.count = 1, .reusable = false}, SHIFT(9702),
  [13504] = {.count = 1, .reusable = true}, SHIFT(9708),
  [13506] = {.count = 1, .reusable = true}, SHIFT(9721),
  [13508] = {.count = 1, .reusable = true}, SHIFT(9720),
  [13510] = {.count = 1, .reusable = true}, REDUCE(sym_rescue, 5),
  [13512] = {.count = 1, .reusable = true}, SHIFT(9732),
  [13514] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5655),
  [13517] = {.count = 1, .reusable = true}, SHIFT(8099),
  [13519] = {.count = 1, .reusable = true}, SHIFT(5686),
  [13521] = {.count = 1, .reusable = true}, SHIFT(9758),
  [13523] = {.count = 1, .reusable = true}, SHIFT(5707),
  [13525] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5714),
  [13528] = {.count = 1, .reusable = true}, SHIFT(9782),
  [13530] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5765),
  [13533] = {.count = 1, .reusable = true}, SHIFT(5799),
  [13535] = {.count = 1, .reusable = true}, SHIFT(9820),
  [13537] = {.count = 1, .reusable = true}, SHIFT(5820),
  [13539] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5827),
  [13542] = {.count = 1, .reusable = true}, SHIFT(9844),
  [13544] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5878),
  [13547] = {.count = 1, .reusable = true}, REDUCE(sym__body_statement, 5),
  [13549] = {.count = 1, .reusable = false}, REDUCE(sym__body_statement, 5),
  [13551] = {.count = 1, .reusable = true}, SHIFT(9860),
  [13553] = {.count = 1, .reusable = true}, SHIFT(8332),
  [13555] = {.count = 1, .reusable = true}, SHIFT(9865),
  [13557] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(5945),
  [13560] = {.count = 1, .reusable = true}, SHIFT(9866),
  [13562] = {.count = 1, .reusable = true}, SHIFT(9867),
  [13564] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5972),
  [13567] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(6001),
  [13570] = {.count = 1, .reusable = true}, SHIFT(8396),
  [13572] = {.count = 1, .reusable = true}, SHIFT(8402),
  [13574] = {.count = 1, .reusable = true}, SHIFT(9900),
  [13576] = {.count = 1, .reusable = true}, SHIFT(9901),
  [13578] = {.count = 1, .reusable = true}, SHIFT(9903),
  [13580] = {.count = 1, .reusable = true}, SHIFT(9904),
  [13582] = {.count = 1, .reusable = false}, SHIFT(9904),
  [13584] = {.count = 1, .reusable = true}, SHIFT(9906),
  [13586] = {.count = 1, .reusable = false}, SHIFT(9906),
  [13588] = {.count = 1, .reusable = true}, SHIFT(8426),
  [13590] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(6092),
  [13593] = {.count = 1, .reusable = true}, SHIFT(9910),
  [13595] = {.count = 1, .reusable = true}, SHIFT(9912),
  [13597] = {.count = 1, .reusable = true}, REDUCE(sym_block_parameters, 4),
  [13599] = {.count = 1, .reusable = false}, REDUCE(sym_block_parameters, 4),
  [13601] = {.count = 1, .reusable = true}, SHIFT(9915),
  [13603] = {.count = 1, .reusable = true}, SHIFT(9916),
  [13605] = {.count = 1, .reusable = true}, SHIFT(9917),
  [13607] = {.count = 1, .reusable = true}, SHIFT(9918),
  [13609] = {.count = 1, .reusable = false}, SHIFT(9920),
  [13611] = {.count = 1, .reusable = false}, SHIFT(9921),
  [13613] = {.count = 1, .reusable = false}, SHIFT(9922),
  [13615] = {.count = 1, .reusable = false}, SHIFT(9923),
  [13617] = {.count = 1, .reusable = true}, SHIFT(9924),
  [13619] = {.count = 1, .reusable = false}, SHIFT(9924),
  [13621] = {.count = 1, .reusable = false}, SHIFT(9925),
  [13623] = {.count = 1, .reusable = true}, SHIFT(9925),
  [13625] = {.count = 1, .reusable = false}, SHIFT(9926),
  [13627] = {.count = 1, .reusable = true}, SHIFT(9928),
  [13629] = {.count = 1, .reusable = false}, SHIFT(9928),
  [13631] = {.count = 1, .reusable = true}, SHIFT(9935),
  [13633] = {.count = 1, .reusable = true}, SHIFT(9936),
  [13635] = {.count = 1, .reusable = false}, REDUCE(sym_keyword_parameter, 3),
  [13637] = {.count = 1, .reusable = false}, SHIFT(9938),
  [13639] = {.count = 1, .reusable = false}, SHIFT(9939),
  [13641] = {.count = 1, .reusable = true}, SHIFT(9940),
  [13643] = {.count = 1, .reusable = false}, SHIFT(9941),
  [13645] = {.count = 1, .reusable = true}, SHIFT(9941),
  [13647] = {.count = 1, .reusable = true}, SHIFT(9942),
  [13649] = {.count = 1, .reusable = true}, SHIFT(9943),
  [13651] = {.count = 1, .reusable = true}, SHIFT(9944),
  [13653] = {.count = 1, .reusable = false}, SHIFT(9943),
  [13655] = {.count = 1, .reusable = true}, SHIFT(9939),
  [13657] = {.count = 1, .reusable = true}, SHIFT(9937),
  [13659] = {.count = 1, .reusable = true}, SHIFT(9945),
  [13661] = {.count = 1, .reusable = true}, SHIFT(9946),
  [13663] = {.count = 1, .reusable = true}, SHIFT(9947),
  [13665] = {.count = 1, .reusable = true}, SHIFT(9948),
  [13667] = {.count = 1, .reusable = false}, SHIFT(9950),
  [13669] = {.count = 1, .reusable = false}, SHIFT(9951),
  [13671] = {.count = 1, .reusable = false}, SHIFT(9952),
  [13673] = {.count = 1, .reusable = false}, SHIFT(9953),
  [13675] = {.count = 1, .reusable = true}, SHIFT(9954),
  [13677] = {.count = 1, .reusable = false}, SHIFT(9954),
  [13679] = {.count = 1, .reusable = false}, SHIFT(9955),
  [13681] = {.count = 1, .reusable = true}, SHIFT(9955),
  [13683] = {.count = 1, .reusable = false}, SHIFT(9956),
  [13685] = {.count = 1, .reusable = true}, SHIFT(9958),
  [13687] = {.count = 1, .reusable = false}, SHIFT(9958),
  [13689] = {.count = 1, .reusable = true}, SHIFT(9964),
  [13691] = {.count = 1, .reusable = false}, SHIFT(9964),
  [13693] = {.count = 1, .reusable = true}, SHIFT(9965),
  [13695] = {.count = 1, .reusable = false}, REDUCE(sym_optional_parameter, 3),
  [13697] = {.count = 1, .reusable = true}, SHIFT(9967),
  [13699] = {.count = 1, .reusable = true}, SHIFT(9968),
  [13701] = {.count = 2, .reusable = true}, REDUCE(aux_sym_method_parameters_repeat1, 2), SHIFT_REPEAT(9969),
  [13704] = {.count = 1, .reusable = true}, REDUCE(sym_destructured_parameter, 4),
  [13706] = {.count = 1, .reusable = true}, SHIFT(9970),
  [13708] = {.count = 1, .reusable = true}, SHIFT(9972),
  [13710] = {.count = 1, .reusable = true}, SHIFT(9973),
  [13712] = {.count = 1, .reusable = true}, REDUCE(sym_do_block, 5),
  [13714] = {.count = 1, .reusable = false}, REDUCE(sym_do_block, 5),
  [13716] = {.count = 1, .reusable = true}, SHIFT(9974),
  [13718] = {.count = 1, .reusable = true}, SHIFT(9975),
  [13720] = {.count = 1, .reusable = true}, SHIFT(9995),
  [13722] = {.count = 1, .reusable = true}, SHIFT(6156),
  [13724] = {.count = 1, .reusable = true}, SHIFT(10002),
  [13726] = {.count = 1, .reusable = true}, SHIFT(6177),
  [13728] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(6184),
  [13731] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(6148),
  [13734] = {.count = 1, .reusable = true}, SHIFT(10026),
  [13736] = {.count = 1, .reusable = true}, SHIFT(10027),
  [13738] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(6231),
  [13741] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(6213),
  [13744] = {.count = 1, .reusable = true}, SHIFT(10044),
  [13746] = {.count = 1, .reusable = true}, SHIFT(10045),
  [13748] = {.count = 1, .reusable = true}, SHIFT(10046),
  [13750] = {.count = 1, .reusable = true}, SHIFT(10047),
  [13752] = {.count = 1, .reusable = true}, SHIFT(10048),
  [13754] = {.count = 1, .reusable = true}, SHIFT(10049),
  [13756] = {.count = 1, .reusable = true}, SHIFT(10050),
  [13758] = {.count = 1, .reusable = true}, SHIFT(10051),
  [13760] = {.count = 1, .reusable = true}, SHIFT(10052),
  [13762] = {.count = 1, .reusable = false}, SHIFT(10053),
  [13764] = {.count = 1, .reusable = false}, SHIFT(10054),
  [13766] = {.count = 1, .reusable = true}, SHIFT(10055),
  [13768] = {.count = 1, .reusable = true}, SHIFT(10056),
  [13770] = {.count = 1, .reusable = true}, SHIFT(10057),
  [13772] = {.count = 1, .reusable = true}, SHIFT(10058),
  [13774] = {.count = 1, .reusable = false}, SHIFT(10059),
  [13776] = {.count = 1, .reusable = true}, SHIFT(10061),
  [13778] = {.count = 1, .reusable = true}, SHIFT(10064),
  [13780] = {.count = 1, .reusable = true}, SHIFT(8629),
  [13782] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(6333),
  [13785] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(6352),
  [13788] = {.count = 1, .reusable = true}, SHIFT(10084),
  [13790] = {.count = 1, .reusable = true}, SHIFT(10085),
  [13792] = {.count = 1, .reusable = true}, SHIFT(10086),
  [13794] = {.count = 1, .reusable = true}, SHIFT(10088),
  [13796] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(6394),
  [13799] = {.count = 1, .reusable = true}, SHIFT(6429),
  [13801] = {.count = 1, .reusable = true}, SHIFT(10112),
  [13803] = {.count = 1, .reusable = true}, SHIFT(6450),
  [13805] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(6457),
  [13808] = {.count = 1, .reusable = true}, SHIFT(10136),
  [13810] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(6508),
  [13813] = {.count = 1, .reusable = true}, SHIFT(10154),
  [13815] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(6549),
  [13818] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(6568),
  [13821] = {.count = 1, .reusable = true}, SHIFT(8817),
  [13823] = {.count = 1, .reusable = true}, SHIFT(10159),
  [13825] = {.count = 1, .reusable = true}, SHIFT(10160),
  [13827] = {.count = 1, .reusable = true}, SHIFT(10161),
  [13829] = {.count = 1, .reusable = true}, SHIFT(10163),
  [13831] = {.count = 1, .reusable = true}, SHIFT(10164),
  [13833] = {.count = 1, .reusable = true}, SHIFT(10165),
  [13835] = {.count = 1, .reusable = true}, SHIFT(10166),
  [13837] = {.count = 1, .reusable = true}, SHIFT(10167),
  [13839] = {.count = 1, .reusable = true}, SHIFT(10169),
  [13841] = {.count = 1, .reusable = true}, SHIFT(10170),
  [13843] = {.count = 1, .reusable = true}, SHIFT(10171),
  [13845] = {.count = 1, .reusable = true}, SHIFT(10172),
  [13847] = {.count = 1, .reusable = true}, SHIFT(6606),
  [13849] = {.count = 1, .reusable = false}, SHIFT(10174),
  [13851] = {.count = 1, .reusable = true}, SHIFT(10175),
  [13853] = {.count = 1, .reusable = true}, SHIFT(10176),
  [13855] = {.count = 1, .reusable = false}, SHIFT(10177),
  [13857] = {.count = 1, .reusable = false}, SHIFT(10178),
  [13859] = {.count = 1, .reusable = true}, SHIFT(10179),
  [13861] = {.count = 1, .reusable = false}, SHIFT(10179),
  [13863] = {.count = 1, .reusable = true}, SHIFT(10181),
  [13865] = {.count = 1, .reusable = false}, SHIFT(10181),
  [13867] = {.count = 1, .reusable = false}, SHIFT(10183),
  [13869] = {.count = 1, .reusable = false}, SHIFT(10185),
  [13871] = {.count = 1, .reusable = true}, SHIFT(10187),
  [13873] = {.count = 1, .reusable = true}, SHIFT(10190),
  [13875] = {.count = 1, .reusable = true}, SHIFT(10188),
  [13877] = {.count = 1, .reusable = true}, SHIFT(10192),
  [13879] = {.count = 1, .reusable = true}, SHIFT(10195),
  [13881] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(3908),
  [13884] = {.count = 1, .reusable = true}, SHIFT(10198),
  [13886] = {.count = 1, .reusable = false}, SHIFT(10198),
  [13888] = {.count = 1, .reusable = true}, SHIFT(8889),
  [13890] = {.count = 1, .reusable = true}, SHIFT(10202),
  [13892] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(6695),
  [13895] = {.count = 1, .reusable = true}, SHIFT(10205),
  [13897] = {.count = 1, .reusable = true}, SHIFT(8924),
  [13899] = {.count = 1, .reusable = true}, SHIFT(10210),
  [13901] = {.count = 1, .reusable = true}, SHIFT(8942),
  [13903] = {.count = 1, .reusable = true}, SHIFT(10215),
  [13905] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(6791),
  [13908] = {.count = 1, .reusable = true}, SHIFT(10216),
  [13910] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(6823),
  [13913] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(6842),
  [13916] = {.count = 1, .reusable = true}, SHIFT(8986),
  [13918] = {.count = 1, .reusable = true}, SHIFT(10221),
  [13920] = {.count = 1, .reusable = true}, SHIFT(10224),
  [13922] = {.count = 1, .reusable = false}, SHIFT(10224),
  [13924] = {.count = 1, .reusable = true}, SHIFT(9009),
  [13926] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(6900),
  [13929] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(6909),
  [13932] = {.count = 1, .reusable = true}, SHIFT(10228),
  [13934] = {.count = 1, .reusable = true}, SHIFT(10229),
  [13936] = {.count = 1, .reusable = true}, SHIFT(10230),
  [13938] = {.count = 1, .reusable = true}, SHIFT(10231),
  [13940] = {.count = 1, .reusable = true}, SHIFT(10233),
  [13942] = {.count = 1, .reusable = true}, SHIFT(10234),
  [13944] = {.count = 1, .reusable = true}, SHIFT(10235),
  [13946] = {.count = 1, .reusable = true}, SHIFT(10237),
  [13948] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(6971),
  [13951] = {.count = 1, .reusable = true}, SHIFT(10239),
  [13953] = {.count = 1, .reusable = true}, SHIFT(9061),
  [13955] = {.count = 1, .reusable = true}, SHIFT(10244),
  [13957] = {.count = 1, .reusable = true}, SHIFT(9079),
  [13959] = {.count = 1, .reusable = true}, SHIFT(10249),
  [13961] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(7072),
  [13964] = {.count = 1, .reusable = true}, REDUCE(sym_method_parameters, 5),
  [13966] = {.count = 1, .reusable = false}, REDUCE(sym_method_parameters, 5),
  [13968] = {.count = 1, .reusable = true}, SHIFT(10250),
  [13970] = {.count = 1, .reusable = true}, SHIFT(10251),
  [13972] = {.count = 1, .reusable = false}, SHIFT(10251),
  [13974] = {.count = 1, .reusable = true}, SHIFT(10253),
  [13976] = {.count = 1, .reusable = true}, SHIFT(10254),
  [13978] = {.count = 2, .reusable = true}, REDUCE(aux_sym_method_parameters_repeat1, 2), SHIFT_REPEAT(7088),
  [13981] = {.count = 1, .reusable = true}, SHIFT(7094),
  [13983] = {.count = 1, .reusable = true}, SHIFT(10261),
  [13985] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(7121),
  [13988] = {.count = 1, .reusable = true}, SHIFT(9135),
  [13990] = {.count = 1, .reusable = true}, SHIFT(9140),
  [13992] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(7171),
  [13995] = {.count = 1, .reusable = true}, SHIFT(9145),
  [13997] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(7189),
  [14000] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(7219),
  [14003] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(7247),
  [14006] = {.count = 1, .reusable = true}, SHIFT(9181),
  [14008] = {.count = 1, .reusable = true}, SHIFT(10287),
  [14010] = {.count = 1, .reusable = true}, SHIFT(10288),
  [14012] = {.count = 1, .reusable = true}, SHIFT(10289),
  [14014] = {.count = 1, .reusable = true}, SHIFT(10290),
  [14016] = {.count = 1, .reusable = true}, SHIFT(10291),
  [14018] = {.count = 1, .reusable = true}, SHIFT(10292),
  [14020] = {.count = 1, .reusable = true}, SHIFT(10293),
  [14022] = {.count = 1, .reusable = true}, SHIFT(10294),
  [14024] = {.count = 1, .reusable = true}, SHIFT(10295),
  [14026] = {.count = 1, .reusable = false}, SHIFT(10296),
  [14028] = {.count = 1, .reusable = false}, SHIFT(10297),
  [14030] = {.count = 1, .reusable = true}, SHIFT(10298),
  [14032] = {.count = 2, .reusable = true}, REDUCE(aux_sym_call_repeat1, 2), SHIFT_REPEAT(7304),
  [14035] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(7306),
  [14038] = {.count = 1, .reusable = true}, SHIFT(10300),
  [14040] = {.count = 1, .reusable = true}, SHIFT(10301),
  [14042] = {.count = 1, .reusable = true}, SHIFT(10302),
  [14044] = {.count = 1, .reusable = true}, SHIFT(10303),
  [14046] = {.count = 1, .reusable = false}, SHIFT(10304),
  [14048] = {.count = 1, .reusable = true}, SHIFT(10306),
  [14050] = {.count = 1, .reusable = true}, SHIFT(10309),
  [14052] = {.count = 1, .reusable = true}, SHIFT(10311),
  [14054] = {.count = 1, .reusable = true}, SHIFT(10312),
  [14056] = {.count = 1, .reusable = false}, SHIFT(10312),
  [14058] = {.count = 1, .reusable = true}, SHIFT(10314),
  [14060] = {.count = 1, .reusable = true}, SHIFT(9242),
  [14062] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(7357),
  [14065] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(7365),
  [14068] = {.count = 1, .reusable = true}, SHIFT(9253),
  [14070] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(7388),
  [14073] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(7393),
  [14076] = {.count = 1, .reusable = true}, SHIFT(9263),
  [14078] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(7428),
  [14081] = {.count = 1, .reusable = true}, SHIFT(10322),
  [14083] = {.count = 1, .reusable = true}, SHIFT(9273),
  [14085] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(7470),
  [14088] = {.count = 1, .reusable = true}, SHIFT(7491),
  [14090] = {.count = 1, .reusable = true}, SHIFT(10347),
  [14092] = {.count = 1, .reusable = true}, SHIFT(7512),
  [14094] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(7519),
  [14097] = {.count = 1, .reusable = true}, SHIFT(10371),
  [14099] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(7570),
  [14102] = {.count = 1, .reusable = true}, REDUCE(sym_elsif, 4),
  [14104] = {.count = 1, .reusable = true}, SHIFT(9386),
  [14106] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(7603),
  [14109] = {.count = 1, .reusable = true}, SHIFT(7637),
  [14111] = {.count = 1, .reusable = true}, SHIFT(10412),
  [14113] = {.count = 1, .reusable = true}, SHIFT(7658),
  [14115] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(7665),
  [14118] = {.count = 1, .reusable = true}, SHIFT(10436),
  [14120] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(7716),
  [14123] = {.count = 1, .reusable = true}, SHIFT(9501),
  [14125] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(7760),
  [14128] = {.count = 1, .reusable = true}, SHIFT(9506),
  [14130] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(7778),
  [14133] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(7799),
  [14136] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(7827),
  [14139] = {.count = 1, .reusable = true}, SHIFT(9539),
  [14141] = {.count = 1, .reusable = true}, SHIFT(9543),
  [14143] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(7860),
  [14146] = {.count = 1, .reusable = true}, SHIFT(9549),
  [14148] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(7886),
  [14151] = {.count = 1, .reusable = true}, REDUCE(sym_case, 7),
  [14153] = {.count = 1, .reusable = false}, REDUCE(sym_case, 7),
  [14155] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(7915),
  [14158] = {.count = 1, .reusable = true}, SHIFT(10491),
  [14160] = {.count = 1, .reusable = false}, SHIFT(10492),
  [14162] = {.count = 1, .reusable = false}, SHIFT(10493),
  [14164] = {.count = 1, .reusable = false}, SHIFT(10494),
  [14166] = {.count = 1, .reusable = false}, SHIFT(10495),
  [14168] = {.count = 1, .reusable = false}, SHIFT(10491),
  [14170] = {.count = 1, .reusable = true}, SHIFT(10496),
  [14172] = {.count = 1, .reusable = false}, SHIFT(10496),
  [14174] = {.count = 1, .reusable = true}, SHIFT(10497),
  [14176] = {.count = 1, .reusable = false}, SHIFT(9578),
  [14178] = {.count = 1, .reusable = true}, SHIFT(10505),
  [14180] = {.count = 1, .reusable = true}, SHIFT(10507),
  [14182] = {.count = 1, .reusable = true}, SHIFT(10508),
  [14184] = {.count = 1, .reusable = true}, SHIFT(10509),
  [14186] = {.count = 1, .reusable = false}, SHIFT(10511),
  [14188] = {.count = 1, .reusable = false}, SHIFT(10517),
  [14190] = {.count = 1, .reusable = true}, SHIFT(10518),
  [14192] = {.count = 1, .reusable = true}, SHIFT(10519),
  [14194] = {.count = 1, .reusable = false}, SHIFT(10520),
  [14196] = {.count = 1, .reusable = false}, SHIFT(10521),
  [14198] = {.count = 1, .reusable = false}, SHIFT(10522),
  [14200] = {.count = 1, .reusable = true}, SHIFT(10523),
  [14202] = {.count = 1, .reusable = false}, SHIFT(10524),
  [14204] = {.count = 1, .reusable = true}, SHIFT(10524),
  [14206] = {.count = 1, .reusable = true}, SHIFT(10526),
  [14208] = {.count = 1, .reusable = true}, SHIFT(10527),
  [14210] = {.count = 1, .reusable = false}, SHIFT(10526),
  [14212] = {.count = 1, .reusable = true}, SHIFT(10522),
  [14214] = {.count = 1, .reusable = true}, SHIFT(10520),
  [14216] = {.count = 1, .reusable = true}, SHIFT(10528),
  [14218] = {.count = 1, .reusable = true}, SHIFT(10529),
  [14220] = {.count = 1, .reusable = true}, SHIFT(10530),
  [14222] = {.count = 1, .reusable = false}, SHIFT(10532),
  [14224] = {.count = 1, .reusable = true}, SHIFT(10538),
  [14226] = {.count = 1, .reusable = true}, SHIFT(10540),
  [14228] = {.count = 1, .reusable = false}, SHIFT(10540),
  [14230] = {.count = 1, .reusable = true}, SHIFT(10541),
  [14232] = {.count = 1, .reusable = false}, SHIFT(10505),
  [14234] = {.count = 1, .reusable = true}, SHIFT(10559),
  [14236] = {.count = 1, .reusable = false}, SHIFT(10560),
  [14238] = {.count = 1, .reusable = false}, SHIFT(10561),
  [14240] = {.count = 1, .reusable = false}, SHIFT(10562),
  [14242] = {.count = 1, .reusable = false}, SHIFT(10563),
  [14244] = {.count = 1, .reusable = false}, SHIFT(10559),
  [14246] = {.count = 1, .reusable = true}, SHIFT(10564),
  [14248] = {.count = 1, .reusable = false}, SHIFT(10564),
  [14250] = {.count = 1, .reusable = true}, SHIFT(10565),
  [14252] = {.count = 1, .reusable = false}, SHIFT(10567),
  [14254] = {.count = 1, .reusable = true}, SHIFT(10567),
  [14256] = {.count = 1, .reusable = false}, SHIFT(9614),
  [14258] = {.count = 1, .reusable = true}, SHIFT(10574),
  [14260] = {.count = 1, .reusable = false}, SHIFT(10577),
  [14262] = {.count = 1, .reusable = true}, SHIFT(10578),
  [14264] = {.count = 1, .reusable = true}, SHIFT(10579),
  [14266] = {.count = 1, .reusable = false}, SHIFT(10580),
  [14268] = {.count = 1, .reusable = false}, SHIFT(10579),
  [14270] = {.count = 1, .reusable = false}, SHIFT(10581),
  [14272] = {.count = 1, .reusable = false}, SHIFT(10582),
  [14274] = {.count = 1, .reusable = true}, SHIFT(10583),
  [14276] = {.count = 1, .reusable = false}, SHIFT(10584),
  [14278] = {.count = 1, .reusable = true}, SHIFT(10584),
  [14280] = {.count = 1, .reusable = false}, SHIFT(10586),
  [14282] = {.count = 1, .reusable = false}, SHIFT(10587),
  [14284] = {.count = 1, .reusable = true}, SHIFT(10586),
  [14286] = {.count = 1, .reusable = true}, SHIFT(10582),
  [14288] = {.count = 1, .reusable = false}, SHIFT(10578),
  [14290] = {.count = 1, .reusable = true}, SHIFT(10589),
  [14292] = {.count = 1, .reusable = true}, SHIFT(10591),
  [14294] = {.count = 1, .reusable = false}, SHIFT(10591),
  [14296] = {.count = 1, .reusable = true}, SHIFT(10592),
  [14298] = {.count = 1, .reusable = false}, SHIFT(10574),
  [14300] = {.count = 1, .reusable = true}, SHIFT(10594),
  [14302] = {.count = 1, .reusable = true}, SHIFT(10595),
  [14304] = {.count = 1, .reusable = false}, SHIFT(10595),
  [14306] = {.count = 1, .reusable = true}, SHIFT(10596),
  [14308] = {.count = 1, .reusable = false}, SHIFT(10596),
  [14310] = {.count = 1, .reusable = true}, SHIFT(10597),
  [14312] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(7964),
  [14315] = {.count = 1, .reusable = true}, SHIFT(9659),
  [14317] = {.count = 1, .reusable = true}, SHIFT(9664),
  [14319] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8000),
  [14322] = {.count = 1, .reusable = true}, SHIFT(9669),
  [14324] = {.count = 1, .reusable = true}, SHIFT(10624),
  [14326] = {.count = 1, .reusable = true}, SHIFT(10627),
  [14328] = {.count = 1, .reusable = false}, SHIFT(10629),
  [14330] = {.count = 1, .reusable = true}, SHIFT(10631),
  [14332] = {.count = 1, .reusable = false}, SHIFT(10627),
  [14334] = {.count = 1, .reusable = true}, SHIFT(8048),
  [14336] = {.count = 1, .reusable = true}, SHIFT(10653),
  [14338] = {.count = 1, .reusable = true}, SHIFT(10654),
  [14340] = {.count = 2, .reusable = true}, REDUCE(aux_sym_call_repeat1, 2), SHIFT_REPEAT(8069),
  [14343] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(8071),
  [14346] = {.count = 1, .reusable = true}, SHIFT(9733),
  [14348] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8099),
  [14351] = {.count = 1, .reusable = true}, SHIFT(10662),
  [14353] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(8125),
  [14356] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(8144),
  [14359] = {.count = 1, .reusable = true}, SHIFT(9765),
  [14361] = {.count = 1, .reusable = true}, SHIFT(10667),
  [14363] = {.count = 1, .reusable = true}, SHIFT(9783),
  [14365] = {.count = 1, .reusable = true}, SHIFT(10672),
  [14367] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8204),
  [14370] = {.count = 1, .reusable = true}, SHIFT(10675),
  [14372] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(8232),
  [14375] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(8251),
  [14378] = {.count = 1, .reusable = true}, SHIFT(9827),
  [14380] = {.count = 1, .reusable = true}, SHIFT(10680),
  [14382] = {.count = 1, .reusable = true}, SHIFT(9845),
  [14384] = {.count = 1, .reusable = true}, SHIFT(10685),
  [14386] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8311),
  [14389] = {.count = 1, .reusable = true}, SHIFT(9861),
  [14391] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8332),
  [14394] = {.count = 1, .reusable = true}, SHIFT(10689),
  [14396] = {.count = 1, .reusable = true}, SHIFT(10692),
  [14398] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8396),
  [14401] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8402),
  [14404] = {.count = 1, .reusable = true}, SHIFT(10695),
  [14406] = {.count = 1, .reusable = true}, SHIFT(10696),
  [14408] = {.count = 1, .reusable = true}, SHIFT(10697),
  [14410] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8426),
  [14413] = {.count = 1, .reusable = true}, REDUCE(sym_block_parameters, 5),
  [14415] = {.count = 1, .reusable = false}, REDUCE(sym_block_parameters, 5),
  [14417] = {.count = 1, .reusable = true}, SHIFT(10698),
  [14419] = {.count = 1, .reusable = true}, REDUCE(aux_sym_block_parameters_repeat1, 2),
  [14421] = {.count = 2, .reusable = true}, REDUCE(aux_sym_block_parameters_repeat1, 2), SHIFT_REPEAT(8432),
  [14424] = {.count = 1, .reusable = true}, SHIFT(10699),
  [14426] = {.count = 1, .reusable = false}, SHIFT(10700),
  [14428] = {.count = 1, .reusable = false}, SHIFT(10701),
  [14430] = {.count = 1, .reusable = false}, SHIFT(10702),
  [14432] = {.count = 1, .reusable = false}, SHIFT(10703),
  [14434] = {.count = 1, .reusable = false}, SHIFT(10699),
  [14436] = {.count = 1, .reusable = true}, SHIFT(10704),
  [14438] = {.count = 1, .reusable = false}, SHIFT(10704),
  [14440] = {.count = 1, .reusable = true}, SHIFT(10705),
  [14442] = {.count = 1, .reusable = false}, SHIFT(10707),
  [14444] = {.count = 1, .reusable = true}, SHIFT(10707),
  [14446] = {.count = 1, .reusable = false}, SHIFT(9917),
  [14448] = {.count = 1, .reusable = true}, SHIFT(10714),
  [14450] = {.count = 1, .reusable = true}, SHIFT(10716),
  [14452] = {.count = 1, .reusable = true}, SHIFT(10717),
  [14454] = {.count = 1, .reusable = true}, SHIFT(10718),
  [14456] = {.count = 1, .reusable = false}, SHIFT(10720),
  [14458] = {.count = 1, .reusable = false}, SHIFT(10726),
  [14460] = {.count = 1, .reusable = true}, SHIFT(10727),
  [14462] = {.count = 1, .reusable = true}, SHIFT(10728),
  [14464] = {.count = 1, .reusable = false}, SHIFT(10729),
  [14466] = {.count = 1, .reusable = false}, SHIFT(10730),
  [14468] = {.count = 1, .reusable = false}, SHIFT(10731),
  [14470] = {.count = 1, .reusable = true}, SHIFT(10732),
  [14472] = {.count = 1, .reusable = false}, SHIFT(10733),
  [14474] = {.count = 1, .reusable = true}, SHIFT(10733),
  [14476] = {.count = 1, .reusable = true}, SHIFT(10735),
  [14478] = {.count = 1, .reusable = true}, SHIFT(10736),
  [14480] = {.count = 1, .reusable = false}, SHIFT(10735),
  [14482] = {.count = 1, .reusable = true}, SHIFT(10731),
  [14484] = {.count = 1, .reusable = true}, SHIFT(10729),
  [14486] = {.count = 1, .reusable = true}, SHIFT(10737),
  [14488] = {.count = 1, .reusable = true}, SHIFT(10738),
  [14490] = {.count = 1, .reusable = true}, SHIFT(10739),
  [14492] = {.count = 1, .reusable = false}, SHIFT(10741),
  [14494] = {.count = 1, .reusable = true}, SHIFT(10747),
  [14496] = {.count = 1, .reusable = true}, SHIFT(10749),
  [14498] = {.count = 1, .reusable = false}, SHIFT(10749),
  [14500] = {.count = 1, .reusable = true}, SHIFT(10750),
  [14502] = {.count = 1, .reusable = false}, SHIFT(10714),
  [14504] = {.count = 1, .reusable = false}, SHIFT(9937),
  [14506] = {.count = 1, .reusable = true}, SHIFT(10762),
  [14508] = {.count = 1, .reusable = false}, SHIFT(10763),
  [14510] = {.count = 1, .reusable = false}, SHIFT(10764),
  [14512] = {.count = 1, .reusable = false}, SHIFT(10765),
  [14514] = {.count = 1, .reusable = false}, SHIFT(10766),
  [14516] = {.count = 1, .reusable = false}, SHIFT(10762),
  [14518] = {.count = 1, .reusable = true}, SHIFT(10767),
  [14520] = {.count = 1, .reusable = false}, SHIFT(10767),
  [14522] = {.count = 1, .reusable = true}, SHIFT(10768),
  [14524] = {.count = 1, .reusable = false}, SHIFT(10770),
  [14526] = {.count = 1, .reusable = true}, SHIFT(10770),
  [14528] = {.count = 1, .reusable = false}, SHIFT(9947),
  [14530] = {.count = 1, .reusable = true}, SHIFT(10777),
  [14532] = {.count = 1, .reusable = false}, SHIFT(10780),
  [14534] = {.count = 1, .reusable = true}, SHIFT(10781),
  [14536] = {.count = 1, .reusable = true}, SHIFT(10782),
  [14538] = {.count = 1, .reusable = false}, SHIFT(10783),
  [14540] = {.count = 1, .reusable = false}, SHIFT(10782),
  [14542] = {.count = 1, .reusable = false}, SHIFT(10784),
  [14544] = {.count = 1, .reusable = false}, SHIFT(10785),
  [14546] = {.count = 1, .reusable = true}, SHIFT(10786),
  [14548] = {.count = 1, .reusable = false}, SHIFT(10787),
  [14550] = {.count = 1, .reusable = true}, SHIFT(10787),
  [14552] = {.count = 1, .reusable = false}, SHIFT(10789),
  [14554] = {.count = 1, .reusable = false}, SHIFT(10790),
  [14556] = {.count = 1, .reusable = true}, SHIFT(10789),
  [14558] = {.count = 1, .reusable = true}, SHIFT(10785),
  [14560] = {.count = 1, .reusable = false}, SHIFT(10781),
  [14562] = {.count = 1, .reusable = true}, SHIFT(10792),
  [14564] = {.count = 1, .reusable = true}, SHIFT(10794),
  [14566] = {.count = 1, .reusable = false}, SHIFT(10794),
  [14568] = {.count = 1, .reusable = true}, SHIFT(10795),
  [14570] = {.count = 1, .reusable = false}, SHIFT(10777),
  [14572] = {.count = 1, .reusable = true}, SHIFT(10797),
  [14574] = {.count = 1, .reusable = true}, SHIFT(10803),
  [14576] = {.count = 1, .reusable = true}, SHIFT(10804),
  [14578] = {.count = 1, .reusable = true}, SHIFT(10806),
  [14580] = {.count = 1, .reusable = true}, REDUCE(sym_do_block, 6),
  [14582] = {.count = 1, .reusable = false}, REDUCE(sym_do_block, 6),
  [14584] = {.count = 1, .reusable = true}, SHIFT(9977),
  [14586] = {.count = 1, .reusable = true}, SHIFT(10811),
  [14588] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(8501),
  [14591] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(8520),
  [14594] = {.count = 1, .reusable = true}, SHIFT(10009),
  [14596] = {.count = 1, .reusable = true}, SHIFT(10816),
  [14598] = {.count = 1, .reusable = true}, SHIFT(10028),
  [14600] = {.count = 1, .reusable = true}, SHIFT(10821),
  [14602] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8581),
  [14605] = {.count = 1, .reusable = true}, SHIFT(10822),
  [14607] = {.count = 1, .reusable = true}, SHIFT(10823),
  [14609] = {.count = 1, .reusable = true}, SHIFT(10825),
  [14611] = {.count = 1, .reusable = true}, SHIFT(10826),
  [14613] = {.count = 1, .reusable = true}, SHIFT(10828),
  [14615] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8629),
  [14618] = {.count = 1, .reusable = true}, SHIFT(10829),
  [14620] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8657),
  [14623] = {.count = 1, .reusable = true}, SHIFT(10830),
  [14625] = {.count = 1, .reusable = true}, SHIFT(10833),
  [14627] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(8705),
  [14630] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(8724),
  [14633] = {.count = 1, .reusable = true}, SHIFT(10119),
  [14635] = {.count = 1, .reusable = true}, SHIFT(10838),
  [14637] = {.count = 1, .reusable = true}, SHIFT(10137),
  [14639] = {.count = 1, .reusable = true}, SHIFT(10843),
  [14641] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8784),
  [14644] = {.count = 1, .reusable = true}, SHIFT(10155),
  [14646] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8817),
  [14649] = {.count = 1, .reusable = true}, SHIFT(10846),
  [14651] = {.count = 1, .reusable = true}, SHIFT(10847),
  [14653] = {.count = 1, .reusable = true}, SHIFT(10848),
  [14655] = {.count = 1, .reusable = true}, SHIFT(10849),
  [14657] = {.count = 1, .reusable = true}, SHIFT(10850),
  [14659] = {.count = 1, .reusable = true}, SHIFT(10851),
  [14661] = {.count = 1, .reusable = true}, SHIFT(10852),
  [14663] = {.count = 1, .reusable = false}, SHIFT(10853),
  [14665] = {.count = 1, .reusable = false}, SHIFT(10854),
  [14667] = {.count = 1, .reusable = true}, SHIFT(10855),
  [14669] = {.count = 1, .reusable = true}, SHIFT(10856),
  [14671] = {.count = 1, .reusable = true}, SHIFT(10857),
  [14673] = {.count = 1, .reusable = true}, SHIFT(10858),
  [14675] = {.count = 1, .reusable = false}, SHIFT(10859),
  [14677] = {.count = 1, .reusable = true}, SHIFT(10861),
  [14679] = {.count = 1, .reusable = true}, SHIFT(10864),
  [14681] = {.count = 1, .reusable = true}, SHIFT(10196),
  [14683] = {.count = 1, .reusable = true}, SHIFT(10869),
  [14685] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8889),
  [14688] = {.count = 1, .reusable = true}, SHIFT(10206),
  [14690] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8924),
  [14693] = {.count = 1, .reusable = true}, SHIFT(10211),
  [14695] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8942),
  [14698] = {.count = 1, .reusable = true}, SHIFT(10217),
  [14700] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8986),
  [14703] = {.count = 1, .reusable = true}, SHIFT(10222),
  [14705] = {.count = 1, .reusable = true}, SHIFT(10880),
  [14707] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9009),
  [14710] = {.count = 1, .reusable = true}, SHIFT(10881),
  [14712] = {.count = 1, .reusable = true}, SHIFT(10240),
  [14714] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9061),
  [14717] = {.count = 1, .reusable = true}, SHIFT(10245),
  [14719] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9079),
  [14722] = {.count = 1, .reusable = true}, SHIFT(10887),
  [14724] = {.count = 1, .reusable = false}, SHIFT(10887),
  [14726] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(9112),
  [14729] = {.count = 1, .reusable = true}, SHIFT(10262),
  [14731] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9135),
  [14734] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9140),
  [14737] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9145),
  [14740] = {.count = 1, .reusable = true}, SHIFT(10891),
  [14742] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9181),
  [14745] = {.count = 1, .reusable = true}, SHIFT(10894),
  [14747] = {.count = 1, .reusable = true}, SHIFT(10895),
  [14749] = {.count = 1, .reusable = true}, SHIFT(10897),
  [14751] = {.count = 1, .reusable = true}, SHIFT(10898),
  [14753] = {.count = 1, .reusable = true}, SHIFT(10900),
  [14755] = {.count = 1, .reusable = true}, SHIFT(10901),
  [14757] = {.count = 1, .reusable = false}, SHIFT(10901),
  [14759] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9242),
  [14762] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9253),
  [14765] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9263),
  [14768] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9273),
  [14771] = {.count = 1, .reusable = true}, SHIFT(10905),
  [14773] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(9301),
  [14776] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(9320),
  [14779] = {.count = 1, .reusable = true}, SHIFT(10354),
  [14781] = {.count = 1, .reusable = true}, SHIFT(10910),
  [14783] = {.count = 1, .reusable = true}, SHIFT(10372),
  [14785] = {.count = 1, .reusable = true}, SHIFT(10915),
  [14787] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9380),
  [14790] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9386),
  [14793] = {.count = 1, .reusable = true}, SHIFT(10918),
  [14795] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(9415),
  [14798] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(9434),
  [14801] = {.count = 1, .reusable = true}, SHIFT(10419),
  [14803] = {.count = 1, .reusable = true}, SHIFT(10923),
  [14805] = {.count = 1, .reusable = true}, SHIFT(10437),
  [14807] = {.count = 1, .reusable = true}, SHIFT(10928),
  [14809] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9494),
  [14812] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9501),
  [14815] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9506),
  [14818] = {.count = 1, .reusable = true}, SHIFT(10929),
  [14820] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9539),
  [14823] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9543),
  [14826] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9549),
  [14829] = {.count = 1, .reusable = true}, SHIFT(10932),
  [14831] = {.count = 1, .reusable = true}, SHIFT(10939),
  [14833] = {.count = 1, .reusable = true}, SHIFT(10940),
  [14835] = {.count = 1, .reusable = false}, SHIFT(10941),
  [14837] = {.count = 1, .reusable = false}, SHIFT(10942),
  [14839] = {.count = 1, .reusable = false}, SHIFT(10943),
  [14841] = {.count = 1, .reusable = true}, SHIFT(10944),
  [14843] = {.count = 1, .reusable = false}, SHIFT(10945),
  [14845] = {.count = 1, .reusable = true}, SHIFT(10945),
  [14847] = {.count = 1, .reusable = true}, SHIFT(10947),
  [14849] = {.count = 1, .reusable = true}, SHIFT(10948),
  [14851] = {.count = 1, .reusable = false}, SHIFT(10947),
  [14853] = {.count = 1, .reusable = true}, SHIFT(10943),
  [14855] = {.count = 1, .reusable = true}, SHIFT(10941),
  [14857] = {.count = 1, .reusable = true}, SHIFT(10949),
  [14859] = {.count = 1, .reusable = false}, SHIFT(10949),
  [14861] = {.count = 1, .reusable = true}, SHIFT(10950),
  [14863] = {.count = 1, .reusable = true}, SHIFT(10955),
  [14865] = {.count = 1, .reusable = false}, SHIFT(10957),
  [14867] = {.count = 1, .reusable = true}, SHIFT(10959),
  [14869] = {.count = 1, .reusable = false}, SHIFT(10955),
  [14871] = {.count = 1, .reusable = true}, SHIFT(10974),
  [14873] = {.count = 1, .reusable = false}, SHIFT(10976),
  [14875] = {.count = 1, .reusable = true}, SHIFT(10978),
  [14877] = {.count = 1, .reusable = false}, SHIFT(10974),
  [14879] = {.count = 1, .reusable = true}, SHIFT(9580),
  [14881] = {.count = 1, .reusable = true}, SHIFT(10989),
  [14883] = {.count = 1, .reusable = true}, SHIFT(10992),
  [14885] = {.count = 1, .reusable = true}, SHIFT(10993),
  [14887] = {.count = 1, .reusable = false}, SHIFT(10994),
  [14889] = {.count = 1, .reusable = false}, SHIFT(10993),
  [14891] = {.count = 1, .reusable = false}, SHIFT(10995),
  [14893] = {.count = 1, .reusable = false}, SHIFT(10996),
  [14895] = {.count = 1, .reusable = true}, SHIFT(10997),
  [14897] = {.count = 1, .reusable = false}, SHIFT(10998),
  [14899] = {.count = 1, .reusable = true}, SHIFT(10998),
  [14901] = {.count = 1, .reusable = false}, SHIFT(11000),
  [14903] = {.count = 1, .reusable = false}, SHIFT(11001),
  [14905] = {.count = 1, .reusable = true}, SHIFT(11000),
  [14907] = {.count = 1, .reusable = true}, SHIFT(10996),
  [14909] = {.count = 1, .reusable = false}, SHIFT(10992),
  [14911] = {.count = 1, .reusable = true}, SHIFT(11002),
  [14913] = {.count = 1, .reusable = false}, SHIFT(11002),
  [14915] = {.count = 1, .reusable = true}, SHIFT(11003),
  [14917] = {.count = 1, .reusable = true}, SHIFT(9616),
  [14919] = {.count = 1, .reusable = true}, SHIFT(11028),
  [14921] = {.count = 1, .reusable = true}, SHIFT(11029),
  [14923] = {.count = 1, .reusable = false}, SHIFT(11030),
  [14925] = {.count = 1, .reusable = false}, SHIFT(11031),
  [14927] = {.count = 1, .reusable = false}, SHIFT(11032),
  [14929] = {.count = 1, .reusable = true}, SHIFT(11033),
  [14931] = {.count = 1, .reusable = false}, SHIFT(11034),
  [14933] = {.count = 1, .reusable = true}, SHIFT(11034),
  [14935] = {.count = 1, .reusable = true}, SHIFT(11036),
  [14937] = {.count = 1, .reusable = true}, SHIFT(11037),
  [14939] = {.count = 1, .reusable = false}, SHIFT(11036),
  [14941] = {.count = 1, .reusable = true}, SHIFT(11032),
  [14943] = {.count = 1, .reusable = true}, SHIFT(11030),
  [14945] = {.count = 1, .reusable = true}, SHIFT(11038),
  [14947] = {.count = 1, .reusable = true}, SHIFT(11040),
  [14949] = {.count = 1, .reusable = false}, SHIFT(11040),
  [14951] = {.count = 1, .reusable = true}, SHIFT(11041),
  [14953] = {.count = 1, .reusable = true}, SHIFT(11042),
  [14955] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9659),
  [14958] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9664),
  [14961] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9669),
  [14964] = {.count = 1, .reusable = true}, SHIFT(9679),
  [14966] = {.count = 1, .reusable = true}, SHIFT(11051),
  [14968] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(9706),
  [14971] = {.count = 1, .reusable = true}, SHIFT(10656),
  [14973] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9733),
  [14976] = {.count = 1, .reusable = true}, SHIFT(10663),
  [14978] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9765),
  [14981] = {.count = 1, .reusable = true}, SHIFT(10668),
  [14983] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9783),
  [14986] = {.count = 1, .reusable = true}, SHIFT(10676),
  [14988] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9827),
  [14991] = {.count = 1, .reusable = true}, SHIFT(10681),
  [14993] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9845),
  [14996] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9861),
  [14999] = {.count = 1, .reusable = true}, SHIFT(10690),
  [15001] = {.count = 1, .reusable = true}, SHIFT(10693),
  [15003] = {.count = 1, .reusable = true}, REDUCE(sym_block_parameters, 6),
  [15005] = {.count = 1, .reusable = false}, REDUCE(sym_block_parameters, 6),
  [15007] = {.count = 1, .reusable = true}, SHIFT(11072),
  [15009] = {.count = 1, .reusable = true}, SHIFT(11073),
  [15011] = {.count = 1, .reusable = false}, SHIFT(11074),
  [15013] = {.count = 1, .reusable = false}, SHIFT(11075),
  [15015] = {.count = 1, .reusable = false}, SHIFT(11076),
  [15017] = {.count = 1, .reusable = true}, SHIFT(11077),
  [15019] = {.count = 1, .reusable = false}, SHIFT(11078),
  [15021] = {.count = 1, .reusable = true}, SHIFT(11078),
  [15023] = {.count = 1, .reusable = true}, SHIFT(11080),
  [15025] = {.count = 1, .reusable = true}, SHIFT(11081),
  [15027] = {.count = 1, .reusable = false}, SHIFT(11080),
  [15029] = {.count = 1, .reusable = true}, SHIFT(11076),
  [15031] = {.count = 1, .reusable = true}, SHIFT(11074),
  [15033] = {.count = 1, .reusable = true}, SHIFT(11082),
  [15035] = {.count = 1, .reusable = false}, SHIFT(11082),
  [15037] = {.count = 1, .reusable = true}, SHIFT(11083),
  [15039] = {.count = 1, .reusable = true}, SHIFT(11088),
  [15041] = {.count = 1, .reusable = false}, SHIFT(11090),
  [15043] = {.count = 1, .reusable = true}, SHIFT(11092),
  [15045] = {.count = 1, .reusable = false}, SHIFT(11088),
  [15047] = {.count = 1, .reusable = true}, SHIFT(11107),
  [15049] = {.count = 1, .reusable = false}, SHIFT(11109),
  [15051] = {.count = 1, .reusable = true}, SHIFT(11111),
  [15053] = {.count = 1, .reusable = false}, SHIFT(11107),
  [15055] = {.count = 1, .reusable = true}, SHIFT(9919),
  [15057] = {.count = 1, .reusable = true}, SHIFT(11121),
  [15059] = {.count = 1, .reusable = true}, SHIFT(11124),
  [15061] = {.count = 1, .reusable = true}, SHIFT(11125),
  [15063] = {.count = 1, .reusable = false}, SHIFT(11126),
  [15065] = {.count = 1, .reusable = false}, SHIFT(11125),
  [15067] = {.count = 1, .reusable = false}, SHIFT(11127),
  [15069] = {.count = 1, .reusable = false}, SHIFT(11128),
  [15071] = {.count = 1, .reusable = true}, SHIFT(11129),
  [15073] = {.count = 1, .reusable = false}, SHIFT(11130),
  [15075] = {.count = 1, .reusable = true}, SHIFT(11130),
  [15077] = {.count = 1, .reusable = false}, SHIFT(11132),
  [15079] = {.count = 1, .reusable = false}, SHIFT(11133),
  [15081] = {.count = 1, .reusable = true}, SHIFT(11132),
  [15083] = {.count = 1, .reusable = true}, SHIFT(11128),
  [15085] = {.count = 1, .reusable = false}, SHIFT(11124),
  [15087] = {.count = 1, .reusable = true}, SHIFT(11134),
  [15089] = {.count = 1, .reusable = false}, SHIFT(11134),
  [15091] = {.count = 1, .reusable = true}, SHIFT(11135),
  [15093] = {.count = 1, .reusable = true}, SHIFT(9949),
  [15095] = {.count = 1, .reusable = true}, SHIFT(11160),
  [15097] = {.count = 1, .reusable = true}, SHIFT(11162),
  [15099] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9977),
  [15102] = {.count = 1, .reusable = true}, SHIFT(10812),
  [15104] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10009),
  [15107] = {.count = 1, .reusable = true}, SHIFT(10817),
  [15109] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10028),
  [15112] = {.count = 1, .reusable = true}, SHIFT(11169),
  [15114] = {.count = 1, .reusable = true}, SHIFT(10834),
  [15116] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10119),
  [15119] = {.count = 1, .reusable = true}, SHIFT(10839),
  [15121] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10137),
  [15124] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10155),
  [15127] = {.count = 1, .reusable = true}, SHIFT(11176),
  [15129] = {.count = 1, .reusable = true}, SHIFT(11177),
  [15131] = {.count = 1, .reusable = true}, SHIFT(11179),
  [15133] = {.count = 1, .reusable = true}, SHIFT(11180),
  [15135] = {.count = 1, .reusable = true}, SHIFT(11182),
  [15137] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10196),
  [15140] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10206),
  [15143] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10211),
  [15146] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10217),
  [15149] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10222),
  [15152] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10240),
  [15155] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10245),
  [15158] = {.count = 1, .reusable = true}, SHIFT(11183),
  [15160] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10262),
  [15163] = {.count = 1, .reusable = true}, SHIFT(10892),
  [15165] = {.count = 1, .reusable = true}, SHIFT(11186),
  [15167] = {.count = 1, .reusable = true}, SHIFT(11187),
  [15169] = {.count = 1, .reusable = true}, SHIFT(10906),
  [15171] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10354),
  [15174] = {.count = 1, .reusable = true}, SHIFT(10911),
  [15176] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10372),
  [15179] = {.count = 1, .reusable = true}, SHIFT(10919),
  [15181] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10419),
  [15184] = {.count = 1, .reusable = true}, SHIFT(10924),
  [15186] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10437),
  [15189] = {.count = 1, .reusable = true}, SHIFT(10930),
  [15191] = {.count = 1, .reusable = true}, SHIFT(10933),
  [15193] = {.count = 1, .reusable = true}, SHIFT(10510),
  [15195] = {.count = 1, .reusable = true}, SHIFT(11224),
  [15197] = {.count = 1, .reusable = true}, SHIFT(10531),
  [15199] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(10538),
  [15202] = {.count = 1, .reusable = true}, SHIFT(11248),
  [15204] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(10589),
  [15207] = {.count = 1, .reusable = true}, SHIFT(11043),
  [15209] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(10631),
  [15212] = {.count = 1, .reusable = true}, SHIFT(11052),
  [15214] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10656),
  [15217] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10663),
  [15220] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10668),
  [15223] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10676),
  [15226] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10681),
  [15229] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10690),
  [15232] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10693),
  [15235] = {.count = 1, .reusable = true}, SHIFT(10719),
  [15237] = {.count = 1, .reusable = true}, SHIFT(11288),
  [15239] = {.count = 1, .reusable = true}, SHIFT(10740),
  [15241] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(10747),
  [15244] = {.count = 1, .reusable = true}, SHIFT(11312),
  [15246] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(10792),
  [15249] = {.count = 1, .reusable = true}, SHIFT(11158),
  [15251] = {.count = 1, .reusable = true}, REDUCE(sym_block_parameters, 7),
  [15253] = {.count = 1, .reusable = false}, REDUCE(sym_block_parameters, 7),
  [15255] = {.count = 1, .reusable = true}, SHIFT(11316),
  [15257] = {.count = 1, .reusable = true}, SHIFT(11317),
  [15259] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10812),
  [15262] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10817),
  [15265] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10834),
  [15268] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10839),
  [15271] = {.count = 1, .reusable = true}, SHIFT(11318),
  [15273] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10892),
  [15276] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10906),
  [15279] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10911),
  [15282] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10919),
  [15285] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10924),
  [15288] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10930),
  [15291] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10933),
  [15294] = {.count = 1, .reusable = true}, SHIFT(11321),
  [15296] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(10959),
  [15299] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(10978),
  [15302] = {.count = 1, .reusable = true}, SHIFT(11231),
  [15304] = {.count = 1, .reusable = true}, SHIFT(11326),
  [15306] = {.count = 1, .reusable = true}, SHIFT(11249),
  [15308] = {.count = 1, .reusable = true}, SHIFT(11331),
  [15310] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11038),
  [15313] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11043),
  [15316] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11052),
  [15319] = {.count = 1, .reusable = true}, SHIFT(11332),
  [15321] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(11092),
  [15324] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(11111),
  [15327] = {.count = 1, .reusable = true}, SHIFT(11295),
  [15329] = {.count = 1, .reusable = true}, SHIFT(11337),
  [15331] = {.count = 1, .reusable = true}, SHIFT(11313),
  [15333] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11158),
  [15336] = {.count = 1, .reusable = true}, REDUCE(sym_block_parameters, 8),
  [15338] = {.count = 1, .reusable = false}, REDUCE(sym_block_parameters, 8),
  [15340] = {.count = 1, .reusable = true}, SHIFT(11322),
  [15342] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11231),
  [15345] = {.count = 1, .reusable = true}, SHIFT(11327),
  [15347] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11249),
  [15350] = {.count = 1, .reusable = true}, SHIFT(11333),
  [15352] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11295),
  [15355] = {.count = 1, .reusable = true}, SHIFT(11338),
  [15357] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11313),
  [15360] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11322),
  [15363] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11327),
  [15366] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11333),
  [15369] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11338),
};

void *tree_sitter_ruby_external_scanner_create();
void tree_sitter_ruby_external_scanner_destroy(void *);
bool tree_sitter_ruby_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_ruby_external_scanner_serialize(void *, char *);
void tree_sitter_ruby_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_ruby() {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_ruby_external_scanner_create,
      tree_sitter_ruby_external_scanner_destroy,
      tree_sitter_ruby_external_scanner_scan,
      tree_sitter_ruby_external_scanner_serialize,
      tree_sitter_ruby_external_scanner_deserialize,
    },
  };
  return &language;
}
